/*
%Copyright   (c) Polak IT
%Author      SHUR
%Purpose     Configure Windows Firewall for AsbSrv
%Codepage    1251
%Modified    30.07.2008 07:17:18 Shur
*/


// MessageBox return codes
var vbOK     = 1;
var vbCancel = 2;
var vbAbort  = 3;
var vbRetry  = 4;
var vbIgnore = 5;
var vbYes    = 6;
var vbNo     = 7;

// MessageBox style flags
var vbOKOnly           = 0x00000000;
var vbOKCancel         = 0x00000001;
var vbAbortRetryIgnore = 0x00000002;
var vbYesNoCancel      = 0x00000003;
var vbYesNo            = 0x00000004;
var vbRetryCancel      = 0x00000005;
var vbCritical         = 0x00000010;
var vbQuestion         = 0x00000020;
var vbExclamation      = 0x00000030;
var vbInformation      = 0x00000040;
var vbDefaultButton1   = 0x00000000;
var vbDefaultButton2   = 0x00000100;
var vbDefaultButton3   = 0x00000200;
var vbDefaultButton4   = 0x00000300;
var vbSystemModal      = 0x00001000;

// Windows Firewall constants
var NET_FW_PROFILE_DOMAIN = 0;
var NET_FW_PROFILE_STANDARD = 1;

var NET_FW_IP_VERSION_V4 = 0;
var NET_FW_IP_VERSION_V6 = 1;
var NET_FW_IP_VERSION_ANY = 2;

var NET_FW_SCOPE_ALL = 0;
var NET_FW_SCOPE_LOCAL_SUBNET = 1;
var NET_FW_SCOPE_CUSTOM = 2;

var NET_FW_IP_PROTOCOL_TCP = 6;
var NET_FW_IP_PROTOCOL_UDP = 17;


function NewOpenPort(Name, IpVersion, Protocol, Port, Enabled)
{
 var oOpenPort = WScript.CreateObject("HNetCfg.FwOpenPort");
 oOpenPort.Name = Name;
 oOpenPort.IpVersion = IpVersion;
 oOpenPort.Protocol = Protocol;
 oOpenPort.Port = Port;
 oOpenPort.Scope = NET_FW_SCOPE_ALL;
 oOpenPort.Enabled = Enabled;
 return oOpenPort;
}




try{
 var oShell = WScript.CreateObject("WScript.Shell");

 var oFwMgr;
 try{
  oFwMgr = WScript.CreateObject("HNetCfg.FwMgr");
 }catch(exc){
  WScript.Echo("      Windows");
  oShell.Popup("      Windows.\n\n"+
               "  ",
               0,  // nSecondsToWait
               " Windows",  // strTitle
               vbOKOnly|vbExclamation);
  WScript.Quit(0);
 }
 
 var oDomainProfile;
 try{
  oDomainProfile = oFwMgr.LocalPolicy.GetProfileByType(NET_FW_PROFILE_DOMAIN);
 }catch(exc){
  WScript.Echo("      Windows");
  oShell.Popup("      Windows.\n\n"+
               "  ",
               0,  // nSecondsToWait
               " Windows",  // strTitle
               vbOKOnly|vbCritical);
  WScript.Quit(1);
 }

 var nReact = oShell.Popup("    Windows  "+
                           "    \"ASB Server\", "+
                           " .\n\n"+
                           "TCP  5301 - \"ASB Server - ASBP\"\n"+
                           "TCP  5380 - \"ASB Server - HTTP\"\n"+
                           "TCP  5401 - \"ASB Server - ASBPS\"\n"+
                           "TCP  5480 - \"ASB Server - HTTPS\"\n\n"+
                           " ,  ?",  // strText
                           0,  // nSecondsToWait
                           " Windows",  // strTitle
                           vbOKCancel|vbQuestion|vbDefaultButton2);
 if ( nReact == vbCancel ){
  WScript.Quit(0);
 }// if ...

 WScript.Echo("TCP  5301 - \"ASB Server - ASBP\"");
 oDomainProfile.GloballyOpenPorts.Add(NewOpenPort("ASB Server - ASBP",
                                                  NET_FW_IP_VERSION_ANY,
                                                  NET_FW_IP_PROTOCOL_TCP,
                                                  5301,
                                                  -1));
 WScript.Echo("TCP  5380 - \"ASB Server - HTTP\"");
 oDomainProfile.GloballyOpenPorts.Add(NewOpenPort("ASB Server - HTTP",
                                                  NET_FW_IP_VERSION_ANY,
                                                  NET_FW_IP_PROTOCOL_TCP,
                                                  5380,
                                                  -1));
 WScript.Echo("TCP  5401 - \"ASB Server - ASBPS\"");
 oDomainProfile.GloballyOpenPorts.Add(NewOpenPort("ASB Server - ASBPS",
                                                  NET_FW_IP_VERSION_ANY,
                                                  NET_FW_IP_PROTOCOL_TCP,
                                                  5401,
                                                  -1));
 WScript.Echo("TCP  5480 - \"ASB Server - HTTPS\"");
 oDomainProfile.GloballyOpenPorts.Add(NewOpenPort("ASB Server - HTTPS",
                                                  NET_FW_IP_VERSION_ANY,
                                                  NET_FW_IP_PROTOCOL_TCP,
                                                  5480,
                                                  -1));
 WScript.Echo("  Windows  ");
 oShell.Popup("  Windows  ",
              0,  // nSecondsToWait
              " Windows",  // strTitle
              vbOKOnly|vbInformation);
 WScript.Quit(0);
}catch(exc){
 if ( exc instanceof Error ){
  sError = "EXCEPTION "+
           (exc.number < 0 ? 
            "0x"+(4294967296+exc.number).toString(16).toUpperCase() : 
            exc.number.toString(10))+
           ": "+exc.description;
 }else{
  sError = "UNKNOWN: "+exc;
 }// if ...
 WScript.Echo(sError);
 oShell.Popup("  Windows  .\n\n"+
              "  ",
              0,  // nSecondsToWait
              " Windows",  // strTitle
              vbOKOnly|vbCritical);
 WScript.Quit(1);
}
