(*
%Copyright   (c) Polak Computer System  
%Author      28.03.1994 12:33:01 SAN                        
%Purpose       ⠭ ⥢  ⥪騩 
%Type        operation
%Specific    AP
%Modified    22.09.2014 18:37:28 POLAK\San
%Environment
*)

 MODULE A_RWayS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_OwnData, L_AP, L_PRoll, L_XDoc, L_Way, L_AR, L_CI,
        L_MathR, L_Fuel, L_Str, L_Sheet, Memo, SysLog, L_Env, L_XObj,
        L_StdFrm, L_AcsPnt, L_AFM, L_Acnt, L_JDoc, L_Stock,
        L_AcCut, L_bp, L_RWayS, Math, L_APtm, P_Firm;

(*
$P { Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
L_bp.getCurId(), L, ""
?, C, ""
?, C, ""
@
############################################################################################  ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|  |    |. ||ᠭ ஡                                                                  |
|-------|--------|-----|-|-----------------------------------------------------------------------------------|
}
*)

(*
$P { RWaySLine:
?, L ""
?, L, "D.N.Y"
?, L, ""
?, L, ""
?, L, ""
@
|#######|########|#####|#|###################################################################################|
}
*)

(*
$P{ JDocTop:
?, C, ""
@
|============================================================================================================|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|  |.|ᠭ ஡                                                                              |
|-------|----|-----------------------------------------------------------------------------------------------|
}
*)

(*
$P{ JDocLine:
?, L, ""
?, L, ""
?, L, ""
@
|#######|####|###############################################################################################|
}
*)

(*
$P{ Dlm:
@
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ MsgLine:
?, C, ""
@
|############################################################################################################|
}
*)

(*
$P { Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE CheckAllRWaySCleared(PerB, PerE: DATE);
 BEGIN
  SETSEL(RWayS, Done, 1);
  IF SRCINSEL(RWayS, GE, PerB) & (RWayS.Date <= L_DatTim.MonthEnd(PerE)) THEN
   L_General.Error(" ६    ⠢  "+RWayS.RWayS+"|"+
                   "  믮"+L_StdFrm.HR()+"室  楤  ");
  END;
 END {CheckAllRWaySCleared};

 PRIVATE PROCEDURE intClearRWaySResults();
  VAR
   _TotRun,
   ResetDone: LIKE(CarRun.TotRun);
   oPrompt: PROMPT_LINE;
   D: DATE;
 BEGIN
  SysLog.Mark("RWayS", L_DatTim.PeriodStr(Memo.gl_mb())+" : "+" ");

  oPrompt:=PROMPT_LINE.Create("஢ઠ 㯭");
  D:=Memo.gl_mb();
  WHILE D <= Memo.gl_me() DO
   PROMPT(" ." + L_DatTim.DateStr(D));
   SETSEL(RWayS, sDate, L_Way.rwsStat_Rated, D);
   FOR_EACH RWayS DO
   END; (* FOR_EACH RWayS *)
   INC(D);
  END;
  IF L_Fuel.TanksIsStockInMonth(Memo.gl_mb()) THEN
   IF SELECT(RWayF, Math) THEN
    REPEAT
     PROMPT(" ." + RWayF.Math);
     CONFORM(RWayF, Math);
    UNTIL ~SRCINSEL(RWayF, GT, RWayF.Math);
   END; (* IF SELECT(RWayF, Math) ... *)
  END;

  oPrompt.Title:="C १⮢ ";
  D:=Memo.gl_mb();
  WHILE D <= Memo.gl_me() DO
   PROMPT(L_DatTim.DateStr(D));
   SETSEL(RWayS, sDate, L_Way.rwsStat_Rated, D);
   FOR_EACH RWayS DO
    IF RWayS.Done THEN
     RWayS.Done:=0; REPLACE(RWayS);
    END;
   END; (* FOR_EACH RWayS *)
   INC(D);
  END;

  oPrompt.Title:="⪠ 楢 ";
  IF L_Fuel.TanksIsStockInMonth(Memo.gl_mb()) THEN
   IF SELECT(RWayF, Math) THEN
    REPEAT
     PROMPT(" " + RWayF.Math);
     CONFORM(RWayF, Math);
     L_MathR.ClearMApport(L_XObj.src_RWayS);
    UNTIL ~SRCINSEL(RWayF, GT, RWayF.Math);
   END; (* IF SELECT(RWayF, Math) ... *)
  END;
 
  oPrompt.Title:="⪠ ⠡,  ⮢, ⥫";
  SETSEL(Staff, TSN);
  FOR_EACH Staff DO
   PROMPT("⭨ " + Staff.TSN);
   (* ⥫ *)
   SELECT(Monthly, TSN, , Staff.TSN, Memo.gl_mb());
   WHILE OCCURE(Monthly) & (Monthly.Source # L_AP.mthlSrc_RWayS) DO
    NEXT(Monthly);
   END;
   ResetDone:=OCCURE(Monthly);
   (*   *)
   SELECT(Money, TSN, , Staff.TSN, Memo.gl_mb(), Memo.gl_mb());
   IF ~ResetDone THEN
    WHILE OCCURE(Money) & (Money.Source # L_PRoll.src_RWayS) DO
     NEXT(Money);
    END;
    ResetDone:=OCCURE(Money);
   END;
   (*  *)
   SELECT(Sheet, TSN, , Staff.TSN, Memo.gl_mb());
   IF ~ResetDone THEN
    WHILE OCCURE(Sheet) & (Sheet.Source # L_Sheet.src_RWayS) DO
     NEXT(Sheet);
    END;
    ResetDone:=OCCURE(Sheet);
   END;
   (*  १⮢  ௫ *)
   IF ResetDone THEN
    TRY [INTEGRITY(INTEGRITY_ON)]
     REMSEL(Monthly, Monthly.Source, L_AP.mthlSrc_RWayS);
     REMSEL(Sheet,   Sheet.Source,   L_Sheet.src_RWayS);
    EXCEPT
    END;
    L_PRoll.ClearMoney(L_PRoll.src_RWayS);
    L_PRoll.ShtDone(0);
   END;
  END; (* FOR_EACH Staff *)
 
  oPrompt.Title:=" ஡";
  SETSEL(Car, BoxNbr);
  FOR_EACH Car DO
   PROMPT(" " + Car.BoxNbr);
   SETSEL(CarRun, BoxNbr, Car.BoxNbr);
   SRCINSEL(CarRun, GE, , Math.Max(Memo.gl_mb(), Car.BegDate));
   IF OCCURE(CarRun) & (CarRun.Date <= Memo.gl_me()) THEN
    _TotRun:=CarRun.TotRun;
    REPEAT
     CarRun.Run   :=0;
     CarRun.TotRun:=_TotRun;
     REPLACE(CarRun);
    UNTIL ~NEXT(CarRun) | (CarRun.Date > Memo.gl_me());
    IF OCCURE(CarRun) THEN
     _TotRun:=CarRun.TotRun-_TotRun;
     WHILE OCCURE(CarRun) DO
      DEC(CarRun.TotRun, _TotRun);
      REPLACE(CarRun);
      NEXT(CarRun);
     END; (* WHILE OCCURE(CarRun) ... *)
    END;
   END; (* IF OCCURE(CarRun) ... *)
  END; (* FOR_EACH Car *)

  oPrompt.Title:=" OC";
  IF L_Env.KeyAssAcntLev(Memo.gl_mb()) & ~L_MathR.E_NotFullActiveKeyAssSystem(Memo.gl_mb()) THEN
   SETSEL(Math, LeafMK, 1, L_MathR.mathk_KeyAs);
   FOR_EACH Math DO
    PROMPT(Math.Math);
    ResetDone:=0;
    IF SELECT(MathMty, Math, Math.Math, Memo.gl_mb(), 01(**)) THEN
     REMSEL(MathMty);
     ResetDone:=1;
    END;
    IF SELECT(MathRun, Math, Math.Math, Memo.gl_mb(), 01(**)) THEN
     REMSEL(MathRun);
     ResetDone:=1;
    END;
    IF ResetDone THEN
     L_MathR.ResetMathDone_AP(Math.Math, Memo.gl_mb());
    END;
   END; (* FOR_EACH Math *)
  END; (* IF L_Env.KeyAssAcntLev ... *)

  oPrompt.Title:=" ୠ 㬥⮢";
  SETSEL(JDoc, JDKDate, L_JDoc.jd_RWayS);
  SRCINSEL(JDoc, GE, , Memo.gl_mb());
  WHILE OCCURE(JDoc) & (JDoc.Date <= Memo.gl_me()) DO
   PROMPT(JDoc.JDoc);
   JDoc.Ready:=0;
   REPLACE(JDoc);
   NEXT(JDoc);
  END;
 END {intClearRWaySResults};

 PRIVATE PROCEDURE ClearRWaySResults(Silent: SCAL[2]);
  VAR
   PerB,
   PerE     : DATE;
 BEGIN
  L_RWayS.CheckPeriodForRWaySProcessing(Memo.ud_mb());
  L_AR.CheckDatabaseTransparency();
  L_AcsPnt.PassAccessPoint(0000030);

  PerB:=Memo.ud_mb();
  IF ~Silent & L_XDoc.AskForXDocProceed(L_XDoc.pm_Clear, "⥢ ", 0) THEN
   PerE:=L_DatTim.Per(SYSDATE());
   L_bp.oncretizeBPName(" ( " + L_DatTim.PeriodStr(PerE) + ")");
  ELSE
   PerE:=PerB;
  END;
  IF ~Silent THEN
   L_PRoll.Salary_CheckClcPer();
  END;

  Memo.gl_SetCurDate(PerE);
  WHILE Memo.gl_mb() >= PerB DO
   PROMPT(L_DatTim.PeriodStr(Memo.gl_mb()));
   intClearRWaySResults();
   Memo.gl_SetCurDate(Memo.gl_mb()-1);
  END;
  CheckAllRWaySCleared(PerB, PerE);
 END {ClearRWaySResults};

 PUBLIC PROCEDURE RW053();
  CONST
   bpId = "RW053";
 BEGIN
  L_bp.Begin(bpId, " ", L_bp.t_Process, L_General.tc_inMonth);
  ClearRWaySResults(L_General.BatchExecution_IsRunning());
  L_bp.End();
 END {RW053};

 PRIVATE PROCEDURE IsTaken(): SCAL[2];
 BEGIN
  RETURN (RWayS.Status >= L_Way.rwsStat_Taken) |
         ((RWayS.Date - (SYSTIME() >= 09:00)) < SYSDATE());
 END {IsTaken};

 PRIVATE PROCEDURE MakeRWaySErrorPart(Description: STRING[]);
  CONST
   ErrDescriptionLen = 83;
  VAR
   i: NUMERIC[0];
   ErrorDescriptionArr: STRING[ErrDescriptionLen][20];
   ErrorDescriptionElm: STRING[];
   _RWayS : LIKE(RWayS.RWayS);
   _Date  : LIKE(RWayS.Date);
   _TSN   : LIKE(RWayS.TSN);
   _Status: LIKE(RWayS.Status);
 BEGIN
  CONFORM(RWayS, Staff, Man);
  _RWayS :=RWayS.RWayS;
  _Date  :=RWayS.Date;
  _TSN   :=RWayS.TSN;
  _Status:=RWayS.Status;
  L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_RWayS, RWayS.Status, RWayS.RWayS),
                    L_XDoc.XDocStr(L_XDoc.XDocId(L_XDoc.xdt_RWayS, RWayS.Status, RWayS.RWayS)) +
                    " " + L_DatTim.DateStr(RWayS.Date));
  L_StdFrm.PrepareLongStringForASLPART(Description, ErrorDescriptionArr, ErrDescriptionLen);
  FOR_EACH ErrorDescriptionElm IN ErrorDescriptionArr DO
   MAKEPART(Rep, RWaySLine, _RWayS, _Date, _TSN, _Status, ErrorDescriptionElm);
   SETEMPTY(_RWayS, _Date, _TSN, _Status);
  END; (* FOR_EACH ~!ErrorDescriptionElm ...*)
 END {MakeRWaySErrorPart};

 PRIVATE PROCEDURE MakeJDocErrorPart(Description: STRING[]);
  CONST
   ErrDescriptionLen = 95;
  VAR
   ErrorDescriptionArr: STRING[ErrDescriptionLen][20];
   ErrorDescriptionElm: STRING[];
   curJDoc            : LIKE(JDoc.JDoc);
   curSrcNbr          : LIKE(JDoc.SrcNbr);
 BEGIN
  curJDoc  :=JDoc.JDoc;
  curSrcNbr:=JDoc.SrcNbr;
  L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_JDoc, JDoc.JDocKind, JDoc.JDoc),
                          L_XDoc.XDocStr(JDoc.XDocId)  +
                    " " + JDoc.SrcNbr);
  L_StdFrm.PrepareLongStringForASLPART(Description, ErrorDescriptionArr, ErrDescriptionLen);
  FOR_EACH ErrorDescriptionElm IN ErrorDescriptionArr DO
   MAKEPART(Rep, JDocLine, curJDoc, curSrcNbr, ErrorDescriptionElm);
   SETEMPTY(curJDoc, curSrcNbr);
  END; (* FOR_EACH ~!ErrorDescriptionElm ...*)
 END {MakeJDocErrorPart};

 PRIVATE PROCEDURE MakeFinalErrorPart(Description: STRING[]);
  CONST
   ErrDescriptionLen = 118;
  VAR
   i: NUMERIC[0];
   ErrorDescriptionArr: STRING[ErrDescriptionLen][20];
 BEGIN
  MAKEPART(Rep, Dlm);
  L_StdFrm.PrepareLongStringForASLPART(Description, ErrorDescriptionArr, ErrDescriptionLen);
  i:=0;
  WHILE ~!ErrorDescriptionArr[i] DO
   MAKEPART(Rep, MsgLine, ErrorDescriptionArr[i]);
   INC(i);
  END; (* WHILE ~!ErrorDescriptionArr[i] ...*)
 END {MakeFinalErrorPart};

 PRIVATE PROCEDURE fjd_SingleRWayJ(crdXObject: LIKE(XObject.XObject); Qnt: L_XObj.tQnt);
  VAR
   trgCostItem: LIKE(CostItem.CostItem);
 BEGIN
  CONFORM(RWayJ, SEJobs);
  L_Way.PositionOnRouteLog(SEJobs.Route, RWayS.Date);
  L_General.Assert(~!RouteLog.CostItem, " ਨ  "+RouteLog.Route+"  㪠   "+L_DatTim.DateStr(RWayS.Date));
  trgCostItem:=L_CI.GetElementOfActivityCostItem(RouteLog.CostItem, RWayS.Date, L_Way.GetRWaySMyFirm(), L_CI.erkn_Fuel, 1);
  ADD(jdRWayS, jdRWayS, , crdXObject, trgCostItem,
       jdRWayS.Qnt, Qnt);
 END {fjd_SingleRWayJ};

 PRIVATE PROCEDURE fjd_SingleRWayS();
  VAR
   rwjFact,
   totFact: LIKE(RWayS.FuelFact);
   totNorm: LIKE(RWayS.FuelNorm);
 BEGIN
  SELECT(RWayF, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayF) DO
   totFact:=L_Fuel._FuelFact();
   IF totFact > 0 THEN
    L_Stock.Obtain_mItem(RWayF.Math, L_Stock.GetFuelTanksStorage(L_Way.GetRWaySMyFirm()));
    CONFORM(RWayS, RWayJ);
    IF RWayS.FuelNorm = 0 THEN
     rwjFact:=L_Fuel._FuelFact();
     DEC(totFact, rwjFact);
     fjd_SingleRWayJ(mItem.XObject, rwjFact);
    ELSE
     totNorm:=RWayS.FuelNorm;
     WHILE OCCURE(RWayJ) DO
      IF RWayJ.FNorm > 0 THEN
       DEC(totNorm, RWayJ.FNorm);
       IF totNorm > 0 THEN
        rwjFact:=L_Fuel._FuelFact()*RWayJ.FNorm / RWayS.FuelNorm;
       ELSE
        rwjFact:=totFact;
       END;
       DEC(totFact, rwjFact);
       fjd_SingleRWayJ(mItem.XObject, rwjFact);
      END;
      NEXT(RWayJ);
     END; (* WHILE OCCURE(RWayJ) *)
     L_General.CallUs(totFact = 0);
    END; (* IF RWayS.FuelNorm = 0... *)
   END; (* IF totFact > 0 *)
   NEXT(RWayF);
  END; (* WHILE OCCURE(RWayF) ... *)
 END {fjd_SingleRWayS};

 PRIVATE PROCEDURE fjd_Build(From, UpTo: DATE);
  VAR
   trgDate : DATE;
   oPrompt : PROMPT_LINE;
   ErrCount: NUMERIC[0];
 BEGIN
  IF L_Fuel.E_DoJDocByRWayS(UpTo) THEN
   oPrompt:=PROMPT_LINE.Create("ନ஢   ᯨᠭ ⮯");
   ErrCount:=0;
   MAKEPART(Rep, JDocTop, "ନ஢   ᯨᠭ ⮯");
   L_AR.GrantRightsUnconditionally();
   L_AFM.MakeMultipleIndex("jdRWayS", "crdXObject : LIKE(XObject.XObject);"  +
                                      "dbtCostItem: LIKE(CostItem.CostItem);"+
                                      "Qnt        : LIKE(JDocList.Qnt)",
                           "jdRWayS: crdXObject, dbtCostItem");
 
   WHILE L_Fuel.E_DoJDocByRWayS(UpTo) & (UpTo >= From) DO
    trgDate:=L_DatTim.MonthEnd(UpTo);
    SELECT(JDoc, JDKDate, , L_JDoc.jd_RWayS, trgDate);
    WHILE OCCURE(JDoc) DO
     IF ~JDoc.Ready THEN
      TRY [TERM_BY_USER(TERM_BY_USER_THROW), TRANSACTION(TRANSACTION_SLAVE)]
       GETLASTVERSION(JDoc);
       RTI.Get().TryBlock.AccessDataMode:=adm_RIDGE;
       L_JDoc.JDoc_OnAnyModification(-1, 1, 1);
       CONFORM(JDoc, JDocList);
       REMSEL(JDocList);
       L_General.CallUs(SEARCH(Car, RECORDID, JDoc.riPrn));
       SETSEL(jdRWayS, jdRWayS);
       REMSEL(jdRWayS);
       SETSEL(RWayS, sBoxNbr, L_Way.rwsStat_Rated, Car.BoxNbr);
       SRCINSEL(RWayS, GE, , UpTo);
       WHILE OCCURE(RWayS) & (RWayS.Date <= trgDate) DO
        PROMPT(RWayS.BoxNbr + ": " + L_DatTim.DateStr(RWayS.Date));
        IF (L_Way.GetRWaySMyFirm() = JDoc.MyFirm) THEN
         L_General.Assert(RWayS.Done, " ࠡ⠭  "+RWayS.RWayS+"  "+L_DatTim.DateStr(RWayS.Date));
         fjd_SingleRWayS();
        END;
        NEXT(RWayS);
       END; (* WHILE OCCURE(RWayS) ... *)

       JDoc.DoneDTS:=L_XDoc.GetSysDTS();
       REPLACE(JDoc);
       SELECT(jdRWayS, jdRWayS);
       WHILE OCCURE(jdRWayS) DO
        SEARCH(CostItem, CostItem, , jdRWayS.dbtCostItem);
        JDocList.JDocKind:=JDoc.JDocKind;
        JDocList.JDoc    :=JDoc.JDoc;
        SETEMPTY(JDocList.JDLNbr);
        JDocList.XObject :=CostItem.XObject;
        JDocList.AcCut   :=L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItem_Default);
        JDocList.Apport  :=L_Acnt.E_Apport_MoneyDebit(JDoc.Date);
        JDocList.XObject2:=jdRWayS.crdXObject;
        JDocList.AcCut2  :=L_AcCut.erkn_Get(JDoc.Date, L_AcCut.erkn_FuelInTanks);
        JDocList.Apport2 :=L_Acnt.E_Apport_FuelWriteOff(JDoc.Date);
        JDocList.Qnt     :=jdRWayS.Qnt;
        JDocList.wQnt    :=0;
        JDocList.wQnt2   :=1;
        JDocList.Sum     :=0;
        JDocList.Date    :=JDoc.Date;
        JDocList.DoneDTS :=JDoc.DoneDTS;
        INSERT(JDocList);
        NEXT(jdRWayS);
       END; (* WHILE OCCURE(jdRWayS) ... *)
       L_JDoc.JDoc_OnAnyModification(+1, 1, 1);
       JDoc.Ready:=1;
       REPLACE(JDoc);
      EXCEPT
      ON Exc:Exc_TermByUser DO
       RAISE();
      ON Exc:Exc_Root DO
       MakeJDocErrorPart(Exc.Description);
       INC(ErrCount);
      END; (* TRY *)
     END; (* IF ~JDoc.Ready ... *)
     NEXT(JDoc);
    END; (* WHILE OCCURE(JDoc) ... *)
    UpTo:=L_DatTim.IncMonth(UpTo, -1);
   END; (* WHILE L_Fuel.E_DoJDocByRWayS( ... *)
   IF ErrCount = 0 THEN
    MakeFinalErrorPart("ନ஢    ᯨᠭ ⮯");
   END;
  END; (* IF L_Fuel.E_DoJDocByRWayS(UpTo) ... *)
 END {fjd_Build};

 PRIVATE PROCEDURE Make(Need: SCAL[2]; From, UpTo: DATE);
  VAR
   TitleMyPF,
   Title   : STRING[];
   ErrCount: NUMERIC[0];
 BEGIN
  L_RWayS.CheckPeriodForRWaySProcessing(From);
  RTI.Get().TryBlock.AccessDataMode:=adm_FINISHED;
  OPENREP(Rep, L_General.NameConnection(L_bp.getCurId()), Create);
  ErrCount:=0;
  Title:=" 㤠 " + L_Str.PoolItem("⪠|ࠡ", Need) + " ⥢  ";
  IF (L_DatTim.MonthBeg(From) = From) & (L_DatTim.MonthEnd(UpTo) = UpTo) THEN
   IF L_DatTim.Per(From) = L_DatTim.Per(UpTo) THEN
    INC(Title, " " + L_DatTim.PeriodStr(From));
   ELSE
    L_bp.oncretizeBPName(" ( " + L_DatTim.PeriodStr(UpTo) + ")");
    INC(Title, "   " + L_DatTim.PeriodStr(From)+"  " + L_DatTim.PeriodStr(UpTo));
   END;
  ELSE
   INC(Title, " ਮ  " + L_DatTim.DateStr(Memo.ud_fr())+"  " + L_DatTim.DateStr(Memo.ud_ut()));
  END;
  IF L_APtm.IsOG() THEN
   TitleMyPF:="࠭: '' ࣠ "+P_Firm.GetDefaultMyFirmName()+", ந⢥ 頤 "+P_Firm.GetDefaultMyPlaceName();
  ELSE
   TitleMyPF:="";
  END;
  MAKEPART(Rep, Top, Title, TitleMyPF);

  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   SETSEL(RWayS, Date);
   SRCINSEL(RWayS, GE, , From);
   WHILE OCCURE(RWayS) & (RWayS.Date <= UpTo) DO
    PROMPT(L_DatTim.DateStr(RWayS.Date));
    IF (~L_APtm.IsOG() | P_Firm.IsAllowedMyPF(RWayS.MyFirm, RWayS.MyPlace)) & (RWayS.Done # Need) & IsTaken() THEN
     IF L_DatTim.Per(RWayS.Date) # Memo.gl_mb() THEN
      Memo.gl_SetCurDate(RWayS.Date);
     END;
     TRY [TERM_BY_USER(TERM_BY_USER_THROW), TRANSACTION(TRANSACTION_SLAVE)]
      GETLASTVERSION(RWayS);
      RTI.Get().TryBlock.AccessDataMode:=adm_RIDGE;
      CALL(RWayS, 060+Need);
     EXCEPT
     ON Exc:Exc_TermByUser DO
      RAISE();
     ON Exc: Exc_Root DO
      MakeRWaySErrorPart(Exc.Description);
      INC(ErrCount);
     END; (* TRY *)
    END;
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
   IF ErrCount = 0 THEN
    MakeFinalErrorPart(L_Str.PoolItem("ந ⪠  ⥢ ⮢|ࠡ⠭  ⥢ ", Need));
   END;
   IF Need & (L_DatTim.MonthBeg(From) = From) & (L_DatTim.MonthEnd(UpTo) = UpTo) THEN
    fjd_Build(From, L_DatTim.Per(UpTo));
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   MakeFinalErrorPart(" ࢠ: " + Exc.Description);
  END; (* TRY *)
  MAKEPART(Rep, Bot);
  CLOSEREP(Rep);
 END {Make};

 PRIVATE PROCEDURE DoRRWChain();
  VAR
   _RemEntr: LIKE(RWayS.RemEntr);
   _SMAft  : LIKE(RWayS.SMAft);
 BEGIN
  SRCINSEL(RWayS, GE, , Memo.gl_mb());
  WHILE OCCURE(RWayS) & (RWayS.Status >= L_Way.rwsStat_Taken) DO
   L_General.Assert(~RWayS.Done, "⥢     ࠡ⠭");
   PROMPT(RWayS.BoxNbr + " : " + RWayS.RWayS);
   CALL(SetRWayF.ProceedRWayF(1));
   _RemEntr:=RWayS.RemEntr;
   _SMAft  :=RWayS.SMAft;
   NEXT(RWayS);
   IF OCCURE(RWayS) & (RWayS.Status >= L_Way.rwsStat_Given) THEN
    IF (RWayS.RemExit # _RemEntr) THEN
     L_General.Error(" 楯窨");
    END;
   END;
  END; (* WHILE OCCURE(RWayS) ... *)
 END {DoRRWChain};

 PUBLIC PROCEDURE RW063();
  CONST
   bpId = "RW063";
 BEGIN
  L_bp.Begin(bpId, "⪠ ", L_bp.t_Prc_wF3, L_General.tc_inIntvl);
  IF ~L_General.BatchExecution_IsRunning() THEN
   L_StdFrm.Choice("⪠   ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) + "  "+L_DatTim.DateStr(Memo.ud_ut()));
   L_PRoll.Salary_CheckClcPer();
  END;
  Make(0, Memo.ud_fr(), Memo.ud_ut());
  L_bp.End();
 END {RW063};

 PUBLIC PROCEDURE RW064();
  CONST
   bpId = "RW064";
 BEGIN
  L_bp.Begin(bpId, "ࠡ⪠   ਮ", L_bp.t_Prc_wF3, L_General.tc_inIntvl);
  IF ~L_General.BatchExecution_IsRunning() THEN
   L_StdFrm.Question("ࠡ   ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) + "  "+L_DatTim.DateStr(Memo.ud_ut()));
   L_PRoll.Salary_CheckClcPer();
  END;
  Make(1, Memo.ud_fr(), Memo.ud_ut());
  L_bp.End();
 END {RW064};

 PUBLIC PROCEDURE RW054();
  CONST
   bpId = "RW054";
 BEGIN
  L_bp.Begin(bpId, "ࠡ⪠   ", L_bp.t_Prc_wF3, L_General.tc_inMonth);
  IF ~L_General.BatchExecution_IsRunning() & L_XDoc.AskForXDocProceed(L_XDoc.pm_Proceed, "⥢ ", 0) THEN
   Make(1, Memo.ud_mb(),  L_DatTim.MonthEnd(SYSDATE()));
  ELSE
   Make(1, Memo.ud_mb(),  Memo.ud_me());
  END;
  L_bp.End();
 END {RW054};

 PUBLIC PROCEDURE MassRWayChn();
 BEGIN
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   IF SELECT(RWayS, BoxNbr, Car.BoxNbr) THEN
    DoRRWChain();
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {MassRWayChn};

END.
