(*
%Copyright   (c) Polak Computer System
%Author      GINA
%Purpose     浪   ࠡ ᯥ
%Type        control
%Specific    AP
%Modified    02.09.2014 15:15:25 POLAK\LDA
*)

 MODULE BegRWS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_Env, Math, Str, L_Str, L_StdFrm, L_BegRWS, L_Print, L_Staff,
        L_DatTim, L_Way, L_General, E_Way, L_Car, L_Rpr,
        L_XDoc, L_EC, L_Fuel, L_BarCode, P_OwnData, Memo, FIO, L_Timer,
        L_RT, L_APtm, SysLog, L_WDO, L_Msg,
        L_AR, P_Route, L_Prop, P_Firm, P_Column;

 PRIVATE PERMANENT VAR
  v_XDocId,
  v_curXDocId                : L_XDoc.tXDocId;
  RWaySToPrint               : LIKE(RWayS.RWayS);
  v_BegStrTitle              : STRING[16];
  v_BegStr                   : STRING[16][27];
  XDoc_Action                : L_XDoc.tAction;
  IsFirstConformToWindowEvent: SCAL[2];
  outpostCurBoxNbr           : LIKE(Car.BoxNbr);

 PRIVATE CONST
  mainWindow = "Beg1E";

  action_View = L_XDoc.action_UserDefined + 0;

  Mode_VerificationAfterPrint = 059;
  Mode_ManualVerification     = 060;

  DepartReturnMarkAmount      = 21;

 PRIVATE PROCEDURE IsBCS_Exist(_Action: L_XDoc.tAction): SCAL[2];
 BEGIN
  IF _Action = action_View THEN
   RETURN 1;
  ELSE
   RETURN L_BegRWS.E_UsingBarCodeScannerLevel(L_BegRWS.RoleOfAction(_Action)) # L_BarCode.bcsl_None;
  END;
 END {IsBCS_Exist};

 PRIVATE PROCEDURE CheckBCS_Exist(trgAction: LIKE(XDocJrn.Action));
 BEGIN
  IF ~IsBCS_Exist(trgAction) THEN
   L_General.InformUs(" '" + L_Str.PoolItem(L_XDoc.action_Pool, trgAction) + "'  ᯮ짮 ᪠ ");
  END;
 END {CheckBCS_Exist};

 PRIVATE PROCEDURE GetRWaySDspDate(): DATE;
 BEGIN
  RETURN L_BegRWS.DspDate(RWayS.Date, RWayS.StartTim);
 END {GetRWaySDspDate};

 PRIVATE PROCEDURE Choice(Msg: STRING[]; _Action: LIKE(XDocJrn.Action));
 BEGIN
  TRY
   L_StdFrm.Choice(Msg);
  EXCEPT
  ON Exc: Exc_Raise DO
   IF IsBCS_Exist(_Action) & (RTI.Get().CurWindow.OriginalName = mainWindow) THEN
    L_General.RaiseLockReleaseException();
   ELSE
    RAISE();
   END;
  END;
 END {Choice};

 PRIVATE PROCEDURE MarkRWaySCWOrdersXDocJrn(_Action: LIKE(XDocJrn.Action); _RWayS: LIKE(RWayS.RWayS));
 BEGIN
  SELECT(CWOrder, RWayS, , _RWayS);
  WHILE OCCURE(CWOrder) DO
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_CWOrder, L_XDoc.EmptyXDocKind, CWOrder.CWOrder, _Action);
   NEXT(CWOrder);
  END; (* WHILE OCCURE(CWOrder)...*)
 END {MarkRWaySCWOrdersXDocJrn};

 PRIVATE PROCEDURE Set_v_XDocId();
 BEGIN
  IF    ACCESS(RWayS) THEN
   v_XDocId:=L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
  ELSIF ACCESS(RprS) THEN
   v_XDocId:=L_XDoc.XDocId(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS);
  ELSE
   L_General.Error(" ⠭  㬥");
  END;
 END {Set_v_XDocId};

 PRIVATE PROCEDURE Reset_v_XDocId();
 BEGIN
  SETEMPTY(v_XDocId);
 END {Reset_v_XDocId};

 PRIVATE PROCEDURE CheckAcceptableAction(curAction: L_XDoc.tAction; curXDocType: L_XDoc.tXDocType);
  VAR
   ErrorMsg  : STRING[];
   Role      : NUMERIC[0];
 BEGIN
  Role:=L_BegRWS.RoleOfAction(curAction);
  IF L_BegRWS.E_UsingBarCodeScannerLevel(Role) # L_BarCode.bcsl_None THEN
   SETEMPTY(ErrorMsg);
   IF    curXDocType = L_XDoc.xdt_RWayS THEN
    ErrorMsg:=L_BegRWS.CheckAcceptableAction(L_BegRWS.GetRWaySActualAction(), curAction);
   ELSIF curXDocType = L_XDoc.xdt_RprS THEN
    L_General.Assert(curAction = L_XDoc.action_CarDeparture, "   ࠧ襭 ⮫쪮 ⬥⪨  륧");

    SETSEL(XDocJrn, XDocJrn, L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS);
    LAST(XDocJrn);
    WHILE OCCURE(XDocJrn) & (XDocJrn.Action # L_XDoc.action_CarDeparture) DO
     PREV(XDocJrn);
    END;
    IF OCCURE(XDocJrn) THEN
     ErrorMsg:="⢨ ⨬, .. 㦥  ⬥⪠  륧";
    END;
   ELSE
    L_General.CallUs(0);
   END;
   IF ~!ErrorMsg THEN
    IF L_BegRWS.E_UsingBarCodeScannerLevel(Role) = L_BarCode.bcsl_Normal THEN
     L_General.Error(ErrorMsg);
    ELSE
     Choice(ErrorMsg, curAction);
    END;
   END;
  END;
 END {CheckAcceptableAction};

 PRIVATE PROCEDURE CheckAcceptableRWaySStatus(_Action: LIKE(XDocJrn.Action);
                                              _Status: LIKE(RWayS.Status));
 BEGIN
  L_General.Assert(RWayS.Status = _Status,
                   "⢨ '" + L_Str.PoolItem(L_XDoc.action_Pool, _Action) + "' |" +
                   "⮫쪮  ⥢ ⮢  ﭨ '" + L_Str.PoolItem(L_Way.rwsStat_Pool, _Status) + "'");
 END {CheckAcceptableRWaySStatus};

 PRIVATE PROCEDURE RePrint(All: SCAL[2]; Stream: SCAL[2]);
 BEGIN
  IF ~Stream THEN
   L_BegRWS.DispOnly();
   CheckAcceptableRWaySStatus(L_XDoc.action_Reprint, L_Way.rwsStat_Given);
  END;
  INC(RWayS.CopyCnt);
  L_BegRWS.REPLACE_RWayS();
  L_Way.CurRWayS_XDocJrn_Mark(L_XDoc.action_Reprint);
  IF ~Stream THEN
   RWaySToPrint:=RWayS.RWayS;
   IF All THEN
    LIKEMENU(CALL, "BegRWS.PrintWPairAndVerify()");
   ELSE
    LIKEMENU(CALL, "BegRWS.PrintAndVerify()");
   END;
  END; (* IF ~Stream ... *)
 END {RePrint};

 PRIVATE PROCEDURE CheckOpenRprS(NeedCheck: SCAL[2];
                                 Text     : STRING[]);
 BEGIN
  IF NeedCheck                                     &
     (L_Rpr.RprLev(SYSDATE()) = L_Rpr.rprl_Active) &
     ~L_Way.IsRepairRWayS()                        &
     L_Rpr.HasOpenRprS(RWayS.BoxNbr, SYSDATE(), SYSTIME()) THEN
   L_General.Error("!| |" +
                   " ࠦ " + RWayS.BoxNbr + " 㦥   " + RprS.RprS + "||" +
                   "  ६  : " + L_DatTim.DateTimeStr(RprS.OrdDate, RprS.OrdTime) + "|" +
                   "  ६  : " + L_DatTim.DateTimeStr(RprS.EDate, RprS.ETime) + "| |" +
                   Text + " 饭!");
  END;
 END {CheckOpenRprS};

 PRIVATE PROCEDURE bcs_DoAndInform(Msg           : STRING[];
                                   wCancel,
                                   wCheckOpenRprS: SCAL[2]);
  VAR
   React,
   Delay         : NUMERIC[0];
   OkBut,
   CancelBut,
   CancelButPlace: STRING[];
 BEGIN
  CheckBCS_Exist(XDoc_Action);
  IF    L_XDoc.ExtractXDocType(v_XDocId) = L_XDoc.xdt_RWayS THEN
   CheckOpenRprS(wCheckOpenRprS, "⢨ " + L_BegRWS.caa_ActionAsStrInQu(XDoc_Action));
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
   CONFORM(RWayS, Staff);
   CONFORM(Staff, Man);
   L_Way.CurRWayS_XDocJrn_Mark(XDoc_Action);
  ELSIF L_XDoc.ExtractXDocType(v_XDocId) = L_XDoc.xdt_RprS THEN
   L_General.CallUs(L_Rpr.IsRprS_w_OutCar());
   L_Rpr.AccessOrigin();
   CONFORM(OutCar, Mark);
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS, XDoc_Action);
  ELSE
   L_General.CallUs(0);
  END;

  IF wCancel THEN
   OkBut         :="%< 믮 $T >FDB";
   CancelBut     :="%<  ⬥  >X";
   CancelButPlace:="%##########% ";
  ELSE
   OkBut         :="%< 믮 $T >DX";
   CancelBut     :="";
   CancelButPlace:="";
  END;
  LOOP
   Delay:=25;
   IF    L_XDoc.ExtractXDocType(v_XDocId) = L_XDoc.xdt_RWayS THEN
    React:=STDFORM(L_StdFrm.PartForm("%L<>NI" +
                                     "%L<>NI" +
                                     "%L<>NI" +
                                     "%L<>NI" +
                                     CancelBut + OkBut +
                                     "@"+
                                      "       %#######%                                     "+
                                     "|       %############################################%"+
                                     "|⥫ %############################################%"+
                                     "|"+
                                     "|⢨ %############################################%"+
                                     "|"+
                                     CancelButPlace + "%##########%"),
                   "   ⢨   ",
                   LIKE_WDO,
                   ,
                   RWayS.RWayS,
                   RWayS.BoxNbr + " (" + CarLog.StateNbr + ") " + Mark.Name,
                   RWayS.TSN + " " + Man.Name,
                   Msg,
                   Delay);
   ELSIF L_XDoc.ExtractXDocType(v_XDocId) = L_XDoc.xdt_RprS THEN
    React:=STDFORM(L_StdFrm.PartForm("%L<>NI" +
                                     "%L<>NI" +
                                     "%L<>NI" +
                                     CancelBut + OkBut +
                                     "@"+
                                      "      %#######%                                     "+
                                     "|       %############################################%"+
                                     "|"+
                                     "|⢨ %############################################%"+
                                     "|"+
                                     CancelButPlace + "%##########%"),
                   "   ⢨   ",
                   LIKE_WDO,
                   ,
                   RprS.RprS,
                   OutCar.StateNbr + " " + Mark.Name,
                   Msg,
                   Delay);
   ELSE
    L_General.CallUs(0);
   END;
   IF    React = 0 THEN
    IF wCancel THEN
     IF L_StdFrm.RedAlternative("⢨⥫쭮 ⬥ 䨪|⢨ " + L_BegRWS.caa_ActionAsStrInQu(XDoc_Action) + "  ୠ?") THEN
      RAISE(1, "⢨ " +  L_BegRWS.caa_ActionAsStrInQu(XDoc_Action) + " ⬥");
     END;
    ELSE
     EXIT;
    END;
   ELSIF React = 1 THEN
    EXIT;
   END;
  END; (* LOOP *)
 END {bcs_DoAndInform};

 PRIVATE PROCEDURE PrintRWaySCWOrders();
  VAR
   trgCWOrder       : LIKE(CWOrder.CWOrder);
   i, Dummy         : NUMERIC[0];
   CWOrderList,
   CWOrderListAsStr,
   PrintOnManualTray: STRING[];
 BEGIN
  SETEMPTY(CWOrderList, CWOrderListAsStr);
  SELECT(CWOrder, RWayS, , RWayS.RWayS);
  WHILE OCCURE(CWOrder) DO
   IF CWOrder.Status # L_CWOrder.st_Canceled THEN
    CWOrderList     :=L_Str.AddStrDlm(CWOrderList, "|") + CWOrder.CWOrder;
    CWOrderListAsStr:=L_Str.AddStrDlm(CWOrderListAsStr, "|") + L_CWOrder.CWOrderStr();
   END;
   NEXT(CWOrder);
  END; (* WHILE OCCURE(CWOrder)...*)
  IF ~!CWOrderListAsStr THEN
   IF !L_Print.GetPrinterName(L_Print.pt_AddRep) | (L_Print.Normal_PaperTrayType(L_Print.pt_AddRep) = L_Print.ptt_Manual) THEN
    PrintOnManualTray:="   鸞 室 ⠢|" +
                       "  ⮪ 筮  㬠";
   ELSE
    SETEMPTY(PrintOnManualTray);
   END;
   Dummy:=0;
   IF STDFORM(L_StdFrm.PartForm("%<             >DB" +
                                "%<  ⫮   >X" +
                                "@"+
                                "  " + RWayS.RWayS + "  易    ॢ:" +
                                "||" +
                                CWOrderListAsStr +
                                L_StdFrm.HR() +
                                PrintOnManualTray +
                                "|" +
                                "%###################%   %###################%"),
                                "  冷   ॢ ",
                                LIKE_WDO,
                                ,
                                ) = 1 THEN
    i:=0;
    LOOP
     trgCWOrder:=L_Str.PoolItem(CWOrderList, i);
     IF !trgCWOrder THEN
      EXIT;
     END;
     SEARCH(CWOrder, CWOrder, , trgCWOrder);
     PROMPT("  " + CWOrder.CWOrder);
     TRY
      CALL(CWOrder.StreamPrint());
     EXCEPT
     ON Exc: Exc_Root DO
      L_StdFrm.RedInform(Exc.MsgOriginalText + "||" + " 鸞   ॢ " + CWOrder.CWOrder + " ");
     END; (* TRY *)
     INC(i);
    END; (* LOOP *)
   END; (* IF *)
  END;
 END {PrintRWaySCWOrders};

 PRIVATE PROCEDURE Print(Stream: SCAL[2]);
 BEGIN
  IF ~Stream THEN
   L_General.Assert(SEARCH(RWayS, RWayS, RWaySToPrint), "  ⥢  ()");
  END;
  TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)]
   PROMPT(" ...");
   IF P_OwnData.HasActualOwnDPro(L_BegRWS.DspSysDate(), P_OwnData.P_RWaySBlank) THEN
    CALL(oldRWayP.Print());
   ELSE
    CALL(RWayP.Print());
   END;
 
   IF RWayS.CopyCnt = 1 THEN
    IF IsBCS_Exist(L_XDoc.action_AutoVerification) THEN
     L_Way.CurRWayS_XDocJrn_Mark(L_XDoc.action_AutoVerification);
    END;
   ELSE
    IF IsBCS_Exist(L_XDoc.action_VerifyCC) THEN
     INC(L_BegRWS.ToBeVerifiedRWaySCnt);
    END;
   END;
   PrintRWaySCWOrders();
  EXCEPT
  END; (* TRY *)
 END {Print};

 PRIVATE PROCEDURE ConvertGrOut(D: DATE; Gr: STRING[]): STRING[];
  VAR
   X: NUMERIC[0];
   s: STRING[];
 BEGIN
  X:=STRTOFLD(Gr, NUMERIC);
  IF     (D >= 16\02\2014) & (X DIV 100 = 4) THEN
   RETURN L_Str.FixedIntStr(X, 3);
  ELSIF  (D <= 16\02\2014) & (X > 50) THEN
   DEC(X, 50);
   INC(X, 400);
   RETURN L_Str.FixedIntStr(X, 3);
  ELSE
   L_General.CallUs(OCCURE(StExit));
   s:=Str.Item(StExit.Name, CHR(250), 1);
   IF ~!s THEN
    RETURN s + L_Str.FixedIntStr(X, 2);
   ELSE
    RETURN L_Str.IntStr(X);
   END;
  END;
 END {ConvertGrOut};

 PUBLIC PROCEDURE IsOG_SpotIt();
  VAR
   dstName,
   tmpName,
   trgStr  : STRING[];
   HasCnclDst: SCAL[2];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
   L_AR.GrantRightsUnconditionally();
   IF L_Env.RealTSN(RWayS.TSN) & L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
    CONFORM(RWayS, StExit);
    IF StExit.Strict = L_Way.ExitStrict_Reg THEN
     HasCnclDst:=L_Way.RWaySSomeTimeWas(L_XDoc.action_begDstCncl);
     IF HasCnclDst |
        SELECT(Dtwo, DExitClss, RWayS.Date, StExit.ExitClss, StExit.Change) &
        ((Dtwo.TSN # RWayS.TSN) | (Dtwo.BoxNbr # RWayS.BoxNbr)) THEN
      CONFORM(StExit, ExitClss);
      IF ~SEARCH(Route, Route, Str.Item(ExitClss.Sign, "/", 0)) THEN
       ^("Bad_ExitClss_Sign_" + RWayS.RWayS);
      END;
      IF ~P_Route.HasActualRoutePro(Route.Route, SYSDATE(), P_Route.P_CodeInHeadFirm) THEN
       ^("Bad_RouteProperty_" + RWayS.RWayS);
      END;
      dstName:=FIO.BuildPath("ltc"
                             + "_" + FLDTOSTR(RWayS.Date, "yND")
                             + "_" + L_DatTim.SysDateTimeStamp(), "txt", "REP\LTC\OUT");
      tmpName:=FIO.BuildPath(dstName, "tmp");
      FIO.Open(F, tmpName, , Create);
      FIO.SetCP(F, FIO.CP_WindowsRussian);
      trgStr:=" " +  L_Prop.getRES(RoutePro.Value, 1) + "-" +
              ConvertGrOut(RWayS.Date, Str.Item(ExitClss.Sign, "/", 1)) + "-" +
              RWayS.Change + " (" + L_DatTim.DateStr(RWayS.Date) + ")";
      FIO.WrStr(F, trgStr);
      FIO.WrLn(F);
      CONFORM(RWayS, Staff);
      L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
      IF RWayS.MyPlace # P_Firm.mp_Fict THEN
       CONFORM(RWayS, MyPlace);
      ELSE
       SEARCH(MyPlace, MyPlace, , P_Column.GetMyPlace(CarLog.Column, RWayS.Date));
      END;
      CONFORM(RWayS, MyFirm);
      FIO.WrStr(F, MyPlace.Name + ", " + MyFirm.Name);
      FIO.WrLn(F);
      IF HasCnclDst | (Dtwo.BoxNbr # RWayS.BoxNbr) THEN
       FIO.WrStr(F, ": " + CarLog.BoxNbr + ", " + CarLog.StateNbr);
       FIO.WrLn(F);
      END;
      IF HasCnclDst | (Dtwo.TSN # RWayS.TSN) THEN
       FIO.WrStr(F, "⥫: " + Staff.TSN + ", " + Staff.Name);
       FIO.WrLn(F);
      END;
      FIO.WrStr(F, L_DatTim.CompleteSystimeStr());
      FIO.WrLn(F);
      FIO.Close(F);
      FIO.RenMov(tmpName, , dstName);
     END;
    END;
   END;
  EXCEPT
  ON Exc:Exc_Root DO
  END; (* TRY *)
 END {IsOG_SpotIt};

 PRIVATE PROCEDURE GatherRequiredCWOrderByRWayS(VAR PreparedCWOrderList: STRING[];
                                                VAR CWOrderForCopyList : STRING[]);
 BEGIN
  SETEMPTY(PreparedCWOrderList, CWOrderForCopyList);
  TRY [RESTORE_CURSORS(RC_ON)]
   CONFORM(RWayS, StExit);
   CONFORM(StExit, SEJobs);
   WHILE OCCURE(SEJobs) DO
    CONFORM(SEJobs, Route);
    L_Way.PositionOnRouteLog(Route.Route, RWayS.Date);
    CONFORM(RouteLog, TKind);
    IF TKind.Rgn = L_Way.tkrgn_Order THEN
     IF SELECT(CWOrder, RoutMod, SEJobs.Route, SEJobs.Modif, SEJobs.StartT) THEN
      LAST(CWOrder);
      WHILE OCCURE(CWOrder) & (CWOrder.Status = L_CWOrder.st_Canceled) DO
       PREV(CWOrder);
      END; (* WHILE OCCURE(CWOrder) ... *)
      IF OCCURE(CWOrder) & (CWOrder.RWayS # RWayS.RWayS) THEN
       IF CWOrder.Date = RWayS.Date THEN
        IF (CWOrder.Status = L_CWOrder.st_Prepared) THEN
         PreparedCWOrderList:=PreparedCWOrderList + CWOrder.CWOrder + "|";
        END;
       ELSE
        CWOrderForCopyList:=CWOrderForCopyList + CWOrder.CWOrder + "|";
       END;
      END;
     END;
    END;
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs) ... *)
  EXCEPT
  END; (* TRY *)
 END {GatherRequiredCWOrderByRWayS};

 PRIVATE PROCEDURE intProceedCWOrderList(    CWOrderList    : STRING[];
                                             OnlyBindToRWayS: SCAL[2];
                                             FirstPass      : SCAL[2];
                                         VAR Msg            : STRING[]);
  VAR
   i         : NUMERIC[0];
   trgCWOrder: LIKE(CWOrder.CWOrder);
 BEGIN
  SETEMPTY(Msg);
  i:=0;
  LOOP
   trgCWOrder:=L_Str.PoolItem(CWOrderList, i);
   IF !trgCWOrder THEN
    EXIT;
   END;
   SEARCH(CWOrder, CWOrder, , trgCWOrder);
   CONFORM(CWOrder, Route);
   CONFORM(CWOrder, RoutMod);
   IF FirstPass THEN
    Msg:=L_Str.AddStrDlm(Msg, "|") + L_CWOrder.CWOrderStr() + ", 륧  " + L_DatTim.TimeStr(CWOrder.p_DeptT) + ",  " + Route.Name + " (" + RoutMod.Name + ")";
   ELSE
    IF ~OnlyBindToRWayS THEN
     CALL(CWOrder.intMakeCopyCWOrder(RWayS.Date));
    END;
    CALL(CWOrder.BindToRWayS(RWayS.RWayS));
   END;
   INC(i);
  END; (* LOOP *)
 END {intProceedCWOrderList};

 PRIVATE PROCEDURE ProceedCWOrderList(CWOrderList: STRING[]; OnlyBindToRWayS: SCAL[2]);
  VAR
   Msg, Dummy: STRING[];
 BEGIN
  IF ~!CWOrderList THEN
   intProceedCWOrderList(CWOrderList, OnlyBindToRWayS, 1, Msg);
   IF OnlyBindToRWayS THEN
    Msg:="⠭   ⮢묨 , 室騬  ⥪饣 :||" + Msg;
   ELSE
    Msg:="⮢     ।騥 , 室騥   ,  ⠭   :||" + Msg;
   END;
   IF L_StdFrm.Alternative(Msg) THEN
    intProceedCWOrderList(CWOrderList, OnlyBindToRWayS, 0, Dummy);
   END;
  END;
 END {ProceedCWOrderList};

 PRIVATE PROCEDURE AutoBuildingCWOrders();
  VAR
   PreparedCWOrderList,
   CWOrderForCopyList : STRING[];
 BEGIN
  GatherRequiredCWOrderByRWayS(PreparedCWOrderList, CWOrderForCopyList);
  ProceedCWOrderList(PreparedCWOrderList, 1);
  ProceedCWOrderList(CWOrderForCopyList,  0);
 END {AutoBuildingCWOrders};

 PRIVATE PROCEDURE Distribute(FirstOfTwo: SCAL[2]);
  VAR
   Now,
   trgStartTim: LIKE(RWayS.StartTim);
 BEGIN
  IF GetRWaySDspDate() = L_BegRWS.DspSysDate() THEN
   Now:=SYSTIME() + 0.03 * ~FirstOfTwo;
   IF RWayS.StartTim > Now THEN
    Now:=RWayS.StartTim;
   END;
   IF FirstOfTwo THEN
    trgStartTim:=Now;
    LOOP
     SAVE(RWayS);
     CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr, RWayS.Date);
     IF ~NEXT(RWayS) | (RWayS.StartTim > Now) THEN
      EXIT;
     END;
     INC(trgStartTim, 0.03);
     RWayS.StartTim:=trgStartTim;
     L_BegRWS.REPLACE_RWayS();
     RESTORE(RWayS);
    END;
    RESTORE(RWayS);
   END; (* IF FirstOfTwo ... *)
   RWayS.StartTim:=Now;
  END;

  RWayS.Status  :=L_Way.rwsStat_Given;
  L_BegRWS.REPLACE_RWayS();
  L_Way.CurRWayS_XDocJrn_Mark(L_XDoc.action_begDst);
  IF L_APtm.IsOG() THEN
   IsOG_SpotIt();
  END;
  AutoBuildingCWOrders();
 END {Distribute};

 PRIVATE PROCEDURE StandOnPair(): SCAL[2];
 BEGIN
  IF RWayS.Change = 1 THEN
   CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
   IF NEXT(RWayS) & (GetRWaySDspDate() = L_BegRWS.DspSysDate()) & (RWayS.Change = 2) THEN
    CONFORM(RWayS, StExit);
    IF StExit.OutBox = L_Way.seob_InLine THEN
     RETURN 1;
    END;
   END; (* IF NEXT(RWayS) ... *)
  END;
  RETURN 0;
 END {StandOnPair};

 PRIVATE PROCEDURE _CheckStaff();
 BEGIN
  L_General.Assert(~L_Env.RealTSN(Staff.TSN) | L_Staff.rInState(RWayS.Date), "⭨ "+Staff.TSN+"  ⮨    "+L_DatTim.DateStr(RWayS.Date));
 END {_CheckStaff};

 PRIVATE PROCEDURE CheckStaff();
 BEGIN
  CONFORM(RWayS, Staff);
  _CheckStaff();
  CONFORM(RWayS, WayLMen);
  WHILE OCCURE(WayLMen) DO
   CONFORM(WayLMen, Staff);
   _CheckStaff();
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
 END {CheckStaff};

 PRIVATE PROCEDURE IsFirstRWS(): SCAL[2];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
   RETURN ~PREV(RWayS);
  EXCEPT
  END;
 END {IsFirstRWS};

 PRIVATE PROCEDURE CheckAcceptableRWaySDspDate(IsWriteOut: SCAL[2]);
  VAR
   RWaySDspDate: DATE;
 BEGIN
  RWaySDspDate:=GetRWaySDspDate();
  IF (RWaySDspDate # L_BegRWS.DspSysDate()) THEN
   IF RWaySDspDate > L_BegRWS.DspSysDate() THEN
    IF L_APtm.IsOG() THEN
     IF RWaySDspDate >= 20\03\2014 THEN
      L_StdFrm.Choice("⥢    ?!");
     ELSE
      L_General.Assert_wReferToAdmin(IsFirstRWS(), "⥢    ?!");
     END;
    ELSE
     L_General.Error("⥢   饥 ᫮  "+L_Str.PoolItem("ਭ|뤠", IsWriteOut) + "!" +
                     L_StdFrm.HR() +
                     "ᯥ᪨ ⪨  " + L_DatTim.DateStr(L_BegRWS.DspSysDate()) +
                     "| ⥢  " + L_DatTim.DateStr(RWaySDspDate));
    END;
   ELSE
    L_General.Assert_wReferToAdmin(0, "⥢    ᥣ譥 ᫮!");
   END; (* IF RWaySDspDate > L_BegRWS.DspSysDate() *)
  END;
 END {CheckAcceptableRWaySDspDate};

 PRIVATE PROCEDURE WriteOut(Stream, wDriverRWayS: SCAL[2]);
  VAR
   Msg     : STRING[];
   _Change : LIKE(RWayS.Change);
   _OutBox : LIKE(StExit.OutBox);
   _SMAft  : LIKE(RWayS.SMAft);
   _RemEntr: LIKE(RWayS.RemEntr);
 BEGIN
  L_BegRWS.DispOnly();

  PROMPT("뤠  " + RWayS.RWayS + ", ࠦ " + RWayS.BoxNbr);

  CheckAcceptableRWaySStatus(L_XDoc.action_begDst, L_Way.rwsStat_Ordered);
  CheckAcceptableRWaySDspDate(1);

  IF L_BegRWS.IsFictiveRWayS() THEN
   L_General.Error("⨬ 뤠  䨪⨢ ");
  END;

  CheckStaff();
  CheckOpenRprS(1, "뤠 ");
  L_BegRWS.E_CheckCrewFitForExit(L_XDoc.action_begDst);

  CONFORM(RWayS, StExit);
  _OutBox:=StExit.OutBox; (*  祭  *)
  _Change:=RWayS.Change;  (* ᬥ *)
  SAVE(RWayS);
  CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
  WHILE NEXT(RWayS) & L_Env.RealBoxNbr(RWayS.BoxNbr) DO
   L_General.Assert(RWayS.Status=L_Way.rwsStat_Ordered, "뤠 ᫥騩 ⥢    ");
  END;
  RESTORE(RWayS);
  SAVE(RWayS);
  CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
  IF PREV(RWayS) THEN
   IF L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
    L_General.Assert(RWayS.Status >= L_Way.rwsStat_Given, " 뤠 ।騩 ⥢    ");
    IF RWayS.Status >= L_Way.rwsStat_Taken THEN (*  ᤠ *)
     _RemEntr:=RWayS.RemEntr;
     _SMAft  :=RWayS.SMAft;
    ELSE
     IF (GetRWaySDspDate() = L_BegRWS.DspSysDate()) & (RWayS.Exit = StExit.Exit) THEN
      NEXT(RWayS); (* 㫨   ,  뤠, ⮡   뫠 Message *)
      L_StdFrm.CrucialChoice("  뤠    " + RWayS.BoxNbr + ", 室 " + StExit.Exit,
                             L_APtm.g_Disp);
     ELSE
      L_General.Assert((GetRWaySDspDate() = L_BegRWS.DspSysDate()) & (_OutBox # L_Way.seob_InGarage),
                       " ᤠ ।騩 ⥢    ");
      IF (_Change # 2) | (RWayS.Change # 1) THEN (*  ᬥ *)
       L_StdFrm.Choice("䫨 ᬥ   " + RWayS.BoxNbr);
      END;
     END;
     SETEMPTY(_RemEntr, _SMAft);
    END; (* IF RWayS.Status ... *)
   ELSE
    SETZERO(_RemEntr, _SMAft);
   END; (* IF L_Env.RealBoxNbr() ... *)
   RESTORE(RWayS);
   RWayS.RemExit :=_RemEntr;
   RWayS.SMBef   :=_SMAft;
  ELSE
   RESTORE(RWayS);
   IF !RWayS.SMBef | !RWayS.RemExit THEN (*  /  設 *)
    SETZERO(RWayS.SMBef, RWayS.RemExit);
    IF L_Fuel.TanksIsStock(RWayS.Date) THEN
     Msg:="(ᯨ)";
    ELSE
     Msg:="(ᯨ, )";
    END;
    L_StdFrm.Inform(" 뤠  ⥢   ࠭ᯮ⭮ ।⢮|" +
                    "祭 㫥 ⪨  륧 " + Msg + "|" +
                    " 饬 ᫥ 믮 ४ ⪮  륧");
   END; (* IF !RWayS.SMBef | ... *)
  END; (* IF PREV(RWayS) ... *)
  L_BegRWS.REPLACE_RWayS();
  Distribute(1);
  IF ~Stream THEN
   SAVE(RWayS);
   IF StandOnPair() THEN
    Distribute(0);
   END;
   RESTORE(RWayS);
  END;
  MarkRWaySCWOrdersXDocJrn(L_XDoc.action_begDst, RWayS.RWayS);
  IF wDriverRWayS THEN
   L_BegRWS.ToBeVerifiedRWaySCnt:=0;
   RePrint(1, Stream);
  END;
 (* ChkLated() in menu !!! *)
 END {WriteOut};

 PRIVATE PROCEDURE intChkLated();
  CONST
   MaxBack = 30/60/24; (* 30  *)
   MaxForw = 20/60/24; (* 20  *)
   MaxNear = 10/60/24; (* 10  *)

   Beg0DWindowName = "Beg0D";
  VAR
   Now : FLOAT;
   Txt : STRING[80];
   i   : SCAL[100];
 BEGIN
  IF (L_Way.E_BegRWSLev(SYSDATE()) > L_Way.brwsl_NoBeg) & L_WDO.WindowExists(Beg0DWindowName) THEN

   i:=0;
   SETEMPTY(v_BegStr);
   WHILE i <= HIGH(v_BegStr) DO
    L_WDO.wz_SetFieldColor(Beg0DWindowName,    0, "v_BegStr" + i, 4);(**)
    INC(i);
   END;

   Now:=L_DatTim.GetSysVARIANTDATE();
   v_BegStrTitle:=" < " + L_DatTim.TimeStr(L_DatTim.GetTimeOfVARIANTDATE(Now)) + "> ";
   i:=0;

   TRY
    RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
 
    SETSEL(rtExit, DispDate, L_BegRWS.DspSysDate(), 0);
    SRCINSEL(rtExit, GE, , Now-MaxBack);
    LOOP
     IF ~OCCURE(rtExit) | (i > HIGH(v_BegStr)) THEN
      EXIT;
     END;
     IF rtExit.BegDTS > (Now+MaxForw) THEN
      EXIT;
     END;
     IF L_Way.intIsAllowedPlace(rtExit.DispDate, EMPTYOF(Car.BoxNbr), EMPTYOF(Staff.TSN), rtExit.Exit) THEN
      Txt:=L_DatTim.TimeStr(L_DatTim.GetTimeOfVARIANTDATE(rtExit.BegDTS))+" "+rtExit.Exit;
      PROMPT("஢ઠ  "+Txt);
      IF ~rtExit.Suppl THEN
       v_BegStr[i]:=Txt;
       IF    rtExit.BegDTS <= Now THEN
        L_WDO.wz_SetFieldColor(Beg0DWindowName,    0, "v_BegStr" + i, 1);(**)
       ELSIF (rtExit.BegDTS-Now) <= MaxNear THEN
        L_WDO.wz_SetFieldColor(Beg0DWindowName,    0, "v_BegStr" + i, 3);(**)
       ELSE
        L_WDO.wz_SetFieldColor(Beg0DWindowName,    0, "v_BegStr" + i, 4);(**)
       END;
       INC(i);
      END;
     END;
     NEXT(rtExit);
    END; (* LOOP ... *)

    L_General.RaiseLockReleaseException();
   EXCEPT
   ON Exc: Exc_Root DO
    L_General.CheckIsLockReleaseException(Exc);
   END; (* TRY *)
  END; (* L_Way.E_BegRWSLev(SYSDATE()) > L_Way.brwsl_NoBeg) &... *)
 END {intChkLated};

 PRIVATE PROCEDURE CancelWriteOut();
 BEGIN
  L_BegRWS.DispOnly();
  Choice(" ⬥ 뤠 ⥢  " + RWayS.RWayS, L_XDoc.action_begDstCncl);
  CheckAcceptableRWaySStatus(L_XDoc.action_begDstCncl, L_Way.rwsStat_Given);
  L_Way.MayDecrRWStatus(L_XDoc.action_begDstCncl);
  IF L_Way.CarBegRWSLev(RWayS.BoxNbr, RWayS.Date) THEN
   CheckAcceptableRWaySDspDate(0);
   SAVE(RWayS);
   CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
   IF NEXT(RWayS) &
      (RWayS.Status >= L_Way.rwsStat_Given) &
      L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
    L_General.Error(" ⬥ 뤠 ⥢ , .. ᫥   뤠|("+RWayS.RWayS+")");
   END; (* IF *)
   RESTORE(RWayS);
  END; (* IF *)

  L_RT.rtx_Init();

  SETEMPTY(RWayS.RemExit, RWayS.SMBef);
  RWayS.Status:=L_Way.rwsStat_Ordered;
  L_BegRWS.REPLACE_RWayS();
  CONFORM(RWayS, RWayJ);
  REMSEL(RWayJ);
  L_BegRWS.SetExitData();
  IF L_Fuel.TanksIsStock(RWayS.Date) THEN
   CONFORM(RWayS, RWayF);
   REMSEL(RWayF);
  END;
  L_Way.CurRWayS_XDocJrn_Mark(L_XDoc.action_begDstCncl);
  MarkRWaySCWOrdersXDocJrn(L_XDoc.action_begDstCncl, RWayS.RWayS);
  intChkLated();
 END {CancelWriteOut};

 PRIVATE PROCEDURE DrvIsStandToRepair(_RprS: LIKE(RprS.RprS);
                                      _TSN : LIKE(Staff.TSN)): SCAL[2];
 BEGIN
  RETURN SELECT(RprP, RprS, _RprS, L_Rpr.rprpwho_Driver, _TSN);
 END {DrvIsStandToRepair};

 PRIVATE PROCEDURE ShowNotification(_Status: SCAL[2]);

  CONST
   Delimiter         = CHR(179);
   DoneDialogWidth   = 54;
   ReturnDialogWidth = 71;

   DateTimeWidth = 16 + 5;
   c_Return = 0;
   c_Done   = 1;
  VAR
   Text,
   Title,
   Header,
   tmpText,
   Palette: STRING[];
   T,
   React,
   DialogWidth,
   DrvNameLength: NUMERIC[0];
 BEGIN
  IF _Status = c_Done THEN
   Title        :=" ᫥ , ।  ᯫ  ";
   Palette      :="INFORM";
   Header       :=" ᯫ   ࠦ                             ";
   DialogWidth  :=DoneDialogWidth;
   DrvNameLength:=0;
  ELSE
   Title        :=" , 訥    ";
   Palette      :="STOP";
   Header       :="     ࠦ                     ⥫                 ";
   DialogWidth  :=ReturnDialogWidth;
   DrvNameLength:=24 + 2;
  END;
  RTI.Get().TryBlock.AccessDataMode  :=adm_SOFT;
  TABLE.Get("XDocJrn").AccessDataMode:=adm_RIDGE;

  Text:="";
  SETSEL(RDCar, Status, _Status);
  LAST(RDCar);
  WHILE OCCURE(RDCar) DO
   Text:=Text + L_DatTim.DateTimeStr(RDCar.Date, RDCar.Time) + Delimiter + RDCar.BoxNbr + " ";
   L_Car.AccessMark(RDCar.BoxNbr, SYSDATE());
   tmpText:=Str.Align(Mark.Name, DialogWidth-DrvNameLength-DateTimeWidth-1, LEFT);
   IF _Status = c_Return THEN
    CONFORM(RDCar, Staff);
    CONFORM(Staff, Man);
    tmpText:=tmpText + Delimiter + Str.Align(RDCar.TSN + " " + L_Str.ShortName(Man.Name), DrvNameLength-2, LEFT) +
                       Delimiter + L_Str.PoolItem(" |", DrvIsStandToRepair(RDCar.RprS, RDCar.TSN));
   END;
   Text:=Text + tmpText + "|";
   PREV(RDCar);
  END; (* WHILE OCCURE(RDCar) ... *)

  T    :=300;
  React:=0;
  IF ~!Text &
     STDFORM("|" + Header +
             "|%L,10<" + Text + "|>I||||||||||" +
             "|%<  ⫮ %T >X         %< ⠭ >DB",
             Title + L_DatTim.TimeStr(SYSTIME()) + " ",
             ^Palette,
             ,
             React, T) THEN
   SELECT(RDCar, Status, , _Status);
   WHILE OCCURE(RDCar) DO
    TRY [TRANSACTION(TRANSACTION_SLAVE)]
     L_XDoc.XDocJrn_Mark(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RDCar.RprS, L_XDoc.action_rprInspection);
    EXCEPT
    ON Exc: Exc_Root DO
    END; (* TRY *)
    NEXT(RDCar);
   END; (* WHILE OCCURE(RDCar) ... *)
  END;
 END {ShowNotification};

 PRIVATE PROCEDURE ChkRDCar();
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   IF L_General.GetAPSiteID() # "53" THEN
    IF L_Rpr.RprLev(SYSDATE()) = L_Rpr.rprl_Active THEN
     L_Rpr.Prepare_RDRprS();
     ShowNotification(1);
     ShowNotification(0);
    END;
   END;
  EXCEPT
  ON Exc: Exc_NoRights DO
   (*祣   *)
  ELSE
   RAISE();
  END; (* TRY *)
 END {ChkRDCar};

 PRIVATE PROCEDURE Beg0D_1_OnZoneOpen();
 BEGIN
  SETEMPTY(v_BegStr, v_BegStrTitle);
  RTI.Get().CurZone.PermanentFilter:=L_Way.extCurPlaceFilter("RWayS", "&(RWayS.Date=Memo.CurDate)");
 END {Beg0D_1_OnZoneOpen};

 PRIVATE PROCEDURE RemoveRWayS(Silent, wRemove: SCAL[2]);
 BEGIN
  IF ~Silent THEN
   L_StdFrm.Choice(" 㤠 ப  ࠧ浪!| "+
                   "|  ਢ  ⥫ ᫥⢨!| "+
                   "| ⢨⥫쭮  㤠 ப?");
   L_General.Assert_wReferToAdmin(GetRWaySDspDate() >= L_BegRWS.DspSysDate(), " 'ண' ");
  END;
  IF L_Way.RWaySSomeTimeWas(L_XDoc.action_begDst) THEN
   L_General.Assert_wReferToAdmin(0," ,   뤠!  ⢨⥫쭮 ⠥ 㦭 㤠 ?");
   SysLog.Mark("RWayS", "  " + RWayS.RWayS);
  END;
  L_BegRWS.REMOVE_RWayS(Silent, wRemove);
 END {RemoveRWayS};

 PRIVATE PROCEDURE re_StandOnRWayS(): SCAL[2];
 BEGIN
  IF ~!rtExit.RWayS THEN
   RETURN SEARCH(RWayS, RWayS, rtExit.RWayS);
  ELSE
   RETURN 0;
  END;
 END {re_StandOnRWayS};

 PRIVATE PROCEDURE Find_rtExitByExit(Strong : SCAL[2];
                                     _Date  : DATE;
                                     _RWayS : LIKE(RWayS.RWayS);
                                     _Exit  : LIKE(RWayS.Exit);
                                     _Change: LIKE(RWayS.Change)): SCAL[2];
 BEGIN
  SELECT(rtExit, DDExit, , _Date, _Exit);
  WHILE OCCURE(rtExit) DO
   IF re_StandOnRWayS() & (RWayS.RWayS # _RWayS) & (~Strong | (RWayS.Change = _Change)) THEN
    RETURN 1;
   END;
   NEXT(rtExit);
  END; (* WHILE OCCURE(rtExit) ... *)
  RETURN 0;
 END {Find_rtExitByExit};

 PRIVATE PROCEDURE CheckStrictExitDoubling(newExit, oldExit: LIKE(RWayS.Exit); switchTime: TIME; VAR Comment: STRING[]);
  CONST
   ButtonWidth = 11;
  VAR
   _RWayS   : LIKE(RWayS.RWayS);
   _Change  : LIKE(RWayS.Change);
   _Date    : LIKE(RWayS.Date);
   SwitchVariantsPool,
   Msg      : STRING[];
   _Variant : SCAL[16];
   _Exit    : LIKE(RWayS.Exit);
 BEGIN
  SwitchVariantsPool:="|⠢  १" +
                      "|ࠢ  ६";
  SEARCH(StExit, Exit, , newExit);
  IF StExit.Strict = L_Way.ExitStrict_Reg THEN
   _RWayS :=RWayS.RWayS;
   _Change:=RWayS.Change;
   _Date  :=RWayS.Date;
   SAVE(RWayS);
   IF Find_rtExitByExit(1, _Date, _RWayS, newExit, _Change) |
      Find_rtExitByExit(0, _Date, _RWayS, newExit, _Change) THEN
    IF L_BegRWS.IsFictiveRWayS() THEN
     IF RWayS.Status = L_Way.rwsStat_Ordered THEN
      RemoveRWayS(1, 1);
     END;
    ELSIF RWayS.Status < L_Way.rwsStat_Taken THEN
     CONFORM(RWayS, Staff, Man);
     IF ~!oldExit THEN
      SwitchVariantsPool:=SwitchVariantsPool +
                          "|ந  室 (" + GetExitClssSign(oldExit) + ")";
     END;
     IF RWayS.Change # _Change THEN
      SwitchVariantsPool:=SwitchVariantsPool +
                          "|४, .. ࠧ ᬥ";
     END;
     _Variant:=0;
     Msg:="|"+
          " 室 " + GetExitClssSign(rtExit.Exit) + "(" + _Change + ")" + " 㦥 " +
          Str.Item("|", "|", rtExit.Status) +
          "||" +
          L_StdFrm.DrawLineInBox(Switch_GetRWaySDescription(RWayS.RWayS)) +
          "|"+
          L_StdFrm._DrawInBox(Str.Align(" %LAI ",
                                        RWaySDescrLength - L_StdFrm.GetMaxItemLength(SwitchVariantsPool) + 2,
                                        LEFT), RWaySDescrLength) +
          "|" +
          L_StdFrm.DrawInLabeledBox("稭 ४祭  ⬥⪨  ୠ",
                                    " %L"+L_Str.IntStr(RWaySDescrLength-4) +
                                    L_Str.PoolItem("N|", L_BegRWS.E_TWOLevel(RWayS.Date)) + "YI ", RWaySDescrLength) +
          "||"+
          L_StdFrm.DrawButton( "⬥", ButtonWidth, "Z") +
          "  " +
          L_StdFrm.DrawButton("믮", ButtonWidth, "D") +
          L_StdFrm.DrawEmpty(RWaySDescrLength - 2*(ButtonWidth+1) - 2);
     STDFORM(Msg,
             " ४祭  ॣ 室 ",
             STOP,
             ,
             SwitchVariantsPool, _Variant, Comment);
     IF    _Variant = 0 THEN _Exit:=L_Way.erkn_e_Get(RWayS.Date, L_Way.erkn_ec_Reserve);
     ELSIF _Variant = 1 THEN _Exit:=L_Way.erkn_e_Get(RWayS.Date, L_Way.erkn_ec_CurRepair);
     ELSIF _Variant = 2 THEN
      IF ~!oldExit THEN _Exit:=oldExit;
      ELSE              _Exit:=newExit;
      END;
     ELSIF _Variant = 3 THEN _Exit:=newExit;
     ELSE
      L_General.CallUs(0);
     END;
     Switch_Do(RWayS.RWayS, switchTime, _Exit, Comment);
    END;
   END; (* IF Find_rtExitByExit ... *)
   RESTORE(RWayS);
  END; (* IF StExit.Strict ... *)
 END {CheckStrictExitDoubling};

 PRIVATE PROCEDURE FormRWayTxtMsg(Width: NUMERIC[0]): STRING[];
  VAR
   Txt,
   Msg: STRING[];
 BEGIN
  SETEMPTY(Msg, Txt);
  IF ~!RWayTxt.FExTime THEN
   Txt:=Txt + "  " + L_DatTim.TimeStr(RWayTxt.FExTime) +
              "  " + L_DatTim.TimeStr(RWayTxt.LEnTime) + ". ";
  END;
  IF ~!RWayTxt.Change THEN
   Txt:=Txt + " " + RWayTxt.Change + ".";
  END;
  IF RWayTxt.IEnType # 0 THEN
   IF ~!Txt THEN
    Msg:=Msg + Str.Align(Txt, Width, LEFT); Msg:=Msg+"|"; SETEMPTY(Txt);
   END;
   Txt:=Txt+"  " + Str.Item(" |-1|⮩", "|", RWayTxt.IEnType);
   IF ~!RWayTxt.IEnTime THEN
    Txt:=Txt + "  " + L_DatTim.TimeStr(RWayTxt.IEnTime) + "  " + L_DatTim.TimeStr(RWayTxt.IExTime);
   ELSE
    Txt:=Txt + "  ६ 뢠";
   END;
   Txt:=Txt + ".";
  END;
  IF ~!RWayTxt.Message THEN
   IF ~!Txt THEN
    Msg:=Msg + Str.Align(Txt, Width, LEFT); Msg:=Msg+"|"; SETEMPTY(Txt);
   END;
   Txt:="᫠: " + Str.Slice(RWayTxt.Message, 0, 30) + ".";
  END;
  IF ~!Txt THEN
   Msg:=Msg + Str.Align(Txt, Width, LEFT);;
  END;
  RETURN Msg;
 END {FormRWayTxtMsg};

 PRIVATE PROCEDURE CheckRWayTxt();
  CONST
   ButtonWidth = 45;
  VAR
   oldStrict: LIKE(StExit.Strict);
   _Valid   : LIKE(RWayTxt.Valid);
   Msg      : STRING[];
 BEGIN
  CONFORM(RWayS, RWayTxt);
  IF OCCURE(RWayTxt) THEN
   _Valid:=RWayTxt.Valid;
   Msg:="| '⥫쭮 ଠ樨' ⠭ ᫥饥:"+
        "||"+
        FormRWayTxtMsg(ButtonWidth)+
        "||"+
        L_StdFrm.DrawButton("ਬ", ButtonWidth, "DB") +
        "|" +
        L_StdFrm.DrawButton(" ᯮ짮", ButtonWidth, "B") +
        "|" +
        L_StdFrm.DrawButton("⬥", ButtonWidth, "Z");
   _Valid:=STDFORM(Msg, , STOP) = 1;
   IF RWayTxt.Valid # _Valid THEN
    RWayTxt.Valid:=_Valid;
    REPLACE(RWayTxt);
    L_BegRWS.SetExitData();
   END;
  END;
 END {CheckRWayTxt};

 PRIVATE PROCEDURE BeforeAccept();
 BEGIN
  IF IsBCS_Exist(L_XDoc.action_begRcp) THEN
   IF (L_BarCode.GetBCSRegime() = L_BarCode.BCSr_OnLine) | (L_BarCode.GetBCSRegime() = L_BarCode.BCSr_Disconnect) THEN
    CheckAcceptableAction(L_XDoc.action_begRcp, L_XDoc.xdt_RWayS);
   ELSE
    L_BarCode.SetBCSRegime(L_BarCode.BCSr_OnLine);
   END;
  END;
  L_Way.CurRWayS_XDocJrn_Start(L_XDoc.action_begRcp);
  L_BegRWS.DispOnly();
  L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
  IF Mark.Electric & !RWayS.RemEntr THEN
   RWayS.RemEntr:=0;
   REPLACE(RWayS);
  END;
  IF L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
   SAVE   (RWayS);
   CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
   L_General.Assert(~PREV(RWayS) | (RWayS.Status >= L_Way.rwsStat_Taken), " ᤠ ।騩 ⥢    ");
   RESTORE(RWayS);
   SAVE   (RWayS);
   CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
   L_General.Assert(~NEXT(RWayS) | (RWayS.Status <  L_Way.rwsStat_Taken), " ᫥騩 ⥢    ");
   RESTORE(RWayS);
  END; (* IF L_Env.RealBoxNbr(RWayS.BoxNbr) *)
  L_WDO.wz_SetFieldModifiable(mainWindow, 0, "RWayS.RemEntr", ~Mark.Electric);
 END {BeforeAccept};

 PRIVATE PROCEDURE AfterAccept(wDriverRWayS: SCAL[2]);
  VAR
   _RemEntr : LIKE(RWayS.RemEntr);
   _SMAft   : LIKE(RWayS.SMAft);
   _Run     : NUMERIC[0];
   _BakVol  : LIKE(Mark.BakVol);
   NxtRWSBeg: FLOAT;
   Default  : L_BegRWS.tCrewFitnessForExit;
   Reason,
   ReasonStr: STRING[];
   Local    : PROC;
 BEGIN
  RWayS.Status:=L_Way.rwsStat_Taken;
  IF RWayS.Date = SYSDATE() THEN
   RWayS.StartTim:=Math.Min(SYSTIME(), RWayS.StartTim);
  END;
  L_BegRWS.REPLACE_RWayS();
  _RemEntr:=RWayS.RemEntr;
  _SMAft  :=RWayS.SMAft;
  L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
  SAVE(RWayS);
  CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr, RWayS.Date);
  IF NEXT(RWayS) & (RWayS.Status = L_Way.rwsStat_Given) THEN
   IF Mark.Electric THEN
    L_General.Assert(_RemEntr = 0, "㫥 ⮪  ");
   ELSE
    L_General.CallUs(~L_Env.RealBoxNbr(RWayS.BoxNbr) | (!RWayS.RemExit & !RWayS.SMBef));
   END;
   RWayS.RemExit:=_RemEntr;
   RWayS.SMBef  :=_SMAft;
   L_BegRWS.REPLACE_RWayS();
  END;
  RESTORE(RWayS);
  _Run:=L_Way.RunBySM();
  IF _Run > 1000 THEN
   L_StdFrm.Choice("஡  ᯨ ⠢ "+FLDTOSTR(_Run, "0", 0)+" ");
  END;
  _BakVol:=L_Way.GetBakVol(RWayS.BoxNbr, RWayS.Date);
  L_General.Assert(RWayS.RemEntr <= _BakVol, "⮪    (" + L_Str.IntStr(_BakVol) + ")");
  IF L_Env.RealBoxNbr(RWayS.BoxNbr) & (RWayS.RemEntr # _BakVol) &
     (L_Fuel.FlAcntLev(RWayS.Date) = L_Fuel.fal_RefuelOperator) &
     L_Fuel.E_TankIsFullOnReturn(RWayS.Date) THEN
   L_StdFrm.Choice("⮪  ࠢ   (" + L_Str.IntStr(_BakVol) + ")");
  END;
  IF ~Mark.Electric THEN
   CALL(SetRWayF.ProceedRWayF(0));
   IF ~L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
    L_General.Assert(RWayS.RemEntr = 0, "⨢   |㫥 ⮪  ");
    L_General.Assert(RWayS.SMAft = 0, "⨢   |㫥  ᯨ");
    IF L_Fuel.FlAcntLev(RWayS.Date) # L_Fuel.fal_RWOP THEN
     L_General.Assert(RWayS.FuelFact = 0, "⨢    㫥 室 ⮯");
    END;
   ELSE
    IF wDriverRWayS THEN
     IF L_Fuel.FlAcntLev(RWayS.Date) = L_Fuel.fal_Dispatcher THEN
      CONFORM(RWayS, RWayF);
      IF ~OCCURE(RWayF) | (RWayF.FuelTake = 0) THEN
       L_StdFrm.Choice(" ࠢ");
      END;
     END;
    END;
    IF (L_Fuel.FlAcntLev(RWayS.Date) # L_Fuel.fal_RWOP) &
       (_Run > 0) & (RWayS.FuelFact = 0) THEN
     L_StdFrm.Choice("㫥 室 ⮯,   ஡");
    END;
   END;
  END;
  IF wDriverRWayS THEN
   L_Way.CurRWayS_XDocJrn_Stop();
   SAVE(RWayS);
   CHANGESEL(RWayS, TSN, , RWayS.TSN);
   IF NEXT(RWayS) THEN
    NxtRWSBeg:=L_DatTim.GetVARIANTDATE(RWayS.Date, L_BegRWS.GetRWaySExitTime(0), 0);
    L_BegRWS.cffe_CheckTimeFromLastChange(NxtRWSBeg, Default, ReasonStr);
    Local:=PROCREF(E_Way.cffe_Correct);
    IF ~!Local THEN
     Reason:=L_BegRWS.cffeR_BadRestTime;
     Local(RWayS.Date, RWayS.TSN, RWayS.BoxNbr, RWayS.Exit, Default, Reason, ReasonStr, L_XDoc.action_begDst);
    END;
    IF Default = L_BegRWS.cffe_No THEN
     L_StdFrm.RedInform("騩  ⥫  ᬮ  뤠 ६" +
                        "|- 筮 ६   ᬥ");
    END;
   END;
   RESTORE(RWayS);
  END;
  MarkRWaySCWOrdersXDocJrn(L_XDoc.action_begRcp, RWayS.RWayS);
 END {AfterAccept};

 PRIVATE PROCEDURE CancelAccept();
  VAR
   _Date: LIKE(RWayS.Date);
 BEGIN
  Choice(" ⬥ ਥ ⥢  " + RWayS.RWayS, L_XDoc.action_begRcpCncl);
  CheckAcceptableRWaySStatus(L_XDoc.action_begRcpCncl, L_Way.rwsStat_Taken);
  L_BegRWS.DispOnly();
  IF L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
   SAVE(RWayS);
   _Date:=RWayS.Date;
   CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
   IF NEXT(RWayS) THEN
    L_General.Assert(RWayS.Status <= L_Way.rwsStat_Given,
                     " ⬥ ਥ ⥢ ,|.. ᫥   ਭ");
    IF (RWayS.Status = L_Way.rwsStat_Given) THEN
     L_General.Assert(RWayS.Date = _Date,
                      " ⬥ ਥ ⥢ ,|.. ᫥   뤠  㣮 ");
     SETEMPTY(RWayS.RemExit, RWayS.SMBef);
     L_BegRWS.REPLACE_RWayS();
    END;
   END; (* IF NEXT(RWayS) ... *)
   RESTORE(RWayS);
  END;
  RWayS.Status:=L_Way.rwsStat_Given;
  SETEMPTY(RWayS.RemEntr, RWayS.SMAft, RWayS.FuelFact);
  L_BegRWS.REPLACE_RWayS();
  IF ~L_Fuel.TanksIsStock(RWayS.Date) THEN
   CONFORM(RWayS, RWayF);
   REMSEL(RWayF);
  END;
  L_Way.CurRWayS_XDocJrn_Mark(L_XDoc.action_begRcpCncl);
  MarkRWaySCWOrdersXDocJrn(L_XDoc.action_begRcpCncl, RWayS.RWayS);
 END {CancelAccept};

(* -------------- Switch support ---------------------- *)

 CONST
  RWaySDescrLength = 61;

 PRIVATE PROCEDURE GetExitOfExitClss(_ExitClss: LIKE(ExitClss.ExitClss); T: TIME; _Strict: LIKE(ExitClss.Strict)): LIKE(StExit.Exit);
  VAR
   Result: LIKE(StExit.Exit);
   D     : DATE;
 BEGIN
  D:=L_BegRWS.DspSysDate();
  L_General.Assert(SEARCH(ExitClss, ExitClss, _ExitClss), "    室 (" + _ExitClss + ")");
  L_General.Assert(!_Strict | (ExitClss.Strict = _Strict), " ⨬  室 (" + _ExitClss + ")");
  SETEMPTY(Result);
  SETSEL(StExit, ECUpDate, _ExitClss);
  SRCINSEL(StExit, GE, , D);
  WHILE OCCURE(StExit) DO
   IF (L_Way._CheckExitOnDate(StExit.Exit, D) = L_Way.exvld_Active) &
      (L_Way.FullBegTime(1 + (D < SYSDATE()), T) >= L_Way.FullBegTime(1, StExit.BegTime)) THEN
    SETSEL(SEJobs, Exit, StExit.Exit);
    LAST(SEJobs);
    IF (L_Way.FullBegTime(1 + (D < SYSDATE()), T) <= L_Way.FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT)) THEN
     IF ~!Result THEN
      L_General.Error("  室 " + _ExitClss + " 㦥    " + L_DatTim.TimeStr(T) + " 室." +
                      "|" +
                      "(" + Result + "  " + StExit.Exit + ")");
     END;
     Result:=StExit.Exit;
    END;
   END;
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit)...*)
  IF !Result THEN
   L_General.Error("  室 " + _ExitClss + "    " + L_DatTim.TimeStr(T) + " 室");
  END;
  RETURN Result
 END {GetExitOfExitClss};

 PRIVATE PROCEDURE GetExitClssSign(_Exit: LIKE(StExit.Exit)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(StExit);
  SAVE(ExitClss);
  IF SEARCH(StExit, Exit, _Exit) & SEARCH(ExitClss, ExitClss, StExit.ExitClss) THEN
   Result:=ExitClss.Sign;
  ELSE
   Result=_Exit;
  END;
  RESTORE(ExitClss);
  RESTORE(StExit);
  RETURN Result;
 END {GetExitClssSign};

 PRIVATE PROCEDURE GetExitOnTime(_RWayS: LIKE(RWayS.RWayS); _Time: TIME): LIKE(RWayS.Exit);
 BEGIN
  SETSEL(RWayJ, RWayS, _RWayS);
  IF SRCINSEL(RWayJ, LE, 1, _Time) THEN
   CONFORM(RWayJ, SEJobs);
   RETURN SEJobs.Exit;
  ELSE
   SEARCH(RWayS, RWayS, , _RWayS);
   RETURN RWayS.Exit;
  END;
 END {GetExitOnTime};

 PRIVATE PROCEDURE Switch_GetRWaySDescription(_RWayS: LIKE(RWayS.RWayS)): STRING[];
 BEGIN
  SEARCH(RWayS, RWayS, , _RWayS);
  CONFORM(RWayS, Man);
  RETURN "(" + Str.Item("|||", "|", RWayS.Status) + ")" +
         " :" + RWayS.BoxNbr +
         " :" + RWayS.TSN + "(" + Str.Align(L_Str.ShortName(Man.Name), 20, LEFT) + ")" +
         " 室:" + Str.Align(GetExitClssSign(GetExitOnTime(RWayS.RWayS, SYSTIME())), 7, LEFT) +"("+RWayS.Change+")";
 END {Switch_GetRWaySDescription};

 PRIVATE PROCEDURE Switch_ConfirmSource(goodRWayS: LIKE(RWayS.RWayS)[];
                                        Amount   : NUMERIC[0]): NUMERIC[0];
  CONST
   ButtonWidth = RWaySDescrLength + 2;
  VAR
   i     : NUMERIC[0];
   Msg   : STRING[];
 BEGIN
  IF Amount = 1 THEN
   RETURN 1;
  ELSE
   i:=0;
   Msg:="|" + L_StdFrm.DrawButton("⬥", ButtonWidth, "X");
   WHILE i < Amount DO
    Msg:=Msg + "|" +
         L_StdFrm.DrawButton(Switch_GetRWaySDescription(goodRWayS[i]),
                    ButtonWidth,
                    L_Str.PoolItem("DB|B", i>0));
    INC(i);
   END; (* WHILE i < Amount ... *)
   RETURN STDFORM(Msg,
                  " ४祭: ⢥ত 롮  ",
                  INFORM);
  END;
 END {Switch_ConfirmSource};

 PRIVATE PROCEDURE Put_iSwap();
 BEGIN
  IF L_BegRWS.E_wTRANSNAVIGATSIA(RWayS.Date) THEN
   TRY
    CALL(xRfTN, 133);
   EXCEPT
   ON Exc: Exc_Root DO
    L_StdFrm.RedInform(", ᮮ   訡:" +
                       "||'" + Exc.MsgOriginalText + "'");
   END; (* TRY *)
  END;
  IF L_General.GetAPSiteNumber() = 84 THEN
   TRY
    CALL(xRWayD.Switch());
   EXCEPT
   ON Exc: Exc_Root DO
    L_StdFrm.RedInform(", ᮮ   訡:" +
                       "||'" + Exc.MsgOriginalText + "'");
   END; (* TRY *)
  END;
 END {Put_iSwap};

 PRIVATE PROCEDURE smn_RWSDescr(asExitCls, asBoxNbr, asTSN: STRING[]): STRING[];
 BEGIN
  RETURN Str.Align(asExitCls, 7, LEFT) + " " + Str.Align(asBoxNbr, 4, LEFT) + " " + Str.Align(asTSN, 5, LEFT);
 END {smn_RWSDescr};

 PRIVATE PROCEDURE switch_intMakeNote(msg, Comment, RWSDescr: STRING[]);
 BEGIN
  IF ~!Comment THEN
   Comment:=" (" + Comment + ")";
  END;
  IF ~!RWSDescr THEN
   RWSDescr:="|" + RWSDescr;
  END;
  L_Msg.MakeCurRecordSystemNote(L_General.curUSER, "RWayS", msg + Comment + RWSDescr);
 END {switch_intMakeNote};

 PUBLIC PROCEDURE switch_MakeNote(msg: STRING[]);
  CONST
   ButtonWidth = 13;
  VAR
   Comment: STRING[];
 BEGIN
  IF L_General.GetAPSiteNumber() # 84 THEN
   Comment:="";
   STDFORM("|稭 ᥭ                              " +
           "|%60YI" +
           "||" + L_StdFrm.DrawButton( "⬥", ButtonWidth, "X") +
           "  " + L_StdFrm.DrawButton("믮", ButtonWidth, "DB"),
           "  " + RWayS.RWayS + ": ⬥⪠  ᥭ    ", , -1, Comment);
   CONFORM(RWayS, StExit);
   CONFORM(StExit, ExitClss);
   switch_intMakeNote(msg, Comment, smn_RWSDescr(ExitClss.Sign, RWayS.BoxNbr, RWayS.TSN));
  END;
 END {switch_MakeNote};

 PRIVATE PROCEDURE ExitClsSign(trgExit: LIKE(RWayS.Exit)): STRING[];
  VAR
   result: STRING[];
 BEGIN
  SAVE(StExit);
  SAVE(ExitClss);
  L_General.CallUs(SEARCH(StExit, Exit, trgExit));
  CONFORM(StExit, ExitClss);
  result:=ExitClss.Sign;
  RESTORE(StExit);
  RESTORE(ExitClss);
  RETURN result;
 END {ExitClsSign};

 PRIVATE PROCEDURE Switch_Do(_RWayS: LIKE(RWayS.RWayS); _Time: TIME; _Exit: LIKE(RWayS.Exit); Comment: STRING[]);
  VAR
   TripByTKind,
   _Trip       : LIKE(SEJobs.Trip);
   prvExit     : LIKE(StExit.Exit);
 BEGIN
  L_General.CallUs(SEARCH(StExit, Exit, _Exit));
  SEARCH(RWayS, RWayS, , _RWayS);
  IF RWayS.Status = L_Way.rwsStat_Ordered THEN
   switch_intMakeNote("室 ->" + ExitClsSign(_Exit),
                      Comment,
                      smn_RWSDescr(ExitClsSign(RWayS.Exit), RWayS.BoxNbr, RWayS.TSN));
   RWayS.Exit:=_Exit;
   L_BegRWS.REPLACE_RWayS();
   L_BegRWS.SetExitData();
   Put_iSwap();
  ELSE
   L_General.CallUs(~L_Way.WasTaxedRWayS());
   CONFORM(RWayS, RWayJ);
   SRCINSEL(RWayJ, GE, , 1, _Time);
   WHILE OCCURE(RWayJ) DO
    REMOVE(RWayJ);
   END;
   CONFORM(StExit, SEJobs);
   IF StExit.Strict = L_Way.ExitStrict_Reg THEN
    IF ~SRCINSEL(SEJobs, LE, SEJobs.Day + (_Time < SEJobs.StartT), _Time) THEN
     FIRST(SEJobs);
    END;
   ELSE
    LOOP
     CONFORM(SEJobs, RoutMod);
     IF L_DatTim.IsActive_Inc(RWayS.Date, RoutMod.FromD, RoutMod.UpDate) THEN
      _Trip:=SEJobs.Trip;
      IF L_Way.E_GetTOL(RWayS.Date) = L_Way.tol_ByDominantTKind THEN
       L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
       CONFORM(SEJobs, Route);
       IF CarLog.TKind = L_Way.GetRouteTKind(RWayS.Date, 0) THEN
        TripByTKind:=SEJobs.Trip;
        EXIT;
       END;
      END;
     END;
     L_General.Assert(NEXT(SEJobs) | ~!_Trip, " 室 " + StExit.Exit +
                                              "  ३ᮢ,   " +
                                              L_DatTim.DateStr(RWayS.Date));
     IF ~OCCURE(SEJobs) THEN
      EXIT;
     END;
    END;
    IF ~OCCURE(SEJobs) & ~!_Trip THEN
     L_General.CallUs(SEARCH(SEJobs, Trip, _Trip));
    END;
   END;
   DEFAULT(RWayJ);
   RWayJ.RWayS :=_RWayS;
   RWayJ.Day   :=1;
   RWayJ.StartT:=_Time;
   RWayJ.Trip  :=SEJobs.Trip;
   INSERT(RWayJ);
   L_BegRWS.REPLACE_RWayS();
   CHANGESEL(RWayJ, RWayS, , RWayJ.RWayS);
   IF PREV(RWayJ) THEN
    CONFORM(RWayJ, SEJobs);
    prvExit:=SEJobs.Exit;
   ELSE
    prvExit:=RWayS.Exit;
   END;
   switch_intMakeNote("c " + L_DatTim.TimeStr(_Time) + " 室 ->" + ExitClsSign(_Exit),
                      Comment,
                      smn_RWSDescr(ExitClsSign(prvExit), RWayS.BoxNbr, RWayS.TSN));
  END;
  IF RWayS.Status = L_Way.rwsStat_Ordered THEN
   L_Way.CurRWayS_XDocJrn_Mark(L_XDoc.action_begEdit);
  ELSE
   L_Way.CurRWayS_XDocJrn_Mark(L_XDoc.action_begSwitch);
  END;
 END {Switch_Do};

 PRIVATE PROCEDURE Switch_SetDestination(_RWayS: LIKE(RWayS.RWayS)): SCAL[2];
  CONST
   ButtonWidth = 11;
   SwitchVariantsPool = "४  㣮 室"+
                        "|⠢  १"+
                        "|ࠢ  ६";
  VAR
   i         : NUMERIC[0];
   s         : STRING[2];
   Comment,
   Msg       : STRING[];
   Result    : NUMERIC[0];
   _ExitClss : LIKE(ExitClss.ExitClss);
   _Exit,
   oldExit   : LIKE(StExit.Exit);
   _Time     : TIME;
   _Variant  : SCAL[4];
 BEGIN
  SEARCH(RWayS, RWayS, , _RWayS);
  Comment:="";
  Msg:="|"+
       L_StdFrm.DrawLineInBox(Switch_GetRWaySDescription(_RWayS)) +
       "|" +
       L_StdFrm._DrawInBox(Str.Align(" %L<HM>I %LAI %L6I",
                           RWaySDescrLength - L_StdFrm.GetMaxItemLength(SwitchVariantsPool) - 1,
                           LEFT), RWaySDescrLength) +
       "|" +
       L_StdFrm.DrawInLabeledBox("稭 ४祭  ⬥⪨  ୠ",
                                 " %L"+L_Str.IntStr(RWaySDescrLength-4)+L_Str.PoolItem("N|", L_BegRWS.E_TWOLevel(RWayS.Date))+"I ", RWaySDescrLength) +
       "||"+
       L_StdFrm.DrawButton("믮", ButtonWidth, "DB") +
       "  " +
       L_StdFrm.DrawButton( "⬥", ButtonWidth, "X") +
       L_StdFrm.DrawEmpty(RWaySDescrLength - 2*(ButtonWidth+1) - 2);

  _Time:=SYSTIME(); SETEMPTY(_ExitClss, _Variant);
  LOOP
   TRY
    Result:=STDFORM(Msg,
                    " ४祭: 롮 祭 ",
                    ,
                    ,
                    _Time, SwitchVariantsPool, _Variant, _ExitClss, Comment);
    IF Result = 0 THEN
     RETURN 0;
    ELSE
     IF    _Variant = 0 THEN
      _Exit:=GetExitOfExitClss(_ExitClss, _Time, EMPTYOF(ExitClss.Strict));
     ELSIF _Variant = 1 THEN _Exit:=L_Way.erkn_e_Get(RWayS.Date, L_Way.erkn_ec_Reserve);
     ELSIF _Variant = 2 THEN _Exit:=L_Way.erkn_e_Get(RWayS.Date, L_Way.erkn_ec_CurRepair);
     ELSE
      L_General.CallUs(0);
     END;
     IF STDFORM("|"+
                L_StdFrm.DrawLineInBox(Switch_GetRWaySDescription(_RWayS)) +
                "|" +
                L_StdFrm.DrawLineInBox(Str.Align(" " + L_DatTim.TimeStr(_Time) + " " +
                                                 Str.Item(SwitchVariantsPool, "|", _Variant) +
                                                 " " + GetExitClssSign(_Exit),
                                                 RWaySDescrLength, CENTRE)) +
               "|" +
               L_StdFrm.DrawInLabeledBox("稭 ४祭  ⬥⪨  ୠ",
                                         Str.Align(Comment, RWaySDescrLength, CENTRE), RWaySDescrLength) +
                "||" + L_StdFrm.DrawButton( "⬥", ButtonWidth, "X") +
                "  " + L_StdFrm.DrawButton("믮", ButtonWidth, "B"),
            " ४祭: ⢥ত 롮 祭 ",
            INFORM) # 0 THEN
      oldExit:=GetExitOnTime(_RWayS, _Time);
      CheckRWayTxt();
      CheckStrictExitDoubling(_Exit, oldExit, _Time, Comment);
      Switch_Do(_RWayS, _Time, _Exit, Comment);
      IF RWayS.Status = L_Way.rwsStat_Ordered THEN
       L_BegRWS.E_CheckCrewFitForExit(L_XDoc.action_begEdit);
      END;
      RETURN 1;
     END; (* IF STDFORM ... *)
    END; (* IF Result ... *)
   EXCEPT
    ON Exc: Exc_Raise DO
     L_StdFrm.RedInform(Exc.MsgOriginalText);
    ON Exc: Exc_Halt DO
     (* nothing *)
   ELSE
    RAISE();
   END; (* TRY *)
  END; (* LOOP *)
 END {Switch_SetDestination};

 PRIVATE PROCEDURE Switch_SetSource(    Title     : STRING[];
                                    VAR _BoxNbr   : LIKE(RWayS.BoxNbr);
                                    VAR _TSN      : LIKE(RWayS.TSN);
                                    VAR _ExitClss : LIKE(RWayS.Exit);
                                    VAR _RWayS    : LIKE(RWayS.RWayS));
 BEGIN
  STDFORM(L_StdFrm.sf_Choice("|"+
                             "              室   "+
                             "||"+
                             "%####%  %#####%  %######%     %#######%|",
                             "%LYI %LYI %LYI %LYI"),
          Title,
          ,
          ,
          _BoxNbr, _TSN, _ExitClss, _RWayS);
 END {Switch_SetSource};

 PUBLIC PROCEDURE Switch();
  CONST
   GoodsNum = 8;
  VAR
   _BoxNbr   : LIKE(RWayS.BoxNbr);
   _TSN      : LIKE(RWayS.TSN);
   _ExitClss : LIKE(ExitClss.ExitClss);
   _Exit     : LIKE(RWayS.Exit);
   _RWayS    : LIKE(RWayS.RWayS);
   goodRWayS : LIKE(RWayS.RWayS)[GoodsNum];
   Result,
   Count     : NUMERIC[0];
   Leader    : STRING[];
 BEGIN
  IF L_General.IsMemberOf(L_APtm.g_DispLine) THEN
   GRANTALLRIGHTS();
  END;
  L_RT.rtx_Init();
  SAVE(RWayS);
  SETEMPTY(_BoxNbr, _TSN, _RWayS, _ExitClss);
  LOOP
   TRY
    Switch_SetSource(" ४祭 ", _BoxNbr, _TSN, _ExitClss, _RWayS);
    IF ~!_ExitClss THEN
     _Exit:=GetExitOfExitClss(_ExitClss, SYSTIME(), L_Way.ExitStrict_Reg);
    ELSE
     SETEMPTY(_Exit);
    END;
    Leader:="RWayS";
    IF    ~!_BoxNbr   THEN SELECT(RWayS, BoxNbr, , _BoxNbr, L_BegRWS.DspSysDate());
    ELSIF ~!_TSN      THEN SELECT(RWayS,    TSN, ,    _TSN, L_BegRWS.DspSysDate());
    ELSIF ~!_RWayS    THEN SELECT(RWayS,  RWayS, ,  _RWayS);
    ELSIF ~!_Exit     THEN
     Leader:="rtExit";
     IF ~SELECT(rtExit, DDExit, L_BegRWS.DspSysDate(), _Exit) | !rtExit.RWayS THEN
      L_General.Error("室 " + _Exit + "   ");
     END;
    ELSE
     L_General.Error("  -");
    END;
    Count:=0; SETEMPTY(goodRWayS);
    WHILE OCCURE(^Leader) DO
     IF Leader = "rtExit" THEN
      SEARCH(RWayS, RWayS, , rtExit.RWayS);
     ELSE
      SELECT(rtExit, DDRWayS, , L_BegRWS.DspSysDate(), RWayS.RWayS);
     END;
     IF (RWayS.Status <= L_Way.rwsStat_Given) &
        (!_TSN    | (_TSN    =    RWayS.TSN)) &
        (!_BoxNbr | (_BoxNbr = RWayS.BoxNbr)) &
        (!_Exit   | (OCCURE(rtExit) & (_Exit =   rtExit.Exit))) THEN
      goodRWayS[Count]:=RWayS.RWayS;
      INC(Count);
      L_General.Assert(Count < GoodsNum, "筨  - ᫨誮  ਠ⮢");
     END;
     NEXT(^Leader);
    END; (* WHILE OCCURE(^Leader) ... *)
    L_General.Assert(Count > 0, " ⥢ ⮢  ⠪ ࠬࠬ");
    Result:=Switch_ConfirmSource(goodRWayS, Count);
    IF (Result > 0) & Switch_SetDestination(goodRWayS[Result-1]) THEN
     Put_iSwap();
     EXIT;
    END;
   EXCEPT
    ON Exc: Exc_Raise DO
     L_StdFrm.RedInform(Exc.MsgOriginalText);
   ELSE
    RAISE();
   END; (* TRY *)
  END; (* LOOP *)
  RESTORE(RWayS);
  intChkLated();
 END {Switch};

 PRIVATE PROCEDURE RWayS_OnBeforeEdit();
 BEGIN
  IF    RWayS.Status = L_Way.rwsStat_Ordered THEN
   L_Way.CurRWayS_XDocJrn_Start(L_XDoc.action_begEdit);
  ELSIF RWayS.Status = L_Way.rwsStat_Given THEN
   BeforeAccept();
  ELSE
   L_General.Error(" 믮 ⢨ 'ਥ'    ﭨ '" +
                    L_Str.PoolItem(L_Way.rwsStat_Pool, RWayS.Status) + "'");
  END;
 END {RWayS_OnBeforeEdit};

 PRIVATE PROCEDURE BeginAccept();
 BEGIN
  CheckAcceptableRWaySStatus(L_XDoc.action_begRcp, L_Way.rwsStat_Given);
  LIKEMENU(Edit, "@");
 END {BeginAccept};

 PRIVATE PROCEDURE AfterEdInsOrderedRWayS(AfterEdit: SCAL[2]);
  VAR
   Note,
   Comment: STRING[];
 BEGIN
  L_RT.rtx_Init();
  Note:="";
  Comment:="";
  IF AfterEdit THEN
   IF RWayS.Exit # GE_PVALUE(RWayS.Exit) THEN
    CheckRWayTxt();
    CheckStrictExitDoubling(RWayS.Exit, GE_PVALUE(RWayS.Exit), SYSTIME(), Comment);
    Note:="室 ->" + ExitClsSign(RWayS.Exit);
   END;
   IF RWayS.BoxNbr # GE_PVALUE(RWayS.BoxNbr) THEN
    Note:=L_Str.AddStrDlm(Note, ", ") + " ->" + RWayS.BoxNbr;
   END;
   IF RWayS.TSN # GE_PVALUE(RWayS.TSN) THEN
    Note:=L_Str.AddStrDlm(Note, ", ") + ". ->" + RWayS.TSN;
   END;
   L_BegRWS.REPLACE_RWayS();
   IF ~!Note THEN
    switch_intMakeNote(Note, Comment, smn_RWSDescr(ExitClsSign(GE_PVALUE(RWayS.Exit)),
                                                   GE_PVALUE(RWayS.BoxNbr),
                                                   GE_PVALUE(RWayS.TSN)));
   END;
  ELSE
   CheckStrictExitDoubling(RWayS.Exit, "", SYSTIME(), Comment);
   L_BegRWS.REPLACE_RWayS();
   switch_intMakeNote("室 " + ExitClsSign(RWayS.Exit) + ",  " + RWayS.BoxNbr + ", . " + RWayS.TSN,
                      Comment, "⠢ ");
  END;
  L_BegRWS.SetExitData();
  L_BegRWS.CheckWithWayLMen();
  Put_iSwap();
  L_Way.CurRWayS_XDocJrn_Stop();
  intChkLated();
  IF AfterEdit THEN
   L_BegRWS.E_CheckCrewFitForExit(L_XDoc.action_begEdit);
  ELSE
   L_BegRWS.E_CheckCrewFitForExit(L_XDoc.action_begInsert);
  END;
 END {AfterEdInsOrderedRWayS};

 PRIVATE PROCEDURE RWayS_OnAfterEdit();
 BEGIN
  IF    RWayS.Status = L_Way.rwsStat_Ordered THEN
   AfterEdInsOrderedRWayS(1);
  ELSIF RWayS.Status = L_Way.rwsStat_Given THEN
   AfterAccept(1);
  ELSE
   L_General.CallUs(0);
  END;
 END {RWayS_OnAfterEdit};

 PRIVATE PROCEDURE RWayS_OnBeforeInsert();
 BEGIN
  RWayS.Status:=L_Way.rwsStat_Ordered;
  RWayS.Date  :=Memo.ud_cd();
  REPLACE(RWayS);
  L_Way.CurRWayS_XDocJrn_Start(L_XDoc.action_begInsert);
 END {RWayS_OnBeforeInsert};

 PRIVATE PROCEDURE RWayS_OnAfterInsert();
 BEGIN
  AfterEdInsOrderedRWayS(0);
 END {RWayS_OnAfterInsert};

 PRIVATE PROCEDURE RWayS_OnBeforeDelete();
 BEGIN
  IF RWayS.Status # L_Way.rwsStat_Ordered THEN
   L_General.Error("  ⮫쪮    '殮'");
  ELSE
   RemoveRWayS(0, 0);
  END;
 END {RWayS_OnBeforeDelete};

 PRIVATE PROCEDURE Beg1E_OnConformToWindow();
 BEGIN
  IF !RTI.Get().TrgWindow.ParentZone THEN
   IF IsFirstConformToWindowEvent THEN
    IF ~!v_XDocId THEN
     L_XDoc.PositionOnXDoc(v_XDocId);
     SE_WWD_CURSOR(mainWindow, RWayS);
     IsFirstConformToWindowEvent:=0;
    END;
   END;
  END;
 END {Beg1E_OnConformToWindow};

 PRIVATE PROCEDURE GetLastObjectSign(): STRING[];
  VAR
   Object,
   Result: STRING[];
 BEGIN
  IF    XDocJrn.XDocType = L_XDoc.xdt_RWayS THEN
   Object:=RWayS.BoxNbr;
  ELSIF XDocJrn.XDocType = L_XDoc.xdt_RprS THEN
   L_Rpr.AccessOrigin();
   Object:=OutCar.StateNbr;
  END;
  Result:=Str.Align(Object, 10, LEFT) + " ";
  IF XDocJrn.Date # SYSDATE() THEN
   Result:=Result + FLDTOSTR(XDocJrn.Date, "D.N.Y") + " " + L_DatTim.TimeStr(XDocJrn.BegTime);
  ELSE
   Result:=Result + "        " +                      " " + L_DatTim.TimeStr(XDocJrn.BegTime);
  END;
  RETURN Result;
 END {GetLastObjectSign};

 PRIVATE PROCEDURE setOutpostFieldValue(FieldName: STRING[]; Value: ANYTYPE);
 BEGIN
  APP.Get().Forms("OutPost").Zones(0).Fields(FieldName).Value:=Value;
 END {setOutpostFieldValue};

 PRIVATE PROCEDURE drc_SetLastBoxNbr(FieldName: STRING[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  IF L_WDO.WindowExists("OutPost") THEN
   i:=DepartReturnMarkAmount;
   WHILE i >= 1 DO
    setOutpostFieldValue(L_WDO.Fld_wIdx(FieldName, i), APP.Get().Forms("OutPost").Zones(0).Fields(L_WDO.Fld_wIdx(FieldName, i-1)).Value);
    DEC(i);
   END;
 
   setOutpostFieldValue(L_WDO.Fld_wIdx(FieldName, 0), GetLastObjectSign());
  END;
 END {drc_SetLastBoxNbr};

 PRIVATE PROCEDURE StartXDocAction(wSetLastBoxNbr: SCAL[2]; trgXDocId: L_XDoc.tXDocId);
  VAR
   LastBoxNbrFieldNameToSet: STRING[];
 BEGIN
  SETEMPTY(LastBoxNbrFieldNameToSet);
  CheckAcceptableAction(XDoc_Action, L_XDoc.ExtractXDocType(trgXDocId));
  IF    XDoc_Action = L_XDoc.action_VerifyCC THEN
   bcs_DoAndInform(" ஢", 0, 0);
  ELSIF XDoc_Action = L_XDoc.action_begDstCncl THEN
   CancelWriteOut();
  ELSIF XDoc_Action = L_XDoc.action_begRcp THEN
   BeginAccept();
  ELSIF XDoc_Action = L_XDoc.action_begRcpCncl THEN
   CancelAccept();
  ELSIF XDoc_Action = L_XDoc.action_AcceptCarDeparture THEN
   bcs_DoAndInform("륧 ࠧ襭", 1, 1);
  ELSIF XDoc_Action = L_XDoc.action_CarDeparture THEN
   bcs_DoAndInform("륧 䨪஢", 1, 1);
   LastBoxNbrFieldNameToSet:="v_Departures";
  ELSIF XDoc_Action = L_XDoc.action_CarReturn THEN
   bcs_DoAndInform(" 䨪஢", 1, 0);
   LastBoxNbrFieldNameToSet:="v_Returns";
  ELSIF XDoc_Action = L_XDoc.action_AcceptCarReturn THEN
   bcs_DoAndInform(" ਭ", 1, 0);
  ELSIF XDoc_Action = L_XDoc.action_MedicalExamination THEN
   bcs_DoAndInform("ᬮ 䨪஢", 1, 0);
  ELSIF XDoc_Action = L_XDoc.action_Reprint THEN
   Choice("  ९ ⥢  " + RWayS.RWayS, XDoc_Action);
   L_BegRWS.ToBeVerifiedRWaySCnt:=0;
   RePrint(0, 0);
  ELSIF XDoc_Action = action_View THEN
   CheckBCS_Exist(XDoc_Action);
  ELSE
   L_General.CallUs(0);
  END;

  IF L_XDoc.ExtractXDocType(v_XDocId) = L_XDoc.xdt_RWayS THEN
   outpostCurBoxNbr:=RWayS.BoxNbr;
   IF L_BegRWS.IsActionChangeCarState(XDoc_Action) THEN
    L_BegRWS.REPLACE_RWayS();
   END;
  END;

  IF wSetLastBoxNbr & ~!LastBoxNbrFieldNameToSet THEN
   drc_SetLastBoxNbr(LastBoxNbrFieldNameToSet);
  END;
 END {StartXDocAction};

 PRIVATE PROCEDURE CheckAcceptableRWayS(trgRWayS  : LIKE(RWayS.RWayS);
                                        trgCopyCnt: L_XDoc.tCopyCnt);
 BEGIN
  L_General.Assert(SEARCH(RWayS, RWayS, trgRWayS), "  ⥢  " + trgRWayS);
  L_General.Assert(RWayS.CopyCnt = trgCopyCnt, "     ᮮ⢥  㬠 ⥫");
 END {CheckAcceptableRWayS};

 PRIVATE PROCEDURE CheckAcceptableRprS(trgRprS   : LIKE(RprS.RprS);
                                       trgCopyCnt: L_XDoc.tCopyCnt);
 BEGIN
  L_General.Assert(SEARCH(RprS, RprS, trgRprS), "   " + trgRprS);
  IF XDoc_Action = L_XDoc.action_CarDeparture THEN
   L_General.Assert(L_Rpr.IsRprS_w_OutCar(), "⬥⪨ ࠧ襭    ६ ஭ ");
   L_General.Assert(trgCopyCnt = 99, "⬥⪨  ⮫쪮    ।  稪");
  ELSE
   L_General.Assert(RprS.CopyCnt = trgCopyCnt, "     ᮮ⢥  㬠 ⥫");
   L_General.Error("   ࠧ襭 ⮫쪮 ⬥⪨  륧");
  END;
 END {CheckAcceptableRprS};

 PRIVATE PROCEDURE AccessXDocByXDocId(_XDocId : L_XDoc.tXDocId;
                                      _CopyCnt: L_XDoc.tCopyCnt);
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
   _XDoc    : L_XDoc.tXDoc;
 BEGIN
  L_XDoc.DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
  IF    _XDocType = L_XDoc.xdt_RWayS THEN
   CheckAcceptableRWayS(_XDoc, _CopyCnt);
  ELSIF _XDocType = L_XDoc.xdt_RprS THEN
   CheckAcceptableRprS(_XDoc, _CopyCnt);
  ELSE
   L_General.Error("४ ");
  END;
  v_XDocId:=_XDocId;
 END {AccessXDocByXDocId};

 PRIVATE PROCEDURE AllowedAction(trgAction: LIKE(XDocJrn.Action); trgXDocType: L_XDoc.tXDocType): SCAL[2];
 BEGIN
  TRY
   CheckAcceptableAction(trgAction, trgXDocType);
   RETURN 1;
  EXCEPT
  ON Exc: Exc_Raise DO
   RETURN 0;
  ELSE
   RAISE();
  END; (* TRY *)
 END {AllowedAction};

 PRIVATE PROCEDURE AllowedBoxNbrAction(TimeOut: NUMERIC[0]): SCAL[2];
  VAR
   LastActionTime,
   CurActionTime: FLOAT;
 BEGIN
  IF outpostCurBoxNbr # RWayS.BoxNbr THEN
   SETSEL(XDocJrn, XDocJrn, L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
   LAST(XDocJrn);
   IF (XDocJrn.Action = L_XDoc.action_CarDeparture) |
      (XDocJrn.Action = L_XDoc.action_CarReturn) THEN
    LastActionTime:=L_DatTim.GetVARIANTDATE(XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec);
    CurActionTime :=L_DatTim.GetSysVARIANTDATE();
    RETURN (CurActionTime - LastActionTime) * 24 * 60 > TimeOut;
   END;
  END;
  RETURN 1;
 END {AllowedBoxNbrAction};

 PRIVATE PROCEDURE pr_OutPost(    _XDocId : L_XDoc.tXDocId;
                                  _CopyCnt: L_XDoc.tCopyCnt;
                              VAR _Message: STRING[]);
  CONST
   TimeOut = 30;
  VAR
   _Action                 : LIKE(XDocJrn.Action);
   ErrMsg,
   LastBoxNbrFieldNameToSet: STRING[];
 BEGIN
  SETEMPTY(ErrMsg);
  L_XDoc.PositionOnXDoc(_XDocId);
  IF    L_XDoc.ExtractXDocType(_XDocId) = L_XDoc.xdt_RWayS THEN
   IF AllowedBoxNbrAction(TimeOut) THEN
    SETEMPTY(outpostCurBoxNbr);
    SETSEL(XDocJrn, XDocJrn, L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
    LAST(XDocJrn);
    LOOP
     IF    ~OCCURE(XDocJrn) THEN
      IF L_BegRWS.CarIsUnderControlOfPrevRWayS() THEN
       _Action:=L_XDoc.action_CarReturn;
       LastBoxNbrFieldNameToSet:="v_Returns";
      ELSE
       _Action:=L_XDoc.action_CarDeparture;
       LastBoxNbrFieldNameToSet:="v_Departures";
      END;
      EXIT;
     ELSIF XDocJrn.Action = L_XDoc.action_CarReturn THEN
      _Action:=L_XDoc.action_CarDeparture;
      LastBoxNbrFieldNameToSet:="v_Departures";
      EXIT;
     ELSIF XDocJrn.Action = L_XDoc.action_CarDeparture THEN
      _Action:=L_XDoc.action_CarReturn;
      LastBoxNbrFieldNameToSet:="v_Returns";
      EXIT;
     END;
     PREV(XDocJrn);
    END; (* LOOP  ... *)
 
    IF ~AllowedAction(_Action, L_XDoc.xdt_RWayS) THEN
     ErrMsg:="|륧/ ࠭ᯮ⭮ ।⢠ " + RWayS.BoxNbr +
             "| ⥢  " + RWayS.RWayS +
             "|" +
             "|!" +
             "|" +
             "| ᭥ ⥫ 室" +
             "|  堭  ᯥ.";
    END;
   ELSE
    outpostCurBoxNbr:=RWayS.BoxNbr;
    ErrMsg          :="륧/  " + RWayS.BoxNbr + "  祭 " + L_Str.IntStr(TimeOut) + " ."+
                      "|" +
                      "| ⢥ত   ᪠ ";
   END;
  ELSIF L_XDoc.ExtractXDocType(_XDocId) = L_XDoc.xdt_RprS THEN
   L_Rpr.AccessOrigin();
   _Action                 :=L_XDoc.action_CarDeparture;
   LastBoxNbrFieldNameToSet:="v_Departures";
   IF ~AllowedAction(_Action, L_XDoc.xdt_RprS) THEN
    ErrMsg:="|륧 ࠭ᯮ⭮ ।⢠ " + OutCar.StateNbr +
            "| ६⭮  " + RprS.RprS +
            "|" +
            "|!" +
            "|" +
            "| ᭥ ⥫ 室" +
            "|  堭.";
   END;
  ELSE
   L_General.Error("⬥⪠  ⮫쪮     ");
  END;
  IF !ErrMsg THEN
   XDoc_Action:=_Action;
   AccessXDocByXDocId(_XDocId, _CopyCnt);
   StartXDocAction(0, _XDocId);
   drc_SetLastBoxNbr(LastBoxNbrFieldNameToSet);
  ELSE
   L_General.Error(ErrMsg);
  END;
  HALT(0); (* Restart *)
 END {pr_OutPost};

 PRIVATE PROCEDURE eh_OutPost(    Exc      : Exc_Raise;
                              VAR _Message : STRING[];
                              VAR _WasError: SCAL[2]);
 BEGIN
  IF FIO.Exists("Err_OutP", "WAV") THEN
   PLAYSOUND("Err_OutP", SOUND_ASYNC);
  END;
  _Message :=Exc.MsgOriginalText;
  _WasError:=1;
 END {eh_OutPost};

 PRIVATE PROCEDURE IsCancelVerifingXDocId(_XDocId : L_XDoc.tXDocId): SCAL[2];
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
   _XDoc    : L_XDoc.tXDoc;
 BEGIN
  L_XDoc.DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
  RETURN (_XDocType = L_XDoc.xdt_Command) & (_XDoc = L_XDoc.cmd_CancelVerifing);
 END {IsCancelVerifingXDocId};

 PRIVATE PROCEDURE CloseRWaySWindow();
 BEGIN
  IF XDoc_Action = L_XDoc.action_VerifyCC THEN
   DEC(L_BegRWS.ToBeVerifiedRWaySCnt);
  END;
  Reset_v_XDocId();
  IF (RTI.Get().CurWindow.OriginalName = mainWindow) & IsBCS_Exist(XDoc_Action) THEN
   LIKEMENU(CloseWin, "",
            CALL,  "BegRWS.RestoreRWaysPosition()");
  END;
 END {CloseRWaySWindow};

 PRIVATE PROCEDURE ProcessXDoc(    _XDocId : L_XDoc.tXDocId;
                                   _CopyCnt: L_XDoc.tCopyCnt;
                               VAR _Message: STRING[]);
 BEGIN
  IF (XDoc_Action = L_XDoc.action_VerifyCC) &
     IsCancelVerifingXDocId(_XDocId) THEN
   L_StdFrm.RedInform("!  ⪠  䨪樨 !|" +
                      "쭥 ࠡ   㤥 㤭  !");
   IF MODE # Mode_ManualVerification THEN
    CloseRWaySWindow();
   END;
   HALT(0);
  ELSE
   IsFirstConformToWindowEvent:=1;
   AccessXDocByXDocId(_XDocId, _CopyCnt);
   IF    XDoc_Action = action_View THEN
    LIKEMENU(ShowWin, mainWindow + " 0 @", SC,  "Beg.BarCodeMode_ShowWin_Beg1E_0");
   ELSIF XDoc_Action = L_XDoc.action_begRcp THEN
    CheckAcceptableRWaySStatus(L_XDoc.action_begRcp, L_Way.rwsStat_Given);
    LIKEMENU(Edit,    mainWindow + " 0 @", SC, "Beg.BarCodeMode_Edit_Beg1E_0");
   ELSIF (XDoc_Action = L_XDoc.action_AcceptCarDeparture) |
         (XDoc_Action = L_XDoc.action_CarDeparture      ) |
         (XDoc_Action = L_XDoc.action_CarReturn         ) |
         (XDoc_Action = L_XDoc.action_AcceptCarReturn   ) THEN
    LIKEMENU(CALL, "BegRWS.StartXDocAction_DoInTry()");
   ELSE
    LIKEMENU(ShowWin, mainWindow + " 0 @",
             SC,      "Beg.BarCodeMode_ShowWin_Beg1E_0",
             CALL,    "BegRWS.ProcessRWaySAfterOpenBegRWSWindow()");
   END;
  END;
 END {ProcessXDoc};

 PUBLIC PROCEDURE StartXDocAction_DoInTry();
 BEGIN
  L_XDoc.PositionOnXDoc(v_XDocId);
  TRY
   StartXDocAction(1, v_XDocId);
  EXCEPT
  ON Exc: Exc_Root DO
   IF ~L_General.IsLockReleaseException(Exc) THEN
    L_StdFrm.RedInform(Exc.MsgOriginalText);
   END;
  END; (* TRY *)
 END {StartXDocAction_DoInTry};

 PUBLIC PROCEDURE ProcessRWaySAfterOpenBegRWSWindow();
  VAR
   trgXDocType: L_XDoc.tXDocType;
   trgXDocKind: L_XDoc.tXDocKind;
   trgXDoc    : L_XDoc.tXDoc;
 BEGIN
  L_XDoc.DecodeXDocId(v_XDocId, trgXDocType, trgXDocKind, trgXDoc);
  IF trgXDocType = L_XDoc.xdt_RWayS THEN
   L_General.CallUs(RTI.Get().CurWindow.OriginalName = mainWindow);
   L_General.CallUs(ACCESS(RWayS));
   L_General.Assert(RWayS.RWayS = trgXDoc, "믮 樨 .||" +
                                           "室  楤 ᪠஢ ");
   StartXDocAction_DoInTry();
   CloseRWaySWindow();
  END;
 END {ProcessRWaySAfterOpenBegRWSWindow};

 PRIVATE PROCEDURE CheckCorrectRWaySParams(_RWayS  : LIKE(RWayS.RWayS);
                                           _CopyCnt: L_XDoc.tCopyCnt;
                                           _BoxNbr : LIKE(Car.BoxNbr);
                                           _TSN    : LIKE(Staff.TSN));
 BEGIN
  CheckAcceptableRWayS(_RWayS, _CopyCnt);
  L_General.Assert(RWayS.BoxNbr = _BoxNbr, "ࠦ      ᮮ⢥ 㪠");
  L_General.Assert(RWayS.TSN = _TSN, "      ᮮ⢥ 㪠");
 END {CheckCorrectRWaySParams};

 PRIVATE PROCEDURE AccessAndProcessXDoc(ActionAsStr: STRING[];
                                        pr_Proc,
                                        eh_Proc    : PROC);
  VAR
   trgRWayS    : LIKE(RWayS.RWayS);
   trgCopyCnt  : L_XDoc.tCopyCnt;
   trgBoxNbr   : LIKE(Car.BoxNbr);
   trgTSN      : LIKE(Staff.TSN);
   BCSRegime   : L_BarCode.tBCSRegime;
   dummyMessage: STRING[];
 BEGIN
  BCSRegime:=L_BarCode.GetBCSRegime();
  IF    BCSRegime = L_BarCode.BCSr_OnLine THEN
   LOOP
    IF ~!eh_Proc THEN
     L_XDoc.extDoByBarCode(ActionAsStr, pr_Proc, 0, eh_Proc);
    ELSE
     L_XDoc.DoByBarCode(ActionAsStr, pr_Proc, 0);
    END;
    IF XDoc_Action # L_XDoc.action_VerifyCC THEN
     EXIT;
    END;
   END; (* LOOP *)
   CloseRWaySWindow();
  ELSIF (BCSRegime = L_BarCode.BCSr_Disconnect) | (BCSRegime = L_BarCode.BCSr_AutoDisconnect) THEN
   SETEMPTY(trgRWayS, trgCopyCnt, trgBoxNbr, trgTSN, v_XDocId);
   IF STDFORM(L_StdFrm.PartForm("%LI" +
                                "%LI" +
                                "%LI" +
                                "%LI" +
                                "%< 믮 >DB" +
                                "%< ⬥ >X" +
                                "@"+
                                "|        : %#######%  %##%|" +
                                "|ࠦ  : %####%           |" +
                                "| : %#####%          |" +
                                "|" +
                                "|  %###########%     %##########%  "),
                                " " + ActionAsStr + " ",
                                ,
                                ,
                                trgRWayS, trgCopyCnt, trgBoxNbr, trgTSN) THEN
    CheckCorrectRWaySParams(trgRWayS, trgCopyCnt, trgBoxNbr, trgTSN);
    IF XDoc_Action # L_XDoc.action_begRcp  THEN
     L_BarCode.SetBCSRegime(L_BarCode.BCSr_OnLine);
    END;
    v_XDocId:=L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, trgRWayS);
    pr_Proc(v_XDocId, trgCopyCnt, dummyMessage);
   ELSE
    L_BarCode.SetBCSRegime(L_BarCode.BCSr_OnLine);
    HALT(1);
   END;
  ELSE
   L_General.Error(" 믮  樨 ॡ OPOS ᪠.   ");
  END;
 END {AccessAndProcessXDoc};

 PRIVATE PROCEDURE IsWriteOutRWaySMode(): SCAL[2];
 BEGIN
  RETURN (MODE = 062) | (MODE = 064);
 END {IsWriteOutRWaySMode};

 PRIVATE PROCEDURE FoundRWayS4Man(D: DATE; trgMan: LIKE(Man.Man); VAR Msg: STRING[]): LIKE(RWayS.RWayS);
  VAR
   fTSN  : LIKE(Staff.TSN);
   Result: LIKE(RWayS.RWayS);
 BEGIN
  SETEMPTY(fTSN, Msg, Result);
  TRY [RESTORE_CURSORS(RC_ON)]
   SELECT(Staff, Man, , trgMan);
   LOOP
    IF ~OCCURE(Staff) THEN
     IF !fTSN THEN
      Msg:="   室 㤮 ஢." +
           "||뤠   ⮫쪮  ਧ樨";
     END;
     EXIT;
    END;
    IF L_Staff.rInState(D) THEN
     IF !fTSN THEN
      fTSN:=Staff.TSN;
     ELSE
      Msg:="  ᪮쪮 㤮 ஢." +
           "||뤠   ⮫쪮  ਧ樨";
      EXIT;
     END;
    END;
    NEXT(Staff);
   END; (* LOOP ... *)
   IF !Msg THEN
    Msg:=" ࠡ⭨ " + fTSN + "  ࠧ殮   " + L_DatTim.DateStr(D) + ".";
    SELECT(RWayS, sTSN, , L_Way.rwsStat_Ordered, fTSN);
    LOOP
     IF ~OCCURE(RWayS) THEN
      EXIT;
     END;
     IF GetRWaySDspDate() = D THEN
      IF ~!Result THEN
       Msg:=" ࠡ⭨ " + fTSN + " ᪮쪮 ࠧ殮   " + L_DatTim.DateStr(D) + "." +
            "||뤠   ⮫쪮  ਧ樨";
       SETEMPTY(Result);
       EXIT;
      END;
      Result:=RWayS.RWayS;
      SETEMPTY(Msg);
     END;
     NEXT(RWayS);
    END; (* LOOP *)
   END;
  EXCEPT
  END;
  L_General.CallUs(!Result # !Msg);
  RETURN Result;
 END {FoundRWayS4Man};

 PRIVATE PROCEDURE Do();
  VAR
   D                  : DATE;
   _TSN               : LIKE(Staff.TSN);
   Msg,
   Dummy,
   dummyMessage,
   ActionAsStr        : STRING[];
   trgCopyCnt         : L_XDoc.tCopyCnt;
   trgRWayS           : LIKE(RWayS.RWayS);
   NeccessaryBCSExists: SCAL[2];
 BEGIN
  IF IsWriteOutRWaySMode() & L_Way.E_CheckStaffByCard() THEN
   SETEMPTY(XDoc_Action, ActionAsStr);

   Reset_v_XDocId();
   D:=L_BegRWS.DspSysDate();
   IF MODE = 062 THEN
    SETEMPTY(_TSN);
    CALL(Staff.AuthoriseByProximityCard("䨪 ࠡ⭨  ய"));
    trgRWayS:=FoundRWayS4Man(D, Man.Man, Msg);
    IF ~!trgRWayS THEN
     v_XDocId:=L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, trgRWayS);
     L_XDoc.PositionOnXDoc(v_XDocId);
    ELSE
     Reset_v_XDocId();
     L_StdFrm.RedInform(Msg);
    END;
   ELSE
    L_General.Assert(ACCESS(RWayS), " ⠭ ⥪騩 ");
    CONFORM(RWayS, StExit);
    CONFORM(RWayS, Staff);
    CONFORM(Staff, Man);
    trgRWayS:=FoundRWayS4Man(D, Man.Man, Dummy);
    L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
    Msg:="       " + Str.Align(RWayS.RWayS, 40, LEFT) + "|" +
         "⥫ " + Str.Align(RWayS.TSN + " " + Man.Name, 40, LEFT) + "|" +
         "室    " + Str.Align(RWayS.Exit + " " + StExit.Name, 40, LEFT) + "|" +
         "       " + Str.Align(RWayS.BoxNbr + " " + Mark.Name, 40, LEFT);
    IF    ~!trgRWayS THEN
     L_StdFrm.Choice("뤠   ਧ樨:                        ||" + Msg);
    ELSIF L_Env.RealTSN(RWayS.TSN) THEN
     L_StdFrm.Question("뤠   ਧ樨:                       ||" + Msg);
    ELSE
     L_StdFrm.Question("뤠   䨪⨢ ⥫  ਧ樨:||" + Msg);
    END;
    v_XDocId:=L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
   END;
  ELSE
   TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    IF    ACCESS(RWayS) THEN
     v_curXDocId:=L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
    ELSIF ACCESS(RprS) THEN
     v_curXDocId:=L_XDoc.XDocId(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS);
    ELSE
     SETEMPTY(v_curXDocId);
    END;
   EXCEPT
   ON Exc: Exc_AccessDeny DO
    SETEMPTY(v_curXDocId);
   END; (* TRY *)
   NeccessaryBCSExists:=0;
   IF    (MODE = Mode_ManualVerification) | (MODE = Mode_VerificationAfterPrint) THEN
    XDoc_Action:=L_XDoc.action_VerifyCC;
    ActionAsStr :="⢥ত ";
    NeccessaryBCSExists:=1;
    IF MODE = Mode_ManualVerification THEN
     L_BegRWS.ToBeVerifiedRWaySCnt:=1;
    END;
   ELSIF MODE = 063 THEN
    XDoc_Action:=L_XDoc.action_begDstCncl;
    ActionAsStr :="⬥ 뤠";
   ELSIF MODE = 065 THEN
    XDoc_Action:=L_XDoc.action_begRcp;
    ActionAsStr :="ਥ ";
   ELSIF MODE = 066 THEN
    XDoc_Action:=L_XDoc.action_begRcpCncl;
    ActionAsStr :="⬥ ਥ ";
   ELSIF MODE = 067 THEN
    XDoc_Action:=action_View;
    ActionAsStr :="ᬮ ";
   ELSIF MODE = 068 THEN
    L_General.TestIsMemberOfSpecificGroup(L_APtm.IsMechanic(), "堭");
    XDoc_Action:=L_XDoc.action_AcceptCarDeparture;
    ActionAsStr :="襭  륧 ";
    NeccessaryBCSExists:=1;
   ELSIF MODE = 069 THEN
    L_General.TestIsMemberOfSpecificGroup(L_APtm.IsMechanic(), "堭");
    XDoc_Action:=L_XDoc.action_CarDeparture;
    ActionAsStr :="륧 ";
    NeccessaryBCSExists:=1;
   ELSIF MODE = 101 THEN
    XDoc_Action:=L_XDoc.action_CarReturn;
    ActionAsStr :=" ";
    NeccessaryBCSExists:=1;
   ELSIF MODE = 102 THEN
    XDoc_Action:=L_XDoc.action_AcceptCarReturn;
    ActionAsStr :="ਥ ";
    NeccessaryBCSExists:=1;
   ELSIF MODE = 103 THEN
    XDoc_Action:=L_XDoc.action_MedicalExamination;
    ActionAsStr :="ᬮ";
    NeccessaryBCSExists:=1;
   ELSIF MODE = 082 THEN
    XDoc_Action:=L_XDoc.action_Reprint;
    ActionAsStr :="९⪠ ";
   ELSE
    XDoc_Action:="";
    ActionAsStr :="";
   END;
   IF NeccessaryBCSExists THEN
    CheckBCS_Exist(XDoc_Action);
   END;
   Reset_v_XDocId();
   IF ~!XDoc_Action & IsBCS_Exist(XDoc_Action) THEN
    L_General.Assert(L_BegRWS.E_BegRWS_IsRequiredAction(XDoc_Action),
                     "⢨ '" + L_Str.PoolItem(L_XDoc.action_Pool, XDoc_Action) + "'  ॡ");
    IF (XDoc_Action # L_XDoc.action_Reprint) |
       (ACCESS(RWayS) &
        ((L_BarCode.GetBCSRegime() = L_BarCode.BCSr_AutoDisconnect) | L_XDoc.BegXDocIsVerified(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS, 2))) THEN
     AccessAndProcessXDoc(ActionAsStr, PROCREF(ProcessXDoc), EMPTYOF(PROC));
    ELSE
     Set_v_XDocId();
     IF    L_XDoc.ExtractXDocType(v_XDocId) = L_XDoc.xdt_RWayS THEN
      trgCopyCnt:=RWayS.CopyCnt;
     ELSIF L_XDoc.ExtractXDocType(v_XDocId) = L_XDoc.xdt_RprS THEN
      trgCopyCnt:=RprS.CopyCnt;
     ELSE
      L_General.CallUs(0);
     END;
     ProcessXDoc(v_XDocId, trgCopyCnt, dummyMessage);
    END;
   ELSE
    Set_v_XDocId();
   END;
  END;
 END {Do};

 PRIVATE PROCEDURE VerifyCurrent();
 BEGIN
  IF IsBCS_Exist(L_XDoc.action_VerifyCC) & (L_BegRWS.ToBeVerifiedRWaySCnt > 0) THEN
   LIKEMENU(RunProg, "BegRWS, " + L_Str.IntStr(Mode_VerificationAfterPrint));
  END; (* IF L_BegRWS.ToBeVerifiedRWaySCnt > 0...*)
 END {VerifyCurrent};

 PUBLIC PROCEDURE RestoreRWaysPosition();
 BEGIN
  IF ~!GE_CURWIN() & ~!v_curXDocId THEN
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    L_XDoc.PositionOnXDoc(v_curXDocId);
    SE_WZD_POSITION(GE_CURWIN(), 1, RWayS);
   EXCEPT
   ELSE
   END; (* TRY *)
  END;
  IF XDoc_Action = L_XDoc.action_VerifyCC THEN
   VerifyCurrent();
  END;
 END {RestoreRWaysPosition};

(*
$P{ Top_AAWOD:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
@
####################################################################################################### ########## #####
=#####==================================================================================================================
|                         ⮪ 뤠  ਭ   ⥢ ⮢  ##########                         |
|----------------------------------------------------------------------------------------------------------------------|
|     |.|. |ઠ                           | 室                         |ਬ砭             |
}
*)

(*
$P{ Line_AAWOD:
RWayS.RWayS, L, ""
Car.BoxNbr, L, ""
CarLog.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
ExitClss.Sign, L, ""
ExitClss.Name, L, ""
@
|-------|----|----------|--------------------------------|-------------------------------------|-----------------------|
|#######|####|##########|#### ###########################|####### #############################|                       |
}
*)

(*
$P{ Bot_AAWOD:
@
=(c) Polak==============================================================================================================
}
*)

 PRIVATE PROCEDURE E_RunTimeAcceptAllWODriver(): TIME;
 BEGIN
  RETURN L_EC.ExecE_Func_Time(SYSDATE(), PROCREF(E_Way.BegRWS_RunTimeAcceptAllWODriver), 20:00);
 END {E_RunTimeAcceptAllWODriver};

 PUBLIC PROCEDURE AcceptAllWODriver();
  CONST
   RepName = "AAWOD";
  VAR
   Run_time     : TIME;
   Run_date     : DATE;
   SysActionTime,
   RunActionTime: FLOAT;
 BEGIN
  Run_date     :=L_BegRWS.DspSysDate();
  Run_time     :=E_RunTimeAcceptAllWODriver();
  SysActionTime:=L_DatTim.GetSysVARIANTDATE();
  RunActionTime:=L_DatTim.GetVARIANTDATE(Run_date, Run_time, 00);

  L_StdFrm.Choice(" 䨪⨢ , 뤠  ਭ   ⥫|| " + L_DatTim.DateStr(Run_date));
  L_General.Assert(SysActionTime >= RunActionTime,
                   " 믮  " + L_DatTim.DateStr(Run_date) +
                   " ᫥ " + L_DatTim.TimeStr(Run_time));

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top_AAWOD, RepName, Run_date);
  SELECT(RWayS, Date, , Run_date);
  WHILE OCCURE(RWayS) DO
   IF RWayS.Status = L_Way.rwsStat_Ordered THEN
    PROMPT("ਥ  "+RWayS.RWayS);
    CONFORM(RWayS, StExit, ExitClss);
    IF L_BegRWS.IsFictiveRWayS() & ~L_Way.RWaySSomeTimeWas(L_XDoc.action_begDst) THEN
     RemoveRWayS(1, 1);
    ELSE
     IF ~L_Env.RealTSN(RWayS.TSN) &
        ((ExitClss.BegType=L_Way.ecbt_Outage) |
         (ExitClss.BegType=L_Way.ecbt_Repair) |
         (ExitClss.BegType=L_Way.ecbt_Reserv) |
         L_Way.E_IsGuardIdleExit(RWayS.Date, RWayS.Exit)) THEN
      CONFORM(RWayS, Car);
      L_Car.StandOnCarLog(Car.BoxNbr, Run_date);
      CONFORM(CarLog, Mark);
      MAKEPART(R, Line_AAWOD);
      SAVE(RWayS);
      WriteOut(1, 0);
      RWayS.RemEntr:=RWayS.RemExit;
      RWayS.SMAft  :=RWayS.SMBef;
      AfterAccept(0);
      L_Way.CurRWayS_XDocJrn_Mark(L_XDoc.action_begRcp);
      RESTORE(RWayS);
     END; (* IF (RWayS.TSN... *)
     NEXT(RWayS);
    END;
   ELSE
    NEXT(RWayS);
   END;
  END; (* WHILE OCCURE(RWayS) ... *)
  MAKEPART(R, Bot_AAWOD);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {AcceptAllWODriver};

 PRIVATE PROCEDURE RenewCarMovementInformationBySingleXDocType();
  VAR
   i, j: NUMERIC[0];
 BEGIN
 END {RenewCarMovementInformationBySingleXDocType};

 PUBLIC PROCEDURE RenewCarMovementInformation();
  VAR
   i, j: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= DepartReturnMarkAmount DO
   setOutpostFieldValue(L_WDO.Fld_wIdx("v_Departures", i), " ");
   setOutpostFieldValue(L_WDO.Fld_wIdx("v_Returns", i),    " ");
   INC(i);
  END;

  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

   SETSEL(XDocJrn, AcsObj, L_General.curUSER);
   LAST(XDocJrn);
   SETZERO(i, j);
   WHILE OCCURE(XDocJrn) & ((i <= DepartReturnMarkAmount) | (j <= DepartReturnMarkAmount)) DO
    IF (XDocJrn.XDocType = L_XDoc.xdt_RWayS) | (XDocJrn.XDocType = L_XDoc.xdt_RprS) THEN
     L_XDoc.PositionOnXDoc(L_XDoc.XDocId(XDocJrn.XDocType, XDocJrn.XDocKind, XDocJrn.XDoc));
     IF    XDocJrn.Action = L_XDoc.action_CarDeparture THEN
      IF i <= DepartReturnMarkAmount THEN
       setOutpostFieldValue(L_WDO.Fld_wIdx("v_Departures", i), GetLastObjectSign());
       INC(i);
      END;
     ELSIF XDocJrn.Action = L_XDoc.action_CarReturn THEN
      IF j <= DepartReturnMarkAmount THEN
       setOutpostFieldValue(L_WDO.Fld_wIdx("v_Returns", j), GetLastObjectSign());
       INC(j);
      END;
     END;
    END;
    PREV(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)
  EXCEPT
  ON Exc: Exc_Root DO
   RAISE();
  END; (* TRY *)
 END {RenewCarMovementInformation};

 PRIVATE PROCEDURE OutPost_0_OnZoneOpen();
 BEGIN
  IF L_APtm.IsOutPost() THEN
   RTI.Get().CurProcess.ReplaceContexts("ShowWin_OutPost_0_UCD_OutPost");
  ELSE
   RTI.Get().CurProcess.ReplaceContexts("ShowWin_OutPost_0_UCD_AP_Users");
  END;
  RenewCarMovementInformation();
 END {OutPost_0_OnZoneOpen};

 PUBLIC PROCEDURE SetMechanicName();
  VAR
   _MN: STRING[];
 BEGIN
  _MN:=L_BegRWS.SetMechanicName(SYSDATE());
  IF ~!_MN THEN
   L_StdFrm.Inform("࠭ 堭 " + _MN);
  ELSE
   L_StdFrm.Inform("᮪ .  ࠭ 堭");
  END;
 END {SetMechanicName};

 PUBLIC PROCEDURE DisconnectBarCodeScanner();
 BEGIN
  CheckBCS_Exist(L_XDoc.action_begDst);
  L_BarCode.DisconnectBarCodeScanner();
 END {DisconnectBarCodeScanner};

 PUBLIC PROCEDURE RePrint_woBCS();
 BEGIN
  L_General.Assert(ACCESS(RWayS), " ⠭ ⥢ ");
  L_StdFrm.Question("९⪠ ﭭ  " + RWayS.RWayS + "  ᪠஢  ."+
                    "|९⪠  ⮫쪮  ,    뫮 ࠡ" +
                    "|(  륧  । ઠ)." +
                    "|| 믮 ⮩ 樨 ᪠ 㤥 ⮬᪨ ⪫祭.");
  L_BarCode.SetBCSRegime(L_BarCode.BCSr_AutoDisconnect);
  LIKEMENU(RunProg, "BegRWS 082");
 END {RePrint_woBCS};

 PUBLIC PROCEDURE AcceptRWayS_woBCS();
 BEGIN
  L_General.Assert(ACCESS(RWayS), " ⠭ ⥢ ");
  L_StdFrm.Question("ਥ ﭭ  " + RWayS.RWayS + "    ᪠஢  ."+
                    "|᫨  ⠭ ,  室 ନ  ." +
                    "|| 믮 ⮩ 樨 ᪠ 㤥 ⮬᪨ ⪫祭.");
  L_BarCode.SetBCSRegime(L_BarCode.BCSr_AutoDisconnect);
  LIKEMENU(RunProg, "BegRWS 065");
 END {AcceptRWayS_woBCS};

 PUBLIC PROCEDURE ResetAnyOutPostTimer();
  VAR
   S: STRING[];
 BEGIN
  S:=L_WDO.GetEnvVarValue("UseOutPostMode");
  IF    S = "AP_User"           THEN L_Timer.ResetTimer("CarMovementView");
  ELSIF S = "AP_User_AsOutPost" THEN L_Timer.ResetTimer("BegRWS_OutPost");
  ELSE                               L_Timer.ResetTimer("BegRWS_OutPost");
  END;
 END {ResetAnyOutPostTimer};

 PUBLIC PROCEDURE ResetTimer();
 BEGIN
  L_Timer.ResetTimer("BegRWS_ChkLated");
 END {ResetTimer};

 PUBLIC PROCEDURE PrintRWSAddDocs();
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   CALL(RWayP.PrintRWSAddDocs());
  EXCEPT
  ON Exc: Exc_Syntax DO
   IF Exc.ErrorCode = L_General.ec_rt_UnknownIdentifier THEN
    L_General.Error("⮢ ⥫ 㬥⮢  ।ᬮ७");
   ELSE
    RAISE();
   END;
  END; (* TRY *)
 END {PrintRWSAddDocs};

 PUBLIC PROCEDURE SetTimer();
 BEGIN
  L_Timer.SetTimer("BegRWS_ChkLated", 1, 20, "BegRWS.ChkLated()");
 END {SetTimer};

 PUBLIC PROCEDURE ChkLated();
 BEGIN
  L_RT.rtx_Init();
  intChkLated();
  ChkRDCar();
 END {ChkLated};

 PRIVATE PROCEDURE intPrintAndVerify(wPair: SCAL[2]);
 BEGIN
  Print(0);
  IF wPair & StandOnPair() THEN
   RePrint(1, 0);
  END;
  VerifyCurrent();
 END {intPrintAndVerify};

 PUBLIC PROCEDURE PrintAndVerify();
 BEGIN
  intPrintAndVerify(0);
 END {PrintAndVerify};

 PUBLIC PROCEDURE PrintWPairAndVerify();
 BEGIN
  intPrintAndVerify(1);
 END {PrintWPairAndVerify};

 PUBLIC PROCEDURE OutPost_SetTimer();
 BEGIN
  L_Timer.SetTimer("BegRWS_OutPost", 1, 1, "BegRWS.OutPost()");
(*  ResetTimer - ..  ᯥ᪮   OutPost  ४묨 *)
 END {OutPost_SetTimer};

 PUBLIC PROCEDURE CarMovementView_SetTimer();
 BEGIN
  L_Timer.SetTimer("CarMovementView", 1, 30, "BegRWS.RenewCarMovementInformation()");
 END {CarMovementView_SetTimer};

 PUBLIC PROCEDURE OutPost();
 BEGIN
  SETEMPTY(XDoc_Action, outpostCurBoxNbr);
  AccessAndProcessXDoc("ਭ  ", PROCREF(pr_OutPost), PROCREF(eh_OutPost));
 END {OutPost};

 PRIVATE PROCEDURE Beg0E_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iField       (0, "RWayS.Exit").First:=1;
  L_WDO.iScsChange   (0, ["RWayS.TSN", "RWayS.BoxNbr", "RWayS.Exit", "RWayS.Date"]);
  L_WDO.iUnmodifiable(0, ["RWayS.CopyCnt", "RWayS.RWayS"]);
  L_WDO.iField       (0, "StExit.ActivKnd").Format:=L_Way.seak_Pool;
  L_WDO.iZone        (0).RLevProg:="BegRWS";
  L_WDO.iZone        (0).ZLevProg:="BegRWS";
  L_WDO.iZone        (0).FLevProg:="RWayS";
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  L_WDO.iField       (1, "WayLMen.TSN").First:=1;
  L_WDO.iScsChange   (1, ["WayLMen.Who"]);
  L_WDO.iUnmodifiable(1, ["WayLMen.StopT", "WayLMen.StartT", "WayLMen.Day"]);
  L_WDO.iField       (1, "WayLMen.Who").Format:=L_Way.wlmwho_Pool;
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (3).ViewOnly:=1;
 END {Beg0E_OnInitializeWindow};

 PRIVATE PROCEDURE Beg1_1_OnSetSubwindow();
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_ShowWin THEN
   RTI.Get().CurZone.SubwindowOriginalName:="Beg0E";
  ELSE
   RTI.Get().CurZone.SubwindowOriginalName:="Beg1E";
  END;
 END {Beg1_1_OnSetSubwindow};

 PRIVATE PROCEDURE Beg0_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Beg";
  L_WDO.iZone        (1).Narrowing:="RWayS.Status="+L_Str.IntStr(L_Way.rwsStat_Ordered);
  L_WDO.iZone        (1).PermanentFilter:=L_Way.extCurPlaceFilter("RWayS", "");
  L_WDO.iSubwindow   (1, "Beg0E");
  L_WDO.iField       (1, "RWayS.Date").ReverseSorting:=1;
  L_WDO.iProgs       (1, "BegRWS");
  L_WDO.iZone        (2).ViewOnly:=1;
 END {Beg0_OnInitializeWindow};

 PRIVATE PROCEDURE Beg1_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Beg";
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).Narrowing:="RWayS.Status="+L_Str.IntStr(L_Way.rwsStat_Given);
  L_WDO.iZone        (1).PermanentFilter:=L_Way.extCurPlaceFilter("RWayS", "");
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iProgs       (1, "BegRWS");
 END {Beg1_OnInitializeWindow};

 PRIVATE PROCEDURE Beg2_1_OnSetSubwindow();
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_ShowWin THEN
   RTI.Get().CurZone.SubwindowOriginalName:="Beg0E";
  ELSE
   RTI.Get().CurZone.SubwindowOriginalName:="";
  END;
 END {Beg2_1_OnSetSubwindow};

 PRIVATE PROCEDURE Beg2_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Beg";
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).Narrowing:="RWayS.Status="+L_Str.IntStr(L_Way.rwsStat_Taken);
  L_WDO.iZone        (1).PermanentFilter:=L_Way.extCurPlaceFilter("RWayS", "");
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iProgs       (1, "BegRWS");
 END {Beg2_OnInitializeWindow};

 PRIVATE PROCEDURE RWayS_PutFilters(VAR Filters: L_WDO.tFilters);
 BEGIN
  IF AMOUNT(RWayS) < 100000 THEN
   L_WDO.PutNewFilter(Filters, "  ⥪饩 ", "(RWayS.Date=Memo.CurDate)", 1);
  END;
 END {RWayS_PutFilters};

 PUBLIC PROCEDURE scs_GetFilters_Beg0_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  RWayS_PutFilters(Filters);
 END {scs_GetFilters_Beg0_1};

 PUBLIC PROCEDURE scs_GetFilters_Beg1_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  RWayS_PutFilters(Filters);
 END {scs_GetFilters_Beg1_1};

 PUBLIC PROCEDURE scs_GetFilters_Beg2_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  RWayS_PutFilters(Filters);
 END {scs_GetFilters_Beg2_1};

BEGIN
 IF    L_Events.IsInternalEvents(MODE) | L_Events.IsSubWinEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSE
  Do();
(* !v_XDocId -  室    - *)
  IF ~!v_XDocId THEN
   IF    ~!XDoc_Action THEN
    StartXDocAction(1, v_XDocId);
   ELSIF IsWriteOutRWaySMode() THEN
    WriteOut(0, 1);
   ELSIF MODE = 083 THEN
    RePrint(0, 1);
   ELSIF MODE = 084 THEN
    WriteOut(1, 1);
   ELSIF MODE = 085 THEN
    Print(1);
   ELSE
    L_General.BadMode(MODE);
   END; (* IF MODE =... *)
   Reset_v_XDocId();
  END;
 END;
END.
