(*
%Copyright   (c) Polak Computer System
%Author      29.11.2000 21:04:16 GINA
%Purpose      楯窨  , ᯨ
%Type        report
%Specific    AP
%Modified    17.01.2014 23:41:32 POLAK\Gina
%Environment
*)

 IMPORT Memo, L_General, L_OwnData, L_Str, L_AFM, L_DatTim, L_Way;

 CONST
  COT_Rem = 0;
  COT_SM  = 1;

 VAR
  _TSNBef,
  _TSNAft : LIKE(Staff.TSN);
  RepName : STRING[];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################################################################                                   ########## #####
=#####=========================================================================================================================================================
|                                           ࠧ뢮 楯窨  ##########  ਮ  ##########  ##########                                           |
}
*)

(*
$P{ TopCol:
Car.Column, L, ""
@
|-------------------------------------------------------------------------------------------------------------------------------------------------------------|
| ##                                                                                                                                                   |
|-------------------------------------------------------------------------------------------------------------------------------------------------------------|
|.|ઠ              | |     |. |. |. | .| .|稭|ਬ砭                                                                   |
|    |                   |     |       |     |।.|᫥.|  ।|  ᫥| ࠧ뢠|                                                                             |
|----|-------------------|-----|-------|-----|-----|-----|------|------|--------|-----------------------------------------------------------------------------|
}
*)

(*
$P{ Line:
RWayS.BoxNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
RWayS.Date, L, "D.N"
RWayS.RWayS, L, ""
RWayS.TSN, L, ""
_TSNBef, L, ""
_TSNAft, L, ""
?, R, ""
?, R, ""
?, R, ""
@
|####|#### ##############|#####|#######|#####|#####|#####|######|######|########|                                                                             |
}
*)

(*
$P{ BotCol:
Car.Column, L, ""
?, R, ""
@
|-------------------------------------------------------------------------------|-----------------------------------------------------------------------------|
|⮣   ##                                             ###############|                                                                             |
}
*)

(*
$P{ Bot_Rem:
?, R, ""
@
|-------------------------------------------------------------------------------|-----------------------------------------------------------------------------|
|⮣                                                           ###############|                                                                             |
=(c) Polak=====================================================================================================================================================
}
*)

(*
$P{ Bot_SM:
@
=(c) Polak=====================================================================================================================================================
}
*)

 PRIVATE PROCEDURE ScanBreakTrip(BreakObjType: SCAL[8];
                                 BreakTrip   : LIKE(SEJobs.Trip));
  VAR
   FirstLine,
   NeedRWayS: SCAL[2];
   Gap,
   ColGap,
   TotGap: NUMERIC[0];
 BEGIN
  L_General.Assert(BreakTrip # 0, "  ஥");

  RepName:="Brek"+L_Str.PoolItem("R|S", BreakObjType);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, L_Str.PoolItem("|ᯨ", BreakObjType));

  L_General.Assert(SEARCH(SEJobs, Trip, BreakTrip),
                   "  ३ " + BreakTrip);
  CONFORM(SEJobs, StExit);
  L_AFM.MakeIndex("BL", "BoxNbr  : LIKE(RWayS.BoxNbr);" +
                        "Date    : DATE;" +
                        "StartTim: LIKE(RWayS.StartTim);" +
                        "RWayS   : LIKE(RWayS.RWayS)");
  SELECT(RWayS, Exit, , StExit.Exit);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date<=Memo.ud_ut()) DO
   PROMPT("  " + L_DatTim.DateStr(RWayS.Date)+ " : " + RWayS.RWayS);
   NeedRWayS:=0;
   CONFORM(RWayS, RWayJ);
   WHILE OCCURE(RWayJ) & ~NeedRWayS DO
    NeedRWayS:=RWayJ.Trip = BreakTrip;
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
   IF NeedRWayS THEN
    BL.BoxNbr  :=RWayS.BoxNbr;
    BL.Date    :=RWayS.Date;
    BL.RWayS   :=RWayS.RWayS;
    BL.StartTim:=RWayS.StartTim;
    INSERT(BL);
   END; (* IF NeedRWayS... *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  SETZERO(TotGap);
  SELECT(Car, Column);
  WHILE OCCURE(Car) DO
   SETZERO(ColGap);
   FirstLine:=1;
   CHANGESEL(Car, Column, , Car.Column);
   WHILE OCCURE(Car) DO
    CONFORM(Car, Mark);
    SELECT(BL, BL, , Car.BoxNbr);
    WHILE OCCURE(BL) DO
     L_General.Assert(SEARCH(RWayS, RWayS, BL.RWayS),
                      "   "+BL.RWayS);
     PROMPT(L_DatTim.DateStr(RWayS.Date)+ " : " + RWayS.RWayS);
     SAVE(RWayS);
     CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
     IF PREV(RWayS) THEN
      _TSNBef:=RWayS.TSN;
      NEXT(RWayS);
     ELSE
      SETEMPTY(_TSNBef);
      FIRST(RWayS);
     END;
     IF NEXT(RWayS) THEN
      _TSNAft:=RWayS.TSN;
     ELSE
      SETEMPTY(_TSNAft);
     END;
     RESTORE(RWayS);
     IF FirstLine THEN
      MAKEPART(R, TopCol);
      FirstLine:=0;
     END;
     IF    (BreakObjType = COT_Rem) THEN
      Gap:=RWayS.RemEntr-RWayS.RemExit;
      MAKEPART(R, Line, RWayS.RemExit, RWayS.RemEntr, Gap);
     ELSE
      Gap:=RWayS.SMAft-RWayS.SMBef;
      MAKEPART(R, Line, RWayS.SMBef,   RWayS.SMAft,   Gap);
     END;
     INC(TotGap, Gap);
     INC(ColGap, Gap);
     NEXT(BL);
    END; (* WHILE OCCURE(BL) ... *)
    NEXT(Car);
   END; (* WHILE OCCURE(Car) ... *)
   LAST(Car);
   IF ~FirstLine THEN
    MAKEPART(R, BotCol, ColGap);
   END;
   CHANGESEL(Car, Column);
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
  IF BreakObjType = COT_Rem THEN
   MAKEPART(R, Bot_Rem, TotGap);
  ELSE
   MAKEPART(R, Bot_SM);
  END;
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("BL");
 END {ScanBreakTrip};

BEGIN
 RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
 IF    MODE = 070 THEN       (* ࠧ   *)
  ScanBreakTrip(COT_Rem, L_Way.E_TripForFuelChainBreak(Memo.ud_fr()))
 ELSIF MODE = 080 THEN       (* ࠧ  ᯨ *)
  ScanBreakTrip(COT_SM,  L_Way.E_TripForSMChainBreak(Memo.ud_fr()))
 ELSE
  L_General.BadMode(MODE);
 END;
END.
