(*
%Copyright   (c) Polak IT
%Author      12.07.2004 19:16:21 POLAK\LDA
%Purpose       襭ﬨ 륧/   ४ ६ ࠡ
%Type        report
%Specific    AP
%Modified    10.04.2012 11:58:30 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_Basis, L_General, L_DatTim, L_Str, FIO, L_AFM, L_Car, L_Way,
        Math, Memo, L_XDoc, L_BegRWS, L_BarCode, L_bp;

 CONST
  CompareKind_Pool = "-|-";
  Reason_Pool      = "|륧|";
  Sign_Pool        = "|||ଠ";

  ck_Plan = 0;
  ck_Fact = 1;

  r_Work      = 0;
  r_Departure = 1;
  r_Return    = 2;

  s_Absent = 0;
  s_Less   = 1;
  s_More   = 2;
  s_Normal = 3;


 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "뤠砏");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "륧");
  L_Basis.wb_WrInQM(F, "⒠");
  L_Basis.wb_WrInQM(F, "륧");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "稭");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "稭");
  L_Basis.wb_WrInQM(F, "浪 ");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]; CompareKind, Reason, Sign: NUMERIC[0]; Value: FLOAT);
  VAR
   BT, ET: TIMESTAMP;
 BEGIN
  L_Basis.wb_WrScl(F, RWayS.RWayS);
  L_Basis.wb_WrDat(F, RWayS.Date);
  IF ~!TmRWS.BegDst THEN
   L_Basis.wb_WrTim(F, L_DatTim.GetTimeOfTIMESTAMP(TmRWS.BegDst));
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
  IF ~!TmRWS.Trip THEN
   SEARCH(SEJobs, Trip, , TmRWS.Trip);
   CONFORM(SEJobs, StExit);
   CONFORM(SEJobs, Route);
   L_Basis.wb_WrScl(F, StExit.Exit);
   L_Basis.wb_WrStr(F, StExit.Name);
   L_Basis.wb_WrScl(F, TmRWS.Trip);
   L_Basis.wb_WrStr(F, Route.Route);
   L_Basis.wb_WrStr(F, Route.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, CarLog.Column);
  L_Basis.wb_WrScl(F, RWayS.BoxNbr);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(CompareKind_Pool, CompareKind));
  IF ~!TmRWS.BT_RWS THEN
   L_Basis.wb_WrOrg(F, L_DatTim.TimestampStr(TmRWS.BT_RWS)+";");
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
  IF ~!TmRWS.ET_RWS THEN
   L_Basis.wb_WrOrg(F, L_DatTim.TimestampStr(TmRWS.ET_RWS)+";");
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
  IF CompareKind = ck_Plan THEN
   BT:=TmRWS.BT_SEJ;
   ET:=TmRWS.ET_SEJ;
  ELSE
   BT:=TmRWS.BT_Jrn;
   ET:=TmRWS.ET_Jrn;
  END;
  IF ~!BT THEN
   L_Basis.wb_WrOrg(F, L_DatTim.TimestampStr(BT)+";");
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
  IF ~!ET THEN
   L_Basis.wb_WrOrg(F, L_DatTim.TimestampStr(ET)+";");
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
  IF    (Reason = r_Departure) & TmRWS.IntmDprt THEN
   L_Basis.wb_WrStr(F, "륧ଦ");
  ELSIF (Reason = r_Return) & TmRWS.IntmRtrn THEN
   L_Basis.wb_WrStr(F, "ଦ");
  ELSE
   L_Basis.wb_WrStr(F, L_Str.PoolItem(Reason_Pool, Reason));
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem(Sign_Pool, Sign));
  L_Basis.wb_WrNum(F, Value, 3);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Car.inBeg_Pool, CarLog.InBeg));
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE Create_TmRWS();
 BEGIN
  CreateFILE(TmRWS, "", "⥫ ", "");

  CreateFIELD(TmRWS, RWayS,    LIKE(RWayS.RWayS), "", "",  "", "", "");
  CreateFIELD(TmRWS, Trip,     LIKE(SEJobs.Trip), "", "",  "", "", "");
  CreateFIELD(TmRWS, BegDst,   TIMESTAMP,         "", "",  "", "뤠 ", "");
  CreateFIELD(TmRWS, BT_RWS,   TIMESTAMP,         "", "",  "", "६ 砫  ", "");
  CreateFIELD(TmRWS, ET_RWS,   TIMESTAMP,         "", "",  "", "६ 砭  ", "");
  CreateFIELD(TmRWS, BT_SEJ,   TIMESTAMP,         "", "",  "", "६ 砫  ᯨᠭ", "");
  CreateFIELD(TmRWS, ET_SEJ,   TIMESTAMP,         "", "",  "", "६ 砭  ᯨᠭ", "");
  CreateFIELD(TmRWS, BT_Jrn,   TIMESTAMP,         "", "",  "", "६ 砫  ୠ", "");
  CreateFIELD(TmRWS, ET_Jrn,   TIMESTAMP,         "", "",  "", "६ 砭  ୠ", "");
  CreateFIELD(TmRWS, IntmDprt, SCAL[2],           "", "1", "", "륧 - ஬", "");
  CreateFIELD(TmRWS, IntmRtrn, SCAL[2],           "", "1", "", " - ஬", "");

  CreateINDEXandLINK(TmRWS, RWayS,  PLURAL, RWayS,  RWayS,  USER, "", "", RWayS, BT_RWS);
  CreateINDEX(TmRWS, Trip,  PLURAL, "", "", RWayS, Trip, BT_RWS);

  SetVersionOfFILE(TmRWS, 0);
  L_AFM.AF_CreateTemp("TmRWS", "TmRWS");
 END {Create_TmRWS};

 PRIVATE PROCEDURE GetRWayJStartDTS(): TIMESTAMP;
 BEGIN
  RETURN L_DatTim.GetTIMESTAMP(RWayS.Date + RWayJ.Day - 1,  RWayJ.StartT);
 END {GetRWayJStartDTS};

 PRIVATE PROCEDURE GetRWayJStopDTS(): TIMESTAMP;
 BEGIN
  RETURN L_DatTim.GetTIMESTAMP(RWayS.Date + RWayJ.Day - 1 + (RWayJ.StopT < RWayJ.StartT),  RWayJ.StopT);
 END {GetRWayJStopDTS};

 PRIVATE PROCEDURE GetSEJobsStartDTS(): TIMESTAMP;
 BEGIN
  RETURN L_DatTim.GetTIMESTAMP(RWayS.Date + SEJobs.Day - 1,  SEJobs.StartT);
 END {GetSEJobsStartDTS};

 PRIVATE PROCEDURE GetSEJobsStopDTS(): TIMESTAMP;
 BEGIN
  RETURN L_DatTim.GetTIMESTAMP(RWayS.Date + SEJobs.Day - 1 + (SEJobs.StopT < SEJobs.StartT),  SEJobs.StopT);
 END {GetSEJobsStopDTS};

 PRIVATE PROCEDURE GetXDocJrnDTS(): TIMESTAMP;
 BEGIN
  RETURN PackTIMESTAMP(XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec);
 END {GetXDocJrnDTS};

 PRIVATE PROCEDURE RWaySHasUnclosedCoupledAction(a1, a2: L_XDoc.tAction): SCAL[2];
 BEGIN
  RETURN L_XDoc.XDocHasUnclosedCoupledAction(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS, a1, a2);
 END {RWaySHasUnclosedCoupledAction};

 PRIVATE PROCEDURE GetBegDstDTS(): TIMESTAMP;
  VAR
   DTS: TIMESTAMP;
 BEGIN
  SAVE(XDocJrn);
  IF RWaySHasUnclosedCoupledAction(L_XDoc.action_begDst, L_XDoc.action_begDstCncl) THEN
   DTS:=PackTIMESTAMP(XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec);
  ELSE
   SETEMPTY(DTS);
  END;
  RESTORE(XDocJrn);
  RETURN DTS;
 END {GetBegDstDTS};

 PRIVATE PROCEDURE GetBegRcpDTS(): TIMESTAMP;
  VAR
   DTS: TIMESTAMP;
 BEGIN
  SAVE(XDocJrn);
  IF RWaySHasUnclosedCoupledAction(L_XDoc.action_begRcp, L_XDoc.action_begRcpCncl) THEN
   DTS:=PackTIMESTAMP(XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec);
  ELSE
   SETEMPTY(DTS);
  END;
  RESTORE(XDocJrn);
  RETURN DTS;
 END {GetBegDstRcpDTS};

 PRIVATE PROCEDURE StandOnWorkRWayJ(StandOnFirstRWayJ: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  CONFORM(RWayS, RWayJ);
  IF ~StandOnFirstRWayJ THEN
   LAST(RWayJ);
  END;
  WHILE OCCURE(RWayJ) & ~Result DO
   CONFORM(RWayJ, SEJobs);
   CONFORM(SEJobs, WJMode);
   IF WJMode.RunSel # L_Way.runsel_None THEN
    Result:=1;
   ELSE
    IF StandOnFirstRWayJ THEN
     NEXT(RWayJ);
    ELSE
     PREV(RWayJ);
    END;
   END;
  END; (* WHILE OCCURE(RWayJ) ... *)
  RETURN Result;
 END {StandOnWorkRWayJ};

 PRIVATE PROCEDURE StandOnWorkSEJobs(StandOnFirstSEJobs: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  CONFORM(RWayS, StExit);
  CONFORM(StExit, SEJobs);
  IF ~StandOnFirstSEJobs THEN
   LAST(SEJobs);
  END;
  WHILE OCCURE(SEJobs) & ~Result DO
   CONFORM(SEJobs, WJMode);
   IF WJMode.RunSel # L_Way.runsel_None THEN
    Result:=1;
   ELSE
    IF StandOnFirstSEJobs THEN
     NEXT(SEJobs);
    ELSE
     PREV(SEJobs);
    END;
   END;
  END; (* WHILE OCCURE(SEJobs) ... *)
  RETURN Result;
 END {StandOnWorkSEJobs};

 PRIVATE PROCEDURE HasOutPost(): SCAL[2];
 BEGIN
  RETURN L_BegRWS.E_UsingBarCodeScannerLevel(L_BegRWS.ubcr_Outpost) # L_BarCode.bcsl_None;
 END {HasOutPost};

 PRIVATE PROCEDURE drt_PutByRWayS(StopInPark: LIKE(Stop.Stop));
  CONST
   dir_Departure = 0;
   dir_Return    = 1;
  VAR
   Direction,
   BegDirection,
   HasDeparture : SCAL[2];
   Cnt          : NUMERIC[0];
 BEGIN
  IF HasOutPost() THEN
   IF L_BegRWS.CarIsUnderControlOfPrevRWayS() THEN
    BegDirection:=dir_Return;
   ELSE
    BegDirection:=dir_Departure;
   END;
  ELSE
   CONFORM(RWayS, StExit);
   IF (RWayS.Change = 2) & StExit.OutBox THEN
    BegDirection:=dir_Return;
   ELSE
    BegDirection:=dir_Departure;
   END;
  END;
  Direction:=BegDirection;

  SETZERO(Cnt, HasDeparture);
  IF RWayS.Status = L_Way.rwsStat_Rated THEN
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayJ) DO
    CONFORM(RWayJ, SEJobs);
    CONFORM(SEJobs, RoutMod);
    CONFORM(RoutMod, RtMStop);
    WHILE OCCURE(RtMStop) DO
     IF RtMStop.Stop = StopInPark THEN
      IF Direction = dir_Departure THEN
       DEFAULT(TmRWS);
       TmRWS.RWayS   :=RWayS.RWayS;
       TmRWS.Trip    :=RWayJ.Trip;
       TmRWS.BegDst  :=GetBegDstDTS();
       TmRWS.BT_RWS  :=GetRWayJStartDTS();
       TmRWS.BT_SEJ  :=GetSEJobsStartDTS();
       TmRWS.IntmDprt:=(BegDirection = dir_Return) | HasDeparture;
       INSERT(TmRWS);
       HasDeparture:=1;
       INC(Cnt);
      ELSE
       IF ~HasDeparture THEN
        DEFAULT(TmRWS);
        TmRWS.RWayS   :=RWayS.RWayS;
        TmRWS.Trip    :=RWayJ.Trip;
        TmRWS.BegDst  :=GetBegDstDTS();
        TmRWS.IntmDprt:=HasDeparture;
        INSERT(TmRWS);
       END;
       TmRWS.ET_RWS:=GetRWayJStopDTS();
       TmRWS.ET_SEJ:=GetSEJobsStopDTS();
       REPLACE(TmRWS);
       INC(Cnt);
      END;
      Direction:=~Direction;
     END;
     NEXT(RtMStop);
    END; (* WHILE OCCURE(RtMStop) ... *)
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)

   IF Cnt = 0 THEN
    DEFAULT(TmRWS);
    TmRWS.RWayS:=RWayS.RWayS;
    TmRWS.BegDst:=GetBegDstDTS();
    IF StandOnWorkRWayJ(1) THEN
     TmRWS.BT_RWS:=GetRWayJStartDTS();
    END;
    IF StandOnWorkRWayJ(0) THEN
     TmRWS.ET_RWS:=GetRWayJStopDTS();
    END;
    TmRWS.IntmDprt:=0;
    TmRWS.IntmRtrn:=0;
    INSERT(TmRWS);
   ELSE
    TmRWS.IntmRtrn:=!TmRWS.ET_RWS;
    REPLACE(TmRWS);
   END;

  ELSE
   CONFORM(RWayS, StExit);
   CONFORM(StExit, SEJobs);
   WHILE OCCURE(SEJobs) DO
    CONFORM(SEJobs, RoutMod);
    CONFORM(RoutMod, RtMStop);
    IF FIRST(RtMStop) & (RtMStop.Stop = StopInPark) | LAST(RtMStop) & (RtMStop.Stop = StopInPark) THEN
     IF Direction = dir_Departure THEN
      DEFAULT(TmRWS);
      TmRWS.RWayS   :=RWayS.RWayS;
      TmRWS.Trip    :=SEJobs.Trip;
      TmRWS.BegDst  :=GetBegDstDTS();
      TmRWS.BT_SEJ  :=GetSEJobsStartDTS();
      TmRWS.IntmDprt:=(BegDirection = dir_Return) | HasDeparture;
      INSERT(TmRWS);
      HasDeparture:=1;
      INC(Cnt);
     ELSE
      IF ~HasDeparture THEN
       DEFAULT(TmRWS);
       TmRWS.RWayS   :=RWayS.RWayS;
       TmRWS.Trip    :=SEJobs.Trip;
       TmRWS.BegDst  :=GetBegDstDTS();
       TmRWS.BT_SEJ  :=GetSEJobsStartDTS();
       TmRWS.IntmDprt:=HasDeparture;
       INSERT(TmRWS);
      END;

      TmRWS.ET_SEJ:=GetSEJobsStopDTS();
      REPLACE(TmRWS);
      INC(Cnt);
     END;
     Direction:=~Direction;
    END;
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs) ... *)

   IF Cnt = 0 THEN
    DEFAULT(TmRWS);
    TmRWS.RWayS:=RWayS.RWayS;
    TmRWS.BegDst:=GetBegDstDTS();
    IF StandOnWorkSEJobs(1) THEN
     TmRWS.BT_SEJ:=GetSEJobsStartDTS();
    END;
    IF StandOnWorkSEJobs(0) THEN
     TmRWS.ET_SEJ:=GetSEJobsStopDTS();
    END;
    TmRWS.IntmDprt:=0;
    TmRWS.IntmRtrn:=0;
    INSERT(TmRWS);
   ELSE
    TmRWS.IntmRtrn:=!TmRWS.ET_SEJ;
    REPLACE(TmRWS);
   END;
  END;
 END {drt_PutByRWayS};

 PRIVATE PROCEDURE LastCarReturnFixed(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF ~L_BegRWS.CarIsUnderControlOfNextRWayS() THEN
   Result:=1;
   SAVE(XDocJrn);
   WHILE NEXT(XDocJrn) & Result DO
    Result:=XDocJrn.Action # L_XDoc.action_CarDeparture;
   END; (* WHILE OCCURE(XDocJrn) ... *)
   RESTORE(XDocJrn);
   RETURN Result;
  ELSE
   RETURN 0;
  END;
 END {LastCarReturnFixed};

 PRIVATE PROCEDURE StandOnAcceptableTmRWS(Begin: SCAL[2]): SCAL[2];
 BEGIN
  WHILE OCCURE(TmRWS) & ((Begin & ~!TmRWS.BT_Jrn) | (~Begin & ~!TmRWS.ET_Jrn)) DO
   NEXT(TmRWS);
  END;
  RETURN OCCURE(TmRWS);
 END {StandOnAcceptableTmRWS};

 PRIVATE PROCEDURE drt_PutByXDocJrn();
  VAR
   HasCarDeparture,
   HasLastCarReturn: SCAL[2];
 BEGIN
  IF HasOutPost() THEN
   SELECT(TmRWS, RWayS, , RWayS.RWayS);

   HasLastCarReturn:=0;
   HasCarDeparture :=0;
   SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
   WHILE OCCURE(XDocJrn) DO
    IF    XDocJrn.Action = L_XDoc.action_CarDeparture THEN
     HasCarDeparture:=1;
     L_General.ConsultToUs(~HasLastCarReturn, "륧 ᫥ ⥫쭮 ");
     IF ~StandOnAcceptableTmRWS(1) THEN
      DEFAULT(TmRWS);
      TmRWS.RWayS :=RWayS.RWayS;
      TmRWS.BegDst:=GetBegDstDTS();
      INSERT(TmRWS);
     END;
     TmRWS.BT_Jrn:=GetXDocJrnDTS();
     REPLACE(TmRWS);
    ELSIF XDocJrn.Action = L_XDoc.action_CarReturn THEN
     IF ~StandOnAcceptableTmRWS(0) THEN
      DEFAULT(TmRWS);
      TmRWS.RWayS :=RWayS.RWayS;
      TmRWS.BegDst:=GetBegDstDTS();
      INSERT(TmRWS);
     END;

     IF LastCarReturnFixed() THEN
      LAST(TmRWS);
      HasLastCarReturn:=1;
     END;
     TmRWS.ET_Jrn:=GetXDocJrnDTS();
     REPLACE(TmRWS);
    END;
    NEXT(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)
  END; (* IF HasOutPost() *)
 END {drt_PutByXDocJrn};

 PRIVATE PROCEDURE MakeIndex(StopInPark: LIKE(Stop.Stop));
 BEGIN
  Create_TmRWS();

  SELECT(RWayS, Date);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   PROMPT("ࠡ⪠ " + RWayS.RWayS);
   drt_PutByRWayS(StopInPark);
   drt_PutByXDocJrn();
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE GetSign(DTS_RWS, DTS: TIMESTAMP; VAR Sign: NUMERIC[0]; VAR Value: NUMERIC[3]);
  CONST
   Delta = 10 / 60;
 BEGIN
  IF !DTS_RWS | !DTS THEN
   Sign :=s_Absent;
   Value:=0;
  ELSE
   Value:=Math.Abs(DTS_RWS - DTS) * 24;
   IF Value >= Delta THEN
    IF DTS_RWS <= DTS THEN
     Sign:=s_Less;
    ELSE
     Sign:=s_More;
    END;
   ELSE
    Sign:=s_Normal;
   END;
  END;
 END {GetSign};

 PRIVATE PROCEDURE GetPeriodSign(Period_1, Period_2: NUMERIC[3]): NUMERIC[0];
 BEGIN
  IF Period_1 <= Period_2 THEN
   RETURN s_Less;
  ELSE
   RETURN s_More;
  END;
 END {GetPeriodSign};

 PRIVATE PROCEDURE CompareTimes(DTS_RWS, DTS: TIMESTAMP; CompareKind, Reason: NUMERIC[0]);
  VAR
   Sign : NUMERIC[0];
   Value: FLOAT;
 BEGIN
  IF (CompareKind = ck_Plan) | HasOutPost() THEN
   IF (~!DTS_RWS | (CompareKind = ck_Plan)) & ~!DTS THEN
    GetSign(DTS_RWS, DTS, Sign, Value);
    MakePart("R", CompareKind, Reason,  Sign, Value);
   END;
  END;
 END {CompareTimes};

 PRIVATE PROCEDURE ComparePeriods(Period_1, Period_2: NUMERIC[3]; CompareKind, Reason: NUMERIC[0]);
  CONST
   Delta = 10 / 60;
  VAR
   Value : FLOAT;
 BEGIN
  IF (CompareKind = ck_Plan) | HasOutPost() THEN
   Value:=Math.Abs(Period_1 - Period_2) * 24;
   IF Value >= Delta THEN
    MakePart("R", CompareKind, Reason, GetPeriodSign(Period_1, Period_2), Value);
   ELSE
    MakePart("R", CompareKind, Reason, s_Normal,                          Value);
   END;
  END;
 END {ComparePeriods};

 PRIVATE PROCEDURE PrintRep();
 BEGIN
  SELECT(TmRWS, RWayS);
  WHILE OCCURE(TmRWS) DO
   NARROWSEL(TmRWS, RWayS);
   PROMPT(" " + TmRWS.RWayS);
   CONFORM(TmRWS, RWayS);
   CONFORM(RWayS, Staff);
   CONFORM(Staff, Man);
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   CONFORM(CarLog, Mark);
   WHILE OCCURE(TmRWS) DO
    IF ~!TmRWS.BT_SEJ | ~L_BegRWS.CarIsUnderControlOfPrevRWayS() THEN
     CompareTimes(TmRWS.BT_RWS, TmRWS.BT_SEJ, ck_Plan, r_Departure);
     CompareTimes(TmRWS.BT_RWS, TmRWS.BT_Jrn, ck_Fact, r_Departure);
    END;
    IF ~!TmRWS.ET_SEJ | ~L_BegRWS.CarIsUnderControlOfNextRWayS() THEN
     CompareTimes(TmRWS.ET_RWS, TmRWS.ET_SEJ, ck_Plan, r_Return);
     CompareTimes(TmRWS.ET_RWS, TmRWS.ET_Jrn, ck_Fact, r_Return);
    END;

    IF ~!TmRWS.BT_RWS & ~!TmRWS.ET_RWS THEN
     IF ~!TmRWS.BT_SEJ & ~!TmRWS.ET_SEJ THEN
      ComparePeriods(TmRWS.ET_RWS - TmRWS.BT_RWS, TmRWS.ET_SEJ - TmRWS.BT_SEJ, ck_Plan, r_Work);
     END;
     IF ~!TmRWS.BT_Jrn & ~!TmRWS.ET_Jrn THEN
      ComparePeriods(TmRWS.ET_RWS - TmRWS.BT_RWS, TmRWS.ET_Jrn - TmRWS.BT_Jrn, ck_Fact, r_Work);
     END;
    END;
    NEXT(TmRWS);
   END; (* WHILE OCCURE(TmRWS) ... *)
   NEXTINEXTENDEDSEL(TmRWS, RWayS);
  END; (* WHILE OCCURE(TmRWS) ... *)
  L_AFM.AF_PurgeTemp("TmRWS");
 END {PrintRep};

 PRIVATE PROCEDURE MakeExcel();
  CONST
   RepName = "BRW01";
  VAR
   StopInPark: LIKE(Stop.Stop);
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.Assert(L_Way.E_BegRWSLev(Memo.ud_ut()) # L_Way.brwsl_NoBeg,
                   " 㯥 ⮫쪮  ⠭ ⥬|" +
                   "'믨᪠ ⥢ 㬥樨'");
  StopInPark:=L_Way.E_GetStopInPark();
  L_General.Assert(~!StopInPark, " ।  ⠭ '⮪'");

  L_bp.Begin(RepName, " 륧/⮢", L_bp.t_Basis, L_General.tc_inIntvl);
  MakeIndex(StopInPark);
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeHeader("R");
  PrintRep();
  FIO.Close(R);
  L_bp.End();
 END {MakeExcel};

END.
