(*
%Copyright   (c) Polak Computer System
%Author      GINA
%Purpose     ஢ઠ ࠧ浪 ⥢ ⮢
%Type        control
%Specific    AP
%Modified    09.06.2014 11:36:45 POLAK\GAV
*)

 MODULE BRWSTst [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Car, L_DatTim, L_General, L_Str, L_Env, E_Way, L_OwnData, L_EC,
        L_Way, Memo, L_MDoc, L_BegRWS, DBD, L_XDoc, L_two, L_Rpr;

 TYPE
  tErr = SCAL[4];

 CONST
  ErrNum = 13;
  RepName = "BRWEr";

 VAR
  IsError: SCAL[2];
  Err    : tErr[ErrNum];

(*
$P {Head:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_cd(), L, "D.N.y"
@
################################################################# ########## #####
=#####============================================================================
|                        訡  ࠧ浪  ##########                       |
|--------------------------------------------------------------------------------|
|                                                                         |
|--------------------------------------------------------------------------------|
|    0    | 䫨 ᬥ    祭 ६ ࠡ                 |
|    1    | ⥫ ࠧ殮                                  |
|    2    |  室 ࠧ殮                          |
|    3    | 室   ࠧ殮  ஬                           |
|    4    | 襭   ९                               |
|    5    | 室   ࠧ殮                                         |
|    6    |    ࠧ殮                                           |
|    7    | ⥫     ࠡ  室                          |
|    8    | 室                                            |
|    9    |                                                                      |
|    A    |  ࠧ殮 :  ᭮  ⥫쭮               |
|    B    | . ᮭ ࠧ殮   祭  ६            |
|    C    |  室 ࠧ殮  ஬                            |
|    D    | 室   ࠧ殮                            |
|    E    | 筮 ६   ᬥ ⥫                    |
|    F    | ⥫   室                                         |
|=========|======================================================================|
|室    | (࠭ᯮ.।⢮)|⥫                | | | | | | | | | | | |
|---------|-----------------------|------------------------|-|-|-|-|-|-|-|-|-|-|-|
}

$P {SubHead:
@
|--------------------------------------------------------------------------------|
|            ॢ,  易  ⥢묨 ⠬          |
|--------------------------------------------------------------------------------|
|  |      |                       |稪                      |
|-------|----------|------------------------------|------------------------------|
}

$P {LineCWorder:
CWOrder.CWOrder, L, ""
CWOrder.Date, L, "D.N.y"
CWOrder.Contract, L, ""
Contract.Name, L, ""
Contract.Firm, L, ""
Firm.Name, L, ""
@
|#######|##########|####### ######################|#### #########################|
}

$P {Line:
RWayS.Exit, L, ""
?, L, ""
Mark.Name, L, ""
CarLog.StateNbr, L, ""
RWayS.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Err[00], R, " |0"
Err[01], R, " |1"
Err[02], R, " |2"
Err[03], R, " |3|C|D"
Err[04], R, " |4"
Err[07], R, " |7"
Err[08], R, " |8"
Err[09], R, " |9|B"
Err[10], R, " |A"
Err[11], R, " |E"
Err[12], R, " |F"
@
|#########|#### ####### ##########|##### ##################|#|#|#|#|#|#|#|#|#|#|#|
}

$P {Dlm_Line:
@
|---------|-----------------------|------------------------|-|-|-|-|-|-|-|-|-|-|-|
}

$P {LineExit:
StExit.Exit, L, ""
Err[5], R, " |5"
@
|#########|                       |                        | | | | | |#| | | | | |
}

$P {LineCar:
Car.BoxNbr, L, ""
Mark.Name, L, ""
CarLog.StateNbr, L, ""
Err[6], R, " |6"
@
|         |#### ####### ##########|                        | | | | | | |#| | | | |
}

$P {End:
@
=(c) Polak========================================================================
}
*)

 PRIVATE PROCEDURE ErrorExpValue(Cond: SCAL[2]; No: SCAL[ErrNum]; ErrValue: tErr);
 BEGIN
  IF Cond THEN
   Err[No]:=ErrValue;
   IsError:=1;
  END;
 END {ErrorExpValue};

 PRIVATE PROCEDURE Error(Cond: SCAL[2]; No: SCAL[ErrNum]);
 BEGIN
  ErrorExpValue(Cond, No, 1);
 END {Error};

 PRIVATE PROCEDURE _Timeint(B1, E1, B2, E2: TIME): SCAL[2];
 BEGIN
  IF ~!B1 & ~!B2 & ~!E1 & ~!E2 THEN
   RETURN TIMEINT(B1, E1, B2, E2) > 0;
  END;
  RETURN 0;
 END {_Timeint};

 PRIVATE PROCEDURE DefaultConforms(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE);
 BEGIN
  CONFORM(RWayS, Staff);
  CONFORM(Staff, Man);
  L_Car.StandOnCarLog(_BoxNbr, _Date);
  CONFORM(CarLog, Mark);
 END {DefaultConforms};

 PRIVATE PROCEDURE CarHasMCFix(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE): SCAL[2];
 BEGIN
  SELECT(MCFix, BoxNbr, , _BoxNbr);
  WHILE OCCURE(MCFix) DO
   IF L_DatTim.IsActive(_Date, MCFix.Begin, MCFix.Till) THEN
    RETURN 1;
   END;
   NEXT(MCFix);
  END; (* WHILE OCCURE(MCFix) ... *)
  RETURN 0;
 END {CarHasMCFix};

 PRIVATE PROCEDURE Tst1(OnDate: DATE);
  VAR
   _Value   : LIKE(StaffPro.Value);
   _StartT,
   _StopT   : TIME;
   _Change  : LIKE(RWayS.Change);
   Count    : NUMERIC[0];
   Dummy    : STRING[];
   Default  : L_BegRWS.tCrewFitnessForExit;
   Reason,
   ReasonStr: STRING[];
   Local    : PROC;
 BEGIN
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   PROMPT(L_DatTim.TimeStr(RWayS.StartTim) + " " + RWayS.TSN);
  EXCEPT
  END;
 
  IF L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
   _Change:=RWayS.Change;
   _StartT:=L_BegRWS.GetRWaySExitTime(1);
   _StopT :=L_BegRWS.GetRWaySEnterTime(1);
   SAVE   (RWayS);
   CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr, OnDate);
   NEXT(RWayS);
(*
    :(     ) 
                         (   )  (   )
*)
   Error(OCCURE(RWayS) & ((_Change # 1) | (RWayS.Change # 2)),        00);
   IF OCCURE(RWayS) THEN
    Error(_Timeint(_StartT, _StopT, L_BegRWS.GetRWaySExitTime(1), L_BegRWS.GetRWaySEnterTime(1)),
                                                                      00);
    Error(NEXT(RWayS),                                                00);
   END;

   RESTORE(RWayS);

   Error(SELECT(WayLCar, BoxNbr, RWayS.BoxNbr, OnDate),               10);
   IF Err[10] THEN
    SAVE(RWayS);
    DefaultConforms(WayLCar.BoxNbr, WayLCar.RWayDate);
    CONFORM(WayLCar, RWayS);
    MAKEPART(R, Line, WayLCar.BoxNbr);
    RESTORE(RWayS);
   END;
  END; (* IF L_Env.RealBoxNbr(RWayS.BoxNbr)... *)

  IF L_Env.RealTSN(RWayS.TSN) THEN
   SAVE   (RWayS);
   CHANGESEL(RWayS, TSN, , RWayS.TSN, OnDate);
   Error(NEXT(RWayS),                                                 01);
   RESTORE(RWayS);

   IF SEARCH(Mtwo, Who, L_DatTim.Per(RWayS.Date), L_two.who_Driver, RWayS.TSN) & ~!Mtwo.Signed THEN
    IF Mtwo.pWhat[L_two.Date2Idx(RWayS.Date)] = L_BegRWS.dt_NotDefined THEN
     Error(1, 12);
    END;
   END;
   IF L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
    Error(CarHasMCFix(RWayS.BoxNbr, RWayS.Date) &
          ~(L_Car.StandOnFirstMCFix    (RWayS.TSN, RWayS.Date) & (MCFix.BoxNbr = RWayS.BoxNbr) |
            L_Car.StandOnSecondaryMCFix(RWayS.TSN, RWayS.Date) & (MCFix.BoxNbr = RWayS.BoxNbr)), 04);

    L_BegRWS.cffe_CheckTimeFromLastChange(L_DatTim.GetVARIANTDATE(RWayS.Date, L_BegRWS.GetRWaySExitTime(0), 0), Default, ReasonStr);
    Local:=PROCREF(E_Way.cffe_Correct);
    IF ~!Local THEN
     Reason:=L_BegRWS.cffeR_BadRestTime;
     Local(RWayS.Date, RWayS.TSN, RWayS.BoxNbr, RWayS.Exit, Default, Reason, ReasonStr, L_XDoc.action_begDst);
    END;
    Error(Default # L_BegRWS.cffe_Yes,                                11);
   ELSE
    Error(SELECT(MCFix, BoxNbr),                                      04);
   END;

   Error(~L_BegRWS.DriverIsAuthorizedToExit(RWayS.Date, RWayS.TSN,
                                                         RWayS.Exit), 07);

  END; (* IF L_Env.RealTSN(RWayS.TSN)... *)

  Error(L_Way._CheckExitOnDate(RWayS.Exit,
                               RWayS.Date) # L_Way.exvld_Active,      08);

  CONFORM(RWayS, StExit);
  IF SELECT(WayLMen, RWayS, RWayS.RWayS, L_Way.wlmwho_Guard) THEN
   CONFORM(StExit, ExitClss);
   ErrorExpValue((ExitClss.BegType # L_Way.ecbt_Line) &
                 (ExitClss.BegType # L_Way.ecbt_Reserv),              03, 2);
   ErrorExpValue(StExit.GuNeed = L_Way.egn_Prohibited,                03, 3);
  ELSE
   Error(StExit.GuNeed = L_Way.egn_Required,                          03);
  END;

  IF StExit.Strict = L_Way.ExitStrict_Reg THEN
   SAVE(RWayS);
   CHANGESEL(RWayS, sDate, , RWayS.Status, RWayS.Date, RWayS.StartTim);
   FIRST(RWayS); Count:=0;
   WHILE OCCURE(RWayS) & (Count <= 1) DO
    TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
     IF RWayS.Exit = StExit.Exit THEN
      INC(Count);
     END;
    EXCEPT
    END;
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
   RESTORE(RWayS);
   Error(Count > 1,                                                   02);
  END; (* IF StExit.Strict... *)

  CONFORM(RWayS, WayLMen);
  WHILE OCCURE(WayLMen) DO
   IF L_BegRWS.WLMHasOverlap(Dummy) THEN
    ErrorExpValue(1,                                                  09, 2);
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)

  IF IsError THEN
   DefaultConforms(RWayS.BoxNbr, RWayS.Date);
   MAKEPART(R, Line, RWayS.BoxNbr);
  END;
 END {Tst1};

 PRIVATE PROCEDURE Tst2(OnDate: DATE);
 BEGIN
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   Error(~SELECT(RWayS, Exit, StExit.Exit, OnDate) |
         (~L_Way.E_IsGuardIdleExit(OnDate, StExit.Exit) & (~L_Env.RealBoxNbr(RWayS.BoxNbr) | ~L_Env.RealTSN(RWayS.TSN))),
                                                                      05);
  EXCEPT
  END;
  IF IsError THEN
   MAKEPART(R, LineExit);
  END;
 END {Tst2};

 PRIVATE PROCEDURE Tst3(OnDate: DATE);
 BEGIN
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   IF ~SELECT(RWayS, BoxNbr, Car.BoxNbr, OnDate) &
      ~SELECT(WayLCar, BoxNbr, Car.BoxNbr, OnDate) &
      ~L_Rpr.HasOpenRprS(Car.BoxNbr, OnDate + 1, 00:00) THEN
    SETSEL(CarEvn, BoxNbr, Car.BoxNbr);
    LAST(CarEvn);
    WHILE OCCURE(CarEvn) & ~L_DatTim.IsActive_Inc(OnDate, CarEvn.StartD, CarEvn.StopD) DO
     PREV(CarEvn);
    END; (* WHILE OCCURE(CarEvn) ... *)
    Error(~OCCURE(CarEvn), 06);
   END;
  EXCEPT
  END;
  IF IsError THEN
   L_Car.StandOnCarLog(Car.BoxNbr, OnDate);
   CONFORM(CarLog, Mark);
   MAKEPART(R, LineCar);
  END;
 END {Tst3};

 PRIVATE PROCEDURE TstOneRWayS(OnDate: DATE; Proc: STRING[]);
 BEGIN
  TRY
   SETZERO(Err, IsError);
   ^Proc(OnDate);
  EXCEPT
  ON Exc: Exc_Raise DO
   DefaultConforms(RWayS.BoxNbr, RWayS.Date);
   MAKEPART(R, Line, RWayS.BoxNbr);
  END; (* TRY ... *)
 END {TstOneRWayS};

 PRIVATE PROCEDURE E_NeedExitClssForBeg(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.NeedExitClssForBeg), 1);
 END {E_NeedExitClssForBeg};

 PRIVATE PROCEDURE BegRWS_Tst(OnDate: DATE);
 BEGIN
  SELECT(RWayS, Date, , OnDate);
  WHILE OCCURE(RWayS) DO
   TstOneRWayS(OnDate, "Tst1");
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 
  MAKEPART(R, Dlm_Line);
 
  SEARCH(Calendar, Date, , OnDate);
  SELECT(StExit, Exit);
  WHILE OCCURE(StExit) DO
   PROMPT("室 " + StExit.Exit);
   CONFORM(StExit, ExitClss);
   IF (((StExit.Strict = L_Way.ExitStrict_Reg) & ~StExit.Suppl) |
       L_Way.E_IsGuardIdleExit(OnDate, StExit.Exit)) &
       (L_Way._CheckExitOnDate(StExit.Exit, OnDate) = L_Way.exvld_Active) THEN
    SAVE(StExit);
    IF E_NeedExitClssForBeg(OnDate) THEN
     TstOneRWayS(OnDate, "Tst2");
    END;
    RESTORE(StExit);
   END;
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit) ... *)

  MAKEPART(R, Dlm_Line);
 
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT("ࠦ " + Car.BoxNbr);
   IF L_Car.CarIsInOperation(Car.BoxNbr, OnDate) &
      (CarLog.InBeg = L_Car.inBeg_Required) THEN
    TstOneRWayS(OnDate, "Tst3");
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)

  IF DBD.FileExist(CWOrder) THEN
   MAKEPART(R, SubHead);
   SELECT(CWOrder, Date);
   SRCINSEL(CWOrder, GE, , OnDate - 30);
   WHILE OCCURE(CWOrder) & (CWOrder.Date <= OnDate) DO
    PROMPT("   " + CWOrder.CWOrder);
    IF !CWOrder.RWayS & (CWOrder.Status # L_MDoc.st_Canceled) THEN
     CONFORM(CWOrder, Contract);
     CONFORM(Contract, Firm);
     MAKEPART(R, LineCWorder);
    END;
    NEXT(CWOrder);
   END; (* WHILE OCCURE(CWorder) ... *)
  END;
 END {BegRWS_Tst};

 PUBLIC PROCEDURE BRWSTst();
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Head);
  BegRWS_Tst(Memo.ud_cd());
  MAKEPART(R, End);
  CLOSEREP(R);
 END {BRWSTst};

END.
