(*
%Copyright   (c) Polak Computer System
%Author      11.10.1999 15:50:56 BOR
%Purpose     ஫   CarE
%Type        control
%Specific    AP
%Modified    13.08.2014 19:16:45 LDA
%Environment
*)

 MODULE Car [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, Str, L_Env, L_Car, L_CUC, L_AR, L_AcsPnt, L_StdFrm, L_WDO, L_Rpr, P_Car, L_Str;

 PUBLIC PROCEDURE Close();
  VAR
   _Date   : LIKE(CarLog.Date);
   _EndDate: LIKE(Car.EndDate);
 BEGIN
  L_General.Assert(SELECT(CarLog, BoxNbr, Car.BoxNbr), "     ப  ᠭ");
  L_General.CallUs(Car.BegDate = CarLog.Date);
  LAST(CarLog);
  IF CarLog.Status = L_Car.carst_Retired THEN
   _EndDate:=CarLog.Date;
  ELSE
   SETEMPTY(_EndDate);
  END;
  L_General.CallUs(Car.EndDate = _EndDate);
  SETEMPTY(_Date);
  REPEAT
   IF (CarLog.Status = L_Car.carst_Retired) & !_Date THEN
    CarLog.DateE:=CarLog.Date-1;
   ELSE
    CarLog.DateE:=_Date;
   END;
   REPLACE(CarLog);
   _Date:=CarLog.Date-1;
  UNTIL ~PREV(CarLog);
(*!?!*)
  LAST(CarLog);
  Car.Mark    :=CarLog.Mark;
  Car.StateNbr:=CarLog.StateNbr;
  Car.Name    :=CarLog.StateNbr;
  Car.Column  :=CarLog.Column;
  Car.Purpose :=CarLog.Purpose;
  REPLACE(Car);
(*!?!*)
 END {Close};

 PRIVATE PROCEDURE Check();
  VAR
   curMath    : LIKE(Math.Math);
   curVehPasp : LIKE(VehPasp.VehPasp);
   HasExchange: SCAL[2];
 BEGIN
  HasExchange:=0;
  IF ACCESS(Car) & SELECT(CarLog, BoxNbr, Car.BoxNbr) THEN
   SETEMPTY(curMath, curVehPasp);
   WHILE OCCURE(CarLog) DO
    IF ~!CarLog.Math THEN
     IF ~!curMath & (curMath # CarLog.Math) THEN
      IF !curVehPasp | (CarLog.VehPasp = curVehPasp) THEN
       HasExchange:=1;
      END;
     END;
     curMath   :=CarLog.Math;
     curVehPasp:=CarLog.VehPasp;
    END;
    NEXT(CarLog);
   END; (* WHILE OCCURE(CarLog) ... *)
  END;
  RTI.Get().CurWindow.Zones(1).PermanentFilter:="";
  IF HasExchange THEN
   TRY
    L_AcsPnt.PassAccessPoint(0000029);
   EXCEPT
   ON Exc: Exc_Raise DO
    RTI.Get().CurWindow.Zones(1).PermanentFilter:="CarLog.Math = " + curMath;
   END;
  END; (* IF HasExchange *)
 END {Check};

 PRIVATE PROCEDURE Car_OnAfterEdIns();
 BEGIN
  Close();
  SAVE(Car);
  IF SELECT(Car, StateNbr, Car.StateNbr) & NEXT(Car) THEN
   L_StdFrm.Choice("    ⠪ .஬ ("+Car.StateNbr+")");
  END;
  RESTORE(Car);

  SETSEL(CarLog, BoxNbr, Car.BoxNbr);
  LAST(CarLog);

  L_Rpr.SetCUCopySerialByAnyCar(Car.CUCopy, CarLog.StateNbr, CarLog.Mark);

  SEARCH(CUCopy, CUCopy, , Car.CUCopy);
  CUCopy.Begin  := Car.BegDate;
  IF ~!Car.EndDate THEN
   CUCopy.Till:=Car.EndDate - 1;
  ELSE
   SETEMPTY(CUCopy.Till);
  END;
  REPLACE(CUCopy);

  SETSEL(CarLog, BoxNbr, Car.BoxNbr);
  FOR_EACH CarLog DO
   L_DBD.CheckValidity("CarLog");
  END; (* FOR_EACH CarLog *)
 END {Car_OnAfterEdIns};

 PRIVATE PROCEDURE Car_OnAfterInsert();
 BEGIN
  DEFAULT(CUCopy);
  CUCopy.Origin := L_CUC.o_Car;
  INSERT(CUCopy);

  Car.CUCopy:=CUCopy.CUCopy;
  REPLACE(Car);

  Car_OnAfterEdIns();
 END {Car_OnAfterInsert};

 PRIVATE PROCEDURE Car_OnAfterEdit();
 BEGIN
  Car_OnAfterEdIns();
 END {Car_OnAfterEdit};

 PRIVATE PROCEDURE Car_OnBeforeEdIns();
 BEGIN
  L_AR.GrantRightsForInteractiveModification();
 END {Car_OnBeforeEdIns};

 PRIVATE PROCEDURE Car_OnBeforeEdit();
 BEGIN
  Car_OnBeforeEdIns();
 END {Car_OnBeforeEdit};

 PRIVATE PROCEDURE Car_OnBeforeInsert();
 BEGIN
  Car_OnBeforeEdIns();
 END {Car_OnBeforeInsert};

 PRIVATE PROCEDURE Car_BoxNbr_OnSuccessfulChange();
 BEGIN
  IF ~!Car.CUCopy THEN
   SELECT(RprS, CUCopy, , Car.CUCopy);
   WHILE OCCURE(RprS) DO
    PROMPT("     " + RprS.RprS);
    RprS.RprObjId:=Car.BoxNbr;
    REPLACE(RprS);
    NEXT(RprS);
   END; (* WHILE OCCURE(RprS) ... *)
  END;
 END {Car_BoxNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE CarE_0_OnReposition();
  VAR
   F: FORM_FIELDS;
 BEGIN
  F:=RTI.Get().CurWindow.Zones(0).Fields;
  F("Car.BoxNbr"  ).Modifiable:=1;
  F("Car.StateNbr").Modifiable:=0;
  F("Car.Column"  ).Modifiable:=0;
  F("Car.Mark"    ).Modifiable:=0;
  F("Car.BegDate" ).Modifiable:=0;
  F("Car.EndDate" ).Modifiable:=0;
  Check();
 END {CarE_0_OnReposition};

 PRIVATE PROCEDURE Car_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "CarE");
 END {Car_OnInitializeWindow};

 PRIVATE PROCEDURE CarE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["Car.BoxNbr"]);
  L_WDO.iSubwindow   (1, "CarLog");
  L_WDO.iField       (1, "CarLog.Purpose").Format:=L_Car.purp_Pool;
  L_WDO.iField       (1, "CarLog.InBeg"  ).Format:=L_Car.inBeg_Pool_Short;
  L_WDO.iField       (1, "CarLog.Status" ).Format:=L_Car.carst_Pool;
 END {CarE_OnInitializeWindow};

 PRIVATE PROCEDURE Car_OnBeforeDelete();
 BEGIN
  IF SELECT(rtCar, BoxNbr, Car.BoxNbr) THEN
   REMSEL(rtCar);
  END;
 END {Car_OnBeforeDelete};

 PUBLIC PROCEDURE SearchCarByFuelCard();
  VAR
   i          : NUMERIC[0];
   trgDate    : DATE;
   trgBoxNbr  : LIKE(Car.BoxNbr);
   Msg,
   BoxNbrList,
   trgFuelCard: STRING[];
 BEGIN
  SETEMPTY(trgFuelCard);
  STDFORM(L_StdFrm.sf_Choice("| ⮯  %###################%",
          "%LI|"),
          "    ⮯ ",
          INFORM,
          ,
          trgFuelCard);

  trgDate:=SYSDATE();
  SETEMPTY(BoxNbrList);
  IF SELECT(CarPro, Property, P_Car.P_FuelCard, trgFuelCard) THEN
   LOOP
    IF ~OCCURE(CarPro) THEN
     EXIT;
    END;
    IF L_DatTim.IsActive_Inc(trgDate, CarPro.Date, CarPro.EndDate) THEN
     BoxNbrList:=BoxNbrList + CarPro.BoxNbr + "|";
    END;
    NEXT(CarPro);
   END; (* LOOP *)
  END;
  IF !BoxNbrList THEN
   L_StdFrm.RedInform("  " + trgFuelCard + "  " + L_DatTim.DateStr(trgDate) + "  ᮯ⠢   ");
  ELSE
   SETEMPTY(Msg);
   i:=0;
   LOOP
    trgBoxNbr:=L_Str.PoolItem(BoxNbrList, i);
    IF !trgBoxNbr THEN
     EXIT;
    END;
    SEARCH(Car, BoxNbr, , trgBoxNbr);
    Msg:=Msg + Car.BoxNbr + ", ᭮ " + Str.Align(Car.StateNbr, 10, LEFT) + "|";
    INC(i);
   END; (* LOOP *)

   IF i = 1 THEN
    L_StdFrm.Inform("  " + trgFuelCard + "  " + L_DatTim.DateStr(trgDate) + "|ᮯ⠢ ||" + Msg);
   ELSE
    L_StdFrm.RedInform("  " + trgFuelCard + "  " + L_DatTim.DateStr(trgDate) + "|ᮯ⠢ ᪮쪨 :||" + Msg);
   END;
  END;
 END {SearchCarByFuelCard};

BEGIN
 L_Events.ExecuteHandler();
END.
