(*
%Copyright   (c) Polak Computer System
%Author      29.07.2002 19:33:36 LDA
%Purpose      ઠ  ਮ
%Type        report
%Specific    SYS
%Modified    20.12.2013 13:34:06 POLAK\MLB
%Environment
*)

 MODULE Car01 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Car, L_DatTim, L_Basis, L_Str, Str, L_Env, FIO, P_Firm, L_Way, P_Mark,
        Math, L_StdFrm, L_bp, L_APtm;

 PRIVATE VAR
  wMF  : SCAL[2];
  _EPer,
  _BPer: DATE;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  IF L_APtm.IsOG() THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ஡");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "஡  ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "  宧-");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ᪠");
  L_Basis.wb_WrInQM(F, " ᪠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⨥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ஡ 30");
  L_Basis.wb_WrInQM(F, " ஡ 75");
  L_Basis.wb_WrInQM(F, " ஡ 100");
  L_Basis.wb_WrInQM(F, "  ஡");
  L_Basis.wb_WrInQM(F, " ਪ");
  L_Basis.wb_WrInQM(F, " ਪ");
  L_Basis.wb_WrInQM(F, "᭮ ਪ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠢ ᮡ⢥");
  L_Basis.wb_WrInQM(F, "⢥");
  L_Basis.wb_WrInQM(F, "⢥");
  L_Basis.wb_WrInQM(F, "㯯 ⨬");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " 宧⢥  砫 ਮ");
  L_Basis.wb_WrInQM(F, " 宧⢥   ਮ");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE GetIntvl_asStr(Run   : NUMERIC[2];
                                  Step,
                                  MaxRun: NUMERIC[0]): STRING[];
  CONST
   MaxLength = 3;
  VAR
   BIntvl: NUMERIC[0];
 BEGIN
  IF Run > MaxRun THEN
   RETURN " " + L_Str.IntStr(MaxRun);
  ELSE
   BIntvl:=(Run DIV Step) * Step;
   RETURN L_Str.Repeat("0", MaxLength - Str.Length(L_Str.IntStr(BIntvl / 1000))) +
          L_Str.IntStr(BIntvl / 1000) + "-" +
          L_Str.Repeat("0", MaxLength - Str.Length(L_Str.IntStr((BIntvl + Step)/ 1000))) +
          L_Str.IntStr((BIntvl + Step)/ 1000);
  END;
 END {GetIntvl_asStr};

 PRIVATE PROCEDURE CountDays_wRun(BDate, EDate: DATE): NUMERIC[0];
  VAR
   Amount: NUMERIC[0];
 BEGIN
  Amount:=0;
  IF L_DatTim.DATEINT(BDate, EDate, CarLog.Date, CarLog.DateE) > 0 THEN
   BDate:=Math.Max(BDate, CarLog.Date);
   EDate:=Math.Min(EDate, CarLog.DateE);
   SELECT(CarRun, BoxNbr, , Car.BoxNbr);
   SRCINSEL(CarRun, GE, , BDate);
   WHILE OCCURE(CarRun) & (CarRun.Date <= EDate) DO
    IF CarRun.Run # 0 THEN
     INC(Amount);
    END;
    NEXT(CarRun);
   END; (* WHILE OCCURE(CarRun) ... *)
  END;
  RETURN Amount;
 END {CountDays_wRun};

 PRIVATE PROCEDURE GetInFirm(D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(CarLog);
  HISTCONF(D, Car, CarLog);
  Result:=OCCURE(CarLog) & (CarLog.Status = L_Car.carst_InOperat);
  RESTORE(CarLog);
  RETURN Result;
 END {GetInFirm};

 PRIVATE PROCEDURE MakePart(F                : STRING[];
                            TotalRun,
                            TotalRun_byPeriod: NUMERIC[2];
                            BDate, EDate     : DATE);
  VAR
   Days       : NUMERIC[0];
   trgProdDate: DATE;
 BEGIN
  CONFORM(CarLog, Column);
  CONFORM(CarLog, Mark);
  IF wMF THEN
   CONFORM(Column, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Car.BoxNbr);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, CarLog.Column);
  L_Basis.wb_WrStr(F, Column.Name);
  IF L_APtm.IsOG() THEN
   CONFORM(Car, am);
   L_Basis.wb_WrScl(F, am.am);
   L_Basis.wb_WrStr(F, am.Name);
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Car.purp_Pool, CarLog.Purpose));
  L_Basis.wb_WrNum(F, TotalRun, 2);
  trgProdDate:=L_Car.GetCarProdDate(Car.BoxNbr, _EPer);
  L_Basis.wb_WrNum(F, L_DatTim.YearsInIntvl(trgProdDate, _EPer), 2);
  L_Basis.wb_WrNum(F, TotalRun_byPeriod, 2);
  L_Basis.wb_WrNum(F, L_DatTim.CompleteYearsInIntvl(trgProdDate, _EPer), 0);
  Days:=0;
  IF CarLog.Status = L_Car.carst_InOperat THEN
   Days:=L_DatTim.DATEINT(BDate, EDate, CarLog.Date, CarLog.DateE);
  END;
  L_Basis.wb_WrNum(F, Days, 0);
  L_Basis.wb_WrNum(F, Days / (_EPer - _BPer + 1), 3);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  L_Basis.wb_WrDat(F, trgProdDate);
  L_Basis.wb_WrStr(F, FLDTOSTR(trgProdDate, "y"));
  L_Basis.wb_WrDat(F, Car.BegDate);
  L_Basis.wb_WrDat(F, Car.EndDate);
  L_Basis.wb_WrStr(F, FLDTOSTR(BDate, "y.N"));

  IF ~!CarLog.TKind THEN
   CONFORM(CarLog, TKind);
   L_Basis.wb_WrScl(F, TKind.TKind);
   L_Basis.wb_WrStr(F, TKind.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;

  L_Basis.wb_WrStr(F, GetIntvl_asStr(TotalRun, 30000,  690000));
  L_Basis.wb_WrStr(F, GetIntvl_asStr(TotalRun, 75000,  750000));
  L_Basis.wb_WrStr(F, GetIntvl_asStr(TotalRun, 100000, 700000));
  L_Basis.wb_WrNum(F, CountDays_wRun(BDate, EDate), 0);
  L_Basis.wb_WrStr(F, CarLog.Order);
  L_Basis.wb_WrDat(F, CarLog.OrdDate);
  L_Basis.wb_WrStr(F, CarLog.OrdCsAtr);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(" ᯫ樨| ᯫ樨|⨥", CarLog.Status));

  IF ~!CarLog.VehPasp THEN
   CONFORM(CarLog, VehPasp);
   L_Basis.wb_WrStr(F, L_Car.VehPaspNbr_AsStr());
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Car.OwnS_VehPPool, VehPasp.OwnerShp));
   CONFORM(VehPasp, Firm);
   L_Basis.wb_WrScl(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
  ELSE
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrStr(F, L_Way.GetMarkPasVolSign(EDate, Mark.Mark));
  L_Basis.wb_WrNum(F, P_Mark.GetP_PasVol(Mark.Mark, EDate), 0);
  L_Basis.wb_WrNum(F, P_Mark.GetP_PVLim(Mark.Mark, EDate), 0);
  L_Basis.wb_WrNum(F, GetInFirm(BDate), 0);
  L_Basis.wb_WrNum(F, GetInFirm(EDate), 0);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE CheckWMIntvl(IntvlB, IntvlE: DATE): SCAL[2];
 BEGIN
  RETURN (L_DatTim.DAY(IntvlB) = 1) & (L_DatTim.DAY(IntvlE+1) = 1);
 END {CheckWMIntvl};

 PRIVATE PROCEDURE CheckDoneRWayS();
 BEGIN
  IF SELECT(RWayS, Done, 0) & SRCINSEL(RWayS, GE, _BPer) & (RWayS.Date<=_EPer) THEN
   L_StdFrm.Warning(" ࠡ⠭ , १ 㤥 ⮢|ਬ,  "+RWayS.RWayS);
  END;
 END {CheckDoneRWayS};

 PUBLIC PROCEDURE Car01();
  CONST
   bpId = "Car01";
  VAR
   _GlobalRun,
   GlobalRun_OnBegPeriod,
   GlobalRun_OnEndPeriod : NUMERIC[2];
   EndPeriod,
   BegPeriod,
   ThisCarEPer           : DATE;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, " ઠ", L_bp.t_Basis, L_General.tc_inIntvl);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_General.SetIntvlByIntvl(_BPer, _EPer);
  FIO.Open(F, L_General.NameConnection(bpId), "rep", Create);
  MakeHeader("F");
  CheckDoneRWayS();
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(Car.BoxNbr);
   IF L_DatTim.IsStarted(_EPer, Car.BegDate) THEN
    GlobalRun_OnBegPeriod:=L_Car.GetGlobalRun(Car.BoxNbr, Math.Max(_BPer, Car.BegDate));
    GlobalRun_OnEndPeriod:=L_Car.GetGlobalRun(Car.BoxNbr, _EPer+1);
    IF ~L_Env.RealBoxNbr(Car.BoxNbr) &
       ((GlobalRun_OnBegPeriod # 0) | (GlobalRun_OnEndPeriod # 0)) THEN
     L_General.Error("㤠 ஡  䨪⨢ ࠦ "+Car.BoxNbr);
    END;
    IF L_Env.RealBoxNbr(Car.BoxNbr) &
       ((GlobalRun_OnEndPeriod # GlobalRun_OnBegPeriod) |
        L_DatTim.IsActiveInIntvl(_BPer, _EPer+1, Car.BegDate, Car.EndDate)) THEN
     IF CheckWMIntvl(_BPer, _EPer) THEN
      ThisCarEPer:=L_DatTim.MonthEnd(Math.Min(_EPer + 1, Car.EndDate) - 1);
      BegPeriod:=L_DatTim.MonthBeg(_BPer);
      EndPeriod:=L_DatTim.MonthEnd(BegPeriod);
      WHILE EndPeriod <= ThisCarEPer DO
       SELECT(CarLog, BoxNbr, , Car.BoxNbr);
       SRCINSEL(CarLog, LE, , EndPeriod);
       WHILE OCCURE(CarLog) & (CarLog.DateE>=BegPeriod) DO
        IF EndPeriod = ThisCarEPer THEN
         _GlobalRun:=GlobalRun_OnEndPeriod;
        ELSE
         _GlobalRun:=0;
        END;
        MakePart("F", _GlobalRun,
                 L_Car.GetGlobalRun(Car.BoxNbr, Math.Min(EndPeriod, CarLog.DateE)+1) - L_Car.GetGlobalRun(Car.BoxNbr, L_DatTim.MaxDATE(BegPeriod, CarLog.Date)),
                 BegPeriod, EndPeriod);
        PREV(CarLog);
       END; (* WHILE OCCURE(CarLog) ... *)
       BegPeriod:=L_DatTim.IncMonth(L_DatTim.MonthBeg(BegPeriod), 1);
       EndPeriod:=L_DatTim.MonthEnd(BegPeriod);
      END; (* WHILE EndPeriod...*)
     ELSE
      SELECT(CarLog, BoxNbr, , Car.BoxNbr);
      SRCINSEL(CarLog, LE, , _EPer);
      WHILE OCCURE(CarLog) & (CarLog.DateE>=_BPer) DO
       MakePart("F", GlobalRun_OnEndPeriod,
                L_Car.GetGlobalRun(Car.BoxNbr, Math.Min(_EPer, CarLog.DateE)+1) - L_Car.GetGlobalRun(Car.BoxNbr, L_DatTim.MaxDATE(_BPer, CarLog.Date)),
                _BPer, _EPer);
       PREV(CarLog);
      END; (* WHILE OCCURE(CarLog) ... *)
     END; (* IF CheckWMIntvl... *)
    END; (* IF L_Env.RealBoxNbr... *)
   END; (*IF L_DatTim.IsStarted(_EPer, Car.BegDate)...*)
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
  FIO.Close(F);
  L_bp.End();
 END {Car01};

END.
