(*
%Copyright   (c) Polak Computer System
%Author      16.04.1998 18:04:13 SAN
%Purpose     ஫ 䨪樨 CarEvn
%Type        control
%Specific    AP
%Modified    20.11.2013 14:19:23 POLAK\GAV
%Environment
*)

 MODULE CarEvn [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Car, L_Events, E_Way, L_Rpr, L_StdFrm, L_DBD,
        L_WDO, L_SysLog;

 PRIVATE PROCEDURE Check(Msg: STRING[100]; _StartD, _StopD: DATE);
 BEGIN
  IF OCCURE(CarEvn) & (L_DatTim.DATEINT(_StartD, _StopD, CarEvn.StartD, CarEvn.StopD)>0) THEN
   L_StdFrm.Choice(Msg);
  END;
 END {Check};

 PRIVATE PROCEDURE ChangeForecast();
 BEGIN
  IF CarEvn.Source = L_Car.src_FrCast THEN
   L_StdFrm.Choice("   ண?");
  ELSE
   L_General.Assert(CarEvn.Source=L_Car.src_Operator, " ᪠  ⮬᪨ ஢");
  END;
 END {ChangeForecast};

 PRIVATE PROCEDURE E_CarEvn_IsAllowedInteractiveModification(): SCAL[2];
  VAR
   local: PROC;
 BEGIN
  local:=PROCREF(E_Way.CarEvn_IsAllowedInteractiveModification);
  IF ~!local THEN
   RETURN local();
  ELSE
   RETURN 1;
  END;
 END {E_CarEvn_IsAllowedInteractiveModification};

 PRIVATE PROCEDURE CarEvn_OnAfterEditInsert();
  VAR
   _StartD, _StopD: DATE;
 BEGIN
  L_General.Assert(E_CarEvn_IsAllowedInteractiveModification(), "   稩   ");
  L_SysLog.SingleMark_Init("CarEvn");
  _StartD:=CarEvn.StartD;
  IF !CarEvn.StopD THEN
   L_StdFrm.Choice("⢨⥫쭮 ⭮,   ய⨥?");
  END;
  _StopD :=CarEvn.StopD;
  L_General.Assert(_StopD >= _StartD, " 砭    砫");
  IF CarEvn.StartD > SYSDATE() THEN
   L_StdFrm.Choice(" ண ய?");
   CarEvn.Source:=L_Car.src_FrCast;
  ELSIF CarEvn.Source = L_Car.src_FrCast THEN
   IF L_StdFrm.Alternative("  ᮡ⨥ 訬?") THEN
    CarEvn.Source:=L_Car.src_Operator;
    SETEMPTY(CarEvn.DocNbr);
   END;
  END;

  SETEMPTY(CarEvn.DocNbr);
  REPLACE(CarEvn);
  SAVE(CarEvn);
  CHANGESEL(CarEvn, BoxNbr, , CarEvn.BoxNbr);
  IF (L_Rpr.RprLev(CarEvn.StartD) = L_Rpr.rprl_Active) &
     L_Rpr.HasOpenRprS(CarEvn.BoxNbr, CarEvn.StartD, 23:59) THEN
   L_StdFrm.Choice("    ६ ");
  END;
  SAVE(CarEvn);
  PREV(CarEvn);
  Check("ᥪ  ।騬 ய⨥", _StartD, _StopD);
  RESTORE(CarEvn);
  NEXT(CarEvn);
  Check("ᥪ  ᫥騬 ய⨥", _StartD, _StopD);
  RESTORE(CarEvn);
  IF (L_WDO.OriginalName(GE_CURWIN()) = "REFrCast") & (CarEvn.Source = L_Car.src_Operator) THEN
   L_StdFrm.Inform("⨥ ⬥祭  襥, ⮬ 㡨ࠥ  ᯨ᪠ ண");
  END;
  L_SysLog.SingleMark_Done("CarEvn");
  L_DBD.CheckValidity("CarEvn");
 END {CarEvn_OnAfterEditInsert};

 PRIVATE PROCEDURE CheckCarServiceLev();
 BEGIN
  L_General.Assert(L_Car.E_CarServiceLev(SYSDATE()) # L_Car.csl_None, " ⠭ ⥬|" +
                                                                      "' ᯫ樨  ⠢'");
 END {CheckCarServiceLev};

 PRIVATE PROCEDURE CarEvn_OnBeforeInsert();
 BEGIN
  CheckCarServiceLev();
 END {CarEvn_OnBeforeInsert};

 PRIVATE PROCEDURE CarEvn_OnBeforeEdit();
 BEGIN
  L_General.Assert(E_CarEvn_IsAllowedInteractiveModification(), "   稩   ");
  ChangeForecast();
  IF (CarEvn.Source = L_Car.src_FrCast) & (CarEvn.StartD <= SYSDATE()) THEN
   FIXALTERING();
  END;
 END {CarEvn_OnBeforeEdit};

 PRIVATE PROCEDURE CarEvn_OnAfterEdit();
 BEGIN
  CarEvn_OnAfterEditInsert();
 END {CarEvn_OnAfterEdit};

 PRIVATE PROCEDURE CarEvn_OnAfterInsert();
 BEGIN
  CarEvn_OnAfterEditInsert();
 END {CarEvn_OnAfterInsert};

 PRIVATE PROCEDURE CarEvn_OnBeforeDelete();
 BEGIN
  L_General.Assert(E_CarEvn_IsAllowedInteractiveModification(), "   稩   ");
  ChangeForecast();
 END {CarEvn_OnBeforeDelete};

 PRIVATE PROCEDURE RepEvent_OnBeforeInsert();
 BEGIN
  CheckCarServiceLev();
 END {RepEvent_OnBeforeInsert};

 PRIVATE PROCEDURE RepEvent_OnAfterEdIns();
 BEGIN
  L_General.Assert((RepEvent.FrAllMrk = L_Car.fam_No) | (RepEvent.FShift > 1),
                   " ਮ ஢     2 ");
  L_DBD.CheckValidity("RepEvent");
 END {RepEvent_OnAfterEdIns};

 PRIVATE PROCEDURE RepEvent_OnAfterInsert();
 BEGIN
  RepEvent_OnAfterEdIns();
 END {RepEvent_OnAfterInsert};

 PRIVATE PROCEDURE RepEvent_OnAfterEdit();
 BEGIN
  RepEvent_OnAfterEdIns();

  SELECT(CarEvn, RepEvent, , RepEvent.RepEvent);
  WHILE OCCURE(CarEvn) DO
   NARROWSEL(CarEvn, Source);
   IF SRCINSEL(CarEvn, GT, RepEvent.Till) THEN
    WHILE OCCURE(CarEvn) DO
     L_DBD.CheckCurRecordsValidity("RepEvent", "CarEvn", 0);
     NEXT(CarEvn);
    END;
   END;
   NEXTINEXTENDEDSEL(CarEvn, Source);
  END;

  SELECT(CarEvn, RepEvent, , RepEvent.RepEvent);
  WHILE OCCURE(CarEvn) DO
   NARROWSEL(CarEvn, Source);
   IF SRCINSEL(CarEvn, LT, RepEvent.Begin) THEN
    WHILE OCCURE(CarEvn) DO
     L_DBD.CheckCurRecordsValidity("RepEvent", "CarEvn", 0);
     PREV(CarEvn);
    END;
   END;
   NEXTINEXTENDEDSEL(CarEvn, Source);
  END;

(*
  L_DBD.CheckValidity("RepEvent");
*)
 END {RepEvent_OnAfterEdit};

 PUBLIC PROCEDURE CarRunAfterEvent();
 BEGIN
  L_General.Assert(ACCESS(CarEvn), " ⠭ ⥪饥 ய⨥");
  CONFORM(CarEvn, Car);
  L_Car.ShowRun(CarEvn.StartD);
 END {CarRunAfterEvent};

 PRIVATE PROCEDURE RepEvE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterInsert]);
  L_WDO.iMayBeEmpty  (0, ["RepEvent.RatedPer", "RepEvent.PlanPer", "RepEvent.Duration", "RepEvent.FShift", "RepEvent.Till"]);
  L_WDO.iProgs       (0, "CarEvn");
 END {RepEvE_OnInitializeWindow};

BEGIN
 L_Events.ExecuteHandler();
END.
