(*
%Copyright   (c) Polak Computer System
%Author      16.04.1998 16:30:50 SAN
%Purpose     ஫ 䨪樨 ᢥ  ய
%Type        control
%Specific    AP
%Modified    05.02.2014 16:56:23 POLAK\LDA
%Environment
*)

 MODULE CarRun [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Car, L_General, L_Env, L_DatTim, L_Events, L_StdFrm, L_OwnData, Math, Memo;

 PRIVATE PROCEDURE Stand_Bal();
 BEGIN
  CHANGESEL(CarRun, BoxNbr, , CarRun.BoxNbr);
  IF ~PREV(CarRun) THEN
   FIRST(CarRun);
   CarRun.TotRun:=0;
   REPLACE(CarRun);
  END;
  L_Car.BalCarRun();
 END {Stand_Bal};

 PUBLIC PROCEDURE ShowCarRunInt();
  VAR
   _From,
   _UpTo : DATE;
   _Run  : LIKE(CarRun.TotRun);
 BEGIN
  L_General.Assert(ACCESS(Car), " ⠭ ");
  _From:=Memo.ud_fr();
  _UpTo:=Memo.ud_ut();
  CONFORM(Car, Mark);
  LOOP
   IF _From <= _UpTo THEN
    _Run:=L_Car.GetAccurateRunInPer_Inc(Car.BoxNbr, _From, _UpTo);
   ELSE
    L_StdFrm.RedInform(" 砭 ਮ      砫");
   END;
   STDFORM(L_StdFrm.sf_Choice("|ࠦ " + Car.BoxNbr +" (" + Car.StateNbr +" " + Mark.Name + ")"+
                              "|| ਮ||c %##########%  %##########% " +
                              "||⠢: %##########% " +
                              "|| 㦭 ਮ|",
                              "%<D.N.y>I %<D.N.y>I %RNI"),
                              " ஡ ࠭ᯮ⭮ ।⢠ ",
                              ,
                              ,
                              _From, _UpTo, FLDTOSTR(_Run, "2.", 0));
  END; (* LOOP *)
 END {ShowCarRunInt};

 PRIVATE PROCEDURE CheckDate();
  VAR
   ModificationAllowed: SCAL[2];
 BEGIN
  CONFORM(CarRun, Car);
  ModificationAllowed:=CarRun.Date < Math.Max(L_Env.aptm_Start, Car.BegDate);
  L_General.Assert(ModificationAllowed,
                   "䨪  ⮫쪮    ⮬  ᯫ"+
                   "|(    ⮏ - " + L_DatTim.DateStr(L_Env.aptm_Start) +  ")");
 END {CheckDate};

 PRIVATE PROCEDURE CarRun_OnAfterEditInsert();
 BEGIN
  CheckDate();
  Stand_Bal();
 END {CarRun_OnAfterEditInsert};

 PRIVATE PROCEDURE CarRun_OnBeforeEdit();
 BEGIN
  L_General.AdminOnly();
 END {CarRun_OnBeforeEdit};

 PRIVATE PROCEDURE CarRun_OnAfterEdit();
 BEGIN
  CarRun_OnAfterEditInsert();
 END {CarRun_OnAfterEdit};

 PRIVATE PROCEDURE CarRun_OnBeforeInsert();
 BEGIN
  L_General.AdminOnly();
 END {CarRun_OnBeforeInsert};

 PRIVATE PROCEDURE CarRun_OnAfterInsert();
 BEGIN
  CarRun_OnAfterEditInsert();
 END {CarRun_OnAfterInsert};

 PRIVATE PROCEDURE CarRun_OnBeforeDelete();
  VAR
   _Run: LIKE(CarRun.Run);
 BEGIN
  L_General.AdminOnly();
  CheckDate();
  _Run:=CarRun.Run;
  DEC(CarRun.Run, _Run);
  REPLACE(CarRun);
  SAVE   (CarRun);
  CHANGESEL(CarRun, BoxNbr, , CarRun.BoxNbr);
  L_General.Assert(PREV(CarRun), " ࢠ ");
  INC(CarRun.Run, _Run);
  REPLACE(CarRun);
  L_Car.BalCarRun();
  RESTORE(CarRun);
 END {CarRun_OnBeforeDelete};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()) L <>
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Car.BoxNbr, L , ""
Car.StateNbr, L, ""
Car.Mark, L, ""
Mark.Name, L, ""
@
############################################################# ########## #####
=#####========================================================================
|                                  ஡                                  |
|----------------------------------------------------------------------------|
|#### ##########    ઠ #### ##############################################|
|----------------------------------------------------------------------------|
|      |                 ஡  |                ஡ ᫥ |
|----------|-------------------------------|---------------------------------|
}
*)

(*
$P{ Line:
?, L, "D.N.y"
?, R, "2."
?, R, "2."
@
|##########|###############################|#################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

(*
 PUBLIC PROCEDURE EU_CarRun();
  CONST
   RepName = "RUNBN";
  VAR
   Cnt    : NUMERIC[0];
   _Run   : LIKE(CarRun.TotRun);
   _Per   : DATE;
   _TotRun: LIKE(CarRun.TotRun);
 BEGIN
  CONFORM(Car, Mark);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  SELECT(CarRun, BoxNbr, , Car.BoxNbr);
  LAST(CarRun);
  Cnt :=0;
  _Run:=0;
  WHILE OCCURE(CarRun) & (Cnt < 12) DO
   INC(Cnt);
   _Per:=L_DatTim.Per(CarRun.Date);
   WHILE OCCURE(CarRun) & (_Per = L_DatTim.Per(CarRun.Date)) DO
    INC(_Run, CarRun.Run);
    _TotRun:=CarRun.TotRun;
    PREV(CarRun);
   END;
   MAKEPART(R, Line, _Per, _TotRun, _Run);
  END; (* WHILE OCCURE(CarRun)... *)
  MAKEPART(R, Bot);
 END {EU_CarRun};
*)

 PUBLIC PROCEDURE RUNBN();
  CONST
   RepName = "RUNBN";
  VAR
   _Per,
   BPer,
   EPer   : DATE;
   _Run,
   _TotRun: LIKE(CarRun.TotRun);
 BEGIN
  CONFORM(Car, Mark);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  BPer:=Memo.ud_fr();
  EPer:=Memo.ud_ut();
  SELECT(CarRun, BoxNbr, , Car.BoxNbr);
  IF ~SRCINSEL(CarRun, GE, EPer) THEN
   LAST(CarRun);
  END;
  WHILE OCCURE(CarRun) & (CarRun.Date >= BPer) DO
   _Run:=0;
   _Per:=L_DatTim.Per(CarRun.Date);
   WHILE OCCURE(CarRun) & (_Per = L_DatTim.Per(CarRun.Date)) DO
    INC(_Run, CarRun.Run);
    _TotRun:=CarRun.TotRun;
    PREV(CarRun);
   END;
   MAKEPART(R, Line, _Per, _TotRun, _Run);
  END; (* WHILE OCCURE(CarRun)... *)
  MAKEPART(R, Bot);
 END {RUNBN};

BEGIN
 L_Events.ExecuteHandler();
END.
