(*
%Copyright   (c) Polak Computer System
%Author      SAN
%Purpose     ࠢ  ﭨ ⥪饩 設
%Type        report
%Specific    AP
%Modified    16.12.2013 11:59:46 POLAK\GAV
%Environment
*)

 MODULE CarTStat [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, L_Str, L_OwnData, L_General, L_Car, L_DatTim, L_AFM, DBD,
        L_Rpr, P_Car, L_CUC;

 PRIVATE CONST
  RepName = "CStat";

 PRIVATE VAR
  OnDate: DATE;

(*
$P {Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
OnDate, L, "D.N.y"
Car.BoxNbr, L, ""
CarLog.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
L_Car.GetCarProdDate(Car.BoxNbr, OnDate), L, "y"
Car.BegDate, L, "D.N.y"
L_Car.GetAccurateRunOnDate(Car.BoxNbr, OnDate), R, "0"
@
############################################################# ########## #####
=#####========================================================================
|              ࠢ  孨᪮ ﭨ   ##########              |
|----------------------------------------------------------------------------|
|: ####     : ##########   ઠ: #### ################################|
| ᪠: ####     ᯫ樨  ########## .  騩 ஡:####### |
|============================================================================|
|孨᪨ ᮡ                                                   |
|----------------------------------------------------------------------------|
}
*)

(*
$P{ ti_Line:
?, L, ""
@
|############################################################################|
}
*)

(*
$P {Top2:
@
|============================================================================|
| ய                       |஢ | ஡|  ଠ|?|
|-----------------------------------------------|----------|-------|-------|-|
}
*)

(*
$P {Top3:
@
|============================================================================|
| ய                         |      |筨         |
|-----------------------------------------------|----------|-----------------|
}
*)

(*
$P {Top4:
@
|============================================================================|
|஢ ய                           |                  |
|------------------------------------------------------|---------------------|
}
*)

(*
$P {Line:
?, L, ""
?, L, "D.N.y"
?, R, "0"
?, R, "0"
?, L, ""
@
|###############################################|##########|#######|#######|#|
}
*)

(*
$P {Line3:
RepEvent.Name, L, ""
CarEvn.StartD, L, "D.N.y"
CarEvn.Source, L, L_Car.src_RE_Pool
@
|###############################################|##########|#################|
}
*)

(*
$P {Line4:
RepEvent.Name, L, ""
CarEvn.StartD, L, "D.N.y"
CarEvn.StopD, L, "D.N.y"
@
|######################################################|########## ##########|
}
*)

(*
$P {Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE TypeLine(Name: STRING[80]; Norm: FLOAT);
  VAR
   R: LIKE(CarRun.TotRun);
   D: DATE;
 BEGIN
  IF OCCURE(CarEvn) THEN
   R:=L_Car.GetAccurateRunInPer(Car.BoxNbr, CarEvn.StartD, OnDate);
   D:=CarEvn.StartD;
  ELSE
   R:=L_Car.GetGlobalRun(Car.BoxNbr, OnDate);
   SETEMPTY(D);
  END;
  IF Norm # 0 THEN
   MAKEPART(R, Line, Name, D, R, Norm, L_Str.PoolItem(" |!", R > Norm));
  ELSE
   MAKEPART(R, Line, Name, D, R, "", " ");
  END;
 END {TypeLine};

 PRIVATE PROCEDURE TypeEvents();
  VAR
   Name     : STRING[];
   Norm     : LIKE(MarkREN.Norm[0]);
   EventDate: DATE;
 BEGIN
  MAKEPART(R, Top2);

  SELECT(RepEvent, RepEvent);
  WHILE OCCURE(RepEvent) DO
   PROMPT(Car.BoxNbr + " " + RepEvent.RepEvent);
   IF L_DatTim.IsActive(OnDate, RepEvent.Begin, RepEvent.Till) THEN
    EventDate:=L_Car.NearestPastRepEventDate(OnDate, RepEvent.RepEvent);
    WHILE OCCURE(CarEvn) & ((CarEvn.Source = L_Car.src_FrCast) | (CarEvn.StartD > OnDate)) DO
     EventDate:=L_Car.NearestPastRepEventDate(EventDate - 1, RepEvent.RepEvent);
    END;
    IF OCCURE(CarEvn) | (RepEvent.FrAllMrk # L_Car.fam_No) THEN
     Norm:=L_Car.MarkRepEventNorm(Mark.Mark, RepEvent.RepEvent, OnDate,
                                  L_Car.GetGlobalRun(Car.BoxNbr, OnDate),
                                  RepEvent.FrAllMrk # L_Car.fam_Strong);
     IF OCCURE(CarEvn) THEN
      Name:=RepEvent.Name;
      IF RepEvent.RepEvent # CarEvn.RepEvent THEN
       SAVE(RepEvent);
       CONFORM(CarEvn, RepEvent);
       Name:=Name + " " + Str.Align("(" + RepEvent.Name + ")", 46 - Str.Length(Name), RIGHT);
       RESTORE(RepEvent);
      END;
      TypeLine(Name, Norm);
     ELSIF Norm > 0 THEN
      Name:=RepEvent.Name + " " + Str.Align(" ஢", 46 - Str.Length(RepEvent.Name), RIGHT);
      TypeLine(Name, Norm);
     END;
    END;
   END;
   NEXT(RepEvent);
  END;

  L_AFM.MakeIndex("tmp", "bad: SCAL[2]; D: DATE; RepEvent: LIKE(RepEvent.RepEvent)");

  SELECT(CarEvn, CarEvn, , Car.BoxNbr);
  WHILE OCCURE(CarEvn) DO
   PROMPT(CarEvn.RepEvent);
   IF CarEvn.Source = L_Car.src_FrCast THEN
    ADD(tmp, tmp, , CarEvn.StopD < OnDate, CarEvn.StartD, CarEvn.RepEvent);
   ELSIF CarEvn.StartD > OnDate THEN
    ADD(tmp, tmp, , 1, CarEvn.StartD, CarEvn.RepEvent);
   END;
   NEXT(CarEvn);
  END;

  IF SELECT(tmp, tmp, 1) THEN
   MAKEPART(R, Top3);
   WHILE OCCURE(tmp) DO
    SEARCH(CarEvn, BoxNbr, , Car.BoxNbr, tmp.D, tmp.RepEvent);
    CONFORM(CarEvn, RepEvent);
    MAKEPART(R, Line3);
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
  END;

  IF SELECT(tmp, tmp, 0) THEN
   MAKEPART(R, Top4);
   WHILE OCCURE(tmp) DO
    SEARCH(CarEvn, BoxNbr, , Car.BoxNbr, tmp.D, tmp.RepEvent);
    CONFORM(CarEvn, RepEvent);
    MAKEPART(R, Line4);
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
  END;
  L_AFM.AF_PurgeTemp("tmp");
 END {TypeEvents};

 PRIVATE PROCEDURE TypeTechInfo();
  VAR
   i       : NUMERIC[0];
   StrArr  : STRING[][10];
 BEGIN
  Str.Format(StrArr, P_Car.GetCarProSoft(Car.BoxNbr, OnDate, P_Car.P_TechnicalFeatures), 76, LEFT);
  i:=0;
  WHILE (i <= HIGH(StrArr)) & ((i = 0) | ~!StrArr[i]) DO
   MAKEPART(R, ti_Line, StrArr[i]);
   INC(i);
  END; (* WHILE (i <= HIGH(StrArr)) &...*)
 END {TypeTechInfo};

 PUBLIC PROCEDURE CStat(ByWhat: SCAL[3]);
 BEGIN
  IF ByWhat = 0 THEN (* RprS *)
   L_Rpr.AccessRprS();
   L_General.Assert(~!RprS.RprObjId, " 㪠 ");
   L_General.Assert(L_Rpr.IsRprS_w_Car(), "ࠢ  ﭨ   祭|⮫쪮  ᮡ⢥ ");
   CONFORM(RprS, CUCopy);
   L_CUC.AccessOrigin();
   OnDate:=RprS.OrdDate;
  ELSIF ByWhat = 1 THEN (* CarEvn *)
   L_General.Assert(ACCESS(CarEvn), " ⠭ ६⭮ ᮡ⨥");
   CONFORM(CarEvn, Car);
   OnDate:=CarEvn.StartD;
  ELSIF ByWhat = 2 THEN
   L_General.Assert(ACCESS(Car), " ⠭ ");
   OnDate:=SYSDATE();
  END;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  L_Car.StandOnCarLog(Car.BoxNbr, OnDate);
  CONFORM(CarLog, Mark);
  MAKEPART(R, Top);
  TypeTechInfo();
  TypeEvents();
  MAKEPART(R, Bot);
  CLOSEREP(R);
  IF ~L_General.KioskExecution_IsRunning() THEN
   LIKEMENU(Survey, "");
  END;
 END {CStat};

END.
