(*
%Copyright   (c) Polak Computer System
%Author      17.04.1998 13:24:03 SAN
%Purpose       ࠬ , ⠭  
%Type        operation
%Specific    AP
%Modified    09.07.2014 11:58:00 POLAK\Gina
%Environment
*)

 IMPORT L_General, L_Env, L_Car, L_CUC, L_DatTim, L_OwnData, L_AFM, Memo,
        L_Events, L_MDoc, L_XDoc, L_Str, Str;

 PRIVATE TYPE
  tInExplStatus = SCAL[3];

 PRIVATE CONST
  ies_Fixed     = 0;
  ies_Installed = 1;
  ies_InReserve = 2;

(*
$P {Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
SYSDATE(), L, "D.N.y"
Car.BoxNbr, L, ""
Car.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
@
######################################################################### ########## #####
==========================================================================================
|                    ࠢ  ⠭ ॣ  ##########                    |
|----------------------------------------------------------------------------------------|
|: #### : ########## ઠ: #### ##################################################|
}

$P {CUTop:
CarUnit.CarUnit, L, ""
CarUnit.Name, L, ""
@
|----------------------------------------------------------------------------------------|
| #### ###############################################################################|
|----------------------------------------------------------------------------------------|
|       |     |                        ||                   |஡,.| ६, |
|    |  |᪮          ||    |-------------|-----------|
|       |     |                        ||                   | | ᥣ||ᥣ|
|-------|-----|------------------------|---|-------------------|------|------|-----|-----|
}

$P {Line:
CUCopy.CUCopy, L, ""
CUCopy.Math, L, ""
CUCopy.Serial, L, ""
L_CUC.GetLastCUCondition(CUCopy.CUCopy), L, L_CUC.cnd_Pool
_CUnt._OpKind, L, L_CUC.ok_Pool
_CUnt._Date, L, "D.N.y"
_CUnt._CurRun/1000, R, "1."
_CUnt._TotRun/1000, R, "1."
L_DatTim.DaysToMonths(_CUnt._CurTim), R, "1."
L_DatTim.DaysToMonths(_CUnt._TotTim), R, "1."
@
|#######|#####|########################|###|######## ##########|######|######|#####|#####|
}

$P {Bot:
@
=(c) Polak================================================================================
}
*)

 PUBLIC PROCEDURE CrUnt();
  VAR
   OnDate: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Car), " ⠭ ");
  L_General.Assert(L_Env.RealBoxNbr(Car.BoxNbr), "쪮   䨪⨢ ");
  L_AFM.MakeMultipleIndex("_CUnt", "_CarUnit : LIKE(CarUnit.CarUnit);"+
                                   "_CUCopy  : LIKE(CUCopy.CUCopy);"+
                                   "_Status  : SCAL[3];"+                (*tInExplStatus*)
                                   "_OpKind  : LIKE(MDocLCU.OpKind);" +
                                   "_Date    : DATE;"+
                                   "_CurRun  : NUMERIC[3];"+
                                   "_TotRun  : NUMERIC[3];"+
                                   "_CurTim  : NUMERIC[6];"+
                                   "_TotTim  : NUMERIC[6];",
                          "_CUCopy: _CUCopy;"+
                          "_CUnt  : _CarUnit, _Status, _Date");
  OPENREP(R, L_General.NameConnection("CrUnt"), Create);
  OnDate:=SYSDATE();
  SAVE(MDocLCU);
  SELECT(MDocLCU, BoxNbr, , Car.BoxNbr, L_MDoc.st_Passed);
  WHILE OCCURE(MDocLCU) DO
   PROMPT(" " + MDocLCU.CUCopy);
   NARROWSEL(MDocLCU, CUCopy);
   IF SRCINSEL(MDocLCU, LE, OnDate) & L_CUC.IsCUAtCar(MDocLCU.OpKind) THEN
    CONFORM(MDocLCU, CUCopy);
    CONFORM(CUCopy,    Math);
    ADD(_CUnt, _CUCopy, , CUCopy.CUCopy,
        _CUnt._CurRun, L_CUC.GetCUCopyLastBoxNbrRun(MDocLCU.CUCopy, OnDate, 1),
        _CUnt._CurTim, L_CUC.GetCUCopyLastBoxNbrTim(MDocLCU.CUCopy, OnDate, 1),
        _CUnt._TotRun, L_CUC.GetCUCopyTotalRun(MDocLCU.CUCopy, OnDate, 1),
        _CUnt._TotTim, L_CUC.GetCUCopyTotalTim(MDocLCU.CUCopy, OnDate, 1));
    _CUnt._CarUnit :=Math.CarUnit;
    _CUnt._Date    :=MDocLCU.Date;
    _CUnt._OpKind  :=MDocLCU.OpKind;
    IF    MDocLCU.OpKind = L_CUC.ok_toRsrv THEN
     _CUnt._Status:=ies_InReserve;
    ELSIF MDocLCU.OpKind = L_CUC.ok_Fixup   THEN
     _CUnt._Status:=ies_Fixed;
    ELSIF MDocLCU.OpKind = L_CUC.ok_Setting THEN
     _CUnt._Status:=ies_Installed;
    ELSE
     L_General.CallUs(0);
    END;
    REPLACE(_CUnt);
   END; (* IF  ... *)
   NEXTINEXTENDEDSEL(MDocLCU, CUCopy);
  END; (* WHILE OCCURE(MDocLCU) ... *)
  RESTORE(MDocLCU);

  L_Car.AccessMark(Car.BoxNbr, SYSDATE());
  L_XDoc.sl_Init("⠭ ॣ   " + Car.BoxNbr);
  MAKEPART(R, Top);
  SELECT(_CUnt, _CUnt);
  WHILE OCCURE(_CUnt) DO
   NARROWSEL(_CUnt, _CarUnit);
   SEARCH(CarUnit, CarUnit, , _CUnt._CarUnit);
   MAKEPART(R, CUTop);
   WHILE OCCURE(_CUnt) DO
    SEARCH(CUCopy, CUCopy, , _CUnt._CUCopy);
    MAKEPART(R, Line);
    L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_CUCopy, L_XDoc.EmptyXDocKind, _CUnt._CUCopy),
                      CarUnit.CarUnit + " " +
                      CUCopy.CUCopy + " " + CUCopy.Math + " " + Str.Align(CUCopy.Serial, 36, LEFT) + " " +
                      L_Str.PoolItem(L_CUC.cnd_Pool, L_CUC.GetLastCUCondition(CUCopy.CUCopy)) + " " +
                      Str.Align(L_Str.PoolItem(L_CUC.ok_Pool, _CUnt._OpKind), 8, LEFT) + " " +
                      L_DatTim.DateStr(_CUnt._Date));
    NEXT(_CUnt);
   END; (* WHILE OCCURE(_CUnt) ... *)
   NEXTINEXTENDEDSEL(_CUnt, _CarUnit);
  END; (* WHILE OCCURE(_CUnt) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_XDoc.sl_Done();
 END {CrUnt};

 PRIVATE PROCEDURE AccessMDocLCU();
 BEGIN
  L_General.Assert(ACCESS(MDocLCU),
                   " ⠭ ⥪   '⠭ ॣ'");
 END {AccessMDocLCU};

 PRIVATE PROCEDURE CarUnt_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("MDocLCU.OpKind").Format:=L_CUC.ok_Pool;
 END {CarUnt_1_OnZoneOpen};

 PUBLIC PROCEDURE ShowCarRunAfterMDocDate();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  AccessMDocLCU();
  CONFORM(MDocLCU, Car);
  L_Car.ShowRun(MDocLCU.Date);
 END {ShowCarRunAfterMDocDate};

 PUBLIC PROCEDURE ShowCUCopyRunOnDate();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  AccessMDocLCU();
  L_CUC.ShowCUCopyRun(MDocLCU.CUCopy, Memo.ud_cd());
 END {ShowCUCopyRunOnDate};

 PUBLIC PROCEDURE ShowCUCopyRunOnMDocDate();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  AccessMDocLCU();
  L_CUC.ShowCUCopyRun(MDocLCU.CUCopy, MDocLCU.Date);
 END {ShowCUCopyRunOnMDocDate};

BEGIN
 L_Events.ExecuteHandler();
END.
