(*
%Copyright   (c) Polak Computer System
%Author      28.03.2000 12:15:07 SAN
%Purpose      ஢ ॣ⮢
%Type        report
%Specific    SYS
%Modified    01.04.2013 17:24:53 POLAK\GAV
%Environment
*)

 MODULE CCMV1 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Basis, L_Str, L_CUC, L_Car, Math, FIO,
        P_Math, P_CUC, P_Firm, L_Env, Memo, L_MDoc, L_AR, L_bp;

 PRIVATE CONST
  rt_Move              = 0;
  rt_OnDate            = 1;
  rt_Retire            = 2;
  rt_CarUnitCUC_OnDate = 3;
  rt_MathCUC_Move      = 4;

 PRIVATE VAR
  RType: SCAL[5];
  wMF  : SCAL[2];

 PRIVATE PROCEDURE ccmv1_MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "᪮ ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⮢⥫");
  L_Basis.wb_WrInQM(F, "⮢⥫");
  L_Basis.wb_WrInQM(F, "ࢮ ﭨ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠪ");
  L_Basis.wb_WrInQM(F, "⮭宦");
  L_Basis.wb_WrInQM(F, "ﭨ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "稭 ᯨᠭ");
  L_Basis.wb_WrInQM(F, "ᠭ");
  L_Basis.wb_WrInQM(F, "⥫ 䨪");
  L_Basis.wb_TermLine(F);
 END {ccmv1_MakeHeader};

 PRIVATE PROCEDURE ccmv1_MakeLine(F          : STRING[];
                                  Date       : DATE;
                                  Type,
                                  OpKind     : STRING[];
                                  _CUCChar   : LIKE(MDMth.CUCChar);
                                  Location   : STRING[];
                                  _BoxNbr    : LIKE(Car.BoxNbr);
                                  _MyFirm    : P_Firm.tMyFirm;
                                  Condition  : STRING[];
                                  Run        : NUMERIC[2];
                                  _Firm      : LIKE(Firm.Firm);
                                  _Date      : DATE);
 BEGIN
  IF wMF THEN
   IF ~!_MyFirm THEN
    P_Firm.PositionOnMyFirm(_MyFirm);
    L_Basis.wb_WrScl(F, MyFirm.MyFirm);
    L_Basis.wb_WrStr(F, MyFirm.vzSign);
   ELSE
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
   END;
  END;
  IF OCCURE(CarUnit) THEN
   L_Basis.wb_WrScl(F, CarUnit.CarUnit);
   L_Basis.wb_WrStr(F, CarUnit.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrScl(F, CUCopy.CUCopy);
  L_Basis.wb_WrStr(F, CUCopy.Serial);
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrScl(F, Vendor.Vendor);
  L_Basis.wb_WrStr(F, Vendor.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_CUC.cnd_Pool, L_CUC.GetInitCUCondition(CUCopy.CUCopy)));
  L_Basis.wb_WrStr(F, Type);
  L_Basis.wb_WrStr(F, OpKind);
  IF ~!_CUCChar THEN
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_CUC.chr_Pool, _CUCChar));
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrStr(F, Location);
  L_Basis.wb_WrStr(F, Condition);

  L_Basis.wb_WrDat(F, _Date);
  L_Basis.wb_WrScl(F, _Firm);
  IF ~!_Firm THEN
   SEARCH(Firm, Firm, , _Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;

  IF ~!_BoxNbr & L_Env.RealBoxNbr(_BoxNbr) THEN
   L_Basis.wb_WrStr(F, _BoxNbr);
   L_Car.AccessMark(_BoxNbr, Date);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrNum(F, Run, 2);
  L_Basis.wb_WrStr(F, P_CUC.GetRetirementReason(CUCopy.CUCopy, Date));
  L_Basis.wb_WrStr(F, P_CUC.GetRetirementDescription(CUCopy.CUCopy, Date));
  L_Basis.wb_WrStr(F, P_CUC.GetCUCProSoft(CUCopy.CUCopy, Date, P_CUC.P_AdditionalId));
  L_Basis.wb_TermLine(F);
 END {ccmv1_MakeLine};

 PRIVATE PROCEDURE ccmv3_MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "᪮ ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⮢⥫");
  L_Basis.wb_WrInQM(F, "⮢⥫");
  L_Basis.wb_WrInQM(F, "⮭宦");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ﭨ");
  L_Basis.wb_WrInQM(F, "ࠪ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ﭨ ");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "ଠ");
  L_Basis.wb_WrInQM(F, "ࢮ ﭨ");
  L_Basis.wb_WrInQM(F, "ࢮ ஡");
  L_Basis.wb_WrInQM(F, " 㯫");
  L_Basis.wb_WrInQM(F, " ᫥ ");
  L_Basis.wb_WrInQM(F, "६ ");
  L_Basis.wb_WrInQM(F, "ଠ ");
  L_Basis.wb_WrInQM(F, "稭 ᯨᠭ");
  L_Basis.wb_WrInQM(F, "ᠭ");
  L_Basis.wb_WrInQM(F, "⥫ 䨪");
  L_Basis.wb_TermLine(F);
 END {ccmv3_MakeHeader};

 PRIVATE PROCEDURE InitRun(): LIKE(CUCopy.InitRun);
 BEGIN
  IF !CUCopy.InitRun THEN
   RETURN 0;
  END;
  RETURN CUCopy.InitRun;
 END {InitRun};

 PRIVATE PROCEDURE DateOfLastMDocLCU(): DATE;
 BEGIN
  IF L_CUC.AccessLastMDocLCU(CUCopy.CUCopy) THEN
   RETURN MDocLCU.Date;
  END;
  RETURN EMPTYOF(DATE);
 END {DateOfLastMDocLCU};

 PRIVATE PROCEDURE CUCConditionForNorm(Date: DATE; VAR crDate: DATE): L_CUC.tCondition;
  VAR
   Result: L_CUC.tCondition;
 BEGIN
  IF !CarUnit.SNDate | (CarUnit.Type # L_CUC.cut_CarImplements) THEN
   Result:=L_CUC.cnd_New;
   SETEMPTY(crDate);
  ELSE
   crDate:=L_CUC.GetCUCopyCRDate(CUCopy.CUCopy, Date);
   IF ~!crDate THEN
    Result:=L_CUC.cnd_Restored;
   ELSE
    Result:=L_CUC.cnd_New;
   END;
  END;
  RETURN Result;
 END {CUCConditionForNorm};

 PRIVATE PROCEDURE GetCUCopyRunForCondition(Date: DATE; Condition: L_CUC.tCondition; crDate: DATE): NUMERIC[3];
  VAR
   Result: NUMERIC[3];
 BEGIN
  IF Condition = L_CUC.cnd_New THEN
   Result:=L_CUC.GetCUCopyTotalRun(CUCopy.CUCopy, Date, 0(*?*));
  ELSIF Condition = L_CUC.cnd_Restored THEN
   L_General.CallUs(~!crDate);
   Result:=L_CUC.GetCUCopyPerRun(CUCopy.CUCopy, crDate, Date, 0(*?*));
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {GetCUCopyRunForCondition};

 PRIVATE PROCEDURE ccmv3_MakeLine(F          : STRING[];
                                  What       : STRING[];
                                  _BoxNbr    : LIKE(Car.BoxNbr);
                                  _MyFirm    : P_Firm.tMyFirm;
                                  Condition  : STRING[];
                                  _CUCChar   : LIKE(MDMth.CUCChar);
                                  _Storage   : LIKE(Storage.Storage);
                                  Date       : DATE);
  VAR
   LifeTime    : NUMERIC[0];
   LifeTimeUnit: P_Math.tLifeTimeUnit;
   crDate      : DATE;
   CondForNorm : L_CUC.tCondition;
 BEGIN
  IF wMF THEN
   IF ~!_MyFirm THEN
    P_Firm.PositionOnMyFirm(_MyFirm);
    L_Basis.wb_WrScl(F, MyFirm.MyFirm);
    L_Basis.wb_WrStr(F, MyFirm.vzSign);
   ELSE
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
   END;
  END;
  IF OCCURE(CarUnit) THEN
   L_Basis.wb_WrScl(F, CarUnit.CarUnit);
   L_Basis.wb_WrStr(F, CarUnit.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrScl(F, CUCopy.CUCopy);
  L_Basis.wb_WrStr(F, CUCopy.Serial);
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrScl(F, Vendor.Vendor);
  L_Basis.wb_WrStr(F, Vendor.Name);
  L_Basis.wb_WrStr(F, What);
  L_Basis.wb_WrScl(F, _Storage);
  IF ~!_Storage THEN
   SEARCH(Storage, Storage, , _Storage);
   L_Basis.wb_WrStr(F, Storage.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrStr(F, Condition);
  IF ~!_CUCChar THEN
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_CUC.chr_Pool, _CUCChar));
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
  IF ~!_BoxNbr & L_Env.RealBoxNbr(_BoxNbr) THEN
   L_Basis.wb_WrStr(F, _BoxNbr);
   IF L_Car._StandOnCarLog(_BoxNbr, Date) THEN
    CONFORM(CarLog, Mark);
    L_Basis.wb_WrStr(F, CarLog.StateNbr);
    L_Basis.wb_WrScl(F, Mark.Mark);
    L_Basis.wb_WrStr(F, Mark.Name);
    L_Basis.wb_WrStr(F, L_Str.PoolItem(" ᯫ樨| ᯫ樨|뫮", CarLog.Status));
   ELSE
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "------");
    L_Basis.wb_WrStr(F, "------");
   END;
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "------");
   L_Basis.wb_WrStr(F, "------");
  END;

  CondForNorm:=CUCConditionForNorm(Date, crDate);
  L_Basis.wb_WrNum(F, GetCUCopyRunForCondition(Date, CondForNorm, crDate), 2);

  P_Math.GetLifeTime(Math.Math, Date, CondForNorm, LifeTimeUnit, LifeTime);
  IF ~!LifeTime & (LifeTimeUnit = P_Math.ltu_ThousandKm) THEN
   L_Basis.wb_WrNum(F, LifeTime * 1000, 2);
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;

  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_CUC.cnd_Pool, L_CUC.GetInitCUCondition(CUCopy.CUCopy)));
  L_Basis.wb_WrNum(F, InitRun(), 2);
  L_Basis.wb_WrDat(F, CUCopy.Begin);
  L_Basis.wb_WrDat(F, DateOfLastMDocLCU());
  L_Basis.wb_WrNum(F, L_DatTim.DaysToMonths(L_CUC.GetCUCopyTotalTim(CUCopy.CUCopy, Date, 1)), 2);
  IF ~!LifeTime & (LifeTimeUnit = P_Math.ltu_Month) THEN
   L_Basis.wb_WrNum(F, LifeTime, 2);
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrStr(F, P_CUC.GetRetirementReason(CUCopy.CUCopy, Date));
  L_Basis.wb_WrStr(F, P_CUC.GetRetirementDescription(CUCopy.CUCopy, Date));
  L_Basis.wb_WrStr(F, P_CUC.GetCUCProSoft(CUCopy.CUCopy, Date, P_CUC.P_AdditionalId));
  L_Basis.wb_TermLine(F);
 END {ccmv3_MakeLine};

 PRIVATE PROCEDURE SetOnEdge(    _CUCopy     : LIKE(CUCopy.CUCopy);
                                 D           : DATE;
                             VAR strLocation,
                                 strCondition: STRING[];
                             VAR _BoxNbr     : LIKE(Car.BoxNbr);
                             VAR _MyFirm     : P_Firm.tMyFirm;
                             VAR DoIt        : SCAL[2];
                             VAR _CUCChar    : LIKE(MDMth.CUCChar);
                             VAR _Storage    : LIKE(Storage.Storage));
  VAR
   _Location: L_CUC.tLocation;
 BEGIN
  SETEMPTY(_MyFirm);
  IF L_CUC.AccessMDocLCU(_CUCopy, D) THEN
   _Location   :=L_CUC.DefineCULocation(MDocLCU.OpKind);
   strLocation :=L_Str.PoolItem(L_CUC.l_Pool,   _Location);
   strCondition:=L_Str.PoolItem(L_CUC.cnd_Pool, L_CUC.GetCUCondition(_CUCopy, D));
   _Storage    :=L_CUC.GetCurMDocLCUStorage();
   _BoxNbr     :=MDocLCU.BoxNbr;
   CONFORM(MDocLCU, MDocList);
   CONFORM(MDocList, MDoc);
   _MyFirm:=MDoc.MyFirm;
   _CUCChar:=L_MDoc.getMDocLCUChar();
   DoIt:=DoIt | (_Location # L_CUC.l_WrittenOff) & ((_Location # L_CUC.l_inExpl) | ~L_CUC.cucRole_IsTck());
  ELSE
   strLocation :="---";
   strCondition:="---";
   SETEMPTY(_BoxNbr, _Storage, _CUCChar);
  END;
 END {SetOnEdge};

 PRIVATE PROCEDURE GetIncomeData(    _CUCopy   : LIKE(CUCopy.CUCopy);
                                     D         : DATE;
                                 VAR IncomeFirm: LIKE(Firm.Firm);
                                 VAR IncomeDate: DATE);
 BEGIN
  IF D < IncomeDate THEN
   SETEMPTY(IncomeDate, IncomeFirm);
   IF L_CUC.AccessMDocLCU(_CUCopy, D) THEN
    WHILE OCCURE(MDocLCU) & !IncomeFirm DO
     IF L_CUC.DefineCULocation(MDocLCU.OpKind) = L_CUC.l_atStock THEN
      CONFORM(MDocLCU, MDocList);
      CONFORM(MDocList, MDoc);
      IF OCCURE(MDoc) THEN
       IF ~!MDoc.Firm THEN
        IncomeDate:=MDoc.Date;
        IncomeFirm:=MDoc.Firm;
       END;
      ELSE
       L_AR.CheckIntegrityViolationBecausePartOfDataBaseConcealing();
      END;
     END;
     PREV(MDocLCU);
    END;
   END;
  END;
 END {GetIncomeData};

 PRIVATE PROCEDURE ccmv1_DoSingleCUCopy(PerB, PerE: DATE);
  VAR
   DoIt       : SCAL[2];
   bLocation,
   eLocation,
   bCondition,
   eCondition : STRING[];
   bBoxNbr,
   eBoxNbr    : LIKE(Car.BoxNbr);
   bRun,
   eRun       : NUMERIC[2];
   bCUCChar,
   eCUCChar   : LIKE(MDMth.CUCChar);
   bMyFirm,
   eMyFirm    : P_Firm.tMyFirm;
   IncomeFirm : LIKE(Firm.Firm);
   IncomeDate : DATE;
   _Storage   : LIKE(Storage.Storage);
 BEGIN
  IF L_CUC.AccessMDocLCU(CUCopy.CUCopy, PerE) THEN
   DoIt:=0;
   WHILE OCCURE(MDocLCU) & (MDocLCU.Date >= PerB) & ~DoIt DO
    DoIt:=1;
    PREV(MDocLCU);
   END;
   SetOnEdge(CUCopy.CUCopy, PerB - 1, bLocation, bCondition, bBoxNbr, bMyFirm, DoIt, bCUCChar, _Storage);
   SetOnEdge(CUCopy.CUCopy, PerE,     eLocation, eCondition, eBoxNbr, eMyFirm, DoIt, eCUCChar, _Storage);
   IF DoIt THEN
    bRun:=L_CUC.GetCUCopyTotalRun(CUCopy.CUCopy, PerB, 0(*?*));
    eRun:=L_CUC.GetCUCopyTotalRun(CUCopy.CUCopy, PerE, 0(*?*));
    SETEMPTY(IncomeDate, IncomeFirm);
    GetIncomeData(CUCopy.CUCopy, PerE,     IncomeFirm, IncomeDate);
    ccmv1_MakeLine("R", PerE, "줮  ",  "", bCUCChar, eLocation, eBoxNbr, eMyFirm, eCondition, eRun, IncomeFirm, IncomeDate);
    GetIncomeData(CUCopy.CUCopy, PerB - 1, IncomeFirm, IncomeDate);
    ccmv1_MakeLine("R", PerE, "C줮  砫", "", eCUCChar, bLocation, bBoxNbr, bMyFirm, bCondition, bRun, IncomeFirm, IncomeDate);

    SETSEL(MDocLCU, CUCopy, CUCopy.CUCopy, L_MDoc.st_Passed);
    SRCINSEL(MDocLCU, LT, , PerE + 1);
    WHILE OCCURE(MDocLCU) & (MDocLCU.Date >= PerB) DO
     CONFORM(MDocLCU, MDocList);
     CONFORM(MDocList, MDoc);
     ccmv1_MakeLine("R", PerE, "",
                    L_Str.PoolItem(L_CUC.ok_Pool, MDocLCU.OpKind),
                    L_MDoc.getMDocLCUChar(),
                    L_Str.PoolItem(L_CUC.l_Pool, L_CUC.DefineCULocation(MDocLCU.OpKind)),
                    MDocLCU.BoxNbr, MDoc.MyFirm,
                    L_Str.PoolItem(L_CUC.cnd_Pool, L_CUC.GetCUCondition(CUCopy.CUCopy, MDocLCU.Date)),
                    L_CUC.GetCUCopyTotalRun(CUCopy.CUCopy, MDocLCU.Date, 0(*?*)),
                    MDoc.Firm,
                    MDoc.Date);
     PREV(MDocLCU);
    END;
   END; (* IF DoIt ... *)
  END; (* IF L_CUC.AccessMDocLCU ... *)
 END {ccmv1_DoSingleCUCopy};

 PRIVATE PROCEDURE ccmv3_DoSingleCUCopy(Date: DATE);
  VAR
   _Location,
   _Condition: STRING[];
   _BoxNbr   : LIKE(Car.BoxNbr);
   _MyFirm   : P_Firm.tMyFirm;
   _CUCChar  : LIKE(MDMth.CUCChar);
   _Storage  : LIKE(Storage.Storage);
   DoIt      : SCAL[2];
 BEGIN
  DoIt:=0;
  SetOnEdge(CUCopy.CUCopy, Date-1, _Location, _Condition, _BoxNbr, _MyFirm, DoIt, _CUCChar, _Storage);
  IF DoIt | (RType = rt_CarUnitCUC_OnDate) & L_CUC.AccessMDocLCU(CUCopy.CUCopy, Date) THEN
   ccmv3_MakeLine("R", _Location, _BoxNbr, _MyFirm, _Condition, _CUCChar, _Storage, Date);
  END;
 END {ccmv3_DoSingleCUCopy};

 PRIVATE PROCEDURE ccmv4_NeedCUC(PerB, PerE: DATE): SCAL[2];
  VAR
   LifeTime    : NUMERIC[0];
   LifeTimeUnit: P_Math.tLifeTimeUnit;
   Condition,
   CondForNorm : L_CUC.tCondition;
   crDate      : DATE;
 BEGIN
  IF L_CUC.AccessMDocLCU(CUCopy.CUCopy, PerE) THEN
   IF    L_CUC.DefineCULocation(MDocLCU.OpKind) = L_CUC.l_WrittenOff THEN
    RETURN L_DatTim.IsActive_Inc(MDocLCU.Date, PerB, PerE);
   ELSIF L_CUC.DefineCULocation(MDocLCU.OpKind) # L_CUC.l_Others THEN
    Condition:=L_CUC.GetCUCondition(CUCopy.CUCopy, PerE);
    IF (Condition = L_CUC.cnd_Nonserviceable) | (Condition = L_CUC.cnd_ToBeReclamaition) THEN
     RETURN 1;
    ELSE
     CondForNorm:=CUCConditionForNorm(PerE, crDate);
     P_Math.GetLifeTime(Math.Math, PerE, CondForNorm, LifeTimeUnit, LifeTime);
     IF (LifeTimeUnit = P_Math.ltu_ThousandKm) | (LifeTimeUnit = P_Math.ltu_Month) THEN
      L_General.Assert(~!LifeTime, " ᢮⢥   । ப 㦡  "+L_Str.PoolItem(L_CUC.cnd_Pool, CondForNorm)+"| "+CUCopy.Math);
     END;
     IF    LifeTimeUnit = P_Math.ltu_ThousandKm THEN
      RETURN GetCUCopyRunForCondition(PerE, CondForNorm, crDate) > (LifeTime * 1000);
     ELSIF LifeTimeUnit = P_Math.ltu_Month THEN
      RETURN L_DatTim.DaysToMonths(L_CUC.GetCUCopyTotalTim(CUCopy.CUCopy, PerE, 1)) > LifeTime;
     ELSE
      RETURN 0;
     END;
    END;
   END;
  END;
  RETURN 0;
 END {ccmv4_NeedCUC};

 PRIVATE PROCEDURE ccmv4_DoSingleCUCopy(PerB, PerE: DATE);
  VAR
   _Norm     : NUMERIC[2];
   _Condition: L_CUC.tCondition;
 BEGIN
  IF ccmv4_NeedCUC(PerB, PerE) THEN
   CONFORM(MDocLCU, MDocList);
   CONFORM(MDocList, MDoc);
   ccmv3_MakeLine("R", L_Str.PoolItem(L_CUC.l_Pool, L_CUC.DefineCULocation(MDocLCU.OpKind)),
                       MDocLCU.BoxNbr,
                       MDoc.MyFirm,
                       L_Str.PoolItem(L_CUC.cnd_Pool, L_CUC.GetCUCondition(CUCopy.CUCopy, PerE)),
                       L_MDoc.getMDocLCUChar(),
                       L_CUC.GetCurMDocLCUStorage(),
                       PerE);
  END;
 END {ccmv4_DoSingleCUCopy};

 PRIVATE PROCEDURE IsMovingMode(): SCAL[2];
 BEGIN
  RETURN (RType = rt_Move) | (RType = rt_MathCUC_Move);
 END {IsMovingMode};

 PRIVATE PROCEDURE ccmv_DoSingleMath(PerB, PerE: DATE);
 BEGIN
  SAVE(CarUnit);
  SAVE(Math);
  IF ~!P_Math.GetParentMath(CUCopy.Math, PerE) THEN
   SEARCH(Math, Math, , P_Math.GetParentMath(CUCopy.Math, PerE));
  ELSE
   IF (RType # rt_CarUnitCUC_OnDate) THEN
    CONFORM(CUCopy, Math);
   END;
  END;

  CONFORM(Math, Vendor);
  CONFORM(Math, CarUnit);
  WHILE OCCURE(CUCopy) DO
   PROMPT(CUCopy.Math + " : " + CUCopy.CUCopy);
   IF    IsMovingMode() THEN
    ccmv1_DoSingleCUCopy(PerB, PerE);
   ELSIF (RType = rt_OnDate) | (RType = rt_CarUnitCUC_OnDate) THEN
    ccmv3_DoSingleCUCopy(PerB);
   ELSIF RType = rt_Retire THEN
    ccmv4_DoSingleCUCopy(PerB, PerE);
   END;
   NEXT(CUCopy);
  END; (* WHILE OCCURE(CUCopy) ... *)
  RESTORE(Math);
  RESTORE(CarUnit);
 END {ccmv_DoSingleMath};

 PRIVATE PROCEDURE ccmv_Do(PerB, PerE: DATE; RepName: STRING[]);
  VAR
   _Math: LIKE(Math.Math);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  IF    IsMovingMode() THEN
   ccmv1_MakeHeader("R");
  ELSE
   ccmv3_MakeHeader("R");
  END;

  IF RType = rt_CarUnitCUC_OnDate THEN
   SELECT(Math, CarUnit, , CarUnit.CarUnit);
   WHILE OCCURE(Math) DO
    PROMPT(Math.Math);
    IF Math.Leaf & SELECT(CUCopy, Math, Math.Math) THEN
     ccmv_DoSingleMath(PerB, PerE);
    END;
    NEXT(Math);
   END; (* WHILE OCCURE(Math) ... *)
  ELSIF RType = rt_MathCUC_Move THEN
   _Math:=Math.Math;
   PROMPT(Math.Math);
   IF SELECT(CUCopy, Math, Math.Math) THEN
    ccmv_DoSingleMath(PerB, PerE);
   END;
   SELECT(MathPro, Property, , P_Math.P_ParentMath, _Math);
   WHILE OCCURE(MathPro) DO
    IF L_DatTim.IsActiveInIntvl_Inc(PerB, PerE, MathPro.Date, MathPro.EndDate) THEN
     PROMPT(MathPro.Math);
     IF SELECT(CUCopy, Math, MathPro.Math) THEN
      SAVE(MathPro);
      ccmv_DoSingleMath(PerB, PerE);
      RESTORE(MathPro);
     END;
    END;
    NEXT(MathPro);
   END; (* WHILE OCCURE(MathPro) ... *)
  ELSE
   SELECT(CUCopy, Math);
   WHILE OCCURE(CUCopy) DO
    NARROWSEL(CUCopy, Math);
    IF SRCINSEL(CUCopy, GT, PerB) &
       ((CUCopy.Origin = L_CUC.o_Other) | (CUCopy.Origin = L_CUC.o_KeyAss)) THEN
     ccmv_DoSingleMath(PerB, PerE);
    END;
    NEXTINEXTENDEDSEL(CUCopy, Math);
   END; (* WHILE OCCURE(CUCopy) ... *)
  END;
  FIO.Close(R);
 END {ccmv_Do};

 PUBLIC PROCEDURE CCMV1();
  CONST
   bpId = "CCMV1";
 BEGIN
  RType:=rt_Move;
  L_bp.Begin(bpId, " ஢", L_bp.t_Basis, L_General.tc_inIntvl);
  ccmv_Do(Memo.ud_fr(), Memo.ud_ut(), bpId);
  L_bp.End();
 END {CCMV1};

 PUBLIC PROCEDURE CCMV3();
  CONST
   bpId = "CCMV3";
 BEGIN
  RType:=rt_OnDate;
  L_bp.Begin(bpId, " ஢", L_bp.t_Basis, L_General.tc_onDate);
  ccmv_Do(Memo.ud_cd(), Memo.ud_cd(), bpId);
  L_bp.End();
 END {CCMV3};

 PUBLIC PROCEDURE CCMV4();
  CONST
   bpId = "CCMV4";
 BEGIN
  RType:=rt_Retire;
  L_bp.Begin(bpId, "  ஢", L_bp.t_Basis, L_General.tc_inIntvl);
  ccmv_Do(Memo.ud_fr(), Memo.ud_ut(), bpId);
  L_bp.End();
 END {CCMV4};

 PUBLIC PROCEDURE CCMV1_ByMath();
  CONST
   bpId = "CCMV1";
 BEGIN
  L_General.Assert(ACCESS(Math), " ⠭ ");
  RType:=rt_MathCUC_Move;
  ccmv_Do(Memo.ud_fr(), Memo.ud_ut(), bpId);
  L_Basis.PlayMakedRunTimeRep(bpId, L_General.tc_inIntvl, " ஢  "+Math.Math, 0);
 END {CCMV1_ByMath};

 PUBLIC PROCEDURE CCMV5();
  CONST
   bpId = "CCMV5";
 BEGIN
  L_General.Assert(ACCESS(CarUnit), " ⠭ ॣ");
  RType:=rt_CarUnitCUC_OnDate;
  ccmv_Do(Memo.ud_cd(), Memo.ud_cd(), bpId);
  L_Basis.ExtPlayMakedRunTimeRep(bpId,
                                 CarUnit.CarUnit,
                                 L_General.tc_onDate,
                                 " ஢ ॣ "+CarUnit.CarUnit+" '"+CarUnit.Name+"'",
                                 0);
 END {CCMV5};

END.
