(*
%Copyright   (c) Polak IT
%Author      11.03.2004 17:26:54 POLAK\LDA
%Purpose     ᮪ , 襤/ॡ 宦 
%Type        report
%Specific    SYS
%Modified    18.07.2013 17:40:21 POLAK\LDA
%Environment
*)

 MODULE Checkup [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_OwnData, L_General, L_DatTim, L_AFM, L_Env, L_Str, Str, Memo,
        L_Car, P_Car, L_StdFrm, L_Excel;

 PRIVATE CONST
  cu_Done        = 0;
  cu_None        = 1;
  cu_NotRequired = 2;

 PRIVATE TYPE
  tCheckup = SCAL[3];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
?, C, ""
@
################################################################################################################################################################################# ########## #####
=#####============================================================================================================================================================================================
|################################################################################################################################################################################################|
|################################################################################################################################################################################################|
}
*)

(*
$P{ LineColumn:
Tmp.Column, L, ""
@
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| ##                                                                                                                                                                                      |
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|N  |.|. |ઠ              |VIN              |          | |-  ॣ樨|C|    |    |᪠ |⥫                           |  ஡|
|/|    |          |                   |                 |                    |.|       |    | |宦.|᫥.   |                     |                                   |      |
|---|----|----------|-------------------|-----------------|--------------------|----|------------|--------|-|--------|--------|---------------------|-----------------------------------|--------|
}
*)

(*
$P{ Line:
?, R, ""
Tmp.BoxNbr, L, ""
CarLog.StateNbr, L, ""
CarLog.Mark, L, ""
Mark.Name, L, ""
Tmp.VIN, L, ""
Tmp.ChassNum, L, ""
Tmp.ProdYear, L, "0"
Tmp.CertNum, L, ""
Tmp.CertDate, L, "D.N.Y"
CarLog.Status, L, "-||?"
Tmp.DocGiveD, L, "D.N.Y"
Tmp.DocExpD, L, "D.N.Y"
Tmp.DocAttr, L, ""
Tmp.DrvName, L, ""
Tmp.Run, R, "0"
@
|###|####|##########|#### ##############|#################|####################|####|############|########|#|########|########|#####################|###################################|########|
}
*)

(*
$P{ Bot:
@
=(c) Polak========================================================================================================================================================================================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "", "");

  CreateFIELD(Tmp, Column,   LIKE(Car.Column), "", "", "", "", "");
  CreateFIELD(Tmp, BoxNbr,   LIKE(Car.BoxNbr), "", "", "", "ࠦ", "");
  CreateFIELD(Tmp, VIN,      LIKE(VehPasp.VIN), "", "", "", "VIN", "");
  CreateFIELD(Tmp, ChassNum, LIKE(VehPasp.ChassNum), "", "", "", " ", "");
  CreateFIELD(Tmp, CertNum,  LIKE(VehPasp.CertNum), "", "", "", " ᢨ⥫⢠  ॣ樨", "");
  CreateFIELD(Tmp, ProdYear, NUMERIC[4,0], "", "", "", " ᪠", "");
  CreateFIELD(Tmp, CertDate, DATE, "", "", "", " ᢨ⥫⢠  ॣ樨", "");
  CreateFIELD(Tmp, DocGiveD, DATE, "", "", "", " 뤠", "");
  CreateFIELD(Tmp, DocExpD,  DATE, "", "", "", " 砭 ⢨ ", "");
  CreateFIELD(Tmp, DocAttr,  STRING[128], "", "", "", ", ,  뤠", "");
  CreateFIELD(Tmp, DrvName,  STRING[48], "", "", "", " ⥫", "");
  CreateFIELD(Tmp, Run,      NUMERIC[0], "", "", "", "஡", "");
  CreateINDEXandLINK(Tmp, BoxNbr, UNIQUE, Car, BoxNbr, USER, "", "", BoxNbr);
  CreateINDEX(Tmp, Column, UNIQUE, "", "", Column, BoxNbr);

  SetVersionOfFILE(Tmp, 0);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE PrintRep(BDate, EDate: DATE; RepName, RepTitle, RepPeriod: STRING[]);
  VAR
   LineNbr : NUMERIC[0];
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, RepTitle, RepPeriod);
  LineNbr:=0;
  SELECT(Tmp, Column);
  WHILE OCCURE(Tmp) DO
   NARROWSEL(Tmp, Column);
   MAKEPART(R, LineColumn);
   WHILE OCCURE(Tmp) DO
    PROMPT(" " + Tmp.BoxNbr);
    L_Car.AccessMark(Tmp.BoxNbr, EDate);
    L_Car.StandOnCarLog(Tmp.BoxNbr, EDate);
    INC(LineNbr);
    MAKEPART(R, Line, LineNbr);
    NEXT(Tmp);
   END; (* WHILE OCCURE(Tmp) ... *)
   NEXTINEXTENDEDSEL(Tmp, Column);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {PrintRep};

 PRIVATE PROCEDURE Checkup_ExcelTop(objWS: OBJECT);
  VAR
   CurRange: OBJECT;
 BEGIN
  PROMPT("ଫ ...");
  objWS.Cells.EntireColumn.NumberFormat:="@";
  objWS.Cells.EntireColumn.HorizontalAlignment:=L_Excel.xlCenter;
  objWS.Cells(1, 1).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Cells(1, 15).HorizontalAlignment:=L_Excel.xlRight;
  L_Excel.ws_Init(objWS);
  L_Excel.ws_WrStr(objWS, L_OwnData.ODFirmName(SYSDATE()));
  L_Excel.ws_SkipCols(objWS, 13);
  L_Excel.ws_WrStr(objWS, L_DatTim.CompleteSystimeStr());
  L_Excel.ws_TermLine(objWS);
  CurRange:=objWS.Range(objWS.Cells(2, 1), objWS.Cells(2, 15));
  CurRange.MergeCells:=L_Excel.xlTrue;
  CurRange.WrapText  :=L_Excel.xlTrue;
  CurRange.Value     :=Checkup_RepTitle;
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_StartHeader(objWS);
  L_Excel.ws_AddHeaderItem(objWS, " /", 4, 0);
  L_Excel.ws_AddHeaderItem(objWS, "ࠦ ", 9, 0);
  L_Excel.ws_AddHeaderItem(objWS, ".  ", 13, 0);
  L_Excel.ws_AddHeaderItem(objWS, "ઠ, ", 30, 0);
  L_Excel.ws_AddHeaderItem(objWS, "VIN", 20, 0);
  L_Excel.ws_AddHeaderItem(objWS, " ", 20, 0);
  L_Excel.ws_AddHeaderItem(objWS, " ᪠", 6, 0);
  L_Excel.ws_AddHeaderItem(objWS, " ᢨ.  ॣ. ", 12, 0);
  L_Excel.ws_AddHeaderItem(objWS, " 뤠 ᢨ", 10, 0);
  L_Excel.ws_AddHeaderItem(objWS, "C", 5, 0);
  L_Excel.ws_AddHeaderItem(objWS, " 宦", 10, 0);
  L_Excel.ws_AddHeaderItem(objWS, "᪠ ", 23, 0);
  L_Excel.ws_AddHeaderItem(objWS, " ᫥", 10, 0);
  L_Excel.ws_AddHeaderItem(objWS, "⥫", 35, 0);
  L_Excel.ws_AddHeaderItem(objWS, "஡ , ", 10, 0);
  L_Excel.ws_StopHeader(objWS);
  objWS.Cells.EntireColumn.NumberFormat:="@";
 END {Checkup_ExcelTop};

 PRIVATE PROCEDURE Checkup_ExcelLine(objWS: OBJECT; i: NUMERIC[0]);
 BEGIN
  L_Car.AccessMark(Tmp.BoxNbr, EDate);
  L_Car.StandOnCarLog(Tmp.BoxNbr, EDate);
  CONFORM(CarLog, Car);
  L_Excel.ws_WrNum(objWS, i);
  L_Excel.ws_WrScl(objWS, Tmp.BoxNbr);
  L_Excel.ws_WrStr(objWS, CarLog.StateNbr);
  L_Excel.ws_WrStr(objWS, Mark.Mark + " " + Mark.Name);
  L_Excel.ws_WrStr(objWS, Tmp.VIN);
  L_Excel.ws_WrStr(objWS, Tmp.ChassNum);
  L_Excel.ws_WrNum(objWS, Tmp.ProdYear);
  L_Excel.ws_WrStr(objWS, Tmp.CertNum);
  L_Excel.ws_WrDat(objWS, Tmp.CertDate);
  L_Excel.ws_WrStr(objWS, L_Str.PoolItem("-||?", CarLog.Status));
  L_Excel.ws_WrDat(objWS, Tmp.DocGiveD);
  L_Excel.ws_WrStr(objWS, Tmp.DocAttr);
  L_Excel.ws_WrDat(objWS, Tmp.DocExpD);
  L_Excel.ws_WrStr(objWS, Tmp.DrvName);
  L_Excel.ws_WrNum(objWS, Tmp.Run);
  L_Excel.ws_TermLine(objWS);
 END {Checkup_ExcelLine};

 PRIVATE PROCEDURE Checkup_ExcelBot(objWS: OBJECT);
 BEGIN
  L_Excel.ws_PaintGrid(objWS, L_Excel.xlThin, 0);
 END {Checkup_ExcelBot};

 PRIVATE PROCEDURE Checkup_MakeExcel(objWB: OBJECT);
  VAR
   objWS   : OBJECT;
   i    : NUMERIC[0];
 BEGIN
  L_General.Assert(SELECT(Tmp, BoxNbr), "   室饣  뢮   ");
  objWS:=L_Excel.NewWorksheet(objWB, 0, "᮪ ");
  Checkup_ExcelTop(objWS);
  i:=1;
  WHILE OCCURE(Tmp) DO
    PROMPT(" " + Tmp.BoxNbr);
    Checkup_ExcelLine(objWS, i);
    INC(i);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  Checkup_ExcelBot(objWS);
 END {Checkup_MakeExcel};

 PRIVATE PROCEDURE CheckUpNotRequired(): SCAL[2];
 BEGIN
  RETURN L_Str.PoolItem(P_Car.GetPool(P_Car.P_Checkup), 0) = CarPro.Value;
 END {CheckUpNotRequired};

 PRIVATE PROCEDURE AcceptableCar(BDate, EDate: DATE; RepType: tCheckup): SCAL[2];
 BEGIN
  IF L_Env.RealBoxNbr(Car.BoxNbr) &
     L_DatTim.IsActive(EDate, Car.BegDate, Car.EndDate) THEN
   IF    RepType = cu_Done THEN
    RETURN P_Car.HasActualCarPro(Car.BoxNbr, EDate, P_Car.P_Checkup) & ~CheckUpNotRequired();
   ELSIF RepType = cu_None THEN
    RETURN ~P_Car.HasActualCarPro(Car.BoxNbr, EDate, P_Car.P_Checkup) |
           L_DatTim.IsActive_Inc(CarPro.DocExpD, BDate, EDate);
   ELSIF RepType = cu_NotRequired THEN
    RETURN P_Car.HasActualCarPro(Car.BoxNbr, EDate, P_Car.P_Checkup) & CheckUpNotRequired();
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   RETURN 0;
  END;
 END {AcceptableCar};

 PRIVATE PROCEDURE MakeIndex(BDate, EDate: DATE; RepType: tCheckup);
 BEGIN
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(Car.BoxNbr);
   IF AcceptableCar(BDate, EDate, RepType) THEN
    L_Car.AccessVehPasp(Car.BoxNbr, EDate);
    DEFAULT(Tmp);
    Tmp.Column:=Car.Column;
    Tmp.BoxNbr:=Car.BoxNbr;
    IF OCCURE(VehPasp) THEN
     Tmp.VIN     :=VehPasp.VIN;
     Tmp.ChassNum:=VehPasp.ChassNum;
     Tmp.CertNum :=VehPasp.CertNum;
     Tmp.CertDate:=VehPasp.CertDate;
    END;
    Tmp.ProdYear:=L_DatTim.YEAR(L_Car.GetCarProdDate(Car.BoxNbr, EDate));
    IF OCCURE(CarPro) THEN
     Tmp.DocGiveD:=CarPro.DocGiveD;
     Tmp.DocExpD :=CarPro.DocExpD;
     Tmp.DocAttr :=Str.Condense(CarPro.DocNum + " " + CarPro.DocGiveS);
    END;
    IF L_Car.StandOnFirstMCFix_ByCar(Tmp.BoxNbr, SYSDATE()) THEN
     CONFORM(MCFix, Staff);
     CONFORM(Staff, Man);
     Tmp.DrvName:=Man.Name;
    END;
    Tmp.Run:=L_Car.GetGlobalRun(Tmp.BoxNbr, SYSDATE());
    INSERT(Tmp);
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {MakeIndex};

 PRIVATE VAR
  BDate, EDate    : DATE;
  Checkup_RepTitle: STRING[];

 PUBLIC PROCEDURE Checkup();
  CONST
   RepList = "᮪ 襤  |"+
             "᮪ ॡ 宦  ਮ|" +
             "᮪  ॡ 宦  ";
   RepTitle = ", 襤訥 孨᪨ ᬮ|" +
              ", ॡ騥 宦 孨᪮ ᬮ|" +
              ",  ॡ騥 宦 孨᪮ ᬮ";
  VAR
   RepType  : tCheckup;
   RepName,
   RepPeriod: STRING[];
   inExcel  : SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepType:=0;
  inExcel:=0;
  STDFORM("|      %39AI" +
          "||ଠ   %39<REP|Excel>I" +
          "||%< 믮 >D %< ⬥ >X",
          " 孨᪨ ᬮ ", INFORM, -1, RepList, RepType, inExcel);

  IF    RepType = cu_Done THEN
   BDate:=Memo.ud_cd();
   EDate:=Memo.ud_cd();
   RepName :="CUDon";
   RepPeriod:=" " + L_DatTim.DateStr(BDate);
  ELSIF RepType = cu_None THEN
   BDate:=Memo.ud_fr();
   EDate:=Memo.ud_ut();
   RepName :="CUNon";
   RepPeriod:=" ਮ  " + L_DatTim.DateStr(BDate) + "  " + L_DatTim.DateStr(EDate);
  ELSIF RepType = cu_NotRequired THEN
   BDate:=Memo.ud_cd();
   EDate:=Memo.ud_cd();
   RepName :="CUNRq";
   RepPeriod:=" " + L_DatTim.DateStr(BDate);
  END;

  Create_Tmp();
  MakeIndex(BDate, EDate, RepType);
  IF inExcel THEN
   Checkup_RepTitle:=L_Str.PoolItem(RepTitle, RepType) + " " + RepPeriod;
   L_Excel.MakeRep(PROCREF(Checkup_MakeExcel), RepName);
  ELSE
   PrintRep(BDate, EDate, RepName, L_Str.PoolItem(RepTitle, RepType), RepPeriod);
   L_General.SurveyLastReport();
  END;
 END {Checkup};

END.
