(*
%Copyright   (c) Polak Computer System
%Author      09.12.2010 14:29:35 POLAK\MLB
%Purpose     ஢ઠ    
%Type        report
%Specific    AP
%Modified    17.07.2013 13:08:52 POLAK\GAV
%Environment
*)

 MODULE CH_Firm [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, L_General, L_OwnData, L_DatTim, L_Str, L_Env, L_StdFrm, Memo, P_Firm, L_ctc;

 PRIVATE CONST
  RepName = "ChFrm";

 PRIVATE VAR
  RepTitle   : STRING[];
  RepTitleArr: STRING[][2];
  curFirm    : LIKE(Firm.Firm);
  numErr     : SCAL[1E2];

(*
$P{Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), R, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
RepTitleArr[0], C, ""
RepTitleArr[1], C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
}
*)

(*
$P{FirmPart:
Firm.Firm, R, ""
P_Firm.FP_FirmShortName(Firm.Firm, SYSDATE()), L, ""
@
|------------------------------------------------------------------------------------------------------------|
|#### #######################################################################################################|
}
*)

(*
$P{TopLine:
?, R, ""
?, L, ""
?, L, ""
@
|  ## ##################################### #################################################################|
}
*)

(*
$P{Line:
?, L, ""
@
|                                           #################################################################|
}
*)

(*
$P{Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE MakeLine(TitleStr, ErrorStr: STRING[]);
  VAR
   ErrorStrArray: STRING[][10];
   Idx          : NUMERIC[0];
 BEGIN
  IF Firm.Firm # curFirm THEN
   MAKEPART(R, FirmPart);
   curFirm:=Firm.Firm;
   numErr:=0;
  END;
  ErrorStr:=Str.Replace(ErrorStr, "|", " ");
  SETEMPTY(ErrorStrArray);
  INC(numErr);
  L_Str.SplitStr(ErrorStrArray, ErrorStr, 65, 10);
  Idx:=0;
  WHILE ~!ErrorStrArray[Idx] DO
   IF Idx = 0 THEN
    MAKEPART(R, TopLine, numErr, TitleStr, ErrorStrArray[Idx]);
   ELSE
    MAKEPART(R, Line, ErrorStrArray[Idx]);
   END;
   INC(Idx);
  END;
 END {MakeLine};

 PUBLIC PROCEDURE MakeRep();
  VAR
   FindAddr,
   SkipOldClosed,
   SkipOldCtcVal,
   SkipOldAdr    : SCAL[2];
   OldPool       : STRING[];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  SETZERO(SkipOldClosed, SkipOldCtcVal, SkipOldAdr);
  OldPool:="஢ | ஢   " + L_DatTim.DateStr(Memo.ud_cd());
  STDFORM(L_StdFrm.sf_Choice("%##########% %###################################%|" +
                             "|" +
                             "%##########% %###################################%|" +
                             "|" +
                             "%##########% %###################################%|",
                             "%<ࠣ:>T" +
                             "%<" + OldPool + ">I" +
                             "%<  :>T" +
                             "%<" + OldPool + ">I" +
                             "%<     :>T" +
                             "%<" + OldPool + ">I"),
          "஢ઠ    ࠣ⠬", , ,
          SkipOldClosed, SkipOldCtcVal, SkipOldAdr);
  RepTitle:="஡    ࠣ⠬";
  IF SkipOldClosed | SkipOldCtcVal | SkipOldAdr THEN
   RepTitle:=RepTitle + " (஬ ";
   IF SkipOldClosed & (SkipOldAdr | SkipOldCtcVal) THEN
    RepTitle:=RepTitle + " ᮢ / ४⮢   ࠣ⮢";
   ELSIF SkipOldClosed THEN
    RepTitle:=RepTitle + "";
   ELSE
    RepTitle:=RepTitle + " ᮢ / ४⮢";
   END;
   RepTitle:=RepTitle + "  " + L_DatTim.DateStr(Memo.ud_cd()) + ")";
  END;
  SETEMPTY(RepTitleArr);
  L_Str.SplitStr(RepTitleArr, RepTitle, 108, 2);


  SETEMPTY(curFirm);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  SELECT(Firm, Firm);
  WHILE OCCURE(Firm) DO
   PROMPT(Firm.Firm);
   WHILE OCCURE(Firm) & SkipOldClosed & (Firm.Till < Memo.ud_cd()) DO
    NEXT(Firm);
   END; (* WHILE OCCURE(Firm) ... *)
   IF OCCURE(Firm) & (Firm.Firm # P_Firm.mf_Fict) THEN
    FindAddr:=0;
    SELECT(FirmCtc, Firm, , Firm.Firm);
    WHILE OCCURE(FirmCtc) DO
     CONFORM(FirmCtc, Contact);

     SELECT(CtcAdr, Contact, , Contact.Contact);
     WHILE OCCURE(CtcAdr) DO
      FindAddr:=1;
      IF ~SkipOldAdr | (CtcAdr.Till > Memo.ud_cd()) THEN
       TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
        CALL(Contact.CtcAdr_OnAfterEdIns());
       EXCEPT
       ON Exc: Exc_Raise DO
        MakeLine(" " + FirmCtc.FirmCtc + ":  " + L_ctc.GetCtcAdrType_asStr(1) + " c " + L_DatTim.DateStr(CtcAdr.Begin),
                  Exc.Description);
       END; (* TRY *)
      END;
      NEXT(CtcAdr);
     END; (* WHILE OCCURE(CtcAdr) ... *)

     SELECT(CtcVal, Contact, , Contact.Contact);
     WHILE OCCURE(CtcVal) DO
      IF ~SkipOldCtcVal | (CtcVal.Till > Memo.ud_cd()) THEN
       IF ~L_DatTim.InPatIntvl(Contact.Begin, Contact.Till, CtcVal.Begin, CtcVal.Till) THEN
        MakeLine(" " + FirmCtc.FirmCtc + ": ४ ⠪ " + CtcVal.Value,
                 "ਮ ਬ ४ ⠪  室  ਮ ਬ ⠪ ( " +
                 L_DatTim.DateStr(Contact.Begin) + "  " + L_DatTim.DateStr(Contact.Till) + ")");
       END;
      END;
      NEXT(CtcVal);
     END; (* WHILE OCCURE(CtcVal) ... *)

     NEXT(FirmCtc);
    END; (* WHILE OCCURE(FirmCtc) ... *)
    IF ~FindAddr THEN
     MakeLine("", "    ");
    END;
   END;
   NEXT(Firm);
  END; (* WHILE OCCURE(Firm) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  LIKEMENU(Survey, "");
 END {MakeRep};

END.
