(*
%Copyright   (c) Polak Computer System
%Author      12.03.1996 13:13:31 SAN
%Purpose     ࠢ 䠪     ॣ 室
%Type        report
%Specific    AP
%Modified    10.07.2013 12:01:22 POLAK\Gina
%Environment
*)

 MODULE Cmp_FS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_Way, L_OwnData, L_AFM, Math, L_Str;

 TYPE
  tMismatch = SCAL[6];

 CONST
  Delta   = 10/60;

  tm_BeforeTheStart  = 0;
  tm_AfterTheStart   = 1;
  tm_Conflux         = 2;
  tm_Gap             = 3;
  tm_LessThenPlanned = 4;
  tm_MoreThenPlanned = 5;
  tm_OutInRWayS      = 6;
  tm_Pool = "堫 ࠭|堫 | |  ࠡ| |॥|⢨  ";

 VAR
  _Exit   : LIKE(StExit.Exit);
  _From   : NUMERIC[3];
  _Len    : NUMERIC[3];
  _EDay   : LIKE(RWayJ.Day);
  _EStartT: LIKE(RWayJ.StartT);
  _Fact   : NUMERIC[0];

(*
$P {Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Memo.ud_cd(), L, "D.N.y"
@
################################################################ ########## #####
=CmpFS===========================================================================
|              ᮮ⢥⢨    ᯨᠭ  ##########              |
|-------------------------------------------------------------------------------|
|室    |  ࠢ   |       | ६|      ||=|    1|    2|
|         |                  | ६|      | ६|     |<>|       |       |
|---------|------------------|--------|------|--------|-----|---|-------|-------|
}

$P {Line:
StExit.Exit, L, ""
?, L, tm_Pool
?, L, ""
?, L, "H:M"
?, R, "3."
?, L, ""
?, L, "H:M"
?, R, ""
?, L, "  | < | > "
?, L, ""
?, L, ""
@
|#########|##################|## #####|######|## #####|#####|###|#######|#######|
}

$P {Bot
@
=(c) Polak=======================================================================
}
*)

 PRIVATE PROCEDURE ExecFact(Exit: LIKE(StExit.Exit)): SCAL[3];
  VAR
   Fact,
   Plan : NUMERIC[0];
 BEGIN
  SAVE(RWJ);
  SAVE(SEJobs);

  Fact:=0;
  SELECT(RWJ, RWJ, , Exit);
  WHILE OCCURE(RWJ) DO
   INC(Fact, RWJ.Fact);
   NEXT(RWJ);
  END; (* WHILE OCCURE(RWJ) ... *)

  Plan:=0;
  SELECT(SEJobs, Exit, , Exit);
  WHILE OCCURE(SEJobs) DO
   IF ~IsNotWork() THEN
    INC(Plan);
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)

  RESTORE(RWJ);
  RESTORE(SEJobs);
  IF Fact=Plan THEN
   RETURN 0;
  ELSIF Fact<Plan THEN
   RETURN 1;
  ELSE
   RETURN 2;
  END;
 END {ExecFact};

 PRIVATE PROCEDURE Init_Exit();
 BEGIN
  _Exit:=StExit.Exit;
  _Fact:=0;
  IF StExit.Strict = L_Way.ExitStrict_Reg THEN
   _From   :=L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT);
   _Len    :=RWayJ.StopT-RWayJ.StartT;
   _EDay   :=RWayJ.Day;
   _EStartT:=RWayJ.StartT;
   IF ~IsNotWork() THEN
    _Fact:=RWayJ.Fact;
   END;
  ELSE
   SETEMPTY(_From);
   _Len    :=0;
  END;
 END {Init_Exit};

 PRIVATE PROCEDURE Store_Exit();
 BEGIN
  IF ~!_From THEN
   SAVE(RWayJ);
   SEARCH(RWayJ, RWayS, , RWayS.RWayS, _EDay, _EStartT);
   RWJ.Exit  :=_Exit;
   RWJ.From  :=_From;
   RWJ.Len   :=_Len;
   RWJ.RWayS := RWayJ.RWayS;
   RWJ.Day   := RWayJ.Day;
   RWJ.StartT:= RWayJ.StartT;
   RWJ.Fact  :=_Fact;
   INSERT(RWJ);
   RESTORE(RWayJ);
  END;
 END {Store_Exit};

 PRIVATE PROCEDURE NeedExit(): SCAL[2];
 BEGIN
  RETURN (StExit.Strict = L_Way.ExitStrict_Reg) &
         (L_Way._CheckExitOnDate(StExit.Exit, Memo.ud_cd()) = L_Way.exvld_Active);
 END {NeedExit};

 PRIVATE PROCEDURE MakePart(Mismatch  : tMismatch;
                            Day       : LIKE(RWayJ.Day);
                            BegIntvl  : TIME;
                            DuratIntvl: NUMERIC[3];
                            RWayS1,
                            RWayS2    : LIKE(RWayS.RWayS));
  VAR
   SEJobsDurat: NUMERIC[3];
   CntTrip    : NUMERIC[0];
   EndIntvl   : NUMERIC[3];
 BEGIN
  SAVE(SEJobs);
  SELECT(SEJobs, Exit, , StExit.Exit);
  SRCINSEL(SEJobs, GE, , Day, BegIntvl);
  SETZERO(SEJobsDurat, CntTrip);
  WHILE OCCURE(SEJobs) & (SEJobsDurat < DuratIntvl + Delta) DO
   CONFORM(SEJobs, WJMode);
   INC(CntTrip, WJMode.RunSel > L_Way.runsel_None);
   INC(SEJobsDurat, SEJobs.StopT-SEJobs.StartT);
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
  RESTORE(SEJobs);
  IF (Mismatch = tm_LessThenPlanned) | (Mismatch = tm_MoreThenPlanned) THEN
   MAKEPART(R, Line, Mismatch, "", EMPTYOF(TIME), DuratIntvl, EMPTYOF(EndIntvl), EMPTYOF(TIME),    CntTrip, ExecFact(StExit.Exit), RWayS1, RWayS2);
  ELSE
   EndIntvl:=(BegIntvl-00:00)+DuratIntvl;
   MAKEPART(R, Line, Mismatch, Day, BegIntvl,     DuratIntvl, AsDay(EndIntvl),   AsTime(EndIntvl), CntTrip, ExecFact(StExit.Exit), RWayS1, RWayS2);
  END;
 END {MakePart};

 PRIVATE PROCEDURE IsNotWork(): SCAL[2];
 BEGIN
  CONFORM(SEJobs, WJMode);
  RETURN ((WJMode.RunSel = L_Way.runsel_None) & (WJMode.WJType = L_Way.WJType_Void)) |
         ((WJMode.RunSel = L_Way.runsel_None) & (WJMode.WJType = L_Way.WJType_Work)) |
         ((WJMode.RunSel = L_Way.runsel_Zero) & (WJMode.WJType = L_Way.WJType_Work));
 END {IsNotWork};

 PRIVATE PROCEDURE NotWorkTime(Day             : LIKE(RWayJ.Day);
                               BegTime, EndTime: TIME;
                               VAR Beg, End    : NUMERIC[3][];
                               VAR i           : NUMERIC[0]): NUMERIC[3];
  VAR
   tmpInterval,
   Interval    : NUMERIC[3];
 BEGIN
  SETZERO(Beg, End);
  i:=0;
  SAVE(SEJobs);
  SELECT(SEJobs, Exit, , StExit.Exit);
  Interval:=0;
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, WJMode);
   IF IsNotWork() THEN
    tmpInterval:=Interval;
    INC(Interval, L_Way._TimeInt(L_Way.FullBegTime(SEJobs.Day, SEJobs.StartT),
                                 L_Way.FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT),
                                 L_Way.FullBegTime(Day, BegTime),
                                 L_Way.FullEndTime(Day, BegTime, EndTime)));
    IF tmpInterval # Interval THEN
     Beg[i]:=L_Way.FullBegTime(SEJobs.Day, SEJobs.StartT);
     End[i]:=L_Way.FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT);
     INC(i);
    END;
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
  RESTORE(SEJobs);
  RETURN Interval;
 END {NotWorkTime};

 PRIVATE PROCEDURE IsWorkBreak(Day             : LIKE(RWayJ.Day);
                               BegTime, EndTime: TIME;
                               VAR Beg, End    : NUMERIC[3][10];
                               VAR i           : NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN (EndTime - BegTime - NotWorkTime(Day , BegTime, EndTime, Beg, End, i)) > Delta;
 END {IsWorkBreak};

 PRIVATE PROCEDURE IsWorkDefect(BegTime, EndTime: NUMERIC[3]): SCAL[2];
  VAR
   Interval: NUMERIC[3];
 BEGIN
  Interval:=0;
  SAVE(SEJobs);
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, WJMode);
   IF IsNotWork() THEN
    INC(Interval, L_Way._TimeInt(L_Way.FullBegTime(SEJobs.Day, SEJobs.StartT),
                                 L_Way.FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT),
                                 BegTime,
                                 EndTime));
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) DO *)
  RESTORE(SEJobs);
  RETURN (EndTime-BegTime-Interval)>Delta;
 END {IsWorkDefect};

 PRIVATE PROCEDURE AsDay(Time: NUMERIC[3]): LIKE(RWayJ.Day);
 BEGIN
  RETURN Math.Div(Time, 24)+1;
 END {AsDay};

 PRIVATE PROCEDURE AsTime(Time: NUMERIC[3]): TIME;
 BEGIN
  RETURN 00:01 + Math.Mod(Time, 24);
 END {AsTime};

 PRIVATE PROCEDURE MakeParts(Mismatch    : tMismatch;
                             ProbTimeBeg,
                             ProbTimeEnd : NUMERIC[3];
                             BegNotWork,
                             EndNotWork  : NUMERIC[3][];
                             NumInt      : NUMERIC[0];
                             curRWayS,
                             prvRWayS    : LIKE(RWayJ.RWayS));
 VAR
  i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i<NumInt DO
   IF (BegNotWork[i]-ProbTimeBeg) > Delta THEN
    MakePart(Mismatch, AsDay(ProbTimeBeg), AsTime(ProbTimeBeg), BegNotWork[i]-ProbTimeBeg, curRWayS, prvRWayS);
   END;
   ProbTimeBeg:=EndNotWork[i];
   INC(i)
  END; (* WHILE i<NumInt DO *)
  IF ProbTimeBeg < ProbTimeEnd THEN
   MakePart(Mismatch, AsDay(ProbTimeBeg), AsTime(ProbTimeBeg), ProbTimeEnd-ProbTimeBeg, curRWayS, prvRWayS);
  END;
 END {MakeParts};

 PRIVATE PROCEDURE TestOneExit();
  VAR
    Beg, End    : NUMERIC[3][10];
    NumInt,
   _RWayS       : LIKE(RWayJ.RWayS);
   _Day         : LIKE(RWayJ.Day);
   _StartT,
   _StopT       : TIME;
   _UpTo        : NUMERIC[3];
   NeedStore    : SCAL[2];
   _FullEndTime,
   _FullBegTime,
   _FullIntvl   : NUMERIC[3];
 BEGIN
  IF SELECT(RWJ, RWJ, StExit.Exit) THEN
   SELECT(SEJobs, Exit, , StExit.Exit);
   _FullBegTime:=L_Way.FullBegTime(SEJobs.Day, SEJobs.StartT);
   IF    RWJ.From < (_FullBegTime - Delta) THEN
    MakePart(tm_BeforeTheStart,  RWJ.Day, RWJ.StartT, _FullBegTime-RWJ.From, RWJ.RWayS, "");
   ELSIF RWJ.From > (_FullBegTime + Delta) THEN
    IF IsWorkDefect(_FullBegTime, RWJ.From) THEN
     MakePart(tm_AfterTheStart, SEJobs.Day, SEJobs.StartT, RWJ.From-_FullBegTime, RWJ.RWayS, "");
    END;
   END;
   NeedStore:=1;
   LOOP
    _RWayS:=RWJ.RWayS;
    IF NeedStore THEN
     _Day   :=RWJ.Day;
     _StartT:=RWJ.StartT;
     _From  :=RWJ.From;
     _Len   :=RWJ.Len;
     _UpTo  :=_From + _Len;
    ELSE
     INC(_UpTo, RWJ.Len);
    END;
    IF NEXT(RWJ) THEN
     IF RWJ.From < (_UpTo-Delta) THEN
      NeedStore:=1;
      IF IsWorkBreak(RWJ.Day, RWJ.StartT, AsTime(_UpTo), Beg, End, NumInt) THEN
       MakeParts(tm_Conflux, RWJ.From, _UpTo, Beg, End, NumInt, _RWayS, RWJ.RWayS);
      END;
     ELSIF RWJ.From > (_UpTo+Delta) THEN
      NeedStore:=1;
      IF IsWorkBreak(AsDay(_UpTo), AsTime(_UpTo), RWJ.StartT, Beg, End, NumInt) THEN
       MakeParts(tm_Gap, _UpTo, RWJ.From, Beg, End, NumInt, _RWayS, RWJ.RWayS);
      END;
     ELSE
      NeedStore:=0;
     END;
    ELSE
     EXIT;
    END; (* IF OCCURE(RWJ) ... *)
   END; (* LOOP *)
   LAST(SEJobs);
   _FullEndTime:=L_Way.FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT);
   _FullIntvl  :=_FullEndTime - _FullBegTime;
   IF (_UpTo - _From) < (_FullIntvl - Delta) THEN
    IF IsWorkDefect(_UpTo, _FullEndTime) THEN
     MakePart(tm_LessThenPlanned, Math.Div(_UpTo, 24)+1, 00:00+Math.Mod(_UpTo, 24), _FullIntvl-(_UpTo - _From), _RWayS, "");
    END;
   ELSIF (_UpTo - _From) > (_FullIntvl + Delta) THEN
    MakePart(tm_MoreThenPlanned, SEJobs.Day+(SEJobs.StopT < SEJobs.StartT), SEJobs.StopT, _UpTo - _From-_FullIntvl, _RWayS, "");
   END;
  ELSE
   MAKEPART(R, Line, tm_OutInRWayS);
  END; (* IF SELECT(RWJ... *)
 END {TestOneExit};

 PRIVATE PROCEDURE GatherRWayJ();
 BEGIN
  L_Way.CheckTaxed(Memo.ud_cd(), Memo.ud_cd());
  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated, Memo.ud_cd());
  WHILE OCCURE(RWayS) DO
   PROMPT("  : " + RWayS.RWayS);
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   SETEMPTY(_Exit);
   WHILE OCCURE(RWayJ) DO
    CONFORM(RWayJ, SEJobs, StExit);
    IF !_Exit THEN
     Init_Exit();
    ELSIF (_Exit # StExit.Exit) | IsNotWork() THEN
     Store_Exit();
     Init_Exit();
    ELSE
     INC(_Len, RWayJ.StopT-RWayJ.StartT);
     IF ~IsNotWork() THEN
      INC(_Fact, RWayJ.Fact);
     END;
    END;
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
   Store_Exit();
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {GatherRWayJ};

 PUBLIC PROCEDURE Cmp_FS();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
 
  SEARCH(Calendar, Date, , Memo.ud_cd());
 
  L_AFM.MakeIndex("RWJ", "Exit  : LIKE(StExit.Exit);"+
                         "From  : NUMERIC[3];"+
                         "Len   : NUMERIC[3];"+
                         "RWayS : LIKE(RWayJ.RWayS);"+
                         "Day   : LIKE(RWayJ.Day);"+
                         "StartT: LIKE(RWayJ.StartT);"+
                         "Fact  : NUMERIC[0]");
  GatherRWayJ();
 
  OPENREP(R, L_General.NameConnection("CmpFS"), Create);
 
  MAKEPART(R, Top);
 
  SELECT(StExit, Exit);
  WHILE OCCURE(StExit) DO
   PROMPT("ઠ : 室 " + StExit.Exit);
   IF NeedExit() THEN
    TestOneExit();
   END;
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit) ... *)
 
  MAKEPART(R, Bot);
  L_AFM.AF_PurgeTemp("RWJ");
  L_General.SurveyLastReport();
 END {Cmp_FS};

END.
