(*
%Copyright   (c) Polak Computer System
%Author      27.11.2000 11:19:44 SAN
%Purpose     ନ஢    㯮/த
%Type        report
%Specific    SYS
%Modified    16.06.2014 11:52:00 POLAK\Bor
%Environment
*)

 MODULE CPrch [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_Str, FIO, Str, L_Basis, P_MDoc, L_Pmnt,
        L_MDoc, L_Cntr, P_Cntr, P_Firm, L_bp;

 TYPE
  tRepName = STRING[];

 CONST
  ds_All     = 0;
  ds_Outside = 1;
  ds_Inside  = 2;
  dsPool = "|쪮 譨|쪮 ७";

  dt_All     = 0;
  dt_Real    = 1;
  dt_Debit   = 2;
  dt_Credit  = 3;
  dtPool = "|쭮 |室|室";

  rn_MD001 = "MD001";
  rn_MD002 = "MD002";
  rn_MD004 = "MD004";
  rn_MS001 = "MS001";

 VAR
  RepName: tRepName;
  wMF    : SCAL[2];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, " ꥪ⠊");
  L_Basis.wb_WrInQM(F, " ꥪ");
  L_Basis.wb_WrInQM(F, " 㬥⠊");
  L_Basis.wb_WrInQM(F, " 㬥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室 ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室 ");
  L_Basis.wb_WrInQM(F, "ﭨ 㬥");
  L_Basis.wb_WrInQM(F, "訫");
  L_Basis.wb_WrInQM(F, "訫");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "儠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "஢");
  L_Basis.wb_WrInQM(F, "७");
  L_Basis.wb_WrInQM(F, " ࠊ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ਬ砭");
  L_Basis.wb_WrInQM(F, " 㬬");
  L_Basis.wb_WrInQM(F, "");

  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
  VAR
   curDescriptionOfGoods: STRING[];
   curDocType           : STRING[];
   curDocDate           : DATE;
   curDocSerAndNum      : STRING[];
 BEGIN
  CONFORM(MDoc, MyFirm);
  CONFORM(MDoc, Alower);
  CONFORM(MDoc, Dest);
  CONFORM(MDoc, Firm);
  CONFORM(MDoc, Staff);
  CONFORM(Staff, Man);
  CONFORM(Math, MathType);
  CONFORM(MDoc, Contract);
  CONFORM(Contract, CntrT);

  IF wMF THEN
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Dest.Dest);
  L_Basis.wb_WrStr(F, Dest.Name);

  L_Basis.wb_WrScl(F, MathType.MathType);
  L_Basis.wb_WrStr(F, MathType.Name);

  L_Basis.wb_WrScl(F, MDoc.MDocKind);
  L_Basis.wb_WrStr(F, L_MDoc.MDocKindNick(MDoc.MDocKind, 1));
  L_Basis.wb_WrScl(F, MDoc.MDoc);
  L_Basis.wb_WrStr(F, MDoc.SrcNbr);
  L_Basis.wb_WrDat(F, MDoc.Date);
  L_Basis.wb_WrDat(F, MDoc.SrcDate);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_MDoc.st_Pool, MDoc.Status));
  IF OCCURE(Alower) THEN
   L_Basis.wb_WrScl(F, Alower.Alower);
   L_Basis.wb_WrStr(F, Alower.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrScl(F, Firm.Firm);
  L_Basis.wb_WrStr(F, Firm.Name);

  L_Basis.wb_WrScl(F, Contract.Contract);
  L_Basis.wb_WrStr(F, Contract.Name);
  L_Basis.wb_WrStr(F, Contract.SrcNbr);
  L_Basis.wb_WrDat(F, Contract.SrcDate);
  L_Basis.wb_WrStr(F, L_Cntr.GetContractType_asStr());
  curDescriptionOfGoods:=P_Cntr.ppi_DescriptionOfGoods(Contract.Contract, MDoc.Date);
  IF !curDescriptionOfGoods THEN
   curDescriptionOfGoods:=Contract.Name;
  END;
  L_Basis.wb_WrStr(F, curDescriptionOfGoods);
  L_Basis.wb_WrStr(F, GetOwnAgentDocInfo(Contract.Contract, Math.Max(Contract.SrcDate, Contract.Begin)));
  L_Basis.wb_WrScl(F, CntrT.CntrT);
  L_Basis.wb_WrStr(F, CntrT.Name);
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);

  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, P_MDoc.GetMDocProSoft(MDoc.MDocKind,MDoc.MDoc, P_MDoc.P_Note));
  L_Basis.wb_WrNum(F, MDocList.Sum+MDocList.VAT, 2);
  L_Basis.wb_WrNum(F, MDocList.VAT, 2);

  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE GetOwnAgentDocInfo(trgContract: LIKE(Contract.Contract); D: DATE): STRING[];
  VAR
   curTSN     : LIKE(Staff.TSN);
   curDocType,
   curDocSer,
   curDocNum,
   curDocGiveS: STRING[];
   curDocGiveD,
   curDocExpD : DATE;
   curCntrSum : NUMERIC[2];
   Result     : STRING[];
 BEGIN
  P_Cntr.Get_FullOwnAgentInfo(trgContract, D, curTSN, curDocType, curDocSer, curDocNum, curDocGiveS, curDocGiveD, curDocExpD, curCntrSum);
  Result:=Str.Condense(curDocSer+" "+curDocNum);
  IF ~!curDocGiveD THEN
   Result:=Str.Condense(Result+"  "+L_DatTim.DateStr(curDocGiveD));
  END;
  IF !Result THEN
   Result:="-";
  END;
  RETURN Result;
 END {GetOwnAgentDocInfo};

 PRIVATE PROCEDURE intCPrch();
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  wMF:=P_Firm.E_wMultipleMyFirm(Memo.ud_ut());
  MakeHeader("R");
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF L_MDoc.IsPrchMDocKind() & L_Pmnt.IsAcptMDocKind(MDocKind.MDocKind) THEN
    SAVE(MDocKind);
    SETSEL(MDoc, MDKDate, MDocKind.MDocKind);
    SRCINSEL(MDoc, GE, , Memo.ud_fr());
    WHILE OCCURE(MDoc) & (MDoc.Date <= Memo.ud_ut()) DO
     PROMPT(L_MDoc.GetMDocStrNbr());
     IF (MDoc.Status = L_MDoc.st_Passed) &
        (!MDoc.Contract | ~P_Cntr.GetInHouse(MDoc.Contract, MDoc.Date)) THEN
      CONFORM(MDoc, MDocList);
      WHILE OCCURE(MDocList) DO
       CONFORM(MDocList, Math);
       MakePart("R");
       NEXT(MDocList);
      END; (* WHILE OCCURE(MDocList) ... *)
     END; (* IF MDoc.Status ... *)
     NEXT(MDoc);
    END; (* WHILE OCCURE(MDoc) ... *)
    RESTORE(MDocKind);
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
 END {intCPrch};

 PUBLIC PROCEDURE CPrch();
  CONST
   bpId = "CPrch";
 BEGIN
  L_bp.Begin(bpId, "㯪  ()", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  intCPrch();
  FIO.Close(R);
  L_bp.End();
 END {CPrch};

END.
