(*
%Copyright   (c) Polak Computer System
%Author      11.09.2002 18:39:48 POLAK\LDA
%Purpose       ॣ⮢  
%Type        report
%Specific    AP
%Modified    23.10.2013 20:22:39 POLAK\LDA
%Environment
*)

 MODULE CURst [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_OwnData, L_General, L_MathR, L_AFM, L_Basis, L_Str, P_Math, FIO,
        L_XObj, L_CUC, L_Stock, L_bp, L_DatTim;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                                       ⪨ ॣ⮢  ##########                                      |
}
*)

(*
$P{ CarUnit:
CarUnit.CarUnit, L, ""
CarUnit.Name, L, ""
@
| #### ################################################                                                      |
}
*)

(*
$P{ AcCut_1:
AcCut.AcCut, L, ""
AcCut.Name, L, ""
Storage.Storage, L, ""
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|१     ### #####################################  ####### ############################################|
}
*)

(*
$P{ AcCut_2:
Contract.Contract, L, ""
Contract.Name, L, ""
Firm.Firm, L, ""
Firm.Name, L, ""
@
|    ####### #########################################################################################|
|ࠣ #### ############################################################################################|
}
*)

(*
$P{ AcCut_3:
@
|------------------------------------------------------------------------------------------------------------|
|  |                    |  ⠫|⮢⥫                           |      ⮪|
|-----|--------------------------------|---------------|---------------------------------------|-------------|
}
*)

(*
$P{ Line:
Math.Math, L, ""
Math.Name, L, ""
Math.UnitedC, L, ""
Vendor.Name, L, ""
L_MathR.DefaultFormatCir(Tmp.Math, Tmp.Rest), R, ""
@
|#####|################################|###############|#######################################|#############|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE MakeExcelTop();
 BEGIN
  L_Basis.wb_WrStr("F", "ॣ");
  L_Basis.wb_WrStr("F", "ॣ");
  L_Basis.wb_WrStr("F", "१");
  L_Basis.wb_WrStr("F", "१");
  L_Basis.wb_WrStr("F", "⮕࠭");
  L_Basis.wb_WrStr("F", "⮕࠭");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "ࠣ");
  L_Basis.wb_WrStr("F", "ࠣ");
  L_Basis.wb_WrStr("F", "_");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "_");
  L_Basis.wb_WrStr("F", "  ⠫");
  L_Basis.wb_WrStr("F", "⮢⥫");
  L_Basis.wb_WrStr("F", "⮪");
  L_Basis.wb_WrStr("F", "_⮪");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "᪮ ");
  L_Basis.wb_WrStr("F", "ﭨ");
  L_Basis.wb_TermLine("F");
 END {MakeExcelTop};

 PRIVATE PROCEDURE StandOnContractByStorage(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF Storage.Type = L_Stock.st_Contract THEN
   IF SELECT(Contract, Storage, Storage.Storage) THEN
    Result:=1;
    CONFORM(Contract, Firm);
    SAVE(Contract);
    L_General.CallUs(~NEXT(Contract));
    RESTORE(Contract);
   END;
  END;
  RETURN Result;
 END {StandOnContractByStorage};

 PRIVATE PROCEDURE MakeExcelLine(IsCUCopy: SCAL[2]; OnDate: DATE);
 BEGIN
  L_Basis.wb_WrScl("F", CarUnit.CarUnit);
  L_Basis.wb_WrStr("F", CarUnit.Name);
  IF IsCUCopy | !Tmp.AcCut THEN
   L_Basis.wb_WrScl("F", "---");
   L_Basis.wb_WrStr("F", "---");
  ELSE
   L_Basis.wb_WrScl("F", AcCut.AcCut);
   L_Basis.wb_WrStr("F", AcCut.Name);
  END;
  IF ~IsCUCopy & !Tmp.Storage | ~OCCURE(Storage) THEN
   L_Basis.wb_WrScl("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrScl("F", "---");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrScl("F", "---");
   L_Basis.wb_WrStr("F", "---");
  ELSE
   L_Basis.wb_WrScl("F", Storage.Storage);
   L_Basis.wb_WrStr("F", Storage.Name);
   IF StandOnContractByStorage() THEN
    L_Basis.wb_WrScl("F", Contract.Contract);
    L_Basis.wb_WrStr("F", Contract.Name);
    L_Basis.wb_WrScl("F", Firm.Firm);
    L_Basis.wb_WrStr("F", Firm.Name);
   ELSE
    L_Basis.wb_WrScl("F", "---");
    L_Basis.wb_WrStr("F", "---");
    L_Basis.wb_WrScl("F", "---");
    L_Basis.wb_WrStr("F", "---");
   END;
  END;
  L_Basis.wb_WrScl("F", Math.Math);
  L_Basis.wb_WrStr("F", Math.Name);
  L_Basis.wb_WrStr("F", L_MathR.DefaultMUnitSign(Math.Math));
  L_Basis.wb_WrStr("F", Math.UnitedC);
  L_Basis.wb_WrStr("F", Vendor.Name);
  IF IsCUCopy THEN
   L_Basis.wb_WrNum("F", 0, 3);
   L_Basis.wb_WrNum("F", 0, 3);
   L_Basis.wb_WrStr("F", CUCopy.CUCopy);
   L_Basis.wb_WrStr("F", CUCopy.Serial);
   L_Basis.wb_WrStr("F", L_Str.PoolItem(L_CUC.cnd_Pool, L_CUC.GetLastCUCondition(CUCopy.CUCopy)));
  ELSE
   L_Basis.wb_WrNum("F", Tmp.Rest,    3);
   L_Basis.wb_WrNum("F", Tmp.MinRmnd, 3);
   L_Basis.wb_WrStr("F", "-----");
   L_Basis.wb_WrStr("F", "-----");
   L_Basis.wb_WrStr("F", "---");
  END;

  L_Basis.wb_TermLine("F");
 END {MakeExcelLine};

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CREATE_TABLE(Tmp);

  CREATE_FIELD(Tmp, CarUnit,  LIKE(CarUnit.CarUnit), , , , "ॣ");
  CREATE_FIELD(Tmp, AcCut,    LIKE(AcCut.AcCut),     , , , "१");
  CREATE_FIELD(Tmp, Storage,  LIKE(Storage.Storage), , , , "");
  CREATE_FIELD(Tmp, Math,     LIKE(Math.Math),       , , , "");
  CREATE_FIELD(Tmp, MathName, LIKE(Math.Name),       , , , " ");
  CREATE_FIELD(Tmp, MinRmnd,  L_XObj.tQnt,           , , , " ⮪");
  CREATE_FIELD(Tmp, Rest,     L_XObj.tQnt,           , "0", , "⮪");

  CREATE_INDEX_AND_LINK(Tmp, CarUnit, UNIQUE, CarUnit, CarUnit, USER, , , CarUnit, AcCut, Storage, MathName, Math, MinRmnd);
  CREATE_INDEX_AND_LINK(Tmp, Storage, PLURAL, Storage, Storage, USER, , , Storage);
  CREATE_INDEX_AND_LINK(Tmp, AcCut,   PLURAL, AcCut,   AcCut,   USER, , , AcCut);
  CREATE_INDEX_AND_LINK(Tmp, Math,    PLURAL, Math,    Math,    USER, , , Math);
  CREATE_INDEX         (Tmp, Tmp,     PLURAL, , ,                         CarUnit, Math);

  SET_VERSION_OF_TABLE(Tmp, 0);
  L_AFM.CreateTemp("Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE MakeIndex(OnDate: DATE; InExcel: SCAL[2]);
  VAR
   i   : NUMERIC[0];
   P   : DATE;
   macc: L_MathR.tMathAcCutCollection;
   MinRmnd,
   TotalMinRmnd,
   rest: L_XObj.tQnt;
 BEGIN
  APP.Get().NewPrompt("⮢");
  P:=L_DatTim.NextPer(OnDate);
  Create_Tmp();
  IF InExcel THEN
   SELECT(CarUnit, CarUnit);
  ELSE
   SELECT(CarUnit, CarUnit, , CarUnit.CarUnit);
  END;
  WHILE OCCURE(CarUnit) DO
   IF SELECT(Math, MCarUnit, L_MathR.mathk_Math, CarUnit.CarUnit) THEN
    WHILE OCCURE(Math) DO
     PROMPT("ॣ " + Math.CarUnit + ",  " + Math.Math);
     IF Math.Leaf THEN
      SELECT(mItem, Math, , Math.Math);
      WHILE OCCURE(mItem) DO
       CONFORM(mItem, Storage);
       CONFORM(mItem, XObject);
       IF Storage.Type # L_Stock.st_AdvHolder THEN
        MinRmnd:=P_Math.GetStorageMinRemainder(Math.Math, OnDate, Storage.Storage);

        macc:=L_MathR.GetXObjectAcCutCollection(mItem.XObject);
        i:=0;
        WHILE ~!macc[i] DO
         IF L_MathR.AcCutOfRealStock(macc[i]) THEN
          rest:=L_XObj.qo_GetInSaldo(macc[i], P);
          IF (rest > 0) | (InExcel & (Math.Till > OnDate)) THEN
           ADD(Tmp, CarUnit, , CarUnit.CarUnit, macc[i], Storage.Storage, Math.Name, Math.Math, MinRmnd,
               Tmp.Rest, rest);
          END;
         END;
         INC(i);
        END (* WHILE ~!macc[i] *);
       END;
       NEXT(mItem);
      END (* WHILE OCCURE(mItem) *);

      IF InExcel THEN
       TotalMinRmnd:=P_Math.GetMinRemainder(Math.Math, OnDate);
       IF (TotalMinRmnd>0) & SELECT(Tmp, Math, Math.Math) THEN
        ADD(Tmp, CarUnit, , CarUnit.CarUnit, EMPTYOF(AcCut.AcCut), EMPTYOF(Storage.Storage),
                            Math.Name, Math.Math, TotalMinRmnd);
       END;
      END;
     END;
     NEXT(Math);
    END; (* WHILE OCCURE(Math) ... *)
   END;
   NEXT(CarUnit);
  END; (* WHILE OCCURE(CarUnit) ... *)
 END {MakeIndex};

 PUBLIC PROCEDURE CURs1();
  CONST
   RepName = "CURs1";
  VAR
   OnDate: DATE;
 BEGIN
  APP.Get().NewPrompt("("+RepName+")");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(CarUnit), " ⠭ ⥪騩 ॣ");
  OnDate:=SYSDATE()+1;
  MakeIndex(OnDate, 0);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, OnDate);

  SELECT(Tmp, CarUnit);
  WHILE OCCURE(Tmp) DO
   NARROWSEL(Tmp, CarUnit);
   CONFORM(Tmp, CarUnit);
   MAKEPART(R, CarUnit);
   WHILE OCCURE(Tmp) DO
    NARROWSEL(Tmp, AcCut, Storage);
    CONFORM(Tmp, AcCut);
    CONFORM(Tmp, Storage);
    IF StandOnContractByStorage() THEN
     MAKEPART(R, AcCut_1, "");
     MAKEPART(R, AcCut_2);
    ELSE
     MAKEPART(R, AcCut_1, Storage.Name);
    END;
    MAKEPART(R, AcCut_3);
    WHILE OCCURE(Tmp) DO
     PROMPT(".  " + Tmp.Math + ", ࠧ१ " + Tmp.AcCut);
     CONFORM(Tmp, Math);
     CONFORM(Math, Vendor);
     MAKEPART(R, Line);
     NEXT(Tmp);
    END; (* WHILE OCCURE(Tmp) ... *)
    NEXTINEXTENDEDSEL(Tmp, AcCut, Storage);
   END; (* WHILE OCCURE(Tmp) ... *)
   NEXTINEXTENDEDSEL(Tmp, CarUnit);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, Bot);
 END {CURs1};

 PUBLIC PROCEDURE CURst();
  CONST
   bpId = "CURst";
  VAR
   OnDate : DATE;
   trgMath: LIKE(Math.Math);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "⪨ ஢   ", L_bp.t_Basis, L_General.tc_onMonthEnd);
  OnDate:=Memo.ud_cd();
  MakeIndex(OnDate, 1);

  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  MakeExcelTop();
  SELECT(Tmp, Tmp);
  WHILE OCCURE(Tmp) DO
   NARROWSEL(Tmp, CarUnit);
   CONFORM(Tmp, CarUnit);
   IF CarUnit.SNDate <= OnDate THEN
    WHILE OCCURE(Tmp) DO
     NARROWSEL(Tmp, Math);
     trgMath:=Tmp.Math;
     WHILE OCCURE(Tmp) DO
      PROMPT(".  " + Tmp.Math);
      CONFORM(Tmp, CarUnit);
      CONFORM(Tmp, AcCut);
      CONFORM(Tmp, Storage);
      CONFORM(Tmp, Math);
      CONFORM(Math, Vendor);
      MakeExcelLine(0, OnDate);
      NEXT(Tmp);
     END; (* WHILE OCCURE(Tmp) ... *)

     SEARCH(Math, Math, , trgMath);
     SETSEL(CUCopy, Math, trgMath);
     SRCINSEL(CUCopy, GT, , OnDate);
     WHILE OCCURE(CUCopy) DO
      PROMPT(".  " + trgMath + ",  " + CUCopy.CUCopy);
      IF L_CUC.AccessMDocLCU(CUCopy.CUCopy, OnDate) & L_CUC.IsCUAtStock(MDocLCU.OpKind) THEN
       SEARCH(Storage, Storage, , L_CUC.GetCurMDocLCUStorage());
       MakeExcelLine(1, OnDate);
      END;
      NEXT(CUCopy);
     END; (* WHILE OCCURE(CUCopy) ... *)

     NEXTINEXTENDEDSEL(Tmp, Math);
    END; (* WHILE OCCURE(Tmp) ... *)
   END;
   NEXTINEXTENDEDSEL(Tmp, CarUnit);
  END; (* WHILE OCCURE(Tmp) ... *)
  FIO.Close(F);
  L_bp.End();
 END {CURst};

END.
