(*
%Copyright   (c) Polak IT
%Author      27.05.2004 13:46:17 POLAK\LDA
%Purpose
%Type        report
%Specific    LOC
%Modified    06.12.2013 13:45:38 POLAK\LDA
%Environment
*)

 MODULE CWO01 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_CWOrder, L_Car, L_Str, L_Basis, P_Firm, P_Mark, FIO, Memo, L_MDoc, L_bp;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "_");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, "⠪⭮ ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⠍_");
  L_Basis.wb_WrInQM(F, "⠎_");
  L_Basis.wb_WrInQM(F, "㫥६");
  L_Basis.wb_WrInQM(F, "ᠦᥣ");
  L_Basis.wb_WrInQM(F, "ᠦ넥");
  L_Basis.wb_WrInQM(F, "客_");
  L_Basis.wb_WrInQM(F, "஡_");
  L_Basis.wb_WrInQM(F, "㬬_");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "祭");
  L_Basis.wb_WrInQM(F, "=");
  L_Basis.wb_WrInQM(F, "Ꮾ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "਩");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "፮");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "६_");
  L_Basis.wb_WrInQM(F, "஡_");
  L_Basis.wb_WrInQM(F, "㬬_");
  L_Basis.wb_WrInQM(F, "_");
  L_Basis.wb_WrInQM(F, "客_");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६_");
  L_Basis.wb_WrInQM(F, "६_");
  L_Basis.wb_WrInQM(F, "६_");
  L_Basis.wb_WrInQM(F, "६_");
  L_Basis.wb_WrInQM(F, "६륧_");
  L_Basis.wb_WrInQM(F, "६_");
  L_Basis.wb_WrInQM(F, "६륧");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "稢६_");
  L_Basis.wb_WrInQM(F, "稢६_");
  L_Basis.wb_WrInQM(F, "⥫ ");
  L_Basis.wb_WrInQM(F, "⥫ ");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakeLine(F: STRING[]);
  VAR
   _PsgAmnt : NUMERIC[0];
   _Math    : LIKE(Math.Math);
   _MathName: LIKE(Math.Name);
   _RWayS   : LIKE(RWayS.RWayS);
   _BoxNbr  : LIKE(Car.BoxNbr);
   _StateNbr: LIKE(CarLog.StateNbr);
   _Column  : LIKE(CarLog.Column);
   _Mark    : LIKE(Mark.Mark);
   _MarkName: LIKE(Mark.Name);
   _TSN     : LIKE(Staff.TSN);
   _Name    : LIKE(Man.Name);
 BEGIN
  IF ~!CWOrder.RWayS THEN
   CONFORM(CWOrder, RWayS);
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
   IF CWOrder.p_PsgAm = 0 THEN
    _PsgAmnt:=P_Mark.GetP_PVSitting(Mark.Mark, CWOrder.Date);
   ELSE
    _PsgAmnt:=CWOrder.p_PsgAm;
   END;
   _RWayS   :=RWayS.RWayS;
   _BoxNbr  :=RWayS.BoxNbr;
   _StateNbr:=CarLog.StateNbr;
   _Mark    :=Mark.Mark;
   _MarkName:=Mark.Name;
   _Column  :=CarLog.Column;
   _TSN     :=RWayS.TSN;
   CONFORM(RWayS, Staff, Man);
   _Name    :=Man.Name;
  ELSE
   SETEMPTY(_RWayS, _BoxNbr, _StateNbr, _Mark, _MarkName, _Column, _TSN, _Name);
   _PsgAmnt:=CWOrder.p_PsgAm;
  END;
  IF ~!CWOrder.Math THEN
   CONFORM(CWOrder, Math);
   _Math    :=CWOrder.Math;
   _MathName:=Math.Name;
  ELSE
   SETEMPTY(_Math, _MathName);
  END;
  CONFORM(CWOrder, Contract);

  L_Basis.wb_WrScl(F, CWOrder.CWOrder);
  L_Basis.wb_WrDat(F, CWOrder.Date);
  L_Basis.wb_WrScl(F, CWOrder.Contract);
  L_Basis.wb_WrStr(F, Contract.Name);
  L_Basis.wb_WrScl(F, Contract.Firm);
  L_Basis.wb_WrStr(F, P_Firm.FP_FirmName(Contract.Firm, CWOrder.Date));
  L_Basis.wb_WrStr(F, CWOrder.ContactP);
  L_Basis.wb_WrScl(F, _Math);
  L_Basis.wb_WrStr(F, _MathName);
  L_Basis.wb_WrDat(F, CWOrder.p_BDate);
  L_Basis.wb_WrDat(F, CWOrder.p_EDate);
  L_Basis.wb_WrNum(F, CWOrder.p_ZTDept + CWOrder.p_ZTRet, 2);
  L_Basis.wb_WrNum(F, _PsgAmnt, 0);
  L_Basis.wb_WrNum(F, CWOrder.p_ChlAm, 0);
  L_Basis.wb_WrNum(F, CWOrder.p_IPSum, 2);
  L_Basis.wb_WrNum(F, CWOrder.p_Run, 0);
  L_Basis.wb_WrNum(F, CWOrder.p_Sum, 2);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_CWOrder.ct_Pool, CWOrder.CalcType));
  L_Basis.wb_WrNum(F, CWOrder.CalcVal, 2);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", CWOrder.FixPlnSm));
  L_Basis.wb_WrStr(F, CWOrder.Adress);
  L_Basis.wb_WrStr(F, CWOrder.RouteDsc);
  L_Basis.wb_WrStr(F, CWOrder.Comment);
  L_Basis.wb_WrScl(F, _RWayS);
  L_Basis.wb_WrScl(F, _BoxNbr);
  L_Basis.wb_WrStr(F, _StateNbr);
  L_Basis.wb_WrScl(F, _Column);
  L_Basis.wb_WrScl(F, _Mark);
  L_Basis.wb_WrStr(F, _MarkName);
  IF ~!CWOrder.DeptDate & ~!CWOrder.DeptTime & ~!CWOrder.RetDate  & ~!CWOrder.RetTime THEN
   L_Basis.wb_WrNum(F, L_CWOrder.GetCWOrderDuration(CWOrder.Date, CWOrder.DeptDate, CWOrder.DeptTime, CWOrder.RetDate, CWOrder.RetTime, CWOrder.DcrTim), 3);
  ELSE
   L_Basis.wb_WrNum(F, 0, 3);
  END;
  IF ~!CWOrder.RetSM & ~!CWOrder.DeptSM THEN
   L_Basis.wb_WrNum(F, CWOrder.RetSM - CWOrder.DeptSM, 0);
  ELSE
   L_Basis.wb_WrNum(F, 0, 0);
  END;
  L_Basis.wb_WrNum(F, CWOrder.Sum, 2);
  L_Basis.wb_WrNum(F, CWOrder.VAT, 2);
  L_Basis.wb_WrNum(F, CWOrder.IPSum, 2);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("||", CWOrder.Status));
  L_Basis.wb_WrTim(F, CWOrder.p_BTime);
  L_Basis.wb_WrTim(F, CWOrder.p_ETime);
  L_Basis.wb_WrTim(F, CWOrder.ArrTime);
  L_Basis.wb_WrTim(F, CWOrder.FallTime);
  L_Basis.wb_WrTim(F, CWOrder.p_DeptT);
  L_Basis.wb_WrTim(F, CWOrder.p_RetT);
  L_Basis.wb_WrTim(F, CWOrder.DeptTime);
  L_Basis.wb_WrTim(F, CWOrder.RetTime);
  L_Basis.wb_WrNum(F, CWOrder.p_DcrTim, 2);
  L_Basis.wb_WrNum(F, CWOrder.DcrTim, 2);
  L_Basis.wb_WrScl(F, _TSN);
  L_Basis.wb_WrStr(F, _Name);
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PUBLIC PROCEDURE CWO01();
  CONST
   bpId = "CWO01";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " 冷   ॢ", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "rep", Create);
  MakeHeader("R");

  SELECT(CWOrder, Date);
  SRCINSEL(CWOrder, GE, , Memo.ud_fr());
  WHILE OCCURE(CWOrder) & (CWOrder.Date <= Memo.ud_ut()) DO
   PROMPT(CWOrder.CWOrder);
   IF CWOrder.Status # L_MDoc.st_Canceled THEN
    MakeLine("R");
   END;
   NEXT(CWOrder);
  END; (* WHILE OCCURE(CWOrder) ... *)
  FIO.Close(R);
  L_bp.End();
 END {CWO01};

END.
