(*
%Copyright   (c) Polak Computer System
%Author      17.12.1998 15:01:15 BOR
%Purpose       室  ⥪饬 室  'ᥣ'
%Type        report
%Specific    AP
%Modified    04.02.2014 17:09:05 POLAK\MLB
%Environment
*)

 IMPORT L_General, L_Way, E_Way, Memo, L_Str, Str, L_APWI, L_OwnData;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
StExit.Exit, L, ""
StExit.Name, L, ""
@
################################################################ ########## #####
=#####===========================================================================
|                           室  ##########                         |
|-------------------------------------------------------------------------------|
|室 ######### ###############################################################|
|-------------------------------------------------------------------------------|
|               |      |     |             㯯 ⨬           |
|⥫⢠ | ६||--------------------------------------------------|
}
*)

(*
$P{ StrPVLim:
?, L, ""
@
|               |      |     |##################################################|
|---------------|------|-----|--------------------------------------------------|
}
*)


(*
$P{ Line:
?, L, ""
?, R, "3."
?, R, "0"
?, L, ""
@
|###############|######|#####|##################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak=======================================================================
}
*)

 PRIVATE PROCEDURE IsNeedCnd(trgDate: DATE; trgCnd: L_Way.tIncPlanCondition): SCAL[2];
 BEGIN
  IF L_Way.GetTypeOfCalcIncPlan(trgCnd, trgDate, StExit.BegTime) = L_Way.tcpi_FromExit THEN
   RETURN (ExitIP.Type # L_Way.ipt_Canceled);
  ELSE
   RETURN L_Way.AccessCurRouteIP(trgDate, trgCnd) & (RouteIP.Type # L_Way.ript_Canceled);
  END;
 END {IsNeedCnd};

 PRIVATE PROCEDURE IsGuardCnd(trgDate: DATE; trgCnd: L_Way.tIncPlanCondition): SCAL[2];
 BEGIN
  RETURN (trgCnd = L_Way.ipc_Guard) |
         (L_Way.E_VldPsgPlanLev(trgDate) & (trgCnd = E_Way.ipc_TermPlanGrd));
 END {IsGuardCnd};

 PRIVATE PROCEDURE AccessRoute(FirstTripWithPlInc: LIKE(SEJobs.Trip));
 BEGIN
  IF !FirstTripWithPlInc THEN
   L_General.Assert(SELECT(SEJobs, Exit, StExit.Exit), "室   ३ᮢ");
  ELSE
   SEARCH(SEJobs, Trip, , FirstTripWithPlInc);
  END;
  CONFORM(SEJobs, Route);
 END {AccessRoute};

 PRIVATE PROCEDURE Do();
  CONST
   RepName     = "ExitI";
   GroupAmount = 10;
   cw_Value    = 10;
  VAR
   onDate            : DATE;
   StrPVLim          : STRING[];
   IncPlan           : NUMERIC[2];
   StrPlan           : STRING[];
   PlTim             : NUMERIC[3];
   VolGrp            : NUMERIC[0][GroupAmount];
   CountGrp          : NUMERIC[0];
   _TripAm           : LIKE(StExit.TripAm);
   _Cnd              : L_Way.tIncPlanCondition;
   FirstTripWithPlInc: LIKE(SEJobs.Trip);
   CndAsStr          : STRING[];
 BEGIN
  L_General.Assert(ACCESS(StExit), " ⠭ ⥪騩 室");
  onDate:=Memo.ud_cd();
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, onDate);
  SEARCH(Calendar, Date, , onDate);
  L_Way.CheckExitOnDate(StExit.Exit, onDate, 1);
  SETEMPTY(VolGrp);
  SETZERO(VolGrp[0]);

  SETEMPTY(FirstTripWithPlInc);
  CONFORM(StExit, SEJobs);
  WHILE OCCURE(SEJobs) & !FirstTripWithPlInc DO
   CONFORM(SEJobs, Route, WJMode);
   IF L_Way.SEJobsWithPlIncome(onDate) THEN
    FirstTripWithPlInc:=SEJobs.Trip;
    IF    (L_Way.E_NeedCrankyWayIPLInterpretation(onDate, L_Way.tcpi_FromRoute) |
           L_Way.E_NeedCrankyWayIPLInterpretation(onDate, L_Way.tcpi_FromExit)) &
          ~!PROCREF(E_Way.PasVolGrpCranky) THEN
     E_Way.PasVolGrpCranky(onDate, VolGrp);
    ELSIF L_Way.E_CalcPlIncBySittingPV(onDate) THEN
     E_Way.PasVolGrpSit(onDate, VolGrp);
    ELSE
     E_Way.PasVolGrp(onDate, VolGrp);
    END;
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)

  IF !FirstTripWithPlInc THEN
   E_Way.PasVolGrp(onDate, VolGrp);
  END;

  SETEMPTY(StrPVLim);
  SETZERO(CountGrp);
  REPEAT
   INC(StrPVLim, FLDTOSTR(VolGrp[CountGrp], "", cw_Value, "R"));
   INC(CountGrp);
  UNTIL !VolGrp[CountGrp];
  MAKEPART(R, StrPVLim, StrPVLim);

  FOR_EACH _Cnd DO
   CndAsStr:=L_Str.PoolItem(L_Way.E_IPConditionPool(onDate), _Cnd);
   SETEMPTY(StrPlan, PlTim, _TripAm);
   SETZERO(CountGrp);
   REPEAT
    AccessRoute(FirstTripWithPlInc);
    SELECT(SEJobs, Exit, , StExit.Exit);
    IF IsNeedCnd(onDate, _Cnd) THEN
     IF L_Way.SetCarForIncPlan(onDate, VolGrp[CountGrp]) THEN
      SETZERO(PlTim, IncPlan, _TripAm);
      SELECT(SEJobs, Exit, , StExit.Exit);
      WHILE OCCURE(SEJobs) DO
       PROMPT("⥫⢠ " + CndAsStr +
              ", ⨬ " + L_Str.IntStr(VolGrp[CountGrp]) +
              ", ३ " + SEJobs.Trip);
       CONFORM(SEJobs, WJMode, Route);
       IF L_Way.SEJobsWithPlIncome(onDate) THEN
        IF ~IsGuardCnd(onDate, _Cnd) | L_Way.SEJobsWithGu() THEN
         INC(_TripAm);
         INC(PlTim,   SEJobs.StopT-SEJobs.StartT);
         INC(IncPlan, L_APWI.E_GetPlanIncomeScope(L_APWI.piScope_SEJobs, onDate, _Cnd));
        END;
       END;
       NEXT(SEJobs);
      END; (* WHILE OCCURE(SEJobs)... *)
   
      INC(StrPlan, FLDTOSTR(IncPlan, "2.", cw_Value, "R"));
     ELSE
      INC(StrPlan, Str.Align("X", cw_Value, RIGHT));
     END; (* IF L_Way.SetCarForIncPlan ... *)
    ELSIF _Cnd < L_Way.ipc_TwoGuards THEN
     INC(StrPlan, Str.Align("X", cw_Value, RIGHT));
    END; (* IF IsNeedCnd... *)
    INC(CountGrp);
   UNTIL !VolGrp[CountGrp];
   IF ~!StrPlan THEN
    MAKEPART(R, Line, CndAsStr, PlTim, _TripAm, StrPlan)
   END;
  END; (* FOR_EACH _Cnd *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {Do};

END.
