(*
%Copyright   (c) Polak IT
%Author      07.10.2004 15:00:06 POLAK\GAV
%Purpose
%Type        report
%Specific    AP
%Modified    18.03.2014 10:05:19 POLAK\San
%Environment
*)

 IMPORT L_General, L_DatTim, Memo, L_OwnData, L_AFM, L_Way, Math, L_SCAD, L_Events, L_XDoc;

 PRIVATE CONST
  dc_All    = 0;
  dc_Active = 1;
  dc_Intrv  = 2;
  mc_WJMode = 0;
  mc_Route  = 1;
  mc_RtMod  = 2;

(*
$P{ Trips_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
###########################################################################################   ########## #####
=#####========================================================================================================
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|       |室    |||  |||-  䨪          | ࠡ      |        | ||
|-----------|---------|-|------|------|--|--|--------------------------|------------------|-----------|----|-|
}
*)

(*
$P{ Trips_Line:
SEJobs.Trip, L, ""
StExit.Exit, L, ""
StExit.Strict, L, "||"
StExit.FromD, L, "DNY"
StExit.UpDate, L, "DNY"
SEJobs.WJCode, L, ""
tmp.TKind, L, ""
Route.Route, L, ""
RoutMod.Modif, L, ""
RoutMod.Name, L, ""
JRegime.JRegime, L, ""
JRegime.Name, L, ""
SEJobs.StartT, L, "H:M"
SEJobs.StopT, L, "H:M"
(SEJobs.StopT-SEJobs.StartT)*60, R, "0"
SELECT(SEJMStop, Trip, SEJobs.Trip), L, " |"
@
|###########|#########|#|######|######|##|##|#### ### #################|## ###############|##### #####|####|#|
}
*)

(*
$P{ Trips_Bot:
@
=(c) Polak====================================================================================================
}
*)

(*
$P{ RtMod_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
Route.Route, L, ""
Route.Name, L, ""
RoutMod.Modif, L, ""
RoutMod.Name, L, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|----------------------------------------------------------------------------|
|     #### ###########################################################|
|䨪 ###  ###########################################################|
|----------------------------------------------------------------------------|
|       |室    ||    |      | ࠡ                    |
|-----------|---------|-|----------|----------|------------------------------|
}
*)

(*
$P{ RtMod_Line:
SEJobs.Trip, L, ""
StExit.Exit, L, ""
SELECT(SEJMStop, Trip, SEJobs.Trip), L, " |"
StExit.FromD, L, "D.N.y"
StExit.UpDate, L, "D.N.y"
WJMode.WJCode, L, ""
WJMode.Name, L, ""
@
|###########|#########|#|##########|##########|## ###########################|
}
*)

(*
$P{ RtMod_Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Make_Trips(ModeCond, DateCond: SCAL[3]);
  VAR
   RepName,
   Title   : STRING[];
   OnDate  : DATE;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);

  L_AFM.MakeIndex("tmp", "WJCode: LIKE(WJMode.WJCode);" +
                         "TKind : LIKE(Route.TKind);"   +
                         "Route : LIKE(Route.Route);"   +
                         "Modif : LIKE(RoutMod.Modif);" +
                         "Trip  : LIKE(SEJobs.Trip)");
  IF    ModeCond = mc_WJMode THEN
   L_General.Assert(ACCESS(WJMode), " ⠭  ࠡ");
   Title:="   ࠡ " + WJMode.WJCode + " " + WJMode.Name;
   RepName:="WJM";
   SELECT(SEJobs, WJCode, , WJMode.WJCode);
  ELSIF ModeCond = mc_RtMod THEN
   L_General.Assert(ACCESS(RoutMod), " ⠭ 䨪 ");
   CONFORM(RoutMod, Route);
   Title:="  䨪樨 ";
   RepName:="RtM";
   SELECT(SEJobs, RoutMod, , RoutMod.Route, RoutMod.Modif);
  ELSE
   L_General.Assert(ACCESS(Route), " ⠭ ");
   Title:="   " + Route.Route + " " + Route.Name;
   RepName:="Rou";
   SELECT(SEJobs, Route, , Route.Route);
  END;
  IF    DateCond = dc_Active THEN
   OnDate:=Memo.ud_cd();
   Title:=Title + "  " + L_DatTim.DateStr(OnDate);
   RepName:=RepName + "Dt";
  ELSIF DateCond = dc_Intrv THEN
   OnDate:=Memo.ud_ut();
   Title:=Title + "  ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) +
                           "  " + L_DatTim.DateStr(Memo.ud_ut());
   RepName:=RepName + "IP";
  ELSE
   OnDate :=SYSDATE();
   RepName:=RepName + "AL";
  END;

  WHILE OCCURE(SEJobs) DO
   PROMPT("⮢ " + SEJobs.Trip);
   CONFORM(SEJobs, StExit);
   IF (DateCond = dc_All) |
      ((DateCond = dc_Active) &
       L_DatTim.IsActive(OnDate, StExit.FromD, StExit.UpDate)) |
      ((DateCond = dc_Intrv) &
       L_DatTim.IsActiveInIntvl(Memo.ud_fr(), Memo.ud_ut(),
                                StExit.FromD, StExit.UpDate)) THEN
    CONFORM(SEJobs, Route);
    ADD(tmp, tmp, , SEJobs.WJCode, L_Way.GetRouteTKind(Math.Max(OnDate, StExit.FromD), 1), SEJobs.Route,
                    SEJobs.Modif, SEJobs.Trip);
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF ModeCond = mc_RtMod THEN
   MAKEPART(R, RtMod_Top, RepName, Title);
  ELSE
   MAKEPART(R, Trips_Top, RepName, Title);
  END;
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   SEARCH(SEJobs, Trip, , tmp.Trip);
   PROMPT(" " + SEJobs.Trip);
   CONFORM(SEJobs, WJMode);
   CONFORM(SEJobs, StExit);
   IF ModeCond = mc_RtMod THEN
    MAKEPART(R, RtMod_Line);
   ELSE
    CONFORM(SEJobs, RoutMod);
    CONFORM(RoutMod, Route);
    L_Way.PositionOnRouteLog(Route.Route, Math.Max(OnDate, StExit.FromD));
    CONFORM(RouteLog, JRegime);
    MAKEPART(R, Trips_Line);
   END;
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)

  IF ModeCond = mc_RtMod THEN
   MAKEPART(R, RtMod_Bot);
  ELSE
   MAKEPART(R, Trips_Bot);
  END;
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("tmp");
 END {Make_Trips};

(*
$P{ SEJ_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
SEJobs.Trip, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
Route.Route, L, ""
Route.Name, L, ""
RoutMod.Modif, L, ""
RoutMod.Name, L, ""
WJMode.WJCode, L, ""
WJMode.Name, L, ""
JRegime.JRegime, L, ""
JRegime.Name, L, ""
@
##########################################################    ########## #####
=#####========================================================================
|   ⥢   ३ ###########  ਮ  ##########  ##########  |
|      #### ################################                          |
|䨪  ###  ########################################                  |
| ࠡ   ##   ################################                          |
| ࠡ ##   ################################                          |
|----------------------------------------------------------------------------|
|     |      |室  ||  |  ||  |⢮             |
}
*)

(*
$P{ SEJ_TSNTop:
Staff.TSN, L, ""
Man.Name, L, ""
?, R, "3."
?, R, "2."
@
|----------------------------------------------------------------------------|
| ##### ################################ ᥣ ६ ####### ஡ ######|
|----------------------------------------------------------------------------|
}
*)

(*
$P{ SEJ_Line:
?, L, ""
?, L, ""
?, L, ""
RWayJ.Day, L, ""
RWayJ.StartT, L, "H:M"
RWayJ.StopT, L, "H:M"
RWayJ.Fact, L, ""
RWayJ.Run, R, "2."
Quality.Quality, L, ""
Quality.Name, L, ""
@
|#######|##########|#########|##|#####|#####|##|#######|### #################|
}
*)

(*
$P{ SEJ_Bot:
?, L, ""
?, L, ""
@
|----------------------------------------------------------------------------|
|⮣ :  #######                                                          |
|⥫: ####                                                             |
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE sej_CreateTmp();
 BEGIN
  L_AFM.MakeIndex("tmp", "TSN   : LIKE(RWayS.TSN);"   +
                         "RWayS : LIKE(RWayS.RWayS);" +
                         "Day   : LIKE(RWayJ.Day);"   +
                         "StartT: LIKE(RWayJ.StartT)");
  CreateFILE(tot);
  CreateFIELD(tot, TSN, LIKE(RWayS.TSN));
  CreateFIELD(tot, Tim, NUMERIC[3], "", "0");
  CreateFIELD(tot, Run, NUMERIC[2], "", "0");
  CreateINDEX(tot, tot, UNIQUE, "", "", TSN);
  SetVersionOfFILE(tot, 0000);
  L_AFM.CreateTemp("tot");
 END {sej_CreateTmp};

 PUBLIC PROCEDURE CSEJb();
  CONST
   RepName = "CSEJb";
  VAR
   rwsCount,
   tsnCount : NUMERIC[0];
   LastRWS  : LIKE(RWayS.RWayS);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  L_General.Assert(ACCESS(SEJobs), " ⠭ ३");
  sej_CreateTmp();

  SELECT(RWayJ, Trip, , SEJobs.Trip);
  WHILE OCCURE(RWayJ) DO
   CONFORM(RWayJ, RWayS);
   PROMPT("⮢ " + RWayS.RWayS);
   IF (RWayJ.Trip = SEJobs.Trip) &
      L_DatTim.IsActive_Inc(RWayS.Date, Memo.ud_fr(), Memo.ud_ut()) THEN
    ADD(tmp, tmp, , RWayS.TSN, RWayJ.RWayS, RWayJ.Day, RWayJ.StartT);
    ADD(tot, tot, , RWayS.TSN, tot.Tim, RWayJ.StopT - RWayJ.StartT,
                               tot.Run, RWayJ.Fact * RWayJ.Run);
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)

  CONFORM(SEJobs, Route);
  CONFORM(SEJobs, RoutMod);
  CONFORM(SEJobs, WJMode);
  CONFORM(SEJobs, JRegime);

  rwsCount:=0;
  tsnCount:=0;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, SEJ_Top, RepName);
  SELECT(tot, tot);
  L_XDoc.sl_Init("  ३ᮬ " + SEJobs.Trip);
  WHILE OCCURE(tot) DO
   INC(tsnCount);
   SEARCH(Staff, TSN, , tot.TSN);
   PROMPT(" " + tot.TSN);
   CONFORM(Staff, Man);
   MAKEPART(R, SEJ_TSNTop, tot.Tim, tot.Run);
   SELECT(tmp, tmp, , tot.TSN);
   SETEMPTY(LastRWS);
   WHILE OCCURE(tmp) DO
    SEARCH(RWayJ, RWayS, , tmp.RWayS, tmp.Day, tmp.StartT);
    CONFORM(RWayJ, Quality);
    IF tmp.RWayS # LastRWS THEN
     INC(rwsCount);
     SEARCH(RWayS, RWayS, , tmp.RWayS);
     L_XDoc.sl_AddCurrentXDoc(L_XDoc.xdt_RWayS);
     MAKEPART(R, SEJ_Line, RWayS.RWayS, L_DatTim.DateStr(RWayS.Date), RWayS.Exit);
     LastRWS:=tmp.RWayS;
    ELSE
     MAKEPART(R, SEJ_Line);
    END;
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
   NEXT(tot);
  END; (* WHILE OCCURE(tot) ... *)
  MAKEPART(R, SEJ_Bot, rwsCount, tsnCount);
  CLOSEREP(R);
  L_XDoc.sl_Done();
 END {CSEJb};

(*
$P{ Stop_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
"ᯮ짮 ⠭ " + Stop.Stop + " " + L_Way.GetStopName(Stop.Stop), C, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|############################################################################|
|----------------------------------------------------------------------------|
|                    |䨪               |   |     |
|---------------------------|--------------------------|----------|----------|
}
*)

(*
$P{ Stop_Line:
Route.Route, L, ""
Route.Name, L, ""
RoutMod.Modif, L, ""
RoutMod.Name, L, ""
RoutMod.FromD, L, "D.N.y"
RoutMod.UpDate, L, "D.N.y"
@
|#### ######################|### ######################|##########|##########|
}
*)

(*
$P{ Stop_Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Make_Stop(DateCond: SCAL[3]);
  VAR
   RepName,
   Title   : STRING[];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);

  L_AFM.MakeIndex("tmp", "Route : LIKE(Route.Route);" +
                         "Modif : LIKE(RoutMod.Modif)");
  L_General.Assert(ACCESS(Stop), " ⠭ ⠭");
  Title:=" 䨪 ⮢";
  RepName:="CSto";
  IF    DateCond = dc_Active THEN
   Title:=Title + "  " + L_DatTim.DateStr(Memo.ud_cd());
   RepName:=RepName + "D";
  ELSIF DateCond = dc_Intrv THEN
   Title:=Title + "  ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) +
                           "  " + L_DatTim.DateStr(Memo.ud_ut());
   RepName:=RepName + "I";
  ELSE
   RepName:=RepName + "A";
  END;
  SELECT(RtMStop, Stop, , Stop.Stop);
  WHILE OCCURE(RtMStop) DO
   CONFORM(RtMStop, RoutMod);
   PROMPT("⮢ " + RoutMod.Route + " " + RoutMod.Modif);
   IF (DateCond = dc_All) |
      ((DateCond = dc_Active) &
       L_DatTim.IsActive(Memo.ud_cd(), RoutMod.FromD, RoutMod.UpDate)) |
      ((DateCond = dc_Intrv) &
       L_DatTim.IsActiveInIntvl(Memo.ud_fr(), Memo.ud_ut(),
                                RoutMod.FromD, RoutMod.UpDate)) THEN
    ADD(tmp, tmp, , RoutMod.Route, RoutMod.Modif);
   END;
   NEXT(RtMStop);
  END; (* WHILE OCCURE(RtMStop) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Stop_Top, RepName, Title);

  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   SEARCH(RoutMod, Route, , tmp.Route, tmp.Modif);
   CONFORM(RoutMod, Route);
   PROMPT(" " + RoutMod.Route + " " + RoutMod.Modif);
   MAKEPART(R, Stop_Line);
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)

  MAKEPART(R, Stop_Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("tmp");
 END {Make_Stop};

(*
$P{ cp_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Stop.CP, L, ""
Stop.CPType, L, L_Way.scpt_Pool
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
"⠭ " + Stop.Stop + " " + L_Way.GetStopName(Stop.Stop), C, ""
@
############################################################# ########## #####
=#####========================================================================
|             ᯮ짮 ஫쭮 㭪 ## ############              |
|            ⥢   ਮ  ##########  ##########            |
|               #############################################                |
|----------------------------------------------------------------------------|
|      |     |     || | |⪫|⢮               |
|----------|-------|-----------|----|-----|-----|----|-----------------------|
}
*)

(*
$P{ cp_Line:
?, L, ""
?, L, ""
RWayJ.Trip, L, ""
RWayCP.Value, L, ""
RWayCP.PlanT, L, "H:M"
RWayCP.FactT, L, "H:M"
RWayCP.Shift, R, "0"
Quality.Quality, L, ""
Quality.Name, L, ""
@
|##########|#######|###########|####|#####|#####|####|### ###################|
}
*)

(*
$P{ cp_Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Make_CP();
  VAR
   lastDate: DATE;
   lastRWS : LIKE(RWayS.RWayS);
   RepName : STRING[];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);

  L_General.Assert(L_SCAD.E_RWayCPLevel(Memo.ud_ut()), "⬥⪨     ");
  L_AFM.MakeIndex("tmp", "Date   : DATE;" +
                         "RWayS  : LIKE(RWayCP.RWayS);" +
                         "Day    : LIKE(RWayCP.Day);" +
                         "StartT : LIKE(RWayCP.StartT);" +
                         "StopNbr: LIKE(RWayCP.StopNbr)");
  L_General.Assert(ACCESS(Stop), " ⠭ ⠭");
  RepName:="RwsCP";

  SELECT(RWayS, Date);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date<=Memo.ud_ut()) DO
   PROMPT("⮢ " + L_DatTim.DateStr(RWayS.Date)+" "+RWayS.RWayS);
   SELECT(RWayCP, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayCP) DO
    IF RWayCP.Stop = Stop.Stop THEN
     ADD(tmp, tmp, , RWayS.Date, RWayCP.RWayS, RWayCP.Day,
                     RWayCP.StartT, RWayCP.StopNbr);
    END;
    NEXT(RWayCP);
   END; (* WHILE OCCURE(RWayCP) ... *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, cp_Top, RepName);
  SETEMPTY(lastDate, lastRWS);

  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   PROMPT(" " + tmp.RWayS);
   SEARCH(RWayCP, RWayS, , tmp.RWayS, tmp.Day, tmp.StartT, tmp.StopNbr);
   CONFORM(RWayCP, RWayJ, Quality);
   IF    lastDate # tmp.Date  THEN
    MAKEPART(R, cp_Line, L_DatTim.DateStr(tmp.Date), tmp.RWayS);
   ELSIF lastRWS  # tmp.RWayS THEN
    MAKEPART(R, cp_Line, , tmp.RWayS);
   ELSE
    MAKEPART(R, cp_Line);
   END;
   lastDate:=tmp.Date;
   lastRWS :=tmp.RWayS;
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)

  MAKEPART(R, cp_Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("tmp");
 END {Make_CP};

(*
$P{ TCHSH_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_cd(), L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|                            室  ##########                            |
}
*)

(*
$P{ TCHSH_RouteTop:
Route.Route, L, ""
Route.Name, L, ""
@
|----------------------------------------------------------------------------|
| #### #################################################              |
|----------------------------------------------------------------------------|
|         |       |      | | |   ஡    |      |  |     |     |           |
|室    |ઠ  ||||-------------| ६||. ||  ⮩   |
|         |       |      | | |㫥|  騩|      |  |     |     |           |
}
*)

(*
$P{ TCHSH_Line:
StExit.Exit, L, ""
L_Way.PasVolEnum2Sign(L_Way.GetExitPasVolEnum()), L, ""
StExit.FromD, L, "DNY"
StExit.Gap, L, "-|+"
StExit.Change, L, ""
?, R, "2."
StExit.Run, R, "2."
StExit.LineT, R, "3."
StExit.TripAm, R, "0"
L_Way.FullStExitBegTimeStr(), L, ""
L_Way.FullStExitStopTimStr(), L, ""
@
|---------|-------|------|-|-|-----|-------|------|--|-----|-----|-----------|
|#########|#######|######|#|#|#####|#######|######|##|#####|#####|}
*)

(*
$P{ TCHSH_Stand_0:
@
           |
}
*)

(*
$P{ TCHSH_Stand_1:
SEJobs.StartT, L, "H:M"
SEJobs.StopT, L, "H:M"
@
#####|#####|
}
*)

(*
$P{ TCHSH_Stand_2:
SEJobs.StartT, L, "H:M"
SEJobs.StopT, L, "H:M"
@
|                                                                |#####|#####|
}
*)

(*
$P{ TCHSH_Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Make_TCHSH(OneRoute: SCAL[2]);
  CONST
   RepName = "TCHSH";
  VAR
   ZeroRun: NUMERIC[2];
   Count  : NUMERIC[0];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);

  IF OneRoute THEN
   L_General.Assert(ACCESS(Route), " ⠭ ");
   SELECT(SEJobs, toRoute, , 0, Route.Route);
  ELSE
   SELECT(SEJobs, toRoute, , 0);
  END;

  L_AFM.MakeIndex("tmp", "Route : LIKE(Route.Route);"+
                         "Change: LIKE(StExit.Change);"+
                         "Exit  : LIKE(StExit.Exit)");
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, StExit);
   PROMPT(SEJobs.Route + " " + SEJobs.Day + " " + L_DatTim.TimeStr(SEJobs.StartT));
   IF L_DatTim.IsActive(Memo.ud_cd(), StExit.FromD, StExit.UpDate) &
      (StExit.Strict = L_Way.ExitStrict_Reg) THEN
    ADD(tmp, tmp, , SEJobs.Route, StExit.Change, StExit.Exit);
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, TCHSH_Top, RepName);
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   NARROWSEL(tmp, Route);
   SEARCH(Route, Route, , tmp.Route);
   MAKEPART(R, TCHSH_RouteTop);
   WHILE OCCURE(tmp) DO
 
    SEARCH(StExit, Exit, , tmp.Exit);
    ZeroRun:=0;
    SELECT(SEJobs, Exit, , tmp.Exit);
    WHILE OCCURE(SEJobs) DO
     IF SEJobs.Route = Route.Route THEN
      CONFORM(SEJobs, WJMode);
      IF WJMode.RunSel = L_Way.runsel_Zero THEN
       CONFORM(SEJobs, RoutMod);
       INC(ZeroRun, RoutMod.Run);
      END;
     END;
     NEXT(SEJobs);
    END; (* WHILE OCCURE(SEJobs) ... *)
    MAKEPART(R, TCHSH_Line, ZeroRun);

    Count:=0;
    SELECT(SEJobs, Exit, , tmp.Exit);
    WHILE OCCURE(SEJobs) DO
     IF (SEJobs.Route = Route.Route) & (SEJobs.WJCode = "50") THEN
      IF Count THEN
       MAKEPART(R, TCHSH_Stand_2);
      ELSE
       MAKEPART(R, TCHSH_Stand_1);
      END;
      INC(Count);
     END;
     NEXT(SEJobs);
    END; (* WHILE OCCURE(SEJobs) ... *)
    IF Count = 0 THEN
     MAKEPART(R, TCHSH_Stand_0);
    END;

    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
   NEXTINEXTENDEDSEL(tmp, Route);
  END; (* WHILE OCCURE(tmp) ... *)
  L_AFM.AF_PurgeTemp("tmp");
  MAKEPART(R, TCHSH_Bot);
  CLOSEREP(R);
 END {Make_TCHSH};

BEGIN
 IF MODE # L_Events.md_InIMPORT THEN
  IF    (MODE = 100) THEN Make_Trips(mc_WJMode, dc_All);
  ELSIF (MODE = 101) THEN Make_Trips(mc_WJMode, dc_Active);
  ELSIF (MODE = 102) THEN Make_Trips(mc_Route,  dc_All);
  ELSIF (MODE = 103) THEN Make_Trips(mc_Route,  dc_Active);
 
  ELSIF (MODE = 110) THEN Make_Trips(mc_RtMod,  dc_Active);
  ELSIF (MODE = 111) THEN Make_Trips(mc_RtMod,  dc_Intrv);
  ELSIF (MODE = 112) THEN Make_Trips(mc_RtMod,  dc_All);
 
  ELSIF (MODE = 130) THEN Make_Stop(dc_Active);
  ELSIF (MODE = 131) THEN Make_Stop(dc_Intrv);
  ELSIF (MODE = 132) THEN Make_Stop(dc_All);
 
  ELSIF (MODE = 140) THEN Make_CP();
 
  ELSIF (MODE = 150) THEN Make_TCHSH(0);
  ELSIF (MODE = 151) THEN Make_TCHSH(1);
 
  ELSE
   L_General.BadMode(MODE);
  END;
 END;
END.
