(*
%Copyright   (c) Polak IT
%Author      19.10.2009 20:11:10 POLAK\Bor
%Purpose
%Type        report
%Specific    LOC
%Modified    01.08.2014 13:24:39 POLAK\GAV
%Environment
*)

 MODULE DrPrm;

 IMPORT Memo, L_General, L_DatTim, L_Basis, L_Staff, L_Way, L_AFM, L_EDO,
        P_EDOL, P_Firm, FIO, L_Man, L_AR, L_Env, L_bp;

 CONST
  bpId = "DrPrm";

  prm_Route = 0;
  prm_MarkG = 1;

 VAR
  wMF: SCAL[2];

 PRIVATE PROCEDURE EDOLProMsg(): STRING[];
  VAR
   RetVal: STRING[];
 BEGIN
  SAVE(EDOrderL);
  SAVE(EDOrder);
  CONFORM(EDOLPro, EDOrderL);
  CONFORM(EDOrderL, EDOrder);
  RetVal:="|. ਪ "+EDOrderL.EDOrder+"  "+L_DatTim.DateStr(EDOrder.Date)+" . "+EDOrderL.Row;
  RESTORE(EDOrder);
  RESTORE(EDOrderL);
  RETURN RetVal;
 END {EDOLProMsg};

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "㯯ப");
  L_Basis.wb_WrStr(F, "㯯ப");
  L_Basis.wb_WrStr(F, "⠄᪠");
  L_Basis.wb_WrStr(F, "⠑⠦஢");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE IsActiveEvent(D: DATE): SCAL[2];
 BEGIN
  RETURN !_DrPr.CancelD | ~!D & (D > _DrPr.CancelD);
 END {IsActiveEvent};

 PRIVATE PROCEDURE MakeLine(F: STRING[]);
 BEGIN
  SEARCH(Staff, TSN, , _DrPr.TSN);
  CONFORM(Staff, Man);
  L_Staff.PosToStaffLog(Staff.TSN, Memo.ud_cd(), 1);
  CONFORM(StaffLog, Sort);
  IF wMF THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  IF    _DrPr.What = prm_Route THEN
   SEARCH(Route, Route, , _DrPr.Code);
   L_Basis.wb_WrStr(F, Route.Route);
   L_Basis.wb_WrStr(F, Route.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  IF    _DrPr.What = prm_MarkG THEN
   SEARCH(MarkG, MarkG, , _DrPr.Code);
   L_Basis.wb_WrScl(F, MarkG.MarkG);
   L_Basis.wb_WrStr(F, MarkG.Name);
  ELSE
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "---");
  END;
  IF IsActiveEvent(_DrPr.PermitD) THEN
   L_Basis.wb_WrDat(F, _DrPr.PermitD);
  ELSE
   L_Basis.wb_WrDat(F, L_General.EMPTY_DATE());
  END;
  L_Basis.wb_WrDat(F, _DrPr.ProbatD);
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PRIVATE PROCEDURE MakeNoPermitLine(F: STRING[]; npRoute, npMarkG: SCAL[2]);
 BEGIN
  CONFORM(Staff, Man);
  CONFORM(StaffLog, Sort);
  IF wMF THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  IF npRoute THEN
   L_Basis.wb_WrStr(F, " ᪮");
   L_Basis.wb_WrStr(F, " ᪮");
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  IF npMarkG THEN
   L_Basis.wb_WrStr(F, " ᪮");
   L_Basis.wb_WrStr(F, " ᪮");
  ELSE
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrDat(F, L_General.EMPTY_DATE());
  L_Basis.wb_WrDat(F, L_General.EMPTY_DATE());
  L_Basis.wb_TermLine(F);
 END {MakeNoPermitLine};

 PRIVATE PROCEDURE SetDate(VAR DstDate, D: DATE);
 BEGIN
  IF !DstDate | (DstDate < D) THEN
   DstDate:=D;
  END;
 END {SetDate};

 PRIVATE PROCEDURE AddDrPr(_TSN: LIKE(Staff.TSN); _What: SCAL[2]; _Code: STRING[]; _EDOGrp: LIKE(EDOGrp.EDOGrp); D: DATE);
 BEGIN
  ADD(_DrPr, TSN, , _TSN, _What, _Code);
  IF    _EDOGrp = L_EDO.grp_Permit THEN
   SetDate(_DrPr.PermitD, D);
  ELSIF _EDOGrp = L_EDO.grp_CancelPermit THEN
   SetDate(_DrPr.CancelD, D);
  ELSIF _EDOGrp = L_EDO.grp_Probation THEN
   SetDate(_DrPr.ProbatD, D);
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(_DrPr);
 END {AddDrPr};

 PRIVATE PROCEDURE MakeOneEDOGrp(_EDOGrp: LIKE(EDOGrp.EDOGrp));
 BEGIN
  TRY
   L_AR.GrantRightsUnconditionally();
   SELECT(EDOrderL, TSNGrOD);
   WHILE OCCURE(EDOrderL) DO
    PROMPT(" "+_EDOGrp+" "+EDOrderL.TSN);
    NARROWSEL(EDOrderL, TSN);
    CONFORM(EDOrderL, Staff);
    IF L_Staff.rInState(Memo.ud_cd()) THEN
     SAVE(EDOrderL);
     SELECT(EDOrderL, TSNGrOD, , EDOrderL.TSN, _EDOGrp);
     SRCINSEL(EDOrderL, GE, , L_Man.GetTakeOnDate(Memo.ud_cd()));
     WHILE OCCURE(EDOrderL) & (EDOrderL.OcrDate <= Memo.ud_cd()) DO
      IF EDOrderL.Status = L_EDO.st_Passed THEN
       SELECT(EDOLPro, EDOrder, , EDOrderL.EDOrder, EDOrderL.Row);
       WHILE OCCURE(EDOLPro) DO
        IF    EDOLPro.Property = P_EDOL.P_MarkG THEN
         L_General.CallUs(SEARCH(MarkG, MarkG, P_EDOL.Decode_CurEDOLPro()));
         IF (MarkG.MarkGT = L_Way.mgt_AccessDriving) &
            L_DatTim.IsActive(Memo.ud_cd(), MarkG.Begin, MarkG.Till) THEN
          AddDrPr(EDOrderL.TSN, prm_MarkG, MarkG.MarkG, _EDOGrp, EDOrderL.OcrDate);
         END;
        ELSIF EDOLPro.Property = P_EDOL.P_Route THEN
         L_General.CallUs(SEARCH(Route, Route, P_EDOL.Decode_CurEDOLPro()));
         IF L_DatTim.IsActive(Memo.ud_cd(), Route.Begin, Route.Till) THEN
          AddDrPr(EDOrderL.TSN, prm_Route, P_EDOL.Decode_CurEDOLPro(), _EDOGrp, EDOrderL.OcrDate);
         END;
        END;
        NEXT(EDOLPro);
       END; (* WHILE OCCURE(EDOLPro) ... *)
      END;
      NEXT(EDOrderL);
     END; (* WHILE OCCURE(EDOrderL) ... *)
     RESTORE(EDOrderL);
    END;
    NEXTINEXTENDEDSEL(EDOrderL, TSN);
   END; (* WHILE OCCURE(EDOrderL) ... *)
  EXCEPT
  END;
 END {MakeOneEDOGrp};

 PRIVATE PROCEDURE PrintRep();
  VAR
   PrbCnt: NUMERIC[0][2];
 BEGIN
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeTop("R");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(" " + Staff.TSN);
   IF L_Staff.rInState(Memo.ud_cd()) THEN
    SETZERO(PrbCnt);
    SELECT(_DrPr, TSN, , Staff.TSN);
    WHILE OCCURE(_DrPr) DO
     PROMPT(" "+_DrPr.TSN);
     IF IsActiveEvent(_DrPr.PermitD) | IsActiveEvent(_DrPr.ProbatD) THEN
      INC(PrbCnt[_DrPr.What], IsActiveEvent(_DrPr.PermitD));
      MakeLine("R");
     END;
     NEXT(_DrPr);
    END; (* WHILE OCCURE(_DrPr) ... *)
    CONFORM(StaffLog, Officer);
    IF L_Env.IsDriver() & ((PrbCnt[prm_Route] = 0) | (PrbCnt[prm_MarkG] = 0)) THEN
     MakeNoPermitLine("R", PrbCnt[prm_Route] = 0, PrbCnt[prm_MarkG] = 0);
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  FIO.Close("R");
 END {PrintRep};

 PRIVATE PROCEDURE MakeRep();
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, " ᪠ ⥫  ન  ", L_bp.t_Basis, L_General.timeCond_OnDate);

  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_AFM.MakeMultipleIndex("_DrPr", "TSN: LIKE(Staff.TSN);"+
                                   "What: SCAL[2];"+
                                   "Code: STRING[4];"+
                                   "PermitD: DATE;"+
                                   "CancelD: DATE;"+
                                   "ProbatD: DATE",
                          "TSN: TSN, What, Code");

  MakeOneEDOGrp(L_EDO.grp_Permit);
  MakeOneEDOGrp(L_EDO.grp_CancelPermit);
  MakeOneEDOGrp(L_EDO.grp_Probation);
  PrintRep();
  L_bp.End();
 END {MakeRep};

END.