(*
%Copyright   (c) Polak IT
%Author      01.09.2006 09:40:38 POLAK\GAV
%Purpose
%Type        report
%Specific    AP
%Modified    13.05.2013 13:03:56 POLAK\GAV
%Environment
*)

 IMPORT L_AFM, L_Way, L_EDO, P_EDOL, L_General, L_OwnData, Memo,
        L_BegRWS, L_Car, L_Env, L_Staff, L_DatTim;

(*
$P{ Top_Route:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|             ᪠  ##########  ##########         |
|----------------------------------------------------------------------------|
|⥫                    |                     |     |    |
|----------------------------|----------------------------|-------|----------|
}
*)

(*
$P{ Top_Mark:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|             ઠ  ᪠  ##########  ##########          |
|----------------------------------------------------------------------------|
|⥫                    |ઠ                       |     |      |
|----------------------------|----------------------------|-------|----------|
}
*)

(*
$P{ Line:
Staff.TSN, L, ""
Man.Name, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, "D.N.y"
@
|##### ######################|#### #######################|#######|##########|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Create_haRou();
 BEGIN
  L_AFM.MakeMultipleIndex("haRou", "TSN      : LIKE(Staff.TSN);" +
                                   "Route    : LIKE(Route.Route);" +
                                   "HasAccess: SCAL[2];"+
                                   "Date     : DATE;"+
                                   "RWayS    : LIKE(RWayS.RWayS)",
                             "TSN    : TSN, Route, Date, HasAccess, RWayS;" +
                             "ToPrint: HasAccess, TSN, Route, Date");
 END {Create_haRou};

 PRIVATE PROCEDURE Create_haMrk();
 BEGIN
  L_AFM.MakeMultipleIndex("haMrk", "TSN      : LIKE(Staff.TSN);" +
                                   "Mark     : LIKE(Mark.Mark);" +
                                   "HasAccess: SCAL[2];"+
                                   "Date     : DATE;"+
                                   "RWayS    : LIKE(RWayS.RWayS)",
                             "TSN    : TSN, Mark, Date, HasAccess, RWayS;"+
                             "ToPrint: HasAccess, TSN, Mark, Date");
 END {Create_haMrk};

 PRIVATE PROCEDURE CheckTrip(FillByRoute, ForceAuthorized: SCAL[2]; VAR WrkTripCnt: NUMERIC[0]);
 BEGIN
  CONFORM(SEJobs, WJMode);
  CONFORM(SEJobs, Route);
  L_Way.StandOnRouteTKind(RWayS.Date);
  IF (WJMode.RunSel = L_Way.runsel_Work) & (WJMode.WJType = L_Way.WJType_Work) THEN
   INC(WrkTripCnt);
  END;
  IF WJMode.WJType & WJMode.IncSel &
   ((TKind.Rgn = L_Way.tkrgn_City)   |
    (TKind.Rgn = L_Way.tkrgn_Suburb) |
    (TKind.Rgn = L_Way.tkrgn_Intercity)) THEN
   IF FillByRoute & ~SELECT(haRou, TSN, RWayS.TSN, SEJobs.Route, RWayS.Date) THEN
    ADD(haRou, TSN, , RWayS.TSN,
                      SEJobs.Route,
                      RWayS.Date,
                      ForceAuthorized | L_BegRWS.DriverIsAuthorizedToRoute(RWayS.Date, RWayS.TSN, SEJobs.Route),
                      RWayS.RWayS);
   END;
  END;
 END {CheckTrip};

 PRIVATE PROCEDURE Prepare(FillByRoute, FillByMark, ForceAuthorized: SCAL[2]; fr, ut: DATE);
  VAR
   WrkTripCnt: NUMERIC[0];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  SELECT(RWayS, Date);
  SRCINSEL(RWayS, GE, , fr);
  WHILE OCCURE(RWayS) & (RWayS.Date <= ut) DO
   PROMPT(RWayS.RWayS);
   WrkTripCnt:=0;
   IF RWayS.Status = L_Way.rwsStat_Rated THEN
    SELECT(RWayJ, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayJ) DO
     CONFORM(RWayJ, SEJobs);
     CheckTrip(FillByRoute, ForceAuthorized, WrkTripCnt);
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
   ELSE
    SELECT(SEJobs, Exit, , RWayS.Exit);
    WHILE OCCURE(SEJobs) DO
     CheckTrip(FillByRoute, ForceAuthorized, WrkTripCnt);
     NEXT(SEJobs);
    END; (* WHILE OCCURE(SEJobs) ... *)
   END;
   IF FillByMark & (WrkTripCnt > 0) THEN
    L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
    ADD(haMrk, TSN, , RWayS.TSN,
                      L_Way.GetMarkG_Soft(Mark.Mark, L_Way.mgt_AccessDriving),
                      RWayS.Date,
                      ForceAuthorized | L_BegRWS.HasPermitToMark(RWayS.Date, RWayS.TSN, Mark.Mark),
                      RWayS.RWayS);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {Prepare};

 PRIVATE PROCEDURE Print_Route(RepName: STRING[]; fr, ut: DATE);
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top_Route, RepName, fr, ut);
  SELECT(haRou, ToPrint, , 0);
  WHILE OCCURE(haRou) DO
   PROMPT(haRou.TSN);
   SEARCH(Staff, TSN, , haRou.TSN);
   CONFORM(Staff, Man);
   SEARCH(Route, Route, , haRou.Route);
   MAKEPART(R, Line, Route.Route, Route.Name, haRou.RWayS, haRou.Date);
   NEXT(haRou);
  END; (* WHILE OCCURE(haRou) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {Print_Route};

 PRIVATE PROCEDURE Print_Mark(RepName: STRING[]; fr, ut: DATE);
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top_Mark, RepName, fr, ut);
  SELECT(haMrk, ToPrint, , 0);
  WHILE OCCURE(haMrk) DO
   PROMPT(haMrk.TSN);
   SEARCH(Staff, TSN, , haMrk.TSN);
   CONFORM(Staff, Man);
   SEARCH(RWayS, RWayS, , haMrk.RWayS);
   L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
   MAKEPART(R, Line, Mark.Mark, Mark.Name, haMrk.RWayS, haMrk.Date);
   NEXT(haMrk);
  END; (* WHILE OCCURE(haMrk) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {Print_Mark};

 PRIVATE PROCEDURE pww_OneStaff(D: DATE; atrMethod: L_BegRWS.tAutorizeToRouteMethod);
  VAR
   LD,
   LPD: DATE;
 BEGIN
  SELECT(MarkG, MarkGT, , L_Way.mgt_AccessDriving);
  WHILE OCCURE(MarkG) DO
   PROMPT(" : " + Staff.TSN + " " + MarkG.MarkG);
   LPD:=L_BegRWS.GetPermit2MarkGDate(D, Staff.TSN, MarkG.MarkG);
   IF ~!LPD THEN
    IF SELECT(haMrk, TSN, Staff.TSN, MarkG.MarkG) THEN
     LAST(haMrk);
     LD:=haMrk.Date;
    ELSE
     SETEMPTY(LD);
    END;
    IF (!LD  | (LD  < D - 90)) &
       (!LPD | (LPD < D - 90)) THEN
     tmpM.TSN   :=Staff.TSN;
     tmpM.MarkG :=MarkG.MarkG;
     tmpM.LastD :=LD;
     tmpM.LastPD:=LPD;
     tmpM.ODPrmt:=(!LD  | (LD  < D - 183)) &
                  (!LPD | (LPD < D - 183));
     INSERT(tmpM);
    END;
   END; (* IF ~!LPD ... *)
   NEXT(MarkG);
  END; (* WHILE OCCURE(MarkG) ... *)

  IF atrMethod # L_BegRWS.atrm_No THEN
   SELECT(Route, Route);
   WHILE OCCURE(Route) DO
    PROMPT(" : " + Staff.TSN + " " + Route.Route);
    IF L_DatTim.IsActive(D, Route.Begin, Route.Till) &
       (L_BegRWS.DriverIsAuthorizedToRoute(D, Staff.TSN, Route.Route) = L_BegRWS.atr_Yes) THEN
     IF SELECT(haRou, TSN, Staff.TSN, Route.Route) THEN
      LAST(haRou);
      LD:=haRou.Date;
     ELSE
      SETEMPTY(LD);
     END;
     LPD:=L_BegRWS.GetPermit2RouteDate(D, Staff.TSN, Route.Route);

     IF (!LD  | (LD  < D - 90)) &
        (!LPD | (LPD < D - 90)) THEN
      tmpR.TSN   :=Staff.TSN;
      tmpR.Route :=Route.Route;
      tmpR.LastD :=LD;
      tmpR.LastPD:=LPD;
      tmpR.ODPrmt:=(!LD  | (LD  < D - 183)) &
                   (!LPD | (LPD < D - 183));
      INSERT(tmpR);
     END;
    END;
    NEXT(Route);
   END; (* WHILE OCCURE(Route) ... *)
  END;
 END {pww_OneStaff};

(*
$P{ pwwTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
SYSDATE(), L, "D.N.y"
@
######################################################################## ########## #####
=#####===================================================================================
|            ⥫, 騥 ,   騥 ࠪ⨪  ##########             |
}
*)

(*
$P{ pwwSubTopR1:
@
|---------------------------------------------------------------------------------------|
|⥫,  ࠡ⠢訥    6 楢                                    |
|---------------------------------------------------------------------------------------|
|⥫                         |                        |    |    |
|---------------------------------|-------------------------------|----------|----------|
}
*)

(*
$P{ pwwSubTopR0:
@
|---------------------------------------------------------------------------------------|
|⥫,  ࠡ⠢訥    3 楢                                    |
|---------------------------------------------------------------------------------------|
|⥫                         |                        |    |    |
|---------------------------------|-------------------------------|----------|----------|
}
*)

(*
$P{ pwwSubTopM1:
@
|---------------------------------------------------------------------------------------|
|⥫,  ࠡ⠢訥  થ   6 楢                                    |
|---------------------------------------------------------------------------------------|
|⥫                         |㯯 ப                   |    |    |
|---------------------------------|-------------------------------|----------|----------|
}
*)

(*
$P{ pwwSubTopM0:
@
|---------------------------------------------------------------------------------------|
|⥫,  ࠡ⠢訥  થ   3 楢                                    |
|---------------------------------------------------------------------------------------|
|⥫                         |㯯 ப                   |    |    |
|---------------------------------|-------------------------------|----------|----------|
}
*)

(*
$P{ pwwLine:
Staff.TSN, L, ""
Man.Name, L, ""
?, L, ""
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
@
|##### ###########################|#### ##########################|##########|##########|
}
*)

(*
$P{ pwwBot:
@
=(c) Polak===============================================================================
}
*)

 PRIVATE PROCEDURE pww_PrintGroup(ODPrmt: SCAL[2]);
 BEGIN
  IF SELECT(tmpR, tmpR, ODPrmt) THEN
   MAKEPART(R, ^("pwwSubTopR"+ODPrmt));
   WHILE OCCURE(tmpR) DO
    PROMPT(": " + tmpR.TSN + " " + tmpR.Route);
    SEARCH(Route, Route, , tmpR.Route);
    SEARCH(Staff, TSN, , tmpR.TSN);
    CONFORM(Staff, Man);
    MAKEPART(R, pwwLine, Route.Route, Route.Name, tmpR.LastD, tmpR.LastPD);
    NEXT(tmpR);
   END; (* WHILE OCCURE(tmpR) ... *)
  END;
  IF SELECT(tmpM, tmpM, ODPrmt) THEN
   MAKEPART(R, ^("pwwSubTopM"+ODPrmt));
   WHILE OCCURE(tmpM) DO
    PROMPT(": " + tmpM.TSN + " " + tmpM.MarkG);
    SEARCH(MarkG, MarkG, , tmpM.MarkG);
    SEARCH(Staff, TSN, , tmpM.TSN);
    CONFORM(Staff, Man);
    MAKEPART(R, pwwLine, MarkG.MarkG, MarkG.Name, tmpM.LastD, tmpM.LastPD);
    NEXT(tmpM);
   END; (* WHILE OCCURE(tmpM) ... *)
  END;
 END {pww_PrintGroup};

 PRIVATE PROCEDURE Print_PermitWoWork(D: DATE);
  CONST
   RepName = "PWWRM";
  VAR
   atrMethod: L_BegRWS.tAutorizeToRouteMethod;
 BEGIN
  atrMethod:=L_BegRWS.E_AuthorizeToRouteMethod(D);
  L_AFM.MakeIndex("tmpR", "ODPrmt: SCAL[2];" +
                          "TSN   : LIKE(Staff.TSN); " +
                          "Route : LIKE(Route.Route); " +
                          "LastD : DATE; " +
                          "LastPD: DATE");
  L_AFM.MakeIndex("tmpM", "ODPrmt: SCAL[2]; " +
                          "TSN   : LIKE(Staff.TSN); " +
                          "MarkG : LIKE(MarkG.MarkG); " +
                          "LastD : DATE; " +
                          "LastPD: DATE");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(" : " + Staff.TSN);
   IF L_Staff.rInState(D) THEN
    CONFORM(StaffLog, Officer);
    IF L_Env.IsRouteDriver() THEN
     pww_OneStaff(D, atrMethod);
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, pwwTop, RepName);
  pww_PrintGroup(1);
  pww_PrintGroup(0);
  MAKEPART(R, pwwBot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("tmpR");
  L_AFM.AF_PurgeTemp("tmpM");
 END {Print_PermitWoWork};

 PRIVATE PROCEDURE Do_Route(fr, ut: DATE);
 BEGIN
  Create_haRou();
  Prepare(1, 0, 0, fr, ut);
  Print_Route("DWWRA", fr, ut);
  L_AFM.AF_PurgeTemp("haRou");
  LIKEMENU(Survey, "");
 END {Do_Route};

 PUBLIC PROCEDURE Do_Route_ByCurPer();
 BEGIN
  Do_Route(Memo.ud_fr(), Memo.ud_ut());
 END {Do_Route_ByCurPer};

 PRIVATE PROCEDURE Do_Mark(fr, ut: DATE);
 BEGIN
  Create_haMrk();
  Prepare(0, 1, 0, fr, ut);
  Print_Mark("DWWMA", fr, ut);
  L_AFM.AF_PurgeTemp("haMrk");
  LIKEMENU(Survey, "");
 END {Do_Mark};

 PUBLIC PROCEDURE Do_Mark_ByCurPer();
 BEGIN
  Do_Mark(Memo.ud_fr(), Memo.ud_ut());
 END {Do_Mark_ByCurPer};

 PUBLIC PROCEDURE Do_PermitWoWork();
 BEGIN
  Create_haRou();
  Create_haMrk();
  Prepare(1, 1, 1, SYSDATE() - 183, SYSDATE());
  Print_PermitWoWork(SYSDATE());
  L_AFM.AF_PurgeTemp("haRou");
  L_AFM.AF_PurgeTemp("haMrk");
  LIKEMENU(Survey, "");
 END {Do_PermitWoWork};

END.