(*
%Copyright   (c) Polak Computer System
%Author      25.09.2000 17:26:00 BOR
%Purpose     ᠭ  ⥫ 䠩 - ⠡ ઠ
%Type        library
%Specific    AP
%Modified    15.07.2014 10:49:28 POLAK\GAV
%Environment
*)

 MODULE D_CarTb [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  RunType    = NUMERIC[2];
  TimType    = NUMERIC[3];
  RCDType    = SCAL[10];
  DtlRCDType = SCAL[1000];

 PRIVATE TYPE
  tRCD = NUMERIC[3][8];

 PUBLIC CONST
  rcd_Nothing                     = 0;
  rcd_Line                        = 1;

  rcd_Repair                      = 2;
  dtlRCD_TO2        = 201;
  dtlRCD_FullDayRep = 202;
  dtlRCD_Overhaul   = 203;

  rcd_Outage                      = 3;
  dtlRCD_OutageInWaitingForRepair = 301;
  dtlRCD_OutageInGoodState        = 302;

  rcd_Reserv                      = 4;
  rcd_Fictive                     = 9;

  dtlRCD_InState   = 901; (*  宧⢥ *)
  dtlRCD_Inventory = 902; (*  - ⭥ᥭ     ਮ *)
  dtlRCD_NoData    = 903; (*   *)

 IMPORT L_General, L_DatTim, L_Str, L_AFM, Math, L_EC, E_Way, L_Env, DBD,
        L_Way, L_Car, L_Rpr, P_Mark, P_Firm, D_RWS;

 PRIVATE VAR
  _From,
  _UpTo     : DATE;
  CarTbReuse: SCAL[2];

 PRIVATE PROCEDURE GetVolDays(_Days: NUMERIC[6]; _Vol: NUMERIC[0]): NUMERIC[3];
 BEGIN
  IF ~!_Vol THEN
   RETURN _Days * _Vol;
  ELSE
   RETURN _Vol;
  END;
 END {GetVolDays};

 PUBLIC PROCEDURE PasVol(_Days: NUMERIC[6]; D: DATE): NUMERIC[3];
 BEGIN
  RETURN GetVolDays(_Days, P_Mark.GetP_PasVol(Mark.Mark, D));
 END {PasVol};

 PUBLIC PROCEDURE PVLim(_Days: NUMERIC[6]; D: DATE): NUMERIC[3];
 BEGIN
  RETURN GetVolDays(_Days, P_Mark.GetP_PVLim(Mark.Mark, D));
 END {PVLim};

 PUBLIC PROCEDURE PVSitting(_Days: NUMERIC[6]; D: DATE): NUMERIC[3];
 BEGIN
  RETURN GetVolDays(_Days, P_Mark.GetP_PVSitting(Mark.Mark, D));
 END {PVSitting};

 PUBLIC PROCEDURE Create_CarTb();
 BEGIN
  IF DBD.FileExist(CarTb) THEN
   RETURN;
  END;
  CreateFILE(CarTb, "", " ઠ", "");

  CreateFIELD(CarTb, BoxNbr,   LIKE(Car.BoxNbr),      "", "", "", "ࠦ", "");
  CreateFIELD(CarTb, Date,     DATE,                  "", "", "", "", "");
  CreateFIELD(CarTb, WJCode,   LIKE(WJMode.WJCode),   "", "", "", " ࠡ", "");
  CreateFIELD(CarTb, WJType,   LIKE(WJMode.WJType),   "", "", "", "ࠪ", "");
  CreateFIELD(CarTb, TKind,    LIKE(TKind.TKind),     "", "", "", " ॢ", "");
  CreateFIELD(CarTb, Route,    LIKE(Route.Route),     "", "", "", "", "");
  CreateFIELD(CarTb, Quality,  LIKE(Quality.Quality), "", "", "", "⢮", "");
  CreateFIELD(CarTb, TimTot,   TimType,               "", "0", "", "६", "");
  CreateFIELD(CarTb, RunTot,   RunType,               "", "0", "", "஡", "");

  CreateINDEXandLINK(CarTb, BoxNbr,  UNIQUE, Car,      BoxNbr, USER, "", "", BoxNbr, Date, WJCode, TKind, Route, Quality, WJType);
  CreateINDEXandLINK(CarTb, Date,    PLURAL, Calendar, Date,   USER, "", "", Date);
  CreateINDEXandLINK(CarTb, WJCode,  PLURAL, WJMode,   WJCode, USER, "", "", WJCode, BoxNbr, Date);
  CreateINDEXandLINK(CarTb, TKind,   PLURAL, TKind,    TKind,  USER, "", "", TKind, BoxNbr, Date);
  CreateINDEXandLINK(CarTb, Route,   PLURAL, Route,    Route,  USER, "", "", Route, BoxNbr, Date);
  CreateINDEXandLINK(CarTb, Quality, PLURAL, Quality, Quality, USER, "", "", Quality, BoxNbr, Date);
  CreateINDEX       (CarTb, WJType,  PLURAL,                         "", "", WJType, BoxNbr, Date);

  SetVersionOfFILE(CarTb, 0);
 END {Create_CarTb};

 PUBLIC PROCEDURE Create_CarTb2();
 BEGIN
  IF DBD.FileExist(CarTb2) THEN
   RETURN;
  END;
  CreateFILE(CarTb2, "", " ઠ 2", "");

  CreateFIELD(CarTb2, MyFirm,   P_Firm.tMyFirm,       "",  "", "", "", "");
  CreateFIELD(CarTb2, BoxNbr,   LIKE(Car.BoxNbr),     "",  "", "", "ࠦ", "");
  CreateFIELD(CarTb2, Mark,     LIKE(Mark.Mark),      "",  "", "", "ઠ", "");
  CreateFIELD(CarTb2, Purpose,  LIKE(CarLog.Purpose), "",  "", "", "祭", "");
  CreateFIELD(CarTb2, clDate,   DATE,              "",  "", "", " CarLog.Date", "");
  CreateFIELD(CarTb2, TKind,    LIKE(TKind.TKind), "",  "", "", " ॢ", "");
  CreateFIELD(CarTb2, Route,    LIKE(Route.Route), "",  "", "", "", "");
  CreateFIELD(CarTb2, DIO,      NUMERIC[6],        "", "0", "", "  宧⢥", "");
  CreateFIELD(CarTb2, RCarDays, tRCD,              "", "0", "", "設", "");
  CreateFIELD(CarTb2, RCarTims, tRCD,              "", "0", "", "設", "");
  CreateFIELD(CarTb2, Run,      RunType,   "", "0", "", "஡", "");

  CreateINDEXandLINK(CarTb2, BoxNbr, UNIQUE, Car,   BoxNbr, USER, "", "", BoxNbr, clDate, Mark, Purpose, TKind, Route, MyFirm);
  CreateINDEXandLINK(CarTb2, TKind,  PLURAL, TKind, TKind,  USER, "", "", TKind);
  CreateINDEXandLINK(CarTb2, Mark,   PLURAL, Mark,  Mark,   USER, "", "", Mark);
  CreateINDEXandLINK(CarTb2, Route,  PLURAL, Route, Route,  USER, "", "", Route);

  SetVersionOfFILE(CarTb2, 1);
 END {Create_CarTb2};

 PRIVATE PROCEDURE E_DtlRCarDay(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE): DtlRCDType;
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.DtlRCarDay);
  IF ~!Local THEN
   RETURN Local(trgBoxNbr, D);
  ELSE
   L_General.SetupRequired();
  END;
 END {E_DtlRCarDay};

 PRIVATE PROCEDURE DistributeCarTb2_ByLevel0();
  VAR
   _Run,
   _LnTim,
   _Tim   : NUMERIC[3];
   RCDT   : RCDType;
 BEGIN
  RCDT:=CarTb_RCarDay(E_DtlRCarDay(CarTb.BoxNbr, CarTb.Date));
  ADD(CarTb2, BoxNbr, , CarTb.BoxNbr, CarLog.Date, CarLog.Mark, CarLog.Purpose,
                        CarTb_DominantTKind(CarTb.BoxNbr, CarTb.Date), "", MyFirm.MyFirm,
      CarTb2.RCarDays[RCDT], 1);
  SELECT(TKind, TKind);
  WHILE OCCURE(TKind) DO
   _Run  := CarTb_GetRunTK(CarTb.BoxNbr, CarTb.Date, TKind.TKind);
   _Tim  := CarTb_GetTimTK(CarTb.BoxNbr, CarTb.Date, TKind.TKind);
   _LnTim:= CarTb_GetLnTimTK(CarTb.BoxNbr, CarTb.Date, TKind.TKind);
   IF _Run # 0 THEN
    ADD(CarTb2, BoxNbr, , CarTb.BoxNbr, CarLog.Date, CarLog.Mark, CarLog.Purpose, TKind.TKind, "", MyFirm.MyFirm,
        CarTb2.Run, _Run,
        CarTb2.RCarTims[RCDT], _LnTim);
   ELSIF _Tim # 0 THEN
    ADD(CarTb2, BoxNbr, , CarTb.BoxNbr, CarLog.Date, CarLog.Mark, CarLog.Purpose, TKind.TKind, "", MyFirm.MyFirm,
        CarTb2.RCarTims[RCDT], _Tim);
   END;
   NEXT(TKind);
  END; (* WHILE OCCURE(TKind) ... *)
 END {DistributeCarTb2_ByLevel0};

 PRIVATE PROCEDURE DistributeCarTb2_ByLevel1();
  VAR
   _Run    : RunType;
   _Tim,
   _TotTim : NUMERIC[3];
   _RCD,
   _Rest   : NUMERIC[3];
 BEGIN
  _TotTim:=CarTb_GetTimWJT(CarTb.BoxNbr, CarTb.Date, L_Way.WJType_Work);
  L_General.Assert(_TotTim > 0, "饥 ६  । = 0 ?");
  _Rest:=1;
  SELECT(TKind, TKind);
  WHILE OCCURE(TKind) DO
   _Run:=CarTb_GetRunTK(CarTb.BoxNbr, CarTb.Date, TKind.TKind);
   _Tim:=CarTb_GetLnTimTK(CarTb.BoxNbr, CarTb.Date, TKind.TKind);
   IF (_Run # 0) | (_Tim # 0) THEN
    _RCD:=_Tim / _TotTim;
    ADD(CarTb2, BoxNbr, , CarTb.BoxNbr, CarLog.Date, CarLog.Mark, CarLog.Purpose, TKind.TKind, "", MyFirm.MyFirm,
        CarTb2.RCarDays[rcd_Line], _RCD,
        CarTb2.RCarTims[rcd_Line], _Tim,
        CarTb2.Run,                _Run);
    DEC(_Rest, _RCD);
   END;
   NEXT(TKind);
  END; (* WHILE OCCURE(TKind) ... *)
  IF _Rest # 0 THEN
   ADD(CarTb2, BoxNbr, , CarTb2.BoxNbr, CarLog.Date, CarLog.Mark, CarLog.Purpose, CarTb2.TKind, "", MyFirm.MyFirm,
       CarTb2.RCarDays[rcd_Line], _Rest);
  END;
 END {DistributeCarTb2_ByLevel1};

 PRIVATE PROCEDURE DistributeCarTb2_ByLevel2(ByDominantRoute: SCAL[2]);
  VAR
   _TotTim : NUMERIC[3];
   _Routes : LIKE(Route.Route)[16];
   _Times  : NUMERIC[3]       [16];
   _Runs   : NUMERIC[2]       [16];
   _RCD,
   maxRCD,
   _Rest   : NUMERIC[3];
   Idx,
   maxIdx  : NUMERIC[0];
   dmnRoute: LIKE(Route.Route);
 BEGIN
  _TotTim:=CarTb_GetTimWJT(CarTb.BoxNbr, CarTb.Date, L_Way.WJType_Work);
  L_General.Assert(_TotTim > 0, "饥 ६  । = 0 ?");
  CarTb_GetLineParmsByRoute(CarTb.BoxNbr, CarTb.Date, _Routes, _Times, _Runs, dmnRoute);
  _Rest :=1;
  maxRCD:=0;
  Idx   :=0;
  WHILE ~!_Routes[Idx] DO
   IF ByDominantRoute THEN
    IF _Routes[Idx] = dmnRoute THEN
     _RCD:=1;
    ELSE
     _RCD:=0;
    END;
   ELSE
    _RCD:=_Times[Idx] / _TotTim;
   END;
   SEARCH(Route, Route, , _Routes[Idx]);
   ADD(CarTb2, BoxNbr, , CarTb.BoxNbr, CarLog.Date, CarLog.Mark, CarLog.Purpose,
                         L_Way.GetRouteTKind(CarTb.Date, 1), Route.Route, MyFirm.MyFirm,
       CarTb2.RCarDays[rcd_Line], _RCD,
       CarTb2.RCarTims[rcd_Line], _Times[Idx],
       CarTb2.Run,                _Runs[Idx]);
   IF maxRCD <= _RCD THEN
    maxIdx:=Idx;
    maxRCD:=_RCD;
   END;
   DEC(_Rest, _RCD);
   INC(Idx);
  END;
  IF _Rest # 0 THEN
   SEARCH(Route, Route, , _Routes[maxIdx]);
   ADD(CarTb2, BoxNbr, , CarTb2.BoxNbr, CarLog.Date, CarLog.Mark, CarLog.Purpose,
                         L_Way.GetRouteTKind(CarTb.Date, 1), Route.Route, MyFirm.MyFirm,
       CarTb2.RCarDays[rcd_Line], _Rest);
  END;
 END {DistributeCarTb2_ByLevel2};

 PRIVATE PROCEDURE CarTb2_TotalRCarDays(): NUMERIC[3];
 BEGIN
  RETURN CarTb2.RCarDays[rcd_Nothing] +
         CarTb2.RCarDays[rcd_Line]    +
         CarTb2.RCarDays[rcd_Repair]  +
         CarTb2.RCarDays[rcd_Reserv]  +
         CarTb2.RCarDays[rcd_Outage]  ;
 END {CarTb2_TotalRCarDays};

 PRIVATE PROCEDURE E_GetRepEventOnCarTbReflectionProc(): PROC;
 BEGIN
  RETURN PROCREF(E_Way.GetRepEventOnCarTbReflection);
 END {E_GetRepEventOnCarTbReflectionProc};

 PRIVATE PROCEDURE E_GetRepEventOnCarTbReflection(    D        : DATE;
                                                      _RepEvent: LIKE(RepEvent.RepEvent);
                                                  VAR _WJCode  : LIKE(WJMode.WJCode);
                                                  VAR _Route   : LIKE(Route.Route);
                                                  VAR _Quality : LIKE(Quality.Quality);
                                                  VAR RETime   : NUMERIC[3]);
  VAR
   Local: PROC;
 BEGIN
  Local:=E_GetRepEventOnCarTbReflectionProc();
  L_General.CallUs(~!Local);
  Local(D, _RepEvent, _WJCode, _Route, _Quality, RETime);
 END {E_GetRepEventOnCarTbReflection};

 PRIVATE PROCEDURE PutRepEvent(D: DATE; trgRepEvent: LIKE(RepEvent.RepEvent));
  VAR
   trgWJCode : LIKE(WJMode.WJCode);
   trgRoute  : LIKE(Route.Route);
   trgTKind  : LIKE(TKind.TKind);
   trgQuality: LIKE(Quality.Quality);
   trgRETime : NUMERIC[3];
   trgRun    : RunType;
 BEGIN
  IF L_Car.CarIsInOperation(Car.BoxNbr, D) THEN
   trgRun:=0;
   IF L_General.GetAPSiteID() = "IV" THEN
    E_GetRepEventOnCarTbReflection(D, trgRepEvent, trgWJCode, trgRoute, trgQuality, trgRETime);
    IF ~!trgWJCode THEN
     IF ~SELECT(CarTb, BoxNbr, Car.BoxNbr, D, trgWJCode) & ~SELECT(CarTb, BoxNbr, Car.BoxNbr, D, "10") THEN
      SELECT(CarTb, BoxNbr, , Car.BoxNbr, D);
      WHILE OCCURE(CarTb) DO
       INC(trgRun, CarTb.RunTot);
       REMOVE(CarTb);
      END; (* WHILE OCCURE(CarTb) ... *)
     END;
    END;
   END;
   IF ~SELECT(CarTb, BoxNbr, Car.BoxNbr, D) THEN
    E_GetRepEventOnCarTbReflection(D, trgRepEvent, trgWJCode, trgRoute, trgQuality, trgRETime);
    IF ~!trgWJCode THEN
     L_General.Assert(SEARCH(WJMode, WJCode, trgWJCode), "    ࠡ " + trgWJCode);
     IF ~!trgRoute THEN
      L_General.Assert(SEARCH(Route,  Route,  trgRoute),  "   " + trgRoute);
      trgTKind:=L_Way.GetRouteTKind(D, 1);
     ELSE
      L_Car.StandOnCarLog(Car.BoxNbr, D);
      trgTKind:=CarLog.TKind;
     END;
     ADD(CarTb, BoxNbr, , Car.BoxNbr, D, trgWJCode, trgTKind, trgRoute, trgQuality, WJMode.WJType,
         CarTb.TimTot, trgRETime,
         CarTb.RunTot, trgRun);
    END;
   END;
  END;
 END {PutRepEvent};

 PRIVATE PROCEDURE PutByCurrentCarEvn();
  VAR
   B,
   E       : DATE;
 BEGIN
  B:=Math.Max(CarEvn.StartD, _From);
  E:=Math.Min(CarEvn.StopD,  _UpTo);
  WHILE B <= E DO
   PutRepEvent(B, CarEvn.RepEvent);
   INC(B);
  END;
 END {PutByCurrentCarEvn};

 PRIVATE PROCEDURE PutByCurrentRprS(D: DATE);
 BEGIN
  L_Rpr.E_GatherRequiredRepEvent(0);
  IF SELECT(RepEv, RepEvent) THEN
   PutRepEvent(D, RepEv.RepEvent);
  END;
 END {PutByCurrentRprS};

 PUBLIC PROCEDURE Gather_CarTb(B, E: DATE; SingleCar: SCAL[2]);
  VAR
   D,
   DateOfTrip: DATE;
 BEGIN
  APP.Get().NewPrompt("ઠ ");
  L_Rpr.Create_RepEv();
  _From:=B;
  _UpTo:=E;
  IF SingleCar THEN
   L_General.Assert(ACCESS(Car), " ⠭ ⥪  Car");
   CHANGESEL(Car, BoxNbr, , Car.BoxNbr);
  ELSE
   SELECT(Car, BoxNbr);
  END;
  WHILE OCCURE(Car) DO
   IF L_Env.RealBoxNbr(Car.BoxNbr) THEN
    SELECT(RWayS, sBoxNbr, , L_Way.rwsStat_Rated, Car.BoxNbr);
    SRCINSEL(RWayS, GE, , _From - 5);
    WHILE OCCURE(RWayS) & (RWayS.Date <= _UpTo) DO
     PROMPT(Car.BoxNbr + " :    " + L_DatTim.DateStr(RWayS.Date));
     CONFORM(RWayS, RWayJ);
     WHILE OCCURE(RWayJ) DO
      CONFORM(RWayJ, Quality);
      IF Quality.Type # 0 THEN
       DateOfTrip:=L_Way.GetDateOfRWayJ();
       IF L_DatTim.IsActive_Inc(DateOfTrip, _From, _UpTo) THEN
        CONFORM(RWayJ, SEJobs);
        CONFORM(SEJobs, Route);
        CONFORM(SEJobs, WJMode);
        ADD(CarTb, BoxNbr, , Car.BoxNbr, DateOfTrip, SEJobs.WJCode, L_Way.GetRouteTKind(RWayS.Date, 1),
                             Route.Route, RWayJ.Quality, WJMode.WJType,
                CarTb.TimTot, RWayJ.StopT-RWayJ.StartT,
                CarTb.RunTot, RWayJ.Run * RWayJ.Fact);
       END;
      END;
      NEXT(RWayJ);
     END; (* WHILE OCCURE(RWayJ) ... *)
     NEXT(RWayS);
    END; (* WHILE OCCURE(RWayS) ... *)

    IF ~!E_GetRepEventOnCarTbReflectionProc() THEN
     IF L_Rpr.RprLev(B) = L_Rpr.rprl_Active THEN
      D:=_From;
      WHILE D <= _UpTo DO
       PROMPT(Car.BoxNbr + " :    " + L_DatTim.DateStr(D));
       IF HasOpenRprS(D) THEN
        L_Rpr.Clear_RepEv();
        PutByCurrentRprS(D);
       END;
       INC(D);
      END;
     ELSE
      SELECT(CarEvn, BoxNbr, , Car.BoxNbr);
      SRCINSEL(CarEvn, LE, , _UpTo);
      WHILE OCCURE(CarEvn) DO
       IF CarEvn.Source # L_Car.src_FrCast THEN
        PutByCurrentCarEvn();
       END;
       PREV(CarEvn);
      END; (* WHILE OCCURE(CarEvn) ... *)
     END; (* IF L_Rpr.RprLev(B) = L_Rpr.rprl_Active...*)
    END; (* IF ~!E_GetRepEventOnCarTbReflectionProc()...*)
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
  L_Rpr.Purge_RepEv();
 END {Gather_CarTb};

 PUBLIC PROCEDURE Purge_CarTb();
 BEGIN
  L_AFM.AF_PurgeTemp("CarTb");
 END {Purge_CarTb};

 PUBLIC PROCEDURE Purge_CarTb2();
 BEGIN
  Purge_CarTb();
  L_AFM.AF_PurgeTemp("CarTb2");
 END {Purge_CarTb2};

 PUBLIC PROCEDURE extPrepare_CarTb(PerB, PerE: DATE; SingleCar, Silent: SCAL[2]);
 BEGIN
  Create_CarTb();
  IF SingleCar THEN
   L_AFM.AF_CreateTemp("CarTb", "CarTb");
   Gather_CarTb(PerB, PerE, SingleCar);
  ELSE
   L_AFM.NewReusableFile("CarTb", "CrTb1", L_General.timeCond_InIntvl, PerB, PerE);
   CarTbReuse:=L_AFM.CanReuseFile("CarTb", Silent);
   IF ~CarTbReuse THEN
    L_AFM.CreateReusableFile("CarTb");
    Gather_CarTb(PerB, PerE, SingleCar);
    L_AFM.ReAttachReusableFile("CarTb");
   END; (* IF ~L_AFM.CanReuseFile("CarTb", Silent) ... *)
  END;
 END {extPrepare_CarTb};

 PUBLIC PROCEDURE Prepare_CarTb(PerB, PerE: DATE; SingleCar: SCAL[2]);
 BEGIN
  extPrepare_CarTb(PerB, PerE, SingleCar, 0);
 END {Prepare_CarTb};

 PRIVATE PROCEDURE Create_MarkT1();
 BEGIN
  CreateFILE(MarkT1, "", "  थ", "");

  CreateFIELD(MarkT1, MyFirm,   P_Firm.tMyFirm,   "",  "", "", "", "");
  CreateFIELD(MarkT1, Purpose,  LIKE(CarLog.Purpose), "",  "", "", "祭", "");
  CreateFIELD(MarkT1, Mark,     LIKE(Mark.Mark),  "",  "", "", "ઠ", "");
  CreateFIELD(MarkT1, TKind,    LIKE(TKind.TKind), "",  "", "", " ॢ", "");
  CreateFIELD(MarkT1, Route,    LIKE(Route.Route), "",  "", "", "", "");
  CreateFIELD(MarkT1, DIO,      NUMERIC[6],        "", "0", "", "  宧⢥", "");
  CreateFIELD(MarkT1, RCarDays, tRCD,              "", "0", "", "設", "");

  CreateINDEX(MarkT1, toAdd, UNIQUE, "", "", MyFirm, Purpose, Mark, TKind, Route);

  SetVersionOfFILE(MarkT1, 0);

  L_AFM.AF_CreateTemp("MarkT1", "MarkT1");
 END {Create_MarkT1};

 PRIVATE PROCEDURE AddMarkT1ByCarTb2();
 BEGIN
  ADD(MarkT1, toAdd, , MyFirm.MyFirm, CarTb2.Purpose, CarTb2.Mark, CarTb2.TKind, CarTb2.Route,
       MarkT1.RCarDays[rcd_Nothing], CarTb2.RCarDays[rcd_Nothing],
       MarkT1.RCarDays[rcd_Line]   , CarTb2.RCarDays[rcd_Line]   ,
       MarkT1.RCarDays[rcd_Repair] , CarTb2.RCarDays[rcd_Repair] ,
       MarkT1.RCarDays[rcd_Reserv] , CarTb2.RCarDays[rcd_Reserv] ,
       MarkT1.RCarDays[rcd_Outage] , CarTb2.RCarDays[rcd_Outage] ,
       MarkT1.DIO                  , CarTb2.DIO);
 END {AddMarkT1ByCarTb2};

 PRIVATE PROCEDURE SetRCD(DstArr: tRCD; Cfc: FLOAT): tRCD;
  VAR
   Result: tRCD;
 BEGIN
  SETZERO(Result);
  Result[rcd_Nothing]:=DstArr[rcd_Nothing] * Cfc;
  Result[rcd_Line]   :=DstArr[rcd_Line]    * Cfc;
  Result[rcd_Repair] :=DstArr[rcd_Repair]  * Cfc;
  Result[rcd_Reserv] :=DstArr[rcd_Reserv]  * Cfc;
  Result[rcd_Outage] :=DstArr[rcd_Outage]  * Cfc;
  RETURN Result;
 END {SetRCD};

 PUBLIC PROCEDURE Gather_CarTb2(PerB, PerE: DATE);
  VAR
   RCDT : RCDType;
   Level: NUMERIC[0];
   tmpDIO,
   totDIO,
   totRCD,
   mrkDIO,
   rstDIO   : NUMERIC[6];
   mrkLin   : NUMERIC[3];
   tmpRCD,
   mrkRCD,
   rstRCD   : tRCD;
   mrkCfc   : FLOAT;
 BEGIN
  Level:=L_Way.E_CarTbLevel(PerE);
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   IF L_Env.RealBoxNbr(Car.BoxNbr) THEN
    SELECT(CarTb, BoxNbr, , Car.BoxNbr);
    WHILE OCCURE(CarTb) DO
     PROMPT("। " + Car.BoxNbr+" "+L_DatTim.DateStr(CarTb.Date));
     NARROWSEL(CarTb, Date);
     L_Car.StandOnCarLog(CarTb.BoxNbr, CarTb.Date);
     IF CarLog.Status = L_Car.carst_InOperat THEN
      RCDT:=CarTb_RCarDay(E_DtlRCarDay(CarTb.BoxNbr, CarTb.Date));
      CONFORM(CarLog, Column);
      CONFORM(Column, MyFirm);
      IF    (Level = L_Way.ctbl_DmntTKind) | (RCDT # rcd_Line) THEN
       DistributeCarTb2_ByLevel0();
      ELSIF (Level = L_Way.ctbl_EveryTKind) THEN
       DistributeCarTb2_ByLevel1();
      ELSIF (Level = L_Way.ctbl_EveryRoute) THEN
       DistributeCarTb2_ByLevel2(0);
      ELSIF (Level = L_Way.ctbl_DmntRoute) THEN
       DistributeCarTb2_ByLevel2(1); (*⭮    ᨬ쭮 ࠡ⪮*)
      END;
     END; (* IF CarLog.Status... *)
     NEXTINEXTENDEDSEL(CarTb, Date);
    END; (* WHILE OCCURE(CarTb) ... *)
 
    PROMPT("। " + Car.BoxNbr);
    SELECT(CarLog, BoxNbr, , Car.BoxNbr);
    SRCINSEL(CarLog, LE, , PerE);
    WHILE OCCURE(CarLog) & (CarLog.DateE >= PerB) DO
     IF CarLog.Status = L_Car.carst_InOperat THEN
      totDIO:=L_DatTim.DATEINT(PerB, PerE, CarLog.Date, CarLog.DateE);
      IF totDIO > 0 THEN
       CONFORM(CarLog, Column);
       CONFORM(Column, MyFirm);
       CONFORM(CarLog, Mark);
       SETZERO(totRCD);
       SELECT(CarTb2, BoxNbr, , CarLog.BoxNbr, CarLog.Date);
       WHILE OCCURE(CarTb2) DO
        CarTb2.DIO    :=CarTb2_TotalRCarDays();
        CarTb2.Mark   :=CarLog.Mark;
        CarTb2.Purpose:=CarLog.Purpose;
        REPLACE(CarTb2);
        INC(totRCD, CarTb2.DIO);
        AddMarkT1ByCarTb2();
        NEXT(CarTb2);
       END; (* WHILE OCCURE(CarTb2) ... *)
       L_General.CallUs(totRCD <= totDIO);
       IF totDIO#totRCD THEN
        ADD(CarTb2, BoxNbr, , Car.BoxNbr, CarLog.Date, CarLog.Mark, CarLog.Purpose,
                              L_General.EMPTY_NUMBER(), "",  MyFirm.MyFirm,
             CarTb2.RCarDays[rcd_Nothing], totDIO-totRCD,
             CarTb2.DIO,                   totDIO-totRCD);
        AddMarkT1ByCarTb2();
       END;
      END; (* IF totDIO > 0 *)
     END; (* IF CarLog.Status *)
     PREV(CarLog);
    END; (* WHILE OCCURE(CarLog) *)
   END; (* IF L_Env.RealBoxNbr *)

   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)

  SELECT(MarkT1, toAdd);
  WHILE OCCURE(MarkT1) DO
   PROMPT("  । " + MarkT1.Mark);
   NARROWSEL(MarkT1, MyFirm, Purpose, Mark);
   SETZERO(mrkRCD, mrkDIO, mrkLin);
   WHILE OCCURE(MarkT1) DO
    IF ~!MarkT1.Route & D_RWS.E_IsRoute2Distribute(MarkT1.Route, PerE) THEN
     INC(mrkLin, MarkT1.RCarDays[rcd_Line]);
    ELSE
     INC(mrkRCD[rcd_Nothing], MarkT1.RCarDays[rcd_Nothing]);
     INC(mrkRCD[rcd_Line],    MarkT1.RCarDays[rcd_Line]   );
     INC(mrkRCD[rcd_Repair],  MarkT1.RCarDays[rcd_Repair] );
     INC(mrkRCD[rcd_Reserv],  MarkT1.RCarDays[rcd_Reserv] );
     INC(mrkRCD[rcd_Outage],  MarkT1.RCarDays[rcd_Outage] );
     INC(mrkDIO, MarkT1.DIO);
    END;
    NEXT(MarkT1);
   END;
   IF mrkLin > 0 THEN
    SETZERO(rstRCD, rstDIO);
    FIRST(MarkT1);
    WHILE OCCURE(MarkT1) DO
     IF ~!MarkT1.Route & D_RWS.E_IsRoute2Distribute(MarkT1.Route, PerE) THEN
      mrkCfc:=MarkT1.RCarDays[rcd_Line]/mrkLin;
      tmpRCD:=SetRCD(mrkRCD, mrkCfc);
      tmpDIO:=mrkDIO * mrkCfc;
     ELSE
      tmpRCD:=SetRCD(MarkT1.RCarDays, -1);
      tmpDIO:=MarkT1.DIO * (-1);
     END;
     ADD(CarTb2, BoxNbr, , L_General.EMPTY_NUMBER(), L_General.EMPTY_DATE(),
                           MarkT1.Mark, MarkT1.Purpose, MarkT1.TKind, MarkT1.Route, MarkT1.MyFirm,
         CarTb2.RCarDays[rcd_Nothing], tmpRCD[rcd_Nothing],
         CarTb2.RCarDays[rcd_Line],    tmpRCD[rcd_Line],
         CarTb2.RCarDays[rcd_Repair],  tmpRCD[rcd_Repair],
         CarTb2.RCarDays[rcd_Reserv],  tmpRCD[rcd_Reserv],
         CarTb2.RCarDays[rcd_Outage],  tmpRCD[rcd_Outage],
         CarTb2.DIO,                   tmpDIO);
     INC(rstRCD[rcd_Nothing], CarTb2.RCarDays[rcd_Nothing]);
     INC(rstRCD[rcd_Line],    CarTb2.RCarDays[rcd_Line]   );
     INC(rstRCD[rcd_Repair],  CarTb2.RCarDays[rcd_Repair] );
     INC(rstRCD[rcd_Reserv],  CarTb2.RCarDays[rcd_Reserv] );
     INC(rstRCD[rcd_Outage],  CarTb2.RCarDays[rcd_Outage] );
     INC(rstDIO,              CarTb2.DIO);
     NEXT(MarkT1);
    END;
    FIRST(MarkT1);
    ADD(CarTb2, BoxNbr, , L_General.EMPTY_NUMBER(), L_General.EMPTY_DATE(),
                          MarkT1.Mark, MarkT1.Purpose, MarkT1.TKind, MarkT1.Route, MarkT1.MyFirm,
        CarTb2.RCarDays[rcd_Nothing], rstRCD[rcd_Nothing],
        CarTb2.RCarDays[rcd_Line],    rstRCD[rcd_Line],
        CarTb2.RCarDays[rcd_Repair],  rstRCD[rcd_Repair],
        CarTb2.RCarDays[rcd_Reserv],  rstRCD[rcd_Reserv],
        CarTb2.RCarDays[rcd_Outage],  rstRCD[rcd_Outage],
        CarTb2.DIO,                   rstDIO);
   END;
   NEXTINEXTENDEDSEL(MarkT1, MyFirm, Purpose, Mark);
  END; (* WHILE OCCURE(MarkT1) ... *)
 END {Gather_CarTb2};

 PUBLIC PROCEDURE Prepare_CarTb2(PerB, PerE: DATE);
 BEGIN
  Prepare_CarTb(PerB, PerE, 0);
  Create_CarTb2();
  L_AFM.NewReusableFile("CarTb2", "CrTb2", L_General.timeCond_InIntvl, PerB, PerE);
  IF ~CarTbReuse | ~L_AFM.CanReuseFile("CarTb2", 1) THEN
   L_AFM.CreateReusableFile("CarTb2");
   Create_MarkT1();
   Gather_CarTb2(PerB, PerE);
   L_AFM.ReAttachReusableFile("CarTb2");
  END;
 END {Prepare_CarTb2};

 PRIVATE PROCEDURE HasOpenRprS(OnDate: DATE): SCAL[2];
 BEGIN
  SELECT(RprS, CUCopy, , Car.CUCopy);
  SRCINSEL(RprS, LE, , OnDate);
  WHILE OCCURE(RprS) & (RprS.Status = L_Rpr.ms_Cancel) DO
   PREV(RprS);
  END;

  IF OCCURE(RprS) THEN
   RETURN RprS.EDate >= OnDate;
  ELSE
   RETURN 0;
  END;
 END {HasOpenRprS};

 PRIVATE PROCEDURE CarTb_GetRun(Index, FieldValue: STRING[];
                                _BoxNbr: LIKE(Car.BoxNbr); _Date: DATE): RunType;
  VAR
   _RunTot: RunType;
 BEGIN
  SAVE(CarTb);
  SETZERO(_RunTot);
  IF !FieldValue THEN
   SELECT(CarTb, ^Index, , _BoxNbr, _Date);
  ELSE
   SELECT(CarTb, ^Index, , FieldValue, _BoxNbr, _Date);
  END;
  WHILE OCCURE(CarTb) DO
   IF CarTb.WJType # L_Way.WJType_Void THEN
    INC(_RunTot, CarTb.RunTot);
   END;
   NEXT(CarTb);
  END; (* WHILE OCCURE(CarTb) ... *)
  RESTORE(CarTb);
  RETURN _RunTot;
 END {CarTb_GetRun};

 PRIVATE PROCEDURE CarTb_GetTim(Index, FieldValue: STRING[];
                                _BoxNbr: LIKE(Car.BoxNbr); _Date: DATE): TimType;
  VAR
   _TimTot: TimType;
 BEGIN
  SAVE(CarTb);
  SETZERO(_TimTot);
  IF !FieldValue THEN
   SELECT(CarTb, ^Index, , _BoxNbr, _Date);
  ELSE
   SELECT(CarTb, ^Index, , FieldValue, _BoxNbr, _Date);
  END;
  WHILE OCCURE(CarTb) DO
   IF CarTb.WJType # L_Way.WJType_Void THEN
    INC(_TimTot, CarTb.TimTot);
   END;
   NEXT(CarTb);
  END; (* WHILE OCCURE(CarTb) ... *)
  RESTORE(CarTb);
  RETURN _TimTot;
 END {CarTb_GetTim};

 PUBLIC PROCEDURE CarTb_GetRunTot(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE): RunType;
 BEGIN
  RETURN CarTb_GetRun("BoxNbr", "",  _BoxNbr, _Date);
 END {CarTb_GetRunTot};

 PUBLIC PROCEDURE CarTb_GetTimTot(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE): TimType;
 BEGIN
  RETURN CarTb_GetTim("BoxNbr", "", _BoxNbr, _Date);
 END {CarTb_GetTimTot};

 PUBLIC PROCEDURE CarTb_GetRunWJT(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE; _WJType: LIKE(WJMode.WJType)): RunType;
 BEGIN
  RETURN CarTb_GetRun("WJType", _WJType, _BoxNbr, _Date);
 END {CarTb_GetRunWJT};

 PUBLIC PROCEDURE CarTb_GetTimWJT(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE; _WJType: LIKE(WJMode.WJType)): TimType;
 BEGIN
  RETURN CarTb_GetTim("WJType", _WJType, _BoxNbr, _Date);
 END {CarTb_GetTimWJT};

 PUBLIC PROCEDURE CarTb_GetRunWJC(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE; _WJCode: LIKE(WJMode.WJCode)): RunType;
 BEGIN
  RETURN CarTb_GetRun("WJCode", _WJCode, _BoxNbr, _Date);
 END {CarTb_GetRunWJC};

 PUBLIC PROCEDURE CarTb_GetTimWJC(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE; _WJCode: LIKE(WJMode.WJCode)): TimType;
 BEGIN
  RETURN CarTb_GetTim("WJCode", _WJCode, _BoxNbr, _Date);
 END {CarTb_GetTimWJC};

 PUBLIC PROCEDURE CarTb_GetRunTK(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE; _TKind: LIKE(TKind.TKind)): RunType;
 BEGIN
  RETURN CarTb_GetRun("TKind", _TKind, _BoxNbr, _Date);
 END {CarTb_GetRunTK};

 PUBLIC PROCEDURE CarTb_GetTimTK(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE; _TKind: LIKE(TKind.TKind)): TimType;
 BEGIN
  RETURN CarTb_GetTim("TKind", _TKind, _BoxNbr, _Date);
 END {CarTb_GetTimTK};

 PUBLIC PROCEDURE CarTb_GetRunQlt(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE; _Quality: LIKE(Quality.Quality)): RunType;
 BEGIN
  RETURN CarTb_GetRun("Quality", _Quality, _BoxNbr, _Date);
 END {CarTb_GetRunQlt};

 PUBLIC PROCEDURE CarTb_GetTimQlt(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE; _Quality: LIKE(Quality.Quality)): TimType;
 BEGIN
  RETURN CarTb_GetTim("Quality", _Quality, _BoxNbr, _Date);
 END {CarTb_GetTimQlt};

 PUBLIC PROCEDURE CarTb_GetLnTimTK(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE; _TKind: LIKE(TKind.TKind)): TimType;
  VAR
   _TimTot: TimType;
 BEGIN
  SAVE(CarTb);
  SETZERO(_TimTot);
  SELECT(CarTb,  TKind, , _TKind, _BoxNbr, _Date);
  WHILE OCCURE(CarTb) DO
   IF CarTb.WJType = L_Way.WJType_Work THEN
    INC(_TimTot, CarTb.TimTot);
   END;
   NEXT(CarTb);
  END; (* WHILE OCCURE(CarTb) ... *)
  RESTORE(CarTb);
  RETURN _TimTot;
 END {CarTb_GetLnTimTK};

 PUBLIC PROCEDURE RCD_Nothing(): RCDType;
 BEGIN
  RETURN rcd_Nothing;
 END {RCD_Nothing};

 PUBLIC PROCEDURE RCD_Line(): RCDType;
 BEGIN
  RETURN rcd_Line;
 END {RCD_Line};

 PUBLIC PROCEDURE RCD_Repair(): RCDType;
 BEGIN
  RETURN rcd_Repair;
 END {RCD_Repair};

 PUBLIC PROCEDURE DtlRCD_TO2(): DtlRCDType;
 BEGIN
  RETURN dtlRCD_TO2;
 END {DtlRCD_TO2};

 PUBLIC PROCEDURE DtlRCD_FullDayRep(): DtlRCDType;
 BEGIN
  RETURN dtlRCD_FullDayRep;
 END {DtlRCD_FullDayRep};

 PUBLIC PROCEDURE RCD_Outage(): RCDType;
 BEGIN
  RETURN rcd_Outage;
 END {RCD_Outage};

 PUBLIC PROCEDURE DtlRCD_OutageInWaitingForRepair(): DtlRCDType;
 BEGIN
  RETURN dtlRCD_OutageInWaitingForRepair;
 END {DtlRCD_OutageInWaitingForRepair};

 PUBLIC PROCEDURE DtlRCD_OutageInGoodState(): DtlRCDType;
 BEGIN
  RETURN dtlRCD_OutageInGoodState;
 END {DtlRCD_OutageInGoodState};

 PUBLIC PROCEDURE RCD_Reserv(): RCDType;
 BEGIN
  RETURN rcd_Reserv;
 END {RCD_Reserv};

 PUBLIC PROCEDURE CarTb_RCarDay(DtlRCarDay: DtlRCDType): RCDType;
 BEGIN
  RETURN DtlRCarDay DIV 100;
 END {CarTb_RCarDay};

 PUBLIC PROCEDURE CarTb_BuildDtlRCarDay(RCarDay: RCDType): DtlRCDType;
 BEGIN
  RETURN RCarDay * 100;
 END {CarTb_BuildDtlRCarDay};

 PUBLIC PROCEDURE CarTb_IsNotDtlRCD(DtlRCarDay: DtlRCDType): SCAL[2];
 BEGIN
  RETURN (DtlRCarDay MOD 100) = 0;
 END {CarTb_IsNotDtlRCD};

 PUBLIC PROCEDURE CarTb_IsUserDefinedDtlRCD(DtlRCarDay: DtlRCDType): SCAL[2];
 BEGIN
  RETURN (DtlRCarDay MOD 100) > 50;
 END {CarTb_IsUserDefinedDtlRCD};

 PUBLIC PROCEDURE CarTb_RCarDayName(RCarDay: RCDType): STRING[];
 BEGIN
  RETURN L_Str.PoolItem("室|||⮩|| | | | |", RCarDay);
 END {CarTb_RCarDayName};

 PUBLIC PROCEDURE CarTb_DtlRCarDayName(DtlRCarDay: DtlRCDType): STRING[];
 BEGIN
  IF    CarTb_IsNotDtlRCD(DtlRCarDay) THEN
   RETURN CarTb_RCarDayName(CarTb_RCarDay(DtlRCarDay));
  ELSIF CarTb_IsUserDefinedDtlRCD(DtlRCarDay) THEN
   RETURN E_Way.UD_DtlRCDName(DtlRCarDay);
  ELSIF CarTb_RCarDay(DtlRCarDay) = rcd_Repair THEN
   RETURN L_Str.PoolItem("-2||६",
                         DtlRCarDay-CarTb_BuildDtlRCarDay(rcd_Repair)-1);
  ELSIF CarTb_RCarDay(DtlRCarDay) = rcd_Outage THEN
   RETURN L_Str.PoolItem("  ६| ࠢ ﭨ",
                         DtlRCarDay-CarTb_BuildDtlRCarDay(rcd_Outage)-1);
  ELSIF CarTb_RCarDay(DtlRCarDay) = rcd_Fictive THEN
   RETURN L_Str.PoolItem(" 宧⢥|E| ଠ樨",
                         DtlRCarDay-CarTb_BuildDtlRCarDay(rcd_Fictive)-1);
  ELSE
   RETURN "?????";
  END;
 END {CarTb_DtlRCarDayName};

 PUBLIC PROCEDURE CarTb_DominantTKind(_BoxNbr: LIKE(Car.BoxNbr); _Date: DATE): LIKE(TKind.TKind);
  VAR
   i      : NUMERIC[0];
   MaxTime: TimType;
   TimsTK : TimType[MAXOF(TKind.TKind)+1];
   Result : LIKE(TKind.TKind);
 BEGIN
  SETZERO(TimsTK);
  SAVE(CarTb);
  SELECT(CarTb, BoxNbr, , _BoxNbr, _Date);
  WHILE OCCURE(CarTb) DO
   INC(TimsTK [CarTb.TKind], CarTb.TimTot);
   NEXT(CarTb);
  END; (* WHILE OCCURE(CarTb) ... *)
  SETEMPTY(Result);
  SETZERO(i, MaxTime);
  WHILE i <= MAXOF(TKind.TKind) DO
   IF MaxTime < TimsTK[i] THEN
    Result :=i;
    MaxTime:=TimsTK[i];
   END;
   INC(i);
  END;
  RESTORE(CarTb);
  RETURN Result;
 END {CarTb_DominantTKind};

 PRIVATE PROCEDURE GetRouteIdx(VAR _Routes: LIKE(Route.Route)[];
                                   _Route : LIKE(Route.Route)):NUMERIC[0];
  VAR
   Idx: NUMERIC[0];
 BEGIN
  Idx:=0;
  WHILE ~!_Routes[Idx] & (_Routes[Idx] # _Route) DO
   INC(Idx);
  END;
  IF !_Routes[Idx] THEN
   _Routes[Idx]:=_Route;
  END;
  RETURN Idx;
 END {GetRouteIdx};

 PUBLIC PROCEDURE CarTb_GetLineParmsByRoute(    _BoxNbr : LIKE(Car.BoxNbr);
                                                _Date   : DATE;
                                            VAR _Routes : LIKE(Route.Route)[];
                                            VAR _Times  : TimType[];
                                            VAR _Runs   : RunType[];
                                            VAR dmnRoute: LIKE(Route.Route));
  VAR
   i      : NUMERIC[0];
   _TotT  : TimType[16];
   maxTotT: TimType;
 BEGIN
  SETEMPTY(_Routes, dmnRoute);
  SETZERO(_Times, _Runs, _TotT);
  SAVE(CarTb);
  SELECT(CarTb, BoxNbr, , _BoxNbr, _Date);
  WHILE OCCURE(CarTb) DO
   i:=GetRouteIdx(_Routes, CarTb.Route);
   INC(_Runs[i], CarTb.RunTot);
   INC(_TotT[i], CarTb.TimTot);
   CONFORM(CarTb, WJMode);
   IF WJMode.WJType = L_Way.WJType_Work THEN
    INC(_Times[i], CarTb.TimTot);
   END;
   NEXT(CarTb);
  END; (* WHILE OCCURE(CarTb) ... *)
  RESTORE(CarTb);
  maxTotT:=0;
  i:=0;
  WHILE ~!_Routes[i] DO
   IF _TotT[i] >= maxTotT THEN
    maxTotT :=_TotT[i];
    dmnRoute:=_Routes[i];
   END;
   INC(i);
  END;
 END {CarTb_GetLineParmsByRoute};

END.
