(*
%Copyright   (c) Polak Computer System
%Author      14.09.2000 12:59:27 GINA
%Purpose     ᠭ  ⥫ 䠩 - ⮯
%Type        library
%Specific    AP
%Modified    15.08.2014 17:17:24 POLAK\San
%Environment
*)

 MODULE D_Fl [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Way, L_Fuel, L_Env, L_Car, Math, L_AFM,
        Memo, L_Staff;

 PRIVATE PROCEDURE Create_FL1(wo_Details: SCAL[2]);
 BEGIN
  CREATE_TABLE(FL1_1, , "室 ⮯");

  CREATE_FIELD(FL1_1, BoxNbr,   LIKE(Car.BoxNbr),    , , , "ࠦ");
  CREATE_FIELD(FL1_1, clDate,   LIKE(CarLog.Date),   , , , "CarLog.Date");
  IF ~wo_Details THEN
   CREATE_FIELD(FL1_1, RWayS,   LIKE(RWayS.RWayS),    , , , "");
  END;
  CREATE_FIELD(FL1_1, Route,    LIKE(Route.Route),   , , , "");
  CREATE_FIELD(FL1_1, Modif,    LIKE(RoutMod.Modif), , , , "䨪");
  CREATE_FIELD(FL1_1, Math,     LIKE(Math.Math),     , , , "");
  CREATE_FIELD(FL1_1, Run,      NUMERIC[3],          , , , "஡");
  CREATE_FIELD(FL1_1, FNorm,    NUMERIC[4],          , , , "ଠ");
  CREATE_FIELD(FL1_1, FFact,    NUMERIC[4],          , , , "");
  CREATE_FIELD(FL1_1, WithDp,   SCAL[2],             , , , " ⠦஬");
  CREATE_FIELD(FL1_1, MchTime,  NUMERIC[3],          , , , "");
  CREATE_FIELD(FL1_1, TSN,      LIKE(Staff.TSN),     , , , "⥫");
  CREATE_FIELD(FL1_1, Sort,     LIKE(Sort.Sort),     , , , "");
  CREATE_FIELD(FL1_1, ASCP,     SCAL[2],             , , , "稥 ");
  CREATE_FIELD(FL1_1, WJCode,   LIKE(WJMode.WJCode), , , , " ࠡ");
  CREATE_FIELD(FL1_1, WorkTim,  NUMERIC[3],          , , , "६  ");
  CREATE_FIELD(FL1_1, WorkRun,  NUMERIC[3],          , , , "ந⢥ ஡");
  CREATE_FIELD(FL1_1, NullRun,  NUMERIC[3],          , , , "㫥 ஡");

  IF wo_Details THEN
   CREATE_INDEX_AND_LINK(FL1_1, BoxNbr, UNIQUE, CarLog,  BoxNbr, USER, , , BoxNbr, clDate, Math, TSN, Sort, Route, Modif, WithDp, ASCP, WJCode);
  ELSE
   CREATE_INDEX_AND_LINK(FL1_1, BoxNbr, UNIQUE, CarLog,  BoxNbr, USER, , , BoxNbr, clDate, Math, RWayS, TSN, Sort, Route, Modif, WithDp, ASCP, WJCode);
   CREATE_INDEX_AND_LINK(FL1_1, RWayS,  PLURAL, RWayS,   RWayS,  USER, , , RWayS);
  END;
  CREATE_INDEX_AND_LINK(FL1_1, TSN,     PLURAL, Staff,   TSN,    USER, , , TSN);
  CREATE_INDEX_AND_LINK(FL1_1, Sort,    PLURAL, Sort,    Sort,   USER, , , Sort);
  CREATE_INDEX_AND_LINK(FL1_1, Route,   PLURAL, Route,   Route,  USER, , , Route);
  CREATE_INDEX_AND_LINK(FL1_1, RoutMod, PLURAL, RoutMod, Route,  USER, , , Route, Modif);
  CREATE_INDEX_AND_LINK(FL1_1, Math,    PLURAL, Math,    Math,   USER, , , Math, BoxNbr, Route);
  CREATE_INDEX_AND_LINK(FL1_1, WJCode,  PLURAL, WJMode,  WJCode, USER, , , WJCode);

  SET_VERSION_OF_TABLE(FL1_1, 11);

  CREATE_TABLE(FL1_2, , "⪨ ⮯   ");

  CREATE_FIELD(FL1_2, BoxNbr,   LIKE(Car.BoxNbr),    , , , "ࠦ");
  CREATE_FIELD(FL1_2, clDate,   LIKE(CarLog.Date),   , , , "CarLog.Date");
  IF wo_Details THEN
   CREATE_FIELD(FL1_2, RemB,     NUMERIC[4],          , "0", , "⮪  砫");
   CREATE_FIELD(FL1_2, RemE,     NUMERIC[4],          , "0", , "⮪  ");
  ELSE
   CREATE_FIELD(FL1_2, RWayS,   LIKE(RWayS.RWayS),    , , , "");
  END;
  CREATE_FIELD(FL1_2, Math,     LIKE(Math.Math),     , , , "");
  CREATE_FIELD(FL1_2, MainFuel, LIKE(Math.Math),     , , , " ⮯");
  CREATE_FIELD(FL1_2, Take,     NUMERIC[2],          , "0", , "뤠");
  CREATE_FIELD(FL1_2, Ret,      NUMERIC[2],          , "0", , "");

  IF wo_Details THEN
   CREATE_INDEX_AND_LINK(FL1_2, BoxNbr, UNIQUE, CarLog, BoxNbr, USER, , , BoxNbr, clDate, MainFuel, Math);
  ELSE
   CREATE_INDEX_AND_LINK(FL1_2, BoxNbr, UNIQUE, CarLog, BoxNbr, USER, , , BoxNbr, clDate, MainFuel, Math, RWayS);
   CREATE_INDEX_AND_LINK(FL1_2, RWayS,  PLURAL, RWayS,  RWayS,  USER, , , RWayS);
  END;
  CREATE_INDEX_AND_LINK(FL1_2, Math,   PLURAL, Math,   Math,   USER, , , Math);

  SET_VERSION_OF_TABLE(FL1_2, 5);
 END {Create_FL1};

 PRIVATE PROCEDURE CheckRWayF();
 BEGIN
  IF !RWayF.Norm THEN
   L_General.CallUs(~RWayS.Done);
   L_General.Error("室 ࠡ  "+RWayS.RWayS);
  END;
 END {CheckRWayF};

 PRIVATE PROCEDURE Prc(Tot1, Cur2, Tot2: NUMERIC[4]): NUMERIC[4];
 BEGIN
  IF Tot2 # 0 THEN
   RETURN Tot1 * Cur2 / Tot2;
  ELSE
   RETURN 0;
  END;
 END {Prc};

 PUBLIC PROCEDURE TrFFact(): NUMERIC[4];
 BEGIN
  RETURN Prc(RWayS.FuelFact, RWayJ.FNorm, RWayS.FuelNorm);
 END {TrFFact};

 PRIVATE PROCEDURE Gather_FL1(BPer, EPer: DATE; wo_Details: SCAL[2]);
  VAR
   rwjrstRun,
   rwjRun,
   curRun  : NUMERIC[2];
   rwjrstFlF,
   rwsrstFlF,
   totrstFlF,
   rwsFlF,
   rwjFlF,
   totFlF,
   rwfFlF,
   curFlF,
   rwjrstFlN,
   rwsrstFlN,
   rwsFlN,
   rwjFlN,
   totFlN,
   rwfFlN,
   curFlN  : NUMERIC[4];
   rwjrstTim,
   rwjTim,
   curTim  : NUMERIC[3];
   TrBTim,
   TrETim  : NUMERIC[2];
   _WithDp : SCAL[2];
   PerB,
   PerE    : DATE;
   MainFuel: LIKE(MarkFuel.Math);
 BEGIN
  L_Way.CheckTaxed(BPer, EPer);
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(" " + Car.BoxNbr);
   HISTCONF(EPer, Car, CarLog);
   WHILE OCCURE(CarLog) & (CarLog.DateE>=BPer) DO
    IF CarLog.Status # L_Car.carst_Retired THEN
     PerB:=Math.Max(CarLog.Date, BPer);
     PerE:=Math.Min(CarLog.DateE, EPer);

     MainFuel:=L_Fuel.GetMainFuelSoft(PerE, CarLog.Mark);
     IF wo_Details THEN
      IF ~!MainFuel & (CarLog.Status = L_Car.carst_InOperat) &
         (L_DatTim.IsActive_Inc(BPer, CarLog.Date, CarLog.DateE) |
          L_DatTim.IsActive_Inc(EPer, CarLog.Date, CarLog.DateE)) THEN
       ADD(FL1_2, BoxNbr, , Car.BoxNbr, CarLog.Date, MainFuel, MainFuel); (*㫥 ⪨*)
      END;
      SETSEL(RWayS, BoxNbr, Car.BoxNbr);
      IF (PerB = BPer) THEN
       IF (BPer=L_Env.aptm_Start) & SRCINSEL(RWayS, GE, PerB) & (RWayS.Status >= L_Way.rwsStat_Taken) THEN
        SETSEL(RWayF, RWayS, RWayS.RWayS);
        FOR_EACH RWayF DO
         IF RWayF.RemExit # 0 THEN
          IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) THEN
           ADD(FL1_2, BoxNbr, , Car.BoxNbr, CarLog.Date, MainFuel, RWayF.Math,
               FL1_2.RemB, RWayF.RemExit);
          END;
         END;
        END; (* FOR_EACH RWayF *)
       ELSIF SRCINSEL(RWayS, LT, PerB) & (RWayS.Status >= L_Way.rwsStat_Taken) THEN
        SETSEL(RWayF, RWayS, RWayS.RWayS);
        FOR_EACH RWayF DO
         IF RWayF.RemEntr # 0 THEN
          IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) THEN
           ADD(FL1_2, BoxNbr, , Car.BoxNbr, CarLog.Date, MainFuel, RWayF.Math,
               FL1_2.RemB, RWayF.RemEntr);
          END;
         END;
        END; (* FOR_EACH RWayF *)
       END;
      END; (* IF (PerB = BPer) ... *)
     END;
     SETSEL(RWayS, BoxNbr, Car.BoxNbr);
     IF SRCINSEL(RWayS, LE, PerE) THEN
      IF wo_Details &
         (PerE = EPer) & (RWayS.Status >= L_Way.rwsStat_Taken) THEN
       SETSEL(RWayF, RWayS, RWayS.RWayS);
       FOR_EACH RWayF DO
        IF RWayF.RemEntr # 0 THEN
         IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) THEN
          ADD(FL1_2, BoxNbr, , Car.BoxNbr, CarLog.Date, MainFuel, RWayF.Math,
              FL1_2.RemE, RWayF.RemEntr);
         END;
        END;
       END; (* FOR_EACH RWayF *)
      END;

      SETSEL(RWayS, sBoxNbr, L_Way.rwsStat_Rated, CarLog.BoxNbr);
      SRCINSEL(RWayS, LE, , PerE);
      WHILE OCCURE(RWayS) & (RWayS.Date >= PerB) DO
       PROMPT(" "+ Car.BoxNbr + ",  " + RWayS.RWayS);
       SETZERO(totFlF);
       SETSEL(RWayF, RWayS, RWayS.RWayS);
       FOR_EACH RWayF DO
        CheckRWayF();
        IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) |
           (MarkFuel.InMix = L_Fuel.im_Heater) |
           (MarkFuel.InMix = L_Fuel.im_Other) THEN
         IF wo_Details THEN
          ADD(FL1_2, BoxNbr, , Car.BoxNbr, CarLog.Date, MainFuel, RWayF.Math,
              FL1_2.Take, RWayF.FuelTake,
              FL1_2.Ret , RWayF.FuelRet);
         ELSE
          ADD(FL1_2, BoxNbr, , Car.BoxNbr, CarLog.Date, MainFuel, RWayF.Math, RWayS.RWayS,
              FL1_2.Take, RWayF.FuelTake,
              FL1_2.Ret , RWayF.FuelRet);
         END;
         INC(totFlF, L_Fuel._FuelFact());
        END;
       END; (* FOR_EACH RWayF *)
       rwsrstFlN:=RWayS.FuelNorm;
       rwsrstFlF:=RWayS.FuelFact;
       SETSEL(RWayJ, RWayS, RWayS.RWayS);
       FOR_EACH RWayJ DO
        rwjFlN:=RWayJ.FNorm;
        IF rwjFlN # 0 THEN
         IF   rwjFlN = rwsrstFlN THEN rwjFlF:=rwsrstFlF;
         ELSE                         rwjFlF:=TrFFact();
         END;
         DEC(rwsrstFlN, rwjFlN);
         DEC(rwsrstFlF, rwjFlF);

         CONFORM(RWayJ, SEJobs);
         CONFORM(RWayJ, Quality);
         CONFORM(SEJobs, WJMode);
         L_General.Assert(Quality.Type # L_Way.QualType_Annul, " "+RWayJ.Trip+" - 㫥 ଠ 室 ⮯| ⢥ "+RWayJ.Quality+"?");
         rwjTim:=RWayJ.StopT-RWayJ.StartT;
         rwjRun:=RWayJ.Run * RWayJ.Fact;

         TrBTim :=L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT);
         TrETim :=L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT);
         _WithDp:=L_Way._IsWith(TrBTim, TrETim, L_Way.wlmwho_DrPupil);
         CONFORM(RWayS, Staff);
         L_Staff.PosToStaffLog(RWayS.TSN, RWayS.Date, 1);
         CONFORM(StaffLog, Officer);

         totrstFlF:=totFlF;
         rwjrstRun:=rwjRun;
         rwjrstFlN:=rwjFlN;
         rwjrstFlF:=rwjFlF;
         rwjrstTim:=rwjTim;
         SETSEL(RWayF, RWayS, RWayS.RWayS);
         FOR_EACH RWayF DO
          IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) |
             (MarkFuel.InMix = L_Fuel.im_Heater) |
             (MarkFuel.InMix = L_Fuel.im_Other) THEN
           rwfFlF:=L_Fuel._FuelFact();
           IF rwfFlF # 0 THEN
            IF rwfFlF = totrstFlF THEN
             curRun:=rwjrstRun;
             curFlN:=rwjrstFlN;
             curFlF:=rwjrstFlF;
             curTim:=rwjrstTim;
            ELSE
             curRun:=Prc(rwjRun, rwfFlF, totFlF);
             curFlN:=Prc(rwjFlN, rwfFlF, totFlF);
             curFlF:=Prc(rwjFlF, rwfFlF, totFlF);
             curTim:=Prc(rwjTim, rwfFlF, totFlF);
            END;
            DEC(totrstFlF, rwfFlF);
            DEC(rwjrstRun, curRun);
            DEC(rwjrstFlN, curFlN);
            DEC(rwjrstFlF, curFlF);
            DEC(rwjrstTim, curTim);

            IF wo_Details THEN
             ADD(FL1_1, BoxNbr, , Car.BoxNbr, CarLog.Date, RWayF.Math, RWayS.TSN,
                                  Officer.Sort, SEJobs.Route, SEJobs.Modif, _WithDp,
                                  L_Way.E_CarASCPLev(RWayS.Date, Car.BoxNbr, SEJobs.Route, SEJobs.Exit),
                                  SEJobs.WJCode,
                 FL1_1.Run,     curRun,
                 FL1_1.WorkRun, curRun * (WJMode.RunSel = L_Way.runsel_Work),
                 FL1_1.NullRun, curRun * (WJMode.RunSel = L_Way.runsel_Zero),
                 FL1_1.FNorm,   curFlN,
                 FL1_1.FFact,   curFlF,
                 FL1_1.MchTime, curTim * ((WJMode.WJType = L_Way.WJType_Work) & (WJMode.FCorRepr > 0)),
                 FL1_1.WorkTim, curTim * (WJMode.RunSel # L_Way.runsel_None));
            ELSE
             ADD(FL1_1, BoxNbr, , Car.BoxNbr, CarLog.Date, RWayF.Math, RWayS.RWayS, RWayS.TSN,
                                  Officer.Sort, SEJobs.Route, SEJobs.Modif, _WithDp,
                                  L_Way.E_CarASCPLev(RWayS.Date, Car.BoxNbr, SEJobs.Route, SEJobs.Exit),
                                  SEJobs.WJCode,
                 FL1_1.Run,     curRun,
                 FL1_1.WorkRun, curRun * (WJMode.RunSel = L_Way.runsel_Work),
                 FL1_1.NullRun, curRun * (WJMode.RunSel = L_Way.runsel_Zero),
                 FL1_1.FNorm,   curFlN,
                 FL1_1.FFact,   curFlF,
                 FL1_1.MchTime, curTim * ((WJMode.WJType = L_Way.WJType_Work) & (WJMode.FCorRepr > 0)),
                 FL1_1.WorkTim, curTim * (WJMode.RunSel # L_Way.runsel_None));
            END;
           END; (* IF rwfFlF # 0 THEN *)
          END; (* IF L_Fuel.IsFuelInMixOnDate *)
         END; (* FOR_EACH RWayF *)
        END; (* IF tFlN # 0 THEN *)
       END; (* FOR_EACH RWayJ *)
       IF rwsrstFlN # 0 THEN
        IF ~RWayS.Done THEN
         L_General.Error("室 ࠡ  " + RWayS.RWayS);
        ELSE
         L_General.CallUs(0);
        END;
       END;
       PREV(RWayS);
      END; (* WHILE OCCURE(RWayS)... *)
     END; (* IF SRCINSEL(RWayS)... *)
    END; (* IF CarLog.Status # L_Car.carst_Retired ... *)
    PREV(CarLog);
   END; (* WHILE OCCURE(CarLog) ... *)
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {Gather_FL1};

 PUBLIC PROCEDURE extPrepare_FL1(wo_Details: SCAL[2]);
  VAR
   BPer,
   EPer     : DATE;
   trgFL1Name,
   trgFL2Name: STRING[];
 BEGIN
  IF   wo_Details THEN
   trgFL1Name:="FL1_1";
   trgFL2Name:="FL1_2";
  ELSE
   trgFL1Name:="FL2_1";
   trgFL2Name:="FL2_2";
  END;
  BPer:=Memo.ud_fr();
  EPer:=Memo.ud_ut();

  IF L_AFM.inRegistering()THEN
   Create_FL1(wo_Details);
   L_AFM.msrf_Register("FL1_1", trgFL1Name, L_General.timeCond_InIntvl, BPer, EPer);
  END;
  IF L_AFM.inAttaching() THEN
   L_AFM.msrf_Register("FL1_2", trgFL2Name, L_General.timeCond_InIntvl, BPer, EPer);
(*
   IF ~(L_AFM.msrf_Reuse("FL1_2", 1) & L_AFM.msrf_Reuse("FL1_1", 0)) THEN (*FL1_2 । ᯥ樠쭮 - ⮡    ୮ ᯮ짮 뫮 Descripton  FL1_1*)
*)
   IF ~(L_AFM.msrf_Reuse("FL1_1", 0) & L_AFM.msrf_Reuse("FL1_2", 1)) THEN
    APP.Get().NewPrompt(L_AFM.rf_PreparePromptStr("FL1_1"));
    L_General.SetCacheables(["Car", "CarLog", "CarPro", "RoutePro", "SEJobs", "Staff", "StaffLog"]);
    L_AFM.msrf_Create("FL1_1");
    L_AFM.msrf_Create("FL1_2");
    Gather_FL1(BPer, EPer, wo_Details);
    L_AFM.msrf_Store("FL1_1");
    L_AFM.msrf_Store("FL1_2");
   END;
  END;
 END {extPrepare_FL1};

 PUBLIC PROCEDURE Prepare_FL1();
 BEGIN
  extPrepare_FL1(1);
 END {Prepare_FL1};

 PUBLIC PROCEDURE Purge_FL1();
 BEGIN
  L_AFM.AF_PurgeTemp("FL1_1");
  L_AFM.AF_PurgeTemp("FL1_2");
 END {Purge_FL1};

 PRIVATE PROCEDURE Create_OIL01();
 BEGIN
  CREATE_TABLE(OIL_1, , "ᯮ⥫ 䠩  ஥ OIL01");

  CREATE_FIELD(OIL_1, BoxNbr,  LIKE(Car.BoxNbr),  , , , "ࠦ");
  CREATE_FIELD(OIL_1, clDate,  LIKE(CarLog.Date), , , , "CarLog.Date");
  CREATE_FIELD(OIL_1, RWDate,  DATE,              , , , " ");
  CREATE_FIELD(OIL_1, TSN,     LIKE(Staff.TSN),   , , , "");
  CREATE_FIELD(OIL_1, Route,   LIKE(Route.Route), , , , "");
  CREATE_FIELD(OIL_1, FFact,   NUMERIC[4],        , , , "᪨ 室 ⮯");

  CREATE_INDEX_AND_LINK(OIL_1, BoxNbr, UNIQUE, CarLog, BoxNbr, USER, "", "", BoxNbr, clDate, RWDate, TSN, Route);

  SET_VERSION_OF_TABLE(OIL_1, 002);

  CREATE_TABLE(OIL01, , "室 ᬠ ਠ");

  CREATE_FIELD(OIL01, BoxNbr,   LIKE(Car.BoxNbr),  , ,  , "ࠦ");
  CREATE_FIELD(OIL01, clDate,   LIKE(CarLog.Date), , ,  , "CarLog.Date");
  CREATE_FIELD(OIL01, TSN,      LIKE(Staff.TSN),   , ,  , "");
  CREATE_FIELD(OIL01, Route,    LIKE(Route.Route), , ,  , "");
  CREATE_FIELD(OIL01, FFact,    NUMERIC[4],        , ,  , "᪨ 室 ⮯");
  CREATE_FIELD(OIL01, OilType,  SCAL[8],           , ,  , " ᫠");
  CREATE_FIELD(OIL01, Math,     LIKE(Math.Math),   , ,  , "  ᫠");
  CREATE_FIELD(OIL01, MNorm,    NUMERIC[4],        , "0", , "室  ଥ  ୮");
  CREATE_FIELD(OIL01, MFact,    NUMERIC[4],        , "0", , "᪨ 室  ୮");
  CREATE_FIELD(OIL01, MFactTO,  NUMERIC[4],        , "0", , "᪨ 室  ୮  ");
  CREATE_FIELD(OIL01, MFactAdd, NUMERIC[4],        , "0", , "᪨ 室  ୮  ");

  CREATE_INDEX_AND_LINK(OIL01, BoxNbr, UNIQUE, CarLog, BoxNbr, USER, , , BoxNbr, clDate, Math, TSN, Route, OilType);
  CREATE_INDEX_AND_LINK(OIL01, TSN,    PLURAL, Staff,  TSN,    USER, , , TSN);
  CREATE_INDEX_AND_LINK(OIL01, Route,  PLURAL, Route,  Route,  USER, , , Route);
  CREATE_INDEX_AND_LINK(OIL01, Math,   PLURAL, Math,   Math,   USER, , , Math);

  SET_VERSION_OF_TABLE(OIL01, 005);
 END {Create_OIL01};

 PRIVATE PROCEDURE Gather_OIL01(BPer, EPer: DATE);
  CONST
   MathTypeNum   = RANGEOF(Mark.OilNorm);
   MathInTypeNum = 16;
  VAR
   rwjFlN    : LIKE(RWayJ.FNorm);
   rwsFlN    : LIKE(RWayS.FuelNorm);
   TotFF,
   rwjFlF,
   rwsFF     : NUMERIC[4];
   OilNorm   : LIKE(Mark.OilNorm);
   OTNum     : NUMERIC[0]     [MathTypeNum];
   OTFact    : NUMERIC[4]     [MathTypeNum];
   OTMath    : LIKE(Math.Math)[MathTypeNum*MathInTypeNum];
   OMFact,
   OMFactTO,
   OMFactAdd : NUMERIC[4]     [MathTypeNum*MathInTypeNum];
   mfInMix   : LIKE(MarkFuel.InMix);
   i,
   Cnt,
   Idx       : NUMERIC[0];
   FRatio,
   NRatio    : FLOAT;
   PerB,
   PerE      : DATE;
   CarOilCoef: L_Fuel.tCarOilCoef;
 BEGIN
  L_Way.CheckTaxed(BPer, EPer);
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(" " + Car.BoxNbr);
   HISTCONF(EPer, Car, CarLog);
   WHILE OCCURE(CarLog) & (CarLog.DateE >= BPer) DO
    IF CarLog.Status # L_Car.carst_Retired THEN
     PerB:=Math.Max(CarLog.Date,  BPer);
     PerE:=Math.Min(CarLog.DateE, EPer);

     CONFORM(CarLog, Mark);
     SETEMPTY(OilNorm);
     SETZERO(OTNum, OTFact, OMFact, OMFactTO, OMFactAdd, TotFF);
     SETSEL(MarkFuel, Mark, Mark.Mark);
     FOR_EACH MarkFuel DO
      IF L_Fuel.IsAnyOil(MarkFuel.InMix) &
         L_DatTim.IsActiveInIntvl_Inc(PerB, PerE, MarkFuel.Begin, L_DatTim.till2ED(MarkFuel.Till)) THEN
       IF !OilNorm[MarkFuel.InMix] THEN
        OilNorm[MarkFuel.InMix]:=Mark.OilNorm[MarkFuel.InMix];
       END;
       Idx:=MarkFuel.InMix * MathInTypeNum + OTNum[MarkFuel.InMix];
       OTMath[Idx]   :=MarkFuel.Math;
       OMFact[Idx]   :=L_Fuel.GetFactByOilMath(CarLog.BoxNbr, MarkFuel.Math, PerB, PerE);
       OMFactTO[Idx] :=L_Fuel.GetSRTFactByOilMath(CarLog.BoxNbr, MarkFuel.Math, PerB, PerE, L_Fuel.mfrt_TO);
       OMFactAdd[Idx]:=L_Fuel.GetSRTFactByOilMath(CarLog.BoxNbr, MarkFuel.Math, PerB, PerE, L_Fuel.mfrt_Add);
       INC(OTFact[MarkFuel.InMix], OMFact[Idx]);
       CONFORM(MarkFuel, Math);
       IF (OMFact[Idx] > 0) | L_DatTim.IsActiveInIntvl_Inc(BPer, EPer, Math.Begin, L_DatTim.till2ED(Math.Till)) THEN
        INC(OTNum[MarkFuel.InMix]);
       END;
      END;
     END; (* FOR_EACH MarkFuel *)

     SETSEL(RWayS, sBoxNbr, L_Way.rwsStat_Rated, CarLog.BoxNbr);
     SRCINSEL(RWayS, LE, , PerE);
     WHILE OCCURE(RWayS) & (RWayS.Date >= PerB) DO
      PROMPT(" " + CarLog.BoxNbr + " " + L_DatTim.DateStr(RWayS.Date));
      rwsFlN:=RWayS.FuelNorm;
      rwsFF :=RWayS.FuelFact;
      SETSEL(RWayJ, RWayS, RWayS.RWayS);
      FOR_EACH RWayJ DO
       rwjFlN:=RWayJ.FNorm;
       IF rwjFlN # 0 THEN
        IF rwjFlN = rwsFlN THEN rwjFlF:=rwsFF;
        ELSE                    rwjFlF:=TrFFact();
        END;
        DEC(rwsFlN, rwjFlN);
        DEC(rwsFF, rwjFlF);
        CONFORM(RWayJ, SEJobs);
        ADD(OIL_1, BoxNbr, , CarLog.BoxNbr, CarLog.Date, RWayS.Date, RWayS.TSN, SEJobs.Route,
            OIL_1.FFact, rwjFlF);
        INC(TotFF, rwjFlF);
       END;
      END; (* FOR_EACH RWayJ *)
      IF rwsFlN # 0 THEN
       L_General.CallUs(~RWayS.Done);
       L_General.Error("室 ࠡ  " + RWayS.RWayS);
      END;
      PREV(RWayS);
     END; (* WHILE OCCURE(RWayS)... *)
     IF ~SELECT(OIL_1, BoxNbr, CarLog.BoxNbr, CarLog.Date) THEN
      ADD(OIL_1, BoxNbr, , CarLog.BoxNbr, CarLog.Date, PerE, L_Env.fictTSN, "",
                           OIL_1.FFact, 0);
     END;
 
     SELECT(OIL_1, BoxNbr, , CarLog.BoxNbr, CarLog.Date);
     WHILE OCCURE(OIL_1) DO
      PROMPT(" " + CarLog.BoxNbr + " " + L_DatTim.DateStr(OIL_1.RWDate) + ", ⭨ " + OIL_1.TSN);
      NARROWSEL(OIL_1, RWDate, TSN);
      WHILE OCCURE(OIL_1) DO
       IF TotFF > 0 THEN
        FRatio:=OIL_1.FFact / TotFF;
       ELSE
        FRatio:=1.00;
       END;
       L_General.Assert(FRatio > 0, "⥫ 室 ⮯   "+OIL_1.Route);
       SETZERO(mfInMix, Cnt);
       L_Fuel.GetCarOilCoef(OIL_1.RWDate, CarOilCoef);
       WHILE mfInMix < MathTypeNum DO
        IF ~!OilNorm[mfInMix] THEN
         i:=0;
         WHILE i < OTNum[mfInMix] DO
          Idx:=mfInMix * MathInTypeNum + i;
          IF OTFact[mfInMix] > 0 THEN
           IF OMFact[Idx] > 0 THEN
            NRatio:=OMFact[Idx] / OTFact[mfInMix];
           ELSE
            NRatio:=0;
           END;
          ELSE
           NRatio:=1 / OTNum[mfInMix];
          END;
          IF (OMFact[Idx] # 0) | ((NRatio # 0) & (OIL_1.FFact # 0)) THEN
           ADD(OIL01, BoxNbr, , OIL_1.BoxNbr, OIL_1.clDate, OTMath[Idx], OIL_1.TSN, OIL_1.Route, mfInMix,
               OIL01.FFact,    OIL_1.FFact * (Cnt=0),
               OIL01.MNorm,    OIL_1.FFact * OilNorm[mfInMix] * CarOilCoef[mfInMix] / 100 * NRatio,
               OIL01.MFact,    OMFact[Idx]    * FRatio,
               OIL01.MFactTO,  OMFactTO[Idx]  * FRatio,
               OIL01.MFactAdd, OMFactAdd[Idx] * FRatio);
           INC(Cnt);
          END;
          INC(i);
         END; (* WHILE i < ... *)
        END;
        INC(mfInMix);
       END; (* WHILE mfInMix < MathTypeNum ... *)
       IF FRatio = 1.00 THEN
        LAST(OIL_1);
       END;
       NEXT(OIL_1);
      END; (* WHILE OCCURE(OIL_1) ... *)
      NEXTINEXTENDEDSEL(OIL_1, RWDate, TSN);
     END; (* WHILE OCCURE(OIL_1) ... *)
    END; (* IF CarLog.Status # L_Car.carst_Retired ... *)
    PREV(CarLog);
   END; (* WHILE OCCURE(CarLog)... *)
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {Gather_OIL01};

 PUBLIC PROCEDURE Prepare_OIL01();
  VAR
   BPer,
   EPer    : DATE;
 BEGIN
  BPer:=Memo.ud_fr();
  EPer:=Memo.ud_ut();

  IF L_AFM.inRegistering() THEN
   Create_OIL01();
   L_AFM.msrf_Register("OIL01", "OIL01", L_General.timeCond_InIntvl, BPer, EPer);
  END;
  IF L_AFM.inAttaching() THEN
   IF ~L_AFM.msrf_Reuse("OIL01", 0) THEN
    APP.Get().NewPrompt(L_AFM.rf_PreparePromptStr("OIL01"));
    L_AFM.CreateTemp("OIL_1");
    L_AFM.msrf_Create("OIL01");
    Gather_OIL01(BPer, EPer);
    L_AFM.msrf_Store("OIL01");
    L_AFM.AF_PurgeTemp("OIL_1");
   END;
  END;
 END {Prepare_OIL01};

 PUBLIC PROCEDURE Purge_OIL01();
 BEGIN
  L_AFM.AF_PurgeTemp("OIL01");
 END {Purge_OIL01};

 PRIVATE PROCEDURE Create_FL003();
 BEGIN
  CREATE_TABLE(FL003, "", "뤠 ᮫  ࠦ", "");

  CREATE_FIELD(FL003, BoxNbr, LIKE(Car.BoxNbr), , ,  , "ࠦ");
  CREATE_FIELD(FL003, Math,   LIKE(Math.Math),  , ,  , "");
  CREATE_FIELD(FL003, TSN,    LIKE(Staff.TSN),  , ,  , "");
  CREATE_FIELD(FL003, Date,   DATE,             , ,  , " 뤠");
  CREATE_FIELD(FL003, Run,    NUMERIC[2],       , "0", , "஡ ᫥ ।. 뤠");
  CREATE_FIELD(FL003, Norm,   NUMERIC[4],       , "0", , "ଠ");
  CREATE_FIELD(FL003, Fact,   NUMERIC[4],       , "0", , "");

  CREATE_INDEX_AND_LINK(FL003, BoxNbr, UNIQUE, Car,   BoxNbr, USER, , , BoxNbr, Date, TSN, Math);
  CREATE_INDEX_AND_LINK(FL003, TSN,    PLURAL, Staff, TSN,    USER, , , TSN);
  CREATE_INDEX_AND_LINK(FL003, Math,   PLURAL, Math,  Math,   USER, , , Math);

  SET_VERSION_OF_TABLE(FL003, 001);
 END {Create_FL003};

 PUBLIC PROCEDURE Prepare_FL003(_BoxNbr: LIKE(Car.BoxNbr));
  VAR
   _Fact           : NUMERIC[4];
   _Run            : NUMERIC[2];
   _Date,
   RunDate,
   DistributionDate: DATE;
   i, j            : NUMERIC[0];
   _Math           : LIKE(Math.Math)[16];
   FactArr         : NUMERIC[4][20];
   TSNArr          : L_Fuel.Arr;
 BEGIN
  Create_FL003();
  APP.Get().NewPrompt(TABLE.Get("FL003").Description);
  L_AFM.CreateTemp("FL003");

  IF !_BoxNbr THEN
   SELECT(Mark, Mark);
  ELSE
   SEARCH(Car, BoxNbr, , _BoxNbr);
   SELECT(Mark, Mark, , Car.Mark);
  END;
  WHILE OCCURE(Mark) DO
   i:=0;
   SETEMPTY(_Math);
   CONFORM(Mark, MarkFuel);
   WHILE OCCURE(MarkFuel) DO
    IF (MarkFuel.InMix = L_Fuel.im_Tosol) &
       L_DatTim.IsActiveInIntvl_Inc(MarkFuel.Begin, L_DatTim.till2ED(MarkFuel.Till), Memo.ud_fr(), Memo.ud_ut()) THEN
     _Math[i]:=MarkFuel.Math;
     INC(i);
    END;
    NEXT(MarkFuel);
   END; (* WHILE OCCURE(MarkFuel) ... *)
   IF !_BoxNbr THEN
    SELECT(Car, Mark, , Mark.Mark);
   ELSE
    SELECT(Car, BoxNbr, , _BoxNbr);
   END;
   WHILE OCCURE(Car) DO
    SETEMPTY(DistributionDate);
    _Date:=Memo.ud_fr();
    WHILE _Date <= Memo.ud_ut() DO
     PROMPT("ઠ " + Mark.Mark + ",  " + Car.BoxNbr + " " + L_DatTim.DateStr(_Date));
     i:=0;
     WHILE ~!_Math[i] DO
      FactArr:=L_Fuel.__GetFactByOilMath(Car.BoxNbr, _Math[i], _Date,
                                         _Date, TSNArr);
      j:=0;
      WHILE ~!TSNArr[j] DO
       IF FactArr[j] # 0 THEN
        ADD(FL003, BoxNbr, , Car.BoxNbr, _Date, TSNArr[j], _Math[i],
            FL003.Fact, FactArr[j]);
        DistributionDate:=_Date;
       END;
       INC(j);
      END;
      INC(i);
     END;
     SELECT(RWayS, BoxNbr, , Car.BoxNbr, _Date);
     WHILE OCCURE(RWayS) DO
      _Run:=0;
      CONFORM(RWayS, RWayJ);
      WHILE OCCURE(RWayJ) DO
       CONFORM(RWayJ, Quality);
       IF Quality.Type # L_Way.QualType_Annul THEN
        INC(_Run, RWayJ.Run * RWayJ.Fact);
       END;
       NEXT(RWayJ);
      END; (* WHILE OCCURE(RWayJ) ... *)
      IF !DistributionDate THEN
       RunDate:=_Date;
      ELSE
       RunDate:=DistributionDate;
      END;
      ADD(FL003, BoxNbr, , RWayS.BoxNbr, RunDate, RWayS.TSN, "",
          FL003.Run, _Run,
          FL003.Norm, _Run * 17 / 10000);
      NEXT(RWayS);
     END; (* WHILE OCCURE(RWayS) ... *)
     INC(_Date);
    END; (* WHILE _Date ... *)
    NEXT(Car);
   END; (* WHILE OCCURE(Car) ... *)
   NEXT(Mark);
  END; (* WHILE OCCURE(Mark) ... *)
 END {Prepare_FL003};

 PUBLIC PROCEDURE Purge_FL003();
 BEGIN
  L_AFM.AF_PurgeTemp("FL003");
 END {Purge_FL003};

END.
