(*
%Copyright   (c) Polak Computer System
%Author      27.04.2000 17:55:26 SAN
%Purpose     ᠭ  ⥫ 䠩 - ॢ
%Type        library
%Specific    AP
%Modified    19.08.2014 17:12:55 POLAK\Gina
%Environment
*)

 MODULE D_RWS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tSalDirect  = SCAL[3];
  tOnRWMx     = SCAL[3];
  tRouteGroup = SCAL[16];

 PUBLIC CONST
  sd_No            = 0; (*SalDirect*)
  sd_Yes           = 1;
  sd_NotProduction = 2;

  dir_Forward    = 0;
  dir_Backward   = 1;
  dir_NotDefined = 2;

  OnRWM01 = 0;
  OnRWM02 = 1;
  OnRWM03 = 2;

 IMPORT L_General, L_Way, L_AFM, L_Env, L_DatTim, E_Way, L_Staff, L_Car,
        L_Str, E_Utils, L_Math, L_PRoll, Memo, L_APtm, Math, L_EC, P_Firm,
        L_APWI, Str, L_TRS, L_StdFrm, L_RWayS;

 PRIVATE TYPE
  tRMCode     = STRING[Str.MaxLength(Route.Route)+Str.Length(MAXOF(Car.BoxNbr))];

 PRIVATE PROCEDURE Create_RWM01();
 BEGIN
  CreateFILE(RWM01, "RWM01.Date", "ࠡ⮪  ", "");

  CreateFIELD(RWM01, RWayS,    LIKE(RWayS.RWayS),  "", "", "", " ⥢ ", "");
  CreateFIELD(RWM01, Day,      LIKE(RWayJ.Day),    "1", "", "", " 砫 㯯 ३ᮢ (⭮⥫쭮  /),   1", "");
  CreateFIELD(RWM01, StartT,   LIKE(RWayJ.StartT), "", "", "", "६ 砫 㯯 ३ᮢ", "");
  CreateFIELD(RWM01, TSN,      LIKE(Staff.TSN),    "", "", "", " ", "");
  CreateFIELD(RWM01, BoxNbr,   LIKE(Car.BoxNbr),   "", "", "", "ࠦ", "");
  CreateFIELD(RWM01, Who,      L_Way.tRWSWho,      "", "", "", "", "");
  CreateFIELD(RWM01, Date,     LIKE(RWayS.Date),   "", "", "", " 륧  ࠦ", "");
  CreateFIELD(RWM01, Route,    LIKE(Route.Route),  "", "", "", "", "");
  CreateFIELD(RWM01, MCode,    LIKE(MCList.MCode), "", "", "", " ᫥/㤥ঠ", "");
  CreateFIELD(RWM01, ASCP,     SCAL[2],            "", "", "", "稥 ", "");
  CreateFIELD(RWM01, InvFacil, SCAL[2],            "", "", "", "稥 㤮  ॢ ", "");
  CreateFIELD(RWM01, Tim,      NUMERIC[6, 3],      "", "0", "", "६", "");
  CreateFIELD(RWM01, Sum,      NUMERIC[12, 2],     "", "0", "", "㬬", "");

  CreateINDEX(RWM01, RWayS, UNIQUE, "", "", RWayS, Day, StartT, TSN, MCode, ASCP, InvFacil);

  SetVersionOfFILE(RWM01, 0006);
 END {Create_RWM01};

 PRIVATE PROCEDURE intProceedRWayS(wProcessing: SCAL[2]);
 BEGIN
  PROMPT(L_Str.PoolItem("஢ઠ|ࠡ⪠", wProcessing) + " : " + L_DatTim.DateStr(RWayS.Date) + ",  " + RWayS.RWayS);
  IF wProcessing THEN
   TRY
    CALL(RWayS.RWM01Do());
   EXCEPT
   ON Exc: Exc_Halt DO
   END; (* TRY *)
  ELSE
   L_General.Assert(RWayS.Done, " ࠡ⠭  " + RWayS.RWayS);
  END; (* IF wProcessing ... *)
 END {intProceedRWayS};

 PRIVATE PROCEDURE ProceedRWayS(wProcessing: SCAL[2]);
 BEGIN
  SETSEL(RWayS, Date);
  SRCINSEL(RWayS, GE, , Memo.ud_mb());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_me()) DO
   intProceedRWayS(wProcessing);
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {ProceedRWayS};

 PUBLIC PROCEDURE PrepareRWM01(Rebuild: SCAL[2]);
 BEGIN
  Create_RWM01();
  L_AFM.msrf_Register("RWM01", "RWM01",
                      L_General.timeCond_InMonth, Memo.ud_mb(), Memo.ud_mb());
 
  IF Rebuild | ~L_AFM.msrf_Reuse("RWM01", 0) THEN
   APP.Get().NewPrompt(L_AFM.rf_PreparePromptStr("RWM01"));
   L_AFM.msrf_Create("RWM01");
   ProceedRWayS(0);
   ProceedRWayS(1);
   L_AFM.msrf_Store("RWM01");
  END;
 END {PrepareRWM01};

 PRIVATE PROCEDURE ProceedRWaySForTSN(wProcessing: SCAL[2]; trgTSN: LIKE(Staff.TSN));
 BEGIN
  SETSEL(RWayS, TSN, trgTSN);
  SRCINSEL(RWayS, GE, , Memo.ud_mb());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_me()) DO
   intProceedRWayS(wProcessing);
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  SETSEL(WayLMen, TSN, trgTSN);
  SRCINSEL(WayLMen, GE, , Memo.ud_mb());
  WHILE OCCURE(WayLMen) & (WayLMen.RWayDate <= Memo.ud_me()) DO
   CONFORM(WayLMen, RWayS);
   PROMPT(L_DatTim.DateStr(RWayS.Date) + ",  " + RWayS.RWayS);
   IF ~SELECT(RWM01, RWayS, RWayS.RWayS) THEN
    intProceedRWayS(wProcessing);
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
 END {ProceedRWaySForTSN};

 PUBLIC PROCEDURE PrepareRWM01ForTSN(trgTSN: LIKE(Staff.TSN));
 BEGIN
  Create_RWM01();
  L_AFM.CreateTemp("RWM01");
  ProceedRWaySForTSN(0, trgTSN);
  ProceedRWaySForTSN(1, trgTSN);
 END {PrepareRWM01ForTSN};

 PRIVATE PROCEDURE PurgeRWM01();
 BEGIN
  L_AFM.AF_PurgeTemp("RWM01");
 END {PurgeRWM01};

 PUBLIC PROCEDURE Create_RWM02();
 BEGIN
  CreateFILE(RWM02, "", "ࠡ⮪   (७)", "");

  CreateFIELD(RWM02, MyFirm,   P_Firm.tMyFirm,     "", "", "", " ࣠", "");
  CreateFIELD(RWM02, Sort,     LIKE(Sort.Sort),    "", "", "", "", "");
  CreateFIELD(RWM02, TSN,      LIKE(Staff.TSN),    "", "", "", " ", "");
  CreateFIELD(RWM02, ODate,    DATE,               "", "", "", " ਪ  ६饭", "");
  CreateFIELD(RWM02, Route,    LIKE(Route.Route),  "", "", "", "", "");
  CreateFIELD(RWM02, Mark,     LIKE(Mark.Mark),    "", "", "", "ઠ", "");
  CreateFIELD(RWM02, BoxNbr,   LIKE(Car.BoxNbr),   "", "", "", "ࠦ", "");
  CreateFIELD(RWM02, Direct,   tSalDirect,         "", "", "", " ", "");
  CreateFIELD(RWM02, MCode,    LIKE(MCList.MCode), "", "", "", " ᫥ / 㤥ঠ", "");
  CreateFIELD(RWM02, Who,      L_Way.tRWSWho,      "", "", "", "", "");
  CreateFIELD(RWM02, ASCP,     SCAL[2],            "", "", "", "稥 ", "");
  CreateFIELD(RWM02, InvFacil, SCAL[2],            "", "", "", "稥 㤮  ॢ ", "");
  CreateFIELD(RWM02, IsDistr,  SCAL[3],            "", "", "", "ப ᮤন । 㬬", "");
  CreateFIELD(RWM02, Sum,      NUMERIC[12, 2],     "", "0", "", "㬬", "");
  CreateFIELD(RWM02, Tim,      L_PRoll.tTime,      "", "0", "", "६", "");

  CreateINDEXandLINK(RWM02, TSN,   UNIQUE, Staff, TSN, USER, "", "",
                       TSN, ODate, MyFirm, Sort, Who, Route, Mark, BoxNbr, ASCP, InvFacil, MCode, Direct, IsDistr);

  CreateINDEXandLINK(RWM02, BoxNbr, PLURAL, Car,    BoxNbr, USER, "", "", BoxNbr);

  CreateINDEX(RWM02, mfMark, PLURAL, "", "", MyFirm, IsDistr, Who, Mark, Sort, Route);

  SetVersionOfFILE(RWM02, 0011);
 END {Create_RWM02};

 PRIVATE PROCEDURE Create_RWM03();
 BEGIN
  CreateFILE(RWM03, "", "ࠡ⮪   ( ⠬, )", "");

  CreateFIELD(RWM03, Route,    LIKE(Route.Route), "", "", "", "", "");
  CreateFIELD(RWM03, MyFirm,   P_Firm.tMyFirm,    "", "", "", " ࣠", "");
  CreateFIELD(RWM03, Mark,     LIKE(Mark.Mark),   "", "", "", "ઠ ", "");
  CreateFIELD(RWM03, Who,      L_Way.tRWSWho,     "", "", "", "", "");
  CreateFIELD(RWM03, Sort,     LIKE(Sort.Sort),   "", "", "", "", "");
  CreateFIELD(RWM03, ASCP,     SCAL[2],           "", "", "", "稥 ", "");
  CreateFIELD(RWM03, InvFacil, SCAL[2],           "", "", "", "稥 㤮  ॢ ", "");
  CreateFIELD(RWM03, Sum,      NUMERIC[12, 2],    "", "0", "", "㬬", "");
  CreateFIELD(RWM03, Tim,      L_PRoll.tTime,     "", "0", "", "६", "");

  CreateINDEX(RWM03, MyFirm, UNIQUE, "", "", MyFirm, Who, Route, Mark, Sort, ASCP, InvFacil);
  CreateINDEX(RWM03, mfMark, PLURAL, "", "", MyFirm, Who, Mark, Sort);
  CreateINDEX(RWM03, mfSort, PLURAL, "", "", MyFirm, Who, Sort);

  SetVersionOfFILE(RWM03, 0006);
 END {Create_RWM03};

 PUBLIC PROCEDURE E_IsRoute2Distribute(_Route: LIKE(Route.Route); P: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  IF ~SEARCH(Route, Route, _Route) THEN
   L_General.Error("   " + _Route + " - ᫥  ⮢ ࠭ 䠩");
  END;
  Local:=PROCREF(E_Utils.RWDst_IsRoute2Distribute);
  IF ~!Local THEN
   RETURN Local(Memo.ud_me());
  ELSE
   IF Route.IncSel > 0 THEN
    RETURN 1;
   ELSE
    L_Way.StandOnRouteTKind(P);
    RETURN ~((TKind.Rgn=L_Way.tkrgn_City) | (TKind.Rgn=L_Way.tkrgn_Suburb) | (TKind.Rgn=L_Way.tkrgn_Intercity));
   END;
  END;
 END {E_IsRoute2Distribute};

 PRIVATE PROCEDURE PackInRWM02();
 BEGIN
  APP.Get().NewPrompt(TABLE.Get("RWM01").Description + ". ");
  SELECT(RWM01, RWayS);
  WHILE OCCURE(RWM01) DO
   PROMPT(" " + RWM01.RWayS);
   IF ~(SEARCH(Staff, TSN, RWM01.TSN) & SELECT(StaffLog, TSN, RWM01.TSN) & SRCINSEL(StaffLog, LE, RWM01.Date)) THEN
    L_General.Error("  ࠡ⭨ " + RWM01.TSN + " - ᫥  ⮢ ࠭ 䠩");
   END;
   IF ~L_Car._StandOnCarLog(RWM01.BoxNbr, RWM01.Date) THEN
    L_General.Error("   " + RWM01.BoxNbr + " - ᫥  ⮢ ࠭ 䠩");
   END;
   ADD(RWM02, TSN, , StaffLog.TSN, StaffLog.Date, L_Staff.GetStaffMyFirm(), StaffLog.Sort,
                     RWM01.Who, RWM01.Route, CarLog.Mark, RWM01.BoxNbr,
                     RWM01.ASCP, RWM01.InvFacil, RWM01.MCode, sd_Yes, 0,
       RWM02.Tim, RWM01.Tim,
       RWM02.Sum, RWM01.Sum);
   NEXT(RWM01);
  END; (* WHILE OCCURE(RWM01) ... *)
  SELECT(RWM02, TSN);
  WHILE OCCURE(RWM02) DO
   PROMPT("⭨ " + RWM02.TSN);
   IF E_IsRoute2Distribute(RWM02.Route, Memo.ud_mb()) THEN
    ADD(RWM03, MyFirm, , RWM02.MyFirm, RWM02.Who, RWM02.Route, RWM02.Mark, RWM02.Sort, RWM02.ASCP, RWM02.InvFacil,
        RWM03.Tim, RWM02.Tim,
        RWM03.Sum, RWM02.Sum);
   END;
   NEXT(RWM02);
  END; (* WHILE OCCURE(RWM02) ... *)
 END {PackInRWM02};

 PRIVATE PROCEDURE GetRMCode(trgRoute: LIKE(Route.Route); trgBoxNbr: LIKE(Car.BoxNbr)): tRMCode;
 BEGIN
  RETURN Str.Align(trgRoute, 4, LEFT) + trgBoxNbr;
 END {GetRMCode};

 PRIVATE PROCEDURE GetDtCode(_Route : LIKE(Route.Route);
                             _BoxNbr: LIKE(Car.BoxNbr);
                             _MCode : LIKE(MCList.MCode)): STRING[];
 BEGIN
  RETURN GetRMCode(_Route, _BoxNbr) + _MCode;
 END {GetDtCode};

 PUBLIC PROCEDURE NeedWho(_Who: L_Way.tRWSWho): SCAL[2];
  VAR
   Need : SCAL[2];
   Local: PROC;
 BEGIN
  Need:=((_Who = L_Way.rwswho_Driver ) & (L_Env.IsDriver())) |
        ((_Who = L_Way.rwswho_Guard  ) & (L_Env.IsGuard())) |
        ((_Who = L_Way.rwswho_DrPupil) & (L_Env.IsDriverPupil() | L_Env.IsDriver())) |
        ((_Who = L_Way.rwswho_GuPupil) & (L_Env.IsGuard()));
  Local:=PROCREF(E_Utils.RWDst_NeedWho);
  IF ~!Local THEN
   Need:=Need & Local(Memo.ud_me(), _Who);
  END;
  RETURN Need;
 END {NeedWho};

 PRIVATE PROCEDURE E_RWDst_RouteInGroup(OnRWMx: tOnRWMx;
                                        _Group : tRouteGroup): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.RWDst_RouteInGroup);
  IF ~!Local THEN
   IF    OnRWMx = OnRWM02 THEN
    RETURN Local(Memo.ud_me(), RWM02.Route, _Group);
   ELSIF OnRWMx = OnRWM03 THEN
    RETURN Local(Memo.ud_me(), RWM03.Route, _Group);
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   Local:=PROCREF(E_Utils.RWDst_RWMxRouteInGroup);
   IF ~!Local THEN
    RETURN Local(Memo.ud_me(), OnRWMx, _Group);
   END;
  END;
  RETURN 0;
 END {E_RWDst_RouteInGroup};

 PRIVATE PROCEDURE E_RWDst_GroupForMCode(_Who   : L_Way.tRWSWho;
                                         _MCode : LIKE(MCList.MCode)): tRouteGroup;
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.RWDst_GroupForMCode);
  IF ~!Local THEN
   RETURN Local(Memo.ud_me(), _Who, _MCode);
  ELSE
   RETURN 0;
  END;
 END {E_RWDst_GroupForMCode};

 PUBLIC PROCEDURE E_RWDst_NeedRouteForCurStaffSpread(trgRoute: LIKE(Route.Route); trgWho: L_Way.tRWSWho): SCAL[2];
  VAR
   Local  : PROC;
   Default: SCAL[2];
 BEGIN
  SEARCH(Route, Route, , trgRoute);
  L_Way.StandOnRouteTKind(Memo.ud_mb());
  IF trgWho # L_Way.rwswho_Driver THEN
   Default:=1;
  ELSE
   IF L_Env.IsRouteDriver() THEN
    Default:=TKind.Rgn <= L_Way.tkrgn_Order;
   ELSE
    Default:=TKind.Rgn > L_Way.tkrgn_Order;
   END;
  END;
  Local:=PROCREF(E_Utils.RWDst_NeedRouteForCurStaffSpread);
  IF ~!Local THEN
   RETURN Local(Default, Memo.ud_me(), trgWho, trgRoute);
  ELSE
   RETURN Default;
  END;
 END {E_RWDst_NeedRouteForCurStaffSpread};

 PRIVATE PROCEDURE getODateIdx(_ODate: LIKE(Money.ODate); ODates: DATE[]): NUMERIC[0];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE ~!ODates[i] & (ODates[i] # _ODate) DO
   INC(i);
  END;
  RETURN i;
 END {getODateIdx};

 PRIVATE PROCEDURE ODateIsDone(_ODate: LIKE(Money.ODate); ODates: DATE[]): SCAL[2];
 BEGIN
  RETURN ~!ODates[getODateIdx(_ODate, ODates)];
 END {ODateIsDone};

 PRIVATE PROCEDURE MergeODates(VAR dst: DATE[]; src: DATE[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE ~!src[i] DO
   dst[getODateIdx(src[i], dst)]:=src[i];
   INC(i);
  END;
 END {MergeODates};

 PRIVATE PROCEDURE SpreadNotProduction(_Who: L_Way.tRWSWho);
  VAR
   Total      : L_PRoll.tSum;
   cTim, rTim : L_PRoll.tTime;
   cSum, rSum : L_PRoll.tSum;
   mRoute     : LIKE(Route.Route);
   mMark      : LIKE(Mark.Mark);
   mASCP      : SCAL[2];
   mInvFacil  : SCAL[2];
   mSum       : L_PRoll.tSum;
   MCodeGroup : tRouteGroup;
   IsRouteDrv : SCAL[2];
 BEGIN
  MCodeGroup:=E_RWDst_GroupForMCode(_Who, Money.MCode);
  Total:=0;
  SELECT(RWM03, mfSort, , MyFirm.MyFirm, _Who, StaffLog.Sort);
  WHILE OCCURE(RWM03) DO
   IF E_RWDst_NeedRouteForCurStaffSpread(RWM03.Route, RWM03.Who) &
      ((MCodeGroup = 0) | E_RWDst_RouteInGroup(OnRWM03, MCodeGroup)) THEN
    INC(Total, RWM03.Sum);
   END;
   NEXT(RWM03);
  END; (* WHILE OCCURE(RWM03) ... *)
  SETEMPTY(mRoute, mMark);
  mASCP    :=0;
  mInvFacil:=0;
  mSum     :=0;
  rSum     :=Money.Sum;
  rTim     :=Money.Tim;
  IF Total # 0 THEN
   FIRST(RWM03);
   WHILE OCCURE(RWM03) DO
    IF E_RWDst_NeedRouteForCurStaffSpread(RWM03.Route, RWM03.Who) &
       ((MCodeGroup = 0) | E_RWDst_RouteInGroup(OnRWM03, MCodeGroup)) THEN
     cSum:=Money.Sum * (RWM03.Sum / Total);
     cTim:=Money.Tim * (RWM03.Sum / Total);
     ADD(RWM02, TSN, , Money.TSN, Money.ODate, MyFirm.MyFirm, StaffLog.Sort, _Who, RWM03.Route, RWM03.Mark, EMPTYOF(RWM02.BoxNbr),
                       RWM03.ASCP, RWM03.InvFacil, Money.MCode, sd_NotProduction, 1,
         RWM02.Sum, cSum,
         RWM02.Tim, cTim);
     IF Math.Abs(cSum) > mSum THEN
      mRoute   :=RWM03.Route;
      mMark    :=RWM03.Mark;
      mASCP    :=RWM03.ASCP;
      mInvFacil:=RWM03.InvFacil;
      mSum     :=Math.Abs(cSum);
     END;
     DEC(rSum, cSum);
     DEC(rTim, cTim);
    END;
    NEXT(RWM03);
   END; (* WHILE OCCURE(RWM03) ... *)
  END; (* IF Total # 0...*)
  IF (rSum # 0) | (rTim # 0) THEN
   ADD(RWM02, TSN, , Money.TSN, Money.ODate, MyFirm.MyFirm, StaffLog.Sort, _Who, mRoute, mMark, EMPTYOF(RWM02.BoxNbr),
                     mASCP, mInvFacil, Money.MCode, sd_NotProduction, 1,
       RWM02.Sum, rSum,
       RWM02.Tim, rTim);
  END;
 END {SpreadNotProduction};

 PRIVATE PROCEDURE E_RWDst_RWM02Need2Distr(): SCAL[2];
  VAR
   Local : PROC;
   Result: SCAL[2];
   TKind02,
   TKind03: LIKE(TKind.TKind);
 BEGIN
  Local:=PROCREF(E_Utils.RWDst_RWM02Need2Distr);
  IF ~!Local THEN
   RETURN Local(Memo.ud_me());
  END;
  Result:=0;
  IF ~!RWM02.Route & ~!RWM03.Route THEN
   SEARCH(Route, Route, , RWM02.Route); TKind02:=L_Way.GetRouteTKind(Memo.ud_mb(), 1);
   SEARCH(Route, Route, , RWM03.Route); TKind03:=L_Way.GetRouteTKind(Memo.ud_mb(), 1);
   Result:=TKind02 = TKind03;
  END;
  RETURN Result;
 END {E_RWDst_RWM02Need2Distr};

 PRIVATE PROCEDURE DistributeRWM02FictiveRoute(cMyFirm: P_Firm.tMyFirm);
  VAR
   Total      : L_PRoll.tSum;
   iTim,
   cTim,
   rTim       : L_PRoll.tTime;
   iSum,
   cSum,
   rSum       : L_PRoll.tSum;
   mRoute     : LIKE(Route.Route);
   mASCP      : SCAL[2];
   mInvFacil  : SCAL[2];
   mSum       : L_PRoll.tSum;
   cSort      : LIKE(Sort.Sort);
   cWho       : L_Way.tRWSWho;
   cMark      : LIKE(Mark.Mark);
   cMCode     : LIKE(MCList.MCode);
   cDirect    : tSalDirect;
 BEGIN
  APP.Get().NewPrompt("।  'ॠ' ");
  SELECT(RWM02, mfMark, , cMyFirm, 0);
  WHILE OCCURE(RWM02) DO
   NARROWSEL(RWM02, Who, Mark, Sort, Route);
   IF ~SELECT(RWM03, MyFirm, RWM02.MyFirm, RWM02.Who, RWM02.Route) THEN
    Total:=0;
    IF SELECT(RWM03, mfMark, RWM02.MyFirm, RWM02.Who, RWM02.Mark, RWM02.Sort) |
       SELECT(RWM03, mfMark, RWM02.MyFirm, RWM02.Who, RWM02.Mark) |
       SELECT(RWM03, mfSort, RWM02.MyFirm, RWM02.Who, RWM02.Sort) THEN
     WHILE OCCURE(RWM03) DO
      IF E_RWDst_RWM02Need2Distr() THEN
       INC(Total, RWM03.Sum);
      END;
      NEXT(RWM03);
     END; (* WHILE OCCURE(RWM03) ... *)
    END;
    IF Total # 0 THEN
     WHILE OCCURE(RWM02) DO
      PROMPT("ઠ " + RWM02.Mark + ",  " + RWM02.Route);
      SAVE(RWM02);
      cSort    :=RWM02.Sort;
      cWho     :=RWM02.Who;
      cMark    :=RWM02.Mark;
      cMCode   :=RWM02.MCode;
      cDirect  :=RWM02.Direct;
      SETEMPTY(mRoute);
      mASCP    :=0;
      mInvFacil:=0;
      mSum     :=0;
      iSum     :=RWM02.Sum;
      iTim     :=RWM02.Tim;
      rSum     :=iSum;
      rTim     :=iTim;
      FIRST(RWM03);
      WHILE OCCURE(RWM03) DO
       IF E_RWDst_RWM02Need2Distr() THEN
        cSum:=iSum * (RWM03.Sum / Total);
        cTim:=iTim * (RWM03.Sum / Total);
        SAVE(RWM02);
        ADD(RWM02, TSN, , EMPTYOF(RWM02.TSN), EMPTYOF(RWM02.ODate), cMyFirm, cSort, cWho,
                          RWM03.Route, cMark, EMPTYOF(RWM02.BoxNbr),
                          RWM03.ASCP, RWM03.InvFacil, cMCode, cDirect, 2,
            RWM02.Sum, cSum,
            RWM02.Tim, cTim);
        RESTORE(RWM02);
        IF Math.Abs(cSum) > mSum THEN
         mRoute   :=RWM03.Route;
         mASCP    :=RWM03.ASCP;
         mInvFacil:=RWM03.InvFacil;
         mSum     :=Math.Abs(cSum);
        END;
        DEC(rSum, cSum);
        DEC(rTim, cTim);
       END;
       NEXT(RWM03);
      END; (* WHILE OCCURE(RWM03) ... *)
      ADD(RWM02, TSN, , EMPTYOF(RWM02.TSN), EMPTYOF(RWM02.ODate), cMyFirm, cSort, cWho,
                        RWM02.Route, RWM02.Mark, EMPTYOF(RWM02.BoxNbr),
                        RWM02.ASCP, RWM02.InvFacil, cMCode, cDirect, 2,
          RWM02.Sum, -iSum,
          RWM02.Tim, -iTim);
      IF (rSum # 0) | (rTim # 0) THEN
       ADD(RWM02, TSN, , EMPTYOF(RWM02.TSN), EMPTYOF(RWM02.ODate), cMyFirm, cSort, cWho,
                         mRoute, cMark, EMPTYOF(RWM02.BoxNbr),
                         mASCP, mInvFacil, cMCode, cDirect, 2,
           RWM02.Sum, rSum,
           RWM02.Tim, rTim);
      END;
      RESTORE(RWM02);
      NEXT(RWM02);
     END;
    END; (* IF Total # 0...*)
   END;
   NEXTINEXTENDEDSEL(RWM02, Who, Mark, Sort, Route);
  END; (* WHILE OCCURE(RWM02) ... *)
 END {DistributeRWM02FictiveRoute};

 TYPE
  tSpreadManner = SCAL[2];
  tSpreadValue  = NUMERIC[3];

 CONST
  sm_byTime   = 0;
  sm_bySalary = 1;

 PRIVATE PROCEDURE E_SpreadManner(): tSpreadManner;
 BEGIN
  IF L_APtm.IsMTA() THEN
   RETURN sm_bySalary;
  ELSE
   RETURN sm_byTime;
  END;
 END {E_SpreadManner};

 PRIVATE PROCEDURE Spread();
  VAR
   MCNum : NUMERIC[0];
   MCArr : LIKE(MCList.MCode)[MAXOF(MCList.MCode)+1];
   _TSum,
   MnMny : L_PRoll.tSum      [MAXOF(MCList.MCode)+1];
   _TTim,
   MnTMn : L_PRoll.tTime     [MAXOF(MCList.MCode)+1];
   RWMny : L_PRoll.tSum      [MAXOF(MCList.MCode)+1];

   DtNum : NUMERIC[0];
   DtArr : STRING[]       [1024];
   DtSum : L_PRoll.tSum   [1024];

   _Val  : tSpreadValue;
   PrtVal: tSpreadValue;
   GrpVal: tSpreadValue[16];
   TotVal: tSpreadValue;

   _Sum     : L_PRoll.tSum;
   _Tim     : L_PRoll.tTime;
   i, j,
   Idx      : NUMERIC[0];
   GrpIdx   : tRouteGroup;
   cODates,
   dODates    : DATE[31+1];

   mVal       : NUMERIC[3];
   mODate     : DATE;
   mSort      : LIKE(Sort.Sort);
   mWho       : L_Way.tRWSWho;
   mMark      : LIKE(Mark.Mark);
   mBoxNbr    : LIKE(Car.BoxNbr);
   mRoute     : LIKE(Route.Route);
   mASCP      : SCAL[2];
   mInvFacil  : SCAL[2];

   _Who       : L_Way.tRWSWho;
 BEGIN
  APP.Get().NewPrompt("।");
  L_AFM.MakeMultipleIndex("RMArr", "RMCode: "+GET_TYPE_SPEC(tRMCode).Name+";"+
                                   "RMVal: "+GET_TYPE_SPEC(tSpreadValue).Name,
                          "RMCode: RMCode");
  SETEMPTY(MCArr, DtArr);
  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   SELECT(Staff, MyFirm, , MyFirm.MyFirm);
   WHILE OCCURE(Staff) DO
    PROMPT(" " + L_Str.IntStr(Staff.Man));
    SETEMPTY(dODates);
    SELECT(RWM02, TSN, , Staff.TSN);
    WHILE OCCURE(RWM02) DO
     SELECT(RMArr, RMCode);
     REMSEL(RMArr);
     SETZERO(MCNum, MnMny, MnTMn, RWMny,
             DtNum, DtSum,
             GrpVal, TotVal,
             _TSum, _TTim,
             mVal);

     NARROWSEL(RWM02, ODate, MyFirm, Sort, Who);
 
     SETEMPTY(cODates);
     SELECT(Money, TSN, , Staff.TSN, Memo.ud_mb());
     WHILE OCCURE(Money) DO
      NARROWSEL(Money, WFPeriod, ODate);
      IF (Money.ODate=RWM02.ODate) & ~ODateIsDone(Money.ODate, dODates) THEN
       HISTCONF(Money.ODate, Staff, StaffLog);
       CONFORM(StaffLog, Officer);
       IF NeedWho(RWM02.Who) THEN
        cODates[getODateIdx(Money.ODate, cODates)]:=Money.ODate;
        FOR_EACH Money DO
         CONFORM(Money, MCList);
         IF (MCList.MCTyp = L_PRoll.mct_Credit) & (MCList.TimeType # L_PRoll.tt_Include) THEN
          L_Math.Math_InsInOrderedArray(MCArr, MCNum, Money.MCode);
          INC(MnMny[Money.MCode], Money.Sum);
          INC(MnTMn[Money.MCode], Money.Tim);
         END;
        END; (* FOR_EACH Money *)
       END; (* IF NeedWho ... *)
      END; (* IF ~ODateIsDone ... *)
      NEXTINEXTENDEDSEL(Money, WFPeriod, ODate);
     END; (* WHILE OCCURE(Money) ... *)
     MergeODates(dODates, cODates);
 
     WHILE OCCURE(RWM02) DO
      L_Math.Math_InsInOrderedArray(MCArr, MCNum, RWM02.MCode);
      INC(RWMny[RWM02.MCode], RWM02.Sum);
      DEC(MnMny[RWM02.MCode], RWM02.Sum);
      DEC(MnTMn[RWM02.MCode], RWM02.Tim);
      IF E_SpreadManner() = sm_byTime THEN
       L_PRoll.PositionOnMCList(RWM02.MCode);
       _Val:=RWM02.Tim * (MCList.TimeType = L_PRoll.tt_Production);
      ELSE
       _Val:=RWM02.Sum;
      END;
      IF _Val # 0 THEN
       ADD(RMArr, RMCode, , GetRMCode(RWM02.Route, RWM02.BoxNbr), RMArr.RMVal, _Val);
       j:=1;
       WHILE j <= MAXOF(tRouteGroup) DO
        IF E_RWDst_RouteInGroup(OnRWM02, j) THEN
         INC(GrpVal[j], _Val);
        END;
        INC(j);
       END;
       INC(TotVal, _Val);
      END;
      INC(DtSum[L_Math.Math__InsInOrderedArray(DtArr, DtNum,
                                               GetDtCode(RWM02.Route, RWM02.BoxNbr, RWM02.MCode))],
          RWM02.Sum);
      NEXT(RWM02);
     END;
     FIRST(RWM02);
     IF TotVal > 0 THEN
      WHILE OCCURE(RWM02) DO
       NARROWSEL(RWM02, Route, Mark, BoxNbr, ASCP, InvFacil);
       IF SEARCH(RMArr, RMCode, GetRMCode(RWM02.Route, RWM02.BoxNbr)) THEN
        PrtVal:=RMArr.RMVal;
       ELSE
        PrtVal:=0;
       END;
       IF PrtVal # 0 THEN
        IF Math.Abs(PrtVal) > mVal THEN
         mVal     :=Math.Abs(PrtVal);
         mODate   :=RWM02.ODate;
         mSort    :=RWM02.Sort;
         mWho     :=RWM02.Who;
         mRoute   :=RWM02.Route;
         mMark    :=RWM02.Mark;
         mBoxNbr  :=RWM02.BoxNbr;
         mASCP    :=RWM02.ASCP;
         mInvFacil:=RWM02.InvFacil;
        END;
        SAVE(RWM02);
        i:=0;
        WHILE i < MCNum DO
         IF MnMny[MCArr[i]] # 0 THEN
          _Sum:=0;
          _Tim:=0;
          IF (RWMny[MCArr[i]] # 0) THEN
           IF L_Math.Math__BisectionSearch(DtArr, DtNum,
                                           GetDtCode(RWM02.Route, RWM02.BoxNbr, MCArr[i]),
                                           Idx) THEN
            _Sum:=MnMny[MCArr[i]] * (DtSum[Idx] / RWMny[MCArr[i]]);
            _Tim:=MnTMn[MCArr[i]] * (DtSum[Idx] / RWMny[MCArr[i]]);
           END;
          ELSE
           GrpIdx:=E_RWDst_GroupForMCode(RWM02.Who, MCArr[i]);
           IF GrpIdx = 0 THEN
            _Sum:=MnMny[MCArr[i]] * (PrtVal / TotVal);
            _Tim:=MnTMn[MCArr[i]] * (PrtVal / TotVal);
           ELSIF E_RWDst_RouteInGroup(OnRWM02, GrpIdx) THEN
            L_General.Assert(GrpVal[GrpIdx] # 0, " "+MCArr[i]+" ।  । ॢ");
            _Sum:=MnMny[MCArr[i]] * (PrtVal / GrpVal[GrpIdx]);
            _Tim:=MnTMn[MCArr[i]] * (PrtVal / GrpVal[GrpIdx]);
           END;
          END;
          IF _Sum # 0 THEN
           ADD(RWM02, TSN, , Staff.TSN, RWM02.ODate, RWM02.MyFirm, RWM02.Sort, RWM02.Who, RWM02.Route, RWM02.Mark, RWM02.BoxNbr,
                             RWM02.ASCP, RWM02.InvFacil, MCArr[i], sd_No, 0,
               RWM02.Sum, _Sum,
               RWM02.Tim, _Tim);
           INC(_TSum[i], _Sum);
           INC(_TTim[i], _Tim);
          END;
         END;
         INC(i);
        END;
        RESTORE(RWM02);
       END; (* IF PrtVal # 0... *)
       NEXTINEXTENDEDSEL(RWM02, Route, Mark, BoxNbr, ASCP, InvFacil);
      END; (* WHILE OCCIRE(RWM02)... *)
     END; (* IF TotVal > 0... *)
     IF mVal # 0 THEN
      SAVE(RWM02);
      i:=0;
      WHILE i < MCNum DO
       IF (MnMny[MCArr[i]]-_TSum[i]) # 0 THEN
        ADD(RWM02, TSN, , Staff.TSN, mODate, MyFirm.MyFirm, mSort, mWho, mRoute, mMark, mBoxNbr,
                          mASCP, mInvFacil, MCArr[i], sd_No, 0,
            RWM02.Sum, MnMny[MCArr[i]]-_TSum[i],
            RWM02.Tim, MnTMn[MCArr[i]]-_TTim[i]);
       END;
       INC(i);
      END;
      RESTORE(RWM02);
     END; (*IF ~!mVal *)
     NEXTINEXTENDEDSEL(RWM02, ODate, MyFirm, Sort, Who);
    END; (* WHILE OCCURE(RWM02) ... *)

    SELECT(Money, TSN, , Staff.TSN, Memo.ud_mb());
    WHILE OCCURE(Money) DO
     NARROWSEL(Money, WFPeriod, ODate);
     HISTCONF(Money.ODate, Staff, StaffLog);
     CONFORM(StaffLog, Officer);
     IF NeedWho(L_Way.rwswho_Driver) THEN
      _Who:=L_Way.rwswho_Driver;
     ELSIF NeedWho(L_Way.rwswho_Guard) THEN
      _Who:=L_Way.rwswho_Guard;
     ELSE
      SETEMPTY(_Who);
     END;
     IF ~!_Who THEN
      FOR_EACH Money DO
       CONFORM(Money, MCList);
       IF (MCList.MCTyp = L_PRoll.mct_Credit) & ((MCList.TimeType = L_PRoll.tt_Include) | ~ODateIsDone(Money.ODate, dODates)) THEN
        SpreadNotProduction(_Who);
       END;
      END; (* FOR_EACH Money  *)
     END; (* IF ~!_Who ... *)
     NEXTINEXTENDEDSEL(Money, WFPeriod, ODate);
    END; (* WHILE OCCURE(Money) ... *)
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)

   DistributeRWM02FictiveRoute(MyFirm.MyFirm);

   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
  L_AFM.AF_PurgeTemp("RMArr");
 END {Spread};

 PUBLIC PROCEDURE PrepareRWM02(Rebuild: SCAL[2]);
 BEGIN
  IF L_AFM.inRegistering()THEN
   Create_RWM02();
   Create_RWM03();
   L_AFM.msrf_Register("RWM02", "RWM02", L_General.timeCond_InMonth, Memo.ud_mb(), Memo.ud_mb());
  END;
  IF L_AFM.inAttaching() THEN
   IF Rebuild | ~L_AFM.msrf_Reuse("RWM02", 0) THEN
    APP.Get().NewPrompt(L_AFM.rf_PreparePromptStr("RWM02"));
    L_General.SetCacheables(["Car", "CarLog", "CarPro", "MarkG", "MarkGM", "MMthLog", "MoneyMth",
                             "RoutePro", "SortPro", "Staff", "StaffLog",
                             "RouteIP", "ExitIP"]);
    PrepareRWM01(Rebuild);
    L_AFM.msrf_Create("RWM02");
    L_AFM.AF_CreateTemp("RWM03", "RWM03");
    PackInRWM02();
    Spread();
    PurgeRWM01();
    L_AFM.msrf_Store("RWM02");
    L_AFM.AF_PurgeTemp("RWM03");
   END; (* IF ~CanReuse ... *)
  END;
 END {PrepareRWM02};

 PUBLIC PROCEDURE PurgeRWM02();
 BEGIN
  L_AFM.AF_PurgeTemp("RWM02");
 END {PurgeRWM02};

 CONST
  TkMNum = 2;

 PUBLIC VAR
  wVldPsgPlan: SCAL[2];

 VAR
  wNumber,
  wDate,
  wStartT,
  ByPlanInc   : SCAL[2];

 PRIVATE PROCEDURE Create_IN001(BasisName: STRING[]);
  VAR
   MainIdx: STRING[];
 BEGIN
  CreateFILE(^BasisName, "", "窠  ", "");

  CreateFIELD(^BasisName, TSN,     LIKE(Staff.TSN),   "", "", "", " ", "");
  CreateFIELD(^BasisName, ODate,   DATE,              "", "", "", " ਪ  ६饭", "");
  CreateFIELD(^BasisName, drvTSN,  LIKE(Staff.TSN),   "", "", "", "  ⥫", "");
  CreateFIELD(^BasisName, BoxNbr,  LIKE(Car.BoxNbr),  "", "", "", "ࠦ", "");
  CreateFIELD(^BasisName, Route,   LIKE(Route.Route), "", "", "", "", "");
  CreateFIELD(^BasisName, Exit,    LIKE(StExit.Exit), "", "", "", "室", "");
  CreateFIELD(^BasisName, WD,      SCAL[8],           "", "", "", "  ", "");
  CreateFIELD(^BasisName, Who,     L_Way.tRWSWho,     "", "", "", "", "");
  CreateFIELD(^BasisName, myPln,   SCAL[2],           "", "", "", " ࠡ⭨  '' ", "");
  CreateFIELD(^BasisName, Dummy,   SCAL[2],           "", "", "", "", "=1  ப,     = 0. 0051072");

  MainIdx:='TSN, ODate, BoxNbr, Route, Exit, WD, Who, myPln, drvTSN, Dummy';
  IF wDate THEN
   CreateFIELD(^BasisName, Date,   DATE,              "", "", "", "", "");
   MainIdx:=MainIdx + ", Date";
  END;
  IF wStartT THEN
   CreateFIELD(^BasisName, Day,    LIKE(RWayJ.Day),   "", "", "", "", "");
   CreateFIELD(^BasisName, StartT, LIKE(RWayJ.StartT),"", "", "", "६", "");
   CreateFIELD(^BasisName, Trip,   LIKE(SEJobs.Trip), "", "", "", "", "");
   CreateFIELD(^BasisName, Dir,    SCAL[3],           "", "", "", "ࠢ", "אַ|⭮| ।");
   MainIdx:=MainIdx + ", Day, StartT, Trip, Dir";
  END;

  IF ByPlanInc THEN
   CreateFIELD(^BasisName, piKind,   SCAL[2],             "", "", "", " ஢", "");
   CreateFIELD(^BasisName, piObject, STRING[9],           "", "", "", "ꥪ ஢", "");
   CreateFIELD(^BasisName, piDay,    LIKE(ExitIPL.Day),   "", "", "", " ࢠ ஢", "");
   CreateFIELD(^BasisName, piTime,   LIKE(ExitIPL.Time),  "", "", "", "६ ࢠ ஢", "");
   CreateFIELD(^BasisName, piCnd,    LIKE(ExitIP.Cnd),    "", "", "", "⥫⢠", "");
   CreateFIELD(^BasisName, piType,   LIKE(ExitIP.Type),   "", "", "", " ஢", "");
   MainIdx:=MainIdx + ", piKind, piObject, piDay, piTime, piCnd, piType";
  END;

  CreateFIELD(^BasisName, ASCP,      SCAL[2],  "", "", "", "稥 ", "");
  CreateFIELD(^BasisName, GuardCnt,  SCAL[10], "", "", "", "⢮ ஢", "");
  CreateFIELD(^BasisName, DriverCnt, SCAL[10], "", "", "", "⢮ ⥫", "");
  MainIdx:=MainIdx + ", ASCP, GuardCnt, DriverCnt";
  IF wNumber THEN
   CreateFIELD(^BasisName, Number, LIKE(WayLMen.Number), "", "", "", "  ਣ", "");
   MainIdx:=MainIdx + ", Number";
  END;
  CreateFIELD(^BasisName, VldPsgPln, NUMERIC[10, 2], "", "0", "", "ନ ᠦ ",   "");

  CreateFIELD(^BasisName, RunTim,  NUMERIC[10, 3],    "", "0", "", "६  ஡", "");
  CreateFIELD(^BasisName, IncTim,  NUMERIC[10, 3],    "", "0", "", "६  ", "");
  CreateFIELD(^BasisName, IncTrp,  NUMERIC[10, 2],    "", "0", "", "᪨ ३  室", "");
  CreateFIELD(^BasisName, IncPln,  NUMERIC[10, 3],    "", "0", "", " 窠", "");
  CreateFIELD(^BasisName, IncFct,  NUMERIC[10, 3],    "", "0", "", "᪠ 窠", "");
  CreateFIELD(^BasisName, TkMFct,  NUMERIC[10, 3][TkMNum], "", "0", "", "஥", "");
  CreateFIELD(^BasisName, CasFct,  NUMERIC[10, 3],     "", "0", "", "窠  ", "");
  CreateFIELD(^BasisName, Run,     NUMERIC[10, 2],     "", "0", "", "஡", "");
  CreateFIELD(^BasisName, CntTim,  NUMERIC[10, 3],     "", "0", "", "஫쭮 ६ (⭮  楫 )", "");
  CreateFIELD(^BasisName, Pass,    NUMERIC[10, 1],     "", "0", "", "ᠦ", "");
  CreateFIELD(^BasisName, VldPsg,  NUMERIC[10, 1][10], "", "0", "", "ᠦ  ", "");
  CreateFIELD(^BasisName, VldSum,  NUMERIC[10, 3][10], "", "0", "", "室  ", "");
  CreateFIELD(^BasisName, pIncPln, NUMERIC[10, 3],     "", "0", "", " ࠡ⭨", "");
  CreateFIELD(^BasisName, pIncTim, NUMERIC[10, 3],     "", "0", "", "६   ࠡ⭨", "");
  CreateFIELD(^BasisName, pIncTrp, NUMERIC[10, 2],     "", "0", "", "᪨ ३   ࠡ⭨", "");
  CreateFIELD(^BasisName, iIncPln, NUMERIC[10, 3],     "", "0", "", "㠫  ࠡ⭨", "");
  CreateFIELD(^BasisName, iIndFct, NUMERIC[10, 3],     "", "0", "", "㠫 䠪 ࠡ⭨", "");
  CreateFIELD(^BasisName, iIncTim, NUMERIC[10, 3],     "", "0", "", "६  㠫  ࠡ⭨", "");
  CreateFIELD(^BasisName, iIncTrp, NUMERIC[10, 2],     "", "0", "", "᪨ ३  㠫  ࠡ⭨", "");

  CreateINDEXandLINK(^BasisName, TSN, UNIQUE, Staff, TSN, USER, "", "", ^MainIdx);

  CreateINDEXandLINK(^BasisName, BoxNbr, PLURAL, Car,    BoxNbr, USER, "", "", BoxNbr, Route);
  CreateINDEXandLINK(^BasisName, Route,  PLURAL, Route,  Route,  USER, "", "", Route);
  CreateINDEXandLINK(^BasisName, Exit,   PLURAL, StExit, Exit,   USER, "", "", Exit);

  SetVersionOfFILE(^BasisName, 0021 + 1000 * wDate + 2000 * 1);
 END {Create_IN001};

 PUBLIC PROCEDURE E_TrIndFct(Who: L_Way.tRWSWho; _Number: LIKE(WayLMen.Number); _RWJPro: LIKE(RWayJP.RWJPro)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.TrIndFct);
  IF ~!Local THEN
   RETURN Local(Who, _Number, _RWJPro);
  ELSE
   RETURN 0;
  END;
 END {E_TrIndFct};

 PRIVATE PROCEDURE GetRWJP(GetFact  : SCAL[2];
                           _Who     : L_Way.tRWSWho;
                           _Number  : LIKE(WayLMen.Number);
                           GuardCnt : NUMERIC[0];
                           VAR _IncFct,
                               _CasFct: NUMERIC[2];
                           VAR _TkMFct: NUMERIC[2][];
                           VAR _Pass  : NUMERIC[0];
                           VAR VldPsg : NUMERIC[0][MAXOF(L_Way.tVldPsgKind)+1];
                           VAR IndFct: L_APWI.tPlanIncome);
  VAR
   cCasFct,
   cPass   : SCAL[2];
   i       : NUMERIC[0];
 BEGIN
  SETSEL(RWayJP, RWayS, RWayJ.RWayS, RWayJ.Day, RWayJ.StartT);
  FOR_EACH RWayJP DO
   IF GetFact THEN
    IF (_Who = L_Way.rwswho_Driver) & (GuardCnt > 0) THEN
     cCasFct:=~L_Way.E_TrCasFct(L_Way.rwswho_Guard, 1, RWayJP.RWJPro);
     cPass  :=~L_Way.E_TrPsgFct(L_Way.rwswho_Guard, 1, RWayJP.RWJPro);
    ELSE
     cCasFct:=1;
     cPass  :=1;
    END;
    IF L_Way.TrIncFct(_Who, _Number, RWayJP.RWJPro) & L_Way.rwswhoWithSale(_Who) THEN
     IF cCasFct | ~L_Way.E_TrCasFct(_Who, _Number, RWayJP.RWJPro) THEN
      INC(_IncFct, RWayJP.Value);
     END;
     IF E_TrIndFct(_Who, _Number, RWayJP.RWJPro) THEN
      INC(IndFct, RWayJP.Value);
     END;
    END;
    i:=0;
    WHILE i < TkMNum DO
     IF E_Way.TrTkMFct(_Who, _Number, RWayJP.RWJPro, i) THEN
      INC(_TkMFct[i], RWayJP.Value);
     END;
     INC(i);
    END;
    IF    cCasFct & L_Way.E_TrCasFct(_Who, _Number, RWayJP.RWJPro) THEN
     INC(_CasFct, RWayJP.Value);
    ELSIF cPass   & L_Way.E_TrPsgFct(_Who, _Number, RWayJP.RWJPro) THEN
     INC(_Pass, RWayJP.Value);
    END;
   END; (* IF GetFact... *)
   i:=0;
   WHILE i <= MAXOF(L_Way.tVldPsgKind) DO
    IF L_Way.IsVldPsgRWJPro(_Who, _Number, i, RWayJP.RWJPro) THEN
     INC(VldPsg[i], RWayJP.Value);
    END;
    INC(i);
   END;
  END; (* FOR_EACH RWayJP *)
 END {GetRWJP};

 PRIVATE PROCEDURE _TrControlTim(): NUMERIC[3];
 BEGIN
  IF (RWayS.Change = 0) |
     (TIMEINT(C_L2T(RWayS.StartTim), 20:00, RWayJ.StartT, RWayJ.StopT) > 0) THEN
   RETURN RWayJ.StopT - RWayJ.StartT;
  ELSE
   RETURN 0;
  END;
 END {_TrControlTim};

 PRIVATE PROCEDURE DefineDir(): SCAL[3];
  VAR
   Dir    : SCAL[3];
   TripCnt: NUMERIC[0];
 BEGIN
  Dir:=SEJobs.Dir;
  SAVE(SEJobs);
  CHANGESEL(SEJobs, Exit, , SEJobs.Exit);
  TripCnt:=1;
  WHILE (TripCnt < RWayJ.Fact) & NEXT(SEJobs) DO
   IF SEJobs.Dir # Dir THEN
    Dir:=dir_NotDefined;
   END;
   INC(TripCnt);
  END;
  RESTORE(SEJobs);
  RETURN Dir;
 END {DefineDir};

 PRIVATE PROCEDURE E_NeedPlaningIntervals(): SCAL[2];
 BEGIN
  IF L_General.GetAPSiteID() = "53" THEN
   RETURN 0;
  ELSE
   RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Way.NeedPlaningIntervals), 1);
  END;
 END {E_NeedPlaningIntervals};

 PRIVATE PROCEDURE GetIndexString_byPlan(_Cnd: L_Way.tIncPlanCondition; AccessIPLRequired: SCAL[2]): STRING[];
  VAR
   tcpi     : L_Way.ttcpi;
   _piDay   : LIKE(ExitIPL.Day);
   _piTime  : LIKE(ExitIPL.Time);
   _piType  : LIKE(ExitIP.Type);
   DayAsStr,
   TimeAsStr: STRING[];
   Result   : STRING[];
   curDay   : LIKE(SEJobs.Day);
   curStartT: LIKE(SEJobs.StartT);
   curStopT : LIKE(SEJobs.StopT);
   dummy    : SCAL[2];
 BEGIN
  TRY
   tcpi:=L_Way.GetTypeOfCalcIncPlan(_Cnd, RWayS.Date, RWayJ.StartT);
   L_Way.E_GetTimesForPlInc(RWayS.Date, curDay, curStartT, curStopT, L_APWI.piScope_RWTaxed);
   dummy:=L_Way.AccessIPL(tcpi, _Cnd, RWayS.Date, curDay, curStartT);
  EXCEPT
  ON Exc: Exc_Raise DO
   tcpi:=L_Way.tcpi_FromRoute;
   AccessIPLRequired:=0;
  END;

  Result:=tcpi;

  IF tcpi = L_Way.tcpi_FromRoute THEN
   Result:=Result + ', "'+SEJobs.Route + '"';
  ELSE
   Result:=Result + ', "'+SEJobs.Exit + '"';
  END;

  IF AccessIPLRequired & E_NeedPlaningIntervals() THEN
   IF tcpi = L_Way.tcpi_FromRoute THEN
    _piDay :=RouteIPL.RoutDay;
    _piTime:=RouteIPL.RoutTime;
    _piType:=RouteIP.Type;
   ELSE
    _piDay :=ExitIPL.Day;
    _piTime:=ExitIPL.Time;
    _piType:=ExitIP.Type;
   END;
   DayAsStr :=_piDay;
   TimeAsStr:=L_DatTim.TimeStr(_piTime);
  ELSE
   DayAsStr :="EMPTYOF(RouteIPL.RoutDay)";
   TimeAsStr:="EMPTYOF(RouteIPL.RoutTime)";
   IF tcpi = L_Way.tcpi_FromRoute THEN
    _piType:=L_Way.ript_Canceled;
   ELSE
    _piType:=L_Way.ipt_Canceled;
   END;
  END;
  RETURN Result + "," + DayAsStr + "," + TimeAsStr + "," + _Cnd + "," + _piType;
 END {GetIndexString_byPlan};

 PRIVATE PROCEDURE rwsWho2trsWho(Who: L_Way.tRWSWho): L_Way.tTRSWho;
 BEGIN
  IF    Who = L_Way.rwswho_Driver THEN
   RETURN L_Way.trs_Driver;
  ELSIF Who = L_Way.rwswho_Guard THEN
   RETURN L_Way.trs_Guard;
  ELSIF Who = L_Way.rwswho_Chopper THEN
   RETURN L_Way.trs_Chopper;
  ELSE
   L_General.CallUs(0);
  END;
 END {rwsWho2trsWho};

 PRIVATE PROCEDURE IN001_Ins(_Who        : L_Way.tRWSWho;
                             _Number     : LIKE(WayLMen.Number);
                             trgTSN      : LIKE(Staff.TSN);
                             GetFact,
                             PutIncValues: SCAL[2];
                             GuardCnt,
                             DriverCnt   : NUMERIC[0];
                             VldPsgPlan  : NUMERIC[2]);
  VAR
   tIncPln,
   pIncPln,
   iIndFct,
   iIncPln    : NUMERIC[2];
   tIncTim,
   pIncTim,
   iIncTim    : NUMERIC[3];
   tIncTrp,
   pIncTrp,
   iIncTrp    : NUMERIC[1];
   tIncFct,
   tIndFct,
   tCasFct    : NUMERIC[2];
   tTkMFct    : NUMERIC[2][TkMNum];
   tCntTim,
   tRunTim    : NUMERIC[3];
   tPass      : NUMERIC[0];
   tRun       : NUMERIC[2];
   IndexStr   : STRING[];
   Dir        : SCAL[3];
   tVldPsg    : NUMERIC[0][MAXOF(L_Way.tVldPsgKind)+1];
   tVldSum    : NUMERIC[2][MAXOF(L_Way.tVldPsgKind)+1];
   AddI2P     : SCAL[2];
   _Cnd       : L_Way.tIncPlanCondition;
   ZeroPValues: SCAL[2];
   pVldPsg    : L_APWI.tVldPsgAmnt;
 BEGIN
  SETZERO(tIncFct, tCasFct, tTkMFct, tPass, tVldPsg, tVldSum, tIndFct);
  SETZERO(iIncPln, iIncTim, iIncTrp, iIndFct, AddI2P);
  tRunTim:=RWayJ.StopT-RWayJ.StartT;
  IF WJMode.IncSel THEN
   tIncTim :=tRunTim;
   tIncTrp :=L_Way.RealRWayJTrip() * RWayJ.Fact;
   tIncPln :=RWayJ.PlIncome * E_IN001_TakeOnIncome(RWayS.Date, _Who);
   tRunTim :=tIncTim;
   tCntTim :=_TrControlTim();
   tRun    :=RWayJ.Run * RWayJ.Fact;
   GetRWJP(GetFact, _Who, _Number, GuardCnt, tIncFct, tCasFct, tTkMFct, tPass, tVldPsg, tIndFct);
   IF wStartT & L_Way.AccessTckRcS_byRWayJ(trgTSN, rwsWho2trsWho(_Who)) THEN
    CONFORM(TckRcJ, TckRcJR);
    WHILE OCCURE(TckRcJR) DO
     CONFORM(TckRcJR, TckKind);
     IF ~L_TRS.E_NeedAutoTaxTckRcJR(TckRcS.Date) THEN
      INC(tVldSum[L_TRS.VldPsgKindOfTckKind(TckKind.TckKind)], TckRcJR.Sum);
     END;
     NEXT(TckRcJR);
    END; (* WHILE OCCURE(TckRcJR) ... *)
   END;
   IF    (_Who = L_Way.rwswho_Guard) & L_APWI.E_IndividualIPl(RWayS.Date, _Who, GuardCnt) THEN
    AddI2P:=1;
    L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
    iIncPln:=L_APWI.GetPlForIPC(L_Way.ipc_Guard);
    iIndFct:=tIndFct;
    iIncTim:=tIncTim;
    iIncTrp:=tIncTrp;
   ELSIF (_Who = L_Way.rwswho_Driver) & L_APWI.E_IndividualIPl(RWayS.Date, _Who, GuardCnt) THEN
    AddI2P:=0;
    L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
    iIncPln:=L_APWI.GetPlForIPC(L_Way.ipc_Driver) / DriverCnt;
    iIndFct:=tIndFct / DriverCnt;
    iIncTim:=tIncTim / DriverCnt;
    iIncTrp:=tIncTrp / DriverCnt;
   END;
  ELSE
   SETZERO(tIncPln, tIncTim, tIncTrp, iIncPln, iIncTim, iIncTrp, iIndFct);
   SETZERO(tCntTim, tRun);
  END;
  IF PutIncValues THEN
   IF _Who = L_Way.rwswho_Driver THEN
    pIncPln:=tIncPln / DriverCnt;
    pIncTim:=tIncTim / DriverCnt;
    pIncTrp:=tIncTrp / DriverCnt;
   ELSIF _Who = L_Way.rwswho_Guard THEN
    pIncPln:=tIncPln / GuardCnt;
    pIncTim:=tIncTim;
    pIncTrp:=tIncTrp;
   END;
  ELSIF _Who = L_Way.rwswho_Chopper THEN
   pIncPln:=L_Way.GetChopperPlanIncome(TRSRW.TSN);
   SETZERO(pIncTim, pIncTrp);
  ELSE
   SETZERO(pIncPln, pIncTim, pIncTrp);
  END;
  IF _Who # L_Way.rwswho_Driver THEN
   SETZERO(tIncPln, tIncTim, tIncTrp,
           tCntTim, tRun);
  END;
  IF AddI2P THEN
   INC(pIncPln, iIncPln);
   INC(pIncTim, iIncTim);
   INC(pIncTrp, iIncTrp);
  END;
  IndexStr:='StaffLog.TSN, StaffLog.Date, CarLog.BoxNbr, SEJobs.Route, SEJobs.Exit, ' +
            'L_APWI.CWD_ForTrip(L_APtm.wdk_toInc, SEJobs.Exit, RWayS.Date, RWayJ.Day, RWayJ.StartT), ' +
            '_Who, PutIncValues';

  IF _Who = L_Way.rwswho_Driver THEN INC(IndexStr, ', StaffLog.TSN');
  ELSE                               INC(IndexStr, ', RWayS.TSN');
  END;

  pVldPsg:=L_Math.Math_GetArraySum(tVldPsg, HIGH(tVldPsg)+1);
  ZeroPValues:=(pIncPln = 0) & (pIncTim = 0) & (pIncTrp = 0) & (pVldPsg=0);
  INC(IndexStr, ', ZeroPValues');

  IF wDate THEN
   IndexStr:=IndexStr + ", RWayS.Date";
  END;

  IF wStartT THEN
   IndexStr:=IndexStr + ", RWayJ.Day, RWayJ.StartT, RWayJ.Trip, Dir";
   Dir:=DefineDir();
  END;
  IF ByPlanInc THEN
   IF GuardCnt = 0 THEN
    _Cnd:=L_Way.ipc_Driver;
   ELSE
    _Cnd:=L_APWI.E_rwsWho2IPC(L_APWI.w2im_toAnalyze, _Who, GuardCnt);
   END;
   IndexStr:=IndexStr + ", " + GetIndexString_byPlan(_Cnd, (pIncPln # 0) | (tIncFct # 0) | (pVldPsg # 0));
  END;
  IndexStr:=IndexStr + ", " +
            L_Str.IntStr(L_Way.E_CarASCPLev(RWayS.Date, RWayS.BoxNbr, SEJobs.Route, SEJobs.Exit)) + ", " +
            L_Str.IntStr(GuardCnt) + ", " +
            L_Str.IntStr(DriverCnt);
  IF wNumber THEN
   IndexStr:=IndexStr + ", "+L_Str.IntStr(_Number);
  END;
  VldPsgPlan:=VldPsgPlan * E_IN001_TakeOnIncome(RWayS.Date, _Who);
  ADD(IN001, TSN, , ^IndexStr,
         IN001.RunTim,    tRunTim    / DriverCnt,
         IN001.Run,       tRun       / DriverCnt,
         IN001.CntTim,    tCntTim    / DriverCnt,
         IN001.IncPln,    tIncPln    / DriverCnt,
         IN001.IncTim,    tIncTim    / DriverCnt,
         IN001.IncTrp,    tIncTrp    / DriverCnt,
         IN001.pIncPln,   pIncPln,
         IN001.pIncTim,   pIncTim,
         IN001.pIncTrp,   pIncTrp,
         IN001.iIncPln,   iIncPln,
         IN001.iIndFct,   iIndFct,
         IN001.iIncTim,   iIncTim,
         IN001.iIncTrp,   iIncTrp,
         IN001.IncFct,    tIncFct    / DriverCnt,
         IN001.TkMFct[0], tTkMFct[0] / DriverCnt,
         IN001.TkMFct[1], tTkMFct[1] / DriverCnt,
         IN001.CasFct,    tCasFct    / DriverCnt,
         IN001.Pass,      tPass      / DriverCnt,
         IN001.VldPsg[L_Way.vpk_Moscow      ], tVldPsg[L_Way.vpk_Moscow      ] / DriverCnt,
         IN001.VldPsg[L_Way.vpk_MoscowRegion], tVldPsg[L_Way.vpk_MoscowRegion] / DriverCnt,
         IN001.VldPsg[L_Way.vpk_OtherSocial ], tVldPsg[L_Way.vpk_OtherSocial ] / DriverCnt,
         IN001.VldPsg[L_Way.vpk_Paid        ], tVldPsg[L_Way.vpk_Paid        ] / DriverCnt,
         IN001.VldSum[L_Way.vpk_Moscow      ], tVldSum[L_Way.vpk_Moscow      ] / DriverCnt,
         IN001.VldSum[L_Way.vpk_MoscowRegion], tVldSum[L_Way.vpk_MoscowRegion] / DriverCnt,
         IN001.VldSum[L_Way.vpk_OtherSocial ], tVldSum[L_Way.vpk_OtherSocial ] / DriverCnt,
         IN001.VldSum[L_Way.vpk_Paid        ], tVldSum[L_Way.vpk_Paid        ] / DriverCnt,
         IN001.VldPsgPln, VldPsgPlan / DriverCnt);
 END {IN001_Ins};

 PUBLIC PROCEDURE E_IN001_TakeOnIncome(D: DATE; rwsWho: L_Way.tRWSWho): SCAL[2];
  VAR
   Local  : PROC;
   Default: SCAL[2];
 BEGIN
  Default:=(rwsWho#L_Way.rwswho_Guard) | ~L_Way.E_CarASCPLev(RWayS.Date, RWayS.BoxNbr, Route.Route, SEJobs.Exit);
  Local:=PROCREF(E_Way.IN001_TakeOnIncome);
  IF ~!Local THEN
   RETURN Local(D, rwsWho, Default);
  ELSE
   RETURN Default;
  END;
 END {E_IN001_TakeOnIncome};

 PRIVATE PROCEDURE IN001_OneRWayS(_Who   : L_Way.tRWSWho;
                                  _Number: LIKE(WayLMen.Number);
                                  trgTSN : LIKE(Staff.TSN);
                                  VAR
                                   wGu,
                                   wGuVld,
                                   wDr   : SCAL[4][]);
  VAR
   TripNbr,
   GuardCnt,
   GuVldCnt,
   DriverCnt  : NUMERIC[0];
   VldPsgPlan : NUMERIC[2];
   FFDr       : SCAL[2];
   IsStaffPlan: SCAL[2];
 BEGIN
  FFDr:=L_Way.E_SeparateIncRWJP(RWayS.Date);
  TripNbr:=0;
  SETSEL(RWayJ, RWayS, RWayS.RWayS);
  FOR_EACH RWayJ DO
   IF (_Who = L_Way.rwswho_Driver) | L_RWayS.IsRWayJForCurWayLMen() THEN

    IF _Who = L_Way.rwswho_Guard THEN
     GuardCnt:=_Number*L_Way.rwswhoWithSale(L_Way.rwswho_Guard)+wGu[TripNbr];
     GuVldCnt:=_Number*L_Way.rwswhoWithVld (L_Way.rwswho_Guard)+wGuVld[TripNbr]
    ELSE
     GuardCnt:=wGu   [TripNbr];
     GuVldCnt:=wGuVld[TripNbr]
    END;

    IF    _Who = L_Way.rwswho_SDriver THEN
     wDr[TripNbr]:=Math.Max(wDr[TripNbr], 1 + _Number);
    ELSIF wDr[TripNbr] = 0 THEN
     wDr[TripNbr]:=1;
    END;
    DriverCnt:=wDr[TripNbr];

    CONFORM(RWayJ, Quality, SEJobs, WJMode, Route);
    IF (Quality.Type | (RWayJ.PlIncome # 0) | (L_APWI.TrVldPsgPlan() # 0)) &
       Route.IncSel & (WJMode.IncSel | WJMode.RunSel) THEN
     VldPsgPlan:=0;
     IF    (_Who = L_Way.rwswho_Driver) | (_Who = L_Way.rwswho_SDriver) THEN
      IF wVldPsgPlan & (GuVldCnt = 0) THEN
       VldPsgPlan:=L_APWI.TrVldPsgPlan();
      END;
      IsStaffPlan:=(GuardCnt = 0) | L_APWI.E_IndividualIPl(RWayS.Date, L_Way.rwswho_Guard, GuardCnt);
      IN001_Ins(L_Way.rwswho_Driver, 1, trgTSN,
                IsStaffPlan | FFDr, IsStaffPlan,
                GuardCnt, DriverCnt, VldPsgPlan);
     ELSIF _Who = L_Way.rwswho_Guard THEN
      IF wVldPsgPlan & L_Way.rwswhoWithVld(_Who) THEN
       VldPsgPlan:=L_APWI.TrVldPsgPlan();
       IF GuVldCnt > 1 THEN
        VldPsgPlan:=VldPsgPlan * L_APWI.E_VldPsgPlanMultiplier(RWayS.Date, GuVldCnt);
       END;
      END;
      IsStaffPlan:=L_Way.rwswhoWithSale(_Who) & ~L_APWI.E_IndividualIPl(RWayS.Date, _Who, GuardCnt);
      IN001_Ins(_Who, _Number, trgTSN,
                IsStaffPlan | FFDr, IsStaffPlan,
                GuardCnt, DriverCnt, VldPsgPlan);
      INC(wGu   [TripNbr], L_Way.rwswhoWithSale(L_Way.rwswho_Guard));
      INC(wGuVld[TripNbr], L_Way.rwswhoWithVld (L_Way.rwswho_Guard));
     ELSE
      L_General.CallUs(0);
     END; (* IF _Who ... *)
    END; (* IF Quality.Type ... *)
   END; (* IF _Who ... *)
   INC(TripNbr);
  END; (* FOR_EACH RWayJ *)
 END {IN001_OneRWayS};

 PRIVATE PROCEDURE IN001_PassWLM(_Who   : L_Way.tRWSWho;
                                 _Number: LIKE(WayLMen.Number);
                                 VAR wGu,
                                     wGuVld,
                                     wDr    : SCAL[4][]);
 BEGIN
  SELECT(WayLMen, RWayS, , RWayS.RWayS);
  WHILE OCCURE(WayLMen) DO
   IF (WayLMen.Who = _Who - 1) & (WayLMen.Number = _Number) THEN
    HISTCONF(RWayS.Date, WayLMen, Staff, StaffLog);
    IN001_OneRWayS(_Who, WayLMen.Number, WayLMen.TSN, wGu, wGuVld, wDr);
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
 END {IN001_PassWLM};

 PRIVATE PROCEDURE IN001_GatherByRWayS(PerB, PerE: DATE);
  VAR
   wGuVld,
   wGu,
   wDr   : SCAL[4][100];
 BEGIN
  APP.Get().NewPrompt("ઠ  ");
  SETSEL(RWayS, sDate, L_Way.rwsStat_Rated);
  SRCINSEL(RWayS, GE, , PerB);
  WHILE OCCURE(RWayS) & (RWayS.Date <= PerE) DO
   PROMPT(L_DatTim.DateStr(RWayS.Date)+ "  " + RWayS.RWayS);
   IF ~L_Way.E_IsGuardIdleExit(RWayS.Date, RWayS.Exit) THEN
    CONFORM(RWayS, Calendar, Car);
    L_Car.StandOnCarLog(Car.BoxNbr, RWayS.Date);
    SETZERO(wGu, wGuVld, wDr);
    IN001_PassWLM(L_Way.rwswho_Guard,   2, wGu, wGuVld, wDr);
    IN001_PassWLM(L_Way.rwswho_Guard,   1, wGu, wGuVld, wDr);
    IN001_PassWLM(L_Way.rwswho_SDriver, 2, wGu, wGuVld, wDr);
    IN001_PassWLM(L_Way.rwswho_SDriver, 1, wGu, wGuVld, wDr);
    HISTCONF(RWayS.Date, RWayS, Staff, StaffLog);
    IN001_OneRWayS(L_Way.rwswho_Driver, 1, RWayS.TSN, wGu, wGuVld, wDr);
   END; (* IF ~L_Way.E_IsGuardIdleExit( ... *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {IN001_GatherByRWayS};

 PRIVATE PROCEDURE IN001_GatherByTckRcS(PerB, PerE: DATE);
 BEGIN
  APP.Get().NewPrompt("ઠ  ");
  L_APWI.CheckDoneTckRcs(PerB, PerE);
  IF L_Way.E_TckRcLevel(Memo.UpTo()) THEN
   L_AFM.MakeIndex("TRSRW", "TSN  : LIKE(Staff.TSN);"+
                            "RWayS: LIKE(RWayS.RWayS)");
   SETSEL(TckRcS, Date);
   SRCINSEL(TckRcS, GE, , PerB);
   WHILE OCCURE(TckRcS) & (TckRcS.Date <= PerE) DO
    IF TckRcS.AsWho = L_Way.trs_Chopper THEN
     IF TckRcS.Done THEN
      SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
      WHILE OCCURE(TckRcJ) DO
       IF ~SEARCH(TRSRW, TRSRW, TckRcS.TSN, TckRcJ.asRWayS) THEN
        TRSRW.TSN  :=TckRcS.TSN;
        TRSRW.RWayS:=TckRcJ.asRWayS;
        INSERT(TRSRW);
       END;
       NEXT(TckRcJ);
      END; (* WHILE OCCURE(TckRcJ) ... *)
     END;
    END;
    NEXT(TckRcS);
   END; (* WHILE OCCURE(TckRcS) ... *)
   IF SELECT(TRSRW, TRSRW) THEN
    WHILE OCCURE(TRSRW) DO
     SEARCH(RWayS, RWayS, , TRSRW.RWayS);
     PROMPT("⭨ " + TRSRW.TSN + ",  " + TRSRW.RWayS);
     CONFORM(RWayS, Calendar, Car);
     L_Car.StandOnCarLog(Car.BoxNbr, RWayS.Date);
     CONFORM(CarLog, Mark);
     SEARCH(Staff, TSN, , TRSRW.TSN);
     HISTCONF(RWayS.Date, Staff, StaffLog);
     SELECT(RWayJ, RWayS, , RWayS.RWayS);
     WHILE OCCURE(RWayJ) DO
      CONFORM(RWayJ, SEJobs, Route, WJMode, Quality);
      IF L_Way.AccessTckRcS_byRWayJ(TRSRW.TSN, L_Way.trs_Chopper) THEN
       IN001_Ins(L_Way.rwswho_Chopper, 1, TRSRW.TSN,
                 1, 0,
                 0, 1, 0);
      END;
      NEXT(RWayJ);
     END; (* WHILE OCCURE(RWayJ) ... *)
     NEXT(TRSRW);
    END; (* WHILE OCCURE(TRSRW) ... *)
   END;
   L_AFM.AF_PurgeTemp("TRSRW");
  END; (* IF L_Way.E_TckRcLevel ... *)
 END {IN001_GatherByTckRcS};

 PUBLIC PROCEDURE E_DetailByDayIN001(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.DetailByDay), 1);
 END {E_DetailByDayIN001};

 PRIVATE PROCEDURE intPrepare_IN001(BasisName: STRING[5]; _wDate, _wStartT, _ByPlanInc: SCAL[2]);
  VAR
   PerB,
   PerE  : DATE;
 BEGIN
  PerB:=Memo.ud_fr();
  PerE:=Memo.ud_ut();
  wDate    :=_wDate;
  wStartT  :=_wStartT;
  ByPlanInc:=_ByPlanInc;
  wVldPsgPlan:=L_Way.E_VldPsgPlanLev(PerE);

  wNumber:=L_APtm.IsTramDepo();

  IF L_AFM.inRegistering()THEN
   Create_IN001("IN001");
   L_AFM.msrf_Register("IN001", BasisName, L_General.timeCond_InIntvl, PerB, PerE);
  END;
  IF L_AFM.inAttaching() THEN
   IF ~L_AFM.msrf_Reuse("IN001", 0) THEN
    APP.Get().NewPrompt(L_AFM.rf_PreparePromptStr("IN001"));
    L_General.SetCacheables(["Car", "CarLog", "CarPro", "MarkG", "MarkGM", "MMthLog", "MoneyMth",
                             "RoutePro", "StExit", "SEJobs", "SortPro", "Staff", "StaffLog",
                             "RouteIP", "ExitIP"]);
    L_Way.CheckTaxed(PerB, PerE);
    L_APWI.CheckDoneTckRcs(PerB, PerE);
    L_AFM.msrf_Create("IN001");
    IN001_GatherByRWayS(PerB, PerE);
    IN001_GatherByTckRcS(PerB, PerE);
    L_AFM.msrf_Store("IN001");
   END; (* IF ~msrf_Reuse ... *)
  END;
  IF BasisName # "IN001" THEN
   L_AFM.AF_PurgeTemp("IN001");
   Create_IN001(BasisName);
   L_AFM.msrf_Register(BasisName, BasisName, L_General.timeCond_InIntvl, PerB, PerE);
   L_General.CallUs(L_AFM.msrf_Reuse(BasisName, 1));
  END;
 END {intPrepare_IN001};

 PUBLIC PROCEDURE Prepare_IN001(_wDate: SCAL[2]);
 BEGIN
  intPrepare_IN001("IN001", _wDate, 0, 1);
 END {Prepare_IN001};

 PUBLIC PROCEDURE Prepare_IN002();
 BEGIN
  intPrepare_IN001("IN002", 1, 1, 0);
 END {Prepare_IN002};

 PUBLIC PROCEDURE Purge_IN001();
 BEGIN
  L_AFM.AF_PurgeTemp("IN001");
 END {Purge_IN001};

 PUBLIC PROCEDURE Purge_IN002();
 BEGIN
  L_AFM.AF_PurgeTemp("IN002");
 END {Purge_IN002};

END.
