(*
%Copyright   (c) Polak Computer System
%Author      25.07.2000 12:43:15 RSN
%Purpose     ⮢ ॣ 䠩  
%Type        library
%Specific    AP
%Modified    15.08.2014 18:33:01 POLAK\San
%Environment
*)

 MODULE D_TP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 CONST
  otp_Amount = 4;
  pv_Amount  = 3;

 PUBLIC TYPE
  tOTP_Change = SCAL[2];
  tOrdTimPart = SCAL[otp_Amount];
  tOrdTimPartArray = NUMERIC[3][otp_Amount];

 PRIVATE TYPE
  tTimeIntvl = STRING[10];

 IMPORT L_General, L_DatTim, L_AFM, L_Way, L_Car, L_APtm, P_Mark, P_Route,
        Math, E_Way, L_Str, P_OwnData, P_Exit, L_StdFrm, L_APWI, P_Firm, L_Env, D_RWS, Memo;

 CONST
  PointsNum = 6;
  WDNum     = 8;
  TkMNum    = 2;

  WDArr_Dim = 1000;

 PUBLIC CONST
  otp_Whl = 0;
  otp_WIM = 1;
  otp_Otg = 2;
  otp_Rsv = 3;

  idx_Plan = 0;
  idx_Fact = 1;

  pv_Averg = 0;
  pv_Limit = 1;
  pv_Sittn = 2;

 PUBLIC VAR
  wVldPsgPlan,
  wTimeIntvl: SCAL[2];

 PRIVATE VAR
  CtrlTime: TIME[PointsNum];
  WDArr   : LIKE(Calendar.WeekDay)[WDArr_Dim];
  SEWDCoef: NUMERIC[0][WDNum];
  wASCP   : SCAL[2];

  geoowd_ShowMsgForIncPln: SCAL[2];

 PRIVATE PROCEDURE Create_TP(_D: DATE);
  VAR
   MainIdx: STRING[];
 BEGIN
  wASCP:=L_Way.E_ASCPLev(_D);

  CreateFILE(TP, "", "᪨ ", "");

  CreateFIELD(TP, Route,     LIKE(Route.Route), "", "", "", " ", "");
  CreateFIELD(TP, _Modif,    LIKE(RoutMod.Modif), "", "", "", "䨪 ", "");
(* ७  Modif  ᮮ⢥騥  - ਬ 祭 쭮 *)
  CreateFIELD(TP, Mark,      LIKE(Mark.Mark), "", "", "", " ન", "");
  CreateFIELD(TP, DN,        SCAL[8],        "", "", "", " ", "");
  CreateFIELD(TP, TOL,       SCAL[2],        "", "", "", "祡 ", "");
  CreateFIELD(TP, Column,    LIKE(CarLog.Column),"", "", "", " ", "");
  CreateFIELD(TP, Exit,      LIKE(StExit.Exit), "", "", "", " 室", "");
  CreateFIELD(TP, Wlm0,      SCAL[2],        "", "", "", "", "");
  CreateFIELD(TP, Wlm1,      SCAL[2],        "", "", "", "⠦", "");
  CreateFIELD(TP, Alien,     SCAL[2],        "", "", "", "0 -, 1 -㦮", "");
  CreateFIELD(TP, CarAmnt,   NUMERIC[0],     "", "", "", "⢮ ", "");
  CreateFIELD(TP, AllTrips,  NUMERIC[8, 1],  "", "0", "", " ३", "");
  CreateFIELD(TP, ZeroTrips, NUMERIC[8, 1],  "", "0", "", "㫥 ३", "");
  CreateFIELD(TP, GoodTrips, NUMERIC[8, 1],  "", "0", "", "⢥ ३", "");
  CreateFIELD(TP, BadTrips,  NUMERIC[6, 1],  "", "0", "", "ࠪ ३", "");
  CreateFIELD(TP, FullRun,   NUMERIC[8, 2],  "", "0", "", "騩 ஡", "");
  CreateFIELD(TP, ZeroRun,   NUMERIC[8, 2],  "", "0", "", "㫥 ஡", "");
  CreateFIELD(TP, RunPass,   NUMERIC[8, 2],  "", "0", "", "஡  ᠦࠬ", "");
  CreateFIELD(TP, OrdTim,    NUMERIC[10, 3], "", "0", "", "६  拉( ----)", "");
  CreateFIELD(TP, WrkTim,    NUMERIC[10, 3], "", "0", "", "設", "");
  CreateFIELD(TP, ZeroTim,   NUMERIC[10, 3], "", "0", "", "६ 㫥 ३ᮢ", "");
  CreateFIELD(TP, PikTim,    NUMERIC[10, 3], "", "0", "", "-", "");
  CreateFIELD(TP, PVKm,      NUMERIC[12, 2], "", "0", "", "-", "");
  CreateFIELD(TP, ZeroPVKm,  NUMERIC[12, 2], "", "0", "", "- 㫥 ३ᮢ", "");
  CreateFIELD(TP, MarkG,     LIKE(MarkG.MarkG), "", "", "", " 㯯 ப  ", "");
  CreateFIELD(TP, BoxNbr,    LIKE(Car.BoxNbr), "", "", "", "ࠦ", "");
  CreateFIELD(TP, Sort,      LIKE(Sort.Sort), "", "", "", "", "");
  MainIdx:='Route, _Modif, Mark, DN, TOL, Column, Exit, Wlm0, Wlm1, Alien, MarkG, CarAmnt, BoxNbr, Sort';
  IF wASCP THEN
   CreateFIELD(TP, ASCP,     SCAL[2],         "", "", "", "稥 ", "");
   MainIdx:=MainIdx + ", ASCP";
  END;
  IF wTimeIntvl THEN
   CreateFIELD(TP, TimeItvl, tTimeIntvl,   "", "", "", "ࢠ ६", "");
   MainIdx:=MainIdx + ", TimeItvl";
  END;

  CreateINDEXandLINK(TP, Route,  UNIQUE, Route,  Route,  USER, "", "", ^MainIdx);
  CreateINDEXandLINK(TP, Mark,   PLURAL, Mark,   Mark,   USER, "", "", Mark);
  CreateINDEXandLINK(TP, Exit,   PLURAL, StExit, Exit,   USER, "", "", Exit);
  CreateINDEXandLINK(TP, MarkG,  PLURAL, MarkG,  MarkG,  USER, "", "", MarkG);
  CreateINDEXandLINK(TP, BoxNbr, PLURAL, Car,    BoxNbr, USER, "", "", BoxNbr);
  CreateINDEXandLINK(TP, Sort,   PLURAL, Sort,   Sort,   USER, "", "", Sort);

  SetVersionOfFILE(TP, 1000 * wASCP + 003);
 END {Create_TP};

 PRIVATE PROCEDURE TrTotNum(): NUMERIC[1];
 BEGIN
  RETURN RWayJ.Fact;
 END {TrTotNum};

 PRIVATE PROCEDURE RealTrTotNum(RealRWayJTrip: SCAL[2]): NUMERIC[1];
 BEGIN
  IF RealRWayJTrip THEN
   RETURN TrTotNum();
  ELSE
   RETURN 0;
  END;
 END {RealTrTotNum};

 PRIVATE PROCEDURE TrZerNum(): NUMERIC[1];
 BEGIN
  IF WJMode.RunSel = L_Way.runsel_Zero THEN
   RETURN RWayJ.Fact;
  ELSE
   RETURN 0;
  END;
 END {TrZerNum};

 PRIVATE PROCEDURE RealTrZerNum(RealRWayJTrip: SCAL[2]): NUMERIC[1];
 BEGIN
  IF RealRWayJTrip THEN
   RETURN TrZerNum();
  ELSE
   RETURN 0;
  END;
 END {RealTrZerNum};

 PUBLIC PROCEDURE TrWrkNum(): NUMERIC[1];
 BEGIN
  IF WJMode.RunSel = L_Way.runsel_Work THEN
   RETURN RWayJ.Fact;
  ELSE
   RETURN 0;
  END;
 END {TrWrkNum};

 PRIVATE PROCEDURE RealTrWrkNum(RealRWayJTrip: SCAL[2]): NUMERIC[1];
 BEGIN
  IF RealRWayJTrip THEN
   RETURN TrWrkNum();
  ELSE
   RETURN 0;
  END;
 END {RealTrWrkNum};

 PUBLIC PROCEDURE TrBadNum(): NUMERIC[1];
 BEGIN
  IF Quality.Type = L_Way.QualType_Defect THEN
   RETURN TrWrkNum();
  ELSE
   RETURN 0;
  END;
 END {TrBadNum};

 PRIVATE PROCEDURE RealTrBadNum(RealRWayJTrip: SCAL[2]): NUMERIC[1];
 BEGIN
  IF RealRWayJTrip THEN
   RETURN TrBadNum();
  ELSE
   RETURN 0;
  END;
 END {RealTrBadNum};

 PUBLIC PROCEDURE TrTotRun(): NUMERIC[2];
 BEGIN
  RETURN TrTotNum()*RWayJ.Run;
 END {TrTotRun};

 PUBLIC PROCEDURE TrPsgRun(): NUMERIC[2];
 BEGIN
  RETURN TrWrkNum()*RWayJ.Run;
 END {TrPsgRun};

 PUBLIC PROCEDURE TrZerRun(): NUMERIC[2];
 BEGIN
  RETURN TrZerNum()*RWayJ.Run;
 END {TrZerRun};

 PUBLIC PROCEDURE TrTotTim(): NUMERIC[3];
 BEGIN
  RETURN RWayJ.StopT-RWayJ.StartT;
 END {TrTotTim};

 PUBLIC PROCEDURE TrOrdTim(): NUMERIC[3];
 BEGIN
  IF WJMode.WJType # L_Way.WJType_Void THEN
   RETURN TrTotTim();
  ELSE
   RETURN 0;
  END;
 END {TrOrdTim};

 PUBLIC PROCEDURE TrWrkTim(): NUMERIC[3];
 BEGIN
  IF WJMode.WJType = L_Way.WJType_Work THEN
   RETURN TrTotTim();
  ELSE
   RETURN 0;
  END;
 END {TrWrkTim};

 PRIVATE PROCEDURE TrZeroTim(): NUMERIC[3];
 BEGIN
  IF WJMode.RunSel = L_Way.runsel_Zero THEN
   RETURN TrTotTim();
  ELSE
   RETURN 0;
  END;
 END {TrZeroTim};

 PRIVATE PROCEDURE IsLoss(): SCAL[2];
 BEGIN
  RETURN (SEJobs.WJCode >= "80") & (SEJobs.WJCode <= "82");
 END {IsLoss};

 PRIVATE PROCEDURE E_TrainingOnLine(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.TrainingOnLine);
  IF ~!Local THEN
   RETURN Local();
  END;
  RETURN 0;
 END {E_TrainingOnLine};

 PRIVATE PROCEDURE GetTimeIntvl(_Day: LIKE(RWayJ.Day); _StartT: LIKE(RWayJ.StartT)): tTimeIntvl;
 BEGIN
  IF _Day = 01 THEN
   IF    _StartT < 07:00 THEN
    RETURN "00-07";
   ELSIF _StartT < 09:00 THEN
    RETURN "07-09";
   ELSIF _StartT < 10:00 THEN
    RETURN "09-10";
   ELSIF _StartT < 16:00 THEN
    RETURN "10-16";
   ELSIF _StartT < 19:00 THEN
    RETURN "16-19";
   END;
  END;
  RETURN "19-24";
 END {GetTimeIntvl};

 PRIVATE PROCEDURE Gather(_From, _UpTo: DATE; _MarkGT: LIKE(MarkG.MarkGT));
  VAR
   RealRWayJTrip,
   _Alien, _TOL,
   _Wlm0, _Wlm1: SCAL[2];
   _DN         : L_DatTim.tWeekday;
   PasVol      : NUMERIC[0];
   _MarkG      : LIKE(MarkGM.MarkG);
   CarAmount   : NUMERIC[0];
   IndexStr    : STRING[];
 BEGIN
  APP.Get().NewPrompt(TABLE.Get("TP").Description);
  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated);
  SRCINSEL(RWayS, GE, , _From);
  WHILE OCCURE(RWayS) & (RWayS.Date <= _UpTo) DO
   PROMPT(L_DatTim.DateStr(RWayS.Date)+ "  " + RWayS.RWayS);
   CONFORM(RWayS, Car);
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   CONFORM(CarLog, Mark);
   CONFORM(RWayS, Calendar);
   _MarkG:=L_Way.GetMarkG(Mark.Mark, _MarkGT);
   PasVol:=P_Mark.GetP_PasVol(Mark.Mark, RWayS.Date);
   CONFORM(RWayS, Staff);
   HISTCONF(RWayS.Date, Staff, StaffLog);
   CarAmount:=1;
   IF L_APtm.IsTramDepo() THEN
    CONFORM(RWayS, WayLCar);
    WHILE OCCURE(WayLCar) DO
     INC(CarAmount);
     NEXT(WayLCar);
    END;
   END;
   CONFORM(RWayS, RWayJ);
   WHILE OCCURE(RWayJ) DO
    CONFORM(RWayJ, SEJobs, Quality);
    IF (Quality.Type # L_Way.QualType_Annul) | IsLoss() THEN
     CONFORM(RWayJ, Route, WJMode, TKind);
     IndexStr:='SEJobs.Route, SEJobs.Modif, Mark.Mark, _DN, _TOL, CarLog.Column, SEJobs.Exit,' +
               '_Wlm0, _Wlm1, _Alien, _MarkG, CarAmount, Car.BoxNbr, StaffLog.Sort';
     IF wASCP THEN
      IndexStr:=IndexStr + ", "+L_Str.IntStr(L_Way.E_CarASCPLev(RWayS.Date, RWayS.BoxNbr, Route.Route, SEJobs.Exit));
     END;
     IF wTimeIntvl THEN
      IndexStr:=IndexStr+", '"+GetTimeIntvl(RWayJ.Day, RWayJ.StartT)+"'";
     END;
     _Alien:=P_Route.HasActualRoutePro(Route.Route, RWayS.Date, P_Route.P_OtherRoute);(*㦮 *)
     _DN   :=L_Way.E_ConvertWD(Calendar.Date, Calendar.WDWay);
     _TOL  :=E_TrainingOnLine();
     _Wlm0 :=L_Way._IsWith(L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT), L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT), 0);
     _Wlm1 :=L_Way._IsWith(L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT), L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT), 1);
     IF Quality.Type # L_Way.QualType_Annul THEN
      RealRWayJTrip:=L_Way.RealRWayJTrip();
      ADD(TP, Route, , ^IndexStr,
              TP.AllTrips,            RealTrTotNum(RealRWayJTrip),
              TP.ZeroTrips,           RealTrZerNum(RealRWayJTrip),
              TP.GoodTrips,           RealTrWrkNum(RealRWayJTrip),
              TP.BadTrips,            RealTrBadNum(RealRWayJTrip),
              TP.FullRun,   CarAmount*TrTotRun(),
              TP.ZeroRun,   CarAmount*TrZerRun(),
              TP.RunPass,   CarAmount*TrPsgRun(),
              TP.OrdTim,    CarAmount*TrOrdTim(),
              TP.WrkTim,    CarAmount*TrWrkTim(),
              TP.ZeroTim,   CarAmount*TrZeroTim(),
              TP.PikTim,    CarAmount*L_Way.E_TrPikTim(RWayS.Date),
              TP.PVKm,      CarAmount*TrTotRun()*PasVol,
              TP.ZeroPVKm,  CarAmount*TrZerRun()*PasVol);
     ELSIF IsLoss() THEN
      ADD(TP, Route, , ^IndexStr,
              TP.OrdTim, CarAmount*TrOrdTim());
     END;
    END;
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {Gather};

 PRIVATE PROCEDURE _PrepareTP(PerB, PerE: DATE);
 BEGIN
  Create_TP(PerE);
  L_AFM.AF_CreateTemp("TP", "TP");
  L_Way.CheckTaxed(PerB, PerE);
  Gather(PerB, PerE, L_Way.mgt_TEP);
 END {_PrepareTP};

 PUBLIC PROCEDURE PrepareTP();
 BEGIN
  _PrepareTP(Memo.ud_fr(), Memo.ud_ut());
 END {PrepareTP};

 PUBLIC PROCEDURE PrepareTPwRDO();
  VAR
   PerB,
   PerE: DATE;
 BEGIN
  PerB:=Memo.ud_fr();
  PerE:=Memo.ud_ut();
  Create_TP(PerE);
  L_AFM.AF_CreateTemp("TP", "TP");
  L_Way.CheckTaxed(PerB, PerE);
  IF SEARCH(MarkGT, MarkGT, L_Way.mgt_Revise_wRDO) THEN
(*
  13.07.2004 22:00:50 POLAK\Gina 易⥫쭮 㦭  Reusabil,
  ⮡  㣨   뫮 L_Way.mgt_Revise_wRDO
*)
   Gather(PerB, PerE, L_Way.mgt_Revise_wRDO);
  ELSE
   Gather(PerB, PerE, L_Way.mgt_TEP);
  END;
 END {PrepareTPwRDO};

 PUBLIC PROCEDURE PurgeTP();
 BEGIN
  L_AFM.AF_PurgeTemp("TP");
 END {PurgeTP};

 PRIVATE PROCEDURE Create_OTP1();
 BEGIN
  CreateFILE(OTP1, "", "  ᪥", "");

  CreateFIELD(OTP1, BoxNbr,   LIKE(Car.BoxNbr),    "", "", "", "ࠦ", "");
  CreateFIELD(OTP1, Column,   LIKE(CarLog.Column), "", "", "", "", "");
  CreateFIELD(OTP1, Route,    LIKE(Route.Route),   "", "", "", " ", "");
  CreateFIELD(OTP1, Mark,     LIKE(Mark.Mark),     "", "", "", " ન", "");
  CreateFIELD(OTP1, MarkG,    LIKE(MarkG.MarkG),   "", "", "", " 㯯 ப", "");
  CreateFIELD(OTP1, WD,       SCAL[8],             "", "", "", " ", "");
  CreateFIELD(OTP1, CtrlTime, TIME,                "", "", "", "⬥⪠", "");
  CreateFIELD(OTP1, Change,   tOTP_Change,         "", "", "", "", "0-ᬥ; 1-楫ᬥ");
  CreateFIELD(OTP1, MPVol,    L_Way.tPasVolEnum,   "", "", "", "㯯 ⨬", "");
  CreateFIELD(OTP1, InOtp,    SCAL[2],             "", "", "", "뢠  ᪥", "");
  CreateFIELD(OTP1, WJCode,   LIKE(WJMode.WJCode), "", "", "", " ࠡ", "");
  CreateFIELD(OTP1, Fact,     NUMERIC[0],          "", "", "", "", "");
  CreateFIELD(OTP1, Plan,     NUMERIC[0],          "", "", "", "Plan", "");

  CreateINDEXandLINK(OTP1, BoxNbr, UNIQUE, Car,    BoxNbr, BORROW, "", "", BoxNbr, Route, Mark, MarkG, WD, CtrlTime, Column, MPVol, InOtp, WJCode, Change);
  CreateINDEXandLINK(OTP1, Route,  PLURAL, Route,  Route,  USER,   "", "", Route, WD);
  CreateINDEXandLINK(OTP1, Mark,   PLURAL, Mark,   Mark,   USER,   "", "", Mark);
  CreateINDEXandLINK(OTP1, MarkG,  PLURAL, MarkG,  MarkG,  USER,   "", "", MarkG);
  CreateINDEXandLINK(OTP1, WJCode, PLURAL, WJMode, WJCode, USER,   "", "", WJCode);

  SetVersionOfFILE(OTP1, 1);
 END {Create_OTP1};

 PRIVATE PROCEDURE OTP1_FillWDArr(_From, _UpTo: DATE);
 BEGIN
  L_General.CallUs((_UpTo - _From) < WDArr_Dim);
  SELECT(Calendar, Date);
  SRCINSEL(Calendar, GE, , _From);
  WHILE OCCURE(Calendar) & (Calendar.Date <= _UpTo) DO
   WDArr[Calendar.Date-_From]:=Calendar.WDWay;
   NEXT(Calendar);
  END; (* WHILE OCCURE(Calendar)... *)
 END {OTP1_FillWDArr};

 PRIVATE PROCEDURE OTP1_ConvWD(_WD: LIKE(Calendar.WeekDay)): LIKE(Calendar.WeekDay);
 BEGIN
  IF _WD < 5 THEN
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {OTP1_ConvWD};

 PRIVATE PROCEDURE OTP1_IsIn(idx: SCAL[100]; B, E: TIME): SCAL[2];
 BEGIN
  RETURN (CtrlTime[idx]>=B) & ((CtrlTime[idx]<E) | (E<B));
 END {OTP1_IsIn};

 PUBLIC PROCEDURE OTP1_IsWork(WasInWork: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF TKind.InOut = L_Way.tkout_In THEN
   IF    (WJMode.WJType = L_Way.WJType_Work) & (WJMode.RunSel = L_Way.runsel_Work) THEN
    Result:=1;
   ELSIF WJMode.WJCode = "50" THEN
    Result:=WasInWork;
   END;
  END;
  RETURN Result;
 END {OTP1_IsWork};

 PRIVATE PROCEDURE OTP1_GetSECoef(_From, _UpTo: DATE): SCAL[2];
  VAR
   D: DATE;
   R: SCAL[2];
 BEGIN
  SETZERO(R, SEWDCoef);
  IF (StExit.UpDate > _From) & (StExit.FromD <= _UpTo) THEN
   D:=_From;
   WHILE D <= _UpTo DO
    IF L_Way._CheckExitOnDate(StExit.Exit, D) = L_Way.exvld_Active THEN
     R:=1;
     INC(SEWDCoef[WDArr[D-_From]]);
    END;
    INC(D);
   END;
  END;
  RETURN R;
 END {OTP1_GetSECoef};

 PUBLIC PROCEDURE OTP1_ToBeAsWasInWork(wZeroRun: SCAL[2]): SCAL[2];
 BEGIN
  RETURN (TKind.InOut = L_Way.tkout_In) &
         (WJMode.WJType = L_Way.WJType_Work) &
         ((WJMode.RunSel=L_Way.runsel_Work) | (wZeroRun & (WJMode.RunSel=L_Way.runsel_Zero)));
 END {OTP1_ToBeAsWasInWork};

 PUBLIC PROCEDURE OTP1_GatherFact_SingleCar(_From, _UpTo : DATE;
                                            wSetCtrlTimes: SCAL[2]);
  VAR
   In_C,
   _IsWork : SCAL[2];
   _MarkG  : LIKE(MarkG.MarkG);
   i,
   _MkPVol,
   _PasVol : NUMERIC[0];
   _Column : LIKE(Car.Column);
   _Route,
   tmpRoute: LIKE(Route.Route);
 BEGIN
  APP.Get().NewPrompt(" "+Car.BoxNbr);
  IF SELECT(RWayS, BoxNbr, Car.BoxNbr, Calendar.Date) THEN
   IF wSetCtrlTimes THEN
    L_Way.SetCtrlTimes(_From, WDArr[0], CtrlTime);
   END;
   L_Car.StandOnCarLog(Car.BoxNbr, Calendar.Date);
   _Column:=CarLog.Column;
   CONFORM(CarLog, Mark);
   _MarkG :=L_Way.GetMarkG(Mark.Mark, L_Way.mgt_TEP);
   _MkPVol:=P_Mark.GetP_PVLim(Mark.Mark, Calendar.Date);
   SETZERO(In_C);
   WHILE OCCURE(RWayS) DO
    PROMPT(L_DatTim.DateStr(RWayS.Date) + "  " + RWayS.RWayS);
    SAVE(Car);
    SELECT(WayLCar, RWayS, , RWayS.RWayS);
    WHILE OCCURE(WayLCar) DO
     CONFORM(WayLCar, Car);
     L_Car.AccessMark(Car.BoxNbr, Calendar.Date);
     INC(_MkPVol, P_Mark.GetP_PVLim(Mark.Mark, Calendar.Date));
     NEXT(WayLCar);
    END; (* WHILE OCCURE(WayLCar) ... *)
    RESTORE(Car);
    _PasVol:=L_Way.intPasVolValue2Enum(_MkPVol);
    SETZERO(_IsWork);
    SETEMPTY(_Route);
    SELECT(RWayJ, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayJ) DO
     CONFORM(RWayJ, SEJobs, WJMode, Route);
     L_Way.StandOnRouteTKind(RWayS.Date);
     IF OTP1_ToBeAsWasInWork(!_Route) THEN
      _Route:=Route.Route;
     END;
     _IsWork:=OTP1_IsWork(~!_Route);
     IF !_Route THEN
      tmpRoute:=SEJobs.Route;
     ELSE
      tmpRoute:=_Route;
     END;
     IF    ~In_C & _IsWork THEN
      In_C:=1;
      ADD(OTP1, BoxNbr,  , RWayS.BoxNbr, tmpRoute, Mark.Mark, _MarkG,
                           OTP1_ConvWD(Calendar.WDWay), L_Way.DayPoint(),
                           _Column, _PasVol, 1, SEJobs.WJCode, RWayS.Change=0,
                OTP1.Plan, 0,
                OTP1.Fact, 1);
     END;
     i:=0;
     WHILE i < PointsNum DO
      IF OTP1_IsIn(i, RWayJ.StartT, RWayJ.StopT) THEN
       ADD(OTP1, BoxNbr,  , RWayS.BoxNbr, tmpRoute, Mark.Mark, _MarkG,
                            OTP1_ConvWD(Calendar.WDWay), CtrlTime[i],
                            _Column, _PasVol, _IsWork, SEJobs.WJCode, RWayS.Change=0,
                 OTP1.Plan, 0,
                 OTP1.Fact, 1);
      END;
      INC(i);
     END; (* WHILE i < PointsNum...*)
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ)... *)
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS)... *)
  END; (* IF SELECT(RWayS, BoxNbr... *)
 END {OTP1_GatherFact_SingleCar};

 PRIVATE PROCEDURE OTP1_GatherFact(_From, _UpTo: DATE);
 BEGIN
  SELECT(Calendar, Date);
  L_General.Assert(SRCINSEL(Calendar, EQ, _From), "    "+L_DatTim.DateStr(_From));
  L_Way.SetCtrlTimes(_From, WDArr[0], CtrlTime);
  WHILE OCCURE(Calendar) & (Calendar.Date<=_UpTo) DO
   SELECT(Car, BoxNbr);
   WHILE OCCURE(Car) DO
    OTP1_GatherFact_SingleCar(_From, _UpTo, 0);
    NEXT(Car);
   END; (* WHILE OCCURE(Car)... *)
   NEXT(Calendar);
  END; (* WHILE OCCURE(Calendar)... *)
 END {OTP1_GatherFact};

 PRIVATE PROCEDURE ExitForOut(D: DATE): SCAL[2];
  VAR
   ExitStr: STRING[];
 BEGIN
  ExitStr:=StExit.Exit;
  RETURN (StExit.Change < 2) | (ExitStr[3] = "1");
 END {ExitForOut};

 PRIVATE PROCEDURE GetColumnByStExit(D: DATE): LIKE(Car.Column);
  VAR
   trgSort: LIKE(Sort.Sort);
   Result : LIKE(Car.Column);
 BEGIN
  SETEMPTY(Result);
  IF L_APtm.IsMGT() THEN
   trgSort:=L_Way.E_GetFixedSortOfExit(StExit.Exit, D, L_Way.rwswho_Driver);
   IF ~!trgSort THEN
    IF SELECT(Column, Sort, trgSort) THEN
     Result:=Column.Column;
    ELSE
     SEARCH(Sort, Sort, , trgSort);
     WHILE ~Sort.isDprt & ~!Sort.Parent & !Result DO
      SEARCH(Sort, Sort, , Sort.Parent);
      IF SELECT(Column, Sort, Sort.Sort) THEN
       Result:=Column.Column;
      END;
     END;
    END;
   END;
  END;
  IF !Result THEN
   Result:=00;
  END;
  RETURN Result;
 END {GetColumnByStExit};

 PRIVATE PROCEDURE OTP1_GatherPlan(_From, _UpTo: DATE);
  VAR
   _IsWork: SCAL[2];
   i, j   : NUMERIC[0];
   In     : SCAL[2][PointsNum];
   _Column: LIKE(CarLog.Column);
   curPVE : L_Way.tPasVolEnum;
 BEGIN
  SELECT(Car, BoxNbr);
  SELECT(StExit, Exit);
  WHILE OCCURE(StExit) DO
   PROMPT("OTP1 ઠ :  室 "+StExit.Exit);
   IF (StExit.Strict = L_Way.ExitStrict_Reg) & OTP1_GetSECoef(_From, _UpTo) THEN
    L_Way.SetCtrlTimes(_From, WDArr[0], CtrlTime);
    SETZERO(_IsWork);
    _Column:=GetColumnByStExit(_UpTo);
    curPVE :=L_Way.GetExitPasVolEnum();
    SELECT(SEJobs, Exit, , StExit.Exit);
    IF ExitForOut(_UpTo) THEN
     LOOP
      IF ~OCCURE(SEJobs) THEN
       FIRST(SEJobs);
       EXIT;
      END;
      CONFORM(SEJobs, WJMode);
      CONFORM(SEJobs, Route);
      L_Way.StandOnRouteTKind(_UpTo);
      IF OTP1_ToBeAsWasInWork(0) THEN
       EXIT;
      END;
      NEXT(SEJobs);
     END;
     j:=0;
     WHILE j < WDNum DO
      IF SEWDCoef[j] # 0 THEN
       ADD(OTP1, BoxNbr, , EMPTYOF(Car.BoxNbr), SEJobs.Route,
                           EMPTYOF(Mark.Mark), EMPTYOF(MarkG.MarkG),
                           OTP1_ConvWD(j), L_Way.DayPoint(), _Column,
                           curPVE, 1, SEJobs.WJCode, StExit.Change=0,
                 OTP1.Plan, SEWDCoef[j],
                 OTP1.Fact, 0);
      END;
      INC(j);
     END; (* WHILE j < ... *)
    END;
    i:=0; 
    WHILE i < PointsNum DO
     SRCINSEL(SEJobs, LE, , 01, CtrlTime[i]);
     IF OCCURE(SEJobs) THEN
      CONFORM(SEJobs, WJMode);
      CONFORM(SEJobs, Route);
      L_Way.StandOnRouteTKind(_UpTo);
      IF OTP1_IsWork(_IsWork) THEN
       IF OTP1_IsIn(i, SEJobs.StartT, SEJobs.StopT) THEN
        j:=0;
        WHILE j < WDNum DO
         IF SEWDCoef[j] # 0 THEN
          ADD(OTP1, BoxNbr, , EMPTYOF(Car.BoxNbr), SEJobs.Route,
                              EMPTYOF(Mark.Mark), EMPTYOF(MarkG.MarkG),
                              OTP1_ConvWD(j), CtrlTime[i], _Column,
                              curPVE, 1, SEJobs.WJCode, StExit.Change=0,
                    OTP1.Plan, SEWDCoef[j],
                    OTP1.Fact, 0);
         END;
         INC(j);
        END; (* WHILE j < ... *)
       END; (* IF IsIn ... *)
       _IsWork:=1;
      END; (* IF WJMode ... *)
     END; (* IF OCCURE(SEJobs) ... *)
     INC(i);
    END; (* WHILE i < ... *)
   END; (* IF (StExit.Strict... *)
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit)... *)
 END {OTP1_GatherPlan};

 PUBLIC PROCEDURE CreateOTP1();
 BEGIN
  Create_OTP1();
  L_AFM.AF_CreateTemp("OTP1", "OTP1");
 END {PurgeOTP1};

 PUBLIC PROCEDURE PrepareOTP1(NeedPl: SCAL[2]; _From, _UpTo: DATE);
 BEGIN
  CreateOTP1();
  OTP1_FillWDArr(_From, _UpTo);
  IF NeedPl THEN
   OTP1_GatherPlan(_From, _UpTo);
  END;
  OTP1_GatherFact(_From, _UpTo);
 END {PrepareOTP1};

 PUBLIC PROCEDURE PurgeOTP1();
 BEGIN
  L_AFM.AF_PurgeTemp("OTP1");
 END {PurgeOTP1};

 PRIVATE PROCEDURE Create_T2102();
 BEGIN
  CreateFILE(T2102, "", "/䠪᪨ ", "");

  CreateFIELD(T2102, MyFirm, P_Firm.tMyFirm,    "", "",  "", " ࣠", "");
  CreateFIELD(T2102, Route,  LIKE(Route.Route), "", "",  "", "", "");
  CreateFIELD(T2102, TKind,  LIKE(TKind.TKind), "", "",  "", " ॢ", "");
  CreateFIELD(T2102, Exit,   LIKE(StExit.Exit), "", "",  "", "室", "");
  CreateFIELD(T2102, WDWay,  SCAL[8],           "", "",  "", " ", "");
  CreateFIELD(T2102, WrkTim, NUMERIC[12, 3][2], "", "0", "", "६ c ந. ஡", "");
  CreateFIELD(T2102, WrkRun, NUMERIC[16, 2][2], "", "0", "", "ந. ஡", "");
  CreateFIELD(T2102, WrkTrp, NUMERIC[10, 1][2], "", "0", "", "ந. ३", "");
  CreateFIELD(T2102, BadTrp, NUMERIC[10, 1]   , "", "0", "", "ࠪ ३", "");
  CreateFIELD(T2102, Inc,    NUMERIC[16, 3][2], "", "0", "", "室", "");
  CreateFIELD(T2102, SEJInc, NUMERIC[16, 3],    "", "0", "", "室  ᯨᠭ", "");
  CreateFIELD(T2102, OrdTim, NUMERIC[12, 3][2], "", "0", "", "६  拉", "");
  CreateFIELD(T2102, TotRun, NUMERIC[16, 2][2], "", "0", "", "騩 ஡", "");
  CreateFIELD(T2102, ZerTim, NUMERIC[12, 3][2], "", "0", "", "६ c 㫥 ஡", "");
  CreateFIELD(T2102, ZerTrp, NUMERIC[10, 1][2], "", "0", "", "㫥 ३", "");
  CreateFIELD(T2102, PVKm,   NUMERIC[12, 2][2], "", "0", "", "-", "");
  CreateFIELD(T2102, ChngCnt,  NUMERIC[10, 3][2], "", "0", "", "⢮ ᬥ", "");
  CreateFIELD(T2102, PassRound,NUMERIC[10, 0][2], "", "0", "", "ᠦம", "");
  CreateFIELD(T2102, PlanVldPsg, L_APWI.tVldPsgAmnt, "", "0", "", "ନ ᠦ ", "");
  CreateFIELD(T2102, FactVldPsg, NUMERIC[10, 0][10], "", "0", "", "ନ ᠦ 䠪", "");

  CreateINDEXandLINK(T2102, Route, UNIQUE, Route,  Route, USER, "", "", Route, TKind, Exit, WDWay, MyFirm);
  CreateINDEXandLINK(T2102, Exit,  PLURAL, StExit, Exit,  USER, "", "", Exit);
  CreateINDEXandLINK(T2102, TKind, PLURAL, TKind,  TKind, USER, "", "", TKind);

  SetVersionOfFILE(T2102, 0002);
  L_AFM.AF_CreateTemp("T2102", "T2102");
 END {Create_T2102};

 PRIVATE PROCEDURE GetSupplChngCnt(D: DATE): NUMERIC[4];
 BEGIN
  CONFORM(TP002, Route);
  IF L_Way.SEJobsWithPlIncome(D) &
     (WJMode.RunSel = L_Way.runsel_Work) & (StExit.TripAm > 0) THEN
   RETURN TP002.GoodTrips/StExit.TripAm;
  ELSE
   RETURN 0;
  END;
 END {GetSupplChngCnt};

 PRIVATE PROCEDURE Gather_T2102(PerB, PerE: DATE);
  VAR
   _WrkTim,
   _ZerTim,
   _OrdTim: NUMERIC[3];
 BEGIN
  SELECT(SEJ01, Route);
  WHILE OCCURE(SEJ01) DO
   PROMPT("ﭨ,  " + SEJ01.Route);
   CONFORM(SEJ01, StExit);
   IF ~StExit.Suppl & (StExit.Strict = L_Way.ExitStrict_Reg) THEN
    CONFORM(SEJ01, Route);
    L_General.Assert(OCCURE(Route), "   " + SEJ01.Route + " - ᫥  ⮢ ࠭ 䠩");
    L_Way.StandOnRouteTKind(PerE);
    ADD(T2102, Route, , SEJ01.Route, TKind.TKind, SEJ01.Exit, SEJ01.WDWay, SEJ01.MyFirm,
        T2102.WrkTim[idx_Plan], SEJ01.WrkTim,
        T2102.WrkRun[idx_Plan], SEJ01.WrkRun,
        T2102.WrkTrp[idx_Plan], SEJ01.WrkTrp,
        T2102.OrdTim[idx_Plan], SEJ01.TotTim,
        T2102.TotRun[idx_Plan], SEJ01.TotRun,
        T2102.ZerTim[idx_Plan], SEJ01.ZerTim,
        T2102.SEJInc,           SEJ01.IncPlan,
        T2102.ZerTrp[idx_Plan], SEJ01.ZerTrp,
        T2102.PVKm  [idx_Plan], SEJ01.PVKm,
        T2102.ChngCnt[idx_Plan], SEJ01.ChngCnt);
   END;
   NEXT(SEJ01);
  END; (* WHILE OCCURE(SEJ01) ... *)

  SELECT(TP002, Route);
  WHILE OCCURE(TP002) DO
   NARROWSEL(TP002, Route);
   PROMPT("ﭨ, 䠪 " + TP002.Route);
   CONFORM(TP002, Route);
   L_General.Assert(OCCURE(Route), "   " + TP002.Route + " - ᫥  ⮢ ࠭ 䠩");
   L_Way.StandOnRouteTKind(PerE);
   WHILE OCCURE(TP002) DO
    NARROWSEL(TP002, BoxNbr);
    IF L_Env.RealBoxNbr(TP002.BoxNbr) THEN
     WHILE OCCURE(TP002) DO
      CONFORM(TP002, WJMode);
      SETZERO(_OrdTim, _ZerTim, _WrkTim);
      IF WJMode.WJType # L_Way.WJType_Repair THEN
       INC(_OrdTim, TP002.OrdTim);
      END;
      IF    WJMode.RunSel = L_Way.runsel_Zero THEN
       INC(_ZerTim, TP002.OrdTim);
      ELSIF WJMode.RunSel = L_Way.runsel_Work THEN
       INC(_WrkTim, TP002.OrdTim);
      END;
      CONFORM(TP002, StExit);
      IF StExit.Suppl & (StExit.Strict = L_Way.ExitStrict_Reg) THEN     (* ⥫ ஬ . = 䠪  ஬ 죮*)
       ADD(T2102, Route, , TP002.Route, TKind.TKind, TP002.Exit, TP002.DN, TP002.MyFirm,
           T2102.WrkTim[idx_Plan], _WrkTim,
           T2102.WrkRun[idx_Plan], TP002.RunPass,
           T2102.WrkTrp[idx_Plan], TP002.GoodTrips,
           T2102.OrdTim[idx_Plan], _OrdTim,
           T2102.TotRun[idx_Plan], TP002.FullRun,
           T2102.ZerTim[idx_Plan], _ZerTim,
           T2102.ZerTrp[idx_Plan], TP002.ZeroTrips,
           T2102.PVKm  [idx_Plan], TP002.PVKm[pv_Averg],
           T2102.ChngCnt[idx_Plan], GetSupplChngCnt(PerB));
      END;
      ADD(T2102, Route, , TP002.Route, TKind.TKind, TP002.Exit, TP002.DN, TP002.MyFirm,
          T2102.WrkTim[idx_Fact], _WrkTim,
          T2102.WrkRun[idx_Fact], TP002.RunPass,
          T2102.WrkTrp[idx_Fact], TP002.GoodTrips,
          T2102.BadTrp          , TP002.BadTrips,
          T2102.Inc   [idx_Plan], TP002.IncPln * (StExit.Strict = L_Way.ExitStrict_Reg), (*!   믮 ३ᠬ,    ᯨᠭ 0064635*)
          T2102.Inc   [idx_Fact], TP002.IncCnt,
          T2102.OrdTim[idx_Fact], _OrdTim,
          T2102.TotRun[idx_Fact], TP002.FullRun,
          T2102.ZerTim[idx_Fact], _ZerTim,
          T2102.ZerTrp[idx_Fact], TP002.ZeroTrips,
          T2102.PVKm  [idx_Fact], TP002.PVKm[pv_Averg],
          T2102.PassRound[idx_Fact], TP002.PassRound,
          T2102.FactVldPsg[L_Way.vpk_MoscowRegion], TP002.VldPsg[L_Way.vpk_MoscowRegion],
          T2102.FactVldPsg[L_Way.vpk_Moscow],       TP002.VldPsg[L_Way.vpk_Moscow],
          T2102.FactVldPsg[L_Way.vpk_OtherSocial],  TP002.VldPsg[L_Way.vpk_OtherSocial],
          T2102.FactVldPsg[L_Way.vpk_Paid],         TP002.VldPsg[L_Way.vpk_Paid]);
       IF wVldPsgPlan THEN
        ADD(T2102, Route, , TP002.Route, TKind.TKind, TP002.Exit, TP002.DN, TP002.MyFirm,
            T2102.PlanVldPsg, TP002.VldPsgPln);
       END;
      NEXT(TP002);
     END; (* WHILE OCCURE(File) *)
    END; (* IF L_Env.RealBoxNbr(TP002.BoxNbr) *)
    NEXTINEXTENDEDSEL(TP002, BoxNbr);
   END; (* WHILE OCCURE(File) *)
   NEXTINEXTENDEDSEL(TP002, Route);
  END; (* WHILE OCCURE(TP002) *)

  SELECT(TP002, Route);
  WHILE OCCURE(TP002) DO
   NEXT(TP002);
  END; (* WHILE OCCURE(TP002) ... *)
 END {Gather_T2102};

 PUBLIC PROCEDURE _Prepare_T2102(PerB, PerE: DATE);
 BEGIN
  Create_T2102();
  Gather_T2102(PerB, PerE);
 END {Prepare_T2102};

 PUBLIC PROCEDURE Purge_T2102();
 BEGIN
  PurgeSEJ01();
  PurgeTP002();
  L_AFM.AF_PurgeTemp("T2102");
 END {Purge_T2102};

 PUBLIC PROCEDURE Prepare_T2102();
  VAR
   PerB,
   PerE : DATE;
 BEGIN
  PerB:=Memo.ud_fr();
  PerE:=Memo.ud_ut();
  extPrepareTP002(PerB, PerE, 0);
  _PrepareSEJ01(PerB, PerE, 0, 1);
  _Prepare_T2102(PerB, PerE);
 END {Prepare_T2102};

 PRIVATE PROCEDURE Create_TP002(_D: DATE);
  VAR
   Version: SCAL[1E3];
 BEGIN
  IF ~!DATABASE.Get().Tables("TP002") THEN
   RETURN;
  END;
  CreateFILE(TP002, "", " ⮢  ", "");

  wVldPsgPlan:=L_Way.E_VldPsgPlanLev(_D);
  Version:=013;
  CreateFIELD(TP002, MyFirm,    P_Firm.tMyFirm,      "", "", "", " ࣠", "");
  CreateFIELD(TP002, TP002,     SCAL[1E10],          "", "", "", " 䨪樨  䠩", "");
  CreateFIELD(TP002, Route,     LIKE(Route.Route),   "", "", "", " ", "");
  CreateFIELD(TP002, BoxNbr,    LIKE(Car.BoxNbr),    "", "", "", "ࠦ", "");
  CreateFIELD(TP002, clDate,    DATE,                "", "", "", "CarLog.Date");
  CreateFIELD(TP002, DN,        SCAL[8],             "", "", "", " ", "");
  CreateFIELD(TP002, Exit,      LIKE(StExit.Exit),   "", "", "", " 室", "");
  CreateFIELD(TP002, WJCode,    LIKE(WJMode.WJCode), "", "", "", " ࠡ", "");
  CreateFIELD(TP002, AllTrips,  NUMERIC[8, 1],  "", "0", "", " ३", "");
  CreateFIELD(TP002, ZeroTrips, NUMERIC[8, 1],  "", "0", "", "㫥 ३", "");
  CreateFIELD(TP002, GoodTrips, NUMERIC[8, 1],  "", "0", "", "⢥ ३", "");
  CreateFIELD(TP002, BadTrips,  NUMERIC[6, 1],  "", "0", "", "ࠪ ३", "");
  CreateFIELD(TP002, FullRun,   NUMERIC[8, 2],  "", "0", "", "騩 ஡", "");
  CreateFIELD(TP002, ZeroRun,   NUMERIC[8, 2],  "", "0", "", "㫥 ஡", "");
  CreateFIELD(TP002, RunPass,   NUMERIC[8, 2],  "", "0", "", "஡  ᠦࠬ", "");
  CreateFIELD(TP002, Pass,      NUMERIC[10, 0], "", "0", "", "ᠦ", "");
  CreateFIELD(TP002, VldPsg,    NUMERIC[10, 0][10], "", "0", "", "죮 ᠦ", "");
  CreateFIELD(TP002, VldPsgRound, NUMERIC[10, 0], "", "0", "", "ᠦம  죮 ᠦࠬ", "");
  IF wVldPsgPlan THEN
   INC(Version, 100);
   CreateFIELD(TP002, VldPsgPln, NUMERIC[10, 0], "", "0", "", "ନ ᠦ ",   "");
  END;
  CreateFIELD(TP002, PassRound, NUMERIC[10, 0], "", "0", "", "ᠦம", "");
  CreateFIELD(TP002, OrdTim,    NUMERIC[10, 3], "", "0", "", "६  拉( ----)", "");
  CreateFIELD(TP002, GodTim,    NUMERIC[10, 3], "", "0", "", "६  ३ᮢ", "");
  CreateFIELD(TP002, BadTim,    NUMERIC[10, 3], "", "0", "", "६  ࠪ", "");
  CreateFIELD(TP002, RunTim,    NUMERIC[10, 3], "", "0", "", "६ c ஡", "");
  CreateFIELD(TP002, WrkTim,    NUMERIC[10, 3], "", "0", "", "ந⢥ ६", "");
  CreateFIELD(TP002, PVKm,      NUMERIC[12, 2][pv_Amount], "", "0", "", "-  ࠧ ⨬", "");
  CreateFIELD(TP002, IncCnt,    NUMERIC[12, 2], "", "0", "", "室 䠪", "");
  CreateFIELD(TP002, IncPln,    NUMERIC[12, 2], "", "0", "", "室 ", "");
  CreateFIELD(TP002, CarDay,    NUMERIC[10, 3], "", "0", "", "設",   "");

  CreateINDEXandLINK(TP002, Route,  UNIQUE, Route,  Route,  USER, "", "", Route, BoxNbr, clDate, Exit, WJCode, DN, MyFirm);
  CreateINDEXandLINK(TP002, BoxNbr, PLURAL, Car,    BoxNbr, USER, "", "", BoxNbr, clDate);
  CreateINDEXandLINK(TP002, Exit,   PLURAL, StExit, Exit,   USER, "", "", Exit);
  CreateINDEXandLINK(TP002, WJCode, PLURAL, WJMode, WJCode, USER, "", "", WJCode);
  CreateINDEX(TP002, TP002,  AUTOINCR, "", "", TP002);

  SetVersionOfFILE(TP002, Version);
 END {Create_TP002};

 PRIVATE PROCEDURE TP002_TrGodTim(): NUMERIC[3];
 BEGIN
  IF Quality.Type  = L_Way.QualType_Realiz THEN
   RETURN TrTotTim();
  ELSE
   RETURN 0;
  END;
 END {TP002_TrGodTim};

 PRIVATE PROCEDURE TP002_TrBadTim(): NUMERIC[3];
 BEGIN
  IF Quality.Type = L_Way.QualType_Defect THEN
   RETURN TrTotTim();
  ELSE
   RETURN 0;
  END;
 END {TP002_TrBadTim};

 PRIVATE PROCEDURE TP002_TrRunTim(): NUMERIC[3];
 BEGIN
  IF (WJMode.WJType = L_Way.WJType_Work) & (WJMode.RunSel # L_Way.runsel_None) THEN
   RETURN TrTotTim();
  ELSE
   RETURN 0;
  END;
 END {TP002_TrRunTim};

 PRIVATE PROCEDURE TP002_GetTotIncPsg(VAR Inc: NUMERIC[2];
                                      VAR Psg: NUMERIC[0];
                                      VAR VldPsg: NUMERIC[0][MAXOF(L_Way.tVldPsgKind)+1]);
  VAR
   i: NUMERIC[0];
 BEGIN
  SETZERO(Inc, Psg, VldPsg);
  SETSEL(RWayJP, RWayS, RWayJ.RWayS, RWayJ.Day, RWayJ.StartT);
  FOR_EACH RWayJP DO
   IF L_Way.TrIncFct(L_Way.rwswho_Driver, 1, RWayJP.RWJPro)   |
      L_Way.TrIncFct(L_Way.rwswho_Guard,  1, RWayJP.RWJPro)   |
      L_Way.TrIncFct(L_Way.rwswho_Guard,  2, RWayJP.RWJPro)   |
      L_Way.E_TrCasFct(L_Way.rwswho_Driver, 1, RWayJP.RWJPro) |
      L_Way.E_TrCasFct(L_Way.rwswho_Guard,  1, RWayJP.RWJPro) |
      L_Way.E_TrCasFct(L_Way.rwswho_Guard,  2, RWayJP.RWJPro) |
      L_Way.E_TrOrdFct(L_Way.rwswho_Driver, 1, RWayJP.RWJPro) THEN
    INC(Inc, RWayJP.Value);
   ELSIF L_Way.E_TrPsgFct(L_Way.rwswho_Driver, 1, RWayJP.RWJPro) THEN
    INC(Psg, RWayJP.Value);
   ELSE
    i:=0;
    WHILE i <= MAXOF(L_Way.tVldPsgKind) DO
     IF L_Way.IsVldPsg(i, RWayJP.RWJPro) THEN
      INC(VldPsg[i], RWayJP.Value);
     END;
     INC(i);
    END;
   END;
  END; (* FOR_EACH RWayJP *)
 END {TP002_GetTotIncPsg};

 PUBLIC PROCEDURE RP5016(D: DATE; trgRoute: LIKE(Route.Route)): NUMERIC[3];
  VAR
   trgAverageLength   : P_Route.tAverageLength;
   trgRunAroundTripTim: P_Route.tRunAroundTripTim;
   trgPsgs            : P_Route.tPsgs;
   trgCoefPass        : P_Route.tCoefPass;
 BEGIN
  P_Route.PsgRndCharact_DecodeValue(P_Route.GetRouteProSoft(trgRoute, D, P_Route.P_PsgRndCharact),
                                    trgAverageLength, trgRunAroundTripTim, trgPsgs, trgCoefPass);
  IF ~!trgAverageLength THEN
   RETURN trgAverageLength;
  ELSE
   RETURN 0;
  END;
 END {RP5016};

 PRIVATE PROCEDURE GetCSignature(): STRING[];
 BEGIN
  RETURN SEJobs.Route + "|" + SEJobs.Exit + "|" + SEJobs.WJCode;
 END {GetCSignature};

 PRIVATE PROCEDURE TP002_GatherOneDate(_BoxNbr: LIKE(Car.BoxNbr); D: DATE);
  CONST
   MaxCBox = 100;
  VAR
   _DN       : L_DatTim.tWeekday;
   PasVol    : NUMERIC[0][pv_Amount];
   Inc       : NUMERIC[2];
   AllVldPsg,
   Psg       : NUMERIC[0];
   PsgRun,
   VldPsgRound,
   PsgRound  : NUMERIC[2];
   MaxIdx,
   i,
   CBoxNbr   : NUMERIC[0];
   CBoxSigntr: STRING[][MaxCBox];
   _Signtr   : STRING[];
   CBoxWrkTim: NUMERIC[3][MaxCBox];
   MaxWrkTim : NUMERIC[3];
   VldPsg    : NUMERIC[0][MAXOF(L_Way.tVldPsgKind)+1];
   RealRWayJTrip,
   wMF       : SCAL[2];
   _MyFirm   : P_Firm.tMyFirm;
 BEGIN
  APP.Get().NewPrompt(" "+_BoxNbr+" "+L_DatTim.DateStr(D));
  IF SELECT(RWayS, sBoxNbr, L_Way.rwsStat_Rated, _BoxNbr, D) THEN
   wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
   SETZERO(CBoxNbr);
   CONFORM(RWayS, Calendar);
   _DN:=L_Way.E_ConvertWD(Calendar.Date, Calendar.WDWay);
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   IF wMF THEN
    _MyFirm:=L_Car.GetCarMyFirm(RWayS.BoxNbr, CarLog.Date);
   ELSE
    _MyFirm:=P_Firm.mf_Own;
   END;
   CONFORM(CarLog, Mark);
   PasVol[pv_Averg]:=P_Mark.GetP_PasVol   (Mark.Mark, RWayS.Date);
   PasVol[pv_Limit]:=P_Mark.GetP_PVLim    (Mark.Mark, RWayS.Date);
   PasVol[pv_Sittn]:=P_Mark.GetP_PVSitting(Mark.Mark, RWayS.Date);
   WHILE OCCURE(RWayS) DO
    PROMPT(" "+RWayS.RWayS);
    SETSEL(RWayJ, RWayS, RWayS.RWayS);
    FOR_EACH RWayJ DO
     CONFORM(RWayJ, Quality);
     IF Quality.Type # L_Way.QualType_Annul THEN
      CONFORM(RWayJ, SEJobs, Route);
      L_Way.StandOnRouteTKind(D);
      CONFORM(SEJobs, WJMode);
      TP002_GetTotIncPsg(Inc, Psg, VldPsg);
      PsgRun:=TrPsgRun();
      SETZERO(i, AllVldPsg);
      WHILE i <= MAXOF(L_Way.tVldPsgKind) DO
       INC(AllVldPsg, VldPsg[i]);
       INC(i);
      END;
      IF TKind.Rgn = L_Way.tkrgn_Order THEN
       PsgRound   :=Psg       * PsgRun;
       VldPsgRound:=AllVldPsg * PsgRun;
      ELSE
       PsgRound   :=Psg       * RP5016(RWayS.Date, SEJobs.Route);
       VldPsgRound:=AllVldPsg * RP5016(RWayS.Date, SEJobs.Route);
      END;
      RealRWayJTrip:=L_Way.RealRWayJTrip();
      ADD(TP002, Route, , SEJobs.Route, RWayS.BoxNbr, CarLog.Date, SEJobs.Exit, WJMode.WJCode, _DN, _MyFirm,
                 TP002.AllTrips,  RealTrTotNum(RealRWayJTrip),
                 TP002.ZeroTrips, RealTrZerNum(RealRWayJTrip),
                 TP002.GoodTrips, RealTrWrkNum(RealRWayJTrip),
                 TP002.BadTrips,  RealTrBadNum(RealRWayJTrip),
                 TP002.FullRun,   TrTotRun(),
                 TP002.ZeroRun,   TrZerRun(),
                 TP002.RunPass,   PsgRun,
                 TP002.Pass,      Psg,
                 TP002.PassRound, PsgRound,
                 TP002.VldPsgRound, VldPsgRound,
                 TP002.VldPsg[L_Way.vpk_Moscow      ], VldPsg[L_Way.vpk_Moscow      ],
                 TP002.VldPsg[L_Way.vpk_MoscowRegion], VldPsg[L_Way.vpk_MoscowRegion],
                 TP002.VldPsg[L_Way.vpk_OtherSocial ], VldPsg[L_Way.vpk_OtherSocial ],
                 TP002.VldPsg[L_Way.vpk_Paid        ], VldPsg[L_Way.vpk_Paid        ],
                 TP002.OrdTim,    TrOrdTim(),
                 TP002.WrkTim,    TrWrkTim(),
                 TP002.GodTim,    TP002_TrGodTim(),
                 TP002.BadTim,    TP002_TrBadTim(),
                 TP002.RunTim,    TP002_TrRunTim(),
                 TP002.PVKm[pv_Averg], TrPsgRun()*PasVol[pv_Averg],
                 TP002.PVKm[pv_Limit], TrPsgRun()*PasVol[pv_Limit],
                 TP002.PVKm[pv_Sittn], TrPsgRun()*PasVol[pv_Sittn],
                 TP002.IncCnt,    Inc,
                 TP002.IncPln,    RWayJ.PlIncome);
      _Signtr:=GetCSignature();
      i:=0;
      WHILE (i<CBoxNbr) & (_Signtr#CBoxSigntr[i]) DO
       INC(i);
      END;
      IF i>=CBoxNbr THEN
       CBoxNbr:=i+1;
       CBoxSigntr[i]:=_Signtr;
       SETZERO(CBoxWrkTim[i]);
      END;
      IF RWayJ.Run > 0 THEN
       INC(CBoxWrkTim[i], TrWrkTim());
      END;
      IF wVldPsgPlan THEN
       ADD(TP002, Route, , SEJobs.Route, RWayS.BoxNbr, CarLog.Date, SEJobs.Exit, WJMode.WJCode, _DN, _MyFirm,
                  TP002.VldPsgPln, L_APWI.TrVldPsgPlan());
      END;
     END; (* IF Quality.Type #... *)
    END; (* FOR_EACH RWayJ *)
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
   LAST(RWayS);
   i:=0; MaxWrkTim:=0; MaxIdx:=0;
   WHILE i < CBoxNbr DO                (*२⢥ , 室,  ࠡ*)
    IF CBoxWrkTim[i] > MaxWrkTim THEN
     MaxIdx:=i;
     MaxWrkTim:=CBoxWrkTim[i];
    END;
    INC(i);
   END;
   IF MaxWrkTim > 0 THEN
    ADD(TP002, Route, , L_Str.PoolItem(CBoxSigntr[MaxIdx], 0),
                        RWayS.BoxNbr,
                        CarLog.Date,
                        L_Str.PoolItem(CBoxSigntr[MaxIdx], 1),
                        L_Str.PoolItem(CBoxSigntr[MaxIdx], 2),
                        _DN,
                        _MyFirm,
               TP002.CarDay, 1);  (*設  २⢥*)
   END;
  END;
 END {TP002_GatherOneDate};

 PUBLIC PROCEDURE E_IsRoute2Distribute(_Route: LIKE(Route.Route); D: DATE): SCAL[2];
 BEGIN
  RETURN D_RWS.E_IsRoute2Distribute(_Route, L_DatTim.MonthEnd(D));
 END {E_IsRoute2Distribute};

 PUBLIC PROCEDURE TPD01_FullOrdTim(otp: tOrdTimPart): NUMERIC[3];
 BEGIN
  IF OCCURE(TPD01) THEN
   RETURN TPD01.OrdTim[otp] + TPD01.dstOTm[otp];
  ELSE
   RETURN 0;
  END;
 END {TPD01_FullOrdTim};

 PRIVATE PROCEDURE XYZ(D: DATE; fctRoute, curRoute: LIKE(Route.Route)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=1;
  IF L_General.GetAPSiteNumber() = 21 THEN
   IF D >= 01\03\2012 THEN
    SAVE(TKind);
    SAVE(Route);
    SEARCH(Route, Route, , curRoute);
    L_Way.StandOnRouteTKind(D);
    IF (fctRoute = "191") | (fctRoute = "291") THEN
     Result:=(TKind.FnMode = L_Way.tkfnm_Subsidy) & ((TKind.Rgn = L_Way.tkrgn_City) | (TKind.Rgn = L_Way.tkrgn_Suburb));
    ELSIF (fctRoute = "198") THEN
     Result:=(TKind.FnMode = L_Way.tkfnm_Commerce) & (TKind.Rgn = L_Way.tkrgn_Intercity);
    END;
    RESTORE(Route);
    RESTORE(TKind);
   END;
  END;
  RETURN Result;
 END {XYZ};

 PRIVATE PROCEDURE IncArr(VAR a1: FLOAT[]; a2: FLOAT[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  IF HIGH(a1) = HIGH(a2) THEN
   i:=0;
   WHILE i <= HIGH(a1) DO
    INC(a1[i], a2[i]);
    INC(i);
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {IncArr};

 PRIVATE PROCEDURE Create_TPD01();
  VAR
   Version: SCAL[1E3];
 BEGIN
  IF ~!DATABASE.Get().Tables("TPD01") THEN
   RETURN;
  END;
  Version:=000;
  CreateFILE(TPD01, "", "᪨  c ।", "");

  CreateFIELD(TPD01, MyFirm,    LIKE(MyFirm.MyFirm), "", "", "", "", "");
  CreateFIELD(TPD01, BoxNbr,    LIKE(Car.BoxNbr),    "", "", "", "", "");
  CreateFIELD(TPD01, clDate,    LIKE(CarLog.Date),   "", "", "", "", "");
  CreateFIELD(TPD01, Mark,      LIKE(Mark.Mark),     "", "", "", "", "");
  CreateFIELD(TPD01, Route,     LIKE(Route.Route),   "", "", "", "", "");
  CreateFIELD(TPD01, IsRlRt,    SCAL[2],             "", "", "", "", "");
  CreateFIELD(TPD01, TP002,     NUMERIC[0],          "", "", "", "", "");
  CreateFIELD(TPD01, OrdTim,    NUMERIC[3][4],       "", "", "", "", "");
  CreateFIELD(TPD01, dstOTm,    NUMERIC[3][4],       "", "", "", "", "");

  CreateINDEX(TPD01, TP002, UNIQUE, "", "", TP002);
  CreateINDEX(TPD01, ToDst, PLURAL, "", "", IsRlRt, MyFirm, Mark, Route);
  CreateINDEX(TPD01, ToIdx, PLURAL, "", "", BoxNbr, clDate, Route);

  SetVersionOfFILE(TPD01, Version);
 END {Create_TPD01};

 PRIVATE PROCEDURE Distribute(PerE: DATE);
  VAR
   maxValue,
   Total         : NUMERIC[3];
   curDst,
   ToDst,
   ToDstDone     : tOrdTimPartArray;
   maxTP002      : NUMERIC[0];
   otp           : tOrdTimPart;
   curMyFirm     : LIKE(MyFirm.MyFirm);
   curMark       : LIKE(Mark.Mark);
   fctRoute      : LIKE(Route.Route);
 BEGIN
  APP.Get().NewPrompt("।");
  SELECT(TP002, BoxNbr);
  WHILE OCCURE(TP002) DO
   PROMPT("⮢.  " + TP002.BoxNbr);
   IF L_Env.RealBoxNbr(TP002.BoxNbr) THEN
    CONFORM(TP002, WJMode);
    otp:=E_GetOrdTimPart();
    IF ~!otp & (TP002.OrdTim # 0) THEN
     IF ~SELECT(TPD01, ToIdx, TP002.BoxNbr, TP002.clDate, TP002.Route) THEN
      TPD01.BoxNbr:=TP002.BoxNbr;
      TPD01.clDate:=TP002.clDate;
      TPD01.Route :=TP002.Route;
      TPD01.TP002 :=TP002.TP002;
      TPD01.MyFirm:=L_Car.GetCarMyFirm(TP002.BoxNbr, TP002.clDate);
      L_Car.AccessMark(TP002.BoxNbr, TP002.clDate);
      TPD01.Mark  :=Mark.Mark;
      TPD01.IsRlRt:=E_IsRoute2Distribute(TP002.Route, PerE);
      SETZERO(TPD01.OrdTim, TPD01.dstOTm);
      INSERT(TPD01);
     END;
     INC(TPD01.OrdTim[otp_Whl], TP002.OrdTim);
     INC(TPD01.OrdTim[otp],     TP002.OrdTim);
     REPLACE(TPD01);
    END;
   END;
   NEXT(TP002);
  END; (* WHILE OCCURE(TP002) ... *)

  SELECT(TPD01, ToDst, , 0);
  WHILE OCCURE(TPD01) DO
   PROMPT("ઠ " + TPD01.Mark + ",  " + TPD01.Route);
   SETZERO(Total, ToDst, ToDstDone);
   curMyFirm:=TPD01.MyFirm;
   curMark  :=TPD01.Mark;
   fctRoute :=TPD01.Route;
   NARROWSEL(TPD01, MyFirm, Mark, Route);
   WHILE OCCURE(TPD01) DO
    IncArr(ToDst, TPD01.OrdTim);
    NEXT(TPD01);
   END;

   SAVE(TPD01);
   SELECT(TPD01, ToDst, , 1, curMyFirm, curMark);
   WHILE OCCURE(TPD01) DO
    IF XYZ(PerE, fctRoute, TPD01.Route) THEN
     INC(Total, TPD01.OrdTim[otp_Whl]);
    END;
    NEXT(TPD01);
   END;
   FIRST(TPD01);
   SETEMPTY(maxTP002);
   SETZERO(maxValue);
   WHILE OCCURE(TPD01) DO
    IF XYZ(PerE, fctRoute, TPD01.Route) THEN
     curDst[otp_Whl]:=ToDst[otp_Whl] * TPD01.OrdTim[otp_Whl]/Total;
     curDst[otp_WIM]:=ToDst[otp_WIM] * TPD01.OrdTim[otp_Whl]/Total;
     curDst[otp_Otg]:=ToDst[otp_Otg] * TPD01.OrdTim[otp_Whl]/Total;
     curDst[otp_Rsv]:=ToDst[otp_Rsv] * TPD01.OrdTim[otp_Whl]/Total;
     IncArr(ToDstDone,    curDst);
     IncArr(TPD01.dstOTm, curDst);
     REPLACE(TPD01);
     IF TPD01.OrdTim[otp_Whl] > maxValue THEN
      maxValue:=TPD01.OrdTim[otp_Whl];
      maxTP002:=TPD01.TP002;
     END;
    END;
    NEXT(TPD01);
   END; (* WHILE OCCURE(TPD01) *)
   RESTORE(TPD01);

   IF ~!maxTP002 THEN
    SAVE(TPD01);
    FIRST(TPD01);
    WHILE OCCURE(TPD01) DO
     SETZERO(TPD01.OrdTim);
     REPLACE(TPD01);
     NEXT(TPD01);
    END; (* WHILE OCCURE(TPD01) *)
    FOR_EACH otp DO
     IF ToDstDone[otp] # ToDst[otp] THEN
      ADD(TPD01, TP002, , maxTP002,
          TPD01.dstOTm[otp], ToDst[otp]-ToDstDone[otp]);
     END;
    END; (* FOR_EACH otp ... *)
    RESTORE(TPD01);
   END; (* IF ~!maxTP002 *)
   NEXTINEXTENDEDSEL(TPD01, MyFirm, Mark, Route);
  END; (* WHILE OCCURE(TPD01) ... *)
 END {Distribute};

 PUBLIC PROCEDURE extPrepareTP002(PerB, PerE: DATE; Silent: SCAL[2]);
  VAR
   D: DATE;
 BEGIN
  IF L_AFM.inRegistering()THEN
   L_Way.CheckTaxed(PerB, PerE);
   L_APWI.CheckDoneTckRcs(PerB, PerE);
   Create_TP002(PerE);
   Create_TPD01();
   L_AFM.msrf_Register("TP002", "TP002", L_General.timeCond_InIntvl, PerB, PerE);
  END;
  IF L_AFM.inAttaching() THEN
   L_AFM.msrf_Register("TPD01", "TPD01", L_General.timeCond_InIntvl, PerB, PerE);
   IF ~(L_AFM.msrf_Reuse("TP002", Silent) & L_AFM.msrf_Reuse("TPD01", 1)) THEN
    APP.Get().NewPrompt(L_AFM.rf_PreparePromptStr("TP002"));
    L_General.SetCacheables(["Car", "CarLog", "MarkPro", "RoutePro", "SEJobs"]);
    L_AFM.msrf_Create("TP002");
    L_AFM.msrf_Create("TPD01");
    SELECT(Car, BoxNbr);
    WHILE OCCURE(Car) DO
     D:=PerB;
     WHILE D <= PerE DO
      TP002_GatherOneDate(Car.BoxNbr, D);
      INC(D);
     END;
     NEXT(Car);
    END; (* WHILE OCCURE(Car) ... *)
    Distribute(PerE);
    L_AFM.msrf_Store("TP002");
    L_AFM.msrf_Store("TPD01");
   END; (* IF ~(L_AFM.msrf_Reuse ... *)
  END;
 END {extPrepareTP002};

 PUBLIC PROCEDURE TP002_TotalVldPsg(): NUMERIC[0];
  VAR
   idx   : L_Way.tVldPsgKind;
   Result: NUMERIC[0];
 BEGIN
  SETZERO(idx, Result);
  FOR_EACH idx DO
   Result:=Result + TP002.VldPsg[idx];
  END; (* FOR_EACH *)
  RETURN Result;
 END {TP002_TotalVldPsg};

 PUBLIC PROCEDURE PrepareTP002();
 BEGIN
  extPrepareTP002(Memo.ud_fr(), Memo.ud_ut(), 0);
 END {PrepareTP002};

 PUBLIC PROCEDURE PurgeTP002();
 BEGIN
  L_AFM.AF_PurgeTemp("TP002");
 END {PurgeTP002};

 PRIVATE PROCEDURE Create_SEJ01(_D: DATE);
  VAR
   MainIdx: STRING[];
 BEGIN
  IF ~!DATABASE.Get().Tables("SEJ01") THEN
   RETURN;
  END;
  wASCP      :=L_Way.E_ASCPLev(_D);
  wVldPsgPlan:=L_Way.E_VldPsgPlanLev(_D);

  CreateFILE(SEJ01, "", " ", "");

  CreateFIELD(SEJ01, MyFirm,     P_Firm.tMyFirm,      "", "",  "", " ࣠", "");
  CreateFIELD(SEJ01, Route,      LIKE(Route.Route),   "", "", "", "", "");
  CreateFIELD(SEJ01, Exit,       LIKE(StExit.Exit),   "", "", "", "室", "");
  CreateFIELD(SEJ01, WDWay,      SCAL[8],             "", "", "", " ", "");
  CreateFIELD(SEJ01, ExitDate,   DATE,                "", "", "", " 砫 ⢨ 室", " 1 ࠧ   ");
  CreateFIELD(SEJ01, withGu,     SCAL[2],             "", "", "", " ஬", "");
  CreateFIELD(SEJ01, PasVol,     SCAL[1E2],           "", "", "", "⨬", "");
  CreateFIELD(SEJ01, Column,     LIKE(CarLog.Column), "", "", "", "", "");
  CreateFIELD(SEJ01, IncPlan,    NUMERIC[16, 3],      "", "", "", "  室", "");
  CreateFIELD(SEJ01, TotTim,     NUMERIC[12, 3],      "", "", "", "饥 ६", "");
  CreateFIELD(SEJ01, WrkTim,     NUMERIC[12, 3],      "", "", "", "६ c ந. ஡", "");
  CreateFIELD(SEJ01, ZerTim,     NUMERIC[12, 3],      "", "", "", "६ . ३ᮢ", "");
  CreateFIELD(SEJ01, IncTim,     NUMERIC[12, 3],      "", "", "", "६  室", "");
  CreateFIELD(SEJ01, TotRun,     NUMERIC[16, 2],      "", "", "", "騩 ஡", "");
  CreateFIELD(SEJ01, WrkRun,     NUMERIC[16, 2],      "", "", "", "ந. ஡", "");
  CreateFIELD(SEJ01, ZerRun,     NUMERIC[16, 2],      "", "", "", "㫥 ஡", "");
  CreateFIELD(SEJ01, TotTrp,     NUMERIC[10, 1],      "", "", "", "ᥣ ३ᮢ", "");
  CreateFIELD(SEJ01, WrkTrp,     NUMERIC[10, 1],      "", "", "", "ந. ३ᮢ", "");
  CreateFIELD(SEJ01, ZerTrp,     NUMERIC[10, 1],      "", "", "", "㫥 ३ᮢ", "");
  CreateFIELD(SEJ01, LinTim,     NUMERIC[12, 3],      "", "", "", "६ ", "");
  CreateFIELD(SEJ01, PVKm,       NUMERIC[12, 2],      "", "", "", "-", "");
  CreateFIELD(SEJ01, ChngCnt,    NUMERIC[10, 4],      "", "", "", "", "");
  CreateFIELD(SEJ01, CarDay,     NUMERIC[10, 3],      "", "", "", "設", "");
  CreateFIELD(SEJ01, OrdTim,     NUMERIC[12, 3],      "", "", "", "६  拉", "");
  CreateFIELD(SEJ01, VldPsgPlan, L_APWI.tVldPsgAmnt, "", "", "", "  죮 ᠦࠬ", "");

  MainIdx:='Route, Exit, WDWay, ExitDate, withGu, PasVol, Column';
  IF wASCP THEN
   CreateFIELD(SEJ01, ASCP,     SCAL[2],      "", "", "", "稥 ", "");
   MainIdx:=MainIdx + ", ASCP";
  END;
  IF wTimeIntvl THEN
   CreateFIELD(SEJ01, TimeItvl, tTimeIntvl,   "", "", "", "ࢠ ६", "");
   MainIdx:=MainIdx + ", TimeItvl";
  END;
  MainIdx:=MainIdx + ", MyFirm";

  CreateINDEXandLINK(SEJ01, Route, UNIQUE, Route,  Route, USER, "", "", ^MainIdx);
  CreateINDEXandLINK(SEJ01, Exit,  PLURAL, StExit, Exit,  USER, "", "", Exit);

  SetVersionOfFILE(SEJ01, 1000 * wASCP + 009);
 END {Create_SEJ01};

 PRIVATE PROCEDURE ActiveExitIP(D: DATE; trgCnd: L_Way.tIncPlanCondition): SCAL[2];
 BEGIN
  CONFORM(SEJobs, StExit);
  RETURN L_Way.AccessCurExitIP(D, trgCnd) &
         (ExitIP.Type # L_Way.ipt_OnRoute) & (ExitIP.Type # L_Way.ipt_Canceled);
 END {ActiveExitIP};

 PRIVATE PROCEDURE StandOnSuitableCar(_Route: LIKE(Route.Route); D: DATE; _PV: NUMERIC[0]);
  VAR
   Text: STRING[];
 BEGIN
  IF (_PV = 0) | ~L_Way.SetCarForIncPlan(Calendar.Date, _PV) THEN
   IF (ActiveExitIP(D, L_Way.ipc_Driver) |
       ActiveExitIP(D, L_Way.ipc_Guard)) &
       SELECT(ExitIPL, Exit, ExitIP.Exit, ExitIP.Date, ExitIP.Cnd) THEN
    _PV:=ExitIPL.TemplPV;
   ELSIF SELECT(RouteIP, Route, _Route) &
         SRCINSEL(RouteIP, LE, D) &
         SELECT(RouteIPL, Route, RouteIP.Route, RouteIP.Date, RouteIP.RoutCnd) THEN
    _PV:=RouteIPL.TemplPV;
   END;
  END;
  IF L_Way.E_CalcPlIncBySittingPV(D) THEN
   _PV:=L_Way.E_DefinePasVolSit(D, _PV);
   Text:="⨬  ᨤ "+L_Str.IntStr(_PV);
  ELSE
   _PV:=L_Way.E_DefinePasVol(D, _PV);
   Text:="⨬ "+L_Str.IntStr(_PV);
  END;
  L_General.Assert(L_Way.SetCarForIncPlan(Calendar.Date, _PV),
                   "  室 ઠ    室| 室 "+SEJobs.Exit+" "+Text);
 END {StandOnSuitableCar};

 PUBLIC PROCEDURE E_GetOrdTimPart(): tOrdTimPart;
 BEGIN
  IF    (WJMode.WJType = L_Way.WJType_Work) & (WJMode.RunSel # L_Way.runsel_None) THEN
   RETURN otp_WIM;
  ELSIF (WJMode.WJType = L_Way.WJType_Work) & (WJMode.RunSel = L_Way.runsel_None) THEN
   RETURN otp_Rsv;
  ELSIF (WJMode.WJType = L_Way.WJType_Stand) THEN
   RETURN otp_Otg;
  ELSE
   RETURN EMPTYOF(tOrdTimPart);
  END;
 END {E_GetOrdTimPart};

 PUBLIC PROCEDURE E_GetOrdTim(_Tim: NUMERIC[3]; otp: tOrdTimPart): NUMERIC[3];
  VAR
   _otp: tOrdTimPart;
 BEGIN
  _otp:=E_GetOrdTimPart();
  IF (_otp = otp) | (~!_otp & (otp = otp_Whl)) THEN
   RETURN _Tim;
  ELSE
   RETURN 0;
  END;
 END {E_GetOrdTim};

 PRIVATE PROCEDURE GatherExitOnOneWeekDay(Full      : SCAL[2];
                                          WD        : L_DatTim.tWeekday;
                                          _PVKm,
                                          _PV       : NUMERIC[0];
                                          _PasVolGrp: SCAL[100];
                                          CarAmount : NUMERIC[0];
                                          _EColumn  : SCAL[100];
                                          Amount    : NUMERIC[0];
                                          FillExitD : SCAL[2];
                                          _MyFirm   : P_Firm.tMyFirm);
  VAR
   CurTime,
   _WrkTim,
   _ZerTim,
   _LinTim,
   _IncTim    : NUMERIC[3];
   _WrkRun,
   _ZerRun    : NUMERIC[2];
   _IncPln    : L_APWI.tPlanIncome;
   _VldPsgPlan: L_APWI.tVldPsgAmnt;
   wGu        : SCAL[2];
   curIPCndVld,
   curIPCnd   : L_Way.tIncPlanCondition;
   _Route     : LIKE(Route.Route);
   _ChngCnt   : NUMERIC[4];
   IndexStr,
   PasVolNorm : STRING[];
   AccessCurExitIP,
   FirstMsgForIncPln,
   First      : SCAL[2];
   ExitDate   : DATE;
   Cnt,
   Rest       : NUMERIC[0];
 BEGIN
  First:=1; FirstMsgForIncPln:=geoowd_ShowMsgForIncPln;
  SETEMPTY(_Route);
  IF Full THEN
   AccessCurExitIP:=L_Way.AccessCurExitIP(Calendar.Date, L_Way.ipc_Total);
  END;
  SELECT(SEJobs, Exit, , StExit.Exit);
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, Route, RoutMod, WJMode);
   SETZERO(_IncPln, _VldPsgPlan, _WrkTim, _ZerTim, _IncTim,  _WrkRun, _ZerRun, _LinTim);
   wGu:=(StExit.GuNeed = L_Way.egn_Required) & L_Way.SEJobsWithGu();
   IF WJMode.WJType # L_Way.WJType_Void THEN
    CurTime:=SEJobs.StopT - SEJobs.StartT;
   ELSE
    CurTime:=0;
   END;
   IF Full THEN
    IF (_Route # SEJobs.Route) & Route.IncSel THEN
     StandOnSuitableCar(SEJobs.Route, Calendar.Date, _PV);
     _Route:=SEJobs.Route;
    END;
    IF AccessCurExitIP THEN
     curIPCnd:=L_Way.ipc_Total;
    ELSIF wGu THEN
     curIPCnd:=L_Way.ipc_Guard;
    ELSE
     curIPCnd:=L_Way.ipc_Driver;
    END;
    TRY
     IF L_Way.SEJobsWithPlIncome(Calendar.Date) THEN
      _IncPln:=L_APWI.E_GetPlanIncomeScope(L_APWI.piScope_SEJobs, Calendar.Date, curIPCnd);
      IF wVldPsgPlan THEN
       curIPCndVld:=L_APWI.ConvWithGu_to_IPCForVldPsg(wGu);
       _VldPsgPlan:=L_APWI.E_GetPlanIncomeScope(L_APWI.piScope_SEJobs, Calendar.Date, curIPCndVld);
      END;
     END;
    EXCEPT
    ON Exc: Exc_Root DO
     IF FirstMsgForIncPln THEN
      L_StdFrm.Choice("   室: "+StExit.Exit+"|" + Exc.MsgOriginalText);
      FirstMsgForIncPln:=0;
     END;
    END; (* TRY *)
   END; (* IF Full ... *)
   IF    WJMode.RunSel = L_Way.runsel_Zero THEN
    _ZerTim:=CurTime;
    _ZerRun:=RoutMod.Run;
   ELSIF WJMode.RunSel = L_Way.runsel_Work THEN
    _WrkTim:=CurTime;
    _WrkRun:=RoutMod.Run;
   END;
   IF L_Way.SEJobsWithPlIncome(Calendar.Date) THEN
    _IncTim :=CurTime;
   END; (* IF WJMode ... *)
   IF WJMode.WJType = L_Way.WJType_Work THEN
    _LinTim:=CurTime;
   END; (* IF WJMode ... *)
   IF L_Way.SEJobsWithPlIncome(Calendar.Date) &
      (WJMode.RunSel = L_Way.runsel_Work) & (StExit.TripAm > 0) THEN
    _ChngCnt:=1/StExit.TripAm;
   ELSE
    _ChngCnt:=0;
   END;

   IndexStr:='SEJobs.Route, SEJobs.Exit, WD, ExitDate, wGu, _PasVolGrp, _EColumn';
   IF wASCP THEN
    IF Full THEN
     IndexStr:=IndexStr+", "+L_Str.IntStr(L_Way.TripWithASCP(Calendar.Date, SEJobs.Route, SEJobs.Exit));
    ELSE
     IndexStr:=IndexStr+", ''";
    END;
   END;
   IF wTimeIntvl THEN
    IndexStr:=IndexStr+", '"+GetTimeIntvl(SEJobs.Day, SEJobs.StartT)+"'";
   END;
   IndexStr:=IndexStr + ", _MyFirm";

   Rest:=Amount;
   WHILE Rest > 0 DO
    IF FillExitD & (Rest = Amount) THEN
     ExitDate:=Calendar.Date;
     Cnt:=1;
    ELSE
     SETEMPTY(ExitDate);
     Cnt:=Rest;
    END;
    ADD(SEJ01, Route, , ^IndexStr,
          SEJ01.TotTim,     Cnt * CurTime * CarAmount,
          SEJ01.WrkTim,     Cnt * _WrkTim * CarAmount,
          SEJ01.ZerTim,     Cnt * _ZerTim * CarAmount,
          SEJ01.LinTim,     Cnt * _LinTim * CarAmount,
          SEJ01.IncTim,     Cnt * _IncTim * CarAmount,
          SEJ01.TotRun,     Cnt * RoutMod.Run * CarAmount,
          SEJ01.WrkRun,     Cnt * _WrkRun * CarAmount,
          SEJ01.ZerRun,     Cnt * _ZerRun * CarAmount,
          SEJ01.TotTrp,     Cnt * (WJMode.RunSel > L_Way.runsel_None),
          SEJ01.WrkTrp,     Cnt * (WJMode.RunSel = L_Way.runsel_Work),
          SEJ01.ZerTrp,     Cnt * (WJMode.RunSel = L_Way.runsel_Zero),
          SEJ01.PVKm,       Cnt * RoutMod.Run * _PVKm * CarAmount,
          SEJ01.ChngCnt,    Cnt * _ChngCnt,
          SEJ01.CarDay,     Cnt * (First & ExitForOut(Calendar.Date)),
          SEJ01.OrdTim,     Cnt * E_GetOrdTim(CurTime*CarAmount, otp_Whl),
          SEJ01.IncPlan,    Cnt * _IncPln,
          SEJ01.VldPsgPlan, Cnt * _VldPsgPlan);
    DEC(Rest, Cnt);
   END;
   First:=0;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
 END {GatherExitOnOneWeekDay};

 PRIVATE PROCEDURE SEJ01_Gather(_From, _UpTo: DATE; Full: SCAL[2]);
  VAR
   _PasVolGrp: SCAL[100];
   _EColumn  : SCAL[100];
   _PVKm,
   _PV       : NUMERIC[0];
   CarAmount : NUMERIC[0];
   NPV       : NUMERIC[3][10];
   IndexStr  : STRING[];
   WDAmount  : NUMERIC[0][8];
   WD        : L_DatTim.tWeekday;
   wMF       : SCAL[2];
   _MyFirm   : P_Firm.tMyFirm;
   dummy     : NUMERIC[1];
   FirstDateInPer: DATE[L_DatTim.wd_DaysAmount];
 BEGIN
  APP.Get().NewPrompt(TABLE.Get("SEJ01").Description);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  SETEMPTY(NPV);
  IF L_APtm.IsMGT() THEN
   P_OwnData.Decode_PasVolNorm(P_OwnData.GetOwnDProSoft(_UpTo, P_OwnData.P_PasVolNorm),
                               NPV[L_Way.pve_Big],
                               NPV[L_Way.pve_VeryBig],
                               dummy,
                               dummy,
                               NPV[L_Way.pve_Small],
                               dummy,
                               NPV[L_Way.pve_Middle],
                               dummy);
  END;

  SELECT(StExit, Strict, , L_Way.ExitStrict_Reg);
  SRCINSEL(StExit, GT, , _From);
  WHILE OCCURE(StExit) DO
   PROMPT("室 " + StExit.Exit);
   IF L_DatTim.IsActiveInIntvl(_From, _UpTo+1, StExit.FromD, StExit.UpDate) THEN
    IF wMF THEN
     _MyFirm:=L_Way.GetMyFirmOfExit(StExit.Exit, _UpTo);
    ELSE
     _MyFirm:=P_Firm.mf_Own;
    END;
    _PV       :=Math.Max(StExit.MinPV, StExit.MaxPV);
    _PasVolGrp:=L_Way.intPasVolValue2Enum(_PV);
    CarAmount :=1;
    IF L_APtm.IsTramDepo() & (_PasVolGrp>=L_Way.pve_VeryBig) THEN
     CarAmount:=2;
    END;
    IF _PV # 0 THEN
     L_General.Assert(~!StExit.MinPV & ~!StExit.MaxPV, "室 "+StExit.Exit+"|   .  . ⨬  室|᫨ ⨬  ,  . 0, . ");
     IF (StExit.MinPV # 0) THEN
      _PV:=(StExit.MinPV+StExit.MaxPV)/2;
     END;
    END;
    _PVKm:=_PV;
    IF (_PVKm # 0) & ~!NPV[_PasVolGrp] THEN
     _PVKm:=NPV[_PasVolGrp];
    END;

    SAVE(StExit);
    SETZERO(WDAmount); SETEMPTY(FirstDateInPer);
    SELECT(Calendar, Date);
    SRCINSEL(Calendar, GE, , _From);
    WHILE OCCURE(Calendar) & (Calendar.Date <= _UpTo) DO
     IF L_Way.CurExitActiveOnCurClndDate() THEN
      WD:=L_Way.E_ConvertWD(Calendar.Date, Calendar.WDWay);
      IF Full THEN
       PROMPT("室 " + StExit.Exit + " : " + L_DatTim.DateStr(Calendar.Date));
       GatherExitOnOneWeekDay(Full, WD, _PVKm, _PV, _PasVolGrp, CarAmount, GetColumnByStExit(Calendar.Date),
                              1, WDAmount[WD] = 0, _MyFirm);
      END;
      INC(WDAmount[WD]);
      IF !FirstDateInPer[WD] THEN  (*  窨 㦥 WDInc. ⠥,  WDWay=WDInc*)
       FirstDateInPer[WD]:=Calendar.Date;
      END;
     END;
     NEXT(Calendar);
    END;
    IF ~Full THEN
     _EColumn:=GetColumnByStExit(_UpTo);
     FOR_EACH WD DO
      IF WDAmount[WD] > 0 THEN
       PROMPT("室 " + StExit.Exit + " : " + WD);
       L_General.Assert(SEARCH(Calendar, Date, FirstDateInPer[WD]), L_DatTim.DateStr(FirstDateInPer[WD])+"   ");
       GatherExitOnOneWeekDay(Full, WD, _PVKm, _PV, _PasVolGrp, CarAmount, _EColumn, WDAmount[WD], 1, _MyFirm);
      END;
     END;
    END;
    RESTORE(StExit);
   END; (* IF (StExit.Strict... *)
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit)... *)
 END {SEJ01_Gather};

 PUBLIC PROCEDURE extPrepareSEJ01(PerB, PerE: DATE; ForceRebuild, Full, Silent, wMsgForIncPln: SCAL[2]);
 BEGIN
  geoowd_ShowMsgForIncPln:=wMsgForIncPln;
  Create_SEJ01(PerE);
  IF Full THEN
   L_AFM.NewReusableFile("SEJ01", "SEJ01", L_General.timeCond_InIntvl, PerB, PerE);
   IF ForceRebuild | ~L_AFM.CanReuseFile("SEJ01", Silent) THEN
    APP.Get().NewPrompt(L_AFM.rf_PreparePromptStr("SEJ01"));
    L_AFM.CreateReusableFile("SEJ01");
    SEJ01_Gather(PerB, PerE, Full);
    L_AFM.ReAttachReusableFile("SEJ01");
   END;(* IF ~CanReuseFile ... *)
  ELSE
   L_AFM.AF_CreateTemp("SEJ01", "SEJ01");
   SEJ01_Gather(PerB, PerE, Full);
  END;
 END {extPrepareSEJ01};

 PUBLIC PROCEDURE _PrepareSEJ01(PerB, PerE: DATE; ForceRebuild, Full: SCAL[2]);
 BEGIN
  extPrepareSEJ01(PerB, PerE, ForceRebuild, Full, 0, 1);
 END {_PrepareSEJ01};

 PUBLIC PROCEDURE PrepareSEJ01();
 BEGIN
  _PrepareSEJ01(Memo.ud_fr(), Memo.ud_ut(), 0, 1);
 END {PrepareSEJ01};

 PUBLIC PROCEDURE PurgeSEJ01();
 BEGIN
  L_AFM.AF_PurgeTemp("SEJ01");
 END {PurgeSEJ01};

BEGIN
 wTimeIntvl:=0;
END.
