(*
%Copyright   (c) Polak IT
%Author      20.07.2007 10:15:22 POLAK\GAV
%Purpose     ஭ 
%Type        operation
%Specific    AP
%Modified    24.12.2013 16:34:48 POLAK\GAV
%Environment
*)

 MODULE ElTck [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_WDO, L_Events, L_General, L_Basis, L_DatTim, FIO, Memo, L_Str,
        L_TRS, L_AFM, L_OwnData, L_StdFrm, L_Way, L_Car, Math, L_bp;

 CONST
  ett_Pool = "???" +
             "|  த  " +
             "|???" +
             "|  த  ᠫ" +
             "|஥ த" +
             "|஥ 饣 த" +
             "|஥ ਣத" +
             "|஥ 饣 ਣத" +
             "|஥ 誮쭨 ᥫ᪮ ⭮" +
             "| 樠 ஥ " +
             "|???" +
             "|࠭ᯮ⭠  㤭  " +
             "|஭ 襫" +
             "|  ()" +
             "| ⥫" +
             "| 室" +
             "| " +
             "| ஫" +
             "| " +
             "| 孨" +
             "|室   ⥫" +
             "|室   ⥫" +
             "|樠쭠  " +
             "|樠쭠  " +
             "|६  樠  " +
             "|६  樠  " +
             "| ६ ⢨ " +
             "|  " +
             "|樠쭠  ()";

 PRIVATE PROCEDURE ElTck_1_OnZoneOpen();
 BEGIN
  L_WDO.z_SetFieldFormat(0, "ElTckTStr", ett_Pool);
 END {ElTck_1_OnZoneOpen};

 PRIVATE PROCEDURE ElTckIsImported(fr, ut: DATE): SCAL[2];
  VAR
   D: DATE;
 BEGIN
  D:=fr;
  WHILE D <= ut DO
   IF ~SELECT(ElTck, Date, D) THEN
    RETURN 0;
   END;
   INC(D);
  END;
  RETURN 1;
 END {ElTckIsImported};

 PRIVATE PROCEDURE HasNotDistributedElTck(fr, ut: DATE): SCAL[2];
 BEGIN
  RETURN SELECT(ElTck, TckRcS, EMPTYOF(ElTck.TckRcS)) & SRCINSEL(ElTck, GE, fr) & (ElTck.Date <= ut);
 END {HasNotDistributedElTck};

 PRIVATE PROCEDURE ElT01_Top(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "䨪");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室६");
  L_Basis.wb_WrInQM(F, "室⠭");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室६");
  L_Basis.wb_WrInQM(F, "室⠭");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_TermLine(F);
 END {ElT01_Top};

 PRIVATE PROCEDURE ElT01_Line(F: STRING[]);
 BEGIN
  L_Basis.wb_WrDat(F, ElTck.Date);
  L_Basis.wb_WrScl(F, ElTck.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, ElTck.Route);
  L_Basis.wb_WrScl(F, ElTck.Schedule);
  L_Basis.wb_WrScl(F, ElTck.Change);
  L_Basis.wb_WrScl(F, ElTck.VldId);
  L_Basis.wb_WrStr(F, ElTck.ElTckId);
  L_Basis.wb_WrScl(F, ElTck.ElTckNum);
  L_Basis.wb_WrScl(F, ElTck.ElTckT);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(ett_Pool, ElTck.ElTckT));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("檠 |檠 |稥 樠|",
                                     L_TRS.VldPsgKindOfTckKind(L_TRS.TckKindOfVldCardType(ElTck.ElTckT))));
  L_Basis.wb_WrDat(F, ElTck.DateIn);
  L_Basis.wb_WrLongTim(F, ElTck.TimeIn, ElTck.SecIn);
  L_Basis.wb_WrScl(F, ElTck.StopNIn);
  L_Basis.wb_WrDat(F, ElTck.DateOut);
  L_Basis.wb_WrLongTim(F, ElTck.TimeOut, ElTck.SecOut);
  L_Basis.wb_WrScl(F, ElTck.StopNOut);
  L_Basis.wb_WrNum(F, ElTck.Price, 2);
  L_Basis.wb_TermLine(F);
 END {ElT01_Line};

 PUBLIC PROCEDURE ElT01_Make();
  CONST
   RepName = "ElT01";
  VAR
   D: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(RepName, "  ஭ ⠬  ਮ", L_bp.t_Basis, L_General.tc_inIntvl);
  IF ~ElTckIsImported(Memo.ud_fr(), Memo.ud_ut()) THEN
   L_StdFrm.Confirm("    ਮ ஢ .  㤥 .");
  END;
  FIO.Open(F, L_General.NameConnection(RepName), "REP", Create);
  ElT01_Top("F");
  D:=Memo.ud_fr();
  WHILE D <= Memo.ud_ut() DO
   SELECT(ElTck, Date, , D);
   WHILE OCCURE(ElTck) DO
    CONFORM(ElTck, Staff);
    CONFORM(Staff, Man);
    PROMPT(L_DatTim.DateStr(ElTck.Date) + " " + ElTck.TSN);
    NARROWSEL(ElTck, TSN);
    WHILE OCCURE(ElTck) DO
     ElT01_Line("F");
     NEXT(ElTck);
    END; (* WHILE OCCURE(ElTck) ... *)
    NEXTINEXTENDEDSEL(ElTck, TSN);
   END; (* WHILE OCCURE(ElTck) ... *)
   INC(D);
  END;
  FIO.Close(F);
  L_bp.End();
 END {ElT01_Make};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
######################################################## ########## #####
=#####===================================================================
|        ஭   ਮ  ##########  ##########         |
|-----------------------------------------------------------------------|
| ஭                     |  ⢮|           㬬|
}
*)

(*
$P{ Dlm:
@
|-----------------------------------------|------------|----------------|
}
*)

(*
$P{ SubTop:
?, L, ""
@
|=======================================================================|
|##################################                                     |
|-----------------------------------------------------------------------|
}
*)

(*
$P{ Line:
?, L, ""
?, R, ""
?, R, "2-"
@
|#########################################|############|################|
}
*)

(*
$P{ Bot:
@
=(c) Polak===============================================================
}
*)

 PUBLIC PROCEDURE ElT02_Make();
  CONST
   RepName = "ElT02";
  VAR
   Amount: NUMERIC[0];
   Sum   : NUMERIC[2];
   ByPer : SCAL[2];
   D     : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(RepName, "஭ ", L_bp.t_Report, L_General.tc_inIntvl);
  ByPer:=Memo.ud_ut() > Memo.ud_fr();
  L_AFM.MakeMultipleIndex("tmp",
                          "Date: DATE; ElTckT: LIKE(ElTck.ElTckT); Amount: NUMERIC[0]; Sum: NUMERIC[2]",
                          "ElTckT: Date, ElTckT");
  IF ByPer THEN
   L_AFM.MakeMultipleIndex("tmpT",
                           "ElTckT: LIKE(ElTck.ElTckT); Amount: NUMERIC[0]; Sum: NUMERIC[2]",
                           "ElTckT: ElTckT");
  END;

  D:=Memo.ud_fr();
  WHILE D <= Memo.ud_ut() DO
   SELECT(ElTck, Date, , D);
   WHILE OCCURE(ElTck) DO
    PROMPT(ElTck.TSN);
    ADD(tmp, ElTckT, , D, ElTck.ElTckT, tmp.Amount, 1, tmp.Sum, ElTck.Price);
    NEXT(ElTck);
   END; (* WHILE OCCURE(ElTck) ... *)
   INC(D);
  END;

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  SELECT(tmp, ElTckT);
  WHILE OCCURE(tmp) DO
   NARROWSEL(tmp, Date);
   SETZERO(Amount, Sum);
   IF ByPer THEN
    MAKEPART(R, SubTop, L_DatTim.DateStr(tmp.Date));
   ELSE
    MAKEPART(R, Dlm);
   END;
   WHILE OCCURE(tmp) DO
    PROMPT(tmp.ElTckT);
    MAKEPART(R, Line, tmp.ElTckT + " " + L_Str.PoolItem(ett_Pool, tmp.ElTckT), tmp.Amount, tmp.Sum);
    INC(Amount, tmp.Amount);
    INC(Sum,    tmp.Sum);
    IF ByPer THEN
     ADD(tmpT, ElTckT, , tmp.ElTckT, tmpT.Amount, tmp.Amount, tmpT.Sum, tmp.Sum);
    END;
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
   MAKEPART(R, Dlm);
   MAKEPART(R, Line, "⮣", Amount, Sum);
   NEXTINEXTENDEDSEL(tmp, Date);
  END;
  L_AFM.AF_PurgeTemp("tmp");

  IF ByPer THEN
   SELECT(tmpT, ElTckT);
   SETZERO(Amount, Sum);
   MAKEPART(R, SubTop, "⮣  ਮ");
   WHILE OCCURE(tmpT) DO
    PROMPT(tmpT.ElTckT);
    MAKEPART(R, Line, tmpT.ElTckT + " " + L_Str.PoolItem(ett_Pool, tmpT.ElTckT), tmpT.Amount, tmpT.Sum);
    INC(Amount, tmpT.Amount);
    INC(Sum,    tmpT.Sum);
    NEXT(tmpT);
   END; (* WHILE OCCURE(tmp) ... *)
   MAKEPART(R, Dlm);
   MAKEPART(R, Line, "⮣", Amount, Sum);
   L_AFM.AF_PurgeTemp("tmpT");
  END;
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_bp.End();
 END {ElT02_Make};

 PRIVATE PROCEDURE GetElTckTimeIn(): FLOAT;
 BEGIN
  RETURN L_DatTim.GetVARIANTDATE(ElTck.DateIn, ElTck.TimeIn, ElTck.SecIn);
 END {GetElTckTimeIn};

 PRIVATE PROCEDURE ShiftElTckTime(Shift: FLOAT);
 BEGIN
  UnPkVARIANTDATE(GetElTckTimeIn() + Shift, ElTck.DateIn, ElTck.TimeIn, ElTck.SecIn);
  ElTck.DateOut:=ElTck.DateIn;
  ElTck.TimeOut:=ElTck.TimeIn;
  ElTck.SecOut :=ElTck.SecIn;
  ElTck.Date  :=ElTck.DateIn - (ElTck.TimeIn < 03:00);
  REPLACE(ElTck);
  CHANGESEL(ElTck, VldId, , ElTck.VldId);
 END {ShiftElTckTime};

 PUBLIC PROCEDURE MakeTimeShift();
  VAR
   frD,
   utD,
   stD  : DATE;
   frT,
   utT,
   stT  : TIME;
   frS,
   utS  : SCAL[60];
   Shift: FLOAT;
   _TSN : LIKE(ElTck.TSN);
 BEGIN
  L_General.Assert(ACCESS(ElTck), " ⠭ ⥪   '஭ '");
  L_General.Assert(!ElTck.TckRcS, " ६ ਬ ⮫쪮  ࠧᥭ ப");
  CHANGESEL(ElTck, VldId, , ElTck.VldId);
  SETEMPTY(stD, stT);
  frD:=ElTck.DateIn;
  frT:=ElTck.TimeIn;
  frS:=ElTck.SecIn;
  _TSN:=ElTck.TSN;
  WHILE NEXT(ElTck) & !ElTck.TckRcS & (_TSN = ElTck.TSN) DO
  END;
  IF ~OCCURE(ElTck) THEN
   LAST(ElTck);
  END;
  WHILE OCCURE(ElTck) & ~!ElTck.TckRcS DO
   PREV(ElTck);
  END;
  utD:=ElTck.DateIn;
  utT:=ElTck.TimeIn;
  utS:=ElTck.SecIn;
  STDFORM(L_StdFrm.sf_Choice( "%#################% %##########%             "+
                             "|"+
                             "|%#################% %##########% %#####% %##%"+
                             "|"+
                             "|%#################% %##########% %#####% %##%"+
                             "|"+
                             "|%#################% %##########% %#####% %##%",
                             "%<          >T" + "%L<>NI" +
                             "%< /६>T" + "%L<D.N.y>NI" + "%L<H:M>NI" + "%<>NI" +
                             "%<                 >T" + "%L<D.N.y>I" +  "%L<H:M>I" +  "%<>I" +
                             "%<த        >T" + "%L<D.N.y>I" +  "%L<H:M>I" +  "%<>I"),
          "  ६ ᪠஢ ", , 1,
          ElTck.VldId, frD, frT, frS, stD, stT, frS, utD, utT, utS);

  L_General.Assert(L_DatTim.GetVARIANTDATE(utD, utT, utS) <= GetElTckTimeIn(),
                   "  ");
  WHILE OCCURE(ElTck) & (L_DatTim.GetVARIANTDATE(utD, utT, utS) < GetElTckTimeIn()) DO
   PREV(ElTck);
  END;
  L_General.Assert(OCCURE(ElTck) & (L_DatTim.GetVARIANTDATE(frD, frT, frS) <= GetElTckTimeIn()),
                   " ᥩ  㪠 ");
  Shift:=L_DatTim.GetVARIANTDATE(stD, stT, 0) - L_DatTim.GetVARIANTDATE(frD, frT, 0);
  IF Shift = 0 THEN
   L_StdFrm.Inform(" ᤢ ???");
  ELSE
   WHILE OCCURE(ElTck) & (L_DatTim.GetVARIANTDATE(frD, frT, frS) <= GetElTckTimeIn()) DO
    PROMPT(L_DatTim.DateStr(ElTck.Date) + ", " + L_DatTim.TimeStr(ElTck.TimeIn) + " " + ElTck.TSN);
    IF PREV(ElTck) THEN
     SAVE(ElTck);
     NEXT(ElTck);
    ELSE
     SAVE(ElTck);
     FIRST(ElTck);
    END;
    ShiftElTckTime(Shift);
    RESTORE(ElTck);
   END;
  END;
 END {MakeTimeShift};

(*
$P{ br_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|   ஢   ⮬  ਮ  ##########  ##########   |
}
*)

(*
$P{ br_TSNTop:
Staff.TSN, L, ""
Man.Name, L, ""
@
|============================================================================|
|##### ################################################                      |
|----------------------------------------------------------------------------|
|      |   ..|      ᪢|   . |     |        ᥣ|
}
*)

(*
$P{ br_Dlm:
@
|----------|------------|------------|------------|------------|-------------|
}
*)

(*
$P{ br_Line:
?, L, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
@
|##########|############|############|############|############|#############|
}
*)

(*
$P{ br_Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE br_TRSRoute(): STRING[];
 BEGIN
  IF    !ElTck.TckRcS THEN
   RETURN "";
  ELSE
   SELECT(TckRcJ, TckRcS, , ElTck.TckRcS);
   IF ~SRCINSEL(TckRcJ, LE, ElTck.DateIn - TckRcJ.asDate + 1, ElTck.TimeIn) THEN
    FIRST(TckRcJ);
   END;
   RETURN TckRcJ.Route;
  END;
 END {br_TRSRoute};

 PRIVATE PROCEDURE br_MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "❁");
  L_Basis.wb_WrInQM(F, "⁓");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "砫ࢠ");
  L_Basis.wb_WrInQM(F, "砫ࢠ६");
  L_Basis.wb_WrInQM(F, "戭ࢠ६");
  L_Basis.wb_WrInQM(F, "죏1");
  L_Basis.wb_WrInQM(F, "죏2");
  L_Basis.wb_WrInQM(F, "죏");
  L_Basis.wb_WrInQM(F, "⏠");
  L_Basis.wb_WrInQM(F, "ᥣ");
  L_Basis.wb_TermLine(F);
 END {br_MakeTop};

 PRIVATE PROCEDURE br_MakeLine(F: STRING[]);
 BEGIN
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrDat(F, ETwBR.D);
  L_Basis.wb_WrStr(F, ETwBR.eRoute);
  L_Basis.wb_WrStr(F, ETwBR.tRoute);
  L_Basis.wb_WrStr(F, ETwBR.VldId);
  L_Basis.wb_WrDat(F, ETwBR.BegD);
  L_Basis.wb_WrTim(F, ETwBR.BegT);
  L_Basis.wb_WrTim(F, ETwBR.EndT);
  L_Basis.wb_WrNum(F, ETwBR.Count[L_Way.vpk_MoscowRegion], 0);
  L_Basis.wb_WrNum(F, ETwBR.Count[L_Way.vpk_Moscow      ], 0);
  L_Basis.wb_WrNum(F, ETwBR.Count[L_Way.vpk_OtherSocial ], 0);
  L_Basis.wb_WrNum(F, ETwBR.Count[L_Way.vpk_Paid        ], 0);
  L_Basis.wb_WrNum(F, ETwBR.Count[L_Way.vpk_MoscowRegion] +
                      ETwBR.Count[L_Way.vpk_Moscow      ] +
                      ETwBR.Count[L_Way.vpk_OtherSocial ] +
                      ETwBR.Count[L_Way.vpk_Paid        ], 0);
  L_Basis.wb_TermLine(F);
 END {br_MakeLine};

 PUBLIC PROCEDURE br_Make();
  CONST
   RepName = "ETwBR";
  VAR
   D: DATE;
   PrvWasBad: SCAL[2];
   TRSRoute: LIKE(Route.Route);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(RepName, "஡ ஭ ", L_bp.t_Basis, L_General.tc_inIntvl);
  L_AFM.MakeMultipleIndex("ETwBR", "TSN   : LIKE(ElTck.TSN); " +
                                   "D     : DATE; " +
                                   "eRoute: LIKE(ElTck.Route); " +
                                   "tRoute: LIKE(ElTck.Route); " +
                                   "VldId : LIKE(ElTck.VldId); " +
                                   "BegD  : DATE;" +
                                   "BegT  : TIME;" +
                                   "BegS  : SCAL[60];" +
                                   "EndT  : TIME;" +
                                   "Count : NUMERIC[0][4]",
                             "ETwBR: TSN, D, eRoute, tRoute, VldId, BegD, BegT, BegS");
  D:=Memo.ud_fr();
  WHILE D <= Memo.ud_ut() DO
   SELECT(ElTck, Date, , D);
   WHILE OCCURE(ElTck) DO
    NARROWSEL(ElTck, TSN);
    PROMPT(L_DatTim.DateStr(D) + " " + ElTck.TSN);
    PrvWasBad:=0;
    WHILE OCCURE(ElTck) DO
     IF !ElTck.TckRcS | ElTck.badRoute THEN
      TRSRoute:=br_TRSRoute();
      IF ~PrvWasBad |
         (ETwBR.eRoute # ElTck.Route) |
         (ETwBR.tRoute # TRSRoute) |
         (ETwBR.VldId # ElTck.VldId) THEN
       ETwBR.TSN   :=ElTck.TSN;
       ETwBR.D     :=ElTck.Date;
       ETwBR.eRoute:=ElTck.Route;
       ETwBR.tRoute:=TRSRoute;
       ETwBR.VldId :=ElTck.VldId;
       ETwBR.BegD  :=ElTck.DateIn;
       ETwBR.BegT  :=ElTck.TimeIn;
       ETwBR.BegS  :=ElTck.SecIn;
       ETwBR.EndT  :=ElTck.TimeIn;
       SETZERO(ETwBR.Count);
       INC(ETwBR.Count[L_TRS.VldPsgKindOfVldCardType(ElTck.ElTckT)]);
       INSERT(ETwBR);
      ELSE
       ETwBR.EndT:=ElTck.TimeIn;
       INC(ETwBR.Count[L_TRS.VldPsgKindOfVldCardType(ElTck.ElTckT)]);
       REPLACE(ETwBR);
      END;
      PrvWasBad:=1;
     ELSE
      PrvWasBad:=0;
     END;
     NEXT(ElTck);
    END; (* WHILE OCCURE(File) *)
    NEXTINEXTENDEDSEL(ElTck, TSN);
   END; (* WHILE OCCURE(ElTck) *)
   INC(D);
  END; (*WHILE D <= Memo.ud_ut()*)

  FIO.Open(F, L_General.NameConnection(RepName), "REP", Create);
  br_MakeTop("F");
  SELECT(ETwBR, ETwBR);
  WHILE OCCURE(ETwBR) DO
   NARROWSEL(ETwBR, TSN);
   SEARCH(Staff, TSN, , ETwBR.TSN);
   CONFORM(Staff, Man);
   PROMPT(". " + Staff.TSN);
   WHILE OCCURE(ETwBR) DO
    br_MakeLine("F");
    NEXT(ETwBR);
   END; (* WHILE OCCURE(File) *)
   NEXTINEXTENDEDSEL(ETwBR, TSN);
  END; (* WHILE OCCURE(ETwBR) *)
  FIO.Close(F);
  L_bp.End();
 END {br_Make};

 PRIVATE PROCEDURE TRJR1_Top(F: STRING[]; wASCP: SCAL[2]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "஢");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "ࠪ室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  IF wASCP THEN
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㬬");
  L_Basis.wb_TermLine(F);
 END {TRJR1_Top};

 PRIVATE PROCEDURE TRJR1_Line(F: STRING[]; wASCP: SCAL[2]);
 BEGIN
  L_Basis.wb_WrDat(F, TckRcS.Date);
  L_Basis.wb_WrScl(F, TckRcS.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.trs_Pool, TckRcS.AsWho));
  L_Basis.wb_WrScl(F, TKind.Rgn);
  L_Basis.wb_WrScl(F, TKind.FnMode);
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, StExit.Exit);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("⨢|裂|", StExit.Strict));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", StExit.Suppl));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("죏1|죏2|죏|⏠",
                                     L_TRS.VldPsgKindOfTckKind(TckRcJR.TckKind)));
  L_Basis.wb_WrScl(F, TckRcJR.TckKind);
  L_Basis.wb_WrStr(F, TckKind.Name);
  IF wASCP THEN
   L_Basis.wb_WrScl(F, L_Way.E_CarASCPLev(RWayS.Date, RWayS.BoxNbr, SEJobs.Route, SEJobs.Exit));
  END;
  L_Basis.wb_WrNum(F, TckRcJR.Psg, 0);
  L_Basis.wb_WrNum(F, TckRcJR.Sum, 2);
  L_Basis.wb_TermLine(F);
 END {TRJR1_Line};

 PUBLIC PROCEDURE TRJR1_Make();
  CONST
   RepName = "TRJR1";
  VAR
   wASCP: SCAL[2];
   From,
   UpTo : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(RepName, " த  ஭ ⠬", L_bp.t_Basis, L_General.tc_inIntvl);
  From:=Memo.ud_fr();
  UpTo:=Memo.ud_ut();
  IF    ~ElTckIsImported(From, UpTo) THEN
   L_StdFrm.Confirm("    ਮ ஢ .  㤥 .");
  ELSIF HasNotDistributedElTck(From, UpTo) THEN
   L_StdFrm.Confirm("  ஭  ࠧᥭ  .  㤥 .");
  END;
  FIO.Open(F, L_General.NameConnection(RepName), "REP", Create);
  wASCP:=L_Way.E_ASCPLev(UpTo);
  TRJR1_Top("F", wASCP);
  SELECT(TckRcS, TSN);
  WHILE OCCURE(TckRcS) DO
   NARROWSEL(TckRcS, TSN);
   IF SRCINSEL(TckRcS, GE, From) THEN
    CONFORM(TckRcS, Staff);
    CONFORM(Staff, Man);
   END;
   WHILE OCCURE(TckRcS) & (TckRcS.Date <= UpTo) DO
    PROMPT(". " + TckRcS.TSN + " " + L_DatTim.DateStr(TckRcS.Date) + "  " + TckRcS.TckRcS);
    L_General.Assert(TckRcS.Done, " ࠡ⠭  " + TckRcS.TckRcS);
    SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
    WHILE OCCURE(TckRcJ) DO
     IF SELECT(TckRcJR, TckRcS, TckRcJ.TckRcS, TckRcJ.Day, TckRcJ.StartT) THEN
      L_General.CallUs(SEARCH(RWayJ, RWayS, TckRcJ.asRWayS, TckRcJ.asDay, TckRcJ.asStartT));
      CONFORM(RWayJ, RWayS);
      L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
      CONFORM(RWayJ, SEJobs);
      CONFORM(SEJobs, StExit);
      CONFORM(SEJobs, Route);
      L_Way.StandOnRouteTKind(RWayS.Date);
      WHILE OCCURE(TckRcJR) DO
       CONFORM(TckRcJR, TckKind);
       TRJR1_Line("F", wASCP);
       NEXT(TckRcJR);
      END; (* WHILE OCCURE(TckRcJR) ... *)
     END;
     NEXT(TckRcJ);
    END; (* WHILE OCCURE(TckRcJ) ... *)
    NEXT(TckRcS);
   END; (* WHILE OCCURE(TckRcS) ... *)
   NEXTINEXTENDEDSEL(TckRcS, TSN);
  END; (* WHILE OCCURE(TckRcS) ... *)
  FIO.Close(F);
  L_bp.End();
 END {TRJR1_Make};

(*
$P{ ElT03_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
@
#############################################################################################    ########## #####
=#####===========================================================================================================
|                             ஢ઠ ᪠஢ ஭   ##########                              |
|---------------------------------------------------------------------------------------------------------------|
|                                     ᪠஢ ஭                                    |
|---------------------------------------------------------------------------------------------------------------|
|⭨                |砫          | த-|ᠭ ࠡ (६, , ࠢ)         |
|------------------------|----------------|--------------|------------------------------------------------------|
}
*)

(*
$P{ ElT03_Line:
?, L, ""
?, L, ""
?, L, "D.N.y"
?, L, "H:M"
?, R, "0"
?, R, "0"
?, L, ""
@
|##### ##################|########## #####|### . ## .|######################################################|
}
*)

(*
$P{ ElT03_CntTop:
@
|---------------------------------------------------------------------------------------------------------------|
|                           ᪠㥬  ࠡ⭨ ஭                          |
|---------------------------------------------------------------------------------------------------------------|
|-|                              |     |Id ⠫    |⭨                             |
|------|--------------------------------------|----------|----------------|-------------------------------------|
}
*)

(*
$P{ ElT03_CntLine:
?, R, ""
?, L, ett_Pool
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|######|######################################|##########|################|##### ###############################|
}
*)

(*
$P{ ElT03_Bot:
@
=(c) Polak=======================================================================================================
}
*)

 PRIVATE PROCEDURE FloatToTime(f: FLOAT): TIME;
 BEGIN
  RETURN 00:00 + (f + 0.0005) MOD 24;
 END {FloatToTime};

 PRIVATE PROCEDURE FloatToDay(f: FLOAT): LIKE(RWayJ.Day);
 BEGIN
  RETURN f DIV 24 + 1;
 END {FloatToDay};

 PRIVATE PROCEDURE ElT03_wWork_OneRWayS(ByWLM: SCAL[2]; VAR NotTaxed: NUMERIC[0]);
  VAR
   _TSN  : LIKE(Staff.TSN);
   Start,
   Stop  : FLOAT;
 BEGIN
  IF ByWLM THEN
   CONFORM(WayLMen, RWayS);
  END;
  IF RWayS.Status = L_Way.rwsStat_Rated THEN
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayJ) DO
    IF ~ByWLM | (L_Way._TimeInt(L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT),
                                L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT),
                                L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT),
                                L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT)) > 0) THEN
     CONFORM(RWayJ, WJMode);
     CONFORM(RWayJ, Quality);
     IF WJMode.IncSel & (Quality.Type # L_Way.QualType_Annul) THEN
      IF ByWLM THEN
       _TSN :=WayLMen.TSN;
       Start:=Math.Max(L_Way.FullBegTime(RWayJ.Day,   RWayJ.StartT),
                       L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT));
       Stop :=Math.Min(L_Way.FullEndTime(RWayJ.Day,   RWayJ.StartT,   RWayJ.StopT),
                       L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT));
      ELSE
       _TSN :=RWayS.TSN;
       Start:=L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT);
       Stop :=L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT);
      END;
      SELECT(wWork, Start, , _TSN);
      IF SRCINSEL(wWork, LE, Start) THEN
       L_General.Assert(wWork.Stop <= Start, "祭 ६ ࠡ ⠡. " + _TSN + ":" +
                                             "| " + wWork.RWayS + " " + FloatToDay(wWork.Start) + " " +
                                              L_DatTim.TimeStr(FloatToTime(wWork.Start)) + " - " +
                                              L_DatTim.TimeStr(FloatToTime(wWork.Stop)) +
                                             "| " + RWayJ.RWayS + " " + FloatToDay(Start) + " " +
                                              L_DatTim.TimeStr(FloatToTime(Start)) + " - " +
                                              L_DatTim.TimeStr(FloatToTime(Stop)));
      END;
      wWork.TSN  :=_TSN;
      wWork.Start:=Start;
      wWork.Stop :=Stop;
      wWork.RWayS:=RWayJ.RWayS;
      INSERT(wWork);
     END;
    END;
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
  ELSE
   IF NotTaxed = 0 THEN
    L_StdFrm.Choice("⠪஢  , ਬ " + RWayS.RWayS +
                    "|| 㤥 ");
   END;
   INC(NotTaxed);
  END;
 END {ElT03_wWork_OneRWayS};

 PRIVATE PROCEDURE SEJobsIsGoodForShow(): SCAL[2];
 BEGIN
  CONFORM(SEJobs, Route);
  CONFORM(RWayJ, RWayS);
  L_Way.StandOnRouteTKind(RWayS.Date);
  RETURN TKind.FnMode = L_Way.tkfnm_Subsidy;
 END {SEJobsIsGoodForShow};

 PUBLIC PROCEDURE ElT03_Make();
  CONST
   RepName = "ElT03";
  VAR
   D        : DATE;
   NotTaxed,
   Cnt,
   Day,
   MinLength: NUMERIC[0];
   StopT    : TIME;
   Start,
   Stop,
   _MaxL    : NUMERIC[3];
   S        : STRING[];
   _RWayS   : LIKE(RWayS.RWayS);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  D:=Memo.ud_cd();
  MinLength:=15;
  STDFORM(L_StdFrm.sf_Choice( "%###############################################%" +
                             "|"+
                             "|%######################% %###% %#####%",
                             "%<뢥   ᪠஢ ஭ >T" +
                             "%<த⥫쭮 >T" +
                             "%<>I" +
                             "%<>T"),
          , INFORM, , MinLength);

  L_AFM.MakeMultipleIndex("woElT", "TSN  : LIKE(Staff.TSN);" +
                                   "Start: NUMERIC[3];" +
                                   "Stop : NUMERIC[3]",
                             "Start: TSN, Start");
  L_AFM.MakeMultipleIndex("wWork", "TSN  : LIKE(Staff.TSN);" +
                                   "Start: NUMERIC[3];" +
                                   "Stop : NUMERIC[3];" +
                                   "RWayS: LIKE(RWayS.RWayS)",
                             "Start: TSN, Start");
  L_AFM.MakeMultipleIndex("tmp",   "TSN   : LIKE(Staff.TSN);" +
                                   "Date  : DATE;" +
                                   "Start : TIME;" +
                                   "RWayS : LIKE(RWayS.RWayS);" +
                                   "Length: NUMERIC[3];" +
                                   "MaxL  : NUMERIC[3]",
                             "MaxL: MaxL, TSN, Date, Start; TSN: TSN, Length");
  L_AFM.MakeMultipleIndex("Count", "TSN     : LIKE(Staff.TSN);" +
                                   "ElTckId : LIKE(ElTck.ElTckId);" +
                                   "ElTckNum: LIKE(ElTck.ElTckNum);" +
                                   "ElTckT  : LIKE(ElTck.ElTckT);" +
                                   "Count   : NUMERIC[0]",
                             "TSN: TSN, ElTckId, ElTckNum, ElTckT; Count: Count, TSN");
  NotTaxed:=0;
  SELECT(ElTck, Date, , D);
  WHILE OCCURE(ElTck) DO
   CHANGESEL(ElTck, Date, , ElTck.Date, ElTck.TSN);
   PROMPT(" :" + ElTck.TSN);
   SELECT(RWayS, TSN, , ElTck.TSN, D);
   WHILE OCCURE(RWayS) DO
    ElT03_wWork_OneRWayS(0, NotTaxed);
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
   SELECT(WayLMen, TSN, , ElTck.TSN, D);
   WHILE OCCURE(WayLMen) DO
    IF WayLMen.Who = L_Way.wlmwho_Guard THEN
     ElT03_wWork_OneRWayS(1, NotTaxed);
    END;
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)

   IF SELECT(wWork, Start, ElTck.TSN) THEN
    Start:=wWork.Start;
    WHILE OCCURE(ElTck) DO
     Stop:=L_Way.FullBegTime(ElTck.DateIn - D + 1, ElTck.TimeIn);
     IF (Stop - Start) > MinLength/60 THEN
      woElT.TSN  :=ElTck.TSN;
      woElT.Start:=Start;
      woElT.Stop :=Stop;
      INSERT(woElT);
     END;
     Start:=Stop;
     NEXT(ElTck);
    END; (* WHILE OCCURE(ElTck) ... *)
    LAST(wWork);
    IF (wWork.Stop - Start) > MinLength/60 THEN
     woElT.TSN  :=wWork.TSN;
     woElT.Start:=Start;
     woElT.Stop :=wWork.Stop;
     INSERT(woElT);
    END;
   END;
   FIRST(ElTck);
   WHILE OCCURE(ElTck) DO
    ADD(Count, TSN, , ElTck.TSN, ElTck.ElTckId, ElTck.ElTckNum, ElTck.ElTckT,
        Count.Count, 1);
    NEXT(ElTck);
   END; (* WHILE OCCURE(ElTck) ... *)
   LAST(ElTck);
   CHANGESEL(ElTck, Date, , ElTck.Date);
   NEXT(ElTck);
  END; (* WHILE OCCURE(ElTck) ... *)

  SELECT(wWork, Start);
  WHILE OCCURE(wWork) DO
   PROMPT("ࠡ⪠:" + wWork.TSN);
   CHANGESEL(wWork, Start, , wWork.TSN);
   SETEMPTY(Stop, _RWayS);
   WHILE OCCURE(wWork) DO
    IF (wWork.Start = Stop) & (_RWayS = wWork.RWayS) THEN
     Stop:=wWork.Stop;
     PREV(wWork);
     wWork.Stop:=Stop;
     REPLACE(wWork);
     NEXT(wWork);
     REMOVE(wWork);
    ELSE
     Stop:=wWork.Stop;
     _RWayS:=wWork.RWayS;
     NEXT(wWork);
    END;
   END; (* WHILE OCCURE(wWork) ... *)
   LAST(wWork);
   CHANGESEL(wWork, Start);
   NEXT(wWork);
  END; (* WHILE OCCURE(wWork) ... *)

  SELECT(woElT, Start);
  WHILE OCCURE(woElT) DO
   PROMPT("஢:" + woElT.TSN);
   SELECT(wWork, Start, , woElT.TSN);
   SRCINSEL(wWork, LE, , woElT.Start);
   WHILE OCCURE(wWork) & (wWork.Start < woElT.Stop) DO
    Stop :=Math.Min(wWork.Stop, woElT.Stop);
    Start:=Math.Max(wWork.Start, woElT.Start);
    IF (Stop - Start) > MinLength/60 THEN
     tmp.TSN   :=wWork.TSN;
     tmp.Date  :=D + (Start DIV 24);
     tmp.Start :=FloatToTime(Start);
     tmp.RWayS :=wWork.RWayS;
     tmp.Length:=Stop - Start;
     tmp.MaxL  :=Stop - Start;
     INSERT(tmp);
     CHANGESEL(tmp, TSN, , tmp.TSN);
     LAST(tmp);
     _MaxL:=tmp.Length;
     WHILE PREV(tmp) DO
      tmp.MaxL:=_MaxL;
      REPLACE(tmp);
     END;
    END;
    NEXT(wWork);
   END;
   NEXT(woElT);
  END; (* WHILE OCCURE(woElT) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, ElT03_Top, RepName, D);
  SELECT(tmp, MaxL);
  LAST(tmp);
  WHILE OCCURE(tmp) DO
   PROMPT(":" + tmp.TSN);
   SEARCH(Staff, TSN, , tmp.TSN);
   CONFORM(Staff, Man);
   CHANGESEL(tmp, MaxL, , tmp.MaxL, tmp.TSN);
   Cnt:=0;
   FIRST(tmp);
   WHILE OCCURE(tmp) DO
    SELECT(RWayJ, RWayS, , tmp.RWayS);
    StopT:=tmp.Start + tmp.Length;
    Day:=tmp.Date - D + 1 + (tmp.Start > StopT);
    SRCINSEL(RWayJ, LE, , tmp.Date - D + 1, tmp.Start);
    CONFORM(RWayJ, SEJobs);
    IF SEJobsIsGoodForShow() THEN
     S:=L_DatTim.TimeStr(tmp.Start) + "-";
     IF L_Way.FullBegTime(Day, StopT) > L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT) THEN
      S:=S + L_DatTim.TimeStr(RWayJ.StopT);
     ELSE
      S:=S + L_DatTim.TimeStr(StopT);
     END;
     S:=S + " " + SEJobs.Route + L_Str.PoolItem(">|<", SEJobs.Dir);
    ELSE
     SETEMPTY(S);
    END;
    NEXT(RWayJ);
    WHILE OCCURE(RWayJ) & ((RWayJ.Day < Day) | (RWayJ.Day = Day) & (RWayJ.StartT < StopT)) DO
     CONFORM(RWayJ, SEJobs);
     IF SEJobsIsGoodForShow() THEN
      S:=S + "; " + L_DatTim.TimeStr(RWayJ.StartT) + "-";
      IF L_Way.FullBegTime(Day, StopT) > L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT) THEN
       S:=S + L_DatTim.TimeStr(RWayJ.StopT);
      ELSE
       S:=S + L_DatTim.TimeStr(StopT);
      END;
      S:=S + " " + SEJobs.Route + L_Str.PoolItem(">|<", SEJobs.Dir);
     END;
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
    IF ~!S THEN
     IF Cnt > 0 THEN
      MAKEPART(R, ElT03_Line,          ,         ,                  tmp.Date, tmp.Start,
               tmp.Length DIV 1, tmp.Length MOD 1 * 60, S);
     ELSE
      MAKEPART(R, ElT03_Line, Staff.TSN, L_Str.ShortName(Man.Name), tmp.Date, tmp.Start,
               tmp.Length DIV 1, tmp.Length MOD 1 * 60, S);
     END;
     INC(Cnt);
    END;
    NEXT(tmp);
   END;
   FIRST(tmp);
   CHANGESEL(tmp, MaxL);
   PREV(tmp);
  END; (* WHILE OCCURE(tmp) ... *)

  MAKEPART(R, ElT03_CntTop);
  SELECT(Count, Count);
  LAST(Count);
  Cnt:=0;
  WHILE OCCURE(Count) & (Cnt < 10) DO
   CHANGESEL(Count, Count, , Count.Count);
   WHILE OCCURE(Count) DO
    SEARCH(Staff, TSN, , Count.TSN);
    CONFORM(Staff, Man);
    MAKEPART(R, ElT03_CntLine, Count.Count, Count.ElTckT, Count.ElTckNum, Count.ElTckId,
                               Staff.TSN, L_Str.ShortName(Man.Name));
    INC(Cnt);
    PREV(Count);
   END; (* WHILE OCCURE(Count) ... *)
   FIRST(Count);
   CHANGESEL(Count, Count);
   PREV(Count);
  END; (* WHILE OCCURE(Count) ... *)

  MAKEPART(R, ElT03_Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("Count");
  L_AFM.AF_PurgeTemp("woElT");
  L_AFM.AF_PurgeTemp("wWork");
  L_AFM.AF_PurgeTemp("tmp");
  LIKEMENU(Survey, "");
 END {ElT03_Make};

(*
$P{ ELT04_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
@
#############################################################   ########## #####
=#####==========================================================================
|      #############################  ਮ  ##########  ##########      |
|------------------------------------------------------------------------------|
|      |. ||䨪|| |室               ||  |
|----------|-----|-------|------|-----|----------|-------------------|--|------|
}
*)

(*
$P{ ELT04_Line:
ElTck.Date, L, "D.N.y"
ElTck.TSN, L, ""
ElTck.Route, L, ""
ElTck.badRoute, L, ""
ElTck.Schedule, L, ""
ElTck.Change, L, ""
ElTck.VldId, L, ""
ElTck.DateIn, L, "D.N.y"
ElTck.TimeIn, L, "H:M"
ElTck.ElTckId, L, ""
ElTck.Price, L, ""
@
|##########|#####| #### #|  ####|   ##|##########|########## ########|##|######|
}
*)

(*
$P{ ELT04_Bot:
@
=(c) Polak======================================================================
}
*)

 PUBLIC PROCEDURE ELT04_Make();
  CONST
   RepName = "ElT04";
  VAR
   From, UpTo: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  From:=Memo.ud_fr();
  UpTo:=Memo.ud_ut();
  MAKEPART(R, ELT04_Top, RepName, ", ࠧᥭ  ", From, UpTo);

  SELECT(ElTck, TckRcS, , EMPTYOF(ElTck.TckRcS));
  SRCINSEL(ElTck, GE, , From);
  WHILE OCCURE(ElTck) & (ElTck.Date <= UpTo) DO
   PROMPT(L_DatTim.DateStr(ElTck.Date) + ", " + ElTck.TSN + ", " + L_DatTim.TimeStr(ElTck.TimeIn));
   MAKEPART(R, ELT04_Line);
   NEXT(ElTck);
  END; (* WHILE OCCURE(ElTck) ... *)
  MAKEPART(R, ELT04_Bot);
  CLOSEREP(R);
 END {ELT04_Make};

 PUBLIC PROCEDURE UnbindElTck();
 BEGIN
  L_General.Assert(ACCESS(ElTck), " ⠭ ⥪   '஭ '");
  L_General.Assert(~!ElTck.TckRcS, "⬥ ࠧᥭ 믮 ⮫쪮  ࠧᥭ ப");
  L_TRS.Unbind_ElTck();
 END {UnbindElTck};

BEGIN
 L_Events.ExecuteHandler();
END.
