(*
%Copyright   (c) Polak Computer System
%Author      17.03.2003 18:46:08 POLAK\SAN
%Purpose       室 (室)
%Type        control
%Specific    AP
%Modified    30.06.2014 19:23:31 POLAK\Gina
%Environment
*)

 MODULE ExitIP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_APtm, L_Events, L_PRoll, L_Way, L_StdFrm, Memo, E_Way, L_APWI,
        L_Str, L_WDO, L_SysLog, Str;

 PRIVATE PROCEDURE ExitIP_1_OnZoneOpen();
 BEGIN
  L_WDO.SetFieldFormat("ExitIP.Cnd", L_Way.E_IPConditionPool(SYSDATE()));
  L_WDO.z_SetFieldFormat(0, "StExit.ActivKnd", L_Way.seak_Pool);
 END {ExitIP_1_OnZoneOpen};

 PRIVATE PROCEDURE ExitIP_2_OnZoneOpen();
 BEGIN
  L_General.Assert(ACCESS(ExitIP), " ⠭ ⥪    ਨ");
  CONFORM(ExitIP, StExit);
  CONFORM(StExit, SEJobs);
  CONFORM(SEJobs, Route);
  IF L_Way.E_NeedCrankyWayIPLInterpretation(ExitIP.Date, L_Way.tcpi_FromExit) THEN
   RTI.Get().CurWindow.ActiveZone.SubwindowOriginalName:="CrExitIPLE";
  ELSE
   RTI.Get().CurWindow.ActiveZone.SubwindowOriginalName:="ExitIPLE";
  END;
 END {ExitIP_2_OnZoneOpen};

 PRIVATE PROCEDURE SetDayTimeLink();
  CONST
   LinkName = "DayTime";
  VAR
   Zone: FORM_ZONE;
   Link: FORM_LINK;
 BEGIN
  Zone:=RTI.Get().CurZone;
  Link:=Zone.Links(LinkName);
  IF (ExitIP.Type = L_Way.ipt_OnTrip) | (ExitIP.Type = L_Way.ipt_OnHour) THEN
   IF !Link THEN
    Zone.Links.Add(FORM_LINK.Create(LinkName,
                                    TABLE.Get("SEJobs").Indexes("Exit"),
                                    Zone.Fields("StExit.Exit"),
                                    Zone.Fields("ExitIPL.Day"),
                                    Zone.Fields("ExitIPL.Time")));
    Zone.Fields("ExitIPL.Day").OwnerWindowOriginalName:="SEJobs";
    Zone.Fields("ExitIPL.Time").OwnerWindowOriginalName:="SEJobs";
   END;
  ELSE
   IF ~!Link THEN
    Zone.Links.Remove(Link);
   END;
  END;
 END {SetDayTimeLink};

 PRIVATE PROCEDURE ExitIPLE_0_OnZoneOpen();
  VAR
   SpcCfEnable,
   PlanFlagEdit: SCAL[2];
   SpcCfPool   : STRING[];
   WD          : L_DatTim.tWeekday;
   i           : NUMERIC[0];
 BEGIN
  L_General.Assert(ACCESS(ExitIP), " ⠭ ⥪    ਨ");
  L_WDO.SetFieldFormat("ExitIP_Cnd", L_Way.E_IPConditionPool(SYSDATE()));
  L_WDO.SetFieldFormat("StExit.ActivKnd", L_Way.seak_Pool);
  CONFORM(ExitIP, StExit);
  SpcCfEnable:=((ExitIP.Cnd = L_Way.ipc_Guard) & L_Way.E_FillIncPlanFromIncPlanG(ExitIP.Date)) |
               (L_APWI.E_FillVldPsgPlanFromVldPsgPlanG(ExitIP.Date) & (ExitIP.Cnd = E_Way.ipc_TermPlanGrd));
  IF SpcCfEnable THEN
   SpcCfPool:=" |. ⥫|. ⥫|. ⥫|. ⥫|. ⥫";
  ELSE
   SpcCfPool:=" | "; (* ??? BUG *)
  END;
  L_WDO.SetFieldFormat("ExitIPL_SpcCf", SpcCfPool);
  L_WDO.SetFieldVisible("ExitIPL.SpcCf", SpcCfEnable);

  SetDayTimeLink();

  FOR_EACH WD DO
   PlanFlagEdit:=(StExit.ActivKnd # L_Way.seak_OnDays) | (StExit.ClndAppl = L_Way.seca_Fact) | StExit.OnDays[WD];
   L_WDO.SetFieldModifiable(L_Str.Var_wIdx("ExitIPL.Plan", WD),    PlanFlagEdit);
   L_WDO.SetFieldModifiable(L_Str.Var_wIdx("ExitIPL.ElstcCf", WD), PlanFlagEdit);
   SETZERO(i);
   WHILE i <= (HIGH(ExitIPL.Cfc) DIV 8) DO
    L_WDO.SetFieldModifiable(L_Str.Var_wIdx("ExitIPL.Cfc", WD + i * 8), PlanFlagEdit);
    INC(i);
   END;
  END; (* FOR_EACH *)
 END {ExitIPLE_0_OnZoneOpen};

 PRIVATE PROCEDURE CrExitIPLE_0_OnZoneOpen();
  CONST
   MaxGrp = 4; (*ᨬ 4 㯯 *)
  VAR
   IdxGrp      : SCAL[HIGH(RouteIPL.Cfc)];
   VolGrp      : NUMERIC[0][MaxGrp];
   curVolGrp   : NUMERIC[0];
   curWd       : L_DatTim.tWeekday;
 BEGIN
  ExitIPLE_0_OnZoneOpen();
  IdxGrp:=0;
  IF ~!PROCREF(E_Way.PasVolGrpCranky) THEN
   SETEMPTY(VolGrp);
   E_Way.PasVolGrpCranky(ExitIP.Date, VolGrp);
   FOR_EACH curVolGrp IN VolGrp DO
    FOR_EACH curWd DO
     L_WDO.SetFieldVisible(L_Str.Var_wIdx("ExitIPL.Cfc", IdxGrp*8+curWd), 1);
    END;
    INC(IdxGrp);
   END;
  END;
  WHILE IdxGrp < MaxGrp DO
   FOR_EACH curWd DO
    L_WDO.SetFieldVisible(L_Str.Var_wIdx("ExitIPL.Cfc", IdxGrp*8+curWd), 0);
   END;
   INC(IdxGrp);
  END;
 END {CrExitIPLE_0_OnZoneOpen};

 PRIVATE PROCEDURE ExitIP_ANY_OnSuccessfulChange();
  VAR
   curIndex: NUMERIC[0];
   curFieldName: STRING[];
 BEGIN
  curIndex:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  curFieldName:=RTI.Get().CurZone.ActiveField.TableField.ObtainName(curIndex);
  IF !^curFieldName THEN
   L_General.Assert(curIndex # 0, "     ");
   ^curFieldName:=^(RTI.Get().CurZone.ActiveField.TableField.ObtainName(curIndex-1));
  END;
  REPLACE(^(RTI.Get().CurZone.MasterTable.Name));
 END {ExitIP_ANY_OnSuccessfulChange};

 PRIVATE PROCEDURE ExitIPL_Plan_OnSuccessfulChange();
 BEGIN
  ExitIP_ANY_OnSuccessfulChange();
 END {ExitIPL_Plan_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckElstcCf(_ElstcCf: LIKE(ExitIPL.ElstcCf[0]));
 BEGIN
  IF _ElstcCf > 1 THEN
   STDMSG(" 筮  1.0!| 㢥७?", CHOICE);
  END;
 END {CheckElstcCf};

 PRIVATE PROCEDURE ExitIPL_ElstcCf_OnSuccessfulChange();
 BEGIN
  CheckElstcCf(^(RTI.Get().CurZone.ActiveField.Expression));
  ExitIP_ANY_OnSuccessfulChange();
 END {ExitIPL_ElstcCf_OnSuccessfulChange};

 PRIVATE PROCEDURE ExitIPL_Cfc_OnSuccessfulChange();
 BEGIN
  ExitIP_ANY_OnSuccessfulChange();
 END {ExitIPL_Cfc_OnSuccessfulChange};

 PRIVATE PROCEDURE ExitIPL_Day_OnSuccessfulChange();
 BEGIN
  IF ExitIPL.Day > 01 THEN
   SAVE(ExitIPL);
   L_General.Assert(CHANGESEL(ExitIPL, Exit, ExitIPL.Exit, ExitIPL.Date, ExitIPL.Cnd) &
                    FIRST(ExitIPL) & (ExitIPL.Day = 01),
                    " 稭 ଫ   ࢮ  ( 砫 ⢨  01)");
   RESTORE(ExitIPL);
   L_General.Assert(SELECT(SEJobs, Exit, ExitIPL.Exit, ExitIPL.Day), " ३ᮢ   砫 "+ExitIPL.Day);
  END;
 END {ExitIPL_Day_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckRights();
 BEGIN
  L_General.Assert_wReferToAdmin(~L_APtm.MonthIsClosed(L_DatTim.Per(ExitIP.Date), L_APtm.system_Salary),
                                 "    ⮬ ");
 END {CheckRights};

 PRIVATE PROCEDURE CheckNoTouchDriverPlan();
 BEGIN
  L_General.Assert(ACCESS(ExitIP), " ⠭  ਨ ");
  CONFORM(ExitIP, StExit);
  IF ExitIP.Cnd = L_Way.ipc_Driver THEN
   L_General.Assert(~L_Way.E_FillIncPlanFromIncPlanG(ExitIP.Date),
                    "  ⥫   ᭮   ");
  END;
  IF L_APWI.E_FillVldPsgPlanFromVldPsgPlanG(ExitIP.Date) THEN
   L_General.Assert(ExitIP.Cnd # E_Way.ipc_TermPlanDrv,
                    "  ⥫   ᭮   ");
  END;
 END {CheckNoTouchDriverPlan};

 PRIVATE PROCEDURE ExitIP_OnBeforeEdit();
 BEGIN
  CheckRights();
 END {ExitIP_OnBeforeEdit};

 PRIVATE PROCEDURE ExitIP_OnBeforeDelete();
 BEGIN
  CheckRights();
 END {ExitIP_OnBeforeDelete};

 PRIVATE PROCEDURE ExitIP_OnAfterEditInsert();
  VAR
   cpit: L_Way.tCalcPlInc;
 BEGIN
  IF ExitIP.Type # L_Way.ipt_Canceled THEN
   CheckNoTouchDriverPlan();
  END;
  CONFORM(ExitIP, StExit);
  SELECT(SEJobs, Exit, , StExit.Exit);
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, Route);
   CONFORM(SEJobs, WJMode);
   IF L_Way.SEJobsWithPlIncome(ExitIP.Date) THEN
    cpit:=L_Way.E_CalcPlIncType(ExitIP.Date, ExitIP.Cnd);
    IF    (cpit=L_Way.cpit_ByTime) | (cpit=L_Way.cpit_ByRun) THEN
     L_General.Assert(ExitIP.Type # L_Way.ipt_OnTrip, '஢ " ३"  ঠ');
    ELSIF (cpit=L_Way.cpit_ByTrip) | (cpit=L_Way.cpit_ByRun) THEN
     L_General.Assert(ExitIP.Type # L_Way.ipt_OnHour, '஢ " "  ঠ');
    END;
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
 END {ExitIP_OnAfterEditInsert};

 PRIVATE PROCEDURE AllowedPlan();
 BEGIN
  L_General.Assert((ExitIP.Type#L_Way.ipt_OnRoute)&(ExitIP.Type#L_Way.ipt_Canceled), " ⠪ ⨯ ஢   㪠뢠");
 END {AllowedPlan};

 PRIVATE PROCEDURE ExitIP_OnAfterEdit();
 BEGIN
  IF ExitIP.Date#GE_PVALUE(ExitIP.Date) THEN
   CheckRights();
  END;
  ExitIP_OnAfterEditInsert();
  CONFORM(ExitIP, ExitIPL);
  IF OCCURE(ExitIPL) THEN
   AllowedPlan();
  END;
 END {ExitIP_OnAfterEdit};

 PRIVATE PROCEDURE ExitIP_OnAfterInsert();
 BEGIN
  CheckRights();
  ExitIP_OnAfterEditInsert();
 END {ExitIP_OnAfterInsert};

 PRIVATE PROCEDURE ExitIPL_OnBeforeEdit();
 BEGIN
  CONFORM(ExitIPL, ExitIP);
  AllowedPlan();
  CheckRights();
  CheckNoTouchDriverPlan();
 END {ExitIPL_OnBeforeEdit};

 PRIVATE PROCEDURE ExitIPL_OnBeforeInsert();
  VAR
   _TemplPV: LIKE(ExitIPL.TemplPV);
   IsFirst : SCAL[2];
 BEGIN
  CONFORM(ExitIPL, ExitIP);
  AllowedPlan();
  CheckRights();
  CheckNoTouchDriverPlan();
  IF !ExitIPL.TemplPV THEN
   SETEMPTY(_TemplPV);
   SAVE(ExitIP);
   SAVE(ExitIPL);
   CHANGESEL(ExitIP, Exit, , ExitIP.Exit);
   WHILE PREV(ExitIP) & !_TemplPV DO
    CONFORM(ExitIP, ExitIPL);
    IF OCCURE(ExitIPL) THEN
     _TemplPV:=ExitIPL.TemplPV;
    END;
   END;
   RESTORE(ExitIP);
   RESTORE(ExitIPL);
   ExitIPL.TemplPV:=_TemplPV;
   REPLACE(ExitIPL);
  END;
  IF L_Way.E_NeedCrankyWayIPLInterpretation(ExitIP.Date, L_Way.tcpi_FromExit) THEN
   SAVE(ExitIPL);
   IsFirst:=CHANGESEL(ExitIPL, Exit, ExitIPL.Exit, ExitIPL.Date, ExitIPL.Cnd) & ~PREV(ExitIPL);
   RESTORE(ExitIPL);
   IF IsFirst THEN
    SELECT(SEJobs, Exit, , ExitIPL.Exit);
    ExitIPL.Day :=SEJobs.Day;
    ExitIPL.Time:=SEJobs.StartT;
    REPLACE(ExitIPL);
   END;
  END;
 END {ExitIPL_OnBeforeInsert};

 PRIVATE PROCEDURE ExitIPL_OnBeforeDelete();
 BEGIN
  CONFORM(ExitIPL, ExitIP);
  CheckRights();
 END {ExitIPL_OnBeforeDelete};

 PRIVATE PROCEDURE ExitIPL_OnAfterEdit();
 BEGIN
  (*㦭 - ⮨ 窠    MarkInSysLog*)
 END {ExitIPL_OnAfterEdit};

 PRIVATE PROCEDURE ExitIPL_OnAfterInsert();
 BEGIN
  (*㦭 - ⮨ 窠    MarkInSysLog*)
 END {ExitIPL_OnAfterInsert};

 PRIVATE PROCEDURE _GetPrc(_IncPrc, _IncPrcLoc: NUMERIC[3]): NUMERIC[3];
 BEGIN
  IF !_IncPrcLoc THEN
   L_General.Assert(~!_IncPrc, "  "+L_Str.PoolItem(L_Way.E_IPConditionPool(ExitIPL.Date), ExitIPL.Cnd)+"|    樥");
   RETURN _IncPrc;
  ELSE
   RETURN _IncPrcLoc;
  END;
 END {_GetPrc};

 PRIVATE PROCEDURE NeedCopy(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(ExitIP);
  Result:=~SEARCH(ExitIP, Exit, ExitIP.Exit, Memo.ud_cd(), ExitIP.Cnd);
  RESTORE(ExitIP);
  IF Result THEN
   CONFORM(ExitIP, StExit);
   IF (L_Way.E_FillIncPlanFromIncPlanG(Memo.ud_cd()) & (ExitIP.Cnd = L_Way.ipc_Driver)) |
      (L_APWI.E_FillVldPsgPlanFromVldPsgPlanG(Memo.ud_cd()) & (ExitIP.Cnd = E_Way.ipc_TermPlanDrv)) THEN
    Result:=0;
   END;
  END;
  RETURN Result;
 END {NeedCopy};

 PUBLIC PROCEDURE CopyPlan();
  VAR
   WD     : L_DatTim.tWeekday;
   _IncPrc: NUMERIC[3];
   Prc    : NUMERIC[3][MAXOF(ExitIP.Cnd)+1];
   Blank,
   PoolIns,
   Vars   : STRING[];
 BEGIN
  L_General.Assert(ACCESS(ExitIP), " ⠭ 室 ");
  L_PRoll.Salary_CheckNoTouch(Memo.ud_mb());

  SAVE(ExitIP);
  IF SEARCH(ExitIP, Exit, ExitIP.Exit, Memo.ud_cd(), ExitIP.Cnd) THEN
   L_StdFrm.Choice("  " + L_DatTim.DateStr(Memo.ud_cd()) + " 㦥  ");
  END;
  RESTORE(ExitIP);

  SETEMPTY( Blank, PoolIns, Prc);
  Vars:=", _IncPrc";
  CHANGESEL(ExitIP, Exit, , ExitIP.Exit, ExitIP.Date);
  FIRST(ExitIP);
  WHILE OCCURE(ExitIP) DO
   IF ExitIP.Type # L_Way.ipt_Canceled THEN
    Blank  :=Blank + "|" + "%#########################% %#######%";
    PoolIns:=PoolIns + "%<" + Str.Align(L_Str.PoolItem(L_Way.E_IPConditionPool(ExitIP.Date), ExitIP.Cnd), 25, LEFT) + ">T" +"%L<3.>YI";
    Vars   :=Vars + ", Prc["+ExitIP.Cnd+"]";
   END;
   NEXT(ExitIP);
  END; (* WHILE ... *)

  _IncPrc:=1;
  STDFORM(L_StdFrm.sf_Choice("|ନ஢   " + L_DatTim.DateStr(Memo.ud_cd()) + "  ᭮ ⥪饣" +
                             "|%#########################% %#######%" +
                             Blank,
                             "%<騩 樥>T" +
                             "%L<3.>I" + PoolIns),
          , STOP, ^Vars);

  FIRST(ExitIP);
  WHILE OCCURE(ExitIP) DO
   IF (ExitIP.Type # L_Way.ipt_Canceled) & NeedCopy() THEN
    SAVE(ExitIP);
    ExitIP.Date:=Memo.ud_cd();
    INSERT(ExitIP);
    L_APtm.SysLogHandler("ExitIP", L_SysLog.knd_AutoBuild);
    RESTORE(ExitIP);
    SELECT(ExitIPL, Exit, , ExitIP.Exit, ExitIP.Date, ExitIP.Cnd);
    WHILE OCCURE(ExitIPL) DO
     PROMPT(L_DatTim.TimeStr(ExitIPL.Time));
     SAVE(ExitIPL);
     ExitIPL.Date:=Memo.ud_cd();
     FOR_EACH WD DO
      ExitIPL.Plan[WD]:=ExitIPL.Plan[WD]*_GetPrc(_IncPrc, Prc[ExitIPL.Cnd]);
     END;
     INSERT(ExitIPL);
     L_APtm.SysLogHandler("ExitIPL", L_SysLog.knd_AutoBuild);
     RESTORE(ExitIPL);
     NEXT(ExitIPL);
    END; (* WHILE ... *)
   END;
   NEXT(ExitIP);
  END; (* WHILE ... *)
  FIRST(ExitIP);
  IF SELECT(ExitIP, Exit, ExitIP.Exit, Memo.ud_cd()) THEN
   SE_WZD_CURSOR(GE_CURWIN(), GE_CURZONE(), ExitIP);
  END;
 END {CopyPlan};

 PUBLIC PROCEDURE SetPlan();
  VAR
   curPlan   : LIKE(ExitIPL.Plan[0]);
   curElstcCf: LIKE(ExitIPL.ElstcCf[0]);
   curIndex  : SCAL[RANGEOF(ExitIPL.Plan)];
 BEGIN
  L_General.Assert(ACCESS(ExitIPL), " ⠭ ப ");
  curIndex:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  IF !curIndex THEN
   curIndex:=0;
  END;
  curPlan   :=ExitIPL.Plan[curIndex];
  curElstcCf:=ExitIPL.ElstcCf[curIndex];
  STDFORM(L_StdFrm.sf_Choice( "%###################% %##########%"+
                             "|"+
                             "|%###################% %##########%",
                             "%<               >T"+
                             "%R<2.>I"+
                             "%<. 筮>T" +
                             "%R<3.>I"),
          "   . 筮", , , curPlan, curElstcCf);
  CheckElstcCf(curElstcCf);
  CONFORM(ExitIPL, StExit);

  FOR_EACH curIndex DO
   IF (StExit.ActivKnd # L_Way.seak_OnDays) | StExit.OnDays[curIndex] THEN
    ExitIPL.Plan   [curIndex]:=curPlan;
    ExitIPL.ElstcCf[curIndex]:=curElstcCf;
   END;
  END;
  REPLACE(ExitIPL);
 END {SetPlan};

 PUBLIC PROCEDURE InsBySEJobs();
 BEGIN
  L_General.Assert(ACCESS(ExitIPL), " ⠭ ப ");
  CONFORM(ExitIPL, ExitIP);
  SAVE(ExitIPL);
  SELECT(SEJobs, Exit, , ExitIP.Exit);
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, WJMode);
   CONFORM(SEJobs, Route);
   IF L_Way.SEJobsWithPlIncome(ExitIP.Date) &
      ~SEARCH(ExitIPL, Exit, ExitIP.Exit, ExitIP.Date, ExitIP.Cnd,
                             SEJobs.Day, SEJobs.StartT) THEN
    RESTORE(ExitIPL);
    ExitIPL.Day :=SEJobs.Day;
    ExitIPL.Time:=SEJobs.StartT;
    REPLACE(ExitIPL);
    RETURN;
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
  RESTORE(ExitIPL);
(*
  L_General.Error("  ப    ३ 室");
*)
  L_StdFrm.Inform("  ப    ३ 室");
 END {InsBySEJobs};

BEGIN
 L_Events.ExecuteHandler();
END.
