(*
%Copyright   (c) Polak Computer System
%Author      20.04.2000 11:37:30 BOR
%Purpose      室 ⮯  
%Type        report
%Specific    AP_PC
%Modified    10.04.2012 12:01:00 ROBOT by POLAK\LDA
%Environment MODE = 100 -  
%Environment MODE = 101 -    -
%Environment MODE = 102 -  ⥪饬 ࠦ  ⥪ 
%Environment MODE = 200 - ⠭ ⥪騩 
%Environment MODE = 201 - ⠭ ⥪   -
%Environment MODE = 202 - ⠭ ⥪騩 ࠦ
*)

 MODULE ExtClsFl;

 IMPORT L_XDoc, L_General, L_DatTim, L_OwnData, L_Way, L_MDoc, Math, Memo;

 PERMANENT VAR
  _RWayS   : LIKE(RWayS.RWayS);
  _MDocKind: LIKE(MDoc.MDocKind);
  _MDoc    : LIKE(MDoc.MDoc);
  _BoxNbr  : LIKE(Car.BoxNbr);
  _ExitClss: LIKE(StExit.ExitClss);

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
Car.BoxNbr, L, ""
Car.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
ExitClss.ExitClss, L, ""
ExitClss.Name, L, ""
@
###################################################### ########## #####
=#####=================================================================
|            室 ⮯    ##########           |
| ####  ########## ઠ ## ################################    |
| 室 ###### ################################################ |
}

$P{ LineExit:
StExit.Exit, L, ""
StExit.Name, L, ""
@
|=====================================================================|
|室 ######### ########################################             |
|---------------------------------------------------------------------|
|, 䨪                 |砫||  ஡|     ଠ|
}

$P{ LineSEJobs:
RoutMod.Modif, L, ""
RoutMod.Name, L, ""
SEJobs.StartT, L, "H:M"
SEJobs.StopT, L, "H:M"
?, R, "1."
?, R, "1."
@
|     ### ############################|#####|#####|########|##########|
}

$P{ LineRoute:
Route.Route, L, ""
Route.Name, L, ""
?, R, "1."
?, R, "1."
@
|#### ############################################|########|##########|
|-------------------------------------------------|--------|----------|
}

$P{ BotExit:
?, R, "1."
?, R, "1."
@
|⮣  室                                  |########|##########|
}

$P{ Bot:
@
=() Polak=============================================================
}
*)

 PRIVATE PROCEDURE StandOnRealizQuality();
 BEGIN
  SELECT(Quality, Quality);
  WHILE OCCURE(Quality) & (Quality.Type # L_Way.QualType_Realiz) DO
   NEXT(Quality);
  END;
 END {StandOnRealizQuality};

 PRIVATE PROCEDURE MakeRep(_Date: DATE);
  CONST
   RepName = "ExtFu";
  VAR
   _Route   : LIKE(Route.Route);
   _Run,
   Run_Exit,
   Run_Route: LIKE(StExit.Run);
   _FNorm,
   FNorm_Rt,
   FNorm_Ex : NUMERIC[3];
 BEGIN
  L_General.Assert(ACCESS(ExitClss), " ⠭ ⥪騩  室");
 
  StandOnRealizQuality();

  L_Way._PrepareFNorm(Car.BoxNbr, _Date);
 
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, _Date);
 
  SELECT(StExit, ExitClss, , ExitClss.ExitClss);
  WHILE OCCURE(StExit) DO
   PROMPT(StExit.Exit);
   SETZERO(FNorm_Ex, Run_Exit);
   IF ((StExit.Strict = L_Way.ExitStrict_Reg) |
       (StExit.Strict = L_Way.ExitStrict_Ord)) &
      L_DatTim.IsActive(_Date, StExit.FromD, StExit.UpDate) THEN
    MAKEPART(R, LineExit);
    SETEMPTY(_Route);
    CONFORM(StExit, SEJobs);
    WHILE OCCURE(SEJobs) DO
     CONFORM(SEJobs, Route, RoutMod, WJMode);
     IF !_Route | (SEJobs.Route # _Route) THEN
      _Route:=SEJobs.Route;
      SETZERO(FNorm_Rt, Run_Route);
     END;
     _Run  :=RoutMod.Run;
     _FNorm:=L_Way.CalcFN(_Date, SEJobs.StopT-SEJobs.StartT, _Run, 0, 0);
     INC(FNorm_Rt, _FNorm);
     INC(Run_Route, _Run);
     MAKEPART(R, LineSEJobs, _Run, _FNorm);
     NEXT(SEJobs);
     IF ~OCCURE(SEJobs) | (SEJobs.Route # _Route) THEN
      MAKEPART(R, LineRoute, Run_Route, FNorm_Rt);
      INC(FNorm_Ex, FNorm_Rt);
      INC(Run_Exit, Run_Route);
     END;
    END; (* WHILE OCCURE(SEJobs)... *)
    MAKEPART(R, BotExit, Run_Exit, FNorm_Ex);
   END;
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit)... *)

  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {MakeRep};

 PRIVATE PROCEDURE Do(Operation: SCAL[2];
              Object   : SCAL[3]);
  CONST
   opr_MakeRep  = 0;
   opr_SaveAttr = 1;
   obj_RWayS    = 0;
   obj_MDoc     = 1;
   obj_Car      = 2;
  VAR
   _Date: DATE;
 BEGIN
  IF    Object = obj_RWayS THEN
   IF Operation = opr_SaveAttr THEN
    L_General.Assert(ACCESS(RWayS), " ⠭ ⥪騩 ");
    _RWayS:=RWayS.RWayS;
   ELSE
    L_General.Assert(SEARCH(RWayS, RWayS, _RWayS),
                     " 㤠   "+_RWayS);
    CONFORM(RWayS, Car, Mark);
    _Date:=RWayS.Date;
   END;
  ELSIF Object = obj_MDoc THEN
   IF Operation = opr_SaveAttr THEN
    L_General.Assert(ACCESS(MDoc), " ⠭ ⥪騩 㬥");
    L_General.Assert(~!MDoc.BoxNbr, "室 㪠 ࠦ");
    _MDocKind:=MDoc.MDocKind;
    _MDoc    :=MDoc.MDoc;
    L_General.Assert(L_XDoc.ExtractXDocType(L_MDoc.curRefToXDoc_GetId()) = L_XDoc.xdt_RWayS,
                     " 믮 ");
    L_MDoc.curRefToXDoc_PositionOn(L_XDoc.xdt_RWayS);
    CONFORM(RWayS, ExitClss);
    _ExitClss:=ExitClss.ExitClss;
   ELSE
    L_General.Assert(SEARCH(MDoc, MDoc, _MDocKind, _MDoc),
                     " 㤠  㬥 "+_MDocKind+" "+_MDoc);
    CONFORM(MDoc, Car, Mark);
    _Date:=MDoc.Date;
   END;
  ELSIF Object = obj_Car THEN
   IF Operation = opr_SaveAttr THEN
    L_General.Assert(ACCESS(Car), " ⠭ ⥪   䠩 ");
    _BoxNbr:=Car.BoxNbr;
   ELSE
    L_General.Assert(SEARCH(Car, BoxNbr, _BoxNbr), " 㤠  ࠦ "+_BoxNbr);
    CONFORM(Car, Mark);
    _Date:=Memo.tmp_cd();
   END;
  ELSE
   L_General.BadMode(MODE);
  END;
  IF Operation = opr_MakeRep THEN
   MakeRep(_Date);
  END;
 END {Do};

 PRIVATE PROCEDURE GetOperation(): SCAL[2];
 BEGIN
  RETURN Math.Div(MODE, 200);
 END {GetOperation};

 PRIVATE PROCEDURE GetObject(): SCAL[10];
 BEGIN
  RETURN Math.Mod(MODE, 100);
 END {GetObject};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
 Do(GetOperation(), GetObject());
END.
