(*
%Copyright   (c) Polak IT
%Author      25.05.2012 11:38:58 POLAK\MLB
%Purpose
%Type        operation
%Specific    AP
%Modified    17.09.2014 13:50:45 POLAK\Bor
%Environment
*)

 IMPORT L_Events, L_ACL, L_StdFrm, L_WDO;

 PRIVATE PROCEDURE Country_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow(1, "CountryE");
  IF L_WDO.IsLoadableAskClone() & (L_WDO.iWindow().AskSourceField.Name # "CstDclr.Country") THEN
   L_WDO.iZone(1).PermanentFilter:="(Country.NotCntry=0)";
  ELSE
   L_WDO.iZone(1).PermanentFilter:="";
  END;
 END {Country_OnInitializeWindow};

 PRIVATE PROCEDURE CountryE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit, L_WDO.e_OnAfterInsert, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["Country.NotCntry"]);
  L_WDO.iMayBeEmpty  (0, ["Country.BegDate", "Country.EndDate"]);
  L_WDO.iProgs       (0, "Federal");
 END {CountryE_OnInitializeWindow};

 PRIVATE PROCEDURE Country_SetFieldsAlfaModifiable();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Country.Alfa2").Modifiable:=~Country.NotCntry;
  Fields("Country.Alfa3").Modifiable:=~Country.NotCntry;
 END {Country_SetFieldsAlfaModifiable};

 PRIVATE PROCEDURE Country_NotCntry_OnSuccessfulChange();
 BEGIN
  SETEMPTY(Country.Alfa2, Country.Alfa3);
  REPLACE(Country);
  Country_SetFieldsAlfaModifiable();
 END {Country_NotCntry_OnSuccessfulChange};

 PRIVATE PROCEDURE Country_OnReposition();
 BEGIN
  Country_SetFieldsAlfaModifiable();
 END {Country_OnReposition};

 PRIVATE PROCEDURE Country_OnAfterEdIns();
 BEGIN
  IF Country.NotCntry & (Country.Country < 950) THEN
   L_StdFrm.Question(" ଫ   ' ࠭'    950");
  END;
 END {Country_OnAfterEdIns};

 PRIVATE PROCEDURE Country_OnAfterEdit();
 BEGIN
  Country_OnAfterEdIns();
 END {Country_OnAfterEdit};

 PRIVATE PROCEDURE Country_OnAfterInsert();
 BEGIN
  Country_OnAfterEdIns();
 END {Country_OnAfterInsert};

BEGIN
 L_Events.ExecuteHandler();
END.