(*
%Copyright   (c) Polak Computer System
%Author      09.08.2010 13:59:31 POLAK\MLB
%Purpose      室 ⮯  ઠ, ⠬, ⥫
%Type        report
%Specific    AP
%Modified    19.04.2013 17:47:15 POLAK\MLB
%Environment
*)

 IMPORT L_bp, FIO, L_Basis, L_Way, Memo, L_DatTim, L_General, L_AFM, L_Car, D_Fl, L_Staff, L_Str;

 TYPE
  tReg     = SCAL[2];

 CONST
  r_ADD             = 0;
  r_CalcAmountRWayJ = 1;

  ot_TSN            = 0;
  ot_BoxNbr         = 1;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");

  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");

  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");

  L_Basis.wb_WrInQM(F, "ࠦ ");
  L_Basis.wb_WrInQM(F, "㤠⢥ ");

  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");

  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ॢ");

  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");

  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");

  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");

  L_Basis.wb_WrInQM(F, "ଠ");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "/");
  L_Basis.wb_WrInQM(F, " १ (/)  ⥫");
  L_Basis.wb_WrInQM(F, " १ (/)  ");

  L_Basis.wb_WrInQM(F, "騩 ஡");
  L_Basis.wb_WrInQM(F, "஡  ");
  L_Basis.wb_WrInQM(F, "஡  室");

  L_Basis.wb_WrInQM(F, "ᥣ 륧");
  L_Basis.wb_WrInQM(F, "륧  ");
  L_Basis.wb_WrInQM(F, "륧  室");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE SignOfRes(): STRING[1];
  VAR
   Result: STRING[1];
 BEGIN
  IF TmpRes.Over = 0 THEN
   Result:="0";
  ELSE
   Result:=L_Str.PoolItem("-|+",(TmpRes.Over > 0));
  END;
  RETURN Result;
 END {SignOfRes};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
  VAR
   Over: NUMERIC[2];
 BEGIN
  CONFORM(Fl002, RWayS);
  L_Basis.wb_WrScl(F, RWayS.RWayS);
  L_Basis.wb_WrDat(F, RWayS.Date);

  L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
  CONFORM(CarLog, Column);
  L_Basis.wb_WrScl(F, Column.Column);
  L_Basis.wb_WrStr(F, Column.Name);

  CONFORM(CarLog, Mark);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);

  L_Basis.wb_WrScl(F, CarLog.BoxNbr);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);

  CONFORM(Fl002, Route);
  L_Basis.wb_WrScl(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);

  CONFORM(Route, TKind);
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);

  CONFORM(RWayS, Staff);
  L_Staff.PosToStaffLog(Staff.TSN, RWayS.Date, 0);
  CONFORM(StaffLog, Officer, Sort);

  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());

  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);

  CONFORM(Staff, Man);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);

  L_Basis.wb_WrNum(F, Fl002.Norm, 2);
  L_Basis.wb_WrNum(F, Fl002.Fact, 2);

  Over:= Fl002.Norm - Fl002.Fact;
  L_Basis.wb_WrNum(F,  Over*(Over > 0), 2);
  L_Basis.wb_WrNum(F, -Over*(Over < 0), 2);
  L_Basis.wb_WrNum(F,  Over, 2);

  L_General.CallUs(SEARCH(TmpRes, ObjType, ot_TSN, Staff.TSN));
  L_Basis.wb_WrStr(F, SignOfRes());

  L_General.CallUs(SEARCH(TmpRes, ObjType, ot_BoxNbr, CarLog.BoxNbr));
  L_Basis.wb_WrStr(F, SignOfRes());

  L_Basis.wb_WrNum(F,  Fl002.Run, 2);
  L_Basis.wb_WrNum(F,  Fl002.Run*(Over > 0), 2);
  L_Basis.wb_WrNum(F,  Fl002.Run*(Over < 0), 2);

  L_Basis.wb_WrNum(F,  Fl002.AmnTot, 9);
  L_Basis.wb_WrNum(F,  (Over > 0)*Fl002.AmnTot, 9);
  L_Basis.wb_WrNum(F,  (Over < 0)*Fl002.AmnTot, 9);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE Create_Fl002();
 BEGIN
  CreateFILE(Fl002, "", "", "");

  CreateFIELD(Fl002, RWayS,    LIKE(RWayS.RWayS),   "", "", "", "", "");
  CreateFIELD(Fl002, Route,    LIKE(Route.Route),   "", "", "", "", "");
  CreateFIELD(Fl002, Norm,     NUMERIC[4],          "", "", "", "", "");
  CreateFIELD(Fl002, Fact,     NUMERIC[4],          "", "", "", "", "");
  CreateFIELD(Fl002, Run,      NUMERIC[4],          "", "", "", "", "");
  CreateFIELD(Fl002, AmnTot,   NUMERIC[9],          "", "0", "", "- ", "");

  CreateINDEXandLINK(Fl002, RWaySRoute, UNIQUE, RWayS, RWayS,  USER, "", "", RWayS, Route);
  CreateINDEXandLINK(Fl002, Route,      PLURAL, Route, Route,  USER, "", "", Route);

  SetVersionOfFILE(Fl002, 0001);
  L_AFM.AF_CreateTemp("Fl002", "Fl002");
 END {Create_Fl002};

 PRIVATE PROCEDURE OneRWayS(Reg: tReg): NUMERIC[0];
  VAR
   RWayJAmount: NUMERIC[0];
 BEGIN
  IF Reg = r_ADD THEN
   RWayJAmount:=OneRWayS(r_CalcAmountRWayJ);
   ADD(TmpRes, ObjType, , ot_TSN, RWayS.TSN,
                          TmpRes.Over, RWayS.FuelNorm - RWayS.FuelFact);
   ADD(TmpRes, ObjType, , ot_BoxNbr, RWayS.BoxNbr,
                          TmpRes.Over, RWayS.FuelNorm - RWayS.FuelFact);
  ELSIF Reg = r_CalcAmountRWayJ THEN
   RWayJAmount:=0;
  ELSE
   L_General.CallUs(0);
  END;
  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayJ) DO
   PROMPT("ઠ " + RWayS.RWayS  + " " + L_DatTim.DateStr(RWayS.Date) + " : ३ "+RWayJ.Trip);
   CONFORM(RWayJ, Quality);
   CONFORM(RWayJ, SEJobs);
   IF Quality.Type # L_Way.QualType_Annul THEN
    IF Reg = r_ADD THEN
     ADD(Fl002, RWaySRoute, , RWayS.RWayS, SEJobs.Route,
                              Fl002.Norm,   RWayJ.FNorm,
                              Fl002.Fact,   D_Fl.TrFFact(),
                              Fl002.Run,    RWayJ.Run * RWayJ.Fact,
                              Fl002.AmnTot, 1 / RWayJAmount);
    ELSE
     INC(RWayJAmount);
    END;
   END;
   NEXT(RWayJ);
  END; (* WHILE... *)
  RETURN RWayJAmount;
 END {OneRWayS};

 PRIVATE PROCEDURE Fl002();

  CONST
   bpId = "FL002";

  VAR
   Dummy: NUMERIC[0];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, "饭  /室 ⮯", L_bp.t_Basis, L_General.timeCond_InIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");

  Create_Fl002();
  L_AFM.MakeMultipleIndex("TmpRes", "ObjType: SCAL[2];"+
                                    "Obj: SCAL[1E5];"+
                                    "Over: NUMERIC[2]",
                           "ObjType: ObjType, Obj");

  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   PROMPT("ઠ " + RWayS.RWayS  + " " + L_DatTim.DateStr(RWayS.Date));
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   CONFORM(CarLog, Mark);
   IF ~Mark.Electric THEN
    Dummy:=OneRWayS(r_ADD);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  SELECT(Fl002, RWaySRoute);
  WHILE OCCURE(Fl002) DO
   PROMPT("㧪 " + Fl002.RWayS  + " " + Fl002.Route);
   MakePart("R");
   NEXT(Fl002);
  END; (* WHILE OCCURE(Fl002) ... *)

  FIO.Close(R);
  L_bp.End();
 END {Fl002};

END.

