(*
%Copyright   (c) Polak Computer System
%Author      14.03.2000 19:51:59 GINA
%Purpose      ⮯  100   ⠬  ઠ
%Type        report
%Specific    AP_PC
%Modified    18.09.2012 15:36:08 POLAK\Gina
%Environment
*)

 MODULE Fl005 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, P_OwnData, L_Basis, FIO, Memo, L_DatTim, L_Way,
        P_Route, P_Firm, P_Mark, L_bp;

 PRIVATE PROCEDURE MakeTop(wMyFirm: SCAL[2]);
 BEGIN
  IF wMyFirm THEN
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
  END;
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "ઠ");
  L_Basis.wb_WrStr("F", "");(* ଠ*)
  L_Basis.wb_WrStr("F", "");(* ଠ*)
  L_Basis.wb_WrStr("F", "");(*ᯮ⭠ ଠ*)

  L_Basis.wb_WrStr("F", " ࠢ");
  L_Basis.wb_WrStr("F", "ࠢ  ");
  L_Basis.wb_WrStr("F", " ॢ");
  L_Basis.wb_WrStr("F", " ॢ");
  L_Basis.wb_TermLine("F");
 END {MakeTop};
 
 PRIVATE PROCEDURE MakeLine(wMyFirm: SCAL[2];
                            MarkFConRun,
                            BaseNorm,
                            CurNorm : L_Way.tFuelNorms;
                            CommonCorr,
                            MarkCorr: NUMERIC[3]);
 BEGIN
  IF wMyFirm THEN
   L_Basis.wb_WrScl("F", MyFirm.MyFirm);
   L_Basis.wb_WrStr("F", MyFirm.vzSign);
  END;
  L_Basis.wb_WrStr("F", Route.Route);
  L_Basis.wb_WrStr("F", L_Basis.ExclQM(Route.Name));
  L_Basis.wb_WrStr("F", Mark.Mark + " " + L_Basis.ExclQM(Mark.Name));
  L_Basis.wb_WrNum("F", BaseNorm, 2);
  L_Basis.wb_WrNum("F", CurNorm, 2);
  L_Basis.wb_WrNum("F", MarkFConRun, 2);

  L_Basis.wb_WrNum("F", CommonCorr, 3);
  L_Basis.wb_WrNum("F", MarkCorr, 3);
  L_Basis.wb_WrScl("F", TKind.TKind);
  L_Basis.wb_WrStr("F", L_Basis.ExclQM(TKind.Name));
  L_Basis.wb_TermLine("F");
 END {MakeLine};

 PRIVATE PROCEDURE HasCommonFCorMove(D: DATE): SCAL[2];
  VAR
   MF       : LIKE(MyFirm.MyFirm)[P_OwnData.fnc_Amount];
   FNC_Move,
   FNC_Heat,
   FNC_Warm : NUMERIC[3][P_OwnData.fnc_Amount];
 BEGIN
  IF ~P_Firm.E_wMultipleMyFirm(D) THEN
   RETURN 1;
  END;
  P_OwnData.Decode_FuelNormCorrection(P_OwnData.GetOwnDProStrong(D, P_OwnData.P_FuelNormCorrection), MF, FNC_Move, FNC_Heat, FNC_Warm);
  RETURN !MF[0];
 END {HasCommonFCorMove};

 PRIVATE PROCEDURE Make(D: DATE; CommonCorr: NUMERIC[3]; wMyFirm: SCAL[2]);
  VAR
   _Norm,
   _CorrectedNorm,
   _FCM,
   _FMarkCMove,
   _FRouteCMove   : NUMERIC[3];
   at100km        : LIKE(RWayJ.FNorm);
   _MarkFNConRun,
   _MarkFNAlFRun  : L_Way.tFuelNorms;
 BEGIN
  SELECT(Mark,Mark);
  WHILE OCCURE(Mark) DO
   PROMPT("ઠ " + Mark.Mark);
   IF L_DatTim.IsActive(D, Mark.Begin, Mark.Till) & ~Mark.AsFact & Mark.use_Self THEN
    _MarkFNConRun:=P_Mark.GetP_FConRun(Mark.Mark, D);
    _MarkFNAlFRun:=P_Mark.GetP_AlFRun(Mark.Mark, D);
    SELECT(Route, Route);
    WHILE OCCURE(Route) DO
     PROMPT("ઠ " + Mark.Mark + "  " + Route.Route);
     IF L_DatTim.IsActive(D, Route.Begin, Route.Till) THEN
      SETEMPTY(_Norm);
      _FMarkCMove:=P_Mark.Get_MarkFuelCor_Move(Mark.Mark, D);
      _FCM       :=CommonCorr;
      IF L_Way.E_GettingRouteFuelNormManner(D) = 0 THEN
       SELECT(MRFlNorm, Mark, , Mark.Mark, Route.Route);
       IF SRCINSEL(MRFlNorm, LE, D) & (D < MRFlNorm.Till) THEN
        _Norm:=MRFlNorm.Norm;
       END;
      ELSE
       IF L_Way.E_FuelMoveNormAsCfcSum(D) THEN
        _Norm:=_MarkFNAlFRun;
       ELSE
        IF P_Route.HasActualRoutePro(Route.Route, D, P_Route.P_FuelNormCoef) THEN
         _Norm:=_MarkFNAlFRun * (1 + STRTOFLD(RoutePro.Value, NUMERIC)/100);
        END;
       END;
      END;
      IF ~!_Norm THEN
       DEC(_FCM);
       IF L_Way.E_FuelMoveNormAsCfcSum(D) THEN
(*
        L_General.CallUs((L_Way.E_GettingRouteFuelNormManner(D) # 0) & ~L_Way.E_ApplyCorrectionToBaseFuelNorm(D));
*)
        IF P_Route.HasActualRoutePro(Route.Route, D, P_Route.P_FuelNormCoef) THEN
         _FRouteCMove:=STRTOFLD(RoutePro.Value, NUMERIC)/100;
        ELSE
         _FRouteCMove:=0;
        END;
        at100km:=_Norm;
        _CorrectedNorm:=(1               +
                         _FCM            +
                         _FRouteCMove    +
                         (_FMarkCMove -1)) * at100km;
       ELSE
        IF L_Way.E_ApplyCorrectionToBaseFuelNorm(D) THEN
         at100km:=_Norm + _MarkFNConRun * _FCM;
        ELSE
         at100km:=_Norm * (1 + _FCM);
        END;
        _CorrectedNorm:= _FMarkCMove * at100km;
       END; (* IF E_FuelMoveNormAsCfcSum(D) ...*)
       L_Way.StandOnRouteTKind(D);
       MakeLine(wMyFirm, _MarkFNConRun, _Norm, _CorrectedNorm, CommonCorr, _FMarkCMove);
      END;
     END;
     NEXT(Route);
    END; (* WHILE OCCURE(Route) ... *)
   END;
   NEXT(Mark);
  END;  (* WHILE OCCURE(Mark)... *)
 END {Make};

 PUBLIC PROCEDURE Fl005();
  CONST
   bpId="FL005";
  VAR
   D: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  D:=Memo.ud_cd();
  L_bp.Begin(bpId, " ⮯  ⠬", L_bp.t_Basis, L_General.timeCond_OnDate);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  IF HasCommonFCorMove(D) THEN
   MakeTop(0);
   Make(D, P_OwnData.FCorMove(D, ""), 0);
  ELSE
   MakeTop(1);
   SELECT(MyFirm, MyFirm);

   WHILE OCCURE(MyFirm) DO
    IF (MyFirm.MyFirm # P_Firm.mf_Fict) & L_DatTim.IsActive(D, MyFirm.Begin, MyFirm.Till) THEN
     Make(D, P_OwnData.FCorMove(D, MyFirm.MyFirm), 1);
    END;
    NEXT(MyFirm);
   END; (* WHILE OCCURE(MyFirm) ... *)

  END;
  FIO.Close(F);
  L_bp.End();
 END {Fl005};

END.
