(*
%Copyright   (c) Polak Computer System
%Author      14.09.2000 12:56:43 RSN
%Purpose      ⮯  室  ઠ
%Type        report
%Specific    AP_PC
%Modified    13.03.2013 18:34:15 POLAK\GAV
%Environment
*)

 MODULE Fl006 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_Basis, L_AFM, L_Way, Str, P_Route,
        L_DatTim, L_Car, P_Mark, Memo, P_OwnData, P_Firm, FIO, L_bp;

 PRIVATE PROCEDURE Create_FL();
 BEGIN
  CreateFILE(_FL, "", " ⮯", "");

  CreateFIELD(_FL, Exit,  LIKE(StExit.Exit), "", "", "", "室",   "");
  CreateFIELD(_FL, Route, LIKE(Route.Route), "", "", "", "", "");
  CreateFIELD(_FL, Mark,  LIKE(Mark.Mark),   "", "", "", "ઠ",   "");
  CreateFIELD(_FL, Run,   NUMERIC[2],        "", "", "", "஡",  "");
  CreateFIELD(_FL, Norm,  NUMERIC[3],        "", "", "", "ଠ",   "");

  CreateINDEXandLINK(_FL, Exit,  UNIQUE, StExit, Exit,  BORROW, "", "", Exit, Route, Mark);
  CreateINDEXandLINK(_FL, Route, PLURAL, Route,  Route, USER,   "", "", Route);
  CreateINDEXandLINK(_FL, Mark,  PLURAL, Mark,   Mark,  USER,   "", "", Mark);

  SetVersionOfFILE(_FL, 0);
  L_AFM.CreateTemp("_FL");
 END {Create_FL};

 PRIVATE PROCEDURE PutInFile(_Mark: LIKE(Mark.Mark); _Norm: LIKE(RWayJ.FNorm));
 BEGIN
  ADD(_FL, Exit, , SEJobs.Exit, SEJobs.Route, _Mark,
                  _FL.Run,  RoutMod.Run,
                  _FL.Norm, _Norm);
 END {PutInFile};

 PRIVATE PROCEDURE MarkHasCommonPrpCar(D: DATE; _Mark: LIKE(Mark.Mark)): SCAL[2];
 BEGIN
  SELECT(Car, Mark, , _Mark);
  WHILE OCCURE(Car) DO
   L_Car.StandOnCarLog(Car.BoxNbr, D);
   IF CarLog.Purpose = L_Car.purp_Common THEN
    RETURN 1;
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car)...*)
  RETURN 0;
 END {MarkHasCommonPrpCar};

 PRIVATE PROCEDURE Excel_MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrStr(F, " 室");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "室");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "஡");
  L_Basis.wb_WrStr(F, "⢍");
  L_Basis.wb_WrStr(F, "ઠ");
  L_Basis.wb_WrStr(F, "ઠ");
  L_Basis.wb_WrStr(F, " ॢ");
  L_Basis.wb_WrStr(F, " ॢ");
  L_Basis.wb_TermLine(F);
 END {Excel_MakeHeader};

 PRIVATE PROCEDURE Excel_MakeLine(F: STRING[]; _ExRun: NUMERIC[2]; _ExNorm: NUMERIC[3]);
 BEGIN
  L_Basis.wb_WrStr(F, ExitClss.Sign);
  L_Basis.wb_WrScl(F, StExit.Change);
  L_Basis.wb_WrStr(F, L_Way.StExitOnDaysAsStr());
  L_Basis.wb_WrScl(F, StExit.Exit);
  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrStr(F, L_Basis.ExclQM(Route.Name));
  L_Basis.wb_WrNum(F, _ExRun, 2);
  L_Basis.wb_WrNum(F, _ExNorm, 3);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, L_Basis.ExclQM(Mark.Name));
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, L_Basis.ExclQM(TKind.Name));
  L_Basis.wb_TermLine(F);
 END {Excel_MakeLine};

 PUBLIC PROCEDURE Fl006();
  CONST
   bpId = "FL006";
  VAR
   _FCM,
   Norm_wFCM,
   _ExNorm   : NUMERIC[3];
   _ExRun    : NUMERIC[2];
   _Sort     : LIKE(Sort.Sort);
   D         : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  D:=Memo.ud_cd();
  L_bp.Begin(bpId, " ⮯  室", L_bp.t_Basis, L_General.timeCond_OnDate);

  Create_FL();

  L_AFM.MakeIndex("_Mark", "Mark   : LIKE(Mark.Mark);"+
                           "AlFRun : "+TYPENAMEOF(L_Way.tFuelNorms)+";"+
                           "FConRun: "+TYPENAMEOF(L_Way.tFuelNorms));

  IF L_Way.E_GettingRouteFuelNormManner(D) THEN
   SELECT(Mark, Mark);
   WHILE OCCURE(Mark) DO
    IF L_DatTim.IsActive(D, Mark.Begin, Mark.Till) & MarkHasCommonPrpCar(D, Mark.Mark) THEN
     _Mark.Mark   :=Mark.Mark;
     _Mark.AlFRun :=P_Mark.GetP_AlFRun(Mark.Mark, D);
     _Mark.FConRun:=P_Mark.GetP_FConRun(Mark.Mark, D);
     INSERT(_Mark);
    END;
    NEXT(Mark);
   END; (* WHILE OCCURE(Mark)...*)
  END;
 
  SELECT(StExit, Exit);
  WHILE OCCURE(StExit) DO
   IF (StExit.Strict = L_Way.ExitStrict_Reg) &
      (L_Way._CheckExitOnDate(StExit.Exit, D) < 2) THEN

    _Sort:=L_Way.E_GetFixedSortOfExit(StExit.Exit, D, L_Way.rwswho_Driver);
    IF !_Sort THEN
     _FCM:=P_OwnData.FCorMove(D, P_Firm.mf_Own);
    ELSE
     L_General.Assert(SEARCH(Sort, Sort, _Sort), "  ᥪ " + _Sort);
     _FCM:=P_OwnData.FCorMove(D, Sort.MyFirm);
    END;

    SELECT(SEJobs, Exit, , StExit.Exit);
    WHILE OCCURE(SEJobs) DO
     PROMPT(StExit.Exit + " : "+ SEJobs.Trip);
     CONFORM(SEJobs, WJMode);
     IF WJMode.RunSel # 0 THEN
      CONFORM(SEJobs, RoutMod);
      IF L_Way.E_GettingRouteFuelNormManner(D) THEN
       IF P_Route.HasActualRoutePro(SEJobs.Route, D, P_Route.P_FuelNormCoef) THEN
        SELECT(_Mark, _Mark);
        WHILE OCCURE(_Mark) DO
         IF L_Way.E_ApplyCorrectionToBaseFuelNorm(D) THEN
          Norm_wFCM:=_Mark.AlFRun + _Mark.FConRun * (_FCM-1);
         ELSE
          Norm_wFCM:=_Mark.AlFRun * _FCM;
         END;
         PutInFile(_Mark.Mark,
                   Norm_wFCM * P_Mark.Get_MarkFuelCor_Move(_Mark.Mark, D) * (1 + STRTOFLD(RoutePro.Value, NUMERIC) / 100) *
                   RoutMod.Run / 100);
         NEXT(_Mark);
        END; (* WHILE OCCURE(_Mark) ... *)
       END;
      ELSE
       SELECT(MRFlNorm, Route, , SEJobs.Route);
       WHILE OCCURE(MRFlNorm) DO
        CHANGESEL(MRFlNorm, Route, , SEJobs.Route, MRFlNorm.Mark);
        CONFORM(MRFlNorm, Mark);
        IF L_DatTim.IsActive(D, Mark.Begin, Mark.Till) &
           SRCINSEL(MRFlNorm, LE, D) & (D < MRFlNorm.Till) THEN
         IF L_Way.E_ApplyCorrectionToBaseFuelNorm(D) THEN
          Norm_wFCM:=MRFlNorm.Norm + P_Mark.GetP_FConRun(Mark.Mark, D) * (_FCM-1);
         ELSE
          Norm_wFCM:=MRFlNorm.Norm * _FCM;
         END;
         PutInFile(MRFlNorm.Mark,
                   Norm_wFCM * P_Mark.Get_MarkFuelCor_Move(MRFlNorm.Mark, D) * RoutMod.Run / 100);
        END;
        LAST(MRFlNorm);
        CHANGESEL(MRFlNorm, Route, , SEJobs.Route);
        NEXT(MRFlNorm);
       END; (* WHILE OCCURE(MRFlNorm) ... *)
      END;
     END;
     NEXT(SEJobs);
    END; (* WHILE OCCURE(SEJobs) ... *)
   END;
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit) ... *)

  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  Excel_MakeHeader("F");
  SELECT(_FL, Exit);
  WHILE OCCURE(_FL) DO
   PROMPT(" " + _FL.Exit);
   CHANGESEL(_FL, Exit, , _FL.Exit, _FL.Route, _FL.Mark);
   SETZERO(_ExRun, _ExNorm);
   WHILE OCCURE(_FL) DO
    _ExRun :=_ExRun  + _FL.Run;
    _ExNorm:=_ExNorm + _FL.Norm;
    NEXT(_FL);
   END;
   LAST(_FL);
   CONFORM(_FL, StExit, ExitClss);
   CONFORM(_FL, Mark);
   CONFORM(_FL, Route);
   L_Way.StandOnRouteTKind(D);

   Excel_MakeLine("F", _ExRun, _ExNorm);

   CHANGESEL(_FL, Exit);
   NEXT(_FL);
  END; (* WHILE OCCURE(_FL) ... *)
  L_AFM.AF_PurgeTemp("_FL");
  L_AFM.AF_PurgeTemp("_Mark");

  FIO.Close(F);
  L_bp.End();
 END {Fl006};

END.
