(*
%Copyright   (c) Polak IT
%Author      13.11.2006 13:04:33 POLAK\Bor
%Purpose      /室
%Type        report
%Specific    AP
%Modified    09.07.2014 12:34:58 POLAK\Bor
%Environment
*)

 MODULE Fl007 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Basis, L_General, L_DatTim, L_PRoll, L_Car, L_Way, L_Fuel, L_AFM, L_AP, L_Staff,
        Math, FIO, E_Way, Memo, L_bp, L_StdFrm;

 VAR
  FullMonth : SCAL[2];

 PRIVATE PROCEDURE E_AbsurdRules(): SCAL[2];
 BEGIN
  RETURN L_General.GetAPSiteID() = "53";
 END {E_AbsurdRules};

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "祭");
  L_Basis.wb_WrInQM(F, " ⮯");
  L_Basis.wb_WrInQM(F, " ⮯");
  L_Basis.wb_WrInQM(F, "ଠ, ");
  L_Basis.wb_WrInQM(F, ", ");
  L_Basis.wb_WrInQM(F, "  ");
  L_Basis.wb_WrInQM(F, ", ");
  L_Basis.wb_WrInQM(F, "०, ");
  L_Basis.wb_WrInQM(F, "/, ");
  L_Basis.wb_WrInQM(F, ", ");
  L_Basis.wb_WrInQM(F, "०, ");
  L_Basis.wb_WrInQM(F, "/, ");
  IF E_AbsurdRules() THEN
   L_Basis.wb_WrInQM(F, "஡ ᥣ ( ९஡)");
   L_Basis.wb_WrInQM(F, "९஡");
   L_Basis.wb_WrInQM(F, "ଠ  ९஡, ");
   L_Basis.wb_WrInQM(F, "०  ९஡, ");
   L_Basis.wb_WrInQM(F, "⮣ /  ⮬ ९஡, ");

   L_Basis.wb_WrInQM(F, "ଠ, ");
   L_Basis.wb_WrInQM(F, ", ");
   L_Basis.wb_WrInQM(F, "   , ");
   L_Basis.wb_WrInQM(F, "   , ");
   L_Basis.wb_WrInQM(F, "   諮 , ");

   L_Basis.wb_WrInQM(F, "ঠ  ⥪饬 , ");
   L_Basis.wb_WrInQM(F, "   , ");
   L_Basis.wb_WrInQM(F, "  ⮬ , ");
   L_Basis.wb_WrInQM(F, " , ");
   L_Basis.wb_WrInQM(F, " १");
  END;
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]; byRWayS       : SCAL[2];
                                         Sign          : NUMERIC[0];
                                         _MarkG,
                                         _MarkGName    : STRING[];
                                         OverRunCfc    : FLOAT;
                                         OverRunForFuel: L_PRoll.tSum;
                                         _Run          : NUMERIC[3];
                                         _FNorm        : NUMERIC[4];
                                         _Price        : NUMERIC[2];
                                         _Norm,
                                         _Fact         : NUMERIC[4]);
  VAR
   _Over,
   _Econ: NUMERIC[4];
   _EconR: L_PRoll.tSum;
 BEGIN
  IF _Norm > _Fact THEN
   _Econ:=_Norm - _Fact;
   _Over:=0;
  ELSE
   _Over:=_Fact - _Norm;
   _Econ:=0;
  END;

  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  IF byRWayS THEN
   L_Basis.wb_WrScl(F, Car.BoxNbr);
   L_Basis.wb_WrScl(F, Car.StateNbr);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
   L_Basis.wb_WrStr(F, _MarkG);
   L_Basis.wb_WrStr(F, _MarkGName);
   L_Basis.wb_WrScl(F, RWayS.RWayS);
   L_Basis.wb_WrDat(F, RWayS.Date);
   L_Basis.wb_WrStr(F, FLDTOSTR(CarLog.Purpose, L_Car.purp_Pool));
   L_Basis.wb_WrScl(F, Math.Math);
   L_Basis.wb_WrStr(F, Math.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrDat(F, EMPTYOF(DATE));
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;

  L_Basis.wb_WrNum(F, _Norm, 4);
  L_Basis.wb_WrNum(F, _Fact, 4);
  L_Basis.wb_WrNum(F, _Price, 2);
  L_Basis.wb_WrNum(F, _Econ, 4);
  L_Basis.wb_WrNum(F, _Over, 4);
  L_Basis.wb_WrNum(F, _Norm-_Fact, 4);
  L_Basis.wb_WrNum(F, _Econ*_Price, 2);
  L_Basis.wb_WrNum(F, _Over*_Price, 2);
  L_Basis.wb_WrNum(F, (_Norm-_Fact)*_Price, 2);

  IF E_AbsurdRules() THEN
   IF byRWayS THEN
    L_Basis.wb_WrNum(F, _Run, 3);
    L_Basis.wb_WrNum(F, _Run*OverRunCfc, 3);
    L_Basis.wb_WrNum(F, _FNorm*OverRunCfc, 3);
    L_Basis.wb_WrNum(F, OverRunForFuel, 2);
    L_Basis.wb_WrNum(F, (_Norm-_Fact)*_Price-OverRunForFuel, 2);
    L_Basis.wb_WrNum(F, _Norm*_Price, 2);
    L_Basis.wb_WrNum(F, _Fact*_Price, 2);
    L_Basis.wb_WrNum(F, 0, 2);
    L_Basis.wb_WrNum(F, 0, 2);
    L_Basis.wb_WrNum(F, 0, 2);
    L_Basis.wb_WrNum(F, 0, 2);

    L_Basis.wb_WrNum(F, 0, 2);
    L_Basis.wb_WrNum(F, 0, 2);
    L_Basis.wb_WrNum(F, 0, 2);
   ELSE
    L_Basis.wb_WrNum(F, 0, 3);
    L_Basis.wb_WrNum(F, 0, 3);
    L_Basis.wb_WrNum(F, 0, 3);
    L_Basis.wb_WrNum(F, 0, 2);
    L_Basis.wb_WrNum(F, 0, 2);
    L_Basis.wb_WrNum(F, 0, 2);
    L_Basis.wb_WrNum(F, 0, 2);

    L_Basis.wb_WrNum(F, _Stf.Debt[2],  2);
    L_Basis.wb_WrNum(F, _Stf.Debt[1],  2);
    L_Basis.wb_WrNum(F, _Stf.Debt[0],  2);
    L_Basis.wb_WrNum(F, _Stf.Deducted, 2);

    _EconR:=_Stf.Econ-_Stf.OverRFFl-_Stf.Debt[0]+_Stf.Deducted;
    IF _EconR > 0 THEN
     L_Basis.wb_WrNum(F, 0, 2);
     L_Basis.wb_WrNum(F, _EconR, 2);
     L_Basis.wb_WrNum(F, Math.Min(_EconR, _Stf.Norm*0.10)*0.54, 2);
    ELSE
     L_Basis.wb_WrNum(F, -_EconR, 2);
     L_Basis.wb_WrNum(F, 0, 2);
     IF Sign < 0 THEN
      L_Basis.wb_WrNum(F, Math.Max(_Stf.Econ-_Stf.OverRFFl, _EconR), 2);
     ELSE
      L_Basis.wb_WrNum(F, 0, 2);
     END;
    END;
   END; (* IF byRWayS *)
   IF    Sign < 0 THEN
    L_Basis.wb_WrStr(F, "-");
   ELSIF Sign > 0 THEN
    L_Basis.wb_WrStr(F, "+");
   ELSE
    L_Basis.wb_WrStr(F, "0");
   END;
  END;
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE GetRWaySRun(): NUMERIC[3];
  VAR
   _Run: NUMERIC[3];
 BEGIN
  _Run:=0;
  CONFORM(RWayS, RWayJ);
  WHILE OCCURE(RWayJ) DO
   CONFORM(RWayJ, SEJobs);
   CONFORM(SEJobs, WJMode);
   CONFORM(RWayJ, Quality);
   IF WJMode.RunSel*Quality.Type > 0 THEN
    INC(_Run, RWayJ.Run * RWayJ.Fact);
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
  RETURN _Run;
 END {GetRWaySRun};

 PRIVATE PROCEDURE OneRWayS(Sign: NUMERIC[0]);
  VAR
   _Fact         : NUMERIC[4];
   _FuelFact     : NUMERIC[4];
   _MarkG        : LIKE(MarkG.MarkG);
   _MarkGName    : STRING[];
   OverRunCfc    : FLOAT;
   OverRunForFuel,
   Price         : L_PRoll.tSum;
  _Run           : NUMERIC[3];
  _FNorm         : NUMERIC[4];
 BEGIN
  PROMPT(L_DatTim.DateStr(RWayS.Date) + "  " + RWayS.RWayS);
  IF RWayS.ToPay THEN
   CONFORM(RWayS, Car);
   L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
 
   IF L_Way.StandOnMarkG_Soft(Mark.Mark, L_Way.mgt_Fuel) THEN
    _MarkG    :=MarkG.MarkG;
    _MarkGName:=MarkG.Name;
   ELSE
    SETEMPTY(_MarkG, _MarkGName);
   END;
 
   IF E_AbsurdRules() THEN
    OverRunCfc:=E_Way.GetOverRunCfc(E_Way.orck_Fuel);
   ELSE
    OverRunCfc:=0;
   END;
 
   CONFORM(RWayS, RWayF);
   WHILE OCCURE(RWayF) DO
    L_General.Assert(L_Fuel.AcsMarkFuel(RWayS.Date, Mark.Mark, RWayF.Math),
                     " ଠ樨  ⥯த " + RWayF.Math + "   " + Mark.Mark + "| " + L_DatTim.DateStr(RWayS.Date));
    IF MarkFuel.CntToPay=2(* *) THEN
     CONFORM(RWayF, Math);
     Price:=L_Fuel.PriceOfOver(RWayF.Math, RWayS.Date);
     IF E_AbsurdRules() THEN
      OverRunForFuel:=-E_Way.GetOverRunForFuel(OverRunCfc, _Run, _FNorm);
     ELSE
      OverRunForFuel:=0;
      _Run:=0;
      _FNorm:=0;
     END;
     IF ~!Sign THEN
      MakePart("R", 1, Sign, _MarkG, _MarkGName, OverRunCfc, OverRunForFuel, _Run, _FNorm, Price,
                    RWayF.Norm, L_Fuel._FuelFact());
     ELSE
      IF E_AbsurdRules() THEN
       ADD(_Stf, TSN, , RWayS.TSN, _Stf.Econ,     (RWayF.Norm-L_Fuel._FuelFact())*Price,
                                   _Stf.Norm,     RWayF.Norm*Price,
                                   _Stf.OverRFFl, OverRunForFuel);
      END;
     END;
    END;
    NEXT(RWayF);
   END; (* WHILE OCCURE(RWayF) ... *)
  END;
 END {OneRWayS};

 PRIVATE PROCEDURE HasMonthly(): SCAL[2];
  VAR
   Result: SCAL[2];
   i     : NUMERIC[0];
 BEGIN
  Result:=0;
  IF E_AbsurdRules() & FullMonth THEN
   L_PRoll.CheckSalDone(Memo.ud_fr());
   SELECT(Monthly, MtyIdx, , 41, Memo.ud_fr(), Staff.TSN);
   WHILE OCCURE(Monthly) DO
    IF (Monthly.Who = L_AP.mthlWho_Driver) THEN
     ADD(_Stf, TSN, , Staff.TSN,
         _Stf.Deducted, Monthly.Proof);
     Result:=1;
    END;
    NEXT(Monthly);
   END; (* WHILE OCCURE(Monthly) ... *)

   i:=1;
   WHILE i <= 3 DO
    SELECT(Monthly, MtyIdx, , 40, L_DatTim.IncMonth(Memo.ud_fr(), -i), Staff.TSN);
    WHILE OCCURE(Monthly) DO
     IF (Monthly.Who = L_AP.mthlWho_Driver) & (Monthly.Source = L_AP.mthlSrc_Sheet) THEN
      ADD(_Stf, TSN, , Staff.TSN,
          _Stf.Debt[i-1], Monthly.Proof);
      Result:=1;
     END;
     NEXT(Monthly);
    END; (* WHILE OCCURE(Monthly) ... *)
    INC(i);
   END;
  END;
  RETURN Result;
 END {HasMonthly};

 PRIVATE PROCEDURE OneStaff();
  VAR
   Sign: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("⭨ "+Staff.TSN);
  IF HasMonthly() | L_Staff.InStateInPer(Memo.ud_fr(), Memo.ud_ut()) THEN
   L_Staff.PosToStaffLog(Staff.TSN, Memo.ud_ut(), 0);
   CONFORM(StaffLog, Officer, Sort);
   CONFORM(Staff, Man);

   SETEMPTY(Sign);
   SELECT(RWayS, sTSN, , L_Way.rwsStat_Rated, Staff.TSN);
   SRCINSEL(RWayS, GE, , Memo.ud_fr());
   WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
    OneRWayS(Sign);
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
 
   Sign:=0;
   IF E_AbsurdRules() THEN
    IF SELECT(_Stf, TSN, Staff.TSN) THEN
     IF    (_Stf.Econ-_Stf.OverRFFl) > (_Stf.Debt[0]-_Stf.Deducted) THEN
      Sign:=+1;
     ELSIF (_Stf.Econ-_Stf.OverRFFl) < 0 THEN
      Sign:=-1;
     END;
    END;
   END;

   SRCINSEL(RWayS, GE, , Memo.ud_fr());
   WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
    OneRWayS(Sign);
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
 
   IF E_AbsurdRules() THEN
    IF SELECT(_Stf, TSN, Staff.TSN) THEN
     MakePart("R", 0, Sign, "---", "---", 0, 0, 0, 0, 0, 0, 0);
    END;
   END;
  END;
 END {OneStaff};

 PRIVATE PROCEDURE Create__Stf();
 BEGIN
  CreateFILE(_Stf, "", "", "");
  CreateFIELD(_Stf, TSN,      LIKE(Staff.TSN), "", "", "", "⭨", "");
  CreateFIELD(_Stf, Debt,     L_PRoll.tSum[4], "", "0", "", "", "");
  CreateFIELD(_Stf, Deducted, L_PRoll.tSum, "", "0", "", "ঠ  ⥪饬 ", "");
  CreateFIELD(_Stf, Econ,     NUMERIC[6], "", "0", "", "/०", "");
  CreateFIELD(_Stf, Norm,     NUMERIC[6], "", "0", "", "ଠ", "");
  CreateFIELD(_Stf, OverRFFl, L_PRoll.tSum, "", "0", "", "०  ९஡", "");

  CreateINDEX(_Stf, TSN, UNIQUE, "", "", TSN);

  SetVersionOfFILE(_Stf, 0);
 END {Create__Stf};

 PRIVATE PROCEDURE Prepare_Stf();
 BEGIN
  IF E_AbsurdRules() THEN
   IF (L_DatTim.DAY(Memo.ud_fr()) # 01) | (Memo.ud_ut() # L_DatTim.MonthEnd(Memo.ud_fr())) THEN
    L_StdFrm.Choice("    |ଠ   뢮  㤥");
    FullMonth:=0;
   ELSE
    FullMonth:=1;
   END;
   Create__Stf();
   L_AFM.AF_CreateTemp("_Stf", "_Stf");
  END;
 END {Prepare_Stf};

 PRIVATE PROCEDURE Purge_Stf();
 BEGIN
  IF E_AbsurdRules() THEN
   L_AFM.AF_PurgeTemp("_Stf");
  END;
 END {Purge_Stf};

 PUBLIC PROCEDURE Fl007_ByTSN();
  CONST
   bpId = "Fl007";
 BEGIN
  L_bp.Begin(bpId, " ⮢  ⥫ﬨ  室   ⮯", L_bp.t_Basis, L_General.timeCond_InIntvl);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Prepare_Stf();
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   OneStaff();
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  FIO.Close(R);
  Purge_Stf();
  L_bp.End();
 END {Fl007_ByTSN};

 PUBLIC PROCEDURE Fl007_ByCurStaff();
  CONST
   RepName = "Fl007";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Prepare_Stf();
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeHeader("R");
  L_General.Assert(ACCESS(Staff), " ࠭ ࠡ⭨");
  OneStaff();
  FIO.Close(R);
  Purge_Stf();
  L_Basis.PlayMakedRunTimeRep(RepName,
                              L_General.timeCond_InIntvl,
                              " ⮢  "+Staff.TSN+"  室   ⮯  ਮ",
                              0);
 END {Fl007_ByCurStaff};

END.