(*
%Copyright   (c) Polak Computer System
%Author      16.03.2001 19:11:15 SAN
%Purpose      室 ᫠  ਮ
%Type        report
%Specific    AP
%Modified    10.04.2012 12:01:40 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_Fuel, L_Basis, L_Car, P_Firm, FIO, Memo, L_Str, L_AFM, L_Env, L_DatTim, E_Way, DBD,
        P_Mark, L_bp, L_MathR;

 PRIVATE PROCEDURE MakeTop(F: STRING[]; wMF: SCAL[2]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrStr(F, "ઠ");
  L_Basis.wb_WrStr(F, "ઠ");
  L_Basis.wb_WrStr(F, "ࠦ");
  L_Basis.wb_WrStr(F, "᭮");
  L_Basis.wb_WrStr(F, " ⥯த");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "஡  ਮ");
  L_Basis.wb_WrStr(F, "⢮ ");
  L_Basis.wb_WrStr(F, "뤠  ");
  L_Basis.wb_WrStr(F, "뤠  ");
  L_Basis.wb_WrStr(F, "뤠");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE MakeLine(F: STRING[]; Run, TOAmount: NUMERIC[0]; wMF: SCAL[2]);
 BEGIN
  IF wMF THEN
   CONFORM(Column, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, Car.BoxNbr);
  L_Basis.wb_WrStr(F, Car.StateNbr);
  L_Basis.wb_WrStr(F, L_Fuel.GetInMixAsStr(FL008.InMix));
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrNum(F, Run, 0);
  L_Basis.wb_WrNum(F, TOAmount, 0);
  L_Basis.wb_WrNum(F, FL008.Fact[L_Fuel.mfrt_TO],      3);
  L_Basis.wb_WrNum(F, FL008.Fact[L_Fuel.mfrt_Add],     3);
  L_Basis.wb_WrNum(F, FL008.Fact[L_Fuel.mfrt_Unknown], 3);
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PRIVATE PROCEDURE E_IsTORepEvent(_RepEvent: LIKE(RepEvent.RepEvent)): SCAL[2];
  VAR
   Local : PROC;
   Result: SCAL[2];
 BEGIN
  Result:=0;
  Local:=PROCREF(E_Way.Fl008_IsTORepEvent);
  IF ~!Local THEN
   Result:=Local(CarEvn.RepEvent);
  ELSE
   TRY
    Result:=(CarEvn.RepEvent = E_Way.re_TO2);
   EXCEPT
   ON Exc: Exc_Root DO
    (*祣  *)
   END;
  END;
  RETURN Result;
 END {E_IsTORepEvent};

 PRIVATE PROCEDURE MakeRep(BPer, EPer: DATE);
  VAR
   Run,
   TOAmount: NUMERIC[0];
   TOFact,
   AddFact : NUMERIC[3];
   _InMix  : LIKE(MarkFuel.InMix);
   wMF     : SCAL[2];
 BEGIN
  wMF:=P_Firm.E_wMultipleMyFirm(EPer);
  MakeTop("R", wMF);
  SELECT(FL008, BoxNbr);
  WHILE OCCURE(FL008) DO
   NARROWSEL(FL008, BoxNbr);
   CONFORM(FL008, Car);
   PROMPT("⮢  "  + Car.BoxNbr);
   IF L_Car.StandOnCarLogSoft(Car.BoxNbr, EPer) THEN
    CONFORM(CarLog, Mark);
    CONFORM(CarLog, Column);
    SETZERO(TOAmount);
    SETSEL(CarEvn, BoxNbr, FL008.BoxNbr);
    SRCINSEL(CarEvn, GE, , BPer);
    WHILE OCCURE(CarEvn) & (CarEvn.StartD <= EPer) DO
     IF E_IsTORepEvent(CarEvn.RepEvent) THEN
      INC(TOAmount);
     END;
     NEXT(CarEvn);
    END; (* WHILE OCCURE(CarEvn) ... *)
 
    Run:=L_Car.GetAccurateRunInPer_Inc(FL008.BoxNbr, BPer, EPer);
 
    WHILE OCCURE(FL008) DO
     CONFORM(FL008, Math);
     MakeLine("R", Run, TOAmount, wMF);
     NEXT(FL008);
    END; (* WHILE OCCURE(FL008) ... *)
   END;
   NEXTINEXTENDEDSEL(FL008, BoxNbr);
  END; (* WHILE OCCURE(FL008) ... *)
 END {MakeRep};

 PRIVATE PROCEDURE Create_FL008();
 BEGIN
  CreateFILE(FL008, "", "뤠 ௮⮢  ࠦ", "");

  CreateFIELD(FL008, BoxNbr,   LIKE(Car.BoxNbr),      "", "",  "", "ࠦ", "");
  CreateFIELD(FL008, InMix,    LIKE(MarkFuel.InMix),  "", "",  "", " ⥯த", "");
  CreateFIELD(FL008, Math,     LIKE(Math.Math),       "", "",  "", "", "");
  CreateFIELD(FL008, Fact,     NUMERIC[3][3],         "", "0", "", "뤠", "");

  CreateINDEXandLINK(FL008, BoxNbr, UNIQUE, Car,   BoxNbr, USER, "", "", BoxNbr, InMix, Math);
  CreateINDEXandLINK(FL008, Math,   PLURAL, Math,  Math,   USER, "", "", Math);

  SetVersionOfFILE(FL008, 001);
  L_AFM.AF_CreateTemp("FL008", "FL008");
 END {Create_FL008};

 PUBLIC PROCEDURE Prepare_Fl008(BPer, EPer: DATE);
  VAR
   i      : NUMERIC[0];
   trgDate: DATE;
   TSNArr : L_Fuel.Arr;
   FactArr: NUMERIC[4][20];
 BEGIN
  Create_FL008();

  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) & L_Car.StandOnCarLogSoft(Car.BoxNbr, EPer) THEN
    CONFORM(CarLog, Mark);
    CONFORM(Mark, MarkFuel);
    WHILE OCCURE(MarkFuel) DO
     IF ((MarkFuel.InMix = L_Fuel.im_Tosol) | L_Fuel.IsAnyOil(MarkFuel.InMix)) &
        L_DatTim.IsActiveInIntvl_Inc(BPer, EPer, MarkFuel.Begin, L_DatTim.till2ED(MarkFuel.Till)) THEN
      L_MathR.AccessMath(MarkFuel.Math);
      IF L_DatTim.IsActiveInIntvl_Inc(BPer, EPer, Math.Begin, L_DatTim.till2ED(Math.Till)) THEN
       trgDate:=BPer;
       WHILE trgDate <= EPer DO
        PROMPT("ઠ  " + Mark.Mark + " " + Car.BoxNbr + " " + L_DatTim.DateStr(trgDate));
        FactArr:=L_Fuel.__GetFactByOilMath(Car.BoxNbr, MarkFuel.Math, trgDate, trgDate, TSNArr);
        i:=0;
        WHILE i <= HIGH(FactArr) DO
         IF FactArr[i] # 0 THEN
          ADD(FL008, BoxNbr, , Car.BoxNbr, MarkFuel.InMix, MarkFuel.Math,
              FL008.Fact[L_Fuel.GetMarkFuelReleaseType(trgDate, FactArr[i])], FactArr[i]);
         END;
         INC(i);
        END;
        INC(trgDate);
       END; (* WHILE trgDate ... *)
       IF ~SELECT(FL008, BoxNbr, Car.BoxNbr, MarkFuel.InMix, MarkFuel.Math) &
          (L_Car.CarIsInOperation(Car.BoxNbr, BPer) | L_Car.CarIsInOperation(Car.BoxNbr, EPer)) THEN
        ADD(FL008, BoxNbr, , Car.BoxNbr, MarkFuel.InMix, MarkFuel.Math,
            FL008.Fact[L_Fuel.mfrt_Unknown], 0);
       END;
      END;
     END;
     NEXT(MarkFuel);
    END; (* WHILE OCCURE(MarkFuel) ... *)
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {Prepare_Fl008};

 PRIVATE PROCEDURE Fl008();
  CONST
   bpId = "FL008";
  VAR
   BPer, EPer: DATE;
 BEGIN
  L_bp.Begin(bpId, " ᪠ ᬠ ਠ", L_bp.t_Basis, L_General.tc_inIntvl);
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  BPer:=Memo.ud_fr();
  EPer:=Memo.ud_ut();
  Prepare_Fl008(BPer, EPer);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeRep(BPer, EPer);
  FIO.Close(R);
  L_bp.End();
 END {Fl008};

END.
