(*
%Copyright   (c) Polak Computer System
%Author      27.08.2010 09:16:22 POLAK\MLB
%Purpose      室 ⮯  ઠ, ⠬, ⥫
%Type        report
%Specific    AP
%Modified    14.03.2013 11:39:50 POLAK\GAV
%Environment
*)

 MODULE Fl020 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_AFM, L_Car, L_Way, L_General, L_DatTim, L_SQL, D_Fl, L_Str, L_Fuel, Str,
        L_MSWStp, L_bp, L_RWayS, L_Events, L_XDoc;

 PRIVATE PROCEDURE Create_Fl020();
 BEGIN
  CreateFILE(Fl020, "", "", "");

  CreateFIELD(Fl020, RWayS, LIKE(RWayS.RWayS), "", "", "", "", "");
  CreateFIELD(Fl020, MathN, LIKE(Math.Name),   "", "", "", "", "");

  CreateFIELD(Fl020, FTake, NUMERIC[4],        "", "", "", "뤠 ⮯", "");
  CreateFIELD(Fl020, FNorm, NUMERIC[4],        "", "", "", "ଠ ⮯", "");
  CreateFIELD(Fl020, FFact, NUMERIC[4],        "", "", "", "室 ⮯", "");

  CreateINDEX(       Fl020, UniqMathN,  UNIQUE,                      "", "", RWayS, MathN);
  CreateINDEXandLINK(Fl020, RWayS,      PLURAL, RWayS, RWayS,  USER, "", "", RWayS);

  SetVersionOfFILE(Fl020, 0001);
  L_AFM.AF_CreateTemp("Fl020", "Fl020");
 END {Create_Fl020};

 PRIVATE PROCEDURE PutSomeRWaysTo_Fl020(trgBegin, trgTill: DATE): SCAL[2];
  VAR
   fullRFFact,
   fullRJFact: NUMERIC[4];
 BEGIN
  IF SELECT(Fl020, RWayS) THEN
   REMSEL(Fl020);
  END;
  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated);
  SRCINSEL(RWayS, GE, , trgBegin);
  WHILE OCCURE(RWayS) & (RWayS.Date <= trgTill) DO
   PROMPT(L_DatTim.DateStr(RWayS.Date) + ",  " + RWayS.RWayS);
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   CONFORM(CarLog, Mark);
   IF ~Mark.Electric THEN
    SETZERO(fullRFFact, fullRJFact);
    SELECT(RWayF, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayF) DO
     CONFORM(CarLog, Car);
     IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) THEN
      SAVE(RWayF);
      IF !RWayF.Norm THEN
       TRY
        CALL(RWayS, L_Events.md_StreamMakeDone);
       EXCEPT
       ON Exc: Exc_Root DO
        RESTORE(RWayF);
        RETURN 0;
       END;
      END;
      RESTORE(RWayF);
      ADD(Fl020, UniqMathN, , RWayS.RWayS, L_Fuel.GetFuelName(RWayF.Math),
                              Fl020.FTake, RWayF.FuelTake,
                              Fl020.FNorm, RWayF.Norm,
                              Fl020.FFact, L_Fuel._FuelFact());
      INC(fullRFFact, L_Fuel._FuelFact());
     END; (* IF L_Fuel.IsFuelInMixOnDate *)
     NEXT(RWayF);
    END; (* WHILE OCCURE(RWayF) ... *)
   END; (* IF ~Mark.Electric *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  RETURN 1;
 END {PutSomeRWaysTo_Fl020};

 CONST
  fn_ModifiedDTS = "६_⠬";

 PRIVATE PROCEDURE Z0002_PutInSQL(trgAPId: SCAL[1E4]; DTS: FLOAT);
 BEGIN
  L_SQL.Insert();

  L_SQL.WrInt("APId",            trgAPId);
  L_SQL.WrDTS(fn_ModifiedDTS,    DTS);
  L_SQL.WrInt("⥢_",    RWayS.RWayS);
  L_SQL.WrDat("",            RWayS.Date);
  L_SQL.WrDat("ਮ",          L_DatTim.Per(RWayS.Date));
  IF ~!Fl020.MathN THEN
   L_SQL.WrStr("", Fl020.MathN);
   L_SQL.WrNum("뤠_", Fl020.FTake);
   L_SQL.WrNum("ଠ_",  Fl020.FNorm);
   L_SQL.WrNum("室_", Fl020.FFact);
  END;
  L_SQL.WrStr("_",       CarLog.BoxNbr);
  L_SQL.WrStr("_",       CarLog.StateNbr);
  L_SQL.WrStr("ઠ",          Mark.Mark);
  L_SQL.WrStr("ઠ",           Mark.Name);
  IF ~!L_Way.GetMarkG(Mark.Mark, L_Way.mgt_TEP) THEN
   SEARCH(MarkG, MarkG, ,        L_Way.GetMarkG(Mark.Mark, L_Way.mgt_TEP));
   L_SQL.WrStr("㯯ப",    MarkG.Name);
  END;
  L_SQL.WrStr("_",       Staff.TSN);
  L_SQL.WrStr("",             Man.Name);

  L_SQL.UpdateRecordSet(0);
 END {Z0002_PutInSQL};

 PRIVATE PROCEDURE Z0002_Do(trgBegin, trgTill: DATE; force: SCAL[2]);
  VAR
   _Firm        : STRING[3];
   trgAPId      : SCAL[1E4];
   sqlConnection: OBJECT;
   sqlStr       : STRING[];
   D            : DATE;
   CntExc       : SCAL[1E2];
   curDTS       : FLOAT;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  Create_Fl020();
  SETEMPTY(sqlConnection, trgAPId);
  CntExc:=0;

  LOOP
   TRY
    IF !sqlConnection THEN
     PROMPT("  ࢥ஬ ᡮ ");
     sqlConnection:=L_SQL.ConnectToMTASQLServer();
     IF !trgAPId THEN
      L_SQL.GetFirmFromSQLServer(sqlConnection, trgAPId);
     END;
    ELSE
     EXIT;
    END;
    D:=trgBegin;
    WHILE D<=trgTill DO
     PROMPT(L_DatTim.DateStr(D));
     sqlStr:="SELECT * FROM Fl020 WHERE APId=" + L_Str.IntStr(trgAPId) + " AND =CONVERT(DATETIME, '" + L_DatTim.DateStr(D) + "', 104) FOR UPDATE";
     L_SQL.OpenRecordSet(sqlConnection, sqlStr);
     IF ~L_SQL.Occure() | force |
        (L_SQL.slqRecordSet.Fields(fn_ModifiedDTS).Value < L_DatTim.TS2FL(L_XDoc.GetLastMdfTime_TheDay(L_XDoc.xdt_RWayS, D))) THEN
      IF PutSomeRWaysTo_Fl020(D, D) THEN
       TRY
        sqlConnection.BeginTrans();
        sqlStr:="DELETE FROM Fl020 WHERE (APId=" + trgAPId + ") AND (=CONVERT(DATETIME, '" + L_DatTim.DateStr(D) + "', 104))";
        L_SQL.OpenRecordSet(sqlConnection, sqlStr);
        sqlConnection.CommitTrans();
       EXCEPT
       ON Exc:Exc_Root DO
        sqlConnection.RollbackTrans();
        RAISE();
       END;
       TRY
        VARIANTSYSDATE(curDTS);
        sqlConnection.BeginTrans();
        sqlStr:="SELECT * FROM Fl020 WHERE APId=" + L_Str.IntStr(trgAPId) + " AND =CONVERT(DATETIME, '" + L_DatTim.DateStr(D) + "', 104) FOR UPDATE";
        L_SQL.OpenRecordSet(sqlConnection, sqlStr);
     
        SELECT(Fl020, RWayS);
        WHILE OCCURE(Fl020) DO
         PROMPT(L_DatTim.DateStr(D) + ", 㧪  SQL  " + Fl020.RWayS);
         CONFORM(Fl020, RWayS);
         L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
         CONFORM(CarLog, Mark);
         CONFORM(RWayS, Staff, Man);
         Z0002_PutInSQL(trgAPId, curDTS);
         NEXT(Fl020);
        END; (* WHILE OCCURE(Fl020) ... *)
        sqlConnection.CommitTrans();
       EXCEPT
       ON Exc:Exc_Root DO
        sqlConnection.RollbackTrans();
        RAISE();
       END;
      END; (* IF PutSomeRWaysTo_Fl020(D, D) ... *)
     END; (* IF ~L_SQL.Occure | force ... *)
     INC(D);
    END; (* WHILE D<= ... *)
   EXCEPT
   ON Exc:Exc_Object DO
    IF ((L_MSWStp.ScodeCode(Exc.ErrorCode) = 3633) | ((L_MSWStp.ScodeCode(Exc.ErrorCode) = -1))) & (CntExc < 5) THEN
     INC(CntExc);
     SETEMPTY(sqlConnection);
     SLEEP(10);
    ELSE
     RAISE();
    END;
   END; (* TRY ... *)
  END; (* LOOP ... *)
 END {Z0002_Do};

 PUBLIC PROCEDURE Z0002_CheckNecessity(VAR Result: SCAL[2]; VAR nextRun: TIMESTAMP);
  VAR
   begD,
   endD: DATE;
 BEGIN
  L_RWayS.GetDaemonBoundaries(begD, endD);
  Result:=L_bp.GetLastSelfExecutionTime() < L_RWayS.GetLastMdfTime_RatedRWayS(endD);
  nextRun:=SYSTIMESTAMP() + 3/24;
 END {Z0002_CheckNecessity};

 PRIVATE PROCEDURE Z0002_Daemon();
  VAR
   begD,
   endD: DATE;
 BEGIN
  L_RWayS.GetDaemonBoundaries(begD, endD);
  Z0002_Do(begD, endD, 0);
 END {Z0002_Daemon};

 PUBLIC PROCEDURE Z0002();
  CONST
   bpId = "Z0002";
 BEGIN
  L_bp.extBegin(bpId, ".㧪. 뤠 ⮯", L_bp.t_Process, L_General.tc_inIntvl, L_bp.pt_Low);
  IF L_bp.IAmInQueue() & !bpRT.fr THEN
   Z0002_Daemon();
  ELSE
   Z0002_Do(Memo.ud_fr(), Memo.ud_ut(), 1);
  END;
  L_bp.End();
 END {Z0002};

END.
