(*
%Copyright   (c) Polak IT
%Author      01.02.2002 10:08:54 LDA
%Purpose     ࠢ ࠢ筮 
%Type        control
%Specific    AP
%Modified    10.06.2014 18:15:52 POLAK\Bor
%Environment
*)

 MODULE FlRec [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_Events, L_General, L_AFM, L_Fuel, L_OwnData, L_Str, L_DatTim,
        L_EC, L_Car, L_MDoc, L_XDoc, L_MathR, L_Stock, L_Basis, L_bp, L_StdFrm,
        FIO, Math, P_Firm, E_Utils, L_Env, L_APtm;

 PRIVATE CONST
  exc_NormalTryExit = " ଠ 室   ஢ 16.06.2005 18:46:39 POLAK\LDA";

 PRIVATE VAR
  _RWayS : LIKE(RWayS.RWayS);
  _TSN   : LIKE(Staff.TSN);

 PRIVATE PROCEDURE E_MakeFlRec_wRWayS(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Utils.FlRec_MakeFlRec_wRWayS), 1);
 END {E_MakeFlRec_wRWayS};

 PRIVATE PROCEDURE E_FlRec_NeedMakeMDoc(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Utils.FlRec_NeedMakeMDoc), 0);
 END {E_FlRec_NeedMakeMDoc};

 PRIVATE PROCEDURE FlRec_OnBeforeEdIns();
  VAR
   FlRecLFields    : FORM_FIELDS;
   MakeFlRec_wRWayS: SCAL[2];
   FirstFieldName  : STRING[];
 BEGIN
  RTI.Get().CurZone.Fields("FlRec.Storage").First:=!FlRec.Storage;
  RTI.Get().CurZone.Fields("FlRec.SrcNbr").First :=~!FlRec.Storage;
  MakeFlRec_wRWayS:=E_MakeFlRec_wRWayS(FlRec.Date);

  IF MakeFlRec_wRWayS THEN
   FirstFieldName:="FlRecL.RWayS";
  ELSE
   FirstFieldName:="FlRecL.BoxNbr";
  END;
  FlRecLFields:=RTI.Get().CurWindow.Zones(1).Fields;
  FlRecLFields(FirstFieldName).First:=1;
  FlRecLFields("FlRecL.RWayS").Modifiable:=MakeFlRec_wRWayS;
  FlRecLFields("FlRecL.TSN").Modifiable:=~MakeFlRec_wRWayS;
 END {FlRec_OnBeforeEdIns};

 PRIVATE PROCEDURE GetOneFuelStorage(D: DATE): LIKE(Storage.Storage);
  VAR
   Result: LIKE(Storage.Storage);
 BEGIN
  TRY
   Result:=L_Stock.GetFuelStorage(P_Firm.mf_Own);
  EXCEPT
  ON Exc: Exc_Raise DO
   IF Exc.ErrorCode # -1 THEN
    RAISE();
   END;
   SETEMPTY(Result);
  END; (* TRY *)
  RETURN Result;
 END {GetOneFuelStorage};

 PRIVATE PROCEDURE FlRec_OnBeforeInsert();
 BEGIN
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_FlRec, L_XDoc.EmptyXDocKind, FlRec.FlRec, L_XDoc.action_Insert);
  FlRec.Date:=Memo.ud_cd();
  FlRec.SrcDate:=FlRec.Date;
  FlRec.Storage:=GetOneFuelStorage(FlRec.Date);
  REPLACE(FlRec);
  FlRec_OnBeforeEdIns();
 END {FlRec_OnBeforeInsert};

 PRIVATE PROCEDURE FillMDoc(trgStatus: LIKE(FlRec.Status));
 BEGIN
  MDoc.Date    :=FlRec.Date;
  MDoc.SrcDate :=SYSDATE();
  MDoc.Status  :=trgStatus;
  MDoc.Done    :=0;
  IF MDoc.Status # L_MDoc.st_Canceled THEN
   L_General.CallUs(OCCURE(FlRecL));
   MDoc.SrcNbr  :=" " + FlRec.SrcNbr + "/" + FlRecL.FlRecL;
   MDoc.Storage :=FlRec.Storage;
   MDoc.TSN     :=FlRecL.TSN;
   MDoc.BoxNbr  :=FlRecL.BoxNbr;
   MDoc.Dest    :=L_MDoc.E_DefMDocDest(FlRec.Date);
   IF !MDoc.Dest THEN
    MDoc.Dest   :=000;
   END;
   SEARCH(Storage, Storage, , MDoc.Storage);
   MDoc.Firm    :=P_Firm.fomf(Storage.MyFirm);
   MDoc.Alower  :=L_MDoc.E_DefaultAlower(MDoc.Date);
   REPLACE(MDoc);
   L_General.Assert(FlRecL.TotalFl >= 0, " ଫ ᪠ ⮯ १ |"+
                                         "   ⥫쭮 ⢠  ப "+L_StdFrm.HR()+
                                         " ଫ  ⮯ ᫥ ନ ᮮ⢥騩  ");

   L_MDoc.InsMDocList(FlRec.Math, L_MathR.mm_New, "", FlRecL.TotalFl, 0, 0);
   IF ~!FlRecL.RWayS THEN
    SEARCH(RWayS, RWayS, , FlRecL.RWayS);
    IF RWayS.Done THEN
     CALL(RWayS, L_Events.md_SingleMakeUnDone);
    END;
    L_XDoc.rf_Insert(L_XDoc.xdt_MDoc, L_XDoc.curXDocId(L_XDoc.xdt_RWayS), L_XDoc.rft_RefTo);
   END;
  ELSE
   REPLACE(MDoc);
  END;
 END {FillMDoc};

 PRIVATE PROCEDURE MakeMDoc(trgDone: SCAL[2]; NewMDoc: SCAL[2]);
 BEGIN
  IF NewMDoc THEN
   L_General.CallUs(trgDone);
   DEFAULT(MDoc);
   MDoc.MDocKind:=L_MDoc.md_NOV;
   L_MDoc.Insert_MDoc();
  ELSE
   L_MDoc.MDoc_OnAnyModification(-1, L_MDoc.np_Yes, 0);
  END;
  PROMPT("ࠡ⪠  " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));

  SAVE(FlRecL);
  IF trgDone THEN
   IF OCCURE(FlRecL) & (FlRec.Status # L_MDoc.st_Canceled) THEN
    L_XDoc.rf_Clear(L_XDoc.xdt_MDoc);
    L_XDoc.rf_Insert(L_XDoc.xdt_MDoc, L_XDoc.curXDocId(L_XDoc.xdt_FlRec), L_XDoc.rft_BaseOn);
    FillMDoc(FlRec.Status);
   ELSE
    FillMDoc(L_MDoc.st_Canceled);
   END;
   L_MDoc.MDoc_OnAnyModification(+1, L_MDoc.np_Yes, 0);
  ELSE
   FillMDoc(L_MDoc.st_Canceled);
   CONFORM(MDoc, MDocList);
   IF OCCURE(MDocList) THEN
    REMOVE(MDocList);
   END;
   L_MDoc.MDoc_OnAnyModification(+1, L_MDoc.np_No, 0);
   L_General.CallUs(~OCCURE(MDocList));
  END;
  RESTORE(FlRecL);
 END {MakeMDoc};

 PRIVATE PROCEDURE FlRec_MDocCollection(): L_XDoc.tXDocCollection;
 BEGIN
  RETURN L_XDoc.GetDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_FlRec), L_XDoc.xdt_MDoc);
 END {FlRec_MDocCollection};

 PRIVATE PROCEDURE Proceed(_Done: SCAL[2]);
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
 BEGIN
  L_Fuel.AccessFlRec();
  IF FlRec.Done # _Done THEN
   L_General.Assert(SELECT(FlRecL, FlRec, FlRec.FlRec),
                    "ࠢ筠     ⮩");
   L_General.Assert(FlRec.Status # L_MDoc.st_Prepared,
                    "   ࠢ筮 |" +
                    " ᮬ '⮢'");
   IF FlRec.Status = L_MDoc.st_Canceled THEN
    L_StdFrm.Choice(L_Str.PoolItem("⪠|ࠡ⪠", _Done) + " 㫨஢ ࠢ筮 ");
   END;
   IF E_FlRec_NeedMakeMDoc(FlRec.Date) THEN
    L_StdFrm.Question(L_Str.PoolItem("⪠|ࠡ⪠", _Done) + " ࠢ筮 |" +
                      "   த⥫쭮 ६");
    i:=0;
    DependentMDocs:=FlRec_MDocCollection();
    WHILE OCCURE(FlRecL) DO
     IF ~L_XDoc.xdc_PositionOn(DependentMDocs, i) THEN
      MakeMDoc(_Done, 1);
     ELSE
      MakeMDoc(_Done, 0);
     END;
     NEXT(FlRecL);
     INC(i);
    END; (* WHILE OCCURE(FlRecL) ... *)
    WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
     MakeMDoc(_Done, 0);
     INC(i);
    END; (* WHILE L_XDoc.xdc_PositionOn ... *)
   END; (* IF E_FlRec_NeedMakeMDoc(FlRec.Date)...*)
   FlRec.Done:=_Done;
   REPLACE(FlRec);
  END; (* IF FlRec.Done # _Done...*)
 END {Proceed};

 PUBLIC PROCEDURE MakeDone();
 BEGIN
  Proceed(1);
 END {MakeDone};

 PUBLIC PROCEDURE MakeUnDone();
 BEGIN
  Proceed(0);
 END {MakeUnDone};

 PRIVATE PROCEDURE FlRec_OnBeforeEdit();
 BEGIN
  L_General.Assert(~FlRec.Done, "饭 䨪 ࠡ⠭ ࠢ筮 |" +
                                "室 ।⥫쭮 ⪠ ");
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_FlRec, L_XDoc.EmptyXDocKind, FlRec.FlRec, L_XDoc.action_Edit);
  FlRec_OnBeforeEdIns();
 END {FlRec_OnBeforeEdit};

 PRIVATE PROCEDURE FlRec_OnBeforeDelete();
 BEGIN
  L_General.Error(" ࠢ筮  饭.|" +
                  "ᯮ '㫨஢'");
 END {FlRec_OnBeforeDelete};

 PRIVATE PROCEDURE FlRec_OnAfterEdIns();
 BEGIN
  IF E_FlRec_NeedMakeMDoc(FlRec.Date) THEN
   L_General.Assert(~!FlRec.Storage, " 㪠  ࠭");
  END;
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_FlRec, L_XDoc.EmptyXDocKind, FlRec.FlRec);
 END {FlRec_OnAfterEdIns};

 PRIVATE PROCEDURE FlRec_OnAfterEdit();
 BEGIN
  FlRec_OnAfterEdIns();
 END {FlRec_OnAfterEdit};

 PRIVATE PROCEDURE FlRec_OnAfterInsert();
 BEGIN
  FlRec_OnAfterEdIns();
 END {FlRec_OnAfterInsert};

 PRIVATE PROCEDURE FlRec_Status_OnSuccessfulChange();
 BEGIN
  IF    GE_PVALUE() = L_MDoc.st_Canceled THEN
   L_StdFrm.Choice("  ⬥ 㫨஢ ࠢ筮 ?");
  ELSIF FlRec.Status = L_MDoc.st_Canceled THEN
   L_StdFrm.Choice("  㫨஢ ࠢ ?");
   L_StdFrm.Choice(" ⮢ 㬥, ନ஢|" +
                   " ⮩ ࠢ筮 ,  㫨஢");
  END;
 END {FlRec_Status_OnSuccessfulChange};

 PRIVATE PROCEDURE FlRecL_Quantity_OnSuccessfulChange();
 BEGIN
  IF ~!GE_PVALUE() THEN
   DEC(FlRecL.TotalFl, GE_PVALUE());
  END;
  IF ~!FlRecL.Quantity[RTI.Get().CurZone.ActiveField.ArrayIndex] THEN
   INC(FlRecL.TotalFl, FlRecL.Quantity[RTI.Get().CurZone.ActiveField.ArrayIndex]);
  END;
  REPLACE(FlRecL);
 END; {FlRecL_Quantity_OnSuccessfulChange}

 PRIVATE PROCEDURE FlRecL_BoxNbr_OnSuccessfulChange();
  VAR
   Dummy: SCAL[2];
 BEGIN
  IF ~!FlRecL.BoxNbr THEN
   TRY
    CONFORM(FlRecL, Car);
    Dummy:=L_Fuel.IsFuelInMixOnDate(FlRec.Date, FlRec.Math);
    RAISE(1, exc_NormalTryExit);
   EXCEPT
   ON Exc: Exc_Root DO
    IF Exc.MsgOriginalText # exc_NormalTryExit THEN
     RAISE();
    END;
   END; (* TRY *)
  END;
 END; {FlRecL_BoxNbr_OnSuccessfulChange}

 PRIVATE PROCEDURE DecrementTotalFl();
 BEGIN
  DEC(FlRec.Total, FlRecL.TotalFl);
  REPLACE(FlRec);
 END {DecrementTotalFl};

 PRIVATE PROCEDURE FlRecL_OnBeforeEdIns();
 BEGIN
(*
  L_Fuel.AccessFlRec();
*)
  L_General.Assert(~!FlRec.Math, " 㪠 ⮯");
 END {FlRecL_OnBeforeEdIns};

 PRIVATE PROCEDURE FlRecL_OnBeforeEdit();
 BEGIN
  FlRecL_OnBeforeEdIns();
  DecrementTotalFl();
 END {FlRecL_OnBeforeEdit};

 PRIVATE PROCEDURE FlRecL_OnBeforeInsert();
 BEGIN
  FlRecL_OnBeforeEdIns();
 END {FlRecL_OnBeforeInsert};

 PRIVATE PROCEDURE FlRecL_OnBeforeDelete();
 BEGIN
  IF ~!FlRec_MDocCollection() THEN
   L_General.Error("  ப ࠢ筮 |" +
                   " ନ஢ ⮢ 㬥.| |" +
                   " ப  饭"+L_StdFrm.HR()+
                   " 㤠 ᫥ 㪠  '뤠' 0.00 ஢");
  END;
  DecrementTotalFl();
 END {FlRecL_OnBeforeDelete};

 PRIVATE PROCEDURE StandOnRWayS_wAddProc(IsAskPhase2: SCAL[2];
                                 Proc       : PROC);
 BEGIN
  TRY
   IF ~IsAskPhase2 & ~!FlRecL.RWayS THEN
    L_General.Assert(SEARCH(RWayS, RWayS, FlRecL.RWayS), "   " + FlRecL.RWayS);
   END;
   IF OCCURE(RWayS) THEN
    L_General.Assert(RWayS.Date <= FlRec.Date,
                     "       ");
    Proc();
   END;
   RAISE(1, exc_NormalTryExit);
  EXCEPT
  ON Exc: Exc_Root DO
   IF Exc.MsgOriginalText # exc_NormalTryExit THEN
    RAISE();
   END;
  END; (* TRY *)
 END {StandOnRWayS_wAddProc};

 PRIVATE PROCEDURE CheckBoxNbrAdaptability();
 BEGIN
  IF ~!FlRecL.BoxNbr THEN
   L_General.Assert(RWayS.BoxNbr = FlRecL.BoxNbr, "⥢  뤠  㣮 ");
  END;
 END {CheckBoxNbrAdaptability};

 PRIVATE PROCEDURE FlRecL_OnAfterEdIns();
 BEGIN
(*
訡  V32 - RAISE  楤 StandOnRWayS_wAddProc ᡨ   FlRecL.
 ᫥ ࠢ
*)
  IF ~!FlRec.Math THEN END;
  IF ~!FlRecL.RWayS THEN END;
(*!*)

  StandOnRWayS_wAddProc(0, PROCREF(CheckBoxNbrAdaptability));
IF ~L_APtm.IsOG() THEN
  L_General.Assert(L_Env.RealTSN(FlRecL.TSN), "  㪠 ॠ ࠡ⭨");
END;
  INC(FlRec.Total, FlRecL.TotalFl);
  REPLACE(FlRec);
 END {FlRecL_OnAfterEdIns};

 PRIVATE PROCEDURE FlRecL_OnAfterEdit();
 BEGIN
  FlRecL_OnAfterEdIns();
 END {FlRecL_OnAfterEdit};

 PRIVATE PROCEDURE FlRecL_OnAfterInsert();
 BEGIN
  FlRecL_OnAfterEdIns();
 END {FlRecL_OnAfterInsert};

 PRIVATE PROCEDURE FlRecE_0_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("Storage.Type").Format:=L_Stock.st_Pool_SH;
 END {FlRecE_0_OnZoneOpen};

 PRIVATE PROCEDURE GetRWaySAttr();
 BEGIN
  _RWayS:=RWayS.RWayS;
  _TSN  :=RWayS.TSN;
 END {GetRWaySAttr};

 PRIVATE PROCEDURE FillFlRecLFieldsFromRWayS(IsAskPhase2: SCAL[2]);
 BEGIN
  SETEMPTY(_RWayS, _TSN);
(*
訡  V32 - RAISE  楤 StandOnRWayS_wAddProc ᡨ   FlRecL.
 ᫥ ࠢ
*)
  IF ~!FlRecL.RWayS THEN END;
(*!*)
  StandOnRWayS_wAddProc(IsAskPhase2, PROCREF(GetRWaySAttr));
  FlRecL.RWayS:=_RWayS;
  FlRecL.TSN  :=_TSN;
  REPLACE(FlRecL);
 END {FillFlRecLFieldsFromRWayS};

 PRIVATE PROCEDURE FlRecL_RWayS_OnSuccessfulChange();
 BEGIN
  FillFlRecLFieldsFromRWayS(0);
 END {FlRecL_RWayS_OnSuccessfullChange};

 PRIVATE PROCEDURE SetWindowRWaySPosition();
 BEGIN
  SE_WZD_POSITION(RTI.Get().TrgWindow.Name, RTI.Get().TrgZone.Number, RWayS);
 END {SetWindowRWaySPosition};

 PRIVATE PROCEDURE FlRecL_RWayS_OnAskPhase1();
 BEGIN
  StandOnRWayS_wAddProc(0, PROCREF(SetWindowRWaySPosition));
 END {FlRecL_RWayS_OnAskPhase1};

 PRIVATE PROCEDURE FlRecL_RWayS_OnAskPhase2();
 BEGIN
  FillFlRecLFieldsFromRWayS(1);
 END {FlRecL_RWayS_OnAskPhase2};

 PRIVATE CONST
  src_FlRec = 0;
  src_RWayS = 1;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
############################################################################################## ########## #####
=#####=========================================================================================================
|                         ⮪ ᮮ⢥⢨ 뤠 ⮯                              |
|#############################################################################################################|
}
*)

(*
$P{ Math:
Math.Name, L, ""
@
|-------------------------------------------------------------------------------------------------------------|
|#############################################################################################################|
|-------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ Title0:
@
|      |. ઠ      |⥫                  |  |  ||ਬ砭                      |
|----------|----------------|--------------------------|------|------|-------|--------------------------------|
}
*)

(*
$P{ Title1:
@
|      |     |. ઠ      |⥫          |  |  ||ਬ砭                      |
|----------|-------|----------------|------------------|------|------|-------|--------------------------------|
}
*)

(*
$P{ Line0:
TmpRW.Date, L, "D.N.y"
TmpRW.BoxNbr, L, ""
Mark.Name, L, ""
TmpRW.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
?, R, "2."
?, R, "2."
?, R, ""
?, L, ""
@
|##########|#### ###########|##### ####################|######|######|#######|################################|
}
*)

(*
$P{ Line1:
TmpRW.Date, L, "D.N.y"
TmpRW.RWayS, L, ""
TmpRW.BoxNbr, L, ""
Mark.Name, L, ""
TmpRW.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
?, R, "2."
?, R, "2."
?, R, ""
?, L, ""
@
|##########|#######|#### ###########|##### ############|######|######|#######|################################|
}
*)

(*
$P{ Total:
?, R, "2."
?, R, "2."
@
|-------------------------------------------------------------------------------------------------------------|
|뤠 ⮯, ⮣                     ࠢ筮  ##########                                 |
|                                          ⥢ ⠬        ##########                                 |
}
*)

(*
$P{ Bot:
@
=(c) Polak=====================================================================================================
}
*)

 PRIVATE PROCEDURE Create_TmpRW();
 BEGIN
  CreateFILE(TmpRW, "", "", "");

  CreateFIELD(TmpRW, Source,   SCAL[2],              "", "", "", "筨",    "0- 1-");
  CreateFIELD(TmpRW, Date,     DATE,                 "", "", "", " ",     "");
  CreateFIELD(TmpRW, RWayS,    LIKE(RWayS.RWayS),    "", "", "", " ",        "");
  CreateFIELD(TmpRW, BoxNbr,   LIKE(RWayS.BoxNbr),   "", "", "", "ࠦ",    "");
  CreateFIELD(TmpRW, TSN,      LIKE(RWayS.TSN),      "", "", "", "",   "");
  CreateFIELD(TmpRW, Math,     LIKE(RWayF.Math),     "", "", "", " ⮯", "");
  CreateFIELD(TmpRW, FuelFact, LIKE(RWayS.FuelFact), "", "", "", "室",      "");
  CreateFIELD(TmpRW, Comment,  STRING[32], "", "", "", "ਬ砭",      "");

  CreateINDEX(TmpRW, TmpRW, UNIQUE, "", "", Math, Date, BoxNbr, RWayS, TSN, Source);
  CreateINDEXandLINK(TmpRW, Math,   PLURAL, Math,  Math,   USER, "", "", Math);
  CreateINDEXandLINK(TmpRW, TSN,    PLURAL, Staff, TSN,    USER, "", "", TSN);

  SetVersionOfFILE(TmpRW, 0);
  L_AFM.AF_CreateTemp("TmpRW", "TmpRW");
 END {Create_TmpRW};

 PRIVATE PROCEDURE GetRWayS(_RWayS: LIKE(RWayS.RWayS); _Date: DATE): LIKE(RWayS.RWayS);
 BEGIN
  IF ~E_MakeFlRec_wRWayS(_Date) THEN
   SETEMPTY(_RWayS);
  END;
  RETURN _RWayS;
 END {GetRWayS};

 PRIVATE PROCEDURE InsIntoTmpRW(trgSource: SCAL[2]);
  VAR
   trgMath    : LIKE(Math.Math);
   trgDate    : DATE;
   trgBoxNbr  : LIKE(Car.BoxNbr);
   trgRWayS   : LIKE(RWayS.RWayS);
   trgTSN     : LIKE(RWayS.TSN);
   trgFuelFact: LIKE(RWayS.FuelFact);
   trgComment : STRING[];
 BEGIN
  IF trgSource = src_FlRec THEN
   trgMath    :=FlRec.Math;
   trgDate    :=FlRec.Date;
   trgBoxNbr  :=FlRecL.BoxNbr;
   trgRWayS   :=GetRWayS(FlRecL.RWayS, FlRec.Date);
   trgTSN     :=FlRecL.TSN;
   trgFuelFact:=FlRecL.TotalFl;
   trgComment :=FlRecL.FlRec;
  ELSE
   trgMath    :=RWayF.Math;
   trgDate    :=RWayS.Date;
   trgBoxNbr  :=RWayS.BoxNbr;
   trgRWayS   :=GetRWayS(RWayS.RWayS, RWayS.Date);
   trgTSN     :=RWayS.TSN;
   trgFuelFact:=RWayF.FuelTake - RWayF.FuelRet;
   trgComment :="";
  END;
  SEARCH(Car, BoxNbr, , trgBoxNbr);
  IF L_Fuel.IsFuelInMixOnDate(trgDate, trgMath) THEN
   ADD(TmpRW, TmpRW, ,  trgMath, trgDate, trgBoxNbr, trgRWayS, trgTSN, trgSource,
       TmpRW.FuelFact, trgFuelFact);
   IF ~!trgComment THEN
    TmpRW.Comment:=L_Str.AddStrDlm(TmpRW.Comment, ",") + trgComment;
    REPLACE(TmpRW);
   END;
  END;
 END {InsIntoTmpRW};

 PRIVATE PROCEDURE FillTmpRWayS(_Date: DATE);
 BEGIN
  SELECT(RWayS, Date, , _Date);
  WHILE OCCURE(RWayS) DO
   PROMPT(L_DatTim.DateStr(RWayS.Date) + "  " + RWayS.RWayS);
   SELECT(RWayF, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayF) DO
    InsIntoTmpRW(src_RWayS);
    NEXT(RWayF);
   END; (* WHILE OCCURE(RWayF) ...*)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ...*)
 END {FillTmpRWayS};

 PRIVATE PROCEDURE FillTmpFlRec(_Date: DATE);
 BEGIN
  SELECT(FlRec, Date, , _Date);
  WHILE OCCURE(FlRec) DO
   IF FlRec.Status # L_MDoc.st_Canceled THEN
    PROMPT(L_DatTim.DateStr(FlRec.Date) + "  " + FlRec.FlRec);
    SELECT(FlRecL, FlRec, , FlRec.FlRec);
    WHILE OCCURE(FlRecL) DO
     InsIntoTmpRW(src_FlRec);
     NEXT(FlRecL);
    END; (* WHILE OCCURE(FlRecL) ...*)
   END;
   NEXT(FlRec);
  END; (* WHILE OCCURE(FlRec) ...*)
 END {FillTmpFlRec};

 PRIVATE PROCEDURE Gather(BDate, EDate: DATE);
 BEGIN
  APP.Get().NewPrompt("");
  WHILE BDate <= EDate DO
   PROMPT(L_DatTim.DateStr(BDate));
   FillTmpFlRec(BDate);
   FillTmpRWayS(BDate);
   INC(BDate);
  END; (* WHILE BDate <= EDate...*)
 END {Gather};

 PRIVATE PROCEDURE AddTotalFlRec(_Value: LIKE(FlRec.Total); VAR _Total: LIKE(FlRec.Total));
 BEGIN
  IF ~!_Value THEN
   INC(_Total, _Value);
  END;
 END {AddTotalFlRec};

 PRIVATE PROCEDURE Check(OnDate: DATE);
  VAR
   _Delta   : LIKE(FlRec.Total);
   Value,
   _Total,
   TotalFuel: LIKE(FlRec.Total)[2];
   Line,
   Title,
   Delta,
   Comment  : STRING[];
 BEGIN
  APP.Get().NewPrompt("");
  SETZERO(_Delta, TotalFuel);
  Line :="Line"  + L_Str.IntStr(E_MakeFlRec_wRWayS(OnDate));
  Title:="Title" + L_Str.IntStr(E_MakeFlRec_wRWayS(OnDate));
  SELECT(TmpRW, TmpRW);
  WHILE OCCURE(TmpRW) DO
   NARROWSEL(TmpRW, Math);
   CONFORM(TmpRW, Math);
   MAKEPART(R, Math);
   MAKEPART(R, ^Title);
   SETZERO(_Total);
   WHILE OCCURE(TmpRW) DO
    PROMPT(" " + TmpRW.BoxNbr);
    NARROWSEL(TmpRW, Date, BoxNbr, RWayS, TSN);
    SETEMPTY(Value);
    Value[TmpRW.Source]:=TmpRW.FuelFact;
    Comment:=TmpRW.Comment;
    INC(_Total[TmpRW.Source], Value[TmpRW.Source]);
    IF NEXT(TmpRW) THEN
     Value[TmpRW.Source]:=TmpRW.FuelFact;
     IF ~!Comment THEN
      Comment:=Comment + "/";
     END;
     Comment:=Comment + TmpRW.Comment;
     INC(_Total[TmpRW.Source], Value[TmpRW.Source]);
     IF (Value[src_FlRec] # Value[src_RWayS])  THEN
      INC(_Delta, Value[src_FlRec]-Value[src_RWayS]);
      Delta :=FLDTOSTR(Value[src_FlRec]-Value[src_RWayS], "2.", 0);
     ELSE
      SETEMPTY(Delta);
     END;
    ELSE
     LAST(TmpRW);
     Delta:="XXXXXXX";
     IF TmpRW.Source = src_RWayS THEN
      DEC(_Delta, Value[TmpRW.Source]);
     ELSE
      INC(_Delta, Value[TmpRW.Source]);
     END;
    END;
    IF ~!Delta & ~(!Value[src_FlRec] & (Value[src_RWayS]=0)) THEN
     L_Car.AccessMark(TmpRW.BoxNbr, TmpRW.Date);
     CONFORM(TmpRW, Staff);
     CONFORM(Staff, Man);
     MAKEPART(R, ^Line, Value[src_FlRec], Value[src_RWayS], Delta, Comment);
    END;
    AddTotalFlRec(Value[src_FlRec], TotalFuel[src_FlRec]);
    AddTotalFlRec(Value[src_RWayS], TotalFuel[src_RWayS]);
    NEXTINEXTENDEDSEL(TmpRW, Date, BoxNbr, RWayS, TSN);
   END; (* WHILE OCCURE(TmpRW)  ...*)
   MAKEPART(R, Total, _Total[src_FlRec], _Total[src_RWayS]);
   NEXTINEXTENDEDSEL(TmpRW, Math);
  END; (* WHILE OCCURE(TmpRW)  ...*)
  L_General.CallUs(_Delta = (TotalFuel[src_FlRec]-TotalFuel[src_RWayS]));
 END {Check};

 PRIVATE PROCEDURE ExecuteRep(ByPeriod: SCAL[2]);
  VAR
   BDate,
   EDate  : DATE;
   Title,
   RepName: STRING[];
  BEGIN
  IF ByPeriod THEN
   BDate  :=Memo.ud_fr();
   EDate  :=Memo.ud_ut();
   RepName:="ProtP";
   Title  :=" ਮ  " + L_DatTim.DateStr(BDate) + "  " + L_DatTim.DateStr(EDate);
  ELSE
   L_Fuel.AccessFlRec();
   BDate  :=FlRec.Date;
   EDate  :=FlRec.Date;
   RepName:="ProtD";
   Title  :=" " + L_DatTim.DateStr(BDate);
  END;

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, Title);
  Create_TmpRW();
  Gather(BDate, EDate);
  Check(EDate);
  MAKEPART(R, Bot);
  L_General.SurveyLastReport();
 END {ExecuteRep};

 PUBLIC PROCEDURE ProtD();
 BEGIN
  ExecuteRep(0);
 END {ProtD};

 PUBLIC PROCEDURE ProtP();
 BEGIN
  ExecuteRep(1);
 END {ProtP};

 PRIVATE PROCEDURE FlRec_Top(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "卮");
  L_Basis.wb_WrInQM(F, "儠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⭨");
  L_Basis.wb_WrInQM(F, "⭨");
  L_Basis.wb_WrInQM(F, "뤠");
  L_Basis.wb_TermLine(F);
 END {FlRec_Top};

 PRIVATE PROCEDURE FlRec_Line(F: STRING[]);
 BEGIN
  L_Basis.wb_WrScl(F, FlRec.FlRec);
  L_Basis.wb_WrDat(F, FlRec.Date);
  L_Basis.wb_WrStr(F, FlRec.SrcNbr);
  L_Basis.wb_WrDat(F, FlRec.SrcDate);
  IF ~!FlRec.Storage THEN
   L_Basis.wb_WrScl(F, FlRec.Storage);
   L_Basis.wb_WrStr(F, Storage.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrScl(F, FlRec.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("⮢|஢|㫨஢", FlRec.Status));
  L_Basis.wb_WrScl(F, FlRecL.RWayS);
  L_Basis.wb_WrStr(F, FlRecL.BoxNbr);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, Column.Column);
  L_Basis.wb_WrStr(F, Column.Name);
  L_Basis.wb_WrScl(F, FlRecL.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrNum(F, FlRecL.Quantity[0], 2);
  L_Basis.wb_TermLine(F);
 END {FlRec_Line};

 PUBLIC PROCEDURE FlRec();
  CONST
   bpId = "FlRec";
 BEGIN
  L_bp.Begin(bpId, "ࠢ ", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  FlRec_Top("R");
  SETSEL(FlRec, Date);
  SRCINSEL(FlRec, GE, , Memo.ud_fr());
  WHILE OCCURE(FlRec) & (FlRec.Date <= Memo.ud_ut()) DO
   PROMPT(" "+FlRec.FlRec);
   IF FlRec.Status # L_MDoc.st_Canceled THEN
    CONFORM(FlRec, Storage);
    CONFORM(FlRec, Math);

    CONFORM(FlRec, FlRecL);
    WHILE OCCURE(FlRecL) DO
     L_Car.StandOnCarLog(FlRecL.BoxNbr, FlRec.Date);
     CONFORM(CarLog, Column);
     CONFORM(CarLog, Mark);
     CONFORM(FlRecL, Staff);
     CONFORM(Staff, Man);
     FlRec_Line("R");
     NEXT(FlRecL);
    END; (* WHILE OCCURE(FlRecL) ... *)
   END;
   NEXT(FlRec);
  END; (* WHILE OCCURE(FlRec) ... *)
  FIO.Close(R);
  L_bp.End();
 END {FlRec};

BEGIN
 L_Events.ExecuteHandler();
END.
