(*
%Copyright   (c) Polak IT
%Author      15.11.2005 14:24:22 POLAK\GAV
%Purpose      ६   ⮯襪
%Type        report
%Specific    LOC
%Modified    07.02.2014 11:36:10 POLAK\Bor
%Environment
*)

 MODULE FO_TE [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_CUC, L_MDoc, Memo, L_Way, L_General, P_Math, L_AFM, Math, L_StdFrm, L_XObj,
        L_Staff, L_DatTim, L_MathR, L_PRoll, L_Money, L_APtm, P_Firm, L_bp, L_Acnt,
        L_Basis, FIO, L_Str;

 CONST
  maxCar = 100;

 PRIVATE PROCEDURE E_CUTires(): LIKE(CarUnit.CarUnit);
 BEGIN
  IF    L_General.GetAPSiteNumber() = 21 THEN RETURN 0002;
  ELSIF L_General.GetAPSiteNumber() = 50 THEN RETURN 0005;
  ELSIF L_General.GetAPSiteNumber() = 52 THEN RETURN 0001;
  ELSIF L_General.GetAPSiteNumber() = 93 THEN RETURN 0008;
  ELSE
   L_General.SetupRequired();
  END;
 END {E_CUTires};

 PRIVATE PROCEDURE E_IsRetireToSurfacing(): SCAL[2];
 BEGIN
  CONFORM(MDocLCU, MDoc);
  IF    L_General.GetAPSiteNumber() = 21 THEN RETURN (MDoc.Dest = 013);
  ELSIF L_General.GetAPSiteNumber() = 50 THEN RETURN (MDocList.MMode = L_MathR.mm_InBadRepair);
  ELSIF L_General.GetAPSiteNumber() = 52 THEN RETURN (MDoc.Dest = 668);
  ELSIF L_General.GetAPSiteNumber() = 93 THEN RETURN 0;
  ELSE
   L_General.SetupRequired();
  END;
 END {E_IsRetireToSurfacing};

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "஡  ࠡ⭨");
  L_Basis.wb_WrStr(F, "஡  ࠡ⭨");
  L_Basis.wb_WrStr(F, "㬬");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "ﭨ");
  L_Basis.wb_WrStr(F, "஡");
  L_Basis.wb_WrStr(F, "ଠ");
  L_Basis.wb_WrStr(F, "९஡");
  L_Basis.wb_WrStr(F, "६");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE MakeLine(F: STRING[]; TireTop: SCAL[2]; Price: L_XObj.tSum);
 BEGIN
  IF TireTop THEN
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  ELSE
   L_Basis.wb_WrScl(F, Staff.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrNum(F, runs.Run, 1);
   L_Basis.wb_WrNum(F, runs.Run * 100 / tmp.Run, 1);
   L_Basis.wb_WrNum(F, runs.Sum, 2);
  END;
  L_Basis.wb_WrScl(F, CUCopy.CUCopy);
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_CUC.cnd_Pool, tmp.Cond));
  L_Basis.wb_WrNum(F, tmp.Run, 1);
  L_Basis.wb_WrNum(F, tmp.Norm, 1);
  L_Basis.wb_WrNum(F, Math.Max(0, tmp.Run - tmp.Norm), 1);
  L_Basis.wb_WrNum(F, BonusPrc(tmp.Cond), 1);
  L_Basis.wb_WrNum(F, Price, 2);
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PRIVATE PROCEDURE BonusPrc(cnd: L_CUC.tCondition): NUMERIC[1];
 BEGIN
  IF cnd = L_CUC.cnd_Restored THEN
   RETURN 25;
  ELSE
   RETURN 40;
  END;
 END {BonusPrc};

 PRIVATE PROCEDURE CreateTemp();
 BEGIN
  CreateFILE(runs);
  CreateFIELD(runs, CUCopy, LIKE(CUCopy.CUCopy));
  CreateFIELD(runs, TSN,    LIKE(Staff.TSN));
  CreateFIELD(runs, Run,    NUMERIC[1]);
  CreateFIELD(runs, Sum,    NUMERIC[2]);
  CreateINDEXandLINK(runs, TSN,    UNIQUE, Staff,  TSN,    USER, , , TSN, CUCopy);
  CreateINDEXandLINK(runs, CUCopy, UNIQUE, CUCopy, CUCopy, USER, , , CUCopy, TSN);
  SetVersionOfFILE(runs, 0);
  L_AFM.CreateTemp("runs");

  CreateFILE(tmp);
  CreateFIELD(tmp, CUCopy, LIKE(CUCopy.CUCopy));
  CreateFIELD(tmp, Cond,   L_CUC.tCondition);
  CreateFIELD(tmp, Price,  NUMERIC[2], , "0");
  CreateFIELD(tmp, Norm,   NUMERIC[1]);
  CreateFIELD(tmp, Run,    NUMERIC[1]);
  CreateINDEXandLINK(tmp, CUCopy, UNIQUE, CUCopy, CUCopy, USER, , , CUCopy);
  SetVersionOfFILE(tmp, 0);
  L_AFM.CreateTemp("tmp");
 END {CreateTemp};

 PRIVATE PROCEDURE PurgeTemp();
 BEGIN
  L_AFM.AF_PurgeTemp("runs");
  L_AFM.AF_PurgeTemp("tmp");
 END {PurgeTemp};

 PRIVATE PROCEDURE GetCUCopyUsersCollection(    _CUCopy : LIKE(CUCopy.CUCopy);
                                            VAR ucBoxNbr: LIKE(Car.BoxNbr)[];
                                            VAR ucFrom,
                                                ucTill  : DATE[]);
  VAR
   i           : NUMERIC[0];
   prvLocation,
   curLocation : L_CUC.tLocation;
 BEGIN
  SAVE(MDocLCU);
  SETEMPTY(ucBoxNbr, ucFrom, ucTill);
  SELECT(MDocLCU, CUCopy, , _CUCopy, L_MDoc.st_Passed);
  prvLocation:=L_CUC.l_Others;
  i:=0;
  WHILE OCCURE(MDocLCU) DO
   IF MDocLCU.OpKind # L_CUC.ok_Mentioning THEN
    curLocation:=L_CUC.DefineCULocation(MDocLCU.OpKind);
    IF curLocation = L_CUC.l_inExpl THEN
     IF prvLocation # L_CUC.l_inExpl THEN
      L_General.CallUs(!ucBoxNbr[i]);
      ucBoxNbr[i]:=MDocLCU.BoxNbr;
      ucFrom  [i]:=MDocLCU.Date;
     ELSE
      L_General.CallUs(MDocLCU.BoxNbr = ucBoxNbr[i]);
     END;
    ELSIF prvLocation = L_CUC.l_inExpl THEN
     L_General.CallUs(MDocLCU.BoxNbr = ucBoxNbr[i]);
     ucTill[i]:=MDocLCU.Date;
     INC(i);
    END;
    prvLocation:=curLocation;
   END;
   NEXT(MDocLCU);
  END; (* WHILE OCCURE(MDocLCU) ... *)
  RESTORE(MDocLCU);
 END {GetCUCopyUsersCollection};

 PRIVATE PROCEDURE GatherRuns();
  VAR
   ucBoxNbr: LIKE(Car.BoxNbr)[maxCar];
   ucFrom,
   ucTill  : DATE[maxCar];
   Idx     : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("஡");
  GetCUCopyUsersCollection(CUCopy.CUCopy, ucBoxNbr, ucFrom, ucTill);
  Idx:=0;
  WHILE ~!ucBoxNbr[Idx] DO
   SELECT(RWayS, BoxNbr, , ucBoxNbr[Idx]);
   SRCINSEL(RWayS, GE, , ucFrom[Idx]);
   WHILE OCCURE(RWayS) & (RWayS.Date < ucTill[Idx]) DO
    PROMPT(" " + CUCopy.CUCopy + "  " + RWayS.RWayS);
    L_General.Assert(RWayS.Status = L_Way.rwsStat_Rated, " ⠪஢  " + RWayS.RWayS);
    SELECT(RWayJ, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayJ) DO
     CONFORM(RWayJ, Quality);
     IF Quality.Type # L_Way.QualType_Annul THEN
      ADD(runs, TSN,    , RWayS.TSN, CUCopy.CUCopy,
          runs.Run, RWayJ.Fact * RWayJ.Run);
      INC(tmp.Run,  RWayJ.Fact * RWayJ.Run);
     END;
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
   INC(Idx);
  END;
 END {GatherRuns};

 PRIVATE PROCEDURE AcCutForMMode(D          : DATE;
                                 trgMathType: LIKE(MathType.MathType);
                                 trgMMode   : LIKE(MMode.MMode)): LIKE(AcCut.AcCut);
  VAR
   Result: LIKE(AcCut.AcCut);
 BEGIN
  SETEMPTY(Result);
  TRY
   Result:=L_Acnt.GetSpecificAcCutForMTMM(D, trgMathType, trgMMode, L_Acnt.acp_Math_Netto);
  EXCEPT
  ON Exc: Exc_Raise DO

  END;
  RETURN Result;
 END {AcCutForMMode};

 PRIVATE PROCEDURE GetCUCopyPrice(): L_XObj.tSum;
  VAR
   PriceNew,
   Result  : L_XObj.tSum;
   curAcCut: LIKE(AcCut.AcCut);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SELECT(MDocLCU, CUCopy, , CUCopy.CUCopy, L_MDoc.st_Passed);
   WHILE OCCURE(MDocLCU) & (MDocLCU.OpKind = L_CUC.ok_Mentioning) DO
    NEXT(MDocLCU);
   END;
   CONFORM(MDocLCU, MDocList);
   CONFORM(MDocList, MDoc);
   Result:=L_MathR.GetMDLMathPrice();
   IF Result = 0 THEN
    CONFORM(MDocList, Math);
    curAcCut:=AcCutForMMode(MDoc.Date, Math.MathType, MDocList.MMode);
    IF ~!curAcCut THEN
     SEARCH(AcCut, AcCut, , curAcCut);
     Result:=L_MathR.GetANYMathPrice(MDoc.Date, Math.Math, MDoc.MyFirm, AcCut.PriceGrp);
    END;
   END;
   IF (Result # 0) & (MDocList.MMode = L_MathR.mm_Restored) THEN (*0101883 06.02.2014 18:11:45 VOLPATP\Bor.Polak*)
    curAcCut:=AcCutForMMode(MDoc.Date, Math.MathType, L_MathR.mm_New);
    IF ~!curAcCut THEN
     SEARCH(AcCut, AcCut, , curAcCut);
     PriceNew:=L_MathR.GetANYMathPrice(MDoc.Date, Math.Math, MDoc.MyFirm, AcCut.PriceGrp);
    END;
    Result:=Math.Max(PriceNew-Result, 0);
   END;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetPrice};

 PRIVATE PROCEDURE MakeCUCopyIdx();
  VAR
   LifeTimeUnit: P_Math.tLifeTimeUnit;
 BEGIN
  APP.Get().NewPrompt("");
  CreateTemp();
  SELECT(Math, CarUnit, , E_CUTires());
  WHILE OCCURE(Math) DO
   IF Math.Leaf THEN
    SETSEL(MDocList, Math, Math.Math);
    SRCINSEL(MDocList, GE, , Memo.ud_fr());
    WHILE OCCURE(MDocList) & (MDocList.Date <= Memo.ud_ut()) DO
     PROMPT(" "+Math.Math+" "+L_DatTim.DateStr(MDocList.Date));
     CONFORM(MDocList, MDoc);
     IF MDoc.Status = L_MDoc.st_Passed THEN
      CONFORM(MDocList, MDocLCU);
      WHILE OCCURE(MDocLCU) DO
       IF (MDocLCU.OpKind = L_CUC.ok_Retire) | (MDocLCU.OpKind = L_CUC.ok_toCR1) | (MDocLCU.OpKind = L_CUC.ok_toCR2) THEN
        CONFORM(MDocLCU, CUCopy);
        TRY [RESTORE_CURSORS(RC_ON)]
         tmp.Cond:=L_CUC.GetInitCUCondition(CUCopy.CUCopy);
         IF E_IsRetireToSurfacing() | (tmp.Cond = L_CUC.cnd_Restored) THEN
          IF tmp.Cond = L_CUC.cnd_Restored THEN
           P_Math.GetLifeTime(Math.Math, MDocLCU.Date, L_CUC.cnd_Restored, LifeTimeUnit, tmp.Norm);
          ELSE
           P_Math.GetLifeTime(Math.Math, MDocLCU.Date, L_CUC.cnd_New,      LifeTimeUnit, tmp.Norm);
          END;
          L_General.Assert(~!tmp.Norm, " 㪠 ப 㦡  " + Math.Math +
                                       "  " + L_DatTim.DateStr(MDocLCU.Date));
          L_General.Assert(LifeTimeUnit = P_Math.ltu_ThousandKm,
                           "ப 㦡  " + Math.Math + " 㪠   ..???");
          tmp.Norm  :=tmp.Norm*1000;
          tmp.CUCopy:=CUCopy.CUCopy;
          IF ~!CUCopy.InitRun THEN
           tmp.Run   :=CUCopy.InitRun;
          ELSE
           tmp.Run   :=0;
          END;
          GatherRuns();
          tmp.Price:=GetCUCopyPrice();
          INSERT(tmp);
         END;
        EXCEPT
        END; (* TRY *)
       END;
       NEXT(MDocLCU);
      END; (* WHILE OCCURE(MDocLCU) ... *)
     END;

     NEXT(MDocList);
    END; (* WHILE OCCURE(MDocList) ... *)
   END; (* IF Math.Leaf ... *)
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)
 END {MakeCUCopyIdx};

 PRIVATE PROCEDURE Make(RepName: STRING[]);
  VAR
   Prc,
   OverRun     : NUMERIC[1];
   Price,
   sum         : L_XObj.tSum;
   HasStf      : SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
  MakeCUCopyIdx();

  APP.Get().NewPrompt("");
  FIO.Open(R, L_General.NameConnection(RepName), "rep", Create);
  MakeTop("R");
  SELECT(tmp, CUCopy);
  WHILE OCCURE(tmp) DO
   PROMPT(" "+CUCopy.CUCopy);
   CONFORM(tmp, CUCopy);
   CONFORM(CUCopy, Math);
   OverRun:=Math.Max(0, tmp.Run - tmp.Norm);
   IF OverRun > 0 THEN
    Prc  :=BonusPrc(tmp.Cond);
    Price:=GetCUCopyPrice();
    sum  :=Price * OverRun * Prc / tmp.Norm / 100;
    HasStf:=0;
    SELECT(runs, CUCopy, , CUCopy.CUCopy);
    WHILE OCCURE(runs) DO
     CONFORM(runs, Staff);
     IF L_Staff.rInState(Memo.ud_ut()) & (runs.Run > 0) THEN
      CONFORM(Staff, Man);
      runs.Sum:=sum * runs.Run / tmp.Run;
      REPLACE(runs);
      IF (runs.Run > tmp.Run * 0.05) THEN
       MakeLine("R", 0, Price);
       HasStf:=1;
      END;
     END;
     NEXT(runs);
    END; (* WHILE OCCURE(runs) ... *)
    IF ~HasStf THEN
     MakeLine("R", 1, Price);
    END;
   END;
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)
  FIO.Close(R);
  PurgeTemp();
 END {Make};

 PUBLIC PROCEDURE FO_TE();
  CONST
   bpId = "FO_TE";
 BEGIN
  L_bp.Begin(bpId, " ६   १", L_bp.t_Basis, L_General.tc_inIntvl);
  Make(bpId);
  L_bp.End();
 END {FO_TE};

END.
