(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose       ⮯  ࢠ
%Type        report
%Specific    AP
%Modified    27.07.2012 17:41:24 POLAK\GAV
%Environment
*)

 MODULE Fuel_Obj [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_EC, L_Fuel, L_AFM, L_XDoc, L_Way, L_Car, L_Staff, L_Str, P_Car,
        P_Firm, Str, E_UI, L_Env, L_DatTim;

 PRIVATE VAR
  RepName   : STRING[];
  _FuelTake : LIKE(RWayF.FuelTake);
  _FuelRet  : LIKE(RWayF.FuelRet);
  _RemExit  : LIKE(RWayS.RemExit);
  _RemEntr  : LIKE(RWayS.RemEntr);
  _Run      : NUMERIC[2];

  s_FuelFact: NUMERIC[2];
  s_FuelNorm: NUMERIC[4];
  s_FuelTake: NUMERIC[2];
  s_FuelRet : NUMERIC[2];
  s_Run     : NUMERIC[2];

  IsTSN_Mode,
  IsBoxNbr_Mode,
  IsEU_Mode : SCAL[2];

(*
$P {Top:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
###################################################################### ########## #####
=#####=================================================================================
|       ##########  室 ⮯  ਮ  ##########  ##########       |
}

$P {S_Header:
Staff.TSN, L, ""
Man.Name, L, ""
@
|-------------------------------------------------------------------------------------|
|##### ################################################                               |
|-------------------------------------------------------------------------------------|
||. |. |室    |  ஡|-|-| 뤠||   |  ଠ|   | |
|----|-------|-----|---------|--------|---|---|-------|-----|-------|-------|-------|-|
}

$P {FuelCorH:
P_Car.P_CarFuelCor, L, ""
@
|-------------------------------------------------------------------------------------|
|                    ࠢ  ଠ ⮯ (᢮⢮  ####)                     |
|-------------------------------------------------------------------------------------|
|         |        |           |   . .|           ணॢ|
|----------|----------|---------------------|--------------------|--------------------|
}

$P {FuelCor:
CarPro.Date, L, "D.N.y"
CarPro.EndDate, L, "D.N.y"
?, R, "3."
?, R, "3."
?, R, "3."
@
|##########|##########|#####################|####################|####################|
}

$P {C_Header:
Car.BoxNbr, L, ""
Car.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
@
|-------------------------------------------------------------------------------------|
|#### ########## ઠ: #### #########################################################|
|-------------------------------------------------------------------------------------|
||. |. |室    |  ஡|-|-| 뤠||   |  ଠ|   ||
|----|-------|-----|---------|--------|---|---|-------|-----|-------|-------|-------|-|
}

$P {Line:
RWayS.Date, L, "DN"
RWayS.RWayS, L, ""
?, L, ""
RWayS.Exit, R, ""
_Run, R, "2."
RWayS.RemExit, R, "0"
RWayS.RemEntr, R, "0"
_FuelTake, R, "2."
_FuelRet, R, "0"
RWayS.FuelFact, R, "2."
RWayS.FuelNorm, R, "2."
?, R, "2."
?, C, "*| |!"
@
|####|#######|#####|#########|########|###|###|#######|#####|#######|#######|#######|#|
}

$P {Itog:
?, L, ""
s_Run, R, "2."
_RemExit, R, "0"
_RemEntr, R, "0"
s_FuelTake, R, "2."
s_FuelRet, R, "0"
s_FuelFact, R, "2."
s_FuelNorm, R, "2."
s_FuelNorm-s_FuelFact, R, "2."
EcPrcStr(s_FuelNorm, s_FuelFact), R, ""
@
|----------------------------|--------|---|---|-------|-----|-------|-------|-------|-|
|⮣ ######################|########|###|###|#######|#####|#######|#######|#######| |
|                            |        |   |   |       |     |       |       |#######| |
}
*)

(*
$P {ItIsOk:
@
|-------------------------------------------------------------------------------------|
|                                室                                       |
=(c) Polak=============================================================================
}
*)

(*
$P{ ObjTop:
?, L, ""
?, L, ""
@
|=====================================================================================|
|#####|###############################################                 |   |% |
|-----|----------------------------------------------------------------|-------|------|
}
*)

(*
$P{ Obj:
?, L, ""
?, L, ""
?, R, "2."
?, R, ""
@
|#####|################################################################|#######|######|
}
*)
(*
$P{ Bot:
@
=(c) Polak=============================================================================
}
*)

 PRIVATE PROCEDURE EcPrcStr(P, F: FLOAT): STRING[];
  VAR
   Prc: FLOAT;
 BEGIN
  IF P > 0 THEN
   Prc:=(P - F) * 100 / P;
   IF Prc > -100 THEN
    RETURN FLDTOSTR(Prc, "1.") + "%";
   ELSE
    RETURN FLDTOSTR(Prc, "0") + "%";
   END;
  ELSE
   RETURN "";
  END;
 END {EcPrcStr};

 PRIVATE PROCEDURE TSN_Mode(): SCAL[2];
 BEGIN
  RETURN IsTSN_Mode;
 END {TSN_Mode};

 PRIVATE PROCEDURE BoxNbr_Mode(): SCAL[2];
 BEGIN
  RETURN IsBoxNbr_Mode;
 END {BoxNbr_Mode};

 PRIVATE PROCEDURE FromEU_Mode(): SCAL[2];
 BEGIN
  RETURN IsEU_Mode;
 END {FromEU_Mode};

 PRIVATE PROCEDURE NeedSrvList_Mode(): SCAL[2];
 BEGIN
  RETURN ~FromEU_Mode();
 END {NeedSrvList_Mode};

 PRIVATE PROCEDURE SingleRW();
  CONST
   c_Broken    = 0;
   c_Correct   = 1;
   c_BreakTrip = 2;
  VAR
   Chain  : SCAL[3];
   _XDocId: L_XDoc.tXDocId;
 BEGIN
  IF RWayS.Status = L_Way.rwsStat_Rated THEN
   Chain  :=c_Correct;
   PROMPT("⥢  "+RWayS.RWayS);
   CONFORM(RWayS, Car);
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   CONFORM(CarLog, Mark);
   IF    TSN_Mode() & L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
    ADD(_Obj, _Code, , RWayS.BoxNbr, Str.Align(CarLog.StateNbr, Str.MaxLength(CarLog.StateNbr), LEFT) + " " + Mark.Name,
                       _Obj._Plan, RWayS.FuelNorm,
                       _Obj._Fact, RWayS.FuelFact);
   ELSIF BoxNbr_Mode() & L_Env.RealTSN(RWayS.TSN) THEN
    CONFORM(RWayS, Staff);
    CONFORM(Staff, Man);
    ADD(_Obj, _Code, , RWayS.TSN, Man.Name,
                       _Obj._Plan, RWayS.FuelNorm,
                       _Obj._Fact, RWayS.FuelFact);
    IF !_RemExit THEN
     _RemExit:=RWayS.RemExit;
     SAVE(RWayS);
     IF PREV(RWayS) THEN
      _RemEntr:=RWayS.RemEntr;
      RESTORE(RWayS);
     ELSE
      RESTORE(RWayS);
      _RemEntr:=RWayS.RemExit;
     END;
    END;
    IF RWayS.RemExit # _RemEntr THEN
     Chain:=c_Broken;
    END;
    _RemEntr:=RWayS.RemEntr;
   END;
   SETZERO(_FuelTake, _FuelRet, _Run);
   SELECT(RWayF, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayF) DO
    IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) THEN
     INC(_FuelTake, RWayF.FuelTake);
     INC(_FuelRet , RWayF.FuelRet );
    END;
    NEXT(RWayF);
   END;
   INC(s_FuelFact, RWayS.FuelFact);
   INC(s_FuelNorm, RWayS.FuelNorm);
   INC(s_FuelTake, _FuelTake);
   INC(s_FuelRet , _FuelRet);
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayJ) DO
    CONFORM(RWayJ, Quality);
    IF Quality.Type # L_Way.QualType_Annul THEN
     INC(_Run, RWayJ.Fact*RWayJ.Run);
    END;
    IF RWayJ.Trip = L_Way.E_TripForFuelChainBreak(RWayS.Date) THEN
     Chain:=c_BreakTrip;
    END;
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ)... *)
   INC(s_Run, _Run);
   IF    TSN_Mode() THEN
    MAKEPART(T, Line, RWayS.BoxNbr, RWayS.FuelNorm-RWayS.FuelFact, Chain);
   ELSIF BoxNbr_Mode() THEN
    MAKEPART(T, Line, RWayS.TSN,    RWayS.FuelNorm-RWayS.FuelFact, Chain);
   END;
   IF NeedSrvList_Mode() THEN
    _XDocId:=L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
    L_XDoc.sl_AddItem(_XDocId, L_XDoc.extXDocStr(_XDocId, L_XDoc.xdast_wDate));
   END;
  END;
 END {SingleRW};

 PRIVATE PROCEDURE E_UI_ShowEconomy(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_UI.UI_ShowEconomy), L_General.IsMemberOf("LEADERS"));
 END {E_UI_ShowEconomy};

 PRIVATE PROCEDURE GetFuelCor();
  VAR
   First: SCAL[2];
   _FCarCMove,
   _FCarCHeat,
   _FCarCWarm: NUMERIC[3];
   FuelCorr  : P_Car.tFuelCorr;
 BEGIN
  First :=1;
  SELECT(CarPro, BoxNbr, , Car.BoxNbr, P_Car.P_CarFuelCor);
  WHILE OCCURE(CarPro) DO
   PROMPT(" ࠢ  ଠ ⮯: " + L_DatTim.DateStr(CarPro.Date));
   IF L_DatTim.IsActiveInIntvl_Inc(CarPro.Date, CarPro.EndDate, Memo.ud_fr(), Memo.ud_ut()) THEN
     P_Car.Decode_CarFuelCor(CarPro.Value, FuelCorr);
    _FCarCMove:=FuelCorr[0];
    _FCarCHeat:=FuelCorr[1];
    _FCarCWarm:=FuelCorr[2];
    IF (_FCarCMove # 1) | (_FCarCHeat # 1) | (_FCarCWarm # 1) THEN
     IF First THEN
      MAKEPART(T, FuelCorH);
      First :=0;
     END;
     MAKEPART(T, FuelCor, _FCarCMove, _FCarCHeat, _FCarCWarm);
    END;
   END;
   NEXT(CarPro);
  END; (* WHILE OCCURE(CarPro) ... *)
 END {GetFuelCor};

 PRIVATE PROCEDURE Create_Obj();
 BEGIN
  CreateFILE(_Obj, "", "", "");

  CreateFIELD(_Obj, _Code, STRING[5],      "",  "", "", "", "");
  CreateFIELD(_Obj, _Name, LIKE(Man.Name), "",  "", "", "", "");
  CreateFIELD(_Obj, _Plan, NUMERIC[4],     "", "0", "", "", "");
  CreateFIELD(_Obj, _Fact, NUMERIC[2],     "", "0", "", "", "");

  CreateINDEX(_Obj, _Code, UNIQUE, "", "", _Code, _Name);

  SetVersionOfFILE(_Obj, 0);
 END {Create_Obj};

 PRIVATE PROCEDURE MakeSingleCard();
  VAR
   DoIt: SCAL[2];
 BEGIN
  IF    TSN_Mode() THEN
   CONFORM(Staff, Man);
   MAKEPART(T, Top, P_Firm.FP_FirmName(L_Staff.GetFirmOfStaff(), SYSDATE()), "⥫");
   MAKEPART(T, S_Header);
   SELECT(RWayS, TSN, , Staff.TSN);
  ELSIF BoxNbr_Mode() THEN
   L_Car.AccessMark(Car.BoxNbr, Memo.ud_ut());
   MAKEPART(T, Top, P_Firm.FP_FirmName(L_Car.GetFirmOfCar(Memo.ud_ut()), SYSDATE()), "⮬");
   GetFuelCor();
   MAKEPART(T, C_Header);
   SELECT(RWayS, BoxNbr, , Car.BoxNbr);
  END;
 
  DoIt:=1;
 
  IF FromEU_Mode() THEN
   SRCINSEL(RWayS, GE, , Memo.ud_fr());
   SETZERO(s_FuelFact, s_FuelNorm);
   WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
    PROMPT("⥢  "+RWayS.RWayS);
    IF RWayS.Status = L_Way.rwsStat_Rated THEN
     INC(s_FuelFact, RWayS.FuelFact);
     INC(s_FuelNorm, RWayS.FuelNorm);
    END;
    NEXT(RWayS);
   END; (* WHILE *)
   IF s_FuelFact <= s_FuelNorm THEN
    IF ~E_UI_ShowEconomy(SYSDATE()) THEN
     MAKEPART(T, ItIsOk);
     DoIt:=0;
    END;
   END;
  END;
 
  IF DoIt THEN
   SETZERO(s_FuelFact, s_FuelNorm, s_FuelTake, s_FuelRet, s_Run);
   SETEMPTY(_RemExit, _RemEntr);

   SRCINSEL(RWayS, GE, , Memo.ud_fr());
   WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
    SingleRW();
    NEXT(RWayS);
   END; (* WHILE *)
 
   IF FromEU_Mode() THEN
    MAKEPART(T, Itog, L_Str.PoolItem("室|", s_FuelNorm >= s_FuelFact));
   ELSE
    MAKEPART(T, Itog, "       ");
   END;
   IF    TSN_Mode() THEN
    MAKEPART(T, ObjTop, ".", Str.Align(".p", Str.MaxLength(CarLog.StateNbr), LEFT) + " p");
   ELSIF BoxNbr_Mode() THEN
    MAKEPART(T, ObjTop, ".", "  ⢮");
   END;
   SELECT(_Obj, _Code);
   WHILE OCCURE(_Obj) DO
    MAKEPART(T, Obj, _Obj._Code, _Obj._Name, _Obj._Plan - _Obj._Fact, EcPrcStr(_Obj._Plan, _Obj._Fact));
    NEXT(_Obj);
   END; (* WHILE OCCURE(_Obj) ... *)
   MAKEPART(T, Bot);
  END;
 END {MakeSingleCard};

 PRIVATE PROCEDURE Make();
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  Create_Obj();
  L_AFM.AF_CreateTemp("_Obj", "_Obj");
 
  IF NeedSrvList_Mode() THEN
   L_XDoc.sl_Init("⥢ ");
  END;
  IF    TSN_Mode() THEN
   IF ~FromEU_Mode() THEN
    L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
   END;
   RepName:="FuelD";
  ELSIF BoxNbr_Mode() THEN
   IF ~FromEU_Mode() THEN
    L_General.Assert(ACCESS(Car), " ⠭ ⥪騩 ⮬");
   END;
   RepName:="FuelC";
  ELSE
   L_General.CallUs(0);
  END;
  IF ~FromEU_Mode() THEN
   OPENREP(T, L_General.NameConnection(RepName), Create);
  END;
 
  MakeSingleCard();
  L_AFM.AF_PurgeTemp("_Obj");
  IF NeedSrvList_Mode() THEN
   L_XDoc.sl_Done();
  END;
  IF ~FromEU_Mode() THEN
   CLOSEREP(T);
  END;
 END {Make};

 PUBLIC PROCEDURE FuelD();
 BEGIN
  IsTSN_Mode   :=1;
  IsBoxNbr_Mode:=0;
  IsEU_Mode    :=0;
  Make();
 END {FuelD};

 PUBLIC PROCEDURE FuelC();
 BEGIN
  IsTSN_Mode   :=0;
  IsBoxNbr_Mode:=1;
  IsEU_Mode    :=0;
  Make();
 END {FuelC};

 PUBLIC PROCEDURE FuelD_EU();
 BEGIN
  IsTSN_Mode   :=1;
  IsBoxNbr_Mode:=0;
  IsEU_Mode    :=1;
  Make();
 END {FuelD_EU};

 PUBLIC PROCEDURE FuelC_EU();
 BEGIN
  IsTSN_Mode   :=0;
  IsBoxNbr_Mode:=1;
  IsEU_Mode    :=1;
  Make();
 END {FuelC_EU};

END.
