(*
%Copyright   (c) Polak IT
%Author      25.07.2008 19:01:19 POLAK\Bor
%Purpose     ࠢ筠 ⠭
%Type        control
%Specific    AP
%Modified    07.08.2014 17:41:06 POLAK\GAV
%Environment
*)

 MODULE GasStan [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_Events, L_MDoc, L_Timer,
        L_XObj, L_BegRWS, L_XDoc, L_Str, L_Way, L_Car, L_WDO, L_MathR,
        L_Fuel, L_Stock, L_Prop, L_Cntr, L_Env, L_StdFrm, P_Firm, P_MDoc,
        FIO, Str, E_Stock, L_FIO, P_Storage, Math, P_Man, L_Dest, L_SES,
        SysLog, L_CUC, L_Rpr, L_Acnt, L_Money, P_Cntr, L_SysLog, L_Staff,
        L_AR, L_APtm;

 PRIVATE TYPE
  tNeftoServerDest = SCAL[10];
  tOperation       = SCAL[9];
  tGasStanMode     = SCAL[5];
  tLoadingProgress = SCAL[3];
  tGasStanPumpArr  = P_Storage.tPump[P_Storage.MaxGasStanPumpAmount];

 PRIVATE CONST
  csv_XDocId             = 0;
  csv_DTS                = 1;
  csv_BoxNbr             = 2;
  csv_Math               = 3;
  csv_Nozzle             = 4;
  csv_Qnt                = 5;
  csv_Sum                = 6;
  csv_Dest               = 7;
  csv_StateNbr           = 8;
  csv_TSN                = 9;
  csv_Comment            = 10;
  csv_ORPAK_StateNbr     = 11;
  csv_ORPAK_BoxNbr       = 12;
  csv_ORPAK_Run          = 13;
  csv_ORPAK_EngineWrkTim = 14;

  o_StartLoading = 0;
  o_StopLoading  = 1;

  s_Error       = "!";
  s_StopLoading = "S";

  i_Service = 0;
  i_PRM     = 1;
  i_Cash    = 2;
  i_Sign    = 3;

  lp_Wait      = 0;
  lp_AcceptPRM = 1;
  lp_Start     = 2;

  gsm_Idle      = 0;
  gsm_BuildNOV  = 1;
  gsm_BuildTOV  = 2;
  gsm_BuildMSP  = 3;
  gsm_OutCar    = 4;

  gsm_Pool = "...|ࠢ ᮡ⢥ | ⥯த⮢  | ⥯த⮢  |ࠢ ஭ ";

  GasStanWindowName = "GasStan";

  v_Operation   = "Operation";
  v_XDocType    = "XDocType";
  v_XDoc        = "XDoc";
  v_XDocDescr_1 = "XDocDescr_1";
  v_XDocDescr_2 = "XDocDescr_2";
  v_CashTitle   = "Cash_Title";
  v_Cash        = "Cash";
  v_SumTitle    = "Sum_Title";
  v_Sum         = "Sum";
  v_Math        = "Math";
  v_Qnt         = "Qnt";
  v_Nozzle      = "Nozzle";

  v_GP_Pump     = "GP_Pump";
  v_GP_Nozzle   = "GP_Nozzle";
  v_GP_Progress = "GP_Progress";
  v_GP_XD       = "GP_XD";
  v_GP_MD       = "GP_MD";
  v_GP_MathName = "GP_MathName";
  v_GP_Car      = "GP_Car";
  v_GP_Staff    = "GP_Staff";
  v_GP_Qnt      = "GP_Qnt";
  v_GP_DTS      = "GP_DTS";
  v_GP_TimePass = "GP_TimePass";

  nsd_Car         = 0;
  nsd_OutCar      = 1;
  nsd_Auxiliaries = 2;
  nsd_Pumping     = 3;
  nsd_BegShift    = 4;
  nsd_EndShift    = 5;

  gs_Settings = "gs_Settings";

  gssi_Storage         = 0;
  gssi_InteractionMode = 1;
  gssi_PRM_Path        = 2;

  im_Normal = 0;
  im_woPRM  = 1;

  gfpm_Silent = 0;
  gfpm_Soft   = 1;
  gfpm_Strong = 2;

 PRIVATE PERMANENT VAR
  BadADV     : OBJECT;
  GasStanMode: tGasStanMode;
  OwnPumps   : P_Storage.tOwnPumpArr;
  OwnNozzles : P_Storage.tOwnNozzleArr;
  OwnMaths   : P_Storage.tOwnMathArr;
  OutNozzles : P_Storage.tOutNozzleArr;
  OutMaths   : P_Storage.tOutMathArr;

 PRIVATE PROCEDURE gs_GetSettings(    trgStorage     : LIKE(Storage.Storage);
                                  VAR InteractionMode: SCAL[2];
                                  VAR PRM_Path       : STRING[]);
  VAR
   i          : NUMERIC[0];
   Value,
   SingleValue: STRING[];
 BEGIN
  InteractionMode:=im_Normal;
  PRM_Path       :="";
  IF ~!trgStorage & L_SES.GetValue(L_SES.sit_Station, gs_Settings, Value) THEN
   i:=0;
   LOOP
    SingleValue:=L_Prop.getAIS(Value, i);
    IF !SingleValue THEN
     EXIT;
    END;
    IF trgStorage = STRTOFLD(L_Prop.getRES(SingleValue, gssi_Storage), SCAL) THEN
     InteractionMode:=STRTOFLD(L_Prop.getRES(SingleValue, gssi_InteractionMode), SCAL);
     PRM_Path       :=STRTOFLD(L_Prop.getRES(SingleValue, gssi_PRM_Path), STRING);
     EXIT;
    END;
    INC(i);
   END (* LOOP *);
  END;
 END {gs_GetSettings};

 PRIVATE PROCEDURE GetInteractionMode(trgStorage: LIKE(Storage.Storage)): SCAL[2];
  VAR
   Dummy          : STRING[];
   InteractionMode: SCAL[2];
 BEGIN
  gs_GetSettings(trgStorage, InteractionMode, Dummy);
  RETURN InteractionMode;
 END {GetInteractionMode};

 PRIVATE PROCEDURE E_gs_IsFuelStation(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Stock.gs_IsFuelStation);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 1;
  END;
 END {E_gs_IsFuelStation};

 PRIVATE PROCEDURE E_gs_GetKind(): L_Fuel.tGasStanKind;
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Stock.gs_GetKind);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   IF E_gs_IsFuelStation() THEN
    RETURN L_Fuel.gsk_NeftoServer;
   ELSE
    RETURN L_Fuel.gsk_ElectroServis;
   END;
  END;
 END {E_gs_GetKind};

 PRIVATE PROCEDURE TimedCHOICE(Body: STRING[]);
  VAR
   T: NUMERIC[0];
 BEGIN
  T:=30;
  STDFORM(Body + "|| %< {}⬥ >X     %< {} %T >DB",
          "",
          STOP,
          1,
          T);
 END {TimedCHOICE};

 PRIVATE PROCEDURE GetWorkPath(gfpm: SCAL[3]): STRING[];
  VAR
   Dummy : SCAL[2];
   Msg,
   Result: STRING[];
 BEGIN
  gs_GetSettings(L_Stock.DefaultStorage(), Dummy, Result);

  IF ~!Result & ~FIO.DirExists(Result) THEN
   Msg:="   䠩  ࠢ饩 ணࠬ|" +
        Result + "|" +
        "㯭   .||  ";
   IF    gfpm = gfpm_Silent THEN
    SETEMPTY(Result);
   ELSIF gfpm = gfpm_Soft THEN
    L_StdFrm.TimedINFORM_AsSTOP(Msg, 15);
    SETEMPTY(Result);
   ELSIF gfpm = gfpm_Strong THEN
    WHILE ~FIO.DirExists(Result) DO
     TimedCHOICE(Msg);
    END;
   ELSE
    L_General.CallUs(0);
   END;
  END;
  RETURN Result;
 END {GetWorkPath};

 PRIVATE PROCEDURE GetArchPath(): STRING[];
 BEGIN
  IF E_gs_IsFuelStation() THEN
   RETURN FIO.FullPath("TXT\NEFTO");
  ELSE
   RETURN FIO.FullPath(GetWorkPath(gfpm_Strong));
  END;
 END {GetArchPath};

 PRIVATE PROCEDURE CheckFolderExists(Cond: SCAL[2]);
 BEGIN
  L_General.Assert(Cond, " ᠭ    䠩  ࠢ饩 ணࠬ.||" +
                         "室 믮 ன ᮯ殮|"+
                         "'ࠢ筮 ⠭樨'  ࠢ饩 ணࠬ");
 END {CheckFolderExists};

 PRIVATE PROCEDURE GetArchFullPath(_Date: DATE): STRING[];
  VAR
   ArchPath,
   ArchFullPath: STRING[];
 BEGIN
  ArchPath:=GetArchPath();
  CheckFolderExists(~!ArchPath);
  ArchFullPath:=FIO.BuildPath(FLDTOSTR(_Date, "yN"), , FIO.BuildPath("ARCH", , ArchPath));
  L_FIO.MakeSubDirs(ArchFullPath);
  RETURN ArchFullPath;
 END {GetArchFullPath};

 PRIVATE PROCEDURE GetAnyFileName(Operation: tOperation; Ext: STRING[]): STRING[];
 BEGIN
  RETURN FIO.BuildPath(L_XDoc.curXDocId(L_XDoc.xdt_MDoc) + Operation, Ext);
 END {GetAnyFileName};

 PRIVATE PROCEDURE GetPRMFileName(Operation: tOperation): STRING[];
 BEGIN
  RETURN GetAnyFileName(Operation, "PRM");
 END {GetPRMFileName};

 PRIVATE PROCEDURE GetCmdFileName(trgDest: tNeftoServerDest; sysDTS: TIMESTAMP): STRING[];
 BEGIN
  RETURN FIO.BuildPath("cmd" + FLDTOSTR(sysDTS, "yNDHMST") + trgDest, "PRM");
 END {GetCmdFileName};

 PRIVATE PROCEDURE GetGasStanField(FieldName: STRING[]): FORM_FIELD;
  VAR
   w     : FORM_WINDOW;
   Result: FORM_FIELD;
 BEGIN
  w     :=APP.Get().Forms(GasStanWindowName);
  IF ~w.Visible THEN
   L_General.Error("   'ࠢ筠 ⠭'");
  END;
  Result:=w.Zones(0).Fields(FieldName);
  IF !Result THEN
   L_StdFrm.RedInform("ॡ १ 'ࠢ筮 ⠭樨'.|" +
                      "饥  㤥 .||" +
                      "᫨ 訡 㤥 ,   ");
   GasStanMode:=gsm_Idle;
   L_Timer.ResetTimer("GasStan_Stat");
   LIKEMENU(Cancel, "NoSave");
  END;
  RETURN Result;
 END {GetGasStanField};

 PRIVATE PROCEDURE getFV_Number(FieldName: STRING[]): FLOAT;
 BEGIN
  RETURN GetGasStanField(FieldName).Value;
 END {getFV_Number};

 PRIVATE PROCEDURE getFV_Scal(FieldName: STRING[]): SCAL[1E7];
 BEGIN
  RETURN GetGasStanField(FieldName).Value;
 END {getFV_Scal};

 PRIVATE PROCEDURE getFV_String(FieldName: STRING[]): STRING[];
 BEGIN
  RETURN GetGasStanField(FieldName).Value;
 END {getFV_String};

 PRIVATE PROCEDURE setFieldValue(FieldName: STRING[]; Value: ANYTYPE);
 BEGIN
  GetGasStanField(FieldName).Value:=Value;
 END {setFieldValue};

 PRIVATE PROCEDURE CalcFuelNorm(): NUMERIC[2];
  VAR
   FNorm,
   Dummy: NUMERIC[3];
 BEGIN
  SETEMPTY(FNorm);
  TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
   L_Way.PrepareFuelInf(FNorm, Dummy)
  EXCEPT
  ON Exc: Exc_Root DO
   L_StdFrm.RedInform(Exc.MsgOriginalText);
  END; (* TRY *)
  RETURN FNorm;
 END {CalcFuelNorm};

 PRIVATE PROCEDURE PosToMath(_Math: LIKE(Math.Math));
 BEGIN
  L_General.CallUs(~!_Math);
  L_General.Assert(SEARCH(Math, Math, _Math), "   "+_Math);
 END {PosToMath};

 PRIVATE PROCEDURE IsOutNozzle(curNozzle: P_Storage.tNozzle): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE (i <= HIGH(OutNozzles)) & ~!OutNozzles[i] DO
   IF curNozzle = OutNozzles[i] THEN
    RETURN 1;
   END;
   INC(i);
  END; (* WHILE (i <= HIGH(OutNozzles)) &...*)
  RETURN 0;
 END {IsOutNozzle};

 PRIVATE PROCEDURE GetNozzleSetup(    curNozzle : P_Storage.tNozzle;
                                  VAR curPump   : P_Storage.tPump;
                                  VAR curMaths  : LIKE(Math.Math)[]);
  VAR
   i, Idx      : NUMERIC[0];
   NozzleExists: SCAL[2];
 BEGIN
  SETEMPTY(curPump, curMaths);
  SETZERO(Idx, i, NozzleExists);
  IF ~IsOutNozzle(curNozzle) THEN
   WHILE Idx <= HIGH(OwnNozzles) DO
    IF curNozzle = OwnNozzles[Idx] THEN
     curPump     :=OwnPumps[Idx];
     curMaths[i] :=OwnMaths[Idx];
     NozzleExists:=1;
     INC(i);
    END;
    INC(Idx);
   END;
  ELSE
   WHILE Idx <= HIGH(OutNozzles) DO
    IF curNozzle = OutNozzles[Idx] THEN
     curMaths[i] :=OutMaths[Idx];
     NozzleExists:=1;
     INC(i);
    END;
    INC(Idx);
   END;
  END; (* IF ~IsOutNozzle() ... *)
  L_General.Assert(NozzleExists, "⨬  ⮫ " + curNozzle);
 END {GetNozzleSetup};

 PRIVATE PROCEDURE GetMathForNozzle(curNozzle: P_Storage.tNozzle): LIKE(Math.Math);
  VAR
   Result   : LIKE(Math.Math);
   acptMaths: LIKE(Math.Math)[10];
   dummy    : P_Storage.tPump;
 BEGIN
  SETEMPTY(Result);
  IF ~!curNozzle THEN
   GetNozzleSetup(curNozzle, dummy, acptMaths);
   IF !acptMaths[1] THEN
    Result:=acptMaths[0];
   END;
  END;
  RETURN Result;
 END {GetMathForNozzle};

 PRIVATE PROCEDURE NozzleToPump(curNozzle: P_Storage.tNozzle): P_Storage.tPump;
  VAR
   dummy  : LIKE(Math.Math)[10];
   curPump: P_Storage.tPump;
 BEGIN
  L_General.CallUs(~IsOutNozzle(curNozzle));
  GetNozzleSetup(curNozzle, curPump, dummy);
  RETURN curPump;
 END {NozzleToPump};

 PRIVATE PROCEDURE PosToRWayS(trgRWayS: LIKE(RWayS.RWayS));
 BEGIN
  L_General.CallUs(~!trgRWayS);
  L_General.Assert(SEARCH(RWayS, RWayS, trgRWayS), "   "+trgRWayS);
 END {PosToRWayS};
 
 PRIVATE PROCEDURE PosToRprS(trgRprS: LIKE(RprS.RprS));
 BEGIN
  L_General.CallUs(~!trgRprS);
  L_General.Assert(SEARCH(RprS, RprS, trgRprS), "   "+trgRprS);
 END {PosToRprS};

 PRIVATE PROCEDURE StandOnMDocByADVFile(FileName: STRING[]; Strong: SCAL[2]): SCAL[2];
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
   _XDoc    : L_XDoc.tXDoc;
   _XDocId  : L_XDoc.tXDocId;
 BEGIN
  _XDocId:=Str.Slice(L_FIO.effp_FileName_woExt(FileName), 0, 13);
  L_XDoc.DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
  IF SEARCH(MDoc, MDoc, _XDocKind, _XDoc) THEN
   RETURN 1;
  ELSE
   L_General.CallUs(~Strong);
   RETURN 0;
  END;
 END {StandOnMDocByADVFile};

 PRIVATE PROCEDURE GetStrCSV(s: STRING[]; i: NUMERIC[0]): STRING[];
 BEGIN
  s:=Str.Item(s, ",", i);
  s:=Str.Item(Str.Condense(s), '"', 0);
  RETURN s;
 END {GeStrCSV};

 PRIVATE PROCEDURE GetNumCSV(s: STRING[]; i: NUMERIC[0]): NUMERIC[2];
 BEGIN
  RETURN L_Str.StrToNum(GetStrCSV(s, i), "", 1);
 END {GetNumCSV};

 PRIVATE PROCEDURE ConvSumToStr(trgSum: L_XObj.tSum): STRING[];
 BEGIN
  RETURN L_Money.MoneyToStr(SYSDATE(), ",", trgSum);
 END {ConvSumToStr};

 PRIVATE PROCEDURE ConvQntToStr(trgQnt: L_XObj.tQnt): STRING[];
 BEGIN
  RETURN FLDTOSTR(trgQnt, "2.", 0);
 END {ConvQntToStr};

 PRIVATE PROCEDURE E_GetNeftoServerDest(): tNeftoServerDest;
  VAR
   Local : PROC;
   Result: tNeftoServerDest;
 BEGIN
  SETEMPTY(Result);
  IF    MDoc.MDocKind = L_MDoc.md_NOV THEN
   Result:=nsd_Car;
  ELSIF MDoc.MDocKind = L_MDoc.md_TCh THEN
   Result:=nsd_OutCar;
  ELSIF MDoc.MDocKind = L_MDoc.md_VPC THEN
   Result:=nsd_OutCar;
  ELSIF MDoc.MDocKind = L_MDoc.md_TOV THEN
   Result:=nsd_Auxiliaries;
  ELSIF MDoc.MDocKind = L_MDoc.md_MSP THEN
   Result:=nsd_Auxiliaries;
   Local:=PROCREF(E_Stock.gs_IsPumping);
   IF ~!Local THEN
    IF Local() THEN
     Result:=nsd_Pumping;
    END;
   ELSE
    L_StdFrm.Inform("ଫ  ⥯த⮢  孮᪨ 㦤.||" +
                    " ଫ 'ப窨 ' 室 |" +
                    "   ன");
   END;
  END;
  L_General.CallUs(~!Result);
  RETURN Result;
 END {E_GetNeftoServerDest};

 PRIVATE PROCEDURE AddQM(S: STRING[]): STRING[];
 BEGIN
  RETURN '"' + S + '"';
 END {AddQM};

 PRIVATE PROCEDURE GetServiceCSV(trgDest: tNeftoServerDest; sysDTS: TIMESTAMP): STRING[];
 BEGIN
  RETURN AddQM("")                              + "," +
         AddQM(FLDTOSTR(sysDTS, "D.M.y H:M:S")) + "," +
         AddQM("")                              + "," +
         AddQM("")                              + "," +
         AddQM("")                              + "," +
         AddQM("")                              + "," +
         AddQM("")                              + "," +
         AddQM(trgDest)                         + "," +
         AddQM("")                              + "," +
         AddQM(L_Staff.Man2TSN(SYSDATE(), P_Man.curUSER2Man(), EMPTYOF(P_Firm.tMyFirm), 0, 1)) + "," +
         AddQM("")
 END {GetServiceCSV};

 PRIVATE PROCEDURE GetMDocServiceNoteItem(Item: NUMERIC[0]): STRING[];
  VAR
   ServiceNote: STRING[];
 BEGIN
  ServiceNote:=P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_ServiceNote);
  IF P_MDoc.IsAutoBuildServiceNote(ServiceNote) THEN
   RETURN Str.Item(ServiceNote, ";", Item);
  ELSE
   RETURN "";
  END;
 END {GetMDocServiceNoteItem};

 PRIVATE PROCEDURE GetMDocCSV(): STRING[];
 BEGIN
  RETURN GetMDocServiceNoteItem(i_PRM);
 END {GetMDocCSV};

 PRIVATE PROCEDURE GetMDocSpecificSign(): STRING[];
 BEGIN
  RETURN GetMDocServiceNoteItem(i_Sign);
 END {GetMDocSpecificSign};

 PRIVATE PROCEDURE GetMDocCash(): NUMERIC[2];
 BEGIN
  RETURN STRTOFLD(Str.Replace(GetMDocServiceNoteItem(i_Cash), '"', ""), NUMERIC);
 END {GetMDocCash};

 PRIVATE PROCEDURE HasMDocAlert(): SCAL[2];
 BEGIN
  RETURN GetMDocSpecificSign() = s_Error;
 END {HasMDocAlert};

 PRIVATE PROCEDURE HasMDocStopLoading(): SCAL[2];
 BEGIN
  RETURN GetMDocSpecificSign() = s_StopLoading;
 END {HasMDocStopLoading};

 PRIVATE PROCEDURE SetMDocSpecificSign(_Sign: STRING[]);
 BEGIN
  MDocPro.Value:=MDocPro.Value+';' + _Sign;
  REPLACE(MDocPro);
 END {SetMDocSpecificSign};

 PRIVATE PROCEDURE ClearMDocSpecificSign();
 BEGIN
  MDocPro.Value:=Str.Delete(MDocPro.Value, Str.Length(MDocPro.Value)-2, 2);
  REPLACE(MDocPro);
 END {ClearMDocSpecificSign};

 PRIVATE PROCEDURE SetAlertSign();
 BEGIN
  IF ~HasMDocAlert() THEN
   TRY [TRANSACTION(TRANSACTION_SLAVE)]
    IF HasMDocStopLoading() THEN
     ClearMDocSpecificSign();
    END;
    SetMDocSpecificSign(s_Error);
   EXCEPT
   ON Exc: Exc_Root DO
    RAISE();
   END; (* TRY *)
  END;
 END {SetAlertSign};

 PRIVATE PROCEDURE extSetEmptyHeadFields(SetEmptyAllFields: SCAL[2]);
 BEGIN
  IF SetEmptyAllFields THEN
   setFieldValue(v_XDocType,    "");
   setFieldValue(v_XDoc,        "");
   setFieldValue(v_XDocDescr_1, "");
   setFieldValue(v_XDocDescr_2, "");
   setFieldValue(v_Nozzle,      "");
   setFieldValue(v_Cash,        EMPTYOF(L_XObj.tSum));
   setFieldValue(v_Sum,         EMPTYOF(L_XObj.tSum));
  END;
  setFieldValue(v_Math,      "");
  setFieldValue(v_Qnt,       EMPTYOF(L_XObj.tQnt));
 END {extSetEmptyHeadFields};

 PRIVATE PROCEDURE SetField(FieldName: STRING[]; Visible: SCAL[2]; Color: NUMERIC[0]; ForceSetColor: SCAL[2]);
  VAR
   Field: FORM_FIELD;
 BEGIN
  Field:=GetGasStanField(FieldName);
  Field.Visible:=Visible;
  IF    ForceSetColor THEN
   Field.Color:=Color;
  ELSIF HasMDocAlert() THEN
   Field.Color:=FORM_FIELD.Color_Field1;
  ELSIF HasMDocStopLoading() THEN
   Field.Color:=FORM_FIELD.Color_Field2;
  END;
 END {SetField};

 PRIVATE PROCEDURE SetCashLoadingFields(Visible: SCAL[2]);
 BEGIN
  setFieldValue(v_CashTitle, "ਭ ");
  setFieldValue(v_SumTitle, " 㬬");

  SetField(v_CashTitle, Visible, FORM_FIELD.Color_Text,   1);
  SetField(v_Cash,      Visible, FORM_FIELD.Color_Field2, 1);
  SetField(v_SumTitle,  Visible, FORM_FIELD.Color_Text,   1);
  SetField(v_Sum,       Visible, FORM_FIELD.Color_Field2, 1);

  GetGasStanField(v_Sum).Modifiable:=1;
  GetGasStanField(v_Qnt).Modifiable:=1;
 END {SetCashLoadingFields};

 PRIVATE PROCEDURE SetEmptyHeadFields();
 BEGIN
  extSetEmptyHeadFields(1);
  SetCashLoadingFields(0);
 END {SetEmptyHeadFields};

 PRIVATE PROCEDURE SetCurrentOperation(curGasStanMode: tGasStanMode);
 BEGIN
  IF !GetWorkPath(gfpm_Soft) THEN
   setFieldValue(v_Operation, "! ॡ 믮 ன ࠢ筮 ⠭樨 !");
  ELSE
   setFieldValue(v_Operation, L_Str.PoolItem(gsm_Pool, curGasStanMode));
  END;
  GasStanMode:=curGasStanMode;
  IF GasStanMode = gsm_Idle THEN
   SetEmptyHeadFields();
  END;
 END {SetCurrentOperation};

 PRIVATE PROCEDURE CreateFile(FileName, csv: STRING[]);
  VAR
   PRM_Path,
   tmpFN,
   arcFN,
   wrkFN,
   tmpExt: STRING[];
 BEGIN
  PRM_Path:=GetWorkPath(gfpm_Strong);
  CheckFolderExists(~!PRM_Path);
  tmpExt:=L_FIO.effp_FileExt(FileName);
  tmpExt:=Str.Slice(tmpExt, 0, Str.Length(tmpExt)-1) + "_";
  tmpFN:=L_FIO.GetUniqueFileNameInFolder(FIO.BuildPath(L_FIO.effp_FileName_woExt(FileName), tmpExt), GetArchFullPath(SYSDATE()));
  FIO.Open(outF, tmpFN, , Create);
  FIO.WrStr(outF, csv);
  FIO.Close(outF);

  arcFN:=L_FIO.GetUniqueFileNameInFolder(FileName, GetArchFullPath(SYSDATE()));
  L_FIO.ExactFileCopy(tmpFN, arcFN);

  wrkFN:=FIO.BuildPath(FileName, , PRM_Path);
  FIO.Rename(tmpFN, , wrkFN);
 END {CreateFile};

 PRIVATE PROCEDURE ShiftManipulation(trgDest: tNeftoServerDest);
  VAR
   sysDTS           : TIMESTAMP;
   ManipulationAsStr: STRING[];
 BEGIN
  L_General.Assert(E_gs_GetKind() = L_Fuel.gsk_NeftoServer, "  ন");
  IF trgDest = nsd_BegShift THEN
   ManipulationAsStr:="⨥";
  ELSE
   ManipulationAsStr:="⨥";
  END;
  sysDTS:=L_DatTim.GetSysTIMESTAMP();
  L_StdFrm.Question(ManipulationAsStr + " ᬥ.||" +
                    "६: " + L_DatTim.TimestampStr(sysDTS));

  CreateFile(GetCmdFileName(trgDest, sysDTS), GetServiceCSV(trgDest, sysDTS));
 END {ShiftManipulation};

 PRIVATE PROCEDURE intSetMDocPro(Operation: tOperation; MakePRMRequired: SCAL[2]): STRING[];
  VAR
   trgNozzle     : P_Storage.tNozzle;
   csv,
   Sign,
   tmpStr,
   MDocProValue,
   trgStateNbr,
   trgXDocIdAsStr,
   trgBoxNbrAsStr: STRING[];
   trgMath       : LIKE(Math.Math);
   trgQnt        : L_XObj.tQnt;
   trgSum,
   trgCash       : L_XObj.tSum;
 BEGIN
  IF Operation = o_StopLoading THEN
   tmpStr   :=GetMDocCSV();
   trgNozzle:=GetNumCSV(tmpStr, csv_Nozzle);
   trgMath  :=GetStrCSV(tmpStr, csv_Math);
   trgQnt   :=0;
   trgSum   :=0;
   trgCash  :=GetMDocCash();
   L_General.Assert(~HasMDocAlert(), L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + ": 室 ࠭ ஡  ");
  ELSE
   trgNozzle:=getFV_Scal(v_Nozzle);
   trgMath  :=getFV_Scal(v_Math);
   trgQnt   :=getFV_Number(v_Qnt);
   trgSum   :=getFV_Number(v_Sum);
   trgCash  :=getFV_Number(v_Cash);
  END;

  IF ~!MDoc.BoxNbr THEN
   L_Car.StandOnCarLog(MDoc.BoxNbr, MDoc.Date);
   trgBoxNbrAsStr:=MDoc.BoxNbr;
   trgStateNbr   :=L_Car.StateNbrToInternational(CarLog.StateNbr, 0);
  ELSE
   SETEMPTY(trgBoxNbrAsStr, trgStateNbr);
  END;

  IF MakePRMRequired THEN
   trgXDocIdAsStr:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
  ELSE
   SETEMPTY(trgXDocIdAsStr);
  END;

  csv:=AddQM(trgXDocIdAsStr)                + "," +
       AddQM(L_DatTim.CompleteSystimeStr()) + "," +
       AddQM(trgBoxNbrAsStr)                + "," +
       AddQM(trgMath)                       + "," +
       AddQM(trgNozzle)                     + "," +
       AddQM(ConvQntToStr(trgQnt))          + "," +
       AddQM(ConvQntToStr(trgSum));

  IF E_gs_GetKind() = L_Fuel.gsk_NeftoServer THEN
   csv:=csv                           + "," +
        AddQM(E_GetNeftoServerDest()) + "," +
        AddQM(trgStateNbr)            + "," +
        AddQM(MDoc.TSN)               + "," +
        AddQM("");
  END;
  MDocProValue:=csv+";"+AddQM(ConvQntToStr(trgCash));
  SETEMPTY(Sign);
  IF Operation = o_StopLoading THEN
   Sign:=s_StopLoading;
  END;

  P_MDoc.SetMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_ServiceNote, P_MDoc.sn_AutoBuildIdent+";"+
                                                                    MDocProValue+";"+
                                                                    Sign);
  RETURN csv;
 END {intSetMDocPro};

 PRIVATE PROCEDURE SetMDocPro(Operation: tOperation; MakePRMRequired: SCAL[2]);
  VAR
   Dummy: STRING[];
 BEGIN
  Dummy:=intSetMDocPro(Operation, MakePRMRequired);
 END {SetMDocPro};

 PRIVATE PROCEDURE MakePRM(Operation: tOperation);
 BEGIN
  CreateFile(GetPRMFileName(Operation), intSetMDocPro(Operation, 1));
 END {MakePRM};

 PRIVATE PROCEDURE GetMDocNozzle(Strong: SCAL[2]): P_Storage.tNozzle;
  VAR
   Result: P_Storage.tNozzle;
 BEGIN
  Result:=GetNumCSV(GetMDocCSV(), csv_Nozzle);
  IF Strong THEN
   L_General.Assert(~!Result, "४ ଠ ᢮⢠  '㦥 ⬥⪨'");
  END;
  RETURN Result;
 END {GetMDocNozzle};

 PRIVATE PROCEDURE CarInfo(): STRING[];
 BEGIN
  RETURN CarLog.BoxNbr+", "+CarLog.StateNbr+", "+Mark.Name;
 END {CarInfo};

 PRIVATE PROCEDURE RecipientInfoByMDoc(): STRING[];
 BEGIN
  IF ~!MDoc.Firm THEN
   P_Firm.AccessFirm(MDoc.Firm);
   RETURN "ࠣ: " + Firm.Firm + " " + Firm.Name;
  ELSE
   SEARCH(Staff, TSN, , MDoc.TSN);
   CONFORM(Staff, Man);
   IF ~!MDoc.BoxNbr THEN
    L_Car.StandOnCarLog(MDoc.BoxNbr, MDoc.Date);
    CONFORM(CarLog, Mark);
    RETURN ": " + CarLog.BoxNbr+", "+CarLog.StateNbr+", "+Man.Name;
   ELSE
    RETURN "⭨: "  +Staff.TSN + " " + Man.Name;
   END;
  END;
 END {RecipientInfoByMDoc};

 PRIVATE PROCEDURE ReadFromFile(FullFileName: STRING[]; Strong: SCAL[2]): STRING[];
  CONST
   MaxTryCnt = 5;
  VAR
   Dummy : SCAL[2];
   TryCnt: NUMERIC[0];
   Result: STRING[];
 BEGIN
  TryCnt:=0;
  SETEMPTY(Result);
  LOOP
   TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
 (*㦥 TRY , ⮡ InfoDone 뢥 *)
    FIO.Open(tmpF, FullFileName, , Output);
    IF E_gs_GetKind() = L_Fuel.gsk_NeftoServer THEN
     FIO.SetCP(tmpF, FIO.CP_WindowsRussian);
    END;
    Dummy:=FIO.RdStr(tmpF, Result);
    FIO.Close(tmpF);
    RETURN Result;
   EXCEPT
   ON Exc: Exc_Root DO
    TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     FIO.Close(tmpF);
    EXCEPT
    ON Exc:Exc_Root DO
     (* nothing *)
    END; (* TRY *)
    IF Strong THEN
     IF TryCnt < MaxTryCnt THEN
      SLEEP(0.2);
     ELSE
      RAISE();
     END;
    ELSE
     RETURN Result;
    END;
   END; (* TRY *)
   INC(TryCnt);
  END; (* LOOP *)
 END {ReadFromFile};

 PRIVATE PROCEDURE GetFolderEntry(FileMask, Path: STRING[]): FOLDER_ENTRY;
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   RETURN FOLDER_ENTRY.CreateRedirector(FIO.BuildPath(FileMask, "", Path));
  EXCEPT
  ON Exc:Exc_Root DO
   L_General.Error("   䠩  ࠢ饩 ணࠬ|" +
                   Path + "|" +
                   "६ 㯭   .||" +
                   "஡   .||" +
                   "᫨ 訡 㤥 ,   ");

  END; (* TRY *)
 END {GetFolderEntry};

 PRIVATE PROCEDURE GetGasPumpProgressFileName(trgNozzle: P_Storage.tNozzle; trgXDocId: L_XDoc.tXDocId; lp: tLoadingProgress): STRING[];
  VAR
   gsk          : L_Fuel.tGasStanKind;
   PRM_Path,
   FileName,
   FullFileName : STRING[];
   File         : OBJECT;
   FolderContent: ENUMERATOR;
 BEGIN
  gsk:=E_gs_GetKind();
  IF    lp = lp_AcceptPRM THEN
   IF    gsk = L_Fuel.gsk_NeftoServer THEN FileName:="TRK_" + L_Str.FixedIntStr(trgNozzle, 2) + ".ON";
   ELSE                                    FileName:=trgXDocId + "?.TRK_ON";
   END;
  ELSIF lp = lp_Start THEN
   IF    gsk = L_Fuel.gsk_NeftoServer THEN FileName:="TRK_" + L_Str.FixedIntStr(trgNozzle, 2) + ".RUN";
   ELSE                                    FileName:=trgXDocId + "?.TRK_RUN";
   END;
  ELSE
   L_General.CallUs(0);
  END;

  SETEMPTY(FullFileName);
  IF GetInteractionMode(L_Stock.DefaultStorage()) = im_Normal THEN
   PRM_Path:=GetWorkPath(gfpm_Silent);
   IF ~!PRM_Path THEN
    FolderContent:=CreateENUMERATOR(GetFolderEntry(FileName, PRM_Path).FolderContent);
    WHILE ~FolderContent.AtEnd() DO
     File:=FolderContent.Item();
     IF ~File.Attributes.Directory THEN
      L_General.CallUs(!FullFileName);
      FullFileName:=File.Path;
     END; (* IF ~File.Attributes.Directory...*)
     FolderContent.MoveNext();
    END; (* WHILE ~AttachmentFolderContent.AtEnd...*)
   END;
  END;
  RETURN FullFileName;
 END {GetGasPumpProgressFileName};

 PRIVATE PROCEDURE IsGasPumpProgressFileExist(trgNozzle: P_Storage.tNozzle; trgXDocId: L_XDoc.tXDocId; lp: tLoadingProgress): SCAL[2];
 BEGIN
  RETURN ~!GetGasPumpProgressFileName(trgNozzle, trgXDocId, lp);
 END {IsGasPumpProgressFileExist};

 PRIVATE PROCEDURE E_gs_ConvMath2MDLMath(trgNozzle  : P_Storage.tNozzle;
                                         trgMath    : LIKE(Math.Math);
                                         trgMDocKind: LIKE(MDocKind.MDocKind)): LIKE(Math.Math);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Stock.gs_ConvMath2MDLMath);
  IF ~!Local THEN
   L_General.CallUs(~!PROCREF(E_Stock.gs_ConvMDLMath2Math));
   RETURN Local(trgNozzle, trgMath, trgMDocKind);
  ELSE
   RETURN trgMath;
  END;
 END {E_gs_ConvMath2MDLMath};

 PRIVATE PROCEDURE E_gs_ConvMDLMath2Math(trgNozzle: P_Storage.tNozzle): LIKE(Math.Math);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Stock.gs_ConvMDLMath2Math);
  IF ~!Local THEN
   RETURN Local(trgNozzle, MDocList.Math, MDocList.MDocKind);
  ELSE
   RETURN MDocList.Math;
  END;
 END {E_gs_ConvMDLMath2Math};

 PRIVATE PROCEDURE StandOnMathByMDLMath(trgNozzle: P_Storage.tNozzle);
 BEGIN
  L_MathR.AccessMath(E_gs_ConvMDLMath2Math(trgNozzle));
 END {StandOnMathByMDLMath};

 PRIVATE PROCEDURE PackPumpArr(VAR Result: tGasStanPumpArr);
  VAR
   i, j        : NUMERIC[0];
   ArrUniqPumps: P_Storage.tPump[100];
 BEGIN
  SETEMPTY(ArrUniqPumps, Result);
  i:=0;
  WHILE i <= HIGH(OwnPumps) DO
   IF ~!OwnPumps[i] THEN
    ArrUniqPumps[OwnPumps[i]]:=OwnPumps[i];
   END;
   INC(i);
  END; (* WHILE i <= HIGH(OwnPumps)...*)

  i:=0; j:=0;
  WHILE i <= HIGH(ArrUniqPumps) DO
   IF ~!ArrUniqPumps[i] THEN
    Result[j]:=ArrUniqPumps[i];
    INC(j);
   END;
   INC(i);
  END; (* WHILE i <= HIGH(ArrUniqPumps)...*)
 END {PackPumpArr};

 PRIVATE PROCEDURE Pump2FieldIdx(trgPump: P_Storage.tPump): STRING[];
  VAR
   i           : NUMERIC[0];
   Found       : SCAL[2];
   GasStanPumps: tGasStanPumpArr;
 BEGIN
  PackPumpArr(GasStanPumps);
  Found:=0;
  i    :=0;
  WHILE (i <= HIGH(GasStanPumps)) & ~!GasStanPumps[i] & ~Found DO
   IF trgPump = GasStanPumps[i] THEN
    Found:=1;
   ELSE
    INC(i);
   END;
  END; (* WHILE (i <= HIGH(GasStanPumps)) &...*)
  L_General.CallUs(Found);
  RETURN L_Str.FixedIntStr(i+1, 2);
 END {Pump2FieldIdx};

 PRIVATE PROCEDURE SetGasPumpProgress(PumpIdx_AsStr: STRING[];
                                      trgNozzle    : P_Storage.tNozzle;
                                      trgXDocId    : L_XDoc.tXDocId;
                                      lp           : tLoadingProgress);
  VAR
   totQnt,
   curQnt          : L_XObj.tQnt;
   Duration        : NUMERIC[0];
   LoadingDTS      : FLOAT;
   s,
   totQnt_AsStr,
   curQnt_AsStr,
   ProgressFileName: STRING[];
 BEGIN
  setFieldValue(v_GP_Progress+PumpIdx_AsStr, L_Str.PoolItem(" ||", lp));

  s:=GetStrCSV(GetMDocCSV(), csv_DTS);
  setFieldValue(v_GP_DTS+PumpIdx_AsStr, Str.Item(s, " ", 1));
  LoadingDTS:=L_DatTim.GetVARIANTDATE(STRTOFLD(Str.Item(s, " ", 0), DATE),
                                      STRTOFLD(Str.Slice(getFV_String(v_GP_DTS+PumpIdx_AsStr), 0, 5), TIME),
                                      STRTOFLD(Str.Slice(getFV_String(v_GP_DTS+PumpIdx_AsStr), 6, 2), NUMERIC));
  Duration:=(L_DatTim.GetSysVARIANTDATE()-LoadingDTS)*24*60 DIV 1;
  IF Duration <= 999 THEN
   setFieldValue(v_GP_TimePass+PumpIdx_AsStr, FLDTOSTR(Duration, ""));
  ELSE
   setFieldValue(v_GP_TimePass+PumpIdx_AsStr, "");
  END;

  totQnt      :=MDocList.Qnt;
  totQnt_AsStr:=FLDTOSTR(totQnt, "1.", 6, "R");
  IF lp = lp_Wait THEN
   setFieldValue(v_GP_Qnt+PumpIdx_AsStr, Str.Align(totQnt_AsStr, 13, RIGHT));
  ELSE
   IF lp = lp_Start THEN
    ProgressFileName:=GetGasPumpProgressFileName(trgNozzle, trgXDocId, lp);
    IF ~!ProgressFileName THEN
     curQnt:=GetNumCSV(ReadFromFile(ProgressFileName, 0), csv_Qnt);
    ELSE
     SETEMPTY(curQnt);
    END;
   ELSE
    curQnt:=0.0;
   END;

   IF ~!curQnt THEN
    IF curQnt = totQnt THEN
     curQnt_AsStr:=Str.Align(FLDTOSTR(curQnt, "1."), 13, RIGHT);
    ELSE
     curQnt_AsStr:=FLDTOSTR(curQnt, "1.", 6, "L")  + "/" + totQnt_AsStr
    END;
   ELSE
    curQnt_AsStr:="???  /" + totQnt_AsStr;
   END;
   setFieldValue(v_GP_Qnt+PumpIdx_AsStr, curQnt_AsStr);
  END;
 END {SetGasPumpProgress};

 PRIVATE PROCEDURE CheckMDocListAmount();
 BEGIN
  SAVE(MDocList);
  L_General.Assert(~NEXT(MDocList), " 㬥  " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + "    ᪮쪮 ப");
  RESTORE(MDocList);
 END {CheckMDocListAmount};

 PRIVATE PROCEDURE CheckMDocListExists();
 BEGIN
  CONFORM(MDoc, MDocList);
  L_General.Assert(OCCURE(MDocList), "⮩ " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
 END {CheckMDocListExists};

 PRIVATE PROCEDURE SetGasPump(trgPump      : P_Storage.tPump;
                              PumpIdx_AsStr: STRING[];
                              trgNozzle    : P_Storage.tNozzle);
  VAR
   trgXDocId,
   refXDocId: L_XDoc.tXDocId;
   trgGP_XD,
   trgGP_Car: STRING[];
 BEGIN
  trgXDocId:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
  setFieldValue(v_GP_Nozzle+PumpIdx_AsStr, trgNozzle);
  setFieldValue(v_GP_MD+PumpIdx_AsStr, L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
  CheckMDocListExists();

  StandOnMathByMDLMath(trgNozzle);
  setFieldValue(v_GP_MathName+PumpIdx_AsStr, Math.Name + " (" + Math.Math + ")");
  CheckMDocListAmount();

  trgGP_XD :=" ";
  trgGP_Car:=" ";
  IF    MDoc.MDocKind = L_MDoc.md_NOV THEN
   trgGP_XD:=L_XDoc.XDocStr(L_XDoc.GetSingleRefToReqXDT(MDoc.XDocId, L_XDoc.xdt_RWayS));
   L_Car.StandOnCarLog(MDoc.BoxNbr, MDoc.Date);
   CONFORM(CarLog, Mark);
   trgGP_Car:=CarInfo()
  ELSIF MDoc.MDocKind = L_MDoc.md_MSP THEN
   refXDocId:=L_XDoc.GetSingleRefToReqXDT(MDoc.XDocId, L_XDoc.xdt_RprS);
   IF ~!refXDocId THEN
    trgGP_XD :=L_XDoc.XDocStr(refXDocId);
    L_XDoc.PositionOnXDoc(refXDocId);
    L_Rpr.AccessOrigin();
    L_Car.StandOnCarLog(Car.BoxNbr, MDoc.Date);
    CONFORM(CarLog, Mark);
    trgGP_Car:=CarInfo()
   END;
  ELSIF (MDoc.MDocKind = L_MDoc.md_TCh) |
        (MDoc.MDocKind = L_MDoc.md_VPC) THEN
   trgGP_XD:=L_XDoc.XDocStr(L_XDoc.XDocId(L_XDoc.xdt_Contract, L_XDoc.EmptyXDocKind, MDoc.Contract));
  END;

  setFieldValue(v_GP_XD+PumpIdx_AsStr, trgGP_XD);
  setFieldValue(v_GP_Car+PumpIdx_AsStr, trgGP_Car);

  CONFORM(MDoc, Staff);
  CONFORM(Staff, Man);
  setFieldValue(v_GP_Staff+PumpIdx_AsStr, Staff.TSN+" "+L_Str.ShortName(Man.Name));

  IF    IsGasPumpProgressFileExist(trgNozzle, trgXDocId, lp_Start) THEN
   SetGasPumpProgress(PumpIdx_AsStr, trgNozzle, trgXDocId, lp_Start);
  ELSIF IsGasPumpProgressFileExist(trgNozzle, trgXDocId, lp_AcceptPRM) THEN
   SetGasPumpProgress(PumpIdx_AsStr, trgNozzle, trgXDocId, lp_AcceptPRM);
  ELSE
   SetGasPumpProgress(PumpIdx_AsStr, trgNozzle, trgXDocId, lp_Wait);
  END;
 END {SetGasPump};

 PRIVATE PROCEDURE SetVideoFieldsParams(PumpIdx_AsStr: STRING[]; Visible, ForceSetColor: SCAL[2]);
 BEGIN
  SetField(v_GP_Nozzle+PumpIdx_AsStr,   Visible, FORM_FIELD.Color_Text,   ForceSetColor);
  SetField(v_GP_XD+PumpIdx_AsStr,       Visible, FORM_FIELD.Color_Field4, ForceSetColor);
  SetField(v_GP_MD+PumpIdx_AsStr,       Visible, FORM_FIELD.Color_Field4, ForceSetColor);
  SetField(v_GP_MathName+PumpIdx_AsStr, Visible, FORM_FIELD.Color_Field3, ForceSetColor);
  SetField(v_GP_Car+PumpIdx_AsStr,      Visible, FORM_FIELD.Color_Field4, ForceSetColor);
  SetField(v_GP_Staff+PumpIdx_AsStr,    Visible, FORM_FIELD.Color_Field4, ForceSetColor);
  SetField(v_GP_Qnt+PumpIdx_AsStr,      Visible, FORM_FIELD.Color_Field2, ForceSetColor);
  SetField(v_GP_DTS+PumpIdx_AsStr,      Visible, FORM_FIELD.Color_Field4, ForceSetColor);
  SetField(v_GP_TimePass+PumpIdx_AsStr, Visible, FORM_FIELD.Color_Field1, ForceSetColor);
 END {SetVideoFieldsParams};

 PRIVATE PROCEDURE SetVideoFieldsByMDocKind(trgMDocKind: LIKE(MDocKind.MDocKind));
  VAR
   trgPump      : P_Storage.tPump;
   trgNozzle    : P_Storage.tNozzle;
   trgStorage   : LIKE(Storage.Storage);
   PumpIdx_AsStr: STRING[];
 BEGIN
  trgStorage:=L_Stock.DefaultStorage();
  SELECT(MDoc, MDKStat, , trgMDocKind, L_MDoc.st_Prepared);
  WHILE OCCURE(MDoc) DO
   IF (MDoc.Storage = trgStorage) | (MDoc.Storage2 = trgStorage) THEN
    trgNozzle:=GetMDocNozzle(0);
    IF ~!trgNozzle THEN
     trgPump:=NozzleToPump(trgNozzle);
     PumpIdx_AsStr:=Pump2FieldIdx(trgPump);
     L_General.Assert(!getFV_String(v_GP_MD+PumpIdx_AsStr), "६  ࠢ    "+trgPump+" ("+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+")");
     SetVideoFieldsParams(PumpIdx_AsStr, 1, 0);
     SetGasPump(trgPump, PumpIdx_AsStr, trgNozzle);
    END;
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {SetVideoFieldsByMDocKind};

 PRIVATE PROCEDURE SetEmptyGPFields();
  VAR
   PumpIdx      : NUMERIC[0];
   PumpIdx_AsStr: STRING[];
 BEGIN
  PumpIdx:=1;
  WHILE PumpIdx <= P_Storage.MaxGasStanPumpAmount DO
   PumpIdx_AsStr:=L_Str.FixedIntStr(PumpIdx, 2);
   setFieldValue(v_GP_Nozzle+PumpIdx_AsStr,   "");
   setFieldValue(v_GP_XD+PumpIdx_AsStr,       "");
   setFieldValue(v_GP_MD+PumpIdx_AsStr,       "");
   setFieldValue(v_GP_MathName+PumpIdx_AsStr, "");
   setFieldValue(v_GP_Car+PumpIdx_AsStr,      "");
   setFieldValue(v_GP_Staff+PumpIdx_AsStr,    "");
   setFieldValue(v_GP_Qnt+PumpIdx_AsStr,      "");
   setFieldValue(v_GP_DTS+PumpIdx_AsStr,      "");
   setFieldValue(v_GP_TimePass+PumpIdx_AsStr, "");
   setFieldValue(v_GP_Progress+PumpIdx_AsStr, " ");
   INC(PumpIdx);
  END; (* WHILE PumpIdx <= P_Storage.MaxGasStanPumpAmount...*)
 END {SetEmptyGPFields};

 PRIVATE PROCEDURE IsAcceptableGasStanMDocKind(): SCAL[2];
 BEGIN
  RETURN (MDocKind.MDocKind = L_MDoc.md_NOV) |
         (MDocKind.MDocKind = L_MDoc.md_TOV) |
         (MDocKind.MDocKind = L_MDoc.md_MSP) |
         (MDocKind.MDocKind = L_MDoc.md_TCh) |
         (MDocKind.MDocKind = L_MDoc.md_VPC);
 END {IsAcceptableGasStanMDocKind};

 PRIVATE PROCEDURE RefreshGasStanWindow();
  VAR
   PumpIdx: NUMERIC[0];
 BEGIN
  TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)]
   SetEmptyGPFields();
   PumpIdx:=1;
   WHILE PumpIdx <= P_Storage.MaxGasStanPumpAmount DO
    SetVideoFieldsParams(L_Str.FixedIntStr(PumpIdx, 2), 0, 1);
    INC(PumpIdx);
   END; (* WHILE PumpIdx <= P_Storage.MaxGasStanPumpAmount...*)

   SELECT(MDocKind, MDocKind);
   WHILE OCCURE(MDocKind) DO
    IF IsAcceptableGasStanMDocKind() THEN
     SetVideoFieldsByMDocKind(MDocKind.MDocKind);
    END;
    NEXT(MDocKind);
   END; (* WHILE OCCURE(MDocKind) ... *)
  EXCEPT
  END (* TRY *);
 END {RefreshGasStanWindow};

 PRIVATE PROCEDURE PumpInfoAsStr(curNozzle: P_Storage.tNozzle): STRING[];
 BEGIN
  IF IsOutNozzle(curNozzle) THEN
   RETURN "ࠢ  ஭ ";
  ELSE
   RETURN " " + NozzleToPump(curNozzle) + " ⮫ " + curNozzle + " (" + Math.Math + " " + Math.Name + ")";
  END;
 END {PumpInfoAsStr};

 PRIVATE PROCEDURE IsRealNozzle(curNozzle: P_Storage.tNozzle): SCAL[2];
  CONST
   spcNozzle = 00;
 BEGIN
  RETURN ~!curNozzle & (curNozzle # spcNozzle);
 END {IsRealNozzle};

 PRIVATE PROCEDURE extCheckAccordanceNozzleToMath(curNozzle: P_Storage.tNozzle; curMath: LIKE(Math.Math); Silent: SCAL[2]): SCAL[2];
  VAR
   i        : NUMERIC[0];
   acptMaths: LIKE(Math.Math)[10];
   dummyPump: P_Storage.tPump;
 BEGIN
  IF ~!curMath & ~!curNozzle THEN
   PosToMath(curMath);
   IF IsRealNozzle(curNozzle) THEN
    GetNozzleSetup(curNozzle, dummyPump, acptMaths);
    i:=0;
    WHILE ~!acptMaths[i] DO
     IF acptMaths[i] = curMath THEN
      RETURN 1;
     END;
     INC(i);
    END;
    L_General.Assert(Silent, " ⮫ "+curNozzle+"  ࠢ ⥯த⮬ "+curMath);
    RETURN 0;
   ELSE
    IF (Math.MathType = L_MathR.mtyp_Fuels) |
       (~E_gs_IsFuelStation() & (Math.MathType = L_MathR.mtyp_Oils)) THEN
     L_General.Error(" ⥯த⮢  ⮩  (⮫ " + curNozzle + ") ");
    END;
   END;
  END;
  RETURN 1;
 END {extCheckAccordanceNozzleToMath};

 PRIVATE PROCEDURE CheckAccordanceNozzleToMath(_Nozzle: P_Storage.tNozzle; _Math: LIKE(Math.Math));
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=extCheckAccordanceNozzleToMath(_Nozzle, _Math, 0);
 END {CheckAccordanceNozzleToMath};

 PRIVATE PROCEDURE CheckFreeGasPumpByMDocKind(trgMDocKind: LIKE(MDocKind.MDocKind);
                                              trgBoxNbr  : LIKE(Car.BoxNbr);
                                              trgTSN     : LIKE(Staff.TSN);
                                              trgNozzle  : P_Storage.tNozzle);
  VAR
   trgPump   : P_Storage.tPump;
   MDNozzle  : P_Storage.tNozzle;
   trgStorage: LIKE(Storage.Storage);
 BEGIN
  IF IsRealNozzle(trgNozzle) THEN
   trgStorage:=L_Stock.DefaultStorage();
   SAVE(MDoc);
   SELECT(MDoc, MDKStat, , trgMDocKind, L_MDoc.st_Prepared);
   WHILE OCCURE(MDoc) DO
    IF (MDoc.Storage = trgStorage) | (MDoc.Storage2 = trgStorage) THEN
     MDNozzle:=GetMDocNozzle(0);
     IF ~!MDNozzle THEN
      trgPump:=NozzleToPump(MDNozzle);
      IF trgMDocKind = L_MDoc.md_NOV THEN
       IF ~!trgBoxNbr THEN
        L_General.Assert(MDoc.BoxNbr # trgBoxNbr, ". "+trgBoxNbr+" 㦥 ࠢ. ( "+trgPump+")");
       END;
       IF ~!trgTSN THEN
        L_General.Assert(MDoc.TSN # trgTSN, ". "+trgTSN+" 㦥   ⥯த⮢. ( "+trgPump+")");
       END;
      END;
      IF ~!trgNozzle & ~IsOutNozzle(trgNozzle) & (trgPump = NozzleToPump(trgNozzle)) THEN
       L_General.Error(" "+trgPump+" 㦥 . ("+RecipientInfoByMDoc()+")");
      END;
     END;
    END;
    NEXT(MDoc);
   END; (* WHILE OCCURE(MDoc) ... *)
   RESTORE(MDoc);
  END;
 END {CheckFreeGasPumpByMDocKind};

 PRIVATE PROCEDURE extCheckSingleLoading(trgNozzle  : P_Storage.tNozzle;
                                         trgMath    : LIKE(Math.Math);
                                         trgMDocKind: LIKE(MDocKind.MDocKind);
                                         trgBoxNbr  : LIKE(Car.BoxNbr);
                                         trgTSN     : LIKE(Staff.TSN));
 BEGIN
  CheckAccordanceNozzleToMath(trgNozzle, trgMath);
  CheckFreeGasPumpByMDocKind(trgMDocKind, trgBoxNbr, trgTSN, trgNozzle);
 END {extCheckSingleLoading};

 PRIVATE PROCEDURE CheckSingleLoading(trgMDocKind: LIKE(MDocKind.MDocKind);
                                      trgBoxNbr  : LIKE(Car.BoxNbr);
                                      trgTSN     : LIKE(Staff.TSN));
 BEGIN
  extCheckSingleLoading(getFV_Scal(v_Nozzle), getFV_Scal(v_Math), trgMDocKind, trgBoxNbr, trgTSN);
 END {CheckSingleLoading};

 PRIVATE PROCEDURE intIsCashLoading(trgContract: LIKE(Contract.Contract)): SCAL[2];
 BEGIN
  RETURN 0;
 END {intIsCashLoading};

 PRIVATE PROCEDURE IsCashLoading(): SCAL[2];
 BEGIN
  RETURN (getFV_Scal(v_XDocType) = L_XDoc.xdt_Contract) & intIsCashLoading(getFV_Scal(v_XDoc));
 END {IsCashLoading};

 PRIVATE PROCEDURE GetMDocListLoadingInf(): STRING[];
 BEGIN
  IF    (MDocList.Qnt = 0) & (MDocList.Sum # 0) THEN
   RETURN ConvSumToStr(MDocList.Sum + MDocList.VAT) + " .";
  ELSIF (MDocList.Qnt # 0) & (MDocList.Sum = 0)  THEN
   RETURN ConvQntToStr(MDocList.Qnt) + " .";
  ELSE
   L_General.CallUs(0);
  END;
 END {GetMDocListLoadingInf};

 PRIVATE PROCEDURE InfoBegin(curNozzle: P_Storage.tNozzle);
 BEGIN
  StandOnMathByMDLMath(curNozzle);
  L_StdFrm.Question(" ⥯த⮢  " + L_MDoc.MDocKindNick(MDoc.MDocKind, 1) +
                    "||" +
                    RecipientInfoByMDoc() +
                    "||" +
                    PumpInfoAsStr(curNozzle) +
                    "||" +
                    " " + GetMDocListLoadingInf());
  extCheckSingleLoading(curNozzle, E_gs_ConvMDLMath2Math(curNozzle), MDoc.MDocKind, MDoc.BoxNbr, MDoc.TSN)
 END {InfoBegin};

 PRIVATE PROCEDURE RemoveADVFileToArchive(ADVFileName: STRING[]);
  VAR
   ADV_Path,
   ArchiveFolder,
   ADVFullFileName: STRING[];
 BEGIN
  ADV_Path:=GetWorkPath(gfpm_Strong);
  IF ~!ADV_Path THEN
   ADVFullFileName:=FIO.BuildPath(ADVFileName, , ADV_Path);
   ArchiveFolder  :=GetArchFullPath(L_DatTim.GetDateOfTIMESTAMP(L_FIO.GetFileLastModifiedDTS(ADVFullFileName)));
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    FIO.RenMov(ADVFullFileName, , L_FIO.GetUniqueFileNameInFolder(ADVFileName, ArchiveFolder));
   EXCEPT
   ON Exc: Exc_Root DO
    RAISE();
   END; (* TRY *)
  END;
 END {RemoveADVFileToArchive};

 PRIVATE PROCEDURE ReadFromADV(ADVFileName: STRING[]): STRING[];
  VAR
   ADV_Path: STRING[];
 BEGIN
  ADV_Path:=GetWorkPath(gfpm_Soft);
  IF ~!ADV_Path THEN
   RETURN ReadFromFile(FIO.BuildPath(ADVFileName, , ADV_Path), 1);
  ELSE
   RETURN "";
  END;
 END {ReadFromADV};

 PRIVATE PROCEDURE CountChangeMsg(sum, cash: NUMERIC[2]): STRING[];
 BEGIN
  RETURN         "ࠢ  㬬 " + Str.Align(ConvSumToStr(sum)       , 10, RIGHT) + " ." +
         "||"  + "ਭ     " + Str.Align(ConvSumToStr(cash)      , 10, RIGHT) + " ." +
         "|||" + "               " + Str.Align(ConvSumToStr(cash - sum), 10, RIGHT) + " .";
 END {CountChangeMsg};

 PRIVATE PROCEDURE InfoDone(ADVFileName: STRING[]);
  CONST
   SuccessLoad = "ࠢ";
  VAR
   csv, Msg,
   LoadResult: STRING[];
   trgNozzle : P_Storage.tNozzle;
   trgCash   : L_XObj.tSum;
 BEGIN
  TRY
   IF StandOnMDocByADVFile(ADVFileName, 1) THEN
    csv       :=GetMDocCSV();
    trgNozzle :=GetMDocNozzle(1);
    trgCash   :=GetMDocCash();
    IF E_gs_GetKind() = L_Fuel.gsk_NeftoServer THEN
     LoadResult:=GetStrCSV(ReadFromADV(ADVFileName), csv_Comment);
    ELSE
     SETEMPTY(LoadResult);
    END;

    RemoveADVFileToArchive(ADVFileName);
    CONFORM(MDoc, MDocList);
    StandOnMathByMDLMath(trgNozzle);
    Msg:=    PumpInfoAsStr(trgNozzle) +
         "|"+
         RecipientInfoByMDoc()+
         "||"+
         "ࠢ       "+Str.Align(ConvQntToStr(MDocList.Qnt)+" ஢", 15, LEFT);
    IF MDocList.Sum # 0 THEN
     Msg:=Msg + "||" + CountChangeMsg(MDocList.Sum + MDocList.VAT, trgCash);
    END;
    IF (MDocList.Qnt = GetNumCSV(csv, csv_Qnt)) | L_Fuel.E_LoadFullTank(SYSDATE()) THEN
     IF (E_gs_GetKind() = L_Fuel.gsk_NeftoServer) & (~!LoadResult & (LoadResult # SuccessLoad)) THEN
      L_StdFrm.RedInform(Msg + "||稭: " + LoadResult);
     ELSE
      L_StdFrm.Inform(Msg);
     END;
    ELSE
     L_StdFrm.RedInform(" "+ADVFileName+", "+Msg+"  "+GetStrCSV(csv, csv_Qnt));
    END;
   END;
  EXCEPT

  END; (* TRY *)
 END {InfoDone};

 PRIVATE PROCEDURE ChangeMDocStatus(trgStatus  : LIKE(MDoc.Status);
                                    newQnt     : L_XObj.tQnt;
                                    newSum     : L_XObj.tSum;
                                    Transaction: NUMERIC[0];
                                    Manual     : SCAL[2]);
  VAR
   Msg   : STRING[];
   newVAT: L_XObj.tSum;
 BEGIN
  Msg:=" 㤠 " + L_Str.PoolItem("????????|஢|㫨஢", trgStatus) + " " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + "||";
  TRY [TRANSACTION(Transaction)]
   Memo.gl_SetCurDate(MDoc.Date);
   L_MDoc.MDoc_OnAnyModification(-1, L_MDoc.np_Yes, 0);
   L_General.CallUs(~MDoc.Done);
   IF trgStatus # L_MDoc.st_Canceled THEN
    CONFORM(MDoc, MDocList);
    IF ~!newQnt THEN
     MDocList.Qnt:=newQnt;
    END;
    IF ~!newSum THEN
     newVAT:=L_Acnt.GetInclVAT(MDoc.Date, newSum);
     MDocList.Sum:=newSum-newVAT;
     MDocList.VAT:=newVAT;
 
     MDoc.Total:=MDocList.Sum + MDocList.VAT;
     REPLACE(MDoc);
    END;
    REPLACE(MDocList);
   END;

   MDoc.Status:=trgStatus;
   REPLACE(MDoc);
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, L_XDoc.action_AutoEdit);
  EXCEPT
  ON Exc:Exc_AccessDeny DO
   Msg:=Msg + Exc.MsgOriginalText + "||" +
              " ࠭ 稭 䫨 ஢    .||";
   IF ~Manual THEN
    Msg:=Msg + "ࠡ⪠ १⮢ ࠢ 㤥 믮 ୮";
   ELSE
    Msg:=Msg + " 믮  ";
   END;
   RAISE(, Msg);
  ON Exc:Exc_Root DO
   Msg:=Msg + Exc.MsgOriginalText + "||";
   IF ~Manual THEN
    Msg:=Msg + " ࠢ ᫥    .";
   ELSE
    Msg:=Msg + " 믮  .";
   END;
   RAISE(, Msg +
           "||" +
           " 訡 室 ᮮ .");
  END; (* TRY *)
 END {ChangeMDocStatus};

 PRIVATE PROCEDURE MakeMDocDone(Transaction: NUMERIC[0]);
  VAR
   Msg: STRING[];
 BEGIN
  ACCESS(MDoc); (* 0081068 - 訡  V32, ⮬ 㤠 ACCESS *)
  TRY [TRANSACTION(Transaction)]
   Memo.gl_SetCurDate(MDoc.Date);
   L_MDoc.MDoc_OnAnyModification(+1, L_MDoc.np_Yes, 0);
  EXCEPT
  ON Exc:Exc_Root DO
   Msg:=" 㤠 ࠡ " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + "||";
   L_SysLog.ELN_Put("GasStan", Msg + Exc.Description);
   L_StdFrm.RedInform(Msg + Exc.MsgOriginalText +
                      "|| 믮 ࠡ  .|" +
                      "᫨ 訡 㤥 ,   ");
  END; (* TRY *)
 END {MakeMDocDone};

 PRIVATE PROCEDURE PrintMDoc(Transaction: NUMERIC[0]);
  VAR
   Msg: STRING[];
 BEGIN
  IF L_MDoc.PrintMDocImmediately() THEN
   TRY [TRANSACTION(Transaction)]
    CALL(MDoc.StreamRePrint());
   EXCEPT
   END; (* TRY *)
   TRY
    CALL(MDoc.SinglePrint());
   EXCEPT
   ON Exc:Exc_Root DO
    Msg:=" 㤠  " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + "||";
    L_SysLog.ELN_Put("GasStan", Msg + Exc.Description);
    L_StdFrm.RedInform(Msg + Exc.MsgOriginalText +
                       "|| 믮   .|" +
                       "᫨ 訡 㤥 ,   ");
   END; (* TRY *)
  END;
 END {PrintMDoc};

 PRIVATE PROCEDURE ProceedMDoc(trgStatus  : LIKE(MDoc.Status);
                               newQnt     : L_XObj.tQnt;
                               newSum     : L_XObj.tSum;
                               Transaction: NUMERIC[0];
                               Manual     : SCAL[2]);
 BEGIN
  ChangeMDocStatus(trgStatus, newQnt, newSum, Transaction, Manual);
(*
IF MDoc.Status # L_MDoc.st_Canceled THEN
  ChangeMDocStatus(trgStatus, newQnt, newSum, Transaction, Manual);
END;
*)
  MakeMDocDone(Transaction);
  PrintMDoc(Transaction);
 END {ProceedMDoc};

 PRIVATE PROCEDURE PassedMDoc(newQnt     : L_XObj.tQnt;
                              newSum     : L_XObj.tSum;
                              Transaction: NUMERIC[0];
                              Manual     : SCAL[2]);
 BEGIN
  ProceedMDoc(L_MDoc.st_Passed, newQnt, newSum, Transaction, Manual);
 END {PassedMDoc};

 PRIVATE PROCEDURE SimplePassedMDoc();
 BEGIN
  PassedMDoc(EMPTYOF(L_XObj.tQnt), EMPTYOF(L_XObj.tSum), TRANSACTION_CURRENT, 0);
 END {SimplePassedMDoc};

 PRIVATE PROCEDURE GetTimeLeft(DTS: TIMESTAMP): NUMERIC[3];
 BEGIN
  RETURN (L_DatTim.GetSysTIMESTAMP() - DTS) * 24 * 60;
 END {GetTimeLeft};

 CONST
  to_Proceed = 2;

  badvo_Miss     = 0;
  badvo_Proceed  = 1;
  badvo_Remove   = 2;
  badvo_DSTFormat = ".3yNDHMS";

  badvdi_LastModifiedDTS = 0;
  badvdi_LastProceedDTS  = 1;
  badvdi_TryCnt          = 2;

 PRIVATE PROCEDURE GetBadADVDescrItem(ADVFileName: STRING[]; Item: NUMERIC[0]): STRING[];
 BEGIN
  IF BadADV.Exists(ADVFileName) THEN
   RETURN Str.Item(BadADV.Item(ADVFileName), ";", Item);
  ELSE
   RETURN "";
  END;
 END {GetBadADVDescrItem};

 PRIVATE PROCEDURE IsNewADVFile(FullADVFileName: STRING[]): SCAL[2];
  VAR
   badv_LastModifiedDTS,
   badv_RealLastModifiedDTS: TIMESTAMP;
 BEGIN
  badv_LastModifiedDTS    :=STRTOFLD(GetBadADVDescrItem(L_FIO.effp_FileName(FullADVFileName), badvdi_LastModifiedDTS), TIMESTAMP, badvo_DSTFormat);
  badv_RealLastModifiedDTS:=STRTOFLD(FLDTOSTR(L_FIO.GetFileLastModifiedDTS(FullADVFileName), badvo_DSTFormat), TIMESTAMP, badvo_DSTFormat);
  RETURN badv_RealLastModifiedDTS # badv_LastModifiedDTS;
 END {IsNewADVFile};

 PRIVATE PROCEDURE GetBadADVOperation(FullADVFileName: STRING[]): SCAL[3];
  VAR
   ADVFileName         : STRING[];
   badv_LastProceedDTS,
   badv_LastModifiedDTS: TIMESTAMP;
 BEGIN
  ADVFileName         :=L_FIO.effp_FileName(FullADVFileName);
  badv_LastModifiedDTS:=STRTOFLD(GetBadADVDescrItem(ADVFileName, badvdi_LastModifiedDTS), TIMESTAMP, badvo_DSTFormat);
  badv_LastProceedDTS :=STRTOFLD(GetBadADVDescrItem(ADVFileName, badvdi_LastProceedDTS),  TIMESTAMP, badvo_DSTFormat);
  IF IsNewADVFile(FullADVFileName) THEN
   RETURN badvo_Proceed;
  ELSE
   IF GetTimeLeft(badv_LastProceedDTS) >= to_Proceed THEN
    RETURN badvo_Proceed;
   ELSE
    RETURN badvo_Miss;
   END;
  END;
 END {GetBadADVOperation};

 PRIVATE PROCEDURE ClearBadADV(ADVFileName: STRING[]);
 BEGIN
  IF BadADV.Exists(ADVFileName) THEN
   BadADV.Remove(ADVFileName);
  END;
 END {ClearBadADV};

 PRIVATE PROCEDURE BadADV_Remove(ADVFileName, Msg: STRING[]);
 BEGIN
  L_StdFrm.Inform(" 㤠 ࠡ 䠩 " + ADVFileName + ":||" +
                   Msg + "||" +
                  " 㤥 ६饭  娢");
  ClearBadADV(ADVFileName);
  L_SysLog.ELN_Put("GasStan", ADVFileName + ":  㤠 ࠡ, ६饭  娢. " + Msg);
  RemoveADVFileToArchive(ADVFileName);
 END {BadADV_Remove};

 PRIVATE PROCEDURE GetBadADVTryCntProceed(ADVFileName: STRING[]): NUMERIC[0];
  VAR
   Val: STRING[];
 BEGIN
  Val:=GetBadADVDescrItem(ADVFileName, badvdi_TryCnt);
  IF ~!Val THEN
   RETURN STRTOFLD(Val, NUMERIC);
  ELSE
   RETURN 0;
  END;
 END {GetBadADVTryCntProceed};

 PRIVATE PROCEDURE IsAcceptableCurUser(): SCAL[2];
 BEGIN
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
  RETURN XDocJrn.AcsObj = L_General.curUSER;
 END {IsAcceptableCurUser};

 PRIVATE PROCEDURE IsADVFileTooOld(FullADVFileName: STRING[]): SCAL[2];
 BEGIN
  RETURN (L_DatTim.GetSysTIMESTAMP() - L_FIO.GetFileLastModifiedDTS(FullADVFileName)) >= 0.5 / 24;
 END {IsADVFileTooOld};

 PRIVATE PROCEDURE IsAcceptableADV(forceScanBadADV: SCAL[2]; FullADVFileName: STRING[]): SCAL[2];
  CONST
   MaxTryCnt = 3;
  VAR
   Msg,
   ADVFileName   : STRING[];
   badv_Operation: SCAL[3];
 BEGIN
  ADVFileName:=L_FIO.effp_FileName(FullADVFileName);
  IF StandOnMDocByADVFile(ADVFileName, 0) & (IsAcceptableCurUser() | IsADVFileTooOld(FullADVFileName)) THEN
   IF BadADV.Exists(ADVFileName) THEN
    IF    IsNewADVFile(FullADVFileName) THEN
     ClearBadADV(ADVFileName);
     badv_Operation:=badvo_Proceed;
    ELSIF GetBadADVTryCntProceed(ADVFileName) >= MaxTryCnt THEN
     badv_Operation:=badvo_Remove;
    ELSIF forceScanBadADV THEN
     badv_Operation:=badvo_Proceed;
    ELSE
     badv_Operation:=GetBadADVOperation(FullADVFileName);
    END;
    IF badv_Operation = badvo_Miss THEN
     RETURN 0;
    ELSE
     IF    badv_Operation = badvo_Proceed THEN
      RETURN 1;
     ELSIF badv_Operation = badvo_Remove THEN
      IF StandOnMDocByADVFile(ADVFileName, 0) THEN
       Msg:=" " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + " 室 ஢ ";
      ELSE
       SETEMPTY(Msg);
      END;
      BadADV_Remove(ADVFileName, Msg);
      RETURN 0;
     ELSE
      L_General.CallUs(0);
     END;
    END;
   ELSE
    RETURN 1;
   END;
  ELSE
   RETURN 0;
  END;
 END {IsAcceptableADV};

 PRIVATE PROCEDURE ORPAKInfAlreadySaved(MDocCSV: STRING[]): SCAL[2];
  VAR
   Pos,
   Amount: NUMERIC[0];
 BEGIN
  SETZERO(Amount, Pos);
  LOOP
   Pos:=Str.Pos(MDocCSV, ",", Pos);
   IF Pos = Str.Length(MDocCSV) THEN
    EXIT;
   END;
   INC(Pos);
   INC(Amount);
  END; (* LOOP *)
  L_General.CallUs(Amount # 0);
  RETURN Amount >= csv_ORPAK_StateNbr;
 END {ORPAKInfAlreadySaved};

 PRIVATE PROCEDURE SaveORPAKInf(ORPAKInf: STRING[]);
  VAR
   i              : NUMERIC[0];
   MDocProValueArr: STRING[][4];
 BEGIN
  ORPAKInf:=L_Str.Replace(ORPAKInf, L_Str.CR, "");
  ORPAKInf:=L_Str.Replace(ORPAKInf, L_Str.LF, "");
  TRY [TRANSACTION(TRANSACTION_SLAVE)]
   SETEMPTY(MDocProValueArr);
   i:=0;
   WHILE i <= HIGH(MDocProValueArr) DO
    MDocProValueArr[i]:=GetMDocServiceNoteItem(i);
    INC(i);
   END; (* WHILE i <= HIGH(MDocProValueArr)...*)

   L_General.CallUs(~!MDocProValueArr[i_Service]);
   IF ~ORPAKInfAlreadySaved(MDocProValueArr[i_PRM]) THEN
    MDocPro.Value:=MDocProValueArr[i_Service] + ";" +
                   MDocProValueArr[i_PRM] + "," + ORPAKInf + ";" +
                   MDocProValueArr[i_Cash] + ";" +
                   MDocProValueArr[i_Sign];
    REPLACE(MDocPro);
   END;
  EXCEPT
  ON Exc:Exc_Root DO
  END; (* TRY *)
 END {SaveORPAKInf};

 PRIVATE PROCEDURE GetORPAKInf(s: STRING[]): STRING[];
 BEGIN
  RETURN AddQM(GetStrCSV(s, csv_ORPAK_StateNbr)) + "," +
         AddQM(GetStrCSV(s, csv_ORPAK_BoxNbr))   + "," +
         AddQM(GetStrCSV(s, csv_ORPAK_Run))      + "," +
         AddQM(GetStrCSV(s, csv_ORPAK_EngineWrkTim))
 END {GetORPAKInf};

 PRIVATE PROCEDURE ProceedNewADV(ADVFileName: STRING[]);
  VAR
   s,
   Msg      : STRING[];
   Sum      : L_XObj.tSum;
   Qnt      : L_XObj.tQnt;
   Dummy,
   HasMDoc  : SCAL[2];
   _XDoc    : L_XDoc.tXDoc;
   _XDocId  : L_XDoc.tXDocId;
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
 BEGIN
  SETEMPTY(Msg);
  HasMDoc:=StandOnMDocByADVFile(ADVFileName, 0);
  IF HasMDoc THEN
   CheckMDocListExists();

   s:=ReadFromADV(ADVFileName);
   IF ~!s THEN
    _XDocId:=GetStrCSV(s, csv_XDocId);
    Qnt    :=GetNumCSV(s, csv_Qnt);
    Sum    :=GetNumCSV(s, csv_Sum);
    L_XDoc.DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
    IF    MDoc.MDoc # _XDoc THEN
     Msg:=" ᮤন  "+L_XDoc.XDocStr(_XDocId);
    ELSIF MDoc.BoxNbr # GetNumCSV(s, csv_BoxNbr) THEN
     Msg:=" ᮢ . "+GetStrCSV(s, csv_BoxNbr)+"  "+L_XDoc.XDocStr(_XDocId)+" ("+MDoc.BoxNbr+")";
    ELSIF GetMDocNozzle(1) # GetNumCSV(s, csv_Nozzle) THEN
     Msg:=" ᮢ  ⮫ "+GetStrCSV(s, csv_Nozzle)+"  "+L_XDoc.XDocStr(_XDocId)+" ("+GetMDocNozzle(1)+")";
    ELSIF E_gs_ConvMDLMath2Math(GetMDocNozzle(1)) # GetNumCSV(s, csv_Math) THEN
     Msg:=" ᮢ  ⥯த "+E_gs_ConvMDLMath2Math(GetMDocNozzle(1))+"  "+L_XDoc.XDocStr(_XDocId)+" ("+GetStrCSV(s, csv_Math)+")";
    ELSIF MDoc.Status # L_MDoc.st_Prepared THEN
     Msg:=L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+"  室  ﭨ '⮢'";
    ELSIF !Qnt THEN
     Msg:=" 䠩-⢥ত  ⢮ 饭 ⮯";
    END;
    IF !Msg & (E_gs_GetKind() = L_Fuel.gsk_NeftoServer) THEN
     SaveORPAKInf(GetORPAKInf(s));
    END;
   ELSE
    Msg:=" "+ADVFileName+" ⮩";
   END;
  ELSE
   Msg:="  ";
  END;

  IF !Msg THEN
   PassedMDoc(Qnt, Sum, TRANSACTION_SLAVE, 0);
   InfoDone(ADVFileName);
  ELSE
   IF HasMDoc THEN
    SetAlertSign();
   END;
   IF HasMDoc & (MDoc.Status # L_MDoc.st_Prepared) THEN
    BadADV_Remove(ADVFileName, Msg);
   ELSE
    L_General.Error(Msg);
   END;
  END;
 END {ProceedNewADV};

 PRIVATE PROCEDURE SetGasStanTitle(force: SCAL[2]);
  CONST
   woPRM_Descr = "( ନ஢ ࠢ 䠩)";
  VAR
   Pos           : NUMERIC[0];
   trgStorage    : LIKE(Storage.Storage);
   StorageName,
   oldStorageName: STRING[];
 BEGIN
  trgStorage:=L_Stock.DefaultStorage();
  IF ~!trgStorage THEN
   L_Stock.PositionOnStorage(trgStorage);
   StorageName:=Storage.Name + " (" + Storage.Storage + ")";
  ELSE
   StorageName:="ࠢ筠 ⠭";
  END;
  oldStorageName:=RTI.Get().CurWindow.Title;
  Pos:=Str.Pos(oldStorageName, woPRM_Descr);
  IF Pos # Str.Length(oldStorageName) THEN
   oldStorageName:=Str.Slice(oldStorageName, 0, Pos);
  END;
  oldStorageName:=Str.Condense(oldStorageName);
  IF ~force & ~!oldStorageName & (oldStorageName # StorageName) THEN
   L_StdFrm.TimedINFORM_AsSTOP("   㬮砭.||" +
                               "ॡ १ 'ࠢ筮 ⠭樨'", 5);
   L_Timer.ResetTimer("GasStan_Stat");
   LIKEMENU(Cancel, "NoSave");
  END;

  RTI.Get().CurWindow.Title:=StorageName;
  IF GetInteractionMode(trgStorage) = im_woPRM THEN
   RTI.Get().CurWindow.Title:=RTI.Get().CurWindow.Title + woPRM_Descr;
  END;
 END {SetGasStanTitle};

 PRIVATE PROCEDURE UpdateSysDateTime();
 BEGIN
  setFieldValue("SysDateTime", L_DatTim.CompleteSystimeStr());
 END {UpdateSysDateTime};

 PRIVATE PROCEDURE intScanNewADV(forceScanBadADV: SCAL[2]);
  VAR
   gfpm                    : SCAL[3];
   File                    : OBJECT;
   badv_TryCnt             : NUMERIC[0];
   FolderContent           : ENUMERATOR;
   ADV_Path,
   badv_Descr,
   ADVFileName,
   badv_LastProceedDTS_Str,
   badv_LastModifiedDTS_Str: STRING[];
 BEGIN
  SetGasStanTitle(0);
  IF IsFuelStationStorage(0) THEN
   IF GetInteractionMode(L_Stock.DefaultStorage()) = im_Normal THEN
    IF forceScanBadADV THEN
     gfpm:=gfpm_Soft;
    ELSE
     gfpm:=gfpm_Silent;
    END;
 
    ADV_Path:=GetWorkPath(gfpm);
    IF ~!ADV_Path THEN
     FolderContent:=CreateENUMERATOR(GetFolderEntry("*.ADV", ADV_Path).FolderContent);
     WHILE ~FolderContent.AtEnd() DO
      File:=FolderContent.Item();
      IF ~File.Attributes.Directory THEN
       ADVFileName:=L_FIO.effp_FileName(File.Path);
       PROMPT(ADVFileName);
       IF IsAcceptableADV(forceScanBadADV, File.Path) THEN
        TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)]
         ProceedNewADV(ADVFileName);
         ClearBadADV(ADVFileName);
        EXCEPT
        ON Exc:Exc_Root DO
         badv_TryCnt             :=GetBadADVTryCntProceed(ADVFileName);
         badv_LastModifiedDTS_Str:=FLDTOSTR(L_FIO.GetFileLastModifiedDTS(File.Path), badvo_DSTFormat);
         badv_LastProceedDTS_Str :=FLDTOSTR(L_DatTim.GetSysTIMESTAMP(), badvo_DSTFormat);
         INC(badv_TryCnt);
         L_SysLog.ELN_Put("GasStan", ADVFileName + " (⠬ " + badv_LastModifiedDTS_Str + " 㧪 " + L_Str.IntStr(badv_TryCnt) + " " + badv_LastProceedDTS_Str + "):" + Exc.Description);
         ClearBadADV(ADVFileName);
         BadADV.Add(ADVFileName, badv_LastModifiedDTS_Str + ";" + badv_LastProceedDTS_Str + ";" + L_Str.IntStr(badv_TryCnt));
         L_StdFrm.RedInform("訡 㧪 䠩-⢥ত (" + L_Str.IntStr(badv_TryCnt) + "):||" + Exc.MsgOriginalText + "||१ ஥ ६ 㤥 믮|ୠ ⪠ ࠡ⪨ 䠩-⢥ত");
        END; (* TRY *)
       END; (* IF IsOwnMDoc()...*)
      END; (* IF ~File.Attributes.Directory...*)
      FolderContent.MoveNext();
     END; (* WHILE ~AttachmentFolderContent.AtEnd...*)
    END; (* IF ~!ADV_Path...*)
   END;
   RefreshGasStanWindow();
  END;
  UpdateSysDateTime();
 END {intScanNewADV};

 PUBLIC PROCEDURE ScanNewADV_wReScanBadADV();
 BEGIN
  intScanNewADV(1);
 END {ScanNewADV_wReScanBadADV};

 PUBLIC PROCEDURE ScanNewADV();
 BEGIN
  intScanNewADV(0);
 END {ScanNewADV};

 PRIVATE PROCEDURE GasStan_OnInitializeWindow();
  VAR
   PumpIdx      : NUMERIC[0];
   PumpIdx_AsStr: STRING[];
 BEGIN
  L_WDO.iWindow().MNUFileName:="GasStan";
  L_WDO.iWindow().OnOpenWindow:=1;
  L_WDO.iEvents      (0, "");
  L_WDO.iField       (0, "Math").OwnerWindowOriginalName:="Math00";
  L_WDO.iField       (0, "Math").OwnerZoneNumber:=1;
  L_WDO.iField       (0, "SysDateTime").FontSize:=FORM_FIELD.fs_Normal;
  L_WDO.iScsChange   (0, ["Math", "Qnt", "Sum", "Cash", "Nozzle"]);
  L_WDO.iModifiable  (0, ["Nozzle", "Qnt", "Math"]);
  L_WDO.iMayBeEmpty  (0, ["Math", "Qnt", "Sum", "Nozzle"]);
  L_WDO.iProgs       (0, "GasStan");
  IF L_General.IsAcceptableProcessorVersion(014207020) THEN
   PumpIdx:=1;
   WHILE PumpIdx <= P_Storage.MaxGasStanPumpAmount DO
    PumpIdx_AsStr:=L_Str.FixedIntStr(PumpIdx, 2);
    L_WDO.iField       (0, v_GP_Pump+PumpIdx_AsStr).FontSize:=FORM_FIELD.fs_Normal;
    L_WDO.iField       (0, v_GP_Nozzle+PumpIdx_AsStr).FontSize:=FORM_FIELD.fs_Normal;
    INC(PumpIdx);
   END; (* WHILE PumpIdx <= P_Storage.MaxGasStanPumpAmount...*)
  END;
  GetGasStanField(v_XDocType).Format:=L_XDoc.ref_FullNames;
  L_WDO.CreateFormLink("Math", "");
 END {GasStan_OnInitializeWindow};

 PUBLIC PROCEDURE GetTotalPumpAmount(): NUMERIC[0];
  VAR
   i           : NUMERIC[0];
   GasStanPumps: tGasStanPumpArr;
 BEGIN
  PackPumpArr(GasStanPumps);
  i:=0;
  WHILE (i <= HIGH(GasStanPumps)) & ~!GasStanPumps[i] DO
   INC(i);
  END; (* WHILE i <= HIGH(GasStanPumps)...*)
  RETURN i;
 END {GetTotalPumpAmount};

 PRIVATE PROCEDURE IsFuelStationStorage(Strong: SCAL[2]): SCAL[2];
  VAR
   Result    : SCAL[2];
   trgStorage: LIKE(Storage.Storage);
 BEGIN
  Result    :=1;
  trgStorage:=L_Stock.DefaultStorage();
  IF !trgStorage THEN
   Result:=0;
   L_General.Assert(~Strong, " ⠭   㬮砭.");
  END;
  IF ~P_Storage.IsFuelStation(trgStorage) THEN
   Result:=0;
   L_General.Assert(~Strong, "  㬮砭   ⨯ ''");
  END;
  RETURN Result;
 END {IsFuelStationStorage};

 PRIVATE PROCEDURE CheckIsFuelStationStorage();
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=IsFuelStationStorage(1);
 END {CheckIsFuelStationStorage};

 PRIVATE PROCEDURE GasStan_OnOpenWindow();
  VAR
   i                : NUMERIC[0];
   trgStorage       : LIKE(Storage.Storage);
   GasStanPumps     : tGasStanPumpArr;
   trgPumpAmount    : NUMERIC[0];
   AcceptableStorage: SCAL[2];
 BEGIN
  SetGasStanTitle(1);
  SetCurrentOperation(gsm_Idle);
  UpdateSysDateTime();
  TRY
   CheckIsFuelStationStorage();
   AcceptableStorage:=1;
  EXCEPT
  ON Exc:Exc_Raise DO
   setFieldValue(v_Operation, "! " + Exc.Description + " !");
   AcceptableStorage:=0;
  ELSE
   RAISE();
  END; (* TRY *)

  IF AcceptableStorage THEN
   trgStorage:=L_Stock.DefaultStorage();

   P_Storage.GetGasStanSetup(trgStorage, SYSDATE(), OwnPumps, OwnNozzles, OwnMaths,
                                                                            OutNozzles, OutMaths);
   trgPumpAmount:=Math.Min(GetTotalPumpAmount(), P_Storage.MaxGasStanPumpAmount);
   L_General.CallUs(trgPumpAmount <= P_Storage.MaxGasStanPumpAmount);
   RTI.Get().CurWindow.Depth:=13 + 3 * trgPumpAmount;
 
   PackPumpArr(GasStanPumps);
   i:=0;
   WHILE (i <= HIGH(GasStanPumps)) & ~!GasStanPumps[i] DO
    setFieldValue(v_GP_Pump+L_Str.FixedIntStr(i+1, 2), GasStanPumps[i]);
    INC(i);
   END; (* WHILE i <= HIGH(GasStanPumps)...*)
 
   RefreshGasStanWindow();
   L_Timer.SetTimer("GasStan_Stat", 1, 5, "GasStan.ScanNewADV()");
   IF ~VAR_IMPL.Get(BadADV).Initialized THEN
    BadADV:=L_General.CreateDictionary();
   END;
  END;
  UpdateSysDateTime();
 END {GasStan_OnOpenWindow};

 PRIVATE PROCEDURE GetMDocKindByGasStanMode(): LIKE(MDocKind.MDocKind);
  VAR
   Result: LIKE(MDocKind.MDocKind);
 BEGIN
  IF    GasStanMode = gsm_BuildNOV THEN
   Result:=L_MDoc.md_NOV;
  ELSIF GasStanMode = gsm_BuildTOV THEN
   Result:=L_MDoc.md_TOV;
  ELSIF GasStanMode = gsm_BuildMSP THEN
   Result:=L_MDoc.md_MSP;
  ELSIF GasStanMode = gsm_OutCar THEN
   Result:=L_MDoc.md_TCh;
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {GetMDocKindByGasStanMode};

 PRIVATE PROCEDURE CheckMathIsMarkFuel(trgDate  : DATE;
                                       trgMath  : LIKE(Math.Math);
                                       trgBoxNbr: LIKE(Car.BoxNbr));
  VAR
   Msg: STRING[];
 BEGIN
  L_Fuel.CheckMathIsMarkFuel(trgDate, trgMath, trgBoxNbr, Msg);
  IF ~!Msg THEN
   L_General.Error(Msg);
  END;
 END {CheckMathIsMarkFuel};

 PRIVATE PROCEDURE Proceed_Math(trgMath: LIKE(Math.Math); RealSuccessfulChange: SCAL[2]);
  VAR
   curXDoc    : L_XDoc.tXDoc;
   curNozzle  : P_Storage.tNozzle;
   curXDocType: L_XDoc.tXDocType;
 BEGIN
  IF ~!trgMath THEN
   curXDocType:=getFV_Scal(v_XDocType);
   curXDoc    :=getFV_Scal(v_XDoc);
   curNozzle  :=getFV_Scal(v_Nozzle);
   PosToMath(trgMath);
   L_General.Assert(L_DatTim.IsActive(SYSDATE(), Math.Begin, Math.Till),
                    " " + Math.Math + "     " + L_DatTim.DateStr(SYSDATE()));

   IF ~!curXDoc THEN
    IF    curXDocType = L_XDoc.xdt_RWayS THEN
     PosToRWayS(curXDoc);
     CheckMathIsMarkFuel(RWayS.Date, trgMath, RWayS.BoxNbr);

     IF IsRealNozzle(curNozzle) & E_gs_IsFuelStation() THEN
      L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
      IF trgMath # L_Fuel.GetMainFuel(RWayS.Date, Mark.Mark) THEN
       L_StdFrm.Question(" " + trgMath + "    ⮯|ન " + Mark.Mark + " " + Mark.Name);
      END;
     END;
    ELSIF curXDocType = L_XDoc.xdt_RprS THEN
     PosToRprS(curXDoc);
     L_Rpr.AccessOrigin();
     CheckMathIsMarkFuel(RprS.OrdDate, trgMath, Car.BoxNbr);
    END;
   END;

   IF ~extCheckAccordanceNozzleToMath(curNozzle, trgMath, ~RealSuccessfulChange) THEN
    SETEMPTY(trgMath);
   END;
  END;
  setFieldValue(v_Math,      trgMath);
 END {Proceed_Math};

 PRIVATE PROCEDURE Proceed_XDoc(trgXDocId: L_XDoc.tXDocId);
  VAR
   Dummy      : STRING[];
   begin,
   till       : DATE;
   trgQnt     : L_XObj.tQnt;
   trgXDocType: L_XDoc.tXDocType;
   trgXDocKind: L_XDoc.tXDocKind;
   trgXDoc    : L_XDoc.tXDoc;
   XDocDescr_1,
   XDocDescr_2: STRING[];
 BEGIN
  IF    ~!trgXDocId THEN
   L_XDoc.DecodeXDocId(trgXDocId, trgXDocType, trgXDocKind, trgXDoc);
   L_XDoc.PositionOnXDoc(trgXDocId);
   setFieldValue(v_XDocType, trgXDocType);
   setFieldValue(v_XDoc,     trgXDoc);

   IF    trgXDocType = L_XDoc.xdt_RWayS THEN
    SetCurrentOperation(gsm_BuildNOV);
    L_General.Assert(RWayS.Status = L_Way.rwsStat_Given, "   ﭨ '뤠' ("+RWayS.RWayS+")");
    L_General.Assert(L_Env.RealBoxNbr(RWayS.BoxNbr), " ⥯த⮢  ⮫쪮    ॠ ");
    CheckSingleLoading(L_MDoc.md_NOV, RWayS.BoxNbr, RWayS.TSN);
    L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
    CONFORM(CarLog, Mark);
    IF E_gs_IsFuelStation() THEN
     Proceed_Math(L_Fuel.GetMainFuel(RWayS.Date, CarLog.Mark), 0);
     IF GetInteractionMode(L_Stock.DefaultStorage()) = im_Normal THEN
      IF L_Fuel.E_LoadFullTank(SYSDATE()) THEN
       trgQnt:=L_Way.GetBakVol(RWayS.BoxNbr, RWayS.Date);
      ELSE
       trgQnt:=CalcFuelNorm();
      END;
     ELSE
      SETEMPTY(trgQnt);
     END;
    ELSE
     SETEMPTY(trgQnt);
    END;
 
    CONFORM(RWayS, Staff);
    CONFORM(Staff, Man);
    XDocDescr_1:=CarInfo();
    XDocDescr_2:=Staff.TSN+" "+Man.Name;
   ELSIF trgXDocType = L_XDoc.xdt_RprS THEN
    SetCurrentOperation(gsm_BuildMSP);

    SETEMPTY(trgQnt);
    L_General.Assert(~RprS.Closed, "     ("+RprS.RprS+")");
    L_General.Assert(L_Rpr.IsRprS_w_Car(), "   ଫ  ᮡ⢥  ("+RprS.RprS+")");

    L_Rpr.AccessOrigin();
    L_Car.StandOnCarLog(Car.BoxNbr, RprS.OrdDate);
    CONFORM(CarLog, Mark);
    XDocDescr_1:=CarInfo();
    XDocDescr_2:="  "+FULLNAME();
   ELSIF trgXDocType = L_XDoc.xdt_Contract THEN
    SetCurrentOperation(gsm_OutCar);

    L_General.Assert(L_DatTim.IsActive(SYSDATE(), Contract.Begin, Contract.Till),
                     "  " + L_DatTim.DateStr(SYSDATE()) + "  ਮ ਬ  " + Contract.Contract);

P_Cntr.GetContractDuration(Contract.Contract, SYSDATE(), begin, till);
IF    !begin THEN
 L_StdFrm.CustomQuestion(" ꥪ ''|" +
                         Contract.Contract + " " + Contract.Name + "|" +
                         "室 ନ ᢮⢮ 7331, 饥  " + L_DatTim.DateStr(SYSDATE()) + ".||" +
                         "१ ஥ ६  ⠭ 訡");
ELSIF ~L_DatTim.IsActive(SYSDATE(), begin, till) THEN
 L_StdFrm.CustomQuestion(" " + Contract.Contract + "    " + L_DatTim.DateStr(SYSDATE()) + ".||" +
                         "१ ஥ ६  ⠭ 訡");
ELSIF ~!till & ((till - SYSDATE()) <= 5) THEN
 L_StdFrm.CustomQuestion("ப ⢨  " + Contract.Contract + " 稢 १ " + L_Str.IntStr(till - SYSDATE()) + " .|" +
                         " 祭 ⮣ ப  ⮯   㤥 .||" +
                         "᫨   , 室   ");
END;

(*
    Dummy:=P_Cntr.GetCntrProStrong(Contract.Contract, SYSDATE(), P_Cntr.P_Duration);
    P_Cntr.GetContractDuration(Contract.Contract, SYSDATE(), begin, till);
    L_General.Assert(L_DatTim.IsActive(SYSDATE(), begin, till),
                     " " + Contract.Contract + "    " + L_DatTim.DateStr(SYSDATE()));
    IF ~!till & ((till - SYSDATE()) <= 5) THEN
     L_StdFrm.CustomQuestion("ப ⢨  " + Contract.Contract + " 稢 १ " + L_Str.IntStr(till - SYSDATE()) + " .|" +
                             " 祭 ⮣ ப  ⮯   㤥 .||" +
                             "᫨   , 室   ");
    END;
*)

    P_Firm.AccessFirm(Contract.Firm);
    SETEMPTY(trgQnt);
    IF GetInteractionMode(L_Stock.DefaultStorage()) = im_Normal THEN
     IF IsCashLoading() THEN
      SetCashLoadingFields(1);
     ELSE
      trgQnt:=500;
     END;
    END;
    XDocDescr_1:=Contract.Name;
    XDocDescr_2:="ࠣ " + Firm.Name;
   ELSE
    L_General.Error(" ⮬  ⮬᪠ ࠢ ");
   END;

   setFieldValue(v_Qnt, trgQnt);

   setFieldValue(v_XDocDescr_1, XDocDescr_1);
   setFieldValue(v_XDocDescr_2, XDocDescr_2);
  ELSE
   SetCurrentOperation(gsm_Idle);
  END;
 END {Proceed_XDoc};

 PRIVATE PROCEDURE CheckFreeGasPump(_BoxNbr: LIKE(Car.BoxNbr); _TSN: LIKE(Staff.TSN); _Nozzle: P_Storage.tNozzle);
 BEGIN
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF IsAcceptableGasStanMDocKind() THEN
    CheckFreeGasPumpByMDocKind(MDocKind.MDocKind, _BoxNbr, _TSN, _Nozzle);
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
 END {CheckFreeGasPump};

 PRIVATE PROCEDURE CheckGasStanMode();
 BEGIN
  L_General.Assert(GasStanMode # gsm_Idle, " ⠭ ० ᪠  ( 뫮 ᪠஢ )");
 END {CheckGasStanMode};

 PRIVATE PROCEDURE GasStan_Nozzle_OnSuccessfulChange();
  VAR
   Dummy    : P_Storage.tPump;
   curNozzle: P_Storage.tNozzle;
 BEGIN
  CheckGasStanMode();
  curNozzle:=RTI.Get().CurZone.ActiveField.Value;
  IF ~!curNozzle THEN
   IF IsRealNozzle(curNozzle) THEN
    IF ~IsOutNozzle(curNozzle) THEN
     Dummy:=NozzleToPump(curNozzle);
    END;
    IF GasStanMode = gsm_BuildNOV THEN
     PosToRWayS(getFV_Scal(v_XDoc));
     CheckFreeGasPump(RWayS.BoxNbr, RWayS.TSN, curNozzle);
     Proceed_Math(getFV_Scal(v_Math), 0);
    ELSE
     CheckFreeGasPump(EMPTYOF(Car.BoxNbr), EMPTYOF(Staff.TSN), curNozzle);
     IF GasStanMode = gsm_OutCar THEN
      Proceed_Math(GetMathForNozzle(curNozzle), 0);
     ELSE
      CheckAccordanceNozzleToMath(curNozzle, getFV_Scal(v_Math));
     END;
    END;
   ELSE
    extSetEmptyHeadFields(0);
   END;
  ELSE
   extSetEmptyHeadFields(0);
  END;
 END {GasStan_Nozzle_OnSuccessfulChange};

 PRIVATE PROCEDURE GasStan_Sum_OnSuccessfulChange();
 BEGIN
  CheckGasStanMode();
  IF ~!getFV_Number(v_Qnt) THEN
   L_StdFrm.Question(" ࠢ  । 㬬 ⢮  .|" +
                     "  ⢮ ⮯?");
   setFieldValue(v_Qnt, EMPTYOF(L_XObj.tQnt));
  END;
  GetGasStanField(v_Qnt).Modifiable:=!getFV_Number(v_Sum);
 END {GasStan_Sum_OnSuccessfulChange};

 PRIVATE PROCEDURE GasStan_Qnt_OnSuccessfulChange();
 BEGIN
  CheckGasStanMode();
  IF ~!getFV_Number(v_Sum) THEN
   L_StdFrm.Question(" ࠢ  । ⢮ 㬬  .|" +
                     "  㬬?");
   setFieldValue(v_Sum, EMPTYOF(L_XObj.tSum));
  END;
  GetGasStanField(v_Sum).Modifiable:=!getFV_Number(v_Qnt);
 END {GasStan_Qnt_OnSuccessfulChange};

 PRIVATE PROCEDURE GasStan_Math_OnSuccessfulChange();
 BEGIN
  CheckGasStanMode();
  Proceed_Math(RTI.Get().CurZone.ActiveField.Value, 1);
 END {GasStan_Math_OnSuccessfulChange};

 PRIVATE PROCEDURE JumpToGasPumpField(curFieldName: STRING[]);
  VAR
   Cnt    : NUMERIC[0];
   Command: STRING[];
 BEGIN
  SETEMPTY(Command);
  IF IsCashLoading() THEN
   SETZERO(Cnt);
   IF    curFieldName = v_Nozzle THEN
    Cnt:=0;
   ELSIF curFieldName = v_Sum THEN
    Cnt:=1;
   ELSIF curFieldName = v_Qnt THEN
    Cnt:=2;
   ELSIF curFieldName = v_Math THEN
    Cnt:=3;
   END;
   WHILE Cnt > 0 DO
    Command:=L_Str.AddStrDlm(Command, ",") + 'PrvField, ""';
    DEC(Cnt);
   END;
  ELSE
   IF    curFieldName = v_Math THEN
    Command:='NxtField, ""';
   ELSIF curFieldName = v_Qnt THEN
    Command:='PrvField, ""';
   END;
  END;
  IF ~!Command THEN
   LIKEMENU(^Command);
  END;
 END {JumpToGasPumpField};

 PUBLIC PROCEDURE GetRefDocId();
  VAR
   trgXDocId   : L_XDoc.tXDocId;
   trgXDocType : L_XDoc.tXDocType;
   trgXDocKind : L_XDoc.tXDocKind;
   trgXDoc     : L_XDoc.tXDoc;
 BEGIN
  CheckIsFuelStationStorage();
  CheckFolderExists(~!GetWorkPath(gfpm_Strong));
  IF GasStanMode # gsm_Idle THEN
   L_StdFrm.Question(" 楤 ଫ ࠢ.|" +
                     "ࢠ 楤   ଫ  ࠢ?");
  END;
  SetCurrentOperation(gsm_Idle);

  trgXDocId        :=L_XDoc.GetRequiredTypeXDocIdByBC("ࠢ", EMPTYOF(L_XDoc.tXDocType), 0);
  L_XDoc.ref_XDocId:=trgXDocId;
  L_XDoc.DecodeXDocId(trgXDocId, trgXDocType, trgXDocKind, trgXDoc);
  IF    ~!trgXDocType THEN
   IF trgXDocType # L_XDoc.xdt_Command THEN
    IF trgXDocType = L_XDoc.xdt_RprS THEN
     L_General.Assert(~E_gs_IsFuelStation(), "ࠢ  ⮬   ⮫쪮  ᫮ࠢ");
    END;
    TRY
     Proceed_XDoc(trgXDocId);
    EXCEPT
    ON Exc: Exc_Root DO
     SetCurrentOperation(gsm_Idle);
     RAISE();
    END; (* TRY *)
   ELSE
    IF    trgXDoc = L_XDoc.cmd_BuildGasStanTOV THEN
     SetCurrentOperation(gsm_BuildTOV);
    ELSIF trgXDoc = L_XDoc.cmd_BuildGasStanMSP THEN
     SetCurrentOperation(gsm_BuildMSP);
    ELSIF trgXDoc = L_XDoc.cmd_BegShift THEN
     ShiftManipulation(nsd_BegShift);
    ELSIF trgXDoc = L_XDoc.cmd_EndShift THEN
     ShiftManipulation(nsd_EndShift);
    ELSE
     L_General.Error(" ⮬  ⮬᪠ ࠢ ");
    END;
   END;
   JumpToGasPumpField(RTI.Get().CurZone.ActiveField.Name);
  END;
 END {GetRefDocId};

 PRIVATE PROCEDURE E_GetOutFuelStation(trgNozzle: P_Storage.tNozzle): LIKE(Storage.Storage);
  VAR
   Local : PROC;
   Result: LIKE(Storage.Storage);
 BEGIN
  SETEMPTY(Result);
  Local:=PROCREF(E_Stock.gs_GetOutFuelStation);
  IF ~!Local THEN
   Result:=Local(trgNozzle);
  END;
  IF !Result THEN
   L_General.SetupRequired();
  END;
  RETURN Result;
 END {E_GetOutFuelStation};

 PRIVATE PROCEDURE BuildMDoc(trgNozzle: P_Storage.tNozzle);
  VAR
   Local  : PROC;
   trgMath: LIKE(Math.Math);
   trgSum,
   trgVAT : L_XObj.tSum;
   trgQnt : L_XObj.tQnt;
 BEGIN
  SE_INTEGRITY(1);

  DEFAULT(MDoc);
  MDoc.MyFirm  :=P_Firm.mf_Fict;
  IF    GasStanMode = gsm_BuildNOV THEN
   PosToRWayS(getFV_Scal(v_XDoc));
   MDoc.MDocKind:=L_MDoc.md_NOV;
   MDoc.Date    :=L_DatTim.MinDATE(L_BegRWS.DspSysDate(), L_DatTim.MonthEnd(RWayS.Date));
   MDoc.BoxNbr  :=RWayS.BoxNbr;
   CONFORM(RWayS, Car);
  ELSIF GasStanMode = gsm_OutCar THEN
   MDoc.MDocKind:=L_MDoc.md_TCh;
   MDoc.Date    :=L_BegRWS.DspSysDate();
   MDoc.Contract:=getFV_Scal(v_XDoc);
   L_Cntr.PositionOnContract(MDoc.Contract);
   MDoc.Firm    :=Contract.Firm;
  ELSIF (GasStanMode = gsm_BuildMSP) & (getFV_Scal(v_XDocType) = L_XDoc.xdt_RprS) THEN
   PosToRprS(getFV_Scal(v_XDoc));
   L_Rpr.AccessOrigin();
   MDoc.MDocKind:=L_MDoc.md_MSP;
   MDoc.Date    :=SYSDATE();
   MDoc.BoxNbr  :=Car.BoxNbr;
  ELSE
   L_General.CallUs(0);
  END;
  MDoc.Alower  :=L_MDoc.E_DefaultAlower(MDoc.Date);
  IF IsOutNozzle(trgNozzle) THEN
   MDoc.Storage :=E_GetOutFuelStation(trgNozzle);
  ELSE
   MDoc.Storage :=L_Stock.DefaultStorage();
  END;
  MDoc.Status  :=L_MDoc.st_Prepared;
  Local:=PROCREF(E_Stock.gs_SetNewMDocFields);
  IF ~!Local THEN
   Local(GasStanMode, trgNozzle);
  END;
(*   SrcDate  PayDate,  E_Stock.gs_SetNewMDocFields MDoc.Date   *)
  MDoc.SrcDate :=MDoc.Date;
  MDoc.PayDate :=MDoc.Date;
  L_MDoc.Insert_MDoc();
  IF GasStanMode = gsm_BuildNOV THEN
   MDoc.TSN:=RWayS.TSN;
  ELSE
   MDoc.TSN:=L_MDoc.curUSER2MDocTSN(0);
  END;

(* ⠢! ॡ ⥪騩 MDoc*)
  trgMath:=E_gs_ConvMath2MDLMath(trgNozzle, getFV_Scal(v_Math), MDoc.MDocKind);
  PosToMath(trgMath);

  IF    (MDoc.MDocKind = L_MDoc.md_NOV) & (Math.MathType = L_MathR.mtyp_Fuels) THEN
   MDoc.Dest:=L_Dest.erkn_Get(MDoc.Date, L_Dest.erkn_FuelStationMovement);
  ELSIF !MDoc.Dest THEN
   MDoc.Dest    :=L_MDoc.E_DefMDocDest(MDoc.Date);
   MDoc.CostItem:=L_MDoc.E_DefMDocCostItem();
   L_General.Assert(~!MDoc.Dest, " 㤠 ।   㬮砭.|" +
                                 "( " + MDoc.Storage + ",  " + trgMath + ",   " + MDoc.MDocKind + ", ० " + GasStanMode + ")||" +
                                 "᫨  㢥७  ࠢ쭮 ᢮ ⢨,|  ");
  END;
  REPLACE(MDoc);

  IF    GasStanMode = gsm_BuildNOV THEN
   L_XDoc.rf_Insert(L_XDoc.xdt_MDoc,
                    L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS),
                    L_XDoc.rft_RefTo);
  ELSIF (GasStanMode = gsm_BuildMSP) & (getFV_Scal(v_XDocType) = L_XDoc.xdt_RprS) THEN
   L_XDoc.rf_Insert(L_XDoc.xdt_MDoc,
                    L_XDoc.XDocId(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS),
                    L_XDoc.rft_RefTo);
  END;
  trgQnt:=getFV_Number(v_Qnt);
  IF !trgQnt THEN
   trgQnt:=0;
  END;
  trgSum:=getFV_Number(v_Sum);
  IF !trgSum THEN
   trgSum:=0;
  END;
  trgVAT:=L_Acnt.GetInclVAT(MDoc.Date, trgSum);
  L_MDoc.InsMDocList(trgMath, L_MathR.mm_New, "", trgQnt, trgSum-trgVAT, trgVAT);

  L_MDoc.MDoc_OnAnyModification(+1, L_MDoc.np_Yes, 0);
  SE_INTEGRITY(0);
  CALL(MDoc.CheckRefToXDocModificationLegality(0));

  CONFORM(MDoc, MDocList);
  InfoBegin(trgNozzle);
 END {BuildMDoc};

 PRIVATE PROCEDURE CheckLoadingAttr();
  VAR
   curNozzle: P_Storage.tNozzle;
   curMath  : LIKE(Math.Math);
   curQnt   : L_XObj.tQnt;
   curSum   : L_XObj.tSum;
 BEGIN
  curNozzle:=getFV_Scal(v_Nozzle);
  curMath  :=getFV_Scal(v_Math);
  curQnt   :=getFV_Number(v_Qnt);
  curSum   :=getFV_Number(v_Sum);
  IF    GasStanMode = gsm_BuildNOV THEN
   L_General.Assert(~!getFV_Scal(v_XDoc), " 㪠  ");
  END;

  L_General.Assert(~!curNozzle, " 㪠  ⮫");
  IF IsCashLoading() THEN
   IF    !curSum THEN
    IF !curQnt THEN
     L_General.Error(" 㪠  ⢮,  㬬 ࠢ");
    ELSE
     L_General.Assert(curQnt # 0,  "ࠢ  0 ஢?");
    END;
   ELSE
    L_General.Assert(curSum # 0,  "ࠢ  0 㡫?");
   END;
  ELSE
   L_General.Assert(~!curQnt,    " 㪠 ⢮");
   L_General.Assert(curQnt # 0,  "ࠢ  0 ஢?");
  END;
  L_General.Assert(~!curMath,   " 㪠  ⥯த");
 END {CheckLoadingAttr};

 PRIVATE PROCEDURE E_MakePRMRequired(trgNozzle: P_Storage.tNozzle; trgMath: LIKE(Math.Math)): SCAL[2];
  VAR
   Local  : PROC;
   Result,
   default: SCAL[2];
 BEGIN
  default:=(GetInteractionMode(L_Stock.DefaultStorage()) = im_Normal) & ~IsOutNozzle(trgNozzle);
  Local  :=PROCREF(E_Stock.gs_MakePRMRequired);
  IF ~!Local THEN
   Result:=Local(trgMath, default);
  ELSE
   Result:=default;
  END;
  RETURN Result;
 END {E_MakePRMRequired};

 PRIVATE PROCEDURE intMakeQuery();
  VAR
   trgNozzle: P_Storage.tNozzle;
 BEGIN
  trgNozzle:=getFV_Scal(v_Nozzle);
  IF E_MakePRMRequired(trgNozzle, getFV_Scal(v_Math)) THEN
   TRY [TRANSACTION(TRANSACTION_SLAVE), MSG_SUPPRESSION(MSG_SUPPRESSION_NONE)]
    BuildMDoc(trgNozzle);
    MakePRM(o_StartLoading);
   EXCEPT
   END; (* TRY *)
  ELSE
   BuildMDoc(trgNozzle);
   SetMDocPro(o_StartLoading, 0);
   SimplePassedMDoc();
  END;
  SetCurrentOperation(gsm_Idle);
  RefreshGasStanWindow();
 END {intMakeQuery};

 PRIVATE PROCEDURE MDocBeforeInsert(WinName: STRING[]);
  VAR
   Params: STRING[];
 BEGIN
  Params:=" MDocSource=GasStan" +
          " UsingBCS=True"      +
          " trgMath="           + getFV_String(v_Math) +
          " trgQnt="            + ConvQntToStr(getFV_Number(v_Qnt)) +
          " trgDate="           + L_DatTim.DateStr(L_BegRWS.DspSysDate());
  IF (GasStanMode = gsm_BuildNOV) & (Math.MathType = L_MathR.mtyp_Fuels) THEN
   INC(Params, " trgDest=" + L_Dest.erkn_Get(SYSDATE(), L_Dest.erkn_FuelStationMovement));
  END;
  LIKEMENU(Ins, WinName + " 0 @" + Params);
 END {MDocBeforeInsert};

 PUBLIC PROCEDURE MakeQuery();
  VAR
   curNozzle: P_Storage.tNozzle;
 BEGIN
  TRY [TRANSACTION(TRANSACTION_SLAVE), MSG_SUPPRESSION(MSG_SUPPRESSION_NONE)]
   L_General.Assert(GasStanMode # gsm_Idle, " ०  ࠢ   ࠢ ");
   CheckLoadingAttr();
   curNozzle:=getFV_Scal(v_Nozzle);
   CheckAccordanceNozzleToMath(curNozzle, getFV_Scal(v_Math));
   IF    GasStanMode = gsm_BuildNOV THEN
    PosToRWayS(getFV_Scal(v_XDoc));
    IF IsRealNozzle(curNozzle) & L_Env.RealTSN(RWayS.TSN) THEN
     intMakeQuery();
    ELSE
     CALL(MDoc.GasStan_InitializePermanent());
     MDocBeforeInsert("MD03EM");
    END;
   ELSIF GasStanMode = gsm_BuildTOV  THEN
    MDocBeforeInsert("MD02E");
   ELSIF GasStanMode = gsm_BuildMSP THEN
    IF getFV_Scal(v_XDocType) = L_XDoc.xdt_RprS THEN
     intMakeQuery();
    ELSE
     MDocBeforeInsert("MD60E");
    END;
   ELSIF GasStanMode = gsm_OutCar THEN
    IF IsRealNozzle(curNozzle) THEN
     intMakeQuery();
    ELSE
     MDocBeforeInsert("MD70E");
    END;
   ELSE
    L_General.CallUs(0);
   END;
  EXCEPT

  END; (* TRY *)
 END {MakeQuery};

 PUBLIC PROCEDURE CheckMDoc();
  VAR
   Msg      : STRING[];
   trgNozzle: P_Storage.tNozzle;
 BEGIN
  trgNozzle:=getFV_Scal(v_Nozzle);
  IF E_MakePRMRequired(trgNozzle, getFV_Scal(v_Math)) THEN
   CheckFolderExists(~!GetWorkPath(gfpm_Strong));
  END;
  L_General.Assert(~!trgNozzle, " 㪠  ⮫");
  IF MDoc.MDocKind = L_MDoc.md_MSP THEN
   L_General.Assert(~!MDoc.Storage2, "  㪠  ");
  END;
  CheckMDocListExists();
  IF IsRealNozzle(trgNozzle) THEN
   CheckMDocListAmount();
   InfoBegin(trgNozzle);
  ELSE
   SETEMPTY(Msg);
   WHILE OCCURE(MDocList) DO
    CONFORM(MDocList, Math);
    Msg:=Msg + Str.Align(MDocList.Math + " " + Math.Name, 64, LEFT) + " " +
               Str.Align(ConvQntToStr(MDocList.Qnt), 8, LEFT)    + " " +
               Str.Align(L_MathR.DefaultMUnitSign(MDocList.Math), Str.MaxLength(MUnit.Sign), LEFT) + "|";
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)

   L_StdFrm.Question("   " + L_MDoc.MDocKindNick(MDoc.MDocKind, 1) +
                     "||" +
                     RecipientInfoByMDoc() +
                     "||" +
                     Msg);
  END;
 END {CheckMDoc};

 PUBLIC PROCEDURE MDocAfterInsert(trg_ri: LIKE(MDoc.RECORDID));
  VAR
   trgNozzle: P_Storage.tNozzle;
 BEGIN
  TRY [TRANSACTION(TRANSACTION_SLAVE), MSG_SUPPRESSION(MSG_SUPPRESSION_NONE), TERM_BY_USER(TERM_BY_USER_IGNORE)]
   L_General.CallUs(SEARCH(MDoc, RECORDID, trg_ri));
   trgNozzle:=getFV_Scal(v_Nozzle);
   L_General.Assert(~!trgNozzle, " 㪠  ⮫");
   IF IsRealNozzle(trgNozzle) THEN
    IF E_MakePRMRequired(trgNozzle, getFV_Scal(v_Math)) THEN
     CONFORM(MDoc, MDocList);
     CONFORM(MDocList, Math);
     Proceed_Math(E_gs_ConvMDLMath2Math(trgNozzle), 0);
     setFieldValue(v_Qnt, MDocList.Qnt);
     MakePRM(o_StartLoading);
    ELSE
     SetMDocPro(o_StartLoading, 0);
     SimplePassedMDoc();
    END;
   ELSE
    SimplePassedMDoc();
   END;
  EXCEPT

  END; (* TRY *)
  SetCurrentOperation(gsm_Idle);
  RefreshGasStanWindow();
 END {MDocAfterInsert};

 PRIVATE PROCEDURE GatherMDocListByMDocKind(_MDocKind: LIKE(MDocKind.MDocKind); VAR XDocIdArr: L_XDoc.tXDocId[]);
  VAR
   Pump      : P_Storage.tPump;
   trgNozzle : P_Storage.tNozzle;
   trgStorage: LIKE(Storage.Storage);
 BEGIN
  trgStorage:=L_Stock.DefaultStorage();
  SELECT(MDoc, MDKStat, , _MDocKind, L_MDoc.st_Prepared);
  WHILE OCCURE(MDoc) DO
   IF (MDoc.Storage = trgStorage) | (MDoc.Storage2 = trgStorage) THEN
    trgNozzle:=GetMDocNozzle(0);
    IF ~!trgNozzle THEN
     Pump:=NozzleToPump(trgNozzle);
     XDocIdArr[Pump]:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
    END;
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {GatherMDocListByMDocKind};

 PRIVATE PROCEDURE ShowMDocSL(Title: STRING[]);
  VAR
   trgPump  : P_Storage.tPump;
   XDocIdArr: L_XDoc.tXDocId[MAXOF(P_Storage.tPump)+1];
 BEGIN
  TRY
   SETEMPTY(XDocIdArr);
   L_XDoc.sl_Init(Title);

   SELECT(MDocKind, MDocKind);
   WHILE OCCURE(MDocKind) DO
    IF IsAcceptableGasStanMDocKind() THEN
     GatherMDocListByMDocKind(MDocKind.MDocKind, XDocIdArr);
    END;
    NEXT(MDocKind);
   END; (* WHILE OCCURE(MDocKind) ... *)
 
   FOR_EACH trgPump DO
    IF ~!XDocIdArr[trgPump] THEN
     L_XDoc.PositionOnXDoc(XDocIdArr[trgPump]);
     CONFORM(MDoc, Staff);
     CONFORM(Staff, Man);
     L_XDoc.sl_AddItem(XDocIdArr[trgPump], " " + trgPump + ", " + Str.Align(Staff.TSN + " " + L_Str.ShortName(Man.Name), 25, LEFT) +": "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
    END;
   END; (* FOR_EACH *)
  EXCEPT

  END; (* TRY *)
  L_XDoc.sl_Show();
 END {ShowMDocSL};

 PUBLIC PROCEDURE StandOnGasStanMDoc();
 BEGIN
  ShowMDocSL("  ࠢ");
  SetCurrentOperation(gsm_Idle);
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.pvs_XDocId, "");
 END {StandOnGasStanMDoc};

 PUBLIC PROCEDURE StopPRM();
 BEGIN
  ShowMDocSL("⠭ ࠢ");
  L_XDoc.PositionOnXDoc(L_XDoc.pvs_XDocId);
  L_General.Assert(MDoc.Status = L_MDoc.st_Prepared, L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+"  室  ﭨ '⮢'");
  L_General.Assert(~HasMDocStopLoading(), L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+": 㦥 ନ஢   ⠭ ࠢ.");
  L_General.Assert(IsAcceptableCurUser(), "⠭ ࠢ  ⮫쪮  ᮡ⢥ ᠬ  ࠢ");

  TRY [TRANSACTION(TRANSACTION_SLAVE)]
   MakePRM(o_StopLoading);
  EXCEPT
  END; (* TRY *)
  RefreshGasStanWindow();
 END {StopPRM};

 PRIVATE PROCEDURE GetAnyFullFileName(Operation: tOperation; Ext: STRING[]): STRING[];
  VAR
   Path: STRING[];
 BEGIN
  Path:=GetWorkPath(gfpm_Strong);
  CheckFolderExists(~!Path);
  RETURN FIO.BuildPath(GetAnyFileName(Operation, Ext), , Path);
 END {GetAnyFullFileName};

 PRIVATE PROCEDURE CheckPRMExists(StartLoadingPRMFileName, StopLoadingPRMFileName: STRING[]);
 BEGIN
  L_General.Assert(FIO.Exists(StartLoadingPRMFileName) | FIO.Exists(StopLoadingPRMFileName),
                   "-ࠧ襭    .|" +
                   ",  ࠡ⠭ ࠢ饩 ணࠬ.|||" +
                   "㫨஢   樨 饭.|||" +
                   "᫨ 䠩  - 孨᪮ ᡮ,| 室 㫨஢ ");
 END {CheckPRMExists};

 PUBLIC PROCEDURE ManualCancelMDoc();
  VAR
   trgCash                : L_XObj.tSum;
   Msg,
   StopLoadingPRMFileName,
   StartLoadingPRMFileName: STRING[];
 BEGIN
  ShowMDocSL("ࠢ  砫, 㫨஢ ");
  L_XDoc.PositionOnXDoc(L_XDoc.pvs_XDocId);

  CheckMDocListExists();
  StandOnMathByMDLMath(GetMDocNozzle(1));

  StartLoadingPRMFileName:=GetAnyFullFileName(o_StartLoading, "PRM");
  StopLoadingPRMFileName :=GetAnyFullFileName(o_StopLoading,  "PRM");;

  CheckPRMExists(StartLoadingPRMFileName, StopLoadingPRMFileName);
  Msg:="㫨஢ " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) +
       "||" + RecipientInfoByMDoc() +
       "||" + PumpInfoAsStr(GetMDocNozzle(1)) +
       "||" + " " + GetMDocListLoadingInf() +
       "|||" + "ࠢ  뫠  - ⢨ 裡  ࠢ饩 ணࠬ";
  TRY [TRANSACTION(TRANSACTION_SLAVE), MSG_SUPPRESSION(MSG_SUPPRESSION_NONE)]
   L_StdFrm.CrucialChoice_FileExplicit("MDoc", Msg, L_APtm.g_FuelStock);
  EXCEPT
  END;
  trgCash:=GetMDocCash();
  IF ~!trgCash THEN
   L_StdFrm.Inform(CountChangeMsg(0.00, trgCash));
  END;

  CheckPRMExists(StartLoadingPRMFileName, StopLoadingPRMFileName);

  ProceedMDoc(L_MDoc.st_Canceled, EMPTYOF(NUMERIC[3]), EMPTYOF(NUMERIC[2]), TRANSACTION_SLAVE, 1);

  FIO.Erase(StartLoadingPRMFileName);
  FIO.Erase(StopLoadingPRMFileName);

  RefreshGasStanWindow();
 END {ManualCancelMDoc};

 PRIVATE PROCEDURE CheckADVExists(StartLoadingADVFileName, StopLoadingADVFileName: STRING[]);
 BEGIN
  L_General.Assert(~FIO.Exists(StartLoadingADVFileName) & ~FIO.Exists(StopLoadingADVFileName),
                   "-㢥    .|||" +
                   "筮 ஢    樨 饭.|||" +
                   "-㢥 㤥 ࠡ⠭  ࠧ.");
 END {CheckADVExists};

 PUBLIC PROCEDURE ManualProceedMDoc();
  VAR
   newQnt                 : L_XObj.tQnt;
   newSum,
   trgCash                : L_XObj.tSum;
   SumRequired            : SCAL[2];
   Msg,
   VarList,
   Blank,
   PoolIns,
   StopLoadingADVFileName,
   StartLoadingADVFileName,
   StopLoadingPRMFileName,
   StartLoadingPRMFileName: STRING[];
 BEGIN
  ShowMDocSL("ࠢ 祭, ஢ ");
  L_XDoc.PositionOnXDoc(L_XDoc.pvs_XDocId);

  CheckMDocListExists();
  StandOnMathByMDLMath(GetMDocNozzle(1));

  StartLoadingPRMFileName:=GetAnyFullFileName(o_StartLoading, "PRM");
  StopLoadingPRMFileName :=GetAnyFullFileName(o_StopLoading,  "PRM");;
  IF FIO.Exists(StartLoadingPRMFileName) | FIO.Exists(StopLoadingPRMFileName) THEN
   L_StdFrm.Choice("-ࠧ襭   ⮯    .|" +
                   " ᪥ ⮯   ⮣ 䠩   .||"+
                   "⢨⥫쭮  믮  ⮯?");
  END;

  StartLoadingADVFileName:=GetAnyFullFileName(o_StartLoading, "ADV");
  StopLoadingADVFileName :=GetAnyFullFileName(o_StopLoading,  "ADV");
  CheckADVExists(StartLoadingADVFileName, StopLoadingADVFileName);

  Msg:="஢ " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + " ." +
       "||" + RecipientInfoByMDoc() +
       "||" + PumpInfoAsStr(GetMDocNozzle(1)) +
       "||" + " " + GetMDocListLoadingInf() +
       "|||" + "ࠢ 﫠,   䠩-㢥" +
       "|- ⢨ 裡  ࠢ饩 ணࠬ";
  TRY [TRANSACTION(TRANSACTION_SLAVE), MSG_SUPPRESSION(MSG_SUPPRESSION_NONE)]
   L_StdFrm.CrucialChoice_FileExplicit("MDoc", Msg, L_APtm.g_FuelStock);
  EXCEPT
  END;

  SETEMPTY(newQnt, newSum);
  Blank      :="%##########% %######% .   ";
  PoolIns    :="%<ࠢ>T %I";
  VarList    :="newQnt";
  SumRequired:=0;
  IF intIsCashLoading(MDoc.Contract) THEN
   Blank      :=Blank + "||" + "%##########% %#######% .";
   PoolIns    :=PoolIns + "%< 㬬>T %I";
   VarList    :=VarList + ", newSum";
   SumRequired:=1;
  END;
  Blank:=Blank + "|";
  LOOP
   STDFORM(L_StdFrm.sf_Choice("|" + RecipientInfoByMDoc() +
                              "||" + PumpInfoAsStr(GetMDocNozzle(1)) +
                              "||" + Blank,
                              PoolIns),
           "筮 ଫ १⮢ ࠢ", INFORM, , ^VarList);
   IF    newQnt < 0 THEN
    L_StdFrm.RedInform("४⭮ ⢮ 饭 ⥯த⮢");
   ELSIF SumRequired & (newSum < 0) THEN
    L_StdFrm.RedInform("४⭠ 㬬");
   ELSIF newQnt = 0 THEN
    IF L_StdFrm.RedAlternative("⢨⥫쭮 ࠢ 0 ஢?") THEN
     IF SumRequired & (newSum # 0) THEN
      L_StdFrm.RedInform("ࠢ  0 ஢     㫥 㬬");
     ELSE
      EXIT;
     END;
    ELSE
     SETEMPTY(newQnt);
    END;
   ELSIF intIsCashLoading(MDoc.Contract) & (newSum = 0) THEN
    IF L_StdFrm.RedAlternative("⢨⥫쭮 ࠢ  0 㡫?") THEN
     IF ~!newQnt & (newQnt # 0) THEN
      L_StdFrm.RedInform("ࠢ  0 㡫     㫥 ⢮ ஢");
     ELSE
      EXIT;
     END;
    ELSE
     SETEMPTY(newSum);
    END;
   ELSIF (MDoc.MDocKind = L_MDoc.md_NOV) &
         E_gs_IsFuelStation()            &
         (newQnt > L_Way.GetBakVol(MDoc.BoxNbr, MDoc.Date)) THEN
    L_StdFrm.RedInform("ࠢ       ࠭ᯮ⭮ ।⢠");
   ELSE
    EXIT;
   END;
  END; (* LOOP *)

  CheckADVExists(StartLoadingADVFileName, StopLoadingADVFileName);
  trgCash:=GetMDocCash();
  IF ~!trgCash THEN
   L_StdFrm.Inform(CountChangeMsg(newSum, trgCash));
  ELSE
   L_General.CallUs(!newSum);
  END;

  PassedMDoc(newQnt, newSum, TRANSACTION_SLAVE, 1);

  IF FIO.Exists(StartLoadingPRMFileName) THEN
   FIO.Erase(StartLoadingPRMFileName);
  END;
  IF FIO.Exists(StopLoadingPRMFileName) THEN
   FIO.Erase(StopLoadingPRMFileName);
  END;

  RefreshGasStanWindow();
 END {ManualProceedMDoc};

 PUBLIC PROCEDURE SetIdleMode();
 BEGIN
  L_General.Assert(GasStanMode # gsm_Idle, "ࠢ筠 ⠭ 室  ० ");
  L_StdFrm.Choice("⬥ ଫ ⥪饩 ࠢ");
  SetCurrentOperation(gsm_Idle);
 END {SetIdleMode};

 PUBLIC PROCEDURE Close();
 BEGIN
  IF GasStanMode # gsm_Idle THEN
   L_StdFrm.Question(" 楤 ଫ ࠢ.|" +
                     "ࢠ 楤   ?");
  END;
  SetCurrentOperation(gsm_Idle);
  L_Timer.ResetTimer("GasStan_Stat");
 END {Close};

 PUBLIC PROCEDURE Settings();
  CONST
   im_Pool = "⠭| ନ஢ ࠢ騥 䠩";
  VAR
   i                 : NUMERIC[0];
   Value,
   PRM_Path,
   newPRM_Path,
   tmpValue,
   SingleValue       : STRING[];
   tmpStorage,
   trgStorage        : LIKE(Storage.Storage);
   InteractionMode,
   newInteractionMode: SCAL[2];
 BEGIN
  CheckIsFuelStationStorage();

  trgStorage:=L_Stock.DefaultStorage();
  gs_GetSettings(trgStorage, InteractionMode, PRM_Path);

  newInteractionMode:=InteractionMode;
  newPRM_Path       :=PRM_Path;
  L_Stock.PositionOnStorage(trgStorage);
  LOOP
   STDFORM(L_StdFrm.sf_Choice(" " + Storage.Storage + " " + Storage.Name + "||" +
                              " ᮯ殮  ࠢ饩 ணࠬ       |" +
                              "%################################%                 ||" +
                              "   䠩  ࠢ饩 ணࠬ  |" +
                              "%################################%                 |",
                              "%<" + im_Pool + ">I %I"),
           ,
           ,
           ,
           newInteractionMode, newPRM_Path);
   IF ~FIO.DirExists(newPRM_Path) THEN
    L_StdFrm.RedInform("  ࠭   䠩  ࠢ饩 ணࠬ|" +
                       newPRM_Path + "|" +
                       "㯭   ");
   ELSE
    IF (InteractionMode # newInteractionMode) | (PRM_Path # newPRM_Path) THEN
     IF InteractionMode # newInteractionMode THEN
      L_StdFrm.Choice(" ⠭ ० ᮯ殮 '" + L_Str.PoolItem(im_Pool, newInteractionMode) + "'|" +
                      "ந  㤥 䨪஢  ⥬ ୠ|"+
                      "த?");
     END;
     SETEMPTY(Value);
     IF L_SES.GetValue(L_SES.sit_Station, gs_Settings, tmpValue) THEN
      i:=0;
      LOOP
       SingleValue:=L_Prop.getAIS(tmpValue, i);
       IF !SingleValue THEN
        EXIT;
       END;
       IF trgStorage # STRTOFLD(L_Prop.getRES(SingleValue, 0), SCAL) THEN
        L_Prop.putAIS(Value, SingleValue);
       END;
       INC(i);
      END (* LOOP *);
     END;
 
     SETEMPTY(SingleValue);
     L_Prop.putREV(SingleValue, trgStorage);
     L_Prop.putREV(SingleValue, newInteractionMode);
     L_Prop.putREV(SingleValue, newPRM_Path);
     L_Prop.putAIS(Value, SingleValue);
 
     L_SES.PutValueAtSlaveTrn(L_SES.sit_Station, gs_Settings, Value);
 
     SetGasStanTitle(0);
     SetCurrentOperation(GasStanMode);
 
     IF InteractionMode # newInteractionMode THEN
      TRY [TRANSACTION(TRANSACTION_SLAVE)]
       SysLog.Mark("IM_Mode", L_Str.PoolItem(im_Pool, newInteractionMode));
      EXCEPT
      ON Exc: Exc_Root DO
  
      END; (* TRY *)
     END;
    END;
    EXIT;
   END;
  END; (* LOOP *)
 END {Settings};

 PUBLIC PROCEDURE IsolateWindow();
 BEGIN
  L_General.Error(" '" + RTI.Get().CurWindow.Title + "'    ஢");
 END {IsolateWindow};

 PUBLIC PROCEDURE Msh_03();
  VAR
   trgMath    : LIKE(Math.Math);
   trgBoxNbr  : LIKE(Car.BoxNbr);
   trgXDoc    : L_XDoc.tXDoc;
   trgXDocType: L_XDoc.tXDocType;
 BEGIN
  CheckGasStanMode();
  trgMath:=getFV_Scal(v_Math);
  L_General.Assert(~!trgMath, " 㪠 ");

  trgXDocType:=getFV_Scal(v_XDocType);
  trgXDoc    :=getFV_Scal(v_XDoc);
  SETEMPTY(trgBoxNbr);
  IF ~!trgXDoc THEN
   IF    trgXDocType = L_XDoc.xdt_RWayS THEN
    PosToRWayS(trgXDoc);
    trgBoxNbr:=RWayS.BoxNbr;
   ELSIF trgXDocType = L_XDoc.xdt_RprS THEN
    PosToRprS(trgXDoc);
    L_Rpr.AccessOrigin();
    trgBoxNbr:=Car.BoxNbr;
   END;
  END;
  L_General.Assert(~!trgBoxNbr, " ᪠஢   । ࠦ  ");

  CALL(MS_His.MakeMsh(trgBoxNbr, trgMath,
                      SYSDATE(), L_DatTim.GetSysVARIANTDATE(),
                      2 (*rm_SingleMathByGasStan*),
                      "Msh03", "। 뤠   "));
 END {Msh_03};

BEGIN
 RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
 L_Events.ExecuteHandler();
END.
