(*
%Copyright   (c) Polak Computer System
%Author      02.09.1999 13:36:44 GINA
%Purpose     ⠭   㯯 ⨬
%Type        report
%Specific    AP
%Modified    04.02.2014 17:13:25 POLAK\MLB
%Environment
*)

 IMPORT Memo, L_General, E_Way, L_Way, L_DatTim, L_OwnData, L_AFM;

 CONST
  RepName = "IN006";

 VAR
  _PVLim   : NUMERIC[0];
  _PVLimArr: L_Way.tPVArr;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_cd(), L, "D.N.y"
@
#############################################################################                                    ########## #####
=#####===========================================================================================================================
|                                ⠭  窨  ॢ  ########## (/)                               |
}
*)

(*
$P{ TopPVGrp:
_PVLim, L, ""
@
|===============================================================================================================================|
|                                                     । ⨬ ###                                                   |
}
*)

(*
$P{ TopTK:
TKind.TKind, L, ""
TKind.Name, L, ""
@
|-------------------------------------------------------------------------------------------------------------------------------|
| ॢ ## ########################################                                                                      |
|-------------------------------------------------------------------------------------------------------------------------------|
|                      |砫 |           ⥫            |                      |                  |
|               |--------|-------------------------------|-------------------------------|-------------------------------|
|                      | ६|  㤭|㡡||ࠧ.|  㤭|㡡||ࠧ.|  㤭|㡡||ࠧ.|
}
*)

(*
$P{ LineDel:
@
|----------------------|--------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|
}
*)

(*
$P{ Line:
?, L, ""
?, L, ""
Tmp01._RoutDay, L, ""
Tmp01._RoutTime, L, "H:M"
IncPlan(L_Way.ipc_Driver,    L_DatTim.wd_Mon), R, "2-"
IncPlan(L_Way.ipc_Driver,    L_DatTim.wd_Sat), R, "2-"
IncPlan(L_Way.ipc_Driver,    L_DatTim.wd_Sun), R, "2-"
IncPlan(L_Way.ipc_Driver,    L_DatTim.wd_Hol), R, "2-"
IncPlan(L_Way.ipc_Guard,     L_DatTim.wd_Mon), R, "2-"
IncPlan(L_Way.ipc_Guard,     L_DatTim.wd_Sat), R, "2-"
IncPlan(L_Way.ipc_Guard,     L_DatTim.wd_Sun), R, "2-"
IncPlan(L_Way.ipc_Guard,     L_DatTim.wd_Hol), R, "2-"
IncPlan(L_Way.ipc_TwoGuards, L_DatTim.wd_Mon), R, "2-"
IncPlan(L_Way.ipc_TwoGuards, L_DatTim.wd_Sat), R, "2-"
IncPlan(L_Way.ipc_TwoGuards, L_DatTim.wd_Sun), R, "2-"
IncPlan(L_Way.ipc_TwoGuards, L_DatTim.wd_Hol), R, "2-"
@
|#### #################|## #####|#######|#######|#######|#######|#######|#######|#######|#######|#######|#######|#######|#######|
}
*)

(*
$P{ Bot:
@
|-------------------------------------------------------------------------------------------------------------------------------|
|                                                                                                                               |
|                                                                   ४ ઠ ............................................ |
|                                                                                                                               |
|                                                                    .......................................... |
|                                                                                                                               |
=(c) Polak=======================================================================================================================
}
*)

 PRIVATE PROCEDURE IncPlan(_Cnd: L_Way.tIncPlanCondition;
                           _WD : L_DatTim.tWeekday): LIKE(RouteIPL.Plan[0]);
  VAR
   Result: LIKE(RouteIPL.Plan[0]);
 BEGIN
  IF L_Way.AccessCurRouteIP(Memo.ud_cd(), _Cnd) THEN
   L_Way._AssertIP(SELECT(RouteIPL, Route, RouteIP.Route, RouteIP.Date, RouteIP.RoutCnd) &
                   SRCINSEL(RouteIPL, LE, Tmp01._RoutDay, Tmp01._RoutTime),
                   " " + Route.Route,
                   _Cnd, Memo.ud_cd(), Tmp01._RoutTime);
   Result:=L_Way.IncPlanRouteIP(RouteIPL.RoutCnd, _WD, _PVLimArr, Memo.ud_cd());
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {IncPlan};

 PRIVATE PROCEDURE WorkOnDate(): SCAL[2];
 BEGIN
  SELECT(SEJobs, Route, , Route.Route);
  WHILE OCCURE(SEJobs) DO
   PROMPT(" "+Route.Route+" ஢ઠ ⢨ ३ "+SEJobs.Trip);
   CONFORM(SEJobs, WJMode, StExit);
   IF WJMode.IncSel & L_DatTim.IsActive(Memo.ud_cd(), StExit.FromD, StExit.UpDate) THEN
    RETURN 1;
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
  RETURN 0;
 END {WorkOnDate};

 PRIVATE PROCEDURE OneIpc_Who(_Cnd: L_Way.tIncPlanCondition);
 BEGIN
  IF L_Way.AccessCurRouteIP(Memo.ud_cd(), _Cnd) THEN
   CONFORM(RouteIP, RouteIPL);
   WHILE OCCURE(RouteIPL) DO
    IF ~SELECT(Tmp01, Tmp01, RouteIPL.Route, RouteIPL.RoutDay, RouteIPL.RoutTime) THEN
     Tmp01._Route   :=RouteIPL.Route;
     Tmp01._RoutDay :=RouteIPL.RoutDay;
     Tmp01._RoutTime:=RouteIPL.RoutTime;
     INSERT(Tmp01);
    END;
    NEXT(RouteIPL);
   END; (* WHILE OCCURE(RouteIPL) ... *)
  END;
 END {OneIpc_Who};

 PRIVATE PROCEDURE MakeOne_PV(BySitt: SCAL[2]);
  VAR
   FirstTKR: SCAL[2];
 BEGIN
  MAKEPART(R, TopPVGrp);
  SELECT(TKind, TKind);
  WHILE OCCURE(TKind) DO
   FirstTKR:=1;
   SELECT(RouteLog, TKind, , TKind.TKind);
   WHILE OCCURE(RouteLog) DO
    NARROWSEL(RouteLog, Route);
    SRCINSEL(RouteLog, LE, , Memo.ud_cd());
    IF OCCURE(RouteLog) & (RouteLog.Till > Memo.ud_cd()) THEN
     CONFORM(RouteLog, Route);
     PROMPT(" "+Route.Route);
     IF (BySitt = L_Way.E_CalcPlIncBySittingPV(Memo.ud_cd())) &
        L_DatTim.IsActive(Memo.ud_cd(), Route.Begin, Route.Till) &
        (Route.IncSel > 0) & ~L_Way.CalcIncPlanIsCancelled(Memo.ud_cd()) & WorkOnDate() THEN
      IF FirstTKR THEN
       MAKEPART(R, TopTK);
       FirstTKR:=0;
      END;
      OneIpc_Who(L_Way.ipc_Driver);
      OneIpc_Who(L_Way.ipc_Guard);
      OneIpc_Who(L_Way.ipc_TwoGuards);
      IF SELECT(Tmp01, Tmp01, Route.Route) THEN
       MAKEPART(R, LineDel);
       MAKEPART(R, Line, Route.Route, Route.Name);
       NEXT(Tmp01);
      END;
      WHILE OCCURE(Tmp01) DO
       MAKEPART(R, Line, "", "");
       NEXT(Tmp01);
      END; (* WHILE OCCURE(Tmp01) ... *)
     END; (* IF Route.IncSel... *)
    END; (* IF OCCURE(RouteLog) ... *)
    NEXTINEXTENDEDSEL(RouteLog, Route);
   END;
   NEXT(TKind);
  END; (* WHILE OCCURE(TKind) ... *)
 END {MakeOne_PV};

 PRIVATE PROCEDURE ScanPVGrpArr(BySitt: SCAL[2]);
  VAR
   i       : NUMERIC[0];
   PVGrpArr: NUMERIC[0][20];
 BEGIN
  SETEMPTY(PVGrpArr);
  IF BySitt THEN
   E_Way.PasVolGrpSit(Memo.ud_cd(), PVGrpArr);
  ELSE
   E_Way.PasVolGrp(Memo.ud_cd(), PVGrpArr);
  END;
 
  SETZERO(i, _PVLimArr);
  WHILE ~!PVGrpArr[i] DO
   _PVLim:=PVGrpArr[i];
   _PVLimArr[0]:=_PVLim;
   _PVLimArr[1]:=_PVLim;
   MakeOne_PV(BySitt);
   INC(i);
  END;
 END {ScanPVGrpArr};

BEGIN
 OPENREP(R, L_General.NameConnection(RepName), Create);
 MAKEPART(R, Top);

 L_AFM.MakeIndex("Tmp01", "_Route   : LIKE(RouteIPL.Route);"+
                             "_RoutDay : LIKE(RouteIPL.RoutDay);"+
                             "_RoutTime: LIKE(RouteIPL.RoutTime)");

 ScanPVGrpArr(0);

 IF ~!PROCREF(E_Way.PasVolGrpSit)THEN
  ScanPVGrpArr(1);
 END;

 MAKEPART(R, Bot);
 CLOSEREP(R);
 L_AFM.AF_PurgeTemp("Tmp01");
END.
