(*
%Copyright   (c) Polak IT
%Author      09.09.2004 13:10:04 POLAK\LDA
%Purpose       室 (, )     
%Type        report
%Specific    AP
%Modified    04.02.2014 16:24:56 POLAK\MLB
%Environment
*)

 MODULE Ipl01 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, E_Way, L_Way, L_Str, L_Basis, Memo, FIO, E_Utils, L_EC, L_APWI, L_bp, L_AFM;

 CONST
  PVNbr   = 10;
  wdt_GrpDays = 0;
  wdt_AllDays = 1;

 VAR
  VolGrpName    : STRING[][PVNbr];
  WD_AsStr      : STRING[][MAXOF(L_DatTim.tWeekday)+1];
  IsStExitOnD,
  EqualPlan     : SCAL[2][MAXOF(L_DatTim.tWeekday)+1];
  wTwoGuards,
  DetailRep,
  DetailNeedTrip: SCAL[2];

 PRIVATE PROCEDURE MakeHeader();
 BEGIN
  L_Basis.wb_WrInQM("R", " ॢ");
  L_Basis.wb_WrInQM("R", " ॢ");
  L_Basis.wb_WrInQM("R", " 室");
  L_Basis.wb_WrInQM("R", "祭  室");
  L_Basis.wb_WrInQM("R", " 室");
  L_Basis.wb_WrInQM("R", "室");
  L_Basis.wb_WrInQM("R", "室");
  IF DetailRep THEN
   L_Basis.wb_WrInQM("R", " ३");
   L_Basis.wb_WrInQM("R", "");
   L_Basis.wb_WrInQM("R", "");
  END;
  L_Basis.wb_WrInQM("R", "砫");
  L_Basis.wb_WrInQM("R", "砭");
  L_Basis.wb_WrInQM("R", "饥 ६");
  L_Basis.wb_WrInQM("R", " ६");
  L_Basis.wb_WrInQM("R", "筮 ६");
  L_Basis.wb_WrInQM("R", "६  ");
  L_Basis.wb_WrInQM("R", "஡");
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_WrInQM("R", "⢮ ३ᮢ");
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_WrInQM("R", "㯯 ⨬");
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_WrInQM("R", " ");
  L_Basis.wb_WrInQM("R", "");

  L_Basis.wb_TermLine("R");
 END {MakeHeader};

 PRIVATE PROCEDURE _MakePart(Group   : NUMERIC[0];
                             trgCnd  : L_Way.tIncPlanCondition;
                             WDType  : SCAL[2];
                             WD_AsStr: STRING[];
                             IncPlan : NUMERIC[2];
                             TripNbr : NUMERIC[0]);
 BEGIN
  L_Basis.wb_WrScl("R", TKind.TKind);
  L_Basis.wb_WrStr("R", TKind.Name);
  L_Basis.wb_WrScl("R", ExitClss.ExitClss);
  L_Basis.wb_WrStr("R", ExitClss.Sign);
  L_Basis.wb_WrStr("R", ExitClss.Name);
  L_Basis.wb_WrScl("R", StExit.Exit);
  L_Basis.wb_WrStr("R", StExit.Name);
  IF DetailRep THEN
   L_Basis.wb_WrNum("R", TripNbr, 0);
   IF TripNbr > 0 THEN
    CONFORM(SEJobs, Route);
    L_Basis.wb_WrStr("R", Route.Route);
    L_Basis.wb_WrStr("R", Route.Name);
   ELSE
    L_Basis.wb_WrStr("R", "---");
    L_Basis.wb_WrStr("R", "---");
   END;
  END;
  IF DetailRep & (TripNbr>0) THEN
   L_Basis.wb_WrTim("R", SEJobs.StartT);
   L_Basis.wb_WrTim("R", SEJobs.StopT);
   IF WJMode.WJType # L_Way.WJType_Void THEN
    L_Basis.wb_WrNum("R", SEJobs.StopT-SEJobs.StartT, 3);
   ELSE
    L_Basis.wb_WrNum("R", 0, 3);
   END;
   IF WJMode.WJType = L_Way.WJType_Work THEN
    L_Basis.wb_WrNum("R", SEJobs.StopT-SEJobs.StartT, 3);
    L_Basis.wb_WrNum("R", TIMEINT(SEJobs.StartT, SEJobs.StopT, 22:00, 06:00), 3);
   ELSE
    L_Basis.wb_WrNum("R", 0, 3);
    L_Basis.wb_WrNum("R", 0, 3);
   END;
   IF L_Way.SEJobsWithPlIncome(Memo.ud_cd()) THEN
    L_Basis.wb_WrNum("R", SEJobs.StopT-SEJobs.StartT, 3);
   ELSE
    L_Basis.wb_WrNum("R", 0, 3);
   END;
   CONFORM(SEJobs, RoutMod);
   L_Basis.wb_WrNum("R", RoutMod.Run, 2);
   L_Basis.wb_WrStr("R", L_Str.PoolItem("|1|2", StExit.Change));
   L_Basis.wb_WrNum("R", 1, 0);
  ELSE
   L_Basis.wb_WrTim("R", StExit.BegTime);
   L_Basis.wb_WrTim("R", StExit.StopTim);
   L_Basis.wb_WrNum("R", StExit.TotT, 3);
   L_Basis.wb_WrNum("R", StExit.LineT, 3);
   L_Basis.wb_WrNum("R", StExit.NightT, 3);
   L_Basis.wb_WrNum("R", StExit.PaidT, 3);
   L_Basis.wb_WrNum("R", StExit.Run, 2);
   L_Basis.wb_WrStr("R", L_Str.PoolItem("|1|2", StExit.Change));
   L_Basis.wb_WrNum("R", StExit.TripAm, 0);
  END;
  L_Basis.wb_WrStr("R", L_Str.PoolItem(L_Way.E_IPConditionPool(Memo.ud_cd()), trgCnd));
  L_Basis.wb_WrStr("R", VolGrpName[Group]);
  L_Basis.wb_WrStr("R", L_Str.PoolItem(L_Way.seak_Pool, StExit.ActivKnd));
  L_Basis.wb_WrStr("R", WDType);
  L_Basis.wb_WrStr("R", WD_AsStr);
  L_Basis.wb_WrNum("R", IncPlan, 2);

  L_Basis.wb_TermLine("R");
 END {_MakePart};

 PRIVATE PROCEDURE MakePart(Group   : NUMERIC[0];
                            trgCnd  : L_Way.tIncPlanCondition;
                            WDType  : SCAL[2];
                            WD_AsStr: STRING[];
                            IncPlan : NUMERIC[2]);
 BEGIN
  _MakePart(Group, trgCnd, WDType, WD_AsStr, IncPlan, 0);
 END {MakePart};

 PRIVATE PROCEDURE IsStExitOnDays(WD: L_DatTim.tWeekday): SCAL[2];
 BEGIN
  RETURN (StExit.ActivKnd#L_Way.seak_OnDays) | StExit.OnDays[WD];
 END {IsStExitOnDays};

 PRIVATE PROCEDURE MakePart_SingleWD(Group  : NUMERIC[0];
                                     trgCnd : L_Way.tIncPlanCondition;
                                     WDType : SCAL[2];
                                     WD     : L_DatTim.tWeekday;
                                     IncPlan: NUMERIC[2]);
 BEGIN
  IF IsStExitOnD[WD] THEN
   MakePart(Group, trgCnd, WDType, WD_AsStr[WD], IncPlan);
  END;
 END {MakePart_SingleWD};

 PRIVATE PROCEDURE MakePart_SingleGroup(Group  : NUMERIC[0];
                                        trgCnd : L_Way.tIncPlanCondition;
                                        IncPlan: NUMERIC[2][]);
  VAR
   WD: L_DatTim.tWeekday;
 BEGIN
  IF (IncPlan[L_DatTim.wd_Mon] = IncPlan[L_DatTim.wd_Tue]) &
     (IncPlan[L_DatTim.wd_Mon] = IncPlan[L_DatTim.wd_Wed]) &
     (IncPlan[L_DatTim.wd_Mon] = IncPlan[L_DatTim.wd_Thu]) &
     (IncPlan[L_DatTim.wd_Mon] = IncPlan[L_DatTim.wd_Fri]) &
     (IncPlan[L_DatTim.wd_Mon] = IncPlan[L_DatTim.wd_Sat]) &
     (IncPlan[L_DatTim.wd_Mon] = IncPlan[L_DatTim.wd_Sun]) &
     (IncPlan[L_DatTim.wd_Mon] = IncPlan[L_DatTim.wd_Hol]) THEN
   IF IsStExitOnD[L_DatTim.wd_Mon] THEN
    MakePart(Group, trgCnd, wdt_GrpDays, " ", IncPlan[L_DatTim.wd_Mon]);
   END;
  ELSE
   IF (IncPlan[L_DatTim.wd_Mon] = IncPlan[L_DatTim.wd_Tue]) &
      (IncPlan[L_DatTim.wd_Mon] = IncPlan[L_DatTim.wd_Wed]) &
      (IncPlan[L_DatTim.wd_Mon] = IncPlan[L_DatTim.wd_Thu]) &
      (IncPlan[L_DatTim.wd_Mon] = IncPlan[L_DatTim.wd_Fri]) THEN
    IF IsStExitOnD[L_DatTim.wd_Mon] THEN
     MakePart(Group, trgCnd, wdt_GrpDays, "㤭", IncPlan[L_DatTim.wd_Mon]);
    END;
   ELSE
    WD:=L_DatTim.wd_Mon;
    WHILE WD <= L_DatTim.wd_Fri DO
     MakePart_SingleWD(Group, trgCnd, wdt_GrpDays, WD, IncPlan[WD]);
     INC(WD);
    END;
   END;
   IF (IncPlan[L_DatTim.wd_Sat] = IncPlan[L_DatTim.wd_Sun]) &
      (IncPlan[L_DatTim.wd_Sat] = IncPlan[L_DatTim.wd_Hol]) THEN
    IF IsStExitOnD[L_DatTim.wd_Sat] THEN
     MakePart(Group, trgCnd, wdt_GrpDays, "室", IncPlan[L_DatTim.wd_Sat]);
    END;
   ELSE
    MakePart_SingleWD(Group, trgCnd, wdt_GrpDays, L_DatTim.wd_Sat, IncPlan[L_DatTim.wd_Sat]);
    MakePart_SingleWD(Group, trgCnd, wdt_GrpDays, L_DatTim.wd_Sun, IncPlan[L_DatTim.wd_Sun]);
    MakePart_SingleWD(Group, trgCnd, wdt_GrpDays, L_DatTim.wd_Hol, IncPlan[L_DatTim.wd_Hol]);
   END;
  END;
 END {MakePart_SingleGroup};

 PRIVATE PROCEDURE AccessCurExitIP(trgCnd: L_Way.tIncPlanCondition): SCAL[2];
 BEGIN
  RETURN L_Way.AccessCurExitIP(Memo.ud_cd(),  trgCnd) & (ExitIP.Type  # L_Way.ipt_Canceled);
 END {AccessCurExitIP};

 PRIVATE PROCEDURE AccessCurRouteIP(trgCnd: L_Way.tIncPlanCondition): SCAL[2];
 BEGIN
  RETURN L_Way.AccessCurRouteIP(Memo.ud_cd(), trgCnd) & (RouteIP.Type # L_Way.ript_Canceled);
 END {AccessCurRouteIP};

 PRIVATE PROCEDURE IsNeedCnd(trgCnd: L_Way.tIncPlanCondition): SCAL[2];
  VAR
   Day   : LIKE(SEJobs.Day);
   StartT: LIKE(SEJobs.StartT);
   StopT : LIKE(SEJobs.StopT);
 BEGIN
  L_Way.E_GetTimesForPlInc(Memo.ud_cd(), Day, StartT, StopT, L_APWI.piScope_SEJobs);
  IF L_Way.GetTypeOfCalcIncPlan(trgCnd, Memo.ud_cd(), StartT) = L_Way.tcpi_FromExit THEN
   RETURN (ExitIP.Type  # L_Way.ipt_Canceled);
  ELSE
   RETURN AccessCurRouteIP(trgCnd);
  END;
 END {IsNeedCnd};

 PRIVATE PROCEDURE GetPl(Group  : NUMERIC[0];
                         trgCnd : L_Way.tIncPlanCondition;
                         WD     : L_DatTim.tWeekday;
                         TripNbr: NUMERIC[0]): NUMERIC[2];
  VAR
   PlInc: NUMERIC[2];
 BEGIN
  IF IsNeedCnd(trgCnd) THEN
   PlInc:=L_APWI.intGetPlanIncomeScope(L_APWI.piScope_SEJobs, Memo.ud_cd(), trgCnd, WD);
   IF DetailRep & E_Utils.Ipl01DetailNeedTrip(Memo.ud_cd()) THEN
    _MakePart(Group, trgCnd, wdt_AllDays, WD_AsStr[WD], PlInc, TripNbr);
   END;
  ELSE
   PlInc:=0;
  END;
  RETURN PlInc;
 END {GetPl};

 PRIVATE PROCEDURE ScanExitIPL(trgCnd: L_Way.tIncPlanCondition; WD: L_DatTim.tWeekday);
  VAR
   i: L_DatTim.tWeekday;
 BEGIN
  IF AccessCurExitIP(trgCnd) THEN
   wTwoGuards:=wTwoGuards | (ExitIP.Cnd = L_Way.ipc_TwoGuards);
   SELECT(ExitIPL, Exit, , ExitIP.Exit, ExitIP.Date, ExitIP.Cnd);
   WHILE OCCURE(ExitIPL) DO
    FOR_EACH i DO
     IF (ExitIPL.Plan[i] # ExitIPL.Plan[WD]) | (ExitIPL.ElstcCf[i] # ExitIPL.ElstcCf[WD]) THEN
      EqualPlan[i]:=0;
     END;
    END;
    NEXT(ExitIPL);
   END; (* WHILE OCCURE(ExitIPL) ... *)
  END;
 END {ScanExitIPL};

 PRIVATE PROCEDURE ScanRouteIPL(trgCnd: L_Way.tIncPlanCondition; WD: L_DatTim.tWeekday);
  VAR
   i: L_DatTim.tWeekday;
 BEGIN
  IF AccessCurRouteIP(trgCnd) THEN
   wTwoGuards:=wTwoGuards | (RouteIP.RoutCnd = L_Way.ipc_TwoGuards);
   SELECT(RouteIPL, Route, , RouteIP.Route, RouteIP.Date, RouteIP.RoutCnd);
   WHILE OCCURE(RouteIPL) DO
    FOR_EACH i DO
     IF (RouteIPL.Plan[i] # RouteIPL.Plan[WD]) | (RouteIPL.ElstcCf[i] # RouteIPL.ElstcCf[WD]) THEN
      EqualPlan[i]:=0;
     END;
    END;
    NEXT(RouteIPL);
   END; (* WHILE OCCURE(RouteIPL) ... *)
  END;
 END {ScanRouteIPL};

 PRIVATE PROCEDURE NeedPutCndToRep(trgCnd: L_Way.tIncPlanCondition): SCAL[2];
 BEGIN
  RETURN (trgCnd  = L_Way.ipc_Driver)    |
         (trgCnd  = L_Way.ipc_Guard)     |
         ((trgCnd = L_Way.ipc_TwoGuards)      & wTwoGuards)                       |
         (L_Way.E_VldPsgPlanLev(Memo.ud_cd()) & (trgCnd = E_Way.ipc_TermPlanDrv)) |
         (L_Way.E_VldPsgPlanLev(Memo.ud_cd()) & (trgCnd = E_Way.ipc_TermPlanGrd));
 END {NeedPutCndToRep};

 PRIVATE PROCEDURE FindEqualPlan();
  VAR
   trgCnd  : L_Way.tIncPlanCondition;
   WD      : L_DatTim.tWeekday;
   trgRoute: LIKE(Route.Route);
   i       : L_DatTim.tWeekday;
 BEGIN
  SAVE(StExit);
  FOR_EACH i DO
   EqualPlan[i]:=1;
  END;
  wTwoGuards:=0;
  FOR_EACH WD DO
   IsStExitOnD[WD]:=IsStExitOnDays(WD);
   FOR_EACH trgCnd DO
    IF NeedPutCndToRep(trgCnd) | (trgCnd  = L_Way.ipc_TwoGuards) THEN
     ScanExitIPL(trgCnd, WD);
    END;
   END;
   SETEMPTY(trgRoute);
   CONFORM(StExit, SEJobs);
   WHILE OCCURE(SEJobs) DO
    IF SEJobs.Route # trgRoute THEN
     trgRoute:=SEJobs.Route;
     DetailNeedTrip:=DetailNeedTrip | DetailRep & E_Utils.Ipl01DetailNeedTrip(Memo.ud_cd());
     CONFORM(SEJobs, Route);
     FOR_EACH trgCnd DO
      IF NeedPutCndToRep(trgCnd) | (trgCnd  = L_Way.ipc_TwoGuards )THEN
       ScanRouteIPL(trgCnd, WD);
      END;
     END;
    END;
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs) ... *)
  END; (* FOR_EACH WD ... *)
  RESTORE(StExit);
 END {FindEqualPlan};

 PRIVATE PROCEDURE MakeOneExit(PVArr: NUMERIC[0][]);
  VAR
   trgGroup   : NUMERIC[0];
   AnyWD,
   CurWD      : L_DatTim.tWeekday;
   trgCnd     : L_Way.tIncPlanCondition;
   TripNbr    : NUMERIC[0];
   PlanIsReady: SCAL[2][MAXOF(L_DatTim.tWeekday)+1];
 BEGIN
  L_AFM.MakeMultipleIndex("IncPlByCnd", "Group: NUMERIC[0];" +
                                        "Cnd  : SCAL[16];"   +
                                        "Plan : NUMERIC[2][8]",
                          "Cnd: Group, Cnd");
  SETZERO(DetailNeedTrip, trgGroup);
  FindEqualPlan();
  WHILE (trgGroup <= HIGH(PVArr)) & (PVArr[trgGroup] > 0) DO
   PROMPT("室: " + StExit.Exit + " 㯯: " + VolGrpName[trgGroup]);
   IF L_Way.SetCarForIncPlan(Memo.ud_cd(), PVArr[trgGroup]) THEN
    FOR_EACH trgCnd DO
     IF NeedPutCndToRep(trgCnd) THEN
      SETZERO(PlanIsReady, IncPlByCnd.Plan);
      IncPlByCnd.Group:=trgGroup;
      IncPlByCnd.Cnd  :=trgCnd;
      INSERT(IncPlByCnd);
      FOR_EACH CurWD DO
       IF IsStExitOnD[CurWD] THEN
        IF ~PlanIsReady[CurWD] THEN
         TripNbr:=0;
         SAVE(StExit);
         CONFORM(StExit, SEJobs);
         WHILE OCCURE(SEJobs) DO
          PROMPT("室: " + StExit.Exit + " 㯯: " + VolGrpName[trgGroup] + " : " + WD_AsStr[CurWD] + " : " + SEJobs.Trip);
          CONFORM(SEJobs, Route);
          CONFORM(SEJobs, WJMode);
          CONFORM(Route, TKind);
          IF L_Way.SEJobsWithPlIncome(Memo.ud_cd()) THEN
           INC(TripNbr);
           ADD(IncPlByCnd, Cnd, , trgGroup, trgCnd,
                           IncPlByCnd.Plan[CurWD], GetPl(trgGroup, trgCnd, CurWD, TripNbr));
          END;
          NEXT(SEJobs);
         END; (* WHILE OCCURE(SEJobs) ... *)
         RESTORE(StExit);
         IF ~DetailNeedTrip THEN
          FOR_EACH AnyWD DO
           IF IsStExitOnD[AnyWD] & EqualPlan[AnyWD] THEN
            PlanIsReady[AnyWD]    :=1;
            IncPlByCnd.Plan[AnyWD]:=IncPlByCnd.Plan[CurWD];
            REPLACE(IncPlByCnd);
           END;
          END;
         END; (* IF ~DetailNeedTrip ... *)
        END; (* IF ~PlanIsReady[CurWD]... *)
        IF ~DetailNeedTrip THEN
         MakePart(trgGroup, trgCnd, wdt_AllDays, WD_AsStr[CurWD], IncPlByCnd.Plan[CurWD]);
        END;
       END; (* IF IsStExitOnD(CurWD)... *)
      END; (* FOR_EACH CurWD *)
      MakePart_SingleGroup(trgGroup, trgCnd, IncPlByCnd.Plan);
     END; (* IF (trgCnd = L_Way. ... *)
    END; (* FOR_EACH trgCnd DO ... *)
   END; (* IF L_Way.SetCarForIncPlan... *)
   INC(trgGroup);
  END; (* WHILE (trgGroup <= HIGH(PVArr))...*)
  L_AFM.AF_PurgeTemp("IncPlByCnd");
 END {MakeOneExit};

 PRIVATE PROCEDURE E_GetGroupVolumeName(PVGroupArr: NUMERIC[0][]);
  VAR
   Local  : PROC;
   GrpAmnt: NUMERIC[0];
 BEGIN
  Local:=PROCREF(E_Way.GetGroupVolumeName);
  IF ~!Local THEN
   Local(VolGrpName);
  ELSE
   GrpAmnt:=0;
   WHILE (GrpAmnt <= HIGH(PVGroupArr)) & (PVGroupArr[GrpAmnt] > 0) DO
    INC(GrpAmnt)
   END;
   SETEMPTY(VolGrpName);
   IF    GrpAmnt = 1 THEN
    VolGrpName[0]:=L_Way.PasVolEnum2Sign(L_Way.pve_Big);
   ELSIF GrpAmnt = 2 THEN
    VolGrpName[0]:=L_Way.PasVolEnum2Sign(L_Way.pve_Big);
    VolGrpName[1]:=L_Way.PasVolEnum2Sign(L_Way.pve_VeryBig);
   ELSIF GrpAmnt = 3 THEN
    VolGrpName[0]:=L_Way.PasVolEnum2Sign(L_Way.pve_Middle);
    VolGrpName[1]:=L_Way.PasVolEnum2Sign(L_Way.pve_Big);
    VolGrpName[2]:=L_Way.PasVolEnum2Sign(L_Way.pve_VeryBig);
   ELSIF GrpAmnt = 4 THEN
    VolGrpName[0]:=L_Way.PasVolEnum2Sign(L_Way.pve_Small);
    VolGrpName[1]:=L_Way.PasVolEnum2Sign(L_Way.pve_Middle);
    VolGrpName[2]:=L_Way.PasVolEnum2Sign(L_Way.pve_Big);
    VolGrpName[3]:=L_Way.PasVolEnum2Sign(L_Way.pve_VeryBig);
   ELSE
    GrpAmnt:=0;
    WHILE (GrpAmnt <= HIGH(PVGroupArr)) & (PVGroupArr[GrpAmnt] > 0) DO
     VolGrpName[GrpAmnt]:=L_Str.IntStr(PVGroupArr[GrpAmnt]);
     INC(GrpAmnt)
    END;
   END;
  END;
 END {E_GetGroupVolumeName};

 PRIVATE PROCEDURE E_GetSittingGroupVolumeName(PVGroupArr: NUMERIC[0][]);
  VAR
   Local  : PROC;
   GrpAmnt: NUMERIC[0];
 BEGIN
  Local:=PROCREF(E_Way.GetSittingGroupVolumeName);
  IF ~!Local THEN
   Local(Memo.ud_cd(), VolGrpName);
  ELSE
   SETEMPTY(VolGrpName);
   GrpAmnt:=0;
   WHILE (GrpAmnt <= HIGH(PVGroupArr)) & (PVGroupArr[GrpAmnt] > 0) DO
    VolGrpName[GrpAmnt]:=L_Str.IntStr(PVGroupArr[GrpAmnt])+" ";
    INC(GrpAmnt)
   END;
  END;
 END {E_GetSittingGroupVolumeName};

 PRIVATE PROCEDURE MakeReport();
  VAR
   PVGroupArr: NUMERIC[0][PVNbr];
   CurWD     : L_DatTim.tWeekday;
 BEGIN
  FOR_EACH CurWD DO
   WD_AsStr[CurWD]:=L_DatTim.WeekDayStr(CurWD, 0);
  END;
  SELECT(StExit, Exit);
  WHILE OCCURE(StExit) DO
   PROMPT("室: " + StExit.Exit);
   IF (StExit.PaidT > 0)                     &
      (StExit.Strict = L_Way.ExitStrict_Reg) &
      L_DatTim.IsActive(Memo.ud_cd(), StExit.FromD, StExit.UpDate)  THEN
    CONFORM(StExit, ExitClss);
    CONFORM(StExit, SEJobs);
    CONFORM(SEJobs, Route);
    SETZERO(PVGroupArr);
    IF L_Way.E_CalcPlIncBySittingPV(Memo.ud_cd()) THEN
     E_Way.PasVolGrpSit(Memo.ud_cd(), PVGroupArr);
     E_GetSittingGroupVolumeName(PVGroupArr);
    ELSE
     E_Way.PasVolGrp(Memo.ud_cd(), PVGroupArr);
     E_GetGroupVolumeName(PVGroupArr);
    END;
    MakeOneExit(PVGroupArr);
   END; (* IF (StExit.Strict = L_Way.ExitStrict_Reg) &...*)
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit) ... *)
 END {MakeReport};

 PUBLIC PROCEDURE IPL01();
  CONST
   bpId = "IPL01";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "  室", L_bp.t_Basis, L_General.timeCond_OnDate);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  DetailRep  :=L_EC.ExecE_Func_Scal2(Memo.ud_cd(), PROCREF(E_Utils.Ipl01DetailRep), 0);
  MakeHeader();
  MakeReport();
  FIO.Close(R);
  L_bp.End();
 END {IPL01};

END.
