(*
%Copyright   (c) Polak IT
%Author      12.02.2010 17:11:45 POLAK\LDA
%Purpose      ⥩ ࠢ/த
%Type        report
%Specific    AP
%Modified    09.01.2014 20:03:32 POLAK\Bor
%Environment
*)

 MODULE IR001 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Basis, FIO, Memo, L_Str, L_Car, L_IRec, L_DatTim, P_Firm, L_bp, Str, L_lsStore,
        L_AFM, P_Math, L_Way;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]; trgType: LIKE(IRec.Type); wMF: SCAL[2]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, " ");
  IF trgType = L_IRec.type_Sale THEN
   L_Basis.wb_WrInQM(F, "  ࠢ");
  END;
  L_Basis.wb_WrInQM(F, "室 ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㭪 ਥ 窨");
  L_Basis.wb_WrInQM(F, "㭪 ਥ 窨");
  L_Basis.wb_WrInQM(F, "㭪 ࠢ");
  L_Basis.wb_WrInQM(F, "㭪 ࠢ");
  L_Basis.wb_WrInQM(F, "஭ ॢ稪");
  L_Basis.wb_WrInQM(F, "ॢ稪");
  L_Basis.wb_WrInQM(F, "ॢ稪");
  L_Basis.wb_WrInQM(F, " ⥪饬 ਮ");

  L_Basis.wb_WrInQM(F, "ப ");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " 죮⭮ ");
  L_Basis.wb_WrInQM(F, "⠢ ");
  L_Basis.wb_WrInQM(F, " த");
  L_Basis.wb_WrInQM(F, " ࠢ");
  L_Basis.wb_WrInQM(F, "६ ࠢ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ⭮ ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠢ");
  IF trgType = L_IRec.type_Departure THEN
   L_Basis.wb_WrInQM(F, "ࠦ");
   L_Basis.wb_WrInQM(F, "᭮");
   L_Basis.wb_WrInQM(F, "ઠ");
   L_Basis.wb_WrInQM(F, "ઠ");
  END;
  L_Basis.wb_WrInQM(F, "ᮡ ");
  L_Basis.wb_WrInQM(F, "⢮ ⮢");
  L_Basis.wb_WrInQM(F, "⢮ ᠦ஢");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㬬");
  L_Basis.wb_WrInQM(F, "ᨮ ᡮ");
  L_Basis.wb_WrInQM(F, "  㣨");
  L_Basis.wb_WrInQM(F, "  ஭஢");
  L_Basis.wb_WrInQM(F, "客 ᡮ");
  L_Basis.wb_WrInQM(F, "⮣");
  L_Basis.wb_WrInQM(F, " ()");
  L_Basis.wb_WrInQM(F, "㬬 ()");
  L_Basis.wb_WrInQM(F, "ᨮ ᡮ ()");
  L_Basis.wb_WrInQM(F, "  㣨 ()");
  L_Basis.wb_WrInQM(F, "  ஭஢ ()");
  L_Basis.wb_WrInQM(F, "客 ᡮ ()");
  L_Basis.wb_WrInQM(F, "⮣ ()");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE Conv(_Sum: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF ~!_Sum THEN
   RETURN L_IRec.ConvToRUR(_Sum);
  ELSE
   RETURN 0;
  END;
 END {Conv};

 PRIVATE PROCEDURE Get(Value: FLOAT): FLOAT;
 BEGIN
  IF ~!Value THEN
   RETURN Value;
  ELSE
   RETURN 0;
  END;
 END {Get};

 PRIVATE PROCEDURE intMakePart(F                 : STRING[];
                               trgType           : LIKE(IRec.Type);
                               trgIRec           : LIKE(IRecL.IRec);
                               trgIRecL          : LIKE(IRecL.IRecL);
                               IRecLDate         : DATE;
                               InReportPer,
                               IsReturnTicketSale,
                               wMF, wIRecL       : SCAL[2]);
  VAR
   FileIRecL      : STRING[];
   trgTariff      : LIKE(IRecL.Tariff);
   trgSum         : LIKE(IRecL.Sum);
   trgComisFee    : LIKE(IRecL.ComisFee);
   trgServFee     : LIKE(IRecL.ServFee);
   trgBookFee     : LIKE(IRecL.BookFee);
   trgInsurFee    : LIKE(IRecL.InsurFee);
   trgTotalSum    : LIKE(IRecL.TotalSum);
   Sign,
   trgPsgAmount,
   trgTicketAmount: NUMERIC[0];
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;

  L_Basis.wb_WrScl(F, IRec.IRec);
  IF trgType = L_IRec.type_Sale THEN
   L_Basis.wb_WrScl(F, trgIRec);
  END;
  L_Basis.wb_WrStr(F, IRec.SrcNbr);
  L_Basis.wb_WrDat(F, IRec.Date);
  IF IRec.CURate = 1 THEN
   L_Basis.wb_WrStr(F, "RUR");
  ELSE
   L_Basis.wb_WrStr(F, "KZT");
  END;
  L_Basis.wb_WrNum(F, IRec.CURate, 4);
  IF ~!IRec.Storage THEN
   SEARCH(Storage, Storage, , IRec.Storage);
   L_Basis.wb_WrScl(F, IRec.Storage);
   L_Basis.wb_WrStr(F, Storage.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  SEARCH(Storage, Storage, , IRec.DprtStrg);
  L_Basis.wb_WrScl(F, IRec.DprtStrg);
  L_Basis.wb_WrStr(F, Storage.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", L_IRec.E_IsOutsideTransporter()));
  L_Basis.wb_WrScl(F, Firm.Firm);
  L_Basis.wb_WrStr(F, Firm.Name);

  IF wIRecL THEN
   IF trgType = L_IRec.type_Sale THEN
    FileIRecL:="tmpIRecL";
   ELSE
    FileIRecL:="IRecL";
   END;
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|", InReportPer));
   L_Basis.wb_WrScl(F, trgIRecL);
   IF ~IsReturnTicketSale & (^(FileIRecL).Kind = L_IRec.knd_Sale) &
      ~!^(FileIRecL).Date & (^(FileIRecL).Date # ^(FileIRecL).StartD) THEN
    L_Basis.wb_WrStr(F, "।⥫쭠 த");
   ELSE
    L_Basis.wb_WrStr(F, L_Str.PoolItem(L_IRec.knd_Pool, ^(FileIRecL).Kind));
   END;

   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_IRec.TicketK_Pool, ^(FileIRecL).TicketK));
   IF (^(FileIRecL).TicketK = L_IRec.tk_Privilege) & ~!^(FileIRecL).PrivKind THEN
     L_Basis.wb_WrStr(F, L_Str.PoolItem(L_IRec.E_GetPrivilegeTicketKindPool(^(FileIRecL).Date, 0), ^(FileIRecL).PrivKind));
   ELSE
    L_Basis.wb_WrStr(F, "---");
   END;
   L_Basis.wb_WrStr(F, L_Str.PoolItem(P_Math.satVAT_Pool, ^(FileIRecL).VATClcM));
   L_Basis.wb_WrDat(F, IRecLDate);
   IF ~L_Way.E_IsImaginaryRoute(^(FileIRecL).Date, ^(FileIRecL).Route) THEN
    L_Basis.wb_WrDat(F, ^(FileIRecL).StartD);
    L_Basis.wb_WrTim(F, ^(FileIRecL).StartT);
   ELSE
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
   END;
   IF ^(FileIRecL).Kind = L_IRec.knd_Sale THEN
    L_Basis.wb_WrStr(F, ^(FileIRecL).TckNbr);
    L_Basis.wb_WrStr(F, "---");
   ELSE
    L_Basis.wb_WrStr(F, Str.Item(L_lsStore.Get(^(FileIRecL).PsgDescr), ";", 1, 0, 1));
    L_Basis.wb_WrStr(F, ^(FileIRecL).TckNbr);
   END;
   L_Basis.wb_WrStr(F, ^(FileIRecL).PlaceNbr);
   IF ~!^(FileIRecL).Route THEN
    CONFORM(^(FileIRecL), Route);
    L_Basis.wb_WrStr(F, Route.Route);
    L_Basis.wb_WrStr(F, Route.Name);
   ELSE
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
   END;
 
   IF ~!^(FileIRecL).asTrip THEN
    SEARCH(SEJobs, Trip, , ^(FileIRecL).asTrip);
    L_Basis.wb_WrStr(F, L_Str.PoolItem("|", SEJobs.Dir));
   ELSE
    L_Basis.wb_WrStr(F, "---");
   END;
 
   IF trgType = L_IRec.type_Departure THEN
    IF ~!^(FileIRecL).asRWayS THEN
     SEARCH(RWayS, RWayS, , ^(FileIRecL).asRWayS);
     L_Car.StandOnCarLog(RWayS.BoxNbr, IRec.Date);
     CONFORM(CarLog, Mark);
     L_Basis.wb_WrScl(F, CarLog.BoxNbr);
     L_Basis.wb_WrStr(F, CarLog.StateNbr);
     L_Basis.wb_WrScl(F, Mark.Mark);
     L_Basis.wb_WrStr(F, Mark.Name);
    ELSE
     L_Basis.wb_WrStr(F, "---");
     L_Basis.wb_WrStr(F, "---");
     L_Basis.wb_WrStr(F, "---");
     L_Basis.wb_WrStr(F, "---");
    END;
   END;
 
   IF IsReturnTicketSale THEN
    Sign:=-1;
   ELSE
    Sign:=+1;
   END;

   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_IRec.paymth_Pool, ^(FileIRecL).PayMth));
   SETZERO(trgTicketAmount, trgPsgAmount);
   IF ^(FileIRecL).Kind = L_IRec.knd_Sale THEN
    trgTicketAmount:=^(FileIRecL).TckAmnt * Sign;
    IF ^(FileIRecL).TicketK # L_IRec.tk_Baggage THEN
     trgPsgAmount:=^(FileIRecL).TckAmnt * Sign;
    END;
   END;

   trgTariff  :=Get(^(FileIRecL).Tariff) * Sign;
   trgSum     :=Get(^(FileIRecL).Sum) * Sign;
   trgComisFee:=Get(^(FileIRecL).ComisFee) * Sign;
   trgServFee :=Get(^(FileIRecL).ServFee) * Sign;
   trgBookFee :=Get(^(FileIRecL).BookFee) * Sign;
   trgInsurFee:=Get(^(FileIRecL).InsurFee) * Sign;
   trgTotalSum:=^(FileIRecL).TotalSum * Sign;
   IF L_Way.E_IsImaginaryRoute(^(FileIRecL).Date, ^(FileIRecL).Route) THEN
    SETZERO(trgTicketAmount, trgPsgAmount);
   END;
  ELSE
   SETZERO(trgTariff, trgSum, trgComisFee, trgServFee, trgBookFee, trgInsurFee, trgTotalSum,
           trgTicketAmount, trgPsgAmount,);
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "த  ");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END; (* IF wIRecL *)

  L_Basis.wb_WrNum(F, trgTicketAmount,   0);
  L_Basis.wb_WrNum(F, trgPsgAmount,      0);
  L_Basis.wb_WrNum(F, Conv(trgTariff),   2);
  L_Basis.wb_WrNum(F, Conv(trgSum),      2);
  L_Basis.wb_WrNum(F, Conv(trgComisFee), 2);
  L_Basis.wb_WrNum(F, Conv(trgServFee),  2);
  L_Basis.wb_WrNum(F, Conv(trgBookFee),  2);
  L_Basis.wb_WrNum(F, Conv(trgInsurFee), 2);
  L_Basis.wb_WrNum(F, trgTotalSum,       2);
  L_Basis.wb_WrNum(F, trgTariff,   2);
  L_Basis.wb_WrNum(F, trgSum,      2);
  L_Basis.wb_WrNum(F, trgComisFee, 2);
  L_Basis.wb_WrNum(F, trgServFee,  2);
  L_Basis.wb_WrNum(F, trgBookFee,  2);
  L_Basis.wb_WrNum(F, trgInsurFee, 2);
  L_Basis.wb_WrNum(F, trgTariff + trgSum + trgComisFee + trgServFee + trgBookFee + trgInsurFee, 2);
  L_Basis.wb_TermLine(F);
 END {intMakePart};

 PRIVATE PROCEDURE MakePart(F                 : STRING[];
                            trgType           : LIKE(IRec.Type);
                            trgIRec           : LIKE(IRecL.IRec);
                            trgIRecL          : LIKE(IRecL.IRecL);
                            IRecLDate         : DATE;
                            InReportPer,
                            IsReturnTicketSale,
                            wMF               : SCAL[2]);
 BEGIN
  intMakePart(F,
              trgType,
              trgIRec,
              trgIRecL,
              IRecLDate,
              InReportPer,
              IsReturnTicketSale,
              wMF,
              1);
 END {MakePart};

 PRIVATE PROCEDURE MakeEmptyPart(F      : STRING[];
                                 trgType: LIKE(IRec.Type);
                                 wMF    : SCAL[2]);
 BEGIN
  intMakePart(F,
              trgType,
              EMPTYOF(IRec.IRec),
              EMPTYOF(IRecL.IRecL),
              EMPTYOF(IRecL.Date),
              0,
              0,
              wMF,
              0);
 END {MakeEmptyPart};

 PRIVATE PROCEDURE InsIntoTmp(trgType: LIKE(IRec.Type));
 BEGIN
  IF ~SEARCH(DprtIRec, DprtIRec, IRec.IRec) THEN
   DprtIRec.IRec:=IRec.IRec;
   INSERT(DprtIRec);
  ELSE
   L_General.CallUs(trgType = L_IRec.type_Sale);
  END;
 END {InsIntoTmp};

 PRIVATE PROCEDURE GatherDepartureIRec(trgType: LIKE(IRec.Type); BPer, EPer: DATE);
 BEGIN
  L_AFM.MakeIndex("DprtIRec", "IRec: LIKE(IRec.IRec)");
  SELECT(IRec, TDate, , trgType);
  SRCINSEL(IRec, GE, , BPer);
  WHILE OCCURE(IRec) & (IRec.Date <= EPer) DO
   PROMPT(" " + L_DatTim.DateStr(IRec.Date));
   IF trgType = L_IRec.type_Sale THEN
    SAVE(IRec);
    L_General.CallUs(L_IRec.StandOnSpecificTypeIRec(L_IRec.type_Departure,
                                                    IRec.SrcNbr,
                                                    IRec.DprtStrg,
                                                    IRec.CarrFirm));
    InsIntoTmp(trgType);
    RESTORE(IRec);
   ELSE
    InsIntoTmp(trgType);
   END;
   NEXT(IRec);
  END; (* WHILE OCCURE(IRec) ... *)
 END {GatherDepartureIRec};

 PRIVATE PROCEDURE MakeRep(bpId: STRING[]; trgType: LIKE(IRec.Type));
  VAR
   wMF             : SCAL[2];
   BPer, EPer      : DATE;
   DepartureIRec   : LIKE(IRec.IRec);
   ReturnTicketDate: DATE;
 BEGIN
  BPer:=Memo.ud_fr();
  EPer:=Memo.ud_ut();
  wMF :=P_Firm.E_wMultipleMyFirm(EPer);

  GatherDepartureIRec(trgType, BPer, EPer);

  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R", trgType, wMF);

  SELECT(DprtIRec, DprtIRec);
  WHILE OCCURE(DprtIRec) DO
   SEARCH(IRec, IRec, , DprtIRec.IRec);
   CONFORM(IRec, MyFirm);
   CONFORM(IRec, Firm);
   IF trgType = L_IRec.type_Sale THEN
    DepartureIRec:=IRec.IRec;
    SAVE(IRec);
    L_IRec.extGatherSaleIRecs(IRec.SrcNbr, IRec.DprtStrg, IRec.CarrFirm, DepartureIRec, BPer, EPer, 0);
    SELECT(tmpIRecL, SaleIR);
    WHILE OCCURE(tmpIRecL) DO
     NARROWSEL(tmpIRecL, SaleIR);
     SEARCH(IRec, IRec, , tmpIRecL.SaleIR);
     CONFORM(IRec, MyFirm);
     CONFORM(IRec, Firm);
     WHILE OCCURE(tmpIRecL) DO
      PROMPT("㧪 " + IRec.SrcNbr + " " + L_DatTim.DateStr(IRec.Date) + " " + tmpIRecL.SaleIRL);
      IF L_DatTim.IsActive_Inc(tmpIRecL.Date, BPer, EPer) THEN
       IF tmpIRecL.Kind = L_IRec.knd_Return THEN
        ReturnTicketDate:=tmpIRecL.Date;
        SAVE(tmpIRecL);
        IF SEARCH(tmpIRecL, SaleIR, tmpIRecL.rtSaleIR, tmpIRecL.rtSaleIRL) THEN
         MakePart("R", trgType, DepartureIRec, tmpIRecL.SaleIRL, ReturnTicketDate,
                       L_DatTim.IsActive_Inc(tmpIRecL.StartD, BPer, EPer), 1, wMF);
        ELSE
         L_General.CallUs(L_General.IsOurSite());
        END;
        RESTORE(tmpIRecL);
       END;
       MakePart("R", trgType, DepartureIRec, tmpIRecL.SaleIRL, tmpIRecL.Date,
                     L_DatTim.IsActive_Inc(tmpIRecL.StartD, BPer, EPer), 0, wMF);
      END;
      NEXT(tmpIRecL);
     END;
     NEXTINEXTENDEDSEL(tmpIRecL, SaleIR);
    END; (* WHILE OCCURE(tmpIRecL) ... *)
    RESTORE(IRec);
   ELSE
    CONFORM(IRec, IRecL);
    IF OCCURE(IRecL) THEN
     WHILE OCCURE(IRecL) DO
      PROMPT("㧪 " + IRec.SrcNbr + " " + L_DatTim.DateStr(IRec.Date) + " " + IRecL.IRecL);
      IF ~!IRecL.Sum THEN
       MakePart("R", trgType, EMPTYOF(IRec.IRec), IRecL.IRecL, IRecL.Date,
                     !IRecL.Date | L_DatTim.IsActive_Inc(IRecL.Date, BPer, EPer), 0, wMF);
      END;
      NEXT(IRecL);
     END; (* WHILE OCCURE(IRecL) ... *)
    ELSE
     MakeEmptyPart("R", trgType, wMF);
    END;
   END;
   NEXT(DprtIRec);
  END; (* WHILE OCCURE(DprtIRec) ... *)
  FIO.Close(R);
 END {MakeRep};

 PUBLIC PROCEDURE IR001();
  CONST
   bpId = "IR001";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " ⥩ த", L_bp.t_Basis, L_General.tc_inIntvl);
  MakeRep(bpId, L_IRec.type_Sale);
  L_bp.End();
 END {IR001};

 PUBLIC PROCEDURE IR002();
  CONST
   bpId = "IR002";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " ⥩ ࠢ", L_bp.t_Basis, L_General.tc_inIntvl);
  MakeRep(bpId, L_IRec.type_Departure);
  L_bp.End();
 END {IR002};

END.
