(*
%Copyright   (c) Polak IT
%Author      19.08.2009 14:38:26 POLAK\LDA
%Purpose      த
%Type        control
%Specific    AP
%Modified    12.08.2014 10:08:56 POLAK\LDA
%Environment
*)

 MODULE IRec [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, L_WDO, L_lsStore, L_XDoc, L_Way, L_Str, L_DatTim, L_StdFrm, L_IRec, L_PCS,
        L_TRS, E_Way, Math, Str, L_ExtDB, FIO, L_AFM, L_FIO, P_Firm, Memo, L_Prop, L_Env, DBD, L_DFS,
        P_Math, L_bp, L_PagePr, L_EC, L_Money, L_APtm;

(*
$P{ Prot_Top:
P_Firm.FP_FirmName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
IRec.IRec, L, ""
IRec.Date, L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|             ⮪ ࠡ⪨  #######  ##########             |
|----------------------------------------------------------------------------|
|     |       |⥫                                   |  祭|
}
*)

(*
$P{ Prot_Dlm1:
@
|-------|-----------|---------------------------------------------|----------|
}
*)

(*
$P{ Prot_Dlm2:
@
|----------------------------------------------------------------------------|
}
*)

(*
$P{ Prot_Line:
IRPrT.RWayS, L, ""
IRPrT.Trip, L, ""
RWJPro.RWJPro, L, ""
RWJPro.Name, L, ""
?, R, ""
@
|#######|###########|## ##########################################|##########|
}
*)

(*
$P{ Prot_BotTotals:
?, L, ""
RWJPro.RWJPro, L, ""
RWJPro.Name, L, ""
?, R, ""
@
|###################|## ##########################################|##########|
}
*)

(*
$P{ Prot_Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE UnBind_FromRWayS();
 BEGIN
  SETEMPTY(IRecL.asDay, IRecL.asStartT, IRecL.asRWayS);
  IRecL.Status:=L_IRec.irls_Prepared;
  REPLACE(IRecL);
 END {UnBind_FromRWayS};

 PRIVATE PROCEDURE RWaySMakeUnDone();
 BEGIN
  IF RWayS.Done THEN
   SAVE(IRec);
   SAVE(IRecL);
   SAVE(RWayJ);
   CALL(RWayS, L_Events.md_StreamMakeUnDone);
   RESTORE(RWayJ);
   RESTORE(IRec);
   RESTORE(IRecL);
  END; (* IF RWayS.Done ... *)
 END {RWaySMakeUnDone};

 PRIVATE PROCEDURE _2SheetAssert(Cond: SCAL[2]; Msg: STRING[]);
 BEGIN
  L_General.Assert(Cond,
                   " " + IRec.IRec + "  " + RWayS.RWayS + "||" +
                   Msg);
 END {_2SheetAssert};

 PRIVATE PROCEDURE GetPaidPrc(): NUMERIC[2];
 BEGIN
  IF IRecL.RegMth = L_IRec.rm_MultiTicket_wSum THEN
   RETURN EMPTYOF(NUMERIC[2]);
  ELSE
   IF IRecL.Kind = L_IRec.knd_Sale THEN
    RETURN L_IRec.E_GetPaidPrc();
   ELSE
    IF    IRecL.ReturnK = 0 THEN
     RETURN 85;
    ELSIF IRecL.ReturnK = 2 THEN
     RETURN 75;
    ELSE
     RETURN 100;
    END;
   END;
  END;
 END {GetPaidPrc};

 PRIVATE PROCEDURE E_GetDefaultStorage(): LIKE(Storage.Storage);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.ir_GetDefaultStorage);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN EMPTYOF(Storage.Storage);
  END;
 END {E_GetDefaultStorage};

 PRIVATE PROCEDURE E_GetIRecLComisFee(): NUMERIC[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.ir_GetComisFee);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 0.00;
  END;
 END {E_GetIRecLComisFee};

 PRIVATE PROCEDURE E_GetIRecLInsurFee(): NUMERIC[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.ir_GetInsurFee);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 0.00;
  END;
 END {E_GetIRecLInsurFee};

 PRIVATE PROCEDURE E_GetIRecLServFee(): NUMERIC[2];
  VAR
   Local: PROC;
 BEGIN
  IF IRecL.Kind = L_IRec.knd_Sale THEN
   Local:=PROCREF(E_Way.ir_GetServFee);
   IF ~!Local THEN
    RETURN Local();
   END;
  END;
  RETURN 0.00;
 END {E_GetIRecLServFee};

 PRIVATE PROCEDURE E_GetIRecLBookFee(): NUMERIC[2];
  VAR
   Local: PROC;
 BEGIN
  IF IRecL.Kind = L_IRec.knd_Sale THEN
   Local:=PROCREF(E_Way.ir_GetBookFee);
   IF ~!Local THEN
    RETURN Local();
   END;
  END;
  RETURN 0.00;
 END {E_GetIRecLBookFee};

 PRIVATE PROCEDURE GetIRecLSum(): NUMERIC[2];
 BEGIN
  IF ~!IRecL.Tariff & ~!IRecL.Prc THEN
   L_General.CallUs(IRecL.TckAmnt = 1);
   RETURN IRecL.Tariff * IRecL.Prc / 100;
  ELSE
   RETURN IRecL.Sum;
  END;
 END {GetIRecLSum};

 PRIVATE PROCEDURE GetIRecLComisFeeSum(): NUMERIC[2];
 BEGIN
  RETURN L_IRec.ConvToRUR(IRecL.ComisFee);
 END {GetIRecLComisFeeSum};

 PRIVATE PROCEDURE GetIRecLServFeeSum(): NUMERIC[2];
 BEGIN
  RETURN L_IRec.ConvToRUR(IRecL.ServFee);
 END {GetIRecLServFeeSum};

 PRIVATE PROCEDURE GetIRecLBookFeeSum(): NUMERIC[2];
 BEGIN
  RETURN L_IRec.ConvToRUR(IRecL.BookFee);
 END {GetIRecLBookFeeSum};

 PRIVATE PROCEDURE GetIRecLInsurFeeSum(): NUMERIC[2];
 BEGIN
  RETURN L_IRec.ConvToRUR(IRecL.InsurFee);
 END {GetIRecLInsurFeeSum};

 PRIVATE PROCEDURE GetFullIRecLSum(): NUMERIC[2];
 BEGIN
  IF ~!IRecL.Sum & ~!IRecL.ComisFee & ~!IRecL.ServFee & ~!IRecL.InsurFee & ~!IRecL.BookFee THEN
   IF L_EC.ExecE_Func_Scal2(IRec.Date, PROCREF(E_Way.ir_IsFeesInSum), 0) THEN
    RETURN L_IRec.ConvToRUR(IRecL.Sum);
   ELSE
    RETURN L_IRec.ConvToRUR(IRecL.Sum + IRecL.ComisFee + IRecL.ServFee + IRecL.InsurFee + IRecL.BookFee);
   END;
  ELSE
   RETURN EMPTYOF(NUMERIC[2]);
  END;
 END {GetFullIRecLSum};

 PRIVATE PROCEDURE SetIRecLDone(Dir: NUMERIC[0]);
 BEGIN
  IF Dir = -1 THEN
   IRecL.Status:=L_IRec.irls_Prepared;
  ELSE
   IRecL.Status:=L_IRec.irls_Passed;
  END;
  REPLACE(IRecL);
 END {SetIRecLDone};

 PRIVATE PROCEDURE E_GetRWJPro(VAR Sum_RWJPro: LIKE(RWJPro.RWJPro);
                               VAR Psg_RWJPro: LIKE(RWJPro.RWJPro));
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.ir_GetRWJPro);
  IF !Local THEN
   L_General.SetupRequired();
  END;
  SETEMPTY(Sum_RWJPro, Psg_RWJPro);
  Local(Sum_RWJPro, Psg_RWJPro);
 END {E_GetRWJPro};

 PRIVATE PROCEDURE GetValueAsStr(trgValue: LIKE(RWayJP.Value)): STRING[];
 BEGIN
  IF RWJPro.Format = 0 THEN
   RETURN L_Str.IntStr(trgValue);
  ELSE
   RETURN L_Money.MoneyToStr(IRec.Date, "", trgValue);
  END;
 END {GetValueAsStr};

 PRIVATE PROCEDURE SaveRWayJP(Dir      : NUMERIC[0];
                              trgRWJPro: LIKE(RWJPro.RWJPro);
                              trgValue : LIKE(RWayJP.Value));
 BEGIN
  IF ~!trgRWJPro THEN
   L_Way.SaveRWayJP(Dir, trgRWJPro, trgValue, L_Way.rwjpSrc_IRec);
   IF Dir = 0 THEN
    ADD(IRPrT, RWayS, , RWayS.RWayS, RWayJ.Trip, trgRWJPro,
        IRPrT.Total, trgValue);
   END;
  END;
 END {SaveRWayJP};

 PRIVATE PROCEDURE PutRWayJP(Dir: NUMERIC[0]);
  VAR
   Sum_RWJPro, Psg_RWJPro: LIKE(RWJPro.RWJPro);
 BEGIN
  RWaySMakeUnDone();
  IF ~!IRecL.Sum & ~!IRecL.TckAmnt THEN
   E_GetRWJPro(Sum_RWJPro, Psg_RWJPro);
   SaveRWayJP(Dir, Sum_RWJPro, L_IRec.ConvToRUR(IRecL.Sum));
   SaveRWayJP(Dir, Psg_RWJPro, IRecL.TckAmnt);
  ELSE
   L_General.CallUs(L_IRec.E_GetIRecLInsertMode() = L_IRec.irlim_AutoFill);
  END;
  SetIRecLDone(Dir);
 END {PutRWayJP};

 PRIVATE PROCEDURE IsAllIRecLDone(): SCAL[2];
 BEGIN
  CONFORM(IRec, IRecL);
  WHILE OCCURE(IRecL) DO
   IF IRecL.Status = L_IRec.irls_Prepared THEN
    RETURN 0;
   END;
   NEXT(IRecL);
  END; (* WHILE OCCURE(IRecL) ... *)
  RETURN 1;
 END {IsAllIRecLDone};

 PRIVATE PROCEDURE GetTripListByRouteAndStopAndTime(    trgRoute : LIKE(Route.Route);
                                                        trgStop  : LIKE(Stop.Stop);
                                                        trgStartD: DATE;
                                                        trgStartT: TIME;
                                                        maxDelta : NUMERIC[0];
                                                    VAR Cnt      : NUMERIC[0];
                                                    VAR List     : STRING[]);
 BEGIN
  APP.Get().NewPrompt(" ३ᮢ");
  SAVE(StExit);
  SAVE(SEJobs);
  SAVE(RoutMod);
  SAVE(SEJMStop);
  Cnt:=0;
  List:="";
  SELECT(SEJobs, toRoute, , 0, trgRoute);
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, StExit);
   IF (StExit.Strict = L_Way.ExitStrict_Reg) THEN
    IF L_Way.StExitActiveOnDate(StExit.Exit, trgStartD - (SEJobs.Day - 1)) THEN
     IF (L_Way.FullBegTime(01, trgStartT) >= L_Way.FullBegTime(01, SEJobs.StartT)) &
        (L_Way.FullBegTime(01, trgStartT) < L_Way.FullEndTime(01, SEJobs.StartT, SEJobs.StopT)) THEN
      PROMPT(SEJobs.Trip);
      CONFORM(SEJobs, RoutMod);
      IF SELECT(SEJMStop, Trip, SEJobs.Trip) THEN
       (* 室  ⭮ 浪, ⮡ ஢  ⠭ *)
       IF SEJobs.Dir = RoutMod.Dir THEN
        LAST(SEJMStop);
        PREV(SEJMStop);
       ELSE
        NEXT(SEJMStop);
       END;
       WHILE OCCURE(SEJMStop) DO
        IF SEJMStop.Stop = trgStop THEN
         IF Math.Abs(L_Way.FullEndTime(01, SEJobs.StartT, SEJobs.StartT + SEJMStop.ATim/60) -
                     L_Way.FullBegTime(01, trgStartT)) <= (maxDelta/60)(*(SEJMStop.DTim/60)*) THEN
          INC(List, SEJobs.Trip + " " + SEJobs.Exit + " " + SEJobs.Day + " " + L_DatTim.TimeStr(SEJobs.StartT) + " " + L_DatTim.TimeStr(SEJobs.StartT + SEJMStop.ATim/60) + "|");
          INC(Cnt);
         END; (* IF Math.Abs ... *)
        END; (* IF SEJMStop.Stop ... *)
        IF SEJobs.Dir = RoutMod.Dir THEN
         PREV(SEJMStop);
        ELSE
         NEXT(SEJMStop);
        END;
       END; (* WHILE OCCURE(SEJMStop) *)
      END; (* IF SELECT(SEJMStop ... *)
     END; (* IF L_Way.FullBegTime ... *)
    END; (* IF L_Way.StExitActiveOnDate ... *)
   END; (* IF StExit.Strict ... *)
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
  RESTORE(StExit);
  RESTORE(SEJobs);
  RESTORE(RoutMod);
  RESTORE(SEJMStop);
 END {GetTripListByRouteAndStopAndTime};

 PRIVATE PROCEDURE IRecLIsInRWayJ(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  CONFORM(RWayJ, SEJobs);
  IF (RWayS.Date <= IRecL.StartD) & (RWayS.Status = L_Way.rwsStat_Rated) &
     (!IRecL.asBoxNbr | (IRecL.asBoxNbr = RWayS.BoxNbr)) THEN
   IF (L_Way.FullBegTime(01 + (IRecL.StartD-RWayS.Date), IRecL.StartT) >= L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT)) &
      (L_Way.FullBegTime(01 + (IRecL.StartD-RWayS.Date), IRecL.StartT) < L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT)) THEN
    Result:=1;
   END;
  END;
  RETURN Result;
 END {IRecLIsInRWayJ};

 PRIVATE PROCEDURE TryBindBySingleTrip(trgTrip: LIKE(IRecL.asTrip)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SAVE(RWayJ);
  SAVE(RWayS);
  SELECT(RWayJ, Trip, , trgTrip);
  LOOP
   IF ~OCCURE(RWayJ) THEN
    EXIT;
   END;
   CONFORM(RWayJ, RWayS);
   IF IRecLIsInRWayJ() THEN
    IRecL.asRWayS :=RWayJ.RWayS;
    IRecL.asDay   :=RWayJ.Day;
    IRecL.asStartT:=RWayJ.StartT;
    REPLACE(IRecL);
    Result:=1;
    EXIT;
   END;
   NEXT(RWayJ);
  END; (* LOOP ... *)
  RESTORE(RWayJ);
  RESTORE(RWayS);
  RETURN Result;
 END {TryBindBySingleTrip};

 PRIVATE PROCEDURE TryBindAtProceed(trgTrip: LIKE(IRecL.asTrip));
  VAR
   curDelta : NUMERIC[0];
   Cnt      : NUMERIC[0];
   List     : STRING[];
   Result   : LIKE(SEJobs.Trip);
 BEGIN
  IF !trgTrip THEN
   L_General.Assert(ACCESS(IRecL), " ⠭ ⥪ ப ");
   curDelta:=0;
   REPEAT
    GetTripListByRouteAndStopAndTime(IRecL.Route,
                                     L_IRec.E_Storage2Stop(IRec.Date, IRec.DprtStrg),
                                     IRecL.StartD, IRecL.StartT,
                                     curDelta, Cnt, List);
    INC(curDelta);
   UNTIL (Cnt > 0) | (curDelta > 7);
  ELSE
   Cnt :=1;
   List:=trgTrip;
  END;
  IF    Cnt = 0 THEN
   L_General.Assert(~!IRecL.asBoxNbr, " " + IRecL.IRec + ", ப " + IRecL.IRecL + ":   室饣 ३  ᯨᠭ  .||" +
                                      " ࠦ ");
  ELSIF Cnt > 1 THEN
   L_General.Assert(~!IRecL.asBoxNbr, " " + IRecL.IRec + ", ப " + IRecL.IRecL + ":  ᯨᠭ ᪮쪮 室 ३ᮢ.||" +
                                      " ࠦ ");
  END;
  LOOP
   IF Cnt = 0 THEN
    IF ~!IRecL.asBoxNbr THEN
     IF L_Env.RealBoxNbr(IRecL.asBoxNbr) THEN
      SAVE(RWayS);
      SAVE(RWayJ);
      SAVE(SEJobs);
      SELECT(RWayS, BoxNbr, , IRecL.asBoxNbr);
      SRCINSEL(RWayS, GE, , IRecL.StartD-5(*sic!*));
      WHILE OCCURE(RWayS) & (RWayS.Date <= IRecL.StartD) & !IRecL.asRWayS DO
       CONFORM(RWayS, RWayJ);
       WHILE OCCURE(RWayJ) & !IRecL.asRWayS DO
        IF L_TRS.IsGoodRWayJForIncome() & IRecLIsInRWayJ() THEN
         CONFORM(RWayJ, SEJobs);
         IF IRecL.Route = SEJobs.Route THEN
          IRecL.asRWayS :=RWayS.RWayS;
          IRecL.asDay   :=RWayJ.Day;
          IRecL.asStartT:=RWayJ.StartT;
          REPLACE(IRecL);
         END;
        END; (* IF L_TRS.IsGoodRWayJForIncome() ... *)
        NEXT(RWayJ);
       END; (* WHILE OCCURE(RWayJ) *)
       NEXT(RWayS);
      END; (* WHILE OCCURE(RWayS) *)
      RESTORE(RWayJ);
      RESTORE(RWayS);
      RESTORE(SEJobs);
      L_General.Assert(~!IRecL.asRWayS, " 㦥 室騩  (ࠦ " + IRecL.asBoxNbr + ")");
     END;
    ELSE
     L_General.Error(" 㦥 室騩  (३ " + trgTrip + ")");
    END; (* IF ~!IRecL.asBoxNbr *)
    EXIT;
   END;
   DEC(Cnt);
   trgTrip:=Str.Item(L_Str.PoolItem(List, Cnt), " ", 0);
   IF TryBindBySingleTrip(trgTrip) THEN
    EXIT;
   END;
  END; (* LOOP *)
 END {TryBindAtProceed};

 PUBLIC PROCEDURE Proceed(Dir: NUMERIC[0]; _RWayS: LIKE(RWayS.RWayS));
  VAR
   _asRWayS : LIKE(IRecL.asRWayS);
   _asDay   : LIKE(IRecL.asDay);
   _asStartT: LIKE(IRecL.asStartT);
 BEGIN
  IF L_Way.E_IRecLevel(IRec.Date) > 0 THEN
   APP.Get().NewPrompt(" த ⮢ " + IRec.IRec);
   IF ~L_IRec.E_IsOutsideTransporter() & (IRec.Type = L_IRec.type_Departure) THEN
    IF (Dir = 0) | (Dir = +1) THEN
     SELECT(IRecL, IRRoute, , IRec.IRec);
     WHILE OCCURE(IRecL) DO
      PROMPT("뢠. ப " + IRecL.IRecL);
      IF ~L_Way.E_IsImaginaryRoute(IRecL.Date, IRecL.Route) THEN
       IF !IRecL.asRWayS & !_RWayS THEN
        TryBindAtProceed(IRecL.asTrip);
       END;
      ELSE
       SETEMPTY(IRecL.asRWayS, IRecL.asDay, IRecL.asStartT);
       REPLACE(IRecL);
      END;
      NEXT(IRecL);
     END; (* WHILE OCCURE(IRecL) *)
    END; (* IF Dir = +1...*)
    SELECT(IRecL, IRec, , IRec.IRec);
    WHILE OCCURE(IRecL) DO
     PROMPT("। 窨. ப " + IRecL.IRecL);
     IF    ~!IRecL.asRWayS & (!_RWayS | (IRecL.asRWayS = _RWayS)) THEN
      IF !_RWayS THEN
       L_General.CallUs(SEARCH(RWayS, RWayS, IRecL.asRWayS));
      END;
 
      _2SheetAssert(SEARCH(RWayJ, RWayS, IRecL.asRWayS, IRecL.asDay, IRecL.asStartT),
                    "  ३ ⥢ ");
 
      IF    (Dir = 0) | ((Dir = +1) & (IRecL.Status = L_IRec.irls_Prepared)) THEN
       _2SheetAssert((Dir = -1) | (RWayS.Status = L_Way.rwsStat_Rated), " ⠪஢ ⥢ ");
       IF    L_TRS.IsGoodRWayJForIncome() THEN
        PutRWayJP(Dir);
       END;
      ELSIF (Dir = -1) THEN
       IF IRecL.Status = L_IRec.irls_Passed THEN
        PutRWayJP(Dir);
       END;
       UnBind_FromRWayS();
      END;
     ELSIF ~L_Env.RealBoxNbr(IRecL.asBoxNbr) | L_Way.E_IsImaginaryRoute(IRecL.Date, IRecL.Route) THEN
      SetIRecLDone(Dir);
     END;
     NEXT(IRecL);
    END; (* WHILE OCCURE(IRecL) ... *)
   ELSE
    SELECT(IRecL, IRRoute, , IRec.IRec);
    WHILE OCCURE(IRecL) DO
     SetIRecLDone(Dir);
     NEXT(IRecL);
    END; (* WHILE OCCURE(IRecL) ... *)
   END; (* IF ~L_IRec.E_IsOutsideTransporter() & (IRec.Type = L_IRec.type_Departure)...*)
  END; (* IF L_Way.E_IRecLevel(IRec.Date) > 0...*)

  IRec.Done:=0;
  IF (Dir = +1) & IsAllIRecLDone() THEN
   IRec.Done:=1;
  END;
  REPLACE(IRec);

  L_IRec.ProceedRefSaleIRec(IRec.SrcNbr, IRec.DprtStrg, IRec.CarrFirm, IRec.Done);
 END {Proceed};

 PRIVATE PROCEDURE IRec_1_OnReposition();
  VAR
   trgType: LIKE(IRec.Type);
 BEGIN
  IF ACCESS(IRec) THEN
   trgType:=IRec.Type;
  ELSE
   trgType:=L_IRec.type_Departure;
  END;
  RTI.Get().CurProcess.ReplaceContexts(L_Str.PoolItem("View_DepartureIRecs|View_SaleIRecs", trgType));
 END {IRec_1_OnReposition};

 PRIVATE PROCEDURE IRecE_0_OnReposition();
  VAR
   Fields : FORMFIELDS;
   trgType: LIKE(IRec.Type);
 BEGIN
  IF ACCESS(IRec) THEN
   trgType:=IRec.Type;
  ELSE
   trgType:=L_IRec.type_Departure;
  END;
  RTI.Get().CurWindow.Title:=L_Str.PoolItem(L_IRec.type_Pool, trgType);
  Fields:=RTI.Get().CurZone.Fields;
  SETEMPTY(Fields("StartD").Value, Fields("StartT").Value, Fields("Route").Value,
           Fields("Trip").Value, Fields("BoxNbr").Value);
  IF ACCESS(IRec) THEN
   IF IRec.Single & SELECT(IRecL, IRec, IRec.IRec) THEN
    Fields("StartD").Value:=IRecL.StartD;
    Fields("StartT").Value:=IRecL.StartT;
    Fields("Route").Value :=IRecL.Route;
    Fields("Trip").Value  :=IRecL.asTrip;
    Fields("BoxNbr").Value:=IRecL.asBoxNbr;
   END;
  END;
 END {IRecE_0_OnReposition};

 PRIVATE PROCEDURE SetMainIRecFieldModifiable(Modifiable: SCAL[2]);
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=L_WDO.GetRelatedWindow(RTI.Get().CurWindow, "IRecE").Zones(0).Fields;
  Modifiable:=Modifiable | (~SELECT(IRecL, IRec, IRec.IRec) & ~L_IRec.E_IsOurIncomeReceivedPlace());
  Fields("IRec.Storage").Modifiable :=Modifiable & (IRec.Type = L_IRec.type_Sale);
  Fields("IRec.DprtStrg").Modifiable:=Modifiable;
  Fields("IRec.CarrFirm").Modifiable:=Modifiable;
 END {SetMainIRecFieldModifiable};

 PRIVATE PROCEDURE SetIRecFieldModifiable();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("StartD").Modifiable:=IRec.Single;
  Fields("StartT").Modifiable:=IRec.Single;
  Fields("Route").Modifiable :=IRec.Single;
  Fields("BoxNbr").Modifiable:=IRec.Single;
 END {SetIRecFieldModifiable};

 PRIVATE PROCEDURE IRec_OnBeforeEdIns(_Action: LIKE(XDocJrn.Action));
 BEGIN
  SetMainIRecFieldModifiable(_Action = L_XDoc.action_Insert);
  SetIRecFieldModifiable();
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_IRec, L_XDoc.EmptyXDocKind, IRec.IRec, _Action);
 END {IRec_OnBeforeEdIns};

 PRIVATE PROCEDURE CheckIRecSingle();
  VAR
   Msg      : STRING[];
   trgStartD: DATE;
   trgStartT: TIME;
   trgRoute : LIKE(Route.Route);
   trgBoxNbr: LIKE(IRecL.asBoxNbr);
 BEGIN
  SETEMPTY(Msg);
  IF IRec.Single & SELECT(IRecL, IRec, IRec.IRec) THEN
   trgStartD  :=IRecL.StartD;
   trgStartT  :=IRecL.StartT;
   trgRoute   :=IRecL.Route;
   trgBoxNbr  :=IRecL.asBoxNbr;
   WHILE OCCURE(IRecL) DO
    IF trgStartD # IRecL.StartD THEN
     Msg:=Msg + Str.Align("ப " + IRecL.IRecL + " ᮤন ⫨  ࠢ", 55, LEFT) + "|";
    END;
    IF trgStartT # IRecL.StartT THEN
     Msg:=Msg + Str.Align("ப " + IRecL.IRecL + " ᮤন ⫨饥 ६ ࠢ", 55, LEFT) + "|";
    END;
    IF trgRoute # IRecL.Route THEN
     Msg:=Msg + Str.Align("ப " + IRecL.IRecL + " ᮤন ⫨騩 ", 55, LEFT) + "|";
    END;
    IF trgBoxNbr # IRecL.asBoxNbr THEN
     Msg:=Msg + Str.Align("ப " + IRecL.IRecL + " ᮤন ⫨騩 ࠦ ", 55, LEFT) + "|";
    END;
    NEXT(IRecL);
   END; (* WHILE OCCURE(IRecL) ... *)
  END;
  IF ~!Msg THEN
   L_StdFrm.RedInform("  ⠭ ਧ ' ३',|" +
                      "  ࠧ騥 ப:" + "||" +
                      Msg);
  END;
 END {CheckIRecSingle};

 PRIVATE PROCEDURE IRec_OnBeforeEdit();
 BEGIN
  L_XDoc.xdmb_CheckABan(L_XDoc.xdcls_RWayS, IRec.Date);
  IF IRec.Source = L_IRec.src_System THEN
   IF IRec.Type = L_IRec.type_Sale THEN
    L_General.Error("䨪 ⮬᪨ 㦥  饭");
   ELSE
    L_StdFrm.CrucialChoice("䨪 ⮬᪨ 㦥 ", L_APtm.g_RWOp);
   END;
  END;
  CheckIRecSingle();
  IRec_OnBeforeEdIns(L_XDoc.action_Edit);
  Proceed(-1, "");
 END {IRec_OnBeforeEdit};

 PRIVATE PROCEDURE IRec_OnBeforeInsert();
 BEGIN
  IRec.MyFirm:=P_Firm.DefineMyFirm();
  IRec.Type  :=L_IRec.type_Departure;
  REPLACE(IRec);
  IRec_OnBeforeEdIns(L_XDoc.action_Insert);
 END {IRec_OnBeforeInsert};

 PRIVATE PROCEDURE IRec_OnBeforeDelete();
 BEGIN
  ACCESS(IRec);
  IF IRec.Source = L_IRec.src_System THEN
   L_General.PrgsOnly();
   L_StdFrm.Choice(" 祭 ⭮ - ॡ  ⥩");
  END;
  L_General.Assert(IRec.Done = 0, "    ࠡ⠭");

  SELECT(IRecL, IRec, , IRec.IRec);
  WHILE OCCURE(IRecL) DO
   PROMPT("஢ઠ " + IRec.IRec + ", ப " + IRecL.IRecL);
   L_General.Assert(IRecL.Status = L_IRec.irls_Prepared, "ப     易  ");
   NEXT(IRecL);
  END; (* WHILE OCCURE(IRecL) ... *)

  IF SELECT(XDocJrn, XDocJrn, L_XDoc.xdt_IRec, L_XDoc.EmptyXDocKind, IRec.IRec) THEN
   REMSEL(XDocJrn);
  END;
 END {IRec_OnBeforeDelete};

 PRIVATE PROCEDURE CalcIRecTotals(Dir: NUMERIC[0]);
 BEGIN
  IF (IRec.Type = L_IRec.type_Sale) & (IRecL.Kind = L_IRec.knd_Return) THEN
   Dir:=(-1) * Dir;
  END;
  IF ~!IRecL.TotalSum THEN
   INC(IRec.tSum,    IRecL.TotalSum        * Dir);
  END;
  INC(IRec.tComisS, GetIRecLComisFeeSum() * Dir);
  INC(IRec.tInsurS, GetIRecLInsurFeeSum() * Dir);
  INC(IRec.tServS,  GetIRecLServFeeSum()  * Dir);
  INC(IRec.tBookS,  GetIRecLBookFeeSum()  * Dir);
  REPLACE(IRec);
 END {CalcIRecTotals};

 PRIVATE PROCEDURE CheckAccordanceStorageAndCarrFirm();
 BEGIN
  IF ~!IRec.Storage & ~!IRec.CarrFirm THEN
   IF ~L_IRec.E_IsOurIncomeReceivedPlace() & L_IRec.E_IsOutsideTransporter() THEN
    L_General.Error("  ଫ  த ⮢|" +
                    " ஭ 㭪 ਥ 窨|" +
                    " ஭ ॢ稪.");
   END;
  END;
 END {CheckAccordanceStorageAndCarrFirm};

 PRIVATE PROCEDURE IRec_Storage_OnSuccessfulChange();
 BEGIN
  CheckAccordanceStorageAndCarrFirm();
 END {IRec_Storage_OnSuccessfulChange};

 PRIVATE PROCEDURE IRec_DprtStrg_OnSuccessfulChange();
 BEGIN
  IF (IRec.Type = L_IRec.type_Departure) & (IRec.Source = L_IRec.src_Operator) THEN
   IRec.Storage:=IRec.DprtStrg;
   REPLACE(IRec);
  END;
  CheckAccordanceStorageAndCarrFirm();
 END {IRec_DprtStrg_OnSuccessfulChange};

 PRIVATE PROCEDURE IRec_CarrFirm_OnSuccessfulChange();
 BEGIN
  CheckAccordanceStorageAndCarrFirm();
  SetIRecFieldModifiable();
 END {IRec_CarrFirm_OnSuccessfulChange};

 PRIVATE PROCEDURE IRec_Single_OnSuccessfulChange();
  CONST
   Msg = " ⠭ ਧ '  '|";
  VAR
   _StartD: DATE;
   _StartT: TIME;
   _Route : LIKE(Route.Route);
   _BoxNbr: LIKE(IRecL.asBoxNbr);
   Fields : FORMFIELDS;
 BEGIN
  SETEMPTY(_StartD, _StartT, _Route, _BoxNbr);
  IF IRec.Single THEN
   IF SELECT(IRecL, IRec, IRec.IRec) THEN
    _StartD  :=IRecL.StartD;
    _StartT  :=IRecL.StartT;
    _Route   :=IRecL.Route;
    _BoxNbr  :=IRecL.asBoxNbr;
    WHILE OCCURE(IRecL) DO
     L_General.Assert(_StartD = IRecL.StartD,   Msg + "ப " + IRecL.IRecL + " ᮤন ⫨  ࠢ");
     L_General.Assert(_StartT = IRecL.StartT,   Msg + "ப " + IRecL.IRecL + " ᮤন ⫨饥 ६ ࠢ");
     L_General.Assert(_Route  = IRecL.Route,    Msg + "ப " + IRecL.IRecL + " ᮤন ⫨騩 ");
     L_General.Assert(_BoxNbr = IRecL.asBoxNbr, Msg + "ப " + IRecL.IRecL + " ᮤন ⫨騩 ࠦ ");
     NEXT(IRecL);
    END; (* WHILE OCCURE(IRecL) ... *)
   END;
  END;
  Fields:=RTI.Get().CurZone.Fields;
  SetIRecFieldModifiable();
  Fields("Route").Value :=_Route;
  Fields("StartD").Value:=_StartD;
  Fields("StartT").Value:=_StartT;
  Fields("BoxNbr").Value:=_BoxNbr;
 END {IRec_Single_OnSuccessfulChange};

 PRIVATE PROCEDURE IRec__OnAskPhase1();
  VAR
   FieldName: STRING[];
 BEGIN
  FieldName:=RTI.Get().CurZone.ActiveField.Name;
  IF FieldName = "Route" THEN
   IF ~!RTI.Get().CurZone.Fields(FieldName).Value THEN
    SEARCH(Route, Route, , RTI.Get().CurZone.Fields(FieldName).Value);
    L_WDO.PositionInOwnerZoneOfActiveField("Route");
   END;
  ELSIF FieldName = "BoxNbr" THEN
   IF ~!RTI.Get().CurZone.Fields(FieldName).Value THEN
    SEARCH(Car, BoxNbr, , RTI.Get().CurZone.Fields(FieldName).Value);
    L_WDO.PositionInOwnerZoneOfActiveField("Car");
   END;
  END;
 END {IRec__OnAskPhase1};

 PRIVATE PROCEDURE IRec__OnAskPhase2();
  VAR
   FieldName: STRING[];
 BEGIN
  FieldName:=RTI.Get().CurZone.ActiveField.Name;
  IF    FieldName = "Route" THEN
   RTI.Get().CurZone.Fields(FieldName).Value:=Route.Route;
  ELSIF FieldName = "BoxNbr" THEN
   RTI.Get().CurZone.Fields(FieldName).Value:=Car.BoxNbr;
  END;
 END {IRec__OnAskPhase2};

 PRIVATE PROCEDURE GetIRecSingleAttr(VAR _Route   : LIKE(Route.Route);
                                     VAR _StartD  : DATE;
                                     VAR _StartT  : TIME;
                                     VAR _asTrip  : LIKE(IRecL.asTrip);
                                     VAR _asBoxNbr: LIKE(IRecL.asBoxNbr));
  VAR
   Fields: FORMFIELDS;
 BEGIN
  Fields   :=L_WDO.GetRelatedWindow(RTI.Get().CurWindow, "IRecE").Zones(0).Fields;
  _Route   :=Fields("Route").Value;
  _StartD  :=Fields("StartD").Value;
  _StartT  :=Fields("StartT").Value;
  _asTrip  :=Fields("Trip").Value;
  _asBoxNbr:=Fields("BoxNbr").Value;
 END {GetIRecSingleAttr};

 PRIVATE PROCEDURE ChangeIRecLAttr(Value, prvValue: ANYTYPE; FieldName: STRING[]);
  VAR
   _Route   : LIKE(Route.Route);
   _StartD  : DATE;
   _StartT  : TIME;
   _asTrip  : LIKE(IRecL.asTrip);
   _asBoxNbr: LIKE(IRecL.asBoxNbr);
   curDelta : NUMERIC[0];
   Cnt      : NUMERIC[0];
   List     : STRING[];
 BEGIN
  IF (FieldName = "Route") | (FieldName = "StartD") | (FieldName = "StartT") THEN
   GetIRecSingleAttr(_Route, _StartD, _StartT, _asTrip, _asBoxNbr);
   SETEMPTY(_asTrip);
   IF ~!_Route & ~!_StartD & ~!_StartT THEN
    curDelta:=0;
    REPEAT
     GetTripListByRouteAndStopAndTime(_Route, L_IRec.E_Storage2Stop(IRec.Date, IRec.DprtStrg), _StartD, _StartT,
                                      curDelta, Cnt, List);
     INC(curDelta);
    UNTIL (Cnt > 0) | (curDelta > 7);
    IF Cnt = 1 THEN
     _asTrip:=Str.Item(List, " ", 0);
    ELSE
     IF    Cnt = 0 THEN
      L_StdFrm.Choice("  室饣 ३  ᯨᠭ  ");
     ELSIF Cnt >= 1 THEN
      L_StdFrm.RedInform(" ᯨᠭ  祬  室騩 ३");
     END;
    END;
   END;
  ELSE
   _asTrip:=L_WDO.GetRelatedWindow(RTI.Get().CurWindow, "IRecE").Zones(0).Fields("Trip").Value;
  END;
  RTI.Get().CurZone.Fields("Trip").Value:=_asTrip;
  SELECT(IRecL, IRec, , IRec.IRec);
  WHILE OCCURE(IRecL) DO
   IF    (FieldName = "Route" ) & (IRecL.Route    = prvValue) THEN IRecL.Route:=Value;
   ELSIF (FieldName = "StartD") & (IRecL.StartD   = prvValue) THEN IRecL.StartD:=Value;
   ELSIF (FieldName = "StartT") & (IRecL.StartT   = prvValue) THEN IRecL.StartT:=Value;
   ELSIF (FieldName = "BoxNbr") & (IRecL.asBoxNbr = prvValue) THEN IRecL.asBoxNbr:=Value;
   END;
   IRecL.asTrip:=_asTrip;
   REPLACE(IRecL);
   NEXT(IRecL);
  END; (* WHILE OCCURE(IRecL) ... *)
 END {ChangeIRecLAttr};

 PRIVATE PROCEDURE IRec__OnSuccessfulChange();
  VAR
   FieldName: STRING[];
   _Route   : LIKE(Route.Route);
   _StartD  : DATE;
   _StartT  : TIME;
   _BoxNbr  : LIKE(IRecL.asBoxNbr);
 BEGIN
  FieldName:=RTI.Get().CurZone.ActiveField.Name;
  IF    FieldName = "Route" THEN
   _Route:=RTI.Get().CurZone.Fields(FieldName).Value;
   ChangeIRecLAttr(_Route, GE_PVALUE(), FieldName);
  ELSIF FieldName = "StartD" THEN
   _StartD:=RTI.Get().CurZone.Fields(FieldName).Value;
   ChangeIRecLAttr(_StartD, GE_PVALUE(), FieldName);
  ELSIF FieldName = "StartT" THEN
   _StartT:=RTI.Get().CurZone.Fields(FieldName).Value;
   ChangeIRecLAttr(_StartT, GE_PVALUE(), FieldName);
  ELSIF FieldName = "BoxNbr" THEN
   _BoxNbr:=RTI.Get().CurZone.Fields(FieldName).Value;
   ChangeIRecLAttr(_BoxNbr, GE_PVALUE(), FieldName);
  END;
 END {IRec__OnSuccessfulChange};

 PRIVATE PROCEDURE IRec_CURate_OnSuccessfulChange();
 BEGIN
  SETZERO(IRec.tSum, IRec.tComisS, IRec.tInsurS, IRec.tServS, IRec.tBookS);
  CONFORM(IRec, IRecL);
  WHILE OCCURE(IRecL) DO
   IRecL.TotalSum:=GetFullIRecLSum();
   REPLACE(IRecL);

   CalcIRecTotals(+1);
   NEXT(IRecL);
  END; (* WHILE OCCURE(IRecL) ... *)
  REPLACE(IRec);
 END {IRec_CURate_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckIRecLTimes();
 BEGIN
  IF ~!IRecL.Date & ~!IRecL.StartD THEN
   L_General.Assert(IRecL.Date <= IRecL.StartD, " த     ࠢ:||" +
                    "ࠢ: " + L_DatTim.DateStr(IRecL.StartD) + "|த    : " + L_DatTim.DateStr(IRecL.Date));
   L_General.Assert(IRecL.Date <= IRec.Date, " த     :||" +
                    " : " + L_DatTim.DateStr(IRec.Date) + "|த       : " + L_DatTim.DateStr(IRecL.Date));
   IF IRec.Type = L_IRec.type_Departure THEN
    L_General.Assert(IRecL.StartD <= IRec.Date, " ࠢ     :||" +
                     " : " + L_DatTim.DateStr(IRec.Date) + "|ࠢ   : " + L_DatTim.DateStr(IRecL.StartD));
   END;
  END;
  IF ~!IRecL.Date & ~!IRecL.Time & ~!IRecL.StartD & ~!IRecL.StartT THEN
   L_General.Assert(L_DatTim.GetVARIANTDATE(IRecL.Date, IRecL.Time, 00) <= L_DatTim.GetVARIANTDATE(IRecL.StartD, IRecL.StartT, 00), "\६ த    \६ ࠢ:||" +
                    "ࠢ: " + L_DatTim.DateTimeStr(IRecL.StartD, IRecL.StartT) + "|த    : " + L_DatTim.DateTimeStr(IRec.Date, IRecL.Time));
  END;
 END {CheckIRecLTimes};

 PRIVATE PROCEDURE IRec_OnAfterEdIns();
 BEGIN
  L_XDoc.xdmb_CheckABan(L_XDoc.xdcls_RWayS, IRec.Date);
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_IRec, L_XDoc.EmptyXDocKind, IRec.IRec);
 END {IRec_OnAfterEdIns};

 PRIVATE PROCEDURE IRec_OnAfterEdit();
 BEGIN
  IRec_OnAfterEdIns();
 END {IRec_OnAfterEdit};

 PRIVATE PROCEDURE IRec_OnAfterInsert();
 BEGIN
  IRec_OnAfterEdIns();
 END {IRec_OnAfterInsert};

 PRIVATE PROCEDURE IRec_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="IRec";
  L_WDO.iEvents      (1, L_WDO.e_OnReposition);
  L_WDO.iSubwindow   (1, "IRecE");
  L_WDO.iField       (1, "IRec.IRec").ReverseSorting:=1;
  L_WDO.iField       (1, "IRec.Type").Format:=L_IRec.type_Pool_Short;
 END {IRec_OnInitializeWindow};

 PRIVATE PROCEDURE IRecE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "IRec.SrcNbr").First:=1;
  L_WDO.iScsChange   (0, ["IRec.Storage", "IRec.DprtStrg", "IRec.CarrFirm", "BoxNbr", "Route", "StartT", "StartD", "IRec.Single", "IRec.CURate"]);
  L_WDO.iUnmodifiable(0, ["IRec.tSum", "IRec.tServS", "IRec.tBookS", "IRec.tInsurS", "IRec.tComisS", "Trip", "IRec.IRec"]);
  L_WDO.iMayBeEmpty  (0, ["BoxNbr", "Route", "IRec.Comment"]);
  L_WDO.iSubwindow   (1, "IRecEE");
  L_WDO.iField       (1, "IRecL.TicketK").Format:=L_IRec.TicketK_Pool_Short;
  L_WDO.CreateFormLink("Route", "");
  L_WDO.CreateFormLink("Car", "");
 END {IRecE_OnInitializeWindow};

 PRIVATE PROCEDURE IRecEE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="IRec";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "v_PsgDescr").LineBreakEnable:=1;
  L_WDO.iField       (0, "IRecL.RegMth").First:=1;
  L_WDO.iScsChange   (0, ["v_IRecLPrivKindPool", "IRecL.Prc", "IRecL.Tariff", "IRecL.Sum", "IRecL.ComisFee", "IRecL.Date", "IRecL.TckAmnt", "IRecL.Route", "IRecL.StartT", "IRecL.StartD", "IRecL.Time", "IRecL.ReturnK", "IRecL.Kind", "IRecL.TicketK", "IRecL.RegMth"]);
  L_WDO.iUnmodifiable(0, ["IRecL.KKM", "IRecL.asTrip", "IRecL.TotalSum", "v_IRecLKind"]);
  L_WDO.iMayBeEmpty  (0, ["IRecL.asBoxNbr", "v_PsgDescr"]);
  L_WDO.iField       (0, "IRecL.RegMth").Format:=L_IRec.rm_Pool;
  L_WDO.iField       (0, "IRecL.TicketK").Format:=L_IRec.TicketK_Pool;
  L_WDO.iField       (0, "v_IRecLPrivKindPool").Format:=L_IRec.E_GetPrivilegeTicketKindPool(SYSDATE(), 0);
  L_WDO.iField       (0, "v_IRecLPrivKindPool_Short").Format:=L_IRec.E_GetPrivilegeTicketKindPool(SYSDATE(), 1);
  L_WDO.iField       (0, "IRecL.Kind").Format:=L_IRec.knd_Pool;
  L_WDO.iField       (0, "IRecL.PayMth").Format:=L_IRec.paymth_Pool;
  L_WDO.iField       (0, "IRecL.ReturnK").Format:=L_IRec.rk_Pool;
  L_WDO.iField       (0, "IRecL.VATClcM").Format:=P_Math.satVAT_Pool;
  L_WDO.iProgs       (0, "IRec");
 END {IRecEE_OnInitializeWindow};

 PRIVATE PROCEDURE ModifiableSum(): SCAL[2];
 BEGIN
  RETURN (IRecL.Kind = L_IRec.knd_Return) |
         (IRecL.RegMth = L_IRec.rm_MultiTicket_wSum) |
         ~((IRecL.Prc = 100) | (IRecL.Prc = 0));
 END {ModifiableSum};

 PRIVATE PROCEDURE SetIRecLFiedldModifiable(ForceEnabled: SCAL[2]);
  VAR
   Fields       : FORMFIELDS;
   Modifiable,
   ForceDisabled: SCAL[2];
 BEGIN
  Fields       :=RTI.Get().CurZone.Fields;
  ForceDisabled:=~ForceEnabled                                          &
                 (RTI.Get().CurProcess.Kind # FORM_PROCESS.Kind_Insert) &
                 (L_IRec.E_GetIRecLInsertMode() = L_IRec.irlim_AutoFill);

  Fields("IRecL.Kind").Modifiable               :=~ForceDisabled;
  Fields("IRecL.PayMth").Modifiable             :=IRec.Type = L_IRec.type_Departure;
  Fields("IRecL.RegMth").Modifiable             :=~ForceDisabled;
  Fields("IRecL.TicketK").Modifiable            :=~ForceDisabled;
  Fields("IRecL.TckNbr").Modifiable             :=IRecL.RegMth = L_IRec.rm_SingleTicket;

  Modifiable:=~L_IRec.E_IsOutsideTransporter();
  Fields("IRecL.Date").Modifiable               :=L_IRec.E_IsOurIncomeReceivedPlace() & (IRecL.RegMth = L_IRec.rm_SingleTicket);
  Fields("IRecL.Time").Modifiable               :=L_IRec.E_IsOurIncomeReceivedPlace() & (IRecL.RegMth = L_IRec.rm_SingleTicket);

  Fields("IRecL.StartD").Modifiable             :=(IRec.Single = 0) & (L_IRec.E_GetIRecLInsertMode() # L_IRec.irlim_AutoFill) & ~L_Way.E_IsImaginaryRoute(IRecL.Date, IRecL.Route);
  Fields("IRecL.StartT").Modifiable             :=(IRec.Single = 0) & ~ForceDisabled & ~L_Way.E_IsImaginaryRoute(IRecL.Date, IRecL.Route);
  Fields("IRecL.Route").Modifiable              :=(IRec.Single = 0) & Modifiable & ~ForceDisabled;
  Fields("IRecL.asBoxNbr").Modifiable           :=(IRec.Single = 0) & Modifiable & ~ForceDisabled & ~L_Way.E_IsImaginaryRoute(IRecL.Date, IRecL.Route);

  Fields("IRecL.PlaceNbr").Modifiable           :=IRecL.RegMth = L_IRec.rm_SingleTicket;
  Fields("IRecL.DstStop").Modifiable            :=Modifiable & ~ForceDisabled;
  Fields("IRecL.DstStop").MustBeNonempty        :=IRecL.RegMth = L_IRec.rm_SingleTicket;

  Fields("IRecL.TckAmnt").Modifiable            :=IRecL.RegMth # L_IRec.rm_SingleTicket;
  Fields("v_IRecLPrivKindPool").Modifiable      :=~!L_IRec.E_GetPrivilegeTicketKindPool(SYSDATE(), 0) & (IRecL.TicketK = L_IRec.tk_Privilege);
  Fields("v_IRecLPrivKindPool_Short").Modifiable:=~!L_IRec.E_GetPrivilegeTicketKindPool(SYSDATE(), 0) & (IRecL.TicketK = L_IRec.tk_Privilege);
  Fields("IRecL.VATClcM").Modifiable            := ~ForceDisabled;
  Fields("IRecL.Tariff").Modifiable             :=IRecL.RegMth # L_IRec.rm_MultiTicket_wSum;
  Fields("IRecL.Prc").Modifiable                :=(IRecL.TicketK = L_IRec.tk_Baggage) & (IRecL.RegMth # L_IRec.rm_MultiTicket_wSum);
  Fields("IRecL.Sum").Modifiable                :=ModifiableSum();
  Fields("IRecL.ComisFee").Modifiable           :=IRecL.Kind = L_IRec.knd_Return;
  Fields("IRecL.ServFee").Modifiable            :=0;
  Fields("IRecL.InsurFee").Modifiable           :=0;
  Fields("IRecL.BookFee").Modifiable            :=0;
  Fields("IRecL.ReturnK").Visible               :=IRecL.Kind = L_IRec.knd_Return;
 END {SetIRecLFiedldModifiable};

 PRIVATE PROCEDURE IRecEE_0_OnReposition();
 BEGIN
  CONFORM(IRecL, IRec);
  SetIRecLFiedldModifiable(0);
  RTI.Get().CurZone.Fields("v_PsgDescr").Value:=L_lsStore.Get(IRecL.PsgDescr);
 END {IRecEE_0_OnReposition};

 PUBLIC PROCEDURE ProceedByOneRWayS(Dir: NUMERIC[0]);
 BEGIN
  L_General.Assert(ACCESS(RWayS), " ⠭ ⥪騩 ");
  SAVE(RWayS);
  Proceed(Dir, RWayS.RWayS);
  RESTORE(RWayS);
 END {ProceedByOneRWayS};

 PRIVATE PROCEDURE intSingleMakeDone(Dir: NUMERIC[0]);
 BEGIN
  L_General.Assert(ACCESS(IRec), " ⠭  ࠢ");
  IF IRec.Type = L_IRec.type_Sale THEN
   L_General.Assert(~!IRec.Storage, " 㪠 㭪 ਥ 窨");
  END;
  L_General.Assert(~!IRec.DprtStrg, " 㪠 㭪 ࠢ");
  Proceed(Dir, "");
  IF L_Way.E_IRecLevel(IRec.Date) = 0 THEN
   L_StdFrm.Inform("㭪樮쭮 ' த ⮢' ᯮ  ⮢ ०.|" +
                   "ࠡ⪠ ⥩  ஥.");
  END;
 END {intSingleMakeDone};

 PUBLIC PROCEDURE SingleMakeDone();
 BEGIN
  intSingleMakeDone(+1);
 END {SingleMakeDone};

 PUBLIC PROCEDURE SingleMakeUnDone();
 BEGIN
  L_General.Assert(ACCESS(IRec), " ⠭  ࠢ");
  Proceed(-1, "");
 END {SingleMakeUnDone};

 PUBLIC PROCEDURE MakeProtokol();
  CONST
   RepName = "IRecE";
  VAR
   Text    : STRING[];
   Need    : SCAL[2];
   Total   : LIKE(RWayJP.Value);
   curRWayS: LIKE(RWayS.RWayS);
 BEGIN
  L_General.Assert(ACCESS(IRec), " ⠭  ࠢ");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Prot_Top, RepName);
  L_AFM.MakeMultipleIndex("IRPrT", "RWayS : LIKE(RWayS.RWayS);" +
                                   "Trip  : LIKE(RWayJ.Trip);" +
                                   "RWJPro: LIKE(RWJPro.RWJPro);" +
                                   "Total : LIKE(RWayJP.Value)",
                          "RWayS:RWayS, Trip, RWJPro;TotRWayS:RWayS, RWJPro, Trip;RWJPro:RWJPro, RWayS, Trip");
  intSingleMakeDone(0);


  Need:=1;
  SELECT(IRPrT, RWayS);
  WHILE OCCURE(IRPrT) DO
   IF Need THEN
    MAKEPART(R, Prot_Dlm1);
   ELSE
    Need:=1;
   END;
   NARROWSEL(IRPrT, RWayS);
   curRWayS:=IRPrT.RWayS;
   WHILE OCCURE(IRPrT) DO
    SEARCH(RWJPro, RWJPro, , IRPrT.RWJPro);
    MAKEPART(R, Prot_Line, GetValueAsStr(IRPrT.Total));
    NEXT(IRPrT);
   END; (* WHILE OCCURE(IRPrT) ... *)

   MAKEPART(R, Prot_Dlm2);
   SAVE(IRPrT);
   Text:="⮣   " + curRWayS;
   SELECT(IRPrT, TotRWayS, , curRWayS);
   WHILE OCCURE(IRPrT) DO
    SETZERO(Total);
    NARROWSEL(IRPrT, RWJPro);
    SEARCH(RWJPro, RWJPro, , IRPrT.RWJPro);
    WHILE OCCURE(IRPrT) DO
     INC(Total, IRPrT.Total);
     NEXT(IRPrT);
    END; (* WHILE OCCURE(IRPrT) ... *)
    MAKEPART(R, Prot_BotTotals, Text, GetValueAsStr(Total));
    SETEMPTY(Text);
    NEXTINEXTENDEDSEL(IRPrT, RWJPro);
   END; (* WHILE OCCURE(IRPrT) ... *)
   RESTORE(IRPrT);
   MAKEPART(R, Prot_Dlm2);
   Need:=0;
   NEXTINEXTENDEDSEL(IRPrT, RWayS);
  END; (* WHILE OCCURE(IRPrT) ... *)

  Text:="⮣  ";
  SELECT(IRPrT, RWJPro);
  WHILE OCCURE(IRPrT) DO
   NARROWSEL(IRPrT, RWJPro);
   SETZERO(Total);
   SEARCH(RWJPro, RWJPro, , IRPrT.RWJPro);
   WHILE OCCURE(IRPrT) DO
    INC(Total, IRPrT.Total);
    NEXT(IRPrT);
   END; (* WHILE OCCURE(IRPrT) ... *)
   MAKEPART(R, Prot_BotTotals, Text, GetValueAsStr(Total));
   SETEMPTY(Text);
   NEXTINEXTENDEDSEL(IRPrT, RWJPro);
  END; (* WHILE OCCURE(IRPrT) ... *)

  MAKEPART(R, Prot_Bot);
  CLOSEREP(R);
  L_General.HaltAndSurveyLastReport(EMPTYOF(Exc_Root));
 END {MakeProtokol};

 PRIVATE PROCEDURE IRecL_OnBeforeEdIns();
  VAR
   _Route     : LIKE(Route.Route);
   _StartD    : DATE;
   _StartT    : TIME;
   dummyTrip  : LIKE(IRecL.asTrip);
   dummyBoxNbr: LIKE(IRecL.asBoxNbr);
   Result     : SCAL[2];
 BEGIN
  L_General.Assert(~!IRec.Date, " 㪠  ");
  IF IRec.Type = L_IRec.type_Sale THEN
   L_General.Assert(~!IRec.Storage, " 㪠 㭪 ਥ 窨");
  END;
  L_General.Assert(~!IRec.DprtStrg, " 㪠 㭪 ࠢ");
  IF IRec.Single THEN
   GetIRecSingleAttr(_Route, _StartD, _StartT, dummyTrip, dummyBoxNbr);
   IF !_StartD | !_StartD | (!_Route & ~L_IRec.E_IsOutsideTransporter()) THEN
    L_General.Error("  ਡ ' ३'");
   END;
  END;
 END {IRecL_OnBeforeEdIns};

 PRIVATE PROCEDURE IRecL_SetFlagFirst(OnInsert: SCAL[2]);
  VAR
   Fields    : FORM_FIELDS;
   f_PayMth,
   f_RegMth,
   f_TckAmnt: SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF OnInsert THEN
   f_PayMth :=SalesByTransportCardExist();
   f_RegMth :=~f_PayMth;
   f_TckAmnt:=0;
  ELSE
   f_PayMth :=0;
   f_RegMth :=Fields("IRecL.RegMth").Modifiable;
   f_TckAmnt:=~f_RegMth;
  END;

  Fields("IRecL.PayMth").First :=f_PayMth;
  Fields("IRecL.RegMth").First :=f_RegMth;
  Fields("IRecL.TckAmnt").First:=f_TckAmnt;
 END {IRecL_SetFlagFirst};

 PRIVATE PROCEDURE IRecL_OnBeforeEdit();
 BEGIN
  IRecL_SetFlagFirst(0);
  IRecL_OnBeforeEdIns();
  CalcIRecTotals(-1);
 END {IRecL_OnBeforeEdit};

 PRIVATE PROCEDURE extFillSums(forcePaidPrc: SCAL[2]);
 BEGIN
  IF forcePaidPrc | !IRecL.Prc THEN
   IRecL.Prc     :=GetPaidPrc();
  END;
  IRecL.Sum     :=GetIRecLSum();
  IRecL.ComisFee:=E_GetIRecLComisFee();
  IRecL.ServFee :=E_GetIRecLServFee();
  IRecL.BookFee :=E_GetIRecLBookFee();
  IRecL.InsurFee:=E_GetIRecLInsurFee();
  IRecL.TotalSum:=GetFullIRecLSum();
  REPLACE(IRecL);
 END {extFillSums};

 PRIVATE PROCEDURE FillSums();
 BEGIN
  extFillSums(1);
 END {FillSums};

 PRIVATE PROCEDURE IRecL_OnBeforeInsert();
 BEGIN
  IRecL_SetFlagFirst(1);
  IRecL_OnBeforeEdIns();

  IRecL.Kind   :=L_IRec.knd_Sale;
  IRecL.PayMth :=L_IRec.paymth_Cash;
  IRecL.RegMth :=L_IRec.rm_MultiTicket_wSum;
  IRecL.TicketK:=L_IRec.tk_Full;

  IF    IRec.Single THEN
   GetIRecSingleAttr(IRecL.Route, IRecL.StartD, IRecL.StartT, IRecL.asTrip, IRecL.asBoxNbr);
  ELSIF L_IRec.E_GetIRecLInsertMode() = L_IRec.irlim_AutoFill THEN
   IRecL.StartD:=IRec.Date;
  END;
  REPLACE(IRecL);

  FillSums();
 END {IRecL_OnBeforeInsert};

 PRIVATE PROCEDURE IRecL_OnBeforeDelete();
 BEGIN
  CalcIRecTotals(-1);
 END {IRecL_OnBeforeDelete};

 PRIVATE PROCEDURE IRecL_Kind_OnSuccessfulChange();
 BEGIN
  FillSums();
  SetIRecLFiedldModifiable(0);
 END {IRecL_Kind_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_RegMth_OnSuccessfulChange();
 BEGIN
  SETEMPTY(IRecL.Tariff, IRecL.Prc, IRecL.Sum, IRecL.Date, IRecL.Time);
  IF IRecL.RegMth = L_IRec.rm_SingleTicket THEN
   IRecL.TckAmnt:=1;
  ELSE
   SETEMPTY(IRecL.TckNbr, IRecL.PlaceNbr, IRecL.DstStop);
  END;
  REPLACE(IRecL);

  FillSums();

  SetIRecLFiedldModifiable(0);
 END {IRecL_RegMth_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_ReturnK_OnSuccessfulChange();
 BEGIN
  FillSums();
 END {IRecL_ReturnK_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_TicketK_OnSuccessfulChange();
 BEGIN
  SETEMPTY(IRecL.PrivKind);
  REPLACE(IRecL);

  FillSums();

  SetIRecLFiedldModifiable(0);
 END {IRecL_TicketK_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_PrivKind_OnSuccessfulChange();
 BEGIN
  FillSums();
 END {IRecL_PrivKind_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_TckAmnt_OnSuccessfulChange();
 BEGIN
  extFillSums(0);
 END {IRecL_TckAmnt_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_Date_OnSuccessfulChange();
 BEGIN
  CheckIRecLTimes();
  extFillSums(0);
 END {IRecL_Date_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_Time_OnSuccessfulChange();
 BEGIN
  CheckIRecLTimes();
 END {IRecL_Time_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckAcceptableRoute();
 BEGIN
  IF ~!IRecL.Route & ~!IRecL.StartD THEN
   CONFORM(IRecL, Route);
   IF ~L_DatTim.IsActive(IRecL.StartD, Route.Begin, Route.Till) THEN
    L_General.Error(" " + Route.Route + " '" + Route.Name + "'     ࠢ " + L_DatTim.DateStr(IRecL.StartD));
   END;
   L_Way.PositionOnRouteLog(IRecL.Route, IRecL.StartD);
  END;
 END {CheckAcceptableRoute};

 PRIVATE PROCEDURE IRecL_StartD_OnSuccessfulChange();
 BEGIN
  CheckIRecLTimes();
  CheckAcceptableRoute();
  extFillSums(0);
 END {IRecL_StartD_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_StartT_OnSuccessfulChange();
 BEGIN
  CheckIRecLTimes();
 END {IRecL_StartT_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_Tariff_OnSuccessfulChange();
 BEGIN
  extFillSums(0);
 END {IRecL_Tariff_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_Prc_OnSuccessfulChange();
 BEGIN
  extFillSums(0);
 END {IRecL_Prc_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_Sum_OnSuccessfulChange();
 BEGIN
  IRecL.InsurFee:=E_GetIRecLInsurFee();
  IRecL.TotalSum:=GetFullIRecLSum();
  REPLACE(IRecL);
 END {IRecL_Sum_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_ComisFee_OnSuccessfulChange();
 BEGIN
  IRecL.TotalSum:=GetFullIRecLSum();
  REPLACE(IRecL);
 END {IRecL_ComisFee_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_Route_OnSuccessfulChange();
  VAR
   Fields    : FORM_FIELDS;
   Modifiable: SCAL[2];
 BEGIN
  CheckAcceptableRoute();
  IF L_Way.E_IsImaginaryRoute(IRecL.Date, IRecL.Route) THEN
   SETEMPTY(IRecL.StartD, IRecL.StartT, IRecL.asTrip, IRecL.asBoxNbr, IRecL.asRWayS,
            IRecL.asDay, IRecL.asStartT);
   REPLACE(IRecL);
  END;

  Modifiable:=(L_IRec.E_GetIRecLInsertMode() # L_IRec.irlim_AutoFill) & ~L_Way.E_IsImaginaryRoute(IRecL.Date, IRecL.Route);
  Fields:=RTI.Get().CurZone.Fields;
  Fields("IRecL.StartD").Modifiable  :=Modifiable;
  Fields("IRecL.StartT").Modifiable  :=Modifiable;
  Fields("IRecL.asBoxNbr").Modifiable:=Modifiable;

  FillSums();
 END {IRecL_Route_OnSuccessfulChange};

 PRIVATE PROCEDURE IRecL_OnAfterEdIns();
 BEGIN
  IRecL.PsgDescr:=L_lsStore.Replace(IRecL.PsgDescr, RTI.Get().CurZone.Fields("v_PsgDescr").Value);
  REPLACE(IRecL);
  CalcIRecTotals(+1);

  SetMainIRecFieldModifiable(0);
 END {IRecL_OnAfterEdIns};

 PRIVATE PROCEDURE IRecL_OnAfterEdit();
 BEGIN
  IRecL_OnAfterEdIns();
 END {IRecL_OnAfterEdit};

 PRIVATE PROCEDURE IRecL_OnAfterInsert();
 BEGIN
  IRecL_OnAfterEdIns();
 END {IRecL_OnAfterInsert};

 PUBLIC PROCEDURE IRec_OnSetupRWayS();
 BEGIN
  APP.Get().NewPrompt("뢠  ");
  L_General.Assert(ACCESS(RWayS), " ⠭ ⥪騩 ");
  SAVE(RWayJ);
  SAVE(SEJobs);

  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayJ) DO
   IF L_TRS.IsGoodRWayJForIncome() THEN
    CONFORM(RWayJ, SEJobs);
    IF SELECT(IRecL, asTrip, SEJobs.Trip) & SRCINSEL(IRecL, GE, RWayS.Date + RWayJ.Day - 1, SEJobs.StartT) THEN
     WHILE OCCURE(IRecL) &
      (L_Way.FullBegTime(IRecL.StartD-RWayS.Date+1, IRecL.StartT) < L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT)) DO
      PROMPT(" " + IRecL.IRec + " ப " + IRecL.IRecL);
      IF !IRecL.asBoxNbr | (IRecL.asBoxNbr = RWayS.BoxNbr) THEN
       IF !IRecL.asRWayS THEN
        IRecL.asRWayS :=RWayS.RWayS;
        IRecL.asDay   :=RWayJ.Day;
        IRecL.asStartT:=RWayJ.StartT;
        REPLACE(IRecL);
       ELSE
        L_General.Assert(IRecL.asRWayS = RWayS.RWayS, " " + IRecL.IRec + ": ப " + IRecL.IRecL + " 㦥 易   " + IRecL.asRWayS);
       END;
      END;
      NEXT(IRecL);
     END; (* WHILE OCCURE(IRecL) ... *)
    END; (* IF SELECT(IRecL, asTrip ... *)
    IF SELECT(IRecL, asBoxNbr, RWayS.BoxNbr) & SRCINSEL(IRecL, GE, RWayS.Date) THEN
     WHILE OCCURE(IRecL) & (IRecL.StartD <= (RWayS.Date + RWayJ.Day - 1)) DO
      PROMPT(" " + IRecL.IRec + " ப " + IRecL.IRecL);
      IF Math.Abs(L_Way.FullBegTime(IRecL.StartD-RWayS.Date+1, IRecL.StartT) - L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StartT)) < 0.5 THEN
       IF IRecL.Route = SEJobs.Route THEN
        IF !IRecL.asRWayS THEN
         IRecL.asRWayS :=RWayS.RWayS;
         IRecL.asDay   :=RWayJ.Day;
         IRecL.asStartT:=RWayJ.StartT;
         REPLACE(IRecL);
        ELSE
         L_General.Assert(IRecL.asRWayS = RWayS.RWayS, " " + IRecL.IRec + ": ப " + IRecL.IRecL + " 㦥 易   " + IRecL.asRWayS);
        END;
       END;
      END;
      NEXT(IRecL);
     END; (* WHILE OCCURE(IRecL) ... *)
    END; (* IF SELECT(IRecL, asBoxNbr ... *)
   END; (* IF L_TRS.IsGoodRWayJForIncome ... *)
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) *)
  RESTORE(SEJobs);
  RESTORE(RWayJ);
 END {IRec_OnSetupRWayS};

 PRIVATE PROCEDURE IsAcceptableDBFFile(FullFileName: STRING[]): SCAL[2];
  VAR
   Sign,
   FileName: STRING[];
 BEGIN
  FileName:=L_FIO.effp_FileName_woExt(FullFileName);
  IF Str.Length(FileName) = 18 THEN
   Sign:=Str.Slice(FileName, 16, 2);
   IF (L_Str.IsEqStrI(Sign, "_V") | L_Str.IsEqStrI(Sign, "_K")) THEN
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {IsAcceptableDBFFile};

 PRIVATE PROCEDURE UploadDBF();
  VAR
   Sign         : STRING[];
   Amount       : NUMERIC[0];
   Folder       : FOLDERENTRY;
   FolderName,
   FullFileName : STRING[];
   FolderContent: ENUMERATOR;
 BEGIN
  SETZERO(Amount);
  FolderName:=FIO.FullPath(FIO.BuildPath("IREC", , "TMP"));
  L_General.Assert(FIO.DirExists(FolderName), "  ⠫  ⥩");
  Folder    :=FOLDERENTRY.CreateRedirector(FIO.BuildPath("*", "DBF", FolderName));
  FolderContent:=CreateENUMERATOR(Folder.FolderContent);
  WHILE ~FolderContent.AtEnd() DO
   FullFileName:=FolderContent.Item().Path;
   PROMPT(" 䠩 " + FullFileName);
   IF ~L_DFS.IsDone(FullFileName, L_PCS.deft_IRec) & IsAcceptableDBFFile(FullFileName) THEN
    PROMPT("㧪 䠩 " + FullFileName);
    Sign:=Str.Slice(L_FIO.effp_FileName_woExt(FullFileName), 17, 1);
    IF    L_Str.IsEqStrI(Sign, "V") THEN
     L_ExtDB.intMakeDBFMirror("IRecHead", FullFileName, "", "num",                                                                              L_ExtDB.m_Append);
    ELSIF L_Str.IsEqStrI(Sign, "K") THEN
     L_ExtDB.intMakeDBFMirror("IRecData", FullFileName, "carrfirm:LIKE(Firm.Firm)", "numved,datesel,ppwir,carrfirm;date1,numved,ppwir,carrfirm", L_ExtDB.m_Append);
    ELSE
     L_General.CallUs(0);
    END;
    L_DFS.Do(FullFileName, L_PCS.deft_IRec);
    INC(Amount);
   END;
   FolderContent.MoveNext();
  END; (* WHILE ~FolderContent.AtEnd...*)
  L_General.Assert(Amount # 0, "  䠩  ");
 END {UploadDBF};

 PRIVATE PROCEDURE GetDate(DateAsStr: STRING[]): DATE;
 BEGIN
  RETURN L_Prop.GetDateFromStr(DateAsStr, 1);
 END {GetDate};

 PRIVATE PROCEDURE GetTime(TimeAsStr: STRING[]): TIME;
 BEGIN
  RETURN L_Prop.GetTimeValueFromStr(TimeAsStr, "H:M", 1);
 END {GetTime};

 PRIVATE PROCEDURE IsTicketAlreadyImport(_IRec: LIKE(IRec.IRec); _Kind: LIKE(IRecL.Kind)): SCAL[2];
 BEGIN
  SELECT(IRecL, TckNbr, , _IRec, _Kind, IRecData.ticketnum, IRecData.kkm);
  WHILE OCCURE(IRecL) DO
   IF (IRecL.Date = GetDate(IRecData.datesel)) & (IRecL.Time = GetTime(IRecData.timesel)) THEN
    RETURN 1;
   END;
   NEXT(IRecL);
  END; (* WHILE OCCURE(IRecL) ... *)
  RETURN 0;
 END {IsTicketAlreadyImport};

 PRIVATE PROCEDURE IsEmpty(Value: STRING[]): SCAL[2];
 BEGIN
  RETURN Value = "-";
 END {IsEmpty};

 PRIVATE PROCEDURE GetStorages(    trgType    : LIKE(IRec.Type);
                                   tmpStorage,
                                   tmpDprtStrg: STRING[];
                               VAR trgMyFirm  : LIKE(MyFirm.MyFirm);
                               VAR trgStorage : LIKE(Storage.Storage);
                               VAR trgDprtStrg: LIKE(Storage.Storage);
                                   Strong     : SCAL[2]);

 BEGIN
  IF ~!tmpStorage THEN
   L_General.Assert(~IsEmpty(tmpStorage), " ।  '㭪 ਥ 窨'");
   trgStorage:=STRTOFLD(tmpStorage, SCAL);
   L_General.Assert(SEARCH(Storage, Storage, trgStorage), "   '㭪 ਥ 窨' " + trgStorage);
   trgMyFirm:=Storage.MyFirm;
  ELSE
   SETEMPTY(trgMyFirm);
   L_General.Assert(~Strong, " ।  '㭪 ਥ 窨'");
  END;
  IF trgType = L_IRec.type_Departure THEN
   SETEMPTY(trgStorage);
  END;

  L_General.Assert(~IsEmpty(tmpDprtStrg), " ।  '㭪 ࠢ'");
  trgDprtStrg:=STRTOFLD(tmpDprtStrg, SCAL);
  L_General.Assert(SEARCH(Storage, Storage, trgDprtStrg), "   '㭪 ࠢ' " + trgDprtStrg);

  L_General.Assert(!trgMyFirm | (trgMyFirm = Storage.MyFirm), "  '㭪 ࠢ'  '㭪 ਥ 窨'");
 END {GetStorages};

 PRIVATE PROCEDURE InsertNewIRec(trgType    : LIKE(IRec.Type);
                                 trgSrcNbr  : LIKE(IRec.SrcNbr);
                                 trgDate    : DATE;
                                 tmpStorage,
                                 tmpDprtStrg: STRING[];
                                 trgCarrFirm: LIKE(Firm.Firm);
                                 Strong     : SCAL[2]);
  VAR
   trgMyFirm  : LIKE(MyFirm.MyFirm);
   trgStorage,
   trgDprtStrg: LIKE(Storage.Storage);
 BEGIN
  GetStorages(trgType, tmpStorage, tmpDprtStrg, trgMyFirm, trgStorage, trgDprtStrg, Strong);
  IF ~SELECT(IRec, TSrcNbr, trgType, trgSrcNbr, trgDprtStrg, trgCarrFirm, trgStorage, trgDate) THEN
   SETEMPTY(IRec.IRec);
   IRec.Type    :=trgType;
   IRec.SrcNbr  :=trgSrcNbr;
   IRec.Date    :=trgDate;
   IRec.Single  :=1;
   IRec.Storage :=trgStorage;
   IRec.DprtStrg:=trgDprtStrg;
   IRec.MyFirm  :=trgMyFirm;
   IRec.CarrFirm:=trgCarrFirm;
   SETEMPTY(IRec.Comment);
   IRec.CURate  :=1;
   SETZERO(IRec.tSum, IRec.tComisS, IRec.tInsurS, IRec.tServS, IRec.tBookS);
   IRec.Done    :=0;
   IRec.Source  :=L_IRec.src_System;
   INSERT(IRec);
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_IRec, L_XDoc.EmptyXDocKind, IRec.IRec, L_XDoc.action_AutoBuild);
  ELSE
   IF trgType = L_IRec.type_Departure THEN
    L_General.Assert((IRec.tSum + IRec.tComisS + IRec.tInsurS + IRec.tServS + IRec.tBookS) = 0,
                     "  ନ஢  ࠢ " + IRec.IRec);
    IF IRec.Done THEN
     Proceed(-1, "");
    END;
   ELSE
    L_General.Assert(~IRec.Done, " " + IRec.IRec + "    ࠡ⠭");
   END;
  END;
 END {InsertNewIRec};

 PRIVATE PROCEDURE GetCarrFirm(srcCarrFirm: STRING[]): LIKE(Firm.Firm);
 BEGIN
  L_General.Assert(~IsEmpty(srcCarrFirm), " । ॢ稪");
  IF ~SEARCH(Firm, Firm, srcCarrFirm) THEN
   IF L_General.IsOurSite() THEN
    SEARCH(Firm, Firm, , 0059);
   END;
   L_General.Assert(OCCURE(Firm), "  ॢ稪 " + srcCarrFirm);
  END;
  RETURN Firm.Firm;
 END {GetCarrFirm};

 PRIVATE PROCEDURE GetSingleBoxNbrFromIRecL(trgIRec: LIKE(IRec.IRec)): LIKE(Car.BoxNbr);
  VAR
   trgBoxNbr         : LIKE(Car.BoxNbr);
   HasDifferentBoxNbr: SCAL[2];
 BEGIN
  SAVE(IRecL);
  SETEMPTY(trgBoxNbr);
  HasDifferentBoxNbr:=0;
  SELECT(IRecL, IRec, , trgIRec);
  WHILE OCCURE(IRecL) & ~HasDifferentBoxNbr DO
   IF    !trgBoxNbr  THEN
    trgBoxNbr:=IRecL.asBoxNbr;
   END;
   HasDifferentBoxNbr:=trgBoxNbr # IRecL.asBoxNbr;
   NEXT(IRecL);
  END; (* WHILE OCCURE(IRecL) ... *)
  RESTORE(IRecL);
  IF HasDifferentBoxNbr THEN
   SETEMPTY(trgBoxNbr);
  END;

  RETURN trgBoxNbr;
 END {GetSingleBoxNbrFromIRecL};

 PRIVATE PROCEDURE ClearIRec(trgSrcNbr  : LIKE(IRec.SrcNbr);
                             trgType    : LIKE(IRec.Type);
                             trgDate    : DATE;
                             tmpStorage,
                             tmpDprtStrg: STRING[];
                             trgCarrFirm: LIKE(Firm.Firm);
                             Strong     : SCAL[2]);
  VAR
   Dummy      : LIKE(MyFirm.MyFirm);
   trgStorage,
   trgDprtStrg: LIKE(Storage.Storage);
 BEGIN
  GetStorages(trgType, tmpStorage, tmpDprtStrg, Dummy, trgStorage, trgDprtStrg, Strong);
  IF SEARCH(IRec, TSrcNbr, trgType, trgSrcNbr, trgDprtStrg, trgCarrFirm, trgStorage, trgDate) THEN
   IF trgType = L_IRec.type_Departure THEN
    Proceed(-1, "");
   END;
   IF SELECT(IRecL, IRec, IRec.IRec) THEN
    IF trgType = L_IRec.type_Departure THEN
     clrIRec.IRec  :=IRec.IRec;
     clrIRec.BoxNbr:=GetSingleBoxNbrFromIRecL(IRec.IRec);
     INSERT(clrIRec);
    END;
    REMSEL(IRecL);

    SETZERO(IRec.tSum, IRec.tComisS, IRec.tInsurS, IRec.tServS, IRec.tBookS);
    REPLACE(IRec);

    L_XDoc.XDocJrn_Mark(L_XDoc.xdt_IRec, L_XDoc.EmptyXDocKind, IRec.IRec, L_XDoc.action_AutoEdit);
   END;
  END;
 END {ClearIRec};

 PRIVATE PROCEDURE GetDprtStrg(numved: STRING[]): LIKE(Storage.Storage);
  VAR
   Result: LIKE(Storage.Storage);
 BEGIN
  IF ~!TABLE.Get("IRecHead").Fields("mxotp") THEN
   L_General.Assert(~IsEmpty(IRecHead.mxotp), " ।  '㭪 ࠢ'");
   Result:=STRTOFLD(IRecHead.mxotp, SCAL);
   L_General.Assert(~!Result, " ।  '㭪 ࠢ'");
   L_General.Assert(SEARCH(Storage, Storage, Result), "   '㭪 ࠢ' " + Result);
  ELSE
   Result:=E_GetDefaultStorage();
  END;
  RETURN Result;
 END {GetDprtStrg};

 PRIVATE PROCEDURE PrepareIRecForReImport();
 BEGIN
  L_AFM.MakeIndex("clrIRec", "IRec:LIKE(IRec.IRec); BoxNbr: LIKE(Car.BoxNbr)");
  IF DBD.FileExist(IRecData) THEN
   SELECT(IRecData, numved);
   WHILE OCCURE(IRecData) DO
    NARROWSEL(IRecData, numved, datesel, ppwir, carrfirm);
    PROMPT(" ⥩ த " + IRecData.numved + " (" + IRecData.DBFFile + ")");
    ClearIRec(IRecData.numved, L_IRec.type_Sale, GetDate(IRecData.datesel), IRecData.ppwir, IRecData.mxotp, GetCarrFirm(IRecData.carrfirm), 1);
    NEXTINEXTENDEDSEL(IRecData, numved, datesel, ppwir, carrfirm);
   END; (* WHILE OCCURE(IRecData) ... *)
 
   SELECT(IRecData, date1);
   WHILE OCCURE(IRecData) DO
    NARROWSEL(IRecData, date1, numved, ppwir, carrfirm);
    PROMPT("  ⥩ ࠢ " + IRecData.numved + " (" + IRecData.DBFFile + ")");
    ClearIRec(IRecData.numved, L_IRec.type_Departure, GetDate(IRecData.date1), IRecData.ppwir, IRecData.mxotp, GetCarrFirm(IRecData.carrfirm), 1);
    NEXTINEXTENDEDSEL(IRecData, date1, numved, ppwir, carrfirm);
   END; (* WHILE OCCURE(IRecData) ... *)
  END;

  IF DBD.FileExist(IRecHead) THEN
   SELECT(IRecHead, num);
   WHILE OCCURE(IRecHead) DO
    PROMPT(" ⥩ ࠢ " + IRecHead.num + " (" + IRecHead.DBFFile + ")");
    ClearIRec(IRecHead.num, L_IRec.type_Departure, GetDate(IRecHead.date1), EMPTYOF(Storage.Storage), GetDprtStrg(IRecHead.num), GetCarrFirm(IRecHead.carrfirm), 0);
    NEXT(IRecHead);
   END; (* WHILE OCCURE(IRecHead) ... *)
  END;
 END {PrepareIRecForReImport};

 PRIVATE PROCEDURE ImportIRec();
  CONST
   o_Sale          = 2;
   o_CancelETicket = 3;
   o_Return        = 5;
   o_Cancel        = 8;
  VAR
   trgKind                : LIKE(IRecL.Kind);
   trgBoxNbr              : LIKE(Car.BoxNbr);
   newIRec                : LIKE(IRec.IRec);
   trgCarrFirm            : LIKE(Firm.Firm);
   trgDprtStrg            : LIKE(Storage.Storage);
   Msg,
   PrivilegeTicketKindPool: STRING[];
 BEGIN
  UploadDBF();

  PrepareIRecForReImport();

  IF DBD.FileExist(IRecData) & SELECT(IRecData, numved) THEN
   WHILE OCCURE(IRecData) DO
    NARROWSEL(IRecData, numved);
    WHILE OCCURE(IRecData) DO
     NARROWSEL(IRecData, datesel, ppwir);
     SETEMPTY(newIRec);
     PROMPT("㧪: " + IRecData.numved + "  " + IRecData.datesel + ",  " + IRecData.ticketnum + " (" + IRecData.DBFFile + ")");
     WHILE OCCURE(IRecData) DO
      IF IRecData.bad = "F" THEN
       trgCarrFirm:=GetCarrFirm(IRecData.carrfirm);
       IF !newIRec THEN
        InsertNewIRec(L_IRec.type_Sale,      IRecData.numved, GetDate(IRecData.datesel), IRecData.ppwir, IRecData.mxotp, trgCarrFirm, 1);
        newIRec:=IRec.IRec;
       END;
       InsertNewIRec(L_IRec.type_Departure, IRecData.numved, GetDate(IRecData.date1),    IRecData.ppwir, IRecData.mxotp, trgCarrFirm, 1);

       IF    STRTOFLD(IRecData.oper, NUMERIC) = o_Sale THEN
        trgKind:=L_IRec.knd_Sale;
       ELSIF STRTOFLD(IRecData.oper, NUMERIC) = o_Return THEN
        trgKind    :=L_IRec.knd_Return;
       ELSE
        L_General.Error("  樨 " + IRecData.oper);
       END;

       IF ~IsTicketAlreadyImport(newIRec, trgKind) THEN
        IRecL.IRec    :=newIRec;
        SETEMPTY(IRecL.IRecL);
        IRecL.Date    :=GetDate(IRecData.datesel);
        IRecL.Time    :=GetTime(IRecData.timesel);
        IRecL.RegMth  :=L_IRec.rm_SingleTicket;
        IF STRTOFLD(IRecData.ppwir, SCAL) = 0000456 THEN
         IRecL.PayMth  :=L_IRec.paymth_BankCard;
        ELSE
         IRecL.PayMth  :=L_IRec.paymth_Cash;
        END;
        SETEMPTY(IRecL.PrivKind);
        IF    L_Str.IsEqStrI(IRecData.nameticket, " ") THEN
         IRecL.TicketK :=L_IRec.tk_Full;
        ELSIF L_Str.IsEqStrI(IRecData.nameticket, "  5  12 ") THEN
         IRecL.TicketK :=L_IRec.tk_Child;
        ELSIF Str.Match(Str.Cap(IRecData.nameticket), "*") THEN
         IRecL.TicketK :=L_IRec.tk_Baggage;
        ELSE
         IRecL.TicketK :=L_IRec.tk_Privilege;
         PrivilegeTicketKindPool:=L_IRec.E_GetPrivilegeTicketKindPool(IRec.Date, 0);
         IF ~!PrivilegeTicketKindPool THEN
          IRecL.PrivKind:=L_Str.PositionInPool(Str.Cap(PrivilegeTicketKindPool), Str.Cap(IRecData.nameticket));
          L_General.Assert(~!IRecL.PrivKind, "  죮⭮  '" + IRecData.nameticket + "'");
         ELSE
          SETEMPTY(IRecL.PrivKind);
         END;
        END;
        IRecL.TckNbr  :=IRecData.ticketnum;
        IRecL.KKM     :=IRecData.kkm;
        SETEMPTY(IRecL.PsgDescr, IRecL.Kind);
        IRecL.TckAmnt :=1;
        IF    L_IRec.E_IsOutsideTransporter() | IsEmpty(IRecData.code) THEN
         SETEMPTY(IRecL.Route);
        ELSIF SEARCH(Route, Route, IRecData.code) THEN
         IRecL.Route:=Route.Route;
        ELSE
         L_General.Error("   " + IRecData.code);
        END;
        IF ~L_Way.E_IsImaginaryRoute(IRecL.Date, IRecL.Route) THEN
         IRecL.StartD  :=GetDate(IRecData.date1);
         IRecL.StartT  :=GetTime(IRecData.time1);
        ELSE
         SETEMPTY(IRecL.StartD, IRecL.StartT);
        END;

        IF IRecL.TicketK = L_IRec.tk_Baggage THEN
         L_General.Assert(IsEmpty(IRecData.place), "४   '" + IRecData.place + "', 䠩 " + IRecData.DBFFile + ".dbf,  N " + IRecData.ticketnum);
         IRecL.PlaceNbr:=0;
        ELSE
         L_General.Assert(L_Prop.IsNumericValue(IRecData.place, "0"), "४   '" + IRecData.place + "', 䠩 " + IRecData.DBFFile + ".dbf,  N " + IRecData.ticketnum);
         IRecL.PlaceNbr:=IRecData.place;
        END;
        SETEMPTY(IRecL.asBoxNbr, IRecL.asTrip);
        IF SEARCH(Stop, Stop, IRecData.codepunkt) THEN
         IRecL.DstStop:=Stop.Stop;
        ELSE
         SETEMPTY(IRecL.DstStop);
        END;
        IRecL.Tariff  :=IRecData.tarif;
        IRecL.Prc     :=IRecData.persent;
        IF    IsEmpty(IRecData.prnds) & IsEmpty(IRecData.prgr) THEN
         IRecL.VATClcM :=P_Math.satVAT_TaxFree;
        ELSIF IsEmpty(IRecData.prnds) & (IRecData.prgr = "*") THEN
         IRecL.VATClcM :=P_Math.satVAT_TaxFree;
        ELSIF (IRecData.prnds = "*") & IsEmpty(IRecData.prgr) THEN
         IRecL.VATClcM :=P_Math.satVAT_woFeatures;
        ELSIF (IRecData.prnds = "*") & (IRecData.prgr = "*") THEN
         IRecL.VATClcM :=P_Math.satVAT_ZeroRate;
        ELSE
         L_General.Error("४⭠   prnds  prgr|" +
                         " । ᯮᮡ  ");
        END;

        IRecL.InsurFee:=IRecData.ssb;
        IRecL.ComisFee:=IRecData.ksb;
        IRecL.ServFee :=IRecData.ussb;
        IRecL.BookFee :=IRecData.bron;

        IF trgKind = L_IRec.knd_Sale THEN
         IRecL.Sum     :=IRecData.tarifpers;
         IRecL.TotalSum:=IRecData.cost1;
        ELSE
         IF IRecData.tarifpers = 0 THEN
          IRecL.Sum:=0;
         ELSE
          L_General.CallUs(IRecData.uder <= IRecData.tarifpers);
          IRecL.Sum:=IRecData.tarifpers-IRecData.uder;
         END;
         L_General.CallUs(IRecData.uder <= IRecData.cost1);
         IRecL.TotalSum:=IRecData.cost1-IRecData.uder;
        END;
        SETEMPTY(IRecL.asRWayS, IRecL.asDay, IRecL.asStartT, IRecL.ReturnK);
        IRecL.Status  :=L_IRec.irls_Passed;
        IRecL.Kind    :=trgKind;

        INSERT(IRecL);
   
        IF trgKind = L_IRec.knd_Return THEN
         IRecL.ReturnK :=7; (*!!  ""*)
        ELSE
         SETEMPTY(IRecL.ReturnK);
        END;
        REPLACE(IRecL);
       ELSE
        L_General.Error(" " + IRecData.numved + ":  " + IRecData.ticketnum + " 㦥 ஢");
       END;
      END; (* IF IRecData.bad = "F"...*)
      NEXT(IRecData);
     END; (* WHILE OCCURE(IRecData) ... *)
     NEXTINEXTENDEDSEL(IRecData, datesel, ppwir);
     IF ~!newIRec THEN
      L_IRec.intProceedIRec(newIRec, 0);
     END;
    END; (* WHILE OCCURE(IRecData) ... *)
    NEXTINEXTENDEDSEL(IRecData, numved);
   END; (* WHILE OCCURE(IRecData) ... *)
  END; (* IF SELECT(IRecData, numved)... *)

  IF DBD.FileExist(IRecHead) & SELECT(IRecHead, num) THEN
   WHILE OCCURE(IRecHead) DO
    PROMPT("㧪 ⥩ ࠢ " + IRecHead.num  + " (" + IRecHead.DBFFile + ")");
    trgCarrFirm:=GetCarrFirm(IRecHead.carrfirm);
    IF trgCarrFirm = P_Firm.OWN_FIRM THEN
     L_General.Assert(IRecHead.selftran = "T", "ᮮ⢥⢨ ॢ稪  ਧ '⢥ ॢ稪  '");
     L_General.Assert(~IsEmpty(IRecHead.garnum), " 㪠 ࠦ ");
     L_General.Assert(L_Prop.IsNumericValue(IRecHead.garnum, "0"), "४ ࠦ  " + IRecHead.garnum);
     L_General.Assert(SEARCH(Car, BoxNbr, IRecHead.garnum), "  ࠦ  " + IRecHead.garnum);
     L_General.Assert(L_Env.RealBoxNbr(Car.BoxNbr), " 䨪⨢ ࠦ  " + Car.BoxNbr);
     trgBoxNbr:=Car.BoxNbr;
    ELSE
     L_General.Assert(IRecHead.selftran = "F", "ᮮ⢥⢨ ॢ稪  ਧ '⢥ ॢ稪  '");
     L_General.Assert(IsEmpty(IRecHead.garnum), "  ஭ ॢ稪    㪠 ࠦ ");
     SETEMPTY(trgBoxNbr);
    END;

    trgDprtStrg:=GetDprtStrg(IRecHead.num);
    InsertNewIRec(L_IRec.type_Departure, IRecHead.num, GetDate(IRecHead.date1), EMPTYOF(Storage.Storage), trgDprtStrg, trgCarrFirm, 0);
    newIRec:=IRec.IRec;
    IF L_IRec.StandOnSpecificTypeIRec(L_IRec.type_Sale, IRecHead.num, trgDprtStrg, trgCarrFirm) THEN
     IF SELECT(clrIRec, clrIRec, newIRec) THEN
      REMOVE(clrIRec);
      L_General.CallUs(~OCCURE(clrIRec));
     END;
     L_IRec.CreateDepartureIRec(IRecHead.num, trgDprtStrg, trgCarrFirm, newIRec, trgBoxNbr);
    END;
    NEXT(IRecHead);
   END; (* WHILE OCCURE(IRecHead) ... *)
  END; (* IF SELECT(IRecHead, num) ... *)

  SELECT(clrIRec, clrIRec);
  WHILE OCCURE(clrIRec) DO
   SEARCH(IRec, IRec, , clrIRec.IRec);
   L_General.CallUs(IRec.Type = L_IRec.type_Departure);
   L_General.CallUs(~IRec.Done);
   L_General.CallUs(~SELECT(IRecL, IRec, IRec.IRec));
   L_IRec.CreateDepartureIRec(IRec.SrcNbr, IRec.DprtStrg, IRec.CarrFirm, IRec.IRec, clrIRec.BoxNbr);
   NEXT(clrIRec);
  END; (* WHILE OCCURE(clrIRec) ... *)
 END {ImportIRec};

(*
$P { prt_Top:
P_Firm.FP_FirmName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_mb(), L, "N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                             ࠡ⠭  ࠢ  ##########                             |
|------------------------------------------------------------------------------------------------------------|
|  |      |㭪 ࠢ       |ᠭ ஡                                               |
|-------|----------|------------------------|----------------------------------------------------------------|
}

(*
$P { prt_Line:
IRec.IRec, L, ""
IRec.Date, L, "D.N.y"
Storage.Storage, L, ""
Storage.Name, L, ""
?, L, ""
@
|#######|##########|####### ################|################################################################|
}
*)

$P { prt_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE intMakeDone();
 BEGIN
  Proceed(+1, "");
 END {intMakeDone};

 PUBLIC PROCEDURE ProceedAll();
  CONST
   bpId = "BadIR";
 BEGIN
  L_bp.Begin(bpId, "ࠡ⪠ ⥩", L_bp.t_Prc_wRp, L_General.tc_inMonth);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  OPENREP(R, L_General.NameConnection(bpId), Create);
  MAKEPART(R, prt_Top, bpId, " 㤠 ࠡ  ࠢ");

  SELECT(IRec, TDate, , L_IRec.type_Departure);
  SRCINSEL(IRec, GE, , Memo.ud_mb());
  WHILE OCCURE(IRec) & (IRec.Date <= Memo.ud_me()) DO
   PROMPT("ࠡ⪠  " + L_DatTim.DateStr(IRec.Date) + " " + IRec.IRec);
   IF ~IRec.Done THEN
    TRY
     L_General.RidgeExecute("IRec", PROCREF(intMakeDone), L_General.rem_Isolated);
    EXCEPT
    ON Exc: Exc_Root DO
     SEARCH(Storage, Storage, , IRec.DprtStrg);
     MAKEPART(R, prt_Line, Exc.Description);
    END; (* TRY *)
   END; (* IF ~IRec.Done ... *)
   NEXT(IRec);
  END; (* WHILE OCCURE(IRec) ... *)
  MAKEPART(R, prt_Bot);
  CLOSEREP(R);
  L_bp.End();
 END {ProceedAll};

 PUBLIC PROCEDURE ClearAll();
  CONST
   bpId = "ClrIR";
 BEGIN
  L_bp.Begin(bpId, " ⥩", L_bp.t_Process, L_General.tc_inMonth);
  L_StdFrm.Warning(" ⥩  " + L_DatTim.PeriodStr(Memo.ud_mb()));
  L_Way.ClearRWayS(L_Way.rwjpSrc_IRec, 0);
  SELECT(IRec, TDate, , L_IRec.type_Departure);
  SRCINSEL(IRec, GE, , Memo.ud_mb());
  WHILE OCCURE(IRec) & (IRec.Date <= Memo.ud_me()) DO
   PROMPT("  " + L_DatTim.DateStr(IRec.Date) + " " + IRec.IRec);
   SELECT(IRecL, IRec, , IRec.IRec);
   WHILE OCCURE(IRecL) DO
    UnBind_FromRWayS();
    NEXT(IRecL);
   END; (* WHILE OCCURE(IRecL) ... *)
   IRec.Done:=0;
   REPLACE(IRec);

   L_IRec.ProceedRefSaleIRec(IRec.SrcNbr, IRec.DprtStrg, IRec.CarrFirm, 0);

   NEXT(IRec);
  END; (* WHILE OCCURE(IRec) ... *)
  L_Way.ClearRWayS(L_Way.rwjpSrc_IRec, 1);
  L_bp.End();
 END {ClearAll};

 PRIVATE PROCEDURE RebuildCurDepartureIRec();
  VAR
   trgBoxNbr: LIKE(Car.BoxNbr);
 BEGIN
  L_General.Assert(ACCESS(IRec), " ⠭ ⥪  ࠢ");
  L_General.Assert(IRec.Type = L_IRec.type_Departure, " 㯭 ⮫쪮   ࠢ");
  L_StdFrm.Choice("ନ஢  ࠢ " + IRec.IRec);
  SAVE(IRec);
  SAVE(IRecL);
  CALL(IRec.Proceed(-1, ""));
  RESTORE(IRecL);
  RESTORE(IRec);

  trgBoxNbr:=GetSingleBoxNbrFromIRecL(IRec.IRec);

  SELECT(IRecL, IRec, , IRec.IRec);
  REMSEL(IRecL);

  L_IRec.CreateDepartureIRec(IRec.SrcNbr, IRec.DprtStrg, IRec.CarrFirm, IRec.IRec, trgBoxNbr);

  TRY
   CALL(IRec.Proceed(+1, ""));
  EXCEPT
  ON Exc: Exc_Root DO
   L_StdFrm.RedInform(Exc.MsgOriginalText);
  END; (* TRY *)
 END {RebuildCurDepartureIRec};

 PRIVATE CONST
  RepName  = "INCSH";
  MaxCount = 1000;

 VAR
  Dir     : SCAL[3];
  Choice  : SCAL[MaxCount];
  NamePool: STRING[];

(*
$P { is_Top_1:
P_Firm.FP_FirmName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_cd(), L, "D.N.y"
"⠭: " + L_Str.PoolItem(NamePool, Choice) + ", " + L_Str.PoolItem(" ३| ३| ३", Dir), C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                                   த ⮢  ##########                                   |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
| |室  |       |                                         |             室|  - .|
}
*)

(*
$P { is_Line_1:
tmp.StartT, C, "H:M"
ExitClss.Sign, L, ""
SEJobs.Trip, L, ""
SEJobs.Route, L, ""
RoutMod.Name, L, ""
@
|-----|-------|-----------|------------------------------------------------|------------------|--------------|
|#####|#######|###########|#### ###########################################|                  |              |
}
*)

(*
$P { is_Filling_1:
@
|-----|-------|-----------|------------------------------------------------|------------------|--------------|
|     |       |           |                                                |                  |              |
}
*)

(*
$P { is_PageBot_1:
L_PagePr.PagePr_CurrentPage(), R, "0"
@
|--------------------------------------------------------------------------|------------------|--------------|
|஫쭠 㬬                                                    |                  |              |
|--------------------------------------------------------------------------|------------------|--------------|
|஫쭠 㬬  砫                                       |                  |              |
=(c) Polak==========================================================================================  ## =
}
*)

(*
$P { is_Bot_1:
L_PagePr.PagePr_CurrentPage(), R, "0"
@
|--------------------------------------------------------------------------|------------------|--------------|
|஫쭠 㬬                                                    |                  |              |
|--------------------------------------------------------------------------|------------------|--------------|
|  ᮤন ### ⮢   㬬                    |                  |              |
|------------------------------------------------------------------------------------------------------------|
| 㬬 ய                                                                                        |
|                                                                                                            |
|............................................................................................................|
|                                                                                                            |
|............................................................................................................|
|                                                                                                            |
}
*)

(*
$P { is_Top_2:
P_Firm.FP_FirmName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_cd(), L, "D.N.y"
"⠭: " + L_Str.PoolItem(NamePool, Choice) + ", " + L_Str.PoolItem(" ३| ३| ३", Dir), C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                         த ⮢  ##########  __________________                        |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|     |       |           |                                      |             |  ࠭ᯮ  |
|.|室  |       |                               |---------------------|---------------------|
|     |       |           |                                      |         室| .|         室| .|
}
*)

(*
$P { is_Line_2:
tmp.StartT, C, "H:M"
ExitClss.Sign, L, ""
SEJobs.Trip, L, ""
SEJobs.Route, L, ""
RoutMod.Name, L, ""
@
|-----|-------|-----------|--------------------------------------|--------------|------|--------------|------|
|#####|#######|###########|#### #################################|              |      |              |      |
}
*)

(*
$P { is_Filling_2:
@
|-----|-------|-----------|--------------------------------------|--------------|------|--------------|------|
|     |       |           |                                      |              |      |              |      |
}
*)

(*
$P { is_PageBot_2:
L_PagePr.PagePr_CurrentPage(), R, "0"
@
|----------------------------------------------------------------|--------------|------|--------------|------|
|஫쭠 㬬                                          |              |      |              |      |
|----------------------------------------------------------------|--------------|------|--------------|------|
|஫쭠 㬬  砫                             |              |      |              |      |
=(c) Polak==========================================================================================  ## =
}
*)

(*
$P { is_Bot_2:
L_PagePr.PagePr_CurrentPage(), R, "0"
@
|----------------------------------------------------------------|--------------|------|--------------|------|
|஫쭠 㬬                                          |              |      |              |      |
|----------------------------------------------------------------|--------------|------|--------------|------|
|  ᮤন ### ⮢   㬬          |              |      |              |      |
|------------------------------------------------------------------------------------------------------------|
| 㬬 ய                                                                                        |
|                                                                                                            |
|............................................................................................................|
|                                                                                                            |
|............................................................................................................|
|                                                                                                            |
}
*)

(*
$P { is_Bot_Cashier:
@
| ⠭樨------------------------------------------------------------------------------------------|
|. |, , ⢮                                                  |                 |
|----------|------------------------------------------------------------------------|------------------------|
|          |                                                                        |                        |
}
*)

(*
$P { is_Bot_ReceiveCashier:
@
|죨 ਭ ----------------------------------------------------------------------------------------|
|. |, , ⢮                                                  |                 |
|----------|------------------------------------------------------------------------|------------------------|
|          |                                                                        |                        |
}
*)

(*
$P { is_Bot:
L_PagePr.PagePr_CurrentPage(), R, "0"
@
=(c) Polak==========================================================================================  ## =
}
*)

 PRIVATE PROCEDURE SalesByTransportCardExist(): SCAL[2];
 BEGIN
  RETURN L_General.GetAPSiteNumber() = 55;
 END {SalesByTransportCardExist};

 PRIVATE PROCEDURE ReceiveCashierExist(): SCAL[2];
 BEGIN
  RETURN L_General.GetAPSiteNumber() # 55;
 END {ReceiveCashierExist};

 PRIVATE PROCEDURE GetPartName(PartName: STRING[]): STRING[];
 BEGIN
  IF SalesByTransportCardExist() THEN
   RETURN PartName + "_2";
  ELSE
   RETURN PartName + "_1";
  END;
 END {GetPartName};

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode=L_PagePr.m_Print THEN

  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF (Mode = L_PagePr.m_Print) | (Mode = L_PagePr.m_RDoneTop) THEN
   MAKEPART(R, ^(GetPartName("is_Top")));
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(^(GetPartName("is_PageBot"))));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, ^(GetPartName("is_PageBot")));
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
  VAR
   Depth: NUMERIC[0];
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   Depth:=DEPTH(^(GetPartName("is_Bot"))) + DEPTH(is_Bot_Cashier) + DEPTH(is_Bot);
   IF L_General.GetAPSiteNumber() = 21 THEN
    INC(Depth, DEPTH(is_Bot_Cashier));
   END;
   IF ReceiveCashierExist() THEN
    INC(Depth, DEPTH(is_Bot_ReceiveCashier));
   END;
   L_PagePr.PagePr_SetResult(Depth);
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, ^(GetPartName("is_Bot")));
   MAKEPART(R, is_Bot_Cashier);
   IF L_General.GetAPSiteNumber() = 21 THEN
    MAKEPART(R, is_Bot_Cashier);
   END;
   IF ReceiveCashierExist() THEN
    MAKEPART(R, is_Bot_ReceiveCashier);
   END;
   MAKEPART(R, is_Bot);
  ELSIF Mode = L_PagePr.m_RDoneTop THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Fill);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(^(GetPartName("is_Filling"))));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, ^(GetPartName("is_Filling")));
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE StandOnRtMStop(trgStop: LIKE(Stop.Stop)): SCAL[2];
 BEGIN
  IF ~!trgStop &
     SELECT(RtMStop, Route, SEJobs.Route, SEJobs.Modif) THEN
   WHILE OCCURE(RtMStop) DO
    IF (RtMStop.Stop = trgStop) THEN
     RETURN 1;
    END;
    NEXT(RtMStop);
   END; (* WHILE OCCURE(RtMStop) ... *)
  END;
  RETURN 0;
 END {StandOnRtMStop};

 PRIVATE PROCEDURE UsefulTr(UsefulBT: SCAL[2][]; trgStop: LIKE(Stop.Stop)): SCAL[2];
 BEGIN
  IF    ~UsefulBT[SEJobs.BoxTick] THEN
   RETURN 0;
  ELSIF !trgStop THEN
   IF SELECT(RtMStop, Route, SEJobs.Route, SEJobs.Modif) THEN
    IF RoutMod.Dir # SEJobs.Dir THEN
     LAST(RtMStop);
    END;
   END;
   RETURN 1;
  ELSE
   RETURN StandOnRtMStop(trgStop);
  END;
 END {UsefulTr};

 PRIVATE PROCEDURE SetStopPool(VAR CodePool: LIKE(Stop.Stop)[MaxCount];
                               VAR NamePool: STRING[];
                               VAR Count   : NUMERIC[0]);
 BEGIN
  Count:=1;
  NamePool:="     ᥬ ⠭|";
  SETEMPTY(CodePool);
  SELECT(Stop, Stop);
  WHILE OCCURE(Stop) DO
   IF (Stop.CPType > 0) THEN
    CodePool[Count]:=Stop.Stop;
    NamePool       :=NamePool + Stop.Stop + " " + L_Way.GetStopName(Stop.Stop) + "|";
    INC(Count);
   END;
   NEXT(Stop);
  END; (* WHILE OCCURE(Stop) ... *)
 END {SetStopPool};

 PRIVATE PROCEDURE Create_tmp();
 BEGIN
  CreateFILE(tmp);
  CreateFIELD(tmp, Trip,    LIKE(SEJobs.Trip));
  CreateFIELD(tmp, Day,     LIKE(SEJobs.Day));
  CreateFIELD(tmp, StartT,  LIKE(SEJobs.StartT));
  CreateFIELD(tmp, StopNbr, LIKE(RtMStop.StopNbr));

  CreateINDEXandLINK(tmp, Trip, UNIQUE, SEJobs, Trip, USER, , , Trip);
  CreateINDEX       (tmp, tmp,  UNIQUE,                     , , Day, StartT, Trip, StopNbr);
  SetVersionOfFILE(tmp, 0);
  L_AFM.AF_CreateTemp("tmp", "tmp");
 END {Create_tmp};

 PRIVATE PROCEDURE Gather(trgDate: DATE);
  CONST
   drAll     = 0;
   drDirect  = 1;
   drReverse = 2;
  VAR
   Count     : NUMERIC[0];
   trgStop   : LIKE(Stop.Stop);
   CodePool  : LIKE(Stop.Stop)[MaxCount];
   UsefulBT  : SCAL[2][3];
   trgStartT : TIME;
   trgStopNbr: LIKE(RtMStop.StopNbr);
 BEGIN
  UsefulBT[L_Way.bt_Never]  :=0;
  IF L_General.GetAPSiteNumber() = 55 THEN
   UsefulBT[L_Way.bt_Ever]   :=0;
   UsefulBT[L_Way.bt_Perhaps]:=1;
  ELSE
   UsefulBT[L_Way.bt_Ever]   :=1;
   UsefulBT[L_Way.bt_Perhaps]:=0;
  END;
 
  SetStopPool(CodePool, NamePool, Count);
  IF    Count = 1 THEN
   Count:=2;
  ELSIF Count > 16 THEN
   Count:= 16;
  END;
 
  Dir   :=drDirect;
  Choice:=0;
  LOOP
   STDFORM("%<த 易⥫쭠   >E|"+
           "%<த       >E|"+
           Str.Align("   ࠢ:", 32, LEFT) + "|" +
           "%L22,3< ३||>O|||" +
           "|"+
           "%L32," + L_Str.IntStr(Count) + "FAI",
           " 롥 ⠭ ",
           INFORM_NEUTRAL,
           1,
           UsefulBT[L_Way.bt_Ever], UsefulBT[L_Way.bt_Perhaps], Dir, NamePool, Choice);
   IF ~UsefulBT[L_Way.bt_Ever] & ~UsefulBT[L_Way.bt_Perhaps] THEN
    L_StdFrm.RedInform("室 㪠 ᯮᮡ த ⮢");
   ELSE
    EXIT;
   END;
  END; (* LOOP *)
  trgStop:=CodePool[Choice];
 
  Create_tmp();
  SELECT(StExit, Exit);
  WHILE OCCURE(StExit) DO
   PROMPT(StExit.Exit);
   IF L_Way._CheckExitOnDate(StExit.Exit, trgDate) = L_Way.exvld_Active THEN
    SELECT(SEJobs, Exit,  , StExit.Exit);
    WHILE OCCURE(SEJobs) DO
     CONFORM(SEJobs, Route);
     CONFORM(SEJobs, RoutMod);
     IF ((Dir = drAll) | ((Dir = drDirect) & ~SEJobs.Dir) | ((Dir = drReverse) & SEJobs.Dir)) &
        UsefulTr(UsefulBT, trgStop) THEN
      IF OCCURE(RtMStop) THEN
       trgStopNbr:=RtMStop.StopNbr;
       trgStartT :=L_Way.GetStopCtrlTime_ofCurrentTrip(SEJobs.StartT, SYSDATE());
      ELSE
       SETEMPTY(trgStopNbr);
       trgStartT :=SEJobs.StartT;
      END;
      ADD(tmp, tmp, , SEJobs.Day, trgStartT, SEJobs.Trip, trgStopNbr);
     END;
     NEXT(SEJobs);
    END; (* WHILE OCCURE(SEJobs) ... *)
   END;
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit) ... *)
 END {Gather};

 PUBLIC PROCEDURE IncSheet();
  CONST
   PageLEN   = 62;
 BEGIN
  Gather(Memo.ud_cd());

  OPENREP(R, L_General.NameConnection(RepName), Create);
  L_PagePr.PagePr_Init("R", PageLEN, PROCREF(_RprtTop),
                                     PROCREF(_PageTop),
                                     PROCREF(_PageBot),
                                     PROCREF(_RprtBot),
                                     PROCREF(_Filling));
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   CONFORM(tmp, SEJobs);
   CONFORM(SEJobs, RoutMod);
   CONFORM(SEJobs, ExitClss);
   PROMPT(" " + SEJobs.Trip);
   L_PagePr.PagePr_BeforePrintLine(DEPTH(^(GetPartName("is_Line"))));
   MAKEPART(R, ^(GetPartName("is_Line")));
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)
 
  L_PagePr.PagePr_Done();
  L_General.SurveyLastReport();
 END {IncSheet};

 PRIVATE PROCEDURE InsIRecL();
 BEGIN
  CONFORM(tmp, SEJobs);
  CONFORM(SEJobs, Route);
  DEFAULT(IRecL);
  IRecL.IRec   :=IRec.IRec;
  IRecL.Kind   :=L_IRec.knd_Sale;
  IRecL.PayMth :=L_IRec.paymth_Cash;
  IRecL.Date   :=IRec.Date;
  IRecL.RegMth :=L_IRec.rm_MultiTicket_wSum;
  IRecL.TicketK:=L_IRec.tk_Full;
  SETEMPTY(IRecL.TckAmnt);
  IRecL.Route  :=Route.Route;
  IRecL.StartD :=IRecL.Date;
  IRecL.StartT :=tmp.StartT;
  IRecL.asTrip :=tmp.Trip;
  IRecL.Status :=L_IRec.irls_Prepared;
  INSERT(IRecL);
  FillSums();
 END {InsIRecL};

 PRIVATE PROCEDURE InsIRec(trgMyFirm: P_Firm.tMyFirm; trgDate: DATE);
  VAR
   trgStorage: LIKE(Storage.Storage);
 BEGIN
  trgStorage:=E_GetDefaultStorage();
  L_General.Assert(~!trgStorage, " ।   㬮砭");
  DEFAULT(IRec);
  IRec.MyFirm  :=trgMyFirm;
  IRec.Type    :=L_IRec.type_Departure;
  IRec.Date    :=trgDate;
  IRec.Single  :=0;
  IRec.Storage :=trgStorage;
  IRec.DprtStrg:=trgStorage;
  IRec.CarrFirm:=P_Firm.fomf(IRec.MyFirm);
  INSERT(IRec);

  IRec.SrcNbr:=IRec.IRec;
  REPLACE(IRec);
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_IRec, L_XDoc.EmptyXDocKind, IRec.IRec, L_XDoc.action_AutoBuild);
 END {InsIRec};

 PRIVATE PROCEDURE AutoFillIRec();
  VAR
   trgDate  : DATE;
   trgMyFirm: P_Firm.tMyFirm;
 BEGIN
  trgDate:=Memo.ud_cd();
  L_StdFrm.Question("ନ  ࠢ  " + L_DatTim.DateStr(trgDate));
  L_General.Assert(trgDate<=L_DatTim.IncWorkDay(SYSDATE(), +1),
                   "ଫ ⥩ ᪠  ,|祬   訩 ࠡ稩 ");
  IF SELECT(IRec, TDate, L_IRec.type_Departure, trgDate) THEN
   L_StdFrm.Choice("   ࠢ  " + L_DatTim.DateStr(trgDate));
  END;
  trgMyFirm:=P_Firm.DefineMyFirm();

  Gather(trgDate);

  L_General.Assert(SELECT(tmp, tmp), "    室饣 ३  ନ஢ ");
  InsIRec(trgMyFirm, trgDate);
  WHILE OCCURE(tmp) DO
   PROMPT(" " + tmp.Trip);
   InsIRecL();
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)
 END {AutoFillIRec};

 PUBLIC PROCEDURE InsertIRecS();
  VAR
   irli_Mode: SCAL[9];
 BEGIN
  irli_Mode:=L_IRec.E_GetIRecLInsertMode();
  IF    irli_Mode = L_IRec.irlim_Manual THEN
   L_General.Error("㯥 ⮫쪮 筮 ᯮᮡ ଫ ⥩");
  ELSIF irli_Mode = L_IRec.irlim_AutoFill THEN
   AutoFillIRec();
  ELSIF irli_Mode = L_IRec.irlim_Import THEN
   ImportIRec();
  ELSE
   L_General.CallUs(0);
  END;
 END {InsertIRecS};

 PUBLIC PROCEDURE ModifyIRecLAttr();
 BEGIN
  SetIRecLFiedldModifiable(1);
 END {ModifyIRecLAttr};

BEGIN
 L_Events.ExecuteHandler();
END.
