(*
%Copyright   (c) Polak IT
%Author      06.03.2009 11:19:41 POLAK\LDA
%Purpose      ⠢ 
%Type        control
%Specific    AP
%Modified    18.09.2013 10:48:22 POLAK\LDA
%Environment
*)

 MODULE IsSData [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, L_MDoc, L_Acnt, L_MathR, L_MDoc, L_APtm, L_DatTim, E_Bills,
        P_Cntr, L_Acnt, Math, L_StdFrm, P_MDoc, L_Str, P_OwnData, L_IsSData, L_WDO;

 PRIVATE PROCEDURE GetBruttoPrice(Price_woVAT: FLOAT): FLOAT;
 BEGIN
  RETURN Price_woVAT + L_Acnt.GetExclVAT(MDoc.Date, Price_woVAT);
 END {GetBruttoPrice};

 PRIVATE PROCEDURE GetIsSDataParams(VAR trgRound  : LIKE(IsSData.Round);
                                    VAR trgExtra_1: NUMERIC[6,2]);
  VAR
   difExtra_1, difRound: SCAL[2];
 BEGIN
  SETZERO(difExtra_1, difRound);
  SETEMPTY(trgRound, trgExtra_1);
  SAVE(IsSData);
  SELECT(IsSData, MDoc, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(IsSData) DO
   IF ~difRound THEN
    IF ~!IsSData.Round THEN
     IF    !trgRound THEN
      trgRound:=IsSData.Round;
     ELSIF trgRound # IsSData.Round THEN
      difRound:=1;
      SETEMPTY(trgRound);
     END;
    END;
   END;

   IF L_IsSData.AcceptableMathForCalculate(IsSData.ISDMType) THEN
    IF ~difExtra_1 THEN
     IF    !trgExtra_1 THEN
      trgExtra_1:=IsSData.Extra[L_IsSData.i_Extra_1];
     ELSIF trgExtra_1 # IsSData.Extra[L_IsSData.i_Extra_1] THEN
      difExtra_1:=1;
      SETEMPTY(trgExtra_1);
     END;
    END;
   END;
   NEXT(IsSData);
  END; (* WHILE OCCURE(IsSData) ... *)
  RESTORE(IsSData);

  IF ~difRound & !trgRound THEN
   trgRound:=0;
  END;
 END {GetIsSDataParams};

 PRIVATE PROCEDURE FillDefaultIsSDataValues();
 BEGIN
  GetIsSDataParams(IsSData.Round, IsSData.Extra[L_IsSData.i_Extra_1]);
  IsSData.Crncy                     :=L_IsSData.ip_GetDefaultCurrency();
  IsSData.opManner                  :=L_IsSData.m_Extra;
  IsSData.pPrice                    :=L_IsSData.GetPublicPrice(L_IsSData.GetBillCU());
  IsSData.Total                     :=L_IsSData.GetTotal();
  REPLACE(IsSData);
 END {FillDefaultIsSDataValues};

 PRIVATE PROCEDURE E_GetDefaultExtra_0(): NUMERIC[4];
  VAR
   Local : PROC;
   Result: NUMERIC[4];
 BEGIN
  Result:=0.0000;
  Local :=PROCREF(E_Bills.GetDefaultExtra_0);
  IF ~!Local THEN

  ELSE
   IF L_General.GetAPSiteNumber() = 84 THEN
    CONFORM(MDocList, Math);
    IF Math.MathType # L_MathR.mtyp_CWOrdIncome THEN
     Result:=100.0000;
    END;
   END;
  END;
  RETURN Result;
 END {E_GetDefaultExtra_0};

 PRIVATE PROCEDURE UpdateIsSData();
 BEGIN
  CONFORM(MDocList, Math);
  IF ~SEARCH(IsSData, MDoc, MDoc.MDocKind, MDoc.MDoc, MDocList.MDLNbr, 1) THEN
   DEFAULT(IsSData);
   IsSData.MDocKind:=MDoc.MDocKind;
   IsSData.MDoc    :=MDoc.MDoc;
   IsSData.MDLNbr  :=MDocList.MDLNbr;
   IsSData.ISDNbr  :=1;
   IsSData.ISDMType:=L_IsSData.E_GetISDMTypeByCurMDL();
   IsSData.Math    :=MDocList.Math;
   IsSData.Amount  :=MDocList.Qnt;
   IsSData.Extra[L_IsSData.i_Extra_0]:=E_GetDefaultExtra_0();
   IF (MDocList.Sum + MDocList.VAT) = 0 THEN
    IsSData.iPrice  :=GetBruttoPrice(L_MathR.GetMDLMathPrice());
   ELSE
    IsSData.iPrice  :=(MDocList.Sum + MDocList.VAT) / MDocList.Qnt;
   END;
   IsSData.oPrice  :=IsSData.iPrice * (1 + IsSData.Extra[L_IsSData.i_Extra_0] / 100);
   INSERT(IsSData);
   FillDefaultIsSDataValues();
  END;
 END {UpdateIsSData};

 PRIVATE PROCEDURE GatherIsSData(idMode: SCAL[3]);
  VAR
   Local: PROC;
 BEGIN
  IF idMode = L_IsSData.idm_Rebuild THEN
   L_StdFrm.Choice("ନ஢  ⠢ ?|" +
                   "   祭.");
   SETSEL(IsSData, MDoc, MDoc.MDocKind, MDoc.MDoc);
   REMSEL(IsSData);
  END;

  Local:=PROCREF(E_Bills.id_Show);
  IF    ~!Local THEN
   Local(idMode);
  ELSIF idMode = L_IsSData.idm_Edit THEN
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) DO
    PROMPT("ࠡ⪠ ப " + MDocList.MDLNbr);
    CONFORM(MDocList, Math);
    UpdateIsSData();
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList)...*)
  END;
 END {GatherIsSData};

 PUBLIC PROCEDURE Save();
 BEGIN
  IF ~CondLaunchLocalProc("id_Save") THEN
   MDoc.Total:=0;
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) DO
    PROMPT(" " + MDocList.MDLNbr);
    CONFORM(MDocList, Math);
    L_IsSData.StandOnIsSData();
    MDocList.Sum:=0;
    MDocList.VAT:=0;
    REPLACE(MDocList);
    L_IsSData.SetMDocListSum(IsSData.Total, IsSData.Round);
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList)...*)
   REPLACE(MDoc);
  END;
 END {Save};

 PUBLIC PROCEDURE SaveMDoc_wIsSData();
 BEGIN
  SEARCH(MDoc, MDoc, , IsSData.MDocKind, IsSData.MDoc);
  Save();
 END {SaveMDoc_wIsSData};

 PUBLIC PROCEDURE AutoBuildMDoc_wIsSData(idMode: SCAL[3]);
 BEGIN
  GatherIsSData(L_IsSData.idm_Edit);
  SaveMDoc_wIsSData();
 END {AutoBuildMDoc_wIsSData};

 PRIVATE PROCEDURE GetIsSDataMode(): NUMERIC[0];
  VAR
   S: STRING[];
 BEGIN
  S:=L_WDO.GetEnvVarValue("IsSDataMode");
  IF ~!S THEN
   RETURN STRTOFLD(S, NUMERIC);
  ELSE
   RETURN 0;
  END;
 END {GetIsSDataMode};

 PRIVATE PROCEDURE IsIncomingBills(): SCAL[2];
 BEGIN
  RETURN (MDoc.MDocKind = L_MDoc.md_IsS) | (MDoc.MDocKind = L_MDoc.md_IAS) | (MDoc.MDocKind = L_MDoc.md_RPr);
 END {IsIncomingBills};

 PRIVATE PROCEDURE SetDefaultVideoFieldsValue(OnInitializeWindow: SCAL[2]);
  VAR
   Fields: FORMFIELDS;
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  Fields("v_IsSData_Total").Value       :=0;
  Fields("v_IsSData_Income").Value      :=0;
  Fields("v_IsSDataTotal_Warning").Value:=" ";
  Fields("v_Appendix").Value            :=" ";
  IF OnInitializeWindow THEN
   Fields("v_oPrice_Title").Value        :=". 業";
  ELSE
   IF    IsIncomingBills() THEN
    Fields("v_oPrice_Title").Value        :=". 業";
   ELSIF MDoc.MDocKind = L_MDoc.md_VhS THEN
    Fields("v_oPrice_Title").Value        :=" .";
   ELSE
    L_General.CallUs(0);
   END;
  END;
  Fields("v_IsSDataTotal_Warning").Visible:=0;   (* 0079956 *)

  Fields("v_IsSData_Changed").Value     :=0;
  Fields("v_IsSData_Changed").Visible   :=0;
 END {SetDefaultVideoFieldsValue};

 PRIVATE PROCEDURE IsSData_0_OnReposition();
 BEGIN
  IF GetIsSDataMode() = L_IsSData.idm_View THEN
   L_MDoc.AccessMDoc();
   CONFORM(MDoc, IsSData);
   L_General.Assert(OCCURE(IsSData), " 믮 楤 ⠢ ");
   TRY
    L_IsSData.ReCalcTotals();
    L_IsSData.id_FillAppendix();
   EXCEPT
   ON Exc: Exc_Root DO
    SetDefaultVideoFieldsValue(0);
   END;
  END;
 END {IsSData_0_OnReposition};

 PRIVATE PROCEDURE MDoc_OnBeforeEdit();
VAR
 Changed: SCAL[2];
 BEGIN
  RTI.Get().CurWindow.Zones(0).Fields("MDoc.MDoc").Modifiable:=1;
  L_MDoc.AccessMDoc();
(*
  IF (MDoc.MDocKind = L_MDoc.md_IsS) | (MDoc.MDocKind = L_MDoc.md_VhS) THEN
*)
  IF IsIncomingBills() THEN
   IF L_IsSData.ip_GetDefaultCurrency() = L_IsSData.c_Dollar THEN

(*६*)
Changed:=~SELECT(MDocPro, MDoc, MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_BilCURate) &
          SELECT(IsSData, MDoc, MDoc.MDocKind, MDoc.MDoc);
    IF Changed THEN
     L_StdFrm.Inform(" 訡筮 饥 ᢮⢮  '  '.||" +
                     " 믮  㬬  ⠢ ");
    END;
(*६*)

    L_IsSData.SaveDefaultBillCU(MDoc.MDocKind, MDoc.MDoc);
   ELSE
    Changed:=0;
(*
    L_General.CallUs(0);
*)
   END;
   SetDefaultVideoFieldsValue(0);

(*६*)
IF Changed THEN
 RTI.Get().CurWindow.Zones(0).Fields("v_IsSData_Changed").Value:=1;
END;

   GatherIsSData(L_IsSData.idm_Edit);
   CONFORM(MDoc, IsSData);
   L_General.Assert(OCCURE(IsSData), " 믮 楤 ⠢ ");
   L_IsSData.id_FillAppendix();
   L_IsSData.ReCalcTotals();
  ELSE
   L_General.Error("  㯭  㬥⮢ ⮣ ");
  END;
  LIKEMENU(View, ". 1");
 END {MDoc_OnBeforeEdit};

 PRIVATE PROCEDURE CondLaunchLocalProc(ProcName: STRING[]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF("E_Bills." + ProcName);
  IF ~!Local THEN
   Local();
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {CondLaunchLocalProc};

 PRIVATE PROCEDURE LaunchLocalProc(ProcName: STRING[]);
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=CondLaunchLocalProc(ProcName);
 END {LaunchLocalProc};

 PRIVATE PROCEDURE IsSData_OnBeforeEdit();
 BEGIN
  L_IsSData.smf_OnBeforeEdit();
  LaunchLocalProc("id_OnBeforeEdit");
 END {IsSData_OnBeforeEdit};

 PRIVATE PROCEDURE IsSData_OnBeforeInsert();
  VAR
   _MDLNbr: LIKE(IsSData.MDLNbr);
   _ISDNbr: LIKE(IsSData.ISDNbr);
 BEGIN
  L_IsSData.sfm_OnBeforeInsert();

  SAVE(IsSData);
  SEARCH(IsSData, ForHierarchy, , MDoc.MDocKind, MDoc.MDoc, IsSData.Parent);
  L_General.Assert(IsSData.ISDMType = L_IsSData.mt_Composite, "⠢  ⮫쪮  ");

  _MDLNbr:=IsSData.MDLNbr;
  SETSEL(IsSData, MDoc, MDoc.MDocKind, MDoc.MDoc, _MDLNbr);
  LAST(IsSData);
  _ISDNbr:=IsSData.ISDNbr;
  RESTORE(IsSData);

  IsSData.MDLNbr  :=_MDLNbr;
  IsSData.ISDNbr  :=_ISDNbr + 1;
  IsSData.ISDMType:=L_IsSData.mt_CellOfComposite;
  REPLACE(IsSData);

  LaunchLocalProc("id_OnBeforeInsert");
 END {IsSData_OnBeforeInsert};

 PRIVATE PROCEDURE IsSData_OnBeforeDelete();
 BEGIN
  LaunchLocalProc("id_OnBeforeDelete");
  L_General.Assert(IsSData.ISDNbr # 1, " , 饣  ப , 饭");
  SAVE(IsSData);
  SEARCH(IsSData, MDoc, , IsSData.MDocKind, IsSData.MDoc, IsSData.MDLNbr, 1);
  L_IsSData.ReCalcSingleMath(1);
  RESTORE(IsSData);
 END {IsSData_OnBeforeDelete};

 PRIVATE PROCEDURE IsSData_OnSuccessfulChange();
 BEGIN
  L_IsSData.ReCalcSingleMath(RTI.Get().CurWindow.OriginalName = "IsSData");
 END {IsSData_OnSuccessfulChange};

 PRIVATE PROCEDURE IsSData_opManner_OnSuccessfulChange();
  VAR
   Fields: FORMFIELDS;
 BEGIN
  IF IsSData.opManner # L_IsSData.m_Extra THEN
   SETEMPTY(IsSData.Extra[L_IsSData.i_Extra_0]);
   REPLACE(IsSData);
  END;
  IsSData_OnBeforeEdit();

  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  Fields("IsSData.Math").Modifiable    :=1;
  Fields("IsSData.Amount").Modifiable  :=1;
  Fields("IsSData.opManner").Modifiable:=1;
 END {IsSData_opManner_OnSuccessfulChange};

 PRIVATE PROCEDURE IsSData_Math_OnSuccessfulChange();
 BEGIN
  IsSData.Extra[L_IsSData.i_Extra_0]:=0;
  REPLACE(IsSData);
  FillDefaultIsSDataValues();
  IsSData_opManner_OnSuccessfulChange();
 END {IsSData_Math_OnSuccessfulChange};

 PRIVATE PROCEDURE IsSData_Amount_OnSuccessfulChange();
 BEGIN
  IsSData_OnSuccessfulChange();
 END {IsSData_Amount_OnSuccessfulChange};

 PRIVATE PROCEDURE IsSData_iPrice_OnSuccessfulChange();
 BEGIN
  IsSData_OnSuccessfulChange();
 END {IsSData_iPrice_OnSuccessfulChange};

 PRIVATE PROCEDURE IsSData_Extra_OnSuccessfulChange();
 BEGIN
  IsSData_OnSuccessfulChange();
 END {IsSData_Extra_OnSuccessfulChange};

 PRIVATE PROCEDURE IsSData_oPrice_OnSuccessfulChange();
 BEGIN
  IsSData_OnSuccessfulChange();
 END {IsSData_oPrice_OnSuccessfulChange};

 PRIVATE PROCEDURE IsSData_pPrice_OnSuccessfulChange();
 BEGIN
  IsSData_OnSuccessfulChange();
 END {IsSData_pPrice_OnSuccessfulChange};

 PRIVATE PROCEDURE IsSData_Round_OnSuccessfulChange();
 BEGIN
  IsSData_OnSuccessfulChange();
 END {IsSData_Round_OnSuccessfulChange};

 PRIVATE PROCEDURE _OnBeforeEdit();
  VAR
   usd       : NUMERIC[4];
   BillCU    : FLOAT;
   FinExtra  : NUMERIC[3];
   Local     : PROC;
 BEGIN
  Local:=PROCREF(E_Bills.id_ParamsAllowed);
  IF !Local | ~Local() THEN
   L_General.Error(" 㯭  ।஢ ࠬ஢ ");
  END;

  L_IsSData.GetCurrencyAttr(usd, FinExtra, BillCU);
  RTI.Get().CurZone.Fields("v_usd").Value     :=usd;
  RTI.Get().CurZone.Fields("v_FinExtra").Value:=FinExtra;

  GetIsSDataParams(RTI.Get().CurZone.Fields("v_Round").Value, RTI.Get().CurZone.Fields("v_Extra_1").Value);
 END {_OnBeforeEdit};

 PRIVATE PROCEDURE _OnAfterEdit();
  VAR
   trgRound   : LIKE(IsSData.Round);
   trgExtra_1 : NUMERIC[6,2];
   trgMDocKind: LIKE(MDoc.MDocKind);
   trgMDoc    : LIKE(MDoc.MDoc);
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = "IDParamE" THEN
   ACCESS(IsSData);
   trgMDocKind:=IsSData.MDocKind;
   trgMDoc    :=IsSData.MDoc;
   L_StdFrm.Question("   ⠢   묨 ࠬࠬ?");

   L_IsSData.SaveBillCU(trgMDocKind, trgMDoc,
                        RTI.Get().CurZone.Fields("v_usd").Value, RTI.Get().CurZone.Fields("v_FinExtra").Value,
                        1);

   trgRound  :=RTI.Get().CurZone.Fields("v_Round").Value;
   trgExtra_1:=RTI.Get().CurZone.Fields("v_Extra_1").Value;

   SELECT(IsSData, MDoc, , trgMDocKind, trgMDoc);
   WHILE OCCURE(IsSData) DO

    SEARCH(MDocList, MDoc, , IsSData.MDocKind, IsSData.MDoc, IsSData.MDLNbr);
    IF ~!trgRound THEN
     IF L_IsSData.MathRequiredRound(IsSData.ISDMType) THEN
      IsSData.Round:=trgRound;
     END;
    END;
    IF ~!trgExtra_1 THEN
     IF L_IsSData.AcceptableMathForCalculate(IsSData.ISDMType) THEN
      IsSData.Extra[L_IsSData.i_Extra_1]:=trgExtra_1;
     END;
    END;
    REPLACE(IsSData);

    L_IsSData.ReCalcSingleMath(0);

    NEXT(IsSData);
   END; (* WHILE OCCURE(IsSData) ... *)
  END;
  L_IsSData.id_FillAppendix();

  SELECT(IsSData, MDoc, , trgMDocKind, trgMDoc);
  L_IsSData.ReCalcTotals();

  RTI.Get().CurWindow.ParentZone.Window.Zones(0).Fields("v_IsSData_Changed").Value:=1;
 END {_OnAfterEdit};

 PRIVATE PROCEDURE IsSData_OnAfterEdIns();
 BEGIN
  L_WDO.GetRelatedWindow(RTI.Get().CurWindow, "IsSData").Zones(0).Fields("v_IsSData_Changed").Value:=1;
  L_IsSData.ReCalcTotals();
 END {IsSData_OnAfterEdIns};

 PRIVATE PROCEDURE IsSData_OnAfterInsert();
 BEGIN
  IsSData_OnAfterEdIns();
 END {IsSData_OnAfterInsert};

 PRIVATE PROCEDURE IsSData_OnAfterEdit();
 BEGIN
  IsSData_OnAfterEdIns();
 END {IsSData_OnAfterEdit};

 PRIVATE PROCEDURE IsSData_OnAfterDelete();
 BEGIN
  L_IsSData.ReCalcTotals();
 END {IsSData_OnAfterDelete};

 PRIVATE PROCEDURE IsSDataE_0_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("IsSData.opManner").Format:="㬬|業|㬬 ";
 END {IsSDataE_0_OnZoneOpen};

 PRIVATE PROCEDURE IsSData_1_OnSetSubwindow();
  VAR
   SubWindow: STRING[];
 BEGIN
  SETEMPTY(SubWindow);
  IF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert)         |
     (RTI.Get().CurProcess.Kind = FORM_PROCESS.ProcessKind_ShowWin) |
     ~!L_WDO.AccessEnvVar("IsSDataEditMode") THEN
   SubWindow:="IsSDataE";
  END;
  RTI.Get().CurZone.HasVariousSubwindows :=1;
  RTI.Get().CurZone.SubwindowOriginalName:=SubWindow;
 END {IsSData_1_OnSetSubwindow};

 PRIVATE PROCEDURE IsSData_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurWindow.Zones(0).Fields("MDoc.MDoc").Modifiable:=0;
 END {IsSData_1_OnZoneOpen};

 PRIVATE PROCEDURE IDParamE_OnConformToWindow();
 BEGIN
(*祣  *)
 END {IDParamE_OnConformToWindow};

 PRIVATE PROCEDURE IsSData_OnConformToWindow();
 BEGIN
  ACCESS(MDoc);
  SE_WWD_CURSOR(RTI.Get().ConformTargetWindow.Name, MDoc);
  SE_WZD_CURSOR(RTI.Get().ConformTargetWindow.Name, 0, MDoc);
  SELECT(IsSData, Parent, , MDoc.MDocKind, MDoc.MDoc);
  SE_WZD_CURSOR(RTI.Get().ConformTargetWindow.Name, 1, IsSData);
 END {IsSData_OnConformToWindow};

 PUBLIC PROCEDURE Quit();
  VAR
   React: NUMERIC[0];
 BEGIN
  IF RTI.Get().CurWindow.Zones(0).Fields("v_IsSData_Changed").Value = 1 THEN
   React:=STDFORM(L_StdFrm.PartForm("%< ࠭ >DB" +
                                    "%<  ࠭ >B" +
                                    "%< ஢  >X" +
                                    "@" +
                                    "|࠭    ⠢ " +
                                    "|" +
                                    "| %###########%  %##############%  %######################% "),
                                    "",
                                    STOP,
                                    1);
  ELSE
   React:=2;
  END;
  RTI.Get().CurWindow.Zones(0).Fields("MDoc.MDoc").Modifiable:=1;
  IF React = 1 THEN
   ACCESS(IsSData);
   SaveMDoc_wIsSData();
   L_MDoc.SetMDocTotals("MDocEIE");
   LIKEMENU(Cancel, "", Cancel, "Save");
  ELSE
   LIKEMENU(Cancel, "", Cancel, "NoSave");
  END;
 END {Quit};

 PRIVATE PROCEDURE IsSData_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnReposition]);
  L_WDO.iUnmodifiable(0, ["MDoc.Total", "MDoc.SrcDate", "MDoc.SrcNbr", "MDoc.CopyCnt", "v_oPrice_Title",
                          "v_IsSData_Changed", "v_Appendix", "v_IsSData_Income", "v_IsSDataTotal_Warning",
                          "v_IsSData_Total"]);
  L_WDO.iProgs       (0, "IsSData");
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete, L_WDO.e_OnOpenZone, L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).HierarchicLink:=LINK.Get("IsSData", "Parent");
  L_WDO.iField       (1, "IsSData.Math").Hierarchic:=1;
  L_WDO.iScsChange   (1, ["IsSData.oPrice", "IsSData.iPrice", "IsSData.Extra[0]", "IsSData.pPrice"]);
  L_WDO.iUnmodifiable(1, ["IsSData.Amount", "IsSData.Math", "IsSData.ISDNbr", "IsSData.MDLNbr"]);
  L_WDO.iZone        (1).OpenAllParentsInHierarchicView();

  SetDefaultVideoFieldsValue(1);
 END {IsSData_OnInitializeWindow};

 PUBLIC PROCEDURE Rebuild();
 BEGIN
  GatherIsSData(L_IsSData.idm_Rebuild);
  CONFORM(MDoc, IsSData);
  L_IsSData.ReCalcTotals();
 END {Rebuild};

 PUBLIC PROCEDURE extReCalc(wReCalcTotals: SCAL[2]);
 BEGIN
  SELECT(IsSData, MDoc, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(IsSData) DO
   L_IsSData.ReCalcSingleMath(0);
   NEXT(IsSData);
  END; (* WHILE OCCURE(IsSData) ... *)

  IF wReCalcTotals THEN
   SELECT(IsSData, MDoc, , MDoc.MDocKind, MDoc.MDoc);
   L_IsSData.ReCalcTotals();
   RTI.Get().CurWindow.Zones(0).Fields("v_IsSData_Changed").Value:=1;
  END;
 END {extReCalc};

 PUBLIC PROCEDURE ReCalc();
 BEGIN
  extReCalc(1);
 END {ReCalc};

 PUBLIC PROCEDURE ShowIsSData();
 BEGIN
  LIKEMENU(Edit, "IsSData 0 " + RTI.Get().CurWindow.OriginalName + " " + L_Str.IntStr(RTI.Get().CurZone.Number) + " IsSDataMode=1");
 END {ShowIsSData};

BEGIN
 L_Events.ExecuteHandler();
END.
