(*
%Copyright   (c) Polak Computer System
%Author      28.06.2001 11:22:45 SAN
%Purpose       Excel -    - ࠭ᯮ ।⢠
%Type        report
%Specific    SYS
%Modified    25.02.2013 18:03:04 POLAK\Bor
%Environment
*)

 IMPORT L_General, L_DatTim, L_MathR, L_Way, L_APtm, L_Basis, D_XObj,
        FIO, Memo, E_Stock, L_Env, L_XObj, L_Acnt, L_Car, L_bp;

 VAR
  Stand: SCAL[2];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⠂");
  L_Basis.wb_WrInQM(F, "㯯த");
  L_Basis.wb_WrInQM(F, "㯯த");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "፮");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㯯ப");
  L_Basis.wb_WrInQM(F, "㯯ப");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ᯮ樨");
  L_Basis.wb_WrInQM(F, "१2");
  L_Basis.wb_WrInQM(F, "१2");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "㬬");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]; IsCar   : SCAL[2];
                                         _AcCut  : LIKE(AcCut.AcCut);
                                         _AcName : LIKE(AcCut.Name);
                                         CalcName: STRING[];
                                         _CirType: LIKE(Apport.CirType);
                                         _AcCut2 : LIKE(AcCut.AcCut);
                                         _AcName2: LIKE(AcCut.Name);
                                         Run     : NUMERIC[2];
                                         Sum     : L_XObj.tSum);
 BEGIN
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrDat(F, L_MathR.GetKeyAssAPrDate(Math.Math));
  IF L_MathR.PosToKAGSoft(Math.Math, Memo.ud_ut()) THEN
   L_Basis.wb_WrScl(F, KAGroup.KAGroup);
   L_Basis.wb_WrScl(F, KAGroup.Name);
   L_Basis.wb_WrScl(F, DeprecT.DeprecT);
   L_Basis.wb_WrStr(F, DeprecT.Name);
  ELSE
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  IF IsCar THEN
   L_Basis.wb_WrScl(F, Car.BoxNbr);
   L_Basis.wb_WrStr(F, CarLog.StateNbr);
   L_Basis.wb_WrScl(F, CarLog.Column);
   L_Basis.wb_WrStr(F, FLDTOSTR(CarLog.Purpose, "|"));
   L_Basis.wb_WrScl(F, MarkG.MarkG);
   L_Basis.wb_WrStr(F, MarkG.Name);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
  ELSE
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "------");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "------");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "------");
  END;
  L_Basis.wb_WrScl(F, _AcCut);
  L_Basis.wb_WrStr(F, _AcName);
  L_Basis.wb_WrStr(F, CalcName);
  L_Basis.wb_WrStr(F, FLDTOSTR(_CirType, "।|"));
  L_Basis.wb_WrScl(F, _AcCut2);
  L_Basis.wb_WrStr(F, _AcName2);
  L_Basis.wb_WrNum(F, Run, 2);
  L_Basis.wb_WrNum(F, Sum, 2);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE OutAcCutType(trgAcCuts: L_MathR.tMathAcCutCollection;
                                IsCar    : SCAL[2];
                                CalcName : STRING[]);

  VAR
   curAcCut: LIKE(AcCut.AcCut);
 BEGIN
  FOR_EACH curAcCut IN trgAcCuts DO
   SEARCH(AcCut, AcCut, , curAcCut);
   SELECT(XA001, mfObject, , XObject.MyFirm, XObject.XObject, curAcCut);
   WHILE OCCURE(XA001) DO
    SEARCH(AcCut2, AcCut2, , XA001.Cut2);
    MakePart("R", IsCar, AcCut.AcCut, AcCut.Name, CalcName, XA001.CirType,
                  AcCut2.AcCut2, AcCut2.Name, 0, XA001.Sum);
    Stand:=0;
    NEXT(XA001);
   END; (* WHILE OCCURE(XA001) ... *)
  END;
 END {OutAcCutType};

 PUBLIC PROCEDURE KA010();
  CONST
   bpId = "KA010";
  VAR
   _BAcCuts,
   _OAcCuts : L_MathR.tMathAcCutCollection;
   IsCar    : SCAL[2];
   Run      : NUMERIC[2];
   trgOM    : L_XObj.tOriginsMap;
   trgMyFirm: LIKE(MyFirm.MyFirm);
 BEGIN
  L_bp.Begin(bpId, "  ᭮ ।", L_bp.t_Basis, L_General.tc_inIntvl);

  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
 
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());

  L_XObj.SetupOrigins(0, trgOM, trgMyFirm);
  D_XObj.PointwiseBuildXC001(D_XObj.XCC_FullKA,
                             EMPTYOF(L_XObj.tSection),
                             L_Acnt.ak_Acn,
                             trgOM,
                             trgMyFirm,
                             D_XObj.XST_ByXObj,
                             D_XObj.XST_ByAcCut,
                             D_XObj.XST_ByAcCut2);
 
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
  E_Stock.GetKeyAssWearAcCuts(Memo.ud_ut(), _BAcCuts, L_MathR.KA_BalDepr,    L_MathR.KA_All, L_MathR.KA_All);
  E_Stock.GetKeyAssWearAcCuts(Memo.ud_ut(), _OAcCuts, L_MathR.KA_OutBalDepr, L_MathR.KA_All, L_MathR.KA_All);
 
  SELECT(Math, LeafMK, , 1, L_MathR.mathk_KeyAs);
  WHILE OCCURE(Math) DO
   PROMPT(Math.Math);
   IF L_MathR.IsActiveKeyAss(Math.Math, Memo.ud_fr(), Memo.ud_ut()) THEN
    L_MathR.AccessKeyAssXObject();
    IsCar:=L_MathR.PosToLastCarLog(Math.Math, Memo.ud_ut());
    IF IsCar THEN
     CONFORM(CarLog, Car);
     CONFORM(CarLog, Mark);
     SEARCH(MarkG, MarkG, , L_Way.GetMarkG(Mark.Mark, L_Way.mgt_Math));
    END;
    Stand:=1;
    OutAcCutType(_BAcCuts, IsCar, "ᮢ");
    OutAcCutType(_OAcCuts, IsCar, "");
    SAVE(CarLog);
    Run:=L_Car.GetWhiteRun(Math.Math, Memo.ud_ut()+1) -
         L_Car.GetWhiteRun(Math.Math, Memo.ud_fr());
    RESTORE(CarLog);
    IF Stand | (Run # 0) THEN
     MakePart("R", IsCar, "", "", "", "", "", "", Run, 0);
    END;
   END;
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)
  D_XObj.PurgeXC001();
  FIO.Close(R);
  L_bp.End();
 END {KA010};

END.