(*
%Copyright   (c) Polak Computer System
%Author      Unknown
%Purpose
%Type        library
%Specific    AP
%Modified    28.07.2014 14:01:23 POLAK\Gina
%Environment
*)

 MODULE L_AP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  mthlSrc_Operator  = 0;
  mthlSrc_RWayS     = 1;
  mthlSrc_Sheet     = 2;
  mthlSrc_LikeRWayS = 15;
  mthlSrc_Pool = "|/|| | | | | | | | | | | | | /";

  mthlWho_Driver  = 0;
  mthlWho_Guard   = 1;
  mthlWho_DrPupil = 2;
  mthlWho_GuPupil = 3;
  mthlWho_Staff   = 4;
  mthlWho_Pool = "⥫||.-|.-|⭨";

  mpgWho_Poll  = "⥫||.-|.-";

 IMPORT L_General, L_DatTim, L_Str, L_Way, Memo, L_XDoc, L_StdFrm, L_Car;

 PRIVATE PROCEDURE Assert_wStandOnXDoc(Cond,
                                       wStandOn,
                                       Strong   : SCAL[2];
                                       VAR Asked: SCAL[2];
                                       curXDocId: L_XDoc.tXDocId;
                                       Msg      : STRING[]);
 BEGIN
  IF ~Cond THEN
   IF wStandOn THEN
    IF STDFORM(L_StdFrm.PartForm("%<     ⮯      >X" +
                                 "%<  ३  " + L_XDoc.Ref_ShortName(L_XDoc.ExtractXDocType(curXDocId)) + ">DB" +
                                 "@" +
                                 "|" + Msg + " " + L_XDoc.XDocStr(curXDocId) +
                                 "|" +
                                 "|%###############%  %################%"),
                                 "",
                                 STOP,
                                 1) THEN
     L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, curXDocId, "");
    END;
   ELSE
    IF Strong THEN
     L_General.Error(Msg + " " + L_XDoc.XDocStr(curXDocId));
    ELSIF ~Asked THEN
     Asked:=1;
     L_StdFrm.CrucialChoice("ନ஢ ' ௫'.| ࠡ⠭ 㬥,|ਬ " + L_XDoc.XDocStr(curXDocId), L_APtm.g_PayRoll);
    END;
   END;
  END;
 END {Assert_wStandOnXDoc};

 PUBLIC PROCEDURE ProceedRWayS(trgDone, SkipNew, wStandOn, Strong: SCAL[2]; VAR Asked: SCAL[2]);
 BEGIN
  PROMPT("⥢  # " + RWayS.RWayS);
  IF RWayS.Done # trgDone THEN
   IF RWayS.Status = L_Way.rwsStat_Rated THEN
    SAVE(Staff);
    SAVE(WayLMen);
    PROCESS(RWayS, 60+trgDone);
    RESTORE(Staff);
    RESTORE(WayLMen);
    Assert_wStandOnXDoc(RWayS.Done=trgDone, wStandOn, Strong, Asked,
                        L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS),
                        " 㤠 "+L_Str.PoolItem("⪠|ࠡ", trgDone));
   ELSE
    Assert_wStandOnXDoc(SkipNew, wStandOn, Strong, Asked,
                        L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS),
                        " ⠪஢");
   END; (* IF RWayS.Status ... *)
  END; (* IF RWayS.Done ... *)
 END {ProceedRWayS};

 PUBLIC PROCEDURE SrcWagePayLByMPG_WP(Silent  : SCAL[2];
                                      _MarkG  : LIKE(MPG_WP.MarkG);
                                      _Who    : LIKE(MPG_WP.Who);
                                      _JRgPayT: LIKE(MPG_WP.JRgPayT);
                                      _RWPay  : LIKE(MPG_WP.RWPay);
                                      _Date   : DATE): SCAL[2];
 BEGIN
  SELECT(MPG_WP, MarkG, , _MarkG, _Who, _JRgPayT, _RWPay);
  WHILE OCCURE(MPG_WP) & ~L_DatTim.IsActive(_Date, MPG_WP.Begin, MPG_WP.Till) DO
   NEXT(MPG_WP);
  END; (* WHILE OCCURE(MPG_WP) ... *)

  IF OCCURE(MPG_WP) THEN
   L_General.Assert(SELECT(WagePayL, WagePay, MPG_WP.WagePay) &
                    SRCINSEL(WagePayL, LE, _Date),
                    " ଠ樨  䭮 ⪥ " + MPG_WP.WagePay +
                    "  " + L_DatTim.PeriodStr(_Date));
   RETURN 1;
  ELSE
   L_General.Assert(Silent,
                    " 㪠   䭮 㯯 " + _MarkG +
                    "| "+L_Str.PoolItem(mpgWho_Poll, _Who) +
                    ", ਠ " + _JRgPayT +", ந " +_RWPay +
                    "| "+L_DatTim.DateStr(_Date));
   RETURN 0;
  END;
 END {SrcWagePayLByMPG_WP};

 PUBLIC PROCEDURE _GetPayByMPG_WP(Silent  : SCAL[2];
                                  _MarkG  : LIKE(MPG_WP.MarkG);
                                  _Who    : LIKE(MPG_WP.Who);
                                  _JRgPayT: LIKE(MPG_WP.JRgPayT);
                                  _RWPay  : LIKE(MPG_WP.RWPay);
                                  _Date   : DATE;
                                  _Class  : LIKE(StaffLog.Class)): LIKE(WagePayL.Pay[0]);
 BEGIN
  IF SrcWagePayLByMPG_WP(Silent, _MarkG, _Who, _JRgPayT, _RWPay, _Date) THEN
   RETURN WagePayL.Pay[_Class];
  ELSE
   RETURN EMPTYOF(WagePayL.Pay[0]);
  END;
 END {_GetPayByMPG_WP};

 PUBLIC PROCEDURE GetPayByMPG_WP(_MarkG  : LIKE(MPG_WP.MarkG);
                                 _Who    : LIKE(MPG_WP.Who);
                                 _JRgPayT: LIKE(MPG_WP.JRgPayT);
                                 _RWPay  : LIKE(MPG_WP.RWPay);
                                 _Date   : DATE;
                                 _Class  : LIKE(StaffLog.Class)): LIKE(WagePayL.Pay[0]);
 BEGIN
  RETURN _GetPayByMPG_WP(0, _MarkG, _Who, _JRgPayT, _RWPay, _Date, _Class);
 END {GetPayByMPG_WP};

 PUBLIC PROCEDURE MCFixPay(_Date: DATE): NUMERIC[3];
  VAR
   _MarkG: LIKE(MarkG.MarkG);
 BEGIN
  L_General.Assert(L_Car.StandOnAnyMCFix(Staff.TSN, _Date),
                   " ९ ⮬   "+L_DatTim.DateStr(_Date)+"|⭨ "+Staff.TSN);
  L_General.Assert(~!MCFix.JRegime,
                   " ९ ⮬  㪠 ० ࠡ." +
                   "|⭨ "+Staff.TSN  + ",  " + MCFix.BoxNbr + ",  "+ L_DatTim.DateStr(MCFix.Begin));
  SAVE(Car);
  CONFORM(MCFix, Car);
  CONFORM(MCFix, JRegime);
  _MarkG:=L_Way.GetMarkG(Car.Mark, L_Way.mgt_WagePay);
  RESTORE(Car);
  RETURN GetPayByMPG_WP(_MarkG, L_Way.rwswho_Driver, JRegime.JRgPayT, L_Way.rwpay_Basic, _Date, StaffLog.Class);
 END {MCFixPay};

 PUBLIC PROCEDURE AcsMonthly(_Who   : LIKE(Monthly.Who);
                             _Source: LIKE(Monthly.Source);
                             _MtyIdx: LIKE(Monthly.MtyIdx)): LIKE(Monthly.Proof);
 BEGIN
  IF SEARCH(Monthly, TSN, Staff.TSN, Memo.gl_mb(), StaffLog.Date, _Who, _Source, _MtyIdx) THEN
   RETURN Monthly.Proof;
  ELSE
   RETURN 0;
  END;
 END {AcsMonthly};

 PUBLIC PROCEDURE AcsMonthlyFullOnPer(_Who   : LIKE(Monthly.Who);
                                      _MtyIdx: LIKE(Monthly.MtyIdx);
                                      _Period: DATE): LIKE(Monthly.Proof);
  VAR
   _Proof: LIKE(Monthly.Proof);
 BEGIN
  _Proof:=0;
  SELECT(Monthly, TSN, , Staff.TSN, _Period, StaffLog.Date, _Who);
  WHILE OCCURE(Monthly) DO
   IF Monthly.MtyIdx = _MtyIdx THEN
    _Proof:=_Proof+Monthly.Proof;
   END;
   NEXT(Monthly);
  END; (* WHILE OCCURE(Monthly) ... *)
  RETURN _Proof;
 END {AcsMonthlyFullOnPer};

 PUBLIC PROCEDURE AcsMonthlyFull(_Who   : LIKE(Monthly.Who);
                                 _MtyIdx: LIKE(Monthly.MtyIdx)): LIKE(Monthly.Proof);
 BEGIN
  RETURN AcsMonthlyFullOnPer(_Who, _MtyIdx, Memo.gl_mb());
 END {AcsMonthlyFull};

 PUBLIC PROCEDURE AcsMonthlyFullMonth(_Who   : LIKE(Monthly.Who);
                                      _Source: LIKE(Monthly.Source);
                                      _MtyIdx: LIKE(Monthly.MtyIdx);
                                      _Period: DATE): LIKE(Monthly.Proof);
  VAR
   _Proof: LIKE(Monthly.Proof);
 BEGIN
  _Proof:=0;
  SELECT(Monthly, MtyIdx, , _MtyIdx, _Period, Staff.TSN);
  WHILE OCCURE(Monthly) DO
   IF (_Who = Monthly.Who) & (_Source = Monthly.Source) THEN
    INC(_Proof, Monthly.Proof);
   END;
   NEXT(Monthly);
  END; (* WHILE OCCURE(Monthly) ... *)
  RETURN _Proof;
 END {AcsMonthlyFullMonth};

 PUBLIC PROCEDURE ClearMonthly(_TSN: LIKE(Staff.TSN); P: DATE; _Source: LIKE(Monthly.Source));
 BEGIN
  SELECT(Monthly, TSN, , _TSN, P);
  REMSEL(Monthly, Monthly.Source, _Source);
 END {ClearMonthly};

END.
