(*
%Copyright   (c) Polak IT
%Author      21.01.2008 11:26:42 POLAK\Gina
%Purpose       窮
%Type        library
%Specific    AP
%Modified    01.08.2014 18:04:09 POLAK\Gina
%Environment
*)

 MODULE L_APWI [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tVldPsgAmnt  = NUMERIC[2];
  tPlanIncome  = NUMERIC[2];
  tObjectP     = SCAL[2];
  tvpkInFact   = SCAL[3];
  tWho2IPCMode = SCAL[4];
  tpiScope     = SCAL[5];

 PUBLIC CONST
  ObjectP_Income = 0;
  ObjectP_VldPsg = 1;

  vif_SocMscw = 0;
  vif_SocOthr = 1;
  vif_AllCard = 2;

  w2im_toSetInRWayJ    = 0; (*tWho2IPCMode*)
  w2im_toPrintInRWayS  = 1;
  w2im_toPrintInTckRcS = 2;
  w2im_toAnalyze       = 3;

  piScope_RWOrdered = 0;
  piScope_RWTaxed   = 1;
  piScope_SEJobs    = 2;

 IMPORT L_Way, E_Way, L_APtm, L_General, L_Car, L_StdFrm, P_OwnData, L_EC, L_DatTim, P_Mark, Math;

 PUBLIC PROCEDURE E_FillVldPsgPlanFromVldPsgPlanG(D: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.FillVldPsgPlanFromVldPsgPlanG);
  IF ~!Local THEN
   IF ~OCCURE(StExit) THEN
    L_General.Assert(OCCURE(Route), " ⠭ 室");
   END;
   RETURN Local(D);
  ELSE
   RETURN 0;
  END;
 END {E_FillVldPsgPlanFromVldPsgPlanG};

 PUBLIC PROCEDURE CalcVldPsgPlanIsCancelled(D: LIKE(RWayS.Date); curIPCondition: L_Way.tIncPlanCondition): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(RouteIP);
  Result:=L_Way.AccessCurRouteIP(D, curIPCondition) & (RouteIP.Type = L_Way.ript_Canceled);
  RESTORE(RouteIP);
  RETURN Result;
 END {CalcVldPsgPlanIsCancelled};

 PUBLIC PROCEDURE GetUnitForRWayJPlan(_Date: DATE; _Cnd: L_Way.tIncPlanCondition): NUMERIC[3];
  VAR
   cpit: L_Way.tCalcPlInc;
 BEGIN
  IF L_Way.RealRWayJTrip() THEN
   cpit:=L_Way.E_CalcPlIncType(_Date, _Cnd);
   IF    cpit = L_Way.cpit_ByTime THEN
    RETURN RWayJ.StopT-RWayJ.StartT;   (*⥫쭮 ३*)
   ELSIF cpit = L_Way.cpit_ByTrip THEN
    RETURN RWayJ.Fact;                 (*३*)
   ELSIF cpit = L_Way.cpit_ByRun THEN
    RETURN RWayJ.Fact * RWayJ.Run;     (*஡  ३*)
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   RETURN 0;
  END;
 END {GetUnitForRWayJPlan};

 PUBLIC PROCEDURE Conv_IPCForVldPsgPlan(Date: DATE; _Cnd: L_Way.tIncPlanCondition): L_Way.tIncPlanCondition;
 BEGIN
  IF L_Way.E_VldPsgPlanLev(Date) & E_FillVldPsgPlanFromVldPsgPlanG(Date) & (_Cnd = E_Way.ipc_TermPlanDrv) THEN;
   RETURN E_Way.ipc_TermPlanGrd;
  ELSE
   RETURN _Cnd;
  END;
 END {Conv_IPCForVldPsgPlan};

 PUBLIC PROCEDURE ConvWithGu_to_IPCForVldPsg(WithGu: SCAL[3]): L_Way.tIncPlanCondition;
 BEGIN
  IF    WithGu = 0 THEN RETURN E_Way.ipc_TermPlanDrv;
  ELSIF WithGu = 1 THEN RETURN E_Way.ipc_TermPlanGrd;
  ELSIF WithGu = 2 THEN
   L_General.Assert(~!PROCREF(E_Way.ConvWith2Gu_to_IPCForVldPsg),
                    " ஥   ନ ᠦ஢   ஢.||"+
                    "᫨ ⢨⥫쭮   ६ ࠡ  ନ,|"+
                    "᫥ ᮮ ࠢ     ஢.          ||"+
                    " ᫥ ࠢ ⠪஢ ,  '⠫'.");
   RETURN E_Way.ConvWith2Gu_to_IPCForVldPsg(RWayS.Date);
  ELSE
   L_General.Error(" ।   ନ ᠦ஢|  祬  ஢");
  END;
 END {ConvWithGu_to_IPCForVldPsg};

 PUBLIC PROCEDURE E_RWayJPlanIsEqualFactAnyObject(_Date: DATE; _Object: tObjectP): SCAL[2];
  VAR
   default: SCAL[2];
   local  : PROC;
 BEGIN
  default:=P_OwnData.IsPlanEqualFactDay(RWayS.Date) | L_Way.CalcIncPlanIsCancelled(RWayS.Date) |
           SEARCH(RWayJP, RWayS, RWayJ.RWayS, RWayJ.Day, RWayJ.StartT, L_Way.rwjp_PlanIsEqualFact)&(RWayJP.Value>0);
  local:=PROCREF(E_Way.RWayJPlanIsEqualFact);
  IF ~!local THEN
   default:=local(_Date, _Object, default);
  END;
  RETURN default;
 END {E_RWayJPlanIsEqualFactVldPsg};

 PRIVATE PROCEDURE intCWD_ForExit(wdk: L_APtm.tWeekdayKind; trgExit: LIKE(StExit.Exit)): L_DatTim.tWeekday;
  CONST
   wd_Default = 8;
  VAR
   Result  : L_DatTim.tWeekday;
   wd      : SCAL[9];
   ExitMask: STRING[9];
   WDInc,
   WDWay   : SCAL[9];
   PlEqFc  : SCAL[2];
   CorrPlan: NUMERIC[1];
 BEGIN
  IF    wdk = L_APtm.wdk_toWay THEN Result:=Calendar.WDWay;
  ELSIF wdk = L_APtm.wdk_toInc THEN Result:=Calendar.WDInc;
  ELSE
   L_General.CallUs(0);
  END;
  P_OwnData.GetUnusualWayIncPlan(Calendar.Date, trgExit, ExitMask, WDInc, WDWay, PlEqFc, CorrPlan);
  IF ~!ExitMask THEN
   IF    wdk = L_APtm.wdk_toWay THEN wd:=WDWay;
   ELSIF wdk = L_APtm.wdk_toInc THEN wd:=WDInc;
   END;
   IF wd # wd_Default THEN
    Result:=wd;
   END;
  END;
  RETURN Result;
 END {intCWD_ForExit};

 PUBLIC PROCEDURE CWD_ForTrip(wdk    : L_APtm.tWeekdayKind;
                              _Exit  : LIKE(StExit.Exit);
                              D      : DATE;
                              _Day   : LIKE(SEJobs.Day);
                              _StartT: TIME): L_DatTim.tWeekday;
  CONST
   wd_Default = 8;
  VAR
   S     : STRING[];
   Result: L_DatTim.tWeekday;
 BEGIN
  IF wdk = L_APtm.wdk_toInc THEN
   D:=L_Way.GetDateOfTrip(D, _Day, _StartT);
  END;
  IF OCCURE(Calendar) & (D = Calendar.Date) THEN
   Result:=intCWD_ForExit(wdk, _Exit);
  ELSE
   SAVE(Calendar);
   SEARCH(Calendar, Date, , D);
   Result:=intCWD_ForExit(wdk, _Exit);
   RESTORE(Calendar);
  END;
  RETURN Result;
 END {CWD_ForTrip};

 PUBLIC PROCEDURE E_AnnulQualityWithPln(D: DATE; WithGu: SCAL[3]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.AnnulQualityWithPln);
  IF ~!Local THEN
   RETURN Local(D, ObjectP_VldPsg, Quality.Quality, WithGu);
  ELSE
   RETURN 0;
  END;
 END {E_AnnulQualityWithPln};

 PUBLIC PROCEDURE SetVldPsgPlans(VldPsgPlan: tVldPsgAmnt);
 BEGIN
  IF L_Way.E_VldPsgPlanLev(RWayS.Date) THEN
   IF VldPsgPlan = 0 THEN
    L_Way.RemoveRWayJP(E_Way.rwjp_TermPassPlan, L_Way.rwjpSrc_System);
   ELSE
    L_Way.SetRWayJP(E_Way.rwjp_TermPassPlan, VldPsgPlan, L_Way.rwjpSrc_System);
   END;
  END;
 END {SetVldPsgPlans};

 PUBLIC PROCEDURE ClearVldPsgPlans();
 BEGIN
  IF L_Way.E_VldPsgPlanLev(RWayS.Date) THEN
   CONFORM(RWayS, RWayJ);
   WHILE OCCURE(RWayJ) DO
    L_Way.RemoveRWayJP(E_Way.rwjp_TermPassPlan, L_Way.rwjpSrc_System);
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
  END;
 END {ClearVldPsgPlans};

 PRIVATE PROCEDURE GetRWaysVldPsgPlanFixedIPC(_ipc : L_Way.tIncPlanCondition;
                                              _Exit: LIKE(StExit.Exit);
                                              _TSN : LIKE(Staff.TSN)): tVldPsgAmnt;
  VAR
   IncPl: NUMERIC[2];
 BEGIN
  SETZERO(IncPl);
  TRY
   CONFORM(RWayS,  Car);
   L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
   CONFORM(CarLog, Mark);
   CONFORM(RWayS, Calendar);
   L_Way.PositionOnStExit(_Exit);
   CONFORM(StExit, SEJobs);
   WHILE OCCURE(SEJobs) DO
    IF (_ipc # E_Way.ipc_TermPlanGrd) | L_Way.SEJobsWithWLMGu(_TSN) THEN
     CONFORM(SEJobs, WJMode);
     CONFORM(SEJobs, Route);
     INC(IncPl, E_GetPlanIncomeScope(piScope_RWOrdered, RWayS.Date, _ipc));
    END;
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs) ... *)
  EXCEPT
  ON Exc: Exc_Root DO
   L_StdFrm.Choice("   室: "+_Exit+"|" + Exc.MsgOriginalText);
   (* 祣   *)
  END; (* TRY *)
  RETURN IncPl;
 END {GetRWaysVldPsgPlanFixedIPC};

 PRIVATE PROCEDURE IPCForGetExitVldPsgPlan(): L_Way.tIncPlanCondition;
 BEGIN
  RETURN ConvWithGu_to_IPCForVldPsg(SELECT(WayLMen, RWayS, RWayS.RWayS, L_Way.wlmwho_Guard));
 END {IPCForGetExitVldPsgPlan};

 PUBLIC PROCEDURE GetExitVldPsgPlan(): NUMERIC[2];
 BEGIN
  IF ~L_Way.E_VldPsgPlanLev(RWayS.Date) THEN
   RETURN 0;
  END;
  RETURN GetRWaysVldPsgPlanFixedIPC(IPCForGetExitVldPsgPlan(), RWayS.Exit, EMPTYOF(Staff.TSN));
 END {GetExitVldPsgPlan};

 PUBLIC PROCEDURE StandOnRWaySExit();
 BEGIN
  CONFORM(RWayS, StExit, ExitClss);
  IF ExitClss.BegType = L_Way.ecbt_Line THEN
   RETURN;
  ELSE
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayJ) DO
    CONFORM(RWayJ, SEJobs, StExit, ExitClss);
    IF ExitClss.BegType = L_Way.ecbt_Line THEN
     RETURN;
    END;
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
  END;
  CONFORM(RWayS, StExit);
 END {StandOnRWaySExit};

 PUBLIC PROCEDURE GetVldPsgPlanForTRS(): NUMERIC[2];
 BEGIN
  IF ~L_Way.E_VldPsgPlanLev(TckRcS.Date) THEN
   RETURN 0;
  END;
  IF TckRcS.AsWho = L_Way.trs_Chopper THEN
   RETURN 0;
  ELSE
   StandOnRWaySExit();
   RETURN GetRWaysVldPsgPlanFixedIPC(ConvWithGu_to_IPCForVldPsg(L_Way.E_GetIPCForTckRcSIncomePlan(TckRcS.Date)), StExit.Exit, TckRcS.TSN);
  END;
 END {GetVldPsgPlanForTRS};

 PUBLIC PROCEDURE GetTckRcSVldPsgPlan(): NUMERIC[2];
  VAR
   VldPsgPl: tVldPsgAmnt;
   i       : NUMERIC[0];
 BEGIN
  SAVE(RWayS);
  VldPsgPl:=0;
  i:=0;
  WHILE i <= HIGH(TckRcS.asRWayS) DO
   IF ~!TckRcS.asRWayS[i] THEN
    L_General.CallUs(SEARCH(RWayS, RWayS, TckRcS.asRWayS[i]));
    INC(VldPsgPl, GetVldPsgPlanForTRS());
   END;
   INC(i);
  END;
  RESTORE(RWayS);
  RETURN VldPsgPl;
 END {GetTckRcSVldPsgPlan};

 PUBLIC PROCEDURE TrVldPsgPlan(): LIKE(RWayJP.Value);
 BEGIN
  RETURN L_Way.GetRWJPByCode(E_Way.rwjp_TermPassPlan);
 END {TrVldPsgPlan};

 PUBLIC PROCEDURE TrVldPsgFact(trgDate: DATE; trgWho: L_Way.tRWSWho; trgNumber: LIKE(WayLMen.Number); trgTripNbr: L_RWayS.tTripAmount): tVldPsgAmnt;
  VAR
   Result: tVldPsgAmnt;
   tvpk  : tvpkInFact;
 BEGIN
  tvpk:=E_VPKInFactMethod(trgDate);
  Result:=L_RWayS.GetRWJP(trgTripNbr, L_Way.GetVldPsgRWJPro(L_Way.vpk_MoscowRegion, trgWho, trgNumber))+
          L_RWayS.GetRWJP(trgTripNbr, L_Way.GetVldPsgRWJPro(L_Way.vpk_Moscow,       trgWho, trgNumber));
  IF (tvpk = vif_SocOthr) | (tvpk = vif_AllCard) THEN
   INC(Result, L_RWayS.GetRWJP(trgTripNbr, L_Way.GetVldPsgRWJPro(L_Way.vpk_OtherSocial, trgWho, trgNumber)));
  END;
  IF (tvpk = vif_AllCard) THEN
   INC(Result, L_RWayS.GetRWJP(trgTripNbr, L_Way.GetVldPsgRWJPro(L_Way.vpk_Paid, trgWho, trgNumber)));
  END;
  RETURN Result;
 END {TrVldPsgFact};

 PUBLIC PROCEDURE CompleteVldPsgFact(_Date: DATE; trgTripNbr: L_RWayS.tTripAmount): tVldPsgAmnt;
 BEGIN
  RETURN TrVldPsgFact(_Date, L_Way.rwswho_Guard, 1, trgTripNbr)+
         TrVldPsgFact(_Date, L_Way.rwswho_Guard, 2, trgTripNbr)+
         TrVldPsgFact(_Date, L_Way.rwswho_Driver,  1, trgTripNbr)+
         TrVldPsgFact(_Date, L_Way.rwswho_Chopper, 1, trgTripNbr);
 END {CompleteVldPsgFact};

 PUBLIC PROCEDURE GetPlForIPC(curIPCondition: L_Way.tIncPlanCondition): NUMERIC[4];
 BEGIN
  RETURN E_GetPlanIncomeScope(piScope_RWTaxed, RWayS.Date, curIPCondition);
 END {GetPlForIPC};

 PUBLIC PROCEDURE CheckDoneTckRcs(B, E: DATE);
  VAR
   Msg: STRING[];
   Timing: NUMERIC[0];
 BEGIN
  Timing:=60;
  SETSEL(TckRcS, Done, 0);
  IF SRCINSEL(TckRcS, GE, B) & (TckRcS.Date <= E) THEN
   Msg:="| ࠡ⠭ ⭮- ." +
        "||ਬ,  " + TckRcS.TckRcS + "." +
        "|窠   " +
        "||" + "%<    ⬥    >Z    %< 믮 (%T) >FD";
   STDFORM(Msg, " ஢ઠ ࠡ⪨  ", INFORM, , Timing);
  END;
 END {CheckDoneTckRcs};

 PRIVATE PROCEDURE AccessIPlInCurrentIP(tcpi   : L_Way.ttcpi;
                                        _Day   : LIKE(RWayJ.Day);
                                        _StartT: LIKE(RWayJ.StartT));
 BEGIN
  IF tcpi = L_Way.tcpi_FromExit THEN
   SETSEL(ExitIPL, Exit, ExitIP.Exit, ExitIP.Date, ExitIP.Cnd);
   L_Way._AssertIP(SRCINSEL(ExitIPL, LE, _Day, _StartT),
                   "室 " + ExitIP.Exit,
                   ExitIP.Cnd, ExitIP.Date, _StartT);
  ELSE
   SETSEL(RouteIPL, Route, RouteIP.Route, RouteIP.Date, RouteIP.RoutCnd);
   L_Way._AssertIP(SRCINSEL(RouteIPL, LE, _Day, _StartT),
                   " " + RouteIP.Route,
                   RouteIP.RoutCnd, RouteIP.Date, _StartT);
  END;
 END {AccessIPlInCurrentIP};

 PRIVATE PROCEDURE GetUnitTotal(_Cnd : L_Way.tIncPlanCondition;
                                _Date: LIKE(RWayS.Date)): NUMERIC[5];
  VAR
   Result: NUMERIC[5];
   cpit  : L_Way.tCalcPlInc;
   Text  : STRING[];
 BEGIN
  cpit:=L_Way.E_CalcPlIncType(_Date, _Cnd);
  IF    cpit = L_Way.cpit_ByTime THEN
   Result:=StExit.PaidT;
   Text  :="६  ";
  ELSIF cpit = L_Way.cpit_ByTrip THEN
   Result:=StExit.TripAm;
   Text  :="⢮ ३ᮢ";
  ELSIF cpit = L_Way.cpit_ByRun THEN
   Result:=StExit.PaidRun;
   Text  :="⭮ ६";
  ELSE
   L_General.CallUs(0);
  END;
  L_General.Assert(Result > 0, "㫥 "+Text+"  室 " + StExit.Exit);
  RETURN Result;
 END {GetUnitTotal};

 PRIVATE PROCEDURE Cur_ipt(tcpi: L_Way.ttcpi; trg_ipt: SCAL[32]): SCAL[2];
 BEGIN
  IF    tcpi = L_Way.tcpi_FromExit THEN
   RETURN ExitIP.Type = trg_ipt;
  ELSE
   IF    trg_ipt = L_Way.ipt_OnTrip THEN
    RETURN RouteIP.Type = L_Way.ript_OnTrip;
   ELSIF trg_ipt = L_Way.ipt_OnHour THEN
    RETURN RouteIP.Type = L_Way.ript_OnHour;
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {Cur_ipt};

 PRIVATE VAR
  gpi_curRWayS: LIKE(RWayS.RWayS);
  gpi_curExit : LIKE(StExit.Exit);
  gpi_curCnd  : L_Way.tIncPlanCondition;
  gpi_totPlan : tPlanIncome;
  gpi_totUnit : NUMERIC[3];

 PRIVATE PROCEDURE GetPI(_Cnd   : L_Way.tIncPlanCondition;
                         _Date  : LIKE(RWayS.Date);
                         _Day   : LIKE(RWayJ.Day);
                         _StartT: LIKE(RWayJ.StartT);
                         _StopT : LIKE(RWayJ.StopT);
                         _WDWay : L_DatTim.tWeekday;
                         _WUnit : NUMERIC[3];
                         pis    : tpiScope): tPlanIncome;
  VAR
   PrvIP,
   _IncPl       : NUMERIC[2];
   _PasVolArr   : L_Way.tPVArr;
   BT, ET,
   NT, PlTim,
   OneTripTime  : NUMERIC[3];
   TripStartT,
   prvTripStartT: TIME;
   tcpi         : L_Way.ttcpi;
   partOfWhole  : FLOAT;
   NeedDec_gpi_tot,
   NeedInit     : SCAL[2];
   Local        : PROC;
 BEGIN
  tcpi:=L_Way.GetTypeOfCalcIncPlan(_Cnd, _Date, _StartT);
  IF L_Way.AccessIPL(tcpi, _Cnd, _Date, _Day, _StartT) THEN
   _PasVolArr[0]:=P_Mark.GetP_PVLim(Mark.Mark, _Date);
   _PasVolArr[1]:=P_Mark.GetP_PVSitting(Mark.Mark, _Date);

   SETEMPTY(_IncPl); NeedDec_gpi_tot:=0;

   IF E_NeedChangePlanDuringTrip(_Date, _Cnd) THEN
    IF Cur_ipt(tcpi, L_Way.ipt_OnTrip) THEN
     _IncPl:=0;
     IF StExit.Strict = L_Way.ExitStrict_Reg THEN
      SAVE(SEJobs);
      TripStartT :=_StartT; PrvIP:=0;
      SETSEL(SEJobs, Exit, StExit.Exit);
      IF ~SRCINSEL(SEJobs, LE, _Day, _StartT) THEN
       FIRST(SEJobs);
      END;
      WHILE OCCURE(SEJobs) & (_WUnit > 0) DO
       DEC(_WUnit, 1);
       AccessIPlInCurrentIP(tcpi, _Day, TripStartT);
       PrvIP:=L_Way.IncPlant_cpi(tcpi, _WDWay, _PasVolArr, _Date, _Cnd);
       INC(_IncPl, PrvIP);
       IF NEXT(SEJobs) THEN
        _Day      :=SEJobs.Day;
        TripStartT:=SEJobs.StartT;
       END;
      END; (* WHILE OCCURE(SEJobs) &  *)
      RESTORE(SEJobs);
      INC(_IncPl, PrvIP * _WUnit);
     ELSE
      OneTripTime:=(_StopT - _StartT) / _WUnit;
      TripStartT :=_StartT;
      WHILE _WUnit > 0 DO
       DEC(_WUnit, 1);
       AccessIPlInCurrentIP(tcpi, _Day, TripStartT);
       INC(_IncPl, L_Way.IncPlant_cpi(tcpi, _WDWay, _PasVolArr, _Date, _Cnd));
       prvTripStartT:=TripStartT;
       INC(TripStartT, OneTripTime);
       IF prvTripStartT > TripStartT THEN
        INC(_Day);
       END;
      END;
     END; (* IF StExit.Strict = ExitStrict_Reg... *)
    ELSIF Cur_ipt(tcpi, L_Way.ipt_OnHour) THEN
     _IncPl:=0;
     BT:=L_Way.FullBegTime(_Day, _StartT);
     ET:=L_Way.FullEndTime(_Day, _StartT, _StopT);
     WHILE BT#ET DO
      PrvIP:=L_Way.IncPlant_cpi(tcpi, _WDWay, _PasVolArr, _Date, _Cnd);
      IF tcpi = L_Way.tcpi_FromExit THEN
       IF ~NEXT(ExitIPL) THEN
        PlTim:=ET-BT;
       ELSE
        NT:=L_Way.FullBegTime(ExitIPL.Day, ExitIPL.Time);
        PlTim:=Math.Min(ET-BT, NT-BT);
       END;
      ELSE
       IF ~NEXT(RouteIPL) THEN
        PlTim:=ET-BT;
       ELSE
        NT:=L_Way.FullBegTime(RouteIPL.RoutDay, RouteIPL.RoutTime);
        PlTim:=Math.Min(ET-BT, NT-BT);
       END;
      END;
      INC(_IncPl, PrvIP * PlTim);
      INC(BT, PlTim);
     END; (* WHILE BT#ET... *)
    END;
   END; (* IF E_NeedChangePlanDuringTrip... *)

   IF !_IncPl THEN
    _IncPl:=L_Way.IncPlant_cpi(tcpi, _WDWay, _PasVolArr, _Date, _Cnd);
    IF tcpi = L_Way.tcpi_FromExit THEN
     IF    (ExitIP.Type = L_Way.ipt_OnTrip) | (ExitIP.Type = L_Way.ipt_OnHour) THEN
      _IncPl:= _IncPl * _WUnit;
     ELSIF ExitIP.Type = L_Way.ipt_OnWholeExit THEN
      partOfWhole:=_WUnit / GetUnitTotal(_Cnd, _Date);
      IF    (_Date >= 01\03\2011) & ((pis = piScope_RWOrdered) | (pis = piScope_RWTaxed)) THEN
       NeedInit:=(gpi_curExit # ExitIP.Exit) | (gpi_curCnd # _Cnd) | (gpi_curRWayS # RWayS.RWayS);
      ELSIF _Date >= 01\09\2010 THEN
       NeedInit:=(gpi_curExit # ExitIP.Exit) | (gpi_curCnd # _Cnd);
      ELSE
       NeedInit:=1;
      END;
      IF NeedInit THEN
       IF (pis = piScope_RWOrdered) | (pis = piScope_RWTaxed) THEN
        gpi_curRWayS:=RWayS.RWayS;
       END;
       gpi_curExit :=ExitIP.Exit;
       gpi_curCnd  :=_Cnd;
       gpi_totPlan :=_IncPl;
       gpi_totUnit :=GetUnitTotal(_Cnd, _Date);
      ELSE
       IF (Math.Abs(_WUnit - gpi_totUnit) < 1/60) & (Math.Abs(_IncPl * partOfWhole-gpi_totPlan) < 0.50) THEN
        _IncPl:=gpi_totPlan;
        partOfWhole:=1;
        SETEMPTY(gpi_curRWayS, gpi_curExit, gpi_curCnd);
       END;
      END;
      _IncPl:=_IncPl * partOfWhole;
      NeedDec_gpi_tot:=1;
     ELSE
      L_General.CallUs(0);
     END;
    ELSE
     _IncPl:=_IncPl * _WUnit;
    END;
   END;

   Local:=PROCREF(E_Way.GetPlanIncomeScope);
   IF ~!Local THEN
    _IncPl:=Local(_IncPl, pis, _Date, _Cnd);
   END;
   IF NeedDec_gpi_tot THEN
    DEC(gpi_totPlan, _IncPl);
    DEC(gpi_totUnit, _WUnit);
   END;
   RETURN _IncPl;
  ELSE
   RETURN 0;
  END; (* IF WJMode.IncSel ... *)
 END {GetPI};

 PRIVATE PROCEDURE GetPlanIncome(_Cnd   : L_Way.tIncPlanCondition;
                                 _Date  : LIKE(RWayS.Date);
                                 _Day   : LIKE(RWayJ.Day);
                                 _StartT: LIKE(RWayJ.StartT);
                                 _StopT : LIKE(RWayJ.StopT);
                                 _WDWay : L_DatTim.tWeekday;
                                 _WUnit : NUMERIC[3];
                                 pis    : tpiScope): tPlanIncome;
  VAR
   Pl: NUMERIC[2];
 BEGIN
  Pl:=GetPI(_Cnd, _Date, _Day, _StartT, _StopT, _WDWay, _WUnit, pis);
  RETURN Pl * (1 + P_OwnData.IncPlanCorr(_Date) / 100);
 END {GetPlanIncome};

 PUBLIC PROCEDURE E_TrVldPsgFact(_Date: DATE; _Who: L_Way.tRWSWho; _Number: LIKE(WayLMen.Number);
                                 Permit: SCAL[2]; trgTripNbr: L_RWayS.tTripAmount): tVldPsgAmnt;
  VAR
   Result: tVldPsgAmnt;
   Local : PROC;
 BEGIN
  IF ~Permit THEN
   RETURN 0;
  END;
  IF (_Who = L_Way.rwswho_Driver) & E_ApplyGuToDrvAnyObject(_Date, ObjectP_VldPsg) THEN
   Result:=CompleteVldPsgFact(_Date, trgTripNbr);
  ELSE
   Result:=TrVldPsgFact(_Date, _Who, _Number, trgTripNbr);
  END;
  Local:=PROCREF(E_Way.TrVldPsgFact);
  IF ~!Local THEN
   RETURN Local(Result, _Date, _Who, _Number, trgTripNbr);
  ELSE
   RETURN Result;
  END;
 END {E_TrVldPsgFact};

 PUBLIC PROCEDURE E_ApplyGuToDrvAnyObject(_Date: DATE; _Object: tObjectP): SCAL[2];
  VAR
   default: SCAL[2];
   local  : PROC;
 BEGIN
  IF    _Object = ObjectP_Income THEN
   default:=L_APtm.IsMTA();
  ELSIF _Object = ObjectP_VldPsg THEN
   default:=0;
  ELSE
   L_General.CallUs(0);
  END;
  local:=PROCREF(E_Way.ApplyGuIncToDrv);
  IF ~!local THEN
   default:=local(_Date, _Object, default);
  END;
  RETURN default;
 END {E_ApplyGuToDrvAnyObject};

 PUBLIC PROCEDURE E_VldPsgPlanMultiplier(_Date: DATE; Cnt: NUMERIC[0]): NUMERIC[6];
  VAR
   Local: PROC;
 BEGIN
  IF Cnt = 1 THEN
   RETURN 1;
  ELSE
   L_General.CallUs(Cnt >= 2);
   L_General.CallUs(OCCURE(WayLMen) & OCCURE(RWayJ));
   Local:=PROCREF(E_Way.VldPsgPlanMultiplier);
   IF ~!Local THEN
    RETURN Local(Cnt);
   ELSE
    RETURN 1/Cnt;
   END;
  END;
 END {E_VldPsgPlanMultiplier};

 PRIVATE PROCEDURE E_VPKInFactMethod(_Date: DATE): tvpkInFact;
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(_Date, PROCREF(E_Way.VPKInFactMethod), vif_SocOthr);
 END {E_VPKInFactMethod};

 PUBLIC PROCEDURE E_IndividualIPl(D: DATE; Who: L_Way.tRWSWho; GuardCnt: NUMERIC[0]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.IndividualIPl);
  IF ~!Local THEN
   RETURN Local(D, Who, GuardCnt);
  ELSE
   RETURN 0;
  END;
 END {E_IndividualIPl};

 PUBLIC PROCEDURE E_trsWho2IPC(): L_Way.tIncPlanCondition;
  VAR
   Result: L_Way.tIncPlanCondition;
   Local : PROC;
 BEGIN
  IF    TckRcS.AsWho = L_Way.trs_Driver  THEN Result:=L_Way.ipc_Driver;
  ELSIF TckRcS.AsWho = L_Way.trs_Guard   THEN Result:=L_Way.ipc_Guard;
  ELSIF TckRcS.AsWho = L_Way.trs_Chopper THEN
   Result:=L_Way.ipc_UserDefined;
   IF ~!TckRcS.AsWhoCnd THEN
    INC(Result, TckRcS.AsWhoCnd);
   END;
  END;
  Local:=PROCREF(E_Way.trsWho2IPC);
  IF ~!Local THEN
   Result:=Local(Result);
  END;
  RETURN Result;
 END {E_trsWho2IPC};

 PUBLIC PROCEDURE E_rwsWho2IPC(Mode: tWho2IPCMode; _Who: L_Way.tRWSWho; Amount: NUMERIC[2]): L_Way.tIncPlanCondition;
  VAR
   Result: L_Way.tIncPlanCondition;
   Local : PROC;
 BEGIN
  IF    _Who = L_Way.rwswho_Driver THEN
   Result:=L_Way.ipc_Driver;
  ELSIF _Who = L_Way.rwswho_Guard THEN
   IF Amount = 2 THEN
    Result:=L_Way.ipc_TwoGuards;
   ELSE
    Result:=L_Way.ipc_Guard;
   END;
  ELSIF _Who = L_Way.rwswho_Chopper THEN
   L_General.CallUs(Mode = w2im_toAnalyze);
   Result:=E_trsWho2IPC();
  ELSIF _Who = L_Way.rwswho_Dr_W_Gu THEN
   L_General.CallUs(0);
  ELSE
   SETEMPTY(Result);
  END;
  Local:=PROCREF(E_Way.rwsWho2IPC);
  IF ~!Local THEN
   Result:=Local(Mode, _Who, Amount, Result);
  END;
  RETURN Result;
 END {E_rwsWho2IPC};

 PUBLIC PROCEDURE E_getIPC_ForRWayJ_PlIncome(WithGu: SCAL[3]): L_Way.tIncPlanCondition;
 BEGIN
  IF    WithGu = 0 THEN RETURN E_rwsWho2IPC(w2im_toSetInRWayJ, L_Way.rwswho_Driver, 1);
  ELSIF WithGu = 1 THEN RETURN E_rwsWho2IPC(w2im_toSetInRWayJ, L_Way.rwswho_Guard,  1);
  ELSIF WithGu = 2 THEN RETURN E_rwsWho2IPC(w2im_toSetInRWayJ, L_Way.rwswho_Guard,  2);
  ELSE
   L_General.CallUs(0);
  END;
 END {E_getIPC_ForRWayJ_PlIncome};

 PUBLIC PROCEDURE intGetPlanIncomeScope(pis  : tpiScope;
                                        D    : DATE;
                                        ipc  : L_Way.tIncPlanCondition;
                                        WDWay: L_DatTim.tWeekday): tPlanIncome;
  VAR
   defaultPI: tPlanIncome;
   _Day     : LIKE(SEJobs.Day);
   _StartT  : LIKE(SEJobs.StartT);
   _StopT   : LIKE(SEJobs.StopT);
 BEGIN
  L_Way.E_GetTimesForPlInc(D, _Day, _StartT, _StopT, pis);
  IF !WDWay THEN
   WDWay:=CWD_ForTrip(L_APtm.wdk_toInc, SEJobs.Exit, D, _Day, _StartT);
  END;
  IF    pis = piScope_RWOrdered THEN
   defaultPI:=GetPlanIncome(ipc, D, _Day, _StartT, _StopT, WDWay,
                            L_Way.GetUnitForPlan(D, ipc),
                            pis);
  ELSIF pis = piScope_RWTaxed THEN
   defaultPI:=GetPlanIncome(ipc, D, _Day, _StartT, _StopT, WDWay,
                            GetUnitForRWayJPlan(D, ipc),
                            pis);
  ELSIF pis = piScope_SEJobs THEN
   defaultPI:=GetPlanIncome(ipc, D, _Day, _StartT, _StopT, WDWay,
                            L_Way.GetUnitForPlan(D, ipc),
                            pis);
  ELSE
   L_General.CallUs(0);
  END;
  RETURN defaultPI;
 END {intGetPlanIncomeScope};

 PUBLIC PROCEDURE E_GetPlanIncomeScope(pis: tpiScope; D: DATE; ipc: L_Way.tIncPlanCondition): tPlanIncome;
 BEGIN
  RETURN intGetPlanIncomeScope(pis, D, ipc, EMPTYOF(L_DatTim.tWeekday));
 END {E_GetPlanIncomeScope};

 PUBLIC PROCEDURE GetPlanIncomeForRWayJ(WithGu: NUMERIC[0]): tPlanIncome;
 BEGIN
  RETURN E_GetPlanIncomeScope(piScope_RWTaxed, RWayS.Date, E_getIPC_ForRWayJ_PlIncome(WithGu));
 END {GetPlanIncomeForRWayJ};

 PRIVATE PROCEDURE E_NeedChangePlanDuringTrip(_Date: DATE; _Cnd: L_Way.tIncPlanCondition): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.NeedChangePlanDuringTrip);
  IF ~!Local THEN
   RETURN Local(_Date, _Cnd);
  ELSE
   RETURN 0;
  END;
 END {E_NeedChangePlanDuringTrip};

BEGIN
 SETEMPTY(gpi_curExit, gpi_curCnd, gpi_curRWayS);
END.
