(*
%Copyright   (c) Polak Computer System
%Author      06.09.1999 18:13:56 BOR
%Purpose      । ९ ⥫
%Type        library
%Specific    AP
%Modified    01.08.2014 13:24:25 POLAK\GAV
%Environment
*)

 MODULE L_BegRWS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tDayType               = SCAL[10];
  tDayChange             = SCAL[4];
  tMPKind                = SCAL[3];
  tMPValue               = SCAL[1E4];
  tMPStatus              = SCAL[3];
  tCrewFitnessForExit    = SCAL[6];
  tECFixMethod           = SCAL[2];
  tSource                = SCAL[4];
  tAutorizeToRouteMethod = SCAL[3];
  tPermit                = SCAL[3];

 PUBLIC CONST
  dt_WholeDay    = 0;
  dt_FirstShift  = 1;
  dt_SecondShift = 2;
  dc_NotWork     = 3;

  dt_Relaxation  = 6;
  dt_Absence     = 7;
  dt_NotInState  = 8;
  dt_NotDefined  = 9;


  twosrc_Operator = 0;
  twosrc_Regime   = 1;
  twosrc_System   = 2;
  twosrc_Auto     = 3;

  wh_Pool = "|1|2| | | |||.|";
  sr_Pool = "||";

  mpk_Car    = 0;
  mpk_Driver = 1;
  mpk_Guard  = 2;

  mpk_Pool = "|⥫|";

  mps_Available = 0;
  mps_CndAvl    = 1;
  mps_NotAvl    = 2;

  cs_Amount = 3;

  csi_Current = 0; (*CarStateIdx*)
  csi_Past    = 1;
  csi_Future  = 2;

  svi_Mechanic = "Mechanic";

  ubcslev_DispOnly       = 0;
  ubcslev_Disp_w_OutPost = 1;
  ubcslev_Full           = 2;
  ubcslev_UserDefined    = 3;

  ubcr_Dispatcher = 0;
  ubcr_Outpost    = 1;
  ubcr_Mechanic   = 2;
  ubcr_Medic      = 3;

  cffe_Yes            = 0; (* tCrewFitnessForExit *)
  cffe_NotInAutoMake  = 1;
  cffe_wChoice        = 2;
  cffe_No             = 3;
  cffe_wInform        = 4;
  cffe_wCrucialChoice = 5;

  cffeR_MyFirmContradiction     = "⭨    ࠧ ' ࣠権'";
  cffeR_DoesNotAuthorizedToExit = "⭨   ᪠  ࠡ  室";
  cffeR_BadCarPsgVolume         = "⨬   ᮮ⢥ 室";
  cffeR_BadCarLicenCard         = "  祭 業 窮";
  cffeR_BadCarCheckup           = "  諮 孨᪨ ᬮ";
  cffeR_BadCarCLIO              = "   饣  ";
  cffeR_BadCarKACKO             = "   饣  ";
  cffeR_BadCategory             = "⭨   ⮩ ⥣ਨ   ";
  cffeR_BadDriveSertificate     = "⭨  祭 㤮⮢७";
  cffeR_BadMedicSertificate     = "⭨  祭 樭᪮ ࠢ";
  cffeR_Prohibited              = "⭨     拉";
  cffeR_BadRestTime             = "筮 ६   ᬥ";
  cffeR_GuardProhibitedInExit   = " 室 饭 ";
  cffeR_GuardRequiredInExit     = " 室 易⥫ ";
  cffeR_GuardInNotLineExit      = "  室,  ⭮饬    १";

  ecfm_Single = 0;
  ecfm_Decade = 1;
  ecfm_Distr  = 2;

  atrm_No         = 0;
  atrm_ByProperty = 1;
  atrm_ByEDO      = 2;

  atr_No      = 0;
  atr_Yes     = 1;
  atr_NotNeed = 2;

 PUBLIC PERMANENT VAR
  ToBeVerifiedRWaySCnt: NUMERIC[0];

 IMPORT L_General, L_DatTim, Str, P_Staff, E_Way, L_Str, L_Env, L_Way,
        L_EC, Math, L_XDoc, L_Rpr, P_OwnData, D_Staff, L_StdFrm, L_SES,
        L_CWOrder, L_BarCode, L_Car, P_Mark, L_RT, L_EDO, P_EDOL, L_AFM,
        L_two, P_Man, P_Car, L_Prop, P_Sort, L_Staff, L_Man, L_AR,
        L_RWayS, DBD, L_APtm;

 PUBLIC CONST
  action_EditInTWO = L_XDoc.action_UserDefined + 0;

 PRIVATE PROCEDURE DECADE(D: DATE): SCAL[3];
  VAR
   _Day: NUMERIC[0];
 BEGIN
  _Day:=L_DatTim.DAY(D);
  IF    _Day <= 10 THEN RETURN 0;
  ELSIF _Day <= 20 THEN RETURN 1;
  ELSE                  RETURN 2;
  END;
 END {DECADE};

 PRIVATE PROCEDURE DateDiffInMonth(D2, D1: DATE): NUMERIC[0];
 BEGIN
  RETURN (L_DatTim.YEAR(D2)*12+L_DatTim.MONTH(D2)) - (L_DatTim.YEAR(D1)*12+L_DatTim.MONTH(D1));
 END {DateDiffInMonth};

 PRIVATE PROCEDURE dec_GetWorkDateBefore(trgTSN: LIKE(Staff.TSN); D: DATE; i: NUMERIC[0]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=0;
  WHILE i > 0 DO
   INC(Result, IsWorkDayType(intGetDayTypeByRegime(trgTSN, D, D-i)));
   DEC(i);
  END;
  RETURN Result;
 END {dec_GetWorkDateBefore};

 PRIVATE PROCEDURE GetFirstWorkDateAfter(trgTSN: LIKE(Staff.TSN); D, curD: DATE): DATE;
  VAR
   srcDate: DATE;
 BEGIN
  IF AccessDayTypeByRegime(trgTSN, D) THEN
   srcDate:=D;
   CONFORM(RegList, RegHead);
   WHILE D <= curD DO
    IF IsWorkDayType(intGetDayTypeByRegime(trgTSN, D, D)) THEN
     RETURN D;
    END;
    INC(D);
   END; (* WHILE D <= curD *)
   L_General.Assert(D <= curD, "    ࠡ祣  ᫥ " + L_DatTim.DateStr(srcDate));
  END;
  RETURN D;
 END {GetFirstWorkDateAfter};

 PRIVATE PROCEDURE GetWorkDaySeqNbr(trgTSN: LIKE(Staff.TSN); fromD, onD: DATE): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  IF AccessDayTypeByRegime(trgTSN, onD) THEN
(* 
    fromD:=Math.Max(fromD, StaffPro.Date);
*)
   CONFORM(RegList, RegHead);
   Result:=dec_GetWorkDateBefore(trgTSN, onD, (onD - fromD) MOD RegHead.Cycle);
   IF (onD - fromD) >= RegHead.Cycle THEN
    INC(Result, ((onD - fromD) DIV RegHead.Cycle) * dec_GetWorkDateBefore(trgTSN, onD, RegHead.Cycle));
   END;
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {GetWorkDaySeqNbr};

 PRIVATE PROCEDURE intAccessDayTypeByRegime(trgTSN: LIKE(StaffLog.TSN);
                                            rgD,
                                            dtD   : DATE): SCAL[2];
  VAR
   trgRegime: LIKE(RegList.Regime);
   trgShift : NUMERIC[0];
   Result   : SCAL[2];
 BEGIN
  P_Staff.GetP_RegimeForMkBegRWS(trgTSN, rgD, trgRegime, trgShift);
  IF ~!trgRegime THEN
   INC(dtD, trgShift);
   L_General.Assert(SEARCH(RegList, HumReg, trgRegime, L_DatTim.Per(dtD), L_DatTim.DAY(dtD)),
                    "  䨪 ࠡ " + trgRegime + "|ࠡ⭨ " + trgTSN + "| " + L_DatTim.DateStr(dtD));
   Result:=1;
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {intAccessDayTypeByRegime};

 PUBLIC PROCEDURE AccessDayTypeByRegime(trgTSN: LIKE(StaffLog.TSN); D: DATE): SCAL[2];
 BEGIN
  RETURN intAccessDayTypeByRegime(trgTSN, D, D);
 END {AccessDayTypeByRegime};

 PRIVATE PROCEDURE intGetDayTypeByRegime(trgTSN: LIKE(StaffLog.TSN); rgD, dtD: DATE): tDayType;
 BEGIN
  IF intAccessDayTypeByRegime(trgTSN, rgD, dtD) THEN
   IF    RegList.JMode = 35 THEN
    RETURN dt_FirstShift;
   ELSIF RegList.JMode = 36 THEN
    RETURN dt_SecondShift;
   ELSIF RegList.JMode = 37 THEN
    RETURN dt_WholeDay;
   ELSIF RegList.JMode = 38 THEN
    RETURN dt_Relaxation;
   ELSE
    RETURN dt_NotDefined;
   END;
  ELSE
   RETURN dt_NotDefined;
  END;
 END {intGetDayTypeByRegime};

 PUBLIC PROCEDURE GetDayTypeByRegime(trgTSN: LIKE(StaffLog.TSN); D: DATE): tDayType;
  VAR
   Result : tDayType;
   fixedEC: LIKE(ExitClss.ExitClss);
   Dummy  : tECFixMethod;
 BEGIN
  Result:=intGetDayTypeByRegime(trgTSN, D, D);
  IF (Result = dt_WholeDay) & ((L_General.GetAPSiteID() = "SP") | (L_General.GetAPSiteID() = "ZV")) THEN
   intGetFixedEC(trgTSN, D, fixedEC, Dummy);
   IF ~!fixedEC & ~L_two.IsWholeDayExitClss(fixedEC, D) & L_two.StandOnExit(fixedEC, dt_FirstShift, D, 0) THEN
    Result:=dt_FirstShift;
   END;
  ELSIF IsWorkDayType(Result) & (L_General.GetAPSiteID() = "KL") THEN
   intGetFixedEC(trgTSN, D, fixedEC, Dummy);
   IF fixedEC = 906001 THEN
    Result:=dt_Relaxation;
   END;
  END;
  RETURN Result;
 END {GetDayTypeByRegime};

 PUBLIC PROCEDURE E_TWOLevel(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.TWOLevel), 1);
 END {E_TWOLevel};

 PUBLIC PROCEDURE GetDayType(trgTSN: LIKE(StaffLog.TSN); D: DATE): tDayType;
 BEGIN
  RETURN GetDayTypeByRegime(trgTSN, D);
 END {GetDayType};

 PUBLIC PROCEDURE IsWorkDayType(_DayType: tDayType): SCAL[2];
 BEGIN
  RETURN (_DayType = dt_WholeDay   ) |
         (_DayType = dt_FirstShift ) |
         (_DayType = dt_SecondShift) ;
 END {IsWorkDayType};

 PUBLIC PROCEDURE PosToSortOfStaff(D: DATE);
  VAR
   _Sort: LIKE(Sort.Sort);
 BEGIN
  _Sort:=P_Staff.GetP_SortForMkBegRWS(Staff.TSN, D);
  IF ~!_Sort THEN
   IF ~SEARCH(Sort, Sort, _Sort) THEN
    L_General.Error(" ᢮⢥ " + L_Str.FixedIntStr(P_Staff.P_SortForMkBegRWS, 4) +
                    " ࠡ⭨ " + Staff.TSN +
                    "|㪠 騩 ᥪ " + _Sort);
   END;
  ELSE
   SAVE(StaffLog);
   L_Staff.PosToStaffLog(Staff.TSN, D, 1);
   CONFORM(StaffLog, Sort);
   RESTORE(StaffLog);
  END;
 END {PosToSortOfStaff};

 PUBLIC PROCEDURE GetSortOfStaff(trgTSN: LIKE(Staff.TSN); D: DATE): LIKE(Sort.Sort);
  VAR
   Result: LIKE(Sort.Sort);
 BEGIN
  SAVE(Staff);
  SAVE(Sort);
  SEARCH(Staff, TSN, , trgTSN);
  PosToSortOfStaff(D);
  Result:=Sort.Sort;
  RESTORE(Sort);
  RESTORE(Staff);
  RETURN Result;
 END {GetSortOfStaff};

 PUBLIC PROCEDURE intGetFixedEC(    trgTSN     : LIKE(Staff.TSN);
                                    D          : DATE;
                                VAR trgExitClss: LIKE(ExitClss.ExitClss);
                                VAR ecfm       : tECFixMethod);
  VAR
   FixingType                : SCAL[3];
   _DayType                  : tDayType;
   curExitClss,
   FullDayScheduleExitClss,
   ChangeableScheduleExitClss: LIKE(ExitClss.ExitClss);
   Cycle                     : SCAL[4];
   CycleLen,
   CycleECAmount,
   IdxInCycle                : NUMERIC[0];
   CycleInWorkDays,
   GroupCycle                : P_Sort.tgcwo;
   arrExitClss               : LIKE(ExitClss.ExitClss)[P_Sort.MaxCntExitClss];
   ec4twoDate,
   GroupCycleStartDate       : DATE;
   GroupCycleStartECIdx      : NUMERIC[0];
 BEGIN
  SETEMPTY(trgExitClss, ecfm);
  IF P_Staff.HasActualStaffPro(trgTSN, D, P_Staff.P_ExitClass4two) THEN
   ec4twoDate:=StaffPro.Date;
   P_Staff.Decode_ExitClass4two(StaffPro.Value, 1, FixingType, FullDayScheduleExitClss, ChangeableScheduleExitClss,
                                Cycle, CycleLen, arrExitClss, GroupCycle, GroupCycleStartECIdx, GroupCycleStartDate);
   IF    FixingType = P_Staff.ec4twoft_Individual THEN
    ecfm    :=ecfm_Single;
    _DayType:=intGetDayTypeByRegime(trgTSN, D, D);
    IF (_DayType = dt_FirstShift) | (_DayType = dt_SecondShift) THEN
     trgExitClss:=ChangeableScheduleExitClss;
    ELSE
     trgExitClss:=FullDayScheduleExitClss;
    END;
   ELSIF FixingType = P_Staff.ec4twoft_Cyclic THEN
    ecfm         :=ecfm_Decade;
    CycleECAmount:=0;
    WHILE ~!arrExitClss[CycleECAmount] DO
     INC(CycleECAmount);
    END;
    L_General.Assert(CycleECAmount >= 0, "୮  ९.|. " + trgTSN);
    IF    Cycle = P_Staff.ec4twoc_ByRegime THEN
     IdxInCycle:=GetWorkDaySeqNbr(trgTSN, ec4twoDate, D) MOD CycleECAmount;
    ELSIF Cycle = P_Staff.ec4twoc_Decade   THEN
     IdxInCycle:=(DateDiffInMonth(D, ec4twoDate)*3 - DECADE(ec4twoDate) + DECADE(D)) MOD CycleECAmount;
    ELSIF Cycle = P_Staff.ec4twoc_Month    THEN
     IdxInCycle:=((L_DatTim.YEAR(D) * 12         + L_DatTim.MONTH(D)) -
                 (L_DatTim.YEAR(ec4twoDate) * 12 + L_DatTim.MONTH(ec4twoDate)))
                MOD CycleECAmount;
    ELSIF Cycle = P_Staff.ec4twoc_Special  THEN
     IdxInCycle:=(D - ec4twoDate) MOD (CycleLen * CycleECAmount) DIV CycleLen;
    END;
    trgExitClss:=arrExitClss[IdxInCycle];
    IF !trgExitClss | (trgExitClss = 0) THEN
     SETEMPTY(trgExitClss);
    END;
   ELSIF FixingType = P_Staff.ec4twoft_InSector THEN
    ecfm:=ecfm_Decade;
    P_Sort.GetGroupCycleWO(GetSortOfStaff(trgTSN, D), D, arrExitClss, CycleLen, CycleInWorkDays, GroupCycle);
    CycleECAmount:=0;
    FOR_EACH curExitClss IN arrExitClss DO
     INC(CycleECAmount);
    END;
    IF CycleECAmount > 0 THEN
     IF    ~!GroupCycleStartECIdx THEN
      IF CycleInWorkDays THEN
       IdxInCycle:=(GroupCycleStartECIdx + GetWorkDaySeqNbr(trgTSN, GetFirstWorkDateAfter(trgTSN, ec4twoDate, D), D) DIV CycleLen) MOD CycleECAmount;
      ELSE
       IdxInCycle:=(GroupCycleStartECIdx + (D - ec4twoDate) DIV CycleLen) MOD CycleECAmount;
      END;
     ELSIF ~!GroupCycleStartDate THEN
      IF CycleInWorkDays THEN
       IdxInCycle:=GetWorkDaySeqNbr(trgTSN, GroupCycleStartDate, D) DIV CycleLen MOD CycleECAmount;
      ELSE
       IdxInCycle:=(D - GroupCycleStartDate) DIV CycleLen MOD CycleECAmount;
      END;
     ELSE
      L_General.CallUs(0);
     END;
     trgExitClss:=arrExitClss[IdxInCycle];
    END;
   ELSE
    L_General.CallUs(0);
   END;
   IF trgExitClss = 0 THEN
    SETEMPTY(trgExitClss);
   END;
   IF !trgExitClss THEN
    SETEMPTY(ecfm);
   END;
  END;
 END {intGetFixedEC};

 PUBLIC PROCEDURE GetFixedEC(    trgTSN     : LIKE(Staff.TSN);
                                 D          : DATE;
                             VAR trgExitClss: LIKE(ExitClss.ExitClss);
                             VAR ecfm       : tECFixMethod);
 BEGIN
  intGetFixedEC(trgTSN, D, trgExitClss, ecfm);
 END {GetFixedEC};

 PUBLIC PROCEDURE RWayTxtIsValid(): SCAL[2];
 BEGIN
  RETURN OCCURE(RWayTxt) & RWayTxt.Valid;
 END {RWayTxtIsValid};

 PUBLIC PROCEDURE SetWayLMenDefaultTime();
 BEGIN
  IF !WayLMen.StartT | (L_Way.E_NeedSetTimesWayLMen(RWayS.Date) = 1) THEN
   IF    RWayTxtIsValid() & ~!RWayTxt.FExTime THEN
    WayLMen.StartT:=RWayTxt.FExTime;
   ELSIF ~!StExit.GuBTime THEN
    WayLMen.StartT:=StExit.GuBTime;
   ELSE
    WayLMen.StartT:=StExit.BegTime;
   END;
   WayLMen.Day:=StExit.BegDay;
  END; (* IF !WayLMen.StartT...*)
  IF !WayLMen.StopT | (L_Way.E_NeedSetTimesWayLMen(RWayS.Date) = 1) THEN
   IF    RWayTxtIsValid() & ~!RWayTxt.LEnTime THEN
    WayLMen.StopT:=RWayTxt.LEnTime;
   ELSIF ~!StExit.GuETime THEN
    WayLMen.StopT:=StExit.GuETime;
   ELSE
    WayLMen.StopT:=StExit.StopTim;
   END;
   IF RWayS.StartTim < WayLMen.StopT THEN
    WayLMen.StartT:=Math.Max(WayLMen.StartT, RWayS.StartTim);
   END;
  END; (* IF !WayLMen.StopT...*)
 END {SetWayLMenDefaultTime};

 PUBLIC PROCEDURE WLMHasOverlap(VAR CondText: STRING[]): SCAL[2];
  VAR
   PrevStartT,
   PrevStopT: NUMERIC[3];
   _Date    : DATE;
   _RWayS   : LIKE(WayLMen.RWayS);
   _Number  : LIKE(WayLMen.Number);
   _Who     : LIKE(WayLMen.Who);
   _Change: LIKE(RWayS.Change);
 BEGIN
  SETEMPTY(CondText);
  IF WayLMen.ToSheet > L_Way.toSheet_Dummy THEN
   SAVE(WayLMen);
   SAVE(RWayS);
   PrevStartT:=L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT);
   PrevStopT :=L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT);
   _Date  :=WayLMen.RWayDate + WayLMen.Day - 1;
   _RWayS :=WayLMen.RWayS;
   _Number:=WayLMen.Number;
   _Who   :=WayLMen.Who;
   SELECT(WayLMen, TSN, , WayLMen.TSN, _Date);
   WHILE OCCURE(WayLMen) & (WayLMen.RWayDate <= _Date) DO
    CONFORM(WayLMen, RWayS);
    IF ((WayLMen.RWayS # _RWayS) | (WayLMen.Number # _Number)) &
       ((_Who # L_Way.wlmwho_Chopper) | (WayLMen.Who # _Who)) THEN
     IF (WayLMen.RWayDate + WayLMen.Day - 1 = _Date) &
        (L_Way._TimeInt(PrevStartT, PrevStopT,
                        L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT),
                        L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT)) > 0) THEN
      CONFORM(RWayS, Staff, Man);
      IF RWayS.Status >= L_Way.rwsStat_Taken THEN
       CondText:=CondText + "| |⥢  " + RWayS.RWayS + " : ";
      ELSE
       CondText:=CondText + "| |";
      END;
      CondText:=CondText +
                L_DatTim.TimeStr(WayLMen.StartT) + " - " +
                L_DatTim.TimeStr(WayLMen.StopT) + "|⥫ " + RWayS.TSN +
                " " + Man.Name;
     END;
    END;
    NEXT(WayLMen);
   END;
   RESTORE(WayLMen);
   RESTORE(RWayS);
   IF ~!CondText THEN
    CondText:=L_Str.PoolItem(L_Way.wlmwho_Pool, WayLMen.Who) + " " +
              WayLMen.TSN + ": 祭 ६ ࠡ" + CondText;
   END;
  END;
  RETURN ~!CondText;
 END {WLMHasOverlap};

 PUBLIC PROCEDURE CheckWithWayLMen();
  VAR
   Dummy : NUMERIC[2];
 BEGIN
  SELECT(WayLMen, RWayS, , RWayS.RWayS);
  WHILE OCCURE(WayLMen) DO
   Dummy:=L_RWayS.IsWith(L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT),
                         L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT),
                         WayLMen.Who);
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
 END {CheckWithWayLMen};

 PUBLIC PROCEDURE intSetExitData(ModifyRTI: SCAL[2]);
  VAR
   _BegTime : LONGTIME[2];
   CondText : STRING[];
   trgStartT: LIKE(WayLMen.StartT);
   trgStopT : LIKE(WayLMen.StopT);
 BEGIN
  IF ~!RWayS.Exit & (RWayS.Status # L_Way.rwsStat_Given) THEN
   CONFORM(RWayS, StExit);
   IF RWayS.Status = L_Way.rwsStat_Ordered THEN
    CONFORM(RWayS, RWayTxt);
    IF RWayTxtIsValid() & ~!RWayTxt.FExTime THEN
     _BegTime:=RWayTxt.FExTime;
    ELSE
     _BegTime:=C_T2L(StExit.BegDay, StExit.BegTime);
    END;
    IF (RWayS.Date = SYSDATE()) & (SYSTIME() > _BegTime) THEN
     RWayS.StartTim:=SYSTIME();
    ELSE
     RWayS.StartTim:=_BegTime;
    END;
    IF RWayTxtIsValid() & ~!RWayTxt.Change THEN
     RWayS.Change:=RWayTxt.Change;
    ELSE
     RWayS.Change:=StExit.Change;
    END;
    IF L_Way.E_NeedSetTimesWayLMen(RWayS.Date) > 0 THEN
     SELECT(WayLMen, RWayS, , RWayS.RWayS);
     WHILE OCCURE(WayLMen) DO
      trgStartT:=WayLMen.StartT;
      trgStopT :=WayLMen.StopT;
      SetWayLMenDefaultTime();
      TRY
       REPLACE(WayLMen);
      EXCEPT
      ON Exc: Exc_RunTime DO
       IF ~L_General.IsUniquenessViolationException(Exc) THEN
        RAISE();
       END;
      END;
      IF ModifyRTI THEN
       REPLACE_RWayS();
      ELSE
       REPLACE(RWayS);
      END;
      IF WLMHasOverlap(CondText) THEN
       L_StdFrm.Choice(CondText);
      END;
      IF (trgStartT # WayLMen.StartT) | (trgStopT # WayLMen.StopT) THEN
       SELECT(WayLMen, RWayS, , RWayS.RWayS);
      ELSE
       NEXT(WayLMen);
      END;
     END; (* WHILE OCCURE(WayLMen) ... *)
    END;
   ELSE
    RWayS.StartTim:=C_T2L(StExit.BegDay, StExit.BegTime);
    RWayS.Change  :=StExit.Change ;
   END; (* IF RWayS.Status = L_Way.rwsStat_Ordered *)
   RWayS.Gap     :=StExit.Gap    ; (*ࠧ *)
   RWayS.DspConn :=StExit.DspConn; (*쬠*)
   RWayS.Type    :=StExit.Type   ; (*⨯    *)
   IF ModifyRTI THEN
    REPLACE_RWayS();
   ELSE
    REPLACE(RWayS);
   END;
  END; (* IF ~!RWayS.Exit... *)
 END {intSetExitData};

 PUBLIC PROCEDURE SetExitData();
 BEGIN
  intSetExitData(1);
 END {SetExitData};

 PUBLIC PROCEDURE DispOnly();
 BEGIN
  L_General.ForbAction("DISP");
 END {DispOnly};

 PUBLIC PROCEDURE DspDate(D: DATE; T: LONGTIME[2]): DATE;
  VAR
   XYZ: SCAL[100];
 BEGIN
  IF C_L2D(T) = 2 THEN
   INC(D);
  END;
  IF C_L2T(T) >= P_OwnData.DspRepTime(D) THEN
   RETURN D;
  ELSE
   RETURN D-1;
  END;
 END {DspDate};

 PUBLIC PROCEDURE DspSysDate(): DATE;
 BEGIN
  RETURN DspDate(SYSDATE(), SYSTIME());
 END {DspSysDate};

 PUBLIC PROCEDURE INSERT_RWayS();
 BEGIN
  RWayS.MyPlace:=L_Way.GetMyPlace(RWayS.Date, RWayS.BoxNbr, RWayS.TSN, RWayS.Exit);
  RWayS.MyFirm :=L_Way.GetRWaySMyFirm();
  INSERT(RWayS);
  L_RT.rtc_PutByRWayS();
  L_RT.rte_Put(1);
 END {INSERT_RWayS};

 PUBLIC PROCEDURE REPLACE_RWayS();
 BEGIN
  RWayS.MyPlace:=L_Way.GetMyPlace(RWayS.Date, RWayS.BoxNbr, RWayS.TSN, RWayS.Exit);
  RWayS.MyFirm :=L_Way.GetRWaySMyFirm();
  REPLACE(RWayS);
  IF RWayS.Status # L_Way.rwsStat_Rated THEN
   L_RT.rtc_PutByRWayS();
   L_RT.rte_Put(1);
  END;
 END {REPLACE_RWayS};

 PUBLIC PROCEDURE REMOVE_RWayS(Silent, wRemove: SCAL[2]);
  CONST
   idLen = 72;
  VAR
   Msg: STRING[];
 BEGIN
  L_Way.MayDecrRWStatus(L_General.EMPTY_NUMBER());

  L_RT.rte_UnbindByRWayS();
  L_RT.rtc_UnbindByRWayS();

  SETEMPTY(Msg);
  WHILE SELECT(CWOrder, RWayS, RWayS.RWayS) DO
   Msg:=Msg + Str.Align(L_CWOrder.CWOrderStr(), idLen, LEFT) + "|";
   SETEMPTY(CWOrder.RWayS);
   REPLACE(CWOrder);
  END; (* WHILE OCCURE(CWOrder)...*)

  WHILE SELECT(Dtwo, RWayS, RWayS.RWayS) DO
   Msg:=Msg + Str.Align(L_two.DtwoStr(), idLen, LEFT) + "|";
   SETEMPTY(Dtwo.RWayS);
   REPLACE(Dtwo);
   NEXT(Dtwo);
  END; (* WHILE OCCURE(Dtwo)...*)

  IF ~!Msg & ~Silent THEN
   L_StdFrm.Warning("   뫠 ᫥騥 㬥:" +
                    "||" + Msg +
                    "||" + "த 樨 ਢ  ࠧ 裡");
  END;
  L_XDoc.XDoc_Clear(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
  IF wRemove THEN
   TRY
    SE_INTEGRITY(1);
    REMOVE(RWayS);
   EXCEPT
   END;
  END;
 END {REMOVE_RWayS};

(*-------------BEGIN OF NORMAL ENVIRONMENT--------------------------*)

 PUBLIC PROCEDURE E_GuardFixedByDriver(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.GuardFixedByDriver), 0);
 END {E_GuardFixedByDriver};

 PUBLIC PROCEDURE caa_ActionAsStrInQu(_Action: L_XDoc.tAction): STRING[];
 BEGIN
  RETURN '"' + L_Str.PoolItem(L_XDoc.action_Pool, _Action)+'"';
 END {caa_ActionAsStrInQu};

 PUBLIC PROCEDURE RoleOfAction(_Action: L_XDoc.tAction): NUMERIC[0];
 BEGIN
  IF    (_Action = L_XDoc.action_CarDeparture)       |
        (_Action = L_XDoc.action_CarReturn)          THEN
   RETURN ubcr_Outpost;
  ELSIF (_Action = L_XDoc.action_AcceptCarDeparture) |
        (_Action = L_XDoc.action_AcceptCarReturn)    THEN
   RETURN ubcr_Mechanic;
  ELSIF (_Action = L_XDoc.action_MedicalExamination) |
        (_Action = L_XDoc.action_NotAllowedByMedic)  THEN
   RETURN ubcr_Medic;
  ELSIF (_Action = L_XDoc.action_begDst)             |
        (_Action = L_XDoc.action_Reprint)            |
        (_Action = L_XDoc.action_AutoVerification)   |
        (_Action = L_XDoc.action_VerifyCC)           |
        (_Action = L_XDoc.action_begDstCncl)         |
        (_Action = L_XDoc.action_begRcp)             |
        (_Action = L_XDoc.action_begRcpCncl)         THEN
   RETURN ubcr_Dispatcher;
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {RoleOfAction};

 PUBLIC PROCEDURE IsActionToCheck(_Action: L_XDoc.tAction): SCAL[2];
 BEGIN
  RETURN ~!RoleOfAction(_Action);
 END {IsActionToCheck};

 PUBLIC PROCEDURE IsActionToIgnore(_Action: L_XDoc.tAction): SCAL[2];
 BEGIN
  RETURN (_Action = L_XDoc.action_begSwitch);
 END {IsActionToIgnore};

 PUBLIC PROCEDURE HasDepartureAction(): SCAL[2];
 BEGIN
  RETURN L_Way.RWaySSomeTimeWas(L_XDoc.action_CarDeparture);
 END {HasDepartureAction};

 PRIVATE PROCEDURE StandOnNeighbour_InDay(_RWayS : LIKE(RWayS.RWayS);
                                          Dir    : NUMERIC[0]): SCAL[2];
 BEGIN
  SEARCH(RWayS, RWayS, , _RWayS);
  CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr, RWayS.Date);
  IF    Dir = -1 THEN
   RETURN PREV(RWayS);
  ELSIF Dir = +1 THEN
   RETURN NEXT(RWayS);
  END;
 END {StandOnNeighbour_InDay};

 PUBLIC PROCEDURE CarIsUnderControlOfPrevRWayS(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(RWayS);
  SAVE(XDocJrn);
  IF StandOnNeighbour_InDay(RWayS.RWayS, -1) THEN
   SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
   LAST(XDocJrn);
   LOOP
    IF ~OCCURE(XDocJrn) | (XDocJrn.Action = L_XDoc.action_CarReturn) THEN
     Result:=0;
     EXIT;
    ELSIF XDocJrn.Action = L_XDoc.action_CarDeparture THEN
     Result:=1;
     EXIT;
    END;
    PREV(XDocJrn);
   END; (* LOOP  ... *)
  ELSE
   Result:=0;
  END;
  RESTORE(RWayS);
  RESTORE(XDocJrn);
  RETURN Result;
 END {CarIsUnderControlOfPrevRWayS};

 PUBLIC PROCEDURE CarIsUnderControlOfNextRWayS(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(RWayS);
  Result:=StandOnNeighbour_InDay(RWayS.RWayS, +1) &
          (RWayS.Status # L_Way.rwsStat_Ordered);
  RESTORE(RWayS);
  RETURN Result;
 END {CarIsUnderControlOfNextRWayS};

 PUBLIC PROCEDURE E_wTRANSNAVIGATSIA(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.wTRANSNAVIGATSIA), 0);
 END {E_wTRANSNAVIGATSIA};

 PUBLIC PROCEDURE E_UsingBarCodeScannerLevel(Role: NUMERIC[0]): L_BarCode.tBCScannerLevel;
  VAR
   Local  : PROC;
   default: L_BarCode.tBCScannerLevel;
 BEGIN
  default:=L_BarCode.bcsl_None;
  Local:=PROCREF(E_Way.UsingBarCodeScannerLevel);
  IF ~!Local THEN
   default:=Local(SYSDATE(), Role, default);
  END;
  RETURN default;
 END {E_UsingBarCodeScannerLevel};

 PUBLIC PROCEDURE IsActionChangeCarState(_Action: L_XDoc.tAction): SCAL[2];
 BEGIN
  RETURN (RoleOfAction(_Action) = ubcr_Outpost) | (RoleOfAction(_Action) = ubcr_Mechanic);
 END {IsActionChangeCarState};

 PUBLIC PROCEDURE E_BegRWS_IsRequiredAction(_Action: L_XDoc.tAction): SCAL[2];
  VAR
   Role: NUMERIC[0];
 BEGIN
  Role:=RoleOfAction(_Action);
  RETURN !Role | (E_UsingBarCodeScannerLevel(Role) > L_BarCode.bcsl_None);
 END {E_BegRWS_IsRequiredAction};

 PRIVATE PROCEDURE ActionActAs(_Action: L_XDoc.tAction): L_XDoc.tAction;
 BEGIN
  IF _Action = L_XDoc.action_AutoVerification THEN
   RETURN L_XDoc.action_VerifyCC;
  ELSE
   RETURN _Action;
  END;
 END {ActionActAs};

 PRIVATE PROCEDURE IsEqualAction(_Action1, _Action2: L_XDoc.tAction): SCAL[2];
 BEGIN
  RETURN ActionActAs(_Action1) = ActionActAs(_Action2);
 END {IsEqualAction};

 PRIVATE PROCEDURE intIsAcceptableAction(curAction, nxtAction: L_XDoc.tAction; rLev: NUMERIC[0]): SCAL[2];
  VAR
   la: L_XDoc.tAction[16];
   i : NUMERIC[0];
 BEGIN
  IF rLev > 4 THEN
   RETURN 0;
  END;
  SETEMPTY(la);
  i:=0;
  IF    nxtAction = L_XDoc.action_begDst THEN
   la[i]:=L_XDoc.action_AutoBuild;            INC(i);
   la[i]:=L_XDoc.action_begInsert;            INC(i);
   la[i]:=L_XDoc.action_begEdit;              INC(i);
   la[i]:=L_XDoc.action_begDstCncl;           INC(i);
  ELSIF nxtAction = L_XDoc.action_Reprint THEN
   la[i]:=L_XDoc.action_begDst;               INC(i);
   la[i]:=L_XDoc.action_VerifyCC;             INC(i);
   la[i]:=L_XDoc.action_AcceptCarReturn;      INC(i);
   la[i]:=L_XDoc.action_Reprint;              INC(i);
   la[i]:=L_XDoc.action_MedicalExamination;   INC(i);
  ELSIF nxtAction = L_XDoc.action_VerifyCC THEN
   la[i]:=L_XDoc.action_Reprint;              INC(i);
  ELSIF (nxtAction = L_XDoc.action_MedicalExamination) |
        (nxtAction = L_XDoc.action_NotAllowedByMedic)  THEN
   la[i]:=L_XDoc.action_VerifyCC;             INC(i); (*।३ᮢ*)
   la[i]:=L_XDoc.action_CarReturn;            INC(i); (*३ᮢ*)
   la[i]:=L_XDoc.action_AcceptCarReturn;      INC(i); (*᫥३ᮢ*)
   la[i]:=L_XDoc.action_MedicalExamination;   INC(i);
   la[i]:=L_XDoc.action_NotAllowedByMedic;    INC(i);
   la[i]:=L_XDoc.action_AcceptCarDeparture;   INC(i);
   IF ~E_BegRWS_IsRequiredAction(L_XDoc.action_CarReturn) &
      ~E_BegRWS_IsRequiredAction(L_XDoc.action_AcceptCarReturn) THEN
    la[i]:=L_XDoc.action_begRcpCncl;          INC(i); (*..  ਥ  ஢ ᬮ - . 0081930*)
   END;
   IF CarIsUnderControlOfNextRWayS() THEN
    la[i]:=L_XDoc.action_CarDeparture;        INC(i); (*᫥३ᮢ*)
   END;
  ELSIF nxtAction = L_XDoc.action_AcceptCarDeparture THEN
   la[i]:=L_XDoc.action_MedicalExamination;   INC(i); (*।३ᮢ*)
   la[i]:=L_XDoc.action_AcceptCarReturn;      INC(i);
  ELSIF nxtAction = L_XDoc.action_CarDeparture THEN
   la[i]:=L_XDoc.action_AcceptCarDeparture;   INC(i);
   la[i]:=L_XDoc.action_CarReturn;            INC(i);
   la[i]:=L_XDoc.action_MedicalExamination;   INC(i); (*३ᮢ*)
  ELSIF nxtAction = L_XDoc.action_CarReturn THEN
   la[i]:=L_XDoc.action_CarDeparture;         INC(i);
   IF CarIsUnderControlOfPrevRWayS() THEN
    la[i]:=L_XDoc.action_MedicalExamination;  INC(i); (*।३ᮢ*)
   END;
  ELSIF nxtAction = L_XDoc.action_AcceptCarReturn THEN
   la[i]:=L_XDoc.action_CarReturn;            INC(i);
   la[i]:=L_XDoc.action_AcceptCarDeparture;   INC(i);
   la[i]:=L_XDoc.action_MedicalExamination;   INC(i); (*  ३ᮢ,    堫*)
   la[i]:=L_XDoc.action_NotAllowedByMedic;    INC(i); (*  ३ᮢ,   襫*)
  ELSIF nxtAction = L_XDoc.action_begDstCncl THEN
   la[i]:=L_XDoc.action_begDst;               INC(i);
   la[i]:=L_XDoc.action_Reprint;              INC(i);
   la[i]:=L_XDoc.action_VerifyCC;             INC(i);
   la[i]:=L_XDoc.action_AcceptCarReturn;      INC(i);
  ELSIF nxtAction = L_XDoc.action_begRcp THEN
   la[i]:=L_XDoc.action_begDst;               INC(i);
   la[i]:=L_XDoc.action_AcceptCarReturn;      INC(i); (*᫨ ࠭*)
   la[i]:=L_XDoc.action_begRcpCncl;           INC(i);
   la[i]:=L_XDoc.action_VerifyCC;             INC(i);
   la[i]:=L_XDoc.action_MedicalExamination;   INC(i);
   la[i]:=L_XDoc.action_NotAllowedByMedic;    INC(i);
  ELSIF nxtAction = L_XDoc.action_begRcpCncl THEN
   la[i]:=L_XDoc.action_begRcp;               INC(i);
  END;

  i:=0;
  WHILE ~!la[i] DO
   IF    IsEqualAction(la[i], curAction) THEN
    RETURN 1;
   ELSIF (E_UsingBarCodeScannerLevel(RoleOfAction(la[i])) # L_BarCode.bcsl_Normal) &
         intIsAcceptableAction(curAction, la[i], rLev + 1) THEN
    RETURN 1;
   END;
   INC(i);
  END;
  RETURN 0;
 END {intIsAcceptableAction};

 PUBLIC PROCEDURE IsAcceptableAction(curAction, nxtAction: L_XDoc.tAction): SCAL[2];
 BEGIN
  RETURN intIsAcceptableAction(curAction, nxtAction, 0);
 END {IsAcceptableAction};

 PUBLIC PROCEDURE GetRWaySActualAction(): L_XDoc.tAction;
 BEGIN
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
  LAST(XDocJrn);
  WHILE OCCURE(XDocJrn) & IsActionToIgnore(XDocJrn.Action) DO
   PREV(XDocJrn);
  END;
  L_General.CallUs(OCCURE(XDocJrn));
  RETURN XDocJrn.Action;
 END {GetRWaySActualAction};

 PRIVATE PROCEDURE HasUnclosedCoupledAction(First, Second: L_XDoc.tAction): SCAL[2];
 BEGIN
  RETURN L_XDoc.XDocHasUnclosedCoupledAction(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS,
                                             First, Second);
 END {HasUnclosedCoupledAction};

 PUBLIC PROCEDURE intCheckAcceptableAction(curAction, nxtAction: L_XDoc.tAction): STRING[];
  VAR
   ErrorMsg: STRING[];
 BEGIN
  L_General.CallUs(IsActionToCheck(nxtAction));
  ErrorMsg:="";
  IF    (nxtAction = L_XDoc.action_Reprint) |
        (nxtAction = L_XDoc.action_begDstCncl) THEN
   IF HasDepartureAction() THEN
    ErrorMsg:="⢨ ⨬, ..  㦥 뢠  ⠬";
   END;
  ELSIF (nxtAction = L_XDoc.action_AcceptCarDeparture) THEN
   IF    E_UsingBarCodeScannerLevel(ubcr_Mechanic) = L_BarCode.bcsl_Normal THEN
    IF HasUnclosedCoupledAction(L_XDoc.action_AcceptCarDeparture, L_XDoc.action_AcceptCarReturn) THEN
     ErrorMsg:="⢨  ॡ, .. 륧 㦥 ࠧ襭";
    END;
   END;
  ELSIF (nxtAction = L_XDoc.action_CarDeparture) THEN
   IF    E_UsingBarCodeScannerLevel(ubcr_Mechanic) = L_BarCode.bcsl_Normal THEN
    IF ~L_Way.RWaySSomeTimeWas(L_XDoc.action_AcceptCarDeparture) |
       HasUnclosedCoupledAction(L_XDoc.action_AcceptCarReturn, L_XDoc.action_AcceptCarDeparture) THEN
     ErrorMsg:="⢨ ⨬, .. 륧 TC  ࠧ襭";
    END;
   END;
   IF    E_UsingBarCodeScannerLevel(ubcr_Medic) = L_BarCode.bcsl_Normal THEN
    SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
    LAST(XDocJrn);
    WHILE OCCURE(XDocJrn) & (XDocJrn.Action # L_XDoc.action_CarReturn) &
                            (XDocJrn.Action # L_XDoc.action_MedicalExamination) DO
     PREV(XDocJrn);
    END;
    IF OCCURE(XDocJrn) &
       (L_DatTim.GetSysVARIANTDATE() -
        L_DatTim.GetVARIANTDATE(XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec) > 3/24) THEN
     ErrorMsg:="⢨ ⨬, ..  ன ३ᮢ ᬮ";
    END;
   END;
  ELSIF (nxtAction = L_XDoc.action_AcceptCarReturn) THEN
   IF    E_UsingBarCodeScannerLevel(ubcr_Mechanic) = L_BarCode.bcsl_Normal THEN
    IF HasUnclosedCoupledAction(L_XDoc.action_AcceptCarReturn, L_XDoc.action_AcceptCarDeparture) THEN
     ErrorMsg:="⢨  ॡ, ..  㦥 ਭ";
    END;
   END;
  ELSIF (nxtAction = L_XDoc.action_begRcp) THEN
   IF ~CarIsUnderControlOfNextRWayS() THEN
    IF    E_UsingBarCodeScannerLevel(ubcr_Mechanic) = L_BarCode.bcsl_Normal THEN
     IF HasUnclosedCoupledAction(L_XDoc.action_AcceptCarDeparture, L_XDoc.action_AcceptCarReturn) THEN
      ErrorMsg:="⢨ ⨬, ..   ਭ";
     ELSIF ~L_Way.RWaySSomeTimeWas(L_XDoc.action_NotAllowedByMedic) &
           (E_UsingBarCodeScannerLevel(ubcr_Medic) = L_BarCode.bcsl_Normal) &
           HasUnclosedCoupledAction(L_XDoc.action_AcceptCarReturn, L_XDoc.action_MedicalExamination) THEN
      ErrorMsg:="⢨ ⨬, ..  ன ᬮ";
     END;
    ELSIF E_UsingBarCodeScannerLevel(ubcr_Outpost) = L_BarCode.bcsl_Normal THEN
     IF HasUnclosedCoupledAction(L_XDoc.action_CarDeparture, L_XDoc.action_CarReturn) THEN
      ErrorMsg:="⢨ ⨬, ..  室  ⠬";
     ELSIF ~L_Way.RWaySSomeTimeWas(L_XDoc.action_NotAllowedByMedic) &
           (E_UsingBarCodeScannerLevel(ubcr_Medic) = L_BarCode.bcsl_Normal) &
           HasUnclosedCoupledAction(L_XDoc.action_CarReturn, L_XDoc.action_MedicalExamination) THEN
      ErrorMsg:="⢨ ⨬, ..  ன ᬮ";
     END;
    END;
   END;
  END;

  IF   !ErrorMsg THEN
   IF IsAcceptableAction(curAction, nxtAction) THEN
    RETURN "";
   ELSE
    ErrorMsg:=" ⢨ 蠥 ⨬ 冷 ⢨  ." +
              "|᫥ ⢨   " + caa_ActionAsStrInQu(curAction);
   END;
  END;
  RETURN ErrorMsg;
 END {intCheckAcceptableAction};

 PUBLIC PROCEDURE CheckAcceptableAction(curAction, nxtAction: L_XDoc.tAction): STRING[];
  VAR
   ErrorMsg,
   ActionList: STRING[];
   trgAction : L_XDoc.tAction;
 BEGIN
  ErrorMsg:=intCheckAcceptableAction(curAction, nxtAction);
  IF ~!ErrorMsg THEN
   ErrorMsg:=" ॡ 믮 ⢨ " + caa_ActionAsStrInQu(nxtAction) + "." +
             "||" + ErrorMsg + ".";

   SETEMPTY(ActionList);
   FOR_EACH trgAction DO
    IF IsActionToCheck(trgAction) &
       (E_UsingBarCodeScannerLevel(RoleOfAction(trgAction)) # L_BarCode.bcsl_None) &
       !intCheckAcceptableAction(curAction, trgAction) THEN
     ActionList:=L_Str.AddStrDlm(ActionList, "|") + caa_ActionAsStrInQu(trgAction);
    END;
   END;
   IF ~!ActionList THEN
    ActionList:="   ⨬ ⢨:|" + ActionList;
   ELSE
    ActionList:="᫨  㢥७  ࠢ쭮 ᢮ ⢨,   ";
   END;
   ErrorMsg:=ErrorMsg + "||" + ActionList;
  END;
  RETURN ErrorMsg;
 END {CheckAcceptableAction};

 PUBLIC PROCEDURE GetRWaySExitTime(NeedAuthenticTime: SCAL[2]): TIME;
  VAR
   Result: TIME;
 BEGIN
  SAVE(StExit);
  CONFORM(RWayS, StExit);
  CONFORM(RWayS, RWayTxt);
  IF    RWayTxtIsValid() & ~!RWayTxt.FExTime THEN
   Result:=RWayTxt.FExTime;
  ELSIF ~NeedAuthenticTime | (StExit.Strict = L_Way.ExitStrict_Reg) THEN
   Result:=StExit.BegTime;
  ELSE
   SETEMPTY(Result);
  END;
  RESTORE(StExit);
  RETURN Result;
 END {GetRWaySExitTime};

 PUBLIC PROCEDURE GetRWaySEnterTime(NeedAuthenticTime: SCAL[2]): TIME;
  VAR
   _EnterTime: TIME;
 BEGIN
  SAVE(RWayJ);
  SAVE(StExit);
  SAVE(SEJobs);
  IF ((RWayS.Status = L_Way.rwsStat_Given) | (RWayS.Status = L_Way.rwsStat_Taken)) &
     SELECT(RWayJ, RWayS, RWayS.RWayS) &
     LAST(RWayJ) THEN
   CONFORM(RWayJ, SEJobs);
   CONFORM(SEJobs, StExit);
  ELSE
   CONFORM(RWayS, StExit);
  END;
  CONFORM(RWayS, RWayTxt);
  IF    RWayTxtIsValid() & ~!RWayTxt.LEnTime THEN
   _EnterTime:=RWayTxt.LEnTime;
  ELSIF ~NeedAuthenticTime | (StExit.Strict = L_Way.ExitStrict_Reg) THEN
   _EnterTime:=StExit.StopTim;
  ELSE
   _EnterTime:=EMPTYOF(TIME);
  END;
  RESTORE(SEJobs);
  RESTORE(StExit);
  RESTORE(RWayJ);
  RETURN _EnterTime;
 END {GetRWaySEnterTime};

 PRIVATE PROCEDURE HasRWayS(_BoxNbr: LIKE(Car.BoxNbr);
                            OnDate : DATE;
                            OnTime : TIME): SCAL[2];
 BEGIN
  IF SELECT(RWayS, BoxNbr, _BoxNbr) & SRCINSEL(RWayS, LE, OnDate, OnTime) THEN
   RETURN RWayS.Date >= DspDate(OnDate, OnTime);
  ELSE
   RETURN 0;
  END;
 END {HasRWayS};

 PUBLIC PROCEDURE GetSingleBoxNbr_XDocIds(_BoxNbr: LIKE(Car.BoxNbr);
                                          OnDate : DATE;
                                          OnTime : TIME;
                                          VAR
                                          XDocIds: L_XDoc.tXDocId[]);
  VAR
   PairIsDone: SCAL[3];
 BEGIN
  PairIsDone:=0;
  SETEMPTY(XDocIds);
  IF    (L_Rpr.RprLev(OnDate) = L_Rpr.rprl_Active) & L_Rpr.HasOpenRprS(_BoxNbr, OnDate, OnTime) THEN
   XDocIds[csi_Current]:=L_XDoc.XDocId(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS);
   IF HasRWayS(_BoxNbr, OnDate, OnTime) THEN
    PairIsDone:=1;
    IF (RWayS.Date > RprS.OrdDate) | (RWayS.StartTim > RprS.OrdTime) THEN
     XDocIds[csi_Past]:=L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
     PairIsDone:=2;
    END;
   END;
   IF ((PairIsDone = 1) & HasRWayS(_BoxNbr, OnDate,   OnTime)) |
      ((PairIsDone = 0) & HasRWayS(_BoxNbr, OnDate-1, L_General.EMPTY_TIME())) THEN
    XDocIds[csi_Future]:=L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
   END;
  ELSIF HasRWayS(_BoxNbr, OnDate,   OnTime) |
        HasRWayS(_BoxNbr, OnDate,   L_General.EMPTY_TIME()) THEN
   XDocIds[csi_Current]:=L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
  ELSIF HasRWayS(_BoxNbr, OnDate+1, L_General.EMPTY_TIME()) THEN
   XDocIds[csi_Future]:=L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
  ELSE
   (*  ⥫  - XDocIdx ⮩ *)
  END;
 END {GetSingleBoxNbr_XDocIds};

 PRIVATE PROCEDURE E_GetMechanicOfficer(D: DATE;
                                         VAR _Sort   : LIKE(Officer.Sort)[];
                                         VAR _Officer: LIKE(Officer.Officer)[]);
  VAR
   Local: PROC;
 BEGIN
  SETEMPTY(_Sort, _Officer);
  Local:=PROCREF(E_Way.GetMechanicOfficer);
  IF ~!Local THEN
   Local(D, _Sort, _Officer);
  END;
 END {E_GetMechanicOfficer};

 PUBLIC PROCEDURE SetMechanicName(D: DATE): STRING[];
  CONST
   ofcAmount = 5;
  VAR
   _Sort   : LIKE(Officer.Sort)   [ofcAmount];
   _Officer: LIKE(Officer.Officer)[ofcAmount];
   Result,
   List    : STRING[];
   i       : NUMERIC[0];
 BEGIN
  SAVE(Sort);
  SAVE(Officer);
  SAVE(Staff);
  SAVE(StaffLog);
  SAVE(Man);
  E_GetMechanicOfficer(D, _Sort, _Officer);
  SETEMPTY(List);
  i:=0;
  LOOP
   IF !_Sort[i] THEN
    EXIT;
   END;
   IF SEARCH(Officer, Officer, _Sort[i], _Officer[i]) THEN
    D_Staff.Prepare_Stl01(L_General.timeCond_OnDate, D_Staff.ofc_ByOfficer, D_Staff.sld_Simple);
    SELECT(Stl01, TSN);
    WHILE OCCURE(Stl01) DO
     CONFORM(Stl01, Man);
     List:=List + Stl01.TSN + " " + L_Str.ShortName(Man.Name) + "|";
     NEXT(Stl01);
    END; (* WHILE OCCURE(Stl01) ... *)
    D_Staff.Purge_Stl01();
   ELSE
    L_StdFrm.RedInform("롮 堭:   ᥪ "+_Sort[i]+"  "+_Officer[i]);
    SETEMPTY(List);
    EXIT;
   END;
   INC(i);
  END; (* LOOP *)
  RESTORE(Man);
  RESTORE(Sort);
  RESTORE(Officer);
  RESTORE(Staff);
  RESTORE(StaffLog);
  IF !List THEN
   Result:="";
  ELSE
   Result:=Str.Delete(L_Str.PoolItem(List, L_StdFrm.ShowListAsMenu(List, "롮 堭")),
                      0, Str.Length(MAXOF(Staff.TSN))+1);
  END;
  L_SES.PutValueAtSlaveTrn(L_SES.sit_Station, svi_Mechanic, Result);
  RETURN Result;
 END {SetMechanicName};

 PUBLIC PROCEDURE GetMechanicName(D: DATE): STRING[];
  VAR
   MechanicName: STRING[];
 BEGIN
  IF L_SES.GetValue(L_SES.sit_Station, svi_Mechanic, MechanicName) THEN
   RETURN MechanicName;
  ELSE
   RETURN SetMechanicName(D);
  END;
 END {GetMechanicName};

 PRIVATE PROCEDURE GetStaffBegun(OnDate: DATE; trgTSN: LIKE(Staff.TSN)): DATE;
  VAR
   begun: DATE;
 BEGIN
  SAVE(Staff);
  SEARCH(Staff, TSN, , trgTSN);
  begun:=L_Man.GetTakeOnDate(OnDate);
  RESTORE(Staff);
  RETURN begun;
 END {GetStaffBegun};

 PUBLIC PROCEDURE HasPermitToRouteEDOrder(    OnDate  : DATE;
                                              trgTSN  : LIKE(Staff.TSN);
                                              trgRoute: LIKE(Route.Route);
                                              trgGroup: LIKE(EDOGrp.EDOGrp);
                                          VAR D       : DATE): SCAL[2];
  VAR
   begun : DATE;
   Result: SCAL[2];
 BEGIN
  begun:=GetStaffBegun(OnDate, trgTSN);
  Result:=0;
  TRY
   L_AR.GrantRightsUnconditionally();
   SETSEL(EDOrderL, TSNGrOD, trgTSN, trgGroup);
   SRCINSEL(EDOrderL, LE, , OnDate);
   WHILE OCCURE(EDOrderL) & (EDOrderL.OcrDate >= begun) & ~Result DO
    PROMPT(EDOrderL.EDOrder);
    IF L_EDO.AcceptableEDOrderL() THEN
     SELECT(EDOLPro, EDOrder, , EDOrderL.EDOrder, EDOrderL.Row, P_EDOL.P_Route);
     WHILE OCCURE(EDOLPro) DO
      IF P_EDOL.Decode_CurEDOLPro() = trgRoute THEN
       D     :=EDOrderL.OcrDate;
       Result:=1;
      END;
      NEXT(EDOLPro);
     END; (* WHILE OCCURE(EDOLPro) ... *)
    END;
    PREV(EDOrderL);
   END; (* WHILE OCCURE(EDOrderL) ... *)
  EXCEPT
  END;
  RETURN Result;
 END {HasPermitToRouteEDOrder};

 PUBLIC PROCEDURE GetPermit2RouteDate(D: DATE; trgTSN: LIKE(Staff.TSN); trgRoute: LIKE(Route.Route)): DATE;
  VAR
   Result,
   CancelDate : DATE;
 BEGIN
  SETEMPTY(Result);
  IF HasPermitToRouteEDOrder(D, trgTSN, trgRoute, L_EDO.grp_Permit, Result) THEN
   IF HasPermitToRouteEDOrder(D, trgTSN, trgRoute, L_EDO.grp_CancelPermit, CancelDate) THEN
    IF CancelDate >= Result THEN
     SETEMPTY(Result);
    END;
   END;
  END;
  RETURN Result;
 END {GetPermit2RouteDate};

 PUBLIC PROCEDURE HasPermitToMarkGEDOrder(    OnDate  : DATE;
                                              trgTSN  : LIKE(Staff.TSN);
                                              trgMarkG: LIKE(MarkG.MarkG);
                                              trgGroup: LIKE(EDOGrp.EDOGrp);
                                          VAR D       : DATE): SCAL[2];
  VAR
   begun : DATE;
   Result: SCAL[2];
 BEGIN
  begun:=GetStaffBegun(OnDate, trgTSN);
  Result:=0;
  TRY
   L_AR.GrantRightsUnconditionally();
   SETSEL(EDOrderL, TSNGrOD, trgTSN, trgGroup);
   SRCINSEL(EDOrderL, LE, , OnDate);
   WHILE OCCURE(EDOrderL) & (EDOrderL.OcrDate >= begun) & ~Result DO
    IF L_EDO.AcceptableEDOrderL() THEN
     SELECT(EDOLPro, EDOrder, , EDOrderL.EDOrder, EDOrderL.Row, P_EDOL.P_MarkG);
     WHILE OCCURE(EDOLPro) DO
      IF STRTOFLD(P_EDOL.Decode_CurEDOLPro(), SCAL) = trgMarkG THEN
       D     :=EDOrderL.OcrDate;
       Result:=1;
      END;
      NEXT(EDOLPro);
     END; (* WHILE OCCURE(EDOLPro) ... *)
    END;
    PREV(EDOrderL);
   END; (* WHILE OCCURE(EDOrderL) ... *)
  EXCEPT
  END;
  RETURN Result;
 END {HasPermitToMarkGEDOrder};

 PUBLIC PROCEDURE GetPermit2MarkGDate(D: DATE; trgTSN: LIKE(Staff.TSN); trgMarkG: LIKE(MarkG.MarkG)): DATE;
  VAR
   Result,
   CancelDate: DATE;
 BEGIN
  SETEMPTY(Result);
  IF HasPermitToMarkGEDOrder(D, trgTSN, trgMarkG, L_EDO.grp_Permit, Result) THEN
   IF HasPermitToMarkGEDOrder(D, trgTSN, trgMarkG, L_EDO.grp_CancelPermit, CancelDate) THEN
    IF CancelDate >= Result THEN
     SETEMPTY(Result);
    END;
   END;
  END;
  RETURN Result;
 END {GetPermit2MarkGDate};

 PUBLIC PROCEDURE HasPermitToMark(D: DATE; trgTSN: LIKE(Staff.TSN); trgMark: LIKE(Mark.Mark)): SCAL[2];
 BEGIN
  RETURN ~!GetPermit2MarkGDate(D, trgTSN, L_Way.GetMarkG_Soft(trgMark, L_Way.mgt_AccessDriving));
 END {HasPermitToMark};

 PRIVATE PROCEDURE hptml_InitOneGroup(fr,
                                      ut      : DATE;
                                      trgTSN  : LIKE(Staff.TSN);
                                      trgGroup: LIKE(EDOGrp.EDOGrp));
 BEGIN
  SETSEL(EDOrderL, TSNGrOD, trgTSN, trgGroup);
  SRCINSEL(EDOrderL, GE, , fr);
  WHILE OCCURE(EDOrderL) & (EDOrderL.OcrDate <= ut) DO
   PROMPT(EDOrderL.EDOrder);
   IF L_EDO.AcceptableEDOrderL() THEN
    SELECT(EDOLPro, EDOrder, , EDOrderL.EDOrder, EDOrderL.Row, P_EDOL.P_MarkG);
    WHILE OCCURE(EDOLPro) DO
     ADD(hptml, hptml, , trgTSN, P_EDOL.Decode_CurEDOLPro(), trgGroup);
     hptml.Date:=EDOrderL.OcrDate;
     REPLACE(hptml);
     NEXT(EDOLPro);
    END; (* WHILE OCCURE(EDOLPro) ... *)
   END;
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
 END {hptml_InitOneGroup};

 PRIVATE PROCEDURE hptml_Init(OnDate: DATE; trgTSN: LIKE(Staff.TSN));
  VAR
   begun : DATE;
 BEGIN
  TRY
   L_AR.GrantRightsUnconditionally();
   IF !DATABASE.Get().Tables("hptml") THEN
    L_AFM.MakeMultipleIndex("hptml", "TSN  : LIKE(Staff.TSN);" +
                                     "MarkG: LIKE(MarkG.MarkG);" +
                                     "Grp  : LIKE(EDOGrp.EDOGrp);" +
                                     "Date : DATE",
                                 "hptml: TSN, MarkG, Grp");
   ELSE
    SELECT(hptml, hptml, , trgTSN);
    REMSEL(hptml);
   END;

   begun:=GetStaffBegun(OnDate, trgTSN);
   hptml_InitOneGroup(begun, OnDate, trgTSN, L_EDO.grp_Permit);
   hptml_InitOneGroup(begun, OnDate, trgTSN, L_EDO.grp_CancelPermit);
  EXCEPT
  END;
 END {hptml_Init};

 PUBLIC PROCEDURE hptml_Permit(D: DATE; trgTSN: LIKE(Staff.TSN); trgMarkG: LIKE(MarkG.MarkG)): tPermit;
  VAR
   PermitDate: DATE;
 BEGIN
  IF ~L_Env.RealTSN(trgTSN) THEN
   RETURN atr_Yes;
  END;
  IF SEARCH(hptml, hptml, trgTSN, trgMarkG, L_EDO.grp_Permit) THEN
   PermitDate:=hptml.Date;
   IF SEARCH(hptml, hptml, trgTSN, trgMarkG, L_EDO.grp_CancelPermit) & (hptml.Date >= PermitDate) THEN
    RETURN atr_No;
   ELSE
    RETURN atr_Yes;
   END;
  ELSE
   RETURN atr_No;
  END;
 END {hptml_Permit};

 PUBLIC PROCEDURE GetPermitToMarkGList(D: DATE; trgTSN: LIKE(Staff.TSN)): STRING[];
  VAR
   PermitToMark: STRING[];
 BEGIN
  APP.Get().NewPrompt("祭 ᪮  㯯 ப");
  hptml_Init(D, trgTSN);
  SETEMPTY(PermitToMark);
  SELECT(MarkG, MarkGT, , L_Way.mgt_AccessDriving);
  WHILE OCCURE(MarkG) DO
   PROMPT(MarkG.MarkG);
   IF hptml_Permit(D, Staff.TSN, MarkG.MarkG) = atr_Yes THEN
    PermitToMark:=L_Str.AddStrDlm(PermitToMark, ", ") + MarkG.Name;
   END;
   NEXT(MarkG);
  END; (* WHILE OCCURE(MarkG) ... *)
  RETURN PermitToMark;
 END {GetPermitToMarkGList};

 PUBLIC PROCEDURE E_AuthorizeToRouteMethod(D: DATE): tAutorizeToRouteMethod;
  VAR
   Local : PROC;
 BEGIN
  Local:=PROCREF(E_Way.AuthorizeToRouteMethod);
  IF ~!Local THEN
   RETURN Local(D);
  ELSE
   RETURN atrm_No;
  END;
 END {E_AuthorizeToRouteMethod};

 PUBLIC PROCEDURE DriverIsAuthorizedToRoute(D       : DATE;
                                            trgTSN  : LIKE(Staff.TSN);
                                            trgRoute: LIKE(Route.Route)): tPermit;
  VAR
   _Rgn  : LIKE(TKind.Rgn);
   Method: tAutorizeToRouteMethod;
 BEGIN
  IF ~L_Env.RealTSN(trgTSN) THEN
   RETURN atr_Yes;
  END;
  SAVE(Route);
  SAVE(TKind);
  L_General.CallUs(SEARCH(Route, Route, trgRoute));
  L_Way.StandOnRouteTKind(D);
  _Rgn:=TKind.Rgn;
  RESTORE(TKind);
  RESTORE(Route);
  IF (_Rgn # L_Way.tkrgn_City) & (_Rgn # L_Way.tkrgn_Suburb) & (_Rgn # L_Way.tkrgn_Intercity) THEN
   RETURN atr_NotNeed;
  END;
  Method:=E_AuthorizeToRouteMethod(D);
  IF    Method = atrm_ByEDO THEN
   IF ~!GetPermit2RouteDate(D, trgTSN, trgRoute) THEN
    RETURN atr_Yes;
   END;
  ELSIF Method = atrm_ByProperty THEN
   L_General.Error(" ஢     " + L_DatTim.DateStr(D) +
                   ", .. ᢮⢮ 0222 ५  㤠");
  ELSIF Method = atrm_No THEN
   RETURN atr_NotNeed;
  ELSE
   L_General.CallUs(0);
  END;
  RETURN atr_No;
 END {DriverIsAuthorizedToRoute};

 PUBLIC PROCEDURE DriverIsAuthorizedToExit(D: DATE; trgTSN: LIKE(Staff.TSN); trgExit: LIKE(StExit.Exit)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=1;
  IF ~!trgExit & ~!trgTSN THEN
   SEARCH(StExit, Exit, , trgExit);
   CONFORM(StExit, ExitClss);
   IF ExitClss.BegType = L_Way.ecbt_Line THEN
    IF SELECT(SEJobs, Exit, trgExit) THEN
     Result:=DriverIsAuthorizedToRoute(D, trgTSN, SEJobs.Route) # atr_No;
    END;
   END;
  END;
  RETURN Result;
 END {DriverIsAuthorizedToExit};

 PRIVATE PROCEDURE hptrl_InitOneGroup(fr,
                                      ut      : DATE;
                                      trgTSN  : LIKE(Staff.TSN);
                                      trgGroup: LIKE(EDOGrp.EDOGrp));
 BEGIN
  SETSEL(EDOrderL, TSNGrOD, trgTSN, trgGroup);
  SRCINSEL(EDOrderL, GE, , fr);
  WHILE OCCURE(EDOrderL) & (EDOrderL.OcrDate <= ut) DO
   PROMPT(EDOrderL.EDOrder);
   IF L_EDO.AcceptableEDOrderL() THEN
    SELECT(EDOLPro, EDOrder, , EDOrderL.EDOrder, EDOrderL.Row, P_EDOL.P_Route);
    WHILE OCCURE(EDOLPro) DO
     ADD(hptrl, hptrl, , trgTSN, P_EDOL.Decode_CurEDOLPro(), trgGroup);
     hptrl.Date:=EDOrderL.OcrDate;
     REPLACE(hptrl);
     NEXT(EDOLPro);
    END; (* WHILE OCCURE(EDOLPro) ... *)
   END;
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
 END {hptrl_InitOneGroup};

 PRIVATE PROCEDURE hptrl_Init(OnDate: DATE; trgTSN: LIKE(Staff.TSN));
  VAR
   begun : DATE;
 BEGIN
  TRY
   L_AR.GrantRightsUnconditionally();
   IF !DATABASE.Get().Tables("hptrl") THEN
    L_AFM.MakeMultipleIndex("hptrl", "TSN  : LIKE(Staff.TSN);" +
                                     "Route: LIKE(Route.Route);" +
                                     "Grp  : LIKE(EDOGrp.EDOGrp);" +
                                     "Date : DATE",
                                 "hptrl: TSN, Route, Grp");
   ELSE
    SELECT(hptrl, hptrl, , trgTSN);
    REMSEL(hptrl);
   END;
   begun:=GetStaffBegun(OnDate, trgTSN);
   hptrl_InitOneGroup(begun, OnDate, trgTSN, L_EDO.grp_Permit);
   hptrl_InitOneGroup(begun, OnDate, trgTSN, L_EDO.grp_CancelPermit);
  EXCEPT
  END;
 END {hptrl_Init};

 PUBLIC PROCEDURE hptrl_Permit(D: DATE; trgTSN: LIKE(Staff.TSN); trgRoute: LIKE(Route.Route)): tPermit;
  VAR
   PermitDate: DATE;
 BEGIN
  IF ~L_Env.RealTSN(trgTSN) THEN
   RETURN atr_Yes;
  END;
  L_Way.StandOnRouteTKind(D);
  IF (TKind.Rgn # L_Way.tkrgn_City) &
     (TKind.Rgn # L_Way.tkrgn_Suburb) &
     (TKind.Rgn # L_Way.tkrgn_Intercity) THEN
   RETURN atr_NotNeed;
  END;
  IF SEARCH(hptrl, hptrl, trgTSN, trgRoute, L_EDO.grp_Permit) THEN
   PermitDate:=hptrl.Date;
   IF SEARCH(hptrl, hptrl, trgTSN, trgRoute, L_EDO.grp_CancelPermit) & (hptrl.Date >= PermitDate) THEN
    RETURN atr_No;
   ELSE
    RETURN atr_Yes;
   END;
  ELSE
   RETURN atr_No;
  END;
 END {hptrl_Permit};

 PUBLIC PROCEDURE GetPermitToRouteList(D: DATE; trgTSN: LIKE(Staff.TSN); VAR AllRoute: SCAL[2]): STRING[];
  VAR
   PermitToRoute: STRING[];
   Permit       : tPermit;
   Method       : tAutorizeToRouteMethod;
 BEGIN
  APP.Get().NewPrompt("祭 ᪮  ⠬");
  AllRoute:=1;
  PermitToRoute:="";
  Method:=E_AuthorizeToRouteMethod(D);
  IF    Method = atrm_ByEDO THEN
   hptrl_Init(D, trgTSN);
  END;
  SELECT(Route, Route);
  WHILE OCCURE(Route) DO
   PROMPT(Route.Route);
   IF L_DatTim.IsActive(D, Route.Begin, Route.Till) THEN
    IF    Method = atrm_ByEDO THEN
     Permit:=hptrl_Permit(D, trgTSN, Route.Route);
    ELSE
     Permit:=DriverIsAuthorizedToRoute(D, trgTSN, Route.Route);
    END;
    IF    Permit = atr_Yes THEN
     PermitToRoute:=L_Str.AddStrDlm(PermitToRoute, "; ") + Route.Route;
    ELSIF Permit = atr_No  THEN
     AllRoute:=0;
    END;
   END;
   NEXT(Route);
  END; (* WHILE OCCURE(Route) ... *)
  RETURN PermitToRoute;
 END {GetPermitToRouteList};

 PRIVATE PROCEDURE CarPsgVolumeFitToExit(D      : DATE;
                                         _BoxNbr: LIKE(Car.BoxNbr);
                                         _Exit  : LIKE(StExit.Exit)): SCAL[2];
  VAR
   _PV: NUMERIC[0];
 BEGIN
  L_Car.AccessMark(_BoxNbr, D);
  _PV:=P_Mark.GetP_PVLim(Mark.Mark, D);
  SEARCH(StExit, Exit, , _Exit);
  RETURN (_PV >= StExit.MinPV) & (!StExit.MaxPV | (_PV <= StExit.MaxPV));
 END {CarPsgVolumeFitToExit};

 PRIVATE PROCEDURE cffeRS_MyFirmContradiction(RWSWho: L_Way.tRWSWho): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(L_Way.rwswho_Pool, RWSWho) + "    ࠧ ࣠権";
 END {cffeRS_MyFirmContradiction};

 PRIVATE PROCEDURE HasAcceptableMarkCategory(D: DATE; _BoxNbr: LIKE(Car.BoxNbr); VAR ReasonStr: STRING[]): SCAL[2];
 BEGIN
  L_Car.AccessMark(_BoxNbr, D);
  ReasonStr:=' ⥫᪮ 㤮⮢७   ⥣ "'+Mark.Category+'"';
  RETURN P_Man.ds_HasCategory(Man.Man, D, Mark.Category);
 END {HasAcceptableMarkCategory};

 PRIVATE VAR
  cffe_Fit,
  cffe_Silent: SCAL[2];

 PRIVATE PROCEDURE cffe_Bark(Fit: tCrewFitnessForExit; ReasonStr: STRING[]);
  VAR
   mt,
   GroupN: STRING[];
 BEGIN
  IF    cffe_Silent THEN
   cffe_Fit:=cffe_Fit & ((Fit = cffe_Yes) | (Fit = cffe_wInform));
  ELSIF Fit = cffe_No THEN
   L_General.Assert_wReferToAdmin(0, ReasonStr);
  ELSIF Fit = cffe_wCrucialChoice THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    IF ~!RTI.Get().CurZone &
       ~!RTI.Get().CurZone.MasterTable &
       OCCURE(^(RTI.Get().CurZone.MasterTable.Name)) THEN
     mt:=RTI.Get().CurZone.MasterTable.Name;
     IF mt = "RWayS" THEN
      GroupN:=L_APtm.g_Disp;
     ELSE
      IF (mt = "Dtwo") & ~!Dtwo.RWayS THEN
       CONFORM(Dtwo, RWayS);
       mt:="RWayS";
      END;
      GroupN:=L_APtm.g_twoOp;
     END;
    ELSE
     mt:="";
     GroupN:=L_APtm.g_twoOp;
    END;
    L_StdFrm.CrucialChoice_FileExplicit(mt, ReasonStr, GroupN);
   EXCEPT
   END;
  ELSIF Fit = cffe_wChoice THEN
   L_StdFrm.Choice(ReasonStr);
  ELSIF Fit = cffe_wInform THEN
   L_StdFrm.Inform(ReasonStr);
  END;
 END {cffe_Bark};

 PRIVATE PROCEDURE cffe_OneCheck_wSFF (D        : DATE;
                                       trgTSN   : LIKE(Staff.TSN);
                                       _BoxNbr  : LIKE(Car.BoxNbr);
                                       _Exit    : LIKE(StExit.Exit);
                                       Cond     : SCAL[2];
                                       Default  : tCrewFitnessForExit;
                                       Reason,
                                       ReasonStr: STRING[];
                                       Local    : PROC;
                                       Action   : L_XDoc.tAction;
                                       FD       : DATE;
                                       FDefault : tCrewFitnessForExit);
 BEGIN
  IF ~Cond THEN
   IF D > FD THEN
    Default:=FDefault;
   END;
   IF ~!Local THEN
    Local(D, trgTSN, _BoxNbr, _Exit, Default, Reason, ReasonStr, Action);
   END;
   IF !ReasonStr THEN
    ReasonStr:=Reason;
   END;
   ReasonStr:=ReasonStr + L_StdFrm.HR() +
              "(⠡. " + FLDTOSTR(trgTSN, "0", 0) + ", . " + FLDTOSTR(_BoxNbr, "0", 0) +
              ", . " + FLDTOSTR(_Exit, "0", 0) + ", " + L_DatTim.DateStr(D) + ")";
   cffe_Bark(Default, ReasonStr);
  END;
 END {cffe_OneCheck_wSFF};

 PRIVATE PROCEDURE cffe_OneCheck(D        : DATE;
                                 trgTSN     : LIKE(Staff.TSN);
                                 _BoxNbr  : LIKE(Car.BoxNbr);
                                 _Exit    : LIKE(StExit.Exit);
                                 Cond     : SCAL[2];
                                 Default  : tCrewFitnessForExit;
                                 Reason,
                                 ReasonStr: STRING[];
                                 Local    : PROC;
                                 Action   : L_XDoc.tAction);
 BEGIN
  cffe_OneCheck_wSFF(D, trgTSN, _BoxNbr, _Exit, Cond, Default, Reason, ReasonStr, Local, Action,
                     L_General.EMPTY_DATE(), Default);
 END {cffe_OneCheck};

 PRIVATE PROCEDURE MayDrive(D        : DATE;
                            trgBoxNbr: LIKE(Car.BoxNbr);
                            trgTSN   : LIKE(Staff.TSN);
                            trgRWSWho: L_Way.tRWSWho;
                            trgExit  : LIKE(StExit.Exit);
                            Local    : PROC;
                            Action   : L_XDoc.tAction);
  CONST
   rwswho_FullPool = "⥫|?|祭 ⥫|?|2- ⥫|?|?|?|?|?";
  VAR
   IsSelfPropelledCar: SCAL[2];
   rwswhoAsStr       : STRING[];
   Fit               : tCrewFitnessForExit;
   Reason,
   ReasonStr         : STRING[];
   DrvSrtProp        : LIKE(Property.Property);
 BEGIN
  IF ~!trgTSN & L_Env.RealTSN(trgTSN) THEN
   IF ~!trgBoxNbr & L_Env.RealBoxNbr(trgBoxNbr) THEN
    L_General.CallUs(SEARCH(Staff, TSN, trgTSN));
    CONFORM(Staff, Man);
    rwswhoAsStr:=L_Str.PoolItem(rwswho_FullPool, trgRWSWho);
    IF L_Way.E_MarkCategoryLevel(D) THEN
     IsSelfPropelledCar:=L_Car.IsSelfPropelledCar(trgBoxNbr, D);
     IF IsSelfPropelledCar THEN
      DrvSrtProp:=P_Man.P_TractorDriverSertification;
     ELSE
      DrvSrtProp:=P_Man.P_DriveSertification;
     END;
     IF ~P_Man.HasActualManPro(Man.Man, D, DrvSrtProp) THEN
      IF D > (SYSDATE() + 10) THEN
       Fit:=cffe_wChoice;
      ELSE
       Fit:=cffe_No;
      END;
      Reason   :=cffeR_BadDriveSertificate;
      ReasonStr:=rwswhoAsStr + "  祭 " +
                 L_Str.PoolItem("⥫᪨ 㤮⮢७|㤮⮢७ ࠪ", IsSelfPropelledCar);
      cffe_OneCheck(D, trgTSN, trgBoxNbr, trgExit, 0, Fit, Reason, ReasonStr, Local, Action);
     ELSIF ~IsSelfPropelledCar THEN
      IF    !P_Man.GetCurDriveSertification_NewStyleCategory() THEN
       Fit      :=cffe_No;
       Reason   :=cffeR_BadDriveSertificate;
       ReasonStr:=rwswhoAsStr + " 襭 ⥫᪨ ࠢ";
       cffe_OneCheck(D, trgTSN, trgBoxNbr, trgExit, 0, Fit, Reason, ReasonStr, Local, Action);
      ELSIF ~HasAcceptableMarkCategory(D, trgBoxNbr, ReasonStr) THEN
       Fit      :=cffe_wChoice;
       Reason   :=cffeR_BadCategory;
       cffe_OneCheck(D, trgTSN, trgBoxNbr, trgExit, 0, Fit, Reason, ReasonStr, Local, Action);
      END;
     END;
    END;
    IF L_Way.E_MedicalSertLevel(D) &
       ~P_Man.HasActualManPro(Man.Man, D, P_Man.P_MedicalSertification) THEN
     IF D > (SYSDATE() + 3) THEN
      Fit:=cffe_wChoice;
     ELSE
      Fit:=cffe_No;
     END;
     Reason   :=cffeR_BadMedicSertificate;
     ReasonStr:=rwswhoAsStr + "  祭 樭᪮ ࠢ";
     cffe_OneCheck(D, trgTSN, trgBoxNbr, trgExit, 0, Fit, Reason, ReasonStr, Local, Action);
    END;
    IF L_Way.CrewHasMyFirmContradiction(D, trgTSN, trgBoxNbr) THEN
     Fit      :=cffe_No;
     Reason   :=cffeR_MyFirmContradiction;
     ReasonStr:=cffeRS_MyFirmContradiction(trgRWSWho);
     cffe_OneCheck(D, trgTSN, trgBoxNbr, trgExit, 0, Fit, Reason, ReasonStr, Local, Action);
    END;
   END;
   IF P_Staff.HasActualStaffPro(trgTSN, D, P_Staff.P_ProhibitInBegRWayS) THEN
    Fit      :=cffe_No;
    Reason   :=cffeR_Prohibited;
    cffe_OneCheck(D, trgTSN, trgBoxNbr, trgExit, 0, Fit, Reason, "", Local, Action);
   END;
  END;
 END {MayDrive};

 PUBLIC PROCEDURE cffe_extCheckTimeFromLastChange(    OnVarDate: FLOAT;
                                                      nReact,
                                                      mReact   : tCrewFitnessForExit;
                                                  VAR Default  : tCrewFitnessForExit;
                                                  VAR ReasonStr: STRING[]);
  VAR
   nrp,
   mrp,
   Hours,
   MinHours: NUMERIC[3];
   Action  : L_XDoc.tAction;
   D       : DATE;
   _TSN    : LIKE(Staff.TSN);
 BEGIN
  Default  :=cffe_Yes;
  ReasonStr:="";
  D        :=RWayS.Date;
  SEARCH(Staff, TSN, , RWayS.TSN);
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  L_two.E_RestPeriod(RWayS.Date, StaffLog.Sort, L_two.who_Driver, nrp, mrp);
  IF nrp > 0 THEN
   IF E_UsingBarCodeScannerLevel(RoleOfAction(L_XDoc.action_AcceptCarReturn)) = L_BarCode.bcsl_Normal THEN
    Action:=L_XDoc.action_AcceptCarReturn;
   ELSE
    Action:=L_XDoc.action_begRcp;
   END;
   SAVE(RWayS);
   CHANGESEL(RWayS, TSN, , Staff.TSN);
   IF SRCINSEL(RWayS, LT, RWayS.Date) THEN
    Hours:=999;
    NARROWSEL(RWayS, Date);
    WHILE OCCURE(RWayS) DO
     IF SELECT(XDocJrn, XDocJrn, L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS) THEN
      LAST(XDocJrn);
      WHILE OCCURE(XDocJrn) DO
       IF XDocJrn.Action = Action THEN
        IF DspDate(XDocJrn.Date, XDocJrn.BegTime) = (D - 1) THEN
         Hours:=Math.Min(Hours, L_DatTim.GetVARIANTDATEPeriod_Hour(L_DatTim.GetVARIANTDATE(XDocJrn.Date, XDocJrn.BegTime, 0), OnVarDate));
        END;
        FIRST(XDocJrn);
       END;
       PREV(XDocJrn);
      END; (* WHILE OCCURE(XDocJrn) ... *)
     END;
     NEXT(RWayS);
    END; (* WHILE OCCURE(RWayS ... *)
    IF Hours < nrp THEN
     IF    Hours < mrp THEN
      Default :=mReact;
     ELSE
      Default :=nReact;
     END;
     ReasonStr:="  砭 ।饩 ᬥ 諮 筮 ६." +
                "||। ᬥ ࠡ⭨ " + Staff.TSN + " 稫 " + FLDTOSTR(Hours, "1.", 0) + " . ";
    END;
   END;
   RESTORE(RWayS);
  END;
 END {cffe_extCheckTimeFromLastChange};

 PUBLIC PROCEDURE cffe_CheckTimeFromLastChange(    OnVarDate: FLOAT;
                                               VAR Default  : tCrewFitnessForExit;
                                               VAR ReasonStr: STRING[]);
 BEGIN
  cffe_extCheckTimeFromLastChange(OnVarDate, cffe_Yes, cffe_Yes, Default, ReasonStr);
 END {cffe_CheckTimeFromLastChange};

 PRIVATE PROCEDURE cffe_CheckRestTime(D        : DATE;
                                      DrvTSN   : LIKE(Staff.TSN);
                                      GrdTSN   : LIKE(Staff.TSN)[];
                                      trgBoxNbr: LIKE(Car.BoxNbr);
                                      trgExit  : LIKE(StExit.Exit);
                                      Local    : PROC;
                                      Action   : L_XDoc.tAction);
  VAR
   Default  : tCrewFitnessForExit;
   ReasonStr: STRING[];
   curGrdTSN: LIKE(Staff.TSN);
 BEGIN
  IF    (Action = L_XDoc.action_AutoBuild) |
        (Action = L_XDoc.action_AutoEdit)  |
        (Action = action_EditInTWO)        THEN
   IF E_TWOLevel(D) = 1 THEN
    IF ~!DrvTSN & L_Env.RealTSN(DrvTSN) THEN
     L_two.CheckRestTime(D, DrvTSN, L_two.who_Driver, -1, Default, ReasonStr);
     cffe_OneCheck(D, DrvTSN,    trgBoxNbr, trgExit, !ReasonStr, Default, cffeR_BadRestTime, ReasonStr, Local, Action);
     L_two.CheckRestTime(D, DrvTSN, L_two.who_Driver, +1, Default, ReasonStr);
     cffe_OneCheck(D, DrvTSN,    trgBoxNbr, trgExit, !ReasonStr, Default, cffeR_BadRestTime, ReasonStr, Local, Action);
    END;
    FOR_EACH curGrdTSN IN GrdTSN DO
     IF ~!curGrdTSN THEN
      L_two.CheckRestTime(D, curGrdTSN, L_two.who_Guard, -1, Default, ReasonStr);
      cffe_OneCheck(D, curGrdTSN, trgBoxNbr, trgExit, !ReasonStr, Default, cffeR_BadRestTime, ReasonStr, Local, Action);
      L_two.CheckRestTime(D, curGrdTSN, L_two.who_Guard, +1, Default, ReasonStr);
      cffe_OneCheck(D, curGrdTSN, trgBoxNbr, trgExit, !ReasonStr, Default, cffeR_BadRestTime, ReasonStr, Local, Action);
     END;
    END;
   END; (*IF E_TWOLevel(D) = 1*)
  ELSIF Action = L_XDoc.action_begDst THEN
   IF ~!DrvTSN & L_Env.RealTSN(DrvTSN) THEN
    cffe_CheckTimeFromLastChange(L_DatTim.GetSysVARIANTDATE(), Default, ReasonStr);
    cffe_OneCheck(D, DrvTSN,     trgBoxNbr, trgExit, !ReasonStr, Default, cffeR_BadRestTime, ReasonStr, Local, Action);
   END;
  END; (* IF    (Action =... *)
 END {cffe_CheckRestTime};

 PRIVATE PROCEDURE cffe_CommonChecks(D        : DATE;
                                     DrvTSN   : LIKE(Staff.TSN);
                                     GrdTSN   : LIKE(Staff.TSN)[];
                                     trgBoxNbr: LIKE(Car.BoxNbr);
                                     trgExit  : LIKE(StExit.Exit);
                                     Local    : PROC;
                                     Action   : L_XDoc.tAction);
  VAR
   Default  : tCrewFitnessForExit;
   ReasonStr: STRING[];
 BEGIN
  IF    (Action = L_XDoc.action_AutoBuild) |
        (Action = L_XDoc.action_AutoEdit)  |
        (Action = L_XDoc.action_begInsert) |
        (Action = L_XDoc.action_begEdit)   |
        (Action = action_EditInTWO)        |
        (Action = L_XDoc.action_begDst)    THEN
   IF ~!trgBoxNbr & L_Env.RealBoxNbr(trgBoxNbr) THEN
    L_Car.StandOnCarLog(trgBoxNbr, D);
    cffe_OneCheck(D, DrvTSN, trgBoxNbr, trgExit,
                  (CarLog.Purpose # L_Car.purp_Common) | P_Car.HasActualCarPro(trgBoxNbr, D, P_Car.P_CarLicenCard),
                  cffe_Yes, cffeR_BadCarLicenCard, "", Local, Action);
    cffe_OneCheck(D, DrvTSN, trgBoxNbr, trgExit, P_Car.HasActualCarPro(trgBoxNbr, D, P_Car.P_Checkup),
                  cffe_Yes, cffeR_BadCarCheckup, "", Local, Action);
    P_Car.GetBegRWSSpecific(trgBoxNbr, D, Default, ReasonStr);
    cffe_OneCheck(D, DrvTSN, trgBoxNbr, trgExit, ~P_Car.HasActualCarPro(trgBoxNbr, D, P_Car.P_BegRWSSpecific),
                  Default, "", "ᮡ ࠧ浪 : " + ReasonStr, Local, Action);

   END;
   IF ~!DrvTSN THEN
    cffe_OneCheck_wSFF(D, DrvTSN, trgBoxNbr, trgExit, DriverIsAuthorizedToExit(D, DrvTSN, trgExit),
                       cffe_wChoice, cffeR_DoesNotAuthorizedToExit, "", Local, Action,
                       SYSDATE()+30, cffe_wInform);
   END;
   IF ~!trgBoxNbr & L_Env.RealBoxNbr(trgBoxNbr) & ~!trgExit THEN
    cffe_OneCheck(D, DrvTSN, trgBoxNbr, trgExit, CarPsgVolumeFitToExit(D, trgBoxNbr, trgExit),
                  cffe_NotInAutoMake, cffeR_BadCarPsgVolume, "", Local, Action);

   END;
   IF ~!trgExit &
      ((Action = L_XDoc.action_AutoBuild) |
       (Action = L_XDoc.action_AutoEdit)  |
       (Action = L_XDoc.action_begInsert) |
       (Action = L_XDoc.action_begEdit)   |
       (Action = action_EditInTWO))        THEN
    SEARCH(StExit, Exit, , trgExit);
    cffe_OneCheck(D, GrdTSN[0], trgBoxNbr, trgExit, !GrdTSN[0] | (StExit.GuNeed # L_Way.egn_Prohibited),
                  cffe_No, cffeR_GuardProhibitedInExit, "", Local, Action);
    IF (Action = L_XDoc.action_begInsert) |
       (Action = L_XDoc.action_begEdit)   THEN
     IF !GrdTSN[0] THEN
      cffe_OneCheck(D, GrdTSN[0], trgBoxNbr, trgExit, (StExit.GuNeed # L_Way.egn_Required),
                    cffe_wChoice, cffeR_GuardRequiredInExit, "", Local, Action);
     ELSE
      CONFORM(StExit, ExitClss);
      cffe_OneCheck(D, GrdTSN[0], trgBoxNbr, trgExit,
                    (ExitClss.BegType = L_Way.ecbt_Line) | (ExitClss.BegType = L_Way.ecbt_Reserv),
                    cffe_wChoice, cffeR_GuardInNotLineExit, "", Local, Action);
     END;
    END;
   END;
   cffe_CheckRestTime(D, DrvTSN, GrdTSN, trgBoxNbr, trgExit, Local, Action);
   IF Action = L_XDoc.action_begDst THEN
    IF ~!trgBoxNbr & L_Env.RealBoxNbr(trgBoxNbr) THEN
     cffe_OneCheck(D, DrvTSN, trgBoxNbr, trgExit, P_Car.HasActualCarPro(trgBoxNbr, D, P_Car.P_CLI_Obligatory),
                   cffe_Yes, cffeR_BadCarCLIO, "", Local, Action);
     cffe_OneCheck(D, DrvTSN, trgBoxNbr, trgExit, P_Car.HasActualCarPro(trgBoxNbr, D, P_Car.P_KACKO),
                   cffe_Yes, cffeR_BadCarKACKO, "", Local, Action);
    END;
   END; (* IF    (Action =... *)
  ELSIF (Action = L_XDoc.action_Edit)     THEN
  ELSE
   L_General.CallUs(0);
  END; (* IF    (Action =... *)

  Local:=PROCREF(E_Way.cffe_UserDefinedCheck);
  IF ~!Local THEN
   Default  :=cffe_Yes;
   ReasonStr:="";
   Local(D, DrvTSN, GrdTSN, trgBoxNbr, trgExit, Default, ReasonStr, Action);
   cffe_Bark(Default, ReasonStr);
  END;
 END {cffe_CommonChecks};

 PUBLIC PROCEDURE E_CheckCrewFitForExit(Action: L_XDoc.tAction);
     (* RWayS.RWayS_OnAfterEdIns         action_Edit
        L_TWO.DtwoBindRWayS              action_AutoBuild, action_AutoEdit
        BegRWS.WriteOut                  action_begDst
        BegRWS.AfterEdInsOrderedRWayS    action_begEdit, action_begInsert *)
  VAR
   Local : PROC;
   D     : DATE;
   GrdTSN: LIKE(Staff.TSN)[100];
   GrdCnt: NUMERIC[0];
 BEGIN

  Local:=PROCREF(E_Way.cffe_Correct);
  D    :=RWayS.Date;

  cffe_Silent:=0;
  MayDrive(RWayS.Date, RWayS.BoxNbr, RWayS.TSN, L_Way.rwswho_Driver, RWayS.Exit, Local, Action);

  CONFORM(RWayS, WayLMen);
  SETEMPTY(GrdTSN); GrdCnt:=0;
  WHILE OCCURE(WayLMen) DO
   IF    WayLMen.Who = L_Way.wlmwho_DrPupil THEN
    MayDrive(RWayS.Date, RWayS.BoxNbr, WayLMen.TSN, L_Way.rwswho_DrPupil, RWayS.Exit, Local, Action);
   ELSIF WayLMen.Who = L_Way.wlmwho_SDriver THEN
    MayDrive(RWayS.Date, RWayS.BoxNbr, WayLMen.TSN, L_Way.rwswho_SDriver, RWayS.Exit, Local, Action);
   ELSE
    IF WayLMen.Who = L_Way.wlmwho_Guard THEN
     GrdTSN[GrdCnt]:=WayLMen.TSN;
     INC(GrdCnt);
    END;
    cffe_OneCheck(D, WayLMen.TSN, RWayS.BoxNbr, RWayS.Exit,
                  ~L_Way.CrewHasMyFirmContradiction(D, WayLMen.TSN, RWayS.BoxNbr),
                  cffe_No, cffeR_MyFirmContradiction,
                  cffeRS_MyFirmContradiction(WayLMen.Who+1), Local, Action);
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)

  cffe_CommonChecks(D, RWayS.TSN, GrdTSN, RWayS.BoxNbr, RWayS.Exit, Local, Action);
 END {E_CheckCrewFitForExit};

 PUBLIC PROCEDURE E_CrewFitForExit(D        : DATE;
                                   trgTSN   : LIKE(Staff.TSN);
                                   trgBoxNbr: LIKE(Car.BoxNbr);
                                   trgExit  : LIKE(StExit.Exit)): SCAL[2];
  VAR
   Local : PROC;
   GrdTSN: LIKE(Staff.TSN)[100];
 BEGIN
  SETEMPTY(GrdTSN);
  Local:=PROCREF(E_Way.cffe_Correct);
  cffe_Silent:=1;
  cffe_Fit   :=1;
  cffe_OneCheck(D, trgTSN, trgBoxNbr, trgExit, ~L_Way.CrewHasMyFirmContradiction(D, trgTSN, trgBoxNbr),
                cffe_No, cffeR_MyFirmContradiction,
                cffeRS_MyFirmContradiction(L_Way.rwswho_Driver), Local, L_XDoc.action_AutoBuild);
  cffe_CommonChecks(D, trgTSN, GrdTSN, trgBoxNbr, trgExit, Local, L_XDoc.action_AutoBuild);
  RETURN cffe_Fit;
 END {E_CrewFitForExit};

 PUBLIC PROCEDURE E_CheckCrewInTWOEdit(D        : DATE;
                                       DrvTSN   : LIKE(Staff.TSN);
                                       trgBoxNbr: LIKE(Car.BoxNbr);
                                       trgExit  : LIKE(StExit.Exit);
                                       GrdTSN   : LIKE(Staff.TSN));
  VAR
   Local    : PROC;
   Fit      : tCrewFitnessForExit;
   ReasonStr: STRING[];
 BEGIN
  Local:=PROCREF(E_Way.cffe_Correct);
  cffe_Silent:=0;
  MayDrive(D, trgBoxNbr, DrvTSN, L_Way.rwswho_Driver, trgExit, Local, action_EditInTWO);
  cffe_OneCheck(D, GrdTSN, trgBoxNbr, trgExit, ~L_Way.CrewHasMyFirmContradiction(D, GrdTSN, trgBoxNbr),
                cffe_No, cffeR_MyFirmContradiction,
                cffeRS_MyFirmContradiction(L_Way.rwswho_Guard), Local, action_EditInTWO);
  cffe_CommonChecks(D, DrvTSN, GrdTSN, trgBoxNbr, trgExit, Local, action_EditInTWO);
 END {E_CheckCrewInTWOEdit};

 PUBLIC PROCEDURE E_GetWayLMenWhoOfGuard(): L_Way.tWLMWho;
  VAR
   Local : PROC;
   Result: L_Way.tWLMWho;
 BEGIN
  Result:=L_Way.wlmwho_Guard;
  Local:=PROCREF(E_Way.GetWayLMenWhoOfGuard);
  IF ~!Local THEN
   Result:=Local(Result);
  END;
  RETURN Result;
 END {E_GetWayLMenWhoOfGuard};

 PUBLIC PROCEDURE IsFictiveRWayS(): SCAL[2];
 BEGIN
  RETURN ~L_Env.RealTSN(RWayS.TSN) & ~L_Env.RealBoxNbr(RWayS.BoxNbr) & ~L_Way.E_IsGuardIdleExit(RWayS.Date, RWayS.Exit);
 END {IsFictiveRWayS};

 PUBLIC PROCEDURE GetCWOrderList(): STRING[];
  VAR
   CWOrderList: STRING[];
 BEGIN
  SETEMPTY(CWOrderList);
  IF SELECT(CWOrder, RWayS, RWayS.RWayS) THEN
   WHILE OCCURE(CWOrder) DO
    CWOrderList:=L_Str.AddStrDlm(CWOrderList, ";") + " N " + CWOrder.CWOrder;
    NEXT(CWOrder);
   END; (* WHILE OCCURE(CWOrder)...*)
  END;
  RETURN CWOrderList;
 END {GetCWOrderList};

END.
