(*
%Copyright   (c) Polak IT
%Author      08.06.2005 18:03:28 POLAK\LDA
%Purpose     ⥪  ࠡ  ४묨 ᤥ
%Type        library
%Specific    AP
%Modified    11.03.2010 23:02:59 POLAK\Gina
%Environment
*)

 MODULE L_CarAD [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_XDoc, L_MDoc, L_Pmnt, L_DatTim, E_Pmnt;

 PUBLIC CONST
  psidx_Netto = 0;
  psidx_VAT   = 1;

 PUBLIC PROCEDURE AccessCarAD();
 BEGIN
  L_General.Assert(ACCESS(CarAD), " ࠭ ४ ᤥ");
 END {AccessCarAD};

 PUBLIC PROCEDURE CarADAsStr(): STRING[];
 BEGIN
  RETURN CarAD.CarAD + "  " + L_DatTim.DateStr(CarAD.Date);
 END {CarADAsStr};

 PUBLIC PROCEDURE GetCarADLTotal(): NUMERIC[2];
 BEGIN
  RETURN CarADL.Mount[psidx_Netto] + CarADL.Dismount[psidx_Netto] + CarADL.Sum[psidx_Netto];
 END {GetCarADLTotal};

 PUBLIC PROCEDURE GetCarADLTotalVAT(): NUMERIC[2];
 BEGIN
  RETURN CarADL.Mount[psidx_VAT] + CarADL.Dismount[psidx_VAT] + CarADL.Sum[psidx_VAT];
 END {GetCarADLTotalVAT};

 PUBLIC PROCEDURE IsAcceptableAddMDocKind(addMDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
 BEGIN
  RETURN (addMDocKind = L_MDoc.md_IsS) |
         (addMDocKind = L_MDoc.md_IAS);
 END {IsAcceptableAddMDocKind};

 PUBLIC PROCEDURE RemAddDoc();
 BEGIN
  AccessCarAD();
  L_Pmnt.ConfirmRemovingDocs(0,
                             L_Pmnt.RemoveGeneratedMDocs(0,
                                                         L_Pmnt.sbvmd_Online,
                                                         L_Pmnt.GetAddMDocKind(PROCREF(IsAcceptableAddMDocKind), " 㬥"),
                                                         L_XDoc.xdt_CarAD,
                                                         L_XDoc.EmptyXDocKind,
                                                         CarAD.CarAD));
 END {RemAddDoc};

 PRIVATE PROCEDURE DecodeCarADId(_XDocId   : L_XDoc.tXDocId;
                                 VAR _CarAD: LIKE(CarAD.CarAD));
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
 BEGIN
  L_XDoc.DecodeXDocId(_XDocId, _XDocType, _XDocKind, _CarAD);
  L_General.Assert(_XDocType = L_XDoc.xdt_CarAD,
                   "L_Pmnt.DecodeCarADId.Error 1");
 END {DecodeCarADId};

 PUBLIC PROCEDURE IsLastMDocInPeriod(D: DATE): SCAL[2];
 BEGIN
  RETURN L_DatTim.Per(CarADL.EndDate) <= L_DatTim.Per(D);
 END {IsLastMDocInPeriod};

 PUBLIC PROCEDURE GetDaysToPay(_Date: DATE): NUMERIC[0];
 BEGIN
  RETURN L_DatTim.MinDATE(L_DatTim.MonthEnd(_Date), CarADL.EndDate) - L_DatTim.MaxDATE(L_DatTim.MonthBeg(_Date), CarADL.BegDate) + 1;
 END {GetDaysToPay};

 PUBLIC PROCEDURE CalcCarADLPartSum(_Cost: NUMERIC[2]; BDate: DATE; LastInPeriod: SCAL[2]): NUMERIC[2];
  VAR
   FirstMonthCost: NUMERIC[2];
 BEGIN
  IF LastInPeriod THEN
   FirstMonthCost:=CalcCarADLPartSum(_Cost, CarADL.BegDate, 0);
   IF _Cost = FirstMonthCost THEN
    RETURN _Cost;
   ELSE
    RETURN _Cost - FirstMonthCost;
   END;
  ELSE
   RETURN (_Cost / L_DatTim.MonthLen(BDate)) * GetDaysToPay(BDate);
  END;
 END {CalcCarADLPartSum};

 PUBLIC PROCEDURE E_GetMountMath(D: DATE): LIKE(Math.Math);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Pmnt.GetMountMath);
  IF ~!Local THEN
   RETURN Local(D);
  ELSE
   L_General.ConsultToUs(0, "GatherSingleCarAD:  ।  '⠦'");
  END;
 END {E_GetMountMath};

 PUBLIC PROCEDURE E_GetDismountMath(D: DATE): LIKE(Math.Math);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Pmnt.GetDismountMath);
  IF ~!Local THEN
   RETURN Local(D);
  ELSE
   L_General.ConsultToUs(0, "GatherSingleCarAD:  ।  '⠦'");
  END;
 END {E_GetDismountMath};

END.
