(*
%Copyright   (c) Polak IT
%Author      08.08.2003 18:10:13 POLAK\LDA
%Purpose        ॢ
%Type        library
%Specific    AP
%Modified    06.02.2014 14:24:51 POLAK\LDA
%Environment
*)

 MODULE L_CWOrder [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  ct_Standart    = 0;
  ct_Discount    = 1;
  ct_ECharge     = 2;
  ct_AgreedPrice = 3;

  ct_Pool = "⠭||業|୮";

  pl_Undefined = 0;
  pl_Defined   = 1;

  pl_Pool = "।|।";

  st_Prepared  = 0; (* ⮢ *)
  st_Passed    = 1; (* ஢    *)
  st_Canceled  = 2; (* 㫨஢ *)
  st_Pool = "⮢|஢|㫨஢";

 IMPORT L_XDoc, L_General, L_DatTim, E_CWOrd, P_Cntr, L_Str, L_Pmnt, L_MDoc, L_Way, L_Hld,
        L_AFM, P_Math, Math, P_Firm, L_Acnt, L_StdFrm;

 PUBLIC PROCEDURE AccessCWOrder();
 BEGIN
  L_General.Assert(ACCESS(CWOrder), " ࠭    ॢ");
 END {AccessCWOrder};

 PRIVATE PROCEDURE DecodeCWOrdId(_CWOrdId   : STRING[];
                                 VAR _CWOrder: LIKE(CWOrder.CWOrder));
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
 BEGIN
  L_XDoc.DecodeXDocId(_CWOrdId, _XDocType, _XDocKind, _CWOrder);
  L_General.Assert(_XDocType = L_XDoc.xdt_CWOrder,
                   "L_CWOrder.DecodeCWOrdId.Error 1");
 END {DecodeCWOrdId};

(* ------------------------------------------------------------------------ *)

 PUBLIC PROCEDURE GetCWOrder_IP_CalculateKind(_Contract: LIKE(Contract.Contract);
                                              _Date    : DATE): P_Cntr.tIP_CalculateKind;
 BEGIN
  L_General.Assert(~!_Contract, " 㪠 ");
  RETURN P_Cntr.Get_IP_CalculateKind(_Contract, _Date);
 END {GetCWOrder_IP_CalculateKind};

 PUBLIC PROCEDURE E_GetIP_Math(D: DATE): LIKE(Math.Math);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_CWOrd.GetIP_Math);
  L_General.Assert(~!Local, " ।    客 ᡮ஢");
  RETURN Local(D);
 END {E_GetIP_Math};

 PUBLIC PROCEDURE CWOrderStr(): STRING[];
 BEGIN
  RETURN " " + CWOrder.CWOrder + "  " + L_DatTim.DateStr(CWOrder.Date);
 END {CWOrderStr};

 PUBLIC PROCEDURE IsAcceptableAddMDocKind(addMDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
 BEGIN
  RETURN (addMDocKind = L_MDoc.md_IsS) | (addMDocKind = L_MDoc.md_ISA);
 END {IsAcceptableAddMDocKind};

 PUBLIC PROCEDURE GetDateTimeIntvlDuration(_BDate: DATE; _BTime: TIME;
                                           _EDate: DATE; _ETime: TIME): NUMERIC[3];
 BEGIN
  RETURN (_EDate - _BDate) * 24 + (-24 * (_ETime < _BTime)) + (_ETime - _BTime);
 END {GetDateTimeIntvlDuration};

 PUBLIC PROCEDURE GetTimeInIntvl(begDate     : DATE;
                                 begTime     : TIME;
                                 endDate     : DATE;
                                 endTime     : TIME;
                                 begIntvlTime: TIME;
                                 endIntvlTime: TIME;
                                 Cond        : PROC): NUMERIC[3];
  VAR
   trgDate        : DATE;
   Result         : FLOAT;
   begSpcIntvlDTS,
   endSpcIntvlDTS,
   begFullIntvlDTS,
   endFullIntvlDTS,
   begSingleDayDTS,
   endSingleDayDTS: TIMESTAMP;
 BEGIN
  SETZERO(Result);
  begFullIntvlDTS:=PackTIMESTAMP(begDate, begTime);
  endFullIntvlDTS:=PackTIMESTAMP(endDate, endTime);

  LOOP
   begSingleDayDTS:=Math.Max(begFullIntvlDTS, PackTIMESTAMP(begDate,   00:00));
   endSingleDayDTS:=Math.Min(endFullIntvlDTS, PackTIMESTAMP(begDate+1, 00:00));

   IF endSingleDayDTS < begSingleDayDTS THEN
    EXIT;
   END;

   IF !Cond | Cond(begDate) THEN
    IF begIntvlTime>=endIntvlTime THEN
     trgDate:=begDate-1;
    ELSE
     trgDate:=begDate;
    END;
    LOOP
     begSpcIntvlDTS:=Math.Max(PackTIMESTAMP(trgDate, begIntvlTime), begSingleDayDTS);
     endSpcIntvlDTS:=Math.Min(PackTIMESTAMP(trgDate+(begIntvlTime>=endIntvlTime), endIntvlTime), endSingleDayDTS);
     IF ~L_DatTim.IsActive_Inc(begDate, L_DatTim.GetDateOfTIMESTAMP(begSpcIntvlDTS), L_DatTim.GetDateOfTIMESTAMP(endSpcIntvlDTS)) THEN
      EXIT;
     END;
     IF begSpcIntvlDTS < endSpcIntvlDTS THEN
      INC(Result, (endSpcIntvlDTS-begSpcIntvlDTS)*24);
     END;
     INC(trgDate)
    END; (* LOOP *)
   END;
   INC(begDate);
  END; (* LOOP *)

  RETURN Result
 END {GetTimeInIntvl};

 PUBLIC PROCEDURE Create_TaxInfFile();
  CONST
   OtherAddingAmount = 3;
 BEGIN
  IF !DATABASE.Get().Tables("TxInf") THEN
   CreateFILE(TxInf, "", "६ 䠩", "");
 
   CreateFIELD(TxInf, CWOrder,  LIKE(CWOrder.CWOrder),         "", "", "", "", "");
   CreateFIELD(TxInf, BegDate,  DATE,                          "", "", "", " 砫 ", "");
   CreateFIELD(TxInf, BegTime,  TIME,                          "", "", "", "६ 砫 ", "");
   CreateFIELD(TxInf, EndDate,  DATE,                          "", "", "", " 砭 ", "");
   CreateFIELD(TxInf, EndTime,  TIME,                          "", "", "", "६ 砭 ", "");
   CreateFIELD(TxInf, HourlyP,  NUMERIC[2],                    "", "", "", "ᮢ ⠢, .", "");
   CreateFIELD(TxInf, Speed,    NUMERIC[0],                    "", "", "", "祭   ஡, .", "");
   CreateFIELD(TxInf, OverRunP, NUMERIC[2],                    "", "", "", "  ९஡, .", "");
   CreateFIELD(TxInf, NghtHrAd, NUMERIC[2],                    "", "", "", "  筮 ६, .", "");
   CreateFIELD(TxInf, HldHrAdd, NUMERIC[2],                    "", "", "", "  ࠧ筮 ६, .", "");
   CreateFIELD(TxInf, WTimAdd,  NUMERIC[2],                    "", "", "", "  ६ , .", "");
   CreateFIELD(TxInf, a_Other,  NUMERIC[2][OtherAddingAmount], "", "", "", "稥 , .", "");
   CreateFIELD(TxInf, a_OtherN, STRING[64][OtherAddingAmount],   "", "", "", "  ", "");
   CreateFIELD(TxInf, DcrTim,   NUMERIC[3],                    "", "", "", "稢 ६, .", "");
   CreateFIELD(TxInf, Duration, NUMERIC[3],                    "", "", "", "த⥫쭮 , .", "");
   CreateFIELD(TxInf, Time,     NUMERIC[3],                    "", "", "", "饥 ६  , .", "");
   CreateFIELD(TxInf, NightTim, NUMERIC[3],                    "", "", "", "筮 ६, .", "");
   CreateFIELD(TxInf, HldTim,   NUMERIC[3],                    "", "", "", "ࠧ筮 ६, .", "");
   CreateFIELD(TxInf, WTim,     NUMERIC[3],                    "", "", "", "६ , .", "");
   CreateFIELD(TxInf, t_Other,  NUMERIC[2][OtherAddingAmount], "", "", "", "祥 ६, .", "");
   CreateFIELD(TxInf, Run,      NUMERIC[0],                    "", "", "", "஡, .", "");
   CreateFIELD(TxInf, OverRun,  NUMERIC[0],                    "", "", "", "९஡, .", "");
   CreateFIELD(TxInf, Sum,      NUMERIC[2],                    "", "", "", " ६, ", "");
   CreateFIELD(TxInf, NightSum, NUMERIC[2],                    "", "", "", " ᥣ, ", "");
   CreateFIELD(TxInf, HldSum,   NUMERIC[2],                    "", "", "", "ࠧ ᥣ, ", "");
   CreateFIELD(TxInf, WTimSum,  NUMERIC[2],                    "", "", "", " ६  ᥣ, ", "");
   CreateFIELD(TxInf, s_Other,  NUMERIC[2][OtherAddingAmount], "", "", "", " ६  ᥣ, ", "");
   CreateFIELD(TxInf, OverRunS, NUMERIC[2],                    "", "", "", "९஡ ᥣ, ", "");
   CreateFIELD(TxInf, TotalSum, NUMERIC[2],                    "", "", "", "ᥣ (), ", "");
   CreateFIELD(TxInf, VAT,      NUMERIC[2],                    "", "", "", ", ", "");
   CreateFIELD(TxInf, IPSum,    NUMERIC[2],                    "", "", "", "客 ᡮ, ", "");
 
   CreateINDEXandLINK(TxInf, CWOrder, UNIQUE, CWOrder, CWOrder, USER, "", "", CWOrder);
   SetVersionOfFILE(TxInf, 0);
  END;
  L_AFM.AF_CreateTemp("TxInf", "TxInf");
 END {Create_TaxInfFile};

 PRIVATE PROCEDURE ApplyPriceLevel(VAR Value: NUMERIC[2]; plt: P_Cntr.t_PriceLevelType; plv: NUMERIC[4]);
 BEGIN
  IF    plt = P_Cntr.plt_Scale    THEN
   L_General.Error(" ਬ ''  '஢ 業'");
  ELSIF plt = P_Cntr.plt_Charge   THEN
   Value:=Value * (1 + plv / 100);
  ELSIF plt = P_Cntr.plt_Discount THEN
   Value:=Value * (1 - plv / 100);
  END;
 END {ApplyPriceLevel};

 PUBLIC PROCEDURE GetCWOrderTariff(VAR MarkG            : LIKE(MarkG.MarkG);
                                   VAR Tariff_wVAT      : SCAL[2];
                                   VAR HourlyPay        : NUMERIC[2];
                                   VAR NightHourlyAdding: NUMERIC[2];
                                   VAR HldHourlyAdding  : NUMERIC[2];
                                   VAR WaitTimeAdding   : NUMERIC[2];
                                   VAR MinOrderLength   : NUMERIC[1];
                                   VAR Speed            : NUMERIC[0];
                                   VAR OverRunPay       : NUMERIC[2]);
  VAR
   plt: P_Cntr.t_PriceLevelType;
   plv: NUMERIC[4];
 BEGIN
  P_Math.GetCWOrderTariff(CWOrder.Math,
                          CWOrder.Date,
                          MarkG,
                          Tariff_wVAT,
                          HourlyPay,
                          NightHourlyAdding,
                          HldHourlyAdding,
                          WaitTimeAdding,
                          MinOrderLength,
                          Speed,
                          OverRunPay);
  P_Cntr.GetPriceLevel(CWOrder.Contract, CWOrder.Date, plt, plv);
  IF ~!plt THEN
   ApplyPriceLevel(HourlyPay,         plt, plv);
   ApplyPriceLevel(NightHourlyAdding, plt, plv);
   ApplyPriceLevel(HldHourlyAdding,   plt, plv);
   ApplyPriceLevel(WaitTimeAdding,    plt, plv);
   ApplyPriceLevel(OverRunPay,        plt, plv);
  END;
 END {GetCWOrderTariff};

 PRIVATE PROCEDURE E_InsurancePayment_ByOneMan(D: DATE): NUMERIC[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_CWOrd.InsurancePayment_ByOneMan);
  IF ~!Local THEN
   RETURN Local(D);
  ELSE
   RETURN 0;
  END;
 END {E_InsurancePayment_ByOneMan};

 PUBLIC PROCEDURE CalcCWOrdIPSum(_Sum: NUMERIC[2]): NUMERIC[2];
  CONST
   IP_Percent = 5 / 100;
  VAR
   Local            : PROC;
   IPSum,
   IPSum_ByPrc,
   IPSum_ByPsg      : NUMERIC[2];
   _IP_CalculateKind: P_Cntr.tIP_CalculateKind;
 BEGIN
  IF ~!_Sum THEN
   _IP_CalculateKind:=GetCWOrder_IP_CalculateKind(CWOrder.Contract, CWOrder.Date);
   IF _IP_CalculateKind = P_Cntr.ipck_Free THEN
    RETURN 0;
   ELSE
    IPSum_ByPrc:=_Sum * IP_Percent;
    IPSum_ByPsg:=E_InsurancePayment_ByOneMan(CWOrder.Date) * CWOrder.p_PsgAm;
    IF    _IP_CalculateKind = P_Cntr.ipck_Percent THEN
     IPSum:=IPSum_ByPrc;
    ELSIF _IP_CalculateKind = P_Cntr.ipck_PsgAmnt THEN
     IPSum:=IPSum_ByPsg;
    ELSIF _IP_CalculateKind = P_Cntr.ipck_PsgAmntORPercent THEN
     IF IPSum_ByPsg < IPSum_ByPrc THEN
      IPSum:=IPSum_ByPrc;
     ELSE
      IPSum:=IPSum_ByPsg;
     END;
    ELSE
     IPSum:=0;
    END;
    Local:=PROCREF(E_CWOrd.CalcInsurancePayment);
    IF ~!Local THEN
     RETURN Local(CWOrder.Date, _Sum, IPSum, _IP_CalculateKind);
    ELSE
     RETURN IPSum;
    END;
   END;
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {CalcCWOrdIPSum};

 PRIVATE PROCEDURE E_CalcOtherAdding(D: DATE);
  VAR
   Local: PROC;
 BEGIN
  SETZERO(TxInf.a_Other, TxInf.t_Other);
  SETEMPTY(TxInf.a_OtherN);
  Local:=PROCREF(E_CWOrd.CalcOtherAdding);
  IF ~!Local THEN
   Local(D);
  END;
 END {E_CalcOtherAdding};

 PRIVATE PROCEDURE E_RoundCWOrderDuration(trgDate: DATE; trgTime: NUMERIC[3]): NUMERIC[3];
  VAR
   Local : PROC;
   Result: NUMERIC[3];
 BEGIN
  Result:=trgTime;
  Local :=PROCREF(E_CWOrd.RoundCWOrderDuration);
  IF ~!Local THEN
   Result:=Local(trgDate, Result);
  END;
  RETURN Result;
 END {E_RoundCWOrderDuration};

 PUBLIC PROCEDURE GetCWOrderDuration(trgDate   : DATE;
                                     trgBegDate: DATE;
                                     trgBegTime: TIME;
                                     trgEndDate: DATE;
                                     trgEndTime: TIME;
                                     trgDcrTim : NUMERIC[2]): NUMERIC[3];
  VAR
   Result: NUMERIC[3];
 BEGIN
  Result:=GetDateTimeIntvlDuration(trgBegDate, trgBegTime, trgEndDate, trgEndTime);
  L_General.Assert(Result >= 0, "४⭠ த⥫쭮 ");
  L_General.Assert((trgDcrTim >= 0) & (trgDcrTim <= Result), "⨬ 稭 㬥襭 ६  ");
  DEC(Result, trgDcrTim);

  RETURN E_RoundCWOrderDuration(trgDate, Result);
 END {GetCWOrderDuration};

 PUBLIC PROCEDURE CalcSingleCWOrderSum(CalcFactSum, Silent: SCAL[2]);
  VAR
   i             : NUMERIC[0];
   Msg           : STRING[];
   trgMarkG      : LIKE(MarkG.MarkG);
   Tariff_wVAT   : SCAL[2];
   MinOrderLength: NUMERIC[3];
   curTotalSum   : NUMERIC[2];
 BEGIN
  Msg:=" " + L_Str.PoolItem("|䠪᪮", CalcFactSum) + " ⮨ :|";
  TxInf.CWOrder :=CWOrder.CWOrder;

  GetCWOrderTariff(trgMarkG,
                   Tariff_wVAT,
                   TxInf.HourlyP,
                   TxInf.NghtHrAd,
                   TxInf.HldHrAdd,
                   TxInf.WTimAdd,
                   MinOrderLength,
                   TxInf.Speed,
                   TxInf.OverRunP);

  IF CalcFactSum THEN
   TxInf.BegDate :=CWOrder.DeptDate;
   TxInf.BegTime :=CWOrder.DeptTime;
   TxInf.EndDate :=CWOrder.RetDate;
   TxInf.EndTime :=CWOrder.RetTime;
   TxInf.Run     :=CWOrder.RetSM - CWOrder.DeptSM;
   TxInf.DcrTim  :=CWOrder.DcrTim;
   TxInf.WTim    :=CWOrder.WaitTim;
  ELSE
   TxInf.BegDate :=CWOrder.p_DeptD;
   TxInf.BegTime :=CWOrder.p_DeptT;
   TxInf.EndDate :=CWOrder.p_RetD;
   TxInf.EndTime :=CWOrder.p_RetT;
   TxInf.Run     :=CWOrder.p_Run;
   TxInf.DcrTim  :=CWOrder.p_DcrTim;
   TxInf.WTim    :=CWOrder.p_WTim;
  END;

  TxInf.Duration:=GetCWOrderDuration(CWOrder.Date, TxInf.BegDate, TxInf.BegTime, TxInf.EndDate, TxInf.EndTime, TxInf.DcrTim);
  TxInf.NightTim:=GetTimeInIntvl(TxInf.BegDate, TxInf.BegTime, TxInf.EndDate, TxInf.EndTime, 22:00, 06:00, EMPTYOF(PROC));
  TxInf.HldTim  :=GetTimeInIntvl(TxInf.BegDate, TxInf.BegTime, TxInf.EndDate, TxInf.EndTime, 00:00, 00:00, PROCREF(L_Hld.DayIsHoliday));

  L_General.Assert(TxInf.Duration >= 0, Msg + "⥫쭠 த⥫쭮 ");
  L_General.Assert(TxInf.Run >= 0, Msg + "⥫ ஡  ");

  IF TxInf.Duration < MinOrderLength THEN
   TxInf.Time:=MinOrderLength;
  ELSE
   TxInf.Time:=TxInf.Duration;
  END;
  E_CalcOtherAdding(CWOrder.Date);

  TxInf.OverRun :=Math.Max(0, TxInf.Run - TxInf.Time * TxInf.Speed);
  SETZERO(TxInf.Sum, TxInf.NightSum, TxInf.HldSum, TxInf.WTimSum, TxInf.OverRunS, TxInf.s_Other);
  IF    CWOrder.CalcType = ct_AgreedPrice THEN
   curTotalSum:=CWOrder.CalcVal;
  ELSIF CalcFactSum & CWOrder.FixPlnSm THEN
   IF Tariff_wVAT THEN
    curTotalSum:=CWOrder.p_Sum + CWOrder.p_VAT;
   ELSE
    curTotalSum:=CWOrder.p_Sum;
   END;
  ELSE
   TxInf.NightSum:=TxInf.NghtHrAd * TxInf.NightTim;
   TxInf.HldSum  :=TxInf.HldHrAdd * TxInf.HldTim;
   TxInf.Sum     :=TxInf.HourlyP * TxInf.Time + TxInf.NightSum + TxInf.HldSum;
   TxInf.OverRunS:=TxInf.OverRunP * TxInf.OverRun;
   TxInf.WTimSum :=TxInf.WTimAdd  * TxInf.WTim;

   curTotalSum   :=TxInf.Sum + TxInf.WTimSum + TxInf.OverRunS;
   i:=0;
   WHILE (i <= HIGH(TxInf.a_OtherN)) & ~!TxInf.a_OtherN[i] DO
    TxInf.s_Other[i]:=TxInf.a_Other[i] * TxInf.t_Other[i];
    INC(curTotalSum, TxInf.s_Other[i]);
    INC(i);
   END; (* WHILE (i <= HIGH(TxInf.a_OtherN)) &...*)
  END;

  IF CWOrder.CalcType = ct_Discount THEN
   curTotalSum:=curTotalSum * (1 - CWOrder.CalcVal / 100);
  ELSIF CWOrder.CalcType = ct_ECharge THEN
   curTotalSum:=curTotalSum * (1 + CWOrder.CalcVal / 100);
  END;

  CONFORM(CWOrder, Contract);
  IF P_Firm.FirmHasSimplifiedTaxation(P_Firm.fomf(Contract.MyFirm), CWOrder.Date) THEN
   L_General.Assert(~Tariff_wVAT, " ࣠樨,  饩 ⥫騪 ,|"+
                                  "   ᮤঠ ");
   TxInf.VAT     :=0;
   TxInf.TotalSum:=curTotalSum;
  ELSE
   IF Tariff_wVAT THEN
    TxInf.VAT     :=L_Acnt.GetInclVAT(CWOrder.Date, curTotalSum);
    TxInf.TotalSum:=curTotalSum - TxInf.VAT;
   ELSE
    TxInf.VAT     :=L_Acnt.GetExclVAT(CWOrder.Date, curTotalSum);
    TxInf.TotalSum:=curTotalSum;
   END;
   IF P_Cntr.GetInHouse(Contract.Contract, CWOrder.Date) THEN
    TxInf.VAT:=0;
   END;
  END;
  TxInf.IPSum:=CalcCWOrdIPSum(TxInf.TotalSum);
  INSERT(TxInf);
 END {CalcSingleCWOrderSum};

 PUBLIC PROCEDURE Purge_TaxInfFile();
 BEGIN
  L_AFM.AF_PurgeTemp("TxInf");
 END {Purge_TaxInfFile};

 PUBLIC PROCEDURE CWOrderIsTaxed(): SCAL[2];
 BEGIN
  RETURN ~!CWOrder.Sum;
 END {CWOrderIsTaxed};

END.
