(*
%Copyright   (c) Polak IT
%Author      25.08.2009 14:59:32 POLAK\LDA
%Purpose      த ⮢
%Type        library
%Specific    AP
%Modified    09.01.2014 19:50:35 POLAK\Bor
%Environment
*)

 MODULE L_IRec [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT P_Firm, E_Way, DBD, L_AFM, Str, L_lsStore, L_General, L_DatTim, L_StdFrm, L_XDoc;

 PUBLIC CONST
  src_Operator = 0;
  src_System   = 1;

  type_Departure = 0;
  type_Sale      = 1;

  type_Pool       = " ࠢ| த";
  type_Pool_Short = "|द";

  knd_Pool = "த|";

  knd_Sale   = 0;
  knd_Return = 1;

  paymth_Pool = "|࠭ᯮ⭠ |᪠ ";

  paymth_Cash          = 0;
  paymth_TransportCard = 1;
  paymth_BankCard      = 2;

  TicketK_Pool     = "|" +
                     "|᪨" +
                     "|죮" +
                     "|";

  TicketK_Pool_Short = "|||";

  tk_Full      = 0;
  tk_Child     = 1;
  tk_Privilege = 2;
  tk_Baggage   = 3;

  rm_MultiTicket_wSum    = 0;
  rm_SingleTicket        = 1;

  rm_Pool = "|᪮쪮 ⮢  㬬"+
            "|⢥ ";

  rk_Pool =  " ࠢ  2- ." +
            "|2 .    ࠢ" +
            "| 3- ᮢ ᫥ ࠢ" +
            "| ⮡" +
            "| ࠢ  1 ." +
            "|।⠢   " +
            "|" +
            "|";

  irls_Prepared = 0;
  irls_Passed   = 1;
  irls_Returned = 2;

  irlim_Manual   = 0;
  irlim_AutoFill = 1;
  irlim_Import   = 2;

 PUBLIC PROCEDURE E_GetIRecLInsertMode(): SCAL[9];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.ir_GetIRecLInsertMode);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN irlim_Manual;
  END;
 END {E_GetIRecLInsertMode};

 PUBLIC PROCEDURE E_GetPrivilegeTicketKindPool(D: DATE; Short: SCAL[2]): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.ir_GetPrivilegeTicketKindPool);
  IF ~!Local THEN
   RETURN Local(D, Short);
  ELSE
   RETURN "";
  END;
 END {E_GetPrivilegeTicketKindPool};

 PUBLIC PROCEDURE E_GetPaidPrc(): NUMERIC[2];
  VAR
   Local: PROC;
   Prc  : NUMERIC[0];
 BEGIN
  IF    IRecL.TicketK = tk_Full THEN
   Prc:=100.00;
  ELSIF IRecL.TicketK = tk_Child THEN
   Prc:=50.00;
  ELSIF IRecL.TicketK = tk_Baggage THEN
   Prc:=35.00;
  ELSE
   Prc:=0.00;
  END;

  Local:=PROCREF(E_Way.ir_GetPaidPrc);
  IF ~!Local THEN
   RETURN Local(IRec.Date, IRecL.TicketK, IRecL.PrivKind, Prc);
  ELSE
   RETURN Prc;
  END;
 END {E_GetPaidPrc};

 PUBLIC PROCEDURE E_IsOurIncomeReceivedPlace(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.ir_IsOurIncomeReceivedPlace);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 1;
  END;
 END {E_IsOurIncomeReceivedPlace};

 PUBLIC PROCEDURE E_IsOutsideTransporter(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.ir_IsOutsideTransporter);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN (IRec.CarrFirm # P_Firm.OWN_FIRM);
  END;
 END {E_IsOutsideTransporter};

 PUBLIC PROCEDURE intProceedIRec(_IRec: LIKE(IRec.IRec); wPrompt: SCAL[2]);
  VAR
   Dir      : NUMERIC[0];
   trgSingle: LIKE(IRec.Single);
   trgStartD: DATE;
   trgStartT: TIME;
   trgRoute : LIKE(Route.Route);
   trgBoxNbr: LIKE(IRecL.asBoxNbr);
 BEGIN
  SEARCH(IRec, IRec, , _IRec);
  SETZERO(IRec.tSum, IRec.tComisS, IRec.tInsurS, IRec.tServS, IRec.tBookS);

  trgSingle:=1;
  IF SELECT(IRecL, IRec, IRec.IRec) THEN
   trgStartD  :=IRecL.StartD;
   trgStartT  :=IRecL.StartT;
   trgRoute   :=IRecL.Route;
   trgBoxNbr  :=IRecL.asBoxNbr;
   WHILE OCCURE(IRecL) DO
    IF wPrompt THEN
     PROMPT(" ⮣: " + IRec.SrcNbr + "  " + L_DatTim.DateStr(IRec.Date) + ",  " + IRecL.TckNbr);
    END;

    IF (trgStartD # IRecL.StartD) |
       (trgStartT # IRecL.StartT) |
       (trgRoute # IRecL.Route)   |
       (trgBoxNbr # IRecL.asBoxNbr) THEN
     trgSingle:=0;
    END;
 
    IF IRec.Type = type_Departure THEN
     Dir:=+1;
    ELSE
     IF IRecL.Kind = knd_Sale THEN
      Dir:=+1;
     ELSE
      Dir:=-1;
     END;
    END;
 
    INC(IRec.tSum,    IRecL.TotalSum * Dir);
    INC(IRec.tComisS, IRecL.ComisFee * Dir);
    INC(IRec.tInsurS, IRecL.InsurFee * Dir);
    INC(IRec.tServS,  IRecL.ServFee  * Dir);
    INC(IRec.tBookS,  IRecL.BookFee  * Dir);
    NEXT(IRecL);
   END; (* WHILE OCCURE(IRecL) ... *)
  END;

  IRec.Single:=trgSingle;
  REPLACE(IRec);
 END {intProceedIRec};

 PUBLIC PROCEDURE ProceedIRec(_IRec: LIKE(IRec.IRec));
 BEGIN
  intProceedIRec(_IRec, 1);
 END {ProceedIRec};

 PUBLIC PROCEDURE extGatherSaleIRecs(trgSrcNbr              : LIKE(IRec.SrcNbr);
                                     trgDprtStrg            : LIKE(Storage.Storage);
                                     trgCarrFirm            : LIKE(Firm.Firm);
                                     trgIRec                : LIKE(IRec.IRec);
                                     BPer, EPer           : DATE;
                                     wDeleteReturnedTicket: SCAL[2]);
  VAR
   Msg         : STRING[];
   saleTarif   : LIKE(IRecL.Tariff);
   saleSum     : LIKE(IRecL.Sum);
   saleComisFee: LIKE(IRecL.ComisFee);
   saleServFee : LIKE(IRecL.ServFee);
   saleBookFee : LIKE(IRecL.BookFee);
   saleInsurFee: LIKE(IRecL.InsurFee);
   saleTotalSum: LIKE(IRecL.TotalSum);
   saleTckNbr  : LIKE(IRecL.TckNbr);
   saleKKM     : LIKE(IRecL.KKM);
   trgSaleIR   : LIKE(IRecL.IRec);
   trgSaleIRL  : LIKE(IRecL.IRecL);
 BEGIN
  SAVE(IRec);
  IF ~DBD.FileExist(tmpIRecL) THEN
   L_AFM.extMakeDataBaseStructureCopy("IRecL", "tmpIRecL",
                                      "SrcNbr   : LIKE(IRec.SrcNbr);" +
                                      "SaleIR   : LIKE(IRec.IRec);" +
                                      "SaleIRL  : LIKE(IRecL.IRecL);" +
                                      "rtSaleIR : LIKE(IRec.IRec);" +
                                      "rtSaleIRL: LIKE(IRecL.IRecL)",
                                      "SaleIR  :UNIQUE:SaleIR,SaleIRL;" +
                                      "rtSaleIR:UNIQUE:rtSaleIR,rtSaleIRL",
                                      L_AFM.tdm_None);
  ELSE
   SELECT(tmpIRecL, IRec);
   REMSEL(tmpIRecL);
  END;

  SELECT(IRec, TSrcNbr, , type_Sale, trgSrcNbr, trgDprtStrg, trgCarrFirm);
  WHILE OCCURE(IRec) DO
   IF !BPer | (IRec.Date <= EPer) THEN
    CONFORM(IRec, IRecL);
    WHILE OCCURE(IRecL) DO
     PROMPT(" " + IRecL.IRec + " " + IRecL.IRecL);
     tmpIRecL.IRec    :=trgIRec;
     SETEMPTY(tmpIRecL.IRecL);
     tmpIRecL.SaleIR   :=IRecL.IRec;
     tmpIRecL.SaleIRL  :=IRecL.IRecL;
     tmpIRecL.SrcNbr   :=IRec.SrcNbr;
     tmpIRecL.Kind     :=IRecL.Kind;
     tmpIRecL.PayMth   :=IRecL.PayMth;
     tmpIRecL.Date     :=IRecL.Date;
     tmpIRecL.Time     :=IRecL.Time;
     tmpIRecL.RegMth   :=IRecL.RegMth;
     tmpIRecL.TicketK  :=IRecL.TicketK;
     tmpIRecL.PrivKind :=IRecL.PrivKind;
     tmpIRecL.TckNbr   :=IRecL.TckNbr;
     tmpIRecL.KKM      :=IRecL.KKM;
     SETEMPTY(tmpIRecL.rtSaleIR, tmpIRecL.rtSaleIRL);
     tmpIRecL.TckAmnt  :=IRecL.TckAmnt;
     tmpIRecL.Route    :=IRecL.Route;
     tmpIRecL.StartD   :=IRecL.StartD;
     tmpIRecL.StartT   :=IRecL.StartT;
     tmpIRecL.asTrip   :=IRecL.asTrip;
     tmpIRecL.asBoxNbr :=IRecL.asBoxNbr;
     tmpIRecL.DstStop  :=IRecL.DstStop;
     tmpIRecL.PlaceNbr :=IRecL.PlaceNbr;
     tmpIRecL.Tariff   :=IRecL.Tariff;
     tmpIRecL.Prc      :=IRecL.Prc;
     tmpIRecL.Sum      :=IRecL.Sum;
     tmpIRecL.VATClcM  :=IRecL.VATClcM;
     tmpIRecL.ComisFee :=IRecL.ComisFee;
     tmpIRecL.ServFee  :=IRecL.ServFee;
     tmpIRecL.BookFee  :=IRecL.BookFee;
     tmpIRecL.InsurFee :=IRecL.InsurFee;
     tmpIRecL.TotalSum :=IRecL.TotalSum;
     tmpIRecL.PsgDescr :=IRecL.PsgDescr;
     SETEMPTY(tmpIRecL.asRWayS, tmpIRecL.asDay, tmpIRecL.asStartT);
     tmpIRecL.ReturnK  :=IRecL.ReturnK;
     tmpIRecL.Status   :=irls_Prepared;
     INSERT(tmpIRecL);
 
     NEXT(IRecL);
    END; (* WHILE OCCURE(IRecL) ... *)
   END;
   NEXT(IRec);
  END; (* WHILE OCCURE(IRec) ... *)

  SELECT(tmpIRecL, TckNbr, , trgIRec, knd_Return);
  WHILE OCCURE(tmpIRecL) DO
   PROMPT("ࠡ⪠ " + tmpIRecL.IRecL);
   IF ~!tmpIRecL.PsgDescr THEN
    saleKKM   :=Str.Item(L_lsStore.Get(tmpIRecL.PsgDescr), ";", 0, 0, 1);
    saleTckNbr:=Str.Item(L_lsStore.Get(tmpIRecL.PsgDescr), ";", 1, 0, 1);
   ELSE
    saleKKM   :=tmpIRecL.KKM;
    saleTckNbr:=tmpIRecL.TckNbr;
   END;
   Msg:="ࠡ⪠ ,  " + tmpIRecL.SrcNbr + " ( " + tmpIRecL.IRec + ")   " + tmpIRecL.TckNbr + ":||";
   L_General.Assert(~!saleTckNbr, Msg + " 㪠  த ");

   SETEMPTY(trgSaleIR, trgSaleIRL);

   SAVE(tmpIRecL);
   IF SELECT(tmpIRecL, TckNbr, trgIRec, knd_Sale, saleTckNbr, saleKKM) THEN
    saleSum     :=tmpIRecL.Sum;
    saleComisFee:=tmpIRecL.ComisFee;
    saleServFee :=tmpIRecL.ServFee;
    saleBookFee :=tmpIRecL.BookFee;
    saleInsurFee:=tmpIRecL.InsurFee;
    saleTotalSum:=tmpIRecL.TotalSum;
    IF wDeleteReturnedTicket THEN
     REMOVE(tmpIRecL);
    ELSE
     trgSaleIR :=tmpIRecL.SaleIR;
     trgSaleIRL:=tmpIRecL.SaleIRL;

     NEXT(tmpIRecL); (* ஢ન ⢥ த*)
    END;
    L_General.Assert(~OCCURE(tmpIRecL), Msg + " " + saleTckNbr + " த ᪮쪮 ࠧ?");
   ELSE
    L_StdFrm.ConditionalCHOICE(Msg + "    த  " + saleTckNbr, L_General.IsOurSite());
    SETZERO(saleSum, saleComisFee, saleServFee, saleBookFee, saleInsurFee, saleTotalSum);
   END;
   RESTORE(tmpIRecL);

   tmpIRecL.Tariff  :=0;
   tmpIRecL.Sum     :=saleSum - tmpIRecL.Sum;
   tmpIRecL.ComisFee:=saleComisFee - tmpIRecL.ComisFee;
   tmpIRecL.ServFee :=saleServFee - tmpIRecL.ServFee;
   tmpIRecL.BookFee :=saleBookFee - tmpIRecL.BookFee;
   tmpIRecL.InsurFee:=saleInsurFee - tmpIRecL.InsurFee;
   tmpIRecL.TotalSum:=saleTotalSum - tmpIRecL.TotalSum;
   tmpIRecL.rtSaleIR :=trgSaleIR;
   tmpIRecL.rtSaleIRL:=trgSaleIRL;
   REPLACE(tmpIRecL);

   NEXT(tmpIRecL);
  END; (* WHILE OCCURE(tmpIRecL) ... *)
  RESTORE(IRec);
 END {extGatherSaleIRecs};

 PUBLIC PROCEDURE GatherSaleIRecs(trgSrcNbr  : LIKE(IRec.SrcNbr);
                                  trgDprtStrg: LIKE(Storage.Storage);
                                  trgCarrFirm: LIKE(Firm.Firm);
                                  trgIRec    : LIKE(IRec.IRec));
 BEGIN
  extGatherSaleIRecs(trgSrcNbr, trgDprtStrg, trgCarrFirm, trgIRec, L_General.EMPTY_DATE(), L_General.EMPTY_DATE(), 1);
 END {GatherSaleIRecs};

 PUBLIC PROCEDURE ProceedRefSaleIRec(trgSrcNbr  : LIKE(IRec.SrcNbr);
                                     trgDprtStrg: LIKE(Storage.Storage);
                                     trgCarrFirm: LIKE(Firm.Firm);
                                     trgDone    : LIKE(IRec.Done));
 BEGIN
  SAVE(IRec);
  SELECT(IRec, TSrcNbr, , type_Sale, trgSrcNbr, trgDprtStrg, trgCarrFirm);
  WHILE OCCURE(IRec) DO
   IRec.Done:=trgDone;
   REPLACE(IRec);
   NEXT(IRec);
  END; (* WHILE OCCURE(IRec) ... *)
  RESTORE(IRec);
 END {ProceedRefSaleIRec};

 PUBLIC PROCEDURE CreateDepartureIRec(trgSrcNbr  : LIKE(IRec.SrcNbr);
                                      trgDprtStrg: LIKE(Storage.Storage);
                                      trgCarrFirm: LIKE(Firm.Firm);
                                      trgIRec    : LIKE(IRec.IRec);
                                      trgBoxNbr  : LIKE(Car.BoxNbr));
 BEGIN
  GatherSaleIRecs(trgSrcNbr, trgDprtStrg, trgCarrFirm, trgIRec);
  ProceedRefSaleIRec(trgSrcNbr, trgDprtStrg, trgCarrFirm, 1);

  SELECT(tmpIRecL, TckNbr);
  WHILE OCCURE(tmpIRecL) DO
   PROMPT("ଫ: " + tmpIRecL.SrcNbr + "  " + L_DatTim.DateStr(tmpIRecL.Date) + ",  " + tmpIRecL.TckNbr);

   SETEMPTY(IRecL.IRecL);
   IRecL.IRec    :=trgIRec;
   IRecL.Kind    :=tmpIRecL.Kind;
   IRecL.PayMth  :=tmpIRecL.PayMth;
   IRecL.Date    :=tmpIRecL.Date;
   IRecL.Time    :=tmpIRecL.Time;
   IRecL.RegMth  :=tmpIRecL.RegMth;
   IRecL.TicketK :=tmpIRecL.TicketK;
   IRecL.PrivKind:=tmpIRecL.PrivKind;
   IRecL.TckNbr  :=tmpIRecL.TckNbr;
   IRecL.KKM     :=tmpIRecL.KKM;
   IRecL.TckAmnt :=tmpIRecL.TckAmnt;
   IRecL.Route   :=tmpIRecL.Route;
   IRecL.StartD  :=tmpIRecL.StartD;
   IRecL.StartT  :=tmpIRecL.StartT;
   IRecL.asTrip  :=tmpIRecL.asTrip;
   IRecL.asBoxNbr:=trgBoxNbr;
   IRecL.DstStop :=tmpIRecL.DstStop;
   IRecL.PlaceNbr:=tmpIRecL.PlaceNbr;
   IRecL.Tariff  :=tmpIRecL.Tariff;
   IRecL.Prc     :=tmpIRecL.Prc;
   IRecL.Sum     :=tmpIRecL.Sum;
   IRecL.VATClcM :=tmpIRecL.VATClcM;
   IRecL.ComisFee:=tmpIRecL.ComisFee;
   IRecL.ServFee :=tmpIRecL.ServFee;
   IRecL.BookFee :=tmpIRecL.BookFee;
   IRecL.InsurFee:=tmpIRecL.InsurFee;
   IRecL.TotalSum:=tmpIRecL.TotalSum;
   IRecL.PsgDescr:=tmpIRecL.PsgDescr;
   SETEMPTY(IRecL.asRWayS, IRecL.asDay, IRecL.asStartT);
   IRecL.ReturnK :=tmpIRecL.ReturnK;
   IRecL.Status  :=irls_Prepared;
   INSERT(IRecL);

   NEXT(tmpIRecL);
  END; (* WHILE OCCURE(tmpIRecL) ... *)

  ProceedIRec(trgIRec);
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_IRec, L_XDoc.EmptyXDocKind, IRec.IRec, L_XDoc.action_AutoEdit);
 END {CreateDepartureIRec};

 PUBLIC PROCEDURE StandOnSpecificTypeIRec(trgType    : LIKE(IRec.Type);
                                          trgSrcNbr  : LIKE(IRec.SrcNbr);
                                          trgDprtStrg: LIKE(Storage.Storage);
                                          trgCarrFirm: LIKE(Firm.Firm)): SCAL[2];
 BEGIN
  RETURN SELECT(IRec, TSrcNbr, trgType, trgSrcNbr, trgDprtStrg, trgCarrFirm);
 END {StandOnSpecificTypeIRec};

 PUBLIC PROCEDURE E_Storage2Stop(D: DATE; trgStorage: LIKE(Storage.Storage)): LIKE(Stop.Stop);
  VAR
   Local  : PROC;
   trgStop: LIKE(Stop.Stop);
 BEGIN
  L_General.Assert(~!trgStorage, " ।  ࠭");
  Local:=PROCREF(E_Way.ir_Storage2Stop);
  SETEMPTY(trgStop);
  IF ~!Local THEN
   trgStop:=Local(D, trgStorage);
  END;
  L_General.Assert(~!trgStop, " ᮯ⠢ ⠭   " + trgStorage);
  RETURN trgStop;
 END {E_Storage2Stop};

 PUBLIC PROCEDURE ConvToRUR(Sum: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF IRec.CURate = 1 THEN
   RETURN Sum;
  ELSE
   RETURN Sum / 100 * IRec.CURate;
  END;
 END {ConvToRUR};

END.
