(*
%Copyright   (c) Polak IT
%Author      08.12.2010 09:09:54 LDA
%Purpose     ଠ樮 
%Type        library
%Specific    SYS
%Modified    11.06.2013 16:57:53 POLAK\San
%Environment
*)

 MODULE L_Kiosk [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, E_UI;

 PUBLIC TYPE
  tRepType  = SCAL[3];

 PUBLIC CONST
  bt_Group  = 0;
  bt_Report = 1;

  rt_REP  = 0;
  rt_HTML = 1;
  rt_Act  = 2;

  p_Staff          = "Page_Staff";
  p_Car            = "Page_Car";

  gsrbid_RWayS         = "gsrbid_RWayS";
  gsrbid_Income        = "gsrbid_Income";
  gsrbid_EDOrder       = "gsrbid_EDOrder";
  gsrbid_Fuel          = "gsrbid_Fuel";
  gsrbid_Math          = "gsrbid_Math";
  gsrbid_Money         = "gsrbid_Money";
  gsrbid_Docs          = "gsrbid_Docs";
  gsrbid_Service       = "gsrbid_Service";

  srid_StNon           = "srid_StNon";
  srid_Sht04           = "srid_Sht04";
  srid_TBTSN           = "srid_TBTSN";
  srid_AnyInc          = "srid_AnyInc";
  srid_DifTs           = "srid_DifTs";
  srid_DrGuS           = "srid_DrGuS";
  srid_EDO10           = "srid_EDO10";
  srid_EDO12           = "srid_EDO12";
  srid_StfFl           = "srid_StfFl";
  srid_MhTSN           = "srid_MhTSN";
  srid_MSStf           = "srid_MSStf";
  srid_MSSMT           = "srid_MSSMT";
  srid_Money           = "srid_Money";
  srid_RWSMP           = "srid_RWSMP";
  srid_BQl02           = "srid_BQl02";
  srid_Constitution    = "srid_Constitution";
  srid_SendRepPck      = "srid_SendRepPck";
  srid_KtmSh           = "srid_KtmSh";
  srid_AvePayPrt       = "srid_AvePayPrt";

  gcrbid_Run           = "gcrbid_Run";
  gcrbid_Stat          = "gcrbid_Stat";
  gcrbid_Fuel          = "gcrbid_Fuel";
  gcrbid_Math          = "gcrbid_Math";
  gcrbid_Service       = "gcrbid_Service";

  crid_RUNBN           = "crid_RUNBN";
  crid_CStat           = "crid_CStat";
  crid_RprHs           = "crid_RprHs";
  crid_CarFl           = "crid_CarFl";
  crid_MTBNB           = "crid_MTBNB";
  crid_MhBNB           = "crid_MhBNB";
  crid_Rpr31           = "Rpr31";
  crid_RprPr           = "RprPr";
  crid_SendRepPck      = "crid_SendRepPck";

 PUBLIC PROCEDURE E_AllowedButton(trgPage, trgId: STRING[]; default: SCAL[2]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_UI.AllowedButton);
  IF ~!Local THEN
   RETURN Local(trgPage, trgId, default);
  ELSE
   RETURN default;
  END;
 END {E_AllowedButton};

 PUBLIC PROCEDURE SetAnyKioskButton(trgPage    : STRING[];
                                    trgButType : SCAL[2];
                                    trgId,
                                    trgGroupId,
                                    trgName,
                                    trgRepName,
                                    trgRepHandl: STRING[];
                                    trgPicture : STRING[];
                                    trgRepType : tRepType;
                                    trgAuthReq : SCAL[2];
                                    trgEnable  : SCAL[2]);
  VAR
   newNbr: NUMERIC[0];
 BEGIN
  SETSEL(kskRepBut, kskRepBut, trgPage, trgButType, trgGroupId);
  IF LAST(kskRepBut) THEN
   newNbr:=kskRepBut.Nbr + 1;
  ELSE
   SETZERO(newNbr);
  END;

  kskRepBut.Page    :=trgPage;
  kskRepBut.ButType :=trgButType;
  kskRepBut.Nbr     :=newNbr;
  kskRepBut.GroupId :=trgGroupId;
  kskRepBut.RepType :=trgRepType;
  kskRepBut.Id      :=trgId;
  kskRepBut.Name    :=trgName;
  kskRepBut.RepName :=trgRepName;
  kskRepBut.RepHandl:=trgRepHandl;
  kskRepBut.Picture :=trgPicture;
  kskRepBut.AuthReq :=trgAuthReq;
  kskRepBut.Enable  :=E_AllowedButton(trgPage, trgId, trgEnable);
  INSERT(kskRepBut);
 END {SetAnyKioskButton};

 PUBLIC PROCEDURE OpenRep();
 BEGIN
  OPENREP(^kskRepBut.RepHandl, L_General.NameConnection(kskRepBut.RepName), Create);
 END {OpenRep};

 PUBLIC PROCEDURE CloseRep();
 BEGIN
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   CLOSEREP(^kskRepBut.RepHandl);
  EXCEPT
  ELSE
  END; (* TRY *)
 END {CloseRep};

END.
