(*
%Copyright   (c) Polak IT
%Author      08.04.2005 18:05:51 POLAK\LDA
%Purpose     稥 
%Type        library
%Specific    AP
%Modified    05.09.2014 10:35:08 POLAK\LDA
%Environment
*)

 MODULE L_OTx [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  bnft_Amount = 5;

  bnft_None         = 0;
  bnft_Social       = 1;
  bnft_Mobilization = 2;
  bnft_IsSteal      = 3;
  bnft_Medic        = 4;

  TravmOblig_InvalidCoef = 0.6;

 PUBLIC TYPE
  tID      = SCAL[1E10];
  tBnfType = SCAL[bnft_Amount];

 IMPORT L_General, P_Car, P_Math, L_DatTim, E_Way, L_AFM, Math, L_Car, L_Str,
        L_Env, L_MathR, DBD, P_Firm, P_MyFirm, L_Russia, L_Card, P_MCList;

 PUBLIC PROCEDURE Create_TmpCr();
 BEGIN
  CreateFILE(TmpCr, "", " ਮ ॣ樨 ", "");

  CreateFIELD(TmpCr, ID,       tID,                    "", "", "",  "䨪 (  .)", "");
  CreateFIELD(TmpCr, BnfType,  tBnfType,               "", "", "",  "  ", "0 -  죮, 1 - . 죮, 2 - . , 3 -   㣮;4 - 樠஢ ");
  CreateFIELD(TmpCr, EngPower, LIKE(VehPasp.EngPower), "", "", "",  "", "");
  CreateFIELD(TmpCr, MnthAmnt, NUMERIC[0],             "", "0", "", "Ⴋ", "");
  CreateFIELD(TmpCr, Age,      NUMERIC[0],             "", "0", "", " ", "");
  CreateFIELD(TmpCr, TaxRate,  NUMERIC[3],             "", "0", "", "⠢", "");
  CreateFIELD(TmpCr, BnfPrc,   NUMERIC[2],             "", "1", "", " ⠢", "");
  CreateFIELD(TmpCr, IncCoef,  NUMERIC[2],             "", "", "",  "騩 樥", "");
  CreateFIELD(TmpCr, OwnPart,  STRING[10],             "", "", "",  " ⥫騪  ࠢ  , ࠢ쭠 ஡", "");

  CreateFIELD(TmpCr, BoxNbr,   LIKE(CarLog.BoxNbr),    "", "", "",  "ࠦ", "");
  CreateFIELD(TmpCr, VIN,      LIKE(VehPasp.VIN),      "", "", "",  "VIN", "");
  CreateFIELD(TmpCr, EcoCls,   LIKE(VehPasp.EcoCls),   "", "", "",  "᪨ ", "");
  CreateFIELD(TmpCr, StateNbr, LIKE(CarLog.StateNbr),  "", "", "",  ".", "");
  CreateFIELD(TmpCr, VehType,  LIKE(VehType.VehType),  "", "", "",  "७  ", "");

  CreateINDEX(TmpCr, ID, UNIQUE, "", "", ID, EngPower, BnfType);
  CreateINDEX(TmpCr, BnfType, PLURAL, "", "", BnfType, BoxNbr);
  CreateINDEX(TmpCr, ForSrc, PLURAL, "", "", ID, EngPower, VIN, StateNbr);
  CreateINDEX(TmpCr, BoxNbr, PLURAL, "", "", BoxNbr);

  SetVersionOfFILE(TmpCr, 0);
  L_AFM.AF_CreateTemp("TmpCr", "TmpCr");


  CreateFILE(TmpCL, "", "ப  CarLog", "");

  CreateFIELD(TmpCL, ID, tID, "", "", "", "䨪", "");
  CreateFIELD(TmpCL, Date, DATE, "", "", "", " ", "");
  CreateFIELD(TmpCL, DateE, DATE, "", "", "", " ", "");
  CreateFIELD(TmpCL, BoxNbr, LIKE(Car.BoxNbr), "", "", "", "ࠦ", "");

  CreateINDEX(TmpCL, ID,     UNIQUE, "", "", ID, Date, BoxNbr);
  CreateINDEX(TmpCL, BoxNbr, UNIQUE, "", "", BoxNbr, Date, ID);

  SetVersionOfFILE(TmpCL, 0);
  L_AFM.AF_CreateTemp("TmpCL", "TmpCL");
 END {Create_TmpCr};

 PUBLIC PROCEDURE AcceptableVehPasp(BDate, EDate: DATE): SCAL[2];
 BEGIN
  L_General.Assert(!VehPasp.Till | (VehPasp.RegRemvD<VehPasp.Till) | (CarLog.DateE<VehPasp.Till), "⢨  "+VehPasp.VehPasp+" 稢 ࠭ ᠭ  "+CarLog.BoxNbr);
  RETURN L_DatTim.IsActiveInIntvl(BDate, EDate+1, VehPasp.Begin, VehPasp.Till) &
         (L_DatTim.IsActiveInIntvl_Inc(BDate, EDate, VehPasp.CertDate, VehPasp.RegRemvD) | (DBD.BaseName() = "10"));
 END {AcceptableVehPasp};

 PRIVATE PROCEDURE E_UseMathMty(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.TT_IsSocialBnfMtyIdx);
  RETURN ~!Local;
 END {E_UseMathMty};

 PUBLIC PROCEDURE IsSocialBnfCar(OnPer, BPer: DATE): SCAL[2];
  VAR
   _Proof,
   BnfProof: NUMERIC[3];
 BEGIN
  IF (Region.Region = L_Russia.reg_77) |
     ((Region.Region = L_Russia.reg_50) & (L_DatTim.YEAR(BPer) < 2005)) THEN
   IF    E_UseMathMty() THEN
    IF SELECT(MathMty, Math, CarLog.Math, OnPer) THEN
     SETZERO(_Proof, BnfProof);
     WHILE OCCURE(MathMty) DO
      IF E_Way.TT_IsSocialBnfMtyIdx(MathMty.MtyIdx) THEN
       INC(BnfProof, MathMty.Proof);
      ELSE
       INC(_Proof, MathMty.Proof);
      END;
      NEXT(MathMty);
     END; (* WHILE OCCURE(MathMty) ... *)
     RETURN BnfProof > _Proof;
    END;
   ELSIF ~!CarLog.TKind THEN
    CONFORM(CarLog, TKind);
    RETURN TKind.FnMode = 0;
   END;
  END;
  RETURN 0;
 END {IsSocialBnfCar};

 PUBLIC PROCEDURE AllowedMobilizationCarBnf(Date: DATE): SCAL[2];
 BEGIN
  RETURN (Region.Region = L_Russia.reg_50) & (Date < 01\01\2007);
 END {AllowedMobilizationCarBnf};

 PUBLIC PROCEDURE IsMobilizationCar(_BoxNbr: LIKE(Car.BoxNbr);
                                    OnDate : DATE): SCAL[2];
  VAR
  default: SCAL[2];
 BEGIN
  default:=0;
  IF AllowedMobilizationCarBnf(OnDate) THEN
   IF    P_Car.HasActualCarPro(_BoxNbr, OnDate, P_Car.P_MobilizationDestinat) THEN
    RETURN 1;
   ELSIF ~!CarLog.Math THEN
    RETURN P_Math.HasActualMathPro(CarLog.Math, OnDate, P_Math.P_MobilizationDestinat);
   END;
  END;
  RETURN default;
 END {IsMobilizationCar};

 PUBLIC PROCEDURE IsMedicCar(): SCAL[2];
 BEGIN
  RETURN (Region.Region = L_Russia.reg_50) & (VehType.Tax_VehT = 033);
 END {IsMedicCar};

 PRIVATE PROCEDURE GetBnfType(P, BPer, EPer: DATE): tBnfType;
  VAR
   _BnfType: tBnfType;
   Local   : PROC;
 BEGIN
  _BnfType:=bnft_None;
  IF    VehPasp.IsSteal THEN
   _BnfType:=bnft_IsSteal;
  ELSIF IsMobilizationCar(Car.BoxNbr, L_DatTim.MaxDATE(Car.BegDate, P)) THEN
   _BnfType:=bnft_Mobilization;
  ELSIF IsMedicCar() THEN
   _BnfType:=bnft_Medic;
  ELSIF IsSocialBnfCar(P, BPer) THEN
   _BnfType:=bnft_Social;
  END;
  Local:=PROCREF(E_Way.ConvertBnfType);
  IF ~!Local THEN
   _BnfType:=Local(BPer, _BnfType);
  END;
  RETURN _BnfType;
 END {GetBnfType};

 PRIVATE PROCEDURE StandOnVehPasp(trgBoxNbr: LIKE(Car.BoxNbr); trgDate: DATE): SCAL[2];
 BEGIN
  SEARCH(CarLog, BoxNbr, , trgBoxNbr, trgDate);
  IF ~!CarLog.VehPasp THEN
   CONFORM(CarLog, VehPasp);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {StandOnVehPasp};

 PRIVATE PROCEDURE IsAcceptableMonthToPay(P, EndP: DATE; trgBoxNbr: LIKE(Car.BoxNbr); ByKeyAssets: SCAL[2]): SCAL[2];
  VAR
   Result             : SCAL[2];
   trgDateE           : DATE;
   IsAcceptableVehPasp: SCAL[2];
 BEGIN
  IsAcceptableVehPasp:=AcceptableVehPasp(P, EndP);
  IF IsAcceptableVehPasp THEN
   Result:=1;
   SAVE(TmpCL);
   IF ~!TmpCL.DateE & (P = L_DatTim.Per(TmpCL.DateE)) THEN
    trgDateE:=TmpCL.DateE;
    IF    ~NEXT(TmpCL) THEN
     IF ByKeyAssets THEN
      IF SELECT(TmpCL, BoxNbr, trgBoxNbr) &
         SRCINSEL(TmpCL, GT, trgDateE) &
         StandOnVehPasp(TmpCL.BoxNbr, TmpCL.Date) &
         AcceptableVehPasp(P, EndP) THEN
       Result:=P # L_DatTim.Per(TmpCL.Date);
      END;
     END;
    ELSIF (P = L_DatTim.Per(TmpCL.Date)) &
          StandOnVehPasp(TmpCL.BoxNbr, TmpCL.Date) &
          AcceptableVehPasp(P, EndP) THEN
     Result:=0;
    END;
   END;
   RESTORE(TmpCL);
   RETURN Result;
  ELSE
   RETURN 0;
  END;
 END {IsAcceptableMonthToPay};

 PRIVATE PROCEDURE IncludeTaxPeriodInAge(curYear: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN (curYear >= 2011);
(*
  RETURN (curYear >= 2011) |
         (curYear = 2010) & (L_General.GetAPSiteNumber() = 24);
*)
 END {IncludeTaxPeriodInAge};

 PRIVATE PROCEDURE InsIntoTmp(BPer, EPer: DATE; ByKeyAssets: SCAL[2]);
  VAR
   _EngPower: LIKE(VehPasp.EngPower);
   P, EndP  : DATE;
   decAge,
   curYear  : NUMERIC[0];
 BEGIN
  SAVE(Car);
  SEARCH(Car, BoxNbr, , TmpCL.BoxNbr);
  WHILE OCCURE(TmpCL) DO
   P:=BPer;
   WHILE P <= EPer DO
    EndP:=L_DatTim.MonthEnd(P);
    IF StandOnVehPasp(TmpCL.BoxNbr, TmpCL.Date) &
       L_DatTim.IsActiveInIntvl_Inc(TmpCL.Date, TmpCL.DateE, P, EndP) &
       IsAcceptableMonthToPay(P, EndP, Car.BoxNbr, ByKeyAssets) THEN
     L_General.Assert(~!VehPasp.VehType,
                      "  " + VehPasp.VehPasp + " (" +  L_Car.VehPaspNbr_AsStr() + ")" +
                      "| 㪠 ⨯ ࠭ᯮ⭮ ।⢠");
      L_General.Assert(~!VehPasp.VIN, "  䨪樮   (VIN),  " + VehPasp.VehPasp);
     CONFORM(VehPasp, VehType);
     IF VehType.IRC_VehT # L_Car.ircvt_NotQualified THEN
      L_General.Assert(~!VehPasp.EngPower,
                       "  " + VehPasp.VehPasp + " (" +  L_Car.VehPaspNbr_AsStr() + ")" +
                       "| 㪠 魮 ⥫");
      IF ~VehPasp.IsSteal THEN
       _EngPower:=VehPasp.EngPower;
      ELSE
       _EngPower:=0;
      END;

      curYear:=L_DatTim.YEAR(BPer);

      ADD(TmpCr, ID, , TmpCL.ID, _EngPower, GetBnfType(P, BPer, EPer),
          TmpCr.MnthAmnt, 1);

      TmpCr.BoxNbr  :=CarLog.BoxNbr;
      TmpCr.StateNbr:=VehPasp.StateNbr;
      TmpCr.VIN     :=VehPasp.VIN;
      TmpCr.EcoCls  :=VehPasp.EcoCls;
      IF curYear >= 2014 THEN
       TmpCr.OwnPart:="1/1";
       SETEMPTY(TmpCr.IncCoef);
      ELSE
       SETEMPTY(IncCoef, TmpCr.OwnPart);
      END;
      TmpCr.VehType :=VehType.VehType;
      IF IncludeTaxPeriodInAge(curYear) THEN
       decAge:=0;
      ELSE
       decAge:=1;
      END;
      TmpCr.Age:=curYear - Math.Min(curYear, L_DatTim.YEAR(L_Car.GetCarProdDate(CarLog.BoxNbr, EPer)) + decAge);
      REPLACE(TmpCr);
     END; (* IF VehType.IRC_VehT # L_Car.ircvt_NotQualified...*)
    END; (* IF StandOnVehPasp...*)
    P:=L_DatTim.IncMonth(P, +1);
   END; (* WHILE P <= EPer...*)
   NEXT(TmpCL);
  END; (* WHILE OCCURE(TmpCL) ... *)
  RESTORE(Car);
 END {InsIntoTmp};

 PRIVATE PROCEDURE GetBnfPrc(_BnfType: tBnfType): NUMERIC[3];
 BEGIN
  IF    _BnfType = bnft_None THEN
   RETURN 0.0;
  ELSIF _BnfType = bnft_Social THEN
   RETURN 1.0;
  ELSIF _BnfType = bnft_IsSteal THEN
   RETURN 1.0;
  END;

  IF    Region.Region = L_Russia.reg_50 THEN
   IF    _BnfType = bnft_Mobilization THEN
    RETURN 1.0;
   ELSIF _BnfType = bnft_Medic THEN
    RETURN 0.5;
   END;
  ELSIF Region.Region = L_Russia.reg_77 THEN
   IF    _BnfType = bnft_Mobilization THEN
    L_General.Error(" ॣ 77  죮  樮 ");
   ELSIF _BnfType = bnft_Medic THEN
    RETURN 1.0;
   END;
  ELSIF Region.Region = L_Russia.reg_72 THEN
   L_General.Error(" ॣ 72  죮");
  END;
  L_General.CallUs(0);
 END {GetBnfPrc};

 PUBLIC PROCEDURE CalcTransportTax(trgMnthAmnt     : NUMERIC[0];
                                   trgMnthAmntInPer: NUMERIC[0];
                                   trgEngPower     : LIKE(VehPasp.EngPower);
                                   trgTaxRate      : NUMERIC[3];
                                   trgBnfPrc       : NUMERIC[2];
                                   trgIncCoef      : NUMERIC[2];
                                   trgOwnPart      : STRING[];
                                   Precision       : NUMERIC[0]): NUMERIC[2];
  VAR
   Step      : NUMERIC[4];
   RoundedCfc: FLOAT; (* 15.01.2007 16:50:00 POLAK\San 0055051 *)
 BEGIN
  Step      :=1 / Math.Pow(10, Precision);
  IF !trgIncCoef THEN
   trgIncCoef:=1;
  END;
  IF !trgOwnPart THEN
   trgOwnPart:="1";
  END;
  RoundedCfc:=Math.Round(trgMnthAmnt / trgMnthAmntInPer, Step);
  RETURN Math.Round(((trgTaxRate * trgEngPower * RoundedCfc) * (1-trgBnfPrc) * trgIncCoef * ^(trgOwnPart)) / (12 / trgMnthAmntInPer), 1);
 END {CalcTransportTax};

 PRIVATE PROCEDURE CheckMonthAmnt(PeriodLength: NUMERIC[0]; Msg: STRING[]);
  VAR
   TotalMonthAmnt: NUMERIC[0];
 BEGIN
  SETZERO(TotalMonthAmnt);
  WHILE OCCURE(TmpCr) DO
   PROMPT("஢ઠ " + TmpCr.ID);
   INC(TotalMonthAmnt, TmpCr.MnthAmnt);
   NEXT(TmpCr);
  END; (* WHILE OCCURE(TmpCr) ... *)
  L_General.Assert(TotalMonthAmnt <= PeriodLength,
                   "४⭮ ⢮ 楢  (" + L_Str.IntStr(TotalMonthAmnt) + ")|" +
                   Msg);
 END {CheckMonthAmnt};

 PUBLIC PROCEDURE GetID(Num: NUMERIC[0]; IsKeyAss: SCAL[2]): tID;
 BEGIN
  RETURN Num * 10 + IsKeyAss;
 END {GetID};

 PRIVATE PROCEDURE TT_Gather(trgID: tID; ByKeyAssets: SCAL[2]; BPer, EPer: DATE);
 BEGIN
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   LOADMODULE(^(L_Card.GetCardName(L_Card.t_TXS, BPer)), TaxesCard);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode # 188 (*  㦥 祭 *) THEN
    RAISE();
   END;
  END;

  IF SELECT(TmpCL, ID, trgID) THEN
   PROMPT("ઠ  " + TmpCL.ID);
   InsIntoTmp(BPer, EPer, ByKeyAssets);
  END; (* IF SELECT(TmpCL) ... *)

  SELECT(TmpCr, ID, , trgID);
  CheckMonthAmnt(L_DatTim.CompleteMonthsInIntvl(BPer, EPer), "䨪  () " + trgID);

  SELECT(TmpCr, ID, , trgID);
  WHILE OCCURE(TmpCr) DO
   PROMPT("ࠡ⪠ " + TmpCr.ID);
   SEARCH(VehType, VehType, , TmpCr.VehType);
   TmpCr.TaxRate:=TaxesCard.GetTransportTaxRate(BPer, VehType.IRC_VehT, TmpCr.Age, TmpCr.EngPower);
   TmpCr.BnfPrc :=GetBnfPrc(TmpCr.BnfType);
   REPLACE(TmpCr);
   NEXT(TmpCr);
  END; (* WHILE OCCURE(TmpCr) ... *)
 END {TT_Gather};

 PRIVATE PROCEDURE E_DebilKeyAssAcntLev(_Date: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.DebilKeyAssAcntLev);
  IF ~!Local THEN
   RETURN Local(_Date);
  ELSE
   RETURN 0;
  END;
 END {E_DebilKeyAssAcntLev};

 PUBLIC PROCEDURE GatherByKeyAssets(EPer: DATE): SCAL[2];
 BEGIN
  RETURN L_Env.KeyAssAcntLev(EPer) & ~E_DebilKeyAssAcntLev(EPer) & ~L_MathR.E_NotFullActiveKeyAssSystem(EPer);
 END {GatherByKeyAssets};

 PUBLIC PROCEDURE E_AdditionalCheckCarAdaptability(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.Xomn7_AdditionalCheckCarAdaptability);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 1;
  END;
 END {E_AdditionalCheckCarAdaptability};

 PUBLIC PROCEDURE IsAcceptableTTPayer(EPer: DATE): SCAL[2];
  VAR
   _MyFirm: P_Firm.tMyFirm;
 BEGIN
  CONFORM(CarLog, VehPasp);
  IF VehPasp.TTPayer = L_Car.ttp_ThirdParty THEN
   RETURN 0;
  ELSE
   IF    VehPasp.TTPayer = L_Car.ttp_Owner THEN
    _MyFirm:=P_Firm.GetMyFirmOfFirm(VehPasp.Firm);
   ELSIF VehPasp.TTPayer = L_Car.ttp_Operator THEN
    _MyFirm:=L_Car.GetCarMyFirm(CarLog.BoxNbr, EPer);
   END;
   RETURN _MyFirm = Packet.MyFirm;
  END;
 END {IsAcceptableTrTaxPayer};

 PUBLIC PROCEDURE IsAcceptableCar(BPer, EPer: DATE): SCAL[2];
 BEGIN
  RETURN  L_DatTim.IsActiveInIntvl_Inc(CarLog.Date, CarLog.DateE, BPer, EPer) &
          ~!CarLog.VehPasp                                                    &
          E_AdditionalCheckCarAdaptability()                                  &
          IsAcceptableTTPayer(EPer);
 END {IsAcceptableCar};

 PRIVATE PROCEDURE TT_GatherByCarLog(ByKeyAssets: SCAL[2]; BPer, EPer: DATE);
  VAR
   curID: tID;
 BEGIN
  WHILE OCCURE(CarLog) DO
   PROMPT("ઠ " + CarLog.BoxNbr + " " + CarLog.StateNbr);
   IF IsAcceptableCar(BPer, EPer) THEN
    IF ByKeyAssets THEN
     IF ~!CarLog.Math THEN
      curID:=GetID(CarLog.Math, 1);
     ELSE
      SETEMPTY(curID);
     END;
    ELSE
     curID:=GetID(CarLog.BoxNbr, 0);
    END;
    IF ~!curID THEN
     TmpCL.ID    :=curID;
     TmpCL.BoxNbr:=CarLog.BoxNbr;
     TmpCL.Date  :=CarLog.Date;
     TmpCL.DateE :=CarLog.DateE;
     INSERT(TmpCL);
    END;
   END;
   NEXT(CarLog);
  END; (* WHILE OCCURE(CarLog) ... *)
 END {TT_GatherByCarLog};

 PUBLIC PROCEDURE TT_PrepareBySingleKeyAssets(_Math: LIKE(Math.Math); BPer, EPer : DATE);
 BEGIN
  IF SELECT(CarLog, Math, _Math) THEN
   TT_GatherByCarLog(1, BPer, EPer);
   TT_Gather(GetID(_Math, 1), 1, BPer, EPer);
  END;
 END {TT_PrepareBySingleKeyAssets};

 PUBLIC PROCEDURE TT_Prepare(ByKeyAssets: SCAL[2]; BPer, EPer: DATE);
 BEGIN
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(" " + Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) THEN
    SELECT(CarLog, BoxNbr, , Car.BoxNbr);
    TT_GatherByCarLog(ByKeyAssets, BPer, EPer);
   END; (* IF L_Env.RealBoxNbr(Car.BoxNbr)... *)
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)

  SELECT(TmpCL, ID);
  WHILE OCCURE(TmpCL) DO
   NARROWSEL(TmpCL, ID);
   PROMPT("ઠ  " + TmpCL.ID);
   SAVE(TmpCL);
   TT_Gather(TmpCL.ID, ByKeyAssets, BPer, EPer);
   RESTORE(TmpCL);
   NEXTINEXTENDEDSEL(TmpCL, ID);
  END; (* WHILE OCCURE(TmpCL) ... *)

  SELECT(TmpCr, BoxNbr);
  WHILE OCCURE(TmpCr) DO
   NARROWSEL(TmpCr, BoxNbr);
   CheckMonthAmnt(L_DatTim.CompleteMonthsInIntvl(BPer, EPer), " " + TmpCr.BoxNbr);
   NEXTINEXTENDEDSEL(TmpCr, BoxNbr);
  END; (* WHILE OCCURE(TmpCr) ... *)
 END {TT_Prepare};

 PUBLIC PROCEDURE Purge_TmpCr();
 BEGIN
  L_AFM.AF_PurgeTemp("TmpCr");
  L_AFM.AF_PurgeTemp("TmpCL");
 END {Purge_TmpCr};

 PUBLIC PROCEDURE TravmObligTariff(MF: LIKE(MyFirm.MyFirm); D: DATE): P_MyFirm.tTravmObligTariff;
  VAR
   Result: P_MyFirm.tTravmObligTariff;
 BEGIN
  Result:=P_MyFirm.TravmObligTariff(MF, D);
  IF ~!P_MyFirm.TravmObligTariffInc(MF, D) THEN
   Result:=Math.Round(Result + (Result * P_MyFirm.TravmObligTariffInc(MF, D) / 100), 0.01);
  END;
  RETURN Result;
 END {TravmObligTariff};

 PUBLIC PROCEDURE TravmObligTariff_InvalidCoef(curMF: LIKE(MyFirm.MyFirm); curD: DATE; curMan: LIKE(Man.Man)): P_MyFirm.tTravmObligTariff;
  VAR
   Result: P_MyFirm.tTravmObligTariff;
 BEGIN
  Result:=TravmObligTariff(curMF, curD);
  IF L_SFee.ManIsInvalid(curMan, curD) THEN
   Result:=Result*TravmOblig_InvalidCoef;
  END;
  RETURN Result;
 END {TravmObligTariff_InvalidCoef};

 PUBLIC PROCEDURE TravmOblig_MCList_Attitude(D: DATE): SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(MCList), " ⠭ ");
  RETURN P_MCList.a2ii_Attitude(MCList.MCode, D) = P_MCList.a2ii_Taxable;
 END {TravmOblig_MCList_Attitude};

END.
