(*
Copyright   (c) Polak IT
%Author      24.10.2005 17:06:53 POLAK\LDA
%Purpose
%Type        library
%Specific    AP
%Modified    14.11.2013 21:13:18 POLAK\LDA
%Environment
*)

 MODULE L_RT [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_XDoc, L_Car, L_General, L_DatTim, L_Way, L_BegRWS, L_Rpr, L_Env,
        Math, L_AFM, DBD, L_BarCode, L_CUC, L_Staff;

 PUBLIC TYPE
  trtc_State = SCAL[18];

 PUBLIC CONST
  LongTimeAgoLength = 40;

  rterwss_NotOrdered = 0;
  rterwss_Ordered    = 1;
  rterwss_Given      = 2;
  rterwss_Departure  = 3;
  rterwss_Return     = 4;
  rterwss_AcptReturn = 5;
  rterwss_Taken      = 6;

  rterwss_Pool = "  拉| ࠧ殮| 뤠| 堫| 㫮| ਭ| ਭ";


  rtc_st_Work               = 0;
  rtc_st_InPark             = 1;
  rtc_st_Ordered            = 2;
  rtc_st_GivenCountdown     = 3;
  rtc_st_GivenDelay         = 4;
  rtc_st_DepartureDelay     = 5;
  rtc_st_EarlyReturn        = 6;
  rtc_st_LongTimeAgoReturn  = 7;
  rtc_st_ReturnDelay        = 8;
  rtc_st_BreakageOnLine     = 9;
  rtc_st_Repair             = 10;
  rtc_st_TO2                = 11;
  rtc_st_LongRepair         = 12;
  rtc_st_WaitRepair         = 13;
  rtc_st_woRWayS            = 14;
  rtc_st_woDriver           = 15;
  rtc_st_Reserve            = 16;
  rtc_st_TotalAmount        = 17;

  rtc_st_Pool =  " ࠡ" +
                 "| થ" +
                 "| 拉" +
                 "| 뤠  ⠫  30 " +
                 "|  뤠祩 " +
                 "|  륧 " +
                 "| " +
                 "| " +
                 "|  ⮬ " +
                 "|  " +
                 "| ६" +
                 "|-2" +
                 "|⥫ ६" +
                 "|  ६" +
                 "| " +
                 "| ⥫" +
                 "| १ࢥ";

 PRIVATE TYPE
  tCarLocation = SCAL[4];

 PRIVATE CONST
  rtcst_Ordered    = 1;
  rtcst_Given      = 2;
  rtcst_Departure  = 3;
  rtcst_Return     = 4;
  rtcst_AcptReturn = 5;
  rtcst_Taken      = 6;
  rtcst_Repair     = 7;
  rtcst_TO2        = 8;
  rtcst_LongRepair = 9;
  rtcst_WaitRepair = 10;
  rtcst_woRWayS    = 11;
  rtcst_woDriver   = 12;
  rtcst_Reserve    = 13;

  cl_HasDepart     = 0;
  cl_HasReturn     = 1;
  cl_NotLeavedPark = 2;
  cl_EndOfWork     = 3;

  DummyRoute = "";

 PRIVATE PROCEDURE ConvToDispDate(_DTS: FLOAT): DATE;
  VAR
   _Date: DATE;
   _Time: TIME;
 BEGIN
  UnPkVARIANTDATE(_DTS, _Date, _Time);
  RETURN L_BegRWS.DspDate(_Date, _Time);
 END {ConvToDispDate};

 PRIVATE PROCEDURE StandOnLastRWaySJrn();
 BEGIN
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
  LAST(XDocJrn);
  WHILE (XDocJrn.Action = L_XDoc.action_begSwitch) |
        (L_BegRWS.RoleOfAction(XDocJrn.Action) = L_BegRWS.ubcr_Medic) DO
   PREV(XDocJrn);
  END;
 END {StandOnLastRWaySJrn};

 PRIVATE PROCEDURE rtc_GetCarMovingState(): LIKE(rtCar.State);
 BEGIN
  StandOnLastRWaySJrn();
  IF    XDocJrn.Action = L_XDoc.action_CarDeparture THEN
   RETURN rtcst_Departure;
  ELSIF XDocJrn.Action = L_XDoc.action_CarReturn THEN
   RETURN rtcst_Return;
  ELSIF XDocJrn.Action = L_XDoc.action_AcceptCarReturn THEN
   RETURN rtcst_AcptReturn;
  ELSE
   RETURN EMPTYOF(rtCar.State);
  END;
 END {rtc_GetCarMovingState};

 PRIVATE PROCEDURE rtc_GetCarLocation(): tCarLocation;
  VAR
   trgState: LIKE(rtCar.State);
 BEGIN
  trgState:=rtc_GetCarMovingState();
  IF    trgState = rtcst_AcptReturn THEN
   RETURN cl_EndOfWork;
  ELSIF trgState = rtcst_Return THEN
   RETURN cl_HasReturn;
  ELSIF trgState = rtcst_Departure THEN
   RETURN cl_HasDepart;
  ELSE
   RETURN cl_NotLeavedPark;
  END;
 END {rtc_GetCarLocation};

 PUBLIC PROCEDURE IsCarInPark(): SCAL[2];
  VAR
   location: tCarLocation;
 BEGIN
  location:=rtc_GetCarLocation();
  IF   location = cl_NotLeavedPark THEN
   RETURN ~L_BegRWS.CarIsUnderControlOfPrevRWayS();
  ELSE
   RETURN location # cl_HasDepart;
  END;
 END {IsCarInPark};

 PRIVATE PROCEDURE rtc_UnbindCurrent();
 BEGIN
  SETEMPTY(rtCar.XDocId, rtCar.BegDispD, rtCar.EndDispD, rtCar.Exit, rtCar.BegDTS, rtCar.EndDTS, rtCar.BRestDTS, rtCar.ERestDTS);
  rtCar.Route :=DummyRoute;
  rtCar.State :=rtcst_woRWayS;
  rtCar.MdfDTS:=L_DatTim.GetSysVARIANTDATE();
  REPLACE(rtCar);
 END {rtc_UnbindCurrent};

 PRIVATE PROCEDURE rt_GetSEJobsEndDTS(_Date: DATE): FLOAT;
 BEGIN
  RETURN L_DatTim.GetVARIANTDATE(_Date + (SEJobs.Day - 1) + 1 * (SEJobs.StopT < SEJobs.StartT), SEJobs.StopT, 00)
 END {rt_GetSEJobsEndDTS};

 PRIVATE PROCEDURE StandOnAnyXDocJrn(trgAction: LIKE(XDocJrn.Action));
 BEGIN
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
  LAST(XDocJrn);
  LOOP
   IF ~OCCURE(XDocJrn) | (XDocJrn.Action = trgAction) THEN
    EXIT;
   END;
   PREV(XDocJrn);
  END; (* LOOP *)
 END {StandOnAnyXDocJrn};

 PRIVATE PROCEDURE StandOnDepartureXDocJrn(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF L_BegRWS.E_UsingBarCodeScannerLevel(L_BegRWS.ubcr_Outpost) # L_BarCode.bcsl_None THEN
   StandOnAnyXDocJrn(L_XDoc.action_CarDeparture);
   Result:=OCCURE(XDocJrn);
  END;
  RETURN Result;
 END {StandOnDepartureXDocJrn};

 PRIVATE PROCEDURE rt_SetExitBegEndDTS(D: DATE; VAR bDTS, eDTS: FLOAT; byRWayS: SCAL[2]);
 BEGIN
  IF StExit.Strict = L_Way.ExitStrict_Reg THEN
   CONFORM(StExit, SEJobs);
   bDTS:=L_DatTim.GetVARIANTDATE(D, SEJobs.StartT, 00);
   LAST(SEJobs);
   eDTS:=rt_GetSEJobsEndDTS(D);
  END;
  IF byRWayS THEN
   IF StandOnDepartureXDocJrn() THEN
    bDTS:=L_DatTim.GetVARIANTDATE(XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec);
   ELSE
    bDTS:=L_DatTim.GetVARIANTDATE(RWayS.Date,   RWayS.StartTim,  00);
   END;
   CONFORM(RWayS, RWayTxt);
   IF L_BegRWS.RWayTxtIsValid() & ~!RWayTxt.FExTime & ~!RWayTxt.LEnTime THEN
    eDTS:=L_DatTim.GetVARIANTDATE(RWayS.Date + 1 * (RWayTxt.LEnTime < RWayTxt.FExTime), RWayTxt.LEnTime, 00);
   END;
  END;
 END {rt_SetExitBegEndDTS};

 PRIVATE PROCEDURE rt_FillExitRestPeriod(D: DATE; VAR BRestDTS, ERestDTS: FLOAT[]);
  VAR
   BegRest,
   parkStop : LIKE(Stop.Stop);
   i        : NUMERIC[0];
 BEGIN
  SETEMPTY(BRestDTS, ERestDTS, BegRest);
  parkStop:=L_Way.E_GetStopInPark();
  IF ~!parkStop THEN
   i:=0;
   SETEMPTY(BegRest);
   CONFORM(StExit, SEJobs);
   WHILE OCCURE(SEJobs) DO
    CONFORM(SEJobs, RoutMod);
    CONFORM(RoutMod, RtMStop);
    WHILE OCCURE(RtMStop) & (i <= HIGH(BRestDTS)) DO
     IF RtMStop.Stop = parkStop THEN
      IF   !BegRest THEN
       BegRest:=1;
      ELSIF BegRest = 1 THEN
       BRestDTS[i]:=rt_GetSEJobsEndDTS(D);
       BegRest:=0;
      ELSIF BegRest = 0 THEN
       ERestDTS[i]:=L_DatTim.GetVARIANTDATE(D + (SEJobs.Day - 1), SEJobs.StartT, 00);
       BegRest:=1;
       INC(i);
      END;
     END;
     NEXT(RtMStop);
    END; (* WHILE OCCURE(RtMStop) ... *)
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs) ... *)
   IF BegRest = 0 THEN
    SETEMPTY(BRestDTS[i]);
   END;
  END;
 END {rt_FillExitRestPeriod};

 PRIVATE PROCEDURE rtc_Unbind(trgBoxNbr: LIKE(Car.BoxNbr); trgXDocId: L_XDoc.tXDocId);
 BEGIN
  WHILE SELECT(rtCar, XDocId, trgXDocId, trgBoxNbr) DO
   rtc_UnbindCurrent();
  END; (* WHILE OCCURE(rtCar) ... *)
 END {rtc_Unbind};

 PUBLIC PROCEDURE rtc_Insert(trgXDocType: L_XDoc.tXDocType; trgBoxNbr: LIKE(Car.BoxNbr));
  VAR
   i          : NUMERIC[0];
   wReplace   : SCAL[2];
   trgBegDTS,
   trgEndDTS  : FLOAT;
   trgBRestDTS: LIKE(rtCar.BRestDTS);
   trgERestDTS: LIKE(rtCar.ERestDTS);
   trgRoute   : LIKE(Route.Route);
   trgExit    : LIKE(StExit.Exit);
   trgXDocId  : L_XDoc.tXDocId;
   trgState   : LIKE(rtCar.State);
   trgDate,
   trgDispDate,
   sysDispDate: DATE;
   trgColumn  : LIKE(CarLog.Column);
   trgPurpose : LIKE(CarLog.Purpose);
   trgMarkName: STRING[];
 BEGIN
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

   SETEMPTY(trgXDocId, trgRoute, trgExit, trgBegDTS, trgEndDTS, trgBRestDTS, trgERestDTS);
   IF ~!trgXDocType THEN
    trgXDocId:=L_XDoc.curXDocId(trgXDocType);
   END;
   sysDispDate:=L_BegRWS.DspSysDate();
 
   IF    trgXDocType = L_XDoc.xdt_RWayS THEN
    IF (RWayS.Status > L_Way.rwsStat_Ordered) & SELECT(RWayJ, RWayS, RWayS.RWayS) & LAST(RWayJ) THEN
     CONFORM(RWayJ, SEJobs);
     CONFORM(SEJobs, StExit);
    ELSE
     CONFORM(RWayS, StExit);
     CONFORM(StExit, SEJobs);
    END;
    rt_SetExitBegEndDTS(RWayS.Date, trgBegDTS, trgEndDTS, 1);
    trgDate    :=RWayS.Date;
    trgDispDate:=L_BegRWS.DspDate(RWayS.Date, RWayS.StartTim);
   ELSIF trgXDocType = L_XDoc.xdt_RprS THEN
    trgDate    :=RprS.OrdDate;
    trgDispDate:=Math.Max(L_BegRWS.DspDate(RprS.OrdDate, RprS.OrdTime), sysDispDate);
   ELSE
    SETEMPTY(trgDate);
    trgDispDate:=sysDispDate;
   END;
 
   IF trgXDocType = L_XDoc.xdt_RWayS THEN
    IF !trgEndDTS | (sysDispDate <= ConvToDispDate(trgEndDTS)) THEN
     trgDispDate:=Math.Max(trgDispDate, sysDispDate);
    END;
   END;
 
   IF L_Env.RealBoxNbr(trgBoxNbr) THEN
    L_Car.StandOnCarLog(trgBoxNbr, trgDispDate);
    CONFORM(CarLog, Mark);
    trgColumn  :=CarLog.Column;
    trgPurpose :=CarLog.Purpose;
    trgMarkName:=CarLog.StateNbr + " (" + Mark.Name + ")";
 
    IF    trgXDocType = L_XDoc.xdt_RWayS THEN
     CONFORM(SEJobs, Route);
     trgRoute :=Route.Route;
     trgExit  :=StExit.Exit;

     IF StExit.Strict = L_Way.ExitStrict_Reg THEN
      rt_FillExitRestPeriod(RWayS.Date, trgBRestDTS, trgERestDTS);
     END;
     IF    RWayS.Status = L_Way.rwsStat_Ordered THEN
      IF L_Env.RealTSN(RWayS.TSN) THEN
       trgState:=rtcst_Ordered;
      ELSE
       trgState:=rtcst_woDriver;
      END;
     ELSIF RWayS.Status = L_Way.rwsStat_Given THEN
      trgState:=rtc_GetCarMovingState();
      IF !trgState THEN
       IF    L_Way.IsExitClasswERKN(StExit.ExitClss, L_Way.erkn_ec_CurRepair) |
             L_Way.IsExitClasswERKN(StExit.ExitClss, L_Way.erkn_ec_RepairWODrv) THEN
        trgState:=rtcst_Repair;
       ELSIF L_Way.IsExitClasswERKN(StExit.ExitClss, L_Way.erkn_ec_TO2) THEN
        trgState:=rtcst_TO2;
       ELSIF L_Way.IsExitClasswERKN(StExit.ExitClss, L_Way.erkn_ec_Overhaul) THEN
        trgState:=rtcst_LongRepair;
       ELSIF L_Way.IsExitClasswERKN(StExit.ExitClss, L_Way.erkn_ec_InWaitingForRepair) THEN
        trgState:=rtcst_WaitRepair;
       ELSIF L_Way.IsExitClasswERKN(StExit.ExitClss, L_Way.erkn_ec_Reserve) THEN
        trgState:=rtcst_Reserve;
       ELSE
        trgState:=rtcst_Given;
       END;
      END;
     ELSIF RWayS.Status = L_Way.rwsStat_Taken THEN
      trgState:=rtcst_Taken;
     END; (* IF RWayS.Status = L_Way.rwsStat_Ordered...*)
    ELSIF trgXDocType = L_XDoc.xdt_RprS THEN
     trgRoute :=DummyRoute;
     trgBegDTS:=L_DatTim.GetVARIANTDATE(RprS.OrdDate, RprS.OrdTime, 00);
     IF    RprS.Status = L_Rpr.ms_PutOff THEN
      trgState:=rtcst_LongRepair;
     ELSIF RprS.Status = L_Rpr.ms_Waiting THEN
      trgState:=rtcst_WaitRepair;
     ELSIF L_Rpr.HasOpenTask_TO2(RprS.RprS) THEN
      trgState:=rtcst_TO2;
     ELSE
      trgState:=rtcst_Repair;
     END;
    ELSIF !trgXDocType THEN
     trgRoute :=DummyRoute;
     trgState :=rtcst_woRWayS;
    END; (* IF trgXDocType = L_XDoc.xdt_RWayS... *)
   END; (* IF L_Env.RealBoxNbr(trgBoxNbr)...*)
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)

  IF ~!trgXDocId THEN
   IF SELECT(rtCar, XDocId, trgXDocId) & (trgDate # rtCar.BegDispD) THEN
    rtc_Unbind(trgBoxNbr, trgXDocId);
   END;
 
   IF SELECT(rtCar, XDocId, trgXDocId) & (trgBoxNbr # rtCar.BoxNbr) THEN
    rtc_UnbindCurrent();
   END;
  END;

  IF L_Env.RealBoxNbr(trgBoxNbr) THEN
   wReplace:=~!trgXDocId & (SELECT(rtCar, DDBoxNbr, trgDispDate, trgBoxNbr, trgXDocId) |
                            SELECT(rtCar, DDBoxNbr, trgDispDate, trgBoxNbr, ""));
   IF ~wReplace THEN
    DEFAULT(rtCar);
    rtCar.DispDate:=trgDispDate;
    rtCar.BoxNbr  :=trgBoxNbr;
    rtCar.Column  :=trgColumn;
    rtCar.Purpose :=trgPurpose;
    rtCar.MarkName:=trgMarkName;
   END;
 
   rtCar.XDocId   :=trgXDocId;
   rtCar.BegDTS   :=trgBegDTS;
   IF !rtCar.EndDTS & !trgEndDTS & (trgXDocType = L_XDoc.xdt_RWayS) & (RWayS.Status = L_Way.rwsStat_Taken) THEN
    trgEndDTS:=L_DatTim.GetSysVARIANTDATE();
   END;
   rtCar.EndDTS   :=trgEndDTS;
   IF ~!rtCar.BegDTS THEN
    rtCar.BegDispD:=ConvToDispDate(rtCar.BegDTS);
   ELSE
    SETEMPTY(rtCar.BegDispD);
   END;
   IF ~!rtCar.EndDTS THEN
    rtCar.EndDispD:=ConvToDispDate(rtCar.EndDTS);
   ELSE
    SETEMPTY(rtCar.EndDispD);
   END;
   rtCar.InFuture :=sysDispDate < trgDispDate;
 
   i:=0;
   WHILE i <= HIGH(trgBRestDTS) DO
    rtCar.BRestDTS[i] :=trgBRestDTS[i];
    rtCar.ERestDTS[i] :=trgERestDTS[i];
    INC(i);
   END;
 
   rtCar.Route  :=trgRoute;
   rtCar.Exit   :=trgExit;
   rtCar.MdfDTS :=L_DatTim.GetSysVARIANTDATE();
   rtCar.State  :=trgState;
   IF wReplace THEN
    REPLACE(rtCar);
   ELSE
    INSERT(rtCar);
   END;
  END;
 END {rtc_Insert};

 PUBLIC PROCEDURE rtc_UnbindByRWayS();
 BEGIN
  rtc_Unbind(RWayS.BoxNbr, L_XDoc.curXDocId(L_XDoc.xdt_RWayS));
 END {rtc_UnbindByRWayS};

 PUBLIC PROCEDURE rtc_PutByRWayS();
 BEGIN
  IF ~!RWayS.BoxNbr THEN
   IF RWayS.Status # L_Way.rwsStat_Rated THEN
    rtc_Insert(L_XDoc.xdt_RWayS, RWayS.BoxNbr);
   ELSE
    rtc_UnbindByRWayS();
   END;
  END;
 END {rtc_PutByRWayS};

 PUBLIC PROCEDURE rtc_PutByRprS();
 BEGIN
  CONFORM(RprS, CUCopy);
  L_CUC.AccessOrigin();
  IF ~RprS.Closed THEN
   rtc_Insert(L_XDoc.xdt_RprS, Car.BoxNbr);
  ELSE
   rtc_Unbind(Car.BoxNbr, L_XDoc.curXDocId(L_XDoc.xdt_RprS));
  END;
 END {rtc_PutByRprS};

 PRIVATE PROCEDURE rtc_Replicate(curDispDate: DATE);
  VAR
   DoIns: SCAL[2];
 BEGIN
  SAVE(rtCar);
  DoIns:=~SELECT(rtCar, DDBoxNbr, curDispDate, rtCar.BoxNbr, rtCar.XDocId);
  RESTORE(rtCar);
  IF DoIns THEN
   SAVE(rtCar);
   rtCar.DispDate:=curDispDate;
   rtCar.MdfDTS  :=L_DatTim.GetSysVARIANTDATE();
   INSERT(rtCar);
   RESTORE(rtCar);
  END;
 END {rtc_Replicate};

 PUBLIC PROCEDURE rtc_Renew();
  VAR
   curDispDate: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  curDispDate:=L_BegRWS.DspSysDate();
  IF SELECT(rtCar, DDInFuture, curDispDate, 1) | ~SELECT(rtCar, DDBoxNbr, curDispDate) THEN
   SELECT(rtCar, DDBoxNbr);
   WHILE OCCURE(rtCar) & (rtCar.DispDate < (curDispDate - 4)) DO
    PROMPT("⪠   ﭨ  " + L_DatTim.DateStr(rtCar.DispDate));
    REMOVE(rtCar);
   END; (* WHILE OCCURE(rtCar) & (rtCar.DispDate < (curDispDate - 4))...*)

   WHILE SELECT(rtCar, DDInFuture, curDispDate, 1) DO
    PROMPT(" ண " + rtCar.BoxNbr);
    rtCar.InFuture:=0;
    rtCar.MdfDTS  :=L_DatTim.GetSysVARIANTDATE();
    REPLACE(rtCar);
   END; (* WHILE SELECT(rtCar, DDInFuture,  ...*)

   TABLE.Get("rtCar").AccessDataMode:=adm_HOTTEST;
   IF SELECT(rtCar, DDEndDispD, curDispDate-1) & SRCINSEL(rtCar, GE, curDispDate) THEN
    WHILE OCCURE(rtCar) DO
     PROMPT(" " + rtCar.BoxNbr);
     IF (rtCar.State # rtcst_woRWayS) & (rtCar.State # rtcst_woDriver) THEN
      IF    ~!rtCar.BegDispD THEN
       rtc_Replicate(curDispDate);
      ELSIF ~!rtCar.XDocId & (L_XDoc.ExtractXDocType(rtCar.XDocId) = L_XDoc.xdt_RWayS) THEN
       rtc_Replicate(curDispDate);
      END;
     END;
     NEXT(rtCar);
    END; (* WHILE OCCURE(rtCar) ... *)
   END;

   SELECT(Car, BoxNbr);
   WHILE OCCURE(Car) DO
    PROMPT("  " + Car.BoxNbr);
    IF L_Env.RealBoxNbr(Car.BoxNbr)                      &
       ~SELECT(rtCar, DDBoxNbr, curDispDate, Car.BoxNbr) &
       L_Car.CarIsInOperation(Car.BoxNbr, curDispDate) THEN
     rtc_Insert(EMPTYOF(L_XDoc.tXDocType), Car.BoxNbr);
    END;
    NEXT(Car);
   END; (* WHILE OCCURE(Car) ... *)
  END; (* IF SELECT(rtCar, DDInFuture, curDispDate, 1) | ~SELECT(rtCar, DDBoxNbr, curDispDate)...*)
 END {rtc_Renew};

 PUBLIC PROCEDURE rtc_Init();
 BEGIN
  TRY [TRANSACTION(TRANSACTION_SLAVE)]
   rtc_Renew();
  EXCEPT
  ON Exc: Exc_Root DO
   RAISE();
  END; (* TRY *)
 END {rtc_Init};

 PUBLIC PROCEDURE BreakageOnLine(): SCAL[2];
 BEGIN
  IF SELECT(RWayJ, RWayS, RWayS.RWayS) & LAST(RWayJ) THEN
   CONFORM(RWayJ,  SEJobs);
   CONFORM(SEJobs, WJMode);
   RETURN (WJMode.WJType = L_Way.WJType_Repair) |
          (WJMode.WJType = L_Way.WJType_Stand );
  END;
  RETURN 0;
 END {BreakageOnLine};

 PRIVATE PROCEDURE IsProblemInRestPeriod(    SysDTS        : FLOAT;
                                         VAR trgBRestDTS   : FLOAT[];
                                         VAR trgERestDTS   : FLOAT[];
                                             CheckBeginRest: SCAL[2]): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=1;
  WHILE (i <= HIGH(trgBRestDTS)) & ~!trgBRestDTS[i-1] DO
   IF CheckBeginRest THEN
    IF (SysDTS >= trgBRestDTS[i-1]) & (SysDTS <= trgERestDTS[i-1]) THEN
     RETURN 1;
    END;
   ELSE
    IF (SysDTS >= trgERestDTS[i-1]) & (~!trgBRestDTS[i] & (SysDTS <= trgBRestDTS[i])) THEN
     RETURN 1;
    END;
   END;
   INC(i);
  END; (* WHILE ~!trgBRestDTS[i-1] &... *)
  RETURN 0;
 END {IsProblemInRestPeriod};

 PUBLIC PROCEDURE IsBeginRestDelay(    SysDTS     : FLOAT;
                                   VAR trgBRestDTS: FLOAT[];
                                   VAR trgERestDTS: FLOAT[]): SCAL[2];
 BEGIN
  RETURN IsProblemInRestPeriod(SysDTS, trgBRestDTS, trgERestDTS, 1);
 END {IsBeginRestDelay};

 PUBLIC PROCEDURE IsEndRestDelay(    SysDTS     : FLOAT;
                                 VAR trgBRestDTS: FLOAT[];
                                 VAR trgERestDTS: FLOAT[]): SCAL[2];
 BEGIN
  RETURN IsProblemInRestPeriod(SysDTS, trgBRestDTS, trgERestDTS, 0);
 END {IsEndRestDelay};

 PUBLIC PROCEDURE IsInRest(    SysDTS     : FLOAT;
                           VAR trgBRestDTS: FLOAT[];
                           VAR trgERestDTS: FLOAT[]): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE (i <= HIGH(trgBRestDTS)) & ~!trgBRestDTS[i] DO
   IF (SysDTS >= trgBRestDTS[i]) & (SysDTS <= trgERestDTS[i]) THEN
    RETURN 1;
   END;
   INC(i);
  END; (* WHILE *)
  RETURN 0;
 END {IsInRest};

 PUBLIC PROCEDURE GetrtCarState(SysDTS: FLOAT): trtc_State;
  VAR
   GivenDelayLength: FLOAT;
 BEGIN
  IF    (rtCar.State = rtcst_Ordered) THEN
   IF ~!rtCar.BegDTS THEN
    GivenDelayLength:=(rtCar.BegDTS - SysDTS) * 24 * 60;
    IF    GivenDelayLength > 30 THEN
     RETURN rtc_st_Ordered;
    ELSIF GivenDelayLength > 10 THEN
     RETURN rtc_st_GivenCountdown;
    ELSE
     RETURN rtc_st_GivenDelay;
    END;
   ELSE
    RETURN rtc_st_Ordered;
   END;
  ELSIF (rtCar.State = rtcst_Given) THEN
   IF    ~!rtCar.BegDTS THEN
    IF SysDTS > rtCar.BegDTS THEN
     L_XDoc.PositionOnXDoc(rtCar.XDocId);
     IF L_BegRWS.CarIsUnderControlOfPrevRWayS() |
        (L_BegRWS.E_UsingBarCodeScannerLevel(L_BegRWS.ubcr_Outpost) = L_BarCode.bcsl_None) THEN
      IF ~!rtCar.EndDTS & (SysDTS > rtCar.EndDTS) THEN
       RETURN rtc_st_ReturnDelay;
      ELSE
       RETURN rtc_st_Work;
      END;
     ELSE
      RETURN rtc_st_DepartureDelay;
     END;
    ELSE
     RETURN rtc_st_InPark;
    END;
   ELSIF (L_BegRWS.E_UsingBarCodeScannerLevel(L_BegRWS.ubcr_Outpost) = L_BarCode.bcsl_None) THEN
    RETURN rtc_st_Work;
   ELSE
    RETURN rtc_st_InPark;
   END;
  ELSIF (rtCar.State = rtcst_Departure) THEN
   IF ~!rtCar.EndDTS THEN
    L_XDoc.PositionOnXDoc(rtCar.XDocId);
    IF    IsBeginRestDelay(SysDTS, rtCar.BRestDTS, rtCar.ERestDTS) THEN
     RETURN rtc_st_ReturnDelay;
    ELSIF SysDTS > rtCar.EndDTS THEN
     IF L_BegRWS.CarIsUnderControlOfNextRWayS() THEN
      RETURN rtc_st_Work;
     ELSE
      RETURN rtc_st_ReturnDelay;
     END;
    ELSIF BreakageOnLine() THEN
     RETURN rtc_st_BreakageOnLine;
    ELSE
     RETURN rtc_st_Work;
    END;
   ELSE
    RETURN rtc_st_Work;
   END;
  ELSIF (rtCar.State = rtcst_Return) THEN
   IF    IsEndRestDelay(SysDTS, rtCar.BRestDTS, rtCar.ERestDTS) THEN
    RETURN rtc_st_DepartureDelay;
   ELSIF ~IsInRest(SysDTS, rtCar.BRestDTS, rtCar.ERestDTS) &
         (L_DatTim.GetVARIANTDATEPeriod_Hour(rtCar.MdfDTS, SysDTS) > (LongTimeAgoLength/60)) THEN
    RETURN rtc_st_LongTimeAgoReturn;
   ELSE
    RETURN rtc_st_InPark;
   END;
  ELSIF (rtCar.State = rtcst_AcptReturn) THEN
   IF ~!rtCar.EndDTS THEN
    IF SysDTS < rtCar.EndDTS THEN
     RETURN rtc_st_EarlyReturn;
    ELSE
     RETURN rtc_st_InPark;
    END;
   ELSE
    RETURN rtc_st_InPark;
   END;
  ELSIF rtCar.State = rtcst_Taken THEN
   IF ~!rtCar.EndDTS THEN
    IF SysDTS < rtCar.EndDTS THEN
     RETURN rtc_st_EarlyReturn;
    ELSE
     RETURN rtc_st_InPark;
    END;
   ELSE
    RETURN rtc_st_InPark;
   END;
  ELSIF (rtCar.State = rtcst_Repair) THEN
   IF L_XDoc.ExtractXDocType(rtCar.XDocId) = L_XDoc.xdt_RWayS THEN
    L_XDoc.PositionOnXDoc(rtCar.XDocId);
    IF (rtc_GetCarMovingState() = rtcst_Departure) & BreakageOnLine() THEN
     RETURN rtc_st_BreakageOnLine;
    END;
   END;
   RETURN rtc_st_Repair;
  ELSIF (rtCar.State = rtcst_TO2) THEN
   RETURN rtc_st_TO2;
  ELSIF (rtCar.State = rtcst_LongRepair) THEN
   RETURN rtc_st_LongRepair;
  ELSIF (rtCar.State = rtcst_WaitRepair) THEN
   RETURN rtc_st_WaitRepair;
  ELSIF (rtCar.State = rtcst_woRWayS) THEN
   L_Car.StandOnCarLog(rtCar.BoxNbr, rtCar.DispDate);
   IF CarLog.InBeg = L_Car.inBeg_Required THEN
    RETURN rtc_st_woDriver;
   ELSE
    RETURN rtc_st_woRWayS;
   END;
  ELSIF (rtCar.State = rtcst_woDriver) THEN
   RETURN rtc_st_woDriver;
  ELSIF (rtCar.State = rtcst_Reserve) THEN
   RETURN rtc_st_Reserve;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetrtCarState};

(*rtExit*)
 PRIVATE PROCEDURE rte_UnbindCurrent();
 BEGIN
  IF L_Way._CheckExitOnDate(rtExit.Exit, rtExit.DispDate) # L_Way.exvld_Active THEN
   REMOVE(rtExit);
  ELSE
   SETEMPTY(rtExit.RWayS);
   rtExit.Status  :=0;
   rtExit.rwsState:=rterwss_NotOrdered;
   REPLACE(rtExit);
  END;
 END {rte_UnbindCurrent};

 PUBLIC PROCEDURE rte_UnbindByRWayS();
 BEGIN
  WHILE SELECT(rtExit, RWayS, RWayS.RWayS) DO
   rte_UnbindCurrent();
  END; (* WHILE SELECT(rtExit ... *)
 END {rte_UnbindByRWayS};

 PRIVATE PROCEDURE rte_GetrwsState(byRWayS: SCAL[2]): LIKE(rtExit.rwsState);
 BEGIN
  IF    ~byRWayS | ~L_Env.RealTSN(RWayS.TSN) | ~L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
   RETURN rterwss_NotOrdered;
  ELSIF RWayS.Status = L_Way.rwsStat_Ordered THEN
   RETURN rterwss_Ordered;
  ELSIF RWayS.Status = L_Way.rwsStat_Given THEN
   StandOnLastRWaySJrn();
   IF    XDocJrn.Action = L_XDoc.action_CarDeparture THEN
    RETURN rterwss_Departure;
   ELSIF XDocJrn.Action = L_XDoc.action_CarReturn THEN
    RETURN rterwss_Return;
   ELSIF XDocJrn.Action = L_XDoc.action_AcceptCarReturn THEN
    RETURN rterwss_AcptReturn;
   ELSE
    RETURN rterwss_Given;
   END;
  ELSIF RWayS.Status = L_Way.rwsStat_Taken THEN
   RETURN rterwss_Taken;
  END;
 END {rte_GetrwsState};

 PUBLIC PROCEDURE rtCar_StandOnActual(SysDTS: FLOAT);
  VAR
   trgBegDTS   : FLOAT;
   ActiveAmount: NUMERIC[0];
 BEGIN
  IF ~DBD.FileExist(ActvD) THEN
   L_AFM.MakeIndex("ActvD", "IsActive: SCAL[2];"+
                            "XDocType: SCAL[1E2];"+
                            "BegDTS  : FLOAT;" +
                            "XDocId  : LIKE(rtCar.XDocId)");
  ELSE
   SELECT(ActvD, ActvD);
   REMSEL(ActvD);
  END;

  SETZERO(ActiveAmount);
  SAVE(rtCar);
  WHILE OCCURE(rtCar) DO
   IF ~!rtCar.XDocId THEN
    ActvD.IsActive:=(!rtCar.BegDTS | (rtCar.BegDTS < SysDTS)) & (!rtCar.EndDTS | (SysDTS < rtCar.EndDTS));
    ActvD.XDocType:=L_XDoc.ExtractXDocType(rtCar.XDocId);
    ActvD.BegDTS  :=rtCar.BegDTS;
    ActvD.XDocId  :=rtCar.XDocId;
    INSERT(ActvD);

    INC(ActiveAmount, ActvD.IsActive);
   END;
   NEXT(rtCar);
  END; (* WHILE OCCURE(rtCar) ... *)
  RESTORE(rtCar);

  IF    ActiveAmount = 0 THEN
   SELECT(ActvD, ActvD, , 0, L_XDoc.xdt_RWayS);
  ELSIF ActiveAmount = 1 THEN
   SELECT(ActvD, ActvD, , 1);
  ELSE
   IF ~SELECT(ActvD, ActvD, 1, L_XDoc.xdt_RprS) THEN
    SELECT(ActvD, ActvD, , 1, L_XDoc.xdt_RWayS);
    SRCINSEL(ActvD, LE, , SysDTS);
   END;
  END;

  IF OCCURE(ActvD) THEN
   LOOP
    WHILE OCCURE(rtCar) DO
     IF rtCar.XDocId = ActvD.XDocId THEN
      EXIT;
     END;
     NEXT(rtCar);
    END; (* WHILE OCCURE(rtCar) ... *)
   END; (* LOOP *)
  END;
 END {rtCar_StandOnActual};

 PRIVATE PROCEDURE rte_Insert(byRWayS  : SCAL[2];
                              _rwsState: LIKE(rtExit.rwsState));
  VAR
   i          : NUMERIC[0];
   trgDispDate,
   sysDispDate: DATE;
   trgStatus  : LIKE(rtExit.Status);
   trgRWayS   : LIKE(RWayS.RWayS);
   wReplace   : SCAL[2];
   trgBegDTS,
   trgEndDTS  : FLOAT;
   trgBRestDTS: LIKE(rtCar.BRestDTS);
   trgERestDTS: LIKE(rtCar.ERestDTS);
   trgExit    : LIKE(StExit.Exit);
   trgSuppl   : LIKE(StExit.Suppl);
   FullECSign : STRING[];
   trgDprt    : LIKE(Sort.Sort);
 BEGIN
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

   sysDispDate:=L_BegRWS.DspSysDate();

   CONFORM(StExit, ExitClss);
   trgExit   :=StExit.Exit;
   trgSuppl  :=StExit.Suppl;
   FullECSign:=ExitClss.Sign;
   IF StExit.Change # 0 THEN
    FullECSign :=FullECSign + "_" + StExit.Change;
   END;

   IF byRWayS THEN
    rt_SetExitBegEndDTS(RWayS.Date, trgBegDTS, trgEndDTS, byRWayS);
    trgDispDate:=L_BegRWS.DspDate(RWayS.Date, RWayS.StartTim);
    trgRWayS   :=RWayS.RWayS;
    rt_FillExitRestPeriod(RWayS.Date, trgBRestDTS, trgERestDTS);
   ELSE
    rt_SetExitBegEndDTS(SYSDATE(),  trgBegDTS, trgEndDTS, byRWayS);
    trgDispDate:=sysDispDate;
    SETEMPTY(trgBRestDTS, trgERestDTS, trgRWayS);
   END;

   IF L_Way.StandOnFixedSortOfExit(trgExit, trgDispDate, L_Way.rwswho_Driver, 0) THEN
    trgDprt:=L_Staff.getSortDprt(Sort.Sort);
   ELSE
    SETEMPTY(trgDprt);
   END;

   IF sysDispDate <= ConvToDispDate(trgEndDTS) THEN
    trgDispDate:=Math.Max(trgDispDate, sysDispDate);
   END;

   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)

  IF byRWayS THEN
   IF SELECT(rtExit, RWayS, RWayS.RWayS) & (RWayS.Date # rtExit.BegDispD) THEN
    rte_UnbindByRWayS();
   END;
   IF SELECT(rtExit, DDRWayS, trgDispDate, RWayS.RWayS) & (trgExit # rtExit.Exit) THEN
    rte_UnbindCurrent();
   END;
  END;

  wReplace:=(byRWayS & SELECT(rtExit, DDRWayS, trgDispDate, trgRWayS)) | SELECT(rtExit, DDExit, trgDispDate, trgExit);

  IF ~wReplace THEN
   DEFAULT(rtExit);
   rtExit.Dprt  :=trgDprt;
  END;

  rtExit.DispDate:=trgDispDate;
  rtExit.ECSign  :=FullECSign;
  rtExit.Exit    :=trgExit;
  rtExit.Suppl   :=trgSuppl;
  rtExit.RWayS   :=trgRWayS;
  rtExit.InFuture:=sysDispDate < trgDispDate;
  rtExit.BegDTS  :=trgBegDTS;
  rtExit.EndDTS  :=trgEndDTS;
  rtExit.BegDispD:=ConvToDispDate(rtExit.BegDTS);
  rtExit.EndDispD:=ConvToDispDate(rtExit.EndDTS);
  i:=0;
  WHILE i <= HIGH(trgBRestDTS) DO
   rtExit.BRestDTS[i] :=trgBRestDTS[i];
   rtExit.ERestDTS[i] :=trgERestDTS[i];
   INC(i);
  END;
  rtExit.RWSMdDTS:=L_DatTim.GetSysVARIANTDATE();
  rtExit.rwsState:=_rwsState;
  IF rtExit.rwsState = rterwss_Taken THEN
   IF rtExit.EndDTS <= rtExit.RWSMdDTS THEN
    trgStatus:=1;
   ELSE
    trgStatus:=0;
   END;
  ELSE
   trgStatus:=rtExit.rwsState > rterwss_Ordered;
  END;
  rtExit.Status  :=trgStatus;

  IF wReplace THEN
   REPLACE(rtExit);
  ELSE
   INSERT(rtExit);
  END;
 END {rte_Insert};

 PUBLIC PROCEDURE rte_Put(byRWayS: SCAL[2]);
 BEGIN
  IF L_Way.E_BegRWSLev(SYSDATE()) > L_Way.brwsl_NoBeg THEN
   IF byRWayS THEN
    IF (RWayS.Status > L_Way.rwsStat_Ordered) & SELECT(RWayJ, RWayS, RWayS.RWayS) & LAST(RWayJ) THEN
     CONFORM(RWayJ, SEJobs);
     CONFORM(SEJobs, StExit);
    ELSE
     CONFORM(RWayS, StExit);
    END;
   END;
   IF StExit.Strict = L_Way.ExitStrict_Reg THEN
    rte_Insert(byRWayS, rte_GetrwsState(byRWayS));
   ELSE
    rte_UnbindByRWayS();
   END;
  END;
 END {rte_Put};

 PRIVATE PROCEDURE rte_Replicate(curDispDate: DATE);
  VAR
   DoIns: SCAL[2];
 BEGIN
  SAVE(rtExit);
  DoIns:=~SELECT(rtExit, DDExit, curDispDate, rtExit.Exit);
  RESTORE(rtExit);
  IF DoIns THEN
   SAVE(rtExit);
   rtExit.DispDate:=curDispDate;
   INSERT(rtExit);
   RESTORE(rtExit);
  END;
 END {rte_Replicate};

 PUBLIC PROCEDURE rte_Renew();
  VAR
   D, curDispDate: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  curDispDate:=L_BegRWS.DspSysDate();
  IF SELECT(rtExit, DDInFuture, curDispDate, 1) | ~SELECT(rtExit, DispDate, curDispDate) THEN
   D:=curDispDate - 4;
   WHILE SELECT(rtExit, DispDate, D) DO
    PROMPT("⪠   ﭨ 室 " + L_DatTim.DateStr(D));
    REMSEL(rtExit);
    DEC(D);
   END; (* WHILE SELECT(rtExit, DispDate,  ...*)

   WHILE SELECT(rtExit, DDInFuture, curDispDate, 1) DO
    PROMPT(" ண " + rtExit.Exit);
    rtExit.InFuture:=0;
    REPLACE(rtExit);
   END; (* WHILE SELECT(rtExit, DDInFuture,  ...*)

   TABLE.Get("rtExit").AccessDataMode:=adm_HOTTEST;
   IF SELECT(rtExit, DDEndDispD, curDispDate-1) & SRCINSEL(rtExit, GE, curDispDate) THEN
    WHILE OCCURE(rtExit) DO
     PROMPT(" " + rtExit.Exit);
     rte_Replicate(curDispDate);
     NEXT(rtExit);
    END; (* WHILE OCCURE(rtExit) ... *)
   END;

   SELECT(StExit, Strict, , L_Way.ExitStrict_Reg);
   SRCINSEL(StExit, GE, , curDispDate-10);
   WHILE OCCURE(StExit) DO
    PROMPT(" ᯨᠭ " + StExit.Exit);
    IF (L_Way._CheckExitOnDate(StExit.Exit, curDispDate) = L_Way.exvld_Active) THEN
     IF ~SELECT(rtExit, DDExit, curDispDate, StExit.Exit) THEN
      rte_Insert(0, rterwss_NotOrdered);
     END;
    ELSE
     IF SELECT(rtExit, DDExit, curDispDate, StExit.Exit) THEN
      IF !rtExit.RWayS THEN
       REMOVE(rtExit);
      END;
     END;
    END;
    NEXT(StExit);
   END; (* WHILE OCCURE(StExit) ... *)
  END; (* IF SELECT(rtExit, DDInFuture, curDispDate, 1) | ~SELECT(rtExit, DispDate, curDispDate)...*)
 END {rte_Renew};

 PUBLIC PROCEDURE rte_Init();
 BEGIN
  IF L_Way.E_BegRWSLev(SYSDATE()) > L_Way.brwsl_NoBeg THEN
   TRY [TRANSACTION(TRANSACTION_SLAVE)]
    rte_Renew();
   EXCEPT
   ON Exc: Exc_Root DO
    RAISE();
   END; (* TRY *)
  END;
 END {rte_Init};

 PUBLIC PROCEDURE rtx_Init();
 BEGIN
  rte_Init();
  rtc_Init();
 END {rtx_Init};

END.
