(*
%Copyright   (c) Polak Computer System
%Author      25.07.2002 12:15:12 SAN
%Purpose     প 
%Type        library
%Specific    AP_PC
%Modified    24.10.2013 19:40:21 POLAK\GAV
%Environment
*)

 MODULE L_SCAD [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tValue = SCAL[1E4];
  tMode  = SCAL[21];

 PUBLIC CONST
  cpv_Unknown       = 9999; (*ᯮ*)
  cpv_Disable       = 9998; (*  ࠡ⠥*)
  cpv_Imported      = 9997; (*६ ஢*)
  cpv_SetByOperator = 9996; (*६ ⠭ ஬*)

 IMPORT L_Str, Math, L_Way, L_General, L_EC, L_Env, L_DatTim, E_Way, DBD, P_Route;

 PRIVATE PROCEDURE convInSec(basisDate, D: DATE; T: TIME; S: NUMERIC[0]): NUMERIC[0];
 BEGIN
  RETURN ((D-basisDate)*24+(T-00:00))*3600 + S;
 END {convInSec};

 PRIVATE PROCEDURE MARK_QQ(Mode: tMode; Value: tValue): NUMERIC[0];
  CONST
   digAmn = 4;
   b_oAmn = 3;
  VAR
   asValue: STRING[digAmn];
   Digit  : SCAL[10];
   Binary,
   Q      : SCAL[2][digAmn*b_oAmn];
   E, D,
   S, T   : SCAL[2][b_oAmn];
   i, j,
   m      : NUMERIC[0];
   R      : NUMERIC[0];
 BEGIN
  asValue:=Value;
  i:=0;
  WHILE i < digAmn DO
   Digit:=L_Str.Char(asValue, i);
   IF Digit > 7 THEN
    RETURN -1;
   END;
   j:=b_oAmn;
   WHILE j > 0 DO
    DEC(j);
    Binary[(digAmn-i)*b_oAmn-j-1]:=Digit MOD 2;
    Digit:=Digit DIV 2;
   END;
   INC(i);
  END;
  E[0]:=Binary[ 1-1]; E[1]:=Binary[ 2-1]; E[2]:=Binary[ 3-1];
  D[0]:=Binary[ 4-1]; D[1]:=Binary[ 5-1]; D[2]:=Binary[ 6-1];
  S[0]:=Binary[ 7-1]; S[1]:=Binary[ 8-1]; S[2]:=Binary[ 9-1];
  T[0]:=Binary[10-1]; T[1]:=Binary[11-1]; T[2]:=Binary[12-1];

  Q[ 3]:=T[2]; Q[ 4]:=D[2];
  Q[ 6]:=E[2]; Q[ 0]:=S[1];
  Q[ 1]:=D[0]; Q[ 2]:=E[0];
  Q[ 9]:=S[2]; Q[ 7]:=T[0];
  Q[10]:=T[1]#Q[1]; Q[ 5]:=Q[0]#S[0];
  Q[11]:=Q[0]#D[1]; Q[ 8]:=Q[0]#E[1];

  IF    Mode = 1 THEN
  ELSIF Mode = 2 THEN
   Q[10]:=T[0]#Q[1]; Q[7]:=T[1];
  ELSIF Mode = 3 THEN
   Q[0]:=S[0]; Q[5]:=Q[0]#S[1]; Q[11]:=Q[0]#D[1]; Q[8]:=Q[0]#E[1];
  ELSIF Mode = 4 THEN
   Q[1]:=D[1]; Q[10]:=Q[1]#T[1]; Q[11]:=Q[0]#D[0];
  ELSIF Mode = 5 THEN
   Q[11]:=Q[0]#D[1]; Q[8]:=Q[0]#E[0]; Q[2]:=E[1];
  ELSIF Mode = 6 THEN
   Q[10]:=Q[0]#T[1];
  ELSIF Mode = 7 THEN
   Q[7]:=T[1]; Q[10]:=Q[0]#T[0];
  ELSIF Mode = 8 THEN
   Q[0]:=S[0]; Q[10]:=Q[0]#T[1]; Q[5]:=Q[0]#S[1];
   Q[11]:=Q[0]#D[1]; Q[8]:=Q[0]#E[1];
  ELSIF Mode = 9 THEN
   Q[1]:=D[1]; Q[10]:=Q[0]#T[1]; Q[11]:=Q[0]#D[0];
  ELSIF Mode = 10 THEN
   Q[10]:=Q[0]#T[1]; Q[8]:=Q[0]#E[0]; Q[2]:=E[1];
  ELSIF Mode = 11 THEN
   Q[10]:=1#T[1];
  ELSIF Mode = 12 THEN
   Q[5] :=1#S[0];
  ELSIF Mode = 13 THEN
   Q[11]:=1#D[1];
  ELSIF Mode = 14 THEN
   Q[8] :=1#E[1];
  ELSIF Mode = 15 THEN
   Q[10]:=1#T[0]; Q[7]:=T[1];
  ELSIF Mode = 16 THEN
   Q[10]:=Q[1]#T[0]; Q[7]:=T[1]; Q[5]:=1#S[0];
  ELSIF Mode = 17 THEN
   Q[10]:=Q[1]#T[0]; Q[7]:=T[1]; Q[11]:=1#D[1];
  ELSIF Mode = 18 THEN
   Q[10]:=Q[1]#T[0]; Q[7]:=T[1]; Q[8]:=1#E[1];
  ELSIF Mode = 19 THEN
   Q[10]:=Q[1]#S[0]; Q[5]:=Q[0]#T[1];
  ELSIF Mode = 20 THEN
   Q[9]:=S[0]; Q[5]:=Q[0]#S[2];
  END;

  R:=0;
  m:=1;
  i:=0;
  WHILE i < (digAmn*b_oAmn) DO
   INC(R, Q[i]*m); m:=m*2; INC(i);
  END;
  RETURN R;
 END {MARK_QQ};

 PUBLIC PROCEDURE intDecode(curDate : DATE;
                            curTime : TIME;
                            curValue: tValue;
                            clbDate : DATE;
                            clbTime : TIME;
                            clbSec  : NUMERIC[0];
                            clbValue: tValue;
                            clbMode : tMode;
                            clbCode : SCAL[1E7];
                       VAR trueTime : TIME;
                       VAR trueSec  : NUMERIC[0]);
  CONST
   Magic    = 2097152 *(*?*)100;
   Power    = 4096;
   SecInDay = 24*60*60;

  VAR
   Cycle    : NUMERIC[0];
   Takt     : FLOAT;
   clbTIME,
   clbQQ,
   curTIME,
   curQQ,
   nrsTIME,
   plnQQ    : NUMERIC[0];
   trueTIME : FLOAT;
   DaysAfter: NUMERIC[0];
 BEGIN
  Takt :=        Magic / clbCode;     (* ਮ ⨪ ⠩ (ᥪ) *)
  Cycle:=Power * Magic / clbCode;     (* ६  㧫 (ᥪ) *)

  clbTIME:=convInSec(clbDate, clbDate, clbTime, clbSec);
  clbQQ  :=MARK_QQ(clbMode, clbValue); (* 諮 QQ ⨪  ⬥⪨ clbValue *)
  clbTIME:= clbTIME - Takt*clbQQ;      (* ६ 㧫 ன *)

  curTIME:=convInSec(clbDate, curDate, curTime, 00);
  curQQ  :=MARK_QQ(clbMode, curValue);

  nrsTIME:=clbTIME + Cycle*(((curTIME - clbTIME)/Cycle) DIV 1); (* ६ 襣  curTIME 㧫 *)
  
  plnQQ  :=Math.Trunc(curTIME - nrsTIME)/Takt; (* ᫮ ⨪   *)

  IF Math.Abs(plnQQ-curQQ) <= Power/2 THEN
   trueTIME:=nrsTIME + Takt*curQQ;
  ELSIF curQQ < plnQQ THEN
   trueTIME:=nrsTIME + Takt*(curQQ+Power);
  ELSE
   trueTIME:=nrsTIME + Takt*(curQQ-Power);
  END;
  DaysAfter:=Math.Trunc(trueTIME / SecInDay);
  IF (clbDate + DaysAfter) # curDate THEN
   SETEMPTY(trueTime, trueSec);
  ELSE
   trueTime:=00:00 + Math.Trunc((trueTIME MOD SecInDay) / 60, 1) / 60;
   trueSec :=Math.Mod((trueTIME MOD SecInDay) / 60, 1) * 60;
  END;
 END {intDecode};

 PUBLIC PROCEDURE EqualDir(): SCAL[2];
 BEGIN
  RETURN SEJobs.Dir = RoutMod.Dir;
 END {EqualDir};

 PUBLIC PROCEDURE RWayCP_PlanT(): LIKE(RWayCP.PlanT);
  VAR
   curStartT: TIME;
 BEGIN
  CONFORM(SEJobs, StExit);
  IF StExit.Strict = L_Way.ExitStrict_Reg THEN
   curStartT:=SEJobs.StartT;
  ELSE
   L_General.Assert(~!RWayJ.StartT, "室 㪠 ६ 砫 ३");
   curStartT:=RWayJ.StartT;
  END;
  RETURN L_Way.GetStopCtrlTime_ofCurrentTrip(curStartT, RWayS.Date);
 END {RWayCP_PlanT};

 PUBLIC PROCEDURE IsActiveStopCP(): SCAL[2];
 BEGIN
  RETURN (Stop.CP # 0) & (Stop.CPType = L_Way.scpt_SCAD) & RtMStop.CPActive[SEJobs.Dir];
 END {IsActiveStopCP};

 PUBLIC PROCEDURE RWayCPForTrip(VAR HasCP: SCAL[2]);
  VAR
   D: DATE;
 BEGIN
  HasCP:=0;
  D:=RWayS.Date + RWayJ.Day - 1;
  CONFORM(SEJobs,  RoutMod);
  CONFORM(RoutMod, RtMStop);
  IF ~EqualDir() THEN
   LAST(RtMStop);
  END;

  WHILE OCCURE(RtMStop) DO
   CONFORM(RtMStop, Stop);
   IF IsActiveStopCP() THEN
    SELECT(StopCP, Stop, , Stop.Stop);
    L_General.Assert(SRCINSEL(StopCP, LE, D, RWayJ.StartT), "   ன  "+Stop.CP+"  "+L_DatTim.DateStr(D));
    SETEMPTY(RWayCP.StopNbr);
    RWayCP.RWayS  :=RWayJ.RWayS;
    RWayCP.Day    :=RWayJ.Day;
    RWayCP.StartT :=RWayJ.StartT;
    RWayCP.Stop   :=RtMStop.Stop;
    RWayCP.PlanT  :=RWayCP_PlanT();
    IF StopCP.Value = cpv_Disable THEN
     RWayCP.Value :=cpv_Disable;
     RWayCP.FactT :=RWayCP.PlanT;
     RWayCP.Shift :=0;
    ELSE
     L_Way.SetQualityStat(0); (*⢮  ।-  *);
     SETEMPTY(RWayCP.Value, RWayCP.FactT, RWayCP.Shift);
    END;
    INSERT(RWayCP);
    HasCP:=1;
   END; (* IF IsActiveStopCP... *)
   IF ~EqualDir() THEN
    PREV(RtMStop);
   ELSE
    NEXT(RtMStop);
   END;
  END; (* WHILE OCCURE(RtMStop) ... *)
 END {RWayCPForTrip};

 PUBLIC PROCEDURE RemSelRWayCP(VAR Asked: SCAL[2]);
 BEGIN
  IF E_RWayCPLevel(RWayS.Date) THEN
   CONFORM(RWayJ, RWayCP);
   IF OCCURE(RWayCP) THEN
    IF ~Asked & ~!RWayCP.Value THEN
     STDMSG(" "+RWayJ.Trip+"    ⬥⪨|   㤠?", CHOICE);
     Asked:=1;
    END;
    REMSEL(RWayCP);
   END;
  END;
 END {RemSelRWayCP};

 PUBLIC PROCEDURE DistributeCP();
  VAR
   _Fact : LIKE(RWayJ.Fact);
   Asked,
   HasCP : SCAL[2];
   _Route: LIKE(SEJobs.Route);
   _Modif: LIKE(SEJobs.Modif);
 BEGIN
  IF E_RWayCPLevel(RWayS.Date) THEN
   Asked:=0;
   RemSelRWayCP(Asked);
   SAVE(SEJobs);
   CONFORM(RWayJ, SEJobs);
   CHANGESEL(SEJobs, Exit, , SEJobs.Exit);
   _Route:=SEJobs.Route;
   _Modif:=SEJobs.Modif;
   _Fact:=0;
   WHILE OCCURE(SEJobs) & (_Fact < RWayJ.Fact) & (SEJobs.Route = _Route) & (SEJobs.Modif = _Modif) DO
    RWayCPForTrip(HasCP);
    INC(_Fact);
    NEXT(SEJobs);
   END; (* WHILE (_Fact < ... *)
   L_General.Assert(_Fact = RWayJ.Fact, " ᯨᠭ  ⠪ ⢠ ३ᮢ");
   RESTORE(SEJobs);
   L_Way.SetRWJQuality();
  END;
 END {DistributeCP};

 PUBLIC PROCEDURE IsRealValue(trgValue: LIKE(RWayCP.Value)): SCAL[2];
 BEGIN
  RETURN (trgValue # cpv_Unknown) &
         (trgValue # cpv_Disable) &
         (trgValue # cpv_Imported) &
         (trgValue # cpv_SetByOperator);
 END {IsRealValue};

 PUBLIC PROCEDURE ErrCPPoint(): STRING[250];
 BEGIN
  RETURN " "+RWayJ.Trip+" ⬥⪠ # "+RWayCP.StopNbr;
 END {ErrCPPoint};

 PUBLIC PROCEDURE CheckCurRWayCP();
 BEGIN
  L_General.Assert(~!RWayCP.Value, ErrCPPoint()+"|  ");
 END {CheckCurRWayCP};

 PUBLIC PROCEDURE GetAccuracy(): NUMERIC[1];
 BEGIN
  RETURN P_Route.GetAccuracy(SEJobs.Route, L_Way.E_IsPikTime(SEJobs.Exit, RWayS.Date, RWayCP.PlanT), RWayS.Date);
 END {GetAccuracy};

(*-------------BEGIN OF NORMAL ENVIRONMENT--------------------------*)

 PUBLIC PROCEDURE E_RWayCPLevel(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(L_Env.RWayCPLevel), 0);
 END {E_RWayCPLevel};

END.
