(*
%Copyright   (c) Polak IT
%Author      24.06.2005 19:03:00 POLAK\LDA
%Purpose      ⨯   
%Type        library
%Specific    AP
%Modified    01.03.2012 19:51:53 POLAK\MLB
%Environment
*)

 MODULE L_TRSP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Print, L_TRS, L_DatTim, L_Way, L_Str, P_Man, Str,
        L_Car, L_BegRWS, L_lsStore, E_TRS, L_Money, P_OwnData,
        L_AcCut, L_XObj, L_EC, L_APWI, L_StdFrm, P_Firm, L_ctc;

 PUBLIC VAR
  TRSPrt: PRINTJOB;

 PRIVATE CONST
  TckRcTRowsAmount = 10;

 PUBLIC PROCEDURE extTypeS(X, Y: NUMERIC[1]; S: STRING[]; P: TEXTSTYLE; CP: NUMERIC[0]);
 BEGIN
  L_Print.extTypeS(TRSPrt, X, Y, S, P, CP);
 END {extTypeS};

 PUBLIC PROCEDURE E_GetSubsidiaryMoney(D: DATE): NUMERIC[2];
  VAR
   Local  : PROC;
   tcAcCut: LIKE(AcCut.AcCut);
 BEGIN
  tcAcCut:=L_AcCut.erkn_GetSoft(D, L_AcCut.erkn_TokenCoins);
  IF ~!tcAcCut THEN
   L_XObj.AccessManXObject(Staff.Man, Staff.MyFirm);
   RETURN L_XObj.mo_GetOutSaldo(tcAcCut, L_DatTim.Per(D));
  ELSE
   Local:=PROCREF(E_TRS.trsp_GetSubsidiaryMoney);
   IF ~!Local THEN
    RETURN Local(D);
   ELSE
    RETURN 0;
   END;
  END;
 END {E_GetSubsidiaryMoney};

 PUBLIC PROCEDURE E_trsp_PrintSubsidiaryMoney(D: DATE): STRING[];
  VAR
   SubsidiaryMoney: NUMERIC[2];
 BEGIN
  SubsidiaryMoney:=E_GetSubsidiaryMoney(D);
  IF SubsidiaryMoney # 0 THEN
   RETURN Str.NumByWord(SubsidiaryMoney, MASCULINE);
  ELSE
   RETURN "";
  END;
 END {E_trsp_PrintSubsidiaryMoney};

 PUBLIC PROCEDURE E_PrintSubsidiaryMoneyInReceipt(D: DATE): STRING[];
  VAR
   SubsidiaryMoney: NUMERIC[2];
 BEGIN
  IF L_EC.ExecE_Func_Scal2(D, PROCREF(E_TRS.PrintSubsidiaryMoneyInReceipt), 1) THEN
   SubsidiaryMoney:=E_GetSubsidiaryMoney(D);
   IF SubsidiaryMoney > 0 THEN
    RETURN " 䮭 " + L_Money.MoneyToSpecStr(D, "", SubsidiaryMoney);
   END;
  END;
  RETURN "";
 END {E_PrintSubsidiaryMoneyInReceipt};

 PUBLIC PROCEDURE TypeS(X, Y: NUMERIC[1]; S: STRING[]; P: TEXTSTYLE);
 BEGIN
  extTypeS(X, Y, S, P, L_Print.cp_OEM_Russian);
 END {TypeS};

 PUBLIC PROCEDURE PrintStamp(X, Y: FLOAT);
  CONST
   StampFileName = "ofStamp_TRS.gif";
 BEGIN
  L_Print.PrintStamp(TRSPrt, X, Y, 30.5, 16.5, StampFileName);
 END {PrintStamp};

 PUBLIC PROCEDURE GetFirmName(): STRING[];
 BEGIN
  RETURN P_Firm.FP_FirmName(Firm.Firm, TckRcS.Date);
 END {GetFirmName};

 PUBLIC PROCEDURE GetFirmAddr(): STRING[];
 BEGIN
  RETURN L_ctc.GetAdr_Reg(TckRcS.Date, Firm.Firm);
 END {GetFirmAddr};

 PUBLIC PROCEDURE PrintFirmAttr(X, Y, step: NUMERIC[1]; DispPhone, FirmPhone: STRING[]; P: TEXTSTYLE);
  VAR
   StrArr: STRING[][2];
 BEGIN
  Str.Format(StrArr, GetFirmName(), 25, LEFT);
  TypeS(X, Y,        StrArr[0], P);
  TypeS(X, Y+1*step, StrArr[1], P);

  Str.Format(StrArr, GetFirmAddr(), 25, LEFT);
  TypeS(X, Y+2*step, StrArr[0], P);
  TypeS(X, Y+3*step, StrArr[1], P);

  TypeS(X, Y+4*step, DispPhone, P);
  TypeS(X, Y+5*step, FirmPhone, P);
 END {PrintFirmAttr};

 PUBLIC PROCEDURE PrintTckRcTBefNbr(): STRING[];
 BEGIN
  CONFORM(TckRcT, TckKind);
  IF L_TRS.IsBulk_wCUC() THEN
   SELECT(TckRcDL, CUCopy, , TckRcT.asCUCopy, L_TRS.trdStat_Passed);
   LAST(TckRcDL);
   WHILE OCCURE(TckRcDL) DO
    CONFORM(TckRcDL, TckRcD);
    IF (TckRcD.Type = L_TRS.trdt_Laying) | (TckRcD.TckRcS # TckRcS.TckRcS) THEN
     RETURN L_Str.IntStr(L_TRS.BulkCUCAmount());
    END;
    PREV(TckRcDL);
   END; (* WHILE OCCURE(TckRcDL) ... *)
  END;
  RETURN FLDTOSTR(TckRcT.BefNbr, "L", TckKind.NbrPrc);
 END {PrintTckRcTBefNbr};

 PRIVATE PROCEDURE StandOnWLMByTRS(_Who: L_Way.tWLMWho; First: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SELECT(WayLMen, RWayS, , RWayS.RWayS, _Who);
  IF ~First THEN
   LAST(WayLMen);
  END;
  WHILE OCCURE(WayLMen) & ~Result DO
   IF WayLMen.TSN = TckRcS.TSN THEN
    Result:=1;
   ELSE
    IF First THEN
     NEXT(WayLMen);
    ELSE
     PREV(WayLMen);
    END;
   END;
  END; (* WHILE OCCURE(WayLMen) ... *)
  RETURN Result;
 END {StandOnWLMByTRS};

 PUBLIC PROCEDURE GetRWaySExitTime(_Who: LIKE(TckRcS.AsWho)): TIME;
  VAR
   Result,
   t     : TIME;
 BEGIN
  SAVE(StExit);
  CONFORM(RWayS, StExit);
  CONFORM(RWayS, RWayTxt);
  IF    L_BegRWS.RWayTxtIsValid() & ~!RWayTxt.FExTime THEN
   Result:=RWayTxt.FExTime;
  ELSIF _Who = L_Way.trs_Guard THEN
   SAVE(WayLMen);
   IF StandOnWLMByTRS(L_Way.wlmwho_Guard, 1) THEN
    Result:=WayLMen.StartT;
   ELSE
    L_Way.GetExitTimes(L_Way.rwswho_Guard, Result, t);
   END;
   RESTORE(WayLMen);
  ELSE
   Result:=StExit.BegTime;
  END;
  RESTORE(StExit);
  RETURN Result;
 END {GetRWaySExitTime};

 PUBLIC PROCEDURE GetRWaySEnterTime(_Who: LIKE(TckRcS.AsWho)): TIME;
  VAR
   _EnterTime,
   t         : TIME;
 BEGIN
  SAVE(RWayJ);
  SAVE(StExit);
  SAVE(SEJobs);
  IF ((RWayS.Status = L_Way.rwsStat_Given) | (RWayS.Status = L_Way.rwsStat_Taken)) &
     SELECT(RWayJ, RWayS, RWayS.RWayS) &
     LAST(RWayJ) THEN
   CONFORM(RWayJ, SEJobs);
   CONFORM(SEJobs, StExit);
  ELSE
   CONFORM(RWayS, StExit);
  END;
  CONFORM(RWayS, RWayTxt);
  IF    L_BegRWS.RWayTxtIsValid() & ~!RWayTxt.LEnTime THEN
   _EnterTime:=RWayTxt.LEnTime;
  ELSIF _Who = L_Way.trs_Guard THEN
   SAVE(WayLMen);
   IF StandOnWLMByTRS(L_Way.wlmwho_Guard, 0) THEN
    _EnterTime:=WayLMen.StopT;
   ELSE
    L_Way.GetExitTimes(L_Way.rwswho_Guard, t, _EnterTime);
   END;
   RESTORE(WayLMen);
  ELSE
   _EnterTime:=StExit.StopTim;
  END;
  RESTORE(SEJobs);
  RESTORE(StExit);
  RESTORE(RWayJ);
  RETURN _EnterTime;
 END {GetRWaySEnterTime};

 PUBLIC PROCEDURE StartSecondPage();
 BEGIN
  TRSPrt.EndPage();
  TRSPrt.StartPage();
  L_Print.PrintBlankBackground(TRSPrt, "TckRcS_b.BMP");
 END {StartSecondPage};

 PUBLIC PROCEDURE TypeBarCode(X, Y: NUMERIC[0]);
  VAR
   tsBarCode  : TEXTSTYLE;
 BEGIN
  tsBarCode:=L_Print.ts_Create(18, "IntP36DlTt");
  tsBarCode.Font.Charset:=FONT.Charset_ANSI;
  extTypeS(X, Y, L_TRS.GetBarCode_bck_IdIn20(), tsBarCode, L_Print.cp_ISO_8859_1_Latin_I);
 END {TypeBarCode};

 PUBLIC PROCEDURE SetParamsForRWSList(VAR carY,
                                          extY,
                                          step     : NUMERIC[1];
                                      VAR bigTS    : TEXTSTYLE;
                                      VAR DfrntCars: SCAL[2]);
  VAR
   i      : NUMERIC[0];
   _BoxNbr: LIKE(Car.BoxNbr);
 BEGIN
  bigTS:=L_Print.ts_Create(11, "Tahoma");
  step:=3;
  i:=0;
  SETEMPTY(_BoxNbr);
  DfrntCars:=0;
  WHILE i < 3 DO
   IF !TckRcS.asRWayS[i] | ~SEARCH(RWayS, RWayS, TckRcS.asRWayS[i]) THEN
    IF step = 3 THEN
     step:=4;
     bigTS.Font.Size:=14;
    END;
    INC(carY, 2);
    INC(extY, 2);
   ELSE
    IF !_BoxNbr THEN
     _BoxNbr:=RWayS.BoxNbr;
    ELSIF _BoxNbr # RWayS.BoxNbr THEN
     DfrntCars:=1;
    END;
   END;
   INC(i);
  END;
 END {SetParamsForRWSList};

 PUBLIC PROCEDURE PrintPhoto(X, Y, Width, Height: FLOAT);
 BEGIN
  P_Man.PrintPhoto(TRSPrt, X, Y, Width, Height, TckRcS.Date);
 END {PrintPhoto};

 PUBLIC PROCEDURE PrintStdProportionPhoto(X, Y, Height: FLOAT);
 BEGIN
  PrintPhoto(X, Y, Height * 35 / 45, Height);
 END {PrintStdProportionPhoto};

 PUBLIC PROCEDURE PrintRWSLine(X, Y: NUMERIC[1]; bigTS, ts09, ts11: TEXTSTYLE);
 BEGIN
  CONFORM(RWayS, Staff);
  CONFORM(Staff, Man);
  L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
  CONFORM(CarLog, Mark);
  TypeS(X,      Y, RWayS.BoxNbr,                bigTS);
  TypeS(X+19,   Y, CarLog.StateNbr,             bigTS);
  TypeS(X+46,   Y, Mark.Mark + " " + Mark.Name, ts09);
  IF TckRcS.TSN # RWayS.TSN THEN
   TypeS(X+96,  Y, RWayS.TSN,                   ts11);
   TypeS(X+115, Y, Man.Name,                    ts09);
  END;
 END {PrintRWSLine};

 PRIVATE PROCEDURE Plan_asStr(IP: L_APWI.tPlanIncome; VPP: L_APWI.tVldPsgAmnt): STRING[];
  VAR
   _Str: STRING[];
 BEGIN
  _Str:=L_Money.MoneyToStr(RWayS.Date, "", IP);
  IF VPP # 0 THEN
   _Str:=_Str+" /"+L_Str.NumericStr(VPP, 0);
  END;
  RETURN _Str;
 END {Plan_asStr};

 PUBLIC PROCEDURE extPrintExitLine(X, Y: NUMERIC[1]; bigTS, ts09, ts11: TEXTSTYLE; wBoxNbr, wVldPlan: SCAL[2]);
  VAR
   _Str      : STRING[];
   VldPsgPlan: L_APWI.tVldPsgAmnt;
 BEGIN
  L_APWI.StandOnRWaySExit();
  TypeS(X,     Y, StExit.Exit, bigTS);
  IF wBoxNbr THEN
   TypeS(X+30, Y, RWayS.BoxNbr, ts09);
  END;
  TypeS(X+40,  Y, StExit.Name, ts09);
  TypeS(X+110, Y, L_DatTim.TimeStr(GetRWaySExitTime(TckRcS.AsWho)), bigTS);
  TypeS(X+133, Y, L_DatTim.TimeStr(GetRWaySEnterTime(TckRcS.AsWho)), bigTS);
  IF wVldPlan THEN
   VldPsgPlan:=L_APWI.GetVldPsgPlanForTRS();
  ELSE
   VldPsgPlan:=0;
  END;
  _Str:=Plan_asStr(L_Way.GetIncomePlanForTRS(), VldPsgPlan);
  IF VldPsgPlan # 0 THEN
   TypeS(167, Y, _Str, ts11);
  ELSE
   TypeS(175, Y, _Str, bigTS);
  END;
 END {extPrintExitLine};

 PUBLIC PROCEDURE PrintExitLine(X, Y: NUMERIC[1]; bigTS, ts09, ts11: TEXTSTYLE; wBoxNbr: SCAL[2]);
 BEGIN
  extPrintExitLine(X, Y, bigTS, ts09, ts11, wBoxNbr, L_Way.E_VldPsgPlanLev(RWayS.Date));
 END {PrintExitLine};

 PUBLIC PROCEDURE PrintRWSData(carX, carY, extX, extY, bntX, bntY: NUMERIC[1]);
  VAR
   i        : NUMERIC[0];
   DfrntCars: SCAL[2];
   step     : FLOAT;
   ts09,
   ts11,
   bigTS    : TEXTSTYLE;
 BEGIN
  SetParamsForRWSList(carY, extY, step, bigTS, DfrntCars);
  ts09:=L_Print.ts_Create(09, "Tahoma");
  ts11:=L_Print.ts_Create(11, "Tahoma");
  SAVE(Staff);
  SAVE(Man);
  IF DfrntCars THEN
   TypeS(bntX, bntY, ". ", L_Print.ts_Create(06, "Times New Roman"));
  END;
  i:=0;
  WHILE i <= HIGH(TckRcS.asRWayS) DO
   IF ~!TckRcS.asRWayS[i] & SEARCH(RWayS, RWayS, TckRcS.asRWayS[i]) THEN
    PrintRWSLine(carX, carY, bigTS, ts09, ts11);
    PrintExitLine(extX, extY, bigTS, ts09, ts11, DfrntCars);
    INC(carY, step);
    INC(extY, step);
   END;
   INC(i);
  END;
  RESTORE(Staff);
  RESTORE(Man);
 END {PrintRWSData};

 PUBLIC PROCEDURE ext_print_TckRcS(wJobs, wPlan, wAntiterror: SCAL[2]);
  CONST
   FirstTripOnFirstPageYPos  = 196;
   FirstTripOnSecondPageYPos = 35;
   MaxTrips                  = 43;
   TripsOnFirstPage          = 13;
  VAR
   i,
   j,
   page      : NUMERIC[0];
   x,
   y         : FLOAT;
   ts14,
   ts12,
   ts11,
   ts09,
   ts08,
   ts07,
   ts06      : TEXTSTYLE;
   Message   : STRING[][10];
   _BoxNbr   : LIKE(Car.BoxNbr);
   _Route    : LIKE(Route.Route);
 BEGIN
  L_Print.SetDuplexMode(TRSPrt, L_Print.dm_Vertical);
  ts14:=L_Print.ts_Create(14, "Tahoma");
  ts12:=L_Print.ts_Resize(ts14, 12);
  ts11:=L_Print.ts_Resize(ts14, 11);
  ts09:=L_Print.ts_Resize(ts14, 09);
  ts08:=L_Print.ts_Resize(ts09, 08);
  ts07:=L_Print.ts_Resize(ts09, 07);
  ts06:=L_Print.ts_Resize(ts09, 06);
  TRSPrt.StartPage();
  page:=1;
  L_Print.PrintBlankBackground(TRSPrt, "TckRcS_F.BMP");
  CONFORM(TckRcS, Staff);
  CONFORM(Staff, Man);
  P_Firm.AccessFirm(P_Firm.GetFirmOfMyFirm(Staff.MyFirm));
  PrintStdProportionPhoto(173, 19, 30.0);
  PrintStamp(10.5, 16);
  TypeS(049, 031, TckRcS.TckRcS, ts14);
  TypeS(068, 031, "(" + TckRcS.CopyCnt + ")", ts08);
  TypeS(080, 031, L_DatTim.DateStr(TckRcS.Date), ts14);
  TypeBarCode(118, 027);

  TypeS(013, 049, L_Str.PoolItem(L_Way.trs_Pool, TckRcS.AsWho), ts09);
  TypeS(037, 049, TckRcS.TSN, ts14);
  TypeS(055, 049, Man.Name, ts12);
  IF P_Man.HasActualManPro(Man.Man, TckRcS.Date, P_Man.P_EmploymentCertificate) THEN
   TypeS(132, 049, ManPro.DocNum, ts09);
  END;

  CONFORM(TckRcS, Storage);
  TypeS(152, 049, TckRcS.Storage, ts12);

  PrintRWSData(16, 63, 15, 81, 45, 77.5);

  i:=0;
  CONFORM(TckRcS, TckRcT);
  WHILE OCCURE(TckRcT) DO
   IF (i MOD TckRcTRowsAmount) = 0 THEN
    x:=12 + 97 * (i DIV TckRcTRowsAmount);
    i:=0;
   END;
   y:=100 + 3.3*i;
   CONFORM(TckRcT, TckKind);
   TypeS(x + 000, y, TckRcT.TckRcT,              ts08);
   TypeS(x + 4.5, y, TckKind.Name,               ts08);
   TypeS(x + 056, y, "(" + TckRcT.TckKind + ")", ts07);
   IF Str.Length(TckRcT.Series) > 10 THEN
    TypeS(x + 065, y, TckRcT.Series,              ts07);
   ELSE
    TypeS(x + 065, y, TckRcT.Series,              ts08);
   END;
   IF Str.Length(PrintTckRcTBefNbr()) > 7 THEN
    TypeS(x + 081.5, y, PrintTckRcTBefNbr(),        ts07);
   ELSE
    TypeS(x + 081.5, y, PrintTckRcTBefNbr(),        ts08);
   END;
   INC(i);
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)

  IF wAntiterror THEN
   y:=128.5;
   TypeS(138, 142, L_Str.ShortName(Man.Name), ts08);
  ELSE
   y:=133;
  END;
  TypeS(042,     y, E_trsp_PrintSubsidiaryMoney(TckRcS.Date),                   ts08);
  TypeS(020, y+6.5, L_DatTim.DateTimeStr(SYSDATE(), SYSTIME()),                 ts08);
  TypeS(091, y+6.5, L_Str.ShortName(P_Man.GetFullNameOfCurrentUser(SYSDATE())), ts09);

  Str.Format(Message, L_lsStore.Get(TckRcS.Message), 100, LEFT);
  i:=0;
  WHILE (i <= HIGH(Message)) & ~!Message[i] DO
   TypeS(013, 153 + i * 4, Message[i], ts09);
   INC(i);
  END; (* WHILE (i <= HIGH(Message)) &... *)
  TypeS(013, 153 + i * 4, P_OwnData.MessageToGuard(TckRcS.Date), ts09);

  wPlan:=wPlan & (TckRcS.AsWho # L_Way.trs_Chopper);
  IF wPlan THEN
   TypeS(086, 187, "", ts07);
   TypeS(086, 190, "",  ts07);
  END;
  IF wJobs THEN
   i:=0;
   y:=FirstTripOnFirstPageYPos;
   j:=0;
   SETEMPTY(_BoxNbr, _Route);
   WHILE j <= HIGH(TckRcS.asRWayS) DO
    IF ~!TckRcS.asRWayS[j] & SEARCH(RWayS, RWayS, TckRcS.asRWayS[j]) THEN
     L_APWI.StandOnRWaySExit();
     IF OCCURE(SEJobs) THEN
      CHANGESEL(SEJobs, Exit, , StExit.Exit);
     ELSE
      SELECT(SEJobs, Exit, , StExit.Exit);
     END;
     LOOP
      IF ~OCCURE(SEJobs) THEN
       EXIT;
      END;
      PROMPT(RWayS.RWayS + " " + SEJobs.Trip);
      CONFORM(SEJobs, WJMode);
      CONFORM(SEJobs, Route);
      IF WJMode.IncSel & Route.IncSel THEN
       IF (TckRcS.AsWho # L_Way.trs_Guard) | L_Way.SEJobsWithGu() THEN
        IF i >= MaxTrips THEN
         L_StdFrm.ShowINFORM_AsSTOP("⢮ ३ᮢ ॢ蠥 - ப  .|"+
                                    " ३   ⠭");
         EXIT;
        ELSIF i >= TripsOnFirstPage THEN
         IF page = 1 THEN
          page:=2;
          StartSecondPage();
          y:=FirstTripOnSecondPageYPos;
          SETEMPTY(_BoxNbr, _Route);
          IF wPlan THEN
           TypeS(086, y-9, "", ts07);
           TypeS(086, y-6, "",  ts07);
          END;
         END;
        END;
        IF RWayS.BoxNbr # _BoxNbr THEN
         TypeS(013, y, RWayS.BoxNbr, ts09);
         _BoxNbr:=RWayS.BoxNbr;
        END;
        IF Route.Route # _Route THEN
         TypeS(030, y, Route.Route, ts09);
         _Route:=Route.Route;
        END;

        CONFORM(SEJobs,  RoutMod);
        CONFORM(RoutMod, RtMStop);
        IF RoutMod.Dir # SEJobs.Dir THEN
         LAST(RtMStop);
        END;
        CONFORM(RtMStop, Stop);
        TypeS(040, y, L_Way.GetStopName(Stop.Stop), ts07);
        TypeS(074, y, L_DatTim.TimeStr(SEJobs.StartT), ts08);
        IF wPlan THEN
         TypeS(086, y, Plan_asStr(L_APWI.E_GetPlanIncomeScope(L_APWI.piScope_RWOrdered,
                                                              RWayS.Date,
                                                              L_Way.E_GetIPCForTckRcSIncomePlan(RWayS.Date)),
                                  L_APWI.E_GetPlanIncomeScope(L_APWI.piScope_RWOrdered,
                                                              RWayS.Date,
                                                              L_APWI.ConvWithGu_to_IPCForVldPsg(L_Way.E_GetIPCForTckRcSIncomePlan(RWayS.Date)))),
               ts06);
        END;
        INC(i);
        INC(y, 7);
       END;
      END;
      NEXT(SEJobs);
     END; (* LOOP *)
    END; (*IF ~!TckRcS.asRWayS[j] & ...*)
    INC(j);
   END;
  END; (*IF wJobs*)
  IF page = 1 THEN
   StartSecondPage();
  END;
  CONFORM(TckRcS, Staff);
  CONFORM(Staff, Man);
  TypeS(075, 248.5, L_Str.ShortName(Man.Name), ts12);
  TRSPrt.EndPage();
 END {ext_print_TckRcS};

 PUBLIC PROCEDURE print_TckRcS();
 BEGIN
  ext_print_TckRcS(0, 0, 0);
 END {print_TckRcS};

 PUBLIC PROCEDURE CreatePrintJob(PrinterType: NUMERIC[0];
                                 Orientation: SCAL[2]);
 BEGIN
  IF !PrinterType THEN
   Orientation:=L_Print.o_Portrait;
   PrinterType:=L_Print.pt_BlankAndDoc;
  END;
  TRSPrt:=L_Print.CreatePrintJob(PrinterType, "  "+TckRcS.TckRcS, L_Print.pf_A4, Orientation);
 END {CreatePrintJob};

END.
