(*
%Copyright   (c) Polak IT
%Author      06.02.2006 20:55:38 POLAK\GAV
%Purpose
%Type        library
%Specific    AP
%Modified    14.07.2014 14:55:21 POLAK\San
%Environment
*)

 MODULE L_two [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tTWOWho         = SCAL[10];
  tDailyAttribute = SCAL[13];
  tObjectFreeCond = SCAL[4];
  tRenovateMode   = SCAL[16];

 PUBLIC CONST
  who_Driver = 0;
  who_Guard  = 1;

  who_ShortPool = "|";
  who_Pool      = "⥫|";

  da_What      = 0;
  da_ExitClss  = 1;
  da_Driver    = 2;
  da_Car       = 3;
  da_Guard     = 4;
  da_CooTSN    = 5;
  da_SrcWh     = 6;
  da_SrcEC     = 7;
  da_SrcDr     = 8;
  da_SrcCr     = 9;
  da_SrcGr     = 10;
  da_Message   = 11;
  da_MsgTarget = 12;

  da_Pool = "| 室|⥫|||.ᮭ";

  ofc_ExitClss = 0;
  ofc_Driver   = 1;
  ofc_Car      = 2;
  ofc_Guard    = 3;

  rm_Initial        = 0;
  rm_Single         = 1;
  rm_NotActual      = 2;
  rm_AutoM          = 3;
  rm_AutoD          = 4;
  rm_Exits          = 5;
  rm_SingleMtwoDay  = 6;
  rm_AllFiltered    = 7;

  NeverFixing = "९  뢠";

  cmpl_NotComplete = 0; (*Dtwo.Complete*)
  cmpl_NoGuard     = 1;
  cmpl_Norma       = 2;

  grd_Need    = 0; (*Dtwo.GuardOk*)
  grd_Norma   = 1;
  grd_NotNeed = 2;

  acspnt_ChangePrinted = 0000049;
  acspnt_ChangeSigned  = 0000050;

 PUBLIC PERMANENT VAR
  MtwoCurWho       : tTWOWho;
  DtwoCurSort,
  MtwoCurSort      : LIKE(Sort.Sort);
  DtwoCurDprt,
  MtwoCurDprt    : LIKE(Sort.Sort);
  DtwoCurComplete  : SCAL[4];

  DtwoCurFilterDsc,
  MtwoCurFilterDsc : STRING[];

 PRIVATE PERMANENT VAR
  rnvMode       : tRenovateMode;
  rnvErrorCnt   : NUMERIC[0];

 IMPORT L_Way, L_BegRWS, L_DatTim, L_Env, L_General, L_Staff, Math,
        L_Sheet, Str, L_Str, L_StdFrm, L_Car, Memo, L_AvePay, P_Staff,
        E_Way, L_OwnData, P_Firm, L_lsStore, L_XDoc, E_two, L_EC,
        L_Prop, L_SysLog, L_APtm, P_Sort, P_Column;

 PRIVATE CONST
  daAmount = MAXOF(tDailyAttribute)+1;

 PRIVATE TYPE
  tDtwoAsString   = STRING[][daAmount];
  tReplaceOption  = STRING[];
  tROArray        = tReplaceOption[daAmount];
  tCheckOfficer   = SCAL[3];

 PRIVATE CONST
  ro_NoAction = "  ( 롮)";
  ro_NoChange = " ";
  ro_Replace  = "";
  ro_Free     = "᢮";
  ro_Swap     = "";
  ro_Append   = "  ";
  ro_Relax    = "⠭  ";
  ro_Rest     = "⠭ 室 ";
  ro_Trow     = "모  鸞";

  co_BySort   = 0;
  co_ByDprt   = 1;
  co_None     = 2;

  RWaySAlreadyDone = " ନ஢ ⥢ . 䨪 鸞 饭";

 PRIVATE VAR
  curRnvTSN: LIKE(Staff.TSN);

 PRIVATE PROCEDURE InStateRegime(D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(RegList);
  SAVE(JMode);
  L_General.Assert(SELECT(RegList, HumReg, StaffLog.Regime, L_DatTim.Per(D)), "  ० ࠡ "+StaffLog.Regime+"  "+L_DatTim.PeriodStr(D));
  CONFORM(RegList, JMode);
  Result:=JMode.InFirm;
  RESTORE(RegList);
  RESTORE(JMode);
  RETURN Result;
 END {InStateRegime};

 PUBLIC PROCEDURE E_Mtwo_Who(D: DATE): tTWOWho;
  VAR
   default: tTWOWho;
   Local  : PROC;
 BEGIN
  IF    L_Env.IsDriver() THEN
   default:=who_Driver;
  ELSIF L_Env.IsGuard() THEN
   default:=who_Guard;
  ELSE
   SETEMPTY(default);
  END;
  Local:=PROCREF(E_two.Mtwo_Who);
  IF ~!Local THEN
   default:=Local(default, D);
  END;
  IF ~!default & ~InStateRegime(D) THEN
   SETEMPTY(default);
  END;
  RETURN default;
 END {E_Mtwo_Who};

 PUBLIC PROCEDURE FirstModifiableDay(): DATE;
 BEGIN
  RETURN SYSDATE() + 0(*1*);
 END {FirstModifiableDay};

 PUBLIC PROCEDURE AccessMtwo();
 BEGIN
  L_General.Assert(ACCESS(Mtwo), " ⠭ ⥪  鸞");
 END {AccessMtwo};

 PUBLIC PROCEDURE WhatStr(_What: L_BegRWS.tDayType): STRING[];
 BEGIN
  IF ~!_What THEN
   RETURN L_Str.PoolItem(L_BegRWS.wh_Pool, _What);
  ELSE
   RETURN " ";
  END;
 END {WhatStr};

 PUBLIC PROCEDURE IsStaffDA(da: tDailyAttribute): SCAL[2];
 BEGIN
  RETURN (da = da_Driver) | (da = da_Guard) | (da = da_CooTSN);
 END {IsStaffDA};

 PRIVATE PROCEDURE GetFirstDateIdx(P: DATE): NUMERIC[0];
 BEGIN
  RETURN L_DatTim.WEEKDAY(P) + L_DatTim.wd_DaysAmount * (L_DatTim.WEEKDAY(P) = L_DatTim.wd_Mon);
 END {GetFirstDateIdx};

 PUBLIC PROCEDURE Idx2Date(Idx: NUMERIC[0]; P: DATE): DATE;
  VAR
   D, M, Y: NUMERIC[0];
   i: NUMERIC[0];
 BEGIN
  UnPkDATE(P, D, M, Y);
  D:=Idx - GetFirstDateIdx(P) + 1;
  RETURN PackDATE(D, M, Y);
 END {Idx2Date};

 PUBLIC PROCEDURE Date2Idx(Date: DATE): NUMERIC[0];
 BEGIN
  RETURN GetFirstDateIdx(L_DatTim.MonthBeg(Date)) + L_DatTim.DAY(Date) - 1;
 END {Date2Idx};

 PUBLIC PROCEDURE MSrcIdx(Idx: NUMERIC[0]; da: tDailyAttribute): NUMERIC[0];
 BEGIN
  IF    da = da_What     THEN RETURN Idx+0*42;
  ELSIF da = da_ExitClss THEN RETURN Idx+1*42;
  ELSIF da = da_Car      THEN RETURN Idx+2*42;
  ELSIF (da = da_Guard) |
        (da = da_Driver)|
        (da = da_CooTSN) THEN RETURN Idx+3*42;
  ELSE
   L_General.CallUs(0);
  END;
 END {MSrcIdx};

 PUBLIC PROCEDURE MHasSealedPlan(): SCAL[2];
 BEGIN
  RETURN ~!Mtwo.Sealed;
 END {MHasSealedPlan};

 PUBLIC PROCEDURE MCheckNotSealed();
 BEGIN
  IF MHasSealedPlan() THEN
   L_General.Error(" ࠡ⭨ " + Mtwo.TSN +
                   " 믮 襭 ⮢ 筮 鸞  " + L_DatTim.PeriodStr(Mtwo.Per));

  END;
 END {MCheckNotSealed};

 PUBLIC PROCEDURE m_c_FitToFilter(): SCAL[2];
 BEGIN
  RETURN (!MtwoCurWho  | (Mtwo.Who  = MtwoCurWho )) &
         (!MtwoCurSort | (Mtwo.Sort = MtwoCurSort)) &
         (!MtwoCurDprt | (Mtwo.Dprt = MtwoCurDprt)) &
         P_Firm.IsAllowedMyPF(Mtwo.MyFirm, Mtwo.MyPlace);
 END {m_c_FitToFilter};

 PUBLIC PROCEDURE d_c_FitToFilter(): SCAL[2];
 BEGIN
  RETURN (!DtwoCurSort   | (Dtwo.Sort = DtwoCurSort)) &
         (!DtwoCurDprt   | (Dtwo.Dprt = DtwoCurDprt)) &
         (!DtwoCurComplete | ((DtwoCurComplete = 0)&(Dtwo.Complete=0)|
                              (DtwoCurComplete = 1)&(Dtwo.Complete#2)|
                              (DtwoCurComplete = 2)&(Dtwo.GuardOk #1)|
                              (DtwoCurComplete = 3)&(Dtwo.Complete=2))) &
         P_Firm.IsAllowedMyPF(Dtwo.MyFirm, Dtwo.MyPlace);
 END {d_c_FitToFilter};

 PUBLIC PROCEDURE M_ConfirmOnMtwo(Msg: STRING[]; Importance: SCAL[3]);
 BEGIN
  Msg:=Msg + "||";
  IF !MtwoCurFilterDsc THEN
   Msg:=Msg + " ࠡ⭨!";
  ELSE
   Msg:=Msg + MtwoCurFilterDsc;
  END;
  IF    Importance = 0 THEN
   L_StdFrm.Question(Msg);
  ELSIF Importance = 1 THEN
   L_StdFrm.Choice(Msg);
  ELSE
   L_StdFrm.CrucialChoice_FileExplicit("", Msg, L_APtm.g_twoOp);
  END;
 END {M_ConfirmOnMtwo};

 PUBLIC PROCEDURE D_ConfirmOnDtwo(Msg: STRING[]; Importance: SCAL[3]);
 BEGIN
  Msg:=Msg + "||";
  IF !DtwoCurFilterDsc THEN
   Msg:=Msg + " ப 鸞!";
  ELSE
   Msg:=Msg + DtwoCurFilterDsc;
  END;
  IF    Importance = 0 THEN
   L_StdFrm.Question(Msg);
  ELSIF Importance = 1 THEN
   L_StdFrm.Choice(Msg);
  ELSE
   L_StdFrm.CrucialChoice_FileExplicit("", Msg, L_APtm.g_twoOp);
  END;
 END {D_ConfirmOnDtwo};

 PRIVATE PROCEDURE DSrcIdx(da: tDailyAttribute): NUMERIC[0];
 BEGIN
  RETURN da;
 END {DSrcIdx};

 PUBLIC PROCEDURE DtwoStr(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="   " + L_DatTim.DateStr(Dtwo.Date);
  IF    ~!Dtwo.ExitClss THEN
   Result:=Result + ",  室 " + Dtwo.ExitClss;
  ELSIF ~!Dtwo.TSN THEN
   Result:=Result + ", ⥫ " + Dtwo.TSN;
  ELSIF ~!Dtwo.BoxNbr THEN
   Result:=Result + ",  " + Dtwo.BoxNbr;
  ELSIF ~!Dtwo.GuardTSN THEN
   Result:=Result + ",  " + Dtwo.GuardTSN;
  END;
  IF ~!Dtwo.Change THEN
   Result:=Result + "(" + L_Str.PoolItem(L_BegRWS.wh_Pool, Dtwo.Change) + ")";
  END;
  RETURN Result;
 END {DtwoStr};

 PUBLIC PROCEDURE E_IsCorrectExitOfExitClss(D: DATE): SCAL[2];
 BEGIN
  IF StExit.Strict # L_Way.ExitStrict_Reg THEN
   RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_two.IsCorrectExitOfExitClss), 1);
  END;
  RETURN 1;
 END {E_IsCorrectExitOfExitClss};

 PUBLIC PROCEDURE StandOnExit(_ExitClss: LIKE(ExitClss.ExitClss); _Change: LIKE(StExit.Change); D: DATE; wAssert: SCAL[2]): SCAL[2];
 BEGIN
  SELECT(StExit, ECUpDate, , _ExitClss);
  SRCINSEL(StExit, GE, , D);
  WHILE OCCURE(StExit) DO
   IF (L_Way._CheckExitOnDate(StExit.Exit, D) = L_Way.exvld_Active) &
      (!_Change | (_Change = StExit.Change)) THEN
    IF E_IsCorrectExitOfExitClss(D) THEN
     RETURN 1;
    END;
   END;
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit)...*)
  L_General.Assert(~wAssert, "    饣 室  " + L_DatTim.DateStr(D) + ", ᬥ " + FLDTOSTR(_Change));
  RETURN 0;
 END {StandOnExit};

 PUBLIC PROCEDURE PositionOnExit(_ExitClss: LIKE(ExitClss.ExitClss); _Change: LIKE(StExit.Change); D: DATE);
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=StandOnExit(_ExitClss, _Change, D, 1);
 END {PositionOnExit};

 PUBLIC PROCEDURE IsWholeDayExitClss(_ExitClss: LIKE(ExitClss.ExitClss); D: DATE): SCAL[2];
 BEGIN
  RETURN StandOnExit(_ExitClss, L_BegRWS.dt_WholeDay, D, 0);
 END {IsWholeDayExitClss};

 PUBLIC PROCEDURE IsStrictExitClss(_ExitClss: LIKE(ExitClss.ExitClss); _Change: LIKE(StExit.Change); OnDate: DATE): SCAL[2];
 BEGIN
  L_General.Assert(SEARCH(ExitClss, ExitClss, _ExitClss), "  室 " + _ExitClss);
  RETURN (ExitClss.Strict = L_Way.ExitStrict_Reg) & StandOnExit(_ExitClss, _Change, OnDate, 0);
 END {IsStrictExitClss};

 PRIVATE PROCEDURE GetPreferableExitClass(D       : DATE;
                                          _TSN    : LIKE(Staff.TSN);
                                          _Who    : tTWOWho;
                                          _DayType: L_BegRWS.tDayType): LIKE(ExitClss.ExitClss);
  VAR
   Result: LIKE(ExitClss.ExitClss);
   Dummy : L_BegRWS.tECFixMethod;
 BEGIN
  SETEMPTY(Result);
  IF L_BegRWS.IsWorkDayType(_DayType) THEN
   L_BegRWS.intGetFixedEC(_TSN, D, Result, Dummy);
  END;
  RETURN Result;
 END {GetPreferableExitClass};

 PRIVATE PROCEDURE Who2RWSWho(_Who: tTWOWho): L_Way.tRWSWho;
 BEGIN
  IF   _Who = who_Driver THEN RETURN L_Way.rwswho_Driver;
  ELSE                        RETURN L_Way.rwswho_Guard;
  END;
 END {Who2RWSWho};

 PUBLIC PROCEDURE m_GetDayTime(_Who: tTWOWho; D: DATE; _What: L_BegRWS.tDayType; _ExitClss: LIKE(ExitClss.ExitClss)): NUMERIC[3];
  VAR
   Result: NUMERIC[3];
 BEGIN
  IF ~!_ExitClss & StandOnExit(_ExitClss, _What, D, 0) THEN
   Result:=StExit.TotT;
  ELSIF _What = L_BegRWS.dt_WholeDay THEN
   IF D >= 01\04\2006 THEN
    Result:=11.6;
   ELSE
    Result:=9.3;
   END;
  ELSIF _What = L_BegRWS.dt_FirstShift THEN
   Result:=8.5;
  ELSIF _What = L_BegRWS.dt_SecondShift THEN
   Result:=8.5;
  ELSE
   Result:=0.0;
  END;
  IF Result > 0 THEN
   INC(Result, L_Way.E_GetStandartPZVTotalTime(D, Who2RWSWho(_Who)));
  END;
  RETURN Result;
 END {m_GetDayTime};

 PUBLIC PROCEDURE m_ChangeTimDone(Dir      : NUMERIC[0];
                                  _What    : L_BegRWS.tDayType;
                                  _ExitClss: LIKE(ExitClss.ExitClss);
                                  Idx      : NUMERIC[0]);
 BEGIN
  INC(Mtwo.asTimDone, Dir*m_GetDayTime(Mtwo.Who, Idx2Date(Idx, Mtwo.Per), _What, _ExitClss));
  REPLACE(Mtwo);
 END {m_ChangeTimDone};

 PUBLIC PROCEDURE m_AddTimDone(Idx: NUMERIC[0]);
 BEGIN
  m_ChangeTimDone(+1, Mtwo.What[Idx], Mtwo.ExitClss[Idx], Idx);
 END {m_AddTimDone};

 PUBLIC PROCEDURE GetDrvTSN(_TSN: LIKE(Staff.TSN); _Who: tTWOWho; _D: DATE): LIKE(Staff.TSN);
  VAR
   drvTSN: LIKE(Staff.TSN);
 BEGIN
  SETEMPTY(drvTSN);
  IF _Who = who_Driver THEN
   drvTSN:=_TSN;
  ELSE
   SAVE(StaffPro);
   IF P_Staff.AccessBySpdSrchV(P_Staff.P_FixedGuard, _TSN, _D) THEN
    drvTSN:=StaffPro.TSN;
   END;
   RESTORE(StaffPro);
  END;
  RETURN drvTSN;
 END {GetDrvTSN};

 PUBLIC PROCEDURE m_c_GetFixedBoxNbr(_TSN: LIKE(Staff.TSN); _Who: tTWOWho; _D: DATE): LIKE(Car.BoxNbr);
  VAR
   drvTSN: LIKE(Staff.TSN);
   Result: LIKE(Car.BoxNbr);
 BEGIN
  SETEMPTY(Result);
  SAVE(MCFix);
  drvTSN:=GetDrvTSN(_TSN, _Who, _D);
  IF ~!drvTSN & L_Car.StandOnAnyMCFix(drvTSN, _D) THEN
   Result:=CheckValidity(0, _D, da_Car, MCFix.BoxNbr, EMPTYOF(Dtwo.Change));
  END;
  RESTORE(MCFix);
  RETURN Result;
 END {m_c_GetFixedBoxNbr};

 PRIVATE PROCEDURE m_c_FillSort();
  VAR
   MonthE: DATE;
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH(Staff, TSN, , Mtwo.TSN);
   IF L_Staff.IsBegan(Mtwo.Per) THEN
    MonthE:=L_DatTim.MonthEnd(Mtwo.Per);
    L_Staff.PosToStaffLog(Staff.TSN, MonthE, 1);
    LOOP
     L_General.CallUs(OCCURE(StaffLog));
     IF ~L_Staff.IsDischargeStaffLog() THEN
      CONFORM(StaffLog, Officer);
      IF E_Mtwo_Who(Mtwo.Per) = Mtwo.Who THEN
       L_BegRWS.PosToSortOfStaff(Math.Min(StaffLog.DateE, MonthE));
       Mtwo.Dprt  :=L_Staff.getSortDprt(Sort.Sort);
       Mtwo.Sort  :=Sort.Sort;
       Mtwo.MyFirm:=Sort.MyFirm;
       EXIT;
      END;
     END;
     PREV(StaffLog);
    END; (* LOOP *)
    Mtwo.MyPlace:=L_Way.GetMyPlace(MonthE, Mtwo.fBoxNbr, Mtwo.TSN, EMPTYOF(StExit.Exit));
   END; (* IF L_Staff.IsBegan... *)
  EXCEPT
  END; (* TRY *)
 END {m_c_FillSort};

 PRIVATE PROCEDURE Insert_Mtwo(_TSN: LIKE(Staff.TSN); _Who: LIKE(Mtwo.Who); P: DATE);
 BEGIN
  DEFAULT(Mtwo);
  Mtwo.Per   :=P;
  Mtwo.Who   :=_Who;
  Mtwo.TSN   :=_TSN;
  Mtwo.Actual:=0;
  m_c_FillSort();
  Mtwo.Created:=SYSTIMESTAMP();
  INSERT(Mtwo);
 END {Insert_Mtwo};

 PRIVATE PROCEDURE ObtainMtwo(_TSN: LIKE(Staff.TSN); _Who: tTWOWho; P: DATE);
 BEGIN
  IF ~SELECT(Mtwo, Who, P, _Who, _TSN) THEN
   Insert_Mtwo(_TSN, _Who, P);
  END;
 END {ObtainMtwo};

 PUBLIC PROCEDURE StandOnMtwo(_TSN: LIKE(Staff.TSN); _Who: tTWOWho; P: DATE);
 BEGIN
  L_General.Assert(SELECT(Mtwo, Who, P, _Who, _TSN),
                   " 筮 拉  ᢥ  ࠡ⭨" +
                   "|" +
                   "(" + _TSN + ", " + L_Str.PoolItem(who_Pool, _Who) + ", " + L_DatTim.PeriodStr(P) + ")");
 END {StandOnMtwo};

 PUBLIC PROCEDURE Who2CooWho(): tTWOWho;
 BEGIN
  IF Mtwo.Who = who_Driver THEN RETURN who_Guard;
  ELSE                          RETURN who_Driver;
  END;
 END {Who2CooWho};

 PUBLIC PROCEDURE Ptwo_StandOn(_TSN: LIKE(Staff.TSN); D: DATE): SCAL[2];
 BEGIN
  RETURN SELECT(Ptwo, TSN, _TSN) & SRCINSEL(Ptwo, LE, D);
 END {Ptwo_StandOn};

 PRIVATE PROCEDURE GetRnvReportName(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem("twoAl|twoSn|twoNA|twoAS|twoEx|twoAN|twoMD|twoAF", rnvMode);
 END {GetRnvReportName};

(*
$P{ md_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "N.y"
@
############################################################################################  ########## #####
=#####========================================================================================================
|                                    ஡ ⮢ 鸞  #######                                    |
|------------------------------------------------------------------------------------------------------------|
|  ||ꥪ              |᭥                                                                    |
|-----|--|---------------------|-----------------------------------------------------------------------------|
}
*)

(*
$P{ md_Line:
?, L, ""
?, L, "D"
?, L, da_Pool
?, L, ""
?, L, L_BegRWS.wh_Pool
?, L, ""
@
|#####|##|############ ###### #|#############################################################################|
}
*)

(*
$P{ md_MsgLine:
?, C, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
}
*)

(*
$P{ md_Bot:
@
=(c) Polak====================================================================================================
}
*)

(*
$P{ DRnv_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
@
############################################################################################  ########## #####
=#####========================================================================================================
|                           ஡ ।⥫쭮 ନ஢   ##########                          |
|------------------------------------------------------------------------------------------------------------|
| ||  |  |  |ᠭ ஡                                                                 |
|------|-|-----|----|-----|----------------------------------------------------------------------------------|
}
*)

(*
$P{ DRnv_Line:
Dtwo.ExitClss, L, ""
Dtwo.Change, L, L_BegRWS.wh_Pool
Dtwo.TSN, L, ""
Dtwo.BoxNbr, L, ""
Dtwo.GuardTSN, L, ""
?, L, ""
?, L, ""
@
|######|#|#####|####|#####|##################################################################################|
|      | |     |    |     |##################################################################################|
}
*)

 PRIVATE PROCEDURE PutErrorLine(    wRaise : SCAL[2];
                                VAR daValue: STRING[];
                                    D      : DATE;
                                    da     : tDailyAttribute;
                                    DayType: L_BegRWS.tDayType;
                                    Msg    : STRING[]);
  CONST
   MsgPartLength = 77;
   MaxLines = 4;
  VAR
   aMsg: STRING[MsgPartLength][MaxLines];
   i   : NUMERIC[0];
 BEGIN
  IF ~!rnvMode THEN
   Str.Format(aMsg, Msg, MsgPartLength, LEFT);
   IF OCCURE(Mtwo) & !curRnvTSN THEN
    MAKEPART(R, md_Line, Mtwo.TSN, D, da, daValue, DayType, aMsg[0]);
    curRnvTSN:=Mtwo.TSN;
   ELSE
    MAKEPART(R, md_Line,         , D, da, daValue, DayType, aMsg[0]);
   END;
   i:=1;
   WHILE (i < MaxLines) & ~!aMsg[i] DO
    MAKEPART(R, md_Line, , , , , , aMsg[i]);
    INC(i);
   END;
   INC(rnvErrorCnt);
  END;
  IF !rnvMode | wRaise THEN
   L_General.Error(L_Str.PoolItem(da_Pool, da) + " " + daValue + " " + Msg);
  ELSE
   SETEMPTY(daValue);
  END;
 END {PutErrorLine};

 PRIVATE PROCEDURE D_PutErrorLine(da: tDailyAttribute; Msg: STRING[]);
  VAR
   daValue: STRING[];
 BEGIN
  daValue:=d_c_GetAttr(da);
  PutErrorLine(0, daValue, Dtwo.Date, da, Dtwo.Change, Msg);
 END {D_PutErrorLine};

 PRIVATE PROCEDURE DRnv_PutErrorLine(Exc: Exc_Root);
  VAR
   _Description: STRING[][2];
 BEGIN
  Str.Format(_Description, Exc.Description, 82, LEFT);
  MAKEPART(R, DRnv_Line, _Description[0], _Description[1]);
 END {DRnv_PutErrorLine};

 PRIVATE PROCEDURE PutChoiceLine(daValue: STRING[];
                                 D      : DATE;
                                 da     : tDailyAttribute;
                                 _Change: LIKE(Dtwo.Change);
                                 Msg    : STRING[]);
 BEGIN
  IF !rnvMode THEN
   L_StdFrm.Choice(L_Str.PoolItem(da_Pool, da) + ": " + daValue + "|" + Msg);
  ELSE
   PutErrorLine(0, daValue, D, da, _Change, Msg);
  END;
 END {PutChoiceLine};

 PRIVATE PROCEDURE GetCarSort(_BoxNbr: LIKE(Car.BoxNbr); D: DATE): LIKE(Sort.Sort);
  VAR
   Result: LIKE(Sort.Sort);
 BEGIN
  SETEMPTY(Result);
  SAVE(Staff);
  SELECT(MCFix, BoxNbr, , _BoxNbr);
  WHILE OCCURE(MCFix) & !Result DO
   IF L_DatTim.IsActive(D, MCFix.Begin, MCFix.Till) THEN
    CONFORM(MCFix, Staff);
    IF L_Staff.rInState(D) THEN
     L_BegRWS.PosToSortOfStaff(D);
     Result:=Sort.Sort;
    END;
   END;
   NEXT(MCFix);
  END; (* WHILE OCCURE(MCFix) ... *)
  RESTORE(Staff);
  RETURN Result;
 END {GetCarSort};

 PUBLIC PROCEDURE GetBoxNbrFixedTSN(_BoxNbr: LIKE(Car.BoxNbr); D: DATE): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="";
  TRY [RESTORE_CURSORS(RC_ON)]
   SELECT(MCFix, BoxNbr, , _BoxNbr);
   WHILE OCCURE(MCFix) DO
    IF L_DatTim.IsActive(D, MCFix.Begin, MCFix.Till) THEN
     CONFORM(MCFix, Staff);
     IF L_Staff.rInState(D) THEN
      Result:=L_Str.AddStrDlm(Result, ", ") + MCFix.TSN;
     END;
    END;
    NEXT(MCFix);
   END; (* WHILE OCCURE(MCFix) ... *)
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetBoxNbrFixedTSN};

 PRIVATE PROCEDURE d_c_FillSortOfTSN(_TSN: LIKE(Staff.TSN));
 BEGIN
  SAVE(Staff);
  SAVE(Sort);
  SEARCH(Staff, TSN, , _TSN);
  L_BegRWS.PosToSortOfStaff(Dtwo.Date);
  Dtwo.Dprt:=L_Staff.getSortDprt(Sort.Sort);
  Dtwo.Sort:=Sort.Sort;
  RESTORE(Sort);
  RESTORE(Staff);
 END {d_c_FillSortOfTSN};

 PRIVATE PROCEDURE GetDtwoMyFirm(): P_Firm.tMyFirm;
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   IF    ~!Dtwo.BoxNbr THEN
    L_Car.StandOnCarLog(Dtwo.BoxNbr, Dtwo.Date);
    CONFORM(CarLog, Column);
    RETURN Column.MyFirm;
   ELSIF ~!Dtwo.Sort THEN
    SEARCH(Sort, Sort, , Dtwo.Sort);
    RETURN Sort.MyFirm;
   ELSE
    RETURN P_Firm.mf_Fict;
   END;
  EXCEPT
  END; (* TRY *)
 END {GetDtwoMyFirm};

 PUBLIC PROCEDURE d_c_FillDependent();
  VAR
   _Sort  : LIKE(Sort.Sort);
 BEGIN
  IF ~!Dtwo.GuardTSN THEN
   SAVE(Staff);
   SAVE(Man);
   SEARCH(Staff, TSN, , Dtwo.GuardTSN);
   CONFORM(Staff, Man);
   Dtwo.GuardNam:=Man.Name;
   RESTORE(Staff);
   RESTORE(Man);
  ELSE
   Dtwo.GuardNam:="";
  END;
  IF ~!Dtwo.ExitClss & StandOnExit(Dtwo.ExitClss, Dtwo.Change, Dtwo.Date, 0) THEN
   Dtwo.Exit:=StExit.Exit;
   IF ~Dtwo.MnlTmSet THEN
    Dtwo.BegDay :=StExit.BegDay;
    Dtwo.BegTime:=StExit.BegTime;
    Dtwo.EndTime:=StExit.StopTim;
   END;
   IF StExit.GuNeed = L_Way.egn_Required THEN
    IF~!Dtwo.GuardTSN THEN
     Dtwo.GuardOk:=grd_Norma;
    ELSE
     Dtwo.GuardOk:=grd_Need;
    END;
   ELSE
    IF !Dtwo.GuardTSN THEN
     Dtwo.GuardOk:=grd_Norma;
    ELSE
     Dtwo.GuardOk:=grd_NotNeed;
    END;
   END;
   IF ((StExit.Strict = L_Way.ExitStrict_Reg) & (!Dtwo.TSN | !Dtwo.BoxNbr)) |
      (~!Dtwo.TSN & !Dtwo.BoxNbr) THEN
    Dtwo.Complete:=cmpl_NotComplete;
   ELSIF Dtwo.GuardOk = grd_Need THEN
    Dtwo.Complete:=cmpl_NoGuard;
   ELSE
    Dtwo.Complete:=cmpl_Norma;
   END;
  ELSE
   SETEMPTY(Dtwo.Exit, Dtwo.BegDay, Dtwo.BegTime, Dtwo.EndTime);
   IF ~!Dtwo.GuardTSN THEN
    Dtwo.GuardOk:=grd_NotNeed;
   ELSE
    Dtwo.GuardOk:=grd_Norma;
   END;
   Dtwo.Complete:=cmpl_NotComplete;
  END; (* IF ~!Dtwo.ExitClss & StandOnExit... *)

  SETEMPTY(Dtwo.Dprt, Dtwo.Sort);
  IF ~!Dtwo.Exit & L_Way.StandOnFixedSortOfExit(Dtwo.Exit, Dtwo.Date, who_Driver, 0) THEN
   Dtwo.Dprt:=L_Staff.getSortDprt(Sort.Sort);
   Dtwo.Sort:=Sort.Sort;
  ELSIF ~!Dtwo.TSN THEN
   d_c_FillSortOfTSN(Dtwo.TSN);
  ELSIF ~!Dtwo.GuardTSN THEN
   d_c_FillSortOfTSN(Dtwo.GuardTSN);
  ELSIF ~!Dtwo.BoxNbr THEN
   _Sort:=GetCarSort(Dtwo.BoxNbr, Dtwo.Date);
   IF ~!_Sort THEN
    Dtwo.Dprt:=L_Staff.getSortDprt(_Sort);
    Dtwo.Sort:=_Sort;
   ELSE
    Dtwo.Dprt:=L_Way.E_GetCarDprt(Dtwo.BoxNbr, Dtwo.Date);
   END;
  END;
  Dtwo.MyPlace:=L_Way.GetMyPlace(Dtwo.Date, Dtwo.BoxNbr, Dtwo.TSN, Dtwo.Exit);
  Dtwo.MyFirm :=GetDtwoMyFirm();
  IF IS_ALTERED(Dtwo) THEN
   REPLACE(Dtwo);
  END; (* IF IS_ALTERED *)
 END {d_c_FillDependent};

 PUBLIC PROCEDURE d_c_SetAttr(da: tDailyAttribute; Value: STRING[]);
 BEGIN
  IF    da = da_What     THEN Dtwo.Change  :=Value;
  ELSIF da = da_Driver   THEN Dtwo.TSN     :=Value;
  ELSIF da = da_Guard    THEN Dtwo.GuardTSN:=Value;
  ELSIF da = da_Car      THEN Dtwo.BoxNbr  :=Value;
  ELSIF da = da_ExitClss THEN Dtwo.ExitClss:=Value;
  ELSIF da = da_SrcWh    THEN Dtwo.Source[DSrcIdx(da_What)]    :=Value;
  ELSIF da = da_SrcEC    THEN Dtwo.Source[DSrcIdx(da_ExitClss)]:=Value;
  ELSIF da = da_SrcDr    THEN Dtwo.Source[DSrcIdx(da_Driver)]  :=Value;
  ELSIF da = da_SrcCr    THEN Dtwo.Source[DSrcIdx(da_Car)]     :=Value;
  ELSIF da = da_SrcGr    THEN Dtwo.Source[DSrcIdx(da_Guard)]   :=Value;
  ELSE
   L_General.CallUs(0);
  END;
 END {d_c_SetAttr};

 PRIVATE PROCEDURE d_SetSource(_Source: L_BegRWS.tSource);
 BEGIN
  Dtwo.Source[DSrcIdx(da_What)]    :=_Source;
  Dtwo.Source[DSrcIdx(da_ExitClss)]:=_Source;
  Dtwo.Source[DSrcIdx(da_Driver)]  :=_Source;
  Dtwo.Source[DSrcIdx(da_Car)]     :=_Source;
  Dtwo.Source[DSrcIdx(da_Guard)]   :=_Source;
 END {d_SetSource};

 PRIVATE PROCEDURE d_InsertSingleValue(D        : DATE;
                                       da       : tDailyAttribute;
                                       Value    : STRING[];
                                       trgChange: LIKE(Dtwo.Change);
                                       trgSource: L_BegRWS.tSource);
 BEGIN
  DEFAULT(Dtwo);
  Dtwo.Date  :=D;
  Dtwo.Change:=trgChange;
  d_SetSource(trgSource);
  d_c_SetAttr(da, Value);
  INSERT(Dtwo);
  d_c_FillDependent();
 END {d_InsertSingleValue};

 PUBLIC PROCEDURE d_InsertExit(D: DATE; trgExitClss: LIKE(Dtwo.ExitClss); trgChange: LIKE(Dtwo.Change));
 BEGIN
  d_InsertSingleValue(D, da_ExitClss, trgExitClss, trgChange, L_BegRWS.twosrc_Regime);
 END {d_InsertExit};

 PUBLIC PROCEDURE r_Access(D: DATE; _Dtwo: LIKE(Dtwo.Dtwo));
 BEGIN
  L_General.CallUs(SEARCH(Dtwo, Dtwo, D, _Dtwo));
 END {r_Access};

 PUBLIC PROCEDURE Who2DA(): tDailyAttribute;
 BEGIN
  IF    Mtwo.Who = who_Driver THEN
   RETURN da_Driver;
  ELSIF Mtwo.Who = who_Guard  THEN
   RETURN da_Guard;
  END;
 END {Who2DA};

 PUBLIC PROCEDURE Who2CooDA(): tDailyAttribute;
 BEGIN
  IF    Mtwo.Who = who_Driver THEN
   RETURN da_Guard;
  ELSIF Mtwo.Who = who_Guard  THEN
   RETURN da_Driver;
  END;
 END {Who2CooDA};

 PRIVATE PROCEDURE d_KeepIn(D: DATE; da: tDailyAttribute; Value: STRING[]; Change: LIKE(Dtwo.Change)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF da = da_ExitClss THEN
   Result:=IsStrictExitClss(Value, Change, D);
  ELSIF da = da_Car THEN
   SAVE(CarLog);
   IF L_Car.CarIsInOperation(Value, D) & (CarLog.InBeg = L_Car.inBeg_Required) THEN
    Result:=1;
   END;
   RESTORE(CarLog);
  ELSE
   SAVE(Mtwo);
   IF    da = da_Driver THEN
    SELECT(Mtwo, Who, , L_DatTim.MonthBeg(D), L_Way.rwswho_Driver, Value);
   ELSIF da = da_Guard THEN
    SELECT(Mtwo, Who, , L_DatTim.MonthBeg(D), L_Way.rwswho_Guard,  Value);
   END;
   Result:=OCCURE(Mtwo) & L_BegRWS.IsWorkDayType(Mtwo.What[Date2Idx(D)]);
   RESTORE(Mtwo);
  END;
  RETURN Result;
 END {d_KeepIn};

 PRIVATE PROCEDURE d_MayThrow(D: DATE; da: tDailyAttribute; Value: STRING[]; Change: LIKE(Dtwo.Change)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=~d_KeepIn(D, da, Value, Change);
  IF ~Result & (da = da_Car) THEN
   SAVE(Dtwo);
   IF SELECT(Dtwo, DBoxNbr, D, Value) & NEXT(Dtwo) THEN
    Result:=1;
   END;
   RESTORE(Dtwo);
  END;
  RETURN Result;
 END {d_MayThrow};

 PRIVATE PROCEDURE d_c_MakePattern(): LIKE(Dtwo.Dtwo);
  VAR
   Result: LIKE(Dtwo.Dtwo);
 BEGIN
  SAVE(Dtwo);
  SETEMPTY(Dtwo.Dtwo);
  d_SetSource(L_BegRWS.twosrc_Regime);
  Dtwo.Message:=L_lsStore.Insert(L_lsStore.Get(Dtwo.Message));
  INSERT(Dtwo);
  Result:=Dtwo.Dtwo;
  RESTORE(Dtwo);
  RETURN Result;
 END {d_c_MakePattern};

 PUBLIC PROCEDURE IsNormalSheet(_TSN: LIKE(Staff.TSN); D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
   _JMode: LIKE(JMode.JMode);
   Local : PROC;
 BEGIN
  _JMode:=L_AvePay.GetNativeSheetJMode(_TSN, D);
  IF ~!_JMode THEN
   Result:=0;
   Local:=PROCREF(E_Way.twoIsNormalSheet);
   IF ~!Local THEN
    Result:=Local(Result, _JMode, D);
   END;
  ELSE
   Result:=1;
  END;
  RETURN Result;
 END {IsNormalSheet};

 PUBLIC PROCEDURE E_RestPeriod(D: DATE; _Sort: LIKE(Sort.Sort); trgWho: tTWOWho; VAR Norm, Min: NUMERIC[3]);
  VAR
   Local: PROC;
 BEGIN
  Norm:=8.0;
  Min :=7.0;
  Local:=PROCREF(E_two.RestPeriod);
  IF ~!Local THEN
   Local(D, _Sort, trgWho, Norm, Min);
  END;
 END {E_RestPeriod};

 PRIVATE PROCEDURE intCheckValidity(wError    : SCAL[2];
                                    D         : DATE;
                                    da        : tDailyAttribute;
                                    Value     : STRING[];
                                    Change    : LIKE(Dtwo.Change);
                                    IsRenovate: SCAL[2]): STRING[];
  VAR
   Msg: STRING[];
 BEGIN
  Msg:="";
  IF da = da_ExitClss THEN
   IF ~StandOnExit(Value, Change, D, 0) THEN
    Msg:="   饣 室 (ᬥ " + WhatStr(Change) + ")";
   ELSIF StExit.Strict = L_Way.ExitStrict_Fict THEN
    Msg:="⨬ ᯮ짮 䨪⨢  室";
   END;
  ELSIF da = da_Car THEN
   L_General.Assert(L_Env.RealBoxNbr(Value), "⨬ ᯮ짮 䨪⨢ ࠦ");
   SAVE(CarLog);
   IF    ~L_Car._StandOnCarLog(Value, D) THEN
    Msg:="⨬ ਬ";
   ELSIF CarLog.Status = L_Car.carst_Retired THEN
    Msg:="ᯨᠭ";
   ELSIF CarLog.InBeg = L_Car.inBeg_DoesNot THEN
    Msg:="ࠧ浪 ";
   END;
   RESTORE(CarLog);
  ELSE
   SAVE(Staff);
   SAVE(StaffLog);
   IF SEARCH(Staff, TSN, Value) THEN
    L_General.Assert(L_Env.RealTSN(Staff.TSN), "⨬ ᯮ짮 䨪⨢ ⠡쭮");
    HISTCONF(D, Staff, StaffLog);
    IF ~OCCURE(StaffLog) | ~L_Staff.InOrder(D) THEN
     Msg:="  ";
    ELSE
     CONFORM(StaffLog, Officer);
     IF    da = da_Driver THEN
      IF E_Mtwo_Who(D) # who_Driver THEN
       Msg:=" ⥫";
      END;
     ELSIF da = da_Guard THEN
      IF E_Mtwo_Who(D) # who_Guard THEN
       Msg:=" ";
      END;
     ELSE
      L_General.CallUs(0);
     END;
     IF ~IsNormalSheet(Staff.TSN, D) THEN
      L_General.CallUs(SEARCH(JMode, JMode, L_AvePay.GetNativeSheetJMode(Staff.TSN, D)));
      IF IsRenovate THEN
       SETEMPTY(Value);
      ELSE
       Msg:=L_DatTim.DateStr(D) + " - '" + JMode.Name + "'";
      END;
     END;
    END;
   ELSE
    Msg:="⨬ ⠡ ";
   END;
   RESTORE(StaffLog);
   RESTORE(Staff);
  END;
  IF ~!Msg THEN
   IF wError THEN
    PutErrorLine(0, Value, D, da, Change, Msg);
   ELSE
    SETEMPTY(Value);
   END;
  END;
  RETURN Value;
 END {intCheckValidity};

 PRIVATE PROCEDURE CheckValidity(wError: SCAL[2];
                                 D     : DATE;
                                 da    : tDailyAttribute;
                                 Value : STRING[];
                                 Change: LIKE(Dtwo.Change)): STRING[];
 BEGIN
  RETURN intCheckValidity(wError, D, da, Value, Change, 0);
 END {CheckValidity};

 PRIVATE PROCEDURE d_r_Get(D: DATE; _Dtwo: LIKE(Dtwo.Dtwo)): tDtwoAsString;
  VAR
   Result: tDtwoAsString;
 BEGIN
  SETEMPTY(Result);
  IF ~!_Dtwo THEN
   r_Access(D, _Dtwo);
   Result[da_What]     :=Dtwo.Change;
   Result[da_ExitClss] :=Dtwo.ExitClss;
   Result[da_Driver]   :=Dtwo.TSN;
   Result[da_Car]      :=Dtwo.BoxNbr;
   Result[da_Guard]    :=Dtwo.GuardTSN;
   Result[da_SrcWh]    :=Dtwo.Source[DSrcIdx(da_What)];
   Result[da_SrcDr]    :=Dtwo.Source[DSrcIdx(da_Driver)];
   Result[da_SrcEC]    :=Dtwo.Source[DSrcIdx(da_ExitClss)];
   Result[da_SrcCr]    :=Dtwo.Source[DSrcIdx(da_Car)];
   Result[da_SrcGr]    :=Dtwo.Source[DSrcIdx(da_Guard)];
   Result[da_Message]  :=L_lsStore.Get(Dtwo.Message);
   Result[da_MsgTarget]:=Dtwo.TSN;
  END;
  RETURN Result
 END {d_r_Get};

 PUBLIC PROCEDURE d_c_GetAttr(da: tDailyAttribute): STRING[];
 BEGIN
  IF    da = da_What     THEN RETURN Dtwo.Change  ;
  ELSIF da = da_Driver   THEN RETURN Dtwo.TSN     ;
  ELSIF da = da_Guard    THEN RETURN Dtwo.GuardTSN;
  ELSIF da = da_Car      THEN RETURN Dtwo.BoxNbr  ;
  ELSIF da = da_ExitClss THEN RETURN Dtwo.ExitClss;
  ELSE
   L_General.CallUs(0);
  END;
 END {d_c_GetAttr};

 PUBLIC PROCEDURE m_c_GetAttr(da: tDailyAttribute; Idx: NUMERIC[0]): STRING[];
 BEGIN
  IF    da = da_What     THEN RETURN Mtwo.What[Idx];
  ELSIF da = da_ExitClss THEN RETURN Mtwo.ExitClss[Idx];
  ELSIF da = da_Driver   THEN RETURN Mtwo.CooTSN[Idx];
  ELSIF da = da_Car      THEN RETURN Mtwo.BoxNbr[Idx];
  ELSIF da = da_Guard    THEN RETURN Mtwo.CooTSN[Idx];
  ELSIF da = da_CooTSN   THEN RETURN Mtwo.CooTSN[Idx];
  END;
 END {m_c_GetAttr};

 PUBLIC PROCEDURE m_c_SetAttr(da: tDailyAttribute; Idx: NUMERIC[0]; Value: STRING[]);
 BEGIN
  IF    da = da_What     THEN Mtwo.What[Idx]    :=Value;
  ELSIF da = da_ExitClss THEN Mtwo.ExitClss[Idx]:=Value;
  ELSIF da = da_Driver   THEN Mtwo.CooTSN[Idx]  :=Value;
  ELSIF da = da_Car      THEN Mtwo.BoxNbr[Idx]  :=Value;
  ELSIF da = da_Guard    THEN Mtwo.CooTSN[Idx]  :=Value;
  ELSIF da = da_CooTSN   THEN Mtwo.CooTSN[Idx]  :=Value;
  END;
 END {m_c_SetAttr};

 PRIVATE PROCEDURE d_c_Remove();
 BEGIN
  Dtwo.Message:=L_lsStore.Replace(Dtwo.Message, "");
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   REMOVE(Dtwo);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_RecordIsInEdIns THEN
    L_General.Error(" ᭠砫  䨪 ப 筮 鸞");
   ELSE
    RAISE();
   END;
  END; (* TRY *)
 END {d_c_Remove};

 PUBLIC PROCEDURE d_c_IsEmpty(): SCAL[2];
  VAR
   Result: SCAL[2];
   Power : NUMERIC[0];
 BEGIN
  IF !Dtwo.TSN & !Dtwo.GuardTSN THEN
   IF ~!Dtwo.ExitClss & ~!Dtwo.BoxNbr THEN
    RETURN 0;
   ELSE
    RETURN (!Dtwo.ExitClss | d_MayThrow(Dtwo.Date, da_ExitClss, Dtwo.ExitClss, Dtwo.Change)) &
           (!Dtwo.BoxNbr   | d_MayThrow(Dtwo.Date, da_Car,      Dtwo.BoxNbr,   Dtwo.Change)) ;
   END;
  ELSE
   RETURN 0;
  END;
 END {d_c_IsEmpty};

 PRIVATE PROCEDURE getDAName(da: tDailyAttribute; V: tDtwoAsString): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF ~!V[da] THEN
   IF da = da_ExitClss THEN
    Result:=V[da] + " " + WhatStr(V[da_What]);
   ELSIF IsStaffDA(da) THEN
    SAVE(Staff);
    SAVE(Man);
    SEARCH(Staff, TSN, , V[da]);
    CONFORM(Staff, Man);
    Result:=Staff.TSN + " " +  L_Str.ShortName(Man.Name);
    RESTORE(Man);
    RESTORE(Staff);
   ELSIF da = da_Car THEN
    SAVE(Car);
    SAVE(CarLog);
    SAVE(Mark);
    SEARCH(Car, BoxNbr, , V[da]);
    L_Car.StandOnCarLog(Car.BoxNbr, Memo.ud_cd());
    CONFORM(CarLog, Mark);
    Result:=Car.BoxNbr + " " + CarLog.StateNbr + " " + Str.Align(Mark.Name, 20, LEFT);
    RESTORE(Car);
    RESTORE(CarLog);
    RESTORE(Mark);
   END;
  ELSE
   Result:="";
  END;
  RETURN Result;
 END {getDAName};

 PRIVATE PROCEDURE d_r_gfd_AddToPool(VAR SclPool, TxtPool: STRING[]; SclItem, TxtItem: STRING[]);
 BEGIN
  IF ~!SclPool THEN
   SclPool:=SclPool + "|";
   TxtPool:=TxtPool + "|";
  END;
  SclPool:=SclPool + SclItem;
  TxtPool:=TxtPool + TxtItem;
 END {d_r_gfd_AddToPool};

 PRIVATE PROCEDURE d_r_GetFD(    da       : tDailyAttribute;
                                 Op       : tROArray;
                                 dst,
                                 src,
                                 pat      : tDtwoAsString;
                             VAR Pool     : STRING[][];
                             VAR Variables: STRING[]): STRING[];
  VAR
   FDText,
   Result : STRING[];
 BEGIN
  SETEMPTY(Result);
  IF Op[da] # ro_NoAction THEN
   Pool[da]:=ro_NoChange;
   FDText  :=ro_NoChange;
   IF ~!Variables THEN
    Variables:=Variables + ",";
   END;
   Variables:=Variables + "OpAsScal[" + L_Str.IntStr(da) + "]";
   IF !dst[da] THEN
    IF ~!src[da] THEN
     d_r_gfd_AddToPool(Pool[da], FDText, ro_Replace,
                       "ᯮ짮 " + getDAName(da, src));
     IF da = da_Car THEN
      d_r_gfd_AddToPool(Pool[da], FDText, ro_Append,
                        " " + getDAName(da, src));
     END;
    ELSE
     d_r_gfd_AddToPool(Pool[da], FDText, ro_Free,
                       "᢮ " + getDAName(da, pat));
     IF IsStaffDA(da) THEN
      d_r_gfd_AddToPool(Pool[da], FDText, ro_Relax,
                        "⠭    " + getDAName(da, pat));
      d_r_gfd_AddToPool(Pool[da], FDText, ro_Rest,
                        "⠭ 室   " + getDAName(da, pat));
     END;
    END;
   ELSE
    d_r_gfd_AddToPool(Pool[da], FDText, ro_Free,
                      "᢮ " + getDAName(da, dst) + "  ᯮ짮 " + getDAName(da, src));
    d_r_gfd_AddToPool(Pool[da], FDText, ro_Swap,
                      " " + getDAName(da, dst) + "  " + getDAName(da, src));
    IF da = da_Car THEN
     d_r_gfd_AddToPool(Pool[da], FDText, ro_Append,
                       "᢮ " + getDAName(da, dst) + "   " + getDAName(da, src));
    END;
    IF IsStaffDA(da) THEN
     d_r_gfd_AddToPool(Pool[da], FDText, ro_Relax,
                       "⠭    " + getDAName(da, dst) + "  ᯮ짮 " + getDAName(da, src));
     d_r_gfd_AddToPool(Pool[da], FDText, ro_Rest,
                       "⠭ 室   " + getDAName(da, dst) + "  ᯮ짮 " + getDAName(da, src));
    END;
   END;
   Result:="%L<"+FDText+">I";
  ELSE
   Pool[da]:=ro_NoAction;
   FDText  :=ro_NoAction;
  END;
  RETURN Result;
 END {d_r_GetFD};

 PRIVATE CONST
  d_r_Length_SingleDATitle = 15;
  d_r_Lenght_SingleDAName  = 40;

 PRIVATE PROCEDURE d_r_GetPair(da: tDailyAttribute; dst, src: tDtwoAsString): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  RETURN Str.Align(L_Str.PoolItem(da_Pool, da), d_r_Length_SingleDATitle, LEFT) +
         Str.Align(getDAName(da, dst), d_r_Lenght_SingleDAName, LEFT) +
         "  " +
         Str.Align(getDAName(da, src), d_r_Lenght_SingleDAName, LEFT) +
         "|";
 END {d_r_GetPair};

 PRIVATE PROCEDURE d_r_GetFP(da: tDailyAttribute; Op: tROArray; dst: tDtwoAsString): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=Str.Align(L_Str.PoolItem(da_Pool, da), d_r_Length_SingleDATitle-1, LEFT);
  IF Op[da] # ro_NoAction THEN
   Result:=Result +
          "%" + L_Str.Repeat("#", d_r_Lenght_SingleDAName*2) + "%";
  ELSE
   Result:=Result + " " + Str.Align(getDAName(da, dst), d_r_Lenght_SingleDAName*2+1, LEFT);
  END;
  RETURN Result + "|";
 END {d_r_GetFP};

 PUBLIC PROCEDURE E_GuardGlued2Exit(): SCAL[2];
 BEGIN
  RETURN L_General.GetAPSiteID() = "HM";
 END {E_GuardGlued2Exit};

 PRIVATE PROCEDURE d_r_MayEasySet(trg_da, cur_da: tDailyAttribute; dst, src: tDtwoAsString): SCAL[2];
 BEGIN
  RETURN (cur_da = trg_da) | ((!dst[trg_da] | !src[trg_da]) & ~((trg_da = da_Guard ) & E_GuardGlued2Exit()));
 END {d_r_MayEasySet};

 PRIVATE PROCEDURE d_r_NeedAsk(da: tDailyAttribute; Op: tROArray; src, dst: tDtwoAsString): SCAL[2];
 BEGIN
  RETURN (Op[da] # (ro_NoAction)) & (~!dst[da] | ((da = da_Guard ) & E_GuardGlued2Exit() & ~!src[da]));
 END {d_r_NeedAsk};

 PRIVATE PROCEDURE d_r_SetInitialOp(curMtwo: LIKE(Mtwo.Mtwo); cur_da, trg_da: tDailyAttribute; dst, src: tDtwoAsString; VAR Op: tROArray);
 BEGIN
  IF ~!src[trg_da] THEN
   IF ~!dst[trg_da] THEN
    Op[trg_da]:=ro_Swap;
   ELSE
    Op[trg_da]:=ro_Replace;
   END;
  ELSE
   Op[trg_da]:=ro_NoAction;
  END;
  IF E_GuardGlued2Exit() THEN
   IF ~!curMtwo THEN
    IF    Mtwo.Who = who_Driver THEN
     IF cur_da = da_ExitClss THEN
      IF ~!dst[da_Guard] THEN
       Op[da_Guard]:=ro_Swap;
      ELSIF ~!src[da_Guard] THEN
       Op[da_Guard]:=ro_Replace;
      ELSE
       Op[da_Guard]:=ro_NoAction;
      END;
     END;
    ELSIF Mtwo.Who = who_Guard THEN
(*
     IF (cur_da = da_Guard)  THEN
      (*  ⥫         *)
      L_General.Error(" ⥫ ( )    饭");
     END;
*)
    END;
   ELSIF (trg_da = da_Guard) & (cur_da # da_Guard) THEN
    IF cur_da = da_ExitClss THEN
     Op[da_Guard]:=ro_Swap;
    ELSE
     Op[da_Guard]:=ro_NoChange;
    END;
   END;
  END;
 END {d_r_SetInitialOp};

 PUBLIC PROCEDURE AccessDtwoByMtwo(Idx: NUMERIC[0]);
  VAR
   D      : DATE;
   trgDtwo: LIKE(Dtwo.Dtwo);
   brrDtwo: LIKE(Dtwo.Dtwo);
 BEGIN
  L_General.CallUs(ACCESS(Mtwo));
  D:=Idx2Date(Idx, Mtwo.Per);
  IF ~L_BegRWS.IsWorkDayType(Mtwo.What[Idx]) THEN
   L_General.Error(" 믮 '' 筮 鸞  " + L_DatTim.DateStr(D));
  END;
  d_GetObject(D, Who2DA(), Mtwo.TSN, Mtwo.What[Idx], 0, trgDtwo, brrDtwo);
  IF    ~!trgDtwo THEN
   r_Access(D, trgDtwo);
  ELSIF ~!brrDtwo THEN
   r_Access(D, brrDtwo);
  ELSE
   L_General.Error(" 筮 拉  " + L_DatTim.DateStr(D) + "  ࠡ⭨ " + Mtwo.TSN);
  END;
 END {AccessDtwoByMtwo};

 PUBLIC PROCEDURE ResetHldOff(Idx: NUMERIC[0]; onDtwo: SCAL[2]);
 BEGIN
  IF Mtwo.HldOff[Idx] THEN
   L_StdFrm.Choice(" ࠡ⭨ " + Mtwo.TSN + " ᤥ ⬥⪠  '⨨' 室");
   Mtwo.HldOff[Idx]:=0;
   REPLACE(Mtwo);
   IF ~onDtwo THEN
    AccessDtwoByMtwo(Idx);
   END;
   Dtwo.HldOff[Mtwo.Who]:=0;
   REPLACE(Dtwo);
  END;
 END {ResetHldOff};

 PUBLIC PROCEDURE E_IsHolidayDayType(trgTSN: LIKE(Staff.TSN); D: DATE): SCAL[2];
  VAR
   regDayType: L_BegRWS.tDayType;
   Local     : PROC;
   Result    : SCAL[2];
 BEGIN
  regDayType:=L_BegRWS.GetDayTypeByRegime(GetTrueTSN(trgTSN, D), D);
  Result:=~L_BegRWS.IsWorkDayType(regDayType);
  Local:=PROCREF(E_two.IsHolidayDayType);
  IF ~!Local THEN
   Result:=Local(Result, trgTSN, D, regDayType);
  END;
  RETURN Result;
 END {E_IsHolidayDayType};

 PUBLIC PROCEDURE SetHldOff(Idx: NUMERIC[0]; onDtwo: SCAL[2]);
  VAR
   D    : DATE;
   Local: PROC;
   doIt : SCAL[2];
 BEGIN
  IF ~Mtwo.HldOff[Idx] THEN
   D:=Idx2Date(Idx, Mtwo.Per);
   doIt:=E_IsHolidayDayType(Mtwo.TSN, D);
   Local:=PROCREF(E_two.SetHldOff);
   IF ~!Local THEN
    doIt:=Local(doIt);
   END;
   IF doIt THEN
    IF L_StdFrm.Alternative(" 䨪 ࠡ⭨ " + Mtwo.TSN + " - ࠡ稩 .  ⬥  '⨨' 室?") THEN
     Mtwo.HldOff[Idx]:=1;
     REPLACE(Mtwo);
     IF ~onDtwo THEN
      AccessDtwoByMtwo(Idx);
      Dtwo.HldOff[Mtwo.Who]:=1;
      REPLACE(Dtwo);
     END;
     L_StdFrm.Inform(" ⬥⪠  '⨨' 室");
    END;
   END;
  END;
 END {SetHldOff};

 PRIVATE PROCEDURE d_c_UpdateSingleMtwo(curMtwo: LIKE(Mtwo.Mtwo);
                                        _Who   : tTWOWho;
                                        _TSN   : LIKE(Staff.TSN);
                                        _Source: L_BegRWS.tSource);
  VAR
   Idx    : NUMERIC[0];
   prvWhat: L_BegRWS.tDayType;
   IdxStr : STRING[];
 BEGIN
  SAVE(Mtwo);
  ObtainMtwo(_TSN, _Who, L_DatTim.Per(Dtwo.Date));
  Idx:=Date2Idx(Dtwo.Date);
  IF _Source = L_BegRWS.twosrc_Operator THEN
   IdxStr:="["+L_Str.IntStr(Idx)+"]";
   L_SysLog.SingleMark_InitField("Mtwo.What"  +IdxStr);
   L_SysLog.SingleMark_InitField("Mtwo.BoxNbr"+IdxStr);
   L_SysLog.SingleMark_InitField("Mtwo.Source"+IdxStr);
   L_SysLog.SingleMark_InitField("Mtwo.ExitClss"+IdxStr);
   L_SysLog.SingleMark_InitField("Mtwo.CooTSN"+IdxStr);
   L_SysLog.SingleMark_InitField("Mtwo.asTimDone");
  END;
  m_ChangeTimDone(-1, Mtwo.What[Idx], Mtwo.ExitClss[Idx], Idx);
  IF Mtwo.BoxNbr[Idx] # Dtwo.BoxNbr THEN
   Mtwo.BoxNbr  [Idx]:=Dtwo.BoxNbr;
   Mtwo.Source[MSrcIdx(Idx, da_Car)]:=_Source;
  END;
  IF Mtwo.ExitClss[Idx] # Dtwo.ExitClss THEN
   Mtwo.ExitClss[Idx]:=Dtwo.ExitClss;
   Mtwo.Source[MSrcIdx(Idx, da_ExitClss)]:=_Source;
  END;
  IF Mtwo.What[Idx] # Dtwo.Change THEN
   prvWhat:=Mtwo.What[Idx];
   IF !Mtwo.What[Idx] THEN
    Mtwo.What    [Idx]:=Dtwo.Change;
   ELSE
    IF Mtwo.Mtwo # curMtwo THEN
     PutChoiceLine(Dtwo.Change, Dtwo.Date, da_What, Dtwo.Change,
                   L_Str.PoolItem(who_Pool, Mtwo.Who) + " " + Mtwo.TSN +
                   " 㤥 믮  ᬥ: " +
                   WhatStr(Mtwo.What[Idx]) +
                   " -> " +
                   WhatStr(Dtwo.Change));
    END;
   END;
   Mtwo.What[Idx]:=Dtwo.Change;
   IF ~L_BegRWS.IsWorkDayType(prvWhat) THEN
    SetHldOff(Idx, 1);
   END;
   Mtwo.Source[MSrcIdx(Idx, da_What)]:=_Source;
  END;
  IF _Who = who_Driver THEN
   IF Mtwo.CooTSN[Idx] # Dtwo.GuardTSN THEN
    Mtwo.CooTSN[Idx]:=Dtwo.GuardTSN;
    Mtwo.Source[MSrcIdx(Idx, da_CooTSN)]:=_Source;
   END;
  ELSE
   IF Mtwo.CooTSN[Idx] # Dtwo.TSN THEN
    Mtwo.CooTSN[Idx]:=Dtwo.TSN;
    Mtwo.Source[MSrcIdx(Idx, da_CooTSN)]:=_Source;
   END;
  END;
  m_AddTimDone(Idx);
  REPLACE(Mtwo);
  IF _Source = L_BegRWS.twosrc_Operator THEN
   L_SysLog.SingleMark_Done("Mtwo");
  END;
  RESTORE(Mtwo);
 END {d_c_UpdateSingleMtwo};

 PUBLIC PROCEDURE d_c_UpdateMtwo(curMtwo: LIKE(Mtwo.Mtwo); _Source: L_BegRWS.tSource);
 BEGIN
  IF ~!Dtwo.TSN THEN
   d_c_UpdateSingleMtwo(curMtwo, who_Driver, Dtwo.TSN, _Source);
  END;
  IF ~!Dtwo.GuardTSN THEN
   d_c_UpdateSingleMtwo(curMtwo, who_Guard, Dtwo.GuardTSN, _Source);
  END;
 END {d_c_UpdateMtwo};

 PRIVATE PROCEDURE d_r_Put_1(curMtwo: LIKE(Mtwo.Mtwo); D: DATE; _Dtwo: LIKE(Dtwo.Dtwo); V: tDtwoAsString);
 BEGIN
  IF ~!_Dtwo THEN
   r_Access(D, _Dtwo);
   Dtwo.ExitClss:=V[da_ExitClss];
   Dtwo.TSN     :=V[da_Driver];
   Dtwo.BoxNbr  :=V[da_Car];
   Dtwo.GuardTSN:=V[da_Guard];
   Dtwo.Source[DSrcIdx(da_What)]    :=V[da_SrcWh];
   Dtwo.Source[DSrcIdx(da_Driver)]  :=V[da_SrcDr];
   Dtwo.Source[DSrcIdx(da_ExitClss)]:=V[da_SrcEC];
   Dtwo.Source[DSrcIdx(da_Car)]     :=V[da_SrcCr];
   Dtwo.Source[DSrcIdx(da_Guard)]   :=V[da_SrcGr];
   Dtwo.Message:=L_lsStore.Replace(Dtwo.Message, V[da_Message]);
   IF !Dtwo.ExitClss & !Dtwo.TSN & !Dtwo.GuardTSN THEN
    SETEMPTY(Dtwo.Change);
   ELSE
    Dtwo.Change:=V[da_What];
   END;
   REPLACE(Dtwo);
  END;
 END {d_r_Put_1};

 PRIVATE PROCEDURE d_r_Put_2(curMtwo  : LIKE(Mtwo.Mtwo);
                             D        : DATE;
                             _Dtwo    : LIKE(Dtwo.Dtwo);
                             _Source  : L_BegRWS.tSource;
                             IsCurDtwo: SCAL[2]);
 BEGIN
  IF ~!_Dtwo THEN
   r_Access(D, _Dtwo);
   IF d_c_IsEmpty() THEN
    IF ~IsCurDtwo THEN
     d_c_Remove();
    ELSE
     d_c_FillDependent();
    END;
   ELSE
    IF !Dtwo.TSN THEN
     Dtwo.Message:=L_lsStore.Replace(Dtwo.Message, "");
     REPLACE(Dtwo);
    END;
    d_c_FillDependent();
    d_c_UpdateMtwo(curMtwo, _Source);
   END;
  END;
 END {d_r_Put_2};

 PRIVATE PROCEDURE d_r_SetEmptySingleDA(da: tDailyAttribute; VAR V: tDtwoAsString);
 BEGIN
  IF da # da_What THEN
   SETEMPTY(V[da]);
  END;
 END {d_r_SetEmptySingleDA};

 PRIVATE PROCEDURE d_r_SetNotWorkDtwo(    da   : tDailyAttribute;
                                          D    : DATE;
                                          _What: L_BegRWS.tDayType;
                                      VAR pat  : tDtwoAsString);
  VAR
   Idx   : NUMERIC[0];
   IdxStr: STRING[];
 BEGIN
  SAVE(Mtwo);
  IF    da = da_Driver THEN
   ObtainMtwo(pat[da], who_Driver, L_DatTim.Per(D));
  ELSIF da = da_Guard THEN
   ObtainMtwo(pat[da], who_Guard, L_DatTim.Per(D));
  ELSE
   L_General.CallUs(0);
  END;
  Idx:=Date2Idx(D);
  IdxStr:="["+L_Str.IntStr(Idx)+"]";
  L_SysLog.SingleMark_InitField("Mtwo.What"  +IdxStr);
  L_SysLog.SingleMark_InitField("Mtwo.BoxNbr"+IdxStr);
  L_SysLog.SingleMark_InitField("Mtwo.Source"+IdxStr);
  L_SysLog.SingleMark_InitField("Mtwo.ExitClss"+IdxStr);
  L_SysLog.SingleMark_InitField("Mtwo.CooTSN"+IdxStr);
  L_SysLog.SingleMark_InitField("Mtwo.asTimDone");
  ResetHldOff(Idx, 1(*San -   㦭 ஢ Dtwo.HldOff,  ࠡ⭨ ⠢ 室 *));
  SETEMPTY(Mtwo.BoxNbr[Idx], Mtwo.ExitClss[Idx], Mtwo.CooTSN[Idx]);
  Mtwo.What  [Idx]:=_What;
  Mtwo.Source[MSrcIdx(Idx, da_What)]:=L_BegRWS.twosrc_Operator;
  REPLACE(Mtwo);
  L_SysLog.SingleMark_Done("Mtwo");
  d_r_SetEmptySingleDA(da, pat);
  RESTORE(Mtwo);
 END {d_r_SetNotWorkDtwo};

 PRIVATE PROCEDURE d_r_SingleDA(    da  : tDailyAttribute;
                                    Op  : tROArray;
                                    D   : DATE;
                                VAR pat,
                                    dst,
                                    src : tDtwoAsString);
  VAR
   dummy: STRING[];
 BEGIN
  IF Op[da] = ro_Trow THEN
   L_General.CallUs((!dst[da] & !src[da]) | (da = da_What));
   d_r_SetEmptySingleDA(da, pat);
  ELSIF (Op[da] = ro_Relax) | (Op[da] = ro_Rest) THEN
   IF ~!src[da] THEN
    L_General.CallUs(~!dst[da]);
    dst[da]:=src[da];
    d_r_SetEmptySingleDA(da, src);
   ELSE
    L_General.CallUs(!dst[da]);
   END;
   IF Op[da] = ro_Relax THEN
    d_r_SetNotWorkDtwo(da, D, L_BegRWS.dt_Relaxation, pat);
   ELSE
    d_r_SetNotWorkDtwo(da, D, L_BegRWS.dt_NotDefined, pat);
   END;
  ELSIF Op[da] = ro_Swap THEN
   dummy:=dst[da];
   dst[da]:=src[da];
   src[da]:=dummy;
   IF    da = da_What     THEN src[da_SrcWh]:=dst[da_SrcWh];
   ELSIF da = da_ExitClss THEN src[da_SrcEC]:=dst[da_SrcEC];
   ELSIF da = da_Driver   THEN src[da_SrcDr]:=dst[da_SrcDr];
   ELSIF da = da_Car      THEN src[da_SrcCr]:=dst[da_SrcCr];
   ELSIF da = da_Guard    THEN src[da_SrcGr]:=dst[da_SrcGr];
   ELSE
    L_General.CallUs(0);
   END;
   d_r_SetEmptySingleDA(da, pat);
  ELSIF  ~!src[da] THEN
   IF    (Op[da] = ro_Free) | (Op[da] = ro_Replace) THEN
    dst[da]:=src[da];
    d_r_SetEmptySingleDA(da, src);
   ELSIF Op[da] = ro_Append THEN
    dst[da]:=src[da];
   ELSIF ~!dst[da] THEN
    d_r_SetEmptySingleDA(da, pat);
   END;
  ELSIF dst[da] = pat[da] THEN
   d_r_SetEmptySingleDA(da, pat);
  END;
 END {d_r_SingleDA};

 PRIVATE PROCEDURE d_r_ArrangeMessages(trg: tDtwoAsString; VAR pat, dst, src: tDtwoAsString);
 BEGIN
  IF ~!trg[da_MsgTarget] THEN
   IF    trg[da_MsgTarget] = pat[da_Driver] THEN pat[da_Message]:=trg[da_Message];
   ELSIF trg[da_MsgTarget] = dst[da_Driver] THEN dst[da_Message]:=trg[da_Message];
   ELSIF trg[da_MsgTarget] = src[da_Driver] THEN src[da_Message]:=trg[da_Message];
   END;
  END;
 END {d_r_ArrangeMessages};

 PRIVATE PROCEDURE d_r_CheckAdditionalParms(da: tDailyAttribute; _Source: L_BegRWS.tSource);
 BEGIN
  IF _Source # L_BegRWS.twosrc_System  THEN
   IF ~!Dtwo.RWayS & (Dtwo.Date >= FirstModifiableDay()) THEN
    RAISE(, DtwoStr() + "||" + RWaySAlreadyDone);
   END;
   IF da = da_ExitClss THEN
    IF Dtwo.MnlTmSet THEN
     IF !rnvMode THEN
      L_StdFrm.Choice(DtwoStr() + "||" + "⠭ ⠭⭮ ६ ࠡ. ⠭ ⠭⭮?");
     ELSE
      D_PutErrorLine(da_ExitClss, "⠭ ⠭⭮ ६ ࠡ");
     END;
     Dtwo.MnlTmSet:=0;
     REPLACE(Dtwo);
    END;
   END;
  END;
 END {d_r_CheckAdditionalParms};

 PUBLIC PROCEDURE E_IsCarIntrinsicExitClss(_ExitClss: LIKE(ExitClss.ExitClss)): SCAL[2];
 BEGIN
  RETURN L_Way.IsExitClasswERKN(_ExitClss, L_Way.erkn_ec_TO2);
 END {E_IsCarIntrinsicExitClss};

 PUBLIC PROCEDURE d_Replace(curMtwo : LIKE(Mtwo.Mtwo);
                            InDtwo  : SCAL[2];
                            D       : DATE;
                            srcDtwo : LIKE(Dtwo.Dtwo);
                            da      : tDailyAttribute;
                            _Source : L_BegRWS.tSource);
  VAR
   patDtwo,
   dstDtwo     : LIKE(Dtwo.Dtwo);
   pat,
   dst,
   src         : tDtwoAsString;
   Op          : tROArray;
   OpAsScal    : SCAL[100][daAmount];
   Pool        : STRING[] [daAmount];
   Variables,
   FormStr     : STRING[];
   ForceAsk    : SCAL[2];
 BEGIN
  d_r_CheckAdditionalParms(da, _Source);
  dstDtwo:=Dtwo.Dtwo;
  patDtwo:=d_c_MakePattern();
  IF !srcDtwo THEN
   Dtwo.Source[DSrcIdx(da)]:=_Source;
   d_c_SetAttr(da, "");
   REPLACE(Dtwo);
  ELSE
   Dtwo.Source[DSrcIdx(da)]:=_Source;
   REPLACE(Dtwo);
   r_Access(D, srcDtwo);
   d_r_CheckAdditionalParms(da, _Source);
  END;

  pat:=d_r_Get(D, patDtwo);
  dst:=d_r_Get(D, dstDtwo);
  src:=d_r_Get(D, srcDtwo);

  SETEMPTY(ForceAsk, Op);
  Op[da_ExitClss]:=ro_NoAction;
  Op[da_Driver]  :=ro_NoAction;
  Op[da_Car]     :=ro_NoAction;
  Op[da_Guard]   :=ro_NoAction;

  IF !srcDtwo THEN
   (*    ,   ⮣ (祣),  (祣)  뫮  拉 *)
   IF ~d_MayThrow(D, da, pat[da], pat[da_What]) THEN
    Op[da]  :=ro_Free;
    IF ~!curMtwo & (da = da_Driver) THEN
     (*  ⥫    *)
     IF ~E_IsCarIntrinsicExitClss(dst[da_ExitClss]) THEN
      dst[da_Car]:="";
      Op[da_Car] :=ro_Free;
     END;
     IF L_BegRWS.E_GuardFixedByDriver(D) THEN
      dst[da_Guard]:="";
      Op[da_Guard] :=ro_Free;
     END;
     ForceAsk:=0;
    ELSIF IsStaffDA(da) & (!curMtwo | (Mtwo.Who = who_Driver)) THEN
    (*  ࠡ⭨  ,     ⥫*)
     ForceAsk:=1;
    ELSE
     ForceAsk:=0;
    END;
   ELSE
    Op[da]  :=ro_Trow;
    ForceAsk:=0;
    IF da = da_Driver THEN
     IF ~E_IsCarIntrinsicExitClss(dst[da_ExitClss]) THEN
      dst[da_Car]:="";
      Op[da_Car] :=ro_Free;
     END;
    END;
   END;
  ELSIF d_r_MayEasySet(da_ExitClss, da, dst, src) &
        d_r_MayEasySet(da_Driver,   da, dst, src) &
        d_r_MayEasySet(da_Guard,    da, dst, src) &
        d_r_MayEasySet(da_Car,      da, dst, src) THEN
   d_r_SetInitialOp(curMtwo, da, da_ExitClss, dst, src, Op);
   d_r_SetInitialOp(curMtwo, da, da_Driver  , dst, src, Op);
   d_r_SetInitialOp(curMtwo, da, da_Car     , dst, src, Op);
   d_r_SetInitialOp(curMtwo, da, da_Guard   , dst, src, Op);
   IF ~!dst[da] & IsStaffDA(da) & !curMtwo THEN
    Op[da]  :=ro_Free;
    ForceAsk:=1;
   ELSE
    ForceAsk:=0;
   END;
  ELSE
   d_r_SetInitialOp(curMtwo, da, da, dst, src, Op);
   IF    da = da_ExitClss THEN
    IF E_GuardGlued2Exit() THEN
     d_r_SetInitialOp(curMtwo, da, da_Guard, dst, src, Op);
    END;
   ELSIF da = da_Driver THEN
    d_r_SetInitialOp(curMtwo, da, da_Car,   dst, src, Op);
    d_r_SetInitialOp(curMtwo, da, da_Guard, dst, src, Op);
   ELSIF da = da_Car THEN
    d_r_SetInitialOp(curMtwo, da, da_Driver, dst, src, Op);
   ELSIF da = da_Guard THEN
    (* nothing *)
   END;
  END;
  IF !ForceAsk & (d_r_NeedAsk(da_ExitClss, Op, src, dst)|
                  d_r_NeedAsk(da_Driver,   Op, src, dst)|
                  d_r_NeedAsk(da_Car,      Op, src, dst)|
                  d_r_NeedAsk(da_Guard,    Op, src, dst)) | (ForceAsk=1) THEN
   Variables:="";
   FormStr:=d_r_GetFD(da_ExitClss, Op, dst, src, pat, Pool, Variables) +
            d_r_GetFD(da_Driver,   Op, dst, src, pat, Pool, Variables) +
            d_r_GetFD(da_Car,      Op, dst, src, pat, Pool, Variables) +
            d_r_GetFD(da_Guard,    Op, dst, src, pat, Pool, Variables) +
            "%< 믮 >DB" +
            "%< ⬥ >X" +
            "@" +
            "|" ;
   IF ~!srcDtwo THEN
    FormStr:=FormStr + d_r_GetPair(da_ExitClss, dst, src) +
                       d_r_GetPair(da_Driver,   dst, src) +
                       d_r_GetPair(da_Car,      dst, src) +
                       d_r_GetPair(da_Guard,    dst, src) +
                       "|";
   END;
   FormStr:=FormStr + d_r_GetFP(da_ExitClss, Op, dst) +
                      d_r_GetFP(da_Driver,   Op, dst) +
                      d_r_GetFP(da_Car,      Op, dst) +
                      d_r_GetFP(da_Guard,    Op, dst) +
                      "|" +
                      "|  %###########%  %##########%  ";

   OpAsScal[da_ExitClss]:=L_Str.PositionInPool(Pool[da_ExitClss], Op[da_ExitClss]);
   OpAsScal[da_Driver]  :=L_Str.PositionInPool(Pool[da_Driver],   Op[da_Driver]  );
   OpAsScal[da_Car]     :=L_Str.PositionInPool(Pool[da_Car],      Op[da_Car]     );
   OpAsScal[da_Guard]   :=L_Str.PositionInPool(Pool[da_Guard],    Op[da_Guard]   );
   IF !rnvMode THEN
    LOOP
     STDFORM(L_StdFrm.PartForm(FormStr), "   " + L_DatTim.DateStr(D) + " ", , 1, ^Variables);
     TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
      Op[da_ExitClss]:=L_Str.PoolItem(Pool[da_ExitClss], OpAsScal[da_ExitClss]);
      Op[da_Driver]  :=L_Str.PoolItem(Pool[da_Driver]  , OpAsScal[da_Driver]  );
      Op[da_Car]     :=L_Str.PoolItem(Pool[da_Car]     , OpAsScal[da_Car]     );
      Op[da_Guard]   :=L_Str.PoolItem(Pool[da_Guard]   , OpAsScal[da_Guard]   );
      EXIT;
     EXCEPT
     ON Exc: Exc_RunTime DO
      IF Exc.ErrorCode = 291 THEN
       L_StdFrm.RedInform("   ");
      ELSE
       RAISE();
      END;
     END; (* TRY *)
    END; (*LOOP*)
   ELSE
    Op[da_ExitClss]:=L_Str.PoolItem(Pool[da_ExitClss], OpAsScal[da_ExitClss]);
    Op[da_Driver]  :=L_Str.PoolItem(Pool[da_Driver]  , OpAsScal[da_Driver]  );
    Op[da_Car]     :=L_Str.PoolItem(Pool[da_Car]     , OpAsScal[da_Car]     );
    Op[da_Guard]   :=L_Str.PoolItem(Pool[da_Guard]   , OpAsScal[da_Guard]   );
   END;
  END;
  IF !dst[da_What] THEN
   Op[da_What]:=ro_Replace;
  ELSE
   Op[da_What]:=Op[da_ExitClss];
  END;
  d_r_SingleDA(da_What,     Op, D, pat, dst, src);
  d_r_SingleDA(da_ExitClss, Op, D, pat, dst, src);
  d_r_SingleDA(da_Driver,   Op, D, pat, dst, src);
  d_r_SingleDA(da_Car,      Op, D, pat, dst, src);
  d_r_SingleDA(da_Guard,    Op, D, pat, dst, src);
  d_r_ArrangeMessages(pat, pat, dst, src);
  d_r_ArrangeMessages(dst, pat, dst, src);
  d_r_ArrangeMessages(src, pat, dst, src);
  d_r_Put_1(curMtwo, D, patDtwo, pat);
  d_r_Put_1(curMtwo, D, dstDtwo, dst);
  d_r_Put_1(curMtwo, D, srcDtwo, src);
  d_r_Put_2(curMtwo, D, patDtwo, _Source, 0);
  d_r_Put_2(curMtwo, D, dstDtwo, _Source, InDtwo);
  d_r_Put_2(curMtwo, D, srcDtwo, _Source, 0);
 END {d_Replace};

 PRIVATE PROCEDURE d_IsBRda(da: tDailyAttribute): SCAL[2];
 BEGIN
  RETURN ((da = da_Driver) & Dtwo.BR_Drv) | ((da = da_Car) & Dtwo.BR_Car);
 END {d_IsBRda};

 PRIVATE PROCEDURE d_GetObject(D        : DATE;
                               da       : tDailyAttribute;
                               Value    : STRING[];
                               _Change  : LIKE(Dtwo.Change);
                               wCurDtwo : SCAL[2];
                               VAR trgDtwo: LIKE(Dtwo.Dtwo);
                               VAR brrDtwo: LIKE(Dtwo.Dtwo));
  VAR
   curDtwo    : LIKE(Dtwo.Dtwo);
   DtwoArr    : LIKE(Dtwo.Dtwo)[16];
   i          : NUMERIC[0];
   DriverName,
   ChangeAsStr,
   List,
   Caption    : STRING[];
 BEGIN
  SAVE(Dtwo);
  IF wCurDtwo THEN
   curDtwo:=Dtwo.Dtwo;
  ELSE
   SETEMPTY(curDtwo);
  END;
  SETEMPTY(trgDtwo, brrDtwo);
  IF ~!Value THEN
   IF    da = da_Driver THEN
    SELECT(Dtwo, DTSN,      , D, Value);
   ELSIF da = da_Guard THEN
    SELECT(Dtwo, DGuardTSN, , D, Value);
   ELSIF da = da_Car THEN
    SELECT(Dtwo, DBoxNbr,   , D, Value);
   ELSIF da = da_ExitClss THEN
    SELECT(Dtwo, DExitClss, , D, Value);
   END;
   IF OCCURE(Dtwo) THEN
    i:=0;
    WHILE OCCURE(Dtwo) DO
     IF (Dtwo.Dtwo # curDtwo) THEN
      IF d_IsBRda(da) THEN
       brrDtwo:=Dtwo.Dtwo;
      ELSIF (!Dtwo.Change | !_Change | (Dtwo.Change = _Change)) &
            ((da # da_Car   ) | ~E_NoCarsConflictExitClss(Dtwo.ExitClss)) THEN
       trgDtwo:=Dtwo.Dtwo;
       INC(i);
      END;
     END;
     NEXT(Dtwo);
    END;
    IF (i > 1) & (RTI.Get().TryBlock.MSG_SUPPRESSION = MSG_SUPPRESSION_NONE) THEN
     Caption:=Str.Align("",      7, LEFT) +
              Str.Align("",          2, LEFT) +
              Str.Align("⥫",  34, LEFT) +
              Str.Align("",         5, LEFT) +
              Str.Align("", 34, LEFT);
     List:="";
     i   :=0;
     FIRST(Dtwo);
     WHILE OCCURE(Dtwo) DO
      IF (Dtwo.Dtwo # curDtwo) & (!Dtwo.Change | !_Change | (Dtwo.Change = _Change)) THEN
       IF ~!Dtwo.TSN THEN
        CONFORM(Dtwo, Staff);
        CONFORM(Staff, Man);
        DriverName:=Man.Name;
       ELSE
        DriverName:="";
       END;
       IF ~!Dtwo.Change THEN
        ChangeAsStr:=L_Str.PoolItem(L_BegRWS.wh_Pool, Dtwo.Change);
       ELSE
        ChangeAsStr:="";
       END;
       DtwoArr[i]:=Dtwo.Dtwo;
       List:=List + Str.Align(FLDTOSTR(Dtwo.ExitClss, "0", 0),                                  7, LEFT) +
                    Str.Align(ChangeAsStr,                                                      2, LEFT) +
                    Str.Align(FLDTOSTR(Dtwo.TSN, "0", 0) + " " + DriverName,                   34, LEFT) +
                    Str.Align(FLDTOSTR(Dtwo.BoxNbr, "0", 0),                                    5, LEFT) +
                    Str.Align(FLDTOSTR(Dtwo.GuardTSN, "0", 0) + " " + Dtwo.GuardNam,           34, LEFT) + "|";
       INC(i);
      END;
      NEXT(Dtwo);
     END;
     trgDtwo:=DtwoArr[L_StdFrm.ShowListAsMenu_wCaption(List,
                                                       " 롮 ப 鸞 (" + L_Str.PoolItem(da_Pool, da) + " " + Value + ") ",
                                                       Caption)];
    END; (* IF i > 1 *)
   END;
  END;
  RESTORE(Dtwo);
 END {d_GetObject};

 PUBLIC PROCEDURE d_ObtainObject(ForceNew,
                                 wCheck   : SCAL[2];
                                 D        : DATE;
                                 da       : tDailyAttribute;
                                 Value    : STRING[];
                                 Change   : LIKE(Dtwo.Change)): LIKE(Dtwo.Dtwo);
  VAR
   Result: LIKE(Dtwo.Dtwo);
   brrDtwo: LIKE(Dtwo.Dtwo);
 BEGIN
  IF ~(~!Value & ((da = da_ExitClss) & ~IsStrictExitClss(Value, Change, D))) THEN
   d_GetObject(D, da, Value, Change, 0, Result, brrDtwo);
  ELSE
   SETEMPTY(Result, brrDtwo);
  END;
  IF !Result & ~!Value THEN
   IF wCheck THEN
    Value:=CheckValidity(1, D, da, Value, Change);
   END;
   IF ~!brrDtwo THEN
    d_GetObject(D, da, Value, EMPTYOF(Change), 0, Result, brrDtwo);
   END;
   IF ForceNew | ~d_KeepIn(D, da, Value, Change) | (!Result & ~!brrDtwo) THEN
    SAVE(Dtwo);
    IF (da = da_ExitClss) & !Change THEN
     IF IsWholeDayExitClss(Value, D) THEN
      Change:=L_BegRWS.dt_WholeDay;
     END;
    END;
    d_InsertSingleValue(D, da, Value, Change, L_BegRWS.twosrc_Regime);
    Result:=Dtwo.Dtwo;
    RESTORE(Dtwo);
   ELSE
    IF da # da_ExitClss THEN
     d_GetObject(D, da, Value, EMPTYOF(Change), 0, Result, brrDtwo);
    END;
    IF !Result THEN
     IF !brrDtwo & ~L_APtm.IsOG() THEN
      L_General.Error(L_Str.PoolItem(da_Pool, da) + " " + Value + "    筮 拉  " +
                      L_DatTim.DateStr(D) + ", ᬥ " + FLDTOSTR(Change) + "|" +
                      ", 室  ");
     ELSE
      SAVE(Dtwo);
      d_InsertSingleValue(D, da, Value, Change, L_BegRWS.twosrc_Regime);
      Result:=Dtwo.Dtwo;
      RESTORE(Dtwo);
     END;
    END;
   END;
  END;
  RETURN Result;
 END {d_ObtainObject};

 PRIVATE PROCEDURE E_ClearExitClssManner(): SCAL[2];
 BEGIN
  RETURN 0;
 END {E_ClearExitClssManner};

 PUBLIC PROCEDURE m_ChangeDA(da      : tDailyAttribute;
                             prvValue: STRING[];
                             Idx     : NUMERIC[0];
                             _Source : L_BegRWS.tSource);
  VAR
   D             : DATE;
   srcDtwo       : LIKE(Dtwo.Dtwo);
   Value,
   dst_Value,
   src_Value     : STRING[];
   dst_da,
   src_da        : tDailyAttribute;
   dst_Change,
   src_Change    : L_BegRWS.tDayType;
   ForceDstObtain: SCAL[3];
   SetChangeOnly : SCAL[2];
 BEGIN
  D:=Idx2Date(Idx, Mtwo.Per);

  Value:=m_c_GetAttr(da, Idx);

  IF Value # prvValue THEN
   SETZERO(ForceDstObtain, SetChangeOnly);
   IF da = da_What THEN
    src_da   :=EMPTYOF(tDailyAttribute);
    dst_da   :=Who2DA();
    dst_Value:=Mtwo.TSN;
    IF    ~L_BegRWS.IsWorkDayType(prvValue) &  L_BegRWS.IsWorkDayType(Mtwo.What[Idx]) THEN
     Mtwo.Source[MSrcIdx(Idx, da_ExitClss)]:=L_BegRWS.twosrc_Regime;
     Mtwo.Source[MSrcIdx(Idx, da_Car)]     :=L_BegRWS.twosrc_Regime;
     Mtwo.Source[MSrcIdx(Idx, da_CooTSN)]  :=L_BegRWS.twosrc_Regime;
     REPLACE(Mtwo);
     ForceDstObtain:=1;
     dst_Change    :=Mtwo.What[Idx];
     da            :=Who2DA();
     Value         :=Mtwo.TSN;
    ELSIF  L_BegRWS.IsWorkDayType(prvValue) & ~L_BegRWS.IsWorkDayType(Mtwo.What[Idx]) THEN
     SETEMPTY(Mtwo.BoxNbr[Idx], Mtwo.ExitClss[Idx], Mtwo.CooTSN[Idx]);
     Mtwo.Source[MSrcIdx(Idx, da_ExitClss)]:=L_BegRWS.twosrc_Regime;
     Mtwo.Source[MSrcIdx(Idx, da_Car)]     :=L_BegRWS.twosrc_Regime;
     Mtwo.Source[MSrcIdx(Idx, da_CooTSN)]  :=L_BegRWS.twosrc_Regime;
     REPLACE(Mtwo);
     dst_Change:=prvValue;
     da:=Who2DA();
     SETEMPTY(Value);
    ELSIF  L_BegRWS.IsWorkDayType(prvValue) &  L_BegRWS.IsWorkDayType(Mtwo.What[Idx]) THEN
     dst_Change:=prvValue;
     IF ~!Mtwo.ExitClss[Idx] THEN
      src_da    :=da_ExitClss;
      src_Value :=Mtwo.ExitClss[Idx];
      src_Change:=Mtwo.What[Idx];
      da        :=src_da;
      Value     :=src_Value;
     ELSE
      SetChangeOnly:=1;
     END;
    ELSE
     dst_da:=EMPTYOF(tDailyAttribute);
    END;
   ELSIF !Value THEN
    src_da    :=EMPTYOF(tDailyAttribute);
    dst_da    :=Who2DA();
    dst_Value :=Mtwo.TSN;
    dst_Change:=Mtwo.What[Idx];
    IF (da = da_ExitClss) & (E_ClearExitClssManner() = 0) THEN
     da:=dst_da;
    END;
   ELSE
    L_General.CallUs(L_BegRWS.IsWorkDayType(Mtwo.What[Idx]));
    IF Mtwo.Who = who_Driver THEN
     src_da    :=da;
     src_Value :=Value;
     src_Change:=Mtwo.What[Idx];
     dst_da    :=Who2DA();
     dst_Value :=Mtwo.TSN;
     dst_Change:=Mtwo.What[Idx];
    ELSE
     src_da    :=Who2DA();
     src_Value :=Mtwo.TSN;
     src_Change:=Mtwo.What[Idx];
     dst_da    :=da;
     dst_Value :=Value;
     dst_Change:=Mtwo.What[Idx];
     da        :=da_Guard;
     Value     :=Mtwo.TSN;
    END;
   END;
   IF ~!dst_da THEN
    IF ~!src_da THEN
     srcDtwo:=d_ObtainObject(_Source # L_BegRWS.twosrc_Operator, 1, D, src_da, src_Value, src_Change);
    ELSE
     SETEMPTY(srcDtwo);
    END;
    r_Access(D, d_ObtainObject((_Source # L_BegRWS.twosrc_Operator) | ForceDstObtain,
                               ~!Value,
                               D, dst_da, dst_Value, dst_Change));
    IF SetChangeOnly THEN
     Dtwo.Source[DSrcIdx(da)]:=_Source;
     Dtwo.Change:=Value;
     REPLACE(Dtwo);
     d_c_UpdateMtwo(Mtwo.Mtwo, _Source);
    ELSIF ~ForceDstObtain THEN
     d_Replace(Mtwo.Mtwo, 0, D, srcDtwo, da, _Source);
    END;
   END; (* IF ~!dst_da *)
  END;
 END {m_ChangeDA};

 PUBLIC PROCEDURE m_ReplacableSource(Idx: NUMERIC[0]; da: tDailyAttribute; _Source: L_BegRWS.tSource): SCAL[2];
 BEGIN
  RETURN (Mtwo.Source[MSrcIdx(Idx, da)] # L_BegRWS.twosrc_Operator) |
         (_Source = L_BegRWS.twosrc_Operator) | (_Source = L_BegRWS.twosrc_System);
 END {m_ReplacableSource};

 PUBLIC PROCEDURE m_SubstituteDA(da     :  tDailyAttribute;
                                 Value  : STRING[];
                                 Idx    : NUMERIC[0];
                                 _Source: L_BegRWS.tSource): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  L_General.CallUs(m_ReplacableSource(Idx, da, _Source));
  Result:=m_c_GetAttr(da, Idx);
  m_c_SetAttr(da, Idx, Value);
  Mtwo.Source[MSrcIdx(Idx, da)]:=_Source;
  REPLACE(Mtwo);
  RETURN Result;
 END {m_SubstituteDA};

 PRIVATE PROCEDURE m_FillSingleAttribute(da     : tDailyAttribute;
                                         Idx    : NUMERIC[0];
                                         Value  : STRING[];
                                         _Source: L_BegRWS.tSource);
  VAR
   prvValue: STRING[];
   prvSource: L_BegRWS.tSource;
 BEGIN
  IF Value # NeverFixing THEN
   IF m_ReplacableSource(Idx, da, _Source) THEN
    prvSource:=Mtwo.Source[MSrcIdx(Idx, da)];
    IF ~(!Value &
         (_Source   = L_BegRWS.twosrc_Regime) &
         (prvSource = L_BegRWS.twosrc_Auto)) THEN
     prvValue:=m_c_GetAttr(da, Idx);
     IF (prvValue # Value) | (prvSource # _Source) THEN
      Mtwo.Source[MSrcIdx(Idx, da)]:=_Source;
      m_c_SetAttr(da, Idx, Value);
      REPLACE(Mtwo);
      m_ChangeDA(da, prvValue, Idx, _Source);
     END;
    END; (* IF Auto *)
   END; (* IF m_ReplacableSource ... *)
  END; (* IF Value # NeverFixing *)
 END {m_FillSingleAttribute};

 PUBLIC PROCEDURE m_FillSingleDay(_What     : L_BegRWS.tDayType;
                                  _Source   : L_BegRWS.tSource;
                                  _ExitClss,
                                  _CooTSN,
                                  _BoxNbr   : STRING[];
                                  Idx       : NUMERIC[0]);
 BEGIN
  m_FillSingleAttribute(da_What,     Idx, _What,     _Source);
  m_FillSingleAttribute(da_ExitClss, Idx, _ExitClss, _Source);
  m_FillSingleAttribute(da_Car,      Idx, _BoxNbr,   _Source);
  m_FillSingleAttribute(Who2CooDA(), Idx, _CooTSN,   _Source);
 END {m_FillSingleDay};

 PUBLIC PROCEDURE GetTrueTSN(_TSN: LIKE(Staff.TSN); D: DATE): LIKE(Staff.TSN);
  VAR
   Result: LIKE(Staff.TSN);
 BEGIN
  Result:=P_Staff.Get_SubstitutionInBegRWS(_TSN, D);
  IF !Result THEN
   Result:=_TSN;
  END;
  RETURN Result;
 END {GetTrueTSN};

 PRIVATE PROCEDURE GetSubstTSN(_TSN: LIKE(Staff.TSN); D: DATE): LIKE(Staff.TSN);
  VAR
   Result: LIKE(Staff.TSN);
 BEGIN
  IF P_Staff.AccessBySpdSrchV(P_Staff.P_SubstitutionInBegRWS, _TSN, D) THEN
   Result:=StaffPro.TSN;
  ELSE
   Result:=_TSN;
  END;
  RETURN Result;
 END {GetSubstTSN};

 PRIVATE PROCEDURE E_HasFixing(D: DATE; _Who: tTWOWho; da: tDailyAttribute): SCAL[2];
  VAR
   default: SCAL[2];
   Local  : PROC;
 BEGIN
  default:=1;
  Local:=PROCREF(E_two.HasFixing);
  IF ~!Local THEN
   default:=Local(default, D, _Who, da);
  END;
  RETURN default;
 END {E_HasFixing};

 PUBLIC PROCEDURE m_GF_ExitClss(D: DATE; _Change: LIKE(Dtwo.Change); wCheck: SCAL[2]): STRING[];
  VAR
   _ExitClss: LIKE(ExitClss.ExitClss);
   Result   : STRING[];
 BEGIN
  IF ~E_HasFixing(D, Mtwo.Who, da_ExitClss) THEN
   RETURN NeverFixing;
  END;
  _ExitClss:=GetPreferableExitClass(D, GetTrueTSN(Mtwo.TSN, D), Mtwo.Who, _Change);
  IF ~!_ExitClss THEN
   IF wCheck THEN
    _ExitClss:=CheckValidity(1, D, da_ExitClss, _ExitClss, _Change);
    IF ~!_ExitClss & d_KeepIn(D, da_ExitClss, _ExitClss, _Change) THEN
     IF SELECT(Dtwo, DExitClss, D, _ExitClss, _Change) &
       (((Mtwo.Who = who_Driver) & ~!Dtwo.TSN      & (Dtwo.TSN      # Mtwo.TSN)) |
        ((Mtwo.Who = who_Guard)  & ~!Dtwo.GuardTSN & (Dtwo.GuardTSN # Mtwo.TSN)) ) THEN
      IF Mtwo.Who = who_Driver THEN
       PutErrorLine(0, _ExitClss, D, da_ExitClss, _Change, "㦥  拉. ⥫ " + FLDTOSTR(Dtwo.TSN));
      ELSE
       PutErrorLine(0, _ExitClss, D, da_ExitClss, _Change, "㦥  拉.  " + FLDTOSTR(Dtwo.GuardTSN));
      END;
     END;
    END;
   END;
  END;
  Result:=_ExitClss;
  RETURN Result;
 END {m_GF_ExitClss};

 PRIVATE PROCEDURE CarIsFreeOfSingleFixedTSN(_BoxNbr: LIKE(Car.BoxNbr); D: DATE; _Change: L_BegRWS.tDayChange): SCAL[2];
  VAR
   _What : L_BegRWS.tDayType;
   Result: SCAL[2];
 BEGIN
  Result:=1;
  TRY [RESTORE_CURSORS(RC_ON)]
   SELECT(MCFix, BoxNbr, , _BoxNbr);
   WHILE OCCURE(MCFix) & Result DO
    IF L_DatTim.IsActive(D, MCFix.Begin, MCFix.Till) THEN
     CONFORM(MCFix, Staff);
     IF L_Staff.rInState(D) & L_Car.StaffHasSingleMCFix(Staff.TSN, D) THEN
      IF SEARCH(Mtwo, Who, L_DatTim.Per(D), who_Driver, GetSubstTSN(Staff.TSN, D)) &
          (Mtwo.Actual | (Mtwo.Source[MSrcIdx(Date2Idx(D), da_What)] = L_BegRWS.twosrc_Operator)) THEN
       _What:=Mtwo.What[Date2Idx(D)];
      ELSE
       _What:=L_BegRWS.GetDayTypeByRegime(Staff.TSN, D);
      END; (* IF SEARCH(Mtwo ... *)
      Result:=~L_BegRWS.IsWorkDayType(_What) | (_What # _Change);
     END; (* IF L_Staff.rInState ... *)
    END; (* IF L_DatTim.IsActive ... *)
    NEXT(MCFix);
   END; (* WHILE OCCURE(MCFix) ... *)
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {CarIsFreeOfSingleFixedTSN};

 PRIVATE PROCEDURE E_NoCarsConflictExitClss(trgExitClss: LIKE(ExitClss.ExitClss)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF L_General.GetAPSiteNumber() = 50 THEN
   Result:=trgExitClss = 150001;
  END;
  RETURN Result;
 END {E_NoCarsConflictExitClss};

 PUBLIC PROCEDURE m_GF_BoxNbr(D: DATE; _ExitClss: STRING[]; _Change: LIKE(Dtwo.Change)): STRING[];
  VAR
   TrueTSN,
   DummyTSN: LIKE(Staff.TSN);
   Result  : STRING[];
 BEGIN
  IF Mtwo.Who = who_Driver THEN
   SETEMPTY(Result);
   TrueTSN:=GetTrueTSN(Mtwo.TSN, D);
   IF L_Car.StandOnAnyMCFix(TrueTSN, D) THEN
    IF L_Car.StaffHasSingleMCFix(TrueTSN, D) |
       (L_Car.StandOnFirstMCFix(TrueTSN, D)     & CarIsFreeOfSingleFixedTSN(MCFix.BoxNbr, D, _Change)) |
       (L_Car.StandOnSecondaryMCFix(TrueTSN, D) & CarIsFreeOfSingleFixedTSN(MCFix.BoxNbr, D, _Change)) THEN
     Result:=CheckValidity(1, D, da_Car, MCFix.BoxNbr, _Change);
    ELSE
     DummyTSN:=Mtwo.TSN;
     PutErrorLine(0, DummyTSN, D, da_Driver, _Change, "⥫ " + TrueTSN + " - ९    ");
    END;
   END;
   IF ~!Result THEN
    IF SELECT(Dtwo, DBoxNbr, D, Result) & ~(E_NoCarsConflictExitClss(_ExitClss) |
                                            ((E_NoCarsConflictExitClss(Dtwo.ExitClss) | (Dtwo.TSN = Mtwo.TSN)) &
                                             (~NEXT(Dtwo)                             | (Dtwo.TSN = Mtwo.TSN)))) THEN
     IF SELECT(Dtwo, DBoxNbr, D, Result, _Change) THEN
      IF (~!Dtwo.TSN & (Dtwo.TSN # Mtwo.TSN)) |
         ((!Dtwo.TSN & (~!Dtwo.ExitClss & ~!_ExitClss & (_ExitClss # NeverFixing) & (FLDTOSTR(Dtwo.ExitClss) # _ExitClss)))) THEN
       PutErrorLine(0, Result, D, da_Car, _Change, "㦥  拉. ⥫ " + FLDTOSTR(Dtwo.TSN) + ",  " + FLDTOSTR(Dtwo.ExitClss));
      END;
     ELSE
      IF _Change = L_BegRWS.dt_WholeDay THEN
       IF SELECT(Dtwo, DBoxNbr, D, Result) & ~!Dtwo.Change THEN
        PutErrorLine(0, Result, D, da_Car, _Change, "㦥  拉  㣮 ᬥ. ⥫ " + FLDTOSTR(Dtwo.TSN) + ",  " + FLDTOSTR(Dtwo.ExitClss));
       END;
      ELSE
       IF SELECT(Dtwo, DBoxNbr, D, Result, L_BegRWS.dt_WholeDay) THEN
        PutErrorLine(0, Result, D, da_Car, _Change, "㦥  拉  楫 室. ⥫ " + FLDTOSTR(Dtwo.TSN) + ",  " + FLDTOSTR(Dtwo.ExitClss));
       END;
      END;
     END;
    END; (* IF SELECT(Dtwo, DBoxNbr, D, Result) ... *)
   END; (* IF ~!Result *)
  ELSE
   Result:=NeverFixing;
  END;
  RETURN Result;
 END {m_GF_BoxNbr};

 PRIVATE PROCEDURE m_GF_CooTSN(D: DATE; _ExitClss: STRING[]; _Change: LIKE(Dtwo.Change)): STRING[];

  VAR
   _Value : STRING[];
   i      : NUMERIC[0];
   Result : STRING[];
   cooWhat: L_BegRWS.tDayType;
   cooTSN : LIKE(Staff.TSN);
 BEGIN
  Result:=NeverFixing;
  IF Mtwo.Who = who_Driver THEN
   IF L_BegRWS.E_GuardFixedByDriver(D) THEN
    SETEMPTY(Result);
    _Value:=P_Staff.GetP_FixedGuard(GetTrueTSN(Mtwo.TSN, D), D);
    i:=0;
    WHILE ~!L_Prop.getRecordElement(_Value, i) DO
     INC(i);
    END;
    WHILE (i > 0) & !Result DO
     DEC(i);
     Result:=L_Prop.getRecordElement(_Value, i);
     Result:=intCheckValidity(i=0, D, da_Guard, Result, _Change, 1);
     IF ~!Result THEN
      SAVE(Mtwo);
      IF SELECT(Mtwo, Who, Mtwo.Per, Who2CooWho(), Result) &
         (Mtwo.Actual | (Mtwo.Source[MSrcIdx(Date2Idx(D), da_What)] = L_BegRWS.twosrc_Operator)) THEN
       cooWhat:=Mtwo.What[Date2Idx(D)];
       cooTSN :=Mtwo.CooTSN[Date2Idx(D)];
      ELSE
       cooWhat:=L_BegRWS.GetDayTypeByRegime(Result, D);
       SETEMPTY(cooTSN);
      END;
      RESTORE(Mtwo);
      IF    ~L_BegRWS.IsWorkDayType(cooWhat) THEN
       IF i = 0 THEN
        PutErrorLine(0, Result, D, da_CooTSN, _Change, "   䨪 'ࠡ'");
       ELSE
        SETEMPTY(Result);
       END;
      ELSIF cooWhat # _Change THEN
       IF i = 0 THEN
        PutErrorLine(0, Result, D, da_CooTSN, cooWhat, "   䨪 㣠 ᬥ");
       ELSE
        SETEMPTY(Result);
       END;
      ELSIF ~!cooTSN & (cooTSN # Mtwo.TSN) THEN
       IF i > 0 THEN
        SETEMPTY(Result);
       END;
      END;
     END;
    END; (* WHILE (i > 0) ... *)
   END;
  ELSIF Mtwo.Who = who_Guard THEN
   IF L_BegRWS.E_GuardFixedByDriver(D) THEN
    Result:=GetDrvTSN(Mtwo.TSN, Mtwo.Who, D);
    IF ~!Result & !CheckValidity(0, D, da_Driver, Result, _Change) THEN
     Result:=GetSubstTSN(Result, D);
    END;
    IF ~!Result THEN
     Result:=CheckValidity(1, D, da_Driver, Result, _Change);
     IF ~!Result THEN
      SAVE(Mtwo);
      IF SELECT(Mtwo, Who, Mtwo.Per, Who2CooWho(), Result) &
         (Mtwo.Actual | (Mtwo.Source[MSrcIdx(Date2Idx(D), da_What)] = L_BegRWS.twosrc_Operator)) THEN
       cooWhat:=Mtwo.What[Date2Idx(D)];
       cooTSN :=Mtwo.CooTSN[Date2Idx(D)];
      ELSE
       cooWhat:=L_BegRWS.GetDayTypeByRegime(Result, D);
       SETEMPTY(cooTSN);
      END;
      RESTORE(Mtwo);
      IF    ~L_BegRWS.IsWorkDayType(cooWhat) THEN
       PutErrorLine(0, Result, D, da_CooTSN, _Change, " ⥫  䨪 'ࠡ'");
      ELSIF cooWhat # _Change THEN
       PutErrorLine(0, Result, D, da_CooTSN, cooWhat, " ⥫  䨪 㣠 ᬥ");
      ELSIF ~!cooTSN & (cooTSN # Mtwo.TSN) THEN
       SETEMPTY(Result);
      END;
     END;
    END;
   END;
  END;
  RETURN Result;
 END {m_GF_CooTSN};

 PRIVATE PROCEDURE m_FillSingleDayByFixing(_What: L_BegRWS.tDayType; D: DATE);
  VAR
   _ExitClss,
   _BoxNbr,
   _CooTSN    : STRING[];
   Idx        : NUMERIC[0];
 BEGIN
  Idx:=Date2Idx(D);
  IF m_ReplacableSource(Idx, da_ExitClss, L_BegRWS.twosrc_Regime) THEN
   _ExitClss:=m_GF_ExitClss(D, _What, 1);
  ELSE
   SETEMPTY(_ExitClss);
  END;
  IF m_ReplacableSource(Idx, da_Car, L_BegRWS.twosrc_Regime) THEN
   _BoxNbr:=m_GF_BoxNbr(D, _ExitClss, _What);
  ELSE
   SETEMPTY(_BoxNbr);
  END;
  IF m_ReplacableSource(Idx, da_CooTSN, L_BegRWS.twosrc_Regime) THEN
   _CooTSN:=m_GF_CooTSN(D, _ExitClss, _What);
   IF    Mtwo.Who = who_Driver THEN
    IF !_CooTSN & E_HasFixing(D, who_Guard, da_ExitClss) THEN
     _CooTSN:=NeverFixing;
    END;
   ELSIF Mtwo.Who = who_Guard THEN
    IF ~!_ExitClss THEN
     _CooTSN:=NeverFixing;
    END;
    IF ~m_ReplacableSource(Idx, da_ExitClss, L_BegRWS.twosrc_Regime) THEN
     _CooTSN:=NeverFixing;
    END;
   END;
  ELSE
   SETEMPTY(_CooTSN);
  END;
  m_FillSingleDay(_What,
                  L_BegRWS.twosrc_Regime,
                  _ExitClss,
                  _CooTSN,
                  _BoxNbr,
                  Idx);
 END {m_FillSingleDayByFixing};

 PUBLIC PROCEDURE m_FillPeriod(B, E: DATE; _Source: L_BegRWS.tSource; forcedWhat: L_BegRWS.tDayType);
  VAR
   Idx      : NUMERIC[0];
   D        : DATE;
   _What    : L_BegRWS.tDayType;
 BEGIN
  APP.Get().NewPrompt(" ப 筮 鸞");
  IF _Source # L_BegRWS.twosrc_System THEN
   D:=Math.Max(B, FirstModifiableDay());
  ELSE
   D:=B;
  END;
  Idx:=Date2Idx(D);
  WHILE D <= E DO
   PROMPT("⭨ " + Mtwo.TSN + " (" + L_DatTim.DateStr(D) + ")");
   IF !forcedWhat THEN
    _What:=L_BegRWS.GetDayTypeByRegime(GetTrueTSN(Mtwo.TSN, D), D);
   ELSE
    _What:=forcedWhat;
   END;
   IF ~IsNormalSheet(Mtwo.TSN, D) THEN
    m_FillSingleDay(L_BegRWS.dt_Absence, L_BegRWS.twosrc_System, "", "", "", Idx);
   ELSE
    TRY
     IF m_ReplacableSource(Idx, da_What, _Source) THEN
      IF ~L_BegRWS.IsWorkDayType(_What) THEN
       m_FillSingleDay(_What, _Source, "", "", "", Idx);
      ELSE
       IF L_BegRWS.IsWorkDayType(Mtwo.What[Idx]) & (_What # Mtwo.What[Idx]) & (_Source = L_BegRWS.twosrc_Regime) THEN
        m_FillSingleDay(L_BegRWS.dc_NotWork, L_BegRWS.twosrc_Regime, "", "", "", Idx);
       END;
       m_FillSingleDayByFixing(_What, D);
      END;
     ELSIF L_BegRWS.IsWorkDayType(Mtwo.What[Idx]) THEN
      m_FillSingleDayByFixing(Mtwo.What[Idx], D);
     END;
    EXCEPT
    ON Exc: Exc_Raise DO
     IF Str.Pos(Exc.MsgOriginalText, RWaySAlreadyDone) = Str.Length(Exc.MsgOriginalText) THEN
      RAISE();
     END;
    END; (* TRY *)
   END;
   INC(D);
   INC(Idx);
  END; (* WHILE D <= E ... *)
 END {m_FillPeriod};

 PRIVATE PROCEDURE RenovateSingleTSN(P: DATE; _TSN: LIKE(Staff.TSN));
  VAR
   Who      : tTWOWho[31];
   D, B,
   E, PE    : DATE;
   _Who     : LIKE(Mtwo.Who);
 BEGIN
  L_General.CallUs(SEARCH(Staff, TSN, _TSN));
  SETEMPTY(Who, curRnvTSN);
  PE:=L_DatTim.MonthEnd(P);
  IF L_Env.RealTSN(Staff.TSN) & L_Staff.InStateInPer(P, PE) THEN
   L_Staff.PosToStaffLog(Staff.TSN, Math.Max(Staff.BegDate, P), 1);
   WHILE OCCURE(StaffLog) & (StaffLog.Date <= PE) DO
    IF ~L_Staff.IsDischargeStaffLog() THEN
     CONFORM(StaffLog, Officer);
     CONFORM(StaffLog, Sort);
     B:=Math.Max(P, StaffLog.Date);
     _Who:=E_Mtwo_Who(B);
     IF ~!_Who THEN
      IF ~SELECT(Mtwo, Who, P, _Who, Staff.TSN) THEN
       Insert_Mtwo(Staff.TSN, _Who, P);
      END;
      E:=Math.Min(PE, StaffLog.DateE);
      D:=B;
      WHILE D <= E DO
       Who[L_DatTim.DAY(D)-1]:=_Who;
       INC(D);
      END;
      m_FillPeriod(B, E, L_BegRWS.twosrc_Regime, EMPTYOF(L_BegRWS.tDayType));
     END;
    END; (* IF ~L_Staff.IsDischargeStaffLog()...*)
    NEXT(StaffLog);
   END; (* WHILE OCCURE(StaffLog) ... *)
  END;
  SELECT(Mtwo, TSN, , _TSN, P);
  WHILE OCCURE(Mtwo) DO
   SETZERO(Mtwo.asTimDone);
   D:=P;
   LOOP
    WHILE (D <= PE) & (Who[L_DatTim.DAY(D)-1] = Mtwo.Who) DO
     m_AddTimDone(Date2Idx(D));
     INC(D);
    END;
    IF D <= PE THEN
     B:=D;
     WHILE (D <= PE) & (Who[L_DatTim.DAY(D)-1] # Mtwo.Who) DO
      INC(D);
     END;
     E:=Math.Min(D-1, PE);
     m_FillPeriod(B, E, L_BegRWS.twosrc_System, L_BegRWS.dt_NotInState);
     IF (B = P) & (E = PE) THEN
      CONFORM(Mtwo, Staff);
      D:=B;
      WHILE D <= E DO
       IF L_Staff.rInState(D) & L_BegRWS.AccessDayTypeByRegime(Mtwo.TSN, D) & !E_Mtwo_Who(D) THEN
        PutErrorLine(1, Mtwo.TSN, D, Who2DA(), L_BegRWS.dt_Absence, "  ⢮  拉,   ᮯ⠢ ᯥ樠 䨪");
        RETURN;
       END;
       INC(D);
      END;
      TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
       _Who:=Mtwo.Who;
       REMOVE(Mtwo);
       IF _Who = who_Guard THEN
        SELECT(Dtwo, DGuardTSN);
       ELSE
        SELECT(Dtwo, DTSN);
       END;
       SRCINSEL(Dtwo, GE, , P);
       WHILE OCCURE(Dtwo) & (Dtwo.Date <= PE) DO
        NARROWSEL(Dtwo, Date);
        IF SRCINSEL(Dtwo, GE, Staff.TSN) & ((_Who = who_Guard ) & (Dtwo.GuardTSN = Staff.TSN)|
                                            (_Who = who_Driver) & (Dtwo.TSN      = Staff.TSN)) THEN
         L_General.CallUs(0);
        END;
        NEXTINEXTENDEDSEL(Dtwo, Date);
       END;
      EXCEPT
      ON Exc: Exc_RunTime DO
       IF Exc.ErrorCode = L_General.ec_rt_RecordIsInEdIns THEN
        L_General.Error(" ᭠砫 믮  ப 筮 鸞 ࠡ⭨ " + Mtwo.TSN);
       ELSE
        RAISE();
       END;
      END; (* TRY *)
      EXIT;
     END;
    ELSE
     Mtwo.Actual :=1;
     Mtwo.fBoxNbr:=m_c_GetFixedBoxNbr(Mtwo.TSN, Mtwo.Who, Math.Max(Mtwo.Per, Math.Min(L_DatTim.MonthEnd(Mtwo.Per), SYSDATE())));
     m_c_FillSort();
     REPLACE(Mtwo);
     NEXT(Mtwo);
     EXIT;
    END;
   END; (* LOOP *)
  END; (* WHILE OCCURE(Mtwo) ... *)
 END {RenovateSingleTSN};

 PRIVATE PROCEDURE Renovate_Finish(Exc: Exc_Root);
  VAR
   _rnvMode: tRenovateMode;
 BEGIN
  _rnvMode:=rnvMode;
  IF rnvErrorCnt > 0 THEN
   SETEMPTY(rnvMode);
   rnvErrorCnt:=0;
   IF ~!Exc THEN
    MAKEPART(R, md_MsgLine, "믮 樨 ࢠ: " + Exc.Description);
   END;
   MAKEPART(R, md_Bot);
   CLOSEREP(R);
   IF ~L_General.BatchExecution_IsRunning() THEN
    IF (_rnvMode # rm_AutoM) & (_rnvMode # rm_AutoD) & (_rnvMode # rm_SingleMtwoDay) THEN
     IF ~!Exc THEN
      L_StdFrm.RedInform(Exc.MsgOriginalText);
     END;
     IF _rnvMode # rm_Initial THEN
      L_General.SurveyLastReport();
     END;
    ELSE
     L_StdFrm.Inform(" ஡  鸞. .  (AltF3)");
    END;
   END;
  ELSE
   SETEMPTY(rnvMode);
   MAKEPART(R, md_MsgLine, " 믮  訡");
   MAKEPART(R, md_Bot);
   CLOSEREP(R);
  END;
 END {Renovate_Finish};

 PRIVATE PROCEDURE RenovateExits(BPer, EPer: DATE);
  VAR
   D            : DATE;
   ExitsToRemove: LIKE(Dtwo.Dtwo)[2048];
   i            : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("  室");
  D:=BPer;
  WHILE D <= EPer DO
   i:=0;
   SELECT(Dtwo, DExitClss, , D);
   WHILE OCCURE(Dtwo) DO
    TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
     PROMPT(L_DatTim.DateStr(D) + " " + Dtwo.Dtwo);
     d_c_FillDependent();
     IF ~!Dtwo.ExitClss & P_Firm.IsAllowedMyPF(Dtwo.MyFirm, Dtwo.MyPlace) THEN
      IF ~StandOnExit(Dtwo.ExitClss, Dtwo.Change, D, 0) THEN
       ExitsToRemove[i]:=Dtwo.Dtwo;
       INC(i);
      ELSIF StExit.Strict = L_Way.ExitStrict_Reg THEN
       CHANGESEL(Dtwo, DExitClss, , D, Dtwo.ExitClss, Dtwo.Change);
       WHILE NEXT(Dtwo) DO
        ExitsToRemove[i]:=Dtwo.Dtwo;
        INC(i);
       END;
       LAST(Dtwo);
       CHANGESEL(Dtwo, DExitClss, , D);
      END;
     END; (* IF P_Firm.IsAllowedMyPF ... *)
    EXCEPT
    ON Exc: Exc_Root DO
     D_PutErrorLine(da_ExitClss, Exc.Description);
    END;
    NEXT(Dtwo);
   END; (* WHILE OCCURE(Dtwo) *)
   WHILE i > 0 DO DEC(i);
    r_Access(D, ExitsToRemove[i]);
    IF rnvMode # rm_Initial THEN
     D_PutErrorLine(da_ExitClss, "㤠");
    END;
    Dtwo.Source[DSrcIdx(da_ExitClss)]:=L_BegRWS.twosrc_Regime;
    d_c_SetAttr(da_ExitClss, "");
    REPLACE(Dtwo);
    d_c_FillDependent();
    IF d_c_IsEmpty() THEN
     d_c_Remove();
    END;
   END; (* WHILE i > 0 *)
   INC(D);
  END; (* WHILE D <= ... *)
 END {RenovateExits};

 PRIVATE PROCEDURE FillFreeExits(BPer, EPer: DATE);
  VAR
   D            : DATE;
   trgSort      : LIKE(Sort.Sort);
   trgMyFirm    : P_Firm.tMyFirm;
   trgMyPlace   : P_Firm.tMyPlace;
 BEGIN
  APP.Get().NewPrompt("  室");
  SELECT(StExit, Strict, , L_Way.ExitStrict_Reg);
  SRCINSEL(StExit, GE, , BPer);
  WHILE OCCURE(StExit) DO
   D:=BPer;
   WHILE D <= EPer DO
    PROMPT(L_DatTim.DateStr(D) + " " + StExit.ExitClss);
    trgSort:=L_Way.E_GetFixedSortOfExit(StExit.Exit, D, EMPTYOF(L_Way.tRWSWho));
    IF ~!trgSort THEN
     SEARCH(Sort, Sort, , trgSort);
     trgMyFirm:=Sort.MyFirm;
     trgMyPlace:=P_Sort.GetMyPlace(trgSort, D);
    ELSE
     trgMyFirm :=P_Firm.mf_Fict;
     trgMyPlace:=P_Firm.mp_Fict;
    END;
    IF P_Firm.IsAllowedMyPF(trgMyFirm, trgMyPlace) THEN
     IF ~SELECT(Dtwo, DExitClss, D, StExit.ExitClss, StExit.Change) &
        (L_Way._CheckExitOnDate(StExit.Exit, D) = L_Way.exvld_Active) THEN
      SAVE(StExit);
      d_InsertExit(D, StExit.ExitClss, StExit.Change);
      IF rnvMode # rm_Initial THEN
       D_PutErrorLine(da_ExitClss, "");
      END;
      RESTORE(StExit);
     END;
    END; (* IF P_Firm.IsAllowedMyPF ... *)
    INC(D);
   END;
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit) ... *)
 END {FillFreeExits};

 PUBLIC PROCEDURE E_DriverParticipateRepEvent(D: DATE; RE: LIKE(RepEvent.RepEvent)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_two.DriverParticipateRepEvent);
  IF ~!Local THEN
   RETURN Local(D, RE);
  END;
  RETURN 0;
 END {E_DriverParticipateRepEvent};

 PRIVATE PROCEDURE RenovateCars(BPer, EPer: DATE);
  VAR
   D            : DATE;
   RE           : LIKE(RepEvent.RepEvent)[10];
   EC           : LIKE(ExitClss.ExitClss)[10];
   DrTSN        : LIKE(Dtwo.TSN);
   DtwoToPutEC  : LIKE(Dtwo.Dtwo);
   ExitsToRemove: LIKE(Dtwo.Dtwo)[256];
   i, j,
   FoundIdx     : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" ﭨ ");
  SETEMPTY(curRnvTSN);
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) THEN
    D:=BPer;
    WHILE D <= EPer DO
     IF L_Car.CarIsInOperation(Car.BoxNbr, D)  THEN
      IF (CarLog.InBeg = L_Car.inBeg_Required) &
         P_Firm.IsAllowedMyPF(L_Car.GetCarMyFirm(Car.BoxNbr, D), P_Column.GetMyPlace(CarLog.Column, D)) &
         ~SELECT(Dtwo, DBoxNbr, D, Car.BoxNbr) THEN
       SAVE(Car);
       d_InsertSingleValue(D, da_Car, Car.BoxNbr, EMPTYOF(Dtwo.Change), L_BegRWS.twosrc_Regime);
       IF rnvMode # rm_Initial THEN
        D_PutErrorLine(da_Car, "");
       END;
       RESTORE(Car);
      END;

      IF L_EC.ExecE_Func_Scal2(D, PROCREF(E_two.FillFromCarEvn), 0) &
         SELECT(Dtwo, DBoxNbr, D, Car.BoxNbr) THEN
       E_two.GetFillFromCarEvnParams(D, RE, EC, 1);
       i:=0;
       SETEMPTY(FoundIdx);
       WHILE ~!RE[i] DO
        IF L_Car.HasRepEventOnDate(Car.BoxNbr, RE[i], D) THEN
         IF ~!FoundIdx THEN
          L_General.Error(" " + Car.BoxNbr + "  " + L_DatTim.DateStr(D) +
                          "  ६ ய " + RE[i] + "  " + RE[FoundIdx]);
         END;
         FoundIdx:=i;
        END;
        INC(i);
       END;
       IF ~!FoundIdx THEN
        PositionOnExit(EC[FoundIdx], "", D);
        IF ~SELECT(Dtwo, DBoxNbr, D, Car.BoxNbr, StExit.Change, EC[FoundIdx]) THEN
         SETEMPTY(DtwoToPutEC, DrTSN);
         SELECT(Dtwo, DBoxNbr, , D, Car.BoxNbr);
         WHILE OCCURE(Dtwo) DO

          NEXT(Dtwo);
          SAVE(Dtwo); (*   १ NEXT- ࠭, .. 㤥  祢  *)
          IF OCCURE(Dtwo) THEN
           PREV(Dtwo);
          ELSE
           LAST(Dtwo);
          END;

          PositionOnExit(EC[FoundIdx], "", D);
          IF !DtwoToPutEC & ((StExit.Change = 0) | !Dtwo.Change | (Dtwo.Change = StExit.Change)) THEN
           IF (!Dtwo.TSN | E_DriverParticipateRepEvent(D, RE[FoundIdx])) & !Dtwo.GuardTSN & !Dtwo.ExitClss THEN
            DtwoToPutEC:=Dtwo.Dtwo;
           ELSE
            IF Dtwo.Source[DSrcIdx(da_Car)] # L_BegRWS.twosrc_Operator THEN
             d_c_SetAttr(da_Car, "");
             REPLACE(Dtwo);
             d_c_FillDependent();
             IF ~!Dtwo.GuardTSN THEN
              ObtainMtwo(Dtwo.GuardTSN, who_Guard, L_DatTim.Per(Dtwo.Date));
              d_c_UpdateSingleMtwo(Mtwo.Mtwo, who_Guard, Dtwo.GuardTSN, L_BegRWS.twosrc_Regime);
             END;
             IF ~!Dtwo.TSN THEN
              IF !DrTSN & E_DriverParticipateRepEvent(D, RE[FoundIdx]) THEN
               DrTSN:=Dtwo.TSN;
               d_c_SetAttr(da_Driver, "");
               REPLACE(Dtwo);
               d_c_FillDependent();
              ELSE
               ObtainMtwo(Dtwo.TSN, who_Driver, L_DatTim.Per(Dtwo.Date));
               d_c_UpdateSingleMtwo(Mtwo.Mtwo, who_Driver, Dtwo.TSN, L_BegRWS.twosrc_Regime);
              END;
             END;
            ELSE
             D_PutErrorLine(da_Car, "  ஢ 室,  ᮮ⢥騩 ய");
            END; (*IF Dtwo.Source[DSrcIdx(da_Car)] # L_BegRWS.twosrc_Operator*)
           END; (*IF !Dtwo.TSN & !Dtwo.GuardTSN*)
          END (*IF (StExit.Change = 0) | !Dtwo.Change | (Dtwo.Change = StExit.Change)*);
          RESTORE(Dtwo);
         END; (* WHILE OCCURE(Dtwo) ... *)

         PositionOnExit(EC[FoundIdx], "", D);
         IF ~!DtwoToPutEC THEN
          SEARCH(Dtwo, Dtwo, , D, DtwoToPutEC);
          d_c_SetAttr(da_What, StExit.Change);
         ELSE
          d_InsertSingleValue(D, da_Car, Car.BoxNbr, StExit.Change, L_BegRWS.twosrc_Regime);
          IF E_DriverParticipateRepEvent(D, RE[FoundIdx]) THEN
           d_c_SetAttr(da_Driver, DrTSN);
          END;
         END;
         d_c_SetAttr(da_ExitClss, EC[FoundIdx]);
         REPLACE(Dtwo);
         d_c_FillDependent();
         IF ~!Dtwo.TSN THEN
          ObtainMtwo(Dtwo.TSN, who_Driver, L_DatTim.Per(Dtwo.Date));
          d_c_UpdateSingleMtwo(Mtwo.Mtwo, who_Driver, Dtwo.TSN, L_BegRWS.twosrc_Regime);
         END;
        END; (*IF ~SELECT(Dtwo, DBoxNbr, D, Car.BoxNbr, StExit.Change, EC[FoundIdx])*)
       END; (* IF ~!FoundIdx ... *)
      END; (* L_EC.ExecE_Func_Scal2(D, PROCREF(E_two.FillFromCarEvn), 0) *)
     ELSE
      WHILE SELECT(Dtwo, DBoxNbr, D, Car.BoxNbr) DO
       IF rnvMode # rm_Initial THEN
        D_PutErrorLine(da_Car, "㤠");
       END;
       Dtwo.Source[DSrcIdx(da_Car)]:=L_BegRWS.twosrc_Regime;
       d_c_SetAttr(da_Car, "");
       REPLACE(Dtwo);
       d_c_FillDependent();
      END; (* WHILE SELECT ... *)
     END; (* IF L_Car.CarIsInOperation ... *)
     INC(D);
    END;
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)

  D:=BPer;
  WHILE D <= EPer DO
   IF L_EC.ExecE_Func_Scal2(D, PROCREF(E_two.FillFromCarEvn), 0) THEN
    j:=0;
    E_two.GetFillFromCarEvnParams(D, RE, EC, 0);
    i:=0;
    WHILE ~!EC[i] DO
     SELECT(Dtwo, DExitClss, , D, EC[i]);
     WHILE OCCURE(Dtwo) DO
      IF ~!Dtwo.BoxNbr & ~L_Car.HasRepEventOnDate(Dtwo.BoxNbr, RE[i], D) THEN
       IF Dtwo.Source[DSrcIdx(da_ExitClss)] # L_BegRWS.twosrc_Operator THEN
        ExitsToRemove[j]:=Dtwo.Dtwo;
        INC(j);
       ELSE
        D_PutErrorLine(da_Car, "   ய, ᮮ⢥饣 室");
       END;
      END;
      NEXT(Dtwo);
     END; (* WHILE OCCURE(Dtwo) ... *)
     INC(i);
    END;
    WHILE j > 0 DO DEC(j);
     r_Access(D, ExitsToRemove[j]);
     IF rnvMode # rm_Initial THEN
      D_PutErrorLine(da_ExitClss, "㤠.  ய   " + Dtwo.BoxNbr);
     END;
     d_c_SetAttr(da_ExitClss, "");
     REPLACE(Dtwo);
     d_c_FillDependent();
    END; (* WHILE j > 0 *)
   END;
   INC(D);
  END;
 END {RenovateCars};

 PRIVATE PROCEDURE Renovate_NotActual(P: DATE; misTSN1, misTSN2: LIKE(Mtwo.TSN));
  VAR
   nxtTSN: LIKE(Staff.TSN);
 BEGIN
  APP.Get().NewPrompt(" 㠫 ப 筮 鸞");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  SELECT(Mtwo, Actual, , P, 0);
  WHILE OCCURE(Mtwo) DO
   nxtTSN:=Mtwo.TSN + 1;
   IF (Mtwo.TSN # misTSN1) & (Mtwo.TSN # misTSN2) THEN
    TRY [TRANSACTION(TRANSACTION_SLAVE), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     IF OCCURE(Mtwo) (* 0096491 *) THEN
      RenovateSingleTSN(Mtwo.Per, Mtwo.TSN);
     END;
    EXCEPT
    ON Exc: Exc_Root DO
     IF Exc.ErrorCode # L_General.ec_rt_LockedByMainASL THEN
      PutErrorLine(0, Mtwo.TSN, Mtwo.Per, Who2DA(), EMPTYOF(SCAL[10]), Exc.Description);
     END;
    END; (* TRY *)
   END;
   SELECT(Mtwo, Actual, , P, 0);
   SRCINSEL(Mtwo, GE, , nxtTSN);
  END; (* WHILE OCCURE(Mtwo) ... *)
 END {Renovate_NotActual};

 PUBLIC PROCEDURE NeedBuildRWaySByDtwo(): SCAL[2];
 BEGIN
  RETURN ~!Dtwo.ExitClss &
         ~L_Way.IsExitClasswERKN(Dtwo.ExitClss, L_Way.erkn_ec_OtherDayOfWork) &
         (~!Dtwo.TSN | ~!Dtwo.BoxNbr | ~!Dtwo.GuardTSN |
          IsStrictExitClss(Dtwo.ExitClss, Dtwo.Change, Dtwo.Date));
 END {NeedBuildRWaySByDtwo};

 PUBLIC PROCEDURE CheckUninterruptedWork(    D          : DATE;
                                             _TSN       : LIKE(Staff.TSN);
                                             _Who       : tTWOWho;
                                             MaxTime    : FLOAT;
                                         VAR Description: STRING[]): SCAL[2];
  VAR
   Time,
   WorkTime: FLOAT;
   Index   : STRING[];
 BEGIN
  IF !_TSN | ~L_Env.RealTSN(_TSN) THEN
   RETURN 1;
  ELSE
   WorkTime:=0;
   SAVE(Dtwo);
   IF    _Who = who_Guard  THEN
    Index:="DGuardTSN";
   ELSIF _Who = who_Driver THEN
    Index:="DTSN";
   END;
   WHILE SELECT(Dtwo, ^Index, D-1, _TSN) DO
    DEC(D);
   END;
   Description:="";
   WHILE SELECT(Dtwo, ^Index, D, _TSN) DO
    WHILE OCCURE(Dtwo) DO
     IF ~!Dtwo.EndTime THEN
      Time:=Dtwo.EndTime - Dtwo.BegTime;
      IF StandOnExit(Dtwo.ExitClss, Dtwo.Change, Dtwo.Date, 0) & (StExit.Strict = L_Way.ExitStrict_Reg) THEN
       DEC(Time, StExit.RestT);
      END;
      INC(WorkTime, Time);
      Description:=Description + "|" + L_DatTim.DateStr(D) + " " + FLDTOSTR(Time, "3.", 6);
     END;
     NEXT(Dtwo);
    END; (* WHILE OCCURE(Dtwo) ... *)
    INC(D);
   END;
   Description:=Description + "|=================|⮣      " + FLDTOSTR(WorkTime, "3.", 6);
   RESTORE(Dtwo);
   RETURN WorkTime <= MaxTime;
  END;
 END {CheckUninterruptedWork};

 PUBLIC PROCEDURE CheckRestTime(    D     : DATE;
                                    trgTSN: LIKE(Staff.TSN);
                                    trgWho: tTWOWho;
                                    Dir   : NUMERIC[0];
                                VAR Result: L_BegRWS.tCrewFitnessForExit;
                                VAR Reason: STRING[]);
  VAR
   rp,
   nrp,
   mrp     : NUMERIC[3];
   What    : L_BegRWS.tDayType;
   ExitClss: LIKE(ExitClss.ExitClss);
   Time    : LTIME;
 BEGIN
  Result:=L_BegRWS.cffe_Yes;
  Reason:="";

  SAVE(Mtwo);
  SAVE(Dtwo);
  SELECT(Mtwo, Who, , L_DatTim.MonthBeg(D), trgWho, trgTSN);
  AccessDtwoByMtwo(Date2Idx(D));
  IF ~!Dtwo.ExitClss THEN
   E_RestPeriod(D, Dtwo.Sort, trgWho, nrp, mrp);
   ObtainTSNEnvironment(trgTSN, trgWho, D, What, ExitClss, Time, Dir);
   IF ~!Time THEN
    IF Dir = -1 THEN
     rp:=(L_Way.FullBegTime(02 + (Dtwo.BegDay-1), C_L2T(Dtwo.BegTime)) - L_Way.FullBegTime(01 + C_L2D(Time)-1, C_L2T(Time)));
     IF    rp < mrp THEN
      Result:=L_BegRWS.cffe_wCrucialChoice;
      Reason:="६  ᫥ 譥   " + FLDTOSTR(mrp, "1.", 0);
     ELSIF rp < nrp THEN
      Result:=L_BegRWS.cffe_wChoice;
      Reason:="६  ᫥ 譥   " + FLDTOSTR(nrp, "1.", 0);
     END;
    ELSE
     rp:=(L_Way.FullBegTime(02 + C_L2D(Time)-1, C_L2T(Time)) - L_Way.FullEndTime(Dtwo.BegDay, Dtwo.BegTime, Dtwo.EndTime));
     IF    rp < mrp THEN
      Result:=L_BegRWS.cffe_wCrucialChoice;
      Reason:="६  । 譨   " + FLDTOSTR(mrp, "1.", 0);
     ELSIF rp < nrp THEN
      Result:=L_BegRWS.cffe_wChoice;
      Reason:="६  । 譨   " + FLDTOSTR(nrp, "1.", 0);
     END;
    END;
   END;
  END;
  IF ~!Reason THEN
   Reason:=L_Str.PoolItem(who_Pool, trgWho) + " " + trgTSN + ", " + L_DatTim.DateStr(D) + ":||" + Reason;
  END;
  RESTORE(Dtwo);
  RESTORE(Mtwo);
 END {CheckRestTime};

 PUBLIC PROCEDURE RenovateDaily(D: DATE);
  VAR
   Choice      : NUMERIC[0];
   Dummy       : STRING[];
   InState,
   doNext      : SCAL[2];
 BEGIN
  APP.Get().NewPrompt(" 筮 鸞  " + L_DatTim.DateStr(D));
  L_General.CallUs(D = Memo.ud_cd());
  Choice:=L_StdFrm.ShowListAsMenu("쪮 |  ஢ઠ", " 롮 ᯮᮡ  ");

  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  TABLE.Get("Dtwo").AccessDataMode :=adm_SOFT;
  RenovateExits(D, D);

  TABLE.Get("Dtwo").AccessDataMode :=adm_RIDGE;
  FillFreeExits(D, D);

  RenovateCars(D, D);

  SELECT(Mtwo, Per, , L_DatTim.Per(D));
  WHILE OCCURE(Mtwo) DO
   IF P_Firm.IsAllowedMyPF(Mtwo.MyFirm, Mtwo.MyPlace) THEN
    SAVE(Mtwo);
    TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
     SETEMPTY(curRnvTSN);
     CONFORM(Mtwo, Staff);
     InState:=0;
     IF L_Staff.rInState(D) THEN
      CONFORM(StaffLog, Officer);
      InState:=~!E_Mtwo_Who(D);
     END;
     IF InState THEN
      m_FillPeriod(D, D, L_BegRWS.twosrc_Regime, EMPTYOF(L_BegRWS.tDayType));
     ELSE
      m_FillPeriod(D, D, L_BegRWS.twosrc_System, L_BegRWS.dt_NotInState);
     END;
    EXCEPT
    ON Exc: Exc_Root DO
     SETEMPTY(Dummy);
     PutErrorLine(0, Dummy, D, da_Driver, EMPTYOF(L_BegRWS.tDayType), Exc.Description);
    END; (* TRY *)
    RESTORE(Mtwo);
   END;
   NEXT(Mtwo);
  END; (* WHILE OCCURE(Mtwo) ... *)

  RENEWDATALAYER();

  RenovateCars(D, D);

  TABLE.Get("Dtwo").AccessDataMode :=adm_SOFT;
  SELECT(Dtwo, Dtwo, , D);
  WHILE OCCURE(Dtwo) DO
   PROMPT(L_Str.IntStr(Dtwo.Dtwo));
   doNext:=1;
   TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    d_c_FillDependent();
    IF P_Firm.IsAllowedMyPF(Dtwo.MyFirm, Dtwo.MyPlace) THEN
     IF d_c_IsEmpty() THEN
      L_General.CallUs((!Dtwo.ExitClss | !Dtwo.BoxNbr) & !Dtwo.TSN & !Dtwo.GuardTSN);
      IF    ~!Dtwo.BoxNbr   THEN D_PutErrorLine(da_Car, "㤠");
      ELSIF ~!Dtwo.ExitClss THEN D_PutErrorLine(da_ExitClss, "㤠");
      END;
      d_c_Remove();
      doNext:=0;
     ELSIF ~!Dtwo.GuardTSN & !Dtwo.TSN & !Dtwo.ExitClss & !Dtwo.BoxNbr &
           (~SELECT(Mtwo, Who, L_DatTim.Per(Dtwo.Date), who_Guard, Dtwo.GuardTSN) | (Mtwo.What[Date2Idx(Dtwo.Date)] # Dtwo.Change)) THEN
      (* 0072906 *)
      D_PutErrorLine(da_Guard, "㤠 (㡫)");
      d_c_Remove();
      doNext:=0;
     END;
    END; (* IF P_Firm.IsAllowedMyPF ... *)
   EXCEPT
   ON Exc: Exc_Root DO
    D_PutErrorLine(da_ExitClss, Exc.Description);
   END; (* TRY *)
   IF doNext THEN
    NEXT(Dtwo);
   END;
  END; (* WHILE OCCURE(Dtwo) ... *)
  IF Choice = 1 THEN
   IF rnvErrorCnt > 0 THEN
    MAKEPART(R, md_Bot);
   END;
   TABLE.Get("RWayS"  ).AccessDataMode:=adm_RIDGE;
   TABLE.Get("WayLMen").AccessDataMode:=adm_RIDGE;
   TABLE.Get("RWayTxt").AccessDataMode:=adm_RIDGE;
   MAKEPART(R, DRnv_Top, GetRnvReportName(), D);
   SELECT(Dtwo, Dtwo, , D);
   WHILE OCCURE(Dtwo) DO
    PROMPT("஢ઠ " + L_Str.IntStr(Dtwo.Dtwo));
    IF P_Firm.IsAllowedMyPF(Dtwo.MyFirm, Dtwo.MyPlace) THEN
     IF NeedBuildRWaySByDtwo() THEN
      TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
       DtwoBindRWayS();
       L_General.RaiseLockReleaseException();
      EXCEPT
      ON Exc: Exc_Raise DO
       IF ~L_General.IsLockReleaseException(Exc) THEN
        DRnv_PutErrorLine(Exc);
        INC(rnvErrorCnt);
       END;
      END; (* TRY *)
     END; (* IF NeedBuildRWaySByDtwo() *)
    END;
    NEXT(Dtwo);
   END; (* WHILE OCCURE(Dtwo) ... *)
  END;
 END {RenovateDaily};

 PRIVATE PROCEDURE RenovateMtwoByDtwo(trgWho: tTWOWho);
  VAR
   trgTSN: LIKE(Staff.TSN);
 BEGIN
  IF    (trgWho = who_Driver) & ~!Dtwo.TSN      THEN trgTSN:=Dtwo.TSN;
  ELSIF (trgWho = who_Guard ) & ~!Dtwo.GuardTSN THEN trgTSN:=Dtwo.GuardTSN;
  ELSE                                                     SETEMPTY(trgTSN);
  END;
  IF ~!trgTSN THEN
   StandOnMtwo(trgTSN, trgWho, L_DatTim.Per(Dtwo.Date));
   IF ~Mtwo.Actual THEN
    FIXALTERING();
    SAVE(Dtwo);
    RenovateSingleTSN(L_DatTim.Per(Dtwo.Date), trgTSN);
    RESTORE(Dtwo);
  END;
  END;
 END {RenovateMtwoByDtwo};

 PUBLIC PROCEDURE Renovate(D: DATE; Mode: tRenovateMode);
  VAR
   P,
   BPer        : DATE;
   curTSN      : LIKE(Staff.TSN);
 BEGIN
  rnvMode    :=Mode;
  OPENREP(R, L_General.NameConnection(GetRnvReportName()), Create);
  rnvErrorCnt:=0;
  P   :=L_DatTim.Per(D);
  BPer:=Math.Max(P, FirstModifiableDay());
  TRY
   MAKEPART(R, md_Top, GetRnvReportName(), D);
   IF rnvMode = rm_Initial THEN
    L_StdFrm.Question("믮 ࢮ砫쭮  筮 鸞  " + L_DatTim.PeriodStr(P));
    SELECT(Staff, TSN);
    WHILE OCCURE(Staff) DO
     PROMPT(Staff.TSN);
     SAVE(Staff);
     RenovateSingleTSN(P, Staff.TSN);
     RESTORE(Staff);
     NEXT(Staff);
    END; (* WHILE OCCURE(Staff) ... *)

    RenovateExits(BPer, L_DatTim.MonthEnd(P));
    FillFreeExits(BPer, L_DatTim.MonthEnd(P));
    RenovateCars(BPer, L_DatTim.MonthEnd(P));
   ELSIF rnvMode = rm_Single THEN
    curTSN:=Mtwo.TSN;
    RenovateSingleTSN(P, curTSN);
    IF ~SELECT(Mtwo, Per, P, curTSN) THEN
     L_StdFrm.Question("⭨ " + curTSN + " 㤥  ᪫祭  鸞");
    ELSE
     TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
      SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), Mtwo);
     EXCEPT
     ON Exc: Exc_RunTime DO
      IF Exc.ErrorCode = L_General.ec_rt_PosOutOfZoneSystemSelect THEN
       L_StdFrm.Question(" ப 鸞 '祧', ⮬   䨫");
      ELSE
       RAISE;
      END;
     END; (* TRY *)
    END;
   ELSIF rnvMode = rm_AutoM THEN
    IF ~Mtwo.Actual THEN
     FIXALTERING();
     SAVE(Mtwo);
     RenovateSingleTSN(Mtwo.Per, Mtwo.TSN);
     RESTORE(Mtwo);
    END;
    SAVE(Mtwo);
    Renovate_NotActual(P, Mtwo.TSN, EMPTYOF(Mtwo.TSN));
    RESTORE(Mtwo);
   ELSIF rnvMode = rm_AutoD THEN
    RenovateMtwoByDtwo(who_Driver);
    RenovateMtwoByDtwo(who_Guard );
    SAVE(Dtwo);
    Renovate_NotActual(P, Dtwo.TSN, Dtwo.GuardTSN);
    RESTORE(Dtwo);
   ELSIF (rnvMode = rm_NotActual) THEN
    Renovate_NotActual(P, EMPTYOF(Mtwo.TSN), EMPTYOF(Mtwo.TSN));
   ELSIF rnvMode = rm_AllFiltered THEN
    M_ConfirmOnMtwo(" ", 0);
    SELECT(Mtwo, Per, , P);
    WHILE OCCURE(Mtwo) DO
     PROMPT(" 鸞: " + Mtwo.TSN);
     IF m_c_FitToFilter() THEN
      curTSN:=Mtwo.TSN;
      TRY [TRANSACTION(TRANSACTION_SLAVE)]
       RenovateSingleTSN(Mtwo.Per, Mtwo.TSN);
      EXCEPT
      END; (* TRY *)
      SELECT(Mtwo, Per, , P);
      SRCINSEL(Mtwo, GT, , curTSN);
     ELSE
      NEXT(Mtwo);
     END;
    END; (* WHILE OCCURE(Mtwo) ... *)
   ELSIF rnvMode = rm_Exits THEN
    RenovateDaily(D);
   ELSIF rnvMode = rm_SingleMtwoDay THEN
    L_General.CallUs(ACCESS(Mtwo));
    SETEMPTY(curRnvTSN);
    m_FillPeriod(D, D, L_BegRWS.twosrc_Regime, EMPTYOF(L_BegRWS.tDayType));
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   Renovate_Finish(Exc);
   RAISE();
  END; (* TRY *)
  Renovate_Finish(EMPTYOF(Exc_Root));
 END {Renovate};

 PRIVATE PROCEDURE int_m_MarkAsNotActual(_TSN: LIKE(Staff.TSN); P: DATE);
 BEGIN
  IF SELECT(Mtwo, TSN, _TSN) & SRCINSEL(Mtwo, GE, P) THEN
   WHILE OCCURE(Mtwo) DO
    Mtwo.Actual:=0;
    REPLACE(Mtwo);
    NEXT(Mtwo);
   END; (* WHILE OCCURE(Mtwo) ... *)
  END;
 END {int_m_MarkAsNotActual};

 PUBLIC PROCEDURE m_MarkAsNotActual(_TSN: LIKE(Staff.TSN); From, UpTo: DATE);
  VAR
   D,
   P      : DATE;
   trueTSN: LIKE(Staff.TSN);
 BEGIN
  IF UpTo >= FirstModifiableDay() THEN
   P:=L_DatTim.Per(Math.Max(FirstModifiableDay(), From));
   IF L_BegRWS.E_TWOLevel(P) THEN
    int_m_MarkAsNotActual(_TSN, P);
    SAVE(StaffPro);
    D:=L_DatTim.MonthEnd(P);
    WHILE P_Staff.HasStaffPro(_TSN, D, P_Staff.P_SubstitutionInBegRWS) & (StaffPro.EndDate >= P) DO
     trueTSN:=P_Staff.Get_SubstitutionInBegRWS(_TSN, D);
     IF ~!trueTSN THEN
      int_m_MarkAsNotActual(trueTSN, P);
     END;
     D:=StaffPro.Date-1;
    END; (* WHILE WHILE P_Staff.HasStaffPro(_TSN, D, P_Staff.P_SubstitutionInBegRWS) & ... *)
    D:=L_DatTim.MonthEnd(P);
    WHILE P_Staff.AccessBySpdSrchV(P_Staff.P_SubstitutionInBegRWS, _TSN, D) DO
     int_m_MarkAsNotActual(StaffPro.TSN, P);
     D:=StaffPro.Date-1;
    END; (* WHILE SELECT(StaffPro ... *)
    RESTORE(StaffPro);
   END;
  END; (* IF EndDate >= FirstModifiableDay() *)
 END {m_MarkAsNotActual};

 PUBLIC PROCEDURE m_MakeNotActual(P: DATE);
  VAR
   _Who: tTWOWho;
 BEGIN
  P:=Math.Max(L_DatTim.Per(FirstModifiableDay()), P);
  IF L_BegRWS.E_TWOLevel(P) THEN
   TABLE.Get("Mtwo").AccessDataMode:=adm_SOFT;
   IF SELECT(Mtwo, TSN, StaffLog.TSN) & SRCINSEL(Mtwo, GE, P) THEN
    m_MarkAsNotActual(StaffLog.TSN, P, EMPTYOF(DATE));
   END;
   WHILE SELECT(Mtwo, Per, P) DO
    IF ~SELECT(Mtwo, TSN, StaffLog.TSN, P) THEN
     _Who:=E_Mtwo_Who(P);
     IF ~!_Who THEN
      Insert_Mtwo(StaffLog.TSN, _Who, P);
     END;
    END;
    P:=L_DatTim.NextPer(P);
   END; (* WHILE SELECT(Mtwo, Per, P) *)
  END;
 END {m_MakeNotActual};

 PRIVATE TYPE
  tAL = SCAL[4];

 PRIVATE CONST
  alrws_Yes          = 0;
  alrws_OnFictBoxNbr = 1;
  alrws_Conditional  = 2;
  alrws_No           = 3;

  altwo_Yes          = 0;
  altwo_Conditional  = 1;
  altwo_No           = 2;

  alrws_Pool      = "|殮  䨪⨢ ࠦ|᫮ ᢮|";
  altwo_Pool      = "| + 室 |";
  alrws_ShortPool = "|||-";
  altwo_ShortPool = "||-";

 PRIVATE PROCEDURE as_InsRoute(VAR Routes: LIKE(Route.Route)[]; _Route: LIKE(Route.Route));
  VAR
   Idx: NUMERIC[0];
 BEGIN
  Idx:=0;
  WHILE ~!Routes[Idx] DO
   IF Routes[Idx] = _Route THEN
    RETURN;
   END;
   INC(Idx);
  END;
  Routes[Idx]:=_Route;
 END {as_InsRoute};

 PRIVATE PROCEDURE AccessRWaySByTSN(_TSN: LIKE(Staff.TSN); D: DATE): SCAL[2];
  VAR
   realBoxNbr: SCAL[2];
   _RWayS    : LIKE(RWayS.RWayS);
 BEGIN
  SETEMPTY(_RWayS);
  realBoxNbr:=0;
  SELECT(RWayS, TSN, , _TSN, D);
  WHILE OCCURE(RWayS) & ~realBoxNbr DO
   _RWayS:=RWayS.RWayS;
   realBoxNbr:=L_Env.RealBoxNbr(RWayS.BoxNbr);
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  SELECT(WayLMen, TSN, , _TSN, D);
  WHILE OCCURE(WayLMen) & ~realBoxNbr DO
   CONFORM(WayLMen, RWayS);
   _RWayS:=RWayS.RWayS;
   realBoxNbr:=L_Env.RealBoxNbr(RWayS.BoxNbr);
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
  IF ~!_RWayS THEN
   SEARCH(RWayS, RWayS, , _RWayS);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {AccessRWaySByTSN};

 PRIVATE PROCEDURE AccessRWaySByBoxNbr(_BoxNbr: LIKE(Car.BoxNbr); D: DATE): SCAL[2];
 BEGIN
  IF SELECT(RWayS, BoxNbr, _BoxNbr, D) & LAST(RWayS) THEN
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {AccessRWaySByBoxNbr};

 PRIVATE PROCEDURE AvailLevel(Who: L_Way.tRWSWho; D: DATE; curRWayS: LIKE(RWayS.RWayS)): tAL;
  VAR
   twoIdx: NUMERIC[0];
 BEGIN
  twoIdx    :=Date2Idx(D);
  IF ~!curRWayS THEN
   IF    AccessRWaySByTSN(Mtwo.TSN, D) THEN
    IF SEARCH(StExit, Exit, RWayS.Exit) & (StExit.Strict # L_Way.ExitStrict_Reg) THEN
     RETURN alrws_Yes;
    ELSIF L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
     RETURN alrws_No;
    ELSE
     RETURN alrws_OnFictBoxNbr;
    END;
   ELSIF L_BegRWS.IsWorkDayType(Mtwo.What[twoIdx])  THEN RETURN alrws_Yes;
   ELSIF Mtwo.What[twoIdx] = L_BegRWS.dt_Relaxation THEN RETURN alrws_Conditional;
   ELSIF Mtwo.What[twoIdx] = L_BegRWS.dt_NotDefined THEN RETURN alrws_Conditional;
   ELSE                                                   RETURN alrws_No;
   END;
  ELSE
   IF    Mtwo.What[twoIdx] = L_BegRWS.dt_Relaxation THEN RETURN altwo_Conditional;
   ELSIF Mtwo.What[twoIdx] = L_BegRWS.dt_NotDefined THEN RETURN altwo_Conditional;
   ELSE
    IF    Who = L_Way.rwswho_Driver THEN
     IF !Mtwo.ExitClss[twoIdx] | ~IsStrictExitClss(Mtwo.ExitClss[twoIdx], Mtwo.What[twoIdx], D) THEN
      RETURN altwo_Yes;
     ELSE
      RETURN altwo_No;
     END;
    ELSIF Who = L_Way.rwswho_Guard THEN
     IF !Mtwo.ExitClss[twoIdx] | !Mtwo.BoxNbr[twoIdx] | !Mtwo.TSN THEN
      RETURN altwo_Yes;
     ELSE
      RETURN altwo_No;
     END;
    END;
   END;
  END;
 END {AvailLevel};

 PRIVATE PROCEDURE PlayChoose(List, Title, Caption: STRING[]): STRING[];
 BEGIN
  RETURN Str.Item(L_Str.PoolItem(List, L_StdFrm.ShowListAsMenu_wCaption(List, Title, Caption)), " ", 0);
 END {PlayChoose};

 PUBLIC PROCEDURE ObtainTSNEnvironment(    _TSN    : LIKE(Staff.TSN);
                                           _Who    : tTWOWho;
                                           D       : DATE;
                                       VAR What    : L_BegRWS.tDayType;
                                       VAR ExitClss: LIKE(ExitClss.ExitClss);
                                       VAR Time    : LTIME;
                                           Dir     : NUMERIC[0]);
  VAR
   Idx  : NUMERIC[0];
   GuBT,
   GuET : TIME;
 BEGIN
  SETEMPTY(What, ExitClss, Time);
  TRY [ABORT_AFTER(AA_ON), RESTORE_CURSORS(RC_ON)]
   INC(D, Dir);
   Idx:=Date2Idx(D);
   IF SELECT(Mtwo, Who, L_DatTim.Per(D), _Who, _TSN) THEN
    What:=Mtwo.What[Idx];
    IF L_BegRWS.IsWorkDayType(Mtwo.What[Idx]) THEN
     AccessDtwoByMtwo(Idx);
     IF ~!Dtwo.ExitClss THEN
      ExitClss:=Dtwo.ExitClss;
      IF   Dir = -1 THEN
       Time:=C_T2L(Dtwo.BegDay + (Dtwo.EndTime < Dtwo.BegTime), Dtwo.EndTime);
      ELSE
       Time:=C_T2L(Dtwo.BegDay, Dtwo.BegTime);
      END;
      IF ~Dtwo.MnlTmSet & (_Who = who_Guard) & StandOnExit(Dtwo.ExitClss, What, D, 0) THEN
       L_Way.GetExitTimes(L_Way.rwswho_Guard, GuBT, GuET);
       IF   Dir = -1 THEN
        Time:=C_T2L(01 + (GuET < GuBT), GuET);
       ELSE
        Time:=C_T2L(01, GuBT);
       END;
      END; (* IF ~Dtwo.MnlTmSet ... *)
     END; (* IF ~!Dtwo.ExitClss *)
    END;
   END;
  EXCEPT
  END; (* TRY *)
 END {ObtainTSNEnvironment};

 PUBLIC PROCEDURE GetTSNEnvironmentAsStr(_TSN: LIKE(Staff.TSN); _Who: tTWOWho; D: DATE): STRING[];
  CONST
   w_OneDay = 1+1+6+1+5;
  VAR
   prvWhat,
   nxtWhat    : L_BegRWS.tDayType;
   prvExitClss,
   nxtExitClss: LIKE(ExitClss.ExitClss);
   prvEndTime,
   nxtBegTime : LTIME;
   Result     : STRING[];
 BEGIN
  Result:="";
  ObtainTSNEnvironment(_TSN, _Who, D, prvWhat, prvExitClss, prvEndTime, -1);
  IF ~!prvWhat THEN
   Result:=Result + WhatStr(prvWhat);
   IF ~!prvExitClss THEN
    Result:=Result + " " + prvExitClss + " " + L_DatTim.TimeStr(prvEndTime);
   END;
  ELSE
   Result:="???"
  END;
  Result:=Str.Align(Result, w_OneDay, LEFT);
  Result:=Result + "/";
  ObtainTSNEnvironment(_TSN, _Who, D, nxtWhat, nxtExitClss, nxtBegTime, +1);
  IF ~!nxtWhat THEN
   Result:=Result + WhatStr(nxtWhat);
   IF ~!nxtExitClss THEN
    Result:=Result + " " + nxtExitClss + " " + L_DatTim.TimeStr(nxtBegTime);
   END;
  ELSE
   Result:=Result + "???";
  END;
  Result:=Str.Align(Result, w_OneDay*2+1, LEFT);
  RETURN Result;
 END {GetTSNEnvironmentAsStr};

 PRIVATE PROCEDURE cs_SetupCheckOfficer(    curSort     : LIKE(Sort.Sort);
                                            w_Total     : NUMERIC[0];
                                        VAR FormStr,
                                            co_Pool,
                                            vars        : STRING[];
                                        VAR CheckOfficer: tCheckOfficer;
                                        VAR curDprt     : LIKE(Sort.Sort));
  CONST
   co_Amount = 3;
 BEGIN
  IF ~!curSort THEN
   CheckOfficer:=co_BySort;
   SEARCH(Sort, Sort, , curSort);
   curDprt:=L_Staff.getSortDprt(Sort.Sort);
   co_Pool:=" ᥪ " + curSort   + " "  + Sort.Name                          + "|" +
            " ⤥  " + curDprt + "  " + L_Staff.getSortDprtName(Sort.Sort) + "|" +
            "";
   FormStr:=FormStr + "|" +Str.Align("뢠  ᮮ⢥⢨  ࠡ稬 ⮬:", w_Total+6, LEFT) +
                      "|%"+L_Str.IntStr(w_Total) + "," + L_Str.IntStr(co_Amount) + "AO" + L_Str.Repeat("|", co_Amount);
   vars   :=vars + "co_Pool, CheckOfficer, ";
  ELSE
   CheckOfficer:=co_None;
   SETEMPTY(curDprt);
  END;
 END {cs_SetupCheckOfficer};

 PRIVATE PROCEDURE cs_CheckOfficer(da          : tDailyAttribute;
                                   D           : DATE;
                                   CheckOfficer: tCheckOfficer;
                                   trgSort     : LIKE(Sort.Sort);
                                   trgDprt     : LIKE(Sort.Sort)): SCAL[2];
  VAR
   _Sort: LIKE(Sort.Sort);
 BEGIN
  IF CheckOfficer = co_None THEN
   RETURN 1;
  ELSE
   SETEMPTY(_Sort);
   IF IsStaffDA(da) THEN
    SEARCH(Staff, TSN, , Mtwo.TSN); (* ??? *)
    SAVE(StaffLog);
    IF L_Staff.rInState(D) THEN
     L_BegRWS.PosToSortOfStaff(D);
     _Sort:=Sort.Sort;
    END;
    RESTORE(StaffLog);
   ELSIF da = da_Car THEN
    _Sort:=GetCarSort(Dtwo.BoxNbr, Dtwo.Date);
   ELSIF da = da_ExitClss THEN
    _Sort:=L_Way.E_GetFixedSortOfExit(Dtwo.Exit, Dtwo.Date, who_Driver);
   END;
   IF ~!_Sort & SEARCH(Sort, Sort, _Sort) THEN
    IF CheckOfficer = co_BySort THEN
     RETURN Sort.Sort = trgSort;
    ELSE
     RETURN L_Staff.getSortDprt(Sort.Sort) = trgDprt;
    END;
   ELSE
    RETURN 0;
   END;
  END;
 END {cs_CheckOfficer};

 PUBLIC PROCEDURE ChooseSuitableStaff(Who            : L_Way.tRWSWho;
                                      D              : DATE;
                                      curRWayS       : LIKE(RWayS.RWayS);
                                      _ExitClss      : LIKE(ExitClss.ExitClss);
                                      _Change        : LIKE(StExit.Change);
                                      _Sort          : LIKE(Sort.Sort);
                                      _BoxNbr        : LIKE(Car.BoxNbr);
                                      CheckFitToRWayS: SCAL[2]): STRING[];
  CONST
   MaxRoute      = 10;
   w_DialogTotal = 70;
   w_MenuTotal   = 90;
  VAR
   CheckRouteAccess: SCAL[2][MaxRoute];
   CheckMarkAccess,
   CheckChange,
   ShowMarkAccess,
   ShowChange,
   Authorized,
   Need            : SCAL[3];
   CheckOfficer    : tCheckOfficer;
   AvailableLevel,
   CheckAvailLevel : tAL;
   Routes          : LIKE(Route.Route)[MaxRoute];
   al_Amount,
   Idx, twoIdx     : NUMERIC[0];
   FormStr,
   vars,
   List,
   Caption,
   ListItem,
   Legend          : STRING[];
   P               : DATE;
   _TSN            : LIKE(Staff.TSN);
   _Dprt           : LIKE(Sort.Sort);
   al_Pool,
   al_ShortPool,
   co_Pool         : STRING[];
   CooTSN          : LIKE(Staff.TSN);
 BEGIN
  L_General.Assert(L_BegRWS.E_TWOLevel(D), "  ⮫쪮  ᯮ짮 鸞");
  SETEMPTY(Routes, vars, FormStr);
  P          :=L_DatTim.Per(D);
  CheckChange:=1;
  twoIdx     :=Date2Idx(D);

  IF ~!curRWayS THEN
   CheckAvailLevel:=alrws_OnFictBoxNbr;
   al_Pool        :=alrws_Pool;
   al_ShortPool   :=alrws_ShortPool;
   al_Amount      :=4;
  ELSE
   CheckAvailLevel:=altwo_Yes;
   al_Pool        :=altwo_Pool;
   al_ShortPool   :=altwo_ShortPool;
   al_Amount      :=3;
  END;

  IF CheckFitToRWayS & ~!_ExitClss & (Who = L_Way.rwswho_Driver) THEN
   SAVE(ExitClss);
   SEARCH(ExitClss, ExitClss, , _ExitClss);
   IF ExitClss.BegType = L_Way.ecbt_Line THEN
    SAVE(StExit);
    SAVE(SEJobs);
    SAVE(WJMode);
    PositionOnExit(_ExitClss, _Change, D);
    SELECT(SEJobs, Exit, , StExit.Exit);
    WHILE OCCURE(SEJobs) DO
     CONFORM(SEJobs, WJMode);
     IF WJMode.RunSel = L_Way.runsel_Work THEN
      as_InsRoute(Routes, SEJobs.Route);
     END;
     NEXT(SEJobs);
    END; (* WHILE OCCURE(SEJobs) ... *)
    RESTORE(WJMode);
    RESTORE(SEJobs);
    RESTORE(StExit);

    SAVE(Route);
    Idx:=0;
    WHILE ~!Routes[Idx] DO
     IF !FormStr THEN
      FormStr:="|";
     END;
     SEARCH(Route, Route, , Routes[Idx]);
     FormStr:=FormStr + "%<" + Str.Align("騥    " + Route.Route + " " + Route.Name,
                                         w_DialogTotal,
                                         LEFT) + ">E|";
     vars   :=vars + "CheckRouteAccess[" + L_Str.IntStr(Idx) + "], ";
     IF L_APtm.IsOG() THEN
      CheckRouteAccess[Idx]:=0;
     ELSE
      CheckRouteAccess[Idx]:=1;
     END;
     INC(Idx);
    END;
    RESTORE(Route);
   END;
   RESTORE(ExitClss);
  END;
  IF ~!_Change THEN
   FormStr:=FormStr + "|%<" + Str.Align(L_Str.PoolItem("|ࢠ|", _Change) + " ᬥ  䨪",
                                        w_DialogTotal,
                                        LEFT) + ">E|";
   vars:=vars + "CheckChange, ";
  ELSE
   CheckChange:=0;
  END;

  cs_SetupCheckOfficer(_Sort, w_DialogTotal,
                       FormStr, co_Pool, vars, CheckOfficer, _Dprt);

  CheckMarkAccess:=0;
  ShowMarkAccess :=~!_BoxNbr & (Who = L_Way.rwswho_Driver);
  IF ShowMarkAccess THEN
   L_Car.AccessMark(_BoxNbr, D);
   FormStr:=FormStr + "|%<" + Str.Align("騥   થ " + Mark.Mark + " " + Mark.Name,
                                         w_DialogTotal,
                                         LEFT) + ">E|";
   vars   :=vars + "CheckMarkAccess, ";
  END;
  FormStr:=FormStr + "|" +Str.Align("뢠 ᢮:", w_DialogTotal+6, LEFT) +
                     "|%"+L_Str.IntStr(w_DialogTotal)+"," + L_Str.IntStr(al_Amount) + "AO" + L_Str.Repeat("|", al_Amount) +
                     "|%< {}믮 >DB   %< {}⬥ >X";
  vars   :=vars + "al_Pool, CheckAvailLevel";

  STDFORM(FormStr, "  " + L_Str.PoolItem("⥫|", Who) + " ", , -1, ^vars);

  Caption:=Str.Align(L_Str.PoolItem(who_Pool, Who), 26, LEFT);
  Idx :=0;
  WHILE ~!Routes[Idx] DO
   Caption:=Caption + L_Str.IntStr(Idx);
   INC(Idx);
  END;
  Caption:=Caption + "   ?     ";
  IF    Who = L_Way.rwswho_Driver THEN
   Caption:=Caption + " .";
  ELSIF Who = L_Way.rwswho_Guard THEN
   Caption:=Caption + " . ";
  END;

  Caption:=Str.Align(Caption, w_MenuTotal, LEFT);

  Caption:=Caption + "|" + L_Str.Repeat("", Str.Length(Caption));

  IF ~!_ExitClss & StandOnExit(_ExitClss, _Change, D, 0) THEN
   Legend:="  室 " + _ExitClss + "/" + _Change +
            " (" + L_Way.FullStExitBegTimeStr() + " " + L_Way.FullStExitStopTimStr() + ") ";
   Caption:=L_StdFrm.DrawLineInBox(Str.Align(Legend, w_MenuTotal-2, LEFT)) + "|" + Caption;
  END;

  List:="";
  TRY
   SAVE(Mtwo);
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   SELECT(Mtwo, Who, , P, Who);
   WHILE OCCURE(Mtwo) DO
    PROMPT(Mtwo.TSN);
    IF cs_CheckOfficer(Who2DA(), D, CheckOfficer, _Sort, _Dprt) THEN
     Need:=1;
     IF CheckChange THEN
      Need:=(Mtwo.What[twoIdx] = _Change) |
            ((Mtwo.Source[MSrcIdx(twoIdx, da_What)] # L_BegRWS.twosrc_System) & ~L_BegRWS.IsWorkDayType(Mtwo.What[twoIdx]));
     ELSIF Mtwo.Source[MSrcIdx(twoIdx, da_What)] = L_BegRWS.twosrc_System THEN
      Need:=0;
     END;
  
     Idx:=0;
     WHILE Need & ~!Routes[Idx] DO
      IF CheckRouteAccess[Idx] THEN
       Need:=L_BegRWS.DriverIsAuthorizedToRoute(D, Mtwo.TSN, Routes[Idx]);
      END;
      INC(Idx);
     END;
  
     IF CheckMarkAccess THEN
      Need:=Need & L_BegRWS.HasPermitToMark(D, Mtwo.TSN, Mark.Mark);
     END;
  
     IF Need THEN
      AvailableLevel:=AvailLevel(Who, D, curRWayS);
      Need          :=AvailableLevel <= CheckAvailLevel;
     END;
 
     IF Need THEN
      CONFORM(Mtwo, Staff);
      CONFORM(Staff, Man);
      ListItem:=Staff.TSN + " " + Str.Align(L_Str.ShortName(Man.Name), 20, LEFT);
      Idx :=0;
      WHILE ~!Routes[Idx] DO
       Authorized:=CheckRouteAccess[Idx] |
                   L_BegRWS.DriverIsAuthorizedToRoute(D, Staff.TSN, Routes[Idx]);
       ListItem:=ListItem + L_Str.PoolItem(" |", Authorized);
       INC(Idx);
      END;
      ListItem:=ListItem + " " + WhatStr(Mtwo.What[twoIdx]);
      IF ShowMarkAccess THEN
       ListItem:=ListItem + " " + L_Str.PoolItem(" |", L_BegRWS.HasPermitToMark(D, Staff.TSN, Mark.Mark));
      ELSE
       ListItem:=ListItem + " " + " ";
      END;
      ListItem:=ListItem + " " + L_Str.PoolItem(al_ShortPool, AvailableLevel);
 
      IF !curRWayS THEN
       ListItem:=ListItem + " " + FLDTOSTR(Mtwo.ExitClss[twoIdx], "0", 6) +
                            " " + FLDTOSTR(Mtwo.BoxNbr[twoIdx], "0", 4) +
                            " " + FLDTOSTR(Mtwo.CooTSN[twoIdx], "0", 5);
      ELSE
       IF AccessRWaySByTSN(Mtwo.TSN, D) THEN
        IF Mtwo.Who = who_Driver THEN
         IF SELECT(WayLMen, RWayS, RWayS.RWayS, L_Way.wlmwho_Guard) THEN
          CooTSN:=WayLMen.TSN;
         ELSE
          SETEMPTY(CooTSN);
         END;
        ELSE
         CooTSN:=RWayS.TSN;
        END;
        CONFORM(RWayS, StExit);
        ListItem:=ListItem + " " + FLDTOSTR(StExit.ExitClss, "0", 6) +
                             " " + FLDTOSTR(RWayS.BoxNbr, "0", 4) +
                             " " + FLDTOSTR(CooTSN, "0", 5);
       ELSE
        ListItem:=ListItem + " " + L_Str.Repeat(" ", 6+1+4+1+5);
       END;
      END;
      ListItem:=Str.Align(ListItem + " " + "(" + GetTSNEnvironmentAsStr(Staff.TSN, Who, D) + ")", w_MenuTotal, LEFT);
      List:=List + ListItem + "|";
     END;
    END;
    NEXT(Mtwo);
   END; (* WHILE OCCURE(Mtwo) ... *)
   RTI.Get().TryBlock.AccessDataMode:=adm_RIDGE;
   RENEWDATALAYER();
   RESTORE(Mtwo);
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Raise DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
  RETURN PlayChoose(List, "롮 ᮭ " + L_DatTim.DateStr(D), Caption);
 END {ChooseSuitableStaff};

 PUBLIC PROCEDURE ChooseSuitableCar(_Sort   : LIKE(Sort.Sort);
                                    D       : DATE;
                                    ofc     : tObjectFreeCond;
                                    curRWayS: LIKE(RWayS.RWayS)): LIKE(Car.BoxNbr);
  CONST
   w_Form = 70;
   al_Pool   = "|";

   al_Free = 0;
   al_All  = 1;

  VAR
   ListItem,
   List,
   vars,
   Caption,
   FormStr        : STRING[];
   CheckAvailLevel: SCAL[2];
   CheckOfficer   : tCheckOfficer;
   _Dprt          : LIKE(Sort.Sort);
   co_Pool        : STRING[];
   Need           : SCAL[2];
   _GuardTSN      : LIKE(Staff.TSN);
 BEGIN

  CheckAvailLevel:=al_Free;
  SETEMPTY(FormStr, vars);

  cs_SetupCheckOfficer(_Sort, w_Form,
                       FormStr, co_Pool, vars, CheckOfficer, _Dprt);

  FormStr:=FormStr + "|" +Str.Align("뢠:", w_Form+6, LEFT) +
                     "|%"+L_Str.IntStr(w_Form)+"," + L_Str.IntStr(2) + "AO" + L_Str.Repeat("|", 2) +
                     "|%< {}믮 >DB   %< {}⬥ >X";
  vars   :=vars + "al_Pool, CheckAvailLevel";

  STDFORM(FormStr, "  ࠭ᯮ⭮ ।⢠ ", , -1, ^vars);

  Caption:=Str.Align("", 40, LEFT) + "    .  .";
  Caption:=Caption + "|" + L_Str.Repeat("", Str.Length(Caption));
  SETEMPTY(List);
  TRY
   SAVE(Dtwo);
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   SELECT(Dtwo, DBoxNbr, , D);
   WHILE OCCURE(Dtwo) DO
    IF ~!Dtwo.BoxNbr THEN
     PROMPT("⮢ " + Dtwo.BoxNbr);
     Need:=0;
     IF !curRWayS THEN
      IF (CheckAvailLevel = al_All)                  |
         ((ofc = ofc_ExitClss) & (!Dtwo.ExitClss | ~IsStrictExitClss(Dtwo.ExitClss, Dtwo.Change, Dtwo.Date))) |
         ((ofc = ofc_Driver)   & !Dtwo.TSN)        |
         ((ofc = ofc_Guard)    & !Dtwo.GuardTSN) THEN
       Need:=1;
      END;
     ELSE
      IF (CheckAvailLevel = al_All) |
         (~AccessRWaySByBoxNbr(Dtwo.BoxNbr, D) | ((RWayS.RWayS # curRWayS) & (RWayS.TSN = L_Env.fictTSN))) THEN
       Need:=1;
      END;
     END;
     IF Need & cs_CheckOfficer(da_Car, D, CheckOfficer, _Sort, _Dprt) THEN
      L_Car.StandOnCarLog(Dtwo.BoxNbr, Dtwo.Date);
      CONFORM(CarLog, Mark);
      ListItem:=Str.Align(CarLog.BoxNbr + " " + CarLog.StateNbr + " " + Mark.Name, 40, LEFT);
      IF !curRWayS THEN
       ListItem:=ListItem + " " + FLDTOSTR(Dtwo.Change, "0", 1) +
                            " " + FLDTOSTR(Dtwo.ExitClss, "0", 6) +
                            " " + FLDTOSTR(Dtwo.TSN, "0", 5) +
                            " " + FLDTOSTR(Dtwo.GuardTSN, "0", 5);
      ELSE
       IF AccessRWaySByBoxNbr(Dtwo.BoxNbr, D) THEN
        CONFORM(RWayS, StExit);
        IF SELECT(WayLMen, RWayS, RWayS.RWayS, L_Way.wlmwho_Guard) THEN
         _GuardTSN:=WayLMen.TSN;
        ELSE
         SETEMPTY(_GuardTSN);
        END;
        ListItem:=ListItem + " " + FLDTOSTR(RWayS.Change, "0", 1) +
                             " " + FLDTOSTR(StExit.ExitClss, "0", 6) +
                             " " + FLDTOSTR(RWayS.TSN, "0", 5) +
                             " " + FLDTOSTR(_GuardTSN, "0", 5);
       ELSE
        ListItem:=ListItem + " " + L_Str.Repeat(" ", 1+1+6+1+5+1+5);
       END;
      END;
      List:=List + ListItem + "|";
     END;
    END;
    NEXT(Dtwo);
   END; (* WHILE OCCURE(Dtwo) ... *)
   RTI.Get().TryBlock.AccessDataMode:=adm_RIDGE;
   RENEWDATALAYER();
   RESTORE(Dtwo);
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Raise DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
  RETURN PlayChoose(List, "롮 ࠭ᯮ⭮ ।⢠ " + L_DatTim.DateStr(D), Caption);
 END {ChooseSuitableCar};

 PUBLIC PROCEDURE ChooseSuitableExitClss(_Sort   : LIKE(Sort.Sort);
                                         D       : DATE;
                                         _Change : LIKE(StExit.Change);
                                         _Driver,
                                         _Guard  : LIKE(Staff.TSN);
                                         ofc     : tObjectFreeCond): LIKE(ExitClss.ExitClss);
  CONST
   w_Total        = 70;
   w_ExitClssName = 45;
   w_StExitDsc    = 20;

   w_MenuTotal    = 90;

   al_0 = 0;
   al_1 = 1;
   al_2 = 2;

  VAR
   List,
   vars,
   Caption,
   Legend,
   FormStr,
   StExitDescription: STRING[];
   al_Pool          : STRING[];
   CheckAvailLevel  : SCAL[3];
   CheckChange      : SCAL[2];
   CheckOfficer     : tCheckOfficer;
   _Dprt            : LIKE(Sort.Sort);
   co_Pool          : STRING[];
 BEGIN
  CheckAvailLevel:=al_0;
  CheckChange    :=1;
  SETEMPTY(FormStr, vars);

  IF ~!_Change THEN
   FormStr:=FormStr + "|%<" + Str.Align(L_Str.PoolItem("|ࢠ|", _Change) + " ᬥ",
                                        w_Total,
                                        LEFT) + ">E|";
   vars:=vars + "CheckChange, ";
  ELSE
   CheckChange:=0;
  END;

  cs_SetupCheckOfficer(_Sort, w_Total,
                       FormStr, co_Pool, vars, CheckOfficer, _Dprt);

  FormStr:=FormStr + "|" +Str.Align("뢠:", w_Total+6, LEFT) +
                     "|%"+L_Str.IntStr(w_Total)+"," + L_Str.IntStr(3) + "AO" + L_Str.Repeat("|", 3) +
                     "|%< {}믮 >DB   %< {}⬥ >X";
  IF ofc = ofc_Guard THEN
   al_Pool:=" 㦥   |  |";
  ELSE
   al_Pool:="| + 裂|";
  END;

  vars:=vars + "al_Pool, CheckAvailLevel";

  STDFORM(FormStr, "   室 ", , -1, ^vars);

  Caption:=Str.Align(" 室", w_ExitClssName, LEFT) +
           " " + " " +
           " " + "" +
           " " + Str.Align("⢠ 室", w_StExitDsc, LEFT) +
           " " + ". " +
           " " + "  " +
           " " + ". " +
           " " + "";
  Caption:=Caption + "|" + L_Str.Repeat("", Str.Length(Caption));

  IF ~!_Driver THEN
   Legend:="  " + _Driver + " (" + GetTSNEnvironmentAsStr(_Driver, who_Driver, D) + ")";
  ELSE
   Legend:="";
  END;
  IF ~!_Guard THEN
   IF ~!Legend THEN
    Legend:=Legend + ",";
   END;
   Legend:=Legend + "  " + _Guard + " (" + GetTSNEnvironmentAsStr(_Guard, who_Guard, D) + ")";
  END;
  IF ~!Legend THEN
   Caption:=L_StdFrm.DrawLineInBox(Str.Align(Legend, w_MenuTotal-2, LEFT)) + "|" + Caption;
  END;

  SETEMPTY(List);
  TRY
   SAVE(Dtwo);
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   SELECT(Dtwo, DExitClss, , D);
   WHILE OCCURE(Dtwo) DO
    IF ~!Dtwo.ExitClss THEN
     PROMPT("⮢ " + Dtwo.ExitClss);
     IF ~CheckChange | (_Change = Dtwo.Change) THEN
      IF (CheckAvailLevel = al_2) |
         ((ofc = ofc_Driver) & !Dtwo.TSN)      |
         ((ofc = ofc_Car)    & !Dtwo.BoxNbr)   |
         ((ofc = ofc_Guard)  & !Dtwo.GuardTSN & ((Dtwo.GuardOk = 0) | (CheckAvailLevel = al_1))) THEN
       IF cs_CheckOfficer(da_ExitClss, D, CheckOfficer, _Sort, _Dprt) THEN
        IF ~!Dtwo.Exit THEN
         StExitDescription:=L_DatTim.TimeStr(Dtwo.BegTime) + " " + L_DatTim.TimeStr(Dtwo.EndTime);
        ELSE
         StExitDescription:="";
        END;
        CONFORM(Dtwo, ExitClss);
        List:=List + Str.Align(ExitClss.ExitClss + " " + ExitClss.Name, w_ExitClssName, LEFT) +
               " " + L_Str.PoolItem("|| ", ExitClss.Strict) +
               " " + FLDTOSTR(Dtwo.Change,   "0", 1) +
               " " + Str.Align(StExitDescription, w_StExitDsc, LEFT)  +
               " " + FLDTOSTR(Dtwo.TSN,      "0", 5) +
               " " + FLDTOSTR(Dtwo.BoxNbr,   "0", 4) +
               " " + FLDTOSTR(Dtwo.GuardTSN, "0", 5) +
               " " + L_Str.PoolItem("!||?", Dtwo.GuardOk) +
               "|";
       END;
      END;
     END;
    END;
    NEXT(Dtwo);
   END; (* WHILE OCCURE(Dtwo) ... *)
   IF (ofc # ofc_Guard) & (CheckAvailLevel # al_0) THEN
    SELECT(ExitClss, ExitClss);
    WHILE OCCURE(ExitClss) DO
     IF (ExitClss.Strict = L_Way.ExitStrict_Ord) & L_DatTim.IsActive(D, ExitClss.Begin, ExitClss.Till) THEN
      List:=List + Str.Align(ExitClss.ExitClss + " " + ExitClss.Name, w_ExitClssName, LEFT) +
            " " + L_Str.PoolItem("|| ", ExitClss.Strict) +
            L_Str.Repeat(" ", w_Total-w_ExitClssName-4) + "|";
     END;
     NEXT(ExitClss);
    END; (* WHILE OCCURE(ExitClss) ... *)
   END;
   RTI.Get().TryBlock.AccessDataMode:=adm_RIDGE;
   RENEWDATALAYER();
   RESTORE(Dtwo);
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Raise DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
  RETURN PlayChoose(List, "롮  室 " + L_DatTim.DateStr(D), Caption);
 END {ChooseSuitableExitclss};

 PUBLIC PROCEDURE PositionOnDtwoRWayS();
 BEGIN
  L_General.CallUs(SEARCH(RWayS, RWayS, Dtwo.RWayS));
 END {PositionOnDtwoRWayS};

 PUBLIC PROCEDURE DtwoBindRWayS();
  VAR
   itsNew      : SCAL[2];
   Action      : LIKE(XDocJrn.Action);
   curDP       : LIKE(Staff.TSN);
   DriverPupils: LIKE(Staff.TSN)[8];
 BEGIN
  L_General.CallUs(~!Dtwo.ExitClss);
  IF !Dtwo.RWayS THEN
   itsNew:=1;
   DEFAULT(RWayS);
  ELSE
   itsNew:=0;
   PositionOnDtwoRWayS();
  END;
  RWayS.Date  :=Dtwo.Date;
  IF ~!Dtwo.TSN THEN
   RWayS.TSN:=Dtwo.TSN;
  ELSE
   RWayS.TSN:=L_Env.fictTSN;
  END;
  IF ~!Dtwo.BoxNbr THEN
   RWayS.BoxNbr:=Dtwo.BoxNbr;
  ELSE
   RWayS.BoxNbr:=L_Car.E_GetFictiveBoxNbr(Dtwo.MyFirm);
  END;
  PositionOnExit(Dtwo.ExitClss, Dtwo.Change, Dtwo.Date);
  RWayS.Exit  :=StExit.Exit;
  RWayS.Change:=Dtwo.Change;
  RWayS.Status:=L_Way.rwsStat_Ordered;
  IF Dtwo.HldOff[who_Driver] THEN
   RWayS.ToSheet:=L_Way.toSheet_Holid;
  ELSE
   RWayS.ToSheet:=L_Way.toSheet_Sheet;
  END;
  IF itsNew THEN
   L_BegRWS.INSERT_RWayS();
  ELSE
   L_BegRWS.REPLACE_RWayS();
   WHILE SELECT(WayLMen, RWayS, RWayS.RWayS) DO
    REMOVE(WayLMen);
   END;
   WHILE SELECT(RWayTxt, RWayS, RWayS.RWayS) DO
    REMOVE(RWayTxt);
   END;
  END;
  IF ~!Dtwo.GuardTSN THEN
   DEFAULT(WayLMen);
   WayLMen.RWayS    :=RWayS.RWayS;
   WayLMen.RWayDate :=RWayS.Date;
   WayLMen.TSN      :=Dtwo.GuardTSN;
   WayLMen.Day      :=1;
   WayLMen.Who      :=L_BegRWS.E_GetWayLMenWhoOfGuard();
   L_Way.SetWayLMenDefaultValue();
   IF (WayLMen.ToSheet = L_Way.toSheet_Sheet) & Dtwo.HldOff[who_Guard] THEN
    WayLMen.ToSheet:=L_Way.toSheet_Holid;
   END;
   INSERT(WayLMen);    
  END;
  IF RWayS.TSN # L_Env.fictTSN THEN
   P_Staff.GetProbationers4Tutor(RWayS.TSN, RWayS.Date, DriverPupils);
   FOR_EACH curDP IN DriverPupils DO
    IF !curDP THEN
     EXIT;
    END;
    DEFAULT(WayLMen);
    WayLMen.RWayS    :=RWayS.RWayS;
    WayLMen.RWayDate :=RWayS.Date;
    WayLMen.TSN      :=curDP;
    WayLMen.Day      :=1;
    WayLMen.Who      :=L_Way.wlmwho_DrPupil;
    L_Way.SetWayLMenDefaultValue();
    INSERT(WayLMen);    
   END;
  END;
  IF ~!Dtwo.Message | Dtwo.MnlTmSet THEN
   DEFAULT(RWayTxt);
   RWayTxt.RWayS:=RWayS.RWayS;
   RWayTxt.Valid:=1;
   RWayTxt.Message:=L_lsStore.Get(Dtwo.Message);
   IF Dtwo.MnlTmSet THEN
    RWayTxt.FExTime:=Dtwo.BegTime;
    RWayTxt.LEnTime:=Dtwo.EndTime;
   END;
   INSERT(RWayTxt);
  END;
  L_BegRWS.SetExitData();
  IF itsNew THEN
   Action:=L_XDoc.action_AutoBuild;
   Dtwo.RWayS:=RWayS.RWayS;
   REPLACE(Dtwo);
  ELSE
   Action:=L_XDoc.action_AutoEdit;
  END;
  L_Way.CurRWayS_XDocJrn_Mark(Action);
  L_BegRWS.E_CheckCrewFitForExit(Action);
 END {DtwoBindRWayS};

BEGIN
 IF ~L_General.VariableIsInitialized(rnvMode) THEN
  SETEMPTY(rnvMode);
 END;
END.
