(*
%Copyright   (c) Polak Computer System  
%Author      MOG                        
%Purpose     ࠡ⪠/⪠   ࠡ⭨, , 室, 
%Type        operation
%Specific    AP
%Modified    17.07.2013 14:54:39 POLAK\Gina
%Environment
*)

 MODULE ManRW [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PRIVATE TYPE
  tObject        = SCAL[4];

 PRIVATE CONST
  obj_Staff      = 0;
  obj_StExit     = 1;
  obj_Route      = 2;
  obj_Car        = 3;
  obj_Pool       = "ࠡ⭨|室||";
  obj_Pool_Field = "Staff.TSN|StExit.Exit|Route.Route|Car.BoxNbr";

 IMPORT Memo, L_DatTim, L_Staff, L_AP, L_Str, L_General, L_Way, L_PRoll, L_XDoc, L_StdFrm;

 PRIVATE VAR
  ObjectType: tObject;
  BPer, EPer: DATE;
  SkipUnTaxed,
  wStandOn,
  Strong,
  Asked     : SCAL[2];

 PRIVATE PROCEDURE GetObjName(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(obj_Pool, ObjectType) + " " + ^(L_Str.PoolItem(obj_Pool_Field, ObjectType));
 END {GetObjName};

 PRIVATE PROCEDURE CondMakeRW(trgDone: SCAL[2]);
 BEGIN
  L_AP.ProceedRWayS(trgDone, SkipUnTaxed, wStandOn, Strong, Asked);
 END {CondMakeRW};

 PRIVATE PROCEDURE IsGoodRWayJ(): SCAL[2];
 BEGIN
  CONFORM(RWayJ, SEJobs);
  IF    ObjectType = obj_StExit THEN
   RETURN SEJobs.Exit = StExit.Exit;
  ELSIF ObjectType = obj_Route THEN
   RETURN SEJobs.Route = Route.Route;
  ELSE
   RETURN 0;
  END;
 END {IsGoodRWayJ};

 PRIVATE PROCEDURE Make(trgDone: SCAL[2]);
  VAR
   Msg: STRING[];
 BEGIN
  Asked:=0;
  IF ObjectType = obj_Staff THEN
   SELECT(RWayS, TSN, , Staff.TSN);
   SRCINSEL(RWayS, GE, , BPer);
   WHILE OCCURE(RWayS) & (RWayS.Date <= EPer) DO
    CondMakeRW(trgDone);
    NEXT(RWayS);
   END;
   SELECT(WayLMen, TSN, , Staff.TSN);
   SRCINSEL(WayLMen, GE, , BPer);
   WHILE OCCURE(WayLMen) & (WayLMen.RWayDate <= EPer) DO
    CONFORM(WayLMen, RWayS);
    CondMakeRW(trgDone);
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
   IF L_Way.E_TckRcLevel(EPer) THEN
    SELECT(TckRcS, TSN, , Staff.TSN);
    SRCINSEL(TckRcS, GE, , BPer);
    WHILE OCCURE(TckRcS) & (TckRcS.Date <= EPer) DO
     IF TckRcS.AsWho = L_Way.trs_Chopper THEN
      IF TckRcS.Done # trgDone THEN
       TRY [TRANSACTION(TRANSACTION_SLAVE)]
        IF trgDone THEN
         CALL(TckRcS.SingleMakeDone());
        ELSE
         CALL(TckRcS.SingleMakeUnDone());
        END;
       EXCEPT
       ON Exc: Exc_Root DO
        Msg:=" 㤠 "+L_Str.PoolItem("⪠|ࠡ", trgDone)+"  "+TckRcS.TckRcS + "||" +
             Exc.MsgOriginalText;
        IF Strong THEN
         L_General.Error(Msg);
        ELSIF ~Asked THEN
         L_StdFrm.CrucialChoice(Msg, "");
        END;
       END; (* TRY *)
      END;
      IF trgDone THEN
       CONFORM(TckRcS, TckRcJ);
       WHILE OCCURE(TckRcJ) DO
        SEARCH(RWayS, RWayS, , TckRcJ.asRWayS);
        CondMakeRW(trgDone);
        NEXT(TckRcJ);
       END; (* WHILE OCCURE(TckRcJ) ... *)
      END;
     END;
     NEXT(TckRcS);
    END; (* WHILE OCCURE(TckRcS) ... *)
   END;
  ELSIF ObjectType = obj_Car THEN
   SELECT(RWayS, BoxNbr, , Car.BoxNbr);
   SRCINSEL(RWayS, GE, , BPer);
   WHILE OCCURE(RWayS) & (RWayS.Date <= EPer) DO
    CondMakeRW(trgDone);
    NEXT(RWayS);
   END;
  ELSE
   L_StdFrm.Choice(L_Str.PoolItem("⪠|ࠡ", trgDone)+" ⥢  "+GetObjName()+
                   "|| "+L_DatTim.DateStr(BPer)+"  "+L_DatTim.DateStr(EPer));
   SELECT(RWayS, Date);
   SRCINSEL(RWayS, GE, , BPer);
   WHILE OCCURE(RWayS) & (RWayS.Date <= EPer) DO
    PROMPT(RWayS.RWayS+" "+L_DatTim.DateStr(RWayS.Date));
    SELECT(RWayJ, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayJ) & (RWayS.Done # trgDone) DO
     IF IsGoodRWayJ() THEN
      CondMakeRW(trgDone);
     END;
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
  END; (* IF *)
 END {Make};

 PRIVATE PROCEDURE SetPer(trgDone: SCAL[2]);
  VAR
   pm: L_XDoc.tProceedManner;
 BEGIN
  IF    (ObjectType = obj_Staff) | (ObjectType = obj_Car) THEN
   BPer:=Memo.ud_mb();
   IF trgDone THEN
    pm:=L_XDoc.pm_Proceed;
   ELSE
    pm:=L_XDoc.pm_Backtracking;
   END;
   IF L_XDoc.AskForXDocProceed(pm, "⥢  " + GetObjName(), 0) THEN
    EPer:=L_DatTim.MonthEnd(SYSDATE());
   ELSE
    EPer:=Memo.ud_me();
   END;
  ELSE
   BPer:=Memo.ud_fr();
   EPer:=Memo.ud_ut();
   L_General.Assert(L_DatTim.Per(BPer) = L_DatTim.Per(EPer), "ਮ    ।  ");
   L_General.Assert(Memo.ud_mb()=L_DatTim.Per(BPer), "騩   ᮮ⢥⢮ ਮ");
  END;
 END {SetPer};

 PRIVATE PROCEDURE intMake(trgDone: SCAL[2]; trgObjectType: tObject);
 BEGIN
  ObjectType:=trgObjectType;
  IF    ObjectType = obj_Staff THEN
   L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
   SetPer(trgDone);
  ELSIF ObjectType = obj_StExit THEN
   L_General.Assert(ACCESS(StExit), " ⠭ 室");
   SetPer(trgDone);
  ELSIF ObjectType = obj_Route THEN
   L_General.Assert(ACCESS(Route), " ⠭ ");
   SetPer(trgDone);
  ELSIF ObjectType = obj_Car THEN
   L_General.Assert(ACCESS(Car), " ⠭ ");
   SetPer(trgDone);
  ELSE
   L_General.CallUs(0);
  END;
  L_PRoll.Salary_CheckClcPer();
  SkipUnTaxed:=ObjectType # obj_Staff;
  wStandOn   :=1;
  Strong     :=1;
  Make(trgDone);
 END {intMake};

 PUBLIC PROCEDURE MakeDoneRWayS_ByStaff();
 BEGIN
  intMake(1, obj_Staff);
 END {MakeDoneRWayS_ByStaff};

 PUBLIC PROCEDURE MakeUnDoneRWayS_ByStaff();
 BEGIN
  intMake(0, obj_Staff);
 END {MakeUnDoneRWayS_ByStaff};

 PUBLIC PROCEDURE MakeDoneRWaySwSkipUnTaxed_ByStaff();
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
  ObjectType:=obj_Staff;
  BPer      :=Memo.gl_mb();
  EPer      :=Memo.gl_me();
  SkipUnTaxed:=~L_Staff.IsLeave(BPer);
  wStandOn   :=0;
  Strong     :=0;
  Make(1);
 END {MakeDoneRWaySwSkipUnTaxed_ByStaff};

 PUBLIC PROCEDURE MakeDoneRWayS_ByStExit();
 BEGIN
  intMake(1, obj_StExit);
 END {MakeDoneRWayS_ByStExit};

 PUBLIC PROCEDURE MakeUnDoneRWayS_ByStExit();
 BEGIN
  intMake(0, obj_StExit);
 END {MakeUnDoneRWayS_ByStExit};

 PUBLIC PROCEDURE MakeDoneRWayS_ByRoute();
 BEGIN
  intMake(1, obj_Route);
 END {MakeDoneRWayS_ByRoute};

 PUBLIC PROCEDURE MakeUnDoneRWayS_ByRoute();
 BEGIN
  intMake(0, obj_Route);
 END {MakeUnDoneRWayS_ByRoute};

 PUBLIC PROCEDURE MakeDoneRWayS_ByCar();
 BEGIN
  intMake(1, obj_Car);
 END {MakeDoneRWayS_ByCar};

 PUBLIC PROCEDURE MakeUnDoneRWayS_ByCar();
 BEGIN
  intMake(0, obj_Car);
 END {MakeUnDoneRWayS_ByCar};

END.
