(*
%Copyright   (c) Polak IT
%Author      16.09.2009 19:50:17 POLAK\Bor
%Purpose     ଠ⨢ ६ ய⨩
%Type        control
%Specific    AP
%Modified    30.12.2013 17:40:52 POLAK\LDA
%Environment
*)

 MODULE MarkREN [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_DatTim, L_AFM, L_Str, L_WDO, P_Mark, L_Way;

 PRIVATE CONST
  fs_All = 0;
  fs_Key = 1;
  fs_Run = 2;

 PRIVATE PROCEDURE SupportBegEndDate(OnDel: SCAL[2]);
  VAR
   _DateE,
   _Date: LIKE(MarkREN.Date);
 BEGIN
  _Date:=MarkREN.Date;
  SAVE(MarkREN);
  SETSEL(MarkREN, RepEvent, MarkREN.RepEvent, MarkREN.Mark);
  LAST(MarkREN);
  _DateE:=MarkREN.DateE;
  REPEAT
   IF ~OnDel | (MarkREN.Date # _Date) THEN
    MarkREN.DateE:=_DateE;
    REPLACE(MarkREN);
    _DateE:=MarkREN.Date-1;
   END;
  UNTIL ~PREV(MarkREN);
  RESTORE(MarkREN);
 END {SupportBegEndDate};

 PRIVATE PROCEDURE ReSortRuns();
  VAR
   i: NUMERIC[0];
 BEGIN
  IF OCCURE(MarkREN) THEN
   L_AFM.MakeMultipleIndex("_Runs", "Run : LIKE(MarkREN.Run[0]);"+
                                    "Norm: LIKE(MarkREN.Norm[0])",
                           "Run: Run");
   i:=0;
   WHILE i < RANGEOF(MarkREN.Run) DO
    IF ~!MarkREN.Run[i] THEN
     L_General.Assert(~SEARCH(_Runs, Run, MarkREN.Run[i]), " ᠭ ஡ "+L_Str.NumericStr(MarkREN.Run[i], 1));
     _Runs.Run :=MarkREN.Run[i];
     _Runs.Norm:=MarkREN.Norm[i];
     INSERT(_Runs);
    END;
    INC(i);
   END;
   SETEMPTY(MarkREN.Run, MarkREN.Norm);
   i:=0;
   SELECT(_Runs, Run);
   WHILE OCCURE(_Runs) DO
    MarkREN.Run[i] :=_Runs.Run;
    MarkREN.Norm[i]:=_Runs.Norm;
    NEXT(_Runs);
    INC(i);
   END; (* WHILE OCCURE(_Runs) ... *)
   REPLACE(MarkREN);
   L_AFM.AF_PurgeTemp("_Runs");
  END;
 END {ReSortRuns};

 PRIVATE PROCEDURE CheckMarkRENOrder(OnIns, REN_ByMark: SCAL[2]);
 VAR
  curDate, prvDate        : LIKE(MarkREN.Date);
  curMark, prvMark        : LIKE(MarkREN.Mark);
  curRepEvent, prvRepEvent: LIKE(MarkREN.RepEvent);
 BEGIN
  curDate    :=MarkREN.Date;
  curMark    :=MarkREN.Mark;
  curRepEvent:=MarkREN.RepEvent;
  IF OnIns THEN
   SETEMPTY(prvDate, prvMark, prvRepEvent);
  ELSE
   prvDate    :=GE_PVALUE(MarkREN.Date);
   prvMark    :=GE_PVALUE(MarkREN.Mark);
   prvRepEvent:=GE_PVALUE(MarkREN.RepEvent);
  END;

  IF (curMark # prvMark) | (curRepEvent # prvRepEvent) THEN
   SETEMPTY(prvDate);
  END;

  SAVE(MarkREN);
  L_AFM.MakeMultipleIndex("_MREND", "Mark    : LIKE(MarkREN.Mark);" +
                                    "RepEvent: LIKE(MarkREN.RepEvent);" +
                                    "oldDate : LIKE(MarkREN.Date)",
                          "Mark    : Mark, RepEvent, oldDate;" +
                          "RepEvent: RepEvent, Mark, oldDate");
  IF REN_ByMark THEN
   SELECT(MarkREN, Mark, ,     curMark,     curRepEvent);
  ELSE
   SELECT(MarkREN, RepEvent, , curRepEvent, curMark);
  END;

  WHILE OCCURE(MarkREN) DO
   IF (MarkREN.Date = curDate)  THEN
    _MREND.oldDate:=prvDate;
   ELSE
    _MREND.oldDate:=MarkREN.Date;
   END;
   _MREND.Mark    :=MarkREN.Mark;
   _MREND.RepEvent:=MarkREN.RepEvent;
   INSERT(_MREND);
   NEXT(MarkREN);
  END; (* WHILE OCCURE(MarkREN) *)


  IF REN_ByMark THEN
   SELECT(MarkREN, Mark, ,     curMark,     curRepEvent);
   SELECT(_MREND,  Mark);
  ELSE
   SELECT(MarkREN, RepEvent, , curRepEvent, curMark);
   SELECT(_MREND,  RepEvent);
  END;

  WHILE OCCURE(MarkREN) DO
   IF MarkREN.Date # _MREND.oldDate THEN
    L_General.Assert(_MREND.oldDate = prvDate,
                     "䨪 ਢ   浪 ᫥ ଠ⨢");
   END;
   NEXT(MarkREN);
   NEXT(_MREND);
  END; (* WHILE OCCURE(MarkREN) *)
  RESTORE(MarkREN);
 END {CheckMarkRENOrder};

 PRIVATE PROCEDURE MarkREN_OnAfterEdIns(OnIns: SCAL[2]);
 BEGIN
  CheckMarkRENOrder(OnIns, RTI.Get().CurWindow.ParentZone.Window.OriginalName = "MarkREN");
  SupportBegEndDate(0);
  ReSortRuns();
 END {MarkREN_OnAfterEdIns};

 PRIVATE PROCEDURE MarkREN_OnAfterInsert();
 BEGIN
  MarkREN_OnAfterEdIns(1);
 END {MarkREN_OnAfterInsert};

 PRIVATE PROCEDURE MarkREN_OnAfterEdit();
 BEGIN
  MarkREN_OnAfterEdIns(0);
 END {MarkREN_OnAfterEdit};

 PRIVATE PROCEDURE MarkREN_OnBeforeDelete();
 BEGIN
  SupportBegEndDate(1);
 END {MarkREN_OnBeforeDelete};

 PRIVATE PROCEDURE SetModifiableFields(FieldsSet: SCAL[3]; Modif: SCAL[2]);
  VAR
   i     : NUMERIC[0];
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF FieldsSet # fs_Run THEN
   Fields("MarkREN.RepEvent").Modifiable:=Modif;
   Fields("MarkREN.Mark").Modifiable    :=Modif;
   Fields("MarkREN.Date").Modifiable    :=Modif;
  END;

  IF FieldsSet # fs_Key THEN
   i:=0;
   WHILE i < RANGEOF(MarkREN.Run) DO
    Fields("MarkREN.Run["+L_Str.IntStr(i)+"]").Modifiable     :=Modif & ((i = 0) | ~!MarkREN.Run[i - 1]);
    Fields("MarkREN.Norm["+L_Str.IntStr(i)+"]").Modifiable    :=Modif & ~!MarkREN.Run[i];
    Fields("MarkREN.Norm["+L_Str.IntStr(i)+"]").MustBeNonempty:=Modif & ~!MarkREN.Run[i];
    INC(i);
   END;
  END;
 END {SetModifiableFields};

 PRIVATE PROCEDURE StandOnLastMarkREN();
 BEGIN
  IF RTI.Get().CurWindow.ParentZone.Window.OriginalName = "MarkREN" THEN
   SETSEL(MarkREN, Mark, MarkREN.Mark, MarkREN.RepEvent);
  ELSE
   SETSEL(MarkREN, RepEvent, MarkREN.RepEvent, MarkREN.Mark);
  END;
  LAST(MarkREN);
 END {StandOnLastMarkREN};

 PRIVATE PROCEDURE MarkREN_OnBeforeEdit();
 VAR
  CurDate : LIKE(MarkREN.Date);
 BEGIN
  CurDate:=MarkREN.Date;
  StandOnLastMarkREN();
  RTI.Get().CurZone.Fields("MarkREN.DateE").Modifiable:=CurDate = MarkREN.Date;
  L_General.Assert(CurDate = MarkREN.Date, "襭   ⮫쪮  ᫥ ଠ⨢");
 END {MarkREN_OnBeforeEdit};

 PRIVATE PROCEDURE MarkREN_Run_OnSuccessfulChange();
 BEGIN
  ReSortRuns();
  SetModifiableFields(fs_Run, 1);
 END {MarkREN_Run_OnSuccessfulChange};

 PRIVATE PROCEDURE MarkREN_Date_OnSuccessfulChange();
 BEGIN
  L_General.Assert(MarkREN.Date <= MarkREN.DateE, " 砭 ⢨ ଠ⨢|  砫 ⢨");
 END {MarkREN_Date_OnSuccessfulChange};

 PRIVATE PROCEDURE MarkREN_DateE_OnSuccessfulChange();
 BEGIN
  L_General.Assert(MarkREN.Date <= MarkREN.DateE, " 砭 ⢨ ଠ⨢|  砫 ⢨");
  SetModifiableFields(fs_Key, !MarkREN.DateE);
 END {MarkREN_DateE_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckAcceptableMarkRENEdit(Text: STRING[]);
  VAR
   _Date: DATE;
 BEGIN
  _Date:=MarkREN.Date;
  StandOnLastMarkREN();
  IF (MarkREN.Date # _Date) | PREV(MarkREN) THEN
   L_General.Assert(!MarkREN.DateE, Text + " ᫥ ⠭ ଠ⨢ ");
  END;
 END {CheckAcceptableMarkRENEdit};

 PRIVATE PROCEDURE MarkREN_Mark_OnSuccessfulChange();
 BEGIN
  CheckAcceptableMarkRENEdit(" થ " + MarkREN.Mark);
 END {MarkREN_Mark_OnSuccessfulChange};

 PRIVATE PROCEDURE MarkREN_RepEvent_OnSuccessfulChange();
 BEGIN
  CheckAcceptableMarkRENEdit(" ய " + MarkREN.RepEvent);
 END {MarkREN_RepEvent_OnSuccessfulChange};

 PRIVATE PROCEDURE MarkRENE_0_OnReposition();
 BEGIN
  IF ACCESS(MarkREN) THEN
   SetModifiableFields(fs_All, !MarkREN.DateE);
  END;
 END {MarkRENE_0_OnReposition};

 PRIVATE PROCEDURE REMGPrm_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="RepEvent";
  L_WDO.iZone        (1).Narrowing:="REPrm.RepEvent=RepEvent.RepEvent";
  L_WDO.iSubwindow   (1, "REPrmE");
  L_WDO.iProgs       (1, "MarkREN");
  L_WDO.iField       (2, "REMGPrm.MarkG").OnBeforeAsk:=1;
  L_WDO.iScsChange   (2, ["REMGPrm.MarkG"]);
  L_WDO.iProgs       (2, "MarkREN");
 END {REMGPrm_OnInitializeWindow};

 PRIVATE PROCEDURE REMGPrm_MarkG_OnBeforeAsk();
 BEGIN
  L_Way.v_MarkGT:=L_Way.mgt_REPlan;
 END {REMGPrm_MarkG_OnBeforeAsk};

 PRIVATE PROCEDURE REMGPrm_MarkG_OnSuccessfulChange();
  VAR
   Dummy: STRING[];
 BEGIN
  IF ~!REMGPrm.MarkG THEN
   Dummy:=P_Mark.GetMarkGName(L_Way.mgt_REPlan, REMGPrm.MarkG);
  END;
 END {REMGPrm_MarkG_OnSuccessfulChange};

 PRIVATE PROCEDURE REPrm_OnAfterEdIns();
 BEGIN
  L_General.Assert(REPrm.TeamAmnt > 0, "⢮ ਣ    0");
  IF REPrm.TeamAmnt > 1 THEN
   L_General.Assert(~!REPrm.FstTeamD, " 㪠  砫 ᬥ ࢮ ਣ");
  END;
 END {REPrm_OnAfterEdIns};

 PRIVATE PROCEDURE REPrm_OnAfterInsert();
 BEGIN
  REPrm_OnAfterEdIns();
 END {REPrm_OnAfterInsert};

 PRIVATE PROCEDURE REPrm_OnAfterEdit();
 BEGIN
  REPrm_OnAfterEdIns();
 END {REPrm_OnAfterEdit};

BEGIN
 L_Events.ExecuteHandler();
END.
