(*
%Copyright   (c) Polak IT
%Author      02.10.2003 12:28:15 POLAK\Gina
%Purpose     ९ 
%Type        control, report
%Specific    AP
%Modified    24.01.2014 13:56:23 POLAK\MLB
%Environment
*)

 IMPORT L_General, L_Staff, L_Car, L_OwnData, L_AFM, L_Env, Memo, L_Events, L_WDO, L_DatTim,
        L_two, L_EDO, L_PRoll, L_AR;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                                          ९   ##########                                      |
}
*)

(*
$P{ TopSort:
Sort.Sort, L, ""
Sort.Name, L, ""
@
|------------------------------------------------------------------------------------------------------------|
| ### ####################################                                                             |
|------------------------------------------------------------------------------------------------------------|
|.|. |ઠ              |||ﭨ |.                                            |N|
|----|----------|-------------------|--|----|----------|---------------------------------------------------|-|
}
*)

(*
$P{ Line:
CarLog.BoxNbr, L, ""
CarLog.StateNbr, L, ""
CarLog.Mark, L, ""
Mark.Name, L, ""
CarLog.Column, L, ""
Car.BegDate, L, "y"
CarLog.Status, L, " ᯫ.| |ᠭ"
Tmp01._TSN, L, ""
Man.Name, L, ""
Tmp01._Nbr, L, L_Car.mcfn_Pool
@
|####|##########|#### ##############|##|####|##########|##### #############################################|#|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE InsTmp01();
 BEGIN
  Tmp01._Sort  :=StaffLog.Sort;
  Tmp01._Column:=CarLog.Column;
  Tmp01._Mark  :=CarLog.Mark;
  Tmp01._BoxNbr:=CarLog.BoxNbr;
  Tmp01._TSN   :=MCFix.TSN;
  Tmp01._Nbr   :=MCFix.Nbr;
  INSERT(Tmp01);
 END {InsTmp01};

 PRIVATE PROCEDURE PutSingleMCFix(OnDate: DATE);
 BEGIN
  CONFORM(MCFix, Car);
  L_Car.StandOnCarLog(MCFix.BoxNbr, OnDate);
  InsTmp01();
 END {PutSingleMCFix};

 PRIVATE PROCEDURE MakeTmp01(OnDate: DATE);
 BEGIN
  SELECT(MCFix, TSN);
  WHILE OCCURE(MCFix) DO
   PROMPT(": ⠡. "+MCFix.TSN);
   CONFORM(MCFix, Staff);
   IF L_Staff.rInState(OnDate) & L_Env.RealTSN(MCFix.TSN) THEN
    CONFORM(StaffLog, Officer);
    SAVE(MCFix);
    IF L_Car.StandOnFirstMCFix(MCFix.TSN, OnDate) THEN
     PutSingleMCFix(OnDate);
    END;
    RESTORE(MCFix);
    SAVE(MCFix);
    IF L_Car.StandOnSecondaryMCFix(MCFix.TSN, OnDate) THEN
     PutSingleMCFix(OnDate);
    END;
    RESTORE(MCFix);
   END;
   SRCINSEL(MCFix, GT, , MCFix.TSN);
  END; (* WHILE OCCURE(MCFix) ... *)
 END {MakeTmp01};

 PRIVATE PROCEDURE MCFix();
  CONST
   RepName = "MCFix";
  VAR
   OnDate: DATE;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  OnDate:=Memo.ud_cd();
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, OnDate);
 
  L_AFM.MakeIndex("Tmp01", "_Sort  : LIKE(Sort.Sort);"+
                              "_Column: LIKE(Car.Column);"+
                              "_Mark  : LIKE(Mark.Mark);"+
                              "_BoxNbr: LIKE(Car.BoxNbr);"+
                              "_TSN   : LIKE(Staff.TSN);" +
                              "_Nbr   : LIKE(MCFix.Nbr)");
  MakeTmp01(OnDate);
 
  SELECT(Tmp01, Tmp01);
  WHILE OCCURE(Tmp01) DO
   PROMPT(": ⠡. "+Tmp01._TSN);
   NARROWSEL(Tmp01, _Sort);
   SEARCH(Sort, Sort, , Tmp01._Sort);
   MAKEPART(R, TopSort);
   WHILE OCCURE(Tmp01) DO
    L_General.CallUs(L_Car.StandOnCarLogSoft(Tmp01._BoxNbr, OnDate));
    CONFORM(CarLog, Car, Mark);
    SEARCH(Staff, TSN, , Tmp01._TSN);
    CONFORM(Staff, Man);
    MAKEPART(R, Line);
    NEXT(Tmp01);
   END; (* WHILE OCCURE(Tmp01) ... *)
   NEXTINEXTENDEDSEL(Tmp01, _Sort);
  END; (* WHILE OCCURE(Tmp01) ... *)
 
  L_AFM.AF_PurgeTemp("Tmp01");
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {MCFix};

 PRIVATE PROCEDURE CheckModificationAllowed();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(L_Env.MCFixModificationThroughEDOrder);
  IF ~!Local THEN
   L_General.Assert(~Local(MCFix.Begin), "९ ଫ ਪ  ᮭ");
  END;
  L_General.Assert(!MCFix._EDOrder,   " ९ ଫ ਪ  ᮭ");
  RTI.Get().CurZone.Fields("MCFix.JRegime").Modifiable:=L_PRoll.E_UseMCFixPay(1, MCFix.Begin);
 END {CheckModificationAllowed};

 PRIVATE PROCEDURE MCFix_OnBeforeEdIns();
 BEGIN
  RTI.Get().CurZone.Fields("MCFix.Nbr").Format:=L_Car.mcfn_Pool;
  CheckModificationAllowed();
  L_AR.GrantRightsForInteractiveModification();
 END {MCFix_OnBeforeEdIns};

 PRIVATE PROCEDURE MCFix_OnBeforeEdit();
 BEGIN
  MCFix_OnBeforeEdIns();
 END {MCFix_OnBeforeEdit};

 PRIVATE PROCEDURE MCFix_OnBeforeInsert();
 BEGIN
  MCFix_OnBeforeEdIns();
 END {MCFix_OnBeforeInsert};

 PRIVATE PROCEDURE MCFix_OnAfterEdIns();
  VAR
   D: DATE;
 BEGIN
  L_General.Assert(MCFix.Begin < MCFix.Till, " ਮ ࠭ 砫?");

  L_two.m_MarkAsNotActual(MCFix.TSN, MCFix.Begin, L_DatTim.till2ED(MCFix.Till));

  CONFORM(MCFix, Car);
  L_General.Assert(L_DatTim.IsActiveInIntvl(MCFix.Begin, MCFix.Till, Car.BegDate, Car.EndDate),
                   " " + Car.BoxNbr + "    ਮ ९");
  CONFORM(MCFix, Staff);

  L_Staff.PosToStaffLog(MCFix.TSN, MCFix.Begin, 1);
  L_General.Assert(MCFix.Begin <= Staff.EndDate, "⭨ 㢮 " + L_DatTim.DateStr(Staff.EndDate));

  CHANGESEL(MCFix, TSN, , MCFix.TSN, MCFix.Nbr);

  SAVE(MCFix);
  IF ~!MCFix.Till THEN
   D:=MCFix.Till;
   L_General.Assert(~NEXT(MCFix) | (MCFix.Begin >= D), "ਮ ⢨ ᥪ  㣨 ९");
   RESTORE(MCFix);
  ELSE
   IF NEXT(MCFix) THEN
    D:=MCFix.Begin;
    RESTORE(MCFix);
    MCFix.Till:=D;
    REPLACE(MCFix);
   ELSE
    RESTORE(MCFix);
   END;
  END;

  D:=MCFix.Begin;
  IF PREV(MCFix) & (MCFix.Till > D) THEN
   IF ~!MCFix._EDOrder & SEARCH(EDOrderL, EDOrder, MCFix._EDOrder, MCFix._Row) THEN
    L_General.Assert(!EDOrderL.EndDate,
                     "ਮ ⢨ ᥪ  ९,|⠭ ਪ " + EDOrderL.EDOrder);
   END;
   MCFix.Till:=D;
   REPLACE(MCFix);
  END;
 END {MCFix_OnAfterEdIns};

 PRIVATE PROCEDURE MCFix_OnAfterEdit();
 BEGIN
  L_two.m_MarkAsNotActual(GE_PVALUE(MCFix.TSN), GE_PVALUE(MCFix.Begin), L_DatTim.till2ED(GE_PVALUE(MCFix.Till)));
  MCFix_OnAfterEdIns();
 END {MCFix_OnAfterEdit};

 PRIVATE PROCEDURE MCFix_OnAfterInsert();
 BEGIN
  MCFix_OnAfterEdIns();
 END {MCFix_OnAfterInsert};

 PRIVATE PROCEDURE _MCFix_OnBeforeDelete();
  VAR
   B, T: DATE;
 BEGIN
  L_two.m_MarkAsNotActual(MCFix.TSN, MCFix.Begin, L_DatTim.till2ED(MCFix.Till));
  B:=MCFix.Begin;
  CHANGESEL(MCFix, TSN, , MCFix.TSN, MCFix.Nbr);
  SAVE(MCFix);
  IF NEXT(MCFix) THEN
   T:=MCFix.Begin;
  ELSE
   SETEMPTY(T);
  END;
  RESTORE(MCFix);
  IF PREV(MCFix) & (MCFix.Till = B) THEN
   IF !MCFix._EDOrder THEN
    MCFix.Till:=T;
    REPLACE(MCFix);
   ELSE
    SEARCH(EDOrderL, EDOrder, , MCFix._EDOrder, MCFix._Row);
    IF !EDOrderL.EndDate THEN
     MCFix.Till:=T;
     REPLACE(MCFix);
    END;
   END;
  END;
 END {_MCFix_OnBeforeDelete};

 PRIVATE PROCEDURE MCFix_OnBeforeDelete();
 BEGIN
  CheckModificationAllowed();
  _MCFix_OnBeforeDelete();
 END {MCFix_OnBeforeDelete};

 PRIVATE PROCEDURE MCFANY_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="MCFix";
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).HasVariousSubwindows:=1;
  L_WDO.iField       (1, "MCFix.Nbr").Format:=L_Car.mcfn_Pool;
 END {MCFANY_OnInitializeWindow};

 PRIVATE PROCEDURE MCFCar_OnInitializeWindow();
 BEGIN
  MCFANY_OnInitializeWindow();
  L_WDO.iZone        (1).Narrowing:="MCFix.BoxNbr=Car.BoxNbr";
 END {MCFCar_OnInitializeWindow};

 PRIVATE PROCEDURE MCFStaff_OnInitializeWindow();
 BEGIN
  MCFANY_OnInitializeWindow();
  L_WDO.iZone        (1).Narrowing:="MCFix.TSN=Staff.TSN";
 END {MCFStaff_OnInitializeWindow};

 PRIVATE PROCEDURE EDOrderL_OnAfterInsert();
 BEGIN
  MCFix_OnAfterInsert();
 END {EDOrderL_OnAfterInsert};

 PRIVATE PROCEDURE EDOrderL_OnBeforeDelete();
 BEGIN
  SAVE(MCFix);
  _MCFix_OnBeforeDelete();
  RESTORE(MCFix);
 END {EDOrderL_OnBeforeDelete};

 PRIVATE PROCEDURE MCFCar_1_OnSetSubwindow();
 BEGIN
  L_EDO.gbo_SetSubwindow("MCFixE");
 END {MCFCar_1_OnSetSubwindow};

 PRIVATE PROCEDURE MCFStaff_1_OnSetSubwindow();
 BEGIN
  L_EDO.gbo_SetSubwindow("MCFixE");
 END {MCFStaff_1_OnSetSubwindow};

 PUBLIC PROCEDURE scs_GetFilters_MCFCar_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "஬ ९ 㢮 ࠡ⭨", "(MCFix.Dschrg>=Memo.CurDate)", 1);
 END {scs_GetFilters_MCFCar_1};

BEGIN
 L_Events.ExecuteHandler();
END.
