(*
%Copyright   (c) Polak Computer System
%Author      30.08.1999 14:50:31 SAN
%Purpose     ஫ 䨪樨 MDocLCU
%Type        control
%Specific    SYS
%Modified    04.01.2013 15:35:05 ROBOT by POLAK\LDA
%Environment
*)

 MODULE MDocLCU [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Math, Str, L_Str, L_General, L_Events, L_MDoc, L_BarCode, L_MathR,
        L_CUC, L_StdFrm, L_XDoc, L_Pmnt, L_DatTim, L_AFM, L_TRS;

 PRIVATE CONST
  sb_Ser = 0;
  sb_Num = 1;

 PRIVATE PERMANENT VAR
  deletedCUCopy: LIKE(MDocLCU.CUCopy);

 PRIVATE PROCEDURE intRemoveTrace(trgCUCopy: LIKE(MDocLCU.CUCopy); VAR Asked: SCAL[2]; Multiple: SCAL[2]);
 BEGIN
  L_General.CallUs(SEARCH(CUCopy, CUCopy, trgCUCopy));
  L_CUC.SetCUCValidity(trgCUCopy);
  IF ~L_General.IsPolakSpecific() THEN
   TRY
    TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
     SE_INTEGRITY(1);
     CALL(CUCopy.CUCopy_OnBeforeNoninteractiveDelete());
     TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
      REMOVE(CUCopy);
     EXCEPT
     END; (* TRY *)
    EXCEPT
    END; (* TRY *)
    IF ~Asked THEN
     IF Multiple THEN
      L_StdFrm.Choice("!" +
                      "| " + trgCUCopy + " , , 㣨 " +
                      "| 㤠  ࠢ筨 ஢." +
                      "||த?");
     ELSE
      L_StdFrm.Choice("!" +
                      "| " + trgCUCopy + " 㤥 㤠  ࠢ筨 ஢." +
                      "||த?");
     END;
     Asked:=1;
    END; (* IF ~Asked *)
   EXCEPT
   ON Exc:Exc_Raise DO
   ON Exc:Exc_RunTime DO
    IF Exc.ErrorCode # L_General.ec_rt_NoDeleteUser THEN
     RAISE();
    END;
   END;
  END; (* IF ~L_General.IsPolakSpecific() *)
 END {intRemoveTrace};

 PRIVATE PROCEDURE RemoveTrace(trgCUCopy: LIKE(MDocLCU.CUCopy));
  VAR
   Asked: SCAL[2];
 BEGIN
  Asked:=0;
  intRemoveTrace(trgCUCopy, Asked, 0);
 END {RemoveTrace};

 PRIVATE PROCEDURE SetOpKindFlagEdit(Edit: SCAL[2]);
 BEGIN
  RTI.Get().CurZone.Fields("MDocLCU.OpKind").Modifiable:=Edit;
 END {SetOpKindFlagEdit};

 PRIVATE PROCEDURE MDocLCU_OnBeforeEdit();
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = "MDocLCU" THEN
   SetOpKindFlagEdit(!L_MDoc.E_DefineMDocLCU_OpKind());
   L_CUC.MustBeLastCUCopyMDocLCU();
  ELSE
   L_General.BadMode(MODE);
  END;
 END {MDocLCU_OnBeforeEdit};

 PRIVATE PROCEDURE MDocLCU_OnBeforeInsert();
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = "MDocLCU" THEN
   MDocLCU.OpKind:=L_MDoc.E_DefineMDocLCU_OpKind();
   IF ~!MDocLCU.OpKind THEN
    REPLACE(MDocLCU);
    SetOpKindFlagEdit(0);
   ELSE
    SetOpKindFlagEdit(1);
   END;
  ELSE
   L_General.BadMode(MODE);
  END;
 END {MDocLCU_OnBeforeEdit};

 PRIVATE PROCEDURE MDocLCU_OnAfterEdIns();
 BEGIN
  CONFORM(MDocLCU, CUCopy);
  IF (CUCopy.Origin = L_CUC.o_Other) | (CUCopy.Origin = L_CUC.o_KeyAss) THEN
   L_CUC.CompleteMDocLCU(0);
  ELSE
   L_General.Error("   '" + L_Str.PoolItem(L_CUC.o_Pool, CUCopy.Origin) + "'.||    ᯮ짮  ");
  END;
 END {MDocLCU_OnAfterEdIns};

 PRIVATE PROCEDURE MDocLCU_OnAfterEdit();
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = "MDocLCU"  THEN
   IF MDocLCU.CUCopy # GE_PVALUE(MDocLCU.CUCopy) THEN
    RemoveTrace(GE_PVALUE(MDocLCU.CUCopy));
   END;
   MDocLCU_OnAfterEdIns();
  ELSE
   L_General.BadMode(MODE);
  END;
 END {MDocLCU_OnAfterEdit};

 PRIVATE PROCEDURE MDocLCU_OnAfterInsert();
 BEGIN
  MDocLCU_OnAfterEdIns();
 END {MDocLCU_OnAfterInsert};

 PRIVATE PROCEDURE MDocLCU_OnBeforeDelete();
 BEGIN
  L_CUC.MustBeLastCUCopyMDocLCU();
  deletedCUCopy:=MDocLCU.CUCopy;
 END {MDocLCU_OnBeforeDelete};

 PRIVATE PROCEDURE MDocLCU_OnAfterDelete();
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = "MDocLCU"  THEN
   RemoveTrace(deletedCUCopy);
  ELSE
   L_General.BadMode(MODE);
  END;
 END {MDocLCU_OnAfterDelete};

 PRIVATE PROCEDURE MathStr(_Math: LIKE(Math.Math)): STRING[];
  VAR
   s, r: STRING[];
   sf: STRING[][10];
   i: NUMERIC[0];
 BEGIN
  s:=_Math;
  SAVE(Math);
  IF SEARCH(Math, Math, _Math) THEN
   s:=s+": "+Math.Name;
  END;
  RESTORE(Math);
  L_Str.FormatStr(sf, s, 64);
  i:=0; r:="";
  WHILE sf[i]#"" DO
   r:=r+sf[i]+"|";
   INC(i);
  END;
  RETURN r;
 END {MathStr};

 PRIVATE CONST
  tryAnotherMDocList = " ஡ 㣮  22.09.2003 19:00:03 POLAK\San";

 PRIVATE PROCEDURE IsAutoAppendMDocListRegime(): SCAL[2];
 BEGIN
  RETURN (MDoc.MDocKind = L_MDoc.md_TOV) |
         (MDoc.MDocKind = L_MDoc.md_NOV) |
         (MDoc.MDocKind = L_MDoc.md_ViP) |
         (MDoc.MDocKind = L_MDoc.md_MSP) |
         (MDoc.MDocKind = L_MDoc.md_VPC) ;
 END {IsAutoAppendMDocListRegime};

 PRIVATE PROCEDURE AppendMDocList(_Math: LIKE(Math.Math));
 BEGIN
  IF SELECT(MDocList, MDLMath, MDoc.MDocKind, MDoc.MDoc, _Math, L_MathR.mm_New) THEN
   INC(MDocList.Qnt);
   REPLACE(MDocList);
  ELSE
   L_MDoc.InsMDocList(_Math, L_MathR.mm_New, L_MDoc.E_DefaultVATMode(MDoc.Date, _Math), 1, 0, 0);
  END;
  CONFORM(MDocList, Math);
  IF L_Pmnt.E_MDocListMustHasCstDclr() THEN
   IF L_MDoc.getMDocListMathFlowType() = L_MDoc.mft_Credit THEN
    MDocList.CstDclr:=L_Pmnt.GetMDocListCstDclr();
    REPLACE(MDocList);
   END;
  END;
 END {AppendMDocList};

 PRIVATE PROCEDURE GetMDLNbr(_Math      : LIKE(Math.Math);
                             _CUCopy    : LIKE(CUCopy.CUCopy);
                             startMDLNbr,
                             baseMDLNbr: LIKE(MDocList.MDLNbr)): LIKE(MDocList.MDLNbr);
  VAR
   cMDLNbr : LIKE(MDocList.MDLNbr);
   cAmount,
   _count  : NUMERIC[0];
   _Problem: SCAL[3];
 BEGIN
  SETEMPTY(cMDLNbr);
  _Problem:=0;
  SETSEL(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc);
  SRCINSEL(MDocList, GE, , startMDLNbr);
  WHILE OCCURE(MDocList) DO
   CONFORM(MDocList, Math);
   IF L_MathR.E_IsComplexMath(MDoc.Date) THEN
    cMDLNbr:=MDocList.MDLNbr;
    cAmount:=MDocList.Qnt;
   ELSIF ~L_MDoc.E_MDocListIsPartOfComplex(MDoc.Date) THEN
    cAmount:=1;
   END;
   IF MDocList.Math=_Math THEN
    CONFORM(MDocList, MDocLCU); _count:=0;
    WHILE OCCURE(MDocLCU) DO
     NEXT(MDocLCU); INC(_count);
    END;
    IF _count<MDocList.Qnt*cAmount THEN
     IF !baseMDLNbr THEN
      RETURN MDocList.MDLNbr;
     ELSE
      IF !cMDLNbr THEN
       L_General.Error(" " + _CUCopy + "   樨 '⮢'  ।饬 㬥"+
                       "|" +
                       "  ஢   ᮮ⢥⢨   ⮢୮ 㬥");
      ELSIF baseMDLNbr > cMDLNbr THEN
       RETURN MDocList.MDLNbr;
      ELSE
      _Problem:=2;
      END;
     END;
    ELSE
     _Problem:=Math.Max(1, _Problem);
    END;
   END;
   NEXT(MDocList);
  END;

  IF    _Problem = 2 THEN
   L_General.Error(tryAnotherMDocList);
  ELSIF IsAutoAppendMDocListRegime() THEN
   AppendMDocList(_Math);
   RETURN MDocList.MDLNbr;
  ELSIF _Problem = 0 THEN
    L_General.Error("ꥪ|"+MathStr(_Math)+"|  㬥");
  ELSIF _Problem = 1 THEN
   L_General.Error("ꥪ|"+MathStr(_Math)+"|㦥   㬥  㦭 ⢥");
  END;
 END {GetMDLNbr};

 PRIVATE VAR
  LastError: STRING[];

 PRIVATE PROCEDURE EnterForm(Title, Hint, Message: STRING[]): STRING[];
  VAR
   Dummy  : L_BarCode.tBarCodeType;
   BarCode: STRING[];
 BEGIN
  IF ~!LastError THEN
   L_BarCode.GetBarCode(Title, Hint, LastError, 1, 1, BarCode, Dummy);
  ELSE
   L_BarCode.GetBarCode(Title, Hint, Message,   0, 1, BarCode, Dummy);
  END;
  RETURN BarCode;
 END {EnterForm};

 PRIVATE PROCEDURE SliceCode(s: STRING[]): SCAL[1e9];
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   RETURN L_Str.RightFrom(s, 1);
  EXCEPT
  ON Exc:Exc_RunTime DO
   IF (Exc.ErrorCode=47) | (Exc.ErrorCode=48) THEN
    RETURN L_General.EMPTY_NUMBER();
   ELSE
    RAISE();
   END;
  END; (* TRY *)
 END {SliceCode};

 PRIVATE PROCEDURE CompleteByComplexing(baseMDLNbr: LIKE(MDocList.MDLNbr);
                                        baseOpKind: LIKE(MDocLCU.OpKind));
  VAR
   _CUCopy: LIKE(CUCopy.CUCopy)[50];
   i      : NUMERIC[0];
 BEGIN
  IF (baseOpKind=L_CUC.ok_Retire) | (baseOpKind=L_CUC.ok_Sale) THEN
   SAVE(MDocLCU);
   IF L_CUC.AccessLastMDocLCU(CUCopy.CUCopy) THEN
    IF (MDocLCU.MDocKind = MDoc.MDocKind) &
       (MDocLCU.MDoc     = MDoc.MDoc    ) THEN
     PREV(MDocLCU);
    END;
   END;
   WHILE OCCURE(MDocLCU) & ((MDocLCU.OpKind=L_CUC.ok_Relocation)|(MDocLCU.OpKind=L_CUC.ok_Mentioning)) DO
    PREV(MDocLCU);
   END;
   L_General.Assert(OCCURE(MDocLCU) &
                    ((MDocLCU.OpKind=L_CUC.ok_Accpt     )|
                     (MDocLCU.OpKind=L_CUC.ok_Complexing)|
                     (MDocLCU.OpKind=L_CUC.ok_Dismant   )),
                    "   ਭ, ᪮⮢  饭|"+CUCopy.Serial);
   CHANGESEL(MDocLCU, MDoc, , MDocLCU.MDocKind, MDocLCU.MDoc);
   FIRST(MDocLCU);
   SETEMPTY(_CUCopy);
   i:=0;
   WHILE OCCURE(MDocLCU) DO
    IF MDocLCU.OpKind=L_CUC.ok_Complexing THEN
     _CUCopy[i]:=MDocLCU.CUCopy;
     INC(i);
    END;
    NEXT(MDocLCU);
   END; (* WHILE OCCURE(MDocLCU) ... *)
   i:=0;
   WHILE ~!_CUCopy[i] DO
    IF _CUCopy[i]#CUCopy.CUCopy THEN
     SAVE(CUCopy);
     SAVE(MDocLCU);
     L_General.Assert(SEARCH(CUCopy, CUCopy, _CUCopy[i]),
                      "    "+_CUCopy[i]);
     L_CUC.InsMDocLCU(_CUCopy[i], GetMDLNbr(CUCopy.Math, _CUCopy[i], baseMDLNbr-1, baseMDLNbr), baseOpKind);
     RESTORE(MDocLCU);
     RESTORE(CUCopy);
    END;
    INC(i);
   END;
   RESTORE(MDocLCU);
  END;
 END {CompleteByComplexing};

 PRIVATE PROCEDURE IsMath_wCUCopy(_Math: LIKE(Math.Math); D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(Math);
  SAVE(CarUnit);
  SEARCH(Math, Math, , _Math);
  CONFORM(Math, CarUnit);
  Result:=CarUnit.SNDate <= D;
  RESTORE(CarUnit);
  RESTORE(Math);
  RETURN Result;
 END {IsMath_wCUCopy};

 PRIVATE PROCEDURE _InputFromBCS(): SCAL[2];
  CONST
   BadMath =   "    ࠦ '!'|";
   BadCUCopy = "    ࠦ '%'|";
  VAR
   _BarCode,
   _Serial  : STRING[];
   _OpKind  : LIKE(MDocLCU.OpKind);
   _Math    : LIKE(Math.Math);
   _MDLNbr  : LIKE(MDocList.MDLNbr);
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
   _XDoc    : L_XDoc.tXDoc;
   _CopyCnt : L_XDoc.tCopyCnt;
   cuExist  : SCAL[2];
 BEGIN
  _BarCode:=EnterForm(" /᪠஢ ", " ⮢/᪮ /!/%", "");
  IF _BarCode="" THEN
   RETURN 0;
  END;
  SETEMPTY(_Math, _Serial);
  cuExist:=0;
  IF    (L_Str.Char(_BarCode, 0)="%") & ~!SliceCode(_BarCode)(* 뢠   %  砫 *) THEN
   L_General.Assert(SEARCH(CUCopy, CUCopy, SliceCode(_BarCode)),
                    BadCUCopy+_BarCode);
   cuExist:=1;
  ELSIF (L_Str.Char(_BarCode, 0)="!") THEN
   L_General.Assert(SEARCH(Math, Math, SliceCode(_BarCode)),
                    BadMath+_BarCode);
   _Math:=Math.Math;
  ELSE
   L_XDoc.DecodeBarCode(L_BarCode.SCAN_STD_KBSCAN, _BarCode, 1, _XDocType, _XDocKind, _XDoc, _CopyCnt);
   IF    _XDocType = L_XDoc.xdt_CUCopy THEN
    cuExist:=1;
    SEARCH(CUCopy, CUCopy, , _XDoc);
   ELSIF _XDocType = L_XDoc.xdt_Math THEN
    IF L_XDoc.SearchMathBySerial(_BarCode, _Math) THEN
     _Serial:=_BarCode;
    ELSE
     _Math:=_XDoc;
    END;
   END;
  END;
  IF ~cuExist THEN
   L_General.Assert(~!_Math, " ⮢/᪮   ⭮    |"+_Serial);
   IF !_Serial THEN
    IF IsMath_wCUCopy(_Math, MDoc.Date) THEN
     SETEMPTY(LastError);
     _Serial:=EnterForm("᪮ ", MathStr(_Math), "");
     IF _Serial="" THEN
      RETURN 0;
     END;
    ELSIF IsAutoAppendMDocListRegime() THEN
     AppendMDocList(_Math);
     RETURN 1;
    ELSE
     L_General.Error(MathStr(_Math) + "| ஢  ");
    END;
   END;
   cuExist:=SEARCH(CUCopy, Serial, _Serial, _Math);
  END;

  IF cuExist THEN
   SELECT(MDocLCU, MDoc, , MDoc.MDocKind, MDoc.MDoc);
   WHILE OCCURE(MDocLCU) & (MDocLCU.CUCopy # CUCopy.CUCopy) DO
    NEXT(MDocLCU);
   END; (* WHILE OCCURE(MDocLCU) ... *)
   L_General.Assert(~OCCURE(MDocLCU),
                    " "+CUCopy.CUCopy+
                    ", ᪮  "+CUCopy.Serial+
                    "|㦥    㬥");
  ELSE
   DEFAULT(CUCopy);
   CUCopy.Math   :=_Math;
   CUCopy.Serial :=_Serial;
   INSERT(CUCopy);
  END;

  _MDLNbr:=0;
  LOOP
   TRY
    _MDLNbr:=GetMDLNbr(CUCopy.Math, CUCopy.CUCopy, _MDLNbr+1, L_General.EMPTY_NUMBER());
    _OpKind:=L_MDoc.E_DefineMDocLCU_OpKind();
    IF    (_OpKind=L_CUC.ok_Retire)     |
          (_OpKind=L_CUC.ok_Dismant)    |
          (_OpKind=L_CUC.ok_Sale)       |
          (_OpKind=L_CUC.ok_Setting)    |
          (_OpKind=L_CUC.ok_Relocation) |
          (_OpKind=L_CUC.ok_Complexing) THEN
     L_General.Assert(cuExist,
                      "   㪠 ⮫쪮 騩 |"+CUCopy.Serial);
    ELSIF (_OpKind=L_CUC.ok_Accpt)      |
          (_OpKind=L_CUC.ok_Fixup)      |
          (_OpKind=L_CUC.ok_Mentioning) THEN
     (* nothing *);
    ELSIF !_OpKind THEN
     L_General.Error(" ⮬᪮ ⠢  室 ࠢ । '樨'"
                     + L_StdFrm.HR()
                     + ", ᫥   ࠢ筨 '樠 樨  '");
    ELSE
     L_General.Error(" ࠢ । '樨'  ⮬᪮ ⠢  ᫥, "
                     + " 室 ᯮ짮 '" + L_Str.PoolItem(L_CUC.ok_Pool, _OpKind) + "'."
                     + "| ਥ");
    END;
    L_CUC.InsMDocLCU(CUCopy.CUCopy, _MDLNbr, _OpKind);
    CompleteByComplexing(_MDLNbr, _OpKind);
    RETURN 1;
   EXCEPT
   ON Exc:Exc_Raise DO
    IF Exc.MsgOriginalText = tryAnotherMDocList THEN
     (* nothing *)
    ELSE
     RAISE()
    END;
   END; (* TRY *)
  END; (* LOOP *)
 END {_InputFromBCS};

 PUBLIC PROCEDURE InputFromBCS();
  VAR
   _exit: SCAL[2];
 BEGIN
  SETEMPTY(_exit, LastError);
  WHILE _exit#1 DO
   SAVE(MDoc);
   TRY
    _exit:=~_InputFromBCS();
   EXCEPT
   ON Exc:Exc_Raise DO
    IF Exc.MsgOriginalText # L_BarCode.ed_FinalError THEN
     LastError:=Exc.MsgOriginalText;
    ELSE
     _exit:=1;
    END;
   ELSE
    RAISE();
   END; (* TRY *)
   RESTORE(MDoc);
   IF _exit = 0 THEN
    IF (RTI.Get().CurWindow.OriginalName = "MDocLCU1") & OCCURE(MDocLCU) THEN
     SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), MDocLCU);
    END;
    LIKEMENU(CALL, "MDocLCU.InputFromBCS()");
   END;
  END; (* WHILE _exit#1 ...*)
 END {InputFromBCS};

 PRIVATE PROCEDURE MDocLCU1_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("MDocLCU.OpKind").Format:=L_CUC.ok_Pool;
 END {MDocLCU1_1_OnZoneOpen};

 PRIVATE PROCEDURE MDocLCU_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("MDocLCU.OpKind").Format:=L_CUC.ok_Pool;
 END {MDocLCU_1_OnZoneOpen};

 PRIVATE PROCEDURE bt_NextSeries(ser: STRING[]): STRING[];
  VAR
   pos: NUMERIC[0];
   res: STRING[];
   num: STRING[1];
 BEGIN
  IF !ser THEN
   RETURN ser;
  END;
  pos:=Str.Length(ser) - 1;
  res:=ser;
  LOOP
   L_General.Assert(pos >= 0, '⭮,    ᫥ "' + ser + '"');
   num:=L_Str.Char(ser, pos);
   IF num = "9" THEN
    res:=Str.Slice(res, 0, pos) + "0" + Str.Slice(res, pos + 1, Str.Length(res));
    pos:=pos - 1;
   ELSE
    res:=Str.Slice(res, 0, pos) + CHR(ORD(num)+1) + Str.Slice(res, pos + 1, Str.Length(res));
    RETURN res;
   END;
  END;
 END {bt_NextSeries};

 PRIVATE PROCEDURE tbpi_CompleteNumber(num: STRING[]): NUMERIC[0];
 BEGIN
  IF Str.Length(num) < TckKind.NbrPrc THEN
   num:=num + L_Str.FixedIntStr(TckKind.FstInPck, TckKind.NbrPrc - Str.Length(num));
  END;
  RETURN STRTOFLD(num, NUMERIC);
 END {tbpi_CompleteNumber};

 PRIVATE PROCEDURE tbpi_TestSeries(_Ser: STRING[]): SCAL[2];
 BEGIN
  TRY
   L_TRS.CheckTicketSeries(TckKind.TckKind, _Ser);
  EXCEPT
  ON Exc: Exc_Raise DO
   L_StdFrm.RedInform(Exc.MsgOriginalText);
   RETURN 0;
  END; (* TRY *)
  RETURN 1;
 END {tbpi_TestSeries};

 PRIVATE PROCEDURE bt_PrepareIndex(IsTickets: SCAL[2]; serB, serE, numB, numE: STRING[]): SCAL[2];
  VAR
   ser    : STRING[];
   iter,
   cnt,
   num,
   _numB,
   _numE,
   Length : NUMERIC[0];
   oPrompt: PROMPTLINE;
 BEGIN
  oPrompt:=PROMPTLINE.Create("⮢");
  SELECT(list, series);
  REMSEL(list);
  IF IsTickets THEN
   Length:=TckKind.NbrPrc;
   _numB :=L_TRS.PackFirstNbr(TckKind.TckKind, tbpi_CompleteNumber(numB));
   _numE :=L_TRS.PackFirstNbr(TckKind.TckKind, tbpi_CompleteNumber(numE));
   iter  :=TckKind.PckVol;
   IF ~tbpi_TestSeries(serB) | ~tbpi_TestSeries(serE) THEN
    RETURN 0;
   END;
  ELSE
   Length:=Str.Length(numB);
   _numB :=STRTOFLD(numB, NUMERIC);
   _numE :=STRTOFLD(numE, NUMERIC);
   iter  :=1;
  END;
  ser:=serB;
  cnt:=0;
  WHILE (cnt = 0) | (~!ser) & (ser <= serE) DO
   num:=_numB;
   WHILE num <= _numE DO
    list.series :=ser;
    list.numbers:=L_Str.FixedIntStr(num, Length);
    list.include:=1;
    INSERT(list);
    PROMPT(list.series + " " + list.numbers);
    INC(num, iter);
   END;
   INC(cnt);
   ser:=bt_NextSeries(ser);
  END;
  RETURN 1;
 END {bt_PrepareIndex};

 PRIVATE CONST
  bt_SeriesLen  = 12;
  bt_NumbersLen = 16;

 PRIVATE PROCEDURE bt_ResortList(sortby: SCAL[2]; VAR included: NUMERIC[0]): STRING[];
  VAR
   el,
   _list : STRING[];
   Idx   : NUMERIC[0];
   oPrompt: PROMPTLINE;
 BEGIN
  oPrompt:=PROMPTLINE.Create("஢");
  included:=0;
  IF sortby = sb_Ser THEN
   SELECT(list, series);
  ELSE
   SELECT(list, numbers);
  END;
  _list:="";
  WHILE OCCURE(list) DO
   IF sortby = sb_Ser THEN
    el:=Str.Align(list.series, bt_SeriesLen, LEFT) + " " + Str.Align(list.numbers, bt_NumbersLen, LEFT);
   ELSE
    el:=Str.Align(list.numbers, bt_NumbersLen, LEFT) + " " + Str.Align(list.series, bt_SeriesLen, LEFT);
   END;
   PROMPT(el);
   _list:=_list + el + " [" + L_Str.PoolItem(" |x", list.include) + "]|";
   INC(included, list.include);
   NEXT(list);
  END;
  RETURN _list;
 END {bt_ResortList};

 PRIVATE PROCEDURE bt_Do(IsTickets: SCAL[2]; _OpKind: L_CUC.tOpKind; DoOperation: PROC; OpStr: STRING[]);
  VAR
   Cnt    : NUMERIC[0];
   serial : STRING[];
   oPrompt: PROMPTLINE;
 BEGIN
  oPrompt:=PROMPTLINE.Create("ࠡ⪠");
  Cnt:=0;
  SELECT(list, include, , 1);
  WHILE OCCURE(list) DO
   PROMPT(list.series + " " + list.numbers);
   IF IsTickets THEN
    serial:=L_TRS.cc_BuildSerial(list.series, list.numbers);
   ELSE
    serial:=Str.Condense(list.series + " " + list.numbers);
   END;
   DoOperation(serial, _OpKind);
   INC(Cnt);
   NEXT(list);
  END; (* WHILE OCCURE(list) ... *)
  L_StdFrm.Inform(OpStr + " " + L_Str.IntStr(Cnt) + " " +
                  Str.EnumObject(Cnt, "||஢"));
 END {bt_Do};

 PRIVATE PROCEDURE bt_PutOne(serial: STRING[]; _OpKind: L_CUC.tOpKind);
 BEGIN
  IF ~SEARCH(CUCopy, Serial, serial, MDocList.Math) THEN
   L_General.Assert(_OpKind = L_CUC.ok_Accpt, "    ᪨ ஬ " + serial);
   DEFAULT(CUCopy);
   CUCopy.Math  :=MDocList.Math;
   CUCopy.Serial:=serial;
   INSERT(CUCopy);
  END;
  L_General.Assert(~SEARCH(MDocLCU, MDoc, MDocList.MDocKind, MDocList.MDoc, MDocList.MDLNbr, CUCopy.CUCopy),
                   " ப 㬥 㦥 㯮   ᪨ ஬ " + serial);
  L_CUC.InsMDocLCU(CUCopy.CUCopy, MDocList.MDLNbr, _OpKind);
  L_CUC.CompleteMDocLCU(0);
 END {bt_PutOne};

 VAR
  bt_r_Asked: SCAL[2];

 PRIVATE PROCEDURE bt_RemoveOne(serial: STRING[]; _OpKind: L_CUC.tOpKind);
 BEGIN
  L_General.Assert(SEARCH(CUCopy, Serial, serial, MDocList.Math),
                   "    ᪨ ஬ " + serial);
  L_General.Assert(SEARCH(MDocLCU, MDoc, MDocList.MDocKind, MDocList.MDoc, MDocList.MDLNbr, CUCopy.CUCopy),
                   " ப 㬥  㯮   ᪨ ஬ " + serial);
  L_CUC.MustBeLastCUCopyMDocLCU();
  TRY
   SE_INTEGRITY(1);
   REMOVE(MDocLCU);
   intRemoveTrace(CUCopy.CUCopy, bt_r_Asked, 1);
  EXCEPT
  END; (* TRY *)
 END {bt_RemoveOne};

 PRIVATE PROCEDURE bt_Put(IsTickets: SCAL[2]; _OpKind: L_CUC.tOpKind);
 BEGIN
  bt_Do(IsTickets, _OpKind, PROCREF(bt_PutOne), "ନ஢");
 END {bt_Put};

 PRIVATE PROCEDURE bt_Remove(IsTickets: SCAL[2]; _OpKind: L_CUC.tOpKind);
 BEGIN
  bt_r_Asked:=0;
  bt_Do(IsTickets, _OpKind, PROCREF(bt_RemoveOne), "");
 END {bt_Remove};

 PUBLIC PROCEDURE BuildNumberedCUCGroup();
  VAR
   s,
   serB,
   serE,
   numB,
   numE,
   _list    : STRING[];
   Idx,
   included,
   Choice   : NUMERIC[0];
   sortby,
   IsTickets: SCAL[2];
   _OpKind  : L_CUC.tOpKind;
   Dummy    : STRING[];
 BEGIN
  L_General.Assert(ACCESS(MDocList), " ⠭ ப ⮢୮ 㬥");
  CONFORM(MDocList, MDoc);
  CONFORM(MDocList, CarUnit);
  L_General.Assert(CarUnit.SNDate <= MDoc.Date,
                     " ॣ " + CarUnit.CarUnit + "    ");

  IsTickets:=CarUnit.Type = L_CUC.cut_TicketProduction;
  IF IsTickets THEN
   L_General.Assert(L_TRS.AccessTckKindByMath(MDocList.Math, MDoc.Date) &
                    ((TckKind.Type = L_TRS.tkt_Ticket) | L_TRS.IsBulk_wCUC()),
                    " 饣  " + L_DatTim.DateStr(MDoc.Date) +
                    "  ஥ 㬥⮢ c  " + MDocList.Math);
  END;
  IF    (MDocList.MDocKind = L_MDoc.md_VTN) |
        (MDocList.MDocKind = L_MDoc.md_FPk) |
        (MDocList.MDocKind = L_MDoc.md_NPr) |
        (MDocList.MDocKind = L_MDoc.md_ViP) |
        (MDocList.MDocKind = L_MDoc.md_DDA) THEN
   _OpKind:=L_CUC.ok_Accpt;
  ELSIF (MDocList.MDocKind = L_MDoc.md_MSP) THEN
   _OpKind:=L_CUC.ok_Relocation;
  ELSIF (MDocList.MDocKind = L_MDoc.md_TOV) THEN
   IF L_MathR.IsAdvHolderFlow(L_MDoc.InvertMathFlowType(L_MDoc.getMDocListStorageRelatedMathFlowType())) THEN 
    _OpKind:=L_CUC.ok_Relocation;
   ELSE
    _OpKind:=L_CUC.ok_Retire;
   END;
  ELSE
   L_General.Error("ନ஢ 㬥஢ ஢  " + L_MDoc.MDocKindNick(MDocList.MDocKind, 1) + " ");
  END;

  L_AFM.MakeMultipleIndex("list", "series : STRING["+L_Str.IntStr(bt_SeriesLen)+"];" +
                                  "numbers: STRING["+L_Str.IntStr(bt_NumbersLen)+"];" +
                                  "include: SCAL[2]",
                             "series : series, numbers;" +
                             "numbers: numbers, series;" +
                             "include: include, series, numbers");
  SETEMPTY(serB, serE, numB, numE);
  LOOP
   LOOP
    STDFORM(L_StdFrm.sf_Choice("|ਨ   %"+L_Str.Repeat("#", bt_SeriesLen) +"%      %"+L_Str.Repeat("#", bt_SeriesLen) +"%   |" +
                               "|  %"+L_Str.Repeat("#", bt_NumbersLen)+"%  %"+L_Str.Repeat("#", bt_NumbersLen)+"%|",
                               "%I %YI" +
                               "%I %YI"),
            " ⮢ ᯨ᪠ ஢ ",
            ,
            ,
            serB, serE, numB, numE);
    serB:=Str.Cap(serB);
    IF !serE THEN
     serE:=serB;
    ELSE
     serE:=Str.Cap(serE);
    END;
    IF !numE THEN
     numE:=numB;
    END;

    IF    (numB > numE) | (Str.Length(numB) # Str.Length(numE)) THEN
     L_StdFrm.RedInform(" ࢠ ஢");
    ELSIF IsTickets THEN
     IF    (serB > serE) | (Str.Length(serB) # Str.Length(serE)) THEN
      L_StdFrm.RedInform(" ࢠ ਩");
     ELSIF Str.Length(numB) > TckKind.NbrPrc THEN
      L_StdFrm.RedInform("    ॢ " + TckKind.NbrPrc + " ᨬ");
     ELSE
      TRY
       Dummy:=L_TRS.cc_BuildSerial(serB, numB);
       Dummy:=L_TRS.cc_BuildSerial(serE, numE);
       EXIT;
      EXCEPT
      ON Exc: Exc_Root DO
       L_StdFrm.RedInform("⨬ ᨬ  ਨ / ");
      END; (* TRY *)
     END;
    ELSE
     EXIT;
    END;
   END; (* LOOP *)

   IF bt_PrepareIndex(IsTickets, serB, serE, numB, numE) THEN
    sortby:=sb_Ser;
    Idx :=0;
    LOOP
     _list:=bt_ResortList(sortby, included);
     Choice:=STDFORM(L_Str.PoolItem("                    |                    ", sortby) +
                     "|%33,15AI" + L_Str.Repeat("|", 15) +
                     "|祭 %6NI ஢    " +
                     "|" +
                     "|%< {} >DB  %< {} ஢ >B" +
                     "|%< {}⬥ >X  %< {} >B  %< {} >B",
                     "  ", , , _list, Idx, included);
     IF    Choice = 1 THEN
      s:=L_Str.PoolItem(_list, Idx);
      IF sortby = sb_Ser THEN
       SEARCH(list, series, , Str.Condense(Str.Slice(s, 0, bt_SeriesLen)),
                              Str.Condense(Str.Slice(s, bt_SeriesLen, bt_NumbersLen)));
      ELSE
       SEARCH(list, series, , Str.Condense(Str.Slice(s, bt_NumbersLen, bt_SeriesLen)),
                              Str.Condense(Str.Slice(s, 0, bt_NumbersLen)));
      END;
      list.include:=~list.include;
      REPLACE(list);
     ELSIF Choice = 2 THEN
      sortby:=~sortby;
     ELSE
      EXIT;
     END;
    END;
    IF Choice # 0 THEN
     EXIT;
    END;
   END;
  END;
  IF    Choice = 3 THEN
   bt_Put(IsTickets, _OpKind);
  ELSIF Choice = 4 THEN
   bt_Remove(IsTickets, _OpKind);
  ELSE
   L_General.CallUs(0);
  END;
  L_AFM.AF_PurgeTemp("list");
 END {BuildNumberedCUCGroup};

 PUBLIC PROCEDURE extRemMDocListMDocLCUs(VAR Asked: SCAL[2]);
  VAR
   curCUCopy: LIKE(MDocLCU.CUCopy);
 BEGIN
  CONFORM(MDocList, MDocLCU);
  WHILE OCCURE(MDocLCU) DO
   PROMPT(MDocLCU.CUCopy);
   L_CUC.MustBeLastCUCopyMDocLCU();
   curCUCopy:=MDocLCU.CUCopy;
   REMOVE(MDocLCU);
   intRemoveTrace(curCUCopy, Asked, 1);
  END; (* WHILE OCCURE(MDocLCU) ... *)
 END {extRemMDocListMDocLCUs};

 PUBLIC PROCEDURE RemMDocListMDocLCUs();
  VAR
   Asked: SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(MDocList), " ࠭ ப 㬥");
  L_General.Assert(SELECT(MDocLCU, MDoc, MDocList.MDocKind, MDocList.MDoc, MDocList.MDLNbr), " ஢  㤠");
  L_StdFrm.Choice("  祭 ஢");
  Asked:=0;
  extRemMDocListMDocLCUs(Asked);
 END {RemMDocListMDocLCUs};

BEGIN
 L_Events.ExecuteHandler();
END.
