(*
%Copyright   (c) Polak Computer System
%Author      24.12.1996 12:21:38 GINA
%Purpose     ஫ 筮    ⥫  ࠡ⭨
%Type        control
%Specific    SYS
%Modified    10.01.2014 20:02:09 POLAK\Gina
%Environment
*)

 MODULE Monthly [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_PRoll, L_Staff, L_AP, L_APtm, Memo, Math, L_StdFrm, L_DatTim, Str, L_WDO;

 PRIVATE PROCEDURE Check();
 BEGIN
  L_General.Assert(Monthly.Source=L_AP.mthlSrc_Operator,
                   " ⮬᪨ ᫥ ⥫  ந");
  L_APtm.ANYDoc_CheckPer(Monthly.Period, L_APtm.system_Salary);
 END {Check};

 PRIVATE PROCEDURE Reset();
 BEGIN
  Check();
  L_PRoll.ShtDone_AP(Monthly.Period, 0);
 END {Reset};

 PRIVATE PROCEDURE Monthly_OnAfterEdIns();
 BEGIN
  CONFORM(Monthly, Staff);
  L_Staff.PosToStaffLog(Monthly.TSN, Monthly.ODate, 0);
  L_Staff.CheckManyStaffLog(Monthly.ODate);
  Reset();
 END {Monthly_OnAfterEdIns};

 PRIVATE PROCEDURE Monthly_OnAfterEdit();
 BEGIN
  Monthly_OnAfterEdIns();
 END {Monthly_OnAfterEdit};

 PRIVATE PROCEDURE Monthly_OnAfterInsert();
 BEGIN
  Monthly_OnAfterEdIns();
 END {Monthly_OnAfterInsert};

 PRIVATE PROCEDURE Monthly_OnBeforeEdit();
 BEGIN
  Check();
 END {Monthly_OnBeforeEdit};

 PRIVATE PROCEDURE Monthly_OnBeforeInsert();
 BEGIN
  Monthly.Source:=L_AP.mthlSrc_Operator;
  REPLACE(Monthly);
 END {Monthly_OnBeforeInsert};

 PRIVATE PROCEDURE Monthly_OnBeforeDelete();
 BEGIN
  CONFORM(Monthly, Staff);
  Reset();
 END {Monthly_OnBeforeDelete};

 PUBLIC PROCEDURE Monthly_MtyIdx_OnSuccessfulChange();
  VAR
   _Date: LIKE(StaffLog.Date)[32];
   List : STRING[];
   i    : NUMERIC[0];
 BEGIN
  IF ~!Monthly.MtyIdx THEN
   L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
   L_Staff.PosToStaffLog(Staff.TSN, Math.Min(Memo.ud_me(), Math.Max(Staff.BegDate, Memo.ud_cd())), 1);
   TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
    Monthly.ODate:=StaffLog.Date;
    REPLACE(Monthly);
   EXCEPT
   ON Exc: Exc_RunTime DO
    IF L_General.IsUniquenessViolationException(Exc) THEN
     LOOP
      List:=""; i:=0;
      L_Staff.PosToStaffLog(Staff.TSN, Memo.ud_me(), 1);
      WHILE OCCURE(StaffLog) DO
       IF L_Staff.OrderInMonth(Memo.ud_mb()) THEN
        _Date[i]:=StaffLog.Date;
        SAVE(Monthly);
        IF ~SEARCH(Monthly, TSN, Monthly.TSN, Monthly.Period, _Date[i], Monthly.Who, Monthly.Source, Monthly.MtyIdx) THEN
         CONFORM(StaffLog, Officer, Post);
         List:=List + L_DatTim.DateStr(StaffLog.Date)+" "+ Str.Slice(Post.Name, 0, 32) + "|";
         INC(i);
        END;
        RESTORE(Monthly);
       END;
       PREV(StaffLog);
      END; (* WHILE OCCURE(StaffLog) ... *)
      L_General.Assert(~!List, "⥫ 㦥 ଫ    ॢ");
      i:=L_StdFrm.ShowListAsMenu(List, "ਪ  ਥ/ॢ");
      TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
       Monthly.ODate:=_Date[i];
       REPLACE(Monthly);
       EXIT;
      EXCEPT
      ON Exc: Exc_RunTime DO
       IF L_General.IsUniquenessViolationException(Exc) THEN
        L_StdFrm.RedInform("   ");
       END;
      ELSE
       RAISE();
       EXIT;
      END;
     END; (* LOOP *)
    ELSE
     RAISE();
    END;
   END;
  END;
 END {Monthly_MtyIdx_OnSuccessfulChange};

 PRIVATE PROCEDURE MonthRt_OnAfterEdIns();
 BEGIN
  CONFORM(MonthRt, Monthly);
  Monthly_OnAfterEdIns()
 END {MonthRt_OnAfterEdIns};

 PRIVATE PROCEDURE MonthRt_OnAfterEdit();
 BEGIN
  MonthRt_OnAfterEdIns();
 END {MonthRt_OnAfterEdit};

 PRIVATE PROCEDURE MonthRt_OnAfterInsert();
 BEGIN
  MonthRt_OnAfterEdIns();
 END {MonthRt_OnAfterInsert};

 PRIVATE PROCEDURE MonthRt_OnBeforeEdit();
 BEGIN
  CONFORM(MonthRt, Monthly);
  Check();
 END {MonthRt_OnBeforeEdit};

 PRIVATE PROCEDURE MonthRt_OnBeforeInsert();
 BEGIN
  CONFORM(MonthRt, Monthly);
  Check();
 END {MonthRt_OnBeforeInsert};

 PRIVATE PROCEDURE MonthRt_OnBeforeDelete();
 BEGIN
  CONFORM(MonthRt, Monthly);
  CONFORM(Monthly, Staff);
  Reset();
 END {MonthRt_OnBeforeDelete};

 PRIVATE PROCEDURE Monthly_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  L_WDO.iZone        (1).Narrowing:="(Monthly.TSN=Staff.TSN)&(Monthly.Period=Memo.MonthB)";
  L_WDO.iScsChange   (1, ["Monthly.MtyIdx"]);
  L_WDO.iUnmodifiable(1, ["Monthly.Source"]);
  L_WDO.iField       (1, "Monthly.Source").Format:=L_AP.mthlSrc_Pool;
  L_WDO.iField       (1, "Monthly.Who").Format   :=L_AP.mthlWho_Pool;
  L_WDO.iEvents      (2, [L_WDO.e_OnAnyModification]);
  L_WDO.iProgs       (2, "Monthly");
 END {Monthly_OnInitializeWindow};

BEGIN
 L_Events.ExecuteHandler();
END.
