(*
%Copyright   (c) Polak Computer System
%Author      20.12.2001 19:50:41 BOR
%Purpose     ஫ 䨪樨  ⮯  ⠬
%Type        control
%Specific    AP
%Modified    18.09.2012 18:17:02 POLAK\GAV
%Environment
*)

 MODULE MRFlNorm [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, L_APtm, L_PRoll, L_Way, Memo, L_ACL, L_WDO;

 PRIVATE PROCEDURE PrevMRFlNorm(): DATE;
  VAR
   Result: DATE;
 BEGIN
  SAVE(MRFlNorm);
  CHANGESEL(MRFlNorm, Mark, , MRFlNorm.Mark, MRFlNorm.Route);
  IF PREV(MRFlNorm) THEN
   Result:=MRFlNorm.Begin;
  ELSE
   SETEMPTY(Result);
  END;
  RESTORE(MRFlNorm);
  RETURN Result;
 END {PrevMRFlNorm};

 PRIVATE PROCEDURE MRFlNorm_Begin_Replicate(prevBegin, curBegin: DATE);
 BEGIN
  SAVE(MRFlNorm);
  CHANGESEL(MRFlNorm, Mark, , MRFlNorm.Mark, MRFlNorm.Route);
  IF PREV(MRFlNorm) THEN
   IF !MRFlNorm.Till | (~!prevBegin & (MRFlNorm.Till = prevBegin))THEN
    MRFlNorm.Till:=curBegin;
    REPLACE(MRFlNorm);
   ELSE
    L_General.Assert(~L_DatTim.IsActive(curBegin, MRFlNorm.Begin, MRFlNorm.Till),
                     L_DatTim.DateStr(curBegin) + "|  ਮ ਬ (" + L_DatTim.DateStr(MRFlNorm.Begin) + " - " + L_DatTim.DateStr(MRFlNorm.Till) +  ")|।饩   ଠ 室 ⮯");
   END;
  END;
  RESTORE(MRFlNorm);
 END {MRFlNorm_Begin_Replicate};

 PRIVATE PROCEDURE IsLastMRFlNorm(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(MRFlNorm);
  CHANGESEL(MRFlNorm, Mark, , MRFlNorm.Mark, MRFlNorm.Route);
  Result:=~NEXT(MRFlNorm);
  RESTORE(MRFlNorm);
  RETURN Result;
 END {IsLastMRFlNorm};

 PRIVATE PROCEDURE MRFlNorm_CheckIsLast();
 BEGIN
  L_General.Assert(IsLastMRFlNorm(), "  ᫥   ଥ 室 ⮯ "+
                                     " થ " + MRFlNorm.Mark + ",  " + MRFlNorm.Route);
 END {MRFlNorm_CheckIsLast};

 PRIVATE PROCEDURE MRFlNorm_Begin_OnSuccessfulChange();
  VAR
   curPrevMRFlNorm,
   oldPrevMRFlNorm: DATE;
 BEGIN
  curPrevMRFlNorm:=PrevMRFlNorm();
  TRY
   MRFlNorm.Begin:=GE_PVALUE();
   REPLACE(MRFlNorm);
   oldPrevMRFlNorm:=PrevMRFlNorm();
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  IF curPrevMRFlNorm # oldPrevMRFlNorm THEN
   L_General.Error("  冷 ᫥ ᥩ  ଠ 室 ⮯");
  END;
  MRFlNorm_Begin_Replicate(GE_PVALUE(), MRFlNorm.Begin);
 END {MRFlNorm_Begin_OnSuccessfulChange};

 PRIVATE PROCEDURE MRFlNorm_Any_OnSuccessfulChange(FName: STRING[]);
  VAR
   trgFName: LIKE(^(FName + "." + FName));
 BEGIN
  MRFlNorm_CheckIsLast();
  IF ~!GE_PVALUE() THEN
   trgFName:=^("MRFlNorm." + FName);
   ^("MRFlNorm." + FName):=GE_PVALUE();
   REPLACE(MRFlNorm);
   MRFlNorm_Begin_Replicate(MRFlNorm.Begin, L_General.EMPTY_DATE());
   ^("MRFlNorm." + FName):=trgFName;
   REPLACE(MRFlNorm);
  END;
  MRFlNorm_Begin_Replicate(L_General.EMPTY_DATE(), MRFlNorm.Begin);
 END {MRFlNorm_Any_OnSuccessfulChange};

 PRIVATE PROCEDURE MRFlNorm_Mark_OnSuccessfulChange();
 BEGIN
  MRFlNorm_Any_OnSuccessfulChange("Mark");
 END {MRFlNorm_Mark_OnSuccessfulChange};

 PRIVATE PROCEDURE MRFlNorm_Route_OnSuccessfulChange();
 BEGIN
  MRFlNorm_Any_OnSuccessfulChange("Route");
 END {MRFlNorm_Route_OnSuccessfulChange};

 PRIVATE PROCEDURE MRFlNorm_OnInitializeWindow();
 BEGIN
  L_WDO.iZone        (1).Narrowing:="MRFlNorm.Mark=Mark.Mark";
  L_WDO.iSubwindow   (1, "MRFlNrmR");
 END {MRFlNorm_OnInitializeWindow};

 PRIVATE PROCEDURE MRFlN_Rt_OnInitializeWindow();
 BEGIN
  L_WDO.iZone        (1).Narrowing:="MRFlNorm.Route=Route.Route";
  L_WDO.iSubwindow   (1, "MRFlNrmM");
 END {MRFlN_Rt_OnInitializeWindow};

 PRIVATE PROCEDURE MayModify();
 BEGIN
  L_General.Assert(~L_Way.E_GettingRouteFuelNormManner(SYSDATE()),
                   " 襬 ।⨨ ਬ|"+
                   " ଠ ⮯  ⮬ ࠢ  .|" +
                   "饭   ⮯  ⮬ ");
 END {MayModify};

 PRIVATE PROCEDURE MRFlNorm_OnBeforeInsert();
 BEGIN
  MRFlNorm.Begin:=Memo.ud_cd();
  REPLACE(MRFlNorm);
  MayModify();
 END {MRFlNorm_OnBeforeInsert};

 PRIVATE PROCEDURE MRFlNorm_OnBeforeEdit();
  VAR
   IsLast: SCAL[2];
   Fields: FORMFIELDS;
 BEGIN
  MayModify();
  IsLast:=IsLastMRFlNorm();
  Fields:=RTI.Get().CurZone.Fields;
  Fields("MRFlNorm.Till").Modifiable:=IsLast;
  IF    RTI.Get().CurWindow.OriginalName = "MRFlNrmR" THEN
   Fields("MRFlNorm.Route").Modifiable:=IsLast;
  ELSIF RTI.Get().CurWindow.OriginalName = "MRFlNrmM" THEN
   Fields("MRFlNorm.Mark").Modifiable:=IsLast;
  ELSE
   L_General.CallUs(0);
  END;
 END {MRFlNorm_OnBeforeEdit};

 PRIVATE PROCEDURE CheckClosed(D: DATE);
 BEGIN
  L_General.Assert_wReferToAdmin(~L_APtm.MonthIsClosed(D, L_APtm.system_Salary),
                                 L_DatTim.PeriodStr(D) + " -  ("+L_APtm.SystemName(L_APtm.system_Salary)+")");
 END {CheckClosed};

 PRIVATE PROCEDURE MRFlNorm_OnBeforeDelete();
 BEGIN
  CheckClosed(MRFlNorm.Begin);
  MRFlNorm_CheckIsLast();
  MRFlNorm_Begin_Replicate(MRFlNorm.Begin, L_General.EMPTY_DATE());
 END {MRFlNorm_OnBeforeDelete};

 PRIVATE PROCEDURE MRFlNorm_OnAfterEdIns();
 BEGIN
  L_General.Assert(MRFlNorm.Till >= MRFlNorm.Begin, " 'ਮ ਬ ()'   'ਮ ਬ (C)'");
 END {MRFlNorm_OnAfterEdIns};

 PRIVATE PROCEDURE MRFlNorm_OnAfterEdit();
 BEGIN
  MRFlNorm_OnAfterEdIns();
  IF (GE_PVALUE(MRFlNorm.Begin) # MRFlNorm.Begin) | (GE_PVALUE(MRFlNorm.Norm) # MRFlNorm.Norm) |
     (GE_PVALUE(MRFlNorm.Route) # MRFlNorm.Route) THEN
   CheckClosed(MRFlNorm.Begin);
   CheckClosed(GE_PVALUE(MRFlNorm.Begin));
  END;
 END {MRFlNorm_OnAfterEdit};

 PRIVATE PROCEDURE MRFlNorm_OnAfterInsert();
 BEGIN
  MRFlNorm_OnAfterEdIns();
  CheckClosed(MRFlNorm.Begin);
 END {MRFlNorm_OnAfterInsert};

 PRIVATE PROCEDURE DoCorrectNorm(ByRoute: SCAL[2]);
 VAR
  _Date    : DATE;
  _Coeff   : NUMERIC[6];
  _FormText: STRING[];
 BEGIN
  L_General.Assert(L_General.IsAdmin(), "㦭  ஬");
 
  SETEMPTY(_Coeff);
  _Date:=Memo.tmp_cd();
 
  IF ByRoute THEN
   L_General.Assert(ACCESS(Route), " ࠭ ");
   _FormText:="|  ⮯  ||" + Route.Route+ " " + Route.Name;
   SELECT(MRFlNorm, Route, , Route.Route);
  ELSE
   L_General.Assert(ACCESS(Mark), " ࠭ ઠ");
   _FormText:="|  ⮯  થ||" + Mark.Mark+ " " + Mark.Name;
   SELECT(MRFlNorm, Mark, , Mark.Mark);
  END;
 
  STDFORM(_FormText+
          "||  %<D.N.y>I ਬ 樥 %8I" +
          "||%< 믮 >DB         %< ⬥ >X",
          , , 1, _Date, _Coeff);
 
  WHILE OCCURE(MRFlNorm) DO
   PROMPT(MRFlNorm.Mark + " " + MRFlNorm.Route);
 
   IF    ByRoute THEN
    CHANGESEL(MRFlNorm, Route, , Route.Route, MRFlNorm.Mark);
   ELSE
    CHANGESEL(MRFlNorm, Mark,  , Mark.Mark, MRFlNorm.Route);
   END;
 
   LAST(MRFlNorm);
   L_General.Assert(MRFlNorm.Begin < _Date,
                    "  " + MRFlNorm.Mark + "   " + MRFlNorm.Route +
                    "|⠭ ଠ ⮯  " + L_DatTim.DateStr(MRFlNorm.Begin));
   MRFlNorm.Till:=_Date;
   REPLACE(MRFlNorm);
 
   SETEMPTY(MRFlNorm.Till);
   MRFlNorm.Begin:=_Date;
   MRFlNorm.Norm:=MRFlNorm.Norm * _Coeff;
   INSERT(MRFlNorm);
 
   IF    ByRoute THEN
    CHANGESEL(MRFlNorm, Route, , Route.Route);
   ELSE
    CHANGESEL(MRFlNorm, Mark,  , Mark.Mark);
   END;
 
   NEXT(MRFlNorm);
  END; (* WHILE OCCURE(MRFlNorm) ... *)
 END {DoCorrectNorm};

 PUBLIC PROCEDURE CorrectByRoute();
 BEGIN
  DoCorrectNorm(1);
 END {CorrectByRoute};

 PUBLIC PROCEDURE CorrectByMark();
 BEGIN
  DoCorrectNorm(0);
 END {CorrectByMark};

BEGIN
 L_Events.ExecuteHandler();
END.