(*
%Copyright   (c) Polak Computer System
%Author      22.07.2002 16:19:05 LDA
%Purpose      ਠ 業⥩  ਮ
%Type        report
%Specific    AP
%Modified    04.12.2013 16:40:12 POLAK\LDA
%Environment
*)

 MODULE MS_CarR1 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_DatTim, L_Str, L_MathR, L_Car, L_AFM, L_XObj, L_Acnt, L_Stock,
        L_MDoc, L_StdFrm, L_Money, L_Fuel, Math, Str, Memo, E_Stock;

 PRIVATE TYPE
  tObject    = SCAL[4];
  tMathScope = SCAL[100];
  tPrintMDoc = SCAL[3];

 PRIVATE CONST
  obj_Car     = 0;
  obj_Mark    = 1;
  obj_TSN     = 2;
  obj_AllMark = 3;

  mth_All          = 0;
  mth_Fuel         = 1;
  mth_AllwoFuel    = 2;
  mth_AnyOil       = 3;
  mth_PrimaryPool  = " 業|⥯த|஬ ⥯த⮢| ᫮|";
  mth_PrimaryDelta = 4;

  grp_MathType     = 0;
  grp_Fuel         = 1;
  grp_Amount       = 2;

  prn_NoMDoc       = 0;
  prn_MDoc         = 1;
  prn_ExtMDoc      = 2;

 PRIVATE VAR
  Object            : tObject;
  w_Money           : SCAL[2];
  MathScope         : tMathScope;
  CreateList        : tPrintMDoc;
  MathTypeScope     : tMathScope[MAXOF(MathType.MathType)+1];

  mth_Pool          : STRING[];
  DelimiterPosInPool: NUMERIC[0][10];

  Amnt              : NUMERIC[3];
  From, UpTo        : DATE;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
" ਠ 業⥩ "+L_Str.PoolItem(" ࠭ᯮ⭮ ।| થ| ࠡ⭨| ᥬ ઠ", Object), C, ""
From, L, "D.N.y"
UpTo, L, "D.N.y"
L_Str.PoolItem(mth_Pool, MathScope)+" ("+L_Str.PoolItem(" ࠫ쭮| ", w_Money)+" ࠦ)", C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|                     ਮ  ##########  ##########                    |
|############################################################################|
}
*)

(*
$P{ RepTitle:
CreateTitle(), L, ""
@
|============================================================================|
|############################################################################|
|---------------------------------뤠---------------ᤠ-----------|
}
*)

(*
$P{ MathTypeTitle:
Tmp.MathType, L, ""
MathType.Name, L, ""
@
|                                                                            |
| ## #####################################################################|
}
*)

(*
$P{ AllMark_MathTypeTitle:
Tmp.MathType, L, ""
MathType.Name, L, ""
?, R, "2-"
?, R, "2-"
@
|                                                                            |
| ## ############################## ###############     ##################|
}
*)

 PRIVATE PROCEDURE convAmnt(_Math: LIKE(Math.Math); A: L_XObj.tQnt): STRING[];
 BEGIN
  IF A = 0 THEN
   RETURN "";
  ELSE
   RETURN Str.Align(L_MathR.DefaultFormatCir(_Math, A), 8, RIGHT) + " " +
                    L_MathR.DefaultMUnitSign(_Math);
  END;
 END {convAmnt};

 PRIVATE PROCEDURE convSum(S: L_XObj.tSum): STRING[];
 BEGIN
  IF S = 0 THEN
   RETURN "";
  ELSE
   RETURN L_Money.MoneyToStr(UpTo, "", S);
  END;
 END {convSum};

 PRIVATE PROCEDURE fullMathName(_Math: LIKE(Math.Math)): STRING[];
 BEGIN
  SEARCH(Math, Math, , _Math);
  RETURN Math.Math+" "+Math.Name;
 END {fullMathName};

(*
$P{ MathLine:
fullMathName(Tmp.Math), L, ""
?, L, ""
?, R, ""
?, L, ""
?, R, ""
@
| ############################# ############ ######### ############ #########|
}
*)

(*
$P{ MathTotal:
?, R, "2-"
?, R, "2-"
@
|⮣:                             ##################     ##################|
}
*)

(*
$P{ Total:
Amnt, R, "3."
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|                                                                            |
|।ᯨ筠 ᫥                   #######                       |
|ᥣ                                    ############            ###########|
|   ।ᯨ      ############            ###########|
}
*)

(*
$P{ MDocKindTitle:
Tmp.MDocKind, L, ""
MDocKind.Name, L, ""
GetMDocObject(Tmp.MDocKind, 1), L, ""
@
|============================================================================|
| ## ################################                                        |
|----------------------------------------------------------------------------|
|    |  |#####|||ꥪ                            |      -|
|--------|-------|-----|---|-|----------------------------------|------------|
}
*)

(*
$P{ MDocListLine:
Tmp.Date, L, "D.N.Y"
Tmp.MDoc, L, ""
?, L, ""
Dest.Dest, L, ""
Tmp.mft, L, "+|-"
fullMathName(Tmp.Math), L, ""
convAmnt(Tmp.Math, Tmp.Amount[Tmp.mft]), L, ""
@
|########|#######|#####|###|#|##################################|############|
}
*)

(*
$P{ MDocListLineShort:
fullMathName(Tmp.Math), L, ""
convAmnt(Tmp.Math, Tmp.Amount[Tmp.mft]), L, ""
@
|                            |##################################|############|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

(*
$P{ ExtMDocKindTitle:
Tmp.MDocKind, L, ""
MDocKind.Name, L, ""
GetMDocObject(Tmp.MDocKind, 1), L, ""
@
|============================================================================================================|
| ## ################################################                                                        |
|------------------------------------------------------------------------------------------------------------|
|    |  |####                                 |||ꥪ                            |  ⢮|
|--------|-------|-------------------------------------|---|-|----------------------------------|------------|
}
*)

(*
$P{ ExtMDocListLine:
Tmp.Date, L, "D.N.Y"
Tmp.MDoc, L, ""
?, L, ""
Dest.Dest, L, ""
Tmp.mft, L, "-|+"
fullMathName(Tmp.Math), L, ""
convAmnt(Tmp.Math, Tmp.Amount[Tmp.mft]), L, ""
@
|########|#######|#####################################|###|#|##################################|############|
}
*)

(*
$P{ ExtMDocListLineShort:
fullMathName(Tmp.Math), L, ""
convAmnt(Tmp.Math, Tmp.Amount[Tmp.mft]), L, ""
@
|                                                            |##################################|############|
}
*)

(*
$P{ ExtBot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CREATE_TABLE(Tmp, , "६ 䠩");

  CREATE_FIELD(Tmp, Date,     DATE, , , , "");
  CREATE_FIELD(Tmp, MDocKind, LIKE(MDoc.MDocKind), , , , " 㬥");
  CREATE_FIELD(Tmp, MDoc,     LIKE(MDoc.MDoc), , , , "");
  CREATE_FIELD(Tmp, Math,     LIKE(Math.Math), , , , "");
  CREATE_FIELD(Tmp, MathType, LIKE(MathType.MathType), , , , " ");
  CREATE_FIELD(Tmp, MMode,    LIKE(MDocList.MMode), , , , "");
  CREATE_FIELD(Tmp, MDLNbr,   LIKE(MDocList.MDLNbr), , , , " ப");
  CREATE_FIELD(Tmp, mft,      L_MDoc.tMathFlowType, , , , "ࠢ");
  CREATE_FIELD(Tmp, Mirror,   SCAL[2], , , , " ப   ");
  CREATE_FIELD(Tmp, Amount,   L_XObj.tQnt[2], , , , "⢮");

  CREATE_INDEX_AND_LINK(Tmp, Math, PLURAL, Math, Math, USER, , , Math);
  CREATE_INDEX_AND_LINK(Tmp, MathType, PLURAL, MathType, MathType, USER, , , MathType, Math);
  CREATE_INDEX_AND_LINK(Tmp, MDocKind, PLURAL, MDocKind, MDocKind, USER, , , MDocKind);
  CREATE_INDEX_AND_LINK(Tmp, MDoc, PLURAL, MDoc, MDoc, USER, , , MDocKind, MDoc);
  CREATE_INDEX(Tmp, ForPrint, PLURAL, , , MDocKind, Date, MDoc, Math);

  CREATE_INDEX(Tmp, ForAdd, UNIQUE, , , MDocKind, Date, MDoc, Math, MathType, MMode, MDLNbr, mft, Mirror);

  SET_VERSION_OF_TABLE(Tmp, 001);
 END {Create_Tmp};

 PRIVATE PROCEDURE GetMDocObject(_MDocKind: LIKE(MDocKind.MDocKind);
                                 NeedTitle: SCAL[2]): STRING[];
  VAR
   _Name: STRING[];
 BEGIN
  SETEMPTY(_Name);
  IF    (Object = obj_Car) | (Object = obj_Mark) THEN
   IF NeedTitle THEN
    RETURN "";
   ELSE
    IF CreateList = prn_ExtMDoc THEN
     CONFORM(MDoc, Staff);
     CONFORM(Staff, Man);
     _Name:=" "+Man.Name;
    END; (* IF *)
    RETURN FLDTOSTR(MDoc.TSN, "")+_Name;
   END; (* IF *)
  ELSE
   IF _MDocKind = L_MDoc.md_NOV THEN
    IF NeedTitle THEN
     RETURN "";
    ELSE
     IF CreateList = prn_ExtMDoc THEN
      SAVE(Car);
      CONFORM(MDoc, Car);
      L_Car.StandOnCarLog(MDoc.BoxNbr, UpTo);
      _Name:=" "+CarLog.StateNbr;
      RESTORE(Car);
     END; (* IF *)
     RETURN FLDTOSTR(MDoc.BoxNbr, "")+_Name;
    END; (* IF *)
   ELSE
    IF NeedTitle THEN
     RETURN "";
    ELSE
     IF ~!MDoc.Firm THEN
      IF CreateList = prn_ExtMDoc THEN
       CONFORM(MDoc, Firm);
       _Name:=" "+Firm.Name;
      END; (* IF *)
      RETURN MDoc.Firm + _Name;
     ELSE
      RETURN "";
     END;
    END; (* IF *)
   END; (* IF *)
  END; (* IF *)
 END {GetMDocObject};

 PRIVATE PROCEDURE CreateTitle(): STRING[];
 BEGIN
  IF    Object = obj_Car THEN
   L_Car.StandOnCarLog(Car.BoxNbr, UpTo);
   CONFORM(CarLog, Mark);
   RETURN "ઠ "+Mark.Mark+" "+Mark.Name+"  "+Car.BoxNbr+" .  "+CarLog.StateNbr;
  ELSIF (Object = obj_Mark) | (Object = obj_AllMark) THEN
   RETURN "ઠ "+Mark.Mark+" "+Mark.Name;
  ELSIF Object = obj_TSN THEN
   CONFORM(Staff, Man);
   RETURN Staff.TSN+" "+Man.Name;
  ELSE
   L_General.CallUs(0);
  END;
 END {CreateTitle};

 PRIVATE PROCEDURE PrintMDocList();
  VAR
   mdCnt : NUMERIC[0];
   Prefix: STRING[];
 BEGIN
  APP.Get().NewPrompt(" 㬥⮢");
  IF CreateList = prn_ExtMDoc THEN
   Prefix:="Ext";
  ELSE
   Prefix:="";
  END;
  SELECT(Tmp, ForPrint);
  WHILE OCCURE(Tmp) DO
   NARROWSEL(Tmp, MDocKind);
   CONFORM(Tmp, MDocKind);
   MAKEPART(R, ^(Prefix+"MDocKindTitle"));
   WHILE OCCURE(Tmp) DO
    CONFORM(Tmp, MDoc);
    CONFORM(MDoc, Dest);
    NARROWSEL(Tmp, Date, MDoc);
    mdCnt:=0;
    WHILE OCCURE(Tmp) DO
     IF ~Tmp.Mirror THEN
      PROMPT(Tmp.MDoc);
      IF mdCnt = 0 THEN
       MAKEPART(R, ^(Prefix+"MDocListLine"), GetMDocObject(MDoc.MDocKind, 0));
      ELSE
       MAKEPART(R, ^(Prefix+"MDocListLineShort"));
      END;
      INC(mdCnt);
     END;
     NEXT(Tmp);
    END; (* WHILE OCCURE(Tmp) ... *)
    NEXTINEXTENDEDSEL(Tmp, Date, MDoc);
   END; (* WHILE OCCURE(Tmp) ... *)
   NEXTINEXTENDEDSEL(Tmp, MDocKind);
  END; (* WHILE OCCURE(Tmp) ... *)
 END {PrintMDocList};

 PRIVATE PROCEDURE PrintRep();
  VAR
   mAmn : L_XObj.tQnt[2];
   mSum,
   tSum,
   gSum : L_XObj.tSum[2];
 BEGIN
  IF SELECT(Tmp, MathType) THEN
   APP.Get().NewPrompt("");
   SETZERO(gSum);
   MAKEPART(R, RepTitle);
   WHILE OCCURE(Tmp) DO
    NARROWSEL(Tmp, MathType);
    CONFORM(Tmp, MathType);
    IF Object # obj_AllMark THEN
     MAKEPART(R, MathTypeTitle);
    END;
    SETZERO(tSum);
    WHILE OCCURE(Tmp) DO
     NARROWSEL(Tmp, Math);
     SETZERO(mAmn, mSum);
     WHILE OCCURE(Tmp) DO
      PROMPT(Tmp.MDoc);
      CONFORM(Tmp, MDoc);
      CONFORM(MDoc, Dest);
      INC(mAmn[Tmp.mft], Tmp.Amount[Tmp.mft]);
      IF w_Money THEN
       SEARCH(MDocList, MDoc, , Tmp.MDocKind, Tmp.MDoc, Tmp.MDLNbr);
       INC(mSum[Tmp.mft], Tmp.Amount[Tmp.mft] * L_MathR.GetMDLMathPrice());
      END;
      NEXT(Tmp);
     END; (* WHILE OCCURE(Tmp) ... *)
     IF Object # obj_AllMark THEN
      LAST(Tmp);
      MAKEPART(R, MathLine, convAmnt(Tmp.Math, mAmn[L_MDoc.mft_Credit]), convSum(mSum[L_MDoc.mft_Credit]),
                            convAmnt(Tmp.Math, mAmn[L_MDoc.mft_Debit]), convSum(mSum[L_MDoc.mft_Debit]));
     END;
     INC(tSum[L_MDoc.mft_Credit], mSum[L_MDoc.mft_Credit]);
     INC(tSum[L_MDoc.mft_Debit],  mSum[L_MDoc.mft_Debit]);
     NEXTINEXTENDEDSEL(Tmp, Math);
    END; (* WHILE OCCURE(Tmp) ... *)
    IF w_Money THEN
     IF Object # obj_AllMark THEN
      MAKEPART(R, MathTotal, tSum[L_MDoc.mft_Credit], tSum[L_MDoc.mft_Debit]);
     ELSE
      LAST(Tmp);
      MAKEPART(R, AllMark_MathTypeTitle, tSum[L_MDoc.mft_Credit], tSum[L_MDoc.mft_Debit]);
     END;
     INC(gSum[L_MDoc.mft_Credit], tSum[L_MDoc.mft_Credit]);
     INC(gSum[L_MDoc.mft_Debit], tSum[L_MDoc.mft_Debit]);
    END;
    NEXTINEXTENDEDSEL(Tmp, MathType);
   END; (* WHILE OCCURE(Tmp) ... *)
   IF w_Money THEN
    IF Amnt # 0 THEN
     MAKEPART(R, Total, gSum[L_MDoc.mft_Credit],        gSum[L_MDoc.mft_Debit],
                        gSum[L_MDoc.mft_Credit] / Amnt, gSum[L_MDoc.mft_Debit] / Amnt);
    ELSE
     MAKEPART(R, Total, gSum[L_MDoc.mft_Credit],        gSum[L_MDoc.mft_Debit]);
    END;
   END;
   IF (CreateList # 0) THEN
    PrintMDocList();
   END;
  END; (* IF *)
 END {PrintRep};

 PRIVATE PROCEDURE E_MathIsFuel(_MathType: LIKE(MathType.MathType)): SCAL[2];
 BEGIN
  RETURN (_MathType = L_MathR.mtyp_Fuels) | (_MathType = L_MathR.mtyp_Oils);
 END {E_MathIsFuel};

 PRIVATE PROCEDURE IsGoodMathType(): SCAL[2];
 BEGIN
  IF MathType.Category = L_Acnt.mtc_Inventories THEN
   IF    MathScope = mth_All THEN
    RETURN 1;
   ELSIF MathScope = mth_Fuel THEN
    RETURN E_MathIsFuel(MathType.MathType);
   ELSIF MathScope = mth_AllwoFuel THEN
    RETURN ~E_MathIsFuel(MathType.MathType);
   ELSIF (MathScope > DelimiterPosInPool[grp_MathType]) &
         (MathScope < DelimiterPosInPool[grp_Fuel]) THEN
    RETURN MathTypeScope[MathType.MathType] = MathScope;
   ELSIF (MathScope = mth_AnyOil) |
         (MathScope > DelimiterPosInPool[grp_Fuel]) THEN
    RETURN SEARCH(_Math, _Math, MDocList.Math)
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   RETURN 0;
  END;
 END {IsGoodMathType};

 PRIVATE PROCEDURE IsGoodInMix(): SCAL[2];
 BEGIN
  IF MathScope = mth_AnyOil THEN
   RETURN L_Fuel.IsAnyOil(MarkFuel.InMix);
  ELSE
   RETURN MarkFuel.InMix=(MathScope + 1 - DelimiterPosInPool[grp_Fuel] - grp_Amount);
  END;
 END {IsGoodInMix};

 PRIVATE PROCEDURE GetMathNecessaryMathScope();
 BEGIN
  IF (MathScope = mth_AnyOil) |
     (MathScope > (DelimiterPosInPool[grp_Fuel])) THEN
   IF Object = obj_TSN THEN
    SELECT(MarkFuel, Mark);
   ELSE
    SELECT(MarkFuel, Mark, , Mark.Mark);
   END;
   WHILE OCCURE(MarkFuel) DO
    IF L_DatTim.IsActiveInIntvl_Inc(From, UpTo, MarkFuel.Begin, L_DatTim.till2ED(MarkFuel.Till)) &
       IsGoodInMix() THEN
     ADD(_Math, _Math, , MarkFuel.Math);
    END;
    NEXT(MarkFuel);
   END; (* WHILE OCCURE(MarkFuel) ... *)
  END;
 END {GetMathNecessaryMathScope};

 PRIVATE PROCEDURE GatherBySingleObject(Index, FieldValue: STRING[]; InvertMFT, AllMDoc: SCAL[2]);
  VAR
   mft: L_MDoc.tMathFlowType;
 BEGIN
  APP.Get().NewPrompt(FieldValue);
  SETSEL(MDoc, ^Index, ^FieldValue);
  SRCINSEL(MDoc, GE, , From);
  WHILE OCCURE(MDoc) & (MDoc.Date <= UpTo) DO
   CONFORM(MDoc, MDocKind);
   PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+" "+L_DatTim.DateStr(MDoc.Date));
   IF MDocKind.Activity & (MDoc.Status = L_MDoc.st_Passed) & ~SELECT(Tmp, MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
    IF AllMDoc | (MDoc.MDocKind # L_MDoc.md_MSP) THEN
     CONFORM(MDoc, Dest);
     SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
     WHILE OCCURE(MDocList) DO
      IF ~!MDocList.Math THEN
       CONFORM(MDocList, Math);
      ELSE
       CONFORM(MDoc, Math);
      END;
      IF OCCURE(Math) THEN
       CONFORM(Math, MathType);
       IF IsGoodMathType() THEN
        mft:=L_MDoc.getMDocListMathFlowType();
        IF mft # L_MDoc.mft_None THEN
         IF InvertMFT THEN
          mft:=L_MDoc.InvertMathFlowType(mft);
         END;
         IF (Object = obj_TSN) & L_MathR.IsAdvHolderFlow(mft) THEN
          mft:=L_MDoc.InvertMathFlowType(mft);
         END;
         ADD(Tmp, ForAdd, , MDoc.MDocKind, MDoc.Date, MDoc.MDoc, MDocList.Math, Math.MathType, MDocList.MMode,  MDocList.MDLNbr, mft, 0,
             Tmp.Amount[mft], MDocList.Qnt);
         IF (Object = obj_TSN) & (L_MDoc.GetMDocKindDir() = L_MDoc.mdd_MSP) &
            ~L_MDoc.IsMDocToTransferBetweenAdvanceHolders() THEN
          mft:=L_MDoc.InvertMathFlowType(mft);
          ADD(Tmp, ForAdd, , MDoc.MDocKind, MDoc.Date, MDoc.MDoc, MDocList.Math, Math.MathType, MDocList.MMode,  MDocList.MDLNbr, mft, 1,
              Tmp.Amount[mft], MDocList.Qnt);
         END;
        END;
       END;
      END;
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList) ... *)
    END; (* IF (Index # "TSN") | ... *)
   END; (* IF MDocKind.Activity & ... *)
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {GatherBySingleObject};

 PRIVATE PROCEDURE Do(RepName: STRING[]);
 BEGIN
  Create_Tmp();
  L_AFM.CreateTemp("Tmp");
  L_AFM.MakeIndex("_Math", "Math: LIKE(Math.Math)");

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);

  IF    Object = obj_Car THEN
   L_General.Assert(ACCESS(Car), " ࠭ ࠭ᯮ⭮ ।⢮");
   CONFORM(Car, Mark);
   GetMathNecessaryMathScope();
   L_Car.CheckAdaptability(Car.BoxNbr, UpTo, 1);
   Amnt:=1;
   GatherBySingleObject("BoxNbr", Car.BoxNbr, 0, 0);
  ELSIF Object = obj_Mark THEN
   L_General.Assert(ACCESS(Mark), " ࠭ ઠ");
   GetMathNecessaryMathScope();
   Amnt:=0;
   SELECT(Car, BoxNbr);
   WHILE OCCURE(Car) DO
    PROMPT(" "+Car.BoxNbr);
    IF L_Car._StandOnCarLog(Car.BoxNbr, UpTo) & (CarLog.Mark = Mark.Mark) THEN
     INC(Amnt, L_Car.CarDaysInOperation(Car.BoxNbr, From, UpTo) / (UpTo - From + 1));
     GatherBySingleObject("BoxNbr", Car.BoxNbr, 0, 0);
    END;
    NEXT(Car);
   END; (* WHILE OCCURE(Car) ... *)
  ELSIF Object = obj_TSN THEN
   L_General.Assert(ACCESS(Staff), " ࠭ ࠡ⭨");
   Amnt:=1;
   GetMathNecessaryMathScope();
   IF ~!Staff.Storage THEN
    GatherBySingleObject("Storage",  Staff.Storage, 1, 1);
    GatherBySingleObject("Storage2", Staff.Storage, 0, 1);
   END;
   SELECT(MDocKind, MDocKind);
   WHILE OCCURE(MDocKind) DO
    IF MDocKind.Activity THEN
     SAVE(MDocKind);
     GatherBySingleObject("TSN", Staff.TSN+", "+MDocKind.MDocKind, 0, 0);
     RESTORE(MDocKind);
    END;
    NEXT(MDocKind);
   END; (* WHILE OCCURE(MDocKind) ... *)
  ELSIF Object = obj_AllMark THEN
   SELECT(Mark, Mark);
   WHILE OCCURE(Mark) DO
    GetMathNecessaryMathScope();
    Amnt:=0;
    SELECT(Car, Mark, , Mark.Mark);
    WHILE OCCURE(Car) DO
     PROMPT("ઠ "+Mark.Mark+"  "+Car.BoxNbr);
     IF L_Car._StandOnCarLog(Car.BoxNbr, UpTo) THEN
      INC(Amnt, L_Car.CarDaysInOperation(Car.BoxNbr, From, UpTo) / (UpTo - From + 1));
      GatherBySingleObject("BoxNbr", Car.BoxNbr, 0, 0);
     END;
     NEXT(Car);
    END; (* WHILE OCCURE(Car) ... *)
    PrintRep();
    SETSEL(_Math, _Math);  REMSEL(_Math);
    SETSEL(Tmp,   Math);   REMSEL(Tmp);
    NEXT(Mark);
   END; (* WHILE OCCURE(Mark) ... *)
  ELSE
   L_General.CallUs(0);
  END;
  IF Object # obj_AllMark THEN
   PrintRep();
  END;
  IF CreateList = prn_ExtMDoc THEN
   MAKEPART(R, ExtBot);
  ELSE
   MAKEPART(R, Bot);
  END;
  L_AFM.AF_PurgeTemp("_Math");
  L_AFM.AF_PurgeTemp("Tmp");
 END {Do};

 PRIVATE PROCEDURE Prepare_mth_Pool();
  VAR
   tmp_Pool     : STRING[];
   tmp_MathScope: tMathScope;
 BEGIN
  SETEMPTY(MathTypeScope);
  tmp_Pool:="";
  tmp_MathScope:=mth_PrimaryDelta;
  SELECT(MathType, MathType);
  WHILE OCCURE(MathType) DO
   IF MathType.Category = L_Acnt.mtc_Inventories THEN
    INC(tmp_MathScope);
    tmp_Pool:=tmp_Pool+MathType.MathType+" "+MathType.Name+"|";
    MathTypeScope[MathType.MathType]:=tmp_MathScope;
   END;
   NEXT(MathType);
  END; (* WHILE OCCURE(MathType) ... *)

  mth_Pool:=                           mth_PrimaryPool+
            "==-   ꥪ -==|"+tmp_Pool+
            "==-        -==|"+L_Fuel.im_Pool;
  SETEMPTY(DelimiterPosInPool);
  DelimiterPosInPool[grp_MathType]:=mth_PrimaryDelta;
  DelimiterPosInPool[grp_Fuel]    :=tmp_MathScope+1;
 END {Prepare_mth_Pool};

 PRIVATE PROCEDURE MathScopeIsDelimiter(): SCAL[2];
  VAR
   DlmPos: NUMERIC[0];
 BEGIN
  FOR_EACH DlmPos IN DelimiterPosInPool DO
   IF MathScope = DlmPos THEN
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {MathScopeIsDelimiter};

 PRIVATE PROCEDURE ShowForm();
 BEGIN
  LOOP
   STDFORM(L_StdFrm.sf_Choice( "%###################% %###%                 "+
                              "|"+
                              "|%###################% %####################%"+
                              "|"+
                              "|%###################% %###########%         ",
                              "%<  ࠦ:>T"+
                              "%L<|>I"+
                              "%<               :>T" +
                              "%L<"+mth_Pool+">I"+
                              "%<祭 㬥⮢ :>T" +
                              "%L<||७>I"),
           "    "+L_Str.PoolItem("|થ|ࠡ⭨|ᥬ ઠ", Object)+" ",
           ,
           -1,
           w_Money, MathScope, CreateList);
   IF MathScopeIsDelimiter() THEN
    L_StdFrm.RedInform("    ⠪  .||  ࠧ⥫,  .");
   ELSE
    EXIT;
   END;
  END; (* LOOP ... *)
 END {ShowForm};

 PRIVATE PROCEDURE MakeRep(RepName     : STRING[];
                           trgObject   : tObject;
                           trgMathScope: tMathScope;
                           trg_w_Money : SCAL[2];
                           IsEU        : SCAL[2]);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt(RepName);
  Prepare_mth_Pool();
  CreateList:=1;
  w_Money   :=trg_w_Money;
  Object    :=trgObject;
  MathScope :=trgMathScope;
  L_General.SetIntvlByIntvl(From, UpTo);
  IF ~IsEU THEN
   ShowForm();
   RepName:=RepName + "_"  + MathScope + CreateList;
  END;
  Do(RepName);
  L_General.SurveyLastReport();
 END {MakeRep};

 PUBLIC PROCEDURE MhBNB();
 BEGIN
  MakeRep("MhBNB", obj_Car, mth_AllwoFuel, 0, 1);
 END {MhBNB};

 PUBLIC PROCEDURE MTBNB();
  VAR
   trgMathScope: tMathScope;
 BEGIN
  Prepare_mth_Pool();
  trgMathScope:=MathTypeScope[L_MathR.mtyp_CarUnits];
  L_General.Assert(~!trgMathScope, "   'ॣ'");
  MakeRep("MTBNB", obj_Car, trgMathScope, 0, 1);
 END {MTBNB};

 PUBLIC PROCEDURE MhTSN();
 BEGIN
  MakeRep("MhTSN", obj_TSN, mth_AllwoFuel, 0, 1);
 END {MhTSN};

 PUBLIC PROCEDURE MSCar();
 BEGIN
  MakeRep("MSCar", obj_Car, mth_All, 0, 0);
 END {MSCar};

 PUBLIC PROCEDURE MSMrk();
 BEGIN
  MakeRep("MSMrk", obj_Mark, mth_All, 0, 0);
 END {MSMrk};

 PUBLIC PROCEDURE MSTSN();
 BEGIN
  MakeRep("MSTSN", obj_TSN, mth_All, 0, 0);
 END {MSTSN};

 PUBLIC PROCEDURE MSAMr();
 BEGIN
  MakeRep("MSAMr", obj_AllMark, mth_All, 1, 0);
 END {MSAMr};

END.
