(*
%Copyright   (c) Polak IT
%Author      11.03.2013 16:32:49 POLAK\Bor
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    12.03.2013 10:52:34 POLAK\Bor
%Environment
*)

 IMPORT Memo, L_General, L_DatTim, L_AFM, L_MDoc, L_MathR, L_XObj, P_Firm, L_Env;

(*
$P{ Top:
P_Firm.MyFirmName(MSCar.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                                ਮ  ##########  ##########                            |
|------------------------------------------------------------------------------------------------------------|
|                                                        |  |     ।騩       |    ⢮|
|                                                           |    |----------------------------|              |
|                                                           |    |諮|      |⢮|              |
|                                                           |    |  |          |          |              |
}
*)

(*
$P{ Dlm:
@
|-----------------------------------------------------------|----|------|----------|----------|--------------|
}
*)


(*
$P{ Line:
?, L, ""
MSCar.BoxNbr, L, ""
?, R, "0"
?, L, ""
L_MathR.DefaultFormatCir(MSCar.Math, MSCar.PrvQnt), R, ""
L_MathR.DefaultFormatCir(MSCar.Math, MSCar.Qnt), R, ""
L_MathR.DefaultMUnitSign(MSCar.Math), L, ""
@
|###########################################################|####|######|##########|##########|########## ###|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE NeedMDoc(): SCAL[2];
 BEGIN
  RETURN (MDoc.Status = L_MDoc.st_Passed);
 END {NeedMDoc};

 PRIVATE PROCEDURE MakeIndex();
 BEGIN
  APP.Get().NewPrompt("");
  SETSEL(MDoc, MDKDate, L_MDoc.md_NOV);
  SRCINSEL(MDoc, GE, , Memo.ud_fr());
  WHILE OCCURE(MDoc) & (MDoc.Date <= Memo.ud_ut()) DO
   PROMPT(": "+L_MDoc.GetMDocStrNbr());
   IF NeedMDoc() THEN
    CONFORM(MDoc, MDocList);
    WHILE OCCURE(MDocList) DO
     CONFORM(MDocList, Math);
     IF Math.MathType # L_MathR.mtyp_Fuels THEN
      IF ~ADD(MSCar, MSCar, MDoc.MyFirm, MDocList.Math, MDoc.BoxNbr,
                     MSCar.Qnt, MDocList.Qnt) THEN
       MSCar.PrvInt:=MAXOF(MSCar.PrvInt);
       REPLACE(MSCar);
      END;
     END;
     NEXT(MDocList);
    END; (* WHILE OCCURE(MDocList) ... *)
   END; (* IF NeedMDoc() ... *)
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE GetPrvOutput();
  VAR
   Found: SCAL[2];
 BEGIN
  APP.Get().NewPrompt("।騩 ");
  SELECT(MSCar, MSCar);
  WHILE OCCURE(MSCar) DO
   Found:=0;
   SETSEL(MDocList, Math, MSCar.Math);
   SRCINSEL(MDocList, LT, , Memo.ud_fr());
   WHILE OCCURE(MDocList) & ((L_Env.MathAcntLev(MDocList.Date) = L_MathR.mal_Recount_ActiveSMMove) & ~Found) DO
    PROMPT(": " + MSCar.Math + " " + ": " + MSCar.BoxNbr + " " + L_DatTim.DateStr(MDocList.Date));
    IF MDocList.MDocKind = L_MDoc.md_NOV THEN
     CONFORM(MDocList, MDoc);
     IF (MDoc.BoxNbr = MSCar.BoxNbr) & (MDoc.MyFirm = MSCar.MyFirm) & NeedMDoc() THEN
      MSCar.PrvInt:=Memo.ud_fr() - MDocList.Date;
      MSCar.PrvQnt:=MDocList.Qnt;
      REPLACE(MSCar);
      Found:=1;
     END;
    END;
    PREV(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
   NEXT(MSCar);
  END; (* WHILE OCCURE(MSCar) ... *)
 END {GetPrvOutput};

 PRIVATE PROCEDURE Print(RepName: STRING[]);
  VAR
   MathStr: STRING[];
 BEGIN
  APP.Get().NewPrompt("");
  OPENREP(R, L_General.NameConnection(RepName), Create);

  IF SELECT(MSCar, Math) THEN
   WHILE OCCURE(MSCar) DO
    NARROWSEL(MSCar, MyFirm);
    MAKEPART(R, Top, RepName);
    WHILE OCCURE(MSCar) DO
     NARROWSEL(MSCar, Math);
     MAKEPART(R, Dlm);
     SEARCH(Math, Math, , MSCar.Math);
     MathStr:=Math.Math + " " +Math.Name;
     WHILE OCCURE(MSCar) DO
      PROMPT(": " + MSCar.Math + " " + ": " + MSCar.BoxNbr);
      IF MSCar.PrvInt # MAXOF(MSCar.PrvInt) THEN
       MAKEPART(R, Line, MathStr, MSCar.PrvInt, L_DatTim.DateStr(Memo.ud_fr() - MSCar.PrvInt));
      ELSE
       MAKEPART(R, Line, MathStr, , );
      END;
      MathStr:="";
      NEXT(MSCar);
     END; (* WHILE OCCURE(MSCar) ... *)
     NEXTINEXTENDEDSEL(MSCar, Math);
    END; (* WHILE OCCURE(MSCar) ... *)
    MAKEPART(R, Bot);
    NEXTINEXTENDEDSEL(MSCar, MyFirm);
   END; (* WHILE OCCURE(MSCar) ... *)
  END;
 END {Print};

 PUBLIC PROCEDURE MSCr2();
  CONST
   RepName = "MSCr2";
 BEGIN
  APP.Get().NewPrompt("("+RepName+")");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  L_AFM.MakeMultipleIndex("MSCar", "MyFirm: LIKE(MyFirm.MyFirm);" +
                                   "BoxNbr: LIKE(Car.BoxNbr);" +
                                   "Math  : LIKE(Math.Math);" +
                                   "PrvInt: NUMERIC[0];" +
                                   "PrvQnt: "+GET_TYPE_SPEC(L_XObj.tQnt).Name + ";" +
                                   "Qnt   : "+GET_TYPE_SPEC(L_XObj.tQnt).Name,
                          "MSCar: MyFirm, Math, BoxNbr;" +
                          "Math: MyFirm, Math, PrvInt, Qnt, BoxNbr");
  MakeIndex();
  GetPrvOutput();
  Print(RepName);
  L_General.SurveyLastReport();
 END {MSCr2};

END.