(*
%Copyright   (c) Polak Computer System
%Author      07.02.2001 16:35:38 SAM
%Purpose     ⥫ 筮 ⥫  ਮ (Excel)
%Type        report
%Specific    AP
%Modified    15.01.2013 09:06:40 POLAK\MLB
%Environment
*)

 IMPORT L_General, L_DatTim, L_OwnData, L_Basis, L_Staff, L_Str, L_AFM, L_AP, L_AR, P_Firm,
        Memo, FIO, Str;

 VAR
  RepName: STRING[];
  wMF    : SCAL[2];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
"⥫  "+MtyIdx.MtyIdx+" "+MtyIdx.Name, C, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|                    ਮ  ##########  ##########                     |
|----------------------------------------------------------------------------|
|. |                                        |/       |       祭|
|-----|-------------------------------------------|----------|---------------|
}
*)

(*
$P{ Line:
Staff.TSN, L, ""
Man.Name, L, ""
?, L, "D.N.y"
?, R, "3."
@
|#####|###########################################|##########|###############|
}
*)

(*
$P{ Bot:
?, R, "3."
@
|------------------------------------------------------------|---------------|
|⮣                                                       |###############|
=(c) Polak====================================================================
}
*)

 VAR
  _Proof: NUMERIC[2][MAXOF(MtyIdx.MtyIdx)+1];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "筨");
  L_Basis.wb_WrInQM(F, "ਮ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "/");

  SELECT(MtyIdx, MtyIdx);
  WHILE OCCURE(MtyIdx) DO
   L_Basis.wb_WrInQM(F, MtyIdx.MtyIdx+" "+Str.Align(MtyIdx.Name, 32, LEFT));
   NEXT(MtyIdx);
  END; (* WHILE OCCURE(MtyIdx) ... *)
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  IF wMF THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, L_Str.ShortName(Man.Name));
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrStr(F, Str.Small(L_Str.PoolItem(L_AP.mthlWho_Pool, _Mnth.Who)));
  L_Basis.wb_WrScl(F, L_Str.PoolItem(L_AP.mthlSrc_Pool, _Mnth.Source));
  L_Basis.wb_WrStr(F, FLDTOSTR(_Mnth.Period, "y.N"));
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|", ~L_Staff.rInState(Memo.ud_ut())));
  L_Basis.wb_WrDat(F, _Mnth.ODate);

  SELECT(MtyIdx, MtyIdx);
  WHILE OCCURE(MtyIdx) DO
   L_Basis.wb_WrNum(F, _Proof[MtyIdx.MtyIdx], 2);
   NEXT(MtyIdx);
  END; (* WHILE OCCURE(MtyIdx) ... *)
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE Create_Mnth();
 BEGIN
  CreateFILE(_Mnth, "", " ⥫", "");
  CreateFIELD(_Mnth, TSN,    LIKE(Monthly.TSN), "", "", "", "⭨", "");
  CreateFIELD(_Mnth, Who,    LIKE(Monthly.Who), "", "", "", "", "");
  CreateFIELD(_Mnth, Period, LIKE(Monthly.Period), "", "", "", "ਮ", "");
  CreateFIELD(_Mnth, MtyIdx, LIKE(Monthly.MtyIdx), "", "", "", "⥫ 筮 ⥫", "");
  CreateFIELD(_Mnth, ODate,  LIKE(Monthly.ODate), "", "", "", "/", "");
  CreateFIELD(_Mnth, Proof,  LIKE(Monthly.Proof), "", "", "", "稭", "");
  CreateFIELD(_Mnth, Source, LIKE(Monthly.Source), "", "", "", "筨", "");

  CreateINDEX(_Mnth, _Mnth, UNIQUE, "", "", TSN, Period, ODate, Who, Source, MtyIdx);
  CreateINDEXandLINK(_Mnth, TSN,    PLURAL, Staff, TSN, USER, " ", "", TSN, ODate);
  CreateINDEXandLINK(_Mnth, MtyIdx, PLURAL, MtyIdx, MtyIdx, USER, "⥫", "", MtyIdx, TSN, ODate);

  SetVersionOfFILE(_Mnth, 0000);
 END {Create_Mnth};

 PRIVATE PROCEDURE MakeIndex(_MtyIdx: LIKE(MtyIdx.MtyIdx));
  VAR
   oPrompt: PROMPTLINE;
 BEGIN
  oPrompt:=PROMPTLINE.Create("");
  SELECT(Monthly, MtyIdx, , _MtyIdx);
  SRCINSEL(Monthly, GE, , Memo.ud_fr());
  WHILE OCCURE(Monthly) & (Monthly.Period <= Memo.ud_ut()) DO
   PROMPT(_MtyIdx+" "+L_DatTim.PeriodStr(Monthly.Period)+" "+Monthly.TSN);
   ADD(_Mnth, _Mnth, , Monthly.TSN, Monthly.Period, Monthly.ODate,
                       Monthly.Who, Monthly.Source, Monthly.MtyIdx,
                       _Mnth.Proof, Monthly.Proof);
   NEXT(Monthly);
  END; (* WHILE OCCURE(Monthly) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE Make_Mthly();
  VAR
   oPrompt: PROMPTLINE;
 BEGIN
  oPrompt:=PROMPTLINE.Create("⮢ "+RepName);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeHeader("R");

  SELECT(MtyIdx, MtyIdx);
  WHILE OCCURE(MtyIdx) DO
   MakeIndex(MtyIdx.MtyIdx);
   NEXT(MtyIdx);
  END; (* WHILE OCCURE(MtyIdx) ... *)

  SELECT(_Mnth, _Mnth);
  WHILE OCCURE(_Mnth) DO
   NARROWSEL(_Mnth, TSN);
   WHILE OCCURE(_Mnth) DO
    SETZERO(_Proof);
    PROMPT(_Mnth.TSN+" "+L_DatTim.DateStr(_Mnth.Period));
    NARROWSEL(_Mnth, Period, ODate, Who, Source);
    CONFORM(_Mnth, Staff);
    IF OCCURE(Staff) THEN
     WHILE OCCURE(_Mnth) DO
      INC(_Proof[_Mnth.MtyIdx], _Mnth.Proof);
      NEXT(_Mnth);
     END; (* WHILE OCCURE(_Mnth) ... *)
     LAST(_Mnth);
     SEARCH(StaffLog, TSN, , Staff.TSN, _Mnth.ODate);
     CONFORM(Staff, Man);
     CONFORM(StaffLog, Sort);
     CONFORM(StaffLog, Officer);
     CONFORM(Officer, Union);
     CONFORM(Officer, Post);
     MakePart("R");
    ELSE
     L_General.ConsultToUs(~L_AR.DatabaseIsTransparent(), "Mthly.Make_Mthly: 㯭  Staff "+_Mnth.TSN);
    END;
    NEXTINEXTENDEDSEL(_Mnth, Period, ODate, Who, Source);
   END; (* WHILE OCCURE(_Mnth) ... *)
   NEXTINEXTENDEDSEL(_Mnth, TSN);
  END; (* WHILE OCCURE(_Mnth) ... *)
  FIO.Close(R);
 END {Make_Mthly};

 PRIVATE PROCEDURE Make_C_MTI();
  VAR
   _Proof,
   TotProof: NUMERIC[3];
   oPrompt: PROMPTLINE;
 BEGIN
  oPrompt:=PROMPTLINE.Create("⮢ "+RepName);
  L_General.Assert(ACCESS(MtyIdx), " । ⥫ 筮 ⥫");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top);
  MakeIndex(MtyIdx.MtyIdx);

  TotProof:=0;
  SELECT(_Mnth, TSN);
  WHILE OCCURE(_Mnth) DO
   _Proof:=0;
   PROMPT(_Mnth.TSN+" "+L_DatTim.PeriodStr(_Mnth.ODate));
   NARROWSEL(_Mnth, TSN, ODate);
   WHILE OCCURE(_Mnth) DO
    INC(_Proof,   _Mnth.Proof);
    INC(TotProof, _Mnth.Proof);
    NEXT(_Mnth);
   END; (* WHILE OCCURE(_Mnth) ... *)
   LAST(_Mnth);
   CONFORM(_Mnth, Staff);
   IF OCCURE(Staff) THEN
    CONFORM(Staff, Man);
    MAKEPART(R, Line, _Mnth.ODate, _Proof);
   ELSE
    L_General.ConsultToUs(~L_AR.DatabaseIsTransparent(), "Mthly.Make_C_MTI: 㯭  Staff "+_Mnth.TSN);
   END;
   NEXTINEXTENDEDSEL(_Mnth, TSN, ODate);
  END; (* WHILE OCCURE(_Mnth) ... *)

  MAKEPART(R, Bot, TotProof);
  CLOSEREP(R);
 END {Make_C_MTI};

(*
$P{ TopUs:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
MtyIdx.MtyIdx + " " + MtyIdx.Name, C, ""
@
##########################################################################################    ########## #####
=#####========================================================================================================
|                                ᯮ짮 ⥫ 筮 ⥫                               |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
| ࠡ                  ||  ࠡ               |⢮                |C         |        |
|----------------------------|---|----------------------------|------------------------|----------|----------|
}
*)

(*
$P{ LineUs:
WJMode.WJCode, L, ""
WJMode.Name, L, ""
L_Str.PoolItem("||||---|", WJMethod.Who), L, ""
JRegime.JRegime,  L, ""
JRegime.Name,     L, ""
WJMethod.Quality, L, ""
Quality.Name,     L, ""
WJMethod.Begin,   L, "D.N.y"
WJMethod.Till,    L, "D.N.y"
@
|## #########################|###|## #########################|### ####################|##########|##########|
}
*)

(*
$P{ BotUs:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE MakeUsMth(D: DATE);
 BEGIN
  L_General.Assert(ACCESS(MtyIdx), " । ⥫ 筮 ⥫");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, TopUs, RepName);
  SELECT(WJMty, WJCode);
  WHILE OCCURE(WJMty) DO
   IF WJMty.MtyIdx = MtyIdx.MtyIdx THEN
    SELECT(WJMethod, WJCode, , WJMty.WJCode, WJMty.Who, WJMty.JRegime, WJMty.Quality, WJMty.Begin);
    WHILE OCCURE(WJMethod) DO
     IF !D | ((D <= WJMethod.Till) & (D >= WJMethod.Begin)) THEN
      CONFORM(WJMethod, WJMode, JRegime, Quality);
      PROMPT(JRegime.Name);
      MAKEPART(R, LineUs);
     END;
     NEXT(WJMethod);
    END; (* WHILE OCCURE(WJMethod) ... *)
   END;
   NEXT(WJMty);
  END; (* WHILE OCCURE(WJMty) ... *)
  MAKEPART(R, BotUs);
  CLOSEREP(R);
 END {MakeUsMth};

BEGIN
 IF    MODE = 002 THEN
  RepName:="UsMt";
  MakeUsMth(L_General.EMPTY_DATE());
 ELSIF MODE = 003 THEN
  RepName:="UsMtA";
  MakeUsMth(Memo.ud_cd());
 ELSE
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
  Create_Mnth();
  L_AFM.AF_CreateTemp("_Mnth", "_Mnth");
  IF    MODE = 000 THEN
   RepName:="Mthly";
   Make_Mthly();
  ELSIF MODE = 001 THEN
   RepName:="C_MTI";
   Make_C_MTI();
  ELSE
   L_General.BadMode(MODE);
  END;
  L_AFM.AF_PurgeTemp("_Mnth");
 END;
END.
