(*
%Copyright   (c) Polak IT
%Author      05.10.2011 12:49:34 POLAK\GAV
%Purpose     殮  "" ( ᠦ஢)
%Type        operation
%Specific    LOC
%Modified    21.07.2014 11:26:32 POLAK\LDA
%Environment
*)

 MODULE NavRs [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Way, Memo, L_DatTim, P_Car, FIO, L_AFM, Math, L_General, L_Str, L_Events, L_StdFrm,
        L_OwnData, E_Way, L_bp, Str, L_Car, L_Basis;

 PRIVATE PROCEDURE E_nrPath(): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.NAVRS_nrPath);
  IF    APP.Get().SupportMode THEN
   RETURN "TMP\NAVIGATOR";
  ELSIF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN "TXT\NAVIGATOR";
  END;
 END {E_nrPath};

 PRIVATE PROCEDURE IsWorkTrip(): SCAL[2];
 BEGIN
  CONFORM(RWayJ, SEJobs);
  CONFORM(SEJobs, WJMode);
  RETURN WJMode.RunSel # L_Way.runsel_None;
 END {IsWorkTrip};

 PRIVATE PROCEDURE CleanRWayJP(D: DATE);
 BEGIN
  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated, D);
  WHILE OCCURE(RWayS) DO
   PROMPT(RWayS.RWayS);
   IF P_Car.HasActualCarPro(RWayS.BoxNbr, D, P_Car.P_WithASMPP) THEN
    SELECT(RWayJP, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayJP) DO
     IF (RWayJP.RWJPro = E_Way.rwjp_PsgFromNavigator) & (RWayJP.Source = L_Way.rwjpSrc_Import) THEN
      IF RWayS.Done THEN
       SAVE(RWayJP);
       CALL(RWayS, L_Events.md_StreamMakeUnDone);
       RESTORE(RWayJP);
      END;
      REMOVE(RWayJP);
     ELSE
      NEXT(RWayJP);
     END;
    END; (* WHILE OCCURE(RWayJP) ... *)
   END; (* IF P_Car.HasActualCarPro(RWayS.BoxNbr, D, P_Car.P_WithASMPP) *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {CleanRWayJP};

 PRIVATE PROCEDURE rwslsGather(D: DATE);
  VAR
   bt,
   et,
   gapT: NUMERIC[3];
 BEGIN
  L_AFM.MakeMultipleIndex("rwsls", "boxnbr  : LIKE(Car.BoxNbr); " +
                                   "statenbr: LIKE(Car.StateNbr); " +
                                   "rways   : LIKE(RWayS.RWayS); " +
                                   "d       : DATE; " +
                                   "bt      : NUMERIC[3]; " +
                                   "et      : NUMERIC[3]; " +
                                   "gap     : NUMERIC[3]",
                          "rwsls: boxnbr, d, bt; rways: rways; statenbr: statenbr, d, bt");
  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated, D);
  WHILE OCCURE(RWayS) DO
   PROMPT(RWayS.RWayS);
   IF P_Car.HasActualCarPro(RWayS.BoxNbr, D, P_Car.P_WithASMPP) THEN
    SETEMPTY(bt, et);
    gapT:=0;
    SELECT(RWayJ, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayJ) DO
     CONFORM(RWayJ, Quality);
     IF Quality.Type THEN
      IF IsWorkTrip() THEN
       IF !bt THEN
        bt:=L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT);
       END;
       et:=L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT);
      ELSE
       INC(gapT, RWayJ.StopT - RWayJ.StartT);
      END; (* IF IsWorkTrip()  *)
     END; (* IF Quality.Type *)
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
    IF ~!bt THEN
     IF SEARCH(rwsls, rwsls, RWayS.BoxNbr, RWayS.Date, bt) THEN
      L_General.Error("  " + RWayS.BoxNbr + " 㦥   " + rwsls.rways + ", 稭騩 " +
                      L_DatTim.TimestampStr(L_DatTim.GetTIMESTAMP(RWayS.Date, 00:00) + bt / 24));
     END;
     CONFORM(RWayS, Car);
     rwsls.boxnbr  :=RWayS.BoxNbr;
     rwsls.statenbr:=Car.StateNbr;
     rwsls.rways   :=RWayS.RWayS;
     rwsls.d       :=RWayS.Date;
     rwsls.bt      :=bt;
     rwsls.et      :=et;
     rwsls.gap     :=gapT;
     INSERT(rwsls);
    END; (* IF ~!bt *)
   END; (* IF P_Car.HasActualCarPro(RWayS.BoxNbr, D, P_Car.P_WithASMPP) *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {rwslsGather};

 PRIVATE PROCEDURE rwslsAddNoWorkIntervals(D: DATE);
  VAR
   bt,
   et,
   gapT: NUMERIC[3];
 BEGIN
  SELECT(rwsls, rwsls);
  WHILE OCCURE(rwsls) DO
   PROMPT(rwsls.boxnbr);
   NARROWSEL(rwsls, boxnbr);
   bt:=L_Way.FullBegTime(1, 00:00);
   SETSEL(RWayS, BoxNbr, rwsls.boxnbr);
   IF SRCINSEL(RWayS, LT, D) THEN
    SETSEL(RWayJ, RWayS, RWayS.RWayS);
    LAST(RWayJ);
    LOOP
     IF ~OCCURE(RWayJ) THEN
      EXIT;
     END;
     CONFORM(RWayJ, Quality);
     IF Quality.Type & IsWorkTrip() THEN
      bt:=Math.Max(bt, (RWayS.Date - D)*24 + L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT));
      EXIT;
     END; (* IF Quality.Type... *)
     PREV(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
   END; (* IF SRCINSEL(RWayS, LT, D) *)

   WHILE OCCURE(rwsls) DO
    et:=rwsls.bt;
    IF et > bt THEN
     rwsls.bt:=bt;
     rwsls.et:=et;
     SETEMPTY(rwsls.rways, rwsls.gap);
     INSERT(rwsls);
    END;
    bt:=rwsls.et;
    NEXT(rwsls);
   END; (* WHILE OCCURE(File) *)
   IF bt < L_Way.FullBegTime(2, 00:00) THEN
    LAST(rwsls);
    rwsls.bt:=bt;
    rwsls.et:=L_Way.FullBegTime(2, 00:00);
    SETEMPTY(rwsls.rways, rwsls.gap);
    INSERT(rwsls);
   END;
   NEXTINEXTENDEDSEL(rwsls, boxnbr);
  END; (* WHILE OCCURE(rwsls) *)
 END {rwslsAddNoWorkIntervals};

 PRIVATE PROCEDURE ToTime(ft: NUMERIC[3]): TIME;
 BEGIN
  RETURN 00:00 + Math.Mod(ft + 0.5/60, 24);
 END {ToTime};

 PRIVATE PROCEDURE MakeRequest(D: DATE);
  VAR
   fn: STRING[];
 BEGIN
  rwslsGather(D);
  rwslsAddNoWorkIntervals(D);
  fn:=FIO.BuildPath("NavRequest_" + FLDTOSTR(D, "yND"), "txt", E_nrPath());
  FIO.Open(F, fn, , Create);
  FIO.SetCP(F, FIO.CP_WindowsRussian);
  SELECT(rwsls, rwsls);
  WHILE OCCURE(rwsls) DO
   PROMPT(rwsls.boxnbr);
   L_General.CallUs(rwsls.bt < 24);
   FIO.WrStr(F, rwsls.statenbr + ";");
   FIO.WrStr(F, L_DatTim.DateStr(rwsls.d) + ";");
   FIO.WrStr(F, L_DatTim.TimeStr(ToTime(rwsls.bt)) + "-");
   FIO.WrStr(F, L_DatTim.TimeStr(ToTime(rwsls.et)) + ";");
   FIO.WrStr(F, FLDTOSTR(rwsls.gap, "3."));
   FIO.WrLn(F);
   NEXT(rwsls);
  END; (* WHILE OCCURE(rwsls) ... *)
  FIO.Close(F);
  L_StdFrm.Inform("ନ஢ 䠩 " + fn);
 END {MakeRequest};

 PUBLIC PROCEDURE NRMRq();
  CONST
   bpId = "NRMRq";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.extBegin(bpId, "⮢     ''",
                L_bp.t_Process, L_General.tc_onDate, L_bp.pt_StrictlyInTime);
  MakeRequest(Memo.ud_cd());
  L_bp.End();
 END {NRMRq};

(*
$P{ NRImp_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                  ⮪    ᠦ   ""  ###########                   |
|------------------------------------------------------------------------------------------------------------|
|.|   ६   |  |     |ᠭ ஡                                                           |
|----|-----------|------|-------|----------------------------------------------------------------------------|
}
*)

(*
$P{ NRImp_Line:
?, L, ""
?, L, "H:M"
?, L, "H:M"
?, R, "0"
?, L, ""
?, L, ""
@
|####|#####-#####|######|#######|############################################################################|
}
*)

(*
$P{ NRImp_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PUBLIC PROCEDURE NRImp();
  CONST
   TryRenewRequestMsg = "|⭮,   ᥭ  ᫥ ନ஢   ''."+
                        "|| ନ஢  ᭮.";
   bpId = "NRImp";
  VAR
   fn,
   s,
   statenbr : STRING[];
   rwsD,
   D        : DATE;
   bt,
   et       : TIME;
   psg      : NUMERIC[0];
   curBoxNbr,
   outBoxNbr: LIKE(Car.BoxNbr);
 BEGIN
  D:=Memo.ud_cd();
  L_bp.extBegin(bpId, "  ''", L_bp.t_Prc_wRp, L_General.tc_onDate, L_bp.pt_StrictlyInTime);
  L_StdFrm.Question("㧨   ᠦ  ''  " + L_DatTim.DateStr(D));
  fn:=FIO.BuildPath("NavResponse_" + FLDTOSTR(D, "yND"), "txt", E_nrPath());
  L_General.Assert(FIO.Exists(fn), "  䠩  묨 " + fn);
  rwslsGather(D);

  CleanRWayJP(D);

  FIO.Open(F, fn, , Input);
  FIO.SetCP(F, FIO.CP_WindowsRussian);
  OPENREP(R, L_General.NameConnection(bpId + "_" + FLDTOSTR(D, "yND")), Create);
  MAKEPART(R, NRImp_Top, bpId, D);
  SETEMPTY(curBoxNbr);
  WHILE FIO.RdStr(F, s) DO
   PROMPT(s);
   statenbr:=L_Str.AnyItem(s, ";", 0);
   rwsD    :=STRTOFLD(L_Str.AnyItem(s, ";", 1), DATE);
   bt      :=STRTOFLD(L_Str.AnyItem(L_Str.AnyItem(s, ";", 2), "-", 0), TIME);
   et      :=STRTOFLD(L_Str.AnyItem(L_Str.AnyItem(s, ";", 2), "-", 1), TIME);
   psg     :=STRTOFLD(L_Str.AnyItem(s, ";", 4), NUMERIC);

   SELECT(Car, StateNbr, , statenbr);
   WHILE OCCURE(Car) & ~L_DatTim.IsActive(D, Car.BegDate, Car.EndDate) &
         ~P_Car.HasActualCarPro(RWayS.BoxNbr, D, P_Car.P_WithASMPP) DO
    NEXT(Car);
   END; (* WHILE OCCURE(Car) ... *)
   L_General.Assert(OCCURE(Car), "    㤠⢥ ॣ樮  " + statenbr);
   IF Car.BoxNbr # curBoxNbr THEN
    outBoxNbr:=Car.BoxNbr;
   ELSE
    SETEMPTY(outBoxNbr);
   END;
   curBoxNbr:=Car.BoxNbr;
   IF SELECT(rwsls, statenbr, statenbr, rwsD, bt - 00:00) THEN
    L_General.Assert(ToTime(rwsls.et) = et,
                     "६ 砭 ᬥ   ⫨砥  㪠  ." + TryRenewRequestMsg);
    IF psg > 0 THEN
     SEARCH(RWayS, RWayS, , rwsls.rways);
     IF RWayS.Done THEN
      CALL(RWayS, L_Events.md_StreamMakeUnDone);
     END;
     SETSEL(RWayJ, RWayS, RWayS.RWayS);
     LAST(RWayJ);
     LOOP
      L_General.CallUs(OCCURE(RWayJ));
      CONFORM(RWayJ, Quality);
      IF Quality.Type THEN
       IF IsWorkTrip() THEN
        L_General.CallUs(et = RWayJ.StopT);
        EXIT;
       END; (* IF IsWorkTrip()  *)
      END; (* IF Quality.Type *)
      PREV(RWayJ);
     END; (* WHILE OCCURE(RWayJ) ... *)
     L_Way.SetRWayJP(E_Way.rwjp_PsgFromNavigator, psg, L_Way.rwjpSrc_Import);
     MAKEPART(R, NRImp_Line, outBoxNbr, bt, et, psg, rwsls.rways);
    ELSIF psg = 0 THEN
     MAKEPART(R, NRImp_Line, outBoxNbr, bt, et, 0, rwsls.rways, "뫨 ᮡ,   䨪஢ 室");
    ELSE
     MAKEPART(R, NRImp_Line, outBoxNbr, bt, et, 0, rwsls.rways, " 뫮 ᮡ⨩");
    END;
   ELSE
    L_General.Assert(!L_Str.AnyItem(s, ";", 3), " 室饣 ." + TryRenewRequestMsg);
    MAKEPART(R, NRImp_Line, outBoxNbr, bt, et, psg, , L_Str.PoolItem(" 室  筮 ६|", psg < 50));
   END; (* IF SEARCH(... *)
  END; (* WHILE FIO.RdStr(F, s) *)
  FIO.Close(F);
  MAKEPART(R, NRImp_Bot);
  L_bp.End();
 END {NRImp};


 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "⥫");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " 窠");
  L_Basis.wb_WrInQM(F, "᪠ 窠");
  L_Basis.wb_WrInQM(F, "ᠦ  ");
  L_Basis.wb_WrInQM(F, "ᠦ  稪");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  SEARCH(Staff, TSN, , _RWay.TSN);
  CONFORM(Staff, Man);
  L_Car.StandOnCarLog(_RWay.BoxNbr, _RWay.Date);
  CONFORM(CarLog, Mark);
  SEARCH(Route, Route, , _RWay.Route);
  SEARCH(StExit, Exit, , _RWay.Exit);
  CONFORM(StExit, ExitClss);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrStr(F, CarLog.BoxNbr);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  L_Basis.wb_WrScl(F, StExit.Exit);
  L_Basis.wb_WrStr(F, StExit.Name);
  L_Basis.wb_WrScl(F, ExitClss.ExitClss);
  L_Basis.wb_WrStr(F, ExitClss.Sign);
  L_Basis.wb_WrDat(F, _RWay.Date);
  L_Basis.wb_WrNum(F, _RWay.PlnInc, 2);
  L_Basis.wb_WrNum(F, _RWay.FctInc, 2);
  L_Basis.wb_WrNum(F, _RWay.PsgRWS, 0);
  L_Basis.wb_WrNum(F, _RWay.PsgCnt, 0);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE ProceedOneRWayS();
  VAR
   _FctInc : NUMERIC[2];
   _PsgRWS,
   _PsgCnt : NUMERIC[0];
 BEGIN
  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayJ) DO
   SETZERO(_FctInc, _PsgRWS, _PsgCnt);
   CONFORM(RWayJ, RWayJP);
   WHILE OCCURE(RWayJP) DO
    IF    L_Way.TrIncFct(L_Way.rwswho_Driver, 1, RWayJP.RWJPro) THEN
     INC(_FctInc, RWayJP.Value);
    ELSIF L_Way.IsVldPsgRWJPro(L_Way.rwswho_Driver, 1, L_Way.vpk_Moscow, RWayJP.RWJPro) |
          L_Way.IsVldPsgRWJPro(L_Way.rwswho_Driver, 1, L_Way.vpk_MoscowRegion, RWayJP.RWJPro) |
          L_Way.IsVldPsgRWJPro(L_Way.rwswho_Driver, 1, L_Way.vpk_OtherSocial, RWayJP.RWJPro) |
          L_Way.IsVldPsgRWJPro(L_Way.rwswho_Driver, 1, L_Way.vpk_Paid, RWayJP.RWJPro) |
          L_Way.E_TrPsgFct(L_Way.rwswho_Driver, 1, RWayJP.RWJPro) THEN
     INC(_PsgRWS, RWayJP.Value);
    ELSIF RWayJP.RWJPro = E_Way.rwjp_PsgFromNavigator THEN
     INC(_PsgCnt, RWayJP.Value);
    END;
    NEXT(RWayJP);
   END; (* WHILE OCCURE(RWayJP) ... *)
   IF (RWayJ.PlIncome # 0) | (_FctInc # 0) | (_PsgRWS # 0) | (_PsgCnt # 0) THEN
    CONFORM(RWayJ, SEJobs);
    ADD(_RWay, _RWay, , RWayS.Date + RWayJ.Day - 1, RWayS.BoxNbr, RWayS.TSN, SEJobs.Route, SEJobs.Exit,
        _RWay.PlnInc, RWayJ.PlIncome,
        _RWay.FctInc, _FctInc,
        _RWay.PsgRWS, _PsgRWS,
        _RWay.PsgCnt, _PsgCnt);
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
 END {ProceedOneRWayS};

 PUBLIC PROCEDURE NvPsg();
  CONST
   bpId = "NvPsg";
  VAR
   PerB,
   PerE : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "  ᠦ஢", L_bp.t_Basis, L_General.tc_inIntvl);
  PerB:=Memo.ud_fr();
  PerE:=Memo.ud_ut();
  L_AFM.MakeMultipleIndex("_RWay", "BoxNbr: LIKE(Car.BoxNbr);" +
                                   "TSN   : LIKE(Staff.TSN);" +
                                   "Route : LIKE(Route.Route);" +
                                   "Exit  : LIKE(StExit.Exit);" +
                                   "Date  : DATE;" +
                                   "PlnInc: NUMERIC[2];" +
                                   "FctInc: NUMERIC[2];" +
                                   "PsgRWS: NUMERIC[0];" +
                                   "PsgCnt: NUMERIC[0]",
                          "_RWay:Date,BoxNbr,TSN,Route,Exit");

  SELECT(RWayS, sBoxNbr, , L_Way.rwsStat_Rated);
  WHILE OCCURE(RWayS) DO
   PROMPT("⮢ " + RWayS.BoxNbr);
   NARROWSEL(RWayS, BoxNbr);
   IF P_Car.HasCarPro(RWayS.BoxNbr, PerE, P_Car.P_WithASMPP) THEN
    SRCINSEL(RWayS, GE, , PerB);
    WHILE OCCURE(RWayS) & (RWayS.Date <= PerE) DO
     IF P_Car.HasActualCarPro(RWayS.BoxNbr, RWayS.Date, P_Car.P_WithASMPP) THEN
      PROMPT("⮢ " + RWayS.BoxNbr + " " + RWayS.RWayS);
      ProceedOneRWayS();
     END; (* IF ~L_Way.E_IsGuardIdleExit( ... *)
     NEXT(RWayS);
    END; (* WHILE OCCURE(File) *)
   END;
   NEXTINEXTENDEDSEL(RWayS, BoxNbr);
  END; (* WHILE OCCURE(RWayS) *)

  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
  SELECT(_RWay, _RWay);
  WHILE OCCURE(_RWay) DO
   PROMPT(" " + L_DatTim.DateStr(_RWay.Date) + " " + _RWay.BoxNbr);
   MakePart("R");
   NEXT(_RWay);
  END; (* WHILE OCCURE(_RWay) ... *)
  FIO.Close(R);
  L_bp.End();
 END {NvPsg};

END.
