(*
%Copyright   (c) Polak IT
%Author      19.04.2010 19:02:33 LDA
%Purpose     殮  ࢥ஬.
%Type        operation
%Specific    AP
%Modified    07.06.2013 12:14:43 POLAK\LDA
%Environment
*)

 IMPORT FIO, L_General, L_OwnData, L_AFM, L_DFS, Str, L_FIO, L_Str, L_MDoc, P_MDoc, L_DatTim, Memo, P_Firm,
        L_Stock, L_XDoc, L_MathR, L_StdFrm, L_BarCode, P_Storage, L_BegRWS, L_Acnt, L_Timer, L_WDO,
        L_Events, L_EC, E_Stock, L_PCS;

 CONST
  RepNameLength = 64;

  MaxErrorAmount = 10;

  st_Amount = 4;

  st_Normal        = 0;
  st_TechOperation = 1;
  st_BadData       = 2;
  st_InsMDocFailed = 3;

 VAR
  LIKEMENUCommand: STRING[];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
############################################################################################# ########## #####
=################################################################=============================================
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|/६    |    | |-|   㬬|                                                        |
|--------------|-------|---|------|--------|-----------------------------------------------------------------|
}
*)

(*
$P{ Line:
?, L, ""
?, L, ""
?, L, ""
?, R, "2."
?, R, "2-"
?, L, ""
@
|##############|#######|###|######|########|#################################################################|
}
*)

(*
$P{ SubBot:
@
|------------------------------------------------------------------------------------------------------------|
|                                         ࠡ⠭      .樨   ஢             ᥣ|
}
*)

(*
$P{ BotLine:
?, L, ""
?, R, "2."
?, R, "2."
?, R, "2."
?, R, "2."
@
|########################################### ##########        ##########        ##########       ###########|
}
*)


(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE E_Nefto_Path(): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(SYSDATE(), PROCREF(E_Stock.NeftoStan_Path), "");
 END {E_Nefto_Path};

 PRIVATE PROCEDURE E_GetMDocKind(nefto_Dest: SCAL[1E3]): LIKE(MDocKind.MDocKind);
  VAR
   Local  : PROC;
   default: LIKE(MDocKind.MDocKind);
 BEGIN
  SETEMPTY(default);
  IF (nefto_Dest = 002) | (nefto_Dest = 009) THEN
   default:=L_MDoc.md_TCh;
  END;
  Local  :=PROCREF(E_Stock.NeftoStan_GetMDocKind);
  IF ~!Local THEN
   RETURN Local(SYSDATE(), default);
  END;
  RETURN default;
 END {E_GetMDocKind};

 PRIVATE PROCEDURE E_GetDest(): LIKE(Dest.Dest);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Stock.NeftoStan_GetDest);
  IF ~!Local THEN
   RETURN Local(SYSDATE());
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {E_GetDest};

 PRIVATE PROCEDURE E_ConvNEFTOMathToMath(): LIKE(Math.Math);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Stock.NeftoStan_ConvNEFTOMathToMath);
  IF !Local THEN
   L_General.SetupRequired();
  END;
  RETURN Local(SYSDATE());
 END {E_ConvNEFTOMathToMath};

 PRIVATE PROCEDURE E_GetStorage(): LIKE(Storage.Storage);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Stock.NeftoStan_GetStorage);
  IF ~!Local THEN
   RETURN Local(SYSDATE());
  ELSE
   RETURN L_Stock.DefaultStorage();
  END;
 END {E_GetStorage};

 PRIVATE PROCEDURE E_GetMDocStatus(): LIKE(MDoc.Status);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Stock.NeftoStan_GetStatus);
  IF ~!Local THEN
   RETURN Local(SYSDATE());
  ELSE
   RETURN L_MDoc.st_Passed;
  END;
 END {E_GetMDocStatus};

 PRIVATE PROCEDURE MDocAlreadyBuilt(_MDocKind: LIKE(MDocKind.MDocKind); D: DATE): SCAL[2];
 BEGIN
  SELECT(MDoc, MDKSrcN, , _MDocKind, _ImpD.TrnNbr, D);
  WHILE OCCURE(MDoc) DO
   IF L_XDoc.XDocWasAutoBuild(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
    RETURN 1;
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
  RETURN 0;
 END {MDocAlreadyBuilt};

 PRIVATE PROCEDURE IsAllowedOperation(): SCAL[2];
 BEGIN
  RETURN (_ImpD.nft_Dest = 007) | ((_ImpD.nft_Dest = 110) & (_ImpD.Amount = 0));
 END {IsAllowedOperation};

 PRIVATE PROCEDURE MakePart();
  VAR
   i  : NUMERIC[0];
   Sum: NUMERIC[2];
   Msg: STRING[];
 BEGIN
  PROMPT(" ⮪: ࠭ " + _ImpD.TrnNbr);
  IF _ImpD.MDocKind = L_MDoc.md_TCh THEN
   Sum:=_ImpD.Sum;
  ELSE
   SETEMPTY(Sum);
  END;
  SETEMPTY(Msg);
  IF    (_ImpD.Status = st_BadData) | (_ImpD.Status = st_InsMDocFailed) THEN
   Msg:="!!! ";
  ELSIF (_ImpD.Status = st_Normal) & !_ImpD.XDocId THEN
   Msg:="  ନ஢ - ।饩 訡";
  END;

  i:=0;
  MAKEPART(R, Line, FLDTOSTR(_ImpD.BegDTS, "D.N.Y H:M"), _ImpD.TrnNbr, _ImpD.nft_Dest, _ImpD.Amount, Sum, Msg + _ImpD.Result[i]);
  LOOP
   INC(i);
   IF (i > HIGH(_ImpD.Result)) | !_ImpD.Result[i] THEN
    EXIT;
   END;
   MAKEPART(R, Line, "", L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(), _ImpD.Result[i], "");
  END;
 END {MakePart};

 PRIVATE PROCEDURE E_InformAboutAllTrn(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Stock.NeftoStan_InformAboutAllTrn), 1);
 END {E_InformAboutAllTrn};

 PRIVATE PROCEDURE InfoDoneSingleTransaction();
  VAR
   i,
   TimeOut : NUMERIC[0];
   Msg,
   Text,
   MathName: STRING[];
   ErrorMsg: SCAL[2];
 BEGIN
  IF    _ImpD.Status = st_BadData THEN
   ErrorMsg :=1;
   Text     :="|४   䠩 :|";
  ELSIF _ImpD.Status = st_InsMDocFailed THEN
   ErrorMsg :=1;
   Text     :="|訡  ଫ  ( 㤥 믮 ୮):|";
  ELSE
   ErrorMsg :=0;
   Text     :="";
  END;

  IF ErrorMsg | E_InformAboutAllTrn() THEN
   i:=0;
   LOOP
    IF (i > HIGH(_ImpD.Result)) | !_ImpD.Result[i] THEN
     EXIT;
    END;
    Text:=Text + _ImpD.Result[i] + "|";
    INC(i);
   END;
 
   IF ~!_ImpD.Math THEN
    SEARCH(Math, Math, , _ImpD.Math);
    MathName:=" ⮯ " + _ImpD.Math + " " + Math.Name;
   ELSE
    MathName:=" ⮯ ?????";
   END;
 
   TimeOut:=10;
   Msg    :=" ⮯||" +
            " " + _ImpD.Nozzle + "|" + MathName + ", - " + FLDTOSTR(_ImpD.Amount, "3.") + "||" +
            Text ;
   IF ~ErrorMsg THEN
    L_StdFrm.TimedINFORM(Msg, TimeOut);
   ELSE
    L_StdFrm.TimedINFORM_AsSTOP(Msg, TimeOut);
   END;
  END;
 END {InfoDoneSingleTransaction};

 PRIVATE PROCEDURE InfoDoneAllTransaction();
  VAR
   Msg,
   Text,
   Palette       : STRING[];
   TimeOut,
   MDocAmount,
   ErrorAmount    : NUMERIC[0];
   _MDocKind      : LIKE(MDocKind.MDocKind);
 BEGIN
  SETEMPTY(Msg);
  SETZERO(ErrorAmount);
  SELECT(_ImpD, MDocKind);
  WHILE OCCURE(_ImpD) DO
   SETZERO(MDocAmount);
   NARROWSEL(_ImpD, MDocKind);
   _MDocKind:=_ImpD.MDocKind;
   IF ~!_MDocKind THEN
    Msg:=Msg + L_MDoc.MDocKindNick(_MDocKind, 1) + ":";
   END;
   WHILE OCCURE(_ImpD) DO
    IF _ImpD.Status # st_TechOperation THEN
     IF ~!_ImpD.XDocId THEN
      INC(MDocAmount);
     ELSE
      INC(ErrorAmount);
     END;
    END;
    NEXT(_ImpD);
   END; (* WHILE OCCURE(_ImpD) ... *)
   IF ~!_MDocKind THEN
    Msg:=Msg + Str.Align(L_Str.IntStr(MDocAmount), 6, RIGHT) + "|";
   END;
   NEXTINEXTENDEDSEL(_ImpD, MDocKind);
  END; (* WHILE OCCURE(_ImpD) ... *)

  IF ~!Msg THEN
   Msg:="ଫ ⮢ 㬥⮢:||" + Msg;
  END;

  SETEMPTY(Text);
  IF ErrorAmount > 0 THEN
   Palette:="STOP";
   Text   :="|   㦥 訡: " + L_Str.IntStr(ErrorAmount) + ".||" +
            "᫥ ࠭ ஡   ,|" +
            " ଫ ⮫쪮  ||";
  ELSE
   Palette:="INFORM";
  END;
  TimeOut:=15;
  STDFORM(Text + Msg + "||" + L_StdFrm.DrawButton("  %T", 16, "B"), , ^Palette, , TimeOut);
 END {InfoDoneAllTransaction};

 PRIVATE PROCEDURE GetInclNetto(_Math: LIKE(Math.Math); D: DATE; _Total: FLOAT): FLOAT;
 BEGIN
  RETURN _Total - L_Acnt.GetInclMathVAT(_Math, D, _Total);
 END {GetInclNetto};

 PRIVATE PROCEDURE GetExclVAT(_Math: LIKE(Math.Math); D: DATE; _Total: FLOAT): FLOAT;
 BEGIN
  RETURN L_Acnt.GetExclMathVAT(_Math, D, _Total);
 END {GetExclVAT};

 PRIVATE PROCEDURE GetMDocDate(_MDocKind: LIKE(MDocKind.MDocKind)): DATE;
 BEGIN
  IF _MDocKind = L_MDoc.md_NOV THEN
   RETURN L_BegRWS.DspDate(L_DatTim.GetDateOfTIMESTAMP(_ImpD.BegDTS), L_DatTim.GetTimeOfTIMESTAMP(_ImpD.BegDTS));
  ELSE
   RETURN L_DatTim.GetDateOfTIMESTAMP(_ImpD.BegDTS);
  END;
 END {GetMDocDate};

 PRIVATE PROCEDURE GetArchiveFolder(_Date: DATE): STRING[];
  VAR
   ArchiveFolder: STRING[];
 BEGIN
  ArchiveFolder:=FIO.BuildPath("ARCHIVE", , E_Nefto_Path());
  ArchiveFolder:=FIO.BuildPath(FLDTOSTR(_Date, "yN"), , ArchiveFolder);
  RETURN ArchiveFolder;
 END {GetArchiveFolder};

 PRIVATE PROCEDURE GetArchiveFullFileName(srcFullFileName: STRING[]): STRING[];
  VAR
   ArchiveFolder: STRING[];
 BEGIN
  ArchiveFolder:=GetArchiveFolder(L_DatTim.GetDateOfTIMESTAMP(L_FIO.GetFileLastModifiedDTS(srcFullFileName)));
  TRY [MSGSUPPRESSIONMODE(MSGSUPPRESS_ALL), EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   L_FIO.MakeSubDirs(ArchiveFolder);
   RETURN L_FIO.GetUniqueFileNameInFolder(L_FIO.effp_FileName(srcFullFileName), ArchiveFolder);
  EXCEPT
  ON Exc: Exc_Root DO
   RETURN srcFullFileName;
  END;
 END {GetArchiveFullFileName};

 PRIVATE PROCEDURE RemoveFileToArchive(srcFullFileName, archFullFileName: STRING[]);
 BEGIN
  IF srcFullFileName # archFullFileName THEN
   TRY [MSGSUPPRESSIONMODE(MSGSUPPRESS_ALL), EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
    FIO.RenMov(srcFullFileName, , archFullFileName);
   EXCEPT
   ON Exc: Exc_Root DO
   END;
  END;
 END {RemoveFileToArchive};

 PRIVATE PROCEDURE BuildMDoc(_MDocKind       : LIKE(MDocKind.MDocKind);
                             _Storage        : LIKE(Storage.Storage);
                             srcFullFileName,
                             archFullFileName: STRING[];
                             ManualImport    : SCAL[2]): SCAL[2];
  VAR
   D        : DATE;
   Cir0, VAT: NUMERIC[2];
 BEGIN
  D:=GetMDocDate(_MDocKind);
  IF ~MDocAlreadyBuilt(_MDocKind, D) THEN
   Memo.gl_SetCurDate(D);
   SE_INTEGRITY(1);
 
   DEFAULT(MDoc);
   MDoc.MDocKind:=_MDocKind;
   L_MDoc.Insert_MDoc();
   SETZERO(Cir0, VAT);

   MDoc.MyFirm  :=P_Firm.mf_Fict;
   MDoc.Date    :=Memo.gl_cd();
   MDoc.SrcDate :=Memo.gl_cd();
   MDoc.SrcNbr  :=_ImpD.TrnNbr;
   MDoc.PayDate :=Memo.gl_cd();
   MDoc.Storage :=_Storage;
   IF    _MDocKind = L_MDoc.md_NOV THEN
    SEARCH(RWayS, RWayS, , _ImpD.RWayS);
    CONFORM(RWayS, Car);
    CONFORM(RWayS, Staff);
    MDoc.TSN     :=RWayS.TSN;
    MDoc.BoxNbr  :=RWayS.BoxNbr;
   ELSE
    MDoc.TSN     :=L_MDoc.curUSER2MDocTSN(0);
    IF ~!_ImpD.Contract THEN
     SEARCH(Contract, Contract, , _ImpD.Contract);
     MDoc.Contract:=Contract.Contract;
     MDoc.Firm    :=Contract.Firm;
    END;
    IF _MDocKind = L_MDoc.md_TCh THEN
     Cir0         :=GetInclNetto(_ImpD.Math, D, _ImpD.Sum);
     VAT          :=GetExclVAT(_ImpD.Math,   D, Cir0);
    END;
   END;
   IF !_ImpD.Dest THEN
    MDoc.Dest    :=L_MDoc.E_DefMDocDest(MDoc.Date);
   ELSE
    MDoc.Dest    :=_ImpD.Dest;
   END;
   MDoc.Alower:=L_MDoc.NoAlower;
   IF !MDoc.Dest | ((_MDocKind = L_MDoc.md_NOV) & (D # RWayS.Date)) THEN
    MDoc.Status  :=L_MDoc.st_Prepared;
   ELSE
    MDoc.Status  :=E_GetMDocStatus();
   END;

   REPLACE(MDoc);
 
   IF _MDocKind = L_MDoc.md_NOV THEN
    L_XDoc.rf_Insert(L_XDoc.xdt_MDoc,
                     L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS),
                     L_XDoc.rft_RefTo);
   END;
   L_MDoc.InsMDocList(_ImpD.Math, L_MathR.mm_New, "", _ImpD.Amount, Cir0, VAT);
   L_MDoc.MDoc_OnAnyModification(+1, L_MDoc.np_Try, 0);
(*
   P_MDoc.SetMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Note, FLDTOSTR(_ImpD.BegDTS, "D.N.y H:M:S") + ";" +
                                                              L_FIO.effp_FileName_woExt(archFullFileName));
*)
   P_MDoc.SetMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Note, FLDTOSTR(_ImpD.BegDTS, "D.N.y H:M:S") + ";" +
                                                              L_FIO.effp_FileName(archFullFileName) + ";" +
                                                              FLDTOSTR(L_FIO.GetFileLastModifiedDTS(srcFullFileName), "D.N.y H:M:S"));

   IF ~ManualImport THEN
    SAVE(MDoc);
    IF L_MDoc.PrintMDocImmediately() THEN
     TRY
      CALL(MDoc.StreamRePrint());
      CALL(MDoc.SinglePrint());
     EXCEPT
     ON Exc:Exc_Root DO
      L_StdFrm.ShowINFORM_AsSTOP(Exc.MsgOriginalText);
     END;
    END;
    RESTORE(MDoc);
   END;
   SE_INTEGRITY(0);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {BuildMDoc};

 PRIVATE PROCEDURE GetRepFolder(): STRING[];
 BEGIN
  RETURN FIO.FullPath("REP\NEFTO");
 END {GetRepFolder};

 PRIVATE PROCEDURE PrintRep(srcFullFileName, archFullFileName: STRING[]; HasError: SCAL[2]);
  VAR
   _Status    : NUMERIC[0];
   RepName,
   MathName,
   RepFolder,
   FullRepName: STRING[];
   Total      : NUMERIC[2];
   Totals     : NUMERIC[2][st_Amount];
 BEGIN
  RepName    :="Nfts3_" + L_FIO.effp_FileName_woExt(archFullFileName) + "_" + L_Str.PoolItem("g|b", HasError) + "_" + L_DatTim.SysDateTimeStamp() + "_" + L_Str.FixedIntStr(APP.Get().MyConnection.ConnectionNo, 4);
  RepFolder  :=GetRepFolder();
  L_FIO.MakeSubDirs(RepFolder);
  FullRepName:=FIO.BuildPath(RepName, "REP", RepFolder);

  LIKEMENUCommand:=L_Str.AddStrDlm(LIKEMENUCommand, ",") + 'Survey, "' + FullRepName + '"';

  IF Str.Length(RepName) < RepNameLength THEN
   RepName:=RepName + L_Str.Repeat("=", RepNameLength - Str.Length(RepName));
  END;
  OPENREP(R, FullRepName, Create);
  MAKEPART(R, Top, RepName, "⮪    ࠢ, 䠩 " + L_FIO.effp_FileName(archFullFileName) + " (" + L_DatTim.TimestampStr(L_FIO.GetFileLastModifiedDTS(srcFullFileName)) + ")");

  SELECT(_ImpD, _ImpD);
  WHILE OCCURE(_ImpD) DO
   MakePart();
   NEXT(_ImpD);
  END; (* WHILE OCCURE(_ImpD) ... *)

  MAKEPART(R, SubBot);
  SELECT(_ImpD, Math);
  WHILE OCCURE(_ImpD) DO
   SETZERO(Totals, Total);
   NARROWSEL(_ImpD, Math);
   IF ~!_ImpD.Math THEN
    SEARCH(Math, Math, , _ImpD.Math);
    MathName:=Math.Math + " " + Math.Name;
   ELSE
    MathName:="  ";
   END;
   WHILE OCCURE(_ImpD) DO
    IF ~!_ImpD.Amount THEN
     IF (_ImpD.Status = st_Normal) & !_ImpD.XDocId THEN
      _Status:=st_InsMDocFailed;
     ELSE
      _Status:=_ImpD.Status;
     END;
     INC(Totals[_Status], _ImpD.Amount);
     INC(Total, _ImpD.Amount);
    END;
    NEXT(_ImpD);
   END; (* WHILE OCCURE(_ImpD) ... *)
   MAKEPART(R, BotLine, MathName, Totals[st_Normal],
                                  Totals[st_TechOperation],
                                  Totals[st_BadData] + Totals[st_InsMDocFailed],
                                  Total);
   NEXTINEXTENDEDSEL(_ImpD, Math);
  END; (* WHILE OCCURE(_ImpD) ... *)

  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {PrintRep};

 PRIVATE PROCEDURE Proceed(_Storage: LIKE(Storage.Storage); srcFullFileName: STRING[]; ManualImport: SCAL[2]);
  VAR
   _XDocId                   : L_XDoc.tXDocId;
   LastTrnNbr                : SCAL[1E7];
   ErrorAmount               : NUMERIC[0];
   _Result,
   archFullFileName          : STRING[];
   AllowedRemoveFileToArchive: SCAL[2];
 BEGIN
  archFullFileName:=GetArchiveFullFileName(srcFullFileName);
  SETEMPTY(LastTrnNbr);
  IF SELECT(_ImpD, _ImpD) THEN
   IF ~ManualImport THEN
    SetCurrentOperation("ࠡ⪠ 㦥 ࠭権...");
   END;
   TRY [TRANSACTION(TRANSACTION_SLAVE), EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
    SETZERO(ErrorAmount);
    WHILE OCCURE(_ImpD) DO
     PROMPT("ନ஢ : ࠭ " + _ImpD.TrnNbr);
     IF    _ImpD.Status = st_Normal THEN
      IF BuildMDoc(_ImpD.MDocKind, _Storage, srcFullFileName, archFullFileName, ManualImport) THEN
       _Result:="ଫ " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc);
       IF MDoc.Status = L_MDoc.st_Prepared THEN
        _Result:=_Result + " ('⮢'!!!)";
       END;
      ELSE
       _Result:=" ନ஢ " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc);
      END;
      SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
      L_General.CallUs(XDocJrn.Action = L_XDoc.action_AutoBuild);
      _Result:=_Result + " [" + L_DatTim.DateTimeStr(XDocJrn.Date, XDocJrn.BegTime) + "]";
      _XDocId:=MDoc.XDocId;
      TRY [TRANSACTION(TRANSACTION_SLAVE)]
       _ImpD.Result[0]:=_Result;
       _ImpD.XDocId   :=_XDocId;
       REPLACE(_ImpD);
      EXCEPT
      ON Exc: Exc_Root DO
       RAISE();
      END; (* TRY *)
     ELSIF _ImpD.Status = st_BadData THEN
      INC(ErrorAmount)
     END;
 
     IF ~ManualImport THEN
      InfoDoneSingleTransaction();
     END;
 
     NEXT(_ImpD);
    END; (* WHILE OCCURE(_ImpD) ... *)
 
    AllowedRemoveFileToArchive:=1;
   EXCEPT
   ON Exc:Exc_Root DO
    _ImpD.Result[0]:="訡  ଫ : " + Exc.MsgOriginalText;
    _ImpD.Status   :=st_InsMDocFailed;
    REPLACE(_ImpD);
    INC(ErrorAmount);
    AllowedRemoveFileToArchive:=0;
    IF ~ManualImport THEN
     InfoDoneSingleTransaction();
    END;
   END; (* TRY *)

   PrintRep(srcFullFileName, archFullFileName, ErrorAmount # 0);

   IF AllowedRemoveFileToArchive THEN
    RemoveFileToArchive(srcFullFileName, archFullFileName);
    L_DFS.Do(archFullFileName, L_PCS.deft_AZS);
   END;

   IF ManualImport THEN
    InfoDoneAllTransaction();
    LIKEMENU(^LIKEMENUCommand);
   ELSE
    SetCurrentOperation("...");
    IF ~!LastTrnNbr THEN
     SELECT(_ImpD, TrnNbr, , LastTrnNbr);
     SEARCH(Math, Math, , _ImpD.Math);
  
     L_WDO.setFieldValue("v_Nozzle",       _ImpD.Nozzle);
     L_WDO.setFieldValue("v_TrnNbr",       _ImpD.TrnNbr);
     L_WDO.setFieldValue("v_Prompt",       L_DatTim.CompleteSystimeStr());
     L_WDO.setFieldValue("v_Math",         _ImpD.Math);
     L_WDO.setFieldValue("v_MathName",     Math.Name);
     L_WDO.setFieldValue("v_Amount",       _ImpD.Amount);
     L_WDO.setFieldValue("v_Sum",          _ImpD.Sum);
     L_WDO.setFieldValue("v_RWayS",        _ImpD.RWayS);
     L_General.ConsultToUs(MDocAlreadyBuilt(_ImpD.MDocKind, GetMDocDate(_ImpD.MDocKind)), "Error 1");
     L_XDoc.pvs_XDocId:=MDoc.XDocId;
     L_WDO.setFieldValue("v_MDoc",         L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
     L_WDO.setFieldValue("v_Contract",     _ImpD.Contract);
  
     IF ~!_ImpD.Contract THEN
      SEARCH(Contract, Contract, , _ImpD.Contract);
      L_WDO.setFieldValue("v_ContractName", Contract.Name);
     ELSE
      L_WDO.setFieldValue("v_ContractName", "");
     END;
    END;
   END; (* IF ManualImport...*)
  END; (* IF SELECT(_ImpD...*)
 END {Proceed};

 PRIVATE PROCEDURE CreateTmpFile();
 BEGIN
  L_AFM.MakeMultipleIndex("_ImpD", "Status  : SCAL[4];" +
                                   "MDocKind: LIKE(MDocKind.MDocKind);" +
                                   "TrnNbr  : SCAL[1E7];" +
                                   "BegDTS  : TIMESTAMP;" +
                                   "EndDTS  : TIMESTAMP;" +
                                   "Nozzle  : SCAL[1E2];"+
                                   "Tank    : SCAL[1E2];"+
                                   "nft_Math: SCAL[1E5];"+
                                   "Math    : LIKE(Math.Math);"+
                                   "Amount  : NUMERIC[6,2];"+
                                   "Price   : NUMERIC[8,2];"+
                                   "Sum     : NUMERIC[10,2];"+
                                   "RWayS   : LIKE(RWayS.RWayS);"+
                                   "nft_Dest: SCAL[1E3];" +
                                   "Dest    : LIKE(Dest.Dest);" +
                                   "Contract: LIKE(Contract.Contract);" +
                                   "Result  : STRING[512][" + L_Str.IntStr(MaxErrorAmount) + "];" +
                                   "XDocId  : LIKE(MDoc.XDocId)",
                          "_ImpD:TrnNbr;MDocKind:MDocKind;TrnNbr:TrnNbr;Math:Math");
 END {CreateTmpFile};

 PUBLIC PROCEDURE Close();
 BEGIN
  L_Timer.ResetTimer("NeftoStan_Stat");
 END {Close};

 PRIVATE PROCEDURE CheckDefaultSettings();
  VAR
   _Storage: LIKE(Storage.Storage);
 BEGIN
  _Storage:=E_GetStorage();
  L_General.Assert(~!_Storage, " ।    ");
  L_General.Assert(P_Storage.IsFuelStation(_Storage), " " + _Storage + "   ");
  L_General.Assert(SEARCH(Alower, Alower, L_MDoc.NoAlower),
                   " ࠢ筨 '⥫'   |" +
                   L_Str.IntStr(L_MDoc.NoAlower) + " ' ॡ ࠧ襭'" );
 END {CheckDefaultSettings};

 PRIVATE PROCEDURE NeftoStan_0_OnZoneOpen();
 BEGIN
  L_General.Assert(~!E_Nefto_Path(), "㭪樮쭮  ⠭");
  CheckDefaultSettings();
  SETEMPTY(L_XDoc.pvs_XDocId);
  L_Timer.SetTimer("NeftoStan_Stat", 1, 3, "NeftoStan, 105");
  SetCurrentOperation("...");
  L_WDO.setFieldValue("v_Nozzle",       "");
  L_WDO.setFieldValue("v_TrnNbr",       "");
  L_WDO.setFieldValue("v_Prompt",       L_DatTim.CompleteSystimeStr());
  L_WDO.setFieldValue("v_Math",         "");
  L_WDO.setFieldValue("v_MathName",     "");
  L_WDO.setFieldValue("v_Amount",       L_General.EMPTY_NUMBER());
  L_WDO.setFieldValue("v_Sum",          L_General.EMPTY_NUMBER());
  L_WDO.setFieldValue("v_RWayS",        "");
  L_WDO.setFieldValue("v_MDoc",         "");
  L_WDO.setFieldValue("v_Contract",     "");
  L_WDO.setFieldValue("v_ContractName", "");
 END {NeftoStan_0_OnZoneOpen};

 PRIVATE PROCEDURE GetItemFromString(S: STRING[]; Item: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Str.Condense(Str.Item(S, ";", Item));
 END {GetItemFromString};

 PRIVATE PROCEDURE gifs_SCAL(S: STRING[]; Item: NUMERIC[0]): SCAL[1E9];
 BEGIN
  RETURN STRTOFLD(GetItemFromString(S, Item), SCAL);
 END {gifs_SCAL};

 PRIVATE PROCEDURE gifs_TIMESTAMP(S: STRING[]; Item: NUMERIC[0]): TIMESTAMP;
 BEGIN
  RETURN STRTOFLD(Str.Replace(GetItemFromString(S, Item), "-", "."), TIMESTAMP, "D.N.y H:M:S");
 END {gifs_TIMESTAMPL};

 PRIVATE PROCEDURE gifs_NUMERIC(S: STRING[]; Item: NUMERIC[0]): FLOAT;
 BEGIN
  RETURN STRTOFLD(GetItemFromString(S, Item), NUMERIC);
 END {gifs_NUMERIC};

 PRIVATE PROCEDURE SetResult(VAR Result: STRING[][]; Text: STRING[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  LOOP
   IF (i > HIGH(Result)) | !Result[i] THEN
    EXIT
   END;
   INC(i);
  END;
  Result[i]:=Result[i] + Text;
 END {SetResult};

 PRIVATE PROCEDURE BarCodeNotAllowed(VAR Result: STRING[][]; nefto_BarCode: STRING[]; nefto_Dest: SCAL[1E3]);
 BEGIN
  SetResult(Result, " " + nefto_BarCode + "  ᮮ⢥  樨 " + nefto_Dest);
 END {BarCodeNotAllowed};

 PRIVATE PROCEDURE DownloadSingleFile(srcFullFileName: STRING[]);
  VAR
   S            : STRING[];
   Row          : NUMERIC[0];
   Result       : STRING[][MaxErrorAmount];
   nefto_TrnNbr : SCAL[1E7];
   nefto_Math   : SCAL[1E5];
   nefto_Amount : NUMERIC[2];
   nefto_Sum    : NUMERIC[2];
   nefto_RWayS  : SCAL[1E7];
   nefto_Dest   : SCAL[1E3];
   nefto_BarCode: STRING[];
   _XDocType    : L_XDoc.tXDocType;
   _XDocKind    : L_XDoc.tXDocKind;
   _XDoc        : L_XDoc.tXDoc;
   _CopyCnt     : L_XDoc.tCopyCnt;
 BEGIN
  SELECT(_ImpD, _ImpD);
  REMSEL(_ImpD);

  FIO.Open(F, srcFullFileName, , Input);
  Row:=1;
  WHILE FIO.RdStr(F, S) DO
   PROMPT("㧪 " + srcFullFileName + ": ப " + L_Str.IntStr(Row));
   IF ~!S THEN
    TRY [TRANSACTION(TRANSACTION_SLAVE)]
     SETEMPTY(Result);
     nefto_TrnNbr  :=gifs_SCAL(S, 1);
     nefto_Dest    :=gifs_SCAL(S, 12);
     nefto_Amount  :=gifs_NUMERIC(S, 7);
     nefto_Sum     :=gifs_NUMERIC(S, 9);
 
     DEFAULT(_ImpD);
     _ImpD.TrnNbr  :=nefto_TrnNbr;
     _ImpD.BegDTS  :=gifs_TIMESTAMP(S, 2);
     _ImpD.EndDTS  :=gifs_TIMESTAMP(S, 3);
     _ImpD.Nozzle  :=gifs_SCAL(S, 4);
     _ImpD.Tank    :=gifs_SCAL(S, 5);
 
     IF !nefto_Amount THEN
      SetResult(Result, " 㪠 饭 ꥬ ⥯த");
     END;
     _ImpD.Amount  :=nefto_Amount;
     _ImpD.Price   :=gifs_NUMERIC(S, 8);
     _ImpD.Sum     :=nefto_Sum;
     _ImpD.nft_Dest:=nefto_Dest;
 
     IF (nefto_Dest = 002) | (nefto_Dest = 004) | (nefto_Dest = 008) | (nefto_Dest = 009) THEN
      nefto_BarCode :=GetItemFromString(S, 13);
      IF ~!nefto_BarCode THEN
       TRY
        L_XDoc.DecodeBarCode(L_BarCode.SCAN_SDT_ITF, nefto_BarCode, 0, _XDocType, _XDocKind, _XDoc, _CopyCnt);
       EXCEPT
       ON Exc: Exc_Root DO
        SetResult(Result, nefto_BarCode + ": " + L_Str.Replace(Exc.MsgOriginalText, "|", " "));
       END;
       IF ~!_XDocType THEN
        IF    (nefto_Dest = 002) | (nefto_Dest = 009) THEN
         IF    _XDocType = L_XDoc.xdt_Contract THEN
          IF !nefto_Sum THEN
           SetResult(Result, " 㪠 㬬  饭 ꥬ ⥯த⮢");
          END;
          IF SEARCH(Contract, Contract, _XDoc) THEN
           _ImpD.Contract:=_XDoc;
          ELSE
           SetResult(Result, "   " + _XDoc);
          END;
          _ImpD.MDocKind:=E_GetMDocKind(nefto_Dest);
         ELSE
          BarCodeNotAllowed(Result, nefto_BarCode, nefto_Dest);
         END;
        ELSIF nefto_Dest = 004 THEN
         IF    _XDocType = L_XDoc.xdt_RWayS THEN
          _ImpD.MDocKind:=L_MDoc.md_NOV;
          nefto_RWayS   :=_XDoc;
          IF ~!nefto_RWayS THEN
           IF SEARCH(RWayS, RWayS, nefto_RWayS) THEN
            _ImpD.RWayS   :=RWayS.RWayS;
           ELSE
            SetResult(Result, "   " + nefto_RWayS);
           END;
          ELSE
           SetResult(Result, " 㪠  ");
          END;
         ELSE
          BarCodeNotAllowed(Result, nefto_BarCode, nefto_Dest);
         END;
        ELSIF nefto_Dest = 008 THEN
         IF _XDocType = L_XDoc.xdt_Command THEN
          IF    _XDoc = L_XDoc.cmd_BuildGasStanTOV THEN
           _ImpD.MDocKind:=L_MDoc.md_TOV;
          ELSIF _XDoc = L_XDoc.cmd_BuildGasStanMSP THEN
           _ImpD.MDocKind:=L_MDoc.md_MSP;
          ELSE
           SetResult(Result, "⭠ ࠢ  " + _XDoc);
          END;
         ELSE
          BarCodeNotAllowed(Result, nefto_BarCode, nefto_Dest);
         END;
        ELSE
         SetResult(Result, "  樨 " + nefto_Dest);
        END;
       END;
      ELSE
       SetResult(Result, "⮩    樨 " + nefto_Dest);
      END;
     ELSIF nefto_Dest = 007 THEN
      SetResult(Result, "孮᪠ ");
      _ImpD.Status:=st_TechOperation;
     ELSIF nefto_Dest = 110 THEN
      IF _ImpD.Amount = 0 THEN
       SetResult(Result, "㫥 ࠭");
       _ImpD.Status:=st_TechOperation;
      ELSE
       SetResult(Result, " ⮯  㫥 ࠭樨");
      END;
     ELSE
      SetResult(Result, " 樨 " + nefto_Dest + "  ঠ.");
     END;
 
     nefto_Math    :=gifs_SCAL(S, 6);
     IF ~!nefto_Math THEN
      _ImpD.nft_Math:=nefto_Math;
     ELSE
      SetResult(Result, " 㪠  ⥯த");
     END;
     INSERT(_ImpD);
 
     IF ~!_ImpD.MDocKind & ~SEARCH(MDocKind, MDocKind, _ImpD.MDocKind) THEN
      SetResult(Result, " ࠢ筨    㬥 " + _ImpD.MDocKind);
     END;
 
     _ImpD.Dest    :=E_GetDest();
     IF ~!_ImpD.Dest & ~SEARCH(Dest, Dest, _ImpD.Dest) THEN
      SetResult(Result, " ࠢ筨    " + _ImpD.Dest);
     END;
 
     _ImpD.Math    :=E_ConvNEFTOMathToMath();
     IF    !_ImpD.Math THEN
      SetResult(Result, "  ⮯  NEFTO " + _ImpD.nft_Math);
     ELSIF ~SEARCH(Math, Math, _ImpD.Math) THEN
      SetResult(Result, " ࠢ筨    ( ⥯த " + _Math + ")");
     END;
 
     _ImpD.Result :=Result;
     IF !_ImpD.Status THEN
      IF !Result[0] THEN
       _ImpD.Status:=st_Normal;
      ELSE
       _ImpD.Status:=st_BadData;
      END;
     END;
     REPLACE(_ImpD);
 
    EXCEPT
    ON Exc: Exc_Root DO
     FIO.Close(F);
     RAISE();
    END; (* TRY *)
   END;
   INC(Row);
  END;
  FIO.Close(F);
 END {DownloadSingleFile};

 PRIVATE PROCEDURE SetCurrentOperation(Text: STRING[]);
 BEGIN
  L_WDO.setFieldValue("v_Operation", Text);
 END {SetCurrentOperation};

 PRIVATE PROCEDURE DownloadTransportFile(ManualImport: SCAL[2]; _Storage: LIKE(Storage.Storage));
  VAR
   File         : OBJECT;
   Folder       : FOLDERENTRY;
   FolderContent: ENUMERATOR;
   SrcFolder    : STRING[];
   FileAmount   : NUMERIC[0];
 BEGIN
  SETEMPTY(LIKEMENUCommand);
  SrcFolder:=E_Nefto_Path();
  L_General.Assert(~!SrcFolder, "㭪樮쭮  ⠭");
  IF FIO.DirExists(SrcFolder) THEN
   IF ~ManualImport THEN
    SetCurrentOperation("  㧪  ࠭権...");
   END;
   Folder   :=FOLDERENTRY.Create(SrcFolder);
 
   SETZERO(FileAmount);
   FolderContent:=CreateENUMERATOR(Folder.FolderContent);
   WHILE ~FolderContent.AtEnd() DO
    File:=FolderContent.Item();
    IF ~File.Attributes.Directory THEN
     PROMPT("ࠡ⪠ " + File.Path);
     TRY
      SE_ACCESSDATAMODE(AccessDataMode_SOFT);
      IF ~L_DFS.IsDone(File.Path, L_PCS.deft_AZS) THEN
       CreateTmpFile();
       DownloadSingleFile(File.Path);
       Proceed(_Storage, File.Path, ManualImport);
       INC(FileAmount);
      ELSE
       RemoveFileToArchive(File.Path, GetArchiveFullFileName(File.Path));
      END;
     EXCEPT
     ON Exc: Exc_RunTime DO
      IF Exc.ErrorCode # 601 THEN
       L_StdFrm.ShowINFORM_AsSTOP(Exc.MsgOriginalText);
      END;
     ON Exc: Exc_Raise DO
      L_StdFrm.ShowINFORM_AsSTOP(Exc.MsgOriginalText);
     FINALLY
      TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
       L_AFM.AF_PurgeTemp("_ImpD");
      EXCEPT
      END;
     END;
    END;
    FolderContent.MoveNext();
   END; (* WHILE ~AttachmentFolderContent.AtEnd...*)
   IF ManualImport THEN
    L_General.Assert(FileAmount # 0, "  䠩  ");
   ELSE
    SetCurrentOperation("...");
   END;
  ELSE
   IF ~ManualImport THEN
    SetCurrentOperation("㯥 ⠫ " + SrcFolder);
   END;
  END;
 END {DownloadTransportFile};

 PRIVATE PROCEDURE ScanNewFiles(ManualImport: SCAL[2]);
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  IF ~ManualImport THEN
   L_WDO.setFieldValue("v_Prompt",       L_DatTim.CompleteSystimeStr());
  END;
  DownloadTransportFile(ManualImport, E_GetStorage());
 END {ScanNewFiles};

 PUBLIC PROCEDURE PosToMDoc();
 BEGIN
  IF ~!L_XDoc.pvs_XDocId THEN
   L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.pvs_XDocId, "");
  END;
 END {PosToMDoc};

 PRIVATE PROCEDURE ViewProtocols();
  VAR
   ChooseFile    : CHOOSEFILEDIALOG;
   ReportFullName: STRING[];
 BEGIN
  ChooseFile:=CHOOSEFILEDIALOG.Create(FIO.BuildPath("*.rep", , GetRepFolder()));
  ChooseFile.FilesAreAcceptable:=1;
  ReportFullName:=ChooseFile.Deal();
  IF ~!ReportFullName THEN
   LIKEMENU(Survey, ReportFullName);
  END;
 END {ViewProtocols};

 PRIVATE PROCEDURE ManualImport();
 BEGIN
  CheckDefaultSettings();
  ScanNewFiles(1);
 END {ManualImport};

 PRIVATE PROCEDURE ViewTransportFileByCurMDoc();
  VAR
   Date        : DATE;
   FileName,
   FullFileName: STRING[];
 BEGIN
  L_MDoc.AccessMDoc();
  L_General.Assert(P_MDoc.HasActualMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Note), "    㧪 ");
  FileName:=Str.Item(MDocPro.Value, ";", 1);
  Date    :=STRTOFLD(Str.Item(Str.Item(MDocPro.Value, ";", 2), " ", 0), DATE, "D.N.y");
  L_General.Assert(~!FileName, "    ࠭ᯮ⭮ 䠩");
  FullFileName:=FIO.BuildPath(FileName, , GetArchiveFolder(Date));
  IF ~FIO.Exists(FullFileName) THEN
   FullFileName:=FIO.BuildPath(FileName, , E_Nefto_Path());
   L_General.Assert(FIO.Exists(FullFileName), "  ࠭ᯮ 䠩 " + FileName);
  END;
  LIKEMENU(EditText, FullFileName + " -v /S:" + MDoc.SrcNbr);
 END {ViewTransportFileByCurMDoc};

 PRIVATE PROCEDURE ViewAllTransportFiles();
  VAR
   ChooseFile  : CHOOSEFILEDIALOG;
   FullFileName: STRING[];
 BEGIN
  ChooseFile:=CHOOSEFILEDIALOG.Create(FIO.BuildPath("*.*", , E_Nefto_Path()));
  ChooseFile.FilesAreAcceptable  :=1;
  ChooseFile.FoldersAreAcceptable:=1;
  FullFileName:=ChooseFile.Deal();
  IF ~!FullFileName THEN
   LIKEMENU(EditText, FullFileName + " -v");
  END;
 END {ViewAllTransportFiles};

BEGIN
 IF    L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSIF MODE = 105 THEN
  ScanNewFiles(0);
 ELSE
  L_General.BadMode(MODE);
 END;
END.
