(*
%Copyright   (c) Polak IT
%Author      17.08.2011 13:39:27 POLAK\LDA
%Purpose      ⮢  襭
%Type        report
%Specific    AP
%Modified    08.11.2013 13:15:22 POLAK\GAV
%Environment
*)

 MODULE OD003 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_bp, FIO, L_General, L_ODoc, L_APtm, Memo, L_Staff, P_ODoc, L_r2r, L_Basis, L_Str, P_EDOKnd,
        Str, L_XDoc;

 PRIVATE PROCEDURE OD003_MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ⠢");
  L_Basis.wb_WrInQM(F, "卮");
  L_Basis.wb_WrInQM(F, " 襭");
  L_Basis.wb_WrInQM(F, "ਬ砭");
  L_Basis.wb_WrInQM(F, "⠢⥫쒠");
  L_Basis.wb_WrInQM(F, "⠢⥫씈");
  L_Basis.wb_WrInQM(F, "⠢⥫쑥");
  L_Basis.wb_WrInQM(F, "⠢⥫쑥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "襭");
  L_Basis.wb_WrInQM(F, "襭");
  L_Basis.wb_WrInQM(F, "業⌨");
  L_Basis.wb_WrInQM(F, "業⌠");
  L_Basis.wb_WrInQM(F, "㬬");
  L_Basis.wb_WrInQM(F, "㬬");
  L_Basis.wb_TermLine(F);
 END {OD003_MakeTop};

 PRIVATE PROCEDURE PrintStaff(F: STRING[]; trgTSN: LIKE(Staff.TSN); Short: SCAL[2]);
 BEGIN
  IF ~!trgTSN THEN
   SEARCH(Staff, TSN, , trgTSN);
   CONFORM(Staff, Man);
   L_Staff.PosToStaffLog(Staff.TSN, ODoc.Date, 1);
   CONFORM(StaffLog, Officer);
   CONFORM(Officer, Sort);
   CONFORM(Officer, Union);
   L_Basis.wb_WrScl(F, Staff.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
   IF ~Short THEN
    L_Basis.wb_WrScl(F, Union.Union);
    L_Basis.wb_WrStr(F, Union.Name);
   END;
  ELSE
   L_Basis.wb_WrStr(F, "-----");
   L_Basis.wb_WrStr(F, "--------");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "--------");
   IF ~Short THEN
    L_Basis.wb_WrStr(F, "--");
    L_Basis.wb_WrStr(F, "--------");
   END;
  END;
 END {PrintStaff};

 PRIVATE PROCEDURE OD003_MakeLine(F: STRING[]);
  VAR
   trgEDOKind    : LIKE(EDOKind.EDOKind);
   SumMin, SumMax,
   PrcMin, PrcMax: NUMERIC[2];
 BEGIN
  L_Basis.wb_WrScl(F, ODocKind.ODocKind);
  L_Basis.wb_WrStr(F, ODocKind.SName);
  L_Basis.wb_WrStr(F, ODocKind.Sign);
  L_Basis.wb_WrScl(F, ODoc.ODoc);
  L_Basis.wb_WrDat(F, ODoc.SrcDate);
  L_Basis.wb_WrStr(F, ODoc.SrcNbr);
  L_Basis.wb_WrDat(F, ODoc.Date);
  L_Basis.wb_WrStr(F, L_Str.Left(Str.Replace(ODoc.Descript, L_Str.CRLF, " "), 128));
  PrintStaff(F, L_XDoc.GetXDocAuthorTSN(L_XDoc.xdt_ODoc), 1);
  PrintStaff(F, ODoc.TSN, 0);
  SETEMPTY(SumMin, SumMax, PrcMin, PrcMax);
  P_ODoc.Get_ViolationActContent(ODoc.ODocKind, ODoc.ODoc, trgEDOKind);
  IF ~!trgEDOKind THEN
   SEARCH(EDOKind, EDOKind, , trgEDOKind);
   P_EDOKnd.Get_AnyInterval(trgEDOKind, ODoc.Date, P_EDOKnd.P_ProcInterval, PrcMin, PrcMax);
   P_EDOKnd.Get_AnyInterval(trgEDOKind, ODoc.Date, P_EDOKnd.P_SumInterval,  SumMin, SumMax);

   L_Basis.wb_WrScl(F, EDOKind.EDOKind);
   L_Basis.wb_WrStr(F, EDOKind.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "--------");
  END;

  L_Basis.wb_WrNum(F, SumMin, 2);
  L_Basis.wb_WrNum(F, SumMax, 2);
  L_Basis.wb_WrNum(F, PrcMin, 2);
  L_Basis.wb_WrNum(F, PrcMax, 2);

  L_Basis.wb_TermLine(F);
 END {OD003_MakeLine};

 PUBLIC PROCEDURE OD003();
  CONST
   bpId = "OD003";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " ⮢  襭", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  OD003_MakeTop("F");
  L_APtm.AccessERKN("ODocKind", L_ODoc.erkn_ViolationAct);
  TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_THROW)]
   SELECT(ODocKind, ERKN, , ERKN.ERKN);
   WHILE OCCURE(ODocKind) DO
    SELECT(ODoc, ODKDate, , ODocKind.ODocKind);
    SRCINSEL(ODoc, GE, , Memo.ud_fr());
    WHILE OCCURE(ODoc) & (ODoc.Date <= Memo.ud_ut()) DO
     PROMPT(ODoc.ODocKind + " " + ODoc.ODoc);
     IF ODoc.Status # L_ODoc.ods_Canceled THEN
      OD003_MakeLine("F");
     END;
     NEXT(ODoc);
    END; (* WHILE OCCURE(ODoc) ... *)
    NEXT(ODocKind);
   END; (* WHILE OCCURE(ODocKind) ... *)
  EXCEPT
  END;
  FIO.Close(F);
  L_bp.End();
 END {OD003};

END.
