(*
%Copyright   (c) Polak Computer System
%Author      28.09.2001 19:50:10 BOR
%Specific    AP
%Modified    13.03.2014 15:17:58 POLAK\GAV
%Environment
*)

 IMPORT L_General, L_OwnData, L_Fuel, L_DatTim, L_AFM, L_Str, Memo, L_Way, L_Env;

 TYPE
  tReportMode = SCAL[2];
  tOilArr     = NUMERIC[4][MAXOF(MarkFuel.InMix)+1];

 CONST
  CurStaffMode = 0;
  CurCarMode   = 1;

 VAR
  TotF, TotN: tOilArr;

(*
$P{ TopCurStaff:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
Staff.TSN+" "+Man.Name, C, ""
@
##########################################################################################    ########## #####
=#####========================================================================================================
|                ⥫  室 ⥯த⮢  ਮ  ##########  ##########                |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|        |    |                |       ||    ୮|࠭ᬨ-|  ஬᫮|      |     '᮫'|
|    | |ઠ           | ஡|    |------------|------------|------------|------------|------------|
|        |    |                |       |⮯|   ଠ |   ଠ |   ଠ |   ଠ |   ଠ |
|--------|----|----------------|-------|----|------------|------------|------------|------------|------------|}
*)

(*
$P{ LineCurStaff:
TempF.Date, L, "D.N.Y"
TempF.BoxNbr, L, ""
Car.Mark, L, ""
Mark.Name, L, ""
TempF.Run, R, "1."
TempF.FuelFact, R, "0"
@

|########|####|#### ###########|#######|####|}
*)

(*
$P{ TopCurCar:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
Car.BoxNbr+" "+Mark.Name, C, ""
@
####################################################################################          ########## #####
=#####========================================================================================================
|                     室 ⥯த⮢  ਮ  ##########  ##########                   |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|        |                     |       ||    ୮|࠭ᬨ-|  ஬᫮|      |     '᮫'|
|    |⥫             | ஡|    |------------|------------|------------|------------|------------|
|        |                     |       |⮯|   ଠ |   ଠ |   ଠ |   ଠ |   ଠ |
|--------|---------------------|-------|----|------------|------------|------------|------------|------------|}
*)

(*
$P{ LineCurCar:
TempF.Date, L, "D.N.Y"
TempF.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
TempF.Run, R, "1."
TempF.FuelFact, R, "0"
@

|########|##### ###############|#######|####|}
*)

(*
$P{ Line:
?, R, "3."
?, R, ""
@
######## ###|}
*)

(*
$P{ PreBot:
@

|-------------------------------------------|------------|------------|------------|------------|------------|
|⮣                                      |}
*)

(*
$P{ PrePreBot:
@

|-------------------------------------------|------------|------------|------------|------------|------------|
|⮣   ०                 |}
*)

(*
$P{ Bot:
@

=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE GetNorm(trgInMix: LIKE(MarkFuel.InMix); trgCoef: NUMERIC[3]): LIKE(Mark.OilNorm[0]);
 BEGIN
   RETURN Mark.OilNorm[trgInMix] * trgCoef;
 END {GetNorm};

 PRIVATE PROCEDURE GetFact(ReportMode: tReportMode;
                   trgInMix  : LIKE(MarkFuel.InMix);
                   trgDateB,
                   trgDateE  : DATE);
  VAR
   i        : NUMERIC[0];
   _OilFact : NUMERIC[4][20];
   _TSN     : LIKE(Staff.TSN)[20];
 BEGIN
  SETEMPTY(_TSN);
  SETZERO(_OilFact);
  SELECT(MarkFuel, Mark, , Mark.Mark);
  WHILE OCCURE(MarkFuel) DO
   IF (MarkFuel.InMix = trgInMix) & L_DatTim.IsActiveInIntvl_Inc(trgDateB, trgDateE, MarkFuel.Begin, L_DatTim.till2ED(MarkFuel.Till)) THEN
    _OilFact:= L_Fuel.__GetFactByOilMath(Car.BoxNbr, MarkFuel.Math, trgDateB, trgDateE, _TSN);
    SETZERO(i);
    WHILE ~!_TSN[i] DO
     IF (ReportMode = CurCarMode) | (SEARCH(TempF, Date, trgDateB, Car.BoxNbr, _TSN[i])) THEN
      ADD(TempF, TSN, , _TSN[i], Car.BoxNbr, trgDateB,
          TempF.F[trgInMix], _OilFact[i]);
      INC(TotF[trgInMix], _OilFact[i]);
     END;
     INC(i);
    END; (* WHILE ~!_TSN[i] ... *)
   END;
   NEXT(MarkFuel);
  END; (* WHILE OCCURE(MarkFuel) ... *)
 END {GetFact};

 PRIVATE PROCEDURE Create_TempF(ReportMode: tReportMode);
 BEGIN
  CreateFILE(TempF, "", "६", "");
  CreateFIELD(TempF, Date,     DATE,             "", "",  "", "", "");
  CreateFIELD(TempF, TSN,      LIKE(Staff.TSN),  "", "",  "", ".", "");
  CreateFIELD(TempF, BoxNbr,   LIKE(Car.BoxNbr), "", "",  "", ".", "");
  CreateFIELD(TempF, FuelFact, NUMERIC[4],       "", "0", "", "", "");
  CreateFIELD(TempF, Run,      L_Way.tRun,       "", "0", "", "஡", "");
  CreateFIELD(TempF, N,        tOilArr,          "", "0", "", "", "");
  CreateFIELD(TempF, F,        tOilArr,          "", "0", "", "", "");

  CreateINDEXandLINK(TempF, TSN,    UNIQUE, Staff, TSN,    USER, "", "", TSN, BoxNbr, Date);
  CreateINDEXandLINK(TempF, BoxNbr, PLURAL, Car,   BoxNbr, USER, "", "", BoxNbr);
  IF ReportMode = CurCarMode THEN
   CreateINDEX      (TempF, Date,   PLURAL,                      "", "", Date, TSN);
  ELSE
   CreateINDEX      (TempF, Date,   UNIQUE,                      "", "", Date, BoxNbr, TSN);
  END;
  SetVersionOfFILE(TempF, 0);
  L_AFM.AF_CreateTemp("TempF", "TempF");
 END {Create_TempF};

 PRIVATE PROCEDURE IsAcceptableInMix(trgInMix: LIKE(MarkFuel.InMix)): SCAL[2];
 BEGIN
  RETURN (trgInMix = L_Fuel.im_MotorOil)        |
         (trgInMix = L_Fuel.im_TransmissionOil) |
         (trgInMix = L_Fuel.im_HydroOil)        |
         (trgInMix = L_Fuel.im_PlasticGreasing) |
         (trgInMix = L_Fuel.im_Tosol);
 END {IsAcceptableInMix};

 PRIVATE PROCEDURE OilFact(ReportMode: tReportMode; trgDate: DATE);
  VAR
   trgInMix: LIKE(MarkFuel.InMix);
 BEGIN
  FOR_EACH trgInMix DO
   IF IsAcceptableInMix(trgInMix) THEN
    GetFact(ReportMode, trgInMix, trgDate, trgDate);
   END;
  END;
 END {OilFact};

 PRIVATE PROCEDURE AddOilNorm(trgInMix: LIKE(MarkFuel.InMix); trgDate: DATE; Norm: NUMERIC[4]);
 BEGIN
  ADD(TempF, TSN, , RWayS.TSN, RWayS.BoxNbr, trgDate,
      TempF.N[trgInMix], Norm);

  INC(TotN[trgInMix], Norm);
 END {AddOilNorm};

 PRIVATE PROCEDURE GetRWaySRun(): L_Way.tRun;
  VAR
   Result: L_Way.tRun;
 BEGIN
  Result:=0;
  CONFORM(RWayS, RWayJ);
  WHILE OCCURE(RWayJ) DO
   CONFORM(RWayJ, Quality);
   IF Quality.Type # L_Way.QualType_Annul THEN
    INC(Result, RWayJ.Run * RWayJ.Fact);
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
  RETURN Result;
 END {GetRWaySRun};

 PRIVATE PROCEDURE PrepareData(ReportMode: tReportMode);
  VAR
   trgDate   : DATE;
   trgInMix  : LIKE(MarkFuel.InMix);
   CarOilCoef: L_Fuel.tCarOilCoef;
 BEGIN
  Create_TempF(ReportMode);
 
  SETZERO(TotN, TotF);
  trgDate:=Memo.ud_fr();
  WHILE trgDate <= Memo.ud_ut() DO
   PROMPT(L_DatTim.DateStr(trgDate));
   IF    ReportMode = CurCarMode THEN
    SELECT(RWayS, sBoxNbr, , L_Way.rwsStat_Rated, Car.BoxNbr, trgDate);
   ELSIF ReportMode = CurStaffMode THEN
    SELECT(RWayS, sTSN, , L_Way.rwsStat_Rated, Staff.TSN, trgDate);
   ELSE
    L_General.CallUs(0);
   END;
 
   WHILE OCCURE(RWayS) DO
    IF ~!RWayS.FuelFact & ((ReportMode # CurStaffMode) | L_Env.RealBoxNbr(RWayS.BoxNbr)) THEN
     ADD(TempF, TSN, , RWayS.TSN, RWayS.BoxNbr, trgDate,
         TempF.FuelFact, RWayS.FuelFact,
         TempF.Run,      GetRWaySRun());
     CONFORM(TempF, Car, Mark);
     L_Fuel.GetCarOilCoef(RWayS.Date, CarOilCoef);
     FOR_EACH trgInMix DO
      IF IsAcceptableInMix(trgInMix) & L_Fuel.IsAnyOil(trgInMix) THEN
       AddOilNorm(trgInMix, trgDate, TempF.FuelFact / 100 * GetNorm(trgInMix, CarOilCoef[trgInMix]));
      END;
     END;
     AddOilNorm(L_Fuel.im_Tosol, trgDate, TempF.Run * 17 / 10000);
    END;
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)

   IF    ReportMode = CurCarMode THEN
    OilFact(ReportMode, trgDate);
   ELSIF SELECT(TempF, Date, trgDate)  THEN
    WHILE OCCURE(TempF) DO
     CONFORM(TempF, Car, Mark);
     SAVE(TempF);
     OilFact(ReportMode, trgDate);
     RESTORE(TempF);
     NEXT(TempF);
    END; (* WHILE OCCURE(TempF) ... *)
   END;
   INC(trgDate);
  END; (* WHILE trgDate <= Memo.ud_ut() ... *)
 END {PrepareData};

 PRIVATE PROCEDURE NumToStr(Fact: FLOAT): STRING[];
 BEGIN
  IF Fact # 0 THEN
   RETURN L_Str.IntStr(Fact);
  ELSE
   RETURN "";
  END;
 END {NumToStr};

 PRIVATE PROCEDURE PrintLine(ArrN, ArrF: tOilArr; Subtract: SCAL[2]);
  VAR
   trgInMix: LIKE(MarkFuel.InMix);
 BEGIN
  FOR_EACH trgInMix DO
   IF IsAcceptableInMix(trgInMix) THEN
    IF Subtract THEN
     DEC(ArrN[trgInMix], ArrF[trgInMix]);
     ArrF[trgInMix]:=0;
    END;
    MAKEPART(R, Line, ArrN[trgInMix], NumToStr(ArrF[trgInMix]));
   END;
  END;
 END {PrintLine};

 PRIVATE PROCEDURE MakeRep(ReportMode: tReportMode);
  VAR
   RepName: STRING[];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);

  IF    ReportMode = CurStaffMode THEN
   L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
   RepName:="Oil10";
   OPENREP(R, L_General.NameConnection(RepName), Create);
   CONFORM(Staff, Man);
   MAKEPART(R, TopCurStaff, RepName);
  ELSIF ReportMode = CurCarMode THEN
   L_General.Assert(ACCESS(Car), " ⠭ ⥪饥 ");
   RepName:="Oil11";
   OPENREP(R, L_General.NameConnection(RepName), Create);
   CONFORM(Car, Mark);
   MAKEPART(R, TopCurCar, RepName);
  ELSE
   L_General.CallUs(0);
  END;

  PrepareData(ReportMode);
 
  SELECT(TempF, Date);
  WHILE OCCURE(TempF) DO
   IF ReportMode = CurCarMode THEN
    CONFORM(TempF, Staff);
    CONFORM(Staff, Man);
    MAKEPART(R, LineCurCar);
   ELSE
    CONFORM(TempF, Car, Mark);
    MAKEPART(R, LineCurStaff);
   END;
   PrintLine(TempF.N, TempF.F, 0);
   NEXT(TempF);
  END;
 
  MAKEPART(R, PreBot);
 
  PrintLine(TotN, TotF, 0);

  MAKEPART(R, PrePreBot);

  PrintLine(TotN, TotF, 1);

  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {MakeRep};

 PRIVATE PROCEDURE MakeRepByCurStaff();
 BEGIN
  MakeRep(CurStaffMode);
 END {MakeRepByCurStaff};

 PRIVATE PROCEDURE MakeRepByCurCar();
 BEGIN
  MakeRep(CurCarMode);
 END {MakeRepByCurCar};

END.
