(*
%Copyright   (c) Polak Computer System
%Author      16.03.2001 19:11:15 SAN
%Purpose      室 ᫠  ਮ
%Type        report
%Specific    AP
%Modified    10.04.2012 12:03:45 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_Fuel, D_Fl, L_Basis, L_Car, P_Firm, FIO, Memo, L_Str, Math, L_Way, L_bp;

 VAR
  wMF: SCAL[2];

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "ࠦ");
  L_Basis.wb_WrStr(F, "፮");
  L_Basis.wb_WrStr(F, "祭");
  L_Basis.wb_WrStr(F, "ઠ");
  L_Basis.wb_WrStr(F, "ઠ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "樥");
  L_Basis.wb_WrStr(F, " ⮯");
  L_Basis.wb_WrStr(F, " ⮯");
  L_Basis.wb_WrStr(F, "室 ⮯");
  L_Basis.wb_WrStr(F, "室 ᫠(ଠ)");
  L_Basis.wb_WrStr(F, "室 ᫠(䠪)");
  L_Basis.wb_WrStr(F, "室 ᫠  (䠪)");
  L_Basis.wb_WrStr(F, "室 ᫠  (䠪)");
  L_Basis.wb_WrStr(F, " ᫠");
  L_Basis.wb_WrStr(F, "᫮");
  L_Basis.wb_WrStr(F, "᫮");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "஡  ਮ");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE MakeLine(F: STRING[];
                    _MFMath : LIKE(Math.Math);
                    _MFName : LIKE(Math.Name);
                    _Run    : LIKE(CarRun.Run);
                    _OilCoef: NUMERIC[3]);
 BEGIN
  IF wMF THEN
   CONFORM(Column, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Column.Column);
  L_Basis.wb_WrScl(F, CarLog.BoxNbr);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|", CarLog.Purpose));
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  IF ~!OIL01.Route THEN
   CONFORM(OIL01, Route);
   L_General.Assert(OCCURE(Route), "   " + OIL01.Route + " - ᫥  ⮢ ࠭ 䠩");
   L_Way.StandOnRouteTKind(Memo.ud_ut());
   L_Basis.wb_WrStr(F, Route.Route);
   L_Basis.wb_WrStr(F, Route.Name);
   L_Basis.wb_WrScl(F, TKind.TKind);
   L_Basis.wb_WrStr(F, TKind.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrNum(F, _OilCoef, 3);
  L_Basis.wb_WrScl(F, _MFMath);
  L_Basis.wb_WrStr(F, _MFName);
  L_Basis.wb_WrNum(F, OIL01.FFact, 4);
  L_Basis.wb_WrNum(F, OIL01.MNorm, 4);
  L_Basis.wb_WrNum(F, OIL01.MFact, 4);
  L_Basis.wb_WrNum(F, OIL01.MFactTO, 4);
  L_Basis.wb_WrNum(F, OIL01.MFactAdd, 4);
  L_Basis.wb_WrStr(F, L_Fuel.GetInMixAsStr(OIL01.OilType));
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrScl(F, OIL01.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrNum(F, _Run, 2);
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PRIVATE PROCEDURE Oil40();
  CONST
   RepName = "Oil40";
  VAR
   _MFMath   : LIKE(Math.Math);
   _MFName   : LIKE(Math.Name);
   _Run      : LIKE(CarRun.Run);
   CarOilCoef: L_Fuel.tCarOilCoef;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_bp.Begin(RepName, " 室 ᫠", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  D_Fl.Prepare_OIL01();
  MakeTop("R");
  SELECT(OIL01, BoxNbr);
  WHILE OCCURE(OIL01) DO
   NARROWSEL(OIL01, BoxNbr, clDate);
   PROMPT("⮢  "  + OIL01.BoxNbr);
   CONFORM(OIL01, CarLog);
   CONFORM(CarLog, Mark);
   CONFORM(CarLog, Column);
   CONFORM(CarLog, Car);
   _MFMath:=L_Fuel.GetMainFuel(Math.Min(Memo.ud_ut(), CarLog.DateE), Mark.Mark);
   L_General.CallUs(SEARCH(Math, Math, _MFMath));
   _MFName:=Math.Name;
   _Run   :=L_Car.GetGlobalRun(OIL01.BoxNbr, Memo.ud_ut() + 1) -
            L_Car.GetGlobalRun(OIL01.BoxNbr, Math.Max(Memo.ud_fr(), Car.BegDate));
   L_Fuel.GetCarOilCoef(Memo.ud_ut(), CarOilCoef);
   WHILE OCCURE(OIL01) DO
    CONFORM(OIL01, Math);
    SEARCH(Staff, TSN, , OIL01.TSN);
    CONFORM(Staff, Man);
    MakeLine("R", _MFMath, _MFName, _Run, CarOilCoef[OIL01.OilType]);
    NEXT(OIL01);
   END;
   NEXTINEXTENDEDSEL(OIL01, BoxNbr, clDate);
  END; (* WHILE OCCURE(OIL01) ... *)
  D_Fl.Purge_OIL01();
  FIO.Close("R");
  L_bp.End();
 END {Oil40};

END.
