(*
%Copyright   (c) Polak IT
%Author      25.12.2001 13:49:09 LDA
%Purpose      .
%Type        report
%Specific    AP
%Modified    04.07.2014 14:52:20 POLAK\GAV
%Environment
*)

 IMPORT L_General, L_Str, Str, L_DatTim, L_Car, Memo, P_Mark, L_AFM,
        P_Car, L_Excel, FIO, P_Firm;

 PRIVATE CONST
  ins_All      = 0;
  ins_Present  = 1;
  ins_Absentee = 2;

 PRIVATE VAR
   insState: SCAL[3];
   objWB,
   objXL   : OBJECT;

(*
$P{ Top:
P_Firm.FP_ContractorBriefName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
}
*)

(*
$P{ Header:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|                                              |ப 客     |#################################### |
|------------------------------------------------|---------------------|                                     |
|.|ઠ                           |. |         |        |                                     |
|----|--------------------------------|----------|----------|----------|-------------------------------------|
}
*)

(*
$P{ ICHeader:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|客  ######################################################################################## |
}
*)

(*
$P{ ICLine:
CarList.BoxNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
CarList.StateNbr, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
?, L, ""
?, L, ""
@
|####|#### ###########################|##########|##########|##########|############## ######################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)


 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(CarList, "", "६ 䠩", "");
  CreateFIELD(CarList, BoxNbr,   LIKE(Car.BoxNbr),      "", "", "", "ࠦ", "");
  CreateFIELD(CarList, VehPasp,  LIKE(VehPasp.VehPasp), "", "", "", "", "");
  CreateFIELD(CarList, Mark,     LIKE(Mark.Mark),       "", "", "", "ઠ", "");
  CreateFIELD(CarList, StateNbr, LIKE(Car.StateNbr),    "", "", "", " ", "");
  CreateFIELD(CarList, DocGiveS, STRING[64],            "", "", "", "客⥫", "");
  CreateFIELD(CarList, HasCLIO,  SCAL[2],               "", "", "", "客", "");

  CreateINDEXandLINK(CarList, VehPasp,  PLURAL, VehPasp, VehPasp, USER, "", "", VehPasp);
  CreateINDEXandLINK(CarList, Mark,     PLURAL, Mark,    Mark,    USER, "", "", Mark, StateNbr);
  CreateINDEX       (CarList, BoxNbr,   UNIQUE,                         "", "", BoxNbr);
  CreateINDEX       (CarList, DocGiveS, PLURAL,                         "", "", DocGiveS, BoxNbr);
  SetVersionOfFILE(CarList, 0);
  L_AFM.AF_CreateTemp("CarList", "CarList");
 END {Create_Tmp};

 PRIVATE PROCEDURE AcceptableVehPasp(): SCAL[2];
 BEGIN
  IF SELECT(CarLog, VehPasp, VehPasp.VehPasp) THEN
   WHILE OCCURE(CarLog) DO
    IF L_DatTim.IsActive(Memo.ud_cd(), CarLog.Date, CarLog.DateE)  &
       (CarLog.Status <= L_Car.carst_InOperat) THEN
     RETURN 1;
    END;
    NEXT(CarLog);
   END; (* WHILE OCCURE(CarLog)...*)
  ELSE
   STDMSG(" " + VehPasp.VehPasp + " " +
          L_Car.VehPaspNbr_AsStr() +
          "  ਭ   |" +
          " " + L_DatTim.DateStr(Memo.ud_cd()), CHOICE);
  END;
  RETURN 0;
 END {AcceptableVehPasp};

 PRIVATE PROCEDURE GatherData(trgProperty: LIKE(Property.Property));
 BEGIN
  Create_Tmp();
  SELECT(VehPasp, VPNbr);
  WHILE OCCURE(VehPasp) DO
   PROMPT(VehPasp.Mark + " " + L_Car.VehPaspNbr_AsStr());
   NARROWSEL(VehPasp, VPNbr);
   IF SRCINSEL(VehPasp, LE, Memo.ud_cd()) &
     (Memo.ud_cd() < VehPasp.Till) &
     AcceptableVehPasp() THEN
    CarList.HasCLIO :=P_Car.HasActualCarPro(CarLog.BoxNbr, Memo.ud_cd(), trgProperty);
    IF  (insState = ins_All) |
       ((insState = ins_Present)  &  CarList.HasCLIO) |
       ((insState = ins_Absentee) & ~CarList.HasCLIO) THEN
     CarList.BoxNbr  :=CarLog.BoxNbr;
     CarList.VehPasp :=VehPasp.VehPasp;
     CarList.Mark    :=VehPasp.Mark;
     CarList.StateNbr:=VehPasp.StateNbr;
     IF CarList.HasCLIO | P_Car.HasCarPro(CarLog.BoxNbr, Memo.ud_cd(), trgProperty) THEN
      CarList.DocGiveS:=Str.Cap(CarPro.DocGiveS);
     ELSE
      SETEMPTY(CarList.DocGiveS);
     END;
     INSERT(CarList);
    END;
   END;
   NEXTINEXTENDEDSEL(VehPasp, VPNbr);
  END; (* WHILE OCCURE(VehPasp) ... *)
 END {GatherData};

 PRIVATE PROCEDURE DecorRange(range: OBJECT; orientation: NUMERIC[0]; text: STRING[]);
 BEGIN
  range.Orientation:=orientation;
  range.MergeCells :=L_Excel.xlTrue;
  range.WrapText   :=L_Excel.xlTrue;
  range.Value      :=text;
 END {DecorRange};

 PRIVATE PROCEDURE InitOneSheet(objWS: OBJECT; ExtendedForm: SCAL[2]);
  VAR
   CurRange: OBJECT;
 BEGIN
  PROMPT("ଫ ...");

  L_Excel.ws_Init(objWS);
  objWS.Columns(1).RowHeight :=17.25;
  objWS.Cells(6, 1).RowHeight:=134.25;
  objWS.Cells(7, 1).RowHeight:=66;
  objWS.Cells(8, 1).RowHeight:=13.5;

  DecorRange(objWS.Range(objWS.Cells(1, 7), objWS.Cells(1, 10)), 0, "ਫ 1");
  DecorRange(objWS.Range(objWS.Cells(2, 7), objWS.Cells(2, 17)), 0, "   祭  易⥫쭮 客");
  DecorRange(objWS.Range(objWS.Cells(3, 7), objWS.Cells(3, 17)), 0, 'ࠦ᪮ ⢥⢥ 楢 ࠭ᯮ ।  "___" ____________ 201___ .');
  DecorRange(objWS.Range(objWS.Cells(4, 7), objWS.Cells(4, 8)), 0, "客⥫: ");
  CurRange:=objWS.Range(objWS.Cells(4, 9), objWS.Cells(4, 17));
  DecorRange(CurRange, 0, P_Firm.FP_ContractorBriefName(P_Firm.OWN_FIRM, SYSDATE()));
  CurRange.Font.Bold:=L_Excel.xlTrue;
  CurRange.Borders(L_Excel.xlEdgeBottom).Weight:=L_Excel.xlThin;

  DecorRange(objWS.Range(objWS.Cells(6, 1), objWS.Cells(7, 1)), 90, " /");
  DecorRange(objWS.Range(objWS.Cells(6, 2), objWS.Cells(7, 2)), 90, "ઠ,  ");
  DecorRange(objWS.Range(objWS.Cells(6, 3), objWS.Cells(7, 3)), 90, "䨪樮  (VIN) ");
  DecorRange(objWS.Range(objWS.Cells(6, 4), objWS.Cells(7, 4)), 90, " ⮢");
  DecorRange(objWS.Range(objWS.Cells(6, 5), objWS.Cells(7, 5)), 90, "魮 ⥫, /..");
  DecorRange(objWS.Range(objWS.Cells(6, 6), objWS.Cells(7, 6)), 90, "襭 ᨬ쭠 ,  ( 㧮 ) /   㧪");
  DecorRange(objWS.Range(objWS.Cells(6, 7), objWS.Cells(7, 7)), 90, "- ᠦ᪨  ( ⮡ᮢ, ஫ᮢ, ࠬ)");
  DecorRange(objWS.Range(objWS.Cells(6, 8), objWS.Cells(7, 8)), 90, " (ࠬ) ");
  DecorRange(objWS.Range(objWS.Cells(6, 9), objWS.Cells(7, 9)), 90, "㧮 (楯) ");
  DecorRange(objWS.Range(objWS.Cells(6, 10), objWS.Cells(6, 12)), 0, "ᯮ ");
  DecorRange(objWS.Cells(7, 10), 0, "");
  DecorRange(objWS.Cells(7, 11), 0, "");
  DecorRange(objWS.Cells(7, 12), 0, " 뤠");
  DecorRange(objWS.Range(objWS.Cells(6, 13), objWS.Cells(7, 13)), 90, ". ");
  DecorRange(objWS.Range(objWS.Cells(6, 14), objWS.Cells(7, 14)), 90, " ᤠ/ ᤠ  ப, ७");
  DecorRange(objWS.Range(objWS.Cells(6, 15), objWS.Cells(7, 15)), 90, " ᯮ짮 ");
  DecorRange(objWS.Range(objWS.Cells(6, 16), objWS.Cells(7, 16)), 90, "客⥫");
  DecorRange(objWS.Range(objWS.Cells(6, 17), objWS.Cells(7, 17)), 90, "⢥");
  objWS.Columns(17).WrapText:=L_Excel.xlTrue;
  DecorRange(objWS.Range(objWS.Cells(6, 18), objWS.Cells(6, 19)),  0, " ண 客 ");
  DecorRange(objWS.Cells(7, 18), 0, "");
  DecorRange(objWS.Cells(7, 19), 0, "");
  DecorRange(objWS.Range(objWS.Cells(6, 20), objWS.Cells(6, 21)),  0, "客 ");
  DecorRange(objWS.Cells(7, 20), 0, "");
  DecorRange(objWS.Cells(7, 21), 0, "");
  DecorRange(objWS.Range(objWS.Cells(6, 22), objWS.Cells(7, 22)), 90, "客 ६  ᫥ ");
  DecorRange(objWS.Range(objWS.Cells(6, 23), objWS.Cells(7, 23)), 90, " ⠢");
  DecorRange(objWS.Range(objWS.Cells(6, 24), objWS.Cells(7, 30)),  0, "樥");
  DecorRange(objWS.Range(objWS.Cells(6, 31), objWS.Cells(7, 31)), 90, " ");
  DecorRange(objWS.Range(objWS.Cells(6, 32), objWS.Cells(7, 32)), 90, " ஡");
  DecorRange(objWS.Range(objWS.Cells(6, 33), objWS.Cells(6, 34)),  0, "ப ⢨ ");
  DecorRange(objWS.Cells(7, 33), 0, "");
  DecorRange(objWS.Cells(7, 34), 0, "");
  IF ExtendedForm THEN
   DecorRange(objWS.Range(objWS.Cells(6, 35), objWS.Cells(7, 35)), 90, "ࠦ ");
   DecorRange(objWS.Range(objWS.Cells(6, 36), objWS.Cells(6, 37)),  0, "  ");
   DecorRange(objWS.Cells(7, 36), 0, " . ⠫ ");
   DecorRange(objWS.Cells(7, 37), 0, " 宦 ᫥. ");
   DecorRange(objWS.Range(objWS.Cells(6, 38), objWS.Cells(7, 38)), 90, "客 ");
   DecorRange(objWS.Range(objWS.Cells(6, 39), objWS.Cells(6, 40)), 0,  "ਮ 客");
   DecorRange(objWS.Cells(7, 39), 0, "");
   DecorRange(objWS.Cells(7, 40), 0, "");
  ELSE
   DecorRange(objWS.Range(objWS.Cells(6, 35), objWS.Cells(6, 36)),  0, "  ");
   DecorRange(objWS.Cells(7, 35), 0, " . ⠫ ");
   DecorRange(objWS.Cells(7, 36), 0, " 宦 ᫥. ");
  END;

  objWS.Cells.Font.Name:="Times New Roman";
  objWS.Cells.Font.Size:=10;
  objWS.Cells.Font.Bold:=L_Excel.xlFalse;
  objWS.Cells.EntireColumn.NumberFormat:="@";
  objWS.Range(objWS.Rows(6), objWS.Rows(8)).HorizontalAlignment:=L_Excel.xlCenter;
  objWS.Range(objWS.Rows(6), objWS.Rows(8)).VerticalAlignment  :=L_Excel.xlCenter;
  objWS.Range(objWS.Rows(6), objWS.Rows(8)).Font.Bold:=L_Excel.xlTrue;
  objWS.PageSetup.Orientation :=L_Excel.xlLandscape;
  objWS.PageSetup.LeftMargin  :=objXL.CentimetersToPoints(1);
  objWS.PageSetup.TopMargin   :=objXL.CentimetersToPoints(1);
  objWS.PageSetup.RightMargin :=objXL.CentimetersToPoints(1);
  objWS.PageSetup.BottomMargin:=objXL.CentimetersToPoints(1);
  objWS.PageSetup.HeaderMargin:=objXL.CentimetersToPoints(0.5);
  objWS.PageSetup.FooterMargin:=objXL.CentimetersToPoints(0.5);
  objWS.PageSetup.CenterHorizontally:=L_Excel.xlTrue;

  L_Excel.ws_SetCurPos(objWS, 9, 1);
 END {InitOneSheet};

 PRIVATE PROCEDURE MakeOneSheet(name: STRING[]; ExtendedForm: SCAL[2]; SheetIdx: NUMERIC[0]);
  CONST
   ColWidth     = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                   0, 0, 0, 7.29, 13.29, 13.29, 31.57, 0, 0, 7.86,
                   12, 0, 10, 2.57, 2.57, 2.57, 2.57, 2.57, 2.57, 2.57,
                   7.29, 7.29, 8, 8, 0, 0, 0, 0, 0, 0];
   ColumnAmount = [36, 40];
  VAR
   Idx,
   NumCar: NUMERIC[0];
   objWS : OBJECT;
 BEGIN
  IF objWB.Sheets.Count < SheetIdx THEN
   objWS:=objWB.Sheets.Add();
  ELSE
   objWS:=objWB.Sheets(SheetIdx);
  END;
  InitOneSheet(objWS, ExtendedForm);
  TRY
   objWS.Name:=name;
  EXCEPT
  END;

  NumCar:=1;
  WHILE OCCURE(CarList) DO
   PROMPT(CarList.VehPasp);
   CONFORM(CarList, VehPasp);
   CONFORM(CarList, Mark);
   L_Excel.ws_WrNum(objWS, NumCar);
   L_Excel.ws_WrStr(objWS, VehPasp.MarkName);
   L_Excel.ws_WrStr(objWS, VehPasp.VIN);
   L_Excel.ws_WrNum(objWS, L_DatTim.YEAR(VehPasp.ProdDate));
   L_Excel.ws_WrStr(objWS, FLDTOSTR(VehPasp.EngPwKWt, "2.") + "/" + FLDTOSTR(VehPasp.EngPower, "2."));
   IF (Mark.Category = "CE") | (Mark.Category = "C1E") | (Mark.Category = "C") THEN
    L_Excel.ws_WrStr(objWS, L_Str.IntStr(VehPasp.MaxWeigh) + "/" + L_Str.IntStr(VehPasp.NetWeigh));
   ELSE
    L_Excel.ws_WrStr(objWS, L_Str.IntStr(VehPasp.NetWeigh));
   END;
   IF (Mark.Category = "D") | (Mark.Category = "D1") | (Mark.Category = "DE") | (Mark.Category = "D1E") THEN
    L_Excel.ws_WrStr(objWS, L_Str.IntStr(P_Mark.GetP_PVSitting(VehPasp.Mark, Memo.ud_cd())));
   ELSE
    L_Excel.ws_WrStr(objWS, "");
   END;
   L_Excel.ws_WrStr(objWS, VehPasp.ChassNum);
   L_Excel.ws_WrStr(objWS, VehPasp.BodyNum);
   L_Excel.ws_WrStr(objWS, Str.Slice(VehPasp.VPNbr, 0, 2) + " " + Str.Slice(VehPasp.VPNbr, 2, 2));
   L_Excel.ws_WrStr(objWS, Str.Slice(VehPasp.VPNbr, 4, 6));
   L_Excel.ws_WrStr(objWS, L_DatTim.DateStr(VehPasp.GiveDate));
   L_Excel.ws_WrStr(objWS, VehPasp.StateNbr);
   L_Excel.ws_SkipCols(objWS, 3);
   IF ~!VehPasp.Firm THEN
    L_Excel.ws_WrStr(objWS, P_Firm.FP_ContractorBriefName(VehPasp.Firm, Memo.ud_cd()));
   ELSE
    L_Excel.ws_SkipCols(objWS, 1);
   END;
   IF P_Car.HasCarPro(CarList.BoxNbr, Memo.ud_cd(), P_Car.P_CLI_Obligatory) THEN
    L_Excel.ws_WrStr(objWS, Str.Item(CarPro.DocNum, " ", 0));
    L_Excel.ws_WrStr(objWS, Str.Slice(CarPro.DocNum, Str.Pos(CarPro.DocNum, " "), Str.Length(CarPro.DocNum)));
    L_Excel.ws_SkipCols(objWS, 2);
    L_Excel.ws_WrStr(objWS, L_Str.AnyItem(CarPro.Value, ";", 1));
    L_Excel.ws_SkipCols(objWS, 12);
   ELSE
    L_Excel.ws_SkipCols(objWS, 17);
   END;
   IF ExtendedForm THEN
    L_Excel.ws_WrStr(objWS, CarList.BoxNbr);
   END;
   IF P_Car.HasCarPro(CarList.BoxNbr, Memo.ud_cd(), P_Car.P_Checkup) THEN
    L_Excel.ws_WrStr(objWS, CarPro.DocNum);
    L_Excel.ws_WrStr(objWS, L_DatTim.PeriodStr(CarPro.EndDate));
   ELSE
    L_Excel.ws_SkipCols(objWS, 2);
   END;
   IF ExtendedForm THEN
    IF P_Car.HasCarPro(CarList.BoxNbr, Memo.ud_cd(), P_Car.P_CLI_Obligatory) THEN
     L_Excel.ws_WrStr(objWS, L_Excel.ReplaceIllegalChars(CarPro.DocGiveS));
     L_Excel.ws_WrDat(objWS, CarPro.Date);
     L_Excel.ws_WrDat(objWS, CarPro.EndDate);
    END;
   END;
   L_Excel.ws_TermLine(objWS);
   INC(NumCar);
   NEXT(CarList);
  END; (* WHILE OCCURE(CarList) ... *)

  Idx:=1;
  WHILE Idx <= ColumnAmount[ExtendedForm] DO
   objWS.Cells(8, Idx).Value:=L_Str.IntStr(Idx);
   IF ColWidth[Idx-1] > 0 THEN
    objWS.Columns(Idx).ColumnWidth:=ColWidth[Idx-1];
   ELSE
    objWS.Columns(Idx).EntireColumn.AutoFit();
   END;
   INC(Idx);
  END;
  objWS.Range(objWS.Cells(6, 1), objWS.Cells(8, ColumnAmount[ExtendedForm])).Borders.Weight:=L_Excel.xlMedium;
  objWS.Range(objWS.Cells(9, 1), objWS.Cells(NumCar+7, ColumnAmount[ExtendedForm])).Borders.Weight:=L_Excel.xlThin;
  objWS.Range(objWS.Rows(9), objWS.Rows(NumCar + 7)).EntireRow.AutoFit();

  DecorRange(objWS.Range(objWS.Cells(NumCar + 9, 1), objWS.Cells(NumCar + 9, 10)), 0,
             "客 , ᯥ樠  㤠⢥ ࠧ 稫.");
  DecorRange(objWS.Range(objWS.Cells(NumCar + 12, 2), objWS.Cells(NumCar + 12, 6)), 0,
             "客⥫ _________________ (________________)");
  DecorRange(objWS.Range(objWS.Cells(NumCar + 12, 14), objWS.Cells(NumCar + 12, 19)), 0,
             "।⠢⥫ 客騪 _____________________ (__________________)");
  DecorRange(objWS.Range(objWS.Cells(NumCar + 14, 2), objWS.Cells(NumCar + 14, 3)), 0,
             '"__" ___________ 201__ .');
 END {MakeOneSheet};

 PRIVATE PROCEDURE UploadToExcel(byIC: SCAL[2]);
  VAR
   SheetIdx: NUMERIC[0];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);

  L_General.Assert(L_Excel.ExcelInstalled(), " ⠭ MS Excel");
  objXL:=CreateOBJECT("Excel.Application");
  TRY
   objWB:=L_Excel.NewWorkbook(objXL, 1);
   L_General.Assert(SELECT(CarList, Mark),
                    "   室饣  뢮   ");
   SheetIdx:=1;
   IF ~byIC THEN
    MakeOneSheet(" ᯨ᮪", 1, SheetIdx);
   ELSE
    SELECT(CarList, DocGiveS);
    WHILE OCCURE(CarList) DO
     NARROWSEL(CarList, DocGiveS);
     IF ~!CarList.DocGiveS THEN
      MakeOneSheet(L_Excel.ReplaceIllegalChars(CarList.DocGiveS), 0, SheetIdx);
     ELSE
      MakeOneSheet("  客訥", 0, SheetIdx);
     END;
     INC(SheetIdx);
     NEXTINEXTENDEDSEL(CarList, DocGiveS);
    END; (* WHILE OCCURE(CarList) ... *)
   END;

   TRY
    objWB.SaveAs(FIO.BuildPath("OpisTS_"+FLDTOSTR(Memo.ud_cd(), "DNy"), "xls",
                               FIO.MakePath("TXT", , FIO.AsbSpecialFolders("ClientProjectRoot"))));
   EXCEPT
   ELSE
   END;
   objXL.Visible:=L_Excel.xlTrue;
  EXCEPT
  ELSE
   L_Excel.CloseExcelAfterCrash(objXL, objWB);
   RAISE();
  END;
  L_AFM.AF_PurgeTemp("CarList");
 END {UploadToExcel};

 PRIVATE PROCEDURE MakeSingleICRep(byIC: SCAL[2]; trgProperty: LIKE(Property.Property));
 BEGIN
  IF insState = ins_Absentee THEN
   MAKEPART(R, Header, "।騩 ");
  ELSE
   MAKEPART(R, Header, "");
  END;
  WHILE OCCURE(CarList) DO
   PROMPT(CarList.VehPasp);
   CONFORM(CarList, Mark);
   IF P_Car.HasCarPro(CarList.BoxNbr, Memo.ud_cd(), trgProperty) THEN
    IF ~byIC THEN
     MAKEPART(R, ICLine, CarPro.Date, CarPro.EndDate, CarPro.DocNum, CarList.DocGiveS);
    ELSE
     MAKEPART(R, ICLine, CarPro.Date, CarPro.EndDate, CarPro.DocNum, "");
    END;
   ELSE
    MAKEPART(R, ICLine, L_General.EMPTY_DATE(), L_General.EMPTY_DATE(), "", "");
   END;
   NEXT(CarList);
  END;
 END {MakeSingleICRep};

 PRIVATE PROCEDURE MakeRep(byIC: SCAL[2]; trgProperty: LIKE(Property.Property));
  VAR
   RepName,
   RepTitle,
   PolicyName: STRING[];
 BEGIN
  IF    trgProperty = P_Car.P_CLI_Obligatory THEN
   PolicyName:="";
  ELSIF trgProperty = P_Car.P_KACKO THEN
   PolicyName:="";
  ELSE
   L_General.CallUs(0);
  END;
  IF    insState = ins_Absentee THEN
   RepName :="CrNCP";
   RepTitle:=",  騥  " + PolicyName + ",   ⥪訬 ப  ⢨  ";
  ELSIF insState = ins_Present THEN
   RepName :="CrCLI";
   RepTitle:="  騬 ᠬ " + PolicyName + "  ";
  ELSIF insState = ins_All THEN
   RepName :="CrALL";
   RepTitle:="ﭨ ᮢ " + PolicyName + "  ";
  END;
  RepTitle:=RepTitle + L_DatTim.DateStr(Memo.tmp_cd());

  L_General.Assert(SELECT(CarList, BoxNbr),
                   "   室饣  뢮   ");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, RepTitle);
  IF ~byIC THEN
   MakeSingleICRep(byIC, trgProperty);
  ELSE
   SELECT(CarList, DocGiveS);
   WHILE OCCURE(CarList) DO
    PROMPT(CarList.VehPasp);
    NARROWSEL(CarList, DocGiveS);
    MAKEPART(R, ICHeader, CarList.DocGiveS);
    MakeSingleICRep(byIC, trgProperty);
    NEXTINEXTENDEDSEL(CarList, DocGiveS);
   END; (* WHILE OCCURE(CarList) ... *)
  END;
  MAKEPART(R, Bot);

  LIKEMENU(Survey, "");
 END {MakeRep};

 PRIVATE PROCEDURE clio_GetList();
  VAR
   byIC,
   inExcel: SCAL[2];
 BEGIN
  SETZERO(insState, byIC, inExcel);
  STDFORM("|稥  %20< |  ᮬ|   >I" +
          "||      %20<騩 ᯨ᮪| 客>I" +
          "||ଠ   %20<REP|Excel>I" +
          "||%< 믮 >D %< ⬥ >X",
          " 客  ", INFORM, -1, insState, byIC, inExcel);
 
  GatherData(P_Car.P_CLI_Obligatory);
  IF ~inExcel THEN
   MakeRep(byIC, P_Car.P_CLI_Obligatory);
  ELSE
   UploadToExcel(byIC);
  END;
 END {clio_GetList};

 PRIVATE PROCEDURE kacko_GetList();
  VAR
   byIC: SCAL[2];
 BEGIN
  SETZERO(insState, byIC);
  STDFORM("|稥  %20< |  ᮬ|   >I" +
          "||      %20<騩 ᯨ᮪| 客>I" +
          "||%< 믮 >D %< ⬥ >X",
          " 客  ", INFORM, -1, insState, byIC);
 
  GatherData(P_Car.P_KACKO);
  MakeRep(byIC, P_Car.P_KACKO);
 END {kacko_GetList};

END.
