(*
%Copyright   (c) Polak IT
%Author      14.01.2009 16:41:49 POLAK\LDA
%Purpose     ஭ 
%Type        control
%Specific    AP
%Modified    23.09.2014 09:43:25 POLAK\LDA
%Environment
*)

 MODULE OutCar [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, Str, L_CUC, L_Car, L_AR, L_StdFrm, L_XDoc, L_Rpr, L_MDoc, L_DatTim, L_r2r;

 PRIVATE PROCEDURE OutCarE_OnInitializeWindow();
 BEGIN
  L_WDO.iField       (0, "OutCar.StateNbr").First:=1;
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (0, ["OutCar.Firm", "OutCar.VIN", "OutCar.StateNbr", "OutCar.OutCar"]);
  L_WDO.iMayBeEmpty  (0, ["OutCar.Till", "OutCar.SaleDate", "OutCar.EnginMod", "OutCar.VIN"]);
 END {OutCarE_OnInitializeWindow};

 PRIVATE PROCEDURE OutCar_OnBeforeEdIns(OnInsert: SCAL[2]);
  VAR
   Modifiable: SCAL[2];
 BEGIN
  L_Rpr.CheckOutRprObjAllowed();
  L_AR.GrantRightsForInteractiveModification();
  Modifiable:=1;
  IF ~OnInsert THEN
   Modifiable:=~SELECT(RprS, CUCopy, OutCar.CUCopy) | L_General.IsAdmin();
  END;
  RTI.Get().CurZone.Fields("OutCar.Firm").Modifiable:=Modifiable;
 END {OutCar_OnBeforeEdIns};

 PRIVATE PROCEDURE OutCar_OnBeforeEdit();
 BEGIN
  OutCar_OnBeforeEdIns(0);
 END {OutCar_OnBeforeEdit};

 PRIVATE PROCEDURE OutCar_OnBeforeInsert();
 BEGIN
  OutCar_OnBeforeEdIns(1);
 END {OutCar_OnBeforeInsert};

 PRIVATE PROCEDURE OutCar_OnAfterEdIns();
 BEGIN
  OutCar.StateNbr:=L_Car.E_GetCorrectedStateNbr(OutCar.StateNbr, 0);
  REPLACE(OutCar);

  IF ~!OutCar.SaleDate THEN
   L_General.Assert(OutCar.ProdYear <= L_DatTim.YEAR(OutCar.SaleDate), " ᪠      த");
  END;

  SAVE(OutCar);
  IF SELECT(OutCar, StateNbr, OutCar.StateNbr) & NEXT(OutCar) THEN
   L_StdFrm.Choice("  ஭   ⠪ . ஬ (" + OutCar.StateNbr + ")");
  END;
  RESTORE(OutCar);

  CONFORM(OutCar, Mark);
  Mark.use_OutC:=1;
  REPLACE(Mark);

  L_Rpr.SetCUCopySerialByAnyCar(OutCar.CUCopy, OutCar.StateNbr, OutCar.Mark);
 END {OutCar_OnAfterEdIns};

 PUBLIC PROCEDURE OutCar_OnAfterInsert();
 BEGIN
  DEFAULT(CUCopy);
  CUCopy.Begin  :=SYSDATE();
  CUCopy.Origin :=L_CUC.o_OutCar;
  INSERT(CUCopy);

  OutCar.CUCopy:=CUCopy.CUCopy;
  REPLACE(OutCar);

  OutCar_OnAfterEdIns();
 END {OutCar_OnAfterInsert};

 PRIVATE PROCEDURE OutCar_OnAfterEdit();
 BEGIN
  OutCar_OnAfterEdIns();
 END {OutCar_OnAfterEdit};

 PRIVATE PROCEDURE OutCar_OutCar_intOnSuccessfulChange(prvValue: LIKE(OutCar.OutCar));
 BEGIN
  IF ~!OutCar.CUCopy THEN
   SELECT(RprS, CUCopy, , OutCar.CUCopy);
   WHILE OCCURE(RprS) DO
    PROMPT("     " + RprS.RprS);
    RprS.RprObjId:=OutCar.OutCar;
    REPLACE(RprS);
    NEXT(RprS);
   END; (* WHILE OCCURE(RprS) ... *)
  END;
 END {OutCar_OutCar_intOnSuccessfulChange};

 PRIVATE PROCEDURE OutCar_OutCar_OnSuccessfulChange();
 BEGIN
  OutCar_OutCar_intOnSuccessfulChange(GE_PVALUE());
 END {OutCar_OutCar_OnSuccessfulChange};

 PRIVATE PROCEDURE OutCar_StateNbr_OnSuccessfulChange();
  VAR
   trgOutCar: LIKE(OutCar.OutCar);
 BEGIN
  OutCar.StateNbr:=L_Car.E_GetCorrectedStateNbr(OutCar.StateNbr, 0);
  REPLACE(OutCar);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   trgOutCar    :=Str.Condense(Str.Slice(OutCar.StateNbr, 0, Str.MaxLength(OutCar.OutCar)));
   OutCar.OutCar:=trgOutCar;
   REPLACE(OutCar);
   OutCar_OutCar_intOnSuccessfulChange("");
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_UniquenessViolation THEN
    L_StdFrm.RedInform(" ࠢ筨 㦥  ஭ ࠭ᯮ⭮ ।⢮   '" + trgOutCar + "'.||" +
                       "⮬᪮ ନ஢   .|   ");
   ELSE
    RAISE();
   END;
  END; (* TRY *)
 END {OutCar_StateNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE OutCar_VIN_OnSuccessfulChange();
 BEGIN
  OutCar.VIN:=Str.Cap(OutCar.VIN);
  REPLACE(OutCar);
  L_Car.CheckVIN(OutCar.VIN);
 END {OutCar_VIN_OnSuccessfulChange};

 PRIVATE PROCEDURE OutCar_Firm_OnSuccessfulChange();
 BEGIN
  IF ~!GE_PVALUE() THEN
   IF ~!OutCar.CUCopy & SELECT(RprS, CUCopy, OutCar.CUCopy) THEN
    WHILE OCCURE(RprS) DO
     PROMPT("஢ઠ  " + RprS.RprS);
     IF L_Rpr.extCheckExistsFinalMDoc(GE_PVALUE(), 1) THEN
      L_General.Error(" ஭   ନ஢ .||" +
                      "冷  ᮡ⢥ ஭  .  㬥樨");
     END;
     NEXT(RprS);
    END; (* WHILE OCCURE(RprS) ... *)
    L_StdFrm.Choice(" ஭  " + OutCar.OutCar + "  .|" +
                    "室 ஢ ࠢ쭮 |⮨ ६ ᫥  ࠣ");
   END;
  END;
 END {OutCar_Firm_OnSuccessfulChange};

 PRIVATE PROCEDURE OutCar_OnBeforeDelete();
 BEGIN
  L_General.Assert(~SELECT(RprS, CUCopy, OutCar.CUCopy),
                   " 饭, ⠪   ⮬   ");

  L_General.CallUs(SEARCH(CUCopy, CUCopy, OutCar.CUCopy));
  REMOVE(CUCopy);

  SETEMPTY(OutCar.CUCopy);
  REPLACE(OutCar);
 END {OutCar_OnBeforeDelete};

 PRIVATE PROCEDURE IsEqualOutCar(oldOutCar, newOutCar: LIKE(OutCar.OutCar)): SCAL[2];
  VAR
   oldMark: LIKE(Mark.Mark);
   oldFirm: LIKE(Firm.Firm);
 BEGIN
  TRY [ABORT_AFTER(AA_ON)]
   SEARCH(OutCar, OutCar, , oldOutCar);
   oldMark:=OutCar.Mark;
   oldFirm:=OutCar.Firm;
   SEARCH(OutCar, OutCar, , newOutCar);
   RETURN (OutCar.Mark=oldMark) & (OutCar.Firm=oldFirm);
  EXCEPT
  END; (* TRY *)
 END {IsEqualOutCar};

 PUBLIC PROCEDURE MergeOutCar();
  VAR
   srcOutCar,
   dstOutCar    : LIKE(OutCar.OutCar);
   srcOutCarName: STRING[];
   srcCUCopy    : LIKE(OutCar.CUCopy);
 BEGIN
  L_General.AdminOnly();
  ACCESS(OutCar);
  srcOutCar    :=OutCar.OutCar;
  srcOutCarName:=OutCar.StateNbr;
  srcCUCopy    :=OutCar.CUCopy;
  SETEMPTY(dstOutCar);
  LOOP
   STDFORM(L_StdFrm.sf_Choice("|  ஭  " + srcOutCar + "  ७ᥭ," +
                              "|᫥ 祣  ஭  㤥 㤠." +
                              L_StdFrm.HR() +
                              "  ஭  ꥤ ?||%#######%|",
                              "%I"),
           "ꥤ ஭ ",
           STOP,
           ,
           dstOutCar);
   IF SEARCH(OutCar, OutCar, dstOutCar) THEN
    EXIT;
   ELSE
    L_StdFrm.RedInform("஭   ஬ " + dstOutCar + "  ");
   END;
  END; (* LOOP *)

  L_StdFrm.Choice(" ᯮ짮 ஭ " +
                   "| |" +
                   srcOutCar + " " + srcOutCarName +
                   "|" +
                   "" +
                   "|" +
                   OutCar.OutCar + " " + OutCar.StateNbr);

  IF ~IsEqualOutCar(srcOutCar, OutCar.OutCar) THEN
   L_General.Error("ꥤ  ⮫쪮 '宦' ");
  END;

  TRY [INTEGRITY(INTEGRITY_ON)]
   WHILE SELECT(RprS, CUCopy, srcCUCopy) DO
    RprS.RprObjId:=OutCar.OutCar;
    RprS.CUCopy  :=OutCar.CUCopy;
    REPLACE(RprS);
   END; (* WHILE OCCURE(RprS) ... *)
 
   SEARCH(OutCar, OutCar, , srcOutCar);
   L_r2r.Owner_OnBeforeDelete("OutCar");
   REMOVE(OutCar);
 
   SEARCH(CUCopy, CUCopy, , srcCUCopy);
   L_r2r.Owner_OnBeforeDelete("CUCopy");
   REMOVE(CUCopy);
  EXCEPT
  END; (* TRY *)
 END {MergeOutCar};

BEGIN
 L_Events.ExecuteHandler();
END.
