(*
%Copyright   (c) Polak IT
%Author      14.01.2009 16:41:49 POLAK\LDA
%Purpose     ஭ ॣ
%Type        control
%Specific    AP
%Modified    03.07.2014 10:33:43 POLAK\LDA
%Environment
*)

 MODULE OutCBlc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, Str, L_CUC, L_AR, L_StdFrm, L_XDoc, L_Rpr, L_MDoc, L_MathR, L_DBD;

 PRIVATE PROCEDURE OutCBlcE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (0, ["OutCBlc.Firm"]);
  L_WDO.iUnmodifiable(0, ["OutCBlc.OutCBlc"]);
  L_WDO.iMayBeEmpty  (0, ["OutCBlc.Serial", "OutCBlc.Till"]);
 END {OutCBlcE_OnInitializeWindow};

 PRIVATE PROCEDURE OutCBlc_OnBeforeEdIns(OnInsert: SCAL[2]);
  VAR
   Modifiable: SCAL[2];
 BEGIN
  L_Rpr.CheckOutRprObjAllowed();
  L_AR.GrantRightsForInteractiveModification();
  Modifiable:=1;
  IF OnInsert THEN
   DEFAULT(CUCopy);
   CUCopy.Begin  :=SYSDATE();
   CUCopy.Origin :=L_CUC.o_OutCBlc;
   INSERT(CUCopy);
 
   OutCBlc.OutCBlc:=CUCopy.CUCopy;
   OutCBlc.CUCopy :=OutCBlc.OutCBlc;
   REPLACE(OutCBlc);
  ELSE
   Modifiable:=~SELECT(RprS, CUCopy, OutCBlc.CUCopy) | L_General.IsAdmin();
  END;
  RTI.Get().CurZone.Fields("OutCBlc.Firm").Modifiable:=Modifiable;
 END {OutCBlc_OnBeforeEdIns};

 PRIVATE PROCEDURE OutCBlc_OnBeforeEdit();
 BEGIN
  OutCBlc_OnBeforeEdIns(0);
 END {OutCBlc_OnBeforeEdit};

 PRIVATE PROCEDURE OutCBlc_OnBeforeInsert();
 BEGIN
  OutCBlc_OnBeforeEdIns(1);
 END {OutCBlc_OnBeforeInsert};

 PRIVATE PROCEDURE OutCBlc_OnAfterEdIns();
  VAR
   Msg       : STRING[];
   curOutCBlc: LIKE(OutCBlc.OutCBlc);
 BEGIN
  L_DBD.CheckOwnersValidity("OutCBlc");

  IF ~!OutCBlc.Serial THEN
   curOutCBlc:=OutCBlc.OutCBlc;
   SETEMPTY(Msg);
   SAVE(OutCBlc);
   SELECT(OutCBlc, Serial, , OutCBlc.Serial);
   WHILE OCCURE(OutCBlc) DO
    IF curOutCBlc # OutCBlc.OutCBlc THEN
     Msg:=Msg + "|" + OutCBlc.OutCBlc;
    END;
    NEXT(OutCBlc);
   END; (* WHILE OCCURE(OutCBlc) ... *)
   RESTORE(OutCBlc);

   IF ~!Msg THEN
    L_StdFrm.Choice("᪮  '" + OutCBlc.Serial + "' 㦥 ᯮ  㣨 ॣ:|" + Msg);
   END;
  END;

  CONFORM(OutCBlc, CUCopy);
  CUCopy.Serial:=L_Rpr.GetRprObjDescr_ByOutCBlc(OutCBlc.OutCBlc);
  REPLACE(CUCopy);
 END {OutCBlc_OnAfterEdIns};

 PRIVATE PROCEDURE OutCBlc_OnAfterInsert();
 BEGIN
  OutCBlc_OnAfterEdIns();
 END {OutCBlc_OnAfterInsert};

 PRIVATE PROCEDURE OutCBlc_OnAfterEdit();
 BEGIN
  OutCBlc_OnAfterEdIns();
 END {OutCBlc_OnAfterEdit};

 PRIVATE PROCEDURE OutCBlc_Firm_OnSuccessfulChange();
 BEGIN
  IF ~!GE_PVALUE() THEN
   IF ~!OutCBlc.CUCopy & SELECT(RprS, CUCopy, OutCBlc.CUCopy) THEN
    L_StdFrm.Choice(" ஭ ॣ " + OutCBlc.OutCBlc + "  .|" +
                    "室 ஢ ࠢ쭮    ᫥  ࠣ");
    WHILE OCCURE(RprS) DO
     PROMPT("஢ઠ  " + RprS.RprS);
     L_General.Assert(~L_Rpr.extCheckExistsFinalMDoc(GE_PVALUE(), 1), " ஭ ॣ  ⮢ 㬥.||" +
                                                                      "  ࠣ  ஭ ॣ 室 |" +
                                                                      "ࠣ    ");
     NEXT(RprS);
    END; (* WHILE OCCURE(RprS) ... *)
   END;
  END;
 END {OutCBlc_Firm_OnSuccessfulChange};

 PRIVATE PROCEDURE OutCBlc_OnBeforeDelete();
 BEGIN
  L_General.Assert(~SELECT(RprS, CUCopy, OutCBlc.CUCopy),
                   " 饭, ⠪   ⮬ ஭ ॣ  ");

  L_General.CallUs(SEARCH(CUCopy, CUCopy, OutCBlc.CUCopy));
  REMOVE(CUCopy);

  SETEMPTY(OutCBlc.CUCopy);
  REPLACE(OutCBlc);
 END {OutCBlc_OnBeforeDelete};

BEGIN
 L_Events.ExecuteHandler();
END.
