(*
%Copyright   (c) Polak IT
%Author      04.03.2005 15:17:11 POLAK\LDA
%Purpose     ନ஢ 㬥⮢  ४ ᤥ  MS_Office
%Type        operation
%Specific    SYS
%Modified    10.04.2012 12:03:55 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Str, Math, L_General, L_DatTim, L_Money, L_PDoc, L_Str, L_MSO,
        P_Firm, P_Cntr, E_Pmnt, L_XDoc, L_Pmnt, Memo, P_Math, P_Route,
        L_Acnt, L_Car, L_CarAD;

 VAR
  ButtonLst,
  TemplateLst,
  DateDefLst,
  PrepareProcLst: STRING[];

 PRIVATE VAR
  PrpResult: L_MSO.PrpResultType;
  _Ver     : STRING[];
  _CopyCnt : NUMERIC[0];

 PRIVATE PROCEDURE AppendSingleList(VAR rLst: STRING[]; aLst: STRING[]);
 BEGIN
  rLst:=rLst + aLst + "|";
 END {AppendSingleList};

 PRIVATE PROCEDURE AppendAdditionalList();
  VAR
   Local               : PROC;
   adtButtonLst,
   adtTemplateLst,
   adtDateDefLst,
   adtPrepareProcLst: STRING[];
 BEGIN
  Local:=PROCREF(E_Pmnt.GetAdditionalDocumentsList);
  IF ~!Local THEN
   E_Pmnt.GetAdditionalDocumentsList(      adtButtonLst,
                                         adtTemplateLst,
                                          adtDateDefLst,
                                     adtPrepareProcLst);
   AppendSingleList(     ButtonLst,      adtButtonLst);
   AppendSingleList(   TemplateLst,    adtTemplateLst);
   AppendSingleList(    DateDefLst,     adtDateDefLst);
   AppendSingleList(PrepareProcLst, adtPrepareProcLst);
  END;
 END {AppendAdditionalList};

 PRIVATE PROCEDURE DefineStandartList();
 BEGIN
  ButtonLst     :="ਫ N 1|⥫쭮 ᮣ襭";
  DateDefLst    :="CarAD.Date|CarAD.Date|";
  TemplateLst   :="CarAD|CarAD_Add";
  PrepareProcLst:="|";
  AppendAdditionalList();
 END {DefineStandartList};

 PRIVATE PROCEDURE BarCode(): STRING[];
 BEGIN
  RETURN L_XDoc.BarCode(L_XDoc.bck_IdIn17, L_XDoc.xdt_Contract, 0, Contract.Contract, _CopyCnt);
 END {BarCode};

 PRIVATE PROCEDURE E_SetInFaceVar(Prefix: STRING[]; _Firm: LIKE(Firm.Firm); D: DATE);
  VAR
   local    : PROC;
   InFaceStr: STRING[];
 BEGIN
  local:=PROCREF(E_Pmnt.CarADFirmInFaceStr);
  InFaceStr:=", 祩 ।⠢⥫";
  IF ~!P_Firm.FP_LeadPostName1(_Firm, D) THEN
   InFaceStr:=InFaceStr + " " + P_Firm.FP_LeadPostName1(_Firm, D);
  END;
  IF P_Firm.FP_PrtnrTyp(_Firm, D) = P_Firm.pt_Branch THEN
   InFaceStr:=InFaceStr + " " + P_Firm.FP_FirmName(_Firm, D);
  END;
  InFaceStr:=InFaceStr + " " + P_Firm.FP_LeadName(_Firm, D) +
             "   ᭮ " + P_Firm.FP_BasisOfLeaderActivity(_Firm, D);

  IF ~!local THEN
   InFaceStr:=local(_Firm, D, InFaceStr);
  END;
  L_MSO.wordSetVar(Prefix + "Firm.InFace", InFaceStr);
 END {E_SetInFaceVar};

 PRIVATE PROCEDURE PrepareCarADObjects(OnDate: DATE; PrepareProc: PROC);
  VAR
   _Root,
   Root,
   r              : STRING[];
   _FirmAcnt      : LIKE(FirmAcnt.FirmAcnt);
   TotalSum,
   TotalTotal,
   TotalMount,
   CarADLTotalSum,
   TotalDismount  : LIKE(CarADL.Sum);
   i,
   Period         : NUMERIC[0];
 BEGIN
  _Root:="CarAD.";
  Root :=_Root;

  L_MSO.wordSetVarsByFile("CarAD");
  Period:=L_DatTim.CompleteMonthsInIntvl(CarAD.BegDate, CarAD.EndDate);
  L_MSO.wordSetVar("CarAD.Period",        L_Str.IntStr(Period));
  L_MSO.wordSetVar("CarAD.Period.ByWord", L_Str.NumericByWord(Period, 0));
  IF ~!CarAD.Amount THEN
   L_MSO.wordSetVar("CarAD.Amount.ByWord", L_Str.NumericByWord(CarAD.Amount, 0));
  ELSE
   L_MSO.wordSetVar("CarAD.Amount.ByWord", "");
  END;
  CONFORM(CarAD, Contract);
  L_MSO.wordSetVarsByFile_wPrefix("Contract", Root);
  L_MSO.wordSetVar(Root + "BarCode", BarCode());
  _FirmAcnt:=P_Cntr.GetDefaultPayOwnFirmAcnt(Contract.Contract, OnDate);
  IF ~!_FirmAcnt THEN
   P_Firm.SetFirmData("Own", P_Firm.OWN_FIRM, OnDate, _FirmAcnt, L_MSO.fps_Soft_asStr);
  END;
  E_SetInFaceVar("Own", P_Firm.OWN_FIRM, OnDate);

  CONFORM(Contract, Firm);
  _FirmAcnt:=P_Cntr.GetDefaultPayFirmAcnt(Contract.Contract, OnDate);
  IF !_FirmAcnt & P_Firm.SoftAccessSilentFirmAcnt(Firm.Firm, OnDate) THEN
   _FirmAcnt:=FirmAcnt.FirmAcnt;
  END;
  P_Firm.SetFirmData(Root + "Contract.", Firm.Firm, OnDate, _FirmAcnt, L_MSO.fps_Soft_asStr);
  E_SetInFaceVar(Root + "Contract.", Firm.Firm, OnDate);

  SETZERO(TotalMount, TotalDismount, TotalSum, TotalTotal);
  Root:=Root + "CarADL";
  L_General.Assert(SELECT(CarADL, CarAD, CarAD.CarAD), " ४ ᤥ");
  i:=0;
  WHILE OCCURE(CarADL) DO
   CONFORM(CarADL, Math);
   CONFORM(CarADL, Route);
   CONFORM(CarADL, Car);
   L_Car.AccessMark(CarADL.BoxNbr, OnDate);
   L_MSO.wordSetVarsByFile_wAliasAndIndexE("CarADL", Root,         i, 0);

   L_MSO.wordSetVarsByFile_wIndexedPrefixE("Car",    Root,         i, 0);
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("Math",   Root,         i, 0);
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("Route",  Root,         i, 0);
   L_MSO.wordSetVarsByFile_wAliasE("Mark",    L_Str.Var_wIdx(Root, i) + ".Car",    0);
   L_MSO.wordSetVarsByFile_wAliasE("MathPro", L_Str.Var_wIdx(Root, i) + ".Tariff", ~P_Math.HasActualMathPro(CarADL.Math, CarAD.Date, P_Math.P_Tariff));

   CarADLTotalSum[L_CarAD.psidx_Netto]:=CarADL.Mount[L_CarAD.psidx_Netto] + CarADL.Dismount[L_CarAD.psidx_Netto] + CarADL.Sum[L_CarAD.psidx_Netto];
   CarADLTotalSum[L_CarAD.psidx_VAT]  :=CarADL.Mount[L_CarAD.psidx_VAT]   + CarADL.Dismount[L_CarAD.psidx_VAT]   + CarADL.Sum[L_CarAD.psidx_VAT];

   L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, i) + ".Mount[2]",    OnDate, CarADL.Mount[L_CarAD.psidx_Netto] +
                                                                           CarADL.Mount[L_CarAD.psidx_VAT]);
   L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, i) + ".Dismount[2]", OnDate, CarADL.Dismount[L_CarAD.psidx_Netto] +
                                                                           CarADL.Dismount[L_CarAD.psidx_VAT]);
   L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, i) + ".MD[0]",       OnDate, CarADL.Mount[L_CarAD.psidx_Netto] + 
                                                                           CarADL.Dismount[L_CarAD.psidx_Netto]);
   L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, i) + ".MD[1]",       OnDate, CarADL.Mount[L_CarAD.psidx_VAT] +
                                                                           CarADL.Dismount[L_CarAD.psidx_VAT]);
   L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, i) + ".MD[2]",       OnDate, CarADL.Mount[L_CarAD.psidx_Netto] + 
                                                                           CarADL.Mount[L_CarAD.psidx_VAT] +
                                                                           CarADL.Dismount[L_CarAD.psidx_Netto] + 
                                                                           CarADL.Dismount[L_CarAD.psidx_VAT]);
   L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, i) + ".Cost[2]",     OnDate, CarADL.Cost[L_CarAD.psidx_Netto] + 
                                                                           CarADL.Cost[L_CarAD.psidx_VAT]);
   L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, i) + ".Sum[2]",      OnDate, CarADL.Sum[L_CarAD.psidx_Netto] + 
                                                                           CarADL.Sum[L_CarAD.psidx_VAT]);
   L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, i) + ".Total[0]",    OnDate, CarADLTotalSum[L_CarAD.psidx_Netto]);
   L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, i) + ".Total[1]",    OnDate, CarADLTotalSum[L_CarAD.psidx_VAT]);
   L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, i) + ".Total[2]",    OnDate, CarADLTotalSum[L_CarAD.psidx_Netto] + 
                                                                           CarADLTotalSum[L_CarAD.psidx_VAT]);

   INC(TotalMount[L_CarAD.psidx_Netto],    CarADL.Mount[L_CarAD.psidx_Netto]);
   INC(TotalMount[L_CarAD.psidx_VAT],      CarADL.Mount[L_CarAD.psidx_VAT]);
   INC(TotalDismount[L_CarAD.psidx_Netto], CarADL.Dismount[L_CarAD.psidx_Netto]);
   INC(TotalDismount[L_CarAD.psidx_VAT],   CarADL.Dismount[L_CarAD.psidx_VAT]);
   INC(TotalSum[L_CarAD.psidx_Netto],      CarADL.Sum[L_CarAD.psidx_Netto]);
   INC(TotalSum[L_CarAD.psidx_VAT],        CarADL.Sum[L_CarAD.psidx_VAT]);
   INC(TotalTotal[L_CarAD.psidx_Netto],    CarADLTotalSum[L_CarAD.psidx_Netto]);
   INC(TotalTotal[L_CarAD.psidx_VAT],      CarADLTotalSum[L_CarAD.psidx_VAT]);
   INC(i);
   NEXT(CarADL);
  END; (* WHILE OCCURE(CarADL) ... *)
  L_MSO.extSetWordTable("CarADL", i, L_MSO.tt_Soft);

  Root:=_Root;
  L_MSO.wordSetMoneyVar(Root + "TotalMount[0]",     OnDate, TotalMount[L_CarAD.psidx_Netto]);
  L_MSO.wordSetMoneyVar(Root + "TotalMount[1]",     OnDate, TotalMount[L_CarAD.psidx_VAT]);
  L_MSO.wordSetMoneyVar(Root + "TotalMount[2]",     OnDate, TotalMount[L_CarAD.psidx_Netto] + TotalMount[L_CarAD.psidx_VAT]);
  L_MSO.wordSetMoneyVar(Root + "TotalDismount[0]",  OnDate, TotalDismount[L_CarAD.psidx_Netto]);
  L_MSO.wordSetMoneyVar(Root + "TotalDismount[1]",  OnDate, TotalDismount[L_CarAD.psidx_VAT]);
  L_MSO.wordSetMoneyVar(Root + "TotalDismount[2]",  OnDate, TotalDismount[L_CarAD.psidx_Netto] + TotalDismount[L_CarAD.psidx_VAT]);
  L_MSO.wordSetMoneyVar(Root + "TotalMD[0]",        OnDate, TotalMount[L_CarAD.psidx_Netto] + TotalDismount[L_CarAD.psidx_Netto]);
  L_MSO.wordSetMoneyVar(Root + "TotalMD[1]",        OnDate, TotalMount[L_CarAD.psidx_VAT]   + TotalDismount[L_CarAD.psidx_VAT]);
  L_MSO.wordSetMoneyVar(Root + "TotalMD[2]",        OnDate, TotalMount[L_CarAD.psidx_Netto] + TotalDismount[L_CarAD.psidx_Netto] + TotalMount[L_CarAD.psidx_VAT]   + TotalDismount[L_CarAD.psidx_VAT]);
  L_MSO.wordSetMoneyVar(Root + "TotalSum[0]",       OnDate, TotalSum[L_CarAD.psidx_Netto]);
  L_MSO.wordSetMoneyVar(Root + "TotalSum[1]",       OnDate, TotalSum[L_CarAD.psidx_VAT]);
  L_MSO.wordSetMoneyVar(Root + "TotalSum[2]",       OnDate, TotalSum[L_CarAD.psidx_Netto] + TotalSum[L_CarAD.psidx_VAT]);
  L_MSO.wordSetMoneyVar(Root + "TotalTotal[0]",     OnDate, TotalTotal[L_CarAD.psidx_Netto]);
  L_MSO.wordSetMoneyVar(Root + "TotalTotal[1]",     OnDate, TotalTotal[L_CarAD.psidx_VAT]);
  L_MSO.wordSetMoneyVar(Root + "TotalTotal[2]",     OnDate, TotalTotal[L_CarAD.psidx_Netto] + TotalTotal[L_CarAD.psidx_VAT]);

  IF ~!PrepareProc THEN
   PrepareProc(OnDate);
  END;
 END {PrepareCarADObjects};

 PRIVATE PROCEDURE MakeDoc(OnDate      : DATE;
                   TemplateName: STRING[];
                   PrepareProc : PROC;
                   PrepareMode : L_MSO.PrpModeType;
                   _PrpResult  : L_MSO.PrpResultType);
  VAR
   Copies: NUMERIC[0];
 BEGIN
  L_MSO.wordInitDocument(OnDate);

  PrpResult:=_PrpResult;
  PrepareCarADObjects(OnDate, PrepareProc);

  IF PrpResult=L_MSO.PrpResult_Original THEN
   Copies:=2;
  ELSE
   Copies:=1;
  END;
(*
  TemplateName:=L_MSO.BuildTemplateName(TemplateName, _Ver);
*)
  L_MSO.MakeWordDocument(TemplateName, Copies, PrepareMode, "");
 END {MakeDoc};

 PRIVATE PROCEDURE MakeAnyDoc();
  VAR
   PrepareMode : L_MSO.PrpModeType;
   Choice      : NUMERIC[0];
   OnDate      : DATE;
   DateDef,
   TemplateName,
   PrepareProc : STRING[];
   PrpProc     : PROC;
 BEGIN
  L_General.Assert(ACCESS(CarAD), " ⠭ ⥪ ४ ᤥ");

  PrpResult   :=L_MSO.PrpResult_Preview;
  Choice      :=L_MSO.SelectDoc(ButtonLst, TemplateLst, PrpResult)-1;
  PrepareMode :=L_MSO.GetStandartPrepareMode(PrpResult);

  DateDef     :=L_Str.PoolItem(DateDefLst,  Choice);
  TemplateName:=L_Str.PoolItem(TemplateLst, Choice);
  _CopyCnt    :=0;
  PrepareProc :=L_Str.AnyItem(PrepareProcLst, "|", Choice);
  L_General.Assert(~!TemplateName, "  ஥");
  PrpProc:=STRTOFLD(PrepareProc, PROC);

  IF    DateDef = "CarAD.Date" THEN
   OnDate:=CarAD.Date;
  ELSIF DateDef = "Memo.CurDate" THEN
   OnDate:=Memo.ud_cd();
  ELSIF DateDef = "SYSDATE" THEN
   OnDate:=SYSDATE();
  ELSE
   L_General.Error("O_CarAD:  ᯮᮡ । ");
  END;
  MakeDoc(OnDate, TemplateName, PrpProc, PrpResult, PrepareMode);
 END {MakeAnyDoc};

BEGIN
 IF    MODE = 100 THEN
  DefineStandartList();
  MakeAnyDoc();
 ELSE
  L_General.BadMode(MODE);
 END;
END.
