(*
%Copyright   (c) Polak IT
%Author      02.10.2009 17:33:06 POLAK\LDA
%Purpose      㬥⮢ ⮑ࢨ
%Type        report
%Specific    AP
%Modified    17.09.2014 11:08:33 POLAK\LDA
%Environment
*)

 MODULE O_RprS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_MSO, L_Rpr, L_Str, P_Firm, L_Staff, L_CUC, L_Str, Str, L_General, L_lsStore, L_XObj,
        L_MathR, L_Acnt, E_Rpr, DBD, L_XDoc, L_Car, L_DatTim, FIO, L_FIO, L_MDoc, MDocP_MO, Memo (*  E_Rpr*);

 PRIVATE PROCEDURE E_GetBusPictureName(): STRING[];
  VAR
   Local  : PROC;
   default: STRING[];
 BEGIN
  default:="sc_Bus.jpg";
  Local  :=PROCREF(E_Rpr.GetBusPictureName);
  IF ~!Local THEN
   RETURN Local(SYSDATE(), default);
  END;
  RETURN default;
 END {E_GetBusPictureName};

 PRIVATE PROCEDURE OutCarAcceptReportPrepare(D: DATE; Root: STRING[]);
 BEGIN
  L_MSO.wordSetPic("BusPicture", L_FIO.rf_GetFullFileName(E_GetBusPictureName()), -1, 83.3);
 END {OutCarAcceptReportPrepare};

 PRIVATE PROCEDURE AcptRep_OutCBlc(D: DATE; Root: STRING[]);
  VAR
   AcptRepName: STRING[];
 BEGIN
  IF L_Rpr.IsRprS_w_OutCBlc() THEN
   AcptRepName:=" ਥ ॣ ᯮ⥫";
   IF L_Rpr.IsSpecificRprSContractConditions(OutCBlc.Firm, RprS.OrdDate) THEN
    AcptRepName:=" ਥ   ⠫ ६";
   END;
   L_MSO.wordSetVar(Root + "RprS.AcptRepName", AcptRepName);
  END;
 END {AcptRep_OutCBlc};

 PRIVATE PROCEDURE OrderWarrantPrepare(TemplateName: STRING[]; PrpMode: L_MSO.PrpModeType);
  VAR
   PrpResult: L_MSO.PrpResultType;
 BEGIN
  TRY
   CALL(M_Bills.GenerateTemporaryFinalMDocByRprS(L_MDoc.md_IAS));
   IF PrpMode = L_MSO.PrpMode_ToDoc THEN
    PrpResult:=L_MSO.PrpResult_Preview;
   ELSE
    PrpResult:=L_MSO.PrpResult_Original;
   END;
   MDocP_MO.MakeDoc(TemplateName, PrpResult);
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Raise DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
 END {OrderWarrantPrepare};

 PRIVATE PROCEDURE E_O_RprS_Copies(TemplateName: STRING[]): NUMERIC[0];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.O_RprS_Copies);
  IF ~!Local THEN
   RETURN Local(TemplateName);
  ELSE
   RETURN 1;
  END;
 END {E_O_RprS_Copies};

 PRIVATE PROCEDURE PrepareRprSObjects(D: DATE; ProcName: PROC; PrintCurRprT: SCAL[2]);
 BEGIN
  PROMPT(RprS.RprS + ": ⮢ ");
  L_Rpr.RprSFileFamily(D, "", 1);
  IF PrintCurRprT THEN
   L_Rpr.UploadSingleRprT(D, "", 1);
  END;
  IF ~!ProcName THEN
   ProcName(D, "");
  END;
 END {PrepareRprSObjects};

 PRIVATE PROCEDURE MakeWordDocument(d           : DATE;
                                    Copies      : NUMERIC[0];
                                    TemplateName: STRING[];
                                    PrpMode     : L_MSO.PrpModeType;
                                    PrepareProc : PROC;
                                    TextParam   : STRING[];
                                    PrintCurRprT: SCAL[2]);
 BEGIN
  L_MSO.wordInitDocument(d);
  PrepareRprSObjects(d, PrepareProc, PrintCurRprT);
  L_MSO.MakeWordDocument(TemplateName, Copies, PrpMode, TextParam);
 END {MakeWordDocument};

 PRIVATE PROCEDURE MakeDoc(PrpMode: L_MSO.PrpModeType; TextParam: STRING[]);
  VAR
   d           : DATE;
   Copies      : NUMERIC[0];
   TemplateName: STRING[];
   PrepareProc : PROC;
 BEGIN
  TemplateName:=MSODL.Template;
  IF Str.Match(Str.Cap(TemplateName), "NARJAD*") THEN
   OrderWarrantPrepare(TemplateName, PrpMode);
  ELSE
   d          :=^(MSODL.DateDef);
   Copies     :=E_O_RprS_Copies(TemplateName);
   PrepareProc:=PROCREF(^(L_MSO.dl_GetPrepareProc()));
   MakeWordDocument(d, Copies, TemplateName, PrpMode, PrepareProc, TextParam, 0);
  END;
 END {MakeDoc};

 PRIVATE PROCEDURE DefineFullDocList();
  VAR
   Local: PROC;
 BEGIN
  IF    L_Rpr.IsServiceCenterLocation(RprS.Location) | L_Rpr.IsRprS_w_OutCar() THEN
   L_MSO.dl_AddDoc(" ਥ-।", "AcptRep_01", "OutCarAcceptReportPrepare", "RprS.OrdDate");
   L_MSO.dl_AddDoc("-",         "Narjad_01",  "",                          "RprS.OrdDate");
  ELSIF L_Rpr.IsWorkshopLocation(RprS.Location) & L_Rpr.IsRprS_w_OutCBlc() THEN
   L_MSO.dl_AddDoc(" ਥ ᯮ⥫", "AcptRep_04", "AcptRep_OutCBlc", "RprS.OrdDate");
   L_MSO.dl_AddDoc("-",             "Narjad_03",  "",                "RprS.OrdDate");
  END;

  Local:=PROCREF(E_Rpr.DefineAdditionalDocList);
  IF ~!Local THEN
   Local();
  END;
 END {DefineFullDocList};

 PUBLIC PROCEDURE Print();
  VAR
   PrpMode: L_MSO.PrpModeType;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  PrpMode:=L_MSO.PrpMode_Print;
  L_Rpr.AccessRprS();
  DefineFullDocList();
  L_General.Assert(DBD.FileExist(MSODL), "       ।ᬮ७");
  L_MSO.dl_SelectDoc(PrpMode);
  MakeDoc(PrpMode, "");
 END {Print};

 PUBLIC PROCEDURE Print_RprS(PrepareProc: PROC);
 BEGIN
  L_Rpr.AccessRprS();
  MakeWordDocument(RprS.OrdDate, 1, "RprS"+RprS.RprObjT+"_01",       L_MSO.PrpMode_Print, PrepareProc, "", 0);
 END {Print_RprS};

 PUBLIC PROCEDURE Print_RprS_Short(PrepareProc : PROC);
 BEGIN
  L_Rpr.AccessRprS();
  MakeWordDocument(RprS.OrdDate, 1, "RprS"+RprS.RprObjT+"_Short_01", L_MSO.PrpMode_Print, PrepareProc, "", 0);
 END {Print_RprS_Short};

 PUBLIC PROCEDURE Print_RprT_Ext(TemplateName: STRING[]; PrepareProc: PROC);
 BEGIN
  L_Rpr.AccessRprS();
  L_Rpr.AccessRprT();
  MakeWordDocument(RprT.BDate, 1, TemplateName,         L_MSO.PrpMode_Print, PrepareProc, "", 1);
 END {Print_RprT_Ext};

 PUBLIC PROCEDURE Print_RprT(PrepareProc: PROC);
 BEGIN
  Print_RprT_Ext("RprT"+RprS.RprObjT+"_01", PrepareProc);
 END {Print_RprT};

END.
