(*
%Copyright   (c) Polak IT
%Author      02.02.2011 18:11:54 POLAK\MLB
%Purpose     㤨  DIALOG
%Type        operation
%Specific    AP
%Modified    28.08.2013 19:13:11 POLAK\LDA
%Environment
*)

 MODULE phs [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_GUI, L_DatTim, L_Str, P_Firm, FIO, L_FIO, Math, L_SpcEq, L_WIA,
        L_Man, P_Man, L_Math, L_EMail, L_SES, L_Staff, L_StdFrm, Str, L_Print;

 PRIVATE CONST
  si_CropWidth = "CropWidth";
  si_CropX     = "CropX";
  si_CropY     = "CropY";

  csm_Normal = 0;
  csm_Debug  = 1;

  p_Main             = "p_Main";

  id_Clock           = "st_DateTime";
  id_ManName         = "st_ManName";
  id_Prompt          = "st_Prompt";

  id_GetPhoto        = "pb_GetPhoto";
  id_SaveAndExit     = "pb_SaveAndExit";
  id_SaveAndPrint    = "pb_SaveAndPrint";
  id_NoSaveAndExit   = "pb_NoSaveAndExit";
  id_SelRect         = "rst_SelRect";
  id_SrcBorder       = "b_SrcBorder";
  id_DstBorder       = "b_DstBorder";
  id_SrcPhoto        = "p_SrcPhoto";
  id_DstPhoto        = "p_DstPhoto";

  refreshCycle_Renew = 1;

  sW_MainShift       = 3;
  sH_MainShift       = 3;
  BorderWidth        = 1.5;

  pL_Most            = sW_MainShift;
  pT_Most            = sH_MainShift;
  pR_Most            = (L_GUI.normalWidth -1) - pL_Most;
  pB_Most            = (L_GUI.normalHeight-1) - pT_Most;
  sW_Most            = pR_Most - pL_Most;
  sH_Most            = pB_Most - pT_Most;

  WidthToHeightCoef  = 45/35;
  sW_DstBorder       = 314;
  sH_DstBorder       = Math.Round(sW_DstBorder * WidthToHeightCoef);

  fs_Clock           = 19;
  sW_Clock           = sW_DstBorder;
  pL_Clock           = pR_Most - sW_Clock;
  pT_Clock           = pT_Most;
  sH_Clock           = 25;

  fs_Title           = 20;
  pL_Title           = pL_Most;
  pT_Title           = pT_Most;
  sH_Title           = sH_Clock;
  sW_Title           = sW_Most-sW_Clock-sW_MainShift;

  fs_ManName         = 29;
  pL_ManName         = pL_Most;
  pT_ManName         = pT_Title + sH_Title + sH_MainShift;
  sW_ManName         = sW_Most;
  sH_ManName         = 50;

  pL_DstBorder       = pL_Clock;
  pT_DstBorder       = pT_ManName + sH_ManName + sH_MainShift;

  fs_Copyright       = 19;
  sW_Copyright       = sW_Clock;
  sH_Copyright       = 20;
  pL_Copyright       = pL_Clock;
  pT_Copyright       = pB_Most - sH_Copyright;

  sH_SrcBorder       = sH_Most - sH_Title - sH_ManName - sH_Copyright - 3*sH_MainShift;
  sW_SrcBorder       = sW_Most - sW_DstBorder - sW_MainShift;
  pL_SrcBorder       = pL_Most;
  pT_SrcBorder       = pT_ManName + sH_ManName + sH_MainShift;

  fs_Prompt          = 19;
  pL_Prompt          = pL_SrcBorder;
  pT_Prompt          = pT_Copyright;
  sH_Prompt          = sH_Copyright;
  sW_Prompt          = sW_SrcBorder;

  fS_Buttons         = 20;
  sW_Buttons         = sW_DstBorder+1;
  sH_Buttons         = Math.Div(sH_SrcBorder - sH_DstBorder, 4) - sH_MainShift;
  pT_Button1         = pT_Copyright - 4*sH_Buttons - 4*sH_MainShift +1;
  pT_Button2         = pT_Copyright - 3*sH_Buttons - 3*sH_MainShift +1;
  pT_Button3         = pT_Copyright - 2*sH_Buttons - 2*sH_MainShift +1;
  pT_Button4         = pT_Copyright - 1*sH_Buttons - 1*sH_MainShift +1;
  pL_Buttons         = pL_DstBorder;

 PRIVATE VAR
  dlg                        : DIALOG;
  Angle                      : NUMERIC[0];
  HRT_Renew                  : FLOAT;
  FullPathToResources        : STRING[];
  ToJPEG,
  Rotator,
  VideoDevice                : OBJECT;
  cs_Mode,
  wStaff,
  IsCanonEOS,
  UseIPCamera,
  wTouchScreen,
  PhotoStudioDemoMode,
  PrintAndCreatePassAfterExit: SCAL[2];

 PRIVATE PROCEDURE GetPicturePath(PictName: STRING[]): STRING[];
 BEGIN
  RETURN FIO.BuildPath(PictName, , FullPathToResources);
 END {GetPicturePath};

 PRIVATE PROCEDURE SetupButtonPictureAttr(id_Button: STRING[]);
  VAR
   pb: PUSH_BUTTON;
 BEGIN
  pb:=dlg.Controls.Item(id_Button);
  pb.PictureRect.Right:=pb.PictureRect.Left + pb.PictureRect.Bottom - pb.PictureRect.Top;
  pb.TextRect.Left    :=pb.PictureRect.Right + 10;
  pb.Style.Font.Size  :=fS_Buttons;
 END {SetupButtonPictureAttr};

 PRIVATE PROCEDURE PutGetPhotoButton();
  CONST
   PictName = "Photo.ico";
 BEGIN
  L_GUI.put_ImgButton(dlg, p_Main, id_GetPhoto, "⮣஢",
                      GetPicturePath(PictName),
                      pL_Buttons, pT_Button1, sW_Buttons, sH_Buttons,
                      PROCREF(OnClick_GetPhoto));
  SetupButtonPictureAttr(id_GetPhoto);
 END {PutGetPhotoButton};

 PRIVATE PROCEDURE PutSaveAndExitButton();
  CONST
   PictName = "Save.ico";
 BEGIN
  L_GUI.put_ImgButton(dlg, p_Main, id_SaveAndExit,  "࠭ ⮣| ",
                      GetPicturePath(PictName),
                      pL_Buttons, pT_Button2, sW_Buttons, sH_Buttons,
                      PROCREF(OnClick_SaveAndExit));
  SetupButtonPictureAttr(id_SaveAndExit);
 END {PutSaveAndExitButton};

 PRIVATE PROCEDURE PrintPassAlowed(): SCAL[2];
 BEGIN
  RETURN FIO.Exists(FIO.BuildPath(L_Staff.E_GetPassTemplateName(L_Staff.E_IsOutsider(SYSDATE())), "DOT")) &
         ~!L_Print.GetPrinterName(L_Print.pt_Pass);
 END {PrintPassAlowed};

 PRIVATE PROCEDURE ProximityCardReaderInstalled(): SCAL[2];
 BEGIN
  RETURN L_SpcEq.IsInstalled(L_SpcEq.et_ProximityCardReader)
 END {ProximityCardReaderInstalled};

 PRIVATE PROCEDURE PutSaveAndPrintButton();
  CONST
   PictName ="SaveAndPrint.ico";
  VAR
   Caption: STRING[];
 BEGIN
  IF PrintPassAlowed() THEN
   IF L_SpcEq.IsInstalled(L_SpcEq.et_ProximityCardReader) THEN
    Caption:="  뤠 ய";
   ELSE
    Caption:=" 㤮⮢७| ";
   END;
  ELSE
   IF L_SpcEq.IsInstalled(L_SpcEq.et_ProximityCardReader) THEN
    Caption:="뤠 ய";
   ELSE
(* dummy -  㤥 㯭 *)
    Caption:="  뤠 ய";
   END;
  END;
  L_GUI.put_ImgButton(dlg, p_Main, id_SaveAndPrint, Caption,
                      GetPicturePath(PictName),
                      pL_Buttons, pT_Button3, sW_Buttons, sH_Buttons,
                      PROCREF(OnClick_SaveAndPrint));
  SetupButtonPictureAttr(id_SaveAndPrint);
 END {PutSaveAndPrintButton};

 PRIVATE PROCEDURE PutNoSaveAndExitButton();
  CONST
   PictName = "Close.ico";
 BEGIN
  L_GUI.put_ImgButton(dlg, p_Main, id_NoSaveAndExit, "  ࠭",
                      GetPicturePath(PictName),
                      pL_Buttons, pT_Button4, sW_Buttons, sH_Buttons,
                      PROCREF(OnClick_NoSaveAndExit));
  SetupButtonPictureAttr(id_NoSaveAndExit);
 END {PutNoSaveAndExitButton};

 PRIVATE PROCEDURE PutManName();
  VAR
   pictL,
   pictT,
   pictH,
   pictW : NUMERIC[0];
   asTSN : STRING[];
 BEGIN
  L_GUI.put_Border(dlg, p_Main, id_ManName + "Border", pL_ManName, pT_ManName, sW_ManName, sH_ManName);
  pictH:= sH_ManName - 2*sH_MainShift;
  pictW:= pictH;
  pictL:= pL_ManName + 2*sW_MainShift;
  pictT:= pT_ManName + sH_MainShift;
  L_GUI.put_Picture(dlg, p_Main, id_ManName + "Picture",
                    GetPicturePath(L_Str.PoolItem("FEMALE.GIF|MALE.GIF", Man.Sex)),
                    pictL, pictT, pictW, pictH);
  IF wStaff THEN
   asTSN:=Staff.TSN;
  ELSE
   asTSN:=Str.Align("/", 5, LEFT);
  END;
  L_GUI.put_StaticText(dlg, p_Main, id_ManName, asTSN + " " + Man.Name,
                       pictL + sW_MainShift + pictW, pictT, sW_ManName - pictW -3*sW_MainShift, sH_ManName - 2*sH_MainShift,
                       fs_ManName, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
 END {PutManName};

 PRIVATE PROCEDURE CreateMainPage();
  VAR
   pL_SelRect,
   pT_SelRect,
   sH_SelRect,
   sW_SelRect: NUMERIC[0];
 BEGIN
  L_GUI.put_StaticText(dlg, p_Main, "Title", "⮣஢. " + P_Firm.FP_FirmShortName(P_Firm.OWN_FIRM, SYSDATE()),
                       pL_Title, pT_Title, sW_Title, sH_Title,
                       fs_Title, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_ThinRidge);

  L_GUI.put_StaticText(dlg, p_Main, id_Clock, "",
                       pL_Clock, pT_Clock, sW_Clock, sH_Clock,
                       fs_Clock, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_ThinRidge);
  FullPathToResources:="mk:@MSITStore:" + L_FIO.rf_GetCHMFullName("phs") + "::/";
  PutManName();

  PutGetPhotoButton();
  PutSaveAndExitButton();
  PutSaveAndPrintButton();
  PutNoSaveAndExitButton();

  L_GUI.put_Border(dlg, p_Main, id_SrcBorder, pL_SrcBorder, pT_SrcBorder, sW_SrcBorder, sH_SrcBorder);
  L_GUI.put_Picture(dlg, p_Main, id_SrcPhoto, "", pL_SrcBorder+BorderWidth, pT_SrcBorder+BorderWidth, sW_SrcBorder-2*BorderWidth, sH_SrcBorder-2*BorderWidth);

  sW_SelRect:=L_SES.GetFieldValue_asNUMERIC(L_SES.sit_User, si_CropWidth, sW_DstBorder);
  sH_SelRect:=sW_SelRect * WidthToHeightCoef;
  pL_SelRect:=L_SES.GetFieldValue_asNUMERIC(L_SES.sit_User, si_CropX, Math.Div(sW_SrcBorder-sW_SelRect, 2));
  pT_SelRect:=L_SES.GetFieldValue_asNUMERIC(L_SES.sit_User, si_CropY, Math.Div(sH_SrcBorder-sH_SelRect, 2));
  L_GUI.put_Rectangle_Select_Tool(dlg, p_Main, id_SelRect,
                                  pL_SelRect, pT_SelRect,
                                  sW_SelRect, sH_SelRect,
                                  id_SrcPhoto,
                                  1,
                                  PROCREF(OnUserChangesRect_SelRect));

  L_GUI.put_Border(dlg, p_Main, id_DstBorder, pL_DstBorder, pT_DstBorder, sW_DstBorder, sH_DstBorder);
  L_GUI.put_Picture(dlg, p_Main, id_DstPhoto, "", pL_DstBorder+BorderWidth, pT_DstBorder+BorderWidth, sW_DstBorder-2*BorderWidth, sH_DstBorder-2*BorderWidth);

  L_GUI.put_StaticText(dlg, p_Main, id_Prompt, "",
                       pL_Prompt, pT_Prompt, sW_ManName, sH_Prompt,
                       fs_Prompt, CONTROL.HorizontalAlignment_Left,  L_GUI.br_st_ThinRidge);
  L_GUI.SetControlBkColor(dlg.Controls.Item(id_Prompt), RGBCOLOR.Create(190, 190, 190));
(*
  L_GUI.put_Border(dlg, p_Main, "id_PromptBorder", pL_Prompt, pT_Prompt, sW_ManName, sH_Copyright);
*)
  L_GUI.put_StaticText(dlg, p_Main, "PolakCopyright", "(c) Polak 2005 - " + L_Str.IntStr(L_DatTim.YEAR(SYSDATE())),
                       pL_Copyright, pT_Copyright, sW_Copyright, sH_Copyright,
                       fs_Copyright, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
 END {CreateMainPage};

 PRIVATE PROCEDURE ShowMainPage();
 BEGIN
  L_GUI.ShowPages(dlg, p_Main, 0);
 END {ShowMainPage};

 PRIVATE PROCEDURE ScanImageInDevice(Items: OBJECT; Clear: SCAL[2]): OBJECT;
  VAR
   i     : NUMERIC[0];
   Item,
   Result: OBJECT;
 BEGIN
  SETEMPTY(Result);
  i:=Items.Count;
  WHILE i > 0 DO
   Item:=Items.Item(i);
   IF HasAcceptableGUID(Item.Formats, L_WIA.if_JPEG) THEN
    IF Clear THEN
     Items.Remove(i);
    ELSE
     RETURN Items.Item(i);
    END;
   END;
   DEC(i);
  END;
  RETURN Result;
 END {ScanImageInDevice};

 PRIVATE PROCEDURE ClearImageFromDevice(Items: OBJECT);
  VAR
   Dummy: OBJECT;
 BEGIN
  Dummy:=ScanImageInDevice(Items, 1);
 END {ClearImageFromDevice};

 PRIVATE PROCEDURE GetImageFromDevice(Items: OBJECT): OBJECT;
 BEGIN
  RETURN ScanImageInDevice(Items, 0);
 END {GetImageFromDevice};

 PRIVATE PROCEDURE GetTmpFileName(PostFix: STRING[]): STRING[];
 BEGIN
  RETURN L_FIO.tf_GetFullPath("Photo" + PostFix + "_" + APP.Get().MyConnection.Number, "JPG");
 END {GetTmpFileName};

 PRIVATE PROCEDURE GetManPhotoFullFileName(CheckOnlySysDate: SCAL[2]): STRING[];
  VAR
   FileName: STRING[];
 BEGIN
  FileName:=P_Man.GetManProSoft(Man.Man, SYSDATE(), P_Man.P_ManPhoto);
  IF CheckOnlySysDate & (~OCCURE(ManPro) | (ManPro.Date # SYSDATE())) THEN
   SETEMPTY(FileName);
  END;
  IF ~!FileName THEN
   FileName:=P_Man.GetFullPhotoFileName(FileName);
  END;
  RETURN FileName;
 END {GetManPhotoFullFileName};

 PRIVATE PROCEDURE SetEnable_SavePhotoButtons(Enable: SCAL[2]);
 BEGIN
  dlg.Controls.Item(id_SaveAndExit).Enable :=Enable;
  IF Enable = 1 THEN
   Enable:=PrintPassAlowed() | ProximityCardReaderInstalled();
  END;
  dlg.Controls.Item(id_SaveAndPrint).Enable:=Enable;
  dlg.Redraw();
 END {SetEnable_SavePhotoButtons};

 PRIVATE PROCEDURE GatherImageFromFolder(Path: STRING[]; VAR Amount: NUMERIC[0]): STRING[];
  VAR
   Result       : STRING[];
   Folder       : FOLDER_ENTRY;
   File         : OBJECT;
   FolderContent: ENUMERATOR;
 BEGIN
  SETEMPTY(Result);
  Folder:=FOLDER_ENTRY.Create(Path);
  FolderContent:=CreateENUMERATOR(Folder.FolderContent);
  WHILE ~FolderContent.AtEnd() DO
   File:=FolderContent.Item();
   IF    File.Attributes.Directory THEN
    Result:=L_Str.AddStrDlm(Result, "|") + GatherImageFromFolder(File.Path, Amount);
   ELSIF (Str.Cap(L_FIO.effp_FileExt(File.Path)) = "JPG") THEN
    Result:=Result+File.Path+"|";
    INC(Amount);
   END;
   FolderContent.MoveNext();
  END; (* WHILE ~FolderContent.AtEnd...*)
  RETURN Result;
 END {GatherImageFromFolder};

 PRIVATE PROCEDURE GetRandomPicture(): STRING[];
  VAR
   Amount    : NUMERIC[0];
   Path,
   Result,
   ImagesList: STRING[];
 BEGIN
  SETEMPTY(Result);
  Path:="C:\WINDOWS\WEB\WALLPAPER";
  IF FIO.DirExists(Path) THEN
   SETZERO(Amount);
   ImagesList:=GatherImageFromFolder(Path, Amount);
   IF Amount # 0 THEN
    Result:=L_Str.PoolItem(ImagesList, L_Math.Random(Amount));
   END;
  END;
  RETURN Result;
 END {GetRandomPicture};

 PRIVATE PROCEDURE MakePhoto(VideoDevice: OBJECT): STRING[];
  CONST
   ec_SysCameraErr = 740;
   ec_UsrCameraErr = 741;
   ec_SavePhotoErr = 490;
  VAR
   ImageURL   : STRING[];
   srcFileName,
   tmpFileName: STRING[];
   Items,
   oImgFile   : OBJECT;
   TryCnt     : NUMERIC[0];
 BEGIN
  TRY
   PROMPT(" ⮣஢...");
   SetEnable_SavePhotoButtons(1);
   FIO.Erase(GetTmpFileName(""));
   tmpFileName:=GetTmpFileName("_Src");
   SETEMPTY(oImgFile);

   IF UseIPCamera THEN
    IF cs_Mode = csm_Normal THEN
     ImageURL:="http://192.168.0.20/IMAGE.JPG";
    ELSE
     ImageURL:="http://www.autopark.ru/ap_wiki/images/0/0d/RWayS_26_1.jpg";
    END;
    IF L_EMail.LaunchWGet(ImageURL +
                          " --output-document=" + tmpFileName +
                          " --http-user=admin --http-passwd=654321 -c", 1) = L_General.eprc_Normal THEN
     oImgFile:=CreateOBJECT("Wia.ImageFile");
     oImgFile.LoadFile(tmpFileName);
    END;
   ELSE
    IF cs_Mode = csm_Normal THEN
     IF ~IsCanonEOS THEN
      ClearImageFromDevice(VideoDevice.Items);
      Items:=VideoDevice.ExecuteCommand(L_WIA.cmd_TakePicture);
      IF !Items THEN
       TryCnt:=0;
       LOOP
        IF ~!Items | (TryCnt = 10) THEN
         EXIT;
        END;
        SLEEP(0.5);
        Items:=GetImageFromDevice(VideoDevice.Items);
        INC(TryCnt);
        VideoDevice.ExecuteCommand(L_WIA.cmd_Synchronize);
       END; (* LOOP *)
      END;
      L_General.Assert(~!Items, " 㤠  ࠦ.|" +
                                "஢, 祭    ");
      oImgFile:=Items.Transfer();
      ClearImageFromDevice(VideoDevice.Items);
     ELSE
      TryCnt:=0;
      LOOP
       TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
        VideoDevice.TakePictureToFile(tmpFileName);
        EXIT;
       EXCEPT
       ON Exc: Exc_RunTime DO
        INC(TryCnt);
        IF TryCnt = 5 THEN
         SETEMPTY(dlg.Controls.Item(id_SrcPhoto).Picture, dlg.Controls.Item(id_DstPhoto).Picture);
         SetEnable_SavePhotoButtons(0);
         IF    Exc.ErrorCode = ec_SysCameraErr THEN
          L_General.Error(Exc.MsgOriginalText);
         ELSIF Exc.ErrorCode = ec_UsrCameraErr THEN
          IF    Str.Pos(Str.Cap(Exc.MsgOriginalText), Str.Cap(" 㤠 믮 䮪஢")) # Str.Length(Exc.MsgOriginalText) THEN
           L_General.Error(Exc.MsgOriginalText + "||" + "஢,   誠  ꥪ⨢");
          ELSE
           L_General.Error(Exc.MsgOriginalText);
          END;
         ELSIF Exc.ErrorCode = ec_SavePhotoErr THEN
          L_General.Error(Exc.MsgOriginalText);
         ELSE
          RAISE();
         END;
        END;
        SLEEP(0.5);
       END; (* TRY *)
      END; (* LOOP *)
      oImgFile:=CreateOBJECT("Wia.ImageFile");
      oImgFile.LoadFile(tmpFileName);
     END; (* IF ~IsCanonEOS ... *)
    ELSE
     srcFileName:=GetManPhotoFullFileName(0);
     IF !srcFileName THEN
      srcFileName:=GetRandomPicture();
     END;
     L_General.Assert(~!srcFileName, "⫠ :  㤠  ⮣|" +
                                     " ⮡ࠦ  㤨");
     L_FIO.FileCopy(srcFileName, tmpFileName);
     oImgFile:=CreateOBJECT("Wia.ImageFile");
     oImgFile.LoadFile(tmpFileName);
    END;
   END;
   L_General.CallUs(~!oImgFile);
   oImgFile := Rotator.Apply(oImgFile);
   IF oImgFile.FormatID # L_WIA.if_JPEG THEN
    oImgFile:= ToJPEG.Apply(oImgFile);
   END;
   IF FIO.Exists(tmpFileName) THEN
    FIO.Erase(tmpFileName);
   END;
   oImgFile.SaveFile(tmpFileName);
   RETURN tmpFileName;
  EXCEPT
  ON Exc: Exc_Object DO
   SetEnable_SavePhotoButtons(0);
   L_General.Error("ந諠 訡  ⮣஢" +
                   "|" + "訡 0x " + L_Math.DecToHex(Exc.ErrorCode) + ": " + Exc.MsgOriginalText +
                   "||" + " ஢ ࠢ   ꥬ");
  END; (* TRY *)
 END {MakePhoto};

 PRIVATE PROCEDURE CropPhoto(srcFileName: STRING[]): STRING[];
  VAR
   dstFileName: STRING[];
 BEGIN
  dstFileName:=GetTmpFileName("");
  PROMPT("१ 뤥  ⮣䨨...");
  L_GUI.CutPieceOfImage(srcFileName,
                        dstFileName,
                        dlg.Controls.Item(id_SrcPhoto),
                        dlg.Controls.Item(id_SelRect),
                        WidthToHeightCoef);
  RETURN dstFileName;
 END {CropPhoto};

 PRIVATE PROCEDURE ShowPhoto(srcFullFileName, dstFullFileName: STRING[]);
  VAR
   rst         : RECTANGLE_SELECT_TOOL;
   oImgFile    : OBJECT;
   IsPortrait  : SCAL[2];
   sW_ImgFile,
   sH_ImgFile,
   pL_SrcPhoto,
   pT_SrcPhoto,
   sW_SrcPhoto,
   sH_SrcPhoto,
   pL_SelRect,
   pT_SelRect,
   sW_SelRect,
   sH_SelRect  : FLOAT;
 BEGIN
  PROMPT("⮡ࠦ ⮣䨨...");
  IF ~!dstFullFileName THEN
   L_GUI.upd_Picture(dlg, id_DstPhoto, dstFullFileName,
                     dlg.Controls.Item(id_DstPhoto).Rect.Left,
                     dlg.Controls.Item(id_DstPhoto).Rect.Top,
                     dlg.Controls.Item(id_DstPhoto).Rect.Right  - dlg.Controls.Item(id_DstPhoto).Rect.Left,
                     dlg.Controls.Item(id_DstPhoto).Rect.Bottom - dlg.Controls.Item(id_DstPhoto).Rect.Top);
  END;

  IF ~!srcFullFileName THEN
   oImgFile:=LOADPICTURE(srcFullFileName);

   sW_ImgFile :=oImgFile.Width;
   sH_ImgFile :=oImgFile.Height;
   sW_SrcPhoto:=sW_ImgFile;
   sH_SrcPhoto:=sH_ImgFile;
   IsPortrait :=sW_ImgFile < sH_ImgFile;

   IF IsPortrait THEN
    IF sH_ImgFile > sH_SrcBorder THEN
     sH_SrcPhoto:=sH_SrcBorder;
     sW_SrcPhoto:=sW_ImgFile / sH_ImgFile * sH_SrcPhoto;
    END;
   ELSE
    IF sW_ImgFile > sW_SrcBorder THEN
     sW_SrcPhoto:=sW_SrcBorder;
     sH_SrcPhoto:=sH_ImgFile / sW_ImgFile * sW_SrcPhoto;
    END;
   END;
   pL_SrcPhoto:=pL_SrcBorder + (sW_SrcBorder-sW_SrcPhoto)/2 + BorderWidth;
   pT_SrcPhoto:=pT_SrcBorder + (sH_SrcBorder-sH_SrcPhoto)/2 + BorderWidth;
   sW_SrcPhoto:=sW_SrcPhoto- 2*BorderWidth;
   sH_SrcPhoto:=sH_SrcPhoto-2*BorderWidth;

   L_GUI.upd_Picture(dlg, id_SrcPhoto, srcFullFileName, pL_SrcPhoto, pT_SrcPhoto, sW_SrcPhoto, sH_SrcPhoto);

   rst:=dlg.Controls.Item(id_SelRect);
   pL_SelRect:=rst.Rect.Left;
   pT_SelRect:=rst.Rect.Top;
   sW_SelRect:=(rst.Rect.Right  - rst.Rect.Left + 1);
   sH_SelRect:=(rst.Rect.Bottom - rst.Rect.Top  + 1);

   IF    sW_SelRect > sW_SrcPhoto THEN
    sW_SelRect:=sW_SrcPhoto;
    sH_SelRect:=sW_SelRect * WidthToHeightCoef;
   ELSIF sH_SelRect > sH_SrcPhoto THEN
    sH_SelRect:=sH_SrcPhoto;
    sW_SelRect:=sH_SelRect / WidthToHeightCoef;
   END;

   IF (pL_SelRect < pL_SrcPhoto)                                |
      (pT_SelRect < pT_SrcPhoto)                                |
      ((pL_SelRect + sW_SelRect) > (pL_SrcPhoto + sW_SrcPhoto)) |
      ((pT_SelRect + sH_SelRect) > (pT_SrcPhoto + sH_SrcPhoto)) THEN
    pL_SelRect:=GetCropCoord(pL_SrcPhoto, sW_SrcPhoto, sW_SelRect);
    pT_SelRect:=GetCropCoord(pT_SrcPhoto, sH_SrcPhoto, sH_SelRect);
   END;

   L_GUI.upd_Rectangle_Select_Tool(dlg, id_SelRect, pL_SelRect, pT_SelRect, sW_SelRect, sH_SelRect);
  END;
  dlg.Redraw();
 END {ShowPhoto};

 PRIVATE PROCEDURE CreateDialog();
 BEGIN
  PROMPT("⮢ 㠫 ꥪ⮢");
  dlg                 :=L_GUI.CreateDialog(~PhotoStudioDemoMode);
  dlg.CaptionText     :=L_General.GetAPSiteID() + ' - "⮏" 㤨';
  dlg.ShowMouseCursor :=~!wTouchScreen;
  dlg.WindowSizeStatus:=DIALOG.WindowSizeStatus_Maximized;
  dlg.OnClose         :=PROCREF(OnClose_Dialog);
  CreateMainPage();
  dlg.Prompt          :=dlg.Controls.Item(id_Prompt);
 END {CreateDialog};

 PRIVATE PROCEDURE UpdateClock();
 BEGIN
  dlg.Controls.Item(id_Clock).Text:=L_DatTim.CompleteSystimeStr();
  dlg.Controls.Item(id_Clock).Redraw();
 END {UpdateClock};

 PRIVATE PROCEDURE SecondsLeft(prvHRT: FLOAT): NUMERIC[3];
 BEGIN
  RETURN HIGH_RESOLUTION_TIMER() - prvHRT;
 END {SecondsLeft};

 PRIVATE PROCEDURE idleProc();
 BEGIN
  IF SecondsLeft(HRT_Renew) >= refreshCycle_Renew THEN
   UpdateClock();
   HRT_Renew:=HIGH_RESOLUTION_TIMER();
  END;
 END {idleProc};

 PRIVATE PROCEDURE PrintAndCreatePass();
 BEGIN
  IF PrintPassAlowed() THEN
   PROMPT(" 㤮⮢७...");
   CALL(O_Staff.MakePassTemplate());
  END;
  IF ProximityCardReaderInstalled() | (cs_Mode = csm_Debug) THEN
   PROMPT("뤠 ....");
   CALL(Staff.CreateProximityCard());
  END;
 END {PrintAndCreatePass};

 PRIVATE PROCEDURE PlayDialog();
  VAR
   srcFileName  : STRING[];
   NeedMakePhoto: SCAL[2];
 BEGIN
  PrintAndCreatePassAfterExit:=0;
  HRT_Renew:=0;
  ShowMainPage();
  dlg.Visible:=1;
  dlg.Redraw();
  TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
   OnClick_GetPhoto(dlg.Controls.Item(id_GetPhoto));
  EXCEPT
  ON Exc: Exc_Root DO
   L_GUI.Error(dlg, Exc.MsgOriginalText);
  END;

  WHILE dlg.Visible DO
   PROMPT("");
   idleProc();
   TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    dlg.Wait(0.5);
   EXCEPT
   ON Exc: Exc_Root DO
    L_GUI.Error(dlg, Exc.MsgOriginalText);
   END;
  END; (* WHILE dlg.Visible *)

  IF PrintAndCreatePassAfterExit THEN
   PrintAndCreatePass();
  END;
 END {PlayDialog};

 PRIVATE PROCEDURE HasAcceptableGUID(Formats: OBJECT;
                             GUID   : STRING[]): SCAL[2];
  VAR
   i         : NUMERIC[0];
   SingleGUID: STRING[];
 BEGIN
  i:=1;
  WHILE i <= Formats.Count DO
   SingleGUID:=Formats.Item(i);
   IF SingleGUID = GUID THEN
    RETURN 1;
   END;
   INC(i);
  END;
  RETURN 0;
 END {HasAcceptableGUID};

 PRIVATE PROCEDURE GetCropCoord(begCoord, PhotoSize, CropSize: NUMERIC[0]): FLOAT;
 BEGIN
  RETURN begCoord + PhotoSize / 2 - CropSize / 2;
 END {GetCropCoord};

 PRIVATE PROCEDURE GetFileName(): STRING[];
 BEGIN
  RETURN Man.Name                  + "_" +
         FLDTOSTR(Man.Man, "0", 5) + "_" +
         FLDTOSTR(SYSDATE(), "yND");
 END {GetFileName};

 PRIVATE PROCEDURE SetupCamShowModeOnOurSite();
  VAR
   Dummy: NUMERIC[0];
 BEGIN
  IF L_General.IsOurEngineeringCopy() THEN
   cs_Mode:=csm_Debug;
   STDFORM("|"+
           "稥 ன⢠  祭 ࠦ" +
           "|" +
           "|%33,2< 祭     |                >O|||" +
           "%<     ⬥     >X        %<         >DB",
           "  㤨 ",
           INFORM,
           1,
           cs_Mode);
  ELSE
   cs_Mode:=csm_Normal;
  END;
 END {SetupCamShowModeOnOurSite};

 PRIVATE PROCEDURE GetPhotoCameraName(Id: STRING[]): STRING[];
  VAR
   DeviceManager: OBJECT;
   Result       : STRING[];
   i            : NUMERIC[0];
 BEGIN
  SETEMPTY(Result);
  i:=1;
  DeviceManager:=CreateOBJECT("Wia.DeviceManager");
  WHILE (i <= DeviceManager.DeviceInfos.Count) & !Result DO
   IF DeviceManager.DeviceInfos.Item(i).DeviceID = Id THEN
    Result:=DeviceManager.DeviceInfos(i).Properties("Name").Value;
   END;
   INC(i);
  END;
  RETURN Result;
 END {GetPhotoCameraName};

 PRIVATE PROCEDURE InitDevice(): OBJECT;
  VAR
   VideoDevice    : OBJECT;
   PhotoCameraId,
   PhotoCameraName: STRING[];
 BEGIN
  SetupCamShowModeOnOurSite();
  UseIPCamera:=L_SpcEq.IsInstalled(L_SpcEq.et_IPCamera);

  SETEMPTY(VideoDevice);
  IF cs_Mode = csm_Normal THEN
   PhotoCameraId  :=L_SpcEq.GetSpcEqValue(L_SpcEq.et_StreamVideo);
   PhotoCameraName:=GetPhotoCameraName(PhotoCameraId);
   IF ~UseIPCamera & ~L_SpcEq.IsInstalled(L_SpcEq.et_StreamVideo) THEN
    L_SpcEq.Setup();
   ELSIF !PhotoCameraName THEN
    L_SpcEq.Setup();
    PhotoCameraId  :=L_SpcEq.GetSpcEqValue(L_SpcEq.et_StreamVideo);
    PhotoCameraName:=GetPhotoCameraName(PhotoCameraId);
   END;
   IsCanonEOS:=Str.Pos(Str.Cap(PhotoCameraName), Str.Cap("CANON EOS")) # Str.Length(PhotoCameraName);
   IF IsCanonEOS THEN
    VideoDevice:=CANON_EOS_PHOTO_CAMERA.Get();
   ELSIF L_WIA.WindowsVersionSupportedPhotography() THEN
    VideoDevice:=L_WIA.ConnectDevice(PhotoCameraId);
   ELSE
    L_General.Error("  " + L_General.GetOSName() + "|室 稥   Canon EOS");
   END;
   L_General.Assert(~!VideoDevice, "  樠஢.");
  END;
  RETURN VideoDevice;
 END {InitDevice};

 PRIVATE PROCEDURE SaveResult();
  VAR
   FileName,
   tmpFileName,
   FullFileName: STRING[];
 BEGIN
  tmpFileName:=GetTmpFileName("");
  IF FIO.Exists(tmpFileName) THEN
   FileName:=FIO.BuildPath(GetFileName(), "JPG");
   L_General.CallUs(ACCESS(Man));
   TRY [TRANSACTION(TRANSACTION_SLAVE)]
    P_Man.InsertProperty_woDoc(Man.Man, SYSDATE(), P_Man.P_ManPhoto, FileName, 1);
   EXCEPT
   END;
   FullFileName:=P_Man.GetFullPhotoFileName(FileName);
   IF FIO.Exists(FullFileName) THEN
    FIO.Erase(FullFileName);
   END;
   L_FIO.ExactFileCopy(GetTmpFileName(""), FullFileName);
   L_SES.PutValueAtCurTrn(L_SES.sit_User, si_CropWidth, FLDTOSTR((dlg.Controls.Item(id_SelRect).Rect.Right-dlg.Controls.Item(id_SelRect).Rect.Left), "0"));
   L_SES.PutValueAtCurTrn(L_SES.sit_User, si_CropX,     FLDTOSTR(dlg.Controls.Item(id_SelRect).Rect.Left, "0"));
   L_SES.PutValueAtCurTrn(L_SES.sit_User, si_CropY,     FLDTOSTR(dlg.Controls.Item(id_SelRect).Rect.Top, "0"));
  ELSE
   L_General.Error(" ⮢ ⮣䨨  ࠭");
  END;
 END {SaveResult};

 PRIVATE PROCEDURE OnClose_Dialog(d: DIALOG);
 BEGIN
  L_GUI.SetTaskBarVisible(1);
  d.Visible:=0;
 END {OnClose_Dialog};

 PRIVATE PROCEDURE OnClick_GetPhoto(Self: OBJECT);
  VAR
   srcFileName: STRING[];
 BEGIN
  srcFileName:=MakePhoto(VideoDevice);
  ShowPhoto(srcFileName, "");
  ShowPhoto(""         , CropPhoto(srcFileName));
 END {OnClick_GetPhoto};

 PRIVATE PROCEDURE OnClick_SaveAndExit(Self: OBJECT);
 BEGIN
  SaveResult();
  OnClose_Dialog(dlg);
 END {OnClick_SaveAndExit};

 PRIVATE PROCEDURE OnClick_SaveAndPrint(Self: OBJECT);
 BEGIN
  SaveResult();
  OnClose_Dialog(dlg);
  dlg.Redraw();
  PrintAndCreatePassAfterExit:=1;
 END {OnClick_SaveAndPrint};

 PRIVATE PROCEDURE OnClick_NoSaveAndExit(Self: OBJECT);
 BEGIN
  OnClose_Dialog(dlg);
 END {OnClick_NoSaveAndExit};

 PRIVATE PROCEDURE OnUserChangesRect_SelRect(Self: OBJECT);
 BEGIN
  IF ~!dlg.Controls.Item(id_SrcPhoto).Picture THEN
   ShowPhoto("", CropPhoto(GetTmpFileName("_Src")));
  END;
 END {OnUserChangesRect_SelRect};

 PRIVATE PROCEDURE IsPhotoAlreadyExist(): SCAL[2];
 BEGIN
  RETURN FIO.Exists(GetManPhotoFullFileName(1));
 END {IsPhotoAlreadyExist};

 PRIVATE PROCEDURE SetupModeOnOurSite();
  VAR
   Timer   : NUMERIC[0];
   btnTest,
   btnTS   : STRING[];
 BEGIN
  Timer:=5;
  IF L_General.IsProgrammer() THEN
   btnTest:="%<  ⫠   %T >DB";
   btnTS  :="%< 稩 ० >B";
  ELSE
   btnTest:="%<  ⫠   %T >B";
   btnTS  :="%< 稩 ० >DB";
  END;
  IF STDFORM("|"+
             btnTest + " " + btnTS + " %<     ⬥     >X",
             "   㤨 ",
             INFORM,
             1,
             Timer) = 1 THEN
   PhotoStudioDemoMode:=1;
   wTouchScreen       :=0;
  END;
 END {SetupModeOnOurSite};

 PRIVATE PROCEDURE SetPhotoStudioSettings();
 BEGIN
  PhotoStudioDemoMode:=~L_General.IsEndUser();
  wTouchScreen       :=~PhotoStudioDemoMode;
  IF MONITORS.Create().Count = 1 THEN
   IF L_General.IsOurSite() & wTouchScreen THEN
    SetupModeOnOurSite();
   END;
  END;
 END {SetPhotoStudioSettings};

 PRIVATE PROCEDURE CheckPhotoFolderExists();
  VAR
   FolderName: STRING[];
 BEGIN
  FolderName  :=L_FIO.effp_Folder(P_Man.GetFullPhotoFileName("Test.tst"));
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   L_FIO.MakeSubDirs(FolderName);
  EXCEPT
  ON Exc: Exc_Root DO
  END; (* TRY *)
  L_General.Assert(FIO.DirExists(FolderName),
                   " ⠫  ࠭ ⮣䨩|" +
                   FolderName);
 END {CheckPhotoFolderExists};

 PUBLIC PROCEDURE phs();
 BEGIN
  L_General.Assert(L_WIA.AcceptableWindowsVersion(),
                   " 믮  樨 ॡ    Windows XP SP1");
  CheckPhotoFolderExists();
  IF L_WIA.IsWIAInstalled(1) THEN
   Rotator:=CreateOBJECT("Wia.ImageProcess");
   Rotator.Filters.Add(Rotator.FilterInfos("RotateFlip").FilterID);
   IF    L_SpcEq.GetSpcEqValue(L_SpcEq.et_CameraImageOrientation) = "1" THEN
    Angle:=270;
   ELSIF L_SpcEq.GetSpcEqValue(L_SpcEq.et_CameraImageOrientation) = "2" THEN
    Angle:=90;
   ELSE
    Angle:=0;
   END;
 
   Rotator.Filters(1).Properties("RotationAngle").Value:=Angle;
   ToJPEG:=CreateOBJECT("Wia.ImageProcess");
   ToJPEG.Filters.Add(Rotator.FilterInfos("Convert").FilterID);
   ToJPEG.Filters(1).Properties("FormatID").Value := L_WIA.if_JPEG;
 
   VideoDevice:=InitDevice();
 
   wStaff:=L_Man.InteractiveAccessStaffByMan(1);
   IF IsPhotoAlreadyExist() THEN
    L_StdFrm.Choice(" 㦥 ⮣஢");
   END;
 
   SetPhotoStudioSettings();
   CreateDialog();
   PlayDialog();
  END; (* IF L_WIA.IsWIAInstalled(1) ... *)
 END {phs};

END.
