(*
%Copyright   (c) Polak IT
%Author      26.07.2006 17:33:44 POLAK\San
%Purpose     :  㤮 樯
%Type        report
%Specific    SYS
%Modified    28.10.2013 16:27:08 POLAK\LDA
%Environment
*)

 MODULE Prc03 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, FIO, L_Basis, L_AFM, Memo, L_Str, L_StdFrm, P_Firm,
        L_Staff, L_ACS, Math, L_Sheet, L_PRoll, P_Staff, P_Man, L_Env, L_OwnData,
        L_BegRWS, L_EDO, P_EDOL, DBD, L_bp, P_OwnData;

 PRIVATE TYPE
  tDeltaType  = SCAL[5];
  tSchdlType  = SCAL[9];
  tDayType    = SCAL[3];
  tEventState = SCAL[6];

 PRIVATE CONST
  ev_Enter   = 2;
  ev_Exit    = 3;

  ek_Pool = "饥|⬥⪠";

  es_BegWork           = 0;
  es_EndWork           = 1;
  es_IntermediateEnter = 2;
  es_IntermediateExit  = 3;
  es_AbsenceEnter      = 4;
  es_AbsenceExit       = 5;

  es_Pool = "砫 ࠡ|砭 ࠡ|室: ஬|室: ஬|室:  ⬥⪨|室:  ⬥⪨";

  ec_Intermediate = 0;
  ec_Primary      = 1;
  ec_Absence      = 2;

  ec_Pool = "஬筮|᭮|";

  daytyp_Work       = 0;
  daytyp_Relaxation = 1;
  daytyp_Absence    = 2;

  daytyp_Pool = "稩|室|⢨";

  st_None         = 0;
  st_AllMonth     = 1;
  st_EveryDay     = 2;
  st_Individual   = 3;
  st_UnNorm       = 4;
  st_OutOfControl = 5;

  st_Pool = " ⠭|  |   |㠫쭮|ନ஢ ࠡ稩 |஫㥬 ";

  deltatyp_Normal  = 0;
  deltatyp_Early   = 1;
  deltatyp_Delay   = 2;
  deltatyp_Absence = 3;
  deltatyp_Unknown = 4;

  deltatyp_Pool = " | 室||⢨|???";

  maxInterrupts = 3;

 PRIVATE VAR
  wMF    : SCAL[2];

 PRIVATE PROCEDURE CreateFiles();
 BEGIN
  CreateFILE(ACSE, "", " ", "");

  CreateFIELD(ACSE, ACSE,     LIKE(ACSEvent.ACSEvent), "", "", "", "Id ᮡ", "");
  CreateFIELD(ACSE, CardCode, LIKE(ACSEvent.CardCode), "", "", "", " ", "");
  CreateFIELD(ACSE, Date,     DATE,                    "", "", "", "", "");
  CreateFIELD(ACSE, Time,     TIME,                    "", "", "", "६", "");
  CreateFIELD(ACSE, DTS,      FLOAT,                   "", "", "", "६ ⠬", "");
  CreateFIELD(ACSE, Event,    LIKE(ACSEvent.Event),    "", "", "", "⨥", "");
  CreateFIELD(ACSE, Man,      LIKE(Man.Man),           "", "", "", "", "");

  CreateINDEX       (ACSE, ACSE,     UNIQUE,                    "", "", ACSE);
  CreateINDEX       (ACSE, CardCode, PLURAL,                    "", "", CardCode, Date, Time);
  CreateINDEX       (ACSE, Date,     PLURAL,                    "", "", Date, Time);
  CreateINDEXandLINK(ACSE, Man,      PLURAL, Man,  Man,  USER,  "", "", Man, Date, Time);
  CreateINDEX       (ACSE, ManDTS,   PLURAL,                    "", "", Man, DTS);

  SetVersionOfFILE(ACSE, 0004);
  L_AFM.AF_CreateTemp("ACSE", "ACSE");


  CreateFILE(TPass, "", " ", "");

  CreateFIELD(TPass, MyFirm,   P_Firm.tMyFirm,            "", "", "", "", "");
  CreateFIELD(TPass, TSN,      LIKE(Staff.TSN),           "", "", "", "", "");
  CreateFIELD(TPass, Man,      LIKE(Man.Man),             "", "", "", "", "");
  CreateFIELD(TPass, Sort,     LIKE(Sort.Sort),           "", "", "", "", "");
  CreateFIELD(TPass, Officer,  LIKE(Officer.Officer),     "", "", "", "祥 ", "");
  CreateFIELD(TPass, Regime,   LIKE(RegMain.Regime),      "", "", "", "", "");
  CreateFIELD(TPass, DayType,  tDayType,                  "", "", "", " ", "");
  CreateFIELD(TPass, SchdlTyp, tSchdlType,                "", "", "", " ᯨᠭ", "");
  CreateFIELD(TPass, EventDTS, FLOAT,                     "", "", "", "६ ᮡ", "");
  CreateFIELD(TPass, Date,     DATE,                      "", "", "", " 砫 ᬥ", "");
  CreateFIELD(TPass, EventD,   DATE,                      "", "", "", " ᮡ", "");
  CreateFIELD(TPass, SchdlDTS, FLOAT,                     "", "", "", "६ ᮡ  ᯨᠭ", "");
  CreateFIELD(TPass, Event,    LIKE(ACSEvent.Event),      "", "", "", "⨥", "");
  CreateFIELD(TPass, EventCls, SCAL[3],                   "", "", "", "䨪 ᮡ", "");
  CreateFIELD(TPass, EventSt,  tEventState,               "", "", "", "䨪 ᮡ", "");
  CreateFIELD(TPass, wrkTim,   NUMERIC[3],                "", "", "", "६ 宦  ।⨨", "");
  CreateFIELD(TPass, DeltaTyp, tDeltaType,                "", "", "", " ⪫", "");
  CreateFIELD(TPass, Delta,    NUMERIC[0],                "", "", "", "⪫  ᯨᠭ", "");

  CreateINDEX       (TPass, Event,    PLURAL,             "", "", Man, Date, EventSt);
  CreateINDEX       (TPass, TSN,      PLURAL,             "", "", MyFirm, TSN, EventDTS);
  CreateINDEX       (TPass, DTSN,     PLURAL,             "", "", MyFirm, TSN, EventD, EventDTS);

  SetVersionOfFILE(TPass, 0002);
  L_AFM.AF_CreateTemp("TPass", "TPass");
 END {CreateFiles};

 PRIVATE PROCEDURE Pump_RegEvents(_Man: LIKE(Man.Man); _From, _UpTo: DATE; trgACSSite: STRING[]);
 BEGIN
  CreateFiles();
  IF !_Man THEN
   SELECT(ACSEvent, Date);
  ELSE
   SELECT(ACSEvent, Man, , _Man);
  END;
  SRCINSEL(ACSEvent, GE, , _From);
  WHILE OCCURE(ACSEvent) & (ACSEvent.Date <= (_UpTo + 1)) DO
   IF (ACSEvent.Event = ev_Enter) | (ACSEvent.Event = ev_Exit) THEN
    PROMPT(" " + ACSEvent.ACSEvent);
    IF !trgACSSite | (P_OwnData.GetACSSiteByOutpost(ACSEvent.Outpost) = trgACSSite) THEN
     ACSE.ACSE    :=ACSEvent.ACSEvent;
     ACSE.CardCode:=ACSEvent.CardCode;
     ACSE.Date    :=ACSEvent.Date;
     ACSE.Time    :=ACSEvent.Time;
     ACSE.DTS     :=ACSEvent.DTS;
     ACSE.Event   :=ACSEvent.Event;
     ACSE.Man     :=ACSEvent.Man;
     INSERT(ACSE);
    END;
   END;
   NEXT(ACSEvent);
  END; (* WHILE OCCURE(ACSEvent) ... *)
 END {Pump_RegEvents};

 PRIVATE PROCEDURE Prc03_MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ᯨᠭ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६ ᮡ");
  L_Basis.wb_WrInQM(F, "६  ᯨᠭ");
  L_Basis.wb_WrInQM(F, " ⪫");
  L_Basis.wb_WrInQM(F, "⪫  ᯨᠭ");
  L_Basis.wb_WrInQM(F, "⨥");
  L_Basis.wb_WrInQM(F, " ᮡ");
  L_Basis.wb_WrInQM(F, "䨪 ᮡ");
(*
  L_Basis.wb_WrInQM(F, "६  ।⨨");
*)
  L_Basis.wb_TermLine(F);
 END {Prc03_MakeHeader};

 PRIVATE PROCEDURE IsRealEvent(): SCAL[2];
 BEGIN
  RETURN (TPass.EventSt # es_AbsenceEnter) & (TPass.EventSt # es_AbsenceExit);
 END {IsRealEvent};

 PRIVATE PROCEDURE Prc03_MakeLine(F: STRING[]);
  VAR
   D    : DATE;
   T    : TIME;
   S    : SCAL[60];
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.Name);
  END;
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrScl(F, L_Staff.getService());
  L_Basis.wb_WrStr(F, L_Staff.getServiceName());
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrScl(F, RegMain.Regime);
  L_Basis.wb_WrStr(F, RegMain.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(st_Pool, TPass.SchdlTyp));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(daytyp_Pool, TPass.DayType));
  UnPkVARIANTDATE(TPass.EventDTS, D, T, S);
  L_Basis.wb_WrDat(F, D);
  L_Basis.wb_WrLongTim(F, T, S);
  IF ~!TPass.SchdlDTS THEN
   UnPkVARIANTDATE(TPass.SchdlDTS, D, T, S);
   L_Basis.wb_WrLongTim(F, T, S);
  ELSE
   L_Basis.wb_WrStr(F, "---");
  END;
  IF TPass.DeltaTyp = deltatyp_Normal THEN
   L_Basis.wb_WrStr(F, "---");
  ELSE
   L_Basis.wb_WrStr(F, L_Str.PoolItem(deltatyp_Pool, TPass.DeltaTyp));
  END;
  L_Basis.wb_WrNum(F, TPass.Delta, 0);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_ACS.EventTypPool, TPass.Event));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(ek_Pool, IsRealEvent()));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(ec_Pool, TPass.EventCls));

(*
  L_Basis.wb_WrNum(F, TPass.wrkTim, 3);
*)
  L_Basis.wb_TermLine(F);
 END {Prc03_MakeLine};

 PRIVATE PROCEDURE Prc03_Print(_From, _UpTo: DATE);
 BEGIN
  wMF:=P_Firm.E_wMultipleMyFirm(_UpTo);
  Prc03_MakeHeader("F");

  SELECT(TPass, DTSN);
  WHILE OCCURE(TPass) DO
   NARROWSEL(TPass, MyFirm, TSN);
   WHILE OCCURE(TPass) & (TPass.EventD <= (_UpTo+1)) DO
    NARROWSEL(TPass, EventD);
    WHILE OCCURE(TPass) DO
     PROMPT(" " + TPass.MyFirm + " " + TPass.TSN + " " + L_DatTim.DateStr(TPass.EventD));
     P_Firm.PositionOnMyFirm(TPass.MyFirm);
     SEARCH(Officer, Sort, , TPass.Sort, TPass.Officer);
     CONFORM(Officer, Sort);
     CONFORM(Officer, Union);
     CONFORM(Officer, Post);
     SEARCH(Man,     Man, ,     TPass.Man);
     SEARCH(Staff,   TSN, ,     TPass.TSN);
     SEARCH(RegMain, HumReg, ,  TPass.Regime);
     Prc03_MakeLine("F");
     NEXT(TPass);
    END; (* WHILE OCCURE(TPass) ... *)
    NEXTINEXTENDEDSEL(TPass, EventD);
   END; (* WHILE OCCURE(TPass) ... *)
   NEXTINEXTENDEDSEL(TPass, MyFirm, TSN);
  END; (* WHILE OCCURE(TPass) ... *)
 END {Prc03_Print};

 PRIVATE PROCEDURE HasRealSchedule(_DayType: tDayType; _SchdlType: tSchdlType): SCAL[2];
 BEGIN
  RETURN (_DayType = daytyp_Work) & (_SchdlType # st_None) & (_SchdlType # st_UnNorm) & (_SchdlType # st_OutOfControl);
 END {HasRealSchedule};

 PRIVATE PROCEDURE FillTPass(D         : DATE;
                             _DayType  : tDayType;
                             _SchdlType: tSchdlType;
                             _SchdlDTS,
                             _EventDTS : FLOAT;
                             _Event    : LIKE(ACSEvent.Event);
                             EventState: tEventState;
                             _wrkTim   : NUMERIC[3];
                             _DeltaTyp : tDeltaType;
                             _Delta    : FLOAT;
                             _EventCls : SCAL[3]);
 BEGIN
  TPass.MyFirm  :=Staff.MyFirm;
  TPass.TSN     :=Staff.TSN;
  TPass.Man     :=Man.Man;
  TPass.Sort    :=Officer.Sort;
  TPass.Officer :=Officer.Officer;
  TPass.Regime  :=RegMain.Regime;
  TPass.SchdlTyp:=_SchdlType;
  TPass.DayType :=_DayType;
  TPass.EventD  :=L_DatTim.GetDateOfVARIANTDATE(_EventDTS);
  TPass.EventDTS:=_EventDTS;
  TPass.Date    :=D;
  IF HasRealSchedule(_DayType, _SchdlType) THEN
   TPass.SchdlDTS:=_SchdlDTS;
  ELSE
   SETEMPTY(TPass.SchdlDTS);
  END;
  TPass.Event   :=_Event;
  TPass.EventSt :=EventState;
  TPass.wrkTim  :=_wrkTim;
  TPass.Delta   :=_Delta * 24 * 60;
  IF    !_DeltaTyp THEN
   IF    ~IsRealEvent() THEN
    _DeltaTyp:=deltatyp_Unknown;
   ELSIF _Event = ev_Enter THEN
    IF TPass.Delta <= 0 THEN
     _DeltaTyp:=deltatyp_Normal;
    ELSE
     _DeltaTyp:=deltatyp_Delay;
    END;
   ELSIF _Event = ev_Exit THEN
    IF TPass.Delta <= 0 THEN
     _DeltaTyp:=deltatyp_Normal;
    ELSE
     _DeltaTyp:=deltatyp_Early;
    END;
   END;
  END;

  TPass.DeltaTyp:=_DeltaTyp;
  TPass.EventCls:=_EventCls;
  INSERT(TPass);
 END {FillTPass};

 PRIVATE PROCEDURE HasRegimeAlteration(D: DATE): SCAL[2];
 BEGIN
  SELECT(EDOrderL, TSNGrOD, , Staff.TSN, L_EDO.grp_RegimeAlteration);
  SRCINSEL(EDOrderL, LE, , D);
  WHILE OCCURE(EDOrderL) DO
   IF (EDOrderL.Status = L_EDO.st_Passed) & (EDOrderL.EndDate >= D) THEN
    RETURN 1;
   END;
   PREV(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
  RETURN 0;
 END {HasRegimeAlteration};

 PRIVATE PROCEDURE IsOutOfControlPerson(): SCAL[2];
 BEGIN
  IF DBD.BaseName() = "SP" THEN
   RETURN (StaffLog.Sort = 031) |
          (StaffLog.Sort = 075) |
          (StaffLog.Sort = 076) |
          (StaffLog.Sort = 089) |
          (StaffLog.Sort = 093) |
          (StaffLog.Sort = 113) |
          (StaffLog.Sort = 030) |
          ((StaffLog.Sort = 023) & (StaffLog.Officer = 010));
  ELSE
   RETURN 0;
  END;
 END {IsOutOfControlPerson};

 PRIVATE PROCEDURE GetShiftDayParams(    D               : DATE;
                                     VAR _DayType        : tDayType;
                                     VAR _SchdlType      : tSchdlType;
                                     VAR BegTime, EndTime: TIME;
                                     VAR DnrBegT, DnrEndT: TIME[]);
  VAR
   _Regime: LIKE(RegMain.Regime);
   dummy  : SCAL[2];
 BEGIN
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  CONFORM(StaffLog, Officer, Post, Sort, Union);

  IF ~L_BegRWS.AccessDayTypeByRegime(Staff.TSN, D) THEN
   CONFORM(StaffLog, RegMain);
   L_General.Assert(SEARCH(RegList, HumReg, RegMain.Regime, L_DatTim.Per(D), L_DatTim.DAY(D)),
                    " ࠡ " + RegMain.Regime + "    " + L_DatTim.DateStr(D));
  ELSE
   CONFORM(RegList, RegMain);
  END;

  SETEMPTY(BegTime, EndTime, DnrBegT, DnrEndT);

  IF HasRegimeAlteration(D) THEN
   dummy:=P_EDOL.GetRegimeTimes(BegTime, EndTime, DnrBegT, DnrEndT);
   _SchdlType:=st_Individual;
  ELSE
   SEARCH(RegHead, HumReg, , RegList.Regime, L_DatTim.Per(D));
   IF    RegHead.ShdlType # L_PRoll.rgs_None THEN
    L_PRoll.FillShedule(RegHead.ShdlType, BegTime, EndTime, DnrBegT, DnrEndT);
    _SchdlType:=RegHead.ShdlType;
   ELSE
    CONFORM(Officer, AlType);
    HISTCONF(D, AlType, AlTypeL);
    IF AlTypeL.Duration[L_Staff.ati_UnNorm] > 0 THEN
     _SchdlType:=st_UnNorm;
    ELSE
     _SchdlType:=st_None;
    END;
   END;
  END;

  IF IsOutOfControlPerson() THEN
   _SchdlType:=st_OutOfControl;
  END;

  IF SEARCH(Sheet, TSN, Staff.TSN, L_DatTim.Per(D), L_DatTim.DAY(D)) & (Sheet.JMode # L_Sheet.jm_RatherEarly(D)) THEN
   CONFORM(Sheet, JMode);
  ELSE
   CONFORM(RegList, JMode);
  END;

  IF    JMode.Type = L_Sheet.jmType_TimDone THEN
   _DayType:=daytyp_Work;
  ELSIF JMode.Type = L_Sheet.jmType_HolTime THEN
   _DayType:=daytyp_Relaxation;
  ELSE
   _DayType:=daytyp_Absence;
  END;
 END {GetShiftDayParams};

 PRIVATE PROCEDURE FillShiftParams(    D                     : DATE;
                                   VAR _DayType              : tDayType;
                                   VAR _SchdlType            : tSchdlType;
                                   VAR cs_begDTS,  cs_endDTS : FLOAT;
                                   VAR dnr_begDTS, dnr_endDTS: FLOAT[];
                                   VAR Shift                 : NUMERIC[3]);
  VAR
   prvDayType      : tDayType;
   prvSchdlType    : tSchdlType;
   i, j            : NUMERIC[0];
   BegTime, EndTime: TIME;
   DnrBegT, DnrEndT: TIME[maxInterrupts];
   IsDnrEndInPrvDay: SCAL[2];
 BEGIN
  GetShiftDayParams(D, _DayType, _SchdlType, BegTime, EndTime, DnrBegT, DnrEndT);
  IF (_DayType = daytyp_Work) & ~!BegTime THEN
   cs_begDTS:=L_DatTim.GetVARIANTDATE(D,                       BegTime, 00);
   cs_endDTS:=L_DatTim.GetVARIANTDATE(D + (BegTime > EndTime), EndTime, 00);

   SETZERO(i, j, IsDnrEndInPrvDay);
   WHILE j <= HIGH(DnrBegT) DO
    IF ~!DnrBegT[j] THEN
     IF i = 0 THEN
      dnr_begDTS[i]:=L_DatTim.GetVARIANTDATE(D + (BegTime > DnrBegT[j]), DnrBegT[j], 00);
     ELSE
      dnr_begDTS[i]:=L_DatTim.GetVARIANTDATE(D + IsDnrEndInPrvDay,       DnrBegT[j], 00);
     END;
     dnr_endDTS[i]:=L_DatTim.GetVARIANTDATE(L_DatTim.GetDateOfVARIANTDATE(dnr_begDTS[i]) + (IsDnrEndInPrvDay | (DnrBegT[j] > DnrEndT[j])), DnrEndT[j], 00);
     INC(i);
     IF j > 0 THEN
      IsDnrEndInPrvDay:=DnrBegT[j] < DnrEndT[j-1];
     END;
    END;
    INC(j);
   END;
   Shift:=5/24;
  ELSE
   cs_begDTS:=L_DatTim.GetVARIANTDATE(D,                       00:00, 00);
   cs_endDTS:=L_DatTim.GetVARIANTDATE(D,                       23:59, 00);
   Shift:=0;
  END;
 END {FillShiftParams};

 PRIVATE PROCEDURE GetShiftACSE(cs_begDTS, cs_endDTS: FLOAT; VAR begACSE, endACSE: LIKE(ACSEvent.ACSEvent); Shift: FLOAT);
 BEGIN
  SETEMPTY(begACSE);
  SAVE(ACSE);
  SRCINSEL(ACSE, GE, , cs_begDTS-Shift);
  WHILE OCCURE(ACSE) & !begACSE & (ACSE.DTS <= (cs_endDTS+Shift)) DO
   IF (ACSE.Event = ev_Enter) & (ACSE.DTS >= (cs_begDTS-Shift)) THEN
    begACSE:=ACSE.ACSE;
   END;
   NEXT(ACSE);
  END; (* WHILE OCCURE(ACSE)... *)
  RESTORE(ACSE);

  SETEMPTY(endACSE);
  SAVE(ACSE);
  SRCINSEL(ACSE, LE, , cs_endDTS + Shift);
  WHILE OCCURE(ACSE) & !endACSE & (ACSE.DTS >= (cs_begDTS-Shift)) DO
   IF (ACSE.Event = ev_Exit) & (ACSE.DTS >= (cs_begDTS-Shift)) THEN
    endACSE:=ACSE.ACSE;
   END;
   PREV(ACSE);
  END; (* WHILE OCCURE(ACSE)... *)
  RESTORE(ACSE);
  IF ~!begACSE & ~!endACSE & (begACSE > endACSE) THEN
   SETEMPTY(endACSE);
  END;
 END {GetShiftACSE};

 PRIVATE PROCEDURE IsNearestBegDnrlEnter(begDTS, endDTS, endShiftDTS: FLOAT): SCAL[2];
  VAR
   _ACSE: LIKE(ACSEvent.ACSEvent);
 BEGIN
  SETEMPTY(_ACSE);
  SAVE(ACSE);
  IF  (SRCINSEL(ACSE, LE, endDTS) & (ACSE.DTS >= begDTS)      & (ACSE.Event = ev_Enter)) |
      (SRCINSEL(ACSE, GE, endDTS) & (ACSE.DTS <= endShiftDTS) & (ACSE.Event = ev_Enter)) THEN
   _ACSE:=ACSE.ACSE;
  END;
  RESTORE(ACSE);
  RETURN ACSE.ACSE = _ACSE;
 END {IsNearestBegDnrlEnter};

 PRIVATE PROCEDURE IsNearestEndDnrExit(begDTS, endDTS, begShiftDTS: FLOAT): SCAL[2];
  VAR
   _ACSE: LIKE(ACSEvent.ACSEvent);
 BEGIN
  SETEMPTY(_ACSE);
  SAVE(ACSE);
  IF  (SRCINSEL(ACSE, LE, begDTS) & (ACSE.DTS >= begShiftDTS) & (ACSE.Event = ev_Exit)) |
      (SRCINSEL(ACSE, GE, begDTS) & (ACSE.DTS <= endDTS)      & (ACSE.Event = ev_Exit)) THEN
   _ACSE:=ACSE.ACSE;
  END;
  RESTORE(ACSE);
  RETURN ACSE.ACSE = _ACSE;
 END {IsNearestEndDnrExit};

 PRIVATE PROCEDURE ConvEvent2EventState(_EventCls: SCAL[3]; _Event: LIKE(ACSEvent.Event)): tEventState;
 BEGIN
  IF    _EventCls = ec_Primary THEN
   IF _Event = ev_Enter THEN
    RETURN es_BegWork;
   ELSE
    RETURN es_EndWork;
   END;
  ELSIF _EventCls = ec_Intermediate THEN
   IF _Event = ev_Enter THEN
    RETURN es_IntermediateEnter;
   ELSE
    RETURN es_IntermediateExit;
   END;
  ELSIF _EventCls = ec_Absence THEN
   IF _Event = ev_Enter THEN
    RETURN es_AbsenceEnter;
   ELSE
    RETURN es_AbsenceExit;
   END;
  END
 END {ConvEvent2EventState};

 PRIVATE PROCEDURE CalcDelta(_DayType: tDayType; _SchdlType: tSchdlType; _SchdlDTS, _EventDTS: FLOAT; _Event: LIKE(ACSEvent.Event)): FLOAT;
  VAR
   _Delta: FLOAT;
 BEGIN
  _Delta:=0;
  IF ~!_SchdlDTS & HasRealSchedule(_DayType, _SchdlType) THEN
   IF    _Event = ev_Enter THEN
    _Delta  :=_EventDTS - _SchdlDTS;
   ELSIF _Event = ev_Exit THEN
    _Delta  :=_SchdlDTS - _EventDTS;
   END;
  END;
  RETURN _Delta
 END {CalcDelta};

 PRIVATE PROCEDURE InsAbsentEvent(D: DATE; _DayType: tDayType; _SchdlType: tSchdlType; cs_begDTS, cs_endDTS: FLOAT; AbsenceEvent: LIKE(ACSEvent.Event); _DeltaTyp: tDeltaType; wCalcDelta: SCAL[2]; _EventCls: SCAL[3]);
  VAR
   _SchdlDTS,
   _EventDTS: FLOAT;
   _Delta   : FLOAT;
 BEGIN
  IF    _EventCls = ec_Primary THEN
   IF AbsenceEvent = ev_Enter THEN
    _EventDTS:=cs_begDTS;
   ELSE
    _EventDTS:=cs_endDTS;
   END;
   _SchdlDTS:=_EventDTS;
  ELSIF _EventCls = ec_Intermediate THEN
   _EventDTS:=ACSE.DTS - 1/24/60/60;
   SETEMPTY(_SchdlDTS);
  END;

  IF wCalcDelta & HasRealSchedule(_DayType, _SchdlType) THEN
   _Delta:=cs_endDTS - cs_begDTS;
  ELSE
   _Delta:=0;
  END;
 
  IF (_EventCls = ec_Intermediate) |
     ((_EventCls = ec_Primary) & ~SELECT(TPass, Event, Man.Man, D, ConvEvent2EventState(ec_Absence, AbsenceEvent))) THEN
    FillTPass(D, _DayType, _SchdlType, _SchdlDTS, _EventDTS, AbsenceEvent, ConvEvent2EventState(ec_Absence, AbsenceEvent), 0, _DeltaTyp, _Delta, _EventCls);
  END;
 END {InsAbsentEvent};

 PRIVATE PROCEDURE ProceedSingleMan(_From, _UpTo: DATE);
  VAR
   i                   : NUMERIC[0];
   D                   : DATE;
   Shift,
   tmp_DTS,
   EnterDTS,
   cs_begDTS,
   cs_endDTS           : FLOAT;
   dnr_begDTS,
   dnr_endDTS          : FLOAT[maxInterrupts];
   begACSE,
   endACSE,
   prvEvent            : LIKE(ACSEvent.ACSEvent);
   _wrkTim             : NUMERIC[3];
   _EventState         : tEventState;
   _SchdlType          : tSchdlType;
   _DayType            : tDayType;
   NoEnter,
   NoExit,
   FirstPass,
   NeedRenewShiftParams: SCAL[2];
   _DeltaTyp           : tDeltaType;
 BEGIN
  SETZERO(_wrkTim);
  NeedRenewShiftParams:=1;
  FirstPass           :=1;
  SETEMPTY(prvEvent);
  SELECT(ACSE, ManDTS, , Man.Man);
  WHILE OCCURE(ACSE) DO
   IF FirstPass | (ACSE.DTS > (cs_endDTS + Shift)) THEN
    NeedRenewShiftParams:=1;
    D                   :=ACSE.Date;
   END;
   PROMPT("஥  " + Staff.TSN + " " + L_DatTim.DateStr(D));

   IF NeedRenewShiftParams THEN
    SETEMPTY(_DayType, cs_begDTS, cs_endDTS, dnr_begDTS, dnr_endDTS);
    LOOP
     FillShiftParams(D, _DayType, _SchdlType, cs_begDTS, cs_endDTS, dnr_begDTS, dnr_endDTS, Shift);
     GetShiftACSE(cs_begDTS, cs_endDTS, begACSE, endACSE, Shift);

     IF _DayType = daytyp_Work THEN
      IF !begACSE & !endACSE THEN
       _DeltaTyp:=deltatyp_Absence;
      ELSE
       SETEMPTY(_DeltaTyp);
      END;
 
      IF !begACSE THEN
       InsAbsentEvent(D, _DayType, _SchdlType, cs_begDTS, cs_endDTS, ev_Enter, _DeltaTyp, 0,        ec_Primary);
      END;
      IF !endACSE THEN
       InsAbsentEvent(D, _DayType, _SchdlType, cs_begDTS, cs_endDTS, ev_Exit,  _DeltaTyp, !begACSE, ec_Primary);
      END;
     END;

     IF ~FirstPass | ~!begACSE | (D > _UpTo) THEN
      EXIT;
     END;

     INC(D);
    END; (* LOOP *)
    NeedRenewShiftParams:=0;
   END;
   SETEMPTY(_DeltaTyp);

   FirstPass:=0;
   _wrkTim  :=0;

(*
   IF ACSE.Event = ev_Enter THEN
    _wrkTim :=0;
    EnterDTS:=ACSE.DTS;
   ELSE
    IF ~!EnterDTS THEN
     _wrkTim:=(ACSE.DTS - EnterDTS) * 24;
     SETEMPTY(EnterDTS);
    END;
   END;
*)
   IF    ACSE.ACSE = begACSE THEN
    FillTPass(D, _DayType, _SchdlType, cs_begDTS, ACSE.DTS, ACSE.Event, ConvEvent2EventState(ec_Primary, ACSE.Event), 0,       _DeltaTyp, CalcDelta(_DayType, _SchdlType, cs_begDTS, ACSE.DTS, ACSE.Event), ec_Primary);
   ELSIF ACSE.ACSE = endACSE THEN
    FillTPass(D, _DayType, _SchdlType, cs_endDTS, ACSE.DTS, ACSE.Event, ConvEvent2EventState(ec_Primary, ACSE.Event), _wrkTim, _DeltaTyp, CalcDelta(_DayType, _SchdlType, cs_endDTS, ACSE.DTS, ACSE.Event), ec_Primary);
   ELSE
    i:=0;
    IF !dnr_begDTS[i] THEN
     FillTPass(D, _DayType, _SchdlType, L_General.EMPTY_NUMBER(), ACSE.DTS, ACSE.Event, ConvEvent2EventState(ec_Intermediate, ACSE.Event), _wrkTim, _DeltaTyp, CalcDelta(_DayType, _SchdlType, L_General.EMPTY_NUMBER(), ACSE.DTS, ACSE.Event), ec_Intermediate);
    ELSE
     WHILE (i <= HIGH(dnr_begDTS)) & ~!dnr_begDTS[i] DO
      IF    ACSE.Event = ev_Enter THEN
       IF IsNearestBegDnrlEnter(dnr_begDTS[i], dnr_endDTS[i], cs_endDTS) THEN
        tmp_DTS:=dnr_endDTS[i];
       ELSE
        SETEMPTY(tmp_DTS);
       END;
      ELSIF ACSE.Event = ev_Exit THEN
       IF IsNearestEndDnrExit(dnr_begDTS[i], dnr_endDTS[i], cs_begDTS) THEN
        tmp_DTS:=dnr_begDTS[i];
       ELSE
        SETEMPTY(tmp_DTS);
       END;
      END;
      FillTPass(D, _DayType, _SchdlType, tmp_DTS, ACSE.DTS, ACSE.Event, ConvEvent2EventState(ec_Intermediate, ACSE.Event), _wrkTim, _DeltaTyp, CalcDelta(_DayType, _SchdlType, tmp_DTS, ACSE.DTS, ACSE.Event), ec_Intermediate);
      INC(i);
     END;
    END;
    IF prvEvent = ACSE.Event THEN
     IF    ACSE.Event = ev_Enter THEN
      InsAbsentEvent(D, _DayType, _SchdlType, cs_begDTS, cs_endDTS, ev_Exit,  _DeltaTyp, 0, ec_Intermediate);
     ELSIF ACSE.Event = ev_Exit THEN
      InsAbsentEvent(D, _DayType, _SchdlType, cs_begDTS, cs_endDTS, ev_Enter, _DeltaTyp, 0, ec_Intermediate);
     END;
    END;
   END;
   prvEvent:=ACSE.Event;
   NEXT(ACSE);
  END; (* WHILE OCCURE(ACSE)...*)

  D:=_From;
  WHILE D <= _UpTo DO
   PROMPT("㧪  ⬥⮪ " + Staff.TSN + " " + L_DatTim.DateStr(D));
   IF L_Staff.rInState(D) THEN
    FillShiftParams(D, _DayType, _SchdlType, cs_begDTS, cs_endDTS, dnr_begDTS, dnr_endDTS, Shift);
    NoEnter:=~SELECT(TPass, Event, Man.Man, D, es_BegWork);
    NoExit :=~SELECT(TPass, Event, Man.Man, D, es_EndWork);
    IF _DayType = daytyp_Work THEN
     IF NoEnter & NoExit THEN
      _DeltaTyp:=deltatyp_Absence;
     ELSE
      SETEMPTY(_DeltaTyp);
     END;

     IF NoEnter THEN
      InsAbsentEvent(D, _DayType, _SchdlType, cs_begDTS, cs_endDTS, ev_Enter, _DeltaTyp, 0,       ec_Primary);
     END;
     IF NoExit THEN
      InsAbsentEvent(D, _DayType, _SchdlType, cs_begDTS, cs_endDTS, ev_Exit,  _DeltaTyp, NoEnter, ec_Primary);
     END;
    ELSE
     SETEMPTY(_DeltaTyp);
     IF    ~NoEnter & NoExit THEN
      InsAbsentEvent(D, _DayType, _SchdlType, cs_begDTS, cs_endDTS, ev_Exit,  _DeltaTyp, 0,       ec_Primary);
(*
     ELSIF NoEnter  & ~NoExit THEN
      InsAbsentEvent(D, _DayType, _SchdlType, cs_begDTS, cs_endDTS, ev_Enter, _DeltaTyp, 0,       ec_Primary);
*)
     END;
    END;
   END;
   INC(D);
  END; (* WHILE D <= _From...*)

  SELECT(TPass, DTSN, , Staff.MyFirm, Staff.TSN);
  WHILE OCCURE(TPass) & (TPass.EventSt # es_BegWork) & (TPass.EventSt # es_AbsenceEnter) DO
   REMOVE(TPass);
  END; (* WHILE OCCURE(TPass) & (TPass.EventSt # es_BegWork)...*)
 END {ProceedSingleMan};

 PRIVATE PROCEDURE CheckACSDate(_From, _UpTo: DATE);
  VAR
   DateAccount: DATE;
 BEGIN
  DateAccount:=L_ACS.GetStartLoadUnloaded(_UpTo);
  IF    !DateAccount THEN
   L_StdFrm.Confirm(" ⠭  砫  室." +
                    "|  室 ⮏   묨.");
  ELSIF _UpTo > DateAccount THEN
   L_StdFrm.Confirm("室 㦥  " + L_DatTim.DateStr(DateAccount) +
                    "|  室 ⮏   묨.");
  END;
 END {CheckACSDate};

 PRIVATE PROCEDURE SetRealUpTo(From: DATE; VAR UpTo: DATE);
 BEGIN
  L_General.Assert(From <= SYSDATE(), "ନ஢   騥 ਮ :|" +
                                       " ⬥⮪  室");
  IF UpTo > SYSDATE() THEN
   L_StdFrm.Question("ନ஢   ਮ  " + L_DatTim.DateStr(From) +
                     "  " + L_DatTim.DateStr(UpTo) + " ," +
                     "| '' 㤥   " + L_DatTim.DateStr(SYSDATE()));
  END;
  UpTo:=Math.Min(UpTo, SYSDATE());
 END {SetRealUpTo};

 PUBLIC PROCEDURE Prc03();
  CONST
   bpId = "Prc03";
  VAR
   _From, _UpTo: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  _From:=Memo.ud_fr();
  _UpTo:=Memo.ud_ut();

  L_bp.Begin(bpId, " 㤮 樯", L_bp.t_Basis, L_General.timeCond_InIntvl);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);

  SetRealUpTo(_From, _UpTo);
  CheckACSDate(_From, _UpTo);
  Pump_RegEvents(L_General.EMPTY_NUMBER(), _From, _UpTo, "");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT("஥  " + Staff.TSN);
   CONFORM(Staff, Man);
   IF L_Staff.rInState(_From) &
      (Staff.Contract = L_Staff.cnt_Basic) &
      P_Man.HasActualManPro(Man.Man, _From, P_Man.P_Pass) THEN
    ProceedSingleMan(_From, _UpTo);
   END; (* IF P_Man.HasActualManPro(Man.Man, D, P_Man.P_Pass) & *)
   NEXT(Staff);
  END; (* OCCURE(Staff)...*)

  Prc03_Print(_From, _UpTo);

  FIO.Close(F);
  L_bp.End();
 END {Prc03};

(*
$P{ Prc04_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
?, C, ""
@
################################################################################ ########## #####
=#####===========================================================================================
|                                     㤮 樯                                 |
|                                ਮ  ##########  ##########                            |
|###############################################################################################|
|-----------------------------------------------------------------------------------------------|
|      |     |६ ᮡ| ᯨᠭ|        |⪫|⨥|䨪|
|----------|-----------|-------------|-------------|-----------|----------|-------|-------------|
}
*)

(*
$P{ Prc04_Line:
?, L, ""
?, L, ""
?, C, ""
?, C, ""
TPass.DeltaTyp, L, deltatyp_Pool
?, R, ""
TPass.Event, L, L_ACS.EventTypPool
TPass.EventCls, L, ec_Pool
@
|##########|###########|#############|#############|###########|##########|#######|#############|
}
*)

(*
$P{ Prc04_Dlm:
@
|----------|-----------|-------------|-------------|-----------|----------|-------|-------------|
}
*)

(*
$P{ Prc04_Bot:
@
=(c) Polak=======================================================================================
}
*)

 PRIVATE PROCEDURE ChooseACSSite(): STRING[];
  VAR
   i, Amount            : NUMERIC[0];
   Result,
   SingleACSSite,
   srcACSSitePool,
   dstACSSitePool       : STRING[];
   IsOutpostHasPerimeter: SCAL[2];
 BEGIN
  P_OwnData.GetACSSystemOutposts(SYSDATE());
  SETEMPTY(dstACSSitePool);
  srcACSSitePool:=L_ACS.E_GetACSSitePool();
  SETZERO(i, Amount);
  LOOP
   SingleACSSite:=L_Str.PoolItem(srcACSSitePool, i);
   IF !SingleACSSite THEN
    EXIT;
   END;
   IsOutpostHasPerimeter:=0;
   SELECT(Outpost, Site, , SingleACSSite);
   WHILE OCCURE(Outpost) & ~IsOutpostHasPerimeter DO
    IsOutpostHasPerimeter:=Outpost.Perimeter;
    NEXT(Outpost);
   END; (* WHILE OCCURE(Outpost) ... *)
   IF IsOutpostHasPerimeter THEN
    dstACSSitePool:=dstACSSitePool + "|" + SingleACSSite;
    INC(Amount);
   END;
   INC(i);
  END; (* LOOP *)

  IF    Amount = 0 THEN
   SETEMPTY(Result);
  ELSIF Amount = 1 THEN
   Result:=L_Str.PoolItem(dstACSSitePool, 0);
  ELSE
   Result:=L_Str.PoolItem(dstACSSitePool, L_StdFrm.ShowListAsMenu(dstACSSitePool, "롮 "));
  END;
  RETURN Result;
 END {ChooseACSSite};

 PRIVATE PROCEDURE Prc04_Make(RepName: STRING[]; _From, _UpTo: DATE);
  VAR
   FirstPass : SCAL[2];
   DeltaAsStr,
   EventTime,
   SchldTime : STRING[];
   D         : DATE;
   T         : TIME;
   S         : SCAL[60];
   Title,
   trgACSSite: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  CheckACSDate(_From, _UpTo);
  L_General.Assert(ACCESS(Staff), " ࠭ ࠡ⭨");
  L_General.Assert(L_Env.RealTSN(Staff.TSN), "  䨪⨢ ࠡ⭨  ନ");
  trgACSSite:=ChooseACSSite();

  CONFORM(Staff, Man);
  Pump_RegEvents(Man.Man, _From, _UpTo, trgACSSite);
  ProceedSingleMan(_From, _UpTo);

  OPENREP(R, L_General.NameConnection(RepName), Create);
  Title:=Staff.TSN + " " + Man.Name;
  IF ~!trgACSSite THEN
   Title:=Title + " ( 室: " + trgACSSite + ")";
  END;
  MAKEPART(R, Prc04_Top, RepName, _From, _UpTo, Title);
  SELECT(TPass, DTSN);
  WHILE OCCURE(TPass) DO
   NARROWSEL(TPass, MyFirm, TSN);
   WHILE OCCURE(TPass) & (TPass.EventD <= (_UpTo+1)) DO
    FirstPass:=1;
    NARROWSEL(TPass, EventD);
    WHILE OCCURE(TPass) DO
     PROMPT(" " + TPass.MyFirm + " " + TPass.TSN + " " + L_DatTim.DateStr(TPass.EventD));
     P_Firm.PositionOnMyFirm(TPass.MyFirm);
     SEARCH(Officer, Sort, , TPass.Sort, TPass.Officer);
     CONFORM(Officer, Sort);
     CONFORM(Officer, Post);
     SEARCH(Man,     Man, ,     TPass.Man);
     SEARCH(Staff,   TSN, ,     TPass.TSN);
     SEARCH(RegMain, HumReg, ,  TPass.Regime);
 
     UnPkVARIANTDATE(TPass.EventDTS, D, T, S);
     IF IsRealEvent() THEN
      EventTime:=L_DatTim.TimeStr(T)+":"+S;
     ELSE
      EventTime:="-";
     END;
     IF ~!TPass.SchdlDTS THEN
      UnPkVARIANTDATE(TPass.SchdlDTS, D, T, S);
      SchldTime:=L_DatTim.TimeStr(T)+":"+S;
     ELSE
      SETEMPTY(SchldTime);
     END;

     IF TPass.Delta # 0 THEN
      DeltaAsStr:=FLDTOSTR(TPass.Delta, "0");
     ELSE
      SETEMPTY(DeltaAsStr);
     END;

     IF FirstPass THEN
      MAKEPART(R, Prc04_Line, L_DatTim.DateStr(TPass.EventD),
                              L_Str.PoolItem(daytyp_Pool, TPass.DayType),
                              EventTime, SchldTime, DeltaAsStr);
      FirstPass:=0;
     ELSE
      MAKEPART(R, Prc04_Line, "",
                              "",
                              EventTime, SchldTime, DeltaAsStr);
     END;
     NEXT(TPass);
    END; (* WHILE OCCURE(TPass) ... *)
    NEXTINEXTENDEDSEL(TPass, EventD);
   END; (* WHILE OCCURE(TPass) ... *)
   NEXTINEXTENDEDSEL(TPass, MyFirm, TSN);
  END; (* WHILE OCCURE(TPass) ... *)
  MAKEPART(R, Prc04_Bot);
  L_General.SurveyLastReport();
 END {Prc04_Make};

 PUBLIC PROCEDURE Prc04();
 BEGIN
  Prc04_Make("Prc04", SYSDATE()-14-1, SYSDATE()-1);
 END {Prc04};

 PUBLIC PROCEDURE Prc06();
 BEGIN
  Prc04_Make("Prc06", Memo.ud_fr(), Memo.ud_ut());
 END {Prc06};

END.
