(*
%Copyright   (c) Polak IT
%Author      06.03.2013 11:38:11 LDA
%Purpose      室
%Type        report
%Specific    SYS
%Modified    05.11.2013 11:29:15 POLAK\LDA
%Environment
*)

 MODULE Prc05 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Basis, FIO, L_bp, P_Firm, P_OwnData, L_General, L_AFM, L_DatTim, Memo, L_Staff, L_Env;

 PRIVATE CONST
  ev_Enter   = 2;
  ev_Exit    = 3;

 PRIVATE PROCEDURE MakeHeader(F  : STRING[];
                              wMF: SCAL[2]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " 室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "  ६ 室");
  L_Basis.wb_WrInQM(F, " 室");
  L_Basis.wb_WrInQM(F, "६ 室");
  L_Basis.wb_WrInQM(F, "  ६ 室");
  L_Basis.wb_WrInQM(F, " 室");
  L_Basis.wb_WrInQM(F, "६ 室");
  L_Basis.wb_WrInQM(F, "த⥫쭮");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakeLine(F  : STRING[];
                            wMF: SCAL[2]);
  VAR
   D,
   trgDate        : DATE;
   T              : TIME;
   S              : NUMERIC[0];
   HasMainContract: SCAL[2];
 BEGIN
  HasMainContract:=0;
  IF Man.rStaff THEN
   IF ~!_ACSE.EnterDTS THEN
    trgDate:=L_DatTim.GetDateOfTIMESTAMP(_ACSE.EnterDTS);
   ELSE
    trgDate:=L_DatTim.GetDateOfTIMESTAMP(_ACSE.ExitDTS);
   END;
   HasMainContract:=L_Staff.IsStandOnAnyMainContract(Man.Man, trgDate);
  END;

  IF HasMainContract THEN
   IF wMF THEN
    CONFORM(Staff, MyFirm);
    L_Basis.wb_WrScl(F, MyFirm.MyFirm);
    L_Basis.wb_WrStr(F, MyFirm.vzSign);
   END;
   HISTCONF(trgDate, Staff, StaffLog);
   CONFORM(StaffLog, Officer);
   CONFORM(Officer, Post);
   CONFORM(Officer, Sort);
   CONFORM(Officer, Union);
   L_Basis.wb_WrScl(F, Staff.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrScl(F, L_Staff.getService());
   L_Basis.wb_WrStr(F, L_Staff.getServiceName());
   L_Basis.wb_WrScl(F, L_Staff.getDepart());
   L_Basis.wb_WrStr(F, L_Staff.getDepartName());
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
   L_Basis.wb_WrScl(F, Post.Post);
   L_Basis.wb_WrStr(F, Post.Name);
  ELSE
   IF wMF THEN
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
   END;
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrStr(F, _ACSE.Site);
  IF ~!_ACSE.EnterOP THEN
   SELECT(Outpost, Outpost, , _ACSE.EnterOP);
   L_Basis.wb_WrScl(F, _ACSE.EnterOP);
   L_Basis.wb_WrStr(F, Outpost.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  IF ~!_ACSE.ExitOP THEN
   SELECT(Outpost, Outpost, , _ACSE.ExitOP);
   L_Basis.wb_WrScl(F, _ACSE.ExitOP);
   L_Basis.wb_WrStr(F, Outpost.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  IF ~!_ACSE.EnterDTS THEN
   UnPkTIMESTAMP(_ACSE.EnterDTS, D, T, S);
   L_Basis.wb_WrStr(F, FLDTOSTR(_ACSE.EnterDTS, "D.N.y H:M:S"));
   L_Basis.wb_WrDat(F, D);
   L_Basis.wb_WrLongTim(F, T, S);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  IF ~!_ACSE.ExitDTS THEN
   UnPkTIMESTAMP(_ACSE.ExitDTS, D, T, S);
   L_Basis.wb_WrStr(F, FLDTOSTR(_ACSE.ExitDTS, "D.N.y H:M:S"));
   L_Basis.wb_WrDat(F, D);
   L_Basis.wb_WrLongTim(F, T, S);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  IF ~!_ACSE.EnterDTS & ~!_ACSE.ExitDTS THEN
   L_Basis.wb_WrNum(F, (_ACSE.ExitDTS-_ACSE.EnterDTS) * 24, 3);
  ELSE
   L_Basis.wb_WrNum(F, 0, 3);
  END;
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PRIVATE PROCEDURE CreateTmpFile();
 BEGIN
  CreateFILE(_ACSE, "", " ", "");

  CreateFIELD(_ACSE, Site,     STRING[16],              "", "", "", " 室", "");
  CreateFIELD(_ACSE, Man,      LIKE(Man.Man),           "", "", "", "", "");
  CreateFIELD(_ACSE, CardCode, LIKE(ACSEvent.CardCode), "", "", "", " ", "");
  CreateFIELD(_ACSE, EnterOP,  LIKE(ACSEvent.Outpost),  "", "", "", "窠 室", "");
  CreateFIELD(_ACSE, ExitOP,   LIKE(ACSEvent.Outpost),  "", "", "", "窠 室", "");
  CreateFIELD(_ACSE, EnterDTS, TIMESTAMP,               "", "", "", "/६ 室", "");
  CreateFIELD(_ACSE, ExitDTS,  TIMESTAMP,               "", "", "", "/६ 室", "");

  CreateINDEX(_ACSE, Site,     UNIQUE,                    "", "", Site, Man, CardCode, EnterOP, EnterDTS);

  SetVersionOfFILE(_ACSE, 0001);
  L_AFM.AF_CreateTemp("_ACSE", "_ACSE");
 END {CreateTmpFile};

 PRIVATE PROCEDURE GetTimeStamp(): TIMESTAMP;
  VAR
   D: DATE;
   T: TIME;
   S: NUMERIC[0];
 BEGIN
  UnPkVARIANTDATE(ACSEvent.DTS, D, T, S);
  RETURN PackTIMESTAMP(D, T, S);
 END {GetTimeStamp};

 PRIVATE PROCEDURE InsIntoTmp();
 BEGIN
  _ACSE.Site    :=P_OwnData.GetACSSiteByOutpost(ACSEvent.Outpost);
  _ACSE.Man     :=ACSEvent.Man;
  _ACSE.CardCode:=ACSEvent.CardCode;
  IF ACSEvent.Event = ev_Enter THEN
   SETEMPTY(_ACSE.ExitDTS, _ACSE.ExitOP);
   _ACSE.EnterDTS:=GetTimeStamp();
   _ACSE.EnterOP :=ACSEvent.Outpost;
  ELSE
   SETEMPTY(_ACSE.EnterDTS, _ACSE.EnterOP);
   _ACSE.ExitDTS :=GetTimeStamp();
   _ACSE.ExitOP  :=ACSEvent.Outpost;
  END;
  INSERT(_ACSE);
 END {InsIntoTmp};

 PRIVATE PROCEDURE StandOnLastSiteEnter(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF SELECT(_ACSE, Site, P_OwnData.GetACSSiteByOutpost(ACSEvent.Outpost), ACSEvent.Man) THEN
   LAST(_ACSE);
   WHILE OCCURE(_ACSE) & !_ACSE.EnterDTS DO
    PREV(_ACSE);
   END; (* WHILE OCCURE(_ACSE) ... *)
   Result:=OCCURE(_ACSE) & !_ACSE.ExitDTS;
  END;
  RETURN Result;
 END {StandOnLastSiteEnter};

 PUBLIC PROCEDURE Prc05();
  CONST
   bpId = "Prc05";
  VAR
   wMF: SCAL[2];
   From,
   UpTo: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF :=P_Firm.E_wMultipleMyFirm(SYSDATE());
  From:=Memo.ud_fr();
  UpTo:=Memo.ud_ut();
  L_bp.Begin(bpId, " 室", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);

  P_OwnData.GetACSSystemOutposts(SYSDATE());
  MakeHeader("R", wMF);

  CreateTmpFile();
  SELECT(ACSEvent, Man);
  WHILE OCCURE(ACSEvent) DO
   NARROWSEL(ACSEvent, Man);
   IF L_Env.RealMan(ACSEvent.Man) THEN
    SRCINSEL(ACSEvent, GE, , From);
    WHILE OCCURE(ACSEvent) & (ACSEvent.Date <= (UpTo + 1)) DO
     PROMPT(":  " + ACSEvent.Man + " " + L_DatTim.DateStr(ACSEvent.Date));
     IF ACSEvent.Event = ev_Enter THEN
      InsIntoTmp();
     ELSE
      IF StandOnLastSiteEnter() THEN
       _ACSE.ExitDTS:=GetTimeStamp();
       _ACSE.ExitOP :=ACSEvent.Outpost;
       REPLACE(_ACSE);
      ELSE
       InsIntoTmp();
      END;
     END;
     NEXT(ACSEvent);
    END; (* WHILE OCCURE(ACSEvent) ... *)
   END;
   NEXTINEXTENDEDSEL(ACSEvent, Man);
  END; (* WHILE OCCURE(ACSEvent) ... *)

  SELECT(_ACSE, Site);
  WHILE OCCURE(_ACSE) DO
   PROMPT(":  " + _ACSE.Man);
   SEARCH(Man, Man, , _ACSE.Man);
   MakeLine("R", wMF);
   NEXT(_ACSE);
  END; (* WHILE OCCURE(_ACSE) ... *)

  FIO.Close(R);
  L_bp.End();
 END {Prc05};

END.
