(*
%Copyright   (c) Polak Computer System
%Author      19.07.2000 12:42:59 SAM
%Purpose     ⥪  ࠡ  ᢮⢠ Car
%Type        library
%Specific    AP
%Modified    29.08.2014 12:01:13 POLAK\Gina
%Environment
*)

 MODULE P_Car [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  P_SMCor                  = 1150;
  P_CarWithKKM             = 1151;
  P_CarNormAsFact          = 1152;
  P_CLI_Obligatory         = 1153;
  P_CarLicenCard           = 1154;
  P_BakVolume              = 1155;
  P_WithASCP               = 1156;
  P_WayLCar                = 1157;
  P_TechnicalFeatures      = 1158;
  P_MobilizationDestinat   = 1159;
  P_WithASMPP              = 1160;
  P_WithCompMonitorSystem  = 1161;
  P_Checkup                = 1162;
  P_WithInvalidFacilities  = 1163;
  P_WithTrainingFacilities = 1164;
  P_SpecialSignals         = 1165;
  P_FirstAidKit            = 1166;
  P_NavigationSystem       = 1167;
  P_FuelCard               = 1168;
  P_FixedRoute             = 1169;
  P_KACKO                  = 1170;
  P_Tachograph             = 1171;
  P_ParkingPlace           = 1172;
  P_BegRWSSpecific         = 1173;

  P_CarFuelCor             = 5012;
  P_CarOilCor              = 5013;

  ssRotatingBeaconPool = "|||-㭭";

  ascpTurnstile = 0;
  ascpValidator = 1;

  FuelCorrAmount = 3;
  CarsAmount     = 15;

 PUBLIC TYPE
  tFuelCorr = NUMERIC[6, 3][FuelCorrAmount];
  tCars     = LIKE(Car.BoxNbr)[CarsAmount];

 IMPORT L_General, L_DatTim, L_Prop, L_Car, L_Str, Str, L_WDO, L_Fuel,
        L_r2r, L_StdFrm, L_APtm;

 PRIVATE CONST
  v_coc_MotorOil        = "v_coc_MotorOil";
  v_coc_TransmissionOil = "v_coc_TransmOil";
  v_coc_HydroOil        = "v_coc_HydroOil";
  v_coc_PlasticGreasing = "v_coc_Plastic";

 PUBLIC PROCEDURE PropertyModificationAllowed(trgProperty: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF    trgProperty = P_FirstAidKit THEN
   RETURN L_Prop.mac_Old;
  ELSE
   RETURN L_Prop.mac_Full;
  END;
 END {PropertyModificationAllowed};

 PUBLIC PROCEDURE GetSubWindowName(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_CarFuelCor THEN
   RETURN "P_5012";
  ELSIF trgProperty = P_CarOilCor THEN
   RETURN "P_5013";
  ELSIF trgProperty = P_WayLCar THEN
   RETURN "P_1157";
  ELSIF trgProperty = P_SpecialSignals THEN
   RETURN "P_1165";
  ELSIF trgProperty = P_CLI_Obligatory THEN
   RETURN "P_1153";
  ELSIF trgProperty = P_KACKO THEN
   RETURN "P_1170";
  ELSIF trgProperty = P_BegRWSSpecific THEN
   RETURN "P_1173";
  ELSE
   RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE IsSimpleUserOf(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_FixedRoute THEN
   RETURN "Route";
  ELSE
   RETURN "";
  END;
 END {IsSimpleUserOf};

 PUBLIC PROCEDURE GetPool(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    (_Property = P_CarWithKKM) |
        (_Property = P_WithASMPP)  |
        (_Property = P_WithCompMonitorSystem) |
        (_Property = P_WithTrainingFacilities) |
        (_Property = P_WithInvalidFacilities)  |
        (_Property = P_NavigationSystem)  |
        (_Property = P_FuelCard)  |
        (_Property = P_Tachograph) THEN
   RETURN "|";
  ELSIF _Property = P_WithASCP THEN
   RETURN " ० ୨| ० ";
  ELSIF _Property = P_CarNormAsFact THEN
   RETURN "|";
  ELSIF (_Property = P_CLI_Obligatory) |
        (_Property = P_Checkup) |
        (_Property = P_FirstAidKit) |
        (_Property = P_KACKO) THEN
   RETURN " ॡ|";
  ELSIF _Property = P_MobilizationDestinat THEN
   RETURN "ᯮ㥬  ⥪饬 ந⢥|ࢨ஢|ᯮ㥬  ⥪饬 ந⢥";
  ELSIF L_Prop.IsLocalProperty(_Property) THEN
   RETURN L_Prop.E_GetPool(_Property);
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PUBLIC PROCEDURE GetPool4DocGiveS(_Property: LIKE(Property.Property)): LIKE(Pool.Pool);
 BEGIN
  IF    _Property = P_CLI_Obligatory       THEN RETURN 0000992;
  ELSIF _Property = P_KACKO                THEN RETURN 0000992;
  ELSIF _Property = P_CarLicenCard         THEN RETURN 0000993;
  ELSIF _Property = P_MobilizationDestinat THEN RETURN 0000994;
  ELSIF _Property = P_Checkup              THEN RETURN 0000995;
  ELSIF _Property = P_SpecialSignals       THEN RETURN 0000996;
  ELSE
   RETURN "";
  END;
 END {GetPool4DocGiveS};

 PUBLIC PROCEDURE Check(trgProperty: LIKE(Property.Property));
  VAR
   Msg      : STRING[];
   curBoxNbr: LIKE(Car.BoxNbr);
   B,
   E        : DATE;
 BEGIN
  IF    trgProperty = P_SMCor THEN
   L_Prop.CheckNumericValue(CarPro.Value, "");
  ELSIF trgProperty = P_CarOilCor THEN
   L_Prop.CheckNumericValue(CarPro.Value, "");
  ELSIF trgProperty = P_BakVolume THEN
   L_Prop.CheckNumericValue(CarPro.Value, "");
  ELSIF trgProperty = P_ParkingPlace THEN
   L_Prop.CheckNumericValue(CarPro.Value, "");
   curBoxNbr:=CarPro.BoxNbr;
   B:=CarPro.Date;
   E:=CarPro.EndDate;
   TRY [RESTORE_CURSORS(RC_ON)]
    Msg:="";
    SELECT(CarPro, Property, , P_ParkingPlace, CarPro.Value (*SpdSrchV ய *));
    WHILE OCCURE(CarPro) DO
     IF (CarPro.BoxNbr # curBoxNbr) &
        L_DatTim.IsActiveInIntvl_Inc(CarPro.Date, CarPro.EndDate, B, E) THEN
      Msg:=L_Str.AddStrDlm(Msg, "|") + " " + CarPro.Value +
           " 㪠   " + CarPro.BoxNbr + "  " + L_DatTim.DateStr(CarPro.Date);
      IF ~!CarPro.EndDate THEN
       INC(Msg, "  " + L_DatTim.DateStr(CarPro.EndDate));
      END;
     END;
     NEXT(CarPro);
    END; (* WHILE OCCURE(CarPro) ... *)
   EXCEPT
   END;
   IF ~!Msg THEN
    L_StdFrm.CrucialChoice(Msg, L_APtm.g_Expl);
   END;
  END;
 END {Check};

 PUBLIC PROCEDURE HasCarPro(_BoxNbr: LIKE(Car.BoxNbr); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SELECT(CarPro, BoxNbr, _BoxNbr, trgProperty) &
         SRCINSEL(CarPro, LE, D);
 END {HasCarPro};

 PUBLIC PROCEDURE HasActualCarPro(_BoxNbr: LIKE(Car.BoxNbr); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasCarPro(_BoxNbr, D, trgProperty) & (!CarPro.DocExpD | (D < CarPro.DocExpD));
 END {HasActualCarPro};

 PRIVATE PROCEDURE GetCarPro(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE; trgProperty: LIKE(Property.Property); Strong: SCAL[2]): LIKE(CarPro.Value);
  VAR
   Result: LIKE(CarPro.Value);
 BEGIN
  IF HasActualCarPro(trgBoxNbr, D, trgProperty) THEN
   IF ~!IsSimpleUserOf(trgProperty) THEN
    Result:=L_r2r.Decode(CarPro.Value);
   ELSE
    Result:=CarPro.Value;
   END;
  ELSE
   IF Strong THEN
    SEARCH(Car, BoxNbr, , trgBoxNbr);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("Car").Id, Car.RECORDID, trgProperty, D);
   ELSE
    SETEMPTY(Result);
   END;
  END;
  RETURN Result;
 END {GetCarPro};

 PUBLIC PROCEDURE GetCarProStrong(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE; trgProperty: LIKE(Property.Property)): LIKE(CarPro.Value);
 BEGIN
  RETURN GetCarPro(trgBoxNbr, D, trgProperty, 1);
 END {GetCarProStrong};

 PUBLIC PROCEDURE GetCarProSoft(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE; trgProperty: LIKE(Property.Property)): LIKE(CarPro.Value);
 BEGIN
  RETURN GetCarPro(trgBoxNbr, D, trgProperty, 0);
 END {GetCarProSoft};

 PUBLIC PROCEDURE Decode_CarFuelCor(Value: STRING[]; VAR FuelCorr: tFuelCorr);
  VAR
   Idx: SCAL[FuelCorrAmount];
 BEGIN
  FOR_EACH Idx DO
   FuelCorr[Idx]:=STRTOFLD(L_Prop.getRES(Value, Idx), NUMERIC);
  END;
 END {Decode_CarFuelCor};

 PRIVATE PROCEDURE formSet_CarFuelCor();
  VAR
   Fields  : FORM_FIELDS;
   FuelCorr: tFuelCorr;
   Idx     : SCAL[FuelCorrAmount];
 BEGIN
  Decode_CarFuelCor(CarPro.Value, FuelCorr);
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   Fields(L_WDO.Fld_wIdx("FuelCorr", Idx)).Value:=FuelCorr[Idx];
  END;
 END {formSet_CarFuelCor};

 PRIVATE PROCEDURE Encode_CarFuelCor(VAR Value: STRING[]; FuelCorr: tFuelCorr);
  VAR
   Idx: SCAL[FuelCorrAmount];
   tmp: STRING[];
 BEGIN
  SETEMPTY(Value);
  FOR_EACH Idx DO
   tmp:=Str.Condense(FLDTOSTR(FuelCorr[Idx]));
   L_Prop.putREV(Value, tmp);
  END;
 END {Encode_CarFuelCor};

 PRIVATE PROCEDURE formGet_CarFuelCor();
  VAR
   Fields  : FORM_FIELDS;
   FuelCorr: tFuelCorr;
   Idx     : SCAL[FuelCorrAmount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   FuelCorr[Idx]:=Fields(L_WDO.Fld_wIdx("FuelCorr", Idx)).Value;
  END;
  Encode_CarFuelCor(CarPro.Value, FuelCorr);
 END {formGet_CarFuelCor};

 PRIVATE PROCEDURE SetCarOilCorData(_Value: LIKE(CarPro.Value); VAR OilCorr: L_Fuel.tCarOilCoef);
  VAR
   i: NUMERIC[0];
 BEGIN
  SETEMPTY(OilCorr);
  OilCorr[L_Fuel.im_MotorOil]       :=L_Prop.GetNumericValueFromStr(L_Prop.getRES(_Value, 0));
  OilCorr[L_Fuel.im_TransmissionOil]:=L_Prop.GetNumericValueFromStr(L_Prop.getRES(_Value, 1));
  OilCorr[L_Fuel.im_HydroOil]       :=L_Prop.GetNumericValueFromStr(L_Prop.getRES(_Value, 2));
  OilCorr[L_Fuel.im_PlasticGreasing]:=L_Prop.GetNumericValueFromStr(L_Prop.getRES(_Value, 3));
  i:=0;
  WHILE i<RANGEOF(OilCorr) DO
   IF !OilCorr[i] THEN
    OilCorr[i]:=1;
   END;
   INC(i);
  END;
 END {SetCarOilCorData};

 PRIVATE PROCEDURE Decode_AnyInsurance(    Value    : STRING[];
                                       VAR trgValue : STRING[];
                                       VAR Insurance: NUMERIC[2]);
 BEGIN
  trgValue :=L_Prop.getRES(Value, 0);
  Insurance:=STRTOFLD(L_Prop.getRES(Value, 1), NUMERIC, "2.");
 END {Decode_AnyInsurance};

 PRIVATE PROCEDURE AnyInsurance_SetPeriodFieldAttr(trgProperty: LIKE(Property.Property); Fields: FORM_FIELDS);
  VAR
   EndTypeStr,
   PeriodName   : STRING[];
   trgModifiable: SCAL[2];
 BEGIN
  IF ~!Fields("Value").Value & (Fields("Value").Value # L_Str.PoolItem(GetPool(trgProperty), 0)) THEN
   PeriodName:="ப 客";
   EndTypeStr:="";
  ELSE
   PeriodName:="";
   EndTypeStr:="";
  END;
  Fields("PeriodName").Value:=PeriodName;
  Fields("EndTypeStr").Value:=EndTypeStr;
 END {AnyInsurance_SetPeriodFieldAttr};

 PRIVATE PROCEDURE formSet_AnyInsurance(trgProperty: LIKE(Property.Property));
  VAR
   Fields   : FORM_FIELDS;
   EndD     : DATE;
   trgValue : STRING[];
   Insurance: NUMERIC[2];
 BEGIN
  Decode_AnyInsurance(CarPro.Value, trgValue, Insurance);
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Value"    ).Value:=trgValue;
  Fields("Insurance").Value:=Insurance;
  AnyInsurance_SetPeriodFieldAttr(trgProperty, Fields);
  IF !CarPro.DocExpD | !Fields("Value").Value | (Fields("Value").Value = L_Str.PoolItem(GetPool(trgProperty), 0)) THEN
   SETEMPTY(EndD);
  ELSE
   EndD:=CarPro.DocExpD - 1;
  END;
  Fields("Value").Template        :=GetPool(trgProperty);
  Fields("Value").TemplateIsStrict:=1;
  Fields("EndD"      ).Value      :=EndD;
 END {formSet_AnyInsurance};

 PRIVATE PROCEDURE formSet_KACKO();
 BEGIN
  formSet_AnyInsurance(P_KACKO);
 END {formSet_KACKO};

 PRIVATE PROCEDURE formSet_CLI_Obligatory();
 BEGIN
  formSet_AnyInsurance(P_CLI_Obligatory);
 END {formSet_CLI_Obligatory};

 PRIVATE PROCEDURE Encode_AnyInsurance(VAR Value    : STRING[];
                                           trgValue : STRING[];
                                           Insurance: NUMERIC[2]);
  VAR
   tmp: STRING[];
 BEGIN
  SETEMPTY(Value);
  L_Prop.putREV(Value, trgValue);
  IF ~!Insurance THEN
   tmp:=FLDTOSTR(Insurance, "N2.");
   L_Prop.putREV(Value, tmp);
  END;
 END {Encode_AnyInsurance};

 PRIVATE PROCEDURE formGet_AnyInsurance(trgProperty: LIKE(Property.Property));
  VAR
   Fields   : FORM_FIELDS;
   trgValue : STRING[];
   Insurance: NUMERIC[2];
 BEGIN
  Fields   :=RTI.Get().CurZone.Fields;
  trgValue :=Fields("Value"    ).Value;
  Insurance:=Fields("Insurance").Value;
  IF Fields("Value").Value # L_Str.PoolItem(GetPool(trgProperty), 0) THEN
   L_General.Assert(~!Fields("EndD").Value, "ਮ ᯮ짮   ࠭祭?");
   CarPro.DocExpD:=Fields("EndD").Value + 1;
  ELSE
   L_General.Assert(!Fields("Insurance").Value, "祬  客 ६, ᫨  ॡ 客?");
   CarPro.DocExpD:=Fields("EndD").Value;
  END;
  Encode_AnyInsurance(CarPro.Value, trgValue, Insurance);
 END {formGet_AnyInsurance};

 PRIVATE PROCEDURE formGet_KACKO();
 BEGIN
  formGet_AnyInsurance(P_KACKO);
 END {formGet_KACKO};

 PRIVATE PROCEDURE formGet_CLI_Obligatory();
 BEGIN
  formGet_AnyInsurance(P_CLI_Obligatory);
 END {formGet_CLI_Obligatory};

 PRIVATE PROCEDURE SetFieldValue(FieldName: STRING[]; Value: ANYTYPE);
  VAR
   Field : FORM_FIELD;
 BEGIN
  Field:=RTI.Get().CurZone.Fields(FieldName);
  IF ~!Field THEN
   Field.Value:=Value;
  END;
 END {SetFieldValue};

 PRIVATE PROCEDURE Decode_SpecialSignals(    Value            : STRING[];
                                         VAR RotatingBeacon   : SCAL[4];
                                         VAR RedRotatingBeacon: SCAL[2];
                                         VAR SoundSignal      : SCAL[2]);
 BEGIN
  SETZERO(RotatingBeacon, RedRotatingBeacon, SoundSignal);
  IF ~!L_Prop.getRES(Value, 0) THEN
   RotatingBeacon   :=L_Str.PositionInPool(ssRotatingBeaconPool, L_Prop.getRES(Value, 0));
  END;
  IF ~!L_Prop.getRES(Value, 1) THEN
   RedRotatingBeacon:=L_Str.PositionInPool("|",           L_Prop.getRES(Value, 1));
  END;
  IF ~!L_Prop.getRES(Value, 2) THEN
   SoundSignal      :=L_Str.PositionInPool("|",           L_Prop.getRES(Value, 2));
  END;
 END {Decode_SpecialSignals};

 PRIVATE PROCEDURE formSet_SpecialSignals();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_SpecialSignals(CarPro.Value,
                        Fields("RotatingBeacon"   ).Value,
                        Fields("RedRotatingBeacon").Value,
                        Fields("SoundSignal"      ).Value);
  Fields("RotatingBeacon"   ).Format:=ssRotatingBeaconPool;
  Fields("RedRotatingBeacon").Format:="|";
  Fields("SoundSignal"      ).Format:="|";
 END {formSet_SpecialSignals};

 PUBLIC PROCEDURE Decode_WayLCar(Value: STRING[]; VAR Cars: LIKE(Car.BoxNbr)[]);
  VAR
   Idx: SCAL[CarsAmount];
 BEGIN
  SETEMPTY(Cars);
  FOR_EACH Idx DO
   IF ~!L_Prop.getRES(Value, Idx) THEN
    Cars[Idx]:=STRTOFLD(L_r2r.Decode(L_Prop.getRES(Value, Idx)), SCAL);
   END;
  END;
 END {Decode_WayLCar};

 PRIVATE PROCEDURE formSet_WayLCar();
  VAR
   Fields: FORM_FIELDS;
   Idx   : SCAL[CarsAmount];
   Cars  : tCars;
 BEGIN
  Decode_WayLCar(CarPro.Value, Cars);
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   L_WDO.extCreateFormLink("Car", "", Idx);
   Fields(L_WDO.Fld_wIdx("BoxNbr", Idx)).Value:=Cars[Idx];
  END;
 END {formSet_WayLCar};

 PRIVATE PROCEDURE Encode_WayLCar(VAR Value: STRING[]; Cars: tCars);
  VAR
   Idx: SCAL[CarsAmount];
 BEGIN
  SETEMPTY(Value);
  FOR_EACH Idx DO
   IF ~!Cars[Idx] THEN
    L_Prop.putRES(Value, L_r2r.Put("CarPro", "Car", Cars[Idx]));
   END;
  END;
 END {Encode_WayLCar};

 PRIVATE PROCEDURE formGet_WayLCar();
  VAR
   Fields: FORM_FIELDS;
   Idx   : SCAL[CarsAmount];
   Cars  : tCars;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  SETEMPTY(Cars);
  FOR_EACH Idx DO
   Cars[Idx]:=Fields(L_WDO.Fld_wIdx("BoxNbr", Idx)).Value;
  END;
  Encode_WayLCar(CarPro.Value, Cars);
 END {formGet_WayLCar};

 PUBLIC PROCEDURE SetDataInForm(trgProperty: LIKE(Property.Property));
  VAR
   OilCorr: L_Fuel.tCarOilCoef;
 BEGIN
  IF    trgProperty = P_CarOilCor THEN
   SetCarOilCorData(CarPro.Value, OilCorr);
   SetFieldValue(v_coc_MotorOil,        OilCorr[L_Fuel.im_MotorOil]);
   SetFieldValue(v_coc_TransmissionOil, OilCorr[L_Fuel.im_TransmissionOil]);
   SetFieldValue(v_coc_HydroOil,        OilCorr[L_Fuel.im_HydroOil]);
   SetFieldValue(v_coc_PlasticGreasing, OilCorr[L_Fuel.im_PlasticGreasing]);
  ELSIF trgProperty = P_CarFuelCor THEN
   formSet_CarFuelCor();
  ELSIF trgProperty = P_WayLCar THEN
   formSet_WayLCar();
  ELSIF trgProperty = P_SpecialSignals THEN
   formSet_SpecialSignals();
  ELSIF trgProperty = P_CLI_Obligatory THEN
   formSet_CLI_Obligatory();
  ELSIF trgProperty = P_KACKO THEN
   formSet_KACKO();
  ELSIF trgProperty = P_BegRWSSpecific THEN
   RTI.Get().CurZone.Fields("Reaction").Value:=L_Prop.getRES(CarPro.Value, 0);
   RTI.Get().CurZone.Fields("Reason").Value  :=L_Prop.getRES(CarPro.Value, 1);
  END;
 END {SetDataInForm};

 PRIVATE PROCEDURE Encode_SpecialSignals(VAR Value            : STRING[];
                                             RotatingBeacon   : SCAL[4];
                                             RedRotatingBeacon: SCAL[2];
                                             SoundSignal      : SCAL[2]);
  VAR
   RotatingBeaconStr,
   RedRotatingBeaconStr,
   SoundSignalStr      : STRING[];
 BEGIN
  SETEMPTY(Value);
  IF (RotatingBeacon # 0) | RedRotatingBeacon | SoundSignal THEN
   RotatingBeaconStr   :=L_Str.PoolItem(ssRotatingBeaconPool, RotatingBeacon);
   RedRotatingBeaconStr:=L_Str.PoolItem("|",           RedRotatingBeacon);
   SoundSignalStr      :=L_Str.PoolItem("|",           SoundSignal);
   L_Prop.putREV(Value, RotatingBeaconStr);
   L_Prop.putREV(Value, RedRotatingBeaconStr);
   L_Prop.putREV(Value, SoundSignalStr);
  END;
 END {Encode_SpecialSignals};

 PRIVATE PROCEDURE formGet_SpecialSignals();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_SpecialSignals(CarPro.Value,
                        Fields("RotatingBeacon"   ).Value,
                        Fields("RedRotatingBeacon").Value,
                        Fields("SoundSignal"      ).Value);
 END {formGet_SpecialSignals};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_CarFuelCor THEN
   formGet_CarFuelCor();
  ELSIF trgProperty = P_CarOilCor THEN
   CarPro.Value:="";
   L_Prop.putREV(CarPro.Value, L_WDO.getActiveZone().Fields(v_coc_MotorOil).Value);
   L_Prop.putREV(CarPro.Value, L_WDO.getActiveZone().Fields(v_coc_TransmissionOil).Value);
   L_Prop.putREV(CarPro.Value, L_WDO.getActiveZone().Fields(v_coc_HydroOil).Value);
   L_Prop.putREV(CarPro.Value, L_WDO.getActiveZone().Fields(v_coc_PlasticGreasing).Value);
  ELSIF trgProperty = P_WayLCar THEN
   formGet_WayLCar();
  ELSIF trgProperty = P_SpecialSignals THEN
   formGet_SpecialSignals();
  ELSIF trgProperty = P_CLI_Obligatory THEN
   formGet_CLI_Obligatory();
  ELSIF trgProperty = P_KACKO THEN
   formGet_KACKO();
  ELSIF trgProperty = P_BegRWSSpecific THEN
   SETEMPTY(CarPro.Value);
   L_Prop.putRES(CarPro.Value, RTI.Get().CurZone.Fields("Reaction").Value);
   L_Prop.putRES(CarPro.Value, RTI.Get().CurZone.Fields("Reason").Value);
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(CarPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Result: STRING[];
   Idx   : SCAL[CarsAmount];
 BEGIN
  SETEMPTY(Result);
  IF    CarPro.Property = P_FixedRoute THEN
   SEARCH(Route, Route, , L_r2r.Decode(CarPro.Value));
   Result:=Route.Route + " " + Route.Name;
  ELSIF CarPro.Property = P_WayLCar THEN
   FOR_EACH Idx DO
    IF ~!L_Prop.getRES(CarPro.Value, Idx) THEN
     SEARCH(Car, BoxNbr, , L_r2r.Decode(L_Prop.getRES(CarPro.Value, Idx)));
     L_Prop.putREV(Result, Car.BoxNbr);
    END;
   END;
  ELSE
   Result:=CarPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PUBLIC PROCEDURE GetP_SMCor(_BoxNbr: LIKE(Car.BoxNbr); D: DATE): FLOAT;
 BEGIN
  IF HasActualCarPro(_BoxNbr, D, P_SMCor) THEN
   RETURN STRTOFLD(CarPro.Value, FLOAT, "9.");
  ELSE
   RETURN 1.0;
  END;
 END {GetP_SMCor};

 PUBLIC PROCEDURE GetP_NormAsFact(_BoxNbr: LIKE(Car.BoxNbr); D: DATE): LIKE(Mark.AsFact);
  VAR
   _AsFact: LIKE(Mark.AsFact);
 BEGIN
  IF HasActualCarPro(_BoxNbr, D, P_CarNormAsFact) THEN
   _AsFact:=L_Prop.GetProValueAsScal(GetPool(P_CarNormAsFact), CarPro.Value);
  ELSE
   SAVE(Mark);
   L_Car.AccessMark(_BoxNbr, D);
   _AsFact:=Mark.AsFact;
   RESTORE(Mark);
  END;
  RETURN _AsFact;
 END {GetP_NormAsFact};

 PUBLIC PROCEDURE CarPro_OnAfterEdIns();
  CONST
   DocNumMask = " 9999999999";
  VAR
   S        : STRING[];
 BEGIN
  IF    CarPro.Property = P_CLI_Obligatory THEN
   IF ~!CarPro.DocNum THEN
    S:=L_Str.TestStrWMask("   ", CarPro.DocNum, DocNumMask, DocNumMask);
    L_General.Assert(!S, S);
   END;
  ELSIF CarPro.Property = P_ParkingPlace THEN
   CarPro.SpdSrchV:=CarPro.Value;
   REPLACE(CarPro);
  ELSIF CarPro.Property = P_FuelCard THEN
   L_General.Assert(~!CarPro.DocNum, " 㪠  ⮯ ");
   CarPro.SpdSrchV:=CarPro.DocNum;
   REPLACE(CarPro);
  END;
 END {CarPro_OnAfterEdIns};

 PUBLIC PROCEDURE CarPro_OnAfterEdit();
 BEGIN
  CarPro_OnAfterEdIns();
 END {CarPro_OnAfterEdit};

 PUBLIC PROCEDURE CarPro_OnAfterInsert();
 BEGIN
  CarPro_OnAfterEdIns();
 END {CarPro_OnAfterInsert};

 PUBLIC PROCEDURE OnSuccessfulChange(trgProperty: LIKE(Property.Property));
  CONST
   IdxMove = 0;
  VAR
   curValue: FLOAT;
 BEGIN
  IF trgProperty = P_CarFuelCor THEN
   IF L_Str.IsStrInStr(RTI.Get().CurZone.ActiveField.Name, "FuelCorr") THEN
    curValue:=RTI.Get().CurZone.ActiveField.Value;
    L_General.Assert(curValue >= 0, "樥 ࠢ  ଥ ⮯    ⥫ ᫮");
    L_General.Assert(curValue < 2,  "樥 ࠢ  ଥ ⮯    2.00");
    IF L_WDO.getFldIdx(RTI.Get().CurZone.ActiveField.Name) = IdxMove THEN
     L_General.Assert(curValue # 0, "樥 ࠢ  ଥ ⮯ ' '    ࠢ ");
    END;
   END;
  END;
 END {OnSuccessfullChange};

 PUBLIC PROCEDURE Value_OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF (trgProperty = P_KACKO) | (trgProperty = P_CLI_Obligatory) THEN
   AnyInsurance_SetPeriodFieldAttr(trgProperty, RTI.Get().CurZone.Fields);
  END;
 END {Value_OnSuccessfulChange};

 PUBLIC PROCEDURE CarPro_OnBeforeEdit();
 BEGIN
  SetDataInForm(CarPro.Property);
 END {CarPro_OnBeforeEdit};

 PUBLIC PROCEDURE CarOilCor(_BoxNbr: LIKE(CarPro.BoxNbr); D: DATE; VAR OilCorr: L_Fuel.tCarOilCoef);
  VAR
   _Value: LIKE(CarPro.Value);
 BEGIN
  _Value:=GetCarProSoft(_BoxNbr, D, P_CarOilCor);
  SetCarOilCorData(_Value, OilCorr);
 END {CarOilCor};

 PUBLIC PROCEDURE HasTurnstile(trgBoxNbr: LIKE(CarPro.BoxNbr); D: DATE): SCAL[2];
 BEGIN
  RETURN HasActualCarPro(trgBoxNbr, D, P_WithASCP) &
         (L_Prop.GetProValueAsScal(GetPool(P_WithASCP), CarPro.Value) = ascpTurnstile);
 END {HasTurnstile};

 PUBLIC PROCEDURE HasValidator(trgBoxNbr: LIKE(CarPro.BoxNbr); D: DATE): SCAL[2];
 BEGIN
  RETURN HasActualCarPro(trgBoxNbr, D, P_WithASCP) &
         (L_Prop.GetProValueAsScal(GetPool(P_WithASCP), CarPro.Value) = ascpValidator);
 END {HasValidator};

 PRIVATE PROCEDURE AnyInsurance_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (0, ["Value", "DocGiveS", "EndD"]);
  L_WDO.iUnmodifiable(0, ["ObjectTitle", "ObjectDescr", "PeriodName", "EndTypeStr"]);
  L_WDO.iMayBeEmpty  (0, ["DocNum", "DocSer", "DocGiveD", "DocGiveS", "EndD", "Insurance"]);
  L_WDO.iProgs       (0, "ObjPro");
 END {AnyInsurance_OnInitializeWindow};

 PUBLIC PROCEDURE P_1170_OnInitializeWindow();
 BEGIN
  AnyInsurance_OnInitializeWindow();
 END {P_1170_OnInitializeWindow};

 PUBLIC PROCEDURE P_1153_OnInitializeWindow();
 BEGIN
  AnyInsurance_OnInitializeWindow();
 END {P_1153_OnInitializeWindow};

 PUBLIC PROCEDURE P_1173_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ObjPro";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iField       (0, "DocGiveS").Last:=1;
  L_WDO.iField       (0, "Reason").LineBreakEnable:=0;
  L_WDO.iField       (0, "Reaction").Template:="饭|롮| 롮|";
  L_WDO.iField       (0, "Reaction").TemplateIsStrict:=1;
  L_WDO.iScsChange   (0, ["DocExpD", "DocGiveS"]);
  L_WDO.iUnmodifiable(0, ["ObjectDescr", "ObjectTitle"]);
  L_WDO.iMayBeEmpty  (0, ["DocSer", "DocNum", "DocExpD", "DocGiveS", "DocGiveD"]);
  L_WDO.iProgs       (0, "ObjPro");
 END {P_1173_OnInitializeWindow};

 PUBLIC PROCEDURE GetBegRWSSpecific(    trgBoxNbr: LIKE(CarPro.BoxNbr);
                                        D        : DATE;
                                    VAR Reaction : L_BegRWS.tCrewFitnessForExit;
                                    VAR Reason   : STRING[]);
  VAR
   s: STRING[];
 BEGIN
  Reaction:=L_BegRWS.cffe_Yes;
  IF HasActualCarPro(trgBoxNbr, D, P_BegRWSSpecific) THEN
   s:=L_Prop.getRES(CarPro.Value, 0);
   IF    s ="롮"        THEN
    Reaction:=L_BegRWS.cffe_wChoice;
   ELSIF s =""       THEN
    Reaction:=L_BegRWS.cffe_No;
   ELSIF s ="饭"    THEN
    Reaction:=L_BegRWS.cffe_wInform;
   ELSIF s =" 롮" THEN
    Reaction:=L_BegRWS.cffe_wCrucialChoice;
   END;
   Reason:=L_Prop.getRES(CarPro.Value, 1);
  ELSE
   Reason:="";
  END;
 END {GetBegRWSSpecific};

END.
