(*
%Copyright   (c) Polak IT
%Author      17.07.2012 18:02:29 POLAK\LDA
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    04.01.2014 13:27:10 POLAK\San
%Environment
*)

 MODULE P_Column [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_r2r, L_Prop, P_Firm, L_Str;

 PUBLIC CONST
  P_MyPlace = 5500;

 PUBLIC PROCEDURE IsSimpleUserOf(curProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF curProperty = P_MyPlace THEN
   RETURN "MyPlace";
  ELSE
   RETURN "";
  END;
 END {IsSimpleUserOf};

 PUBLIC PROCEDURE HasPro(trgColumn: LIKE(Column.Column); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SELECT(ClmnPro, Column, trgColumn, trgProperty) & SRCINSEL(ClmnPro, LE, D);
 END {HasPro};

 PUBLIC PROCEDURE HasActualPro(trgColumn: LIKE(Column.Column); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasPro(trgColumn, D, trgProperty) & (!ClmnPro.DocExpD | (D < ClmnPro.DocExpD));
 END {HasActualPro};

 PRIVATE PROCEDURE Decode_Pro(trgValue   : STRING[];
                              trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  L_General.CallUs(~!IsSimpleUserOf(trgProperty));
  RETURN L_r2r.DecodeReferenceStamp(trgValue);
 END {Decode_Pro};

 PRIVATE PROCEDURE intGetPro(trgColumn  : LIKE(Column.Column);
                             D          : DATE;
                             trgProperty: LIKE(Property.Property);
                             Actual     : SCAL[2];
                             Strong     : SCAL[2]): STRING[];
  VAR
   Has   : SCAL[2];
   Result: STRING[];
 BEGIN
  IF Actual THEN
   Has:=HasActualPro(trgColumn, D, trgProperty);
  ELSE
   Has:=HasPro(trgColumn, D, trgProperty);
  END;
  SETEMPTY(Result);
  IF Has THEN
   IF ~!IsSimpleUserOf(trgProperty) THEN
    Result:=Decode_Pro(ClmnPro.Value, trgProperty);
   ELSE
    Result:=ClmnPro.Value;
   END;
  ELSE
   IF Strong THEN
    SEARCH(Column, Column, , trgColumn);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("Column").Id, Column.RECORDID, trgProperty, D);
   END;
  END;
  RETURN Result;
 END {intGetPro};

 PUBLIC PROCEDURE GetProStrong(trgColumn: LIKE(Column.Column); D: DATE; trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN intGetPro(trgColumn, D, trgProperty, 1, 1);
 END {GetProStrong};

 PUBLIC PROCEDURE GetProSoft(trgColumn: LIKE(Column.Column); D: DATE; trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN intGetPro(trgColumn, D, trgProperty, 1, 0);
 END {GetProSoft};

 PUBLIC PROCEDURE Value_OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_MyPlace THEN
   L_General.Assert(STRTOFLD(RTI.Get().CurZone.Fields("Value").Value, NUMERIC) # P_Firm.mp_Fict,
                    "'⮯' "+L_Str.FixedIntStr(P_Firm.mp_Fict, 4)+"    㪠  ᢮⢥");
  END;
 END {Value_OnSuccessfulChange};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Result    : STRING[];
   trgMyPlace: LIKE(MyPlace.MyPlace);
 BEGIN
  SETEMPTY(Result);
  IF    ClmnPro.Property = P_MyPlace THEN
   trgMyPlace:=L_r2r.DecodeReferenceStamp(ClmnPro.Value);
   IF ~!trgMyPlace THEN
    SEARCH(MyPlace, MyPlace, , trgMyPlace);
    Result:=MyPlace.MyPlace + " " + MyPlace.Name;
   END;
  ELSE
   Result:=ClmnPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PUBLIC PROCEDURE GetMyPlace(trgColumn: LIKE(Column.Column); trgD: DATE): LIKE(MyPlace.MyPlace);
  VAR
   Result: LIKE(MyPlace.MyPlace);
 BEGIN
  Result:=GetProSoft(trgColumn, trgD, P_MyPlace);
  IF !Result THEN
   SEARCH(Column, Column, , trgColumn);
   Result:=P_Firm.GetMainMyPlace(trgD, Column.MyFirm);
  END;
  RETURN Result;
 END {GetMyPlace};

END.
