(*
%Copyright   (c) Polak IT
%Author      10.10.2005 12:36:48 POLAK\Bor
%Purpose     ⥪  ࠡ  ᢮⢠ StExit
%Type        library
%Specific    AP
%Modified    20.02.2014 17:21:28 POLAK\GAV
%Environment
*)

 MODULE P_Exit [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  P_InvalidFacilities = 1401;
  P_MkBegAuto         = 1402; (*५*)
  P_WithASCP          = 1404;
  P_ExitFeature       = 1405;

 IMPORT L_Prop, L_General, L_DatTim, Str, L_Str, L_BegRWS;

 PUBLIC PROCEDURE PropertyModificationAllowed(_Property: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF    _Property = P_MkBegAuto THEN
   RETURN L_Prop.mac_Old;
  ELSIF _Property = P_InvalidFacilities THEN
   RETURN L_Prop.mac_Inside;
  ELSE
   RETURN L_Prop.mac_Full;
  END;
 END {PropertyModificationAllowed};

 PUBLIC PROCEDURE GetPool(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    _Property = P_InvalidFacilities THEN
   RETURN "|";
  ELSIF _Property = P_MkBegAuto THEN
   RETURN "饭|襭";
  ELSIF _Property = P_WithASCP THEN
   RETURN "|";
  ELSIF L_Prop.IsLocalProperty(_Property) THEN
   RETURN L_Prop.E_GetPool(_Property);
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PUBLIC PROCEDURE HasPro(_Exit: LIKE(StExit.Exit); _Date: DATE; _Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SELECT(ExitPro, Exit, _Exit, _Property) & SRCINSEL(ExitPro, LE, _Date);
 END {HasPro};

 PUBLIC PROCEDURE HasActualPro(_Exit: LIKE(StExit.Exit); _Date: DATE; _Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasPro(_Exit, _Date, _Property) & (!ExitPro.DocExpD | (_Date < ExitPro.DocExpD));
 END {HasActualPro};

 PUBLIC PROCEDURE GetProValueStrong(_Exit: LIKE(StExit.Exit); _Date: DATE; _Property: LIKE(Property.Property)): LIKE(ExitPro.Value);
 BEGIN
  IF ~HasActualPro(_Exit, _Date, _Property) THEN
   SEARCH(StExit, Exit, , _Exit);
   L_Prop.ShowUndefinedProValueError(TABLE.Get("StExit").Id, StExit.RECORDID, _Property, _Date);
  END;
  RETURN ExitPro.Value;
 END {GetProValueStrong};

 PUBLIC PROCEDURE GetProValueSoft(_Exit: LIKE(StExit.Exit); _Date: DATE; _Property: LIKE(Property.Property)): LIKE(ExitPro.Value);
  VAR
   _Value: LIKE(ExitPro.Value);
 BEGIN
  IF HasActualPro(_Exit, _Date, _Property) THEN
   _Value:=ExitPro.Value;
  ELSE
   SETEMPTY(_Value);
  END;
  RETURN _Value;
 END {GetProValueSoft};

END.