(*
%Copyright   (c) Polak Computer System
%Author      24.08.2000 19:07:08 BOR
%Purpose     ⥪  ࠡ  ᢮⢠ Route
%Type        library
%Specific    AP
%Modified    03.12.2013 13:12:23 POLAK\GAV
%Environment
*)

 MODULE P_Route [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Prop, L_General, L_Str, L_Pool, L_WDO, L_qs;

 PUBLIC CONST
  P_OtherRoute        = 5009;
  P_IncomeDetail      = 5010;
  P_AdvertisingGroup  = 5011;
  P_PsgRndCharact     = 5016;
  P_FuelNormCoef      = 5017;
  P_CodeInHeadFirm    = 5018;
  P_ASDC              = 5019; (*⮬᪠ ⥬ ᯥ᪮ ࠢ*)
  P_InvalidFacilities = 5020;
  P_WithASCP          = 5021;
  P_Accuracy          = 5022;
  P_Group             = 5023;

  qsa_InHFReestrCode  = 0;
  qsa_InHFSign        = 1;
  CoefPassAmount      = 5;

 PUBLIC TYPE
  twASCP = SCAL[3];
  tAverageLength    = NUMERIC[2];                   (*।  *)
  tRunAroundTripTim = NUMERIC[1];                   (*६ ⭮ ३*)
  tPsgs             = NUMERIC[0];                   (*ᠦய⮪*)
  tCoefPass         = NUMERIC[6,3][CoefPassAmount]; (*-  ᠦࠬ  ࠧ *)

 PUBLIC CONST
  wascp_None     = 0;
  wascp_Normal   = 1;
  wascp_Starting = 2;

 PRIVATE CONST
  pool_Group = 0000950;
  asdch_Pool = "|";

 PUBLIC PROCEDURE GetRouteProPool(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_OtherRoute THEN
   RETURN "|";
  ELSIF trgProperty = P_IncomeDetail THEN
   RETURN "| ३|  ३";
  ELSIF trgProperty = P_InvalidFacilities THEN
   RETURN "|";
  ELSIF trgProperty = P_WithASCP THEN
   RETURN "|ਮ ᪠";
  ELSIF trgProperty = P_AdvertisingGroup THEN
   RETURN "0|1|2|3|4|5|6|7|8|9|10";
  ELSIF trgProperty = P_Group THEN
   RETURN L_Pool.Get(pool_Group);
  ELSIF L_Prop.IsLocalProperty(trgProperty) THEN
   RETURN L_Prop.E_GetPool(trgProperty);
  ELSE
   RETURN "";
  END;
 END {GetRouteProPool};

 PUBLIC PROCEDURE GetSubWindowName(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_PsgRndCharact THEN
   RETURN "P_5016";
  ELSIF trgProperty = P_CodeInHeadFirm THEN
   RETURN "P_5018";
  ELSIF trgProperty = P_ASDC THEN
   RETURN "P_5019";
  ELSIF trgProperty = P_Accuracy THEN
   RETURN "P_5022";
  ELSE
   RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE PsgRndCharact_DecodeValue(    Value              : STRING[];
                                            VAR trgAverageLength   : tAverageLength;
                                            VAR trgRunAroundTripTim: tRunAroundTripTim;
                                            VAR trgPsgs            : tPsgs;
                                            VAR trgCoefPass        : tCoefPass);
  VAR
   Idx: SCAL[CoefPassAmount];
 BEGIN
  trgAverageLength   :=STRTOFLD(L_Prop.getRES(Value, 0), NUMERIC);
  trgRunAroundTripTim:=STRTOFLD(L_Prop.getRES(Value, 1), NUMERIC);
  trgPsgs            :=STRTOFLD(L_Prop.getRES(Value, 2), NUMERIC);
  FOR_EACH Idx DO
   trgCoefPass[Idx]:=STRTOFLD(L_Prop.getRES(Value, Idx+3), NUMERIC);
  END;
 END {PsgRndCharact_DecodeValue};

 PRIVATE PROCEDURE formSet_PsgRndCharact();
  VAR
   trgAverageLength   : tAverageLength;
   trgRunAroundTripTim: tRunAroundTripTim;
   trgPsgs            : tPsgs;
   trgCoefPass        : tCoefPass;
   Fields             : FORM_FIELDS;
   Idx                : SCAL[CoefPassAmount];
 BEGIN
  PsgRndCharact_DecodeValue(RoutePro.Value, trgAverageLength, trgRunAroundTripTim, trgPsgs, trgCoefPass);
  Fields:=RTI.Get().CurZone.Fields;
  Fields("AverageLength"   ).Value:=trgAverageLength;
  Fields("RunAroundTripTim").Value:=trgRunAroundTripTim;
  Fields("Psgs"            ).Value:=trgPsgs;
  FOR_EACH Idx DO
   Fields(L_WDO.Fld_wIdx("CoefPass", Idx)).Value:=trgCoefPass[Idx];
  END;
 END {formSet_PsgRndCharact};

 PRIVATE PROCEDURE PsgRndCharact_EncodeValue(VAR Value              : STRING[];
                                                 trgAverageLength   : tAverageLength;
                                                 trgRunAroundTripTim: tRunAroundTripTim;
                                                 trgPsgs            : tPsgs;
                                                 trgCoefPass        : tCoefPass);
  VAR
   Idx     : SCAL[CoefPassAmount];
   NotEmpty: SCAL[2];
 BEGIN
  NotEmpty:=~!trgAverageLength | ~!trgRunAroundTripTim | ~!trgPsgs;
  FOR_EACH Idx DO
   NotEmpty:=NotEmpty | ~!trgCoefPass[Idx];
  END;
  IF NotEmpty THEN
   L_Prop.putREV(Value, trgAverageLength);
   L_Prop.putREV(Value, trgRunAroundTripTim);
   L_Prop.putREV(Value, trgPsgs);
   FOR_EACH Idx DO
    L_Prop.putREV(Value, trgCoefPass[Idx]);
   END;
  END;
 END {PsgRndCharact_EncodeValue};

 PRIVATE PROCEDURE formGet_PsgRndCharac();
  VAR
   trgAverageLength   : tAverageLength;
   trgRunAroundTripTim: tRunAroundTripTim;
   trgPsgs            : tPsgs;
   trgCoefPass        : tCoefPass;
   Fields             : FORM_FIELDS;
   Idx                : SCAL[CoefPassAmount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  trgAverageLength   :=Fields("AverageLength"   ).Value;
  trgRunAroundTripTim:=Fields("RunAroundTripTim").Value;
  trgPsgs            :=Fields("Psgs"            ).Value;
  FOR_EACH Idx DO
   trgCoefPass[Idx]:=Fields(L_WDO.Fld_wIdx("CoefPass", Idx)).Value;
  END;
  PsgRndCharact_EncodeValue(RoutePro.Value, trgAverageLength, trgRunAroundTripTim, trgPsgs, trgCoefPass);
 END {formGet_PsgRndCharac};

 PUBLIC PROCEDURE ASDC_DecodeValue(    Value      : STRING[];
                                   VAR trgHas     : SCAL[2];
                                   VAR trgCodeInTN: STRING[]);
 BEGIN
  trgHas     :=L_Str.PositionInPool(asdch_Pool, L_Prop.getRES(Value, 0));
  trgCodeInTN:=L_Prop.getRES(Value, 1);
 END {ASDC_DecodeValue};

 PRIVATE PROCEDURE formSet_ASDC();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields              :=RTI.Get().CurZone.Fields;
  Fields("Has").Format:=asdch_Pool;
  ASDC_DecodeValue(RoutePro.Value, Fields("Has").Value, Fields("CodeInTN").Value);
 END {formSet_ASDC};

 PRIVATE PROCEDURE ASDC_EncodeValue(VAR Value      : STRING[];
                                        trgHas     : SCAL[2];
                                        trgCodeInTN: STRING[]);
  VAR
   s: STRING[];
 BEGIN
  IF trgHas THEN
   s:=L_Str.PoolItem(asdch_Pool, trgHas);
   L_Prop.putREV(Value, s);
   L_Prop.putREV(Value, trgCodeInTN);
  END;
 END {ASDC_EncodeValue};

 PRIVATE PROCEDURE formGet_ASDC();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  ASDC_EncodeValue(RoutePro.Value, Fields("Has").Value, Fields("CodeInTN").Value);
  RoutePro.SpdSrchV:=Fields("CodeInTN").Value;
 END {formGet_ASDC};

 PUBLIC PROCEDURE Value_OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_Group THEN
   L_Pool.Put(pool_Group, RoutePro.Value);
  END;
 END {Value_OnSuccessfulChange};

 PUBLIC PROCEDURE RoutePro_Check(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    (trgProperty = P_FuelNormCoef) THEN
   L_Prop.CheckNumericValue(RoutePro.Value, "");
  END;
 END {RoutePro_Check};

 PRIVATE PROCEDURE OnBeforeModification();
 BEGIN
  IF RoutePro.Property = P_CodeInHeadFirm THEN
   L_qs.OnBeforeDelete("RoutePro");
  END;
 END {OnBeforeModification};

 PUBLIC PROCEDURE OnBeforeEdit();
 BEGIN
  OnBeforeModification();
 END {OnBeforeEdit};

 PUBLIC PROCEDURE OnBeforeDelete();
 BEGIN
  OnBeforeModification();
 END {OnBeforeDelete};

 PRIVATE PROCEDURE OnAfterEdIns();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  IF RoutePro.Property = P_CodeInHeadFirm THEN
   Fields:=RTI.Get().CurZone.Fields;
   L_qs.byPro_Add("RoutePro", qsa_InHFReestrCode, L_Str.IntStr(Fields("InHFReestrCode").Value));
   L_qs.byPro_Add("RoutePro", qsa_InHFSign,       Fields("InHFSign").Value);
  END;
 END {OnAfterEdIns};

 PUBLIC PROCEDURE OnAfterInsert();
 BEGIN
  OnAfterEdIns();
 END {OnAfterInsert};

 PUBLIC PROCEDURE OnAfterEdit();
 BEGIN
  OnAfterEdIns();
 END {OnAfterEdit};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=RoutePro.Value;
  RETURN Result;
 END {GetVal2Show};

 PRIVATE PROCEDURE formSet_CodeInHeadFirm();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("InHFReestrCode").Value:=STRTOFLD(L_Prop.getRES(RoutePro.Value, 0), NUMERIC);
  Fields("InHFSign").Value:=L_Prop.getRES(RoutePro.Value, 1);
  Fields("InHFName").Value:=L_Prop.getRES(RoutePro.Value, 2);
 END {formSet_CodeInHeadFirm};

 PRIVATE PROCEDURE formSet_Accuracy();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Value_0").Value:=STRTOFLD(L_Prop.getRES(RoutePro.Value, 0), NUMERIC);
  Fields("Value_1").Value:=STRTOFLD(L_Prop.getRES(RoutePro.Value, 1), NUMERIC);
 END {formSet_Accuracy};

 PUBLIC PROCEDURE SetDataInForm(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_PsgRndCharact THEN
   formSet_PsgRndCharact();
  ELSIF trgProperty = P_ASDC THEN
   formSet_ASDC();
  ELSIF trgProperty = P_CodeInHeadFirm THEN
   formSet_CodeInHeadFirm();
  ELSIF trgProperty = P_Accuracy THEN
   formSet_Accuracy();
  END;
 END {SetDataInForm};

 PRIVATE PROCEDURE formGet_CodeInHeadFirm();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_Prop.putREV(RoutePro.Value, Fields("InHFReestrCode").Value);
  L_Prop.putREV(RoutePro.Value, Fields("InHFSign").Value);
  L_Prop.putREV(RoutePro.Value, Fields("InHFName").Value);
 END {formGet_CodeInHeadFirm};

 PRIVATE PROCEDURE formGet_Accuracy();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_Prop.putREV(RoutePro.Value, Fields("Value_0").Value);
  L_Prop.putREV(RoutePro.Value, Fields("Value_1").Value);
 END {formGet_Accuracy};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty: LIKE(Property.Property));
 BEGIN
  SETEMPTY(RoutePro.Value);
  IF    trgProperty = P_PsgRndCharact THEN
   formGet_PsgRndCharac();
  ELSIF trgProperty = P_CodeInHeadFirm THEN
   formGet_CodeInHeadFirm();
  ELSIF trgProperty = P_ASDC THEN
   formGet_ASDC();
  ELSIF trgProperty = P_Accuracy THEN
   formGet_Accuracy();
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(RoutePro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE HasRoutePro(trgRoute: LIKE(Route.Route); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SELECT(RoutePro, Route, trgRoute, trgProperty) & SRCINSEL(RoutePro, LE, D);
 END {HasRoutePro};

 PUBLIC PROCEDURE HasActualRoutePro(trgRoute: LIKE(Route.Route); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasRoutePro(trgRoute, D, trgProperty) & (!RoutePro.DocExpD | (D < RoutePro.DocExpD));
 END {HasActualRoutePro};

 PUBLIC PROCEDURE GetRouteProStrong(trgRoute: LIKE(Route.Route); D: DATE; trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF ~HasActualRoutePro(trgRoute, D, trgProperty) THEN
   SEARCH(Route, Route, , trgRoute);
   L_Prop.ShowUndefinedProValueError(TABLE.Get("Route").Id, Route.RECORDID, trgProperty, D);
  END;
  RETURN RoutePro.Value;
 END {GetRouteProStrong};

 PUBLIC PROCEDURE GetRouteProSoft(trgRoute: LIKE(Route.Route); D: DATE; trgProperty: LIKE(Property.Property)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF HasActualRoutePro(trgRoute, D, trgProperty) THEN
   Result:=RoutePro.Value;
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetRouteProSoft};

 PUBLIC PROCEDURE Get_wASCP(trgRoute: LIKE(Route.Route); D: DATE): twASCP;
 BEGIN
  IF HasActualRoutePro(trgRoute, D, P_WithASCP) THEN
   RETURN L_Prop.GetProValueAsScal(GetRouteProPool(P_WithASCP), RoutePro.Value) + 1;
  ELSE
   RETURN wascp_None;
  END;
 END {Get_wASCP};

 PUBLIC PROCEDURE GetCurProGroupName(CurVal: SCAL[2]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  L_General.CallUs(ACCESS(RoutePro));
  IF RoutePro.Property = P_Group THEN
   IF CurVal THEN
    Result:=RoutePro.Value;
   ELSE
    Result:=GE_PVALUE(RoutePro.Value);
   END;
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetCurProGroupName};

 PUBLIC PROCEDURE GetAccuracy(trgRoute: LIKE(Route.Route); PikTim: SCAL[2]; D: DATE): NUMERIC[2];
 BEGIN
  RETURN L_Prop.GetNumericValueFromStr(L_Prop.getRES(GetRouteProStrong(trgRoute, D, P_Accuracy), PikTim));
 END {GetAccuracy};

END.
