(*
%Copyright   (c) Polak IT
%Author      07.10.2003 12:47:58 POLAK\LDA
%Purpose        
%Type        report
%Specific    AP
%Modified    06.08.2014 11:55:08 POLAK\GAV
%Environment
*)

 MODULE RC_DL [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_Rpr, L_XDoc, Memo, Math, L_AFM,
        L_StdFrm, Str, L_Str, L_Car, L_DatTim, L_AR;

 PRIVATE TYPE
  tRprSState = SCAL[4];

 PRIVATE CONST
  RepName = "RCDLR";

  rprs_Insert     = 0;
  rprs_IntoOp     = 1;
  rprs_IntoOp_New = 2;
  rprs_Cancel     = 3;

 PRIVATE VAR
  _AcsObj          : LIKE(AcsObj.AcsObj);
  BDate, EDate     : DATE;
  BTime, ETime     : TIME;
  Total            : NUMERIC[0];
  TotalsByOperation: NUMERIC[0][3];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
BDate, L, "D.N.y"
BTime, L, "H:M"
EDate, L, "D.N.y"
ETime, L, "H:M"
?, L, ""
@
#######################################################################################       ########## #####
=#####========================================================================================================
|                                ६⭮   ᬥ                          |
|                                     ########## #####  ########## #####                                  |
| ###################################################################################################|
}
*)


(*
$P{ SubTop:
?, L, ""
?, L, ""
@
|============================================================================================================|
|##############################################################                                              |
|------------------------------------------------------------------------------------------------------------|
|    |ꥪ ६           |⨥   | ᯫ|ࠢ                   |###########|
|-------|-------------------------|--------------|--------------|--------------------------------|-----------|
}
*)

 PRIVATE PROCEDURE GetRprSOpenDesigner(): STRING[];
 BEGIN
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS);
  L_General.CallUs(XDocJrn.Action = L_XDoc.action_Insert);
  CONFORM(XDocJrn, AcsObj);
  RETURN L_Str.ShortName(L_AR.GetAcsObjManName());
 END {GetRprSOpenDesigner};

 PRIVATE PROCEDURE GetRprSInExplDesigner(): STRING[];
 BEGIN
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, _RprS.RprS);
  LAST(XDocJrn);
  WHILE OCCURE(XDocJrn) & (XDocJrn.Action # L_XDoc.action_rprPuttingIntoOperation) DO
   PREV(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ... *)
  CONFORM(XDocJrn, AcsObj);
  RETURN L_Str.ShortName(L_AR.GetAcsObjManName());
 END {GetRprSInExplDesigner};

(*
$P{ Line:
RprS.RprS, L, ""
RprS.RprObjId, L, ""
RprS.RprObjT, L, L_Rpr.rot_Pool_Short
L_Rpr.GetRprSObjDescr(), L, ""
_RprS.BDate, L, "D.N.Y"
_RprS.BTime, L, "H:M"
?, L, "D.N.Y"
?, L, "H:M"
?, L, ""
?, L, ""
@
|#######|####### # ###############|######## #####|######## #####|################################|###########|
}
*)

(*
$P{ Line_Add:
?, L, ""
@
|       |                         |              |              |################################|           |
}
*)

(*
$P{ Bot:
Total, R, "0"
TotalsByOperation[rprs_Insert], R, "0"
TotalsByOperation[rprs_IntoOp] + TotalsByOperation[rprs_IntoOp_New], R, "0"
@
|------------------------------------------------------------------------------------------------------------|
|ᥣ #####                  #####           ।  ᯫ #####                |
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(_RprS, "", "", "");

  CreateFIELD(_RprS, RprS,     LIKE(RprS.RprS), "", "", "", "", "");
  CreateFIELD(_RprS, BDate,    DATE, "", "", "", "", "");
  CreateFIELD(_RprS, BTime,    TIME, "", "", "", "", "");
  CreateFIELD(_RprS, AcsObj,   LIKE(AcsObj.AcsObj), "", "", "", "", "");
  CreateFIELD(_RprS, State,    tRprSState, "", "", "", "", "0 - ⠢, 1 -  ᯫ");

  CreateINDEXandLINK(_RprS, RprS, PLURAL, RprS, RprS, USER, "", "", RprS);
  CreateINDEX(_RprS, State, UNIQUE, "", "", State, RprS);
  CreateINDEX(_RprS, AcsObj, PLURAL, "", "", AcsObj);

  SetVersionOfFILE(_RprS, 01);
  L_AFM.AF_CreateTemp("_RprS", "_RprS");
 END {Create_Tmp};

 PRIVATE PROCEDURE PutOneRprS(_State: tRprSState);
 BEGIN
  IF    (_State = rprs_Insert) | (_State = rprs_IntoOp) THEN
   IF (_State = rprs_IntoOp) & SEARCH(_RprS, State, rprs_Insert, XDocJrn.XDoc) THEN
    _State:=rprs_IntoOp_New;
   END;

   IF ~SEARCH(_RprS, State, _State, XDocJrn.XDoc) THEN
    DEFAULT(_RprS);
    _RprS.RprS  :=XDocJrn.XDoc;
    _RprS.AcsObj:=XDocJrn.AcsObj;
    _RprS.State :=_State;

    SAVE(XDocJrn);
    SELECT(XDocJrn, XDocJrn, , XDocJrn.XDocType, XDocJrn.XDocKind, XDocJrn.XDoc);
    L_General.CallUs(XDocJrn.Action = L_XDoc.action_Insert);
    _RprS.BDate:=XDocJrn.Date;
    _RprS.BTime:=XDocJrn.BegTime;
    RESTORE(XDocJrn);
    INSERT(_RprS);

    INC(Total);
    INC(TotalsByOperation[_State]);
   END;
  ELSIF _State = rprs_Cancel THEN
   IF SELECT(_RprS, RprS, XDocJrn.XDoc) THEN
    DEC(Total);
    DEC(TotalsByOperation[rprs_IntoOp]);
   END;

   IF SEARCH(_RprS, State, rprs_IntoOp, XDocJrn.XDoc) THEN
    REMOVE(_RprS);
   END;
  END;
 END {PutOneRprS};

 PRIVATE PROCEDURE IsInSession(): SCAL[2];
 BEGIN
  RETURN ((XDocJrn.Date > BDate) | ((XDocJrn.Date = BDate) & (XDocJrn.BegTime >= BTime))) &
         ((XDocJrn.Date < EDate) | ((XDocJrn.Date = EDate) & (XDocJrn.BegTime <  ETime)));
 END {IsInSession};

 PRIVATE PROCEDURE Gather();
 BEGIN
  SETZERO(Total, TotalsByOperation);
  SELECT(XDocJrn, UserIdx, , L_XDoc.xdt_RprS, _AcsObj);
  SRCINSEL(XDocJrn, GE, , BDate, BTime);
  WHILE OCCURE(XDocJrn) & IsInSession() DO
   PROMPT("⮢  " + XDocJrn.XDoc);
   IF    XDocJrn.Action = L_XDoc.action_Insert THEN
    PutOneRprS(rprs_Insert);
   ELSIF (XDocJrn.Action = L_XDoc.action_rprPuttingIntoOperation) THEN
    PutOneRprS(rprs_IntoOp);
   ELSIF XDocJrn.Action = L_XDoc.action_rprCnclPuttingIntoOperation THEN
    PutOneRprS(rprs_Cancel);
   END;
   NEXT(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ... *)
 END {Gather};

 PRIVATE PROCEDURE IsRprSOperator(): SCAL[2];
 BEGIN
  RETURN (XDocJrn.Action = L_XDoc.action_Insert)                  |
         (XDocJrn.Action = L_XDoc.action_rprPuttingIntoOperation) |
         (XDocJrn.Action = L_XDoc.action_rprCnclPuttingIntoOperation);
 END {IsRprSOperator};

 PUBLIC PROCEDURE MakeRep();
  VAR
   FullRprDA_AsStr: STRING[];
   RprDA_AsArrStr : STRING[][10];
   i              : NUMERIC[0];
   _EDate         : DATE;
   _ETime         : TIME;
   DesignerName,
   Text           : STRING[];
   TotalsByACSobj : NUMERIC[0][2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Rpr.GetCurShiftBeginEnd(BDate, BTime, EDate, ETime);
  STDFORM(L_StdFrm.sf_Choice( "%#############% %##########% %#####%" +
                             "|" +
                             "|%#############% %##########% %#####%",
                             "%<砫 ᬥ>T" +
                             "%<D.N.y>I" +
                             "%<H:M>I" +
                             "%<砭 ᬥ>T" +
                             "%<D.N.y>I" +
                             "%<H:M>I"),
          " ਮ ࠡ ᬥ ", , 1, BDate, BTime, EDate, ETime);
 
  Create_Tmp();

  _AcsObj:=L_XDoc.ChooseAcsObj(L_XDoc.xdt_RprS, BDate, EDate, BTime, ETime, PROCREF(IsRprSOperator));
  Gather();

  L_XDoc.sl_Init("  ");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  SEARCH(AcsObj, AcsObj, , _AcsObj);
  MAKEPART(R, Top, AcsObj.Name + " " + L_AR.GetAcsObjManName());

  SETZERO(TotalsByACSobj);
  SELECT(_RprS, State);
  WHILE OCCURE(_RprS) DO
   NARROWSEL(_RprS, State);
   IF (_RprS.State = rprs_Insert) | (_RprS.State = rprs_IntoOp) THEN
    WHILE OCCURE(_RprS) DO
     PROMPT(" ⮣ " + _RprS.RprS);
     INC(TotalsByACSobj[_RprS.State]);
     NEXT(_RprS);
    END; (* WHILE OCCURE(_RprS) ... *)
   END;
   NEXTINEXTENDEDSEL(_RprS, State);
  END; (* WHILE OCCURE(_RprS) ... *)

  SELECT(_RprS, State);
  WHILE OCCURE(_RprS) DO
   NARROWSEL(_RprS, State);
   IF (_RprS.State = rprs_Insert) | (_RprS.State = rprs_IntoOp) THEN
    MAKEPART(R, SubTop, L_Str.PoolItem("  |।  ᯫ   ࠭ ", _RprS.State) + ": " + L_Str.IntStr(TotalsByACSobj[_RprS.State]), L_Str.PoolItem("ਬ砭|ନ⥫", _RprS.State));
    WHILE OCCURE(_RprS) DO
     PROMPT(" " + _RprS.RprS);
     CONFORM(_RprS, RprS);
     CONFORM(RprS, CUCopy);
     L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS),
                       RprS.RprS + " " +
                       L_DatTim.DateStr(RprS.OrdDate) + " " +
                       L_DatTim.DateStr(RprS.EDate)   + " " +
                       L_Str.PoolItem("-|", RprS.Closed));
     SETEMPTY(FullRprDA_AsStr);
     SELECT(RprDA, RprS, , RprS.RprS);
     WHILE OCCURE(RprDA) DO
      CONFORM(RprDA, CarBlock);
      CONFORM(RprDA, RprDfApr);
      FullRprDA_AsStr:=FullRprDA_AsStr + Str.Delete(L_Rpr.GetRprDA_AsStr(), 0, 2) + L_Str.CRLF;
      NEXT(RprDA);
     END; (* WHILE OCCURE(RprDA)...*)
 
     SETEMPTY(_EDate, _ETime);
 
     IF RprS.Status # L_Rpr.ms_Cancel THEN
      SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, _RprS.RprS);
      LAST(XDocJrn);
      WHILE OCCURE(XDocJrn) &
            (XDocJrn.Action # L_XDoc.action_rprPuttingIntoOperation) &
            (XDocJrn.Action # L_XDoc.action_rprCnclPuttingIntoOperation) DO
       PREV(XDocJrn);
      END; (* WHILE OCCURE(XDocJrn) ... *)
  
      IF OCCURE(XDocJrn) & (XDocJrn.Action = L_XDoc.action_rprPuttingIntoOperation) THEN
       _EDate:=XDocJrn.Date;
       _ETime:=XDocJrn.EndTime;
      END;
     END;
 
     IF (RprS.Closed = 0) | (RprS.Status = L_Rpr.ms_Cancel) THEN
      Text:=L_Rpr.GetRprSStatus_AsStr(RprS.Status);
     ELSE
      DesignerName:=GetRprSOpenDesigner();
      IF _RprS.State = rprs_Insert THEN
       Text:=GetRprSInExplDesigner();
       IF DesignerName = Text THEN
        Text:=L_Rpr.GetRprSStatus_AsStr(RprS.Status);
       END;
      ELSE
       Text:=DesignerName;
      END;
     END;
 
     Str.Format(RprDA_AsArrStr, FullRprDA_AsStr, 32, LEFT);
     MAKEPART(R, Line, _EDate, _ETime, RprDA_AsArrStr[0], Text);
 
     i:=1;
     WHILE (i <= HIGH(RprDA_AsArrStr)) & (~!RprDA_AsArrStr[i]) DO
      MAKEPART(R, Line_Add, RprDA_AsArrStr[i]);
      INC(i);
     END; (* WHILE i <= HIGH(RprDA_AsArrStr)...*)
     NEXT(_RprS);
    END; (* WHILE OCCURE(_RprS) ... *)
   END;
   NEXTINEXTENDEDSEL(_RprS, State);
  END; (* WHILE OCCURE(_RprS) ... *)
  MAKEPART(R, Bot);
  L_AFM.AF_PurgeTemp("_RprS");
  L_XDoc.sl_Done();
 END {MakeRep};

END.
