(*
%Copyright   (c) Polak Computer System
%Author      13.05.1997 13:16:48 MOG
%Purpose     䨪 Route
%Type        control
%Specific    AP
%Modified    14.11.2013 16:55:40 POLAK\GAV
%Environment
*)

 MODULE Route [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, L_CI, L_r2r, L_DBD,
        L_WDO, L_AR, L_StdFrm, Math, L_Way, L_Str, L_Prop;

 PRIVATE PROCEDURE SetRouteLogTill();
  VAR
   _Till: LIKE(RouteLog.Till);
 BEGIN
  SAVE(RouteLog);
  L_General.Assert(SELECT(RouteLog, Route, Route.Route), "   ");
  L_General.Assert(L_DatTim.MonthBeg(Route.Begin) = RouteLog.Date,
                   "砫 ⢨   ᮢ  砫 ਨ ");
  LAST(RouteLog);
  L_General.Assert(!Route.Till | (L_DatTim.MonthBeg(Route.Till) >= RouteLog.Date),
                   "砭 ⢨   ᮮ⢥ ਨ ");
  Route.TKind  :=RouteLog.TKind;
  Route.JRegime:=RouteLog.JRegime;
  REPLACE(Route);

  _Till:=Route.Till;
  WHILE OCCURE(RouteLog) DO
   RouteLog.Till:=_Till;
   REPLACE(RouteLog);
   _Till:=RouteLog.Date;
   PREV(RouteLog);
  END; (* WHILE OCCURE(RouteLog) ... *)
  RESTORE(RouteLog);
 END {SetRouteLogTill};

 PUBLIC PROCEDURE MakeCopy();
 BEGIN
  ACCESS(Route);
  L_WDO.LaunchInsertBySource(Route.Route, "");
 END {MakeCopy};

 PRIVATE PROCEDURE Route_OnAfterEdIns();
 BEGIN
  SELECT(RoutMod, Route, , Route.Route);
  WHILE OCCURE(RoutMod) DO
   L_General.Assert(L_DatTim.InPatIntvl(Route.Begin, Route.Till, RoutMod.FromD, RoutMod.UpDate),
                    "䨪 " + RoutMod.Modif + "   ⢮," +
                    "|   ");
   NEXT(RoutMod);
  END; (* WHILE OCCURE(RoutMod) ... *)

  SAVE(Route);
  IF ~!Route.dSign THEN
   CHANGESEL(Route, dSign, , Route.dSign);
   FIRST(Route);
   IF NEXT(Route) THEN
    L_General.Error("  ஢ 祭  '" + Route.dSign + "'");
   END;
  END;
  RESTORE(Route);

  SetRouteLogTill();
  IF Route.IncSel THEN
   CONFORM(Route, TKind);
   IF TKind.Rgn > L_Way.tkrgn_Intercity THEN
    L_StdFrm.Choice("   室:  ॢ  ॣ "+L_Str.PoolItem(L_Way.tkrgn_Pool, TKind.Rgn));
   END;
  END;
  L_DBD.CheckUsersValidity("Route");
 END {Route_OnAfterEdIns};

 PRIVATE PROCEDURE Route_OnAfterEdit();
 BEGIN
  Route_OnAfterEdIns();
 END {Route_OnAfterEdit};

 PRIVATE PROCEDURE Route_OnAfterInsert();
 BEGIN
  Route_OnAfterEdIns();
 END {Route_OnAfterInsert};

 PRIVATE PROCEDURE Route_OnBeforeInsert();
  VAR
   srcRoute: LIKE(Route.Route);
 BEGIN
  srcRoute:=L_WDO.GetInsertionSource();
  IF ~!srcRoute THEN
   L_DBD.CopyFromSrcRecord("Route", srcRoute);
   REPLACE(Route);
  END;
 END {Route_OnBeforeInsert};

 PRIVATE PROCEDURE DeleteRelatedFile();
 BEGIN
  SETSEL(RoutMod,  Route, Route.Route); REMSEL(RoutMod);
  SETSEL(RtMStop,  Route, Route.Route); REMSEL(RtMStop);
  SETSEL(RouteIPL, Route, Route.Route); REMSEL(RouteIPL);
  SETSEL(RouteIP,  Route, Route.Route); REMSEL(RouteIP);
  SETSEL(RouteLog, Route, Route.Route); REMSEL(RouteLog);
  SELECT(RoutePro, Route, , Route.Route);
  WHILE OCCURE(RoutePro) DO
   L_Prop.RemoveCurrentPro("RoutePro");
  END; (* WHILE OCCURE(RoutePro) ... *)
 END {DeleteRelatedFile};

 PRIVATE PROCEDURE crd_IsActiveRoutMod(): SCAL[2];
 BEGIN
  IF RoutMod.UpDate <= Route.Begin THEN
   RETURN 0;
  ELSE
   SELECT(SEJobs, RoutMod, , RoutMod.Route, RoutMod.Modif);
   WHILE OCCURE(SEJobs) DO
    CONFORM(SEJobs, StExit);
    IF StExit.UpDate > Route.Begin THEN
     RETURN 1;
    END;
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs)... *)
   RETURN 0;
  END;
 END {crd_IsActiveRoutMod};

 PRIVATE PROCEDURE CopyRelatedFile(srcRoute: LIKE(Route.Route));
  VAR
   srcRI: LIKE(RoutePro.RECORDID);
 BEGIN
  SELECT(RoutMod, Route, , srcRoute);
  WHILE OCCURE(RoutMod) DO
   PROMPT("஢ 䨪権: " + RoutMod.Modif);
   IF crd_IsActiveRoutMod() THEN
    SAVE(RoutMod);
    RoutMod.Route:=Route.Route;
    RoutMod.FromD:=Math.Max(RoutMod.FromD, Route.Begin);
    INSERT(RoutMod);
    RESTORE(RoutMod);
    CONFORM(RoutMod, RtMStop);
    WHILE OCCURE(RtMStop) DO
     SAVE(RtMStop);
     RtMStop.Route:=Route.Route;
     INSERT(RtMStop);
     RESTORE(RtMStop);
     NEXT(RtMStop);
    END; (* WHILE OCCURE(RtMStop)... *)
   END;
   NEXT(RoutMod);
  END; (* WHILE OCCURE(RoutMod)... *)

  SELECT(RouteIP, RouteIP, , srcRoute);
  WHILE OCCURE(RouteIP) DO
   PROMPT("஢ : " + RouteIP.RoutCnd);
   NARROWSEL(RouteIP, RoutCnd);
   IF ~SRCINSEL(RouteIP, LE, Route.Begin) THEN
    FIRST(RouteIP);
   END;
   WHILE OCCURE(RouteIP) DO
    SAVE(RouteIP);
    RouteIP.Route:=Route.Route;
    RouteIP.Date :=Math.Max(RouteIP.Date, Route.Begin);
    INSERT(RouteIP);
    RESTORE(RouteIP);
    SELECT(RouteIPL, Route, , RouteIP.Route, RouteIP.Date, RouteIP.RoutCnd);
    WHILE OCCURE(RouteIPL) DO
     SAVE(RouteIPL);
     RouteIPL.Route:=Route.Route;
     RouteIPL.Date :=Math.Max(RouteIPL.Date, Route.Begin);
     INSERT(RouteIPL);
     RESTORE(RouteIPL);
     NEXT(RouteIPL);
    END; (* WHILE OCCURE(RouteIPL) ... *)
    NEXT(RouteIP);
   END; (* WHILE OCCURE(RouteIP) *)
   NEXTINEXTENDEDSEL(RouteIP, RoutCnd);
  END; (* WHILE OCCURE(RouteIP) *)

  SELECT(RouteLog, Route, , srcRoute);
  PROMPT("஢ ਨ ");
  IF ~SRCINSEL(RouteLog, LE, Route.Begin) THEN
   FIRST(RouteLog);
  END;
  WHILE OCCURE(RouteLog) DO
   IF Route.Begin < RouteLog.Till THEN
    SAVE(RouteLog);
    RouteLog.Route:=Route.Route;
    RouteLog.Date :=Math.Max(RouteLog.Date, L_DatTim.MonthBeg(Route.Begin));
    INSERT(RouteLog);
    RESTORE(RouteLog);
   END;
   NEXT(RouteLog);
  END; (* WHILE OCCURE(RouteLog) ... *)

  SAVE(Route);
  SEARCH(Route, Route, , srcRoute);
  srcRI:=Route.RECORDID;
  RESTORE(Route);
  L_Prop.CopyProRecords("Route", srcRI, Route.RECORDID);
 END {CopyRelatedFile};

 PRIVATE PROCEDURE Route_Begin_OnSuccessfulChange();
  VAR
   srcRoute: LIKE(Route.Route);
 BEGIN
  srcRoute:=L_WDO.GetInsertionSource();
  IF ~!srcRoute THEN
   L_General.Assert(~!Route.Route, "  㪠뢠   ।");
   TRY
    L_AR.GrantRightsUnconditionally();
    IF ~!GE_PVALUE() THEN
     L_StdFrm.Choice("  (, 䨪樨 , ᢮⢠,   窥)|" +
                     " 㤠  ⠢ , 㠫  " + L_DatTim.DateStr(Route.Begin));
     DeleteRelatedFile();
    END;
    CopyRelatedFile(srcRoute);
   EXCEPT
   END; (* TRY *)
  END;
 END {Route_Begin_OnSuccessfulChange};

 PRIVATE PROCEDURE Route_OnBeforeDelete();
 BEGIN
  L_r2r.Owner_OnBeforeDelete("Route");
 END {Route_OnBeforeDelete};

 PRIVATE PROCEDURE IsFirstInsertInRouteLog(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(RouteLog);
  Result:=~SELECT(RouteLog, Route, RouteLog.Route) | ~NEXT(RouteLog);
  RESTORE(RouteLog);
  RETURN Result;
 END {IsFirstInsertInRouteLog};

 PRIVATE PROCEDURE CopyLastRouteLogParam();
  VAR
   _TKind   : LIKE(RouteLog.TKind);
   _JRegime : LIKE(RouteLog.JRegime);
   _CostItem: LIKE(RouteLog.CostItem);
 BEGIN
  SAVE(RouteLog);
  SETSEL(RouteLog, Route, RouteLog.Route);
  IF LAST(RouteLog) THEN
   WHILE !RouteLog.Date & PREV(RouteLog) DO
   END;
  END;
  IF OCCURE(RouteLog) THEN
   _TKind   :=RouteLog.TKind;
   _JRegime :=RouteLog.JRegime;
   _CostItem:=RouteLog.CostItem;
  ELSE
   SETEMPTY(_TKind, _JRegime, _CostItem);
  END;
  RESTORE(RouteLog);
  RouteLog.TKind:=_TKind;
  RouteLog.JRegime:=_JRegime;
  RouteLog.CostItem:=_CostItem;
  REPLACE(RouteLog);
 END {CopyLastRouteLogParam};

 PRIVATE PROCEDURE RouteLog_OnBeforeInsert();
 BEGIN
  L_General.Assert(~!Route.Begin, " 㪠  砫 ⢨ ");
  IF IsFirstInsertInRouteLog() THEN
   RouteLog.Date:=L_DatTim.MonthBeg(Route.Begin);
   REPLACE(RouteLog);
  ELSE
   CopyLastRouteLogParam();
  END;
 END {RouteLog_OnBeforeInsert};

 PRIVATE PROCEDURE CheckNotDoneRWayS();
  VAR
   PerStr  : STRING[];
 BEGIN
  IF SELECT(SEJobs, Route, Route.Route) THEN
   SETSEL(RWayS, Done, 1);
   SRCINSEL(RWayS, GE, , RouteLog.Date);
   WHILE OCCURE(RWayS) & (RWayS.Date < RouteLog.Till) DO
    PROMPT(RWayS.RWayS + " " + L_DatTim.DateStr(RWayS.Date));
    SELECT(RWayJ, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayJ) DO
     CONFORM(RWayJ, SEJobs);
     IF SEJobs.Route = RouteLog.Route THEN
      PerStr:= " ਮ  " + L_DatTim.DateStr(RouteLog.Date);
      IF ~!RouteLog.Till THEN
       PerStr:=PerStr + "  " + L_DatTim.DateStr(RouteLog.Till-1);
      END;
      L_General.Error(PerStr + "|" +
                      " ࠡ⠭  (ਬ, " + RWayS.RWayS + ")" + "||" +
                      "䨪 ਨ  饭.||" +
                      "室 ।⥫쭮 ⪠    " + Route.Route);
     END;
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
  END;
 END {CheckNotDoneRWayS};

 PRIVATE PROCEDURE RouteLog_OnAfterEdIns();
 BEGIN
  SetRouteLogTill();
  CheckNotDoneRWayS();
 END {RouteLog_OnAfterEdIns};

 PRIVATE PROCEDURE RouteLog_OnAfterInsert();
 BEGIN
  RouteLog_OnAfterEdIns();
 END {RouteLog_OnAfterInsert};

 PRIVATE PROCEDURE RouteLog_OnAfterEdit();
 BEGIN
  RouteLog_OnAfterEdIns();
 END {RouteLog_OnAfterEdit};

 PRIVATE PROCEDURE RouteLog_OnBeforeDelete();
 BEGIN
  CheckNotDoneRWayS();
 END {RouteLog_OnBeforeDelete};

 PRIVATE PROCEDURE RouteLog_OnAfterDelete();
 BEGIN
  SetRouteLogTill();
 END {RouteLog_OnAfterDelete};

 PRIVATE PROCEDURE RouteLog_CostItem_OnSuccessfulChange();
 BEGIN
  IF ~!RouteLog.CostItem THEN
   L_CI.CheckActivityCostItem(RouteLog.CostItem);
  END;
 END {RouteLog_CostItem_OnSuccessfulChange};

BEGIN
 L_Events.ExecuteHandler();
END.
