(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose       室 ()
%Type        control
%Specific    AP
%Modified    30.06.2014 19:20:48 POLAK\Gina
%Environment
*)

 MODULE RouteIP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_APtm, L_Events, L_PRoll, L_Way, L_StdFrm, Memo, E_Way, L_APWI,
        L_Str, L_SysLog, Str;

(*
$P{ LineBd:
Route.Route, L, ""
Route.Name, L, ""
?, L, ""
@
#### ######################## - #####################################
}
*)

 PRIVATE PROCEDURE RouteIP_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("RouteIP.RoutCnd").Format:=L_Way.E_IPConditionPool(SYSDATE());
 END {RouteIP_1_OnZoneOpen};

 PRIVATE PROCEDURE RouteIP_2_OnZoneOpen();
 BEGIN
  L_General.Assert(ACCESS(RouteIP), " ⠭ ⥪    ਨ");
  CONFORM(RouteIP, Route);
  IF L_Way.E_NeedCrankyWayIPLInterpretation(RouteIP.Date, L_Way.tcpi_FromRoute) THEN
   RTI.Get().CurZone.SubwindowOriginalName:="CrRouteIPE";
  ELSE
   RTI.Get().CurZone.SubwindowOriginalName:="RouteIPE";
  END;
 END {RouteIP_2_OnZoneOpen};

 PRIVATE PROCEDURE RouteIPE_0_OnZoneOpen();
  VAR
   SpcCfEnable: SCAL[2];
   SpcCfPool  : STRING[];
 BEGIN
  L_General.Assert(ACCESS(RouteIP), " ⠭ ⥪    ਨ");
  CONFORM(RouteIP, Route);
  RTI.Get().CurZone.Fields("RouteIP_RoutCnd").Format:=L_Way.E_IPConditionPool(SYSDATE());
  SpcCfEnable:=((RouteIP.RoutCnd = L_Way.ipc_Guard) & L_Way.E_FillIncPlanFromIncPlanG(RouteIP.Date)) |
               (L_APWI.E_FillVldPsgPlanFromVldPsgPlanG(RouteIP.Date) & (RouteIP.RoutCnd = E_Way.ipc_TermPlanGrd));
  IF SpcCfEnable THEN
   SpcCfPool:=" |. ⥫|. ⥫|. ⥫|. ⥫|. ⥫";
  ELSE
   SpcCfPool:=" | "; (* ??? BUG *)
  END;
  RTI.Get().CurZone.Fields("RouteIPL_SpcCf").Format:=SpcCfPool;
  RTI.Get().CurZone.Fields("RouteIPL.SpcCf").Visible:=SpcCfEnable;
 END {RouteIPE_0_OnZoneOpen};

 PRIVATE PROCEDURE CrRouteIPE_0_OnZoneOpen();
  CONST
   MaxGrp = 4; (*ᨬ 4 㯯 *)
  VAR
   IdxGrp      : SCAL[HIGH(RouteIPL.Cfc)];
   VolGrp      : NUMERIC[0][MaxGrp];
   curVolGrp   : NUMERIC[0];
   curWd       : L_DatTim.tWeekday;
 BEGIN
  RouteIPE_0_OnZoneOpen();
  IdxGrp:=0;
  IF ~!PROCREF(E_Way.PasVolGrpCranky) THEN
   SETEMPTY(VolGrp);
   E_Way.PasVolGrpCranky(RouteIP.Date, VolGrp);
   FOR_EACH curVolGrp IN VolGrp DO
    FOR_EACH curWd DO
     L_WDO.SetFieldVisible(L_Str.Var_wIdx("RouteIPL.Cfc", IdxGrp*8+curWd), 1);
    END;
    INC(IdxGrp);
   END;
  END;
  WHILE IdxGrp < MaxGrp DO
   FOR_EACH curWd DO
    L_WDO.SetFieldVisible(L_Str.Var_wIdx("RouteIPL.Cfc", IdxGrp*8+curWd), 0);
   END;
   INC(IdxGrp);
  END;
 END {CrRouteIPE_0_OnZoneOpen};

 PRIVATE PROCEDURE RouteIPL_ANY_OnSuccessfulChange();
  VAR
   curIndex: NUMERIC[0];
   curFieldName: STRING[];
 BEGIN
  curIndex:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  curFieldName:=RTI.Get().CurZone.ActiveField.TableField.ObtainName(curIndex);
  IF !^curFieldName THEN
   L_General.Assert(curIndex # 0, "     ");
   ^curFieldName:=^(RTI.Get().CurZone.ActiveField.TableField.ObtainName(curIndex-1));
  END;
  REPLACE(^(RTI.Get().CurZone.MasterTable.Name));
 END {RouteIPL_ANY_OnSuccessfulChange};

 PRIVATE PROCEDURE RouteIPL_Plan_OnSuccessfulChange();
 BEGIN
  RouteIPL_ANY_OnSuccessfulChange();
 END {RouteIPL_Plan_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckElstcCf(_ElstcCf: LIKE(RouteIPL.ElstcCf[0]));
 BEGIN
  IF _ElstcCf > 1 THEN
   STDMSG(" 筮  1.0!| 㢥७?", CHOICE);
  END;
 END {CheckElstcCf};

 PRIVATE PROCEDURE RouteIPL_ElstcCf_OnSuccessfulChange();
 BEGIN
  CheckElstcCf(^(RTI.Get().CurZone.ActiveField.Name));
  RouteIPL_ANY_OnSuccessfulChange();
 END {RouteIPL_ElstcCf_OnSuccessfulChange};

 PRIVATE PROCEDURE RouteIPL_Cfc_OnSuccessfulChange();
 BEGIN
  RouteIPL_ANY_OnSuccessfulChange();
 END {RouteIPL_Cf_OnSuccessfulChange};

 PRIVATE PROCEDURE RouteIPL_RoutDay_OnSuccessfulChange();
 BEGIN
  IF    RouteIPL.RoutDay = 02 THEN
   SAVE(RouteIPL);
   L_General.Assert(CHANGESEL(RouteIPL, Route, RouteIPL.Route, RouteIPL.Date, RouteIPL.RoutCnd) &
                    FIRST(RouteIPL) & (RouteIPL.RoutDay = 01),
                    " 稭 ଫ   ࢮ  ( 砫 ⢨  01)");
   RESTORE(RouteIPL);
  ELSIF RouteIPL.RoutDay # 01 THEN
   L_General.Error(" 砫 ⢨    01  02");
  END;
 END {RouteIPL_RoutDay_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckRights();
 BEGIN
  L_General.Assert_wReferToAdmin(~L_APtm.MonthIsClosed(L_DatTim.Per(RouteIP.Date), L_APtm.system_Salary),
                                 "    ⮬ ");
 END {CheckRights};

 PRIVATE PROCEDURE CheckNoTouchDriverPlan();
 BEGIN
  L_General.Assert(ACCESS(RouteIP), " ⠭  ਨ ");
  CONFORM(RouteIP, Route);
  IF RouteIP.RoutCnd = L_Way.ipc_Driver THEN
   L_General.Assert(~L_Way.E_FillIncPlanFromIncPlanG(RouteIP.Date),
                    "  ⥫   ᭮   ");
  END;
  IF L_APWI.E_FillVldPsgPlanFromVldPsgPlanG(RouteIP.Date) THEN
   L_General.Assert(RouteIP.RoutCnd # E_Way.ipc_TermPlanDrv,
                    "  ⥫   ᭮   ");
  END;
 END {CheckNoTouchDriverPlan};

 PRIVATE PROCEDURE RouteIP_OnBeforeEdit();
 BEGIN
  CheckRights();
 END {RouteIP_OnBeforeEdit};

 PRIVATE PROCEDURE RouteIP_OnBeforeDelete();
 BEGIN
  CheckRights();
 END {RouteIP_OnBeforeDelete};

 PRIVATE PROCEDURE RouteIP_OnAfterEditInsert();
  VAR
   cpit: L_Way.tCalcPlInc;
 BEGIN
  IF RouteIP.Type # L_Way.ript_Canceled THEN
   CheckNoTouchDriverPlan();
  END;
  CONFORM(RouteIP, Route);
  cpit:=L_Way.E_CalcPlIncType(RouteIP.Date, RouteIP.RoutCnd);
  IF    (cpit=L_Way.cpit_ByTime) | (cpit=L_Way.cpit_ByRun) THEN
   L_General.Assert(RouteIP.Type # L_Way.ript_OnTrip, '஢ " ३"  ঠ');
  ELSIF (cpit=L_Way.cpit_ByTrip) | (cpit=L_Way.cpit_ByRun) THEN
   L_General.Assert(RouteIP.Type # L_Way.ript_OnHour, '஢ " "  ঠ');
  END;
 END {RouteIP_OnAfterEditInsert};

 PRIVATE PROCEDURE AllowedPlan();
 BEGIN
  L_General.Assert(RouteIP.Type<L_Way.ript_OnExit, " ⠪ ⨯ ஢   㪠뢠");
 END {AllowedPlan};

 PRIVATE PROCEDURE RouteIP_OnAfterEdit();
 BEGIN
  IF RouteIP.Date#GE_PVALUE(RouteIP.Date) THEN
   CheckRights();
  END;
  RouteIP_OnAfterEditInsert();
  CONFORM(RouteIP, RouteIPL);
  IF OCCURE(RouteIPL) THEN
   AllowedPlan();
  END;
 END {RouteIP_OnAfterEdit};

 PRIVATE PROCEDURE RouteIP_OnAfterInsert();
 BEGIN
  CheckRights();
  RouteIP_OnAfterEditInsert();
 END {RouteIP_OnAfterInsert};

 PRIVATE PROCEDURE RouteIPL_OnBeforeEdit();
 BEGIN
  CONFORM(RouteIPL, RouteIP);
  AllowedPlan();
  CheckRights();
  CheckNoTouchDriverPlan();
 END {RouteIPL_OnBeforeEdit};

 PRIVATE PROCEDURE RouteIPL_OnBeforeInsert();
  VAR
   _TemplPV: LIKE(RouteIPL.TemplPV);
 BEGIN
  CONFORM(RouteIPL, RouteIP);
  AllowedPlan();
  CheckRights();
  CheckNoTouchDriverPlan();
  IF !RouteIPL.TemplPV THEN
   SETEMPTY(_TemplPV);
   SAVE(RouteIP);
   SAVE(RouteIPL);
   CHANGESEL(RouteIP, Route, , RouteIP.Route);
   WHILE PREV(RouteIP) & !_TemplPV DO
    CONFORM(RouteIP, RouteIPL);
    IF OCCURE(RouteIPL) THEN
     _TemplPV:=RouteIPL.TemplPV;
    END;
   END;
   RESTORE(RouteIP);
   RESTORE(RouteIPL);
   RouteIPL.TemplPV:=_TemplPV;
   REPLACE(RouteIPL);
  END;
 END {RouteIPL_OnBeforeInsert};

 PRIVATE PROCEDURE RouteIPL_OnBeforeDelete();
 BEGIN
  CONFORM(RouteIPL, RouteIP);
  CheckRights();
 END {RouteIPL_OnBeforeDelete};

 PRIVATE PROCEDURE RouteIPL_OnAfterEdit();
 BEGIN
  (*㦭 - ⮨ 窠    MarkInSysLog*)
 END {RouteIPL_OnAfterEdit};

 PRIVATE PROCEDURE RouteIPL_OnAfterInsert();
 BEGIN
  (*㦭 - ⮨ 窠    MarkInSysLog*)
 END {RouteIPL_OnAfterInsert};

 PRIVATE PROCEDURE _GetPrc(_IncPrc, _IncPrcLoc: NUMERIC[3]): NUMERIC[3];
 BEGIN
  IF !_IncPrcLoc THEN
   L_General.Assert(~!_IncPrc, "  "+L_Str.PoolItem(L_Way.E_IPConditionPool(RouteIPL.Date), RouteIPL.RoutCnd)+"|    樥");
   RETURN _IncPrc;
  ELSE
   RETURN _IncPrcLoc;
  END;
 END {_GetPrc};

 PRIVATE PROCEDURE NeedCopy(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(RouteIP);
  Result:=~SEARCH(RouteIP, Route, RouteIP.Route, Memo.ud_cd(), RouteIP.RoutCnd);
  RESTORE(RouteIP);
  IF Result THEN
   CONFORM(RouteIP, Route);
   IF (L_Way.E_FillIncPlanFromIncPlanG(Memo.ud_cd()) & (RouteIP.RoutCnd = L_Way.ipc_Driver)) |
      (L_APWI.E_FillVldPsgPlanFromVldPsgPlanG(Memo.ud_cd()) & (RouteIP.RoutCnd = E_Way.ipc_TermPlanDrv)) THEN
    Result:=0;
   END;
  END;
  RETURN Result;
 END {NeedCopy};

 PUBLIC PROCEDURE CopyPlan(All: SCAL[2]);
  VAR
   WD     : L_DatTim.tWeekday;
   _IncPrc: NUMERIC[3];
   Prc    : NUMERIC[3][MAXOF(RouteIP.RoutCnd)+1];
   Blank,
   PoolIns,
   Vars   : STRING[];
 BEGIN
  IF ~All THEN
   L_General.Assert(ACCESS(RouteIP), " ⠭ ப ");
  END;
  L_PRoll.Salary_CheckNoTouch(Memo.ud_mb());

  SAVE(RouteIP);
  IF SEARCH(RouteIP, Route, RouteIP.Route, Memo.ud_cd(), RouteIP.RoutCnd) THEN
   L_StdFrm.Choice("  " + L_DatTim.DateStr(Memo.ud_cd()) + " 㦥  ");
  END;
  RESTORE(RouteIP);

  SETEMPTY(Blank, PoolIns, Prc);
  Vars:=", _IncPrc";

  _IncPrc:=1;
  CHANGESEL(RouteIP, Route, , RouteIP.Route, RouteIP.Date);
  IF ~All THEN
   FIRST(RouteIP);
   WHILE OCCURE(RouteIP) DO
    IF RouteIP.Type # L_Way.ipt_Canceled THEN
     Blank  :=Blank + "|" + "%#########################% %#######%";
     PoolIns:=PoolIns + "%<" + Str.Align(L_Str.PoolItem(L_Way.E_IPConditionPool(RouteIP.Date), RouteIP.RoutCnd), 25, LEFT) + ">T" +"%L<3.>YI";
     Vars   :=Vars+", Prc["+RouteIP.RoutCnd+"]";
    END;
    NEXT(RouteIP);
   END; (* WHILE ... *)
   STDFORM(L_StdFrm.sf_Choice("|ନ஢   " + L_DatTim.DateStr(Memo.ud_cd()) + "  ᭮ ⥪饣" +
                              "|%#########################% %#######%" +
                              Blank,
                              "%<騩 樥>T" +
                              "%L<3.>I" + PoolIns),
           , STOP, ^Vars);
  END;

  FIRST(RouteIP);
  WHILE OCCURE(RouteIP) DO
   IF (RouteIP.Type # L_Way.ript_Canceled) & NeedCopy() THEN
    SAVE(RouteIP);
    RouteIP.Date:=Memo.ud_cd();
    INSERT(RouteIP);
    L_APtm.SysLogHandler("RouteIP", L_SysLog.knd_AutoBuild);
    RESTORE(RouteIP);
    SELECT(RouteIPL, Route, , RouteIP.Route, RouteIP.Date, RouteIP.RoutCnd);
    WHILE OCCURE(RouteIPL) DO
     PROMPT(L_DatTim.TimeStr(RouteIPL.RoutTime));
     SAVE(RouteIPL);
     RouteIPL.Date:=Memo.ud_cd();
     FOR_EACH WD DO
      RouteIPL.Plan[WD]:=RouteIPL.Plan[WD]*_GetPrc(_IncPrc, Prc[RouteIPL.RoutCnd]);
     END;
     INSERT(RouteIPL);
     L_APtm.SysLogHandler("RouteIPL", L_SysLog.knd_AutoBuild);
     RESTORE(RouteIPL);
     NEXT(RouteIPL);
    END; (* WHILE OCCURE(RouteIPL) ... *)
   END; (* IF RouteIP.Type... *)
   NEXT(RouteIP);
  END; (* WHILE ... *)
  IF ~All THEN
   FIRST(RouteIP);
   IF SELECT(RouteIP, Route, RouteIP.Route, Memo.ud_cd()) THEN
    SE_WZD_CURSOR(GE_CURWIN(), GE_CURZONE(), RouteIP);
   END;
  END;
 END {CopyPlan};

 PUBLIC PROCEDURE SetPlan();
  VAR
   curPlan   : LIKE(RouteIPL.Plan[0]);
   curElstcCf: LIKE(RouteIPL.ElstcCf[0]);
   curIndex  : SCAL[RANGEOF(RouteIPL.Plan)];
 BEGIN
  L_General.Assert(ACCESS(RouteIPL), " ⠭ ப ");
  curIndex:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  IF !curIndex THEN
   curIndex:=0;
  END;
  curPlan   :=RouteIPL.Plan[curIndex];
  curElstcCf:=RouteIPL.ElstcCf[curIndex];
  STDFORM(L_StdFrm.sf_Choice( "%###################% %##########%"+
                             "|"+
                             "|%###################% %##########%",
                             "%<               >T"+
                             "%R<2.>I"+
                             "%<. 筮>T" +
                             "%R<3.>I"),
          "   . 筮", , , curPlan, curElstcCf);
  CheckElstcCf(curElstcCf);

  FOR_EACH curIndex DO
   RouteIPL.Plan   [curIndex]:=curPlan;
   RouteIPL.ElstcCf[curIndex]:=curElstcCf;
  END;
  REPLACE(RouteIPL);
 END {SetPlan};

 PUBLIC PROCEDURE AllRouteCopyPlan();
  CONST
   RepName = "BdPln";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_StdFrm.Choice("ନ஢   ᥬ ⠬  " + L_DatTim.DateStr(Memo.ud_cd()) + "  ᭮ ⥪饣|樥  1.000");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  SELECT(Route, Route);
  WHILE OCCURE(Route) DO
   PROMPT(Route.Route);
   IF L_DatTim.IsActive(Memo.ud_cd(), Route.Begin, Route.Till) THEN
    SETSEL(RouteIP, Route, Route.Route);
    IF SRCINSEL(RouteIP, LE, Memo.ud_cd()) & (RouteIP.Type # L_Way.ript_Canceled) THEN
     TRY [TRANSACTION(TRANSACTION_SLAVE)]
      CopyPlan(1);
     EXCEPT
     ON Exc: Exc_Root DO
      MAKEPART(R, LineBd, " ନ஢ ");
     END;
    ELSE
     MAKEPART(R, LineBd, " ");
    END;
   END;
   NEXT(Route);
  END; (* WHILE OCCURE(Route) ... *)
  CLOSEREP(R);
 END {AllRouteCopyPlan};

BEGIN
 L_Events.ExecuteHandler();
END.
