(*
%Copyright   (c) Polak Computer System
%Author      07.09.1994 18:45:07 GINA
%Purpose     ஫ 䨪樨 RoutMod
%Type        operation
%Specific    AP
%Modified    14.11.2013 16:55:22 POLAK\GAV
*)

 MODULE RoutMod [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_DatTim, L_AFM, L_Way, L_OwnData, L_StdFrm, L_WDO, L_Str, L_DBD;

 PRIVATE PROCEDURE GetStopCP_asString(CPActive: SCAL[2]): STRING[];
 BEGIN
  IF CPActive THEN
   RETURN Stop.CP;
  ELSE
   RETURN "";
  END;
 END {GetStopCP_asString};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
RoutMod.Route, L, ""
Route.Name, L, ""
RoutMod.Modif, L, ""
RoutMod.Name, L, ""
RoutMod.Dir, L, "|"
RoutMod.Run, R, "1."
RoutMod.Tim[0], R, "0"
RoutMod.FCor, R, "3."
@
############################################################# ########## #####
=#####========================================================================
|                      ᯮ 䨪樨                           |
|----------------------------------------------------------------------------|
|     #### #################################                          |
|䨪 ###  ######################################## ###               |
|            殮        ###########                                |
|            த⥫쭮    ###########                                |
|            ४  ⮯ ########                                |
|----------------------------------------------------------------------------|
|  |                            |      ஡     |    ६,     | .|
|N |⠭                   |-----------------|------------------|-------|
|  |                            | .|| .| .|⮩| .|||
|--|----------------------------|-----|-----|-----|-----|------|-----|---|---|
}
*)

(*
$P{ Line:
RtMStop.StopNbr, L, ""
RtMStop.Stop, L, ""
L_Way.GetStopName(Stop.Stop), L, ""
RtMStop.RDis, R, "1."
RtMStop.BDis, R, "1."
RtMStop.ADis, R, "1."
RtMStop.RTim[0], R, "0"
RtMStop.DTim[0], R, "0"
RtMStop.ATim[0], R, "0"
GetStopCP_asString(RtMStop.CPActive[0]), L, ""
GetStopCP_asString(RtMStop.CPActive[1]), L, ""
@
|##|### ########################|#####|#####|#####|#####|######|#####|## |## |
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE CheckIntvl();
 BEGIN
  SELECT(SEJobs, RoutMod, , RoutMod.Route, RoutMod.Modif);
  WHILE OCCURE(SEJobs) DO
   PROMPT(SEJobs.Trip);
   CONFORM(SEJobs, StExit);
   IF ~L_DatTim.InPatIntvl(RoutMod.FromD, RoutMod.UpDate,
                           StExit.FromD,  StExit.UpDate) THEN
    L_StdFrm.ConditionalCHOICE("䨪 ᯮ  室 " + StExit.Exit +
                               "|(३ " + SEJobs.Trip + ")," +
                               "|饬  " + L_DatTim.DateStr(StExit.FromD) +
                               "  " + L_DatTim.DateStr(StExit.UpDate),
                               StExit.Strict # L_Way.ExitStrict_Reg);
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
 END {CheckIntvl};

 PRIVATE PROCEDURE RoutMod_FromD_OnSuccessfulChange();
 BEGIN
  CheckIntvl();
 END {RoutMod_FromD_OnSuccessfulChange};

 PRIVATE PROCEDURE RoutMod_UpDate_OnSuccessfulChange();
 BEGIN
  CheckIntvl();
 END {RoutMod_UpDate_OnSuccessfulChange};

 PRIVATE PROCEDURE RoutMod_Modif_OnSuccessfulChange();
  VAR
   srcModif: LIKE(RoutMod.Modif);
 BEGIN
  IF !GE_PVALUE() & ~!RoutMod.Dir THEN
   srcModif:=L_WDO.GetInsertionSource();
   IF ~!srcModif THEN
    CopyRtMStop(srcModif, L_WDO.GetEnvVarValue("Backward"));
   END;
  END;
 END {RoutMod_Modif_OnSuccessfulChange};

 PRIVATE PROCEDURE RoutMod_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeInsert]);
  L_WDO.iMayBeEmpty  (0, ["Route.VCor", "Route.dSign", "Route.Till"]);
  L_WDO.iScsChange   (0, ["Route.Begin"]);
  L_WDO.iSubwindow   (1, "RoutModE");
  L_WDO.iSubwindow   (2, "RoutLogE");
 END {RoutMod_OnInitializeWindow};

 PRIVATE PROCEDURE CheckRtMStop();
 BEGIN
  SELECT(RtMStop, Route, , RoutMod.Route, RoutMod.Modif);
  IF RoutMod.Run = 0 THEN
   L_General.Assert(~OCCURE(RtMStop),
                    "䨪   ஡    ⠭");
  ELSE
   L_General.Assert(OCCURE(RtMStop) & NEXT(RtMStop),
                    "䨪      ⠭");
  END;
 END {CheckRtMStop};

 PRIVATE PROCEDURE CheckIfIsInUse(wRefresh: SCAL[2]);
 BEGIN
  L_AFM.MakeIndex("_Exit", "_Exit: LIKE(StExit.Exit)");
  SELECT(SEJobs, RoutMod, , RoutMod.Route, RoutMod.Modif);
  LOOP
   IF ~OCCURE(SEJobs) THEN
    EXIT;
   END;
   PROMPT(SEJobs.Exit + " " + SEJobs.Trip);
   IF SELECT(RWayJ, Trip, SEJobs.Trip) THEN
    L_General.Assert(~wRefresh,
                     " 䨪   ," +
                     "|.. ᮮ⢥騥 ३ 㯮  ⥢ ");
    STDMSG(" 䨪 㯮  ⥢ .|⨬  ஡", CHOICE);
    EXIT;
   END;
   IF wRefresh & ~SEARCH(_Exit, _Exit, SEJobs.Exit) THEN
    SAVE(SEJobs);
    CONFORM(SEJobs, StExit);
    _Exit._Exit:= SEJobs.Exit;
    INSERT(_Exit);
    CALL(StExit.Recalculate());
    RESTORE(SEJobs);
   END;
   NEXT(SEJobs);
  END; (* LOOP ... *)
  L_AFM.AF_PurgeTemp("_Exit");
 END {CheckIfIsInUse};

 PUBLIC PROCEDURE MakeCopy(Backward: SCAL[2]);
 BEGIN
  ACCESS(RoutMod);
  L_WDO.LaunchInsertBySource(RoutMod.Modif, " Backward=" + Backward);
 END {MakeCopy};

 PRIVATE PROCEDURE CopyRtMStop(srcModif: LIKE(RoutMod.Modif); Backward: SCAL[2]);
  VAR
   _BDis    : LIKE(RtMStop.BDis);
   _RTim    : LIKE(RtMStop.RTim);
   _RDis    : LIKE(RtMStop.RDis);
   _CPActive: LIKE(RtMStop.CPActive[0]);
 BEGIN
  SELECT(RtMStop, Route, , RoutMod.Route, srcModif);
  IF Backward THEN
   LAST(RtMStop);
  END;
  WHILE OCCURE(RtMStop) DO
   PROMPT(RtMStop.StopNbr);
   SAVE(RtMStop);
   RtMStop.Modif:=RoutMod.Modif;
   SETEMPTY(RtMStop.StopNbr);
   INSERT(RtMStop);
   RESTORE(RtMStop);
   IF Backward THEN
    PREV(RtMStop);
   ELSE
    NEXT(RtMStop);
   END;
  END; (* WHILE OCCURE(RtMStop) ... *)
  IF Backward THEN
   IF SELECT(RtMStop, Route, RoutMod.Route, RoutMod.Modif) THEN
    CONFORM(RtMStop, RoutMod);
    LAST(RtMStop);
    WHILE OCCURE(RtMStop) DO
     PROMPT(RtMStop.StopNbr);
     SAVE(RtMStop);
     IF PREV(RtMStop) THEN
      _BDis:=RtMStop.BDis;
      _RTim:=RtMStop.RTim;
      _RDis:=RtMStop.RDis;
      RESTORE(RtMStop);
      RtMStop.BDis:=_BDis;
      RtMStop.RTim:=_RTim;
      RtMStop.RDis:=_RDis;
     ELSE
      RESTORE(RtMStop);
      SETZERO(RtMStop.BDis, RtMStop.RTim, RtMStop.RDis);
     END;
     _CPActive          :=RtMStop.CPActive[0];
     RtMStop.CPActive[0]:=RtMStop.CPActive[1];
     RtMStop.CPActive[1]:=_CPActive;
     REPLACE(RtMStop);
     PREV(RtMStop);
    END; (* WHILE OCCURE(RtMStop) ... *)
   END; (* IF SELECT(RtMStop... *)
   CALL(RtMStop.RecountRoutMod());
  END;
 END {CopyRtMStop};

 PUBLIC PROCEDURE intMakeCopy(srcModif: LIKE(RoutMod.Modif); Backward: SCAL[2]);
 BEGIN
  L_DBD.CopyFromSrcRecord("RoutMod", RoutMod.Route + "|" + srcModif);
  IF Backward THEN
   RoutMod.Dir:=~RoutMod.Dir;
  END;
  REPLACE(RoutMod);
 END {intMakeCopy};

 PRIVATE PROCEDURE RoutMod_OnBeforeEdit();
 BEGIN
  CheckIfIsInUse(0);
 END {RoutMod_OnBeforeEdit};

 PRIVATE PROCEDURE RoutMod_OnAfterEdit();
 BEGIN
  CheckRtMStop();
  IF RoutMod.Run # GE_PVALUE(RoutMod.Run) THEN
   CheckIfIsInUse(1);
  END (* IF RoutMod.Run ... *)
 END {RoutMod_OnAfterEdit};

 PRIVATE PROCEDURE RoutMod_OnAfterInsert();
 BEGIN
  CheckRtMStop();
 END {RoutMod_OnAfterInsert};

 PRIVATE PROCEDURE RoutMod_OnBeforeInsert();
  VAR
   srcModif: LIKE(RoutMod.Modif);
 BEGIN
  srcModif:=L_WDO.GetInsertionSource();
  IF ~!srcModif THEN
   intMakeCopy(srcModif, L_WDO.GetEnvVarValue("Backward"));
  END;
 END {RoutMod_OnBeforeInsert};

 PRIVATE PROCEDURE RoutModE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Route";
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterEdit, L_WDO.e_OnAfterInsert]);
  L_WDO.iScsChange   (0, ["RoutMod.FromD", "RoutMod.UpDate", "RoutMod.Modif"]);
  L_WDO.iUnmodifiable(0, ["RoutMod.TimSign[2]", "RoutMod.Tim[0]", "RoutMod.Run"]);
  L_WDO.iMayBeEmpty  (0, ["RoutMod.UpDate"]);
  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterInsert, L_WDO.e_OnAfterDelete, L_WDO.e_OnSetSubwindow]);
  L_WDO.iField       (1, "RtMStop.Stop").First:=1;
  L_WDO.iScsChange   (1, ["RtMStop.Stop"]);
  L_WDO.iUnmodifiable(1, ["RtMStop.ADis", "RtMStop.ATim[0]"]);
  L_WDO.iField       (1, "Stop.CPType").Format:=L_Way.scpt_PoolWdo;
 END {RoutModE_OnInitializeWindow};

 PUBLIC PROCEDURE MakeNameByTerminalStops();
 BEGIN
  CONFORM(RoutMod, RtMStop);
  IF OCCURE(RtMStop) THEN
   CONFORM(RtMStop, Stop);
   RoutMod.Name:=L_Way.GetStopName(Stop.Stop);
   LAST(RtMStop);
   CONFORM(RtMStop, Stop);
   RoutMod.Name:=RoutMod.Name+" - "+L_Way.GetStopName(Stop.Stop);
   REPLACE(RoutMod);
  END;
 END {MakeNameByTerminalStops};

 PUBLIC PROCEDURE MakeRouteModPassp();
  CONST
   RepName = "RtMdP";
 BEGIN
  L_General.Assert(ACCESS(RoutMod),
                   " ⠭ ⥪ 䨪 ");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  CONFORM(RoutMod, Route);
  MAKEPART(R, Top, RepName);
  SELECT(RtMStop, Route, , RoutMod.Route, RoutMod.Modif);
  WHILE OCCURE(RtMStop) DO
   PROMPT(RtMStop.Stop);
   CONFORM(RtMStop, Stop);
   MAKEPART(R, Line);
   NEXT(RtMStop);
  END; (* WHILE OCCURE(RtMStop) ... *)
  MAKEPART(R, Bot);
 END {MakeRouteModPassp};

BEGIN
 L_Events.ExecuteHandler();
END.
