(*
%Copyright   (c) Polak IT
%Author      17.12.2009 17:06:45 POLAK\LDA
%Purpose
%Type        report
%Specific    LOC
%Modified    02.07.2014 18:55:07 POLAK\LDA
%Environment
*)

 MODULE Rpr02 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_AFM, L_General, L_Rpr, L_DatTim, D_Staff, L_Staff, L_Sheet, Memo, L_Basis, FIO, Math, L_Str,
        L_AR, L_bp, L_Car, DBD;

 PRIVATE VAR
  RepBegDTS,
  RepEndDTS   : TIMESTAMP;
  ShiftBegTime: TIME;
  ShiftEndTime: TIME;
  ShiftLength : NUMERIC[0];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]; wWagePay: SCAL[2]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ᯮ⥫");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "筥 ६");
  L_Basis.wb_WrInQM(F, "६  ");
  L_Basis.wb_WrInQM(F, "६  ⠡");
  L_Basis.wb_WrInQM(F, "砫 ᬥ");
  L_Basis.wb_WrInQM(F, "砭 ᬥ");

  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ꥪ ६");
  L_Basis.wb_WrInQM(F, "ꥪ ६");

  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "᪮ ");

  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");

  L_Basis.wb_WrInQM(F, " ࠡ");
  L_Basis.wb_WrInQM(F, "⠊");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ॡ㥬 ࠧ  ࠡ");
  L_Basis.wb_WrInQM(F, "ଠ⨢ 㤮 ࠡ");
  L_Basis.wb_WrInQM(F, "ଠ⨢ 㤮  ࠡ⭨");
  IF wWagePay THEN
   L_Basis.wb_WrInQM(F, "䭠 ⪠");
   L_Basis.wb_WrInQM(F, "䭠 ⪠");
   L_Basis.wb_WrInQM(F, "䭠 ⠢");
  END;
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]; wWagePay: SCAL[2]);
  CONST
   EmptyVal = "---";
  VAR
   RprJobClass : LIKE(RprJMG.Class);
   normBaseTime: LIKE(RprJ.BaseTime);
   dummySource : LIKE(RprJ.Source);
 BEGIN
  SEARCH(Staff, TSN, , TotW.TSN);
  L_Staff.PosToStaffLog(Staff.TSN, TotW.Date, 0);
  CONFORM(StaffLog, Sort);
  CONFORM(StaffLog, Post);
  CONFORM(Staff, Man);

  L_Basis.wb_WrDat(F, TotW.Date);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);

  IF ~!TotW.Who THEN
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Rpr.rprpwho_Pool, TotW.Who));
  ELSE
   L_Basis.wb_WrStr(F, EmptyVal);
  END;
  L_Basis.wb_WrScl(F, StaffLog.Class);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", TotW.HasDtlT));
  L_Basis.wb_WrNum(F, TotW.WrkTim, 3);
  L_Basis.wb_WrNum(F, TotW.ShtTim, 3);

  IF SEARCH(rStaff, TSN, TotW.TSN, TotW.Date) & ~!rStaff.BegDTS THEN
   L_Basis.wb_WrTim(F, L_DatTim.GetTimeOfTIMESTAMP(rStaff.BegDTS));
   L_Basis.wb_WrTim(F, L_DatTim.GetTimeOfTIMESTAMP(rStaff.EndDTS));
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;

  SETEMPTY(RprJobClass, normBaseTime);
  IF ~!TotW.RprS THEN
   SEARCH(RprS, RprS, , TotW.RprS);
   L_Rpr.AccessOrigin();
   L_Basis.wb_WrDat(F, RprS.OrdDate);
   L_Basis.wb_WrScl(F, RprS.RprS);
   L_Basis.wb_WrStr(F, L_Rpr.GetRprObjT_AsStr());
   L_Basis.wb_WrScl(F, RprS.RprObjId);
   IF    L_Rpr.IsRprS_w_Car() THEN
    L_Car.StandOnCarLog(Car.BoxNbr, RprS.OrdDate);
    CONFORM(CarLog, Mark);
    L_Basis.wb_WrScl(F, CarLog.StateNbr);
    L_Basis.wb_WrScl(F, Mark.Mark);
    L_Basis.wb_WrStr(F, Mark.Name);
    L_Basis.wb_WrStr(F, CarLog.Column);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
   ELSIF L_Rpr.IsRprS_w_OutCar() THEN
    CONFORM(OutCar, Mark);
    CONFORM(OutCar, Firm);
    L_Basis.wb_WrScl(F, OutCar.StateNbr);
    L_Basis.wb_WrScl(F, Mark.Mark);
    L_Basis.wb_WrStr(F, Mark.Name);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrScl(F, Firm.Firm);
    L_Basis.wb_WrStr(F, Firm.Name);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
   ELSIF L_Rpr.IsRprS_w_CarBlock() THEN
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrScl(F, Math.Math);
    L_Basis.wb_WrStr(F, Math.Name);
    L_Basis.wb_WrStr(F, CUCopy.Serial);
   ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
    CONFORM(OutCBlc, Math);
    CONFORM(OutCBlc, Firm);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrScl(F, Firm.Firm);
    L_Basis.wb_WrStr(F, Firm.Name);
    L_Basis.wb_WrScl(F, Math.Math);
    L_Basis.wb_WrStr(F, Math.Name);
    L_Basis.wb_WrStr(F, OutCBlc.Serial);
   ELSIF L_Rpr.IsRprS_w_Math() THEN
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrScl(F, Math.Math);
    L_Basis.wb_WrStr(F, Math.Name);
    L_Basis.wb_WrStr(F, EmptyVal);
   ELSE
    L_General.CallUs(0);
   END;

   IF ~!TotW.RprT THEN
    SEARCH(RprT, RprS, , TotW.RprS, TotW.RprT);
    L_Basis.wb_WrScl(F, TotW.RprT);
    L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Rpr.rpr_TaskKind_Pool, RprT.TaskKind));
   ELSE
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
   END;

   IF ~!TotW.RprJ THEN
    SEARCH(RprJ, RprS, , TotW.RprS, TotW.RprT, TotW.RprJ);
    CONFORM(RprJ, RprJob);
    L_Basis.wb_WrScl(F, TotW.RprJ);
    L_Basis.wb_WrScl(F, RprJ.RprJob);
    L_Basis.wb_WrStr(F, RprJob.Name);
    L_Rpr.extGetRprJobBaseTime(RprJob.RprJob, TotW.Date, 1, normBaseTime, dummySource, RprJobClass);
    L_Basis.wb_WrScl(F, RprJobClass);
    IF !normBaseTime THEN
     SETZERO(normBaseTime);
    END;
    L_Basis.wb_WrNum(F, normBaseTime, 3);
    L_Basis.wb_WrNum(F, TotW.BasTim, 3);
   ELSE
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrStr(F, EmptyVal);
    L_Basis.wb_WrNum(F, 0, 3);
    L_Basis.wb_WrNum(F, 0, 3);
   END;
  ELSE
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);

   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);

   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);

   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrStr(F, EmptyVal);
   L_Basis.wb_WrNum(F, 0, 3);
   L_Basis.wb_WrNum(F, 0, 3);
  END;
  IF wWagePay THEN
   IF !RprJobClass THEN
    RprJobClass:=StaffLog.Class;
   END;
   CONFORM(StaffLog, Officer);
   CONFORM(Officer, WagePay);
   HISTCONF(TotW.Date, WagePay, WagePayL);
   L_Basis.wb_WrScl(F, WagePay.WagePay);
   L_Basis.wb_WrStr(F, WagePay.Name);
   L_Basis.wb_WrNum(F, WagePayL.Pay[Math.Max(StaffLog.Class, RprJobClass)], 2);
  END;
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE GatherBySort();
  VAR
   trgTim    : LIKE(Sheet.Tim);
   trgDate   : DATE;
   trgBegTime,
   trgEndTime: TIME;
 BEGIN
  APP.Get().NewPrompt(" ᥪ஢");
  SELECT(Sort, IsRprSrt, , 1);
  WHILE OCCURE(Sort) DO
   PROMPT(Sort.Sort);
   D_Staff.Prepare_Stl01(L_General.timeCond_InIntvl, D_Staff.ofc_BySort, 1);
   SELECT(Stl01, TSN);
   WHILE OCCURE(Stl01) DO
    NARROWSEL(Stl01, TSN);
    WHILE OCCURE(Stl01) DO
     IF Stl01.Source # D_Staff.ofcs_byEDO THEN
      trgDate:=Memo.ud_fr();
      WHILE (trgDate <= Memo.ud_ut()) DO
       IF L_DatTim.IsActive_Inc(trgDate, Stl01.OBegDate, Stl01.OEndDate) THEN
        PROMPT(" ⭨ " + Stl01.TSN + " " + L_DatTim.DateStr(trgDate));
        SETEMPTY(trgTim);
        L_General.Assert(SEARCH(RegList, HumReg, Stl01.Regime, L_DatTim.Per(trgDate), L_DatTim.DAY(trgDate)),
                         " ࠡ " + Stl01.Regime + "    " + L_DatTim.DateStr(trgDate));
 
        IF SEARCH(Sheet, TSN, Stl01.TSN, L_DatTim.Per(trgDate), L_DatTim.DAY(trgDate)) & (Sheet.JMode # L_Sheet.jm_RatherEarly(trgDate)) THEN
         CONFORM(Sheet, JMode);
         IF JMode.Type = L_Sheet.jmType_TimDone THEN
          trgTim    :=Sheet.Tim;
         END;
        ELSE
         CONFORM(RegList, JMode);
         IF JMode.Type = L_Sheet.jmType_TimDone THEN
          trgTim    :=RegList.GrTime;
         END;
        END;
 
        SETEMPTY(trgBegTime);
        IF ~!trgTim & (trgTim # 0) THEN
         trgBegTime:=RegList.BegTime;
         trgEndTime:=RegList.EndTime;
         IF !trgBegTime THEN
          CONFORM(RegList, RegHead);
          trgBegTime:=RegHead.BegTime;
          trgEndTime:=RegHead.EndTime;
         END;
 
         rStaff.TSN   :=Stl01.TSN;
         rStaff.Date  :=trgDate;
         IF ~!trgBegTime THEN
          rStaff.BegDTS:=L_DatTim.GetTIMESTAMP(trgDate,                                  trgBegTime);
          rStaff.EndDTS:=L_DatTim.GetTIMESTAMP(trgDate + 1 * (trgEndTime <= trgBegTime), trgEndTime);
         ELSE
          SETEMPTY(rStaff.BegDTS, rStaff.EndDTS);
         END;
         rStaff.ShtTim:=trgTim;
         INSERT(rStaff);
        END;
       END;
       INC(trgDate);
      END;
     END;
     NEXT(Stl01);
    END; (* WHILE OCCURE(Stl01) ... *)
    NEXTINEXTENDEDSEL(Stl01, TSN);
   END; (* WHILE OCCURE(Stl01) ... *)
   D_Staff.Purge_Stl01();
   NEXT(Sort);
  END; (* WHILE OCCURE(Sort) ... *)
 END {GatherBySort};

 PRIVATE PROCEDURE IsRprPForRprJ(trgRprT: LIKE(RprT.RprT); trgRprJ: LIKE(RprJ.RprJ)): SCAL[2];
 BEGIN
  RETURN (!RprP.RprT            & !RprP.RprJ           ) |
         ((RprP.RprT = trgRprT) & !RprP.RprJ           ) |
         ((RprP.RprT = trgRprT) & (RprP.RprJ = trgRprJ))
 END {IsRprPForRprJ};

 PRIVATE PROCEDURE CalcRprJExecutorAmount(): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  SETZERO(Result);
  IF SELECT(RprP, RprS, RprS.RprS, L_Rpr.rprpwho_Executor) THEN
   WHILE OCCURE(RprP) DO
    IF IsRprPForRprJ(RprJ.RprT, RprJ.RprJ) THEN
     INC(Result);
    END;
    NEXT(RprP);
   END; (* WHILE OCCURE(RprP) ... *)
  END;
  IF Result = 0 THEN
   Result:=1;
  END;
  RETURN Result;
 END {CalcRprJExecutorAmount};

 PRIVATE PROCEDURE IsAcceptableRprP(EndDTS: TIMESTAMP): SCAL[2];
 BEGIN
  RETURN ~!RprP.EDate                            &
         (RprP.Who # L_Rpr.rprpwho_AnyDeclarant) &
         (RprP.Who # L_Rpr.rprpwho_DrvDeclarant) &
         (RprP.Who # L_Rpr.rprpwho_Driver)       &
         IsRprPForRprJ(RprJ.RprT, RprJ.RprJ)     &
         (EndDTS >= RepBegDTS) & (EndDTS <= RepEndDTS);
 END {IsAcceptableRprP};

 PRIVATE PROCEDURE IsRprJRprP(): SCAL[2];
 BEGIN
  RETURN ~!RprP.RprT & ~!RprP.RprJ;
 END {IsRprJRprP};

 PRIVATE PROCEDURE GetShiftBegDate(DTS: TIMESTAMP): DATE;
 BEGIN
  RETURN L_DatTim.GetDateOfTIMESTAMP(L_Rpr.GetShiftBegDTS(DTS, ShiftBegTime, ShiftEndTime, ShiftLength));
 END {GetShiftBegDate};

 PRIVATE PROCEDURE GetBasTimeBySingleRprS(trgTSN: LIKE(Staff.TSN); wAdd2Index: SCAL[2]): NUMERIC[3];
  VAR
   Coef           : FLOAT;
   trgDate        : DATE;
   trgRprPLev     : SCAL[3];
   Result,
   curRslt,
   curBasTim,
   RprJLength,
   RprPWrkLength  : NUMERIC[3];
   BegDTS,
   EndDTS,
   RprJBegDTS,
   RprJEndDTS     : TIMESTAMP;
   ExecutorAmount : NUMERIC[0];
   ReplaceRequired: SCAL[2];
 BEGIN
  Result:=0;
  SELECT(RprJ, RprS, , RprS.RprS);
  WHILE OCCURE(RprJ) DO
   IF ~!RprJ.EDate THEN
    RprJBegDTS     :=L_DatTim.GetTIMESTAMP(RprJ.BDate, RprJ.BTime);
    RprJEndDTS     :=L_DatTim.GetTIMESTAMP(RprJ.EDate, RprJ.ETime);
    IF (RprJEndDTS >= RepBegDTS) & (RprJBegDTS <= RepEndDTS) THEN
     RprJLength:=(RprJEndDTS - RprJBegDTS) * 24;
     L_General.Assert(RprJLength # 0, " " + RprJ.RprS +",  " + RprJ.RprT + ",  " + RprJ.RprJ + ": 㫥 த⥫쭮 ࠡ");
     IF !RprJ.BaseTime | (RprJ.BaseTime = 0) THEN
      SETEMPTY(curBasTim);
     ELSE
      curBasTim:=(RprJ.BaseTime * RprJ.ComplCfc * RprJ.Quantity) / CalcRprJExecutorAmount();
     END;
 
     SELECT(RprP, RprS, , RprS.RprS);
     WHILE OCCURE(RprP) DO
      IF ~!RprP.EDate & (!trgTSN | (RprP.TSN = trgTSN)) THEN
       IF IsRprJRprP() THEN
        BegDTS:=L_DatTim.GetTIMESTAMP(RprP.BDate, RprP.BTime);
        EndDTS:=L_DatTim.GetTIMESTAMP(RprP.EDate, RprP.ETime);
       ELSE
        BegDTS:=RprJBegDTS;
        EndDTS:=RprJEndDTS;
       END;
       IF IsAcceptableRprP(EndDTS) THEN
        RprPWrkLength:=(EndDTS - BegDTS) * 24;
        Coef         :=RprPWrkLength / RprJLength;
        IF RprP.Who = L_Rpr.rprpwho_Executor THEN
         IF    !curBasTim THEN
          curRslt:=RprPWrkLength;
         ELSE
          curRslt:=curBasTim * Coef;
         END;
        ELSE
         curRslt:=0;
        END;
        INC(Result, curRslt);
        IF wAdd2Index THEN
         trgDate   :=GetShiftBegDate(EndDTS);
         trgRprPLev:=L_Rpr.GetRprPLevel(RprP.RprS, RprP.RprT, RprP.RprJ);
         IF ~SEARCH(TotW, RprS,   RprJ.RprS, RprJ.RprT, RprJ.RprJ, trgDate, RprP.Who, RprP.TSN) THEN
          DEFAULT(TotW);
          TotW.RprS   :=RprJ.RprS;
          TotW.RprT   :=RprJ.RprT;
          TotW.RprJ   :=RprJ.RprJ;
          TotW.Date   :=trgDate;
          TotW.Who    :=RprP.Who;
          TotW.TSN    :=RprP.TSN;
          INSERT(TotW);
          ReplaceRequired:=1;
         ELSE
          ReplaceRequired:=trgRprPLev > TotW.RprPLev;
         END;
         IF ReplaceRequired THEN
          TotW.RprPLev:=trgRprPLev;
          TotW.HasDtlT:=(Coef # 1);
          TotW.WrkTim :=RprPWrkLength;
          TotW.BasTim :=curRslt;
          TotW.ShtTim :=0;
          REPLACE(TotW);
         END;
        END;
       END; (* IF IsAcceptableRprP()...*)
      END; (* IF ~!trgTSN |...*)
      NEXT(RprP);
     END; (* WHILE OCCURE(RprP) ... *)
    END;
   END;
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ) ... *)
  RETURN Result;
 END {GetBasTimeBySingleRprS};

 PRIVATE PROCEDURE GatherBySingleRprS(trgTSN: LIKE(Staff.TSN));
  VAR
   Dummy: NUMERIC[3];
 BEGIN
  Dummy:=GetBasTimeBySingleRprS(trgTSN, 1);
 END {GatherBySingleRprS};

 PRIVATE PROCEDURE GatherByRprS();
  VAR
   Amount     : NUMERIC[0];
   LastRepDate: DATE;
 BEGIN
  APP.Get().NewPrompt(" ");
  LastRepDate:=L_DatTim.GetDateOfTIMESTAMP(RepEndDTS);
  SELECT(RprS, EDate);
  SRCINSEL(RprS, GE, , Memo.ud_fr());
  WHILE OCCURE(RprS) DO
   PROMPT(RprS.RprS);
   IF (RprS.OrdDate <= LastRepDate) & (RprS.Status # L_Rpr.ms_Cancel) THEN
    GatherBySingleRprS(EMPTYOF(Staff.TSN));
   END;
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)

  SELECT(TotW, TSN);
  WHILE OCCURE(TotW) DO
   NARROWSEL(TotW, TSN, Date);
   IF SEARCH(rStaff, TSN, TotW.TSN, TotW.Date) THEN
    SAVE(TotW);
    SETZERO(Amount);
    WHILE OCCURE(TotW) DO
     INC(Amount);
     NEXT(TotW);
    END; (* WHILE OCCURE(TotW) ... *)
    RESTORE(TotW);
    WHILE OCCURE(TotW) DO
     TotW.ShtTim:=rStaff.ShtTim/Amount;
     REPLACE(TotW);
     NEXT(TotW);
    END; (* WHILE OCCURE(TotW) ... *)
   END;
   NEXTINEXTENDEDSEL(TotW, TSN, Date);
  END; (* WHILE OCCURE(TotW) ... *)

  SELECT(rStaff, TSN);
  WHILE OCCURE(rStaff) DO
   IF ~SELECT(TotW, TSN, rStaff.TSN, rStaff.Date) THEN
    SETEMPTY(TotW.RprS, TotW.RprT, TotW.RprJ, TotW.Who, TotW.RprPLev);
    TotW.Date  :=rStaff.Date;
    TotW.TSN   :=rStaff.TSN;
    SETZERO(TotW.WrkTim, TotW.BasTim, TotW.HasDtlT);
    TotW.ShtTim:=rStaff.ShtTim;
    INSERT(TotW);
   END;
   NEXT(rStaff);
  END; (* WHILE OCCURE(rStaff) ... *)
 END {GatherByRprS};

 PRIVATE PROCEDURE CreateTmpFile();
 BEGIN
  L_AFM.MakeMultipleIndex("TotW", "RprS   : LIKE(RprS.RprS);" +
                                  "RprT   : LIKE(RprT.RprT);" +
                                  "RprJ   : LIKE(RprJ.RprJ);" +
                                  "Date   : DATE;" +
                                  "Who    : LIKE(RprP.Who);" +
                                  "TSN    : LIKE(Staff.TSN);" +
                                  "RprPLev: SCAL[3];" +
                                  "HasDtlT: SCAL[2];" +
                                  "BasTim : NUMERIC[3];" +
                                  "ShtTim : NUMERIC[3];" +
                                  "WrkTim : NUMERIC[3]",
                          "RprS:RprS, RprT, RprJ, Date, Who, TSN;" +
                          "TSN:TSN, Date,RprS, RprT, RprJ");
 END {CreateTmpFile};

 PRIVATE PROCEDURE MakeIndex();
 BEGIN
  L_AR.GrantRightsUnconditionally();
  CreateTmpFile();

  L_AFM.MakeMultipleIndex("rStaff", "TSN   : LIKE(Staff.TSN);" +
                                    "Date  : DATE;" +
                                    "BegDTS: TIMESTAMP;" +
                                    "EndDTS: TIMESTAMP;" +
                                    "ShtTim: NUMERIC[3]",
                          "TSN:TSN,Date");
  GatherBySort();
  GatherByRprS();
 END {MakeIndex};

 PRIVATE PROCEDURE SetReportParams(trgFrom, trgUpTo: DATE);
 BEGIN
  L_Rpr.E_RprSShiftParams(ShiftBegTime, ShiftEndTime, ShiftLength);
  RepBegDTS:=L_DatTim.GetTIMESTAMP(trgFrom,   ShiftBegTime);
  RepEndDTS:=L_DatTim.GetTIMESTAMP(trgUpTo+1, ShiftBegTime);
 END {SetReportParams};

 PUBLIC PROCEDURE Rpr02();
  CONST
   bpId = "Rpr02";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "㧪 ६ ᥪ஢", L_bp.t_Basis, L_General.timeCond_InIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);

  SetReportParams(Memo.ud_fr(), Memo.ud_ut());
  MakeIndex();

  APP.Get().NewPrompt("㧪");
  MakeHeader("R", 0);
  SELECT(TotW, TSN);
  WHILE OCCURE(TotW) DO
   PROMPT("⭨ " + TotW.TSN + " " + L_DatTim.DateStr(TotW.Date));
   MakePart("R", 0);
   NEXT(TotW);
  END; (* WHILE OCCURE(TotW) ... *)

  FIO.Close(R);
  L_bp.End();
 END {Rpr02};

 PUBLIC PROCEDURE GetTSNTotalBaseTime(trgTSN: LIKE(Staff.TSN); trgFrom, trgUpTo: DATE; VAR TotalBaseTim: NUMERIC[3]);
  VAR
   LastRepDate: DATE;
 BEGIN
  APP.Get().NewPrompt(" ࠡ⠭ ६  ");
  SETZERO(TotalBaseTim);
  L_AR.GrantRightsUnconditionally();
  SetReportParams(trgFrom, trgUpTo);
  IF ~DBD.FileExist("TotW") THEN
   CreateTmpFile();
   L_AFM.MakeIndex("_RLst", "RprS: LIKE(RprS.RprS)");
  ELSE
   SELECT(TotW, TSN);   REMSEL(TotW);
   SELECT(_RLst, _RLst); REMSEL(_RLst);
  END;

  LastRepDate:=L_DatTim.GetDateOfTIMESTAMP(RepEndDTS);
  SELECT(RprP, EBDTSN, , trgTSN);
  SRCINSEL(RprP, GE, , trgFrom);
  WHILE OCCURE(RprP) DO
   IF RprP.BDate <= LastRepDate THEN
    CONFORM(RprP, RprS);
    PROMPT(":  " + RprS.RprS);
    IF (RprS.Status # L_Rpr.ms_Cancel) THEN
     IF ~SEARCH(_RLst, _RLst, RprS.RprS) THEN
      _RLst.RprS:=RprS.RprS;
      INSERT(_RLst);
     END;
    END;
   END;
   NEXT(RprP);
  END; (* WHILE OCCURE(RprP) ... *)

  SELECT(_RLst, _RLst);
  WHILE OCCURE(_RLst) DO
   SEARCH(RprS, RprS, , _RLst.RprS);
   PROMPT("ࠡ⪠ " + RprS.RprS);
   GatherBySingleRprS(trgTSN);
   NEXT(_RLst);
  END; (* WHILE OCCURE(_RLst) ... *)

  SELECT(TotW, TSN);
  WHILE OCCURE(TotW) DO
   INC(TotalBaseTim, TotW.BasTim);
   NEXT(TotW);
  END; (* WHILE OCCURE(TotW) ... *)
 END {GetTSNTotalBaseTime};

 PUBLIC PROCEDURE GetRprSBasTime(VAR Result: NUMERIC[2]);
 BEGIN
  RepBegDTS:=MINOF(RepBegDTS);
  RepEndDTS:=MAXOF(RepEndDTS);
  Result:=GetBasTimeBySingleRprS(EMPTYOF(Staff.TSN), 0);
 END {GetRprSBasTime};

END.
