(*
%Copyright   (c) Polak IT
%Author      14.04.2003 17:54:41 POLAK\LDA
%Purpose      ६  ࠧ ࠧ१
%Type        report
%Specific    AP
%Modified    03.07.2014 09:56:07 POLAK\LDA
%Environment
*)

 MODULE Rpr06 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_Rpr, L_Str, L_DatTim, L_StdFrm, Str,
        L_AFM, Memo, L_CUC, P_Rpr;

 PRIVATE CONST
  obj_curCar             = 0;
  obj_curCarBlock        = 1;
  obj_curRprDA           = 2;
  obj_curTSN             = 3;
  obj_curRprDAAndJob     = 4;
  obj_curRprT            = 5;
  obj_curCarBlockAndNote = 6;
  obj_curRprJobAndNote   = 7;
  obj_Last10RprS         = 8;
  obj_Shift              = 9;
  obj_OpenRprS_w_Scope   = 10;
  obj_curRprDfApr        = 11;

  per_byPeriod    = 0;
  per_byLastMonth = 1;
  per_byLastDays  = 2;
  per_byShift     = 3;
  per_AllRprS     = 4;

  RprSMaxAmount = 10;

 PRIVATE VAR
  RepName  : STRING[];
  curObj   : SCAL[1E2];
  curPer   : SCAL[10];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
?, C, ""
?, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
|############################################################################################################|
}
*)


(*
$P{ Dlm:
@
|============================================================================================================|
}
*)

(*
$P{ SubTop_1:
@
|                              . ६      . ६            ᥣ                                |
}
*)

(*
$P{ SubTop_2:
?, L, ""
?, R, "0"
?, R, "0"
?, R, "0"
@
|#########################           ######           ######           ######                                |
}
*)

(*
$P{ SubBot:
?, R, "2."
?, R, "2."
@
|------------------------------------------------------------------------------------------------------------|
| ଠ⨢ 㤮 ࠡ     ########                                                           |
|饥 䠪᪮ ६ 믮 ࠡ ########                                                           |
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE EU_Mode(): SCAL[2];
 BEGIN
  RETURN L_General.KioskExecution_IsRunning();
 END {EU_Mode};

 PRIVATE PROCEDURE GetLocationList_byScope(): STRING[];
  VAR
   _Location       : L_Rpr.tRprSLocation;
   LocationList    : STRING[];
   RprSLocationView: SCAL[2][L_Rpr.rprl_Amount];
 BEGIN
  L_Rpr.GetDefaultViewRprSScopeMode(RprSLocationView);
  SETEMPTY(LocationList);
  _Location:=0;
  WHILE _Location < L_Rpr.rprl_Amount DO
   IF L_Rpr.E_AllowedRprSLocation(_Location) & RprSLocationView[_Location] THEN
    LocationList:=L_Str.AddStrDlm(LocationList, ", ") + L_Rpr.GetRprSLocation_AsStr(_Location);
   END;
   INC(_Location);
  END; (* WHILE _Location < L_Rpr.rprl_Amount...*)
  RETURN LocationList;
 END {GetLocationList_byScope};

 PRIVATE PROCEDURE FoundRprDA(): SCAL[2];
 BEGIN
  SELECT(RprDA, RprS, , RprS.RprS);
  WHILE OCCURE(RprDA) DO
   IF SEARCH(_RprD, RprDfApr, RprDA.RprDfApr) THEN
    RETURN 1;
   END;
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)
  RETURN 0;
 END {FoundRprDA};

 PRIVATE PROCEDURE FoundRprJ(): SCAL[2];
 BEGIN
  IF SELECT(RprJ, RprS, RprS.RprS) THEN
   WHILE OCCURE(RprJ) DO
    IF SEARCH(_RprJ, RprJob, RprJ.RprJob) THEN
     RETURN 1;
    END;
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {FoundRprJ};

 PRIVATE PROCEDURE IsRprSOpenInIntvl(BDate: DATE; BTime: TIME; EDate: DATE; ETime: TIME): SCAL[2];
  VAR
   BegPerIntvl,
   EndPerIntvl,
   RprSDateTimeIntvl: FLOAT;
 BEGIN
  PackVARIANTDATE(RprSDateTimeIntvl, RprS.OrdDate, RprS.OrdTime);
  PackVARIANTDATE(BegPerIntvl,       BDate,        BTime);
  PackVARIANTDATE(EndPerIntvl,       EDate,        ETime);
  RETURN (RprSDateTimeIntvl >= BegPerIntvl) & (RprSDateTimeIntvl <= EndPerIntvl);
 END {IsRprSOpenInIntvl};

 PRIVATE PROCEDURE HasAcceptableCarBlockInCurRprS(trgCarBlock: LIKE(CarBlock.CarBlock)): SCAL[2];
 BEGIN
  SELECT(RprDA, RprS, , RprS.RprS);
  WHILE OCCURE(RprDA) DO
   IF RprDA.CarBlock = trgCarBlock THEN
    RETURN 1;
   END;
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)
  RETURN 0;
 END {HasAcceptableCarBlockInCurRprS};

 PRIVATE PROCEDURE AcceptableRprS(BPer       : DATE; BTime: TIME;
                                  EPer       : DATE; ETime: TIME;
                                  RprSAmnt   : NUMERIC[0];
                                  trgCarBlock: LIKE(CarBlock.CarBlock);
                                  trgSort    : LIKE(Sort.Sort);
                                  trgRprDfApr: LIKE(RprDfApr.RprDfApr)): SCAL[2];
  VAR
   RprSLocationView: SCAL[2][L_Rpr.rprl_Amount];
 BEGIN
  IF    curObj = obj_curCar THEN
   RETURN 1;
  ELSIF (curObj = obj_curCarBlock) | (curObj = obj_curRprDA) THEN
   RETURN HasAcceptableCarBlockInCurRprS(trgCarBlock);
  ELSIF curObj = obj_curTSN THEN
   SELECT(RprP, RprS, , RprS.RprS);
   WHILE OCCURE(RprP) DO
    IF RprP.TSN = Staff.TSN THEN
     RETURN 1;
    END;
    NEXT(RprP);
   END; (* WHILE OCCURE(RprP)...*)
  ELSIF curObj = obj_curRprDAAndJob THEN
   RETURN FoundRprDA() & FoundRprJ();
  ELSIF curObj = obj_curRprT THEN
   RETURN FoundRprJ();
  ELSIF curObj = obj_curCarBlockAndNote THEN
   RETURN HasAcceptableCarBlockInCurRprS(trgCarBlock) &
          P_Rpr.HasRprSPro(RprS.RprS, P_Rpr.P_AdditionalInfo);
  ELSIF curObj = obj_curRprJobAndNote THEN
   RETURN FoundRprJ() &
          P_Rpr.HasRprSPro(RprS.RprS, P_Rpr.P_AdditionalInfo);
  ELSIF curObj = obj_Last10RprS THEN
   RETURN RprSAmnt < RprSMaxAmount;
  ELSIF curObj = obj_Shift THEN
   IF IsRprSOpenInIntvl(BPer, BTime, EPer, ETime) THEN
    SELECT(RprT, RprS, , RprS.RprS);
    WHILE OCCURE(RprT) DO
     IF RprT.Sort = trgSort THEN
      RETURN 1;
     END;
     NEXT(RprT);
    END; (* WHILE OCCURE(RprT) ... *)
   END;
  ELSIF curObj = obj_OpenRprS_w_Scope THEN
   L_Rpr.GetDefaultViewRprSScopeMode(RprSLocationView);
   RETURN (RprS.Closed = 0) & RprSLocationView[RprS.Location];
  ELSIF curObj = obj_curRprDfApr THEN
   RETURN SEARCH(RprDA, RprS, RprS.RprS, trgRprDfApr);
  ELSE
   L_General.Error(" ० " + curObj);
  END;
  RETURN 0;
 END {AcceptableRprS};

 PRIVATE PROCEDURE NeedPrintPutOffDA(): SCAL[2];
 BEGIN
  RETURN (curObj = obj_curCar)     |
         (curObj = obj_curRprDA)   |
         (curObj = obj_Last10RprS) |
         (curObj = obj_curRprDfApr);
 END {NeedPrintPutOffDA};

 PRIVATE PROCEDURE GetRprTime(): NUMERIC[3];
 BEGIN
  IF RprS.Closed THEN
   RETURN (L_DatTim.GetTIMESTAMP(RprS.EDate, RprS.ETime) - L_DatTim.GetTIMESTAMP(RprS.OrdDate, RprS.OrdTime)) * 24;
  ELSE
   RETURN (L_DatTim.GetSysTIMESTAMP() - L_DatTim.GetTIMESTAMP(RprS.OrdDate, RprS.OrdTime)) * 24;
  END;
 END {GetRprTime};

 PRIVATE PROCEDURE MakeRep();
  VAR
   BPer,
   EPer           : DATE;
   Title          : STRING[][3];
   SortList       : STRING[];
   SortPos,
   Total,
   LongRpr,
   RprSAmnt       : NUMERIC[0];
   BTime, ETime   : TIME;
   TotalRprJTimes : NUMERIC[2][2];
   pr_Obj, RprTime: NUMERIC[0];
   NeedPrintDlm   : SCAL[2];
   curRprS        : LIKE(RprS.RprS);
   curSort        : LIKE(Sort.Sort);
   curCarBlock    : LIKE(CarBlock.CarBlock);
   curRprDfApr    : LIKE(RprDfApr.RprDfApr);
 BEGIN
  SETEMPTY(BPer, BTime, EPer, ETime);
  IF    curPer = per_byPeriod THEN
   L_General.SetIntvlByIntvl(BPer, EPer);
  ELSIF curPer = per_byLastMonth THEN
   EPer:=Memo.tmp_cd();
   BPer:=EPer - 30;
  ELSIF curPer = per_byLastDays THEN
   EPer:=RprS.OrdDate;
   BPer:=EPer - 10;
  ELSIF curPer = per_byShift THEN
   L_Rpr.GetCurShiftBeginEnd(BPer, BTime, EPer, ETime);
  ELSIF curPer = per_AllRprS THEN
   SETEMPTY(BPer, EPer);
  END;

  SETEMPTY(curRprS, curCarBlock, curSort, curRprDfApr);
  IF    curObj = obj_curCar THEN
(*
祣  .  ⮬ ०     ᪠
 롮 ਮ  
*)
  ELSIF (curObj = obj_curCarBlock)        |
        (curObj = obj_curRprDA)           |
        (curObj = obj_curRprDAAndJob)     |
        (curObj = obj_curRprT)            |
        (curObj = obj_curCarBlockAndNote) |
        (curObj = obj_curRprJobAndNote)   |
        (curObj = obj_curRprDfApr) THEN
   STDFORM(L_StdFrm.sf_Choice("| ਮ  %##########%  %##########%|",
                              "%L<D.N.y>YI  %L<D.N.y>YI"),
           "  ६⮢ ",
           ,
           ,
           BPer, EPer);
  ELSIF curObj = obj_Shift THEN
   SETEMPTY(SortList);
   SELECT(Sort, IsRprSrt, , 1);
   WHILE OCCURE(Sort) DO
    SortList:=SortList + Sort.Sort + " " + Sort.Name + "|";
    NEXT(Sort);
   END; (* WHILE OCCURE(Sort) ... *)
   SortPos:=0;
   STDFORM(L_StdFrm.sf_Choice("| %###############################%" +
                              "|                                        " +
                              "|砫 ᬥ      %##########%  %#####% " +
                              "|                                        " +
                              "|砭 ᬥ   %##########%  %#####%|",
                              "%<"+SortList+">I" +
                              "%<D.N.y>I" +
                              "%<H:M>I" +
                              "%<D.N.y>I" +
                              "%<H:M>I"),
           " ਮ ࠡ ᬥ ",
           ,
           ,
           SortPos,
           BPer,
           BTime,
           EPer,
           ETime);
  ELSIF curObj = obj_OpenRprS_w_Scope THEN
(* 祣   - 㦭    *)
  END;

  L_Rpr.InitRprSReport(EU_Mode(), " ६⮢");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF    (curObj = obj_curCar) | (curObj = obj_Last10RprS) THEN
   Title[0]:=" ६";
   IF    CUCopy.Origin = L_CUC.o_Car THEN
    L_Car.StandOnCarLog(Car.BoxNbr, EPer);
    CONFORM(CarLog, Mark);
    Title[1]:=L_Str.PoolItem(L_CUC.o_Pool, CUCopy.Origin) + " " + Car.BoxNbr + " " + CarLog.StateNbr + " " + Mark.Name;
   ELSIF CUCopy.Origin = L_CUC.o_OutCar THEN
    CONFORM(OutCar, Mark);
    Title[1]:=L_Str.PoolItem(L_CUC.o_Pool, CUCopy.Origin) + " " + OutCar.OutCar + " " + OutCar.StateNbr + " " + Mark.Name;
   ELSIF CUCopy.Origin = L_CUC.o_OutCBlc THEN
    CONFORM(OutCBlc, Math);
    Title[1]:=L_Str.PoolItem(L_CUC.o_Pool, CUCopy.Origin) + " " + OutCBlc.OutCBlc + Str.Condense(" " + OutCBlc.Serial + " " + Math.Name);
   END;
   SELECT(RprS, CUCopy, , CUCopy.CUCopy);
  ELSIF curObj = obj_curRprDA THEN
   L_General.Assert(~!RprS.CUCopy, " 㪠 ꥪ ६");
   CONFORM(RprS, CUCopy);
   curCarBlock:=CarBlock.CarBlock;
   Title[0]:=" ६";
   Title[1]:=L_Str.PoolItem(L_CUC.o_Pool, CUCopy.Origin) + " " + RprS.RprObjId + " " + CUCopy.Serial + ", ॣ " + CarBlock.CarBlock + " " + CarBlock.Name;
   curRprS:=RprS.RprS;
   SELECT(RprS, CUCopy, , RprS.CUCopy);
  ELSIF curObj = obj_curCarBlock THEN
   curCarBlock:=CarBlock.CarBlock;
   SELECT(RprS, OrdDate);
   Title[0]:=" ६";
   Title[1]:=" (⥬) ꥪ ६ " + CarBlock.CarBlock + " " + CarBlock.Name;
  ELSIF curObj = obj_curTSN THEN
   CONFORM(Staff, Man);
   Title[0]:="⨥ ࠡ⭨  ६";
   Title[1]:="⭨ " + Staff.TSN + " " + Man.Name;
   SELECT(RprS, OrdDate);
  ELSIF curObj = obj_curRprDAAndJob THEN
   curRprS:=RprS.RprS;
   L_General.Assert(~!RprS.CUCopy, " 㪠 ꥪ ६");
   CONFORM(RprS, CUCopy);
   Title[0]:="祭   騬 ࠢﬨ  ࠡ⠬";
   Title[1]:=L_Str.PoolItem(L_CUC.o_Pool, CUCopy.Origin) + " " + RprS.RprObjId;
   SELECT(RprS, CUCopy, , RprS.CUCopy);
  ELSIF curObj = obj_curRprT THEN
   curRprS:=RprS.RprS;
   CONFORM(RprS, CUCopy);
   Title[0]:="祭   騬 ६묨 ࠡ⠬";
   Title[1]:=L_Str.PoolItem(L_CUC.o_Pool, CUCopy.Origin) + " " + RprS.RprObjId;
   SELECT(RprS, CUCopy, , RprS.CUCopy);
  ELSIF curObj = obj_curCarBlockAndNote THEN
   curCarBlock:=CarBlock.CarBlock;
   Title[0]:="祭  ";
   Title[1]:=" (⥬) ꥪ ६ " + CarBlock.CarBlock + " " + CarBlock.Name;
   SELECT(RprS, OrdDate);
  ELSIF curObj = obj_curRprJobAndNote THEN
   _RprJ.RprJob:=RprJob.RprJob;
   INSERT(_RprJ);
   Title[0]:="祭  ";
   Title[1]:="⭠ ࠡ " + RprJob.RprJob + " " + RprJob.Name;
   SELECT(RprS, OrdDate);
  ELSIF curObj = obj_Shift THEN
   curSort:=Str.Item(L_Str.PoolItem(SortList, SortPos), " ", 0);
   SEARCH(Sort, Sort, , curSort);
   Title[0]:=" ࠡ ᥪ";
   Title[1]:=" " + Sort.Sort + " " + Sort.Name;
   SELECT(RprS, OrdDate);
  ELSIF curObj = obj_OpenRprS_w_Scope THEN
   Title[0]:="  ६ ";
   Title[1]:="(" + GetLocationList_byScope() + ")";
   SELECT(RprS, cOrdDate, , 0);
  ELSIF curObj = obj_curRprDfApr THEN
   curRprDfApr:=RprDfApr.RprDfApr;
   SELECT(RprS, OrdDate);
   Title[0]:=" ६";
   Title[1]:="ࠢ " + RprDfApr.RprDfApr + " " + RprDfApr.Name;
  END;

  IF    curObj = obj_Last10RprS THEN
   Title[2]:="(᫥ " + L_Str.IntStr(RprSMaxAmount) + " ६ ⮢)";
  ELSIF curObj = obj_Shift THEN
   Title[2]:="  " + L_DatTim.DateTimeStr(BPer, BTime) + "  " + L_DatTim.DateTimeStr(EPer, ETime);
  ELSIF curObj = obj_OpenRprS_w_Scope THEN
   SETEMPTY(Title[2]);
  ELSE
   IF    !BPer & !EPer THEN
    Title[2]:="  ";
   ELSIF !BPer THEN
    Title[2]:=" ਮ  " + L_DatTim.DateStr(EPer);
   ELSIF !EPer THEN
    Title[2]:=" ਮ  " + L_DatTim.DateStr(BPer);
   ELSE
    Title[2]:=" ਮ  " + L_DatTim.DateStr(BPer) + "  " + L_DatTim.DateStr(EPer);
   END;
  END;

  MAKEPART(R, Top,  Title[0], Title[1], Title[2]);

  IF !BPer THEN
   BPer:=L_DatTim.MINDATE();
  END;
  IF !EPer THEN
   EPer:=L_DatTim.MAXDATE();
  END;

  IF (curObj = obj_curCar)         |
     (curObj = obj_Last10RprS)     |
     (curObj = obj_curRprDA)       |
     (curObj = obj_curRprDAAndJob) |
     (curObj = obj_curRprT) THEN
   pr_Obj:=L_Rpr.pro_Staff;
  ELSE
   pr_Obj:=L_Rpr.pro_RprObj;
  END;

  L_AFM.MakeMultipleIndex("_RprS", "RprS   : LIKE(RprS.RprS);" +
                                   "OrdDate: DATE;" +
                                   "OrdTime: TIME;" +
                                   "RprTime: NUMERIC[3];" +
                                   "Group  : NUMERIC[0]",
                          "RprTime:Group,RprTime,RprS;OrdDT:OrdDate,OrdTime");

  L_AFM.MakeMultipleIndex("_TotR", "Location: LIKE(RprS.Location);" +
                                   "Total   : NUMERIC[0];" +
                                   "LongRpr : NUMERIC[0]",
                          "Location:Location");

  SETZERO(RprSAmnt);
  SETZERO(TotalRprJTimes);
  SRCINSEL(RprS, LE, , EPer);
  WHILE OCCURE(RprS) & (RprS.OrdDate >= BPer) DO
   PROMPT(" " + RprS.RprS);
   IF (RprS.Status # L_Rpr.ms_Cancel) &
       AcceptableRprS(BPer, BTime, EPer, ETime, RprSAmnt, curCarBlock, curSort, curRprDfApr) THEN
    RprTime:=GetRprTime();
    _RprS.RprS   :=RprS.RprS;
    _RprS.OrdDate:=RprS.OrdDate;
    _RprS.OrdTime:=RprS.OrdTime;
    _RprS.RprTime:=-RprTime;
    _RprS.Group  :=RprTime <= 24;
    INSERT(_RprS);

    INC(RprSAmnt);
    ADD(_TotR, Location, , RprS.Location,
        _TotR.Total,   1,
        _TotR.LongRpr, _RprS.Group = 0);
   END;
   PREV(RprS);
  END; (* WHILE OCCURE(RprS) ... *)

  IF curObj = obj_OpenRprS_w_Scope THEN
   MAKEPART(R, Dlm);
   MAKEPART(R, SubTop_1);
   SETZERO(Total, LongRpr);
   SELECT(_TotR, Location);
   WHILE OCCURE(_TotR) DO
    MAKEPART(R, SubTop_2, L_Rpr.GetRprSLocation_AsStr(_TotR.Location), _TotR.LongRpr, _TotR.Total - _TotR.LongRpr, _TotR.Total);
    INC(Total,   _TotR.Total);
    INC(LongRpr, _TotR.LongRpr);
    NEXT(_TotR);
   END; (* WHILE OCCURE(_TotR) ... *)
   MAKEPART(R, SubTop_2, "⮣: ", LongRpr, Total - LongRpr, Total);
   NeedPrintDlm:=0;
   SELECT(_RprS, RprTime);
   WHILE OCCURE(_RprS) DO
    IF (LongRpr # 0) & NeedPrintDlm THEN
     MAKEPART(R, Dlm);
     MAKEPART(R, Dlm);
    END;
    NARROWSEL(_RprS, Group);
    WHILE OCCURE(_RprS) DO
     SEARCH(RprS, RprS, , _RprS.RprS);
     PROMPT(" " + RprS.RprS);
     L_Rpr.intPrintRprS("R", pr_Obj, EU_Mode(), NeedPrintPutOffDA(), curCarBlock, curSort);
     NEXT(_RprS);
    END; (* WHILE OCCURE(_RprS) ... *)
    NeedPrintDlm:=1;
    NEXTINEXTENDEDSEL(_RprS, Group);
   END; (* WHILE OCCURE(_RprS) ... *)
  ELSE
   SELECT(_RprS, OrdDT);
   LAST(_RprS);
   WHILE OCCURE(_RprS) DO
    SEARCH(RprS, RprS, , _RprS.RprS);
    PROMPT(" " + RprS.RprS);
    L_Rpr.intPrintRprS_wRprJTimes("R", pr_Obj, EU_Mode(), 0, 1, NeedPrintPutOffDA(), curCarBlock, curSort, TotalRprJTimes);
    PREV(_RprS);
   END; (* WHILE OCCURE(_RprS) ... *)
   MAKEPART(R, SubBot, TotalRprJTimes[0], TotalRprJTimes[1]);
  END;
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_Rpr.DoneRprSReport(EU_Mode());
 END {MakeRep};

 PRIVATE PROCEDURE Create_TmpFiles();
 BEGIN
  CreateFILE(_RprD, "", "६ 䠩 ࠢ⥩", "");
  CreateFIELD(_RprD, RprDfApr, LIKE(RprDfApr.RprDfApr), "", "", "", "ࠢ", "");

  CreateINDEX(_RprD, RprDfApr, UNIQUE, "", "", RprDfApr);

  SetVersionOfFILE(_RprD, 0);
  L_AFM.AF_CreateTemp("_RprD", "_RprD");

  CreateFILE(_RprJ, "", "६ 䠩 ࠡ", "");
  CreateFIELD(_RprJ, RprJob, LIKE(RprJob.RprJob), "", "", "", "", "");

  CreateINDEX(_RprJ, RprJob, UNIQUE, "", "", RprJob);
  SetVersionOfFILE(_RprJ, 0);
  L_AFM.AF_CreateTemp("_RprJ", "_RprJ");
 END {Create_TmpFiles};

 PRIVATE PROCEDURE MakeIndex(wRprT: SCAL[2]);
 BEGIN
  PROMPT("ઠ ....");
  IF wRprT THEN
   SELECT(RprDA, RprS, , RprS.RprS);
   WHILE OCCURE(RprDA) DO
    IF ~SEARCH(_RprD, RprDfApr, RprDA.RprDfApr) THEN
     _RprD.RprDfApr:=RprDA.RprDfApr;
     INSERT(_RprD);
    END;
    NEXT(RprDA);
   END; (* WHILE OCCURE(RprDA) ... *)
  END;

  SELECT(RprJ, RprS, , RprS.RprS);
  WHILE OCCURE(RprJ) DO
   IF ~SEARCH(_RprJ, RprJob, RprJ.RprJob) THEN
    _RprJ.RprJob:=RprJ.RprJob;
    INSERT(_RprJ);
   END;
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE ByCarBlockRepMode(): SCAL[2];
 BEGIN
  RETURN (MODE = 101) | (MODE = 102) | (MODE = 107);
 END {ByCarBlockRepMode};

 PUBLIC PROCEDURE RHs00();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Car), " ࠭ ");
  CONFORM(Car, CUCopy);
  RepName:="RHs00";
  curObj :=obj_curCar;
  curPer :=per_byPeriod;
  MakeRep();
 END {RHs00};

 PUBLIC PROCEDURE RHs01();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(CarBlock), " ࠭ ॣ/⥬");
  RepName:="RHs01";
  curObj :=obj_curCarBlock;
  curPer :=per_byPeriod;
  MakeRep();
 END {RHs01};

 PUBLIC PROCEDURE RHs02();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Rpr.AccessRprS();
  L_General.Assert(ACCESS(RprDA), " ࠭  ࠢ");
  CONFORM(RprDA, CarBlock);
  RepName:="RHs02";
  curObj :=obj_curRprDA;
  curPer :=per_byLastMonth;
  MakeRep();
 END {RHs02};

 PUBLIC PROCEDURE RHs03();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Staff), " ࠭ ࠡ⭨");
  RepName:="RHs03";
  curObj :=obj_curTSN;
  curPer :=per_byPeriod;
  MakeRep();
 END {RHs03};

 PUBLIC PROCEDURE RHs04();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Rpr.AccessRprS();
  RepName:="RHs04";
  curObj :=obj_curRprDAAndJob;
  curPer :=per_byLastDays;
  Create_TmpFiles();
  MakeIndex(1);
  MakeRep();
 END {RHs04};

 PUBLIC PROCEDURE RHs05();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Rpr.AccessRprS();
  L_Rpr.AccessRprT();
  RepName:="RHs05";
  curObj :=obj_curRprT;
  curPer :=per_byPeriod;
  Create_TmpFiles();
  MakeIndex(0);
  MakeRep();
 END {RHs05};

 PUBLIC PROCEDURE RHs07();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(CarBlock), " ࠭ ॣ/⥬");
  RepName:="RHs07";
  curObj :=obj_curCarBlockAndNote;
  curPer :=per_byPeriod;
  MakeRep();
 END {RHs07};

 PUBLIC PROCEDURE RHs08();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(RprJob), " ࠭ ६⭠ ࠡ");
  RepName:="RHs08";
  curObj :=obj_curRprJobAndNote;
  curPer :=per_byPeriod;
  Create_TmpFiles();
  MakeRep();
 END {RHs08};

 PUBLIC PROCEDURE RHs09();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Car), " ࠭ ");
  CONFORM(Car, CUCopy);
  RepName:="RHs09";
  curObj :=obj_Last10RprS;
  curPer :=per_AllRprS;
  MakeRep();
 END {RHs09};

 PUBLIC PROCEDURE RHs10();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepName:="RHs10";
  curObj :=obj_Shift;
  curPer :=per_byShift;
  MakeRep();
 END {RHs10};

 PUBLIC PROCEDURE RHs11();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(OutCar), " ࠭ ");
  CONFORM(OutCar, CUCopy);
  RepName:="RHs11";
  curObj :=obj_curCar;
  curPer :=per_byPeriod;
  MakeRep();
 END {RHs11};

 PUBLIC PROCEDURE RHs12();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(OutCar), " ࠭ ");
  CONFORM(OutCar, CUCopy);
  RepName:="RHs12";
  curObj :=obj_Last10RprS;
  curPer :=per_AllRprS;
  MakeRep();
 END {RHs12};

 PUBLIC PROCEDURE RHs13();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepName:="RHs13";
  curObj :=obj_OpenRprS_w_Scope;
  curPer :=per_AllRprS;
  MakeRep();
 END {RHs13};

 PUBLIC PROCEDURE RHs14();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(OutCBlc), " ࠭ ॣ");
  CONFORM(OutCBlc, CUCopy);
  RepName:="RHs14";
  curObj :=obj_curCar;
  curPer :=per_byPeriod;
  MakeRep();
 END {RHs14};

 PUBLIC PROCEDURE RHs15();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(OutCBlc), " ࠭ ॣ");
  CONFORM(OutCBlc, CUCopy);
  RepName:="RHs15";
  curObj :=obj_Last10RprS;
  curPer :=per_AllRprS;
  MakeRep();
 END {RHs15};

 PUBLIC PROCEDURE RHs16();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(RprDfApr), " ࠭ ࠢ");
  RepName:="RHs16";
  curObj :=obj_curRprDfApr;
  curPer :=per_byPeriod;
  Create_TmpFiles();
  MakeRep();
 END {RHs16};

END.
