(*
%Copyright   (c) Polak IT
%Author      07.06.2004 10:43:51 POLAK\LDA
%Purpose     
%Type        report
%Specific    LOC
%Modified    29.08.2013 15:56:01 POLAK\LDA
%Environment
*)

 MODULE Rpr17 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Rpr, L_Car, L_General, L_DatTim, L_OwnData, L_BegRWS, L_AFM, L_Env,
        L_StdFrm, L_Str, L_XDoc, Str, E_Rpr, L_RT, L_Way, Math, P_Rpr, DBD;

 PRIVATE TYPE
  tTKindGroup = SCAL[3];

 PRIVATE CONST
  StateAmnt = 9;

  st_InPark     = 0;
  st_TimeToGo   = 1;
  st_DrvFall    = 2;
  st_woDrv1     = 3;
  st_woDrv2     = 4;
  st_Repair     = 5;
  st_LongRepair = 6;
  st_Ordered    = 7;
  st_InWork     = 8;

  SpcColumnWidth = 60;

  ReportKindAmount  = 3;
  defReportKindPool = "|饣 짮|⢥ 짮";

  rk_All       = 0;
  rk_CommonAll = 1;
  rk_DepartAll = 2;

 PRIVATE VAR
  plnEDate       : DATE;
  plnETime       : TIME;
  plnRepairPeriod: NUMERIC[1];
  SysDTS, BDTS, EDTS : FLOAT;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
#############################################################                                                                             ########## #####
=######===================================================================================================================================================
|########################################################################################################################################################|
|--------------------------------------------------------------------------------------------------------------------------------------------------------|
||.륧||   /   |                                      ஫ ப|             ⥫ ६              ஫ ப|
|----|----------|----|---------|------------------------------------------------------------|------------------------------------------------------------|
}
*)

(*
$P{ Line:
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
@
|####|##########|####|#### ####|############################################################|############################################################|
}
*)

(*
$P{ Dlm:
@
|--------------------------------------------------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ OtherTotals:
?, R, ""
?, R, ""
@
|  拉 #####                                                                                                                                       |
|  ࠡ #####                                                                                                                                       |
}
*)

(*
$P{ SummaryTop:
?, C, ""
?, C, ""
?, C, ""
@
|                                                    |########################|########################|########################|          ⮣         |
|㯯 ப                                        |------------------------|------------------------|------------------------|------------------------|
|                                                    |-              |-              |-              |-              |
}
*)

(*
$P{ SummaryDlm:
@
|----------------------------------------------------|------------------------|------------------------|------------------------|------------------------|
}
*)

(*
$P{ SummaryLine:
?, L, ""
?, R, "0"
?, R, "3."
?, R, "3."
?, R, "0"
?, R, "3."
?, R, "3."
?, R, "0"
?, R, "3."
?, R, "3."
?, R, "0"
?, R, "3."
?, R, "3."
@
|####################################################|#### ######### #########|#### ######### #########|#### ######### #########|#### ######### #########|
}
*)

(*
$P{ Bot:
@
=(c) Polak================================================================================================================================================
}
*)

 PRIVATE PROCEDURE E_GetReportSettings(VAR ReportKindPool: STRING[];
                                       VAR ReportKind    : NUMERIC[0]);
  VAR
   Local                  : PROC;
   E_ReportKind           : NUMERIC[0];
   E_ReportKindPool       : STRING[];
   ChangeDefReportKindPool: SCAL[2];
 BEGIN
  ChangeDefReportKindPool:=0;
  SETEMPTY(E_ReportKindPool, E_ReportKind);
  Local:=PROCREF(E_Rpr.Rpr17_GetAdditionalReportSettings);
  IF ~!Local THEN
   Local(E_ReportKindPool, E_ReportKind, ChangeDefReportKindPool);
  END;
  IF ChangeDefReportKindPool THEN
   ReportKindPool:=E_ReportKindPool;
   ReportKind    :=E_ReportKind;
  ELSE
   ReportKindPool:=defReportKindPool;
   ReportKind    :=rk_CommonAll;
   IF ~!E_ReportKindPool THEN
    ReportKindPool:=ReportKindPool + "|" + E_ReportKindPool;
   END;
   IF ~!E_ReportKind THEN
    ReportKind:=ReportKindAmount + E_ReportKind;
   END;
  END;
 END {E_GetReportSettings};

 PRIVATE PROCEDURE E_IsAcceptableCar(ReportKindPool: STRING[]; ReportKind: NUMERIC[0]): SCAL[2];
  VAR
   Local : PROC;
 BEGIN
  IF defReportKindPool = Str.Slice(ReportKindPool, 0, Str.Length(defReportKindPool)) THEN
   IF    ReportKind = rk_All THEN
    RETURN 1;
   ELSIF ReportKind = rk_CommonAll THEN
    RETURN CarLog.Purpose = L_Car.purp_Common;
   ELSIF ReportKind = rk_DepartAll THEN
    RETURN CarLog.Purpose = L_Car.purp_Depart;
   ELSE
    Local:=PROCREF(E_Rpr.Rpr17_IsAcceptableCar);
    RETURN Local(ReportKind - ReportKindAmount);
   END;
  ELSE
   Local:=PROCREF(E_Rpr.Rpr17_IsAcceptableCar);
   IF !Local THEN
    L_General.SetupRequired();
   END;
   RETURN Local(ReportKind);
  END;
 END {E_IsAcceptableCar};

 PRIVATE PROCEDURE E_GetReportDivisionMarkG(): LIKE(MarkG.MarkG);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.Rpr17_GetReportDivisionMarkG);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN L_Way.GetMarkG_Soft(CarLog.Mark, L_Way.mgt_KIPandKTG);
  END;
 END {E_GetReportDivisionMarkG};

 PRIVATE PROCEDURE E_GetSummaryColumnTitles(VAR SummaryColumnTitles: STRING[][]);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.Rpr17_GetSummaryColumnTitles);
  IF ~!Local THEN
   Local(SummaryColumnTitles);
  ELSE
   SummaryColumnTitles[L_Way.tkfnm_Subsidy] :=L_Str.PoolItem(L_Way.tkfnm_Pool, L_Way.tkfnm_Subsidy);
   SummaryColumnTitles[L_Way.tkfnm_Commerce]:=L_Str.PoolItem(L_Way.tkfnm_Pool, L_Way.tkfnm_Commerce);
   SummaryColumnTitles[L_Way.tkfnm_Other]   :=L_Str.PoolItem(L_Way.tkfnm_Pool, L_Way.tkfnm_Other);
  END;
 END {E_GetSummaryColumnTitles};

 PRIVATE PROCEDURE PutIn_ForPrint(_State     : NUMERIC[0];
                                  IsDelimiter: SCAL[2]);
  VAR
   _ForPr: SCAL[1E4];
   Text  : STRING[];
 BEGIN
  SELECT(ForPr, ForPr);
  WHILE OCCURE(ForPr) & ~!ForPr.BoxNbrs[_State] DO
   NEXT(ForPr);
  END; (* WHILE OCCURE(ForPr) ... *)

  IF IsDelimiter THEN
   Text:=L_Str.Repeat("-", SpcColumnWidth);
  ELSE
   Text:=TmpF.BoxNbr;
   IF ~!TmpF.AddInf THEN
    Text:=Text  +  " " + TmpF.AddInf;
   END;
  END;

  IF ~OCCURE(ForPr) THEN
   DEFAULT(ForPr);
   INSERT(ForPr);
  END;
  ForPr.BoxNbrs[_State]:=Text;
  REPLACE(ForPr);

  IF IsDelimiter THEN
   IF _State = st_woDrv1 THEN
    _ForPr:=ForPr.ForPr;
    SELECT(ForPr, ForPr);
    WHILE OCCURE(ForPr) & ~!ForPr.BoxNbrs[_State] DO
     IF !ForPr.BoxNbrs[st_woDrv2] THEN
      IF ForPr.ForPr = _ForPr THEN
       ForPr.BoxNbrs[st_woDrv2]:=Text;
      ELSE
       ForPr.BoxNbrs[st_woDrv2]:=" ";
      END;
      REPLACE(ForPr);
     END;
     NEXT(ForPr);
    END; (* WHILE OCCURE(ForPr) ... *)
   END;
  END;
 END {PutIn_ForPrint};

 PRIVATE PROCEDURE pr_PrintSummary(Title: STRING[]; _Total, _Ready, _InWork: NUMERIC[0][]);
  VAR
   i,
   Total,
   Ready,
   InWork    : NUMERIC[0];
   KTG, KIP  : NUMERIC[3][MAXOF(tTKindGroup)+1];
   tKIP, tKTG: NUMERIC[3];
 BEGIN
  SETZERO(Total, Ready, InWork);
  SETEMPTY(KTG, KIP, tKTG, tKIP);
  i:=0;
  WHILE i <= HIGH(_Total) DO
   IF _Total[i] = 0 THEN
    SETEMPTY(_Total[i], KTG[i], KIP[i]);
   ELSE
    KTG[i]:=_Ready[i]  / _Total[i];
    KIP[i]:=_InWork[i] / _Total[i];
    INC(Ready,  _Ready[i]);
    INC(InWork, _InWork[i]);
    INC(Total,  _Total[i]);
   END;
   INC(i);
  END;
  IF Total # 0 THEN
   tKTG:=Ready  / Total;
   tKIP:=InWork / Total;
  END;

  MAKEPART(R, SummaryLine, Title, _Total[L_Way.tkfnm_Subsidy],  KTG[L_Way.tkfnm_Subsidy],  KIP[L_Way.tkfnm_Subsidy],
                                  _Total[L_Way.tkfnm_Commerce], KTG[L_Way.tkfnm_Commerce], KIP[L_Way.tkfnm_Commerce],
                                  _Total[L_Way.tkfnm_Other],    KTG[L_Way.tkfnm_Other],    KIP[L_Way.tkfnm_Other],
                                  Total,                        tKTG,                      tKIP);
 END {pr_PrintSummary};

 PRIVATE PROCEDURE IsInWork(): SCAL[2];
 BEGIN
  RETURN (TmpF.State = st_Ordered)  |
         (TmpF.State = st_InWork)   |
         (TmpF.State = st_InPark)   |
         (TmpF.State = st_TimeToGo) |
         (TmpF.State = st_DrvFall);
 END {IsInWork};

 PRIVATE PROCEDURE IsReady(): SCAL[2];
 BEGIN
  RETURN (TmpF.State = st_woDrv1) |
         (TmpF.State = st_woDrv2) |
         IsInWork();
 END {IsReady};

 PRIVATE PROCEDURE AcceptableStateForPrint(_State: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN (_State # st_Ordered) & (_State # st_InWork);
 END {AcceptableStateForPrint};

 PRIVATE PROCEDURE GetRepName(_ReportKind: NUMERIC[0]): STRING[];
 BEGIN
  RETURN "Rp17_" + L_Str.IntStr(_ReportKind);
 END {GetRepName};

 PRIVATE PROCEDURE GetMarkGName(_MarkG: LIKE(MarkG.MarkG)): STRING[];
 BEGIN
  IF ~!_MarkG THEN
   SEARCH(MarkG, MarkG, , _MarkG);
   RETURN MarkG.MarkG + " " + MarkG.Name;
  ELSE
   RETURN "      祭    㯯";
  END;
 END {GetMarkGName};

 PRIVATE PROCEDURE PrintRep(Step          : NUMERIC[0];
                            ReportKindPool: STRING[];
                            ReportKind,
                            RealReportKind: NUMERIC[0];
                            OnDate        : DATE;
                            OnTime        : TIME);
  TYPE
   tTotalArray = NUMERIC[0][MAXOF(tTKindGroup)+1];
  VAR
   i,
   _State             : NUMERIC[0];
   tReady,
   tInWork,
   tTotal             : tTotalArray;
   CarState           : NUMERIC[0][StateAmnt];
   Title,
   BoxNbr_asStr       : STRING[];
   NeedInsDlm,
   FirstwoDrvColumn   : SCAL[2];
   SummaryColumnTitles: STRING[][MAXOF(TKind.FnMode)+1];
 BEGIN
  IF ~DBD.FileExist(ForPr) THEN
   CreateFILE(ForPr, "", "६ 䠩  ", "");
 
   CreateFIELD(ForPr, ForPr,   SCAL[1E4], "", "", "", " ", "");
   CreateFIELD(ForPr, BoxNbrs, STRING[128][StateAmnt], "", "", "", "ࠦ+.", "");
 
   CreateINDEX(ForPr, ForPr, AUTOINCR, "", "", ForPr);
   SetVersionOfFILE(ForPr, 0);
  END;
  L_AFM.AF_CreateTemp("ForPr", "ForPr");

  IF ~DBD.FileExist(Totals) THEN
   CreateFILE(Totals, "", "⮣", "");
 
   CreateFIELD(Totals, MGName, LIKE(MarkG.Name), "", "",  "", " 㯯 ப", "");
   CreateFIELD(Totals, Ready,  tTotalArray,      "", "0", "", "ᥣ ࠢ", "");
   CreateFIELD(Totals, InWork, tTotalArray,      "", "0", "", "ᥣ  ࠡ", "");
   CreateFIELD(Totals, Total,  tTotalArray,      "", "0", "", "ᥣ ", "");
 
   CreateINDEX(Totals, MGName, UNIQUE, "", "", MGName);
   SetVersionOfFILE(Totals, 0);
  END;
  L_AFM.AF_CreateTemp("Totals", "Totals");

  WHILE SELECT(TmpF, GoodCar, 1) DO
   TmpF.GoodCar:=0;
   REPLACE(TmpF);
  END;

  SELECT(TmpF, MarkG);
  WHILE OCCURE(TmpF) DO
   PROMPT("⮢ " + TmpF.BoxNbr + ": ⠯ 1");
   SEARCH(Car, BoxNbr, , TmpF.BoxNbr);
   L_Car.StandOnCarLog(Car.BoxNbr, OnDate);
   CONFORM(CarLog, Mark);
   IF E_IsAcceptableCar(ReportKindPool, RealReportKind) THEN
    TmpF.GoodCar:=1;
    REPLACE(TmpF);
   END;
   NEXT(TmpF);
  END; (* WHILE OCCURE(TmpF) ... *)

  SETZERO(CarState);
  SELECT(TmpF, GoodCar, , 1);
  WHILE OCCURE(TmpF) DO
   NARROWSEL(TmpF, MarkG);
   FirstwoDrvColumn:=1;
   WHILE OCCURE(TmpF) DO
    PROMPT("⮢ " + TmpF.BoxNbr + ": ⠯ 2");
    _State:=TmpF.State;
    IF AcceptableStateForPrint(_State) THEN
     IF _State = st_woDrv1 THEN
      IF ~FirstwoDrvColumn THEN
       _State:=st_woDrv2;
      END;
      FirstwoDrvColumn:=~FirstwoDrvColumn;
     END;

     PutIn_ForPrint(_State, 0);
     NeedInsDlm:=1;
    END;

    INC(CarState[_State]);

    ADD(Totals, MGName, , GetMarkGName(TmpF.MarkG),
        Totals.Ready[TmpF.FnMode],  IsReady(),
        Totals.InWork[TmpF.FnMode], IsInWork(),
        Totals.Total[TmpF.FnMode],  1);

    NEXT(TmpF);
   END; (* WHILE OCCURE(TmpF) ... *)
   IF NEXTINEXTENDEDSEL(TmpF, MarkG) THEN
    _State:=0;
    WHILE _State < StateAmnt DO
     IF AcceptableStateForPrint(_State) & (_State # st_woDrv2) THEN
      PutIn_ForPrint(_State, 1);
     END;
     INC(_State);
    END; (* WHILE _State < StateAmnt...*)
   END;
  END; (* WHILE OCCURE(TmpF) ... *)

  IF Step = 0 THEN
   OPENREP(R, L_General.NameConnection(GetRepName(ReportKind)), Create);
   SetPrintAttr(R, PaperForm,       A4,
                   Orientation,     Landscape,
                   MinLinesPerPage, 1,
                   SpreadLinInPage, 0,
                   TopMargin,       10,
                   BottomMargin,    10);
  ELSE
   FORMFEED(R);
  END;
  MAKEPART(R, Top, GetRepName(RealReportKind),
                   " ﭨ  (" + L_Str.PoolItem(ReportKindPool, RealReportKind) + ")  " + L_DatTim.DateStr(OnDate) + " " + L_DatTim.TimeStr(OnTime));

  MAKEPART(R, Line, CarState[st_InPark],
                    CarState[st_TimeToGo],
                    CarState[st_DrvFall],
                    CarState[st_woDrv1],
                    CarState[st_woDrv2],
                    CarState[st_Repair],
                    CarState[st_LongRepair]);
  MAKEPART(R, Dlm);

  SELECT(ForPr, ForPr);
  WHILE OCCURE(ForPr) DO
   PROMPT(" " + ForPr.ForPr);
   MAKEPART(R, Line, ForPr.BoxNbrs[st_InPark],
                     ForPr.BoxNbrs[st_TimeToGo],
                     ForPr.BoxNbrs[st_DrvFall],
                     ForPr.BoxNbrs[st_woDrv1],
                     ForPr.BoxNbrs[st_woDrv2],
                     ForPr.BoxNbrs[st_Repair],
                     ForPr.BoxNbrs[st_LongRepair]);
   NEXT(ForPr);
  END; (* WHILE OCCURE(ForPr) ... *)

  MAKEPART(R, Dlm);
  MAKEPART(R, OtherTotals, CarState[st_Ordered], CarState[st_InWork]);
  MAKEPART(R, Dlm);

  E_GetSummaryColumnTitles(SummaryColumnTitles);

  MAKEPART(R, SummaryTop, SummaryColumnTitles[L_Way.tkfnm_Subsidy],
                          SummaryColumnTitles[L_Way.tkfnm_Commerce],
                          SummaryColumnTitles[L_Way.tkfnm_Other]);

  MAKEPART(R, SummaryDlm);

  SETZERO(tReady, tInWork, tTotal);
  SELECT(Totals, MGName);
  WHILE OCCURE(Totals) DO
   pr_PrintSummary(Totals.MGName, Totals.Total, Totals.Ready, Totals.InWork);
   i:=0;
   WHILE i <= HIGH(Totals.Total) DO
    INC(tTotal[i],  Totals.Total[i]);
    INC(tReady[i],  Totals.Ready[i]);
    INC(tInWork[i], Totals.InWork[i]);
    INC(i);
   END;
   NEXT(Totals);
  END; (* WHILE OCCURE(Totals) ... *)

  MAKEPART(R, SummaryDlm);
  pr_PrintSummary("⮣ ⥫", tTotal, tReady, tInWork);

  MAKEPART(R, Bot);

  L_AFM.AF_PurgeTemp("Totals");
  L_AFM.AF_PurgeTemp("ForPr");
 END {PrintRep};

 PRIVATE PROCEDURE PutInIndex(_FnMode: LIKE(TKind.FnMode);
                              _MarkG : LIKE(MarkG.MarkG);
                              _State : NUMERIC[0];
                              _AddInf: STRING[]);
 BEGIN
  DEFAULT(TmpF);
  TmpF.MarkG :=_MarkG;
  TmpF.FnMode:=_FnMode;
  TmpF.State :=_State;
  TmpF.BoxNbr:=Car.BoxNbr;
  TmpF.AddInf:=_AddInf;
  INSERT(TmpF);
 END {PutInIndex};

 PRIVATE PROCEDURE GetRprTFailReasonPro(): STRING[];
 BEGIN
  SELECT(RprT, RprS, , RprS.RprS);
  WHILE OCCURE(RprT) DO
   IF SELECT(RprPro, RprS, RprT.RprS, RprT.RprT, "", P_Rpr.P_RprTFailReason) THEN
    RETURN " (" + RprPro.Value + ")";
   END;
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT) ... *)
  RETURN "";
 END {GetRprTFailReasonPro};

 PRIVATE PROCEDURE GetShortRprSDescr(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="";
  IF OCCURE(RprS) THEN
   IF L_Rpr.IsFailureOutput() THEN
    INC(Result, "!! ");
   END;
   INC(Result, P_Rpr.GetShortRprSDescr(RprS.RprS));
  END;
  RETURN Result;
 END {GetShortRprSDescr};

 PRIVATE PROCEDURE GetExpirationValue(): STRING[];
 BEGIN
  RETURN "!" + FLDTOSTR(Math.Abs(L_DatTim.GetVARIANTDATEPeriod_Hour(SysDTS, EDTS)), "1.", 6);
 END {GetExpirationValue};

 PRIVATE PROCEDURE GetplnRepairPeriodAsStr(): STRING[];
 BEGIN
  RETURN FLDTOSTR(plnRepairPeriod, "1.", 6);
 END {GetplnRepairPeriodAsStr};

 PRIVATE PROCEDURE GetLongRepairDescr(IsPutOffRprS: SCAL[2]): STRING[];
  VAR
   Prefix,
   ExpirationValue,
   plnRepairPeriodAsStr: STRING[];
   BDate               : DATE;
 BEGIN
  SETEMPTY(BDate);
  IF ~!BDTS THEN
   UnPkVARIANTDATE(BDTS, BDate);
  END;
  plnRepairPeriodAsStr:=GetplnRepairPeriodAsStr();
  IF IsPutOffRprS THEN
   RETURN Str.Align(FLDTOSTR(BDate, "D.N") + " " + "" + " " + GetShortRprSDescr() + GetRprTFailReasonPro(), SpcColumnWidth-(4+1), LEFT);
  ELSE
   IF (RprS.Status = L_Rpr.ms_WaitTechAid) | (RprS.Status = L_Rpr.ms_WaitRetriever) THEN
    Prefix:=L_Str.PoolItem(L_Rpr.GetRprSStatus_Pool(0), RprS.Status) + " ";
   ELSE
    SETEMPTY(Prefix);
   END;
   IF !EDTS | (EDTS >= SysDTS) THEN
    RETURN Str.Align(FLDTOSTR(BDate, "D.N") + " " + Prefix + GetShortRprSDescr(), SpcColumnWidth-(4+1)-(1+Str.Length(plnRepairPeriodAsStr))-(1+5+2+5), LEFT) + " " + plnRepairPeriodAsStr + " " + FLDTOSTR(plnEDate, "D.N") + "  " + FLDTOSTR(plnETime, "H:M");
   ELSE
    ExpirationValue:=GetExpirationValue();
    RETURN Str.Align(FLDTOSTR(BDate, "D.N") + " " + Prefix + GetShortRprSDescr(), SpcColumnWidth-(4+1)-(1+Str.Length(plnRepairPeriodAsStr))-(1+3+2+Str.Length(ExpirationValue)), LEFT) + " " + plnRepairPeriodAsStr + "    " + "  " + ExpirationValue;
   END;
  END;
 END {GetLongRepairDescr};

 PRIVATE PROCEDURE GetMinPlnBDTS(): FLOAT;
  VAR
   RprTBDTS, minRprTBDTS: FLOAT;
 BEGIN
  SETEMPTY(minRprTBDTS);
  IF SELECT(RprT, RprS, RprS.RprS) THEN
   WHILE OCCURE(RprT) DO
    RprTBDTS:=L_DatTim.GetVARIANTDATE(RprT.JobBDate, RprT.JobBTime, 00);
    IF !minRprTBDTS THEN
     minRprTBDTS:=RprTBDTS;
    ELSE
     minRprTBDTS:=Math.Min(minRprTBDTS, RprTBDTS);
    END;
    NEXT(RprT);
   END; (* WHILE OCCURE(RprT) ... *)
  END;
  RETURN minRprTBDTS;
 END {GetMinPlnBDTS};

 PRIVATE PROCEDURE GetRprSDTAsStr(Force: SCAL[2]): STRING[];
  VAR
   RprSBDTS: FLOAT;
 BEGIN
  RprSBDTS:=L_DatTim.GetVARIANTDATE(RprS.OrdDate, RprS.OrdTime, 00);
  IF Force | (RprSBDTS # BDTS) THEN
   RETURN " (" + FLDTOSTR(RprS.OrdDate, "D.N") + " " + FLDTOSTR(RprS.OrdTime, "H:M") + ")";
  ELSE
   RETURN ""
  END;
 END {GetRprSDTAsStr};

 PRIVATE PROCEDURE GetUsualRepairDescription(Prefix, ETimeAsStr: STRING[]): STRING[];
  VAR
   plnRepairPeriodAsStr,
   RprSBDTAsStr,
   minBTimeAsStr: STRING[];
 BEGIN
  ETimeAsStr:=Str.Align(ETimeAsStr, 7, RIGHT);
  RprSBDTAsStr:=GetRprSDTAsStr(0);
  IF ~!BDTS THEN
   minBTimeAsStr:=L_DatTim.TimeStr(L_DatTim.GetTimeOfVARIANTDATE(BDTS))+ " ";
  ELSE
   minBTimeAsStr:="      ";
  END;
  IF (RprS.Status = L_Rpr.ms_WaitTechAid) | (RprS.Status = L_Rpr.ms_WaitRetriever) THEN
   Prefix:=L_Str.AddStrDlm(Prefix, " ") + L_Str.PoolItem(L_Rpr.GetRprSStatus_Pool(0), RprS.Status);
  END;

  plnRepairPeriodAsStr:=GetplnRepairPeriodAsStr();
  RETURN Str.Align(minBTimeAsStr + Prefix + GetShortRprSDescr(), SpcColumnWidth-(4+1)-(Str.Length(plnRepairPeriodAsStr)+1)-Str.Length(ETimeAsStr)-Str.Length(RprSBDTAsStr), LEFT) + RprSBDTAsStr + " " + plnRepairPeriodAsStr + ETimeAsStr;
 END {GetUsualRepairDescription};

 PRIVATE PROCEDURE IsLongRepair(): SCAL[2];
  VAR
   DeadLineDTS: FLOAT;
 BEGIN
  DeadLineDTS:=L_DatTim.GetVARIANTDATE(SYSDATE()-1, 19:00, 00);
  RETURN (~!BDTS & (BDTS < DeadLineDTS)) | (~!plnEDate & (plnEDate # SYSDATE()));
 END {IsLongRepair};

 PRIVATE PROCEDURE ChooseReportKind(VAR ReportKindPool : STRING[];
                                    VAR ReportKind     : NUMERIC[0];
                                    VAR RealReportKinds: NUMERIC[0][]);
  VAR
   Local: PROC;
 BEGIN
  E_GetReportSettings(ReportKindPool, ReportKind);
  STDFORM(L_StdFrm.sf_Choice("%#########% %########################################%",
                             "%< :>T" +
                             "%L<" + ReportKindPool + ">I"),
          "  ﭨ  ", , 1, ReportKind);
  SETEMPTY(RealReportKinds);
  Local:=PROCREF(E_Rpr.Rpr17_GetRealReportKinds);
  IF !Local THEN
   RealReportKinds[0]:=ReportKind;
  ELSE
   Local(ReportKind, RealReportKinds);
  END;
 END {ChooseReportKind};

 PRIVATE PROCEDURE Gather(OnDate: DATE; OnTime: TIME);
  VAR
   _BegTime           : TIME;
   _State             : SCAL[1E2];
   IsFirst_woDrvColumn: SCAL[2];
   DispDate           : DATE;
   _MarkG             : LIKE(MarkG.MarkG);
   _FnMode            : LIKE(TKind.FnMode);
   rpr17_State        : NUMERIC[0];
   AddInf             : STRING[];
 BEGIN
  CreateFILE(TmpF, "", "६ 䠩", "");

  CreateFIELD(TmpF, GoodCar, SCAL[2],            "", "0", "", "㯯 ப", "");
  CreateFIELD(TmpF, MarkG,   LIKE(MarkG.MarkG),  "", "", "", "㯯 ப", "");
  CreateFIELD(TmpF, FnMode,  LIKE(TKind.FnMode), "", "",  "", " 䨭஢", "");
  CreateFIELD(TmpF, BoxNbr,  LIKE(Car.BoxNbr),   "", "", "", "ࠦ", "");
  CreateFIELD(TmpF, State,   NUMERIC[0],         "", "", "", "", "");
  CreateFIELD(TmpF, AddInf,  STRING[64],         "", "", "", "⥫쭠 ଠ (-, ६ 륧   室)", "");

  CreateINDEX(TmpF, GoodCar, PLURAL, "", "", GoodCar, MarkG, BoxNbr);
  CreateINDEX(TmpF, MarkG,   PLURAL, "", "", MarkG, BoxNbr);

  SetVersionOfFILE(TmpF, 0);
  L_AFM.AF_CreateTemp("TmpF", "TmpF");

  SysDTS  :=L_DatTim.GetSysVARIANTDATE();
  DispDate:=L_BegRWS.DspDate(OnDate, OnTime);
  IsFirst_woDrvColumn:=1;
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT("  " + Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) &
      L_Car.CarIsInOperation(Car.BoxNbr, OnDate) THEN
    IF SELECT(rtCar, DDBoxNbr, DispDate, Car.BoxNbr) THEN
     L_RT.rtCar_StandOnActual(SysDTS);
     IF ~!rtCar.XDocId THEN
      L_XDoc.PositionOnXDoc(rtCar.XDocId);
     END;
     _State:=L_RT.GetrtCarState(SysDTS);
    ELSE
     IF CarLog.InBeg = L_Car.inBeg_Required THEN
      _State:=L_RT.rtc_st_woDriver;
     ELSE
      _State:=L_RT.rtc_st_woRWayS;
     END;
    END;

    IF (_State = L_RT.rtc_st_BreakageOnLine) |
       (_State = L_RT.rtc_st_LongRepair)     |
       (_State = L_RT.rtc_st_Repair)         |
       (_State = L_RT.rtc_st_TO2) THEN
     SETEMPTY(plnEDate, plnETime, plnRepairPeriod, BDTS, EDTS);
     IF    (L_XDoc.ExtractXDocType(rtCar.XDocId) = L_XDoc.xdt_RprS) THEN
      BDTS:=GetMinPlnBDTS();
      EDTS:=L_Rpr.GetMaxPlnEDTS();
      IF ~!EDTS THEN
       UnPkVARIANTDATE(EDTS, plnEDate, plnETime);
      END;
      IF ~!BDTS & ~!EDTS THEN
       plnRepairPeriod:=L_DatTim.GetVARIANTDATEPeriod_Hour(BDTS, EDTS);
      END;
     ELSIF (L_XDoc.ExtractXDocType(rtCar.XDocId) = L_XDoc.xdt_RWayS) THEN
      BDTS:=L_DatTim.GetVARIANTDATE(RWayS.Date, RWayS.StartTim, 00);
     ELSE
      L_General.CallUs(0);
     END;
    END;

    _MarkG:=E_GetReportDivisionMarkG();
    IF ~!CarLog.TKind THEN
     CONFORM(CarLog, TKind);
     _FnMode:=TKind.FnMode;
    ELSE
     _FnMode:=L_Way.tkfnm_Other;
    END;
    SETEMPTY(rpr17_State, AddInf);

    IF    (_State = L_RT.rtc_st_DepartureDelay) | (_State = L_RT.rtc_st_GivenDelay) THEN
     rpr17_State:=st_DrvFall;
    ELSIF (_State = L_RT.rtc_st_Ordered) | (_State = L_RT.rtc_st_GivenCountdown) THEN
     IF ~!rtCar.BegDTS THEN
      IF _State = L_RT.rtc_st_GivenCountdown THEN
       UnPkVARIANTDATE(rtCar.BegDTS, , _BegTime);
       rpr17_State:=st_TimeToGo;
       AddInf     :=L_DatTim.TimeStr(_BegTime);
      ELSE
       rpr17_State:=st_Ordered;
      END;
     ELSE
      rpr17_State:=st_TimeToGo;
     END;
    ELSIF _State = L_RT.rtc_st_BreakageOnLine THEN
     rpr17_State:=st_Repair;
     AddInf     :=GetUsualRepairDescription(" ", L_DatTim.TimeStr(plnETime));
    ELSIF (_State = L_RT.rtc_st_Work)              | (_State = L_RT.rtc_st_ReturnDelay) |
          (_State = L_RT.rtc_st_LongTimeAgoReturn) | (_State = L_RT.rtc_st_woRWayS)     |
          (_State = L_RT.rtc_st_Reserve) THEN
     rpr17_State:=st_InWork;
    ELSIF (_State = L_RT.rtc_st_InPark) THEN
     rpr17_State:=st_InPark;
    ELSIF (_State = L_RT.rtc_st_EarlyReturn) THEN
     IF RWayS.Status < L_Way.rwsStat_Taken THEN
      rpr17_State:=st_InPark;
     ELSE
      rpr17_State:=st_woDrv1;
     END;
    ELSIF _State = L_RT.rtc_st_LongRepair THEN
     rpr17_State:=st_LongRepair;
     AddInf     :=GetLongRepairDescr(1);
    ELSIF (_State = L_RT.rtc_st_Repair) | (_State = L_RT.rtc_st_TO2) THEN
     IF    (L_XDoc.ExtractXDocType(rtCar.XDocId) = L_XDoc.xdt_RprS) THEN
      IF    ~IsLongRepair() THEN
       IF !EDTS | (EDTS >= SysDTS) THEN
        rpr17_State:=st_Repair;
        AddInf     :=GetUsualRepairDescription("", L_DatTim.TimeStr(plnETime));
       ELSE
        rpr17_State:=st_Repair;
        AddInf     :=GetUsualRepairDescription("", GetExpirationValue());
       END;
      ELSE
       rpr17_State:=st_LongRepair;
       AddInf     :=GetLongRepairDescr(0);
      END;
     ELSE
      rpr17_State:=st_Repair;
      AddInf     :=Str.Align(L_DatTim.TimeStr(L_DatTim.GetTimeOfVARIANTDATE(BDTS))+ " " + "뤠   ६", SpcColumnWidth, LEFT);
     END;
    ELSIF _State = L_RT.rtc_st_WaitRepair THEN
     rpr17_State:=st_Repair;
     IF L_Rpr.HasOpenTask_TO2(RprS.RprS) THEN
      AddInf     :=Str.Align("       -2 " + Str.Align(GetShortRprSDescr(), 12, LEFT) + GetRprSDTAsStr(1), SpcColumnWidth, LEFT);
     ELSE
      AddInf     :=Str.Align("       ଭ " + Str.Align(GetShortRprSDescr(), 12, LEFT) + GetRprSDTAsStr(1), SpcColumnWidth, LEFT);
     END;
    ELSIF _State = L_RT.rtc_st_woDriver THEN
     rpr17_State:=st_woDrv1;
    ELSE
     L_General.CallUs(0);
    END;
    IF ~!rpr17_State THEN
     PutInIndex(_FnMode, _MarkG, rpr17_State, AddInf);
    END;
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {Gather};

 PUBLIC PROCEDURE MakeRep();
  VAR
   ReportKindPool : STRING[];
   i,
   ReportKind     : NUMERIC[0];
   RealReportKinds: NUMERIC[0][5];
   OnDate         : DATE;
   OnTime         : TIME;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  OnDate:=SYSDATE();
  OnTime:=SYSTIME();
  L_RT.rtc_Init();
  ChooseReportKind(ReportKindPool, ReportKind, RealReportKinds);
  Gather(OnDate, OnTime);
  i:=0;
  WHILE ~!RealReportKinds[i] DO
   PrintRep(i, ReportKindPool, ReportKind, RealReportKinds[i], OnDate, OnTime);
   INC(i);
  END;
  CLOSEREP(R);
  LIKEMENU(Survey, "");
 END {MakeRep};

END.
