(*
%Copyright   (c) Polak IT
%Author      02.11.2006 12:27:54 POLAK\GAV
%Purpose     LDA
%Type        report
%Specific    AP
%Modified    10.04.2012 12:04:55 ROBOT by POLAK\LDA
%Environment  ⫮ ࠢ⥩
*)

 IMPORT L_Rpr, L_Car, L_Basis, L_General, FIO, L_Str, L_CUC;

 PRIVATE PROCEDURE Gather(D: DATE);
 BEGIN
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(Car.BoxNbr);
   IF L_Car.CarIsInOperation(Car.BoxNbr, D) THEN
    L_Rpr.lpoda_GatherCar(Car.CUCopy, 0, 1);
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {Gather};

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, ".");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "਩");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE MakeLine(F: STRING[]);
 BEGIN
  SEARCH(RprS, RprS, , lpoda.RprS);
  CONFORM(RprS, CUCopy);
  L_CUC.AccessOrigin();
  L_Car.StandOnCarLog(Car.BoxNbr, RprS.OrdDate);

  SEARCH(RprDA, RprS, , lpoda.RprS, lpoda.RprDfApr);
  CONFORM(lpoda, RprDfApr);
  CONFORM(RprDfApr, CarBlock);

  CONFORM(CarLog, Mark);
  L_Basis.wb_WrScl(F, RprS.RprS);
  L_Basis.wb_WrDat(F, RprS.OrdDate);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|", RprS.Closed));
  L_Basis.wb_WrScl(F, Car.BoxNbr);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, CarBlock.CarBlock);
  L_Basis.wb_WrStr(F, CarBlock.Name);
  L_Basis.wb_WrScl(F, RprDfApr.RprDfApr);
  L_Basis.wb_WrStr(F, RprDfApr.Name);
  L_Basis.wb_WrStr(F, RprDA.Comment);
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PRIVATE PROCEDURE Make(D: DATE);
 BEGIN
  L_Rpr.lpoda_Create();
  Gather(D);
  FIO.Open(F, L_General.NameConnection("Rpr22"), "REP", Create);
  MakeTop("F");
  SELECT(lpoda, RprDfApr);
  WHILE OCCURE(lpoda) DO
   MakeLine("F");
   NEXT(lpoda);
  END; (* WHILE OCCURE(lpodf) ... *)
  L_Rpr.lpoda_Purge();
  FIO.Close(F);
 END {Make};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
 IF MODE = 100 THEN
  Make(SYSDATE());
 ELSE
  L_General.BadMode(MODE);
 END;
END.
