(*
%Copyright   (c) Polak IT
%Author      06.03.2013 18:02:03 POLAK\San
%Purpose      室  ࠧ१ 
%Type        report
%Specific    AP
%Modified    20.06.2014 11:37:07 POLAK\San
%Environment
*)

 IMPORT L_General, Memo, L_Rpr, L_MathR, L_DatTim, P_MarkG, L_Car, L_AFM, L_Env, L_bp, L_Basis, FIO,
        L_Str, L_Way, L_OwnData, L_Pmnt;

 PRIVATE PROCEDURE GetHourlyPay(D: DATE): NUMERIC[2];
 BEGIN
  IF L_General.GetAPSiteNumber() = 84 THEN
   IF    D >= 01\06\2014 THEN RETURN 74.18 * 2.75;
   ELSIF D >= 01\10\2013 THEN RETURN 59.32 * 3.44;
   ELSIF D >= 01\03\2013 THEN RETURN 57.79 * 3.44;
   ELSE                       RETURN 57.79 * 3.48;
   END;
  ELSE
   RETURN 0;
  END;
 END {GetHourlyPay};

 PRIVATE PROCEDURE MakeTemporaryFile();
 BEGIN
  L_AFM.MakeMultipleIndex("Rpr30", "CUCopy  : LIKE(CUCopy.CUCopy);"+
                                   "Date    : DATE;"+
                                   "RprS    : LIKE(RprS.RprS);"+
                                   "RunVal  : NUMERIC[2];"+
                                   "MathPlan: NUMERIC[2];"+
                                   "MathFact: NUMERIC[2];"+
                                   "TimePlan: NUMERIC[2];"+
                                   "TimeFact: NUMERIC[2];"+
                                   "wError  : SCAL[2]",
                          "CUCopy: CUCopy, Date, RprS; RprS: RprS");
 END {MakeTemporaryFile};

 PRIVATE PROCEDURE CalcPlan(trgBoxNbr: LIKE(Car.BoxNbr); fr, ut: DATE);
  VAR
   curHourlyPay: NUMERIC[2];
   curRunLim,
   curRunVal   : NUMERIC[3];
   curMathExp,
   curTimeExp  : NUMERIC[2];
   ExitLoop    : SCAL[2];
   cntrlDate   : DATE;
 BEGIN
  APP.Get().NewPrompt("  室");
  SEARCH(Car, BoxNbr, , trgBoxNbr);
  curHourlyPay:=GetHourlyPay(fr);
  curRunLim:=MINOF(curRunLim);
  SETEMPTY(curMathExp, curTimeExp);
  curRunVal:=0;
  SELECT(CarRun, BoxNbr, , trgBoxNbr);
  SRCINSEL(CarRun, GE, , fr);
  LOOP
   ExitLoop:=~OCCURE(CarRun) | (CarRun.Date > ut);
   IF ExitLoop | (CarRun.TotRun > curRunLim) | (curHourlyPay # GetHourlyPay(CarRun.Date)) THEN
    IF curRunVal > 0 THEN
     IF ExitLoop THEN
      cntrlDate:=ut+1;
     ELSE
      cntrlDate:=CarRun.Date;
     END;
     curMathExp:=curMathExp                * (curRunVal/1000);
     curTimeExp:=curTimeExp * curHourlyPay * (curRunVal/1000);
     ADD(Rpr30, CUCopy, , Car.CUCopy, cntrlDate, EMPTYOF(RprS.RprS),
         Rpr30.RunVal,   curRunVal,
         Rpr30.MathPlan, curMathExp,
         Rpr30.TimePlan, curTimeExp,
         Rpr30.MathFact, 0,
         Rpr30.TimeFact, 0);
    END;
    IF ExitLoop THEN
     EXIT;
    END;
    curRunVal:=0;
    curHourlyPay:=GetHourlyPay(CarRun.Date);
    IF CarRun.Date >= 01\01\2013 THEN
     P_MarkG.Car_Get_NormExpTR_TO(trgBoxNbr, CarRun.Date, CarRun.TotRun, curRunLim, curMathExp, curTimeExp);
    ELSE
     SETZERO(curRunLim, curMathExp, curTimeExp)
    END;
   END;
   PROMPT(L_DatTim.DateStr(CarRun.Date));
   INC(curRunVal, CarRun.Run);
   NEXT(CarRun);
  END; (* LOOP *)
 END {CalcPlan};

(*
$P{ pr_MathExp:
@
|------------------------------------------------------------------------------------------------------------|
|ᯮ짮 ਠ 業                                    |      ⢮|             㬬|
|------------------------------------------------------------------------|----------------|------------------|
}
*)

(*
$P{ pr_Math:
Math.Math, L, ""
Math.Name, L, ""
MMode.Sign, L, ""
?, R, ""
?, R, "2-"
@
|##### ############################################################## ###|################|##################|
}
*)

(*
$P{ pr_TotExp:
?, L, ""
?, R, ""
?, R, "2-"
@
|------------------------------------------------------------------------|----------------|------------------|
|########################################################################|################|##################|
}
*)

(*
$P{ pr_TimeExp:
@
|------------------------------------------------------------------------|----------------|------------------|
|믮 ࠡ                                                      |      ମᮢ|             㬬|
|------------------------------------------------------------------------|----------------|------------------|
}
*)

(*
$P{ pr_Job:
RprJob.RprJob, L, ""
RprJob.Name,   L, ""
L_Str.PoolItem(L_Rpr.GetRprJobType_Pool(1), RprJob.Type), L, ""
?, R, "3."
?, R, "2-"
@
|##### ############################################################## ###|################|##################|
}
*)


 PRIVATE PROCEDURE CalcFact_SingleRprS(wProtocol: SCAL[2]);
  VAR
   curHourlyPay: NUMERIC[2];
   curMathExp,
   curTimeExp  : NUMERIC[2];
   curTime,
   curTotTime  : NUMERIC[3];
   curPrice    : FLOAT;
   wError      : NUMERIC[0];
 BEGIN
  curMathExp:=0;
  TRY [ABORT_AFTER(AA_ON)]
   wError:=0;
   L_Rpr.intPrepareMathMovementByRprS(RprS.RprS, 0);
   SELECT(MathMvmnt, Storage);
   IF wProtocol THEN
    MAKEPART(R, pr_MathExp);
   END; (* IF wProtocol *)
   WHILE OCCURE(MathMvmnt) DO
    NARROWSEL(MathMvmnt, Storage);
    SEARCH(Storage, Storage, , MathMvmnt.Storage);
    WHILE OCCURE(MathMvmnt) DO
     IF MathMvmnt.Crd_WO # 0 THEN
      TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
       curPrice:=L_MathR.GetANYMathPrice(RprS.EDate, MathMvmnt.Math, Storage.MyFirm, L_MathR.MMode2PriceGrp(RprS.EDate, MathMvmnt.Math, MathMvmnt.MMode));
       INC(curMathExp, MathMvmnt.Crd_WO*curPrice);
       IF wProtocol THEN
        SEARCH(Math, Math, , MathMvmnt.Math);
        SEARCH(MMode, MMode, , MathMvmnt.MMode);
        MAKEPART(R, pr_Math, L_MathR.DefaultFormatCir(Math.Math, MathMvmnt.Crd_WO), MathMvmnt.Crd_WO*curPrice);
       END; (* IF wProtocol *)
      EXCEPT
      ON Exc: Exc_Raise DO
       INC(wError);
      END;
     END; (* IF MathMvmnt.Crd_WO # 0 *)
     NEXT(MathMvmnt);
    END; (* WHILE OCCURE(MathMvmnt) *)
    NEXTINEXTENDEDSEL(MathMvmnt, Storage);
   END; (* WHILE OCCURE(MathMvmnt) *)
  EXCEPT
  FINALLY
   L_Rpr.PurgeMathMvmnt();
  END; (* TRY *)
  CALL(Rpr02.GetRprSBasTime(curTotTime));
  curHourlyPay:=GetHourlyPay(RprS.EDate);
  curTimeExp:=curTotTime * curHourlyPay;
  IF wProtocol THEN
   MAKEPART(R, pr_TotExp,  "⮣  ", "", curMathExp);
   MAKEPART(R, pr_TimeExp);
   SELECT(RprJ, RprS, , RprS.RprS);
   WHILE OCCURE(RprJ) DO
    CONFORM(RprJ, RprJob);
    curTime:=RprJ.BaseTime * RprJ.ComplCfc * RprJ.Quantity;
    MAKEPART(R, pr_Job, curTime, curTime * curHourlyPay);
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
   MAKEPART(R, pr_TotExp,  "⮣  㤮⠬", FLDTOSTR(curTotTime, "3."), curTimeExp);
   MAKEPART(R, pr_TotExp,  "ᥣ", "", curMathExp + curTimeExp);
  ELSE
   ADD(Rpr30, CUCopy, , RprS.CUCopy, RprS.EDate, RprS.RprS,
       Rpr30.MathFact, curMathExp,
       Rpr30.TimeFact, curTimeExp,
       Rpr30.RunVal,   0,
       Rpr30.MathPlan, 0,
       Rpr30.TimePlan, 0);
   IF wError THEN
    Rpr30.wError:=1;
    REPLACE(Rpr30);
   END;
  END;
 END {CalcFact_SingleRprS};

 PRIVATE PROCEDURE CUCopy_CalcFact(trgCUCopy: LIKE(CUCopy.CUCopy); fr, ut: DATE);
 BEGIN
  APP.Get().NewPrompt(" 䠪᪨ 室");
  SELECT(RprS, CUCopy, , trgCUCopy);
  SRCINSEL(RprS, LE, , ut);
  LOOP
   IF ~OCCURE(RprS) THEN
    EXIT;
   ELSIF RprS.EDate >= fr THEN
    PROMPT(L_DatTim.DateStr(RprS.OrdDate) + " " + RprS.RprS);
    IF RprS.Status = L_Rpr.ms_Done THEN
     CalcFact_SingleRprS(0);
    END;
   ELSIF !RprS.Parent THEN
    EXIT;
   END;
   PREV(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
 END {CUCopy_CalcFact};

 PRIVATE PROCEDURE CalcFact(trgBoxNbr: LIKE(Car.BoxNbr); fr, ut: DATE);
 BEGIN
  SEARCH(Car, BoxNbr, , trgBoxNbr);
  CUCopy_CalcFact(Car.CUCopy, fr, ut);
 END {CalcFact};

 PUBLIC PROCEDURE MakeProtocol_SingleRprS();
 BEGIN
  CalcFact_SingleRprS(1);
 END {MakeProtocol_SingleRprS};

 PRIVATE PROCEDURE Rpr30_MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "㯯_ப");
  L_Basis.wb_WrInQM(F, "㯯_ப");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "騩஡");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "_");
  L_Basis.wb_WrInQM(F, "_");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "_");
  L_Basis.wb_WrInQM(F, "_");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_TermLine(F);
 END {Rpr30_MakeHeader};

 PRIVATE PROCEDURE Rpr30_MakeLine(F: STRING[]);
 BEGIN
  L_Basis.wb_WrScl(F, CarLog.BoxNbr);
  L_Basis.wb_WrScl(F, Column.Column);
  L_Basis.wb_WrStr(F, Column.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Car.purp_Pool, CarLog.Purpose));
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, MarkG.MarkG);
  L_Basis.wb_WrStr(F, MarkG.Name);
  L_Basis.wb_WrDat(F, Rpr30.Date);
  L_Basis.wb_WrNum(F, L_Car.GetGlobalRun(CarLog.BoxNbr, Rpr30.Date), 2);
  L_Basis.wb_WrNum(F, Rpr30.RunVal, 2);
  L_Basis.wb_WrNum(F, Rpr30.MathPlan, 2);
  L_Basis.wb_WrNum(F, Rpr30.TimePlan, 2);
  L_Basis.wb_WrNum(F, Rpr30.MathPlan+Rpr30.TimePlan, 2);
  L_Basis.wb_WrScl(F, Rpr30.RprS);
  L_Basis.wb_WrNum(F, Rpr30.MathFact, 2);
  L_Basis.wb_WrNum(F, Rpr30.TimeFact, 2);
  L_Basis.wb_WrNum(F, Rpr30.MathFact+Rpr30.TimeFact, 2);
  L_Basis.wb_TermLine(F);
 END {Rpr30_MakeLine};

 PUBLIC PROCEDURE Rpr30();
  CONST
   bpId="Rpr30";
 BEGIN
  L_bp.Begin(bpId, " 室    ", L_bp.t_Basis, L_General.tc_inIntvl);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  MakeTemporaryFile();
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(" " + Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) & (Car.EndDate >= Memo.ud_fr()) THEN
    TRY [RESTORE_CURSORS(RC_ON)]
     CalcPlan(Car.BoxNbr, Memo.ud_fr(), Memo.ud_ut());
     CalcFact(Car.BoxNbr, Memo.ud_fr(), Memo.ud_ut());
    EXCEPT
    END;
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  Rpr30_MakeHeader("R");
  SELECT(Rpr30, CUCopy);
  WHILE OCCURE(Rpr30) DO
   PROMPT("⮢  " + Rpr30.CUCopy);
   SEARCH(Car, CUCopy, , Rpr30.CUCopy);
   L_Car.StandOnCarLog(Car.BoxNbr, Rpr30.Date);
   CONFORM(CarLog, Column);
   CONFORM(CarLog, Mark);
   SEARCH(MarkG, MarkG, , L_Way.GetMarkG(Mark.Mark, L_Way.mgt_CostAccounting));
   Rpr30_MakeLine("R");
   NEXT(Rpr30);
  END; (* WHILE OCCURE(Rpr30) ... *)
  FIO.Close(R);
  L_bp.End();
 END {Rpr30};

(*
$P{ Rpr31_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
CarLog.BoxNbr, L, ""
CarLog.StateNbr, L, ""
Mark.Name, L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|室      ਮ  ##########  ##########.  #### ########## ################################|
|------------------------------------------------------------------------------------------------------------|
|                                                                                                     |
|------------------------------------------------------------------------------------------------------------|
|஫쭠              |         ஡|  㤮 ()|  ਠ ()|         ᥣ ()|
|-----------------------------|---------------|--------------------|--------------------|--------------------|
}
*)

(*
$P{ Rpr31_LP:
Rpr30.Date, L, "D.N.y"
Rpr30.RunVal, R, ",2."
Rpr30.TimePlan, R, ",2-"
Rpr30.MathPlan, R, ",2-"
Rpr30.TimePlan + Rpr30.MathPlan, R, ",2-"
@
|#############################|###############|####################|####################|####################|
}
*)

(*
$P{ Rpr31_TF:
@
|------------------------------------------------------------------------------------------------------------|
|᪨                                                                                                  |
|------------------------------------------------------------------------------------------------------------|
| 砫  砭      |            |  㤮 ()|  ਠ ()|         ᥣ ()|
|-----------------------------|---------------|--------------------|--------------------|--------------------|
}
*)

(*
$P{ Rpr31_LF:
RprS.OrdDate, L, "D.N.y"
RprS.EDate, L, "D.N.y"
Rpr30.RprS, R, ""
Rpr30.TimeFact, R, ",2-"
Rpr30.MathFact, R, ",2-"
Rpr30.TimeFact + Rpr30.MathFact, R, ",2-"
@
|########## ##########        |###############|####################|####################|####################|
}
*)

(*
$P{ Rpr31_Total:
?, L, ""
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
@
|---------------------------------------------|--------------------|--------------------|--------------------|
|############################################ |####################|####################|####################|
}
*)

(*
$P{ Rpr31_Bot:
@
=(c) Polak====================================================================================================
}
*)


 PUBLIC PROCEDURE Rpr31();
  CONST
   RepId = "Rpr31";
  VAR
   totTimePlan,
   totMathPlan,
   totTimeFact,
   totMathFact : NUMERIC[2];
   fr, ut      : DATE;
 BEGIN
  ACCESS(Car);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  fr:=Memo.ud_fr();
  ut:=Memo.ud_ut();
  MakeTemporaryFile();
  TRY [RESTORE_CURSORS(RC_ON)]
   CalcPlan(Car.BoxNbr, fr, ut);
   CalcFact(Car.BoxNbr, fr, ut);
  EXCEPT
  END;
  OPENREP(R, L_General.NameConnection(RepId), Create);
  L_Car.StandOnCarLog(Car.BoxNbr, Memo.ud_ut());
  CONFORM(CarLog, Mark);
  MAKEPART(R, Rpr31_Top, RepId, fr, ut);
  SETZERO(totTimePlan, totMathPlan, totTimeFact, totMathFact);
  SELECT(Rpr30, CUCopy);
  WHILE OCCURE(Rpr30) DO
   IF (Rpr30.TimePlan # 0) | (Rpr30.MathPlan # 0) THEN
    MAKEPART(R, Rpr31_LP);
    INC(totTimePlan, Rpr30.TimePlan);
    INC(totMathPlan, Rpr30.MathPlan);
   END;
   NEXT(Rpr30);
  END; (* WHILE OCCURE(Rpr30) ... *)
  MAKEPART(R, Rpr31_TF);
  SELECT(Rpr30, CUCopy);
  WHILE OCCURE(Rpr30) DO
   IF (Rpr30.TimeFact # 0) | (Rpr30.MathFact # 0) THEN
    SEARCH(RprS, RprS, , Rpr30.RprS);
    MAKEPART(R, Rpr31_LF);
    INC(totTimeFact, Rpr30.TimeFact);
    INC(totMathFact, Rpr30.MathFact);
   END;
   NEXT(Rpr30);
  END; (* WHILE OCCURE(Rpr30) ... *)
  MAKEPART(R, Rpr31_Total, "⮣  ",   totTimePlan, totMathPlan, totTimePlan+totMathPlan);
  MAKEPART(R, Rpr31_Total, "⮣ 䠪᪨", totTimeFact, totMathFact, totTimeFact+totMathFact);
  MAKEPART(R, Rpr31_Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {Rpr31};

 PRIVATE PROCEDURE Rpr32_MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "窠_");
  L_Basis.wb_WrInQM(F, "窠_");
  L_Basis.wb_WrInQM(F, "窠");
  L_Basis.wb_WrInQM(F, "室_");
  L_Basis.wb_WrInQM(F, "室_");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_TermLine(F);
 END {Rpr32_MakeHeader};

 PRIVATE PROCEDURE Rpr32_MakeLine(F: STRING[]);
  VAR
   curMDocTotal: L_Pmnt.tValuesToBalance;
 BEGIN
  L_Basis.wb_WrScl(F, OutCar.OutCar);
  CONFORM(OutCar, Mark);
  CONFORM(OutCar, Firm);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, Firm.Firm);
  L_Basis.wb_WrStr(F, Firm.Name);
  L_Basis.wb_WrDat(F, Rpr30.Date);
  L_Basis.wb_WrScl(F, Rpr30.RprS);
  SEARCH(RprS, RprS, , Rpr30.RprS);
  IF L_Rpr.extCheckExistsFinalMDoc(EMPTYOF(Firm.Firm), 0) THEN
   curMDocTotal:=L_Pmnt.GetMDocAcpt();
  ELSE
   SETZERO(curMDocTotal);
  END;
  L_Basis.wb_WrNum(F, curMDocTotal[L_Pmnt.vtb_Netto], 2);
  L_Basis.wb_WrNum(F, curMDocTotal[L_Pmnt.vtb_VAT  ], 2);
  L_Basis.wb_WrNum(F, curMDocTotal[L_Pmnt.vtb_Total], 2);
  L_Basis.wb_WrNum(F, Rpr30.MathFact, 2);
  L_Basis.wb_WrNum(F, Rpr30.TimeFact, 2);
  L_Basis.wb_WrNum(F, Rpr30.MathFact+Rpr30.TimeFact, 2);
  L_Basis.wb_TermLine(F);
 END {Rpr32_MakeLine};

 PUBLIC PROCEDURE Rpr32();
  CONST
   bpId="Rpr32";
 BEGIN
  L_bp.Begin(bpId, " 室  室     ஭ ", L_bp.t_Basis, L_General.tc_inIntvl);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  MakeTemporaryFile();
  SELECT(OutCar, OutCar);
  WHILE OCCURE(OutCar) DO
   PROMPT("஭ : " + OutCar.OutCar);
   TRY [RESTORE_CURSORS(RC_ON)]
    CUCopy_CalcFact(OutCar.CUCopy, Memo.ud_fr(), Memo.ud_ut());
   EXCEPT
   END;
   NEXT(OutCar);
  END; (* WHILE OCCURE(OutCar) ... *)
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  Rpr32_MakeHeader("R");
  SELECT(Rpr30, RprS);
  WHILE OCCURE(Rpr30) DO
   PROMPT("⮢ . : " + Rpr30.RprS);
   SEARCH(OutCar, CUCopy, , Rpr30.CUCopy);
   Rpr32_MakeLine("R");
   NEXT(Rpr30);
  END; (* WHILE OCCURE(Rpr30) ... *)
  FIO.Close(R);
  L_bp.End();
 END {Rpr32};

END.
