(*
%Copyright   (c) Polak IT
%Author      22.10.2009 14:42:25 POLAK\LDA
%Purpose      ࠢ⥩
%Type        control
%Specific    AP
%Modified    11.03.2013 11:36:54 POLAK\LDA
%Environment
*)

 MODULE RprDfApr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, L_WDO, L_Str, Str, Math;

 PRIVATE PROCEDURE RprDfApr_OnInitializeWindow();
 BEGIN
  L_WDO.iField    (0, "v_Parent").Value:="";
  L_WDO.iEvents   (1, [L_WDO.e_OnReposition]);
  L_WDO.iZone     (1).HierarchicLink:=LINK.Get("RprDfApr", "Parent");
  L_WDO.iSubwindow(1, "RprDfApE");
  L_WDO.iField    (1, "RprDfApr.Name").Hierarchic:=1;
  IF L_WDO.IsLoadableAskClone() & (L_WDO.iWindow().AskSourceField.Name = "RprDfApr.Parent") THEN
   L_WDO.iZone(1).ShowLeavesInHierarchicView:=0;
  END;
 END {RprDfApr_OnInitializeWindow};

 PRIVATE PROCEDURE RprDfApE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["RprDfApr.Parent"]);
  L_WDO.iUnmodifiable(0, ["RprDfApr.RprDfApr", "ParentTitle", "LeafTitle", "v_ParentName"]);
 END {RprDfApE_OnInitializeWindow};

 PRIVATE PROCEDURE GetRprDfAprParentName(): STRING[];
  VAR
   rda_ParentName: STRING[];
 BEGIN
  SETEMPTY(rda_ParentName);
  IF ACCESS(RprDfApr) & ~!RprDfApr.Parent THEN
   SAVE(RprDfApr);
   SEARCH(RprDfApr, RprDfApr, , RprDfApr.Parent);
   rda_ParentName:=RprDfApr.Name;
   RESTORE(RprDfApr);
  END;
  RETURN rda_ParentName;
 END {GetRprDfAprParentName};

 PRIVATE PROCEDURE RprDfApE_0_OnReposition();
 BEGIN
  RTI.Get().CurWindow.Title:=L_Str.PoolItem("㯯  ࠢ⥩| ࠢ", RprDfApr.Leaf);
  RTI.Get().CurZone.Fields("v_ParentName").Value:=GetRprDfAprParentName();
  RTI.Get().CurZone.Fields("RprDfApr.InExpl").Modifiable:=RprDfApr.Leaf;
 END {RprDfApE_0_OnReposition};

 PRIVATE PROCEDURE RprDfApr_1_OnReposition();
  CONST
   v_ParentLength = 51;
  VAR
   Cnt,
   MaxRprDfAprNameLength,
   MaxCarBlockNameLength: NUMERIC[0];
   Shift,
   ParentAsStr          : STRING[];
 BEGIN
  SETEMPTY(ParentAsStr);
  IF ACCESS(RprDfApr) THEN
   Cnt                  :=0;
   MaxCarBlockNameLength:=0;
   SAVE(RprDfApr);
   WHILE ~!RprDfApr.Parent & (Cnt < 3) DO
    SEARCH(RprDfApr, RprDfApr, , RprDfApr.Parent);
    CONFORM(RprDfApr, CarBlock);
(*
    MaxCarBlockNameLength:=Math.Max(MaxCarBlockNameLength, Str.Length(CarBlock.Name) + 2);
*)
    INC(Cnt);
   END;
   RESTORE(RprDfApr);
   SAVE(RprDfApr);
   WHILE ~!RprDfApr.Parent & (Cnt > 0) DO
    DEC(Cnt);
    SEARCH(RprDfApr, RprDfApr, , RprDfApr.Parent);
(*
    CONFORM(RprDfApr, CarBlock);
*)
    Shift                :=Str.Slice("       ", 0, Cnt);
    MaxRprDfAprNameLength:=v_ParentLength - Str.Length(Shift) - MaxCarBlockNameLength - 1;
    ParentAsStr:=Shift + Str.Slice(RprDfApr.Name, 0, MaxRprDfAprNameLength) + L_Str.CRLF + ParentAsStr;
(*
    ParentAsStr:=Shift + Str.Align(Str.Slice(RprDfApr.Name, 0, MaxRprDfAprNameLength), MaxRprDfAprNameLength, LEFT) + " " +
                                                Str.Align("(" + CarBlock.Name + ")", MaxCarBlockNameLength, LEFT) + L_Str.CRLF + ParentAsStr;
*)
   END;
   RESTORE(RprDfApr);
  END;

  RTI.Get().CurWindow.Zones(0).Fields("v_Parent").Value:=ParentAsStr;
  RTI.Get().CurWindow.Zones(0).Fields("v_Parent").Visible:=~!ParentAsStr;
  RTI.Get().CurWindow.Zones(0).Fields("v_Parent_Title").Visible:=~!ParentAsStr;
 END {RprDfApr_1_OnReposition};

 PRIVATE PROCEDURE RprDfApr_Parent_OnSuccessfulChange();
 BEGIN
  IF ~!RprDfApr.Parent THEN
   SAVE(RprDfApr);
   SEARCH(RprDfApr, RprDfApr, , RprDfApr.Parent);
   L_General.Assert(RprDfApr.Leaf=0, "室 㪠뢠 㯯  ࠢ⥩");
   RESTORE(RprDfApr);
   L_General.Assert(RprDfApr.Parent # RprDfApr.RprDfApr, " ᯮ짮 ⥪ ");
  ELSE
   L_General.Assert(RprDfApr.Leaf = 0, " 㪠 㯯  ࠢ⥩");
  END;
  RTI.Get().CurZone.Fields("v_ParentName").Value:=GetRprDfAprParentName();
 END {RprDfApr_Parent_OnSuccessfulChange};

 PRIVATE PROCEDURE RprDfApr_OnBeforeModification();
 BEGIN
  RTI.Get().CurZone.Fields("RprDfApr.Parent").MustBeNonempty:=RprDfApr.Leaf;
 END {RprDfApr_OnBeforeModification};

 PRIVATE PROCEDURE RprDfApr_OnBeforeInsert();
  VAR
   _CarBlock: LIKE(CarBlock.CarBlock);
 BEGIN
  SETEMPTY(_CarBlock);
  IF ~!RprDfApr.Parent THEN
   SAVE(RprDfApr);
   SEARCH(RprDfApr, RprDfApr, , RprDfApr.Parent);
   _CarBlock:=RprDfApr.CarBlock;
   RESTORE(RprDfApr);
  END;

  IF L_WDO.InHierarchyInsMode() THEN
   RprDfApr.Leaf:=0;
  ELSE
   RprDfApr.Leaf:=1;
  END;
  RprDfApr.CarBlock:=_CarBlock;
  REPLACE(RprDfApr);

  RprDfApr_OnBeforeModification();
 END {RprDfApr_OnBeforeInsert};

 PRIVATE PROCEDURE RprDfApr_OnBeforeEdit();
 BEGIN
  RprDfApr_OnBeforeModification();
 END {RprDfApr_OnBeforeEdit};

BEGIN
 L_Events.ExecuteHandler();
END.
