(*
%Copyright   (c) Polak IT
%Author      20.10.2009 12:35:50 POLAK\LDA
%Purpose     20.10.2009 12:38:22 POLAK\LDA
%Type        control
%Specific    AP
%Modified    17.06.2014 17:28:52 POLAK\LDA
%Environment
*)

 MODULE RprJob [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, L_Rpr, L_WDO, L_Way, P_Mark, L_AFM, Str, L_Str;

 PRIVATE PERMANENT VAR
  curRprJobDtNbr: LIKE(RprJobDt.Nbr);

 PRIVATE PROCEDURE RprJob_OnInitializeWindow();
 BEGIN
  L_WDO.iField (0, "v_Parent").LineBreakEnable:=1;
  L_WDO.iEvents(1, [L_WDO.e_OnReposition, L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone  (1).HierarchicLink:=LINK.Get("RprJob", "Parent");
  L_WDO.iField (1, "RprJob.Name").Hierarchic:=1;
  L_WDO.iField (1, "RprJob_Type_Short").Format:=L_Rpr.GetRprJobType_Pool(1);
  L_WDO.iField (1, "RprJob.RprJobDt").Format  :=L_Rpr.rjd_Pool_Short;

  IF L_WDO.IsLoadableAskClone() & (L_WDO.iWindow().AskSourceField.Name = "RprJob.Parent") THEN
   L_WDO.iZone(1).ShowLeavesInHierarchicView:=0;
  END;
 END {RprJob_OnInitializeWindow};

 PRIVATE PROCEDURE RprJob_1_OnSetSubwindow();
  VAR
   SubWindow: STRING[];
 BEGIN
  IF MODE = L_Events.md_SubWinInsert THEN
   IF L_WDO.InHierarchyInsMode() THEN
    SubWindow:="RprJobGE";
   ELSE
    SubWindow:="RprJobE";
   END;
  ELSE
   IF ACCESS(RprJob) & (RprJob.Leaf = 0) THEN
    SubWindow:="RprJobGE";
   ELSE
    SubWindow:="RprJobE";
   END;
  END;
  RTI.Get().CurZone.HasVariousSubwindows :=1;
  RTI.Get().CurZone.SubwindowOriginalName:=SubWindow;
 END {RprJob_1_OnSetSubwindow};

 PRIVATE PROCEDURE RprJobE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterInsert, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["RprJob.Parent"]);
  L_WDO.iUnmodifiable(0, ["RprJobDt2", "RprJob.RprJob", "v_ParentName"]);
  L_WDO.iMayBeEmpty  (0, ["RprJob.UnitedC"]);
  L_WDO.iField       (0, "RprJob.Type").Format    :=L_Rpr.GetRprJobType_Pool(0);
  L_WDO.iField       (0, "RprJob.RprJobDt").Format:=L_Rpr.rjd_Pool;
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterMdf]);
  L_WDO.iField       (1, "RprJMG.MarkG").OnBeforeAsk:=1;
  L_WDO.iScsChange   (1, ["RprJMG.MarkG"]);
  L_WDO.iUnmodifiable(1, ["RprJMG.Till"]);
  L_WDO.iProgs       (1, "RprJob");
  L_WDO.iEvents      (2, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (2).Narrowing:="RprJobDt.RprJob=RprJob.RprJob";
  L_WDO.iScsChange   (2, ["RprJobDt.RprJob2"]);
  L_WDO.iProgs       (2, "RprJob");
  L_WDO.iField       (2, "RprJob.RprJobDt").Format:=L_Rpr.rjd_Pool_Short;
  L_WDO.iField       (2, "RprJobDt.RprJob2").First:=1;
 END {RprJobE_OnInitializeWindow};

 PRIVATE PROCEDURE RprJobGE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeInsert, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["RprJob.Parent"]);
  L_WDO.iUnmodifiable(0, ["v_ParentName", "RprJob.RprJob"]);
  L_WDO.iMayBeEmpty  (0, ["RprJob.Parent"]);
 END {RprJobGE_OnInitializeWindow};

 PRIVATE PROCEDURE GetRprJobParentName(): STRING[];
  VAR
   rj_ParentName: STRING[];
 BEGIN
  SETEMPTY(rj_ParentName);
  IF ACCESS(RprJob) & ~!RprJob.Parent THEN
   SAVE(RprJob);
   SEARCH(RprJob, RprJob, , RprJob.Parent);
   rj_ParentName:=RprJob.Name;
   RESTORE(RprJob);
  END;
  RETURN rj_ParentName;
 END {GetRprJobParentName};

 PRIVATE PROCEDURE RprJob_1_OnReposition();
  CONST
   v_ParentLength = 53;
  VAR
   Cnt        : NUMERIC[0];
   Shift,
   ParentAsStr: STRING[];
   Fields     : FORM_FIELDS;
 BEGIN
  SETEMPTY(ParentAsStr);
  IF ACCESS(RprJob) THEN
   Cnt                  :=0;
   SAVE(RprJob);
   WHILE ~!RprJob.Parent & (Cnt < 3) DO
    SEARCH(RprJob, RprJob, , RprJob.Parent);
    INC(Cnt);
   END;
   RESTORE(RprJob);
   SAVE(RprJob);
   WHILE ~!RprJob.Parent & (Cnt > 0) DO
    DEC(Cnt);
    SEARCH(RprJob, RprJob, , RprJob.Parent);
    Shift                :=Str.Slice("       ", 0, Cnt);
    ParentAsStr:=Shift + Str.Slice(RprJob.Name, 0, v_ParentLength) + L_Str.CRLF + ParentAsStr;
   END;
   RESTORE(RprJob);
  END;
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  Fields("v_Parent").Value        :=ParentAsStr;
  Fields("v_Parent").Visible      :=~!ParentAsStr;
  Fields("v_Parent_Title").Visible:=~!ParentAsStr;
 END {RprJob_1_OnReposition};

 PRIVATE PROCEDURE RprJobE_0_OnReposition();
 BEGIN
  RTI.Get().CurZone.Fields("v_ParentName").Value    :=GetRprJobParentName();
 END {RprJobE_0_OnReposition};

 PRIVATE PROCEDURE RprJobGE_0_OnReposition();
 BEGIN
  RTI.Get().CurZone.Fields("v_ParentName").Value    :=GetRprJobParentName();
 END {RprJobGE_0_OnReposition};

 PRIVATE PROCEDURE RprJob_Parent_OnSuccessfulChange();
 BEGIN
  IF ~!RprJob.Parent THEN
   SAVE(RprJob);
   SEARCH(RprJob, RprJob, , RprJob.Parent);
   L_General.Assert(RprJob.Leaf=0, "室 㪠뢠 㯯஢ ");
   RESTORE(RprJob);
   L_General.Assert(RprJob.Parent # RprJob.RprJob, " ᯮ짮 ⥪ ");
  ELSE
   L_General.Assert(RprJob.Leaf = 0, " 㪠 㯯஢筠 ");
  END;
  RTI.Get().CurZone.Fields("v_ParentName").Value:=GetRprJobParentName();
 END {RprJob_Parent_OnSuccessfulChange};

 PRIVATE PROCEDURE RprJob_OnBeforeInsert();
  VAR
   _CarBlock: LIKE(CarBlock.CarBlock);
 BEGIN
  SETEMPTY(_CarBlock);
  IF ~!RprJob.Parent THEN
   SAVE(RprJob);
   SEARCH(RprJob, RprJob, , RprJob.Parent);
   _CarBlock:=RprJob.CarBlock;
   RESTORE(RprJob);
  END;

  IF L_WDO.InHierarchyInsMode() THEN
   RprJob.Leaf:=0;
   SETEMPTY(RprJob.Type);
  ELSE
   RprJob.Leaf:=1;
  END;
  RprJob.CarBlock:=_CarBlock;
  REPLACE(RprJob);
 END {RprJob_OnBeforeInsert};

 PRIVATE PROCEDURE RprJob_OnAfterEdIns();
 BEGIN
  IF    RprJob.RprJobDt = L_Rpr.rjd_None THEN
   L_General.Assert(~SELECT(RprJobDt, Nbr, RprJob.RprJob), "  ࠡ  ॡ ⠫");
  ELSE
   L_General.Assert(SELECT(RprJobDt, Nbr, RprJob.RprJob), "  ࠡ   । ⠫");
  END;
  IF ~RprJob.HasNorm THEN
   L_General.Assert(~SELECT(RprJMG, RprJob, RprJob.RprJob), "  ࠡ  ॡ ନ஢ 㤮");
  END;
 END {RprJob_OnAfterEdIns};

 PRIVATE PROCEDURE RprJob_OnAfterInsert();
 BEGIN
  RprJob_OnAfterEdIns();
 END {RprJob_OnAfterInsert};

 PRIVATE PROCEDURE RprJob_OnAfterEdit();
 BEGIN
  RprJob_OnAfterEdIns();
 END {RprJob_OnAfterEdit};

 PRIVATE PROCEDURE RprJMG_MarkG_OnBeforeAsk();
 BEGIN
  L_Way.v_MarkGT:=L_Way.mgt_RprJobBaseTime;
 END {RprJMG_MarkG_OnBeforeAsk};

 PRIVATE PROCEDURE RprJMG_MarkG_OnSuccessfulChange();
  VAR
   Dummy: STRING[];
 BEGIN
  IF ~!RprJMG.MarkG THEN
   Dummy:=P_Mark.GetMarkGName(L_Way.mgt_RprJobBaseTime, RprJMG.MarkG);
  END;
 END {RprJMG_MarkG_OnSuccessfulChange};

 PRIVATE PROCEDURE RprJMG_SupportEndDate(WithCur: SCAL[2]);
  VAR
   _Till,
   _Begin: DATE;
 BEGIN
  SAVE(RprJMG);
  SETEMPTY(_Begin);
  SETSEL(RprJMG, RprJob, RprJMG.RprJob, RprJMG.MarkG);
  LAST(RprJMG);
  WHILE OCCURE(RprJMG) DO
   IF (RprJMG.Begin # _Begin) | WithCur THEN
    IF !_Begin THEN
     SETEMPTY(_Till);
    ELSE
     _Till:=_Begin - 1;
    END;
    IF _Till # RprJMG.Till THEN
     RprJMG.Till:=_Till;
     REPLACE(RprJMG);
    END;
    _Begin:=RprJMG.Begin;
   END;
   PREV(RprJMG);
  END; (* WHILE OCCURE(RprJMG) ... *)
  RESTORE(RprJMG);
 END {RprJMG_SupportEndDate};

 PRIVATE PROCEDURE CheckUniqueMark();
 BEGIN
  L_AFM.MakeIndex("RJMGM", "Mark : LIKE(Mark.Mark);" +
                           "MarkG: LIKE(MarkG.MarkG)");
  CONFORM(RprJMG, RprJob);
  SELECT(RprJMG, RprJob, , RprJob.RprJob);
  WHILE OCCURE(RprJMG) DO
   NARROWSEL(RprJMG, MarkG);
   SELECT(MarkGM, MarkG, , RprJMG.MarkG);
   WHILE OCCURE(MarkGM) DO
    CONFORM(MarkGM, Mark);
    IF SELECT(RJMGM, RJMGM, MarkGM.Mark) THEN
     L_General.Error("ઠ " + Mark.Mark + " " + Mark.Name +
                     "|ନ஢   ࠧ   ६⭮ ࠡ," +
                     "|.. 室  㯯 ப " + RJMGM.MarkG + "  " + MarkGM.MarkG);
    END;
    RJMGM.Mark :=MarkGM.Mark;
    RJMGM.MarkG:=MarkGM.MarkG;
    INSERT(RJMGM);
    NEXT(MarkGM);
   END; (* WHILE OCCURE(MarkGM) ... *)
   NEXTINEXTENDEDSEL(RprJMG, MarkG);
  END; (* WHILE OCCURE(RprJMG) ... *)
  L_AFM.AF_PurgeTemp("RJMGM");
 END {CheckUniqueMark};

 PRIVATE PROCEDURE RprJMG_OnAfterEdit();
 BEGIN
  RprJMG_SupportEndDate(1);
  CheckUniqueMark();
 END {RprJMG_OnAfterEdit};

 PRIVATE PROCEDURE RprJMG_OnAfterInsert();
 BEGIN
  RprJMG_SupportEndDate(1);
  CheckUniqueMark();
 END {RprJMG_OnAfterInsert};

 PRIVATE PROCEDURE RprJMG_OnBeforeDelete();
 BEGIN
  RprJMG_SupportEndDate(0);
 END {RprJMG_OnBeforeDelete};

 PRIVATE PROCEDURE RprJobDt_RprJob2_OnSuccessfulChange();
  VAR
   curRprJob2 : LIKE(RprJob.RprJob);
   curRprJobDt: LIKE(RprJob.RprJobDt);
 BEGIN
  L_General.Assert(RprJobDt.RprJob # RprJobDt.RprJob2, "뫪  ⠫樨  ᭮ ६ ࠡ 饭");

  SEARCH(RprJob, RprJob, , RprJobDt.RprJob2);
  L_General.Assert(RprJob.Leaf = 1, "ᯮ짮 㯯஢ ᥩ 饭");
  curRprJob2:=RprJob.RprJob;
  curRprJobDt:=RprJob.RprJobDt;
  IF curRprJobDt # L_Rpr.rjd_None THEN
   SELECT(RprJobDt, Nbr, , RprJob.RprJob);
   WHILE OCCURE(RprJobDt) DO
    SEARCH(RprJob, RprJob, , RprJobDt.RprJob2);
    L_General.Assert(RprJob.RprJobDt # curRprJobDt, "࠭ ६⭠ ࠡ  ᢮|" +
                                                    "⠫樨 ᮤন .||" +
                                                    "  ⠫権  ন");
    NEXT(RprJobDt);
   END; (* WHILE OCCURE(RprJobDt) ... *)
  END;
 END {RprJobDt_RprJob2_OnSuccessfulChange};

 PRIVATE PROCEDURE RprJobDt_OnBeforeInsert();
  VAR
   newNbr: LIKE(RprJobDt.Nbr);
 BEGIN
  L_General.Assert(RprJob.RprJobDt # L_Rpr.rjd_None, "  ࠡ  ॡ ⠫");
  IF ~!curRprJobDtNbr & (curRprJobDtNbr > 1) THEN
   SETEMPTY(newNbr);
   SAVE(RprJobDt);
   IF ~SEARCH(RprJobDt, Nbr, RprJobDt.RprJob, curRprJobDtNbr-1) THEN
    newNbr:=curRprJobDtNbr-1;
   END;
   RESTORE(RprJobDt);
   IF ~!newNbr THEN
    RprJobDt.Nbr:=newNbr;
    REPLACE(RprJobDt);
   END;
  END;
 END {RprJobDt_OnBeforeInsert};

 PRIVATE PROCEDURE SetCurrentRprJobDtNbr();
 BEGIN
  IF ACCESS(RprJobDt) THEN
   curRprJobDtNbr:=RprJobDt.Nbr;
  ELSE
   SETEMPTY(curRprJobDtNbr);
  END;
 END {SetCurrentRprJobDtNbr};

 PRIVATE PROCEDURE RprJobE_2_OnSetSubwindow();
 BEGIN
  SetCurrentRprJobDtNbr();
 END {RprJobE_2_OnSetSubwindow};

 PRIVATE PROCEDURE RprJobGE_1_OnSetSubwindow();
 BEGIN
  SetCurrentRprJobDtNbr();
 END {RprJobGE_1_OnSetSubwindow};

 PRIVATE PROCEDURE RprJobDt_OnAfterDelete();
  VAR
   curNbr   : LIKE(RprJobDt.Nbr);
   curRprJob: LIKE(RprJob.RprJob);
 BEGIN
  IF ACCESS(RprJobDt) THEN
   curRprJob:=RprJobDt.RprJob;
   curNbr   :=1;
   SELECT(RprJobDt, Nbr, , curRprJob);
   WHILE OCCURE(RprJobDt) DO
    RprJobDt.Nbr:=curNbr;
    REPLACE(RprJobDt);
    INC(curNbr);
    NEXT(RprJobDt);
   END; (* WHILE OCCURE(RprJobDt) ... *)
  END;
 END {RprJobDt_OnAfterDelete};

 PUBLIC PROCEDURE RprJobDt_MoveUp();
  VAR
   curNbr   : LIKE(RprJobDt.Nbr);
   curRprJob: LIKE(RprJob.RprJob);
 BEGIN
  L_General.Assert(ACCESS(RprJobDt), " ࠭ ⥪ ६⭠ ࠡ");
  curNbr   :=RprJobDt.Nbr;
  curRprJob:=RprJobDt.RprJob;
  L_General.Assert(curNbr#1, "࠭ ६⭠ ࠡ - ࢠ  ᯨ᪥");
  L_General.Assert(~SEARCH(RprJobDt, Nbr, curRprJob, curNbr-1), " । :|" +
                                                                " ᢮ 浪 ");
  SETSEL(RprJobDt, Nbr, curRprJob);
  SRCINSEL(RprJobDt, EQ, , curNbr);
  WHILE OCCURE(RprJobDt) DO
   DEC(RprJobDt.Nbr);
   REPLACE(RprJobDt);
   NEXT(RprJobDt);
  END; (* WHILE OCCURE(RprJobDt) ... *)

  SEARCH(RprJobDt, Nbr, , curRprJob, curNbr-1);
  SE_WZD_POSITION(RTI.Get().CurWindow.OriginalName, RTI.Get().CurZone.Number, RprJobDt);
 END {RprJobDt_MoveUp};

 PUBLIC PROCEDURE RprJobDt_MoveDown();
  VAR
   curNbr: LIKE(RprJobDt.Nbr);
 BEGIN
  L_General.Assert(ACCESS(RprJobDt), " ࠭ ⥪ ६⭠ ࠡ");
  curNbr:=RprJobDt.Nbr;
  SELECT(RprJobDt, Nbr, , RprJobDt.RprJob);
  LAST(RprJobDt);
  WHILE OCCURE(RprJobDt) & (RprJobDt.Nbr >= curNbr) DO
   INC(RprJobDt.Nbr);
   REPLACE(RprJobDt);
   PREV(RprJobDt);
  END; (* WHILE OCCURE(RprJobDt) ... *)
 END {RprJobDt_MoveDown};

BEGIN
 L_Events.ExecuteHandler();
END.
