(*
%Copyright   (c) Polak IT
%Author      26.04.2002 14:35:48 SAN
%Purpose      ﭨ 
%Type        operation
9%Specific   AP
%Modified    27.03.2014 15:35:54 POLAK\LDA
%Environment
*)

 MODULE RprShow [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, Str, L_Str, L_Rpr, L_Car, P_Firm, Math, L_DatTim, L_Env, L_AFM,
        L_StdFrm, DBD, L_GUI, L_FIO;

 PUBLIC TYPE
  tRprBayState   = SCAL[1E2];
  tRprBayCluster = SCAL[100];
  tRprBay        = STRING[];

 PUBLIC CONST
  p_Main = "p_Main";

  rbs_Free     = 00;
  rbs_Wait     = 01;
(*RprBayGrad*)
  rbs_Open     = 04;
(*RprBayGrad*)
  rbs_Expired  = 07;
(*RprBayGrad*)
  rbs_Ready    = 10;
(*RprBayGrad*)
  rbs_PutOff   = 13;
  rbs_Multiple = 14;
  rbs_woDriver = 15;
  rbs_FO_Wait  = 16;
  rbs_FO_Open  = 17;
  rbs_FO_Ready = 18;

  rbc_Wait              = 0;
  rbc_Ready             = 1;
  rbc_IndependentRepair = 2;

  rbgrad_Low    = 0;
  rbgrad_Middle = 1;
  rbgrad_High   = 2;

  bo_Vertical   = 0;
  bo_Horizontal = 1;

  gb_Vertical    = 0;
  gb_Horizontal  = 1;
  gb_Vertical_DU = 2;

  sW_MainShift       = 3;
  sH_MainShift       = 3;

  pL_Most            = sW_MainShift;
  pT_Most            = sH_MainShift;

  pT_Clock           = pT_Most;

  pL_Title           = pL_Most;
  pT_Title           = pT_Most;

 PUBLIC VAR
  dlg         : DIALOG;

  pT_Beg,
  pR_Most     : NUMERIC[0];

  SpaceBtwBtns,
  sW_RprBBut_V,
  sH_RprBBut_V,
  sW_RprBBut_H,
  sH_RprBBut_H: NUMERIC[0];

 PRIVATE TYPE
  tOrientation = SCAL[2];
  gArrangement = SCAL[3];

  tGradation   = SCAL[3];

 PRIVATE CONST
  id_Clock           = "st_DateTime";
  id_Prompt          = "st_Prompt";
  id_Renew           = "pb_Renew";

  fs_Prompt          = 19;
  fs_Frame           = 14;
  fs_RprSDescr       = 16;
  fs_Title           = 20;
  fs_Clock           = 19;

  sW_ControlBut = 150;
  sH_ControlBut = 30;

  sW_Space = 5;
  sH_Space = 5;

  RenewPeriod =  5 * 60;

  MultipleRprBay = "X";

  maxTimeLimitAmnt = 2;

  MaxToolTipWidth = 460;

 PRIVATE PERMANENT VAR
  CurrentRprS: LIKE(RprS.RprS);

 PRIVATE VAR
  rb_Colors: RGBCOLOR[100];
  HRT_Renew: FLOAT;
  pB_Most,
  sW_Most,
  sH_Most,
  sH_Clock,
  sW_Clock,
  pL_Clock,
  sH_Title,
  sW_Title: NUMERIC[0];
  ScaleX, ScaleY: FLOAT;

 PUBLIC PROCEDURE E_SetSpaceBtwBtns();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_RprSh.GetHSpaceBtwBtns);
  IF ~!Local THEN
   SpaceBtwBtns:=Local();
  ELSE
   SpaceBtwBtns:=15;
  END;
 END {E_SetSpaceBtwBtns};

 PRIVATE PROCEDURE E_SetRprBButSize();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_RprSh.GetRprBButSize);
  IF ~!Local THEN
   Local(sW_RprBBut_H, sH_RprBBut_H);
  ELSE
   sW_RprBBut_H:=55;
   sH_RprBBut_H:=20;
  END;
  sW_RprBBut_V:=sH_RprBBut_H;
  sH_RprBBut_V:=sW_RprBBut_H;
 END {E_SetRprBButSize};

 PRIVATE PROCEDURE E_SetRprShowParams(VAR dlgWidth, dlgHeight: NUMERIC[0]);
  VAR
   Local: PROC;
 BEGIN
  E_SetRprBButSize();
  E_SetSpaceBtwBtns();

  Local:=PROCREF(E_RprSh.GetRprShowSize);
  IF ~!Local THEN
   Local(dlgWidth, dlgHeight);
  ELSE
   dlgWidth :=L_GUI.normalWidth;
   dlgHeight:=L_GUI.normalHeight;
  END;
  ScaleX:=dlgWidth / L_GUI.normalWidth;
  ScaleY:=dlgHeight / L_GUI.normalHeight;

  pR_Most :=dlgWidth - pL_Most;
  pB_Most :=dlgHeight - pT_Most;
  sW_Most :=pR_Most - pL_Most;
  sH_Most :=pB_Most - pT_Most;
  sW_Clock:=214 * ScaleX;
  pL_Clock:=pR_Most - sW_Clock;
  sW_Title:=sW_Most-sW_Clock-sW_MainShift;
  sH_Clock:=25 * ScaleY;
  sH_Title:=sH_Clock;
  pT_Beg  :=pT_Title + sH_Title;
 END {E_SetRprShowParams};

 PRIVATE PROCEDURE E_GetReportList(): STRING[];
  VAR
   Local     : PROC;
   Color,
   defRepList: STRING[];
 BEGIN
  Local     :=PROCREF(E_RprSh.GetReportList);
  Color     :="#DAD1C8";
  defRepList:="Rpr11 祭   祭묨 ﬨ:" + Color;
  IF ~!Local THEN
   defRepList:=defRepList + "|" + Local(Color);
  END;
  RETURN defRepList;
 END {E_GetReportList};

 PRIVATE PROCEDURE IsFailureOutputState(rb_State: tRprBayState): SCAL[2];
 BEGIN
  RETURN (rb_State = rbs_FO_Wait) |
         (rb_State = rbs_FO_Open) |
         (rb_State = rbs_FO_Ready);
 END {IsFailureOutputState};

 PRIVATE PROCEDURE E_GetTimeLimitsCondition(    rb_State  : tRprBayState;
                                            VAR TimeLimits: NUMERIC[3][]);
  VAR
   Local: PROC;
 BEGIN
  SETZERO(TimeLimits);
  IF    rb_State = rbs_Wait THEN
   TimeLimits[0]:=5.0;
   TimeLimits[1]:=10.0;
  ELSIF rb_State = rbs_Open THEN
   TimeLimits[0]:=3.0;
   TimeLimits[1]:=2.0;
  ELSIF rb_State = rbs_Expired THEN
   TimeLimits[0]:=2.0;
   TimeLimits[1]:=3.0;
  ELSIF rb_State = rbs_Ready THEN
   TimeLimits[0]:=2.0;
   TimeLimits[1]:=3.0;
  ELSIF (rb_State = rbs_PutOff)   |
        (rb_State = rbs_woDriver) |
        IsFailureOutputState(rb_State) THEN
(*
祣   - ⪠  ᠬ஫
*)
  ELSE
   L_General.CallUs(0);
  END;
  Local:=PROCREF(E_RprSh.GetTimeLimitsCondition);
  IF ~!Local THEN
   Local(rb_State, TimeLimits);
  END;
 END {E_GetTimeLimitsCondition};

 PRIVATE PROCEDURE E_GetStateGradation(rb_State: tRprBayState;
                                       overTime: NUMERIC[3]): tGradation;
  VAR
   rb_Grad   : tGradation;
   TimeLimits: NUMERIC[3][maxTimeLimitAmnt];
 BEGIN
  E_GetTimeLimitsCondition(rb_State, TimeLimits);
  IF    (rb_State = rbs_Wait)    |
        (rb_State = rbs_Expired) |
        (rb_State = rbs_Ready) THEN
   IF    overTime > TimeLimits[1] THEN
    rb_Grad:=rbgrad_High;
   ELSIF overTime > TimeLimits[0] THEN
    rb_Grad:=rbgrad_Middle;
   ELSE
    rb_Grad:=rbgrad_Low;
   END;
  ELSIF rb_State = rbs_Open THEN
   IF    -overTime < TimeLimits[0] THEN
    rb_Grad:=rbgrad_High;
   ELSIF -overTime < TimeLimits[1] THEN
    rb_Grad:=rbgrad_Middle;
   ELSE
    rb_Grad:=rbgrad_Low;
   END;
  ELSIF (rb_State = rbs_PutOff)        |
        (rb_State = rbs_woDriver) |
        IsFailureOutputState(rb_State) THEN
   rb_Grad:=rbgrad_Low;
  ELSE
   L_General.Error("⭮ ﭨ " + rb_State);
  END;
  RETURN rb_Grad;
 END {E_GetStateGradation};

 PRIVATE PROCEDURE E_GetCluster(_RprPlace: LIKE(RprPlace.RprPlace);
                                rb_State : tRprBayState): tRprBayCluster;
  VAR
   Local  : PROC;
   default: tRprBayCluster;
 BEGIN
  IF    (rb_State = rbs_Wait)   |
        (rb_State = rbs_PutOff) |
        (rb_State = rbs_FO_Wait)  THEN
   default:=rbc_Wait;
  ELSIF (rb_State = rbs_Ready) |
        (rb_State = rbs_FO_Ready) THEN
   default:=rbc_Ready;
  ELSIF ((rb_State = rbs_Open) | (rb_State = rbs_Expired)) & (RprS.Status = L_Rpr.ms_IndependentRepair) THEN
   default:=rbc_IndependentRepair;
  ELSE
   SETEMPTY(default);
  END;

  Local:=PROCREF(E_RprSh.GetCluster);
  IF ~!Local THEN
   RETURN Local(_RprPlace, rb_State, default);
  ELSE
   RETURN default;
  END;
 END {E_GetCluster};

 PRIVATE PROCEDURE E_AdditionalRenewPage();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_RprSh.AdditionalRenewPage);
  IF ~!Local THEN
   Local();
  END;
 END {E_AdditionalRenewPage};

 PRIVATE PROCEDURE E_IsAcceptableGroup(_Group: LIKE(RprSMirr.Group)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_RprSh.IsAcceptableGroup);
  IF ~!Local THEN
   RETURN Local(_Group);
  ELSE
   RETURN 1;
  END;
 END {E_IsAcceptableGroup};

 PRIVATE PROCEDURE E_NeedPrepare_woDrivers(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_RprSh.NeedPrepare_woDrivers);
  IF ~!Local THEN
   RETURN Local(SYSDATE());
  ELSE
   RETURN 0;
  END;
 END {E_NeedPrepare_woDrivers};

 PRIVATE PROCEDURE E_GetRprShowTitle(): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_RprSh.GetRprShowTitle);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN " .";
  END;
 END {E_GetRprShowTitler};

 PRIVATE PROCEDURE ExistRprPlace(_RprPlace: LIKE(RprPlace.RprPlace)): SCAL[2];
 BEGIN
  RETURN SEARCH(RprPlace, RprPlace, _RprPlace);
 END {ExistRprPlace};

 PRIVATE PROCEDURE GetRprPlaceEquipment(_RprPlace: LIKE(RprPlace.RprPlace)): LIKE(RprPlace.Equip);
 BEGIN
  IF ExistRprPlace(_RprPlace) THEN
   RETURN RprPlace.Equip;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetRprPlaceEquipment};

 PRIVATE PROCEDURE GetRprPlaceName(_RprPlace: LIKE(RprPlace.RprPlace)): STRING[];
 BEGIN
  IF ExistRprPlace(_RprPlace) THEN
   RETURN RprPlace.Name;
  ELSE
   RETURN "";
  END;
 END {GetRprPlaceName};

 PRIVATE PROCEDURE GetControlNameForRprPlace(_RprPlace: LIKE(RprPlace.RprPlace);
                                             Real     : SCAL[2]): STRING[];
 BEGIN
  RETURN L_Str.PoolItem("V|P", Real) + "_" + _RprPlace;
 END {GetControlNameForRprPlace};

 PRIVATE PROCEDURE FillButtonTextForLegend(VAR Text: STRING[][]);
  VAR
   TimeLimits: NUMERIC[3][maxTimeLimitAmnt];
 BEGIN
  SETEMPTY(Text);
  Text[rbs_Free]:=" ᢮";

  E_GetTimeLimitsCondition(rbs_Wait, TimeLimits);
  Text[rbs_Wait+rbgrad_Low]:="  ६";
  Text[rbs_Wait+rbgrad_Middle]:="  ६  " + GetSignForLegend(TimeLimits[0]);
  Text[rbs_Wait+rbgrad_High]:="  ६  " + GetSignForLegend(TimeLimits[1]);

  E_GetTimeLimitsCondition(rbs_Open, TimeLimits);
  Text[rbs_Open+rbgrad_Low]:=" ࠡ";
  Text[rbs_Open+rbgrad_Middle]:=" 砭  ⠫  " + GetSignForLegend(TimeLimits[0]);
  Text[rbs_Open+rbgrad_High]:=" 砭  ⠫  " + GetSignForLegend(TimeLimits[1]);

  E_GetTimeLimitsCondition(rbs_Expired, TimeLimits);
  Text[rbs_Expired+rbgrad_Low]:="ᯮ  祭";
  Text[rbs_Expired+rbgrad_Middle]:="ᯮ  祭  祬  " + GetSignForLegend(TimeLimits[0]);
  Text[rbs_Expired+rbgrad_High]:="ᯮ  祭  祬  " + GetSignForLegend(TimeLimits[1]);

  E_GetTimeLimitsCondition(rbs_Ready, TimeLimits);
  Text[rbs_Ready+rbgrad_Low]:=" 믮";
  Text[rbs_Ready+rbgrad_Middle]:=" 믮  祬 " + GetSignForLegend(TimeLimits[0]);
  Text[rbs_Ready+rbgrad_High]:=" 믮  祬 " + GetSignForLegend(TimeLimits[1]);

  Text[rbs_PutOff]:="  ⫮";
  Text[rbs_Multiple]:="⢨     ";
  Text[rbs_woDriver]:="  ⥫";
  Text[rbs_FO_Wait]:=" ᪠";
 END {FillButtonTextForLegend};

 PRIVATE PROCEDURE RprBayState_SetColors();
 BEGIN
  SETEMPTY(rb_Colors);
  rb_Colors[rbs_Free]                 :=RGBCOLOR.Create(218, 209, 200);
  rb_Colors[rbs_Wait+rbgrad_Low]      :=RGBCOLOR.Create(255, 255, 204);
  rb_Colors[rbs_Wait+rbgrad_Middle]   :=RGBCOLOR.Create(255, 255, 102);
  rb_Colors[rbs_Wait+rbgrad_High]     :=RGBCOLOR.Create(255, 255, 000);
  rb_Colors[rbs_Open+rbgrad_Low]      :=RGBCOLOR.Create(102, 204, 255);
  rb_Colors[rbs_Open+rbgrad_Middle]   :=RGBCOLOR.Create(000, 102, 255);
  rb_Colors[rbs_Open+rbgrad_High]     :=RGBCOLOR.Create(000, 000, 204);
  rb_Colors[rbs_Expired+rbgrad_Low]   :=RGBCOLOR.Create(255, 102, 102);
  rb_Colors[rbs_Expired+rbgrad_Middle]:=RGBCOLOR.Create(255, 102, 000);
  rb_Colors[rbs_Expired+rbgrad_High]  :=RGBCOLOR.Create(255, 000, 000);
  rb_Colors[rbs_Ready+rbgrad_Low]     :=RGBCOLOR.Create(204, 255, 153);
  rb_Colors[rbs_Ready+rbgrad_Middle]  :=RGBCOLOR.Create(153, 255, 102);
  rb_Colors[rbs_Ready+rbgrad_High]    :=RGBCOLOR.Create(000, 153, 000);
  rb_Colors[rbs_PutOff]               :=RGBCOLOR.Create(153, 000, 255);
  rb_Colors[rbs_Multiple]             :=RGBCOLOR.Create(000, 000, 000);
  rb_Colors[rbs_woDriver]             :=RGBCOLOR.Create(255, 245, 238);
  rb_Colors[rbs_FO_Wait]              :=RGBCOLOR.Create(255, 000, 255);
  rb_Colors[rbs_FO_Open]              :=RGBCOLOR.Create(255, 000, 255);
  rb_Colors[rbs_FO_Ready]             :=RGBCOLOR.Create(255, 000, 255);
 END {RprBayState_SetColors};

 PRIVATE PROCEDURE GetRprBayColor(ColorIdx: NUMERIC[0]): RGBCOLOR;
 BEGIN
  RETURN rb_Colors[ColorIdx];
 END {GetRprBayColor};

 PRIVATE PROCEDURE PutStaticText(Text: STRING[]; Left, Top, Width, Height: NUMERIC[0]; Border: STRING[]);
  VAR
   Id: STRING[];
   st: STATIC_TEXT;
 BEGIN
  Id:="st_Frame" + L_Str.IntStr(dlg.Controls.Count);
  L_GUI.put_StaticText(dlg, p_Main, Id, Text,
                       Left, Top, Width, Height,
                       fs_Frame,
                       CONTROL.HorizontalAlignment_Center,
                       Border);
  st:=dlg.Controls.Item(Id);
  st.VerticalAlignment  :=CONTROL.VerticalAlignment_Top;
 END {PutStaticText};

 PUBLIC PROCEDURE PutLabel(Text: STRING[]; Left, Top, Width, Height: NUMERIC[0]);
 BEGIN
  PutStaticText(Text, Left, Top, Width, Height, L_GUI.br_st_None);
 END {PutLabel};

 PUBLIC PROCEDURE PutFrame(Text: STRING[]; Left, Top, Width, Height: NUMERIC[0]);
 BEGIN
  PutStaticText(Text, Left, Top, Width, Height, L_GUI.br_st_ThinRidge);
 END {PutFrame};

 PRIVATE PROCEDURE psv_RprDA(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="";
  CONFORM(RprS, RprDA);
  WHILE OCCURE(RprDA) DO
   CONFORM(RprDA, RprDfApr, CarBlock);
   Result:=Result + L_Rpr.GetRprDA_AsStr() + L_Str.CRLF;
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)
  RETURN Result;
 END {psv_RprDA};

 PRIVATE PROCEDURE GetROName(trgRprObjT: LIKE(RprS.RprObjT);
                             trgDate   : DATE;
                             Full      : SCAL[2]): STRING[];
 BEGIN
  IF    trgRprObjT = L_Rpr.rot_Car THEN
   L_Car.StandOnCarLog(Car.BoxNbr, trgDate);
   CONFORM(CarLog, Mark);
   IF Full THEN
    RETURN CarLog.StateNbr + " " + Mark.Name;
   ELSE
    RETURN Mark.Name;
   END;
  ELSIF trgRprObjT = L_Rpr.rot_OutCar THEN
   CONFORM(OutCar, Mark);
   RETURN Mark.Name;
  ELSIF trgRprObjT = L_Rpr.rot_CarBlock THEN
   RETURN Math.Name;
  ELSIF trgRprObjT = L_Rpr.rot_OutCBlc THEN
   CONFORM(OutCBlc, Math);
   RETURN Math.Name;
  ELSIF trgRprObjT = L_Rpr.rot_Math THEN
   RETURN Math.Name;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetROName};
 
 PRIVATE PROCEDURE descr_RprS(wHintDelimiter: SCAL[2]): STRING[];
  VAR
   HintDelimiter,
   trgRprObjCode: STRING[];
 BEGIN
  IF wHintDelimiter THEN
   HintDelimiter:='=========================================================';
  ELSE
   SETEMPTY(HintDelimiter);
  END;
  L_Rpr.AccessOrigin();
  IF    L_Rpr.IsRprS_w_Car() THEN
   trgRprObjCode:=Car.BoxNbr;
  ELSIF L_Rpr.IsRprS_w_OutCar() THEN
   trgRprObjCode:=OutCar.StateNbr;
  ELSIF L_Rpr.IsRprS_w_CarBlock() THEN
   trgRprObjCode:=CUCopy.Serial;
  ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
   trgRprObjCode:=OutCBlc.OutCBlc;
  ELSIF L_Rpr.IsRprS_w_Math() THEN
   trgRprObjCode:=Math.Math;
  ELSE
   L_General.CallUs(0);
  END;

  RETURN              HintDelimiter +
         L_Str.CRLF + "  " + RprS.RprS + " " + L_Rpr.DateTimeToStr(RprS.OrdDate, RprS.OrdTime) + " " +
         L_Rpr.GetRprObjT_AsStr() + " " + trgRprObjCode + " " + GetROName(RprS.RprObjT, RprS.OrdDate, 1) +
         L_Str.CRLF + HintDelimiter +
         L_Str.CRLF + psv_RprDA();
 END {descr_RprS};

 PRIVATE PROCEDURE descr_RprT(): STRING[];
  VAR
   RprT_Tip,
   RprJ_Tip: STRING[];
 BEGIN
  SETEMPTY(RprT_Tip, RprJ_Tip);
  RprT_Tip:=L_Rpr.GetRprT_AsStr(1) + L_Str.CRLF;
  CONFORM(RprT, RprJ);
  WHILE OCCURE(RprJ) DO
   CONFORM(RprJ, RprJob);
   CONFORM(RprJob, CarBlock);
   RprJ_Tip:=RprJ_Tip + L_Rpr.GetRprJ_AsStr() + L_Str.CRLF;
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ) ... *)
  RETURN RprT_Tip + RprJ_Tip;
 END {descr_RprT};

 PRIVATE PROCEDURE descr_AllRprT(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF SELECT(RprT, RprS, RprS.RprS) THEN
   WHILE OCCURE(RprT) DO
    IF ~!RprT.RprPlace THEN
     Result:=Result + descr_RprT();
    END;
    NEXT(RprT);
   END; (* WHILE OCCURE(RprT) ... *)
  END;
  RETURN Result;
 END {descr_AllRprT};

 PRIVATE PROCEDURE GetSingleRprSDescription(wHintDelimiter: SCAL[2]): STRING[];
 BEGIN
  RETURN descr_RprS(wHintDelimiter) + descr_AllRprT();
 END {GetSingleRprSDescription};

 PRIVATE PROCEDURE OnClick_GoToRprS(SLF: OBJECT);
 BEGIN
  Purge_TmpFiles();
  LIKEMENU(CALL, "RprShow.StandOnRprSByRprS_1()");
 END {OnClick_GoToRprS};

 PRIVATE PROCEDURE OnClick_CloseSingleRprS(SLF: OBJECT);
 BEGIN
  SLF.Parent.Parent.Visible:=0;
 END {OnClick_CloseSingleRprS};

 PRIVATE PROCEDURE UpdateClock();
 BEGIN
  dlg.Controls.Item(id_Clock).Text:=L_DatTim.CompleteSystimeStr();
  dlg.Controls.Item(id_Clock).Redraw();
 END {UpdateClock};

 PRIVATE PROCEDURE SecondsLeft(prvHRT: FLOAT): NUMERIC[3];
 BEGIN
  RETURN HIGH_RESOLUTION_TIMER() - prvHRT;
 END {SecondsLeft};

 PRIVATE PROCEDURE SetRenewButtonText(Text: STRING[]);
  VAR
   pb: PUSH_BUTTON;
 BEGIN
  pb:=dlg.Controls.Item(id_Renew);
  pb.Text:=Text;
  pb.Redraw();
 END {SetRenewButtonText};

 PRIVATE PROCEDURE FirstDTIsLessSecondDT(Date1: DATE; Time1: TIME; Date2: DATE; Time2: TIME): SCAL[2];
  VAR
   Intvl1, Intvl2: FLOAT;
 BEGIN
  IF    !Date1  | !Time1 THEN
   RETURN 0;
  ELSIF !Date2 | !Time2 THEN
   RETURN 1;
  ELSE
   PackVARIANTDATE(Intvl1, Date1,  Time1);
   PackVARIANTDATE(Intvl2, Date2, Time2);
   RETURN Intvl1 <= Intvl2;
  END;
 END {FirstDTIsLessSecondDT};

 PRIVATE PROCEDURE DateIsLessSystemDate(_Date: DATE;
                                        _Time: TIME): SCAL[2];
 BEGIN
  RETURN FirstDTIsLessSecondDT(_Date, _Time, SYSDATE(), SYSTIME());
 END {DateIsLessSystemDate};

 PRIVATE PROCEDURE GetLastModifiedDateTime(VAR _Date: DATE;
                                           VAR _Time: TIME);
 BEGIN
  IF ~!RprS.EDate & ~DateIsLessSystemDate(RprS.EDate, RprS.ETime) THEN
   _Date:=RprS.EDate;
   _Time:=RprS.ETime;
  ELSE
   _Date:=RprS.OrdDate;
   _Time:=RprS.OrdTime;
  END;
  IF SELECT(RprT, RprS, RprS.RprS) THEN
   WHILE OCCURE(RprT) DO
    IF DateIsLessSystemDate(RprT.BDate, RprT.BTime) &
       ~!RprT.EDate &
       FirstDTIsLessSecondDT(_Date, _Time, RprT.EDate, RprT.ETime) THEN
     _Date:=RprT.EDate;
     _Time:=RprT.ETime;
    END;
    NEXT(RprT);
   END; (* WHILE OCCURE(RprT) ... *)
  END;
 END {GetLastModifiedDateTime};

 PRIVATE PROCEDURE intGetRprBay(_RprPlace: LIKE(RprPlace.RprPlace)): tRprBay;
  VAR
   _RprBay: tRprBay;
 BEGIN
  _RprBay:=ARprB.RprBay;
  IF ~!_RprPlace & SRCINSEL(ARprB, EQ, _RprPlace) THEN
   _RprBay:=ARprB.RprBay;
   IF  NEXT(ARprB) THEN
    _RprBay:=ARprB.RprBay;
   END;
  END;

  RETURN _RprBay;
 END {intGetRprBay};

 PRIVATE PROCEDURE GetRprBay(_ZonePlc: LIKE(RprPlace.RprPlace);
                             _Cluster: tRprBayCluster): STRING[];
  VAR
   _RprBay  : tRprBay;
   _RprPlace: LIKE(RprPlace.RprPlace);
 BEGIN
  SETEMPTY(_RprBay);
  IF     ~!_Cluster THEN
   L_General.CallUs(SELECT(ARprB, Cluster, 0, _Cluster));
   IF SELECT(TmRBS, Cluster, 0, _Cluster) THEN
    LAST(TmRBS);
    _RprPlace:=TmRBS.RprPlace;
   ELSE
    SETEMPTY(_RprPlace);
   END;
   _RprBay:=intGetRprBay(_RprPlace);
  ELSIF ~!_ZonePlc THEN
   L_General.CallUs(SELECT(ARprB, ZonePlc, 0, _ZonePlc));
   IF SELECT(TmRBS, ZonePlc, 0, _ZonePlc, _Cluster) THEN
    LAST(TmRBS);
    _RprPlace:=TmRBS.RprPlace;
   ELSE
    SETEMPTY(_RprPlace);
   END;
   _RprBay:=intGetRprBay(_RprPlace);
  END;

  RETURN _RprBay;
 END {GetRprBay};

 PRIVATE PROCEDURE StandOnRprBay(_RprBay: tRprBay): SCAL[2];
 BEGIN
  RETURN SEARCH(ARprB, RprBay, _RprBay);
 END {StandOnRprBay};

 PRIVATE PROCEDURE GatherSingleRprObj(trgCUCopy  : LIKE(CUCopy.CUCopy);
                                      trgRprObjT : LIKE(RprS.RprObjT);
                                      trgRprObjId: LIKE(RprS.RprObjId);
                                      trgRprPlace: LIKE(RprPlace.RprPlace);
                                      rb_State   : tRprBayState;
                                      overTime   : NUMERIC[3];
                                      RprSDescr,
                                      RprTDescr  : STRING[]);
  VAR
   trgRprBay : STRING[];
   trgCluster: tRprBayCluster;
   trgZonePlc: LIKE(RprPlace.RprPlace);
 BEGIN
  trgCluster:=E_GetCluster(trgRprPlace, rb_State);
  SETEMPTY(trgZonePlc);
  IF ExistRprPlace(trgRprPlace) & (RprPlace.Kind = L_Rpr.rpk_Zone) THEN
   SETEMPTY(trgRprPlace, trgCluster);
   trgZonePlc:=RprPlace.RprPlace;
  END;

  IF !trgCluster & ~!trgRprPlace THEN
   trgRprBay :=GetControlNameForRprPlace(trgRprPlace, 1);
  ELSE
   trgRprBay :=GetRprBay(trgZonePlc, trgCluster);
  END;

  DEFAULT(TmRBS);
  TmRBS.Cluster :=trgCluster;
  TmRBS.RprBay  :=trgRprBay;
  TmRBS.CUCopy  :=trgCUCopy;
  TmRBS.CnvObjId:=Str.Small(Str.Replace(trgRprObjId, " ", ""));
  TmRBS.RprObjId:=Str.Small(trgRprObjId);
  TmRBS.ROName  :=GetROName(trgRprObjT, SYSDATE(), 0);
  TmRBS.State   :=rb_State;
  TmRBS.Grad    :=E_GetStateGradation(rb_State, overTime);
  TmRBS.RprSDscr:=RprSDescr;
  TmRBS.RprTDscr:=RprTDescr;
  TmRBS.ZonePlc :=trgZonePlc;
  IF ~!trgRprBay & StandOnRprBay(trgRprBay) THEN
   TmRBS.Real    :=ARprB.Real;
   TmRBS.RprPlace:=ARprB.RprPlace;
  END;
  INSERT(TmRBS);
 END {GatherSingleRprObj};

 PRIVATE PROCEDURE CarHasRepEvent(_BoxNbr: LIKE(Car.BoxNbr); D: DATE): SCAL[2];
 BEGIN
  IF SELECT(CarEvn, BoxNbr, _BoxNbr) &
     SRCINSEL(CarEvn, LE, D) &
     L_DatTim.IsActive_Inc(D, CarEvn.StartD, CarEvn.StopD) THEN
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {CarHasRepEvent};

 PRIVATE PROCEDURE HasRWayS(_BoxNbr: LIKE(Car.BoxNbr);
                            OnDate : DATE;
                            OnTime : TIME): SCAL[2];
 BEGIN
  SELECT(RWayS, BoxNbr, , _BoxNbr, OnDate);
  RETURN SRCINSEL(RWayS, LE, OnTime);
 END {HasRWayS};

 PRIVATE PROCEDURE GatherRprBayState();
  VAR
   overTime: NUMERIC[3];
   _Date,
   SysDate : DATE;
   _Time,
   SysTime : TIME;
   rb_State: tRprBayState;
   RprTDescr: STRING[];
 BEGIN
  SysDate:=SYSDATE();
  SysTime:=SYSTIME();

  SELECT(TmRBS, RprBay);
  REMSEL(TmRBS);

  SELECT(RprS, cRprS, , 0);
  WHILE OCCURE(RprS) DO
   PROMPT(RprS.RprS);
   L_Rpr.AccessOrigin();

   IF ~DBD.FileExist("tmpRT") THEN
    L_AFM.MakeMultipleIndex("tmpRT", "RprT    : LIKE(RprT.RprT);" +
                                     "RprPlace: LIKE(RprPlace.RprPlace);" +
                                     "rb_State: SCAL[1E2];" +
                                     "overTime: NUMERIC[3]",
                            "RprT:RprT;RprPlace:RprPlace,overTime");
   ELSE
    SELECT(tmpRT, RprT);
    REMSEL(tmpRT);
   END;

   SELECT(RprT, RprS, , RprS.RprS);
   WHILE OCCURE(RprT) DO
    SETEMPTY(rb_State);
    IF ~DateIsLessSystemDate(RprT.EDate, RprT.ETime) THEN
     IF ~!RprT.TaskLen THEN
      IF  ~!RprT.RprPlace | (RprT.TaskKind = L_Rpr.tk_IndependentRepair) | (RprT.TaskKind = L_Rpr.tk_Overhaul) THEN
       IF  DateIsLessSystemDate(RprT.BDate, RprT.BTime) THEN
        IF L_Rpr.HasRprTNotification() THEN
         IF ~L_Rpr.HasRprTEnding() THEN
          L_Rpr.GetRprTEndDateTime(_Date, _Time);
          overTime:=L_Rpr.SysOverTime(_Date, _Time);
          IF overTime > 0 THEN
           rb_State:=rbs_Expired;
          ELSE
           rb_State:=rbs_Open;
          END;
         ELSE
          overTime:=L_Rpr.SysOverTime(RprT.JobEDate, RprT.JobETime);
          rb_State:=rbs_Ready;
         END;
        ELSE
         overTime:=L_Rpr.SysOverTime(RprT.BDate, RprT.BTime);
         rb_State:=rbs_Wait;
        END;
       ELSE
        overTime:=0;
        rb_State:=rbs_Wait;
       END; (* IF ~!RprT.RprPlace...*)
      ELSE
       overTime:=L_Rpr.SysOverTime(RprT.BDate, RprT.BTime);
       rb_State:=rbs_Wait;
      END;
     END;

     IF    RprS.Status = L_Rpr.ms_PutOff THEN
      rb_State:=rbs_PutOff;
      overTime:=0;
     ELSIF L_Rpr.IsFailureOutput() THEN
      overTime:=L_Rpr.SysOverTime(RprS.OrdDate, RprS.OrdTime);
      IF    rb_State = rbs_Wait THEN
       rb_State:=rbs_FO_Wait;
      ELSIF rb_State = rbs_Ready THEN
       rb_State:=rbs_FO_Ready;
      ELSE
       rb_State:=rbs_FO_Open;
      END;
     END;

     IF ~!rb_State THEN
      tmpRT.RprT    :=RprT.RprT;
      tmpRT.RprPlace:=RprT.RprPlace;
      tmpRT.rb_State:=rb_State;
      tmpRT.overTime:=overTime;
      INSERT(tmpRT);
     END;
    END;
    NEXT(RprT);
   END; (* WHILE OCCURE(RprT)...*)

   SETEMPTY(RprTDescr);
   SELECT(tmpRT, RprT);
   WHILE OCCURE(tmpRT) DO
    SEARCH(RprT, RprS, , RprS.RprS, tmpRT.RprT);
    IF L_Rpr.E_OccupySingleRprPlaceByWholeRprS() THEN
     RprTDescr:=RprTDescr + descr_RprT();
    ELSE
     GatherSingleRprObj(RprS.CUCopy,
                        RprS.RprObjT,
                        RprS.RprObjId,
                        tmpRT.RprPlace,
                        tmpRT.rb_State,
                        tmpRT.overTime,
                        descr_RprS(1),
                        descr_RprT());
    END;
    NEXT(tmpRT);
   END; (* WHILE OCCURE(tmpRT) ... *)

   IF L_Rpr.E_OccupySingleRprPlaceByWholeRprS() THEN
    SELECT(tmpRT, RprPlace);
    WHILE OCCURE(tmpRT) DO
     NARROWSEL(tmpRT, RprPlace);
     LAST(tmpRT);
     GatherSingleRprObj(RprS.CUCopy,
                        RprS.RprObjT,
                        RprS.RprObjId,
                        tmpRT.RprPlace,
                        tmpRT.rb_State,
                        tmpRT.overTime,
                        descr_RprS(1),
                        RprTDescr);
     NEXTINEXTENDEDSEL(tmpRT, RprPlace);
    END; (* WHILE OCCURE(tmpRT) ... *)
   END;

   IF ~SELECT(tmpRT, RprT) THEN
    GetLastModifiedDateTime(_Date, _Time);
    overTime :=L_Rpr.SysOverTime(_Date, _Time);
    IF    L_Rpr.IsFailureOutput() THEN
     rb_State:=rbs_FO_Wait;
    ELSIF (RprS.Status = L_Rpr.ms_Ready) |
          (RprS.Status = L_Rpr.ms_Done) THEN
     rb_State:=rbs_Ready;
    ELSIF (RprS.Status = L_Rpr.ms_Waiting) |
          (RprS.Status = L_Rpr.ms_Return)  |
          (RprS.Status = L_Rpr.ms_WaitTechAid) THEN
     rb_State:=rbs_Wait;
    ELSIF RprS.Status = L_Rpr.ms_PutOff THEN
     rb_State:=rbs_PutOff;
    ELSE
     L_General.Error("⭮ ﭨ  " + RprS.RprS);
    END;
    GatherSingleRprObj(RprS.CUCopy,
                       RprS.RprObjT,
                       RprS.RprObjId,
                       L_General.EMPTY_NUMBER(),
                       rb_State,
                       overTime,
                       descr_RprS(1),
                       "");
   END;
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS)...*)

  IF E_NeedPrepare_woDrivers() THEN
   SELECT(_Cars, BoxNbr);
   WHILE OCCURE(_Cars) DO
    PROMPT("⮢   ⥫ " + _Cars.BoxNbr);
    IF ~(SELECT(RprS, cCUCopy, 0, _Cars.CUCopy)                 |
         CarHasRepEvent(_Cars.BoxNbr, SysDate)                  |
         HasRWayS(_Cars.BoxNbr, SysDate, L_General.EMPTY_TIME())) THEN
     GatherSingleRprObj(_Cars.CUCopy,
                        L_Rpr.rot_Car,
                        _Cars.BoxNbr,
                        L_General.EMPTY_NUMBER(),
                        rbs_woDriver,
                        0,
                        _Cars.BoxNbr + " " + _Cars.MarkName,
                        "");
    END;
    NEXT(_Cars);
   END; (* WHILE OCCURE(_Cars) ... *)
  END;
  L_AFM.ssrf_Store_InOutputMode("TmRBS");
 END {GatherRprBayState};

 PRIVATE PROCEDURE NeedInvertButtonTextFontColor(rb_State  : tRprBayState;
                                                 rb_Grad   : tGradation): SCAL[2];
 BEGIN
  RETURN (rb_State = rbs_PutOff) |
         ((rb_Grad = rbgrad_High) &
          ((rb_State = rbs_Open) | (rb_State = rbs_Expired) | (rb_State = rbs_Ready)));
 END {NeedInvertButtonTextFontColor};

 PRIVATE PROCEDURE ConvertButtonText(Text                 : STRING[];
                                     HorizontalOrientation: SCAL[2]): STRING[];
  VAR
   Result,
   d: STRING[];
   i,
   l: NUMERIC[0];
 BEGIN
  l:=Str.Length(Text);
  IF ~HorizontalOrientation THEN
   d:=L_Str.CRLF;
  ELSE
   SETEMPTY(d);
  END;
  Result:="";
  i:=0;
  LOOP
   INC(Result, L_Str.Char(Text, i));
   INC(i);
   IF i = l THEN
    EXIT;
   END;
   INC(Result, d);
  END;
  RETURN Result;
 END {ConvertButtonText};

 PRIVATE PROCEDURE intRenewSingleRprBay(pb            : PUSH_BUTTON;
                                        trgRprBay     : tRprBay;
                                        rb_State      : tRprBayState;
                                        rb_Grad       : tGradation;
                                        rb_Text,
                                        rb_ToolTipText: STRING[]);
  VAR
   Width,
   Height,
   FontSize             : NUMERIC[2];
   HorizontalOrientation: SCAL[2];
 BEGIN
  FontSize:=15;
  IF    rb_State = rbs_Free THEN
   pb.Text:="";
  ELSIF rb_State = rbs_Multiple THEN
   pb.Text:=rb_Text;
  ELSE
   Width                :=pb.Rect.Right - pb.Rect.Left;
   Height               :=pb.Rect.Bottom - pb.Rect.Top;
   HorizontalOrientation:=Width > Height;
   pb.Text              :=ConvertButtonText(rb_Text, HorizontalOrientation);

   IF (Str.Length(rb_Text) / ARprB.Capacity) <= 6 THEN
    IF HorizontalOrientation THEN
     FontSize:=15;
    ELSE
     FontSize:=13;
    END;
   ELSE
    IF HorizontalOrientation THEN
     FontSize:=14;
    ELSE
     FontSize:=13;
    END;
   END;
  END;
  pb.Style.Font.Face:=L_GUI.fn_CourierNew;
  pb.Style.Font.Size:=FontSize;
  L_GUI.SetControlBkColor(pb, GetRprBayColor(rb_State+rb_Grad));
  IF NeedInvertButtonTextFontColor(rb_State, rb_Grad) THEN
   L_GUI.SetControlFgColor(pb, RGBCOLOR.Create(255, 255, 255));
  ELSE
   L_GUI.SetControlFgColor(pb, RGBCOLOR.Create(000, 000, 000));
  END;
  L_GUI.SetToolTipText(pb, rb_ToolTipText);
 END {intRenewSingleRprBay};

 PRIVATE PROCEDURE RenewSingleRprBay(trgRprBay     : tRprBay;
                                     rb_State      : tRprBayState;
                                     rb_Grad       : tGradation;
                                     rb_Text,
                                     rb_ToolTipText: STRING[]);

 BEGIN
  intRenewSingleRprBay(dlg.Controls.Item(trgRprBay),
                       trgRprBay,
                       rb_State,
                       rb_Grad,
                       rb_Text,
                       rb_ToolTipText);
 END {RenewSingleRprBay};

 PRIVATE PROCEDURE RenewPage(force: SCAL[2]);
  VAR
   Amnt          : NUMERIC[0];
   rb_State      : tRprBayState;
   rb_Grad       : tGradation;
   rb_Text,
   rb_ToolTipText: STRING[];
 BEGIN
  SetRenewButtonText("...");

  E_AdditionalRenewPage();
  PROMPT("  ...");

  IF force THEN
   GatherRprBayState();
  END;

  IF SELECT(TmRBS, RprBay, "") THEN
   L_General.CallUs(0);
  END;

  SELECT(ARprB, RprBay);
  WHILE OCCURE(ARprB) DO
   PROMPT(" ﭨ  " + ARprB.RprBay);
   rb_ToolTipText:=ARprB.Name;
   IF SELECT(TmRBS, RprBay, ARprB.RprBay) THEN
    Amnt:=0;
    SETEMPTY(rb_Text);
    WHILE OCCURE(TmRBS) DO
     NARROWSEL(TmRBS, CnvObjId);
     rb_Text       :=L_Str.AddStrDlm(rb_Text, "+") + TmRBS.RprObjId;
     rb_State      :=TmRBS.State;
     rb_Grad       :=TmRBS.Grad;
     rb_ToolTipText:=rb_ToolTipText + L_Str.CRLF + TmRBS.RprSDscr;
     WHILE OCCURE(TmRBS) DO
      rb_ToolTipText:=L_Str.AddStrDlm(rb_ToolTipText, L_Str.CRLF) + TmRBS.RprTDscr;
      NEXT(TmRBS);
     END; (* WHILE OCCURE(TmRBS) ...*)
     INC(Amnt);
     NEXTINEXTENDEDSEL(TmRBS, CnvObjId);
    END; (* WHILE OCCURE(TmRBS)...*)
    IF    Amnt > ARprB.Capacity THEN
     rb_State      :=rbs_Multiple;
     rb_Grad       :=rbgrad_Low;
     rb_Text       :=MultipleRprBay;
     rb_ToolTipText:=" ᬮ ஡ ଠ樨   ";
    END;
    RenewSingleRprBay(ARprB.RprBay, rb_State, rb_Grad,    rb_Text, rb_ToolTipText);
   ELSE
    RenewSingleRprBay(ARprB.RprBay, rbs_Free, rbgrad_Low, "",      rb_ToolTipText);
   END; (* IF SELECT(TmRBS... *)
   NEXT(ARprB);
  END; (* WHILE OCCURE(ARprB) ... *)
  PROMPT("");
  HRT_Renew:=HIGH_RESOLUTION_TIMER();
  dlg.Redraw();
 END {RenewPage};

 PRIVATE PROCEDURE GetRenewButtonText(Sec: NUMERIC[0]): STRING[];
 BEGIN
  RETURN " (" + L_Str.IntStr(Math.Div(Sec, 60)) + ":" + FLDTOSTR(Math.Mod(Sec, 60), "L", 2) + ")";
 END {GetRenewButtonText};

 PRIVATE PROCEDURE idleProc_int(curDlg: DIALOG): SCAL[2];
 BEGIN
  UpdateClock();
  SetRenewButtonText(GetRenewButtonText(RenewPeriod - SecondsLeft(HRT_Renew)));

  IF SecondsLeft(HRT_Renew) >= RenewPeriod THEN
   IF L_General.IsAcceptableProcessorVersion(014160040) THEN
    curDlg.ProcessUserInput:=0;
   END;
   RenewPage(1);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {idleProc_int};

 PRIVATE PROCEDURE idleProc(curDlg: DIALOG);
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=idleProc_int(curDlg);
 END {idleProc};

 PRIVATE PROCEDURE CreateChildDialog(parentDlg              : DIALOG;
                                     trgCaption             : STRING[];
                                     trgStandardClientWidth : NUMERIC[0];
                                     trgStandardClientHeight: NUMERIC[0]): DIALOG;
  VAR
   Result: DIALOG;
 BEGIN
  Result                          :=DIALOG.Create(parentDlg);
  Result.WindowSizeStatus         :=DIALOG.WindowSizeStatus_Restored;
  Result.WindowStyle              :=DIALOG.WindowStyle_FixedSize;
  Result.CaptionText              :=trgCaption;
  Result.BackgroundPicture        :=L_GUI.SoftLoadPicture(L_FIO.rf_GetFullFileName("RprShow_BackGround_Small.jpg"));
  Result.BackgroundPicturePosition:=DIALOG.BackgroundPicturePosition_Tile;
  Result.StandardClientWidth      :=trgStandardClientWidth;
  Result.StandardClientHeight     :=trgStandardClientHeight;
  Result.ClientRect.Right         :=Result.ClientRect.Left+trgStandardClientWidth;
  Result.ClientRect.Bottom        :=Result.ClientRect.Top+trgStandardClientHeight;
  Result.Redraw();
  RETURN Result;
 END {CreateChildDialog};

 PRIVATE PROCEDURE ShowSingleRprS(trgRprBay: tRprBay; trgRprObjId: LIKE(RprS.RprObjId); parentDlg: DIALOG);
  CONST
   sW_GoToRprSBut = 120;
   sH_GoToRprSBut = 30;

   sH_RprPlace    = 30;
  VAR
   st                : STATIC_TEXT;
   i, pT, pL,
   sW_SingleRprS,
   sH_SingleRprS,
   sW_RprPlace,
   sW_DescrRprS,
   sH_DescrRprS      : NUMERIC[0];
   dlgSingleRprS     : DIALOG;
   curMonitor        : MONITOR;
   MonitorsCollection: MONITORS;
 BEGIN
  L_General.CallUs(SELECT(TmRBS, RprBay, trgRprBay, trgRprObjId));
  IF SELECT(RprS, cCUCopy, 0, TmRBS.CUCopy) THEN
   CurrentRprS:=RprS.RprS;

   sW_SingleRprS:=dlg.StandardClientWidth  * 0.8;
   sH_SingleRprS:=dlg.StandardClientHeight * 0.8;

   dlgSingleRprS:=CreateChildDialog(parentDlg, "  " + RprS.RprS, sW_SingleRprS, sH_SingleRprS);

   MonitorsCollection:=MONITORS.Create();
   i                 :=0;
   LOOP
    L_General.CallUs(i <= MonitorsCollection.Count);
    curMonitor:=MonitorsCollection.Item(i);
    IF curMonitor.Primary THEN
     EXIT;
    END;
    INC(i);
   END; (* LOOP *)

   pT         :=sH_Space;
   sW_RprPlace:=sW_SingleRprS - 2 * sW_Space;
   L_General.CallUs(StandOnRprBay(trgRprBay));
   L_GUI.add_StaticText(dlgSingleRprS, "st_RprPlace", ARprB.Name,
                        sW_Space, pT, sW_RprPlace, sH_RprPlace,
                        fs_RprSDescr, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_Ridge);

   st:=dlgSingleRprS.Controls.Item("st_RprPlace");
   st.Visible:=1;
   st.Style.Font.Face:=L_GUI.fn_LucidaConsole;

   pT          :=pT + sH_RprPlace + sH_Space;
   sW_DescrRprS:=sW_RprPlace;
   sH_DescrRprS:=sH_SingleRprS - pT - sH_Space - sH_GoToRprSBut - sH_Space;
   L_GUI.add_StaticText(dlgSingleRprS,
                        "st_RprSDescr",
                        GetSingleRprSDescription(0),
                        sW_Space, pT, sW_DescrRprS, sH_DescrRprS,
                        fs_RprSDescr, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_Ridge);
   st:=dlgSingleRprS.Controls.Item("st_RprSDescr");
   st.Visible          :=1;
   st.Style.Font.Face  :=L_GUI.fn_LucidaConsole;
   st.VerticalAlignment:=CONTROL.VerticalAlignment_Top;
   st.VerticalScroll   :=1;

   pT:=pT + sH_DescrRprS + sH_Space;
   pL:=sW_SingleRprS - (sW_GoToRprSBut + sW_Space) * 2;

   L_GUI.add_Button(dlgSingleRprS, "pb_GotoRprS", "३  ", "",
                    pL, pT, sW_GoToRprSBut, sH_GoToRprSBut,
                    14, L_GUI.fn_LucidaConsole,
                    PROCREF(OnClick_GoToRprS));
   dlgSingleRprS.Controls.Item("pb_GotoRprS").Visible:=1;

   pL:=pL + sW_GoToRprSBut + sW_Space;

   L_GUI.add_Button(dlgSingleRprS, "pb_CloseSingleRprS", "", "",
                    pL, pT, sW_GoToRprSBut, sH_GoToRprSBut,
                    14, L_GUI.fn_LucidaConsole,
                    PROCREF(OnClick_CloseSingleRprS));
   dlgSingleRprS.Controls.Item("pb_CloseSingleRprS").Visible:=1;

   dlgSingleRprS.Visible:=1;
   dlgSingleRprS.Redraw();
   WHILE dlgSingleRprS.Visible DO
    RENEWDATALAYER();
    idleProc(dlgSingleRprS);
    dlgSingleRprS.Wait(1);
   END; (* WHILE dlgSingleRprS.Visible...*)
  ELSE
   L_StdFrm.Inform("   . ,   㦥  ।  ᯫ");
  END;
 END {ShowSingleRprS};

 PRIVATE PROCEDURE OnClick_RprBay(SLF: OBJECT);
  VAR
   trgRprBay  : tRprBay;
   trgRprObjId: STRING[];
 BEGIN
  trgRprObjId:=Str.Replace(Str.Replace(SLF.Text, " ", ""), L_Str.CRLF, "");
  trgRprBay  :=SLF.Id;
  IF    (trgRprObjId = MultipleRprBay) | (Str.Pos(trgRprObjId, "+") # Str.Length(trgRprObjId)) THEN
   ShowAllRprS(trgRprBay);
  ELSIF !trgRprObjId THEN
   IF StandOnRprBay(trgRprBay) THEN
    L_StdFrm.Inform(" '" + SLF.ToolTipText + "'  ");
   ELSE
    L_General.CallUs(0);
   END;
  ELSIF SELECT(TmRBS, RprBay, trgRprBay) & (TmRBS.State = rbs_woDriver) THEN
   L_StdFrm.Inform(" " + trgRprObjId + "  ⥫");
  ELSE
   ShowSingleRprS(trgRprBay, trgRprObjId, dlg);
  END;
 END {OnClick_RprBay};

 PRIVATE PROCEDURE _PutButton(Text,
                              Id,
                              BorderColor,
                              BackgroundColor: STRING[];
                              Left,
                              Top,
                              Width,
                              Height,
                              FontSize: NUMERIC[0]);
  VAR
   pb: PUSH_BUTTON;
 BEGIN
  L_GUI.put_Button(dlg, p_Main, Id, Text,
                   Left, Top, Width, Height,
                   FontSize, L_GUI.fn_Default,
                   PROCREF(OnClick_RprBay));

  pb:=dlg.Controls.Item(Id);
  pb.OldStyleDrawing  :=1;
  pb.Style.Font.Weight:=FONT.Weight_Bold;
 END {_PutButton};

 PRIVATE PROCEDURE PutButton(Id         : STRING[];
                             Equipment  : LIKE(RprPlace.Equip);
                             Left,
                             Top        : NUMERIC[0];
                             Orientation: tOrientation;
                             _Capacity  : NUMERIC[0]);
  VAR
   Height,
   Width      : NUMERIC[0];
   BorderColor: STRING[];
 BEGIN
  IF Orientation = bo_Vertical THEN
   Height:=sH_RprBBut_V * _Capacity + SpaceBtwBtns * (_Capacity - 1);
   Width :=sW_RprBBut_V;
  ELSE
   Height:=sH_RprBBut_H;
   Width :=sW_RprBBut_H * _Capacity + SpaceBtwBtns * (_Capacity - 1);
  END;

(*
  IF Equipment # L_Rpr.rpe_None THEN
  rpe_BorderColors = " |#0000FF|#FF6600|#00FF66";
   BorderColor:=L_Str.PoolItem(rpe_BorderColors, Equipment);
  ELSE
   SETEMPTY(BorderColor);
  END;
*)
  SETEMPTY(BorderColor);

  _PutButton("",
             Id,
             BorderColor,
             "",
             Left,
             Top,
             Width,
             Height,
             00);
 END {PutButton};

 PRIVATE PROCEDURE intPutButtonGroup(_ZonePlc   : LIKE(RprPlace.RprPlace);
                                     Places     : STRING[];
                                     Left,
                                     Top        : NUMERIC[1];
                                     Orientation: tOrientation;
                                     Arrangement: gArrangement;
                                     _Cluster   : tRprBayCluster;
                                     _Name      : STRING[]);
  VAR
   i        : NUMERIC[0];
   _Equip   : LIKE(RprPlace.Equip);
   _RprPlace: LIKE(RprPlace.RprPlace)[256];
 BEGIN
  L_Str.StrToScalArr(Places, _RprPlace);
  i:=0;
  WHILE ~!_RprPlace[i] DO
   PROMPT(_RprPlace[i]);

   DEFAULT(ARprB);
   IF !_ZonePlc & !_Cluster & ExistRprPlace(_RprPlace[i]) THEN
    IF ~L_DatTim.IsActive(SYSDATE(), RprPlace.Begin, RprPlace.Till) THEN
     L_StdFrm.Choice(" " + _RprPlace[i] + " ");
    END;
    ARprB.Real    :=1;
    ARprB.Name    :=GetRprPlaceName(_RprPlace[i]) + " ( " + _RprPlace[i] + ")";
    ARprB.Capacity:=RprPlace.Capacity;
    _Equip        :=GetRprPlaceEquipment(_RprPlace[i]);
   ELSE
    IF ~!_ZonePlc & ExistRprPlace(_ZonePlc) THEN
     _Name :=RprPlace.Name;
     _Equip:=GetRprPlaceEquipment(_ZonePlc);
    ELSE
     _Equip:=L_Rpr.rpe_None;
    END;
    ARprB.ZonePlc :=_ZonePlc;
    ARprB.Real    :=0;
    L_General.Assert(~!_Name, " 㪠   " + _RprPlace[i]);
    ARprB.Name    :=_Name;
    ARprB.Capacity:=1;
   END;
   ARprB.RprBay  :=GetControlNameForRprPlace(_RprPlace[i], ARprB.Real);
   ARprB.Cluster :=_Cluster;
   ARprB.RprPlace:=_RprPlace[i];
   INSERT(ARprB);

   PutButton(GetControlNameForRprPlace(_RprPlace[i], ARprB.Real),
             _Equip,
             Left,
             Top,
             Orientation,
             ARprB.Capacity);

   IF    Arrangement = gb_Vertical THEN
    IF Orientation = bo_Vertical THEN
     INC(Top, (sH_RprBBut_V + SpaceBtwBtns) * ARprB.Capacity);
    ELSE
     INC(Top, sH_RprBBut_H + SpaceBtwBtns);
    END;
   ELSIF Arrangement = gb_Vertical_DU THEN
    IF Orientation = bo_Vertical THEN
     DEC(Top, (sH_RprBBut_V + SpaceBtwBtns) * ARprB.Capacity);
    ELSE
     DEC(Top, sH_RprBBut_H + SpaceBtwBtns);
    END;
   ELSE
    IF Orientation = bo_Vertical THEN
     INC(Left, sW_RprBBut_V + SpaceBtwBtns);
    ELSE
     INC(Left, (sW_RprBBut_H + SpaceBtwBtns) * ARprB.Capacity);
    END;
   END;
   INC(i);
  END; (* WHILE ~! ... *)
 END {intPutButtonGroup};

 PUBLIC PROCEDURE _PutButtonGroup(Places     : STRING[];
                                  Left,
                                  Top        : NUMERIC[1];
                                  Orientation: tOrientation;
                                  Arrangement: gArrangement;
                                  Border     : STRING[];
                                  _Cluster   : tRprBayCluster;
                                  _Name      : STRING[]);
 BEGIN
  intPutButtonGroup(L_General.EMPTY_NUMBER(), Places, Left, Top, Orientation, Arrangement, _Cluster, _Name);
 END {_PutButtonGroup};

 PUBLIC PROCEDURE PutButtonGroup_byZone(_ZonePlc   : LIKE(RprPlace.RprPlace);
                                        Places     : STRING[];
                                        Left,
                                        Top        : NUMERIC[1];
                                        Orientation: tOrientation;
                                        Arrangement: gArrangement);
 BEGIN
  intPutButtonGroup(_ZonePlc, Places, Left, Top, Orientation, Arrangement, "", "");
 END {PutButtonGroup_byZone};

 PUBLIC PROCEDURE PutButtonGroup(Places     : STRING[];
                                 Left,
                                 Top        : NUMERIC[1];
                                 Orientation: tOrientation;
                                 Arrangement: gArrangement);
 BEGIN
  _PutButtonGroup(Places, Left, Top, Orientation, Arrangement, "", "", "");
 END {PutButtonGroup};

 PRIVATE PROCEDURE OnClick_AllRprSRprBay(SLF: OBJECT);
  VAR
   trgRprBay  : tRprBay;
   trgRprObjId: LIKE(RprS.RprObjId);
 BEGIN
  trgRprObjId:=Str.Replace(Str.Replace(SLF.Text, " ", ""), L_Str.CRLF, "");
  trgRprBay  :=Str.Slice(SLF.Id, 0, Str.MaxLength(TmRBS.RprBay));
  IF    (trgRprObjId = MultipleRprBay) | !trgRprObjId THEN
   L_General.CallUs(0);
  ELSIF SELECT(TmRBS, RprBay, trgRprBay) & (TmRBS.State = rbs_woDriver) THEN
   L_StdFrm.Inform(" " + trgRprObjId + "  ⥫");
  ELSE
   ShowSingleRprS(trgRprBay, trgRprObjId, SLF.Parent.Parent);
  END;
 END {OnClick_AllRprSRprBay};

 PRIVATE PROCEDURE AllRprS_PutButton(dlgAllRprS: DIALOG;
                                     Id        : STRING[];
                                     Left,
                                     Top       : NUMERIC[0]);
  VAR
   pb: PUSH_BUTTON;
 BEGIN
  L_GUI.add_Button(dlgAllRprS, Id, "", "",
                   Left, Top, sW_RprBBut_H, sH_RprBBut_H,
                   15, L_GUI.fn_LucidaConsole,
                   PROCREF(OnClick_AllRprSRprBay));

  pb                  :=dlgAllRprS.Controls.Item(Id);
  pb.OldStyleDrawing  :=1;
  pb.Visible          :=1;
  pb.Style.Font.Weight:=FONT.Weight_Bold;
  pb.Redraw();
 END {AllRprS_PutButton};

 PRIVATE PROCEDURE GetRoundValue(Value: NUMERIC[3]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=Math.Trunc(Value);
  IF Value # Result THEN
   INC(Result);
  END;
  RETURN Result;
 END {GetRoundValue};

 PRIVATE PROCEDURE ShowAllRprS(trgRprBay: tRprBay);
  VAR
   st                : STATIC_TEXT;
   Id                : STRING[];
   tmpValue          : NUMERIC[3];
   i,
   tmp_pL,
   pT, pL,
   Amount,
   RowAmount,
   ColumnAmount,
   sW_Border,
   sH_Border,
   sW_AllRprS,
   sH_AllRprS        : NUMERIC[0];
   dlgAllRprS        : DIALOG;
   DataHasBeenUpdated: SCAL[2];
 BEGIN
  SETZERO(Amount);
  SELECT(TmRBS, RprBay, , trgRprBay);
  WHILE OCCURE(TmRBS) DO
   INC(Amount);
   NEXT(TmRBS);
  END; (* WHILE OCCURE(TmRBS) ... *)

  L_General.CallUs(Amount > 1);

  ColumnAmount:=GetRoundValue(Math.Pow(Amount, 1/2));
  RowAmount   :=GetRoundValue(Amount / ColumnAmount);

  pT:=sH_Space;
  pL:=sW_Space;

  sW_Border:=sW_Space + sW_RprBBut_H * ColumnAmount + SpaceBtwBtns * (ColumnAmount - 1) + sW_Space;
  sH_Border:=sH_Space + sH_RprBBut_H * RowAmount    + SpaceBtwBtns * (RowAmount    - 1) + sH_Space;

  sW_AllRprS:=pL + sW_Border + sW_Space;
  sH_AllRprS:=pT + sH_Border + sH_Space;

  L_General.CallUs(StandOnRprBay(trgRprBay));

  dlgAllRprS:=CreateChildDialog(dlg, ARprB.Name, sW_AllRprS, sH_AllRprS);
  dlgAllRprS.ToolTipMaxWidth     :=MaxToolTipWidth;

  L_GUI.add_StaticText(dlgAllRprS, "st_AllRprS", "",
                       pL, pT, sW_Border, sH_Border,
                       EMPTYOF(NUMERIC[0]), CONTROL.HorizontalAlignment_Left, L_GUI.br_st_Ridge);
  st        :=dlgAllRprS.Controls.Item("st_AllRprS");
  st.Visible:=1;

  tmp_pL:=pL + sW_Space;
  pL    :=tmp_pL;
  pT    :=pT + sH_Space;
  i:=0;
  SELECT(TmRBS, RprBay, , trgRprBay);
  WHILE OCCURE(TmRBS) DO
   IF i = ColumnAmount THEN
    i :=0;
    pL:=tmp_pL;
    pT:=pT + sH_RprBBut_H + SpaceBtwBtns;
   END;
   Id:=ARprB.RprBay + L_Str.IntStr(Amount);
   AllRprS_PutButton(dlgAllRprS, Id, pL, pT);
   intRenewSingleRprBay(dlgAllRprS.Controls.Item(Id), ARprB.RprBay, TmRBS.State, TmRBS.Grad, TmRBS.RprObjId, ARprB.Name + L_Str.CRLF + TmRBS.RprSDscr);
   pL:=pL + sW_RprBBut_H + SpaceBtwBtns;
   INC(i);
   DEC(Amount);
   NEXT(TmRBS);
  END; (* WHILE OCCURE(TmRBS) ... *)

  dlgAllRprS.Visible:=1;
  dlgAllRprS.Redraw();

  DataHasBeenUpdated:=0;
  WHILE dlgAllRprS.Visible DO
   IF idleProc_int(dlgAllRprS) THEN
    DataHasBeenUpdated:=1;
    dlgAllRprS.Visible:=~DataHasBeenUpdated;
    dlgAllRprS.Redraw();
   ELSE
    RENEWDATALAYER();
    dlgAllRprS.Wait(1);
   END;
  END; (* WHILE dlgAllRprS.Visible...*)

  IF DataHasBeenUpdated THEN
   ShowAllRprS(trgRprBay);
  END;
 END {ShowAllRprS};

 PRIVATE PROCEDURE GatherAllowedCars();
  VAR
   _Group: LIKE(RprSMirr.Group);
 BEGIN
  IF E_NeedPrepare_woDrivers() THEN
   SELECT(Car, BoxNbr);
   WHILE OCCURE(Car)  DO
    PROMPT("ࠡ⪠: ࠦ " + Car.BoxNbr);
    IF L_Env.RealBoxNbr(Car.BoxNbr) &
       L_Car.CarIsInOperation(Car.BoxNbr, SYSDATE()) &
       (CarLog.Purpose = L_Car.purp_Common) &
       (CarLog.InBeg # L_Car.inBeg_DoesNot) THEN
      _Group:=L_Rpr.E_GetOpenRprSGroup();
     IF E_IsAcceptableGroup(_Group) THEN
      CONFORM(CarLog, Mark);
      _Cars.CUCopy  :=Car.CUCopy;
      _Cars.BoxNbr  :=Car.BoxNbr;
      _Cars.Group   :=_Group;
      _Cars.MarkName:=Mark.Name;
      INSERT(_Cars);
     END;
    END;
    NEXT(Car);
   END; (* WHILE OCCURE(Car) ... *)
  END;
  L_AFM.ssrf_Store_InOutputMode("_Cars");
 END {GatherAllowedCars};

 PRIVATE PROCEDURE RebuildRequired(DTS: TIMESTAMP; TimeOut: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN ((SYSTIMESTAMP() - DTS) * 24 * 60 * 60) > TimeOut;
 END {RebuildRequired};

 PRIVATE PROCEDURE Create_TmpFiles();
 BEGIN
  L_AFM.ssrf_Register("_Cars", "_Cars");
  CreateFILE(_Cars, "", " 㠫 ", "");

  CreateFIELD(_Cars, CUCopy,   LIKE(CUCopy.CUCopy), "", "", "", " ", "");
  CreateFIELD(_Cars, BoxNbr,   LIKE(Car.BoxNbr), "", "", "", "ࠦ", "");
  CreateFIELD(_Cars, Group,    LIKE(RprSMirr.Group), "", "", "", "㯯", "");
  CreateFIELD(_Cars, MarkName, LIKE(Mark.Name), "", "", "", "ઠ", "");

  CreateINDEX(_Cars, BoxNbr, UNIQUE, "", "", BoxNbr);

  SetVersionOfFILE(_Cars, 0);

  IF ~L_AFM.ssrf_Reuse_InOutputMode("_Cars") | RebuildRequired(GETFILETIME(_Cars), 1 * 60 * 60) THEN
   L_AFM.ssrf_Create("_Cars");
   GatherAllowedCars();
  END;

  L_AFM.ssrf_Register("TmRBS", "TmRBS");
  CreateFILE(TmRBS, "", "ﭨ ६ ", "");

  CreateFIELD(TmRBS, RprBay,   STRING[6], "", "", "", "", "");
  CreateFIELD(TmRBS, Real,     SCAL[2], "", "", "", " ", "");
  CreateFIELD(TmRBS, Cluster,  tRprBayCluster, "", "", "", " ()", "");
  CreateFIELD(TmRBS, ZonePlc,  LIKE(RprPlace.RprPlace), "", "", "", "", "");
  CreateFIELD(TmRBS, RprPlace, LIKE(RprPlace.RprPlace), "", "", "", "", "");
  CreateFIELD(TmRBS, CUCopy,   LIKE(CUCopy.CUCopy), "", "", "", " ꥪ ६", "");
  CreateFIELD(TmRBS, CnvObjId, LIKE(RprS.RprObjId), "", "", "", "ꥪ ६  ஡ -  ᪠", "");
  CreateFIELD(TmRBS, RprObjId, LIKE(RprS.RprObjId), "", "", "", "ꥪ ६", "");
  CreateFIELD(TmRBS, ROName,   STRING[128], "", "", "", " ꥪ ६", "");
  CreateFIELD(TmRBS, RprSDscr, STRING[1024], "", "", "", " ", "");
  CreateFIELD(TmRBS, RprTDscr, STRING[1024], "", "", "", "ᠭ ", "");
  CreateFIELD(TmRBS, State,    tRprBayState, "", "", "", " ", "");
  CreateFIELD(TmRBS, Grad,     tGradation, "", "", "", "ࠤ ﭨ", "");

  CreateINDEX(TmRBS, RprBay,  PLURAL, "", "", RprBay, CnvObjId);
  CreateINDEX(TmRBS, Cluster, PLURAL, "", "", Real, Cluster, RprPlace, CnvObjId);
  CreateINDEX(TmRBS, ZonePlc, PLURAL, "", "", Real, ZonePlc, Cluster, RprPlace, CnvObjId);

  SetVersionOfFILE(TmRBS, 0);
  IF ~L_AFM.ssrf_Reuse_InOutputMode("TmRBS") | RebuildRequired(GETFILETIME(TmRBS), RenewPeriod) THEN
   L_AFM.ssrf_Create("TmRBS");
   GatherRprBayState();
  END;
 END {Create_TmpFiles};

 PRIVATE PROCEDURE Purge_TmpFiles();
 BEGIN
  L_AFM.AF_PurgeTemp("_Cars");
  L_AFM.AF_PurgeTemp("TmRBS");
 END {Purge_TmpFiles};

 PRIVATE PROCEDURE OnClick_Report(SLF: OBJECT);
 BEGIN
  L_General.SetupRequired();
 END {ShowReport};

 PRIVATE PROCEDURE ShowMainPage();
 BEGIN
  L_GUI.ShowPages(dlg, p_Main, 0);
 END {ShowMainPage};

 PRIVATE PROCEDURE PlayDialog();
 BEGIN
  RprBayState_SetColors();
  HRT_Renew:=HIGH_RESOLUTION_TIMER();

  ShowMainPage();
  RenewPage(0);

  dlg.Visible:=1;
  dlg.Redraw();

  WHILE dlg.Visible DO
   idleProc(dlg);
   RENEWDATALAYER();
   IF L_General.IsAcceptableProcessorVersion(014155170) THEN
    dlg.Wait(1);
   ELSE
    TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
     dlg.Wait(0.5);
    EXCEPT
    ON Exc: Exc_Root DO
     L_GUI.Error(dlg, Exc.MsgOriginalText);
    END;
   END;
  END; (* WHILE dlg.Visible *)
  Purge_TmpFiles();
 END {PlayDialog};

 PRIVATE PROCEDURE PutLegendButton(dlgLegend: DIALOG;
                                   Text     : STRING[];
                                   Idx      : NUMERIC[0]);
  CONST
   LabelWidth = 400;
   pL         = 20;
   pT         = 20;
   Space      = 5;
  VAR
   Id : STRING[];
   pb : PUSH_BUTTON;
   Top: NUMERIC[0];
 BEGIN
  Id :="pb_Legend" + L_Str.IntStr(Idx);
  Top:=pT + (sH_RprBBut_H + Space) * Idx;
  L_GUI.add_Button(dlgLegend, Id, "", "",
                   pL, Top, sW_RprBBut_H, sH_RprBBut_H,
                   12, L_GUI.fn_LucidaConsole,
                   L_General.EMPTY_PROC());
  pb:=dlgLegend.Controls.Item(Id);
  pb.OldStyleDrawing:=1;
  pb.Visible        :=1;
  L_GUI.SetControlBkColor(pb, GetRprBayColor(Idx));
  pb.Redraw();

  Id :="pb_LegendText" + L_Str.IntStr(Idx);
  L_GUI.add_StaticText(dlgLegend, Id, Text,
                       sW_RprBBut_H + 30, Top, LabelWidth, sH_RprBBut_H,
                       16, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  dlgLegend.Controls.Item(Id).Visible:=1;
 END {PutLegendButton};

 PRIVATE PROCEDURE GetSignForLegend(TimeLimit: NUMERIC[3]): STRING[];
 BEGIN
  RETURN FLDTOSTR(Math.Abs(TimeLimit), "1.") + " . ";
 END {GetSignForLegend};

 PRIVATE PROCEDURE GetStateMaxGradation(rb_State: tRprBayState): tGradation;
 BEGIN
  IF (rb_State = rbs_Wait)    |
     (rb_State = rbs_Open)    |
     (rb_State = rbs_Expired) |
     (rb_State = rbs_Ready) THEN
   RETURN rbgrad_High;
  ELSE
   RETURN rbgrad_Low;
  END;
 END {GetStateMaxGradation};

 PRIVATE PROCEDURE OnClick_Legend(SLF: OBJECT);
  VAR
   dlgLegend : DIALOG;
   Idx,
   sW_Legend,
   sH_Legend : NUMERIC[0];
   Text      : STRING[][MAXOF(tRprBayState)];
 BEGIN
  FillButtonTextForLegend(Text);
  Idx:=0;
  WHILE (Idx <= HIGH(Text)) & ~!Text[Idx] DO
   INC(Idx);
  END;

  sW_Legend:=500;
  sH_Legend:=20 + sH_RprBBut_H * Idx + 5 * (Idx-1) + 20;

  dlgLegend:=CreateChildDialog(dlg, "", sW_Legend, sH_Legend);

  Idx:=0;
  WHILE (Idx <= HIGH(Text)) & ~!Text[Idx] DO
   PutLegendButton(dlgLegend, Text[Idx], Idx);
   INC(Idx);
  END;

  dlgLegend.Visible:=1;
  dlgLegend.Redraw();

  WHILE dlgLegend.Visible DO
   idleProc(dlgLegend);
   RENEWDATALAYER();
   dlgLegend.Wait(1);
  END; (*  WHILE dlgLegend.Visible...*)
 END {OnClick_Legend};

 PRIVATE PROCEDURE OnClick_Renew(SLF: OBJECT);
 BEGIN
  RenewPage(1);
 END {OnClick_Renew};

 PRIVATE PROCEDURE OnClick_Close(SLF: OBJECT);
 BEGIN
  L_GUI.SetTaskBarVisible(1);
  dlg.Visible:=0;
 END {OnClick_Close};

 PRIVATE PROCEDURE PutControlButton(Id,
                                    Text : STRING[];
                                    Left,
                                    Top  : NUMERIC[0];
                                    Proc : PROC);
 BEGIN
  L_GUI.put_Button(dlg, p_Main, Id, Text,
                   Left, Top, sW_ControlBut * ScaleX, sH_ControlBut * ScaleY,
                   16 * ScaleY, L_GUI.fn_Default,
                   Proc);
 END {PutControlButton};

 PRIVATE PROCEDURE CreateMainPage();
  CONST
  VAR
   pT, pL,
   Amount,
   sW_ButGroup,
   pT_ControlBut,
   pL_ControlBut,
   sH_Prompt,
   sH_SpcRprButBorder: NUMERIC[0];
   sH_ControlButBorder,
   sW_ControlButSpace: NUMERIC[0];
   Local             : PROC;
   begRprPlace,
   endRprPlace       : LIKE(RprPlace.RprPlace);
 BEGIN
  sH_SpcRprButBorder :=50;
  sH_ControlButBorder:=sH_SpcRprButBorder * ScaleY;
  sW_ControlButSpace :=20;
  sH_Prompt          :=20 * ScaleY;
  L_GUI.put_StaticText(dlg, p_Main, "id_Title", E_GetRprShowTitle() + " " + P_Firm.FP_FirmShortName(P_Firm.OWN_FIRM, SYSDATE()),
                       pL_Title, pT_Title, sW_Title, sH_Title,
                       fs_Title * ScaleY, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_ThinRidge);

  L_GUI.put_StaticText(dlg, p_Main, id_Clock, "",
                       pL_Clock, pT_Clock, sW_Clock, sH_Clock,
                       fs_Clock * ScaleY, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_ThinRidge);

  Amount     :=Math.Trunc((sW_Most - 20) / (sW_RprBBut_H + SpaceBtwBtns));
  sW_ButGroup:=sW_RprBBut_H * Amount + SpaceBtwBtns * (Amount - 1);

  IF !PROCREF(E_RprSh.WaitRprAndReadyButtonInUserDefinePosition) THEN
   pT         :=pB_Most - (sH_SpcRprButBorder + sH_MainShift +
                           sH_SpcRprButBorder + sH_MainShift +
                           sH_ControlButBorder + sH_MainShift +
                           sH_Prompt);
   pL         :=pL_Most + 10 + (sW_Most - 20 - sW_ButGroup) / 2;
   begRprPlace:=0001;
   endRprPlace:=begRprPlace + Amount - 1;
   PutFrame("  ६", pL_Most, pT, sW_Most, sH_SpcRprButBorder);
   _PutButtonGroup(begRprPlace + ".." + endRprPlace,
                   pL, pT + 20, bo_Horizontal,   gb_Horizontal, "", rbc_Wait, "  ६");
 
   pT         :=pT + sH_SpcRprButBorder + sH_MainShift;
   begRprPlace:=endRprPlace + 1;
   endRprPlace:=begRprPlace + Amount - 1;
   PutFrame("⮢ ⮡", pL_Most, pT, sW_Most, sH_SpcRprButBorder);
   _PutButtonGroup(begRprPlace + ".." + endRprPlace,
                   pL, pT + 20, bo_Horizontal,   gb_Horizontal, "", rbc_Ready, "⮢");
  END;

  pT         :=pB_Most - sH_ControlButBorder - sH_MainShift - sH_Prompt;
  L_GUI.put_Border(dlg, p_Main, "st_ControlButBorder",
                   pL_Most, pT, sW_Most, sH_ControlButBorder);
  Local:=PROCREF(E_RprSh.PutControlsButton);
  IF !Local THEN
   pL_ControlBut:=sW_Most - (sW_ControlBut * 3 + sW_ControlButSpace * 2 + 10) * ScaleX;
   pT_ControlBut:=pT + (sH_ControlButBorder / 2 - sH_ControlBut * ScaleY / 2);

   PutControlButton("id_Legend",  "",                       pL_ControlBut, pT_ControlBut, PROCREF(OnClick_Legend));
   INC(pL_ControlBut, (sW_ControlBut + sW_ControlButSpace) * ScaleX);
   PutControlButton(id_Renew,     GetRenewButtonText(RenewPeriod), pL_ControlBut, pT_ControlBut, PROCREF(OnClick_Renew));
   INC(pL_ControlBut, (sW_ControlBut + sW_ControlButSpace) * ScaleX);
   PutControlButton("id_Close",   "",                       pL_ControlBut, pT_ControlBut, PROCREF(OnClick_Close));
  ELSE
   Local();
  END;

  pT:=pT + sH_ControlButBorder + sH_MainShift;
  L_GUI.put_StaticText(dlg, p_Main, id_Prompt, "",
                       pL_Most, pT, sW_Most, sH_Prompt,
                       fs_Prompt * ScaleY, CONTROL.HorizontalAlignment_Left,  L_GUI.br_st_ThinRidge);

  E_RprSh.PutButtonTable(dlg);
 END {CreateMainPage};

 PRIVATE PROCEDURE CheckExistRealRprPlace();
  VAR
   Msg: STRING[];
 BEGIN
  IF L_General.IsProgrammer() THEN
   SETEMPTY(Msg);
   SELECT(RprPlace, RprPlace);
   WHILE OCCURE(RprPlace) DO
    PROMPT("஢ઠ " + RprPlace.RprPlace);
    IF L_DatTim.IsActive(SYSDATE(), RprPlace.Begin, RprPlace.Till) THEN
     IF  ((RprPlace.Kind # L_Rpr.rpk_Zone) & ~SEARCH(ARprB, RprPlace, 1, RprPlace.RprPlace)) |
         ((RprPlace.Kind = L_Rpr.rpk_Zone) & ~SELECT(ARprB, ZonePlc,  0, RprPlace.RprPlace)) THEN
      Msg:=Msg + RprPlace.RprPlace + " " + RprPlace.Name + "|";
     END;
    END;
    NEXT(RprPlace);
   END; (* WHILE OCCURE(RprPlace) ... *)

   IF ~!Msg THEN
    L_StdFrm.CustomQuestion(" ⨭ ६   ॠ |" +
                            Msg);
   END;
  END;
 END {CheckExistRealRprPlace};

 PRIVATE PROCEDURE Create_ARprB();
 BEGIN
  L_AFM.ssrf_Register("ARprB", "ARprB");
  CreateFILE(ARprB, "", "६ 䠩 -  ६  ( ⨭)", "");

  CreateFIELD(ARprB, RprBay,   STRING[6], "", "", "", "", "");
  CreateFIELD(ARprB, Real,     SCAL[2], "", "", "", " ", "");
  CreateFIELD(ARprB, ZonePlc,  LIKE(RprPlace.RprPlace), "", "", "", "", "");
  CreateFIELD(ARprB, Cluster,  tRprBayCluster, "", "", "", " ()", "");
  CreateFIELD(ARprB, RprPlace, LIKE(RprPlace.RprPlace), "", "", "", "", "");
  CreateFIELD(ARprB, Name,     STRING[64], "", "", "", " ", "");
  CreateFIELD(ARprB, Capacity, NUMERIC[0], "", "1", "", "⨬ ", "");

  CreateINDEX(ARprB, RprBay,   UNIQUE, "", "", RprBay);
  CreateINDEX(ARprB, Cluster,  PLURAL, "", "", Real, Cluster, RprPlace);
  CreateINDEX(ARprB, ZonePlc,  PLURAL, "", "", Real, ZonePlc, RprPlace);
  CreateINDEX(ARprB, RprPlace, UNIQUE, "", "", Real, RprPlace);

  SetVersionOfFILE(ARprB, 1);
  L_AFM.AF_CreateTemp("ARprB", "ARprB");
 END {Create_ARprB};

 PRIVATE PROCEDURE CreateDialog();
  VAR
   dlgWidth,
   dlgHeight: NUMERIC[0];
 BEGIN
  PROMPT("⮢ 㠫 ꥪ⮢");
  E_SetRprShowParams(dlgWidth, dlgHeight);
  dlg                          :=L_GUI.CreateDialog(0);
  dlg.CaptionText              :=L_General.GetAPSiteID() + ' - "⮏"  ﭨ ६⭮ ';
  dlg.ShowMouseCursor          :=1;
  dlg.StandardClientWidth      :=dlgWidth;
  dlg.StandardClientHeight     :=dlgHeight;
  dlg.ToolTipMaxWidth          :=MaxToolTipWidth;
  dlg.BackgroundPicture        :=L_GUI.SoftLoadPicture(L_FIO.rf_GetFullFileName("RprShow_BackGround.jpg"));
  dlg.BackgroundPicturePosition:=DIALOG.BackgroundPicturePosition_Stretch;
  dlg.Redraw();

  dlg.WindowSizeStatus:=DIALOG.WindowSizeStatus_Maximized;
  dlg.OnClose         :=PROCREF(OnClose_Dialog);
  CreateMainPage();
  dlg.Prompt          :=dlg.Controls.Item(id_Prompt);
  CheckExistRealRprPlace();
 END {CreateDialog};

 PUBLIC PROCEDURE RprShow();
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   LOADMODULE(E_RprSh, E_RprSh);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_CantLoadModule THEN
    L_General.SetupRequired();
   ELSE
    RAISE();
   END;
  END; (* TRY *)
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Create_ARprB();
  CreateDialog();
  Create_TmpFiles();
  PlayDialog();
 END {RprShow};

 PUBLIC PROCEDURE StandOnRprSByRprS_1();
 BEGIN
  LIKEMENU(View, "RprS 1", CALL, "RprShow.StandOnRprSByRprS_2()");
 END {StandOnRprSByRprS_1};

 PUBLIC PROCEDURE StandOnRprSByRprS_2();
 BEGIN
  SEARCH(RprS, RprS, , CurrentRprS);
  SE_WZD_POSITION("RprS", 1, RprS);
  IF L_Rpr.CanModify(RprS.Location) THEN
   LIKEMENU(Edit, "@");
  ELSE
   LIKEMENU(ShowWin, "@");
  END;
 END {StandOnRprSByRprS_2};

END.
