(*
%Copyright   (c) Polak IT
%Author      27.04.2009 09:11:44 POLAK\LDA
%Purpose
%Type        report
%Specific    AP
%Modified    03.07.2014 10:25:14 POLAK\LDA
%Environment
*)

 MODULE RprSMM [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_MathR, L_Rpr, L_XObj, P_Firm, L_Car, L_DatTim, L_AFM, P_Storage,
        L_Stock, L_XDoc, L_MDoc, Memo, L_Str, L_Basis, P_Rpr, FIO, L_Money, L_StdFrm, L_bp;

(*
$P{ RprSMM_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
RprS.RprS, L, ""
RprS.OrdDate, L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                           ⭮-ᠫ줮  (  裡   )                          |
|------------------------------------------------------------------------------------------------------------|
|         #######  ##########                                                                 |
}
*)

(*
$P{ RprSMM_Top_Car:
Car.BoxNbr, L, ""
CarLog.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
@
|࠭ᯮ⭮ ।⢮ #### ########## #### #####################################                            |
}
*)

(*
$P{ RprSMM_Top_OutCar:
OutCar.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
Firm.Firm, L, ""
?, L, ""
?, L, ""
Contract.Contract, L, ""
Contract.Name, L, ""
Contract.SrcNbr, L, ""
@
|࠭ᯮ⭮ ।⢮ ########## #### #####################################                                 |
|ࠣ            #### #################################################### ############                |
|               ####### ################################################# . ##################|
}
*)

(*
$P{ RprSMM_Top_CarBlock:
Math.Math, L, ""
Math.Name, L, ""
CUCopy.Serial, L, ""
@
|                   ##### ################################################################################|
| ॣ        #########################################################                             |
}
*)

(*
$P{ RprSMM_Top_OutCBlc:
OutCBlc.OutCBlc, L, ""
OutCBlc.Serial, L, ""
Math.Math, L, ""
Math.Name, L, ""
Firm.Firm, L, ""
?, L, ""
?, L, ""
Contract.Contract, L, ""
Contract.Name, L, ""
Contract.SrcNbr, L, ""
@
|ॣ               ####### ᪮  ##################################################            |
|                   ##### ################################################################################|
|ࠣ            #### #################################################### ############                |
|               ####### ################################################# . ##################|
}
*)

(*
$P{ RprSMM_Top_Math:
Math.Math, L, ""
Math.Name, L, ""
@
|                   ##### ################################################################################|
}
*)

(*
$P{ RprSMM_SubTop:
Storage.Storage, L, ""
Storage.Name, L, ""
@
|============================================================================================================|
| ࠭ ####### ################################################################                     |
|------------------------------------------------------------------------------------------------------------|
|                                            |            |   |   |            |      ।     |      |
|                                         |        |||-----------------|-----------------|.  |
|                                            |            |   |   | ६| ଭ.| | ᠭ|ᠫ줮|
|--------------------------------------------|------------|---|---|--------|--------|--------|--------|------|
}
*)

(*
$P{ RprSMM_Line:
Math.Math, L, ""
Math.Name, L, ""
?, L, ""
?, R, ""
?, L, ""
L_MathR.DefaultMUnitSign(Math.Math), L, ""
?, R, "2."
?, R, "2."
?, R, "2."
?, R, "2."
?, R, "2."
@
|##### ######################################|# ##########|###|###|########|########|########|########|######|
}
*)

(*
$P{ RprSMM_Bot:
?, R, ""
@
|------------------------------------------------------------------------------------------------------------|
|⮣ ⮨ 祭  ६ :                                                ###################|
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE ConvValue(Qnt: L_XObj.tQnt): L_XObj.tQnt;
 BEGIN
  IF Qnt = 0 THEN
   RETURN L_General.EMPTY_NUMBER();
  ELSE
   RETURN Qnt;
  END;
 END {ConvValue};

 PRIVATE PROCEDURE CalcPrice(trgDate  : DATE;
                             trgMath  : LIKE(Math.Math);
                             trgMyFirm: LIKE(MyFirm.MyFirm);
                             trgMMode : LIKE(MMode.MMode)): NUMERIC[2];
  VAR
   Result: NUMERIC[2];
 BEGIN
  SETEMPTY(Result);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=L_MathR.GetANYMathPrice(trgDate, trgMath, trgMyFirm, L_MathR.MMode2PriceGrp(trgDate, trgMath, trgMMode));
  EXCEPT
  ON Exc: Exc_Root DO

  END;
  RETURN Result;
 END {CalcPrice};

 PRIVATE PROCEDURE IsViP(): SCAL[2];
 BEGIN
  RETURN (L_XDoc.ExtractXDocType(MathMvmnt.XDocId) = L_XDoc.xdt_MDoc) &
         (L_XDoc.ExtractXDocKindId(MathMvmnt.XDocId) = L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, L_MDoc.md_ViP));
 END {IsViP};

 PUBLIC PROCEDURE RprMM();
  CONST
   RepName = "RprMM";
  VAR
   Sign      : STRING[];
   trgStorage: LIKE(Storage.Storage);
   trgMath   : LIKE(Math.Math);
   trgMMode  : LIKE(MMode.MMode);
   trgDate   : DATE;
   trgXDocId : L_XDoc.tXDocId;
   _Dbt,
   OutSaldo,
   TotalFrRpr,
   TotalInRpr,
   _FrRpr,
   _Crd,
   _Crd_WO   : L_XObj.tQnt;
   Sum,
   Price,
   Value,
   SumByViP,
   TotalSum  : L_XObj.tSum;
   FirstPass : SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Rpr.AccessRprS();
  trgDate:=RprS.OrdDate;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, RprSMM_Top, RepName);
  L_Rpr.AccessOrigin();
  IF    L_Rpr.IsRprS_w_Car() THEN
   L_Car.StandOnCarLog(Car.BoxNbr, trgDate);
   L_Car.AccessMark(Car.BoxNbr, trgDate);
   MAKEPART(R, RprSMM_Top_Car);
  ELSIF L_Rpr.IsRprS_w_OutCar() THEN
   CONFORM(OutCar, Mark);
   CONFORM(OutCar, Firm);
   L_Rpr.StandOnRprContract(Firm.Firm, trgDate);
   MAKEPART(R, RprSMM_Top_OutCar, P_Firm.FP_FirmName(Firm.Firm, trgDate), P_Firm.FP_INN(Firm.Firm, trgDate));
  ELSIF L_Rpr.IsRprS_w_CarBlock() THEN
   MAKEPART(R, RprSMM_Top_CarBlock);
  ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
   CONFORM(OutCBlc, Math);
   CONFORM(OutCBlc, Firm);
   L_Rpr.StandOnRprContract(Firm.Firm, trgDate);
   MAKEPART(R, RprSMM_Top_OutCBlc, P_Firm.FP_FirmName(Firm.Firm, trgDate), P_Firm.FP_INN(Firm.Firm, trgDate));
  ELSIF L_Rpr.IsRprS_w_Math() THEN
   MAKEPART(R, RprSMM_Top_Math);
  ELSE
   L_General.CallUs(0);
  END;

  L_Rpr.intPrepareMathMovementByRprS(RprS.RprS, 0);
  SETZERO(TotalSum);
  SETZERO(TotalInRpr);
  SELECT(MathMvmnt, Storage);
  WHILE OCCURE(MathMvmnt) DO
   FirstPass:=1;
   NARROWSEL(MathMvmnt, Storage);
   SEARCH(Storage, Storage, , MathMvmnt.Storage);
   WHILE OCCURE(MathMvmnt) DO
    NARROWSEL(MathMvmnt, Math);
    trgMath:=MathMvmnt.Math;
    PROMPT(" " + trgMath);
    SEARCH(Math, Math, , trgMath);
    WHILE OCCURE(MathMvmnt) DO
     NARROWSEL(MathMvmnt, MMode);
     trgMMode:=MathMvmnt.MMode;
     SETZERO(_Dbt, _FrRpr, _Crd, _Crd_WO, OutSaldo, Sum);
     SETEMPTY(SumByViP);
     WHILE OCCURE(MathMvmnt) DO
      INC(_Dbt,     MathMvmnt.Dbt);
      INC(_Crd,     MathMvmnt.Crd);
      INC(_Crd_WO,  MathMvmnt.Crd_WO);

      IF L_Rpr.IsRestoreFromRepair(MathMvmnt.XDocId, trgMMode) THEN
       INC(_FrRpr, MathMvmnt.Dbt);
      END;

      IF IsViP() THEN
       IF !SumByViP THEN
        SETZERO(SumByViP);
       END;
       INC(SumByViP, MathMvmnt.DbtSum);
      END;
      IF MathMvmnt.Crd_WO # 0 THEN
       Price:=CalcPrice(MathMvmnt.Date, Math.Math, Storage.MyFirm, trgMMode);
       IF ~!Price THEN
        INC(Sum, Price * MathMvmnt.Crd_WO);
       END;
      END;
      INC(OutSaldo, MathMvmnt.Dbt-MathMvmnt.Crd-MathMvmnt.Crd_WO);
      NEXT(MathMvmnt);
     END; (* WHILE OCCURE(MathMvmnt) ... *)
     IF FirstPass THEN
      MAKEPART(R, RprSMM_SubTop);
      FirstPass:=0;
     END;

     INC(TotalSum, Sum);

     IF !SumByViP THEN
      IF _Crd_WO # 0 THEN
       Value:=Sum / _Crd_WO;
       Sign :="";
      ELSE
       Value:=CalcPrice(trgDate, Math.Math, Storage.MyFirm, trgMMode);
       Sign :="?";
      END;
     ELSE
      Value:=SumByViP;
      Sign :="!";
     END;

     MAKEPART(R, RprSMM_Line, Sign,
                              L_Money.MoneyToStr(trgDate, "", Value),
                              L_MathR.MModeStr(trgMMode),
                              ConvValue(_Dbt-_FrRpr),
                              ConvValue(_FrRpr),
                              ConvValue(_Crd),
                              ConvValue(_Crd_WO),
                              ConvValue(OutSaldo));
     NEXTINEXTENDEDSEL(MathMvmnt, MMode);
    END; (* WHILE OCCURE(MathMvmnt) ... *)
    NEXTINEXTENDEDSEL(MathMvmnt, Math);
   END; (* WHILE OCCURE(MathMvmnt) ... *)
   NEXTINEXTENDEDSEL(MathMvmnt, Storage);
  END; (* WHILE OCCURE(MathMvmnt) ... *)
  MAKEPART(R, RprSMM_Bot, L_Money.MoneyToStr(trgDate, "", TotalSum));
 END {RprMM};

 PRIVATE CONST
  idx_ByRprS    = 0;
  idx_ByStorage = 1;

(*
$P{ RprStorageInven_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Storage.Storage + " " + Storage.Name, C, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                            ਧ ⪮ ਠ 業⥩                              |
|############################################################################################################|
|                                             ########### #####                                            |
|------------------------------------------------------------------------------------------------------------|
|                                                                   |||     |      ||
|----------------------------------------------------------------------|---|---|----------|----------|-------|
}
*)

(*
$P{ RprStorageInven_Line:
Math.Math, L, ""
Math.Name, L, ""
?, L, ""
L_MathR.DefaultMUnitSign(Math.Math), L, ""
?, R, "2."
?, R, "2."
?, R, "2."
@
|##### ################################################################|###|###|##########|##########|#######|
}
*)

(*
$P{ RprStorageInven_Line2:
MathRst.RprS, L, ""
ConvValue(MathRst.Qnt[idx_ByRprS]), R, "2."
@
| #######                                                              |   |   |##########|          |       |
}
*)

(*
$P{ RprStorageInven_Line3:
@
| -------                                                              |   |   |          |          |       |
}
*)

(*
$P{ RprStorageInven_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE GatherByRprS(_Closed: SCAL[2]);
  VAR
   OutSaldo: L_XObj.tQnt;
   trgMath : LIKE(Math.Math);
   trgMMode: LIKE(MMode.MMode);
 BEGIN
  IF _Closed THEN
   SELECT(RprS, cStatus, , 1, L_Rpr.ms_NeedRate);
  ELSE
   SELECT(RprS, cStatus, , 0);
  END;
  WHILE OCCURE(RprS) DO
   PROMPT("ࠡ⪠  " + RprS.RprS);
   L_Rpr.intPrepareMathMovementByRprS(RprS.RprS, 0);
   SELECT(MathMvmnt, Storage, , Storage.Storage);
   WHILE OCCURE(MathMvmnt) DO
    NARROWSEL(MathMvmnt, Math);
    trgMath:=MathMvmnt.Math;
    WHILE OCCURE(MathMvmnt) DO
     NARROWSEL(MathMvmnt, MMode);
     trgMMode:=MathMvmnt.MMode;
     SETZERO(OutSaldo);
     WHILE OCCURE(MathMvmnt) DO
      INC(OutSaldo,   MathMvmnt.Dbt-MathMvmnt.Crd-MathMvmnt.Crd_WO);
      NEXT(MathMvmnt);
     END; (* WHILE OCCURE(MathMvmnt) ... *)
     IF OutSaldo # 0 THEN
      ADD(MathRst, MathRst, , trgMath, trgMMode, RprS.RprS,
          MathRst.Qnt[idx_ByRprS],    OutSaldo,
          MathRst.Qnt[idx_ByStorage], 0);
     END;
     NEXTINEXTENDEDSEL(MathMvmnt, MMode);
    END; (* WHILE OCCURE(MathMvmnt) ... *)
    NEXTINEXTENDEDSEL(MathMvmnt, Math);
   END; (* WHILE OCCURE(MathMvmnt) ... *)
   L_Rpr.PurgeMathMvmnt();
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
 END {GatherByRprS};

 PRIVATE PROCEDURE GatherByStorage();
  VAR
   P: DATE;
 BEGIN
  P:=L_DatTim.IncMonth(L_DatTim.Per(SYSDATE()), +1);
  L_MathR.amm_Init(P);
  L_MathR.mr_Init();
  CALL(MS_Rest.mRst1_Gather(P, 0));

  SELECT(mRst1, Math);
  WHILE OCCURE(mRst1) DO
   NARROWSEL(mRst1, Math, AcCut);
   PROMPT(" :  " + mRst1.Math);
   WHILE OCCURE(mRst1) DO
    ADD(MathRst, MathRst, , mRst1.Math, L_MathR.amm_GetMMode(mRst1.MathType, mRst1.AcCut), L_General.EMPTY_NUMBER(),
        MathRst.Qnt[idx_ByRprS],    0,
        MathRst.Qnt[idx_ByStorage], mRst1.Qnt);
    NEXT(mRst1);
   END; (* WHILE OCCURE(mRst1) ... *)
   NEXTINEXTENDEDSEL(mRst1, Math, AcCut);
  END; (* WHILE OCCURE(mRst1) ... *)
  L_MathR.amm_DeInit();
 END {GatherByStorage};

 PRIVATE PROCEDURE CheckUnDoneMDoc(trgMath: LIKE(Math.Math));
  VAR
   HasUnDoneMDoc: SCAL[2];
 BEGIN
  HasUnDoneMDoc:=0;
  SETSEL(MDocList, Math, trgMath);
  LAST(MDocList);
  WHILE OCCURE(MDocList) & ~HasUnDoneMDoc DO
   IF (MDocList.MDocKind = L_MDoc.md_MSP) |
      (MDocList.MDocKind = L_MDoc.md_NOV) |
      (MDocList.MDocKind = L_MDoc.md_TOV) THEN
    CONFORM(MDocList, MDoc);
    IF (MDoc.Status = L_MDoc.st_Passed) & ~MDoc.Done THEN
     HasUnDoneMDoc:=1;
    END;
   END;
   PREV(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  IF HasUnDoneMDoc THEN
   L_StdFrm.Inform(" ࠡ⠭ . ⮪ 㤥 ⫨  ⭮");
  END;
 END {CheckUnDoneMDoc};

 PRIVATE PROCEDURE PrintRep(RepName: STRING[]);
  VAR
   trgMath               : LIKE(Math.Math);
   trgMMode              : LIKE(MMode.MMode);
   TotalQnt              : L_XObj.tQnt[2];
   HasNoRprS,
   AlreadyCheckUnDoneMDoc: SCAL[2];
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, RprStorageInven_Top, RepName);

  AlreadyCheckUnDoneMDoc:=0;
  SELECT(MathRst, MathRst);
  WHILE OCCURE(MathRst) DO
   NARROWSEL(MathRst, Math, MMode);
   trgMath :=MathRst.Math;
   trgMMode:=MathRst.MMode;
   PROMPT("  " + MathRst.Math);
   SETZERO(TotalQnt);
   WHILE OCCURE(MathRst) DO
    INC(TotalQnt[idx_ByRprS],    MathRst.Qnt[idx_ByRprS]);
    INC(TotalQnt[idx_ByStorage], MathRst.Qnt[idx_ByStorage]);
    NEXT(MathRst);
   END; (* WHILE OCCURE(MathRst) ... *)
   SEARCH(Math, Math, , trgMath);

   MAKEPART(R, RprStorageInven_Line, L_MathR.MModeStr(trgMMode),
                                     ConvValue(TotalQnt[idx_ByRprS]),
                                     ConvValue(TotalQnt[idx_ByStorage]),
                                     ConvValue(TotalQnt[idx_ByRprS] - TotalQnt[idx_ByStorage]));
   IF ((TotalQnt[idx_ByRprS] - TotalQnt[idx_ByStorage]) # 0) & ~AlreadyCheckUnDoneMDoc THEN
    CheckUnDoneMDoc(trgMath);
    AlreadyCheckUnDoneMDoc:=1;
   END;

   HasNoRprS:=1;
   SAVE(MathRst);
   SELECT(MathRst, MathRst, , trgMath, trgMMode);
   WHILE OCCURE(MathRst) DO
    PROMPT("  " + MathRst.Math);
    IF ~!MathRst.RprS THEN
     HasNoRprS:=0;
     MAKEPART(R, RprStorageInven_Line2);
    END;
    NEXT(MathRst);
   END; (* WHILE OCCURE(MathRst) ... *)
   IF HasNoRprS THEN
    MAKEPART(R, RprStorageInven_Line3);
   END;

   RESTORE(MathRst);
   NEXTINEXTENDEDSEL(MathRst, Math, MMode);
  END; (* WHILE OCCURE(MathRst) ... *)

  MAKEPART(R, RprStorageInven_Bot);
  L_General.SurveyLastReport();
 END {PrintRep};

 PUBLIC PROCEDURE RprSI();
  CONST
   RepName = "RprSI";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Storage), " ࠭ ");
  L_General.Assert(L_Rpr.RprLev(SYSDATE()) = L_Rpr.rprl_Active, "㯭  稨 ⥬ 'ࠢ ६ ᮬ'");
  L_General.Assert(P_Storage.IsRepair(Storage.Storage, Memo.ud_me()), " ନ ⮫쪮    ''");
  L_AFM.MakeMultipleIndex("MathRst", "RprS  : LIKE(RprS.RprS);" +
                                     "Math  : LIKE(Math.Math);" +
                                     "MMode : LIKE(MMode.MMode);"+
                                     "Qnt   : NUMERIC[3][2]",
                          "MathRst:Math,MMode,RprS");
  GatherByStorage();

  GatherByRprS(0);
  GatherByRprS(1);

  PrintRep(RepName);
 END {RprSI};

 PRIVATE PROCEDURE MakeHeader(F: STRING[]; ServiceCenterRprS: SCAL[2]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " 砫 ६");
  L_Basis.wb_WrInQM(F, " 砭 ६");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ꥪ ६");
  L_Basis.wb_WrInQM(F, "ꥪ ६");
  IF ServiceCenterRprS THEN
   L_Basis.wb_WrInQM(F, "᭮");
   L_Basis.wb_WrInQM(F, "ઠ");
   L_Basis.wb_WrInQM(F, "ઠ");
   L_Basis.wb_WrInQM(F, "஡");
  ELSE
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "᪮ ");
  END;
  L_Basis.wb_WrInQM(F, "ࠣ⒨");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, " ६");
  L_Basis.wb_WrInQM(F, "⪠ ଠ  ");
  L_Basis.wb_WrInQM(F, "⮨ ࠡ");
  L_Basis.wb_WrInQM(F, "⮨ ⥩");
  L_Basis.wb_WrInQM(F, "⮭宦");
  L_Basis.wb_WrInQM(F, "筠 㤮 ࠡ");
  L_Basis.wb_WrInQM(F, "᪮ ६ ࠡ");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE GetRprJBaseTime(): NUMERIC[3];
  VAR
   Result: NUMERIC[0];
 BEGIN
  SETZERO(Result);
  SELECT(RprJ, RprS, , RprS.RprS);
  WHILE OCCURE(RprJ) DO
   IF ~!RprJ.BaseTime THEN
    INC(Result, RprJ.BaseTime * RprJ.ComplCfc * RprJ.Quantity);
   END;
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ) ... *)
  RETURN Result;
 END {GetRprJBaseTime};

 PRIVATE PROCEDURE GetRprJFactTime(): NUMERIC[3];
  VAR
   Result: NUMERIC[0];
 BEGIN
  SETZERO(Result);
  SELECT(RprJ, RprS, , RprS.RprS);
  WHILE OCCURE(RprJ) DO
   IF ~!RprJ.EDate THEN
    INC(Result, L_Rpr.dti_GetDuration(RprJ.BDate, RprJ.BTime, RprJ.EDate, RprJ.ETime));
   END;
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ) ... *)
  RETURN Result;
 END {GetRprJFactTime};

 PRIVATE PROCEDURE GetRprSKind_asStr(): STRING[];
  VAR
   Amount         : NUMERIC[0];
   trgRprTTaskKind: LIKE(RprT.TaskKind);
 BEGIN
  SETZERO(Amount);
  SETEMPTY(trgRprTTaskKind);
  SELECT(RprT, RprS, , RprS.RprS);
  WHILE OCCURE(RprT) DO
   trgRprTTaskKind:=RprT.TaskKind;
   INC(Amount);
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT) ... *)
  IF Amount > 1 THEN
   SETEMPTY(trgRprTTaskKind);
  END;
  IF ~!trgRprTTaskKind THEN
   RETURN L_Str.PoolItem(L_Rpr.rpr_TaskKind_Pool, trgRprTTaskKind);
  ELSE
   RETURN "";
  END;
 END {GetRprSKind_asStr};

 PRIVATE PROCEDURE MakePart(F: STRING[]; RepairSum, MathSum: NUMERIC[2]; ServiceCenterRprS: SCAL[2]);
  VAR
   trgRun     : LIKE(CarRun.TotRun);
   trgSerial  : STRING[];
   trgStateNbr: LIKE(Car.StateNbr);
 BEGIN
  L_Basis.wb_WrScl(F, RprS.RprS);
  L_Basis.wb_WrDat(F, RprS.OrdDate);
  L_Basis.wb_WrDat(F, RprS.EDate);
  L_Basis.wb_WrStr(F, L_Rpr.GetRprSStatus_AsStr(RprS.Status));
  L_Basis.wb_WrStr(F, L_Rpr.GetRprObjT_AsStr());
  L_Basis.wb_WrScl(F, RprS.RprObjId);
  IF ServiceCenterRprS THEN
   L_Rpr.AccessMark(RprS.OrdDate);
   IF    L_Rpr.IsRprS_w_Car() THEN
    SEARCH(Firm, Firm, , L_Car.GetFirmOfCar(RprS.OrdDate));
    L_Car.StandOnCarLog(Car.BoxNbr, RprS.OrdDate);
    trgStateNbr:=CarLog.StateNbr;
    trgRun     :=L_Car.GetAccurateRunOnDate(Car.BoxNbr, RprS.OrdDate);
   ELSIF L_Rpr.IsRprS_w_OutCar() THEN
    CONFORM(OutCar, Firm);
    trgStateNbr:=OutCar.StateNbr;
    trgRun     :=RprS.SMBef;
   ELSE
    L_General.CallUs(0);
   END;
   L_Basis.wb_WrStr(F, trgStateNbr);
   L_Basis.wb_WrScl(F, Mark.Mark);
   L_Basis.wb_WrStr(F, Mark.Name);
   L_Basis.wb_WrNum(F, trgRun, 0);
  ELSE
   L_Rpr.AccessOrigin();
   IF    L_Rpr.IsRprS_w_CarBlock() THEN
    P_Firm.AccessFirm(L_MathR.GetFirmOfMath());
    trgSerial:=CUCopy.Serial;
   ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
    CONFORM(OutCBlc, Math);
    CONFORM(OutCBlc, Firm);
    trgSerial:=OutCBlc.Serial;
   ELSIF L_Rpr.IsRprS_w_Math() THEN
    P_Firm.AccessFirm(L_MathR.GetFirmOfMath());
    SETEMPTY(trgSerial);
   ELSE
    L_General.CallUs(0);
   END;
   L_Basis.wb_WrScl(F, Math.Math);
   L_Basis.wb_WrStr(F, Math.Name);
   L_Basis.wb_WrStr(F, CUCopy.CUCopy);
   L_Basis.wb_WrStr(F, trgSerial);
  END;
  L_Basis.wb_WrStr(F, P_Firm.GetPartnerType_AsStr(P_Firm.FP_PrtnrTyp(Firm.Firm, RprS.OrdDate)));
  L_Basis.wb_WrScl(F, Firm.Firm);
  L_Basis.wb_WrStr(F, Firm.Name);
  IF ServiceCenterRprS THEN
   IF L_Rpr.HasRprTask(L_Rpr.tk_Servicing1, L_General.EMPTY_NUMBER()) |
      L_Rpr.HasRprTask(L_Rpr.tk_Servicing2, L_General.EMPTY_NUMBER()) THEN
    L_Basis.wb_WrStr(F, "");
   ELSE
    L_Basis.wb_WrStr(F, "");
   END;
  ELSE
   L_Basis.wb_WrStr(F, GetRprSKind_asStr());
  END;

  L_Basis.wb_WrStr(F, P_Rpr.GetShortRprSDescr(RprS.RprS));
  L_Basis.wb_WrNum(F, RepairSum, 2);
  L_Basis.wb_WrNum(F, MathSum,   2);
  L_Basis.wb_WrStr(F, L_Rpr.GetRprSLocation_AsStr(RprS.Location));
  L_Basis.wb_WrNum(F, GetRprJBaseTime(), 3);
  L_Basis.wb_WrNum(F, GetRprJFactTime(), 3);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE GetRepairSums(VAR MathSum, RepairSum: NUMERIC[2]);
  VAR
   i                 : NUMERIC[0];
   _XDocId           : L_XDoc.tXDocId;
   RprSDependentMDocs: STRING[];
 BEGIN
  SETZERO(MathSum, RepairSum);
  IF    L_Rpr.IsRprS_w_OutCar() | L_Rpr.IsRprS_w_OutCBlc() THEN
   RprSDependentMDocs:=L_XDoc.GetDependentXDC(L_XDoc.XDocId(L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS), L_XDoc.xdt_MDoc);
   i  :=0;
   WHILE L_XDoc.xdc_PositionOn(RprSDependentMDocs, i) DO
    CONFORM(MDoc, MDocKind);
    IF (MDoc.Status # L_MDoc.st_Canceled) &
       ((MDocKind.MDocKind = L_MDoc.md_IsS) | (MDocKind.MDocKind = L_MDoc.md_RPr)) THEN
     CONFORM(MDoc, MDocList);
     WHILE OCCURE(MDocList) DO
      IF L_MathR.IsInventories(MDocList.Math) THEN
       INC(MathSum,   MDocList.Sum + MDocList.VAT);
      ELSE
       INC(RepairSum, MDocList.Sum + MDocList.VAT);
      END;
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList) ... *)
    END; (* IF (MDocKind.MDocKind = _MDocKind) &...*)
    INC(i);
   END; (* WHILE L_XDoc.xdc_PositionOn ... *)
  ELSIF L_Rpr.IsRprS_w_Car() | L_Rpr.IsRprS_w_Math() THEN
   L_Rpr.PrepareMayBePaidMDocData(RprS.OrdDate, 0, 1);
   SELECT(_MBPM, _MBPM);
   WHILE OCCURE(_MBPM) DO
    IF L_MathR.IsInventories(_MBPM.Math) THEN
     INC(MathSum,   _MBPM.Sum + _MBPM.VAT);
    ELSE
     INC(RepairSum, _MBPM.Sum + _MBPM.VAT);
    END;
    NEXT(_MBPM);
   END; (* WHILE OCCURE(_MBPM) ... *)
   L_Rpr.Purge_MBPM();
   L_Rpr.PurgeMathMvmnt();
  END;
 END {GetRepairSums};

 PRIVATE PROCEDURE PrintOneRprS(F: STRING[]; ServiceCenterRprS: SCAL[2]);
  VAR
   MathSum, RepairSum: NUMERIC[2];
 BEGIN
  GetRepairSums(MathSum, RepairSum);
  MakePart(F, RepairSum, MathSum, ServiceCenterRprS);
 END {PrintMakeOneRprS};

 PRIVATE PROCEDURE MakeRep(bpId, Name: STRING[]; ServiceCenterRprS: SCAL[2]);
  VAR
   BPer, EPer: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  BPer:=Memo.ud_fr();
  EPer:=Memo.ud_ut();
  L_bp.Begin(bpId, Name, L_bp.t_Basis, L_General.timeCond_InIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R", ServiceCenterRprS);
  SETSEL(RprS, cOrdDate, 1);
  SRCINSEL(RprS, GE, , BPer);
  WHILE OCCURE(RprS) & (RprS.OrdDate <= EPer) DO
   PROMPT(RprS.RprS + " " + L_DatTim.DateStr(RprS.OrdDate));
   IF (RprS.Status # L_Rpr.ms_Cancel) &
      ((ServiceCenterRprS  & L_Rpr.IsServiceCenterLocation(RprS.Location))  |
       (~ServiceCenterRprS & L_Rpr.IsWorkshopLocation(RprS.Location))) THEN
    PrintOneRprS("R", ServiceCenterRprS);
   END;
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
  FIO.Close(R);
  L_bp.End();
 END {MakeRep};

 PUBLIC PROCEDURE Rpr24();
 BEGIN
  MakeRep("Rpr24", " ࠡ ࢨ 業஢", 1);
 END {Rpr24};

 PUBLIC PROCEDURE Rpr29();
 BEGIN
  MakeRep("Rpr29", " ࠡ  ६ ॣ⮢", 0);
 END {Rpr29};

END.
