(*
%Copyright   (c) Polak Computer System
%Author      07.09.1994 18:26:18 GINA
%Purpose     ஫  RtMStop
%Type        control
%Specific    AP
%Modified    04.04.2013 12:59:09 POLAK\GAV
*)

 MODULE RtMStop [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_StdFrm, L_Way, E_Way, L_Str;

 PUBLIC PERMANENT VAR
  v_RtMVer: L_Way.v_Arr;

 PUBLIC PROCEDURE RecountRoutMod();
  VAR
   i     : NUMERIC[0];
   _Speed: LIKE(Route.MaxSpeed);
 BEGIN
  SELECT(RtMStop, Route, , RoutMod.Route, RoutMod.Modif);
  SETZERO(RoutMod.TimSign, RoutMod.Run, RoutMod.Tim, RtMStop.RDis, RtMStop.RTim);
  WHILE OCCURE(RtMStop) DO
   INC(RoutMod.Run, RtMStop.RDis);
   CONFORM(RtMStop, Stop);
   INC(RoutMod.TimSign[Stop.Sign], RtMStop.RTim[0]);
   RtMStop.ADis:=RoutMod.Run;
   i:=0;
   WHILE i <= HIGH(RoutMod.Tim) DO
    INC(RoutMod.Tim[i], RtMStop.RTim[i] + RtMStop.DTim[i]);
    IF RtMStop.RTim[i] > 0 THEN
     _Speed:=RtMStop.RDis / (RtMStop.RTim[i] / 60);
     CONFORM(RoutMod, Route);
     L_General.Assert(_Speed <= Route.MaxSpeed,
                      "। ᪮ "+FLDTOSTR(_Speed, "0", 0)+
                      " /|  ⨬  ");
    END;
    INC(i);
   END; (* WHILE i <= HIGH(RoutMod.Tim)...*)
   RtMStop.ATim:=RoutMod.Tim;
   REPLACE(RtMStop);
   NEXT(RtMStop);
  END; (* WHILE OCCURE(RtMStop ... *)
  REPLACE(RoutMod);
 END {RecountRoutMod};

 PRIVATE PROCEDURE CheckSEJMStopAfterRtMStopModification(): SCAL[2];
  VAR
   oPrompt: PROMPT_LINE;
 BEGIN
  oPrompt:=PROMPT_LINE.Create("஢ઠ");
  SELECT(SEJobs, RoutMod, , RoutMod.Route, RoutMod.Modif);
  WHILE OCCURE(SEJobs) DO
   PROMPT(SEJobs.Trip);
   IF SELECT(SEJMStop, Trip, SEJobs.Trip) THEN
    SELECT(RtMStop, Route, , RoutMod.Route, RoutMod.Modif);
    LOOP
     IF ~OCCURE(SEJMStop) & ~OCCURE(RtMStop) THEN
      EXIT;
     ELSIF ~OCCURE(SEJMStop) | ~OCCURE(RtMStop) | (SEJMStop.Stop # RtMStop.Stop) THEN
      RETURN 0;
     END;
     NEXT(SEJMStop);
     NEXT(RtMStop);
    END;
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
  RETURN 1;
 END {CheckSEJMStopAfterRtMStopModification};

 PRIVATE PROCEDURE RtMStop_OnAfterModificationEvent();
  VAR
   RtMVerPool: STRING[];
   i         : NUMERIC[0];
 BEGIN
  SAVE(RtMStop);
  IF ~CheckSEJMStopAfterRtMStopModification() THEN
   L_StdFrm.Choice("|室 " + SEJobs.Exit + ", ३ " + SEJobs.Trip + " (, , 㣨)" +
                   L_StdFrm.HR() +
                   "| 筥 ६  祭 ⠭" +
                   "| ᮮ⢥  ⠭ 䨪樨 ." +
                   L_StdFrm.HR() +
                   "|  믮 筥 ६   ⮬ ३.|");
  END;
  RESTORE(RtMStop);

  SAVE(RoutMod);
  SAVE(RtMStop);
  IF OCCURE(RtMStop) THEN
   CONFORM(RtMStop, Stop, RoutMod);
   L_General.Assert((Stop.CP # 00) |
                    ~(RtMStop.CPActive[0] | RtMStop.CPActive[1]),
                    " ⠭    ⬥ ॡ ");
   IF RtMStop.RDis > 0 THEN
    RtMVerPool:=L_Way.E_GetRtMVerPool(RoutMod.FromD);
    IF !RtMVerPool THEN
     L_General.Assert(RtMStop.RTim[0] > 0, " 㪠 ६ ⭮⥫쭮 ।饩 ⠭");
    ELSE
     i:=0;
     WHILE ~!L_Str.PoolItem(RtMVerPool, i) DO
      L_General.Assert(RtMStop.RTim[i] > 0,
                       " 㪠 ६ ⭮⥫쭮 ।饩 ⠭ (" +
                       L_Str.PoolItem(RtMVerPool, i) + ")");
      INC(i);
     END;
    END;
   END; (* IF RtMStop.RDis > 0 ...*)
  END; (* IF OCCURE(RtMStop)... *)
  RecountRoutMod();
  RESTORE(RtMStop);
  RESTORE(RoutMod);
 END {RtMStop_OnAfterModificationEvent};

 PRIVATE PROCEDURE RoutMdEE_Init();
  VAR
   i         : NUMERIC[0];
   Fields    : FORMFIELDS;
   RtMVerPool: STRING[];
 BEGIN
  ACCESS(RoutMod);
  SETEMPTY(v_RtMVer, RtMVerPool);
  Fields    :=RTI.Get().CurZone.Fields;
  RtMVerPool:=L_Way.E_GetRtMVerPool(RoutMod.FromD);
  i:=0;
  IF ~!RtMVerPool THEN
   WHILE i <= HIGH(v_RtMVer) DO
    v_RtMVer[i]:=L_Str.PoolItem(RtMVerPool, i);
    Fields("RtMStop.RTim["+L_Str.IntStr(i)+"]").Modifiable:=~!v_RtMVer[i];
    Fields("RtMStop.DTim["+L_Str.IntStr(i)+"]").Modifiable:=~!v_RtMVer[i];
    INC(i);
   END; (* WHILE (i <= HIGH(v_RtMVer))...*)
  END; (* IF *)
  i:=0;
  WHILE i <= HIGH(v_RtMVer) DO
   IF !v_RtMVer[i] THEN
    v_RtMVer[i]:=" ";
   END;
   INC(i);
  END; (* WHILE (i <= HIGH(v_RtMVer))...*)
 END {RoutMdEE_Init};

 PRIVATE PROCEDURE RtMStop_OnBeforeEdit();
 BEGIN
  RoutMdEE_Init();
 END {RtMStop_OnBeforeEdit};

 PRIVATE PROCEDURE RtMStop_OnBeforeInsert();
 BEGIN
  SAVE(RtMStop);
  CHANGESEL(RtMStop, Route, , RtMStop.Route, RtMStop.Modif);
  IF ~PREV(RtMStop) THEN
   RESTORE(RtMStop);
   RtMStop.RDis:=0;
   REPLACE(RtMStop);
  ELSE
   RESTORE(RtMStop);
  END;
  RoutMdEE_Init();
 END {RtMStop_OnBeforeInsert};

 PRIVATE PROCEDURE RtMStop_OnAfterEdit();
 BEGIN
  RtMStop_OnAfterModificationEvent();
 END {RtMStop_OnAfterEdit};

 PRIVATE PROCEDURE RoutMod_OnAfterInsert();
        (* ! 뢠 ᫥ ⠢  ᨨ RoutMod ! *)
 BEGIN
  RtMStop_OnAfterModificationEvent();
 END {RoutMod_OnAfterInsert};

 PRIVATE PROCEDURE RoutMdEE_0_OnZoneOpen();
 BEGIN
  RoutMdEE_Init();
 END {RoutMdEE_0_OnZoneOpen};

 PRIVATE PROCEDURE RtMStop_OnAfterInsert();
 BEGIN
  RtMStop_OnAfterModificationEvent();
 END {RtMStop_OnAfterInsert};

 PRIVATE PROCEDURE RtMStop_OnAfterDelete();
 BEGIN
  RtMStop_OnAfterModificationEvent();
 END {RtMStop_OnAfterDelete};

 PRIVATE PROCEDURE RtMStop_Stop_OnSuccessfulChange();
 BEGIN
  IF ~!RtMStop.Stop THEN
   CONFORM(RtMStop, Stop);
   IF Stop.CP # 00 THEN
    RtMStop.CPActive[0]:=1;
    RtMStop.CPActive[1]:=1;
   END;
  END;
  REPLACE(RtMStop);
 END {RtMStop_Stop_OnSuccessfulChange};

 PRIVATE PROCEDURE RoutModE_1_OnSetSubwindow();
 BEGIN
  IF ACCESS(RoutMod) & ~!L_Way.E_GetRtMVerPool(RoutMod.FromD) THEN
   RTI.Get().CurZone.SubwindowOriginalName:="RoutMdEE";
  END;
 END {RoutModE_1_OnSetSubwindow};

BEGIN
 L_Events.ExecuteHandler();
END.
