(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     ࠢ ४஢ 楯窨
%Type        control
%Specific    AP
%Modified    11.08.2014 16:43:26 POLAK\Gina
%Environment
*)

 MODULE RWayChn [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Way, Str, L_General, L_StdFrm, L_DatTim, L_Env, L_SysLog,
        L_Events, L_BegRWS, L_XDoc, L_Car, L_AcsPnt, L_WDO, L_MDoc,
        L_APtm, L_Fuel;

 PRIVATE PROCEDURE RWayChn_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete]);
  L_WDO.iScsChange   (0, ["RWayS.TSN"]);
  L_WDO.iUnmodifiable(0, ["RWayS.ToPay", "RWayS.ToSheet", "RWayS.Type", "RWayS.Change", "RWayS.Gap",
                          "RWayS.SMBef", "RWayS.RemExit", "RWayS.CopyCnt", "RWayS.RWayS"]);
  L_WDO.iProgs       (0, "RWayChn");
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (1, ["RWayF.FuelTake", "RWayF.FuelRet"]);
  L_WDO.iUnmodifiable(1, ["RWayF.RemExit", "RWayF.Norm"]);
  L_WDO.iMayBeEmpty  (1, ["RWayF.RemEntr"]);
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).PermanentFilter:="(CarLog.Date<=RWayS.Date)&(CarLog.DateE>=RWayS.Date)";
 END {RWayChn_OnInitializeWindow};

 PRIVATE PROCEDURE RWayS_TSN_OnSuccessfulChange();
 BEGIN
  CALL(RWayS.extRWayS_TSN_OnSuccessfulChange());
 END {RWayS_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE ChangeChain_AccessPoint();
 BEGIN
  L_General.Assert(RWayS.Status >= L_Way.rwsStat_Taken,
                   "  믮 ⮫쪮  ਭ  ⠪஢ ⥢ ⮢");
  L_General.Assert(~RWayS.Done, "⥢  " + RWayS.RWayS + "    ࠡ⠭");
  L_AcsPnt.PassAccessPoint(0000001);
 END {ChangeChain_AccessPoint};

 PRIVATE PROCEDURE IsMixedRWayF(): SCAL[2];
  VAR
   Amount: NUMERIC[0];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   CONFORM(RWayS, Car);
   Amount:=0;
   SELECT(RWayF, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayF) DO
    IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) THEN
     INC(Amount);
    END; (* IF IsFuelInMix ... *)
    NEXT(RWayF);
   END; (* WHILE OCCURE(RWayF) ... *)
  EXCEPT
  END; (* TRY *)
  RETURN (Amount > 1);
 END {IsMixedRWayF};

 PRIVATE PROCEDURE intAfterChainChange();
  VAR
   _RemEntr: LIKE(RWayS.RemEntr);
   _SMAft  : LIKE(RWayS.SMAft);
 BEGIN
  SAVE   (RWayS);
  CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
  CALL(RWayS, L_Events.md_StreamMakeUnDone);
  CALL(RWayS.OnAfterChainChange(1));
  IF L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
   LOOP
    _RemEntr:=RWayS.RemEntr;
    _SMAft  :=RWayS.SMAft;
    IF ~NEXT(RWayS) | (RWayS.Status = L_Way.rwsStat_Ordered) THEN
     EXIT;
    END;
    CALL(RWayS, L_Events.md_StreamMakeUnDone);
    RWayS.RemExit:=_RemEntr;
    RWayS.SMBef  :=_SMAft;
    REPLACE(RWayS);
    IF RWayS.Status >= L_Way.rwsStat_Taken THEN
     CALL(RWayS.OnAfterChainChange(0));
    END;
    IF ~IsMixedRWayF() THEN
     EXIT;
    END;
   END; (* LOOP *)
  END; (* IF L_Env.RealBoxNbr(RWayS.BoxNbr) ... *)
  RESTORE(RWayS);
  L_Way.CurRWayS_XDocJrn_Mark(L_XDoc.action_ChainCor);
 END {intAfterChainChange};

 PUBLIC PROCEDURE AfterChainChange();
 BEGIN
  ChangeChain_AccessPoint();
  intAfterChainChange();
 END {AfterChainChange};

 PRIVATE PROCEDURE MakeChainBreak_SetDocument(_RemExit: LIKE(RWayS.RemExit); _SMBef: LIKE(RWayS.SMBef)): SCAL[2];
  CONST
   TripsNum = 2;
  VAR
   Trips        : LIKE(SEJobs.Trip)[TripsNum];
   _Date,
   _prvDate     : DATE;
   _StartTim,
   _prvStartTim : LIKE(RWayS.StartTim);
   _prvRemEntr  : LIKE(RWayS.RemEntr);
   _prvSMAft    : LIKE(RWayS.SMAft);
   _BoxNbr      : LIKE(RWayS.BoxNbr);
   i            : SCAL[TripsNum+1];
 BEGIN
  IF ~!_RemExit & ~!_SMBef THEN
   SETEMPTY(Trips);
   IF RWayS.RemExit # _RemExit THEN
    L_General.Assert(SEARCH(SEJobs, Trip, L_Way.E_TripForFuelChainBreak(RWayS.Date)),
                     " ஥ ३  ४஢ ");
    Trips[0]:=SEJobs.Trip;
   END;
   IF RWayS.SMBef # _SMBef THEN
    L_General.Assert(SEARCH(SEJobs, Trip, L_Way.E_TripForSMChainBreak(RWayS.Date)),
                     " ஥ ३  ४஢ ᯨ");
    Trips[1]:=SEJobs.Trip;
   END;
   IF    !Trips[0] & !Trips[1] THEN
    STDMSG("祬 祣  﫮?", INFORM);
    RETURN 0;
   END;
   CONFORM(SEJobs, StExit);
   SAVE(RWayS);
   CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
   L_General.Assert(PREV(RWayS), "  ⥢  設");
   L_General.Assert(RWayS.Status>=L_Way.rwsStat_Taken, "।騩    ਭ:  "+RWayS.RWayS);
   _prvDate    :=RWayS.Date;
   _prvStartTim:=RWayS.StartTim;
   _prvRemEntr :=RWayS.RemEntr;
   _prvSMAft   :=RWayS.SMAft;
   RESTORE(RWayS);
   _BoxNbr:=RWayS.BoxNbr;
   _Date  :=RWayS.Date;
   IF    _prvDate = _Date THEN
    _StartTim:=RWayS.StartTim-(RWayS.StartTim-_prvStartTim)/2;
   ELSIF RWayS.StartTim > 00:00 THEN
    _StartTim:=00:00;
   ELSE
    DEC(_Date);
    _StartTim:=23:59;
   END;
   DEFAULT(RWayS);
   RWayS.Date    :=_Date;
   RWayS.StartTim:=_StartTim;
   RWayS.TSN     :=L_Env.fictTSN;
   RWayS.BoxNbr  :=_BoxNbr;
   RWayS.Exit    :=StExit.Exit;
   RWayS.RemExit :=_prvRemEntr;
   RWayS.RemEntr :=_RemExit;
   RWayS.SMBef   :=_prvSMAft;
   RWayS.SMAft   :=_SMBef;
   RWayS.Gap     :=StExit.Gap;
   RWayS.Change  :=StExit.Change;
   RWayS.DspConn :=StExit.DspConn;
   RWayS.Type    :=StExit.Type;
   RWayS.Status  :=L_Way.rwsStat_Taken;
   RWayS.ToSheet :=0;
   RWayS.ToPay   :=0;
   L_BegRWS.INSERT_RWayS();
   L_Way.CurRWayS_XDocJrn_Mark(L_XDoc.action_AutoBuild);
   i:=0;
   WHILE i < TripsNum DO
    IF ~!Trips[i] THEN
     DEFAULT(RWayJ);
     RWayJ.RWayS  :=RWayS.RWayS;
     RWayJ.Day    :=C_L2D(_StartTim);
     RWayJ.StartT :=C_L2T(_StartTim);
     RWayJ.StopT  :=RWayJ.StartT+1/60;
     _StartTim    :=C_T2L(RWayJ.Day+(RWayJ.StopT<RWayJ.StartT), RWayJ.StopT);
     RWayJ.Trip   :=Trips[i];
     RWayJ.Quality:=000;
     RWayJ.Fact   :=1;
     RWayJ.Run    :=0;
     INSERT(RWayJ);
    END;
    INC(i);
   END;
   AfterChainChange();
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {MakeChainBreak_SetDocument};

 PUBLIC PROCEDURE MakeChainBreak();
  CONST
   BoxWidth = 48;
  VAR
   _RemExit: LIKE(RWayS.RemExit);
   _SMBef  : LIKE(RWayS.SMBef);
 BEGIN
  L_General.Assert(ACCESS(RWayS), " ⠭ ⥢ ");
  L_General.Assert(RWayS.Status > L_Way.rwsStat_Ordered, "⥢   뤠");
  _RemExit:=RWayS.RemExit;
  _SMBef  :=RWayS.SMBef;
  LOOP
   STDFORM("|   륧  ⥢ " +
           "|" + L_StdFrm.DrawLineInBox(Str.Align(" ⥢:" + RWayS.RWayS +
                                                  " :" + L_DatTim.DateStr(RWayS.Date) +
                                                  " :" + RWayS.BoxNbr, BoxWidth, CENTRE)) +
           "|" + L_StdFrm._DrawInBox(Str.Align(" %R4I        %R7I", BoxWidth-2-5, CENTRE),
                                     BoxWidth) +
           "|" + L_StdFrm.DrawButton("⬥", 16, "Z") + "      " + L_StdFrm.DrawButton("믮", 16, "B"),
           " ନ஢   ࠧ뢥 楯窨 ", STOP, , _RemExit, _SMBef);
   IF MakeChainBreak_SetDocument(_RemExit, _SMBef) THEN
    IF STDFORM("|ନ஢ ⥢  -   ࠧ뢥 楯窨"+
               "||" + L_StdFrm.DrawButton("", 16, "B") + "   " + L_StdFrm.DrawButton("ய", 16, "X"),
               , INFORM) # 0 THEN
     CALL(BegRWS, 083); (* RePrint *)
     CALL(BegRWS, 085); (*  *)
    END;
    EXIT;
   END;
  END;
 END {MakeChainBreak};

 PRIVATE PROCEDURE ResetRWaySStatus();
 BEGIN
  IF RWayS.Status > L_Way.rwsStat_Taken THEN
   L_StdFrm.OrdinaryCHOICE("⥢  㤥 ॢ  ﭨ '⠪஢'");
   RWayS.Status:=L_Way.rwsStat_Taken;
   REPLACE(RWayS);
  END;
 END {ResetRWaySStatus};

 PRIVATE PROCEDURE ResetRWayS();
  VAR
   _RemExit: LIKE(RWayS.RemExit);
   _SMBef  : LIKE(RWayS.SMBef);
   Asked   : SCAL[2];
 BEGIN
  IF L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
   _RemExit:=RWayS.RemExit;
   _SMBef  :=RWayS.SMBef;
   SAVE(RWayS);
   IF CHANGESEL(RWayS, BoxNbr, RWayS.BoxNbr) & PREV(RWayS) THEN
    IF _RemExit # RWayS.RemEntr THEN
     L_StdFrm.OrdinaryCHOICE("⮪    륧   ⥢ |"+
            " ᮢ  ⪮    ⥢ " + RWayS.RWayS+
            "| |⠭ 祭 ⪠    륧?");
     _RemExit:=RWayS.RemEntr;
    END;
    IF _SMBef # RWayS.SMAft THEN
     L_StdFrm.OrdinaryCHOICE(" ᯨ  륧   ⥢ |"+
           " ᮢ      ⥢ " + RWayS.RWayS +
           "| |⠭  ᯨ  륧?");
     _SMBef:=RWayS.SMAft;
    END;
   ELSE
    L_StdFrm.OrdinaryCHOICE(" ⥢   設?");
   END;
   RESTORE(RWayS);
   ResetRWaySStatus();
   RWayS.RemExit:=_RemExit;
   RWayS.SMBef  :=_SMBef;
  ELSE
   ResetRWaySStatus();
   SETZERO(RWayS.RemExit, RWayS.SMBef);
  END;
  L_BegRWS.REPLACE_RWayS();
  IF SELECT(RWayJ, RWayS, RWayS.RWayS) THEN
   L_StdFrm.OrdinaryCHOICE(" ⥢   㤠");
   Asked:=0;
   WHILE OCCURE(RWayJ) DO
    L_Way.RemoveSingleRWayJ(Asked);
   END;
  END;
 END {ResetRWayS};

 PRIVATE PROCEDURE SupportPrevBoxNbr();
 BEGIN
  SAVE(RWayS);
  IF SELECT(RWayS, BoxNbr, GE_PVALUE(RWayS.BoxNbr)) &
     SRCINSEL(RWayS, LE, GE_PVALUE(RWayS.Date), GE_PVALUE(RWayS.StartTim)) THEN
   IF RWayS.Status >= L_Way.rwsStat_Taken THEN
    intAfterChainChange();
   ELSE
    L_General.Assert(~L_Env.RealBoxNbr(RWayS.BoxNbr), "।騩    ਭ:  "+RWayS.RWayS);
   END;
  ELSE
   L_StdFrm.OrdinaryCHOICE("⥢   ।饩 設  ?");
  END;
  RESTORE(RWayS);
 END {SupportPrevBoxNbr};

 PRIVATE PROCEDURE SetAbilityEditStartParameterRWayS(_MayEdit: SCAL[2]);
 BEGIN
  L_WDO.SetFieldModifiable(     "RWayS.SMBef",   _MayEdit);
  L_WDO.SetFieldModifiable(     "RWayS.RemExit", _MayEdit);
  L_WDO.z_SetFieldModifiable(1, "RWayF.RemExit", _MayEdit);
 END {SetAbilityEditStartParameterRWayS};

 PRIVATE PROCEDURE IsFirstRWaySOnCar(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(RWayS);
  CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
  Result:=~PREV(RWayS);
  RESTORE(RWayS);
  RETURN Result;
 END {IsFirstRWaySOnCar};

 PRIVATE PROCEDURE RWayS_OnBeforeEdit();
 BEGIN
  ChangeChain_AccessPoint();
  IF IsFirstRWaySOnCar() THEN
   SetAbilityEditStartParameterRWayS(1);
  ELSE
   SetAbilityEditStartParameterRWayS(0);
  END;
 END {RWayS_OnBeforeEdit};

 PRIVATE PROCEDURE RWayS_OnAfterEdit();
  VAR
   rwsOrderChange: SCAL[2];
   xdc           : STRING[];
   i             : NUMERIC[0];
 BEGIN
  IF    (RWayS.BoxNbr # GE_PVALUE(RWayS.BoxNbr)) THEN
   L_StdFrm.OrdinaryCHOICE("  ࠦ ?!");

   xdc:=L_XDoc.GetDependentXDC(L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS), L_XDoc.xdt_MDoc);
   i:=0;
   WHILE ~!L_XDoc.xdc_Item(xdc, i) DO
    L_XDoc.PositionOnXDoc(L_XDoc.xdc_Item(xdc, i));
    L_General.Assert((MDoc.Status # L_MDoc.st_Passed) | (MDoc.BoxNbr = RWayS.BoxNbr),
                     " ࠦ   ᪠, ..    ࠢ|(" +
                     L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + ", ஢, ࠦ  " + MDoc.BoxNbr + ")");
    INC(i);
   END;

   L_Car.CheckAdaptability(RWayS.BoxNbr, RWayS.Date, 0);
   ResetRWayS();
   intAfterChainChange();
   SupportPrevBoxNbr();
  ELSIF (RWayS.Date # GE_PVALUE(RWayS.Date)) | (RWayS.StartTim # GE_PVALUE(RWayS.StartTim)) THEN
   SAVE(RWayS);
   CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
   IF PackTIMESTAMP(RWayS.Date, RWayS.StartTim) >
      PackTIMESTAMP(GE_PVALUE(RWayS.Date), GE_PVALUE(RWayS.StartTim)) THEN
    rwsOrderChange:=PREV(RWayS) &
                    (PackTIMESTAMP(RWayS.Date, RWayS.StartTim) >
                     PackTIMESTAMP(GE_PVALUE(RWayS.Date), GE_PVALUE(RWayS.StartTim)));
   ELSE
    rwsOrderChange:=NEXT(RWayS) &
                    (PackTIMESTAMP(RWayS.Date, RWayS.StartTim) <
                     PackTIMESTAMP(GE_PVALUE(RWayS.Date), GE_PVALUE(RWayS.StartTim)));
   END;
   RESTORE(RWayS);
   IF rwsOrderChange THEN
    L_StdFrm.CrucialChoice("   / ६ ⥢  ⠪," +
                           "|  冷 ᫥   ." +
                           "||⭮, ॡ 믮 '⠭ 楯窨'!", L_APtm.g_RWOp);
   ELSE
    L_StdFrm.Choice("   / ६ ⥢ ?!");
   END;
   ResetRWayS();
   intAfterChainChange();
  ELSIF RWayS.TSN # GE_PVALUE(RWayS.TSN) THEN
   ResetRWaySStatus();
   intAfterChainChange();
  ELSE
   intAfterChainChange();
  END;
  IF RWayS.Date # GE_PVALUE(RWayS.Date) THEN
   CONFORM(RWayS, WayLMen);
   WHILE OCCURE(WayLMen) DO
    WayLMen.RWayDate:=RWayS.Date;
    REPLACE(WayLMen);
    NEXT(WayLMen);
   END; (* WHILE OCCURE(... *)
  END;
  L_SysLog.SingleMark_AfterEdit("RWayS");
 END {RWayS_OnAfterEdit};

 PUBLIC PROCEDURE RestoreChain();
 BEGIN
  L_General.Assert(ACCESS(RWayS), " ⠭ ⥢ ");
  AfterChainChange();
 END {RestoreChain};

 PUBLIC PROCEDURE AfterRefMDocModify();
 BEGIN
  RestoreChain();
 END {AfterRefMDocModify};

BEGIN
 L_Events.ExecuteHandler();
END.
