(*
%Copyright   (c) Polak Computer System
%Author      22.01.1996 10:29:04 GINA
%Purpose     ࠢ 䨪樥   RWayCP
%Type        control
%Specific    AP
%Modified    25.10.2013 15:53:26 POLAK\GAV
%Environment
*)

 IMPORT Memo, L_General, L_DatTim, L_Events, L_Way, L_SCAD, Math, L_Str, L_r2r,
        L_StdFrm, Str, L_Prop, P_Route, DBD, L_WDO;

 CONST
  MaxShift = 99;

 PRIVATE PROCEDURE IsCorrectSCADValue(V: L_SCAD.tValue): SCAL[2];
  VAR
  i     : NUMERIC[0];
  _Value: STRING[4];
 BEGIN
  i:=0;
  _Value:=FLDTOSTR(V, "0000", 4);
  WHILE i < 4 DO
   IF ~L_Str.TestStrAlowChar(_Value[i], "07") THEN
    RETURN 0;
   END;
   INC(i);
  END;
  RETURN 1;
 END {IsCorrectSCADValue};

 PRIVATE PROCEDURE GetShiftByDaylightSavingTimeSwitch(TimeSwitchDate, D: DATE): NUMERIC[0];
 BEGIN
  IF L_DatTim.IsActive_Inc(TimeSwitchDate, StopCP.Date-1, D) &
     (L_DatTim.GetVARIANTDATE(StopCP.Date, StopCP.Tim, 00) < L_DatTim.GetVARIANTDATE(TimeSwitchDate, 03:00, 00)) THEN
   RETURN 1;
  ELSE
   RETURN 0;
  END
 END {GetShiftByDaylightSavingTimeSwitch};

 PRIVATE PROCEDURE prvDaylightSavingTimeSwitchDate(D: DATE; On: SCAL[2]): DATE;
  VAR
   result: DATE;
 BEGIN
  result:=L_DatTim.DaylightSavingTimeSwitchDate(D, On);
  IF result > D THEN
   result:=L_DatTim.DaylightSavingTimeSwitchDate(L_DatTim.YearBeg(D) - 1, On);
  END;
  RETURN result;
 END {prvDaylightSavingTimeSwitchDate};

 PRIVATE PROCEDURE intDecodeSCAD(_Stop : LIKE(Stop.Stop);
                                 D     : DATE;
                                 T     : TIME;
                                 V     : L_SCAD.tValue;
                                 VAR _T: TIME;
                                 VAR _S: NUMERIC[0]);
  VAR
   clbTime: TIME;
 BEGIN
  IF ~L_SCAD.IsRealValue(V) THEN
   _T:=T;
   _S:=0;
  ELSE
   L_General.Assert(IsCorrectSCADValue(V), " ⬥⪠   ᯮ짮 ⮫쪮   0  7");
   SETSEL(StopCP, Stop, _Stop);
   L_General.Assert(SRCINSEL(StopCP, LE, D, T),
                    "   ன   "+L_DatTim.DateStr(D)+" "+L_DatTim.TimeStr(T));
   L_General.Assert(StopCP.Value # L_SCAD.cpv_Disable,
                    "  ࠡ⠥  "+L_DatTim.DateStr(D)+" "+L_DatTim.TimeStr(T));

   L_General.Assert((StopCP.Date > prvDaylightSavingTimeSwitchDate(D, 0)) |
                    (StopCP.Date > prvDaylightSavingTimeSwitchDate(D, 1)),
                    "ன  ५ (諮  1 室  ⭥/ ६)");

   clbTime:=StopCP.Tim;
   DEC(clbTime, GetShiftByDaylightSavingTimeSwitch(L_DatTim.DaylightSavingTimeSwitchDate(D, 0), D));
   INC(clbTime, GetShiftByDaylightSavingTimeSwitch(L_DatTim.DaylightSavingTimeSwitchDate(D, 1), D));

   IF !T THEN
    T:=clbTime;
   END;
   L_SCAD.intDecode(D, T, V,
                    StopCP.Date, clbTime, StopCP.Sec, StopCP.Value,
                    StopCP.CPMode, StopCP.Code, _T, _S);
  END;
 END {intDecodeSCAD};

 PRIVATE PROCEDURE DecodeSCAD(_Stop : LIKE(Stop.Stop);
                      D     : DATE;
                      T     : TIME;
                      V     : L_SCAD.tValue): TIME;
  VAR
   DecodeTime: TIME;
   DecodeSec : NUMERIC[0];
 BEGIN
  intDecodeSCAD(_Stop, D, T, V, DecodeTime, DecodeSec);
  IF DecodeSec >= 30 THEN
   INC(DecodeTime, 1/60);
  END;
  RETURN DecodeTime;
 END {DecodeSCAD};

 PRIVATE PROCEDURE GetShift();
 BEGIN
  IF ~!RWayCP.Value THEN
   IF RWayCP.Value # L_SCAD.cpv_SetByOperator THEN
    RWayCP.FactT:=DecodeSCAD(RWayCP.Stop, RWayS.Date+RWayJ.Day-1, RWayCP.PlanT, RWayCP.Value);
    IF !RWayCP.FactT & (RWayJ.StopT < RWayJ.StartT) THEN
     RWayCP.FactT:=DecodeSCAD(RWayCP.Stop, RWayS.Date+RWayJ.Day, RWayCP.PlanT, RWayCP.Value);
    END;
   END;
   IF !RWayCP.FactT THEN (*㤠筮 ஢*)
    RWayCP.Shift:=MaxShift;
   ELSE
    IF RWayCP.FactT < RWayCP.PlanT THEN
     RWayCP.Shift:=Math.Max(-MaxShift, -(RWayCP.PlanT - RWayCP.FactT) * 60);
    ELSE
     RWayCP.Shift:=Math.Min( MaxShift,  (RWayCP.FactT - RWayCP.PlanT) * 60);
    END;
   END;
  ELSE
   SETEMPTY(RWayCP.FactT, RWayCP.Shift);
  END;
  REPLACE(RWayCP);
 END {GetShift};

 PRIVATE PROCEDURE ScanRWayCP();
 BEGIN
  CONFORM(RWayJ, SEJobs);
  RWayJ.Quality:=00;
  CONFORM(RWayJ, RWayCP);
  WHILE OCCURE(RWayCP) & (RWayJ.Quality=00) DO
   IF ~!RWayCP.Value & ((RWayCP.Value=L_SCAD.cpv_Unknown) | (Math.Abs(RWayCP.Shift) > L_SCAD.GetAccuracy())) THEN
    RWayJ.Quality:=01(*ࠪ*);
   END;
   NEXT(RWayCP);
  END;
  REPLACE(RWayJ);
 END {ScanRWayCP};

 PRIVATE PROCEDURE DefRWJQuality();
 BEGIN
  CONFORM(RWayJ, SEJobs);
  IF (RWayCP.Value=L_SCAD.cpv_Unknown) | (Math.Abs(RWayCP.Shift) > L_SCAD.GetAccuracy()) THEN
   RWayJ.Quality:=01(*ࠪ*);
   REPLACE(RWayJ);
  ELSE
   IF !RWayJ.Quality | (RWayJ.Quality # 00) THEN
    SAVE   (RWayCP);
    ScanRWayCP();
    RESTORE(RWayCP);
   END;
  END;
 END {DefRWJQuality};

 PUBLIC PROCEDURE SetEmptyRWayCP();
 BEGIN
  STDMSG("   ⬥⪨  "+FLDTOSTR(L_SCAD.cpv_Disable, "0", 0), CHOICE);
  SAVE(RWayJ);
  SAVE(RWayCP);
  SELECT(RWayCP, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayCP) DO
   IF !RWayCP.Value THEN
    RWayCP.Value:=L_SCAD.cpv_Disable;
    RWayCP.FactT:=RWayCP.PlanT;
    RWayCP.Shift:=0;
    REPLACE(RWayCP);
    CONFORM(RWayCP, RWayJ);
    IF !RWayJ.Quality THEN
     RWayJ.Quality:=00(*믮*);
     REPLACE(RWayJ);
    END;
   END;
   NEXT(RWayCP);
  END; (* WHILE OCCURE(RWayCP)... *)
  RESTORE(RWayCP);
  RESTORE(RWayJ);
 END {SetEmptyRWayCP};

 PUBLIC PROCEDURE ReDecodeSCAD();
  VAR
   _Quality: LIKE(RWayJ.Quality);
 BEGIN
  SELECT(RWayCP, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayCP) DO
   NARROWSEL(RWayCP, Day, StartT);
   CONFORM(RWayCP, RWayJ);
   _Quality:=RWayJ.Quality;
   IF ~!_Quality & ~!RWayCP.Value & (RWayCP.Value # L_SCAD.cpv_Unknown) THEN
    CONFORM(RWayJ, SEJobs);
    RWayJ.Quality:=00;
    WHILE OCCURE(RWayCP) DO
     GetShift();
     IF ~!RWayCP.Value & ((RWayCP.Value=L_SCAD.cpv_Unknown) | (Math.Abs(RWayCP.Shift) > L_SCAD.GetAccuracy())) THEN
      RWayJ.Quality:=01(*ࠪ*);
     END;
     NEXT(RWayCP);
    END; (* WHILE OCCURE(File) *)
    IF (RWayJ.Quality # _Quality) &
       L_StdFrm.Alternative(" ⢮ ३ " + RWayJ.Trip +
                            "|| " + _Quality + "  " + RWayJ.Quality) THEN
     REPLACE(RWayJ);
    END;
   END;
   NEXTINEXTENDEDSEL(RWayCP, Day, StartT);
  END; (* WHILE OCCURE(RWayCP) *)
 END {ReDecodeSCAD};

 PRIVATE PROCEDURE ChooseDigitInSCAD(    _Value  : STRING[4];
                                         i       : NUMERIC[0];
                                     VAR MinValue: LIKE(RWayCP.Value);
                                     VAR MinFactT: TIME;
                                     VAR MinShift: NUMERIC[3]);
  VAR
   NewShift : NUMERIC[3];
   NewValue : LIKE(RWayCP.Value);
   _FactT   : TIME;
   j        : NUMERIC[0];
 BEGIN
  j:=0;
  WHILE j < 8 DO
   _Value[i]:=FLDTOSTR(j, "0", 1);
   PROMPT(" :" + _Value);
   NewValue:=STRTOFLD(_Value, SCAL);
   CONFORM(RWayCP, RWayJ);
   _FactT:=DecodeSCAD(RWayCP.Stop, RWayS.Date+RWayJ.Day-1, RWayCP.PlanT, NewValue);
   IF ~!_FactT THEN
    IF _FactT < RWayCP.PlanT THEN
     NewShift:=-(RWayCP.PlanT -_FactT) * 60;
    ELSE
     NewShift:= (_FactT - RWayCP.PlanT) * 60;
    END;
    IF Math.Abs(MinShift) > Math.Abs(NewShift) THEN
     MinValue:=NewValue;
     MinFactT:=_FactT;
     MinShift:=NewShift;
    END;
   END;
   INC(j);
  END;
 END {ChooseDigitInSCAD};

 PUBLIC PROCEDURE SelectSCADValue();
  VAR
   MinShift: NUMERIC[3];
   MinValue: LIKE(RWayCP.Value);
   _Value  : STRING[4];
   MinFactT: TIME;
   i, j    : NUMERIC[0];
 BEGIN
  L_General.Assert(ACCESS(RWayCP), " ⠭ ⥪ ⬥⪠ ");
  LOOP
   IF ~!RWayCP.Value THEN
    L_General.Assert(L_SCAD.IsRealValue(RWayCP.Value), " 䨪⨢ ⬥⪠ ");
    _Value:=FLDTOSTR(RWayCP.Value, "0000", 4);
    MinValue:=RWayCP.Value;
    MinFactT:=RWayCP.FactT;
    MinShift:=RWayCP.Shift;
   ELSE
    SETEMPTY(_Value, MinValue, MinFactT);
    MinShift:=99;
   END;
   STDFORM(L_StdFrm.sf_Choice( "           蠡:             "+
                              "|                                   "+
                              "|'1*34'   ⭮ "+
                              "|'*'            "+
                              "|                                   "+
                              "|         %#####% %####%            ",
                              "%<:>T" +
                              "%L<>I"),
                              "    ", , , _Value);
   _Value:=Str.Condense(_Value);
   IF (_Value = "*") THEN
    IF !RWayCP.Value THEN
     STDMSG("   室 -⬥⪠", INFORM);
    ELSE
     EXIT;
    END;
   ELSE
    i:=0; j:=0;
    WHILE i < 4 DO
     IF L_Str.TestStrAlowChar(_Value[i], "09") | (_Value[i]="*") THEN
      INC(j, _Value[i]="*"); INC(i);
     ELSE
      i:=4; j:=0;
     END;
    END;
    IF j > 1 THEN
     STDMSG(" 蠡   뤥 ⮫쪮    ", INFORM);
    ELSIF j = 0 THEN
     STDMSG("୮  蠡  ", INFORM);
    ELSE
     EXIT;
    END;
   END;
  END;
  IF _Value = "*" THEN
   _Value:=FLDTOSTR(RWayCP.Value, "0000", 4);
   i:=0;
   WHILE i < 4 DO
    ChooseDigitInSCAD(_Value, i, MinValue, MinFactT, MinShift);
    INC(i);
   END;
  ELSE
   i:=Str.Pos(_Value, "*");
   ChooseDigitInSCAD(_Value, i, MinValue, MinFactT, MinShift);
  END;
  IF (~!MinFactT | (Math.Abs(MinShift) < 99)) & (RWayCP.Value # MinValue) THEN
   RWayCP.Value:=MinValue;
   RWayCP.Shift:=MinShift;
   RWayCP.FactT:=MinFactT;
   REPLACE(RWayCP);
   DefRWJQuality();
  ELSIF RWayCP.Value = MinValue THEN
   STDMSG("⬥⪠ " + RWayCP.Value + "  ⨬쭮", INFORM);
  ELSE
   STDMSG(" ⬥⪨, ᮢ饩  蠡.", INFORM);
  END;
 END {SelectSCADValue};

 PRIVATE PROCEDURE DecodeSingle();
 BEGIN
  CONFORM(RWayCP, RWayJ);
  GetShift();
  IF ~!RWayCP.Shift THEN
   L_General.Assert(OCCURE(RWayJ), " ⠭ ⥪  RWayJ");
   DefRWJQuality();
  END;
 END {DecodeSingle};

 PRIVATE PROCEDURE RWayCP_Value_OnSuccessfulChange();
 BEGIN
  IF ~!RWayCP.Value THEN
   L_General.Assert(RWayCP.Value # L_SCAD.cpv_Imported,
                    '祭 "' + RWayCP.Value + '" ⠢ ⮬᪨');
   CONFORM(RWayCP, RWayJ);
   GetShift();
  END;
  RTI.Get().CurZone.Fields("RWayCP.FactT").Modifiable:=!RWayCP.Value | (RWayCP.Value = L_SCAD.cpv_SetByOperator);
  RTI.Get().CurZone.Fields("RWayCP.Value").Last:=~RTI.Get().CurZone.Fields("RWayCP.FactT").Modifiable;
 END {RWayCP_Value_OnSuccessfulChange};

 PRIVATE PROCEDURE RWayCP_FactT_OnSuccessfulChange();
 BEGIN
  IF !RWayCP.Value THEN
   RWayCP.Value:=L_SCAD.cpv_SetByOperator;
   L_StdFrm.Confirm("⢨⥫쭮 㪠 䠪᪮ ६ ?");
   REPLACE(RWayCP);
  END;
  GetShift();
 END {RWayCP_FactT_OnSuccessfulChange};

 PRIVATE PROCEDURE RWayCP_OnBeforeInsert();
 BEGIN
  L_General.Error("⬥⪨  ⠢ ⮬᪨");
 END {RWayCP_OnBeforeInsert};

 PRIVATE PROCEDURE RWayCP_OnBeforeDelete();
 BEGIN
  L_General.Error(" ⬥⮪   ᪠");
 END {RWayCP_OnBeforeDelete};

 PRIVATE PROCEDURE RWayCP_OnBeforeEdit();
 BEGIN
  L_General.Assert(RWayCP.Value # L_SCAD.cpv_Imported, " ᪠  ஢ ");
  RTI.Get().CurZone.Fields("RWayCP.FactT").Modifiable:=!RWayCP.Value | (RWayCP.Value = L_SCAD.cpv_SetByOperator);
  RTI.Get().CurZone.Fields("RWayCP.Value").Last:=~RTI.Get().CurZone.Fields("RWayCP.FactT").Modifiable;
 END {RWayCP_OnBeforeEdit};

 PRIVATE PROCEDURE RWayCP_OnAfterEdit();
 BEGIN
  DecodeSingle();
 END {RWayCP_OnAfterEdit};

 PUBLIC PROCEDURE DecodeEmtpySCAD();
 BEGIN
  SELECT(RWayCP, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayCP) DO
   PROMPT("஢ ⬥⮪ " + L_DatTim.TimeStr(RWayCP.StartT) + " " + RWayCP.StopNbr);
   IF !RWayCP.Shift THEN
    SAVE(RWayCP);
    DecodeSingle();
    RESTORE(RWayCP);
   END;
   NEXT(RWayCP);
  END; (* WHILE OCCURE(RWayCP)... *)
 END {DecodeEmtpySCAD};

 PUBLIC PROCEDURE PlayCheckDialog();
  VAR
   Title : STRING[];
   _Date : DATE;
   _Time : TIME;
   dTime : TIME;
   dSec  : NUMERIC[0];
   sTime : STRING[8];
   _Value,
   pValue: LIKE(RWayCP.Value);
   CPList: STRING[];
   _CPPnt: SCAL[1E2];
   Delta : NUMERIC[0];
 BEGIN
  Title:="஢ઠ  ";
  CPList:="";
  SAVE(Stop);
  SETSEL(Stop, CP);
  IF SRCINSEL(Stop, GT, 00) THEN
   WHILE OCCURE(Stop) DO
    IF Stop.CPType = L_Way.scpt_SCAD THEN
     CPList:=CPList + Stop.CP + "|";
    END;
    NEXT(Stop);
   END; (* WHILE OCCURE(Stop) ... *)
  END;
  L_General.Assert(~!CPList, " ⠭  ");
  RESTORE(Stop);
  IF ACCESS(Stop) & (Stop.CPType = L_Way.scpt_SCAD) THEN
   _CPPnt:=L_Str.PositionInPool(CPList, Stop.CP);
  ELSE
   _CPPnt:=0;
  END;

  IF ACCESS(StopCP) THEN
   _Date :=StopCP.Date;
   _Time :=StopCP.Tim;
   _Value:=StopCP.Value;
  ELSE
   _Date:=Memo.tmp_cd();
   SETEMPTY(_Time, _Value, sTime);
  END;
  LOOP
   pValue:=_Value;

   L_General.Assert(SELECT(Stop, CP, L_Str.PoolItem(CPList, _CPPnt)),
                    "?????");
   IF ~!_Value THEN
    intDecodeSCAD(Stop.Stop, _Date, _Time, _Value, dTime, dSec);
    IF !dTime THEN
     sTime:="XX:XX:";
    ELSE
     sTime:=L_DatTim.TimeStr(dTime)+":"+L_Str.FixedIntStr(dSec, 2);
    END;
   ELSE
    SETEMPTY(sTime);
   END;
   SETEMPTY(_Value);
   IF ~STDFORM(L_StdFrm.sf_Choice( "              : %##########%"+
                                  "|"+
                                  "|६             : %#####%     "+
                                  "|"+
                                  "|⬥⪠           : %####%      "+
                                  "|"+
                                  "|। ⬥⪠: %####%      "+
                                  "|"+
                                  "|६             : %########%  "+
                                  "|"+
                                  "|           : %##%        ",
                                  "%L<D.N.y>I"+
                                  "%L<H:M>FI"+
                                  "%L<>I"+
                                  "%L<>NI"+
                                  "%L<>NI"+
                                  "%L<"+CPList+">I"),
         " " + Title + " ",
         ,
         ,
         _Date, _Time, _Value, pValue, sTime, _CPPnt) THEN
    EXIT;
   END;
  END; (* LOOP *)
 END {PlayCheckDialog};

 PRIVATE PROCEDURE intMergeStops(SrcStop, DstStop: LIKE(Stop.Stop));
  VAR
   srcBegin,
   srcTill  : DATE;
   srcCP    : LIKE(Stop.CP);
   srcCPType: LIKE(Stop.CPType);
   srcSign  : LIKE(Stop.Sign);
   User     : STRING[];
   Idx      : NUMERIC[0];
   l        : LINK;
   FName    : STRING[];
 BEGIN
  L_General.Assert(SrcStop # DstStop, "  ᮡ?");
  SEARCH(Stop, Stop, , SrcStop);
  L_r2r.Owner_OnBeforeDelete("Stop");
  L_General.Assert(~SELECT(StopCP, Stop, SrcStop), " ⠭ " + Stop.Stop + " " + L_Way.GetStopName(SrcStop) + "    ");
  srcBegin :=Stop.Begin;
  srcTill  :=Stop.Till;
  srcCP    :=Stop.CP;
  srcCPType:=Stop.CPType;
  srcSign  :=Stop.Sign;

  L_General.Assert(SEARCH(Stop, Stop, DstStop), "  ⠭   " + DstStop);
  L_General.Assert(srcCP    = Stop.CP,     " '஫ 㭪'  ꥤ塞 ⠭");
  L_General.Assert(srcCPType= Stop.CPType, " ' '  ꥤ塞 ⠭");
  L_General.Assert(srcSign  = Stop.Sign,   "筠 ''  ꥤ塞 ⠭");

  Stop.Begin:=Math.Min(Stop.Begin, srcBegin);
  Stop.Till :=Math.Max(Stop.Till,  srcTill);
  REPLACE(Stop);

  TRY [INTEGRITY(INTEGRITY_ON)]
   Idx:=0;
   WHILE Idx < DBD.LinkAmount(Stop) DO
    IF DBD.LinkKind(Stop, ^(DBD.LinkName(Stop, Idx))) = L_General.lk_OWNER THEN
     User:=DBD.LinkCooFileName(Stop, ^(DBD.LinkName(Stop, Idx)));
     FOR_EACH l IN TABLE.Get(User).Links DO
      IF l.CooIndex.Table.Name = "Stop" THEN
       L_General.CallUs(DBD.IndexFieldAmount(^(User), ^(l.Name)) = 1);
       FName:=DBD.IndexFieldName(^(User), ^(l.Name), 0);
       WHILE SELECT(^(User), ^(l.Name), SrcStop) DO
        ^(User + "." + FName):=Stop.Stop;
        REPLACE(^(User));
       END; (* WHILE SELECT(^(User) ... *)
      END;
     END; (* FOR_EACH *)
    END;
    INC(Idx);
   END;
   L_General.CallUs(SEARCH(Stop, Stop, SrcStop));
   REMOVE(Stop);
  EXCEPT
  END;
 END {intMergeStops};

 PUBLIC PROCEDURE MergeStops();
  VAR
   DstStop: LIKE(Stop.Stop);
 BEGIN
  L_General.AdminOnly();
  L_General.Assert(ACCESS(Stop), " ⠭ ⠭");
  SETEMPTY(DstStop);
  IF STDFORM(L_StdFrm.sf_Choice("  ⠭ " + Stop.Stop + "  ७ᥭ," +
                                "|᫥ 祣  ⠭ 㤥 㤠.  " +
                                "|  ⠭ ꥤ ?    " +
                                "||%####%|",
                                "%<>I"),
             " ꥤ ⠭ ", , 1, DstStop) THEN
   intMergeStops(Stop.Stop, DstStop);
  END;
 END {MergeStops};

 PRIVATE PROCEDURE RWayCP_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete]);
  L_WDO.iZone        (1).Narrowing:="RWayCP.RWayS=RWayS.RWayS";
  L_WDO.iScsChange   (1, ["RWayCP.FactT", "RWayCP.Value"]);
  L_WDO.iMayBeEmpty  (1, ["RWayCP.FactT", "RWayCP.Value"]);
  L_WDO.iModifiable  (1, ["RWayCP.Value"]);
  L_WDO.iField(1, "RWayCP.FactT").Last:=1;
 END {RWayCP_OnInitializeWindow};

BEGIN
 L_Events.ExecuteHandler();
END.
