(*
%Copyright   (c) Polak Computer System
%Author      GINA 22.12.1994 17:04:38
%Purpose     ஢ઠ ४⭮  ⮯    RWayF
%Type        control
%Specific    AP
%Modified    20.06.2012 14:42:59 POLAK\Gina
%Environment
*)

 MODULE RWayF [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Fuel, L_General, L_Way, L_Car, L_Events, L_WDO, L_DatTim, L_Str;

 PRIVATE PROCEDURE RWayF_FuelTake_OnSuccessfulChange();
 BEGIN
  L_Way.CheckBakVol(RWayS.BoxNbr, RWayS.Date, RWayF.FuelTake, 0);
  L_General.Assert(RWayF.FuelTake < MAXOF(RWayS.FuelFact),
                   "祭 ॢ蠥 稭 "+L_Str.IntStr(MAXOF(RWayS.FuelFact)));
 END {RWayF_FuelTake_OnSuccessfulChange};

 PRIVATE PROCEDURE RWayF_FuelRet_OnSuccessfulChange();
 BEGIN
  L_Way.CheckBakVol(RWayS.BoxNbr, RWayS.Date, RWayF.FuelRet, 0);
  L_General.Assert(RWayF.FuelRet < MAXOF(RWayS.FuelFact),
                   "祭 ॢ蠥 稭 "+L_Str.IntStr(MAXOF(RWayS.FuelFact)));
 END {RWayF_FuelRet_OnSuccessfulChange};

 PRIVATE PROCEDURE InsertSingleRWayF(trgInMix: LIKE(MarkFuel.InMix)): SCAL[2];
 BEGIN
  L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
  CONFORM(Mark, MarkFuel);
  L_General.Assert(OCCURE(MarkFuel), " ଠ樨  ⮯  ન " + Mark.Mark);
  WHILE OCCURE(MarkFuel) &
        ((MarkFuel.InMix # trgInMix) | ~L_DatTim.IsActive(RWayS.Date, MarkFuel.Begin, MarkFuel.Till)) DO
   NEXT(MarkFuel);
  END;
  SAVE(RWayF);
  IF OCCURE(MarkFuel) & ~SEARCH(RWayF, RWayS, RWayS.RWayS, MarkFuel.Math) THEN
   RESTORE(RWayF);
   RWayF.Math:=MarkFuel.Math;
   REPLACE(RWayF);
   RETURN 1;
  ELSE
   RESTORE(RWayF);
   RETURN 0;
  END;
 END {InsertSingleRWayF};

 PRIVATE PROCEDURE CheckIsGoodWindowForFuel(WinOName: STRING[]);
 BEGIN
  L_General.Assert((L_Fuel.FlAcntLev(RWayS.Date) = L_Fuel.fal_RWOP) |
                   (L_Fuel.FlAcntLev(RWayS.Date) = L_Fuel.fal_Dispatcher) & (WinOName = "Beg1E") |
                   (WinOName = "RWayChn"),
                   "ࠢ   ४஢");
 END {CheckIsGoodWindowForFuel};

 PRIVATE PROCEDURE RWayF_OnBeforeEdIns();
  VAR
   FuelMoveModifiable: SCAL[2];
 BEGIN
  CheckIsGoodWindowForFuel(L_WDO.OriginalName(GE_CURWIN()));
  FuelMoveModifiable:=~L_Fuel.TanksIsStock(RWayS.Date);
  L_WDO.SetFieldModifiable("RWayF.FuelTake", FuelMoveModifiable);
  L_WDO.SetFieldModifiable("RWayF.FuelRet",  FuelMoveModifiable);
 END {RWayF_OnBeforeEdIns};

 PRIVATE PROCEDURE RWayF_OnBeforeEdit();
 BEGIN
  RWayF_OnBeforeEdIns();
 END {RWayF_OnBeforeEdit};

 PRIVATE PROCEDURE RWayF_OnBeforeInsert();
 BEGIN
  RWayF_OnBeforeEdIns();
  IF InsertSingleRWayF(L_Fuel.im_MainFuel) |
     InsertSingleRWayF(L_Fuel.im_MotorOil) THEN
   LIKEMENU(NxtField, "");
  END;
 END {RWayF_OnBeforeInsert};

 PRIVATE PROCEDURE RWayF_OnBeforeDelete();
 BEGIN
  CheckIsGoodWindowForFuel(L_WDO.OriginalName(GE_CURWIN()));
  IF L_Fuel.TanksIsStock(RWayS.Date) THEN
   L_General.Assert((RWayF.FuelTake = 0) & (RWayF.FuelRet = 0), "ࠢ   ४஢");
  END;
 END {RWayF_OnBeforeDelete};

 PRIVATE PROCEDURE RWayF_OnAfterEdIns();
  VAR
   _InMix: LIKE(MarkFuel.InMix);
 BEGIN
  CONFORM(RWayS, Car);
  _InMix:=L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math);
 END {RWayF_OnAfterEdIns};

 PRIVATE PROCEDURE RWayF_OnAfterInsert();
 BEGIN
  RWayF_OnAfterEdIns();
 END {RWayF_OnAfterInsert};

 PRIVATE PROCEDURE RWayF_OnAfterEdit();
 BEGIN
  RWayF_OnAfterEdIns();
 END {RWayF_OnAfterEdit};

BEGIN
 CONFORM(RWayF, RWayS);
 L_Events.ExecuteHandler();
END.
