(*
%Copyright   (c) Polak Computer System
%Author      14.03.1994 12:51:40 SAN
%Purpose     on-line ஢ઠ ࠢ쭮  窨 /
%Purpose     稢  RWayJ ⠭ 室  祥
%Type        control, operation
%Specific    AP
%Modified    09.06.2014 12:29:44 POLAK\GAV
*)

 MODULE RWayJ [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_SCAD, L_General, L_Way, L_DatTim, L_Str, E_Way, E_Utils, L_StdFrm, L_Car,
        P_Car, L_EC, L_BegRWS, Str, SysLog, Math, L_AcsPnt, L_APtm;

 PRIVATE PROCEDURE CondAction(Text: STRING[]);
 BEGIN
  L_AcsPnt.PassAccessPoint_wExplanation(0000033, Text);
 END {CondAction};

 PRIVATE PROCEDURE CheckStopT();
  VAR
   Delta: NUMERIC[2];
 BEGIN
  CHANGESEL(SEJobs, Exit, , SEJobs.Exit);
  IF L_Way.GetTripsGroup(RWayJ.Fact, L_Way.FullEndTime(99, 00:00, 00:00), 0) < RWayJ.Fact THEN
   CondAction(" ᯨᠭ  ⠪ ⢠ ३ᮢ");
  ELSE
   Delta:=(L_Way.FullEndTime(RWayJ.Day,  RWayJ.StartT,  RWayJ.StopT) -
          L_Way.FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT)) MOD 24;
   IF    Delta < -0.4 THEN CondAction(" 祭 ᫨誮 ࠭");
   ELSIF Delta > +0.4 THEN CondAction(" 祭 ᫨誮 ");
   END;
  END;
 END {CheckStopT};

 PRIVATE PROCEDURE CheckStartT();
  VAR
   Delta: NUMERIC[2];
 BEGIN
  Delta:=(L_Way.FullBegTime(RWayJ.Day,  RWayJ.StartT) - L_Way.FullBegTime(SEJobs.Day, SEJobs.StartT)) MOD 24;
  IF    Delta < -0.4 THEN CondAction("  ᫨誮 ࠭");
  ELSIF Delta > +0.4 THEN CondAction("  ᫨誮 ");
  END;
 END {CheckStartT};

 PRIVATE PROCEDURE CheckRWayJExitOnDate();
  VAR
   D: DATE;
 BEGIN
  D:=RWayS.Date;
  IF StExit.Strict = L_Way.ExitStrict_Reg THEN
   L_General.Assert((RWayJ.StartT - SEJobs.StartT <= 8) | (SEJobs.StartT - RWayJ.StartT <= 8),
                    "⪫  ᯨᠭ  8 ᮢ  ᪠");
   INC(D, Math.Round((L_Way.FullBegTime(RWayJ.Day,  RWayJ.StartT) -
                      L_Way.FullBegTime(SEJobs.Day, SEJobs.StartT)) / 24));
  END;
  L_Way.CheckExitOnDate(StExit.Exit, D, 0);
 END {CheckRWayJExitOnDate};

 PRIVATE PROCEDURE CheckAnyExit();
 BEGIN
  CheckRWayJExitOnDate();
  L_Way.ChkTripPermiss(RWayJ.StartT, RWayJ.StopT, (RWayJ.Run * RWayJ.Fact));
  IF ((WJMode.IncSel * Route.IncSel) = 0) | (Quality.Type = 0) THEN
   L_General.Assert(L_Way.GetRWJPByType(0) = 0,
                    " ⮬ ३    ⥫,|"+
                    "易  ॢ ᠦ஢");
  END;
 END {CheckAnyExit};

 PRIVATE PROCEDURE CheckStrictExit();
 BEGIN
  IF StExit.Strict = L_Way.ExitStrict_Reg THEN
   IF (StExit.Change # RWayS.Change) & (StExit.Change > 0) & (RWayS.Change > 0) THEN
    CondAction(" 室 㣮 ᬥ");
   END;
   CheckStartT();
   CheckStopT();
  END; (* IF StExit.Strict ... *)
 END {CheckStrictExit};

 PRIVATE PROCEDURE CheckNonStrictExit();
 BEGIN
  IF StExit.Strict # L_Way.ExitStrict_Reg THEN
   CONFORM(RWayJ, SEJobs, RoutMod);
   L_General.Assert(L_DatTim.IsActive_Inc(RWayS.Date, RoutMod.FromD, RoutMod.UpDate),
                    "䨪 " + RoutMod.Modif +
                    "  " + RoutMod.Route +
                    "   " + L_DatTim.DateStr(RWayS.Date));
  END;
 END {CheckNonStrictExit};

 PRIVATE PROCEDURE RWayJ_Trip_OnSuccessfulChange();
  VAR
   PrevRun : LIKE(RoutMod.Run);
   Asked   : SCAL[2];
 BEGIN
  IF ~ACCESS(RWayS) (*   *) THEN
   CONFORM(RWayJ, RWayS);
  END;
  SETEMPTY(PrevRun);
  IF ~!GE_PVALUE(RWayJ.Trip) THEN
   SAVE(SEJobs);
   SEARCH(SEJobs, Trip, , GE_PVALUE(RWayJ.Trip));
   CONFORM(SEJobs, RoutMod);
   PrevRun:=RoutMod.Run;
   RESTORE(SEJobs);
  END;
  IF RWayJ.Run = PrevRun THEN
   IF ~!RWayJ.Trip THEN
    CONFORM(RWayJ, RoutMod);
    RWayJ.Run :=RoutMod.Run;
    RWayJ.Fact:=1;
   ELSE
    SETEMPTY(RWayJ.Run, RWayJ.Fact);
   END;
  END;

  IF L_SCAD.E_RWayCPLevel(RWayS.Date) THEN
   IF ~!RWayJ.Trip THEN
    CONFORM(RWayJ, SEJobs, RoutMod);
    CONFORM(RoutMod, RtMStop);
    L_General.Assert(~!RWayJ.Day,    "室 । ");
    L_General.Assert(~!RWayJ.StartT | ~OCCURE(RtMStop), "室 । ६ 砫 ३");
    L_SCAD.DistributeCP();
   ELSE
    Asked:=0;
    L_SCAD.RemSelRWayCP(Asked);
   END;
  END;
  REPLACE(RWayJ);
 END {RWayJ_Trip_OnSuccessfulChange};

 PRIVATE PROCEDURE RWayJ_Trip_OnBeforeAskForEdit();
 BEGIN
  IF !RWayJ.Trip THEN
   LIKEMENU(Home, "");
  END;
 END {RWayJ_Trip_OnBeforeAskForEdit};

 PRIVATE PROCEDURE RWayJ_Trip_OnBeforeAskForView();
 BEGIN
 END {RWayJ_Trip_OnBeforeAskForView};

 PRIVATE PROCEDURE RWayJ_Fact_OnSuccessfulChange();
  VAR
   _Fact: LIKE(RWayJ.Fact);
   Asked: SCAL[2];
 BEGIN
  IF L_SCAD.E_RWayCPLevel(RWayS.Date) THEN
   L_General.Assert(~!RWayJ.Trip, " 㪠 ३");
   IF RWayJ.Fact < GE_PVALUE(RWayJ.Fact) THEN
    CONFORM(RWayJ, SEJobs);
    _Fact:=1;
    WHILE _Fact < GE_PVALUE(RWayJ.Fact) DO
     INC(_Fact);
     NEXT(SEJobs);
    END; (* WHILE (_Fact < ... *)
    CONFORM(RWayJ, RWayCP);
    LAST(RWayCP);
    Asked:=0;
    _Fact:=GE_PVALUE(RWayJ.Fact) - RWayJ.Fact;
    WHILE _Fact > 0 DO
     SELECT(RtMStop, Route, , SEJobs.Route, SEJobs.Modif);
     LAST(RtMStop);
     WHILE OCCURE(RtMStop) DO
      CONFORM(RtMStop, Stop);
      IF L_SCAD.IsActiveStopCP() &
         (RWayCP.Stop=RtMStop.Stop) &
         (RWayCP.PlanT=L_SCAD.RWayCP_PlanT()) THEN
       IF ~Asked & ~!RWayCP.Value THEN
        L_StdFrm.Choice(" " + RWayJ.Trip + "    ⬥⪨.|" +
                        "   㤠?");
        Asked:=1;
       END;
       REMOVE(RWayCP);
       LAST(RWayCP);
      END;
      PREV(RtMStop);
     END; (* WHILE OCCURE(RtMStop) ... *)
     DEC(_Fact);
     PREV(SEJobs);
    END; (* WHILE _Fact > 0... *)
   ELSE
    L_SCAD.DistributeCP();
   END;
  END;
 END {RWayJ_Fact_OnSuccessfulChange};

 PRIVATE PROCEDURE RWayJ_Quality_OnSuccessfulChange();
  VAR
   Asked,
   A_IsReal: SCAL[2];
 BEGIN
  CONFORM(RWayJ, Quality);
  IF Quality.Type = L_Way.QualType_Annul THEN
   Asked:=0;
   L_SCAD.RemSelRWayCP(Asked);
  ELSIF L_SCAD.E_RWayCPLevel(RWayS.Date) THEN
   CONFORM(RWayJ, RWayCP);
   A_IsReal:=OCCURE(RWayCP);
   WHILE OCCURE(RWayCP) & A_IsReal DO
    A_IsReal:=~!RWayCP.Value &
              (RWayCP.Value # L_SCAD.cpv_Unknown) &
              (RWayCP.Value # L_SCAD.cpv_Disable);
    NEXT(RWayCP);
   END;
   IF A_IsReal THEN
    L_StdFrm.Choice(" ⮫쪮 ॠ ⬥⪨ |" +
                    "⢨⥫쭮  ⢮?");
   END;
  END;
 END {RWayJ_Quality_OnSuccessfulChange};

 PRIVATE PROCEDURE Check_CPFactT();
 BEGIN
  L_General.Assert(~!RWayCP.FactT, "। 䠪᪮ ६ ⬥⪨:|" +
                                   L_SCAD.ErrCPPoint());
 END {Check_CPFactT};

 PRIVATE CONST
  MaxShiftZ = 60/60;
  MaxShiftW = 24/60;
  MaxLongZ  =  0/60;
  MaxLongW  =  5/60;

 PUBLIC PROCEDURE CorrRWayJAsRWayCP();
  VAR
   T,
   CurTime,
   MaxLong,
   MaxShift : NUMERIC[3];
   CorStopT,
   CorStartT: SCAL[2];
   _StopNbr : LIKE(RWayCP.StopNbr);
 BEGIN
  L_StdFrm.Question("४஢ ६ ३   ⬥⪠");
  CONFORM(RWayJ, RWayCP);
  IF OCCURE(RWayCP) THEN
   CONFORM(RWayJ, SEJobs, WJMode);
   IF WJMode.RunSel = 1(*㫥*) THEN
    MaxShift:=MaxShiftZ;
    MaxLong :=MaxLongZ;
   ELSE
    MaxShift:=MaxShiftW;
    MaxLong :=MaxLongW;
   END;

   SETZERO(CorStartT, CorStopT);
   _StopNbr:=RWayCP.StopNbr;
   CurTime :=RWayJ.StopT-RWayJ.StartT;
   Check_CPFactT();

   IF RWayJ.StartT > RWayCP.FactT THEN
    L_General.Assert(RWayJ.StartT - RWayCP.FactT <= MaxShift,
                     "誮 讥 ᬥ饭 砫 ३");
    T:=L_Way.FullBegTime(RWayJ.Day, RWayCP.FactT);
    SAVE(RWayJ);
    IF PREV(RWayJ) THEN
     L_General.Assert(T >= L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT),
                      "砫 ३ ४뢠  ।騬");
    END;
    RESTORE(RWayJ);
    RWayJ.StartT:=RWayCP.FactT;
    CorStartT   :=1;
    RWayJ.StopT :=RWayJ.StartT + CurTime;
   END;

   LAST(RWayCP);
   Check_CPFactT();
   IF (~CorStartT | (CorStartT & (RWayCP.StopNbr # _StopNbr))) &
      (RWayJ.StopT < RWayCP.FactT) THEN
    L_General.Assert(RWayCP.FactT - RWayJ.StopT <= MaxShift,
                     "誮 讥 ᬥ饭 砭 ३");
    T:=L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayCP.FactT);
    SAVE(RWayJ);
    IF NEXT(RWayJ) THEN
     L_General.Assert(T <= L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT),
                      "砭 ३ ४뢠  ᫥騬");
    END;
    RESTORE(RWayJ);
    RWayJ.StopT:=RWayCP.FactT;
    CorStopT   :=1;
    IF ~CorStartT THEN
     RWayJ.StartT:=RWayJ.StopT-CurTime;
    END;
   END;

   IF CorStartT | CorStopT THEN
    INTEGRITY(NoAsk);
    L_General.Assert(RWayJ.StopT - RWayJ.StartT <= CurTime + MaxLong,
                     "誮 讥 ⪫ த⥫쭮 ३");
    REPLACE(RWayJ);
    INTEGRITY(Off);
   END;
  END;
 END {CorrRWayJAsRWayCP};

 PRIVATE PROCEDURE SetRunBySM();
  VAR
   Proportionally_Run: SCAL[2];
   Unit,
   TotalRWayJ,
   TotRunRWayJ,
   TotTimeRWayJ: NUMERIC[3];
   Run,
   Step,
   TotRun      : NUMERIC[2];
   Coeff       : NUMERIC[3];
 BEGIN
  L_General.Assert(~!RWayS.BoxNbr & ~!RWayS.Date, "  ⮬   ");
  SAVE(RWayJ);
  SETZERO(TotTimeRWayJ, TotRunRWayJ);
  CONFORM(RWayS, RWayJ);
  WHILE OCCURE(RWayJ) DO
   CONFORM(RWayJ, Quality);
   IF (Quality.Type > L_Way.QualType_Annul) THEN
    CONFORM(RWayJ, WJMode);
    IF WJMode.RunSel > 0 THEN
     INC(TotTimeRWayJ, RWayJ.StopT - RWayJ.StartT);
     INC(TotRunRWayJ,  RWayJ.Fact*RWayJ.Run);
    END;
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
  L_General.Assert(TotTimeRWayJ > 0, " ३ᮢ,     ஡");
  TotRun:=L_Way.RunBySM();
  L_General.Assert(TotRun < 10000, "誮 让 ஡  ᯨ: " + L_Str.IntStr(TotRun) + " ");
  Proportionally_Run:=TotRunRWayJ > 0;
  IF Proportionally_Run THEN
   TotalRWayJ:=TotRunRWayJ;
  ELSE
   TotalRWayJ:=TotTimeRWayJ;
  END;
  Coeff:=TotRun / TotalRWayJ;

  CONFORM(RWayS, RWayJ);
  WHILE OCCURE(RWayJ) DO
   CONFORM(RWayJ, Quality);
   IF (Quality.Type > L_Way.QualType_Annul) THEN
    CONFORM(RWayJ, WJMode);
    IF WJMode.RunSel > 0 THEN
     IF Proportionally_Run THEN
      Unit:=RWayJ.Run * RWayJ.Fact;
     ELSE
      Unit:=RWayJ.StopT - RWayJ.StartT;
     END;
     IF TotalRWayJ = Unit THEN
      Run:=TotRun;
     ELSE
      Run:=Coeff * Unit;
     END;
     IF    Math.Round(RWayJ.Run, 1.00) = RWayJ.Run THEN
      Step:=1.00;
     ELSIF Math.Round(RWayJ.Run, 0.10) = RWayJ.Run THEN
      Step:=0.10;
     ELSIF Math.Round(RWayJ.Run, 0.01) = RWayJ.Run THEN
      Step:=0.01;
     END;
     RWayJ.Run:=Math.Round(Run / RWayJ.Fact, Step);
     DEC(TotalRWayJ, Unit);
     DEC(TotRun,     RWayJ.Fact*RWayJ.Run);
     REPLACE(RWayJ);
    END;
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
  RESTORE(RWayJ);
 END {SetRunBySM};

 PUBLIC PROCEDURE ChkDifRun();
  VAR
   Text,
   AddText      : STRING[];
   React,
   curRunBySM   : NUMERIC[0];
   Delta,
   curRunByRWayJ: NUMERIC[2];
 BEGIN
  LOOP
   L_General.Assert(~!RWayS.BoxNbr & ~!RWayS.Date, "  ⮬   ");
   L_General.Assert(~!RWayS.SMBef & ~!RWayS.SMAft, "   ᯨ");
   curRunByRWayJ:=0;
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayJ) DO
    L_General.Assert(~!RWayJ.Quality, " " + RWayJ.Trip + "  । ⢮.||" +
                                      " ஡  ३ᠬ .");
    CONFORM(RWayJ, Quality);
    IF Quality.Type # L_Way.QualType_Annul THEN
     INC(curRunByRWayJ, RWayJ.Fact * RWayJ.Run);
    END;
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
   curRunBySM:=L_Way.RunBySM();
   Delta     :=curRunBySM - curRunByRWayJ;
   Text      :="஡  ᯨ " + FLDTOSTR(curRunBySM, "0", 8, "L") + "||" +
               "஡  ३ᠬ     " + FLDTOSTR(curRunByRWayJ, "2.", 8, "L");
   IF Math.Abs(Delta) < 1 THEN
    IF Delta # 0 THEN
     AddText:="||(宦  । 譮)";
    ELSE
     AddText:="";
    END;
    L_StdFrm.Inform(Text +
                    AddText);
    EXIT;
   ELSE
    React:=STDFORM(Text + "||" +
                   "宦          " + FLDTOSTR(Delta, "2.", 8, "L") + "||"+
                   "%< O⬥ >X  %< ਢ  ᮮ⢥⢨  ஡  ᯨ >DB",
                   " ஫ ஡  ३ᠬ  ᯨ ",
                   STOP,
                   ,
                   );
    IF React = 1 THEN
     SetRunBySM();
    ELSE
     EXIT;
    END;
   END;
  END; (* LOOP *)
 END {ChkDifRun};

 PUBLIC PROCEDURE SetRWayJStopT();
  VAR
   _Fact: LIKE(RWayJ.Fact);
 BEGIN
  L_General.Assert(~!RWayJ.Trip & ~!RWayJ.StartT,
                   "室 ।  ३  ६ 砫");
  CONFORM(RWayJ, SEJobs);
  CHANGESEL(SEJobs, Exit, , SEJobs.Exit);
  RWayJ.StopT:=RWayJ.StartT + (SEJobs.StopT - SEJobs.StartT);
  _Fact:=RWayJ.Fact;
  WHILE _Fact > 1 DO
   DEC(_Fact);
   NEXT(SEJobs);
   L_General.Assert(OCCURE(SEJobs), " ⠪ ⢠ ३ᮢ");
   INC(RWayJ.StopT, SEJobs.StopT - SEJobs.StartT);
  END;
  REPLACE(RWayJ);
 END {SetRWayJStopT};

 PRIVATE PROCEDURE RWayJGroup(FET: NUMERIC[3]; FirstDay: LIKE(RWayJ.Day); ReplaceFirst: SCAL[2]): SCAL[99];
  VAR
   StartT,
   FStart  : LIKE(SEJobs.StopT);
   FDay    : LIKE(SEJobs.Day);
   I       : SCAL[99];
 BEGIN
  I:=0;
  WHILE OCCURE(SEJobs) &
        (L_Way.FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT) <= FET) DO
   CONFORM(SEJobs, Route);
   CONFORM(SEJobs, RoutMod);

   IF L_DatTim.IsActive_Inc(RWayS.Date, RoutMod.FromD, RoutMod.UpDate) THEN
    IF ReplaceFirst THEN
     StartT:=RWayJ.StartT;
    ELSE
     StartT:=SEJobs.StartT;
     IF OCCURE(RWayJ) THEN
      SAVE(RWayJ);
      IF OCCURE(RWayJ) & ~!RWayJ.StopT &
         (L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT) > L_Way.FullBegTime(FirstDay, StartT)) THEN
       FirstDay:=RWayJ.Day + (RWayJ.StartT > RWayJ.StopT);
       StartT  :=RWayJ.StopT;
      END;
      RESTORE(RWayJ);
     END;
    END; (* IF ReplaceFirst *)

    DEFAULT(RWayJ);
    RWayJ.RWayS :=RWayS.RWayS;
    RWayJ.Trip  :=SEJobs.Trip;
    RWayJ.Day   :=FirstDay;
    RWayJ.Fact  :=0;
    RWayJ.Run   :=RoutMod.Run;
    RWayJ.StartT:=StartT;
    IF ~ReplaceFirst THEN
     TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
      INSERT(RWayJ);
     EXCEPT
     ON Exc: Exc_Root DO
      IF Exc.ErrorCode = L_General.ec_rt_UniquenessViolation THEN
       L_General.Error(" ३ 㦥    ६ 砫 " + FirstDay + " " + FLDTOSTR(StartT, "H:M", 0));
      ELSE
       RAISE();
      END;
     END;
    ELSE
     ReplaceFirst:=0;
    END;
    RWayJ.Fact  :=L_Way.GetTripsGroup(250, FET, 1);
    RWayJ.StopT :=SEJobs.StopT;
    IF L_SCAD.E_RWayCPLevel(RWayS.Date) THEN
     L_Way.SetRWJQuality();
    ELSE
     RWayJ.Quality:=00;
    END;
    REPLACE(RWayJ);
    IF I = 0 THEN
     FDay  :=RWayJ.Day;
     FStart:=RWayJ.StartT;
    END;
    INC(FirstDay, RWayJ.StopT < RWayJ.StartT);
    INC(I);
    PROMPT("⠢ " + L_Str.IntStr(I) + " ३ᮢ");
   ELSE
    L_General.Assert(StExit.Strict # L_Way.ExitStrict_Reg,
                     " ३ " + SEJobs.Trip + " 室 " + SEJobs.Exit +
                     "| ᯮ  䨪 ." +
                     "||  믮  室  ⠪ ३ᠬ.");
   END;
   NEXT(SEJobs);
  END; (* WHILE SEJobs ... *)
  IF I > 0 THEN
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   SRCINSEL(RWayJ, EQ, , FDay, FStart);
  END;
  RETURN I;
 END {RWayJGroup};

 PRIVATE PROCEDURE SwitchToExit_OnExplicitAskPhase1();
 BEGIN
  (* nothing *)
 END {SwitchToExit_OnExplicitAskPhase1};

 PRIVATE PROCEDURE GetStopTime(VAR _Day: LIKE(RWayJ.Day);
                               VAR _StartT: LIKE(RWayJ.StartT));
 BEGIN
  _Day   :=MAXOF(_Day);
  _StartT:=00:00;
  IF ACCESS(RWayJ) THEN
   SAVE(RWayJ);
   NEXT(RWayJ);
   IF OCCURE(RWayJ) THEN
    _Day   :=RWayJ.Day;
    _StartT:=RWayJ.StartT;
   END;
   RESTORE(RWayJ);
  END;
 END {GetStopTime};

 PRIVATE PROCEDURE SwitchToExit_OnExplicitAskPhase2();
  VAR
   _Day    : LIKE(RWayJ.Day);
   _StartT : LIKE(RWayJ.StartT);
   RWayJDay,
   MaxDay  : LIKE(RWayJ.Day);
   curShift: NUMERIC[0];
   IntStr  : STRING[];
 BEGIN
  GetStopTime(_Day, _StartT);
  IF ACCESS(RWayJ) THEN
   RWayJDay:=RWayJ.Day + (RWayJ.StopT < RWayJ.StartT);
   IntStr  :=" ࢠ ६ "+L_DatTim.TimeStr(RWayJ.StopT)+"-"+L_DatTim.TimeStr(_StartT);
  ELSE
   RWayJDay:=1;
   SETEMPTY(IntStr);
  END;
  SELECT(SEJobs, Exit, , StExit.Exit);
  LAST(SEJobs);
  MaxDay:=Math.Max(RWayJDay, SEJobs.Day);
  curShift:=0;
  LOOP
   SELECT(SEJobs, Exit, , StExit.Exit);
   IF ACCESS(RWayJ) THEN
    IF SRCINSEL(SEJobs, GE, MaxDay - curShift, RWayJ.StopT) THEN
     IF ~(PREV(SEJobs) &
          SELECT(SEJMStop, Trip, SEJobs.Trip) &
          ((SEJobs.StartT+SEJMStop.DTim/60) >= RWayJ.StopT)) THEN
      SRCINSEL(SEJobs, GE, , MaxDay - curShift, RWayJ.StopT);
     END;
    END;
   END;
   IF RWayJGroup(L_Way.FullBegTime(_Day, _StartT), RWayJDay, 0) > 0 THEN
    CONFORM(RWayJ, SEJobs);
    CONFORM(SEJobs, StExit);
    CheckRWayJExitOnDate();
    EXIT;
   END;
   INC(curShift);
   IF curShift >= MaxDay THEN
    L_General.Error(" 室 ३ᮢ:|"+
                    "室 "+StExit.Exit+IntStr);
   END;
  END; (* LOOP *)
 END {SwitchToExit_OnExplicitAskPhase2};

 PUBLIC PROCEDURE SwitchToExit_Do();
 BEGIN
  LIKEMENU(Ask, "StExit 1 " + L_Events.ee_ProcessId + "=SwitchToExit");
 END {SwitchToExit_Do};

 PRIVATE PROCEDURE SwitchToRoute_OnExplicitAskPhase1();
 BEGIN
  (* nothing *)
 END {SwitchToRoute_OnExplicitAskPhase1};

 PRIVATE PROCEDURE SwitchToRoute_OnExplicitAskPhase2();
 BEGIN
  InsRoute(Route.Route);
 END {SwitchToRoute_OnExplicitAskPhase2};

 PUBLIC PROCEDURE SwitchToRoute_Do();
 BEGIN
  IF ACCESS(RWayJ) THEN
   LIKEMENU(Ask, "Route 1 " + L_Events.ee_ProcessId + "=SwitchToRoute");
  ELSE
   L_StdFrm.Inform(" ⠭ ३");
  END;
 END {SwitchToRoute_Do};

 PRIVATE PROCEDURE SwitchToTime_OnExplicitAskPhase1();
 BEGIN
  (* nothing *)
 END {SwitchToTime_OnExplicitAskPhase1};

 PRIVATE PROCEDURE SwitchToTime_OnExplicitAskPhase2();
 BEGIN
  InsExitInTrip();
  LIKEMENU(Cancel, "Save");
 END {SwitchToTime_OnExplicitAskPhase2};

 PUBLIC PROCEDURE SwitchToTime_Do();
 BEGIN
  LIKEMENU(Ask, "StExit 1 " + L_Events.ee_ProcessId + "=SwitchToTime");
 END {SwitchToTime_Do};

 PRIVATE PROCEDURE RemRest();
  VAR
   Asked: SCAL[2];
   I    : SCAL[99];
 BEGIN
  Asked:=0;
  I    :=0;
  WHILE ACCESS(RWayJ) DO
   L_Way.RemoveSingleRWayJ(Asked);
   INC(I);
   PROMPT(" " + L_Str.IntStr(I) + " ३ᮢ");
  END;
 END {RemRest};

 PRIVATE PROCEDURE GoodSEJobs(): SCAL[2];
 BEGIN
  CONFORM(SEJobs, WJMode);
  RETURN (WJMode.WJType = L_Way.WJType_Work) & (WJMode.RunSel = L_Way.runsel_Work);
 END {GoodSEJobs};

 PRIVATE PROCEDURE intInsRoute(_Route: LIKE(Route.Route); wChangeCheck: SCAL[2]; VAR SrcIdent: STRING[]): SCAL[2];
  VAR
   _Change: LIKE(StExit.Change);
   _Day   : LIKE(RWayJ.Day);
   _StartT: LIKE(RWayJ.StartT);
   I      : SCAL[99];
 BEGIN
  GetStopTime(_Day, _StartT);
  SrcIdent:=" "+_Route+" ࢠ ६ "+L_DatTim.TimeStr(RWayJ.StopT)+"-"+L_DatTim.TimeStr(_StartT);
  CONFORM(RWayJ, SEJobs, StExit);
  _Change:=StExit.Change;
  CONFORM(RWayS, Calendar);
  SELECT(SEJobs, Route, , _Route);
  SRCINSEL(SEJobs, GE, , RWayJ.Day + (RWayJ.StopT < RWayJ.StartT), RWayJ.StopT);
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, StExit);
   PROMPT(" " + SEJobs.Trip);
   IF (L_Way._CheckExitOnDate(StExit.Exit, RWayS.Date) = L_Way.exvld_Active) &
      (~wChangeCheck | (_Change = StExit.Change)) & GoodSEJobs() THEN
    SAVE(SEJobs);
    CHANGESEL(SEJobs, Exit, , SEJobs.Exit, SEJobs.Day);
    I:=RWayJGroup(L_Way.FullBegTime(_Day, _StartT), 1, 0);
    RESTORE(SEJobs);
    IF I > 0 THEN
     RETURN 1;
    END;
   END;
   NEXT(SEJobs);
  END;
  RETURN 0;
 END {intInsRoute};

 PRIVATE PROCEDURE InsRoute(_Route: LIKE(Route.Route));
  VAR
   SrcIdent: STRING[];
 BEGIN
  IF ~intInsRoute(_Route, 1, SrcIdent) THEN
   L_General.Assert(intInsRoute(_Route, 0, SrcIdent), " 室 ३ᮢ:|"+SrcIdent);
  END;
 END {InsRoute};

 PRIVATE PROCEDURE InsExitInTrip();
  VAR
   _StartT    : LIKE(RWayJ.StartT);
   _StopT     : LIKE(RWayJ.StopT);
   _Day       : LIKE(RWayJ.Day);
   Rest       : NUMERIC[3];
   InsertedCnt,
   FictTripCnt: SCAL[100];
 BEGIN
  IF ACCESS(RWayJ) & ~!RWayJ.StartT & ~!RWayJ.StopT THEN
   L_General.Assert(StExit.Strict = L_Way.ExitStrict_Fict,
                    "뢠 䨪⨢ 室");
   _Day   :=RWayJ.Day;
   _StartT:=RWayJ.StartT;
   _StopT :=RWayJ.StopT;
   Rest   :=RWayJ.StopT - RWayJ.StartT;
   FictTripCnt:=0;
   CONFORM(StExit, SEJobs);
   WHILE OCCURE(SEJobs) DO
    CONFORM(SEJobs, RoutMod);
    IF L_DatTim.IsActive_Inc(RWayS.Date, RoutMod.FromD, RoutMod.UpDate) THEN
     IF RoutMod.Run # 0 THEN
      DEC(Rest, SEJobs.StopT - SEJobs.StartT);
     ELSE
      INC(FictTripCnt, RoutMod.Run = 0);
     END;
    END;
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs)... *)
   L_General.Assert(Rest > 0, "筮 ६");
   L_General.Assert(FictTripCnt > 0, "  ६");
   InsertedCnt:=0;
   CONFORM(StExit, SEJobs);
   WHILE OCCURE(SEJobs) DO
    CONFORM(SEJobs, RoutMod);
    IF L_DatTim.IsActive_Inc(RWayS.Date, RoutMod.FromD, RoutMod.UpDate) THEN
     INC(InsertedCnt);
     DEFAULT(RWayJ);
     RWayJ.RWayS  :=RWayS.RWayS;
     RWayJ.Trip   :=SEJobs.Trip;
     RWayJ.Quality:=0;
     RWayJ.Fact   :=1;
     RWayJ.Run    :=RoutMod.Run;
     RWayJ.Day    :=_Day;
     RWayJ.StartT :=_StartT;
     IF RoutMod.Run # 0 THEN
      RWayJ.StopT:=_StartT + (SEJobs.StopT - SEJobs.StartT);
     ELSE
      RWayJ.StopT:=_StartT + (Rest / FictTripCnt);
      DEC(Rest, RWayJ.StopT - RWayJ.StartT);
      DEC(FictTripCnt);
     END;
     IF InsertedCnt = 1 THEN
      REPLACE(RWayJ);
      SAVE(RWayJ);
     ELSE
      INSERT(RWayJ);
     END;
     _StartT:=RWayJ.StopT;
     _Day   :=RWayJ.Day + (RWayJ.StartT > RWayJ.StopT);
    END;
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs)... *)
   IF InsertedCnt > 0 THEN
    RWayJ.StopT:=_StopT;
    REPLACE(RWayJ);
    RESTORE(RWayJ);
   END;
  END;
 END {InsExitInTrip};

 PRIVATE PROCEDURE E_SetPTTAttr();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.SetPTTAttr);
  IF ~!Local THEN
   Local();
  END;
 END {E_SetPTTAttr};

 PUBLIC PROCEDURE StandartExit();
  VAR
   Dummy: SCAL[99];
   FET  : NUMERIC[3];
 BEGIN
  L_General.Assert(~!RWayS.RWayS, "室 ।  ⥢ ");
  L_General.Assert(~!RWayS.Exit,  "室 ।   室");
  L_Way.CheckExitOnDate(RWayS.Exit, RWayS.Date, 1);
  FET:=L_Way.FullEndTime(99, 00:00, 00:00);
  CONFORM(RWayS, RWayJ);
  IF OCCURE(RWayJ) THEN
   IF !RWayJ.StopT THEN
    L_StdFrm.Question("⠭ 室  ६ ࢮ ४祭?");
    FET:=L_Way.FullBegTime(RWayJ.Day,  RWayJ.StartT);
   ELSE
    L_StdFrm.Choice(" ३ ⥢   㤠!");
    RemRest();
   END;
  END;
  CONFORM(RWayS, StExit);
  CONFORM(StExit, SEJobs);
  Dummy:=RWayJGroup(FET, SEJobs.Day, 0);
  IF ~L_SCAD.E_RWayCPLevel(RWayS.Date) THEN
   RWayS.DspConn:=StExit.DspConn;
  END;
  RWayS.Change:=StExit.Change;
  RWayS.Gap   :=StExit.Gap;
  RWayS.Type  :=StExit.Type;
  E_SetPTTAttr();
  REPLACE(RWayS);
 END {StandartExit};

 PUBLIC PROCEDURE SameRoute();
 BEGIN
  IF ACCESS(RWayJ) THEN
   CONFORM(RWayJ, SEJobs);
   InsRoute(SEJobs.Route);
  ELSE
   L_StdFrm.Inform(" ⠭ ३");
  END;
 END {SameRoute};

 PUBLIC PROCEDURE RemoveMarkedTrips();
  VAR
   AskedM: SCAL[2];
 BEGIN
  L_StdFrm.Choice("  㤠 ⬥祭 ");
  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  AskedM:=0;
  WHILE OCCURE(RWayJ) DO
   IF WITHLAB(RWayJ, 0) THEN
    L_Way.RemoveSingleRWayJ(AskedM);
   ELSE
    NEXT(RWayJ);
   END;
  END; (* WHILE OCCURE(RWayJ) ... *)
 END {RemoveMarkedTrips};

 PUBLIC PROCEDURE RemoveRestTrips();
 BEGIN
  L_StdFrm.Choice("  㤠   ");
  RemRest();
 END {RemoveRestTrips};

 PRIVATE PROCEDURE GetAnnulQuality(D: DATE): LIKE(RWayJ.Quality);
  VAR
   QualityList,
   NameList: STRING[];
   Cnt     : NUMERIC[0];
 BEGIN
  SETEMPTY(NameList, QualityList); Cnt:=0;
  SELECT(Quality, Quality);
  WHILE OCCURE(Quality) DO
   IF Quality.Type = L_Way.QualType_Annul THEN
    NameList:=NameList+Quality.Quality+" "+Quality.Name+"|";
    QualityList:=QualityList+Quality.Quality+"|";
    INC(Cnt);
   END;
   NEXT(Quality);
  END; (* WHILE OCCURE(Quality) ... *)
  IF    Cnt = 0 THEN
   L_StdFrm.BlueStop(" ࠢ筨  ।  ⢠ ' 믮'");
  ELSIF Cnt = 1 THEN
   RETURN L_Str.PoolItem(QualityList, 0);
  ELSE
   RETURN L_Str.PoolItem(QualityList, L_StdFrm.ShowListAsMenu(NameList, "롮  ⢠"));
  END;
 END {GetAnnulQuality};

 PUBLIC PROCEDURE SetAnnulQuality();
  VAR
   Asked: SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(RWayJ), " ⠭ ३");
  L_StdFrm.Choice("⠭  ⢠ ३ ' 믮'");
  RWayJ.Run:=0;
  RWayJ.Quality:=GetAnnulQuality(RWayS.Date);
  REPLACE(RWayJ);
  Asked:=0;
  L_SCAD.RemSelRWayCP(Asked);
 END {SetAnnulQuality};

 PRIVATE PROCEDURE TKStr(_TKind: LIKE(TKind.TKind)): STRING[];
 BEGIN
  L_General.Assert(SEARCH(TKind, TKind, _TKind), "   ॢ "+_TKind);
  RETURN TKind.TKind+" "+TKind.Name;
 END {TKStr};

 PRIVATE PROCEDURE StandOnDominantTKind();
  VAR
   i      : NUMERIC[0];
   MaxTime: NUMERIC[3];
   DomTK  : LIKE(TKind.TKind);
   TimsTK : NUMERIC[3][MAXOF(TKind.TKind)+1];
   Choice : SCAL[10];
   _Day   : LIKE(RWayJ.Day);
   _StartT: LIKE(RWayJ.StartT);
   MaxTKind,
   _TKind: LIKE(TKind.TKind);
 BEGIN
  SETZERO(i, MaxTime, DomTK, TimsTK);
  _Day   :=RWayJ.Day;
  _StartT:=RWayJ.StartT;
  MaxTKind:=MINOF(TKind.TKind);
  SAVE(RWayJ);
  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayJ) DO
   IF (RWayJ.Day#_Day) | (RWayJ.StartT#_StartT) THEN
    CONFORM(RWayJ, SEJobs, Route);
    CONFORM(SEJobs, WJMode);
    IF WJMode.WJType = L_Way.WJType_Work THEN
     _TKind:=L_Way.GetRouteTKind(RWayS.Date, 1);
     INC(TimsTK[_TKind], RWayJ.StopT-RWayJ.StartT);
     MaxTKind:=Math.Max(MaxTKind, _TKind);
    END;
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
  SETZERO(i, MaxTime, DomTK);
  WHILE i <= MaxTKind DO
   IF MaxTime < TimsTK[i] THEN
    DomTK  := i;
    MaxTime:=TimsTK[i];
   END;
   INC(i);
  END;
  RESTORE(RWayJ);

  L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
  IF (MaxTime>0) & (DomTK # CarLog.TKind) THEN
   Choice:=L_StdFrm.ShowListAsMenu(" ९  : "+TKStr(CarLog.TKind)+
                                  "|         : "+TKStr(DomTK),
                                  "ନ ३ ᮣ᭮ ");
   IF Choice = 0 THEN
    CONFORM(CarLog, TKind);
   ELSE
    SEARCH(TKind, TKind, , DomTK);
   END;
  ELSE
   CONFORM(CarLog, TKind);
  END;
  L_General.Assert(OCCURE(TKind), " ९  ॢ");
 END {StandOnDominantTKind};

 PRIVATE PROCEDURE GetPreviosRoute(): LIKE(Route.Route);
  VAR
   _Route: LIKE(Route.Route);
 BEGIN
  L_General.Assert(~!RWayJ.Day & ~!RWayJ.StartT, "室    ६ 砫 ३");
  SETEMPTY(_Route);
  SAVE(RWayJ);
  CHANGESEL(RWayJ, RWayS, , RWayJ.RWayS, RWayJ.Day);
  IF PREV(RWayJ) THEN
   CONFORM(RWayJ, SEJobs);
   _Route:=SEJobs.Route;
  END;
  RESTORE(RWayJ);
  IF !_Route THEN
   SAVE(RWayJ);
   IF NEXT(RWayJ) THEN
    CONFORM(RWayJ, SEJobs);
    _Route:=SEJobs.Route;
   END;
   RESTORE(RWayJ);
   IF !_Route & ~!RWayS.Exit THEN
    CONFORM(RWayS, StExit, SEJobs);
    _Route:=SEJobs.Route;
   END;
  END;
  L_General.Assert(~!_Route, " । ");
  RETURN _Route;
 END {GetPreviosRoute};

 PRIVATE PROCEDURE E_RWayJ_NeedRouteOutLine(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(RWayS.Date, PROCREF(E_Utils.RWayJ_NeedRouteOutLine), Route.IncSel=0(*, 䨪⨢ *));
 END {E_RWayJ_NeedRouteOutLine};

 PRIVATE PROCEDURE E_RWayJ_NeedTripOutLine(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(RWayS.Date, PROCREF(E_Utils.RWayJ_NeedTripOutLine), 1);
 END {E_RWayJ_NeedTripOutLine};

 PRIVATE PROCEDURE _Align(_Trip, _Route, _Name: STRING[]): STRING[];
 BEGIN
  RETURN Str.Align(_Trip,  11, LEFT)+" "+
         Str.Align(_Route, Str.MaxLength(Route.Route), LEFT)+" "+
         Str.Align(_Name,  32, LEFT);
 END {_Align};

 PRIVATE PROCEDURE ChooseTrip(_Trip: LIKE(SEJobs.Trip)[]);
  VAR
   i   : NUMERIC[0];
   List: STRING[];
 BEGIN
  List:="";
  i:=0;
  WHILE (i<=HIGH(_Trip)) & ~!_Trip[i] DO
   L_General.CallUs(SEARCH(SEJobs, Trip, _Trip[i]));
   CONFORM(SEJobs, Route, RoutMod);
   List:=List+_Align(_Trip[i], Route.Route, RoutMod.Name)+"|";
   INC(i);
  END;
  IF i > 1 THEN
   i:=L_StdFrm.ShowListAsMenu_wCaption(List, " ३", _Align("", "", "䨪"));
  ELSE
   i:=0;
  END;
  L_General.CallUs(SEARCH(SEJobs, Trip, _Trip[i]));
 END {ChooseTrip};

 PRIVATE PROCEDURE E_stol_GetElement(    i       : NUMERIC[0];
                                     VAR _Name   : STRING[];
                                     VAR _WJCode : LIKE(WJMode.WJCode);
                                     VAR _Quality: LIKE(Quality.Quality);
                                     VAR _Trip   : LIKE(SEJobs.Trip);
                                     VAR _Type   : L_Way.tTripOutLine);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.stol_GetElement);
  L_General.Assert(~!Local, " ।  ࠡ");
  Local(RWayS.Date, i, _Name, _WJCode, _Quality, _Trip, _Type);
 END {E_stol_GetElement};

 PUBLIC PROCEDURE SetTripOutLine();
  CONST
   MaxTrip = 32;
  VAR
   WJCodeList,
   WJNameList: STRING[];
   tolType   : L_Way.tTripOutLine;
   Choice    : SCAL[10];
   _Route    : LIKE(Route.Route);
   FindSEJobs: SCAL[2];
   _TripArr  : LIKE(SEJobs.Trip)[MaxTrip];
   i         : SCAL[MaxTrip];
   _Name     : STRING[];
   _WJCode   : LIKE(WJMode.WJCode);
   _Quality  : LIKE(Quality.Quality);
   _Trip     : LIKE(SEJobs.Trip);
 BEGIN
  L_General.Assert(~!RWayS.BoxNbr & ~!RWayS.Date, "  ⮬   ");

  i:=0; SETEMPTY(WJNameList);
  LOOP
   E_stol_GetElement(i, _Name, _WJCode, _Quality, _Trip, tolType);
   IF ~!_Name THEN
    WJNameList:=WJNameList + _Name + "|";
   ELSE
    EXIT;
   END;
   INC(i);
  END; (* LOOP *)

  E_stol_GetElement(L_StdFrm.ShowListAsMenu(WJNameList, "롮  ࠡ"),
                    _Name, _WJCode, _Quality, _Trip, tolType);

  SETEMPTY(_TripArr);
  IF ~!_Trip THEN
   L_General.Assert(SEARCH(SEJobs, Trip, _Trip), "  ३ "+_Trip);
   _TripArr[0]:=_Trip;
  ELSE
   IF    tolType = L_Way.tol_ByFixedRoute THEN
    _Route:=P_Car.GetCarProStrong(RWayS.BoxNbr, RWayS.Date, P_Car.P_FixedRoute);
    L_General.Assert(SEARCH(Route, Route, _Route), "  ࠢ筨 ९  "+_Route);
   ELSIF tolType = L_Way.tol_ByFixedTKind THEN
    _Route:=P_Car.GetCarProStrong(RWayS.BoxNbr, RWayS.Date, P_Car.P_FixedRoute);
    L_General.Assert(SEARCH(Route, Route, _Route), "  ࠢ筨 ९  "+_Route);
    L_Way.StandOnRouteTKind(RWayS.Date);
   ELSIF tolType = L_Way.tol_ByDominantTKind THEN
    StandOnDominantTKind();
   ELSIF tolType = L_Way.tol_ByPreviosRoute THEN
    _Route:=GetPreviosRoute();
   ELSE
    L_General.CallUs(0);
   END;
 
   i:=0;
   SELECT(SEJobs, WJCode, , _WJCode);
   WHILE OCCURE(SEJobs) & (i<=HIGH(_TripArr)) DO
    CONFORM(SEJobs, Route);
    CONFORM(SEJobs, RoutMod);
    IF (tolType = L_Way.tol_ByFixedRoute) | (tolType = L_Way.tol_ByPreviosRoute) THEN
     FindSEJobs:=(SEJobs.Route=_Route) & E_RWayJ_NeedTripOutLine() &
                 L_DatTim.IsActive_Inc(RWayS.Date, RoutMod.FromD, RoutMod.UpDate) &
                 (L_Way._CheckExitOnDate(SEJobs.Exit, RWayS.Date)=L_Way.exvld_Active);
    ELSE
     FindSEJobs:=(L_Way.GetRouteTKind(RWayS.Date, 1)=TKind.TKind) & E_RWayJ_NeedRouteOutLine() & ~L_Way.E_IsGuardIdleExit(RWayS.Date, SEJobs.Exit) &
                 L_DatTim.IsActive_Inc(RWayS.Date, RoutMod.FromD, RoutMod.UpDate) &
                 (L_Way._CheckExitOnDate(SEJobs.Exit, RWayS.Date)=L_Way.exvld_Active);
    END;
    IF FindSEJobs THEN
     _TripArr[i]:=SEJobs.Trip;
     INC(i);
    END;
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs) ... *)
  END;
 
  IF (tolType = L_Way.tol_ByFixedRoute) | (tolType = L_Way.tol_ByPreviosRoute) THEN
   L_General.Assert(~!_TripArr[0], "  ᮮ⢥騩 室   "+_Route);
  ELSE
   L_General.Assert(~!_TripArr[0], "  ᮮ⢥騩 室   ॢ|"+TKind.TKind+" "+TKind.Name);
  END;
 
  IF ~!RWayJ.Trip THEN
   L_StdFrm.Choice(" 㦥 ");
  END;
  ChooseTrip(_TripArr);
  RWayJ.Trip:=SEJobs.Trip;
  IF !RWayJ.Run THEN
   RWayJ.Run:=0;
  END;
  REPLACE(RWayJ);
  CONFORM(SEJobs, StExit);
  IF !RWayS.Exit & (StExit.Strict # L_Way.ExitStrict_Fict) THEN
   RWayS.Exit:=SEJobs.Exit;
   L_BegRWS.SetExitData();
   REPLACE(RWayS);
  END;
 END {SetTripOutLine};

 PRIVATE PROCEDURE RWayJ_OnAfterEdIns(AfterIns: SCAL[2]);
 BEGIN
  CONFORM(RWayS, Calendar);
  CONFORM(RWayJ, SEJobs, Route, WJMode, Quality);
  CONFORM(SEJobs, StExit, RoutMod);
  IF (StExit.Strict = L_Way.ExitStrict_Reg) & (AfterIns | (RWayJ.Run # GE_PVALUE(RWayJ.Run))) &
     (RWayJ.Run # RoutMod.Run) THEN
   L_StdFrm.Choice("஡  ᮮ⢥ ஡  ᯨᠭ");
  END;
  L_General.Assert((RWayJ.Fact > 0) | (Quality.Type = L_Way.QualType_Annul), " 믮 ३ ⨬ 㪠뢠 0 ३ᮢ");
  CheckStrictExit();
  CheckAnyExit();
  CheckNonStrictExit();
 END {RWayJ_OnAfterEdIns};

 PRIVATE PROCEDURE RWayJ_OnAfterEdit();
 BEGIN
  RWayJ_OnAfterEdIns(0);
 END {RWayJ_OnAfterEdit};

 PRIVATE PROCEDURE RWayJ_OnAfterInsert();
 BEGIN
  RWayJ_OnAfterEdIns(1);
 END {RWayJ_OnAfterInsert};

 PRIVATE PROCEDURE RWayJ_OnBeforeInsert();
  VAR
   _StartT    : LIKE(RWayJ.StartT);
   _Day       : LIKE(RWayJ.Day);
 BEGIN
  L_Way.SetRWJQuality();
  _Day:=RWayJ.Day;
  _StartT:=GE_PVALUE(RWayJ.StopT);
  IF ~!_StartT THEN
   IF GE_PVALUE(RWayJ.StartT) > _StartT THEN
    INC(_Day);
   END;
   SAVE(RWayJ);
   IF SEARCH(RWayJ, RWayS, RWayS.RWayS, _Day, _StartT) THEN
    RESTORE(RWayJ);
   ELSE
    RESTORE(RWayJ);
    RWayJ.Day   :=_Day;
    RWayJ.StartT:=_StartT;
    REPLACE(RWayJ);
   END;
  END;
 END {RWayJ_OnBeforeInsert};

 PRIVATE PROCEDURE CheckHasImportedRWayJP();
 BEGIN
  CONFORM(RWayJ, RWayJP);
  WHILE OCCURE(RWayJP) DO
   IF (RWayJP.Source = L_Way.rwjpSrc_Import) THEN
    L_StdFrm.CrucialChoice(" ३ "+ RWayJ.Day + " " + L_DatTim.TimeStr(RWayJ.StartT) +
                           "  ஢ ⥫." +
                           "||   㤠?", L_APtm.g_RWOp);
    SysLog.Mark("RWayJ",
                RWayJ.RWayS + " " + RWayJ.Day + " " + L_DatTim.TimeStr(RWayJ.StartT) +
                ":    ஢묨 ⥫ﬨ");
    RETURN;
   END;
   NEXT(RWayJP);
  END; (* WHILE OCCURE(RWayJP) ... *)
 END {CheckHasImportedRWayJP};

 PRIVATE PROCEDURE RWayJ_OnBeforeDelete();
  VAR
   WasAsk: SCAL[2];
 BEGIN
  WasAsk:=0;
  L_SCAD.RemSelRWayCP(WasAsk);
  CheckHasImportedRWayJP();
 END {RWayJ_OnBeforeDelete};

 CONST
  ZeroRunAmnt = 10;

 VAR
  ParkStop: LIKE(Stop.Stop);

 VAR
  ZeroRunArr : LIKE(RoutMod.Run)[ZeroRunAmnt];
  ZeroTimArr : LIKE(RoutMod.Tim[0])[ZeroRunAmnt];
  StopArr    : LIKE(Stop.Stop)[ZeroRunAmnt];
  ModifArr   : LIKE(RoutMod.Modif)[ZeroRunAmnt];
  RouteArr   : LIKE(RoutMod.Route)[ZeroRunAmnt];
  DoneArr    : SCAL[2][MAXOF(Stop.Stop)];
  RunThisTrip: LIKE(RoutMod.Run);
  ListIdx    : STRING[];

 PRIVATE PROCEDURE StopForReturnInPark(_Stop: LIKE(Stop.Stop); VAR Idx: NUMERIC[0]): SCAL[2];
 BEGIN
  Idx:=0;
  WHILE Idx <= HIGH(StopArr) DO
   IF (StopArr[Idx] = _Stop) & ~DoneArr[_Stop] THEN
    DoneArr[_Stop]:=1;
    RETURN 1;
   END;
   INC(Idx);
  END;
  RETURN 0;
 END {StopForReturnInPark};

 PRIVATE PROCEDURE StopStr(_Stop: LIKE(Stop.Stop)): STRING[];
 BEGIN
  L_General.Assert(SEARCH(Stop, Stop, _Stop), "  ⠭ "+_Stop);
  RETURN Stop.Stop+" ("+L_Str.Left(L_Way.GetStopName(Stop.Stop), 15)+")";
 END {StopStr};

 PRIVATE PROCEDURE ScanRtMStop(Dir: SCAL[2]; _CurStopNbr: LIKE(RtMStop.StopNbr)): STRING[];
  VAR
   Idx  : NUMERIC[0];
   _S,
   List : STRING[];
   _ADis: LIKE(RtMStop.ADis);
   _ATim: LIKE(RtMStop.ATim[0]);
   CurStop: LIKE(RtMStop.Stop);
   First  : SCAL[2];
 BEGIN
  SETEMPTY(List);
  SELECT(RtMStop, Route, , RoutMod.Route, RoutMod.Modif);
  SRCINSEL(RtMStop, EQ, , _CurStopNbr);
  CurStop:=RtMStop.Stop;
  IF RoutMod.Dir # SEJobs.Dir THEN
   _ADis:=RoutMod.Run - RtMStop.ADis;
   _ATim:=RoutMod.Tim[SEJobs.RtMVer] - RtMStop.ATim[SEJobs.RtMVer];
  ELSE
   _ADis:=RtMStop.ADis;
   _ATim:=RtMStop.ATim[SEJobs.RtMVer];
  END;
  RunThisTrip:=_ADis;
  IF Dir = L_Way.dir_Forward THEN
   IF ~NEXT(RtMStop) THEN
    SRCINSEL(RtMStop, EQ, , _CurStopNbr);
   END;
  ELSE
   IF ~PREV(RtMStop)  THEN
    SRCINSEL(RtMStop, EQ, , _CurStopNbr);
   END;
  END;
  WHILE OCCURE(RtMStop) DO
   First:=1;
   WHILE StopForReturnInPark(RtMStop.Stop, Idx) DO
    IF RtMStop.StopNbr # _CurStopNbr THEN
     IF Dir = L_Way.dir_Forward THEN
      INC(ZeroRunArr[Idx], RtMStop.ADis-_ADis);
      INC(ZeroTimArr[Idx], RtMStop.ATim[SEJobs.RtMVer]-_ATim);
     ELSE
      INC(ZeroRunArr[Idx], _ADis-RtMStop.RDis);
      INC(ZeroTimArr[Idx], _ATim-RtMStop.ATim[SEJobs.RtMVer]);
     END;
    END;
    SAVE(RoutMod);
    L_General.CallUs(SEARCH(RoutMod, Route, RouteArr[Idx], ModifArr[Idx]));
    INC(ZeroRunArr[Idx], RoutMod.Run);
    INC(ZeroTimArr[Idx], RoutMod.Tim[SEJobs.RtMVer]);
    RESTORE(RoutMod);
    ListIdx:=ListIdx+L_Str.IntStr(Idx)+"|";
    IF First & (CurStop#RtMStop.Stop) THEN
     _S:=StopStr(CurStop)+"-";
     First:=0;
    ELSE
     _S:="";
    END;
    List:=List+Str.Align(_S+StopStr(RtMStop.Stop)+"-"+StopStr(ParkStop), 49, LEFT) +" "+L_Str.NumericStr(ZeroRunArr[Idx], 2)+" , "+L_Str.NumericStr(ZeroTimArr[Idx], 0)+" |";
   END;
   IF Dir = L_Way.dir_Forward THEN
    NEXT(RtMStop);
   ELSE
    PREV(RtMStop);
   END;
  END; (* WHILE OCCURE(RtMStop) ... *)
  RETURN List;
 END {ScanRtMStop};

 PUBLIC PROCEDURE SetZeroTripRun();
  VAR
   i         : NUMERIC[0];
   ZeroTrip  : LIKE(SEJobs.Trip)[ZeroRunAmnt];
   List      : STRING[];
   _NewDay   : LIKE(RWayJ.Day);
   _NewStartT: LIKE(RWayJ.StartT);
   _NewStopT : LIKE(RWayJ.StopT);
   CurStopNbr: LIKE(RtMStop.StopNbr);
 BEGIN
  L_General.Assert(ACCESS(RWayJ), " ⠭ ३");
  ParkStop:=L_Way.E_GetStopInPark();
  L_General.Assert(~!ParkStop, " । ⠭ ''");

  CONFORM(RWayJ, SEJobs);
  IF RWayJ.Fact > 1 THEN
   L_General.Assert(L_Way.GetTripsGroup(RWayJ.Fact, L_Way.FullEndTime(99, 00:00, 00:00), 0) = RWayJ.Fact, " ᯨᠭ  ⠪ ⢠ ३ᮢ");
   (* 㯯 ३ᮢ ⠥,  ࢠ ᫥ ( ࠢ 冷 ⠪஢)*)
   _NewStartT:=RWayJ.StopT - (SEJobs.StopT-SEJobs.StartT);
   _NewStopT :=RWayJ.StopT;
   _NewDay   :=RWayJ.Day + (_NewStartT > _NewStopT);
   SAVE(RWayJ);
   WHILE SEARCH(RWayJ, RWayS, RWayS.RWayS, _NewDay, _NewStopT) DO
    INC(_NewStopT, 1/60);
    _NewDay:=_NewDay + (_NewStartT > _NewStopT);
   END;
   RESTORE(RWayJ);
   DEC(RWayJ.Fact);
   RWayJ.StopT:=_NewStartT;
   REPLACE(RWayJ);
   RWayJ.Trip :=SEJobs.Trip;
   RWayJ.Day  :=_NewDay;
   RWayJ.StartT:=_NewStartT;
   RWayJ.StopT:=_NewStopT;
   RWayJ.Fact:=1;
   INSERT(RWayJ);
  END;

  L_General.Assert(GoodSEJobs(), " ந⢥ ३ "+SEJobs.Trip);

  SETEMPTY(StopArr, ModifArr, RouteArr); SETZERO(DoneArr);  (*ᯨ᮪ 㫥 ஡ / ઠ*)
  i:=0;
  SAVE(SEJobs);
  SELECT(SEJobs, Exit, , SEJobs.Exit);
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, WJMode);
   IF WJMode.RunSel = L_Way.runsel_Zero THEN
    CONFORM(SEJobs, RoutMod);
    IF SELECT(RtMStop, Route, RoutMod.Route, RoutMod.Modif) &
       (((RoutMod.Dir=L_Way.dir_Forward) & (RtMStop.Stop=ParkStop)) |
        ((RoutMod.Dir=L_Way.dir_Backward) & LAST(RtMStop) & (RtMStop.Stop=ParkStop))) THEN
     IF RoutMod.Dir=L_Way.dir_Forward THEN
      LAST(RtMStop);
     ELSE
      FIRST(RtMStop);
     END;
     ZeroTrip[i]:=SEJobs.Trip;
     StopArr[i] :=RtMStop.Stop;
     RouteArr[i]:=RoutMod.Route;
     ModifArr[i]:=RoutMod.Modif;
     INC(i);
    END;
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
  RESTORE(SEJobs);
  L_General.Assert(i>0, "  ३  㫥 ஡ (): 室 "+SEJobs.Exit);

  List:="";
  CONFORM(SEJobs, RoutMod);         (*ᯨ᮪ ⠭ ३, ஬ ࢮ*)
  CONFORM(RoutMod, RtMStop);
  IF RoutMod.Dir = SEJobs.Dir THEN
   NEXT(RtMStop);
  ELSE
   LAST(RtMStop);
   PREV(RtMStop);
  END;
  WHILE OCCURE(RtMStop) DO
   List:=List+RtMStop.StopNbr+" "+Str.Align(StopStr(RtMStop.Stop), 22, LEFT)+" "+
              L_DatTim.TimeStr(L_Way.GetStopCtrlTime_ofCurrentTrip(SEJobs.StartT, RWayS.Date))+"|";
   IF RoutMod.Dir = SEJobs.Dir THEN
    NEXT(RtMStop);
   ELSE
    PREV(RtMStop);
   END;
  END; (* WHILE OCCURE(RtMStop) ... *)
  LAST(RtMStop);

  i:=L_StdFrm.ShowListAsMenu_wCaption(List, "⠭ 室", "#  ⠭              ६");
  CurStopNbr:=Str.Item(L_Str.PoolItem(List, i), " ", 0);

  SETZERO(ZeroRunArr, ZeroTimArr); ListIdx:="";
  List:=ScanRtMStop(L_Way.dir_Forward, CurStopNbr);
  List:=List+ScanRtMStop(L_Way.dir_Backward, CurStopNbr);

  RWayJ.Run:=RunThisTrip;
  REPLACE(RWayJ);

  IF !List THEN
   L_StdFrm.RedInform("஡  ३ "+RWayJ.Trip+" ⠭ "+L_Str.NumericStr(RWayJ.Run, 2)+
                      "|㫥 ஡  ઠ  ");
   RETURN;
  END;

  i:=L_StdFrm.ShowListAsMenu(List, "㫥 ஡  ⠭ 室");
  i:=STRTOFLD(L_Str.PoolItem(ListIdx, i), NUMERIC);

  L_General.Assert(~!RWayJ.StartT & ~!RWayJ.StopT, "室  ६ 砫  砭");
  _NewDay   :=RWayJ.Day + (RWayJ.StartT > RWayJ.StopT);
  _NewStartT:=RWayJ.StopT;
  _NewStopT :=_NewStartT+ZeroTimArr[i]/60;
  WHILE SEARCH(RWayJ, RWayS, RWayS.RWayS, _NewDay, _NewStartT) DO
   INC(_NewStartT, 1/60);
  END;
  DEFAULT(RWayJ);
  RWayJ.RWayS  :=RWayS.RWayS;
  RWayJ.Day    :=_NewDay;
  RWayJ.StartT :=_NewStartT;
  RWayJ.StopT  :=_NewStopT;
  RWayJ.Trip   :=ZeroTrip[i];
  RWayJ.Quality:=000;
  RWayJ.Fact   :=1;
  RWayJ.Run    :=ZeroRunArr[i];
  INSERT(RWayJ);
 END {SetZeroTripRun};

 PUBLIC PROCEDURE TaxTheSwitch();
  VAR
   FET: NUMERIC[3];
 BEGIN
  L_General.Assert(ACCESS(RWayJ), " ⠭ ⥪   ' ⥢ '");
  L_General.Assert(!RWayJ.StopT, "஢ ४祭 믮 ⮫쪮  ३-४祭");
  SAVE(RWayJ);
  IF NEXT(RWayJ) THEN
   FET:=L_Way.FullBegTime(RWayJ.Day,  RWayJ.StartT);
  ELSE
   FET:=L_Way.FullEndTime(99, 00:00, 00:00);
  END;
  RESTORE(RWayJ);
  CONFORM(RWayJ, SEJobs);
  CHANGESEL(SEJobs, Exit, , SEJobs.Exit);
  WHILE  L_Way.FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT) <
         L_Way.FullBegTime(RWayJ.Day,  RWayJ.StartT) DO
   L_General.Assert(NEXT(SEJobs), " 祣 室饣");
  END;
  CONFORM(SEJobs, StExit);
  IF StExit.Strict = L_Way.ExitStrict_Reg THEN
   IF RWayJGroup(FET, RWayJ.Day, 1) = 0 THEN
    L_General.Error(" 祣 室饣");
   END;
  ELSE
   L_General.Error("஢ ४祭 믮 ⮫쪮  ॣ୮ 室");
  END;
 END {TaxTheSwitch};

 PUBLIC PROCEDURE DistributeCP();
 BEGIN
  L_General.Assert(~!RWayJ.Trip, "室 ।  ३");
  L_SCAD.DistributeCP();
 END {DistributeCP};

BEGIN
 L_Events.ExecuteHandler();
END.
