(*
%Copyright   (c) Polak Computer System
%Author      04.04.1997 11:59:26 SAN
%Purpose     ࠢ 䨪樥 RWayJP
%Type        control
%Specific    AP
%Modified    26.11.2013 14:16:17 POLAK\Gina
%Environment
*)

 MODULE RWayJP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Way, E_Way, L_Events, L_StdFrm, L_Car;

 PUBLIC PROCEDURE MakeAnyRWJPBlank();
  VAR
   _RWJPro: LIKE(RWayJP.RWJPro);
   _Value : LIKE(RWayJP.Value);
   Need   : SCAL[2];
   List   : STRING[];
   local  : PROC;
 BEGIN
  L_General.Assert(ACCESS(RWayJP), " । ⥫");
  _RWJPro:=RWayJP.RWJPro;
  _Value :=RWayJP.Value;
  CONFORM(RWayJP, RWJPro);
  IF    RWayJP.RWJPro = L_Way.rwjp_PlanIsEqualFact THEN
   List:="0  ⥫|1  ࠢ 䠪";
   local :=PROCREF(E_Way.PlEqFcRWayJP);
   IF ~!local THEN
    local(RWayS.Date, List);
   END;
   STDFORM(L_StdFrm.sf_Choice("|祭: %###########################%", "%LAI"),
           ' ⠢ "=䠪"  室   ३', CHOICE, -1, List, _Value);
  ELSIF RWJPro.Type # L_Way.rwjpt_RateSpecific THEN
   L_StdFrm.Choice("஢ ⥫ '"+RWJPro.RWJPro+" "+RWJPro.Name+"'|  ३");
  END;
  SAVE(RWayJ);
  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayJ) DO
   IF (RWJPro.Type = L_Way.rwjpt_PassTransportation) | (_RWJPro = L_Way.rwjp_PlanIsEqualFact) THEN
    CONFORM(RWayJ, SEJobs, Route, WJMode, Quality);
    Need:=(WJMode.IncSel * Route.IncSel # 0) & (Quality.Type # L_Way.QualType_Annul);
   ELSE
    CONFORM(RWayJ, Quality);
    Need:=Quality.Type # L_Way.QualType_Annul;
   END;
   IF Need THEN
    L_Way.SetRWayJP(_RWJPro, _Value, L_Way.rwjpSrc_Opert);
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ)... *)
  RESTORE(RWayJ);
 END {MakeAnyRWJPBlank};

 PRIVATE PROCEDURE SetValueFormat(ForceLossValue: SCAL[2]);
  VAR
   Format: STRING[];
 BEGIN
  IF ~ACCESS(RWayS) THEN
   CONFORM(RWayJP, RWayS);
  END;
  IF (L_Way.E_GetLossReasonCode(RWayS.Date) # L_Way.rwjp_Fict) &
     (ForceLossValue & (RWayJP.RWJPro = L_Way.E_GetLossReasonCode(RWayS.Date))) THEN
   Format:=L_Way.E_GetLossReasonPool(RWayS.Date);
  ELSE
   Format:="3.";
  END;
  RTI.Get().CurZone.Fields("RWayJP.Value").Format:=Format;
 END {SetValueFormat};

 PRIVATE PROCEDURE E_TimeLength(rwjp: LIKE(RWJPro.RWJPro)): SCAL[2];
 BEGIN
  RETURN (L_General.GetAPSiteNumber() = 10) & (rwjp = 68);
 END {E_TimeLength};

 PRIVATE PROCEDURE SetSpecificRWJProModifying();
  VAR
   AskMode: NUMERIC[0];
 BEGIN
  L_General.Assert(~!RWayS.BoxNbr, " 㪠 ");
  L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
  IF E_TimeLength(RWayJP.RWJPro) THEN
   AskMode:=WFD_ASK_MANUAL;
  ELSE
   AskMode:=WFD_ASK_SYSTEM;
  END;

  RTI.Get().CurZone.Fields(GE_CURFILE()+".Value").AskMode    :=AskMode;
  RTI.Get().CurZone.Fields(GE_CURFILE()+".Value").OnBeforeAsk:=AskMode = WFD_ASK_MANUAL;
 END {SetSpecificRWJProModifying};

 PRIVATE PROCEDURE RWayJP_RWJPro_OnSuccessfulChange();
 BEGIN
  SetValueFormat(1);
  SetSpecificRWJProModifying();
  IF L_Way.E_VldPsgPlanLev(RWayS.Date) THEN
   L_General.Assert(RWayJP.RWJPro # E_Way.rwjp_TermPassPlan,
                    "⥫ " + RWayJP.RWJPro + " ଫ ⮫쪮 ⮬᪨");
  END;
 END {RWayJP_RWJPro_OnSuccessfulChange};

 PRIVATE PROCEDURE RWayJP_Value_CheckTimeVal();
 BEGIN
  L_General.Assert(RWayJP.Value >= 0, "祭 ⥫    ⥫");
  L_General.Assert(RWayJP.Value < 24, "த⥫쭮   ॢ 23,99 ");
 END {RWayJP_Value_CheckTimeVal};

 PRIVATE PROCEDURE RWayJP_Value_OnSuccessfulChange();
  VAR
   Fields: FORMFIELDS;
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = "RWayJPE_T" THEN
   RWayJP_Value_CheckTimeVal();
   Fields:=RTI.Get().CurZone.Fields;
   IF    ~!Fields("v_StartT").Value THEN
    Fields("v_StopT").Value:=Fields("v_StartT").Value + RWayJP.Value;
   ELSIF ~!Fields("v_StopT").Value THEN
    Fields("v_StartT").Value:=Fields("v_StopT").Value - RWayJP.Value;
   END;
  END;
 END {RWayJP_Value_OnSuccessfulChange};

 PRIVATE PROCEDURE RWayJP_Value_OnBeforeAskForEdit();
 BEGIN
  LIKEMENU(Edit, "RWayJPE_T 0");
 END {RWayJP_Value_OnBeforeAskForEdit};

 PRIVATE PROCEDURE RWayJPE_T_0_OnZoneOpen();
  VAR
   Fields: FORMFIELDS;
 BEGIN
  CONFORM(RWayJP, RWayJ);
  Fields:=RTI.Get().CurZone.Fields;
  Fields("v_StartT").Value:=RWayJ.StartT;
  IF !RWayJP.Value THEN
   SETEMPTY(Fields("v_StopT").Value);
  ELSE
   RWayJP_Value_CheckTimeVal();
   Fields("v_StopT").Value:=Fields("v_StartT").Value + RWayJP.Value;
  END;
 END {RWayJPE_T_0_OnZoneOpen};

 PRIVATE PROCEDURE RWayJP__OnSuccessfulChange();
  VAR
   Fields: FORMFIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF ~!Fields("v_StartT").Value & ~!Fields("v_StopT").Value THEN
   RWayJP.Value:=Fields("v_StopT").Value - Fields("v_StartT").Value;
   REPLACE(RWayJP);
  END;
 END {RWayJP__OnSuccessfulChange};

 PRIVATE PROCEDURE CheckFormat(curValue : LIKE(RWayJP.Value));
  VAR
   Prod: NUMERIC[3];
 BEGIN
  IF    RWJPro.Format = 0 THEN Prod:=curValue *    1;
  ELSIF RWJPro.Format = 1 THEN Prod:=curValue *   10;
  ELSIF RWJPro.Format = 2 THEN Prod:=curValue *  100;
  ELSIF RWJPro.Format = 3 THEN Prod:=curValue * 1000;
  ELSE
   L_General.CallUs(0);
  END;
  L_General.Assert(Prod MOD 1 = 0, "祭 ⥫ '" + RWJPro.Name + "'" +
                                   "|  㪠뢠  筮  " + RWJPro.Format +
                                   "  ᫥ ⮩");
 END {CheckFormat};

 PRIVATE PROCEDURE RWayJP_OnAfterEdIns();
 BEGIN
  L_General.Assert(RWayJP.Source = L_Way.rwjpSrc_Opert, "䨪 ⮬᪨ ᫥ ⥫ 饭");
  CONFORM(RWayJP, RWJPro);
  CONFORM(RWayJP, RWayJ, RWayS);
  L_General.Assert(~!RWayJ.Quality, "室 । ⢮");
  IF RWayJP.RWJPro = L_Way.E_GetLossReasonCode(RWayS.Date) THEN
   CONFORM(RWayJP, RWayJ);
   CONFORM(RWayJ, Quality);
   L_General.Assert(Quality.Type = L_Way.QualType_Annul,
                    " ⮬ ३    ⥫,|易  ﬨ");
  ELSIF (RWayJP.RWJPro = L_Way.rwjp_PlanIsEqualFact) | (RWJPro.Type = L_Way.rwjpt_PassTransportation) THEN
   CONFORM(RWayJP, RWayJ);
   CONFORM(RWayJ, SEJobs, Route, WJMode, Quality);
   IF ((WJMode.IncSel * Route.IncSel = 0) |
       (Quality.Type = L_Way.QualType_Annul)) THEN
    L_General.Error(" ⮬ ३    ⥫,|易  ॢ ᠦ஢");
   END;
  END;
  CheckFormat(RWayJP.Value);
  SetValueFormat(0);
 END {RWayJP_OnAfterEdIns};

 PRIVATE PROCEDURE RWayJP_OnAfterEdit();
 BEGIN
  RWayJP_OnAfterEdIns();
 END {RWayJP_OnAfterEdit};

 PRIVATE PROCEDURE RWayJP_OnAfterInsert();
 BEGIN
  RWayJP_OnAfterEdIns();
 END {RWayJP_OnAfterInsert};

 PRIVATE PROCEDURE RWayJP_OnBeforeEdDel();
 BEGIN
  L_General.Assert(RWayJP.Source = L_Way.rwjpSrc_Opert,
                   "䨪 ⮬᪨ ᫥ ⥫ 饭");
 END {RWayJP_OnBeforeEdDel};

 PRIVATE PROCEDURE RWayJP_OnBeforeEdit();
 BEGIN
  RWayJP_OnBeforeEdDel();
  SetValueFormat(1);
  SetSpecificRWJProModifying();
 END {RWayJP_OnBeforeEdit};

 PRIVATE PROCEDURE RWayJP_OnBeforeInsert();
 BEGIN
  SetValueFormat(0);
  SetSpecificRWJProModifying();
 END {RWayJP_OnBeforeInsert};

 PRIVATE PROCEDURE RWayJP_OnBeforeDelete();
 BEGIN
  RWayJP_OnBeforeEdDel();
 END {RWayJP_OnBeforeDelete};

 PRIVATE PROCEDURE RWayJPV_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("RWayJP.Source").Format:=L_Way.rwjpSrc_Pool;
 END {RWayJPV_1_OnZoneOpen};

BEGIN
 L_Events.ExecuteHandler();
END.
