(*
%Copyright   (c) Polak Computer System
%Author      SAN
%Purpose       ⥢ 
%Type        control
%Specific    AP
%Modified    10.09.2014 10:54:43 POLAK\Bor
%Environment
*)

 MODULE RWayS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_OwnData, L_Events, L_Staff, L_Way, L_Car, L_EC, L_CI,
        L_PRoll, L_SCAD, L_Hld, L_Card, L_Money, L_Sheet, L_Str, L_AP, L_Fuel,
        L_APtm, L_MathR, L_BegRWS, L_Math, L_StdFrm, L_XDoc, L_MDoc, L_XObj,
        L_AcCut, L_Acnt, P_Staff, P_Math, P_Car, L_AFM, L_WDO, L_AcsPnt,
        Str, Math, Memo, E_Stock, E_Way, L_Env, L_Stock, L_two, L_APWI, L_TRS,
        L_JDoc, L_RWayS, L_Msg, L_PCS;

 TYPE
  tPay     = LIKE(WagePayL.Pay[0]);
  tRWMoney = NUMERIC[6];
  tRWRSal  = SCAL[4];

 CONST
  TripAmount = L_RWayS.TripAmount;
  MaxTKnd    = MAXOF(TKind.TKind)+1;
  WhoNbr     = 006;
  MaxCBox    = 030;
  FCAmnt     = 024;

  Dr      = L_Way.rwswho_Driver;
  Gu      = L_Way.rwswho_Guard;
  Dp      = L_Way.rwswho_DrPupil;
  Gp      = L_Way.rwswho_GuPupil;

  rwrs_Short                 = 0; (*tRWRSal RWRSal*)
  rwrs_WithTrips             = 1;
  rwrs_WithTripsAndMoney     = 2;
  rwrs_WithTripsAndZeroMoney = 3;

 VAR
  ToTS,
  ForTEP,
  CarMan                 : STRING[9];
  FStore                 : NUMERIC[0];

  PayTime,
  TotalTime,
  TotalNight,
  TotalHolid,
  TotalDayTime,
  CurTime,
  AddTime,
  WrkTime,
  CurNight,
  CurHolid,
  CurDayTime             : NUMERIC[3];

  CurIncome              : NUMERIC[2];

  CurRun,
  ZrRun,
  TotalRun               : LIKE(CarRun.Run);
  GlobalRun              : LIKE(CarRun.TotRun);

  CurWho                 : L_Way.tRWSWho;

  TS                     : NUMERIC[3];

  TripNbr                : SCAL[TripAmount];

  _FNorm                 : LIKE(RWayS.FuelNorm)[MaxTKnd];
  TK_AcCut               : LIKE(AcCut.AcCut)   [MaxTKnd];

  TripArrVld,
  TripArr                : SCAL[Math.Pow(2, WhoNbr)][TripAmount];
  VldDvdr,
  IPlDvdr                : NUMERIC[0]          [TripAmount];
  TripIPl                : LIKE(RWayJ.PlIncome)[TripAmount];
  ForFN                  : LIKE(RWayJ.FNorm)   [TripAmount];
  Sal                    : LIKE(RWayJ.ByTS)    [TripAmount];
  TripPsgPl              : L_APWI.tVldPsgAmnt  [TripAmount];

  CBoxLevel              : SCAL[3];
  CBoxNbr                : NUMERIC[0];
  CBoxSigntr             : STRING[16]          [MaxCBox];
  CBoxByCash,
  CBoxIncome,
  CBoxIncPln             : NUMERIC[2]          [MaxCBox];

  ToSheet                : LIKE(RWayS.ToSheet);
  ToPay                  : LIKE(RWayS.ToPay);
  HasGap                 : L_Way.tGapType;

  RWRExp, (*Expanded*)
  RWRDo,
  RWLDo,
  RWProc,
  Final,
  RWMDo,
  StreamMode,
  KioskMode              : SCAL[2];
  KioskTSN               : LIKE(Staff.TSN);

  Who                    : STRING[18][WhoNbr];
  RWFin                  : STRING[4];

  ByTSone,
  TSsum                  : tRWMoney;

  ForFuel                : NUMERIC[2];
  HigTKind               : LIKE(TKind.TKind);

  _n                     : LIKE(MoneyRul.Number);
  _TSN                   : LIKE(Staff.TSN);

  WithGuVld,
  WithGu,
  WithDp                 : NUMERIC[0];

  Holidays               : SCAL[2][TripAmount];

  Econ                   : LIKE(RWayF.RemExit)[FCAmnt];
  EconMaths              : LIKE(Math.Math)    [FCAmnt];
  RWRSal                 : tRWRSal;

  mg_WagePay             : LIKE(MarkG.MarkG);
  MJComment              : STRING[];

  WithASCP,
  WithInvFacil           : SCAL[2];

  IamInBeforeEdit        : SCAL[2];

(*-------------RWayPrt.ASL--------------------*)

 CONST
  MonCol = 20;
  MemCol = 10;

 VAR
  _Sum   : LIKE(Money.Sum)    [MonCol];
  _Tim   : LIKE(Money.Tim)    [MonCol];
  SMem   : STRING[9]          [MemCol];
  Mon_Idx: LIKE(MCList.MCode) [MAXOF(MCList.MCode)+1];
  Mem_Idx: LIKE(MtyIdx.MtyIdx)[100];

 PRIVATE PROCEDURE PutFncDtl(): STRING[];
 BEGIN
  IF (CurWho = Gu) & (WayLMen.FncDtl > L_Way.wlmdtl_Full) THEN
   RETURN " ("+L_Str.PoolItem(L_Way.wlmdtl_Pool, WayLMen.FncDtl)+")";
  END;
  RETURN "";
 END {PutFncDtl};

(*
$P { Header:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
L_Str.PoolItem("⮪ ࠡ⪨ ⥢ |  ' ⠪஢'  ", RWRExp), R, ""
RWayS.RWayS, L, "", "B"
RWayS.Date, L, "D.N.y"
RWayS.Exit, L, ""
RWayS.Change, R, ""
RWayS.Gap, R, "-|+"
RWFin, L, ""
Car.BoxNbr, L, ""
Car.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
@
############################################################# ########## #####
==============================================================================
|     ########################################## #######  ##########       |
|----------------------------------------------------------------------------|
|                                  室: #########    : #  : #  : ##|
|---࠭ᯮ⭮ ।⢮---------------ઠ--------------------------------|
|   .  .                                           |
|   ####  ##########                    #### ################################|
}
*)

(*
$P { HeaderK:
RWayS.RWayS, L, ""
RWayS.Date, L, "D.N.y"
RWayS.Exit, L, ""
RWayS.Change, R, ""
RWayS.Gap, R, "-|+"
RWFin, L, ""
Car.BoxNbr, L, ""
Car.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
@
|----------------------------------------------------------------------------|
| #######    ##########    室 #########     #   #   ##|
| ####  ##########              ઠ #### ################################|
}
*)

(*
$P{ CarLine:
Car.BoxNbr, L, ""
Car.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
@
|   ####  ##########                    #### ################################|
}
*)

(*
$P { StaffLine :
L_Str.PoolItem("⥫||- ⥫|- |2- ⥫|稪", CurWho)+PutFncDtl()+"====================", L, ""
Staff.TSN, L, ""
Man.Name, L, ""
StaffLog.Class, R, ""
Post.Post, L, ""
Post.Name, L, ""
ToSheet, C, "---|+++|"
ToPay, C, "---|+++"
@
|#####################========================================|
|.                                                 |
|##### ################################ #  ### ###################### ### ###|
}
*)

(*
$P { JTitle:
@
|----६------------------- - - |
}
*)

(*
$P { JLine:
RWayJ.StartT, L, "HM"
RWayJ.StopT, L, "HM"
RWayJ.StopT - RWayJ.StartT, R, "3."
RWayJ.Trip, L, ""
L_RWayS.GetasWJMode(CurWho), L, ""
JRegime.JRegime, L, ""
Quality.Quality, L, ""
TS, R, "2-"
CurRun, R, "1."
RWayJ.Fact, R, "1."
?, R, "0" 
CurIncome, R, "0"
?, R, "1."
@
|#### #### ###### ########### ## ## ## ####### ##### #### ###### ###### #####|
}
*)

(*
$P { WSEnd:
@
| ⮣ ⥢                                                     |
}
*)

(*
$P { MJLine:
sMonRul[sMonCur], L, ""
MJComment, L, ""
MCList.MCode, L, ""
MCList.Name, L, ""
?, R, "3."
?, R, "2-"
@
| ############# ################ ### ###################### ####### #########|
}
*)

(*
$P { MonTitle:
ToPay, C, "/!|------"
@
|  :-######----------------------६-----㬬|
}
*)

(*
$P { MonTitleExp:
@
|६   ࠡ:-----------------------------------६|
}
*)

(*
$P { MonLine:
MCList.MCode, L, ""
MCList.Name, L, ""
?, R, "3."
?, R, ""
@
|                         ### ############################# ####### #########|
}
*)

(*
$P { MonLineExp:
MCList.MCode, L, ""
MCList.Name, L, ""
?, R, "3."
@
|                         ### ##################################### #########|
}
*)

(*
$P { MntTitle:
ToPay, C, "/!|------"
@
| ⥫:-----######-----------------------------祭|
}
*)

(*
$P { MntLine:
MtyIdx.MtyIdx, L, ""
MtyIdx.Name, L, ""
?, R, ""
@
|                         ##  ################################## ############|
}
*)

(*
$P { TimeToSh:
ToSheet, C, "/⠡| |c "
TotalTime, R, "3."
@
|                  #####  --  饥 ६  ⠡             ############|
}
*)

(*
$P { Bot:
TotalRun, R, "2."
ZrRun, R, "2."
RWayS.FuelNorm, R, "4."
RWayS.FuelFact, R, "0"
@
|騩 ஡---㫥 ஡------ଠ ⮯------室 ⮯--------|
|    ########         ########       ############             #######        |
}
*)

(*
$P { EndRep:
?, L, ""
?, L, ""
@
|----------------------------------------------------------------------------|
|c⥫: ####################################### #######################|
=(c) Polak====================================================================
}
*)

(*
$P { MLine:
RWayS.Date, L, "D.N"
RWayS.BoxNbr, L, ""
Mark.Mark, L, ""
TotalRun, R, "1."
_Tim[00], R, "3."
_Tim[01], R, "3."
_Tim[02], R, "3."
_Tim[03], R, "3."
_Tim[04], R, "3."
_Tim[05], R, "3."
_Tim[06], R, "3."
_Tim[07], R, "3."
_Tim[08], R, "3."
_Tim[09], R, "3."
_Tim[10], R, "3."
_Tim[11], R, "3."
_Tim[12], R, "3."
_Tim[13], R, "3."
_Tim[14], R, "3."
_Tim[15], R, "3."
_Tim[16], R, "3."
_Tim[17], R, "3."
_Tim[18], R, "3."
_Tim[19], R, "3."
SMem[00], R, ""
SMem[02], R, ""
SMem[04], R, ""
SMem[06], R, ""
SMem[08], R, ""
RWayS.RWayS, L, ""
CurWho, C, ".|.|.|.|2 .|."
RWayS.Exit, L, ""
ZrRun, R, "1."
_Sum[00], R, "2-"
_Sum[01], R, "2-"
_Sum[02], R, "2-"
_Sum[03], R, "2-"
_Sum[04], R, "2-"
_Sum[05], R, "2-"
_Sum[06], R, "2-"
_Sum[07], R, "2-"
_Sum[08], R, "2-"
_Sum[09], R, "2-"
_Sum[10], R, "2-"
_Sum[11], R, "2-"
_Sum[12], R, "2-"
_Sum[13], R, "2-"
_Sum[14], R, "2-"
_Sum[15], R, "2-"
_Sum[16], R, "2-"
_Sum[17], R, "2-"
_Sum[18], R, "2-"
_Sum[19], R, "2-"
SMem[01], R, ""
SMem[03], R, ""
SMem[05], R, ""
SMem[07], R, ""
SMem[09], R, ""
@
|-------|------|---------|------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|---------|---------|---------|---------|---------|
| ##### |      |#### ####|######|########|########|########|########|########|########|########|########|########|########|########|########|########|########|########|########|########|########|########|########|#########|#########|#########|#########|#########|
|#######|######|#########|######|########|########|########|########|########|########|########|########|########|########|########|########|########|########|########|########|########|########|########|########|#########|#########|#########|#########|#########|
}
*)

 PRIVATE CONST
  sAmount = 1024;

 PRIVATE VAR
  RWSProcCollection: OBJECT;
  RWSPC_Period     : DATE;
  RWSPC_MonCur,
  RWSPC_MtyCur     : SCAL[sAmount];

  sMonCur: NUMERIC[0];
  sMonRul: LIKE(MoneyRul.Rule)  [sAmount];
  sMonTmT: SCAL[2]              [sAmount];
  sMonCod: LIKE(MoneyRul.MCode) [sAmount];
  sMonNum: LIKE(MoneyRul.Number)[sAmount];

  sMtyRul: LIKE(MoneyRul.Rule)  [sAmount];
  sMtyIdx: LIKE(MtyIdx.MtyIdx)  [sAmount];

 PRIVATE PROCEDURE RWSPC_PutMoneyRul();
 BEGIN
  CONFORM(MoneyRul, MCList);
  sMonRul[RWSPC_MonCur]:=MoneyRul.Rule;
  sMonTmT[RWSPC_MonCur]:=MCList.TimeType > 0;
  sMonCod[RWSPC_MonCur]:=MoneyRul.MCode;
  sMonNum[RWSPC_MonCur]:=MoneyRul.Number;
  INC(RWSPC_MonCur);
 END {RWSPC_PutMoneyRul};

 PRIVATE PROCEDURE ExecRWSProc();
  VAR
   P       : DATE;
   Id      : STRING[];
   S       : STRING[];
   anyProc : PROC;
   begMon,
   endMon,
   begMty,
   endMty  : SCAL[sAmount];
 BEGIN
  P:=L_DatTim.Per(RWayS.Date);
  IF ~VAR_IMPL.Get(RWSProcCollection).Initialized | (P # RWSPC_Period) THEN
   RWSProcCollection:=L_General.CreateDictionary();
   RWSPC_Period     :=P;
   RWSPC_MonCur     :=0;
   RWSPC_MtyCur     :=0;
  END;
  Id:=WJMethod.WJCode + WJMethod.Who + WJMethod.JRegime + WJMethod.Quality;
  L_General.CallUs(OCCURE(WJMethod));
  IF ~RWSProcCollection.Exists(Id) THEN
   begMon:=RWSPC_MonCur;
   L_PRoll.ExecMethod(P, WJMethod.Method, PROCREF(RWSPC_PutMoneyRul), EMPTYOF(PROC));
 
   begMty:=RWSPC_MtyCur;
   CONFORM(WJMethod, WJMty);
   WHILE OCCURE(WJMty) DO
    CONFORM(WJMty, MtyIdx);
    IF L_DatTim.IsActive(P, MtyIdx.Begin, MtyIdx.Till) THEN
     sMtyRul[RWSPC_MtyCur]:=MtyIdx.Rule;
     sMtyIdx[RWSPC_MtyCur]:=WJMty.MtyIdx;
     INC(RWSPC_MtyCur);
    END;
    NEXT(WJMty);
   END; (* WHILE OCCURE(WJMty) ... *)
   RWSProcCollection.Add(Id, begMon + "|" + RWSPC_MonCur + "|" + begMty + "|" + RWSPC_MtyCur);
  END;
  S:=RWSProcCollection.Item(Id);
  begMon:=L_Str.PoolItem(S, 0);
  endMon:=L_Str.PoolItem(S, 1);
  begMty:=L_Str.PoolItem(S, 2);
  endMty:=L_Str.PoolItem(S, 3);
  sMonCur:=begMon;
  WHILE sMonCur < endMon DO
   _n:=sMonNum[sMonCur];
   ^(sMonRul[sMonCur])();
   INC(sMonCur);
  END;
  WHILE begMty < endMty DO
   SMI(sMtyIdx[begMty], ^(sMtyRul[begMty])());
   INC(begMty);
  END;
 END {ExecRWSProc};

 PRIVATE PROCEDURE CheckBegin(Begin: DATE);
 BEGIN
  L_General.Assert(RWayS.Date >= Begin, "ࠢ "+RTI.Get().Stack.Item(1).Proc.Name+"   "+L_DatTim.PeriodStr(Begin));
 END {CheckBegin};

 PRIVATE PROCEDURE CheckTill(Till: DATE);
 BEGIN
  L_General.Assert(RWayS.Date < Till, "ࠢ "+RTI.Get().Stack.Item(1).Proc.Name+"   "+L_DatTim.PeriodStr(Till));
 END {CheckTill};

 PRIVATE PROCEDURE InitSLineRpt();
  VAR
   MC_Code: LIKE(MCList.ProtIn[0])[MonCol];
   Mt_Code: LIKE(MtyIdx.ProtIn[0])[MemCol];
 BEGIN
  SETEMPTY(Mon_Idx, Mem_Idx, SMem, _Tim, _Sum);
  L_PRoll.DefMC_Code(0(*⥢ *), RWayS.Date, MC_Code, Mon_Idx);
  L_Way.DefMt_Code(0(*⥢ *), RWayS.Date, Mt_Code, Mem_Idx);
 END {InitSLineRpt};

 PRIVATE PROCEDURE SaveRWLMon();
  VAR
   Idx: NUMERIC[0];
 BEGIN
  Idx:=Mon_Idx[RWRes.MCode];
  IF !_Tim[Idx] THEN
   _Tim[Idx]:=0;
   _Sum[Idx]:=0;
  END;
  INC(_Tim[Idx], RWRes.Tim);
  IF ToPay THEN
   INC(_Sum[Idx], RWRes.Sum);
  END; (* IF ToPay ... *)
 END {SaveRWLMon};

 PRIVATE PROCEDURE RoundProof(_Proof: tRWMoney): tRWMoney;
  CONST
   _s = "1|0.1|0.01|0.001";
 BEGIN
  IF MtyIdx.RoundMth = 4(*죨*) THEN
   RETURN L_Money.RoundMoney(RWayS.Date, _Proof);
  ELSE
   RETURN Math.Round(_Proof, STRTOFLD(Str.Item(_s, "|", MtyIdx.RoundMth), NUMERIC));
  END;
 END {RoundProof};

 PRIVATE PROCEDURE GetRWMI(_MtyIdx: LIKE(MtyIdx.MtyIdx)): tRWMoney;
  VAR
   _Proof: tRWMoney;
 BEGIN
  SAVE(MtyIdx);
  L_General.Assert(SEARCH(MtyIdx, MtyIdx, _MtyIdx) & L_DatTim.IsActive(RWayS.Date, MtyIdx.Begin, MtyIdx.Till),
                   "    ⥫ 筮 ⥫ "+_MtyIdx);
  RESTORE(MtyIdx);
  SETZERO(_Proof);
  SELECT(RWMty, MtyIdx, , _MtyIdx);
  WHILE OCCURE(RWMty) DO
   INC(_Proof, RWMty.Proof);
   NEXT(RWMty);
  END; (* WHILE OCCURE(RWMty) ... *)
  RETURN _Proof;
 END {GetRWMI};

 PRIVATE PROCEDURE SaveRWLMem();
  VAR
   _Proof: LIKE(Monthly.Proof);
 BEGIN
  SELECT(RWMty, MtyIdx);
  WHILE OCCURE(RWMty) DO
   NARROWSEL(RWMty, MtyIdx);
   IF ~!Mem_Idx[RWMty.MtyIdx] THEN
    SEARCH(MtyIdx, MtyIdx, , RWMty.MtyIdx);
    SETZERO(_Proof);
    WHILE OCCURE(RWMty) DO
     INC(_Proof, RoundProof(RWMty.Proof));
     NEXT(RWMty);
    END; (* WHILE OCCURE(RWMty) ... *)
    SMem[Mem_Idx[MtyIdx.MtyIdx]]:=L_Way.MemToStr(_Proof, MtyIdx.RoundMth, RWayS.Date);
   END;
   NEXTINEXTENDEDSEL(RWMty, MtyIdx);
  END; (* WHILE OCCURE(RWMty) ... *)
 END {SaveRWLMem};

 PRIVATE PROCEDURE E_NeedMonthlyRoute(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(NeedMonthlyRoute), 0);
 END {E_NeedMonthlyRoute};

 PRIVATE PROCEDURE SMI(_MtyIdx: LIKE(MtyIdx.MtyIdx); _Proof: tRWMoney);
  VAR
   _Route: LIKE(Route.Route);
 BEGIN
  IF ~Final & E_NeedMonthlyRoute(RWayS.Date) THEN
   _Route:=SEJobs.Route;
  ELSE
   _Route:="";
  END;
  ADD(RWMty, MtyIdx, , _MtyIdx, _Route,
      RWMty.Proof, _Proof);
 END {SMI};

(*-------------END OF RWayPrt.ASL--------------------*)

 PRIVATE PROCEDURE ProceedTrouble_MustShow(Msg: STRING[]): SCAL[2];
 BEGIN
  RETURN L_Msg.PutCurRecordShownTrouble(TABLE.Get("RWayS"), Msg) |
         ~VAR_IMPL.Get(RWProc).Initialized | ~RWProc;
 END {ProceedTrouble_MustShow};

 PRIVATE PROCEDURE ProceedTrouble_Confirm(Msg: STRING[]);
 BEGIN
  IF ProceedTrouble_MustShow(Msg) THEN
   L_StdFrm.Confirm(Msg);
  END;
 END {ProceedTrouble_Confirm};

 PRIVATE PROCEDURE ProceedTrouble_Warning(Msg: STRING[]);
 BEGIN
  IF ProceedTrouble_MustShow(Msg) THEN
   L_StdFrm.Warning(Msg);
  END;
 END {ProceedTrouble_Warning};

 PRIVATE PROCEDURE SetUnratedRWaySStatus(Msg, WhatToDo: STRING[]);
 BEGIN
  IF ~!WhatToDo THEN
   Msg:=Msg + "||" + WhatToDo;
  END;
  Msg:="|" + Msg + "||" + L_StdFrm.DrawButton("⮯!", 9, "DX");
  IF (MODE # L_Events.md_SingleMakeDone) & (MODE # L_Events.md_StreamMakeDone) THEN
   Msg:=Msg + "   " +
        L_StdFrm.DrawButton(L_Str.PoolItem("⠢   ﭨ|ॢ   ﭨ",
                              RWayS.Status = L_Way.rwsStat_Rated) + " ' ⠪஢'", 42, "B");
   STDFORM(Msg, , CHOICE, L_General.ec_Raise_RoughAssert);
  ELSE
   STDFORM(Msg, , STOP,   L_General.ec_Raise_RoughAssert);
  END;
  IF RWayS.Status = L_Way.rwsStat_Rated THEN
   L_General.Assert(~RWayS.Done, " ॢ   ﭨ ' ⠪஢'" +
                                 "|⠪   ࠡ⠭." +
                                 "||,  ࠢ   ⪠/ " +
                                 "| " + RWayS.RWayS);
   RWayS.Status:=L_Way.rwsStat_Taken;
   REPLACE(RWayS);
  END;
 END {SetUnratedRWaySStatus};

 PRIVATE PROCEDURE MainRWOpAction(Text: STRING[]);
 BEGIN
  IF ProceedTrouble_MustShow(Text) THEN
   IF L_Way.IsMainRWOp() THEN
    IF (RWayS.Status = L_Way.rwsStat_Rated) THEN
     L_StdFrm.Choice(Text);
    ELSE
     SetUnratedRWaySStatus(Text, "");
    END;
   ELSE
    SetUnratedRWaySStatus(Text, "    襬 ⠪஢騪");
   END;
  END;
 END {MainRWOpAction};

 PRIVATE PROCEDURE SingleMCode();
  VAR
   _MaxSum,
   _SpreadSum: LIKE(Money.Sum);
   _SpreadTim: LIKE(Money.Tim);
   _Day      : LIKE(RWayJ.Day);
   _StartT   : LIKE(RWayJ.StartT);
   _ASCP,
   _InvFacil : SCAL[2];
 BEGIN
  IF ToPay THEN
   IF RWProc THEN
    IF RWRes.TimOnly THEN
     L_General.CallUs(RWayS.Date<01\11\2007);
     L_PRoll.SaveMoneyTimOnly(FStore, RWRes.MCode, L_DatTim.Per(RWayS.Date), L_PRoll.src_RWayS, RWRes.Tim);
    ELSE
     L_PRoll.detailedSaveMoney(FStore, RWRes.MCode, L_DatTim.Per(RWayS.Date), StaffLog.Date, L_PRoll.src_RWayS,
                               EMPTYOF(MoneyDst.XDocId), RWRes.XObject, EMPTYOF(MoneyDst.AcCut),
                               RWRes.Sum, RWRes.Tim);
    END;
   END;
   IF RWMDo THEN
    _SpreadSum:=RWRes.Sum; (*㣫塞  筮 Money.Sum*)
    _SpreadTim:=RWRes.Tim; (*㣫塞  筮 Money.Tim*)
    DEC(_SpreadSum, RWRes.RWM_Mon);
    DEC(_SpreadTim, RWRes.RWM_Tim);
    IF (_SpreadSum#0) | (_SpreadTim#0) THEN
     _MaxSum   :=0;
     SETEMPTY(_Day);
     SELECT(RWM01, RWayS, , RWayS.RWayS);
     WHILE OCCURE(RWM01) DO
      NARROWSEL(RWM01, Day, StartT);
      SRCINSEL(RWM01, GE, , Staff.TSN, RWRes.MCode, 0);
      WHILE OCCURE(RWM01) & (RWM01.TSN=Staff.TSN) & (RWM01.MCode=RWRes.MCode) DO
       IF Math.Abs(RWM01.Sum) > _MaxSum THEN
        _Day     :=RWM01.Day;
        _StartT  :=RWM01.StartT;
        _ASCP    :=RWM01.ASCP;
        _InvFacil:=RWM01.InvFacil;
        _MaxSum  :=Math.Abs(RWM01.Sum);
       END;
       NEXT(RWM01);
      END; (* WHILE OCCURE(RWM01) ... *)
      NEXTINEXTENDEDSEL(RWM01, Day, StartT);
     END; (* WHILE OCCURE(RWM01) ... *)
     IF ~!_Day THEN (*  . ()  ।  RWM01*)
      ADD(RWM01, RWayS, , RWayS.RWayS, _Day, _StartT, Staff.TSN, RWRes.MCode, _ASCP, _InvFacil,
                          RWM01.Sum, _SpreadSum,
                          RWM01.Tim, _SpreadTim);
     END;
    END;
   END;
   IF RWLDo & (_TSN = Staff.TSN) THEN
    SaveRWLMon();
   END; (* IF RWRDo ... *)
  END; (* IF ToPay ... *)
 END {SingleMCode};

 PRIVATE PROCEDURE StMoney();
  VAR
   curTim    : LIKE(Money.Tim);
   curSum    : LIKE(Money.Sum);
   curTimOnly: SCAL[2];
 BEGIN
  IF RWRDo THEN
   IF ~RWRExp THEN
    MAKEPART(R, MonTitle);
   ELSIF (KioskMode & (Staff.TSN = KioskTSN)) | (~KioskMode & (CurWho = Dr)) THEN
    MAKEPART(R, MonTitleExp);
   END;
  END;

  SELECT(RWRes, MCode);
  WHILE OCCURE(RWRes) DO
   IF (RWRes.Sum # 0) | RWRes.TimOnly THEN
    SingleMCode();
   END;
   NEXT(RWRes);
  END; (* WHILE OCCURE(RWRes) ... *)
  IF RWRDo THEN
   SELECT(RWRes, MCode);
   WHILE OCCURE(RWRes) DO
    NARROWSEL(RWRes, MCode);
    SEARCH(MCList, MCode, , RWRes.MCode);
    SETZERO(curTim, curSum, curTimOnly);
    WHILE OCCURE(RWRes) DO
     curTimOnly:=curTimOnly | RWRes.TimOnly;
     L_General.Assert((curTim+RWRes.Tim) < MAXOF(curTim), "誮 讥 祭 ६    "+MCList.MCode+" ("+FLDTOSTR(curTim+RWRes.Tim, "3.")+" .)"+
                                                          L_StdFrm.HR()+
                                                          "஢ ࠢ쭮 ଫ ");
     INC(curTim, RWRes.Tim);
     INC(curSum, RWRes.Sum);
     NEXT(RWRes);
    END;
    IF (curSum # 0) | curTimOnly THEN
     IF ~RWRExp THEN
      MAKEPART(R, MonLine, curTim, L_Money.MoneyToStr(RWayS.Date, "", curSum));
     ELSIF (KioskMode & (Staff.TSN = KioskTSN)) | (~KioskMode & (CurWho = Dr)) THEN
      MAKEPART(R, MonLineExp, curTim);
     END;
    END;
    NEXTINEXTENDEDSEL(RWRes, MCode);
   END; (* WHILE OCCURE(RWRes) ... *)
  END;
 END {StMoney};

 PRIVATE PROCEDURE SetTimOnly(TimOnly: SCAL[2]);
 BEGIN
  IF TimOnly THEN
   L_General.Assert(RWRes.Sum=0, "㫥 㬬");
   RWRes.TimOnly:=1;
   REPLACE(RWRes);
  END;
 END {SetTimOnly};

 PRIVATE PROCEDURE SetMJComment(_S: STRING[]);
 BEGIN
  MJComment:=_S;
 END {SetMJComment};

 PRIVATE PROCEDURE _MoneyMan(s: tRWMoney; t: NUMERIC[3]; TimOnly: SCAL[2]);
  VAR
   trgXObject: LIKE(XObject.XObject);
 BEGIN
  IF (s # 0) | (t # 0) THEN
   IF ~Final THEN
    trgXObject:=tmpCI.XObject;
    IF RWMDo & ToPay THEN
     IF !trgXObject THEN
      CheckRouteLogCostItemObligatory();
     END;
     IF ~SEARCH(RWM01, RWayS, RWayJ.RWayS, RWayJ.Day, RWayJ.StartT, Staff.TSN, sMonCod[sMonCur], WithASCP, WithInvFacil) THEN
      RWM01.RWayS   :=RWayJ.RWayS;
      RWM01.Day     :=RWayJ.Day;
      RWM01.StartT  :=RWayJ.StartT;
      RWM01.BoxNbr  :=RWayS.BoxNbr;
      RWM01.TSN     :=Staff.TSN;
      RWM01.Who     :=L_Way.GetWho(CurWho);
      RWM01.Date    :=RWayS.Date;
      RWM01.Route   :=SEJobs.Route;
      RWM01.MCode   :=sMonCod[sMonCur];
      RWM01.ASCP    :=WithASCP;
      RWM01.InvFacil:=WithInvFacil;
      RWM01.Tim     :=t;
      RWM01.Sum     :=s;
      INSERT(RWM01);
     ELSE
      INC(RWM01.Tim, t);
      INC(RWM01.Sum, s);
      REPLACE(RWM01);
     END;
     ADD(RWRes, MCode, , sMonCod[sMonCur], trgXObject,
         RWRes.RWM_Mon, s,
         RWRes.RWM_Tim, t);
     SetTimOnly(TimOnly);
    END; (* IF RWMDo ... *)
    IF ToPay THEN
     INC(Sal[TripNbr], s);
    END; (* IF ToPay ... *)
    IF sMonTmT[sMonCur] THEN
     INC(ByTSone, TS*t);
     INC(PayTime,    t);
     INC(TSsum,      s);
    END;
   ELSE
    SETEMPTY(trgXObject);
   END; (* IF ~Final ... *)
   ADD(RWRes, MCode, , sMonCod[sMonCur], trgXObject,
       RWRes.Sum, s,
       RWRes.Tim, t);
   SetTimOnly(TimOnly);
  END;
  IF RWRDo & (RWRSal > rwrs_WithTrips) & ToPay & ((s # 0)|(RWRSal > rwrs_WithTripsAndMoney)|TimOnly) & ~RWRExp THEN
   SEARCH(MCList, MCode, , sMonCod[sMonCur]);
   MAKEPART(R, MJLine, t, s);
   SetMJComment("");
  END;
 END {_MoneyMan};

 PRIVATE PROCEDURE MoneyMan(s: tRWMoney; t: NUMERIC[3]);
 BEGIN
  _MoneyMan(s, t, 0);
 END {MoneyMan};

(*--------------------------------------------------------------------------*)

 PRIVATE PROCEDURE E_GapTimeLimit(D: DATE): NUMERIC[3];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.GapTimeLimit), 2.000);
 END {E_GapTimeLimit};

 PRIVATE PROCEDURE E_GapType(D: DATE): L_Way.tGapType;
  VAR
   Proc: PROC;
 BEGIN
  Proc:=PROCREF(E_Way.GapType);
  IF ~!Proc THEN
   RETURN Proc(D);
  ELSIF L_APtm.IsMGT() THEN
   RETURN L_Way.gt_Cumulative;
  ELSE
   RETURN L_Way.gt_Single;
  END;
 END {E_GapType};

 PRIVATE PROCEDURE E_RWayJIsGap(D: DATE): SCAL[2];
  VAR
   default: SCAL[2];
   Proc   : PROC;
 BEGIN
  default:=(Quality.Type # L_Way.QualType_Annul) & (WJMode.WJType=L_Way.WJType_Void) & L_Env.RealTSN(RWayS.TSN);
  Proc:=PROCREF(E_Way.RWayJIsGap);
  IF ~!Proc THEN
   default:=Proc(D, default);
  END;
  RETURN default;
 END {E_RWayJIsGap};

 PRIVATE PROCEDURE E_MaxRunFSMRatio(D: DATE): NUMERIC[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.MaxRunFSMRatio), 99999999999);
 END {E_MaxRunFSMRatio};

 PRIVATE PROCEDURE E_MaxFuelFNRatio(D: DATE): NUMERIC[2];
 BEGIN
IF L_APtm.IsOG_Fuel(D) THEN
 RETURN 999999999999;
END;
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.MaxFuelFNRatio), 2);
 END {E_MaxFuelFNRatio};

 PRIVATE PROCEDURE E_MaxPlIncRatio(D: DATE): NUMERIC[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.MaxPlIncRatio), 3);
 END {E_MaxPlIncRatio};

 PRIVATE PROCEDURE E_ShowRWaySInf(D: DATE): SCAL[3];
  VAR
   default: SCAL[3];
 BEGIN
  IF CBoxLevel > 0 THEN
   default:=2;
  ELSE
   default:=1;
  END;
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.ShowRWaySInf), default);
 END {E_ShowRWaySInf};

 PRIVATE PROCEDURE E_NeedWLMStrongTimes(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.NeedWLMStrongTimes), 1);
 END {E_NeedWLMStrongTimes};

 PRIVATE PROCEDURE E_NormalTimeIntersectionOnSingleCar(D: DATE): NUMERIC[3];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.NormalTimeIntersectionOnSingleCar), 0);
 END {E_NormalTimeIntersectionOnSingleCar};

 PRIVATE PROCEDURE E_CBoxCheckLevel(D: DATE): NUMERIC[0];
 BEGIN
  IF L_APtm.IsMGT() THEN
   RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.CBoxCheckLevel), 0);
  ELSE
   RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.CBoxCheckLevel), 1);
  END;
 END {E_CBoxCheckLevel};

 PRIVATE PROCEDURE E_NeedTimeChain(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.NeedTimeChain), 1);
 END {E_NeedTimeChain};

 PRIVATE PROCEDURE E_NeedTimeCross(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Way.NeedTimeCross), 0);
 END {E_NeedTimeCross};

(*- ⥫------------------------------------------------------*)

 PRIVATE PROCEDURE SingleMty(_Who   : LIKE(Monthly.Who);
                             _Route : LIKE(Route.Route);
                             _Proof : LIKE(Monthly.Proof));
 BEGIN
  IF ToPay THEN
   IF RWProc THEN
    _Proof:=_Proof * FStore;
    IF L_General.DoConcurrentModification() THEN
     CONCURRENTADD(Monthly, TSN, Staff.TSN, L_DatTim.Per(RWayS.Date), StaffLog.Date, _Who, L_AP.mthlSrc_RWayS, MtyIdx.MtyIdx,
                   Proof, _Proof);

     IF ~!_Route THEN
      CONCURRENTADD(MonthRt, Monthly, Monthly.Monthly, _Route, Mark.Mark,
                    Proof, _Proof);
     END;

    ELSE
     ADD(Monthly, TSN, , Staff.TSN, L_DatTim.Per(RWayS.Date), StaffLog.Date, _Who, L_AP.mthlSrc_RWayS, MtyIdx.MtyIdx,
         Monthly.Proof, _Proof);
     IF ~!_Route THEN
      ADD(MonthRt, Monthly, , Monthly.Monthly, _Route, Mark.Mark,
          MonthRt.Proof, _Proof);
     END;
    END;
   END;
  END;
 END {SingleMty};

 PRIVATE PROCEDURE StMonthly();
  VAR
   _Who    : LIKE(Monthly.Who);
   _Proof,
   TotProof: LIKE(Monthly.Proof);
 BEGIN
  IF CurWho = L_Way.rwswho_Chopper THEN
   _Who:=L_AP.mthlWho_Guard;
  ELSE
   _Who:=L_Way.GetWho(CurWho);
  END;

  IF RWRDo & ~RWRExp THEN
   MAKEPART(R, MntTitle);
  END;
  SELECT(RWMty, MtyIdx);
  WHILE OCCURE(RWMty) DO
   NARROWSEL(RWMty, MtyIdx);
   IF SEARCH(MtyIdx, MtyIdx, RWMty.MtyIdx) & L_DatTim.IsActive(RWayS.Date, MtyIdx.Begin, MtyIdx.Till) THEN
    SETZERO(TotProof);
    WHILE OCCURE(RWMty) DO
     IF RWMty.Proof # 0 THEN
      _Proof:=RoundProof(RWMty.Proof);
      SingleMty(_Who, RWMty.Route, _Proof);
      INC(TotProof, _Proof);
     END;
     NEXT(RWMty);
    END; (* WHILE OCCURE(RWMty) ... *)
    IF RWRDo & ~RWRExp & (TotProof # 0) THEN
     MAKEPART(R, MntLine, L_Way.MemToStr(TotProof, MtyIdx.RoundMth, RWayS.Date));
    END;
   END;
   NEXTINEXTENDEDSEL(RWMty, MtyIdx);
  END; (* WHILE OCCURE(RWMty) ... *)
 END {StMonthly};

 PRIVATE PROCEDURE GetRWJP(trgRWJPro: LIKE(RWJPro.RWJPro)): LIKE(RWayJP.Value);
 BEGIN
  RETURN L_RWayS.GetRWJP(TripNbr, trgRWJPro);
 END {GetRWJP};

 PRIVATE PROCEDURE ChkOneValue(s: FLOAT; VName: STRING[]);
  VAR
   Str: STRING[];
 BEGIN
  IF s#0 THEN
   Str:="ॡ  ⥢ ⮢  " +
         L_DatTim.PeriodStr(RWayS.Date) +
         "|(" + VName + ", ३ " + FLDTOSTR(TripNbr + 1, "0", 0) +
         ", ࠧ " + FLDTOSTR(s, "4.", 0) + ")";
   L_StdFrm.ConditionalCHOICE(Str, L_General.IsProgrammer());
  END;
 END {ChkOneValue};

 PRIVATE PROCEDURE ChckTEP();
 BEGIN
  ChkOneValue(RWayJ.FNorm    - ForFN  [TripNbr], "ଠ ⮯");
  ChkOneValue(RWayJ.PlIncome - TripIPl[TripNbr], "  室");
  ChkOneValue(RWayJ.ByTS     - Sal    [TripNbr], "ࠡ⮪");
  IF L_Way.E_VldPsgPlanLev(RWayS.Date) THEN
   ChkOneValue(GetRWJP(E_Way.rwjp_TermPassPlan) - TripPsgPl[TripNbr], "  ᠦࠬ");
  END;
 END {ChckTEP};

 PRIVATE PROCEDURE SaveTEP();
 BEGIN
  RWayJ.FNorm   :=ForFN  [TripNbr];
  RWayJ.PlIncome:=TripIPl[TripNbr];
  RWayJ.ByTS    :=Sal    [TripNbr];
  REPLACE(RWayJ);
  L_APWI.SetVldPsgPlans(TripPsgPl[TripNbr]);
 END {SaveTEP};

 PRIVATE PROCEDURE ___GetMPTPay(Silent  : SCAL[2];
                                _Who    : LIKE(MPG_WP.Who);
                                _JRgPayT: LIKE(JRgPayT.JRgPayT);
                                _RWPay  : LIKE(RWPay.RWPay);
                                _Class  : LIKE(StaffLog.Class)): tPay;
  VAR
   _TS: tPay;
 BEGIN
  _TS:=L_AP._GetPayByMPG_WP(Silent, mg_WagePay, _Who, _JRgPayT, _RWPay, RWayS.Date, _Class);
  IF ~!_TS THEN
   L_General.Assert(OCCURE(WagePayL), " । 䭠 ⪠");
   L_General.Assert(WagePayL.Type = L_PRoll.wplType_Tariff, "  ਬ 䭠 ⪠  ⨯ '筠':|䭠 ⪠ "+WagePayL.WagePay);
  END;
  RETURN _TS;
 END {___GetMPTPay};

 PRIVATE PROCEDURE __GetMPTPay(Silent  : SCAL[2];
                               _Who    : LIKE(MPG_WP.Who);
                               _JRgPayT: LIKE(JRgPayT.JRgPayT);
                               _RWPay  : LIKE(RWPay.RWPay)): tPay;
 BEGIN
  RETURN ___GetMPTPay(Silent, _Who, _JRgPayT, _RWPay, 1);
 END {__GetMPTPay};

 PRIVATE PROCEDURE _GetMPTPay(Silent  : SCAL[2];
                              _Who    : LIKE(MPG_WP.Who);
                              _RWPay  : LIKE(RWPay.RWPay)): tPay;
  VAR
   _TS: tPay;
 BEGIN
  _TS:=__GetMPTPay(Silent, _Who, JRegime.JRgPayT, _RWPay);
  IF ~!_TS THEN
   RETURN _CompletePay(_TS, _Who, _RWPay);
  ELSE
   RETURN _TS;
  END;
 END {_GetMPTPay};

 PRIVATE PROCEDURE __GetMPTPayWClass(Silent  : SCAL[2];
                                     _Who    : LIKE(MPG_WP.Who);
                                     _JRgPayT: LIKE(JRgPayT.JRgPayT);
                                     _RWPay  : LIKE(RWPay.RWPay)): tPay;
 BEGIN
  RETURN ___GetMPTPay(Silent, _Who, _JRgPayT, _RWPay, StaffLog.Class);
 END {__GetMPTPayWClass};

 PRIVATE PROCEDURE _GetMPTPayWClass(Silent  : SCAL[2];
                                    _Who    : LIKE(MPG_WP.Who);
                                    _RWPay  : LIKE(RWPay.RWPay)): tPay;
  VAR
  _TS: tPay;
 BEGIN
  _TS:=__GetMPTPayWClass(Silent, _Who, JRegime.JRgPayT, _RWPay);
  IF ~!_TS THEN
   RETURN _CompletePay(_TS, _Who, _RWPay);
  ELSE
   RETURN _TS;
  END;
 END {_GetMPTPayWClass};

 PRIVATE PROCEDURE AccessRegHead();
 BEGIN
  IF ~SEARCH(RegHead, HumReg, StaffLog.Regime, L_DatTim.Per(RWayS.Date)) THEN
   L_General.Error("  ० ࠡ " + StaffLog.Regime + "  " + L_DatTim.PeriodStr(L_DatTim.Per(RWayS.Date)));
  END;
 END {AccessRegHead};

 PRIVATE PROCEDURE GetOfficerTS(): NUMERIC[3];
  VAR
   _TS,
   Dummy: NUMERIC[3];
 BEGIN
  AccessRegHead();
  CONFORM(StaffLog, Officer);
  CONFORM(Officer, WagePay);
  HISTCONF(RWayS.Date, WagePay, WagePayL);
  L_PRoll.GetHMPay(L_DatTim.Per(RWayS.Date), RegHead.FullBal, _TS, Dummy);
  RETURN _TS;
 END {GetOfficerTS};

 PRIVATE PROCEDURE E_GetSpecTS(): NUMERIC[3];
  VAR
   local: PROC;
 BEGIN
  local:=PROCREF(GetSpecTS);
  L_General.Assert(~!local, "稥 ⮤ । 䭮 ⠢  ॠ");
  RETURN local();
 END {E_GetSpecTS};

 PRIVATE PROCEDURE SetTS(_PayType: LIKE(WJMethod.PayType));
 BEGIN
  IF L_APtm.IsMGT() THEN
   IF _PayType = L_Way.wjmpt_ByMark       THEN
    IF ~Final THEN
     L_General.Error("  થ  ।!");
    ELSIF PayTime > 0 THEN
     TS:=ByTSone/PayTime; (* Average TS *)
    ELSE
     TS:=0;
    END;
   ELSIF _PayType = L_Way.wjmpt_ByMCFix   THEN
    L_General.Error("  ९  ।!");
   ELSIF _PayType = L_Way.wjmpt_ByOfficer THEN
    CONFORM(Officer, WagePay);
    HISTCONF(RWayS.Date, WagePay, WagePayL);
    IF WagePayL.Type = L_PRoll.wplType_Tariff THEN
     TS:=WagePayL.Pay[StaffLog.Class];
    ELSE
     AccessRegHead();
     TS:=WagePayL.Pay[StaffLog.Class]/RegHead.FullBal;
    END;
   ELSIF _PayType = L_Way.wjmpt_Other     THEN
    TS:=E_GetSpecTS();
   ELSIF _PayType = L_Way.wjmpt_None      THEN
    TS:=0;
   END; (* IF _PayType... *)
  ELSE
   IF (CurWho = Dr) & ~L_Env.RealTSN(RWayS.TSN) THEN
    TS:=0;
   ELSIF _PayType = L_Way.wjmpt_ByMark     THEN
    IF ~Final THEN
     TS:=_GetMPTPay(0, L_Way.GetWho(CurWho), 01);
    ELSIF PayTime > 0 THEN
     TS:=ByTSone/PayTime; (* Average TS *)
    ELSE
     TS:=0;
    END;
   ELSIF _PayType = L_Way.wjmpt_ByMCFix   THEN
    TS:=L_AP.MCFixPay(RWayS.Date);
   ELSIF _PayType = L_Way.wjmpt_ByOfficer THEN
    TS:=GetOfficerTS();
   ELSIF _PayType = L_Way.wjmpt_Other     THEN
    TS:=E_GetSpecTS();
   ELSIF _PayType = L_Way.wjmpt_None      THEN
    TS:=0;
   END; (* IF _PayType... *)
  END; (* IF L_APtm.IsMGT() ... *)
 END {SetTS};

 PRIVATE PROCEDURE CalcSal();
  VAR
   _TripIPl   : NUMERIC[2];
 BEGIN
  SetTS(WJMethod.PayType);

  IF RWRDo & (RWRSal > rwrs_Short) & ~RWRExp THEN
   IF Final THEN
    MAKEPART(R, WSEnd);
   ELSE
    IF CurWho = L_Way.rwswho_Guard THEN
     _TripIPl:=TripIPl[TripNbr]/L_Way.E_IPlDvdr(RWayS.Date, IPlDvdr[TripNbr], CurWho, WayLMen.Number);
    ELSE
     _TripIPl:=TripIPl[TripNbr];
    END;
    MAKEPART(R, JLine, _TripIPl, ForFN[TripNbr]);
   END;
  END;

  IF WJMethod.TimeSel*Quality.Type > 0 THEN  (* !!! *)
   INC(TotalTime,    WrkTime);
   INC(TotalNight,   CurNight);
   INC(TotalHolid,   CurHolid);
   INC(TotalDayTime, CurDayTime);
  END;

  SETZERO(TSsum);
  ExecRWSProc();
 END {CalcSal};

 PRIVATE PROCEDURE NeedKeyAssProceed(): SCAL[2];
 BEGIN
  RETURN RWProc &
         L_Env.KeyAssAcntLev(RWayS.Date) &
         (L_MathR.E_NotFullActiveKeyAssSystem(RWayS.Date) = 0);
 END {NeedKeyAssProceed};

 PRIVATE PROCEDURE KA_CalcRunTKind(_Math: LIKE(CarLog.Math));
  VAR
   _MtyIdx: LIKE(MtyIdx.MtyIdx);
 BEGIN
  IF CurRun # 0 THEN
   _MtyIdx:=E_Stock.TKind2MtyIdx(RWayS.Date, RouteLog.TKind);
   L_General.Assert(SEARCH(MtyIdx, MtyIdx, _MtyIdx),
                    "  ⥫ 筮 ⥫ "+_MtyIdx);
   IF L_General.DoConcurrentModification() THEN
    CONCURRENTADD(MathMty, Math,
                   _Math, L_DatTim.Per(RWayS.Date), L_AP.mthlSrc_RWayS, _MtyIdx,
                  Proof, FStore * CurRun);
   ELSE
    ADD(MathMty, Math, , _Math, L_DatTim.Per(RWayS.Date), L_AP.mthlSrc_RWayS, _MtyIdx,
                         MathMty.Proof, FStore * CurRun);
    IF MathMty.Proof = 0 THEN
     REMOVE(MathMty);
    END;
   END;

   IF RWayS.Date >= 01\10\2009 THEN
    IF ~!RouteLog.CostItem THEN
     L_MathR.AccessMath(_Math);
     IF L_General.DoConcurrentModification() THEN
      CONCURRENTADD(MathRun, Math, _Math, L_DatTim.Per(RWayS.Date), L_AP.mthlSrc_RWayS,
                                   tmpCI.ActCostItem,
                                   Run, FStore * CurRun);
     ELSE
      ADD(MathRun, Math, , _Math, L_DatTim.Per(RWayS.Date), L_AP.mthlSrc_RWayS,
                           tmpCI.ActCostItem,
                           MathRun.Run, FStore * CurRun);
      IF MathRun.Run = 0 THEN
       REMOVE(MathRun);
      END;
     END;
    ELSE
     CheckRouteLogCostItemObligatory();
    END;
   END;
  END;
 END {KA_CalcRunTKind};

 PRIVATE PROCEDURE KA_ResetMathDone(_Math: LIKE(CarLog.Math));
 BEGIN
  L_MathR.ResetMathDone_AP(_Math, L_DatTim.Per(RWayS.Date));
 END {KA_ResetMathDone};

 PRIVATE PROCEDURE ProceedAllKeyAss(Proc: PROC);
 BEGIN
  IF NeedKeyAssProceed() THEN
   SAVE(Car);
   CONFORM(RWayS, Car);
   L_Car.StandOnCarLog(Car.BoxNbr, RWayS.Date);
   IF ~!CarLog.Math THEN
    Proc(CarLog.Math);
   END;
   SELECT(WayLCar, RWayS, , RWayS.RWayS);
   WHILE OCCURE(WayLCar) DO
    CONFORM(WayLCar, Car);
    L_Car.StandOnCarLog(Car.BoxNbr, RWayS.Date);
    IF ~!CarLog.Math THEN
     Proc(CarLog.Math);
    END;
    NEXT(WayLCar);
   END; (* WHILE OCCURE(WayLCar) ... *)
   RESTORE(Car);
  END;
 END {ProceedAllKeyAss};

 PRIVATE PROCEDURE ProcTrip();
 BEGIN
  CONFORM(RWayJ, SEJobs, Route, RoutMod, WJMode, Quality);

  L_Way.PositionOnRouteLog(Route.Route, RWayS.Date);
  StandOn_tmpCIByRouteLog();

  CONFORM(RouteLog, JRegime);
  CONFORM(RouteLog, TKind);

  WithASCP    :=L_Way.E_CarASCPLev(RWayS.Date, RWayS.BoxNbr, SEJobs.Route, SEJobs.Exit);
  WithInvFacil:=L_Way.E_CarInvFacilLev(RWayS.Date, RWayS.BoxNbr, SEJobs.Route, SEJobs.Exit);
  InitTrip();
  SetCurIncome();
  CurRun:= RWayJ.Run * RWayJ.Fact;

  L_Way.PosToWJMethod(L_RWayS.GetasWJMode(CurWho), L_Way.GetWho(CurWho), JRegime.JRegime, RWayJ.Quality, RWayS.Date);

  CalcSal();

  IF (CurWho = L_Way.rwswho_Driver) & RWProc THEN
   ^ForTEP();
   ProceedAllKeyAss(PROCREF(KA_CalcRunTKind));
  END;
 END {ProcTrip};

 PRIVATE PROCEDURE IsHoliday(_Day: LIKE(RWayJ.Day)): SCAL[2];
 BEGIN
  IF !Holidays[_Day] THEN
   Holidays[_Day]:=L_Hld.DayIsHoliday(RWayS.Date+(_Day-1));
  END;
  RETURN Holidays[_Day];
 END {IsHoliday};

 PRIVATE PROCEDURE GetRWayJDayTime(curStartT, curStopT: TIME): FLOAT;
 BEGIN
  IF curStopT > curStartT THEN
   RETURN curStopT - curStartT;
  ELSE
   RETURN 00:00 - curStartT;
  END;
 END {GetRWayJDayTime};

 PRIVATE PROCEDURE GetHolTime(curDay: LIKE(RWayJ.Day); curStartT, curStopT: TIME): FLOAT;
  VAR
   Result: FLOAT;
 BEGIN
  Result:=0;
  IF IsHoliday(curDay) THEN
   INC(Result, GetRWayJDayTime(curStartT, curStopT));
  END;
  IF (curStopT < curStartT) & IsHoliday(curDay+1) THEN
   INC(Result, curStopT - 00:00);
  END;
  IF RWayS.Date < 01\09\2013 THEN
   Result:=Math.Round(Result, 0.001);
  END;
  RETURN Result;
 END {GetHolTime};

 PRIVATE PROCEDURE GetRWaySDateDayTime(_Day: LIKE(RWayJ.Day); _StartT, _StopT: TIME): FLOAT;
  VAR
   Result: FLOAT;
 BEGIN
  IF _Day = 01 THEN
   Result:=GetRWayJDayTime(_StartT, _StopT);
  ELSE
   Result:=0;
  END;
  IF RWayS.Date < 01\09\2013 THEN
   Result:=Math.Round(Result, 0.001);
  END;
  RETURN Result;
 END {GetRWaySDateDayTime};

 PRIVATE PROCEDURE SetCurTimes(curDay: LIKE(RWayJ.Day); curStartT, curStopT: TIME);
  VAR
   CurCoef,
   AddCoef,
   TotCoef: L_RWayS.tTimeCoeff;
 BEGIN
  CurCoef   :=L_RWayS.E_RWAYS_CoeffForCurTimes(RWayS.Date, CurWho);
  AddCoef   :=L_RWayS.E_RWAYS_CoeffForAddTimes(RWayS.Date, CurWho);
  TotCoef   :=CurCoef + AddCoef;
  CurTime   :=CurCoef * (curStopT  - curStartT);
  AddTime   :=AddCoef * (curStopT  - curStartT);
  IF RWayS.Date >= 01\09\2013 THEN
   WrkTime  :=TotCoef * (curStopT - curStartT);
  ELSE
   WrkTime  :=CurTime + AddTime;
  END;
  CurNight  :=TotCoef * TIMEINT(curStartT, curStopT, 22:00, 06:00);
  CurHolid  :=TotCoef * GetHolTime(curDay, curStartT, curStopT);
  CurDayTime:=TotCoef * GetRWaySDateDayTime(curDay, curStartT, curStopT);
 END {SetCurTimes};

 PRIVATE PROCEDURE ja_forDriver(): SCAL[2];
 BEGIN
  SetCurTimes(RWayJ.Day, RWayJ.StartT, RWayJ.StopT);
  RETURN 1;
 END {ja_forDriver};

 PRIVATE PROCEDURE ja_SetZero();
 BEGIN
  SETZERO(CurTime, AddTime, WrkTime, CurNight, CurHolid, CurDayTime);
 END {ja_SetZero};

 PRIVATE PROCEDURE ja_forAnyWayLMen(): SCAL[2];
  VAR
   doIt: SCAL[2];
 BEGIN
  IF L_RWayS.E_GetTimesFromWayLMen() THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    doIt:=~PREV(RWayJ);
   EXCEPT
   END; (* TRY *)
   IF doIt THEN
    SetCurTimes(WayLMen.Day, WayLMen.StartT, WayLMen.StopT);
   ELSE
    ja_SetZero();
   END;
  ELSE
   IF L_RWayS.IsRWayJForCurWayLMen() THEN
    SetCurTimes(RWayJ.Day, RWayJ.StartT, RWayJ.StopT);
   ELSE
    ja_SetZero();
   END;
  END;
  RETURN WrkTime > 0;
 END {ja_forAnyWayLMen};

 PRIVATE PROCEDURE ja_ByTckRcS(): SCAL[2];
 BEGIN
  ja_SetZero();
  RETURN L_Way.AccessTckRcS_byRWayJ(Staff.TSN, L_Way.trs_Chopper);
 END {ja_ByTckRcS};

 PRIVATE PROCEDURE SetFinalTimes();
 BEGIN
  IF WJMethod.TimeSel = 0 THEN
   ja_SetZero();
  ELSE
   CurTime   :=L_Way.E_GetPzvTotalTime(L_Way.GetWho(CurWho));
   AddTime   :=0;
   WrkTime   :=CurTime + AddTime;
   CurNight  :=L_Way.E_GetPzvNightTime(L_Way.GetWho(CurWho), WrkTime);
   CurHolid  :=L_Way.E_GetPzvHolidTime(L_Way.GetWho(CurWho), WrkTime);
   CurDayTime:=L_Way.E_GetPzvDayTime  (L_Way.GetWho(CurWho), WrkTime);
  END;
 END {SetFinalTimes};

 PRIVATE PROCEDURE Inc_TripNbr();
 BEGIN
  INC(TripNbr);
  L_General.Assert(TripNbr<TripAmount,
                   "⢮ ३ᮢ ॢ蠥 ࠭祭 ("+L_Str.IntStr(TripAmount)+")| ᫥ ᢥ ३");
 END {Inc_TripNbr};

 PRIVATE PROCEDURE Create_RWRes();
 BEGIN
  CreateFILE(RWRes, "", " ࠡ⪨ ", "");

  CreateFIELD(RWRes, MCode,    LIKE(MCList.MCode),      "", "", "", "/", "");
  CreateFIELD(RWRes, XObject,  LIKE(XObject.XObject), "", "", "", "", "");
  CreateFIELD(RWRes, Tim,      NUMERIC[3], "", "0", "", "६", "");
  CreateFIELD(RWRes, Sum,      tRWMoney, "", "0", "", "죨", "");
  CreateFIELD(RWRes, RWM_Tim,  NUMERIC[3], "", "0", "", "६ ()", "");
  CreateFIELD(RWRes, RWM_Mon,  tRWMoney, "", "0", "", "죨 ()", "");
  CreateFIELD(RWRes, TimOnly,  SCAL[2],    "", "0", "", "易⥫쭮 ६  㫥 㬬", "");

  CreateINDEX(RWRes, MCode,  UNIQUE, "", "", MCode, XObject);

  SetVersionOfFILE(RWRes, 0);
 END {Create_RWRes};

 PRIVATE PROCEDURE Create_RWMty();
 BEGIN
  CreateFILE(RWMty, "", " ࠡ⪨ ", "");

  CreateFIELD(RWMty, MtyIdx, LIKE(MtyIdx.MtyIdx), "", "", "", "⥫ 筮 ⥫", "");
  CreateFIELD(RWMty, Route,  LIKE(Route.Route),   "", "", "", "", "");
  CreateFIELD(RWMty, Proof,  tRWMoney,            "", "", "", "祭", "");

  CreateINDEX(RWMty, MtyIdx,  UNIQUE, "", "", MtyIdx, Route);

  SetVersionOfFILE(RWMty, 0);
 END {Create_RWMty};

 PRIVATE PROCEDURE PassJobs(IsAcceptableJob: PROC);
  VAR
   AcceptableJobCount: NUMERIC[0];
 BEGIN
  IF RWLDo THEN
   InitSLineRpt();
  END;

  IF RWRDo THEN
   IF ~RWRExp | (KioskMode & (Staff.TSN = KioskTSN)) | (~KioskMode & (CurWho = Dr)) THEN
    MAKEPART(R, StaffLine);
   END;
   IF (RWRSal > rwrs_Short) & ~RWRExp THEN
    MAKEPART(R, JTitle);
   END;
  END;

  IF !DATABASE.Get().Tables("RWRes") THEN
   Create_RWRes();
  END;
  IF !DATABASE.Get().Tables("RWMty") THEN
   Create_RWMty();
  END;
  L_AFM.AF_CreateTemp("RWRes", "RWRes");
  L_AFM.AF_CreateTemp("RWMty", "RWMty");

  Final:=0;
  InitRWSWho();
  SETZERO(TotalTime, TotalNight, TotalHolid, TotalDayTime, ByTSone, PayTime,
          TripNbr, AcceptableJobCount);
  SETSEL(RWayJ, RWayS, RWayS.RWayS);
  FOR_EACH RWayJ DO
   IF IsAcceptableJob() THEN
    INC(AcceptableJobCount);
    IF L_Way.rwswhoWithSale(CurWho) THEN
     INCL(TripArr[TripNbr], CurWho);
    END;
    IF L_Way.rwswhoWithVld(CurWho) THEN
     INCL(TripArrVld[TripNbr], CurWho);
    END;
    PROMPT(RWayJ.Trip+" ("+Staff.TSN+")");
    ProcTrip();
   END;
   Inc_TripNbr();
  END; (* FOR_EACH RWayJ *)

  IF (AcceptableJobCount = 0) & (CurWho # L_Way.rwswho_Chopper) & ~L_RWayS.E_GetTimesFromWayLMen() THEN
   L_General.Error("     ३  ࠡ⭨ " + Staff.TSN + "  ⥫쭮 ᮭ");
  END;

  PROMPT("⮣     ("+Staff.TSN+")");
  Final:=1;

  SETZERO(CurIncome, CurRun);

  IF ~L_RWayS.WayLMenWithOwnWJMode(CurWho) THEN
   L_Way.PosToWJMethod(RWFin, L_Way.GetWho(CurWho), 01, L_RWayS.Qlt_Good, RWayS.Date);

   SetFinalTimes();

   CONFORM(WJMethod, Quality);

   CalcSal();
  END;

  StMoney  ();
  StMonthly();

  IF RWProc THEN
   ^ToTS();
   L_PRoll.ShtDone(0);
  END;

  IF RWRDo & ~RWRExp THEN
   MAKEPART(R, TimeToSh);
  END;

  IF RWLDo & (_TSN = Staff.TSN) THEN
   SaveRWLMem();

   MAKEPART(R, MLine);
  END;
  L_AFM.AF_PurgeTemp("RWRes");
  L_AFM.AF_PurgeTemp("RWMty");
 END {PassJobs};

 PRIVATE PROCEDURE PassChopper();
  VAR
   prvTckRcS: LIKE(TckRcS.TckRcS);
   TSNs     : LIKE(Staff.TSN)[16];
   i,
   Count    : NUMERIC[0];
   _ToPay,
   _ToSheet : SCAL[2][16];
   msgHeader: STRING[];
   IsNewTSN : SCAL[2];
 BEGIN
  Count:=0;
  SETEMPTY(prvTckRcS, TSNs, _ToPay, _ToSheet);
  SELECT(TckRcJ, asRWayS, , RWayS.RWayS);
  WHILE OCCURE(TckRcJ) DO
   IF TckRcJ.TckRcS # prvTckRcS THEN
    CONFORM(TckRcJ, TckRcS);
    IF TckRcS.AsWho = L_Way.trs_Chopper THEN
     msgHeader:=L_Str.PoolItem(L_Way.trs_Pool, L_Way.trs_Chopper) + " " + TckRcS.TSN + ": ";
     i:=Count-1;
     WHILE (i >= 0) & (TSNs[i] # TckRcS.TSN) DO
      DEC(i);
     END;
     IsNewTSN:=i < 0;
     IF IsNewTSN THEN
      TSNs[Count]    :=TckRcS.TSN;
      _ToSheet[Count]:=TckRcS.ToSheet;
      _ToPay[Count]  :=TckRcS.ToPay;
      INC(Count);
     ELSE
      L_General.Assert(_ToSheet[i] = TckRcS.ToSheet, msgHeader + " ᪮쪮    ࠧ 祭 ' ⠡'");
      L_General.Assert(_ToPay[i] = TckRcS.ToPay,     msgHeader + " ᪮쪮    ࠧ 祭 ''");
     END;
    END;
    prvTckRcS:=TckRcJ.TckRcS;
   END;
   NEXT(TckRcJ);
  END; (* WHILE OCCURE(TckRcJ) ... *)
  WHILE Count > 0 DO DEC(Count);
   ToSheet:=_ToSheet[Count];
   ToPay  :=_ToPay[Count];
   SEARCH(Staff, TSN, , TSNs[Count]);
   L_Staff.PosToStaffLog(Staff.TSN, RWayS.Date, 1);
   CONFORM(Staff, Man);
   CONFORM(StaffLog, Officer);
   CONFORM(Officer, Post);
   PassJobs(PROCREF(ja_ByTckRcS));
  END;
 END {PassChopper};

 PRIVATE PROCEDURE PassLeft(_Who: L_Way.tWLMWho);
 BEGIN
  CurWho:=_Who + 1;
  IF (_Who = L_Way.wlmwho_Chopper) & (L_Way.E_TckRcLevel(RWayS.Date) > 0) &
     ~SELECT(WayLMen, RWayS, RWayS.RWayS, _Who) THEN
   PassChopper();
  ELSE
   SELECT(WayLMen, RWayS, , RWayS.RWayS, _Who);
   WHILE OCCURE(WayLMen) DO
    L_Way.GetWLMSigns(ToSheet, ToPay);
    HasGap:=L_Way.GetGapSign(CurWho);
    CONFORM(WayLMen, Staff, Man);
    L_Staff.PosToStaffLog(Staff.TSN, RWayS.Date, 1);
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, Post);
    PassJobs(PROCREF(ja_forAnyWayLMen));
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
  END;
 END {PassLeft};

(*----------------------  ⠡----------------------------*)

 PRIVATE PROCEDURE GetJMode(): LIKE(JMode.JMode);
  VAR
   _JMode: LIKE(JMode.JMode);
   _Name : LIKE(JMode.Name);
 BEGIN
  IF    ToSheet = L_Way.toSheet_Sheet THEN
   _JMode:=L_Sheet.jm_Line(RWayS.Date);
   _Name :="";
  ELSIF ToSheet = L_Way.toSheet_Holid THEN
   _JMode:=L_Sheet.jm_LineHld(RWayS.Date);
   _Name :="  室";
  ELSE
   L_General.CallUs(0);
  END;
  L_General.Assert(SEARCH(JMode, JMode, _JMode),
                   " ࠡ  ⠡ '"+_JMode+" "+_Name+"'| ᠭ  ࠢ筨");
  RETURN _JMode;
 END {GetJMode};

 PRIVATE PROCEDURE GetShitDayTime(): LIKE(Sheet.DayTime);
 BEGIN
  IF RWayS.Date >= 01\06\2008 THEN (*0064243*)
   L_General.CallUs(TotalDayTime >= 0);
   RETURN TotalDayTime;
  ELSE (*delirium*)
   L_General.Assert(SEARCH(RegList, HumReg, StaffLog.Regime, L_DatTim.Per(RWayS.Date), L_DatTim.DAY(RWayS.Date)),
                    "  ० ࠡ  " + L_DatTim.DateStr(RWayS.Date));
   IF (RegList.DayTime=RegList.GrTime) | !RegList.DayTime | (RegList.DayTime = 0(*?*)) THEN
    RETURN TotalTime;
   ELSE
    RETURN RegList.DayTime;
   END;
  END;
 END {GetShitDayTime};

 PRIVATE PROCEDURE SheetModFail(D: DATE);
 BEGIN
  L_General.Error("㤠筠 䨪 ⠡ ࠡ⭨ " + Staff.TSN + "  " + L_DatTim.DateStr(D));
 END {SheetModFail};

 PRIVATE PROCEDURE StTS();
 BEGIN
  IF (ToSheet > L_Way.toSheet_Dummy) & (TotalTime > 0) THEN
   TotalDayTime:=GetShitDayTime();
   L_Sheet.MaySUBSheet(RWayS.Date, GetJMode(), L_Sheet.src_RWayS);
   SEARCH(Sheet, TSN, , Staff.TSN, L_DatTim.Per(RWayS.Date), L_DatTim.DAY(RWayS.Date));
   IF Sheet.Tim > TotalTime THEN
    IF !Sheet.DayTime THEN
     Sheet.DayTime:=Sheet.Tim;
    END;
    DEC(Sheet.Tim,     TotalTime);
    DEC(Sheet.SpTime,  TotalNight);
    IF    Sheet.SpTime > 0 THEN
     Sheet.SpKind:=L_Sheet.spk_Night;
    ELSIF Sheet.SpTime = 0 THEN
     Sheet.SpKind:=L_Sheet.spk_None;
    ELSE
     SheetModFail(RWayS.Date);
    END;
    DEC(Sheet.DayTime, TotalDayTime);
    IF    Sheet.DayTime = Sheet.Tim THEN
     SETEMPTY(Sheet.DayTime);
    ELSIF (Sheet.DayTime > Sheet.Tim) | (Sheet.DayTime < 0) THEN
     SheetModFail(RWayS.Date);
    END;
    REPLACE(Sheet);
   ELSIF Sheet.Tim = TotalTime THEN
    REMOVE(Sheet);
   ELSE
    SheetModFail(RWayS.Date);
   END;
  END; (* IF ToSheet ... *)
 END; (* StTS *)

 PRIVATE PROCEDURE LineTS();
  VAR
   trgJMode  : LIKE(JMode.JMode);
   trgTim    : LIKE(Sheet.Tim);
   trgDayTime: LIKE(Sheet.DayTime);
   trgSpTime : LIKE(Sheet.SpTime);
   trgSpKind : LIKE(Sheet.SpKind);
 BEGIN
  IF (ToSheet > L_Way.toSheet_Dummy) & (TotalTime > 0) THEN
   TotalDayTime:=GetShitDayTime();
   trgJMode:=GetJMode();
   L_Sheet.MayADDSheet(RWayS.Date, trgJMode, L_Sheet.src_RWayS);
   IF OCCURE(Sheet) & (Sheet.Source = L_Sheet.src_RWayS) THEN
    trgTim    :=Sheet.Tim;
    trgDayTime:=Sheet.DayTime;
    IF !trgDayTime THEN
     trgDayTime:=trgTim;
    END;
    trgSpTime :=Sheet.SpTime;
    trgSpKind :=Sheet.SpKind;
    IF trgSpTime # 0 THEN
     L_General.CallUs(trgSpKind = L_Sheet.spk_Night);
    END;
   ELSE
    SETZERO(trgTim, trgDayTime, trgSpTime);
    trgSpKind:=L_Sheet.spk_None;
   END;
   INC(trgTim,     TotalTime);
   INC(trgDayTime, TotalDayTime);
   IF trgDayTime = trgTim THEN
    SETEMPTY(trgDayTime);
   END;
   IF TotalNight > 0 THEN
    INC(trgSpTime, TotalNight);
    trgSpKind:=L_Sheet.spk_Night;
   END;
   L_Sheet.UpdateSheet(RWayS.Date, trgJMode, trgTim, trgSpKind, trgSpTime, trgDayTime, L_Sheet.src_RWayS);
   IF Sheet.Tim > L_Way.E_MaxDayDuration(RWayS.Date, CurWho) THEN
    MainRWOpAction("ࠡ⠭  ⪨ " + FLDTOSTR(Sheet.Tim, "3.", 0) + " ᮢ. : " + Sheet.TSN);
   END;
  END; (* IF ToSheet... *)
 END {LineTS};

 PRIVATE PROCEDURE CheckChain(Dir: SCAL[2]);
  VAR
   CurF,
   OthF   : LIKE(RWayS.RemExit);
   CurS,
   OthS   : LIKE(RWayS.SMBef);
   Ok     : SCAL[20];
   MsgTxt : STRING[];
 BEGIN
  SAVE(RWayS);
  CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
  IF Dir = 0 THEN
   CurF:=RWayS.RemExit;
   CurS:=RWayS.SMBef;
   IF PREV(RWayS) THEN
    IF ~!RWayS.RemEntr & ~!RWayS.SMAft THEN
     OthF:=RWayS.RemEntr;
     OthS:=RWayS.SMAft;
    ELSE
     SETZERO(OthF, OthS); (*  *)
    END;
    MsgTxt:="襭 楯窨! ।騩  " + RWayS.RWayS + "|";
   END;
  ELSE
   CurF:=RWayS.RemEntr;
   CurS:=RWayS.SMAft;
   IF NEXT(RWayS) THEN
    IF ~!RWayS.RemExit & ~!RWayS.SMBef THEN
     OthF:=RWayS.RemExit;
     OthS:=RWayS.SMBef;
    ELSE
     SETZERO(OthF, OthS); (*  *)
    END;
    MsgTxt:="襭 楯窨! 騩  " + RWayS.RWayS + "|";
   END;
  END;
  IF OCCURE(RWayS) & (RWayS.Status >= L_Way.rwsStat_Given) THEN
   RESTORE(RWayS);
   Ok:=0;
   IF P_Car.HasCarPro(RWayS.BoxNbr, RWayS.Date, P_Car.P_SMCor) & (CarPro.Value="0") THEN
    SETZERO(CurS, OthS);
   END;
   IF L_Way.E_NeedFuelChain(RWayS.Date) THEN
    INC(Ok, (CurF # OthF)*1);
   END;
   IF L_Way.E_NeedSMChain(RWayS.Date) THEN
    INC(Ok, (CurS # OthS)*2);
   END;
   IF    Ok = 3 THEN
    MainRWOpAction(MsgTxt + "祭  " + FLDTOSTR(OthF, "0", 6) +
                           "|祭 ᯤ. " + FLDTOSTR(OthS, "0", 6)   );
   ELSIF Ok = 2 THEN
    MainRWOpAction(MsgTxt + "祭 ᯤ. " + FLDTOSTR(OthS, "0", 6));
   ELSIF Ok = 1 THEN
    MainRWOpAction(MsgTxt + "祭  " + FLDTOSTR(OthF, "0", 6));
   END;
  ELSE
   RESTORE(RWayS);
  END;
 END {CheckChain};

 PRIVATE PROCEDURE RWayJIsAnyWork(): SCAL[2];
 BEGIN
  L_General.Assert(~!RWayJ.Quality,
                   " "+RWayJ.Trip+"  । ⢮"); (*  ᯮ짮  *)
  CONFORM(RWayJ, Quality);
  CONFORM(RWayJ, SEJobs);
  CONFORM(SEJobs, WJMode);
  RETURN (Quality.Type # L_Way.QualType_Annul) & (WJMode.WJType # L_Way.WJType_Void);
 END {RWayJIsAnyWork};

 PRIVATE PROCEDURE crwsit_GetRWaySFullBegTime(): FLOAT;
 BEGIN
  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayJ) DO
   IF RWayJIsAnyWork() THEN
    RETURN L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT);
   END;
   NEXT(RWayJ);
  END;
  RETURN 0;
 END {crwsit_GetRWaySFullBegTime};

 PRIVATE PROCEDURE crwsit_GetRWaySFullEndTime(): FLOAT;
 BEGIN
  SETSEL(RWayJ, RWayS, RWayS.RWayS);
  LAST(RWayJ);
  WHILE OCCURE(RWayJ) DO
   IF RWayJIsAnyWork() THEN
    RETURN L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT);
   END;
   PREV(RWayJ);
  END;
  RETURN 0;
 END {crwsit_GetRWaySFullEndTime};

 PRIVATE PROCEDURE crwsit_Ins(TSN: LIKE(Staff.TSN); Start: FLOAT; Stop: FLOAT; ToSheet: LIKE(RWayS.ToSheet));
 BEGIN
  IF L_Env.RealTSN(TSN) THEN
   IF ~ADD(rwtsn, TSN, TSN, Start) THEN
    rwtsn.Stop   :=Stop;
    rwtsn.ToSheet:=ToSheet;
    REPLACE(rwtsn);
   ELSE
    L_General.Error(". " + TSN + " 㪠  ( " + L_Str.IntStr(1 + Start DIV 24) + " " +
                    L_DatTim.TimeStr(00:00 + (Start MOD 24)) + ")");
   END;
  END;
 END {crwsit_Ins};

 PRIVATE PROCEDURE crwsit_HasIntersection(TSN: LIKE(Staff.TSN); Start: FLOAT; Stop: FLOAT): SCAL[2];
 BEGIN
  SETSEL(rwtsn, TSN, TSN);
  RETURN SRCINSEL(rwtsn, LT, Stop) & (rwtsn.Stop > Start);
 END {crwsit_HasIntersection};

 PRIVATE PROCEDURE crwsit_OneTSN(VAR _RWayS: LIKE(RWayS.RWayS); D: DATE; TSN: LIKE(Staff.TSN); VAR _Found: SCAL[3]);
 BEGIN
  SAVE(RWayS);
  SELECT(RWayS, sTSN, , L_Way.rwsStat_Rated, TSN, D);
  WHILE ~_Found & OCCURE(RWayS) DO
   IF RWayS.RWayS # _RWayS THEN
    IF crwsit_HasIntersection(RWayS.TSN, crwsit_GetRWaySFullBegTime(), crwsit_GetRWaySFullEndTime()) THEN
     _Found:=1;
     _RWayS:=RWayS.RWayS;
    END;
   END;
   IF _Found & (RWayS.ToSheet = L_Way.toSheet_Dummy) THEN
    _Found:=2;
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  SELECT(WayLMen, TSN, , TSN, D);
  WHILE ~_Found & OCCURE(WayLMen) DO
   CONFORM(WayLMen, RWayS);
   IF (RWayS.RWayS # _RWayS) & (RWayS.Status = L_Way.rwsStat_Rated) THEN
    IF L_RWayS.E_GetTimesFromWayLMen() THEN
     IF crwsit_HasIntersection(WayLMen.TSN, L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT),
                               L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT)) THEN
      _Found:=1;
      _RWayS:=RWayS.RWayS;
     END;
    ELSE
     SETSEL(RWayJ, RWayS, RWayS.RWayS);
     SRCINSEL(RWayJ, EQ, , WayLMen.Day, WayLMen.StartT);
     WHILE ~_Found & OCCURE(RWayJ) DO
      IF RWayJIsAnyWork() & L_RWayS.IsRWayJForCurWayLMen() THEN
       IF crwsit_HasIntersection(WayLMen.TSN, L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT),
                                 L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT)) THEN
        _Found:=1;
        _RWayS:=RWayS.RWayS;
       END;
      END;
      NEXT(RWayJ);
     END;
    END;
   END; (*IF RWayS.RWayS # _RWayS*)
   IF _Found & (L_Way.GetWLMToSheetSign(WayLMen.Who) = L_Way.toSheet_Dummy) THEN
    _Found:=2;
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
  RESTORE(RWayS);
 END {crwsit_OneTSN};

 PRIVATE PROCEDURE CheckRWaySIntersectionTime();
  VAR
   _RWayS : LIKE(RWayS.RWayS);
   _StartT,
   _StopT : FLOAT;
   _Found : SCAL[3];
   crwsD  : DATE;
 BEGIN
  crwsD  :=RWayS.Date;
  IF L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
   _RWayS :=RWayS.RWayS;
   _StartT:=crwsit_GetRWaySFullBegTime();
   _StopT :=crwsit_GetRWaySFullEndTime();
   _Found :=0;
   SAVE(RWayS);
   CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
   IF PREV(RWayS) THEN
    IF (RWayS.RWayS # _RWayS) & (RWayS.Status=L_Way.rwsStat_Rated) &
       (L_Way._TimeInt(_StartT + 24 * (crwsD - RWayS.Date),
                       _StopT + 24 * (crwsD - RWayS.Date),
                       crwsit_GetRWaySFullBegTime(),
                       crwsit_GetRWaySFullEndTime()) >
       E_NormalTimeIntersectionOnSingleCar(RWayS.Date)) THEN
     _Found:=1;
     _RWayS:=RWayS.RWayS;
    END;
   END;
   RESTORE(RWayS);
   SAVE(RWayS);
   CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
   IF ~_Found & NEXT(RWayS) THEN
    IF (RWayS.RWayS # _RWayS) & (RWayS.Status=L_Way.rwsStat_Rated) &
       (L_Way._TimeInt(_StartT,
                       _StopT,
                       crwsit_GetRWaySFullBegTime() + 24 * (RWayS.Date - crwsD),
                       crwsit_GetRWaySFullEndTime() + 24 * (RWayS.Date - crwsD)) >
       E_NormalTimeIntersectionOnSingleCar(RWayS.Date)) THEN
     _Found:=1;
     _RWayS:=RWayS.RWayS;
    END;
   END;
   RESTORE(RWayS);
   IF _Found THEN
    IF (E_NormalTimeIntersectionOnSingleCar(RWayS.Date) > 0) THEN
     MainRWOpAction("祭 ६ ࠡ    " + _RWayS + "  ⨬");
    ELSE
     MainRWOpAction("祭 ६ ࠡ    " + _RWayS);
    END;
   END;
  END; (* IF L_Env.RealBoxNbr... *)

  _Found:=0;
  _RWayS:=RWayS.RWayS;
  L_AFM.MakeMultipleIndex("rwtsn", "TSN: LIKE(Staff.TSN); Start: FLOAT; Stop: FLOAT; ToSheet: LIKE(RWayS.ToSheet)", "TSN: TSN, Start");
  crwsit_Ins(RWayS.TSN, crwsit_GetRWaySFullBegTime(), crwsit_GetRWaySFullEndTime(), RWayS.ToSheet);
  SELECT(WayLMen, RWayS, , RWayS.RWayS);
  WHILE OCCURE(WayLMen) DO
   IF L_RWayS.E_GetTimesFromWayLMen() THEN
    crwsit_Ins(WayLMen.TSN, L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT),
               L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT), L_Way.GetWLMToSheetSign(WayLMen.Who));
   ELSE
    SETSEL(RWayJ, RWayS, RWayS.RWayS);
    SRCINSEL(RWayJ, EQ, , WayLMen.Day, WayLMen.StartT);
    WHILE OCCURE(RWayJ) DO
     IF RWayJIsAnyWork() & L_RWayS.IsRWayJForCurWayLMen() THEN
      crwsit_Ins(WayLMen.TSN, L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT),
                 L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT), L_Way.GetWLMToSheetSign(WayLMen.Who));
     END;
     NEXT(RWayJ);
    END;
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)

  SAVE(RWayS);
  SELECT(rwtsn, TSN);
  WHILE ~_Found & OCCURE(rwtsn) DO
   NARROWSEL(rwtsn, TSN);
   SAVE(rwtsn);
   crwsit_OneTSN(_RWayS, crwsD, rwtsn.TSN, _Found);
   RESTORE(rwtsn);
   IF _Found THEN
    IF (rwtsn.ToSheet = L_Way.toSheet_Dummy) | (_Found = 2) THEN
     L_StdFrm.Choice("⭨ " + rwtsn.TSN + ": 祭 ६ ࠡ   " + _RWayS);
    ELSE
     MainRWOpAction("⭨ " + rwtsn.TSN + ": 祭 ६ ࠡ   " + _RWayS);
    END;
   END;
   NEXTINEXTENDEDSEL(rwtsn, TSN);
  END; (* WHILE OCCURE(rwtsn) ... *)
  RESTORE(RWayS);
  L_AFM.AF_PurgeTemp("rwtsn");
 END {CheckRWaySIntersectionTime};

 PRIVATE PROCEDURE GetGuNbr(B, E: NUMERIC[3]; VAR curGuNbr, curGuVldNbr: LIKE(WayLMen.Number));
 BEGIN
  SETZERO(curGuNbr, curGuVldNbr);
  IF ~L_RWayS.E_GetTimesFromWayLMen() THEN
   SETSEL(WayLMen, RWayS, RWayS.RWayS, L_Way.wlmwho_Guard);
   FOR_EACH WayLMen DO
    IF L_Way._TimeInt(B, E, L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT),
                            L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT)) > 0 THEN
     INC(curGuNbr,    L_Way.rwswhoWithSale(L_Way.rwswho_Guard));
     INC(curGuVldNbr, L_Way.rwswhoWithVld(L_Way.rwswho_Guard));
    END;
   END; (* FOR_EACH WayLMen *)
  END;
 END {GetGuNbr};

 PRIVATE PROCEDURE CheckRatio(v, R: FLOAT; Text: STRING[]);
 BEGIN
  IF (v < 1/R) | (v > R) THEN
   MainRWOpAction("⢥ ᮮ⭮襭 " + Text);
  END;
 END {CheckRatio};

 PRIVATE PROCEDURE GetRun_Fct(TripNbr: NUMERIC[0]; VAR _Run: LIKE(RWayJ.Run)[]; VAR _Trips: NUMERIC[0][]);
  VAR i: NUMERIC[0];
 BEGIN
  IF (RWayJ.Run = 0) | ~L_Way.RealRWayJTrip() THEN
   RETURN;
  END;
  i:=0;
  WHILE (i <= TripNbr) DO
   IF    _Run[i] = RWayJ.Run THEN
    INC(_Trips[i], RWayJ.Fact);
    RETURN;
   ELSIF _Run[i] = 0 THEN
    INC(_Trips[i], RWayJ.Fact);
    _Run[i]:=RWayJ.Run;
    RETURN;
   END;
   INC(i);
  END;
 END {GetRun_Fct};

 PRIVATE PROCEDURE InfRun_Fct(VAR _Run: LIKE(RWayJ.Run)[25]; VAR _Trips: NUMERIC[1][25]): STRING[];
  VAR
   i  : NUMERIC[0];
   Str: STRING[];
   TA : NUMERIC[1];
 BEGIN
  i:=0; TA:=0;
  WHILE _Run[i] # 0 DO
   INC(TA, _Trips[i]);
   INC(i);
  END;
  i:=0; Str:=FLDTOSTR(TA, "1.", 0) + "|";
  WHILE _Run[i] # 0 DO
   Str:=Str+FLDTOSTR(_Trips[i], "1.", 4)+" x "+FLDTOSTR(_Run[i], "2.", 7)+";";
   INC(i);
   IF _Run[i] # 0 THEN
    Str:=Str+"  "+FLDTOSTR(_Trips[i], "1.", 4)+" x "+FLDTOSTR(_Run[i], "2.", 7)+";|";
    INC(i);
   ELSE
    Str:=Str+"|";
   END;
  END;
  RETURN Str;
 END {InfRun_Fct};

 PRIVATE PROCEDURE E_CheckGuardTckRcS();
  VAR
   DoIt,
   Found: SCAL[2];
   Local: PROC;
 BEGIN
  DoIt:=(L_Way.E_TckRcLevel(RWayS.Date) = L_TRS.il_Full) & ~L_Way.E_IsGuardIdleExit(RWayS.Date, RWayS.Exit);
  Local:=PROCREF(E_Way.CheckGuardTckRcS);
  IF ~!Local THEN
   DoIt:=Local(RWayS.Date, DoIt);
  END;
  IF DoIt THEN
   SELECT(WayLMen, RWayS, , RWayS.RWayS, L_Way.wlmwho_Guard);
   WHILE OCCURE(WayLMen) DO
    Found:=0;
    SELECT(TckRcS, TSN, , WayLMen.TSN, WayLMen.RWayDate);
    WHILE ~Found & OCCURE(TckRcS) DO
     IF TckRcS.AsWho = L_Way.trs_Guard THEN
      CONFORM(TckRcS, TckRcJ);
      WHILE ~Found & OCCURE(TckRcJ) DO
       IF TckRcJ.asRWayS = RWayS.RWayS THEN
        Found:=1;
       END;
       NEXT(TckRcJ);
      END;
     END;
     NEXT(TckRcS);
    END;
    IF ~Found THEN
     SELECT(TckRcJ, asRWayS, , RWayS.RWayS);
     WHILE ~Found & OCCURE(TckRcJ) DO
      CONFORM(TckRcJ, TckRcS);
      IF (TckRcS.AsWho = L_Way.trs_Guard) & (TckRcS.TSN = WayLMen.TSN) THEN
       Found:=1;
      END;
      NEXT(TckRcJ);
     END; (* WHILE OCCURE(TckRcJ) ... *)
    END;
    IF ~Found THEN
     CONFORM(RWayS, RWayJ);
     WHILE OCCURE(RWayJ) DO
      IF L_RWayS.IsRWayJForCurWayLMen() & L_TRS.IsGoodRWayJForIncome() THEN
       L_General.Error("  " + WayLMen.TSN + "     " + RWayS.RWayS);
      END;
      NEXT(RWayJ);
     END; (* WHILE OCCURE(RWayJ) ... *)
    END;
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
  END;
 END {E_CheckGuardTckRcS};

 PRIVATE PROCEDURE AcceptTckRcS(Dir: NUMERIC[0]);
 BEGIN
  IF L_Way.E_TckRcLevel(RWayS.Date) > 0 THEN
   IF (Dir = +1) & ~L_Way.E_Fill_asRWayS(RWayS.Date) THEN
    CALL(TckRcS.TckRcS_OnSetupRWayS());
   END;
   IF Dir = +1 THEN
    E_CheckGuardTckRcS();
   END;
   LOOP
    IF SELECT(TckRcJ, asRWayS, RWayS.RWayS) THEN
     IF (Dir = +1) & (LAST(TckRcJ) & !TckRcJ.asDay) THEN
      SEARCH(TckRcS, TckRcS, , TckRcJ.TckRcS);
      CALL(TckRcS.ProceedByOneRWayS(+1));
     ELSIF (Dir = -1) & (FIRST(TckRcJ) & ~!TckRcJ.asDay) THEN
      SEARCH(TckRcS, TckRcS, , TckRcJ.TckRcS);
      CALL(TckRcS.ProceedByOneRWayS(-1));
     ELSE
      EXIT;
     END;
    ELSE
     EXIT;
    END
   END; (* LOOP *)
  END; (* IF L_Way.E_TckRcLevel ... *)
 END {AcceptTckRcS};

 PRIVATE PROCEDURE AcceptCWOrder(Dir: NUMERIC[0]);
 BEGIN
  IF L_Way.E_CWOrderLevel(RWayS.Date) > 0 THEN
   SELECT(CWOrder, RWayS, , RWayS.RWayS);
   WHILE OCCURE(CWOrder) DO
    SAVE(RWayS);
    IF    Dir = +1 THEN
     CALL(CWOrder.StreamMakeDone());
    ELSIF Dir = -1 THEN
     L_General.Assert(CWOrder.Status # L_MDoc.st_Prepared,
                      "⥢     ⠪஢,|" +
                      "..  易    " + CWOrder.CWOrder + "|"+
                      "   '⮢'");
     CALL(CWOrder.StreamMakeUnDone());
    ELSE
     L_General.CallUs(0);
    END;
    RESTORE(RWayS);
    NEXT(CWOrder);
   END; (* WHILE OCCURE(CWOrder) ... *)
  END; (* IF L_Way.E_CWOrderLevel ... *)
 END {AcceptCWOrder};

 PRIVATE PROCEDURE AcceptIRec(Dir: NUMERIC[0]);
 BEGIN
  IF L_Way.E_IRecLevel(RWayS.Date) > 0 THEN
   IF Dir = +1 THEN
    CALL(IRec.IRec_OnSetupRWayS());
   END;
   LOOP
    IF    (Dir = +1) & SELECT(IRecL, asRWayS, RWayS.RWayS, 0) THEN
     SEARCH(IRec, IRec, , IRecL.IRec);
     CALL(IRec.ProceedByOneRWayS(+1));
    ELSIF (Dir = -1) & SELECT(IRecL, asRWayS, RWayS.RWayS, 1) THEN
     SEARCH(IRec, IRec, , IRecL.IRec);
     CALL(IRec.ProceedByOneRWayS(-1));
    ELSE
     EXIT;
    END;
   END; (* LOOP *)
  END; (* IF L_Way.E_IRecLevel ... *)
 END {AcceptIRec};

 PUBLIC PROCEDURE RWayJPoint(): STRING[];
 BEGIN
  RETURN RWayJ.Trip + ", . " + L_DatTim.TimeStr(RWayJ.StartT);
 END {RWayJPoint};

 VAR
  fp_sri_ZeroTrips,
  fp_sri_WorkTrips : NUMERIC[1][25];
  fp_sri_ZeroRun,
  fp_sri_WorkRun   : LIKE(RWayJ.Run)[25];
  fp_HasGap        : SCAL[2];
  fp_GapTime       : NUMERIC[3];

 PRIVATE PROCEDURE fpof_AtBegin();
 BEGIN
  IF L_Way.CarBegRWSLev(RWayS.BoxNbr, RWayS.Date) = 0 THEN
   CheckChain(0);
   CheckChain(1);
  END;

  CheckRWaySIntersectionTime();

  IF ~L_RWayS.E_GetTimesFromWayLMen() & E_NeedWLMStrongTimes(RWayS.Date) THEN
   SELECT(WayLMen, RWayS, , RWayS.RWayS);
   WHILE OCCURE(WayLMen) DO
    IF (WayLMen.Who # L_Way.wlmwho_Chopper) & (WayLMen.ToSheet | WayLMen.ToPay) THEN
     L_General.Assert(~!WayLMen.StopT,
                     " 㪠 ६ 砭 ࠡ |⥫쭮 ᮭ. . " + WayLMen.TSN);
     SETSEL(RWayJ, RWayS, WayLMen.RWayS);
     L_General.Assert(SRCINSEL(RWayJ, EQ, WayLMen.Day, WayLMen.StartT),
                      "६ 砫 ࠡ " + WayLMen.TSN + "  ᮢ  砫 ३");
     SRCINSEL(RWayJ, LT, , WayLMen.Day + (WayLMen.StopT < WayLMen.StartT), WayLMen.StopT);
     LOOP
      L_General.Assert(OCCURE(RWayJ), "६ 砭 ࠡ "+ WayLMen.TSN +
                                      "| ᮢ  砭 ३");
      CONFORM(RWayJ, Quality);
      CONFORM(RWayJ, WJMode);
      IF ~E_NeedTimeCross(RWayS.Date) &
         (L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT) =
          L_Way.FullEndTime(RWayJ.Day,   RWayJ.StartT,   RWayJ.StopT)) THEN
       IF Quality.Type > L_Way.QualType_Annul THEN
        EXIT;
       END;
      END;
      PREV(RWayJ);
     END; (* LOOP ... *)
    END;
    NEXT(WayLMen);
   END;
  END;
  SETZERO(fp_GapTime, fp_HasGap,
          fp_sri_ZeroTrips, fp_sri_WorkTrips, fp_sri_ZeroRun, fp_sri_WorkRun);
 END {fpof_AtBegin};

 PRIVATE PROCEDURE fpof_AtEveryTrip();
  VAR
   _Signtr: STRING[16];
   i      : NUMERIC[0];
 BEGIN
  IF CBoxLevel > 0 THEN
   IF ((WJMode.IncSel*Quality.Type>L_Way.QualType_Annul)|(Quality.Type=L_Way.QualType_Annul)) &
      ((Route.IncSel = 2) | (Route.IncSel = 1)) & (L_Way.RealRWayJTrip() | (Quality.Type=L_Way.QualType_VoidTr)) THEN
    _Signtr:=GetCSignature();
    i:=0;
    WHILE (i<CBoxNbr) & (_Signtr#CBoxSigntr[i]) DO
     INC(i);
    END;
    IF i>=CBoxNbr THEN
     CBoxNbr:=i+1;
     CBoxSigntr[i]:=_Signtr;
     SETZERO(CBoxByCash[i], CBoxIncome[i], CBoxIncPln[i]);
     IF CBoxLevel > 1 THEN
      InitAddCBoxIndexes(i);
     END;
    END;
    SetCBox(i);
    IF CBoxLevel > 1 THEN
     SetAddCBox(i);
    END;
    INC(CBoxIncPln[i], TripIPl[TripNbr]);
   END;
  END; (* IF CBoxLevel ... *)
  IF E_RWayJIsGap(RWayS.Date) THEN
   INC(fp_GapTime, CurTime);
  ELSE
   IF fp_GapTime >= E_GapTimeLimit(RWayS.Date) THEN
    fp_HasGap:=1;
   END;
   IF E_GapType(RWayS.Date) = L_Way.gt_Single THEN
    SETZERO(fp_GapTime);
   END;
  END;
  IF WJMode.RunSel*Quality.Type > 0 THEN
   IF (CurRun = 0) & L_EC.ExecE_Func_Scal2(RWayS.Date, PROCREF(E_Way.DisallowTripWORun), 1) THEN
    MainRWOpAction("  㪠 ஡: ३ " + RWayJPoint());
   END;
   IF WJMode.RunSel = L_Way.runsel_Zero THEN
    GetRun_Fct(TripNbr, fp_sri_ZeroRun, fp_sri_ZeroTrips);
   ELSIF (WJMode.RunSel = L_Way.runsel_Work) & (WJMode.IncSel*Route.IncSel > 0) THEN
    GetRun_Fct(TripNbr, fp_sri_WorkRun, fp_sri_WorkTrips);
   END;
  ELSE
   L_General.Assert(RWayJ.Run = 0, "室  ஡: ३ " + RWayJPoint());
  END;

  IF (WithGu | WithGuVld) & L_Way.E_CarASCPLev(RWayS.Date, RWayS.BoxNbr, SEJobs.Route, SEJobs.Exit) THEN
   IF WJMode.IncSel * Route.IncSel > 0 THEN
    L_General.Error("   ६   ࠡ ,|ਬ, ३ " + RWayJPoint());
   END;
  END;
 END {fpof_AtEveryTrip};

 PRIVATE PROCEDURE fpof_AtEnd(First: SCAL[2]; Dir: NUMERIC[0]);
  VAR
   _RunBySM,
   i       : NUMERIC[0];
 BEGIN
  IF First THEN
   SAVE(RWayJ);
   _RunBySM:=L_Way.RunBySM() * P_Car.GetP_SMCor(RWayS.BoxNbr, RWayS.Date);
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayJ) DO
    IF (RWayJ.Trip = L_Way.E_TripForSMChainBreak(RWayS.Date)) THEN
     _RunBySM:=0;
    END;
    NEXT(RWayJ);
   END;(* WHILE OCCURE(RWayJ)... *)
   IF _RunBySM # 0 THEN
    CheckRatio(Math.Round(TotalRun, 1.00)/_RunBySM, E_MaxRunFSMRatio(RWayS.Date),
               "|஡ 䠪᪨   " + FLDTOSTR(TotalRun, "0") +
               "|஡  ᯨ " + FLDTOSTR(_RunBySM, "0"));
   END;
   RESTORE(RWayJ);
   IF    L_APtm.IsOG() THEN
    RWaySInfOG();
   ELSIF E_ShowRWaySInf(RWayS.Date) # 0 THEN
    L_StdFrm.Inform("ந⢥ ३ᮢ - " +
                    FLDTOSTR(InfRun_Fct(fp_sri_WorkRun, fp_sri_WorkTrips), "0", 0)+
                    "| |" +
                    "㫥 ३ᮢ - " +
                     FLDTOSTR(InfRun_Fct(fp_sri_ZeroRun, fp_sri_ZeroTrips), "0", 0));
    IF E_ShowRWaySInf(RWayS.Date) = 2 THEN
     i:=0;
     WHILE i < CBoxNbr DO
      L_StdFrm.Inform(DecCSignature(CBoxSigntr[i])+"| "+
                      "|  - "+FLDTOSTR(Math.Round(CBoxIncPln[i], 1.00), "2-", 0)+
                      "|  - "+FLDTOSTR(CBoxIncome[i], "2-", 0));
      INC(i);
     END; (* WHILE i < CBoxNbr *)
    END; (* IF E_ShowRWaySInf(RWayS.Date) = 2 *)
   END; (* IF E_ShowRWaySInf(RWayS.Date) # 0 *)
   IF CBoxLevel > 0 THEN
    i:=0;
    WHILE i<CBoxNbr DO
     IF CBoxIncPln[i] > 0 THEN
      IF CBoxIncome[i] = 0 THEN
       MainRWOpAction(" 室. " + DecCSignature(CBoxSigntr[i]));
      ELSE
       CheckRatio((CBoxIncome[i]+CBoxByCash[i])/CBoxIncPln[i], E_MaxPlIncRatio(RWayS.Date),
                  " / 䠪  室|"+DecCSignature(CBoxSigntr[i]));
      END;
     END; (* IF CBoxIncPln[i] ... *)
     IF CBoxLevel > 1 THEN
      AddCBoxCheck(i);
     END;
     INC(i);
    END; (* WHILE i < ... *)
   END; (* IF CBoxLevel ... *)
   IF E_GapType(RWayS.Date) = L_Way.gt_Cumulative THEN
    fp_HasGap:=fp_HasGap | (fp_GapTime > E_GapTimeLimit(RWayS.Date));
   END;
   IF fp_HasGap # RWayS.Gap THEN
    MainRWOpAction("ਧ ''  ᮮ⢥|   ⥢ ");
   END;
   IF (RWayS.ToPay # 0) | (RWayS.ToSheet # 0) THEN
    L_General.Assert(L_Env.RealTSN(RWayS.TSN), " 䨪⨢ ⥫ ⨬ 㪠뢠   ⠡");
    CONFORM(RWayS, Staff);
    L_Staff.PosToStaffLog(Staff.TSN, RWayS.Date, 1);
    CONFORM(StaffLog, Officer);
    IF ~L_Env.IsDriver() THEN
     MainRWOpAction(" ࠡ⭨,  饣 ⥫,|㪠   ⠡");
    END;
   END; (* IF (RWayS.ToPay#0) | (RWayS.ToSheet#0) *)
  END; (* IF First *)
  IF First | ((Dir = 0) & ~RWMDo) THEN
   TripNbr:=0;
   SETSEL(RWayJ, RWayS, RWayS.RWayS);
   FOR_EACH RWayJ DO
    RWayJ.FNorm    :=ForFN  [TripNbr];
    IF First THEN
     RWayJ.ByTS    :=0;
     RWayJ.PlIncome:=TripIPl[TripNbr];
     L_APWI.SetVldPsgPlans(TripPsgPl[TripNbr]);
    END;
    REPLACE(RWayJ);
    Inc_TripNbr();
   END; (* FOR_EACH RWayJ *)
  END; (* IF First | (Dir = 0) *)
 END {fpof_AtEnd};

 PRIVATE PROCEDURE _CondErrorForFuel(Cond: SCAL[2]; Msg, WhatToDo: STRING[]);
 BEGIN
  IF ~Cond THEN
   IF L_Fuel.FlAcntLev(RWayS.Date) = L_Fuel.fal_RfOpOffline THEN
    SetUnratedRWaySStatus(Msg, WhatToDo);
   ELSE
    L_General.Error(Msg);
   END;
  END;
 END {_CondErrorForFuel};

 PRIVATE PROCEDURE SetForFN(_TripNbr: SCAL[TripAmount]; _TKind: LIKE(Route.TKind); FN: LIKE(RWayJ.FNorm));
 BEGIN
  ForFN[_TripNbr]:=FN;
  INC(_FNorm[_TKind], FN);
 END {SetForFN};

 PRIVATE PROCEDURE ProceedLinkedDocs(Dir: NUMERIC[0]; wGlobalSettings: SCAL[2]);
 BEGIN
  AcceptTckRcS(Dir);
  AcceptCWOrder(Dir);
  AcceptIRec(Dir);
  IF wGlobalSettings THEN
   GlobalSettings();
  END;
  E_CompleteRWayS(Dir);
 END {ProceedLinkedDocs};

 PRIVATE PROCEDURE CheckRouteLogCostItemObligatory();
 BEGIN
  IF RWProc & !RouteLog.CostItem & (RWayS.Date >= 01\04\2011) & (FStore = +1)THEN
   IF (L_General.GetAPSiteID() = "KL") |
      (L_General.GetAPSiteID() = "HM") |
      (L_General.GetAPSiteID() = "55") |
      ((L_General.GetAPSiteID() = "SP") & (RWayS.Date >= 01\05\2011)) THEN
    L_General.Error(" ਨ  "+RouteLog.Route+"  㪠   "+L_DatTim.DateStr(RWayS.Date));
   END;
  END;
 END {CheckRouteLogCostItemObligatory};

 PRIVATE PROCEDURE StandOn_tmpCIByRouteLog();
  VAR
   trgCostItem: LIKE(CostItem.CostItem);
   trgMyFirm  : LIKE(MyFirm.MyFirm);
 BEGIN
  IF ~SEARCH(tmpCI, CostItem, RouteLog.CostItem) THEN
   tmpCI.CostItem:=RouteLog.CostItem;
   IF !RouteLog.CostItem THEN
    SETEMPTY(tmpCI.XObject, tmpCI.ActCostItem);
   ELSE
    trgMyFirm:=L_Way.GetRWaySMyFirm();
    IF (RWayS.Date >= 01\10\2009) THEN
     CONFORM(RWayS, Car);
     trgCostItem:=L_CI.GetElementOfActivityCostItem(RouteLog.CostItem, RWayS.Date, trgMyFirm, L_CI.erkn_Salary, 1);
    ELSE
     trgCostItem:=RouteLog.CostItem;
    END;
    L_CI.PositionOnCostItem(trgCostItem);
    tmpCI.XObject:=CostItem.XObject;
    tmpCI.ActCostItem:=L_CI.E_GetActivityCostItem(RouteLog.CostItem, RWayS.Date, trgMyFirm, 1);
   END;
   INSERT(tmpCI);
  END;
 END {StandOn_tmpCIByRouteLog};

 PRIVATE PROCEDURE CallProceedRWayF(Silent: SCAL[2]);
 BEGIN
  IF ~Mark.Electric THEN
   CALL(SetRWayF.ProceedRWayF(Silent));
  ELSE
   SETZERO(RWayS.FuelFact);
   REPLACE(RWayS);
  END;
 END {CallProceedRWayF};

 PRIVATE PROCEDURE GetLossExit(): LIKE(StExit.Exit);
  VAR
   Result: LIKE(StExit.Exit);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   CHANGESEL(RWayJ, RWayS, , RWayJ.RWayS);
   SRCINSEL(RWayJ, LT, , RWayJ.Day + (RWayJ.StopT < RWayJ.StartT), RWayJ.StopT);
   SETEMPTY(Result);
   LOOP
    IF ~OCCURE(RWayJ) THEN
     IF    !Result THEN
      Result:=RWayS.Exit;
     END;
     EXIT;
    END;
    CONFORM(RWayJ, Quality);
    CONFORM(RWayJ, WJMode);
    CONFORM(RWayJ, SEJobs);
    IF (Quality.Type = L_Way.QualType_Annul) THEN
     IF (WJMode.RunSel = L_Way.runsel_Work) & (WJMode.WJType = L_Way.WJType_Work) THEN
      IF    !Result THEN
       Result:=SEJobs.Exit;
      ELSIF SEJobs.Exit # Result THEN
       (* ࢠ ३ ࠧ 室 *)
       SETEMPTY(Result);
       EXIT;
      END;
     END;
    ELSE
     IF (WJMode.RunSel = L_Way.runsel_Work) & (WJMode.WJType = L_Way.WJType_Work) THEN
      IF    !Result THEN
       Result:=SEJobs.Exit;
      END;
      EXIT;
     END;
    END;
    PREV(RWayJ);
   END; (* LOOP *)
  EXCEPT
  END;
  RETURN Result;
 END {GetLossExit};

 PUBLIC PROCEDURE GetVldPsgPlans(): L_APWI.tVldPsgAmnt;
  VAR
   curIPCondition: L_Way.tIncPlanCondition;
   Result        : L_APWI.tVldPsgAmnt;
 BEGIN
  Result:=0;
  IF L_Way.SEJobsWithPlIncome(RWayS.Date) THEN
   curIPCondition:=L_APWI.ConvWithGu_to_IPCForVldPsg(WithGuVld);
   IF ((Quality.Type # L_Way.QualType_Annul) | L_APWI.E_AnnulQualityWithPln(RWayS.Date, WithGuVld)) &
      ~L_APWI.CalcVldPsgPlanIsCancelled(RWayS.Date, L_APWI.Conv_IPCForVldPsgPlan(RWayS.Date, curIPCondition)) THEN
    IF L_APWI.E_RWayJPlanIsEqualFactAnyObject(RWayS.Date, L_APWI.ObjectP_VldPsg) THEN
     Result:=ଏᔠ();
    ELSE
     Result:=L_APWI.E_GetPlanIncomeScope(L_APWI.piScope_RWTaxed, RWayS.Date, curIPCondition);
    END;
   END;
  END;
  RETURN Result;
 END {GetVldPsgPlans};

 PRIVATE PROCEDURE FirstPass(First: SCAL[2]; Dir: NUMERIC[0]);
  VAR
   TrBTim,
   TrBTim2,
   TrETim,
   TrETim2,
   voidTimeFact,
   voidTimeTaxed: NUMERIC[3];
   TrCorFlNbr   : SCAL[TripAmount];
   curTKind,
   TKindCorFl   : LIKE(TKind.TKind);
   FuelIdx,
   FuelAmnt     : NUMERIC[0];
   _RemEntr     : LIKE(RWayF.RemEntr);
   _RemExit     : LIKE(RWayF.RemExit);
   _FuelFact    : LIKE(RWayS.FuelFact);
   FN,
   FMove,
   FMoved       : LIKE(RWayS.FuelNorm);
   LossExit     : LIKE(StExit.Exit);
 BEGIN
  IF First | (Dir = +1) THEN
   ProceedLinkedDocs(+1, 0);
  END;

  IF First THEN
   fpof_AtBegin();
  END;

  SETEMPTY(TrETim, Holidays, CurWho, ForFN, TripIPl, TrCorFlNbr);
  L_RWayS.InitRWJPStore();

  SETZERO(RWayS.FuelNorm, _FNorm, CBoxNbr,
          TotalRun, ZrRun,
          TripNbr, HigTKind);

  IF ~Mark.Electric THEN
   L_Way.PrepareFNorm();
  END;

  SETSEL(RWayJ, RWayS, RWayS.RWayS);
  FOR_EACH RWayJ DO
   PROMPT(" "+RWayJ.Trip);
   L_RWayS.ScanRWJP(TripNbr);
   CONFORM(RWayJ, SEJobs, Route, RoutMod, WJMode, Quality, TKind);
   IF L_SCAD.E_RWayCPLevel(RWayS.Date) THEN
    CONFORM(RWayJ, RWayCP);
    WHILE OCCURE(RWayCP) DO
     L_General.Assert(~!RWayJ.Quality & ~!RWayCP.Shift, "室 믮 ஢  ⬥⮪");
     L_General.Assert(Quality.Type # L_Way.QualType_Annul, "믮 ३     ⬥⪨");
     L_SCAD.CheckCurRWayCP();
     NEXT(RWayCP);
    END;
   END;

   IF L_Events.IsAfterEditInsertEvents(MODE) THEN
    voidTimeTaxed:=GetRWJP(L_Way.rwjp_DecreaseLossTime);
    IF L_Way.IsLOSS() THEN
     LossExit:=GetLossExit();
     IF ~!LossExit THEN
      voidTimeFact :=L_Way.RWayJVoidTime(LossExit);
      IF voidTimeFact # voidTimeTaxed THEN
       IF STDFORM("|⥫ 81 '४஢ ६ ' ३ " + RWayJPoint() +
                  "| ᮮ⢥ ६ ()  ᯨᠭ" +
                  "||⥫    " + FLDTOSTR(voidTimeTaxed, "3.") +
                  "| ᯨᠭ " + FLDTOSTR(voidTimeFact, "3.") +
                  "||%< {}ਢ  ᮮ⢥⢨ >DB %< {}믮 >B %< {} >X", , STOP, -1) = 1 THEN
        IF SEARCH(RWayJP, RWayS, RWayJ.RWayS, RWayJ.Day, RWayJ.StartT, L_Way.rwjp_DecreaseLossTime) THEN
         RWayJP.Value:=voidTimeFact;
         REPLACE(RWayJP);
        ELSE
         RWayJP.RWayS :=RWayJ.RWayS;
         RWayJP.Day   :=RWayJ.Day;
         RWayJP.StartT:=RWayJ.StartT;
         RWayJP.RWJPro:=L_Way.rwjp_DecreaseLossTime;
         RWayJP.Value :=voidTimeFact;
         RWayJP.Source:=L_Way.rwjpSrc_Opert;
         INSERT(RWayJP);
        END;
        L_RWayS.SetRWJP(TripNbr, voidTimeFact);
       END;
      END; (* IF voidTimeFact # voidTimeTaxed *)
      voidTimeTaxed:=GetRWJP(L_Way.rwjp_DecreaseLossTime);
      L_General.Assert(voidTimeTaxed <= (L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT) -
                                         L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT)),
                       "襭   ३  த⥫쭮 ३ " + RWayJPoint());
     END; (* IF ~!LossExit *)
    ELSIF voidTimeTaxed # 0 THEN
     L_General.CallUs(SEARCH(RWayJP, RWayS, RWayJ.RWayS, RWayJ.Day, RWayJ.StartT, L_Way.rwjp_DecreaseLossTime));
     L_RWayS.SetRWJP(TripNbr, 0);
     REMOVE(RWayJP);
    END; (* IF L_Way.IsLOSS() *)
   END;

   TrBTim2:=L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT);
   TrETim2:=L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT);
   IF (Quality.Type # L_Way.QualType_Annul) & ~E_NeedTimeCross(RWayS.Date) THEN
    TrBTim:=TrBTim2;
    L_General.Assert(L_Events.IsBeforeEditEvent(MODE)                                | !TrETim | (TrBTim >= TrETim), " ३ᮢ");
    L_General.Assert(L_Events.IsBeforeEditEvent(MODE) | ~E_NeedTimeChain(RWayS.Date) | !TrETim | (TrBTim =  TrETim), " ᮡ 楯窠 ६: ३ " + RWayJPoint());
    TrETim:=TrETim2;
   END;

   L_Way.PositionOnRouteLog(Route.Route, RWayS.Date);
   curTKind:=RouteLog.TKind;

   IF curTKind > HigTKind THEN
    HigTKind:=curTKind;
   END;

   CurTime   := RWayJ.StopT  - RWayJ.StartT;
   CurRun    := RWayJ.Run * RWayJ.Fact;

   SETZERO(WithGuVld, WithGu, WithDp);
   IF Quality.Type # L_Way.QualType_Annul THEN
    WithGu:=L_RWayS.IsWith(TrBTim2, TrETim2, L_Way.wlmwho_Guard);
    WithDp:=L_RWayS.IsWith(TrBTim2, TrETim2, L_Way.wlmwho_DrPupil);
    GetGuNbr(TrBTim2, TrETim2, WithGu, WithGuVld);
   END;

   IF CBoxLevel > 0 THEN
    SetCurIncome();
   END;

   TripIPl[TripNbr]:=GetPl();
   IF L_Way.E_VldPsgPlanLev(RWayS.Date) THEN
    TripPsgPl[TripNbr]:=GetVldPsgPlans();
   ELSE
    TripPsgPl[TripNbr]:=0;
   END;
   VldDvdr[TripNbr]:=Math.Max(1, WithGuVld);
   IPlDvdr[TripNbr]:=Math.Max(1, WithGu);

   IF ~Mark.Electric THEN
    IF RWayJ.Trip # L_Way.E_TripForFuelChainBreak(RWayS.Date) THEN
     SetForFN(TripNbr, curTKind, L_Way.CalcFN(RWayS.Date, CurTime, CurRun, WithDp>0, 1));
    ELSE
     SetForFN(TripNbr, curTKind, 0);
     TrCorFlNbr:=TripNbr;
     TKindCorFl:=curTKind;
    END;
   ELSE
    SetForFN(TripNbr, curTKind, 0);
   END;

   INC(RWayS.FuelNorm, ForFN[TripNbr]);

   IF WJMode.RunSel*Quality.Type > 0 THEN
    INC(TotalRun, CurRun);
    IF  WJMode.RunSel = L_Way.runsel_Zero THEN
     INC(ZrRun, CurRun);
    END;
   END;
   IF First THEN
    fpof_AtEveryTrip();
   END; (* IF First *)
   Inc_TripNbr();
  END; (* FOR_EACH RWayJ *)

  IF First & L_RWayS.E_GetTimesFromWayLMen() & (TripNbr > 1) THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    SELECT(WayLMen, RWayS, , RWayS.RWayS);
    WHILE OCCURE(WayLMen) DO
     IF !WayLMen.asWJMode THEN
      L_General.Error("   ६  ⥫쭮 ᮭ 뢠   ३ᠬ." +
                      "|⮬,      ⮫쪮  ३,"+
                      "|   ப ᮭ 㦭 㪠  ࠡ ()");
     END;
     NEXT(WayLMen);
    END; (* WHILE OCCURE(WayLMen) ... *)
   EXCEPT
   END; (* TRY *)
  END; (* IF First & L_RWayS.E_GetTimesFromWayLMen() & (TripNbr > 1) *)

  IF First & ((L_Fuel.FlAcntLev(RWayS.Date) = L_Fuel.fal_RfOpOffline) |
              ~L_Fuel.CarMustHaveNormalChain(RWayS.BoxNbr, RWayS.Date) )  THEN
   REPLACE(RWayS);
   CallProceedRWayF(1);
  END; (* IF First & ((L_Fuel.FlAcntLev( ... *)

  IF RWayS.FuelNorm > 0 THEN
   L_General.Assert(!TrCorFlNbr, "   ᯨᠭ ⮯ ?| |      ३ᮢ!");
   IF P_Car.GetP_NormAsFact(RWayS.BoxNbr, RWayS.Date) THEN
    SETZERO(_FNorm);

    FMoved:=RWayS.FuelFact;
    CONFORM(RWayS, RWayJ);
    TripNbr:=0;
    FN:=0;
    WHILE OCCURE(RWayJ) DO
     IF ForFN[TripNbr] # 0 THEN
      CONFORM(RWayJ, SEJobs);
      L_Way.PositionOnRouteLog(SEJobs.Route, RWayS.Date);
      INC(FN, ForFN[TripNbr]);
      IF FN < RWayS.FuelNorm THEN
       FMove:=ForFN[TripNbr]*RWayS.FuelFact/RWayS.FuelNorm;
      ELSE
       FMove:=FMoved;
      END;
      DEC(FMoved, FMove);
      SetForFN(TripNbr, RouteLog.TKind, FMove);
     END;
     NEXT(RWayJ);
     Inc_TripNbr();
    END; (* WHILE OCCURE(RWayJ) *)
    RWayS.FuelNorm:=RWayS.FuelFact;
   ELSIF First & (RWayS.FuelFact > 0) THEN
    CheckRatio(RWayS.FuelFact/RWayS.FuelNorm, E_MaxFuelFNRatio(RWayS.Date), "ଠ / 室 ⮯");
   END;
  ELSE
   IF ~!TrCorFlNbr THEN
    RWayS.FuelNorm:=RWayS.FuelFact;
    SetForFN(TrCorFlNbr, TKindCorFl, RWayS.FuelFact);
   END;
  END; (* IF RWayS.FuelNorm > 0... *)

  fpof_AtEnd(First, Dir);

  SETZERO(ForFuel, Econ, FuelAmnt, _RemExit, _RemEntr, _FuelFact);
  SETEMPTY(EconMaths);
  SELECT(RWayF, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayF) DO
   IF ~L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) THEN
    RWayF.Norm:=L_Fuel._FuelFact();
    L_General.CallUs(RWayF.RemExit=0);
    L_General.CallUs(RWayF.RemEntr=0);
   ELSE
    IF RWayS.FuelFact > 0 THEN
     RWayF.Norm:=RWayS.FuelNorm * (L_Fuel._FuelFact()/RWayS.FuelFact);
    ELSE
     RWayF.Norm:=0;
    END;
    INC(_RemExit, RWayF.RemExit);
    INC(_RemEntr, RWayF.RemEntr);
    IF ~L_APtm.IsOG_Fuel(RWayS.Date) THEN
     L_General.Assert(L_Fuel._FuelFact()>=0, "⥫ 室 ⮯   " + RWayF.Math +
                                             "|(. ' ')");
    END;
    INC(_FuelFact, L_Fuel._FuelFact());
   END;
   IF MarkFuel.CntToPay=2(* *) THEN
    INC(ForFuel, (RWayF.Norm-L_Fuel._FuelFact())*L_Fuel.PriceOfOver(RWayF.Math, RWayS.Date));
    IF L_Way.E_FuelPayLev(RWayS.Date) = 1 THEN
     L_General.Assert(SEARCH(MtyIdx, MtyIdx, RWayF.Math), " ࠢ筨  ⥫  ⮯"+RWayF.Math);
     L_Fuel.GetOrAddMathIdx(EconMaths, RWayF.Math, FuelIdx, FuelAmnt);
     Econ[FuelIdx]:=RWayF.Norm-L_Fuel._FuelFact();
    END;
   END;
   REPLACE(RWayF);
   NEXT(RWayF);
  END; (* WHILE OCCURE(RWayF) ... *)
  REPLACE(RWayS);

IF ~L_APtm.IsOG_Fuel(RWayS.Date) THEN
  IF (_RemExit # RWayS.RemExit) | (_RemEntr # RWayS.RemEntr) | (_FuelFact # RWayS.FuelFact) THEN
   L_General.Error("⪨  륧/ / 室 ⮯  ' '" +
                   "| ᮮ⢥  " +
                   L_StdFrm.HR() +
                   ", 뫨    뤠 ⮯" +
                   "| 믮 '⠭ 楯窨'");
  END;
  L_General.CallUs(_RemExit=RWayS.RemExit);
  L_General.CallUs(_RemEntr=RWayS.RemEntr);
END;

  IF ~L_Events.IsBeforeEditEvent(MODE) THEN
   IF    RWayS.FuelFact < 0 THEN
    IF L_APtm.IsOG_Fuel(RWayS.Date) THEN
     RWayS.FuelFact:=0;
     REPLACE(RWayS);
    ELSE
     _CondErrorForFuel(0, "⥫ 室 ⮯", ", ᫥ ନ 뤠 ⮯");
    END;
   ELSIF RWayS.FuelFact = 0 THEN
    IF ~L_APtm.IsOG_Fuel(RWayS.Date) THEN
     _CondErrorForFuel(RWayS.FuelNorm=0, "㫥 ଠ ⮯  㫥 室", ", ᫥ ନ 뤠 ⮯");
    END;
   ELSE
    _CondErrorForFuel(RWayS.FuelNorm>0, "㫥 室 ⮯  㫥 ଥ", ", ᫥ ନ ᤠ ⮯");
   END;
  END; (* IF ~L_Events.IsBeforeEditEvent(MODE) ... *)
 END {FirstPass};

 PRIVATE PROCEDURE CheckBoxNbrForCarRun(_BoxNbr: LIKE(Car.BoxNbr); Text: STRING[]);
 BEGIN
  IF (MODE = L_Events.md_SingleMakeDone) | (MODE = L_Events.md_StreamMakeDone) THEN
   L_General.Assert(L_Env.RealBoxNbr(_BoxNbr), " 䨪⨢ ࠦ ⨬ 㪠뢠 ஡"+Text);
  END;
 END {CheckBoxNbrForCarRun};

 PRIVATE PROCEDURE CarRunModify();
 BEGIN
  IF RWProc & (TotalRun # 0) THEN
   CheckBoxNbrForCarRun(Car.BoxNbr, "");
   L_Car.FixCarRun(Car.BoxNbr, RWayS.Date);
   ^CarMan(CarRun.Run, TotalRun);
   L_Car.BalCarRun();
   SELECT(WayLCar, RWayS, , RWayS.RWayS);
   WHILE OCCURE(WayLCar) DO
    CheckBoxNbrForCarRun(WayLCar.BoxNbr, "| ⥫ ");
    L_Car.FixCarRun(WayLCar.BoxNbr, RWayS.Date);
    ^CarMan(CarRun.Run, TotalRun);
    L_Car.BalCarRun();
    NEXT(WayLCar);
   END; (* WHILE OCCURE(WayLCar) ... *)
  END;
 END {CarRunModify};

 PRIVATE PROCEDURE FuelAcntCir(trgTKind: LIKE(TKind.TKind); trgQnt: L_XObj.tQnt);
 BEGIN
  IF !TK_AcCut[trgTKind] | (TK_AcCut[trgTKind] = L_Acnt.fictAcCut) THEN
   L_MathR.TKind2MtyIdxInformUs(trgTKind);
  END;
  IF trgQnt # 0 THEN
   L_Stock.Obtain_mItem(Math.Math, L_Stock.GetFuelTanksStorage(L_Way.GetRWaySMyFirm()));
   L_XObj.AccessXObject(mItem.XObject);
   L_XObj.MakeCir(FStore, L_AcCut.erkn_Get(RWayS.Date, L_AcCut.erkn_FuelInTanks),
                  L_DatTim.Per(RWayS.Date),
                  L_Acnt.E_Apport_FuelWriteOff(RWayS.Date),
                  TK_AcCut[trgTKind], 0, trgQnt, L_XObj.src_RWayS);
  END;
 END {FuelAcntCir};

 PRIVATE PROCEDURE GetPrvRWayS(): LIKE(RWayS.RWayS);
  VAR
   Result: LIKE(RWayS.RWayS);
 BEGIN
  SAVE(RWayS);
  IF CHANGESEL(RWayS, BoxNbr, RWayS.BoxNbr) & PREV(RWayS) THEN
   Result:=RWayS.RWayS;
  ELSE
   SETEMPTY(Result);
  END;
  RESTORE(RWayS);
  RETURN Result;
 END {GetPrvRWayS};

 PRIVATE PROCEDURE FuelAcnt();
  VAR
   _TKind : LIKE(TKind.TKind);
   FN     : LIKE(RWayS.FuelNorm);
   Moved,
   Move   : NUMERIC[2];
 BEGIN
  IF L_Fuel.TanksIsStock(RWayS.Date) & RWProc THEN
   IF !GetPrvRWayS() & (RWayS.RemExit # 0) THEN
    IF ~L_APtm.IsOG() THEN
     L_StdFrm.ConditionalCHOICE("    ࠦ "+RWayS.BoxNbr+"|⮪    륧   㫥", FStore # +1);
    END;
   END;
   IF L_Fuel.E_DoJDocByRWayS(RWayS.Date) THEN
    L_JDoc.ResetJDocByRWayS();
   ELSE
    IF !PROCREF(FuelAcntInit) THEN
     L_General.InformUs("ॡ ⠡ ᮮ⢥⢨  ॢ|" +
                        "  ࠧ१  ᯨᠭ ⮯");
    END;
    SETEMPTY(TK_AcCut);
    FuelAcntInit(TK_AcCut);
    PROMPT("஢   ");
    SELECT(RWayF, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayF) DO
     CONFORM(RWayF, Math);
     IF RWayS.FuelNorm = 0 THEN
      CONFORM(RWayS, RWayJ);
      CONFORM(RWayJ, Route);
      FuelAcntCir(L_Way.GetRouteTKind(RWayS.Date, 1), L_Fuel._FuelFact());
     ELSE
      Moved:=L_Fuel._FuelFact();
      _TKind:=01;
      FN:=0;
      WHILE _TKind <= HigTKind DO
       IF _FNorm[_TKind] > 0 THEN
        INC(FN, _FNorm[_TKind]);
        IF FN < RWayS.FuelNorm THEN
         Move:=L_Fuel._FuelFact()*_FNorm[_TKind]/RWayS.FuelNorm;
        ELSE
         Move:=Moved;
        END;
        DEC(Moved, Move);
        FuelAcntCir(_TKind, Move);
       END;
       INC(_TKind);
      END;
      L_General.CallUs(Moved = 0);
     END; (* IF RWayS.FuelNorm = 0... *)
     NEXT(RWayF);
    END; (* WHILE OCCURE(RWayF) ... *)
   END; (* IF L_Fuel.E_DoJDocByRWayS(RWayS.Date) *)
  END; (* IF L_Fuel.TanksIsStock ... *)
 END {FuelAcnt};

 PRIVATE PROCEDURE PasteAll();
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   PASTE(^(L_Card.GetCardName(L_Card.t_RWT, L_DatTim.Per(RWayS.Date))));
   PASTE(^(L_Card.GetCardName(L_Card.t_RWS, L_DatTim.Per(RWayS.Date))));
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = 191 THEN
    IF (RTI.Get().Stack(RTI.Get().Stack.Count-1).Proc.Module.Name = "RWayS") &
        RTI.Get().Stack(RTI.Get().Stack.Count-1).FindVar("IamInBeforeEdit").Initialized THEN
     TOOLTIP("  砥    㤥 ।⥫쭮 ந  ⪠");
     CALL(CallStub.AppendMacro('RunProg, "RWayS ' + L_Str.IntStr(L_Events.md_StreamMakeUnDone) + '", Edit, "@"'));
     HALT();
    ELSE
     L_General.Error("  筮 ० ⪠  " + RWayS.RWayS);
    END;
   ELSE
    RAISE();
   END;
  END;
  IF RWRExp THEN
   PASTE(RWayPrt);
  END;
 END {PasteAll};

 PRIVATE PROCEDURE SetStartTim();
  VAR
   prvRWayS: LIKE(RWayS.RWayS);
 BEGIN
  IF L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
   prvRWayS:=GetPrvRWayS();
   RWayS.StartTim:=C_T2L(RWayJ.Day, RWayJ.StartT);
   REPLACE(RWayS);
   IF L_Way.CarBegRWSLev(RWayS.BoxNbr, RWayS.Date) THEN
    L_General.Assert(prvRWayS = GetPrvRWayS(), "६ 砫 ⥢  蠥 楯 . "+RWayS.BoxNbr);
   END;
  ELSE
   RWayS.StartTim:=C_T2L(RWayJ.Day, RWayJ.StartT);
   REPLACE(RWayS);
  END;
 END {SetStartTim};

 PRIVATE PROCEDURE E_RWayS_ToPay(): LIKE(RWayS.ToPay);
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(RWayS.Date, PROCREF(E_Way.RWayS_ToPay), RWayS.ToPay);
 END {E_RWayS_ToPay};

 PRIVATE PROCEDURE CheckIsTaxed();
 BEGIN
  L_General.Assert(RWayS.Status=L_Way.rwsStat_Rated, "㬥  ⠪஢");
 END {CheckIsTaxed};

 PRIVATE PROCEDURE E_CompleteRWayS(Dir: NUMERIC[0]);
 BEGIN
  IF Dir = -1 THEN
   L_APWI.ClearVldPsgPlans();
  END;
  IF ~!PROCREF(CompleteRWayS) THEN (*  RWS_ *)
   CompleteRWayS(Dir);
  END;
 END {E_CompleteRWayS};

 PRIVATE PROCEDURE DoClientPart();
 BEGIN
  IF ~!PROCREF(ClientPart) THEN
   ClientPart();
  END;
 END {DoClientPart};

 PRIVATE PROCEDURE GlobalSettings();
 BEGIN
  PasteAll();
  CONFORM(RWayS, Calendar);
  CONFORM(RWayS, Car);
  L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
  RWFin     :=L_Way.RWaySType(RWayS.Type);
  mg_WagePay:=L_Way.GetMarkG(Mark.Mark, L_Way.mgt_WagePay);
  CBoxLevel :=E_CBoxCheckLevel(RWayS.Date); (* ?!? *)
  DoClientPart();
  L_AFM.MakeMultipleIndex("tmpCI", "CostItem   : LIKE(CostItem.CostItem);" +
                                   "XObject    : LIKE(XObject.XObject);"   +
                                   "ActCostItem: LIKE(CostItem.CostItem)",
                          "CostItem: CostItem");
 END {GlobalSettings};

 PRIVATE PROCEDURE CheckCurPer();
 BEGIN
  Memo.gl_SetCurDate(RWayS.Date);
  IF ~L_Events.IsStreamEvents(MODE) THEN
   L_PRoll.Salary_CheckClcPer();
  END;
 END {CheckCurPer};

 PRIVATE PROCEDURE Proceed(_Dir: NUMERIC[0]; Prompt: STRING[]);
  VAR
   i         : SCAL[WhoNbr+1];
   o_TSN     : LIKE(Staff.TSN);
   o_ManName,
   o_PostName: STRING[];
 BEGIN
  APP.Get().NewPrompt(" " + RWayS.RWayS + "  " + L_DatTim.DateStr(RWayS.Date)+". "+Prompt);
  IF (_Dir = -1) THEN
   L_AcsPnt.PassAccessPoint(0000019);
  ELSE
   L_AcsPnt.PassAccessPoint(0000017);
  END;

  L_General.SetConcurrentMode();

  IF StreamMode THEN
   L_General.SetCacheables(["Car", "CarLog", "CarPro", "MarkPro", "StExit", "SEJobs", "RoutePro", "MPG_WP", "WagePayL"]);
  END;

  L_General.Assert(~!RWayS.BoxNbr, " 㪠 ");
  L_General.Assert(~!RWayS.TSN,    " 㪠 ⥫");

  RWProc:=_Dir # 0;
  IF RWProc THEN
   L_RWayS.CheckPeriodForRWaySProcessing(RWayS.Date);
  END;
  IF    _Dir = -1 THEN
   ToTS     := "StTS";
   ForTEP   := "ChckTEP";
   FStore   := -1;
   CarMan   := "DEC";
  ELSIF _Dir = +1 THEN
   ToTS     := "LineTS";
   ForTEP   := "SaveTEP";
   FStore   := +1;
   CarMan   := "INC";
  END;

  CheckIsTaxed();
 
  Who[L_Way.rwswho_Driver ]:="⥫";
  Who[L_Way.rwswho_Guard  ]:="";
  Who[L_Way.rwswho_DrPupil]:="祭 ⥫";
  Who[L_Way.rwswho_GuPupil]:="祭 ";
  Who[L_Way.rwswho_SDriver]:="ண ⥫";
  Who[L_Way.rwswho_Chopper]:="稪";
  i:=L_Way.rwswho_Chopper+1;
  WHILE i < WhoNbr DO
   Who[i]:=".ᮭ "+L_Str.IntStr(i);
   INC(i);
  END;
 
  IF RWProc | RWRDo THEN
   Memo.gl_SetCurDate(RWayS.Date);
  END;

  IF RWProc THEN
   L_General.Assert(RWayS.Date >= L_General.DenominationDate(), "⨬ ࠡ⪠  樨");
   CheckCurPer();
  END;
 
  IF KioskMode THEN
   KioskTSN:=Staff.TSN;
  END;
  GlobalSettings();
 
  IF RWRDo THEN
   IF ~StreamMode THEN
    IF RWRExp THEN
     OPENREP(R, L_General.NameConnection("RWayE"), Create, FontProperty, "/B");
    ELSE
     OPENREP(R, L_General.NameConnection("RWayS"), Create, FontProperty, "/B");
    END;
   END;
   IF KioskMode THEN
    MAKEPART(R, HeaderK);
   ELSE
    MAKEPART(R, Header);
   END;
   SAVE(Car);
   SAVE(Mark);
   SELECT(WayLCar, RWayS, , RWayS.RWayS);
   WHILE OCCURE(WayLCar) DO
    CONFORM(WayLCar, Car);
    L_Car.AccessMark(WayLCar.BoxNbr, RWayS.Date);
    MAKEPART(R, CarLine);
    NEXT(WayLCar);
   END; (* WHILE OCCURE(WayLCar) ... *)
   RESTORE(Car);
   RESTORE(Mark);
  END;

  IF RWProc & ~L_Fuel.CarMustHaveNormalChain(RWayS.BoxNbr, RWayS.Date) THEN
   CallProceedRWayF(1);
  END; (* IF FlAcntLev ... *)
 
  SETZERO(TripArr, TripArrVld, Sal);
  FirstPass(0, _Dir);
 
  GlobalRun:=L_Car.GetAccurateRunOnDate(RWayS.BoxNbr, L_DatTim.Per(RWayS.Date));
 
  PassLeft(L_Way.wlmwho_SDriver);
  PassLeft(L_Way.wlmwho_GuPupil);
  PassLeft(L_Way.wlmwho_DrPupil);
  PassLeft(L_Way.wlmwho_Chopper);
  PassLeft(L_Way.wlmwho_Guard);
 
  CurWho :=L_Way.rwswho_Driver;
  ToSheet:=RWayS.ToSheet;
  ToPay  :=E_RWayS_ToPay();
  HasGap :=L_Way.GetGapSign(CurWho);
  CONFORM(RWayS, Staff);
  L_Staff.PosToStaffLog(Staff.TSN, RWayS.Date, 1);
  CONFORM(Staff, Man);
  CONFORM(StaffLog, Officer);
  CONFORM(Officer, Post);

  PassJobs(PROCREF(ja_forDriver));
  ProceedAllKeyAss(PROCREF(KA_ResetMathDone));

  L_AFM.AF_PurgeTemp("tmpCI");
 
  CarRunModify();
 
  FuelAcnt();
 
  IF RWProc THEN
   RWayS.Done:=~RWayS.Done;
   IF RWayS.Done THEN
    CheckIsTaxed();
   END;
   REPLACE(RWayS);
   IF L_Events.IsBeforeEditEvent(MODE) THEN
    ProceedLinkedDocs(-1, 0);
   END;
  END;
 
  IF RWRDo THEN
   IF ~RWRExp THEN
    MAKEPART(R, Bot);
   ELSE
    MakeBotExp();
   END;
   IF ~KioskMode THEN
    SETSEL(XDocJrn, XDocJrn, L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
    LAST(XDocJrn);
    WHILE (XDocJrn.Action # L_XDoc.action_Edit) & (XDocJrn.Action # L_XDoc.action_Insert) DO
     PREV(XDocJrn);
    END;
    CONFORM(XDocJrn, AcsObj);
    IF ~!AcsObj.Man THEN
     CONFORM(AcsObj, Man);
     o_TSN    :=L_Staff.Man2TSN(XDocJrn.Date, Man.Man, "", 0, 0);
     o_ManName:=Man.Name;
     IF ~!o_TSN THEN
      o_PostName:=P_Firm.GetManAttrByTSN(o_TSN, XDocJrn.Date, P_Firm.mpt_ManPostName);
     ELSE
      SETEMPTY(o_PostName);
     END;
    ELSE
     o_ManName:=AcsObj.FullName;
     SETEMPTY(o_PostName);
    END;
    MAKEPART(R, EndRep, o_PostName, L_Str.ShortName(o_ManName));
   END;
   IF ~StreamMode THEN
    CLOSEREP(R);
   END;
  END;
  IF L_Events.IsAfterEditInsertEvents(MODE) THEN
   L_Way.CurRWayS_XDocJrn_Stop();
  END;
  PROMPT("");
  IF ~RWProc THEN
   IF RWRDo & ~StreamMode & ~KioskMode THEN
    L_General.HaltAndSurveyLastReport(EMPTYOF(Exc_Root));
   ELSE
    HALT(1);
   END;
  END;
  IF RWRDo & L_Events.IsAfterEditInsertEvents(MODE) THEN
   L_General.SurveyLastReport();
  END;
 END {Proceed};

 PRIVATE PROCEDURE PosToFirstRWayJ();
 BEGIN
  CONFORM(RWayS, RWayJ);
  IF ~OCCURE(RWayJ) THEN
   L_General.Error("⥢    ३");
  ELSIF RWayJ.Day > 02 THEN
   L_General.Error(" ३      01,    02");
  END;
 END {PosToFirstRWayJ};

 PRIVATE PROCEDURE RWayS_OnAfterEdIns();
 BEGIN
(*? 0074618 *) TABLE.Get("RWayJP"  ).AccessDataMode:=adm_RIDGE;
  L_XDoc.xdmb_CheckABan(L_XDoc.xdcls_RWayS, RWayS.Date);
  TRY
   PosToFirstRWayJ();
   SetStartTim();
   RWProc:=0;
   IF ~L_Env.RealTSN(RWayS.TSN) THEN
    RWayS.ToPay  :=0;
    RWayS.ToSheet:=0;
    REPLACE(RWayS);
   END;
   GlobalSettings();
   FirstPass(1, 0);
   IF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert) |
      (L_Way.CarBegRWSLev(RWayS.BoxNbr, RWayS.Date) = 0) THEN
    L_BegRWS.E_CheckCrewFitForExit(L_XDoc.action_Edit);
   END;
  EXCEPT
  ON Exc: Exc_Raise DO
   L_General.CheckIsRoughRaiseException(Exc);
   SetUnratedRWaySStatus(Exc.MsgOriginalText, "");
  ON Exc: Exc_Root DO
   SetUnratedRWaySStatus(L_General.ExcDescription(Exc), "");
  END;
  CheckCurPer();
  IF L_APtm.MonthIsClosed(L_DatTim.Per(RWayS.Date), L_APtm.system_Salary) THEN
   L_StdFrm.Inform("室 ࠡ ⥢ ");
  END;
  L_Way.CurRWayS_XDocJrn_Stop();
 END {RWayS_OnAfterEdIns};

 PRIVATE PROCEDURE SetWinFieldsForBegRWS(Edit: SCAL[2]);
  VAR
   _EditRWayF: SCAL[2];
   _Zone     : NUMERIC[0];
   fal       : L_Fuel.tfal;
 BEGIN
  fal:=L_Fuel.FlAcntLev(RWayS.Date);
  L_WDO.SetFieldModifiable("RWayS.RWayS",      0);
  L_WDO.SetFieldModifiable("RWayS.BoxNbr",  Edit);
  L_WDO.SetFieldModifiable("RWayS.Date",    Edit);
  L_WDO.SetFieldModifiable("RWayS.TSN",     Edit);
  L_WDO.SetFieldModifiable("RWayS.Exit",    Edit);
  L_WDO.SetFieldModifiable("RWayS.RemExit", Edit & (fal # L_Fuel.fal_None));
  L_WDO.SetFieldModifiable("RWayS.RemEntr", Edit & (fal # L_Fuel.fal_None));
  L_WDO.SetFieldModifiable("RWayS.SMBef",   Edit);
  L_WDO.SetFieldModifiable("RWayS.SMAft",   Edit);
  _EditRWayF:=Edit | (fal = L_Fuel.fal_RWOP);
  TRY
   IF L_WDO.getActiveForm().OriginalName = "RWaySE_F" THEN
    _Zone:=6;
   ELSE
    _Zone:=2;
   END;
   L_WDO.SetFieldModifiable("RWayF.Math",     _EditRWayF);
   L_WDO.SetFieldModifiable("RWayF.FuelTake", _EditRWayF);
   L_WDO.SetFieldModifiable("RWayF.FuelRet",  _EditRWayF);
  EXCEPT
   ON Exc: Exc_RunTime DO
    IF Exc.ErrorCode # 66 THEN
     RAISE();
    END;
  END;
  L_WDO.z_SetFieldFormat(1, "RWayJ.Fact", L_Str.PoolItem("1.|0", L_Way.E_IntegerRWayJFact(RWayS.Date)));
 END {SetWinFieldsForBegRWS};

 PRIVATE PROCEDURE RWaySE_F_0_OnZoneOpen();
 BEGIN
  L_WDO.z_SetFieldFormat(3, "RWayJP.Source", L_Way.rwjpSrc_Pool);
  L_WDO.z_SetFieldFormat(5, "WayLMen.Who",   L_Way.wlmwho_Pool_Short);
 END {RWaySE_F_0_OnZoneOpen};

 PRIVATE PROCEDURE RWayS_OnBeforeInsert();
 BEGIN
  L_WDO.SetFieldFirst("RWayS.TSN", 1);
  SetWinFieldsForBegRWS(1);
  RWayS.Date:=Memo.ud_cd();
  IF L_Fuel.FlAcntLev(RWayS.Date) = L_Fuel.fal_None THEN
   SETZERO(RWayS.RemExit, RWayS.RemEntr);
  END;
  REPLACE(RWayS);
  L_AcsPnt.PassAccessPoint(0000022);
  L_Way.CurRWayS_XDocJrn_Start(L_XDoc.action_Insert);
  CheckCurPer();
 END {RWayS_OnBeforeInsert};

 PRIVATE PROCEDURE RWayS_OnAfterInsert();
 BEGIN
  RWayS_OnAfterEdIns();
 END {RWayS_OnAfterInsert};

 PRIVATE PROCEDURE RWayS_OnBeforeEdit();
 BEGIN
  L_General.SetSoftAccessDataModeForInteractiveModification();

  L_Way.CurRWayS_XDocJrn_Start(L_XDoc.action_Edit);
  L_General.Assert((RWayS.Status = L_Way.rwsStat_Taken) | (RWayS.Status = L_Way.rwsStat_Rated),
                   "㬥  ਭ");
  IamInBeforeEdit:=1;
  RWayS.Status:=L_Way.rwsStat_Rated;
  SetWinFieldsForBegRWS(L_Way.CarBegRWSLev(RWayS.BoxNbr, RWayS.Date)=0);
  REPLACE(RWayS);
  L_AcsPnt.PassAccessPoint(0000022);
  L_XDoc.xdmb_CheckABan(L_XDoc.xdcls_RWayS, RWayS.Date);
  IF RWayS.Done THEN
   Proceed(-1, "");
  ELSE
   ProceedLinkedDocs(-1, 1);
  END;
  L_Msg.CurRecordShownTroubles_MakeRead(TABLE.Get("RWayS"));
 END {RWayS_OnBeforeEdit};

 PRIVATE PROCEDURE RWayS_OnAfterEdit();
 BEGIN
  RWayS_OnAfterEdIns();
 END {RWayS_OnAfterEdit};

 PRIVATE PROCEDURE RWayS_OnBeforeDelete();
 BEGIN
  L_General.Error(" 㤠 ⥢ ");
 END {RWayS_OnBeforeDelete};

 PRIVATE PROCEDURE CondAction(Text: STRING[250]);
 BEGIN
  L_StdFrm.Choice(Text);
 END {CondAction};

 PRIVATE PROCEDURE RWayS_RWayS_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!RWayS.RWayS, " ⠢ ");
  L_XDoc.ChangeXDoc(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, GE_PVALUE(), RWayS.RWayS);
 END {RWayS_RWayS_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckChgConflict();
  VAR
   _Change: LIKE(RWayS.Change);
   _Status: LIKE(RWayS.Status);
   _Exit  : LIKE(RWayS.Exit);
   _CurRWayS,
   _RWayS : LIKE(RWayS.RWayS);
 BEGIN
  IF ~!RWayS.Exit & ~!RWayS.BoxNbr & L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
   IF RWayS.Status = L_Way.rwsStat_Ordered THEN
    SAVE(RWayS);
    CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
    NEXT(RWayS);
    L_General.Assert(~OCCURE(RWayS) | (RWayS.Status = L_Way.rwsStat_Ordered),
                     "뤠 ᫥騩 ⥢    ");
    RESTORE(RWayS);
   END;

   SAVE(StExit);
   CONFORM(RWayS, StExit);
   IF (RWayS.Status = L_Way.rwsStat_Ordered) |
      (StExit.Strict = L_Way.ExitStrict_Reg) THEN
    IF SELECT(WayLCar, BoxNbr, RWayS.BoxNbr, RWayS.Date) THEN
     CondAction(" ࠧ殮 | ᭮  ⥫쭮");
    END;
    SETEMPTY(_Change);
    _Status:=RWayS.Status;
    _CurRWayS:=RWayS.RWayS;
    SAVE(RWayS);
    CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr, RWayS.Date);
    FIRST(RWayS);
    WHILE OCCURE(RWayS) DO
     CONFORM(RWayS, StExit);
     IF (_Status=L_Way.rwsStat_Ordered) |
        (StExit.Strict = L_Way.ExitStrict_Reg) THEN
      IF !_Change THEN
       _RWayS :=RWayS.RWayS;
       _Change:=RWayS.Change;
       _Exit  :=RWayS.Exit;
      ELSE
       IF (_Change # 1) | (RWayS.Change # 2) THEN
        IF RWayS.RWayS # _CurRWayS THEN
         _RWayS :=RWayS.RWayS;
         _Exit  :=RWayS.Exit;
         _Change:=RWayS.Change;
        END;
        CondAction("䫨 ᬥ  ,  ࠧ殮    "+
                   "| " + _RWayS + ", 室 " + _Exit+ ", ᬥ " + _Change);
       END;
      END;
     END;
     NEXT(RWayS);
    END;
    RESTORE(RWayS);
   END; (* IF StExit.Strict ... *)
   RESTORE(StExit);
  END;
 END {CheckChgConflict};

 PRIVATE PROCEDURE GetWayLCars(    trgBoxNbr: LIKE(Car.BoxNbr);
                                   D        : DATE;
                               VAR WayLCars : LIKE(Car.BoxNbr)[]);
 BEGIN
  SETEMPTY(WayLCars);
  IF P_Car.HasActualCarPro(trgBoxNbr, D, P_Car.P_WayLCar) THEN
   P_Car.Decode_WayLCar(CarPro.Value, WayLCars);
  END;
 END {GetWayLCars};

 PRIVATE PROCEDURE ClearWayLCar(prvBoxNbr: LIKE(Car.BoxNbr);
                                prvDate  : DATE);
  VAR
   WayLCars: LIKE(Car.BoxNbr)[100];
   i       : NUMERIC[0];
 BEGIN
  IF ~!prvBoxNbr THEN
   GetWayLCars(prvBoxNbr, prvDate, WayLCars);
   i:=0;
   WHILE ~!WayLCars[i] DO
    IF SELECT(WayLCar, RWayS, RWayS.RWayS, WayLCars[i]) THEN
     REMSEL(WayLCar);
    END;
    INC(i);
   END; (* WHILE ~!WayLCars[i]...*)
  END;
 END {ClearWayLCar};

 PRIVATE PROCEDURE GetWayLCarList(WayLCars: LIKE(Car.BoxNbr)[100]; D: DATE): STRING[];
  VAR
   WayLCarList: STRING[];
   i          : NUMERIC[0];
 BEGIN
  SETEMPTY(WayLCarList);
  i:=0;
  WHILE ~!WayLCars[i] DO
   L_Car.AccessMark(WayLCars[i], D);
   WayLCarList:=WayLCarList + WayLCars[i] + " " + Mark.Name + "|";
   INC(i);
  END; (* WHILE ~!WayLCars[i]...*)
  RETURN WayLCarList;
 END {GetWayLCarList};

 PRIVATE PROCEDURE _RWayS_BoxNbr_OnSuccessfulChange(prvBoxNbr: LIKE(Car.BoxNbr);
                                                    prv_Date : DATE);
  VAR
   WayLCars   : LIKE(Car.BoxNbr)[100];
   i          : NUMERIC[0];
 BEGIN
  IF ~!RWayS.BoxNbr THEN
   CONFORM(RWayS, Car);
   CONFORM(RWayS, Staff);
   L_Car.CheckAdaptability(RWayS.BoxNbr, RWayS.Date, 0);
   IF L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
    L_BegRWS.intSetExitData(0);
    CheckChgConflict();
    L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
    IF RWayS.Status = L_Way.rwsStat_Ordered THEN
     IF ~L_BegRWS.E_wTRANSNAVIGATSIA(RWayS.Date) THEN
      L_General.Assert(CarLog.InBeg # L_Car.inBeg_DoesNot,
                       "浪   (. 'ᠭ ')");
     END;
    ELSE
     L_General.Assert(L_Way.CarBegRWSLev(RWayS.BoxNbr, RWayS.Date) = 0,
                      "ଫ ,  믨,  ⮫쪮  ,"+
                      "|ࠧ浪   (. 'ᠭ ')");
     SetWinFieldsForBegRWS(1);
    END;
   END;
   L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
   TRY
    L_WDO.SetFieldModifiable("RWayS.RemExit", ~Mark.Electric);
    L_WDO.SetFieldModifiable("RWayS.RemEntr", ~Mark.Electric);
   EXCEPT
    ON Exc: Exc_RunTime DO
     IF Exc.ErrorCode # 66 THEN
      RAISE();
     END;
   END;
   IF Mark.Electric THEN
    SETZERO(RWayS.RemExit, RWayS.RemEntr);
    REPLACE(RWayS);
   ELSIF (RWayS.Status = L_Way.rwsStat_Rated) &
         L_Env.RealBoxNbr(RWayS.BoxNbr) THEN
    RWayS.RemExit:=L_Way.GetBakVol(RWayS.BoxNbr, RWayS.Date);
    RWayS.RemEntr:=RWayS.RemExit;
    REPLACE(RWayS);
   END;
   IF ~L_Way.E_NeedSMChain(RWayS.Date) & !RWayS.SMBef &
      !RWayS.SMAft & (RWayS.Status = L_Way.rwsStat_Rated) THEN
    SETZERO(RWayS.SMBef, RWayS.SMAft);
    REPLACE(RWayS);
   END;
   ClearWayLCar(prvBoxNbr, prv_Date);
   GetWayLCars(RWayS.BoxNbr, RWayS.Date, WayLCars);
   IF ~!WayLCars[0] &
    L_StdFrm.RedAlternative("⠢ ⥫  ࠦ " + RWayS.BoxNbr + ":| |" +
                            GetWayLCarList(WayLCars, RWayS.Date)+" ?") THEN
    i:=0;
    WHILE ~!WayLCars[i] DO
     L_General.Assert(~SEARCH(WayLCar, RWayS, RWayS.RWayS, WayLCars[i]),
                      "  " + RWayS.RWayS + "|" +
                      " ⥫  㦥  ࠦ " + WayLCars[i]);
     DEFAULT(WayLCar);
     WayLCar.RWayS   :=RWayS.RWayS;
     WayLCar.RWayDate:=RWayS.Date;
     WayLCar.BoxNbr  :=WayLCars[i];
     INSERT(WayLCar);
     INC(i);
    END; (* WHILE ~!WayLCars[i]...*)
   END;
  ELSE
   ClearWayLCar(prvBoxNbr, prv_Date);
  END; (* IF ~!RWayS.BoxNbr & ... *)
 END {_RWayS_BoxNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE RWayS_BoxNbr_OnSuccessfulChange();
 BEGIN
  _RWayS_BoxNbr_OnSuccessfulChange(GE_PVALUE(RWayS.BoxNbr), RWayS.Date);
 END {RWayS_BoxNbr_OnSuccessfulChange};

 PUBLIC PROCEDURE extRWayS_TSN_OnSuccessfulChange();
  VAR
   _RWayS : LIKE(RWayS.RWayS);
   _StopT : TIME;
 BEGIN
  IF ~!RWayS.TSN & L_Env.RealTSN(RWayS.TSN) THEN
   CONFORM(RWayS, Staff);
   L_General.Assert(L_Staff.rInState(RWayS.Date), "⥫  ⮨  ");
   L_Staff.PosToStaffLog(Staff.TSN, RWayS.Date, 1);
   CONFORM(Staff, Man);
   CONFORM(StaffLog, Officer);
   IF ~L_Env.IsDriver() THEN
    CondAction(" ࠡ⭨   ⥫");
   END;
   L_RWayS.CheckSheet(RWayS.ToSheet);
   SAVE(RWayS);
   _RWayS:=RWayS.RWayS;
   CHANGESEL(RWayS, TSN, , RWayS.TSN, RWayS.Date);
   FIRST(RWayS);
   WHILE OCCURE(RWayS) DO
    IF RWayS.RWayS # _RWayS THEN
     SAVE(RWayJ);
     SETSEL(RWayJ, RWayS, RWayS.RWayS);
     IF LAST(RWayJ) THEN
      _StopT:=RWayJ.StopT;
     ELSE
      SETEMPTY(_StopT);
     END;
     RESTORE(RWayJ);
     CondAction("⥫ ࠧ殮    "+
                "| " + RWayS.RWayS + " 室 " + RWayS.Exit+
                "|  " + L_DatTim.TimeStr(RWayS.StartTim) + "  " + L_DatTim.TimeStr(_StopT));
    END;
    NEXT(RWayS);
   END;
   RESTORE(RWayS);
   IF !RWayS.BoxNbr | ((RWayS.Status = L_Way.rwsStat_Ordered) & ~L_Env.RealBoxNbr(RWayS.BoxNbr)) THEN
    IF L_Car.StandOnAnyMCFix(RWayS.TSN, RWayS.Date) THEN
     TRY
      RWayS.BoxNbr:=MCFix.BoxNbr;
      _RWayS_BoxNbr_OnSuccessfulChange(RWayS.BoxNbr, RWayS.Date);
      REPLACE(RWayS);
     EXCEPT
     ELSE
     END;
    END;
   END; (* IF !RWayS.BoxNbr ... *)
  END; (* IF ~!RWayS.TSN & ... *)
 END {extRWayS_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE RWayS_TSN_OnSuccessfulChange();
 BEGIN
  extRWayS_TSN_OnSuccessfulChange();
 END {RWayS_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE RWayS_Exit_OnSuccessfulChange();
 BEGIN
  IF ~!RWayS.Exit THEN
   CONFORM(RWayS, StExit);
   L_General.Assert(StExit.Strict # L_Way.ExitStrict_Fict, "⨢ 室");
   L_Way.CheckExitOnDate(RWayS.Exit, RWayS.Date, 1);
   L_BegRWS.intSetExitData(0);
   CheckChgConflict();
  END; (* IF ~!RWayS.Exit ... *)
 END {RWayS_Exit_OnSuccessfulChange};

 PRIVATE PROCEDURE RWayS_Date_OnSuccessfulChange();
 BEGIN
  RWayS_Exit_OnSuccessfulChange();
  _RWayS_BoxNbr_OnSuccessfulChange(RWayS.BoxNbr, GE_PVALUE(RWayS.Date));
  RWayS_TSN_OnSuccessfulChange();
  CONFORM(RWayS, WayLMen);
  WHILE OCCURE(WayLMen) DO
   WayLMen.RWayDate:=RWayS.Date;
   REPLACE(WayLMen);
   NEXT(WayLMen);
  END; (* WHILE OCCURE(... *)
 END {RWayS_Date_OnSuccessfulChange};

 PRIVATE PROCEDURE RWayS_RemExit_OnSuccessfulChange();
 BEGIN
  IF ~!RWayS.BoxNbr THEN
   L_Way.CheckBakVol(RWayS.BoxNbr, RWayS.Date, RWayS.RemExit, 1);
  END;
 END {RWayS_RemExit_OnSuccessfulChange};

 PRIVATE PROCEDURE RWayS_RemEntr_OnSuccessfulChange();
 BEGIN
  IF ~!RWayS.BoxNbr THEN
   L_Way.CheckBakVol(RWayS.BoxNbr, RWayS.Date, RWayS.RemEntr, 1);
  END;
 END {RWayS_RemEntr_OnSuccessfulChange};

 PRIVATE PROCEDURE SetSubWindow();
  VAR
   awWidth,
   awHeight     : NUMERIC[0];
   SubwindowName: STRING[];
 BEGIN
  IF (RTI.Get().CurWindow.OriginalName = "RWayS") & (RTI.Get().CurZone.Number = 1) THEN
   IF L_StdFrm.wGUI() & L_General.IsAcceptableProcessorVersion(14216030) THEN
    SubwindowName:="RWaySE_F";
   ELSE
    GE_APPWIN_SIZE(awWidth, awHeight);
    IF (awWidth >= L_General.MainWindowStandartWidth()) & (awHeight >= L_General.MainWindowStandartHeight()) THEN
     SubwindowName:="RWaySE_F";
    ELSE
     SubwindowName:="RWaySE";
    END;
   END;
   RTI.Get().CurZone.SubwindowOriginalName:=SubwindowName;
  END;
 END {SetSubWindow};

 PUBLIC PROCEDURE ChooseSuitableDriver(CheckFitToRWayS: SCAL[2]);
  VAR
   _TSN: LIKE(Staff.TSN);
 BEGIN
  L_General.Assert(ACCESS(RWayS), " ⠭ ");
  SAVE(RWayS);
  L_General.Assert(~!RWayS.Exit, "  室");
  CONFORM(RWayS, StExit);
  _TSN:=L_two.ChooseSuitableStaff(L_Way.rwswho_Driver,
                                  RWayS.Date,
                                  RWayS.RWayS,
                                  StExit.ExitClss,
                                  RWayS.Change,
                                  L_Way.E_GetFixedSortOfExit(StExit.Exit, RWayS.Date, L_two.who_Driver),
                                  RWayS.BoxNbr,
                                  CheckFitToRWayS);
  RESTORE(RWayS);
  RWayS.TSN:=_TSN;
  REPLACE(RWayS);
  RWayS_TSN_OnSuccessfulChange();
 END {ChooseSuitableDriver};

 PUBLIC PROCEDURE ChooseSuitableGuard();
  VAR
   _TSN: LIKE(Staff.TSN);
 BEGIN
  L_General.Assert(ACCESS(WayLMen), " ⠭ ");
  CONFORM(WayLMen, RWayS);
  SAVE(WayLMen);
  L_General.Assert(~!RWayS.Exit, "  室");
  CONFORM(RWayS, StExit);
  _TSN:=L_two.ChooseSuitableStaff(L_Way.rwswho_Guard,
                                  RWayS.Date,
                                  RWayS.RWayS,
                                  StExit.ExitClss,
                                  RWayS.Change,
                                  L_Way.E_GetFixedSortOfExit(StExit.Exit, RWayS.Date, L_two.who_Guard),
                                  RWayS.BoxNbr,
                                  0);
  RESTORE(WayLMen);
  WayLMen.TSN:=_TSN;
  REPLACE(WayLMen);
 END {ChooseSuitableGuard};

 PUBLIC PROCEDURE ChooseSuitableCar();
  VAR
   prvBoxNbr,
   newBoxNbr: LIKE(Car.BoxNbr);
 BEGIN
  L_General.Assert(ACCESS(RWayS), " ⠭ ");
  SAVE(RWayS);
  L_General.Assert(~!RWayS.Exit, "  室");
  prvBoxNbr:=RWayS.BoxNbr;
  CONFORM(RWayS, StExit);
  newBoxNbr:=L_two.ChooseSuitableCar(L_Way.E_GetFixedSortOfExit(StExit.Exit, RWayS.Date, L_two.who_Driver),
                                     RWayS.Date,
                                     L_two.ofc_Driver,
                                     RWayS.RWayS);
  RESTORE(RWayS);
  RWayS.BoxNbr:=newBoxNbr;
  REPLACE(RWayS);
  _RWayS_BoxNbr_OnSuccessfulChange(prvBoxNbr, RWayS.Date);
 END {ChooseSuitableCar};

 PUBLIC PROCEDURE OnAfterChainChange(Silent: SCAL[2]);
 BEGIN
  ACCESS(RWayS);
  APP.Get().NewPrompt(" " + RWayS.RWayS + "  " + L_DatTim.DateStr(RWayS.Date));
  SetCommonVars();
  CONFORM(RWayS, Car);
  CONFORM(Car, Mark);
  CallProceedRWayF(Silent);
  PASTE(^(L_Card.GetCardName(L_Card.t_RWT, L_DatTim.Per(RWayS.Date))));
  PASTE(^(L_Card.GetCardName(L_Card.t_RWS, L_DatTim.Per(RWayS.Date))));
  IF ~!PROCREF(OnSMChange) THEN (*  RWS_ *)
   OnSMChange();
  END;
  IF RWayS.Status = L_Way.rwsStat_Rated THEN
   TRY
    GlobalSettings();
    FirstPass(0, 0);
   EXCEPT
   ON Exc: Exc_Raise DO
    L_General.CheckIsRoughRaiseException(Exc);
    SetUnratedRWaySStatus(Exc.MsgOriginalText, "");
   ON Exc: Exc_Root DO
    SetUnratedRWaySStatus(L_General.ExcDescription(Exc), "");
   END;
  END;
 END {OnAfterChainChange};

 PUBLIC PROCEDURE scs_GetFilters_RWayS_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  IF AMOUNT(RWayS) < 100000 THEN
   L_WDO.PutNewFilter(Filters, "  ⥪饩 ", "(RWayS.Date=Memo.CurDate)", 1);
  END;
 END {scs_GetFilters_RWayS_1};

 PUBLIC PROCEDURE scs_GetNarrowing_RWayS_1(VAR NarrowingDescriptions: STRING[]);
 BEGIN
  NarrowingDescriptions:="ਭ ⥢ ";
  IF ACCESS(RWayS) THEN
   INC(NarrowingDescriptions, "|  ⥪饬 ");
   INC(NarrowingDescriptions, "|  ⥪饬 ࠡ⭨");
  END;
 END {scs_GetNarrowing_RWayS_1};

 PUBLIC PROCEDURE scs_SetNarrowing_RWayS_1(SelectChoice: NUMERIC[0]);
 BEGIN
  IF    SelectChoice = 1 THEN
   SELECT(RWayS, sRWayS, , L_Way.rwsStat_Taken);
  ELSIF SelectChoice = 2 THEN
   SELECT(RWayS, BoxNbr, , RWayS.BoxNbr);
  ELSIF SelectChoice = 3 THEN
   SELECT(RWayS, TSN, , RWayS.TSN);
  END;
 END {scs_SetNarrowing_RWayS_1};

 PRIVATE PROCEDURE SetCommonVars();
 BEGIN
  RWRDo     :=0;
  RWRExp    :=0;
  RWLDo     :=0;
  RWMDo     :=0;
  StreamMode:=0;
  KioskMode :=0;
  SetMJComment("");
 END {SetCommonVars};

 PUBLIC PROCEDURE MakeFaceLine();
 BEGIN
  SetCommonVars();
  _TSN      :=Staff.TSN;
  RWLDo     :=1;
  StreamMode:=1;
  Proceed(~RWayS.Done & (L_DatTim.Per(RWayS.Date) = Memo.gl_mb()), "楢 ");
 END {MakeFaceLine};

 PUBLIC PROCEDURE SetRated();
 BEGIN
  ACCESS(RWayS);
  L_StdFrm.Question("⬥ ⠪஢ ⥢ ");
  REPLACE(RWayS);
 END {SetRated};

 PRIVATE PROCEDURE MakeProtocolInteractive(trgRWRSal: tRWRSal);
 BEGIN
  ACCESS(RWayS);
  SetCommonVars();
  RWRDo     :=1;
  RWRSal:=trgRWRSal;
  Proceed(0, "⮪");
 END {MakeProtocolInteractive};

 PUBLIC PROCEDURE ProtocolShort();
 BEGIN
  MakeProtocolInteractive(rwrs_Short);
 END {ProtocolShort};

 PUBLIC PROCEDURE ProtocolWithTrips();
 BEGIN
  MakeProtocolInteractive(rwrs_WithTrips);
 END {ProtocolWithTrips};

 PUBLIC PROCEDURE ProtocolWithTripsAndMoney();
 BEGIN
  MakeProtocolInteractive(rwrs_WithTripsAndMoney);
 END {ProtocolWithTripsAndMoney};

 PUBLIC PROCEDURE ProtocolWithTripsAndZeroMoney();
 BEGIN
  MakeProtocolInteractive(rwrs_WithTripsAndZeroMoney);
 END {ProtocolWithTripsAndZeroMoney};

 PUBLIC PROCEDURE SingleRWPrtExp();
 BEGIN
  ACCESS(RWayS);
  SetCommonVars();
  RWRDo     :=1;
  RWRExp    :=1;
  RWRSal    :=rwrs_Short;
  Proceed(0, "⮪");
 END {SingleRWPrtExp};

 PUBLIC PROCEDURE StreamRWPrtExp();
 BEGIN
  ACCESS(RWayS);
  SetCommonVars();
  RWRDo     :=1;
  RWRExp    :=1;
  StreamMode:=1;
  RWRSal    :=rwrs_Short;
  Proceed(0, "⮪");
 END {StreamRWPrtExp};

 PUBLIC PROCEDURE KioskRWPrtExp();
 BEGIN
  ACCESS(RWayS);
  SetCommonVars();
  RWRDo     :=1;
  RWRExp    :=1;
  StreamMode:=1;
  KioskMode :=1;
  RWRSal    :=rwrs_Short;
  Proceed(0, "⮪");
 END {KioskRWPrtExp};

 PUBLIC PROCEDURE ProtocolCalcFN();
 BEGIN
  IF ACCESS(RWayS) THEN
   APP.Get().NewPrompt("⥢  " + RWayS.RWayS + "  " + L_DatTim.DateStr(RWayS.Date));
  END;
  SetCommonVars();
  PASTE(RWayPrt);
  MakeFNPRT();
  L_General.HaltAndSurveyLastReport(EMPTYOF(Exc_Root));
 END {ProtocolCalcFN};

 PUBLIC PROCEDURE RWM01Do();
 BEGIN
  ACCESS(RWayS);
  SetCommonVars();
  L_General.CallUs(~!DATABASE.Get().Tables("RWM01") & RWayS.Done);
  RWMDo     :=1;
  StreamMode:=1;
  Proceed(0, " ");
 END {RWM01Do};

BEGIN
 IF    L_Events.IsSubWinEvents(MODE) THEN
  SetSubWindow();
 ELSIF MODE # L_Events.md_InIMPORT THEN
  SetCommonVars();
  IF    L_Events.IsInternalEvents(MODE) THEN
   ^(L_Events.GetInternalEventHandlerName(MODE))();
  ELSIF (MODE = L_Events.md_SingleMakeUnDone) | (MODE = L_Events.md_StreamMakeUnDone) THEN
   ACCESS(RWayS);
   IF RWayS.Done THEN
    StreamMode:=(MODE=L_Events.md_StreamMakeUnDone);
    Proceed(-1, "");
   END;
  ELSIF (MODE = L_Events.md_SingleMakeDone) | (MODE = L_Events.md_StreamMakeDone) THEN
   ACCESS(RWayS);
   IF ~RWayS.Done THEN
    StreamMode:=(MODE=L_Events.md_StreamMakeDone);
    Proceed(+1, "᫥");
   END;
  ELSE
   L_General.BadMode(MODE);
  END; (* IF MODE ... *)
 END; (* IF L_Events.IsSubWinEvents(MODE) *)
END.
