(*
%Copyright   (c) Polak IT
%Author      02.06.2005 19:32:55 POLAK\Gina
%Purpose     ⮪    
%Type        report
%Specific    AP_PC
%Modified    11.08.2014 17:50:23 POLAK\Gina
%Environment
*)

 MODULE RWPrtExp [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Way, Memo, L_AFM, L_DatTim, L_Env, L_EC, E_Utils, L_OwnData, L_bp;

 PRIVATE CONST
  RepName = "RWayA";

 PRIVATE VAR
  RWOnPage,
  Cnt: NUMERIC[0];

(*
$P { Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################# ########## #####
==============================================================================
|  ⮪ ࠡ⪨ ⥢ ⮢  ਮ  ##########  ##########   |
}
*)

(*
$P{ EmptyLine:
@

}
*)

(*
$P{ Bot:
@
=() Polak====================================================================
}
*)


 PRIVATE PROCEDURE E_RWPrt_RWAmntOnPage(): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(Memo.ud_ut(), PROCREF(E_Utils.RWPrt_RWAmntOnPage), 9999999999);
 END {E_RWPrt_RWAmntOnPage};

 PUBLIC PROCEDURE RWPrtExp();
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
  L_AFM.MakeIndex("Tmp01", "_RWayS: LIKE(RWayS.RWayS)");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top);

  SELECT(RWayS, TSN, , Staff.TSN);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   ADD(Tmp01, Tmp01, , RWayS.RWayS);
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  SELECT(WayLMen, TSN, , Staff.TSN);
  SRCINSEL(WayLMen, GE, , Memo.ud_fr());
  WHILE OCCURE(WayLMen) & (WayLMen.RWayDate <= Memo.ud_ut()) DO
   IF (WayLMen.Who # L_Way.wlmwho_DrPupil) & (WayLMen.Who # L_Way.wlmwho_GuPupil) THEN
    ADD(Tmp01, Tmp01, , WayLMen.RWayS);
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)

  SELECT(Tmp01, Tmp01);
  WHILE OCCURE(Tmp01) DO
   SEARCH(RWayS, RWayS, , Tmp01._RWayS);
   IF RWayS.Status = L_Way.rwsStat_Rated THEN
    TRY
     GRANTALLRIGHTS();
     CALL(RWayS.KioskRWPrtExp());
    EXCEPT
    ON Exc: Exc_Halt DO
    END; (* TRY *)
   END;
   NEXT(Tmp01);
  END; (* WHILE OCCURE(RWayS) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("Tmp01");
 END {RWPrtExp};

 PUBLIC PROCEDURE SingleRWPrtExp();
 BEGIN
  CALL(RWayS.SingleRWPrtExp());
 END {SingleRWPrtExp};

 PRIVATE PROCEDURE E_SortVal(): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(Memo.ud_ut(), PROCREF(E_Utils.RWPrt_SortVal), RWayS.RWayS);
 END {E_SortVal};

 PUBLIC PROCEDURE RWayA();
  CONST
   bpId = "RWayA";
 BEGIN
  L_bp.Begin(bpId, "ᮢ ⮢ ਫ  ", L_bp.t_Report, L_General.tc_inIntvl);
  RWOnPage:=E_RWPrt_RWAmntOnPage();
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF (RWOnPage > 1) & (RWOnPage<5) THEN
   SetPrintAttr(R, MaxPages, 1, FontEnlargement, 0.7, TopMargin, 0, BottomMargin, 0, FontProperty, "/B");
  ELSE
   SetPrintAttr(R, FontProperty, "/B");
  END;
  L_AFM.MakeIndex("Tmp01", "SortVal: STRING[32]; _RWayS: LIKE(RWayS.RWayS)");
  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   PROMPT(" " + L_DatTim.DateStr(RWayS.Date) + "  " + RWayS.RWayS);
   CONFORM(RWayS, StExit, ExitClss);
   IF (L_Env.RealBoxNbr(RWayS.BoxNbr) | L_Env.RealTSN(RWayS.TSN)) &
      ((L_Way.E_BegRWSLev(RWayS.Date) < L_Way.brwsl_Active) |
       ((ExitClss.BegType # L_Way.ecbt_Outage) & (ExitClss.BegType # L_Way.ecbt_Repair) &
        (ExitClss.BegType # L_Way.ecbt_Reserv) & ~L_Way.E_IsGuardIdleExit(RWayS.Date, RWayS.Exit)) |
       L_XDoc.XDocSomeTimeWas(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS, L_XDoc.action_Reprint)) THEN
    Tmp01.SortVal:=E_SortVal();
    Tmp01._RWayS:=RWayS.RWayS;
    INSERT(Tmp01);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  PROMPT("");
  Cnt:=0;
  SELECT(Tmp01, Tmp01);
  WHILE OCCURE(Tmp01) DO
   SEARCH(RWayS, RWayS, , Tmp01._RWayS);
   TRY
    CALL(RWayS.StreamRWPrtExp());
   EXCEPT
   ON Exc: Exc_Halt DO
   END; (* TRY *)
   INC(Cnt);
   IF Cnt=RWOnPage THEN
    FORMFEED(R);
    Cnt:=0;
   ELSE
    MAKEPART(R, EmptyLine);
    MAKEPART(R, EmptyLine);
   END;
   NEXT(Tmp01);
  END; (* WHILE OCCURE(Tmp01) ... *)
  L_AFM.AF_PurgeTemp("Tmp01");
  CLOSEREP(R);
  L_bp.End();
 END {RWayA};

END.
