(*
%Copyright   (c) Polak Computer System
%Author      18.09.2002 16:55:19 POLAK\LDA
%Purpose       ਮ  ⥫, ࠬ  ⮬.
%Type        report
%Specific    AP
%Modified    17.07.2013 16:00:36 POLAK\GAV
%Environment
*)

 MODULE RWSWrk [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PRIVATE CONST
  ExcelRepName = "RWSWR";

  rlk_Normal = 0;
  rlk_Svod   = 1;
  rlk_Total  = 2;

  dl_None   = 0;
  dl_wModif = 1;

  emptyDtlObject = "...";

  cur_Route   = 0;
  cur_Exit    = 1;
  cur_ExitCls = 2;
  cur_Car     = 3;
  cur_Driver  = 4;
  cur_WJMode  = 5;

  svt_None  = 0;
  svt_Drv   = 1;
  svt_Gu    = 2;

  svt_Car   = 3;
  svt_Mark  = 4;

  svt_Route = 5;
  svt_Exit  = 6;

  p_CmnF = 0;
  p_CmnD = 1;
  p_CmnS = 2;
  p_CmnC = 3;
  p_RMdf = 4;
  p_Tims = 5;
  p_Runs = 6;
  p_Trps = 7;
  p_Incm = 8;
  p_Fuel = 9;

  p_RWay = 10;
  p_SvdT = 11;
  p_TimNoWork = 12;
  p_Excel= 13;

  BlockAmount = 10;
  LineAmount  = 13;

  lnbr_First  = 00;
  lnbr_RName1 = 01;
  lnbr_RName2 = 02;
  lnbr_Dlm0   = 03;
  lnbr_Dlm1   = 07;
  lnbr_Data   = 08;
  lnbr_Svod   = 09;
  lnbr_Dlm2   = 10;
  lnbr_Total  = 11;
  lnbr_Last   = 12;

  alg_LEFT   = "LEFT";
  alg_RIGHT  = "RIGHT";
  alg_CENTRE = "CENTRE";

 PRIVATE TYPE
  tCurObject   = SCAL[10];
  tRepPartKind = SCAL[10];
  tRepLineKind = SCAL[3];
  tDetailLevel = SCAL[2];

  tSortObject   = STRING[10 + 1 + 7 + 1 + 9 + 8];
  tDetailObject = STRING[3];

  tStringArr = STRING[][BlockAmount * LineAmount];

 IMPORT L_General, L_OwnData, L_StdFrm, L_Str, L_AFM, L_Way, D_TP, L_DatTim,
        L_Car, E_Way, Str, FIO, L_Basis, L_APtm, L_XDoc, L_RWayS, L_APWI, Memo;

 PRIVATE VAR
  CurObject  : tCurObject;

  RepSettings: SCAL[7][14];
  _Route     : LIKE(Route.Route);
  _Exit      : LIKE(StExit.Exit);
  _ExitClss  : LIKE(ExitClss.ExitClss);
  _BoxNbr    : LIKE(Car.BoxNbr);
  _TSN       : LIKE(Staff.TSN);
  _WJCode    : LIKE(WJMode.WJCode);
  RepTitle   : STRING[];
  tmpS       : STRING[][LineAmount];
  LineNbr    : NUMERIC[0];
  _ModifName : STRING[];

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "६ 䠩", "");
  CreateFIELD(Tmp, TypeRep,  SCAL[3],             "", "", "", "  (0-⮩, 1-᢮  ꥪ; 2-騩 ⮣)", "");
  CreateFIELD(Tmp, srtObj,   tSortObject,         "", "", "", "ꥪ ஢", "");
  CreateFIELD(Tmp, dtlObj,   tDetailObject,       "", "", "", "ꥪ ⠫樨", "");
  IF RepSettings[p_Excel] THEN
   CreateFIELD(Tmp, Exit,    LIKE(SEJobs.Exit),   "", "", "", "室", "");
   CreateFIELD(Tmp, Route,   LIKE(SEJobs.Route),  "", "", "", "", "");
   CreateFIELD(Tmp, Modif,   LIKE(SEJobs.Modif),  "", "", "", "䨪 ", "");
   CreateFIELD(Tmp, Day,     LIKE(SEJobs.Day),    "", "", "", " 砫 ३", "");
   CreateFIELD(Tmp, StartT,  LIKE(SEJobs.StartT), "", "", "", "砫 ३", "");
  END;
  CreateFIELD(Tmp, TSN,      LIKE(Staff.TSN),     "", "", "", "", "");
  CreateFIELD(Tmp, BoxNbr,   LIKE(CarLog.BoxNbr), "", "", "", "ࠦ", "");
  CreateFIELD(Tmp, RWayS,    LIKE(RWayS.RWayS),   "", "", "", "", "");
  CreateFIELD(Tmp, TotTim,   NUMERIC[3],         "", "0", "", "饥 ६", "");
  CreateFIELD(Tmp, WrkTim,   NUMERIC[3],         "", "0", "", "ந ६", "");
  CreateFIELD(Tmp, OrdTim,   NUMERIC[3],         "", "0", "", "६  拉", "");
  CreateFIELD(Tmp, TotRun,   NUMERIC[2],         "", "0", "", "騩 ஡", "");
  CreateFIELD(Tmp, ZeroRun,  NUMERIC[2],         "", "0", "", "㫥 ஡", "");
  CreateFIELD(Tmp, PsgRun,   NUMERIC[2],         "", "0", "", "ந. ஡", "");
  CreateFIELD(Tmp, FactTrip, NUMERIC[1],         "", "0", "", " (䠪)", "");
  CreateFIELD(Tmp, BadTrip,  NUMERIC[1],         "", "0", "", " (ࠪ)", "");
  CreateFIELD(Tmp, Cassa,    NUMERIC[2],         "", "0", "", "", "");
  CreateFIELD(Tmp, PlanIncome, NUMERIC[2],       "", "0", "", "室 ()", "");
  CreateFIELD(Tmp, FactIncome, NUMERIC[2],       "", "0", "", "室 (䠪)", "");
  CreateFIELD(Tmp, PassAmount, NUMERIC[0],       "", "0", "", "ᠦ", "");
  CreateFIELD(Tmp, FuelNorm, NUMERIC[4],         "", "0", "", "ଠ ⮯", "");
  CreateFIELD(Tmp, FuelFact, NUMERIC[4],         "", "0", "", "室 ⮯", "");

  CreateINDEXandLINK(Tmp, TSN,     PLURAL, Staff,  TSN,   USER, "", "", TSN);
  IF RepSettings[p_Excel] THEN
   CreateINDEXandLINK(Tmp, Exit,    PLURAL, StExit  , Exit,     USER, "", "", Exit);
   CreateINDEXandLINK(Tmp, RoutMod, PLURAL, RoutMod , Route,    USER, "", "", Route, Modif);
  END;
  CreateINDEXandLINK(Tmp, RWayS,   PLURAL, RWayS, RWayS, USER, "", "", RWayS);
  CreateINDEX       (Tmp, TypeRep, UNIQUE,                     "", "", TypeRep, srtObj, dtlObj);

  SetVersionOfFILE(Tmp, 0);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE _td(blockType: tRepPartKind;
                       Line     : NUMERIC[0]): NUMERIC[0];
 BEGIN
  RETURN blockType*LineAmount+Line;
 END {_td};

 PRIVATE PROCEDURE td(blockType: tRepPartKind): NUMERIC[0];
 BEGIN
  INC(LineNbr);
  RETURN _td(blockType, LineNbr-1);
 END {td};

 PRIVATE PROCEDURE ReplaceValue(VAR tmpStr: STRING[];
                                    Value : STRING[];
                                    Align : STRING[]);
  VAR
   BegPos, i: NUMERIC[0];
 BEGIN
  BegPos:=Str.Pos(tmpStr, "#");
  L_General.Assert(BegPos < Str.Length(tmpStr),
                   " ப  蠡   ⠢ 祭|"+Value);
  i:=BegPos;
  WHILE (i < Str.Length(tmpStr)) & (L_Str.Char(tmpStr, i) = "#") DO
   INC(i);
  END;
  tmpStr:=Str.Delete(tmpStr, BegPos, i - BegPos);
  tmpStr:=Str.Insert(tmpStr, Str.Align(Value, i - BegPos, ^Align), BegPos);
 END {ReplaceValue};

 PRIVATE PROCEDURE PlaceLineInFile(Line: STRING[]);
 BEGIN
  FIO.WrStr(R, Line);
  FIO.WrLn(R);
 END {PlaceLineInFile};

 PRIVATE PROCEDURE JoinArrays_InOne(s: tStringArr);
  VAR
   i, j: NUMERIC[0];
 BEGIN
  SETEMPTY(tmpS);
  i:=0;
  WHILE i < LineAmount DO
   j:=0;
   WHILE j < BlockAmount DO
    tmpS[i]:=tmpS[i]+s[_td(j, i)];
    INC(j);
   END; (* WHILE j < BlockAmount ...*)
   INC(i);
  END; (* WHILE i < LineAmount...*)

  i:=LineAmount-1;
  WHILE i > 1 DO
   DEC(i);
   tmpS[i]:=tmpS[i]+"|";
  END; (* WHILE i > 1...*)
 END {JoinArrays_InOne};

 PRIVATE PROCEDURE AddDelimiters(VAR s        : tStringArr;
                                     blockType: tRepPartKind);
  VAR
   Idx: NUMERIC[0];
 BEGIN
  LineNbr:=0;
  s[_td(blockType, 0)] := s[_td(blockType, 0)]  + "=";
  s[_td(blockType, 1)] := s[_td(blockType, 1)]  + "#";
  s[_td(blockType, 2)] := s[_td(blockType, 2)]  + "#";
  s[_td(blockType, 3)] := s[_td(blockType, 3)]  + "-";
  s[_td(blockType, 4)] := s[_td(blockType, 4)]  + "|";
  s[_td(blockType, 5)] := s[_td(blockType, 5)]  + "|";
  s[_td(blockType, 6)] := s[_td(blockType, 6)]  + "|";
  s[_td(blockType, 7)] := s[_td(blockType, 7)]  + "|";
  s[_td(blockType, 8)] := s[_td(blockType, 8)]  + "|";
  s[_td(blockType, 9)] := s[_td(blockType, 9)]  + "#";
  s[_td(blockType, 10)]:= s[_td(blockType, 10)] + "-";
  s[_td(blockType, 11)]:= s[_td(blockType, 11)] + "#";
  s[_td(blockType, 12)]:= s[_td(blockType, 12)] + "=";
 END {AddDelimiters};

 PRIVATE PROCEDURE CreateRep();
  VAR
   s: tStringArr;
 BEGIN
  SETEMPTY(s);

  LineNbr:=0;
  s[td(p_CmnF)] := "==";
  s[td(p_CmnF)] := "|";
  s[td(p_CmnF)] := "|";
  s[td(p_CmnF)] := "|";
  s[td(p_CmnF)] := "|";
  s[td(p_CmnF)] := "|";
  s[td(p_CmnF)] := "|";
  s[td(p_CmnF)] := "|";
  s[td(p_CmnF)] := "|";
  s[td(p_CmnF)] := "|";
  s[td(p_CmnF)] := "|";
  s[td(p_CmnF)] := "|";
  s[td(p_CmnF)] := "==";

  IF RepSettings[p_CmnD] THEN
   LineNbr:=0;
   s[td(p_CmnD)]:="================";
   s[td(p_CmnD)]:="################";
   s[td(p_CmnD)]:="################";
   s[td(p_CmnD)]:="----------------";
   s[td(p_CmnD)]:="        |       ";
   s[td(p_CmnD)]:="    |⥢";
   s[td(p_CmnD)]:="        |       ";
   s[td(p_CmnD)]:="--------|-------";
   s[td(p_CmnD)]:="########|#######";
   s[td(p_CmnD)]:="################";
   s[td(p_CmnD)]:="----------------";
   s[td(p_CmnD)]:="################";
   s[td(p_CmnD)]:="================";
   AddDelimiters(s, p_CmnD);
  END;

  IF RepSettings[p_CmnS] THEN
   LineNbr:=0;
   s[td(p_CmnS)]:="=====================";
   s[td(p_CmnS)]:="#####################";
   s[td(p_CmnS)]:="#####################";
   s[td(p_CmnS)]:="---------------------";
   s[td(p_CmnS)]:="                     ";
   s[td(p_CmnS)]:="##############       ";
   s[td(p_CmnS)]:="                     ";
   s[td(p_CmnS)]:="---------------------";
   s[td(p_CmnS)]:="#####################";
   s[td(p_CmnS)]:="#####################";
   s[td(p_CmnS)]:="---------------------";
   s[td(p_CmnS)]:="#####################";
   s[td(p_CmnS)]:="=====================";
   IF RepSettings[p_CmnC] | RepSettings[p_RMdf] THEN
    AddDelimiters(s, p_CmnS);
   END;
  END;

  IF RepSettings[p_CmnC] THEN
   LineNbr:=0;
   s[td(p_CmnC)]:="====================================";
   s[td(p_CmnC)]:="####################################";
   s[td(p_CmnC)]:="####################################";
   s[td(p_CmnC)]:="------------------------------------";
   s[td(p_CmnC)]:="    |          |                    ";
   s[td(p_CmnC)]:=".|. |ઠ               ";
   s[td(p_CmnC)]:="    |          |                    ";
   s[td(p_CmnC)]:="----|----------|--------------------";
   s[td(p_CmnC)]:="####|##########|####################";
   s[td(p_CmnC)]:="####################################";
   s[td(p_CmnC)]:="------------------------------------";
   s[td(p_CmnC)]:="####################################";
   s[td(p_CmnC)]:="====================================";
   IF RepSettings[p_RMdf] THEN
    AddDelimiters(s, p_CmnC);
   END;
  END;

  IF RepSettings[p_RMdf] THEN
   LineNbr:=0;
   s[td(p_RMdf)]:="===";
   s[td(p_RMdf)]:="###";
   s[td(p_RMdf)]:="###";
   s[td(p_RMdf)]:="---";
   s[td(p_RMdf)]:="   ";
   s[td(p_RMdf)]:="";
   s[td(p_RMdf)]:="   ";
   s[td(p_RMdf)]:="---";
   s[td(p_RMdf)]:="###";
   s[td(p_RMdf)]:="###";
   s[td(p_RMdf)]:="---";
   s[td(p_RMdf)]:="###";
   s[td(p_RMdf)]:="===";
  END;

  IF RepSettings[p_Tims] THEN
   LineNbr:=0;
   s[td(p_Tims)]:="===========================";
   s[td(p_Tims)]:="###########################";
   s[td(p_Tims)]:="###########################";
   s[td(p_Tims)]:="---------------------------";
   s[td(p_Tims)]:="|           ६          ";
   s[td(p_Tims)]:="|--------------------------";
   s[td(p_Tims)]:="|    .|    .|   ";
   s[td(p_Tims)]:="|--------|--------|--------";
   s[td(p_Tims)]:="|########|########|########";
   s[td(p_Tims)]:="###########################";
   s[td(p_Tims)]:="|--------|--------|--------";
   s[td(p_Tims)]:="|########|########|########";
   s[td(p_Tims)]:="===========================";
  END;
  IF RepSettings[p_Runs] THEN
   LineNbr:=0;
   s[td(p_Runs)]:="===========================";
   s[td(p_Runs)]:="###########################";
   s[td(p_Runs)]:="###########################";
   s[td(p_Runs)]:="---------------------------";
   s[td(p_Runs)]:="|          ஡          ";
   s[td(p_Runs)]:="|--------------------------";
   s[td(p_Runs)]:="|    .|    .|    ";
   s[td(p_Runs)]:="|--------|--------|--------";
   s[td(p_Runs)]:="|########|########|########";
   s[td(p_Runs)]:="                           ";
   s[td(p_Runs)]:="|--------|--------|--------";
   s[td(p_Runs)]:="|########|########|########";
   s[td(p_Runs)]:="===========================";
  END;
  IF RepSettings[p_Trps] THEN
   LineNbr:=0;
   s[td(p_Trps)]:="==============";
   s[td(p_Trps)]:="##############";
   s[td(p_Trps)]:="##############";
   s[td(p_Trps)]:="--------------";
   s[td(p_Trps)]:="|        ";
   s[td(p_Trps)]:="|-------------";
   s[td(p_Trps)]:="|   | ࠪ";
   s[td(p_Trps)]:="|-------|-----";
   s[td(p_Trps)]:="|#######|#####";
   s[td(p_Trps)]:="              ";
   s[td(p_Trps)]:="|-------|-----";
   s[td(p_Trps)]:="|#######|#####";
   s[td(p_Trps)]:="==============";
  END;
  IF RepSettings[p_Incm] THEN
   LineNbr:=0;
   s[td(p_Incm)]:="===============================================";
   s[td(p_Incm)]:="###############################################";
   s[td(p_Incm)]:="###############################################";
   s[td(p_Incm)]:="-----------------------------------------------";
   s[td(p_Incm)]:="|                    室                     ";
   s[td(p_Incm)]:="|----------------------------------------------";
   s[td(p_Incm)]:="|     |      |      | % |  ";
   s[td(p_Incm)]:="|----------|----------|----------|------|------";
   s[td(p_Incm)]:="|##########|##########|##########|######|######";
   s[td(p_Incm)]:="                                               ";
   s[td(p_Incm)]:="|----------|----------|----------|------|------";
   s[td(p_Incm)]:="|##########|##########|##########|######|######";
   s[td(p_Incm)]:="===============================================";
  END;
  IF RepSettings[p_Fuel] THEN
   LineNbr:=0;
   s[td(p_Fuel)]:="==============================";
   s[td(p_Fuel)]:="##############################";
   s[td(p_Fuel)]:="##############################";
   s[td(p_Fuel)]:="------------------------------";
   s[td(p_Fuel)]:="|                      ";
   s[td(p_Fuel)]:="|-----------------------------";
   s[td(p_Fuel)]:="|    ଠ|     |   /";
   s[td(p_Fuel)]:="|---------|---------|---------";
   s[td(p_Fuel)]:="|#########|#########|#########";
   s[td(p_Fuel)]:="                              ";
   s[td(p_Fuel)]:="|---------|---------|---------";
   s[td(p_Fuel)]:="|#########|#########|#########";
   s[td(p_Fuel)]:="==============================";
  END;
  JoinArrays_InOne(s);
 END {CreateRep};

 PRIVATE PROCEDURE InsText_InBasicString(    Text       : STRING[];
                                         VAR BasicString: STRING[]);
  CONST
   BasicPosition = 1;
 BEGIN
  BasicString:=Str.Insert(Str.Delete(BasicString, BasicPosition, Str.Length(Text)),
                          Text, BasicPosition);
 END {InsText_InBasicString};

 PRIVATE PROCEDURE MakeTop(FullRepName: STRING[]; BPer, EPer: DATE);
  CONST
   SysDateTimeLength = 16;
  VAR
   i          : NUMERIC[0];
   Title,
   _ODFirmName: STRING[];
 BEGIN
  OPENREP(R, L_General.NameConnection(FullRepName), Create,
          TopMargin,       10,
          BottomMargin,    10,
          LeftMargin,      10,
          RightMargin,     10,
          FontEnlargement, 1.2);
  InsText_InBasicString(FullRepName, tmpS[lnbr_First]);
  ReplaceValue(tmpS[lnbr_RName1], "  ਮ  " + L_DatTim.DateStr(BPer) + "  " + L_DatTim.DateStr(EPer), alg_CENTRE);
  ReplaceValue(tmpS[lnbr_RName2], RepTitle, alg_CENTRE);
  IF RepSettings[p_CmnS] THEN
   IF RepSettings[p_RWay] THEN
    IF RepSettings[p_SvdT] = svt_Gu THEN
     Title:="";
    ELSE
     Title:="⥫";
    END;
   ELSE
    IF    CurObject = cur_Car THEN
     Title:=L_Str.PoolItem(" |⥫|| | ||室", RepSettings[p_SvdT]);
    ELSIF  CurObject = cur_Driver THEN
     Title:=L_Str.PoolItem(" |||ઠ||室", RepSettings[p_SvdT]);
    ELSE
     Title:=L_Str.PoolItem(" |⥫||⥫|⥫", RepSettings[p_SvdT]);
    END;
   END;
   ReplaceValue(tmpS[5], Title, alg_LEFT);
  END;

  _ODFirmName:=Str.Slice(L_OwnData.ODFirmName(SYSDATE()), 0, Str.Length(tmpS[lnbr_First]) - SysDateTimeLength - 1);
  PlaceLineInFile(Str.Align(_ODFirmName, Str.Length(tmpS[lnbr_First]) - SysDateTimeLength, LEFT) + L_DatTim.DateStr(SYSDATE()) + " " + L_DatTim.TimeStr(SYSTIME()));
  i:=0;
  WHILE i < lnbr_Data DO
   PlaceLineInFile(tmpS[i]);
   INC(i);
  END; (* WHILE i < lnbr_Data...*)
 END {MakeTop};

 PRIVATE PROCEDURE MakeDataLine(Former: STRING[]);
 BEGIN
  IF RepSettings[p_Tims] THEN
   ReplaceValue(Former, FLDTOSTR(Tmp.TotTim, "3."), alg_RIGHT);
   ReplaceValue(Former, FLDTOSTR(Tmp.WrkTim, "3."), alg_RIGHT);
   ReplaceValue(Former, FLDTOSTR(Tmp.OrdTim, "3."), alg_RIGHT);
  END;
  IF RepSettings[p_Runs] THEN
   ReplaceValue(Former, FLDTOSTR(Tmp.TotRun,  "1."), alg_RIGHT);
   ReplaceValue(Former, FLDTOSTR(Tmp.ZeroRun, "1."), alg_RIGHT);
   ReplaceValue(Former, FLDTOSTR(Tmp.PsgRun,  "1."), alg_RIGHT);
  END;
  IF RepSettings[p_Trps] THEN
   ReplaceValue(Former, FLDTOSTR(Tmp.FactTrip, "1."), alg_RIGHT);
   ReplaceValue(Former, FLDTOSTR(Tmp.BadTrip,  "1."), alg_RIGHT);
  END;
  IF RepSettings[p_Incm] THEN
   ReplaceValue(Former, FLDTOSTR(Tmp.Cassa, "2."), alg_RIGHT);
   ReplaceValue(Former, FLDTOSTR(Tmp.PlanIncome, "2."), alg_RIGHT);
   ReplaceValue(Former, FLDTOSTR(Tmp.FactIncome, "2."), alg_RIGHT);
   IF Tmp.PlanIncome # 0 THEN
    ReplaceValue(Former, FLDTOSTR(Tmp.FactIncome / Tmp.PlanIncome * 100, "2."), alg_RIGHT);
   ELSE
    ReplaceValue(Former, FLDTOSTR(0, "2."), alg_RIGHT);
   END;
   ReplaceValue(Former, FLDTOSTR(Tmp.PassAmount, "0"), alg_RIGHT);
  END;
  IF RepSettings[p_Fuel] THEN
   ReplaceValue(Former, FLDTOSTR(Tmp.FuelNorm,              "2."), alg_RIGHT);
   ReplaceValue(Former, FLDTOSTR(Tmp.FuelFact,              "2."), alg_RIGHT);
   ReplaceValue(Former, FLDTOSTR(Tmp.FuelNorm-Tmp.FuelFact, "2."), alg_RIGHT);
  END;
  PlaceLineInFile(Former);
 END {MakeDataLine};

 PRIVATE PROCEDURE MakeLine(_Date,
                            _RWayS,
                            _ManName,
                            _BoxNbr,
                            _StateNbr,
                            _MarkName: STRING[]);
  VAR
   Former: STRING[];
 BEGIN
  Former:=tmpS[lnbr_Data];
  IF RepSettings[p_CmnD] THEN
   ReplaceValue(Former, _Date,      alg_LEFT);
   ReplaceValue(Former, _RWayS,     alg_LEFT);
  END;
  IF RepSettings[p_CmnS] THEN
   ReplaceValue(Former, _ManName,   alg_LEFT);
  END;
  IF RepSettings[p_CmnC] THEN
   ReplaceValue(Former, _BoxNbr,    alg_LEFT);
   ReplaceValue(Former, _StateNbr,  alg_LEFT);
   ReplaceValue(Former, _MarkName,  alg_LEFT);
  END;
  IF RepSettings[p_RMdf] THEN
   ReplaceValue(Former, _ModifName, alg_LEFT);
  END;
  MakeDataLine(Former);
 END {MakeLine};

 PRIVATE PROCEDURE MakeLine_woTitle();
 BEGIN
  MakeLine("", "", "", "", "", "");
 END {MakeLine_woTitle};

 PRIVATE PROCEDURE MakeSubTitle(Text, Former: STRING[]);
 BEGIN
  ReplaceValue(Former, Text, alg_LEFT);
  PlaceLineInFile(Former);
  PlaceLineInFile(tmpS[lnbr_Dlm0]);
 END {MakeSubTitle};

 PRIVATE PROCEDURE MakeSvodTitle(Text: STRING[]);
 BEGIN
  PlaceLineInFile(tmpS[lnbr_Dlm0]);
  MakeSubTitle("   " + Text, tmpS[lnbr_Svod]);
 END {MakeSvodTitle};

 PRIVATE PROCEDURE GetModifName(): STRING[];
 BEGIN
  IF Tmp.dtlObj # emptyDtlObject THEN
   SEARCH(RoutMod, Route, , Route.Route, Tmp.dtlObj);
   RETURN RoutMod.Modif + " " + RoutMod.Name;
  ELSE
   RETURN "___"         + " " + "   楫";
  END;
 END {GetModifName};

 PRIVATE PROCEDURE MakeBot();
  CONST
   Stamp = "(c) Polak";
  VAR
   formerTmpS: STRING[];
 BEGIN
  IF SELECT(Tmp, TypeRep, rlk_Total) THEN
   formerTmpS:=tmpS[lnbr_Total];
   IF RepSettings[p_RMdf] THEN
    PlaceLineInFile(tmpS[lnbr_Dlm0]);
    MakeSubTitle("ᥣ  ࠧ१ 䨪権", tmpS[lnbr_Svod]);
    NEXT(Tmp); (* 'ᥣ  ਮ' ⮨ ࢮ ப, ய᪠  *)
    WHILE OCCURE(Tmp) DO
     tmpS[lnbr_Total]:=formerTmpS;
     ReplaceValue(tmpS[lnbr_Total], GetModifName(), alg_LEFT);
     MakeDataLine(tmpS[lnbr_Total]);
     NEXT(Tmp);
    END; (* WHILE OCCURE(Tmp)...*)
    PlaceLineInFile(tmpS[lnbr_Dlm2]);
    SELECT(Tmp, TypeRep, , rlk_Total);
   ELSE
    PlaceLineInFile(tmpS[lnbr_Dlm2]);
   END;
   ReplaceValue(formerTmpS, "ᥣ", alg_LEFT);
   MakeDataLine(formerTmpS);
  END;
  InsText_InBasicString(Stamp, tmpS[lnbr_Last]);
  PlaceLineInFile(tmpS[lnbr_Last]);
 END {MakeBot};

 PRIVATE PROCEDURE GetCurObject(): tCurObject;
 BEGIN
  RETURN MODE MOD 10;
 END {GetCurObject};

 PRIVATE PROCEDURE GetRoute(): LIKE(Route.Route);
 BEGIN
  IF (CurObject = cur_Car) | (CurObject = cur_Driver) THEN
   RETURN Tmp.srtObj;
  ELSE
   RETURN Route.Route;
  END;
 END {GetRoute};

 PRIVATE PROCEDURE PrintRep(FullRepName: STRING[]; BPer, EPer: DATE);
  VAR
   FirstLine: SCAL[2];
   _Value,
   TitlePool: STRING[];
   _Route   : LIKE(Route.Route);
 BEGIN
  CreateRep();
  MakeTop(FullRepName, BPer, EPer);
  IF RepSettings[p_RWay] THEN
   SELECT(Tmp, TypeRep, , rlk_Normal);
   WHILE OCCURE(Tmp) DO
    NARROWSEL(Tmp, srtObj);
    FirstLine:=1;
    WHILE OCCURE(Tmp) DO
     CONFORM(Tmp, RWayS);
     PROMPT(" " + RWayS.RWayS);
     L_XDoc.sl_AddCurrentXDoc(L_XDoc.xdt_RWayS);
     _ModifName:=GetModifName();
     CONFORM(Tmp, Staff);
     CONFORM(Staff, Man);
     L_Car.StandOnCarLog(Tmp.BoxNbr, RWayS.Date);
     L_Car.AccessMark(Tmp.BoxNbr, RWayS.Date);
     IF FirstLine THEN
      MakeLine(FLDTOSTR(RWayS.Date, "D.N.Y"),
               RWayS.RWayS,
               Staff.TSN + " " + L_Str.ShortName(Man.Name),
               CarLog.BoxNbr,
               CarLog.StateNbr,
               Mark.Name);
     ELSE
      MakeLine_woTitle();
     END;
     FirstLine:=0;
     NEXT(Tmp);
    END; (* WHILE OCCURE(Tmp) ... *)
    NEXTINEXTENDEDSEL(Tmp, srtObj);
   END; (* WHILE OCCURE(Tmp) ... *)
  END;

  IF RepSettings[p_SvdT] # svt_None THEN
   IF RepSettings[p_RWay] THEN
    TitlePool:=" |⥫|ࠬ|࠭ᯮ ।⢠|ઠ|⠬|室";
    MakeSvodTitle(L_Str.PoolItem(TitlePool, RepSettings[p_SvdT]));
   END;

   SELECT(Tmp, TypeRep, , rlk_Svod);
   WHILE OCCURE(Tmp) DO
    PROMPT(" " + Tmp.srtObj);
    NARROWSEL(Tmp, srtObj);
    FirstLine:=1;
    WHILE OCCURE(Tmp) DO
     _ModifName:=GetModifName();
     IF    (RepSettings[p_SvdT] = svt_Drv) | (RepSettings[p_SvdT] = svt_Gu) THEN
      CONFORM(Tmp, Staff);
      CONFORM(Staff, Man);
      IF FirstLine THEN
       MakeLine("",
                "",
                Staff.TSN + " " + L_Str.ShortName(Man.Name),
                "",
                "",
                "");
      ELSE
       MakeLine_woTitle();
      END;
     ELSIF RepSettings[p_SvdT] = svt_Car THEN
      L_Car.StandOnCarLog(Tmp.BoxNbr, EPer);
      L_Car.AccessMark(Tmp.BoxNbr, EPer);
      IF FirstLine THEN
       MakeLine("",
                "",
                "",
                CarLog.BoxNbr,
                CarLog.StateNbr,
                Mark.Name);
      ELSE
       MakeLine_woTitle();
      END;
     ELSIF RepSettings[p_SvdT] = svt_Mark THEN
      L_General.CallUs(SEARCH(Mark, Mark, Tmp.srtObj));
      IF FirstLine THEN
       MakeLine("",
                "",
                "",
                "",
                "",
                Mark.Mark + " " + Mark.Name);
      ELSE
       MakeLine_woTitle();
      END;
     ELSIF RepSettings[p_SvdT] = svt_Route THEN
      L_General.CallUs(SEARCH(Route, Route, Tmp.srtObj));
      IF FirstLine THEN
       IF CurObject = cur_Driver THEN
        MakeLine("",
                 "",
                 "",
                 "",
                 Route.Route,
                 Route.Name);
       ELSE
        MakeLine("",
                 "",
                 Route.Route + " " + Route.Name,
                 "",
                 "",
                 "");
       END;
      ELSE
       MakeLine_woTitle();
      END;
     ELSIF RepSettings[p_SvdT] = svt_Exit THEN
      L_General.CallUs(SEARCH(StExit, Exit, Tmp.srtObj));
      IF FirstLine THEN
       IF CurObject = cur_Driver THEN
        MakeLine("",
                 "",
                 "",
                 "",
                 StExit.Exit,
                 StExit.Name);
       ELSE
        MakeLine("",
                 "",
                 StExit.Exit + " " + StExit.Name,
                 "",
                 "",
                 "");
       END;
      ELSE
       MakeLine_woTitle();
      END;
     END;
     FirstLine:=0;
     NEXT(Tmp);
    END; (* WHILE OCCURE(Tmp) ... *)
    NEXTINEXTENDEDSEL(Tmp, srtObj);
   END; (* WHILE OCCURE(Tmp) ... *)
  END;
  MakeBot();
 END {PrintRep};

 PRIVATE PROCEDURE GetFuelFact(): NUMERIC[3];
 BEGIN
  IF RWayS.FuelNorm # 0 THEN
   RETURN RWayS.FuelFact * RWayJ.FNorm / RWayS.FuelNorm;
  ELSE
   RETURN 0;
  END;
 END {GetFuelFact};

 PRIVATE PROCEDURE GetTotIncPsgFact(_Who             : L_Way.tRWSWho;
                                    _Number          : LIKE(WayLMen.Number);
                                    VAR Pln, Inc, Cas: NUMERIC[3];
                                    VAR Psg          : NUMERIC[0]);
  VAR
   _WCnt: NUMERIC[0];
 BEGIN
  Pln  :=0;
  Inc  :=0;
  Psg  :=0;
  Cas  :=0;
  _WCnt:=0;
  IF _Who = L_Way.rwswho_Guard THEN
   SAVE(WayLMen);
   SELECT(WayLMen, RWayS, , RWayS.RWayS, L_Way.wlmwho_Guard);
   WHILE OCCURE(WayLMen) DO
    IF L_RWayS.IsRWayJForCurWayLMen() THEN
     INC(_WCnt);
    END;
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
   RESTORE(WayLMen);
  ELSE
   _WCnt:=1;
  END;

  Pln:=RWayJ.PlIncome / L_Way.E_IPlDvdr(RWayS.Date, _WCnt, _Who, _Number);
  SELECT(RWayJP, RWayS, , RWayJ.RWayS, RWayJ.Day, RWayJ.StartT);
  WHILE OCCURE(RWayJP) DO
   IF L_Way.E_TrPsgFct(_Who, _Number, RWayJP.RWJPro) THEN
    INC(Psg, RWayJP.Value);
   END;

   IF L_Way.E_TrCasFct(_Who, _Number, RWayJP.RWJPro) THEN
    INC(Cas, RWayJP.Value);
   END;

   IF L_Way.TrIncFct(_Who, _Number, RWayJP.RWJPro) THEN
    INC(Inc, RWayJP.Value);
   END;

   IF (_Who # L_Way.rwswho_Guard) & L_Way.E_TrOrdFct(_Who, _Number, RWayJP.RWJPro) THEN
    INC(Inc, RWayJP.Value);
   END;
   NEXT(RWayJP);
  END; (* WHILE OCCURE(RWayJP) ... *)
 END {GetTotIncPsgFact};

 PRIVATE PROCEDURE InsGuCond(): SCAL[2];
 BEGIN
  IF RepSettings[p_SvdT] = svt_Gu THEN
   RETURN L_RWayS.IsRWayJForCurWayLMen();
  ELSE
   RETURN 1;
  END;
 END {InsGuCond};

 PRIVATE PROCEDURE IsGoodRWayJ(): SCAL[2];
 BEGIN
  IF    CurObject = cur_Route THEN
   RETURN SEJobs.Route = _Route;
  ELSIF CurObject = cur_Exit THEN
   RETURN SEJobs.Exit = _Exit;
  ELSIF CurObject = cur_ExitCls THEN
   CONFORM(SEJobs, StExit);
   RETURN StExit.ExitClss = _ExitClss;
  ELSIF CurObject = cur_Car THEN
   RETURN 1;
  ELSIF CurObject = cur_Driver THEN
   RETURN 1;
  ELSIF CurObject = cur_WJMode THEN
   RETURN SEJobs.WJCode = _WJCode;
  ELSE
   L_General.CallUs(0);
  END;
 END {IsGoodRWayJ};

 PRIVATE PROCEDURE E_OrdTim(): NUMERIC[3];
  VAR
   Local: PROC;
 BEGIN
  IF (WJMode.WJType # L_Way.WJType_Void) &
     (WJMode.WJType # L_Way.WJType_Repair) THEN
   Local:=PROCREF(E_Way.OrdTim);
   IF ~!Local THEN
    RETURN Local();
   ELSE
    RETURN D_TP.TrOrdTim();
   END;
  ELSE
   RETURN 0;
  END;
 END {E_OrdTim};

 PRIVATE PROCEDURE InsIntoTmp(_TSN   : LIKE(Staff.TSN);
                              _Who   : L_Way.tRWSWho;
                              _Number: LIKE(WayLMen.Number));
  VAR
   Inc, Cas,
   Pln       : NUMERIC[3];
   Psg       : NUMERIC[0];
   _Modif    : LIKE(RoutMod.Modif);
   _srtObj   : tSortObject;
   _dtlObj   : tDetailObject;
   i, j      : NUMERIC[0];
   dlMax     : tDetailLevel;
   _TotRun   : NUMERIC[2];
   _OrdTim,
   _TotTim   : NUMERIC[3];
   NeedRWJVld: SCAL[2];
 BEGIN
  L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
  WHILE OCCURE(RWayJ) DO
   CONFORM(RWayJ, Quality);
   CONFORM(RWayJ, SEJobs);
   CONFORM(SEJobs, WJMode);
   IF IsGoodRWayJ() & InsGuCond() THEN
    GetTotIncPsgFact(_Who, _Number, Pln, Inc, Cas, Psg);
    NeedRWJVld:=(Quality.Type # L_Way.QualType_Annul);
    IF RepSettings[p_RMdf] THEN
     dlMax:=dl_wModif; _Modif:=SEJobs.Modif;
    ELSE
     dlMax:=dl_None;   _Modif:="";
    END;
    i:=rlk_Normal;
    j:=dlMax;
    WHILE ((RepSettings[p_Excel] = 0) & (i <= MAXOF(tRepLineKind)) & (j >= dl_None)) |
          ((RepSettings[p_Excel] = 1) & (i = rlk_Normal) & (j = dl_wModif)) DO
     IF i = rlk_Total THEN
      _srtObj:="Total";
     ELSE
      IF    i = rlk_Normal THEN
       IF RepSettings[p_Excel] = 0 THEN
        _srtObj:=FLDTOSTR(RWayS.Date, "y.N.D") + " " +
                 RWayS.RWayS                   + " " +
                 _TSN; (* TSN   -      *)
       ELSE
        _srtObj:=RWayS.RWayS  + " " +
                 SEJobs.Exit  + " " +
                 SEJobs.Route + " " +
                 SEJobs.Modif + " " +
                 SEJobs.Day   + " " +
                 L_DatTim.TimeStr(SEJobs.StartT);
       END;
      ELSIF (RepSettings[p_SvdT] # svt_None) & (i = rlk_Svod) THEN
       IF    RepSettings[p_SvdT] = svt_Car THEN
        _srtObj:=RWayS.BoxNbr;
       ELSIF (RepSettings[p_SvdT] = svt_Mark) & (i = rlk_Svod) THEN
        _srtObj:=Mark.Mark;
       ELSIF (RepSettings[p_SvdT] = svt_Route) & (i = rlk_Svod) THEN
        _srtObj:=SEJobs.Route;
       ELSIF (RepSettings[p_SvdT] = svt_Exit) & (i = rlk_Svod) THEN
        _srtObj:=SEJobs.Exit;
       ELSE
        _srtObj:=_TSN;
       END;
      ELSE
       _srtObj:="";
      END;
     END;
     _TotRun := D_TP.TrTotRun();
     _TotTim := D_TP.TrOrdTim();
     _OrdTim := E_OrdTim();
     IF RepSettings[p_TimNoWork] & (WJMode.WJType = L_Way.WJType_Void) THEN
      INC(_TotTim, D_TP.TrTotTim());
     END;
     IF (_TotRun = 0) & (_TotTim = 0) THEN
      _srtObj:="";
     END;
     IF ~!_srtObj THEN
      IF j = dl_wModif THEN
       _dtlObj:=_Modif;
      ELSE
       _dtlObj:=emptyDtlObject;
      END;
      IF (i # rlk_Total) & ~SEARCH(Tmp, TypeRep, i, _srtObj, _dtlObj) THEN
       DEFAULT(Tmp);
       Tmp.TypeRep:=i;
       Tmp.srtObj :=_srtObj;
       Tmp.dtlObj :=_dtlObj;
       Tmp.RWayS  :=RWayS.RWayS;
       Tmp.TSN    :=_TSN;
       Tmp.BoxNbr :=RWayS.BoxNbr;
       IF RepSettings[p_Excel] = 1 THEN
        Tmp.Exit  :=SEJobs.Exit;
        Tmp.Route :=SEJobs.Route;
        Tmp.Modif :=SEJobs.Modif;
        Tmp.Day   :=SEJobs.Day;
        Tmp.StartT:=SEJobs.StartT;
       END;
       INSERT(Tmp);
      END;
      ADD(Tmp, TypeRep, , i, _srtObj, _dtlObj,
          Tmp.Cassa,      Cas,
          Tmp.PlanIncome, Pln,
          Tmp.FactIncome, Inc,
          Tmp.PassAmount, Psg);
      IF NeedRWJVld THEN
       ADD(Tmp, TypeRep, , i, _srtObj, _dtlObj,
           Tmp.TotTim,     _TotTim,
           Tmp.WrkTim,     D_TP.TrWrkTim(),
           Tmp.OrdTim,     _OrdTim,
           Tmp.TotRun,     _TotRun,
           Tmp.PsgRun,     D_TP.TrPsgRun(),
           Tmp.ZeroRun,    D_TP.TrZerRun(),
           Tmp.FactTrip,   D_TP.TrWrkNum(),
           Tmp.BadTrip,    D_TP.TrBadNum(),
           Tmp.FuelNorm,   RWayJ.FNorm,
           Tmp.FuelFact,   GetFuelFact());
      END;
     END; (* IF ~!_srtObj ... *)
     IF j = dl_None THEN
      j:=dlMax;
      INC(i);
     ELSE
      DEC(j);
     END;
    END; (* WHILE i ...*)
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
 END {InsIntoTmp};

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "썠琥");
  L_Basis.wb_WrInQM(F, "६琥");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, " 室");
  L_Basis.wb_WrInQM(F, " 室");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "஢");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "䠪");
  L_Basis.wb_WrInQM(F, "ࠪ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "䠪");
  L_Basis.wb_WrInQM(F, "ᠦ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  CONFORM(Tmp, RWayS);
  CONFORM(RWayS, Car, CarLog, Mark);
  CONFORM(Tmp, Route, RoutMod);
  CONFORM(Tmp, StExit, ExitClss);
  CONFORM(Tmp, Staff);
  CONFORM(Staff, Man);
  L_Way.StandOnRouteTKind(RWayS.Date);
  CONFORM(RWayS, Calendar);

  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrScl(F, Car.BoxNbr);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  L_Basis.wb_WrScl(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  L_Basis.wb_WrScl(F, RoutMod.Modif);
  L_Basis.wb_WrStr(F, RoutMod.Name);
  L_Basis.wb_WrScl(F, Tmp.Day);
  L_Basis.wb_WrTim(F, Tmp.StartT);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, StExit.Exit);
  L_Basis.wb_WrStr(F, StExit.Name);
  L_Basis.wb_WrScl(F, ExitClss.ExitClss);
  L_Basis.wb_WrStr(F, ExitClss.Name);
  L_Basis.wb_WrScl(F, TKind.Rgn);
  L_Basis.wb_WrScl(F, TKind.FnMode);
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrScl(F, RWayS.RWayS);
  L_Basis.wb_WrDat(F, RWayS.Date);
  L_Basis.wb_WrStr(F, L_Way.E_ConvertWDStr(RWayS.Date, L_Way.E_ConvertWD(RWayS.Date, L_APWI.CWD_ForTrip(L_APtm.wdk_toWay, StExit.Exit, RWayS.Date, Tmp.Day, Tmp.StartT))));
  L_Basis.wb_WrNum(F, Tmp.TotTim, 3);
  L_Basis.wb_WrNum(F, Tmp.WrkTim, 3);
  L_Basis.wb_WrNum(F, Tmp.OrdTim, 3);
  L_Basis.wb_WrNum(F, Tmp.TotRun, 2);
  L_Basis.wb_WrNum(F, Tmp.ZeroRun, 2);
  L_Basis.wb_WrNum(F, Tmp.PsgRun,  2);
  L_Basis.wb_WrNum(F, Tmp.FactTrip, 1);
  L_Basis.wb_WrNum(F, Tmp.BadTrip,  1);
  L_Basis.wb_WrNum(F, Tmp.Cassa,      2);
  L_Basis.wb_WrNum(F, Tmp.PlanIncome, 2);
  L_Basis.wb_WrNum(F, Tmp.FactIncome, 2);
  L_Basis.wb_WrNum(F, Tmp.PassAmount, 0);
  L_Basis.wb_WrNum(F, Tmp.FuelNorm, 4);
  L_Basis.wb_WrNum(F, Tmp.FuelFact, 4);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE MakeExcel();
 BEGIN
  FIO.Open(R, L_General.NameConnection(ExcelRepName), "REP", Create);
  MakeHeader("R");
  SELECT(Tmp, TypeRep, , rlk_Normal);
  WHILE OCCURE(Tmp) DO
   MakePart("R");
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  FIO.Close(R);
 END {MakeExcel};

 PRIVATE PROCEDURE Make(FullRepName: STRING[]; BPer, EPer: DATE);
  VAR
   _Who           : L_Way.tRWSWho;
   WasUntaxedRWayS: SCAL[2];
 BEGIN
  WasUntaxedRWayS:=0;
  IF    CurObject = cur_Car THEN
   SELECT(RWayS, BoxNbr, , _BoxNbr);
  ELSIF CurObject = cur_Driver THEN
   SELECT(RWayS, TSN, , _TSN);
  ELSE
   SELECT(RWayS, Date);
  END;
  SRCINSEL(RWayS, GE, , BPer);
  WHILE OCCURE(RWayS) &
        (RWayS.Date <= EPer) DO
   PROMPT(RWayS.RWayS + " " + L_DatTim.DateStr(RWayS.Date));
   IF (RWayS.Status >= L_Way.rwsStat_Rated) THEN
    IF    RepSettings[p_SvdT] = svt_Gu THEN
     SELECT(WayLMen, RWayS, , RWayS.RWayS, L_Way.wlmwho_Guard);
     WHILE OCCURE(WayLMen) DO
      PROMPT(WayLMen.TSN + " " + RWayS.RWayS + " " + L_DatTim.DateStr(RWayS.Date));
      SELECT(RWayJ, RWayS, , WayLMen.RWayS);
      InsIntoTmp(WayLMen.TSN, L_Way.rwswho_Guard, WayLMen.Number);
      NEXT(WayLMen);
     END; (* WHILE OCCURE(WayLMen) ... *)
    ELSE
     IF RepSettings[p_SvdT] = svt_Drv THEN
      _Who:=L_Way.rwswho_Driver;
     ELSE
      _Who:=L_Way.rwswho_Dr_W_Gu;
     END;
     SELECT(RWayJ, RWayS, , RWayS.RWayS);
     InsIntoTmp(RWayS.TSN, _Who, 1);
    END;
   ELSIF ~WasUntaxedRWayS THEN
    STDMSG(" ⠪஢ ", CHOICE);
    WasUntaxedRWayS:=1;
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  IF RepSettings[p_Excel] THEN
   MakeExcel();
  ELSE
   PrintRep(FullRepName, BPer, EPer);
  END;
 END {Make};

 PRIVATE PROCEDURE GetRepName(): STRING[];
 BEGIN
  IF    CurObject = cur_Route THEN
   RETURN Route.Route;
  ELSIF CurObject = cur_Exit THEN
   RETURN StExit.Exit;
  ELSIF CurObject = cur_ExitCls THEN
   RETURN ExitClss.ExitClss;
  ELSIF CurObject = cur_Car THEN
   RETURN Car.BoxNbr;
  ELSIF CurObject = cur_Driver THEN
   RETURN Staff.TSN;
  ELSIF CurObject = cur_WJMode THEN
   RETURN WJMode.WJCode;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetRepName};

 PRIVATE PROCEDURE InitRepContent(): STRING[];
  VAR
   Local: PROC;
 BEGIN
  RepSettings[p_RWay]:=1;
  RepSettings[p_SvdT]:=0;
  RepSettings[p_RMdf]:=0;
  RepSettings[p_Excel]:=0;

  RepSettings[p_CmnF]:=1;
  RepSettings[p_CmnD]:=1;
  RepSettings[p_CmnS]:=1;
  RepSettings[p_CmnC]:=1;
  RepSettings[p_TimNoWork]:=0;

  Local:=PROCREF(E_Way.RwsWrk_InitRepContent);
  IF ~!Local THEN
   Local(RepSettings);
  ELSE
   RepSettings[p_Tims]:=1;
   RepSettings[p_Runs]:=1;
   RepSettings[p_Trps]:=1;
   RepSettings[p_Incm]:=1;
   RepSettings[p_Fuel]:=1;
  END;
  RETURN GetRepName();
 END {InitRepContent};

 PRIVATE PROCEDURE CondRepSet();
 BEGIN
  RepSettings[p_CmnD]:=0;
  RepSettings[p_CmnS]:=0;
  RepSettings[p_CmnC]:=0;

  IF    RepSettings[p_RWay] THEN
   RepSettings[p_CmnD]:=1;
   IF    CurObject = cur_Car THEN
    RepSettings[p_CmnS]:=1;
   ELSIF CurObject = cur_Driver THEN
    RepSettings[p_CmnC]:=1;
   ELSE
    RepSettings[p_CmnS]:=1;
    RepSettings[p_CmnC]:=1;
   END;
  END;

  IF    (RepSettings[p_SvdT] = svt_Drv)  |
        (RepSettings[p_SvdT] = svt_Gu)   THEN
   RepSettings[p_CmnS]:=1;
  ELSIF (RepSettings[p_SvdT] = svt_Car)  |
        (RepSettings[p_SvdT] = svt_Mark) THEN
   RepSettings[p_CmnC]:=1;
  ELSIF (RepSettings[p_SvdT] = svt_Route)|
        (RepSettings[p_SvdT] = svt_Exit) THEN
   RepSettings[p_CmnD]:=1;
   RepSettings[p_CmnS]:=1;
  END;
 END {CondRepSet};

 PRIVATE PROCEDURE GetByRouteModFieldStatus(): STRING[];
 BEGIN
  IF (CurObject = cur_Route) THEN
   RETURN "E";
  ELSE
   RETURN "NE";
  END;
 END {GetByRouteModFieldStatus};

 PRIVATE PROCEDURE ConvSvodType();
 BEGIN
  IF (CurObject = cur_Car) &
     (RepSettings[p_SvdT] > svt_Gu) THEN
   RepSettings[p_SvdT]:=RepSettings[p_SvdT] + 2;
  ELSIF (CurObject = cur_Driver) &
     (RepSettings[p_SvdT] > 0) THEN
   RepSettings[p_SvdT]:=RepSettings[p_SvdT] + 1;
  END;
 END {ConvSvodType};

 PRIVATE PROCEDURE Do(RepName_Prefix: STRING[]);
  VAR
   SvdPool,
   FullRepName,
   RepName_Suffix: STRING[];
  BEGIN
  IF    CurObject = cur_Car THEN
   SvdPool:=" |⥫|ࠬ|⠬|室";
  ELSIF CurObject = cur_Driver THEN
   SvdPool:=" |ࠬ||ઠ|⠬|室";
  ELSE
   SvdPool:=" |⥫|ࠬ||ઠ";
  END;
  RepName_Suffix:=InitRepContent();
  LOOP
   IF STDFORM(L_StdFrm.PartForm("%L<|Excel>I" +
                                "%<"+RepName_Prefix+"_>T" +
                                "%LI" +
                                "%L<|>I" +
                                "%L<" + SvdPool + ">I" +
                                "%< ࠧ१ 䨪権>"+GetByRouteModFieldStatus() +
                                "%<뢠 ६>E" +
                                "%< ࠡ祥 ६>E" +
                                "%<뢠 ஡>E" +
                                "%<뢠 ३>E" +
                                "%<뢠 >E" +
                                "%<뢠 ⮯>E" +
                                "%< 믮 >DB" +
                                "%< ⬥ >X" +
                                "@" +
                                 "ଠ:               %#####%" +
                                "|                             " +
                                "| :%###%_%#####%" +
                                "|                             " +
                                "| 祭 :    %##%" +
                                "|                             " +
                                "| :     %###########%" +
                                "|                             " +
                                "|%###########################%" +
                                L_StdFrm.HR() +
                                 "%###########################%" +
                                "| %##########################%" +
                                "|%###########################%" +
                                "|%###########################%" +
                                "|%###########################%" +
                                "|%###########################%" +
                                "| %###########%  %##########% "),
                                "  "+L_Str.PoolItem(" | 室|  室||⥫", CurObject)+"  ਮ ",
                                ,
                                ,
                                RepSettings[p_Excel],
                                RepName_Suffix,
                                RepSettings[p_RWay],
                                RepSettings[p_SvdT],
                                RepSettings[p_RMdf],
                                RepSettings[p_Tims],
                                RepSettings[p_TimNoWork],
                                RepSettings[p_Runs],
                                RepSettings[p_Trps],
                                RepSettings[p_Incm],
                                RepSettings[p_Fuel]) THEN
    IF (RepSettings[p_SvdT] = svt_None) & ~RepSettings[p_RWay] |
       ((RepSettings[p_Tims] = 0) &
        (RepSettings[p_Runs] = 0) &
        (RepSettings[p_Trps] = 0) &
        (RepSettings[p_Incm] = 0) &
        (RepSettings[p_Fuel] = 0)) THEN
     L_StdFrm.RedInform("祣 !");
    ELSE
     ConvSvodType();
     Create_Tmp();
     IF ~RepSettings[p_Excel] THEN
      CondRepSet();
      L_XDoc.sl_Init(RepTitle);
     ELSE
      RepSettings[p_Tims]     :=1;
      RepSettings[p_TimNoWork]:=1;
      RepSettings[p_Runs]     :=1;
      RepSettings[p_Trps]     :=1;
      RepSettings[p_Incm]     :=1;
      RepSettings[p_Fuel]     :=1;
      RepSettings[p_RMdf]     :=1;
     END;
     FullRepName:=RepName_Prefix+"_"+RepName_Suffix;
     Make(FullRepName, Memo.ud_fr(), Memo.ud_ut());
     IF ~RepSettings[p_Excel] THEN
      L_XDoc.sl_Done();
     ELSE
      L_Basis.ExtPlayMakedRunTimeRep(ExcelRepName,
                                     RepName_Suffix,
                                     L_General.timeCond_InIntvl,
                                     " "+L_Str.PoolItem(" | 室|  室||⥫", CurObject)+"  ਮ",
                                     0);
      EXIT;
     END;
    END; (* IF *)
   ELSE
    EXIT;
   END; (* IF STDFORM(...*)
  END; (* LOOP *)
 END {Do};

 PUBLIC PROCEDURE RWr01();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Route), " ⠭ ⥪騩 ");
  _Route   :=Route.Route;
  RepTitle :="  "+Route.Route+" "+Route.Name;
  CurObject:=cur_Route;
  Do("RWr01");
 END {RWr01};

 PUBLIC PROCEDURE RWr02();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(StExit), " ⠭ ⥪騩 室");
  _Exit    :=StExit.Exit;
  CurObject:=cur_Exit;
  RepTitle :=" 室 "+StExit.Exit+" "+StExit.Name;
  Do("RWr02");
 END {RWr02};

 PUBLIC PROCEDURE RWr03();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(ExitClss), " ⠭ ⥪騩  室");
  _ExitClss:=ExitClss.ExitClss;
  RepTitle :="  室 "+ExitClss.ExitClss+" "+ExitClss.Name;
  CurObject:=cur_ExitCls;
  Do("RWr03");
 END {RWr03};

 PUBLIC PROCEDURE RWr04();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Car), " ࠭ ");
  L_Car.AccessMark(Car.BoxNbr, Memo.ud_ut());
  _BoxNbr  :=Car.BoxNbr;
  RepTitle :="  " + _BoxNbr + " " + Mark.Name;
  CurObject:=cur_Car;
  Do("RWr04");
 END {RWr04};

 PUBLIC PROCEDURE RWr05();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Staff), " ࠭ ࠡ⭨");
  CONFORM(Staff, Man);
  _TSN     :=Staff.TSN;
  RepTitle :=" ⥫ " + Staff.TSN + " " + Man.Name;
  CurObject:=cur_Driver;
  Do("RWr05");
 END {RWr05};

 PUBLIC PROCEDURE RWr06();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(WJMode), " ⠭ ⥪騩 ");
  _WJCode  :=WJMode.WJCode;
  RepTitle :="  ࠡ "+WJMode.WJCode+" "+WJMode.Name;
  CurObject:=cur_WJMode;
  Do("RWr06");
 END {RWr06};

END.
