(*
%Copyright   (c) Polak Computer System
%Author      15.10.2003 20:55:28 POLAK\GAV
%Purpose     ४  ࠡ    ਮ
%Type        report
%Specific    AP
%Modified    25.06.2014 12:21:40 POLAK\LDA
%Environment
*)

 MODULE RWSWrkEr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PRIVATE CONST
  Delta  = 0.0;

(*
$P {Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
################################################################# ########## #####
=#####============================================================================
|                 ४  ६ ࠡ  ⥢ ⠬                 |
|                       ਮ  ##########  ##########                      |
|--------------------------------------------------------------------------------|
|                   |     |           1          |           2          |    |
|⭨           | |------------------------|------------------------||
|                   |     |         |         |    |
|-------------------|-----|------------------------|------------------------|----|
}

$P { Line:
Staff.TSN, L, <>
L_Str.ShortName(Man.Name), L, <>
?, L, <D.N>
?, L, <>
?, L, <>
?, L, <>
?, L, <H:M>
?, L, <H:M>
?, L, <>
?, L, <>
?, L, <>
?, L, <H:M>
?, L, <H:M>
?, R, <1.>
@
|##### #############|#####|# ####### ## ##### #####|# ####### ## ##### #####|####|
}

$P { Bot:
@
=(c) Polak========================================================================
}
*)

 PRIVATE PROCEDURE ToSheetSign(trgToSheet: LIKE(RWayS.ToSheet)): STRING[1];
 BEGIN
  RETURN L_Str.PoolItem("-||", trgToSheet)
 END {ToSheetSign};

 PRIVATE PROCEDURE ToPaySign(trgToPay: LIKE(RWayS.ToPay)): STRING[1];
 BEGIN
  RETURN L_Str.PoolItem("-|", trgToPay)
 END {ToPaySign};

 PRIVATE PROCEDURE FillOneDay(trgDate: DATE);
 BEGIN
  SELECT(RWayS, sTSN, , L_Way.rwsStat_Rated, Staff.TSN, trgDate);
  WHILE OCCURE(RWayS) DO
   PROMPT("ࠡ⪠: ⠡. " + Staff.TSN + ", " + L_DatTim.DateStr(trgDate) + " " + RWayS.RWayS);
   _RWayS.TSN    :=Staff.TSN;
   _RWayS.Date   :=trgDate;
   _RWayS.RWayS  :=RWayS.RWayS;
   _RWayS.Type   :=L_Math.DecToHex(RWayS.Type);
   _RWayS.StartT :=RWayS.StartTim;
   CONFORM(RWayS, RWayJ);
   LAST(RWayJ);
   _RWayS.StopT  :=C_T2L(RWayJ.Day + (RWayJ.StopT<RWayJ.StartT), RWayJ.StopT);
   _RWayS.ToSheet:=RWayS.ToSheet;
   _RWayS.ToPay  :=RWayS.ToPay;
   INSERT(_RWayS);
   NEXT(RWayS);
  END;
  SELECT(WayLMen, TSN, , Staff.TSN, trgDate);
  WHILE OCCURE(WayLMen) DO
   PROMPT("ࠡ⪠: ⠡. " + Staff.TSN + ", " + L_DatTim.DateStr(trgDate) + " " + WayLMen.RWayS);
   CONFORM(WayLMen, RWayS);
   IF RWayS.Status = L_Way.rwsStat_Rated THEN
    _RWayS.TSN    :=Staff.TSN;
    _RWayS.Date   :=trgDate;
    _RWayS.RWayS  :=WayLMen.RWayS;
    _RWayS.Type   :=L_Math.DecToHex(RWayS.Type);
    _RWayS.StartT :=C_T2L(WayLMen.Day, WayLMen.StartT);
    _RWayS.StopT  :=C_T2L(WayLMen.Day + (WayLMen.StopT<WayLMen.StartT), WayLMen.StopT);
    _RWayS.ToSheet:=L_Way.GetWLMToSheetSign(WayLMen.Who);
    _RWayS.ToPay  :=L_Way.GetWLMToPaySign(WayLMen.Who);
    INSERT(_RWayS);
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
 END {FillOneDay};

 PRIVATE PROCEDURE GatherSingleStaff();
  VAR
   trgDate: DATE;
 BEGIN
  CONFORM(Staff, Man);
  trgDate:=Memo.ud_fr();
  WHILE (trgDate <= Memo.ud_ut()) DO
   FillOneDay(trgDate);
   INC(trgDate);
  END;
 END {GatherSingleStaff};

 PRIVATE PROCEDURE CreateTmpFiles();
 BEGIN
  L_AFM.MakeMultipleIndex("_RWayS", "TSN: LIKE(Staff.TSN);"+
                                    "Date: DATE;"+
                                    "RWayS: LIKE(RWayS.RWayS);"+
                                    "Type   : STRING[1];"+
                                    "ToSheet: LIKE(RWayS.ToSheet);"+
                                    "ToPay  : LIKE(RWayS.ToPay);"+
                                    "StartT : LTIME;"+
                                    "StopT  : LTIME",
                          "_RWayS:TSN,Date,RWayS, StartT")
 END {CreateTmpFiles};

 PRIVATE PROCEDURE Print(RepName: STRING[]);
  VAR
   T         : FLOAT;
   trgRWayS  : LIKE(RWayS.RWayS);
   trgType   : STRING[];
   trgToSheet: LIKE(RWayS.ToSheet);
   trgToPay  : LIKE(RWayS.ToPay);
   trgStartT,
   trgStopT  : LTIME;
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  SELECT(_RWayS, _RWayS);
  WHILE OCCURE(_RWayS) DO
   NARROWSEL(_RWayS, TSN, Date);
   SEARCH(Staff, TSN, , _RWayS.TSN);
   CONFORM(Staff, Man);
   WHILE OCCURE(_RWayS) DO
    PROMPT(": ⠡. " + _RWayS.TSN + " " + L_DatTim.DateStr(_RWayS.Date) + " " + _RWayS.RWayS);
    trgRWayS  :=_RWayS.RWayS;
    trgType   :=_RWayS.Type;
    trgToSheet:=_RWayS.ToSheet;
    trgToPay  :=_RWayS.ToPay;
    trgStartT :=_RWayS.StartT;
    trgStopT  :=_RWayS.StopT;
    SAVE(_RWayS);
    WHILE NEXT(_RWayS) DO
     T:=TIMEINT(trgStartT, trgStopT, _RWayS.StartT, _RWayS.StopT);
     IF T > Delta THEN
      MAKEPART(R, Line, _RWayS.Date,
                        trgType,     trgRWayS,     ToSheetSign(trgToSheet)+ToPaySign(trgToPay),         C_L2T(trgStartT),     C_L2T(trgStopT),
                        _RWayS.Type, _RWayS.RWayS, ToSheetSign(_RWayS.ToSheet)+ToPaySign(_RWayS.ToPay), C_L2T(_RWayS.StartT), C_L2T(_RWayS.StopT),
                        T);
     END;
    END; (* WHILE OCCURE(_RWayS) ... *)
    RESTORE(_RWayS);
    NEXT(_RWayS);
   END; (* WHILE OCCURE(_RWayS) ... *)
   NEXTINEXTENDEDSEL(_RWayS, TSN, Date);
  END; (* WHILE OCCURE(_RWayS) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {Print};

 PUBLIC PROCEDURE CurStaff();
  CONST
   RepName = "RWSW1";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
  CreateTmpFiles();
  GatherSingleStaff();
  Print(RepName);
 END {CurStaff};

 PUBLIC PROCEDURE AllStaff();
  CONST
   RepName = "RWSWE";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Way.CheckTaxed(Memo.ud_fr(), Memo.ud_ut());
  CreateTmpFiles();
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   IF L_Env.RealTSN(Staff.TSN) &
      L_Staff.InStateInPer(Memo.ud_fr(), Memo.ud_ut()) &
      (SELECT(RWayS, TSN, Staff.TSN) | SELECT(WayLMen, TSN, Staff.TSN)) THEN
    GatherSingleStaff();
   END; (* IF RealTSN... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  Print(RepName);
 END {AllStaff};

END.
