(*
%Copyright   (c) Polak IT
%Author      30.04.2008 16:41:02 POLAK\Gina
%Purpose        rways
%Type        library,to paste
%Specific    AP
%Modified    04.08.2014 20:09:06 POLAK\San
%Environment
*)

 IMPORT L_Way, L_RWayS, L_APWI, L_General, E_Way, DBD;

 PRIVATE VAR
  __: tRWMoney;
  Done___     : SCAL[2];
  RWSTime,
  PZVTime        : NUMERIC[3];

 PRIVATE PROCEDURE PermitVldPsgForDriver(): SCAL[2];
 BEGIN
  RETURN (~INBITSET(TripArrVld[TripNbr], Gu) & (~INBITSET(TripArr[TripNbr], Gu) | (RWayS.Date<01\06\2008))) |
         (L_APWI.E_ApplyGuToDrvAnyObject(RWayS.Date, L_APWI.ObjectP_VldPsg) & INBITSET(TripArrVld[TripNbr], Gu));
 END {PermitVldPsgForDriver};

 PUBLIC PROCEDURE E_AccountVldPsg(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(RWayS.Date, PROCREF(E_Way.AccountVldPsg), 1);
 END {E_AccountVldPsg};

 PUBLIC PROCEDURE ଏᏫ(): L_APWI.tVldPsgAmnt;
  VAR
   Result: L_APWI.tVldPsgAmnt;
 BEGIN
  IF ~E_AccountVldPsg() THEN
   RETURN 0;
  END;
  SETEMPTY(Result);
  IF    CurWho = Gu THEN
   IF ~L_Way.rwswhoWithVld(CurWho) THEN
    Result:=0;
   ELSE
    Result:=TripPsgPl[TripNbr] * L_APWI.E_VldPsgPlanMultiplier(RWayS.Date, VldDvdr[TripNbr]);
   END;
  ELSIF CurWho = Dr THEN
   IF PermitVldPsgForDriver() THEN
    Result:=TripPsgPl[TripNbr];
   ELSE
    Result:=0;
   END;
  END;
  IF !Result THEN
   L_General.Error(" ঠ ஢ ନ ᠦ஢  "+L_Way.RWSWhoStr(CurWho));
  ELSE
   RETURN Result;
  END;
 END {ଏᏫ};

 PUBLIC PROCEDURE ଏᔠ(): L_APWI.tVldPsgAmnt;
  VAR
   Result: L_APWI.tVldPsgAmnt;
 BEGIN
  IF ~E_AccountVldPsg() THEN
   RETURN 0;
  END;
  SETEMPTY(Result);
  IF    !CurWho THEN
   Result:=L_APWI.CompleteVldPsgFact(RWayS.Date, TripNbr);
  ELSIF CurWho = Gu THEN
   L_General.Assert(WayLMen.Number<=2, "  2- ஢");
   Result:=L_APWI.E_TrVldPsgFact(RWayS.Date, L_Way.rwswho_Guard, WayLMen.Number, 1, TripNbr);
  ELSIF CurWho = Dr THEN
   Result:=L_APWI.E_TrVldPsgFact(RWayS.Date, L_Way.rwswho_Driver, 1, PermitVldPsgForDriver(), TripNbr);
  END;
  IF ~L_Way.rwswhoWithVld(CurWho) THEN
   L_General.Assert(Result=0, "㤠 䠪᪨ ⥫    "+L_Way.RWSWhoStr(CurWho)+" ⠡. "+Staff.TSN);
  ELSIF CurWho = Gu THEN
   IF (L_DatTim.Per(RWayS.Date) # 01\09\2008) | ((Str.Cap(DBD.BaseName()) # "ES") & (DBD.BaseName() # "53")) THEN (*0066203 & 0066220*)
    L_General.Assert((L_APWI.TrVldPsgFact(RWayS.Date, L_Way.rwswho_Driver,  1, TripNbr)=0) &
                     (L_APWI.TrVldPsgFact(RWayS.Date, L_Way.rwswho_Chopper, 1, TripNbr)=0),
                     "  ஬,    ᪨ ⥫"); (* , 㤠 , ⤠ ?*)
   END;
  END;
  IF !Result THEN
   L_General.Error(" ঠ ஢ ନ ᠦ஢  "+L_Way.RWSWhoStr(CurWho));
  ELSE
   RETURN Result;
  END;
 END {ଏᔠ};

 PRIVATE PROCEDURE TripForWayLMen(): SCAL[2];
 BEGIN
  RETURN L_RWayS.IsRWayJForCurWayLMen();
 END {TripForWayLMen};

 PUBLIC PROCEDURE E_NeedRWayJRWSTime(_CurWho: L_Way.tRWSWho): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.NeedRWayJRWSTime);
  IF !Local THEN
   CONFORM(RWayJ, SEJobs, Route);
   CONFORM(RWayJ, Quality);
   L_Way.PosToWJMethod(L_RWayS.GetasWJMode(_CurWho),
                       L_Way.GetWho(_CurWho),
                       L_Way.GetRouteJRegime(RWayS.Date, 1),
                       RWayJ.Quality,
                       RWayS.Date);
   RETURN WJMethod.TimeSel*Quality.Type > 0;
  ELSE
   RETURN Local(_CurWho);
  END;
 END {E_NeedRWayJRWSTime};

 PRIVATE PROCEDURE GetRWSTime(): NUMERIC[3];
  VAR
   Result: NUMERIC[3];
 BEGIN
  Result:=0;
  TRY [RESTORE_CURSORS(RC_ON)]
   IF (RWayS.Date >= 01\02\2010) | ((RWayS.Date >= 01\01\2010) & (DBD.BaseName() = "53")) THEN
    SETSEL(RWayJ, RWayS, RWayS.RWayS);
    FOR_EACH RWayJ DO
     IF ((CurWho = L_Way.rwswho_Driver) | TripForWayLMen()) & E_NeedRWayJRWSTime(CurWho) THEN
      INC(Result, L_RWayS.E_RWAYS_CoeffForCurTimes(RWayS.Date, CurWho) * (RWayJ.StopT - RWayJ.StartT));
     END;
    END; (* FOR_EACH RWayJ *)
   ELSE
    IF L_Way.GetWho(CurWho) = L_Way.rwswho_Driver THEN
     SELECT(RWayJ, RWayS, , RWayS.RWayS);
     WHILE OCCURE(RWayJ) DO
      IF E_NeedRWayJRWSTime(L_Way.rwswho_Driver) THEN
       IF (CurWho = L_Way.rwswho_Driver) | TripForWayLMen()(*ன ⥫*) THEN
        INC(Result, RWayJ.StopT  - RWayJ.StartT);
       END;
      END;
      NEXT(RWayJ);
     END; (* WHILE OCCURE(RWayJ) ... *)
    ELSIF (L_Way.GetWho(CurWho) = L_Way.rwswho_Guard) |
          (L_Way.GetWho(CurWho) = L_Way.rwswho_GuPupil) | (L_Way.GetWho(CurWho) = L_Way.rwswho_Chopper) THEN
     SELECT(WayLMen, RWayS, , RWayS.RWayS, CurWho-1);
     WHILE OCCURE(WayLMen) DO
      IF (WayLMen.TSN = Staff.TSN) THEN
       SELECT(RWayJ, RWayS, , RWayS.RWayS);
       WHILE OCCURE(RWayJ) DO
        IF TripForWayLMen() & E_NeedRWayJRWSTime(CurWho) THEN
         INC(Result, RWayJ.StopT - RWayJ.StartT);
        END;
        NEXT(RWayJ);
       END; (* WHILE OCCURE(RWayJ) ... *)
      END;
      NEXT(WayLMen);
     END; (* WHILE OCCURE(WayLMen) ... *)
    END;
   END;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetRWSTime};

 PRIVATE PROCEDURE E_ExecuteArchaicCodeDateForTariffAndAddPayment(): DATE;
 BEGIN
  RETURN L_EC.ExecE_Func_Date(RWayS.Date, PROCREF(E_Way.ExecuteArchaicCodeDateForTariffAndAddPayment), 01\06\2010);
 END {E_ExecuteArchaicCodeDateForTariffAndAddPayment};

 PUBLIC PROCEDURE Init__();
 BEGIN
  SETZERO(Done___, __);
 END {Init__};

 PUBLIC PROCEDURE Add___(_sum: tRWMoney): tRWMoney;
  VAR
   BUG___: NUMERIC[2];
 BEGIN
  L_General.Assert(~Done___, "ୠ ᫥⥫쭮 ࠢ."+
                                "|ࠢ "+RTI.Get().Stack.Item(1).Proc.Name+"  믮  ६ ࠢ");
  IF L_General.NeedExecuteArchaicCode(RWayS.Date, E_ExecuteArchaicCodeDateForTariffAndAddPayment()) THEN
   BUG___:=_sum; _sum:=BUG___;  (* 訡 __ 뫠 NUMERIC[2]*)
  END;
  INC(__, _sum);
  RETURN _sum;
 END {Add___};

 PUBLIC PROCEDURE Get___(): tRWMoney;
 BEGIN
  Done___:=1;
  RETURN __;
 END {Get___};

 PUBLIC PROCEDURE InitRWSWho();
 BEGIN
  RWSTime:=0; PZVTime:=0;
  IF (L_Way.GetWho(CurWho) # L_Way.rwswho_Chopper) | OCCURE(WayLMen) THEN
   PZVTime:=L_Way.E_GetPzvTotalTime(L_Way.GetWho(CurWho));
   IF PZVTime > 0 THEN
    RWSTime:=GetRWSTime();
   END;
  END;
 END {InitRWSWho};

 PUBLIC PROCEDURE GetReadyRWSTime(): NUMERIC[3];
 BEGIN
  RETURN RWSTime;
 END {GetReadyRWSTime};

 PUBLIC PROCEDURE GetReadyPZVTime(): NUMERIC[3];
 BEGIN
  RETURN PZVTime;
 END {GetReadyPZVTime};

 PRIVATE PROCEDURE Class(): NUMERIC[2];
 BEGIN
  IF L_Env.IsDriver() THEN
   IF    StaffLog.Class = 1 THEN
    RETURN 1.25;
   ELSIF StaffLog.Class = 2 THEN
    RETURN 1.10;
   END;
  END;
  RETURN 1.00;
 END {Class};

 PUBLIC PROCEDURE AddPZVSum();
  VAR
   Dummy: NUMERIC[2];
 BEGIN
  IF (RWSTime > 0) & (PZVTime > 0) THEN
   Dummy:=Add___(CurTime * TS * Class() * PZVTime / RWSTime);
  END;
 END {AddPZVSum};

 PUBLIC PROCEDURE InitTrip();
 BEGIN
  Init__();
 END {InitTrip};

END.