(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     ।  ३,
%Purpose     on-line ஢ન ࠢ쭮  ਡ⮢ ३
%Type        control
%Specific    AP
%Modified    30.07.2014 14:59:59 POLAK\San
*)

 MODULE SEJobs [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Way, L_Env, L_DatTim, L_StdFrm, L_Events, L_Str, Math, L_APtm, L_WDO;

 PRIVATE PROCEDURE SEJobsAccess();
 BEGIN
  L_General.Assert(ACCESS(SEJobs), " ࠭ ३");
 END {SEJobsAccess};

 PRIVATE PROCEDURE AllowIllegalChanging(): SCAL[2];
 BEGIN
  RETURN (SYSDATE() < L_DatTim.IncMonth(L_Env.aptm_Start, +1)) |
         (~L_APtm.MonthIsClosed(L_Env.aptm_Start, L_APtm.system_Salary));
 END {AllowIllegalChanging};

 PRIVATE PROCEDURE MayModify();
 BEGIN
  IF ~AllowIllegalChanging() THEN
   SAVE(SEJobs);
   SELECT(SEJobs, Exit, , StExit.Exit);
   WHILE OCCURE(SEJobs) DO
    IF ~!SEJobs.Trip THEN
     PROMPT(SEJobs.Trip);
     L_General.Assert(~SELECT(RWayJ, Trip, SEJobs.Trip), " 室   ,|"+
                      "..  ३ 㯮  ⥢ ");
    END;
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs) ... *)
   RESTORE(SEJobs);
  END;
 END {MayModify};

 PRIVATE PROCEDURE CheckExitStrict();
 BEGIN
  IF StExit.Strict = L_Way.ExitStrict_Reg THEN
   MayModify();
  END;
 END {CheckExitStrict};

 PRIVATE PROCEDURE SEJobsChangeAllowed(): SCAL[2];
 BEGIN
  RETURN AllowIllegalChanging() | ~SELECT(RWayJ, Trip, SEJobs.Trip);
 END {SEJobsChangeAllowed};

 PRIVATE PROCEDURE CheckIfIsInUse(wStop: SCAL[2]);
 BEGIN
  IF ~SEJobsChangeAllowed() THEN
   L_StdFrm.ConditionalCHOICE(" "+SEJobs.Trip+" 㯮  ⥢ ." +
                              "|⨬  ⮫쪮 ࠢ" +
                              "|  ਧ த ⮢ /", ~wStop);
  END;
 END {CheckIfIsInUse};

 PUBLIC PROCEDURE ChangeStopT(dir: NUMERIC[0]);
 BEGIN
  IF ACCESS(SEJobs) THEN
   CheckIfIsInUse(1);
   INC(SEJobs.StopT, dir*1/60);
   REPLACE(SEJobs);
  END;
 END {ChangeStopT};

 PUBLIC PROCEDURE ChangeAllTimes(dir: NUMERIC[0]);
  VAR
   _Trip: LIKE(SEJobs.Trip);
 BEGIN
  IF ACCESS(SEJobs) THEN
   _Trip:=SEJobs.Trip;
   SELECT(SEJobs, Exit, , StExit.Exit);
   WHILE OCCURE(SEJobs) DO
    CheckIfIsInUse(1);
    INC(SEJobs.StartT, dir*1/60);
    INC(SEJobs.StopT,  dir*1/60);
    REPLACE(SEJobs);
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs)... *)
   SEARCH(SEJobs, Trip, , _Trip);
   SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), SEJobs);
  END;
 END {ChangeAllTimes};

 PRIVATE PROCEDURE SetTripStopT();
 BEGIN
  IF ~!SEJobs.StartT THEN
   SEJobs.RtMVer:=L_Way.E_FittingRtMVerOnCurrentSEJobs();
  ELSE
   SETEMPTY(SEJobs.RtMVer);
  END;
  REPLACE(SEJobs);

  IF ~!SEJobs.StartT & ~!SEJobs.Modif THEN
   CONFORM(SEJobs, RoutMod);
   SEJobs.StopT:=SEJobs.StartT +
                 RoutMod.Tim[SEJobs.RtMVer] / 60;
  END;
  REPLACE(SEJobs);
 END {SetTripStopT};

 PRIVATE PROCEDURE InsertJobCopy(_StartT: LIKE(SEJobs.StartT);
                                 _Day   : LIKE(SEJobs.Day);
                                 _Inc   : NUMERIC[0]);
  VAR
   Duration: FLOAT;
   _Trip   : LIKE(SEJobs.Trip);
 BEGIN
  _Trip:=SEJobs.Trip+_Inc;
  SAVE(SEJobs);
  L_General.Assert(~SEARCH(SEJobs, Trip, _Trip),
                   "  ३   " + _Trip + ".|"+
                   ", 襭 ஢ ३ᮢ.");
  RESTORE(SEJobs);
  Duration     :=SEJobs.StopT - SEJobs.StartT;
  SEJobs.Day   :=_Day;
  SEJobs.StartT:=_StartT;
  SEJobs.StopT :=SEJobs.StartT + Duration;
  SEJobs.Trip  :=_Trip;
  INSERT(SEJobs);
  CONFORM(SEJobs, StExit);
  IF ~!L_Way.E_GetRtMVerPool(StExit.FromD) THEN
   SetTripStopT();
  END;
 END {InsertJobCopy};

 PRIVATE PROCEDURE SetParamsForInsertJob(VAR _StartT: LIKE(SEJobs.StartT);
                                         VAR _Day   : LIKE(SEJobs.Day));
 BEGIN
  _StartT:=SEJobs.StopT;
  _Day   :=SEJobs.Day;
  IF SEJobs.StopT < SEJobs.StartT THEN
   INC(_Day);
  END;
 END {SetParamsForInsertJob};

 PUBLIC PROCEDURE AppendTrip();
  VAR
   _Dir   : SCAL[2];
   _StartT: LIKE(SEJobs.StartT);
   _Day   : LIKE(SEJobs.Day);
   _Stop  : LIKE(Stop.Stop);
   TrpDir : LIKE(SEJobs.Dir);
   RtMDir : LIKE(RoutMod.Dir);
 BEGIN
  CheckExitStrict();
  SEJobsAccess();
  SAVE(SEJobs);
  CONFORM(SEJobs, RoutMod);
  CONFORM(RoutMod, RtMStop);
  TrpDir:=SEJobs.Dir;
  IF RoutMod.Dir = TrpDir THEN
   RtMDir:=L_Way.dir_Forward;
  ELSE
   RtMDir:=L_Way.dir_Backward;
  END;
  IF RtMDir = L_Way.dir_Forward THEN
   LAST(RtMStop);
  END;
  _Dir:=SEJobs.Dir;
  IF NEXT(SEJobs) THEN
   L_General.Assert(OCCURE(RtMStop), '  ⮫쪮 ᫥ ᫥ ३|'+
                                     '  ᫥ ३ᮢ "㤠 - ⭮"');
   _Stop:=RtMStop.Stop;
   CONFORM(SEJobs, RoutMod);
   CONFORM(RoutMod, RtMStop);
   TrpDir:=SEJobs.Dir;
   IF RoutMod.Dir = TrpDir THEN
    RtMDir:=L_Way.dir_Forward;
   ELSE
    RtMDir:=L_Way.dir_Backward;
   END;
   IF RtMDir = L_Way.dir_Backward THEN
    LAST(RtMStop);
   END;
   L_General.Assert(OCCURE(RtMStop) & (_Stop=RtMStop.Stop) &
                    (_Dir # SEJobs.Dir) & ~NEXT(SEJobs),
                    '  ⮫쪮 ᫥ ᫥ ३|' +
                    '  ᫥ ३ᮢ "㤠 - ⭮"');
   LAST(SEJobs);
   SetParamsForInsertJob(_StartT, _Day);
   RESTORE(SEJobs);
   InsertJobCopy(_StartT, _Day, 2);
   SetParamsForInsertJob(_StartT, _Day);
   PREV(SEJobs);
   InsertJobCopy(_StartT, _Day, 2);
   LIKEMENU(End, "", Up, "");
  ELSE
   RESTORE(SEJobs);
   SetParamsForInsertJob(_StartT, _Day);
   InsertJobCopy(_StartT, _Day, 1);
   LIKEMENU(End, "");
  END;
 END {AppendTrip};

 PRIVATE PROCEDURE ChangeModif();
  VAR
   _OldModif,
   _NewModif : LIKE(SEJobs.Modif);
   _OldRoute,
   _Route    : LIKE(SEJobs.Route);
 BEGIN
  SEJobsAccess();
  _Route   :=SEJobs.Route;
  _OldRoute:=SEJobs.Route;
  _OldModif:=SEJobs.Modif;
  SETEMPTY(_NewModif);
  CONFORM(SEJobs, RoutMod);
  STDFORM("| 䨪 "+_OldModif+"  "+_Route+
          "|'"+RoutMod.Name+"'"+
          "| 䨪 %3I  %4I"+"|  ३ 室|"+
          "|%< 믮 >DB          %< ⬥ >X",
          , STOP, 1, _NewModif, _Route);
  IF L_DatTim.InPatIntvl(RoutMod.FromD, RoutMod.UpDate, StExit.FromD, StExit.UpDate) THEN
   L_StdFrm.Choice("䨪 "+_OldModif+"    ਮ ⢨ 室|"+
                   " 㢥७,    ?");
  END;
  L_General.Assert(SEARCH(Route, Route, _Route),
                   "  " + _Route);
  L_General.Assert(SEARCH(RoutMod, Route, _Route, _NewModif),
                   "  "+_Route+"  䨪樨 "+_NewModif);
  L_General.Assert(L_DatTim.InPatIntvl(RoutMod.FromD, RoutMod.UpDate, StExit.FromD, StExit.UpDate),
                   "䨪 "+_NewModif+"    ਮ ⢨ 室.");

  CONFORM(StExit, SEJobs);
  WHILE OCCURE(SEJobs) DO
   IF (SEJobs.Modif = _OldModif) & (SEJobs.Route = _OldRoute) THEN
    SEJobs.Modif:=_NewModif;
    SEJobs.Route:=_Route;
    REPLACE(SEJobs);
    CONFORM(SEJobs, WJMode, Route);
    L_Way.ChkTripPermiss(SEJobs.StartT, SEJobs.StopT, RoutMod.Run);
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
 END {ChangeModif};

 PRIVATE PROCEDURE SetRtMVerPool();
  VAR
   RtMVerPool: STRING[];
 BEGIN
  SEJobsAccess();
  IF OCCURE(SEJobs) THEN
   CONFORM(SEJobs, StExit);
   CONFORM(SEJobs, RoutMod);
   IF OCCURE(RoutMod) THEN
    RtMVerPool:=L_Way.E_GetRtMVerPool(StExit.FromD);
   ELSE
    SETEMPTY(RtMVerPool);
   END;
   RTI.Get().CurZone.Fields("SEJobs.RtMVer").Modifiable:=~!RtMVerPool;
   IF !RtMVerPool THEN
    RtMVerPool:=" 㬮砭|";
   END;
   RTI.Get().CurZone.Fields("SEJobs.RtMVer").Format:=RtMVerPool;
  END;
 END {SetRtMVerPool};

 PRIVATE PROCEDURE SEJobs_SetModifiable(trgM: SCAL[2]);
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  Fields("SEJobs.Trip"  ).Modifiable:=trgM;
  Fields("SEJobs.Day"   ).Modifiable:=trgM;
  Fields("SEJobs.StartT").Modifiable:=trgM;
  Fields("SEJobs.StopT" ).Modifiable:=trgM;
  Fields("SEJobs.Route" ).Modifiable:=trgM;
  Fields("SEJobs.Modif" ).Modifiable:=trgM;
  Fields("SEJobs.RtMVer").Modifiable:=trgM;
  Fields("SEJobs.WJCode").Modifiable:=trgM;
 END {SEJobs_SetModifiable};

 PRIVATE PROCEDURE SEJobs_OnBeforeModification();
  VAR
   AllowChange: SCAL[2];
 BEGIN
  IF RTI.Get().CurWindow.ParentZone.Processes(0).Kind # FORM_PROCESS.Kind_View THEN
   L_General.Error(" ३ᮢ  ⮬ ⥪ 饭");
  END;
  AllowChange:=SEJobsChangeAllowed();
  SEJobs_SetModifiable(AllowChange);
  IF ~AllowChange THEN
   CheckIfIsInUse(0);
  END;
  SetRtMVerPool();
 END {SEJobs_OnBeforeModification};

 PRIVATE PROCEDURE SEJobs_OnBeforeEdit();
 BEGIN
  SEJobs_OnBeforeModification();
 END {SEJobs_OnBeforeEdit};

 PRIVATE PROCEDURE FindFreeTrip(): LIKE(SEJobs.Trip);
  VAR
   _Trip: LIKE(SEJobs.Trip);
 BEGIN
  IF StExit.Strict = L_Way.ExitStrict_Reg THEN
   IF SELECT(SEJobs, Exit, StExit.Exit) THEN
    _Trip:=SEJobs.Trip;
    WHILE OCCURE(SEJobs) DO
     IF ~!SEJobs.Trip & (_Trip < SEJobs.Trip) THEN
      _Trip:=SEJobs.Trip;
     END;
     NEXT(SEJobs);
    END; (* WHILE OCCURE(SEJobs) ... *)
    CONFORM(StExit, SEJobs);
    RETURN _Trip+1;
   END;
   L_General.CallUs(0);
  ELSE
   RETURN StExit.Exit*100;
  END;
 END {FindFreeTrip};

 PRIVATE PROCEDURE SEJobs_OnBeforeInsert();
  VAR
   _StartT: LIKE(SEJobs.StartT);
   _Trip  : LIKE(SEJobs.Trip);
   _Day   : LIKE(SEJobs.Day);
   _RtMVer: LIKE(SEJobs.RtMVer);
 BEGIN
  IF RTI.Get().CurWindow.ParentZone.Processes(0).Kind # FORM_PROCESS.Kind_View THEN
   L_General.Error(" ३ᮢ  ⮬ ⥪ 饭");
  END;
  CheckExitStrict();
  SEJobs_SetModifiable(1);
  SAVE(SEJobs);
  _Day   :=SEJobs.Day;
  _StartT:=GE_PVALUE(SEJobs.StopT);
  _RtMVer:=GE_PVALUE(SEJobs.RtMVer);
  IF !_StartT THEN (*⢥ *)
   _Trip  :=StExit.Exit*100+01;
   _RtMVer:=0;
  ELSE
   IF GE_PVALUE(SEJobs.StartT) > _StartT THEN (*new day*)
    _Day:=SEJobs.Day+1;
   END;
   CONFORM(StExit, SEJobs);
   LAST(SEJobs);
   IF !SEJobs.Trip THEN (*⠫  ᠬ ᥡ*)
    PREV(SEJobs);
   END;
   IF SEJobs.StopT = _StartT THEN
    _Trip:=SEJobs.Trip+1;
    IF SEARCH(SEJobs, Trip, _Trip) THEN
     _Trip:=FindFreeTrip();
    END;
   ELSE
    _Trip:=FindFreeTrip();
   END;
  END;
  IF SEARCH(SEJobs, Trip, _Trip) THEN
   L_General.Error("襭 ࠢ ஢ ३ᮢ." +
                   "||c   " + SEJobs.Trip + " 㦥   室 " + SEJobs.Exit +
                   "||室 ४஢ ३  室 " + SEJobs.Exit);
  END;
  RESTORE(SEJobs);
  SEJobs.StartT:=_StartT;
  SEJobs.Day   :=_Day;
  SEJobs.Trip  :=_Trip;
  SEJobs.RtMVer:=_RtMVer;
  SEJobs.FromD :=StExit.FromD;
  SEJobs.UpDate:=StExit.UpDate;
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   REPLACE(SEJobs);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF L_General.IsUniquenessViolationException(Exc) THEN
   ELSE
    RAISE();
   END;
  END;
 END {SEJobs_OnBeforeInsert};

 PRIVATE PROCEDURE SettleTim(): NUMERIC[0];
  VAR
   SettlTim    : NUMERIC[0];
   StopCtrlTime: TIME;
 BEGIN
  IF ~!SEJobs.Route & ~!SEJobs.Modif THEN
   CONFORM(SEJobs, RoutMod);
   IF SELECT(SEJMStop, Trip, SEJobs.Trip) THEN
    IF SEJobs.Dir = RoutMod.Dir THEN
     LAST(SEJMStop);
    END;
    SettlTim:=SEJMStop.DTim;
   ELSIF SELECT(RtMStop, Route, RoutMod.Route, RoutMod.Modif) THEN
    IF SEJobs.Dir = RoutMod.Dir THEN
     LAST(RtMStop);
    END;
    StopCtrlTime:=L_Way.GetStopCtrlTime_ofCurrentTrip(SEJobs.StartT, SYSDATE());
    SettlTim:=(L_Way.FullEndTime(1, SEJobs.StartT, SEJobs.StopT) -
               L_Way.FullEndTime(1, SEJobs.StartT, StopCtrlTime)) * 60;
   ELSE
    SettlTim:=0;
   END;
  ELSE
   SETEMPTY(SettlTim);
  END;
  RETURN SettlTim;
 END {SettleTim};

 PUBLIC PROCEDURE CheckTripLength(InsideExit: SCAL[2]);
  CONST
   Delta = 20;
  VAR
   SettlTim,
   SEJobsLength: NUMERIC[0];
 BEGIN
  CONFORM(SEJobs, Route, RoutMod, WJMode);
  IF ~!SEJobs.StopT & (RoutMod.Tim[SEJobs.RtMVer] > 0) THEN
   SEJobsLength:=(SEJobs.StopT - SEJobs.StartT) * 60;
   IF InsideExit &
      (Math.Abs(SEJobsLength - RoutMod.Tim[SEJobs.RtMVer]) * 100 /
       Math.Max(SEJobsLength, RoutMod.Tim[SEJobs.RtMVer]) > Delta) THEN
    L_StdFrm.Choice("  த⥫쭮 䨪樨 |" +
                    " ⠭ ࢠ 砫/砭 ३|"+
                    " " + L_Str.IntStr(Delta) + "%");
   END;

   IF SettleTim() < 0 THEN
    L_StdFrm.ConditionalCHOICE(" " + SEJobs.Trip +
                               "||த⥫쭮  䨪樨 " +
                               "|ॢ蠥 த⥫쭮 ३." +
                               "|| ନ 筥 ६ .", InsideExit);
   END;
  END;
 END {CheckTripLength};

 PRIVATE PROCEDURE HasActiveWJMethod(D: DATE): SCAL[2];
 BEGIN
  IF AllowIllegalChanging() THEN
   RETURN 1;
  ELSE
   SELECT(WJMethod, WJCode, , SEJobs.WJCode, L_Way.rwswho_Driver, L_Way.GetRouteJRegime(D, 1));
   WHILE OCCURE(WJMethod) DO
    IF L_DatTim.IsActive(D, WJMethod.Begin, WJMethod.Till) THEN
     RETURN 1;
    END;
    NEXT(WJMethod);
   END; (* WHILE OCCURE(WJMethod) ... *)
   RETURN 0;
  END;
 END {HasActiveWJMethod};

 PRIVATE PROCEDURE SEJobs_OnAfterEditInsert();
  VAR
   ExitCod: LIKE(StExit.Exit);
 BEGIN
  SAVE(SEJobs);
  CHANGESEL(SEJobs, Exit, , SEJobs.Exit);
  IF (SEJobs.Day > 01) & ~PREV(SEJobs) THEN
   L_StdFrm.Question("室 ⢨⥫쭮 稭  ᫥騥 ⪨ ( ३ 㪠   01)?");
  END;
  RESTORE(SEJobs);
  CONFORM(SEJobs, Route, RoutMod, WJMode);
  IF (StExit.Strict > L_Way.ExitStrict_Fict) & ~HasActiveWJMethod(StExit.FromD) THEN
   L_StdFrm.Choice("  ⮤   ࠡ "+SEJobs.WJCode+"| ० "+ L_Way.GetRouteJRegime(StExit.FromD, 1) +"  "+L_DatTim.DateStr(StExit.FromD));
  END;
  ExitCod:=SEJobs.Trip DIV 100;
  L_General.Assert(ExitCod # MAXOF(StExit.Exit), " ३   稭  " + ExitCod);
  L_General.Assert(SEJobs.Trip MOD 100 # 0,      " ३   稢  00");
  L_Way.ChkTripPermiss(SEJobs.StartT, SEJobs.StopT, RoutMod.Run);
  CheckTripLength(1);
  L_General.Assert((SEJobs.BoxTick = L_Way.bt_Never) | (WJMode.IncSel*Route.IncSel > 0),
                   "த ⮢  / ⨬ ⮫쪮  稨 室");
 END {SEJobs_OnAfterEditInsert};

 PRIVATE PROCEDURE SEJobs_OnAfterEdit();
 BEGIN
  IF ~L_General.IsLegalRecordModification("SEJobs", "Trip|Dir|BoxTick") THEN
   CheckIfIsInUse(1);
  END;
  SEJobs_OnAfterEditInsert();
 END {SEJobs_OnAfterEdit};

 PRIVATE PROCEDURE SEJobs_OnAfterInsert();
 BEGIN
  SEJobs_OnAfterEditInsert();
 END {SEJobs_OnAfterInsert};

 PRIVATE PROCEDURE SEJobs_OnBeforeDelete();
 BEGIN
  SEJobs_OnBeforeModification();
 END {SEJobs_OnBeforeDelete};

 PRIVATE PROCEDURE SetSettleTim();
 BEGIN
  L_WDO.iField(0, "SettlTim").Value:=SettleTim();
 END {SetSettleTim};

 PRIVATE PROCEDURE SetRealSEJobsStopT();
  VAR
   curStopT: TIME;
   curWin  : FORM_WINDOW;
   Field   : FORM_FIELD;
   trgColor: NUMERIC[0];
 BEGIN
  curWin:=RTI.Get().CurWindow;
  IF ~!curWin THEN
   Field:=curWin.Zones(0).Fields("v_StopT");
  ELSE
   SETEMPTY(Field);
  END;
  IF ~!Field THEN
   CONFORM(SEJobs, RoutMod);
   IF SELECT(SEJMStop, Trip, SEJobs.Trip) THEN
    IF SEJobs.Dir = RoutMod.Dir THEN
     LAST(SEJMStop);
    END;
    L_General.Assert(SEJMStop.ATim < 1440(*24*60*), "த⥫쭮 ३     ⮪");
    curStopT:=SEJobs.StartT + SEJMStop.ATim / 60;
   ELSE
    curStopT:=SEJobs.StopT;
   END;
   IF curStopT # SEJobs.StopT THEN
    trgColor:=FORM_FIELD.Color_Field1;
   ELSE
    trgColor:=FORM_FIELD.Color_Field4;
   END;
   Field.Color:=trgColor;
   Field.Value:=curStopT;
  END;
 END {SetRealSEJobsStopT};

 PRIVATE PROCEDURE Clear_SEJMStop();
 BEGIN
  SEJobsAccess();
  IF SELECT(SEJMStop, Trip, SEJobs.Trip) THEN
   L_StdFrm.Choice("!    筥 ६|" +
                   "  ⠭  ३ " + SEJobs.Trip +
                   "| 㤠!");
   REMSEL(SEJMStop);
   SetRealSEJobsStopT();
  END;
 END {Clear_SEJMStop};

 PRIVATE PROCEDURE CheckSEJMStop(Operation: STRING[]);
 BEGIN
  SEJobsAccess();
  IF SELECT(SEJMStop, Trip, SEJobs.Trip) THEN
   L_StdFrm.Choice(Operation + "|" +
                   " 稨 筥 ६|" +
                   "  ⠭.||" +
                   " 筥 ६   ⠭?");
   Clear_SEJMStop();
  END;
 END {CheckSEJMStop};

 PRIVATE PROCEDURE SEJobs_Route_OnSuccessfulChange();
 BEGIN
  CheckSEJMStop(" ");
 END {SEJobs_Route_OnSuccessfulChange};

 PRIVATE PROCEDURE SEJobs_Modif_OnSuccessfulChange();
 BEGIN
  CheckSEJMStop(" 䨪樨 ");
  IF ~!SEJobs.Route & ~!SEJobs.Modif THEN
   CONFORM(SEJobs, RoutMod);
   IF ~RoutMod.InPsp THEN
    SEJobs.RtMVer:=00;
    REPLACE(SEJobs);
   END;
  END;
  SetRtMVerPool();
  SetSettleTim();
 END {SEJobs_Modif_OnSuccessfulChange};

 PRIVATE PROCEDURE SEJobs_RtMVer_OnSuccessfulChange();
 BEGIN
  SetSettleTim();
 END {SEJobs_RtMVer_OnSuccessfulChange};

 PRIVATE PROCEDURE SEJobs_StartT_OnSuccessfulChange();
 BEGIN
  SetSettleTim();
 END {SEJobs_StartT_OnSuccessfulChange};

 PRIVATE PROCEDURE SEJobs_StopT_OnSuccessfulChange();
 BEGIN
  SetSettleTim();
 END {SEJobs_StopT_OnSuccessfulChange};

 PRIVATE PROCEDURE SEJobs_Dir_OnSuccessfulChange();
 BEGIN
  CheckSEJMStop(" ࠢ ३");
  SetSettleTim();
 END {SEJobs_Dir_OnSuccessfulChange};

 PUBLIC PROCEDURE RecodeTrips();
  VAR
   i: NUMERIC[0];
   _Trip: LIKE(SEJobs.Trip);
 BEGIN
  L_StdFrm.Choice("४஢ ३ 室");
  INTEGRITY(NoAsk);

  SELECT(SEJobs, Exit, , StExit.Exit);
  i:=0;
  WHILE OCCURE(SEJobs) DO
   INC(i);
   PROMPT(SEJobs.Trip);
   SEJobs.Trip:=MAXOF(StExit.Exit)*100+i;
   REPLACE(SEJobs);
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)

  SELECT(SEJobs, Exit, , StExit.Exit);
  i:=0;
  WHILE OCCURE(SEJobs) DO
   INC(i);
   _Trip:=SEJobs.Exit*100+i;
   SEJobs.Trip:=_Trip;
   PROMPT(SEJobs.Trip);
   TRY
    REPLACE(SEJobs);
   EXCEPT
   ON Exc: Exc_RunTime DO
    IF L_General.IsUniquenessViolationException(Exc) THEN
     L_StdFrm.RedInform(" ३ 㦥 ᯮ: " + _Trip +
                        "|, ᫥   室  ४஢ ३ ");
    ELSE
     RAISE();
    END;
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
 END {RecodeTrips};

 PUBLIC PROCEDURE ChangeTripDir();
 BEGIN
  SEJobsAccess();
  SEJobs.Dir:=~SEJobs.Dir;
  REPLACE(SEJobs);
  CheckSEJMStop(" ࠢ ३");
 END {ChangeTripDir};

 PUBLIC PROCEDURE ChangeTripModif();
 BEGIN
  SEJobsAccess();
  MayModify();
  ChangeModif();
 END {ChangeTripModif};

 PUBLIC PROCEDURE DeleteTripToEnd();
 BEGIN
  SEJobsAccess();
  L_StdFrm.Choice("  㤠 ३  , 稭  "+L_DatTim.TimeStr(SEJobs.StartT));
  INTEGRITY(NoAsk);
  WHILE OCCURE(SEJobs) DO
   MayModify();
   REMOVE(SEJobs);
  END;
 END {DeleteTripToEnd};

 PUBLIC PROCEDURE SEJMStop_Modification(Clear: SCAL[2]);
  VAR
   _DTim,
   _RTim: NUMERIC[4];
 BEGIN
  Clear_SEJMStop();
  CONFORM(SEJobs, RoutMod);
  IF ~Clear THEN
   L_General.Assert(SELECT(RtMStop, Route, SEJobs.Route, SEJobs.Modif),
                    "    ⠭.|"+
                    " " + SEJobs.Route + ", 䨪 " + SEJobs.Modif);
   WHILE OCCURE(RtMStop) DO
    PROMPT("⠢ " + RtMStop.Stop);
    IF SEJobs.Dir # RoutMod.Dir THEN
     SAVE(RtMStop);
     _DTim:=RtMStop.DTim[SEJobs.RtMVer];
     IF NEXT(RtMStop) THEN
      _RTim:=RtMStop.RTim[SEJobs.RtMVer];
     ELSE
      SETZERO(_RTim);
     END;
     RESTORE(RtMStop);
    ELSE
     _DTim:=RtMStop.DTim[SEJobs.RtMVer];
     _RTim:=RtMStop.RTim[SEJobs.RtMVer];
    END;
    DEFAULT(SEJMStop);
    SEJMStop.Trip   :=SEJobs.Trip;
    SEJMStop.StopNbr:=RtMStop.StopNbr;
    SEJMStop.Stop   :=RtMStop.Stop;
    SEJMStop.DTim   :=_DTim;
    SEJMStop.RTim   :=_RTim;
    INSERT(SEJMStop);
    NEXT(RtMStop);
   END; (* WHILE OCCURE(RtMStop) ... *)
  END;
  RecountSEJMStop();
  SetRealSEJobsStopT();
 END {SEJMStop_Modification};

 PRIVATE PROCEDURE SEJMStop_OnBeforeInsert();
 BEGIN
  L_General.Error("⠢ 饭|" +
                  "ᯮ ᮮ⢥騬 㭪⮬ 쭮 ");
 END {SEJMStop_OnBeforeInsert};

 PRIVATE PROCEDURE SEJMStop_OnBeforeDelete();
 BEGIN
  L_General.Error(" 饭|" +
                  "ᯮ ᮮ⢥騬 㭪⮬ 쭮 ");
 END {SEJMStop_OnBeforeDelete};

 PRIVATE PROCEDURE RecountSEJMStop();
  VAR
   _ATim: LIKE(SEJMStop.ATim);
 BEGIN
  SEJobsAccess();
  CONFORM(SEJobs, RoutMod);
  IF SELECT(SEJMStop, Trip, SEJobs.Trip) THEN
   IF SEJobs.Dir # RoutMod.Dir THEN
    LAST(SEJMStop);
   END;
   SETZERO(SEJMStop.RTim, _ATim);
   WHILE OCCURE(SEJMStop) DO
    INC(_ATim, SEJMStop.RTim + SEJMStop.DTim);
    SEJMStop.ATim:=_ATim;
    REPLACE(SEJMStop);
    IF SEJobs.Dir # RoutMod.Dir THEN
     PREV(SEJMStop);
    ELSE
     NEXT(SEJMStop);
    END;
   END; (* WHILE OCCURE(SEJMStop ... *)
   SetRealSEJobsStopT();
  END;
 END {RecountSEJMStop};

 PRIVATE PROCEDURE SEJMStop_RTim_OnSuccessfulChange();
 BEGIN
  RecountSEJMStop();
 END {SEJMStop_RTim_OnSuccessfulChange};

 PRIVATE PROCEDURE SEJMStop_DTim_OnSuccessfulChange();
 BEGIN
  RecountSEJMStop();
 END {SEJMStop_DTim_OnSuccessfulChange};

 PRIVATE PROCEDURE SEJMStpE_1_OnZoneOpen();
 BEGIN
  SEJobsAccess();
  SetRealSEJobsStopT();
 END {SEJMStpE_1_OnZoneOpen};

 PRIVATE PROCEDURE SEJMStpE_0_OnReposition();
 BEGIN
  SetRealSEJobsStopT();
 END {SEJMStpE_0_OnReposition};

 PRIVATE PROCEDURE SEJMStpE_OnInitializeWindow();
 BEGIN
  L_WDO.iUnmodifiable(0, ["SEJobs.StartT", "SEJobs.StopT", "v_StopT", "SEJobs.Dir", "SEJobs.Trip"]);
  L_WDO.iEvents      (0, [L_WDO.e_OnReposition]);
  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete]);
  L_WDO.iZone        (1).Narrowing:="SEJMStop.Trip=SEJobs.Trip";
  L_WDO.iScsChange   (1, ["SEJMStop.DTim", "SEJMStop.RTim"]);
  L_WDO.iUnmodifiable(1, ["SEJMStop_StartT", "SEJMStop_StopT", "SEJMStop.ATim", "SEJMStop.StopNbr", "SEJMStop.Stop"]);
  L_WDO.iField       (1, "Stop.CPType").Format:=L_Way.scpt_PoolWdo;
  L_WDO.iProgs       (1, "SEJobs");
 END {SEJMStpE_OnInitializeWindow};

 PRIVATE PROCEDURE SEJobsE_0_OnReposition();
 BEGIN
  SetRtMVerPool();
  SetSettleTim();
 END {SEJobsE_0_OnReposition};

 PRIVATE PROCEDURE SEJobsE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "SEJobs.StartT").First:=1;
  L_WDO.iScsChange   (0, ["SEJobs.RtMVer", "SEJobs.Dir", "SEJobs.Route", "SEJobs.Modif", "SEJobs.StartT", "SEJobs.StopT"]);
  L_WDO.iUnmodifiable(0, ["RoutMod_StopT", "BoxTick_Title", "SettlTim", "SEJobs.Exit"]);
  L_WDO.iField       (0, "BoxTick_Title").Visible:=~L_APtm.IsMGT();
  L_WDO.iField       (0, "SEJobs.BoxTick").Visible:=~L_APtm.IsMGT();
  L_WDO.iZone        (1).ViewOnly:=1;
 END {SEJobsE_OnInitializeWindow};

BEGIN
 L_Events.ExecuteHandler();
END.
