(*
%Copyright   (c) Polak Computer System
%Author      SAN
%Purpose       
%Type        operation
%Specific    AP
%Modified    03.03.2014 16:54:25 POLAK\LDA
%Environment
*)

 MODULE SetRWayF [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Fuel, L_Car, Math, L_Way, L_AcsPnt, L_APtm, L_StdFrm;

 PRIVATE PROCEDURE RoundRemEntr(_RemEntr: LIKE(RWayF.RemEntr)): LIKE(RWayF.RemEntr);
 BEGIN
  IF (RWayS.Date >= 01\11\2002) | L_General.IsPolakSpecific() THEN
   RETURN Math.Round(_RemEntr, 0.01);
  ELSE
   RETURN _RemEntr;
  END;
 END {RoundRemEntr};

 PRIVATE PROCEDURE _ItWas(): LIKE(RWayF.RemEntr);
 BEGIN
  RETURN RWayF.RemExit+RWayF.FuelTake-RWayF.FuelRet;
 END {_ItWas};

 PRIVATE PROCEDURE Do_woHardChain();
  VAR
   Amount: NUMERIC[0];
   Msg   : STRING[];
 BEGIN
  CONFORM(RWayS, Car);
  Amount:=0;
  SELECT(RWayF, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayF) DO
   IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) THEN
    INC(Amount);
   END; (* IF IsFuelInMix ... *)
   NEXT(RWayF);
  END; (* WHILE OCCURE(RWayF) ... *)
  IF Amount > 1 THEN
   Msg:="ଫ ᪮쪨  ⮯     ᪠";
   IF L_Fuel.FlAcntLev(RWayS.Date) # L_Fuel.fal_RWOP THEN
    INC(Msg, '| , ࠧ浪  ""');
   END;
   INC(Msg, L_StdFrm.HR() +
            "᫨ ॡ ନ ॢ   㣮 ⮯," +
            "|ᤠ ⪮ ண ⮯  ࠢ  ⮯" +
            "|᫥ ନ  ࠧ ");
   L_General.Error(Msg);
  END;
  IF (Amount = 0) & ((RWayS.RemExit # 0) | (RWayS.RemEntr # 0)) THEN
   L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
   RWayF.RWayS   :=RWayS.RWayS;
   RWayF.Math    :=L_Fuel.GetMainFuel(RWayS.Date, Mark.Mark);
   RWayF.RemExit :=0;
   RWayF.FuelTake:=0;
   RWayF.FuelRet :=0;
   RWayF.RemEntr :=0;
   RWayF.Norm    :=0;
   INSERT(RWayF);
  END;
  SETZERO(RWayS.FuelFact);
  SELECT(RWayF, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayF) DO
   IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) THEN
    RWayF.RemExit :=RWayS.RemExit;
    RWayF.RemEntr :=RWayS.RemEntr;
    INC(RWayS.FuelFact, L_Fuel._FuelFact());
   ELSE
    RWayF.RemExit :=0;
    RWayF.RemEntr :=0;
   END; (* IF IsFuelInMix ... *)
   REPLACE(RWayF);
   NEXT(RWayF);
  END; (* WHILE OCCURE(RWayF) ... *)
  REPLACE(RWayS);
 END {Do_woHardChain};

 PRIVATE PROCEDURE Do_Normal(Silent: SCAL[2]);
  CONST
   FCAmnt = 24;
  VAR
   OnExit     : LIKE(RWayF.RemExit)[FCAmnt];
   Maths      : LIKE(RWayF.Math)   [FCAmnt];
   MathAmount,
   MathIdx,
   Amount     : NUMERIC[0];
   First      : SCAL[2];
   ItWas,
   rstRemEntr : LIKE(RWayF.RemEntr);
   totRemExit : LIKE(RWayF.RemExit);
   totFuelFact: LIKE(RWayF.RemEntr);
   rwsFact    : LIKE(RWayS.FuelFact);
   Msg        : STRING[];
   MaxRemEntr : LIKE(RWayF.RemEntr);
   MaxRemEntrMath: LIKE(RWayF.Math);
 BEGIN
  L_General.CallUs(~RWayS.Done);
  (*  ⪨  諮  *)
  SETZERO(OnExit);
  SETEMPTY(Maths);
  MathAmount:=0;
  SAVE   (RWayS);
  IF CHANGESEL(RWayS, BoxNbr, RWayS.BoxNbr) & PREV(RWayS) THEN
   First:=0;
   SELECT(RWayF, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayF) DO
    L_Fuel.GetOrAddMathIdx(Maths, RWayF.Math, MathIdx, MathAmount);
    OnExit[MathIdx]:=RWayF.RemEntr;
    NEXT(RWayF);
   END; (* WHILE OCCURE(RWayF) ... *)
  ELSE
   First:=1;
  END;
  RESTORE(RWayS);
  (* ⠢ ⪨  륧 , ६,  䠪. 室 *)
  CONFORM(RWayS, Car);
  SETZERO(ItWas, Amount, totRemExit);
  SELECT(RWayF, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayF) DO
   IF ~First THEN
    L_Fuel.GetOrAddMathIdx(Maths, RWayF.Math, MathIdx, MathAmount);
    RWayF.RemExit:=OnExit[MathIdx];
    OnExit[MathIdx]:=0;
    REPLACE(RWayF);
   END;
   IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) THEN
    INC(totRemExit, RWayF.RemExit);
    INC(ItWas, _ItWas());
    INC(Amount);
   END; (* IF IsFuelInMix ... *)
   NEXT(RWayF);
  END; (* WHILE OCCURE(RWayF) ... *)

  IF First THEN
   IF ~L_APtm.IsOG() THEN
    Msg:="  ⥢    " + RWayS.BoxNbr + "||" + "⮪    륧   㫥";
    IF ~(~L_Fuel.TanksIsStock(RWayS.Date) | (RWayS.RemExit = 0)) THEN
     L_General.Error(Msg);
    END;
   END;

   L_General.Assert(totRemExit = RWayS.RemExit,
                    "室 ନ ᮣᮢ ⪨  륧:" +
                    "|" +
                    ". ' '  ⮪    楫");
  END;
  (*  ப,   ࠢ = 0,  ⪨ # 0 *)
  MathIdx:=0;
  WHILE MathIdx < MathAmount DO
   IF OnExit[MathIdx] > 0 THEN
    DEFAULT(RWayF);
    RWayF.RWayS   :=RWayS.RWayS;
    RWayF.Math    :=Maths[MathIdx];
    RWayF.RemExit :=OnExit[MathIdx];
    INSERT(RWayF);
    L_General.Assert(L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math),
                     " ⮪  륧  ᬠ ਠ." +
                     "  "+Maths[MathIdx]);
    INC(totRemExit, RWayF.RemExit);
    INC(ItWas, _ItWas());
    INC(Amount);
   END; (* IF OnExit ... *)
   INC(MathIdx);
  END; (* WHILE MathIdx ... *)
 
  (* ⠢  ⪨   *)
  SETZERO(totFuelFact);
  IF SELECT(RWayF, RWayS, RWayS.RWayS) THEN
   rwsFact:=ItWas - RWayS.RemEntr;
   IF rwsFact < 0 THEN
IF ~L_APtm.IsOG_Fuel(RWayS.Date) THEN
    Msg:="  " + RWayS.RWayS;
    IF RWayS.Status = L_Way.rwsStat_Rated THEN
     Msg:=Msg + ".  㤥 ॢ  ﭨ ' ⠪஢'";
     RWayS.Status:=L_Way.rwsStat_Taken;
     REPLACE(RWayS);
    END;
    L_AcsPnt.PassAccessPoint_wExplanation(0000032, Msg);
END;
   END;
   L_General.Assert(Silent | (totRemExit = RWayS.RemExit),
                    "襭 楯窠 |⥢  " + RWayS.RWayS);
   WHILE OCCURE(RWayF) DO
    IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) THEN
     IF Amount > 1 THEN
      IF ItWas # 0 THEN
       RWayF.RemEntr:=_ItWas()*RWayS.RemEntr/ItWas;
      ELSE
       L_General.Assert(RWayS.RemEntr = 0, "㬬 ⮪   ⮯ ࠢ ." +
                                           "|| 㪠   ⪥    ");
       RWayF.RemEntr:=0;
      END;
      IF (rwsFact > 0) & (RWayF.RemEntr < 1.0) & (RWayF.RemEntr < RWayS.RemEntr) THEN
       RWayF.RemEntr:=0;
       DEC(Amount);
      ELSE
       SETEMPTY(RWayF.RemEntr);
      END;
     ELSE
      SETEMPTY(RWayF.RemEntr);
     END;
     REPLACE(RWayF);
    END; (* IF L_Fuel.IsFuelInMix ... *)
    NEXT(RWayF);
   END; (* WHILE OCCURE(RWayF) ... *)

   rstRemEntr:=RWayS.RemEntr;
   FIRST(RWayF);
   SETEMPTY(MaxRemEntrMath); MaxRemEntr:=MINOF(MaxRemEntr);
   WHILE OCCURE(RWayF) DO
    IF L_Fuel.IsFuelInMixOnDate(RWayS.Date, RWayF.Math) THEN
     IF !RWayF.RemEntr THEN
      IF ItWas # 0 THEN
       RWayF.RemEntr:=RoundRemEntr(_ItWas()*RWayS.RemEntr/ItWas);
      ELSE
       RWayF.RemEntr:=0;
      END;
      IF RWayF.RemEntr >= MaxRemEntr THEN
       MaxRemEntrMath:=RWayF.Math;
       MaxRemEntr    :=RWayF.RemEntr;
      END;
     END;
     INC(totFuelFact, L_Fuel._FuelFact());
     DEC(rstRemEntr, RWayF.RemEntr);
    ELSE
     RWayF.RemEntr:=0;
    END; (* IF L_Fuel.IsFuelInMix ... *)
    SETEMPTY(RWayF.Norm);
    REPLACE(RWayF);
    NEXT(RWayF);
   END; (* WHILE OCCURE(RWayF) ... *)
   IF rstRemEntr # 0 THEN
    SEARCH(RWayF, RWayS, , RWayS.RWayS, MaxRemEntrMath);
    DEC(totFuelFact, L_Fuel._FuelFact());
    INC(RWayF.RemEntr, rstRemEntr);
    REPLACE(RWayF);
    INC(totFuelFact, L_Fuel._FuelFact());
   END;
   SELECT(RWayF, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayF) DO
    IF (RWayF.RemExit=0)&(RWayF.FuelTake=0)&(RWayF.FuelRet=0)&(RWayF.RemEntr=0) THEN
     REMOVE(RWayF);
    ELSE
     NEXT(RWayF);
    END;
   END; (* WHILE OCCURE(RWayF) ... *)
  ELSE
   IF L_APtm.IsOG() THEN
    IF ~Silent & (RWayS.Date > 14\01\2014) THEN
     IF (RWayS.RemEntr=0) THEN
      L_StdFrm.Choice("   㫥 ⪮ ⮯  ");
     END;
    END;
    Do_woHardChain();
   ELSE
    L_General.Assert((RWayS.RemExit=0) & (RWayS.RemEntr=0), " 㫥 ⪨ ⮯  ࠢ");
   END;
  END; (* IF SELECT(RWayF ... *)
  RWayS.FuelFact:=totFuelFact;
  REPLACE(RWayS);
 END {Do_Normal};

 PUBLIC PROCEDURE ProceedRWayF(Silent: SCAL[2]);
 BEGIN
  IF L_Fuel.CarMustHaveNormalChain(RWayS.BoxNbr, RWayS.Date) THEN
   Do_Normal(Silent);
  ELSE
   Do_woHardChain();
  END;
 END {ProceedRWayF};

END.
