(*
%Copyright   (c) Polak Computer System
%Author      13.09.2002 08:35:32 POLAK\BOR
%Type        report
%Specific    AP
%Modified    10.04.2012 12:06:35 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, L_General, L_OwnData, L_DatTim, D_CarTb, L_Car, L_Way, E_Way;

 CONST
  RepName = "ShCar";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
Car.BoxNbr, L , ""
Car.StateNbr, L, ""
Car.Mark, L, ""
Mark.Name, L, ""
@
################################################### ########## #####
=#####==============================================================
|             ਮ  ##########  ##########          |
|------------------------------------------------------------------|
|#### ##########    ઠ #### ####################################|
|------------------------------------------------------------------|
|          |    騩|            ६            |   設   |
|      |   ஡|-----------------------------|---------------|
|          |         |   |   |  ⮩|||||
|----------|---------|---------|---------|---------|---|---|---|---|
}
*)

(*
$P{ Line:
CarTb.Date, L, "D.N.y"
Run__, R, "1."
?, R, ""
?, R, ""
?, R, ""
?, C ," |"
?, C ," |"
?, C ," |"
?, C ," |"
@
|##########|#########|#########|#########|#########|###|###|###|###|
}
*)

(*
$P{ Bot:
C_Run__, R, "1."
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
@
|----------|---------|---------|---------|---------|---|---|---|---|
|ᥣ     |#########|#########|#########|#########|###|###|###|###|
=(c) Polak==========================================================
}
*)

 VAR
  Run__,
  C_Run__:D_CarTb.RunType;
  Day   : SCAL[2][4];
  C_Day : NUMERIC[0][4];
  totDIO,
  C_DIO : NUMERIC[0];
  Tim,
  C_Tim : D_CarTb.TimType[4];
  i     : NUMERIC[0];

 PRIVATE PROCEDURE IsCarDay(Idx: NUMERIC[0]): SCAL[2];
  VAR
   RCarDay: D_CarTb.RCDType;
 BEGIN
  RCarDay:=D_CarTb.CarTb_RCarDay(E_Way.DtlRCarDay(CarTb.BoxNbr, CarTb.Date));
  IF    Idx = 0 THEN
   RETURN RCarDay = D_CarTb.rcd_Line;
  ELSIF Idx = 1 THEN
   RETURN RCarDay = D_CarTb.rcd_Repair;
  ELSIF Idx = 2 THEN
   RETURN RCarDay = D_CarTb.rcd_Outage;
  ELSIF Idx = 3 THEN
   RETURN RCarDay = D_CarTb.rcd_Nothing;
  ELSE
   L_General.ConsultToUs(0, "Error in IsCarDay");
  END;
 END {IsCarDay};

 PRIVATE PROCEDURE GetTim(Idx: NUMERIC[0]): NUMERIC[3];
 BEGIN
  IF    Idx = 0 THEN
   RETURN D_CarTb.CarTb_GetTimWJT(CarTb.BoxNbr, CarTb.Date, L_Way.WJType_Work);
  ELSIF Idx = 1 THEN
   RETURN D_CarTb.CarTb_GetTimWJT(CarTb.BoxNbr, CarTb.Date, L_Way.WJType_Repair);
  ELSIF Idx = 2 THEN
   RETURN D_CarTb.CarTb_GetTimWJT(CarTb.BoxNbr, CarTb.Date, L_Way.WJType_Stand);
  ELSIF Idx = 3 THEN
   RETURN 0;
  ELSE
   L_General.ConsultToUs(0, "Error in GetTim");
  END;
 END {GetTim};

 PRIVATE PROCEDURE _TimeStr(t: NUMERIC[3]): STRING[];
 BEGIN
  IF t # 0 THEN
   RETURN FLDTOSTR(t, "3.");
  ELSE
   RETURN "";
  END;
 END {_TimeStr};

 PRIVATE PROCEDURE _DayStr(d: NUMERIC[0]): STRING[];
 BEGIN
  IF d # 0 THEN
   RETURN FLDTOSTR(d, "0");
  ELSE
   RETURN "";
  END;
 END {_DayStr};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);

 OPENREP(R, L_General.NameConnection(RepName), Create);
 ACCESS(Car);
 SAVE(Car);
 D_CarTb.Prepare_CarTb(Memo.ud_fr(), Memo.ud_ut(), 1);
 RESTORE(Car);
 L_Car.AccessMark(Car.BoxNbr, Memo.ud_ut());
 MAKEPART(R, Top);

 SETZERO(C_Run__, C_Tim, C_Day, totDIO);

 SELECT(CarLog, BoxNbr, , Car.BoxNbr);
 IF ~SRCINSEL(CarLog, LE, Memo.ud_fr()) THEN
  FIRST(CarLog);
 END;
 WHILE OCCURE(CarLog) & (CarLog.Date <= Memo.ud_ut()) DO
  IF CarLog.Status = L_Car.carst_InOperat THEN

   INC(totDIO, L_DatTim.DATEINT(Memo.ud_fr(), Memo.ud_ut(), CarLog.Date, CarLog.DateE));
   SELECT(CarTb, BoxNbr, , CarLog.BoxNbr);
   SRCINSEL(CarTb, GE, , CarLog.Date);
   WHILE OCCURE(CarTb) & (CarTb.Date<=CarLog.DateE) DO
    PROMPT(": "+L_DatTim.DateStr(CarTb.Date));
    CHANGESEL(CarTb, BoxNbr, , Car.BoxNbr, CarTb.Date);
    LAST(CarTb);
    CHANGESEL(CarTb, BoxNbr, , Car.BoxNbr);
  
    Run__ :=D_CarTb.CarTb_GetRunTot(CarTb.BoxNbr, CarTb.Date);
    INC(C_Run__, Run__);
  
    i:=0;
    WHILE i < 4 DO
     Tim[i]:=GetTim(i);
     Day[i]:=IsCarDay(i);
     INC(C_Tim[i], Tim[i]);
     INC(C_Day[i], Day[i]);
     INC(i);
    END;
  
    MAKEPART(R, Line, _TimeStr(Tim[0]), _TimeStr(Tim[1]), _TimeStr(Tim[2]),
                      Day[0],           Day[1],           Day[2],          Day[3]);
    NEXT(CarTb);
   END; (* WHILE OCCURE(CarTb) ... *)
  END; (* IF CarLog.Status *)
  NEXT(CarLog);
 END; (* WHILE OCCURE(CarLog) *)

 C_DIO:=C_Day[0]+C_Day[1]+C_Day[2];
 L_General.Assert(totDIO>=C_DIO, "  宧⢥  祬  ");
 IF totDIO>C_DIO THEN
  C_Day[3]:=totDIO-C_DIO;
 END;
 MAKEPART(R, Bot, _TimeStr(C_Tim[0]), _TimeStr(C_Tim[1]), _TimeStr(C_Tim[2]),
                  _DayStr(C_Day[0]),  _DayStr(C_Day[1]),  _DayStr(C_Day[2]), _DayStr(C_Day[3]));
 CLOSEREP(R);
 D_CarTb.Purge_CarTb();
END.