(*
%Copyright   (c) Polak Computer System
%Author      28.09.2000 14:37:28 BOR
%Purpose      ઠ   ॢ
%Type        report
%Specific    AP
%Modified    18.02.2013 11:37:41 POLAK\MLB
%Environment
*)

 IMPORT Memo, L_General, L_DatTim, D_CarTb, L_AFM, E_Way, L_Basis, FIO,
        L_Env, L_Car, L_Way, L_Str, L_bp;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ﭨ");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " /");
  L_Basis.wb_WrInQM(F, "⢮");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "/  宧⢥");
  L_Basis.wb_WrInQM(F, "/  ६");
  L_Basis.wb_WrInQM(F, "/  ࠡ");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]; EPer: DATE);
 BEGIN
  L_Basis.wb_WrScl(F, CarT2.BoxNbr);
  L_General.Assert(SEARCH(CarLog, BoxNbr, CarT2.BoxNbr, CarT2.clDate), "  CarLog: . "+CarT2.BoxNbr+" "+L_DatTim.DateStr(CarT2.clDate));
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Car.purp_Pool, CarLog.Purpose));
  L_Car.AccessMark(CarLog.BoxNbr, CarLog.Date);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, L_Basis.ExclQM(Mark.Name));
  CONFORM(CarLog, Column);
  L_Basis.wb_WrScl(F, Column.Column);
  L_Basis.wb_WrStr(F, Column.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(" ᯫ| ᯫ|뫮", CarLog.Status));
  IF ~!CarT2.TKind THEN
   CONFORM(CarT2, TKind);
   L_Basis.wb_WrStr(F, TKind.TKind);
   L_Basis.wb_WrStr(F, L_Basis.ExclQM(TKind.Name));
  ELSE
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "--");
  END;
  L_Basis.wb_WrStr(F, D_CarTb.CarTb_DtlRCarDayName(CarT2.DtlRCD));
  L_Basis.wb_WrNum(F, CarT2.Amount, 4);
  L_Basis.wb_WrDat(F, CarT2.Date);
  L_Basis.wb_WrStr(F, L_Way.E_ConvertWDStr(EPer, CarT2.WD));
  L_General.ConsultToUs(SEARCH(MarkG, MarkG,
                               L_Way.GetMarkG(Mark.Mark, L_Way.mgt_TEP)),
                        "MakePart.Error 1");
  L_Basis.wb_WrStr(F, MarkG.MarkG);
  L_Basis.wb_WrStr(F, L_Basis.ExclQM(MarkG.Name));
  L_Basis.wb_WrNum(F, CarT2.Run, 2);
  L_Basis.wb_WrNum(F, CarT2.RCarDays[D_CarTb.rcd_Fictive],3);
  L_Basis.wb_WrNum(F, CarT2.RCarDays[D_CarTb.rcd_Repair], 3);
  L_Basis.wb_WrNum(F, CarT2.RCarDays[D_CarTb.rcd_Line],   3);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE Create_CarT2();
 BEGIN
  CreateFILE(CarT2, "", " ઠ", "");

  CreateFIELD(CarT2, BoxNbr,   LIKE(Car.BoxNbr),      "", "", "", "ࠦ", "");
  CreateFIELD(CarT2, clDate,   DATE,                  "", "", "", " CarLog.Date", "");
  CreateFIELD(CarT2, WD,       L_DatTim.tWeekday,     "", "", "", "ਢ  ", "");
  CreateFIELD(CarT2, Date,     DATE,                  "", "", "", "", "");
  CreateFIELD(CarT2, TKind,    LIKE(TKind.TKind),     "", "", "", " ॢ", "");
  CreateFIELD(CarT2, DtlRCD,   D_CarTb.DtlRCDType,    "", "0", "", " /", "");
  CreateFIELD(CarT2, Amount,   NUMERIC[12, 4],        "", "0", "", "- /", "");
  CreateFIELD(CarT2, Run,      NUMERIC[8, 2],         "", "", "", "஡", "");
  CreateFIELD(CarT2, RCarDays, NUMERIC[3][100],       "", "0", "", "設", "");

  CreateINDEXandLINK(CarT2, BoxNbr, UNIQUE, Car, BoxNbr, USER, "", "", BoxNbr, clDate, WD, TKind, DtlRCD, Date);
  CreateINDEXandLINK(CarT2, TKind, PLURAL,TKind, TKind,  USER, "", "", TKind);

  SetVersionOfFILE(CarT2, 0);
  L_AFM.AF_CreateTemp("CarT2", "CarT2");
 END {Create_CarT2};

 PRIVATE PROCEDURE PutToCarT2(_TKind : LIKE(TKind.TKind);
                      _DtlRCD: D_CarTb.DtlRCDType;
                      _Amount: NUMERIC[4];
                      _Run   : NUMERIC[2]);
 BEGIN
  ADD(CarT2, BoxNbr, , Car.BoxNbr, CarLog.Date,
                       L_Way.E_ConvertWD(Calendar.Date, Calendar.WDWay), _TKind, _DtlRCD, Calendar.Date,
      CarT2.Amount, _Amount,
      CarT2.Run, _Run,
      CarT2.RCarDays[D_CarTb.CarTb_RCarDay(_DtlRCD)], 1,
      CarT2.RCarDays[D_CarTb.rcd_Fictive], _DtlRCD=D_CarTb.dtlRCD_InState(* 宧⢥*));
 END {PutToCarT2};

 PUBLIC PROCEDURE ShDtl();
  CONST
   bpId = "ShDtl";
  VAR
   BPer, EPer: DATE;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);

  L_bp.Begin(bpId, " ઠ  ⠫樥 設", L_bp.t_Basis, L_General.tc_inIntvl);

  BPer:=Memo.ud_fr();
  EPer:=Memo.ud_ut();
  D_CarTb.Prepare_CarTb(BPer, EPer, 0);
 
  Create_CarT2();

  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   IF L_Env.RealBoxNbr(Car.BoxNbr) THEN
    SELECT(Calendar, Date);
    SRCINSEL(Calendar, GE, , BPer);
    WHILE OCCURE(Calendar) & (Calendar.Date <= EPer) DO
     PROMPT(": " + Car.BoxNbr + ", " + L_DatTim.DateStr(Calendar.Date));
     IF L_Car.CarIsInOperation(Car.BoxNbr, Calendar.Date) THEN
      SELECT(CarTb, BoxNbr, , Car.BoxNbr, Calendar.Date);
      HISTCONF(Calendar.Date, Car, CarLog);

      PutToCarT2(CarLog.TKind, D_CarTb.dtlRCD_InState, 1, 0);
      PutToCarT2(CarLog.TKind, D_CarTb.dtlRCD_Inventory, 1/(EPer-BPer+1), 0);
      IF OCCURE(CarTb) THEN
       PutToCarT2(D_CarTb.CarTb_DominantTKind(Car.BoxNbr, Calendar.Date),
                  E_Way.DtlRCarDay(Car.BoxNbr, Calendar.Date),
                  1,
                  D_CarTb.CarTb_GetRunTot(Car.BoxNbr, Calendar.Date));
      ELSE
       PutToCarT2(CarLog.TKind, D_CarTb.dtlRCD_NoData, 1, 0);
      END;
     ELSIF L_Car._StandOnCarLog(Car.BoxNbr, Calendar.Date) & (CarLog.Status = L_Car.carst_Retired) THEN
      L_General.Assert(~SELECT(CarTb, BoxNbr, Car.BoxNbr, Calendar.Date), "㤠 ଠ  ᯨᠭ : . "+Car.BoxNbr+"  "+L_DatTim.DateStr(Calendar.Date));
     END;
     NEXT(Calendar);
    END; (* WHILE OCCURE(Calendar) ... *)
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)

  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
  SELECT(CarT2, BoxNbr);
  WHILE OCCURE(CarT2) DO
   PROMPT("㧪: " + CarT2.BoxNbr);
   MakePart("R", EPer);
   NEXT(CarT2);
  END; (* WHILE OCCURE(CarT2) ... *)
  L_AFM.AF_PurgeTemp("CarT2");
  D_CarTb.Purge_CarTb();
  FIO.Close(R);

  L_bp.End();
 END {ShDtl};

END.
