(*
%Copyright   (c) Polak IT
%Author      04.07.2003 15:15:26 POLAK\LDA
%Purpose      ઠ
%Type        report
%Specific    AP
%Modified    20.12.2013 16:37:12 POLAK\Bor
%Environment
*)

 MODULE ShPark [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, D_CarTb, E_Way, L_Env, L_AFM, L_Car, L_Str, L_DatTim,
        P_Firm, Str;

 PRIVATE CONST
  RepName = "ShPar";

  dt_InPark  = 0;
  dt_Work    = 1;
  dt_Repair  = 2;
  dt_Reserve = 3;

 PRIVATE VAR
  IntvlB,
  IntvlE: DATE;

(*
$P{ TopCst:
P_Firm.MyFirmName(P_Firm.curMyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
################################################################################################# ########## #####
}
*)

(*
$P{ Top:
RepName, L, ""
IntvlB, L, "D.N.y"
IntvlE, L, "D.N.y"
@
=#####============================================================================================================
|                                 ઠ  ਮ  ##########  ##########                               |
}
*)

(*
$P{ Column:
Column.Column, L, ""
Column.Name, L, ""
@
|================================================================================================================|
| ## ################################                                                                     |
}
*)

(*
$P{ Mark:
CarT2.Mark, L, ""
Mark.Name, L, ""
@
|----------------------------------------------------------------------------------------------------------------|
|ઠ #### #############################################                                                        |
|----------------------------------------------------------------------------------------------------------------|
|.|. ॣ. | | | | | | | | | |1|1|1|1|1|1|1|1|1|1|2|2|2|2|2|2|2|2|2|2|3|3|     || ..||- |
|.|      |1|2|3|4|5|6|7|8|9|0|1|2|3|4|5|6|7|8|9|0|1|2|3|4|5|6|7|8|9|0|1|宧-|      |१|      |⮩   |
|----|----------|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|------|------|------|------|------|
}
*)

(*
$P{ Line_1:
CarT2.BoxNbr, L, ""
Car.StateNbr, L, ""
@
|####|##########}
*)

(*
$P{ Line_2:
?, L, ""
@
|#}
*)

(*
$P{ Line_3:
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
@
|######|######|######|######|######|
}
*)

(*
$P{ Bot:
?, L, ""
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
@
|-----------------------------------------------------------------------------|------|------|------|------|------|
|##########################                                                   |######|######|######|######|######|
}
*)

(*
$P{ Dlm:
@
=(c) Polak========================================================================================================
}
*)

 PRIVATE PROCEDURE GetDaySign(_CarDay: D_CarTb.RCDType): STRING[1];
 BEGIN
  IF    _CarDay = D_CarTb.rcd_Line THEN
   RETURN "+";
  ELSIF _CarDay = D_CarTb.rcd_Repair THEN
   RETURN "";
  ELSIF _CarDay = D_CarTb.rcd_Reserv THEN
   RETURN "";
  ELSE
   RETURN "";
  END;
 END {GetDaySign};

 PRIVATE PROCEDURE Create_CarT2();
 BEGIN
  CreateFILE(CarT2, "", " ઠ", "");

  CreateFIELD(CarT2, Column, LIKE(CarLog.Column), "", "",  "", "", "");
  CreateFIELD(CarT2, Mark,   LIKE(CarLog.Mark),   "", "",  "", "ઠ", "");
  CreateFIELD(CarT2, BoxNbr, LIKE(Car.BoxNbr),    "", "",  "", "ࠦ", "");
  CreateFIELD(CarT2, C_Day,  NUMERIC[0][4],       "", "0", "", " ( 宧-,  , ࠡ, ६-, )", "");
  CreateFIELD(CarT2, Sign,   STRING[1][31],       "", "",  "", "祭  ", "");

  CreateINDEXandLINK(CarT2, BoxNbr, PLURAL, Car,  BoxNbr, USER, "", "", BoxNbr);
  CreateINDEXandLINK(CarT2, Mark,   PLURAL, Mark, Mark,   USER, "", "", Mark);
  CreateINDEX       (CarT2, Column, UNIQUE,                     "", "", Column, Mark, BoxNbr);

  SetVersionOfFILE(CarT2, 0);
  L_AFM.AF_CreateTemp("CarT2", "CarT2");
 END {Create_CarT2};

 PRIVATE PROCEDURE CountSums(VAR Arr1: NUMERIC[0][];
                                 Arr2: NUMERIC[0][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(Arr1) DO
   INC(Arr1[i], Arr2[i]);
   INC(i);
  END; (* WHILE i <= HIGH(Arr1)...*)
 END {CountSums};

 PRIVATE PROCEDURE E_Make(P: PROC);
 BEGIN
  IF ~!P THEN
   P();
  END;
 END {E_Make};

 PRIVATE PROCEDURE PrintRep();
  VAR
   M_Day,
   L_Day,
   F_Day : NUMERIC[0][4];
   i     : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("");
  OPENREP(R, L_General.NameConnection(RepName), Create, RightMargin, 0);
  MAKEPART(R, TopCst);
  E_Make(PROCREF(E_Way.ShPar_MakeTopSigns));
  MAKEPART(R, Top);
  SETZERO(F_Day);
  SELECT(CarT2, Column);
  WHILE OCCURE(CarT2) DO
   PROMPT(". " + CarT2.BoxNbr);
   L_General.ConsultToUs(SEARCH(Column, Column, CarT2.Column), "   "+CarT2.Column);
   MAKEPART(R, Column);
   SETZERO(L_Day);
   NARROWSEL(CarT2, Column);
   WHILE OCCURE(CarT2) DO
    CONFORM(CarT2, Mark);
    MAKEPART(R, Mark);
    SETZERO(M_Day);
    NARROWSEL(CarT2, Mark);
    WHILE OCCURE(CarT2) DO
     CONFORM(CarT2, Car);
     MAKEPART(R, Line_1);
     i:=0;
     WHILE i <= HIGH(CarT2.Sign) DO
      MAKEPART(R, Line_2, CarT2.Sign[i]);
      INC(i);
     END; (* WHILE i <= HIGH(CarT2.Sign)...*)
     MAKEPART(R, Line_3, CarT2.C_Day[dt_InPark], CarT2.C_Day[dt_Work], CarT2.C_Day[dt_Reserve], CarT2.C_Day[dt_Repair],
                         CarT2.C_Day[dt_InPark] - CarT2.C_Day[dt_Work] - CarT2.C_Day[dt_Repair]);
     CountSums(M_Day, CarT2.C_Day);
     NEXT(CarT2);
    END; (* WHILE OCCURE(CarT2) ... *)
    MAKEPART(R, Bot, "ᥣ  થ",
                     M_Day[dt_InPark], M_Day[dt_Work], M_Day[dt_Reserve], M_Day[dt_Repair],
                     M_Day[dt_InPark] - M_Day[dt_Work] - M_Day[dt_Repair]);
    CountSums(L_Day, M_Day);
    NEXTINEXTENDEDSEL(CarT2, Mark);
   END; (* WHILE OCCURE(CarT2) ... *)
   MAKEPART(R, Bot, "ᥣ  ",
                    L_Day[dt_InPark], L_Day[dt_Work], L_Day[dt_Reserve], L_Day[dt_Repair],
                    L_Day[dt_InPark] - L_Day[dt_Work] - L_Day[dt_Repair]);
   CountSums(F_Day, L_Day);
   NEXTINEXTENDEDSEL(CarT2, Column);
  END; (* WHILE OCCURE(CarT2) ... *)
  MAKEPART(R, Bot, "ᥣ  ",
                   F_Day[dt_InPark], F_Day[dt_Work], F_Day[dt_Reserve], F_Day[dt_Repair],
                   F_Day[dt_InPark] - F_Day[dt_Work] - F_Day[dt_Repair]);
  MAKEPART(R, Dlm);
  E_Make(PROCREF(E_Way.ShPar_MakeBotSigns));
 END {PrintRep};

 PRIVATE PROCEDURE MakeIndex();
  VAR
   CarDay: D_CarTb.RCDType;
   i     : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("");
  D_CarTb.Prepare_CarTb(IntvlB, IntvlE, 0);
  Create_CarT2();
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(". "+Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) THEN
    SELECT(CarLog, BoxNbr, , Car.BoxNbr);
    IF ~SRCINSEL(CarLog, LE, IntvlB) THEN
     FIRST(CarLog);
    END;
    WHILE OCCURE(CarLog) & (CarLog.DateE >= IntvlB) DO
     IF CarLog.Status = L_Car.carst_InOperat THEN
      CONFORM(CarLog, Column);
      IF Column.MyFirm = P_Firm.curMyFirm THEN
       ADD(CarT2, Column, , CarLog.Column, CarLog.Mark, Car.BoxNbr,
           CarT2.C_Day[dt_InPark], L_DatTim.DATEINT(CarLog.Date, CarLog.DateE, IntvlB, IntvlE));
       SETSEL(CarTb, BoxNbr, Car.BoxNbr);
       SRCINSEL(CarTb, GE, , CarLog.Date);
       WHILE OCCURE(CarTb) & (CarTb.Date<=CarLog.DateE) DO
        NARROWSEL(CarTb, Date);
        CarDay:=D_CarTb.CarTb_RCarDay(E_Way.DtlRCarDay(Car.BoxNbr, CarTb.Date));
        IF    (CarDay = D_CarTb.rcd_Line) THEN
         INC(CarT2.C_Day[dt_Work]);
        ELSIF (CarDay = D_CarTb.rcd_Repair) THEN
         INC(CarT2.C_Day[dt_Repair]);
        ELSIF (CarDay = D_CarTb.rcd_Reserv) THEN
         INC(CarT2.C_Day[dt_Work]);
         INC(CarT2.C_Day[dt_Reserve]);
        END;
        CarT2.Sign[L_DatTim.DAY(CarTb.Date)-1]:=GetDaySign(CarDay);
        REPLACE(CarT2);
        NEXTINEXTENDEDSEL(CarTb, Date);
       END; (* WHILE OCCURE(CarTb) ... *)
      END; (* IF Column.MyFirm = P_Firm.curMyFirm  ... *)
     END; (* IF CarLog.Status ... *)
     NEXT(CarLog);
    END; (* WHILE OCCURE(CarLog) ... *)
   END; (* IF L_Env.RealBoxNbr... *)
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {MakeIndex};

 PUBLIC PROCEDURE ShPar();
 BEGIN
  APP.Get().NewPrompt("("+RepName+")");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  P_Firm.SetCurMyFirm();
  IntvlB:=Memo.ud_mb();
  IntvlE:=Memo.ud_cd();
  MakeIndex();
  PrintRep();
  L_AFM.AF_PurgeTemp("CarT2");
  D_CarTb.Purge_CarTb();
  L_General.SurveyLastReport();
 END {ShPar};

END.
