(*
%Copyright   (c) Polak Computer System
%Author      01.09.1999 12:52:33 RSN
%Purpose       ᯨ  ࢠ
%Type        report
%Specific    AP
%Modified    10.04.2012 12:07:05 ROBOT by POLAK\LDA
%Environment  ⮬
*)

 IMPORT L_OwnData, P_Car, Memo, L_Way, L_General;

 CONST
  c_Broken    = 0;
  c_Correct   = 1;
  c_BreakTrip = 2;

 VAR
  Chain     : SCAL[3];
  _SMBef    : LIKE(RWayS.SMBef);
  _SMAft    : LIKE(RWayS.SMAft);
  _RunSM    : NUMERIC[2];
  _RunPL    : NUMERIC[2];
  _Dif      : NUMERIC[2];

  s_RunSM   : NUMERIC[2];
  s_RunPL   : NUMERIC[2];
  s_Dif     : NUMERIC[2];

(*
$P {Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.From(), L, "D.N.y"
Memo.UpTo(), L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|        ᯨ  ਮ  ##########  ##########       |
|----------------------------------------------------------------------------|
}
$P {C_Header:
Car.BoxNbr, L, ""
Car.StateNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
@
|#### ########## ઠ: #### ################################                |
|----------------------------------------------------------------------------|
|      |. |. |  륧||-  .|-  /|  +/- (%)||
|----------|-------|-----|-------|-------|-----------|-----------|---------|-|
}
$P {Line:
RWayS.Date, L, "D.N.y"
RWayS.RWayS, L, ""
?, L, ""
RWayS.SMBef, R, "0"
RWayS.SMAft, R, "0"
_RunSM, R, "1."
_RunPL, R, "1."
_Dif, R, "2."
Chain, C, "*| |"
@
|##########|#######|#####|#######|#######|###########|###########| ########|#|
}

$P {Itog:
s_RunSM, R, "1."
s_RunPL, R, "1."
s_Dif, R, "2."
@
|------------------------|-------|-------|-----------|-----------|---------|-|
|⮣                                   |###########|###########|#########| |
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE GetPrc(_rSM, _rPL: NUMERIC[2]): NUMERIC[3];
 BEGIN
  IF _rPL # 0 THEN
   RETURN (_rSM -_rPL) / _rPL * 100;
  ELSE
   RETURN 0;
  END;
 END {GetPrc};

 PRIVATE PROCEDURE SingleRW();
 BEGIN
  IF RWayS.Status = L_Way.rwsStat_Rated THEN
   PROMPT("⥢  # " + RWayS.RWayS);
   IF !_SMAft | (RWayS.SMBef = _SMAft) THEN
    Chain:=c_Correct;
   ELSE
    Chain:=c_Broken;
   END;
   _SMAft:=RWayS.SMAft;
   SETZERO(_RunSM, _RunPL, _Dif);
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayJ) DO
    INC(_RunPL, RWayJ.Run * RWayJ.Fact);
    IF (RWayJ.Trip = L_Way.E_TripForSMChainBreak(RWayS.Date)) THEN
     Chain:=c_BreakTrip;
    END;
    NEXT(RWayJ);
   END;(* WHILE OCCURE(RWayJ)... *)
   INC(s_RunPL, _RunPL);
   IF Chain # c_BreakTrip THEN
    INC(_RunSM, L_Way.RunBySM() * P_Car.GetP_SMCor(Car.BoxNbr, RWayS.Date));
    INC(s_RunSM, _RunSM);
    _Dif:=GetPrc(_RunSM, _RunPL);
   ELSE
    SETEMPTY(_RunSM, _Dif);
   END;
   MAKEPART(T, Line, RWayS.TSN);
  END;
 END {SingleRW};

 CONST
  RepName = "SMObj";

BEGIN
 L_General.Assert(ACCESS(Car), " ⠭ ⮬");

 OPENREP (T, L_General.NameConnection(RepName), Create);
 CONFORM(Car, Mark);
 MAKEPART(T, Top, RepName);
 MAKEPART(T, C_Header);
 SELECT(RWayS, BoxNbr, , Car.BoxNbr);
 SRCINSEL(RWayS, GE, , Memo.From());
 SETZERO(s_RunSM, s_RunPL, s_Dif);
 SETEMPTY(_SMAft);
 WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.UpTo()) DO
  SingleRW();
  NEXT(RWayS);
 END; (* WHILE *)
 s_Dif:=GetPrc(s_RunSM, s_RunPL);
 MAKEPART(T, Itog);
 CLOSEREP(T);
END.