(*
%Copyright   (c) Polak IT
%Author      15.07.2010 13:37:32 POLAK\GAV
%Purpose
%Type        control
%Specific    AP
%Modified    07.12.2010 20:11:15 POLAK\GAV
%Environment
*)

 IMPORT L_Events, L_TRS, L_General, L_AFM, L_Basis, L_Str, L_bp, FIO, Memo;

 PRIVATE PROCEDURE SnTckTrf_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurWindow.ActiveZone.Fields.Item("SnTckTrf.Type").Format:=L_TRS.sttt_Pool;
 END {SnTckTrf_1_OnZoneOpen};

 PRIVATE PROCEDURE SnTckTrf_OnAfterEdIns();
 BEGIN
  CONFORM(SnTckTrf, TckKind);
  IF TckKind.Type = L_TRS.tkt_ZonalTicket THEN
   L_General.Assert(SnTckTrf.Price <= TckKind.FaceVal, "       ");
  ELSE
   L_General.Assert(SnTckTrf.Price = TckKind.FaceVal, "  ࠢ   ");
  END;
  CONFORM(SnTckTrf, SnTckRng);
  SnTckTrf.strName:=SnTckRng.Name;
  REPLACE(SnTckTrf);
 END {SnTckTrf_OnAfterEdIns};

 PRIVATE PROCEDURE SnTckTrf_OnAfterEdit();
 BEGIN
  SnTckTrf_OnAfterEdIns();
 END {SnTckTrf_OnAfterEdit};

 PRIVATE PROCEDURE SnTckTrf_OnAfterInsert();
 BEGIN
  SnTckTrf_OnAfterEdIns();
 END {SnTckTrf_OnAfterInsert};

 PRIVATE PROCEDURE SnTckRng_OnAfterEdit();
 BEGIN
  IF SnTckRng.Name # GE_PVALUE(SnTckRng.Name) THEN
   SELECT(SnTckTrf, SnTckRng, , SnTckRng.SnTckRng);
   WHILE OCCURE(SnTckTrf) DO
    SnTckTrf.strName:=SnTckRng.Name;
    REPLACE(SnTckTrf);
    NEXT(SnTckTrf);
   END; (* WHILE OCCURE(SnTckTrf) ... *)
  END;
 END {SnTckRng_OnAfterEdit};

 PRIVATE PROCEDURE SnT01_MakeLine(F: STRING[]; isTop: SCAL[2]);
 BEGIN
  IF isTop THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  ELSE
   CONFORM(SnTck, Storage);
   CONFORM(Storage, StrgKind);
   L_Basis.wb_WrScl(F, Storage.Storage);
   L_Basis.wb_WrStr(F, Storage.Sign);
   L_Basis.wb_WrStr(F, Storage.Name);
   L_Basis.wb_WrStr(F, StrgKind.Name);
  END;
  IF isTop THEN
   L_Basis.wb_WrInQM(F, "");
  ELSE
   L_Basis.wb_WrDat(F, SnTck.Date);
  END;
  IF isTop THEN
   L_Basis.wb_WrInQM(F, "த");
  ELSE
   L_Basis.wb_WrStr(F, L_Str.PoolItem(" |ࠣ|⭨|稪", SnTck.SaleType));
  END;
  IF isTop THEN
   L_Basis.wb_WrInQM(F, "섥⢨");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  ELSE
   CONFORM(SnTck, SnTckTrf);
   CONFORM(SnTckTrf, SnTckRng);
   L_Basis.wb_WrStr(F, SnTckRng.Name);
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_TRS.sttt_Pool, SnTckTrf.Type));
   L_Basis.wb_WrNum(F, SnTckTrf.Price, 2);
  END;
  IF isTop THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  ELSE
   CONFORM(SnTckTrf, TckKind);
   L_Basis.wb_WrStr(F, TckKind.TckKind);
   L_Basis.wb_WrStr(F, TckKind.Name);
  END;
  IF isTop THEN
   L_Basis.wb_WrInQM(F, "⢮");
   L_Basis.wb_WrInQM(F, "㬬");
  ELSE
   L_Basis.wb_WrNum(F, SnTck.Cnt, 0);
   L_Basis.wb_WrNum(F, SnTck.Sum, 2);
  END;
  L_Basis.wb_TermLine(F);
 END {SnT01_MakeLine};

 PRIVATE PROCEDURE Create_SnTck();
 BEGIN
  CreateFILE(SnTck);

  CreateFIELD(SnTck, Storage,  LIKE(Storage.Storage));
  CreateFIELD(SnTck, Date,     DATE);
  CreateFIELD(SnTck, SnTckTrf, LIKE(SnTckTrf.SnTckTrf));
  CreateFIELD(SnTck, SaleType, SCAL[4]);
  CreateFIELD(SnTck, Cnt,      NUMERIC[0], , "0");
  CreateFIELD(SnTck, Sum,      NUMERIC[2], , "0");

  CreateINDEX(SnTck, SnTck, UNIQUE, "", "", Storage, Date, SnTckTrf, SaleType);
  CreateINDEXandLINK(SnTck, Storage,  PLURAL, Storage,  Storage,  USER, "", "", Storage);
  CreateINDEXandLINK(SnTck, SnTckTrf, PLURAL, SnTckTrf, SnTckTrf, USER, "", "", SnTckTrf);

  SetVersionOfFILE(SnTck, 2);
  L_AFM.CreateTemp("SnTck");
 END {Create_SnTck};

 PUBLIC PROCEDURE SnT01_Make();
  CONST
   bpId = "SnT01";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, " த  ஥ ⮢", L_bp.t_Basis, L_General.tc_inIntvl);
 
  Create_SnTck();
  SELECT(TckRcD, Type, , L_TRS.trdt_Sale);
  SRCINSEL(TckRcD, LE, , Memo.ud_ut());
  WHILE OCCURE(TckRcD) & (TckRcD.Date >= Memo.ud_fr()) DO
   PROMPT(TckRcD.TckRcD);
   IF TckRcD.Status # L_TRS.trdStat_Canceled THEN
    SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
    WHILE OCCURE(TckRcDL) DO
     SELECT(TckRcDLL, TckRcD, , TckRcDL.TckRcD, TckRcDL.TRDLNbr);
     WHILE OCCURE(TckRcDLL) DO
      ADD(SnTck, SnTck, , TckRcD.Storage, TckRcD.Date, TckRcDLL.SnTckTrf, L_TRS.TckRcDSaleType(),
             SnTck.Cnt, 1,
             SnTck.Sum, TckRcDLL.Sum);
      NEXT(TckRcDLL);
     END; (* WHILE OCCURE(TckRcDLL) ... *)
     NEXT(TckRcDL);
    END; (* WHILE OCCURE(TckRcDL) ... *)
   END;
   PREV(TckRcD);
  END; (* WHILE OCCURE(TckRcD) ... *)

  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  SnT01_MakeLine("F", 1);
  SELECT(SnTck, SnTck);
  WHILE OCCURE(SnTck) DO
   PROMPT(SnTck.Storage);
   SnT01_MakeLine("F", 0);
   NEXT(SnTck);
  END; (* WHILE OCCURE(SnTck) ... *)
  FIO.Close(F);
  L_bp.End();
 END {SnT01_Make};

BEGIN
 IF L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSE
  L_General.BadMode(MODE);
 END;
END.