(*
%Copyright   (c) Polak IT
%Author      26.04.2002 14:35:48 SAN
%Purpose      ﭨ Show
%Type        operation
%Specific    AP
%Modified    23.09.2014 13:42:15 POLAK\LDA
%Environment
*)

 MODULE StatusMap [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, FIO, Str, L_Str, L_Rpr, L_Car, P_Firm, Math, L_DatTim, L_Env,
        L_RT, L_XDoc, L_BegRWS, L_Way, L_StdFrm, L_BarCode, L_FIO, L_AR, L_Staff,
        L_GUI, L_Math, L_ACL,  P_Sort, P_Column;

 PUBLIC CONST
  sm_Car  = 0;
  sm_Exit = 1;

 PRIVATE TYPE
  tShowMode = SCAL[2];
  tb_Color  = RGBCOLOR[100];

 PRIVATE PERMANENT VAR
  ShowMode     : tShowMode;
  MapIsLoad    : SCAL[2][MAXOF(tShowMode)+1];

  cs_SortCar   : SCAL[1E2];
  csf_Purpose  : LIKE(CarLog.Purpose);
  csf_Column   : LIKE(CarLog.Column);
  csf_Dprt     : NUMERIC[0];

  csf_State    : NUMERIC[0][MAXOF(tShowMode)+1];
  csf_Status   : LIKE(rtExit.Status);
  HRT_RenewCar,
  HRT_RenewExit: FLOAT;

  curXDocId    : L_XDoc.tXDocId;

 PRIVATE CONST
  p_Main             = "p_Main";
  p_CarMap           = "p_CarMap";
  p_ExitMap          = "p_ExitMap";

  id_Title           = "st_Title";
  id_Totals          = "st_Totals";
  id_Clock           = "st_DateTime";
  id_Prompt          = "st_Prompt";
  id_DispDate        = "st_DispDate";
  id_ShowMode        = "pb_ShowMode";
  id_Legend          = "pb_Legend";
  id_Update          = "pb_Update";
  id_Close           = "pb_Close";
  id_ExitFilters     = "st_ExitFilters";
  id_Dprt            = "e_Dprt";
  id_CarFilters      = "st_CarFilters";
  id_Column          = "e_Column";
  id_Purpose         = "e_Purpose";
  id_Sort            = "st_Sort";
  id_SortCar         = "e_SortCar";
  id_BtnsBorder      = "st_BtnsBorder";
  id_Map             = "st_Map";

  RenewPeriod        = 5*60;

  sW_MainShift       = 4;
  sH_MainShift       = 4;

  sW_ColBtnShift     = 4;
  sH_ColBtnShift     = 4;

  pL_Most            = sW_MainShift;
  pT_Most            = sH_MainShift;
  pR_Most            = L_GUI.normalWidth  - pL_Most;
  pB_Most            = L_GUI.normalHeight - pT_Most;
  sW_Most            = pR_Most - pL_Most;
  sH_Most            = pB_Most - pT_Most;

  fS_Clock           = 19;
  sW_Clock           = 170;
  pL_Clock           = pR_Most - sW_Clock;
  pT_Clock           = pT_Most;
  sH_Clock           = 25;

  fS_DispDate        = 19;
  sW_DispDate        = 190;
  sH_DispDate        = sH_Clock;
  pL_DispDate        = pL_Clock - sW_DispDate - sW_MainShift;
  pT_DispDate        = pT_Most;

  fS_Title           = 19;
  pL_Title           = pL_Most;
  pT_Title           = pT_Most;
  sH_Title           = sH_Clock;
  sW_Title           = sW_Most - sW_DispDate - sW_Clock - 2*sW_MainShift;

  fS_Prompt          = 16;
  pL_Prompt          = pL_Title;
  sH_Prompt          = 20;
  pT_Prompt          = pB_Most - sH_Prompt;
  sW_Prompt          = sW_Most;

  sH_BtnsBorder      = 35;
  pT_BtnsBorder      = pT_Prompt - sH_BtnsBorder - sH_MainShift;

  fS_Buttons         = 13;

  sH_Buttons         = sH_BtnsBorder - 2*sH_MainShift;
  pT_Buttons         = pT_BtnsBorder + sH_MainShift;

  sW_ShowMode        = sW_Most*0.20;
  sW_Legend          = sW_Most*0.12;
  sW_Update          = sW_Most*0.12;
  sW_Close           = sW_Most*0.08;

  sW_BtnsBorder      = sW_MainShift+
                       sW_Close+sW_MainShift+
                       sW_Update+sW_MainShift+
                       sW_Legend+sW_MainShift+
                       sW_ShowMode+
                       sW_MainShift;

  pL_BtnsBorder      = pR_Most - sW_BtnsBorder;

  pL_ShowMode        = pL_BtnsBorder+sW_MainShift;
  pL_Legend          = pL_ShowMode+sW_ShowMode+sW_MainShift;
  pL_Update          = pL_Legend+sW_Legend+sW_MainShift;
  pL_Close           = pL_Update+sW_Update+sW_MainShift;

  pL_AnyFilters      = pL_Most;

  sW_Dprt            = 195;
  pL_Dprt            = pL_AnyFilters + sW_MainShift;
  sW_ExitFilters     = sW_MainShift+sW_Dprt+sW_MainShift;

  sW_Column          = 140;
  pL_Column          = pL_AnyFilters + sW_MainShift;
  sW_Purpose         = 140;
  pL_Purpose         = pL_Column + sW_Column + sW_MainShift;

  sW_CarFilters      = sW_MainShift+sW_Column+sW_MainShift+sW_Purpose+sW_MainShift;

  pL_Sort            = pL_AnyFilters+sW_CarFilters+sW_MainShift;
  sW_Sort            = pL_BtnsBorder-sW_MainShift-pL_Sort;

  pL_SortCar         = pL_Sort+sW_MainShift;
  sW_SortCar         = sW_Sort-sW_MainShift-sW_MainShift;

  sH_LegendBut       = 20;
  sW_LegendBut       = 55;

  sW_Totals          = sW_Most;
  sH_Totals          = 40;
  pL_Totals          = pL_Most;
  pT_Totals          = pT_Title + sH_Title + sH_MainShift;

  sW_Map             = sW_Most;
  sH_Map             = sH_Most - sH_BtnsBorder - sH_Prompt - sH_Title - sH_Totals - 4*sH_MainShift;
  pL_Map             = pL_Most;
  pT_Map             = pT_Totals + sH_Totals + sH_MainShift;

  fS_ColorBtn        = 20;


  rte_st_NormalShutdown     = 0;
  rte_st_Work               = 1;
  rte_st_InPark             = 2;
  rte_st_Ordered            = 3;
  rte_st_GivenCountdown     = 4;
  rte_st_GivenDelay         = 5;
  rte_st_DepartureDelay     = 6;
  rte_st_NotOrdered         = 7;
  rte_st_NotOrderedSuppl    = 8;
  rte_st_NotOrderedInRest   = 9;
  rte_st_EarlyReturn        = 10;
  rte_st_LongTimeAgoReturn  = 11;
  rte_st_ReturnDelay        = 12;
  rte_st_BreakageOnLine     = 13;
  rte_st_TotalAmount        = 14;

 PRIVATE VAR
  dlg              : DIALOG;
  HRT_RenewClock   : FLOAT;
  idleStart        : FLOAT;
  b_ColorCar,
  b_ColorExit      : tb_Color;
  Amount           : NUMERIC[0][100];
  MaxButtonAmount,
  TotalButtonAmount: NUMERIC[0][MAXOF(tShowMode)+1];
  DispDate         : DATE;
  sH_ColorBtn,
  sW_ColorBtn      : NUMERIC[6][MAXOF(tShowMode)+1];
  WhiteColor,
  RedColor,
  BlackColor       : RGBCOLOR;

 PRIVATE PROCEDURE GetTotalAmountState(): NUMERIC[0];
 BEGIN
  IF    ShowMode = sm_Car THEN
   RETURN L_RT.rtc_st_TotalAmount;
  ELSIF ShowMode = sm_Exit THEN
   RETURN rte_st_TotalAmount;
  END;
 END {GetTotalAmountState};

 PRIVATE PROCEDURE SetButtonColors();
  VAR
   bgc_Work,
   bgc_InPark,
   bgc_Ordered,
   bgc_GivenCountdown,
   bgc_GivenDelay,
   bgc_DepartureDelay,
   bgc_EarlyReturn,
   bgc_LongTimeAgoReturn,
   bgc_ReturnDelay,
   bgc_BreakageOnLine,
   bgc_TotalAmount: RGBCOLOR;
 BEGIN
  bgc_Work              := RGBCOLOR.Create(204, 255, 204);
  bgc_InPark            := RGBCOLOR.Create(102, 204, 102);
  bgc_Ordered           := RGBCOLOR.Create(000, 153, 000);
  bgc_GivenCountdown    := RGBCOLOR.Create(255, 204, 204);
  bgc_GivenDelay        := RGBCOLOR.Create(204, 102, 102);
  bgc_DepartureDelay    := RedColor;
  bgc_EarlyReturn       := RGBCOLOR.Create(255, 000, 255);
  bgc_LongTimeAgoReturn := RGBCOLOR.Create(255, 153, 255);
  bgc_ReturnDelay       := RGBCOLOR.Create(255, 255, 000);
  bgc_BreakageOnLine    := RGBCOLOR.Create(000, 255, 255);
  bgc_TotalAmount       := WhiteColor;
  IF    ShowMode = sm_Car THEN
   b_ColorCar[L_RT.rtc_st_Work]             :=bgc_Work;
   b_ColorCar[L_RT.rtc_st_InPark]           :=bgc_InPark;
   b_ColorCar[L_RT.rtc_st_Ordered]          :=bgc_Ordered;
   b_ColorCar[L_RT.rtc_st_GivenCountdown]   :=bgc_GivenCountdown;
   b_ColorCar[L_RT.rtc_st_GivenDelay]       :=bgc_GivenDelay;
   b_ColorCar[L_RT.rtc_st_DepartureDelay]   :=bgc_DepartureDelay;
   b_ColorCar[L_RT.rtc_st_EarlyReturn]      :=bgc_EarlyReturn;
   b_ColorCar[L_RT.rtc_st_LongTimeAgoReturn]:=bgc_LongTimeAgoReturn;
   b_ColorCar[L_RT.rtc_st_ReturnDelay]      :=bgc_ReturnDelay;
   b_ColorCar[L_RT.rtc_st_BreakageOnLine]   :=bgc_BreakageOnLine;
   b_ColorCar[L_RT.rtc_st_Repair]           :=RGBCOLOR.Create(000, 000, 204);
   b_ColorCar[L_RT.rtc_st_TO2]              :=RGBCOLOR.Create(000, 102, 255);
   b_ColorCar[L_RT.rtc_st_LongRepair]       :=RGBCOLOR.Create(102, 204, 255);
   b_ColorCar[L_RT.rtc_st_WaitRepair]       :=RGBCOLOR.Create(153, 204, 255);
   b_ColorCar[L_RT.rtc_st_woRWayS]          :=RGBCOLOR.Create(221, 221, 221);
   b_ColorCar[L_RT.rtc_st_woDriver]         :=RGBCOLOR.Create(128, 128, 128);
   b_ColorCar[L_RT.rtc_st_Reserve]          :=RGBCOLOR.Create(106, 181, 181);
   b_ColorCar[L_RT.rtc_st_TotalAmount]      :=bgc_TotalAmount;
  ELSIF ShowMode = sm_Exit THEN
   b_ColorExit[rte_st_NormalShutdown]       :=RGBCOLOR.Create(255, 255, 204);
   b_ColorExit[rte_st_Work]                 :=bgc_Work;
   b_ColorExit[rte_st_InPark]               :=bgc_InPark;
   b_ColorExit[rte_st_Ordered]              :=bgc_Ordered;
   b_ColorExit[rte_st_GivenCountdown]       :=bgc_GivenCountdown;
   b_ColorExit[rte_st_GivenDelay]           :=bgc_GivenDelay;
   b_ColorExit[rte_st_DepartureDelay]       :=bgc_DepartureDelay;
   b_ColorExit[rte_st_NotOrdered]           :=RGBCOLOR.Create(102, 000, 000);
   b_ColorExit[rte_st_NotOrderedSuppl]      :=RGBCOLOR.Create(153, 060, 000);
   b_ColorExit[rte_st_NotOrderedInRest]     :=RGBCOLOR.Create(255, 153, 000);
   b_ColorExit[rte_st_EarlyReturn]          :=bgc_EarlyReturn;
   b_ColorExit[rte_st_LongTimeAgoReturn]    :=bgc_LongTimeAgoReturn;
   b_ColorExit[rte_st_ReturnDelay]          :=bgc_ReturnDelay;
   b_ColorExit[rte_st_BreakageOnLine]       :=bgc_BreakageOnLine;
   b_ColorExit[rte_st_TotalAmount]          :=bgc_TotalAmount;
  END;
 END {SetButtonColors};

 PRIVATE PROCEDURE Getb_Color(trgState: NUMERIC[0]): RGBCOLOR;
 BEGIN
  IF    ShowMode = sm_Car THEN
   RETURN b_ColorCar[trgState];
  ELSIF ShowMode = sm_Exit THEN
   RETURN b_ColorExit[trgState];
  END;
 END {Getb_Color};

 PRIVATE PROCEDURE GetShowModeList(): STRING[];
 BEGIN
  RETURN " ﭨ | ﭨ 室";
 END {GetShowModeList};

 PRIVATE PROCEDURE GetSortCarList(): STRING[];
 BEGIN
  RETURN " ࠦ| |";
 END {GetSortCarList};

 PRIVATE CONST
  CodeInListDlm = CHR(250);

 PRIVATE PROCEDURE GetColumnList(): STRING[];
  VAR
   ColumnList: STRING[];
 BEGIN
  ColumnList:="|";
  SELECT(rtCar, DDColumn, , DispDate);
  WHILE OCCURE(rtCar) DO
   NARROWSEL(rtCar, Column);
   ColumnList:=ColumnList + "" + CodeInListDlm + rtCar.Column + "|";
   NEXTINEXTENDEDSEL(rtCar, Column);
  END; (* WHILE OCCURE(rtCar) ... *)
  RETURN ColumnList;
 END {GetColumnList};

 PRIVATE PROCEDURE GetDprtList(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="|";
  SELECT(rtExit, DDDprt, , DispDate);
  WHILE OCCURE(rtExit) DO
   NARROWSEL(rtExit, Dprt);
   IF !rtExit.Dprt THEN
    Result:=Result + " ९" + "|";
   ELSE
    CONFORM(rtExit, Sort);
    Result:=Result + Sort.Name + CodeInListDlm + Sort.Sort + "|";
   END;
   NEXTINEXTENDEDSEL(rtExit, Dprt);
  END; (* WHILE OCCURE(rtExit) ... *)
  RETURN Result;
 END {GetDprtList};

 PRIVATE PROCEDURE GetPurposeList(): STRING[];
 BEGIN
  RETURN " |饣 짮|⢥|";
 END {GetPurposeList};

 PRIVATE PROCEDURE GetStatePool(): STRING[];
 BEGIN
  IF    ShowMode = sm_Car THEN
   RETURN " ࠡ" +
         "| થ" +
         "| 拉" +
         "| 뤠  ⠫  30 " +
         "|  뤠祩 " +
         "|  륧 " +
         "| " +
         "|  " + L_Str.IntStr(L_RT.LongTimeAgoLength) + " " +
         "|  ⮬ " +
         "|  " +
         "| ६" +
         "|-2" +
         "|⥫ ६" +
         "|  ६" +
         "| " +
         "| ⥫" +
         "| १ࢥ" +
         "|ᥣ ";
  ELSIF ShowMode = sm_Exit THEN
   RETURN "ଠ쭮 襭 室" +
         "| ࠡ" +
         "| થ" +
         "| 拉" +
         "| 뤠  ⠫  30 " +
         "|  뤠祩 " +
         "|  륧 " +
         "|  拉" +
         "|  拉 - ⥫ 室" +
         "|  拉 - /⮩" +
         "| " +
         "|  " + L_Str.IntStr(L_RT.LongTimeAgoLength) + " " +
         "|  ⮬ " +
         "|  " +
         "|ᥣ 室";
  END;
 END {GetStatePool};

 PRIVATE PROCEDURE NeedInvertButtonCaptionFontColor(trgState: NUMERIC[0]): SCAL[2];
 BEGIN
  IF    ShowMode = sm_Car THEN
   RETURN (trgState = L_RT.rtc_st_Ordered) |
          (trgState = L_RT.rtc_st_Repair)  |
          (trgState = L_RT.rtc_st_woDriver);
  ELSIF ShowMode = sm_Exit THEN
   RETURN (trgState = rte_st_Ordered) |
          (trgState = rte_st_NotOrdered);
  END;
 END {NeedInvertButtonCaptionFontColor};

 PRIVATE PROCEDURE SplitString(Value, lf: STRING[]): STRING[];
  VAR
   i       : NUMERIC[0];
   StrArr  : STRING[][10];
   prpValue: STRING[];
 BEGIN
  SETEMPTY(prpValue);
  Str.Format(StrArr, Value, 60, LEFT);
  i:=0;
  WHILE ~!StrArr[i] DO
   prpValue:=prpValue + StrArr[i] + lf;
   INC(i);
  END; (* WHILE ~!StrArr[i]...*)
  RETURN prpValue;
 END {SplitString};

 PRIVATE PROCEDURE CondExclQM(S      : STRING[];
                              wExclQM: SCAL[2]): STRING[];
 BEGIN
  IF wExclQM THEN
   RETURN L_Str.ExclQM(S);
  ELSE
   RETURN S;
  END;
 END {CondExclQM};

 PRIVATE PROCEDURE psv_RprDA(lf: STRING[];
                             wExclQM: SCAL[2]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="";
  CONFORM(RprS, RprDA);
  WHILE OCCURE(RprDA) DO
   CONFORM(RprDA, RprDfApr, CarBlock);
   Result:=Result + SplitString(CondExclQM(L_Rpr.GetRprDA_AsStr(), wExclQM), lf);
   NEXT(RprDA);
  END; (* WHILE OCCURE(RprDA) ... *)
  RETURN Result;
 END {psv_RprDA};

 PRIVATE PROCEDURE descr_RprS(lf     : STRING[];
                              wExclQM: SCAL[2]): STRING[];
 BEGIN
  RETURN "  " + RprS.RprS + " " + L_DatTim.DateTimeStr(RprS.OrdDate, RprS.OrdTime) + " " +
         lf +
         lf +
         psv_RprDA(lf, wExclQM);
 END {descr_RprS};

 PRIVATE PROCEDURE descr_RprT(lf     : STRING[];
                              wExclQM: SCAL[2]): STRING[];
  VAR
   RprT_Tip,
   RprJ_Tip: STRING[];
 BEGIN
  SETEMPTY(RprT_Tip, RprJ_Tip);
  RprT_Tip:=SplitString(CondExclQM(L_Rpr.GetRprT_AsStr(1), wExclQM), lf);
  CONFORM(RprT, RprJ);
  WHILE OCCURE(RprJ) DO
   CONFORM(RprJ, RprJob);
   CONFORM(RprJob, CarBlock);
   RprJ_Tip:=RprJ_Tip + SplitString(CondExclQM(L_Rpr.GetRprJ_AsStr(), wExclQM), lf);
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ) ... *)
  RETURN RprT_Tip + RprJ_Tip;
 END {descr_RprT};

 PRIVATE PROCEDURE GetSingleRprSDescription(lf     : STRING[];
                                            wExclQM: SCAL[2]): STRING[];
  VAR
   RprS_Tip,
   RprT_Tip: STRING[];
 BEGIN
  SETEMPTY(RprS_Tip, RprT_Tip);
  RprS_Tip :=descr_RprS(lf, wExclQM);
  IF SELECT(RprT, RprS, RprS.RprS) THEN
   WHILE OCCURE(RprT) DO
    IF ~!RprT.RprPlace THEN
     RprT_Tip:=RprT_Tip + descr_RprT(lf, wExclQM);
    END;
    NEXT(RprT);
   END; (* WHILE OCCURE(RprT) ... *)
  END;
  RETURN RprS_Tip + RprT_Tip;
 END {GetSingleRprSDescription};

 PRIVATE PROCEDURE IsRWaySAction(): SCAL[2];
 BEGIN
  RETURN (XDocJrn.Action = L_XDoc.action_begDst)     |
         (XDocJrn.Action = L_XDoc.action_begDstCncl) |
         (XDocJrn.Action = L_XDoc.action_begRcp)     |
         (XDocJrn.Action = L_XDoc.action_begRcpCncl) |
         (XDocJrn.Action = L_XDoc.action_Edit)       |
         (XDocJrn.Action = L_XDoc.action_Insert)     |
         (XDocJrn.Action = L_XDoc.action_AutoEdit)   |
         (XDocJrn.Action = L_XDoc.action_AutoBuild)  |
         (XDocJrn.Action = L_XDoc.action_Reprint)    |
         (XDocJrn.Action = L_XDoc.action_VerifyCC)   |
         (XDocJrn.Action = L_XDoc.action_AutoVerification);
 END {IsRWaySAction};

 PRIVATE PROCEDURE GetSingleRWaySDescription(ExitTime,
                                             EntrTime    : TIME;
                                             VAR BRestDTS: FLOAT[];
                                             VAR ERestDTS: FLOAT[];
                                             lf           : STRING[];
                                             wExclQM,
                                             isStExitShowMode: SCAL[2]): STRING[];
  VAR
   Spaces,
   CarAsStr,
   RWayS_Tip,
   StExitAsStr,
   RestPeriods,
   PostName,
   ActionAsStr: STRING[];
   i          : NUMERIC[0];
   BRestTime,
   ERestTime  : TIME;
 BEGIN
  CONFORM(RWayS, Staff);
  CONFORM(Staff, Man);
  SETEMPTY(StExitAsStr, CarAsStr, RestPeriods);
  i:=0;
  WHILE (i <= HIGH(BRestDTS)) & ~!BRestDTS[i] DO
   UnPkVARIANTDATE(BRestDTS[i], , BRestTime);
   UnPkVARIANTDATE(ERestDTS[i], , ERestTime);
   RestPeriods:=L_Str.AddStrDlm(RestPeriods, ", ") + L_DatTim.TimeStr(BRestTime) + " - " + L_DatTim.TimeStr(ERestTime);
   INC(i);
  END; (* WHILE ~!BRestDTS[i] & (i <= HIGH())...*)
  IF ~!RestPeriods THEN
   RestPeriods:=lf + "஬ : " + RestPeriods;
   Spaces:=L_Str.Repeat(" ", Str.Length("஬ ") - Str.Length("⥫"));
  ELSE
   SETEMPTY(Spaces);
  END;
  IF isStExitShowMode THEN
   CONFORM(RWayS, Car);
   L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
   CarAsStr   :=lf + "      " + Spaces + ": " + RWayS.BoxNbr + " " + Car.StateNbr + " " + CondExclQM(Mark.Name, wExclQM);
  ELSE
   StExitAsStr:=lf + "室   " + Spaces + ": " + StExit.Exit + " " + CondExclQM(StExit.Name, wExclQM);
  END;
  RWayS_Tip:=     "      " + Spaces + ": " + RWayS.RWayS + " " + L_DatTim.DateStr(RWayS.Date) + " (" + L_Str.PoolItem(L_Way.rwsStat_Pool, RWayS.Status) + ")" +
             lf + " " + Spaces + ": " + Route.Route + " " + CondExclQM(Route.Name, wExclQM) +
             StExitAsStr +
             lf + "   " + Spaces + ": " + RWayS.Change +
             lf + "륧   " + Spaces + ": " + L_DatTim.TimeStr(ExitTime) +
             lf + " " + Spaces + ": " + L_DatTim.TimeStr(EntrTime) +
             lf + "⥫" + Spaces + ": " + RWayS.TSN + " " + CondExclQM(Man.Name, wExclQM) +
             CarAsStr +
             RestPeriods +
             lf;
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
  LAST(XDocJrn);
  WHILE OCCURE(XDocJrn) DO
   ActionAsStr:=L_Str.PoolItem(L_XDoc.action_Pool, XDocJrn.Action);
   IF IsRWaySAction() THEN
    ActionAsStr:=ActionAsStr + " ";
   END;
   RWayS_Tip:=      RWayS_Tip +
               lf + Str.Align(ActionAsStr, 23, LEFT) +
                    L_DatTim.DateTimeStr(XDocJrn.Date, XDocJrn.BegTime);
   CONFORM(XDocJrn, AcsObj);
   IF ~!AcsObj.Man & (AcsObj.ManAssT = L_AR.aomat_Staff) &
      L_Staff.IsStandOnAnyMainContract(AcsObj.Man, RWayS.Date) &
      L_Staff.rInState(RWayS.Date) THEN
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, Post);
    PostName:=Post.Name;
   ELSE
    SETEMPTY(PostName);
   END;
   RWayS_Tip:=RWayS_Tip +
              " " + Str.Align(PostName, 20, LEFT) +
              " " + AcsObj.FullName;
   PREV(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ... *)
  RETURN RWayS_Tip;
 END {GetSingleRWaySDescription};

 PRIVATE PROCEDURE GetDescription(xdt    : L_XDoc.tXDocType;
                                  lf     : STRING[];
                                  wExclQM: SCAL[2]): STRING[];
  VAR
   ExitTime,
   EntrTime   : TIME;
   Description: STRING[];
 BEGIN
  IF    ShowMode = sm_Car THEN
   L_XDoc.PositionOnXDoc(rtCar.XDocId);
   IF    xdt = L_XDoc.xdt_RprS THEN
    Description:=GetSingleRprSDescription(lf, wExclQM);
   ELSIF xdt = L_XDoc.xdt_RWayS THEN
    L_General.CallUs(SEARCH(Route, Route, rtCar.Route));
    L_General.CallUs(SEARCH(StExit, Exit, rtCar.Exit));
    SETEMPTY(ExitTime, EntrTime);
    IF ~!rtCar.BegDTS THEN
     UnPkVARIANTDATE(rtCar.BegDTS, , ExitTime);
    END;
    IF ~!rtCar.EndDTS THEN
     UnPkVARIANTDATE(rtCar.EndDTS, , EntrTime);
    END;
    Description:=GetSingleRWaySDescription(ExitTime, EntrTime, rtCar.BRestDTS,rtCar.ERestDTS,  lf, wExclQM, ShowMode = sm_Exit);
   END;
  ELSIF ShowMode = sm_Exit THEN
   SEARCH(RWayS, RWayS, , rtExit.RWayS);
   SEARCH(StExit, Exit, , rtExit.Exit);
   CONFORM(StExit, SEJobs);
   CONFORM(SEJobs, Route);
   UnPkVARIANTDATE(rtExit.BegDTS, , ExitTime);
   UnPkVARIANTDATE(rtExit.EndDTS, , EntrTime);
   Description:=GetSingleRWaySDescription(ExitTime, EntrTime, rtExit.BRestDTS, rtExit.ERestDTS, lf, wExclQM, ShowMode = sm_Exit);
  END;
  RETURN Description;
 END {GetDescription};

 PRIVATE PROCEDURE GetFontColor(trgState: NUMERIC[0]): RGBCOLOR;
 BEGIN
  IF NeedInvertButtonCaptionFontColor(trgState) THEN
   RETURN WhiteColor;
  ELSE
   RETURN BlackColor;
  END;
 END {GetFontColor};

 PRIVATE PROCEDURE GetrtExitState(): SCAL[1E2];
  VAR
   SysDTS, GivenDelayLength: FLOAT;
 BEGIN
  SysDTS:=L_DatTim.GetSysVARIANTDATE();
  IF rtExit.rwsState = L_RT.rterwss_NotOrdered THEN
   CONFORM(rtExit, StExit);
   IF StExit.Strict = L_Way.ExitStrict_Reg THEN
    SELECT(SEJobs, Exit, , StExit.Exit);
    SRCINSEL(SEJobs, LE, , 01, SYSTIME());
    IF OCCURE(SEJobs) & (SEJobs.StartT <= SYSTIME()) & (SEJobs.StopT >= SYSTIME()) THEN
     CONFORM(SEJobs, WJMode);
     IF WJMode.WJType # L_Way.WJType_Work THEN
      RETURN rte_st_NotOrderedInRest;
     END;
    END;
   END;
   IF ~rtExit.Suppl THEN
    RETURN rte_st_NotOrdered;
   ELSE
    RETURN rte_st_NotOrderedSuppl;
   END;
  ELSIF rtExit.rwsState = L_RT.rterwss_Ordered THEN
   GivenDelayLength:=(rtExit.BegDTS - SysDTS) * 24 * 60;
   IF    GivenDelayLength > 30 THEN
    RETURN rte_st_Ordered;
   ELSIF GivenDelayLength > 10 THEN
    RETURN rte_st_GivenCountdown;
   ELSE
    RETURN rte_st_GivenDelay;
   END;
  ELSIF rtExit.rwsState = L_RT.rterwss_Given THEN
   IF SysDTS > rtExit.BegDTS THEN
    SEARCH(RWayS, RWayS, , rtExit.RWayS);
    IF L_BegRWS.CarIsUnderControlOfPrevRWayS() |
       (L_BegRWS.E_UsingBarCodeScannerLevel(L_BegRWS.ubcr_Outpost) = L_BarCode.bcsl_None) THEN
     IF SysDTS > rtExit.EndDTS THEN
      RETURN rte_st_ReturnDelay;
     ELSE
      RETURN rte_st_Work;
     END;
    ELSE
     RETURN rte_st_DepartureDelay;
    END;
   ELSE
    RETURN rte_st_InPark;
   END;
  ELSIF rtExit.rwsState = L_RT.rterwss_Departure THEN
   SEARCH(RWayS, RWayS, , rtExit.RWayS);
   IF    L_RT.IsBeginRestDelay(SysDTS, rtExit.BRestDTS, rtExit.ERestDTS) THEN
    RETURN rte_st_ReturnDelay;
   ELSIF SysDTS > rtExit.EndDTS THEN
    IF L_BegRWS.CarIsUnderControlOfNextRWayS() THEN
     RETURN rte_st_Work;
    ELSE
     RETURN rte_st_ReturnDelay;
    END;
   ELSIF L_RT.BreakageOnLine() THEN
    RETURN rte_st_BreakageOnLine;
   ELSE
    RETURN rte_st_Work;
   END;
  ELSIF (rtExit.rwsState = L_RT.rterwss_Return) THEN
   IF    L_RT.IsEndRestDelay(SysDTS, rtExit.BRestDTS, rtExit.ERestDTS) THEN
    RETURN rte_st_DepartureDelay;
   ELSIF ~L_RT.IsInRest(SysDTS, rtExit.BRestDTS, rtExit.ERestDTS) &
         (L_DatTim.GetVARIANTDATEPeriod_Hour(rtExit.RWSMdDTS, SysDTS) > (L_RT.LongTimeAgoLength/60)) THEN
    RETURN rte_st_LongTimeAgoReturn;
   ELSE
    RETURN rte_st_InPark;
   END;
  ELSIF (rtExit.rwsState = L_RT.rterwss_AcptReturn) THEN
   IF SysDTS < rtExit.EndDTS THEN
    RETURN rte_st_EarlyReturn;
   ELSE
    RETURN rte_st_NormalShutdown;
   END;
  ELSIF rtExit.rwsState = L_RT.rterwss_Taken THEN
   IF SysDTS < rtExit.EndDTS THEN
    RETURN rte_st_EarlyReturn;
   ELSE
    RETURN rte_st_NormalShutdown;
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetrtExitState};

 PRIVATE PROCEDURE GetAmountasStr(Amount: NUMERIC[0]): STRING[];
 BEGIN
  IF Amount = 0 THEN
   RETURN "";
  ELSE
   RETURN L_Str.IntStr(Amount);
  END;
 END {GetAmountasStr};

 PRIVATE PROCEDURE GetIdBtn(Idx : NUMERIC[0]): STRING[];
 BEGIN
  IF    ShowMode = sm_Car THEN
   RETURN "CarColorBtn"  + "_" + L_Str.IntStr(Idx);
  ELSIF ShowMode = sm_Exit THEN
   RETURN "ExitColorBtn" + "_" + L_Str.IntStr(Idx);
  END;
 END {GetIdBtn};

 PRIVATE PROCEDURE GetIdStT(Idx : NUMERIC[0]): STRING[];
 BEGIN
  IF    ShowMode = sm_Car THEN
   RETURN "CarColorStT"  + "_" + L_Str.IntStr(Idx);
  ELSIF ShowMode = sm_Exit THEN
   RETURN "ExitColorStT" + "_" + L_Str.IntStr(Idx);
  END;
 END {GetIdStT};

 PRIVATE PROCEDURE GetIdMapBtn(Idx : NUMERIC[0]): STRING[];
 BEGIN
  IF    ShowMode = sm_Car THEN
   RETURN "CarMapBtn"  + "_" + L_Str.IntStr(Idx);
  ELSIF ShowMode = sm_Exit THEN
   RETURN "ExitMapBtn" + "_" + L_Str.IntStr(Idx);
  END;
 END {GetIdMapBtn};

 PRIVATE PROCEDURE GetIdMapStT(Idx : NUMERIC[0]): STRING[];
 BEGIN
  IF    ShowMode = sm_Car THEN
   RETURN "CarMapStT"  + "_" + L_Str.IntStr(Idx);
  ELSIF ShowMode = sm_Exit THEN
   L_General.CallUs(0);
  END;
 END {GetIdMapStT};

 PRIVATE PROCEDURE SetButtonBkColorSize(pb: PUSH_BUTTON; BtnNbr: NUMERIC[0]);
  VAR
   st: STATIC_TEXT;
 BEGIN
  IF ShowMode = sm_Car THEN
   st:=dlg.Controls.Item(GetIdMapStT(BtnNbr));
   st.Rect.Top   :=pb.Rect.Top    - sH_ColBtnShift / 2;
   st.Rect.Left  :=pb.Rect.Left   - sW_ColBtnShift / 2;
   st.Rect.Right :=pb.Rect.Right  + sH_ColBtnShift / 2;
   st.Rect.Bottom:=pb.Rect.Bottom + sH_ColBtnShift / 2;
  END;
 END {SetButtonBkColorSize};

 PRIVATE PROCEDURE ResizeMapBtns(Total: NUMERIC[0]);
  VAR
   pb                  : PUSH_BUTTON;
   idBtn               : STRING[];
   a, b, c, D,
   sH_NewColBtn,
   sW_NewColBtn,
   sW_Trunc,
   sH_Trunc,
   pL_MapBtn,
   pT_MapBtn           : FLOAT;
   Num, i, j,
   CntBtnsInRow,
   CntBtnsInCol,
   MaxButAmountInRow,
   MaxButAmountInColumn: NUMERIC[0];
 BEGIN
  (*  ࠧ   ⠪, ⮡   ᨬ 頤                                *)
  (*   ࠧ  sW_NewColBtn  sH_NewColBtn                                                                          *)
  (* 1) (sW_Map-sW_ColBtnShift)/(sW_NewColBtn+sW_ColBtnShift) =    ਧ⠫                                   *)
  (* 2) (sH_Map-sH_ColBtnShift)/(sH_NewColBtn+sH_ColBtnShift) =    ⨪                                     *)
  (* 3)    ਧ⠫ *    ⨪ >= Total                                       *)
  (* 4) sW_NewColBtn/sH_NewColBtn = sW_ColorBtn/sH_ColorBtn                                                                          *)
  (* sW_NewColBtn = sH_NewColBtn*sW_ColorBtn/sH_ColorBtn                                                                             *)
  (* ((sW_Map-sW_ColBtnShift)/(sW_NewColBtn+sW_ColBtnShift))*((sH_Map-sH_ColBtnShift)/(sH_NewColBtn+sH_ColBtnShift)) >= Total                  *)
  (* (sW_Map-sW_ColBtnShift)*(sH_Map-sH_ColBtnShift)/((sH_NewColBtn*sW_ColorBtn/sH_ColorBtn+sW_ColBtnShift)*(sH_NewColBtn+sH_ColBtnShift)) >= Total *)
  (* (sW_Map-sW_ColBtnShift)*(sH_Map-sH_ColBtnShift) >= Total*(sH_NewColBtn*sW_ColorBtn/sH_ColorBtn+sW_ColBtnShift)*(sH_NewColBtn+sH_ColBtnShift)     *)
  (* (sW_Map-sW_ColBtnShift)*(sH_Map-sH_ColBtnShift)/Total >= (sH_NewColBtn*sH_NewColBtn*sW_ColorBtn/sH_ColorBtn+sH_NewColBtn*sH_ColBtnShift*sW_ColorBtn/sH_ColorBtn + sH_NewColBtn*sW_ColBtnShift + sH_ColBtnShift*sW_ColBtnShift)   *)
  (* 0 >= sH_NewColBtn*sH_NewColBtn*sW_ColorBtn/sH_ColorBtn + sH_NewColBtn*(sH_ColBtnShift*sW_ColorBtn/sH_ColorBtn+sW_ColBtnShift) + sH_ColBtnShift*sW_ColBtnShift - (sW_Map-sW_ColBtnShift)*(sH_Map-sH_ColBtnShift)/Total *)
  
  (* 稫 ⭮ ࠢ⢮  0 >= a*sH_NewColBtn*sH_NewColBtn + b*sH_NewColBtn + c,  *)
  (* a = sW_ColorBtn/sH_ColorBtn                                      *)
  (* b = sH_ColBtnShift*sW_ColorBtn/sH_ColorBtn + sW_ColBtnShift          *)
  (* c = (sH_ColBtnShift*sW_ColBtnShift - (sW_Map-sW_ColBtnShift)*(sH_Map-sH_ColBtnShift))/Total  *)
  (* c = (sW_Map*sH_ColBtnShift+sH_Map*sW_ColBtnShift-sW_Map*sH_Map)/Total  *)
  (* D = b*b - 4*a*c                                                  *)
  (* D<0 - ୥                                                  *)

  IF Total > 0 THEN
   IF    ShowMode = sm_Car THEN
    MaxButAmountInRow   :=12;
    MaxButAmountInColumn:=14;
   ELSIF ShowMode = sm_Exit THEN
    MaxButAmountInRow   :=08;
    MaxButAmountInColumn:=12;
   END;

   a:= sW_ColorBtn[ShowMode] / sH_ColorBtn[ShowMode];
   b:= sH_ColBtnShift * sW_ColorBtn[ShowMode] / sH_ColorBtn[ShowMode] + sW_ColBtnShift;
   c:= (sW_Map * sH_ColBtnShift + sH_Map * sW_ColBtnShift - sW_Map * sH_Map) / Total;
   D:= b*b - 4*a*c;
   L_General.CallUs(D>=0);
   IF D = 0 THEN
    sH_NewColBtn:=-b/(2*a);
   ELSE
    sH_NewColBtn:=Math.Max((-b - Math.Pow(D, 0.5))/(2*a),
                           (-b + Math.Pow(D, 0.5))/(2*a));
   END;
   L_General.CallUs(sH_NewColBtn>0);
   sW_NewColBtn:=sH_NewColBtn * sW_ColorBtn[ShowMode] / sH_ColorBtn[ShowMode];
   CntBtnsInRow:=Math.Div(sW_Map - sW_ColBtnShift, sW_NewColBtn + sW_ColBtnShift);
   CntBtnsInCol:=Math.Div(sH_Map - sH_ColBtnShift, sH_NewColBtn + sH_ColBtnShift);

   CntBtnsInRow:=Math.Max(CntBtnsInRow, MaxButAmountInRow);
   CntBtnsInCol:=Math.Max(CntBtnsInCol, MaxButAmountInColumn);

   IF (Total - CntBtnsInRow*CntBtnsInCol) > 0 THEN
    IF    Math.Min(CntBtnsInRow, CntBtnsInCol) >= (Total - CntBtnsInRow*CntBtnsInCol) THEN
     IF CntBtnsInRow < CntBtnsInCol THEN
      INC(CntBtnsInCol);
     ELSE
      INC(CntBtnsInRow);
     END;
    ELSIF Math.Max(CntBtnsInRow, CntBtnsInCol) >= (Total - CntBtnsInRow*CntBtnsInCol) THEN
     IF CntBtnsInRow > CntBtnsInCol THEN
      INC(CntBtnsInCol);
     ELSE
      INC(CntBtnsInRow);
     END;
    ELSE
     INC(CntBtnsInRow);
     INC(CntBtnsInCol);
    END;
   END; (* IF Total - CntBtnsInRow*CntBtnsInCol ... *)

   sW_NewColBtn:=Math.Trunc((sW_Map - sW_ColBtnShift) / CntBtnsInRow - sW_ColBtnShift);
   sH_NewColBtn:=Math.Trunc((sH_Map - sH_ColBtnShift) / CntBtnsInCol - sH_ColBtnShift);

   sW_Trunc:=Math.Div(sW_Map - (sW_NewColBtn + sW_ColBtnShift)*CntBtnsInRow - sW_ColBtnShift, 2);
   sH_Trunc:=Math.Div(sH_Map - (sH_NewColBtn + sH_ColBtnShift)*CntBtnsInCol - sH_ColBtnShift, 2);
   SETZERO(i, Num);
   pT_MapBtn:=pT_Map + sH_ColBtnShift + sH_Trunc;
   WHILE (i < CntBtnsInCol) & (Num < Total) DO
    pL_MapBtn:=pL_Map + sW_ColBtnShift + sW_Trunc;
    j:=0;
    WHILE (j < CntBtnsInRow) & (Num < Total) DO
     Num:=i*CntBtnsInRow + j;
     IF Num < Total THEN
      idBtn:=GetIdMapBtn(Num);
      PROMPT("ᮢ " + L_Str.IntStr(Num));
      pb:=dlg.Controls.Item(idBtn);
      pb.Rect.Left  := pL_MapBtn;
      pb.Rect.Top   := pT_MapBtn;
      pb.Rect.Right := pb.Rect.Left + sW_NewColBtn;
      pb.Rect.Bottom:= pb.Rect.Top  + sH_NewColBtn;
      pb.TextRect.Left  := 0;
      pb.TextRect.Top   := 0;
      pb.TextRect.Right := sW_NewColBtn;
      pb.TextRect.Bottom:= sH_NewColBtn;
      SetButtonBkColorSize(pb, Num);
      INC(pL_MapBtn, sW_NewColBtn + sW_ColBtnShift);
     END;
     INC(j);
    END; (* WHILE j <= ... *)
    INC(pT_MapBtn, sH_NewColBtn + sH_ColBtnShift);
    INC(i);
   END; (* WHILE i <= ... *)
   PROMPT("");
  END; (* IF Total > 0 ... *)
 END {ResizeMapBtns};

 PRIVATE PROCEDURE HideUnwantedButton(ButtonAmount: NUMERIC[0]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=ButtonAmount;
  WHILE i < MaxButtonAmount[ShowMode] DO
   PROMPT("⨥ " + L_Str.IntStr(i));
   dlg.Controls.Item(GetIdMapBtn(i)).Visible:=0;
   IF ShowMode = sm_Car THEN
    dlg.Controls.Item(GetIdMapStT(i)).Visible:=0;
   END;
   INC(i);
  END;
 END {HideUnwantedButton};

 PRIVATE PROCEDURE UpdateTotals();
  VAR
   i,
   Total,
   prvTotal,
   StateAmnt: NUMERIC[0];
 BEGIN
  StateAmnt:=GetTotalAmountState();
  prvTotal :=STRTOFLD(dlg.Controls.Item(GetIdBtn(StateAmnt)).Text, SCAL);
  SETZERO(i, Total);
  WHILE i <= StateAmnt DO
   IF i = StateAmnt THEN
    dlg.Controls.Item(GetIdBtn(i)).Text:=GetAmountasStr(Total);
   ELSE
    INC(Total, Amount[i]);
    dlg.Controls.Item(GetIdBtn(i)).Text:=GetAmountasStr(Amount[i]);
   END;
   INC(i);
  END;
  IF prvTotal # Total THEN
   ResizeMapBtns(TotalButtonAmount[ShowMode]);
  END;
  HideUnwantedButton(Total);
  PROMPT("");
 END {UpdateTotals};

 PRIVATE PROCEDURE UpdateMapBtn(BtnNbr     : NUMERIC[0];
                                Text,
                                ToolTipText: STRING[];
                                State      : NUMERIC[0];
                                StTColor   : RGBCOLOR);
  VAR
   pb: PUSH_BUTTON;
 BEGIN
  pb            :=dlg.Controls.Item(GetIdMapBtn(BtnNbr));
  pb.Text       :=Text;
  pb.Visible    :=1;
  L_GUI.SetToolTipText(pb, ToolTipText);
  L_GUI.SetControlFgColor(pb, GetFontColor(State));
  L_GUI.SetControlBkColor(pb, Getb_Color(State));
  IF ShowMode = sm_Car THEN
   SetButtonBkColorSize(pb, BtnNbr);
   L_GUI.SetControlBkColor(dlg.Controls.Item(GetIdMapStT(BtnNbr)), StTColor);
  END;
 END {UpdateMapBtn};

 PRIVATE PROCEDURE IsAllowedCar(): SCAL[2];
 BEGIN
  IF L_Car.StandOnCarLogSoft(rtCar.BoxNbr, SYSDATE()) THEN
   CONFORM(CarLog, Column);
   RETURN P_Firm.IsAllowedMyPF(Column.MyFirm, P_Column.GetMyPlace(Column.Column, SYSDATE()));
  ELSE
   RETURN 1;
  END;
 END {IsAllowedCar};

 PRIVATE PROCEDURE RenewCars(VAR Nbr      : NUMERIC[0];
                                 Condition: STRING[];
                                 StTColor : RGBCOLOR);
  VAR
   Hint  : STRING[];
   Result: SCAL[2];
   xdt   : L_XDoc.tXDocType;
   xdk   : L_XDoc.tXDocKind;
   xd    : L_XDoc.tXDoc;
   State : SCAL[L_RT.rtc_st_TotalAmount];
   SysDTS: FLOAT;
 BEGIN
  WHILE OCCURE(rtCar) DO
   NARROWSEL(rtCar, BoxNbr);
   PROMPT(" ﭨ " + rtCar.BoxNbr);
   IF IsAllowedCar() THEN
    SysDTS:=L_DatTim.GetSysVARIANTDATE();
    L_RT.rtCar_StandOnActual(SysDTS);
    State:=L_RT.GetrtCarState(SysDTS);
    IF !Condition THEN
     Result:=1;
    ELSE
     Result:=^Condition;
    END;
    IF Result THEN
     INC(Amount[State]);
     Hint:="";
     IF ~!rtCar.XDocId THEN
      L_XDoc.DecodeXDocId(rtCar.XDocId, xdt, xdk, xd);
      Hint:=GetDescription(xdt, L_Str.CRLF, 1);
     END;
     UpdateMapBtn(Nbr, rtCar.BoxNbr, L_Str.ExclQM(rtCar.MarkName) + L_Str.CRLF + Hint, State, StTColor);
     INC(Nbr);
    END;
   END;
   NEXTINEXTENDEDSEL(rtCar, BoxNbr);
  END; (* WHILE OCCURE(rtCar) ... *)
  PROMPT("");
 END {RenewCars};

 PRIVATE PROCEDURE intReSortCarPage(Index,
                                    ChangeSel,
                                    Condition : STRING[]);
  VAR
   Nbr,
   prvNbr  : NUMERIC[0];
   StTColor: RGBCOLOR;
 BEGIN
  StTColor:=WhiteColor;
  SETZERO(Nbr);
  SELECT(rtCar, ^Index, , DispDate);
  WHILE OCCURE(rtCar) DO
   IF ~!ChangeSel THEN
    NARROWSEL(rtCar, ^ChangeSel);
    SAVE(rtCar);
   END;
   prvNbr:=Nbr;
   RenewCars(Nbr, Condition, StTColor);
   IF prvNbr # Nbr THEN
    IF StTColor = WhiteColor THEN
     StTColor:=BlackColor;
    ELSE
     StTColor:=WhiteColor;
    END;
   END;
   IF ~!ChangeSel THEN
    RESTORE(rtCar);
    NEXTINEXTENDEDSEL(rtCar, ^ChangeSel);
   END;
  END; (* WHILE OCCURE(rtCar) ... *)
 END {intReSortCarPage};

 PRIVATE PROCEDURE AddCondition(VAR Result: STRING[];
                                    NewCondition: STRING[]);
 BEGIN
  NewCondition:="("+NewCondition+")";
  IF ~!Result THEN
   Result:=Result + "&" + NewCondition;
  ELSE
   Result:=NewCondition;
  END;
 END {AddCondition};

 PRIVATE PROCEDURE GetColumnNbr(): LIKE(CarLog.Column);
 BEGIN
  RETURN Str.Item(L_Str.PoolItem(GetColumnList(), csf_Column), CodeInListDlm, 1);
 END {GetColumnNbr};

 PRIVATE PROCEDURE GetDprt(): LIKE(Sort.Sort);
 BEGIN
  RETURN Str.Item(L_Str.PoolItem(GetDprtList(), csf_Dprt), CodeInListDlm, 1);
 END {GetDprt};

 PRIVATE PROCEDURE ReSortCarPage();
  VAR
   Condition: STRING[];
   trgColumn: LIKE(CarLog.Column);
 BEGIN
  SETEMPTY(Condition);
  IF csf_Column # 0 THEN
   trgColumn:=GetColumnNbr();
   AddCondition(Condition, "rtCar.Column=" + L_Str.IntStr(trgColumn));
  END;
  IF csf_Purpose # 0 THEN
   AddCondition(Condition, "rtCar.Purpose=" + L_Str.IntStr(csf_Purpose-1));
  END;

  IF csf_State[ShowMode] # GetTotalAmountState() THEN
   AddCondition(Condition, "State=" + L_Str.IntStr(csf_State[ShowMode]));
  END;

  IF    cs_SortCar = 0 THEN
   intReSortCarPage("DDBoxNbr",  "",      Condition);
  ELSIF cs_SortCar = 1 THEN
   intReSortCarPage("DDColumn", "Column", Condition);
  END;
  PROMPT("");
 END {ReSortCarPage};

 PRIVATE PROCEDURE IsAllowedExit(): SCAL[2];
  VAR
   fxdSort: LIKE(Sort.Sort);
 BEGIN
  fxdSort:=L_Way.E_GetFixedSortOfExit(rtExit.Exit, SYSDATE(), EMPTYOF(L_Way.tRWSWho));
  IF ~!fxdSort THEN
   SEARCH(Sort, Sort, , fxdSort);
   RETURN P_Firm.IsAllowedMyPF(Sort.MyFirm, P_Sort.GetMyPlace(Sort.Sort, SYSDATE()));
  ELSE
   RETURN 1;
  END;
 END {IsAllowedExit};

 PRIVATE PROCEDURE RenewExit(Condition : STRING[]);
  VAR
   Nbr   : NUMERIC[0];
   Hint  : STRING[];
   Result: SCAL[2];
   State : SCAL[rte_st_TotalAmount];
   Dummy : RGBCOLOR;
 BEGIN
  SETZERO(Nbr);
  Dummy:=WhiteColor;
  SELECT(rtExit, DDECSign, , DispDate);
  WHILE OCCURE(rtExit) DO
   PROMPT(" ﭨ " + rtExit.ECSign);
   IF IsAllowedExit() THEN
    State:=GetrtExitState();
    IF !Condition THEN
     Result:=1;
    ELSE
     Result:=^Condition;
    END;
    IF Result THEN
     INC(Amount[State]);
     IF ~!rtExit.RWayS THEN
      Hint:=GetDescription(L_XDoc.xdt_RWayS, L_Str.CRLF, 1);
     ELSE
      Hint:=rtExit.Exit;
     END;
     UpdateMapBtn(Nbr, rtExit.ECSign, Hint, State, Dummy);
     INC(Nbr);
    END;
   END;
   NEXT(rtExit);
  END; (* WHILE OCCURE(rtExit) ... *)
 END {RenewExit};

 PRIVATE PROCEDURE ReSortExitPage();
  VAR
   Condition: STRING[];
   trgDprt  : LIKE(Sort.Sort);
 BEGIN
  SETEMPTY(Condition);
  IF csf_Status # 0 THEN
   AddCondition(Condition, "rtExit.Status=" + L_Str.IntStr((csf_Status-1)));
  END;
  IF csf_State[ShowMode] # GetTotalAmountState() THEN
   AddCondition(Condition, "State=" + L_Str.IntStr((csf_State[ShowMode])));
  END;

  IF csf_Dprt # 0 THEN
   trgDprt:=GetDprt();
   IF !trgDprt THEN
    AddCondition(Condition, "!rtExit.Dprt");
   ELSE
    AddCondition(Condition, "rtExit.Dprt = " + trgDprt);
   END;
  END;
  RenewExit(Condition);
 END {ReSortExitPage};

 PRIVATE PROCEDURE ShowPage(Page: STRING[]);
 BEGIN
  L_GUI.ShowPages(dlg, p_Main + "|" + Page, 1);
 END {ShowPage};

 PRIVATE PROCEDURE RefreshPage();
 BEGIN
  SETZERO(Amount);
  IF    ShowMode = sm_Car  THEN
   ShowPage(p_CarMap);
   ReSortCarPage();
  ELSIF ShowMode = sm_Exit THEN
   ShowPage(p_ExitMap);
   ReSortExitPage();
  ELSE
   L_General.CallUs(0);
  END;

  UpdateTotals();

  dlg.Redraw();
 END {RefreshPage};

 PRIVATE PROCEDURE SetColorBtnPressed(ClickBtnIdx: NUMERIC[0]);
  VAR
   Idx,
   CntColBtn: NUMERIC[0];
   trgColor : RGBCOLOR;
 BEGIN
  CntColBtn :=GetTotalAmountState() + 1;
  Idx       :=0;
  WHILE Idx < CntColBtn DO
   IF Idx = ClickBtnIdx THEN
    IF ((ShowMode = sm_Car)  & (Idx = L_RT.rtc_st_DepartureDelay)) |
       ((ShowMode = sm_Exit) & (Idx = rte_st_DepartureDelay))      THEN
     trgColor:=BlackColor;
    ELSE
     trgColor:=RedColor;
    END;
   ELSE
    trgColor:=WhiteColor;
   END;
   L_GUI.SetControlBkColor(dlg.Controls.Item(GetIdStT(Idx)), trgColor);
   dlg.Controls.Item(GetIdStT(Idx)).Redraw();
   INC(Idx);
  END;
 END {SetColorBtnPressed};

 PRIVATE PROCEDURE OnClick_ColorBtn(Self: OBJECT);
  VAR
   tcsf_State: NUMERIC[0];
 BEGIN
  idleStart :=HIGH_RESOLUTION_TIMER();
  tcsf_State:=STRTOFLD(Str.Item(Self.Id, "_", 1), SCAL);
  IF csf_State[ShowMode] # tcsf_State THEN
   SetColorBtnPressed(tcsf_State);
   csf_State[ShowMode]:=tcsf_State;
   RefreshPage();
  END;
 END {OnClick_ColorBtn};

 PRIVATE PROCEDURE OnClick_MapBtn(Self: OBJECT);
 BEGIN
  idleStart:=HIGH_RESOLUTION_TIMER();
  ShowXDoc(Self.Text);
 END {OnClick_MapBtn};

 PRIVATE PROCEDURE UpdateControlText(Id, Text: STRING[]);
 BEGIN
  dlg.Controls.Item(Id).Text:=Text;
  dlg.Controls.Item(Id).Redraw();
 END {UpdateControlText};

 PRIVATE PROCEDURE SecondsLeft(prvHRT: FLOAT): NUMERIC[3];
 BEGIN
  RETURN HIGH_RESOLUTION_TIMER() - prvHRT;
 END {SecondsLeft};

 PRIVATE PROCEDURE GetSecondsLeft(): NUMERIC[0];
  VAR
   curHRT: FLOAT;
 BEGIN
  IF    ShowMode = sm_Car THEN
   curHRT:=HRT_RenewCar;
  ELSIF ShowMode = sm_Exit THEN
   curHRT:=HRT_RenewExit;
  END;
  RETURN SecondsLeft(curHRT);
 END {GetSecondsLeft};

 PRIVATE PROCEDURE RedrawUpdateBtn();
  VAR
   Sec: NUMERIC[0];
 BEGIN
  Sec:=RenewPeriod - GetSecondsLeft();
  UpdateControlText(id_Update, " (" + L_Str.IntStr(Math.Div(Sec, 60)) + ":" + FLDTOSTR(Math.Mod(Sec, 60), "L", 2) + ")");
 END {RedrawUpdateBtn};

 PRIVATE PROCEDURE GetNextShowMode(): tShowMode;
 BEGIN
  IF    ShowMode = sm_Car THEN
   RETURN sm_Exit;
  ELSIF ShowMode = sm_Exit THEN
   RETURN sm_Car;
  END;
 END {GetNextShowMode};

 PRIVATE PROCEDURE pb_UpdateShowMode();
  VAR
   pb: PUSH_BUTTON;
 BEGIN
  pb     :=dlg.Controls.Item(id_ShowMode);
  pb.Text:=L_Str.PoolItem(GetShowModeList(), GetNextShowMode());
  L_GUI.SetToolTipText(pb, "롮  ﭨ.");
  pb.Redraw();
 END {pb_UpdateShowMode};

 PRIVATE PROCEDURE IsTimeToRenew(): SCAL[2];
 BEGIN
  RETURN GetSecondsLeft() > RenewPeriod;
 END {IsTimeToRenew};

 PRIVATE PROCEDURE RenewData();
 BEGIN
  UpdateControlText(id_Update, "...");
  IF    ShowMode = sm_Car THEN
   L_RT.rtc_Init();
  ELSIF ShowMode = sm_Exit THEN
   L_RT.rte_Init();
  END;
  SETZERO(TotalButtonAmount);
  IF    ShowMode = sm_Car THEN
   SELECT(rtCar, DDBoxNbr, , DispDate);
   WHILE OCCURE(rtCar) DO
    PROMPT(" " + rtCar.BoxNbr);
    NARROWSEL(rtCar, BoxNbr);
    IF IsAllowedCar() THEN
     INC(TotalButtonAmount[ShowMode]);
    END;
    NEXTINEXTENDEDSEL(rtCar, BoxNbr);
   END; (* WHILE OCCURE(rtCar) ... *)
  ELSIF ShowMode = sm_Exit THEN
   SELECT(rtExit, DDECSign, , DispDate);
   WHILE OCCURE(rtExit) DO
    PROMPT(" " + rtExit.Exit);
    IF IsAllowedExit() THEN
     INC(TotalButtonAmount[ShowMode]);
    END;
    NEXT(rtExit);
   END; (* WHILE OCCURE(rtExit) ... *)
  END;
 END {RenewData};

 PRIVATE PROCEDURE RenewPage(RenewRequired, UpdateTimers: SCAL[2]);
 BEGIN
  PROMPT(" ");
  IF RenewRequired THEN
   RenewData();
  END;
  pb_UpdateShowMode();
  RefreshPage();
  IF ShowMode = sm_Exit THEN
   UpdateControlText(id_DispDate, DispDateText());
  END;

  IF UpdateTimers THEN
   IF    ShowMode = sm_Car THEN
    HRT_RenewCar:=HIGH_RESOLUTION_TIMER();
   ELSIF ShowMode = sm_Exit THEN
    HRT_RenewExit:=HIGH_RESOLUTION_TIMER();
   END;
  END;
 END {RenewPage};

 PRIVATE PROCEDURE PutMap(force: SCAL[2]);
  VAR
   sW_BtnShift,
   sH_BtnShift,
   pL_Btn,
   pT_Btn,
   pL_MapBtn,
   pT_MapBtn   : FLOAT;
   fS_MapBtn,
   Total,
   Idx,
   CntColBtn,
   RowAmount,
   ColAmount,
   i, j        : NUMERIC[0];
   StatePool,
   page,
   idStT,
   idBtn       : STRING[];
   pb          : PUSH_BUTTON;
   RowAddPass  : SCAL[2];
 BEGIN
  MapIsLoad[ShowMode]:=1;
  IF    ShowMode = sm_Car THEN
   csf_State[ShowMode]:=L_RT.rtc_st_TotalAmount;
   page               :=p_CarMap;
   fS_MapBtn          :=20;
   ColAmount          :=19;
   RowAmount          :=22;
  ELSIF ShowMode = sm_Exit THEN
   csf_State[ShowMode]:=rte_st_TotalAmount;
   page               :=p_ExitMap;
   fS_MapBtn          :=18;
   ColAmount          :=17;
   RowAmount          :=22;
  END;
  CntColBtn:=csf_State[ShowMode] + 1;
  SetButtonColors();

  sW_BtnShift:=8;
  sH_BtnShift:=8;

  sH_ColorBtn[ShowMode]:=sH_Totals - 2*sH_BtnShift;
  sW_ColorBtn[ShowMode]:=(sW_Totals - sW_BtnShift) / CntColBtn - sW_BtnShift;
  pT_Btn   :=pT_Totals + sH_BtnShift;
  i:=0;
  StatePool:=GetStatePool();
  WHILE i < CntColBtn DO
   PROMPT(" ꥪ " + L_Str.IntStr(i));
   idBtn:=GetIdBtn(i);
   pL_Btn:=pL_Totals + sW_BtnShift*(i+1) + sW_ColorBtn[ShowMode]*i;
   L_GUI.put_ColorButton(dlg, page, idBtn, "",
                         pL_Btn, pT_Btn, sW_ColorBtn[ShowMode], sH_ColorBtn[ShowMode],
                         fS_ColorBtn,
                         Getb_Color(i),
                         PROCREF(OnClick_ColorBtn));
   pb                  :=dlg.Controls.Item(idBtn);
   L_GUI.SetToolTipText(pb, L_Str.PoolItem(StatePool, i));
   pb.Style.Font.Face  :=L_GUI.fn_CourierNew;
   pb.Style.Font.Weight:=FONT.Weight_Bold;
   L_GUI.SetControlFgColor(dlg.Controls.Item(idBtn), GetFontColor(i));

   idStT:=GetIdStT(i);
   L_GUI.put_StaticText(dlg, page, idStT, "",
                        pb.Rect.Left   - sW_BtnShift/2,
                        pb.Rect.Top    - sH_BtnShift/2,
                        pb.Rect.Right  - pb.Rect.Left  + sW_BtnShift,
                        pb.Rect.Bottom - pb.Rect.Top   + sH_BtnShift,
                        fS_Clock, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
   INC(i);
  END;
  SetColorBtnPressed(csf_State[ShowMode]);
  PROMPT("");

  RenewData();

  RowAddPass:=1;
  LOOP
   MaxButtonAmount[ShowMode]:=RowAmount * ColAmount;
   IF MaxButtonAmount[ShowMode] >= TotalButtonAmount[ShowMode] THEN
    EXIT;
   END;
   IF RowAddPass THEN
    INC(RowAmount);
   ELSE
    INC(ColAmount);
    DEC(fS_MapBtn);
   END;
   RowAddPass:=~RowAddPass;
  END; (* LOOP *)

  i:=0;
  pT_MapBtn:=pT_Map + sH_ColBtnShift;
  WHILE i < ColAmount DO
   pL_MapBtn:=pL_Map + sW_ColBtnShift;
   j:=0;
   WHILE j < RowAmount DO
    Idx:=i*RowAmount + j;
    PROMPT(" ꥪ " + L_Str.IntStr(Idx));
    IF ShowMode = sm_Car THEN
     L_GUI.put_StaticText(dlg, page, GetIdMapStT(Idx), "",
                          pL_MapBtn - sW_ColBtnShift/2,
                          pT_MapBtn - sH_ColBtnShift/2,
                          sW_ColorBtn[ShowMode] + sW_ColBtnShift,
                          sH_ColorBtn[ShowMode] + sH_ColBtnShift,
                          fS_Clock, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
    END;
    idBtn:=GetIdMapBtn(Idx);
    L_GUI.put_ColorButton(dlg, page, idBtn, "",
                          pL_MapBtn,
                          pT_MapBtn,
                          sW_ColorBtn[ShowMode],
                          sH_ColorBtn[ShowMode],
                          fS_MapBtn,
                          BlackColor,
                          PROCREF(OnClick_MapBtn));
    pb:=dlg.Controls.Item(idBtn);
    pb.Style.Font.Face  :=L_GUI.fn_CourierNew;
    pb.Style.Font.Weight:=FONT.Weight_Bold;
    INC(pL_MapBtn, sW_ColorBtn[ShowMode] + sW_ColBtnShift);
    INC(j);
   END; (* WHILE j <= ... *)
   INC(pT_MapBtn, sH_ColorBtn[ShowMode] + sH_ColBtnShift);
   INC(i);
  END; (* WHILE i <= ... *)
  PROMPT("");
  RenewPage(0, 1);
 END {PutMap};

 PRIVATE PROCEDURE DispDateText(): STRING[];
 BEGIN
  RETURN ".⪨ " + L_DatTim.DateStr(DispDate);
 END {DispDateText};

 PRIVATE PROCEDURE OnClick_GoTo(Self: OBJECT);
 BEGIN
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, curXDocId, "");
 END {OnClick_GoTo};

 PRIVATE PROCEDURE ShowXDocDialog(xdt: L_XDoc.tXDocType);
  CONST
   kfc         = 0.85;
   sW_Btns     = 150;
   sH_DlgShift = 3;
   sW_DlgShift = 3;
   fS_Btns     = 14;
   fS_Text     = 16;
   sH_Btns     = 20;

   b_GoTo  = 0;
   b_Close = 1;

  VAR
   TextDlg     : DIALOG;
   CntStrInText,
   MaxSLn,
   Idx         : NUMERIC[0];
   tmpScaleX,
   tmpScaleY,
   sW_TextDlg,
   sH_TextDlg,
   pT_Btn,
   pL_Btn      : FLOAT;
   Text        : STRING[];
   Result      : SCAL[2];
 BEGIN
  IF    ShowMode = sm_Car THEN
   Text:=rtCar.BoxNbr + " " + rtCar.MarkName + "||";
  ELSIF ShowMode = sm_Exit THEN
   Text:=rtExit.Exit + " " + StExit.Name     + "||";
  END;
  Text:=Text + GetDescription(xdt, "|", 0);

  CntStrInText:=L_Str.CntItemsInPool(Text);
  SETZERO(Idx, MaxSLn);
  WHILE Idx < CntStrInText DO
   IF Str.Length(L_Str.PoolItem(Text, Idx)) > MaxSLn THEN
    MaxSLn:=Str.Length(L_Str.PoolItem(Text, Idx));
   END;
   INC(Idx);
  END;
  WHILE Str.Pos(Text, "||") # Str.Length(Text) DO
   Text:=Str.Replace(Text, "||", "|" + L_Str.Repeat("", MaxSLn) + "|");
   INC(CntStrInText);
  END;
  SETZERO(Idx);
  WHILE Idx <= CntStrInText DO
   IF Str.Length(L_Str.PoolItem(Text, Idx)) < MaxSLn THEN
    Text:=Str.Replace(Text, L_Str.PoolItem(Text, Idx), Str.Align(L_Str.PoolItem(Text, Idx), MaxSLn, LEFT));
   END;
   INC(Idx);
  END;

  TextDlg                     :=DIALOG.Create(dlg);
  TextDlg.WindowSizeStatus    :=DIALOG.WindowSizeStatus_Restored;
  TextDlg.WindowStyle         :=DIALOG.WindowStyle_FixedSize;

  sW_TextDlg                  :=L_GUI.normalWidth  * kfc;
  sH_TextDlg                  :=L_GUI.normalHeight * kfc;
  TextDlg.StandardClientWidth :=sW_TextDlg;
  TextDlg.StandardClientHeight:=sH_TextDlg;
  TextDlg.CaptionText         :=L_XDoc.Ref_FullName(xdt);
  IF L_General.IsAcceptableProcessorVersion(014159040) THEN
   TextDlg.AutoScale:=0;
  END;
  TextDlg.Redraw();

  tmpScaleX          :=(dlg.ClientRect.Right  - dlg.ClientRect.Left) / TextDlg.StandardClientWidth;
  tmpScaleY          :=(dlg.ClientRect.Bottom - dlg.ClientRect.Top)  / TextDlg.StandardClientHeight;
  TextDlg.Rect.Right :=TextDlg.Rect.Left + TextDlg.StandardClientWidth  * tmpScaleX * kfc;
  TextDlg.Rect.Bottom:=TextDlg.Rect.Top  + TextDlg.StandardClientHeight * tmpScaleY * kfc;
  TextDlg.AutoPos:=1;
  TextDlg.Redraw();

  sW_TextDlg:=TextDlg.StandardClientWidth -2*sW_DlgShift;
  sH_TextDlg:=TextDlg.StandardClientHeight-2*sH_DlgShift;

  pT_Btn    :=sH_TextDlg - sH_Btns + sH_DlgShift;
  pL_Btn    :=sW_TextDlg - 2*(sW_Btns + sW_DlgShift);

  L_GUI.add_Button(TextDlg, "id_GoTo", "३  " + L_XDoc.Ref_ShortName(xdt), "",
                   pL_Btn, pT_Btn, sW_Btns, sH_Btns,
                   fS_Btns, L_GUI.fn_Default,
                   PROCREF(OnClick_GoTo));
  TextDlg.Controls.Item("id_GoTo").Visible:=1;
  INC(pL_Btn, sW_Btns + sW_DlgShift);

  L_GUI.add_Button(TextDlg, "id_CloseTextDialog", "", "",
                   pL_Btn, pT_Btn, sW_Btns, sH_Btns,
                   fS_Btns, L_GUI.fn_Default,
                   PROCREF(OnClick_Close));
  TextDlg.Controls.Item("id_CloseTextDialog").Visible:=1;

  L_GUI.add_StaticText(TextDlg, "id_Text", Text,
                       sW_DlgShift, sH_DlgShift, sW_TextDlg, sH_TextDlg - sH_Btns - sH_DlgShift,
                       fS_Text, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_Ridge);
  TextDlg.Controls.Item("id_Text").Visible           :=1;
  TextDlg.Controls.Item("id_Text").VerticalAlignment :=CONTROL.VerticalAlignment_Top;
  TextDlg.Controls.Item("id_Text").Style.Font.Face   :=L_GUI.fn_CourierNew;

  TextDlg.Visible:=1;
  TextDlg.Redraw();
  WHILE TextDlg.Visible DO
   RENEWDATALAYER();
   TextDlg.Wait(0.5);
  END;
  SETEMPTY(curXDocId);
 END {ShowXDocDialog};

 PRIVATE PROCEDURE ShowXDoc(trgObject: STRING[]);
  VAR
   xdt: L_XDoc.tXDocType;
   xdk: L_XDoc.tXDocKind;
   xd : L_XDoc.tXDoc;
 BEGIN
  SETEMPTY(curXDocId);
  IF    ShowMode = sm_Car THEN
   SELECT(rtCar, DDBoxNbr, , DispDate, trgObject);
   L_RT.rtCar_StandOnActual(L_DatTim.GetSysVARIANTDATE());
   IF ~!rtCar.XDocId THEN
    curXDocId:=rtCar.XDocId;
    L_XDoc.DecodeXDocId(rtCar.XDocId, xdt, xdk, xd);
    ShowXDocDialog(xdt);
   ELSE
    L_StdFrm.Inform("ﭨ  "+rtCar.BoxNbr+": '"+L_Str.PoolItem(GetStatePool(), L_RT.GetrtCarState(L_DatTim.GetSysVARIANTDATE()))+"'");
   END;
  ELSIF ShowMode = sm_Exit THEN
   SELECT(rtExit, DDECSign, , DispDate, trgObject);
   IF ~!rtExit.RWayS THEN
    curXDocId:=L_XDoc.XDocId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, rtExit.RWayS);
    SEARCH(StExit, Exit, , rtExit.Exit);
    ShowXDocDialog(L_XDoc.xdt_RWayS);
   ELSE
    L_StdFrm.Inform("ﭨ 室 "+rtExit.ECSign+": '"+L_Str.PoolItem(GetStatePool(), GetrtExitState())+"'");
   END;
  END;
 END {ShowXDoc};

 PRIVATE PROCEDURE OnClose_Dialog(d: DIALOG);
 BEGIN
  L_GUI.SetTaskBarVisible(1);
  d.Visible:=0;
 END {OnClose_Dialog};

 PRIVATE PROCEDURE OnClick_Close(Self: OBJECT);
 BEGIN
  Self.Parent.Parent.Visible:=0;
 END {OnClick_Close};

 PRIVATE PROCEDURE OnClick_Update(Self: OBJECT);
 BEGIN
  idleStart:=HIGH_RESOLUTION_TIMER();
  RenewPage(1, 1);
 END {OnClick_Update};

 PRIVATE PROCEDURE E_IsInIdleProccess();
  CONST
   restartShowExitsMapIdleTimout = 300; (* ᥪ㭤 *)
 BEGIN
  IF L_General.GetAPSiteNumber() = 50 THEN
   IF L_Str.IsEqStrI(LOGINNAME(), "") THEN
    IF SecondsLeft(idleStart) > restartShowExitsMapIdleTimout THEN
     StatusMap.ChangeShowMode(StatusMap.sm_Exit);
    END;
   END;
  END;
 END {E_IsInIdleProccess};

 PRIVATE PROCEDURE idleProc();
 BEGIN
  UpdateControlText(id_Clock, L_DatTim.CompleteSystimeStr());
  RedrawUpdateBtn();
  HRT_RenewClock:=HIGH_RESOLUTION_TIMER();
  E_IsInIdleProccess();
 END {idleProc};

 PRIVATE PROCEDURE PutLegendButton(dlgLegend: DIALOG;
                                   Text     : STRING[];
                                   Idx,
                                   sW_Legend: NUMERIC[0]);
  CONST
   pL         = 20;
   pT         = 20;
   Space      = 5;
  VAR
   Id        : STRING[];
   pb        : PUSH_BUTTON;
   Top,
   LabelWidth: NUMERIC[0];
 BEGIN
  Id :="pb_Legend" + L_Str.IntStr(Idx);
  Top:=pT + (sH_LegendBut + Space) * Idx;
  L_GUI.add_Button(dlgLegend, Id, "", "",
                   pL,
                   Top,
                   sW_LegendBut,
                   sH_LegendBut,
                   12, L_GUI.fn_Default,
                   L_General.EMPTY_PROC());

  pb                :=dlgLegend.Controls.Item(Id);
  pb.Visible        :=1;
  pb.OldStyleDrawing:=1;
  L_GUI.SetControlBkColor(pb, Getb_Color(Idx));
  pb.Redraw();

  Id        :="pb_LegendText" + L_Str.IntStr(Idx);
  LabelWidth:=sW_Legend - (pL + sW_LegendBut + Space + pL);
  L_GUI.add_StaticText(dlgLegend, Id, Text,
                       pL + sW_LegendBut + Space, Top, LabelWidth, 20,
                       16, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);

  dlgLegend.Controls.Item(Id).Visible:=1;
 END {PutLegendButton};

 PRIVATE PROCEDURE OnClick_Legend(Self: OBJECT);
  VAR
   dlgLegend : DIALOG;
   i, Idx,
   sW_Legend,
   sH_Legend : NUMERIC[0];
   Text,
   StatePool : STRING[];
 BEGIN
  dlgLegend                 :=DIALOG.Create(dlg);
  dlgLegend.WindowSizeStatus:=DIALOG.WindowSizeStatus_Restored;
  dlgLegend.WindowStyle     :=DIALOG.WindowStyle_FixedSize;
  dlgLegend.CaptionText     :="";
  dlgLegend.AutoPos         :=1;

  sW_Legend:=380;

  StatePool:=GetStatePool();
  i        :=0;
  Idx      :=0;
  LOOP
   Text:=L_Str.PoolItem(StatePool, i);
   IF !Text THEN
    EXIT;
   END;
   IF i # GetTotalAmountState() THEN
    PutLegendButton(dlgLegend, Text, Idx, sW_Legend);
    INC(Idx);
   END;
   INC(i);
  END; (* LOOP *)

  sH_Legend:=20 + sH_LegendBut * Idx + 5 * (Idx-1) + 20;
  dlgLegend.StandardClientWidth :=sW_Legend;
  dlgLegend.StandardClientHeight:=sH_Legend;
  dlgLegend.Redraw();
  dlgLegend.Rect.Right          :=dlgLegend.Rect.Left + dlgLegend.StandardClientWidth * dlg.ScaleX;
  dlgLegend.Rect.Bottom         :=dlgLegend.Rect.Top + dlgLegend.StandardClientHeight * dlg.ScaleY;
  dlgLegend.Visible:=1;
  dlgLegend.Redraw();

  WHILE dlgLegend.Visible DO
   idleProc();
   RENEWDATALAYER();
   dlgLegend.Wait(1);
  END; (*  WHILE dlgLegend.Visible...*)
 END {OnClick_Legend};

 PRIVATE PROCEDURE GetDlgCaptionText(): STRING[];
 BEGIN
  RETURN L_General.GetAPSiteID() + ' - "⮏" ' + L_Str.PoolItem(GetShowModeList(), ShowMode);
 END {GetDlgCaptionText};

 PUBLIC PROCEDURE ChangeShowMode(trgShowMode: tShowMode);
  VAR
   st: STATIC_TEXT;
 BEGIN
  IF trgShowMode # ShowMode THEN
   ShowMode       :=trgShowMode;
   st             :=dlg.Controls.Item(id_Title);
   st.Text        :=GetTitle();
   st.Rect.Right  :=st.Rect.Left + TitleWidth();
   dlg.CaptionText:=GetDlgCaptionText();
   IF ~MapIsLoad[ShowMode] THEN
    PutMap(1);
   ELSE
    RefreshPage();
   END;
   pb_UpdateShowMode();
  END;
 END {ChangeShowMode};

 PRIVATE PROCEDURE OnClick_ShowMode(Self: OBJECT);
 BEGIN
  idleStart:=HIGH_RESOLUTION_TIMER();
  ChangeShowMode(GetNextShowMode());
 END {OnClick_ShowMode};

 PRIVATE PROCEDURE AnyOnSuccessfulChange(    trgValue: NUMERIC[0];
                                             Text    : STRING[];
                                         VAR curMode : NUMERIC[0]);
 BEGIN
  L_General.Assert(~!trgValue, " । " + Text);
  idleStart:=HIGH_RESOLUTION_TIMER();
  curMode  :=trgValue;
  RefreshPage();
 END {AnyOnSuccessfulChange};

 PRIVATE PROCEDURE Dprt_OnSuccessfulChange(Edit: EDIT; Prev: ANYTYPE);
 BEGIN
  AnyOnSuccessfulChange(Edit.Value, "䨫  ⤥", csf_Dprt);
 END {Dprt_OnSuccessfulChange};

 PRIVATE PROCEDURE Purpose_OnSuccessfulChange(Edit: EDIT; Prev: ANYTYPE);
 BEGIN
  AnyOnSuccessfulChange(Edit.Value, "䨫  祭 ", csf_Purpose);
 END {Purpose_OnSuccessfulChange};

 PRIVATE PROCEDURE Column_OnSuccessfulChange(Edit: EDIT; Prev: ANYTYPE);
 BEGIN
  AnyOnSuccessfulChange(Edit.Value, "䨫  ", csf_Column);
 END {Column_OnSuccessfulChange};

 PRIVATE PROCEDURE SortCar_OnSuccessfulChange(Edit: EDIT; Prev: ANYTYPE);
 BEGIN
  AnyOnSuccessfulChange(Edit.Value, "० ஢", cs_SortCar);
 END {SortCar_OnSuccessfulChange};

 PRIVATE PROCEDURE PutEdit(Page       : STRING[];
                           Id         : STRING[];
                           pT         : NUMERIC[0];
                           pL         : NUMERIC[0];
                           sW         : NUMERIC[0];
                           trgCurValue: NUMERIC[0];
                           trgFormat  : STRING[];
                           Proc       : PROC);
 BEGIN
  L_GUI.put_Edit(dlg, Page, Id,
                 pL, pT+10, sW, sH_Buttons-10,
                 fS_Buttons, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_Solid);
  dlg.Controls.Item(Id).Value             :=trgCurValue;
  dlg.Controls.Item(Id).Format            :=trgFormat;
  dlg.Controls.Item(Id).OnSuccessfulChange:=Proc;
 END {PutEdit};

 PRIVATE PROCEDURE TitleWidth(): NUMERIC[0];
 BEGIN
  RETURN sW_Title + (sW_DispDate + sW_MainShift)*(ShowMode = sm_Car);
 END {TitleWidth};

 PRIVATE PROCEDURE GetTitle(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=L_Str.PoolItem(GetShowModeList(), ShowMode) + ". "+ P_Firm.FP_FirmShortName(P_Firm.OWN_FIRM, SYSDATE());
  IF VAR_IMPL.Get(P_Firm.dfpAssigned).Initialized & P_Firm.dfpAssigned THEN
   SEARCH(MyPlace, MyPlace, , P_Firm.defaultMyPlace);
   Result:=Result + " (" + MyPlace.Name + ")";
  END;
  RETURN Result;
 END {GetTitle};

 PRIVATE PROCEDURE CreateMainPage();
 BEGIN
  L_GUI.put_StaticText(dlg, p_ExitMap, id_DispDate, "",
                       pL_DispDate, pT_DispDate, sW_DispDate, sH_DispDate,
                       fS_DispDate, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_ThinRidge);

  L_GUI.put_StaticText(dlg, p_Main, id_Title, GetTitle(),
                       pL_Title, pT_Title, TitleWidth(), sH_Title,
                       fS_Title, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_ThinRidge);

  L_GUI.put_StaticText(dlg, p_Main, id_Clock, "",
                       pL_Clock, pT_Clock, sW_Clock, sH_Clock,
                       fS_Clock, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_ThinRidge);

  L_GUI.put_Border(dlg, p_Main, id_Totals, pL_Totals, pT_Totals, sW_Totals, sH_Totals);
  L_GUI.put_Border(dlg, p_Main, id_Map, pL_Map, pT_Map, sW_Map, sH_Map);
  L_GUI.put_Border(dlg, p_Main, id_BtnsBorder, pL_BtnsBorder, pT_BtnsBorder, sW_BtnsBorder, sH_BtnsBorder);

  L_GUI.put_Button(dlg, p_Main, id_ShowMode, "",
                   pL_ShowMode, pT_Buttons, sW_ShowMode, sH_Buttons,
                   fS_Buttons, L_GUI.fn_Default,
                   PROCREF(OnClick_ShowMode));

  L_GUI.put_Button(dlg, p_Main, id_Legend, "",
                   pL_Legend, pT_Buttons, sW_Legend, sH_Buttons,
                   fS_Buttons, L_GUI.fn_Default,
                   PROCREF(OnClick_Legend));

  L_GUI.put_Button(dlg, p_Main, id_Update, "",
                   pL_Update, pT_Buttons, sW_Update, sH_Buttons,
                   fS_Buttons, L_GUI.fn_Default,
                   PROCREF(OnClick_Update));

  L_GUI.put_Button(dlg, p_Main, id_Close, "",
                   pL_Close, pT_Buttons, sW_Close, sH_Buttons,
                   fS_Buttons, L_GUI.fn_Default,
                   PROCREF(OnClick_Close));

  L_GUI.put_StaticText(dlg, p_CarMap, id_CarFilters,
                       "",
                       pL_AnyFilters, pT_BtnsBorder, sW_CarFilters, sH_BtnsBorder,
                       10,
                       CONTROL.HorizontalAlignment_Left,
                       L_GUI.br_st_ThinRidge);
  dlg.Controls.Item(id_CarFilters).VerticalAlignment:=CONTROL.VerticalAlignment_Top;
  PutEdit(p_CarMap, id_Purpose,
          pT_Buttons, pL_Purpose, sW_Purpose,
          csf_Purpose, GetPurposeList(),
          PROCREF(Purpose_OnSuccessfulChange));
  PutEdit(p_CarMap, id_Column,
          pT_Buttons, pL_Column, sW_Column,
          csf_Column, GetColumnList(),
          PROCREF(Column_OnSuccessfulChange));

  L_GUI.put_StaticText(dlg, p_CarMap, id_Sort,
                       "஢",
                       pL_Sort, pT_BtnsBorder, sW_Sort, sH_BtnsBorder,
                       10,
                       CONTROL.HorizontalAlignment_Left,
                       L_GUI.br_st_ThinRidge);
  dlg.Controls.Item(id_Sort).VerticalAlignment:=CONTROL.VerticalAlignment_Top;
  PutEdit(p_CarMap, id_SortCar,
          pT_Buttons, pL_SortCar, sW_SortCar,
          cs_SortCar, GetSortCarList(),
          PROCREF(SortCar_OnSuccessfulChange));

  L_GUI.put_StaticText(dlg, p_ExitMap, id_ExitFilters,
                       "",
                       pL_AnyFilters, pT_BtnsBorder, sW_ExitFilters, sH_BtnsBorder,
                       10,
                       CONTROL.HorizontalAlignment_Left,
                       L_GUI.br_st_ThinRidge);

  dlg.Controls.Item(id_ExitFilters).VerticalAlignment:=CONTROL.VerticalAlignment_Top;
  PutEdit(p_ExitMap, id_Dprt,
          pT_Buttons, pL_Dprt, sW_Dprt,
          csf_Dprt, GetDprtList(),
          PROCREF(Dprt_OnSuccessfulChange));

  L_GUI.put_StaticText(dlg, p_Main, id_Prompt, "",
                       pL_Prompt, pT_Prompt, sW_Prompt, sH_Prompt,
                       fS_Prompt, CONTROL.HorizontalAlignment_Left,  L_GUI.br_st_ThinRidge);
 END {CreateMainPage};

 PRIVATE PROCEDURE CreateDialog();
 BEGIN
  PROMPT("⮢ 㠫 ꥪ⮢");
  dlg                 :=L_GUI.CreateDialog(0);
  dlg.CaptionText     :=GetDlgCaptionText();
  dlg.ShowMouseCursor :=1;
  dlg.OnClose         :=PROCREF(OnClose_Dialog);
  dlg.WindowSizeStatus:=DIALOG.WindowSizeStatus_Maximized;
  dlg.ToolTipMaxWidth :=600;
  CreateMainPage();
  dlg.Prompt:=dlg.Controls.Item(id_Prompt);
  dlg.Redraw();
 END {CreateDialog};

 PRIVATE PROCEDURE PlayDialog();
 BEGIN
  idleStart     :=HIGH_RESOLUTION_TIMER();
  HRT_RenewClock:=idleStart;
  IF ~VAR_IMPL.Get(HRT_RenewCar).Initialized THEN
   HRT_RenewCar:=HIGH_RESOLUTION_TIMER();
  END;
  IF ~VAR_IMPL.Get(HRT_RenewExit).Initialized THEN
   HRT_RenewExit:=HIGH_RESOLUTION_TIMER();
  END;
  dlg.Visible:=1;
  dlg.Redraw();
  WHILE dlg.Visible DO
   idleProc();
   RENEWDATALAYER();
   dlg.Wait(1);
   IF IsTimeToRenew() THEN
    RenewPage(1, 1);
   END;
  END; (*WHILE dlg.Visible ... *)
 END {PlayDialog};

 PRIVATE PROCEDURE StatusMap();
  VAR
   force: SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  SETZERO(cs_SortCar, csf_Column, csf_Purpose, csf_Status, csf_Dprt, MapIsLoad, force);
  WhiteColor:=RGBCOLOR.Create(255, 255, 255);
  RedColor  :=RGBCOLOR.Create(255, 000, 000);
  BlackColor:=RGBCOLOR.Create(000, 000, 000);
  DispDate  :=L_BegRWS.DspSysDate();
  CreateDialog();
  IF    ShowMode = sm_Car THEN
   force:=~VAR_IMPL.Get(HRT_RenewCar).Initialized | IsTimeToRenew();
  ELSIF ShowMode = sm_Exit THEN
   force:=~VAR_IMPL.Get(HRT_RenewExit).Initialized | IsTimeToRenew();
  END;

  PutMap(force);
  PlayDialog();
 END {StatusMap};

 PUBLIC PROCEDURE StatusMapByCar();
 BEGIN
  ShowMode:=sm_Car;
  StatusMap();
 END {StatusMapByCar};

 PUBLIC PROCEDURE StatusMapByExit();
 BEGIN
  ShowMode:=sm_Exit;
  StatusMap();
 END {StatusMapByExit};

END.
