(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     । ⮣ ⥫ ⠭⭮ 室,
%Purpose     ஫ 䨪樨 室
%Type        control
%Specific    AP
%Modified    06.08.2014 12:07:31 POLAK\GAV
*)

 MODULE StExit [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_Events, L_Way, L_StdFrm, L_OwnData, L_WDO, L_Str, L_BegRWS, L_Prop,
        L_RT, L_AFM, P_Exit, Math, E_Way, L_Env, L_APtm, L_AR, L_SysLog, L_DBD, L_r2r;

 PRIVATE CONST
  ReservedExit = 000000001;
  TripsPerExit = 100;

 PRIVATE PROCEDURE AssertUseInRWayS(Cond: SCAL[2]; Text: STRING[]);
 BEGIN
  L_General.Assert(Cond,
                   Text+","+
                   "|⠪  室 ᯮ   (ਬ,  "+RWayS.RWayS+", "+L_Str.PoolItem(L_Way.rwsStat_Pool, RWayS.Status)+")");
 END {AssertUseInRWayS};

 PRIVATE PROCEDURE AssertBegTime(Cond: SCAL[2]);
 BEGIN
  L_General.Assert(Cond,
                   "६ 砫 室   ,"+
                   "|⠪  室 ᯮ   (ਬ,  "+RWayS.RWayS+")."+
                   "|室 ।⥫쭮 ᪫ ᯮ짮 室"+
                   "| ࠧ殮   ॠ묨 ࠡ⭨");
 END {AssertBegTime};

 PRIVATE PROCEDURE CheckAllowedExitClssForCurrentExit();
  VAR
   Composition: SCAL[2][30];
   _ActivKnd: LIKE(StExit.ActivKnd);
   wd     : L_DatTim.tWeekday;
   BegDate,
   EndDate: DATE;
   _AddMsg: STRING[];
   _Exit: LIKE(StExit.Exit);
 BEGIN
  IF ~!StExit.ExitClss THEN (* 室    ᮬ*)
   IF L_Events.IsAfterEditInsertEvents(MODE) THEN
    _AddMsg:="|६  ࠭ 室,   ⠪  ⮩,   ";
   ELSE
    _AddMsg:="";
   END;
   _ActivKnd:=StExit.ActivKnd;
   SAVE(StExit);
   CONFORM(StExit, ExitClss);
   L_General.Assert(StExit.Strict = ExitClss.Strict, " ᮢ 'ࠪ' 室   室");
   BegDate:=StExit.FromD;
   EndDate:=StExit.UpDate;
   _Exit  :=StExit.Exit;
   IF ExitClss.Strict = L_Way.ExitStrict_Reg THEN
    SETZERO(Composition);
    IF    StExit.ActivKnd = L_Way.seak_OnDays THEN
     FOR_EACH wd DO
      Composition[10*StExit.Change + wd]:=StExit.OnDays[wd];
     END;
    ELSIF StExit.ActivKnd =L_Way.seak_EveryOtherDay THEN
     Composition[10*StExit.Change + Math.Mod(StExit.FromD-L_DatTim.MINDATE(), 2)]:=1;
    ELSE
     L_General.CallUs(0);
    END;

    SETSEL(StExit, ECUpDate, ExitClss.ExitClss);
    SRCINSEL(StExit, GT, , Math.Max(BegDate, 31\12\2006));
    WHILE OCCURE(StExit) DO
     IF (StExit.Exit # _Exit) & L_DatTim.IsActiveInIntvl(BegDate, EndDate, StExit.FromD, StExit.UpDate) THEN
      L_General.Assert(StExit.ActivKnd = _ActivKnd, " ⠢  室 "+ ExitClss.ExitClss +
                                                    "|室 "+StExit.Exit+ "  "+L_Str.PoolItem(L_Way.seak_Pool, StExit.ActivKnd));
      IF   StExit.ActivKnd = L_Way.seak_OnDays THEN
       FOR_EACH wd DO
        IF StExit.OnDays[wd] THEN
         IF StExit.Change = 0 THEN
          L_General.Assert((Composition[wd] = 0) & (Composition[10+wd] = 0) & (Composition[20+wd] = 0),
                          " ⠢  室 " + ExitClss.ExitClss +
                          "|室 "+StExit.Exit+ "   " + L_DatTim.WeekDayStr(wd, 3) +
                          "  ᬥ "+StExit.Change + _AddMsg);
         ELSE
          L_General.Assert((Composition[wd] = 0) & (Composition[10*StExit.Change+wd] = 0),
                          " ⠢  室 " + ExitClss.ExitClss +
                          "|室 "+StExit.Exit+ "   " + L_DatTim.WeekDayStr(wd, 3) +
                          "  ᬥ "+StExit.Change + _AddMsg);
         END;
        END;
       END;
      ELSIF StExit.ActivKnd =L_Way.seak_EveryOtherDay THEN
       IF StExit.Change = 0 THEN
        L_General.Assert((Composition[0  + Math.Mod(StExit.FromD-L_DatTim.MINDATE(), 2)] = 0) &
                         (Composition[10 + Math.Mod(StExit.FromD-L_DatTim.MINDATE(), 2)] = 0) &
                         (Composition[20 + Math.Mod(StExit.FromD-L_DatTim.MINDATE(), 2)] = 0),
                        " ⠢  室 " + ExitClss.ExitClss +
                        "|室 "+StExit.Exit+ "   ᬥ "+StExit.Change + _AddMsg);
       ELSE
        L_General.Assert((Composition[0                + Math.Mod(StExit.FromD-L_DatTim.MINDATE(), 2)] = 0) &
                         (Composition[10*StExit.Change + Math.Mod(StExit.FromD-L_DatTim.MINDATE(), 2)] = 0),
                        " ⠢  室 " + ExitClss.ExitClss +
                        "|室 "+StExit.Exit+ "   ᬥ "+StExit.Change + _AddMsg);
       END;
      ELSE
       L_General.CallUs(0);
      END;
     END;
     NEXT(StExit);
    END;
   END;
   RESTORE(StExit);
  END;
 END {CheckAllowedExitClssForCurrentExit};

 PRIVATE PROCEDURE SetOnDaysVisible();
  VAR
   i     : SCAL[RANGEOF(StExit.OnDays)];
   Fields: FORM_FIELDS;
   v     : SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  v     :=StExit.ActivKnd = L_Way.seak_OnDays;
  FOR_EACH i DO
   Fields("StExit.OnDays["+i+"]").Visible:=v;
  END;
  Fields("StExit.ClndAppl").Visible:=v;
 END {SetOnDaysVisible};

 PRIVATE PROCEDURE SEJobs_0_OnReposition();
 BEGIN
  IF ACCESS(StExit) THEN
   SetOnDaysVisible();
  END;
 END {SEJobs_0_OnReposition};

 PRIVATE PROCEDURE StExit_OnInitializeWindow();
 BEGIN
  L_WDO.iField       (0, "StExit.ActivKnd").Format:=L_Way.seak_Pool;
  L_WDO.iWindow().OnOpenWindow:=~!RTI.Get().CurWindow.ParentZone;
  L_WDO.iSubwindow   (1, "SEJobs");
 END {StExit_OnInitializeWindow};

 PRIVATE PROCEDURE StExit_OnOpenWindow();
  VAR
   prnTableName: STRING[];
   z           : FORM_ZONE;
 BEGIN
  prnTableName:=RTI.Get().CurWindow.ParentZone.MasterTable.Name;
  TRY [RESTORE_CURSORS(RC_ON)]
   RTI.Get().TryBlock.AccessDataMode:=adm_HOTTEST;
   GE_WZD_CURSOR(RTI.Get().CurWindow.ParentZone.Window.Name, RTI.Get().CurWindow.ParentZone.Number, (prnTableName));
   IF prnTableName # "RWayS" THEN
    FOR_EACH z IN RTI.Get().CurWindow.ParentZone.Window.Zones DO
     IF z.MasterTable.Name = "RWayS" THEN
      GE_WZD_CURSOR(z.Window.Name, z.Number, RWayS);
     END;
    END;
   END;
   IF OCCURE(RWayS) THEN
    RTI.Get().CurWindow.Zones(1).PermanentFilter:="(StExit.FromD<=" + FLDTOSTR(RWayS.Date) + ")&(StExit.UpDate>" + FLDTOSTR(RWayS.Date) + ")";
(*
   ELSE
    SETEMPTY(RTI.Get().CurWindow.Zones(1).PermanentFilter);
*)
   END;
  EXCEPT
  END; (* TRY *)
 END {StExit_OnOpenWindow};

 PRIVATE PROCEDURE SEJobs_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="StExit";
  L_WDO.iEvents    (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iScsChange (0, ["StExit.ActivKnd", "StExit.FromD"]);
  L_WDO.iMayBeEmpty(0, ["StExit.MaxPV", "StExit.GuETime", "StExit.GuBTime", "StExit.UpDate"]);
  L_WDO.iField     (0, "StExit.Strict").Format:=L_Way.ExitStrict_ShortPool;
  L_WDO.iField     (0, "StExit.ActivKnd").Format:=L_Way.seak_Pool;
  L_WDO.iZone      (0).RLevProg:="StExit";
  L_WDO.iZone      (0).FLevProg:="StExit";
  L_WDO.iEvents    (1, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete]);

  IF !RTI.Get().CurWindow.ParentZone                               |
     (RTI.Get().CurWindow.ParentZone.MasterTable.Name = "StExit" ) |
     (RTI.Get().CurWindow.ParentZone.MasterTable.Name = "ExitIPL") THEN
   L_WDO.iZone(0).SetMaster(TABLE.Get("StExit"));
   L_WDO.iWindow().OnOpenWindow:=0;
  ELSE
   L_WDO.iZone(0).SetMaster(TABLE.Get("SEJobs"));
   L_WDO.iWindow().OnOpenWindow:=1;
  END;
  L_WDO.iWindow().SetMaster(L_WDO.iZone(0).MasterTable);
  L_WDO.iSubwindow (1, "SEJobsE");
 END {SEJobs_OnInitializeWindow};

 PRIVATE PROCEDURE SEJobs_OnOpenWindow();
  VAR
   prnTableName: STRING[];
 BEGIN
  prnTableName:=RTI.Get().CurWindow.ParentZone.MasterTable.Name;
  TRY [RESTORE_CURSORS(RC_ON)]
   RTI.Get().TryBlock.AccessDataMode:=adm_HOTTEST;
   GE_WZD_CURSOR(RTI.Get().CurWindow.ParentZone.Window.Name, RTI.Get().CurWindow.ParentZone.Number, (prnTableName));
   IF prnTableName # "RWayJ" THEN
    L_General.CallUs(0);
   END;
   CONFORM(RWayJ, RWayS);
   RTI.Get().CurWindow.Zones(1).PermanentFilter:="(SEJobs.FromD<=" + FLDTOSTR(RWayS.Date) + ")&(SEJobs.UpDate>" + FLDTOSTR(RWayS.Date) + ")";
  EXCEPT
  END; (* TRY *)
 END {SEJobs_OnOpenWindow};

 PRIVATE PROCEDURE IsWorkSEJobs(): SCAL[2];
 BEGIN
  RETURN (L_Way.SEJobsWithPlIncome(StExit.FromD) | L_APtm.IsOG()) & (WJMode.RunSel = L_Way.runsel_Work);
 END {IsWorkSEJobs};

 PUBLIC PROCEDURE intRecalculate();
  VAR
   TotT,
   LineT,
   NightT,
   CompT,
   ZeroT,
   RestT,
   CurTime: FLOAT;
   PaidT  : LIKE(StExit.PaidT);
 BEGIN
  SETZERO(TotT, LineT, NightT, PaidT, CompT, ZeroT, RestT,
          StExit.PaidRun, StExit.Run, StExit.ZeroRun, StExit.TripAm);
  SELECT(SEJobs, Exit, , StExit.Exit);
  StExit.BegDay :=SEJobs.Day;
  StExit.BegTime:=SEJobs.StartT;
  WHILE OCCURE(SEJobs) DO
   PROMPT(SEJobs.Trip);
   CONFORM(SEJobs, WJMode, Route);
   CONFORM(SEJobs, RoutMod);
   CurTime:=SEJobs.StopT - SEJobs.StartT;
   INC(CompT, CurTime);
   IF WJMode.WJType # L_Way.WJType_Void THEN
    INC(TotT,   CurTime); 
    INC(NightT, TIMEINT(SEJobs.StartT, SEJobs.StopT, 22:00, 06:00));
    IF (WJMode.WJType = L_Way.WJType_Work) & (WJMode.RunSel # L_Way.runsel_None) THEN
     INC(LineT, CurTime);
    END;
   ELSE
    INC(RestT, CurTime); 
   END;
   IF L_Way.SEJobsWithPlIncome(StExit.FromD) THEN
    INC(PaidT, CurTime);
    IF WJMode.RunSel = L_Way.runsel_Work THEN
     INC(StExit.PaidRun, RoutMod.Run);
    END;
   END;
   IF IsWorkSEJobs() THEN
    INC(StExit.TripAm);
   END;
   IF WJMode.RunSel = L_Way.runsel_Zero THEN
    INC(ZeroT,   CurTime);
    INC(StExit.ZeroRun, RoutMod.Run);
   END;
   StExit.StopTim:=SEJobs.StopT;
   INC(StExit.Run, RoutMod.Run);
   SEJobs.TooOld :=0;
   SEJobs.FromD  :=StExit.FromD;
   SEJobs.UpDate :=StExit.UpDate;
   REPLACE(SEJobs);
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs ... *)
  StExit.TotT  :=TotT;
  StExit.LineT :=LineT;
  StExit.NightT:=NightT;
  StExit.PaidT :=PaidT;
  StExit.CompT :=CompT;
  StExit.ZeroT :=ZeroT;
  StExit.RestT :=RestT;
  REPLACE(StExit);
 END {intRecalculate};

 PRIVATE PROCEDURE StExit_OnAfterEdIns();
  VAR 
   PrevStopT: NUMERIC[3];
   TripNum,
   TripCod  : NUMERIC[0];
   ExitCod  : LIKE(StExit.Exit);
 BEGIN
  ACCESS(StExit);
  APP.Get().NewPrompt(StExit.Exit);
  L_General.Assert((StExit.Exit # MAXOF(StExit.Exit)) & (StExit.Exit # ReservedExit), "  室   ᯮ짮");
  L_General.Assert(SELECT(SEJobs, Exit, StExit.Exit), "室    ࠩ   ३");
  CheckAllowedExitClssForCurrentExit();

  IF SELECT(RWayS, sExit, L_Way.rwsStat_Ordered, StExit.Exit) & (StExit.BegTime#SEJobs.StartT) THEN
   WHILE OCCURE(RWayS) DO
    AssertBegTime(~L_Env.RealTSN(RWayS.TSN));
    SELECT(WayLMen, RWayS, , RWayS.RWayS);
    WHILE OCCURE(WayLMen) DO
     AssertBegTime(~L_Env.RealTSN(WayLMen.TSN));
     NEXT(WayLMen);
    END; (* WHILE OCCURE(WayLMen) ... *)
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
  END;

  PrevStopT:=L_Way.FullBegTime(SEJobs.Day, SEJobs.StartT);
  TripNum  :=0;
  WHILE OCCURE(SEJobs) DO
   PROMPT("஢ઠ.  " + SEJobs.Trip);
   CALL(SEJobs.CheckTripLength(0));
   INC(TripNum);
   IF SELECT(SEJMStop, Trip, SEJobs.Trip) THEN
    CONFORM(SEJobs, RoutMod);
    IF SEJobs.Dir = RoutMod.Dir THEN
     LAST(SEJMStop);
    END;
    L_General.Assert(SEJobs.StopT = SEJobs.StartT + SEJMStop.ATim / 60,
                     " " + SEJobs.Trip + "|" +
                     "筥 ६ 砭 ३|" +
                     " ᮮ⢥ 㪠  ३:| |" +
                     "६ 砭 ३     : " + L_DatTim.TimeStr(SEJobs.StopT) + "|" +
                     "筥 ६ 砭: " + L_DatTim.TimeStr(SEJobs.StartT + SEJMStop.ATim / 60));
   END;
   IF StExit.Strict > L_Way.ExitStrict_Fict THEN
    L_General.Assert(L_Way.FullBegTime(SEJobs.Day, SEJobs.StartT) = PrevStopT,
                     " ᮡ 楯窠 ६| " + SEJobs.Trip);
    TripCod:=SEJobs.Trip MOD 100;
    ExitCod:=SEJobs.Trip DIV 100;
    L_General.Assert((TripNum = TripCod) & (StExit.Exit = ExitCod),
                      "ࠢ쭠 ஢ ३: " + SEJobs.Trip +
                      "||믮 ४஢ ३ᮢ");
   END;
   PrevStopT     :=L_Way.FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT);
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs ... *)

  intRecalculate();

  IF StExit.ActivKnd # L_Way.seak_OnDays THEN
   SETZERO(StExit.OnDays);
  END;
  REPLACE(StExit);
  IF ~!PROCREF(E_Way.AdditionalStExitCheck) THEN
   E_Way.AdditionalStExitCheck();
  END;
  IF StExit.Strict = L_Way.ExitStrict_Reg THEN
   L_DBD.CheckOwnersValidity("StExit");
  END;
 END {StExit_OnAfterEdIns};

 PRIVATE PROCEDURE HasOnDaysUnset(): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  IF (StExit.ActivKnd # L_Way.seak_OnDays) & (StExit.ActivKnd # GE_PVALUE(StExit.ActivKnd)) THEN
   RETURN 1;
  END;
  i:=0;
  WHILE i <= HIGH(StExit.OnDays) DO
   IF ~StExit.OnDays[i] & GE_PVALUE(StExit.OnDays[i]) THEN
    RETURN 1;
   END;
   INC(i);
  END;
  RETURN 0;
 END {HasOnDaysUnset};

 PRIVATE PROCEDURE StExit_OnAfterEdit();
 BEGIN
  IF (StExit.FromD # GE_PVALUE(StExit.FromD)) & SELECT(RWayS, Exit, StExit.Exit) THEN
   AssertUseInRWayS(RWayS.Date>=StExit.FromD, "  室     "+L_DatTim.DateStr(RWayS.Date));
  END;
  IF (StExit.UpDate # GE_PVALUE(StExit.UpDate)) & SELECT(RWayS, Exit, StExit.Exit) THEN
   LAST(RWayS);
   AssertUseInRWayS(RWayS.Date<StExit.UpDate, "  室    "+L_DatTim.DateStr(RWayS.Date));
  END;
  IF HasOnDaysUnset() THEN
   SELECT(RWayS, Exit, , StExit.Exit);
   WHILE OCCURE(RWayS) DO
    IF ~L_Way.StExitActiveOnDate(StExit.Exit, RWayS.Date) THEN
     IF    StExit.ActivKnd = L_Way.seak_OnDays THEN
      SEARCH(Calendar, Date, , RWayS.Date);
      AssertUseInRWayS(0, "஢  ⢨   ");
     ELSIF StExit.ActivKnd = L_Way.seak_EveryOtherDay THEN
      AssertUseInRWayS(0, "室  ⢮  "+L_DatTim.DateStr(RWayS.Date));
     ELSE
      L_General.CallUs(0);
     END;
    END;
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
  END;

  StExit_OnAfterEdIns();
 END {StExit_OnAfterEdit};

 PRIVATE PROCEDURE StExit_OnAfterInsert();
 BEGIN
  StExit_OnAfterEdIns();
 END {StExit_OnAfterInsert};

 PRIVATE PROCEDURE StExit_OnBeforeDelete();
 BEGIN
  SELECT(SEJobs, Exit, , StExit.Exit);
  WHILE OCCURE(SEJobs) DO
   PROMPT(StExit.Exit + " " + SEJobs.Trip);
   L_General.Assert(~SELECT(RWayJ, Trip, SEJobs.Trip),
                    " 室 㤠  ,|" +
                    "..  ३ 㯮  ⥢ ");
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs ... *)

  SELECT(rtExit, Exit, , StExit.Exit);
  REMSEL(rtExit);
 END {StExit_OnBeforeDelete};

 PRIVATE PROCEDURE CopySEJobs(_Exit: LIKE(StExit.Exit));
  VAR
   TripNo: SCAL[99];
   _Trip : LIKE(SEJobs.Trip);
 BEGIN
  CONFORM(StExit, SEJobs);
  TripNo:=01;
  WHILE OCCURE(SEJobs) DO
   PROMPT("஢ ३ᮢ " + TripNo);
   SAVE(SEJobs);
   _Trip:=_Exit * TripsPerExit + TripNo;
   IF SEARCH(SEJobs, Trip, _Trip) THEN
    L_General.Error(" " + _Trip + " 㦥   室 " + SEJobs.Exit +
                    "|४  ३");
   END;
   RESTORE(SEJobs);
   SAVE(SEJobs);
   SELECT(SEJMStop, Trip, , SEJobs.Trip);
   WHILE OCCURE(SEJMStop) DO
    SAVE(SEJMStop);
    SEJMStop.Trip:=_Trip;
    INSERT(SEJMStop);
    RESTORE(SEJMStop);
    NEXT(SEJMStop);
   END; (* WHILE OCCURE(SEJMStop)... *)
   SEJobs.Exit:=_Exit;
   SEJobs.Trip:=_Trip;
   PROMPT(SEJobs.Trip);
   INSERT(SEJobs);
   RESTORE(SEJobs);
   NEXT(SEJobs);
   INC(TripNo);
  END;
 END {CopySEJobs};

 PRIVATE PROCEDURE MakeCopyStExit(PatStExit, NewExit: LIKE(StExit.Exit); trgFromD: DATE);
 BEGIN
  SAVE(StExit);
  SEARCH(StExit, Exit, , PatStExit);
  CopySEJobs(NewExit);
  RESTORE(StExit);
  L_DBD.CopyFromSrcRecord("StExit", PatStExit);
  StExit.Exit :=NewExit;
  StExit.FromD:=trgFromD;
  REPLACE(StExit);
 END {MakeCopyStExit};

 PRIVATE PROCEDURE StExit_OnBeforeEdit();
 BEGIN
  L_AR.GrantRightsForInteractiveModification();
 END {StExit_OnBeforeEdit};

 PRIVATE PROCEDURE StExit_OnBeforeInsert();
  VAR
   srcStExit: LIKE(StExit.Exit);
 BEGIN
  L_AR.GrantRightsForInteractiveModification();
  srcStExit:=L_WDO.GetInsertionSource();
  IF ~!srcStExit THEN
   IF STRTOFLD(L_WDO.GetEnvVarValue("MakeNewVersion"), SCAL) = 1 THEN
    intMakeNewVersion(srcStExit);
   ELSE
    MakeCopyStExit(srcStExit, ReservedExit, EMPTYOF(DATE));
   END;
  END;
 END {StExit_OnBeforeInsert};

 PRIVATE PROCEDURE StExit_ActivKnd_OnSuccessfulChange();
 BEGIN
  SetOnDaysVisible();
 END {StExit_ActivKnd_OnSuccessfulChange};

 PRIVATE PROCEDURE StExit_FromD_OnSuccessfulChange();
  VAR
   srcStExit: LIKE(StExit.Exit);
   srcRI    : LIKE(StExit.RECORDID);
 BEGIN
  srcStExit:=L_WDO.GetInsertionSource();
  IF ~!srcStExit & (STRTOFLD(L_WDO.GetEnvVarValue("MakeNewVersion"), SCAL) = 0) THEN
   IF ~!GE_PVALUE() THEN
    L_StdFrm.Choice(" ᢮⢠,   窥, ९  㤠" +
                    "| ⠢ , 㠫  " + L_DatTim.DateStr(StExit.FromD));
    SELECT(ExitPro, Exit, , StExit.Exit);
    WHILE OCCURE(ExitPro) DO
     L_Prop.RemoveCurrentPro("ExitPro");
    END; (* WHILE OCCURE(ExitPro) ... *)
   END;
   SAVE(StExit);
   SEARCH(StExit, Exit, , srcStExit);
   srcRI:=StExit.RECORDID;
   RESTORE(StExit);
   L_Prop.CopyProRecords("StExit", srcRI, StExit.RECORDID);
   CopyBorrow(srcStExit, StExit.Exit, StExit.FromD);
  END;
 END {StExit_FromD_OnSuccessfulChange};

 PRIVATE PROCEDURE ECExit_OnInitializeWindow();
 BEGIN
  L_WDO.iZone     (1).Narrowing:="StExit.ExitClss=ExitClss.ExitClss";
  L_WDO.iSubwindow(1, "SEJobs");
  L_WDO.iField    (1, "StExit.Strict").Format:=L_Way.ExitStrict_ShortPool;
 END {ECExit_OnInitializeWindow};

 PRIVATE PROCEDURE SetOperating(OnWorkDays, OnRestDays: SCAL[2]);
 BEGIN
  StExit.ActivKnd:=L_Way.seak_OnDays;
  StExit.OnDays[L_DatTim.wd_Mon]:=OnWorkDays;
  StExit.OnDays[L_DatTim.wd_Tue]:=OnWorkDays;
  StExit.OnDays[L_DatTim.wd_Wed]:=OnWorkDays;
  StExit.OnDays[L_DatTim.wd_Thu]:=OnWorkDays;
  StExit.OnDays[L_DatTim.wd_Fri]:=OnWorkDays;
  StExit.OnDays[L_DatTim.wd_Sat]:=OnRestDays;
  StExit.OnDays[L_DatTim.wd_Sun]:=OnRestDays;
  StExit.OnDays[L_DatTim.wd_Hol]:=OnRestDays;
  REPLACE(StExit);
  SetOnDaysVisible();
 END {SetOperating};

 PUBLIC PROCEDURE SetOperatingOnAllDays();
 BEGIN
  SetOperating(1, 1);
 END {SetOperatingOnAllDays};

 PUBLIC PROCEDURE SetOperatingOnWorkDays();
 BEGIN
  SetOperating(1, 0);
 END {SetOperatingOnWorkDays};

 PUBLIC PROCEDURE SetOperatingOnRestDays();
 BEGIN
  SetOperating(0, 1);
 END {SetOperatingOnRestDays};

 PUBLIC PROCEDURE SetNameByRoute();
 BEGIN
  CONFORM(StExit, SEJobs);
  L_General.Assert(OCCURE(SEJobs), " 㪠   ३ 室");
  CONFORM(SEJobs, Route);
  IF NEXT(SEJobs) THEN
   CONFORM(SEJobs, Route);
  END;
  IF ~!StExit.Name THEN
   L_StdFrm.Warning(" 㦥 㪠. ?");
  END;
  StExit.Name:=Route.Name;
  REPLACE(StExit);
 END {SetNameByRoute};

 PUBLIC PROCEDURE SetNameByExitClass();
 BEGIN
  L_General.Assert(~!StExit.ExitClss, " 㪠  室");
  CONFORM(StExit, ExitClss);
  IF ~!StExit.Name THEN
   L_StdFrm.Warning(" 㦥 㪠. ?");
  END;
  StExit.Name:=ExitClss.Name;
  REPLACE(StExit);
 END {SetNameByExitClass};

(*
$P{ el_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_cd(), L, "D.N.y"
@
####################################################################################################################               ########## #####
=#####=============================================================================================================================================
|                                                                室  ##########                                                             |
}
*)

(*
$P{ el_StrictTop:
?, L, "⨢|裂|"
@
|=================================================================================================================================================|
|###################################                                                                                                              |
|-------------------------------------------------------------------------------------------------------------------------------------------------|
|      |                    |   |    |      |C|||||஡|. .|. .|. .|
|---------|--------------------------------|-----------------------|----------|----------|-----|-----|---|---|--|------|--------|--------|--------|
}
*)

(*
$P{ el_Line:
StExit.Exit, L, ""
StExit.Name, L, ""
L_Way.StExitOnDaysAsStr(), L, ""
StExit.FromD, L, "D.N.y"
StExit.UpDate, L, "D.N.y"
L_Way.FullStExitBegTimeStr(), L, ""
L_Way.FullStExitStopTimStr(), L, ""
StExit.Change, L, ""
StExit.Gap, L, "-|+"
StExit.TripAm, R, ""
StExit.Run, R, "1."
StExit.TotT, R, "3."
StExit.LineT, R, "3."
StExit.PaidT, R, "3."
@
|#########|################################|#######################|##########|##########|#####|#####| # | # |##|######|########|########|########|
}
*)

(*
$P{ el_Bot:
@
=() Polak=========================================================================================================================================}
*)

 PRIVATE PROCEDURE el_CreateTmp();
 BEGIN
  CreateFILE(el);
  CreateFIELD(el, Strict, LIKE(StExit.Strict));
  CreateFIELD(el, Exit,   LIKE(StExit.Exit));
  CreateINDEX(el, Strict, UNIQUE, , , Strict, Exit);
  SetVersionOfFILE(el, 0);
  L_AFM.AF_CreateTemp("el", "el");
 END {el_CreateTmp};

 PRIVATE PROCEDURE el_Gather();
 BEGIN
  APP.Get().NewPrompt("");
  el_CreateTmp();
  SELECT(StExit, Exit);
  WHILE OCCURE(StExit) DO
   PROMPT(StExit.Exit);
   IF L_DatTim.IsActive(Memo.ud_cd(), StExit.FromD, StExit.UpDate) THEN
    el.Strict:=StExit.Strict;
    el.Exit  :=StExit.Exit;
    INSERT(el);
   END;
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit) ... *)
 END {el_Gather};

 PUBLIC PROCEDURE ExitL();
  CONST
   el_RepName = "ExitL";
 BEGIN
  el_Gather();
  APP.Get().NewPrompt("");
  OPENREP(R, L_General.NameConnection(el_RepName), Create);
  MAKEPART(R, el_Top, el_RepName);
  SETSEL(el, Strict);
  LAST(el);
  WHILE OCCURE(el) DO
   NARROWSEL(el, Strict);
   FIRST(el);
   MAKEPART(R, el_StrictTop, el.Strict);
   WHILE OCCURE(el) DO
    SEARCH(StExit, Exit, , el.Exit);
    PROMPT(StExit.Exit);
    MAKEPART(R, el_Line);
    NEXT(el);
   END; (* WHILE OCCURE(el) ... *)
   FIRST(el);
   CHANGESEL(el, Strict);
   PREV(el);
  END; (* WHILE OCCURE(el) ... *)
  MAKEPART(R, el_Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {ExitL};

(*
$P{ StExt_Top1:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
"   "+StExit.Exit+" "+StExit.Name, L, ""
StExit.Change, L, "|1-|2-"
StExit.Gap, L, "-|+"
StExit.FromD, L, "D.N.y"
StExit.UpDate, L, "D.N.y"
L_Way.StExitOnDaysAsStr(), L, ""
@
####################################################################################################  ########## #####
=#####================================================================================================================
|####################################################################################################################|
|--------------------------------------------------------------------------------------------------------------------|
|                                                                                      |
| ###         #       ##########   ##########       ####################################################             |
|====================================================================================================================|
|       |                                         |. ||६ |  |஡| ࠡ            |
}
*)

(*
$P{ StExt_Line1:
SEJobs.Trip, L, ""
SEJobs.Route, L, ""
SEJobs.Modif, L, ""
RoutMod.Name, L, ""
SEJobs.StartT, L, "H:M"
SEJobs.StopT, L, "H:M"
SEJobs.StopT-SEJobs.StartT, R, "3."
TIMEINT(SEJobs.StartT, SEJobs.StopT, 22:00, 06:00), R, "3."
RoutMod.Run, R, "1."
SEJobs.WJCode, L, ""
WJMode.Name, L, ""
@
|-----------|------------------------------------------------|-----|-----|------|------|------|----------------------|
|###########|####-### #######################################|#####|#####|######|######|######|## ###################|
}
*)

(*
$P{ StExt_Top2:
@
|================================================================================================================|===|
|                                             ⥫  ⠬                                            |   |
|----------------------------------------------------------------------------------------------------------------|---|
|                       |                                 ६                                 |     ஡     |   |
|                |-----------------------------------------------------------------------|----------------| |
|                       |   ᥣ|   饥|    | |    |   |  ⮩| 㫥|  騩| 㫥|   |
}
*)

(*
$P{ StExt_Line2:
Route.Route, L, ""
Route.Name, L, ""
StEx1.TotTim, R, "3."
StEx1.WrkTim, R, "3."
StEx1.TotTim-StEx1.WrkTim, R, "3."
StEx1.IncTim, R, "3."
StEx1.NightTim, R, "3."
StEx1.LinTim, R, "3."
StEx1.SettlTim, R, "3."
StEx1.ZeroTim, R, "3."
StEx1.TotRun, R, "1."
StEx1.ZeroRun, R, "1."
StEx1.TripAm, R, "0"
@
|-----------------------|--------|--------|--------|--------|--------|--------|--------|--------|-------|--------|---|
|#### ##################|########|########|########|########|########|########|########|########|#######|########|###|
}
*)

(*
$P{ StExt_Bot2:
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "3."
?, R, "1."
?, R, "1."
?, R, "0"
@
|=======================|========|========|========|========|========|========|========|========|=======|========|---|
|⮣  室        |########|########|########|########|########|########|########|########|#######|########|###|
=(c) Polak============================================================================================================
}
*)

 PRIVATE PROCEDURE CreateTemp();
 BEGIN
  CreateFILE(StEx1);

  CreateFIELD(StEx1, Route,    LIKE(SEJobs.Route));
  CreateFIELD(StEx1, TotTim,   NUMERIC[3], "", "0", "", "", "");
  CreateFIELD(StEx1, WrkTim,   NUMERIC[3], "", "0", "", "", "");
  CreateFIELD(StEx1, IncTim,   NUMERIC[3], "", "0", "", "", "");
  CreateFIELD(StEx1, NightTim, NUMERIC[3], "", "0", "", "", "");
  CreateFIELD(StEx1, LinTim,   NUMERIC[3], "", "0", "", "", "");
  CreateFIELD(StEx1, SettlTim, NUMERIC[3], "", "0", "", "", "");
  CreateFIELD(StEx1, ZeroTim,  NUMERIC[3], "", "0", "", "", "");
  CreateFIELD(StEx1, TotRun,   NUMERIC[2], "", "0", "", "", "");
  CreateFIELD(StEx1, ZeroRun,  NUMERIC[2], "", "0", "", "", "");
  CreateFIELD(StEx1, TripAm,   NUMERIC[0], "", "0", "", "", "");

  CreateINDEXandLINK(StEx1, Route, UNIQUE, Route, Route, USER, "", "", Route);

  SetVersionOfFILE(StEx1, 1);
  L_AFM.CreateTemp("StEx1");
 END {CreateTemp};

 PUBLIC PROCEDURE StExt();
  CONST
   RepName = "StExt";
  VAR
   TTripAm   : NUMERIC[0];
   TTotTim,
   TWrkTim,
   TIncTim,
   TNightTim,
   TLinTim,
   TSettlTim,
   TZeroTim  : NUMERIC[3];
   TTotRun,
   TZeroRun  : NUMERIC[2];
 BEGIN
  L_General.Assert(ACCESS(StExit), " ⠭ 室");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  CreateTemp();
  MAKEPART(R, StExt_Top1, RepName);
  SELECT(SEJobs, Exit, , StExit.Exit);
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, RoutMod);
   CONFORM(SEJobs, Route);
   CONFORM(SEJobs, WJMode);
   ADD(StEx1, Route, , SEJobs.Route,
          StEx1.TotTim,   SEJobs.StopT - SEJobs.StartT,
          StEx1.TotRun,   RoutMod.Run);
   IF    WJMode.WJType # L_Way.WJType_Void THEN
    INC(StEx1.WrkTim,   SEJobs.StopT - SEJobs.StartT);
    INC(StEx1.NightTim, TIMEINT(SEJobs.StartT, SEJobs.StopT, 22:00, 06:00));
   END;
   IF    WJMode.RunSel = L_Way.runsel_Zero THEN
    INC(StEx1.ZeroTim,   SEJobs.StopT - SEJobs.StartT);
    INC(StEx1.ZeroRun,   RoutMod.Run);
   END;
   IF (WJMode.RunSel # L_Way.runsel_None) & (WJMode.WJType = L_Way.WJType_Work) THEN
    INC(StEx1.LinTim,   SEJobs.StopT - SEJobs.StartT);
   END;
   IF L_Way.SEJobsWithPlIncome(StExit.FromD) THEN
    INC(StEx1.IncTim,   SEJobs.StopT - SEJobs.StartT);
   END; (* IF WJMode ... *)
   IF L_Way.E_IsResInLine(StExit.UpDate) THEN
    INC(StEx1.SettlTim,   SEJobs.StopT - SEJobs.StartT);
   END; (* IF WJMode ... *)
   IF IsWorkSEJobs() THEN
    INC(StEx1.TripAm);
   END;
   REPLACE(StEx1);
   MAKEPART(R, StExt_Line1);
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
  MAKEPART(R, StExt_Top2);
  SETZERO(TTotTim, TWrkTim, TIncTim, TNightTim, TLinTim, TSettlTim, TZeroTim, TTotRun, TZeroRun, TTripAm);
  SELECT(StEx1, Route);
  WHILE OCCURE(StEx1) DO
   CONFORM(StEx1, Route);
   MAKEPART(R, StExt_Line2);
   INC(TTotTim,   StEx1.TotTim);
   INC(TWrkTim,   StEx1.WrkTim);
   INC(TIncTim,   StEx1.IncTim);
   INC(TNightTim, StEx1.NightTim);
   INC(TLinTim,   StEx1.LinTim);
   INC(TSettlTim, StEx1.SettlTim);
   INC(TZeroTim,  StEx1.ZeroTim);
   INC(TTotRun,   StEx1.TotRun);
   INC(TZeroRun,  StEx1.ZeroRun);
   INC(TTripAm,   StEx1.TripAm);
   NEXT(StEx1);
  END; (* WHILE OCCURE(StEx1) ... *)
  MAKEPART(R, StExt_Bot2, TTotTim, TWrkTim, TTotTim - TWrkTim, TIncTim, TNightTim, TLinTim, TSettlTim,
                          TZeroTim, TTotRun, TZeroRun, TTripAm);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {StExt};

 PUBLIC PROCEDURE Recalculate();
 BEGIN
  ACCESS(StExit);
  L_SysLog.SingleMark_Init("StExit");
  APP.Get().NewPrompt(" ⥫ 室 " + StExit.Exit);
  intRecalculate();
  L_SysLog.SingleMark_Done("StExit");
 END {Recalculate};

 PUBLIC PROCEDURE RecalculateAll();
 BEGIN
  SELECT(StExit, Exit);
  WHILE OCCURE(StExit) DO
   PROMPT("室 "+StExit.Exit);
   Recalculate();
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit) ... *)
 END {RecalculateAll};

 PRIVATE PROCEDURE CopyBorrow(_PrvExit, _NewExit: LIKE(StExit.Exit); _UpDate: DATE);
 BEGIN
  SELECT(ExitIP, Exit, , _NewExit);
  WHILE OCCURE(ExitIP) DO
   SELECT(ExitIPL, Exit, , ExitIP.Exit, ExitIP.Date, ExitIP.Cnd);
   WHILE OCCURE(ExitIPL) DO
    L_SysLog.SingleMark_BeforeDelete("ExitIPL");
    REMOVE(ExitIPL);
   END; (* WHILE ... *)
   L_SysLog.SingleMark_BeforeDelete("ExitIP");
   REMOVE(ExitIP);
  END; (* WHILE OCCURE(ExitIP) ... *)

  SELECT(ExitIP, Exit, , _PrvExit);
  WHILE OCCURE(ExitIP) DO
   CHANGESEL(ExitIP, ExitIP, , ExitIP.Exit, ExitIP.Cnd);
   LAST(ExitIP);
   SAVE(ExitIP);
   ExitIP.Exit:=_NewExit;
   ExitIP.Date:=_UpDate;
   INSERT(ExitIP);
   L_APtm.SysLogHandler("ExitIP", L_SysLog.knd_AutoBuild);
   RESTORE(ExitIP);
   SELECT(ExitIPL, Exit, , ExitIP.Exit, ExitIP.Date, ExitIP.Cnd);
   WHILE OCCURE(ExitIPL) DO
    PROMPT("஢  " + L_DatTim.TimeStr(ExitIPL.Time));
    SAVE(ExitIPL);
    ExitIPL.Exit:=_NewExit;
    ExitIPL.Date:=_UpDate;
    INSERT(ExitIPL);
    L_APtm.SysLogHandler("ExitIPL", L_SysLog.knd_AutoBuild);
    RESTORE(ExitIPL);
    NEXT(ExitIPL);
   END; (* WHILE ... *)
   CHANGESEL(ExitIP, ExitIP, , ExitIP.Exit);
   NEXT(ExitIP);
  END; (* WHILE OCCURE(ExitIP) ... *)

  SETSEL(ECSort,  Exit, _NewExit);
  REMSEL(ECSort);
  SETSEL(ECSort,  Exit, _PrvExit);
  IF ~SRCINSEL(ECSort, LE, _UpDate) THEN
   FIRST(ECSort);
  END;
  WHILE OCCURE(ECSort) DO
   SAVE(ECSort);
   SETEMPTY(ECSort.ExitClss);
   ECSort.Exit:=_NewExit;
   ECSort.Date:=_UpDate;
   INSERT(ECSort);
   RESTORE(ECSort);
   NEXT(ECSort);
  END; (* WHILE OCCURE(ECSort) ... *)
 END {CopyBorrow};

 PRIVATE PROCEDURE ExitsIsEqual(E1, E2: LIKE(StExit.Exit)): SCAL[2];
  CONST
   VersAmount = 100;
 BEGIN
  RETURN (E1 DIV VersAmount) = (E2 DIV VersAmount);
 END {ExitsIsEqual};

 PRIVATE PROCEDURE NewVersionCode(_Exit: LIKE(StExit.Exit); VAR _UpDate: DATE): LIKE(StExit.Exit);
  VAR
   i         : NUMERIC[0];
   CloseDate : DATE;
   TextStr,
   MessageStr: STRING[];
 BEGIN
  SETSEL(StExit, Exit);
  IF SRCINSEL(StExit, EQ, _Exit) THEN
   SAVE(StExit);
   SETEMPTY(CloseDate);
   WHILE OCCURE(StExit) & ~!StExit.Exit & ExitsIsEqual(_Exit, StExit.Exit) DO
    IF !StExit.UpDate THEN
     L_General.Assert(!CloseDate, " ᪠   室 "+StExit.Exit);
     IF Memo.ud_cd() > StExit.FromD THEN
      CloseDate:=Memo.ud_cd();
     END;
     LOOP
      TextStr   :="%< 室 "+StExit.Exit+"   >T"+"%L<D.N.y>I";
      MessageStr:="|%#############################% %##########%";
      IF StExit.Exit # _Exit THEN
       MessageStr:="| 室 " +_Exit + "    室 " + StExit.Exit + "." +
                   "|" + MessageStr;
      END;
      STDFORM(L_StdFrm.sf_Choice(MessageStr, TextStr), "   室 ", QUESTION, 1, CloseDate);
      IF CloseDate < StExit.FromD THEN
       L_StdFrm.RedInform("室  "+L_DatTim.DateStr(StExit.FromD)+".|  ࠭ .");
      ELSE
       EXIT;
      END;
     END;
     StExit.UpDate:=CloseDate;
     REPLACE(StExit);
     StExit_OnAfterEdIns();
    END;
    NEXT(StExit);
   END; (* WHILE OCCURE(StExit) ... *)
   RESTORE(StExit);

   _UpDate:=StExit.UpDate;
   i:=0;
   WHILE OCCURE(StExit) & ~!StExit.Exit & ExitsIsEqual(_Exit, StExit.Exit) DO
    INC(i);
    _UpDate:=L_DatTim.MaxDATE(StExit.UpDate, _UpDate);
    _Exit  :=StExit.Exit+1;
    NEXT(StExit);
   END;
   IF i > 1 THEN
    L_StdFrm.Choice("   ᫥ 室?");
   END;
  END;
  RETURN _Exit;
 END {NewVersionCode};

 PRIVATE PROCEDURE rpeirws_CheckStatus();
 BEGIN
  L_General.Assert(RWayS.Status <= L_Way.rwsStat_Taken,
                   "  ⠪஢ : " + RWayS.RWayS + "| ⠪஢ ");
 END {rpeirws_CheckStatus};

 PRIVATE PROCEDURE ReplacePrvExitInRWayS(OldExit, NewExit: LIKE(StExit.Exit));
  VAR
   NewTrip: LIKE(SEJobs.Trip);
 BEGIN
  SETSEL(RWayS, Date);
  SRCINSEL(RWayS, GE, , StExit.UpDate);
  WHILE OCCURE(RWayS) DO
   PROMPT("ᬮ : "+RWayS.RWayS);
   IF RWayS.Exit = OldExit THEN
    rpeirws_CheckStatus();
    L_RT.rte_UnbindByRWayS();
    L_RT.rtc_UnbindByRWayS();
    RWayS.Exit:=NewExit;
    REPLACE(RWayS);
    L_BegRWS.SetExitData();
   END;
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayJ) DO
    CONFORM(RWayJ, SEJobs);
    IF SEJobs.Exit = OldExit THEN
     rpeirws_CheckStatus();
     NewTrip:=NewExit * TripsPerExit + (RWayJ.Trip MOD TripsPerExit);
     L_General.CallUs(SEARCH(SEJobs, Trip, NewTrip));
     RWayJ.Trip:=NewTrip;
     REPLACE(RWayJ);
    END;
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {ReplacePrvExitInRWayS};

 PRIVATE PROCEDURE intMakeNewVersion(srcStExit: LIKE(StExit.Exit));
  VAR
   newDigit                 : SCAL[10];
   srcRI,
   dstRI                    : LIKE(StExit.RECORDID);
   tmpStExit,
   newStExit                : LIKE(StExit.Exit);
   newUpDate                : DATE;
   BegStExitCode            : STRING[];
   NeedReplacePrvExitInRWayS: SCAL[2];
 BEGIN
  dstRI:=StExit.RECORDID;
  SAVE(StExit);
  SEARCH(StExit, Exit, , srcStExit);
  srcRI:=StExit.RECORDID;
  L_SysLog.SingleMark_Init("StExit");
  NeedReplacePrvExitInRWayS:=!StExit.UpDate;
  tmpStExit                :=srcStExit;
  LOOP
   newStExit:=NewVersionCode(tmpStExit, newUpDate);
   IF ExitsIsEqual(newStExit, tmpStExit) THEN
    EXIT;
   ELSE
    SETEMPTY(newDigit);
    BegStExitCode:=L_Str.FixedIntStr(tmpStExit DIV 1000, 6);
    STDFORM(L_StdFrm.sf_Choice("|௠  室, 稭騥  " + L_Str.FixedIntStr(tmpStExit DIV TripsPerExit, 7) + "." +
                               "||᢮  ᨨ 室 , 稭騩  %######%%#%",
                               "%RNI" +
                               "%I"),
            , CHOICE, -1, BegStExitCode, newDigit);
    tmpStExit:=tmpStExit DIV 1000 * 1000 + newDigit * TripsPerExit + 1;
   END;
  END; (* LOOP *)
  RESTORE(StExit);

  MakeCopyStExit(srcStExit, newStExit, newUpDate);

  L_AR.GrantRightsUnconditionally();
  IF NeedReplacePrvExitInRWayS THEN
   ReplacePrvExitInRWayS(srcStExit, newStExit);
  END;

  L_Prop.CopyProRecords("StExit", srcRI, dstRI);
  CopyBorrow(srcStExit, newStExit, newUpDate);
  SEARCH(StExit, Exit, , srcStExit);
  L_SysLog.SingleMark_Done("StExit");
  FIX_ALTERING();
 END {intMakeNewVersion};

 PUBLIC PROCEDURE MakeNewVersion();
 BEGIN
  ACCESS(StExit);
  L_WDO.LaunchInsertBySource(StExit.Exit, " MakeNewVersion=1");
 END {MakeNewVersion};

 PUBLIC PROCEDURE MakeCopy();
 BEGIN
  ACCESS(StExit);
  L_WDO.LaunchInsertBySource(StExit.Exit, " MakeNewVersion=0");
 END {MakeCopy};

 PRIVATE PROCEDURE ExitClss_OnBeforeDelete();
 BEGIN
  L_r2r.Owner_OnBeforeDelete("ExitClss");
 END {ExitClss_OnBeforeDelete};

 PRIVATE PROCEDURE ExitClss_ERKN_OnBeforeAskForView();
 BEGIN
  L_APtm.CurrentEntityId:=RTI.Get().CurZone.MasterTable.Id;
 END {ExitClss_ERKN_OnBeforeAskForView};

 PRIVATE PROCEDURE ExitClss_ERKN_OnBeforeAskForEdit();
 BEGIN
  L_APtm.CurrentEntityId:=RTI.Get().CurZone.MasterTable.Id;
 END {ExitClss_ERKN_OnBeforeAskForEdit};

BEGIN
 L_Events.ExecuteHandler();
END.
