(*
%Copyright   (c) Polak Computer System
%Author      28.03.1994 13:11:58 SAN
%Purpose     ⠢  ३  -  ६ ࠬ
%Type        operation
%Specific    AP
%Modified    03.08.2012 21:06:06 POLAK\Gina
%Environment
*)

 MODULE S_Tr_Fc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Way, L_General, Math, L_DatTim, L_SCAD, L_Str;

 PRIVATE PROCEDURE TryInsert();
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   INSERT(RWayJ);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF L_General.IsUniquenessViolationException(Exc) THEN
    L_General.Error(" 믮 ࠧ. "+
                    "|  ३  ६ 砫 "+ L_DatTim.TimeStr(RWayJ.StartT));
   ELSE
    RAISE();
   END;
  END;
 END {TryInsert};

 PUBLIC PROCEDURE Slice(D: NUMERIC[0]);
  VAR
   _D      : NUMERIC[0];
   _Fact   : LIKE(RWayJ.Fact);
   _StopT  : LIKE(RWayJ.StopT);
   OneTripTime: NUMERIC[3];
   Delta   : NUMERIC[2];
 BEGIN
  IF ACCESS(RWayJ) & (RWayJ.Fact > 1) THEN
   STDMSG(" ப " + L_Str.PoolItem(" |  ३|  ३", D), CHOICE);
   SAVE(RWayJ);
   CONFORM(RWayJ, SEJobs, StExit);
   Delta:=(L_Way.FullBegTime(RWayJ.Day,  RWayJ.StartT) - L_Way.FullBegTime(SEJobs.Day, SEJobs.StartT)) MOD 24;
   IF (StExit.Strict=L_Way.ExitStrict_Reg) & (Math.Abs(Delta) < 0.4) THEN
    CHANGESEL(SEJobs, Exit, , SEJobs.Exit);
    _Fact:=RWayJ.Fact;
    _StopT:=RWayJ.StopT;
    WHILE _Fact > D DO DEC(_Fact, D);
     _D:=0;
     LOOP
      IF (_D >= D) | ~OCCURE(SEJobs) THEN
       EXIT;
      END;
      RWayJ.StopT:=SEJobs.StopT;
      INC(_D);
      NEXT(SEJobs);
     END; (* LOOP *)
     L_General.Assert(OCCURE(SEJobs), " ⠪ ⢠ ३ᮢ");
     RWayJ.Fact   :=D;
     REPLACE(RWayJ);
     CONFORM(SEJobs, RoutMod);
     DEFAULT(RWayJ);
     RWayJ.RWayS  :=RWayS.RWayS;
     RWayJ.Day    :=SEJobs.Day;
     RWayJ.StartT :=SEJobs.StartT;
     RWayJ.Trip   :=SEJobs.Trip;
     RWayJ.Quality:=0;
     RWayJ.Run    :=RoutMod.Run;
     TryInsert();
     D:=Math.Min(D, _Fact);
    END;
    RWayJ.StopT  :=_StopT;
    RWayJ.Fact   :=D;
    REPLACE(RWayJ);
   ELSE
    OneTripTime:=(RWayJ.StopT-RWayJ.StartT)/RWayJ.Fact;
    _Fact:=RWayJ.Fact;
    _StopT:=RWayJ.StopT;
    WHILE _Fact > D DO DEC(_Fact, D);
     RWayJ.Fact :=D;
     RWayJ.StopT:=RWayJ.StartT+OneTripTime*D;
     REPLACE(RWayJ);
     RWayJ.StartT :=RWayJ.StopT;
     RWayJ.Quality:=0;
     TryInsert();
     D:=Math.Min(D, _Fact);
    END;
    RWayJ.StopT  :=_StopT;
    RWayJ.Fact   :=D;
    REPLACE(RWayJ);
   END; (* IF StExit.Strict=2... *)
   RESTORE(RWayJ);
  END;
 END {Slice};

 PUBLIC PROCEDURE Compress();
  VAR
   _F,
   MFact,
   _Fact  : LIKE(RWayJ.Fact);
   _StopT : LIKE(RWayJ.StopT);
   Cnt    : SCAL[200];
   Asked  : SCAL[2];
   curQuality: LIKE(RWayJ.Quality);
   curRun    : LIKE(RWayJ.Run);
 BEGIN
  IF ACCESS(RWayJ) THEN
   curQuality:=RWayJ.Quality;
   curRun:=RWayJ.Run;
   SAVE(RWayJ);
   CONFORM(RWayJ, SEJobs, StExit);
   CHANGESEL(SEJobs, Exit, , SEJobs.Exit);
   SAVE(SEJobs);
   MFact:=L_Way.GetTripsGroup(250, L_Way.FullEndTime(99, 00:00, 00:00), 0);
   RESTORE(SEJobs);
   _Fact:=0; Cnt:=0; Asked:=0;
   REPEAT
    INC(_Fact, RWayJ.Fact);
    _StopT:=RWayJ.StopT;
    _F:=RWayJ.Fact;
    WHILE (_F > 0) & OCCURE(SEJobs) DO
     DEC(_F);
     NEXT(SEJobs);
    END;
    IF Cnt > 0 THEN
     L_General.Assert(RWayJ.Run = curRun, "஡ ⫨砥  ᢮稢 ३:|३ "+L_DatTim.TimeStr(RWayJ.StartT));
     CONFORM(RWayJ, RWayJP);
     L_General.Assert(~OCCURE(RWayJP), "  ⥫  ᢮稢 ३|३ "+L_DatTim.TimeStr(RWayJ.StartT));
     L_Way.RemoveSingleRWayJ(Asked);
    ELSE
     NEXT(RWayJ);
    END;
    INC(Cnt);
   UNTIL ~OCCURE(SEJobs) |
         ~OCCURE(RWayJ) |
         (SEJobs.Trip # RWayJ.Trip) |
         (_Fact >= MFact) |
         (RWayJ.Quality # curQuality);
   RESTORE(RWayJ);
   RWayJ.Fact :=_Fact;
   RWayJ.StopT:=_StopT;
   REPLACE(RWayJ);
  END;
 END {Compress};

 PUBLIC PROCEDURE SetTrAttr();
  VAR
   _Fact   : LIKE(RWayJ.Fact);
   _StartT : LIKE(SEJobs.StartT);
   Delta1,
   Delta2  : NUMERIC[4];
   _Trip   : LIKE(SEJobs.Trip);
   CPChange: SCAL[2];
 BEGIN
  IF OCCURE(RWayJ) & ~!RWayJ.Trip THEN
   CONFORM(RWayJ, SEJobs);
   SELECT(SEJobs, Exit, , SEJobs.Exit);
   IF SRCINSEL(SEJobs, LE, RWayJ.Day, RWayJ.StartT) THEN
    L_General.Assert(~!RWayJ.Day & ~!RWayJ.StartT & ~!RWayJ.StopT, "  ,  ६ 砫,  ६ 砭 ३");
    Delta1:=L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT)-L_Way.FullBegTime(SEJobs.Day, SEJobs.StartT);
    IF NEXT(SEJobs) THEN
     Delta2:=L_Way.FullBegTime(SEJobs.Day, SEJobs.StartT) - L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT);
     IF Delta1 < Delta2 THEN
      PREV(SEJobs);
     ELSE
      Delta1:=Delta2;
     END;
    ELSE
     LAST(SEJobs);
    END;
    IF Delta1 > 0.4 THEN
     STDMSG("誮 讥 ⪫  ᯨᠭ", STOP);
    END;
    _Trip  :=SEJobs.Trip;
    _StartT:=SEJobs.StartT;
    _Fact  :=L_Way.GetTripsGroup(250, L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT), 0);
    CPChange:=(RWayJ.Trip#_Trip) | (RWayJ.Fact#_Fact);
    RWayJ.Trip  :=_Trip;
    RWayJ.Fact  :=_Fact;
    INTEGRITY(NoAsk);
    REPLACE(RWayJ);
    TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     RWayJ.StartT:=_StartT;
     REPLACE(RWayJ);
    EXCEPT
    ON Exc: Exc_RunTime DO
     IF ~L_General.IsUniquenessViolationException(Exc) THEN
      RAISE();
     END;
    END;
    INTEGRITY(Off);
    IF CPChange & L_SCAD.E_RWayCPLevel(RWayS.Date) THEN
     L_SCAD.DistributeCP();
    END;
   END; (* IF SRCINSEL(SEJobs ... *)
  END; (* IF OCCURE( ... *)
 END {SetTrAttr};

END.
