(*
%Copyright   (c) Polak IT
%Author      28.03.2003 13:57:49 POLAK\BOR
%Purpose      
%Type        report
%Specific    AP
%Modified    16.06.2014 14:33:17 POLAK\GAV
%Environment
*)

 MODULE T0400 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_APtm, L_DatTim, L_Basis, L_Way, L_Str, L_AFM,
        FIO, Math, E_Way, D_TP, L_bp, L_RWayS;

 TYPE
  QGroupType = SCAL[100];
  ReasonNType = STRING[32];

 VAR
  IsT0400: SCAL[2];

 CONST
  NoReasonName = "----";

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "㯯 ப");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㯯 稭");
  L_Basis.wb_WrInQM(F, "稭");
  L_Basis.wb_WrInQM(F, "稭");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ᯨᠭ");
  L_Basis.wb_WrInQM(F, "⢨⥫쭠 稭");
  L_Basis.wb_WrInQM(F, "६ ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "砨");

  IF IsT0400 THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "祥 ६");
   L_Basis.wb_WrInQM(F, " ⠦஬");
  ELSE
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "᭮");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, " ");
   L_Basis.wb_WrInQM(F, " ");
  END;
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE E_QualityGroup(trgQuality: LIKE(Quality.Quality)): SCAL[100];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.QualityGroup);
  IF !Local THEN
   L_General.SetupRequired();
  END;
  RETURN Local(trgQuality);
 END {E_QualityGroup};

 PRIVATE PROCEDURE E_QualityGroupName(_QGroup: SCAL[100]): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.QualityGroupName);
  IF !Local THEN
   L_General.SetupRequired();
  END;
  RETURN Local(_QGroup);
 END {E_QualityGroupName};

 PRIVATE PROCEDURE E_IsLossableCar(trgBoxNbr: LIKE(Car.BoxNbr); trgDate: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.IsLossableCar);
  IF !Local THEN
   L_General.SetupRequired();
  END;
  RETURN Local(trgBoxNbr, trgDate);
 END {E_IsLossableCar};

 PUBLIC PROCEDURE PutRWayJWithWayLMen_Who(F: STRING[]; _Who: L_Way.tWLMWho);
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF ~L_Way.E_IsGuardIdleExit(RWayS.Date, RWayS.Exit) THEN
   SAVE(WayLMen);
   SELECT(WayLMen, RWayS, , RWayS.RWayS, _Who);
   WHILE OCCURE(WayLMen) & ~Result DO
    IF L_RWayS.IsRWayJForCurWayLMen() THEN
     Result:=1;
     SAVE(Staff);
     SAVE(Man);
     CONFORM(WayLMen, Staff, Man);
     L_Basis.wb_WrScl(F, WayLMen.TSN);
     L_Basis.wb_WrStr(F, Man.Name);
     RESTORE(Staff);
     RESTORE(Man);
    END;
    NEXT(WayLMen);
   END;
   RESTORE(WayLMen);
  END;
  IF ~Result THEN
   L_Basis.wb_WrScl(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
 END {PutRWayJWithWayLMen_Who};

 PRIVATE PROCEDURE MakePart(F: STRING[]; _Column    : LIKE(CarLog.Column);
                                         _Sort      : LIKE(Sort.Sort);
                                         _QGroup    : SCAL[100];
                                         _IsTSLoss  : SCAL[2];
                                         _ReasonName: STRING[];
                                         _TrpTime   : NUMERIC[3];
                                         _RWJFact   : NUMERIC[1];
                                         _Count     : NUMERIC[0];
                                         Change     : LIKE(RWayS.Change));
 BEGIN
  L_Basis.wb_WrScl(F, _Column);
  IF L_Way.StandOnMarkG_Soft(Mark.Mark, L_Way.mgt_Loss) THEN
   L_Basis.wb_WrScl(F, MarkG.MarkG);
   L_Basis.wb_WrStr(F, MarkG.Name);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  IF ~!_Sort THEN
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  IF ~!Change THEN
   L_Basis.wb_WrStr(F, L_Str.PoolItem("|1|2", Change));
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
  IF ~!_QGroup THEN
   L_Basis.wb_WrStr(F, E_QualityGroupName(_QGroup));
  ELSE
   L_Basis.wb_WrStr(F, "----");
  END;
  IF OCCURE(Quality) THEN
   L_Basis.wb_WrScl(F, Quality.Quality);
   L_Basis.wb_WrStr(F, Quality.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "----------");
  END;
  IF OCCURE(WJMode) THEN
   L_Basis.wb_WrStr(F, WJMode.WJCode);
   L_Basis.wb_WrStr(F, WJMode.Name);
  ELSE
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "----------");
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", _IsTSLoss));
  L_Basis.wb_WrStr(F, _ReasonName);
  L_Basis.wb_WrNum(F, _TrpTime, 3);
  L_Basis.wb_WrNum(F, _RWJFact, 1);
  L_Basis.wb_WrNum(F, _Count, 0);

  IF IsT0400 THEN
   L_Basis.wb_WrNum(F, T0400.Output, 0);
   L_Basis.wb_WrNum(F, T0400.WTime, 3);
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", T0400.WDrPup));
  ELSE
   L_Basis.wb_WrScl(F, RWayS.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrScl(F, RWayS.BoxNbr);
   L_Basis.wb_WrStr(F, CarLog.StateNbr);
   L_Basis.wb_WrScl(F, RWayS.RWayS);
   L_Basis.wb_WrDat(F, RWayS.Date);
   L_Basis.wb_WrStr(F, SEJobs.Route);
   L_Basis.wb_WrStr(F, Route.Name);
   L_Basis.wb_WrStr(F, TKind.TKind);
   L_Basis.wb_WrStr(F, TKind.Name);
   L_Basis.wb_WrStr(F, FLDTOSTR(RWayJ.StartT, "H:M"));
   L_Basis.wb_WrStr(F, FLDTOSTR(RWayJ.StopT, "H:M"));
   PutRWayJWithWayLMen_Who(F, L_Way.wlmwho_Guard);
  END;
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE LossReasonName(): STRING[32];
 BEGIN
  IF SEARCH(RWayJP, RWayS, RWayJ.RWayS, RWayJ.Day, RWayJ.StartT, L_Way.E_GetLossReasonCode(RWayS.Date)) THEN
   RETURN L_Str.PoolItem(L_Way.E_GetLossReasonPool(RWayS.Date), RWayJP.Value);
  ELSE
   RETURN NoReasonName;
  END;
 END {LossReasonName};

 PRIVATE PROCEDURE Create_T0400();
 BEGIN
  CreateFILE(T0400, "", "", "");
  CreateFIELD(T0400, Column,   LIKE(CarLog.Column), "", "", "", "", "");
  CreateFIELD(T0400, Mark,     LIKE(Mark.Mark), "", "", "", "ઠ", "");
  CreateFIELD(T0400, QGroup,   SCAL[100], "", "", "", "㯯 稭", "");
  CreateFIELD(T0400, Sort,     LIKE(Sort.Sort), "", "", "", "", "");
  CreateFIELD(T0400, Quality,  LIKE(Quality.Quality), "", "", "", "稭", "");
  CreateFIELD(T0400, WJCode,   LIKE(WJMode.WJCode), "", "", "", " ࠡ", "");
  CreateFIELD(T0400, IsTSLoss, SCAL[2], "", "", "", "ᯨᠭ", "");
  CreateFIELD(T0400, ReasonN,  ReasonNType, "", "", "", "⢨⥫쭠 稭", "");
  CreateFIELD(T0400, WDrPup,   SCAL[2], "", "", "", " ⠦஬", "");
  CreateFIELD(T0400, Change,   LIKE(RWayS.Change), "", "", "", "", "");

  CreateFIELD(T0400, TrpTime, NUMERIC[3], "", "0", "", "६ ", "");
  CreateFIELD(T0400, RWJFact, NUMERIC[1], "", "0", "", "", "");
  CreateFIELD(T0400, Output,  NUMERIC[0], "", "0", "", "", "");
  CreateFIELD(T0400, WTime,   NUMERIC[3], "", "0", "", "祥 ६", "");
  CreateFIELD(T0400, Count,   NUMERIC[0], "", "0", "", "砨", "");

  CreateINDEXandLINK(T0400, Mark, PLURAL, Mark, Mark, USER, "", "", Mark);
  CreateINDEXandLINK(T0400, Sort, PLURAL, Sort, Sort, USER, "", "", Sort);
  CreateINDEXandLINK(T0400, Quality, PLURAL,Quality, Quality, USER, "", "", Quality);
  CreateINDEXandLINK(T0400, WJCode, PLURAL, WJMode, WJCode, USER, "", "", WJCode);
  CreateINDEX(T0400, T0400, UNIQUE, "", "", Column, Mark, QGroup, Sort, Quality, WJCode, IsTSLoss, ReasonN, WDrPup, Change);

  SetVersionOfFILE(T0400, 0);
 END {Create_T0400};

 PRIVATE PROCEDURE Make();
  VAR
   BD,
   ED          : DATE;
   IsTSLoss    : SCAL[2];
   rwsWTime    : NUMERIC[3];
   _QGroup     : QGroupType;
   CarAmount   : NUMERIC[0];
   dayInOut,
   dayWasInWork: SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  MakeHeader("R");
 
  Create_T0400(); L_AFM.AF_CreateTemp("T0400", "T0400");
 
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(Car.BoxNbr);
   SELECT(CarLog, BoxNbr, , Car.BoxNbr);
   IF ~SRCINSEL(CarLog, LE, Memo.ud_fr()) THEN
    FIRST(CarLog);
   END;
   WHILE OCCURE(CarLog) & (CarLog.Date<=Memo.ud_ut()) DO
    IF E_IsLossableCar(CarLog.BoxNbr, CarLog.Date) THEN
     BD:=Math.Max(CarLog.Date,  Memo.ud_fr());
     ED:=Math.Min(CarLog.DateE, Memo.ud_ut());
     CONFORM(CarLog, Mark);
 
     SELECT(RWayS, sBoxNbr, , L_Way.rwsStat_Rated, CarLog.BoxNbr);
     SRCINSEL(RWayS, GE, , BD);
     WHILE OCCURE(RWayS) & (RWayS.Date <= ED) DO
      SETZERO(dayInOut, dayWasInWork);
      NARROWSEL(RWayS, Date);
      WHILE OCCURE(RWayS)  DO
       PROMPT(Car.BoxNbr+" "+L_DatTim.DateStr(RWayS.Date)+" "+RWayS.RWayS);
 
       CarAmount:=1;
       IF L_APtm.IsTramDepo() THEN
        CONFORM(RWayS, WayLCar);
        WHILE OCCURE(WayLCar) DO
         INC(CarAmount);
         NEXT(WayLCar);
        END;
       END;
       SETZERO(rwsWTime);
       CONFORM(RWayS, Staff);
       CONFORM(Staff, Man);
       HISTCONF(RWayS.Date, Staff, StaffLog);
       CONFORM(StaffLog, Sort);
       CONFORM(RWayS, RWayJ);
       WHILE OCCURE(RWayJ) DO
        CONFORM(RWayJ, SEJobs);
        CONFORM(SEJobs, WJMode);
        CONFORM(SEJobs, Route);
        L_Way.StandOnRouteTKind(RWayS.Date);
        IF TKind.InLoss THEN
         IF ~dayInOut THEN
          dayInOut:=D_TP.OTP1_IsWork(dayWasInWork);
         END;
         IF ~dayWasInWork THEN
          dayWasInWork:=D_TP.OTP1_ToBeAsWasInWork(1);
         END;
         IF (WJMode.WJType=L_Way.WJType_Work) THEN
          INC(rwsWTime, RWayJ.StopT - RWayJ.StartT);
         END;
        END;
  
        CONFORM(RWayJ, Quality);
        IF Quality.Type = L_Way.QualType_Annul THEN
         IsTSLoss:=RWayJ.Fact>0;
         _QGroup:=E_QualityGroup(RWayJ.Quality);
         IF IsT0400 THEN
          ADD(T0400, T0400, , CarLog.Column, CarLog.Mark, _QGroup,
                              StaffLog.Sort, RWayJ.Quality, SEJobs.WJCode,
                              IsTSLoss, LossReasonName(),
                              L_Way._IsWith(L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT),
                                            L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT),
                                            L_Way.wlmwho_DrPupil),
                              RWayS.Change,
                       T0400.TrpTime, CarAmount * L_Way.LossTrpTime(),
                       T0400.RWJFact, RWayJ.Fact * L_Way.IsLOSS(),
                       T0400.Count,   L_Way.IsLOSS());
         ELSE
          MakePart("R", CarLog.Column, StaffLog.Sort, _QGroup, IsTSLoss, LossReasonName(),
                   CarAmount * L_Way.LossTrpTime(),
                   RWayJ.Fact * L_Way.IsLOSS(),
                   L_Way.IsLOSS(), RWayS.Change);
         END;
        END;
        NEXT(RWayJ);
       END; (* WHILE OCCURE(RWayJ) ... *)
       IF IsT0400 THEN
        IF rwsWTime # 0 THEN
         ADD(T0400, T0400, , CarLog.Column, CarLog.Mark, "",
                             StaffLog.Sort, "", "", 1, NoReasonName, 0, RWayS.Change,
                       T0400.WTime,  CarAmount * rwsWTime);
        END;
       END;
       NEXT(RWayS);
      END; (* WHILE OCCURE(RWayS) ... *)
      IF IsT0400 THEN
       ADD(T0400, T0400, , CarLog.Column, CarLog.Mark, "",
                           "", "", "", 1, NoReasonName, 0, "",
                       T0400.Output, dayInOut);
      END;
      NEXTINEXTENDEDSEL(RWayS, Date);
     END; (* WHILE OCCURE(RWayS) ... *)
    END;
    NEXT(CarLog);
   END; (* WHILE OCCURE(CarLog) ... *)
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 
  IF IsT0400 THEN
   SELECT(T0400, T0400);
   WHILE OCCURE(T0400) DO
    CONFORM(T0400, Mark);
    CONFORM(T0400, Sort);
    CONFORM(T0400, Quality);
    CONFORM(T0400, WJMode);
 
    MakePart("R", T0400.Column, T0400.Sort, T0400.QGroup, T0400.IsTSLoss, T0400.ReasonN,
                  T0400.TrpTime, T0400.RWJFact, T0400.Count, T0400.Change);
    NEXT(T0400);
   END; (* WHILE OCCURE(T0400) ... *)
  END;
  L_AFM.AF_PurgeTemp("T0400");
 END {Make};

 PUBLIC PROCEDURE T0400();
  CONST
   bpId = "T0400";
 BEGIN
  L_bp.Begin(bpId, " ", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  IsT0400:=1;
  Make();
  FIO.Close(R);
  L_bp.End();
 END {T0400};

 PUBLIC PROCEDURE T0401();
  CONST
   bpId = "T0401";
 BEGIN
  L_bp.Begin(bpId, "   ", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  IsT0400:=0;
  Make();
  FIO.Close(R);
  L_bp.End();
 END {T0401};

END.
