(*
%Copyright   (c) Polak IT
%Author      27.08.2009 19:50:00 POLAK\San
%Purpose      ࠡ祣 ६ ᮭ    ਮ
%Type        report
%Specific    AP
%Modified    05.08.2014 19:15:35 POLAK\San
%Environment
*)

 MODULE T0411 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Basis, L_Str, L_Staff, L_Way, L_Car, Memo, FIO,
        L_Env, L_AFM, L_RWayS, Math, L_bp;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠪ");
  L_Basis.wb_WrInQM(F, " ࠡ");
  L_Basis.wb_WrInQM(F, " ࠡ");
  L_Basis.wb_WrInQM(F, " ⢠");
  L_Basis.wb_WrInQM(F, " ⢠");
  L_Basis.wb_WrInQM(F, "६  ⠡");
  L_Basis.wb_WrInQM(F, "᭮ ६");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
  VAR
   trgFirm: LIKE(Firm.Firm);
   dmyStr : STRING[];
   dmyTSN : LIKE(Staff.TSN);
 BEGIN
  L_Basis.wb_WrDat(F, T0411.clcDate);
  L_Basis.wb_WrDat(F, T0411.rwsDate);
  SEARCH(Staff, TSN, , T0411.TSN);
  CONFORM(Staff, Man);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.rwswho_Pool_Short, T0411.Who));
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, L_Str.ShortName(Man.Name));
  L_Staff.PosToStaffLog(Staff.TSN, T0411.rwsDate, 1);
  CONFORM(StaffLog, Sort);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  IF Staff.Contract = L_Staff.cnt_OutStaff THEN
   P_Man.GetAccessOutsiderInf(Staff.Man, T0411.rwsDate, trgFirm, dmyStr, dmyTSN);
   IF !trgFirm THEN
    trgFirm:=P_Firm.OWN_FIRM;
   END;
   SEARCH(Firm, Firm, , trgFirm);
   L_Basis.wb_WrScl(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Car.StandOnCarLog(T0411.BoxNbr, T0411.rwsDate);
  CONFORM(CarLog, Mark);
  L_Basis.wb_WrScl(F, CarLog.BoxNbr);
  L_Basis.wb_WrScl(F, CarLog.StateNbr);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, CarLog.Column);
  SEARCH(Route, Route, , T0411.Route);
  L_Way.StandOnRouteTKind(T0411.clcDate);
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  SEARCH(WJMode, WJCode, , T0411.WJCode);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("---|ந.||⮩", WJMode.WJType));
  L_Basis.wb_WrStr(F, WJMode.WJCode);
  L_Basis.wb_WrStr(F, WJMode.Name);
  SEARCH(Quality, Quality, , T0411.Quality);
  L_Basis.wb_WrScl(F, Quality.Quality);
  L_Basis.wb_WrStr(F, Quality.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", T0411.TimeSel));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", T0411.Main));
  L_Basis.wb_WrNum(F, T0411.Time, 3);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE PutTime(_Who    : L_Way.tRWSWho;
                           clcDate : DATE;
                           asWJMode: LIKE(WJMode.WJCode);
                           Coef    : NUMERIC[3];
                           _Time   : FLOAT;
                           Main    : SCAL[2];
                           _ToSheet: LIKE(RWayS.ToSheet));
 BEGIN
  IF Coef # 0 THEN
   ADD(T0411, T0411, , Staff.TSN, _Who, RWayS.Date, clcDate,
                       RWayS.BoxNbr,
                       SEJobs.Route, asWJMode, RWayJ.Quality,
                       WJMethod.TimeSel & (_ToSheet#L_Way.toSheet_Dummy),
                       Main,
       T0411.Time, Coef * _Time);
  END;
 END {PutTime};

 PRIVATE PROCEDURE MakeSingleStaff(byWLM: SCAL[2]; _Who: L_Way.tRWSWho);
  VAR
   _Time   : FLOAT;
   clcDate : DATE;
   _ToSheet: LIKE(RWayS.ToSheet);
   asWJMode: LIKE(WJMode.WJCode);
 BEGIN
  IF L_Env.RealTSN(Staff.TSN) THEN
   CONFORM(RWayS, RWayJ);
   WHILE OCCURE(RWayJ) DO
    CONFORM(RWayJ, Quality);
    IF Quality.Type # L_Way.QualType_Annul THEN
     _Time:=0;
     IF byWLM THEN
      IF L_RWayS.E_GetTimesFromWayLMen() THEN
       _Time:=WayLMen.StopT-WayLMen.StartT;
      ELSIF L_RWayS.IsRWayJForCurWayLMen() THEN
       _Time:=RWayJ.StopT-RWayJ.StartT;
      END;
      _ToSheet:=L_Way.GetWLMToSheetSign(WayLMen.Who);
     ELSE
      _Time:=RWayJ.StopT-RWayJ.StartT;
      _ToSheet:=RWayS.ToSheet;
     END;
     IF _Time # 0 THEN
      clcDate:=L_Way.GetDateOfRWayJ();
      IF L_DatTim.IsActive_Inc(clcDate, Memo.ud_fr(), Memo.ud_ut()) THEN
       CONFORM(RWayJ, SEJobs);
       L_Way.PositionOnRouteLog(SEJobs.Route, RWayS.Date);
       asWJMode:=L_RWayS.GetasWJMode(_Who);
       L_Way.PosToWJMethod(asWJMode, _Who, RouteLog.JRegime, RWayJ.Quality, RWayS.Date);
       PutTime(_Who, clcDate, asWJMode, L_RWayS.E_RWAYS_CoeffForCurTimes(RWayS.Date, _Who), _Time, 1, _ToSheet);
       PutTime(_Who, clcDate, asWJMode, L_RWayS.E_RWAYS_CoeffForAddTimes(RWayS.Date, _Who), _Time, 0, _ToSheet);
      END;
     END; (* IF _Time # 0 *)
    END;
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
  END;
 END {MakeSingleStaff};

 PUBLIC PROCEDURE T0411();
  CONST
   bpId = "T0411";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " ࠡ祣 ६ ᮭ  ", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");

  L_AFM.MakeMultipleIndex("T0411", "TSN    : LIKE(Staff.TSN);"+
                                   "Who    : " + TYPENAMEOF(L_Way.tRWSWho) + ";"+
                                   "clcDate: DATE;"+
                                   "rwsDate: DATE;"+
                                   "BoxNbr : LIKE(Car.BoxNbr);"+
                                   "Route  : LIKE(Route.Route);"+
                                   "WJCode : LIKE(WJMode.WJCode);"+
                                   "Quality: LIKE(Quality.Quality);"+
                                   "TimeSel: SCAL[2];"+
                                   "Main   : SCAL[2];"+
                                   "Time   : NUMERIC[3]",
                          "T0411: TSN, Who, rwsDate, clcDate, BoxNbr, Route, WJCode, Quality, TimeSel, Main");
  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated);
  SRCINSEL(RWayS, GE, , Math.Max(Memo.ud_fr() - 5, L_DatTim.MonthBeg(Memo.ud_fr())));
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   PROMPT("⮢  " + L_DatTim.DateStr(RWayS.Date)+" "+RWayS.RWayS);
   CONFORM(RWayS, Staff);
   MakeSingleStaff(0, L_Way.rwswho_Driver);
   SELECT(WayLMen, RWayS, , RWayS.RWayS, L_Way.wlmwho_SDriver);
   WHILE OCCURE(WayLMen) DO
    CONFORM(WayLMen, Staff);
    MakeSingleStaff(1, L_Way.rwswho_Driver);
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
   SELECT(WayLMen, RWayS, , RWayS.RWayS, L_Way.wlmwho_Guard);
   WHILE OCCURE(WayLMen) DO
    CONFORM(WayLMen, Staff);
    MakeSingleStaff(1, L_Way.rwswho_Guard);
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  SELECT(T0411, T0411);
  WHILE OCCURE(T0411) DO
   PROMPT(" " + T0411.TSN);
   MakePart("R");
   NEXT(T0411);
  END; (* WHILE OCCURE(T0411) ... *)
  FIO.Close(R);
  L_bp.End();
 END {T0411};

END.
