(*
%Copyright   (c) Polak IT
%Author      13.08.2004 13:20:30 POLAK\ATS
%Purpose
%Type        report
%Specific    AP
%Modified    25.06.2014 12:27:48 POLAK\LDA
%Environment
*)

 MODULE T0500 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Way, Memo, L_DatTim, FIO, L_Basis, L_Str, Str, L_StdFrm,
        L_AFM, L_OwnData, L_bp, P_OwnData, L_PagePr;

 PRIVATE TYPE
  tArrTime = TIME[24];

 PRIVATE CONST
  d_Pool  = "אַ ࠢ|⭮ ࠢ";

 PRIVATE VAR
  RepName         : STRING[];
  PosCurHour      : SCAL[24];
  ArrTime         : tArrTime;
  DRTime          : TIME;
  HoursPart0_Pool,
  HoursPart1_Pool : STRING[];
  trgDir          : LIKE(SEJobs.Dir);
  BeganNewPage    : SCAL[2];
  curRoutMod      : LIKE(RoutMod.Modif);

 PRIVATE PROCEDURE MakeHeader();
 BEGIN
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_WrInQM("R", "⠭");
  L_Basis.wb_WrInQM("R", "⠭");
  L_Basis.wb_WrInQM("R", "ࠢ");
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_WrInQM("R", "室");
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_WrInQM("R", "䨪");
  L_Basis.wb_WrInQM("R", "६");
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_TermLine("R");
 END {MakeHeader};

 PRIVATE PROCEDURE MakeLine();
 BEGIN
  CONFORM(Shdl, Stop);
  CONFORM(Shdl, Route);
  CONFORM(Shdl, RoutMod);

  CONFORM(Shdl, SEJobs);
  CONFORM(Shdl, TKind);
  CONFORM(Shdl, StExit);
  CONFORM(Shdl, ExitClss);
  CONFORM(Shdl, WJMode);

  L_Basis.wb_WrStr("R", L_Str.PoolItem(L_Way.scpt_Pool, Stop.CPType));
  L_Basis.wb_WrScl("R", Stop.Stop);
  L_Basis.wb_WrStr("R", L_Way.GetStopName(Stop.Stop));
  L_Basis.wb_WrStr("R", L_Str.PoolItem("אַ|⭮", Shdl.Dir));
  L_Basis.wb_WrStr("R", TKind.Name);
  L_Basis.wb_WrScl("R", Route.Route);
  L_Basis.wb_WrScl("R", StExit.Exit);
  L_Basis.wb_WrStr("R", L_Str.PoolItem("||", StExit.Strict));
  L_Basis.wb_WrStr("R", ExitClss.Sign);
  L_Basis.wb_WrStr("R", RoutMod.Name);
  L_Basis.wb_WrTim("R", Shdl.Time);
  L_Basis.wb_WrStr("R", Shdl.Hour);
  L_Basis.wb_WrStr("R", WJMode.Name);
  L_Basis.wb_WrStr("R", Str.Small(Str.Condense(L_Way.StExitOnDaysAsStr())));
  L_Basis.wb_TermLine("R");
 END {MakeLine};

 PRIVATE PROCEDURE Create_Shdl();
 BEGIN
  CreateFILE(Shdl, "", "ᯨᠭ", "");

  CreateFIELD(Shdl, Route,   LIKE(Route.Route),   "", "", "", " ", "");
  CreateFIELD(Shdl, RoutMod, LIKE(RoutMod.Modif), "", "", "", " 䨪樨 ", "");
  CreateFIELD(Shdl, Stop,    LIKE(Stop.Stop),     "", "", "", " ⠭", "");
  CreateFIELD(Shdl, Time,    TIME,                "", "", "", "६ ⠭", "");
  CreateFIELD(Shdl, Hour,    SCAL[24],            "", "", "", "", "");
  CreateFIELD(Shdl, Dir,     SCAL[2],             "", "", "", "ࠢ", "0-אַ, 1-⭮");

  CreateFIELD(Shdl, SEJobs,  LIKE(SEJobs.Trip),       "", "", "", "",          "᫥ 㤠  T0500   㦭");
  CreateFIELD(Shdl, TKind,   LIKE(TKind.TKind),       "", "", "", " ॢ", "᫥ 㤠  T0500   㦭");
  CreateFIELD(Shdl, StExit,  LIKE(StExit.Exit),       "", "", "", "室",         "᫥ 㤠  T0500   㦭");
  CreateFIELD(Shdl, ExitClss,LIKE(ExitClss.ExitClss), "", "", "", " 室",  "᫥ 㤠  T0500   㦭");
  CreateFIELD(Shdl, WJMode,  LIKE(WJMode.WJCode),     "", "", "", " ࠡ",    "᫥ 㤠  T0500   㦭");

  CreateINDEXandLINK(Shdl, SEJobs,  PLURAL, SEJobs,  Trip,    USER, "", "᫥ 㤠  T0500 뫪  㦭", SEJobs);
  CreateINDEXandLINK(Shdl, TKind,   PLURAL, TKind,   TKind,   USER, "", "᫥ 㤠  T0500 뫪  㦭", TKind);
  CreateINDEXandLINK(Shdl, StExit,  PLURAL, StExit,  Exit,    USER, "", "᫥ 㤠  T0500 뫪  㦭", StExit, Dir, Time);
  CreateINDEXandLINK(Shdl, ExitCls, PLURAL, ExitClss,ExitClss,USER, "", "᫥ 㤠  T0500 뫪  㦭", ExitClss);
  CreateINDEXandLINK(Shdl, WJMode,  PLURAL, WJMode,  WJCode,  USER, "", "᫥ 㤠  T0500 뫪  㦭", WJMode);

  CreateINDEXandLINK(Shdl, RoutMod, PLURAL, RoutMod, Route,   USER, "", "", Route, RoutMod);
  CreateINDEXandLINK(Shdl, Route,   PLURAL, Route,   Route,   USER, "", "", Route, Stop, Dir, RoutMod, Hour, Time);
  CreateINDEXandLINK(Shdl, Stop,    PLURAL, Stop,    Stop,    USER, "", "", Stop, Dir, Route, RoutMod, Hour);
  CreateINDEX(Shdl, StopDir, PLURAL, "", "", Stop, Dir);

  SetVersionOfFILE(Shdl, 0);
  L_AFM.AF_CreateTemp("Shdl", "Shdl");
 END {Create_Shdl};

 PRIVATE PROCEDURE Create_TmpRtMod();
 BEGIN
  CreateFILE(TmpRtMod, "", "䨪樨 ", "");

  CreateFIELD(TmpRtMod, Route,   LIKE(Route.Route),   "", "", "", " ", "");
  CreateFIELD(TmpRtMod, RoutMod, LIKE(RoutMod.Modif), "", "", "", " 䨪樨 ", "");
  CreateFIELD(TmpRtMod, TKind,   LIKE(TKind.TKind),   "", "", "", " ॢ", "");

  CreateINDEXandLINK(TmpRtMod, RoutMod, UNIQUE, RoutMod, Route,   USER, "", "", Route, RoutMod, TKind);
  CreateINDEXandLINK(TmpRtMod, Route,   PLURAL, Route,   Route,   USER, "", "", Route);
  CreateINDEXandLINK(TmpRtMod, TKind,   PLURAL, TKind,   TKind,   USER, "", "", TKind);

  SetVersionOfFILE(TmpRtMod, 0);
  L_AFM.AF_CreateTemp("TmpRtMod", "TmpRtMod");
 END {Create_TmpRtMod};

 PRIVATE PROCEDURE Gather_TmpRtMod(trgRoute: LIKE(Route.Route); trgStop: LIKE(Stop.Stop));
 BEGIN
  IF     !trgRoute &  !trgStop THEN
   SELECT(RtMStop, RoutStop);
  ELSIF  !trgRoute & ~!trgStop THEN
   SELECT(RtMStop, Stop, , trgStop);
  ELSIF ~!trgRoute &  !trgStop THEN
   SELECT(RtMStop, RoutStop, , trgRoute);
  ELSE
   SELECT(RtMStop, RoutStop, , trgRoute, trgStop);
  END;
  WHILE OCCURE(RtMStop) DO
   PROMPT("ઠ:" + RtMStop.Route + " " + RtMStop.Modif);
   CONFORM(RtMStop, RoutMod);
   IF L_DatTim.IsActive(Memo.ud_cd(), RoutMod.FromD, RoutMod.UpDate) THEN
    CONFORM(RoutMod, Route);
    IF L_DatTim.IsActive(Memo.ud_cd(), Route.Begin, Route.Till) THEN
     L_Way.StandOnRouteTKind(Memo.ud_cd());
     ADD(TmpRtMod, RoutMod, , RtMStop.Route, RtMStop.Modif, TKind.TKind);
    END;
   END;
   NEXT(RtMStop);
  END; (* WHILE OCCURE(RtMStop) ... *)
 END {Gather_TmpRtMod};

 PRIVATE PROCEDURE Prepare_TmpRtMod(trgRoute: LIKE(Route.Route); trgStop: LIKE(Stop.Stop));
 BEGIN
  Create_TmpRtMod();
  Gather_TmpRtMod(trgRoute, trgStop);
 END {Prepare_TmpRtMod};

 PRIVATE PROCEDURE Gather_Shdl(trgStop: LIKE(Stop.Stop));
  VAR
   sysD,
   curD: DATE;
 BEGIN
  sysD:=SYSDATE();
  curD:=Memo.ud_cd();
  SAVE(Route);
  SELECT(TmpRtMod, RoutMod);
  WHILE OCCURE(TmpRtMod) DO
   CONFORM(TmpRtMod, RoutMod);
   IF RoutMod.Run > 0 THEN
    SELECT(SEJobs, RoutMod, , TmpRtMod.Route, TmpRtMod.RoutMod);
    SRCINSEL(SEJobs, GE, , curD);
    WHILE OCCURE(SEJobs) DO
     PROMPT("ઠ: " + SEJobs.Trip);
     CONFORM(SEJobs, StExit);
     IF (StExit.Strict=L_Way.ExitStrict_Reg) & L_Way.StExitActiveOnDate(StExit.Exit, curD) THEN
      CONFORM(StExit, ExitClss);
      SELECT(RtMStop, Route, , SEJobs.Route, SEJobs.Modif);
      WHILE OCCURE(RtMStop) DO
       IF !trgStop | (RtMStop.Stop = trgStop) THEN
        CONFORM(RtMStop, Stop);
        Shdl.Route   := TmpRtMod.Route;
        Shdl.Stop    := Stop.Stop;
        Shdl.Time    := L_Way.GetStopCtrlTime_ofCurSEJobs(sysD);
        Shdl.Hour    := FLDTOSTR(Shdl.Time, "H");
        Shdl.RoutMod := TmpRtMod.RoutMod;
        Shdl.SEJobs  := SEJobs.Trip;
        Shdl.TKind   := TmpRtMod.TKind;
        Shdl.StExit  := StExit.Exit;
        Shdl.ExitClss:= ExitClss.ExitClss;
        Shdl.WJMode  := SEJobs.WJCode;
        Shdl.Dir     := SEJobs.Dir;
        INSERT(Shdl);
       END; (* IF (~!trgStop & (RtMStop.Stop = trgStop)) ... *)
       NEXT(RtMStop);
      END; (* WHILE OCCURE(RtMStop) ... *)
     END; (* IF (StExit.Strict=L_Way.ExitStrict_Reg) ... *)
     NEXT(SEJobs);
    END; (* WHILE OCCURE(SEJobs) ... *)
   END; (* IF RoutMod.Run > 0 ... *)
   NEXT(TmpRtMod);
  END; (* WHILE OCCURE(TmpRtMod) ... *)
  RESTORE(Route);
 END {Gather_Shdl};

 PRIVATE PROCEDURE Prepare_Shdl(trgRoute: LIKE(Route.Route); trgStop: LIKE(Stop.Stop));
 BEGIN
  Prepare_TmpRtMod(trgRoute, trgStop);
  Create_Shdl();
  Gather_Shdl(trgStop);
 END {Prepare_Shdl};

 PUBLIC PROCEDURE T0500();
  CONST
   bpId = "T0500";
  VAR
   EmptyRoute: LIKE(Route.Route);
   EmptyStop : LIKE(Stop.Stop);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "ᯨᠭ  ⠭", L_bp.t_Basis, L_General.timeCond_OnDate);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader();
  SETEMPTY(EmptyRoute, EmptyStop);
  Prepare_Shdl(EmptyRoute, EmptyStop);
  SELECT(Shdl, Route);
  WHILE OCCURE(Shdl) DO
   PROMPT("㧪:  " + Shdl.Route);
   MakeLine();
   NEXT(Shdl);
  END; (* WHILE OCCURE(Shdl) ... *)
  FIO.Close(R);
  L_bp.End();
 END {T0500};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
Memo.ud_cd(), L, "D.N.y"
"(" + L_DatTim.WeekDayStr(L_DatTim.WEEKDAY(Memo.ud_cd()), 0) + ")", C, ""
@
############################################################################################ ########## #####
=#####=======================================================================================================
                                             ᯨᠭ 
#############################################################################################################
                                          ########## #############
}
*)

(*
$P{ Bot:
@
=(c) Polak===================================================================================================
}
*)

(*
$P{ SubTopByCurStop:
?, L, ""
@
-------------------------------------------------------------------------------------------------------------
|                                   |########################################################################
}
*)

(*
$P{ LineByCurStop:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|#### ##############################|##|##|##|##|##|##|##|##|##|##|##|##|##|##|##|##|##|##|##|##|##|##|##|##|
}
*)

(*
$P{ SplitterSparse:
@
|- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -|
}
*)

(*
$P{ SubTitle:
?, L, ""
@

#############################################################################################################
}
*)

(*
$P{ Splitter:
@
-------------------------------------------------------------------------------------------------------------
}
*)

(*
$P{ LineByCurRouteAndChosenStop:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
| #####    #####    #####    #####    #####    #####    #####    #####    #####    #####    #####    #####  |
}
*)

(*
$P{ SubTopKRM:
StExit.Exit, L, ""
StExit.Name, L, ""
StExit.Exit, L, ""
StExit.Name, L, ""
@

室                                                            室
######### ################################                       ######### ################################
--------------------------------------------                     --------------------------------------------
|אַ ࠢ                        |                     |⭮ ࠢ                      |
|------------------------------------------|                     |------------------------------------------|
|६|⠭                           |                     |६|⠭                           |
|-----|------------------------------------|                     |-----|------------------------------------|
}
*)

(*
$P{ LineKRM:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|#####|### ################################|                     |#####|### ################################|
}
*)

(*
$P{ SubBotKRM:
@
--------------------------------------------                     --------------------------------------------
}
*)

(*
$P{ BotKRM:
@
=(c) Polak==================================                     ============================================
}
*)

 PRIVATE PROCEDURE GetNextHour(Hour: SCAL[24]): SCAL[24];
 BEGIN
  IF    Hour + 1 < 24 THEN
   RETURN Hour + 1
  ELSE
   RETURN 0;
  END;
 END {GetNextHour};

 PRIVATE PROCEDURE IncHour(Hour, dt: SCAL[24]): SCAL[24];
  VAR
   idx   : SCAL[24 + 1];
   Result: SCAL[24];
 BEGIN
  idx:=0;
  Result:=Hour;
  WHILE idx < dt DO
   Result:=GetNextHour(Result);
   INC(idx);
  END;
  RETURN Result;
 END {IncHour};

 PRIVATE PROCEDURE GetHoursPools(PartsInADay: NUMERIC[0]);
  VAR
   Idx   : SCAL[24 + 1];
   Hour0,
   Hour1 : SCAL[24];
 BEGIN
  L_General.CallUs((PartsInADay = 1) | (PartsInADay = 2));
  DRTime:=P_OwnData.DspRepTime(Memo.ud_cd());
  SETEMPTY(HoursPart0_Pool, HoursPart1_Pool);
  Hour0:=FLDTOSTR(DRTime, "H");
  IF PartsInADay = 2 THEN
   Hour1:=(Hour0 + 12) - ((Hour0 + 12) > 24)*24;
  END;
  Idx:=0;
  REPEAT
   HoursPart0_Pool:=HoursPart0_Pool + Hour0 + "|";
   Hour0:=GetNextHour(Hour0);

   IF PartsInADay = 2 THEN
    HoursPart1_Pool:=HoursPart1_Pool + Hour1 + "|";
    Hour1:=GetNextHour(Hour1);
   END;
   INC(Idx);
  UNTIL Idx = 24/PartsInADay;
 END {GetHoursPools};

 PRIVATE PROCEDURE AccessRoute();
 BEGIN
  L_General.Assert(ACCESS(Route), " ⠭ ");
 END {AccessRoute};

 PRIVATE PROCEDURE GetOneRecordFromShdl(       trgExit : LIKE(StExit.Exit);
                                               trgDir  : SCAL[2];
                                           VAR dstTime,
                                               dstStop,
                                               dstSName: STRING[]);
 BEGIN
  IF SELECT(Shdl, StExit, trgExit, trgDir) THEN
   SRCINSEL(Shdl, GE, , 00:00);
   CONFORM(Shdl, Stop);
   dstTime :=FLDTOSTR(Shdl.Time, "H:M");
   dstStop :=Stop.Stop;
   dstSName:=L_Way.GetStopName(Stop.Stop);
   REMOVE(Shdl);
  ELSE
   SETEMPTY(dstTime, dstStop, dstSName);
  END;
 END {GetOneRecordFromShdl};

 PUBLIC PROCEDURE ShRAS();
  VAR
   EmptyStop     : LIKE(Stop.Stop);
   fwdTime,
   rvsTime,
   fwdStop,
   rvsStop,
   fwdSName,
   rvsSName      : STRING[];
   trgExit       : LIKE(StExit.Exit);
   ShdlIsNotEmpty: SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepName:="ShRAS";
  AccessRoute();
  SETEMPTY(EmptyStop);
  Prepare_Shdl(Route.Route, EmptyStop);
  IF ~SELECT(Shdl, Route) THEN
   L_StdFrm.RedInform(" 饣 ᯨᠭ |" +
                      Route.Route + " " + Route.Name);
  ELSE
   OPENREP(R, L_General.NameConnection(RepName), Create);
   MAKEPART(R, Top, "  " + Route.Route + " " + Route.Name);
   SELECT(Shdl, StExit);
   WHILE OCCURE(Shdl) DO
    NARROWSEL(Shdl, StExit);
    CONFORM(Shdl, StExit);
    trgExit:= StExit.Exit;
    MAKEPART(R, SubTopKRM);
    WHILE SELECT(Shdl, StExit, trgExit) DO
     GetOneRecordFromShdl(trgExit, L_Way.dir_Forward,  fwdTime, fwdStop, fwdSName);
     GetOneRecordFromShdl(trgExit, L_Way.dir_Backward, rvsTime, rvsStop, rvsSName);
     MAKEPART(R, LineKRM, fwdTime, fwdStop, fwdSName, rvsTime, rvsStop, rvsSName);
    END;
    SAVE(Shdl);
    ShdlIsNotEmpty:=SELECT(Shdl, StExit);
    RESTORE(Shdl);
    IF ShdlIsNotEmpty THEN
     MAKEPART(R, SubBotKRM);
    ELSE
     MAKEPART(R, BotKRM);
    END;
    NEXTINEXTENDEDSEL(Shdl, StExit);
   END; (* WHILE OCCURE(Shdl) ... *)
   CLOSEREP(R);
   L_General.SurveyLastReport();
  END;
 END {ShRAS};

 PRIVATE PROCEDURE MakeRepLine(PartsInADay: NUMERIC[0]; ThisIsFirstRepLine: SCAL[2]);
  VAR
   Idx         : SCAL[24 + 1];
   ArrStr      : STRING[][24];
   FindNotEmpty: SCAL[2];
   trgRoute    : LIKE(Route.Route);
   trgName     : LIKE(Route.Name);
 BEGIN
  L_General.CallUs((PartsInADay = 1) | (PartsInADay = 2));
  SETZERO(FindNotEmpty, Idx);
  WHILE Idx < 24/PartsInADay DO
   IF !ArrTime[Idx] THEN
    ArrStr[Idx]:="";
   ELSE
    ArrStr[Idx]:=FLDTOSTR(ArrTime[Idx], L_Str.PoolItem(" |M|H:M", PartsInADay));
    FindNotEmpty:=1;
   END;
   INC(Idx);
  END; (* WHILE Idx < 24/PartsInADay ... *)
  IF FindNotEmpty THEN
   BeganNewPage:=0;
   IF PartsInADay = 1 THEN
    IF ThisIsFirstRepLine THEN
     L_General.CallUs(SEARCH(RoutMod, Route, Route.Route, curRoutMod));
     trgRoute:=RoutMod.Route;
     trgName :=RoutMod.Name;
    ELSE
     SETEMPTY(trgRoute, trgName);
    END;
    MAKEPART(R, LineByCurStop, trgRoute, trgName,
                               ArrStr[00], ArrStr[01], ArrStr[02],
                               ArrStr[03], ArrStr[04], ArrStr[05],
                               ArrStr[06], ArrStr[07], ArrStr[08],
                               ArrStr[09], ArrStr[10], ArrStr[11],
                               ArrStr[12], ArrStr[13], ArrStr[14],
                               ArrStr[15], ArrStr[16], ArrStr[17],
                               ArrStr[18], ArrStr[19], ArrStr[20],
                               ArrStr[21], ArrStr[22], ArrStr[23]);
   ELSE
    MAKEPART(R, LineByCurRouteAndChosenStop, ArrStr[00], ArrStr[01], ArrStr[02],
                                             ArrStr[03], ArrStr[04], ArrStr[05],
                                             ArrStr[06], ArrStr[07], ArrStr[08],
                                             ArrStr[09], ArrStr[10], ArrStr[11]);
   END;
   SETEMPTY(ArrTime);
  END;
  PosCurHour:=0;
 END {MakeRepLine};

 PRIVATE PROCEDURE AddToRep(    PartsInADay       : NUMERIC[0];
                            VAR ThisIsFirstRepLine: SCAL[2]);
 BEGIN
  L_General.CallUs((PartsInADay = 1) | (PartsInADay = 2));
  curRoutMod:=ShedTmp.RoutMod;
  IF (ShedTmp.PosHour >= PosCurHour) THEN
   PosCurHour:=ShedTmp.PosHour;
   ArrTime[PosCurHour]:=ShedTmp.Time;
   IF REMOVE(ShedTmp) & (PosCurHour < (24/PartsInADay - 1)) THEN
    INC(PosCurHour);
   ELSE
    MakeRepLine(PartsInADay, ThisIsFirstRepLine);
    ThisIsFirstRepLine:=0;
    IF FIRST(ShedTmp) THEN
     PosCurHour:=ShedTmp.PosHour;
    END;
   END;
  ELSE
   IF ~NEXT(ShedTmp) THEN
    SELECT(ShedTmp, ShedTmp);
    IF ShedTmp.PosHour < PosCurHour THEN
     MakeRepLine(PartsInADay, ThisIsFirstRepLine);
     ThisIsFirstRepLine:=0;
    END;
    PosCurHour:=ShedTmp.PosHour;
   END;
  END;
 END {AddToRep};

 PRIVATE PROCEDURE SelectShdlRoutStopDirModif(trgDir  : SCAL[2];
                                              trgModif: LIKE(RoutMod.Modif)): SCAL[2];
 BEGIN
  IF ~!trgModif THEN
   RETURN SELECT(Shdl, Route, Route.Route, Stop.Stop, trgDir, trgModif);
  ELSE
   RETURN SELECT(Shdl, Route, Route.Route, Stop.Stop, trgDir);
  END;
 END {SelectShdlRoutStopDirModif};

 PRIVATE PROCEDURE PreparePartRep(    NumPartRep    : SCAL[2];
                                      PartsInADay   : NUMERIC[0];
                                      trgDir        : SCAL[2];
                                      trgModif      : LIKE(RoutMod.Modif);
                                      Title         : STRING[];
                                  VAR PartRepIsEmpty: SCAL[2]);
  VAR
   HoursPart_Pool    : STRING[];
   PosHour           : SCAL[24];
   ThisIsFirstRepLine: SCAL[2];
 BEGIN
  L_General.CallUs((PartsInADay = 1) | (PartsInADay = 2));
  SAVE(Shdl);
  IF SelectShdlRoutStopDirModif(trgDir, trgModif) THEN
   HoursPart_Pool:=^("HoursPart" + NumPartRep + "_Pool");
   IF (NumPartRep = 0) & (PartsInADay = 2) THEN
    MAKEPART(R, SubTitle, Title + L_Str.PoolItem(d_Pool, trgDir));
    MAKEPART(R, Splitter);
   END;
   WHILE OCCURE(Shdl) DO
    PosHour:=L_Str.PositionInPool(HoursPart_Pool, Shdl.Hour);
    IF ~!PosHour THEN
     ADD(ShedTmp, ShedTmp, , Shdl.RoutMod, PosHour, Shdl.Time);
     PartRepIsEmpty:=0;
    END;
    NEXT(Shdl);
   END; (* WHILE OCCURE(Shdl) ... *)
   SETEMPTY(ArrTime);
   IF SELECT(ShedTmp, ShedTmp) THEN
    PosCurHour:=ShedTmp.PosHour;
    curRoutMod:=ShedTmp.RoutMod;
   END;
   ThisIsFirstRepLine:=1;
   WHILE OCCURE(ShedTmp) DO
    AddToRep(PartsInADay, ThisIsFirstRepLine);
   END; (* WHILE OCCURE(ShedTmp) ... *)
   MakeRepLine(PartsInADay, ThisIsFirstRepLine);
   SELECT(ShedTmp, ShedTmp);
   REMSEL(ShedTmp);
  END;
  RESTORE(Shdl);
 END {PreparePartRep};

 PRIVATE PROCEDURE GetCurRouteListStop(VAR Idx, List: STRING[]);
 BEGIN
  SETEMPTY(List, Idx);
  SELECT(RtMStop, RoutStop, , Route.Route);
  WHILE OCCURE(RtMStop) DO
   NARROWSEL(RtMStop, Stop);
   PROMPT("஥ ᯨ᪠ ⠭: " + RtMStop.Stop);
   CONFORM(RtMStop, Stop);
   List:=List + Stop.Stop + " " + Str.Align(L_Way.GetStopName(Stop.Stop), 32, LEFT) + "|";
   Idx :=Idx  + Stop.Stop + "|";
   NEXTINEXTENDEDSEL(RtMStop, Stop);
  END; (* WHILE OCCURE(RtMStop) ... *)
 END {GetCurRouteListStop};

 PRIVATE PROCEDURE Create_ShedTmp();
 BEGIN
  L_AFM.MakeIndex("ShedTmp", "RoutMod: LIKE(RoutMod.Modif); PosHour: SCAL[24]; Time: TIME");
 END {Create_ShedTmp};

 PUBLIC PROCEDURE ShRSS();
  VAR
   Idx,
   Title,
   List   : STRING[];
   trgStop: LIKE(Stop.Stop);
   PartRepIsEmpty: SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepName:="ShRSS";
  AccessRoute();
  GetCurRouteListStop(Idx, List);
  trgStop:=L_Str.PoolItem(Idx, L_StdFrm.ShowListAsMenu(List, "⠭  " + Route.Route));
  L_General.CallUs(SEARCH(Stop, Stop, trgStop));
  GetHoursPools(2);
  Prepare_Shdl(Route.Route, Stop.Stop);
  IF ~SELECT(Shdl, Route) THEN
   L_StdFrm.RedInform(" 饣 ᯨᠭ |" +
                      Route.Route + " " + Route.Name + "|" +
                      "१ ⠭ 㭪|" +
                      Stop.Stop + " " + L_Way.GetStopName(Stop.Stop));
  ELSE
   Create_ShedTmp();

   OPENREP(R, L_General.NameConnection(RepName), Create);
   MAKEPART(R, Top, "  " + Route.Route + " " + Route.Name);
   Title:="१ ⠭ 㭪 " + Stop.Stop   + " " + L_Way.GetStopName(Stop.Stop) + " ";
   BeganNewPage:=0;
   PartRepIsEmpty:=1;
   PreparePartRep(0, 2, L_Way.dir_Forward, "", Title, PartRepIsEmpty);
   PreparePartRep(1, 2, L_Way.dir_Forward, "", Title, PartRepIsEmpty);
   IF ~PartRepIsEmpty THEN
    MAKEPART(R, Splitter);
   END;
 
   PartRepIsEmpty:=1;
   PreparePartRep(0, 2, L_Way.dir_Backward, "", Title, PartRepIsEmpty);
   PreparePartRep(1, 2, L_Way.dir_Backward, "", Title, PartRepIsEmpty);
   MAKEPART(R, Bot);
   CLOSEREP(R);
   L_General.SurveyLastReport();
  END;
 END {ShRSS};

 PRIVATE PROCEDURE CntLinesInPartLineByCurStop(): NUMERIC[0];
  VAR
   Idx            : SCAL[24];
   Result         : NUMERIC[0];
   CntLinesByHours: NUMERIC[0][24];
   trgRoutMod     : LIKE(RoutMod.Modif);
 BEGIN
  SAVE(Shdl);
  SETZERO(CntLinesByHours, Result);
  IF SELECT(Shdl, Stop, Shdl.Stop, trgDir, Shdl.Route) THEN
   trgRoutMod:=Shdl.RoutMod;
  END;
  WHILE OCCURE(Shdl) DO
   IF Shdl.RoutMod # trgRoutMod THEN
    FOR_EACH Idx DO
     INC(CntLinesByHours[Idx]);
    END;
    trgRoutMod:=Shdl.RoutMod;
   END;
   INC(CntLinesByHours[Shdl.Hour]);
   NEXT(Shdl);
  END;
  RESTORE(Shdl);
  FOR_EACH Idx DO
   IF CntLinesByHours[Idx] > Result THEN
    Result:=CntLinesByHours[Idx];
   END;
  END;
  RETURN Result;
 END {CntLinesInPartLineByCurStop};

 PRIVATE PROCEDURE PartWithReverseDirectionIsNotEmpty(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  L_General.CallUs(OCCURE(Stop));
  SAVE(Shdl);
  Result:= SELECT(Shdl, StopDir, Stop.Stop, L_Way.dir_Forward);
  RESTORE(Shdl);
  RETURN Result;
 END {PartWithReverseDirectionIsNotEmpty};

 PRIVATE PROCEDURE MakeShdlByCurStopByOneDir();
  VAR
   PartRepIsEmpty: SCAL[2];
 BEGIN
  IF ~BeganNewPage & PartWithReverseDirectionIsNotEmpty() THEN
   L_PagePr.PagePr_BeforePrintLine(DEPTH(SubTopByCurStop) + DEPTH(Splitter));
   MAKEPART(R, SubTopByCurStop, HoursPart0_Pool);
   MAKEPART(R, Splitter);
   FORMFEED(R);
   L_PagePr.PagePr_BeforePrintLine(DEPTH(SubTitle) + DEPTH(SubTopByCurStop) + DEPTH(Splitter));
   MAKEPART(R, SubTitle, L_Str.PoolItem(d_Pool, trgDir));
   MAKEPART(R, SubTopByCurStop, HoursPart0_Pool);
   MAKEPART(R, Splitter);
  END;
  PartRepIsEmpty:=1;
  SELECT(Shdl, Stop, , Stop.Stop, trgDir);
  WHILE OCCURE(Shdl) DO
   NARROWSEL(Shdl, Route);
   CONFORM(Shdl, Route);
   L_PagePr.PagePr_BeforePrintLine(DEPTH(SplitterSparse) + DEPTH(LineByCurStop)*CntLinesInPartLineByCurStop());
   IF ~PartRepIsEmpty & ~BeganNewPage THEN
    MAKEPART(R, SplitterSparse);
   END;
   WHILE OCCURE(Shdl) DO
    NARROWSEL(Shdl, RoutMod);
    PreparePartRep(0, 1, trgDir, Shdl.RoutMod, "", PartRepIsEmpty);
    NEXTINEXTENDEDSEL(Shdl, RoutMod);
   END;
   NEXTINEXTENDEDSEL(Shdl, Route);
  END; (* WHILE OCCURE(Shdl) ... *)
 END {MakeShdlByCurStopByOneDir};

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Top, "१ ⠭ 㭪 " + Stop.Stop + " " + L_Way.GetStopName(Stop.Stop));
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(SubTopByCurStop) + DEPTH(Bot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, SubTopByCurStop, HoursPart0_Pool);
   MAKEPART(R, Bot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Print);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(SubTitle) + DEPTH(SubTopByCurStop) + DEPTH(Splitter));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, SubTitle, L_Str.PoolItem(d_Pool, L_Way.dir_Forward));
   MAKEPART(R, SubTopByCurStop, HoursPart0_Pool);
   MAKEPART(R, Splitter);
   BeganNewPage:=1;
  ELSIF Mode = L_PagePr.m_RDoneTop THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(SubTopByCurStop) + DEPTH(Splitter));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, SubTopByCurStop, HoursPart0_Pool);
   MAKEPART(R, Splitter);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(LineByCurStop) + 1);
  ELSIF Mode = L_PagePr.m_Print THEN
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PUBLIC PROCEDURE ShdlS();
  VAR
   EmptyRoute: LIKE(Route.Route);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepName:="ShdlS";
  L_General.Assert(ACCESS(Stop), " ⠭ ⠭");
  SETEMPTY(EmptyRoute);
  GetHoursPools(1);
  Prepare_Shdl(EmptyRoute, Stop.Stop);
  IF ~SELECT(Shdl, Route) THEN
   L_StdFrm.RedInform(" 饣 ᯨᠭ|" +
                      "१ ⠭ 㭪|" +
                      Stop.Stop + " " + L_Way.GetStopName(Stop.Stop));
  ELSE
   Create_ShedTmp();
   OPENREP(R, L_General.NameConnection(RepName), Create);
   L_PagePr.PagePr_Init("R", 64, PROCREF(_RprtTop),
                                 PROCREF(_PageTop),
                                 PROCREF(_PageBot),
                                 PROCREF(_RprtBot),
                                 PROCREF(_Filling));
   FOR_EACH trgDir DO
    MakeShdlByCurStopByOneDir();
   END;
   L_PagePr.PagePr_Done();
   CLOSEREP(R);
   L_General.SurveyLastReport();
  END;
 END {ShdlS};

END.
