(*
%Copyright   (c) Polak Computer System
%Author      28.06.2002 18:19:39 GAV
%Purpose       
%Type        report
%Specific    AP_PC
%Modified    15.08.2014 22:12:54 POLAK\San
%Environment
*)

 MODULE T2100 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT FIO, L_General, L_Env, L_Car, L_Basis, L_DatTim, L_Str, L_Way,
        P_Firm, D_TP, P_Route, D_RWS, L_AFM, L_bp;

 VAR
  wMF : SCAL[2];
  BPer,
  EPer      : DATE;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "஢");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "ࠪ室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "죏1");
  L_Basis.wb_WrInQM(F, "죏2");
  L_Basis.wb_WrInQM(F, "죏");
  L_Basis.wb_WrInQM(F, "⏠");
  IF D_TP.wVldPsgPlan THEN
   L_Basis.wb_WrInQM(F, "ଏᏫ");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "Ꭱ");
  L_Basis.wb_WrInQM(F, "ଏᎡ");
  L_Basis.wb_WrInQM(F, "୫");
  L_Basis.wb_WrInQM(F, "ࢯ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " /");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ৢ");
  L_Basis.wb_WrInQM(F, "ৢ");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "ࠢ ᮡ⢥");
  L_Basis.wb_WrInQM(F, "⢥");
  L_Basis.wb_WrInQM(F, "⢥");
  L_Basis.wb_WrInQM(F, "⊬");
  L_Basis.wb_WrInQM(F, "⊬");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "㯯_ப");
  L_Basis.wb_WrInQM(F, "㯯_ப");
  L_Basis.wb_WrInQM(F, "設  ࠡ (業)");
  L_Basis.wb_WrInQM(F, "㯯 ⮢");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  CONFORM(TP002, StExit);
  CONFORM(TP002, WJMode);
  IF wMF THEN
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.tkrgn_Pool, TKind.Rgn));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.tkfnm_Pool, TKind.FnMode));
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Car.purp_Pool, CarLog.Purpose));
  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|", D_TP.E_IsRoute2Distribute(Route.Route, EPer)));
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, TP002.Exit);
  L_Basis.wb_WrScl(F, L_Str.PoolItem(L_Way.ExitStrict_Pool, StExit.Strict));
  L_Basis.wb_WrScl(F, L_Str.PoolItem("-|+", StExit.Suppl));

  L_Basis.wb_WrNum(F, TP002.OrdTim,  3);
  L_Basis.wb_WrNum(F, D_TP.E_GetOrdTim(TP002.OrdTim, D_TP.otp_WIM), 3);
  L_Basis.wb_WrNum(F, D_TP.E_GetOrdTim(TP002.OrdTim, D_TP.otp_Rsv),      3);
  L_Basis.wb_WrNum(F, D_TP.E_GetOrdTim(TP002.BadTim, D_TP.otp_WIM), 3);
  IF WJMode.WJType = L_Way.WJType_Repair THEN
   L_Basis.wb_WrNum(F, TP002.OrdTim, 3);
  ELSE
   L_Basis.wb_WrNum(F, 0, 3);
  END;
  L_Basis.wb_WrNum(F, D_TP.E_GetOrdTim(TP002.OrdTim, D_TP.otp_Otg),       3);

  IF    WJMode.RunSel = L_Way.runsel_Zero THEN
   L_Basis.wb_WrNum(F, TP002.FullRun, 1);
  ELSE
   L_Basis.wb_WrNum(F, 0, 1);
  END;

  L_Basis.wb_WrNum(F, TP002.FullRun,  1);

  IF (WJMode.WJType = L_Way.WJType_Work) & (WJMode.RunSel = L_Way.runsel_Work) THEN
   L_Basis.wb_WrNum(F, TP002.AllTrips, 1);
   L_Basis.wb_WrNum(F, TP002.GoodTrips, 1);
   L_Basis.wb_WrNum(F, TP002.BadTrips, 1);
  ELSE
   L_Basis.wb_WrNum(F, 0, 1);
   L_Basis.wb_WrNum(F, 0, 1);
   L_Basis.wb_WrNum(F, 0, 1);
  END;

  L_Basis.wb_WrNum(F, TP002.IncCnt, 2);
  L_Basis.wb_WrNum(F, TP002.IncPln, 2);
  L_Basis.wb_WrNum(F, TP002.Pass, 0);
  L_Basis.wb_WrNum(F, TP002.VldPsg[L_Way.vpk_MoscowRegion], 0);
  L_Basis.wb_WrNum(F, TP002.VldPsg[L_Way.vpk_Moscow      ], 0);
  L_Basis.wb_WrNum(F, TP002.VldPsg[L_Way.vpk_OtherSocial ], 0);
  L_Basis.wb_WrNum(F, TP002.VldPsg[L_Way.vpk_Paid        ], 0);
  IF D_TP.wVldPsgPlan THEN
   L_Basis.wb_WrNum(F, TP002.VldPsgPln, 2);
  END;

  IF WJMode.IncSel THEN
   L_Basis.wb_WrNum(F, TP002.FullRun, 1);
  ELSE
   L_Basis.wb_WrNum(F, 0, 1);
  END;

  L_Basis.wb_WrScl(F, StExit.ExitClss);
  L_Basis.wb_WrNum(F, D_TP.E_GetOrdTim(TP002.OrdTim, D_TP.otp_Whl), 3);
  L_Basis.wb_WrNum(F, TP002.PassRound,   3);
  L_Basis.wb_WrNum(F, TP002.VldPsgRound, 3);

  IF    (WJMode.WJType = L_Way.WJType_Repair) & L_Way.E_IsRepInLine(EPer) THEN
   L_Basis.wb_WrNum(F, TP002.OrdTim, 3);
   L_Basis.wb_WrNum(F, 0, 3);
  ELSIF (WJMode.WJType = L_Way.WJType_Repair) & L_Way.E_IsRepInPark(EPer) THEN
   L_Basis.wb_WrNum(F, 0, 3);
   L_Basis.wb_WrNum(F, TP002.OrdTim, 3);
  ELSE
   L_Basis.wb_WrNum(F, 0, 3);
   L_Basis.wb_WrNum(F, 0, 3);
  END;

  L_Basis.wb_WrNum(F, Route.VCor, 0);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", TKind.InTEP));
  L_Basis.wb_WrScl(F, CarLog.Column);
  L_Basis.wb_WrScl(F, Column.Name);

  IF WJMode.RunSel = L_Way.runsel_Work THEN
   L_Basis.wb_WrNum(F, TP002.FullRun, 1);
   IF  WJMode.WJType = L_Way.WJType_Work THEN
    L_Basis.wb_WrNum(F, TP002.OrdTim, 3);
   ELSE
    L_Basis.wb_WrNum(F, 0, 3);
   END;
  ELSE
   L_Basis.wb_WrNum(F, 0, 1);
   L_Basis.wb_WrNum(F, 0, 3);
  END;

  L_Basis.wb_WrScl(F, TP002.BoxNbr);
  L_Basis.wb_WrStr(F, CarLog.StateNbr);
  IF ~!CarLog.VehPasp THEN
   CONFORM(CarLog, VehPasp);
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Car.OwnS_VehPPool, VehPasp.OwnerShp));
   CONFORM(VehPasp, Firm);
   L_Basis.wb_WrScl(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrNum(F, TP002.PVKm[D_TP.pv_Sittn], 2);
  L_Basis.wb_WrNum(F, TP002.PVKm[D_TP.pv_Averg], 2);

  IF    (WJMode.WJType = L_Way.WJType_Work) & L_Way.E_IsResInLine(EPer) THEN
   L_Basis.wb_WrNum(F, TP002.OrdTim, 3);
   L_Basis.wb_WrNum(F, 0, 3);
  ELSIF (WJMode.WJType = L_Way.WJType_Work) & L_Way.E_IsResInPark(EPer) THEN
   L_Basis.wb_WrNum(F, 0, 3);
   L_Basis.wb_WrNum(F, TP002.OrdTim, 3);
  ELSE
   L_Basis.wb_WrNum(F, 0, 3);
   L_Basis.wb_WrNum(F, 0, 3);
  END;

  L_Basis.wb_WrStr(F, L_Way.E_ConvertWDStr(EPer, TP002.DN));
  L_General.Assert(SEARCH(MarkG, MarkG, L_Way.GetMarkG(Mark.Mark, L_Way.mgt_TEP)), "  㯯 ப");
  L_Basis.wb_WrScl(F, MarkG.MarkG);
  L_Basis.wb_WrStr(F, MarkG.Name);
  L_Basis.wb_WrNum(F, TP002.CarDay, 2);
  L_Basis.wb_WrStr(F, P_Route.GetRouteProSoft(Route.Route, EPer, P_Route.P_Group));
  SEARCH(TPD01, TP002, , TP002.TP002);
  L_Basis.wb_WrNum(F, D_TP.TPD01_FullOrdTim(D_TP.otp_Whl), 3);
  L_Basis.wb_WrNum(F, D_TP.TPD01_FullOrdTim(D_TP.otp_WIM), 3);
  L_Basis.wb_WrNum(F, D_TP.TPD01_FullOrdTim(D_TP.otp_Otg), 3);
  L_Basis.wb_WrNum(F, D_TP.TPD01_FullOrdTim(D_TP.otp_Rsv), 3);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PUBLIC PROCEDURE T2100();
  CONST
   bpId = "T2100";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "  ", L_bp.t_Basis, L_General.tc_inIntvl);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_General.SetIntvlByIntvl(BPer, EPer);
  D_TP.PrepareTP002();
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
  SELECT(TP002, Route);
  WHILE OCCURE(TP002) DO
   NARROWSEL(TP002, Route);
   CONFORM(TP002, Route);
   L_Way.StandOnRouteTKind(EPer);
   WHILE OCCURE(TP002) DO
    NARROWSEL(TP002, BoxNbr, clDate);
    L_Car.StandOnCarLog(TP002.BoxNbr, TP002.clDate);
    CONFORM(CarLog, Mark);
    CONFORM(CarLog, Column);
    IF wMF THEN
     CONFORM(Column, MyFirm);
    END;
    WHILE OCCURE(TP002) DO
     PROMPT("㧪: " + TP002.Route + " " + TP002.BoxNbr + " " + TP002.Exit);
     IF L_Env.RealBoxNbr(TP002.BoxNbr) & ((TP002.OrdTim # 0) | (TP002.FullRun # 0)) THEN
      MakePart("R");
     END; (* IF L_Env.RealBoxNbr(TP002.BoxNbr)... *)
     NEXT(TP002);
    END; (* WHILE OCCURE(TP002) ... *)
    NEXTINEXTENDEDSEL(TP002, BoxNbr, clDate);
   END;
   NEXTINEXTENDEDSEL(TP002, Route);
  END; (* WHILE OCCURE(TP002) ... *)
  D_TP.PurgeTP002();
  FIO.Close(R);
  L_bp.End();
 END {T2100};

END.
