(*
%Copyright   (c) Polak IT
%Author      05.05.2003 13:35:44 POLAK\SAN
%Purpose      ⠢   窥
%Type        report
%Specific    AP
%Modified    20.02.2014 13:41:44 POLAK\MLB
%Environment
*)

 IMPORT L_General, L_DatTim, L_Way, E_Way, L_Car, L_AFM, FIO, L_Basis, L_Str,
        L_TRS, L_APWI, L_Staff, L_bp, L_EC;

 VAR
  IntvlB,
  IntvlE      : DATE;
  ReminderPlIncome,
  SpecialPlIncome,
  ReminderPaidT,
  SpecialPaidT: NUMERIC[3];

 PRIVATE PROCEDURE Create_T9450();
 BEGIN
  CreateFILE(T9450, "", "", "");

  CreateFIELD(T9450, TSN,    LIKE(Staff.TSN), "", "", "", " ", "");
  CreateFIELD(T9450, Cnd,    L_Way.tIncPlanCondition, "", "", "", "⥫⢠", "");
  CreateFIELD(T9450, Route,  STRING[4], "", "", "", "", "");
  CreateFIELD(T9450, Exit,   LIKE(StExit.Exit), "", "", "", "室", "");
  CreateFIELD(T9450, Trip,   LIKE(SEJMStop.Trip), "", "", "", "", "");
  CreateFIELD(T9450, Day,    LIKE(RWayJ.Day), "", "", "", " 砫 ३", "");
  CreateFIELD(T9450, StartT, TIME, "", "", "", "६ 砫 ३", "");
  CreateFIELD(T9450, Mark,   SCAL[10000], "", "", "", "ઠ", "");
  CreateFIELD(T9450, WD,     SCAL[8], "", "", "", "ਢ  ", "");
  CreateFIELD(T9450, Date,   DATE, "", "", "", "", "");

  CreateFIELD(T9450, IncTim, NUMERIC[10, 3], "", "0", "", "६  ", "");
  CreateFIELD(T9450, IncTrp, NUMERIC[10, 1], "", "0", "", "᪨ ३  室", "");
  CreateFIELD(T9450, IncPln, NUMERIC[10, 2], "", "0", "", " 窠", "");
  CreateFIELD(T9450, IncFct, NUMERIC[10, 2], "", "0", "", "᪠ 窠", "");

  CreateINDEXandLINK(T9450, TSN, UNIQUE, Staff, TSN, USER, "", "",
                               TSN, Cnd, Route, Exit, Trip, Day, StartT, Mark, WD, Date);

  CreateINDEXandLINK(T9450, Mark, PLURAL, Mark, Mark, USER, "", "", Mark);
  CreateINDEXandLINK(T9450, Route, PLURAL, Route, Route, USER, "", "", Route);
  CreateINDEXandLINK(T9450, Exit, PLURAL, StExit, Exit, USER, "", "", Exit);

  SetVersionOfFILE(T9450, 0001);
 END {Create_T9450};

 PRIVATE PROCEDURE GetTotalIncFact(): NUMERIC[2];
  VAR
   Result: NUMERIC[2];
 BEGIN
  Result:=0;
  CONFORM(RWayJ, RWayJP);
  WHILE OCCURE(RWayJP) DO
   IF L_Way.TrIncFct(L_Way.rwswho_Dr_W_Gu, 0, RWayJP.RWJPro) THEN
    INC(Result, RWayJP.Value);
   END;
   NEXT(RWayJP);
  END; (* WHILE OCCURE(RWayJP) ... *)
  RETURN Result;
 END {GetTotalIncFact};

 PRIVATE PROCEDURE GetGuardNumber(): LIKE(WayLMen.Number);
 BEGIN
  IF    TckRcS.AsWho = L_Way.trs_Guard THEN
   SELECT(WayLMen, RWayS, , RWayS.RWayS, L_Way.wlmwho_Guard);
  ELSE
   RETURN 1;
  END;
  WHILE OCCURE(WayLMen) DO
   IF WayLMen.TSN = TckRcS.TSN THEN
    IF L_Way._TimeInt(L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT),
                      L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT),
                      L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT),
                      L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT)) > 0 THEN
     RETURN WayLMen.Number;
    END;
   END;
   NEXT(WayLMen);
  END; (* WHILE ... *)
  L_General.Error(" ⥢  " + RWayS.RWayS + "  㪠 " +
                  Str.Small(L_Str.PoolItem(L_Way.trs_Pool, TckRcS.AsWho)) +
                  " " + TckRcS.TSN + "  " + L_DatTim.TimeStr(RWayJ.StartT));
 END {GetGuardNumber};

 PRIVATE PROCEDURE GetIncByTckRcJ(): NUMERIC[2];
  VAR
   _RWJPro: LIKE(RWJPro.RWJPro)[16];
   _Value : LIKE(RWayJP.Value)[16];
   i,
   Number : NUMERIC[0];
   Result : NUMERIC[2];
   _Who   : L_Way.tRWSWho;
 BEGIN
  CONFORM(TckRcJ, TckRcS);
  Number:=GetGuardNumber();
  L_TRS.PrepareRWayJP(Number, _RWJPro, _Value);
  IF TckRcS.AsWho = L_Way.trs_Chopper THEN
   _Who:=L_Way.rwswho_Chopper;
  ELSE
   _Who:=TckRcS.AsWho;
  END;
  Result:=0;
  i:=0;
  WHILE ~!_RWJPro[i] DO
   IF L_Way.E_TrIncFct(_Who, Number, _RWJPro[i]) & ~L_Way.E_TrCasFct(_Who, Number, _RWJPro[i]) THEN
    INC(Result, _Value[i]);
   END;
   INC(i);
  END;
  RETURN Result;
 END {GetIncByTckRcJ};

 PRIVATE PROCEDURE GetPlForIPC(curIPCondition: L_Way.tIncPlanCondition): NUMERIC[4];
  VAR
   PlInc : LIKE(RWayJ.PlIncome);
   CurTime: NUMERIC[3];
 BEGIN
  CurTime:=RWayJ.StopT  - RWayJ.StartT;
  IF ~!SpecialPlIncome & (curIPCondition#L_Way.ipc_Total) THEN (*騩  ⮫쪮   ࠢ*)
   PlInc:=SpecialPlIncome / SpecialPaidT * CurTime;
   DEC(ReminderPlIncome, PlInc);
   DEC(ReminderPaidT,    CurTime);
   IF ReminderPaidT = 0 THEN  (* ᫥ ३ ᣮ塞 ⮪ 㣫*)
    RETURN PlInc+ReminderPlIncome;
   ELSE
    RETURN PlInc;
   END;
  ELSE
   RETURN L_APWI.GetPlForIPC(curIPCondition);
  END;
 END {GetPlForIPC};

 PRIVATE PROCEDURE DoSingleIPC(curIPCondition: L_Way.tIncPlanCondition);
  VAR
   _Pln,
   _Fct    : NUMERIC[2];
   curTSN  : LIKE(Staff.TSN);
   Need_Pln: SCAL[2];
   curWho  : L_Way.tTRSWho;
 BEGIN
  SAVE(ExitIP);
  CONFORM(SEJobs, StExit);
  IF L_Way.AccessCurExitIP(RWayS.Date, curIPCondition) &
     (ExitIP.Type # L_Way.ipt_Canceled) THEN
   CONFORM(RWayJ, SEJobs, WJMode, Route);
   CONFORM(RWayJ, Quality);

   Need_Pln:=1;
   IF curIPCondition = L_Way.ipc_Total THEN
    _Fct  :=GetTotalIncFact();
    curTSN:=RWayS.TSN;
    curWho:=L_Way.trs_Driver;
   ELSE
    SETEMPTY(curTSN, curWho);
    _Fct:=0;
    SELECT(TckRcJ, asRWayS, , RWayJ.RWayS, RWayJ.Day, RWayJ.StartT);
    WHILE OCCURE(TckRcJ) DO
     CONFORM(TckRcJ, TckRcS);
     IF L_APWI.E_trsWho2IPC() = curIPCondition THEN
      IF !curTSN THEN
       curTSN:=TckRcS.TSN;
       curWho:=TckRcS.AsWho;
      ELSE
       L_General.Assert(curTSN = TckRcS.TSN,
                        "   ,  ࠧ ࠡ⭨   ३?");
      END;
      INC(_Fct, GetIncByTckRcJ());
     END;
     NEXT(TckRcJ);
    END; (* WHILE OCCURE(TckRcJ) ... *)
    IF !curTSN THEN
     curTSN:=RWayS.TSN;
     curWho:=L_Way.trs_Driver;
     IF curIPCondition >= L_Way.ipc_UserDefined THEN
      Need_Pln:=0;
     END;
    END;
   END;

   _Pln:=0;
   IF ((curIPCondition=L_Way.ipc_Driver) | (curIPCondition=L_Way.ipc_Total)) &
      L_Way.E_RWayJPlanIsEqualFact() THEN
    _Pln:=_Fct;
   ELSIF (WJMode.IncSel*Route.IncSel > 0) & (Quality.Type # L_Way.QualType_Annul) & Need_Pln THEN
    IF curWho = L_Way.trs_Chopper THEN
     _Pln:=L_Way.GetChopperPlanIncome(curTSN);
    ELSE
     _Pln:=GetPlForIPC(curIPCondition);
    END;
   END;

   IF _Fct | _Pln | ((curIPCondition<=L_Way.ipc_Total) & L_Way.RWayJWithPlIncome()) THEN
    ADD(T9450, TSN, , curTSN, curIPCondition,
                      SEJobs.Route, SEJobs.Exit, SEJobs.Trip, RWayJ.Day, RWayJ.StartT,
                      Mark.Mark, Calendar.WDInc, RWayS.Date,
         T9450.IncPln, _Pln,
         T9450.IncFct, _Fct,
         T9450.IncTim, RWayJ.StopT-RWayJ.StartT,
         T9450.IncTrp, RWayJ.Fact);
   END;
  END; (* IF L_Way.AccessCurExitIP ... *)
  RESTORE(ExitIP);
 END {DoSingleIPC};

 PUBLIC PROCEDURE E_PlIncomeRWJPro(D: DATE): LIKE(RWJPro.RWJPro);
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Way.PlIncomeRWJPro), L_General.EMPTY_NUMBER());
 END {E_PlIncomeRWJPro};

 PRIVATE PROCEDURE ClientPart();
  VAR
   PlIncomeRWJPro: LIKE(RWJPro.RWJPro);
 BEGIN
  SETEMPTY(SpecialPlIncome); SpecialPaidT:=0;
  PlIncomeRWJPro:=E_PlIncomeRWJPro(IntvlE);
  IF !PlIncomeRWJPro THEN
   RETURN;
  END;
  SELECT(RWayJP, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayJP) DO
   IF RWayJP.RWJPro = PlIncomeRWJPro THEN
    L_General.Assert(!SpecialPlIncome, "   ⠭ ⢥ ࠧ  ");
    SpecialPlIncome:=RWayJP.Value;
   END;
   NEXT(RWayJP);
  END; (* WHILE OCCURE(RWayJP) ... *)
  IF ~!SpecialPlIncome THEN
   CONFORM(RWayS, RWayJ);
   CONFORM(RWayJ, SEJobs);
   WHILE OCCURE(RWayJ) DO
    CONFORM(RWayJ, SEJobs, Route, WJMode, Quality);
    IF L_Way.RWayJWithPlIncome() THEN
     INC(SpecialPaidT, RWayJ.StopT - RWayJ.StartT);
    END;
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
  END;
  ReminderPlIncome:=SpecialPlIncome;
  ReminderPaidT   :=SpecialPaidT;
 END {ClientPart};

 PRIVATE PROCEDURE E_Need_ipc_Total(): SCAL[2];
 BEGIN
  CONFORM(SEJobs, StExit);
  RETURN L_EC.ExecE_Func_Scal2(RWayS.Date, PROCREF(E_Way.Need_ipc_Total),
                               L_Way.AccessCurExitIP(RWayS.Date, L_Way.ipc_Total));
 END {E_Need_ipc_Total};

 PRIVATE PROCEDURE DoOneRWayS();
  VAR
   _Cnd  : L_Way.tIncPlanCondition;
 BEGIN
  ClientPart();
  CONFORM(RWayS, Calendar);
  CONFORM(RWayS, Car);
  L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayJ) DO
   CONFORM(RWayJ, SEJobs);
   IF E_Need_ipc_Total() THEN
    SELECT(ExitIP, ExitIP, , SEJobs.Exit);
    WHILE OCCURE(ExitIP) DO
     CHANGESEL(ExitIP, ExitIP, , ExitIP.Exit, ExitIP.Cnd);
     _Cnd:=ExitIP.Cnd;
     IF (_Cnd = L_Way.ipc_Guard) & L_Way.E_FillIncPlanFromIncPlanG(RWayS.Date) THEN
      _Cnd:=L_Way.ipc_Driver;
     END;
     DoSingleIPC(_Cnd);
     LAST(ExitIP);
     CHANGESEL(ExitIP, ExitIP, , ExitIP.Exit);
     NEXT(ExitIP);
    END; (* WHILE OCCURE(ExitIP) ... *)
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
 END {DoOneRWayS};

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥫⢠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६ 砫 ३");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "㯯 ⨬");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.E_IPConditionPool(T9450.Date), T9450.Cnd));
  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrScl(F, StExit.Exit);
  L_Basis.wb_WrScl(F, StExit.ExitClss);
  L_Basis.wb_WrStr(F, T9450.Trip);
  L_Basis.wb_WrStr(F, T9450.Day + " " + L_DatTim.TimeStr(T9450.StartT));
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrScl(F, Mark.Name);
  L_Basis.wb_WrStr(F, L_Way.GetMarkPasVolSign(IntvlE, Mark.Mark));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("||||", L_Way.E_ConvertWD(T9450.Date, T9450.WD)));
  L_Basis.wb_WrDat(F, T9450.Date);
  L_Basis.wb_WrNum(F, T9450.IncTim, 3);
  L_Basis.wb_WrNum(F, T9450.IncTrp, 1);
  L_Basis.wb_WrNum(F, T9450.IncPln, 2);
  L_Basis.wb_WrNum(F, T9450.IncFct, 2);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE T9450();
  CONST
   bpId="T9450";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.SetIntvlByIntvl(IntvlB, IntvlE);
  L_bp.Begin(bpId, " ⠢   窥", L_bp.t_Basis, L_General.tc_inIntvl);
  Create_T9450(); L_AFM.AF_CreateTemp("T9450", "T9450");

  L_Way.CheckTaxed(IntvlB, IntvlE);
  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated);
  SRCINSEL(RWayS, GE, , IntvlB);
  WHILE OCCURE(RWayS) & (RWayS.Date <= IntvlE) DO
   PROMPT("  " + RWayS.RWayS + " (" + L_DatTim.DateStr(RWayS.Date) + "): ⮢ ");
   DoOneRWayS();
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
  SELECT(T9450, TSN);
  WHILE OCCURE(T9450) DO
   PROMPT("⭨  " + T9450.TSN + " (" + L_DatTim.DateStr(T9450.Date) + "): ⮢ ");
   CONFORM(T9450, Staff);
   L_Staff.PosToStaffLog(T9450.TSN, T9450.Date, 1);
   CONFORM(StaffLog, Sort);
   CONFORM(Staff, Man);
   CONFORM(T9450, Route);
   CONFORM(T9450, StExit);
   CONFORM(T9450, Mark);
   MakePart("R");
   NEXT(T9450);
  END; (* WHILE OCCURE(T9450) ... *)
  L_AFM.AF_PurgeTemp("T9450");
  FIO.Close(R);
  L_bp.End();
 END {T9450};

END.
