(*
%Copyright   (c) Polak Computer System
%Author      16.08.93 GINA 
%Purpose      䮢  䨪 
%Type        report
%Specific    AP
%Modified    22.11.2013 15:55:46 POLAK\San
%Environment
*)

 MODULE Tariff [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, P_OwnData, L_DatTim, Math, Str, Memo, L_Str, L_APtm, L_MSO, L_Way, P_Firm;

 PRIVATE CONST
  TrfIdx   = 30;
  StopNbr  = 128;
  VizitNbr = 10;

 PRIVATE VAR
  RetInTown  : SCAL[2];
  ScalBase,
  ScalStep   : LIKE(RtMStop.RDis)[TrfIdx];
  PriceBase,
  PriceStep  : NUMERIC[2][TrfIdx];
  Dis        : LIKE(RtMStop.RDis)[StopNbr];
  Trf        : NUMERIC[2][StopNbr];
  Sign       : LIKE(Stop.Sign)[StopNbr];
  BRelation  : SCAL[2*VizitNbr+1][StopNbr];
  CurStopIdx,
  CurVizit,
  j          : NUMERIC[0];
  _BDis      : LIKE(RtMStop.BDis)[VizitNbr];
  StopAmount : NUMERIC[0];

(*
$P {Title:
"  ஥", C, ""
"  "+RoutMod.Route+" 䨪樨 "+RoutMod.Modif+" "+RoutMod.Name, C, ""
"  "+L_DatTim.DateStr(Memo.ud_cd()), C, ""
@
#############################################################################################################################
#############################################################################################################################
#############################################################################################################################
}
*)

(*
$P {Name:
L_Way.GetStopName(Stop.Stop), L, ""
@
|################################
}
*)

(*
$P {Dis:
?, R, "1."
@
|##### }
*)

(*
$P {Tariff:
?, R, ""
@
|#####}
*)

(*
$P {Line:
?, L, ""
@
#######}
*)

(*
$P {CR:
@
|
}
*)

(*
$P {CR1:
@
-
}
*)

 PRIVATE PROCEDURE Short_Assert(Cond: SCAL[2]; S: NUMERIC[2]);
 BEGIN
  L_General.Assert(Cond, "⠭ " + RtMStop.StopNbr + "  室  蠡|" + " " + FLDTOSTR(S, "2-", 0));
 END {Short_Assert};

 PRIVATE PROCEDURE Short(S: NUMERIC[2]): NUMERIC[2];
 BEGIN
  Short_Assert((S < 10000) & ((S < 100) | (S MOD 1 = 0)), S);
  IF    (Memo.ud_cd() >= 15\03\2002) THEN
   RETURN S;
  ELSIF (Memo.ud_cd() >= 25\10\2000) THEN
   RETURN Math.Round(S, 1);
  ELSE
   RETURN S;
  END;
 END {Short};

 PRIVATE PROCEDURE Tariff(VAR _RDis: LIKE(RtMStop.RDis); Idx: NUMERIC[0]): NUMERIC[2];
  VAR
   v,
   k,
   Found: NUMERIC[0];
   Trf  : NUMERIC[2];
 BEGIN
  IF (BRelation[CurStopIdx] MOD 2 = 0) &  (BRelation[CurStopIdx] - BRelation[CurStopIdx - 1] = 1) &
     (BRelation[Idx] < BRelation[CurStopIdx - 1]) THEN
   DEC(_RDis, _BDis[BRelation[CurStopIdx - 1] DIV 2]);
  END;
  IF (Stop.Sign = L_Way.ss_City) &
     (Sign[Idx] = 0) &
     (RetInTown = 0(*  த*)) THEN
   RETURN Short(PriceBase[0]);
  END;
  Found:=0;
  k    :=0;
  WHILE ~!ScalBase[k] DO
   IF _RDis > ScalBase[k] THEN
    Found:=k;
   END;
   INC(k);
  END;
  L_General.Assert(~!ScalBase[Found], " ।   ⠭ " + RtMStop.StopNbr);
  RETURN Short(PriceBase[Found] + (_RDis - 0.01 - ScalBase[Found]) DIV ScalStep[Found] * PriceStep[Found]);
 END {Tariff};

 PRIVATE PROCEDURE FormatTariff(t: NUMERIC[2]): STRING[];
 BEGIN
  IF t >= 100 THEN
   RETURN Str.Align(L_Str.IntStr(t), 4, RIGHT) + "=";
  ELSE
   RETURN FLDTOSTR(t, "2-", 5);
  END;
 END {FormatTariff};

 PRIVATE PROCEDURE MakeNum(m: NUMERIC[0]; VAR Ms: NUMERIC[2][StopNbr]);
 BEGIN
  WHILE m > 0 DO
   MAKEPART(R, Tariff, FormatTariff(Ms[m]));
   DEC(m);
  END;
 END {MakeNum};

 PRIVATE PROCEDURE MakeLine(m: NUMERIC[0]; MCh: SCAL[2]);
  VAR
   S: STRING[];
 BEGIN
  IF BRelation[m] MOD 2 = 1 THEN
   S:="=======";
  ELSE
   S:="-------";
  END;
  IF MCh THEN
   S[0]:="|";
  END;
  INC(m);
  WHILE m > 0 DO
   MAKEPART(R, Line, S);
   DEC(m);
  END;
  MAKEPART(R, CR1);
 END {MakeLine};

 PRIVATE PROCEDURE Make(InWord: SCAL[2]);
  VAR
   Prefix,
   OneLine: STRING[];
 BEGIN
  L_General.Assert(ACCESS(RoutMod), " ⠭ 䨪");
  L_General.Assert(SELECT(RtMStop, Route, RoutMod.Route, RoutMod.Modif), " 䨪樨    ⠭");
  IF InWord THEN
   CONFORM(RoutMod, Route);
   L_MSO.wordInitDocument(Memo.ud_cd());
   P_Firm.SetFirmDefaultData("Own", P_Firm.OWN_FIRM, Memo.ud_cd(), "");
   L_MSO.wordSetVarsByFile("RoutMod");
   Prefix:="RoutMod.";
   L_MSO.wordSetVarsByFile_wPrefix("Route", Prefix);
  ELSE
   OPENREP(R, L_General.NameConnection("Tarif"), Create, TopMargin, 10, BottomMargin, 10, LeftMargin, 10, RightMargin, 10);
   MAKEPART(R, Title);
   MAKEPART(R, Line, "|஡");
  END;
  P_OwnData.FillTariffs(Memo.ud_cd(), ScalBase, ScalStep, PriceBase, PriceStep);
  SETZERO(CurStopIdx, CurVizit, _BDis, Dis, BRelation);
  Trf[0] :=Short(PriceBase[0]);
  WHILE OCCURE(RtMStop) DO
   PROMPT(RtMStop.StopNbr);
   CONFORM(RtMStop, Stop);
   Sign[CurStopIdx]:=Stop.Sign;
   IF    RtMStop.BDis > 0 THEN
    BRelation[CurStopIdx]:=2*CurVizit+1;
    INC(_BDis[CurVizit], RtMStop.BDis);
   ELSIF _BDis[CurVizit] > 0 THEN
    INC(CurVizit);
    BRelation[CurStopIdx]:=2*CurVizit;
   END; (* IF    RtMStop.BDis > 0...*)
   IF CurStopIdx > 0 THEN
    j:=CurStopIdx;
    RetInTown:=0;
    WHILE j > 0 DO
     Dis[j]:=Dis[j-1]+RtMStop.RDis;
     IF Trf[j-1] > Short(PriceBase[0]) THEN
      RetInTown:=1;
     END;
     Trf[j]:=Tariff(Dis[j], CurStopIdx-j);
     DEC(j);
    END; (* WHILE j > 0...*)
    IF InWord THEN
     L_MSO.wordSetVarsByFile_wAlias("Stop", "RoutMod.Stop" + L_MSO.IndexStr(CurStopIdx-1));
     Prefix:="RoutMod.Stop" + L_MSO.IndexStr(CurStopIdx-1) + ".";
     L_MSO.wordSetVar(Prefix + "Distance", FLDTOSTR(Dis[CurStopIdx], "1.", 0));
     OneLine:="";
     j:=CurStopIdx;
     WHILE j > 0 DO
      OneLine:=OneLine + FormatTariff(Trf[j]) + "|";
      DEC(j);
     END;
     L_MSO.wordSetVar(Prefix + "FormatedTariffs", OneLine);
    ELSE
     MAKEPART(R, Dis, Dis[CurStopIdx]);
     MakeNum(CurStopIdx, Trf);
    END;
   ELSE
    IF InWord THEN
     L_MSO.wordSetVarsByFile_wAlias("Stop", "RoutMod.StartingStop");
    END;
   END; (* IF CurStopIdx > 0...*)
   IF InWord THEN
    NEXT(RtMStop);
   ELSE
    MAKEPART(R, Name);
    IF NEXT(RtMStop) THEN
     IF ((BRelation[CurStopIdx] MOD 2 = 0) & (RtMStop.BDis # 0)) |
        ((BRelation[CurStopIdx] MOD 2 = 1) & (RtMStop.BDis = 0)) THEN
      MakeLine(CurStopIdx, 0);
     END;
    END;
   END;
   INC(CurStopIdx);
  END; (* WHILE OCCURE(RtMStop)...*)
 
  IF InWord THEN
   L_MSO.SetWordTable("Stops", CurStopIdx - 1);
   L_MSO.PutInTables:=L_MSO.Put_Values;
   L_MSO.MakeWordDocument("Tarif", 1, L_MSO.PrpMode_ToDoc, "");
  ELSE
   CLOSEREP(R);
   L_General.SurveyLastReport();
  END;
 END {Make};

 PUBLIC PROCEDURE Tarif();
 BEGIN
  Make(0);
 END {Tarif};

 PUBLIC PROCEDURE Tarif_InWord();
 BEGIN
  Make(1);
 END {Tarif_InWord};

END.
