(*
%Copyright   (c) Polak IT
%Author      26.07.2005 14:34:03 POLAK\San
%Purpose     ⠭ 楤    
%Type        report,operation
%Specific    AP
%Modified    03.07.2014 21:24:09 gav
%Environment
*)

 MODULE Tck02 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, Memo, L_AFM, L_Str, L_DatTim, L_XDoc, L_MathR,
        P_MyFirm, L_TRS, P_Man, Math, P_Firm, E_TRS, L_OwnData,
        L_EC, L_Money, L_PagePr, Str, L_Acnt, L_CUC, L_MDoc, L_AR,
        L_XObj, L_AcCut, L_Stock, P_Storage, D_XObj;

(*
$P{ Tck02_PageTop:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
L_PagePr.PagePr_CurrentPage(), R, "0"
?, L, "D.N.y"
?, L, "H:M"
?, L, "D.N.y"
?, L, "H:M"
@
############################################################# ########## #####
=#####================================================================###=
|                      ਥ 窨                   |
|              (ᬥ  ########## #####  ########## #####)                |
|----------------------------------------------------------------------------|
|६|    |    |⭨                            ||        㬬|
|-----|-------|-------|------------------------------------|---|-------------|
}
*)

(*
$P{ Tck02_Line:
?, L, "H:M"
TckRcC.TckRcC, L, ""
TckRcC.TckRcS, L, ""
Staff.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
TckRcC.Type, L, L_TRS.trct_Pool_SH
TckRcC.Total, R, ",2-"
@
|#####|#######|#######|##### ##############################|###|#############|
}
*)

(*
$P{ Tck02_PageBot:
@
------------------------------------------------------------------------------
}
*)

(*
$P{ Tck02_Total:
Amount[L_TRS.trct_CashAccept], R, "0"
Total[L_TRS.trct_CashAccept], R, ",2-"
Amount[L_TRS.trct_DeficitAct], R, "0"
Total[L_TRS.trct_DeficitAct], R, ",2-"
Amount[L_TRS.trct_SurPlusAct], R, "0"
Total[L_TRS.trct_SurPlusAct], R, ",2-"
Amount[L_TRS.trct_TckWriteOffLack], R, "0"
Total[L_TRS.trct_TckWriteOffLack], R, ",2-"
?, L, ""
?, L, ""
@
|----------------------------------------------------------------------------|
| ⮣  ⨯                      |⢮ 㬥⮢|        㬬|
|   묨                       |             ########|#############|
|                               |             ########|#############|
|  襪                               |             ########|#############|
|   ᯨᠭ                         |             ########|#############|
|----------------------------------------------------------------------------|
| 㬬  ய:                                                   |
| ########################################################################## |
| ########################################################################## |
}
*)

(*
$P{ Tck02_Bot_Cashier:
?, L, ""
@
|                                                                            |
|            _________________ /###########################################/ |
}
*)

(*
$P{ Tck02_Bot:
@
|                                                                            |
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   (* nothing *)
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
  VAR
   shiftBegDate,
   shiftEndDate       : DATE;
   shiftBegTime,
   shiftEndTime       : TIME;
 BEGIN
  IF (Mode = L_PagePr.m_Print) THEN
   L_TRS.SetupShiftBorders(Memo.ud_cd(), shiftBegDate, shiftEndDate, shiftBegTime, shiftEndTime);
   MAKEPART(R, Tck02_PageTop, P_Firm.MyFirmName(Tck02.MyFirm, SYSDATE()), "Tck02",
            shiftBegDate, shiftBegTime, shiftEndDate, shiftEndTime);
  ELSIF (Mode = L_PagePr.m_RDoneTop) THEN
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Tck02_PageBot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Tck02_PageBot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
  VAR
   _Dummy: NUMERIC[0];
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   RepBot(0, _Dummy, "");
   L_PagePr.PagePr_SetResult(_Dummy);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(0);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE E_JointResponsibility(D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=L_EC.ExecE_Func_Scal2(D, PROCREF(E_TRS.JointResponsibility), 1);
  IF !Result THEN
   Result:=1;
   STDFORM("|ୠ ⢥⢥|%20,2<|>O|||%< {}⬥ >X  %< {}믮 >DB",
           , INFORM, -1, Result);
  END;
  RETURN Result;
 END {E_JointResponsibility};

 PRIVATE PROCEDURE RepBot(Print: SCAL[2]; VAR Depth: NUMERIC[0]; Cashier: STRING[]);
  VAR
   InWords: STRING[][2];
   i      : NUMERIC[0];
 BEGIN
  Depth:=0;
  IF Print THEN
   L_General.CallUs(L_Str.FormatStrToStrArray(InWords, L_Money.ByWord(Total[L_TRS.trct_CashAccept]), 74));
   MAKEPART(R, Tck02_Total, InWords[0], InWords[1]);
  END;
  INC(Depth, DEPTH(Tck02_Total));

  IF JointResponsibility THEN
   i:=0;
   WHILE ~!L_Str.PoolItem(PoolCashier, i) DO
    IF Print THEN
     MAKEPART(R, Tck02_Bot_Cashier, L_Str.PoolItem(PoolCashier, i));
    END;
    INC(Depth, DEPTH(Tck02_Bot_Cashier));
    INC(i);
   END;
   IF Print THEN
    MAKEPART(R, Tck02_Bot_Cashier, "");
    MAKEPART(R, Tck02_Bot_Cashier, "");
   END;
   INC(Depth, DEPTH(Tck02_Bot_Cashier)*2);
  ELSE
   IF Print THEN
    MAKEPART(R, Tck02_Bot_Cashier, Cashier);
   END;
   INC(Depth, DEPTH(Tck02_Bot_Cashier));
  END;
  IF Print THEN
   MAKEPART(R, Tck02_Bot);
  END;
  INC(Depth, DEPTH(Tck02_Bot));
 END {RepBot};

 VAR
  Amount,
  Total              : NUMERIC[2][MAXOF(L_TRS.tTckRcCType)+1];
  JointResponsibility: SCAL[2];
  PoolCashier        : STRING[];

 PRIVATE PROCEDURE Tck02_PrintOut(Cashier: STRING[]);
  VAR
   InWords: STRING[][2];
   _Dummy : NUMERIC[0];
 BEGIN
  SETZERO(Total, Amount);
  WHILE OCCURE(Tck02) DO
   SEARCH(TckRcC, TckRcC, , Tck02.TckRcC);
   IF TckRcC.Status = L_TRS.trcStat_Passed THEN
    CONFORM(TckRcC, TckRcS);
    CONFORM(TckRcS, Staff, Man);
    L_PagePr.PagePr_BeforePrintLine(DEPTH("Tck02_Line"));
    MAKEPART(R, Tck02_Line, Tck02.Time);
    INC(Total[TckRcC.Type], TckRcC.Total);
    INC(Amount[TckRcC.Type]);
   END;
   NEXT(Tck02);
  END; (* WHILE OCCURE(Tck02) ... *)
  RepBot(1, _Dummy, Cashier);
 END {Tck02_PrintOut};

 PUBLIC PROCEDURE Tck02();
  CONST
   RepName = "Tck02";
  VAR
   D            : DATE;
   Cashier      : STRING[];
   trgMyFirm    : P_Firm.tMyFirm;
   o            : ASBCONNECTION;
   Connections  : ASBCONNECTIONS;
   i            : NUMERIC[0];
   PoolLoginName: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  D:=Memo.ud_cd();
  JointResponsibility:=E_JointResponsibility(D);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  L_AFM.MakeMultipleIndex("Tck02", "MyFirm : SCAL[1E4](*ᮢ⨬!*);"+
                                   "TckRcC : LIKE(TckRcC.TckRcC);"+
                                   "Cashier: STRING[48];"+
                                   "Date   : DATE;"+
                                   "Time   : TIME;"+
                                   "Sec    : LIKE(XDocJrn.BegSec)",
                             "Cashier: MyFirm, Cashier, Date, Time, Sec;"+
                             "Total: MyFirm, Date, Time, Sec");

  SETEMPTY(PoolLoginName);
  Connections:=ASBCONNECTIONS.Create();
  FOR_EACH o IN Connections DO
   PoolLoginName:=PoolLoginName+L_Str.Left(o.LoginName, Str.MaxLength(AcsObj.Name))+"|";
  END; (* FOR_EACH *)
  SELECT(TckRcC, Date, , D);
  WHILE OCCURE(TckRcC) DO
   IF (TckRcC.Status # L_TRS.trcStat_Canceled) &
      L_XDoc.XDocSomeTimeWas(L_XDoc.xdt_TckRcC,
                             L_XDoc.EmptyXDocKind,
                             TckRcC.TckRcC,
                             L_XDoc.action_AutoBuild) THEN
    Tck02.TckRcC :=TckRcC.TckRcC;
    IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
     CONFORM(TckRcC, Staff);
     Tck02.MyFirm:=Staff.MyFirm;
    ELSE
     Tck02.MyFirm:=P_Firm.mf_Own;
    END;
    CONFORM(XDocJrn, AcsObj);
    Tck02.Cashier:=L_AR.GetAcsObjManName();
    Tck02.Date   :=XDocJrn.Date;
    Tck02.Time   :=XDocJrn.BegTime;
    Tck02.Sec    :=XDocJrn.BegSec;
    INSERT(Tck02);
   END;
   NEXT(TckRcC);
  END; (* WHILE OCCURE(TckRcC) ... *)

  SELECT(Tck02, Cashier);
  WHILE OCCURE(Tck02) DO
   NARROWSEL(Tck02, MyFirm);

   SAVE(Tck02);
   IF JointResponsibility THEN
    SETEMPTY(PoolCashier);
    WHILE OCCURE(Tck02) DO
     NARROWSEL(Tck02, Cashier);
     IF ~!L_Str.PositionInPool(PoolLoginName, AcsObj.Name) THEN
      PoolCashier:=PoolCashier + Tck02.Cashier + "|";
     END;
     NEXTINEXTENDEDSEL(Tck02, Cashier);
    END; (* WHILE OCCURE(Tck02) by Cashier *)
   END;
   RESTORE(Tck02);
   L_PagePr.PagePr_Init("R", 64, PROCREF(_RprtTop),
                         PROCREF(_PageTop),
                         PROCREF(_PageBot),
                         PROCREF(_RprtBot),
                         PROCREF(_Filling));
   SAVE(Tck02);
   trgMyFirm:=Tck02.MyFirm;
   Cashier  :=Tck02.Cashier;
   IF JointResponsibility THEN
    SELECT(Tck02, Total, , trgMyFirm);
    Tck02_PrintOut(P_Man.GetFullNameOfCurrentUser(D));
   ELSE
    SELECT(Tck02, Cashier, , trgMyFirm);
    WHILE OCCURE(Tck02) DO
     NARROWSEL(Tck02, Cashier);
     Tck02_PrintOut(Tck02.Cashier);
     NEXTINEXTENDEDSEL(Tck02, Cashier);
     IF OCCURE(Tck02) THEN
      L_PagePr.PagePr_Done();
      L_PagePr.PagePr_Init("R", 64, PROCREF(_RprtTop),
                            PROCREF(_PageTop),
                            PROCREF(_PageBot),
                            PROCREF(_RprtBot),
                            PROCREF(_Filling));
     END;
    END; (* WHILE OCCURE(Tck02) by Cashier *)
   END;
   RESTORE(Tck02);
   NEXTINEXTENDEDSEL(Tck02, MyFirm);
   IF LINENUM(R)>0 THEN
    FORMFEED(R);
   END;
  END; (* WHILE OCCURE(Tck02) by MyFirm ... *)
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("Tck02");
 END {Tck02};

 CONST
  tmv_PartsAmount = MAXOF(L_Acnt.tAcntVectorPart)+1+3;
 TYPE
  tTckMovement = SCAL[tmv_PartsAmount];
  tTMVector    = NUMERIC[2][tmv_PartsAmount];

 CONST
  tmv_InSaldo  = L_Acnt.avp_InSaldo;
  tmv_Debit    = L_Acnt.avp_Debit;
  tmv_Credit   = L_Acnt.avp_Credit;
  tmv_OutSaldo = L_Acnt.avp_OutSaldo;
  tmv_Laying   = tmv_OutSaldo+1;
  tmv_Return   = tmv_OutSaldo+2;
  tmv_Revaluation = tmv_OutSaldo+3;

  VAR
   Tck03_Total: tTMVector;

(*
$P{ Tck03_Top:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
####################################################################################################################################                                                                           ########## #####
=#####=========================================================================================================================================================================================================================
|#############################################################################################################################################################################################################################|
|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|  ()                           |          砫       |        㯨        |          뤠         |         ਭ         |         饭      |        ८業       |                  |
|                                       |-------------------------|-------------------------|-------------------------|-------------------------|-------------------------|-------------------------|-------------------------|
|                                       |          㬬|          㬬|          㬬|          㬬|          㬬|          㬬|          㬬|
}
*)

 PRIVATE PROCEDURE GetOutSaldo(V: tTMVector): NUMERIC[2];
 BEGIN
  IF !V[tmv_InSaldo] THEN
   RETURN EMPTYOF(NUMERIC[2]);
  ELSE
   RETURN V[tmv_InSaldo]+V[tmv_Debit]-V[tmv_Credit]-V[tmv_Laying]+V[tmv_Return]+V[tmv_Revaluation];
  END;
 END {GetOutSaldo};

(*
$P{ Tck03_Line:
Math.Math, L, ""
Math.Name, L, ""
Tck03.PckAmn[tmv_InSaldo], R, "0"
Tck03.Amount[tmv_InSaldo], R, "0"
Tck03.Amount[tmv_InSaldo]*Tck03.FaceVal, R, "2-"
Tck03.PckAmn[tmv_Debit], R, "0"
Tck03.Amount[tmv_Debit], R, "0"
Tck03.Amount[tmv_Debit]*Tck03.FaceVal, R, "2-"
Tck03.PckAmn[tmv_Laying], R, "0"
Tck03.Amount[tmv_Laying], R, "0"
Tck03.Amount[tmv_Laying]*Tck03.FaceVal, R, "2-"
Tck03.PckAmn[tmv_Return], R, "0"
Tck03.Amount[tmv_Return], R, "0"
Tck03.Amount[tmv_Return]*Tck03.FaceVal, R, "2-"
Tck03.PckAmn[tmv_Credit], R, "0"
Tck03.Amount[tmv_Credit], R, "0"
Tck03.Amount[tmv_Credit]*Tck03.FaceVal, R, "2-"
Tck03.PckAmn[tmv_Revaluation], R, "0"
Tck03.Amount[tmv_Revaluation], R, "0"
Tck03.Amount[tmv_Revaluation]*Tck03.FaceVal, R, "2-"
GetOutSaldo(Tck03.PckAmn), R, "0"
GetOutSaldo(Tck03.Amount), R, "0"
GetOutSaldo(Tck03.Amount)*Tck03.FaceVal, R, "2-"
@
|---------------------------------------|-------------------------|-------------------------|-------------------------|-------------------------|-------------------------|-------------------------|-------------------------|
|##### #################################|#### ####### ############|#### ####### ############|#### ####### ############|#### ####### ############|#### ####### ############|#### ####### ############|#### ####### ############|
}
*)

(*
$P{ Tck03_movBot:
Tck03_Total[tmv_InSaldo], R, "2-"
Tck03_Total[tmv_Debit], R, "2-"
Tck03_Total[tmv_Laying], R, "2-"
Tck03_Total[tmv_Return], R, "2-"
Tck03_Total[tmv_Credit], R, "2-"
Tck03_Total[tmv_Revaluation], R, "2-"
GetOutSaldo(Tck03_Total), R, "2-"
@
|---------------------------------------|-------------------------|-------------------------|-------------------------|-------------------------|-------------------------|-------------------------|-------------------------|
|⮣                                  |            #############|            #############|            #############|            #############|            #############|            #############|            #############|
}
*)

(*
$P{ Tck03_cucTop:
@
|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|                                                                           祭 뤠/ਭ⮩ ⭮ த樨                                                                                                     |
|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|  ()                                                  |/                     |..|/|    |    |⭨                                                                                        |
|--------------------------------------------------------------|--------------------------------|--------|---|-------|-------|------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ Tck03_cucLine:
Math.Math, L, ""
Math.Name, L, ""
Tcc03.Serial, L, ""
?, R, ""
Tcc03.tmv, L, " | | | ||"
Tcc03.TckRcD, L, ""
TckRcD.TckRcS, L, ""
Staff.TSN, L, ""
Man.Name, L, ""
@
|##### ########################################################|################################|########|###|#######|#######|##### ################################################                                          |
}
*)


(*
$P{ Tck03_Bot:
?, L, ""
@
|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|                                                                                                                                                                                                                             |
|                                                                                                                       ᯮ⥫ ___________________ ###################################################                   |
|                                                                                                                                                                                                                             |
=(c) Polak=====================================================================================================================================================================================================================
}
*)

 PRIVATE PROCEDURE Tck03_PutSingleTckRcDL(Cashier  : STRING[];
                                          atTckRcDL: SCAL[2];
                                          tmv      : tTckMovement;
                                          _RestNbr : NUMERIC[0]);
  VAR
   curMyFirm: LIKE(MyFirm.MyFirm);
 BEGIN
  IF atTckRcDL THEN
   curMyFirm:=L_TRS.GetTckRcDMyFirm();
  ELSE
   curMyFirm:=MyFirm.MyFirm;
  END;
  IF ~ADD(Tck03, Total, curMyFirm, -1 * TckKind.FaceVal, TckKind.Math, TckKind.FaceVal) THEN
   IF L_TRS.IsBulk() THEN
    SETEMPTY(Tck03.PckAmn);
   ELSE
    SETZERO(Tck03.PckAmn);
   END;
   SETZERO(Tck03.Amount);
   REPLACE(Tck03);
  END;
  IF ~L_TRS.IsBulk() THEN
   INC(Tck03.PckAmn[tmv]);
  END;
  IF atTckRcDL & L_TRS.IsBulk_wCUC() THEN
   INC(Tck03.Amount[tmv], L_TRS.BulkCUCAmount());
  ELSIF ~!_RestNbr THEN
   IF TckKind.Type = L_TRS.tkt_PieceTck THEN
    INC(Tck03.Amount[tmv], _RestNbr);
   ELSE
    INC(Tck03.Amount[tmv], Math.Abs(_RestNbr-L_TRS.PackLastNbr(TckKind.TckKind, _RestNbr)));
   END;
  ELSE
   INC(Tck03.Amount[tmv], TckKind.PckVol);
  END;
  REPLACE(Tck03);
  IF (tmv = tmv_Laying) | (tmv = tmv_Return) THEN
   Tcc03.MyFirm  :=curMyFirm;
   CONFORM(TckRcDL, CUCopy);
   Tcc03.TckRcD  :=TckRcDL.TckRcD;
   Tcc03.TRDLNbr :=TckRcDL.TRDLNbr;
   Tcc03.Cashier :=Cashier;
   Tcc03.NFaceVal:=-1 * TckKind.FaceVal;
   Tcc03.Math    :=TckKind.Math;
   Tcc03.Serial  :=CUCopy.Serial;
   Tcc03.PassDTS :=TckRcDL.PassDTS;
   IF atTckRcDL & L_TRS.IsBulk_wCUC() THEN
    Tcc03.RestNbr:=L_TRS.BulkCUCAmount();
   ELSE
    Tcc03.RestNbr:=TckRcDL.RestNbr;
   END;
   Tcc03.tmv     :=tmv;
   INSERT(Tcc03);
  END;
 END {Tck03_PutSingleTckRcDL};

 PRIVATE PROCEDURE Tck03_AccessTckKindByMath(trgMath: LIKE(Math.Math); From, UpTo: DATE);
  VAR
   trgTckKind: LIKE(TckKind.TckKind);
   curB      : DATE;
 BEGIN
  curB:=MINOF(DATE);
  SETEMPTY(trgTckKind);
  SELECT(TckKind, Math, , trgMath);
  WHILE OCCURE(TckKind) DO
   IF L_DatTim.IsActiveInIntvl(From, UpTo + 1, TckKind.Begin, TckKind.Till) &
      (TckKind.Begin > curB) THEN
    trgTckKind:=TckKind.TckKind;
    curB      :=TckKind.Begin;
   END;
   NEXT(TckKind);
  END; (* WHILE OCCURE(TckKind) ... *)
  L_General.CallUs(SEARCH(TckKind, TckKind, trgTckKind));
 END {Tck03_AccessTckKindByMath};

 PRIVATE PROCEDURE Tck03_PrintOut(From,
                                  UpTo       : DATE;
                                  RepName,
                                  RepTitle,
                                  curUserName: STRING[];
                                  PrintCUC   : SCAL[2];
                                  trgMyFirm  : P_Firm.tMyFirm);
  VAR
   RevaluationAmount: NUMERIC[0];
   RevaluationPckAmn: NUMERIC[0];
 BEGIN
  MAKEPART(R, Tck03_Top, P_Firm.MyFirmName(trgMyFirm, SYSDATE()), RepName, RepTitle);

  SELECT(Tck03, Total, , trgMyFirm);
  WHILE OCCURE(Tck03) DO
   SEARCH(Math, Math, , Tck03.Math);
   Tck03_AccessTckKindByMath(Tck03.Math, From, UpTo);
   IF TckKind.FaceVal # Tck03.FaceVal THEN
    RevaluationAmount:=GetOutSaldo(Tck03.Amount);
    RevaluationPckAmn:=GetOutSaldo(Tck03.PckAmn);
    Tck03.Amount[tmv_Revaluation]:=-RevaluationAmount;
    REPLACE(Tck03);
    SAVE(Tck03);
    IF ~!RevaluationPckAmn THEN
     Tck03.PckAmn[tmv_Revaluation]:=-RevaluationPckAmn;
     REPLACE(Tck03);
     ADD(Tck03, Total, , trgMyFirm, -TckKind.FaceVal, Tck03.Math, TckKind.FaceVal,
                  Tck03.PckAmn[tmv_Revaluation], RevaluationPckAmn);
    END;
    ADD(Tck03, Total, , trgMyFirm, -TckKind.FaceVal, Tck03.Math, TckKind.FaceVal,
                 Tck03.Amount[tmv_Revaluation], RevaluationAmount);
    RESTORE(Tck03);
   END;
   NEXT(Tck03);
  END; (* WHILE OCCURE(Tck03) ... *)

  SETZERO(Tck03_Total);
  FIRST(Tck03);
  WHILE OCCURE(Tck03) DO
   SEARCH(Math, Math, , Tck03.Math);
   MAKEPART(R, Tck03_Line);
   INC(Tck03_Total[tmv_InSaldo],     Tck03.Amount[tmv_InSaldo]    *Tck03.FaceVal);
   INC(Tck03_Total[tmv_Debit],       Tck03.Amount[tmv_Debit]      *Tck03.FaceVal);
   INC(Tck03_Total[tmv_Credit],      Tck03.Amount[tmv_Credit]     *Tck03.FaceVal);
   INC(Tck03_Total[tmv_Laying],      Tck03.Amount[tmv_Laying]     *Tck03.FaceVal);
   INC(Tck03_Total[tmv_Return],      Tck03.Amount[tmv_Return]     *Tck03.FaceVal);
   INC(Tck03_Total[tmv_Revaluation], Tck03.Amount[tmv_Revaluation]*Tck03.FaceVal);
   NEXT(Tck03);
  END; (* WHILE OCCURE(Tck03) ... *)
  MAKEPART(R, Tck03_movBot);

  IF PrintCUC THEN
   MAKEPART(R, Tck03_cucTop);
   SELECT(Tcc03, Total, , trgMyFirm);
   WHILE OCCURE(Tcc03) DO
    NARROWSEL(Tcc03, NFaceVal, Math);
    SEARCH(Math, Math, , Tcc03.Math);
    WHILE OCCURE(Tcc03) DO
     SEARCH(TckRcD, TckRcD, , Tcc03.TckRcD);
     CONFORM(TckRcD, Staff, Man);
     L_General.Assert(L_TRS.AccessTckKindByMath(Tcc03.Math, SYSDATE()),
                      " ࠢ筨 ' ஥ 㬥⮢'     뫪   " + Tcc03.Math);
     IF L_TRS.IsBulk() THEN
      MAKEPART(R, Tck03_cucLine, L_Str.IntStr(Tcc03.RestNbr));
     ELSE
      MAKEPART(R, Tck03_cucLine, Tcc03.RestNbr);
     END;
     NEXT(Tcc03);
    END; (* WHILE OCCURE(Tcc03) ... *)
    NEXTINEXTENDEDSEL(Tcc03, NFaceVal, Math);
   END;
  END;

  MAKEPART(R, Tck03_Bot, "/" + curUserName + "/");
 END {Tck03_PrintOut};

 PRIVATE PROCEDURE Tck03_PackCUCopyAtStorage(atTckRcDL: SCAL[2];
                                             avp      : L_Acnt.tAcntVectorPart;
                                             _RestNbr : NUMERIC[0]);
 BEGIN
  Tck03_PutSingleTckRcDL("줮/", atTckRcDL, avp, _RestNbr);
 END {Tck03_PackCUCopyAtStorage};

 PRIVATE PROCEDURE Tck03_Do(From, UpTo: DATE; PrintCUC: SCAL[2]; RepName, RepTitle: STRING[]);
  VAR
   Cashier   : STRING[];
   D,
   DummyD,
   BegDate,
   EndDate   : DATE;
   DummyT,
   BegTime,
   EndTime   : TIME;
 BEGIN
  L_TRS.SetupTicketKassaShiftBorders(From, BegDate, DummyD, BegTime, DummyT);
  L_TRS.SetupTicketKassaShiftBorders(UpTo, DummyD, EndDate, DummyT, EndTime);

  OPENREP(R, L_General.NameConnection(RepName), Create);
  SetPrintAttr(R, Orientation,     Landscape,
                  LeftMargin,      10,
                  RightMargin,     10,
                  TopMargin,       10,
                  BottomMargin,    10,
                  FontEnlargement, 1.2,
                  LinesPerPage,    60);
  L_AFM.MakeMultipleIndex("Tck03", "MyFirm : LIKE(MyFirm.MyFirm);"+
                                   "FaceVal: LIKE(TckKind.FaceVal);"+
                                   "NFaceVal: LIKE(TckKind.FaceVal);"+
                                   "Math   : LIKE(Math.Math);"+
                                   "PckAmn : NUMERIC[0]["+L_Str.IntStr(tmv_PartsAmount)+"];"+
                                   "Amount : NUMERIC[0]["+L_Str.IntStr(tmv_PartsAmount)+"]",
                             "Total: MyFirm, NFaceVal, Math, FaceVal");
  L_AFM.MakeMultipleIndex("Tcc03", "MyFirm : LIKE(MyFirm.MyFirm);"+
                                   "TckRcD : LIKE(TckRcD.TckRcD);"+
                                   "TRDLNbr: LIKE(TckRcDL.TRDLNbr);"+
                                   "NFaceVal: LIKE(TckKind.FaceVal);"+
                                   "Math   : LIKE(Math.Math);"+
                                   "Serial : LIKE(CUCopy.Serial);"+
                                   "PassDTS: LIKE(TckRcDL.PassDTS);"+
                                   "RestNbr: LIKE(TckRcDL.RestNbr);"+
                                   "Cashier: STRING[48];"+
                                   "tmv    : "+GET_TYPE_SPEC(tTckMovement).Name,
                             "Tcc03: TckRcD, TRDLNbr;" +
                             "Total: MyFirm, NFaceVal, Math, Serial, PassDTS");

  D:=From;
  WHILE D <= UpTo DO
   SELECT(TckRcD, Date, , D);
   WHILE OCCURE(TckRcD) DO
    NARROWSEL(TckRcD, Type);
    IF TckRcD.Type # L_TRS.trdt_Inventory THEN
     WHILE OCCURE(TckRcD) DO
      PROMPT("ᬮ . " + L_DatTim.DateStr(D) + " " + TckRcD.TckRcD);
      CONFORM(TckRcD, Storage);
      IF (TckRcD.Status # L_TRS.trcStat_Canceled) & (Storage.Type = L_Stock.st_TckBag) &
         L_XDoc.XDocSomeTimeWas(L_XDoc.xdt_TckRcD,
                                L_XDoc.EmptyXDocKind,
                                TckRcD.TckRcD,
                                L_XDoc.action_AutoBuild) THEN
       CONFORM(XDocJrn, AcsObj);
       Cashier:=L_AR.GetAcsObjManName();
       SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
       WHILE OCCURE(TckRcDL) DO
        CONFORM(TckRcDL, TckKind);
        IF ~L_TRS.IsDevice(TckKind.Type) THEN
         IF    TckRcD.Type = L_TRS.trdt_Laying THEN
          Tck03_PutSingleTckRcDL(Cashier, 1, tmv_Laying, TckRcDL.RestNbr);
         ELSIF TckRcD.Type = L_TRS.trdt_Return THEN
          Tck03_PutSingleTckRcDL(Cashier, 1, tmv_Return, TckRcDL.RestNbr);
         ELSE
          L_General.CallUs(0);
         END;
        END;
        NEXT(TckRcDL);
       END; (* WHILE OCCURE(TckRcDL) ... *)
      END;
      NEXT(TckRcD);
     END; (* WHILE OCCURE(File) *)
    END; (* IF TckRcD.Type # L_TRS.trdt_Inventory  *)
    NEXTINEXTENDEDSEL(TckRcD, Type);
   END; (* WHILE OCCURE(TckRcD) *)
   INC(D);
  END; (* WHILE D <= UpTo DO *)

  RepTitle:=RepTitle + "  " + L_DatTim.DateTimeStr(BegDate, BegTime) +
                      "  " + L_DatTim.DateTimeStr(EndDate, EndTime);
  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF SELECT(Tck03, Total, MyFirm.MyFirm) | SELECT(Tcc03, Total, MyFirm.MyFirm) THEN
    IF L_TRS.E_HasTckAtStorage(EndDate) THEN
     L_CUC.CollectTckMovement(L_TRS.TckOfficeStorage(BegDate, MyFirm.MyFirm),
                              PackTIMESTAMP(BegDate, BegTime),
                              PackTIMESTAMP(EndDate, EndTime),
                              PROCREF(Tck03_PackCUCopyAtStorage));
    END;
    Tck03_PrintOut(From, UpTo, RepName, RepTitle, P_Man.GetFullNameOfCurrentUser(BegDate), PrintCUC, MyFirm.MyFirm);
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("Tcc03");
  L_AFM.AF_PurgeTemp("Tck03");
 END {Tck03_Do};

(*
$P{ TSInv_Top:
P_Firm.MyFirmName(Storage.MyFirm, SYSDATE()), L, ""
P_Firm.FP_OKPO(P_Firm.fomf(Storage.MyFirm), SYSDATE()), L, ""
P_MyFirm.OKVED_Code(P_Firm.curMyFirm, SYSDATE()), C, ""
?, C, "", "U"
?, C, ""
?, C, "D.N.y"
?, C, "D.N.y"
?, C, "D.N.y"
actNumStr, C, ""
?, C, "D.N.y"
Storage.Storage, L, "", "U"
Storage.Name, L, "", "U"
@
                                                                                                                                                           ------------
                                                                    ##############################################################################   |##########|
                                                                                                                                                           |          |
                                                                    ______________________________________________________________________________________ |          |
                                                                                    ୮ ࠧ                                              |          |
                                                                                                                                           ⥫쭮 |##########|
                                                                       ᭮  ஢ ਧ樨: ####################################  |##########|
                                                                                                                                                       |##########|
                                                                                                                                 砫 ਧ樨 |##########|
                                                                                                                              砭 ਧ樨 |##########|
                                                                                                                                               樨 |          |
                                                                                                                                                           ------------

                                                                                                                                    -----------------------------------
                                                                                                                                    | 㬥 | ⠢|
                                                                                                                                    |----------------|----------------|
                                                                                                                                    |################|################|
                                                        ਧ樮  ⮢୮-ਠ 業⥩                     -----------------------------------

 ࠭ ####### ###################################################

                                                                              ᯨ᪠

  砫 ஢ ਧ樨  室  室 㬥  ⮢୮-ਠ 業 ᤠ  壠   ⮢୮-ਠ 業,
 㯨訥  () ⢥⢥, 室,  訥 ᯨᠭ  室.

ਠ쭮-⢥⢥ ():

}
*)

(*
$P{ TSInv_TopOnDate:
?, L, "", "U"
@
ந ⨥ 䠪᪨ ⪮ 業⥩  ﭨ  #####################################

 ਧ樨 ⠭ ᫥饥:
}
*)

(*
$P{ TSInv_PageTop:
@
=================================================================================================================================================================
}
*)

(*
$P{ TSInv_MathTop1:
@
|---------------------------------------------------------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ TSInv_MathTop2:
Math.Math, L, ""
Math.Name, L, ""
?, L, ""
?, L, ""
@
| ##### ################################################################################################################################                     |
|  壠᪮ : ##################  㬬 ###################################################################################################|
}
*)

(*
$P{ TSInv_NoCUC:
@
|                                                                                                                                      |
}
*)

(*
$P{ TSInv_CUCTop:
@
|祭 ஢-------------------------------------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ TSInv_OneSerial:
?, R, ""
?, R, ""
@
|############################## ########}
*)

(*
$P{ TSInv_EOL:
@
|
}
*)

(*
$P{ TSInv_CUCBot:
?, R, "0"
?, R, "0"
?, L, ""
@
|---------------------------------------------------------------------------------------------------------------------------------------------------------------|
|⮣: ஢ ##########, ⢮  ########## ###################################################################################################|
}
*)

(*
$P{ TSInv_PageBot:
PAGENUM(R) , R, "0"
?, R, "0"
?, R, "0"
?, L, ""
glbOnDateFact, L, "D=N=Y"
SYSDATE(), L, "DNy"
SYSTIME(), L, "HM"
@
|---------------------------------------------------------------------------------------------------------------------------------------------------------------|
|⮣  ࠭ ###:  ஢ ##########, ⢮  ##########                                                                                   |
| 㬬  쭮 ⮨ #############################################################################################################################|
=(c) Polak================================================================================================================================########=########=####=
}
*)

(*
$P{ TSInv_BotHead:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
⮣  
 ) ⢮ ஢
    ###################################################################################################################################################################
 ) 饥 ⢮  䠪᪨
    ###################################################################################################################################################################
    ###################################################################################################################################################################
 )  㬬  쭮 ⮨ 䠪᪨
    ###################################################################################################################################################################
    ###################################################################################################################################################################
 )  㬬 䠪᪨
    ###################################################################################################################################################################
    ###################################################################################################################################################################

     業,  ⮣  ப, ࠭栬   楫  ਧ樮  ⮢୮-ਠ 業⥩ ஢७.

}
*)

(*
$P{ TSInv_Sign:
?, L, "", "U"
?, L, "", "U"
@
#################################################################  _____________________________________  #############################################################
                                                                                          ஢ 

}
*)

(*
$P{ TSInv_BotFoot:
@
      ⮢୮ - ਠ 業,   饩 ਧ樮 , ᨥ ஢७     (襬) ⢨  ᥭ 
,  裡  祬 ⥭  ਧ樮 ᨨ   ( ). ୮ - ਠ 業, ᫥  , 室  (襬)
⢥⢥ ࠭.

(), ⢥⢥()  ࠭ ⮢୮-ਠ 業⥩:

}
*)

(*
$P{ TSInv_BotChMan:
?, L, "", "U"
?, L, "", "U"
@
"________" ____________________________________  ___________.

  饩     ஢ਫ


#################################################################  _____________________________________  #############################################################
                                                                                          ஢ 

"________" ____________________________________  ___________.
}
*)

 CONST
  TSInv_Columns = 4;

 VAR
  PageCount,
  PageAmount,
  actNum       : NUMERIC[0];
  PageSum      : NUMERIC[2];
  actNumStr    : STRING[];
  glbOnDateFact: DATE;

 PRIVATE PROCEDURE TSInv_PackCUCopyAtStorage(atTckRcDL: SCAL[2];
                                             avp      : L_Acnt.tAcntVectorPart;
                                             _RestNbr : NUMERIC[0]);
  VAR
   FstNbr : LIKE(TckRcDL.RestNbr);
   _Serial: LIKE(CUCopy.Serial);
   _Amount: NUMERIC[0];
 BEGIN
  IF (avp = L_Acnt.avp_InSaldo) & (TckKind.Type # L_TRS.tkt_PieceTck) THEN
   _Serial:=CUCopy.Serial;
   _Amount:=TckKind.PckVol;
   IF ~!_RestNbr THEN
    FstNbr:=L_TRS.PackFirstNbr(TckKind.TckKind, _RestNbr);
    IF FstNbr # _RestNbr THEN
     _Serial:=Str.Slice(_Serial, 0, Str.Length(_Serial) - TckKind.NbrPrc) +
              FLDTOSTR(_RestNbr, "L", TckKind.NbrPrc);
     _Amount:=TckKind.PckVol - Math.Abs(_RestNbr - FstNbr);
    END;
   END;
   ADD(TSInv, TSInv, , Math.Math, TckKind.TckKind, _Serial,
         TSInv.Amount, _Amount);
   ADD(xxInv, xxInv, , Math.Math);
  END;
 END {TSInv_PackCUCopyAtStorage};

 PRIVATE PROCEDURE TSInv_PackNonTicketMathAtStorage(D: DATE);
  VAR
   SaldoPer: DATE;
   mft     : L_MDoc.tMathFlowType;
 BEGIN
  SELECT(mItem, Storage, , Storage.Storage);
  WHILE OCCURE(mItem) DO
   PROMPT(mItem.Math);
   IF ~L_TRS.AccessTckKindByMath(mItem.Math, D) THEN
    SAVE(mItem);
    CONFORM(mItem, Math);
    CONFORM(Math, CarUnit);
    IF CarUnit.SNDate <= D THEN
     SETSEL(CUCopy, Math, mItem.Math);
     SRCINSEL(CUCopy, GE, , D);
     WHILE OCCURE(CUCopy) DO
      PROMPT(CUCopy.Math + " " + CUCopy.CUCopy);
      IF L_CUC.AccessMDocLCU(CUCopy.CUCopy, D) & L_CUC.IsCUAtStock(MDocLCU.OpKind) &
         (L_CUC.GetCurMDocLCUStorage() = Storage.Storage) THEN
       ADD(TSInv, TSInv, , mItem.Math, "", CUCopy.Serial,
             TSInv.Amount, 1);
       ADD(xxInv, xxInv, , Math.Math);
      END;
      NEXT(CUCopy);
     END; (* WHILE OCCURE(CUCopy) *)
    END; (* IF CarUnit.SNDate <= D *)
    RESTORE(mItem);
   END; (* IF ~L_TRS.AccessTckKindByMath(CUCopy.Math, D) *)
   NEXT(mItem);
  END; (* WHILE OCCURE(mItem) ... *)
 END {TSInv_PackNonTicketMathAtStorage};

 PRIVATE PROCEDURE TSInv_PackMathRestAtStorage(D: DATE);
  VAR
   SaldoPer: DATE;
   mft     : L_MDoc.tMathFlowType;
   curSum  : L_XObj.tSum;
   curQnt  : L_XObj.tQnt;
 BEGIN
  SaldoPer:=L_DatTim.IncMonth(L_DatTim.Per(D), -1);
  SELECT(mItem, Storage, , Storage.Storage);
  WHILE OCCURE(mItem) DO
   PROMPT(mItem.Math);
   IF SELECT(XCalc, XObject, mItem.XObject) THEN
    L_MathR.CountUpMath(mItem.Math, SaldoPer);
    CONFORM(mItem, XObject);
    CONFORM(mItem, Math);
    SELECT(XCalc, XObject, , XObject.XObject);
    WHILE OCCURE(XCalc) DO
     NARROWSEL(XCalc, AcCut);
     CONFORM(XCalc, AcCut);
     IF AcCut.SldType = L_AcCut.sldt_wAmount THEN
      SAVE(XCalc);
      L_XObj.GetOutRSaldo(XCalc.AcCut, SaldoPer, curSum, curQnt);
      ADD(MSInv, Math, , mItem.Math,
            MSInv.Amount, curQnt,
            MSInv.Sum,    curSum);
      ADD(xxInv, xxInv, , Math.Math);
      RESTORE(XCalc);
     END;
     NEXTINEXTENDEDSEL(XCalc, AcCut);
    END; (* WHILE OCCURE(XCalc) ... *)
   END; (* IF SELECT(XCalc ... *)
   NEXT(mItem);
  END; (* WHILE OCCURE(mItem) ... *)
 END {TSInv_PackMathRestAtStorage};

 PRIVATE PROCEDURE TSInv_RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {TSInv_RprtTop};

 PRIVATE PROCEDURE TSInv_PageTop(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Print THEN
   SETZERO(PageCount, PageAmount, PageSum);
   MAKEPART(R, TSInv_PageTop);
  ELSIF Mode = L_PagePr.m_RDoneTop THEN
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {TSInv_PageTop};

 PRIVATE PROCEDURE TSInv_PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(TSInv_PageBot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, TSInv_PageBot, PageCount, PageAmount, L_Money.ByWord(PageSum));
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Fill);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {TSInv_PageBot};

 PRIVATE PROCEDURE TSInv_RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(1);
  ELSIF Mode = L_PagePr.m_Print THEN
  ELSIF Mode =  L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {TSInv_RprtBot};

 PRIVATE PROCEDURE TSInv_Filling(Mode: SCAL[20]);
  VAR
   i: NUMERIC[0];
 BEGIN
  IF Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(2);
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, TSInv_MathTop1);
   i:=0;
   WHILE i < TSInv_Columns DO
    MAKEPART(R, TSInv_OneSerial);
    INC(i);
   END;
   MAKEPART(R, TSInv_EOL);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {TSInv_Filling};

 PRIVATE CONST
  liableNum  = 100;

 PRIVATE PROCEDURE TSInv_PrintLiables(D: DATE; LiableTSN: LIKE(Staff.TSN)[]);
  VAR
   Idx     : SCAL[liableNum];
   curPostN,
   curManN : STRING[];
 BEGIN
  FOR_EACH Idx DO
   CALL(MS_Inven.extGetPostAndName(D, LiableTSN[Idx], curPostN, curManN));
   IF (Idx >= 2) & !curManN THEN
    EXIT;
   ELSE
    MAKEPART(R, TSInv_Sign, curPostN, curManN);
   END;
  END;
 END {TSInv_PrintLiables};

 PUBLIC PROCEDURE extTSInv(trgMyFirm     : P_Firm.tMyFirm;
                           trgInvCommType: L_MathR.tInvCommitteeType;
                           OnDateFact,
                           OnDateRep,
                           curDate       : DATE);
  CONST
   RepName = "TSInv";
  VAR
   IsOnMonthBeg : SCAL[2];
   shiftBegDate,
   DummyD       : DATE;
   DummyT,
   shiftBegTime : TIME;
   Step,
   TotCount,
   TotAmount,
   Idx,
   Count,
   GrpCnt,
   Amount       : NUMERIC[0];
   TotSum,
   TotAcSum,
   FaceVal      : NUMERIC[2];
   TotSumStr,
   TotAcSumStr,
   TotAmountStr : STRING[][2];
   s,
   serial1,
   serial2      : STRING[];
   InvFrom,
   InvUpTo      : DATE;
   InvDocName,
   InvDocNum    : STRING[];
   InvDocDate   : DATE;
   ChTSN        : LIKE(Staff.TSN);
   CommTSN      : LIKE(Staff.TSN)[L_MathR.icomNum];
   LiableTSN    : LIKE(Staff.TSN)[liableNum];
   curPostN     : STRING[];
   curManN      : STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Storage), " ⠭  ࠭");
  APP.Get().NewPrompt("("+RepName+")");
  L_General.CallUs(trgMyFirm = Storage.MyFirm);
  P_Firm.curMyFirm:=trgMyFirm;
  glbOnDateFact   :=OnDateFact;
  IsOnMonthBeg:=OnDateFact = L_DatTim.MonthBeg(OnDateFact);

  actNum:=0;

  L_AFM.MakeIndex        ("xxInv", "Math   : LIKE(Math.Math)");
  L_AFM.MakeMultipleIndex("TSInv", "Math   : LIKE(Math.Math);"       +
                                   "TckKind: LIKE(TckKind.TckKind);" +
                                   "Serial : LIKE(CUCopy.Serial);"   +
                                   "Amount : NUMERIC[0]",
                                "TSInv: Math, TckKind, Serial");
  L_AFM.MakeMultipleIndex("MSInv", "Math   : LIKE(Math.Math);"  +
                                   "Amount : NUMERIC[2];"       +
                                   "Sum    : NUMERIC[2]",
                                "Math: Math");

  L_TRS.SetupTicketKassaShiftBorders(OnDateFact - 1, DummyD, shiftBegDate, DummyT, shiftBegTime);
  L_CUC.CollectTckMovement(Storage.Storage,
                           PackTIMESTAMP(shiftBegDate, shiftBegTime),
                           PackTIMESTAMP(shiftBegDate, shiftBegTime), (*  ⮫쪮 室饥 ᠫ줮 *)
                           PROCREF(TSInv_PackCUCopyAtStorage));

  TSInv_PackNonTicketMathAtStorage(OnDateFact);
  IF IsOnMonthBeg THEN
   TSInv_PackMathRestAtStorage(OnDateFact);
  END;
  OPENREP(R, L_General.NameConnection(RepName), Create,
             FontProperty, "/U");
  L_MathR.GetCommitteeFromSES(trgMyFirm, trgInvCommType, Storage.Storage,
                              InvFrom, InvUpTo, InvDocName, InvDocNum, InvDocDate, CommTSN, ChTSN);

  INC(actNum);
  IF L_General.GetAPSiteID() = "57" THEN
   actNumStr:="16/"+L_Str.IntStr(actNum);
  ELSE
   actNumStr:="";
  END;
  MAKEPART(R, TSInv_Top, InvDocName, InvDocNum, InvDocDate, InvFrom, InvUpTo, curDate);
  CALL(MS_Inven.GetLiables(curDate, Storage.Storage, LiableTSN));
  TSInv_PrintLiables(curDate, LiableTSN);
  MAKEPART(R, TSInv_TopOnDate, L_DatTim.FullDateStr(OnDateRep));
  FORMFEED(R);
  L_PagePr.PagePr_Init("R", 60, PROCREF(TSInv_RprtTop),
                            PROCREF(TSInv_PageTop), PROCREF(TSInv_PageBot),
                            PROCREF(TSInv_RprtBot), PROCREF(TSInv_Filling));
  SETZERO(TotCount, TotAmount, TotSum, TotAcSum);

  SELECT(xxInv, xxInv);
  WHILE OCCURE(xxInv) DO
   PROMPT(xxInv.Math);
   SEARCH(Math, Math, , xxInv.Math);
   CONFORM(Math, MUnit);

   IF SELECT(TSInv, TSInv, xxInv.Math) THEN
    L_PagePr.PagePr_BeforePrintLine(DEPTH(TSInv_MathTop1) + DEPTH(TSInv_MathTop2) +
                                    DEPTH(TSInv_CUCTop) + DEPTH(TSInv_CUCBot));
    IF LINENUM(R) > 1 THEN
     MAKEPART(R, TSInv_MathTop1);
    END;
    IF IsOnMonthBeg THEN
     SEARCH(MSInv, Math, , xxInv.Math);
     MAKEPART(R, TSInv_MathTop2, L_MathR.DefaultFormatCir(Math.Math, MSInv.Amount) + " " + MUnit.Sign,
                                 FLDTOSTR(MSInv.Sum, ",2-", 0) + " (" + L_Money.ByWord(MSInv.Sum) + ")");
     INC(TotAcSum, MSInv.Sum);
    ELSE
     MAKEPART(R, TSInv_MathTop2, "XXXXXXXXXXXXXXX", "XXXXXXXXXXXXXXX");
    END;
    MAKEPART(R, TSInv_CUCTop);
    SETZERO(Count, Amount);
    IF ~!TSInv.TckKind THEN
     SEARCH(TckKind, TckKind, , TSInv.TckKind);
     FaceVal:=TckKind.FaceVal;
     Step   :=TckKind.PckVol;
    ELSE
     FaceVal:=0;
     CONFORM(Math, CarUnit);
     Step   :=1;
    END;
    Idx:=0;

    serial1:=TSInv.Serial;
    serial2:=TSInv.Serial;
    GrpCnt :=1;
    INC(Amount,     TSInv.Amount);
    INC(PageAmount, TSInv.Amount);
    INC(PageSum,    TSInv.Amount * FaceVal);
    LOOP
     REPEAT
      NEXT(TSInv);
     UNTIL ~OCCURE(TSInv) | (TSInv.Amount # 0);

     IF OCCURE(TSInv) & L_CUC.IsSuccessionSerials(serial2, TSInv.Serial, Step) THEN
      serial2:=TSInv.Serial;
      INC(GrpCnt);
      INC(Amount,     TSInv.Amount);
      INC(PageAmount, TSInv.Amount);
      INC(PageSum,    TSInv.Amount * FaceVal);
     ELSE
      IF serial1 = serial2 THEN
       s:="";
      ELSE
       s:=serial1 + " .. ";
      END;

      IF Idx MOD TSInv_Columns = 0 THEN
       L_PagePr.PagePr_BeforePrintLine(1 + DEPTH(TSInv_CUCBot));
      END;
      MAKEPART(R, TSInv_OneSerial, s + serial2, L_Str.IntStr(GrpCnt) + " " + MUnit.Sign);
      INC(Idx);
      INC(Count, GrpCnt);
      INC(PageCount, GrpCnt);
      IF Idx MOD TSInv_Columns = 0 THEN
       MAKEPART(R, TSInv_EOL);
      END;

      IF OCCURE(TSInv) THEN
       serial1:=TSInv.Serial;
       serial2:=TSInv.Serial;
       GrpCnt :=1;
       INC(Amount,     TSInv.Amount);
       INC(PageAmount, TSInv.Amount);
       INC(PageSum,    TSInv.Amount * FaceVal);
      ELSE
       EXIT;
      END;
     END;
    END; (* WHILE OCCURE(File) *)

    WHILE Idx MOD TSInv_Columns # 0 DO
     INC(Idx);
     MAKEPART(R, TSInv_OneSerial);
     IF Idx MOD TSInv_Columns = 0 THEN
      MAKEPART(R, TSInv_EOL);
     END;
    END;
    MAKEPART(R, TSInv_CUCBot, Count, Amount, " 㬬  쭮 ⮨ " +
             FLDTOSTR(Amount * FaceVal, ",2-", 0) + " (" + L_Money.ByWord(Amount * FaceVal) + ")");
    INC(TotCount,  Count);
    INC(TotAmount, Amount);
    INC(TotSum,    Amount * FaceVal);
   ELSIF SEARCH(MSInv, Math, xxInv.Math) & (MSInv.Amount # 0) THEN
    L_PagePr.PagePr_BeforePrintLine(DEPTH(TSInv_MathTop1) + DEPTH(TSInv_MathTop2) + DEPTH(TSInv_NoCUC));
    IF LINENUM(R) > 1 THEN
     MAKEPART(R, TSInv_MathTop1);
    END;
    IF IsOnMonthBeg THEN
     MAKEPART(R, TSInv_MathTop2, L_MathR.DefaultFormatCir(Math.Math, MSInv.Amount) + " " + MUnit.Sign,
                                 FLDTOSTR(MSInv.Sum, ",2-", 0) + " (" + L_Money.ByWord(MSInv.Sum) + ")");
    ELSE
     MAKEPART(R, TSInv_MathTop2, "XXXXXXXXXXXXXXX", "XXXXXXXXXXXXXXX");
    END;
    MAKEPART(R, TSInv_NoCUC);
    INC(PageAmount, MSInv.Amount);
    INC(TotAmount, MSInv.Amount);
    INC(TotAcSum, MSInv.Sum);
   END; (* IF SELECT(TSInv, TSInv, MSInv.Math) *)
   NEXT(xxInv);
  END; (* WHILE OCCURE(xxInv) ... *)
  L_PagePr.PagePr_Done();
  Str.Format(TotSumStr,    L_Money.ByWord(TotSum),            157, LEFT);
  Str.Format(TotAmountStr, L_Str.NumericByWord(TotAmount, 0), 157, LEFT);
  IF IsOnMonthBeg THEN
   Str.Format(TotAcSumStr,  L_Money.ByWord(TotAcSum),          157, LEFT);
  ELSE
   TotAcSumStr[0]:=L_Str.Repeat("X", 157);
   TotAcSumStr[1]:=L_Str.Repeat("X", 157);
  END;
  MAKEPART(R, TSInv_BotHead, L_Str.NumericByWord(TotCount, 0),
                             TotAmountStr[0], TotAmountStr[1],
                             TotSumStr[0], TotSumStr[1],
                             TotAcSumStr[0], TotAcSumStr[1]);
  CALL(MS_Inven.extPrintInvCommittee(curDate, CommTSN));
  MAKEPART(R, TSInv_BotFoot);
  TSInv_PrintLiables(curDate, LiableTSN);
  CALL(MS_Inven.extGetPostAndName(curDate, ChTSN, curPostN, curManN));
  MAKEPART(R, TSInv_BotChMan, curPostN, curManN);

  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {extTSInv};

 PUBLIC PROCEDURE Tck03();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  CALL(tck30.Tck32_CheckIsDone(Memo.ud_cd() - 1));
  Tck03_Do(Memo.ud_cd(), Memo.ud_cd(), 1,
           "Tck03_"+FLDTOSTR(Memo.ud_cd(), "D", 0),
           "   ⭮ . ");
 END {Tck03};

 PUBLIC PROCEDURE Tck23();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  CALL(tck30.Tck32_CheckIsDone(Memo.ud_fr() - 1));
  Tck03_Do(Memo.ud_fr(), Memo.ud_ut(), 0,
           "Tck23_"+FLDTOSTR(Memo.ud_fr(), "D", 0)+FLDTOSTR(Memo.ud_ut(), "D", 0),
           " ⭮ த樨  樮   ਮ");
 END {Tck23};

(*
$P{ Tck43_Top:
P_Firm.MyFirmName(MC2.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "N.y"
?, L, "N.y"
?, L, "D.N.y"
?, L, "D.N.y"
@
############################################################################################################################################################################# ########## #####
=#####========================================================================================================================================================================================
|                                             ⭮ த樨  , த騬  ஥   ਮ  #######  #######                                           |
|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|                                              |                       |                     |                     |                   |  ᠭ   |              |                       |
|                                           | ⮪  ########## |      祭       |                |      த      |   誠   |    ८業| ⮪  ########## |
}
*)

(*
$P{ Tck43_StorageTop:
StrgKind.StrgKind, L, ""
StrgKind.Name, L, ""
Storage.Storage, L, ""
Storage.Name, L, ""
@
|============================================================================================================================================================================================|
|  ## ################################################  ####### ######################################################################################################################|
|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ Tck43_Line:
Math.Math, L, ""
Math.Name, L, ""
MC2.iSldQnt, R, "0"
MC2.iSldSum, R, ",2-"
MC2.DbtQnt, R, "0"
MC2.DbtSum, R, ",2-"
MC2.CrdQnt, R, "0"
MC2.CrdSum, R, ",2-"
MC2.SaleQnt, R, "0"
MC2.SaleSum, R, ",2-"
MC2.Retire, R, ",2-"
MC2.oSldSum - MC2.iSldSum - MC2.DbtSum + MC2.CrdSum + MC2.SaleSum + MC2.Retire, R, ",2-"
MC2.oSldQnt, R, "0"
MC2.oSldSum, R, ",2-"
@
|##### ########################################|###### ################|##### ###############|##### ###############|#### ##############|##############|##############|###### ################|
}
*)

(*
$P{ Tck43_Totals:
?, L, ""
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
@
|----------------------------------------------|-----------------------|---------------------|---------------------|-------------------|--------------|--------------|-----------------------|
|##############################################|#######################|#####################|#####################|###################|##############|##############|#######################|
}
*)

(*
$P{ Tck43_Bot:
@
=(c) Polak====================================================================================================================================================================================
}
*)

 PRIVATE PROCEDURE Create_MC2();
 BEGIN
  CreateFILE(MC2, "", " 楢  ꥪ⮢   ਮ", "");
  CreateFIELD(MC2, MyFirm,   LIKE(MyFirm.MyFirm),     "", "", "", "", "");
  CreateFIELD(MC2, Math,     LIKE(Math.Math),         "", "", "", "", "");
  CreateFIELD(MC2, StrgKind, LIKE(StrgKind.StrgKind), "", "",  "", " ", "");
  CreateFIELD(MC2, Storage,  LIKE(Storage.Storage), "", "",  "", " ࠭", "");
  CreateFIELD(MC2, iSldSum,  L_XObj.tSum,           "", "0", "", "줮, 㬬", "");
  CreateFIELD(MC2, iSldQnt,  L_XObj.tQnt,           "", "0", "", "줮, ⢮", "");
  CreateFIELD(MC2, DbtSum,   L_XObj.tSum,           "", "0", "", "⮢ , 㬬", "");
  CreateFIELD(MC2, DbtQnt,   L_XObj.tQnt,           "", "0", "", "⮢ , ⢮", "");
  CreateFIELD(MC2, CrdSum,   L_XObj.tSum,           "", "0", "", "।⮢ , 㬬", "");
  CreateFIELD(MC2, CrdQnt,   L_XObj.tQnt,           "", "0", "", "।⮢ , ⢮", "");
  CreateFIELD(MC2, SaleSum,  L_XObj.tSum,           "", "0", "", "த, 㬬", "");
  CreateFIELD(MC2, SaleQnt,  L_XObj.tQnt,           "", "0", "", "த, ⢮", "");
  CreateFIELD(MC2, Reval,    L_XObj.tSum,           "", "0", "", "८業, 㬬", "");
  CreateFIELD(MC2, Retire,   L_XObj.tSum,           "", "0", "", "ᠭ  誠, 㬬", "");
  CreateFIELD(MC2, oSldSum,  L_XObj.tSum,           "", "0", "", "줮, 㬬", "");
  CreateFIELD(MC2, oSldQnt,  L_XObj.tQnt,           "", "0", "", "줮, ⢮", "");

  CreateINDEX       (MC2, MC2,   UNIQUE,                   "", "", MyFirm, StrgKind, Storage, Math);
  CreateINDEXandLINK(MC2, Math,  UNIQUE, Math, Math, USER, "", "", Math, Storage);
  SetVersionOfFILE(MC2, 0000);
  L_AFM.CreateTemp("MC2");
 END {Create_MC2};

 PRIVATE PROCEDURE Tck43_AccessTckKind(trgMath: LIKE(Math.Math)): SCAL[2];
 BEGIN
  RETURN L_TRS.AccessTckKindByMath(trgMath, Memo.ud_ut()) | L_TRS.AccessTckKindByMath(trgMath, Memo.ud_fr());
 END {Tck43_AccessTckKind};

 PRIVATE PROCEDURE uav_IsZero(uav: L_Acnt.tUnfoldedAcntVector): SCAL[2];
  VAR
   uavp: L_Acnt.tUnfoldedAcntVectorPart;
 BEGIN
  FOR_EACH uavp DO
   IF uav[uavp] # 0 THEN
    RETURN 0;
   END;
  END;
  RETURN 1;
 END {uav_IsZero};

 PUBLIC PROCEDURE Tck43();
  CONST
   RepName = "Tck43";
  VAR
   From,
   UpTo : DATE;
   PackSum,
   iSld,
   Dbt,
   Crd,
   Sale,
   oSld,
   Retire,
   Reval,
   tot_iSld,
   tot_Dbt,
   tot_Crd,
   tot_Sale,
   tot_oSld,
   tot_Retire,
   tot_Reval : NUMERIC[2];
   trgOM     : L_XObj.tOriginsMap;
   trgMyFirm : LIKE(MyFirm.MyFirm);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt("("+RepName+")");
  From:=Memo.ud_fr();
  UpTo:=Memo.ud_ut();
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
  L_XObj.SetupOrigins(0, trgOM, trgMyFirm);
  Create_MC2();
  SELECT(Storage, TpStrg, , L_Stock.st_Stock);
  WHILE OCCURE(Storage) DO
   IF L_DatTim.IsActiveInIntvl(Storage.Begin, Storage.Till, From, UpTo+1) &
      (P_Storage.StoringType(Storage.Storage, UpTo) = L_Stock.storingType_Tickets) THEN

    D_XObj.PointwiseBuildXC001(D_XObj.XCC_SingleStorage,
                               EMPTYOF(L_XObj.tSection),
                               L_Acnt.ak_Acn,
                               trgOM,
                               trgMyFirm,
                               D_XObj.XST_ByXObj,
                               D_XObj.XST_ByAcCut,
                               D_XObj.XST_ByAcCut2);

    SELECT(XC001, mfObject);
    WHILE OCCURE(XC001) DO
     SEARCH(XObject, XObject, , XC001.Object);
     NARROWSEL(XC001, MyFirm, Object);
     L_XObj.AccessOrigin();
     PROMPT(" "+mItem.XObject+",  "+mItem.Math);
     IF Tck43_AccessTckKind(mItem.Math) & ~L_TRS.IsDevice(TckKind.Type) THEN
      L_General.CallUs(mItem.Storage = Storage.Storage);
      WHILE OCCURE(XC001) DO
       IF L_MathR.AcCutOfRealStock(XC001.Cut1) &
          (~uav_IsZero(XC001.uav_aSum) | ~uav_IsZero(XC001.uav_aQnt)) THEN
        ADD(MC2, MC2, , Storage.MyFirm, Storage.StrgKind, mItem.Storage, mItem.Math,
                   MC2.iSldQnt, XC001.uav_aQnt[L_Acnt.uavp_ISlDbt]-XC001.uav_aQnt[L_Acnt.uavp_ISlCrd],
                   MC2.DbtQnt,  XC001.uav_aQnt[L_Acnt.uavp_CirDbt],
                   MC2.CrdQnt,  XC001.uav_aQnt[L_Acnt.uavp_CirCrd],
                   MC2.oSldQnt, XC001.uav_aQnt[L_Acnt.uavp_OSlDbt]-XC001.uav_aQnt[L_Acnt.uavp_OSlCrd],
                   MC2.DbtSum,  XC001.uav_aQnt[L_Acnt.uavp_CirDbt] * TckKind.FaceVal * TckKind.PckVol,
                   MC2.CrdSum,  XC001.uav_aQnt[L_Acnt.uavp_CirCrd] * TckKind.FaceVal * TckKind.PckVol,
                   MC2.oSldSum, (XC001.uav_aQnt[L_Acnt.uavp_OSlDbt]-XC001.uav_aQnt[L_Acnt.uavp_OSlCrd]) * TckKind.FaceVal * TckKind.PckVol);

        IF (XC001.uav_aQnt[L_Acnt.uavp_ISlDbt]-XC001.uav_aQnt[L_Acnt.uavp_ISlCrd]) # 0 THEN
         L_General.CallUs(L_TRS.AccessTckKindByMath(mItem.Math, From));
         INC(MC2.iSldSum, (XC001.uav_aQnt[L_Acnt.uavp_ISlDbt]-XC001.uav_aQnt[L_Acnt.uavp_ISlCrd]) * TckKind.FaceVal * TckKind.PckVol);
         REPLACE(MC2);
        END;
       END; (* IF L_MathR.AcCutOfRealStock ... *)
       NEXT(XC001);
      END; (* WHILE OCCURE(XC001) ... *)
     END; (* IF Tck43_AccessTckKind( ... *)
     NEXTINEXTENDEDSEL(XC001, MyFirm, Object);
    END; (* WHILE OCCURE(XC001) ... *)

    D_XObj.PurgeXC001();;

    IF SELECT(TckRcD, TypeStrg, L_TRS.trdt_Sale, Storage.Storage) THEN
     SAVE(TckRcD);
     CALL(Tck30.Tck33_CheckIsDone(UpTo, TckRcD.Storage));
     RESTORE(TckRcD);
     SRCINSEL(TckRcD, GE, , From);
     WHILE OCCURE(TckRcD) & (TckRcD.Date <= UpTo) DO
      SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
      WHILE OCCURE(TckRcDL) DO
       CONFORM(TckRcDL, TckKind);
       CONFORM(TckRcD, Storage);
       IF TckKind.Type # L_TRS.tkt_EasySales THEN
        PackSum:=TckKind.FaceVal * TckKind.PckVol;
        L_General.CallUs(Tck43_AccessTckKind(TckKind.Math));
        ADD(MC2, MC2, , Storage.MyFirm, Storage.StrgKind, TckRcD.Storage, TckKind.Math,
                   MC2.CrdQnt,  -TckRcDL.Psg,
                   MC2.SaleQnt, TckRcDL.Psg,
                   MC2.CrdSum,  -TckRcDL.Psg * TckKind.FaceVal * TckKind.PckVol,
                   MC2.Retire,  TckRcDL.Psg * PackSum - TckRcDL.RestNbr,
                   MC2.SaleSum, TckRcDL.RestNbr);
       END;
       NEXT(TckRcDL);
      END; (* WHILE OCCURE(TckRcDL) ... *)
      NEXT(TckRcD);
     END; (* WHILE OCCURE(File) *)
    END; (* IF L_DatTim.IsActiveInIntvl... *)
   END;
   NEXT(Storage);
  END; (* WHILE OCCURE(Storage) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  SELECT(MC2, MC2);
  WHILE OCCURE(MC2) DO
   NARROWSEL(MC2, MyFirm);
   MAKEPART(R, Tck43_Top, RepName, From, UpTo, From, UpTo+1);
   WHILE OCCURE(MC2) DO
    SETZERO(tot_iSld, tot_Dbt, tot_Crd, tot_Sale, tot_oSld, tot_Retire, tot_Reval);
    NARROWSEL(MC2, StrgKind);
    WHILE OCCURE(MC2) DO
     NARROWSEL(MC2, Storage);
     SEARCH(Storage, Storage, , MC2.Storage);
     CONFORM(Storage, StrgKind);
     MAKEPART(R, Tck43_StorageTop);
     SETZERO(iSld, Dbt, Crd, Sale, oSld, Retire, Reval);
     SETZERO(iSld, Dbt, Crd, Sale, oSld, Retire, Reval);
     WHILE OCCURE(MC2) DO
      CONFORM(MC2, Math);
  (*
      L_General.CallUs(Tck43_AccessTckKind(MC2.Math));
  *)
      MAKEPART(R, Tck43_Line);
      INC(iSld,   MC2.iSldSum);
      INC(Dbt,    MC2.DbtSum);
      INC(Crd,    MC2.CrdSum);
      INC(Sale,   MC2.SaleSum);
      INC(Retire, MC2.Retire);
      INC(oSld,   MC2.oSldSum);
      INC(Reval,  MC2.oSldSum - MC2.iSldSum - MC2.DbtSum + MC2.CrdSum + MC2.SaleSum + MC2.Retire);
      NEXT(MC2);
     END; (* WHILE OCCURE(MC2) ... *)
     MAKEPART(R, Tck43_Totals, "⮣", iSld, Dbt, Crd, Sale, Retire, Reval, oSld);
     INC(tot_iSld,   iSld);
     INC(tot_Dbt,    Dbt);
     INC(tot_Crd,    Crd);
     INC(tot_Sale,   Sale);
     INC(tot_Retire, Retire);
     INC(tot_oSld,   oSld);
     INC(tot_Reval,  Reval);
     NEXTINEXTENDEDSEL(MC2, Storage);
    END; (* WHILE OCCURE(MC2) ... *)
    MAKEPART(R, Tck43_Totals, "⮣    " + StrgKind.StrgKind + " " + StrgKind.Name,
                              tot_iSld, tot_Dbt, tot_Crd, tot_Sale, tot_Retire, tot_Reval, tot_oSld);
    NEXTINEXTENDEDSEL(MC2, StrgKind);
   END; (* WHILE OCCURE(MC2) ... *)
   MAKEPART(R, Tck43_Bot);
   NEXTINEXTENDEDSEL(MC2, MyFirm);
  END; (* WHILE OCCURE(MC2) ... *)
  L_General.SurveyLastReport();
 END {Tck43};

END.
