(*
%Copyright   (c) Polak IT
%Author      26.07.2005 14:34:03 POLAK\San
%Purpose      ஢ ⭮ 
%Type        report
%Specific    AP
%Modified    10.04.2012 12:08:35 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, Memo, L_AFM, L_OwnData, L_XDoc, L_TRS;

(*
$P{ Tck04_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
?, L, "H:M"
?, L, "D.N.y"
?, L, "H:M"
@
######################################################################### ########## #####
=#####====================================================================================
|         ஢ ⭮   ########## #####  ########## #####         |
|----------------------------------------------------------------------------------------|
|                |.|.|. |.|. | | |.|
}
*)

(*
$P{ Tck04_Line:
?, L, ""
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
@
|------------------------|-------|-------|-------|-------|-------|-------|-------|-------|
|########################|#######|#######|#######|#######|#######|#######|#######|#######|
}
*)

(*
$P{ Tck04_Bot:
@
=(c) Polak================================================================================
}
*)

 PRIVATE PROCEDURE Tck04_WorkType(): SCAL[8];
 BEGIN
  IF    XDocJrn.XDocType = L_XDoc.xdt_TckRcS THEN
   RETURN 0;
  ELSIF XDocJrn.XDocType = L_XDoc.xdt_TckRcD THEN
   SEARCH(TckRcD, TckRcD, , XDocJrn.XDoc);
   RETURN 1 + TckRcD.Type;
  ELSIF XDocJrn.XDocType = L_XDoc.xdt_TckRcC THEN
   SEARCH(TckRcC, TckRcC, , XDocJrn.XDoc);
   RETURN 4 + TckRcC.Type;
  ELSE
   L_General.ConsultToUs(0, "  ⨯ 㬥?");
  END;
 END {Tck04_WorkType};

 PRIVATE PROCEDURE Tck04_DoOneXDocType(_XDocType: LIKE(XDocJrn.XDocType);
                               _Action  : LIKE(XDocJrn.Action);
                               BegDate,
                               EndDate  : DATE;
                               BegTime,
                               EndTime  : TIME);
  VAR
   File: STRING[];
 BEGIN
  SELECT(XDocJrn, UserIdx, , _XDocType);
  WHILE OCCURE(XDocJrn) DO
   NARROWSEL(XDocJrn, AcsObj);
   SRCINSEL(XDocJrn, GE, , BegDate, BegTime);
   WHILE OCCURE(XDocJrn) & ((XDocJrn.Date < EndDate) |
                            (XDocJrn.Date = EndDate) & (XDocJrn.BegTime < EndTime)) DO
    PROMPT(XDocJrn.XDocType + " " + XDocJrn.XDoc);
    IF (XDocJrn.Action = _Action) THEN
     CONFORM(XDocJrn, AcsObj);
     ADD(xd004, xd004, , AcsObj.Name, xd004.Amount[Tck04_WorkType()], 1);
    END;
    NEXT(XDocJrn);
   END; (* WHILE OCCURE(File) *)
   NEXTINEXTENDEDSEL(XDocJrn, AcsObj);
  END; (* WHILE OCCURE(XDocJrn) *)
 END {Tck04_DoOneXDocType};

 PRIVATE PROCEDURE Tck04_Do(B, E: DATE);
  CONST
   RepName = "Tck04";
  VAR
   DummyD,
   BegDate,
   EndDate   : DATE;
   DummyT,
   BegTime,
   EndTime   : TIME;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);

  L_TRS.SetupTicketKassaShiftBorders(B, BegDate, DummyD, BegTime, DummyT);
  L_TRS.SetupTicketKassaShiftBorders(E, DummyD, EndDate, DummyT, EndTime);

  CreateFILE(xd004);
  CreateFIELD(xd004, Login,  LIKE(AcsObj.Name));
  CreateFIELD(xd004, Amount, NUMERIC[0][8], , "0");
  CreateINDEX(xd004, xd004, UNIQUE, , , Login);
  SetVersionOfFILE(xd004, 0);
  L_AFM.AF_CreateTemp("xd004", "xd004");

  Tck04_DoOneXDocType(L_XDoc.xdt_TckRcS, L_XDoc.action_begDst,    BegDate, EndDate, BegTime, EndTime);
  Tck04_DoOneXDocType(L_XDoc.xdt_TckRcD, L_XDoc.action_AutoBuild, BegDate, EndDate, BegTime, EndTime);
  Tck04_DoOneXDocType(L_XDoc.xdt_TckRcC, L_XDoc.action_AutoBuild, BegDate, EndDate, BegTime, EndTime);

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Tck04_Top, RepName, BegDate, BegTime, EndDate, EndTime);
  SELECT(xd004, xd004);
  WHILE OCCURE(xd004) DO
   MAKEPART(R, Tck04_Line, xd004.Login,
                           xd004.Amount[0],
                           xd004.Amount[1],
                           xd004.Amount[2],
                           xd004.Amount[3],
                           xd004.Amount[4],
                           xd004.Amount[5],
                           xd004.Amount[6],
                           xd004.Amount[7]);
   NEXT(xd004);
  END; (* WHILE OCCURE(xd004) ... *)
  MAKEPART(R, Tck04_Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("xd004");
 END {Tck04_Do};

BEGIN
 IF    MODE = 100 THEN
  Tck04_Do(Memo.ud_fr(), Memo.ud_ut());
 ELSE
  L_General.BadMode(MODE);
 END;
END.
