(*
%Copyright   (c) Polak IT
%Author      26.11.2007 09:58:07 POLAK\GAV
%Purpose     ﭨ 뤠  ࠡ⭨
%Type        report
%Specific    AP
%Modified    27.02.2014 14:01:16 POLAK\Gina
%Environment
*)

 MODULE Tck05 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_AFM, L_Way, L_TRS, L_General, L_Str, L_Env, L_OwnData;

 CONST
  RepName = "Tck05";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, L, "H:M"
?, L, "D.N.y"
@
############################################################################## ########## #####
=#####=========================================================================================
|                     ﭨ 뤠  ࠡ⭨  ##### ##########                     |
|---------------------------------------------------------------------------------------------|
|. |                       ||륧|. |                |               |.|
}
*)


(*
$P{ DlmLine:
@
|-----|--------------------------|---|-----|-------|------------------|------------------|----|
}
*)

(*
$P{ Line:
Staff.TSN, L, ""
Man.Name, L, ""
?, L, L_Way.rwswho_Pool_Short
?, L, "H:M"
?, L, ""
?, L, ""
?, L, ""
?, R, "0"
@
|#####|##########################|###|#####|#######|##################|##################|####|
}
*)

(*
$P{ Bot:
@
=(c) Polak=====================================================================================
}
*)

 PRIVATE PROCEDURE InsStaff(D      : DATE;
                            _TSN   : LIKE(Staff.TSN);
                            Who    : L_Way.tRWSWho;
                            _StartT: LTIME);
  VAR
   Op: SCAL[3];
 BEGIN
  IF L_Env.RealTSN(_TSN) THEN
   IF SEARCH(tmp, TSN, _TSN) THEN
    Op:=tmp.StartT > _StartT;
   ELSE
    Op:=2;
   END;
   IF Op > 0 THEN
    tmp.Who     :=Who;
    tmp.StartT  :=_StartT;
    tmp.ECSign  :=ExitClss.Sign;
    tmp.rws     :=RWayS.RWayS;
    tmp.TRSGiven:=SELECT(TckRcS, TSN, _TSN, D) & (TckRcS.Status >= L_TRS.trsStat_Given);
    IF OCCURE(TckRcS) THEN
     tmp.trs    :=TckRcS.TckRcS;
    ELSE
     SETEMPTY(tmp.trs);
    END;
    IF Op = 1 THEN
     REPLACE(tmp);
    ELSE
     tmp.TSN    :=_TSN;
     INSERT(tmp);
    END;
   END;
  END;
 END {InsStaff};

 PRIVATE PROCEDURE Print(D: DATE; T: TIME);
  VAR
   MinutesLeft: NUMERIC[0];
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, T, D);
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   MAKEPART(R, DlmLine);
   CHANGESEL(tmp, tmp, , tmp.TRSGiven);
   WHILE OCCURE(tmp) DO
    SEARCH(Staff, TSN, , tmp.TSN);
    CONFORM(Staff, Man);
    IF ~tmp.TRSGiven THEN
     MinutesLeft:=(tmp.StartT - C_T2L(01, 00:00)) * 60 - (T - 00:00) * 60;
    ELSE
     SETEMPTY(MinutesLeft);
    END;
    SEARCH(RWayS, RWayS, , tmp.rws);
    IF ~!tmp.trs THEN
     SEARCH(TckRcS, TckRcS, , tmp.trs);
     MAKEPART(R, Line, tmp.Who, tmp.StartT, tmp.ECSign,
                       tmp.rws + " " + L_Str.PoolItem(L_Way.rwsStat_Pool, RWayS.Status),
                       tmp.trs + " " + L_Str.PoolItem(L_TRS.trsStat_Pool, TckRcS.Status),
                       MinutesLeft);
    ELSE
     MAKEPART(R, Line, tmp.Who, tmp.StartT, tmp.ECSign,
                       tmp.rws + " " + L_Str.PoolItem(L_Way.rwsStat_Pool, RWayS.Status), , MinutesLeft);
    END;
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
   LAST(tmp);
   CHANGESEL(tmp, tmp);
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {Print};

 PRIVATE PROCEDURE Gather(D: DATE);
  VAR
   GuardCount: NUMERIC[0];
 BEGIN
  SELECT(RWayS, Date, , D);
  WHILE OCCURE(RWayS) DO
   PROMPT(RWayS.RWayS);
   CONFORM(RWayS, StExit);
   CONFORM(StExit, ExitClss);
   GuardCount:=0;
   SELECT(WayLMen, RWayS, , RWayS.RWayS, L_Way.wlmwho_Guard);
   WHILE OCCURE(WayLMen) DO
    INC(GuardCount);
    InsStaff(D, WayLMen.TSN, L_Way.rwswho_Guard, C_T2L(WayLMen.Day, WayLMen.StartT));
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
   IF (GuardCount = 0) & (StExit.Strict = L_Way.ExitStrict_Reg) THEN
    InsStaff(D, RWayS.TSN, L_Way.rwswho_Driver, RWayS.StartTim);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {Gather};

 PUBLIC PROCEDURE Tck05();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AFM.MakeMultipleIndex("tmp", "TSN     : LIKE(Staff.TSN); " +
                                 "Who     : SCAL[10]; " +
                                 "StartT  : LTIME; " +
                                 "ECSign  : LIKE(ExitClss.Sign); " +
                                 "rws     : LIKE(RWayS.RWayS); " +
                                 "trs     : LIKE(TckRcS.TckRcS); " +
                                 "TRSGiven: SCAL[2]",
                             "TSN: TSN;" +
                             "tmp: TRSGiven, StartT");
  Gather(SYSDATE());
  Print(SYSDATE(), SYSTIME());
  L_AFM.AF_PurgeTemp("tmp");
  L_General.SurveyLastReport();
 END {Tck05};

END.