(*
%Copyright   (c) Polak IT
%Author      27.07.2005 17:49:04 POLAK\San
%Purpose       
%Type        report
%Specific    AP
%Modified    16.08.2013 08:46:02 POLAK\MLB
%Environment
*)

 IMPORT L_General, Memo, P_Firm, L_Str, L_AFM, L_Way, L_TRS, D_TP, E_Utils, Str, DBD, E_Prop,
        P_Route, L_EC, E_TRS, L_Car, L_Staff;

 CONST
  planIdx    = MAXOF(TckRcS.AsWho)+1;
  totalIdx   = planIdx+1;

  kv_NoValue = "no value";

 TYPE
  tTotals = NUMERIC[2][totalIdx+1];

 VAR
  _StateNbr: LIKE(CarLog.StateNbr);
  _MarkName: LIKE(Mark.Name);

  wPlan    : SCAL[2];

(*
$P{ Tck10_Top:
P_Firm.MyFirmName(Tck10.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
@
############################################################################################################ ########## #####
=#####=======================================================================================================================
|                ।⥫쭮 । த  ਭ      ॢ  ##########              |
|---------------------------------------------------------------------------------------------------------------------------|
|                                             |            |                   窠 䠪                    |            |
|㯯 ( ॢ/ ...)           |窠 |---------------------------------------------------|     |
|                                             |            |    ⥫|  |  稪|       ᥣ|            |
}
*)

(*
$P{ Tck10_Delim:
@
|---------------------------------------------|------------|------------|------------|------------|------------|------------|
}
*)

(*
$P{ Tck10_Line:
?, L, ""
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
@
|#############################################|############|############|############|############|############|############|
}
*)

(*
$P{ Tck10_SupplBot:
@
|---------------------------------------------------------------------------------------------------------------------------|
|                                                    祭 ࠡ⭨                                                    |
}
*)

(*
$P{ Tck10_SupplSortTop:
Sort.Sort, L, ""
Sort.Name, L, ""
L_Staff.getSortDprt(Sort.Sort), L, ""
L_Staff.getSortDprtName(Sort.Sort), L, ""
@
|---------------------------------------------------------------------------------------------------------------------------|
| ### ###################################################### ⤥ ### ###############################################|
|---------------------------------------------------------------------------------------------------------------------------|
|. |                  |    |室  |.|. |ઠ                           |   ""|     |   |
|-----|---------------------|-------|-------|----|----------|--------------------------------|---------|---------|----------|
}
*)

(*
$P{ Tck10_SupplLine:
TckRcS.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Suppl.TckRcS, L, ""
GetExitClssSign(), L, ""
TckRcS.asBoxNbr, L, ""
_StateNbr, L, ""
_MarkName, L, ""
Suppl.Plan, R, "2-"
Suppl.Fact, R, "2-"
Suppl.Fact-Suppl.Plan, R, "2-"
@
|#####|#####################|#######|#######|####|##########|################################|#########|#########|##########|
}
*)

(*
$P{ DlmLine:
@
|-----|---------------------|-------|-------|----|----------|--------------------------------|---------|---------|----------|
}
*)

(*
$P{ Tck10_SupplSortBot:
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|--------------------------------------------------------------------------------------------|---------|---------|----------|
|⮣  ᥪ                                                                            |#########|#########|##########|
}
*)

(*
$P{ Tck10_Bot:
@
=(c) Polak===================================================================================================================
}
*)

 PRIVATE PROCEDURE GetExitClssSign(): LIKE(ExitClss.Sign);
 BEGIN
  IF ~!Suppl.ExitClss THEN
   SEARCH(ExitClss, ExitClss, , Suppl.ExitClss);
   RETURN ExitClss.Sign;
  END;
  RETURN "";
 END {GetExitClssSign};

 PRIVATE PROCEDURE GetCarInf();
 BEGIN
  SETEMPTY(_StateNbr, _MarkName);
  IF ~!TckRcS.asBoxNbr THEN
   L_General.Assert(SEARCH(Car, BoxNbr, TckRcS.asBoxNbr),
                    "  " + TckRcS.TckRcS + " 㪠 饥  " + TckRcS.asBoxNbr);
   L_Car.StandOnCarLog(TckRcS.asBoxNbr, TckRcS.Date);
   _StateNbr:=CarLog.StateNbr;
   CONFORM(CarLog, Mark);
   _MarkName:=Mark.Name;
  END;
 END {GetCarInf};

 PRIVATE PROCEDURE xyz_IsSP(): SCAL[2];
 BEGIN
  RETURN Str.Cap(DBD.BaseName()) = "SP";
 END {xyz_IsSP};

 PRIVATE PROCEDURE xyz_Is53(): SCAL[2];
 BEGIN
  RETURN Str.Cap(DBD.BaseName()) = "53";
 END {xyz_Is53};

 PRIVATE PROCEDURE E_GetRouteForChopper(D: DATE): LIKE(Route.Route);
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_TRS.GetRouteForChopper), "");
 END {E_GetRouteForChopper};

 PRIVATE PROCEDURE _Tck10_AccessKeyValues(D: DATE; VAR kvL1, kvL2: STRING[]);
 BEGIN
  L_Way.StandOnRouteTKind(D);
  kvL1:=TKind.FnMode;
  kvL2:=TKind.TKind;
  IF xyz_IsSP() THEN
   kvL1:=P_Route.GetRouteProSoft(Route.Route, D, E_Prop.P_RouteforTck10);
   kvL2:=Route.Route;
  END;
 END {_Tck10_AccessKeyValues};

 PRIVATE PROCEDURE StandOnSEJobs();
  VAR
   _Trip: LIKE(SEJobs.Trip);
 BEGIN
  CONFORM(StExit, SEJobs);
  IF (TckRcS.AsWho = L_Way.trs_Guard) & ~!StExit.GuBTime THEN
   IF ~SRCINSEL(SEJobs, GE, 01, StExit.GuBTime) THEN
    FIRST(SEJobs);
   END;
  END;
  _Trip:=SEJobs.Trip;
  CONFORM(SEJobs, Route);
  WHILE OCCURE(SEJobs) & ~Route.IncSel DO
   NEXT(SEJobs);
   IF OCCURE(SEJobs) THEN
    CONFORM(SEJobs, Route);
   END;
  END; (* WHILE OCCURE(SEJobs) ... *)
  IF ~OCCURE(SEJobs) THEN
   SEARCH(SEJobs, Trip, , _Trip);
   CONFORM(SEJobs, Route);
  END;
 END {StandOnSEJobs};

 PRIVATE PROCEDURE Tck10_AccessKeyValues(    D        : DATE;
                                         VAR kvL1,
                                             kvL2,
                                             kvL3     : STRING[];
                                         VAR _ExitClss: LIKE(ExitClss.ExitClss));
  VAR
   i   : NUMERIC[0];
   _Who: L_Way.tRWSWho;
 BEGIN
  TRY
   SETEMPTY(kvL1, kvL2, _ExitClss);
   SELECT(rout1, rout1);
   REMSEL(rout1);
   kvL3:=kv_NoValue;
   IF L_TRS.IsStandOnTckRcSExit() THEN
    StandOnSEJobs();
    ADD(rout1, rout1, , Route.Route);
    _Tck10_AccessKeyValues(D, kvL1, kvL2);
    _ExitClss:=StExit.ExitClss;
    IF xyz_Is53() THEN
     IF TckRcS.AsWho = L_Way.trs_Chopper THEN
      _Who:=L_Way.rwswho_Chopper;
     ELSE
      _Who:=TckRcS.AsWho;
     END;
     IF L_Way.StandOnFixedSortOfExit(StExit.Exit, D, _Who, 0) THEN
      kvL3:=L_Staff.getSortDprtName(Sort.Sort);
     ELSE
      SETEMPTY(kvL3);
     END;
    END;
    i:=0;
    WHILE i <= HIGH(TckRcS.asRWayS) DO
     IF ~!TckRcS.asRWayS[i] & SEARCH(RWayS, RWayS, TckRcS.asRWayS[i]) &
        L_TRS.IsStandOnRWaySExit() & (StExit.Strict # L_Way.ExitStrict_Fict) THEN
      SELECT(SEJobs, Exit, , StExit.Exit);
      WHILE OCCURE(SEJobs) DO
       CONFORM(SEJobs, Route);
       IF Route.IncSel THEN
        ADD(rout1, rout1, , Route.Route);
       END;
       NEXT(SEJobs);
      END; (* WHILE OCCURE(SEJobs) ... *)
     END;
     INC(i);
    END;
   ELSIF TckRcS.AsWho = L_Way.trs_Chopper THEN
    ADD(rout1, rout1, , E_GetRouteForChopper(D));
    IF ~!rout1.Route THEN
     L_General.CallUs(SEARCH(Route, Route, rout1.Route));
     _Tck10_AccessKeyValues(D, kvL1, kvL2);
    END;
   ELSE
    ADD(rout1, rout1, , "");
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc:Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
 END {Tck10_AccessKeyValues};

 PRIVATE PROCEDURE Tck10_GetKeyName(Level: NUMERIC[0]; KeyValue: STRING[]): STRING[];
 BEGIN
  IF Level = 0 THEN
   RETURN " ";
  ELSIF KeyValue = kv_NoValue THEN
   RETURN "";
  ELSIF !KeyValue THEN
   RETURN " ।";
  ELSE
   IF xyz_IsSP() THEN
    IF Level = 1 THEN
     RETURN KeyValue;
    ELSIF Level = 2 THEN
     SEARCH(Route, Route, , KeyValue);
     RETURN Route.Route + " " + Route.Name;
    END;
   ELSE
    IF    Level = 1 THEN
     RETURN L_Str.PoolItem("樮|᪨|稥", L_Str.StrToScal(KeyValue));
    ELSIF Level = 2 THEN
     SEARCH(TKind, TKind, , KeyValue);
     RETURN TKind.TKind + " " + TKind.Name;
    ELSIF Level = 3 THEN
     RETURN KeyValue;
    END;
   END;
  END;
  L_General.ConsultToUs(0, "Tck10_GetKeyName.Error 123");
 END {Tck10_GetKeyName};

 PRIVATE PROCEDURE Tck10_GetPlan(): NUMERIC[2];
  VAR
   Result: NUMERIC[2];
 BEGIN
  Result:=0;
  IF wPlan & ~!Tck10.Route THEN
   SELECT(SEJ01, Route, , Tck10.Route);
   WHILE OCCURE(SEJ01) DO
    PROMPT(" "+" "+SEJ01.Route);
    CONFORM(SEJ01, StExit);
    IF ~StExit.Suppl THEN
     INC(Result, SEJ01.IncPlan);
    END;
    NEXT(SEJ01);
   END; (* WHILE OCCURE(SEJ01) ... *)
  END;
  RETURN Result;
 END {Tck10_GetPlan};

 PRIVATE PROCEDURE E_NeedDlmLine(): SCAL[2];
  VAR
   local: PROC;
 BEGIN
  local:=PROCREF(E_Utils.Tck10_NeedDlmLine);
  IF ~!local THEN
   RETURN local();
  ELSE
   RETURN 0;
  END;
 END {E_NeedDlmLine};

 PRIVATE PROCEDURE GetRoute(): STRING[];
  VAR
   Char,
   _Sign,
   _Route: STRING[];
   i     : NUMERIC[0];
 BEGIN
  SETEMPTY(_Route);
  _Sign:=Str.Cap(GetExitClssSign());
  i:=0;
  LOOP
   Char:=L_Str.Char(_Sign, i);
   IF !Char THEN
    EXIT;
   END;
   IF ~L_Str.TestStrAlowChar(Char, "09") &
      ~L_Str.TestStrAlowChar(Char, "AZ") &
      ~L_Str.TestStrAlowChar(Char, "") THEN
    RETURN _Route;
   END;
   _Route:=_Route+Char;
   INC(i);
  END; (* LOOP *)
  RETURN _Route;
 END {GetRoute};

 PRIVATE PROCEDURE MakeSupplement();
  VAR
   T_Fact,
   T_Plan: NUMERIC[2];
   _Route: STRING[];
 BEGIN
  MAKEPART(R, Tck10_SupplBot);
  SELECT(Suppl, Suppl, , Tck10.MyFirm);
  WHILE OCCURE(Suppl) DO
   _Route:=GetRoute();
   SETZERO(T_Fact, T_Plan);
   NARROWSEL(Suppl, Dprt, Sort);
   SEARCH(Sort, Sort, , Suppl.Sort);
   MAKEPART(R, Tck10_SupplSortTop);
   WHILE OCCURE(Suppl) DO
    SEARCH(TckRcS, TckRcS, , Suppl.TckRcS);
    CONFORM(TckRcS, Staff, Man);
    GetCarInf();
    MAKEPART(R, Tck10_SupplLine);
    INC(T_Plan, Suppl.Plan);
    INC(T_Fact, Suppl.Fact);
    NEXT(Suppl);
    IF OCCURE(Suppl) & E_NeedDlmLine() & (GetRoute() # _Route) THEN
     MAKEPART(R, DlmLine);
     _Route:=GetRoute();
    END;
   END; (* WHILE OCCURE(Suppl) ... *)
   LAST(Suppl);
   MAKEPART(R, Tck10_SupplSortBot, T_Plan, T_Fact, T_Fact-T_Plan);
   NEXTINEXTENDEDSEL(Suppl, Dprt, Sort);
  END; (* WHILE OCCURE(Suppl) ... *)
 END {MakeSupplement};

 PRIVATE PROCEDURE GetPlanForTckRcS(): NUMERIC[2];
  VAR
   _Plan: NUMERIC[2];
   i    : NUMERIC[0];
 BEGIN
  _Plan:=0;
  TRY
   IF wPlan THEN
    i:=0;
    WHILE i <= HIGH(TckRcS.asRWayS) DO
     IF ~!TckRcS.asRWayS[i] & SEARCH(RWayS, RWayS, TckRcS.asRWayS[i]) THEN
      INC(_Plan, L_Way.GetIncomePlanForTRS());
     END;
     INC(i);
    END;
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  RETURN _Plan;
 END {GetPlanForTckRcS};

 PRIVATE PROCEDURE Tck10_PrintTotal(Level     : NUMERIC[0];
                            keyValue  : STRING[];
                            TotalName : STRING[];
                            Total     : tTotals;
                            VAR addTo : tTotals);
  VAR
   ObjectName: STRING[];
 BEGIN
  ObjectName:=Tck10_GetKeyName(Level, keyValue);
  IF ~!ObjectName THEN
   IF ~!TotalName THEN
    MAKEPART(R, Tck10_Delim);
    ObjectName:=TotalName + " " + ObjectName;
   END;
   MAKEPART(R, Tck10_Line,
            ObjectName,
            Total[planIdx],
            Total[L_Way.trs_Driver],
            Total[L_Way.trs_Guard],
            Total[L_Way.trs_Chopper],
            Total[totalIdx],
            Total[totalIdx]-Total[planIdx]);
  END;
  INC(addTo[L_Way.trs_Driver],  Total[L_Way.trs_Driver]);
  INC(addTo[L_Way.trs_Guard],   Total[L_Way.trs_Guard]);
  INC(addTo[L_Way.trs_Chopper], Total[L_Way.trs_Chopper]);
  INC(addTo[totalIdx],          Total[totalIdx]);
  INC(addTo[planIdx],           Total[planIdx]);
 END {Tck10_PrintTotal};

 PUBLIC PROCEDURE Tck10();
  CONST
   RepName     = "Tck10";
  VAR
   D          : DATE;
   byTckRcS   : LIKE(TckRcT.ExpSum);
   grTotal,
   l1Total,
   l2Total,
   l3Total    : tTotals;
   missedCount: NUMERIC[0][100];
   summaryMsg : STRING[];
   kvL1,
   kvL2,
   kvL3       : STRING[];
   _ExitClss  : LIKE(ExitClss.ExitClss);
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  wPlan:=1;
  D:=Memo.ud_cd();
  L_AFM.MakeMultipleIndex("Tck10", "MyFirm: LIKE(MyFirm.MyFirm);"+
                                   "kvL1  : STRING[16];"+
                                   "kvL2  : STRING[16];"+
                                   "kvL3  : STRING[16];"+
                                   "Route : LIKE(Route.Route);"+
                                   "Total : NUMERIC[2][5](*tTotal)*)",
                          "k123: MyFirm, kvL1, kvL2, kvL3, Route");

  L_AFM.MakeMultipleIndex("Suppl", "MyFirm  : LIKE(MyFirm.MyFirm);"+
                                   "Sort    : LIKE(Sort.Sort);"+
                                   "Dprt    : LIKE(Sort.Sort);"+
                                   "ExitClss: LIKE(ExitClss.ExitClss);"+
                                   "TckRcS  : LIKE(TckRcS.TckRcS);"+
                                   "Plan    : NUMERIC[2];"+
                                   "Fact    : NUMERIC[2]",
                          "Suppl: MyFirm, Dprt, Sort, ExitClss, TckRcS");
  L_AFM.MakeIndex("rout1", "Route : LIKE(Route.Route)");
  IF wPlan THEN
   D_TP._PrepareSEJ01(D, D, 0, 1);
  END;
  SETZERO(missedCount);
  SELECT(TckRcS, Date, , D);
  WHILE OCCURE(TckRcS) DO
   PROMPT(TckRcS.TckRcS);
   CONFORM(TckRcS, Staff);
   IF TckRcS.Status >= L_TRS.trsStat_Taken THEN
    byTckRcS:=0;
    SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
    WHILE OCCURE(TckRcT) DO
     CONFORM(TckRcT, TckKind);
     IF (TckKind.InSale = L_TRS.tks_Sales) | (TckKind.InSale = L_TRS.tks_CashlessSales) THEN
      INC(byTckRcS, TckRcT.ExpSum - TckRcT.RSum);
     END;
     NEXT(TckRcT);
    END; (* WHILE OCCURE(TckRcT) ... *)
    Tck10_AccessKeyValues(D, kvL1, kvL2, kvL3, _ExitClss);
    SELECT(rout1, rout1);
    IF ~ADD(Tck10, k123, Staff.MyFirm, kvL1, kvL2, kvL3, rout1.Route) THEN
     SETZERO(Tck10.Total);
    END;
    INC(Tck10.Total[TckRcS.AsWho], byTckRcS);
    INC(Tck10.Total[totalIdx],  byTckRcS);
    REPLACE(Tck10);
    WHILE NEXT(rout1) DO
     SEARCH(Route, Route, , rout1.Route);
     _Tck10_AccessKeyValues(D, kvL1, kvL2);
     IF ~ADD(Tck10, k123, Staff.MyFirm, kvL1, kvL2, kvL3, rout1.Route) THEN
      SETZERO(Tck10.Total);
      REPLACE(Tck10);
     END;
    END;
    CONFORM(TckRcS, Staff);
    HISTCONF(TckRcS.Date, Staff, StaffLog);
    CONFORM(StaffLog, Officer);
    ADD(Suppl, Suppl, , Staff.MyFirm, L_Staff.getDepart(), Officer.Sort, _ExitClss, TckRcS.TckRcS,
                        Suppl.Plan, GetPlanForTckRcS(),
                        Suppl.Fact, byTckRcS);
   ELSE
    INC(missedCount[Staff.MyFirm]);
   END;
   NEXT(TckRcS);
  END; (* WHILE OCCURE(TckRcS) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  SELECT(Tck10, k123);
  WHILE OCCURE(Tck10) DO
   NARROWSEL(Tck10, MyFirm);
   MAKEPART(R, Tck10_Top, RepName, D);
   SETZERO(grTotal);
   WHILE OCCURE(Tck10) DO
    SETZERO(l1Total);
    NARROWSEL(Tck10, kvL1);
    IF Tck10.kvL2 # kv_NoValue THEN
     MAKEPART(R, Tck10_Delim);
    END;
    WHILE OCCURE(Tck10) DO
     SETZERO(l2Total);
     NARROWSEL(Tck10, kvL2);
     WHILE OCCURE(Tck10) DO
      SETZERO(l3Total);
      NARROWSEL(Tck10, kvL3);
      WHILE OCCURE(Tck10) DO
       Tck10.Total[planIdx]:=Tck10_GetPlan();
       Tck10_PrintTotal(4, kv_NoValue, "", Tck10.Total, l3Total);
       NEXT(Tck10);
      END; (* WHILE OCCURE(Tck10) 4 *)
      LAST(Tck10);
      Tck10_PrintTotal(3, Tck10.kvL3, "", l3Total, l2Total);
      NEXTINEXTENDEDSEL(Tck10, kvL3);
     END; (* WHILE OCCURE(Tck10) 3 *)
     LAST(Tck10);
     Tck10_PrintTotal(2, Tck10.kvL2, Str.Condense(L_Str.PoolItem(" | ᥣ", Tck10.kvL3 # kv_NoValue)), l2Total, l1Total);
     NEXTINEXTENDEDSEL(Tck10, kvL2);
     IF OCCURE(Tck10) & (Tck10.kvL3 # kv_NoValue) THEN
      MAKEPART(R, Tck10_Delim);
     END;
    END; (* WHILE OCCURE(Tck10) 2 *)
    LAST(Tck10);
    Tck10_PrintTotal(1, Tck10.kvL1, Str.Condense(L_Str.PoolItem(" |ᥣ", Tck10.kvL2 # kv_NoValue)), l1Total, grTotal);
    NEXTINEXTENDEDSEL(Tck10, kvL1);
   END; (* WHILE OCCURE(Tck10) 2 *)
   LAST(Tck10);
   summaryMsg:="⮣";
   IF missedCount[Tck10.MyFirm] > 0 THEN
    summaryMsg:=summaryMsg + "( " + L_Str.IntStr(missedCount[Tck10.MyFirm]) + " !)";
   END;
   Tck10_PrintTotal(0, "", summaryMsg, grTotal, grTotal);
   MakeSupplement();
   MAKEPART(R, Tck10_Bot);
   NEXTINEXTENDEDSEL(Tck10, MyFirm);
  END; (* WHILE OCCURE(Tck10) 1 *)
  CLOSEREP(R);
  LIKEMENU(Survey, "");
 END {Tck10};

END.
