(*
%Copyright   (c) Polak Computer System
%Author      09.04.2001 12:05:33 GINA
%Purpose       
%Type        report
%Specific    AP
%Modified    27.08.2014 18:01:05 POLAK\GAV
%Environment
*)

 MODULE Tck20 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_DatTim, L_Way, Memo, L_TRS,
        Math, L_Stock, L_Str, L_Acnt, L_XDoc, L_AFM, L_CUC,
        P_Man, P_Firm, L_Staff, L_TRSP, L_Events, P_OwnData,
        L_StdFrm;

 CONST
  RepNameForUI = "DifTs"; (* uip1.asl *)

  rt_AllStrgMov     = 0;
  rt_SnglStrgMov    = 1;
  rt_AllStrgInv     = 2;
  rt_SnglTckKindMov = 3;

 VAR
  sByTck     : NUMERIC[2];
  Total      : L_Acnt.tAcntVector;
  lastStorage: LIKE(Storage.Storage);
  Tck20_fr,
  Tck20_ut   : DATE;
  RT         : SCAL[4];
  curTckKind : LIKE(TckKind.TckKind);

 PRIVATE PROCEDURE CountWithdrawal(av: L_Acnt.tAcntVector): NUMERIC[2];
 BEGIN
  IF !av[L_Acnt.avp_InSaldo] THEN
   RETURN L_General.EMPTY_NUMBER();
  ELSE
   RETURN av[L_Acnt.avp_InSaldo] + av[L_Acnt.avp_Credit] - av[L_Acnt.avp_Debit] - av[L_Acnt.avp_OutSaldo];
  END;
 END {CountWithdrawal};

(*
$P{ TopAll:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|        誨    ਮ  ##########  ##########       |
}
*)

(*
$P{ Top:
P_Firm.FP_FirmName(P_Firm.fomf(Staff.MyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
Staff.TSN, L, ""
Man.Name, L, ""
@
############################################################# ########## #####
=#####========================================================================
|        窠 ࠡ⭨   த ஥ 㬥⮢ ()        |
|                     ਮ  ##########  ##########                    |
|----------------------------------------------------------------------------|
|⭨ ##### #############################################################|
}
*)

(*
$P{ TopLAll:
Staff.TSN, L, ""
Man.Name, L, ""
@
|----------------------------------------------------------------------------|
|⭨ ##### #############################################################|
}
*)

(*
$P{ TopL:
@
|----------------------------------------------------------------------------|
| |    |||         |    묨|    |      誨|
|-----|-------|--|---|-------------|-------------|-------------|-------------|
}
*)

(*
$P{ Line:
TckRcS.Date, L, "D.N"
TckRcS.TckRcS, L, ""
?, C, " |"
?, C, " |"
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
@
|#####|#######|##|###|#############|#############|#############|#############|
}
*)

(*
$P{ BotL:
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
@
|--------------------|-------------|-------------|-------------|-------------|
|⮣  ࠡ⭨  |#############|#############|#############|#############|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

(*
$P{ BotAll:
?, R, "2-"
?, R, "2-"
@
|------------------------------------------------|-------------|-------------|
|⮣                                           |#############|#############|
=(c) Polak====================================================================
}
*)

(*
$P{ MovTKTop:
?, C, ""
@
|----------------------------------------------------------------------------|
|            ⭮-ᠫ줮  ⭮ த樨 ()            |
|############################################################################|
|----------------------------------------------------------------------------|
| |/|    |       |/             |..|      㬬|
|-----|---|-------|------------|------------------------|--------|-----------|
}
*)

(*
$P{ MovTKLine:
?, L, ""
?, L, ""
?, L, ""
TckKind.TckKind, L, ""
TckKind.FaceVal, R, "2-"
CUCopy.Serial, L, ""
?, R, ""
?, R, ",2-"
@
|#####|###|#######|#### #######|########################|########|###########|
}
*)

(*
$P{ TotalTKBot:
Total[L_Acnt.avp_InSaldo], R, ",2-"
Total[L_Acnt.avp_Credit], R, ",2-"
CountWithdrawal(Total), R, ",2-"
Total[L_Acnt.avp_Debit], R, ",2-"
Total[L_Acnt.avp_OutSaldo], R, ",2-"
@
|----------------------------------------------------------------------------|
|⮣:                                            줮        ############|
|                                                  祭      ############|
|                                                  室 ############|
|                                                           ############|
|                                                  줮        ############|
}
*)

(*
$P{ MovTKBot:
@
=(c) Polak====================================================================
}
*)

(*
$P{ MathTop21:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Tck20_fr, L, "D.N.y"
Tck20_ut, L, "D.N.y"
Tck20_fr, L, "D.N.y"
Tck20_ut + 1, L, "D.N.y"
@
######################################################################################################################################################## ########## #####
=#####===================================================================================================================================================================
|                                            ⭮ த樨 ()    ਮ  ##########  ##########                                           |
|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|                                             |  줮  ########## |        祭        |         த        |                  |  줮  ########## |
|  ()                                 |-----------------------|------------------------|------------------------|-----------------------|-----------------------|
|                                             |        㬬|         㬬|         㬬|        㬬|        㬬|
}
*)

(*
$P{ StrgTop21:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Tck20_fr, L, "D.N.y"
Tck20_ut, L, "D.N.y"
Tck20_fr, L, "D.N.y"
Tck20_ut + 1, L, "D.N.y"
@
######################################################################################################################################################## ########## #####
=#####===================================================================================================================================================================
|                                            ⭮ த樨 ()    ਮ  ##########  ##########                                           |
|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|                |                            |  줮  ########## |        祭        |      室     |                  |  줮  ########## |
| ࠭  |⭨                    |-----------------------|------------------------|------------------------|-----------------------|-----------------------|
|                |                            |                㬬|                 㬬|                 㬬|                㬬|                㬬|
|----------------|----------------------------|-----------------------|------------------------|------------------------|-----------------------|-----------------------|
}
*)

(*
$P{ StrgTop27:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
TckKind.TckKind, L, ""
TckKind.Name, L, ""
Tck20_fr, L, "D.N.y"
Tck20_ut, L, "D.N.y"
Tck20_fr, L, "D.N.y"
Tck20_ut + 1, L, "D.N.y"
@
######################################################################################################################################################## ########## #####
=#####===================================================================================================================================================================
|                                   #### ################################    ਮ  ##########  ##########                              |
|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|                |                            |  줮  ########## |        祭        |      室     |                  |  줮  ########## |
| ࠭  |⭨                    |-----------------------|------------------------|------------------------|-----------------------|-----------------------|
|                |                            |        㬬|         㬬|         㬬|        㬬|        㬬|
|----------------|----------------------------|-----------------------|------------------------|------------------------|-----------------------|-----------------------|
}
*)

(*
$P{ StrgLine21:
Storage.Storage, L, ""
Storage.Name, L, ""
?, L, ""
?, L, ""
Storg.Sum[L_Acnt.avp_InSaldo], R, ",2-"
Storg.Sum[L_Acnt.avp_Credit], R, ",2-"
CountWithdrawal(Storg.Sum), R, ",2-"
Storg.Sum[L_Acnt.avp_Debit], R, ",2-"
Storg.Sum[L_Acnt.avp_OutSaldo], R, ",2-"
@
|##### ##########|##### ######################|#######################|########################|########################|#######################|#######################|
}
*)

(*
$P{ StrgLine27:
Storage.Storage, L, ""
Storage.Name, L, ""
?, L, ""
?, L, ""
Storg.PckAmn[L_Acnt.avp_InSaldo], R, "0"
Storg.Amount[L_Acnt.avp_InSaldo], R, "0"
Storg.Sum[L_Acnt.avp_InSaldo], R, ",2-"
Storg.PckAmn[L_Acnt.avp_Credit], R, "0"
Storg.Amount[L_Acnt.avp_Credit], R, "0"
Storg.Sum[L_Acnt.avp_Credit], R, ",2-"
CountWithdrawal(Storg.PckAmn), R, "0"
CountWithdrawal(Storg.Amount), R, "0"
CountWithdrawal(Storg.Sum), R, ",2-"
Storg.PckAmn[L_Acnt.avp_Debit], R, "0"
Storg.Amount[L_Acnt.avp_Debit], R, "0"
Storg.Sum[L_Acnt.avp_Debit], R, ",2-"
Storg.PckAmn[L_Acnt.avp_OutSaldo], R, "0"
Storg.Amount[L_Acnt.avp_OutSaldo], R, "0"
Storg.Sum[L_Acnt.avp_OutSaldo], R, ",2-"
@
|##### ##########|##### ######################|#### ####### ##########|#### ####### ###########|#### ####### ###########|#### ####### ##########|#### ####### ##########|
}
*)

(*
$P{ StrgBot21:
@
=(c) Polak===============================================================================================================================================================
}
*)

(*
$P{ MathLine21:
Math.Math, L, ""
Math.Name, L, ""
Mov01.PckAmn[L_Acnt.avp_InSaldo], R, "0"
Mov01.Amount[L_Acnt.avp_InSaldo], R, "0"
Mov01.Sum   [L_Acnt.avp_InSaldo], R, "2-"
Mov01.PckAmn[L_Acnt.avp_Credit], R, "0"
Mov01.Amount[L_Acnt.avp_Credit], R, "0"
Mov01.Sum   [L_Acnt.avp_Credit], R, "2-"
CountWithdrawal(Mov01.PckAmn), R, "0"
CountWithdrawal(Mov01.Amount), R, "0"
CountWithdrawal(Mov01.Sum)   , R, "2-"
Mov01.PckAmn[L_Acnt.avp_Debit], R, "0"
Mov01.Amount[L_Acnt.avp_Debit], R, "0"
Mov01.Sum   [L_Acnt.avp_Debit], R, "2-"
Mov01.PckAmn[L_Acnt.avp_OutSaldo], R, "0"
Mov01.Amount[L_Acnt.avp_OutSaldo], R, "0"
Mov01.Sum   [L_Acnt.avp_OutSaldo], R, "2-"
@
|---------------------------------------------|-----------------------|------------------------|------------------------|-----------------------|-----------------------|
|##### #######################################|#### ####### ##########|#### ####### ###########|#### ####### ###########|#### ####### ##########|#### ####### ##########|
}
*)

(*
$P{ MathBot21:
Total[L_Acnt.avp_InSaldo], R, ",2-"
Total[L_Acnt.avp_Credit], R, ",2-"
CountWithdrawal(Total), R, ",2-"
Total[L_Acnt.avp_Debit], R, ",2-"
Total[L_Acnt.avp_OutSaldo], R, ",2-"
@
|---------------------------------------------|-----------------------|------------------------|------------------------|-----------------------|-----------------------|
|⮣                                        |#######################|########################|########################|#######################|#######################|
=(c) Polak===============================================================================================================================================================
}
*)

 PRIVATE PROCEDURE IsAllStrgMov(): SCAL[2];
 BEGIN
  RETURN (RT = rt_AllStrgMov) | (RT = rt_SnglTckKindMov);
 END {IsAllStrgMov};

 PRIVATE PROCEDURE AddMov01(avp    : L_Acnt.tAcntVectorPart;
                            _PckAmn: NUMERIC[0];
                            _Amount: NUMERIC[0];
                            _Sum   : NUMERIC[2]);
  VAR
   OcMov01,
   OcStorg : SCAL[2];
 BEGIN
  ADD(Mov01, Mov01, OcMov01, Storage.MyFirm, TckKind.Math,
                      Mov01.Amount[avp], _Amount,
                      Mov01.Sum   [avp], _Sum);
  ADD(Storg, Storg, OcStorg, Storage.MyFirm, Storage.Storage,
                     Storg.Sum[avp], _Sum);
  IF ~L_TRS.IsBulk() THEN
   IF ~OcMov01 THEN
    SETZERO(Mov01.PckAmn);
   END;
   INC(Mov01.PckAmn[avp], _PckAmn);
   REPLACE(Mov01);
   IF RT = rt_SnglTckKindMov THEN
    IF ~OcStorg THEN
     SETZERO(Storg.PckAmn);
    END;
    INC(Storg.PckAmn[avp], _PckAmn);
    INC(Storg.Amount[avp], _Amount);
    REPLACE(Storg);
   END;
  END;
 END {AddMov01};

 VAR
  LineCnt: NUMERIC[0];

 PRIVATE PROCEDURE Tck20_PrintSingleLine(D       : DATE;
                                         _TckRcD : LIKE(TckRcD.TckRcD);
                                         avt     : L_Acnt.tAcntVectorPart;
                                         _RestNbr: LIKE(TckRcDL.RestNbr);
                                         First   : SCAL[2]);
  VAR
   Amount,
   Cir         : NUMERIC[2];
   RestNbrAsStr: STRING[];
 BEGIN
  IF L_TRS.IsBulk() THEN
   Amount:=_RestNbr;
   RestNbrAsStr:=L_Str.IntStr(Amount);
  ELSE
   Amount:=Math.Abs(_RestNbr-L_TRS.PackLastNbr(TckKind.TckKind, _RestNbr));
   RestNbrAsStr:=L_Str.FixedIntStr(_RestNbr, TckKind.NbrPrc);
  END;
  Cir:=Amount * TckKind.FaceVal;
  IF    IsAllStrgMov() THEN
   AddMov01(avt, 1, Amount, Cir);
  ELSIF RT = rt_SnglStrgMov THEN
   MAKEPART(R, InvStrgLine, RestNbrAsStr, Cir);
   INC(Total[avt], Cir);
  ELSIF RT = rt_AllStrgInv THEN
   IF LineCnt = 0 THEN
    IF OCCURE(StaffLog) & (~L_Staff.IsDischargeStaffLog()) THEN
     CONFORM(StaffLog, Officer, Post);
     MAKEPART(R, atbStrgTop, Post.Name);
    ELSE
     MAKEPART(R, atbStrgTop, "  ");
    END;
   END;
   INC(LineCnt);
   MAKEPART(R, atbStrgLine, RestNbrAsStr, Cir);
   INC(Total[avt], Cir);
  ELSE
   INC(Total[avt], Cir);
   IF lastStorage # Storage.Storage THEN
    MAKEPART(R, MovTKTop, "⭠ 㬪: " + Storage.Storage + " " + Storage.Name);
    lastStorage:=Storage.Storage;
   END;
   IF First THEN
    MAKEPART(R, MovTKLine, FLDTOSTR(D, "D.N"), L_Str.PoolItem("|||", avt), _TckRcD,
             RestNbrAsStr, Cir);
   ELSE
    MAKEPART(R, MovTKLine, "", "", "",
             RestNbrAsStr, Cir);
   END;
  END;
 END {Tck20_PrintSingleLine};

 PRIVATE PROCEDURE Tck20_OneTckRcD();
  VAR
   i     : NUMERIC[0];
   avt   : L_Acnt.tAcntVectorPart;
 BEGIN
  IF (TckRcD.Type # L_TRS.trdt_Inventory) &
     (TckRcD.Status # L_TRS.trdStat_Canceled) &
     (Tck20_TckRcD_IsInIntvl() = 1) THEN
   IF    TckRcD.Type = L_TRS.trdt_Laying THEN
    avt:=L_Acnt.avp_Credit;
   ELSIF TckRcD.Type = L_TRS.trdt_Return THEN
    avt:=L_Acnt.avp_Debit;
   ELSE
    L_General.ConsultToUs(0, "Tck20_OneTckRcD.Error 123");
   END;
   i:=0;
   SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
   WHILE OCCURE(TckRcDL) DO
    IF (RT # rt_SnglTckKindMov) | (TckRcDL.TckKind = curTckKind) THEN
     CONFORM(TckRcDL, TckKind);
     IF ~L_TRS.IsDevice(TckKind.Type) & ~!TckRcDL.RestNbr THEN
      CONFORM(TckRcDL, CUCopy);
      IF L_TRS.IsBulk_wCUC() THEN
       Tck20_PrintSingleLine(TckRcD.Date, TckRcD.TckRcD, avt, L_TRS.BulkCUCAmount(), i = 0);
      ELSE
       Tck20_PrintSingleLine(TckRcD.Date, TckRcD.TckRcD, avt, TckRcDL.RestNbr, i = 0);
      END;
      INC(i);
     END;
    END;
    NEXT(TckRcDL);
   END; (* WHILE OCCURE(TckRcDL) ... *)
  END; (* IF (TckRcD.Type#... *)
 END {Tck20_OneTckRcD};

 PRIVATE PROCEDURE Tck20_TckRcD_IsInIntvl(): SCAL[3];
 BEGIN
  IF    TckRcD.Date < Tck20_fr THEN
   RETURN 0;
  ELSIF TckRcD.Date > Tck20_ut THEN
   RETURN 2;
  ELSE
   RETURN 1;
  END;
 END {Tck20_TckRcD_IsInIntvl};

 PRIVATE PROCEDURE Tck20_GetSaldo(D: DATE; MustBeIn: SCAL[2]; avt: L_Acnt.tAcntVectorPart);
  VAR
   pta       : L_TRS.tPackedTck[1E2];
   i, j      : NUMERIC[0];
   _Number   : LIKE(TckRcDL.RestNbr);
   _TckKind  : LIKE(TckRcDL.TckKind);
   _Series   : LIKE(TckRcDL.Series);
   _RestNbr  : LIKE(TckRcDL.RestNbr);
   _CUCopy   : LIKE(TckRcDL.CUCopy);
   _Psg      : LIKE(TckRcDL.Psg);
   isInIntvl : SCAL[3];
 BEGIN
  IF SELECT(TckRcD, Storage, Storage.Storage) THEN
   SRCINSEL(TckRcD, GE, , D);
   LOOP
    IF ~OCCURE(TckRcD) THEN
     L_TRS.GetStorageTckSummary(Storage.Storage, L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(), 1, pta);
     EXIT;
    END;
    isInIntvl:=Tck20_TckRcD_IsInIntvl();
    IF (isInIntvl = 2) | (isInIntvl = MustBeIn) THEN
     L_TRS.GetStorageTckSummary(Storage.Storage, TckRcD.TckRcS, TckRcD.TckRcD, 1, pta);
     EXIT;
    ELSE
     NEXT(TckRcD);
    END;
   END; (* LOOP *)
   i:=0; j:=0;
   WHILE ~!pta[i] DO
    IF L_TRS.pt_GetState(pta[i]) = L_TRS.ts_inBag THEN
     L_TRS.pt_Unpack(pta[i], _Number, _TckKind, _Series, _RestNbr, _CUCopy, _Psg);
     IF (RT # rt_SnglTckKindMov) | (_TckKind = curTckKind) THEN
      SEARCH(TckKind, TckKind, , _TckKind);
      IF ~L_TRS.IsDevice(TckKind.Type) THEN
       SEARCH(CUCopy, CUCopy, , _CUCopy);
       IF L_TRS.IsBulk_wCUC() THEN
        Tck20_PrintSingleLine(D, L_General.EMPTY_NUMBER(), avt, STRTOFLD(L_Str.AnyItem(pta[i], "|", 7), SCAL), j=0);
       ELSE
        Tck20_PrintSingleLine(D, L_General.EMPTY_NUMBER(), avt, _RestNbr, j=0);
       END;
      END;
     END;
     INC(j);
    END;
    INC(i);
   END;
  END (* IF SELECT(TckRcD, Storage, Storage.Storage) *);
 END {Tck20_GetSaldo};

 PRIVATE PROCEDURE Tck20_MovTK();
  VAR
   curD,
   endD : DATE;
 BEGIN
  L_General.Assert(OCCURE(Staff), " ⠭ ࠡ⭨");
  SETZERO(Total, lastStorage);
  Tck20_fr:=Memo.ud_fr();
  Tck20_ut:=Memo.ud_ut();
  SELECT(StrgLog, TSN, , Staff.TSN);
  WHILE OCCURE(StrgLog) DO
   CONFORM(StrgLog, Storage);
   IF (Storage.Type = L_Stock.st_TckBag) &
      L_DatTim.IsActiveInIntvl(Tck20_fr, Tck20_ut+1, StrgLog.Date, StrgLog.Till) THEN
    curD:=Math.Max(Tck20_fr, StrgLog.Date);
    IF ~!StrgLog.Till & (StrgLog.Till <= Tck20_ut) THEN
     endD:=StrgLog.Till-1;
     SAVE(StrgLog);
     CHANGESEL(StrgLog, Storage, , StrgLog.Storage);
     IF NEXT(StrgLog) & (StrgLog.TSN # Staff.TSN) THEN
      INC(endD);
     END;
     RESTORE(StrgLog);
    ELSE
     endD:=Tck20_ut;
    END;
    IF L_DatTim.IsActive(Tck20_fr, StrgLog.Date, StrgLog.Till) THEN
     Tck20_GetSaldo(Tck20_fr, 1, L_Acnt.avp_InSaldo);
    END;
    WHILE curD <= endD DO
     SELECT(TckRcD, Storage, , Storage.Storage, curD);
     WHILE OCCURE(TckRcD) DO
      PROMPT(" "+TckRcD.TckRcD);
      IF TckRcD.TSN = Staff.TSN THEN
       Tck20_OneTckRcD();
      END;
      NEXT(TckRcD);
     END; (* WHILE OCCURE(TckRcD) ... *)
     INC(curD);
    END; (* WHILE curD <=... *)
    IF L_DatTim.IsActive(Tck20_ut + 1, StrgLog.Date, StrgLog.Till) THEN
     Tck20_GetSaldo(Tck20_ut + 1, 0, L_Acnt.avp_OutSaldo);
    END;
   END;
   NEXT(StrgLog);
  END; (* WHILE OCCURE(StrgLog) ... *)
  IF ~!lastStorage THEN
   MAKEPART(R, TotalTKBot);
  END;
  MAKEPART(R, MovTKBot);
 END {Tck20_MovTK};

 PRIVATE PROCEDURE GetTckKindType(VAR KKM, TK: SCAL[2]);
 BEGIN
  SETZERO(KKM, TK);
  CONFORM(TckRcS, TckRcT);
  WHILE OCCURE(TckRcT) DO
   CONFORM(TckRcT, TckKind);
   IF    TckKind.Type = L_TRS.tkt_KKMActivities THEN
    KKM:=1;
   ELSIF (TckKind.Type = L_TRS.tkt_Ticket) | (TckKind.Type = L_TRS.tkt_PieceTck) THEN
    TK:=1;
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
 END {GetTckKindType};

 PRIVATE PROCEDURE Do(RepName: STRING[]; bySingleTSN: SCAL[2]);
  VAR
   _Over, _Under,
   sOver, sUnder,
   tOver, tUnder,
   sByCash,
   asTotTInc     : NUMERIC[2];
   StaffCnt      : NUMERIC[0];
   KKM, TK       : SCAL[2];
 BEGIN
  L_General.Assert(L_Way.E_TckRcLevel(Memo.ud_ut())>L_TRS.il_None,
                   "  ⠭  "+L_DatTim.DateStr(Memo.ud_ut()));
  SETEMPTY(RT);
  IF RepName # RepNameForUI THEN
   OPENREP(R, L_General.NameConnection(RepName), Create);
  END;
  IF bySingleTSN THEN
   L_General.Assert(ACCESS(Staff), " ࠭ ࠡ⭨");
   CONFORM(Staff, Man);
   MAKEPART(R, Top, RepName);
   SELECT(TckRcS, TSN, , Staff.TSN);
  ELSE
   MAKEPART(R, TopAll, RepName);
   SETZERO(tUnder, tOver); 
   SELECT(TckRcS, TSN);
  END;
  WHILE OCCURE(TckRcS) DO
   StaffCnt:=0;
   SETZERO(sByTck, sByCash, sUnder, sOver);
   CHANGESEL(TckRcS, TSN, , TckRcS.TSN);
   SRCINSEL(TckRcS, GE, , Memo.ud_fr());
   WHILE OCCURE(TckRcS) & (TckRcS.Date<=Memo.ud_ut()) DO
    PROMPT(TckRcS.TSN+" "+L_DatTim.DateStr(TckRcS.Date));
    IF TckRcS.Status >= L_TRS.trsStat_Taken THEN
     asTotTInc:=L_Way.GetAdjustedTckRcSTotTInc();
     IF bySingleTSN | (TckRcS.TotCash#asTotTInc) THEN
      IF StaffCnt = 0 THEN
       IF ~bySingleTSN THEN
        CONFORM(TckRcS, Staff, Man);
        MAKEPART(R, TopLAll);
       END;
       MAKEPART(R, TopL);
      END;
      SETEMPTY(_Under, _Over);
      IF asTotTInc > TckRcS.TotCash THEN
       _Under:=asTotTInc-TckRcS.TotCash;
       INC(sUnder, _Under);
      ELSIF asTotTInc < TckRcS.TotCash THEN
       _Over :=TckRcS.TotCash-asTotTInc;
       INC(sOver, _Over);
      END;
      IF bySingleTSN THEN
       INC(sByTck,  asTotTInc);
       INC(sByCash, TckRcS.TotCash);
      END;
      GetTckKindType(KKM, TK);
      MAKEPART(R, Line, TK, KKM, asTotTInc, TckRcS.TotCash, _Under, _Over);
      INC(StaffCnt);
     END;
    END; (* IF TckRcS.Status... *)
    NEXT(TckRcS);
   END; (* WHILE OCCURE(TckRcS) ... *)
   IF StaffCnt > 0 THEN
    MAKEPART(R, BotL, sByTck, sByCash, sUnder, sOver);
   END;
   LAST(TckRcS);
   IF ~bySingleTSN THEN
    INC(tUnder, sUnder);
    INC(tOver,  sOver);
    CHANGESEL(TckRcS, TSN);
   END;
   NEXT(TckRcS);
  END; (* WHILE OCCURE(TckRcS) ... *)
  IF bySingleTSN THEN
   IF L_Way.E_TckRcLevel(Memo.ud_fr())>=L_TRS.il_Full THEN
    Tck20_MovTK();
   ELSE
    MAKEPART(R, Bot);
   END;
  ELSE
   MAKEPART(R, BotAll, tUnder, tOver);
  END;
  IF RepName # RepNameForUI THEN
   CLOSEREP(R);
  END;
 END {Do};

 PUBLIC PROCEDURE Tck20();
 BEGIN
  Do("Tck20", 1);
  L_General.SurveyLastReport();
 END {Tck20};

 PRIVATE PROCEDURE Create_Mov();
 BEGIN
  CreateFILE(Mov01, "", "     ", "");

  CreateFIELD(Mov01, MyFirm, LIKE(MyFirm.MyFirm), "", "",  "", "", "");
  CreateFIELD(Mov01, Math,   LIKE(TckKind.Math), "", "",  "", "", "");
  CreateFIELD(Mov01, PckAmn, L_Acnt.tAcntVector, "", "", "", "", "");
  CreateFIELD(Mov01, Amount, L_Acnt.tAcntVector, "", "0", "", "⢮ ⮢", "");
  CreateFIELD(Mov01, Sum,    L_Acnt.tAcntVector, "", "0", "", "㬬", "");

  CreateINDEX(Mov01, Mov01, UNIQUE, "", "", MyFirm, Math);

  SetVersionOfFILE(Mov01, 0);
  L_AFM.AF_CreateTemp("Mov01", "Mov01");

  CreateFILE(Storg, "", "     㬪", "");

  CreateFIELD(Storg, MyFirm,  LIKE(MyFirm.MyFirm),   "", "",  "", "", "");
  CreateFIELD(Storg, Storage, LIKE(Storage.Storage), "", "",  "", " ࠭", "");
  CreateFIELD(Storg, Sum,     L_Acnt.tAcntVector,    "", "0", "", "㬬", "");
  CreateFIELD(Storg, PckAmn,  L_Acnt.tAcntVector, "", "", "", "", "");
  CreateFIELD(Storg, Amount,  L_Acnt.tAcntVector, "", "0", "", "⢮ ⮢", "");

  CreateINDEX(Storg, Storg, UNIQUE, "", "", MyFirm, Storage);

  SetVersionOfFILE(Storg, 0);
  L_AFM.AF_CreateTemp("Storg", "Storg");
 END {Create_Mov};

 PRIVATE PROCEDURE Tck21_MovTK_ByStrg(LinePart: STRING[]);
  VAR
   _TSN: LIKE(Staff.TSN);
 BEGIN
  WHILE OCCURE(Storg) DO
   IF (Storg.Sum[L_Acnt.avp_InSaldo]  # 0) |
      (Storg.Sum[L_Acnt.avp_Credit]   # 0) |
      (Storg.Sum[L_Acnt.avp_Debit]    # 0) |
      (Storg.Sum[L_Acnt.avp_OutSaldo] # 0) THEN
    SEARCH(Storage, Storage, , Storg.Storage);
    _TSN:=L_Stock.GetStorageFixedStaff(Storage.Storage, Memo.ud_ut());
    IF ~!_TSN THEN
     L_General.Assert(SEARCH(Staff, TSN, _TSN), " ࠢ筨  ࠡ⭨ "+_TSN);
     CONFORM(Staff, Man);
     MAKEPART(R, ^LinePart, Staff.TSN, L_Str.ShortName(Man.Name));
    ELSE
     MAKEPART(R, ^LinePart);
    END;
   END;
   NEXT(Storg);
  END; (* WHILE OCCURE(Storg) ... *)
 END {Tck21_MovTK_ByStrg};

 PRIVATE PROCEDURE Tck21_MovTK(RepName: STRING[]);
  VAR
   _MyFirm: LIKE(MyFirm.MyFirm);
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  Create_Mov();
  Tck20_fr:=Memo.ud_fr();
  Tck20_ut:=Memo.ud_ut();

  SELECT(Storage, TpStrg, , L_Stock.st_TckBag);
  WHILE OCCURE(Storage) DO
   PROMPT(" ࠭ "+Storage.Storage);
   IF SELECT(TckRcD, Storage, Storage.Storage) THEN
    Tck20_GetSaldo(Tck20_fr, 1, L_Acnt.avp_InSaldo);
  
    SELECT(TckRcD, Storage, , Storage.Storage);
    SRCINSEL(TckRcD, GE, , Tck20_fr);
    WHILE OCCURE(TckRcD) & (TckRcD.Date <= Tck20_ut) DO
     PROMPT(" ࠭ "+Storage.Storage+":  "+TckRcD.TckRcD);
     Tck20_OneTckRcD();
     NEXT(TckRcD);
    END; (* WHILE OCCURE(TckRcD) ... *)
 
    Tck20_GetSaldo(Tck20_ut + 1, 0, L_Acnt.avp_OutSaldo);
   END; (* IF SELECT(TckRcD... *)
   NEXT(Storage);
  END; (* WHILE OCCURE(Storage) ... *)

  SELECT(Mov01, Mov01);
  WHILE OCCURE(Mov01) DO
   NARROWSEL(Mov01, MyFirm);
   _MyFirm:=Mov01.MyFirm;
   SETZERO(Total);
   IF RT # rt_SnglTckKindMov THEN
    MAKEPART(R, MathTop21, P_Firm.FP_FirmName(P_Firm.fomf(_MyFirm), SYSDATE()), RepName);
   END;
   WHILE OCCURE(Mov01) DO
    IF RT # rt_SnglTckKindMov THEN
     SEARCH(Math, Math, , Mov01.Math);
     MAKEPART(R, MathLine21);
    END;
    INC(Total[L_Acnt.avp_InSaldo],  Mov01.Sum[L_Acnt.avp_InSaldo]);
    INC(Total[L_Acnt.avp_Credit],   Mov01.Sum[L_Acnt.avp_Credit]);
    INC(Total[L_Acnt.avp_Debit],    Mov01.Sum[L_Acnt.avp_Debit]);
    INC(Total[L_Acnt.avp_OutSaldo], Mov01.Sum[L_Acnt.avp_OutSaldo]);
    NEXT(Mov01);
   END; (* WHILE OCCURE(Mov01) ... *)
   SELECT(Storg, Storg, , _MyFirm);
   IF RT # rt_SnglTckKindMov THEN
    MAKEPART(R, MathBot21);
    FORMFEED(R);
    MAKEPART(R, StrgTop21, P_Firm.FP_FirmName(P_Firm.fomf(_MyFirm), SYSDATE()), RepName);
    Tck21_MovTK_ByStrg("StrgLine21");
    MAKEPART(R, StrgBot21);
   ELSE
    SEARCH(TckKind, TckKind, , curTckKind);
    MAKEPART(R, StrgTop27, P_Firm.FP_FirmName(P_Firm.fomf(_MyFirm), SYSDATE()), RepName);
    Tck21_MovTK_ByStrg("StrgLine27");
    MAKEPART(R, MathBot21);
   END;
   IF NEXTINEXTENDEDSEL(Mov01, MyFirm) THEN
    FORMFEED(R);
   END;
  END;
  L_AFM.AF_PurgeTemp("Mov01");
  L_AFM.AF_PurgeTemp("Storg");
  CLOSEREP(R);
 END {Tck21_MovTK};

 PUBLIC PROCEDURE Tck21();
 BEGIN
  RT:=rt_AllStrgMov;
  Tck21_MovTK("Tck21");
  L_General.SurveyLastReport();
 END {Tck21};

 PUBLIC PROCEDURE Tck27();
 BEGIN
  ACCESS(TckKind);
  L_General.Assert(L_TRS.IsBulk() | (TckKind.Type = L_TRS.tkt_Ticket),
                   "   ⮫쪮  ⮢  筮 ");
  curTckKind:=TckKind.TckKind;
  RT:=rt_SnglTckKindMov;
  Tck21_MovTK("Tck27");
  L_General.SurveyLastReport();
 END {Tck21};

(*
$P{ InvStrgTop:
P_Firm.FP_FirmName(P_Firm.fomf(Storage.MyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
Storage.Storage, L, ""
Storage.Name, L, ""
?, L, ""
?, L, ""
?, L, ""
@
############################################################# ########## #####
=#####========================================================================
|               ਧ樨 ⭮ 㬪  ##########               |
|----------------------------------------------------------------------------|
|⭠ 㬪 ####### #####################################################|
|⭨       #####   ################################### #################|
|============================================================================|
|         |                             |    孨     |           |
|⭮    |/                  |---------------------|      㬬|
|த樨   |                             |    |᪨|           |
}
*)

(*
$P{ InvStrgLine:
TckKind.TckKind, L, ""
TckKind.FaceVal, R, "2-"
CUCopy.Serial, L, ""
?, R, ""
?, R, ",2-"
@
|------------|-----------------------------|----------|----------|-----------|
|#### #######|#############################|##########|          |###########|
}
*)

(*
$P{ InvStrgBot:
Total[L_Acnt.avp_OutSaldo], R, ",2-"
?, R, ",2-"
?, L, ""
@
|------------|-----------------------------|----------|----------|-----------|
|            |                             |          |          |           |
|------------|-----------------------------|----------|----------|-----------|
|            |                             |          |          |           |
|------------|-----------------------------|----------|----------|-----------|
|            |                             |          |          |           |
|----------------------------------------------------------------------------|
|⮣                                                        ###############|
|============================================================================|
| 䮭                                            |###########|
|                                                                |-----------|
|                                                      ᪨|           |
|============================================================================|
|                                                                            |
|ᯮ⥫ _________________ ##############################################|
|                                                                            |
=(c) Polak====================================================================
}
*)

(*
$P{ atbTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
@
###################################################################### ########## #####
=#####=================================================================================
|           ﭨ    㬪    ##########           |
}
*)

(*
$P{ atbStrgTop:
Staff.TSN, L, ""
Man.Name, L, ""
?, L, ""
Storage.Storage, L, ""
Storage.Name, L, ""
@
|=====================================================================================|
|⭨       #####   #################################### #########################|
|⭠ 㬪 ####### ##############################################################|
|-------------------------------------------------------------------------------------|
| ⭮ த樨               |/     |.||      㬬|
}
*)

(*
$P{ atbStrgLine:
TckKind.TckKind, L, ""
TckKind.Name, L, ""
CUCopy.Serial, L, ""
?, R, ""
TckKind.FaceVal, R, "2-"
?, R, ",2-"
@
|-------------------------------------|----------------|----------|-------|-----------|
|#### ################################|################|##########|#######|###########|
}
*)

(*
$P{ atbStrgBot:
Total[L_Acnt.avp_OutSaldo], R, ",2-"
L_Str.ShortName(Man.Name), L, ""
@
|-------------------------------------------------------------------------------------|
|⮣                                                                 ###############|
|                                                                                     |
|            ⭮  _________________ ##############################|
}
*)

(*
$P{ atbBot:
?, R, ",2-"
@
|-------------------------------------------------------------------------------------|
|⮣  ।                                                #################|
=(c) Polak=============================================================================
}
*)

 PRIVATE PROCEDURE SnglStrg();
  CONST
   RepName = "Tck22";
  VAR
   OnDate  : DATE;
   fixedTSN: LIKE(Staff.TSN);
   SubsidiaryMoney: NUMERIC[2];

 BEGIN
  RT:=rt_SnglStrgMov;
  L_General.Assert(ACCESS(Storage), " ⠭  ࠭");
  L_General.Assert(Storage.Type = L_Stock.st_TckBag, "࠭  ࠭   ⭮ 㬪");
  OnDate:=SYSDATE();
  L_General.Assert(L_DatTim.IsActive(OnDate, Storage.Begin, Storage.Till),
                   "࠭  ࠭  ");

  fixedTSN:=L_Stock.GetStorageFixedStaff(Storage.Storage, OnDate);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF ~!fixedTSN THEN
   L_General.CallUs(SEARCH(Staff, TSN, fixedTSN));
   CONFORM(Staff, Man);
   HISTCONF(OnDate, Staff, StaffLog);
   IF OCCURE(StaffLog) & (~L_Staff.IsDischargeStaffLog()) THEN
    CONFORM(StaffLog, Officer, Post);
    MAKEPART(R, InvStrgTop, RepName, OnDate, fixedTSN, Man.Name, Post.Name);
   ELSE
    MAKEPART(R, InvStrgTop, RepName, OnDate, fixedTSN, Man.Name, "  ");
   END;
   SubsidiaryMoney:=L_TRSP.E_GetSubsidiaryMoney(OnDate);
  ELSE
   MAKEPART(R, InvStrgTop, RepName, OnDate);
   SETEMPTY(SubsidiaryMoney);
  END;
  SETZERO(Total);
  Tck20_GetSaldo(OnDate + 1, 0, L_Acnt.avp_OutSaldo);
  MAKEPART(R, InvStrgBot, SubsidiaryMoney, "(" + P_Man.GetFullNameOfCurrentUser(OnDate) + ")");
  CLOSEREP(R);
 END {SnglStrg};

 PUBLIC PROCEDURE Tck22();
 BEGIN
  SnglStrg();
  L_General.SurveyLastReport();
 END {Tck22};

 PUBLIC PROCEDURE SnglCUCopy();
 BEGIN
  L_General.Assert(ACCESS(CUCopy), " ⠭ ");
  L_General.Assert(L_CUC.cucRole_IsTckBag(), "࠭    ⭮ 㬪");
  CONFORM(CUCopy, Storage);
  Tck22();
 END {SnglCUCopy};

 PUBLIC PROCEDURE Tck25();
  CONST
   RepName = "Tck25";
  VAR
   OnDate: DATE;
   tot   : NUMERIC[2];
 BEGIN
  RT:=rt_AllStrgInv;
  L_AFM.MakeIndex("strgs", "TSN: LIKE(Staff.TSN); Storage: LIKE(Storage.Storage)");
  OnDate:=Memo.ud_cd();
  SELECT(Storage, TpStrg, , L_Stock.st_TckBag);
  WHILE OCCURE(Storage) DO
   PROMPT(Storage.Storage);
   IF L_DatTim.IsActive(OnDate, Storage.Begin, Storage.Till) THEN
    ADD(strgs, strgs, , L_Stock.GetStorageFixedStaff(Storage.Storage, OnDate), Storage.Storage);
   END;
   NEXT(Storage);
  END; (* WHILE OCCURE(Storage) ... *)

  Tck20_fr:=OnDate;
  Tck20_ut:=OnDate;
  tot:=0;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, atbTop, RepName, OnDate);
  SELECT(strgs, strgs);
  WHILE OCCURE(strgs) DO
   IF ~!strgs.TSN THEN
    PROMPT(strgs.TSN);
    L_General.CallUs(SEARCH(Staff, TSN, strgs.TSN));
    L_General.CallUs(SEARCH(Storage, Storage, strgs.Storage));
    CONFORM(Staff, Man);
    HISTCONF(OnDate, Staff, StaffLog);
    SETZERO(Total, LineCnt);
    Tck20_GetSaldo(OnDate + 1, 0, L_Acnt.avp_OutSaldo);
    IF LineCnt # 0 THEN
     MAKEPART(R, atbStrgBot);
     INC(tot, Total[L_Acnt.avp_OutSaldo]);
    END;
   END;
   NEXT(strgs);
  END; (* WHILE OCCURE(strgs) ... *)
  MAKEPART(R, atbBot, tot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {Tck25};

 PUBLIC PROCEDURE DifTc();
 BEGIN
  Do("DifTc", 0);
  L_General.SurveyLastReport();
 END {DifTc};

 PUBLIC PROCEDURE DifTs();
 BEGIN
  Do(RepNameForUI, 1);
 END {DifTs};

(*
$P{ Tck26_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|                         |                            |                                   |     |  室   |
|⭠ 㬪           |⭨                    |                              |-|-----------|
|                         |                            |                                   |     |।|.|
|-------------------------|----------------------------|-----------------------------------|-----|-----|-----|
}
*)

(*
$P{ Tck26_Line:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
TckKind.TckKind, L, ""
TckKind.Name, L, ""
Tck26.Rest, R, "0"
Tck26.AmntTot / Tck26.TRSCnt, R, "0"
Tck26.Amnt, R, "0"
@
|####### #################|##### ######################|#### ##############################|#####|#####|#####|
}
*)

(*
$P{ Tck26_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PUBLIC PROCEDURE intTck26(trgStorage: LIKE(Storage.Storage));
  CONST
   LastDays = 10;
   Coef     = 1.1;
   RepName  = "Tck26";
  VAR
   fixedTSN: LIKE(Staff.TSN);
   Amount  : NUMERIC[0];
   Sum  : NUMERIC[2];
   pta     : L_TRS.tPackedTck[1E2];
   i       : NUMERIC[0];
   curNumber : LIKE(TckRcDL.RestNbr);
   curTckKind: LIKE(TckRcDL.TckKind);
   curSeries : LIKE(TckRcDL.Series);
   curRestNbr: LIKE(TckRcDL.RestNbr);
   curCUCopy : LIKE(TckRcDL.CUCopy);
   curPsg    : LIKE(TckRcDL.Psg);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AFM.MakeMultipleIndex("Tck26", "Storage: LIKE(Storage.Storage);" +
                                   "TSN:     LIKE(Staff.TSN);" +
                                   "TckKind: LIKE(TckKind.TckKind);" +
                                   "Amnt   : NUMERIC[0];" +
                                   "AmntTot: NUMERIC[0];" +
                                   "TRSCnt : NUMERIC[0];" +
                                   "Rest   : NUMERIC[0]",
                            "Storage: Storage, TSN, TckKind");
  L_AFM.MakeMultipleIndex("tmp26", "TckKind: LIKE(TckKind.TckKind);" +
                                   "Amnt   : NUMERIC[0]",
                            "TckKind: TckKind");
  IF !trgStorage THEN
   SELECT(TckRcS, Storage);
  ELSE
   SELECT(TckRcS, Storage, , trgStorage);
  END;
  WHILE OCCURE(TckRcS) DO
   IF !trgStorage THEN
    NARROWSEL(TckRcS, Storage);
   END;
   IF ~!TckRcS.Storage THEN
    PROMPT(TckRcS.Storage);
    fixedTSN:=L_Stock.GetStorageFixedStaff(TckRcS.Storage, SYSDATE());
    IF ~!fixedTSN THEN
     L_General.CallUs(SEARCH(Staff, TSN, fixedTSN));
     IF L_Staff.rInState(SYSDATE()) & SRCINSEL(TckRcS, GE, SYSDATE() - LastDays) THEN
      CONFORM(TckRcS, Storage);
      L_TRS.GetStorageTckSummary(Storage.Storage, "", "", 1, pta);
      i:=0;
      WHILE ~!pta[i] DO
       IF (L_TRS.pt_GetState(pta[i]) = L_TRS.ts_inBag) | (L_TRS.pt_GetState(pta[i]) = L_TRS.ts_Ended) THEN
        L_TRS.pt_Unpack(pta[i], curNumber, curTckKind, curSeries, curRestNbr, curCUCopy, curPsg);
        SEARCH(TckKind, TckKind, , curTckKind);
        IF ~L_TRS.IsDevice(TckKind.Type) THEN
         IF    L_TRS.pt_GetState(pta[i]) = L_TRS.ts_Ended THEN
          Amount:=0;
         ELSIF L_TRS.IsBulk() THEN
          Amount:=curRestNbr;
         ELSE
          Amount:=Math.Abs(curRestNbr - L_TRS.PackLastNbr(TckKind.TckKind, curRestNbr));
         END;
         ADD(Tck26, Storage, , TckRcS.Storage, fixedTSN, TckKind.TckKind,
               Tck26.AmntTot, 0,
               Tck26.TRSCnt, 0,
               Tck26.Amnt, 0,
               Tck26.Rest, Amount);
        END; (* IF ~L_TRS.IsDevice(TckKind.Type) *)
       END; (* IF L_TRS.pt_GetState(pta[i]) = L_TRS.ts_inBag *)
       INC(i);
      END; (* WHILE ~!pta[i] *)
  
      WHILE OCCURE(TckRcS) DO
       SELECT(tmp26, TckKind);
       REMSEL(tmp26);
       SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
       WHILE OCCURE(TckRcT) DO
        PROMPT(Storage.Storage + " " + TckRcT.TckRcS + " " + TckRcT.TckRcT);
        IF ~!TckRcT.Number & SEARCH(Tck26, Storage, TckRcS.Storage, fixedTSN, TckRcT.TckKind) THEN
         L_TRS.Calc2NumbersDifference(TckRcT.TckKind, TckRcT.BefNbr, TckRcT.AftNbr, Amount, Sum);
         ADD(tmp26, TckKind, , TckRcT.TckKind,
                 tmp26.Amnt, Amount);
        END;
        NEXT(TckRcT);
       END; (* WHILE OCCURE(TckRcT) ... *)
       SELECT(tmp26, TckKind);
       WHILE OCCURE(tmp26) DO
        SEARCH(Tck26, Storage, , Storage.Storage, fixedTSN, tmp26.TckKind);
        IF tmp26.Amnt > 0 THEN
         INC(Tck26.TRSCnt);
         INC(Tck26.AmntTot, tmp26.Amnt);
        END;
        IF tmp26.Amnt > Tck26.Amnt THEN
         Tck26.Amnt:=tmp26.Amnt;
        END;
        REPLACE(Tck26);
        NEXT(tmp26);
       END; (* WHILE OCCURE(tmp26) ... *)
       NEXT(TckRcS);
      END; (* WHILE OCCURE(TckRcS) *)
     END; (* IF SRCINSEL(TckRcS, GE, SYSDATE() - LastDays) *)
    END; (* IF ~!fixedTSN *)
   END; (* IF ~!TckRcS.Storage *)
   IF !trgStorage THEN
    NEXTINEXTENDEDSEL(TckRcS, Storage);
   END;
  END; (* WHILE OCCURE(TckRcS) *)

  SELECT(Tck26, Storage);
  WHILE OCCURE(Tck26) DO
   IF Tck26.AmntTot = 0 THEN
    REMOVE(Tck26);
   ELSIF P_OwnData.IsMainTckKind(Tck26.TckKind, SYSDATE()) THEN
    IF Coef * Tck26.Amnt < Tck26.Rest THEN
     REMOVE(Tck26);
    ELSE
     NEXT(Tck26);
    END;
   ELSE
    IF Coef * Tck26.AmntTot / Tck26.TRSCnt < Tck26.Rest THEN
     REMOVE(Tck26);
    ELSE
     NEXT(Tck26);
    END;
   END;
  END; (* WHILE OCCURE(Tck26) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);

  IF !trgStorage THEN
   MAKEPART(R, Tck26_Top, RepName, " 㬪   ⢮ ");
  ELSE
   SEARCH(Storage, Storage, , trgStorage);
   MAKEPART(R, Tck26_Top, RepName, "筮 ⢮ . ⭠ 㬪 " + trgStorage + " " + Storage.Name);
  END;
  SELECT(Tck26, Storage);
  WHILE OCCURE(Tck26) DO
   NARROWSEL(Tck26, Storage, TSN);
   SEARCH(Storage, Storage, , Tck26.Storage);
   PROMPT(Storage.Storage);
   SEARCH(Staff, TSN, , Tck26.TSN);
   CONFORM(Staff, Man);
   SEARCH(TckKind, TckKind, , Tck26.TckKind);
   MAKEPART(R, Tck26_Line, Storage.Storage, Storage.Name, Staff.TSN, L_Str.ShortName(Man.Name));
   WHILE NEXT(Tck26) DO
    SEARCH(TckKind, TckKind, , Tck26.TckKind);
    MAKEPART(R, Tck26_Line);
   END; (* WHILE OCCURE(File) *)
   NEXTINEXTENDEDSEL(Tck26, Storage, TSN);
  END; (* WHILE OCCURE(Tck26) *)
  MAKEPART(R, Tck26_Bot);
  CLOSEREP(R);
 END {intTck26};

 PUBLIC PROCEDURE Tck26();
 BEGIN
  intTck26(EMPTYOF(Storage.Storage));
  L_General.SurveyLastReport();
 END {Tck26};

 PUBLIC PROCEDURE CheckEnoughTck(trgStorage: LIKE(Storage.Storage));
 BEGIN
  intTck26(trgStorage);
  IF SELECT(Tck26, Storage) & L_StdFrm.Alternative(", ॡ  .  ?") THEN
   L_General.SurveyLastReport();
  END;
 END {CheckEnoughTck};

BEGIN
 L_Events.ExecuteHandler();
END.
