(*
%Copyright   (c) Polak IT
%Author      14.02.2005 12:47:01 POLAK\GAV
%Purpose
%Type        control
%Specific    AP
%Modified    01.11.2013 11:16:57 POLAK\GAV
%Environment
*)

 MODULE TckRcC;

 IMPORT L_Events, Memo, Str, L_Str, L_General, L_Way, L_DatTim, L_XDoc,
        L_StdFrm, L_TRS, L_BarCode, L_Print, P_Man, L_Money, Math, L_Staff,
        P_Firm, L_EC, L_WDO, E_TRS, L_APtm;

 PRIVATE PERMANENT VAR
  TckRcCToPrint: LIKE(TckRcC.TckRcC);

 PRIVATE CONST
  TckRcC_Amount_HIGH = 14;

 PRIVATE PROCEDURE CheckTckRcSStatus();
 BEGIN
  CONFORM(TckRcC, TckRcS);
  IF (TckRcC.Type = L_TRS.trct_CashAccept) & (TckRcS.Status # L_TRS.trsStat_Given) THEN
   L_General.Error(" " + TckRcS.TckRcS + "  室  ﭨ '뤠'");
  END;
 END {CheckTckRcSStatus};

 PRIVATE PROCEDURE SignOfTckRcCType(): NUMERIC[0];
 BEGIN
  IF    (TckRcC.Type = L_TRS.trct_CashAccept) THEN
   RETURN +1;
  ELSIF (TckRcC.Type = L_TRS.trct_SurPlusAct) |
        (TckRcC.Type = L_TRS.trct_DeficitAct) |
        (TckRcC.Type = L_TRS.trct_TckWriteOffLack) THEN
   RETURN 0;
  ELSE
   L_General.CallUs(0);
  END;
 END {SignOfTckRcCType};

 PRIVATE PROCEDURE Proceed(Dir: NUMERIC[0]);
  VAR
   _Done: LIKE(TckRcC.Done);
 BEGIN
  L_General.Assert(ACCESS(TckRcC), " ⠭ ⥪騩 ");
  _Done:=Dir = +1;
  IF (TckRcC.Done # _Done) THEN
   IF    TckRcC.Status = L_TRS.trcStat_Passed THEN
    CheckTckRcSStatus();
    INC(TckRcS.TotCash, Dir * SignOfTckRcCType() * TckRcC.Total);
    REPLACE(TckRcS);
   END;
   IF TckRcC.Status # L_TRS.trcStat_Prepared THEN
    TckRcC.Done:=_Done;
    REPLACE(TckRcC);
   END;
  END;
 END {Proceed};

 PRIVATE PROCEDURE Nom_Val(Idx: NUMERIC[0]): NUMERIC[2];
 BEGIN
  IF    Idx = 00 THEN RETURN  0.01;
  ELSIF Idx = 01 THEN RETURN  0.05;
  ELSIF Idx = 02 THEN RETURN  0.10;
  ELSIF Idx = 03 THEN RETURN  0.50;
  ELSIF Idx = 04 THEN RETURN  1.00;
  ELSIF Idx = 05 THEN RETURN  2.00;
  ELSIF Idx = 06 THEN RETURN  5.00;
  ELSIF Idx = 07 THEN RETURN 10.00;
  ELSIF Idx = 08 THEN RETURN     5;
  ELSIF Idx = 09 THEN RETURN    10;
  ELSIF Idx = 10 THEN RETURN    50;
  ELSIF Idx = 11 THEN RETURN   100;
  ELSIF Idx = 12 THEN RETURN   500;
  ELSIF Idx = 13 THEN RETURN  1000;
  ELSIF Idx = 14 THEN RETURN  5000;
  ELSE
   L_General.Error("⭠   ???");
  END;
 END {Nom_Val};

 PRIVATE PROCEDURE MakeUnprinted(Force: SCAL[2]);
 BEGIN
  L_General.Assert(ACCESS(TckRcC), " ⠭ ⥪騩 ");
  IF Force |
     L_XDoc.XDocIsPrinted(L_XDoc.xdt_TckRcC, L_XDoc.EmptyXDocKind, TckRcC.TckRcC) THEN
   INC(TckRcC.CopyCnt);
   REPLACE(TckRcC);
  END;
 END {MakeUnprinted};

 PRIVATE PROCEDURE TckRcC_OnBeforeEdit();
 BEGIN
  L_General.Error("䨪 㬥 饭");
 END {TckRcC_OnBeforeEdit};

 PRIVATE PROCEDURE TckRcC_OnBeforeInsert();
  VAR
   pId      : STRING[];
   trcType  : LIKE(TckRcC.Type);
   trcTotal : LIKE(TckRcC.Total);
   TotalOnly: SCAL[2];
   i        : NUMERIC[0];
   LastTS   : TIMESTAMP;
   Msg      : STRING[];
   Fields   : FORM_FIELDS;
 BEGIN
  pId:=L_WDO.GetEnvVarValue(L_Events.ee_ProcessId);
  L_General.Assert(~!pId, "ନ஢ 㬥 ᪠ ⮫쪮   ᪠ -");
  MakeUnprinted(1);
  L_TRS.bc_PositionOnTckRcS(pId);
  IF    pId = L_TRS.pid_CashAccept THEN
   trcType:=L_TRS.trct_CashAccept;
   L_TRS.CheckSwitchMonthRWS(0);
  ELSE
   L_General.CallUs(0);
  END;
  SAVE(TckRcC);
  trcTotal:=0;
  LastTS:=MINOF(LastTS);
  SELECT(TckRcC, TckRcS, , TckRcS.TckRcS, trcType);
  WHILE OCCURE(TckRcC) DO
   IF TckRcC.Status # L_TRS.trcStat_Canceled THEN
    L_General.CallUs(L_XDoc.XDocWasAutoBuild(L_XDoc.xdt_TckRcC, L_XDoc.EmptyXDocKind, TckRcC.TckRcC));
    LastTS:=Math.Max(LastTS, PackTIMESTAMP(XDocJrn.Date + (XDocJrn.EndTime < XDocJrn.BegTime),
                                           XDocJrn.EndTime,
                                           XDocJrn.EndSec));
    INC(trcTotal, TckRcC.Total);
   END;
   NEXT(TckRcC);
  END; (* WHILE OCCURE(TckRcC) ... *)
  RESTORE(TckRcC);
  IF trcTotal # 0 THEN
   Msg:="  " + TckRcS.TckRcS + " 㦥  ନ஢ " +
        "|  㬬 " + FLDTOSTR(trcTotal, "2-", 0);
   IF (SYSTIMESTAMP() - LastTS) < 2/24 THEN
    L_StdFrm.Question(Msg);
   END;
  END;
  TckRcC.TckRcS:=TckRcS.TckRcS;
  TckRcC.TSN   :=TckRcS.TSN;
  TckRcC.Date  :=L_TRS.GetTRCOnDate();
  L_General.Assert((TckRcC.Date >= TckRcS.Date) | ~L_TRS.E_HasTckAtStorage(TckRcS.Date),
                   "   " + L_DatTim.DateStr(TckRcS.Date) + "." +
                   "|ਥ   ᬥ " + L_DatTim.DateStr(TckRcC.Date) + " ⨬." +
                   "||⭮,  뫨 ' ᬥ'.");
  TckRcC.Type  :=trcType;
  TotalOnly:=(TckRcC.Type # L_TRS.trct_CashAccept) |
              L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_TRS.AbnormalCashAcceptMode), 0);
  IF ~TotalOnly THEN
   TckRcC.Total:=0;
  END;
  REPLACE(TckRcC);

  Fields:=RTI.Get().CurZone.Fields;
  Fields("TckRcC.Total").Modifiable:=TotalOnly;
  i:=0;
  WHILE i <= TckRcC_Amount_HIGH DO
   IF i # 8 (* 5 . ⦨*) THEN
    Fields("TckRcC.Amount[" + L_Str.IntStr(i) + "]").Modifiable:=~TotalOnly;
   END;
   INC(i);
  END;
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_TckRcC, L_XDoc.EmptyXDocKind, TckRcC.TckRcC, L_XDoc.action_AutoBuild);
 END {TckRcC_OnBeforeInsert};

 PRIVATE PROCEDURE TckRcC_Amount_OnSuccessfulChange();
  VAR
   Idx: NUMERIC[0];
 BEGIN
  Idx:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  IF ~!GE_PVALUE() THEN
   DEC(TckRcC.Total, GE_PVALUE() * Nom_Val(Idx));
  END;
  IF ~!TckRcC.Amount[Idx] THEN
   L_General.Assert((TckRcC.Total + TckRcC.Amount[Idx] * Nom_Val(Idx) <= MAXOF(TckRcC.Total)) &
                    (TckRcC.Total + TckRcC.Amount[Idx] * Nom_Val(Idx) >= MINOF(TckRcC.Total)),
                    "⨬ 讥 ⢮ ." + L_StdFrm.HR() +
                    "᫨ ⢨⥫쭮 ॡ ਭ  㬬 ," +
                    "| ନ ⮫쪮 .");
   INC(TckRcC.Total, TckRcC.Amount[Idx] * Nom_Val(Idx));
  END;
  REPLACE(TckRcC);
 END {TckRcC_Amount_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcC_RePrint(Stream: SCAL[2]);
 BEGIN
  MakeUnprinted(0);
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_TckRcC, L_XDoc.EmptyXDocKind, TckRcC.TckRcC, L_XDoc.action_Reprint);
  TckRcCToPrint:=TckRcC.TckRcC;
  IF ~Stream THEN
   LIKEMENU(RunProg, "TckRcC " + L_Str.IntStr(L_Events.md_SinglePrint));
  END;
 END {TckRcC_RePrint};

 PRIVATE PROCEDURE TckRcC_OnAfterInsert();
 BEGIN
  Proceed(+1);
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_TckRcC, L_XDoc.EmptyXDocKind, TckRcC.TckRcC);
  TckRcC_RePrint(0);
 END {TckRcC_OnAfterInsert};

 PRIVATE PROCEDURE TckRcC_OnAfterEdit();
 BEGIN
  L_General.CallUs(0);
 END {TckRcC_OnAfterEdit};

 PRIVATE PROCEDURE TckRcC_OnBeforeDelete();
 BEGIN
  L_General.Error(" 㬥 饭");
 END {TckRcC_OnBeforeDelete};

 PRIVATE PROCEDURE TckRcC_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("TckRcC.Type").Format:=L_TRS.trct_Pool_SH;
 END {TckRcC_1_OnZoneOpen};

 PRIVATE PROCEDURE TckRcCE_0_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("TckRcS.AsWho").Format:=L_Way.trs_Pool;
  RTI.Get().CurZone.Fields("TckRcC.Type").Format :=L_TRS.trct_Pool;
 END {TckRcCE_0_OnZoneOpen};

 PRIVATE PROCEDURE PrintOneTckRcC(trcPrt: PRINTJOB);
  CONST
   DefaultPosForSign = 55;
  VAR
   SumStr: STRING[][3];
   Pt08,
   Pt09,
   Pt10B,
   Pt11B : TEXTSTYLE;
   Y,
   Idx,
   Count : NUMERIC[0];
   S     : STRING[];
 BEGIN
  trcPrt.StartPage();
  Pt08 :=L_Print.ts_Create(08, "Lucida Console");
  IF L_General.GetOSPlatform() = L_General.osp_WinNT THEN
   Pt08.CharExtra:=-0.2;
  ELSE
   Pt08.CharExtra:=-0.3;
  END;
  Pt09 :=L_Print.ts_Resize(Pt08, 09);
  Pt10B:=L_Print.ts_Resize(Pt08, 10);
  Pt10B.Font.Weight:=FONT.Weight_Bold;
  Pt11B:=L_Print.ts_Resize(Pt08, 11);
  Pt11B.Font.Weight:=FONT.Weight_SemiBold;

  CONFORM(TckRcC, Staff);
  CONFORM(TckRcC, TckRcS);
  CONFORM(Staff, Man);
  Str.Format(SumStr, "㬬 " + FLDTOSTR(Math.Abs(TckRcC.Total), ",2-") +
                     " ("+L_Money.ByWord(Math.Abs(TckRcC.Total))+")", 36, LEFT);

  L_Print.TypeS(trcPrt,  0, 0, P_Firm.FP_FirmShortName(L_Staff.GetFirmOfStaff(), SYSDATE()), Pt08);
  L_Print.TypeS(trcPrt, 38, 3, L_DatTim.DateTimeStr(SYSDATE(), SYSTIME()),     Pt08);
  IF    TckRcC.Type = L_TRS.trct_CashAccept THEN
   IF TckRcC.Total >= 0 THEN
    L_Print.TypeS(trcPrt, 0, 7, "⠭  ਥ 窨",     Pt10B);
   ELSE
    L_Print.TypeS(trcPrt, 0, 7, "⠭   窨",   Pt10B);
   END;
  ELSIF TckRcC.Type = L_TRS.trct_DeficitAct THEN
   L_Print.TypeS(trcPrt, 0, 7, "  ", Pt11B);
  ELSIF TckRcC.Type = L_TRS.trct_SurPlusAct THEN
   L_Print.TypeS(trcPrt, 0, 7, "  誥",  Pt11B);
  ELSIF TckRcC.Type = L_TRS.trct_TckWriteOffLack THEN
   L_Print.TypeS(trcPrt, 0, 7, "    ᯨᠭ ",  Pt10B);
  ELSE
   L_General.CallUs(0);
  END;
  L_Print.TypeS(trcPrt, 0, 13, TckRcC.TckRcC + "(" + TckRcC.CopyCnt+")  " +
                               L_DatTim.DateStr(TckRcC.Date),   Pt11B);
  L_Print.TypeS(trcPrt, 0, 19, " " + TckRcC.TckRcS + ", " +
                                               L_Str.PoolItem(L_Way.trs_Pool, TckRcS.AsWho), Pt09);
  L_Print.TypeS(trcPrt, 0, 23, Staff.TSN + " " + Man.Name,           Pt09);
  L_Print.TypeS(trcPrt, 0, 27, SumStr[0],                            Pt09);
  L_Print.TypeS(trcPrt, 0, 30, SumStr[1],                            Pt09);
  L_Print.TypeS(trcPrt, 0, 34, SumStr[2],                            Pt09);

  Idx:=TckRcC_Amount_HIGH;
  Count:=0;
  Y:=38;
  WHILE Idx >= 0 DO
   IF ~!TckRcC.Amount[Idx] & (TckRcC.Amount[Idx] # 0) THEN
    S:=Str.Align(L_Str.IntStr(TckRcC.Amount[Idx]), 4, RIGHT) + " x " +
       L_Money.MoneyToStr(TckRcC.Date, "", Nom_Val(Idx));
    INC(Count);
    IF    (Count MOD 3) = 1 THEN
     L_Print.TypeS(trcPrt,  0, Y, S, Pt08);
    ELSIF (Count MOD 3) = 2 THEN
     L_Print.TypeS(trcPrt, 21, Y, S, Pt08);
    ELSE
     L_Print.TypeS(trcPrt, 42, Y, S, Pt08);
     INC(Y, 3);
    END;
   END;
   DEC(Idx);
  END;

  INC(Y, 4);
  Y:=Math.Max(Y, DefaultPosForSign);
  L_Print.TypeS(trcPrt,  0, Y, "", Pt09);
  INC(Y, 2);
  L_Print.TypeS(trcPrt, 12, Y, "_________ /" + L_Str.ShortName(P_Man.GetFullNameOfCurrentUser(SYSDATE())) + "/", Pt09);
  INC(Y, 4);
  L_Print.TypeS(trcPrt,  0, Y, L_Str.PoolItem(L_Way.trs_Pool, TckRcS.AsWho), Pt09);
  INC(Y, 2);
  L_Print.TypeS(trcPrt, 12, Y, "_________ /" + L_Str.ShortName(Man.Name) + "/", Pt09);
  trcPrt.EndPage();
 END {PrintOneTckRcC};

 PRIVATE PROCEDURE TckRcC_Print(Stream: SCAL[2]);
  VAR
   trcPrt: PRINTJOB;
 BEGIN
  TRY
   SAVE(TckRcC);
   L_General.Assert(SEARCH(TckRcC, TckRcC, TckRcCToPrint),
                    "  㬥    । " + TckRcCToPrint + " ()");
   trcPrt:=L_Print.pj_Create_ChequeBand("㬥  " + TckRcC.TckRcC);
   PrintOneTckRcC(trcPrt);
   IF L_Print.Cheque_BandType() = L_Print.bt_Single THEN
    PrintOneTckRcC(trcPrt);
   END;
   trcPrt.Close();
   RESTORE(TckRcC);
  EXCEPT
  ON Exc: Exc_Root DO
   L_StdFrm.RedInform(Exc.MsgOriginalText);
  END; (* TRY *)
 END {TckRcC_Print};

 PRIVATE PROCEDURE TckRcCE_OnConformToWindow();
 BEGIN
  IF ~ACCESS(TckRcC) THEN
   SELECT(TckRcC, TckRcC);
  END;
  SE_WWD_CURSOR("TckRcCE", TckRcC);
 END {TckRcCE_OnConformToWindow};

BEGIN
 IF    L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSIF MODE = L_Events.md_SingleMakeDone THEN
  Proceed(+1);
 ELSIF MODE = L_Events.md_SingleMakeUnDone THEN
  Proceed(-1);
 ELSIF (MODE = L_Events.md_SinglePrint) |
       (MODE = L_Events.md_StreamPrint) THEN
  TckRcC_Print(MODE = L_Events.md_StreamPrint);
 ELSIF (MODE = L_Events.md_SingleRePrint) |
       (MODE = L_Events.md_StreamRePrint) THEN
  TckRcC_RePrint(MODE = L_Events.md_StreamRePrint);
 ELSE
  L_General.BadMode(MODE);
 END;
END.
