(*
%Copyright   (c) Polak IT
%Author      20.02.2005 14:27:01 POLAK\San
%Purpose     䨪 㬥⮢   ⭮ த樨
%Type        control
%Specific    AP
%Modified    07.05.2014 16:32:56 POLAK\GAV
%Environment
*)

 MODULE TckRcD [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_Str, L_General, L_Stock, L_TRS, L_Way, L_XDoc,
        L_StdFrm, L_Print, Str, L_Staff, L_DatTim, P_Man, Math, P_Firm,
        L_CUC, L_WDO, L_TRSP, L_MDoc, Memo, L_BegRWS, L_BarCode;

 PRIVATE PERMANENT VAR
  TckRcDToPrint: LIKE(TckRcD.TckRcD);
  ptToInsert   : L_TRS.tPackedTck;

 PRIVATE PROCEDURE proceed_SetDate(_Done: SCAL[2]; cucopy: LIKE(CUCopy.CUCopy));
 BEGIN
  SEARCH(CUCopy, CUCopy, , cucopy);
  IF _Done THEN
   CUCopy.Till:=TckRcD.Date + 1;
  ELSE
   SETEMPTY(CUCopy.Till);
  END;
  REPLACE(CUCopy);
 END {proceed_SetDate};

 PUBLIC PROCEDURE Proceed(Dir: NUMERIC[0]);
  VAR
   _Done: SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(TckRcD), " ⠭ ⥪騩 ");
  IF    Dir = +1 THEN
   _Done:=1;
  ELSIF Dir = -1 THEN
   _Done:=0;
  ELSE
   _Done:=TckRcD.Done;
  END;
  IF TckRcD.Done # _Done THEN
   IF TckRcD.Status = L_TRS.trdStat_Passed THEN
    IF TckRcD.Type = L_TRS.trdt_Inventory THEN
     SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
     WHILE OCCURE(TckRcDL) DO
      IF !TckRcDL.RestNbr THEN
       proceed_SetDate(_Done, TckRcDL.CUCopy);
      END;
      NEXT(TckRcDL);
     END; (* WHILE OCCURE(TckRcDL) ... *)
    END;
    IF TckRcD.Type # L_TRS.trdt_Laying THEN
     SELECT(TckRcDLL, TckRcD, , TckRcD.TckRcD);
     WHILE OCCURE(TckRcDLL) DO
      IF ~!TckRcDLL.Sum THEN
       proceed_SetDate(_Done, TckRcDLL.CUCopy);
      END;
      NEXT(TckRcDLL);
     END; (* WHILE OCCURE(TckRcDLL) ... *)
    END;
   END;
   TckRcD.Done:=_Done;
   REPLACE(TckRcD);
  END;
 END {Proceed};

 PRIVATE PROCEDURE SetSaleTypeStr();
  VAR
   trgField: FORM_FIELD;
 BEGIN
  IF (TckRcD.Type = L_TRS.trdt_Sale) THEN
   trgField:=RTI.Get().CurZone.Fields("SaleTypeStr");
   IF !TckRcD.Firm THEN
    IF !TckRcD.TSN THEN
     trgField.Value:="筠 த   ";
    ELSE
     trgField.Value:="뤠 ࠡ⭨";
    END;
   ELSE
    IF !TckRcD.TSN THEN
     trgField.Value:="뤠 ।⠢⥫ ࠣ";
    ELSE
     trgField.Value:="뤠 ࠡ⭨  । 㣨 ࠡ⭨";
    END;
   END;
  END;
 END {SetSaleTypeStr};

 PRIVATE PROCEDURE TckRcD3E_0_OnReposition();
 BEGIN
  SetSaleTypeStr();
 END {TckRcD3E_0_OnReposition};

 PRIVATE PROCEDURE TckRcD_Firm_OnSuccessfulChange();
 BEGIN
  SetSaleTypeStr();
 END {TckRcD_Firm_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcD_TSN_OnSuccessfulChange();
 BEGIN
  SetSaleTypeStr();
 END {TckRcD_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcD_1_OnZoneOpen();
 BEGIN
  L_WDO.SetFieldFormat("Storage.Type", L_Stock.st_Pool_SH);
  L_WDO.SetFieldFormat("TckRcD.Type",  L_TRS.trdt_Pool_SH);
 END {TckRcD_1_OnZoneOpen};

 PRIVATE PROCEDURE TckRcD3E_0_OnZoneOpen();
 BEGIN
  L_WDO.SetFieldFormat("TckRcD.Type",  L_TRS.trdt_Pool);
  L_WDO.SetFieldFormat("Storage.Type", L_Stock.st_Pool_SH);
 END {TckRcD3E_0_OnZoneOpen};

 PRIVATE PROCEDURE TckRcD_Storage_OnBeforeAskForEdit();
 BEGIN
  L_Stock.v_StorageType:=L_Stock.st_TckBag;
 END {TckRcD_Storage_OnBeforeAskForEdit};

 PRIVATE PROCEDURE MakeUnprinted(Force: SCAL[2]);
 BEGIN
  L_General.Assert(ACCESS(TckRcD), " ⠭ ⥪騩 ");
  IF Force |
     L_XDoc.XDocIsPrinted(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD) THEN
   INC(TckRcD.CopyCnt);
   REPLACE(TckRcD);
  END;
 END {MakeUnprinted};

 PRIVATE PROCEDURE Insert_NightLayingTckRcS(trgStorage: LIKE(Storage.Storage));
  VAR
   curTSN,
   newTSN : LIKE(Staff.TSN);
   OnDate : DATE;
 BEGIN
  OnDate:=L_TRS.GetTRDOnDate();
  curTSN:=L_Stock.GetStorageFixedStaff(trgStorage, OnDate);
  L_General.Assert(~!curTSN, "㬪     ९");
  newTSN:=L_Stock.GetStorageFixedStaff(trgStorage, OnDate+1);
  IF ~!newTSN THEN
   L_General.Assert(curTSN = newTSN,
                    "㦥  ९ 㬪  ᬥ  " + L_DatTim.DateStr(OnDate+1) +
                    "|(⥪饥 ९  ࠡ⭨ " + curTSN +
                    ",  ९ - ࠡ⭨ " + newTSN + ")" +
                    L_StdFrm.HR() +
                    "    ९, " +
                    "|ନ   ᫥ 砭 ⥪饩 ᬥ");
  END;
  L_TRS.CheckStaffAdaptability(curTSN, OnDate);
  L_TRS.CheckGivenTckRcS(curTSN);
  IF L_TRS.PositionOnTckRcS(curTSN, trgStorage, EMPTYOF(DATE), L_Way.rwsStat_Ordered) THEN
   IF !TckRcS.Storage THEN
    TckRcS.Storage:=trgStorage;
    REPLACE(TckRcS);
   ELSE
    L_General.Assert(TckRcS.Storage = trgStorage, "     㬪  ࠧ ࠡ⭨?");
   END;
  ELSE
   L_TRS.Insert_TckRcS(EMPTYOF(DATE), curTSN, trgStorage, L_TRS.E_GetDefaultAsWho(curTSN, OnDate),
                       L_TRS.E_GetDefaultAsWhoCnd(curTSN, OnDate),
                       EMPTYOF(TckRcS.asRWayS), EMPTYOF(TckRcS.asBoxNbr), "");
  END;
 END {Insert_NightLayingTckRcS};

 PRIVATE PROCEDURE TckRcD_OnBeforeInsert();
  VAR
   pId      : STRING[];
   bs       : L_TRS.tBagState;
   bagTckRcS: LIKE(TckRcS.TckRcS);
 BEGIN
  pId:=L_WDO.GetEnvVarValue(L_Events.ee_ProcessId);
  L_General.Assert(~!pId, "筠 ⠢ ⨬");
  MakeUnprinted(1);
  IF    (pId = L_TRS.pid_Sale) THEN
   L_General.Assert(~!L_Stock.DefaultStorage(), " ⠭   㬮砭");
   SAVE(TckRcD);
   IF    Memo.ud_cd() > SYSDATE() THEN
    L_General.Error('ଫ " 饬" ⨬');
   ELSIF Memo.ud_cd() < SYSDATE() THEN
    CALL(Tck30.Tck33_CheckIsNotDone(Memo.ud_cd() + 1, L_Stock.DefaultStorage()));
    L_StdFrm.OrdinaryCHOICE("㬥   ᥣ?");
   END;
   RESTORE(TckRcD);
   TckRcD.Type   :=L_TRS.trdt_Sale;
   TckRcD.Date   :=Memo.ud_cd();
   TckRcD.PassDTS:=SYSTIMESTAMP();
   TckRcD.Storage:=L_Stock.DefaultStorage();
   REPLACE(TckRcD);
   L_TRS.Correct_TckRcD_PassDTS();
   L_XDoc.XDocJrn_Start(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD, L_XDoc.action_Insert);
   FIXALTERING();
  ELSE
   IF pId = L_TRS.pid_NightLaying THEN
    L_TRS.bc_PositionOnTckBag(pId);
    L_TRS.getBagLastLocation(Storage.Storage, bs, bagTckRcS);
    IF bs = L_TRS.bs_GivenOut THEN
     L_General.Error("㬪 " + Storage.Storage + " 뤠 ( " + bagTckRcS + ").|筠  ⨬");
    END;
    Insert_NightLayingTckRcS(Storage.Storage);
   ELSE
    L_TRS.bc_PositionOnTckRcS(pId);
    L_General.Assert(TckRcS.Status = L_TRS.trsStat_Given,
                     "ଫ 㬥⮢    ⮫쪮  뤠 ");
    L_TRS.bc_PositionOnTckBag(pId);
   END;
   TckRcD.TckRcS :=TckRcS.TckRcS;
   TckRcD.TSN    :=TckRcS.TSN;
   TckRcD.Storage:=Storage.Storage;
   L_General.Assert(Storage.Storage = TckRcS.Storage,
                    " 㪠 㬪,  뤠   ");
   IF    pId = L_TRS.pid_Laying THEN
    TckRcD.Type:=L_TRS.trdt_Laying;
   ELSIF pId = L_TRS.pid_NightLaying THEN
    TckRcD.Type:=L_TRS.trdt_Laying;
   ELSIF pId = L_TRS.pid_Return THEN
    TckRcD.Type:=L_TRS.trdt_Return;
   ELSE
    L_General.CallUs(0);
   END;
   TckRcD.Date   :=L_TRS.GetTRDOnDate();
   TckRcD.PassDTS:=SYSTIMESTAMP();
   REPLACE(TckRcD);
   L_TRS.Correct_TckRcD_PassDTS();
   L_TRS.CheckTckRcS_StorageConsistency();
   L_XDoc.XDocJrn_Start(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD, L_XDoc.action_AutoBuild);
   FIXALTERING();
   LIKEMENU(View, ". 1");
  END; (*IF    pId = L_TRS.pid_Sale... *)
 END {TckRcD_OnBeforeInsert};

 PRIVATE PROCEDURE CheckNotEmpty_TckRcD_Type();
 BEGIN
  L_General.Assert(~!TckRcD.Type, "室 㪠 '' 㬥");
 END {CheckNotEmpty_TckRcD_Type};

 PRIVATE PROCEDURE TckRcDL_SetupWin();
  VAR
   ia_TckKind,
   ia_Series,
   ia_RestNbr,
   ia_Psg     : SCAL[2];
   nbrFormat  : STRING[];
 BEGIN
  CheckNotEmpty_TckRcD_Type();
  L_TRS.trdl_ia_Set(TckRcD.Type, TckRcDL.TckKind, ia_TckKind, ia_Series, ia_RestNbr, ia_Psg, nbrFormat);
  L_WDO.z_SetFieldFormat(0, "TckKind.Type",    L_TRS.tkt_Pool);
  L_WDO.z_SetFieldModifiable(0, "TckRcDL.TckKind", ia_TckKind);
  L_WDO.z_SetFieldModifiable(0, "TckRcDL.Series",  ia_Series);
  IF L_TRS.IsSaleTckRcD(TckRcD.Type) THEN
   L_WDO.z_SetFieldFormat(0, "TckRcDL.RestNbr", "N");
  ELSE
   L_WDO.z_SetFieldFormat(0, "TckRcDL.RestNbr", nbrFormat);
  END;
  L_WDO.z_SetFieldModifiable(0, "TckRcDL.RestNbr", ia_RestNbr);
  L_WDO.z_SetFieldModifiable(0, "TckRcDL.Psg",     ia_Psg);
  IF L_WDO.getActiveForm().OriginalName = "TckRcDLEE" THEN
   L_WDO.z_SetFieldFormat(1, "TckRcDLL.RestNbr", nbrFormat);
   L_WDO.z_SetFieldFormat(1, "SnTckTrf.Type", "|||");
   L_WDO.z_SetFieldModifiable(1, "TckRcDLL.TckKind",  (TckRcD.Type = L_TRS.trdt_Laying) |
                                                      L_TRS.IsSaleTckRcD(TckRcD.Type));
   L_WDO.z_SetFieldModifiable(1, "TckRcDLL.Series",   (TckRcD.Type = L_TRS.trdt_Laying) |
                                                      L_TRS.IsSaleTckRcD(TckRcD.Type));
   L_WDO.z_SetFieldModifiable(1, "TckRcDLL.RestNbr",  (TckRcD.Type = L_TRS.trdt_Laying) |
                                                      L_TRS.IsSaleTckRcD(TckRcD.Type));
   L_WDO.z_SetFieldModifiable(1, "TckRcDLL.SnTckTrf", ((TckRcD.Type = L_TRS.trdt_Inventory) |
                                                       (TckRcD.Type = L_TRS.trdt_Return) |
                                                       L_TRS.IsSaleTckRcD(TckRcD.Type)) &
                                                      ~!TckRcDL.TckKind);
   L_WDO.z_SetFieldModifiable(1, "TckRcDLL.Sum",      ((TckRcD.Type = L_TRS.trdt_Inventory) |
                                                       (TckRcD.Type = L_TRS.trdt_Return) |
                                                       L_TRS.IsSaleTckRcD(TckRcD.Type)) &
                                                      ~!TckRcDL.TckKind);
  END;
 END {TckRcDL_SetupWin};

 PRIVATE PROCEDURE HasGeneratedMDoc(): SCAL[2];
  VAR
   xdc: L_XDoc.tXDocCollection;
   i  : NUMERIC[0];
 BEGIN
  xdc:=L_XDoc.GetDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_TckRcD), L_XDoc.xdt_MDoc);
  i:=0;
  WHILE ~!L_XDoc.xdc_Item(xdc, i) DO
   L_XDoc.PositionOnXDoc(L_XDoc.xdc_Item(xdc, i));
   IF MDoc.Status # L_MDoc.st_Canceled THEN
    RETURN 1;
   END;
   INC(i);
  END;
  RETURN 0;
 END {HasGeneratedMDoc};

 PRIVATE PROCEDURE TckRcD_OnBeforeEdit();
 BEGIN
  L_General.Assert(L_TRS.IsSaleTckRcD(TckRcD.Type), "䨪 㬥 饭");

  L_General.Assert(~HasGeneratedMDoc(),
                   " ନ஢ ⮢ 㬥. 䨪 饭.");

  L_XDoc.XDocJrn_Start(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD, L_XDoc.action_Edit);
  Proceed(-1);
 END {TckRcD_OnBeforeEdit};

 PRIVATE PROCEDURE TckRcD_OnBeforeDelete();
 BEGIN
  L_General.Error(" 㬥 饭");
  Proceed(-1);
 END {TckRcD_OnBeforeDelete};

 PUBLIC PROCEDURE TckRcD_RePrint(Stream: SCAL[2]);
 BEGIN
  MakeUnprinted(0);
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD, L_XDoc.action_Reprint);
  TckRcDToPrint:=TckRcD.TckRcD;
  IF ~Stream THEN
   LIKEMENU(CALL, "TckRcD.TckRcD_Print(0)");
  END;
 END {TckRcD_RePrint};

 PRIVATE PROCEDURE TckRcD_OnAfterEdIns();
  VAR
   ItIsFirstLaying: SCAL[2];
 BEGIN
  SAVE(TckRcD);
  CHANGESEL(TckRcD, Storage, , TckRcD.Storage);
  ItIsFirstLaying:=(TckRcD.Type = L_TRS.trdt_Laying) & ~PREV(TckRcD);
  RESTORE(TckRcD);
  L_General.Assert(ItIsFirstLaying | SELECT(TckRcDL, TckRcD, TckRcD.TckRcD), "⮩ 㬥???");
 END {TckRcD_OnAfterEdIns};

 PRIVATE PROCEDURE TckRcD_OnAfterInsert();
  VAR
   Dummy1, Dummy2: NUMERIC[2];
 BEGIN
  TckRcD_OnAfterEdIns();
  L_TRS.bc_CheckDevices_Init();
  CONFORM(TckRcD, TckRcDL);
  WHILE OCCURE(TckRcDL) DO
   CONFORM(TckRcDL, TckKind);
   IF TckKind.Type = L_TRS.tkt_KKMActivities THEN
    L_General.Assert(~!TckRcDL.RestNbr, "室    " + TckRcDL.CUCopy);
    IF TckRcD.Type = L_TRS.trdt_Return THEN
     L_General.Assert(~!TckRcDL.Psg | ~L_TRS.TckKind_wPsg(),
                      "室 㪠 ⢮ ᠦ஢   " + TckRcDL.CUCopy);
     L_TRS.Calc2NumbersDifference(TckRcDL.TckKind, L_TRS.getTckLastRestNbr(1, TckRcDL.CUCopy),
                                  TckRcDL.RestNbr, Dummy1, Dummy2);
     L_TRS.bc_CheckDevices_Add(TckKind.Type, TckRcDL.CUCopy);
    ELSE
     L_General.CallUs(TckRcD.Type = L_TRS.trdt_Laying);
    END;
    L_TRS.KKMAdditionalActions(TckRcD.Type, TckRcDL.CUCopy, TckRcD.TckRcS);
   ELSIF TckKind.Type = L_TRS.tkt_VLDActivities THEN
    L_General.Assert(~L_TRS.IsSaleTckRcD(TckRcD.Type), "த  ??");
    IF TckRcD.Type # L_TRS.trdt_Laying THEN
     L_TRS.bc_CheckDevices_Add(TckKind.Type, TckRcDL.CUCopy);
    END;
    L_TRS.VLDAdditionalActions(TckRcD.Type, TckRcDL.CUCopy, TckRcD.TckRcS);
   END;
   NEXT(TckRcDL);
  END; (* WHILE OCCURE(TckRcDL) ... *)
  L_TRS.bc_CheckDevices_Check("");
  L_TRS.bc_CheckDevices_Deinit();
  Proceed(+1);
  TckRcD.PassDTS:=SYSTIMESTAMP();
  REPLACE(TckRcD);
  L_TRS.Correct_TckRcD_PassDTS();
  SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
  WHILE OCCURE(TckRcDL) DO
   L_TRS.CompleteTckRcDL();
   NEXT(TckRcDL);
  END; (* WHILE OCCURE(TckRcDL) ... *)
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD);
  TckRcD_RePrint(0);
 END {TckRcD_OnAfterInsert};

 PRIVATE PROCEDURE TckRcD_OnAfterEdit();
 BEGIN
  L_General.CallUs(L_TRS.IsSaleTckRcD(TckRcD.Type));
  TckRcD_OnAfterEdIns();
  Proceed(+1);
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD);
 END {TckRcD_OnAfterEdit};

 PRIVATE PROCEDURE CheckIsLastTckRcD(_TckRcD: LIKE(TckRcD.TckRcD));
 BEGIN
  SAVE(TckRcD);
  SEARCH(TckRcD, TckRcD, , _TckRcD);
  L_General.Assert(~!TckRcD.Storage, "室 㪠 ' ࠭'");
  CHANGESEL(TckRcD, Storage, , TckRcD.Storage); (* ??? *)
  WHILE NEXT(TckRcD) & (TckRcD.Status # L_TRS.trdStat_Passed) DO
  END;
  L_General.Assert(~OCCURE(TckRcD),
                   " 㬥  ᫥   ࠭");
  RESTORE(TckRcD);
 END {CheckIsLastTckRcD};

 PRIVATE PROCEDURE TckRcD_Status_OnSuccessfulChange();
 BEGIN
  L_General.Error("⨬   㬥");
 END {TckRcD_Status_OnSuccessfulChange};

 PRIVATE PROCEDURE InsertTckRcDL_FromBag(pt: L_TRS.tPackedTck);
 BEGIN
  TckRcDL.TckRcD  :=TckRcD.TckRcD;
  L_TRS.pt_Unpack(pt,
                  TckRcDL.TRDLNbr, TckRcDL.TckKind, TckRcDL.Series,
                  TckRcDL.RestNbr, TckRcDL.CUCopy, TckRcDL.Psg);
  REPLACE(TckRcDL);
  CONFORM(TckRcDL, TckKind);
  IF L_TRS.IsBulk_wCUC() THEN
   TckRcDL.RestNbr:=0;
   TckRcDL.Psg    :=0;
   REPLACE(TckRcDL);
   L_TRS.CompleteTckRcDL();
   SAVE(TckRcDL);
   CHANGESEL(TckRcDL, CUCopy, , TckRcDL.CUCopy, L_TRS.trdStat_Passed);
   PREV(TckRcDL);
   SELECT(TckRcDLL, TckRcD, , TckRcDL.TckRcD, TckRcDL.TRDLNbr);
   RESTORE(TckRcDL);
   WHILE OCCURE(TckRcDLL) DO
    IF !TckRcDLL.Sum THEN
     SAVE(TckRcDLL);
     TckRcDLL.TckRcD :=TckRcDL.TckRcD;
     TckRcDLL.TRDLNbr:=TckRcDL.TRDLNbr;
     TckRcDLL.PassDTS:=TckRcDL.PassDTS;
     INSERT(TckRcDLL);
     L_TRS.CompleteTckRcDLL();
     RESTORE(TckRcDLL);
    END;
    NEXT(TckRcDLL);
   END;
  ELSE
   L_TRS.CompleteTckRcDL();
  END;
 END {InsertTckRcDL_FromBag};

 PRIVATE PROCEDURE ChoiceTckRcDL_FromBag(): L_TRS.tPackedTck;
  VAR
   i, j     : NUMERIC[0];
   pta     : L_TRS.tPackedTck[1E2];
   _TRDLNbr: LIKE(TckRcDL.TRDLNbr);
   _TckKind: LIKE(TckRcDL.TckKind);
   _Series : LIKE(TckRcDL.Series);
   _RestNbr: LIKE(TckRcDL.RestNbr);
   _CUCopy : LIKE(TckRcDL.CUCopy);
   _Psg    : LIKE(TckRcDL.Psg);
   List    : STRING[];
   ptaIdx  : NUMERIC[0][1E2];
 BEGIN
  SAVE(TckRcDL);
  L_TRS.GetStorageTckSummary(TckRcD.Storage, TckRcD.TckRcS, TckRcD.TckRcD, 1, pta);
  List:="";
  i:=0;
  j:=0;
  WHILE ~!pta[i] DO
   IF L_TRS.pt_GetState(pta[i]) # L_TRS.ts_Returned THEN
    L_TRS.pt_Unpack(pta[i], _TRDLNbr, _TckKind, _Series, _RestNbr, _CUCopy,  _Psg);
    SEARCH(TckKind, TckKind, , _TckKind);
    IF ~SEARCH(TckRcDL, TckRcD, TckRcD.TckRcD, _TRDLNbr) &
       ~((TckKind.Type = L_TRS.tkt_PieceTck) & !_RestNbr) THEN
     List:=List + "|" + Str.Align(_Series, 13, LEFT) +
                  Str.Align(FLDTOSTR(_RestNbr, "0", TckKind.NbrPrc), 8, RIGHT) + "  " +
                  TckKind.TckKind + " " + Str.Align(TckKind.Name, 32, LEFT);
     ptaIdx[j]:=i;
     INC(j);
    END;
   END;
   INC(i);
  END;
  j:=L_StdFrm.ShowListAsMenu_Full(List, "",
                                  "                                             |"+
                                  "", 0);
  RESTORE(TckRcDL);
  RETURN pta[ptaIdx[j]];
 END {ChoiceTckRcDL_FromBag};

 PRIVATE PROCEDURE TckRcDL_OnBeforeInsert();
 BEGIN
  CheckNotEmpty_TckRcD_Type();
  IF   TckRcD.Type = L_TRS.trdt_Return THEN
   IF ~L_General.VariableIsInitialized(ptToInsert) | !ptToInsert THEN
    ptToInsert:=ChoiceTckRcDL_FromBag();
   END;
   InsertTckRcDL_FromBag(ptToInsert);
   SETEMPTY(ptToInsert);
   FIXALTERING();
  ELSE
   L_General.Assert(TckRcD.Type # L_TRS.trdt_Inventory, "⠢  㬥 ਧ樨 ⨬");
   L_TRS.AssignTckRcDL_TckNbr();
  END;
  TckRcDL_SetupWin();
 END {TckRcDL_OnBeforeInsert};

 PRIVATE PROCEDURE InteractiveSetup_TckRcDL_CUCopy(_Dir: NUMERIC[0]);
 BEGIN
  IF (TckRcD.Type = L_TRS.trdt_Laying) | L_TRS.IsSaleTckRcD(TckRcD.Type) THEN
   L_TRS.Setup_TckRcDL_CUCopy(_Dir);
  END;
 END {InteractiveSetup_TckRcDL_CUCopy};

 PRIVATE PROCEDURE InteractiveSetup_TckRcDLL_CUCopy(_Dir: NUMERIC[0]);
 BEGIN
  IF (TckRcD.Type = L_TRS.trdt_Laying) | L_TRS.IsSaleTckRcD(TckRcD.Type) THEN
   CONFORM(TckRcDL, TckKind);
   L_TRS.Setup_TckRcDLL_CUCopy(_Dir);
   IF (_Dir = +1) & L_TRS.IsBulk_wCUC() THEN
    IF TckRcD.Type = L_TRS.trdt_Laying THEN
     ctmf_Laying(TckRcDLL.CUCopy, TckRcDLL.RestNbr);
    ELSE
     ctmf_Sale(TckRcDLL.CUCopy, TckRcDLL.RestNbr);
    END;
   END;
  END;
 END {InteractiveSetup_TckRcDLL_CUCopy};

 PRIVATE PROCEDURE TckRcDL_OnBeforeEdit();
 BEGIN
  TckRcDL_SetupWin();
  InteractiveSetup_TckRcDL_CUCopy(-1);
 END {TckRcDL_OnBeforeEdit};

 PRIVATE PROCEDURE TckRcDL_OnBeforeDelete();
 BEGIN
  CheckNotEmpty_TckRcD_Type();
  IF    TckRcD.Type = L_TRS.trdt_Laying THEN
   L_General.Error(" 㬥  㤠 饭.    ࠭");
  ELSIF TckRcD.Type = L_TRS.trdt_Inventory THEN
   L_General.Error(" 㬥 ਧ樨 㤠 ⨬");
  END;
  InteractiveSetup_TckRcDL_CUCopy(-1);
 END {TckRcDL_OnBeforeDelete};

 PRIVATE PROCEDURE TckRcDL_OnAfterDelete();
 BEGIN
 END {TckRcDL_OnAfterDelete};

 PRIVATE PROCEDURE ctmf_CheckCUCStorage(CUCStr: STRING[]; _Storage: LIKE(Storage.Storage); StrgName: STRING[]);
  VAR
   tckStorage: LIKE(Storage.Storage);
 BEGIN
  L_General.Assert((TckRcD.Date >= MDocLCU.Date) & (TckRcD.PassDTS > MDocLCU.PassDTS),
                   "ୠ ᫥⥫쭮 .|" + CUCStr +
                   "||. " + L_MDoc.MDocStr(MDocLCU.MDocKind, MDocLCU.MDoc));
  tckStorage:=L_CUC.GetCurMDocLCUStorage();
  IF ~!tckStorage THEN
   L_General.Assert(tckStorage = _Storage,
                    CUCStr + " 室   " + tckStorage + ",    " + StrgName);
  ELSE
   L_General.Error(CUCStr + " ᯨᠭ");
  END;
 END {ctmf_CheckCUCStorage};

 PRIVATE PROCEDURE ctmf_Laying(_CUCopy: LIKE(CUCopy.CUCopy); _RestNbr: L_TRS.tTckNumber);
  VAR
   ts        : L_TRS.tTckState;
   tckStorage,
   curStorage: LIKE(Storage.Storage);
   curTckRcS : LIKE(TckRcS.TckRcS);
   CUCStr    : STRING[];
 BEGIN
  L_TRS.getTckLastLocation(1, _CUCopy, ts, curStorage, curTckRcS);
  SEARCH(CUCopy, CUCopy, , _CUCopy);
  CUCStr:="  " + _CUCopy + " (" + CUCopy.Serial + ")";
  IF    ts = L_TRS.ts_inBag THEN
   L_General.Error(CUCStr + " 㦥 뤠   " + curTckRcS);
  ELSIF ts = L_TRS.ts_Ended THEN
   L_General.Error(CUCStr + " 㦥 稫");
  ELSIF ts = L_TRS.ts_New THEN
   IF L_TRS.E_HasTckAtStorage(TckRcD.Date) THEN
    IF ~L_TRS.IsDevice(TckKind.Type) THEN
     L_General.Assert(L_CUC.AccessLastMDocLCU(_CUCopy), "ୠ ᫥⥫쭮 .|" + CUCStr);
     ctmf_CheckCUCStorage(CUCStr, L_TRS.TckOfficeStorage(TckRcD.Date, L_TRS.GetTckRcDMyFirm()), "");
     L_General.Assert(_RestNbr = L_TRS.PackFirstNbr(TckRcDL.TckKind, _RestNbr), "  㯠!");
    END;
   END;
  ELSIF ts = L_TRS.ts_Returned THEN
   L_General.Assert(_RestNbr = L_TRS.getTckLastRestNbr(1, _CUCopy), "孨  , 祬  ");
   IF L_TRS.E_HasTckAtStorage(TckRcD.Date) THEN
    SAVE(TckRcDL);
    SAVE(TckRcDLL);
    IF L_CUC.AccessLastMDocLCU(_CUCopy) &
      ~(L_CUC.SearchTckRcDL(_CUCopy, MDocLCU.Date, MDocLCU.PassDTS, 1)  & (TckRcDL.TckRcD # TckRcD.TckRcD)) &
      ~(L_CUC.SearchTckRcDLL(_CUCopy, MDocLCU.Date, MDocLCU.PassDTS, 1) & (TckRcDLL.TckRcD # TckRcD.TckRcD)) THEN
     ctmf_CheckCUCStorage(CUCStr, L_TRS.TckOfficeStorage(TckRcD.Date, L_TRS.GetTckRcDMyFirm()), "");
    END;
    RESTORE(TckRcDLL);
    RESTORE(TckRcDL);
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {ctmf_Laying};

 PRIVATE PROCEDURE ctmf_Sale(_CUCopy: LIKE(CUCopy.CUCopy); _RestNbr: L_TRS.tTckNumber);
  VAR
   ts        : L_TRS.tTckState;
   tckStorage,
   curStorage: LIKE(Storage.Storage);
   curTckRcS : LIKE(TckRcS.TckRcS);
   CUCStr    : STRING[];
 BEGIN
  L_TRS.getTckLastLocation(1, _CUCopy, ts, curStorage, curTckRcS);
  SEARCH(CUCopy, CUCopy, , _CUCopy);
  CUCStr:="  " + _CUCopy + " (" + CUCopy.Serial + ")";
  IF    ts = L_TRS.ts_inBag THEN
   L_General.Error(CUCStr + " 㦥 뤠   " + curTckRcS);
  ELSIF ts = L_TRS.ts_Ended THEN
   L_General.Error(CUCStr + " 㦥 稫");
  ELSIF ts = L_TRS.ts_New THEN
   IF L_TRS.E_HasTckAtStorage(TckRcD.Date) THEN
    IF ~L_TRS.IsDevice(TckKind.Type) THEN
     L_General.Assert(L_CUC.AccessLastMDocLCU(_CUCopy), "ୠ ᫥⥫쭮 .|" + CUCStr);
     ctmf_CheckCUCStorage(CUCStr, TckRcD.Storage, " " + TckRcD.Storage);
     L_General.Assert(_RestNbr = L_TRS.PackFirstNbr(TckRcDL.TckKind, _RestNbr), "  㯠!");
    END;
   END;
  ELSIF ts = L_TRS.ts_Returned THEN
   L_General.Assert(_RestNbr = L_TRS.getTckLastRestNbr(1, _CUCopy), "孨  , 祬  ");
   IF L_TRS.E_HasTckAtStorage(TckRcD.Date) THEN
    SAVE(TckRcDL);
    SAVE(TckRcDLL);
    IF L_CUC.AccessLastMDocLCU(_CUCopy) &
      ~(L_CUC.SearchTckRcDL(_CUCopy, MDocLCU.Date, MDocLCU.PassDTS, 1)  & (TckRcDL.TckRcD # TckRcD.TckRcD)) &
      ~(L_CUC.SearchTckRcDLL(_CUCopy, MDocLCU.Date, MDocLCU.PassDTS, 1) & (TckRcDLL.TckRcD # TckRcD.TckRcD)) THEN
     ctmf_CheckCUCStorage(CUCStr, TckRcD.Storage, " " + TckRcD.Storage);
    END;
    RESTORE(TckRcDLL);
    RESTORE(TckRcDL);
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {ctmf_Sale};

 PRIVATE PROCEDURE CheckTckMovementFeasibility();
  VAR
   ts        : L_TRS.tTckState;
   tckStorage,
   curStorage: LIKE(Storage.Storage);
   curTckRcS : LIKE(TckRcS.TckRcS);
 BEGIN
  IF    TckRcD.Type = L_TRS.trdt_Laying THEN
   CONFORM(TckRcDL, TckKind);
   IF L_TRS.IsBulk_wCUC() THEN
    SELECT(TckRcDLL, TckRcD, , TckRcDL.TckRcD, TckRcDL.TRDLNbr);
    WHILE OCCURE(TckRcDLL) DO
     ctmf_Laying(TckRcDLL.CUCopy, TckRcDLL.RestNbr);
     NEXT(TckRcDLL);
    END; (* WHILE OCCURE(TckRcDLL) ... *)
   ELSIF TckKind.Type # L_TRS.tkt_PieceTck THEN
    ctmf_Laying(TckRcDL.CUCopy, TckRcDL.RestNbr);
   END;
  ELSIF TckRcD.Type = L_TRS.trdt_Return THEN
   L_TRS.getTckLastLocation(1, TckRcDL.CUCopy, ts, curStorage, curTckRcS);
   CONFORM(TckRcDL, TckKind);
   L_General.CallUs((*L_TRS.IsBulk() | *)(TckRcD.Storage = curStorage));
   IF TckKind.wPsg THEN
    IF (TckKind.Type = L_TRS.tkt_KKMActivities) &
       (TckRcDL.RestNbr = L_TRS.getTckLastRestNbr(1, TckRcDL.CUCopy)) THEN
     L_General.Assert(TckRcDL.Psg = 0, "   ᠦ஢  祣  த.   " + TckRcDL.TckKind);
    END;
   END;
  ELSIF L_TRS.IsSaleTckRcD(TckRcD.Type) THEN
   CONFORM(TckRcDL, TckKind);
   IF L_TRS.IsBulk_wCUC() THEN
    SELECT(TckRcDLL, TckRcD, , TckRcDL.TckRcD, TckRcDL.TRDLNbr);
    WHILE OCCURE(TckRcDLL) DO
     ctmf_Sale(TckRcDLL.CUCopy, TckRcDLL.RestNbr);
     NEXT(TckRcDLL);
    END; (* WHILE OCCURE(TckRcDLL) ... *)
   ELSIF TckKind.Type = L_TRS.tkt_PieceTck THEN
    (* Nothing *)
   ELSIF TckKind.Type = L_TRS.tkt_EasySales THEN
    (* Nothing *)
   ELSE
    ctmf_Sale(TckRcDL.CUCopy, TckRcDL.RestNbr);
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {CheckTckMovementFeasibility};

 PRIVATE PROCEDURE TckRcDL_OnAfterEdIns();
 BEGIN
  CONFORM(TckRcDL, TckKind);
  IF ((TckRcD.Type = L_TRS.trdt_Laying) | L_TRS.IsSaleTckRcD(TckRcD.Type)) & ~L_TRS.IsBulk_wCUC() THEN
   L_General.Assert(~!TckRcDL.RestNbr, "室  '孨 '");
  END;
  IF L_TRS.IsBulk_wCUC() THEN
   L_General.Assert(SELECT(TckRcDLL, TckRcD, TckRcDL.TckRcD, TckRcDL.TRDLNbr),
                    "  ?");
  END;
  L_General.Assert(L_DatTim.IsActive(TckRcD.Date, TckKind.Begin, TckKind.Till),
                   "  " + TckRcDL.TckKind + "   " + L_DatTim.DateStr(TckRcD.Date));
  InteractiveSetup_TckRcDL_CUCopy(+1);
  L_TRS.CompleteTckRcDL();
  CheckTckMovementFeasibility();
 END {TckRcDL_OnAfterEdIns};

 PRIVATE PROCEDURE TckRcDL_OnAfterEdit();
 BEGIN
  TckRcDL_OnAfterEdIns();
 END {TckRcDL_OnAfterEdit};

 PRIVATE PROCEDURE TckRcDL_OnAfterInsert();
 BEGIN
  TckRcDL_OnAfterEdIns();
 END {TckRcDL_OnAfterInsert};

 PRIVATE PROCEDURE TckRcDL_TckKind_OnSuccessfulChange();
 BEGIN
  CONFORM(TckRcDL, TckKind);
  IF    (L_WDO.getActiveForm().OriginalName = "TckRcDLE") THEN
   IF L_TRS.IsBulk_wCUC() THEN
    L_General.Error(" 㯯 ஢ 筮  ந . . F9");
   ELSIF (TckKind.Type = L_TRS.tkt_PieceTck) THEN
    SAVE(TckRcDL);
    SAVE(TckRcD);
    CONFORM(TckRcDL, TckRcD);
    IF TckRcD.Type = L_TRS.trdt_Laying THEN
     SELECT(TckRcD, TckRcS, , TckRcD.TckRcS);
     WHILE OCCURE(TckRcD) DO
      IF (TckRcD.Type = L_TRS.trdt_Return) & (TckRcD.Status # L_TRS.trdStat_Canceled) THEN
       SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
       WHILE OCCURE(TckRcDL) DO
        L_General.Assert(TckRcDL.TckKind # TckKind.TckKind,
                         "  㦥 ଫ   " + TckKind.TckKind + "." +
                         "||ଫ  뤠  ⮬   .");
        NEXT(TckRcDL);
       END; (* WHILE OCCURE(TckRcDL) ... *)
      END;
      NEXT(TckRcD);
     END; (* WHILE OCCURE(TckRcD) ... *)
    END;
    RESTORE(TckRcD);
    RESTORE(TckRcDL);
    TckRcDL.Series:="㯯";
    REPLACE(TckRcDL);
   ELSE
    L_General.Assert(TckKind.Type = L_TRS.tkt_Ticket, "᪠ 筮  ⮫쪮 ⭮ த樨");
   END;
  ELSIF L_WDO.getActiveForm().OriginalName = "TckRcDLEE" THEN
   L_General.Assert(L_TRS.IsBulk() | (TckKind.Type = L_TRS.tkt_EasySales),
                    "த  ⨯ '" + L_Str.PoolItem(L_TRS.tkt_Pool, TckKind.Type) + "'  ᪠");
   L_General.Assert(~SELECT(TckRcDLL, TckRcD, TckRcDL.TckRcD, TckRcDL.TRDLNbr),
                    "  祭 த ⮢.    ⨬.");
   TckRcDL.Series :="㯯";
   TckRcDL.RestNbr:=0;
   TckRcDL.Psg    :=0;
   REPLACE(TckRcDL);
  END;
  TckRcDL_SetupWin();
 END {TckRcDL_TckKind_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcDL_Series_OnSuccessfulChange();
 BEGIN
  IF ~!TckRcDL.Series THEN
   L_General.Assert(~!TckRcDL.TckKind, " 㪠  ⭮ த樨");
   TckRcDL.Series:=Str.Cap(TckRcDL.Series);
   L_TRS.CheckTicketSeries(TckRcDL.TckKind, TckRcDL.Series);
   REPLACE(TckRcDL);
  END;
 END {TckRcDL_Series_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcDL_RestNbr_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!TckRcDL.TckKind, " 㪠  ⭮ த樨");
  CONFORM(TckRcDL, TckKind);
  IF L_WDO.getActiveForm().OriginalName = "TckRcDLEE" THEN
   L_General.Assert(~L_TRS.IsBulk_wCUC(), "㬬 த ⮢ ⠥ ⮬᪨");
  ELSE
   L_TRS.SupportRestNbrChanging(1, TckRcD.Type, TckRcDL.CUCopy, TckRcDL.RestNbr);
   REPLACE(TckRcDL);
  END;
 END {TckRcDL_RestNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcDL_Psg_OnSuccessfulChange();
 BEGIN
  IF L_WDO.getActiveForm().OriginalName = "TckRcDLEE" THEN
   L_General.Assert(~!TckRcDL.TckKind, " 㪠  ⭮ த樨");
   CONFORM(TckRcDL, TckKind);
   IF    L_TRS.IsBulk_wCUC() THEN
    L_General.Error("⢮ த ⮢ ⠥ ⮬᪨");
   ELSIF TckKind.Type = L_TRS.tkt_PieceTck THEN
    TckRcDL.RestNbr:=TckRcDL.Psg * TckKind.FaceVal;
    REPLACE(TckRcDL);
   END;
  END;
 END {TckRcDL_Psg_OnSuccessfulChange};

 PRIVATE PROCEDURE potctrd_Line(VAR i: NUMERIC[0]; s1, s2, s3: STRING[]): STRING[];
  VAR
   nppStr: STRING[];
 BEGIN
  INC(i);
  IF    L_TRS.IsSaleTckRcD(TckRcD.Type)  THEN
   nppStr:=L_Str.FixedIntStr(i, 2);
  ELSE
   nppStr:=TckRcDL.TRDLNbr;
  END;
  RETURN nppStr + " " + Str.Align(s1, 14, LEFT) + " " +
         Str.Align(s2, 9, RIGHT) + " " + Str.Align(s3, 8, RIGHT);
 END {potctrd_Line};

 PRIVATE PROCEDURE potctrd_BulkLine(VAR i: NUMERIC[0]): STRING[];
 BEGIN
  RETURN potctrd_Line(i, TckKind.Name,
                      L_Str.Right(TckRcDLL.Series, 9),
                      FLDTOSTR(TckRcDLL.RestNbr, "0", TckKind.NbrPrc));
 END {potctrd_BulkLine};

 PRIVATE PROCEDURE potctrd_StdLine(VAR i: NUMERIC[0]; FaceValFormat, RestNbrStr: STRING[]): STRING[];
  VAR
   s: STRING[];
 BEGIN
  IF ~!TckRcDL.CUCopy THEN
   s:="(" + TckRcDL.CUCopy + ") ";
  ELSE
   s:="        ";
  END;
  RETURN potctrd_Line(i, s + FLDTOSTR(TckKind.FaceVal, FaceValFormat, 5),
                      L_Str.Right(TckRcDL.Series, 9), RestNbrStr);
 END {potctrd_StdLine};

 PRIVATE PROCEDURE PrintOneTicketCassTckRcD(trdPrt: PRINTJOB);
  CONST
   DefaultPosForSign = 55;
  VAR
   Pt08,
   Pt09,
   Pt10,
   Pt11,
   Pt11B        : TEXTSTYLE;
   i,
   Y            : NUMERIC[0];
   FaceValFormat,
   SubsidiaryMoneyStr,
   RestNbrStr,
   AsWho_asStr  : STRING[];
 BEGIN
  trdPrt.StartPage();
  Pt08 :=L_Print.ts_Create(08, "Lucida Console");
  IF L_General.GetOSPlatform() = L_General.osp_WinNT THEN
   Pt08.CharExtra:=-0.2;
  ELSE
   Pt08.CharExtra:=-0.3;
  END;
  Pt09 :=L_Print.ts_Resize(Pt08, 09);
  Pt10 :=L_Print.ts_Resize(Pt08, 10);
  Pt11 :=L_Print.ts_Resize(Pt08, 11);
  Pt11B:=L_Print.ts_Resize(Pt08, 11);
  Pt11B.Font.Weight:=FONT.Weight_SemiBold;

  CONFORM(TckRcD, Storage);
  IF ~!TckRcD.TckRcS THEN
   CONFORM(TckRcD, TckRcS);
  END;
  CONFORM(TckRcD, Staff);
  CONFORM(Staff, Man);

  Y:=0;

  L_Print.TypeS(trdPrt,  0, Y, P_Firm.FP_FirmShortName(L_Staff.GetFirmOfStaff(), SYSDATE()), Pt08);
  INC(Y, 3);
  L_Print.TypeS(trdPrt, 38, Y, L_DatTim.DateTimeStr(SYSDATE(), SYSTIME()), Pt08);
  INC(Y, 3);
  L_Print.TypeS(trdPrt,  0, Y, L_Str.PoolItem(L_TRS.trdt_Pool, TckRcD.Type), Pt11B);
  IF    TckRcD.Type = L_TRS.trdt_Laying THEN
   L_Print.TypeS(trdPrt, 21, Y, "⭮ த樨", Pt10);
  ELSIF TckRcD.Type = L_TRS.trdt_Inventory THEN
   L_Print.TypeS(trdPrt, 34.5, Y, "⭮ 㬪",     Pt10);
  ELSIF TckRcD.Type = L_TRS.trdt_Return    THEN
   L_Print.TypeS(trdPrt, 18, Y, "⭮ த樨", Pt10);
  END;
  IF TckRcD.Status = L_TRS.trdStat_Canceled THEN
   INC(Y, 4);
   L_Print.TypeS(trdPrt, 15, Y, "()", Pt11B);
  END;
  INC(Y, 4);
  L_Print.TypeS(trdPrt, 0, Y,
                TckRcD.TckRcD + "(" + TckRcD.CopyCnt+")  " + L_DatTim.DateStr(TckRcD.Date),
                Pt10);
  INC(Y, 4);
  L_Print.TypeS(trdPrt, 0, Y,
                L_Str.PoolItem(L_Stock.st_Pool_SH, Storage.Type) + " " +
                Storage.Storage + " " + Storage.Name,
                Pt09);
  IF TckRcD.Type = L_TRS.trdt_Inventory THEN
   L_Print.TypeS(trdPrt, 52, Y, "/ᤠ", Pt09);
  END;

  IF ~!TckRcD.TckRcS THEN
   IF ~!TckRcS.AsWho THEN
    AsWho_asStr:=L_Str.PoolItem(L_Way.trs_Pool, TckRcS.AsWho);
   ELSE
    (* ⮬᪨ ନ஢   筮   㥬 ࠡ⭨ *)
    AsWho_asStr:="---";
   END;
   INC(Y, 4);
   L_Print.TypeS(trdPrt, 0, Y, " " + TckRcD.TckRcS + ", " + AsWho_asStr, Pt09);
   IF TckRcD.Type = L_TRS.trdt_Inventory THEN
    L_Print.TypeS(trdPrt, 52, Y, "/ᤠ", Pt09);
   END;
   INC(Y, 4);
   L_Print.TypeS(trdPrt, 0, Y, Staff.TSN + " " + Man.Name, Pt09);
  ELSE
   AsWho_asStr:="⭨";
  END;
  INC(Y, 5);
  L_Print.TypeS(trdPrt, 0, Y, "                     ", Pt09);
  INC(Y, 1);
  L_Print.TypeS(trdPrt, 0, Y, "____________________________________", Pt09);

  i:=0;
  SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
  WHILE OCCURE(TckRcDL) DO
   CONFORM(TckRcDL, TckKind);
   IF    L_TRS.IsSaleTckRcD(TckRcD.Type) & L_TRS.IsBulk_wCUC() THEN
    CONFORM(TckRcDL, TckRcDLL);
    WHILE OCCURE(TckRcDLL) DO
     L_Print.ChequeBand_BeforePrintLine(trdPrt, Y, 6.5);
     INC(Y, 4);
     L_Print.TypeS(trdPrt, 0,      Y, potctrd_BulkLine(i),                               Pt09);
     INC(Y, 2.5);
     IF ~!TckRcDLL.SnTckTrf THEN
      CONFORM(TckRcDLL, SnTckRng);
      L_Print.TypeS(trdPrt, 5,      Y, L_Str.IntStr(TckRcDLL.Sum) + "= " + SnTckRng.Name, Pt08);
     ELSE
      L_Print.TypeS(trdPrt, 5,      Y, L_Str.IntStr(TckRcDLL.Sum) + "=", Pt08);
     END;
     NEXT(TckRcDLL);
    END; (* WHILE OCCURE(TckRcDLL) ... *)
   ELSIF TckKind.Type = L_TRS.tkt_EasySales THEN
    L_Print.ChequeBand_BeforePrintLine(trdPrt, Y, 4);
    INC(Y, 4);
    L_Print.TypeS(trdPrt, 0,      Y, potctrd_Line(i, TckKind.Name, "---",
                                                  L_Str.IntStr(TckRcDL.RestNbr)),        Pt09);
   ELSIF TckKind.Type = L_TRS.tkt_ZonalTicket THEN
    L_Print.ChequeBand_BeforePrintLine(trdPrt, Y, 4);
    INC(Y, 4);
    L_Print.TypeS(trdPrt, 0,      Y, potctrd_Line(i, TckKind.Name, TckRcDL.Series,
                                                  L_Str.IntStr(L_TRS.BulkCUCAmount())),  Pt09);
   ELSE
    IF Math.Mod(TckKind.FaceVal, 1) = 0 THEN
     FaceValFormat:="0=";
    ELSE
     FaceValFormat:="2-";
     L_General.Assert(TckKind.FaceVal < 1, "࠭ ⮨  " + FLDTOSTR(TckKind.FaceVal, FaceValFormat));
    END;
    IF    L_TRS.IsBulk_wCUC() THEN
     RestNbrStr:=L_Str.IntStr(L_TRS.BulkCUCAmount());
    ELSIF L_TRS.RestNbrIsAmount() THEN
     RestNbrStr:=L_Str.IntStr(TckRcDL.RestNbr);
    ELSE
     RestNbrStr:=FLDTOSTR(TckRcDL.RestNbr, "0", TckKind.NbrPrc);
    END;
    L_Print.ChequeBand_BeforePrintLine(trdPrt, Y, 4);
    INC(Y, 4);
    L_Print.TypeS(trdPrt, 0,      Y, potctrd_StdLine(i, FaceValFormat, RestNbrStr),         Pt09);
   END;
   NEXT(TckRcDL);
  END; (* WHILE OCCURE(TckRcDL) ... *)

  IF TckRcD.Type = L_TRS.trdt_Inventory THEN
   SubsidiaryMoneyStr:=L_TRSP.E_PrintSubsidiaryMoneyInReceipt(TckRcD.Date);
   IF ~!SubsidiaryMoneyStr THEN
    L_Print.ChequeBand_BeforePrintLine(trdPrt, Y, 7);
    INC(Y, 3);
    L_Print.TypeS(trdPrt, 0, Y, "", Pt09);
    INC(Y, 4);
    L_Print.TypeS(trdPrt, 0, Y, SubsidiaryMoneyStr, Pt09);
   END;
  END;

  L_Print.ChequeBand_BeforePrintLine(trdPrt, Y, 12);
  INC(Y, 4);
  Y:=Math.Max(Y, DefaultPosForSign);
  L_Print.TypeS(trdPrt,  0, Y, "", Pt09);
  INC(Y, 2);
  L_Print.TypeS(trdPrt, 12, Y, "_________ /" + L_Str.ShortName(P_Man.GetFullNameOfCurrentUser(SYSDATE())) + "/", Pt09);
  INC(Y, 4);
  L_Print.TypeS(trdPrt,  0, Y, AsWho_asStr, Pt09);
  INC(Y, 2);
  L_Print.TypeS(trdPrt, 12, Y, "_________ /" + L_Str.ShortName(Man.Name) + "/", Pt09);
  trdPrt.EndPage();
 END {PrintOneTicketCassTckRcD};

(*
$P{ TRDPR_Top:
P_Firm.FP_FirmName(P_Firm.fomf(Storage.MyFirm), SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
"㬥   ⭮ த樨 (" + L_Str.PoolItem(L_TRS.trdt_Pool, TckRcD.Type) + ") " + TckRcD.TckRcD + "(" + TckRcD.CopyCnt + ")  " + L_DatTim.DateStr(TckRcD.Date), C, ""
TckRcD.Storage, L, ""
Storage.Name, L, ""
Firm.Firm, L, ""
P_Firm.FP_FirmName(Firm.Firm, SYSDATE()), L, ""
@
############################################################################################# ########## #####

##############################################################################################################

 ࠭ ####### #######################################################################################
㯠⥫     #### ##########################################################################################

==============================================================================================================
| ⭮ த樨       |,     |                                               |   㬬|
|-----------------------------|----------------|----------------------------------------------------|--------|
}
*)

(*
$P{ TRDPR_Line:
TckRcDL.TckKind, L, ""
TckKind.Name, L, ""
CUCopy.Serial, L, ""
TckRcDLL.SnTckTrf, L, ""
SnTckRng.Name, L, ""
SnTckTrf.Type, L, L_TRS.sttt_Pool
TckRcDLL.Sum, R, "0"
@
|#### ########################|################|##### ############################## ###############|########|
}
*)

(*
$P{ TRDPR_Bot:
@
==============================================================================================================
}
*)

 PRIVATE PROCEDURE PrintOneSaleTckRcD();
 BEGIN
  OPENREP(R, L_General.NameConnection("TRDPR"), Print, MinCharsPerLine, 110);
  CONFORM(TckRcD, Storage);
  CONFORM(TckRcD, Firm);
  MAKEPART(R, TRDPR_Top);
  CONFORM(TckRcD, TckRcDL);
  WHILE OCCURE(TckRcDL) DO
   CONFORM(TckRcDL, TckRcDLL);
   CONFORM(TckRcDL, TckKind);
   WHILE OCCURE(TckRcDLL) DO
    CONFORM(TckRcDLL, CUCopy);
    CONFORM(TckRcDLL, SnTckTrf);
    CONFORM(SnTckTrf, SnTckRng);
    MAKEPART(R, TRDPR_Line);
    NEXT(TckRcDLL);
   END; (* WHILE OCCURE(TckRcDLL) ... *)
   NEXT(TckRcDL);
  END; (* WHILE OCCURE(TckRcDL) ... *)
  MAKEPART(R, TRDPR_Bot);
  CLOSEREP(R);
 END {PrintOneSaleTckRcD};

 PUBLIC PROCEDURE TckRcD_Print(Stream: SCAL[2]);
  VAR
   trdPrt: PRINTJOB;
 BEGIN
  TRY
   SAVE(TckRcD);
   L_General.Assert(SEARCH(TckRcD, TckRcD, TckRcDToPrint),
                    "  㬥   ⭮ த樨 " + TckRcDToPrint + " ()");
   L_General.Assert(TckRcD.Status = L_TRS.trdStat_Passed, " ⨬ ⮫쪮  ஢ ");
   IF ~!TckRcD.TSN THEN
    trdPrt:=L_Print.pj_Create_ChequeBand("㬥   ⭮ த樨 " + TckRcD.TckRcD);
    PrintOneTicketCassTckRcD(trdPrt);
    IF (L_Print.Cheque_BandType() = L_Print.bt_Single) &
       ~((L_General.GetAPSiteID() = "84") & (TckRcD.Type = L_TRS.trdt_Inventory)) THEN
     PrintOneTicketCassTckRcD(trdPrt);
    END;
    trdPrt.Close();
   ELSIF L_TRS.IsSaleTckRcD(TckRcD.Type) & ~!TckRcD.Firm THEN
    PrintOneSaleTckRcD();
   ELSE
    (* த     *)
   END; (*IF L_TRS.IsSaleTckRcD(TckRcD.Type) *)
   RESTORE(TckRcD);
  EXCEPT
  ON Exc: Exc_Root DO
   L_StdFrm.ShowINFORM_AsSTOP(Exc.MsgOriginalText);
  END; (* TRY *)
 END {TckRcD_Print};

 PUBLIC PROCEDURE InputTckRcDL_byBCS();
  VAR
   tckType: L_TRS.tTckKindType;
 BEGIN
  SAVE(TckRcS);
  L_General.Assert(TckRcD.Type # L_TRS.trdt_Return, "⠢  㬥    ⨬");
  CONFORM(TckRcD, TckRcS);
  L_General.Assert(~!TckRcS.Date, "'筠'  ன ⨬");
  RESTORE(TckRcS);
  SETEMPTY(tckType);
  L_TRS.bc_PositionOnDevice("  ன⢠", tckType, TckRcD.Type = L_TRS.trdt_Laying);
  L_TRS.CheckDeviceMovementFeasibility(CUCopy.CUCopy, tckType, TckRcD.Type, TckRcD.TckRcS, TckRcD.Storage);
  L_TRS.Insert_TckRcDL(EMPTYOF(TckRcDL.TRDLNbr),
                       L_TRS.GetMathTckKind(CUCopy.Math, tckType, TckRcD.Date),
                       CUCopy.Serial,
                       L_TRS.getTckLastRestNbr(0, CUCopy.CUCopy),
                       EMPTYOF(TckRcDL.Psg),
                       CUCopy.CUCopy);
 END {InputTckRcDL_byBCS};

 PRIVATE VAR
  LastError: STRING[];

 PRIVATE PROCEDURE EnterForm(Title, Hint, Message: STRING[]): STRING[];
  VAR
   Dummy  : L_BarCode.tBarCodeType;
   BarCode: STRING[];
 BEGIN
  IF ~!LastError THEN
   L_BarCode.GetBarCode(Title, Hint, LastError, 1, 1, BarCode, Dummy);
  ELSE
   L_BarCode.GetBarCode(Title, Hint, Message,   0, 1, BarCode, Dummy);
  END;
  RETURN BarCode;
 END {EnterForm};

 PUBLIC PROCEDURE intInputTckRcDLL_byBCS(): SCAL[2];
  VAR
   BarCode   : STRING[];
   curDocType: L_XDoc.tXDocType;
   curDocKind: L_XDoc.tXDocKind;
   curMath,
   curDoc    : L_XDoc.tXDoc;
   curCopyCnt: L_XDoc.tCopyCnt;
 BEGIN
  BarCode:=EnterForm("  筮 ", "", "");
  IF !BarCode THEN
   RETURN 0;
  END;
  L_XDoc.DecodeBarCode(L_BarCode.SCAN_STD_KBSCAN, BarCode, 1, curDocType, curDocKind, curDoc, curCopyCnt);
  IF    curDocType = L_XDoc.xdt_CUCopy THEN
   L_General.Assert(SEARCH(CUCopy, CUCopy, curDoc), "   " + curDoc);
  ELSIF curDocType = L_XDoc.xdt_Math THEN
   IF ~(L_XDoc.SearchMathBySerial(BarCode, curMath) & SEARCH(CUCopy, Serial, BarCode, curMath)) THEN
    L_General.Assert(~!curDoc, "᪠஢   ⭮    |"+BarCode);
    SEARCH(Math, Math, , curDoc);
    CONFORM(Math, CarUnit);
    IF CarUnit.SNDate <= SYSDATE() THEN
     SETEMPTY(LastError);
     BarCode:=EnterForm("᪮ ", " " + Math.Math + " " + Math.Name, "");
    ELSE
     L_General.Error(" ஢  " + Math.Math + " " + Math.Name + "  ");
    END;
    L_General.Assert(SEARCH(CUCopy, Serial, BarCode, Math.Math),
                     "   |" + Math.Math + " " + Math.Name +
                     "| ᪨ ஬ " + BarCode);
   END;
  ELSE
   L_General.Error(" ᪠஢     ");
  END;
  RETURN 1;
 END {intInputTckRcDLL_byBCS};

 PUBLIC PROCEDURE LayingTckRcDLL_byBCS(le: STRING[]);
  VAR
   _exit: SCAL[2];
 BEGIN
  LastError:=le;
  TRY
   _exit:=~intInputTckRcDLL_byBCS();
   IF ~_exit THEN
    LastError:="";
    SELECT(TckRcDLL, TckRcD, , TckRcDL.TckRcD, TckRcDL.TRDLNbr);
    WHILE OCCURE(TckRcDLL) & (TckRcDLL.CUCopy # CUCopy.CUCopy) DO
     NEXT(TckRcDLL);
    END; (* WHILE OCCURE(TckRcDLL) ... *)
    IF OCCURE(TckRcDLL) THEN
     LastError:=" " + CUCopy.CUCopy + ", ᪮  " + CUCopy.Serial +
                "|㦥    㬥";
    ELSE
     TckRcDLL_OnBeforeInsert();
     DEFAULT(TckRcDLL);
     TckRcDLL.TckRcD :=TckRcDL.TckRcD;
     TckRcDLL.TRDLNbr:=TckRcDL.TRDLNbr;
     TckRcDLL.CUCopy :=CUCopy.CUCopy;
     L_TRS.cc_SplitTckSerial(CUCopy.Serial, TckRcDLL.Series, TckRcDLL.RestNbr);
     INSERT(TckRcDLL);
     TckRcDLL_OnAfterInsert();
    END;
    IF (RTI.Get().CurWindow.OriginalName = "TckRcDLEE") & OCCURE(TckRcDLL) THEN
     SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), TckRcDLL);
    END;
   END;
  EXCEPT
  ON Exc: Exc_Raise DO
   LastError:=Exc.MsgOriginalText;
   _exit:=Exc.MsgOriginalText = L_BarCode.ed_FinalError;
  END; (* TRY *)
  IF ~_exit THEN
   LIKEMENU(CALL, "TckRcD.LayingTckRcDLL_byBCS('"+LastError+"')");
  END;
 END {LayingTckRcDLL_byBCS};

 PUBLIC PROCEDURE SetNotSoldTckRcDLL_byBCS(le: STRING[]);
  VAR
   _exit: SCAL[2];
 BEGIN
  LastError:=le;
  TRY
   _exit:=~intInputTckRcDLL_byBCS();
   IF ~_exit THEN
    LastError:="";
    SELECT(TckRcDLL, TckRcD, , TckRcDL.TckRcD, TckRcDL.TRDLNbr);
    WHILE OCCURE(TckRcDLL) & (TckRcDLL.CUCopy # CUCopy.CUCopy) DO
     NEXT(TckRcDLL);
    END; (* WHILE OCCURE(TckRcDLL) ... *)
    L_General.Assert(OCCURE(TckRcDLL),
                     " " + CUCopy.CUCopy + ", ᪮  " + CUCopy.Serial + "  뫮  㬪");
    TckRcDLL_OnModify(-1);
    SETEMPTY(TckRcDLL.Sum);
    REPLACE(TckRcDLL);
    TckRcDLL_OnModify(+1);
    IF (RTI.Get().CurWindow.OriginalName = "TckRcDLEE") & OCCURE(TckRcDLL) THEN
     SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), TckRcDLL);
    END;
   END;
  EXCEPT
  ON Exc: Exc_Raise DO
   LastError:=Exc.MsgOriginalText;
   _exit:=Exc.MsgOriginalText = L_BarCode.ed_FinalError;
  END; (* TRY *)
  IF ~_exit THEN
   LIKEMENU(CALL, "TckRcD.SetNotSoldTckRcDLL_byBCS('"+LastError+"')");
  END;
 END {SetNotSoldTckRcDLL_byBCS};

 PUBLIC PROCEDURE InputTckRcDLL_byBCS();
 BEGIN
  ACCESS(TckRcDL);
  CONFORM(TckRcDL, TckRcD);
  IF (TckRcD.Type = L_TRS.trdt_Laying) | L_TRS.IsSaleTckRcD(TckRcD.Type) THEN
   LayingTckRcDLL_byBCS("");
  ELSE
   CONFORM(TckRcDL, TckKind);
   L_General.Assert(TckKind.Type = L_TRS.tkt_PieceTck_wCUC, "쪮  筮   䨪஢ ");
   SELECT(TckRcDLL, TckRcD, , TckRcDL.TckRcD, TckRcDL.TRDLNbr);
   WHILE OCCURE(TckRcDLL) DO
    TckRcDLL_OnModify(-1);
    TckRcDLL.Sum:=TckKind.FaceVal;
    REPLACE(TckRcDLL);
    TckRcDLL_OnModify(+1);
    NEXT(TckRcDLL);
   END; (* WHILE OCCURE(TckRcDLL) ... *)
   FIRST(TckRcDLL);
   IF (RTI.Get().CurWindow.OriginalName = "TckRcDLEE") & OCCURE(TckRcDLL) THEN
    SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), TckRcDLL);
   END;
   LIKEMENU(CALL, "TckRcD.SetNotSoldTckRcDLL_byBCS('')");
  END;
 END {InputTckRcDLL_byBCS};

 PRIVATE PROCEDURE TckRcDE_OnConformToWindow();
 BEGIN
  IF ~ACCESS(TckRcD) THEN
   SELECT(TckRcD, TckRcD);
  END;
  SE_WWD_CURSOR("TckRcDE", TckRcD);
 END {TckRcDE_OnConformToWindow};

 PUBLIC PROCEDURE CancelTckRcD();
 BEGIN
  ACCESS(TckRcD);
  L_General.Assert(TckRcD.Status # L_TRS.trdStat_Canceled, " 㦥 㫨஢");
  L_General.Assert((TckRcD.Type = L_TRS.trdt_Return) | (TckRcD.Type = L_TRS.trdt_Laying),
                   "㫨஢  ⨯ '" + L_Str.PoolItem(L_TRS.trdt_Pool, TckRcD.Type) + "' 饭");
  L_General.Assert(~HasGeneratedMDoc(),
                   " ନ஢ ⮢ 㬥. 㫨஢ 饭");
  CONFORM(TckRcD, TckRcS);
  L_General.Assert(TckRcS.Status < L_TRS.trsStat_Taken, " ਭ ");
  SAVE(TckRcD);
  CHANGESEL(TckRcD, Storage, , TckRcD.Storage);
  WHILE NEXT(TckRcD) DO
   L_General.Assert(TckRcD.Status = L_TRS.trdStat_Canceled,
                    "  ᫥ ஢   ⭮ 㬪 " + TckRcD.Storage);
  END; (* WHILE OCCURE(TckRcD) ... *)
  RESTORE(TckRcD);

  TckRcD.Status:=L_TRS.trdStat_Canceled;
  REPLACE(TckRcD);
  SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
  WHILE OCCURE(TckRcDL) DO
   L_TRS.MustBeLastCUCopyTckRcDL();
   TckRcDL.Status:=TckRcD.Status;
   REPLACE(TckRcDL);
   CONFORM(TckRcDL, TckRcDLL);
   WHILE OCCURE(TckRcDLL) DO
    L_TRS.MustBeLastCUCopyTckRcDLL();
    TckRcDLL.Status:=TckRcD.Status;
    REPLACE(TckRcDLL);
    NEXT(TckRcDLL);
   END; (* WHILE OCCURE(TckRcDLL) ... *)
   NEXT(TckRcDL);
  END; (* WHILE OCCURE(TckRcDL) ... *)
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD, L_XDoc.action_AutoEdit);
 END {CancelTckRcD};

 PRIVATE PROCEDURE TckRcDLL_OnBeforeInsert();
 BEGIN
  L_General.Assert(ACCESS(TckRcDL), " ⠭ ப ");
  CONFORM(TckRcDL, TckRcD);
  L_General.Assert((TckRcD.Type = L_TRS.trdt_Laying) | L_TRS.IsSaleTckRcD(TckRcD.Type), "⠢ 饭");
  L_General.Assert(~!TckRcDL.TckKind, " 㪠  ");
  CONFORM(TckRcDL, TckKind);
  L_General.Assert(L_TRS.IsBulk_wCUC(), "祭 ஢    " + TckKind.TckKind + "  ॡ");
 END {TckRcDLL_OnBeforeInsert};

 PRIVATE PROCEDURE TckRcDLL_OnModify(Sign: NUMERIC[0]);
 BEGIN
  CONFORM(TckRcDLL, TckRcDL);
  CONFORM(TckRcDL, TckRcD);
  IF ~!TckRcDLL.Sum THEN
   CONFORM(TckRcDL, TckKind);
   IF    TckKind.Type = L_TRS.tkt_PieceTck_wCUC THEN
    L_General.Assert(!TckRcDLL.Sum | (TckRcDLL.Sum = TckKind.FaceVal), " த   ?");
   ELSIF TckKind.Type = L_TRS.tkt_ZonalTicket THEN
    L_General.Assert(!TckRcDLL.Sum | (TckRcDLL.Sum <= TckKind.FaceVal), " த ஦ ?");
   END;
   IF ~!TckRcDLL.SnTckTrf THEN
    CONFORM(TckRcDLL, SnTckTrf);
    L_General.Assert(TckRcDLL.Sum = SnTckTrf.Price, " த   ?");
   END;
   INC(TckRcDL.RestNbr, Sign*TckRcDLL.Sum);
   INC(TckRcDL.Psg, Sign);
   REPLACE(TckRcDL);
   IF TckRcD.Type = L_TRS.trdt_Inventory THEN
    CALL(BegTRS.bullshitRenovateBegTRSPermanents());
   END;
  ELSE
   L_General.Assert(~L_TRS.IsSaleTckRcD(TckRcD.Type), " 㪠 㬬");
  END;
 END {TckRcDLL_OnModify};

 PRIVATE PROCEDURE TckRcDLL_OnBeforeEdit();
 BEGIN
  TckRcDLL_OnModify(-1);
  InteractiveSetup_TckRcDLL_CUCopy(-1);
 END {TckRcDLL_OnBeforeEdit};

 PUBLIC PROCEDURE TckRcDLL_OnBeforeDelete();
 BEGIN
  CONFORM(TckRcDLL, TckRcD);
  L_General.Assert((TckRcD.Type = L_TRS.trdt_Laying) | L_TRS.IsSaleTckRcD(TckRcD.Type), " 饭");
  TckRcDLL_OnModify(-1);
  InteractiveSetup_TckRcDLL_CUCopy(-1);
 END {TckRcDLL_OnBeforeDelete};

 PRIVATE PROCEDURE TckRcDLL_OnAfterEdit();
 BEGIN
  TckRcDLL_OnModify(+1);
  InteractiveSetup_TckRcDLL_CUCopy(+1);
 END {TckRcDLL_OnAfterEdit};

 PUBLIC PROCEDURE TckRcDLL_OnAfterInsert();
 BEGIN
  TckRcDLL_OnModify(+1);
  InteractiveSetup_TckRcDLL_CUCopy(+1);
 END {TckRcDLL_OnAfterInsert};

 PUBLIC PROCEDURE ToggleIsSold();
 BEGIN
  L_General.Assert(ACCESS(TckRcDLL), " ⠭ ");
  CONFORM(TckRcDLL, TckRcDL);
  CONFORM(TckRcDL, TckRcD);
  CONFORM(TckRcDL, TckKind);
  L_General.Assert(TckKind.Type = L_TRS.tkt_PieceTck_wCUC, "쪮  筮   䨪஢ ");
  L_General.Assert(TckRcD.Type # L_TRS.trdt_Laying, "㤠 த  ?");
  TckRcDLL_OnModify(-1);
  IF !TckRcDLL.Sum THEN
   TckRcDLL.Sum:=TckKind.FaceVal;
  ELSE
   SETEMPTY(TckRcDLL.Sum);
  END;
  REPLACE(TckRcDLL);
  TckRcDLL_OnModify(+1);
 END {ToggleIsSold};

 PUBLIC PROCEDURE SetIsSoldFromBegToCur();
 BEGIN
  L_General.Assert(ACCESS(TckRcDLL), " ⠭ ");
  CONFORM(TckRcDLL, TckRcDL);
  CONFORM(TckRcDL, TckRcD);
  CONFORM(TckRcDL, TckKind);
  L_General.Assert(TckKind.Type = L_TRS.tkt_PieceTck_wCUC, "쪮  筮   䨪஢ ");
  L_General.Assert(TckRcD.Type # L_TRS.trdt_Laying, "㤠 த  ?");
  CHANGESEL(TckRcDLL, TckRcD, , TckRcDLL.TckRcD, TckRcDLL.TRDLNbr);
  SAVE(TckRcDLL);
  WHILE OCCURE(TckRcDLL) DO
   TckRcDLL_OnModify(-1);
   TckRcDLL.Sum:=TckKind.FaceVal;
   REPLACE(TckRcDLL);
   TckRcDLL_OnModify(+1);
   PREV(TckRcDLL);
  END; (* WHILE OCCURE(TckRcDLL) ... *)
  RESTORE(TckRcDLL);
  WHILE NEXT(TckRcDLL) DO
   TckRcDLL_OnModify(-1);
   SETEMPTY(TckRcDLL.Sum);
   REPLACE(TckRcDLL);
   TckRcDLL_OnModify(+1);
  END;
 END {SetIsSoldFromBegToCur};

 PUBLIC PROCEDURE SoldLikePrevious();
  VAR
   _Sum     : LIKE(TckRcDLL.Sum);
   _SnTckTrf: LIKE(TckRcDLL.SnTckTrf);
 BEGIN
  L_General.Assert(ACCESS(TckRcDLL), " ⠭ ");
  CONFORM(TckRcDLL, TckRcD);
  L_General.Assert(TckRcD.Type # L_TRS.trdt_Laying, "㤠 த  ?");
  CHANGESEL(TckRcDLL, TckRcD, , TckRcDLL.TckRcD, TckRcDLL.TRDLNbr);
  SAVE(TckRcDLL);
  L_General.Assert(PREV(TckRcDLL), "  ");
  _Sum     :=TckRcDLL.Sum;
  _SnTckTrf:=TckRcDLL.SnTckTrf;
  RESTORE(TckRcDLL);
  TckRcDLL_OnModify(-1);
  TckRcDLL.Sum     :=_Sum;
  TckRcDLL.SnTckTrf:=_SnTckTrf;
  REPLACE(TckRcDLL);
  TckRcDLL_OnModify(+1);
 END {SoldLikePrevious};

 PRIVATE PROCEDURE TckRcDLL_Series_OnSuccessfulChange();
 BEGIN
  IF ~!TckRcDLL.Series THEN
   TckRcDLL.Series:=Str.Cap(TckRcDLL.Series);
   L_TRS.CheckTicketSeries(TckRcDL.TckKind, TckRcDLL.Series);
   REPLACE(TckRcDLL);
  END;
 END {TckRcDLL_Series_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcDLL_RestNbr_OnSuccessfulChange();
 BEGIN
  CONFORM(TckRcDL, TckKind);
  L_TRS.SupportRestNbrChanging(1, TckRcD.Type, TckRcDLL.CUCopy, TckRcDLL.RestNbr);
  REPLACE(TckRcDLL);
 END {TckRcDLL_RestNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcDLE_0_OnZoneOpen();
 BEGIN
  L_WDO.SetFieldFormat("RestNbrTitle", "孨 |⢮|孨 |㬬| |㬬|㬬|㬬");
  L_WDO.SetFieldFormat("TckKind.Type", L_TRS.tkt_Pool);
 END {TckRcDLE_0_OnZoneOpen};

 PRIVATE PROCEDURE TckRcDE_1_OnZoneOpen();
  VAR
   Context: STRING[];
 BEGIN
  SETEMPTY(Context);
  IF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit) | (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert) THEN
   IF L_WDO.GetEnvVarValue(L_Events.ee_ProcessId) = L_TRS.pid_Return THEN
    Context:="View_TckRcDE_Return";
   ELSE
    Context:="View_TckRcDE_1";
   END;
  END;
  RTI.Get().CurProcess.ReplaceContexts(Context);
 END {TckRcDE_1_OnZoneOpen};

 PRIVATE PROCEDURE TckRcDLEE_OnConformToWindow();
 BEGIN
  IF ~ACCESS(TckRcDLL) THEN
   SEARCH(TckRcDL, TckRcD, , L_TRS.TckRcD2Accept, L_TRS.TRDLNbr2Accept);
  ELSE
   CONFORM(TckRcDLL, TckRcDL);
  END;
  SE_WWD_CURSOR(GE_CONFORMTARGETWINDOW(), TckRcDL);
 END {TckRcDLEE_OnConformToWindow};

 PRIVATE CONST
  e_TckKindType = "TckKindType";
  tkt_Bulk_wCUC = "Bulk_wCUC";

 PRIVATE PROCEDURE TckRcDLEE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="TckRcS";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete, L_WDO.e_OnOpenZone]);
  IF L_WDO.GetEnvVarValue(L_Events.ee_ProcessId) = L_TRS.pid_AcceptTKGroup THEN
   L_WDO.iZone       (0).ViewOnly:=1;
  ELSE
   L_WDO.iZone       (0).ViewOnly:=0;
  END;
  L_WDO.iScsChange   (0, ["TckRcDL.Psg", "TckRcDL.RestNbr", "TckRcDL.TckKind"]);
  L_WDO.iUnmodifiable(0, ["TckRcDL.CUCopy", "TckRcDL.TRDLNbr"]);
  L_WDO.iMayBeEmpty  (0, ["TckRcDL.RestNbr"]);
  L_WDO.iField       (0, "TckKind.Type").Format:=L_TRS.tkt_Pool;
  L_WDO.iProgs       (0, "TckRcD");
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification, L_WDO.e_OnOpenZone]);
  L_WDO.iField       (1, "TckRcDLL.SnTckTrf").AskMode:=1;
  L_WDO.iField       (1, "TckRcDLL.SnTckTrf").OwnerWindowOriginalName:="SnTckTrf";
  L_WDO.iField       (1, "TckRcDLL.SnTckTrf").OwnerZoneNumber:=1;
  L_WDO.iField       (1, "TckRcDLL.Sum").Last:=1;
  L_WDO.iField       (1, "TckRcDLL.CUCopy").OwnerWindowOriginalName:="CUCopyA";
  L_WDO.iField       (1, "TckRcDLL.CUCopy").OwnerZoneNumber:=1;
  L_WDO.iScsChange   (1, ["TckRcDLL.SnTckTrf", "TckRcDLL.RestNbr", "TckRcDLL.Series"]);
  L_WDO.iUnmodifiable(1, ["TckRcDLL.CUCopy"]);
  L_WDO.iMayBeEmpty  (1, ["TckRcDLL.SnTckTrf", "TckRcDLL.Sum"]);
  L_WDO.iProgs       (1, "TckRcD");
 END {TckRcDLEE_OnInitializeWindow};

 PRIVATE PROCEDURE TckRcDLEE_0_OnZoneOpen();
 BEGIN
  IF ACCESS(TckRcDL) THEN
   CONFORM(TckRcDL, TckRcD);
   TckRcDL_SetupWin();
  END;
 END {TckRcDLEE_0_OnZoneOpen};

 PRIVATE PROCEDURE TckRcDLEE_1_OnZoneOpen();
 BEGIN
  L_General.CallUs(ACCESS(TckRcDL));
  CONFORM(TckRcDL, TckRcD);
  TckRcDL_SetupWin();
 END {TckRcDLEE_1_OnZoneOpen};

 PRIVATE PROCEDURE TckRcDLE_SetSubWin(IsBulk_wCUC: SCAL[2]);
 BEGIN
  IF    IsBulk_wCUC | L_TRS.IsSaleTckRcD(TckRcD.Type) THEN
   RTI.Get().CurZone.SubwindowOriginalName:="TckRcDLEE";
   RTI.Get().CurZone.SubwindowAssignedName:=RTI.Get().CurZone.SubwindowOriginalName + "<㬐஢>";
  ELSE
   RTI.Get().CurZone.SubwindowOriginalName:="TckRcDLE";
   RTI.Get().CurZone.SubwindowAssignedName:=RTI.Get().CurZone.SubwindowOriginalName;
  END;
 END {TckRcDLE_SetSubWin};

 PRIVATE PROCEDURE TckRcDE_1_OnSetSubwindow();
  VAR
   _TRDLNbr: LIKE(TckRcDL.TRDLNbr);
   _TckKind: LIKE(TckRcDL.TckKind);
   _Series : LIKE(TckRcDL.Series);
   _RestNbr: LIKE(TckRcDL.RestNbr);
   _CUCopy : LIKE(TckRcDL.CUCopy);
   _Psg    : LIKE(TckRcDL.Psg);
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert THEN
   CheckNotEmpty_TckRcD_Type();
   IF   TckRcD.Type = L_TRS.trdt_Return THEN
    ptToInsert:=ChoiceTckRcDL_FromBag();
    L_TRS.pt_Unpack(ptToInsert, _TRDLNbr, _TckKind, _Series, _RestNbr, _CUCopy,  _Psg);
    SEARCH(TckKind, TckKind, , _TckKind);
    TckRcDLE_SetSubWin(L_TRS.IsBulk_wCUC());
   ELSE
    TckRcDLE_SetSubWin(L_WDO.GetEnvVarValue(e_TckKindType) = tkt_Bulk_wCUC);
   END;
  ELSE
   L_General.Assert(ACCESS(TckRcDL), " ⠭ ப ");
   CONFORM(TckRcDL, TckKind);
   CONFORM(TckRcDL, TckRcD);
   TckRcDLE_SetSubWin(L_TRS.IsBulk_wCUC());
  END;
 END {TckRcDE_1_OnSetSubwindow};

 PRIVATE PROCEDURE TckRcD3E_1_OnSetSubwindow();
 BEGIN
  TckRcDE_1_OnSetSubwindow();
 END {TckRcD3E_1_OnSetSubwindow};

 PRIVATE PROCEDURE TckRcDE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iField       (0, "TckRcD.Type").Format :=L_TRS.trdt_Pool;
  L_WDO.iField       (0, "Storage.Type").Format:=L_Stock.st_Pool_SH;
  L_WDO.iField       (0, "TckRcS.AsWho").Format:=L_Way.trs_Pool;
  L_WDO.iScsChange   (0, ["TckRcD.Type", "TckRcD.Status"]);
  L_WDO.iUnmodifiable(0, ["TckRcD.Type", "TckRcD.Storage", "TckRcD.TckRcS", "TckRcD.CopyCnt", "TckRcD.TckRcD", "TckRcD.Date"]);
  L_WDO.iField       (0, "TckRcD.Status").Format:=L_TRS.trdStat_Pool;
  L_WDO.iZone        (1).HasVariousSubwindows:=1;
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow, L_WDO.e_OnOpenZone]);
  L_WDO.iScsChange   (1, ["TckRcDL.RestNbr", "TckRcDL.Series", "TckRcDL.TckKind"]);
  L_WDO.iProgs       (1, "TckRcD");
 END {TckRcDE_OnInitializeWindow};

 PUBLIC PROCEDURE TckRcDL_InsBulk_wCUC();
 BEGIN
  LIKEMENU(Ins, "@ " + e_TckKindType + "=" + tkt_Bulk_wCUC);
 END {TckRcDL_InsBulk_wCUC};

 PRIVATE PROCEDURE TckRcDLL_SnTckTrf_OnSuccessfulChange();
 BEGIN
  IF ~!TckRcDLL.SnTckTrf THEN
   CONFORM(TckRcDLL, SnTckTrf);
   TckRcDLL.Sum:=SnTckTrf.Price;
   REPLACE(TckRcDLL);
  END;
 END {TckRcDLL_SnTckTrf_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcDLL_SnTckTrf_OnAskPhase1();
 BEGIN
  CONFORM(TckRcDLL, TckRcDL);
  L_WDO.GetOwnerZone(L_WDO.getActiveField()).PermanentFilter:="SnTckTrf.TckKind=" + TckRcDL.TckKind;
 END {TckRcDLL_SnTckTrf_OnAskPhase1};

 PRIVATE PROCEDURE TckRcDLL_SnTckTrf_OnAskPhase2();
 BEGIN
  L_General.Assert(ACCESS(SnTckTrf), " ⠭ ");
  TckRcDLL.SnTckTrf:=SnTckTrf.SnTckTrf;
  REPLACE(TckRcDLL);
 END {TckRcDLL_SnTckTrf_OnAskPhase2};

BEGIN
 L_Events.ExecuteHandler();
END.
