(*
%Copyright   (c) Polak Computer System
%Author      23.03.2001 16:16:43 SAN
%Purpose     ஫ 䨪樨 ⭮-⭮ 
%Type        control
%Specific    AP
%Modified    06.08.2014 12:24:25 POLAK\Gina
%Environment
*)

 MODULE TckRcS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, Math, Str, L_Str, L_AP, P_Firm,
        L_XDoc, L_DatTim, L_Way, L_AFM, L_EC, L_Env, L_Car, E_Way,
        L_StdFrm, L_TRS, Memo, L_WDO, L_lsStore, L_Stock, P_CUC,
        L_bp, E_TRS, L_APtm, L_AcsPnt, L_Money, L_SysLog;

 PRIVATE CONST
  ap_TicketCassaTRSModify = 0000060;

 PRIVATE PERMANENT VAR
  v_Message         : STRING[];
  TckRcDForBulkSale : LIKE(TckRcD.TckRcD);
  TRDLNbrForBulkSale: LIKE(TckRcDL.TRDLNbr);
  DayForBulkSale    : LIKE(TckRcJ.Day);
  TimeForBulkSale   : TIME;
  IndexForBulkSale  : NUMERIC[0];

 PRIVATE PROCEDURE IsAutoBuildTckRcT(): SCAL[2];
 BEGIN
  IF L_TRS.TckRcSLevel() > L_TRS.il_woBeg THEN
   IF ~!TckRcT.TckKind THEN
    CONFORM(TckRcT, TckKind);
    RETURN (TckKind.Type # L_TRS.tkt_OutsideSales);
   END;
  END;
  RETURN 0;
 END {IsAutoBuildTckRcT};

 PRIVATE PROCEDURE IsModifiableAutobuildTCK(): SCAL[2];
 BEGIN
  RETURN IsAutoBuildTckRcT() &
         ((TckKind.InCash # L_TRS.tkc_Cash) | (TckKind.FaceVal = 0)) &
         (TckKind.Type # L_TRS.tkt_VLDActivities);
 END {IsModifiableAutobuildTCK};

 PRIVATE PROCEDURE MayModifyTckRcT(PossibleTckKindChange: SCAL[2]);
 BEGIN
  IF PossibleTckKindChange THEN
   L_General.Assert(~SELECT(TckRcJ, TckRcS, TckRcS.TckRcS), "  த  ३ᠬ");
  END;
  L_General.Assert(~L_TRS.IsVldTckKind(TckRcT.TckKind), "   ଫ ⮬᪨");
  IF IsAutoBuildTckRcT() & ~IsModifiableAutobuildTCK() THEN
   L_General.Assert(~PossibleTckKindChange & (L_TRS.IsEasySalesTck() | L_TRS.TckKind_wPsg()),
                    ' ⮩ ⭮ த樨 ଫ  ⥬ "⭠ "');
  END;
 END {MayModifyTckRcT};

 PRIVATE PROCEDURE CheckJobsOrder(oldDay   : LIKE(TckRcJ.Day);
                                  oldStartT: LIKE(TckRcJ.StartT));
  VAR
   newDay,
   prvDay    : LIKE(TckRcJ.Day);
   newStartT,
   prvStartT : LIKE(TckRcJ.StartT);
   Ok         : SCAL[2];
   i          : NUMERIC[0];
 BEGIN
  REPLACE(TckRcJ);
  newDay   :=TckRcJ.Day;
  newStartT:=TckRcJ.StartT;
  SAVE(TckRcJ);
  IF L_TRS.StandOnPrevJob() THEN
   prvDay   :=TckRcJ.Day;
   prvStartT:=TckRcJ.StartT;
  ELSE
   SETEMPTY(prvDay, prvStartT);
  END;
  Ok:=0;
  SETSEL(TckRcJ, TckRcS, TckRcS.TckRcS);
  IF SRCINSEL(TckRcJ, LT, oldDay, oldStartT) THEN
   Ok:=(prvDay = TckRcJ.Day) & (prvStartT = TckRcJ.StartT) |
       (newDay = TckRcJ.Day) & (newStartT = TckRcJ.StartT) ;
  ELSE
   Ok:=!prvDay;
  END;
  IF ~Ok THEN
   i:=0;
   WHILE i <= HIGH(TckRcJ.TckNbrs) DO
    L_General.Assert(OCCURE(TckRcJ) & !TckRcJ.TckNbrs[i],
                     " 冷 ப. 室  ");
    INC(i);
   END;
  END;
  RESTORE(TckRcJ);
 END {CheckJobsOrder};

 PRIVATE PROCEDURE CheckTckKindAllowedOnTrip();
  VAR
   Local  : PROC;
   Reason : STRING[];
   prvNbrs: LIKE(TckRcJ.TckNbrs);
   prvPsg : LIKE(TckRcJ.TckPsg);
   Amount : NUMERIC[0];
   Sum    : NUMERIC[2];
 BEGIN
  Local:=PROCREF(E_TRS.TckKindAllowedOnTrip);
  IF ~!Local THEN
   SAVE(TckKind);
   L_TRS.GetPrvJobInfo(prvNbrs, prvPsg);
   SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
   WHILE OCCURE(TckRcT) DO
    IF ~!TckRcT.Number THEN
     L_TRS.Calc2NumbersDifference(TckRcT.TckKind, prvNbrs[TckRcT.Number-1], TckRcJ.TckNbrs[TckRcT.Number-1],
                                  Amount, Sum);
     IF Amount # 0 THEN
      IF ~Local(TckRcS.Date, Reason) THEN
       CONFORM(TckRcT, TckKind);
       L_StdFrm.CrucialChoice("த   " + TckRcT.TckKind + " " + TckKind.Name + "  ३ " +
                              TckRcJ.Day + " " + L_DatTim.TimeStr(TckRcJ.StartT) + " ⨬." + Reason,
                              L_APtm.g_RWOp);
      END;
     END;
    END;
    NEXT(TckRcT);
   END; (* WHILE OCCURE(TckRcT) ... *)
   RESTORE(TckKind);
  END; (* IF ~!Local... *)
 END {CheckTckKindAllowedOnTrip};

 PRIVATE PROCEDURE CalcJobTotals(Dir     : NUMERIC[0];
                                 TheLast : SCAL[2];
                                 prvNbr,
                                 curNbr  : L_TRS.tTckNumber;
                                 prvPsg,
                                 curPsg  : L_TRS.tTckPsg;
                                 curRAmnt: L_TRS.tTckNumber;
                                 curRPsg : L_TRS.tTckPsg);
  VAR
   Psg,
   RPsg,
   Amount,
   RAmount : NUMERIC[0];
   Sum,
   RSum    : NUMERIC[2];
   WhereStr: STRING[];
 BEGIN
  WhereStr:="   " + L_DatTim.TimeStr(TckRcJ.StartT) +
            " ( " + TckRcJ.Day + "),   " + TckRcT.TckRcT + ": ";
  L_TRS.Calc2NumbersDifference(TckRcT.TckKind, prvNbr, curNbr, Amount, Sum);
  RAmount:=curRAmnt;
  IF TckKind.Type = L_TRS.tkt_ZonalTicket THEN
   RSum  :=RAmount;
  ELSE
   RSum  :=RAmount * TckKind.FaceVal;
  END;
  INC(TckRcJ.Sum,  Dir * Sum);
  INC(TckRcJ.RSum, Dir * RSum);
  IF L_TRS.IsMainTckKind(TckKind.TckKind, TckRcS.Date, TckRcJ.Route) THEN
   IF L_TRS.IsBulk_wCUC() THEN
    Psg                            :=curPsg;
    RPsg                           :=curRPsg;
   ELSE
    Psg                            :=Amount;
    TckRcJ.TckPsg[TckRcT.Number-1] :=Amount;
    RPsg                           :=RAmount;
    TckRcJ.TckRPsg[TckRcT.Number-1]:=RAmount;
   END;
  ELSIF L_TRS.TckKind_wPsg() THEN
   Psg :=curPsg - prvPsg;
   IF Psg < 0 THEN
    L_General.Error(WhereStr +
                    "|砥 ⥫쭮 ⢮ ᠦ஢." +
                    "||, ࠢ ᫥    ⮣ ३.");
   END;
   RPsg:=curRPsg;
  ELSE
   Psg :=0;
   RPsg:=0;
  END;
  INC(TckRcJ.Psg, Dir * Psg);
  REPLACE(TckRcJ);
  IF L_TRS.TckRcSLevel() <= L_TRS.il_woBeg THEN
   IF TheLast | (L_TRS.NumbersDir() = L_TRS.nd_None) THEN
    IF    L_TRS.NumbersDir() = L_TRS.nd_Incr THEN
     L_General.Assert(L_TRS.EndOfPack() >= TckRcT.BefNbr + (TckRcT.ExpNum + Dir * Amount),
                      WhereStr + " ௠");
     INC(TckRcT.AftNbr, Dir * Amount);
    ELSIF L_TRS.NumbersDir() = L_TRS.nd_Decr THEN
     L_General.Assert(L_TRS.EndOfPack() <= TckRcT.BefNbr - (TckRcT.ExpNum + Dir * Amount),
                      WhereStr + " ௠");
     DEC(TckRcT.AftNbr, Dir * Amount);
    END;
    L_General.Assert((TckRcT.ExpSum + Dir * Sum) <= MAXOF(TckRcT.ExpSum),
                     WhereStr + "誮 讥 祭 (㬬)");
    INC(TckRcT.ExpSum, Dir * Sum);
    INC(TckRcT.RSum,   Dir * RSum);
    IF ~L_TRS.TckKind_wPsg() THEN
     L_General.Assert((TckRcT.ExpNum + Dir * Amount) <= MAXOF(TckRcT.ExpNum),
                      WhereStr + "誮 讥 祭 (⢮)");
     INC(TckRcT.ExpNum, Dir * Amount);
     INC(TckRcT.RNum,   Dir * RAmount);
    ELSE
     INC(TckRcT.ExpNum, Dir * Psg);
     INC(TckRcT.RNum,   Dir * RPsg);
    END;
    REPLACE(TckRcT);
    REPLACE(TckRcS);
   END; (* IF TheLast ... *)
  END; (* IF L_TRS.TckRcSLevel() ... *)
 END {CalcJobTotals};

 PRIVATE PROCEDURE CalcTheWholeJob(Dir    : NUMERIC[0];
                                   TheLast: SCAL[2];
                                   prvNbrs: LIKE(TckRcJ.TckNbrs);
                                   prvPsg : LIKE(TckRcJ.TckPsg));
 BEGIN
  SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcT) DO
   IF ~!TckRcT.Number THEN
    CalcJobTotals(Dir, TheLast, prvNbrs[TckRcT.Number-1], TckRcJ.TckNbrs[TckRcT.Number-1],
                                prvPsg [TckRcT.Number-1], TckRcJ.TckPsg [TckRcT.Number-1],
                                TckRcJ.TckRAmnt[TckRcT.Number-1],
                                TckRcJ.TckRPsg [TckRcT.Number-1]);
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
 END {CalcTheWholeJob};

 PRIVATE PROCEDURE CheckReturned(prvNbrs: LIKE(TckRcJ.TckNbrs); prvPsg: LIKE(TckRcJ.TckPsg));
 BEGIN
  SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcT) DO
   IF ~!TckRcT.Number & (TckRcT.RNum > 0) THEN
    CONFORM(TckRcT, TckKind);
    L_General.Assert((Math.Abs(TckRcJ.TckNbrs[TckRcT.Number-1] - prvNbrs[TckRcT.Number-1]) >= TckRcJ.TckRAmnt[TckRcT.Number-1]),
                     " "+ TckRcT.TckRcT + ": ᠭ |    祬 த");
    IF ~L_TRS.IsMainTckKind(TckKind.TckKind, TckRcS.Date, TckRcJ.Route) & L_TRS.TckKind_wPsg() THEN
     L_General.Assert((Math.Abs(TckRcJ.TckPsg[TckRcT.Number-1] - prvPsg [TckRcT.Number-1]) >= TckRcJ.TckRPsg [TckRcT.Number-1]),
                     " "+ TckRcT.TckRcT + ": ᠦ஢  ᯨᠭ |    祬 ᠦ஢  ३");
    END;
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
 END {CheckReturned};

 PRIVATE PROCEDURE SupportNextJob(Dir: NUMERIC[0]);
  VAR
   TheLast  : SCAL[2];
   prvNbrs,
   curNbrs : LIKE(TckRcJ.TckNbrs);
   prvPsg,
   curPsg  : LIKE(TckRcJ.TckPsg);
 BEGIN
  L_TRS.GetPrvJobInfo(prvNbrs, prvPsg);
  SAVE(TckRcJ);
  TheLast:=~L_TRS.StandOnNextJob();
  IF ~TheLast THEN
   L_TRS.GetPrvJobInfo(curNbrs, curPsg);
   IF Dir = +1 THEN
    CalcTheWholeJob(-1, 0, prvNbrs, prvPsg);
    CalcTheWholeJob(+1, 0, curNbrs, curPsg);
    CheckReturned(prvNbrs, prvPsg);
   ELSE
    CalcTheWholeJob(-1, 0, curNbrs, curPsg);
    CalcTheWholeJob(+1, 0, prvNbrs, prvPsg);
   END;
  END;
  RESTORE(TckRcJ);
  IF Dir = +1 THEN
   CheckReturned(prvNbrs, prvPsg);
  END;
 END {SupportNextJob};

 PRIVATE PROCEDURE CheckDatesEqual();
 BEGIN
  L_General.Assert(RWayS.Date >= TckRcS.Date,
                   " ᮢ   " + RWayS.RWayS + "   " + TckRcS.TckRcS);
 END {CheckDatesEqual};

 PRIVATE PROCEDURE CheckRWayS(_asRWayS: LIKE(RWayS.RWayS); ByJob: SCAL[2]);
 BEGIN
  IF ~!_asRWayS THEN
   L_General.Assert(SEARCH(RWayS, RWayS, _asRWayS), "  㪠 ");
   IF L_Way.E_BegRWSLev(TckRcS.Date) >= L_Way.brwsl_Active THEN
    CheckDatesEqual();
    IF TckRcS.Status = L_TRS.trsStat_Ordered THEN
     L_General.CallUs(~ByJob);
     L_General.Assert((RWayS.Status <= L_Way.rwsStat_Given), "⨬ ﭨ  " + RWayS.RWayS);
    ELSE
     L_General.Assert((ByJob | (L_TRS.TckRcSLevel() # L_TRS.il_None)) = (RWayS.Status >= L_Way.rwsStat_Taken),
                      "⨬ ﭨ  " + RWayS.RWayS);
    END;
   END;
   IF ByJob THEN
    TckRcJ.asBoxNbr:=RWayS.BoxNbr;
    REPLACE(TckRcJ);
   ELSE
    TckRcS.asBoxNbr:=RWayS.BoxNbr;
    REPLACE(TckRcS);
   END;
  ELSE
   IF ByJob THEN
    SETEMPTY(TckRcJ.asBoxNbr);
    REPLACE(TckRcJ);
   ELSE
    SETEMPTY(TckRcS.asBoxNbr);
    REPLACE(TckRcS);
   END;
  END; (* IF ~!_asRWayS *)
 END {CheckRWayS};

 PRIVATE PROCEDURE CheckANYBoxNbr(_asBoxNbr: LIKE(TckRcS.asBoxNbr); ByJob: SCAL[2]);
 BEGIN
  IF ~!_asBoxNbr THEN
   L_General.Assert(L_Env.RealBoxNbr(_asBoxNbr), "  㪠 ॠ ࠦ");
   L_General.Assert(~!TckRcS.Date, "   ");
   L_Car.CheckAdaptability(_asBoxNbr, TckRcS.Date, 0);
  END;
  IF ByJob THEN
   SETEMPTY(TckRcJ.asRWayS);
   REPLACE(TckRcJ);
  END;
 END {CheckANYBoxNbr};

 PRIVATE PROCEDURE CurTckRcS_XDocJrn_Mark(trgAction: LIKE(XDocJrn.Action));
 BEGIN
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, TckRcS.TckRcS, trgAction);
 END {CurTckRcS_XDocJrn_Mark};

 PRIVATE PROCEDURE CurTckRcS_XDocJrn_Start(trgAction: LIKE(XDocJrn.Action));
 BEGIN
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, TckRcS.TckRcS, trgAction);
 END {CurTckRcS_XDocJrn_Start};

 PRIVATE PROCEDURE CurTckRcS_XDocJrn_Stop();
 BEGIN
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, TckRcS.TckRcS);
 END {CurTckRcS_XDocJrn_Stop};

 PRIVATE PROCEDURE IsInBegModification(): SCAL[2];
 BEGIN
  RETURN L_WDO.getActiveForm().OriginalName = "TRS0E";
 END {IsInBegModification};

 PRIVATE PROCEDURE TckRcSE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="TckRcS";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "TckRcS.TSN").First:=1;
  L_WDO.iField       (0, "TckRcS.asBoxNbr").AskMode:=1;
  L_WDO.iField       (0, "TckRcS.asBoxNbr").OwnerWindowOriginalName:="Car";
  L_WDO.iField       (0, "TckRcS.asBoxNbr").OwnerZoneNumber:=1;
  L_WDO.iField       (0, "TckRcS.asRWayS[0]").AskMode:=1;
  L_WDO.iField       (0, "TckRcS.asRWayS[0]").OwnerWindowOriginalName:="RWayS";
  L_WDO.iField       (0, "TckRcS.asRWayS[0]").OwnerZoneNumber:=1;
  L_WDO.iScsChange   (0, ["TckRcS.TSN", "TckRcS.asBoxNbr", "TckRcS.AsWho", "TckRcS.asRWayS[0]",
                          "TckRcS.TckRcS", "TckRcS.Date"]);
  L_WDO.iUnmodifiable(0, ["TckRcS.Storage", "TckRcS.CopyCnt", "TckRcS.TckRcS"]);
  L_WDO.iMayBeEmpty  (0, ["TckRcS.asBoxNbr", "TckRcS.asRWayS[0]"]);
  L_WDO.iField       (0, "TckRcS.AsWho").Format:=L_Way.trs_Pool;
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete]);
  L_WDO.iScsChange   (1, ["TckRcT.Series", "TckRcT.BefNbr", "TckRcT.AftNbr", "TckRcT.TckKind"]);
  L_WDO.iUnmodifiable(1, ["TckRcT.AftNbr", "TckRcT.TckRcT", "TckRcT.Number", "TckRcT.ExpSum", "TckRcT.ExpNum"]);
  L_WDO.iMayBeEmpty  (1, ["TckRcT.Series"]);
  L_WDO.iProgs       (1, "TckRcS");
  L_WDO.iSubwindow   (2, "TckRcJE");
 END {TckRcSE_OnInitializeWindow};

 PRIVATE PROCEDURE AvailableToPay(): SCAL[2];
 BEGIN
  RETURN TckRcS.AsWho # L_Way.trs_Driver;
 END {AvailableToPay};

 PRIVATE PROCEDURE TckRcSE_0_SetupWinFields();
  VAR
   D    : DATE;
   AsWhoCndPool: STRING[];
   woBeg,
   FlagEdit: SCAL[2];
 BEGIN
  ACCESS(TckRcS);
  IF !TckRcS.Date THEN
   D:=Memo.ud_cd();
  ELSE
   D:=TckRcS.Date;
  END;
  IF TckRcS.Status = L_TRS.trsStat_Ordered THEN
   woBeg:=1;
  ELSE
   woBeg:=L_TRS.TckRcSLevel() <= L_TRS.il_woBeg;
  END;
  IF TckRcS.Status # L_TRS.trsStat_Ordered THEN
   L_WDO.SetFieldModifiable("TckRcS.asRWayS[0]", L_Way.E_Fill_asRWayS(D));
   L_WDO.SetFieldModifiable("TckRcS.asBoxNbr", ~L_Way.E_Fill_asRWayS(D));
   L_WDO.SetFieldModifiable("TckRcS.Gap",      (TckRcS.AsWho = L_Way.trs_Guard));
   L_WDO.SetFieldModifiable("TckRcS.ToSheet",  (TckRcS.AsWho = L_Way.trs_Guard));
   L_WDO.SetFieldModifiable("TckRcS.ToPay",    AvailableToPay());
   L_WDO.SetFieldModifiable("TckRcS.PlAsFc",   (TckRcS.AsWho = L_Way.trs_Chopper));
   L_WDO.SetFieldModifiable("TckRcS.TotCash", woBeg);
  END;
  AsWhoCndPool:=L_TRS.E_TckRcS_AsWhoCnd_GetPool(D, TckRcS.AsWho);
  IF !AsWhoCndPool THEN
   FlagEdit:=0;
  ELSIF ~!L_Str.PoolItem(AsWhoCndPool, 1) THEN
   FlagEdit:=1;
  ELSE
   FlagEdit:=!TckRcS.AsWhoCnd;
  END;
  L_WDO.SetFieldFormat("TckRcS.AsWhoCnd", AsWhoCndPool);
  L_WDO.SetFieldModifiable("TckRcS.AsWhoCnd", FlagEdit);
  L_WDO.SetFieldModifiable("TckRcS.Date",     TckRcS.Status # L_TRS.trsStat_Ordered);
  L_WDO.SetFieldModifiable("TckRcS.AsWho",    1);
  L_WDO.SetFieldModifiable("TckRcS.TSN",      woBeg);
 END {TckRcSE_0_SetupWinFields};

 PRIVATE PROCEDURE TckRcJR_CleanTckRcT();
 BEGIN
  SELECT(TckRcJR, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcJR) DO
   CONFORM(TckRcJR, TckKind);
   IF L_TRS.E_NeedAutoTaxTckRcJR(TckRcS.Date) THEN
    SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
    LOOP
     IF ~OCCURE(TckRcT) THEN
      EXIT;
     ELSIF (TckRcT.TckKind = TckKind.TckKind) THEN
      L_General.CallUs((TckRcT.ExpSum = 0) & (TckRcT.ExpNum = 0));
      SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
      WHILE OCCURE(TckRcJ) DO
       SETEMPTY(TckRcJ.TckNbrs[TckRcT.Number - 1], TckRcJ.TckPsg[TckRcT.Number - 1]);
       REPLACE(TckRcJ);
       NEXT(TckRcJ);
      END; (* WHILE OCCURE(TckRcJ) ... *)
      REMOVE(TckRcT);
      EXIT;
     ELSE
      NEXT(TckRcT);
     END;
    END; (* LOOP *)
   END;
   NEXT(TckRcJR);
  END; (* WHILE OCCURE(TckRcJR) ... *)
 END {TckRcJR_CleanTckRcT};

 PRIVATE PROCEDURE TckRcJR_Proceed(Dir: NUMERIC[0]);
  VAR
   Found: NUMERIC[0];
   _num : NUMERIC[0];
 BEGIN
  SAVE(TckRcJ);
  SELECT(TckRcJR, TckRcS, , TckRcJ.TckRcS, TckRcJ.Day, TckRcJ.StartT);
  WHILE OCCURE(TckRcJR) DO
   CONFORM(TckRcJR, TckKind);
   IF L_TRS.E_NeedAutoTaxTckRcJR(TckRcS.Date) THEN
    L_General.Assert(TckKind.FaceVal # 0,
                     "୮ ଫ   " + TckKind.TckKind + ":     0-00");
    IF    Dir = -1 THEN
     Found:=0;
     SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
     LOOP
      IF ~OCCURE(TckRcT) THEN
       L_General.CallUs(Found = 1);
       EXIT;
      ELSIF (TckRcT.TckKind = TckKind.TckKind) THEN
       CONFORM(TckRcJR, TckKind);
       CONFORM(TckRcJR, TckRcJ);
       _num:=TckRcJR.Sum / TckKind.FaceVal;
       L_General.CallUs((TckRcJ.TckNbrs [TckRcT.Number - 1] = _num) &
                        (TckRcJ.TckRAmnt[TckRcT.Number - 1] = 0));
       IF L_TRS.TckKind_wPsg() THEN
        L_General.CallUs((TckRcJ.TckPsg  [TckRcT.Number - 1] = TckRcJR.Psg) &
                         (TckRcJ.TckRPsg [TckRcT.Number - 1] = 0));
        DEC(TckRcT.ExpNum, TckRcJ.TckPsg[TckRcT.Number - 1]);
        DEC(TckRcJ.Psg,    TckRcJ.TckPsg[TckRcT.Number - 1]);
        SETZERO(TckRcJ.TckPsg[TckRcT.Number - 1]);
       ELSE
        DEC(TckRcT.ExpNum, TckRcJ.TckNbrs[TckRcT.Number - 1]);
       END;
       DEC(TckRcT.ExpSum,  TckRcJ.TckNbrs[TckRcT.Number - 1] * TckKind.FaceVal);
       DEC(TckRcJ.Sum,     TckRcJ.TckNbrs[TckRcT.Number - 1] * TckKind.FaceVal);
       SETZERO(TckRcJ.TckNbrs[TckRcT.Number - 1]);
       REPLACE(TckRcS);
       REPLACE(TckRcJ);
       REPLACE(TckRcT);
       NEXT(TckRcT);
       IF Found = 0 THEN
        INC(Found);
       ELSE
        L_General.Error(" ( )     " + TckKind.TckKind);
       END;
      ELSE
       NEXT(TckRcT);
      END;
     END; (* LOOP ... *)
    ELSIF Dir = 1 THEN
     SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
     LOOP
      IF ~OCCURE(TckRcT) THEN
       DEFAULT(TckRcT);
       TckRcT.TckRcS :=TckRcJR.TckRcS;
       TckRcT.TckKind:=TckRcJR.TckKind;
       INSERT(TckRcT);
       TckRcT.Number:=NewTckRcTNumber();
       SAVE(TckRcJ);
       SELECT(TckRcJ, TckRcS, , TckRcJ.TckRcS);
       WHILE OCCURE(TckRcJ) DO
        SETZERO(TckRcJ.TckNbrs[TckRcT.Number - 1]);
        IF L_TRS.TckKind_wPsg() THEN
         SETZERO(TckRcJ.TckPsg[TckRcT.Number - 1]);
        END;
        REPLACE(TckRcJ);
        NEXT(TckRcJ);
       END; (* WHILE OCCURE(TckRcJ) ... *)
       RESTORE(TckRcJ);
       EXIT;
      ELSIF (TckRcT.TckKind = TckKind.TckKind) THEN
       EXIT;
      END;
      NEXT(TckRcT);
     END;
     CONFORM(TckRcJR, TckRcJ);
     L_General.CallUs((TckRcJ.TckNbrs [TckRcT.Number - 1] = 0) &
                      (TckRcJ.TckRAmnt[TckRcT.Number - 1] = 0));
     TckRcJ.TckNbrs[TckRcT.Number - 1]:=TckRcJR.Sum / TckKind.FaceVal;
     INC(TckRcJ.Sum,     TckRcJ.TckNbrs[TckRcT.Number - 1] * TckKind.FaceVal);
     INC(TckRcT.ExpSum,  TckRcJ.TckNbrs[TckRcT.Number - 1] * TckKind.FaceVal);
     IF L_TRS.TckKind_wPsg() THEN
      L_General.CallUs((TckRcJ.TckPsg  [TckRcT.Number - 1] = 0) &
                       (TckRcJ.TckRPsg [TckRcT.Number - 1] = 0));
      TckRcJ.TckPsg[TckRcT.Number - 1]:=TckRcJR.Psg;
      INC(TckRcJ.Psg,    TckRcJ.TckPsg[TckRcT.Number - 1]);
      INC(TckRcT.ExpNum, TckRcJ.TckPsg[TckRcT.Number - 1]);
     ELSE
      INC(TckRcT.ExpNum, TckRcJ.TckNbrs[TckRcT.Number - 1]);
     END;
     REPLACE(TckRcJ);
     REPLACE(TckRcT);
     REPLACE(TckRcS);
    END;
   END;
   NEXT(TckRcJR);
  END; (* WHILE OCCURE(TckRcJR) ... *)
  RESTORE(TckRcJ);
 END {TckRcJR_Proceed};

 PRIVATE PROCEDURE TckRcS_OnBeforeEdit();
 BEGIN
  IF IsInBegModification() THEN
   IF    TckRcS.Status = L_TRS.trsStat_Ordered THEN
    CurTckRcS_XDocJrn_Start(L_XDoc.action_begEdit);
    v_Message:=L_lsStore.Get(TckRcS.Message);
   ELSE
    L_General.Error("  믮 ⮫쪮   拉");
   END;
  ELSE
   L_XDoc.xdmb_CheckABan(L_XDoc.xdcls_RWayS, TckRcS.Date);
   L_General.Assert((TckRcS.Status = L_TRS.trsStat_Taken) | (TckRcS.Status = L_TRS.trsStat_Rated),
                    "㬥  ਭ");
   CurTckRcS_XDocJrn_Start(L_XDoc.action_Edit);
  END;
  TckRcS_OnProceed(-1);

  IF SELECT(TckRcJR, TckRcS, TckRcS.TckRcS) THEN
   IF ~SELECT(ElTck, TckRcS, TckRcS.TckRcS) THEN
    L_General.CallUs(SYSDATE() - TckRcS.Date > 180);
    L_General.Error("䨪  饭, ⠪  㦥 㤠 ஭ ");
   ELSE
    IF SELECT(ElTck, TckRcS, TckRcS.TckRcS) THEN
     LOOP
      PROMPT("  ஭ : " + L_DatTim.DateTimeStr(ElTck.DateIn, ElTck.TimeIn));
      IF NEXT(ElTck) THEN
       SAVE(ElTck);
       PREV(ElTck);
       SETEMPTY(ElTck.TckRcS);
       L_TRS.ReplaceElTckAfterBind();
       RESTORE(ElTck);
      ELSE
       FIRST(ElTck);
       SETEMPTY(ElTck.TckRcS);
       L_TRS.ReplaceElTckAfterBind();
       EXIT;
      END; (* IF NEXT(ElTck) *)
     END; (* LOOP *)
    END; (* IF SELECT(ElTck ... *)
   END;
   REMSEL(TckRcJR);
  ELSE
   L_General.CallUs(~SELECT(ElTck, TckRcS, TckRcS.TckRcS));
  END;
  IF (TckRcS.Status = L_TRS.trsStat_Rated) & ~SELECT(TckRcJ, TckRcS, TckRcS.TckRcS) THEN
   TOOLTIP('⠭ ﭨ " ⠪஢", ⠪     ३ᮢ');
   L_SysLog.SingleMark_Init("TckRcS");
   TckRcS.Status:=L_TRS.trsStat_Taken;
   REPLACE(TckRcS);
   FIX_ALTERING();
   L_SysLog.SingleMark_Done("TckRcS");
  END;
  IF L_Way.E_Fill_asRWayS(TckRcS.Date) & SEARCH(RWayS, RWayS, TckRcS.asRWayS[0]) THEN
   TckRcS.asBoxNbr:=RWayS.BoxNbr;
   REPLACE(TckRcS);
  END;
 END {TckRcS_OnBeforeEdit};

 PRIVATE PROCEDURE TckRcS_OnBeforeInsert();
 BEGIN
  IF IsInBegModification() THEN
   CurTckRcS_XDocJrn_Start(L_XDoc.action_begInsert);
   TckRcS.Status:=L_TRS.trsStat_Ordered;
   SETEMPTY(v_Message);
  ELSE
   TckRcS.Date:=Memo.ud_cd();
   CurTckRcS_XDocJrn_Start(L_XDoc.action_Insert);
   TckRcS.Status:=L_TRS.trsStat_Rated;
  END;
  REPLACE(TckRcS);
 END {TckRcS_OnBeforeInsert};

 PRIVATE PROCEDURE TckRcS_OnBeforeDelete();
 BEGIN
  L_General.Assert((TckRcS.Status = L_TRS.trsStat_Ordered) & !TckRcS.Date, "   㤠");
  L_XDoc.XDoc_OnBeforeDelete(L_XDoc.curXDocId(L_XDoc.xdt_TckRcS));
 END {TckRcS_OnBeforeDelete};

 PRIVATE PROCEDURE AnyTckRcS_OnReposition();
 BEGIN
  TckRcSE_0_SetupWinFields();
  v_Message:=L_lsStore.Get(TckRcS.Message);
 END {AnyTckRcS_OnReposition};

 PRIVATE PROCEDURE TckRcSE_0_OnReposition();
 BEGIN
  AnyTckRcS_OnReposition();
 END {TckRcSE_0_OnReposition};

 PRIVATE PROCEDURE TRS0E_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="TckRcS";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "TckRcS.TSN").First:=1;
  L_WDO.iScsChange   (0, ["TckRcS.TSN", "TckRcS.AsWho"]);
  L_WDO.iUnmodifiable(0, ["TckRcS.Storage", "TckRcS.CopyCnt", "TckRcS.TckRcS", "TckRcS.Date"]);
  L_WDO.iMayBeEmpty  (0, ["TckRcS.v_Message"]);
  L_WDO.iField       (0, "TckRcS.AsWho").Format:=L_Way.trs_Pool;
 END {TRS0E_OnInitializeWindow};

 PRIVATE PROCEDURE TRS0E_0_OnReposition();
 BEGIN
  AnyTckRcS_OnReposition();
 END {TRS0E_0_OnReposition};

 PRIVATE PROCEDURE TckRcT_SetupFields();
  VAR
   MayModify: SCAL[2];
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurWindow.ActiveZone.Fields;
  IF ~!TckRcT.TckKind THEN
   CONFORM(TckRcT, TckKind);
   MayModify:=~L_TRS.IsVldTckKind(TckRcT.TckKind) & (TckKind.Type # L_TRS.tkt_VLDActivities) &
              (~IsAutoBuildTckRcT() | IsModifiableAutobuildTCK());

   Fields("TckRcT.Series" ).Modifiable:=MayModify & (TckKind.Type = L_TRS.tkt_Ticket);
   Fields("TckRcT.AftNbr" ).Modifiable:=MayModify & IsModifiableAutobuildTCK();
   Fields("TckRcT.ExpNum" ).Modifiable:=(IsAutoBuildTckRcT() & L_TRS.TckKind_wPsg()) |
                                        (TckKind.Type = L_TRS.tkt_OutsideSales);
   Fields("TckRcT.ExpSum" ).Modifiable:=TckKind.Type = L_TRS.tkt_OutsideSales;
   Fields("TckRcT.TckKind").Modifiable:=(~IsAutoBuildTckRcT() | L_TRS.IsEasySalesTck());

   MayModify:=MayModify & (TckKind.NbrsDir # L_TRS.nd_None);
   IF IsAutoBuildTckRcT() THEN
    Fields("TckRcT.BefNbr").Modifiable:=MayModify & (TckKind.FaceVal = 0) & L_TRS.IsEasySalesTck();
   ELSE
    Fields("TckRcT.BefNbr").Modifiable:=MayModify;
   END;
  ELSE
   Fields("TckRcT.TckKind").Modifiable:=1;
   Fields("TckRcT.Series" ).Modifiable:=0;
   Fields("TckRcT.BefNbr" ).Modifiable:=0;
   Fields("TckRcT.AftNbr" ).Modifiable:=0;
   Fields("TckRcT.ExpNum" ).Modifiable:=0;
   Fields("TckRcT.ExpSum" ).Modifiable:=0;
  END;
 END {TckRcT_SetupFields};

 PRIVATE PROCEDURE TckRcT_BefNbr_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~SELECT(TckRcJ, TckRcS, TckRcS.TckRcS), "  த  ३ᠬ");
 END {TckRcT_BefNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcT_Series_OnSuccessfulChange();
 BEGIN
  TckRcT.Series:=Str.Cap(TckRcT.Series);
  L_TRS.CheckTicketSeries(TckRcT.TckKind, TckRcT.Series);
  REPLACE(TckRcT);
 END {TckRcT_Series_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcT_OnBeforeEdit();
 BEGIN
  MayModifyTckRcT(0);
  TckRcT_SetupFields();
 END {TckRcT_OnBeforeEdit};

 PRIVATE PROCEDURE TckRcT_OnBeforeInsert();
 BEGIN
  MayModifyTckRcT(1);
  TckRcT_SetupFields();
 END {TckRcT_OnBeforeInsert};

 PRIVATE PROCEDURE TckRcT_OnBeforeDelete();
 BEGIN
  MayModifyTckRcT(1);
  CONFORM(TckRcT, TckKind);
  IF L_TRS.IsEasySalesTck() THEN
   L_General.Assert(((TckKind.InCash # L_TRS.tkc_Cash) & ~L_TRS.InSale()) | (TckKind.FaceVal = 0),
                    " ⮣    ᪠");
  ELSE
   L_General.Assert(~IsAutoBuildTckRcT(), " ⮣    ᪠");
  END;
 END {TckRcT_OnBeforeDelete};

 PRIVATE PROCEDURE CheckTckRcTSum();
  VAR
   InCashSum,
   InSaleSum: NUMERIC[2];
 BEGIN
  InCashSum:=0; InSaleSum:=0;
  SAVE(TckRcT);
  SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcT) DO
   CONFORM(TckRcT, TckKind);
   IF TckKind.InCash # L_TRS.tkc_No THEN
    INC(InCashSum, TckRcT.ExpSum - TckRcT.RSum);
   END;
   IF L_TRS.InSale() THEN
    INC(InSaleSum, TckRcT.ExpSum - TckRcT.RSum);
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
  L_General.Assert(InCashSum = InSaleSum,
                   "|ࠦ , 饩            "+FLDTOSTR(InCashSum, "2-", 8) +
                   "|ࠦ , 饩   த "+FLDTOSTR(InSaleSum, "2-", 8));
  RESTORE(TckRcT);
 END {CheckTckRcTSum};

 PRIVATE PROCEDURE TckRcT_OnAfterDelete();
  VAR
   _Number: LIKE(TckRcT.Number);
   _TckRcT: LIKE(TckRcT.TckRcT);
 BEGIN
  _TckRcT:=1;
  SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcT) DO
   TckRcT.TckRcT:=_TckRcT;
   REPLACE(TckRcT);
   INC(_TckRcT);
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
  _Number:=1;
  SELECT(TckRcT, Number, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcT) DO
   IF ~!TckRcT.Number THEN
    TckRcT.Number:=_Number;
    REPLACE(TckRcT);
    INC(_Number);
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
 END {TckRcT_OnAfterDelete};

 PRIVATE PROCEDURE NewTckRcTNumber(): LIKE(TckRcT.Number);
  VAR
   _Number: LIKE(TckRcT.Number);
 BEGIN
  SAVE(TckRcT);
  SETSEL(TckRcT, Number, TckRcT.TckRcS);
  LAST(TckRcT);
  WHILE OCCURE(TckRcT) & !TckRcT.Number DO
   PREV(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
  IF OCCURE(TckRcT) THEN
   _Number:=TckRcT.Number + 1;
  ELSE
   _Number:=1;
  END;
  RESTORE(TckRcT);
  RETURN _Number;
 END {NewTckRcTNumber};

 PRIVATE PROCEDURE TckRcT_OnAfterEdIns();
  VAR
   _Amount: NUMERIC[0];
 BEGIN
  MayModifyTckRcT(0);
  CONFORM(TckRcT, TckKind);
  IF IsAutoBuildTckRcT() THEN
   IF !TckRcT.Number THEN
    TckRcT.Number:=NewTckRcTNumber();
   END;
   L_TRS.Calc2NumbersDifference(TckRcT.TckKind, TckRcT.BefNbr, TckRcT.AftNbr, _Amount, TckRcT.ExpSum);
   IF ~L_TRS.TckKind_wPsg() &
      (TckKind.Type # L_TRS.tkt_KKMActivities) &
      (TckKind.Type # L_TRS.tkt_OutsideSales)  &
      (TckKind.Type # L_TRS.tkt_VLDActivities) &
      (TckKind.Type # L_TRS.tkt_EasySales)     THEN
    TckRcT.ExpNum:=_Amount;
   END;
  ELSE
   IF L_TRS.NumbersDir() # L_TRS.nd_None THEN
    L_General.Assert(~!TckRcT.BefNbr, "室 㪠  ''");
    L_General.Assert(L_TRS.GetNbrFactLength(TckRcT.BefNbr) <= TckKind.NbrPrc, "誮    ");
    TckRcT.AftNbr:=TckRcT.BefNbr;
    IF L_TRS.NumbersDir() # TckKind.NbrsDir THEN
     L_StdFrm.Question("⭮ ࠢ  ஢?");
    END;
   ELSE
    SETEMPTY(TckRcT.BefNbr, TckRcT.AftNbr);
   END;
   IF L_TRS.TckRcSLevel() <= L_TRS.il_woBeg THEN
    SETZERO(TckRcT.ExpNum, TckRcT.ExpSum, TckRcT.RNum, TckRcT.RSum);
   END;
   IF !TckRcT.Number THEN
    REPLACE(TckRcT);
    TckRcT.Number:=NewTckRcTNumber();
   END;
  END;
  REPLACE(TckRcT);
 END {TckRcT_OnAfterEdIns};

 PRIVATE PROCEDURE TckRcT_OnAfterEdit();
 BEGIN
  CONFORM(TckRcT, TckKind);
  IF IsAutoBuildTckRcT() THEN
   IF (TckRcT.TckKind # GE_PVALUE(TckRcT.TckKind)) THEN
    L_StdFrm.Question("   ");
   ELSE
    L_StdFrm.Question("  த    "+TckKind.TckKind+" "+TckKind.Name);
   END;
   IF (TckRcT.AftNbr # GE_PVALUE(TckRcT.AftNbr)) & ~L_TRS.IsEasySalesTck() THEN
    L_AcsPnt.PassAccessPoint(ap_TicketCassaTRSModify);
   END;
  END;
  TckRcT_OnAfterEdIns();
 END {TckRcT_OnAfterEdit};

 PRIVATE PROCEDURE TckRcT_OnAfterInsert();
 BEGIN
  TckRcT_OnAfterEdIns();
 END {TckRcT_OnAfterInsert};

 PRIVATE PROCEDURE TckRcJE_0_SetupNbrs(prvNbrs: LIKE(TckRcJ.TckNbrs));
  VAR
   i: NUMERIC[0];
   m: SCAL[2];
   f: FORM_FIELD;
   fields: FORM_FIELDS;
 BEGIN
  SELECT(TckRcT, Number, , TckRcS.TckRcS);
  L_General.Assert(OCCURE(TckRcT), "室    ");
  fields:=RTI.Get().CurZone.Fields;
  i:=0;
  WHILE OCCURE(TckRcT) DO
   IF ~!TckRcT.Number THEN
    CONFORM(TckRcT, TckKind);
    f:=fields(L_WDO.Fld_wIdx("BegStr", i));
    f.Value:=Str.Align(TckRcT.TckRcT + " " + TckKind.Name, 26, LEFT);
    f.Visible:=1;

    m:=~L_TRS.IsSpecialNoSaleTckKind() &
       ((L_TRS.NumbersDir() = L_TRS.nd_None) | (prvNbrs[i] # L_TRS.EndOfPack()));

    f:=fields(L_Str.Var_wIdx("TckRcJ.TckNbrs", i));
    f.Visible   :=1;
    f.Modifiable:=m;
    f.Format    :=GetSingleNbrFormat(i);

    f:=fields(L_Str.Var_wIdx("TckRcJ.TckPsg", i));
    f.Visible   :=1;
    f.Modifiable:=m & L_TRS.TckKind_wPsg();

    f:=fields(L_WDO.Fld_wIdx("Space", i));
    IF ((TckRcT.RSum # 0) & ~L_TRS.IsCashWithoutSale()) | (TckRcT.RNum # 0) THEN
     f.Value:=" !";
    ELSE
     f.Value:=" ";
    END;
    f.Visible   :=1;

    INC(i);
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
  WHILE i <= HIGH(TckRcJ.TckNbrs) DO
   fields(L_WDO.Fld_wIdx("BegStr",         i)).Visible:=0;
   fields(L_Str.Var_wIdx("TckRcJ.TckNbrs", i)).Visible:=0;
   fields(L_Str.Var_wIdx("TckRcJ.TckPsg",  i)).Visible:=0;
   fields(L_WDO.Fld_wIdx("Space",          i)).Visible:=0;
   INC(i);
  END;
 END {TckRcJE_0_SetupNbrs};

 PRIVATE PROCEDURE intSetFirstField(CurField, FirstField: STRING[]);
 BEGIN
  RTI.Get().CurWindow.ActiveZone.Fields(CurField).First:=CurField=FirstField;
 END {intSetFirstField};

 PRIVATE PROCEDURE SetFirstField();
  VAR
   FirstField: STRING[];
 BEGIN
  IF    !TckRcJ.asRWayS & L_Way.E_Fill_asRWayS(TckRcS.Date) THEN
   FirstField:="TckRcJ.asRWayS";
  ELSIF !TckRcJ.asBoxNbr THEN
   FirstField:="TckRcJ.asBoxNbr";
  ELSIF L_TRS.IsFirstJob() THEN
   FirstField:="TckRcJ.Route";
  ELSE
   FirstField:="TckRcJ.StartT";
  END;
  intSetFirstField("TckRcJ.asRWayS",  FirstField);
  intSetFirstField("TckRcJ.asBoxNbr", FirstField);
  intSetFirstField("TckRcJ.Route",    FirstField);
  intSetFirstField("TckRcJ.StartT",   FirstField);
 END {SetFirstField};

 PRIVATE PROCEDURE TckRcJ_OnBeforeEdit();
 BEGIN
  SetFirstField();
  SupportNextJob(-1);
  TckRcJE_0_SetupNbrs(L_TRS.GetPrvNbrs());
 END {TckRcJ_OnBeforeEdit};

 PRIVATE PROCEDURE TckRcJ_OnBeforeInsert();
 BEGIN
  IF L_TRS.IsFirstJob() THEN
   TckRcJ.asRWayS :=TckRcS.asRWayS[0];
   TckRcJ.asBoxNbr:=TckRcS.asBoxNbr;
  END;
  IF L_Way.E_Fill_asRWayS(TckRcS.Date) THEN
   IF ~!TckRcJ.asRWayS THEN
    L_General.Assert(SEARCH(RWayS, RWayS, TckRcJ.asRWayS), "   " + TckRcJ.asRWayS);
    IF (RWayS.Date # TckRcS.Date) | ~L_Way.RWaySSomeTimeWas(L_XDoc.action_begDst) THEN
     SETEMPTY(TckRcJ.asRWayS);
    END;
   END;
  ELSE
   SETEMPTY(TckRcJ.asRWayS);
  END;
  REPLACE(TckRcJ);
  SetFirstField();
  TckRcJ.asDate:=TckRcS.Date;
  SETEMPTY(TckRcJ.TckPsg);
  SELECT(TckRcT, Number, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcT) DO
   CONFORM(TckRcT, TckKind);
   IF ~!TckRcT.Number & (L_TRS.TckKind_wPsg() | L_TRS.IsMainTckKind(TckKind.TckKind, TckRcS.Date, TckRcJ.Route)) THEN
    TckRcJ.TckPsg[TckRcT.Number - 1]:=0;
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
  REPLACE(TckRcJ);
 END {TckRcJ_OnBeforeInsert};

 PRIVATE PROCEDURE TckRcJ_OnBeforeDelete();
  VAR
   TheLast  : SCAL[2];
   prvNbrs : LIKE(TckRcJ.TckNbrs);
   prvPsg  : LIKE(TckRcJ.TckPsg);
 BEGIN
  SAVE(TckRcJ);
  TheLast:=~L_TRS.StandOnNextJob();
  IF ~TheLast THEN
   L_TRS.GetPrvJobInfo(prvNbrs, prvPsg);
   CalcTheWholeJob(-1, 0, prvNbrs, prvPsg);
  END;
  RESTORE(TckRcJ);
  SupportTckRcDLLTimeChange(TckRcJ.Day, TckRcJ.StartT, EMPTYOF(TckRcDLL.Day), EMPTYOF(TckRcDLL.Time));
  L_TRS.GetPrvJobInfo(prvNbrs, prvPsg);
  CalcTheWholeJob(-1, TheLast, prvNbrs, prvPsg);
  IF ~TheLast THEN
   L_General.CallUs(L_TRS.StandOnNextJob());
   CalcTheWholeJob(+1, 0, prvNbrs, prvPsg);
  END;
 END {TckRcJ_OnBeforeDelete};

 PRIVATE PROCEDURE TckRcJ_OnAfterEdIns();
 BEGIN
  IF !TckRcJ.asRWayS THEN
   TckRcJ.udRWayS:=0;
   REPLACE(TckRcJ);
  END;
  IF L_Way.E_IsImaginaryRoute(TckRcS.Date, TckRcJ.Route) THEN
   L_General.Assert(!TckRcJ.asRWayS & !TckRcJ.asBoxNbr,
                    " ଫ 䨪⨢ த   ࠦ   㪠뢠");
  END;
  SupportNextJob(+1);
 END {TckRcJ_OnAfterEdIns};

 PRIVATE PROCEDURE TckRcJ_OnAfterEdit();
 BEGIN
  TckRcJ_OnAfterEdIns();
 END {TckRcJ_OnAfterEdit};

 PRIVATE PROCEDURE TckRcJ_OnAfterInsert();
 BEGIN
  TckRcJ_OnAfterEdIns();
 END {TckRcJ_OnAfterInsert};

 PRIVATE PROCEDURE trsHasAnySelling(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SAVE(TckRcT);
  CONFORM(TckRcS, TckRcT);
  WHILE OCCURE(TckRcT) & ~Result DO
   Result:=(TckRcT.ExpNum # 0) | (TckRcT.ExpSum # 0);
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
  RESTORE(TckRcT);
  RETURN Result;
 END {trsHasAnySelling};

 PRIVATE PROCEDURE FillTckRcJR();
  VAR
   so           : SCAL[3];
   NotFoundList,
   wBadRouteList: STRING[];
   NotFoundCnt,
   wBadRouteCnt : NUMERIC[0];
 BEGIN
  SETEMPTY(NotFoundList, wBadRouteList);
  SETZERO(NotFoundCnt, wBadRouteCnt);
  IF SELECT(ElTck, TSN, TckRcS.TSN, TckRcS.Date) THEN
   WHILE OCCURE(ElTck) DO
    PROMPT("  ஭ : " + L_DatTim.DateTimeStr(ElTck.DateIn, ElTck.TimeIn));
    IF !ElTck.TckRcS THEN
     so:=L_TRS.StandOnJobByElTck(1);
     IF (so # L_TRS.sojbet_Found) & ElTck.badRoute THEN
      so:=L_TRS.StandOnJobByElTck(0);
      IF so = L_TRS.sojbet_Found THEN
       INC(wBadRouteCnt);
       IF wBadRouteCnt < 15 THEN
        wBadRouteList:=wBadRouteList + "|" + L_DatTim.DateTimeStr(ElTck.DateIn, ElTck.TimeIn) +
                      "  " + Str.Align(ElTck.Route, 4, LEFT);
       END;
      END;
     END;
     IF so = L_TRS.sojbet_Found THEN
      ADD(TckRcJR, TckRcS, , TckRcJ.TckRcS, TckRcJ.Day, TckRcJ.StartT, L_TRS.TckKindOfVldCardType(ElTck.ElTckT),
                             TckRcJR.Sum, ElTck.Price,
                             TckRcJR.Psg, 1);
      ElTck.TckRcS:=TckRcS.TckRcS;
      L_TRS.ReplaceElTckAfterBind();
     ELSE
      INC(NotFoundCnt);
      IF NotFoundCnt < 15 THEN
       NotFoundList:=NotFoundList + "|" + L_DatTim.DateTimeStr(ElTck.DateIn, ElTck.TimeIn) +
                     "  " + Str.Align(ElTck.Route, 4, LEFT);
      END;
     END;
    END;
    NEXT(ElTck);
   END; (* WHILE OCCURE(ElTck) ... *)
  END;
  IF NotFoundCnt >= 15 THEN
   NotFoundList:=NotFoundList + "|" + "...";
  END;
  IF NotFoundCnt > 0 THEN
   L_StdFrm.Question(" 㤠  ३ .|  " + L_Str.IntStr(NotFoundCnt) +
                     Str.EnumObject(NotFoundCnt, " | | ") + ":|" + NotFoundList + "|");
  END;
  IF wBadRouteCnt >= 15 THEN
   wBadRouteList:=wBadRouteList + "|" + "...";
  END;
  IF wBadRouteCnt > 0 THEN
   L_StdFrm.Question("  ࠭  ᮮ⢥⢨ " +
                     "|(⠪  ࠭ 믮﫮 ࠧᥭ  ⪫祭 ஫)." +
                     "|  " + L_Str.IntStr(wBadRouteCnt) +
                     Str.EnumObject(wBadRouteCnt, " | | ") + ":|" + wBadRouteList + "|");
  END;
 END {FillTckRcJR};

 PRIVATE PROCEDURE MismatchTotalsMsg(s: STRING[]): STRING[];
 BEGIN
  RETURN " " + TckRcT.TckRcT + " (" + TckKind.TckKind + " " + TckKind.Name + "):" +
         "| ᮢ " + s + "  ३ᠬ   " + s + "  楫  " +
         '|(. "F9 - ஡"  ப  )';
 END {MismatchTotalsMsg};

 PRIVATE PROCEDURE TckRcS_OnAfterEdIns();
  VAR
   _TckRAmnt: LIKE(TckRcJ.TckRAmnt);
   _TckRPsg : LIKE(TckRcJ.TckRPsg);
   i        : NUMERIC[0];
   _TckSum  : NUMERIC[2];
   _TckPsg  : NUMERIC[0];
 BEGIN
  L_XDoc.xdmb_CheckABan(L_XDoc.xdcls_RWayS, TckRcS.Date);
  IF trsHasAnySelling() & ~SELECT(TckRcJ, TckRcS, TckRcS.TckRcS) THEN
   L_StdFrm.Choice("   த,   ३ᮢ. ⠭ ﭨ ' ⠪஢'?");
   TckRcS.Status:=L_TRS.trsStat_Taken;
   REPLACE(TckRcS);
  ELSE
   IF ~L_TRS.E_FillRWJP(TckRcS.Date) THEN
    FillTckRcJR();
   END;
   IF L_TRS.TckRcSLevel() > L_TRS.il_woBeg THEN
    CheckTckRcTSum();
    IF SELECT(TckRcJ, TckRcS, TckRcS.TckRcS) THEN
     SETZERO(_TckRAmnt, _TckRPsg);
     WHILE OCCURE(TckRcJ) DO
      i:=0;
      WHILE i <= HIGH(TckRcJ.TckRAmnt) DO
       INC(_TckRAmnt[i], TckRcJ.TckRAmnt[i]);
       INC(_TckRPsg[i],  TckRcJ.TckRPsg[i]);
       INC(i);
      END;
      NEXT(TckRcJ);
     END; (* WHILE OCCURE(TckRcJ) ... *)
     LAST(TckRcJ);
     SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
     WHILE OCCURE(TckRcT) DO
      CONFORM(TckRcT, TckKind);
      IF ~!TckRcT.Number & ~L_TRS.IsSpecialNoSaleTckKind() & ~L_TRS.E_SpecialTckRcTCheck() THEN
       IF TckKind.Type = L_TRS.tkt_ZonalTicket THEN
        L_General.Assert(TckRcT.RSum = _TckRAmnt[TckRcT.Number-1],
                         MismatchTotalsMsg("㬬 ᯨᠭ "));
       ELSE
        L_General.Assert(TckRcT.RSum = _TckRAmnt[TckRcT.Number-1] * TckKind.FaceVal,
                         MismatchTotalsMsg("㬬 ᯨᠭ "));
       END;
       IF    L_TRS.E_TckRcJTckNbrIsAmountOnTrip() THEN
        SETZERO(_TckSum, _TckPsg);
        SAVE(TckRcJ);
        SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
        WHILE OCCURE(TckRcJ) DO
         IF L_TRS.IsBulk_wCUC() THEN
          INC(_TckSum, TckRcJ.TckNbrs[TckRcT.Number-1]);
         ELSE
          INC(_TckSum, TckRcJ.TckNbrs[TckRcT.Number-1] * TckKind.FaceVal);
         END;
         IF ~!TckRcJ.TckPsg[TckRcT.Number-1] THEN
          INC(_TckPsg, TckRcJ.TckPsg[TckRcT.Number-1]);
         END;
         NEXT(TckRcJ);
        END; (* WHILE OCCURE(TckRcJ) ... *)
        RESTORE(TckRcJ);
        IF TckKind.Type = L_TRS.tkt_OutsideSales THEN
         IF _TckSum # TckRcT.ExpSum THEN
          L_StdFrm.Choice(MismatchTotalsMsg("㬬") + L_StdFrm.HR() +
                          "⮣ 㬬 㤥 ਢ  ᮮ⢥⢨  㬬  ३ᠬ");
          TckRcT.ExpSum:=_TckSum;
          REPLACE(TckRcT);
         END;
         IF (_TckPsg # TckRcT.ExpNum) & L_TRS.TckKind_wPsg() THEN
          L_StdFrm.Choice(MismatchTotalsMsg("⢮ ᠦ஢"));
         END;
        ELSE
         L_General.Assert(_TckSum = TckRcT.ExpSum, MismatchTotalsMsg("㬬"));
         IF (_TckPsg # TckRcT.ExpNum) & L_TRS.TckKind_wPsg() THEN
          L_StdFrm.CrucialChoice(MismatchTotalsMsg("⢮ ᠦ஢"), L_APtm.g_RWOp);
         END;
        END;
       ELSIF L_TRS.ResetNumbersAtTaxing() THEN
        L_General.Assert((TckRcT.BefNbr + TckRcJ.TckNbrs[TckRcT.Number-1]) = TckRcT.AftNbr,
                         MismatchTotalsMsg("㬬"));
        IF L_TRS.TckKind_wPsg() THEN
         IF TckRcJ.TckPsg[TckRcT.Number-1] # TckRcT.ExpNum THEN
          L_StdFrm.CrucialChoice(MismatchTotalsMsg("⢮ ᠦ஢"), L_APtm.g_RWOp);
         END;
         IF _TckRPsg[TckRcT.Number-1] # TckRcT.RNum THEN
          L_StdFrm.CrucialChoice(MismatchTotalsMsg("⢮ ᠦ஢"), L_APtm.g_RWOp);
         END;
        END;
       ELSE
        L_General.Assert((TckRcJ.TckNbrs[TckRcT.Number-1] = TckRcT.AftNbr), MismatchTotalsMsg("㬬"));
        IF (TckRcJ.TckPsg[TckRcT.Number-1] # TckRcT.ExpNum) & L_TRS.TckKind_wPsg() THEN
         L_StdFrm.CrucialChoice(MismatchTotalsMsg("⢮ ᠦ஢"), L_APtm.g_RWOp);
        END;
       END;
      END; (*IF ~!TckRcT.Number & ... *)
      NEXT(TckRcT);
     END; (* WHILE OCCURE(TckRcT) ... *)
 
     TckRcS.Status:=L_TRS.trsStat_Rated;
    END;
   ELSE
    IF L_Way.GetAdjustedTckRcSTotTInc() # TckRcS.TotCash THEN
     L_StdFrm.Question("㬬    ᮢ  ' 묨'");
    END;
    IF TckRcS.AsWho # L_Way.trs_Driver THEN
     SELECT(WayLMen, TSN, , TckRcS.TSN, TckRcS.Date);
     WHILE OCCURE(WayLMen) DO
      CONFORM(WayLMen, RWayS);
      L_General.Assert(~RWayS.Done, "室 ।⥫쭮 ⪠  ࠡ⭨  "+L_DatTim.DateStr(TckRcS.Date)+"|ਬ,  "+RWayS.RWayS);
      NEXT(WayLMen);
     END; (* WHILE OCCURE(WayLMen) ... *)
    END;
   END; (*IF L_TRS.TckRcSLevel() > L_TRS.il_woBeg*)
   SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
   WHILE OCCURE(TckRcJ) DO
    IF L_Way.E_IsImaginaryRoute(TckRcS.Date, TckRcJ.Route) THEN
     L_General.Assert(TckRcS.AsWho<L_Way.trs_Chopper, "⨢ த ᪠ ଫ    ⥫");
    END;
    CheckTckKindAllowedOnTrip();
    NEXT(TckRcJ);
   END; (* WHILE OCCURE(TckRcJ) ... *)
   IF IsInBegModification() THEN
    TckRcS.Message:=L_lsStore.Replace(TckRcS.Message, v_Message);
   END;
   REPLACE(TckRcS);
   IF TckRcS.AsWho = L_Way.trs_Chopper THEN
    L_General.Assert(TckRcS.ToPay # L_Way.toPay_SeeRsp, "稪 ⨬ 㪠뢠 '' = ''");
   END;
   IF TckRcS.Status = L_TRS.trsStat_Rated THEN
    IF AvailableToPay() & (TckRcS.ToPay # 0) THEN
     CONFORM(TckRcS, Staff);
     IF Staff.Contract = L_Staff.cnt_ContractorsAgreement THEN
      L_StdFrm.WrongDB("⭨ " + TckRcS.TSN + " ଫ   鸞.   ''");
     END;
    END;
   END;
  END; (*IF trsHasAnySelling() &... *)
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, TckRcS.TckRcS);
 END {TckRcS_OnAfterEdIns};

 PRIVATE PROCEDURE TckRcS_OnAfterEdit();
 BEGIN
  IF (TckRcS.Status # L_TRS.trsStat_Ordered) & (L_TRS.TckRcSLevel() > L_TRS.il_woBeg) THEN
   IF (TckRcS.AsWho # GE_PVALUE(TckRcS.AsWho)) | (TckRcS.Date # GE_PVALUE(TckRcS.Date)) THEN
    L_AcsPnt.PassAccessPoint(ap_TicketCassaTRSModify);
   END;
  END;
  TckRcS_OnAfterEdIns();
 END {TckRcS_OnAfterEdit};

 PRIVATE PROCEDURE TckRcS_OnAfterInsert();
 BEGIN
  TckRcS_OnAfterEdIns();
 END {TckRcS_OnAfterInsert};

 PRIVATE PROCEDURE GetSingleNbrFormat(Idx: NUMERIC[0]): STRING[];
 BEGIN
  IF ACCESS(TckRcJ) THEN
   RETURN L_TRS.GetNbrFormat(TckRcJ.TckNbrs[Idx]);
  ELSE
   RETURN L_TRS.GetNbrFormat(EMPTYOF(L_TRS.tTckNumber));
  END;
 END {GetSingleNbrFormat};

 PRIVATE PROCEDURE TckRcJE_0_OnReposition();
  VAR
   fields: FORM_FIELDS;
 BEGIN
  IF ACCESS(TckRcS) THEN
   fields:=RTI.Get().CurZone.Fields;
   fields("TckRcJ.asRWayS").Modifiable:=L_Way.E_Fill_asRWayS(TckRcS.Date);
   fields("TckRcJ.asBoxNbr").Modifiable:=~L_Way.E_Fill_asRWayS(TckRcS.Date);
  END;
 END {TckRcJE_0_OnReposition};

 PUBLIC PROCEDURE TckRcJ_asRWayS_SetModifiable();
 BEGIN
  ACCESS(TckRcJ);
  L_WDO.SetFieldModifiable("TckRcJ.asRWayS", 1);
  TckRcJ.udRWayS:=1;
  REPLACE(TckRcJ);
 END {TckRcJ_asRWayS_SetModifiable};

 PUBLIC PROCEDURE TckRcJ_asRWayS_Reset();
 BEGIN
  ACCESS(TckRcJ);
  L_WDO.SetFieldModifiable("TckRcJ.asRWayS", L_Way.E_Fill_asRWayS(TckRcJ.asDate));
  SETEMPTY(TckRcJ.asRWayS);
  TckRcJ.udRWayS:=0;
  REPLACE(TckRcJ);
 END {TckRcJ_asRWayS_Reset};

 PRIVATE PROCEDURE TckRcJE_0_OnZoneOpen();
  VAR
   prvNumbers: LIKE(TckRcJ.TckNbrs);
 BEGIN
  SETEMPTY(prvNumbers);
  ACCESS(TckRcS);
  TckRcJE_0_SetupNbrs(prvNumbers);
 END {TckRcJE_0_OnZoneOpen};

 PRIVATE PROCEDURE TckRcS_TckRcS_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!TckRcS.TckRcS, " ⠢ ");
  L_XDoc.ChangeXDoc(L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, GE_PVALUE(), TckRcS.TckRcS);
 END {TckRcS_TckRcS_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcS_Date_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!TckRcS.Date, "   ।");
  TckRcS_TSN_OnSuccessfulChange();
  IF L_Way.E_Fill_asRWayS(TckRcS.Date) THEN
   CheckRWayS(TckRcS.asRWayS[0], 0);
  END;
  CONFORM(TckRcS, TckRcJ);
  WHILE OCCURE(TckRcJ) DO
   TckRcJ.asDate:=TckRcS.Date;
   REPLACE(TckRcJ);
   NEXT(TckRcJ);
  END; (* WHILE OCCURE(TckRcJ) ... *)
  IF (TckRcS.Status # L_TRS.trsStat_Ordered) & (L_Way.E_TckRcLevel(TckRcS.Date) > L_TRS.il_woBeg) THEN
   IF ~L_AcsPnt.MayPassAccessPoint(ap_TicketCassaTRSModify) THEN
    L_AcsPnt.PassAccessPoint(ap_TicketCassaTRSModify);
   END;
  END;
 END {TckRcS_Date_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcS_AsWho_OnSuccessfulChange();
  VAR
   D: DATE;
 BEGIN
  IF !TckRcS.Date THEN
   D:=Memo.ud_cd();
  ELSE
   D:=TckRcS.Date;
  END;
  L_TRS.E_SetDefaultTckRcS_Signs(D);
  IF ~!TckRcS.TSN & ~!(L_TRS.E_TckRcS_AsWhoCnd_GetPool(D, TckRcS.AsWho)) THEN
   TckRcS.AsWhoCnd:=L_TRS.E_GetDefaultAsWhoCnd(TckRcS.TSN, D);
  ELSE
   SETEMPTY(TckRcS.AsWhoCnd);
  END;
  REPLACE(TckRcS);
  IF (L_Way.E_TckRcLevel(TckRcS.Date) > L_TRS.il_woBeg) & ~!GE_PVALUE() THEN
   IF ~L_AcsPnt.MayPassAccessPoint(ap_TicketCassaTRSModify) THEN
    L_AcsPnt.PassAccessPoint(ap_TicketCassaTRSModify);
   END;
  END;
  TckRcSE_0_SetupWinFields();
 END {TckRcS_AsWho_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcSIsSingle(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(TckRcS);
  Result:=CHANGESEL(TckRcS, TSN, TckRcS.TSN, TckRcS.Date) & FIRST(TckRcS) & ~NEXT(TckRcS);
  RESTORE(TckRcS);
  RETURN Result;
 END {TckRcSIsSingle};

 PRIVATE PROCEDURE TckRcS_TSN_OnSuccessfulChange();
  CONST
   zeroRWayS = 0;
  VAR
   _RWayS  : LIKE(RWayS.RWayS);
   D       : DATE;
 BEGIN
  L_General.Assert(~!TckRcS.TSN, "   ⠢ ");
  IF TckRcS.Status = L_TRS.trsStat_Ordered THEN
   L_General.CallUs(!TckRcS.Date);
   L_General.Assert(!TckRcS.Storage,
                    "   ଫ 㬥 ⭮ .| ⠡쭮  ࠡ⭨ 饭");
   L_General.Assert(TckRcSIsSingle(),
                    " ࠡ⭨ " + TckRcS.TSN + " 㦥  ࠧ殮 ");
   D:=SYSDATE();
  ELSE
   L_General.Assert(~!TckRcS.Date, "  ");
   D:=TckRcS.Date;
  END;
  L_TRS.CheckStaffAdaptability(TckRcS.TSN, D);
  IF !TckRcS.AsWho THEN
   TckRcS.AsWho:=L_TRS.E_GetDefaultAsWho(TckRcS.TSN, D);
   IF ~!TckRcS.AsWho THEN
    TckRcS_AsWho_OnSuccessfulChange();
   ELSE
    L_StdFrm.Question(" ⥫,  ?");
    REPLACE(TckRcS);
   END;
  ELSIF !GE_PVALUE() THEN
   TckRcS_AsWho_OnSuccessfulChange();
  END;
  IF TckRcS.Status # L_TRS.trsStat_Ordered THEN
   IF ~TckRcSIsSingle() THEN
    L_StdFrm.Choice("   ࠡ⭨   ?");
   END;
   IF L_Way.E_BegRWSLev(D) >= L_Way.brwsl_Active THEN
    IF !TckRcS.asRWayS[0] & !TckRcS.asBoxNbr THEN
     SETEMPTY(_RWayS);
     IF TckRcS.AsWho = L_Way.trs_Driver THEN
      IF SELECT(RWayS, TSN, TckRcS.TSN, D) THEN
       _RWayS:=RWayS.RWayS;
       IF NEXT(RWayS) THEN
        _RWayS:=zeroRWayS;
       END;
      END;
     ELSIF TckRcS.AsWho = L_Way.trs_Guard THEN
      SELECT(WayLMen, TSN, , TckRcS.TSN, D);
      WHILE OCCURE(WayLMen) DO
       IF WayLMen.Who = L_Way.wlmwho_Guard THEN
        IF !_RWayS THEN
         _RWayS:=WayLMen.RWayS;
        ELSE
         _RWayS:=zeroRWayS;
        END;
       END;
       NEXT(WayLMen);
      END; (* WHILE OCCURE(WayLMen) ... *)
     END;
     IF ~!_RWayS & (_RWayS # zeroRWayS) THEN
      IF L_Way.E_Fill_asRWayS(D) THEN
       TckRcS.asRWayS[0]:=_RWayS;
       TckRcS_asRWayS_OnSuccessfulChange();
      ELSE
       SEARCH(RWayS, RWayS, , _RWayS);
       TckRcS.asBoxNbr:=RWayS.BoxNbr;
      END;
      REPLACE(TckRcS);
     END;
    END;
   END;
  END;
 END {TckRcS_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckTckKindIsActive(trgTckKind: LIKE(TckKind.TckKind); D: DATE);
 BEGIN
  SEARCH(TckKind, TckKind, , trgTckKind);
  L_General.Assert(L_DatTim.IsActive(D, TckKind.Begin, TckKind.Till),
                   "  " + trgTckKind + "   " + L_DatTim.DateStr(D));
 END {CheckTckKindIsActive};

 PRIVATE PROCEDURE TckRcT_TckKind_OnSuccessfulChange();
  VAR
   cur_InCash: LIKE(TckKind.InCash);
   cur_InSale: SCAL[2];
 BEGIN
  L_General.Assert(~SELECT(TckRcJ, TckRcS, TckRcS.TckRcS), "  த  ३ᠬ");
  IF ~!TckRcT.TckKind THEN
   CONFORM(TckRcT, TckKind);
   L_General.Assert(~IsAutoBuildTckRcT() | L_TRS.IsEasySalesTck(), "     ᪠");
   CheckTckKindIsActive(TckRcT.TckKind, TckRcS.Date);
   MayModifyTckRcT(!GE_PVALUE(TckRcT.TckKind));

   IF IsAutoBuildTckRcT() & ~!GE_PVALUE(TckRcT.TckKind) THEN
    cur_InCash:=TckKind.InCash;
    cur_InSale:=L_TRS.InSale();
    SAVE(TckKind);
    SEARCH(TckKind, TckKind, , GE_PVALUE(TckRcT.TckKind));
    L_General.Assert((TckKind.InCash = cur_InCash) & (L_TRS.InSale() = cur_InSale),
                     "     ᪠");
    RESTORE(TckKind);
   END;
   IF IsModifiableAutobuildTCK() THEN
    TckRcT.BefNbr:=0;
    REPLACE(TckRcT);
   END;
  END;
  TckRcT_SetupFields();
 END {TckRcT_TckKind_OnSuccessfulChange};

 PRIVATE PROCEDURE _TckRcJ_TckNbrs_OnSuccessfulChange(pvNbr  : L_TRS.tTckNumber;
                                                      pvPsg  : L_TRS.tTckPsg;
                                                      pvRAmnt: L_TRS.tTckNumber;
                                                      pvRPsg : L_TRS.tTckPsg;
                                                      Index  : NUMERIC[0]);
  VAR
   TheLast: SCAL[2];
   prvNbrs: LIKE(TckRcJ.TckNbrs);
   prvPsg : LIKE(TckRcJ.TckPsg);
 BEGIN
  L_General.Assert(~(!TckRcJ.StartT | !TckRcJ.Day), "室  ६ 砫 ३");
  L_General.CallUs(SELECT(TckRcT, Number, TckRcJ.TckRcS, Index+1));
  L_TRS.GetPrvJobInfo(prvNbrs, prvPsg);
  TheLast:=L_TRS.IsLastJob();
  CalcJobTotals(-1, TheLast, prvNbrs[Index], pvNbr,
                             prvPsg [Index], pvPsg,
                             pvRAmnt, pvRPsg);
  CONFORM(TckRcT, TckKind);
  L_TRS.CompleteNumber(TckRcJ.TckNbrs[Index], prvNbrs[Index]);
  REPLACE(TckRcJ);
  IF L_TRS.TckKind_wPsg() & (L_TRS.NumbersDir() = L_TRS.nd_Incr) THEN
   L_General.Assert(TckRcJ.TckPsg[Index] >= prvPsg[Index],
                    "⢮ ᠦ஢     ।饣 祭");
  END;
  CalcJobTotals(+1, TheLast, prvNbrs[Index], TckRcJ.TckNbrs[Index],
                             prvPsg [Index], TckRcJ.TckPsg [Index],
                             TckRcJ.TckRAmnt[Index], TckRcJ.TckRPsg[Index]);
 END {_TckRcJ_TckNbrs_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcJ_TckNbrs_OnSuccessfulChange();
  VAR
   Index: NUMERIC[0];
 BEGIN
  Index:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  L_General.Assert(~!TckRcJ.TckNbrs[Index], "   ⠢ ");
  SELECT(TckRcT, Number, , TckRcJ.TckRcS, Index+1);
  CONFORM(TckRcT, TckKind);
  L_General.Assert(~L_TRS.IsBulk_wCUC(), ". F9 -  த  㯯 ஢ 筮 ");
  _TckRcJ_TckNbrs_OnSuccessfulChange(GE_PVALUE(TckRcJ.TckNbrs[Index]),
                                     TckRcJ.TckPsg[Index],
                                     TckRcJ.TckRAmnt[Index],
                                     TckRcJ.TckRPsg[Index],
                                     Index);
 END {TckRcJ_TckNbrs_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcJ_TckPsg_OnSuccessfulChange();
  VAR
   Index: NUMERIC[0];
 BEGIN
  Index:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  L_General.Assert(~!TckRcJ.TckPsg[Index], "   ⠢ ");
  _TckRcJ_TckNbrs_OnSuccessfulChange(TckRcJ.TckNbrs[Index],
                                     GE_PVALUE(TckRcJ.TckPsg[Index]),
                                     TckRcJ.TckRAmnt[Index],
                                     TckRcJ.TckRPsg[Index],
                                     Index);
 END {TckRcJ_TckPsg_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcJ_TckRAmnt_OnSuccessfulChange();
  VAR
   Incr,
   Index: NUMERIC[0];
 BEGIN
  Index:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  L_General.Assert(~!TckRcJ.TckRAmnt[Index], "   ⠢ ");
  L_General.CallUs(SELECT(TckRcT, Number, TckRcJ.TckRcS, Index+1));
  Incr:=TckRcJ.TckRAmnt[Index] - GE_PVALUE();
  CONFORM(TckRcT, TckKind);
  CONFORM(TckRcJ, TckRcS);
  IF TckKind.Type = L_TRS.tkt_ZonalTicket THEN
   INC(TckRcJ.RSum, Incr);
  ELSE
   INC(TckRcJ.RSum, Incr * TckKind.FaceVal);
   IF L_TRS.IsMainTckKind(TckKind.TckKind, TckRcS.Date, TckRcJ.Route) THEN
    INC(TckRcJ.TckRPsg[Index], Incr);
    INC(TckRcJ.RPsg, Incr);
   END;
  END;

  REPLACE(TckRcJ);
 END {TckRcJ_TckRAmnt_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcJ_TckRPsg_OnSuccessfulChange();
  VAR
   Incr,
   Index: NUMERIC[0];
 BEGIN
  Index:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  L_General.Assert(~!TckRcJ.TckRPsg[Index], "   ⠢ ");
  Incr:=TckRcJ.TckRPsg[Index] - GE_PVALUE();
  INC(TckRcJ.RPsg, Incr);
  REPLACE(TckRcJ);
 END {TckRcJ_TckRPsg_OnSuccessfulChange};

 PRIVATE PROCEDURE SupportTckRcDLLTimeChange(PDay: LIKE(TckRcDLL.Day); PTime: LIKE(TckRcDLL.Time);
                                             NDay: LIKE(TckRcDLL.Day); NTime: LIKE(TckRcDLL.Time));
 BEGIN
  SELECT(TckRcD, TckRcS, , TckRcJ.TckRcS);
  WHILE OCCURE(TckRcD) DO
   IF TckRcD.Type # L_TRS.trdt_Laying THEN
    CONFORM(TckRcD, TckRcDL);
    WHILE OCCURE(TckRcDL) DO
     CONFORM(TckRcDL, TckRcDLL);
     WHILE OCCURE(TckRcDLL) DO
      IF (TckRcDLL.Day = PDay) & (TckRcDLL.Time = PTime) THEN
       TckRcDLL.Day :=NDay;
       TckRcDLL.Time:=NTime;
       REPLACE(TckRcDLL);
      END;
      NEXT(TckRcDLL);
     END; (* WHILE OCCURE(TckRcDLL) ... *)
     NEXT(TckRcDL);
    END; (* WHILE OCCURE(TckRcDL) ... *)
   END;
   NEXT(TckRcD);
  END; (* WHILE OCCURE(TckRcD) ... *)
 END {SupportTckRcDLLTimeChange};

 PRIVATE PROCEDURE TckRcJ_StartT_OnSuccessfulChange();
  VAR
   _TckNbrs : LIKE(TckRcJ.TckNbrs);
   _TckPsg  : LIKE(TckRcJ.TckPsg);
 BEGIN
  L_General.Assert(~!TckRcJ.StartT, "⨬ ⠢ ६ ");
  IF ~!GE_PVALUE(TckRcJ.StartT) THEN
   CheckJobsOrder(TckRcJ.Day, GE_PVALUE(TckRcJ.StartT));
   SupportTckRcDLLTimeChange(TckRcJ.Day, GE_PVALUE(TckRcJ.StartT), TckRcJ.Day, TckRcJ.StartT);
  ELSE
   L_TRS.GetPrvJobInfo(_TckNbrs, _TckPsg);
   TckRcJ.TckNbrs:=_TckNbrs;
   TckRcJ.TckPsg :=_TckPsg;
   CONFORM(TckRcS, TckRcT);
   WHILE OCCURE(TckRcT) DO
    IF ~!TckRcT.Number & L_TRS.IsMainTckKind(TckRcT.TckKind, TckRcJ.asDate, TckRcJ.Route) THEN
     TckRcJ.TckPsg[TckRcT.Number-1]:=0;
    END;
    NEXT(TckRcT);
   END; (* WHILE OCCURE(TckRcT) ... *)
   REPLACE(TckRcJ);
   TckRcJE_0_SetupNbrs(TckRcJ.TckNbrs);
  END;
 END {TckRcJ_StartT_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcJ_Day_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!TckRcJ.Day, "⨬ ⠢  ");
  IF ~!TckRcJ.StartT THEN
   CheckJobsOrder(GE_PVALUE(TckRcJ.Day), TckRcJ.StartT);
   SupportTckRcDLLTimeChange(GE_PVALUE(TckRcJ.Day), TckRcJ.StartT, TckRcJ.Day, TckRcJ.StartT);
  END;
 END {TckRcJ_Day_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcJ_asRWayS_OnSuccessfulChange();
 BEGIN
  CheckRWayS(TckRcJ.asRWayS, 1);
 END {TckRcS_asRWayJ_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcS_asRWayS_OnSuccessfulChange();
 BEGIN
  CheckRWayS(TckRcS.asRWayS[0], 0);
 END {TckRcS_asRWayS_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcS_asBoxNbr_OnSuccessfulChange();
 BEGIN
  CheckANYBoxNbr(TckRcS.asBoxNbr, 0);
 END {TckRcS_asBoxNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcJ_asBoxNbr_OnSuccessfulChange();
 BEGIN
  CheckANYBoxNbr(TckRcJ.asBoxNbr, 1);
 END {TckRcJ_asBoxNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcJ_Route_OnSuccessfulChange();
 BEGIN
  SAVE(TckRcT);
  SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcT) DO
   IF L_TRS.IsMainTckKind(TckRcT.TckKind, TckRcS.Date, TckRcJ.Route) #
      L_TRS.IsMainTckKind(TckRcT.TckKind, TckRcS.Date, GE_PVALUE(TckRcJ.Route)) THEN
    IF (TckRcJ.Psg # 0) | (TckRcJ.Sum # 0) | (TckRcJ.RPsg # 0) | (TckRcJ.RSum # 0) THEN
     L_General.Error(" ᭮ .  㤠 ३  ନ .");
    ELSE
     IF ~!TckRcT.Number & ~!TckRcJ.TckNbrs[TckRcT.Number-1] THEN
      IF L_TRS.IsMainTckKind(TckRcT.TckKind, TckRcJ.asDate, TckRcJ.Route) |
         L_TRS.TckKind_wPsg() & L_TRS.E_TckRcJTckNbrIsAmountOnTrip() THEN
       TckRcJ.TckPsg[TckRcT.Number-1]:=0;
      ELSE
       SETEMPTY(TckRcJ.TckPsg[TckRcT.Number-1]);
      END;
      REPLACE(TckRcJ);
     END;
    END;
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
  RESTORE(TckRcT);
 END {TckRcJ_Route_OnSuccessfulChange};

 PRIVATE PROCEDURE ANY_asRWayS_OnAskPhase1();
  VAR
   curFieldExpression: STRING[];
 BEGIN
  curFieldExpression:=RTI.Get().CurZone.ActiveField.Expression;
  IF ~!^(curFieldExpression) THEN
   IF SEARCH(RWayS, RWayS, ^(curFieldExpression)) THEN
    SE_WZD_POSITION(RTI.Get().TrgWindow.Name, RTI.Get().TrgZone.Number, RWayS);
   END;
  END;
 END {ANY_asRWayS_OnAskPhase1};

 PRIVATE PROCEDURE TckRcS_asRWayS_OnAskPhase1();
 BEGIN
  ANY_asRWayS_OnAskPhase1();
 END {TckRcS_asRWayS_OnAskPhase1};

 PRIVATE PROCEDURE TckRcJ_asRWayS_OnAskPhase1();
 BEGIN
  ANY_asRWayS_OnAskPhase1();
 END {TckRcJ_asRWayS_OnAskPhase1};

 PRIVATE PROCEDURE ANY_asRWayS_OnAskPhase2();
 BEGIN
  ACCESS(RWayS);
  INTEGRITY(NoAsk);
  ^(RTI.Get().CurZone.ActiveField.Expression):=RWayS.RWayS;
  REPLACE(^(RTI.Get().CurZone.MasterTable.Name));
 END {ANY_asRWayS_OnAskPhase2};

 PRIVATE PROCEDURE TckRcS_asRWayS_OnAskPhase2();
 BEGIN
  ANY_asRWayS_OnAskPhase2();
 END {TckRcS_asRWayS_OnAskPhase2};

 PRIVATE PROCEDURE TckRcJ_asRWayS_OnAskPhase2();
 BEGIN
  ANY_asRWayS_OnAskPhase2();
 END {TckRcJ_asRWayS_OnAskPhase2};

 PRIVATE PROCEDURE ANY_asBoxNbr_OnAskPhase1();
  VAR
   curFieldExpression: STRING[];
 BEGIN
  curFieldExpression:=RTI.Get().CurZone.ActiveField.Expression;
  IF ~!^(curFieldExpression) THEN
   L_General.CallUs(SEARCH(Car, BoxNbr, ^(curFieldExpression)));
   SE_WZD_POSITION(RTI.Get().TrgWindow.Name, RTI.Get().TrgZone.Number, Car);
  END;
 END {ANY_asBoxNbr_OnAskPhase1};

 PRIVATE PROCEDURE TckRcS_asBoxNbr_OnAskPhase1();
 BEGIN
  ANY_asBoxNbr_OnAskPhase1();
 END {TckRcS_asBoxNbr_OnAskPhase1};

 PRIVATE PROCEDURE TckRcJ_asBoxNbr_OnAskPhase1();
 BEGIN
  ANY_asBoxNbr_OnAskPhase1();
 END {TckRcJ_asBoxNbr_OnAskPhase1};

 PRIVATE PROCEDURE ANY_asBoxNbr_OnAskPhase2();
 BEGIN
  ACCESS(Car);
  INTEGRITY(NoAsk);
  ^(GE_CURFILE()+".asBoxNbr") :=Car.BoxNbr;
  REPLACE(^(GE_CURFILE()));
 END {ANY_asBoxNbr_OnAskPhase2};

 PRIVATE PROCEDURE TckRcS_asBoxNbr_OnAskPhase2();
 BEGIN
  ANY_asBoxNbr_OnAskPhase2();
 END {TckRcS_asBoxNbr_OnAskPhase2};

 PRIVATE PROCEDURE TckRcJ_asBoxNbr_OnAskPhase2();
 BEGIN
  ANY_asBoxNbr_OnAskPhase2();
 END {TckRcJ_asBoxNbr_OnAskPhase2};

 PUBLIC PROCEDURE TckRcJ_TckNbrs_OnSetEndOfPacket();
  VAR
   curField: FORM_FIELD;
   _TckNbr: L_TRS.tTckNumber;
   Index  : NUMERIC[0];
 BEGIN
  curField:=RTI.Get().CurZone.ActiveField;
  L_General.CallUs(~!curField.TableField & (curField.TableField.Name = "TckNbrs"));
  Index:=curField.ArrayIndex;
  L_General.CallUs(SELECT(TckRcT, Number, TckRcJ.TckRcS, Index+1));
  CONFORM(TckRcT, TckKind);
  L_General.Assert(TckKind.Type = L_TRS.tkt_Ticket, "쪮  ⮢");
  L_General.Assert(TckKind.PckVol # 0, " 㯠    0 ⮢");
  _TckNbr:=TckRcJ.TckNbrs[Index];
  TckRcJ.TckNbrs[Index]:=L_TRS.EndOfPack();
  REPLACE(TckRcJ);
  IF L_TRS.GetNbrFactLength(TckRcJ.TckNbrs[Index]) > TckKind.NbrPrc THEN
   L_WDO.SetFieldFormat(L_Str.Var_wIdx("TckRcJ.TckNbrs", Index), GetSingleNbrFormat(Index));
  END;
  _TckRcJ_TckNbrs_OnSuccessfulChange(_TckNbr, TckRcJ.TckPsg[Index],
                                     TckRcJ.TckRAmnt[Index], TckRcJ.TckRPsg[Index], Index);
  LIKEMENU(NxtField, "");
 END {TckRcJ_TckNbrs_OnSetEndOfPacket};

 PRIVATE PROCEDURE PutRWayJP(Store: NUMERIC[0]; _Number: LIKE(WayLMen.Number));
  VAR
   _RWJPro: LIKE(RWJPro.RWJPro)[16];
   _Value : LIKE(RWayJP.Value)[16];
   i      : NUMERIC[0];
 BEGIN
  L_TRS.PrepareRWayJP(_Number, _RWJPro, _Value);
  i:=0;
  WHILE ~!_RWJPro[i] DO
   L_Way.SaveRWayJP(Store, _RWJPro[i],  _Value[i], L_Way.rwjpSrc_TckRcS);
   INC(i);
  END; (* WHILE ... *)
 END {PutRWayJP};

 PRIVATE PROCEDURE getRWayJTime(): FLOAT;
  VAR
   Result: FLOAT;
 BEGIN
  IF L_TRS.E_TRJStartTMeaning() = L_TRS.trjstm_StopT THEN
   Result:=L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT);
  ELSE
   Result:=L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT);
   IF L_TRS.E_TRJStartTMeaning() = L_TRS.trjstm_Departure THEN
    CONFORM(RWayJ, SEJobs);
    CONFORM(SEJobs, RoutMod);
    IF SELECT(SEJMStop, Trip, SEJobs.Trip) THEN
     IF SEJobs.Dir # RoutMod.Dir THEN
      LAST(SEJMStop);
     END;
     Result:=Math.Max(Result, L_Way.FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StartT + SEJMStop.DTim / 60));
    END;
   END;
  END;
  RETURN Result;
 END {getRWayJTime};

 PRIVATE PROCEDURE _2SheetAssert(Cond: SCAL[2]; Msg: STRING[]);
 BEGIN
  L_General.Assert(Cond,
                   " " + TckRcS.TckRcS + " (⠡. " + TckRcS.TSN + "),  " + RWayS.RWayS +
                   L_StdFrm.HR() + Msg);
 END {_2SheetAssert};

 PRIVATE PROCEDURE _2JobAssert(Cond: SCAL[2]; Msg: STRING[]);
  VAR
   Dummy: STRING[];
 BEGIN
  Dummy:="    " + L_DatTim.TimeStr(TckRcJ.StartT) + " (" + TckRcJ.Day + ")";
  IF OCCURE(RWayJ) THEN
   Dummy:=Dummy + "|" +
         "     " + L_DatTim.TimeStr(RWayJ.StartT) + " (" +  RWayJ.Day + ")";
  ELSE
   Dummy:=Dummy + "|" +
         "     ।";
  END;
  _2SheetAssert(Cond, Dummy + "| |" + Msg);
 END {_2JobAssert};

 PRIVATE PROCEDURE GetGuardNumber(): LIKE(WayLMen.Number);
 BEGIN
  IF    TckRcS.AsWho = L_Way.trs_Guard THEN
   SELECT(WayLMen, RWayS, , RWayS.RWayS, L_Way.wlmwho_Guard);
  ELSE
   RETURN 1;
  END;
  WHILE OCCURE(WayLMen) DO
   IF WayLMen.TSN = TckRcS.TSN THEN
    IF L_Way._TimeInt(L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT),
                      L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT),
                      L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT),
                      L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT)) > 0 THEN
     RETURN WayLMen.Number;
    END;
   END;
   NEXT(WayLMen);
  END; (* WHILE ... *)
  _2SheetAssert(0,
                " ⥢   㪠 " +
                Str.Small(L_Str.PoolItem(L_Way.trs_Pool, TckRcS.AsWho)) +
                " " + TckRcS.TSN + "  " + L_DatTim.TimeStr(RWayJ.StartT));
 END {GetGuardNumber};

 PRIVATE PROCEDURE E_IsByUser_asRWayS(D: DATE): SCAL[2];
 BEGIN
  RETURN L_Way.E_Fill_asRWayS(D) | TckRcJ.udRWayS;
 END {E_IsByUser_asRWayS};

 PRIVATE PROCEDURE UnBind_FromRWayS();
 BEGIN
  SETEMPTY(TckRcJ.asDay, TckRcJ.asStartT);
  IF ~E_IsByUser_asRWayS(TckRcS.Date) THEN
   SETEMPTY(TckRcJ.asRWayS);
  END;
  REPLACE(TckRcJ);
 END {UnBind_FromRWayS};

 PRIVATE PROCEDURE E_MaxDelta(): NUMERIC[3];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(TckRcS.Date, PROCREF(E_Way.TckRcS_MaxDelta), 0.25);
 END {E_MaxDelta};

 PRIVATE PROCEDURE getTckRcJTime(): NUMERIC[3];
 BEGIN
  RETURN L_Way.FullBegTime(TckRcJ.Day - (RWayS.Date - TckRcS.Date), TckRcJ.StartT);
 END {getTckRcJTime};

 PRIVATE PROCEDURE GetDelta(): NUMERIC[3];
 BEGIN
  RETURN Math.Abs(getRWayJTime() - getTckRcJTime());
 END {GetDelta};

 PRIVATE PROCEDURE SrcInSelForSeekBetterTrip();
  VAR
   begT: FLOAT;
 BEGIN
  begT:=Math.Max(0, getTckRcJTime() - E_MaxDelta());
  IF L_TRS.E_TRJStartTMeaning() = L_TRS.trjstm_StopT THEN
   SRCINSEL(RWayJ, LT, , begT DIV 24 + 1, 00:00 + begT MOD 24);
  ELSE
   SRCINSEL(RWayJ, LE, , begT DIV 24 + 1, 00:00 + begT MOD 24);
  END;
  IF ~OCCURE(RWayJ) THEN
   FIRST(RWayJ);
  END;
 END {SrcInSelForSeekBetterTrip};

 PRIVATE PROCEDURE Set_TckRcJ_asRWayS(_RWayS: LIKE(RWayS.RWayS));
  VAR
   bestRWayS: LIKE(RWayS.RWayS);
   curDelta,
   bestDelta: NUMERIC[3];
 BEGIN
  IF !TckRcJ.asDay & ~TckRcJ.udRWayS THEN
   CONFORM(TckRcJ, TckRcS);
   IF L_Way.E_IsImaginaryRoute(TckRcS.Date, TckRcJ.Route) THEN
    SETEMPTY(TckRcJ.asRWayS);
    REPLACE(TckRcJ);
   ELSE
    SAVE(TckRcS);
    SAVE(TckRcJ);
    SAVE(RWayS);
    SAVE(RWayJ);
    SETEMPTY(bestRWayS);
    bestDelta:=MAXOF(bestDelta);
    SELECT(RWayS, BoxNbr, , TckRcJ.asBoxNbr, TckRcS.Date);
    WHILE OCCURE(RWayS) DO
     IF (RWayS.Status = L_Way.rwsStat_Rated) & (!_RWayS | (RWayS.RWayS = _RWayS)) THEN
      IF SELECT(RWayJ, RWayS, RWayS.RWayS) THEN
       SrcInSelForSeekBetterTrip();
       WHILE OCCURE(RWayJ) & (getRWayJTime() < getTckRcJTime() + E_MaxDelta()) DO
        curDelta:=GetDelta();
        IF L_TRS.IsGoodRWayJForIncome() & (curDelta < bestDelta) & (curDelta < E_MaxDelta()) THEN
         bestRWayS:=RWayS.RWayS;
         bestDelta:=curDelta;
        END;
        NEXT(RWayJ);
       END;
      END;
     END;
     NEXT(RWayS);
    END; (* WHILE OCCURE(RWayS) ... *)
    TckRcJ.asRWayS:=bestRWayS;
    REPLACE(TckRcJ);
    RESTORE(RWayJ);
    RESTORE(RWayS);
    RESTORE(TckRcS);
    RESTORE(TckRcJ);
   END; (* IF L_Way.E_IsImaginaryRoute... *)
  END;
 END {Set_TckRcJ_asRWayS};

 PRIVATE PROCEDURE RWaySMakeUnDone();
 BEGIN
  IF RWayS.Done THEN
   SAVE(TckRcS);
   SAVE(TckRcJ);
   CALL(RWayS, L_Events.md_StreamMakeUnDone);
   RESTORE(TckRcJ);
   RESTORE(TckRcS);
  END; (* IF RWayS.Done ... *)
 END {RWaySMakeUnDone};

 PRIVATE PROCEDURE MakeDoneRWaySWithPlanIsEqualFact(RWaySWithPlanIsEqualFact: LIKE(RWayS.RWayS)[]);
  VAR
   Idx: NUMERIC[0];
 BEGIN
  SAVE(RWayS);
  SAVE(TckRcS);
  SAVE(TckRcJ);
  Idx:=0;
  WHILE ~!RWaySWithPlanIsEqualFact[Idx] DO
   TRY
    SEARCH(RWayS, RWayS, , RWaySWithPlanIsEqualFact[Idx]);
    CALL(RWayS, L_Events.md_StreamMakeDone);
   EXCEPT
   ELSE
    L_StdFrm.RedInform("   ᪮쪨 易 ३ᠬ " +
                       "|⠭   室, ࠢ 䠪." +
                       "|| 裡  ⨬ ॡ ࠡ 易 .");
    RAISE();
   END; (* TRY *)
   INC(Idx);
  END;
  RESTORE(TckRcJ);
  RESTORE(TckRcS);
  RESTORE(RWayS);
 END {MakeDoneRWaySWithPlanIsEqualFact};

 PRIVATE PROCEDURE PutRWaySToArr(VAR Arr: LIKE(RWayS.RWayS)[]; _RWayS: LIKE(RWayS.RWayS));
  VAR
   Idx: NUMERIC[0];
 BEGIN
  Idx:=0;
  WHILE ~!Arr[Idx] DO
   IF Arr[Idx] = _RWayS THEN
    RETURN;
   END;
   INC(Idx);
  END;
  Arr[Idx]:=_RWayS;
 END {PutRWaySToArr};

 PRIVATE PROCEDURE Proceed(Dir: NUMERIC[0]; _RWayS: LIKE(RWayS.RWayS));
  VAR
   prvRWayS: LIKE(TckRcJ.asRWayS);
   prvDelta,
   curDelta : NUMERIC[3];
   _Day     : LIKE(RWayJ.Day);
   _StartT  : TIME;
   _Done    : LIKE(TckRcS.Done);
   DoIt     : SCAL[2];
   RWaySWithPlanIsEqualFact: LIKE(RWayS.RWayS)[100];
 BEGIN
  APP.Get().NewPrompt("  "+TckRcS.TckRcS+" ("+L_DatTim.DateStr(TckRcS.Date)+"). । 窨");
  SETEMPTY(RWaySWithPlanIsEqualFact);
  IF Dir = +1 THEN
   _Done:=1;
  ELSE
   _Done:=0;
  END;
  IF L_TRS.TckRcSLevel() # L_TRS.il_None THEN
   IF (Dir = +1) & L_Way.E_Fill_asRWayS(TckRcS.Date) & ~!TckRcS.asRWayS[0] THEN
    IF SEARCH(RWayS, RWayS, TckRcS.asRWayS[0]) THEN
     TckRcS.asBoxNbr:=RWayS.BoxNbr;
    ELSE
     SETEMPTY(TckRcS.asRWayS, TckRcS.asBoxNbr);
    END;
    REPLACE(TckRcS);
   END;
   IF SELECT(TckRcJ, TckRcS, TckRcS.TckRcS) THEN
    SETEMPTY(prvRWayS);
    DoIt:=0;
    WHILE OCCURE(TckRcJ) DO
     IF Dir = +1 THEN
      IF ~E_IsByUser_asRWayS(TckRcS.Date) THEN
       IF !_RWayS THEN
        Set_TckRcJ_asRWayS("");
        L_General.Assert(~!TckRcJ.asRWayS | L_Way.E_IsImaginaryRoute(TckRcS.Date, TckRcJ.Route),
                         "  ⥢   ப  " + TckRcJ.TckRcS +
                         "|६ " + L_DatTim.TimeStr(TckRcJ.StartT));
       ELSIF TckRcJ.asRWayS # _RWayS THEN
        _Done:=0;
       END;
      ELSE
       L_General.Assert(~!TckRcJ.asRWayS | L_Way.E_IsImaginaryRoute(TckRcS.Date, TckRcJ.Route),
                        " 㪠 ⥢   ப  " + TckRcJ.TckRcS +
                        "|६ " + L_DatTim.TimeStr(TckRcJ.StartT));

      END;
     END;
(*
     IF TckRcJ.asRWayS # prvRWayS THEN
*)
      DoIt:=(((Dir = +1) &  !TckRcJ.asDay & ~!TckRcJ.asRWayS) |
             ((Dir = -1) & ~!TckRcJ.asDay));
      IF DoIt THEN
       L_General.CallUs(SEARCH(RWayS, RWayS, TckRcJ.asRWayS));
       IF !_RWayS | (TckRcJ.asRWayS = _RWayS) THEN
        _2SheetAssert((Dir = -1) | (RWayS.Status = L_Way.rwsStat_Rated), " ⠪஢ ⥢ ");
       ELSIF (RWayS.Status # L_Way.rwsStat_Rated) | (Dir = -1) THEN
        _Done:=0;
        DoIt:=0;
       END;
      END;
      IF DoIt THEN
       CheckDatesEqual();
       _2SheetAssert((TckRcS.AsWho # L_Way.trs_Driver) | (RWayS.TSN = TckRcS.TSN),
                     " ⥢  " + RWayS.RWayS + " ⥫ -  " + TckRcS.TSN);
       RWaySMakeUnDone();
      END;
      prvRWayS:=TckRcJ.asRWayS;
(*
     END;
*)
     IF DoIt THEN
      PROMPT(" " + TckRcJ.Day + " " + L_DatTim.TimeStr(TckRcJ.StartT));
      SELECT(RWayJ, RWayS, , RWayS.RWayS);
      SrcInSelForSeekBetterTrip();
      IF (Dir = +1) & !TckRcJ.asDay THEN
       prvDelta:=999999999999999;
       curDelta:=prvDelta;
       SETEMPTY(_Day);
       LOOP
        IF ~OCCURE(RWayJ) THEN
         prvDelta:=curDelta;
         EXIT;
        END;
        IF L_TRS.IsGoodRWayJForIncome() THEN
         curDelta:=GetDelta();
         IF curDelta > prvDelta THEN
          EXIT;
         END;
         _Day    :=RWayJ.Day;
         _StartT :=RWayJ.StartT;
         prvDelta:=curDelta;
        END; (* IF WJMode ... *)
        NEXT(RWayJ);
       END; (* LOOP *)
       _2JobAssert(prvDelta <= E_MaxDelta(), " 㤠 । ");
       SAVE(RWayJ);
       L_General.CallUs(SEARCH(RWayJ, RWayS, RWayS.RWayS, _Day, _StartT));
       CONFORM(RWayJ, SEJobs);
       _2JobAssert(TckRcJ.Route = SEJobs.Route,
                   " ࠧ :   - " + SEJobs.Route + ",   - " + TckRcJ.Route);
       TckRcJ.asDay   :=RWayJ.Day;
       TckRcJ.asStartT:=RWayJ.StartT;
       IF L_Way.E_Fill_asRWayS(TckRcS.Date) THEN
        TckRcJ.asBoxNbr:=RWayS.BoxNbr;
       END;
       REPLACE(TckRcJ);
       IF !_RWayS & L_Way.E_RWayJPlanIsEqualFact() THEN
        PutRWaySToArr(RWaySWithPlanIsEqualFact, RWayJ.RWayS);
       END;
       TckRcJR_Proceed(+1);
       PutRWayJP(+1, GetGuardNumber());
       RESTORE(RWayJ);
       (*    TckRcJ   RWayJ *)
       IF ~OCCURE(RWayJ) THEN
        LAST(RWayJ);
       ELSIF ~PREV(RWayJ) THEN
        FIRST(RWayJ);
       END;
      ELSIF (Dir = -1) & ~!TckRcJ.asDay THEN
       _2SheetAssert(SEARCH(RWayJ, RWayS, TckRcJ.asRWayS, TckRcJ.asDay, TckRcJ.asStartT),
                     "  ३ ⥢ ");
       PutRWayJP(-1, GetGuardNumber());
       TckRcJR_Proceed(-1);
       UnBind_FromRWayS();
      END; (* IF Dir ... *)
     ELSIF (Dir = -1) & !TckRcJ.asDay & ~!TckRcJ.asRWayS THEN
      UnBind_FromRWayS();
     END; (* IF DoIt *)
     NEXT(TckRcJ);
    END; (* WHILE OCCURE(TckRcJ) ... *)
   END; (* IF SELECT(TckRcJ ... *)
   IF (Dir = -1) & !_RWayS THEN
    TckRcJR_CleanTckRcT();
   END; (* IF (Dir = -1) *)
   IF (Dir = -1) & (TckRcS.AsWho # L_Way.trs_Driver) THEN
    SELECT(WayLMen, TSN, , TckRcS.TSN, TckRcS.Date);
    WHILE OCCURE(WayLMen) DO
     CONFORM(WayLMen, RWayS);
     SAVE(WayLMen);
     RWaySMakeUnDone();
     RESTORE(WayLMen);
     NEXT(WayLMen);
    END; (* WHILE OCCURE(WayLMen) ... *)
   END;
   IF TckRcS.Done # _Done THEN
    L_General.Assert(TckRcS.Status = L_TRS.trsStat_Rated, "㬥  ⠪஢");
    TckRcS.Done:=_Done;
   END;
   REPLACE(TckRcS);
   MakeDoneRWaySWithPlanIsEqualFact(RWaySWithPlanIsEqualFact);
  ELSIF TckRcS.Done # _Done THEN
   TckRcS.Done:=_Done;
   REPLACE(TckRcS);
  END;
 END {Proceed};

 PRIVATE PROCEDURE TckRcS_OnProceed(Dir: NUMERIC[0]);
 BEGIN
  Proceed(Dir, "");
 END {TckRcS_OnProceed};

 PUBLIC PROCEDURE ProceedByOneRWayS(Dir: NUMERIC[0]);
 BEGIN
  ACCESS(RWayS);
  SAVE(RWayS);
  Proceed(Dir, RWayS.RWayS);
  RESTORE(RWayS);
 END {ProceedByOneRWayS};

 PUBLIC PROCEDURE TckRcS_OnSetupRWayS();
  VAR
   _RWayS: LIKE(RWayS.RWayS);
 BEGIN
  ACCESS(RWayS);
  SAVE(RWayS);
  _RWayS:=RWayS.RWayS;
  SELECT(TckRcJ, asBoxNbr, , RWayS.BoxNbr, RWayS.Date);
  WHILE OCCURE(TckRcJ) DO
   PROMPT("뢠   : " + TckRcJ.TckRcS + " " + L_DatTim.TimeStr(TckRcJ.StartT));
   Set_TckRcJ_asRWayS(_RWayS);
   NEXT(TckRcJ);
  END; (* WHILE OCCURE(TckRcJ) ... *)
  RESTORE(RWayS);
 END {TckRcS_OnSetupRWayS};

(*
$P { Top:
P_Firm.FP_FirmName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
L_bp.getCurId(), L, ""
Memo.ud_mb(), L, "N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                              ࠡ⠭ ⭮-   #######                               |
|------------------------------------------------------------------------------------------------------------|
|  |      |  |      ||ᠭ ஡                                                      |
|-------|----------|-----|---------|-|-----------------------------------------------------------------------|
}

(*
$P { Line:
TckRcS.TckRcS, L, ""
TckRcS.Date, L, "D.N.y"
TckRcS.TSN, L, ""
L_Str.PoolItem(L_Way.trs_Pool, TckRcS.AsWho), L, ""
TckRcS.Status, L, ""
?, L, ""
@
|#######|##########|#####|#########|#|#######################################################################|
}
*)

$P { Bot:
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
=(c) Polak====================================================================================########## #####
}
*)

 PUBLIC PROCEDURE ProceedAll();
  CONST
   bpId = "BadTS";
 BEGIN
  L_bp.Begin(bpId, "ࠡ⪠ ", L_bp.t_Prc_wF3, L_General.tc_inMonth);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  OPENREP(R, L_General.NameConnection(bpId), Create);
  MAKEPART(R, Top);
  SETSEL(TckRcS, Date);
  SRCINSEL(TckRcS, GE, , Memo.ud_mb());
  WHILE OCCURE(TckRcS) & (TckRcS.Date <= Memo.ud_me()) DO
   IF ~TckRcS.Done THEN
    TRY [TRANSACTION(TRANSACTION_SLAVE)]
     CALL(TckRcS.SingleMakeDone());
    EXCEPT
    ON Exc: Exc_Root DO
     L_XDoc.sl_AddItem(L_XDoc.curXDocId(L_XDoc.xdt_TckRcS),
                       L_XDoc.XDocStr(L_XDoc.curXDocId(L_XDoc.xdt_TckRcS)) +
                       " " + L_DatTim.DateStr(TckRcS.Date));
     CONFORM(TckRcS, Man);
     MAKEPART(R, Line, Exc.Description);
    END; (* TRY *)
   ELSE
    PROMPT(TckRcS.TckRcS+" ("+L_DatTim.DateStr(TckRcS.Date)+")");
   END;
   NEXT(TckRcS);
  END; (* WHILE OCCURE(TckRcS) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_bp.End();
 END {ProceedAll};

 PRIVATE PROCEDURE ClearVldOutsideSales();
 BEGIN
  SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcT) DO
   CONFORM(TckRcT, TckKind);
   IF L_TRS.E_NeedAutoTaxTckRcJR(TckRcS.Date) THEN
    SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
    WHILE OCCURE(TckRcJ) DO
     DEC(TckRcJ.Sum, TckRcJ.TckNbrs[TckRcT.Number - 1] * TckKind.FaceVal);
     IF ~!TckRcJ.TckPsg[TckRcT.Number - 1] THEN
      DEC(TckRcJ.Psg, TckRcJ.TckPsg[TckRcT.Number - 1]);
     END;
     SETEMPTY(TckRcJ.TckNbrs[TckRcT.Number - 1], TckRcJ.TckPsg[TckRcT.Number - 1]);
     REPLACE(TckRcJ);
     NEXT(TckRcJ);
    END; (* WHILE OCCURE(TckRcJ) ... *)
    REMOVE(TckRcT);
   ELSE
    NEXT(TckRcT);
   END;
  END; (* WHILE OCCURE(TckRcT) ... *)
 END {ClearVldOutsideSales};

 PUBLIC PROCEDURE ClearAll();
 BEGIN
  L_StdFrm.Choice("   " + L_DatTim.PeriodStr(Memo.ud_mb()));
  L_Way.ClearRWayS(L_Way.rwjpSrc_TckRcS, 0);
  SETSEL(TckRcS, Date);
  SRCINSEL(TckRcS, GE, , Memo.ud_mb());
  WHILE OCCURE(TckRcS) & (TckRcS.Date <= Memo.ud_me()) DO
   PROMPT("  " + L_DatTim.DateStr(TckRcS.Date) + " " + TckRcS.TckRcS);
   SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
   WHILE OCCURE(TckRcJ) DO
    UnBind_FromRWayS();
    REPLACE(TckRcJ);
    NEXT(TckRcJ);
   END; (* WHILE OCCURE(TckRcJ) ... *)
   ClearVldOutsideSales();
   TckRcS.Done:=0;
   REPLACE(TckRcS);
   NEXT(TckRcS);
  END; (* WHILE OCCURE(TckRcS) ... *)
  L_Way.ClearRWayS(L_Way.rwjpSrc_TckRcS, 1);
 END {ClearAll};

 PUBLIC PROCEDURE SetTckRcJAsLast();
  VAR
   Nbr,
   prvNbr: L_TRS.tTckNumber;
   Psg,
   prvPsg: L_TRS.tTckPsg;
   dummy : NUMERIC[2];
 BEGIN
  L_General.Assert(L_TRS.TckRcSLevel() > L_TRS.il_woBeg,
                   " ⮫쪮  , 襤  ⥬ '⭠ '");
  CONFORM(TckRcS, TckRcT);
  WHILE OCCURE(TckRcT) DO
   CONFORM(TckRcT, TckKind);
   IF ~!TckRcT.Number THEN
    IF IsAutoBuildTckRcT() & ~L_TRS.IsSpecialNoSaleTckKind() THEN
     prvNbr:=TckRcJ.TckNbrs[TckRcT.Number-1];
     prvPsg:=TckRcJ.TckPsg [TckRcT.Number-1];
     IF L_TRS.IsBulk_wCUC() THEN
      SELECT(TckRcD, TckRcS, , TckRcJ.TckRcS);
      WHILE OCCURE(TckRcD) DO
       IF (TckRcD.Type # L_TRS.trdt_Laying) & (TckRcD.Status # L_TRS.trdStat_Canceled) THEN
        SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
        WHILE OCCURE(TckRcDL) DO
         IF TckRcDL.CUCopy = TckRcT.asCUCopy THEN
          CONFORM(TckRcDL, TckRcDLL);
          WHILE OCCURE(TckRcDLL) DO
           IF !TckRcDLL.Day & ~!TckRcDLL.Sum THEN
            TckRcDLL.Day :=TckRcJ.Day;
            TckRcDLL.Time:=TckRcJ.StartT;
            REPLACE(TckRcDLL);
            INC(TckRcJ.TckNbrs[TckRcT.Number-1], TckRcDLL.Sum);
            IF L_TRS.IsMainTckKind(TckRcT.TckKind, TckRcS.Date, TckRcJ.Route) THEN
             INC(TckRcJ.TckPsg[TckRcT.Number-1], 1);
            END;
           END;
           NEXT(TckRcDLL);
          END; (* WHILE OCCURE(TckRcDLL) ... *)
         END;
         NEXT(TckRcDL);
        END; (* WHILE OCCURE(TckRcDL) ... *)
       END;
       NEXT(TckRcD);
      END; (* WHILE OCCURE(TckRcD) ... *)
      REPLACE(TckRcJ);
     ELSE
      IF L_TRS.E_TckRcJTckNbrIsAmountOnTrip() THEN
       SAVE(TckRcJ);
       L_TRS.Calc2NumbersDifference(TckKind.TckKind, TckRcT.BefNbr, TckRcT.AftNbr, Nbr, dummy);
       IF L_TRS.TckKind_wPsg() THEN
        Psg:=TckRcT.ExpNum;
       END;
       CHANGESEL(TckRcJ, TckRcS, , TckRcJ.TckRcS);
       WHILE PREV(TckRcJ) DO
        TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
         DEC(Nbr, TckRcJ.TckNbrs[TckRcT.Number-1]);
         IF L_TRS.TckKind_wPsg() THEN
          DEC(Psg, TckRcJ.TckPsg [TckRcT.Number-1]);
         END;
        EXCEPT
        ON Exc: Exc_RunTime DO
         IF Exc.ErrorCode = L_General.ec_rt_Overfilling THEN
          L_General.Error("୮  த  । ३   " + TckRcT.Number);
         ELSE
          RAISE();
         END;
        END; (* TRY *)
       END;
       RESTORE(TckRcJ);
       TckRcJ.TckNbrs[TckRcT.Number-1]:=Nbr;
       IF L_TRS.TckKind_wPsg() THEN
        TckRcJ.TckPsg [TckRcT.Number-1]:=Psg;
       END;
      ELSE
       IF TckKind.Type = L_TRS.tkt_KKMActivities THEN
        TckRcJ.TckNbrs[TckRcT.Number-1]:=TckRcT.ExpSum / TckKind.FaceVal;
        TckRcJ.TckPsg [TckRcT.Number-1]:=TckRcT.ExpNum;
       ELSE
        TckRcJ.TckNbrs[TckRcT.Number-1]:=TckRcT.AftNbr;
        IF L_TRS.TckKind_wPsg() THEN
         TckRcJ.TckPsg [TckRcT.Number-1]:=TckRcT.ExpNum;
        END;
       END;
      END;
      REPLACE(TckRcJ);
     END;
     SAVE(TckRcT);
     _TckRcJ_TckNbrs_OnSuccessfulChange(prvNbr, prvPsg,
                                       TckRcJ.TckRAmnt[TckRcT.Number-1], TckRcJ.TckRPsg[TckRcT.Number-1],
                                       TckRcT.Number-1);
     RESTORE(TckRcT);
    END;
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
 END {SetTckRcJAsLast};

 PRIVATE PROCEDURE TRS0_1_OnZoneOpen();
 BEGIN
  CALL(BegTRS.TRS0_SetEmptyPermanentVar());
 END {TRS0_1_OnZoneOpen};

 PRIVATE PROCEDURE TRS0_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="TckRcS";
  L_WDO.iEvents      (1, [L_WDO.e_OnOpenZone]);
  L_WDO.iZone        (1).Narrowing:="TckRcS.Status="+L_Str.IntStr(L_TRS.trsStat_Ordered);
  L_WDO.iField       (1, "TckRcS.AsWho").Format:=L_Way.trs_Pool;
  L_WDO.iSubwindow   (1, "TRS0E");
 END {TRS0_OnInitializeWindow};

 PRIVATE PROCEDURE TRS1_1_OnSetSubwindow();
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_ShowWin THEN
   RTI.Get().CurZone.SubwindowOriginalName:="TckRcSE";
  ELSE
   RTI.Get().CurZone.SubwindowOriginalName:="";
  END;
 END {TRS1_1_OnSetSubwindow};

 PRIVATE PROCEDURE TRS1_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="TckRcS";
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).Narrowing:="TckRcS.Status="+L_Str.IntStr(L_TRS.trsStat_Given);
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iField       (1, "TckRcS.AsWho").Format:=L_Way.trs_Pool;
 END {TRS1_OnInitializeWindow};

 PRIVATE PROCEDURE TRS2_1_OnSetSubwindow();
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_ShowWin THEN
   RTI.Get().CurZone.SubwindowOriginalName:="TckRcSE";
  ELSE
   RTI.Get().CurZone.SubwindowOriginalName:="";
  END;
 END {TRS2_1_OnSetSubwindow};

 PRIVATE PROCEDURE TRS2_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="TckRcS";
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).Narrowing:="TckRcS.Status="+L_Str.IntStr(L_TRS.trsStat_Taken);
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iField       (1, "TckRcS.AsWho").Format:=L_Way.trs_Pool;
 END {TRS2_OnInitializeWindow};

 PUBLIC PROCEDURE SetRated();
 BEGIN
  IF TckRcS.Status # L_TRS.trsStat_Rated THEN
   L_General.Assert(~SELECT(TckRcJ, TckRcS, TckRcS.TckRcS), "祬?");
   TckRcS.Status:=L_TRS.trsStat_Rated;
   REPLACE(TckRcS);
  ELSE
   L_StdFrm.Question("⬥ ⠪஢ ");
   FIX_ALTERING();
  END;
 END {SetRated};

 PRIVATE PROCEDURE scuc_Put(    Comment : STRING[];
                            VAR CUCStr  : STRING[][];
                            VAR CUCopies: LIKE(CUCopy.CUCopy)[];
                            VAR CUCState: L_TRS.tTckState[];
                            VAR IsBulk  : SCAL[2][];
                                isBulk  : SCAL[2]);
  VAR
   State: L_TRS.tTckState;
   i    : NUMERIC[0];
 BEGIN
  IF ~!CUCopy.Storage THEN
   State:=L_TRS.ts_New;
  ELSE
   State:=L_TRS.DefineTckState();
  END;
  i:=0;
  LOOP
   IF !CUCopies[i] THEN
    CUCopies[i]:=CUCopy.CUCopy;
    CUCStr  [i]:=Str.Align(Comment, 39, LEFT) + " (" + CUCopy.CUCopy + ")";
    CUCState[i]:=State;
    IsBulk  [i]:=isBulk;
    INC(i);
    EXIT;
   ELSIF CUCopies[i] = CUCopy.CUCopy THEN
    CUCState[i]:=State;
    EXIT;
   END;
   INC(i);
  END; (* LOOP *)
 END {scuc_Put};

 PRIVATE PROCEDURE scuc_PutTckRcD(VAR CUCStr  : STRING[][];
                                  VAR CUCopies: LIKE(CUCopy.CUCopy)[];
                                  VAR CUCState: L_TRS.tTckState[];
                                  VAR IsBulk  : SCAL[2][];
                                      _CUCopy : LIKE(CUCopy.CUCopy));
 BEGIN
  CONFORM(TckRcD, TckRcDL);
  WHILE OCCURE(TckRcDL) DO
   IF !_CUCopy THEN
    CONFORM(TckRcDL, CUCopy);
    CONFORM(TckRcDL, TckKind);
    CONFORM(TckKind, Math);
    IF    TckKind.Type = L_TRS.tkt_KKMActivities THEN
     scuc_Put(": " + CUCopy.Serial + " " + Math.Name,    CUCStr, CUCopies, CUCState, IsBulk, 0);
    ELSIF TckKind.Type = L_TRS.tkt_VLDActivities THEN
     scuc_Put(": " + CUCopy.Serial + " " + Math.Name,    CUCStr, CUCopies, CUCState, IsBulk, 0);
    ELSIF TckKind.Type = L_TRS.tkt_BankCardTerminal THEN
     scuc_Put(": " + CUCopy.Serial + " " + Math.Name,    CUCStr, CUCopies, CUCState, IsBulk, 0);
    ELSE
     scuc_Put(" : " + CUCopy.Serial + " " + TckKind.Name, CUCStr, CUCopies, CUCState, IsBulk, L_TRS.IsBulk_wCUC());
    END;
   ELSIF TckRcDL.CUCopy = _CUCopy THEN
    CONFORM(TckRcDL, TckKind);
    CONFORM(TckRcDL, TckRcDLL);
    WHILE OCCURE(TckRcDLL) DO
     CONFORM(TckRcDLL, CUCopy);
     scuc_Put(" : " + CUCopy.Serial + " " + TckKind.Name, CUCStr, CUCopies, CUCState, IsBulk, 0);
     NEXT(TckRcDLL);
    END; (* WHILE OCCURE(TckRcDLL) ... *)
   END;
   NEXT(TckRcDL);
  END; (* WHILE OCCURE(TckRcDL) ... *)
 END {scuc_PutTckRcD};

 PRIVATE PROCEDURE scuc_BuildList(CUCStr  : STRING[][];
                                  CUCopies: LIKE(CUCopy.CUCopy)[];
                                  CUCState: L_TRS.tTckState[];
                                  IsBulk  : SCAL[2][]): STRING[];
  VAR
   i   : NUMERIC[0];
   List: STRING[];
 BEGIN
  List:="";
  i:=0;
  WHILE ~!CUCopies[i] DO
   List:=List + CUCStr[i] + " " +
         Str.Align(L_Str.PoolItem(" || - | ", CUCState[i]), 3, LEFT) + " " +
         Str.Align(P_CUC.GetCUCProSoft(CUCopies[i], TckRcS.Date, P_CUC.P_Location), 24, LEFT) + " " +
         L_Str.PoolItem("  |>>", IsBulk[i]) + "|";
   INC(i);
  END;
  RETURN(List);
 END {scuc_BuildList};

 PRIVATE PROCEDURE intShowCUCopies(_CUCopy: LIKE(CUCopy.CUCopy));
  CONST
   CUCMaxAmount = 100;
  VAR
   List    : STRING[];
   CUCopies: LIKE(CUCopy.CUCopy)[CUCMaxAmount];
   CUCStr  : STRING[][CUCMaxAmount];
   CUCState: L_TRS.tTckState[CUCMaxAmount];
   IsBulk  : SCAL[2][CUCMaxAmount];
   i       : NUMERIC[0];
   HasInv  : SCAL[2];
 BEGIN
  ACCESS(TckRcS);
  L_General.Assert(~!TckRcS.Storage, " ଫ  ⥬ '⭠ '");
  SETZERO(HasInv);
  SETEMPTY(List, CUCopies, CUCStr, CUCState, IsBulk);
  CONFORM(TckRcS, Storage);
  L_General.CallUs(SELECT(CUCopy, Storage, Storage.Storage));
  IF !_CUCopy THEN
   scuc_Put(": " + Storage.Storage + " " + Storage.Name, CUCStr, CUCopies, CUCState, IsBulk, 0);
  END;
  SELECT(TckRcD, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcD) DO
   HasInv:=HasInv | (TckRcD.Type = L_TRS.trdt_Inventory) & (TckRcD.Status # L_TRS.trdStat_Canceled);
   scuc_PutTckRcD(CUCStr, CUCopies, CUCState, IsBulk, _CUCopy);
   NEXT(TckRcD);
  END; (* WHILE OCCURE(TckRcD) ... *)

  IF ~HasInv THEN
   IF FIRST(TckRcD) THEN
    CHANGESEL(TckRcD, Storage, , TckRcD.Storage);
    PREV(TckRcD);
   ELSE
    SETSEL(TckRcD, Storage, TckRcS.Storage);
    SRCINSEL(TckRcD, LE, , TckRcS.Date);
   END;
   LOOP
    IF ~OCCURE(TckRcD) THEN
     EXIT;
    ELSIF (TckRcD.Type = L_TRS.trdt_Inventory) & (TckRcD.Status # L_TRS.trdStat_Canceled) THEN
     scuc_PutTckRcD(CUCStr, CUCopies, CUCState, IsBulk, _CUCopy);
     EXIT;
    END;
    PREV(TckRcD);
   END; (* LOOP *)
  END;
  i:=L_StdFrm.ShowListAsMenu(scuc_BuildList(CUCStr, CUCopies, CUCState, IsBulk), "  ");
  IF IsBulk[i] THEN
   intShowCUCopies(CUCopies[i]);
  ELSE
   L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly,
                                L_XDoc.XDocId(L_XDoc.xdt_CUCopy, L_XDoc.EmptyXDocKind, CUCopies[i]), "");
  END;
 END {intShowCUCopies};

 PUBLIC PROCEDURE ShowCUCopies();
 BEGIN
  intShowCUCopies("");
 END {ShowCUCopies};

 PRIVATE PROCEDURE IsSpecialTckKindForElTck(_TckKind: LIKE(TckKind.TckKind)): SCAL[2];
 BEGIN
  RETURN (_TckKind >= 0700) & (_TckKind <= 0814);
 END {IsSpecialTckKindForElTck};

 PRIVATE PROCEDURE MayModifySpecialTckKindForElTck(): SCAL[2];
 BEGIN
  RETURN ~IsSpecialTckKindForElTck(TckKind.TckKind) | ~APP.Get().ProductiveCopy;
 END {MayModifySpecialTckKindForElTck};

 PRIVATE PROCEDURE SetTckKindFieldsModifiable();
 BEGIN
  L_WDO.FieldMustBeNonEmpty("TckKind.Math", L_Way.E_TckRcLevel(SYSDATE()) > L_TRS.il_woBeg);
  IF ACCESS(TckKind) THEN
   L_WDO.SetFieldModifiable("TckKind.TckKind", MayModifySpecialTckKindForElTck());
   L_WDO.SetFieldModifiable("TckKind.Name",    MayModifySpecialTckKindForElTck());
   L_WDO.SetFieldModifiable("TckKind.Begin",   MayModifySpecialTckKindForElTck());
   L_WDO.SetFieldModifiable("TckKind.Till",    MayModifySpecialTckKindForElTck());
   L_WDO.SetFieldModifiable("TckKind.Type",    MayModifySpecialTckKindForElTck());
   L_WDO.SetFieldModifiable("TckKind.NbrPrc",  MayModifySpecialTckKindForElTck());
   L_WDO.SetFieldModifiable("TckKind.InSale",  MayModifySpecialTckKindForElTck());
   IF ~MayModifySpecialTckKindForElTck() THEN
    L_WDO.SetFieldModifiable("TckKind.FstInPck", 0);
    L_WDO.SetFieldModifiable("TckKind.PckVol",   0);
    L_WDO.SetFieldModifiable("TckKind.wPsg",     0);
    L_WDO.SetFieldModifiable("TckKind.FaceVal",  0);
    L_WDO.SetFieldModifiable("TckKind.SrsPat",   0);
    L_WDO.SetFieldModifiable("TckKind.InCash",   0);
    L_WDO.SetFieldModifiable("TckKind.NbrsDir",  0);
    L_WDO.SetFieldModifiable("TckKind.Math",     0);
   ELSIF ~!TckKind.Type THEN
    IF ((TckKind.Type = L_TRS.tkt_OutsideSales) | L_TRS.IsEasySalesTck()) THEN
     L_WDO.FieldMustBeNonEmpty("TckKind.Math", 0);
    END;
    L_WDO.SetFieldModifiable("TckKind.FstInPck", TckKind.Type = L_TRS.tkt_Ticket);
    L_WDO.SetFieldModifiable("TckKind.PckVol",   TckKind.Type = L_TRS.tkt_Ticket);
    L_WDO.SetFieldModifiable("TckKind.wPsg",     (TckKind.Type # L_TRS.tkt_Ticket) &
                                                 ~L_TRS.IsBulk_wCUC() &
                                                 ((TckKind.InSale = L_TRS.tks_Sales) |
                                                  (TckKind.InSale = L_TRS.tks_CashlessSales)));
    L_WDO.SetFieldModifiable("TckKind.FaceVal",  (TckKind.Type # L_TRS.tkt_VLDActivities));
    L_WDO.SetFieldModifiable("TckKind.SrsPat",   (TckKind.Type = L_TRS.tkt_Ticket) | L_TRS.IsBulk_wCUC());
    L_WDO.SetFieldModifiable("TckKind.InCash",   TckKind.Type # L_TRS.tkt_OutsideSales);
    L_WDO.SetFieldModifiable("TckKind.NbrsDir",  (TckKind.Type # L_TRS.tkt_KKMActivities) &
                                                 (TckKind.Type # L_TRS.tkt_VLDActivities) &
                                                 (TckKind.Type # L_TRS.tkt_OutsideSales));
    L_WDO.SetFieldModifiable("TckKind.Math",     1);
   END;
  END;
 END {SetTckKindFieldsModifiable};

 PRIVATE PROCEDURE TckKindE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="TckRcS";
  L_WDO.iEvents    (0, [L_WDO.e_OnAfterMdf, L_WDO.e_OnReposition]);
  L_WDO.iScsChange (0, ["TckKind.InSale", "TckKind.Type", "TckKind.TckKind"]);
  L_WDO.iMayBeEmpty(0, ["TckKind.SrsPat", "TckKind.Math", "TckKind.Till"]);
  L_WDO.iField     (0, "TckKind.NbrsDir").Format:="|稢|蠥";
  L_WDO.iField     (0, "TckKind.Type").Format:=L_TRS.tkt_Pool;
  L_WDO.iField     (0, "TckKind.InSale").Format:=L_TRS.tks_Pool;
  L_WDO.iProgs     (0, "TckRcS");
 END {TckKindE_OnInitializeWindow};

 PRIVATE PROCEDURE TckKindE_0_OnReposition();
 BEGIN
  SetTckKindFieldsModifiable();
 END {TckKindE_0_OnReposition};

 PRIVATE PROCEDURE TckKind_TckKind_OnSuccessfulChange();
 BEGIN
  L_General.Assert(MayModifySpecialTckKindForElTck(), "  १ࢨ஢ ࠧࠡ稪");
 END {TckKind_TckKind_OnSuccessfulChange};

 PRIVATE PROCEDURE TckKind_OnBeforeDelete();
 BEGIN
  L_General.Assert(MayModifySpecialTckKindForElTck(), "  १ࢨ஢ ࠧࠡ稪");
 END {TckKind_OnBeforeDelete};

 PRIVATE PROCEDURE TckKind_Type_OnSuccessfulChange();
 BEGIN
  SetTckKindFieldsModifiable();
 END {TckKind_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE TckKind_InSale_OnSuccessfulChange();
 BEGIN
  SetTckKindFieldsModifiable();
 END {TckKind_InSale_OnSuccessfulChange};

 PRIVATE PROCEDURE TckKind_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="TckRcS";
  L_WDO.iSubwindow   (1, "TckKindE");
  L_WDO.iProgs       (1, "TckRcS");
 END {TckKind_OnInitializeWindow};

 PRIVATE PROCEDURE TckKind_OnAfterEdIns();
 BEGIN
  IF TckKind.Type = L_TRS.tkt_OutsideSales THEN
   TckKind.InCash  :=L_TRS.tkc_No;
   TckKind.NbrsDir :=L_TRS.nd_None;
  END;
  IF TckKind.Type # L_TRS.tkt_Ticket THEN
   TckKind.FstInPck:=1;
   TckKind.PckVol  :=1;
  END;
  IF (TckKind.InSale # L_TRS. tks_Sales) & (TckKind.InSale # L_TRS.tks_CashlessSales) THEN
   TckKind.wPsg    :=0;
  END;
  IF (TckKind.Type = L_TRS.tkt_Ticket) | L_TRS.IsBulk_wCUC() THEN
   TckKind.wPsg    :=0;
  ELSE
   TckKind.SrsPat  :="";
  END;
  IF TckKind.Type = L_TRS.tkt_VLDActivities THEN
   TckKind.FaceVal :=0;
   TckKind.NbrsDir :=L_TRS.nd_None;
  END;
  IF TckKind.Type = L_TRS.tkt_KKMActivities THEN
   TckKind.NbrsDir :=L_TRS.nd_Incr;
  END;
  REPLACE(TckKind);
 END {TckKind_OnAfterEdIns};

 PRIVATE PROCEDURE TckKind_OnAfterEdit();
 BEGIN
  TckKind_OnAfterEdIns();
 END {TckKind_OnAfterEdit};

 PRIVATE PROCEDURE TckKind_OnAfterInsert();
 BEGIN
  TckKind_OnAfterEdIns();
 END {TckKind_OnAfterInsert};

 PRIVATE PROCEDURE TckRcJTB_OnConformToWindow();
 BEGIN
  ACCESS(TckRcJ);
  SE_WWD_CURSOR("TckRcJTB", TckRcJ);
 END {TckRcJTB_OnConformToWindow};

 PRIVATE PROCEDURE TckRcJTB_0_OnZoneOpen();
  VAR
   i      : NUMERIC[0];
   m      : SCAL[2];
   PrvNbrs: LIKE(TckRcJ.TckNbrs);
   f      : FORM_FIELD;
   fields : FORM_FIELDS;
 BEGIN
  PrvNbrs:=L_TRS.GetPrvNbrs();
  L_General.Assert(SELECT(TckRcT, Number, TckRcS.TckRcS), "室    ");
  fields:=RTI.Get().CurZone.Fields;
  i:=0;
  WHILE OCCURE(TckRcT) DO
   IF ~!TckRcT.Number THEN
    CONFORM(TckRcT, TckKind);
    f:=fields(L_WDO.Fld_wIdx("BegStr", i));
    f.Value:=TckRcT.TckRcT + " " + TckKind.Name;
    f.Visible:=1;

    m:=~L_TRS.IsSpecialNoSaleTckKind() & (TckRcT.RSum > 0) & (TckRcJ.TckNbrs[i] # PrvNbrs[i]);
    f:=fields(L_Str.Var_wIdx("TckRcJ.TckRAmnt", i));
    f.Visible:=1;
    f.Modifiable:=m;

    f:=fields(L_Str.Var_wIdx("TckRcJ.TckRPsg", i));
    f.Visible:=1;
    f.Modifiable:=m & (L_TRS.TckKind_wPsg() |
                       (TckKind.Type = L_TRS.tkt_ZonalTicket) &
                        L_TRS.IsMainTckKind(TckKind.TckKind, TckRcS.Date, TckRcJ.Route));
    INC(i);
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
  WHILE i <= HIGH(TckRcJ.TckNbrs) DO
   fields(L_WDO.Fld_wIdx("BegStr", i)).Visible         :=0;
   fields(L_Str.Var_wIdx("TckRcJ.TckRAmnt", i)).Visible:=0;
   fields(L_Str.Var_wIdx("TckRcJ.TckRPsg", i)).Visible :=0;
   INC(i);
  END;
 END {TckRcJTB_0_OnZoneOpen};

 PRIVATE PROCEDURE CheckAllowedTicketsBack();
  VAR
   Msg             : STRING[];
   PrvNbrs         : LIKE(TckRcJ.TckNbrs);
   i,
   TicketBackAmount: NUMERIC[0];
 BEGIN
  PrvNbrs:=L_TRS.GetPrvNbrs();
  SETEMPTY(Msg);
  SETZERO(TicketBackAmount);
  i:=0;
  WHILE i <= HIGH(TckRcJ.TckNbrs) DO
   IF ~!TckRcJ.TckNbrs[i] THEN
    SELECT(TckRcT, Number, , TckRcS.TckRcS, i + 1);
    IF (TckRcT.RNum # 0) | (TckRcT.RSum # 0) THEN
     IF TckRcJ.TckNbrs[i] = PrvNbrs[i] THEN
      IF TicketBackAmount = 0 THEN
       Msg:="ᠭ    ଫ ⮫쪮  ३,  ஬ 뫨 த ⮩ ";
      END;
     ELSE
      SETEMPTY(Msg);
     END;
     INC(TicketBackAmount);
    END;
   END;
   INC(i);
  END; (* i <= HIGH(TckRcJ.TckNbrs) ... *)
  IF ~!Msg THEN
   L_General.Error(Msg);
  END;
 END {CheckAllowedTicketsBack};

 PUBLIC PROCEDURE EditTckRcJTicketsBack();
  VAR
   _TotRSum,
   SalesRSum: LIKE(TckRcT.RSum);
   _TotRNum : LIKE(TckRcT.RNum);
 BEGIN
  ACCESS(TckRcJ);
  SETZERO(_TotRSum, _TotRNum, SalesRSum);
  CONFORM(TckRcJ, TckRcS);
  CONFORM(TckRcS, TckRcT);
  WHILE OCCURE(TckRcT) DO
   CONFORM(TckRcT, TckKind);
   INC(_TotRSum, TckRcT.RSum);
   IF ~L_TRS.IsCashWithoutSale() THEN
    INC(SalesRSum, TckRcT.RSum);
   END;
   INC(_TotRNum, TckRcT.RNum);
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
  L_General.Assert((_TotRSum # 0) | (_TotRNum # 0), "   ᯨᠭ ");
  L_General.Assert(SalesRSum # 0, "ᥭ ᯨᠭ   ३ᠬ  ॡ");
  L_General.Assert(~!TckRcJ.StartT, "砫 ᫥ 㪠 ६ ३");
  CheckAllowedTicketsBack();
  LIKEMENU(Edit, "TckRcJTB 0 TckRcJE 0");
 END {EditTckRcJTicketsBack};

 PUBLIC PROCEDURE ViewBulkSale();
  VAR
   curField: FORM_FIELD;
   Cnt,
   Index: NUMERIC[0];
 BEGIN
  Cnt:=0;
  ACCESS(TckRcJ);
  curField:=RTI.Get().CurZone.ActiveField;
  L_General.CallUs(~!curField.TableField & (curField.TableField.Name = "TckNbrs"));
  Index:=curField.ArrayIndex;
  SELECT(TckRcT, Number, , TckRcJ.TckRcS, Index+1);
  SELECT(TckRcD, TckRcS, , TckRcJ.TckRcS);
  WHILE OCCURE(TckRcD) DO
   IF (TckRcD.Type # L_TRS.trdt_Laying) & (TckRcD.Status # L_TRS.trdStat_Canceled) &
      SEARCH(TckRcDL, TckRcD, TckRcD.TckRcD, TckRcT.TckRcT) THEN
    CONFORM(TckRcDL, TckRcDLL);
    WHILE OCCURE(TckRcDLL) DO
     INC(Cnt, ~!TckRcDLL.Sum);
     NEXT(TckRcDLL);
    END; (* WHILE OCCURE(TckRcDLL) ... *)
    TckRcDForBulkSale :=TckRcDL.TckRcD;
    TRDLNbrForBulkSale:=TckRcDL.TRDLNbr;
    L_General.Assert(~!TckRcJ.Day & ~!TckRcJ.StartT, "砫 ᫥ 㪠 ६ ३");
    IndexForBulkSale  :=Index;
    DayForBulkSale    :=TckRcJ.Day;
    TimeForBulkSale   :=TckRcJ.StartT;
   END;
   NEXT(TckRcD);
  END; (* WHILE OCCURE(TckRcD) ... *)
  L_General.Assert(Cnt > 0, " ⮩   த ஢");
  APPLICATION.Get().Forms.Load("TckRcJBS");
  LIKEMENU(View, "TckRcJBS 2 TckRcJE 0");
 END {ViewBulkSale};

 PUBLIC PROCEDURE BulkSale_Toggle();
  VAR
   prvNbr: L_TRS.tTckNumber;
   prvPsg: L_TRS.tTckPsg;
 BEGIN
  ACCESS(TckRcDLL);
  CONFORM(TckRcDLL, TckRcDL);
  CONFORM(TckRcDL, TckRcD);
  SEARCH(TckRcJ, TckRcS, , TckRcD.TckRcS, DayForBulkSale, TimeForBulkSale);
  prvNbr:=TckRcJ.TckNbrs[IndexForBulkSale];
  prvPsg:=TckRcJ.TckPsg[IndexForBulkSale];
  IF !TckRcDLL.Day THEN
   TckRcDLL.Day :=DayForBulkSale;
   TckRcDLL.Time:=TimeForBulkSale;
   INC(TckRcJ.TckNbrs[IndexForBulkSale], TckRcDLL.Sum);
   IF L_TRS.IsMainTckKind(TckRcDL.TckKind, TckRcD.Date, TckRcJ.Route) THEN
    INC(TckRcJ.TckPsg[IndexForBulkSale], 1);
   END;
  ELSE
   SETEMPTY(TckRcDLL.Day, TckRcDLL.Time);
   DEC(TckRcJ.TckNbrs[IndexForBulkSale], TckRcDLL.Sum);
   IF L_TRS.IsMainTckKind(TckRcDL.TckKind, TckRcD.Date, TckRcJ.Route) THEN
    DEC(TckRcJ.TckPsg[IndexForBulkSale], 1);
   END;
  END;
  REPLACE(TckRcJ);
  REPLACE(TckRcDLL);
  _TckRcJ_TckNbrs_OnSuccessfulChange(prvNbr, prvPsg,
                                    TckRcJ.TckRAmnt[IndexForBulkSale], TckRcJ.TckRPsg[IndexForBulkSale],
                                    IndexForBulkSale);
 END {BulkSale_Toggle};

 PRIVATE PROCEDURE cnc_CorrectLine(VAR BefNbr   : LIKE(TckRcT.AftNbr);
                                       tBadNbr,
                                       tRightNbr: LIKE(TckRcT.AftNbr);
                                       dBadNbr,
                                       dRightNbr: LIKE(TckRcDL.RestNbr);
                                   VAR Prtcl    : STRING[];
                                       curTckRcS: LIKE(TckRcS.TckRcS));
  VAR
   _Amount : NUMERIC[0];
 BEGIN
  CONFORM(TckRcDL, TckRcS);
  L_General.Assert((TckRcS.Status <= L_TRS.trsStat_Taken) | (TckRcS.TckRcS = curTckRcS),
                   " " + TckRcS.TckRcS + " 㦥 ⠪஢");
  IF SEARCH(TckRcT, TckRcS, TckRcS.TckRcS, TckRcDL.TRDLNbr) THEN
   IF TckRcDL.RestNbr = dBadNbr THEN
    Prtcl:=Prtcl + "| " + TckRcDL.TckRcD + " " + TckRcDL.Series + " " +
                   FLDTOSTR(TckRcDL.RestNbr) + "         " +  " -> " + FLDTOSTR(dRightNbr) + "         ";
    TckRcDL.RestNbr:=dRightNbr;
    REPLACE(TckRcDL);
    _Amount:=0;
    IF TckRcS.TckRcS # curTckRcS THEN
     IF TckRcS.Status = L_TRS.trsStat_Taken THEN
      Prtcl:=Prtcl + "| " + TckRcS.TckRcS + " " + TckRcT.Series + " " +
                     TckRcT.BefNbr + "-" + TckRcT.AftNbr + " -> " + BefNbr + "-" + tRightNbr;
      TckRcT.BefNbr  :=BefNbr;
      TckRcT.AftNbr  :=tRightNbr;
      L_TRS.Calc2NumbersDifference(TckRcT.TckKind, TckRcT.BefNbr, TckRcT.AftNbr, _Amount, TckRcT.ExpSum);
      IF ~L_TRS.TckKind_wPsg() THEN
       TckRcT.ExpNum:=_Amount;
      END;
      REPLACE(TckRcT);
     ELSE
      Prtcl:=Prtcl + "| " + TckRcS.TckRcS + " " + TckRcT.Series + " " +
                     TckRcT.BefNbr + "         " + " -> " + BefNbr + "         ";
      TckRcT.BefNbr  :=BefNbr;
     END;
    END;
    BefNbr:=TckRcT.AftNbr;
   ELSE
    Prtcl:=Prtcl + "| " + TckRcS.TckRcS + " " + TckRcT.Series + " " +
                   TckRcT.BefNbr + "-" + TckRcT.AftNbr + " -> " + BefNbr + "-" + TckRcT.AftNbr;
    TckRcT.BefNbr  :=BefNbr;
    L_TRS.Calc2NumbersDifference(TckRcT.TckKind, TckRcT.BefNbr, TckRcT.AftNbr, _Amount, TckRcT.ExpSum);
    IF ~L_TRS.TckKind_wPsg() THEN
     TckRcT.ExpNum:=_Amount;
    END;
    REPLACE(TckRcT);
    LAST(TckRcDL);
   END;
   IF    (_Amount # 0) & !TckRcT.Number THEN
    TckRcT.Number:=NewTckRcTNumber();
   END;
   REPLACE(TckRcT);
  ELSE
   L_General.CallUs(~NEXT(TckRcDL));
   LAST(TckRcDL);
  END; (* IF SEARCH(TckRcT.. *)
 END {cnc_CorrectLine};

 PRIVATE PROCEDURE cnc_Do(VAR BefNbr   : LIKE(TckRcT.AftNbr);
                              tBadNbr,
                              tRightNbr: LIKE(TckRcT.AftNbr);
                              dBadNbr,
                              dRightNbr: LIKE(TckRcDL.RestNbr);
                          VAR Prtcl    : STRING[]);
  VAR
   curTckRcS: LIKE(TckRcS.TckRcS);
 BEGIN
  curTckRcS:=TckRcT.TckRcS;
  SETSEL(TckRcD, TckRcS, TckRcT.TckRcS);
  LAST(TckRcD);
  LOOP
   L_General.CallUs(OCCURE(TckRcD));
   IF TckRcD.Status = L_TRS.trdStat_Passed THEN
    SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
    WHILE OCCURE(TckRcDL) DO
     IF    TckRcDL.TRDLNbr = TckRcT.TckRcT THEN
      EXIT;
     ELSIF (TckRcDL.TckKind = TckRcT.TckKind) & (TckKind.Type = L_TRS.tkt_PieceTck) THEN
      L_General.Error("     " + TckRcT.TckKind +
                      " c  ப " + TckRcDL.TRDLNbr);
     END;
     NEXT(TckRcDL);
    END; (* WHILE OCCURE(TckRcDL) ... *)
   END; (* IF TckRcD.Status = L_TRS.trdStat_Passed *)
   PREV(TckRcD);
  END; (* LOOP ... *)
  L_General.CallUs(TckRcD.Type # L_TRS.trdt_Laying);
  L_General.CallUs(TckRcDL.RestNbr = dBadNbr);
  CHANGESEL(TckRcDL, CUCopy, , TckRcDL.CUCopy, TckRcDL.Status);
  WHILE OCCURE(TckRcDL) DO
   cnc_CorrectLine(BefNbr, tBadNbr, tRightNbr, dBadNbr, dRightNbr, Prtcl, curTckRcS);
   NEXT(TckRcDL);
  END; (* WHILE OCCURE(TckRcDL) ... *)
 END {cnc_Do};

 PRIVATE PROCEDURE TckRcT_AftNbr_OnSuccessfulChange();
  VAR
   BefNbr,
   tBadNbr,
   tRightNbr: LIKE(TckRcT.AftNbr);
   dBadNbr,
   dRightNbr: LIKE(TckRcDL.RestNbr);
   Prtcl    : STRING[];
 BEGIN
  CONFORM(TckRcT, TckKind);
  IF IsAutoBuildTckRcT() & ~L_TRS.IsEasySalesTck() THEN
   CONFORM(TckRcT, TckRcS);
   L_General.Assert(TckKind.FaceVal = 0, "  ᯫ⭠ ");
   BefNbr   :=TckRcT.BefNbr;
   tBadNbr  :=GE_PVALUE();
   tRightNbr:=TckRcT.AftNbr;
   dBadNbr  :=tBadNbr;
   dRightNbr:=tRightNbr;
   IF    tBadNbr   = L_TRS.EndOfPack() THEN
    SETEMPTY(dBadNbr);
    SETSEL(TckRcD, TckRcS, TckRcT.TckRcS);
    LAST(TckRcD);
    CHANGESEL(TckRcD, Storage, , TckRcD.Storage);
    L_General.Assert(~NEXT(TckRcD), " ଫ ᫥騥 ");
    L_General.Assert(~SELECT(TckRcS, sTSN, L_TRS.trsStat_Given, TckRcS.TSN), " 뤠 ᫥騩 ");
   ELSIF tRightNbr = L_TRS.EndOfPack() THEN
    SETEMPTY(dRightNbr);
    SETSEL(TckRcD, TckRcS, TckRcT.TckRcS);
    LAST(TckRcD);
    CHANGESEL(TckRcD, Storage, , TckRcD.Storage);
    L_General.Assert(~NEXT(TckRcD), " ଫ ᫥騥 . ନ 砭 誨 .");
    L_General.Assert(~SELECT(TckRcS, sTSN, L_TRS.trsStat_Given, TckRcS.TSN), " 뤠 ᫥騩 ");
   END;
 
   Prtcl:="";
   SAVE(TckRcT);
   TRY [ABORT_AFTER(AA_ON)]
    cnc_Do(BefNbr, tBadNbr, tRightNbr, dBadNbr, dRightNbr, Prtcl);
   EXCEPT
   END; (* TRY *)
   RESTORE(TckRcT);
   IF ~!Prtcl THEN
    L_General.Assert(~SELECT(TckRcJ, TckRcS, TckRcT.TckRcS), "  த  ३ᠬ");
    IF ~L_AcsPnt.MayPassAccessPoint(ap_TicketCassaTRSModify) THEN
     L_AcsPnt.PassAccessPoint(ap_TicketCassaTRSModify);
    END;
    L_StdFrm.Question(" ᥭ   㬥:|" + Prtcl);
   END;
   Prtcl :="";
   BefNbr:=TckRcT.BefNbr;
   cnc_Do(BefNbr, tBadNbr, tRightNbr, dBadNbr, dRightNbr, Prtcl);
  END;
 END {TckRcT_AftNbr_OnSuccessfulChange};

 PUBLIC PROCEDURE TckRcT_ShowFullInfo();
  VAR
   Msg: STRING[];
 BEGIN
  ACCESS(TckRcT);
  CONFORM(TckRcT, TckKind);
  CONFORM(TckRcT, TckRcS);
  Msg:=L_StdFrm.PartForm("%<>M" + "%<>M" +
                         "%<"+TckRcT.TckKind+">T" + "%<"+TckKind.Name+">T" +
                         "%<>M" + "%R<>M" +
                         "%<"+L_Str.PoolItem(L_TRS.tkt_Pool, TckKind.Type)+">T" +
                         "%R<"+L_Money.MoneyToStr(TckRcS.Date, "", TckKind.FaceVal)+">T" +
                         "%<>M" + "%<"+TckRcT.Series+">T" +
                         "%R< >M" + "%<"+FLDTOSTR(TckRcT.BefNbr, L_TRS.GetNbrFormat(TckRcT.BefNbr), 8, "L")+">T" +
                         "%R<᫥>M" + "%<"+FLDTOSTR(TckRcT.AftNbr, L_TRS.GetNbrFormat(TckRcT.AftNbr), 8, "L")+">T" +
                         "%R<>M" + "%R<㬬>M" +
                         "%R<"+L_Str.IntStr(TckRcT.ExpNum)+">T" +
                         "%R<"+L_Money.MoneyToStr(TckRcS.Date, "", TckRcT.ExpSum)+">T" +
                         "%R< .. ᯨᠭ>M" +
                         "%R<"+L_Str.IntStr(TckRcT.RNum)+">T" +
                         "%R<"+L_Money.MoneyToStr(TckRcS.Date, "", TckRcT.RSum)+">T" +
                         "%C<>DZ" +
                         "@" +
                          "%##% %##############################%  " +
                         "|%##% %##############################%  " +
                         "|%#%                             %#####%" +
                         "|%##############################% %####%" +
                         L_StdFrm.HR() +
                          "%###%%##########%     %######% %######%" +
                         "|                         %###% %######%" +
                         L_StdFrm.THR("室") +
                          "                         %###% %######%" +
                         "|                         %###% %######%" +
                         "|          %############% %###% %######%" +
                         "|" +
                         "|%####%");

  STDFORM(Msg, "⭠ த", INFORM);
 END {TckRcT_ShowFullInfo};

 PRIVATE PROCEDURE TckRcJBS_OnConformToWindow();
 BEGIN
  IF ~ACCESS(TckRcDLL) THEN
   SEARCH(TckRcDL, TckRcD, , TckRcDForBulkSale, TRDLNbrForBulkSale);
  ELSE
   CONFORM(TckRcDLL, TckRcDL);
  END;
  SE_WWD_CURSOR(GE_CONFORMTARGETWINDOW(), TckRcDL);
 END {TckRcJBS_OnConformToWindow};

 PRIVATE PROCEDURE TckRcDLL_OnBeforeDelete();
 BEGIN
  L_General.Error(" 饭");
 END {TckRcDLL_OnBeforeDelete};

 PRIVATE PROCEDURE TckRcDLL_OnBeforeInsert();
 BEGIN
  L_General.Error("⠢ 饭");
 END {TckRcDLL_OnBeforeInsert};

 PRIVATE PROCEDURE TckRcJBS_2_OnZoneOpen();
 BEGIN
  IF ACCESS(TckRcDL) THEN
   CONFORM(TckRcDL, TckKind);
   RTI.Get().CurWindow.Zones(1).Fields("TckRcDLL.RestNbr").Format:=L_TRS.GetNbrFormat(EMPTYOF(L_TRS.tTckNumber));
   RTI.Get().CurWindow.Zones(2).Fields("TckRcDLL.RestNbr").Format:=L_TRS.GetNbrFormat(EMPTYOF(L_TRS.tTckNumber));
   RTI.Get().CurWindow.Zones(2).Fields("TckRcDLL.Sum").Modifiable:=(TckKind.InCash # L_TRS.tkc_No) & (TckKind.Type = L_TRS.tkt_ZonalTicket);
  END;
 END {TckRcJBS_2_OnZoneOpen};

 PRIVATE PROCEDURE TckRcJBS_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="TckRcS";
  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeDelete, L_WDO.e_OnBeforeInsert]);
  L_WDO.iZone        (1).ParentZone:=L_WDO.iZone(0);
  L_WDO.iZone        (1).Narrowing:="(TckRcDLL.TckRcD=TckRcDL.TckRcD)&(TckRcDLL.TRDLNbr=TckRcDL.TRDLNbr)";
  L_WDO.iUnmodifiable(1, ["TckRcDLL.RestNbr", "TckRcDLL.Sum", "TckRcDLL.Series", "TckRcDLL.CUCopy"]);
  L_WDO.iProgs       (1, "TckRcS");
  L_WDO.iZone        (1).PermanentFilter:="(TckRcDLL.Day=TckRcS.DayForBulkSale)&(TckRcDLL.Time=TckRcS.TimeForBulkSale)";
  L_WDO.iEvents      (2, [L_WDO.e_OnOpenZone, L_WDO.e_OnBeforeDelete, L_WDO.e_OnBeforeInsert]);
  L_WDO.iZone        (2).ParentZone:=L_WDO.iZone(0);
  L_WDO.iZone        (2).Narrowing:="(TckRcDLL.TckRcD=TckRcDL.TckRcD)&(TckRcDLL.TRDLNbr=TckRcDL.TRDLNbr)";
  L_WDO.iZone        (2).PermanentFilter:="(~!TckRcDLL.Sum)&(!TckRcDLL.Day)";
  L_WDO.iUnmodifiable(2, ["TckRcDLL.RestNbr", "TckRcDLL.Sum", "TckRcDLL.Series", "TckRcDLL.CUCopy"]);
  L_WDO.iProgs       (2, "TckRcS");
 END {TckRcJBS_OnInitializeWindow};

 PUBLIC PROCEDURE SingleMakeUnDone();
 BEGIN
  L_TRS.AccessTckRcS();
  TckRcS_OnProceed(-1);
 END {SingleMakeUnDone};

 PUBLIC PROCEDURE SingleMakeDone();
 BEGIN
  L_TRS.AccessTckRcS();
  TckRcS_OnProceed(+1);
 END {SingleMakeDone};

 PUBLIC PROCEDURE ShowLegend();
 BEGIN
  L_Str.ShowLegend();
 END {ShowLegend};

 PUBLIC PROCEDURE Close();
 BEGIN
  IF   GE_CURZONE() = 2 THEN
   LIKEMENU(Cancel, "", Cancel, "Save");
  ELSE
   LIKEMENU(Cancel, "Save");
  END;
 END {Close};

BEGIN
 L_Events.ExecuteHandler();
END.
