(*
%Copyright   (c) Polak IT
%Author      20.09.2012 10:45:32 POLAK\GAV
%Purpose
%Type        report
%Specific    AP
%Modified    28.05.2013 18:56:45 POLAK\Gina
%Environment
*)

 MODULE Tw200 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_AFM, L_Way, L_two, L_BegRWS, L_DatTim, L_General, L_AvePay,
        Memo, L_Staff, L_Env, L_Basis, L_bp, L_Str, FIO;

 PRIVATE PROCEDURE RWSwWork(): SCAL[2];
 BEGIN
  IF RWayS.Status < L_Way.rwsStat_Rated THEN
   RETURN 1;
  END;
  CONFORM(RWayS, RWayJ);
  WHILE OCCURE(RWayJ) DO
   CONFORM(RWayJ, Quality);
   IF Quality.Type # L_Way.QualType_Annul THEN
    CONFORM(RWayJ, SEJobs);
    CONFORM(SEJobs, WJMode);
    IF WJMode.WJType # L_Way.WJType_Void THEN
     RETURN 1;
    END;
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
  RETURN 0;
 END {RWSwWork};

 PRIVATE PROCEDURE Gather(Fr, UT: DATE);
  VAR
   D: DATE;
 BEGIN
  L_Way.CheckTaxed(Fr, UT);
  SELECT(Mtwo, Who, , L_DatTim.Per(Fr), L_two.who_Driver);
  WHILE OCCURE(Mtwo) DO
   PROMPT(Mtwo.TSN);
(*
   L_General.Assert(~!Mtwo.Signed, "  ᠭ");
*)
   D:=Fr;
   WHILE D <= UT DO
    ADD(tmp, tmp, , Mtwo.TSN, D);
    IF !Mtwo.Signed THEN
     tmp.Plan:=Mtwo.What[L_two.Date2Idx(D)];
    ELSE
     tmp.Plan:=Mtwo.pWhat[L_two.Date2Idx(D)];
    END;
    REPLACE(tmp);
    INC(D);
   END; (* WHILE D <= UT *)
   NEXT(Mtwo);
  END; (* WHILE OCCURE(Mtwo) ... *)

  SELECT(RWayS, Date);
  SRCINSEL(RWayS, GE, , Fr);
  WHILE OCCURE(RWayS) & (RWayS.Date <= UT) DO
   PROMPT(RWayS.RWayS);
   IF L_Env.RealTSN(RWayS.TSN) & RWSwWork() THEN
    ADD(tmp, tmp, , RWayS.TSN, RWayS.Date);
    IF ~!tmp.Fact & (tmp.Fact # RWayS.Change) THEN
     tmp.Fact:=L_BegRWS.dt_WholeDay;
    ELSE
     tmp.Fact:=RWayS.Change;
    END;
    REPLACE(tmp);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   PROMPT(tmp.TSN);
   IF L_BegRWS.IsWorkDayType(tmp.Fact) = L_BegRWS.IsWorkDayType(tmp.Plan) THEN
    REMOVE(tmp);
   ELSE
    IF L_BegRWS.IsWorkDayType(tmp.Fact) THEN
     tmp.Type:=0;
    ELSE
     SETSEL(AvePay, EBDTSN, tmp.TSN);
     SRCINSEL(AvePay, GE, , tmp.Date);
     WHILE OCCURE(AvePay) & ~(L_AvePay.IsRealAvePay() & L_AvePay.AvePayHasJMode()) DO
      NEXT(AvePay);
     END;
     IF OCCURE(AvePay) & L_DatTim.IsActive_Inc(tmp.Date, AvePay.StartD, AvePay.StopD) THEN
      CONFORM(AvePay, AvePayP);
      WHILE ~L_DatTim.IsActive_Inc(tmp.Date, AvePayP.StartD, AvePayP.StopD) DO
       NEXT(AvePayP);
      END;
      CONFORM(AvePayP, AveTypeP);
      tmp.JMode:=AveTypeP.JMode;
     END;
     tmp.Type:=1;
    END;
    REPLACE(tmp);
    NEXT(tmp);
   END;
  END; (* WHILE OCCURE(tmp) ... *)
 END {Gather};

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "  ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, " ");
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "襭");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE dtStr(dt: L_BegRWS.tDayType): STRING[];
  CONST
   dt_Pool = " ()| (1)| (2)| | | ||⢨|  |室";
 BEGIN
  IF !dt THEN
   RETURN "";
  ELSE
   RETURN L_Str.PoolItem(dt_Pool, dt);
  END;
 END {dtStr};

 PRIVATE PROCEDURE MakeLine(F: STRING[]);
 BEGIN
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrDat(F, tmp.Date);
  L_Basis.wb_WrScl(F, L_Staff.rInState(tmp.Date));
  CONFORM(StaffLog, Officer);
  CONFORM(Officer, Union);
  CONFORM(Officer, Sort);
  CONFORM(Officer, Post);
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("室|室", tmp.Type));
  L_Basis.wb_WrStr(F, dtStr(tmp.Plan));
  L_Basis.wb_WrStr(F, dtStr(tmp.Fact));
  IF ~!tmp.JMode THEN
   SEARCH(JMode, JMode, , tmp.JMode);
   L_Basis.wb_WrScl(F, JMode.JMode);
   L_Basis.wb_WrStr(F, JMode.Name);
   L_Basis.wb_WrStr(F, JMode.ShtSign);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PUBLIC PROCEDURE Tw200();
  CONST
   bpId = "Tw200";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId,"襭 ᯮ 鸞", L_bp.t_Basis, L_General.tc_inIntvl);
  L_General.Assert(L_DatTim.Per(Memo.ud_fr()) = L_DatTim.Per(Memo.ud_ut()),
                   "ਮ     ।  ");

  L_AFM.MakeMultipleIndex("tmp", "Type : SCAL[2];" +
                                 "TSN  : LIKE(Staff.TSN);" +
                                 "Date : DATE;" +
                                 "Plan : SCAL[10];" +
                                 "Fact : SCAL[10];" +
                                 "JMode: LIKE(JMode.JMode)",
                             "tmp: TSN, Date");
  Gather(Memo.ud_fr(), Memo.ud_ut());
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  MakeTop("F");
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   PROMPT(tmp.TSN);
   SEARCH(Staff, TSN, , tmp.TSN);
   CONFORM(Staff, Man);
   NARROWSEL(tmp, TSN);
   WHILE OCCURE(tmp) DO
    MakeLine("F");
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) *)
   NEXTINEXTENDEDSEL(tmp, TSN);
  END; (* WHILE OCCURE(tmp) *)
  FIO.Close(F);
  L_bp.End();
 END {Tw200};

END.