(*
%Copyright   (c) Polak Computer System
%Author      24.09.2002 15:20:19 POLAK\SAN
%Purpose     ⮢ "䨪-鸞"
%Type        operation
%Specific    AP
%Modified    29.08.2014 11:53:47 POLAK\Gina
%Environment
*)

 MODULE two;

 IMPORT Memo, L_General, L_Events, L_Str, L_DatTim, L_BegRWS, L_two, L_WDO, L_Env,
        L_Staff, L_Way, Math, L_StdFrm, Str, L_Car, L_lsStore, L_XDoc, P_Firm, L_AcsPnt, L_AR, L_bp;

 PERMANENT VAR
  MtwoCurDate    : DATE;
  MtwoCurECShift : NUMERIC[0];
  MtwoCurECDay   : NUMERIC[0];

  v_M_CurDate        : DATE;
  v_M_TSNDescr,
  v_M_ExitClssDescr,
  v_M_BoxNbrDescr,
  v_M_CooTSN_Name,
  v_M_CooTSNAsTimDone,
  v_M_CooTSNDescr    : STRING[];

  v_D_TSNDescr,
  v_D_ExitClssDescr,
  v_D_BoxNbrDescr,
  v_D_GuardTSNDescr  : STRING[];

  v_D_Message        : STRING[];

  asDtwoRWayS        : LIKE(RWayS.RWayS);

  Mtwo_TSN_ToStandon : LIKE(Staff.TSN);
  Dtwo_Dtwo_ToStandOn: LIKE(Dtwo.Dtwo);

 CONST
  Mtwo_DaysInLine = 7;

 PRIVATE PROCEDURE Mtwo_1_SetFirstDay(D: DATE);
 BEGIN
  MtwoCurDate:=Math.Min(Math.Max(D, Memo.ud_mb()), L_DatTim.MonthEnd(Memo.ud_mb())+1-Mtwo_DaysInLine);
  MtwoCurECShift:=L_two.Date2Idx(MtwoCurDate);
  MtwoCurECDay  :=(MtwoCurDate-L_DatTim.Per(MtwoCurDate));
 END {Mtwo_1_SetFirstDay};

 PRIVATE PROCEDURE MJumpByDays(Days: NUMERIC[0]);
 BEGIN
  CALL(SetDfDat.MoveToAnyDay_Ext(Memo.ud_cd()+Days));
  Mtwo_1_SetFirstDay(Memo.ud_cd());
 END {MJumpByDays};

 PRIVATE PROCEDURE M_SetCurFilter();
  VAR
   Value: STRING[];
 BEGIN
  SETEMPTY(Value, L_two.MtwoCurFilterDsc);
  IF ~!L_two.MtwoCurWho THEN
   filter_AddVal(Value,            "Mtwo.Who=" + L_two.MtwoCurWho);
   filter_AddDsc(L_two.MtwoCurFilterDsc, L_Str.PoolItem("⥫|", L_two.MtwoCurWho));
  END;
  IF ~!L_two.MtwoCurDprt THEN
   filter_AddVal(Value,            "Mtwo.Dprt=" + L_two.MtwoCurDprt);
   filter_AddDsc(L_two.MtwoCurFilterDsc, "⤥ " + L_two.MtwoCurDprt);
  END;
  IF ~!L_two.MtwoCurSort THEN
   filter_AddVal(Value,            "Mtwo.Sort=" + L_two.MtwoCurSort);
   filter_AddDsc(L_two.MtwoCurFilterDsc, "ᥪ " + L_two.MtwoCurSort);
  END;
  IF ~!Value THEN
   Value:="&("+Value+")";
  END;
  RTI.Get().CurZone.PermanentFilter:=L_Way.extCurPlaceFilter("Mtwo", Value);
  IF ~!L_two.MtwoCurFilterDsc THEN
   L_two.MtwoCurFilterDsc:=Str.Cap(L_two.MtwoCurFilterDsc, 0, 1);
  END;
  L_WDO.wz_SetFieldVisible("Mtwo", 0, "v_MtwoCurFilterDsc", ~!L_two.MtwoCurFilterDsc);
 END {M_SetCurFilter};

 PUBLIC PROCEDURE ResetAllMtwoFilters();
 BEGIN
  SETEMPTY(L_two.MtwoCurWho, L_two.MtwoCurSort, L_two.MtwoCurDprt);
  M_SetCurFilter();
 END {ResetAllMtwoFilters};

 PRIVATE PROCEDURE Mtwo_1_OnZoneOpen();
  VAR
   i: NUMERIC[0];
 BEGIN
  L_WDO.z_SetFieldFormat(0, "Mtwo.Who", L_two.who_ShortPool);
  L_WDO.z_SetFieldFormat(1, "Mtwo.Who", L_two.who_ShortPool);
  i:=0;
  WHILE i < Mtwo_DaysInLine DO
   L_WDO.z_SetFieldFormat(0, "What_"+L_Str.IntStr(i), L_BegRWS.wh_Pool);
   L_WDO.z_SetFieldFormat(1, "What_"+L_Str.IntStr(i), L_BegRWS.wh_Pool);
   INC(i);
  END;
  IF ~L_General.VariableIsInitialized(MtwoCurDate) | (L_DatTim.Per(MtwoCurDate) # Memo.ud_mb()) THEN
   Mtwo_1_SetFirstDay(Memo.ud_cd());
  END;
  IF ~L_General.VariableIsInitialized(L_two.MtwoCurSort) THEN
   ResetAllMtwoFilters();
  ELSE
   M_SetCurFilter();
  END;
 END {Mtwo_1_OnZoneOpen};

 CONST
  two_WeekAmount = 6;

 PRIVATE PERMANENT VAR
  v_Day: STRING[2][L_DatTim.wd_DaysAmount * two_WeekAmount];

 PRIVATE PROCEDURE MtwoE_pwf_SingleField(da      : L_two.tDailyAttribute;
                                         i       : NUMERIC[0];
                                         Editable: SCAL[2]);
  VAR
   trgColor     : NUMERIC[0];
   FieldName    : STRING[];
   trgVisible,
   trgModifiable: SCAL[2];
 BEGIN
  IF    da = L_two.da_What     THEN FieldName:="Mtwo.What";
  ELSIF da = L_two.da_ExitClss THEN FieldName:="Mtwo.ExitClss";
  ELSIF da = L_two.da_Car      THEN FieldName:="Mtwo.BoxNbr";
  ELSIF da = L_two.da_CooTSN   THEN FieldName:="Mtwo.CooTSN";
  END;
  FieldName:=L_Str.Var_wIdx(FieldName, i);
  IF ~Editable THEN
   IF !^FieldName THEN
    trgVisible   :=0;
   ELSE
    trgVisible   :=1;
    trgModifiable:=0;
   END;
  ELSE
   trgVisible   :=1;
   trgModifiable:=1;
  END;
  RTI.Get().CurZone.Fields(FieldName).Visible:=trgVisible;
  IF trgVisible THEN
   RTI.Get().CurZone.Fields(FieldName).Modifiable:=trgModifiable;
   IF trgModifiable THEN
    IF    Mtwo.Source[L_two.MSrcIdx(i, da)] = L_BegRWS.twosrc_System THEN
     trgColor:=FORM_FIELD.Color_Text;
    ELSIF Mtwo.Source[L_two.MSrcIdx(i, da)] = L_BegRWS.twosrc_Operator THEN
     trgColor:=FORM_FIELD.Color_Field1;
    ELSIF Mtwo.Source[L_two.MSrcIdx(i, da)] = L_BegRWS.twosrc_Auto THEN
     trgColor:=FORM_FIELD.Color_CurFieldInActiveHighlightBar;
    ELSE
     trgColor:=FORM_FIELD.Color_Native;
    END;
    RTI.Get().CurZone.Fields(FieldName).Color:=trgColor;
   END;
  END;
 END {MtwoE_pwf_SingleField};

 TYPE
  tMtwoFieldsEnable = SCAL[4];

 CONST
  twfe_All      = 0;
  twfe_ExitClss = 1;
  twfe_BoxNbr   = 2;
  twfe_CooTSN   = 3;

 PERMANENT VAR
  MtwoFieldsEnable: tMtwoFieldsEnable;

 PRIVATE PROCEDURE MtwoE_PrepareSingleWinField(Visible: SCAL[2]; i: NUMERIC[0]);
 BEGIN
  RTI.Get().CurZone.Fields(L_Str.Var_wIdx("Mtwo.What", i)).MustBeNonempty:=1;
  MtwoE_pwf_SingleField(L_two.da_What,     i, Visible);
  MtwoE_pwf_SingleField(L_two.da_ExitClss, i, Visible & L_BegRWS.IsWorkDayType(Mtwo.What[i]) & ((MtwoFieldsEnable = twfe_All) | (MtwoFieldsEnable = twfe_ExitClss)));
  MtwoE_pwf_SingleField(L_two.da_Car,      i, Visible & L_BegRWS.IsWorkDayType(Mtwo.What[i]) & ((MtwoFieldsEnable = twfe_All) | (MtwoFieldsEnable = twfe_BoxNbr)));
  MtwoE_pwf_SingleField(L_two.da_CooTSN,   i, Visible & L_BegRWS.IsWorkDayType(Mtwo.What[i]) & ((MtwoFieldsEnable = twfe_All) | (MtwoFieldsEnable = twfe_CooTSN)));
  RTI.Get().CurZone.Fields(L_Str.Var_wIdx("Mtwo.HldOff", i)).Visible:=Visible &
                                                                      L_BegRWS.IsWorkDayType(Mtwo.What[i]) &
                                                                      (Mtwo.Source[L_two.MSrcIdx(i, L_two.da_What)] = L_BegRWS.twosrc_Operator) &
                                                                      L_two.E_IsHolidayDayType(Mtwo.TSN, L_two.Idx2Date(i, Mtwo.Per));
 END {MtwoE_PrepareSingleWinField};

 PRIVATE PROCEDURE MtwoE_PrepareWinField();
  VAR
   Visible: SCAL[2];
   i, j,
   BegIdx,
   EndIdx,
   SysIdx : NUMERIC[0];
 BEGIN
  BegIdx:=L_two.Date2Idx(Mtwo.Per);
  EndIdx:=BegIdx + L_DatTim.MonthLen(Mtwo.Per) - 1;
  SysIdx:=BegIdx + (L_two.FirstModifiableDay()-1-Mtwo.Per);
  i:=0;
  WHILE i <= HIGH(Mtwo.ExitClss) DO
   IF (i >= BegIdx) & (i <= EndIdx) THEN
    j:=i-BegIdx+1;
    v_Day[i]:=L_Str.IntStr(j);
    IF j < 10 THEN
     v_Day[i]:=""+v_Day[i];
    END;
    Visible   :=(SysIdx<i) & (Mtwo.Source[L_two.MSrcIdx(i, L_two.da_What)] # L_BegRWS.twosrc_System);
   ELSE
    v_Day[i]:="";
    Visible :=0;
   END;
   IF ~L_General.VariableIsInitialized(MtwoFieldsEnable) THEN
    MtwoFieldsEnable:=twfe_All;
   END;
   MtwoE_PrepareSingleWinField(Visible, i);
   INC(i);
  END;
 END {MtwoE_PrepareWinField};

 PRIVATE PROCEDURE SetMtwoFieldsEnable(tofe: tMtwoFieldsEnable);
 BEGIN
  MtwoFieldsEnable:=tofe;
  MtwoE_PrepareWinField();
 END {SetMtwoFieldsEnable};

 PUBLIC PROCEDURE SetMtwoExitClssEnable();
 BEGIN
  SetMtwoFieldsEnable(twfe_ExitClss);
 END {SetMtwoExitClssEnable};

 PUBLIC PROCEDURE SetMtwoCooTSNEnable();
 BEGIN
  SetMtwoFieldsEnable(twfe_CooTSN);
 END {SetMtwoCooTSNEnable};

 PUBLIC PROCEDURE SetMtwoBoxNbrEnable();
 BEGIN
  SetMtwoFieldsEnable(twfe_BoxNbr);
 END {SetMtwoBoxNbrEnable};

 PUBLIC PROCEDURE SetMtwoAllFieldsEnable();
 BEGIN
  SetMtwoFieldsEnable(twfe_All);
 END {SetMtwoAllFieldsEnable};

 PRIVATE PROCEDURE M_InitCurDescription();
 BEGIN
  SETEMPTY(v_M_CurDate, v_M_TSNDescr, v_M_ExitClssDescr, v_M_BoxNbrDescr,
           v_M_CooTSN_Name, v_M_CooTSNAsTimDone, v_M_CooTSNDescr);
 END {M_InitCurDescription};

 PRIVATE PROCEDURE MtwoE_0_OnReposition();
  VAR
   i: NUMERIC[0];
 BEGIN
  MtwoE_PrepareWinField();
  i:=0;
  WHILE i <= HIGH(Mtwo.What) DO
   RTI.Get().CurZone.Fields(L_Str.Var_wIdx("Mtwo.What", i)).Format:=L_BegRWS.wh_Pool;
   INC(i);
  END;
  M_InitCurDescription();
 END {MtwoE_0_OnReposition};

 PRIVATE PROCEDURE Mtwo_OnBeforeInsert();
 BEGIN
  L_General.Error("   ᯮ F9");
 END {Mtwo_OnBeforeInsert};

 PRIVATE PROCEDURE Mtwo_OnBeforeEdit();
  VAR
   First    : SCAL[2];
   BegIdx,
   EndIdx,
   CurIdx,
   i        : NUMERIC[0];
   wasActual: SCAL[2];
 BEGIN
  wasActual:=Mtwo.Actual;
  L_two.Renovate(Mtwo.Per, L_two.rm_AutoM);
  IF ~wasActual THEN
   MtwoE_PrepareWinField();
  END;
  First:=1;
  BegIdx:=L_two.Date2Idx(Memo.ud_mb());
  EndIdx:=L_two.Date2Idx(Memo.ud_me());
  CurIdx:=L_two.Date2Idx(Memo.ud_cd());
  i:=CurIdx;
  REPEAT
   IF ~First THEN
    L_WDO.SetFieldFirst(L_Str.Var_wIdx("Mtwo.What", i), 0);
   ELSIF Mtwo.Source[L_two.MSrcIdx(i, L_two.da_What)] # L_BegRWS.twosrc_System THEN
    L_WDO.SetFieldFirst(L_Str.Var_wIdx("Mtwo.What", i), 1);
    First:=0;
   END;
   INC(i);
   IF i > EndIdx THEN
    i:=BegIdx;
   END;
  UNTIL i = CurIdx;
 END {Mtwo_OnBeforeEdit};

 PRIVATE PROCEDURE Mtwo_OnBeforeDelete();
 BEGIN
  L_General.Error(" 㤠  ᯮ F9");
 END {Mtwo_OnBeforeDelete};

 PRIVATE PROCEDURE Mtwo_OnAfterEdIns();
 BEGIN
 END {Mtwo_OnAfterEdIns};

 PRIVATE PROCEDURE Mtwo_OnAfterEdit();
 BEGIN
  Mtwo_OnAfterEdIns();
 END {Mtwo_OnAfterEdit};

 PRIVATE PROCEDURE Mtwo_OnAfterInsert();
 BEGIN
  Mtwo_OnAfterEdIns();
 END {Mtwo_OnAfterInsert};

 PRIVATE PROCEDURE MtwoE_OnConformToWindow();
  VAR
   curFN : STRING[];
   curWho: L_two.tTWOWho;
   curTSN: LIKE(Staff.TSN);
 BEGIN
  curFN:=RTI.Get().CurZone.ActiveField.Name;
  IF    curFN = "Dtwo.TSN"      THEN
   curWho:=L_two.who_Driver;
   curTSN:=Dtwo.TSN;
  ELSIF curFN = "Dtwo.GuardTSN" THEN
   curWho:=L_two.who_Guard;
   curTSN:=Dtwo.GuardTSN;
  ELSE
   HALT(1);
  END;
  L_General.Assert(~!curTSN, " 㪠 ⠡  ࠡ⭨ (" + L_Str.PoolItem(L_two.who_Pool, curWho) + ")");
  L_General.CallUs(SEARCH(Mtwo, Who, L_DatTim.Per(Dtwo.Date), curWho, curTSN));
  SE_WWD_CURSOR("MtwoE", Mtwo);
 END {MtwoE_OnConformToWindow};

 PRIVATE PROCEDURE DtwoE_OnConformToWindow();
  VAR
   curIndex: NUMERIC[0];
 BEGIN
  curIndex:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  L_General.Assert(L_BegRWS.IsWorkDayType(Mtwo.What[curIndex]), "室 ");
  L_two.AccessDtwoByMtwo(curIndex);
  SE_WWD_CURSOR("DtwoE", Dtwo);
 END {DtwoE_OnConformToWindow};

 PRIVATE PROCEDURE GetSuitableObject(da       : L_two.tDailyAttribute;
                                     D        : DATE;
                                     _ExitClss: LIKE(ExitClss.ExitClss);
                                     _Change  : LIKE(StExit.Change);
                                     _Driver,
                                     _Guard   : LIKE(Staff.TSN);
                                     _Sort    : LIKE(Sort.Sort);
                                     _BoxNbr  : LIKE(Car.BoxNbr);
                                     ofc      : L_two.tObjectFreeCond): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF    da = L_two.da_ExitClss THEN
   Result:=L_two.ChooseSuitableExitClss(_Sort, D, _Change, _Driver, _Guard, ofc);
  ELSIF da = L_two.da_Driver THEN
   Result:=L_two.ChooseSuitableStaff(L_Way.rwswho_Driver, D, EMPTYOF(RWayS.RWayS), _ExitClss, _Change, _Sort,          _BoxNbr, 1);
  ELSIF da = L_two.da_Guard THEN
   Result:=L_two.ChooseSuitableStaff(L_Way.rwswho_Guard , D, EMPTYOF(RWayS.RWayS), _ExitClss, _Change, EMPTYOF(_Sort), _BoxNbr, 0);
  ELSIF da = L_two.da_Car THEN
   Result:=L_two.ChooseSuitableCar(_Sort, D, ofc, EMPTYOF(RWayS.RWayS));
  END;
  RETURN Result;
 END {GetSuitableObject};

 PRIVATE PROCEDURE MtwoAttrOnsuccessfulChange(da: L_two.tDailyAttribute; prvValue: STRING[]; Idx: NUMERIC[0]);
 BEGIN
  Mtwo.Source[L_two.MSrcIdx(Idx, da)]:=L_BegRWS.twosrc_Operator;
  REPLACE(Mtwo);
  L_two.m_ChangeDA(da, prvValue, Idx, L_BegRWS.twosrc_Operator);
 END {MtwoAttrOnsuccessfulChange};

 PRIVATE PROCEDURE D_GetExitDescription(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF ~!Dtwo.ExitClss & L_two.StandOnExit(Dtwo.ExitClss, Dtwo.Change, Dtwo.Date, 1) THEN
   Result:=FLDTOSTR(Dtwo.BegDay, "L0", 2) +
           " " + L_DatTim.TimeStr(Dtwo.BegTime) +
           " " + L_DatTim.TimeStr(Dtwo.EndTime) +
           " " +  FLDTOSTR(StExit.TotT, "1.", 0) + " " +
           L_Str.PoolItem("-|+", StExit.Gap) + " " + L_Str.PoolItem(" |+|-", StExit.GuNeed);

  ELSE
   Result:="";
  END;
  RETURN Result;
 END {D_GetExitDescription};

 PUBLIC PROCEDURE SetMtwoCurDescription();
  VAR
   Idx: NUMERIC[0];
   D  : DATE;
 BEGIN
  M_InitCurDescription();
  Idx:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  D  :=L_two.Idx2Date(Idx, Mtwo.Per);
  v_M_CurDate:=D;
  TRY
   v_M_TSNDescr:=L_two.GetTSNEnvironmentAsStr(Mtwo.TSN, Mtwo.Who, D);
   IF ~!Mtwo.ExitClss[Idx] THEN
    L_two.AccessDtwoByMtwo(Idx);
    v_M_ExitClssDescr:=D_GetExitDescription();
   END;
   IF ~!Mtwo.BoxNbr[Idx] THEN
    L_Car.StandOnCarLog(Mtwo.BoxNbr[Idx], D);
    CONFORM(CarLog, Mark);
    v_M_BoxNbrDescr:=Str.Align(CarLog.BoxNbr + " " + CarLog.StateNbr + " " + Mark.Name, 32, LEFT) +
                     "/" + L_two.GetBoxNbrFixedTSN(Mtwo.BoxNbr[Idx], D);
   END;
   IF ~!Mtwo.CooTSN[Idx] THEN
    SEARCH(Staff, TSN, , Mtwo.CooTSN[Idx]);
    CONFORM(Staff, Man);
    v_M_CooTSN_Name:=Staff.TSN + " " + Man.Name;
    v_M_CooTSNDescr:=L_two.GetTSNEnvironmentAsStr(Mtwo.TSN, Mtwo.Who, D);
    TRY
     SAVE(Mtwo);
     L_two.StandOnMtwo(Staff.TSN, L_two.Who2CooWho(), Mtwo.Per);
     v_M_CooTSNAsTimDone:=FLDTOSTR(Mtwo.asTimDone, "1.", 0);
     RESTORE(Mtwo);
     L_General.RaiseLockReleaseException();
    EXCEPT
    ON Exc: Exc_Root DO
     IF ~L_General.IsLockReleaseException(Exc) THEN
      v_M_CooTSNAsTimDone:="?!";
     END;
    END;
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Raise DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
 END {SetMtwoCurDescription};

 PRIVATE PROCEDURE Mtwo_What_OnSuccessfulChange();
  VAR
   newWhat: L_BegRWS.tDayType;
   Idx    : NUMERIC[0];
   D      : DATE;
 BEGIN
  Idx:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  D  :=L_two.Idx2Date(Idx, Mtwo.Per);
  L_two.m_ChangeTimDone(-1, GE_PVALUE(), Mtwo.ExitClss[Idx], Idx);
  IF L_BegRWS.IsWorkDayType(GE_PVALUE()) & ~L_BegRWS.IsWorkDayType(Mtwo.What[Idx]) THEN
   newWhat:=Mtwo.What[Idx];
   Mtwo.What[Idx]:=GE_PVALUE();
   REPLACE(Mtwo);
   L_two.ResetHldOff(Idx, 0);
   Mtwo.What[Idx]:=newWhat;
  END;
  MtwoAttrOnsuccessfulChange(L_two.da_What, GE_PVALUE(), Idx);
  IF ~L_BegRWS.IsWorkDayType(GE_PVALUE()) & L_BegRWS.IsWorkDayType(Mtwo.What[Idx]) THEN
   L_two.SetHldOff(Idx, 0);
   TRY
    L_two.Renovate(D, L_two.rm_SingleMtwoDay);
    Mtwo_CheckCrew(Idx);
   EXCEPT
   ON Exc: Exc_Raise DO
    L_StdFrm.RedInform("⪠ ⮬᪮ ⠭   ᮣ᭮ ९  㤠." + "||" + Exc.MsgOriginalText);
   ELSE
    RAISE();
   END; (* TRY *)
  END;
  L_two.m_AddTimDone(Idx);
  MtwoE_PrepareSingleWinField(1, Idx);
  SetMtwoCurDescription();
 END {Mtwo_What_OnSuccessfulChange};

 PRIVATE PROCEDURE Mtwo_HldOff_OnSuccessfulChange();
  VAR
   curIndex: NUMERIC[0];
 BEGIN
  curIndex:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  L_two.AccessDtwoByMtwo(curIndex);
  Dtwo.HldOff[Mtwo.Who]:=Mtwo.HldOff[curIndex];
  REPLACE(Dtwo);
 END {Mtwo_HldOff_OnSuccessfulChange};

 PRIVATE PROCEDURE Mtwo_CheckCrew(Idx: NUMERIC[0]);
  VAR
   D      : DATE;
   DrvTSN,
   GrdTSN : LIKE(Staff.TSN);
   _Exit  : LIKE(StExit.Exit);
 BEGIN
  D:=L_two.Idx2Date(Idx, Mtwo.Per);
  IF    Mtwo.Who = L_two.who_Driver THEN
   DrvTSN:=Mtwo.TSN;
   GrdTSN:=Mtwo.CooTSN[Idx];
  ELSE
   DrvTSN:=Mtwo.CooTSN[Idx];
   GrdTSN:=Mtwo.TSN;
  END;

  IF ~!Mtwo.ExitClss[Idx] THEN
   L_two.PositionOnExit(Mtwo.ExitClss[Idx], Mtwo.What[Idx], D);
   _Exit:=StExit.Exit;
  ELSE
   SETEMPTY(_Exit);
  END;
  L_BegRWS.E_CheckCrewInTWOEdit(D, DrvTSN, Mtwo.BoxNbr[Idx], _Exit, GrdTSN);
 END {Mtwo_CheckCrew};

 PRIVATE PROCEDURE Mtwo_ExitClss_OnSuccessfulChange();
  VAR
   Idx  : NUMERIC[0];
 BEGIN
  Idx:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  L_two.m_ChangeTimDone(-1, Mtwo.What[Idx], GE_PVALUE(), Idx);
  MtwoAttrOnsuccessfulChange(L_two.da_ExitClss, GE_PVALUE(), Idx);
  L_two.m_AddTimDone(Idx);
  IF ~!Mtwo.ExitClss[Idx] THEN
   Mtwo_CheckCrew(Idx);
  END;
  MtwoE_PrepareSingleWinField(1, Idx);
  SetMtwoCurDescription();
 END {Mtwo_ExitClss_OnSuccessfulChange};

 PRIVATE PROCEDURE GetObjectFreeCondition(da       : L_two.tDailyAttribute;
                                          _ExitClss: LIKE(ExitClss.ExitClss);
                                          _Driver  : LIKE(Staff.TSN);
                                          _BoxNbr  : LIKE(Car.BoxNbr);
                                          _Guard   : LIKE(Staff.TSN)): L_two.tObjectFreeCond;
 BEGIN
  IF    (da # L_two.da_Driver)   & ~!_Driver THEN
   RETURN L_two.ofc_Driver;
  ELSIF (da # L_two.da_ExitClss) & ~!_ExitClss THEN
   RETURN L_two.ofc_ExitClss;
  ELSIF (da # L_two.da_Guard)    & ~!_Guard THEN
   RETURN L_two.ofc_Guard;
  ELSIF (da # L_two.da_Car)      & ~!_BoxNbr THEN
   RETURN L_two.ofc_Car;
  ELSE
   L_General.Error(" 拉  ⢥ ਡ - ⥪騩. 祬  ?");
  END;
 END {GetObjectFreeCondition};

 PRIVATE PROCEDURE Mtwo_ChooseSuitableObject(da: L_two.tDailyAttribute; prvValue: STRING[]; Idx: NUMERIC[0]);
  VAR
   Object   : STRING[];
   _Driver,
   _Guard   : LIKE(Staff.TSN);
   _BoxNbr  : LIKE(Car.BoxNbr);
   _ExitClss: LIKE(ExitClss.ExitClss);
   _Sort    : LIKE(Sort.Sort);
   D        : DATE;
 BEGIN
  SETEMPTY(_Sort);
  D:=L_two.Idx2Date(Idx, Mtwo.Per);
  IF    Mtwo.Who = L_two.who_Driver THEN
   _Driver  :=Mtwo.TSN;
   _ExitClss:=Mtwo.ExitClss[Idx];
   _BoxNbr  :=Mtwo.BoxNbr[Idx];
   _Guard   :=Mtwo.CooTSN[Idx];
   IF (da = L_two.da_ExitClss) | (da = L_two.da_Car) THEN
    SEARCH(Staff, TSN, , _Driver);
    L_Staff.PosToStaffLog(Staff.TSN, D, 1);
    _Sort:=StaffLog.Sort;
   END;
  ELSIF Mtwo.Who = L_two.who_Guard  THEN
   SETEMPTY(_Driver, _BoxNbr, _ExitClss);
   _Guard :=Mtwo.TSN;
   IF (da = L_two.da_ExitClss) &
      ~!Mtwo.ExitClss[Idx]     &
      L_two.StandOnExit(Mtwo.ExitClss[Idx], Mtwo.What[Idx], D, 0) THEN
    _Sort:=L_Way.E_GetFixedSortOfExit(StExit.Exit, D, Mtwo.Who);
   END;
  END;

  Object:=GetSuitableObject(da,
                            D,
                            _ExitClss,
                            Mtwo.What[Idx],
                            _Driver,
                            _Guard,
                            _Sort,
                            _BoxNbr,
                            GetObjectFreeCondition(da, _ExitClss, _Driver, _BoxNbr, _Guard));
  L_two.m_c_SetAttr(da, Idx, Object);
  REPLACE(Mtwo);
  MtwoAttrOnsuccessfulChange(da, prvValue, Idx);
  Mtwo_CheckCrew(Idx);
  MtwoE_PrepareSingleWinField(1, Idx);
  SetMtwoCurDescription();
 END {Mtwo_ChooseSuitableObject};

 PRIVATE PROCEDURE EmulateMtwoOnBeforeAskForEdit();
  VAR
   Idx     : NUMERIC[0];
   curField: FORM_FIELD;
   curFN,
   prvValue: STRING[];
   da      : L_two.tDailyAttribute;
 BEGIN
  SETEMPTY(da);
  curField:=RTI.Get().CurZone.ActiveField;
  IF ~!curField.TableField THEN
   curFN:=curField.TableField.Name;
   Idx:=curField.ArrayIndex;
   IF    curFN = "ExitClss" THEN
    da      :=L_two.da_ExitClss;
    prvValue:=Mtwo.ExitClss[Idx];
   ELSIF curFN = "BoxNbr" THEN
    da      :=L_two.da_Car;
    prvValue:=Mtwo.BoxNbr[Idx];
   ELSIF curFN = "CooTSN" THEN
    prvValue:=Mtwo.CooTSN[Idx];
    IF    Mtwo.Who = L_two.who_Driver THEN
     da     :=L_two.da_Guard;
    ELSIF Mtwo.Who = L_two.who_Guard  THEN
     da     :=L_two.da_Driver;
    END;
   END;
  END;
  IF ~!da THEN
   Mtwo_ChooseSuitableObject(da, prvValue, Idx);
  ELSE
   LIKEMENU(Ask, "");
  END;
 END {EmulateMtwoOnBeforeAskForEdit};

 PRIVATE PROCEDURE Mtwo_ExitClss_OnBeforeAsk();
 BEGIN
  EmulateMtwoOnBeforeAskForEdit();
 END {Mtwo_ExitClss_OnBeforeAsk};

 PRIVATE PROCEDURE Mtwo_BoxNbr_OnBeforeAsk();
 BEGIN
  EmulateMtwoOnBeforeAskForEdit();
 END {Mtwo_BoxNbr_OnBeforeAsk};

 PRIVATE PROCEDURE Mtwo_CooTSN_OnBeforeAsk();
 BEGIN
  EmulateMtwoOnBeforeAskForEdit();
 END {Mtwo_CooTSN_OnBeforeAsk};

 PRIVATE PROCEDURE D_SetCurDescription();
 BEGIN
  SETEMPTY(v_D_TSNDescr, v_D_ExitClssDescr, v_D_BoxNbrDescr, v_D_GuardTSNDescr);
  TRY
   IF ACCESS(Dtwo) THEN
    IF ~!Dtwo.TSN THEN
     v_D_TSNDescr:=L_two.GetTSNEnvironmentAsStr(Dtwo.TSN, L_two.who_Driver, Dtwo.Date);
    END;
    v_D_ExitClssDescr:=D_GetExitDescription();
    IF ~!Dtwo.BoxNbr THEN
     v_D_BoxNbrDescr:=L_two.GetBoxNbrFixedTSN(Dtwo.BoxNbr, Dtwo.Date);
    END;
    IF ~!Dtwo.GuardTSN THEN
     v_D_GuardTSNDescr:=L_two.GetTSNEnvironmentAsStr(Dtwo.GuardTSN, L_two.who_Guard, Dtwo.Date);
    END;
    L_WDO.SetFieldModifiable("Dtwo.BegDay",  Dtwo.MnlTmSet);
    L_WDO.SetFieldModifiable("Dtwo.BegTime", Dtwo.MnlTmSet);
    L_WDO.SetFieldModifiable("Dtwo.EndTime", Dtwo.MnlTmSet);
    L_WDO.SetFieldModifiable("Dtwo.Change", !Dtwo.ExitClss | ~L_two.IsWholeDayExitClss(Dtwo.ExitClss, Dtwo.Date));
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Raise DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
 END {D_SetCurDescription};

 TYPE
  tReplaceDtwoMode = SCAL[3];
 CONST
  rdm_Choice           = 0;
  rdm_SuccessfulChange = 1;
  rdm_SetValue         = 2;

 PRIVATE PROCEDURE Replace_Dtwo(da                : L_two.tDailyAttribute;
                                Value             : STRING[];
                                Mode              : tReplaceDtwoMode);
  VAR
   D      : DATE;
   _Change: LIKE(Dtwo.Change);
 BEGIN
  D      :=Dtwo.Date;
  _Change:=Dtwo.Change;
  IF Mode = rdm_SuccessfulChange THEN
   L_two.d_c_SetAttr(da, GE_PVALUE());
   REPLACE(Dtwo);
   IF da = L_two.da_What THEN
    da   :=L_two.da_ExitClss;
    Value:=Dtwo.ExitClss;
   END;
  ELSIF Mode = rdm_Choice THEN
   Value:=GetSuitableObject(da,
                            D,
                            Dtwo.ExitClss,
                            Dtwo.Change,
                            Dtwo.TSN,
                            Dtwo.GuardTSN,
                            Dtwo.Sort,
                            Dtwo.BoxNbr,
                            GetObjectFreeCondition(da, Dtwo.ExitClss, Dtwo.TSN, Dtwo.BoxNbr, Dtwo.GuardTSN));
  END;
  SAVE(Dtwo);
  L_two.d_Replace(EMPTYOF(Mtwo.Mtwo), 1, D, L_two.d_ObtainObject(0, 1, D, da, Value, _Change), da, L_BegRWS.twosrc_Operator);
  RESTORE(Dtwo);
  D_SetCurDescription();
 END {Replace_Dtwo};

 PRIVATE PROCEDURE EmulateDtwoOnBeforeAskForEdit();
  VAR
   da   : L_two.tDailyAttribute;
   curFN: STRING[];
 BEGIN
  curFN:=RTI.Get().CurZone.ActiveField.Name;
  IF    curFN = "Dtwo.ExitClss" THEN da:=L_two.da_ExitClss;
  ELSIF curFN = "Dtwo.BoxNbr"   THEN da:=L_two.da_Car;
  ELSIF curFN = "Dtwo.TSN"      THEN da:=L_two.da_Driver;
  ELSIF curFN = "Dtwo.GuardTSN" THEN da:=L_two.da_Guard;
  ELSE                               SETEMPTY(da);
  END;
  IF ~!da THEN
   Replace_Dtwo(da, "", rdm_Choice);
  ELSE
   LIKEMENU(Ask, "");
  END;
 END {EmulateDtwoOnBeforeAskForEdit};

 PRIVATE PROCEDURE Mtwo_BoxNbr_OnSuccessfulChange();
  VAR
   Idx: NUMERIC[0];
 BEGIN
  Idx:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  MtwoAttrOnsuccessfulChange(L_two.da_Car, GE_PVALUE(), Idx);
  Mtwo_CheckCrew(Idx);
  MtwoE_PrepareSingleWinField(1, Idx);
  SetMtwoCurDescription();
 END {Mtwo_BoxNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE Mtwo_CooTSN_OnSuccessfulChange();
  VAR
   Idx: NUMERIC[0];
 BEGIN
  Idx:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  MtwoAttrOnsuccessfulChange(L_two.Who2CooDA(), GE_PVALUE(), Idx);
  IF ~!Mtwo.ExitClss[Idx] & ~!Mtwo.CooTSN[Idx] THEN
   SAVE(Mtwo);
   L_two.StandOnMtwo(Mtwo.CooTSN[Idx], L_two.Who2CooWho(), Mtwo.Per);
   Mtwo_CheckCrew(Idx);
   RESTORE(Mtwo);
  END;
  MtwoE_PrepareSingleWinField(1, Idx);
  SetMtwoCurDescription();
 END {Mtwo_CooTSN_OnSuccessfulChange};

 PRIVATE PROCEDURE filter_AddVal(VAR Result: STRING[]; Val: STRING[]);
 BEGIN
  IF ~!Result THEN
   Result:=Result + "&";
  END;
  Result:=Result + "(" + Val + ")";
 END {filter_AddVal};

 PRIVATE PROCEDURE filter_AddDsc(VAR Result: STRING[]; Dsc: STRING[]);
 BEGIN
  IF ~!Result THEN
   Result:=Result + ", ";
  END;
  Result:=Result + Dsc;
 END {filter_AddDsc};

 PRIVATE PROCEDURE D_SetCurFilter_Int(SetNormalFilter: SCAL[2]);
  VAR
   Value  : STRING[];
   trgZone: FORM_ZONE;
 BEGIN
  trgZone:=RTI.Get().CurZone;
  IF trgZone.Plane THEN
   trgZone:=trgZone.Window.ParentZone;
  END;
  SETEMPTY(Value, L_two.DtwoCurFilterDsc);
  IF SetNormalFilter THEN
   IF ~!L_two.DtwoCurDprt THEN
    filter_AddVal(Value,              "Dtwo.Dprt=" + L_two.DtwoCurDprt);
    filter_AddDsc(L_two.DtwoCurFilterDsc, "⤥ " + L_two.DtwoCurDprt);
   END;
   IF ~!L_two.DtwoCurSort THEN
    filter_AddVal(Value,            "Dtwo.Sort=" + L_two.DtwoCurSort);
    filter_AddDsc(L_two.DtwoCurFilterDsc, "ᥪ " + L_two.DtwoCurSort);
   END;
   IF ~!L_two.DtwoCurComplete THEN
    IF    L_two.DtwoCurComplete = 0 THEN
     filter_AddVal(Value,            "Dtwo.Complete=0");
    ELSIF L_two.DtwoCurComplete = 1 THEN
     filter_AddVal(Value,            "Dtwo.Complete#2");
    ELSIF L_two.DtwoCurComplete = 2 THEN
     filter_AddVal(Value,            "Dtwo.GuardOk#1");
    ELSIF L_two.DtwoCurComplete = 3 THEN
     filter_AddVal(Value,            "Dtwo.Complete=2");
    ELSE
     L_General.CallUs(0);
    END;
    filter_AddDsc(L_two.DtwoCurFilterDsc, L_Str.PoolItem("஡!|஫!|?|⮢!", L_two.DtwoCurComplete));
   END;
   IF ~!Value THEN
    Value:="&("+Value+")";
   END;
   IF ~!L_two.DtwoCurFilterDsc THEN
    L_two.DtwoCurFilterDsc:=Str.Cap(L_two.DtwoCurFilterDsc, 0, 1);
   END;
  END;
  trgZone.PermanentFilter:=L_Way.extCurPlaceFilter("Dtwo", Value);
  trgZone.Window.Zones(0).Fields("v_DtwoCurFilterDsc").Visible:=~!L_two.DtwoCurFilterDsc;
 END {D_SetCurFilter_Int};

 PRIVATE PROCEDURE D_SetCurFilter();
 BEGIN
  D_SetCurFilter_Int(1);
 END {D_SetCurFilter};

 PUBLIC PROCEDURE ResetAllDtwoFilters();
 BEGIN
  SETEMPTY(L_two.DtwoCurSort, L_two.DtwoCurDprt, L_two.DtwoCurComplete);
  D_SetCurFilter();
 END {ResetAllDtwoFilters};

 PRIVATE PROCEDURE Dtwo_1_OnZoneOpen();
 BEGIN
  L_WDO.SetFieldFormat("Dtwo.Change", L_BegRWS.wh_Pool);
  L_WDO.SetFieldFormat("IsLinkWithRWayS", "|-");
  IF ~L_General.VariableIsInitialized(L_two.DtwoCurSort) THEN
   ResetAllDtwoFilters();
  ELSE
   D_SetCurFilter();
  END;
 END {Dtwo_1_OnZoneOpen};

 PRIVATE PROCEDURE DtwoE_0_OnReposition();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  D_SetCurDescription();
  v_D_Message:=L_lsStore.Get(Dtwo.Message);
  IF !Dtwo.RWayS THEN
   asDtwoRWayS:=MAXOF(Dtwo.RWayS);
  ELSE
   asDtwoRWayS:=Dtwo.RWayS;
  END;
  Fields:=RTI.Get().CurZone.Fields;
  Fields(L_Str.Var_wIdx("Dtwo.HldOff", L_two.who_Driver)).Visible:=~!Dtwo.TSN      & L_two.E_IsHolidayDayType(Dtwo.TSN,      Dtwo.Date);
  Fields(L_Str.Var_wIdx("Dtwo.HldOff", L_two.who_Guard )).Visible:=~!Dtwo.GuardTSN & L_two.E_IsHolidayDayType(Dtwo.GuardTSN, Dtwo.Date);
  Fields("Dtwo.BR_Drv").Visible:=Dtwo.BR_Drv;
  Fields("Dtwo.BR_Car").Visible:=Dtwo.BR_Car;
 END {DtwoE_0_OnReposition};

 PRIVATE PROCEDURE Dtwo_0_SetFirstField(da: L_two.tDailyAttribute);
 BEGIN
  L_WDO.SetFieldFirst("Dtwo.ExitClss", da=L_two.da_ExitClss);
  L_WDO.SetFieldFirst("Dtwo.TSN",      da=L_two.da_Driver);
  L_WDO.SetFieldFirst("Dtwo.BoxNbr",   da=L_two.da_Car);
  L_WDO.SetFieldFirst("Dtwo.GuardTSN", da=L_two.da_Guard);
 END {Dtwo_0_SetFirstField};

 PRIVATE PROCEDURE Dtwo_OnBeforeEdIns();
 BEGIN
  TRY
   L_two.Renovate(L_DatTim.Per(Dtwo.Date), L_two.rm_AutoD);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_NoRecordAfterRESTORE THEN
    L_General.Error(" ࠢ  ந諨 ." +
                    "| 믮  鸞");
   ELSE
    RAISE();
   END;
  END; (* TRY *)
  IF    !Dtwo.ExitClss THEN Dtwo_0_SetFirstField(L_two.da_ExitClss);
  ELSIF !Dtwo.TSN      THEN Dtwo_0_SetFirstField(L_two.da_Driver);
  ELSIF !Dtwo.BoxNbr   THEN Dtwo_0_SetFirstField(L_two.da_Car);
  ELSIF !Dtwo.GuardTSN THEN Dtwo_0_SetFirstField(L_two.da_Guard);
  ELSE
   Dtwo_0_SetFirstField(L_two.da_Driver);
  END;
 END {Dtwo_OnBeforeEdIns};

 PRIVATE PROCEDURE Dtwo_OnBeforeEdit();
  VAR
   Msg: STRING[];
 BEGIN
  L_General.Assert(Dtwo.Date >= L_two.FirstModifiableDay(), "஢ 冷    饭");
  IF ~!Dtwo.RWayS THEN
   Msg:="  㦥 ନ஢  " + Dtwo.RWayS;
   IF L_XDoc.XDoc_wo_Handicraft(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, Dtwo.RWayS) THEN
    L_StdFrm.Choice(Msg);
   ELSE
    L_General.Error(Msg + "||" + "  ஢,  鸞 饭!");
   END;
  END;
  Dtwo_OnBeforeEdIns();
 END {Dtwo_OnBeforeEdit};

 PRIVATE PROCEDURE Dtwo_OnBeforeInsert();
 BEGIN
  L_General.Error("⠢ 饭");
 END {Dtwo_OnBeforeInsert};

 PRIVATE PROCEDURE Dtwo_OnBeforeDelete();
 BEGIN
  L_General.Error(" 饭");
 END {Dtwo_OnBeforeDelete};

 PUBLIC PROCEDURE Dtwo_RemoveEmptyAfterEdIns(D: DATE; trgDtwo: LIKE(Dtwo.Dtwo));
 BEGIN
  IF ACCESS(Dtwo) & (Dtwo.Date = D) & (Dtwo.Dtwo = trgDtwo) THEN
   INTEGRITY(NoAsk);
   REMOVE(Dtwo);
  END;
  D_SetCurFilter();
 END {Dtwo_RemoveEmptyAfterEdIns};

 PRIVATE PROCEDURE Dtwo_OnAfterEdIns();
 BEGIN
  IF ~L_two.d_c_IsEmpty() THEN
   Dtwo.Message:=L_lsStore.Replace(Dtwo.Message, v_D_Message);
   REPLACE(Dtwo);
   L_two.d_c_FillDependent();
   IF    ~!Dtwo.RWayS THEN
    L_two.DtwoBindRWayS();
   ELSIF ~!Dtwo.ExitClss THEN
    L_BegRWS.E_CheckCrewInTWOEdit(Dtwo.Date, Dtwo.TSN, Dtwo.BoxNbr, Dtwo.Exit, Dtwo.GuardTSN);
   END;
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    SE_WZD_POSITION(RTI.Get().CurWindow.ParentZone.Window.Name, 1, Dtwo);
   EXCEPT
   ON Exc:Exc_Root DO
    IF Exc.ErrorCode = L_General.ec_rt_PosOutOfZoneSystemSelect THEN
     IF !L_two.DtwoCurComplete THEN
      TOOLTIP("ப 筮 鸞 ⠫ 㤮⢮ ᫮ 䨫.  ");
      D_SetCurFilter_Int(0);
      TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
       SE_WZD_POSITION(RTI.Get().CurWindow.ParentZone.Window.Name, 1, Dtwo);
      EXCEPT
      ON Exc:Exc_Root DO
      END;
     END;
    ELSE
     RAISE();
    END;
   END; (* TRY *)
  ELSE
   L_General.Assert(!v_D_Message, " '饭 ⥫'");
   L_General.Assert(!Dtwo.RWayS,  " ப 鸞 㦥 ନ஢ ⥢ ");
   D_SetCurFilter_Int(0);
   TOOLTIP("ப 筮 鸞 㤠");
   LIKEMENU(CALL, "two.Dtwo_RemoveEmptyAfterEdIns(" + FLDTOSTR(Dtwo.Date) + ", " + Dtwo.Dtwo + ")")
  END;
 END {Dtwo_OnAfterEdIns};

 PRIVATE PROCEDURE Dtwo_OnAfterEdit();
 BEGIN
  Dtwo_OnAfterEdIns();
 END {Dtwo_OnAfterEdit};

 PRIVATE PROCEDURE Dtwo_OnAfterInsert();
 BEGIN
  Dtwo_OnAfterEdIns();
 END {Dtwo_OnAfterInsert};

 PRIVATE PROCEDURE DtwoStaffOnSuccessfulChange(da  : L_two.tDailyAttribute;
                                               _TSN: LIKE(Staff.TSN));
  VAR
   _Who: L_two.tTWOWho;
 BEGIN
  Replace_Dtwo(da, _TSN, rdm_SuccessfulChange);
  IF da = L_two.da_Driver THEN
   _Who:=L_two.who_Driver;
  ELSE
   _Who:=L_two.who_Guard;
  END;
  IF ~!_TSN THEN
   L_two.StandOnMtwo(_TSN, _Who, L_DatTim.Per(Dtwo.Date));
   Dtwo.HldOff[_Who]:=Mtwo.HldOff[L_two.Date2Idx(Dtwo.Date)];
   REPLACE(Dtwo);
   L_WDO.SetFieldVisible(L_Str.Var_wIdx("Dtwo.HldOff", _Who),
                         L_two.E_IsHolidayDayType(_TSN, Dtwo.Date));
  ELSE
   Dtwo.HldOff[_Who]:=0;
   REPLACE(Dtwo);
   L_WDO.SetFieldVisible(L_Str.Var_wIdx("Dtwo.HldOff", _Who), 0);
  END;
 END {DtwoStaffOnSuccessfulChange};

 PUBLIC PROCEDURE Dtwo_BR_Drv_Switch(On: SCAL[2]);
 BEGIN
  IF On THEN
   IF ~Dtwo.BR_Drv THEN
    L_AcsPnt.PassAccessPoint(0000065);
    IF ~!Dtwo.TSN THEN
     L_General.Error("砫 ⠭ ' ࠢ',  ⮬ 㪠 ⥫");
    END;
   ELSE
    TOOLTIP(" ' ࠢ'");
   END;
  END;
  Dtwo.BR_Drv:=On;
  REPLACE(Dtwo);
  RTI.Get().CurZone.Fields("Dtwo.BR_Drv").Visible:=Dtwo.BR_Drv;
 END {Dtwo_BR_Drv_Switch};

 PUBLIC PROCEDURE Dtwo_BR_Car_Switch(On: SCAL[2]);
 BEGIN
  IF On THEN
   IF ~Dtwo.BR_Car THEN
    L_AcsPnt.PassAccessPoint(0000066);
    IF ~!Dtwo.BoxNbr THEN
     L_General.Error("砫 ⠭ ' ࠢ',  ⮬ 㪠 ");
    END;
   ELSE
    TOOLTIP(" ' ࠢ'");
   END;
  END;
  Dtwo.BR_Car:=On;
  REPLACE(Dtwo);
  RTI.Get().CurZone.Fields("Dtwo.BR_Car").Visible:=Dtwo.BR_Car;
 END {Dtwo_BR_Car_Switch};

 PRIVATE PROCEDURE Dtwo_TSN_OnSuccessfulChange();
  VAR
   _BoxNbr: LIKE(Car.BoxNbr);
 BEGIN
  IF ~Dtwo.BR_Drv THEN
   DtwoStaffOnSuccessfulChange(L_two.da_Driver, Dtwo.TSN);
   IF ~!Dtwo.TSN THEN
    L_two.StandOnMtwo(Dtwo.TSN, L_two.who_Driver, L_DatTim.Per(Dtwo.Date));
    TRY
     SAVE(Dtwo);
     _BoxNbr:=L_two.m_GF_BoxNbr(Dtwo.Date, Dtwo.ExitClss, Dtwo.Change);
     RESTORE(Dtwo);
     IF ~!_BoxNbr & (_BoxNbr # Dtwo.BoxNbr) THEN
      IF ~!Dtwo.BoxNbr THEN
       L_StdFrm.Question(" ९  ⥫ .  ?");
      END;
      Replace_Dtwo(L_two.da_Car, _BoxNbr, rdm_SetValue);
     END;
    EXCEPT
    ON Exc: Exc_Root DO
     (* silent *)
    END; (* TRY *)
   ELSIF ~!Dtwo.BoxNbr & ~L_two.E_IsCarIntrinsicExitClss(Dtwo.ExitClss) THEN
    TRY
     L_StdFrm.Question("᢮ ࠭ᯮ⭮ ।⢮?");
     Replace_Dtwo(L_two.da_Car, "", rdm_SetValue);
    EXCEPT
    ON Exc: Exc_Root DO
     (* silent *)
    END; (* TRY *)
   END;
  ELSIF !Dtwo.TSN THEN
   Dtwo_BR_Drv_Switch(0);
  END; (* IF ~Dtwo.BR_Drv *)
 END {Dtwo_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE Dtwo_GuardTSN_OnSuccessfulChange();
 BEGIN
  DtwoStaffOnSuccessfulChange(L_two.da_Guard, Dtwo.GuardTSN);
 END {Dtwo_GuardTSN_OnSuccessfulChange};

 PRIVATE PROCEDURE Dtwo_BoxNbr_OnSuccessfulChange();
 BEGIN
  IF ~Dtwo.BR_Car THEN
   Replace_Dtwo(L_two.da_Car, Dtwo.BoxNbr, rdm_SuccessfulChange);
  ELSIF !Dtwo.BoxNbr THEN
   Dtwo_BR_Car_Switch(0);
  END;
 END {Dtwo_BoxNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE Dtwo_ExitClss_OnSuccessfulChange();
 BEGIN
  Replace_Dtwo(L_two.da_ExitClss, Dtwo.ExitClss, rdm_SuccessfulChange);
 END {Dtwo_ExitClss_OnSuccessfulChange};

 PRIVATE PROCEDURE Dtwo_Change_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!Dtwo.Change, "     ");
  IF ~!Dtwo.ExitClss THEN
   L_General.Assert(L_two.StandOnExit(Dtwo.ExitClss, Dtwo.Change, Dtwo.Date, 0),
                    " ᬥ  ᮣᮢ  㪠 ᮬ 室");
   Replace_Dtwo(L_two.da_What, Dtwo.Change, rdm_SuccessfulChange);
  ELSE
   L_two.d_c_UpdateMtwo(EMPTYOF(Mtwo.Mtwo), L_BegRWS.twosrc_Operator);
  END;
 END {Dtwo_Change_OnSuccessfulChange};

 PRIVATE PROCEDURE Dtwo_HldOff_OnSuccessfulChange();
  VAR
   _TSN: LIKE(Staff.TSN);
   _Who: L_two.tTWOWho;
 BEGIN
  IF RTI.Get().CurZone.ActiveField.ArrayIndex = L_two.who_Driver THEN
   _TSN:=Dtwo.TSN;
   _Who:=L_two.who_Driver;
  ELSE
   _TSN:=Dtwo.GuardTSN;
   _Who:=L_two.who_Guard;
  END;
  L_two.StandOnMtwo(_TSN, _Who, L_DatTim.Per(Dtwo.Date));
  Mtwo.HldOff[L_two.Date2Idx(Dtwo.Date)]:=Dtwo.HldOff[_Who];
  REPLACE(Mtwo);
 END {Dtwo_HldOff_OnSuccessfulChange};

 PRIVATE PROCEDURE Dtwo_MnlTmSet_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!Dtwo.ExitClss, "  室");
  IF ~Dtwo.MnlTmSet THEN
   L_two.PositionOnExit(Dtwo.ExitClss, Dtwo.Change, Dtwo.Date);
   Dtwo.BegDay :=StExit.BegDay;
   Dtwo.BegTime:=StExit.BegTime;
   Dtwo.EndTime:=StExit.StopTim;
   REPLACE(Dtwo);
  END;
  D_SetCurDescription();
 END {Dtwo_MnlTmSet_OnSuccessfulChange};

 PRIVATE PROCEDURE Dtwo_BegDay_OnSuccessfulChange();
 BEGIN
  L_General.Assert((Dtwo.BegDay >= 1) & (Dtwo.BegDay <= 2), " 砫   01  02");
  D_SetCurDescription();
 END {Dtwo_BegDay_OnSuccessfulChange};

 PRIVATE PROCEDURE Dtwo_BegTime_OnSuccessfulChange();
 BEGIN
  D_SetCurDescription();
 END {Dtwo_BegTime_OnSuccessfulChange};

 PRIVATE PROCEDURE Dtwo_EndTime_OnSuccessfulChange();
 BEGIN
  D_SetCurDescription();
 END {Dtwo_EndTime_OnSuccessfulChange};

 PRIVATE PROCEDURE Dtwo_v_D_Message_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!Dtwo.TSN, " ⥫");
 END {Dtwo_v_D_Message_OnSuccessfulChange};

 PUBLIC PROCEDURE ChooseDtwoCurSort();
  VAR
   i,
   c      : NUMERIC[0];
   Sorts  : LIKE(Sort.Sort)[256];
   List   : STRING[];
   _Sort  : LIKE(Sort.Sort);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  IF ACCESS(Dtwo) THEN
   _Sort:=Dtwo.Sort;
  ELSE
   SETEMPTY(_Sort);
  END;
  List:=" 䨫" + "|";
  i:=1;
  c:=0;
  SELECT(Dtwo, DSort, , Memo.ud_cd());
  WHILE OCCURE(Dtwo) DO
   IF ~!Dtwo.Sort THEN
    SEARCH(Sort, Sort, , Dtwo.Sort);
    IF !L_two.DtwoCurDprt | (L_Staff.getSortDprt(Sort.Sort) = L_two.DtwoCurDprt) THEN
     List:=List + Sort.Sort + " " + Str.Align(Sort.Name, 32, LEFT) + " / " + Str.Align(L_Staff.getSortDprtName(Sort.Sort), 32, LEFT) + "|";
     Sorts[i]:=Sort.Sort;
     IF Sort.Sort = _Sort THEN
      c:=i;
     END;
     INC(i);
    END;
   END;
   NARROWSEL(Dtwo, Dprt, Sort);
   NEXTINEXTENDEDSEL(Dtwo, Dprt, Sort);
  END; (* WHILE OCCURE(Dtwo) ... *)
  c:=L_StdFrm.ShowListAsMenu_wInit(List, "롮 ⥪饣 ᥪ", c);
  IF c = 0 THEN
   SETEMPTY(L_two.DtwoCurSort);
  ELSE
   L_two.DtwoCurSort:=Sorts[c];
  END;
  D_SetCurFilter();
 END {ChooseDtwoCurSort};

 PUBLIC PROCEDURE ChooseMtwoCurSort();
  VAR
   i,
   c      : NUMERIC[0];
   Sorts  : LIKE(Sort.Sort)[256];
   List   : STRING[];
   _Sort  : LIKE(Sort.Sort);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  IF ACCESS(Mtwo) THEN
   _Sort:=Mtwo.Sort;
  ELSE
   SETEMPTY(_Sort);
  END;
  List:=" 䨫" + "|";
  i:=1;
  c:=0;
  SELECT(Mtwo, PSort, , Memo.ud_mb());
  WHILE OCCURE(Mtwo) DO
   IF ~!Mtwo.Sort THEN
    CONFORM(Mtwo, Sort);
    IF !L_two.MtwoCurDprt | (L_Staff.getSortDprt(Sort.Sort) = L_two.MtwoCurDprt) THEN
     List:=List + Sort.Sort + " " + Str.Align(Sort.Name, 32, LEFT) + " / " + Str.Align(L_Staff.getSortDprtName(Sort.Sort), 32, LEFT) + "|";
     Sorts[i]:=Sort.Sort;
     IF Sort.Sort = _Sort THEN
      c:=i;
     END;
     INC(i);
    END;
   END;
   NARROWSEL(Mtwo, Dprt, Sort);
   NEXTINEXTENDEDSEL(Mtwo, Dprt, Sort);
  END; (* WHILE OCCURE(Mtwo) ... *)
  c:=L_StdFrm.ShowListAsMenu_wInit(List, "롮 ⥪饣 ᥪ", c);
  IF c = 0 THEN
   SETEMPTY(L_two.MtwoCurSort);
  ELSE
   L_two.MtwoCurSort:=Sorts[c];
  END;
  M_SetCurFilter();
 END {ChooseMtwoCurSort};

 PUBLIC PROCEDURE ChoooseDtwoCurDepart();
  VAR
   i,
   c      : NUMERIC[0];
   Dprts  : LIKE(Sort.Sort)[256];
   List   : STRING[];
   curDprt: LIKE(Sort.Sort);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  IF ACCESS(Dtwo) THEN
   curDprt:=Dtwo.Dprt;
  ELSE
   SETEMPTY(curDprt);
  END;
  List:=" 䨫" + "|";
  i:=1;
  c:=0;
  SELECT(Dtwo, DSort, , Memo.ud_cd());
  WHILE OCCURE(Dtwo) DO
   IF ~!Dtwo.Dprt THEN
    SEARCH(Sort, Sort, , Dtwo.Dprt);
    List:=List + Sort.Sort + " " + Str.Align(Sort.Name, 32, LEFT) + "|";
    Dprts[i]:=Sort.Sort;
    IF Sort.Sort = curDprt THEN
     c:=i;
    END;
    INC(i);
   END;
   NARROWSEL(Dtwo, Dprt);
   NEXTINEXTENDEDSEL(Dtwo, Dprt);
  END; (* WHILE OCCURE(Dtwo) ... *)
  c:=L_StdFrm.ShowListAsMenu_wInit(List, "롮 ⥪饣 ⤥", c);
  IF c = 0 THEN
   SETEMPTY(L_two.DtwoCurDprt);
  ELSE
   L_two.DtwoCurDprt:=Dprts[c];
   SETEMPTY(L_two.DtwoCurSort);
  END;
  D_SetCurFilter();
 END {ChoooseDtwoCurDepart};

 PUBLIC PROCEDURE ChooseMtwoCurWho();
  VAR
   c: NUMERIC[0];
 BEGIN
  IF ACCESS(Mtwo) THEN
   c:=Mtwo.Who + 1;
  ELSE
   c:=0;
  END;
  c:=L_StdFrm.ShowListAsMenu_wInit(" 䨫|⥫|", " ⡮  '' ", c);
  IF c = 0 THEN
   SETEMPTY(L_two.MtwoCurWho);
  ELSE
   L_two.MtwoCurWho:=c-1;
  END;
  M_SetCurFilter();
 END {ChooseMtwoCurWho};

 PUBLIC PROCEDURE ChooseMtwoCurDepart();
  VAR
   i,
   c      : NUMERIC[0];
   Dprts  : LIKE(Sort.Sort)[256];
   List   : STRING[];
   curDprt: LIKE(Sort.Sort);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  IF ACCESS(Mtwo) THEN
   curDprt:=Mtwo.Dprt;
  ELSE
   SETEMPTY(curDprt);
  END;
  List:=" 䨫" + "|";
  i:=1;
  c:=0;
  SELECT(Mtwo, PSort, , Memo.ud_mb());
  WHILE OCCURE(Mtwo) DO
   NARROWSEL(Mtwo, Dprt);
   IF ~!Mtwo.Dprt THEN
    SEARCH(Sort, Sort, , Mtwo.Dprt);
    List:=List + Sort.Sort + " " + Str.Align(Sort.Name, 32, LEFT) + "|";
    Dprts[i]:=Sort.Sort;
    IF Sort.Sort = curDprt THEN
     c:=i;
    END;
    INC(i);
   END;
   NEXTINEXTENDEDSEL(Mtwo, Dprt);
  END; (* WHILE OCCURE(Mtwo) ... *)
  c:=L_StdFrm.ShowListAsMenu_wInit(List, "롮 ⥪饣 ⤥", c);
  IF c = 0 THEN
   SETEMPTY(L_two.MtwoCurDprt);
  ELSE
   L_two.MtwoCurDprt:=Dprts[c];
   SETEMPTY(L_two.MtwoCurSort);
  END;
  M_SetCurFilter();
 END {ChooseMtwoCurDepart};

 PUBLIC PROCEDURE ChooseDtwoCurComplete();
  VAR
   c   : NUMERIC[0];
   List: STRING[];
 BEGIN
  List:=" 䨫| । 室,  ⥫,  |ॡ ஫|冷  ࠬ| ⮢ ப 鸞";
  c:=L_StdFrm.ShowListAsMenu_wInit(List, "⡮  ﭨ ப 鸞", 0);
  IF c = 0 THEN
   SETEMPTY(L_two.DtwoCurComplete);
  ELSE
   L_two.DtwoCurComplete:=c-1;
  END;
  D_SetCurFilter();
 END {ChooseDtwoCurComplete};

 PRIVATE PROCEDURE DefinePtwo();
  VAR
   Idx,
   i        : NUMERIC[0];
   D        : DATE;
   Dir      : SCAL[2];
   _CycleLen: LIKE(Ptwo.CycleLen);
   FormStr  : STRING[];
 BEGIN
  Idx:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  D:=L_two.Idx2Date(Idx, Mtwo.Per);
  Dir:=0;
  _CycleLen:=4;
  FormStr:="%<|।>I%<>I" +
            "%< 믮 >DB" +
            "%< ⬥ >X" +
            "@" +
            "|" +
            "ନ ९  " + L_DatTim.DateStr(D) + " %######%  横 %##%" +
            "|" +
            "|  %###########%  %##########%  ";

  LOOP
   IF STDFORM(L_StdFrm.PartForm(FormStr),
              " ଫ ९  ᭮ 鸞 ", , 1, Dir, _CycleLen) THEN
    TRY
     IF Dir = 0 THEN
      L_General.Assert((D-(_CycleLen-1)) >= L_DatTim.Per(D), " 稭  砫 ");
      DEC(D, (_CycleLen-1));
     ELSE
      L_General.Assert((D+(_CycleLen-1)) <= L_DatTim.MonthEnd(D), " 稢 ᫥  ");
     END;
     SETSEL(Ptwo, TSN, Mtwo.TSN);
     IF LAST(Ptwo) THEN
      L_General.Assert(Ptwo.Date <= D,
                       " ࠡ⭨ " + Mtwo.TSN + " 㦥  ९, ଫ " + L_DatTim.DateStr(Ptwo.Date));
      IF Ptwo.Date = D THEN
       REMOVE(Ptwo);
      END;
     END;
     EXIT;
    EXCEPT
    ON Exc: Exc_Raise DO
     L_StdFrm.RedInform(Exc.MsgOriginalText);
    ELSE
     RAISE();
    END; (* TRY *)
   END;
  END; (* LOOP *)
  DEFAULT(Ptwo);
  Ptwo.TSN     :=Mtwo.TSN;
  Ptwo.Date    :=D;
  Ptwo.CycleLen:=_CycleLen;
  Ptwo.Who     :=Mtwo.Who;
  i:=0;
  Idx:=L_two.Date2Idx(D);
  WHILE i < _CycleLen DO
   Ptwo.What[i]    :=Mtwo.What[Idx];
   Ptwo.ExitClss[i]:=Mtwo.ExitClss[Idx];
   Ptwo.BoxNbr[i]  :=Mtwo.BoxNbr[Idx];
   Ptwo.CooTSN[i]  :=Mtwo.CooTSN[Idx];
   INC(i);
   INC(Idx);
  END;
  INSERT(Ptwo);
 END {DefinePtwo};

 PRIVATE PROCEDURE MtwoFillByCycle();
  VAR
   Idx,
   i,
   EndIdx,
   cFirstIdx: NUMERIC[0];
   D        : DATE;
   cFrom,
   cUpTo    : NUMERIC[0];
   FormStr  : STRING[];
 BEGIN
  Idx  :=RTI.Get().CurZone.ActiveField.ArrayIndex;
  D    :=L_two.Idx2Date(Idx, Mtwo.Per);
  cUpTo:=L_DatTim.DAY(D)-1;
  cFrom:=cUpTo-3;
  FormStr:="%<D>I" +
           "%<D>I" +
           "%< 믮 >DB" +
           "%< ⬥ >X" +
           "@" +
           "|" +
           " , 稭  " + L_DatTim.DateStr(D) + "  横  %##%  %##%" +
           "|" +
           "|  %###########%  %##########%  ";

  LOOP
   IF STDFORM(L_StdFrm.PartForm(FormStr),
              "  鸞  ᭮ 横 ", , 1,
               cFrom, cUpTo) THEN
    TRY
     L_General.Assert((cUpTo - cFrom) > 0, " , 祬 2?");
     L_General.Assert(cUpTo < L_DatTim.DAY(D), "  横    " + FLDTOSTR(D, "D", 2));
     EXIT;
    EXCEPT
    ON Exc: Exc_Raise DO
     L_StdFrm.RedInform(Exc.MsgOriginalText);
    ELSE
     RAISE();
    END; (* TRY *)
   END;
  END; (* LOOP *)
  cFirstIdx:=L_two.Date2Idx(Mtwo.Per+cFrom-1);
  i        :=0;
  EndIdx:=L_two.Date2Idx(L_DatTim.MonthEnd(Mtwo.Per));
  WHILE Idx <= EndIdx DO
   PROMPT(" " + L_DatTim.DateStr(L_two.Idx2Date(Idx, Mtwo.Per)));
   L_General.Error(" ஥");
   IF Mtwo.Source[Idx] # L_BegRWS.twosrc_System THEN
    L_two.m_FillSingleDay(Mtwo.What[i+cFirstIdx],
                          L_BegRWS.twosrc_Operator,
                          Mtwo.ExitClss[i+cFirstIdx],
                          Mtwo.CooTSN[i+cFirstIdx],
                          Mtwo.BoxNbr[i+cFirstIdx],
                          Idx,
                          1);
   END;
   INC(Idx);
   i:=(i + 1) MOD (cUpTo-cFrom+1);
  END; (* WHILE Idx < *)
  MtwoE_PrepareWinField();
 END {MtwoFillByCycle};

 PRIVATE PROCEDURE MtwoFillAsYesterday();
  VAR
   Idx: NUMERIC[0];
   _ExitClss,
   _CooTSN,
   _BoxNbr    : STRING[];
 BEGIN
  Idx:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  IF L_two.Idx2Date(Idx, Mtwo.Per) > Mtwo.Per THEN
   _ExitClss:=L_two.m_c_GetAttr(L_two.da_ExitClss, Idx-1);
   _CooTSN  :=L_two.m_c_GetAttr(L_two.da_CooTSN,   Idx-1);
   _BoxNbr  :=L_two.m_c_GetAttr(L_two.da_Car,      Idx-1);
   IF Mtwo.Who = L_two.who_Guard THEN
    IF    ~!_ExitClss THEN
     _CooTSN:=L_two.NeverFixing;
     _BoxNbr:=L_two.NeverFixing;
    ELSIF ~!_CooTSN   THEN
     _BoxNbr:=L_two.NeverFixing;
    END;
   END;
   L_two.m_FillSingleDay(L_two.m_c_GetAttr(L_two.da_What, Idx-1),
                         L_BegRWS.twosrc_Operator,
                         _ExitClss,
                         _CooTSN,
                         _BoxNbr,
                         Idx);
   MtwoE_PrepareSingleWinField(1, Idx);
  END;
 END {MtwoFillAsYesterday};

 PRIVATE PROCEDURE MtwoFillByPtwo();
  VAR
   Idx,
   EndIdx,
   i       : NUMERIC[0];
   D       : DATE;
 BEGIN
  Idx:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  D  :=L_two.Idx2Date(Idx, Mtwo.Per);
  L_General.Assert(L_two.Ptwo_StandOn(Mtwo.TSN, D), " " + L_DatTim.DateStr(D) + " ९  ।");
  i:=(D - Ptwo.Date) MOD Ptwo.CycleLen;
  EndIdx:=L_two.Date2Idx(Mtwo.Per) + L_DatTim.MonthLen(Mtwo.Per) - 1;
  WHILE Idx <= EndIdx DO
   PROMPT(" " + L_DatTim.DateStr(L_two.Idx2Date(Idx, Mtwo.Per)));
   L_General.Error(" ஥");
   IF Mtwo.Source[Idx] # L_BegRWS.twosrc_System THEN
    L_two.m_FillSingleDay(Ptwo.What[i],
                          L_BegRWS.twosrc_Operator,
                          Ptwo.ExitClss[i],
                          Ptwo.CooTSN[i],
                          Ptwo.BoxNbr[i],
                          Idx,
                          1);
   END;
   INC(Idx);
   i:=(i + 1) MOD Ptwo.CycleLen;
  END; (* WHILE Idx < *)
  MtwoE_PrepareWinField();
 END {MtwoFillByPtwo};


 PRIVATE PROCEDURE SetWZDPosition(File: STRING[]; ProcToResetFilter: PROC);
  VAR
   trgDate   : DATE;
   trgMyPlace: LIKE(MyPlace.MyPlace);
 BEGIN
  trgMyPlace:=^(TABLE.Get(File).Fields("MyPlace").ObtainName());
  IF (trgMyPlace # P_Firm.mp_Fict) & ((trgMyPlace < P_Firm.minMyPlace) | (trgMyPlace > P_Firm.maxMyPlace)) THEN
   IF    File = "Mtwo" THEN
    trgDate:=Mtwo.Per;
   ELSIF File = "Dtwo" THEN
    trgDate:=Dtwo.Date;
   ELSE
    L_General.CallUs(0);
   END;
   L_StdFrm.BlueHalt("⭨ " + ^(TABLE.Get(File).Fields("TSN").ObtainName()) + "  " + L_DatTim.DateStr(trgDate) +
                     " ⭮  㣮 ந⢥ 頤.|" +
                     "騬 ⠭ 㣮 ࠡ⭨");
  END;
  TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   SE_WZD_POSITION(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number, ^File);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF (Exc.ErrorCode = L_General.ec_rt_PosOutOfZoneSystemSelect) |
      (Exc.ErrorCode = L_General.ec_rt_PosOutOfZoneFilter)       |
      (Exc.ErrorCode = L_General.ec_rt_PosOutOfZoneUserSelect)   THEN
    ProcToResetFilter();
    SE_WZD_POSITION(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number, ^File);
   ELSE
    RAISE();
   END;
  END; (* TRY *)
 END {SetWZDPosition};

 PRIVATE PROCEDURE Dtwo_GuardTSN_OnAskForViewPhase1();
 BEGIN
  IF ACCESS(Dtwo) & ~!Dtwo.GuardTSN & SEARCH(Staff, TSN, Dtwo.GuardTSN) THEN
   SE_WZD_POSITION(RTI.Get().TrgWindow.Name, RTI.Get().TrgZone.Number, Staff);
  END;
 END {Dtwo_GuardTSN_OnAskForViewPhase1};

 PRIVATE PROCEDURE Dtwo_GuardTSN_OnAskForViewPhase2();
 BEGIN
  IF ACCESS(Staff) & SELECT(Dtwo, DGuardTSN, Memo.ud_cd(), Staff.TSN) THEN
   SetWZDPosition("Dtwo", PROCREF(ResetAllDtwoFilters));
  ELSE
   L_StdFrm.Inform("  拉  " + L_DatTim.DateStr(Memo.ud_cd()));
  END;
 END {Dtwo_GuardTSN_OnAskForViewPhase2};

 PRIVATE PROCEDURE BindCWOrder();
 BEGIN
  IF !Dtwo.RWayS THEN
   L_StdFrm.Choice(" 뢠 ப 鸞   室 ନ ");
   L_General.Assert(~!Dtwo.ExitClss & ~!Dtwo.TSN & ~!Dtwo.BoxNbr,
                    "室 㪠  ࠩ "+
                    "|" +
                    " 室, ⥫  ࠭ᯮ⭮ ।⢮");
   L_two.DtwoBindRWayS();
   asDtwoRWayS:=Dtwo.RWayS;
  END;
  LIKEMENU(Ask, "CWOrder 1 " + L_Events.ee_ProcessId + "=BindToRWayS");
 END {BindCWOrder};

 PRIVATE PROCEDURE UnbindRWayS(Stream: SCAL[2]);
 BEGIN
  IF ~!Dtwo.RWayS THEN
   IF ~Stream THEN
    L_StdFrm.Choice(" ନ஢  ப 鸞 ");
   END;
   L_two.PositionOnDtwoRWayS();
   IF L_XDoc.XDoc_wo_Handicraft(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS) THEN
    L_BegRWS.REMOVE_RWayS(Stream, 1);
   ELSE
    IF ~Stream THEN
     L_General.Error(", ନ஢  ப 鸞 ஢."+
                     "|஡ 㤠   ࠧ浪 묨 ।⢠");
    END;
   END;
  ELSE
   L_StdFrm.Inform(" ப 鸞  ନ஢ ");
  END;
 END {UnbindRWayS};

 PRIVATE PROCEDURE brws_AddSpecialRWayS(D: DATE; _Exit: LIKE(StExit.Exit); _MyFirm: P_Firm.tMyFirm);
 BEGIN
  IF ~!_Exit & ~SELECT(RWayS, Exit, _Exit, D) THEN
   DEFAULT(RWayS);
   RWayS.Date    :=D;
   RWayS.TSN     :=L_Env.fictTSN;
   RWayS.BoxNbr  :=L_Car.E_GetFictiveBoxNbr(_MyFirm);
   RWayS.Exit    :=_Exit;
   RWayS.Status  :=L_Way.rwsStat_Ordered;
   L_BegRWS.INSERT_RWayS();
   L_BegRWS.SetExitData();
   L_Way.CurRWayS_XDocJrn_Mark(L_XDoc.action_AutoBuild);
  END;
 END {brws_AddSpecialRWayS};

 PUBLIC PROCEDURE BuildRWayS();
  VAR
   D: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(Dtwo);
  D:=Dtwo.Date;
  L_General.Assert(D >= L_BegRWS.DspSysDate(), "ନ஢ ⥢ ⮢    饭");
  L_two.D_ConfirmOnDtwo("ନ஢ ⥢   " + L_DatTim.DateStr(D), 0);
  brws_AddSpecialRWayS(D, L_Way.E_GuardReserveExit(D), P_Firm.mf_Own);
  brws_AddSpecialRWayS(D, L_Way.E_GuardOutageExit(D), P_Firm.mf_Own);
  CHANGESEL(Dtwo, Dtwo, , Dtwo.Date);
  FIRST(Dtwo);
  WHILE OCCURE(Dtwo) DO
   PROMPT("ନ஢ ⥢ ⮢: " + Str.Small(L_two.DtwoStr()));
   IF !Dtwo.RWayS & L_two.d_c_FitToFilter() THEN
    IF L_two.NeedBuildRWaySByDtwo() THEN
     TRY
      L_two.DtwoBindRWayS();
     EXCEPT
     ON Exc: Exc_Root DO
      L_StdFrm.RedInform("ନ஢ ⥢   ப 鸞" +
                         "|" + L_two.DtwoStr() +
                         "|" + " 믮.  ᫥ ஡:" +
                         "||" + Exc.MsgOriginalText +
                         "||" + "ନ஢  㤥 த");
     END; (* TRY *)
    END;
   END;
   NEXT(Dtwo);
  END;
 END {BuildRWayS};

 PUBLIC PROCEDURE RemoveRWayS();
 BEGIN
  ACCESS(Dtwo);
  L_General.Assert(Dtwo.Date >= L_two.FirstModifiableDay(), "       饭");
  L_two.D_ConfirmOnDtwo(" ନ஢ ⥢   " + L_DatTim.DateStr(Dtwo.Date), 1+(SYSTIME()>L_Way.DtwoReadyTime));
  CHANGESEL(Dtwo, Dtwo, , Dtwo.Date);
  FIRST(Dtwo);
  WHILE OCCURE(Dtwo) DO
   PROMPT(" ⥢ ⮢: " + Str.Small(L_two.DtwoStr()));
   IF ~!Dtwo.RWayS & L_two.d_c_FitToFilter() THEN
    IF ~SELECT(CWOrder, RWayS, Dtwo.RWayS) THEN
     SAVE(Dtwo);
     UnbindRWayS(1);
     RESTORE(Dtwo);
    END;
   END;
   NEXT(Dtwo);
  END;
 END {RemoveRWayS};

 PUBLIC PROCEDURE SealMtwo();
  VAR
   curSealed: TIMESTAMP;
 BEGIN
  L_two.M_ConfirmOnMtwo(" ⮢ 筮 鸞  " + L_DatTim.PeriodStr(Memo.ud_mb()), 0);
  curSealed:=SYSTIMESTAMP();
  SELECT(Mtwo, Per, , Memo.ud_mb());
  WHILE OCCURE(Mtwo) DO
   PROMPT(Mtwo.TSN);
   IF L_two.m_c_FitToFilter() THEN
    PROMPT(Mtwo.TSN + " 襭 ⮢ 筮 鸞");
    IF ~L_two.MHasSealedPlan() THEN
     IF ~Mtwo.Actual THEN
      L_General.Error("। 襭 ⮢ ᫥  .|(ਬ, ࠡ⭨ " + Mtwo.TSN + ")");
     END;
     Mtwo.pWhat    :=Mtwo.What;
     Mtwo.pExitClss:=Mtwo.ExitClss;
     Mtwo.pBoxNbr  :=Mtwo.BoxNbr;
     Mtwo.pCooTSN  :=Mtwo.CooTSN;
     Mtwo.pSource  :=Mtwo.Source;
     Mtwo.Sealed   :=curSealed;
     REPLACE(Mtwo);
    END;
   END;
   NEXT(Mtwo);
  END; (* WHILE OCCURE(Mtwo) ... *)
 END {SealMtwo};

 PUBLIC PROCEDURE UnSealMtwo();
  VAR
   PrintedPassed,
   SignedPassed  : SCAL[2];
 BEGIN
  L_two.M_ConfirmOnMtwo("⬥ 襭 ⮢ 筮 鸞  " + L_DatTim.PeriodStr(Memo.ud_mb()), 2);
  PrintedPassed:=0;
  SignedPassed :=0;
  SELECT(Mtwo, Per, , Memo.ud_mb());
  WHILE OCCURE(Mtwo) DO
   PROMPT(Mtwo.TSN);
   IF L_two.m_c_FitToFilter() THEN
    PROMPT(Mtwo.TSN + " ⬥ 襭 ⮢ 筮 鸞");
    IF L_two.MHasSealedPlan() THEN
     IF    ~!Mtwo.Signed THEN
      IF ~SignedPassed THEN
       L_AcsPnt.PassAccessPoint(L_two.acspnt_ChangeSigned);
       SignedPassed:=1;
      END;
     ELSIF ~!Mtwo.Printed THEN
      IF ~SignedPassed & ~PrintedPassed THEN
       L_AcsPnt.PassAccessPoint(L_two.acspnt_ChangePrinted);
       PrintedPassed:=1;
      END;
     END;
     SETEMPTY(Mtwo.pWhat, Mtwo.pExitClss, Mtwo.pBoxNbr, Mtwo.pCooTSN, Mtwo.pSource, Mtwo.Sealed, Mtwo.Printed, Mtwo.Signed);
     REPLACE(Mtwo);
    END;
   END;
   NEXT(Mtwo);
  END; (* WHILE OCCURE(Mtwo) ... *)
 END {UnSealMtwo};

 PRIVATE PROCEDURE SignMtwo();
  VAR
   curSigned,
   minCreated,
   maxSealed  : TIMESTAMP;
   SignedCnt  : NUMERIC[0];
 BEGIN
  IF ~L_AcsPnt.MayPassAccessPoint(L_two.acspnt_ChangeSigned) THEN
   L_AcsPnt.PassAccessPoint(L_two.acspnt_ChangeSigned);
  ELSE
   L_AR.GrantRightsUnconditionally();
  END;
  L_StdFrm.Question("  " + L_DatTim.PeriodStr(Memo.ud_mb()) + " ᠭ");
  SignedCnt :=0;
  curSigned :=SYSTIMESTAMP();
  minCreated:=MAXOF(TIMESTAMP);
  maxSealed :=MINOF(TIMESTAMP);
  SELECT(Mtwo, Per, , Memo.ud_mb());
  WHILE OCCURE(Mtwo) DO
   PROMPT(Mtwo.TSN);
   IF !Mtwo.Sealed THEN
    minCreated:=Math.Min(Mtwo.Created, minCreated);
   ELSE
    maxSealed:=Math.Max(Mtwo.Sealed, maxSealed);
    IF !Mtwo.Printed THEN
     L_General.Error("   ⠭. ਬ, ࠡ⭨ " + Mtwo.TSN);
    END;
    IF !Mtwo.Signed THEN
     Mtwo.Signed:=curSigned;
     REPLACE(Mtwo);
     INC(SignedCnt);
    END;
   END;
   NEXT(Mtwo);
  END;
  IF (maxSealed = MINOF(TIMESTAMP)) | (minCreated <= maxSealed) THEN
   L_General.Error("   襭  ⠭");
  END;
  IF SignedCnt > 0 THEN
   L_StdFrm.Inform(" ᠭ (" + L_Str.IntStr(SignedCnt) + " ப)");
  ELSE
   L_StdFrm.Inform(" ப 鸞 㦥 뫨 ᠭ");
  END;
 END {SignMtwo};

 PRIVATE PROCEDURE M_FieldName2da(FieldName: STRING[]): L_two.tDailyAttribute;
 BEGIN
  IF    FieldName = "What"     THEN RETURN L_two.da_What;
  ELSIF FieldName = "HldOff"   THEN RETURN L_two.da_What;
  ELSIF FieldName = "ExitClss" THEN RETURN L_two.da_ExitClss;
  ELSIF FieldName = "BoxNbr"   THEN RETURN L_two.da_Car;
  ELSIF FieldName = "CooTSN"   THEN RETURN L_two.da_CooTSN;
  END;
 END {M_FieldName2da};

 PRIVATE PROCEDURE cot_Single(Idx: NUMERIC[0]; da: L_two.tDailyAttribute): SCAL[2];
  VAR
   srcIdx: NUMERIC[0];
   Result: SCAL[2];
 BEGIN
  srcIdx:=L_two.MSrcIdx(Idx, da);
  Result:=Mtwo.Source[srcIdx] = L_BegRWS.twosrc_Operator;
  IF Result THEN
   Mtwo.Source[srcIdx]:=L_BegRWS.twosrc_Regime;
  END;
  RETURN Result;
 END {cot_Single};

 PUBLIC PROCEDURE ClearOperatorTrace();
  VAR
   Idx : NUMERIC[0];
   D   : DATE;
   Cnt : NUMERIC[0];
 BEGIN
  Idx:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  D  :=L_two.Idx2Date(Idx, Mtwo.Per);
  Cnt:=0;
  INC(Cnt, cot_Single(Idx, L_two.da_What));
  INC(Cnt, cot_Single(Idx, L_two.da_ExitClss));
  INC(Cnt, cot_Single(Idx, L_two.da_Car));
  INC(Cnt, cot_Single(Idx, L_two.da_CooTSN));
  L_General.Assert(Cnt > 0, "⪠ ᪮ ⬥⪨   믮, ⮫쪮 ᫨  ᭮");
  L_StdFrm.Question("   ᪨ ⬥⪨ ()  " + L_DatTim.DateStr(D));
  REPLACE(Mtwo);
  L_two.m_ChangeTimDone(-1, Mtwo.What[Idx], Mtwo.ExitClss[Idx], Idx);
  L_two.m_FillPeriod(D, D, L_BegRWS.twosrc_Regime, EMPTYOF(L_BegRWS.tDayType));
  Mtwo.HldOff[Idx]:=0;
  REPLACE(Mtwo);
  L_two.m_AddTimDone(Idx);
  MtwoE_PrepareSingleWinField(1, Idx);
 END {ClearOperatorTrace};

 PUBLIC PROCEDURE ChangeMonth(Dir: NUMERIC[0]);
 BEGIN
  IF ACCESS(Mtwo) THEN
   Mtwo_TSN_ToStandon:=Mtwo.TSN;
  ELSE
   SETEMPTY(Mtwo_TSN_ToStandon);
  END;
  IF    Dir = +1 THEN
   CALL(SetDfDat.NextMonth_Ext(Memo.ud_cd()));
  ELSIF Dir = -1 THEN
   CALL(SetDfDat.PrvMonth_Ext(Memo.ud_cd()));
  END;
  Mtwo_1_SetFirstDay(Memo.ud_cd());
  IF ~!Mtwo_TSN_ToStandon THEN
   IF SELECT(Mtwo, Per, Memo.ud_mb(), Mtwo_TSN_ToStandon) THEN
    LIKEMENU(RunProg, "two 194");
   ELSE
    L_StdFrm.Inform(" 拉  " + L_DatTim.PeriodStr(Memo.ud_mb()) + " ࠡ⭨ " + Mtwo_TSN_ToStandon + " ");
   END;
  END;
 END {ChangeMonth};

 PRIVATE PROCEDURE TwoAl();
  CONST
   bpId = "twoAl";
 BEGIN
  L_bp.Begin(bpId, "ࢮ砫쭮  筮 鸞", L_bp.t_Prc_wRp, L_General.tc_onMonthBeg);
  L_two.Renovate(bpRT.cd, L_two.rm_Initial);
  L_bp.End();
 END {TwoAl};

 PUBLIC PROCEDURE RenovateCurStaff();
 BEGIN
  L_two.AccessMtwo();
  L_two.Renovate(Mtwo.Per, L_two.rm_Single);
 END {RenovateCurStaff};

 PUBLIC PROCEDURE RenovateNotActual();
 BEGIN
  L_two.Renovate(Memo.ud_mb(), L_two.rm_NotActual);
 END {RenovateNotActual};

 PUBLIC PROCEDURE RenovateAllFiltered();
 BEGIN
  L_two.Renovate(Memo.ud_mb(), L_two.rm_AllFiltered);
 END {RenovateAllFiltered};

 PUBLIC PROCEDURE RenovateExists();
 BEGIN
  L_two.Renovate(Memo.ud_cd(), L_two.rm_Exits);
 END {RenovateExists};

 PUBLIC PROCEDURE StandOnDtwo();
 BEGIN
  IF ACCESS(Mtwo) THEN
   IF L_BegRWS.IsWorkDayType(Mtwo.What[L_two.Date2Idx(Memo.ud_cd())]) THEN
    L_two.AccessDtwoByMtwo(L_two.Date2Idx(Memo.ud_cd()));
    Dtwo_Dtwo_ToStandOn:=Dtwo.Dtwo;
    LIKEMENU(View, "Dtwo 1", RunProg, "two 196");
   ELSE
    L_General.Assert(SELECT(Dtwo, DExitClss, Memo.ud_cd()), " 筮 鸞  " + L_DatTim.DateStr(Memo.ud_cd()));
    L_StdFrm.Inform(" 筮 拉  " + L_DatTim.DateStr(Memo.ud_cd()) + "    ࠡ⭨ " + Mtwo.TSN +
                    "||室 㤥 믮   ப 鸞");
    SETEMPTY(Dtwo_Dtwo_ToStandOn);
    LIKEMENU(View, "Dtwo 1", Home, "");
   END;
  END;
 END {StandOnDtwo};

 PUBLIC PROCEDURE JumpPrevWeek();
 BEGIN
  MJumpByDays(-7);
 END {JumpPrevWeek};

 PUBLIC PROCEDURE JumpNextWeek();
 BEGIN
  MJumpByDays(+7);
 END {JumpNextWeek};

 PUBLIC PROCEDURE JumpPrevDay();
 BEGIN
  MJumpByDays(-1);
 END {JumpPrevDay};

 PUBLIC PROCEDURE JumpNextDay();
 BEGIN
  MJumpByDays(+1);
 END {JumpNextDay};

 PUBLIC PROCEDURE ChooseCurMonthDay();
 BEGIN
  CALL(SetDfDat.ChooseMonthDay_Ext(Memo.ud_cd()));
  Mtwo_1_SetFirstDay(Memo.ud_cd());
 END {ChooseCurMonthDay};

BEGIN
 IF    L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetHandlerName(Event))();
 ELSIF MODE = 129 THEN
  MtwoFillByCycle();
 ELSIF MODE = 130 THEN
  DefinePtwo();
 ELSIF MODE = 131 THEN
  MtwoFillAsYesterday();
 ELSIF MODE = 132 THEN
  MtwoFillByPtwo();
 ELSIF MODE = 190 THEN
  EmulateDtwoOnBeforeAskForEdit();
 ELSIF MODE = 191 THEN
  EmulateMtwoOnBeforeAskForEdit();
 ELSIF MODE = 192 THEN
  IF ACCESS(Dtwo) & ~!Dtwo.TSN THEN
   Mtwo_TSN_ToStandon:=Dtwo.TSN;
   LIKEMENU(View, "Mtwo 1", RunProg, "two 194");
  END;
 ELSIF MODE = 193 THEN
  IF ACCESS(Dtwo) & ~!Dtwo.GuardTSN THEN
   Mtwo_TSN_ToStandon:=Dtwo.GuardTSN;
   LIKEMENU(View, "Mtwo 1", RunProg, "two 194");
  END;
 ELSIF MODE = 194 THEN
  IF ACCESS(Mtwo) & SELECT(Mtwo, Per, Mtwo.Per, Mtwo_TSN_ToStandon) THEN
   SetWZDPosition("Mtwo", PROCREF(ResetAllMtwoFilters));
  END;
 ELSIF MODE = 196 THEN
  IF SELECT(Dtwo, Dtwo, Memo.ud_cd(), Dtwo_Dtwo_ToStandOn) THEN
   SetWZDPosition("Dtwo", PROCREF(ResetAllDtwoFilters));
  END;
 ELSIF MODE = 197 THEN
  BindCWOrder();
 ELSIF MODE = 198 THEN
  UnbindRWayS(0);
 ELSE
  L_General.BadMode(MODE);
 END;
END.
