(*
%Copyright   (c) Polak IT
%Author      28.07.2006 19:23:48 POLAK\San
%Purpose     ⮯⮢ 鸞
%Type        operation
%Specific    AP
%Modified    03.01.2014 16:02:22 POLAK\San
%Environment
*)

 MODULE two05 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_two, L_AFM, L_Way, L_DatTim, L_BegRWS, Math, L_OwnData,
        E_two, Memo, Str, L_EC, L_Staff;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "N.y"
@
############################################################# ########## #####
=#####========================================================================
|                । 室  ᮭ  #######               |
|----------------------------------------------------------------------------|
||ਨ                                                              |
|--|-------------------------------------------------------------------------|
}
*)

(*
$P{ Line1:
?, L, "D"
StExit.ExitClss, L, ""
StExit.Exit, L, ""
StExit.Change, L, L_BegRWS.wh_Pool
StExit.Name, L, ""
@
|##|###### ######### # ######################################################|
}
*)

(*
$P{ Line2:
?, L, "D"
Staff.TSN, L, ""
Man.Name, L, ""
@
|##|##### ###################################################################|
}
*)

(*
$P{ Line3:
?, L, "D"
?, L, ""
@
|##|#########################################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 TYPE
  tSurrounding = SCAL[3];

 CONST
  s_Prv = 0;
  s_Nxt = 1;
  s_Any = 2;

  REC_Amount = 16;

 VAR
  BegDate,
  EndDate     : DATE;
  BegIdx,
  EndIdx      : NUMERIC[0];
  RsrvECAmount: NUMERIC[0];
  RsrvExitClss: LIKE(ExitClss.ExitClss)[REC_Amount];
  REC_BegTime,
  REC_EndTime : TIME[REC_Amount];

 PRIVATE PROCEDURE E_two05_NeedSameExitInPairDays(D: DATE; _Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho): SCAL[2];
  VAR
   Local  : PROC;
 BEGIN
  Local:=PROCREF(E_two.two05_NeedSameExitInPairDays);
  IF ~!Local THEN
   RETURN Local(D, _Sort, trgWho);
  ELSE
   RETURN 0;
  END;
 END {E_two05_NeedSameExitInPairDays};

 PRIVATE PROCEDURE E_two05_MtwoDoNotNeedSameExitInPairDays(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_two.two05_MtwoDoNotNeedSameExitInPairDays), 0);
 END {E_two05_MtwoDoNotNeedSameExitInPairDays};

 PRIVATE PROCEDURE E_two05_ExitKeyTimeAddValue(D: DATE; _Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho): NUMERIC[3];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_two.two05_ExitKeyTimeAddValue);
  IF ~!Local THEN
   RETURN Local(D, _Sort, trgWho);
  ELSE
   RETURN 1.5;
  END;
 END {E_two05_ExitKeyTimeAddValue};

 PRIVATE PROCEDURE E_two05_Need1Pass(D: DATE; _Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho): SCAL[2];
  VAR
   default: SCAL[2];
   Local  : PROC;
 BEGIN
  default:=E_two05_NeedSameExitInPairDays(D, _Sort, trgWho);
  Local:=PROCREF(E_two.two05_Need1Pass);
  IF ~!Local THEN
   default:=Local(default, D, _Sort, trgWho);
  END;
  RETURN default;
 END {E_two05_Need1Pass};

 PRIVATE PROCEDURE two05_IsRsrvExitClss(_ExitClss: LIKE(ExitClss.ExitClss)): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  LOOP
   IF i >= RsrvECAmount THEN
    RETURN 0;
   ELSIF RsrvExitClss[i] = _ExitClss THEN
    RETURN 1;
   END;
   INC(i);
  END; (* LOOP *)
 END {two05_IsRsrvExitClss};

 PRIVATE PROCEDURE two05_Put_NowDone(_ExitClss: LIKE(ExitClss.ExitClss); _Amount: NUMERIC[0]);
 BEGIN
  ADD(NowDone, Mtwo, , Mtwo.Mtwo, _ExitClss,
      NowDone.Amount, _Amount);
 END {two05_Put_NowDone};

 PRIVATE PROCEDURE two05_intPutExitL(D      : DATE;
                                     _Sort  : LIKE(Sort.Sort);
                                     trgWho : L_two.tTWOWho;
                                     _TSN   : LIKE(Staff.TSN);
                                     begTime,
                                     endTime: TIME);
  VAR
   _ExitLNbr: NUMERIC[0];
 BEGIN
  IF SELECT(ExitL, ExitLNbr, _Sort, D) & LAST(ExitL) THEN
   _ExitLNbr:=ExitL.ExitLNbr+1;
  ELSE
   _ExitLNbr:=0;
  END;
  ExitL.Sort    :=_Sort;
  ExitL.D       :=D;
  ExitL.Exit    :=StExit.Exit;
  ExitL.ExitClss:=StExit.ExitClss;
  ExitL.Change  :=StExit.Change;
  IF !begTime THEN
   L_Way.GetExitFullTimes(trgWho, ExitL.BegTime, ExitL.EndTime);
  ELSE
   ExitL.BegTime:=L_Way.FullBegTime(01, begTime);
   ExitL.EndTime:=L_Way.FullEndTime(01, begTime, endTime);
  END;
  ExitL.InvET    :=(-1)*ExitL.EndTime;
  ExitL.GuNeed   :=StExit.GuNeed;
  ExitL.ExitLNbr :=_ExitLNbr;
  ExitL.maxAmount:=0;
  ExitL.termTime :=0;
  ExitL.GCAmount :=0;
  ExitL.TSN      :=_TSN;
  ExitL.Closed   :=~!ExitL.TSN;
  INSERT(ExitL);
 END {two05_intPutExitL};

 PRIVATE PROCEDURE two05_PutExitL(D: DATE; _Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho; _TSN: LIKE(Staff.TSN));
 BEGIN
  two05_intPutExitL(D, _Sort, trgWho, _TSN, EMPTYOF(TIME), EMPTYOF(TIME));
 END {two05_PutExitL};

 PRIVATE PROCEDURE two05_PrepareExitList(_Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho);
  VAR
   D   : DATE;
   _TSN: LIKE(Staff.TSN);
 BEGIN
  D:=BegDate;
  WHILE D <= EndDate DO
   SELECT(ExitClss, ExitClss);
   WHILE OCCURE(ExitClss) DO
    IF ExitClss.Strict = L_Way.ExitStrict_Reg THEN
     SELECT(StExit, ECUpDate, , ExitClss.ExitClss);
     SRCINSEL(StExit, GT, , BegDate);
     WHILE OCCURE(StExit) DO
      PROMPT("  ⥫: " + L_DatTim.DateStr(D) + " " + StExit.Exit);
      IF L_Way._CheckExitOnDate(StExit.Exit, D) = L_Way.exvld_Active THEN
       IF ((trgWho = L_two.who_Driver) | (StExit.GuNeed = L_Way.egn_Required)) &
          (L_Way.E_GetFixedSortOfExit(StExit.Exit, D, trgWho) = _Sort) THEN
        L_two.r_Access(D, L_two.d_ObtainObject(0, 1, D, L_two.da_ExitClss, StExit.ExitClss, StExit.Change));
        IF trgWho = L_two.who_Driver THEN
         _TSN:=Dtwo.TSN;
        ELSE
         _TSN:=Dtwo.GuardTSN;
        END;
        IF ~!_TSN THEN
         L_two.StandOnMtwo(_TSN, trgWho, L_DatTim.Per(BegDate));
         two05_Put_NowDone(ExitClss.ExitClss, 1);
        END;
        two05_PutExitL(D, _Sort, trgWho, _TSN);
        ADD(PlFct, Date, , _Sort, D,
            PlFct.Plan, 1,
            PlFct.Fact, ~!_TSN);
       END;
      END;
      NEXT(StExit);
     END;
    END;
    NEXT(ExitClss);
   END; (* WHILE OCCURE(ExitClss) ... *)
   INC(D);
  END; (* WHILE D ... *)
 END {two05_PrepareExitList};

 PRIVATE PROCEDURE Dtwo_AccessByMtwo(D: DATE): SCAL[2];
 BEGIN
  IF Mtwo.Who = L_two.who_Driver THEN
   RETURN SELECT(Dtwo, DTSN, D, Mtwo.TSN);
  ELSE
   RETURN SELECT(Dtwo, DGuardTSN, D, Mtwo.TSN);
  END;
 END {Dtwo_AccessByMtwo};

 PRIVATE PROCEDURE HasNormalRestPeriod(D      : DATE;
                                       _Sort  : LIKE(Sort.Sort);
                                       trgWho : L_two.tTWOWho;
                                       BegTime,
                                       EndTime: NUMERIC[3]): SCAL[2];
  VAR
   nrp,
   mrp   : NUMERIC[3];
   Result: SCAL[2];
 BEGIN
  Result:=1;
  L_two.E_RestPeriod(D, _Sort, trgWho, nrp, mrp);
  IF Dtwo_AccessByMtwo(D-1) THEN
   IF ~!Dtwo.Exit THEN
    Result:=((BegTime+24) - L_Way.FullEndTime(Dtwo.BegDay, Dtwo.BegTime, Dtwo.EndTime)) >= nrp;
   END;
  END;
  IF Result THEN
   IF Dtwo_AccessByMtwo(D+1) THEN
    IF ~!Dtwo.Exit THEN
     Result:=((L_Way.FullBegTime(Dtwo.BegDay, Dtwo.BegTime)+24) - EndTime) >= nrp;
    END;
   END;
  END;
  RETURN Result;
 END {HasNormalRestPeriod};

 PRIVATE PROCEDURE ChangeMtwoExitClss(_ExitClss: LIKE(ExitClss.ExitClss); Idx: NUMERIC[0]; _Source: L_BegRWS.tSource);
 BEGIN
  L_two.m_ChangeDA(L_two.da_ExitClss, L_two.m_SubstituteDA(L_two.da_ExitClss, _ExitClss, Idx, _Source), Idx, _Source);
 END {ChangeMtwoExitClss};

 PRIVATE PROCEDURE two05_intCloseCurrentExit(Idx: NUMERIC[0]; Dir: NUMERIC[0]; wMwd: SCAL[2]; _TSN: LIKE(Staff.TSN));
 BEGIN
  two05_Put_NowDone(ExitL.ExitClss, Dir);
  IF Dir = +1 THEN
   ChangeMtwoExitClss(ExitL.ExitClss, Idx, L_BegRWS.twosrc_Auto);
  ELSE
   ChangeMtwoExitClss("", Idx, L_BegRWS.twosrc_Regime);
  END;
  IF wMwd THEN
   REMOVE(Mwd);
  END;
  ExitL.TSN    :=_TSN;
  ExitL.Closed :=~!ExitL.TSN;
  REPLACE(ExitL);
 END {two05_intCloseCurrentExit};

 PRIVATE PROCEDURE two05_CloseCurrentExit(Idx: NUMERIC[0]);
 BEGIN
  two05_intCloseCurrentExit(Idx, +1, 1, Mtwo.TSN);
 END {two05_CloseCurrentExit};

 PRIVATE PROCEDURE E_CrewFitForExit(D            : DATE;
                                    trgWho       : L_two.tTWOWho;
                                    _Exit        : LIKE(StExit.Exit);
                                    _TSN         : LIKE(Staff.TSN);
                                    _BoxNbr      : LIKE(Car.BoxNbr)): SCAL[2];
  VAR
   Local  : PROC;
   default: SCAL[2];
 BEGIN
  IF trgWho = L_two.who_Driver THEN
   SAVE(Dtwo);
   IF !_Exit THEN
    SELECT(Dtwo, DTSN, , D, _TSN);
   ELSE
    SAVE(StExit);
    SEARCH(StExit, Exit, , _Exit);
    SELECT(Dtwo, DTSN, , D, _TSN, StExit.ExitClss);
    RESTORE(StExit);
   END;
   default:=L_BegRWS.E_CrewFitForExit(D, _TSN, _BoxNbr, _Exit);
   RESTORE(Dtwo);
  ELSE
   default:=1;
  END;
  Local:=PROCREF(E_two.CrewFitForExit);
  IF ~!Local THEN
   default:=Local(default, D, trgWho, _Exit, _BoxNbr);
  END;
  RETURN default;
 END {E_CrewFitForExit};

 PRIVATE PROCEDURE Mwd_HasRest(Srn: tSurrounding): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=Mwd.HasRest[Srn];
RETURN Result;
  IF Srn = s_Prv THEN
   Result:=Result & ~Mwd.HasRest[s_Nxt];
  END;
  RETURN Result;
 END {Mwd_HasRest};

 PRIVATE PROCEDURE two05_AccessTheMin(D        : DATE;
                                      _ExitClss: LIKE(ExitClss.ExitClss);
                                      Srn      : tSurrounding;
                                      maxAmount: NUMERIC[0];
                                      SeqNbr   : NUMERIC[0]): SCAL[3];
  VAR
   exclMtwo    : LIKE(Mtwo.Mtwo)[128];
   exclCnt,
   i           : NUMERIC[0];
   maxDeviation,
   curDeviation: NUMERIC[2];
   TargetMtwo  : LIKE(Mtwo.Mtwo);
 BEGIN
  exclCnt     :=0;
  WHILE SeqNbr > 0 DO
   SETEMPTY(TargetMtwo);
   maxDeviation:=-1;
   SELECT(NowDone, ExitClss, , _ExitClss);
   LOOP
    IF ~OCCURE(NowDone) THEN
     EXIT;
    ELSIF SELECT(Mwd, Mtwo, NowDone.Mtwo, D) & Mwd_HasRest(Srn) THEN
     IF NowDone.Amount > maxAmount THEN
      EXIT;
     END;
     i:=0;
     LOOP
      IF i = exclCnt THEN
       SAVE(NowDone);
       SAVE(ExitL);
       CHANGESEL(NowDone, Mtwo1, , NowDone.Mtwo);
       LAST(NowDone);
       curDeviation:=0;
       WHILE NowDone.Amount > maxAmount DO
        SELECT(ExitL, ExitClss, , Mwd.Sort, NowDone.ExitClss, D);
        LOOP
         IF ~OCCURE(ExitL) THEN
          EXIT;
         ELSIF !ExitL.TSN THEN
          INC(curDeviation, Math.Pow(10, (NowDone.Amount-maxAmount)));
          EXIT;
         END;
         NEXT(ExitL);
        END;
        PREV(NowDone);
       END;
       IF curDeviation > maxDeviation THEN
        maxDeviation:=curDeviation;
        TargetMtwo   :=NowDone.Mtwo;
       END;
       RESTORE(ExitL);
       RESTORE(NowDone);
       EXIT;
      ELSIF NowDone.Mtwo = exclMtwo[i] THEN
       EXIT;
      END;
      INC(i);
     END; (* LOOP *)
    END;
    NEXT(NowDone);
   END; (* LOOP *)
   DEC(SeqNbr);
   IF    ~!TargetMtwo THEN
    IF SeqNbr = 0 THEN
     SEARCH(Mwd, Mtwo, , TargetMtwo, D);
     SEARCH(Mtwo, Mtwo, , Mwd.Mtwo);
     RETURN 2;
    ELSE
     exclMtwo[exclCnt]:=TargetMtwo;
     INC(exclCnt);
    END;
   ELSIF OCCURE(NowDone) THEN
    RETURN 1;
   ELSE
    RETURN 0;
   END;
  END; (* WHILE SeqNbr > 0 *)
 END {two05_AccessTheMin};

 PRIVATE PROCEDURE two05_IsAcceptableExitL(D: DATE; _Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho): SCAL[2];
 BEGIN
  RETURN (ExitL.Change = Mtwo.What[L_two.Date2Idx(D)]) &
         HasNormalRestPeriod(D, _Sort, trgWho, ExitL.BegTime, ExitL.EndTime) &
         E_CrewFitForExit(D, Mtwo.Who, ExitL.Exit, Mtwo.TSN, Mtwo.BoxNbr[L_two.Date2Idx(D)]);
 END {two05_IsAcceptableExitL};

 PRIVATE PROCEDURE two05_IsTargetMtwo(trgWho: L_two.tTWOWho; Idx: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN L_BegRWS.IsWorkDayType(Mtwo.What[Idx]) &
        (~!Mtwo.BoxNbr[Idx] | (trgWho = L_two.who_Guard)) &
        !Mtwo.ExitClss[Idx] & (Mtwo.Source[L_two.MSrcIdx(Idx, L_two.da_ExitClss)] # L_BegRWS.twosrc_Operator);
 END {two05_IsTargetMtwo};

 PRIVATE PROCEDURE two05_GetExitLKeyTime(Srn: tSurrounding): FLOAT;
 BEGIN
  IF  Srn = s_Nxt THEN
   RETURN ExitL.InvET;
  ELSE
   RETURN ExitL.EndTime;
  END;
 END {two05_GetExitLKeyTime};

 PRIVATE PROCEDURE two05_FillMnmze(forSpecialExit: SCAL[2];
                           D             : DATE;
                           _Sort         : LIKE(Sort.Sort);
                           trgWho        : L_two.tTWOWho;
                           Srn           : tSurrounding);
 BEGIN
  SELECT(NowDone, Amount);
  LAST(NowDone);
  WHILE OCCURE(NowDone) DO
   IF SEARCH(Mwd, Mtwo, NowDone.Mtwo, D) & Mwd_HasRest(Srn) THEN
    IF SELECT(ExitL, ExitClss, _Sort, NowDone.ExitClss, D) THEN
     WHILE OCCURE(ExitL) DO
      IF !ExitL.TSN & ~SEARCH(Mnmze, ExitLNbr, ExitL.ExitLNbr) THEN
       IF ~forSpecialExit | (E_CrewFitForExit(D, trgWho, ExitL.Exit, EMPTYOF(Staff.TSN), EMPTYOF(Car.BoxNbr))=0) THEN
        Mnmze.Order   :=FLDTOSTR(~forSpecialExit, "", 0) + " " + FLDTOSTR(two05_GetExitLKeyTime(Srn), "7.", 0);
        Mnmze.ExitLNbr:=ExitL.ExitLNbr;
        INSERT(Mnmze);
       END;
      END;
      NEXT(ExitL);
     END;
    END;
    CHANGESEL(NowDone, Amount, , NowDone.Amount, NowDone.ExitClss);
    FIRST(NowDone);
    CHANGESEL(NowDone, Amount);
   END;
   PREV(NowDone);
  END; (* WHILE OCCURE(NowDone) ... *)
 END {two05_FillMnmze};

 PRIVATE PROCEDURE two05_Bind(D: DATE; _Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho; Srn: tSurrounding; forSpecialExit: NUMERIC[0]);
  VAR
   Idx,
   maxAmount,
   Amount,
   SeqNbr,
   i             : NUMERIC[0];
   Res           : SCAL[3];
   termTime      : FLOAT;
   ItsAll        : SCAL[2];
   Unclosed      : NUMERIC[0];
 BEGIN
  Idx:=L_two.Date2Idx(D);
  Amount:=0;
  SELECT(Mwd, Sort, , _Sort, D);
  WHILE OCCURE(Mwd) DO
   INC(Amount, Mwd_HasRest(Srn));
   NEXT(Mwd);
  END; (* WHILE OCCURE(Mwd) *)

  termTime:=MAXOF(termTime);
  IF Srn = s_Any THEN
   SELECT(ExitL, EndTime, , _Sort, D);
   WHILE OCCURE(ExitL) DO
    ExitL.maxAmount:=0;
    SELECT(NowDone, ExitClss, , ExitL.ExitClss);
    WHILE OCCURE(NowDone) DO
     INC(ExitL.maxAmount, NowDone.Amount);
     NEXT(NowDone);
    END; (* WHILE OCCURE(NowDone) *)
    REPLACE(ExitL);
    NEXT(ExitL);
   END;
   SELECT(ExitL, SortAm, , _Sort, D);
  ELSE
   IF Srn = s_Prv THEN
    SELECT(ExitL, EndTime, , _Sort, D);
   ELSE
    SELECT(ExitL, InvET, , _Sort, D);
   END;
   i:=0;
   LOOP
    IF ~OCCURE(ExitL) THEN
     EXIT;
    ELSIF !ExitL.TSN THEN
     INC(i);
     IF i >= Amount THEN
      termTime:=two05_GetExitLKeyTime(Srn) + E_two05_ExitKeyTimeAddValue(D, _Sort, trgWho);
      EXIT;
     END;
    END;
    NEXT(ExitL);
   END; (* LOOP *)
  END;
  maxAmount:=0;
  REPEAT
   Unclosed:=0;
   ItsAll:=FIRST(ExitL);
   WHILE OCCURE(ExitL) & (two05_GetExitLKeyTime(Srn) <= termTime) & (Amount > 0) DO
    PROMPT("। 室: " + L_DatTim.DateStr(D) + " " + ExitL.Exit);
    IF !ExitL.TSN THEN
     IF (forSpecialExit = 0) | (E_CrewFitForExit(D, trgWho, ExitL.Exit, EMPTYOF(Staff.TSN), EMPTYOF(Car.BoxNbr))=0) THEN
      SeqNbr:=1;
      LOOP
       Res:=two05_AccessTheMin(D, ExitL.ExitClss, Srn, maxAmount, SeqNbr);
       IF Res = 2 THEN
        IF two05_IsAcceptableExitL(D, _Sort, trgWho) THEN
         DEC(Amount);
         two05_CloseCurrentExit(Idx);
         EXIT;
        ELSE
         IF SeqNbr < Amount THEN
          INC(SeqNbr);
         ELSE
          EXIT;
         END;
        END;
       ELSIF Res = 1 THEN
        ItsAll:=0;
        EXIT;
       ELSE
        EXIT;
       END;
      END; (* LOOP *)
      INC(Unclosed, !ExitL.TSN);
     END;
    END;
    NEXT(ExitL);
   END; (* WHILE OCCURE(ExitL) ... *)
   INC(maxAmount);
  UNTIL ItsAll;
  IF forSpecialExit & (Srn = s_Any) & (Unclosed > 0) THEN
   two05_AddSingleDayRsrvToExitL(D, _Sort, trgWho, Unclosed);
  END;
 END {two05_Bind};

 PRIVATE PROCEDURE two05_Bind3(D: DATE; _Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho; Srn: tSurrounding);
  VAR
   Idx,
   maxAmount,
   Amount,
   SeqNbr     : NUMERIC[0];
   Res        : SCAL[3];
 BEGIN
  Idx:=L_two.Date2Idx(D);
  Amount:=0;
  SELECT(Mwd, Sort, , _Sort, D);
  WHILE OCCURE(Mwd) DO
   INC(Amount);
   NEXT(Mwd);
  END; (* WHILE OCCURE(Mwd) *)
  SELECT(ExitL, EndTime, , _Sort, D);
  WHILE OCCURE(ExitL) DO
   IF SELECT(NowDone, ExitClss, ExitL.ExitClss) & LAST(NowDone) THEN
    WHILE OCCURE(NowDone) & ~SEARCH(Mwd, Mtwo, NowDone.Mtwo, D) DO
     PREV(NowDone);
    END;
    IF ~OCCURE(NowDone) THEN
     ExitL.maxAmount:=0;
    ELSE
     ExitL.maxAmount:=(-1) * NowDone.Amount;
    END;
    REPLACE(ExitL);
   END;
   NEXT(ExitL);
  END;
  SELECT(ExitL, SortAm, , _Sort, D);
  WHILE OCCURE(ExitL) & (Amount > 0) DO
   PROMPT("। 室: " + L_DatTim.DateStr(D) + " " + ExitL.Exit);
   IF !ExitL.TSN THEN
    maxAmount:=0;
    SeqNbr:=1;
    LOOP
     Res:=two05_AccessTheMin(D, ExitL.ExitClss, Srn, maxAmount, SeqNbr);
     IF Res = 2 THEN
      IF two05_IsAcceptableExitL(D, _Sort, trgWho) THEN
       DEC(Amount);
       two05_CloseCurrentExit(Idx);
       EXIT;
      ELSE
       IF SeqNbr < Amount THEN
        INC(SeqNbr);
       ELSE
        EXIT;
       END;
      END;
     ELSIF Res = 1 THEN
      INC(maxAmount);
      SeqNbr:=1;
     ELSE
      EXIT;
     END;
    END; (* LOOP *)
   END;
   NEXT(ExitL);
  END; (* WHILE OCCURE(ExitL) ... *)
 END {two05_Bind3};

 PRIVATE PROCEDURE two05_Bind4(D: DATE; _Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho; Srn: tSurrounding);
  VAR
   Idx,
   maxAmount,
   Amount,
   i,
   SeqNbr     : NUMERIC[0];
   termTime   : FLOAT;
   Res        : SCAL[3];
   ItsAll     : SCAL[2];
 BEGIN
  Idx:=L_two.Date2Idx(D);
  Amount:=0;
  SELECT(Mwd, Sort, , _Sort, D);
  WHILE OCCURE(Mwd) DO
   INC(Amount, Mwd_HasRest(Srn));
   NEXT(Mwd);
  END; (* WHILE OCCURE(Mwd) *)

  IF Srn = s_Prv THEN
   SELECT(ExitL, EndTime, , _Sort, D);
  ELSIF Srn = s_Nxt THEN
   SELECT(ExitL, InvET, , _Sort, D);
  ELSE
   SELECT(ExitL, EndTime, , _Sort, D);
  END;
  i:=0;
  LOOP
   IF ~OCCURE(ExitL) THEN
    termTime:=MAXOF(termTime);
    EXIT;
   ELSIF !ExitL.TSN THEN
    INC(i);
    IF i >= Amount THEN
     termTime:=two05_GetExitLKeyTime(Srn) + 1.5;
     EXIT;
    END;
   END;
   NEXT(ExitL);
  END; (* LOOP *)
  maxAmount:=0;
  REPEAT
   ItsAll:=FIRST(ExitL);(*SELECT(ExitL, SortAm, _Sort, D)*)
   WHILE OCCURE(ExitL) & (two05_GetExitLKeyTime(Srn) <= termTime) & (Amount > 0) DO
    PROMPT("। 室: " + L_DatTim.DateStr(D) + " " + ExitL.Exit);
    IF !ExitL.TSN THEN
     SeqNbr:=1;
     LOOP
      Res:=two05_AccessTheMin(D, ExitL.ExitClss, Srn, maxAmount, SeqNbr);
      IF Res = 2 THEN
       IF two05_IsAcceptableExitL(D, _Sort, trgWho) THEN
        DEC(Amount);
        two05_CloseCurrentExit(Idx);
        EXIT;
       ELSE
        IF SeqNbr < Amount THEN
         INC(SeqNbr);
        ELSE
         EXIT;
        END;
       END;
      ELSIF Res = 1 THEN
       ItsAll:=0;
       EXIT;
      ELSE
       EXIT;
      END;
     END; (* LOOP *)
    END;
    NEXT(ExitL);
   END; (* WHILE OCCURE(ExitL) ... *)
   INC(maxAmount);
  UNTIL ItsAll;
 END {two05_Bind4};

 PRIVATE PROCEDURE two05_Bind5(D: DATE; _Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho; Srn: tSurrounding);
  VAR
   Idx,
   maxAmount,
   Amount,
   SeqNbr        : NUMERIC[0];
   Res           : SCAL[3];
   ItsAll        : SCAL[2];
   forSpecialExit: SCAL[2];
 BEGIN
  Idx:=L_two.Date2Idx(D);

  IF Srn = s_Any THEN
   SELECT(ExitL, GCAmount, , _Sort, D);
   WHILE OCCURE(ExitL) & ~!ExitL.TSN DO
    NEXT(ExitL);
   END;
   IF OCCURE(ExitL) & (ExitL.GCAmount = 0) THEN
    two05_Bind5(D, _Sort, trgWho, s_Nxt);
   END;
  END;

  Amount:=0;
  SELECT(Mwd, Sort, , _Sort, D);
  WHILE OCCURE(Mwd) DO
   INC(Amount, Mwd_HasRest(Srn));
   NEXT(Mwd);
  END; (* WHILE OCCURE(Mwd) *)

  maxAmount:=0;
  forSpecialExit:=1;
  REPEAT
   ItsAll:=FIRST(ExitL);
   WHILE OCCURE(ExitL) & (Amount > 0) DO
    PROMPT("। 室: " + L_DatTim.DateStr(D) + " " + ExitL.Exit);
    IF !ExitL.TSN & ((Srn = s_Any) | (ExitL.GCAmount = 0)) THEN
     IF ~forSpecialExit | (E_CrewFitForExit(D, trgWho, ExitL.Exit, EMPTYOF(Staff.TSN), EMPTYOF(Car.BoxNbr))=0) THEN
      SeqNbr:=1;
      LOOP
       Res:=two05_AccessTheMin(D, ExitL.ExitClss, Srn, maxAmount, SeqNbr);
       IF Res = 2 THEN
        IF two05_IsAcceptableExitL(D, _Sort, trgWho) THEN
         DEC(Amount);
         two05_CloseCurrentExit(Idx);
         EXIT;
        ELSE
         IF SeqNbr < Amount THEN
          INC(SeqNbr);
         ELSE
          EXIT;
         END;
        END;
       ELSIF Res = 1 THEN
        ItsAll:=0;
        EXIT;
       ELSE
        EXIT;
       END;
      END; (* LOOP *)
     ELSE
      ItsAll:=0;
     END;
    END;
    NEXT(ExitL);
   END; (* WHILE OCCURE(ExitL) ... *)
   forSpecialExit:=~forSpecialExit;
   INC(maxAmount, forSpecialExit);
  UNTIL ItsAll;
 END {two05_Bind5};

 PRIVATE PROCEDURE E_two05_PrepareRsrvExitClss(P: DATE; _Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_two.two05_PrepareRsrvExitClss);
  L_General.Assert(~!Local, " ஥ ⠡ १ࢭ ᮢ 室");
  SETEMPTY(RsrvExitClss);
  RsrvECAmount:=0;
  LOOP
   Local(RsrvECAmount, P, _Sort, trgWho,
         RsrvExitClss[RsrvECAmount], REC_BegTime[RsrvECAmount], REC_EndTime[RsrvECAmount]);
   IF ~!RsrvExitClss[RsrvECAmount] THEN
    INC(RsrvECAmount);
   ELSE
    L_General.Assert(RsrvECAmount > 0, "  १ࢭ  室");
    EXIT;
   END;
  END; (* LOOP *)
 END {E_two05_PrepareRsrvExitClss};

 PRIVATE PROCEDURE two05_AddSingleDayRsrvToExitL(D: DATE; _Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho; A: NUMERIC[0]);
  VAR
   i    : NUMERIC[0];
   Dummy: SCAL[2];
 BEGIN
  i:=0;
  WHILE A > 0 DO
   Dummy:=L_two.StandOnExit(RsrvExitClss[i], "", D, 1);
   two05_intPutExitL(D, _Sort, trgWho, EMPTYOF(Staff.TSN), REC_BegTime[i], REC_EndTime[i]);
   DEC(A);
   i:=(i + 1) MOD RsrvECAmount;
  END;
 END {two05_AddSingleDayRsrvToExitL};

 PRIVATE PROCEDURE two05_AddRsrvToExitL(_Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho);
  VAR
   D    : DATE;
   A,
   i    : NUMERIC[0];
   Dummy: SCAL[2];
 BEGIN
  D:=BegDate;
  WHILE D <= EndDate DO
   IF SEARCH(PlFct, Date, _Sort, D) THEN
    A:=PlFct.Fact-PlFct.Plan;
   ELSE
    A:=0;
   END;
   two05_AddSingleDayRsrvToExitL(D, _Sort, trgWho, A);
   INC(D);
  END;
 END {two05_AddRsrvToExitL};

 PRIVATE PROCEDURE E_two05_GetManner(D: DATE; _Sort: LIKE(Sort.Sort); trgWho: L_two.tTWOWho): NUMERIC[0];
  VAR
   default: NUMERIC[0];
   Local  : PROC;
 BEGIN
  default:=0;
  Local:=PROCREF(E_two.two05_GetManner);
  IF ~!Local THEN
   default:=Local(default, D, _Sort, trgWho);
  END;
  RETURN default;
 END {E_two05_GetManner};

 PRIVATE PROCEDURE E_IsGoodNextExitL(_Sort        : LIKE(Sort.Sort);
                                     D            : DATE;
                                     trgWho       : L_two.tTWOWho;
                                     prvExitClss  : LIKE(ExitClss.ExitClss);
                                     RestTime     : NUMERIC[3]): SCAL[2];
  VAR
   nrp,
   mrp        : NUMERIC[3];
 BEGIN
  L_two.E_RestPeriod(D, _Sort, trgWho, nrp, mrp);
  RETURN RestTime >= nrp;
 END {E_IsGoodNextExitL};

 PRIVATE PROCEDURE two05_PrepareCooExit(_Sort: LIKE(Sort.Sort); D: DATE; trgWho: L_two.tTWOWho);
  VAR
   curGCAmount: NUMERIC[0];
   curEndTime : NUMERIC[3];
   curExitLNbr: NUMERIC[0];
   curExitClss: LIKE(ExitClss.ExitClss);
   RestTime   : NUMERIC[3];
 BEGIN
  SELECT(ExitL, Sort, , _Sort, D);
  WHILE OCCURE(ExitL) DO
(*
   PROMPT("⮢  室: " + L_DatTim.DateStr(D) + ", " + ExitL.Exit);
*)
   IF !ExitL.TSN THEN
    SAVE(ExitL);
    curGCAmount:=0;
    curEndTime :=ExitL.EndTime;
    curExitClss:=ExitL.ExitClss;
    curExitLNbr:=ExitL.ExitLNbr;
    SELECT(ExitL, Sort, , _Sort, D+1);
    WHILE OCCURE(ExitL) DO
     RestTime:=((ExitL.BegTime+24) - curEndTime);
     IF E_IsGoodNextExitL(_Sort, D, trgWho, curExitClss, RestTime) THEN
      INC(curGCAmount);
     END;
     NEXT(ExitL);
    END; (* WHILE OCCURE(ExitL) *)
    RESTORE(ExitL);
    ExitL.GCAmount:=curGCAmount;
    REPLACE(ExitL);
   END;
   NEXT(ExitL);
  END; (* WHILE OCCURE(ExitL) *)
 END {two05_PrepareCooExit};

 PUBLIC PROCEDURE two05_Do();
  CONST
   RepName = "two05";
  VAR
   _Sort       : LIKE(Sort.Sort);
   Idx,
   i           : NUMERIC[0];
   D           : DATE;
   Unclosed    : NUMERIC[0];
   trgWho      : L_two.tTWOWho;
   freeTSN,
   trgTSN      : LIKE(Staff.TSN);
   freeExitLNbr,
   trgExitLNbr : NUMERIC[0];
   Success     : SCAL[2];
   PassNbr     : NUMERIC[0];
   Pass0Cnd    : SCAL[2];
   Manner      : NUMERIC[0];
   P           : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  IF (L_General.GetAPSiteID() = "KL") | (L_General.GetAPSiteID() = "55") THEN
   CALL(two03.FillGuard());
   HALT(0);
  END;
  L_two.M_ConfirmOnMtwo("믮 ⮬᪮ ஢", 0);

  P      :=Memo.ud_mb();
  BegDate:=P;
  EndDate:=L_DatTim.MonthEnd(P);

  BegIdx:=L_two.Date2Idx(BegDate);
  EndIdx:=L_two.Date2Idx(EndDate);

  L_General.Assert(~!L_two.MtwoCurSort, "ॡ ⠭ ⡮  ᥪ");
  _Sort :=L_two.MtwoCurSort;

  IF ~!L_two.MtwoCurWho THEN
   trgWho:=L_two.MtwoCurWho;
  ELSE
   L_General.Assert(ACCESS(Mtwo), " ⠭ ⥪   筮 拉");
   trgWho:=Mtwo.Who;
   CHANGESEL(Mtwo, PSort, , Mtwo.Per, Mtwo.Dprt, Mtwo.Sort);
   FIRST(Mtwo);
   LOOP
    IF ~OCCURE(Mtwo) THEN
     EXIT;
    ELSIF Mtwo.Who # trgWho THEN
     L_General.Error("ॡ ⠭ ⡮  ''");
    END;
    NEXT(Mtwo);
   END; (* LOOP *)
  END;

  L_two.Renovate(P, L_two.rm_NotActual);

  E_two05_PrepareRsrvExitClss(P, _Sort, trgWho);

  L_AFM.MakeMultipleIndex("ExitL", "Sort     : LIKE(Sort.Sort);"+
                                   "D        : DATE;"+
                                   "ExitClss : LIKE(ExitClss.ExitClss);"+
                                   "Change   : LIKE(StExit.Change);"+
                                   "Exit     : LIKE(StExit.Exit);"+
                                   "BegTime  : NUMERIC[3];"+
                                   "EndTime  : NUMERIC[3];"+
                                   "InvET    : NUMERIC[3];"+
                                   "GuNeed   : LIKE(StExit.GuNeed);"+
                                   "TSN      : LIKE(Staff.TSN);"+
                                   "Closed   : SCAL[2];"+
                                   "ExitLNbr : NUMERIC[0];"+
                                   "maxAmount: NUMERIC[0];"+
                                   "termTime : FLOAT;"+
                                   "GCAmount : NUMERIC[0]",
                           "ExitLNbr: Sort, D, ExitLNbr;"+
                           "Sort    : Sort, D, Exit;"+
                           "SortAm  : Sort, D, maxAmount, termTime;"+
                           "GCAmount: Sort, D, GCAmount;"+
                           "ExitClss: Sort, ExitClss, D;"+
                           "InvET   : Sort, D, InvET, ExitClss;"+
                           "EndTime : Sort, D, EndTime, ExitClss;"+
                           "Closed  : Sort, D, Closed");

  L_AFM.MakeMultipleIndex("Mwd", "Sort     : LIKE(Sort.Sort);"+
                                 "D        : DATE;"+
                                 "Mtwo     : LIKE(Mtwo.Mtwo);"+
                                 "TSN      : LIKE(Staff.TSN);"+
                                 "maxAmount: NUMERIC[0];"+
                                 "HasRest  : SCAL[2][3(*tSurrounding-1*)]",
                          "Mtwo  : Mtwo, D;"+
                          "TSN   : Sort, TSN, D;"+
                          "Sort  : Sort, D;"+
                          "Sort1 : Sort, D, maxAmount;");

  L_AFM.MakeMultipleIndex("NowDone", "Mtwo    : LIKE(Mtwo.Mtwo);"+
                                     "ExitClss: LIKE(ExitClss.ExitClss);"+
                                     "Amount  : NUMERIC[0]",
                          "Mtwo    : Mtwo, ExitClss;"+
                          "Mtwo1   : Mtwo, Amount, ExitClss;"+
                          "ExitClss: ExitClss, Amount;"+
                          "Amount  : Amount, ExitClss;");

  L_AFM.MakeMultipleIndex("Mnmze", "Order   : STRING[32];"+
                                   "ExitLNbr: NUMERIC[0]",
                          "Mnmze: Order;"+
                          "ExitLNbr: ExitLNbr");

  L_AFM.MakeMultipleIndex("PlFct", "Sort    : LIKE(Sort.Sort);"+
                                   "D       : DATE;"+
                                   "Plan    : NUMERIC[0];"+
                                   "Fact    : NUMERIC[0]",
                          "Date: Sort, D");

  two05_PrepareExitList(_Sort, trgWho);
  L_General.Assert(SELECT(ExitL, Sort, _Sort), "   室  ᯨ᪥");

  IF ~!_Sort THEN
   L_General.CallUs(SEARCH(Sort, Sort, _Sort));
   SELECT(Mtwo, PSort, , P, L_Staff.getSortDprt(Sort.Sort), Sort.Sort);
  ELSE
   SELECT(Mtwo, PSort, , P);
  END;

  WHILE OCCURE(Mtwo) DO
   PROMPT("⮢ ᯨ᪠ ࠡ⭨: "+Mtwo.TSN);
   IF Mtwo.Who = trgWho THEN
    i:=0;
    WHILE i < RsrvECAmount DO
     two05_Put_NowDone(RsrvExitClss[i], 0);
     INC(i);
    END;
    SELECT(ExitL, ExitClss, , _Sort);
    WHILE OCCURE(ExitL) DO
     two05_Put_NowDone(ExitL.ExitClss, 0);
     CHANGESEL(ExitL, ExitClss, , ExitL.Sort, ExitL.ExitClss);
     LAST(ExitL);
     CHANGESEL(ExitL, ExitClss, , ExitL.Sort);
     NEXT(ExitL);
    END; (* WHILE OCCURE(ExitL) ... *)
    Idx:=BegIdx;
    WHILE Idx <= EndIdx DO
     IF two05_IsTargetMtwo(trgWho, Idx) THEN
      Mwd.Sort     :=_Sort;
      Mwd.D        :=L_two.Idx2Date(Idx, Mtwo.Per);
      Mwd.Mtwo     :=Mtwo.Mtwo;
      Mwd.TSN      :=Mtwo.TSN;
      Mwd.maxAmount:=0;
      Mwd.HasRest[s_Prv]:=~Dtwo_AccessByMtwo(Mwd.D-1) & ~L_BegRWS.IsWorkDayType(L_BegRWS.GetDayTypeByRegime(Mtwo.TSN, Mwd.D-1));
      Mwd.HasRest[s_Nxt]:=~Dtwo_AccessByMtwo(Mwd.D+1) & ~L_BegRWS.IsWorkDayType(L_BegRWS.GetDayTypeByRegime(Mtwo.TSN, Mwd.D+1));
      Mwd.HasRest[s_Any]:=1;
      INSERT(Mwd);
      ADD(PlFct, Date, , _Sort, Mwd.D,
          PlFct.Plan, 0,
          PlFct.Fact, 1);
     END;
     INC(Idx);
    END;
   END;
   NEXT(Mtwo);
  END;  (* WHILE OCCURE(Mtwo) *)

  two05_AddRsrvToExitL(_Sort, trgWho);

  Manner:=E_two05_GetManner(P, _Sort, trgWho);

  Idx:=BegIdx;
  WHILE Idx <= EndIdx DO
   D:=L_two.Idx2Date(Idx, P);

   two05_PrepareCooExit(_Sort, D, trgWho);

   IF    Manner = 0 THEN
    IF E_two05_Need1Pass(D, _Sort, trgWho) THEN
     two05_Bind(D, _Sort, trgWho, s_Any, 1);
    ELSE
     two05_Bind(D, _Sort, trgWho, s_Prv, 1);
     two05_Bind(D, _Sort, trgWho, s_Nxt, 1);
    END;
   ELSIF Manner = 3 THEN
    two05_Bind3(D, _Sort, trgWho, s_Any);
   ELSIF Manner = 4 THEN
    two05_Bind4(D, _Sort, trgWho, s_Prv);
   ELSIF Manner = 5 THEN
    two05_Bind5(D, _Sort, trgWho, s_Any);
   ELSE
    L_General.CallUs(0);
   END;
   INC(Idx);
  END; (* WHILE Idx *)

  Idx:=BegIdx;
  WHILE Idx <= EndIdx DO
   D:=L_two.Idx2Date(Idx, P);

   IF E_two05_NeedSameExitInPairDays(D, _Sort, trgWho) THEN
    SELECT(Mwd, Sort, , _Sort, D);
    WHILE OCCURE(Mwd) DO
     SEARCH(Mtwo, Mtwo, , Mwd.Mtwo);
     IF ~E_two05_MtwoDoNotNeedSameExitInPairDays(D) &
         Dtwo_AccessByMtwo(D-1) & ~!Dtwo.ExitClss &
         (*~two05_IsRsrvExitClss(Dtwo.ExitClss) &*)
      SELECT(ExitL, ExitClss, _Sort, Dtwo.ExitClss, D) & !ExitL.TSN THEN
      two05_CloseCurrentExit(Idx);
     ELSE
      NEXT(Mwd);
     END;
    END; (* WHILE OCCURE(Mwd) ... *)
   END;

   IF    Manner = 0 THEN
    IF E_two05_Need1Pass(D, _Sort, trgWho) THEN
     two05_Bind(D, _Sort, trgWho, s_Any, 0);
    ELSE
     two05_Bind(D, _Sort, trgWho, s_Any, 1);
     two05_Bind(D, _Sort, trgWho, s_Prv, 0);
     two05_Bind(D, _Sort, trgWho, s_Nxt, 0);
    END;
   END;
   INC(Idx);
  END; (* WHILE Idx *)

  Unclosed:=0;
  Idx:=BegIdx;
  WHILE Idx <= EndIdx DO
   D:=L_two.Idx2Date(Idx, P);

   IF    Manner = 0 THEN
    IF ~E_two05_Need1Pass(D, _Sort, trgWho) THEN
     two05_Bind(D, _Sort, trgWho, s_Any, 0);
    END;
   ELSIF Manner = 3 THEN
    (* nothing *)
   ELSIF Manner = 4 THEN
    two05_Bind4(D, _Sort, trgWho, s_Nxt);
    two05_Bind4(D, _Sort, trgWho, s_Any);
   ELSIF Manner = 5 THEN
    (* nothing *)
   ELSE
    L_General.CallUs(0);
   END;

   IF SELECT(ExitL, Closed, _Sort, D, 0) & (Unclosed = 0) THEN
    INC(Unclosed);
    OPENREP(R, L_General.NameConnection(RepName), Create);
    MAKEPART(R, Top, RepName, P);
   END;

   SELECT(Mwd, Sort, , _Sort, D);
   WHILE OCCURE(Mwd) DO
    freeTSN:=Mwd.TSN;
    Pass0Cnd:=Mwd_HasRest(s_Prv);
    PassNbr:=0;
    Success:=0;
    REPEAT
     SELECT(ExitL, Closed, , _Sort, D, 1);
     WHILE OCCURE(ExitL) & ~Success DO
      trgTSN     :=ExitL.TSN;
      trgExitLNbr:=ExitL.ExitLNbr;
      L_two.StandOnMtwo(trgTSN, trgWho, P);
      IF (PassNbr > 0) | (Pass0Cnd = ~Dtwo_AccessByMtwo(D-1)) THEN
       IF !L_two.m_GF_ExitClss(D, ExitL.Change, 0) &
          (Mtwo.Source[L_two.MSrcIdx(Idx, L_two.da_ExitClss)] # L_BegRWS.twosrc_Operator) THEN
        SAVE(ExitL);
        SELECT(ExitL, Closed, , _Sort, D, 0);
        WHILE OCCURE(ExitL) & ~Success DO
         IF two05_IsAcceptableExitL(D, _Sort, trgWho) THEN
          freeExitLNbr:=ExitL.ExitLNbr;
          SAVE(ExitL);
          SAVE(Mtwo);
          L_two.StandOnMtwo(freeTSN, trgWho, P);
          SEARCH(ExitL, ExitLNbr, , _Sort, D, trgExitLNbr);
          IF two05_IsAcceptableExitL(D, _Sort, trgWho) THEN
           Success:=1;
          END;
          RESTORE(ExitL);
          RESTORE(Mtwo);
         END;
         NEXT(ExitL);
        END;
        RESTORE(ExitL);
       END;
      END;
      NEXT(ExitL);
     END; (* WHILE OCCURE(ExitL) ... *)
     INC(PassNbr);
    UNTIL Success | (PassNbr > 1);
    IF Success THEN
     L_two.StandOnMtwo(trgTSN, trgWho, P);
     SEARCH(ExitL, ExitLNbr, , _Sort, D, trgExitLNbr);
     two05_intCloseCurrentExit(Idx, -1, 0, "");
     SEARCH(ExitL, ExitLNbr, , _Sort, D, freeExitLNbr);
     two05_intCloseCurrentExit(Idx, +1, 0, trgTSN);
     MAKEPART(R, Line3, D, "             室 " + ExitL.ExitClss + " -> " + Mtwo.TSN);
     L_two.StandOnMtwo(freeTSN, trgWho, P);
     SEARCH(ExitL, ExitLNbr, , _Sort, D, trgExitLNbr);
     two05_CloseCurrentExit(Idx);
     MAKEPART(R, Line3, D, "             室 " + ExitL.ExitClss + " -> " + Mtwo.TSN);
    ELSE
     SEARCH(Mtwo, Mtwo, , Mwd.Mtwo);
     CONFORM(Mtwo, Staff);
     CONFORM(Staff, Man);
     MAKEPART(R, Line2, D);
     NEXT(Mwd);
    END;
   END; (* WHILE OCCURE(Mwd) ... *)

   SELECT(ExitL, Closed, , _Sort, D, 0);
   WHILE OCCURE(ExitL) DO
    PROMPT("஫  室: " + ExitL.ExitClss + ", " + L_DatTim.DateStr(D));
    SEARCH(StExit, Exit, , ExitL.Exit);
    MAKEPART(R, Line1, D);
    INC(Unclosed);
    NEXT(ExitL);
   END; (* WHILE OCCURE(ExitL) ... *)
   INC(Idx);
  END; (* WHILE Idx *)

  IF Unclosed > 0 THEN
   MAKEPART(R, Bot);
   CLOSEREP(R);
   LIKEMENU(Survey, "");
  END;
 END {two05_Do};

 PUBLIC PROCEDURE two05_Clear();
  VAR
   BegIdx,
   EndIdx,
   Idx     : NUMERIC[0];
   P       : DATE;
 BEGIN
  L_two.M_ConfirmOnMtwo(" १ ⮬᪮ ஢", 1);
  P:=Memo.ud_mb();
  BegIdx:=L_two.Date2Idx(P);
  EndIdx:=L_two.Date2Idx(L_DatTim.MonthEnd(P));
  SELECT(Mtwo, Per, , P);
  WHILE OCCURE(Mtwo) DO
   PROMPT(Mtwo.TSN);
   IF L_two.m_c_FitToFilter() THEN
    IF ~L_two.MHasSealedPlan() THEN
     Idx:=BegIdx;
     WHILE Idx <= EndIdx DO
      PROMPT(Mtwo.TSN + " ⪠: " + L_DatTim.DateStr(L_two.Idx2Date(Idx, Mtwo.Per)));
      IF ~!Mtwo.ExitClss[Idx] & (Mtwo.Source[L_two.MSrcIdx(Idx, L_two.da_ExitClss)] = L_BegRWS.twosrc_Auto) THEN
       ChangeMtwoExitClss("", Idx, L_BegRWS.twosrc_Regime);
      END;
      INC(Idx);
     END; (* WHILE Idx <= ... *)
    END;
   END; (* IF L_two.m_c_FitToFilter *)
   NEXT(Mtwo);
  END; (* WHILE OCCURE(Mtwo) ... *)
 END {two05_Clear};

END.
