(*
%Copyright   (c) Polak Computer System
%Author      UnKnown
%Purpose      ᯨᠭ ⥪饣 室
%Type        report
%Specific    AP
%Modified    17.04.2014 17:13:27 GAV
%Environment
*)

 MODULE TypeTT [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_DatTim, L_AFM, L_Str, Str, L_MSO,
        Memo, L_Way, P_Exit, Math, L_StdFrm, L_APtm, L_XDoc, L_bp;

 CONST
  MaxTripsInTTPart = 25;
  TripAm           = 101; (* - ३ᮢ *)
  StopAm           = 100; (* - ⠭  室 *)
  Width            = 152;
  LineSpacCoef     = 0.82;

  FontStyle = "U";

 VAR
  Stops         : LIKE(RtMStop.Stop)[StopAm];
  CurIdx,
  PrvIdx,
  NumStop,
  curTTPart     : NUMERIC[0];

  arrRoute      : LIKE(Route.Route)[TripAm];
  arrRun        : LIKE(RoutMod.Run)[TripAm];
  TripNo        : NUMERIC[0][TripAm];
  Times         : STRING[4][MaxTripsInTTPart];
  byCPActiveOnly: SCAL[2];

 PRIVATE PROCEDURE GetOnDaysByWords(Short: SCAL[2]): STRING[];
  CONST
   Mon = 1;
   Tue = 2;
   Wed = 4;
   Ths = 8;
   Fri = 16;
   Sat = 32;
   Sun = 64;
   Hol = 128;
   WrkDays = Mon+Tue+Wed+Ths+Fri;
   HldDays = Sat+Sun+Hol;
  VAR
   SumOnDays: NUMERIC[0];
 BEGIN
  SumOnDays:=Mon*StExit.OnDays[0] + Tue*StExit.OnDays[1] + Wed*StExit.OnDays[2] + Ths*StExit.OnDays[3] +
             Fri*StExit.OnDays[4] + Sat*StExit.OnDays[5] + Sun*StExit.OnDays[6] + Hol*StExit.OnDays[7];
  IF    SumOnDays = WrkDays THEN
   RETURN L_Str.PoolItem(" ࠡ稬 |", Short);
  ELSIF SumOnDays = HldDays THEN
   RETURN L_Str.PoolItem(" 室 |", Short);
  ELSIF SumOnDays = WrkDays+HldDays THEN
   RETURN L_Str.PoolItem(" ᥬ | ", Short);
  ELSE
   IF Short THEN
    RETURN Str.Cap(Str.Condense(L_Way.StExitOnDaysAsStr()));
   ELSE
    RETURN Str.Small(Str.Condense(L_Way.StExitOnDaysAsStr()));
   END;
  END;
 END {GetOnDaysByWords};

(*
$P {Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
"ᯨᠭ " + GetOnDaysByWords(0), C, ""
ExitClss.Sign, L, ""       "B U"
StExit.Change, L, " |1|2"  "B U"
StExit.BegTime, R, "H:M"   "B U"
StExit.StopTim, R, "H:M"   "B U"
StExit.Name, L, ""         "B U"
@
####################################################################################################################################### ########## #####
========================================================================================================================================================
|######################################################################################################################################################|
|                                  室 #######  # 륧 #####  ##### #################################                                   |
}
*)

(*
$P {SubTop:
TripNo[curTTPart*MaxTripsInTTPart+00], R, ""
TripNo[curTTPart*MaxTripsInTTPart+01], R, ""
TripNo[curTTPart*MaxTripsInTTPart+02], R, ""
TripNo[curTTPart*MaxTripsInTTPart+03], R, ""
TripNo[curTTPart*MaxTripsInTTPart+04], R, ""
TripNo[curTTPart*MaxTripsInTTPart+05], R, ""
TripNo[curTTPart*MaxTripsInTTPart+06], R, ""
TripNo[curTTPart*MaxTripsInTTPart+07], R, ""
TripNo[curTTPart*MaxTripsInTTPart+08], R, ""
TripNo[curTTPart*MaxTripsInTTPart+09], R, ""
TripNo[curTTPart*MaxTripsInTTPart+10], R, ""
TripNo[curTTPart*MaxTripsInTTPart+11], R, ""
TripNo[curTTPart*MaxTripsInTTPart+12], R, ""
TripNo[curTTPart*MaxTripsInTTPart+13], R, ""
TripNo[curTTPart*MaxTripsInTTPart+14], R, ""
TripNo[curTTPart*MaxTripsInTTPart+15], R, ""
TripNo[curTTPart*MaxTripsInTTPart+16], R, ""
TripNo[curTTPart*MaxTripsInTTPart+17], R, ""
TripNo[curTTPart*MaxTripsInTTPart+18], R, ""
TripNo[curTTPart*MaxTripsInTTPart+19], R, ""
TripNo[curTTPart*MaxTripsInTTPart+20], R, ""
TripNo[curTTPart*MaxTripsInTTPart+21], R, ""
TripNo[curTTPart*MaxTripsInTTPart+22], R, ""
TripNo[curTTPart*MaxTripsInTTPart+23], R, ""
TripNo[curTTPart*MaxTripsInTTPart+24], R, ""
@
|------------------------------------------------------------------------------------------------------------------------------------------------------|
|⠭                |####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|
|-------------------------|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|----|
}
*)

(*
$P {Line:
Stop.Stop, L, "" FontStyle
L_Way.GetStopName(Stop.Stop), L, "" FontStyle
Times[00], L, "" FontStyle
Times[01], L, "" FontStyle
Times[02], L, "" FontStyle
Times[03], L, "" FontStyle
Times[04], L, "" FontStyle
Times[05], L, "" FontStyle
Times[06], L, "" FontStyle
Times[07], L, "" FontStyle
Times[08], L, "" FontStyle
Times[09], L, "" FontStyle
Times[10], L, "" FontStyle
Times[11], L, "" FontStyle
Times[12], L, "" FontStyle
Times[13], L, "" FontStyle
Times[14], L, "" FontStyle
Times[15], L, "" FontStyle
Times[16], L, "" FontStyle
Times[17], L, "" FontStyle
Times[18], L, "" FontStyle
Times[19], L, "" FontStyle
Times[20], L, "" FontStyle
Times[21], L, "" FontStyle
Times[22], L, "" FontStyle
Times[23], L, "" FontStyle
Times[24], L, "" FontStyle
@
|### #####################|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|####|
}
*)

(*
$P {Bot:
@
=(c) Polak==============================================================================================================================================
}
*)

 PRIVATE PROCEDURE AlreadyIns(_Stop: LIKE(RtMStop.Stop);
                      Dir  : SCAL[2];
                      First: SCAL[2]): SCAL[2];
 BEGIN
  IF Dir = L_Way.dir_Forward THEN
   CurIdx:=0;
   WHILE CurIdx < NumStop DO
    IF Stops[CurIdx] = _Stop THEN
     IF First THEN
      RETURN 1;
     ELSE
      First:=1;
     END;
    END;
    INC(CurIdx);
   END;
   CurIdx:=0;
  ELSE
   CurIdx:=NumStop;
   WHILE CurIdx > 0 DO
    DEC(CurIdx);
    IF Stops[CurIdx] = _Stop THEN
     IF First THEN
      RETURN 1;
     ELSE
      First:=1;
     END;
    END;
   END;
  END;
  RETURN 0;
 END {AlreadyIns};

 PRIVATE PROCEDURE GetStopIdx(_Stop: LIKE(RtMStop.Stop); Dir: SCAL[2]): NUMERIC[0];
 BEGIN
  WHILE Stops[CurIdx] # _Stop DO
   IF Dir = L_Way.dir_Forward THEN
    CurIdx:=(CurIdx + 1) MOD NumStop;
   ELSE
    CurIdx:=(CurIdx + NumStop- 1) MOD NumStop;
   END;
  END;
  RETURN CurIdx;
 END {GetStopIdx};

 PRIVATE PROCEDURE CheckDir(Dir: SCAL[2]): SCAL[2];
 BEGIN
  IF Dir = L_Way.dir_Forward THEN
   RETURN CurIdx >= PrvIdx;
  ELSE
   RETURN CurIdx <= PrvIdx;
  END;
 END {CheckDir};

 PRIVATE PROCEDURE Ins(_Stop: LIKE(RtMStop.Stop); Dir: SCAL[2]);
  VAR
   i: NUMERIC[0];
 BEGIN
  IF NumStop = 0 THEN
   CurIdx:=0;
  ELSE
   IF Dir = L_Way.dir_Forward THEN
    CurIdx:=PrvIdx+1;
   ELSE
    CurIdx:=PrvIdx;
   END;
   i:=NumStop;
   WHILE i > CurIdx DO
    Stops[i]:=Stops[i-1];
    DEC(i);
   END;
  END;
  Stops[CurIdx]:=_Stop;
  PrvIdx       :=CurIdx;
  INC(NumStop);
 END {Ins};

 PRIVATE PROCEDURE TypeTT(InWord           : SCAL[2];
                          EmptyTrips       : SCAL[2][];
                          TripAmnt_ForPrint: NUMERIC[0]);
  VAR
   root      : STRING[];
   CurIdx,
   StopNumber,
   i,
   TripNumber: NUMERIC[0];
   HasActiveTime: SCAL[2];
 BEGIN
  IF InWord THEN
   L_MSO.wordInitDocument(Memo.ud_cd());
   i:=0;
   WHILE i < TripAmnt_ForPrint DO
    CurIdx:=curTTPart * TripAmnt_ForPrint + i;
    L_MSO.wordSetVar("StExit.SEJobs" + L_MSO.IndexStr(i) + ".Run", FLDTOSTR(arrRun[CurIdx], "1."));
    L_MSO.wordSetVar("StExit.SEJobs" + L_MSO.IndexStr(i) + ".Route", arrRoute[CurIdx]);
    L_MSO.wordSetVar("StExit.SEJobs" + L_MSO.IndexStr(i) + ".TripNo", L_Str.IntStr(TripNo[CurIdx]));
    INC(i);
   END;
  ELSE
   MAKEPART(R, SubTop);
  END;

  SETZERO(CurIdx, StopNumber);
  WHILE CurIdx < NumStop DO
   IF ~!Stops[CurIdx] THEN
    SEARCH(Stop, Stop, , Stops[CurIdx]);
    SETEMPTY(Times);
    SETZERO(i, HasActiveTime);
    WHILE i < TripAmnt_ForPrint DO
     TripNumber:=curTTPart * TripAmnt_ForPrint + i + 1;
     IF    SELECT(RtMSt, RtMSt, CurIdx, TripNumber) THEN
      Times[i]:=FLDTOSTR(RtMSt._StartT, "HM", 4);
      HasActiveTime:=1;
     ELSIF EmptyTrips[TripNumber] = 1 THEN
      Times[i]:="----";
     END;
     INC(i);
    END; (* WHILE i < TripAmnt_ForPrint*)
 
    IF HasActiveTime THEN
     IF InWord THEN
      root:="StExit.SEJobs.Route.RoutMod.RtMStop.Stop";
      L_MSO.wordSetVar(root + "[" + L_Str.IntStr(StopNumber) + "].Stop", Stop.Stop);
      L_MSO.wordSetVar(root + "[" + L_Str.IntStr(StopNumber) + "].Name", L_Way.GetStopName(Stop.Stop));
      i   :=0;
      root:=root + ".Time";
      WHILE i < TripAmnt_ForPrint DO
       IF Times[i] = "----" THEN
        L_MSO.wordSetVar(root + L_Str.IntStr(i) + "[" + L_Str.IntStr(StopNumber) + "].Hour",   "");
        L_MSO.wordSetVar(root + L_Str.IntStr(i) + "[" + L_Str.IntStr(StopNumber) + "].Minute", "--");
       ELSE
        L_MSO.wordSetVar(root + L_Str.IntStr(i) + "[" + L_Str.IntStr(StopNumber) + "].Hour",   Str.Slice(Times[i], 0, 2));
        L_MSO.wordSetVar(root + L_Str.IntStr(i) + "[" + L_Str.IntStr(StopNumber) + "].Minute", Str.Slice(Times[i], 2, 2));
       END;
       INC(i);
      END; (* WHILE i < TripAmnt_ForPrint...*)
      INC(StopNumber);
     ELSE
      MAKEPART(R, Line);
     END; (* IF InWord...*)
    END; (* IF HasActiveTime... *)
   END;
   INC(CurIdx);
  END; (* WHILE CurIdx < NumStop...*)

  IF InWord THEN
   L_MSO.SetWordTable("Stops", StopNumber);
   L_MSO.PutInTables:=L_MSO.Put_Values;
   L_MSO.PutInFields:=L_MSO.Put_Values;
   L_MSO.MakeWordDocument("TypeTT_1", 1, L_MSO.PrpMode_ToTmpDot, "TypeTT_0;;Here");
  END;
 END {TypeTT};

 PRIVATE PROCEDURE InMStops(_Stop     : LIKE(RtMStop.Stop);
                    VAR MStops: LIKE(RtMStop.Stop)[]): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE ~!MStops[i] & (MStops[i] # _Stop) DO
   INC(i);
  END;
  IF !MStops[i] THEN
   MStops[i]:=_Stop;
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {InMStops};

 PRIVATE PROCEDURE AllowedStop(TrpDir: SCAL[2]): SCAL[2];
 BEGIN
  RETURN (Stop.CPType > 0) & (~byCPActiveOnly | RtMStop.CPActive[TrpDir]);
 END {AllowedStop};

 PUBLIC PROCEDURE Make(InWord: SCAL[2]);
  CONST
   nwMax = 16;
  VAR
   EmptyTrips   : SCAL[2][TripAm];
   RtMDir,
   TrpDir,
   FirstPass    : SCAL[2];
   MStops       : LIKE(RtMStop.Stop)[100];
   LastStop     : LIKE(RtMStop.Stop);
   StopName,
   ExitFeature  : STRING[];
   TripNbr,
   wrkTripNbr,
   TripAmnt_ForPrint: NUMERIC[0];
   nwTripName   : STRING[20][nwMax];
   nwStartT,
   nwStopT      : STRING[5][nwMax];
   nwTripN      : SCAL[nwMax];
   curTrip      : LIKE(SEJobs.Trip);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(StExit), " ⠭ ⥪騩 室");

  IF InWord THEN
   IF L_XDoc.xdf_StandOnActualBy_iri(L_General.iri_GetCurrent("StExit"), L_XDoc.xdfk_DocOrig) THEN
    IF STDFORM(L_StdFrm.PartForm("%<  ⮢ >DB" +
                                 "%< ⮢  >B" +
                                 "%< ⮯! >Z" +
                                 "@" +
                                 "|" +
                                 " ⮢ 㬥  ᯨᠭ" +
                                 "|" +
                                 L_StdFrm.THR("६ ⮢ 㬥") +
                                 L_DatTim.TimestampStr(UNIVERSALTOLOCALTIMESTAMP(XDocFile.FileDTS)) +
                                 "|"+
                                 "|%###################% %###################% %#######%"),
                                 "",
                                 INFORM) = 1 THEN
     CALL(XDocFile.OpenFile());
     RETURN;
    END;
   END;
  END; (* IF InWord *)

  byCPActiveOnly:=1;

  IF ~InWord | ~L_APtm.IsOG() THEN
   STDFORM(L_StdFrm.sf_Choice("|%#############################%||",
                              "%,2< ஫ 㭪| ⬥⪠ ' ᯮ'>O"),
           "  ᯨᠭ 室 ",
           INFORM,
           1,
           byCPActiveOnly);
  END;

  APP.Get().NewPrompt(" ᯨᠭ");
  L_AFM.MakeIndex("RtMSt", "StopIdx: NUMERIC[0];"+
                           "_TripNo: NUMERIC[0];"+
                           "_StartT: LIKE(SEJobs.StartT);");
  TRY
   CONFORM(StExit, ExitClss);
   IF InWord THEN
    L_MSO.CreateTmpDot("TypeTT_0");
    TripAmnt_ForPrint:=nwMax;
   ELSE
    OPENREP(R, L_General.NameConnection("ExtTT"), Create);
    SetPrintAttr(R, FontProperty,    "/U /B /I",
                    TopMargin,       0,
                    BottomMargin,    0,
                    MinCharsPerLine, Width*LineSpacCoef,
                    SpreadChrInLine, Width,
                    Orientation,     Landscape,
                    MaxPages,        1);
    MAKEPART(R, Top);
    TripAmnt_ForPrint:=MaxTripsInTTPart;
   END;
   SETEMPTY(EmptyTrips, arrRun, arrRoute, nwTripName, nwStartT, nwStopT);
   NumStop  :=0;
   PrvIdx   :=0;
   CurIdx   :=0;
   nwTripN  :=0;
   LastStop :="";
   CONFORM(StExit, SEJobs);
   WHILE OCCURE(SEJobs) DO
    FirstPass:=1;
    CONFORM(SEJobs, RoutMod);
    IF  RoutMod.Run # 0 THEN
     TrpDir:=SEJobs.Dir;
     IF RoutMod.Dir = TrpDir THEN
      RtMDir:=L_Way.dir_Forward;
     ELSE
      RtMDir:=L_Way.dir_Backward;
     END;
     SETEMPTY(MStops);
     CONFORM(RoutMod, RtMStop);
     IF RtMDir = L_Way.dir_Backward THEN
      LAST(RtMStop);
     END;
     WHILE OCCURE(RtMStop) DO
      CONFORM(RtMStop, Stop);
      IF FirstPass & ~!LastStop & (LastStop # RtMStop.Stop) THEN
       PROMPT(SEJobs.Trip);
       StopName:=L_Way.GetStopName(Stop.Stop);
       SAVE(Stop);
       SEARCH(Stop, Stop , , LastStop);
       STDMSG("襭 ᫥⥫쭮 ⠭.|" +
              "筠 ⠭  " + LastStop + " " + L_Way.GetStopName(Stop.Stop) + "|" +
              "砫쭠 ⠭ " + RtMStop.Stop + " " + StopName, CHOICE);
       RESTORE(Stop);
      END;
      IF AllowedStop(TrpDir) THEN
       PROMPT(SEJobs.Trip + " " + RtMStop.Stop);
       IF AlreadyIns(RtMStop.Stop, TrpDir, ~InMStops(RtMStop.Stop, MStops)) THEN
        IF ~CheckDir(TrpDir) & ~AlreadyIns(RtMStop.Stop, TrpDir, 0) THEN
         Ins(RtMStop.Stop, TrpDir);
        ELSE
         PrvIdx:=CurIdx;
        END;
       ELSE
        Ins(RtMStop.Stop, TrpDir);
       END;
      END;
      IF RtMDir = L_Way.dir_Forward THEN
       NEXT(RtMStop);
      ELSE
       PREV(RtMStop);
      END;
      IF OCCURE(RtMStop) THEN
       FirstPass:=0;
       LastStop:=RtMStop.Stop;
      END;
     END; (* WHILE OCCURE(RtMStop) ... *)
    ELSE
     LastStop:="";
    END;
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs) ... *)
   IF NumStop = 0 THEN
    STDMSG(" ⠭   ⨯ |ᯨᠭ 㤥 ⮥", INFORM);
   END;
   SETEMPTY(TripNo);
   TripNbr:=1;
   wrkTripNbr:=1;
   CONFORM(StExit, SEJobs);
   WHILE OCCURE(SEJobs) DO
    CONFORM(SEJobs, RoutMod);
    IF RoutMod.Run # 0 THEN
     arrRun[TripNbr-1]:=RoutMod.Run;
     CONFORM(SEJobs, WJMode);
     IF WJMode.RunSel = L_Way.runsel_Work THEN
      TripNo[TripNbr-1]:=wrkTripNbr;
      INC(wrkTripNbr);
     END;
     EmptyTrips[TripNbr]:=0;
     TrpDir:=SEJobs.Dir;
     IF RoutMod.Dir = TrpDir THEN
      RtMDir:=L_Way.dir_Forward;
     ELSE
      RtMDir:=L_Way.dir_Backward;
     END;
     IF TrpDir = L_Way.dir_Forward THEN
      CurIdx:=0;
     ELSE
      CurIdx:=NumStop-1;
     END;
     CONFORM(RoutMod, RtMStop);
     IF RtMDir = L_Way.dir_Forward THEN
      FIRST(RtMStop);
     ELSE
      LAST(RtMStop);
     END;
     WHILE OCCURE(RtMStop) DO
      CONFORM(RtMStop, Stop);
      IF AllowedStop(TrpDir) THEN
       PROMPT(SEJobs.Trip + " " + RtMStop.Stop);
       RtMSt._StartT:=L_Way.GetStopCtrlTime_ofCurSEJobs(SYSDATE());
       RtMSt.StopIdx:=GetStopIdx(RtMStop.Stop, TrpDir);
       RtMSt._TripNo:=TripNbr;
       IF TrpDir = L_Way.dir_Forward THEN
        CurIdx:=(CurIdx + 1) MOD NumStop;
       ELSE
        CurIdx:=(CurIdx + NumStop- 1) MOD NumStop;
       END;
       INSERT(RtMSt);
       curTrip:=SEJobs.Trip;
      END; (* IF AllowedStop(TrpDir) ... *)
      IF RtMDir = L_Way.dir_Forward THEN
       NEXT(RtMStop);
      ELSE
       PREV(RtMStop);
      END;
     END; (* WHILE OCCURE(RtMStop) ... *)
    ELSE
     EmptyTrips[TripNbr]:=1;
     IF InWord THEN
      nwTripName[nwTripN]:=RoutMod.Name;
      nwStartT  [nwTripN]:=L_DatTim.TimeStr(SEJobs.StartT);
      nwStopT   [nwTripN]:=L_DatTim.TimeStr(SEJobs.StopT);
      INC(nwTripN);
     END;
    END; (* IF RoutMod.Run # 0...*)
    arrRoute[TripNbr-1]:=RoutMod.Route;
 
    INC(TripNbr);
    NEXT(SEJobs);
   END; (* WHILE OCCURE(SEJobs) ... *)
 
   DEC(TripNbr);
   curTTPart:=0;
   WHILE (curTTPart * TripAmnt_ForPrint) < TripNbr DO
    TypeTT(InWord, EmptyTrips, TripAmnt_ForPrint);
    INC(curTTPart);
   END; (* WHILE (curTTPart * TripAmnt_ForPrint) < TripNbr...*)
   IF InWord THEN
    L_MSO.wordInitDocument(L_DatTim.MonthBeg(Memo.ud_cd()));
    L_MSO.wordSetVarsByFile("StExit");
    L_MSO.wordSetVar("StExit.Kind",       GetOnDaysByWords(0));
    L_MSO.wordSetVar("StExit.Kind.Short", GetOnDaysByWords(1));
    L_MSO.wordSetVar("StExit.Change", L_Str.PoolItem(" |1|2", StExit.Change));
    ExitFeature:=P_Exit.GetProValueSoft(StExit.Exit, Math.Max(Memo.ud_cd(), StExit.FromD), P_Exit.P_ExitFeature);
    IF ~!ExitFeature THEN
     ExitFeature:="ਬ砭: "+ExitFeature;
    END;
    L_MSO.wordSetVar("StExit.P_ExitFeature", ExitFeature);
    FOR_EACH nwTripN DO
     L_MSO.wordSetVar("StExit.SEJobs.RoutMod.Name"+L_MSO.IndexStr(nwTripN), nwTripName[nwTripN]);
     L_MSO.wordSetVar("StExit.SEJobs"+L_MSO.IndexStr(nwTripN)+".StartT.Hour",   Str.Item(nwStartT[nwTripN], ":", 0));
     L_MSO.wordSetVar("StExit.SEJobs"+L_MSO.IndexStr(nwTripN)+".StartT.Minute", Str.Item(nwStartT[nwTripN], ":", 1));
     L_MSO.wordSetVar("StExit.SEJobs"+L_MSO.IndexStr(nwTripN)+".StopT.Hour",    Str.Item(nwStopT[nwTripN], ":", 0));
     L_MSO.wordSetVar("StExit.SEJobs"+L_MSO.IndexStr(nwTripN)+".StopT.Minute",  Str.Item(nwStopT[nwTripN], ":", 1));
    END;
    L_MSO.wordSetVarsByFile("StExit");
    L_MSO.wordSetVarsByFile_wAlias("ExitClss", "StExit.ExitClss");
    L_MSO.wordSetVar("StExit.ExitClss.SignAndName", ExitClss.Sign+" - "+StExit.Name);
    L_MSO.UseTmpDot:=1;

    IF L_APtm.IsOG() THEN
     L_MSO.MakeXDFWordDocument(L_General.iri_GetCurrent("StExit"), "TypeTT_0", 1, L_MSO.PrpMode_ToDoc);
    ELSE
     L_MSO.MakeWordDocument("TypeTT_0", 1, L_MSO.PrpMode_ToDoc, "");
    END;
   ELSE
    MAKEPART(R, Bot);
    CLOSEREP(R);
    L_General.SurveyLastReport();
   END;
  EXCEPT
  FINALLY
   L_AFM.AF_PurgeTemp("RtMSt");
  END; (* TRY *)
 END {Make};

(*
$P {Top_TypeT:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                             ⮢ ᯨᠭ  ⥫  ###########                              |
|------------------------------------------------------------------------------------------------------------|
|室    |ᠭ ஡                                                                                 |
|---------|--------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ Line_TypeT:
StExit.Exit, L, ""
?, L, ""
@
|#########|##################################################################################################|
}
*)

(*
$P{Bot_TypeT:
@
=(c) Polak====================================================================================================
}
*)

 PUBLIC PROCEDURE MakeAllInWord();
  CONST
   bpId = "TypeT";
 BEGIN
  L_bp.Begin(bpId, "⮢ ᯨᠭ  ⥫  ", L_bp.t_Prc_wRp, L_General.tc_onDate);
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   IF ~L_bp.IAmInQueue() THEN
    L_General.BatchExecution_Begin(L_General.curUSER);
   END;
   OPENREP(R, L_General.rfn_byConnection(bpId + "_" + FLDTOSTR(Memo.ud_cd(), "y_N_D")), Create);
   MAKEPART(R, Top_TypeT, bpId, Memo.ud_cd());
   SETSEL(StExit, Strict, L_Way.ExitStrict_Reg);
   SRCINSEL(StExit, GT, , Memo.ud_cd());
   WHILE OCCURE(StExit) DO
    PROMPT(StExit.Exit);
    IF L_Way.StExitActiveOnDate(StExit.Exit, Memo.ud_cd()) THEN
     IF ~L_XDoc.xdf_StandOnActualBy_iri(L_General.iri_GetCurrent("StExit"), L_XDoc.xdfk_DocOrig) THEN
      TRY [RESTORE_CURSORS(RC_ON), TRANSACTION(TRANSACTION_SLAVE)]
       GETLASTVERSION(StExit);
       Make(1);
      EXCEPT
      ON Exc: Exc_Root DO
       MAKEPART(R, Line_TypeT, Exc.Description);
      END;
     END;
    END;
    NEXT(StExit);
   END;
  EXCEPT
  FINALLY
   MAKEPART(R, Bot_TypeT);
   IF ~L_bp.IAmInQueue() THEN
    L_General.BatchExecution_End();
   END;
  END;
  L_bp.End();
 END {MakeAllInWord};

END.
