(*
%Copyright   (c) Polak Computer System
%Author      04.02.1998 17:22:49 SAN
%Purpose
%Type        report
%Specific    AP
%Modified    30.07.2014 18:32:29 POLAK\GAV
%Environment
*)

 IMPORT L_General, L_DatTim, L_PRoll, L_OwnData, E_UI, L_Man, Math, Str, Memo;

 VAR
  FullBal,
  CorBal,
  TimDone,
  LineT    : NUMERIC[3];
  RW_Tot,
  RW_UnD   : NUMERIC[0];
  IncPl,
  IncFc    : NUMERIC[2];
  IncPrc   : NUMERIC[2];

(*
$P{ TimeTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, "D.N.Y"
?, L, "D.N.Y"
L_Man.GetTakeOnDate(SYSDATE()), L, "D.N.Y"
Math.Min(L_Man.GetTimedContractEndDate(SYSDATE()), L_Man.GetRealEndDate(SYSDATE())), L, "D.N.Y"
"⭨ " + Staff.TSN + " " + Man.Name, C, ""
TimDone, R, "3."
RW_Tot, R, "0"
LineT, R, "3."
RW_UnD, R, "0"
FullBal, R, "3."
IncPl, R, "2-"
CorBal, R, "3."
IncFc, R, "2-"
Str.Item("ࠡ⪠|ࠡ⪠", "|", TimDone >= CorBal), L, ""
Math.Abs(TimDone - CorBal), R, "3."
IncFc-IncPl, R, "2-"
IncPrc, R, "2."
@
############################################################# ########## #####
==============================================================================
|ࠡ⪠  ਮ  ########  ######## (ࠪ  ########  ########)|
|############################################################################|
|----------------------------------------------------------------------------|
|ࠡ⠭ ᥣ       #######  |        ⥢ ᥣ                 ###  |
|  ⮬ ᫥    #######  |          ⮬ ᫥ ࠡ⠭   ###  |
|----------------------------------------------------------------------------|
|ଠ                  #######  |窠:  ############# .           |
|४஢ ଠ #######  |         䠪 ############# .           |
|           ########### #######  |         +/-  ############# .  ###### % |
|============================================================================|
|                        ६   ࠡ                                |
|----------------------------------------------------------------------------|
|                                                   |                ६|
|------------------------------------------------------|---------------------|
}
*)

(*
$P{ MLine:
Money.MCode L ""
MCList.Name L ""
Money.Tim   R "3."
@
|### ##################################################|#####################|
}
*)

(*
$P{ MBot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE RunLocalProc(Local: PROC): SCAL[2];
 BEGIN
  L_General.Assert(~!Local, " 'ࠡ⪠, 窠'  ஥");
  RETURN Local(Monthly.MtyIdx);
 END {RunLocalProc};

 PRIVATE PROCEDURE GetGate(VAR D1, D2: DATE);
 BEGIN
  D1:=L_DatTim.MaxDATE(Staff.BegDate, D1);
  D2:=L_DatTim.MinDATE(Staff.EndDate, D2);
 END {GetGate};

 PRIVATE PROCEDURE _TimeByTSN(F, U: DATE);
  VAR
   D     : DATE;
   _Tim  : LIKE(Sheet.Tim);
   _Corr : NUMERIC[3];
 BEGIN
  SETZERO(RW_Tot, RW_UnD, IncPl, IncFc, IncPrc);
  SETZERO(TimDone, LineT, FullBal, CorBal, _Corr);
  GetGate(F, U);
  D:=F;
  WHILE D <= U DO
   HISTCONF(D, Staff, StaffLog);
   IF OCCURE(StaffLog) THEN
    L_General.Assert(SEARCH(RegList, HumReg, StaffLog.Regime, L_DatTim.Per(D), L_DatTim.DAY(D)),
                     "  ० ࠡ "+StaffLog.Regime+"  "+L_DatTim.DateStr(D));
    PROMPT(L_DatTim.DateStr(RegList.Period+RegList.Day-1));
    IF SEARCH(Sheet, TSN, Staff.TSN, L_DatTim.Per(D), L_DatTim.DAY(D)) THEN
     CONFORM(Sheet,   JMode);
     _Tim:=Sheet.Tim;
    ELSE
     CONFORM(RegList, JMode);
     _Tim:=RegList.GrTime;
    END;
    IF    JMode.Type = 2 THEN
     INC(TimDone, _Tim);
    ELSIF JMode.DecrBal THEN
     INC(_Corr, _Tim);
    END;
    INC(FullBal, RegList.Durat);
   END;
   INC(D);
  END;

  CorBal:=FullBal-_Corr;

  SELECT(Monthly, TSN, , Staff.TSN, L_DatTim.Per(F));
  WHILE OCCURE(Monthly) DO
   IF    RunLocalProc(PROCREF(E_UI.IsLineTime)) THEN
    INC(LineT, Monthly.Proof);
   ELSIF RunLocalProc(PROCREF(E_UI.IsIncPlan)) THEN
    INC(IncPl, Monthly.Proof);
   ELSIF RunLocalProc(PROCREF(E_UI.IsIncFact)) THEN
    INC(IncFc, Monthly.Proof);
   END;
   NEXT(Monthly);
  END; (* WHILE OCCURE(Monthly)... *)
  IF IncPl > 0 THEN
   IncPrc:=IncFc/IncPl * 100;
  ELSE
   IncPrc:=0;
  END;
  SELECT(RWayS, TSN, , Staff.TSN);
  SRCINSEL(RWayS, GE, , F);
  WHILE OCCURE(RWayS) & (RWayS.Date <= U) DO
   PROMPT("⥢  " + L_DatTim.DateStr(RWayS.Date));
   IF RWayS.Status > 0 THEN
    INC(RW_Tot);
    IF ~RWayS.Done THEN
     INC(RW_UnD);
    END;
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS)... *)
  SELECT(WayLMen, TSN, , Staff.TSN);
  SRCINSEL(WayLMen, GE, , F);
  WHILE OCCURE(WayLMen) & (WayLMen.RWayDate <= U) DO
   CONFORM(WayLMen, RWayS);
   PROMPT("⥢  " + L_DatTim.DateStr(RWayS.Date));
   INC(RW_Tot);
   IF ~RWayS.Done THEN
    INC(RW_UnD);
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen)... *)
  MAKEPART(R, TimeTop, F, U);
 END {_TimeByTSN};

 PRIVATE PROCEDURE _MoneyByTSN(F, U: DATE);
 BEGIN
  SELECT(Money, TSN, , Staff.TSN, F);
  WHILE OCCURE(Money) DO
   PROMPT(Money.MCode);
   IF (Money.Source = L_PRoll.src_RWayS) & (Money.WFPeriod = F) & (Money.Tim # 0) THEN
    CONFORM(Money, MCList);
    MAKEPART(R, MLine);
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money)... *)
 END {_MoneyByTSN};

 PRIVATE PROCEDURE MoneyAndTimeByTSN();
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  CONFORM(Staff, Man);
  _TimeByTSN(Memo.ud_fr(), Memo.ud_ut());
  _MoneyByTSN(Memo.ud_fr(), Memo.ud_ut());
  MAKEPART(R, MBot);
 END {MoneyAndTimeByTSN};

BEGIN
 IF MODE = 100 THEN (* ᮢ饭  ࠡ⪠  ६   ࠡ*)
  MoneyAndTimeByTSN();
 END;
END.
