(*
%Copyright   (c) Polak Computer System
%Author      04.02.2002 20:24:06 GAV
%Purpose     
%Type        control
%Specific    AP
%Modified    13.08.2014 11:06:28 POLAK\LDA
%Environment
*)

 MODULE VehPasp [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_DatTim, L_StdFrm, L_Str, Str, L_Car,
        Memo, L_OwnData, L_CUC, L_Russia, L_AcsPnt, L_WDO, L_DBD;

 PUBLIC PROCEDURE MakeCopy();
 BEGIN
  ACCESS(VehPasp);
  L_WDO.LaunchInsertBySource(VehPasp.VehPasp, "");
 END {MakeCopy};

 PRIVATE PROCEDURE ReflectInCarLog();
  VAR
   HasCarLog  : SCAL[2];
   CarLogDateE: DATE;
 BEGIN
  HasCarLog:=SELECT(CarLog, VehPasp, VehPasp.VehPasp);
  IF HasCarLog THEN
   LAST(CarLog);
   L_General.Assert(CarLog.Date <= VehPasp.Till,
                    "  뫠 ᠭ  " + CarLog.BoxNbr + "  " + L_DatTim.DateStr(CarLog.Date));
   NEXT(VehPasp);
   IF    CarLog.Date = VehPasp.Begin THEN
    CarLog.VehPasp:=VehPasp.VehPasp;
    REPLACE(CarLog);
   ELSIF CarLog.DateE >= VehPasp.Begin THEN
    CarLogDateE :=CarLog.DateE;
    CarLog.DateE:=VehPasp.Begin - 1;
    REPLACE(CarLog);
    CarLog.Date   :=VehPasp.Begin;
    CarLog.VehPasp:=VehPasp.VehPasp;
    CarLog.DateE  :=CarLogDateE;
    INSERT(CarLog);
   END;
   CHANGESEL(CarLog, BoxNbr, , CarLog.BoxNbr);
   IF NEXT(CarLog) THEN
    L_StdFrm.Inform(" ᠭ  " + CarLog.BoxNbr + "   ᫥ " + L_DatTim.DateStr(VehPasp.Begin) +
                    "|᫨ ॡ, ᫥ 㪠    .");
   END;
  END;
 END {ReflectInCarLog};

 PRIVATE PROCEDURE intMakeCopy(srcVehPasp: LIKE(VehPasp.VehPasp));
 BEGIN
  L_DBD.CopyFromSrcRecord("VehPasp", srcVehPasp);
  REPLACE(VehPasp);
 END {intMakeCopy};

 PRIVATE PROCEDURE VehPasp_OnBeforeInsert();
  VAR
   srcVehPasp: LIKE(VehPasp.VehPasp);
 BEGIN
  srcVehPasp:=L_WDO.GetInsertionSource();
  IF ~!srcVehPasp THEN
   intMakeCopy(srcVehPasp);
  END;
 END {VehPasp_OnBeforeInsert};

 PRIVATE PROCEDURE intFillVehPaspByMark();
 BEGIN
  CONFORM(VehPasp, Mark);
  CheckConvergence("VehPasp.MarkName", "Mark.Name",     "",       "");
  CheckConvergence("VehPasp.EngPower", "Mark.EngPower", "魮 ⥫", "");
  CheckConvergence("VehPasp.EngVol",   "Mark.EngVol",   " ⥫",    "");
  CheckConvergence("VehPasp.EnginTyp", "Mark.EnginTyp", " ⥫",      "");
  CheckConvergence("VehPasp.VehType",  "Mark.VehType",  " ",             "");
  CheckConvergence("VehPasp.MaxWeigh", "Mark.MaxWeigh", "ᨬ쭠 ࠧ񭭠 ", "");
  CheckConvergence("VehPasp.NetWeigh", "Mark.NetWeigh", "񭭠 ",  "");
  REPLACE(VehPasp);
 END {intFillVehPaspByMark};

 PUBLIC PROCEDURE FillVehPaspByMark();
 BEGIN
  L_General.Assert(~!VehPasp.Mark, " ન  㪠");
  intFillVehPaspByMark();
 END {FillVehPaspByMark};

 PRIVATE PROCEDURE CheckConvergence(_Field1, _Field2, Description, Suffix: STRING[]);
 BEGIN
  IF !^_Field1 THEN
   ^_Field1:=^_Field2;
  ELSIF ~!^_Field2 THEN
   IF ^_Field1 # ^_Field2 THEN
    IF STDFORM(" |" + Description + " ࠭ ન|" +
               " ᮮ⢥ 㪠" + Suffix + "  .| |" +
               L_StdFrm.DrawButton("ਢ  ᮮ⢥⢨", 48, "DB")+ "|" +
               L_StdFrm.DrawButton("⠢ ஥ 祭", 48, "B")+ "|" +
               L_StdFrm.DrawButton("⬥", 48, "Z"),
               "",
               INFORM) = 1 THEN
     ^_Field1:=^_Field2;
    END;
   END;
  END;
 END {CheckConvergence};

 PRIVATE PROCEDURE VehPasp_Mark_OnSuccessfulChange();
 BEGIN
  IF ~!VehPasp.Mark THEN
   intFillVehPaspByMark();
  END;
 END {VehPasp_Mark_OnSuccessfulChange};

 PRIVATE PROCEDURE VehPasp_Country_OnSuccessfulChange();
 BEGIN
  L_Russia.Check_MayChooseCountry("VehPasp", VehPasp.Country)
 END {VehPasp_Country_OnSuccessfulChange};

 PRIVATE PROCEDURE VehPasp_StateNbr_OnSuccessfulChange();
 BEGIN
  VehPasp.StateNbr:=L_Car.E_GetCorrectedStateNbr(VehPasp.StateNbr, 1);
  REPLACE(VehPasp);
 END {VehPasp_StateNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE VehPasp_AfterEdIns();
  VAR
   D: DATE;
 BEGIN
  L_General.Assert(VehPasp.Begin < VehPasp.Till, " ' '   ࠭  ''");
  IF ~!VehPasp.RegRemvD THEN
   L_General.Assert(VehPasp.RegRemvD < VehPasp.Till, "        ' '");
  END;

  L_Car.CheckVIN(VehPasp.VIN);

  IF VehPasp.TTPayer # L_Car.ttp_ThirdParty THEN
   L_General.Assert(~!VehPasp.EngPower, "  ࠭ᯮ⭮ |  㪠 魮  ⥫  ..");
   L_General.Assert(~!VehPasp.EngPwKWt, "  ࠭ᯮ⭮ |  㪠 魮  ⥫  ");
   L_General.Assert(~!VehPasp.EcoCls,   "  ࠭ᯮ⭮ |  㪠 ᪨  ");
   L_General.Assert(~!VehPasp.VehType,  "  ࠭ᯮ⭮ |  㪠 ⨯ ");
   L_General.Assert(~!VehPasp.GiveDate, "   ' 뤠 '");
  END;

  D:=VehPasp.Begin;
  CHANGESEL(VehPasp, VPNbr, , VehPasp.VPNbr);
  SAVE(VehPasp);
  IF PREV(VehPasp) THEN
   IF !VehPasp.Till THEN
    L_StdFrm.Choice("  " + VehPasp.VehPasp + "  " + L_DatTim.DateStr(D) + "?");
    VehPasp.Till:=D;
    REPLACE(VehPasp);
    ReflectInCarLog();
   ELSE
    L_General.Assert(VehPasp.Till <= D, "ਮ ਬ ᥪ  ।騬");
   END;
  END;
  RESTORE(VehPasp);
  D:=VehPasp.Till;
  SAVE(VehPasp);
  L_General.Assert(~NEXT(VehPasp) | (VehPasp.Begin >= D), "ਮ ਬ ᥪ  ᫥騬");
  RESTORE(VehPasp);

  L_DBD.CheckValidity("VehPasp");

  SETSEL(CarLog, VehPasp, VehPasp.VehPasp);
  IF SRCINSEL(CarLog, LT, VehPasp.Till) THEN
   L_Car.CheckCarLogToVehPaspCompliance();
  END;
 END {VehPasp_AfterEdIns};

 PRIVATE PROCEDURE VehPasp_OnAfterInsert();
 BEGIN
  VehPasp_AfterEdIns();
 END {VehPasp_OnAfterInsert};

 PRIVATE PROCEDURE VehPasp_OnAfterEdit();
 BEGIN
  VehPasp_AfterEdIns();
 END {VehPasp_OnAfterEdit};

 PRIVATE PROCEDURE CheckEngineCUCopy();
  VAR
   f        : FORM_FIELD;
   CUCSerial: LIKE(CUCopy.Serial);
   D        : DATE;
 BEGIN
  f:=RTI.Get().CurZone.Fields("v_CUCSerial");
  IF L_CUC.EngineAcntLev() THEN
   IF ~!VehPasp.Till THEN
    D:=VehPasp.Till;
   ELSE
    D:=Memo.ud_cd();
   END;
   IF L_Car.StandOnCarLogFromVehPasp(VehPasp.VehPasp, D) THEN
    CUCSerial:=L_Car.GetEngineCUCopySerial();
    IF ~!CUCSerial THEN
     IF CUCSerial # VehPasp.EnginNum THEN
      f.Value:="    ⥫ " + CUCSerial;
      f.Color:=FORM_FIELD.Color_Field2;
     ELSE
      f.Value:=" ⥫ ᮮ⢥ ୮ ";
      f.Color:=FORM_FIELD.Color_Field4;
     END;
    ELSE
     f.Value:="   ⥫    ⠭";
     f.Color:=FORM_FIELD.Color_Field2;
    END;
   ELSE
    f.Value:="  ᮯ⠢   " + L_DatTim.DateStr(D);
    f.Color:=FORM_FIELD.Color_Field2;
   END;
  ELSE
   f.Value:=" ";
   f.Color:=FORM_FIELD.Color_Field4;
  END;
 END {CheckEngineCUCopy};

 PRIVATE PROCEDURE VehPasp_EnginNum_OnSuccessfulChange();
 BEGIN
  CheckEngineCUCopy();
 END {VehPasp_EnginNUm_OnSuccessfulChange};

 PRIVATE PROCEDURE VehPasp_Till_OnSuccessfulChange();
 BEGIN
  CheckEngineCUCopy();
 END {VehPasp_Till_OnSuccessfulChange};

 PRIVATE PROCEDURE VehPaspE_0_OnReposition();
 BEGIN
  CheckEngineCUCopy();
 END {VehPaspE_0_OnReposition};

 PRIVATE PROCEDURE VehPaspE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="VehPasp";
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterInsert, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["VehPasp.EnginNum", "VehPasp.StateNbr", "VehPasp.Country", "VehPasp.Mark", "VehPasp.Till"]);
  L_WDO.iUnmodifiable(0, ["v_CUCSerial", "VehPasp.OwnerShp", "VehPasp.VehPasp"]);
  L_WDO.iMayBeEmpty  (0, ["VehPasp.EnginNum", "VehPasp.EnginMod", "VehPasp.ChassNum", "VehPasp.Producer", "VehPasp.CertDate", "VehPasp.StateNbr",
                          "VehPasp.CertOrg", "VehPasp.RegRemvD", "VehPasp.SaleDate", "VehPasp.SaleDoc", "VehPasp.BodyNum", "VehPasp.VPGivAdr",
                          "VehPasp.CustDNum", "VehPasp.VPGiver", "VehPasp.CustLim", "VehPasp.ApprGive", "VehPasp.ApprNum", "VehPasp.ApprDate",
                          "VehPasp.Country", "VehPasp.CertNum", "VehPasp.NetWeigh", "VehPasp.EnginTyp", "VehPasp.Color", "VehPasp.MaxWeigh",
                          "VehPasp.EngVol", "VehPasp.Till", "VehPasp.EngPwKWt", "VehPasp.EngPower", "VehPasp.EcoCls", "VehPasp.VehType",
                          "VehPasp.GiveDate"]);
  L_WDO.iField       (0, "OwnerShp").Format      :=L_Car.OwnS_VehPPool;
  L_WDO.iField       (0, "VehPasp.EcoCls").Format:=L_Car.EcoCls_VehPPool;
 END {VehPaspE_OnInitializeWindow};

 PRIVATE PROCEDURE VehType_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, "");
  L_WDO.iSubwindow   (1, "VehTypeE");
  L_WDO.iUnmodifiable(1, ["VehType.VehType"]);
  L_WDO.iField       (1, "VehType.IRC_VehT").Format:=L_Car.IRC_VehTPool;
 END {VehType_OnInitializeWindow};

 PRIVATE PROCEDURE VehTypeE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, "");
  L_WDO.iUnmodifiable(0, ["VehType.VehType"]);
  L_WDO.iField       (0, "VehType.IRC_VehT").Format:=L_Car.IRC_VehTPool;
  L_WDO.iField       (0, "VehType.Tax_VehT").Format:=L_Car.Tax_VehTPool;
 END {VehTypeE_OnInitializeWindow};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
"  "+L_Car.VehPaspNbr_AsStr()+", 뤠 "+L_DatTim.DateStr(VehPasp.GiveDate)+" "+VehPasp.VPGiver, C, ""
@
############################################################## ########## #####
=#####=========================================================================
|#############################################################################|
|-----------------------------------------------------------------------------|
|                              |            ᠭ              |
|---------------------------------------|-------------------------------------|
|   |.ॣ.|.  |. |.|.ॣ.|.  |. |
}
*)

(*
$P{ Line:
VehPasp.VehPasp, L, ""
VehPasp.StateNbr, L, ""
VehPasp.Begin, L, "D.N.y"
VehPasp.Till, L, "D.N.y"
CarLog.BoxNbr, L, ""
CarLog.StateNbr, L, ""
CarLog.Date, L, "D.N.y"
CarLog.DateE, L, "D.N.y"
@
|------|----------|----------|----------|----|----------|----------|----------|
|######|##########|##########|##########|####|##########|##########|##########|
}
*)

(*
$P{ SecondLine:
CarLog.BoxNbr, L, ""
CarLog.StateNbr, L, ""
CarLog.Date, L, "D.N.y"
CarLog.DateE, L, "D.N.y"
@
|      |          |          |          |####|##########|##########|##########|
}
*)

(*
$P{ NoCarLogLine:
VehPasp.VehPasp, L, ""
VehPasp.StateNbr, L, ""
VehPasp.Begin, L, "D.N.y"
VehPasp.Till, L, "D.N.y"
@
|------|----------|----------|----------|----|----------|----------|----------|
|######|##########|##########|##########|    |          |          |          |
}
*)

(*
$P{ Bot:
@
=(c) Polak=====================================================================
}
*)

 PUBLIC PROCEDURE History();
  CONST
   RepName = "VPHis";
  VAR
   HasCarLog: SCAL[2];
   _BoxNbr  : LIKE(Car.BoxNbr);
 BEGIN
  L_General.Assert(ACCESS(VehPasp), " ⠭ ");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  SETEMPTY(_BoxNbr);
  SELECT(VehPasp, VPNbr, , VehPasp.VPNbr);
  WHILE OCCURE(VehPasp) DO
   HasCarLog:=0;
   IF SELECT(CarLog, VehPasp, VehPasp.VehPasp) THEN
    IF !_BoxNbr THEN
     _BoxNbr:=CarLog.BoxNbr;
    END;
    WHILE OCCURE(CarLog) DO
     L_General.Assert((_BoxNbr = CarLog.BoxNbr) | L_AcsPnt.MayPassAccessPoint(0000029),
                      "   稩  믮 ⮩ 樨");
     IF HasCarLog THEN
      MAKEPART(R, SecondLine);
     ELSE
      MAKEPART(R, Line);
      HasCarLog:=1;
     END;
     NEXT(CarLog);
    END; (* WHILE OCCURE(CarLog) ... *)
   END; (* SELECT(CarLog... *)
   IF ~HasCarLog THEN
    MAKEPART(R, NoCarLogLine);
   END;
   NEXT(VehPasp);
  END; (* WHILE OCCURE(VehPasp) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {History};

BEGIN
 L_Events.ExecuteHandler();
END.
