(*
%Copyright   (c) Polak IT
%Author      28.08.2003 14:54:02 POLAK\GAV
%Purpose     ᯮ짮  ⠢. Excel.
%Type        report
%Specific    LOC
%Modified    19.04.2013 17:37:32 POLAK\MLB
%Environment
*)

 IMPORT L_Basis, L_General, L_Way, L_Car, L_DatTim, FIO, L_Env, L_AFM, L_Str, L_BegRWS,
        L_bp, P_Firm, L_Staff, Memo;

 VAR
  wMF: SCAL[2];

 PRIVATE PROCEDURE MakeTop();
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
  END;
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "፮");
  L_Basis.wb_WrStr("F", "ઠ");
  L_Basis.wb_WrStr("F", "ઠ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "ந");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "⮩");
  L_Basis.wb_WrStr("F", "஡");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "室");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "室");
  L_Basis.wb_WrStr("F", "室");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "⤥");
  L_Basis.wb_WrStr("F", "⤥");
  L_Basis.wb_WrStr("F", "९");
  L_Basis.wb_WrStr("F", "९_");
  L_Basis.wb_WrStr("F", "_");
  L_Basis.wb_WrStr("F", "__");
  L_Basis.wb_WrStr("F", "_室");
  L_Basis.wb_WrStr("F", "_室_");
  L_Basis.wb_TermLine("F");
 END {MakeTop};

 PRIVATE PROCEDURE GetFixBoxNbr(trgTSN   : LIKE(Staff.TSN);
                                trgBoxNbr: LIKE(Car.BoxNbr);
                                D        : DATE): LIKE(Car.BoxNbr);
  VAR
   Result: LIKE(Car.BoxNbr);
 BEGIN
  SETEMPTY(Result);
  IF (L_Car.StandOnFirstMCFix    (trgTSN, D) & (MCFix.BoxNbr = trgBoxNbr)) |
     (L_Car.StandOnSecondaryMCFix(trgTSN, D) & (MCFix.BoxNbr = trgBoxNbr)) |
     L_Car.StandOnFirstMCFix(trgTSN, D) THEN
   Result:=MCFix.BoxNbr;
  END;
  RETURN Result;
 END {GetFixBoxNbr};

 PRIVATE PROCEDURE GetFixSort_ByBoxNbr(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE): LIKE(Sort.Sort);
  VAR
   Result: LIKE(Sort.Sort);
 BEGIN
  IF L_Car.StandOnFirstMCFix_ByCar(trgBoxNbr, D) THEN
   SAVE(Staff);
   CONFORM(MCFix, Staff);
   L_Staff.PosToStaffLog(MCFix.TSN, D, 1);
   Result:=StaffLog.Sort;
   RESTORE(Staff);
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetFixSort_ByBoxNbr};

 PRIVATE PROCEDURE GetFixSort_ByExit(trgExit: LIKE(StExit.Exit); D: DATE): LIKE(Sort.Sort);
  VAR
   Result: LIKE(Sort.Sort);
 BEGIN
  L_General.CallUs(SEARCH(StExit, Exit, trgExit));
  IF StExit.Strict = L_Way.ExitStrict_Reg THEN
   Result:=L_Way.E_GetFixedSortOfExit(StExit.Exit, D, L_Way.rwswho_Driver);
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetFixSort_ByExit};

 PRIVATE PROCEDURE convEmptyString(S: STRING[]): STRING[];
 BEGIN
  IF !S THEN RETURN "---";
  ELSE       RETURN S;
  END;
 END {convEmptyString};

 PRIVATE PROCEDURE getPlus(Cond: SCAL[2]): STRING[];
 BEGIN
  RETURN L_Str.PoolItem("-|+", Cond);
 END {getPlus};

 PRIVATE PROCEDURE MakeLine();
  VAR
   FixSort_ByBoxNbr,
   FixSort_ByExit  : LIKE(Sort.Sort);
   FixBoxNbr       : LIKE(Car.BoxNbr);
 BEGIN
  IF wMF THEN
   CONFORM(VU001, MyFirm);
   L_Basis.wb_WrScl("F", MyFirm.MyFirm);
   L_Basis.wb_WrStr("F", MyFirm.vzSign);
  END;
  CONFORM(VU001, Car);
  L_Car.StandOnCarLog(Car.BoxNbr, VU001.Date);
  CONFORM(CarLog, Mark);
  CONFORM(CarLog, Column);
  L_Basis.wb_WrScl("F", Car.BoxNbr);
  L_Basis.wb_WrStr("F", CarLog.StateNbr);
  L_Basis.wb_WrScl("F", Mark.Mark);
  L_Basis.wb_WrStr("F", Mark.Name);
  L_Basis.wb_WrScl("F", Column.Column);
  L_Basis.wb_WrStr("F", Column.Name);
  CONFORM(VU001, Staff, Man);
  L_Basis.wb_WrScl("F", Staff.TSN);
  L_Basis.wb_WrStr("F", Man.Name);
  L_Basis.wb_WrNum("F", VU001.Tim[L_Way.WJType_Work],   3);
  L_Basis.wb_WrNum("F", VU001.Tim[L_Way.WJType_Repair], 3);
  L_Basis.wb_WrNum("F", VU001.Tim[L_Way.WJType_Stand],  3);
  L_Basis.wb_WrNum("F", VU001.Run,    1);

  L_Basis.wb_WrDat("F", VU001.Date);
  L_Basis.wb_WrScl("F", VU001.Exit);
  L_Basis.wb_WrStr("F", L_Str.PoolItem(L_BegRWS.wh_Pool, VU001.Change));
  CONFORM(VU001, ExitClss);
  L_Basis.wb_WrScl("F", ExitClss.ExitClss);
  L_Basis.wb_WrScl("F", ExitClss.Sign);

  L_Staff.PosToStaffLog(Staff.TSN, VU001.Date, 1);
  CONFORM(StaffLog, Officer, Sort);
  L_Basis.wb_WrScl("F", Sort.Sort);
  L_Basis.wb_WrStr("F", Sort.Name);
  L_Basis.wb_WrScl("F", L_Staff.getDepart());
  L_Basis.wb_WrStr("F", L_Staff.getDepartName());
  FixBoxNbr       :=GetFixBoxNbr(Staff.TSN, Car.BoxNbr, VU001.Date);
  FixSort_ByBoxNbr:=GetFixSort_ByBoxNbr(Car.BoxNbr, VU001.Date);
  FixSort_ByExit  :=GetFixSort_ByExit  (VU001.Exit, VU001.Date);

  L_Basis.wb_WrScl("F", convEmptyString(FixBoxNbr));
  L_Basis.wb_WrStr("F", getPlus(FixBoxNbr = Car.BoxNbr));

  L_Basis.wb_WrStr("F", convEmptyString(FixSort_ByBoxNbr));
  L_Basis.wb_WrStr("F", getPlus(FixSort_ByBoxNbr = Sort.Sort));

  L_Basis.wb_WrStr("F", convEmptyString(FixSort_ByExit));
  L_Basis.wb_WrStr("F", getPlus(FixSort_ByExit = Sort.Sort));
  L_Basis.wb_TermLine("F");
 END {MakeLine};

 PRIVATE PROCEDURE CreateTemp();
 BEGIN
  CreateFILE(VU001);
  CreateFIELD(VU001, BoxNbr,   LIKE(RWayS.BoxNbr));
  CreateFIELD(VU001, TSN,      LIKE(RWayS.TSN));
  CreateFIELD(VU001, Tim,      NUMERIC[10, 3][4], , "0");
  CreateFIELD(VU001, Run,      NUMERIC[8, 1], ,     "0");
  CreateFIELD(VU001, Date,     DATE);
  CreateFIELD(VU001, Exit,     LIKE(StExit.Exit));
  CreateFIELD(VU001, Change,   LIKE(RWayS.Change));
  CreateFIELD(VU001, ExitClss, LIKE(ExitClss.ExitClss));
  CreateFIELD(VU001, MyFirm,   LIKE(MyFirm.MyFirm));

  CreateINDEXandLINK(VU001, BoxNbr,   UNIQUE, Car,      BoxNbr,    USER, , , BoxNbr, TSN, Date, Exit, Change, ExitClss, MyFirm);
  CreateINDEXandLINK(VU001, MyFirm,   PLURAL, MyFirm,   MyFirm,    USER, , , MyFirm);
  CreateINDEXandLINK(VU001, TSN,      PLURAL, Staff,    TSN,       USER, , , TSN);
  CreateINDEXandLINK(VU001, ExitClss, PLURAL, ExitClss, ExitClss,  USER, , , ExitClss);
  SetVersionOfFILE(VU001, 0000);
  L_AFM.AF_CreateTemp("VU001", "VU001");
 END {CreateTemp};

 PRIVATE PROCEDURE GatherTemp(BegD, EndD: DATE);
  VAR
   trgMyFirm: LIKE(MyFirm.MyFirm);
 BEGIN
  SELECT(RWayS, sDate, , L_Way.rwsStat_Rated);
  SRCINSEL(RWayS, GE, , BegD);
  WHILE OCCURE(RWayS) & (RWayS.Date <= EndD) DO
   PROMPT(" : " + L_DatTim.DateStr(RWayS.Date) + "  " + RWayS.RWayS);
   IF L_Env.RealBoxNbr(RWayS.BoxNbr) & L_Env.RealTSN(RWayS.TSN) THEN
    CONFORM(RWayS, StExit);
    trgMyFirm:=L_Way.GetRWaySMyFirm();
    CONFORM(RWayS, RWayJ);
    WHILE OCCURE(RWayJ) DO
     CONFORM(RWayJ, SEJobs, WJMode);
     ADD(VU001, BoxNbr, , RWayS.BoxNbr, RWayS.TSN, RWayS.Date, RWayS.Exit, RWayS.Change, StExit.ExitClss, trgMyFirm,
                       VU001.Tim[WJMode.WJType], RWayJ.StopT - RWayJ.StartT,
                       VU001.Run,                RWayJ.Fact * RWayJ.Run);
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {GatherTemp};

 PRIVATE PROCEDURE VehUs();
  CONST
   bpId = "VehUs";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_bp.Begin(bpId, "ᯮ짮  ⠢  ਮ", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  CreateTemp();
  GatherTemp(Memo.ud_fr(), Memo.ud_ut());
  MakeTop();
  SELECT(VU001, BoxNbr);
  WHILE OCCURE(VU001) DO
   PROMPT("뢮 :  " + VU001.BoxNbr);
   MakeLine();
   NEXT(VU001);
  END; (* WHILE OCCURE(VU001) ... *)
  FIO.Close(F);
  L_bp.End();
 END {VehUs};

END.