(*
%Copyright   (c) Polak IT
%Author      29.03.2007 09:51:43 POLAK\GAV
%Purpose
%Type        report
%Specific    AP
%Modified    23.01.2014 11:02:48 POLAK\Bor
%Environment
*)

 MODULE VldMv [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Basis, L_TRS, L_XDoc, Memo, L_DatTim, FIO, L_AFM, L_OwnData, L_bp, P_CUC;

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "᪮");
  L_Basis.wb_WrInQM(F, "⥫ 䨪");
  L_Basis.wb_WrInQM(F, "਩");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "뤠砄");
  L_Basis.wb_WrInQM(F, "뤠砂६");
  L_Basis.wb_WrInQM(F, "℠");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE MakeLine(F: STRING[]; TakeD: DATE; TakeT: TIME; ReturnD: DATE; ReturnT: TIME);
 BEGIN
  SEARCH(CUCopy, CUCopy, , tmp.CUCopy);
  CONFORM(CUCopy, Math);
  SEARCH(Staff, TSN, , tmp.TSN);
  CONFORM(Staff, Man);
  L_Basis.wb_WrScl(F, CUCopy.CUCopy);
  L_Basis.wb_WrStr(F, CUCopy.Serial);
  L_Basis.wb_WrStr(F, P_CUC.GetCUCProSoft(CUCopy.CUCopy, Memo.ud_ut(), P_CUC.P_AdditionalId));
  L_Basis.wb_WrStr(F, CUCopy.Comment);
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrDat(F, TakeD);
  L_Basis.wb_WrTim(F, TakeT);
  L_Basis.wb_WrDat(F, ReturnD);
  L_Basis.wb_WrTim(F, ReturnT);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PRIVATE PROCEDURE CreateTemp();
 BEGIN
  L_AFM.MakeIndex("tmp", "CUCopy: LIKE(CUCopy.CUCopy);" +
                         "D     : DATE;" +
                         "T     : TIME;" +
                         "Sec   : NUMERIC[4,2];" +
                         "TSN   : LIKE(Staff.TSN);" +
                         "Type  : LIKE(TckRcD.Type)");
 END {CreateTemp};

 PRIVATE PROCEDURE GatherByTckRcD();
 BEGIN
  SELECT(TckRcDL, TckRcD, , TckRcD.TckRcD);
  WHILE OCCURE(TckRcDL) DO
   CONFORM(TckRcDL, TckKind);
   IF TckKind.Type = L_TRS.tkt_VLDActivities THEN
    ADD(tmp, tmp, , TckRcDL.CUCopy, XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec, TckRcD.TSN, TckRcD.Type);
   END;
   NEXT(TckRcDL);
  END; (* WHILE OCCURE(TckRcDL) ... *)
 END {GatherByTckRcD};

 PRIVATE PROCEDURE GatherTemp(D: DATE);
 BEGIN
  CreateTemp();
  SELECT(TckRcD, Date, , D);
  WHILE OCCURE(TckRcD) DO
   NARROWSEL(TckRcD, Type);
   IF TckRcD.Type # L_TRS.trdt_Inventory THEN
    WHILE OCCURE(TckRcD) DO
     PROMPT(" "+TckRcD.TckRcD);
     IF (TckRcD.Status = L_TRS.trdStat_Passed) &
        L_XDoc.XDocWasAutoBuild(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD) THEN
      GatherByTckRcD();
     END;
     NEXT(TckRcD);
    END; (* WHILE OCCURE(File) *)
   END;
   NEXTINEXTENDEDSEL(TckRcD, Type);
  END; (* WHILE OCCURE(TckRcD) *)
 END {GatherTemp};

 PRIVATE PROCEDURE GatherTempByTckRcSDate(BegDate, EndDate: DATE);
  VAR
   D: DATE;
 BEGIN
  CreateTemp();
  D:=BegDate;
  WHILE D <= EndDate DO
   SELECT(TckRcS, Date, , D);
   WHILE OCCURE(TckRcS) DO
    SELECT(TckRcD, TckRcS, , TckRcS.TckRcS);
    PROMPT(" "+TckRcS.TckRcS);
    WHILE OCCURE(TckRcD) DO
     IF (TckRcD.Type # L_TRS.trdt_Inventory) & (TckRcD.Status = L_TRS.trdStat_Passed) &
        L_XDoc.XDocWasAutoBuild(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD) THEN
      GatherByTckRcD();
     END;
     NEXT(TckRcD);
    END; (* WHILE OCCURE(TckRcD) ... *)
    NEXT(TckRcS);
   END; (* WHILE OCCURE(TckRcS) ... *)
   INC(D);
  END;
 END {GatherTempByTckRcSDate};

 PUBLIC PROCEDURE MakeExcel();
  CONST
   RepName = "VldMv";
  VAR
   curD  : DATE;
   curT  : TIME;
   curTSN: LIKE(Staff.TSN);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(RepName, " ஢", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(F, L_General.NameConnection(RepName), "rep", Create);
  MakeTop("F");
  GatherTempByTckRcSDate(Memo.ud_fr(), Memo.ud_ut());
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   CHANGESEL(tmp, tmp, , tmp.CUCopy);
   SETEMPTY(curD, curT, curTSN);
   WHILE OCCURE(tmp) DO
    PROMPT(" " + tmp.CUCopy + " " + L_DatTim.DateTimeStr(tmp.D, tmp.T));
    IF tmp.Type = L_TRS.trdt_Return THEN
     L_General.CallUs(!curTSN | (curTSN = tmp.TSN));
     MakeLine("F", curD, curT, tmp.D, tmp.T);
    ELSE
     curD  :=tmp.D;
     curT  :=tmp.T;
     curTSN:=tmp.TSN;
    END;
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
   LAST(tmp);
   IF tmp.Type = L_TRS.trdt_Laying THEN
    MakeLine("F", tmp.D, tmp.T, L_General.EMPTY_DATE(), L_General.EMPTY_TIME());
   END;
   CHANGESEL(tmp, tmp);
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)
  FIO.Close(F);
  L_bp.End();
 END {MakeExcel};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
####################################################################                          ########## #####
=#####========================================================================================================
|                                             뤠 ஢                                             |
|------------------------------------------------------------------------------------------------------------|
||᪮          |. |  ⢮            |뤠||ਬ砭              |
|-------|------------------------|-----|--------------------------------|-----|-----|------------------------|
}
*)

(*
$P{ Line:
CUCopy.CUCopy, L, ""
CUCopy.Serial, L, ""
Staff.TSN, L, ""
Man.Name, L, ""
?, L, "H:M"
?, L, "H:M"
CUCopy.Comment, L, ""
@
|#######|########################|#####|################################|#####|#####|########################|
}
*)

(*
$P{ Bot:
?, R, ""
?, R, ""
@
|------------------------------------------------------------------------------------------------------------|
|                                                        ⮣ 뤠  ᬥ: ####                         |
|                                                          ⮬ ᫥  ࠡ: ####                         |
=(c) Polak====================================================================================================
}
*)

 PUBLIC PROCEDURE MakeRep();
  CONST
   RepName = "VldLy";
  VAR
   T          : TIME;
   _TSN       : LIKE(Staff.TSN);
   IssuedVld,
   ReturnedVld: NUMERIC[0];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  OPENREP(R, L_General.NameConnection(RepName), Create);

  GatherTemp(L_TRS.GetTRDOnDate());

  IssuedVld  :=0;
  ReturnedVld:=0;
  MAKEPART(R, Top, RepName);
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   CHANGESEL(tmp, tmp, , tmp.CUCopy);
   SETEMPTY(T, _TSN);
   WHILE OCCURE(tmp) DO
    PROMPT(" " + tmp.CUCopy + " " + L_DatTim.DateTimeStr(tmp.D, tmp.T));
    IF tmp.Type = L_TRS.trdt_Return THEN
     IF ~!_TSN THEN
      L_General.CallUs(_TSN = tmp.TSN);
      SEARCH(Staff, TSN, , tmp.TSN);
      SEARCH(CUCopy, CUCopy, , tmp.CUCopy);
      CONFORM(Staff, Man);
      MAKEPART(R, Line, T, tmp.T);
      INC(IssuedVld);
      INC(ReturnedVld);
     END;
    ELSE
     T:=tmp.T;
     _TSN:=tmp.TSN;
    END;
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
   LAST(tmp);
   IF tmp.Type = L_TRS.trdt_Laying THEN
    SEARCH(Staff, TSN, , tmp.TSN);
    SEARCH(CUCopy, CUCopy, , tmp.CUCopy);
    CONFORM(Staff, Man);
    MAKEPART(R, Line, tmp.T);
    INC(IssuedVld);
   END;
   CHANGESEL(tmp, tmp);
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)
  MAKEPART(R, Bot, IssuedVld, IssuedVld - ReturnedVld);
  CLOSEREP(R);
  LIKEMENU(Survey, "");
 END {MakeRep};

END.
