(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose     ஢ન ப WayLMen
%Type        control
%Specific    AP
%Modified    09.06.2014 12:17:28 POLAK\Gina
%Environment
*)

 MODULE WayLMen [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Env, L_Staff, L_Way, L_General, L_DatTim, L_Sheet,
        L_Events, L_BegRWS, L_StdFrm, L_RWayS, L_Str, L_SCAD, Math;

 PRIVATE PROCEDURE MainRWOpAction(Text: STRING[]);
 BEGIN
  L_General.Assert(L_Way.IsMainRWOp() | (RWayS.Status < L_Way.rwsStat_Rated),
                   Text + ".||᫨  㢥७  ࠢ쭮 ଫ," +
                   "|᫥   襬 ⠪஢騪.");
  L_StdFrm.Choice(Text);
 END {MainRWOpAction};

 PUBLIC PROCEDURE WholeRWaySTime();
 BEGIN
  SAVE(RWayJ);
  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  CONFORM(RWayS, StExit);
  IF OCCURE(RWayJ) THEN
   SETEMPTY(WayLMen.Day, WayLMen.StartT);
   REPLACE(WayLMen);
   IF (StExit.Strict = L_Way.ExitStrict_Reg) & ~!StExit.GuBTime THEN
    WHILE OCCURE(RWayJ) & (RWayJ.StopT < StExit.GuBTime) DO
     NEXT(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
    IF ~OCCURE(RWayJ) THEN
     LAST(RWayJ);
     L_General.Error(" 稢  " + L_DatTim.TimeStr(RWayJ.StopT) + "," +
                     "| 室 㪠 砫 ࠡ  " + L_DatTim.TimeStr(StExit.GuBTime));
    END;
   END;
   WayLMen.Day   :=RWayJ.Day;
   WayLMen.StartT:=RWayJ.StartT;
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    REPLACE(WayLMen);
   EXCEPT
   ON Exc: Exc_RunTime DO
    IF L_General.IsUniquenessViolationException(Exc) THEN
     L_General.Error("  ⬥⪠  ࠡ  " + L_DatTim.TimeStr(RWayJ.StartT));
    ELSE
     RAISE();
    END;
   END;
   LAST(RWayJ);
   IF (StExit.Strict = L_Way.ExitStrict_Reg) & ~!StExit.GuETime THEN
    WHILE OCCURE(RWayJ) & (L_Way.FullEndTime(1, StExit.GuBTime, StExit.GuETime) <=
                           L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT)) DO
     PREV(RWayJ);
    END; (* WHILE OCCURE(RWayJ) ... *)
    IF ~OCCURE(RWayJ) THEN
     FIRST(RWayJ);
     L_General.Error(" 稭  " + L_DatTim.TimeStr(RWayJ.StartT) + "," +
                     "| 室 㪠 砭 ࠡ  " + L_DatTim.TimeStr(StExit.GuETime));
    END;
   END;
   L_General.Assert(L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT) -
                    L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT) < 24,
                    " ⥢");
   WayLMen.StopT:=RWayJ.StopT;
   REPLACE(WayLMen);
  END;
  RESTORE(RWayJ);
 END {WholeRWaySTime};

 PRIVATE PROCEDURE SetCurWinFlags();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  IF (RTI.Get().CurWindow.OriginalName="Beg0E") & (L_Way.E_NeedSetTimesWayLMen(RWayS.Date) = 2) THEN
   Fields:=RTI.Get().CurWindow.Zones(1).Fields;
   Fields("WayLMen.Day").Modifiable:=1;
   Fields("WayLMen.StartT").Modifiable:=1;
   Fields("WayLMen.StopT").Modifiable:=1
  END;
 END {SetCurWinFlags};

 PRIVATE PROCEDURE WayLMen_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("WayLMen.Who").Format:=L_Way.wlmwho_Pool;
 END {WayLMen_1_OnZoneOpen};

 PRIVATE PROCEDURE WayLMen_Who_OnSuccessfulChange();
 BEGIN
  L_Way.SetWayLMenDefaultValue();
  REPLACE(WayLMen);
 END {WayLMen_Who_OnSuccessfulChange};

 PRIVATE PROCEDURE WayLMen_TSN_OnSuccessfulChange();
  VAR
   curTSN     : LIKE(WayLMen.TSN);
   curStartT  : LIKE(WayLMen.StartT);
   curWho     : LIKE(WayLMen.Who);
   curasWJMode: LIKE(WayLMen.asWJMode);
   Found      : SCAL[2];
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert THEN
   curTSN   :=WayLMen.TSN;
   curStartT:=WayLMen.StartT;
   Found:=0;
   SAVE(WayLMen);
   SELECT(WayLMen, RWayS, , WayLMen.RWayS);
   WHILE OCCURE(WayLMen) & ~Found DO
    IF (WayLMen.TSN = curTSN) & (WayLMen.StartT # curStartT) THEN
     curWho     :=WayLMen.Who;
     curasWJMode:=WayLMen.asWJMode;
     Found:=1;
    END;
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
   RESTORE(WayLMen);
   IF Found THEN
    WayLMen.Who     :=curWho;
    WayLMen.asWJMode:=curasWJMode;
   END;
  END;
  L_Way.SetWayLMenDefaultValue();
  REPLACE(WayLMen);
 END {WayLMen_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE WayLMen_OnBeforeInsert();
 BEGIN
  WayLMen.RWayDate:=RWayS.Date;
  L_Way.SetWayLMenDefaultValue();
  REPLACE(WayLMen);
  IF RWayS.Status = L_Way.rwsStat_Ordered THEN
   L_General.Assert(~!RWayS.Exit, "室  室");
   CONFORM(RWayS, StExit);
   CONFORM(RWayS, RWayTxt);
   L_BegRWS.SetWayLMenDefaultTime();
   REPLACE(WayLMen);
  END;
  SetCurWinFlags();
 END {WayLMen_OnBeforeInsert};

 PRIVATE PROCEDURE WayLMen_OnBeforeEdit();
 BEGIN
  SetCurWinFlags();
 END {WayLMen_OnBeforeEdit};

 PRIVATE PROCEDURE WayLMen_OnAfterEditInsert(AfterInsert: SCAL[2]);
  VAR
   msg: STRING[];
 BEGIN
  CONFORM(WayLMen, RWayS);
  IF (RWayS.Status = L_Way.rwsStat_Ordered) & L_BegRWS.E_TWOLevel(RWayS.Date) THEN
   IF AfterInsert | (WayLMen.TSN # GE_PVALUE(WayLMen.TSN)) | (WayLMen.Who # GE_PVALUE(WayLMen.Who)) THEN
    msg:="";
    IF AfterInsert THEN
     IF WayLMen.Who = L_Way.wlmwho_Guard THEN
      msg:=" " + L_Str.PoolItem(L_Way.wlmwho_Pool, WayLMen.Who) + " " + WayLMen.TSN;
     END;
    ELSE
     IF (WayLMen.Who = L_Way.wlmwho_Guard) | (GE_PVALUE(WayLMen.Who) = L_Way.wlmwho_Guard) THEN
      msg:=L_Str.PoolItem(L_Way.wlmwho_Pool, GE_PVALUE(WayLMen.Who)) + " " + GE_PVALUE(WayLMen.TSN) + "->";
      IF WayLMen.Who # GE_PVALUE(WayLMen.Who) THEN
       msg:=msg + L_Str.PoolItem(L_Way.wlmwho_Pool, WayLMen.Who) + " ";
      END;
      msg:=msg + WayLMen.TSN;
     END;
    END;
    IF ~!msg THEN
     CALL(BegRWS.switch_MakeNote(msg));
    END;
   END;
  END; (* IF (RWayS.Status = L_Way.rwsStat_Ordered) & L_BegRWS.E_TWOLevel(RWayS.Date) *)
  IF ~!WayLMen.asWJMode THEN
   L_General.Assert(SEARCH(WJMode, WJCode, WayLMen.asWJMode), "   ࠢ筨  ࠡ "+WayLMen.asWJMode);
  END;
  CONFORM(WayLMen, Staff);
  L_General.Assert(L_Env.RealTSN(WayLMen.TSN),
                   " 㪠뢠 ⮫쪮 ॠ ࠡ⭨");
  L_Staff.PosToStaffLog(Staff.TSN, RWayS.Date, 0);
  L_General.Assert(~L_Staff.IsDischargeStaffLog(),
                   "⭨  ⮨    " + L_DatTim.DateStr(RWayS.Date));
  CONFORM(Staff, Man);
  CONFORM(StaffLog, Officer);
  IF    (WayLMen.Who=L_Way.wlmwho_Guard) & ~L_Env.IsGuard() THEN
   L_StdFrm.Choice(" ࠡ⭨   ஬");
   IF WayLMen.ToPay | (WayLMen.ToSheet > L_Way.toSheet_Dummy) THEN
    MainRWOpAction(" ࠡ⭨,  饣 ஬,|㪠   ⠡");
   END;
  ELSIF (WayLMen.Who=L_Way.wlmwho_DrPupil) | (WayLMen.Who=L_Way.wlmwho_SDriver) THEN
   IF ~(L_Env.IsDriver() | L_Env.IsDriverPupil()) THEN
    L_StdFrm.Choice(" ࠡ⭨   ⥫  祭 ⥫");
    IF WayLMen.ToPay | (WayLMen.ToSheet > L_Way.toSheet_Dummy) THEN
     MainRWOpAction(" ࠡ⭨,  饣 ⥫  祭 ⥫,|㪠   ⠡");
    END;
   END;
  END;
  L_RWayS.CheckSheet(WayLMen.ToSheet);
 END {WayLMen_OnAfterEditInsert};

 PRIVATE PROCEDURE WayLMen_OnAfterEdit();
 BEGIN
  WayLMen_OnAfterEditInsert(0);
 END {WayLMen_OnAfterEdit};

 PRIVATE PROCEDURE WayLMen_OnAfterInsert();
 BEGIN
  WayLMen_OnAfterEditInsert(1);
 END {WayLMen_OnAfterInsert};

 PRIVATE PROCEDURE WayLMen_OnBeforeDelete();
 BEGIN
  CONFORM(WayLMen, RWayS);
  IF WayLMen.Who = L_Way.wlmwho_Guard THEN
   CALL(BegRWS.switch_MakeNote(" " + L_Str.PoolItem(L_Way.wlmwho_Pool, WayLMen.Who) + " " + WayLMen.TSN));
  END;
 END {WayLMen_OnBeforeDelete};

 PUBLIC PROCEDURE CondPlanAsFact_ForAllTrips();
 BEGIN
  L_General.Assert(ACCESS(WayLMen), " ࠭ ");
  L_General.Assert(WayLMen.Who = L_Way.wlmwho_Guard,
                   "  믮 ⮫쪮  ஢");
  L_StdFrm.Question("⠢ ' = 䠪'   ३ᮢ," +
                    "|  ࠡ⠫  " + WayLMen.TSN);
  SELECT(RWayJ, RWayS, , WayLMen.RWayS);
  WHILE OCCURE(RWayJ) DO
   PROMPT(RWayJ.Trip);
   IF L_RWayS.IsRWayJForCurWayLMen() THEN
    CONFORM(RWayJ, SEJobs);
    CONFORM(SEJobs, WJMode);
    IF WJMode.IncSel THEN
     L_Way.SetRWayJP(L_Way.rwjp_PlanIsEqualFact, 1, L_Way.rwjpSrc_Opert);
    END;
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
 END {CondPlanAsFact_ForAllTrips};

 PRIVATE PROCEDURE FstTrip(): SCAL[2];
 BEGIN
  CONFORM(RWayJ, SEJobs, StExit);
  RETURN (StExit.Strict = L_Way.ExitStrict_Reg) & (RWayJ.StartT = SEJobs.StartT);
 END {FstTrip};

 PRIVATE PROCEDURE SlcRWayJ(VAR _Fact: LIKE(RWayJ.Fact));
  VAR
   _Trip  : LIKE(SEJobs.Trip);
   _StartT: LIKE(SEJobs.StartT);
   _StopT : LIKE(RWayJ.StopT);
   _Day   : LIKE(RWayJ.Day);
   F1     : LIKE(RWayJ.Fact);
 BEGIN
  L_General.Assert(OCCURE(SEJobs), ". "+WayLMen.TSN+"  ࠧ ३ "+RWayJ.Trip);
  _Trip      :=SEJobs.Trip;
  _Day       :=RWayJ.Day;
  _StopT     :=RWayJ.StopT;
  _StartT    :=SEJobs.StartT;
  RWayJ.StopT:=SEJobs.StartT;
  F1         :=RWayJ.Fact-_Fact;
  RWayJ.Fact :=_Fact;
  _Fact      :=F1;
  REPLACE(RWayJ);
  L_SCAD.DistributeCP();
  WHILE OCCURE(SEJobs) & (F1 > 1) DO
   NEXT(SEJobs);
   PROMPT(" "+SEJobs.Trip);
   DEC(F1);
  END;
  L_General.Assert(_StopT = SEJobs.StopT, "砭 ३   ᯨᠭ");
  CONFORM(SEJobs, RoutMod);
  DEFAULT(RWayJ);
  RWayJ.RWayS :=RWayS.RWayS;
  RWayJ.Day   :=_Day;
  RWayJ.StartT:=_StartT;
  RWayJ.Trip  :=_Trip;
  RWayJ.Fact  :=Math.Max(_Fact, 1);
  RWayJ.StopT :=SEJobs.StopT;
  RWayJ.Run   :=RoutMod.Run;
  INSERT(RWayJ);
  L_Way.SetRWJQuality();
  L_SCAD.DistributeCP();
 END {SlcRWayJ};

 PRIVATE PROCEDURE SlcRWayJAsCurrent(_Trip: LIKE(SEJobs.Trip); WLMTime: TIME; VAR _Fact: LIKE(RWayJ.Fact));
  VAR
   _StartT: LIKE(SEJobs.StartT);
   _StopT : LIKE(RWayJ.StopT);
   _Day   : LIKE(RWayJ.Day);
   F1     : LIKE(RWayJ.Fact);
   _Run   : LIKE(RWayJ.Run);
 BEGIN
  _Run       :=RWayJ.Run;
  _Fact      :=Math.Round((WLMTime-RWayJ.StartT)/((RWayJ.StopT-RWayJ.StartT)/RWayJ.Fact), 1);
  _Day       :=RWayJ.Day;
  _StopT     :=RWayJ.StopT;
  _StartT    :=RWayJ.StartT;
  RWayJ.StopT:=WLMTime;
  F1         :=RWayJ.Fact-_Fact;
  RWayJ.Fact :=Math.Max(_Fact, 1);
  _Fact      :=F1;
  REPLACE(RWayJ);
  L_SCAD.DistributeCP();
  DEFAULT(RWayJ);
  RWayJ.RWayS :=RWayS.RWayS;
  RWayJ.StartT:=WLMTime;
  RWayJ.StopT :=_StopT;
  RWayJ.Day   :=_Day+(_StartT>RWayJ.StartT);
  RWayJ.Trip  :=_Trip;
  RWayJ.Fact  :=Math.Max(_Fact, 1);
  RWayJ.Run   :=_Run;
  INSERT(RWayJ);
  L_Way.SetRWJQuality();
  L_SCAD.DistributeCP();
 END {SlcRWayJAsCurrent};

 PUBLIC PROCEDURE SplitRWayJ();
  CONST
   MaxShift = 0.25(*15/60*);
  VAR
   Found    : SCAL[2];
   WLMBTim,
   WLMETim,
   RWJBTim,
   RWJETim,
   SEJBTim,
   SEJETim  : NUMERIC[3];
   _Fact    : LIKE(RWayJ.Fact);
 BEGIN
  L_General.Assert(ACCESS(WayLMen), " । ࠡ⭨ . ᮭ");
  L_General.Assert(~L_RWayS.E_GetTimesFromWayLMen(), " ॡ ࠧ ३,|⠪    砥 ६ 뢠  . ᮭ");
 
  WLMBTim:=L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT);
  WLMETim:=L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT);
 
  SETZERO(Found);
  CONFORM(RWayS, RWayJ);
  WHILE OCCURE(RWayJ) & ~Found DO
   RWJBTim:=L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT);
   RWJETim:=L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT);
   IF Math.Abs(WLMBTim-RWJBTim)<MaxShift THEN
    ACCESS(WayLMen);
    WayLMen.StartT:=RWayJ.StartT;
    REPLACE(WayLMen);
    WLMBTim:=L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT);
   END;
   IF (RWJBTim<=WLMBTim) & (WLMBTim<RWJETim-MaxShift) THEN
    Found:=1;
   ELSE
    NEXT(RWayJ);
   END;
  END; (* WHILE OCCURE(RWayJ) ... *)
 
  L_General.Assert(OCCURE(RWayJ), ". "+WayLMen.TSN+":   ३  ࠧ");
 
  RWJBTim:=L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT);
  RWJETim:=L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT);
 
  IF RWJBTim<WLMBTim THEN
   IF FstTrip() THEN
    _Fact:=0;(* ࠡ⠭ ३*)
    CHANGESEL(SEJobs, Exit, , SEJobs.Exit);
    SEJBTim:=L_Way.FullBegTime(SEJobs.Day, SEJobs.StartT);
    WHILE OCCURE(SEJobs) & (Math.Abs(WLMBTim-SEJBTim) > MaxShift) DO
     IF NEXT(SEJobs) THEN
      SEJBTim:=L_Way.FullBegTime(SEJobs.Day, SEJobs.StartT);
      PROMPT(" "+SEJobs.Trip);
      INC(_Fact);
     END;
    END;
    SlcRWayJ(_Fact);
    WayLMen.StartT:=RWayJ.StartT;
    REPLACE(WayLMen);
    WLMBTim:=L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT);
   ELSE
    IF StExit.Strict=L_Way.ExitStrict_Reg THEN
     CHANGESEL(SEJobs, Exit, , SEJobs.Exit);
     SRCINSEL(SEJobs, LE, , WayLMen.Day, WayLMen.StartT);
     IF OCCURE(SEJobs) & (Math.Abs(WayLMen.StartT-SEJobs.StartT) < MaxShift) THEN
      SlcRWayJAsCurrent(SEJobs.Trip, WayLMen.StartT, _Fact);
     ELSE
      SlcRWayJAsCurrent(RWayJ.Trip, WayLMen.StartT, _Fact);
     END;
    ELSE
     SlcRWayJAsCurrent(RWayJ.Trip, WayLMen.StartT, _Fact);
    END;
   END; (* IF FstTrip()... *)
  END; (* IF RWJBTim<WLMBTim ... *)
 
  SETZERO(Found);
  WHILE OCCURE(RWayJ) & ~Found DO
   RWJBTim:=L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT);
   RWJETim:=L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT);
   IF Math.Abs(WLMETim-RWJETim)<MaxShift THEN
    WayLMen.StopT:=RWayJ.StopT;
    REPLACE(WayLMen);
    WLMETim:=L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT);
   END;
   IF (RWJBTim<WLMETim) & (WLMETim<=RWJETim) THEN
    Found:=1;
   ELSE
    NEXT(RWayJ);
   END;
  END; (* OCCURE(RWayJ) ... *)
  L_General.Assert(OCCURE(RWayJ), ". "+WayLMen.TSN+":   ३  ࠧ");
 
  RWJBTim:=L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT);
  RWJETim:=L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT);
 
  IF WLMETim<RWJETim THEN
   IF FstTrip() THEN
    _Fact:=0;(*ࠡ⠭ ३*)
    CHANGESEL(SEJobs, Exit, , SEJobs.Exit);
    SEJETim:=L_Way.FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT);
    WHILE OCCURE(SEJobs) & (Math.Abs(WLMETim-SEJETim) > MaxShift) DO
     IF NEXT(SEJobs) THEN
      SEJETim:=L_Way.FullEndTime(SEJobs.Day, SEJobs.StartT, SEJobs.StopT);
      PROMPT(" "+SEJobs.Trip);
      INC(_Fact);
     END;
    END;
    L_General.Assert(OCCURE(SEJobs) & NEXT(SEJobs), ". "+WayLMen.TSN+"  ࠧ ३ "+RWayJ.Trip);
    INC(_Fact);
    SlcRWayJ(_Fact);
    WayLMen.StopT:=RWayJ.StartT;
    REPLACE(WayLMen);
   ELSE
    IF StExit.Strict=L_Way.ExitStrict_Reg THEN
     CHANGESEL(SEJobs, Exit, , SEJobs.Exit);
     SRCINSEL(SEJobs, GE, , WayLMen.Day, WayLMen.StartT);
     IF OCCURE(SEJobs) & (Math.Abs(WayLMen.StopT-SEJobs.StopT) < MaxShift) THEN
      SlcRWayJAsCurrent(SEJobs.Trip, WayLMen.StopT, _Fact);
     ELSE
      SlcRWayJAsCurrent(RWayJ.Trip, WayLMen.StopT, _Fact);
     END;
    ELSE
     SlcRWayJAsCurrent(RWayJ.Trip, WayLMen.StopT, _Fact);
    END;
   END; (* IF FstTrip()... *)
  END; (* IF IF WLMETim<RWJETim... *)
 END {SplitRWayJ};

BEGIN
 L_Events.ExecuteHandler();
END.
