(*
%Copyright   (c) Polak IT
%Author      10.02.2003 17:10:49 POLAK\LDA
%Purpose       ࠭ᯮ⭮ 
%Type        report
%Specific    SYS
%Modified    05.09.2014 10:41:08 POLAK\LDA
%Environment
*)

 MODULE XOMN14 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, Math, L_General, L_MSO, L_Car, L_AFM, L_Env, L_DatTim, P_Car,
        L_Str, L_OwnData, P_Firm, P_Math, E_Way, L_Packet, P_MyPlc,
        DBD, L_EC, L_OTx, L_StdFrm, L_Russia;

 PRIVATE CONST
  rn_BnfCarList = "BnfCr";
  rn_BnfTaxSum  = "BnfSm";
  rn_BadCar     = "BadCr";

 PRIVATE VAR
  _Table2: LIKE(ATERAttr.Table);
  _Row2  : LIKE(ATERAttr.Row);

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
rn_BnfCarList, L, ""
?, L, "N.y"
?, L, "N.y"
@
####################################################################################################### ########## #####
=#####==================================================================================================================
|                               ᮪ , ᢮  㯫 ࠭ᯮ⭮                                 |
|                                             ਮ  #######  #######                                            |
|----------------------------------------------------------------------------------------------------------------------|
|.|.  | ॢ                      |᭮                                                         |
}
*)

(*
$P{ Dlm:
@
|----|----------|-----------------------------------|------------------------------------------------------------------|
}
*)

(*
$P{ Line:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|####|##########|###################################|##################################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak==============================================================================================================
}
*)

(*
$P{ BadTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
rn_BadCar, L, ""
@
#############################################################                                 ########## #####
=#####========================================================================================================
|                        ᮪ ,  祭    ࠭ᯮ⭮                        |
|------------------------------------------------------------------------------------------------------------|
|.|ઠ                       |      |稭                                                        |
|----|----------------------------|----------|---------------------------------------------------------------|
}
*)

(*
$P{ BadLine:
Car.BoxNbr, L, ""
Mark.Mark, L , ""
Mark.Name, L , ""
CarLog.Date, L, "D.N.y"
?, L, ""
@
|####|#### #######################|##########|###############################################################|
}
*)

(*
$P{ BadBot:
@
=(c) Polak====================================================================================================
}
*)

(*
$P{ BnfTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
rn_BnfTaxSum, L, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|            ࠭ᯮ⭮ , 饣 ᢮           |
|                    १ 죮⭮                    |
|           ࣠権 ᠦ᪮ ࠭ᯮ 饣 짮         |
|############################################################################|
}
*)

(*
$P{ BnfSubTop:
TmpCr.BnfType, L, "?????????|樠 ॢ| 樮 祭|  㣮|樠஢ "
@
|============================================================================|
|############################################################################|
|----------------------------------------------------------------------------|
|.|ઠ                       |  | ⠢||      㬬|      |
|----|----------------------------|------|-------|---|-----------|-----------|
}
*)

(*
$P{ BnfLine:
TmpCr.BoxNbr, L, ""
Mark.Name, L, ""
TmpCr.EngPower, R, "2."
?, R, "2-"
TmpCr.MnthAmnt, R, "0"
?, R, "0"
?, R, "0"
@
|####|############################|######|#######|###|###########|###########|
}
*)

(*
$P{ BnfSubBot:
?, L, ""
?, R, "0"
@
|----------------------------------------------------------------------------|
|############################################################# ##############|
}
*)

(*
$P{ BnfBot:
?, R, "0"
@
|----------------------------------------------------------------------------|
|⮣:                                                        ##############|
=(c) Polak====================================================================
}
*)

(*
$P{ 5AX_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
############################################################# ########## #####
=#####========================================================================
}
*)

(*
$P{ 5AX_Line:
@

}
*)

(*
$P{ 5AX_Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE psf_Str(pn, Value: STRING[]);
 BEGIN
  L_Packet.psf_Str(pn, Value, _Table2, _Row2);
 END {psf_Str};

 PRIVATE PROCEDURE psf_Num(pn: STRING[]; Value: FLOAT);
 BEGIN
  L_Packet.psf_Num(pn, Value, _Table2, _Row2);
 END {psf_Num};

 PRIVATE PROCEDURE CreateTmpFiles();
 BEGIN
  CreateFILE(TotTx, "", "⮣  樨", "");

  CreateFIELD(TotTx, Tax_VehT, STRING[6], "", "", "", " ", "");
  CreateFIELD(TotTx, BnfType,  L_OTx.tBnfType, "", "", "", " 죮", "");
  CreateFIELD(TotTx, CarAmnt,  NUMERIC[0], "", "", "", "- ", "");

  CreateINDEX(TotTx, Tax_VehT, UNIQUE, "", "", Tax_VehT, BnfType);

  SetVersionOfFILE(TotTx, 0);
  L_AFM.AF_CreateTemp("TotTx", "TotTx");
 END {CreateTmpFiles};

 PRIVATE PROCEDURE PurgeTmpFiles();
 BEGIN
  L_AFM.AF_PurgeTemp("TotTx");
 END {PurgeTmpFiles};

 PRIVATE PROCEDURE CalcTransportTax(trgMnthAmnt     : NUMERIC[0];
                                    trgMnthAmntInPer: NUMERIC[0];
                                    trgBnfPrc       : NUMERIC[2]): NUMERIC[2];
 BEGIN
  RETURN L_OTx.CalcTransportTax(trgMnthAmnt, trgMnthAmntInPer, TmpCr.EngPower, TmpCr.TaxRate, trgBnfPrc, TmpCr.IncCoef, TmpCr.OwnPart, 4);
 END {CalcTransportTax};

 PRIVATE PROCEDURE GetStateNbr(BPer: DATE): STRING[];
  VAR
   _StateNbr: STRING[];
 BEGIN
  SAVE(CarLog);
  IF ~OCCURE(CarLog) THEN
   _StateNbr:=TmpCr.StateNbr;
  ELSE
   SRCINSEL(CarLog, LE, , L_DatTim.MaxDATE(CarLog.Date, BPer));
   _StateNbr:=CarLog.StateNbr;
  END;
  RESTORE(CarLog);
  RETURN _StateNbr;
 END {GetStateNbr};

 PRIVATE PROCEDURE GetTKindName(): STRING[];
 BEGIN
  IF ~!CarLog.TKind THEN
   CONFORM(CarLog, TKind);
   RETURN TKind.TKind + " " + TKind.Name;
  ELSE
   RETURN "";
  END;
 END {GetTKindName};

 PRIVATE PROCEDURE MakeBnfPart(_BoxNbr: LIKE(Car.BoxNbr);
                               BPer,
                               EPer   : DATE);
  VAR
   tmpBoxNbr: LIKE(Car.BoxNbr);
   Reason,
   TKindName: STRING[];
   _TKind   : LIKE(TKind.TKind);
   FirstPass: SCAL[2];
 BEGIN
  FirstPass:=1;
  SELECT(CarLog, BoxNbr, , _BoxNbr);
  tmpBoxNbr:=_BoxNbr;
  IF SRCINSEL(CarLog, LE, BPer) | SRCINSEL(CarLog, LE, EPer) THEN
   WHILE OCCURE(CarLog) &
         (CarLog.Date <= EPer) &
         (CarLog.Status # L_Car.carst_Retired) &
         L_OTx.E_AdditionalCheckCarAdaptability() DO
    SETEMPTY(_TKind, TKindName);
    CONFORM(CarLog, TKind);
    IF !CarLog.VehPasp THEN
     MAKEPART(R, Dlm);
     MAKEPART(R, Line, _BoxNbr, GetStateNbr(BPer), GetTKindName(), "!!!  㪠   " + L_DatTim.DateStr(CarLog.Date));
     NEXT(CarLog);
    ELSE
     CONFORM(CarLog, VehPasp);
     CONFORM(VehPasp, VehType);
 
     IF    ~L_OTx.IsAcceptableTTPayer(EPer) THEN
      NEXT(CarLog);
     ELSIF VehPasp.IsSteal THEN
      IF FirstPass THEN
       MAKEPART(R, Dlm);
       FirstPass:=0;
      END;
      MAKEPART(R, Line, _BoxNbr, GetStateNbr(BPer), GetTKindName(), "  㣮");
      NEXT(CarLog);
     ELSIF L_OTx.IsMedicCar() THEN
      IF FirstPass THEN
       MAKEPART(R, Dlm);
       FirstPass:=0;
      END;
      MAKEPART(R, Line, tmpBoxNbr, GetStateNbr(BPer), GetTKindName(), "樭᪮ ");
      NEXT(CarLog);
     ELSIF L_OTx.IsSocialBnfCar(CarLog.Date, BPer) THEN
      _TKind   :=CarLog.TKind;
      TKindName:=GetTKindName();
      Reason   :="N " + CarLog.Order + "  " + L_DatTim.DateStr(CarLog.OrdDate) + " " + CarLog.OrdCsAtr;
      WHILE OCCURE(CarLog) & (CarLog.Date <= EPer) & (_TKind = CarLog.TKind) DO
       NEXT(CarLog);
      END;
      IF ~OCCURE(CarLog) | (CarLog.Date > BPer) THEN
       IF FirstPass THEN
        MAKEPART(R, Dlm);
        FirstPass:=0;
       END;
       MAKEPART(R, Line, tmpBoxNbr, GetStateNbr(BPer), TKindName, Reason);
       SETEMPTY(tmpBoxNbr);
      END;
     ELSE
      NEXT(CarLog);
     END;
    END;
   END; (* WHILE OCCURE(CarLog) ... *)
  END;
 END {MakeBnfPart};

 PRIVATE PROCEDURE PrintBnfCarListRep(BPer, EPer: DATE);
 BEGIN
  OPENREP(R, L_General.NameConnection(rn_BnfCarList), Create);
  MAKEPART(R, Top, BPer, EPer);
  SELECT(TmpCr, BnfType);
  WHILE OCCURE(TmpCr) DO
   NARROWSEL(TmpCr, BnfType);
   IF TmpCr.BnfType # L_OTx.bnft_None THEN
    WHILE OCCURE(TmpCr) DO
     NARROWSEL(TmpCr, BoxNbr);
     WHILE OCCURE(TmpCr) DO
      PROMPT("  ,   : " + TmpCr.BoxNbr);
      MakeBnfPart(TmpCr.BoxNbr, BPer, EPer);
      NEXT(TmpCr);
     END; (* WHILE OCCURE(TmpCr) ... *)
     NEXTINEXTENDEDSEL(TmpCr, BoxNbr);
    END; (* WHILE OCCURE(TmpCr) ... *)
   END;
   NEXTINEXTENDEDSEL(TmpCr, BnfType);
  END; (* WHILE OCCURE(TmpCr) ... *)
  MAKEPART(R, Bot);
 END {PrintBnfCarListRep};

 PRIVATE PROCEDURE PrintBnfSumRep(BPer, EPer: DATE);
  VAR
   Total,
   SubTotal,
   BnfTaxSum,
   BnfTaxRate: NUMERIC[2];
   _BnfType  : L_OTx.tBnfType;
 BEGIN
  OPENREP(S, L_General.NameConnection(rn_BnfTaxSum), Create);
  MAKEPART(S, BnfTop, " " + L_Str.PoolItem("I ⠫ |II ⠫ |III ⠫ |", L_DatTim.QUARTAL(EPer)) + L_Str.IntStr(L_DatTim.YEAR(EPer)) + " .");
  SETZERO(Total);
  SELECT(TmpCr, BnfType);
  WHILE OCCURE(TmpCr) DO
   NARROWSEL(TmpCr, BnfType);
   IF TmpCr.BnfType # L_OTx.bnft_None THEN
    _BnfType:=TmpCr.BnfType;
    SETZERO(SubTotal);
    MAKEPART(S, BnfSubTop);
    WHILE OCCURE(TmpCr) DO
     PROMPT("⮢  ,   : " + TmpCr.BoxNbr);
     L_Car.AccessMark(TmpCr.BoxNbr, EPer);
     BnfTaxSum :=CalcTransportTax(TmpCr.MnthAmnt, L_DatTim.MONTH(EPer)-L_DatTim.MONTH(BPer)+1, 1-TmpCr.BnfPrc);
     BnfTaxRate:=TmpCr.TaxRate * TmpCr.BnfPrc;
     MAKEPART(S, BnfLine, BnfTaxRate, BnfTaxRate * TmpCr.EngPower, BnfTaxSum);
     INC(SubTotal, BnfTaxSum);
     NEXT(TmpCr);
    END; (* WHILE OCCURE(TmpCr) ... *)
    MAKEPART(S, BnfSubBot, "ᥣ", SubTotal);
    INC(Total, SubTotal);
   END;
   NEXTINEXTENDEDSEL(TmpCr, BnfType);
  END; (* WHILE OCCURE(TmpCr) ... *)
  MAKEPART(S, BnfBot, Total);
 END {PrintBnfSumRep};

 PRIVATE PROCEDURE PrintBadCarRep(BPer, EPer: DATE);
 BEGIN
  OPENREP(B, L_General.NameConnection(rn_BadCar), Create);
  MAKEPART(B, BadTop);
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT("஢ઠ : " + Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) &
      L_DatTim.IsActiveInIntvl_Inc(Car.BegDate, Car.EndDate, BPer, EPer) THEN
    HISTCONF(Math.Max(BPer, Car.BegDate), Car, CarLog);
    WHILE OCCURE(CarLog) & (CarLog.Date <= EPer) DO
     CONFORM(CarLog, Mark);
     IF L_OTx.GatherByKeyAssets(EPer) & !CarLog.Math THEN
      MAKEPART(B, BadLine, " ᮯ⠢ ");
     END;
     IF (DBD.BaseName() = "OD") & (CarLog.Column = 99) THEN
      MAKEPART(B, BadLine, "   99");
     END;
     IF CarLog.Status # L_Car.carst_Retired THEN
      IF ~!CarLog.VehPasp THEN
       CONFORM(CarLog, VehPasp);
      END;
      IF    !CarLog.VehPasp THEN
       MAKEPART(B, BadLine, "  㪠");
      ELSIF ~L_OTx.AcceptableVehPasp(BPer, EPer) THEN
       MAKEPART(B, BadLine, " " + CarLog.VehPasp + "  ");
      ELSIF ~L_OTx.IsAcceptableTTPayer(EPer) THEN
       MAKEPART(B, BadLine, "࠭ᯮ   " + L_Str.PoolItem("쥩 ஭|⢥|ᯫ⠭⮬", VehPasp.TTPayer));
      END;
     END;
     NEXT(CarLog);
    END; (* WHILE OCCURE(CarLog) & (CarLog.Date <= EPer)...*)
   END; (* IF L_Env.RealBoxNbr(Car.BoxNbr)... *)
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
  MAKEPART(B, BadBot);
 END {PrintBadCarRep};

 PRIVATE PROCEDURE BnfCancel();
 BEGIN
  TmpCr.BnfType:=L_OTx.bnft_None;
  TmpCr.BnfPrc :=0;
  REPLACE(TmpCr);
 END {BnfCancel};

 PRIVATE PROCEDURE E_BnfCancelRequired(_BnfType: L_OTx.tBnfType): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  IF (Region.Region = L_Russia.reg_50) & (_BnfType # L_OTx.bnft_IsSteal) THEN
   Local:=PROCREF(E_Way.Xomn7_BnfCancelRequired);
   IF ~!Local THEN
    RETURN Local(_BnfType);
   ELSE
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {E_BnfCancelRequired};

 PRIVATE PROCEDURE MakeIndex(BPer, EPer: DATE);
 BEGIN
  L_OTx.TT_Prepare(L_OTx.GatherByKeyAssets(EPer), BPer, EPer);
  PrintBnfCarListRep(BPer, EPer);
  PrintBnfSumRep(BPer, EPer);
  PrintBadCarRep(BPer, EPer);
 END {MakeIndex};

 PRIVATE PROCEDURE ConvertTaxVehTypeAsStr(Idx: NUMERIC[0]; wExclSpaces: SCAL[2]): STRING[];
  VAR
   S: STRING[];
 BEGIN
  S:=Str.Condense(Str.Item(L_Str.PoolItem(L_Car.Tax_VehTPool, VehType.Tax_VehT), "-", Idx));
  IF wExclSpaces THEN
   S:=L_Str.Replace(S, " ", "");
  END;
  RETURN S;
 END {ConvertTaxVehTypeAsStr};

 PRIVATE PROCEDURE FillPacketBySingleOKTMO(BPer, EPer: DATE; OKTMONbr: STRING[]);
  VAR
   i                 : NUMERIC[0];
   Source            : LIKE(PckATER.Source);
   FreeTaxCode       : STRING[];
   TotalTaxSum,
   DecTaxSum,
   FreeTaxSum        : NUMERIC[2];
   AdvSum,
   MnthAmntInPer,
   TotalMnthAmnt,
   DecTaxMnthAmnt,
   FreeTaxMnthAmnt,
   TotalBnfMnthAmnt: NUMERIC[0];
 BEGIN
  _Table2      :=00000;
  _Row2        :=00000;
  MnthAmntInPer:=L_DatTim.MONTH(EPer)-L_DatTim.MONTH(BPer)+1;
  psf_Str(L_Str.PoolItem("|", BPer >= 01\01\2013)+OKTMONbr, P_MyPlc.GetP_OKTMO(Packet.MyFirm, Packet.MyPlace, L_DatTim.MonthEnd(EPer)));
  SELECT(TmpCr, ID);
  WHILE OCCURE(TmpCr) DO
   PROMPT("㧪 " + TmpCr.ID);
   NARROWSEL(TmpCr, ID, EngPower);
   SAVE(TmpCr);
   SETZERO(TotalMnthAmnt, FreeTaxMnthAmnt, DecTaxMnthAmnt, TotalTaxSum, FreeTaxSum, DecTaxSum);
   WHILE OCCURE(TmpCr) DO
    IF TmpCr.BnfType # L_OTx.bnft_IsSteal THEN
     INC(TotalMnthAmnt, TmpCr.MnthAmnt);
     INC(TotalTaxSum, CalcTransportTax(TmpCr.MnthAmnt, MnthAmntInPer, 0));
     IF    TmpCr.BnfType = L_OTx.bnft_None THEN
      (*  ᠬ஫ *)
     ELSIF TmpCr.BnfType = L_OTx.bnft_Social THEN
      INC(FreeTaxMnthAmnt, TmpCr.MnthAmnt);
      INC(FreeTaxSum, CalcTransportTax(TmpCr.MnthAmnt, MnthAmntInPer, 1-TmpCr.BnfPrc));
     ELSIF TmpCr.BnfType = L_OTx.bnft_Medic THEN
      INC(DecTaxMnthAmnt, TmpCr.MnthAmnt);
      INC(DecTaxSum, CalcTransportTax(TmpCr.MnthAmnt, MnthAmntInPer, 1-TmpCr.BnfPrc));
     ELSE
      L_General.CallUs(0);
     END;
    END;
    NEXT(TmpCr);
   END; (* WHILE OCCURE(TmpCr) ... *)
   RESTORE(TmpCr);
   IF TotalMnthAmnt # 0 THEN
    SEARCH(VehType, VehType, , TmpCr.VehType);
    L_Car.StandOnCarLog(TmpCr.BoxNbr, EPer);
    CONFORM(CarLog, Car);
    CONFORM(CarLog, Mark);
    psf_Str(""+OKTMONbr, ConvertTaxVehTypeAsStr(0, 1));
    psf_Str(""+OKTMONbr, TmpCr.VIN);
    psf_Str("ઠ"+OKTMONbr, Mark.Name);
    psf_Str(""+OKTMONbr, TmpCr.StateNbr);
    psf_Num(""+OKTMONbr, TmpCr.EngPower);
    psf_Str(""+OKTMONbr, "251");
    psf_Num(""+OKTMONbr, TmpCr.EcoCls);
    psf_Num("᪒"+OKTMONbr, TmpCr.Age);
    psf_Num(""+OKTMONbr, TotalMnthAmnt);
    psf_Num("䊢"+OKTMONbr, TotalMnthAmnt / MnthAmntInPer);
    psf_Num("⠢"+OKTMONbr, TmpCr.TaxRate);
    IF L_DatTim.YEAR(BPer) >= 2014 THEN
     IF ~!TmpCr.IncCoef THEN
      psf_Num("䊯"+OKTMONbr, TmpCr.IncCoef);
     END;
     psf_Str(""+OKTMONbr, TmpCr.OwnPart);
    END;
    psf_Num("㬈"+OKTMONbr, TotalTaxSum);
    TotalBnfMnthAmnt:=FreeTaxMnthAmnt + DecTaxMnthAmnt;
    IF TotalBnfMnthAmnt # 0 THEN
     psf_Num("죮⌥ᒑ"+OKTMONbr, TotalBnfMnthAmnt);
     psf_Num("䊫"+OKTMONbr, TotalBnfMnthAmnt / MnthAmntInPer);
     IF FreeTaxSum # 0 THEN
      IF    Region.Region = L_Russia.reg_72 THEN
       FreeTaxCode:="000100050000";
      ELSIF Region.Region = L_Russia.reg_77 THEN
       FreeTaxCode:="000400010001";
      ELSE
       L_General.CallUs(0);
      END;
      psf_Str("ᢍ"+OKTMONbr, "20210/" + FreeTaxCode);
      psf_Num("㬎ᢍ"+OKTMONbr, FreeTaxSum);
     END;
     IF DecTaxSum # 0 THEN
      IF Region.Region = L_Russia.reg_50 THEN
       FreeTaxCode:="000700020000";
       psf_Str("⠢"+OKTMONbr, "20230/" + FreeTaxCode);
       psf_Num("㬑⠢"+OKTMONbr, DecTaxSum);
      ELSE
       L_General.CallUs(0);
      END;
     END;
    END;
    psf_Num("㬈᫓"+OKTMONbr, TotalTaxSum - (FreeTaxSum + DecTaxSum));
    psf_Str("ID"+OKTMONbr, TmpCr.ID);
    INC(_Table2);
   END;
   NEXTINEXTENDEDSEL(TmpCr, ID, EngPower);
  END; (* WHILE OCCURE(TmpCr) ... *)

  i:=0;
  WHILE i < 3 DO
   IF Region.Region = L_Russia.reg_77 THEN
    AdvSum:=0;
    Source:=L_Packet.src_System;
   ELSE
    SETEMPTY(AdvSum);
    Source:=L_Packet.src_Operator;
   END;
   L_Packet.ext_psf_Num(""+L_Str.IntStr(i+1)+OKTMONbr, AdvSum, 00000, 00000, Source);
   INC(i);
  END; (* WHILE i < 3 *)
 END {FillPacketBySingleOKTMO};

 PRIVATE PROCEDURE PutInPacket(BPer, EPer: DATE);
  VAR
   trgStatus: LIKE(Packet.Status);
 BEGIN
  L_Packet.DefinePckMyFirm(L_Packet.bm_byPacket);
  CONFORM(Packet, ATER);
  L_Packet.psf_Str("", L_Packet.GetIdFile("NO_TRAND"), 00000, 00000);
  FillPacketBySingleOKTMO(BPer, EPer, "_1");
  IF Region.Region = L_Russia.reg_77 THEN
   trgStatus:=L_Packet.st_Prepared;
  ELSE
   trgStatus:=L_Packet.st_InProcess;
  END;
  L_Packet.FinishATER(trgStatus);
 END {PutInPacket};

 PRIVATE PROCEDURE Make(BPer, EPer: DATE);
 BEGIN
  L_OTx.Create_TmpCr();
  CreateTmpFiles();
  MakeIndex(BPer, EPer);
  PutInPacket(BPer, EPer);
  L_OTx.Purge_TmpCr();
  PurgeTmpFiles();
  LIKEMENU(Survey, L_General.NameConnection(rn_BadCar),
           Survey, L_General.NameConnection(rn_BnfTaxSum),
           Survey, L_General.NameConnection(rn_BnfCarList));
 END {Make};

 PRIVATE PROCEDURE AllowedCalcTransportTax(): SCAL[2];
 BEGIN
  RETURN (Region.Region = L_Russia.reg_77) |
         (Region.Region = L_Russia.reg_50) |
         (Region.Region = L_Russia.reg_72);
 END {AllowedCalcTransportTax};

 PUBLIC PROCEDURE XOMN14();
  VAR
   Msg           : STRING[];
   StandartPeriod: SCAL[2];
   BPer, EPer    : DATE;
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭    ⭮");
  L_Packet.ClearATER(0);
  BPer:=Packet.PerB;
  EPer:=L_DatTim.MonthEnd(Packet.PerE);
  CONFORM(Packet, ATER);
  L_Packet.CheckActualPacketInPer();
  L_General.Assert(SEARCH(Region, Region, Str.Slice(P_Firm.FP_KPP(L_Packet.GetPacketOwnFirm(), EPer), 0, 2)),
                   " ࠢ筨 ॣ   ॣ,|" + "㪠   ࣠樨");

  L_General.ConsultToUs(AllowedCalcTransportTax(),
                        " ࠭ᯮ⭮ |" +
                        " ॣ '" + Region.Region + " " + Region.Name + "'  ॠ");
  IF (L_DatTim.MONTH(BPer) = 0) & (L_DatTim.MONTH(EPer) = 11) THEN
   StandartPeriod:=1;
   Msg     :=" " +
             L_Str.IntStr(L_DatTim.YEAR(EPer)) + " ";
   L_General.Assert(ATER.Kind = L_Packet.knd_TT_Decl, "   㦭 ନ஢ ⭮  |'"+L_Str.PoolItem(L_Packet.knd_Pool, L_Packet.knd_TT_Decl)+"'");
  ELSE
   StandartPeriod:=0;
   IF (L_DatTim.QUARTAL(EPer) < 3) & L_DatTim.IsLastMonthOfQuartal(EPer) & (L_DatTim.MonthEnd(L_DatTim.IncMonth(BPer, +2)) = EPer) THEN
    Msg    :=" " +
             L_Str.PoolItem("I ⠫ |II ⠫ |III ⠫ ", L_DatTim.QUARTAL(EPer)) +
             L_Str.IntStr(L_DatTim.YEAR(EPer)) + " ";
   ELSE
    Msg    :=" ਮ c " +
             Str.Cap(L_DatTim.FullDateStr(BPer)) +
             "  " + Str.Cap(L_DatTim.FullDateStr(EPer));
   END;
  END;
  L_StdFrm.Question("⮢ ⭮  ଥ|" + L_Str.PoolItem(L_Packet.knd_Pool, ATER.Kind) + "|" +  Msg);
  IF ~StandartPeriod THEN
   L_StdFrm.Choice(" ਮ|" + "c " + Str.Cap(L_DatTim.FullDateStr(BPer)) +
                   "  " + Str.Cap(L_DatTim.FullDateStr(EPer)) + "|  ⠭! த?");
  END;

  Make(BPer, EPer);
 END {XOMN14};

END.
