(*
%Copyright   (c) Polak IT
%Author      31.01.2012 12:38:56 POLAK\GAV
%Purpose     ⢨  
%Type        operation
%Specific    AP
%Modified    28.03.2014 10:40:00 POLAK\LDA
%Environment
*)

 MODULE xRWayD [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT FIO, L_FIO, L_Events, L_HTTP, Str, L_Str, L_General,
        Memo, L_Way, L_DatTim, P_Car, L_StdFrm, L_SES,
        L_bp, L_AFM, Math, P_Route, L_Prop, L_WDO, L_SCAD;

 CONST
(*
  ftp_url = "ftp://217.116.59.151";
  ftp_usr = "ftpuser";
  ftp_psw = "WpAHVxXu7p0=";
*)
  ftp_url = "ftp://192.168.0.100";
  ftp_usr = "ftpuser";
  ftp_psw = "TGlYrWV9f5RBpszJLl2Ysw==";

 PUBLIC PROCEDURE xRWayD_OnInitializeWindow();
 BEGIN
  L_WDO.iMayBeEmpty  (1, ["xRWayDH.Exit"]);
  L_WDO.iField       (1, "xRWayDH.Status").Format:="-||A";
  L_WDO.iMayBeEmpty  (2, ["xRWayDCP.asStartT", "xRWayDCP.asDay", "xRWayDCP.asRWayS"]);
  L_WDO.iField       (2, "xRWayDCP.Status").Format:="-||A";
  L_WDO.iField       (2, "xRWayDCP.Dir").Format:="|";
  L_WDO.iZone        (3).ViewOnly:=1;
  L_WDO.iZone        (4).ViewOnly:=1;
  L_WDO.iZone        (5).ViewOnly:=1;
  L_WDO.iZone        (1).Narrowing:="xRWayDH.date=Memo.CurDate";
  L_WDO.iZone        (3).Narrowing:="Staff.TSN=xRWayDH.tsn";
  L_WDO.iZone        (4).Narrowing:="Car.BoxNbr=xRWayDH.boxnbr";
  L_WDO.iZone        (5).Narrowing:="Stop.Stop=xRWayDCP.stop";
 END {xRWayD_OnInitializeWindow};

 PRIVATE PROCEDURE path_Root(): STRING[];
 BEGIN
  RETURN FIO.BuildPath("REP\GLONASS", , FIO.AsbSpecialFolders("ClientProjectRoot"));
 END {path_Root};

 PRIVATE PROCEDURE path_In(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=FIO.BuildPath("IN", , path_Root());
  L_FIO.MakeSubDirs(Result);
  RETURN Result;
 END {path_In};

 PRIVATE PROCEDURE path_Out(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=FIO.BuildPath("OUT", , path_Root());
  L_FIO.MakeSubDirs(Result);
  RETURN Result;
 END {path_Out};

 PRIVATE PROCEDURE GetArchFullPath(D: DATE; IsIncoming: SCAL[2]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=FIO.BuildPath("ARCH", , path_Root());
  Result:=FIO.BuildPath(L_Str.PoolItem("OUT|IN", IsIncoming), , Result);
  Result:=FIO.BuildPath(FLDTOSTR(D, "yN"), , Result);
  L_FIO.MakeSubDirs(Result);
  RETURN Result;
 END {GetArchFullPath};

 PRIVATE PROCEDURE E_InFileMask(D: DATE): STRING[];
 BEGIN
  RETURN "Out4"+FLDTOSTR(D, "D")+"*.txt";
 END {E_InFileMask};

 PRIVATE PROCEDURE E_OutFileName(): STRING[];
 BEGIN
  RETURN "tpatp4"+FLDTOSTR(SYSDATE(), "D")+"-"+L_DatTim.SysDateTimeStamp()+".txt";
 END {E_OutFileName};

 PRIVATE PROCEDURE MoveToArchive(D: DATE; FN: STRING[]; IsIncoming: SCAL[2]);
  VAR
   ArcFN,
   fName,
   fExt  : STRING[];
 BEGIN
  FIO.SplitPath(FN, fName, fExt);
  ArcFN:=FIO.BuildPath(fName + "_" + L_DatTim.SysDateTimeStamp(), fExt);
  ArcFN:=L_FIO.GetUniqueFileNameInFolder(ArcFN, GetArchFullPath(D, IsIncoming));
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
   FIO.RenMov(FN, , ArcFN);
  EXCEPT
  ON Exc: Exc_Root DO
(*
   RAISE();
*)
  END; (* TRY *)
 END {MoveToArchive};

 PRIVATE PROCEDURE PutToFTP(D: DATE; FN: STRING[]);
 BEGIN
  IF ~L_General.IsOurSite() THEN
   L_HTTP.ftpPutFileSafe(ftp_url, ftp_usr, ftp_psw, FN, "ftpin");
  END;
  MoveToArchive(D, FN, 0);
 END {PutToFTP};

 PRIVATE PROCEDURE E_outRoute(): STRING[];
  VAR
   Result: STRING[];
   Dummy : NUMERIC[0];
 BEGIN
  Result:=Str.Item(ExitClss.Sign, "/-*", 0);
  RETURN Result;
 END {E_outRoute};

 PRIVATE PROCEDURE E_outGrNbr(): STRING[];
  VAR
   Result: STRING[];
   Dummy : NUMERIC[0];
 BEGIN
  Result:=Str.Item(ExitClss.Sign, "/-*", 1);
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   Dummy:=STRTOFLD(Result, NUMERIC);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_FailedSTRTOFLD THEN
    L_General.Error(" 祭  室 " + ExitClss.ExitClss +
                    "|㪠 ஢  䨪 '" + Result + "'");
   ELSE
    RAISE();
   END;
  END; (* TRY *)
  RETURN Result;
 END {E_outGrNbr};

 PRIVATE PROCEDURE E_outChange(): STRING[];
 BEGIN
  RETURN StExit.Change;
 END {E_outChange};

 PRIVATE PROCEDURE E_outTSN(): STRING[];
 BEGIN
  RETURN L_Str.IntStr(RWayS.TSN);
 END {E_outTSN};

 PRIVATE PROCEDURE E_outBoxNbr(): STRING[];
 BEGIN
  RETURN L_Str.IntStr(RWayS.BoxNbr);
 END {E_outBoxNbr};

 PRIVATE PROCEDURE E_outPark(): STRING[];
 BEGIN
  RETURN "4";
 END {E_outPark};

 PRIVATE PROCEDURE E_outStop(): STRING[];
 BEGIN
  RETURN L_Str.IntStr(2000 + Stop.Stop);
 END {E_outStop};

 PRIVATE PROCEDURE E_inStop(stop: STRING[]): LIKE(xRWayDCP.stop);
 BEGIN
  RETURN STRTOFLD(stop, SCAL) MOD 1000;
 END {E_inStop};

 PRIVATE PROCEDURE ConvertCrazyStringToTime(s: STRING[]): TIME;
  VAR
   asNumeric: NUMERIC[2];
   result: TIME;
 BEGIN
  asNumeric:=STRTOFLD(s, NUMERIC) MOD 24;
  RETURN 00:00 + asNumeric DIV 1 + (asNumeric MOD 1) * 100 / 60;
(*
  s:=Str.Item(s, ".", 1);
  IF ~!s THEN
   IF Str.Length(s) = 1 THEN
    s:=s + "0"; (* 17:40    "17.4" *)
   END;
   result:=result + STRTOFLD(s, NUMERIC) / 60;
  END;
  RETURN result;
*)
 END {ConvertCrazyStringToTime};

 PRIVATE PROCEDURE ConvertTimeToCrazyString(t: TIME): STRING[];
 BEGIN
  RETURN FLDTOSTR(t, "H.M");
 END {ConvertTimeToCrazyString};

 PRIVATE PROCEDURE ImportOneFile(D: DATE; FN: STRING[]): SCAL[2];
  VAR
   txt,
   s      : STRING[];
   cnt,
   lcnt   : NUMERIC[0];
   date   : LIKE(xRWayDH.date);
   tsn    : LIKE(xRWayDH.tsn);
   boxnbr : LIKE(xRWayDH.boxnbr);
   route  : LIKE(xRWayDH.route);
   grnbr  : LIKE(xRWayDH.grnbr);
   change : LIKE(xRWayDH.change);
   Job    : LIKE(xRWayDCP.Job);
   Plan   : LIKE(xRWayDCP.Plan);
   Stop   : LIKE(xRWayDCP.stop);
   oPrompt: PROMPT_LINE;
 BEGIN
  PROMPT(FN);
  oPrompt:=PROMPT_LINE.Create("");
  SETZERO(cnt, lcnt);
  FIO.Open(F, FN, , Input);
  FIO.SetCP(F, FIO.CP_WindowsRussian);
  IF ~FIO.RdStr(F, txt) THEN
   txt:="";
  END;
  FIO.Close(F);
  LOOP
   s:=Str.Item(txt, L_Str.LF, lcnt);
   IF !s THEN
    EXIT;
   END;
   INC(lcnt);
   PROMPT(L_Str.IntStr(lcnt) + "  " + s);
   IF (Str.Item(s, ",", 0) = "9") THEN
    IF (Str.Item(s, ",", 1) # "2") THEN
     L_General.InformUs(" ⮪ " + Str.Item(s, ",", 1) + "  ঠ");
    END;
    date  :=STRTOFLD(Str.Item(s, ",", 2), DATE, "y-N-D");
    boxnbr:=STRTOFLD(Str.Item(s, ",", 7), SCAL);
    tsn   :=STRTOFLD(Str.Item(s, ",", 8), SCAL);
    route :=Str.Item(s, ",", 4);
    grnbr :=STRTOFLD(Str.Item(s, ",", 5), NUMERIC);
    change:=STRTOFLD(Str.Item(s, ",", 6), NUMERIC);
    IF date = D THEN
     IF ~ADD(xRWayDH, date, date, boxnbr, tsn, route, grnbr, change) THEN
      IF SELECT(tmpEC, tmpEC, xRWayDH.route, xRWayDH.grnbr) THEN
       SELECT(StExit, ExitClss, , tmpEC.ExitClss);
       WHILE OCCURE(StExit) DO
        IF (StExit.Change = xRWayDH.change) & L_Way.StExitActiveOnDate(StExit.Exit, D) THEN
         L_General.Assert(!xRWayDH.Exit, "  饣 室  " + tmpEC.ExitClss + "," +
                                         "|ᬥ " + StExit.Change + ",  " + L_DatTim.DateStr(D));
         xRWayDH.Exit:=StExit.Exit;
         REPLACE(xRWayDH);
        END;
        NEXT(StExit);
       END; (* WHILE OCCURE(StExit) ... *)
(**)
       IF NEXT(tmpEC) THEN
        L_StdFrm.Choice("  饣  室," +
                        "| " + xRWayDH.route +
                        ", 䨪 " + L_Str.IntStr(xRWayDH.grnbr) +
                        ",  " + L_DatTim.DateStr(D));
      END;
(**)
      END;
     END;
     Job   :=STRTOFLD(Str.Item(s, ",", 12), SCAL);
     Plan  :=ConvertCrazyStringToTime(Str.Item(s, ",", 13));
     Stop  :=E_inStop(Str.Item(s, ",", 9));
     ADD(xRWayDCP, xRWayDH, , xRWayDH.xRWayDH, Job, Plan, Stop);
     xRWayDCP.Fact:=ConvertCrazyStringToTime(Str.Item(s, ",", 14));
     xRWayDCP.Dir :=STRTOFLD(Str.Item(s, ",", 10), SCAL);
     REPLACE(xRWayDCP);
     INC(cnt);
    ELSE
     L_General.CallUs(cnt = 0);
    END;
   END; (* IF (Str.Item(s, ",", 0) = "9") *)
  END; (* LOOP *)
  RETURN (cnt > 0) | (lcnt = 0);
 END {ImportOneFile};

 PRIVATE PROCEDURE tmpEC_Make(D: DATE);
 BEGIN
  L_AFM.MakeIndex("tmpEC", "route   : LIKE(xRWayDH.route);" +
                           "grnbr   : LIKE(xRWayDH.grnbr);" +
                           "ExitClss: LIKE(ExitClss.ExitClss)");
  SELECT(ExitClss, ExitClss);
  WHILE OCCURE(ExitClss) DO
   PROMPT(ExitClss.ExitClss);
   IF (ExitClss.Strict = L_Way.ExitStrict_Reg) & L_DatTim.IsActive(D, ExitClss.Begin, ExitClss.Till) THEN
    TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     ADD(tmpEC, tmpEC, , E_outRoute(), STRTOFLD(E_outGrNbr(), NUMERIC), ExitClss.ExitClss);
    EXCEPT
    ELSE
    END;
   END;
   NEXT(ExitClss);
  END; (* WHILE OCCURE(ExitClss) ... *)
 END {tmpEC_Make};

 PUBLIC PROCEDURE Import();
  CONST
   maxFiles = 1000;
  VAR
   File     : OBJECT;
   InFolder : FOLDER_ENTRY;
   eInFolder: ENUMERATOR;
   D        : DATE;
   FNs      : STRING[][maxFiles];
   i        : NUMERIC[0];
 BEGIN
(*
SELECT(xRWayDCP, xRWayDH); REMSEL(xRWayDCP);
SELECT(xRWayDH, xRWayDH); REMSEL(xRWayDH);
*)
  D:=Memo.ud_cd();
  tmpEC_Make(D);
  L_FIO.MakeSubDirs(path_In());
  IF ~L_General.IsOurSite() THEN
   L_HTTP.ftpMoveFilesFromDir(ftp_url, ftp_usr, ftp_psw, E_InFileMask(D), "ftpout", path_In());
  END;
  InFolder :=FOLDER_ENTRY.Create(path_In());
  eInFolder:=CreateENUMERATOR(InFolder.FolderContent);
  i:=0;
  WHILE ~eInFolder.AtEnd() DO
   File:=eInFolder.Item();
   IF ~File.Attributes.Directory THEN
    IF ImportOneFile(D, File.Path) THEN
     FNs[i]:=File.Path;
     INC(i);
    END;
   END;
   eInFolder.MoveNext();
  END; (* WHILE ~eInFolder.AtEnd...*)
  DEC(i);
  WHILE i >= 0 DO
   PROMPT("७  娢...");
   MoveToArchive(D, FNs[i], 1);
   DEC(i);
  END; (* WHILE i >= 0  *)
 END {Import};

 PRIVATE CONST
  ses_OrderExported = "OrderExported";

 PRIVATE PROCEDURE MarkExportOrder(D: DATE);
 BEGIN
  L_SES.PutValueAtSlaveTrn(L_SES.sit_Global, ses_OrderExported, FLDTOSTR(D));
 END {MarkExportOrder};

 PRIVATE PROCEDURE OrderExported(D: DATE): SCAL[2];
 BEGIN
  RETURN D <= L_SES.GetFieldValue_asDATE(L_SES.sit_Global, ses_OrderExported, D-1);
 END {OrderExported};

 PUBLIC PROCEDURE xRWEO();
  CONST
   bpId = "xRWEO";
  VAR
   D       : DATE;
   fName,
   fNameTmp: STRING[];
   TakenCnt: NUMERIC[0];
 BEGIN
  L_bp.Begin(bpId, ".㧪 鸞", L_bp.t_Process, L_General.tc_onDate);

  D:=Memo.ud_cd();
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_StdFrm.Question("।   " + L_DatTim.DateStr(D));
  IF OrderExported(D) THEN
   L_StdFrm.Confirm("  " + L_DatTim.DateStr(D) + " 㦥 ।." +
                    "||।  ୮?");
  END;

  fName   :=FIO.BuildPath(E_OutFileName(), , path_Out());
  fNameTmp:=FIO.BuildPath(fName, "tmp");
  FIO.Open(F, fNameTmp, , Create);
  FIO.SetCP(F, FIO.CP_WindowsRussian);
  TakenCnt:=0;
  SELECT(RWayS, Date, , D);
  WHILE OCCURE(RWayS) DO
   PROMPT(RWayS.RWayS);
   CONFORM(RWayS, StExit);
   IF P_Car.HasActualCarPro(RWayS.BoxNbr, D, P_Car.P_NavigationSystem) &
      (StExit.Strict = L_Way.ExitStrict_Reg) THEN
    CONFORM(StExit, ExitClss);
    IF RWayS.Status # L_Way.rwsStat_Ordered THEN
     IF TakenCnt = 0 THEN
      L_StdFrm.Choice("  " + L_DatTim.DateStr(D) + " 㦥 뤠." +
                      "| 믮 ᢮६ ᯮ 鸞?");
     END;
     INC(TakenCnt);
    END;
    FIO.WrStr(F, "2,"); (*type*)
    FIO.WrStr(F, "2,"); (*version*)
    FIO.WrStr(F, FLDTOSTR(D, "y-N-D") + ",");
    FIO.WrStr(F, E_outPark() + ",");
    FIO.WrStr(F, E_outRoute() + ",");
    FIO.WrStr(F, E_outGrNbr() + ",");
    FIO.WrStr(F, E_outChange() + ",");

    CONFORM(StExit, SEJobs);
    LOOP
     L_General.Assert(OCCURE(SEJobs), " ३ᮢ  ࠡ⮩  ॣ୮ 室 " + StExit.Exit);
     CONFORM(SEJobs, WJMode);
     IF WJMode.RunSel = L_Way.runsel_Work THEN
      EXIT;
     END;
     NEXT(SEJobs);
    END;
    FIO.WrStr(F, ConvertTimeToCrazyString(SEJobs.StartT) + ",");
    FIO.WrStr(F, E_outBoxNbr() + ",");
    FIO.WrStr(F, E_outTSN() + L_Str.LF);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  FIO.Close(F);
  FIO.RenMov(fNameTmp, , fName);
(*
  PutToFTP(D, fName);
  STDMSG(" 䠩 " + fName, INFORM);
*)
  MarkExportOrder(D);
  L_bp.End();
 END {xRWEO};

 PRIVATE PROCEDURE Switch_PutToFTP(D: DATE; s: STRING[]);
  VAR
   fName: STRING[];
 BEGIN
  fName:=FIO.BuildPath(E_OutFileName(), , path_Out());
  FIO.Open(F, fName, , Create);
  FIO.SetCP(F, FIO.CP_WindowsRussian);
  FIO.WrStr(F, s);
  FIO.Close(F);
(*
  PutToFTP(D, fName);
*)
 END {Switch_PutToFTP};

 PUBLIC PROCEDURE Switch();
  VAR
   D      : DATE;
   oPrompt: PROMPTLINE;
   s      : STRING[];
 BEGIN
  L_General.CallUs(OCCURE(RWayS));
  D:=RWayS.Date;
  IF OrderExported(D) THEN
   IF P_Car.HasActualCarPro(RWayS.BoxNbr, D, P_Car.P_NavigationSystem) THEN
    oPrompt:=PROMPTLINE.Create("ࠢ   ''");
    IF RWayS.Status = L_Way.rwsStat_Ordered THEN
     CONFORM(RWayS, StExit);
     CONFORM(StExit, ExitClss);
     IF (StExit.Strict = L_Way.ExitStrict_Reg) THEN
      s:="2" + "," + (*type*)
         "2" + "," + (*version*)
         FLDTOSTR(D, "y-N-D") + "," +
         E_outPark() + "," +
         E_outRoute() + "," +
         E_outGrNbr() + "," +
         E_outChange() + "," +
         ConvertTimeToCrazyString(StExit.BegTime) + "," +
         E_outBoxNbr() + "," +
         E_outTSN() + L_Str.LF;
      Switch_PutToFTP(D, s);
     ELSIF RTI.Get().CurProcess.Kind = FORM_PROCESS.ProcessKind_Edit THEN
      SEARCH(StExit, Exit, , GE_PVALUE(RWayS.Exit));
      IF (StExit.Strict = L_Way.ExitStrict_Reg) THEN
       s:="5" + "," + (*type*)
          "2" + "," + (*version*)
          FLDTOSTR(D, "y-N-D") + "," +
          E_outPark() + "," +
          E_outRoute() + "," +
          E_outGrNbr() + "," +
          E_outChange() + "," +
          E_outBoxNbr() + "," +
          E_outTSN() + "," +
          ConvertTimeToCrazyString(StExit.BegTime) + "," +
          "5555" + "," +      (* 室*)
          "00:00" + L_Str.LF; (* ६ 砭 室*)
       Switch_PutToFTP(D, s);
      END; (* IF (StExit.Strict = L_Way.ExitStrict_Reg) *)
     END; (* IF (StExit.Strict = L_Way.ExitStrict_Reg) *)
    ELSE
     CONFORM(RWayS, RWayJ);
     LAST(RWayJ);
     PROMPT(RWayS.RWayS + " " + L_DatTim.TimeStr(RWayJ.StartT));
     CONFORM(RWayJ, SEJobs);
     CONFORM(SEJobs, StExit);
     CONFORM(StExit, ExitClss);
     IF (StExit.Strict = L_Way.ExitStrict_Reg) THEN
      s:="2" + "," + (*type*)
         "2" + "," + (*version*)
         FLDTOSTR(D, "y-N-D") + "," +
         E_outPark() + "," +
         E_outRoute() + "," +
         E_outGrNbr() + "," +
         E_outChange() + "," +
         ConvertTimeToCrazyString(RWayJ.StartT) + "," +
         E_outBoxNbr() + "," +
         E_outTSN() + L_Str.LF;
      Switch_PutToFTP(D, s);
     ELSE
      SAVE(RWayJ);
      IF PREV(RWayJ) THEN
       CONFORM(RWayJ, SEJobs);
       CONFORM(SEJobs, StExit);
      ELSE
       CONFORM(RWayS, StExit);
      END;
      RESTORE(RWayJ);
      IF (StExit.Strict = L_Way.ExitStrict_Reg) THEN
       s:="5" + "," + (*type*)
          "2" + "," + (*version*)
          FLDTOSTR(D, "y-N-D") + "," +
          E_outPark() + "," +
          E_outRoute() + "," +
          E_outGrNbr() + "," +
          E_outChange() + "," +
          E_outBoxNbr() + "," +
          E_outTSN() + ",";
       CONFORM(RWayJ, SEJobs);
       s:=s +
          ConvertTimeToCrazyString(SEJobs.StartT) + "," +
          "5555" + "," +      (* 室*)
          "00:00" + L_Str.LF; (* ६ 砭 室*)
       Switch_PutToFTP(D, s);
      END; (* IF (StExit.Strict = L_Way.ExitStrict_Reg) *)
     END; (* IF (StExit.Strict = L_Way.ExitStrict_Reg) *)
    END; (* IF RWayS.Status = L_Way.rwsStat_Ordered *)
   END; (* IF P_Car.HasActualCarPro(RWayS.BoxNbr, D, P_Car.P_NavigationSystem) *)
  END; (* IF OrderExported(D) *)
 END {Switch};

 PRIVATE PROCEDURE NeedRtMStop(): SCAL[2];
 BEGIN
  CONFORM(RtMStop, Stop);
  RETURN (Stop.CP # 00) | RtMStop.CPActive[SEJobs.Dir];
 END {NeedRtMStop};

 PRIVATE PROCEDURE CheckFinalStopIsCP();
 BEGIN
  IF ~NeedRtMStop() THEN
   L_General.Error("⠭ " + Stop.Stop + " " + Stop.Name +
                   "| 筮 ( " + RtMStop.Route + ", 䨪 " + RtMStop.Modif + "." +
                   "|| 㪠  , ⫨  00.");
  END;
 END {CheckFinalStopIsCP};

 PRIVATE PROCEDURE NxtRtMStop(): SCAL[2];
 BEGIN
  LOOP
   IF RoutMod.Dir = SEJobs.Dir THEN
    NEXT(RtMStop);
   ELSE
    PREV(RtMStop);
   END;
   IF ~OCCURE(RtMStop) THEN
    RETURN 0;
   END;
   IF NeedRtMStop() THEN
    RETURN 1;
   END;
  END;
 END {NxtRtMStop};

 PRIVATE PROCEDURE E_IsDinner(): SCAL[2];
 BEGIN
  RETURN WJMode.WJType = L_Way.WJType_Void;
 END {E_IsDinner};

 PRIVATE PROCEDURE intFillExitSchedule(OnDaysStr: STRING[]; asFrom: DATE);
  VAR
   Common  : STRING[];
   TripCnt,
   StopCnt : NUMERIC[0];
   LastTrip: LIKE(SEJobs.Trip);
   Dummy,
   PrvTripWasExported: SCAL[2];
 BEGIN
  Common:="8," + (*type*)
          "2," +  (*version*)
          FLDTOSTR(asFrom(*StExit.FromD*), "y-N-D") + "," +
          E_outPark() + "," +
          OnDaysStr + "," +
          "0" + "," + (* "ਧ  ᯨᠭ".  㯮 0 *)
          E_outRoute() + "," +
          E_outGrNbr() + "," +
          E_outChange() + ",";

  CONFORM(StExit, SEJobs);
  SETEMPTY(LastTrip);
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, WJMode);
   CONFORM(SEJobs, RoutMod);
   IF  (RoutMod.Run # 0) & (WJMode.RunSel = L_Way.runsel_Work) THEN
    LastTrip:=SEJobs.Trip;
   END;
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)

  FIRST(SEJobs);
  TripCnt:=0;
  PrvTripWasExported:=0;
  WHILE OCCURE(SEJobs) DO
   PROMPT(SEJobs.Trip);
   StopCnt:=0;
   CONFORM(SEJobs, WJMode);
   CONFORM(SEJobs, RoutMod);
   IF  RoutMod.Run # 0 THEN
    CONFORM(RoutMod, Route);
    CONFORM(Route, TKind);
    IF TKind.Rgn = L_Way.tkrgn_City THEN
     SETSEL(RtMStop, Route, SEJobs.Route, SEJobs.Modif);
     IF RoutMod.Dir = SEJobs.Dir THEN
      LAST(RtMStop);
      CheckFinalStopIsCP();
      FIRST(RtMStop);
      CheckFinalStopIsCP();
     ELSE
      FIRST(RtMStop);
      CheckFinalStopIsCP();
      LAST(RtMStop);
      CheckFinalStopIsCP();
     END;
     WHILE OCCURE(RtMStop) DO
      FIO.WrStr(F, Common);
      FIO.WrStr(F, E_outStop() + ",");
      FIO.WrStr(F, SEJobs.Dir + ",");
      FIO.WrStr(F, ConvertTimeToCrazyString(L_Way.GetStopCtrlTime_ofCurSEJobs(SYSDATE())) + ",");
      FIO.WrStr(F, L_Str.IntStr(WJMode.RunSel = L_Way.runsel_Zero) + ",");
      IF    ~NxtRtMStop() THEN
       IF SEJobs.Trip = LastTrip THEN
        FIO.WrStr(F, "6" + ","); (* "ਧ 砫 " *)
       ELSE
        FIO.WrStr(F, "0" + ","); (* "ਧ 砫 " *)
       END;
       FIO.WrStr(F, "2" + ","); (* "ਧ 砫 ३" *)
      ELSIF StopCnt = 0 THEN
       IF (TripCnt = 0) & (WJMode.RunSel = L_Way.runsel_Work) THEN
        FIO.WrStr(F, "5" + ","); (* "ਧ 砫 " *)
       ELSE
        FIO.WrStr(F, "0" + ","); (* "ਧ 砫 " *)
       END;
       FIO.WrStr(F, "1" + ","); (* "ਧ 砫 ३" *)
      ELSE
       FIO.WrStr(F, "0" + ","); (* "ਧ 砫 " *)
       FIO.WrStr(F, "0" + ","); (* "ਧ 砫 ३" *)
      END;
      INC(StopCnt);
      FIO.WrStr(F, "0" + L_Str.LF); (* "⥫ ࠬ. ᥣ 0" *)
     END; (* WHILE OCCURE(RtMStop) ... *)
     INC(TripCnt, WJMode.RunSel = L_Way.runsel_Work);
     PrvTripWasExported:=1;
    ELSE
     PrvTripWasExported:=0;
    END; (* IF TKind.Rgn = L_Way.tkrgn_City *)
   ELSE
    IF PrvTripWasExported THEN
     FIO.WrStr(F, Common);
     FIO.WrStr(F, E_outStop() + ",");
     FIO.WrStr(F, SEJobs.Dir + ",");
     FIO.WrStr(F, ConvertTimeToCrazyString(SEJobs.StartT) + ",");
     FIO.WrStr(F, "0" + ",");
     IF E_IsDinner() THEN
      FIO.WrStr(F, "1" + ","); (* "ਧ 砫 " *)
     ELSE
      FIO.WrStr(F, "2" + ","); (* "ਧ 砫 " *)
     END;
     FIO.WrStr(F, "0" + ","); (* "ਧ 砫 ३" *)
     FIO.WrStr(F, "0" + L_Str.LF); (* "⥫ ࠬ. ᥣ 0" *)
 
     FIO.WrStr(F, Common);
     FIO.WrStr(F, E_outStop() + ",");
     FIO.WrStr(F, SEJobs.Dir + ",");
     FIO.WrStr(F, ConvertTimeToCrazyString(SEJobs.StopT) + ",");
     FIO.WrStr(F, "0" + ",");
     IF E_IsDinner() THEN
      FIO.WrStr(F, "3" + ","); (* "ਧ 砫 " *)
     ELSE
      FIO.WrStr(F, "4" + ","); (* "ਧ 砫 " *)
     END;
     FIO.WrStr(F, "0" + ","); (* "ਧ 砫 ३" *)
     FIO.WrStr(F, "0" + L_Str.LF); (* "⥫ ࠬ. ᥣ 0" *)
    END; (* IF PrvTripWasExported *)
   END; (* IF  RoutMod.Run # 0... *)
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
 END {intFillExitSchedule};

 PRIVATE PROCEDURE FillExitSchedule();
 BEGIN
  CONFORM(StExit, ExitClss);
(*
  IF    StExit.OnDays[L_DatTim.wd_Mon] &
        StExit.OnDays[L_DatTim.wd_Tue] &
        StExit.OnDays[L_DatTim.wd_Wed] &
        StExit.OnDays[L_DatTim.wd_Thu] &
        StExit.OnDays[L_DatTim.wd_Fri] &
        StExit.OnDays[L_DatTim.wd_Sat] &
        StExit.OnDays[L_DatTim.wd_Sun] THEN
   intFillExitSchedule("10");
  ELSIF StExit.OnDays[L_DatTim.wd_Mon] &
        StExit.OnDays[L_DatTim.wd_Tue] &
        StExit.OnDays[L_DatTim.wd_Wed] &
        StExit.OnDays[L_DatTim.wd_Thu] &
        StExit.OnDays[L_DatTim.wd_Fri] &
        ~StExit.OnDays[L_DatTim.wd_Sat] &
        ~StExit.OnDays[L_DatTim.wd_Sun] THEN
   intFillExitSchedule("8");
  ELSIF ~StExit.OnDays[L_DatTim.wd_Mon] &
        ~StExit.OnDays[L_DatTim.wd_Tue] &
        ~StExit.OnDays[L_DatTim.wd_Wed] &
        ~StExit.OnDays[L_DatTim.wd_Thu] &
        ~StExit.OnDays[L_DatTim.wd_Fri] &
        ~StExit.OnDays[L_DatTim.wd_Sat] &
        ~StExit.OnDays[L_DatTim.wd_Sun] THEN
   intFillExitSchedule("9");
  ELSE
*)
   IF StExit.OnDays[L_DatTim.wd_Mon] THEN
    intFillExitSchedule("1", 11\02\2012);
   END;
   IF StExit.OnDays[L_DatTim.wd_Tue] THEN
    intFillExitSchedule("2", 12\02\2012);
   END;
   IF StExit.OnDays[L_DatTim.wd_Wed] THEN
    intFillExitSchedule("3", 13\02\2012);
   END;
   IF StExit.OnDays[L_DatTim.wd_Thu] THEN
    intFillExitSchedule("4", 14\02\2012);
   END;
   IF StExit.OnDays[L_DatTim.wd_Fri] THEN
    intFillExitSchedule("5", 15\02\2012);
   END;
   IF StExit.OnDays[L_DatTim.wd_Sat] THEN
    intFillExitSchedule("6", 16\02\2012);
   END;
   IF StExit.OnDays[L_DatTim.wd_Sun] THEN
    intFillExitSchedule("7", 17\02\2012);
   END;
(*
  END;
*)
 END {FillExitSchedule};

 PUBLIC PROCEDURE xRWES();
  CONST
   bpId = "xRWES";
  VAR
   D       : DATE;
   fName,
   fNameTmp: STRING[];
 BEGIN
  L_bp.Begin(bpId, ".㧪 ᯨᠭ", L_bp.t_Process, L_General.tc_onDate);
  D:=Memo.ud_cd();
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);

  fName   :=FIO.BuildPath(E_OutFileName(), , path_Out());
  fNameTmp:=FIO.BuildPath(fName, "tmp");
  FIO.Open(F, fNameTmp, , Create);
  FIO.SetCP(F, FIO.CP_WindowsRussian);
  SETSEL(StExit, Strict, L_Way.ExitStrict_Reg);
  LAST(StExit);
  WHILE OCCURE(StExit) & (StExit.UpDate > D) DO
   PROMPT(StExit.Exit);
   IF L_DatTim.IsActive(D, StExit.FromD, StExit.UpDate) THEN
    FillExitSchedule();
   END; (* IF L_DatTim.IsActive(D, StExit.FromD, StExit.UpDate) *)
   PREV(StExit);
  END; (* WHILE OCCURE(StExit) ... *)
  FIO.Close(F);
  FIO.RenMov(fNameTmp, , fName);
(*
  PutToFTP(D, fName);
  STDMSG(" 䠩 " + fName, INFORM);
*)
  L_bp.End();
 END {xRWES};

 PUBLIC PROCEDURE ExportExitSchedule();
  VAR
   fName,
   fNameTmp: STRING[];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.Assert(ACCESS(StExit), " ⠭ 室");
  L_General.Assert(L_DatTim.IsActive(SYSDATE(), StExit.FromD, StExit.UpDate) |
                   L_DatTim.IsActive(SYSDATE() + 1, StExit.FromD, StExit.UpDate),
                   "祬 । 騩 室?");
  L_General.Assert(StExit.Strict = L_Way.ExitStrict_Reg, "室   ॣ");
  fName   :=FIO.BuildPath(E_OutFileName(), , path_Out());
  fNameTmp:=FIO.BuildPath(fName, "tmp");
  FIO.Open(F, fNameTmp, , Create);
  FIO.SetCP(F, FIO.CP_WindowsRussian);
  FillExitSchedule();
  L_General.Assert(FIO.Size(F) > 0, " 室  ३ᮢ,  㧪  ");
  FIO.Close(F);
  FIO.RenMov(fNameTmp, , fName);
(*
  PutToFTP(D, fName);
  STDMSG(" 䠩 " + fName, INFORM);
*)
 END {ExportExitSchedule};

 PRIVATE PROCEDURE xPD2F_File2Put(File: FOLDER_ENTRY): SCAL[2];
 BEGIN
  RETURN ~File.Attributes.Directory & ~Str.Match(File.Path, "*.tmp");
 END {xPD2F_File2Put};

 PUBLIC PROCEDURE xPD2F(); (* PutDelayedToFTP *)
  CONST
   bpId = "xPD2F";
  VAR
   FolderContent: ENUMERATOR;
   File         : FOLDER_ENTRY;
   dts          : TIMESTAMP;
 BEGIN
  L_bp.extBegin(bpId, ".ࠢ ४祭  FTP",
                L_bp.t_Process, L_General.tc_Entire, L_bp.pt_StrictlyInTime);
  FolderContent:=CreateENUMERATOR(FOLDER_ENTRY.Create(path_Out()).FolderContent);
  WHILE ~FolderContent.AtEnd() DO
   File:=FolderContent.Item();
   PROMPT(File.Path);
   IF xPD2F_File2Put(File) THEN
    dts:=File.TimeLastModified;
    TRY
     PutToFTP(SYSDATE(), File.Path);
    EXCEPT
    ON Exc: Exc_Root DO
     IF SYSTIMESTAMP() - dts > 1/24 THEN
      RAISE();
     END;
    END;
   END;
   FolderContent.MoveNext();
  END; (* WHILE ~FolderContent.AtEnd...*)
  L_bp.End();
 END {xPD2F};

 PUBLIC PROCEDURE xPD2F_CheckNecessity(VAR Result: SCAL[2]; VAR nextRun: TIMESTAMP);
  VAR
   FolderContent: ENUMERATOR;
 BEGIN
  FolderContent:=CreateENUMERATOR(FOLDER_ENTRY.Create(path_Out()).FolderContent);
  Result:=0;
  WHILE ~FolderContent.AtEnd() & ~Result DO
   IF xPD2F_File2Put(FolderContent.Item()) THEN
    Result:=1;
   END;
   FolderContent.MoveNext();
  END; (* WHILE ~FolderContent.AtEnd...*)
  nextRun      :=SYSTIMESTAMP() + 5/60/24;
 END {xPD2F_CheckNecessity};

 PRIVATE PROCEDURE Shift(): NUMERIC[0];
  CONST
   MaxShift = 99;
  VAR
   Result: NUMERIC[0];
 BEGIN
  IF RWayCP.FactT < RWayCP.PlanT THEN
   Result:=-(RWayCP.PlanT - RWayCP.FactT) * 60;
  ELSE
   Result:= (RWayCP.FactT - RWayCP.PlanT) * 60;
  END;
  IF    Result > MaxShift THEN
   Result:=MaxShift;
  ELSIF Result < -MaxShift THEN
   Result:=-MaxShift;
  END;
  RETURN Result;
 END {Shift};

 PUBLIC PROCEDURE FillRWayCPFact();
  VAR
   _Quality: LIKE(RWayJ.Quality);
 BEGIN
  ACCESS(RWayCP);
  CONFORM(RWayCP, RWayS);
  L_General.Assert(SELECT(xRWayDH, exit, RWayS.Date), " 믮    " + L_DatTim.DateStr(RWayS.Date));

  SELECT(xRWayDH, date, , RWayS.Date, RWayS.BoxNbr, RWayS.TSN);
  WHILE OCCURE(xRWayDH) DO
   SELECT(xRWayDCP, xRWayDH, , xRWayDH.xRWayDH);
   WHILE OCCURE(xRWayDCP) DO
    SELECT(RWayCP, RWayS, , RWayS.RWayS);
    WHILE OCCURE(RWayCP) DO
     IF RWayCP.Value # L_SCAD.cpv_Imported THEN
      IF (xRWayDCP.stop = RWayCP.Stop) & (xRWayDCP.Plan = RWayCP.PlanT) THEN
       CONFORM(RWayCP, SEJobs);
       IF (xRWayDCP.Dir = SEJobs.Dir) & (xRWayDH.Exit = SEJobs.Exit) THEN
        IF RWayCP.Value # L_SCAD.cpv_SetByOperator THEN
         RWayCP.Value:=L_SCAD.cpv_Imported;
         RWayCP.FactT:=xRWayDCP.Fact;
         RWayCP.Shift:=Shift();
         REPLACE(RWayCP);
        END;
        xRWayDCP.asRWayS :=RWayCP.RWayS;
        xRWayDCP.asDay   :=RWayCP.Day;
        xRWayDCP.asStartT:=RWayCP.StartT;
        xRWayDCP.Status  :=1;
        REPLACE(xRWayDCP);
        LAST(RWayCP);
       END;
      END;
     END;
     NEXT(RWayCP);
    END; (* WHILE OCCURE(RWayCP) *)
    NEXT(xRWayDCP);
   END; (* WHILE OCCURE(xRWayDCP) ... *)
   NEXT(xRWayDH);
  END; (* WHILE OCCURE(xRWayDH) ... *)

  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayJ) DO
   _Quality:=00;
   CONFORM(RWayJ, SEJobs);
   CONFORM(RWayJ, RWayCP);
   WHILE OCCURE(RWayCP) & (_Quality=00) DO
    IF !RWayCP.Shift THEN
     _Quality:=RWayJ.Quality;
     LAST(RWayCP);
    ELSIF Math.Abs(RWayCP.Shift) > L_SCAD.GetAccuracy() THEN
     _Quality:=01(*ࠪ*);
    END;
    NEXT(RWayCP);
   END;
   IF (RWayJ.Quality # _Quality) & (!RWayJ.Quality |
                                    L_StdFrm.Alternative(" ⢮ ३ " + RWayJ.Trip +
                                                         "|| " + RWayJ.Quality + "  " + _Quality)) THEN
    RWayJ.Quality:=_Quality;
    REPLACE(RWayJ);
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
 END {FillRWayCPFact};

 PUBLIC PROCEDURE ClearRWayCP();
 BEGIN
  ACCESS(RWayCP);
  WHILE SELECT(xRWayDCP, asRWayS, 1, RWayCP.RWayS) DO
   SETEMPTY(xRWayDCP.asRWayS, xRWayDCP.asDay, xRWayDCP.asStartT);
   xRWayDCP.Status:=0;
   REPLACE(xRWayDCP);
  END; (* WHILE OCCURE(xRWayDCP) ... *)
  SELECT(RWayCP, RWayS, , RWayCP.RWayS);
  WHILE OCCURE(RWayCP) DO
   IF RWayCP.Value = L_SCAD.cpv_Imported THEN
    SETEMPTY(RWayCP.Value, RWayCP.FactT, RWayCP.Shift);
    REPLACE(RWayCP);
   END;
   NEXT(RWayCP);
  END; (* WHILE OCCURE(RWayCP) ... *)
 END {ClearRWayCP};

BEGIN
 L_Events.ExecuteHandler();
END.
