(*
%Copyright   (c) Polak Computer System
%Author      16.07.2002 12:58:08 GAV
%Purpose     Excel (ole) প  ஡
%Type        control
%Specific    AP
%Modified    10.04.2012 12:10:20 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_OLE, L_DatTim, Str, L_Car, D_CarTb, E_Way, L_AFM, L_General;

 CONST
  prm_BoxNbr  = "ࠦ";
  prm_Date    = "";
  prm_Month   = "";
  prm_DayType = "";

 VAR
  IntvlB,
  IntvlE:   DATE;

  CurBoxNbr,
  v_BoxNbr:  LIKE(Car.BoxNbr);
  v_Date:    STRING[];
  v_Month:   STRING[];
  v_DayType: L_OLE.tKeyValue[128];

 PRIVATE PROCEDURE FillByKeyWord(Params:  STRING[][];
                         keyWord: STRING[];
                     VAR Value:   STRING[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  SETEMPTY(Value);
  i:=0;
  WHILE ~!Params[i] DO
   IF keyWord = Str.Item(Params[i], ": ", 0) THEN
    Value:=Str.Item(Params[i], ": ", 1);
   END;
   INC(i);
  END;
 END {FillByKeyWord};

 PRIVATE PROCEDURE FillParams(Heap: STRING[]);
  VAR
   Params     : STRING[][32];
 BEGIN
  L_OLE.SliceBySingle(Heap, Params);
  L_OLE.FillByKeyWord(Params, prm_DayType, v_DayType);
        FillByKeyWord(Params, prm_BoxNbr,  v_BoxNbr);
        FillByKeyWord(Params, prm_Date,    v_Date);
        FillByKeyWord(Params, prm_Month,   v_Month);
 END {FillParams};

 PRIVATE PROCEDURE ConvertToDate(Val: STRING[]): DATE;
 BEGIN
  RETURN STRTOFLD(Val, DATE, "D.N.y");
 END {ConvertToDate};

 TYPE
  tpbResult = SCAL[3];

 CONST
  pb_NoSuchBoxNbr      = 0;
  pb_FirstHandling     = 1;
  pb_PosteriorHandling = 2;

 PRIVATE PROCEDURE PrepareBasis(): tpbResult;
 BEGIN
  IF (v_BoxNbr # CurBoxNbr) THEN
   IF ~SEARCH(Car, BoxNbr, v_BoxNbr) THEN
    RETURN pb_NoSuchBoxNbr;
   ELSE
    CurBoxNbr:=v_BoxNbr;
    IF SEARCH(CarTb, BoxNbr, v_BoxNbr) THEN
     RETURN pb_PosteriorHandling;
    ELSE
     D_CarTb.Gather_CarTb(IntvlB, IntvlE, 1);
    END;
    RETURN pb_FirstHandling;
   END;
  ELSE
   RETURN pb_PosteriorHandling;
  END;
 END {PrepareBasis};

 PRIVATE PROCEDURE CR001_GetRun(Heap: STRING[]): NUMERIC[2];
 BEGIN
  FillParams(Heap);
  IF PrepareBasis() # pb_NoSuchBoxNbr THEN
   RETURN D_CarTb.CarTb_GetRunTot(v_BoxNbr, ConvertToDate(v_Date));
  ELSE
   RETURN 0;
  END;
 END {CR001_GetRun};

 PRIVATE PROCEDURE CR001_GetTotRun(Heap: STRING[]): NUMERIC[2];
 BEGIN
  FillParams(Heap);
  IF SELECT(CarRun, BoxNbr, v_BoxNbr) THEN
   IF    SRCINSEL(CarRun, EQ, ConvertToDate(v_Date) + 1) THEN
    RETURN CarRun.TotRun;
   ELSIF SRCINSEL(CarRun, LT, ConvertToDate(v_Date) + 1) THEN
    RETURN CarRun.TotRun + CarRun.Run;
   END;
  END;
  RETURN 0;
 END {CR001_GetTotRun};

 PRIVATE PROCEDURE CR001_GetMarkName(Heap: STRING[]): STRING[];
 BEGIN
  FillParams(Heap);
  IF L_Car._StandOnCarLog(v_BoxNbr, ConvertToDate(v_Date)) THEN
   CONFORM(CarLog, Mark);
   RETURN Mark.Mark + " " + Mark.Name;
  ELSE
   RETURN "ࠦ  ";
  END;
 END {CR001_GetMarkName};

 PRIVATE PROCEDURE CR001_GetStateNbr(Heap: STRING[]): STRING[];
 BEGIN
  FillParams(Heap);
  IF L_Car._StandOnCarLog(v_BoxNbr, ConvertToDate(v_Date)) THEN
   RETURN CarLog.StateNbr;
  ELSE
   RETURN " .";
  END;
 END {CR001_GetStateNbr};

 PRIVATE PROCEDURE GetDtlRCDType(_BoxNbr: LIKE(Car.BoxNbr); D: DATE): D_CarTb.DtlRCDType;
 BEGIN
(*
  D_CarTb.CarTb_Init(_BoxNbr, D);
*)
  RETURN E_Way.DtlRCarDay(_BoxNbr, D);
 END {GetDtlRCDType};

 PRIVATE PROCEDURE CR001_GetDays(Heap: STRING[]): NUMERIC[0];
  VAR
   D    : DATE;
   Count: NUMERIC[0];
   Val  : L_OLE.tKeyValue;
 BEGIN
  FillParams(Heap);
  SETZERO(Count);
  IF PrepareBasis() # pb_NoSuchBoxNbr THEN
   D:=L_DatTim.MonthBeg(ConvertToDate(v_Month));
   WHILE (D <= L_DatTim.MonthEnd(ConvertToDate(v_Month))) &
         (D <= IntvlE) DO
    Val:=GetDtlRCDType(v_BoxNbr, D);
    IF L_OLE.Check(Val, v_DayType) THEN
     INC(Count);
    END;
    INC(D);
   END;
  END;
  RETURN Count;
 END {CR001_GetDays};

 PRIVATE PROCEDURE CR001_WhyOutage(Heap: STRING[]): STRING[];
  VAR
   D  : DATE;
   Val: L_OLE.tKeyValue;
 BEGIN
  FillParams(Heap);
  IF PrepareBasis() # pb_NoSuchBoxNbr THEN
   D  :=ConvertToDate(v_Date);
   Val:=GetDtlRCDType(v_BoxNbr, D);
   IF D_CarTb.CarTb_RCarDay(Val) # D_CarTb.rcd_Line THEN
    RETURN D_CarTb.CarTb_DtlRCarDayName(Val);
   END;
  END;
  RETURN "";
 END {CR001_WhyOutage};

 PRIVATE PROCEDURE oleInit(_IntvlB, _IntvlE: DATE);
 BEGIN
  IntvlB:=_IntvlB;
  IntvlE:=_IntvlE;
  SETEMPTY(CurBoxNbr);
  D_CarTb.Create_CarTb();
  L_AFM.AF_CreateTemp("CarTb", "CarTb");
 END {oleInit};

 PRIVATE PROCEDURE oleInit_wRebuild(_IntvlB, _IntvlE: DATE);
 BEGIN
  oleInit(_IntvlB, _IntvlE);
 END {oleInit_wRebuild};

 PRIVATE PROCEDURE oleDeInit();
 BEGIN
  TRY
   DetachFILE(CarTb, Purge);
  EXCEPT
  ELSE
  END;
 END {oleDeInit};

BEGIN
 (* nothing *)
END.
