(*
%Copyright   (c) Polak Computer System
%Author      28.11.2002 12:35:58 POLAK\LDA
%Purpose       
%Type        report
%Specific    AP
%Modified    27.03.2014 14:59:46 POLAK\GAV
%Environment
*)

 MODULE X_RWayS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_OwnData, L_General, L_AFM, L_DatTim, L_Car, L_Str, L_Way,
        L_bp, L_Basis, FIO, L_Staff, L_Env;

 CONST
  rt_RWJPro    = 0;
  rt_RWaySAmnt = 1;
  rt_RWJQua    = 2;

 VAR
  RepName: STRING[];
  RepType: SCAL[100];

(*
$P{ RWJPro_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
?, L, "D.N.y"
?, L, "D.N.y"
@
########################################################################################## ########## #####
=#####=====================================================================================================
|#########################################################################################################|
|                                    ਮ  ##########  ##########                                  |
}
*)

(*
$P{ RWJPro_SubTitle:
Tmp.TKind, L, ""
TKind.Name, L, ""
@
|---------------------------------------------------------------------------------------------------------|
| ॢ ## ###############################################                                         |
|---------------------------------------------------------------------------------------------------------|
|     |      |⥫              |             |. . |筨 |      稭|
|-------|----------|----------------------|----------------------|---------------|---------|--------------|
}
*)

(*
$P{ RWJPro_Line:
Tmp.RWayS, L, ""
Tmp.Date, L, "D.N.y"
Tmp.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Tmp.GuTSN, L, ""
GetManName(Tmp.GuTSN), L, ""
Tmp.BoxNbr, L, ""
CarLog.StateNbr, L, ""
Tmp.Source, L, L_Way.rwjpSrc_Pool
Tmp.Value, R, ",2."
@
|#######|##########|##### ################|##### ################|#### ##########|#########|##############|
}
*)

(*
$P{ RWJPro_SubBot:
?, R, ",2."
@
|------------------------------------------------------------------------------------------|--------------|
|⮣   ॢ                                                                   |##############|
}
*)

(*
$P{ RWJPro_Bot:
?, R, ",2."
@
|------------------------------------------------------------------------------------------|--------------|
|⮣  ।                                                                      |##############|
=(c) Polak=================================================================================================
}
*)

(*
$P{ RWJQua_SubTitle:
Tmp.TKind, L, ""
TKind.Name, L, ""
@
|---------------------------------------------------------------------------------------------------------|
| ॢ ## ###############################################                                         |
|---------------------------------------------------------------------------------------------------------|
|     |      |⥫              |             |. .           |         |
|-------|----------|----------------------|----------------------|-------------------------|--------------|
}
*)

(*
$P{ RWJQua_Line:
Tmp.RWayS, L, ""
Tmp.Date, L, "D.N.y"
Tmp.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Tmp.GuTSN, L, ""
GetManName(Tmp.GuTSN), L, ""
Tmp.BoxNbr, L, ""
CarLog.StateNbr, L, ""
Tmp.Value, R, ",2."
@
|#######|##########|##### ################|##### ################|#### ##########          |##############|
}
*)

(*
$P{ RWaySAmnt_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
@
######################################### ########## ######
=#####=====================================================
|        ਮ  ##########  ##########   |
|---------------------------------------------------------|
|    |   01|   02|   03|   04|   05|   06| | ᥣ|
|--------|-----|-----|-----|-----|-----|-----|-----|------|
}
*)

(*
$P{ RWaySAmnt_Line:
RWayS.Date, L, "D.N.Y"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
@
|########|#####|#####|#####|#####|#####|#####|#####|######|
}
*)

(*
$P{ RWaySAmnt_Bot:
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
@
|--------|-----|-----|-----|-----|-----|-----|-----|------|
|⮣   |#####|#####|#####|#####|#####|#####|#####|######|
=() Polak ================================================
}
*)

 PRIVATE PROCEDURE GetManName(_TSN: LIKE(Staff.TSN)): STRING[];
 BEGIN
  IF ~!_TSN THEN
   SEARCH(Staff, TSN, , _TSN);
   CONFORM(Staff, Man);
   RETURN L_Str.ShortName(Man.Name);
  END;
  RETURN "";
 END {GetManName};

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "६ 䠩", "");
  CreateFIELD(Tmp, TKind,  LIKE(TKind.TKind),   "", "", "", " ॢ", "");
  CreateFIELD(Tmp, RWayS,  LIKE(RWayS.RWayS),   "", "", "", "", "");
  CreateFIELD(Tmp, Date,   DATE,                "", "", "", " ", "");
  CreateFIELD(Tmp, TSN,    LIKE(Staff.TSN),     "", "", "", "", "");
  CreateFIELD(Tmp, GuTSN,  LIKE(Staff.TSN),     "", "", "", " ", "");
  CreateFIELD(Tmp, BoxNbr, LIKE(CarLog.BoxNbr), "", "", "", "ࠦ", "");
  CreateFIELD(Tmp, Value,  LIKE(RWayJP.Value),  "", "0", "", "祭", "");
  CreateFIELD(Tmp, Source, LIKE(RWayJP.Source), "", "0", "", "筨", "");

  CreateINDEX(Tmp, TKind, UNIQUE, "", "", TKind, RWayS, Date, TSN, GuTSN, BoxNbr, Source);

  SetVersionOfFILE(Tmp, 0);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE PrintRep(BPer, EPer: DATE);
  VAR
   Total,
   SubTotal: NUMERIC[2];
 BEGIN
  Total:=0;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF RepType = rt_RWJPro THEN
   MAKEPART(R, RWJPro_Top, "⥫  "+RWJPro.RWJPro + " "+RWJPro.Name, BPer, EPer);
  ELSE
   MAKEPART(R, RWJPro_Top, " ⢠ "+Quality.Quality+" "+Quality.Name, BPer, EPer);
  END;
  SELECT(Tmp, TKind);
  WHILE OCCURE(Tmp) DO
   PROMPT(" " + Tmp.RWayS);
   CHANGESEL(Tmp, TKind, , Tmp.TKind);
   SubTotal:=0;
   SEARCH(TKind, TKind, , Tmp.TKind);
   IF RepType = rt_RWJPro THEN
    MAKEPART(R, RWJPro_SubTitle);
   ELSE
    MAKEPART(R, RWJQua_SubTitle);
   END;
   WHILE OCCURE(Tmp) DO
    L_Car.StandOnCarLog(Tmp.BoxNbr, Tmp.Date);
    SEARCH(Staff, TSN, , Tmp.TSN);
    CONFORM(Staff, Man);
    IF    RepType = rt_RWJPro THEN
     MAKEPART(R, RWJPro_Line);
    ELSE
     MAKEPART(R, RWJQua_Line);
    END;
    INC(SubTotal, Tmp.Value);
    NEXT(Tmp);
   END; (* WHILE OCCURE(Tmp) ... *)
   MAKEPART(R, RWJPro_SubBot, SubTotal);
   LAST(Tmp);
   CHANGESEL(Tmp, TKind);
   NEXT(Tmp);
   INC(Total, SubTotal);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, RWJPro_Bot, Total);
 END {PrintRep};

 PRIVATE PROCEDURE AddTmp(_Source: LIKE(RWayJP.Source);
                  _Value: LIKE(RWayJP.Value));
  VAR
   _GuTSN: LIKE(Staff.TSN);
 BEGIN
  CONFORM(RWayJ, SEJobs);
  CONFORM(SEJobs, Route);
  SETEMPTY(_GuTSN);
  IF L_Way._IsWith(L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT), L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT), L_Way.wlmwho_Guard) THEN
   _GuTSN:=WayLMen.TSN;
  END;
  ADD(Tmp, TKind, , L_Way.GetRouteTKind(RWayS.Date, 1), RWayS.RWayS, RWayS.Date, RWayS.TSN, _GuTSN,
                    RWayS.BoxNbr, _Source, Tmp.Value, _Value);
 END {AddTmp};

 PRIVATE PROCEDURE MakeIndex_RWJPro();
 BEGIN
  SELECT(RWayJP, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayJP) DO
   IF RWayJP.RWJPro = RWJPro.RWJPro THEN
    SEARCH(RWayJ, RWayS, , RWayJP.RWayS, RWayJP.Day, RWayJP.StartT);
    AddTmp(RWayJP.Source, RWayJP.Value);
   END;
   NEXT(RWayJP);
  END; (* WHILE OCCURE(RWayJP) ... *)
 END {MakeIndex_RWJPro};

 PRIVATE PROCEDURE MakeIndex_Quality();
 BEGIN
  SELECT(RWayJ, RWayS, , RWayS.RWayS);
  WHILE OCCURE(RWayJ) DO
   IF RWayJ.Quality = Quality.Quality THEN
    AddTmp(L_General.EMPTY_NUMBER(), RWayJ.Fact);
   END;
   NEXT(RWayJ);
  END; (* WHILE OCCURE(RWayJ) ... *)
 END {MakeIndex_Quality};

 PRIVATE PROCEDURE mr_UseRWJPro_byPer(BPer, EPer: DATE);
 BEGIN
  Create_Tmp();
  SELECT(RWayS, Date);
  SRCINSEL(RWayS, GE, , BPer);
  WHILE OCCURE(RWayS) & (RWayS.Date <= EPer) DO
   PROMPT(RWayS.RWayS + " " + L_DatTim.DateStr(RWayS.Date));
   IF    RepType = rt_RWJPro THEN
    MakeIndex_RWJPro();
   ELSIF RepType = rt_RWJQua THEN
    MakeIndex_Quality();
   ELSE
    L_General.BadMode();
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  PrintRep(BPer, EPer);
  L_AFM.AF_PurgeTemp("Tmp");
 END {mr_UseRWJPro_byPer};

 PRIVATE PROCEDURE mr_RWaySAmnt_byPer(BPer, EPer: DATE);
  VAR
   Amnt,
   Total: NUMERIC[0][7];
 BEGIN

  SETZERO(Total);
  RepName:="TP003";
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, RWaySAmnt_Top, BPer, EPer);
  SELECT(RWayS, Date);
  SRCINSEL(RWayS, GE, , BPer);
  WHILE OCCURE(RWayS) & (RWayS.Date <= EPer) DO
   SETZERO(Amnt);
   CHANGESEL(RWayS, Date, , RWayS.Date);
   WHILE OCCURE(RWayS) DO
    PROMPT(RWayS.RWayS + " " + L_DatTim.DateStr(RWayS.Date));
    L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
    IF (CarLog.Column = 00) |
       (CarLog.Column > 06) THEN
     INC(Amnt[0]);
    ELSE
     INC(Amnt[CarLog.Column]);
    END;
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
   LAST(RWayS);
   MAKEPART(R, RWaySAmnt_Line, Amnt[1], Amnt[2], Amnt[3],
                               Amnt[4], Amnt[5], Amnt[6], Amnt[0],
                               Amnt[1] + Amnt[2] + Amnt[3] +
                               Amnt[4] + Amnt[5] + Amnt[6] + Amnt[0]);
   INC(Total[0], Amnt[0]);
   INC(Total[1], Amnt[1]);
   INC(Total[2], Amnt[2]);
   INC(Total[3], Amnt[3]);
   INC(Total[4], Amnt[4]);
   INC(Total[5], Amnt[5]);
   INC(Total[6], Amnt[6]);
   CHANGESEL(RWayS, Date);
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  MAKEPART(R, RWaySAmnt_Bot, Total[1], Total[2], Total[3],
                             Total[4], Total[5], Total[6], Total[0],
                             Total[0] + Total[1] + Total[2] +
                             Total[3] + Total[4] + Total[5] + Total[6]);
 END {mr_RWaySAmnt_byPer};

 PUBLIC PROCEDURE CRWJP();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(RWJPro);
  RepType:=rt_RWJPro;
  RepName:="CRWJP";
  mr_UseRWJPro_byPer(Memo.ud_fr(), Memo.ud_ut());
  L_General.SurveyLastReport();
 END {CRWJP};

 PUBLIC PROCEDURE CQual();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(Quality);
  RepType:=rt_RWJQua;
  RepName:="CQual";
  mr_UseRWJPro_byPer(Memo.ud_fr(), Memo.ud_ut());
  L_General.SurveyLastReport();
 END {CQual};

 PUBLIC PROCEDURE TP003();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepType:=rt_RWaySAmnt;
  mr_RWaySAmnt_byPer(Memo.ud_fr(), Memo.ud_ut());
  L_General.SurveyLastReport();
 END {TP003};

 PRIVATE PROCEDURE T9050_MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ॢ");
  L_Basis.wb_WrInQM(F, "ॢ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "፮");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "㯯ப");
  L_Basis.wb_WrInQM(F, "㯯ப");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥫쒠");
  L_Basis.wb_WrInQM(F, "⥫씈");
  L_Basis.wb_WrInQM(F, "⥫쑥");
  L_Basis.wb_WrInQM(F, "⥫쑥");
  L_Basis.wb_WrInQM(F, "1");
  L_Basis.wb_WrInQM(F, "1");
  L_Basis.wb_WrInQM(F, "1");
  L_Basis.wb_WrInQM(F, "1");
  L_Basis.wb_WrInQM(F, "2");
  L_Basis.wb_WrInQM(F, "2");
  L_Basis.wb_WrInQM(F, "2");
  L_Basis.wb_WrInQM(F, "2");
  L_Basis.wb_WrInQM(F, "⥫");
  L_Basis.wb_WrInQM(F, "⥫");
  L_Basis.wb_WrInQM(F, "⥫쇭祭");
  L_Basis.wb_TermLine(F);
 END {T9050_MakeTop};

 PRIVATE PROCEDURE T9050_MakeTSN(F: STRING[]; curTSN: LIKE(Staff.TSN));
 BEGIN
  IF ~!curTSN & L_Env.RealTSN(curTSN) THEN
   SEARCH(Staff, TSN, , curTSN);
   CONFORM(Staff, Man);
   L_Staff.PosToStaffLog(curTSN, RWayS.Date, 1);
   CONFORM(StaffLog, Sort);
   L_Basis.wb_WrScl(F, Staff.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
 END {T9050_MakeTSN};

 PRIVATE PROCEDURE T9050_MakeLine(F: STRING[]; Grd1, Grd2: LIKE(Staff.TSN));
 BEGIN
  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrScl(F, Car.BoxNbr);
  L_Basis.wb_WrStr(F, Car.StateNbr);
  L_Basis.wb_WrScl(F, Mark.Mark);
  L_Basis.wb_WrStr(F, Mark.Name);
  L_Basis.wb_WrScl(F, MarkG.MarkG);
  L_Basis.wb_WrStr(F, MarkG.Name);
  L_Basis.wb_WrScl(F, RWayS.RWayS);
  L_Basis.wb_WrDat(F, RWayS.Date);
  T9050_MakeTSN(F, RWayS.TSN);
  T9050_MakeTSN(F, Grd1);
  T9050_MakeTSN(F, Grd2);
  L_Basis.wb_WrScl(F, RWayJP.RWJPro);
  L_Basis.wb_WrStr(F, RWJPro.Name);
  L_Basis.wb_WrNum(F, RWayJP.Value, RWJPro.Format);
  L_Basis.wb_TermLine(F);
 END {T9050_MakeLine};

 PRIVATE PROCEDURE T9050_GetWLM(Who: LIKE(WayLMen.Who); Number: NUMERIC[0]): LIKE(Staff.TSN);
  VAR
   Result: LIKE(Staff.TSN);
 BEGIN
  SETEMPTY(Result);
  SELECT(WayLMen, RWS_TSN, , RWayJ.RWayS, Number, Who);
  WHILE OCCURE(WayLMen) DO
   IF L_Way._TimeInt(L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT),
                     L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT),
                     L_Way.FullBegTime(WayLMen.Day, WayLMen.StartT),
                     L_Way.FullEndTime(WayLMen.Day, WayLMen.StartT, WayLMen.StopT)) > 0 THEN
    Result:=WayLMen.TSN;
    LAST(WayLMen);
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
  RETURN Result;
 END {T9050_GetWLM};

 PUBLIC PROCEDURE T9050();
  CONST
   bpId = "T9050";
   VAR
    Grd1,
    Grd2 : LIKE(Staff.TSN);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " ⥫  ", L_bp.t_Basis, L_General.tc_inIntvl);
  L_Way.CheckTaxed(Memo.ud_fr(), Memo.ud_ut());
  FIO.Open(F, L_General.NameConnection(bpId), "rep", Create);
  T9050_MakeTop("F");
  SELECT(RWayS, Date);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   PROMPT(L_DatTim.DateStr(RWayS.Date) + " " + RWayS.RWayS);
   IF SELECT(RWayJP, RWayS, RWayS.RWayS) THEN
    CONFORM(RWayS, Car);
    L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
    SEARCH(MarkG, MarkG, , L_Way.GetMarkG(Mark.Mark, L_Way.mgt_TEP));
    WHILE OCCURE(RWayJP) DO
     NARROWSEL(RWayJP, Day, StartT);
     CONFORM(RWayJP, RWayJ);
     CONFORM(RWayJ, SEJobs);
     CONFORM(SEJobs, Route);
     CONFORM(Route, TKind);
     Grd1:=T9050_GetWLM(L_Way.wlmwho_Guard, 1);
     Grd2:=T9050_GetWLM(L_Way.wlmwho_Guard, 2);
     WHILE OCCURE(RWayJP) DO
      CONFORM(RWayJP, RWJPro);
      T9050_MakeLine("F", Grd1, Grd2);
      NEXT(RWayJP);
     END; (* WHILE OCCURE(File) *)
     NEXTINEXTENDEDSEL(RWayJP, Day, StartT);
    END; (* WHILE OCCURE(RWayJP) *)
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
  FIO.Close(F);
  L_bp.End();
 END {T9050};

END.
