(*
%Copyright   (c) Polak IT
%Author      05.04.2005 18:24:21 POLAK\LDA
%Purpose
%Type        operation
%Specific    AP
%Modified    14.04.2014 12:34:41 POLAK\GAV
%Environment
*)

 MODULE BegTRS;

 IMPORT L_BegRWS, L_General, L_XDoc, L_BarCode, L_Way, L_Env, L_Staff, L_Print, P_Man,
        L_DatTim, L_StdFrm, L_Str, L_Events, L_TRS, L_Stock, L_Car, L_WDO, Str,
        DBD, L_lsStore, P_OwnData, Math, P_Firm, L_APtm, L_Prop, L_TRSP, L_CUC,
        L_Timer, L_RT, L_AFM;

 CONST
  sb_Ser  = 0;
  sb_Num  = 1;
  TimerId = "BegTRS_ChkLated";

  fn_EmptyInventory = "v_EmptyInventory";
  es_LineAmount = 10;

 PRIVATE PERMANENT VAR
  TckRcSToPrint,
  TckRcSToAccept,
  TckRcSToPrintRelated : LIKE(TckRcS.TckRcS);

  v_TSN          : LIKE(Staff.TSN);
  v_ManName      : STRING[];
  v_AsWho        : LIKE(TckRcS.AsWho);
  v_AsWhoCnd     : LIKE(TckRcS.AsWhoCnd);

  v_Storage      : LIKE(Storage.Storage);
  v_StorageName  : STRING[];
  v_RWayS        : LIKE(TckRcS.asRWayS);
  v_BoxNbr       : LIKE(Car.BoxNbr)[3];
  v_MarkName     : STRING[][3];
  v_RequiredKKM,
  v_RequiredVLD,
  v_RequiredBCT  : SCAL[2];

  v_TRDLNbr     : LIKE(TckRcDL.TRDLNbr)[L_TRS.trdl_Amount];
  v_TckKind     : LIKE(TckKind.TckKind)[L_TRS.trdl_Amount];
  v_TckKind_Name: LIKE(TckKind.Name)   [L_TRS.trdl_Amount];
  v_Series      : L_TRS.tTckSeries     [L_TRS.trdl_Amount];
  v_RestNbr     : L_TRS.tTckNumber     [L_TRS.trdl_Amount];
  v_Psg         : L_TRS.tTckPsg        [L_TRS.trdl_Amount];
  v_CUCopy      : LIKE(TckRcDL.CUCopy) [L_TRS.trdl_Amount];
  v_Message     : STRING[];

  v_TB_TRDLNbr     : LIKE(TckRcDL.TRDLNbr)[L_TRS.trdl_Amount];
  v_TB_TckKind     : LIKE(TckKind.TckKind)[L_TRS.trdl_Amount];
  v_TB_TckKind_Name: LIKE(TckKind.Name)   [L_TRS.trdl_Amount];
  v_TB_Series      : L_TRS.tTckSeries     [L_TRS.trdl_Amount];
  v_TB_RAmount     : L_TRS.tTckNumber     [L_TRS.trdl_Amount];
  v_TB_RPsg        : L_TRS.tTckPsg        [L_TRS.trdl_Amount];
  v_TB_CUCopy      : LIKE(TckRcDL.CUCopy) [L_TRS.trdl_Amount];

  v_ES_TckKind     : LIKE(TckKind.TckKind)[L_TRS.trdl_Amount];
  v_ES_TckKind_Name: LIKE(TckKind.Name)   [L_TRS.trdl_Amount];
  v_ES_Amount      : L_TRS.tTckNumber     [L_TRS.trdl_Amount];
  v_ES_Psg         : L_TRS.tTckPsg        [L_TRS.trdl_Amount];

  v_EmptyInventory : SCAL[2];

 PRIVATE PROCEDURE OnDate(): DATE;
  VAR
   Result: DATE;
 BEGIN
  Result:=L_BegRWS.DspSysDate();
  IF L_Way.E_TckRcLevel(Result) < L_TRS.il_Full THEN
   Result:=L_TRS.GetTRCOnDate();
  END;
  RETURN Result;
 END {OnDate};

 PRIVATE PROCEDURE PrintReceipt(Out: SCAL[2]);
  VAR
   Pt08,
   Pt09,
   Pt11B          : TEXTSTYLE;
   trcPrt         : PRINTJOB;
   mn_To,
   mn_From        : STRING[];
   To_Sex         : LIKE(Man.Sex);
 BEGIN
  TRY
   L_TRS.AccessTckRcS();
   CONFORM(TckRcS, Staff);
   CONFORM(Staff, Man);
   IF Out THEN
    L_General.Assert(TckRcS.Status >= L_TRS.trsStat_Given, "  뤠");
    mn_To :=L_Str.ShortName(Man.Name);
    To_Sex:=Man.Sex;
    SETEMPTY(mn_From);
   ELSE
    L_General.Assert(TckRcS.Status >= L_TRS.trsStat_Taken, "  ਭ");
    SAVE(Man);
    SEARCH(Man, Man, , P_Man.curUSER2Man());
    mn_To  :=L_Str.ShortName(Man.Name);
    To_Sex :=Man.Sex;
    RESTORE(Man);
    mn_From:=L_Str.ShortName(Man.Name);
   END;

   Pt08 :=L_Print.ts_Create(08, "Lucida Console");
   IF L_General.GetOSPlatform() = L_General.osp_WinNT THEN
    Pt08.CharExtra:=-0.2;
   ELSE
    Pt08.CharExtra:=-0.3;
   END;
   Pt09 :=L_Print.ts_Resize(Pt08, 09);
   Pt11B:=L_Print.ts_Resize(Pt08, 11);
   Pt11B.Font.Weight:=FONT.Weight_SemiBold;

   trcPrt:=L_Print.pj_Create_ChequeBand("ᯨ᪠");
   trcPrt.StartPage();
   L_Print.TypeS(trcPrt,  0,  0, P_Firm.FP_FirmShortName(L_Staff.GetFirmOfStaff(), SYSDATE()), Pt08);
   L_Print.TypeS(trcPrt, 38,  3, L_DatTim.DateTimeStr(SYSDATE(), SYSTIME()), Pt08);
   L_Print.TypeS(trcPrt,  0, 13, " " + L_Str.PoolItem(" | 祭", Out),   Pt11B);
   L_Print.TypeS(trcPrt,  0, 23, ", " + mn_To + ",",   Pt11B);
   IF Out THEN
    L_Print.TypeS(trcPrt, 0, 28, L_Str.PoolItem(L_Way.trs_Pool, TckRcS.AsWho) + ", ⠡.  " + TckRcS.TSN, Pt11B);
    L_Print.TypeS(trcPrt, 0, 33, "稫" + L_Str.AnyItem("|",  "|", To_Sex)+ ":", Pt11B);
   ELSE
    L_Print.TypeS(trcPrt, 0, 28, "ਭ" + L_Str.AnyItem("|",  "|", To_Sex) + "  ࠡ⭨", Pt11B);
    L_Print.TypeS(trcPrt, 0, 33, "(" + TckRcS.TSN + " " + mn_From + "):", Pt11B);
   END;
   L_Print.TypeS(trcPrt, 0, 41, " " + TckRcS.TckRcS,   Pt11B);
   CONFORM(TckRcS, Storage);
   L_Print.TypeS(trcPrt, 0, 46, " " + TckRcS.Storage + " " + Storage.Name,  Pt11B);

   L_Print.TypeS(trcPrt, 0, 51, L_TRSP.E_PrintSubsidiaryMoneyInReceipt(TckRcS.Date), Pt11B);

   L_Print.TypeS(trcPrt, 0,  68, "______________ " + mn_To,   Pt11B);
   trcPrt.EndPage();
   trcPrt.Close();
  EXCEPT
  ON Exc: Exc_Root DO
   L_StdFrm.RedInform(Exc.MsgOriginalText);
  END;
 END {PrintReceipt};

 PRIVATE PROCEDURE CurTckRcS_XDocJrn_Mark(_Action: LIKE(XDocJrn.Action));
 BEGIN
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, TckRcS.TckRcS, _Action);
 END {CurTckRcS_XDocJrn_Mark};

 PRIVATE PROCEDURE CurTckRcS_XDocJrn_Start(_Action: LIKE(XDocJrn.Action));
 BEGIN
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, TckRcS.TckRcS, _Action);
 END {CurTckRcS_XDocJrn_Start};

 PRIVATE PROCEDURE CurTckRcS_XDocJrn_Stop();
 BEGIN
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, TckRcS.TckRcS);
 END {CurTckRcS_XDocJrn_Stop};

 PUBLIC PROCEDURE VerifyTckRcS();
 BEGIN
  L_XDoc.VerifyRequiredTypeXDocIdByBC("䨪 :  ⭮-⭮ ", L_XDoc.xdt_TckRcS, 0);
 END {VerifyTckRcS};

 PRIVATE PROCEDURE E_BegTRS_AcceptableWho(_Who: L_Way.tRWSWho): SCAL[2];
  VAR
   default: SCAL[2];
   Local  : PROC;
 BEGIN
  default:=(_Who = L_Way.rwswho_Guard) | (_Who = L_Way.rwswho_Chopper);
  Local:=PROCREF(E_Way.BegTRS_AcceptableWho);
  IF ~!Local THEN
   RETURN Local(default);
  ELSE
   RETURN default;
  END;
 END {E_BegTRS_AcceptableWho};

 PRIVATE PROCEDURE ConvertWayLMenWho(_Who: L_Way.tWLMWho): L_Way.tRWSWho;
 BEGIN
  IF    _Who = L_Way.wlmwho_Guard THEN
   RETURN L_Way.rwswho_Guard;
  ELSIF _Who = L_Way.wlmwho_Chopper THEN
   RETURN L_Way.rwswho_Chopper;
  ELSIF _Who = L_Way.wlmwho_Driver THEN
   RETURN L_Way.rwswho_Driver;
  ELSE
   L_General.EMPTY_NUMBER();
  END;
 END {ConvertWayLMenWho};

 PRIVATE PROCEDURE SetNearestRWayS(D: DATE; VAR minPeriod: FLOAT; VAR _RWayS: LIKE(RWayS.RWayS));
  VAR
   curPeriod: FLOAT;
 BEGIN
  IF    L_Way.E_TckRcLevel(D) = L_TRS.il_offLine THEN
   _RWayS:=RWayS.RWayS;
  ELSIF (RWayS.Status = L_Way.rwsStat_Ordered) | (RWayS.Status = L_Way.rwsStat_Given) THEN
   curPeriod:=Math.Abs(L_DatTim.GetSysVARIANTDATE()-L_DatTim.GetVARIANTDATE(RWayS.Date, RWayS.StartTim, 00));
   IF !minPeriod | (curPeriod <= minPeriod) THEN
    minPeriod:=curPeriod;
    _RWayS   :=RWayS.RWayS;
   END;
  END;
 END {SetNearestRWayS};

 PRIVATE PROCEDURE asRWayS_Add(D: DATE; VAR _RWayS: LIKE(TckRcS.asRWayS); VAR i: NUMERIC[0]);
 BEGIN
  IF RWayS.RWayS # _RWayS[0] THEN
   IF (L_Way.E_TckRcLevel(D) = L_TRS.il_offLine) |
      (RWayS.Status = L_Way.rwsStat_Ordered) |
      (RWayS.Status = L_Way.rwsStat_Given) THEN
    _RWayS[i]:=RWayS.RWayS;
    INC(i);
   END;
  END;
 END {asRWayS_Add};

 PRIVATE PROCEDURE GetRWayS(_TSN: LIKE(Staff.TSN); D: DATE; VAR _RWayS: LIKE(TckRcS.asRWayS));
  VAR
   minPeriod: FLOAT;
   i        : NUMERIC[0];
 BEGIN
  SETEMPTY(_RWayS, minPeriod);
  IF    SELECT(RWayS, TSN, _TSN, D) THEN
   WHILE OCCURE(RWayS) DO
    SetNearestRWayS(D, minPeriod, _RWayS[0]);
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
   FIRST(RWayS);
   i:=~!_RWayS[0];
   WHILE OCCURE(RWayS) & (i <= HIGH(_RWayS)) DO
    asRWayS_Add(D, _RWayS, i);
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
  ELSIF SELECT(WayLMen, TSN, _TSN, D) THEN
   WHILE OCCURE(WayLMen) DO
    CONFORM(WayLMen, RWayS);
    SetNearestRWayS(D, minPeriod, _RWayS[0]);
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
   FIRST(WayLMen);
   i:=~!_RWayS[0];
   WHILE OCCURE(WayLMen) & (i <= HIGH(_RWayS))  DO
    CONFORM(WayLMen, RWayS);
    asRWayS_Add(D, _RWayS, i);
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
  END;
 END {GetRWayS};

 PRIVATE PROCEDURE RePrint_TckRcS(inWriteOuting: SCAL[2]);
 BEGIN
  L_TRS.CheckAcceptableTckRcSStatus(L_XDoc.action_Reprint, L_TRS.trsStat_Given);
  INC(TckRcS.CopyCnt);
  REPLACE(TckRcS);
  TckRcSToPrint:=TckRcS.TckRcS;
  IF inWriteOuting THEN
   CurTckRcS_XDocJrn_Mark(L_XDoc.action_PrintAdditionalDocument);
  END;
  CurTckRcS_XDocJrn_Mark(L_XDoc.action_Reprint);
  IF inWriteOuting THEN
   LIKEMENU(RunProg, "BegTRS 080");
  ELSE
   LIKEMENU(RunProg, "BegTRS 081");
  END;
 END {RePrint_TckRcS};

 PRIVATE PROCEDURE wo_MakeTckRcDLForDeviceMovement(Required: SCAL[2]; trgType: L_TRS.tTckKindType);
 BEGIN
  IF Required THEN
   L_TRS.bc_PositionOnDevice("뤠 ", trgType, 1);
   L_TRS.InsTckRcDLForDeviceMovement(trgType, L_TRS.trdt_Laying, L_General.EMPTY_NUMBER(),
                                     TckRcS.TckRcS, TckRcS.Storage,
                                     CUCopy.CUCopy, L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER());
  END;
 END {wo_MakeTckRcDLForDeviceMovement};

 PRIVATE PROCEDURE WriteOut();
 BEGIN
(*
  L_General.CallUs(SELECT(TckRcS, sTSN, L_Way.rwsStat_Ordered, v_TSN, OnDate()));
*)
  L_General.CallUs((TckRcS.TSN = v_TSN) & (TckRcS.Status = L_Way.rwsStat_Ordered));
  TckRcS.Status:=L_TRS.trsStat_Given;
  REPLACE(TckRcS);
  CurTckRcS_XDocJrn_Start(L_XDoc.action_begDst);
  L_TRS.bc_PositionOnTckBag("뤠 ");
  L_General.Assert(TckRcS.Storage = Storage.Storage, "  㬪!");

  IF v_RequiredKKM | v_RequiredVLD | v_RequiredBCT THEN
   L_TRS.Insert_TckRcD(L_TRS.trdt_Laying, TckRcS.TckRcS, TckRcS.Storage);
   wo_MakeTckRcDLForDeviceMovement(v_RequiredKKM, L_TRS.tkt_KKMActivities);
   wo_MakeTckRcDLForDeviceMovement(v_RequiredVLD, L_TRS.tkt_VLDActivities);
   wo_MakeTckRcDLForDeviceMovement(v_RequiredBCT, L_TRS.tkt_BankCardTerminal);
  END;
  L_TRS.TckRcS_AcceptSummary(L_TRS.ass_Begining);
  L_General.Assert(TckRcS.Date = OnDate(), "! ந諠 ᬥ ᯥ᪨ ⮪!|" +
                                           "室  (!) 믮 楤 뤠   ࠡ⭨ " + v_TSN);
  CurTckRcS_XDocJrn_Stop();
  RePrint_TckRcS(1);
 END {WriteOut};

 PRIVATE PROCEDURE PrintTckRcSRelatedDocs(_TckRcS: LIKE(TckRcS.TckRcS));
 BEGIN
  SELECT(TckRcD, TckRcS, , _TckRcS);
  WHILE OCCURE(TckRcD) DO
   IF (TckRcD.Status = L_TRS.trdStat_Passed) &
      ~L_XDoc.XDocIsPrinted(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD) THEN
    CALL(TckRcD.TckRcD_RePrint(1));
    CALL(TckRcD.TckRcD_Print(0));
   END;
   NEXT(TckRcD);
  END; (* WHILE OCCURE(TckRcD) ... *)
  SELECT(TckRcC, TckRcS, , _TckRcS);
  WHILE OCCURE(TckRcC) DO
   IF (TckRcC.Status = L_TRS.trcStat_Passed) &
      ~L_XDoc.XDocIsPrinted(L_XDoc.xdt_TckRcC, L_XDoc.EmptyXDocKind, TckRcC.TckRcC) THEN
    CALL(TckRcC, L_Events.md_StreamRePrint);
    CALL(TckRcC, L_Events.md_SinglePrint);
   END;
   NEXT(TckRcC);
  END; (* WHILE OCCURE(TckRcC) ... *)
 END {PrintTckRcSRelatedDocs};

 PRIVATE PROCEDURE Print(inWriteOuting: SCAL[2]);
 BEGIN
  L_General.Assert(SEARCH(TckRcS, TckRcS, TckRcSToPrint),
                   "   " + TckRcSToPrint + " ()");
  TRY  [TERM_BY_USER(TERM_BY_USER_IGNORE)]
   SAVE(TckRcS);
   TRY
    RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
    CALL(TRSP, 051);
   EXCEPT
   END;
   RESTORE(TckRcS);
   IF inWriteOuting THEN
    IF Str.Cap(DBD.BaseName()) # "SP" THEN
     PrintReceipt(1);
    END;
    PrintTckRcSRelatedDocs(TckRcS.TckRcS);
   END;
   IF TckRcS.CopyCnt > 1 THEN
    VerifyTckRcS();
   ELSE
    CurTckRcS_XDocJrn_Mark(L_XDoc.action_AutoVerification);
   END;
  EXCEPT
  END;
 END {Print};

 PRIVATE PROCEDURE SetAsWhoCndFieldState(_AsWho: LIKE(TckRcS.AsWho));
  VAR
   Dummy: STRING[];
 BEGIN
  Dummy:=L_TRS.E_TckRcS_AsWhoCnd_GetPool(OnDate(), _AsWho);
  RTI.Get().CurZone.Fields("v_AsWhoCnd").Modifiable:=~!Dummy;
  RTI.Get().CurZone.Fields("v_AsWhoCnd").Format:=Dummy;
 END {SetAsWhoCndFieldState};

 PRIVATE PROCEDURE wo_SetEmptyPermanents();
 BEGIN
  SETEMPTY(v_TSN, v_ManName, v_AsWho, v_AsWhoCnd, v_Storage, v_StorageName,
           v_RWayS, v_BoxNbr, v_MarkName, v_RequiredKKM, v_RequiredVLD, v_RequiredBCT, v_Message);
 END {wo_SetEmptyPermanents};

 PRIVATE PROCEDURE AccessExistingTckRcS(_TSN: LIKE(Staff.TSN); _Storage: LIKE(Storage.Storage); D: DATE): SCAL[2];
 BEGIN
  RETURN L_TRS.PositionOnTckRcS(_TSN, _Storage,                      D, L_Way.rwsStat_Ordered) |
         L_TRS.PositionOnTckRcS(_TSN, _Storage, L_General.EMPTY_DATE(), L_Way.rwsStat_Ordered);
 END {AccessExistingTckRcS};

 PRIVATE PROCEDURE TRSWrOut_v_TSN_OnSuccessfulChange();
  VAR
   l_AsWho        : LIKE(TckRcS.AsWho);
   l_AsWhoCnd     : LIKE(TckRcS.AsWhoCnd);
   l_ManName      : STRING[];
   l_Storage      : LIKE(Storage.Storage);
   l_StorageName  : STRING[];
   l_RWayS        : LIKE(TckRcS.asRWayS);
   l_BoxNbr       : LIKE(Car.BoxNbr)[3];
   l_MarkName     : STRING[][3];
   l_RequiredKKM,
   l_RequiredVLD,
   l_RequiredBCT  : SCAL[2];
   l_Message      : STRING[];
   i              : NUMERIC[0];
 BEGIN
  IF ~!v_TSN THEN
   L_General.Assert(SEARCH(Staff, TSN, v_TSN), "祭    ந");
   L_TRS.CheckStaffAdaptability(v_TSN, OnDate());
   l_Storage:=L_Stock.GetStaffFixedStorage(v_TSN, OnDate(), L_Stock.st_TckBag);
   L_General.Assert(~!l_Storage, " ࠡ⭨  ९ 㬪");
   SETEMPTY(l_RWayS);
   IF AccessExistingTckRcS(v_TSN, l_Storage, OnDate()) THEN
    l_AsWho   :=TckRcS.AsWho;
    l_AsWhoCnd:=TckRcS.AsWhoCnd;
    l_Message :=L_lsStore.Get(TckRcS.Message);
   ELSE
    l_AsWho   :=L_TRS.E_GetDefaultAsWho   (v_TSN, OnDate());
    l_AsWhoCnd:=L_TRS.E_GetDefaultAsWhoCnd(v_TSN, OnDate());
    SETEMPTY(l_Message);
   END;
   GetRWayS(v_TSN, OnDate(), l_RWayS);
   IF !l_RWayS[0] THEN
    L_StdFrm.Choice("  室騩   ࠡ⭨ " + v_TSN + "| " + L_DatTim.DateStr(OnDate()));
   END;
   i:=0;
   WHILE i <= HIGH(l_RWayS) DO
    IF ~!l_RWayS[i] THEN
     SEARCH(RWayS, RWayS, , l_RWayS[i]);
     l_BoxNbr[i]:=RWayS.BoxNbr;
     L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
     l_MarkName[i]:=Mark.Name;
    ELSE
     SETEMPTY(l_BoxNbr[i], l_MarkName[i]);
     l_RequiredKKM:=0;
     l_RequiredVLD:=0;
     l_RequiredBCT:=0;
    END;
    INC(i);
   END;
   l_RequiredKKM:=L_TRS.E_RequiredKKM(v_TSN, l_AsWho, l_RWayS);
   l_RequiredVLD:=L_TRS.E_RequiredVLD(v_TSN, l_AsWho, l_RWayS);
   l_RequiredBCT:=L_TRS.E_RequiredBCT(v_TSN, l_AsWho, l_RWayS);
   CONFORM(Staff, Man);
   l_ManName:=Man.Name;
   SEARCH(Storage, Storage, , l_Storage);
   l_StorageName:=Storage.Name;

   v_AsWho      :=l_AsWho;
   v_AsWhoCnd   :=l_AsWhoCnd;
   v_ManName    :=l_ManName;
   v_Storage    :=l_Storage;
   v_StorageName:=l_StorageName;
   v_RWayS      :=l_RWayS;
   v_BoxNbr     :=l_BoxNbr;
   v_MarkName   :=l_MarkName;
   v_RequiredKKM:=l_RequiredKKM;
   v_RequiredVLD:=l_RequiredVLD;
   v_RequiredBCT:=l_RequiredBCT;
   v_Message    :=l_Message;
  ELSE
   wo_SetEmptyPermanents();
  END;
  SetAsWhoCndFieldState(v_AsWho);
 END {TRSWrOut_v_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE FoundTSN4Man(D: DATE; trgMan: LIKE(Man.Man); VAR Msg: STRING[]): LIKE(Staff.TSN);
  VAR
   Result: LIKE(Staff.TSN);
 BEGIN
  SETEMPTY(Result, Msg);
  TRY [RESTORE_CURSORS(RC_ON)]
   SELECT(Staff, Man, , trgMan);
   LOOP
    IF ~OCCURE(Staff) THEN
     IF !Result THEN
      Msg:="   室 㤮 ஢.";
     END;
     EXIT;
    END;
    IF L_Staff.rInState(D)  THEN
     IF !Result THEN
      Result:=Staff.TSN;
     ELSE
      Msg:="  ᪮쪮 㤮 ஢.";
      SETEMPTY(Result);
      EXIT;
     END;
    END;
    NEXT(Staff);
   END; (* LOOP ... *)
  EXCEPT
  END;
  RETURN Result;
 END {FoundTSN4Man};

 PRIVATE PROCEDURE TRSWrOut_OnBeforeEdit();
  VAR
   Msg: STRING[];
 BEGIN
  wo_SetEmptyPermanents();
  SetAsWhoCndFieldState(v_AsWho);
  RTI.Get().CurZone.Fields("v_AsWho").Format:=L_Way.trs_Pool;

  IF L_TRS.E_CheckStaffByCard() THEN
   IF ~!L_WDO.AccessEnvVar("Authorise") THEN
    CALL(Staff.AuthoriseByProximityCard("䨪 ࠡ⭨  ய"));
    v_TSN:=FoundTSN4Man(OnDate(), Man.Man, Msg);
    IF ~!v_TSN THEN
     TRSWrOut_v_TSN_OnSuccessfulChange();
     FIX_ALTERING();
    ELSE
     L_StdFrm.RedInform(Msg + "||室  㦭 ࠡ⭨ ");
    END;
   END;
   RTI.Get().CurZone.Fields("v_TSN").Modifiable:=!v_TSN;
  END;
 END {TRSWrOut_OnBeforeEdit};

 PRIVATE PROCEDURE TRSWrOut_v_AsWho_OnSuccessfulChange();
 BEGIN
  IF ~!v_TSN THEN
   v_AsWhoCnd:=L_TRS.E_GetDefaultAsWhoCnd(v_TSN, OnDate());
  ELSE
   SETEMPTY(v_AsWhoCnd);
  END;
  SetAsWhoCndFieldState(v_AsWho);
 END {TRSWrOut_v_AsWho_OnSuccessfulChange};

 PRIVATE PROCEDURE TRSWrOut_v_TSN_OnAskPhase1();
 BEGIN
  IF ~!v_TSN THEN
   L_General.Assert(SEARCH(Staff, TSN, v_TSN), "  ⠡ " + v_TSN);
   L_WDO.PositionInOwnerZoneOfActiveField("Staff");
  END;
 END {TRSWrOut_v_TSN_OnAskPhase1};

 PRIVATE PROCEDURE TRSWrOut_v_TSN_OnAskPhase2();
 BEGIN
  v_TSN:=Staff.TSN;
 END {TRSWrOut_v_TSN_OnAskPhase2};

 PRIVATE PROCEDURE TRSWrOut_OnAfterEdit();
  VAR
   Dummy: STRING[];
 BEGIN
  L_TRS.CheckGivenTckRcS(v_TSN);
  IF SELECT(TckRcS, TSN, v_TSN) & SRCINSEL(TckRcS, GT, OnDate()) & ~!TckRcS.Date THEN
   L_General.Error("      (" +
                   TckRcS.TckRcS + "  " + L_DatTim.DateStr(TckRcS.Date) + ")");
  END;
  IF AccessExistingTckRcS(v_TSN, v_Storage, OnDate()) THEN
   IF !TckRcS.Storage THEN
    TckRcS.Storage :=v_Storage;
   END;
   TckRcS.AsWho   :=v_AsWho;
   TckRcS.AsWhoCnd:=v_AsWhoCnd;
   TckRcS.asRWayS :=v_RWayS;
   TckRcS.asBoxNbr:=v_BoxNbr[0];
   TckRcS.Message :=L_lsStore.Replace(TckRcS.Message, v_Message);
   TckRcS.Date    :=OnDate();
   L_TRS.E_SetDefaultTckRcS_Signs(TckRcS.Date);
   REPLACE(TckRcS);
  ELSE
   L_TRS.Insert_TckRcS(OnDate(), v_TSN, v_Storage, v_AsWho, v_AsWhoCnd, v_RWayS, v_BoxNbr[0], v_Message);
   SLEEP(0.01);
  END;
  TRY
   TABLE.Get("RWayS").AccessDataMode   :=adm_SOFT;
   TABLE.Get("StExit").AccessDataMode  :=adm_SOFT;
   TABLE.Get("ExitClss").AccessDataMode:=adm_SOFT;
   TABLE.Get("RWayJ").AccessDataMode   :=adm_SOFT;
   CONFORM(TckRcS, Staff);
   IF TckRcS.AsWho = L_Way.trs_Driver THEN
    IF L_Staff.rInState(TckRcS.Date) & ~SELECT(RWayS, TSN, TckRcS.TSN, TckRcS.Date) THEN
     L_StdFrm.CrucialChoice_FileExplicit("TckRcS",
                                         " ⥫ " + TckRcS.TSN + "  ",
                                         L_APtm.g_TckCashier);
    END;
   END;
   IF ~!TckRcS.asRWayS[0] & ~L_TRS.IsStandOnTckRcSExit() THEN
    L_StdFrm.Choice("   .|,   ᫥ 뤠.");
   END;
   IF L_TRS.E_CheckStaffByCard() & !L_WDO.AccessEnvVar("Authorise") &
      RTI.Get().CurZone.Fields("v_TSN").Modifiable THEN
    IF ~!FoundTSN4Man(TckRcS.Date, Staff.Man, Dummy) THEN
     L_StdFrm.Choice("뤠   ਧ樨");
    END;
   END;
  EXCEPT
  END;
  WriteOut();
 END {TRSWrOut_OnAfterEdit};

 PRIVATE PROCEDURE BuildTckRcC(pId: STRING[]);
 BEGIN
  L_TRS.RunProcess("Ins", "TckRcCE 0 @", pId);
 END {BuildTckRcC};

 PRIVATE PROCEDURE BuildTckRcD(pId: STRING[]);
 BEGIN
  L_TRS.RunProcess("Ins", "TckRcDE 0 @", pId);
 END {BuildTckRcD};

 PRIVATE PROCEDURE Trs1E_OnConformToWindow();
 BEGIN
  L_General.CallUs(SEARCH(TckRcS, TckRcS, TckRcSToAccept));
  SE_WWD_CURSOR("Trs1E", TckRcS);
 END {Trs1E_OnConformToWindow};

 PRIVATE PROCEDURE Trs1ATB_OnConformToWindow();
 BEGIN
  L_General.CallUs(SEARCH(TckRcS, TckRcS, TckRcSToAccept));
  SE_WWD_CURSOR("Trs1ATB", TckRcS);
 END {Trs1ATB_OnConformToWindow};

 PRIVATE PROCEDURE Trs1ES_OnConformToWindow();
 BEGIN
  L_General.CallUs(SEARCH(TckRcS, TckRcS, TckRcSToAccept));
  SE_WWD_CURSOR("Trs1ES", TckRcS);
 END {Trs1ES_OnConformToWindow};

 PRIVATE PROCEDURE Trs1E_0_OnZoneOpen();
 BEGIN
  L_TRS.AccessTckRcS();
  L_WDO.SetFieldFormat("TckRcS.Status",   L_TRS.trsStat_Pool);
  L_WDO.SetFieldFormat("TckRcS.AsWho",    L_Way.trs_Pool);
  L_WDO.SetFieldFormat("TckRcS.AsWhoCnd", L_TRS.E_TckRcS_AsWhoCnd_GetPool(TckRcS.Date, TckRcS.AsWho));
 END {Trs1E_0_OnZoneOpen};

 PRIVATE PROCEDURE Trs1ATB_0_OnZoneOpen();
 BEGIN
  L_TRS.AccessTckRcS();
  L_WDO.SetFieldFormat("TckRcS.Status",   L_TRS.trsStat_Pool);
  L_WDO.SetFieldFormat("TckRcS.AsWho",    L_Way.trs_Pool);
  L_WDO.SetFieldFormat("TckRcS.AsWhoCnd", L_TRS.E_TckRcS_AsWhoCnd_GetPool(TckRcS.Date, TckRcS.AsWho));
 END {Trs1ATB_0_OnZoneOpen};

 PRIVATE PROCEDURE Trs1ES_0_OnZoneOpen();
 BEGIN
  L_TRS.AccessTckRcS();
  L_WDO.SetFieldFormat("TckRcS.Status",   L_TRS.trsStat_Pool);
  L_WDO.SetFieldFormat("TckRcS.AsWho",    L_Way.trs_Pool);
  L_WDO.SetFieldFormat("TckRcS.AsWhoCnd", L_TRS.E_TckRcS_AsWhoCnd_GetPool(TckRcS.Date, TckRcS.AsWho));
 END {Trs1ES_0_OnZoneOpen};

 PRIVATE PROCEDURE _SetVisible(l: NUMERIC[0]; Visible: SCAL[2]);
 BEGIN
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_TRDLNbr",      l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_TckKind",      l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_TckKind_Name", l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_Series",       l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_RestNbr",      l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_Psg",          l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_Space",        l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_Space",        l)).Value  :=" ";
 END {_SetVisible};

 PRIVATE PROCEDURE _TB_SetVisible(l: NUMERIC[0]; Visible: SCAL[2]);
 BEGIN
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_TRDLNbr",      l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_TckKind",      l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_TckKind_Name", l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_Series",       l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_RAmount",      l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_RPsg",         l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_Space",        l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_Space",        l)).Value  :=" ";
 END {_TB_SetVisible};

 PRIVATE PROCEDURE _ES_SetVisible(l: NUMERIC[0]; Visible: SCAL[2]);
 BEGIN
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_ES_TckKind",   l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_TckKind_Name", l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_ES_Amount",    l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_ES_Psg",       l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_Space",        l)).Visible:=Visible;
  L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_Space",        l)).Value  :=" ";
 END {_ES_SetVisible};

 PRIVATE PROCEDURE atrs_SetupSingleLine(pt: L_TRS.tPackedTck; VAR l: NUMERIC[0]);
  VAR
   ia_TckKind,
   ia_Series,
   ia_RestNbr,
   ia_Psg     : SCAL[2];
   nbrFormat  : STRING[];
   dummyPsg   : LIKE(TckRcDL.Psg);
   f          : FORM_FIELD;
 BEGIN
  IF L_TRS.pt_GetState(pt) # L_TRS.ts_Returned THEN
   L_TRS.pt_Unpack(pt,
                   v_TRDLNbr[l], v_TckKind[l], v_Series[l],
                   v_RestNbr[l], v_CUCopy[l], dummyPsg);
   L_General.CallUs(SEARCH(TckKind, TckKind, v_TckKind[l]));
   IF (TckKind.Type # L_TRS.tkt_PieceTck) | ~!v_RestNbr[l] THEN
    IF    L_TRS.IsDevice(TckKind.Type) THEN
     L_TRS.bc_CheckDevices_Add(TckKind.Type, v_CUCopy[l]);
     IF !L_TRS.TckRcD2DeviceReturn THEN
      L_TRS.Insert_TckRcD(L_TRS.trdt_Return, TckRcS.TckRcS, TckRcS.Storage);
      L_TRS.TckRcD2DeviceReturn:=TckRcD.TckRcD;
     END;
    END;
    v_TckKind_Name[l]:=TckKind.Name;
    L_TRS.trdl_ia_Set(L_TRS.trdt_Inventory, TckKind.TckKind, ia_TckKind, ia_Series, ia_RestNbr, ia_Psg, nbrFormat);
    _SetVisible(l, 1);
    f:=L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_RestNbr", l));
    f.Format    :=nbrFormat;
    f.Modifiable:=ia_RestNbr;
    f.OnGotFocus:=1;
    f:=L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_Psg", l));
    f.Modifiable:=ia_Psg & ~L_TRS.IsBulk();
    f.OnGotFocus:=1;
    INC(l);
   END;
  END;
 END {atrs_SetupSingleLine};

 PRIVATE PROCEDURE atrs_FillTckRcDLL(pt: L_TRS.tPackedTck; VAR l: NUMERIC[0]);
  VAR
   ia_TckKind,
   ia_Series,
   ia_RestNbr,
   ia_Psg     : SCAL[2];
   nbrFormat  : STRING[];
   dummyPsg   : LIKE(TckRcDL.Psg);
 BEGIN
  IF L_TRS.pt_GetState(pt) # L_TRS.ts_Returned THEN
   L_TRS.pt_Unpack(pt,
                   v_TRDLNbr[l], v_TckKind[l], v_Series[l],
                   v_RestNbr[l], v_CUCopy[l], dummyPsg);
   L_General.CallUs(SEARCH(TckKind, TckKind, v_TckKind[l]));
   IF    L_TRS.IsBulk_wCUC() THEN
    IF SELECT(TckRcDL, CUCopy, v_CUCopy[l], L_TRS.trdStat_Passed) & LAST(TckRcDL) THEN
     SELECT(TckRcDLL, TckRcD, , TckRcDL.TckRcD, TckRcDL.TRDLNbr);
     SAVE(TckRcDLL);
     L_TRS.Insert_TckRcDL(v_TRDLNbr[l], TckKind.TckKind, v_Series[l], 0, 0, v_CUCopy[l]);
     RESTORE(TckRcDLL);
     WHILE OCCURE(TckRcDLL) DO
      IF !TckRcDLL.Sum THEN
       SAVE(TckRcDLL);
       TckRcDLL.TckRcD :=TckRcDL.TckRcD;
       TckRcDLL.TRDLNbr:=TckRcDL.TRDLNbr;
       TckRcDLL.PassDTS:=TckRcDL.PassDTS;
       INSERT(TckRcDLL);
       RESTORE(TckRcDLL);
      END;
      NEXT(TckRcDLL);
     END;
     L_TRS.CompleteTckRcDL();
    ELSE
     L_General.CallUs(0);
    END;
   END;
   IF (TckKind.Type # L_TRS.tkt_PieceTck) | ~!v_RestNbr[l] THEN
    INC(l);
   END;
  END;
 END {atrs_FillTckRcDLL};

 PRIVATE PROCEDURE pt_GetTckKind(pt: L_TRS.tPackedTck): LIKE(TckKind.TckKind);
 BEGIN
  RETURN L_Str.AnyItem(pt, "|", 1);
 END {pt_GetTckKind};

 PRIVATE PROCEDURE atb_SetupSingleLine(pt: L_TRS.tPackedTck; VAR l: NUMERIC[0]);
  VAR
   ia_TckKind,
   ia_Series,
   ia_RestNbr,
   ia_Psg      : SCAL[2];
   nbrFormat   : STRING[];
   dummyRestNbr: LIKE(TckRcDL.RestNbr);
   dummyPsg    : LIKE(TckRcDL.Psg);
   f           : FORM_FIELD;
 BEGIN
  L_TRS.pt_Unpack(pt,
                  v_TB_TRDLNbr[l], v_TB_TckKind[l], v_TB_Series[l],
                  dummyRestNbr, v_TB_CUCopy[l], dummyPsg);
  L_General.CallUs(SEARCH(TckKind, TckKind, v_TB_TckKind[l]));
  L_TRS.trdl_ia_Set(L_TRS.trdt_Inventory, TckKind.TckKind, ia_TckKind, ia_Series, ia_RestNbr, ia_Psg, nbrFormat);
  ia_RestNbr:=ia_RestNbr(* & ~L_TRS.IsBulk()*);
  ia_Psg    :=ia_Psg | (TckKind.Type = L_TRS.tkt_ZonalTicket)(* & ~L_TRS.IsBulk()*);
  v_TB_TckKind_Name[l]:=TckKind.Name;
  _TB_SetVisible(l, 1);
  f:=L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_RAmount", l));
  f.Modifiable    :=ia_RestNbr;
  f.MustBeNonempty:=ia_RestNbr;
  f.OnGotFocus    :=1;
  f:=L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_RPsg", l));
  f.Modifiable    :=ia_Psg;
  f.Visible       :=ia_Psg;
  f.MustBeNonempty:=ia_Psg;
  f.OnGotFocus    :=1;
  INC(l);
 END {atb_SetupSingleLine};

 PRIVATE PROCEDURE es_SetupSingleLine(VAR l: NUMERIC[0]);
  VAR
   ia_TckKind,
   ia_Series,
   ia_RestNbr,
   ia_Psg      : SCAL[2];
   nbrFormat   : STRING[];
   f           : FORM_FIELD;
 BEGIN
  L_General.CallUs(OCCURE(TckKind));
  v_ES_TckKind[l]     :=TckKind.TckKind;
  v_ES_TckKind_Name[l]:=TckKind.Name;
  L_TRS.trdl_ia_Set(L_TRS.trdt_Inventory, TckKind.TckKind, ia_TckKind, ia_Series, ia_RestNbr, ia_Psg, nbrFormat);
  _ES_SetVisible(l, 1);
  f:=L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_ES_Amount", l));
  f.Modifiable    :=ia_RestNbr;
  f.MustBeNonempty:=ia_RestNbr;
  f.OnGotFocus    :=1;
  f:=L_WDO.getFieldInActiveZone(L_WDO.Fld_wIdx("v_ES_Psg", l));
  f.Modifiable    :=ia_Psg;
  f.Visible       :=ia_Psg;
  f.MustBeNonempty:=ia_Psg;
  f.OnGotFocus    :=1;
  INC(l);
 END {es_SetupSingleLine};

 PRIVATE PROCEDURE TckRcS_OnBeforeEdit();
  VAR
   pId : STRING[];
   n,
   l   : NUMERIC[0];
   pta : L_TRS.tPackedTck[1E2];
 BEGIN
  pId:=L_WDO.GetEnvVarValue(L_Events.ee_ProcessId);
  IF pId = L_TRS.pid_AcceptTckRcS THEN
   CurTckRcS_XDocJrn_Start(L_XDoc.action_begRcp);
   L_General.Assert(TckRcS.TckRcS = TckRcSToAccept, " ਥ");
   L_General.Assert(TckRcS.Status = L_TRS.trsStat_Given,
                    "ਥ 믮    ﭨ '뤠'");
   L_TRS.CheckSwitchMonthRWS(1);
   L_TRS.bc_PositionOnTckBag(pId);
   L_General.Assert(Storage.Storage = TckRcS.Storage,
                    " 㪠 㬪,  뤠   ");
   SETEMPTY(v_TRDLNbr, v_TckKind, v_TckKind_Name, v_Series, v_RestNbr, v_Psg, v_CUCopy,
            L_TRS.s_ES_TckKind, L_TRS.TckRcD2DeviceReturn);
   SETZERO(L_TRS.s_TB_RAmount, L_TRS.s_TB_RPsg, L_TRS.s_ES_Amount, L_TRS.s_ES_Psg);
   L_TRS.bc_CheckDevices_Init();
  ELSIF pId = L_TRS.pid_AcceptTicketsBack THEN
  ELSIF pId = L_TRS.pid_EasySales THEN
   SETEMPTY(v_ES_TckKind, v_ES_TckKind_Name, v_ES_Amount, v_ES_Psg);
   n:=0; l:=0;
   SAVE(TckKind);
   SELECT(TckKind, TckKind);
   WHILE OCCURE(TckKind) DO
    IF L_TRS.IsEasySalesTck() & ~L_TRS.IsVldTckKind(TckKind.TckKind) &
       L_DatTim.IsActive(TckRcS.Date, TckKind.Begin, TckKind.Till) THEN
     L_General.Assert(l < es_LineAmount, "᪠   " + L_Str.IntStr(es_LineAmount) +
                                         '     ⨯ " த".');
     es_SetupSingleLine(l);
     INC(n);
    END;
    NEXT(TckKind);
   END; (* WHILE OCCURE(TckKind) ... *)
   RESTORE(TckKind);
   v_ES_Amount :=L_TRS.s_ES_Amount;
   v_ES_Psg    :=L_TRS.s_ES_Psg;
  ELSE
   L_General.CallUs(0);
  END;
  IF pId # L_TRS.pid_EasySales THEN
   L_TRS.GetStorageTckSummary(TckRcS.Storage, TckRcS.TckRcS, L_General.EMPTY_NUMBER(), 1, pta);
   n:=0; l:=0;
   WHILE ~!pta[n] DO
    IF    pId = L_TRS.pid_AcceptTckRcS THEN
     atrs_SetupSingleLine(pta[n], l);
    ELSIF pId = L_TRS.pid_AcceptTicketsBack THEN
     atb_SetupSingleLine(pta[n], l);
    END;
    INC(n);
   END; (* WHILE ~!pta[n] *)
   IF pId = L_TRS.pid_AcceptTckRcS THEN
    L_TRS.bc_CheckDevices_Check(pId);
    L_TRS.bc_CheckDevices_Deinit();
    L_TRS.Insert_TckRcD(L_TRS.trdt_Inventory, TckRcS.TckRcS, TckRcS.Storage);
    L_TRS.TckRcD2Accept:=TckRcD.TckRcD;
    n:=0; l:=0;
    WHILE ~!pta[n] DO
     atrs_FillTckRcDLL(pta[n], l);
     INC(n);
    END; (* WHILE ~!pta[n] *)
   END;
   v_TB_RAmount:=L_TRS.s_TB_RAmount;
   v_TB_RPsg   :=L_TRS.s_TB_RPsg;
   L_WDO.getActiveForm().Depth:=11+Math.Max(10, l);
  END;

  v_EmptyInventory:=(l = 0);
  IF pId = L_TRS.pid_AcceptTckRcS THEN
   RTI.Get().CurZone.Fields(fn_EmptyInventory).Modifiable:=v_EmptyInventory;
  END;
  RTI.Get().CurZone.Fields(fn_EmptyInventory).Format:="-|㬪 !";
  IF pId = L_TRS.pid_EasySales THEN
   WHILE l < es_LineAmount DO
    _ES_SetVisible(l, 0);
    INC(l);
   END; (* WHILE l < *)
  ELSE
   WHILE l < L_TRS.trdl_Amount DO
    IF    pId = L_TRS.pid_AcceptTckRcS THEN
     _SetVisible(l, 0);
    ELSIF pId = L_TRS.pid_AcceptTicketsBack THEN
     _TB_SetVisible(l, 0);
    END;
    INC(l);
   END; (* WHILE l < *)
  END;
  FIXALTERING();
 END {TckRcS_OnBeforeEdit};

 PRIVATE PROCEDURE RestNbr_StraightInput(VAR RestNbr: L_TRS.tTckNumber);
  VAR
   value: NUMERIC[0];
 BEGIN
  value:=RestNbr;
  L_General.Assert(TckKind.Type = L_TRS.tkt_KKMActivities, "  ");
  STDFORM("|" + TckKind.Name + " %I||", "孨 ", , , value);
  RestNbr:=value MOD Math.Pow(10, TckKind.NbrPrc);
 END {RestNbr_StraightInput};

 PUBLIC PROCEDURE v_RestNbr_StraightInput();
  VAR
   cfn: STRING[];
   ci : NUMERIC[0];
 BEGIN
  cfn:=L_WDO.getActiveField().Name;
  IF cfn = "TckRcDL.RestNbr" THEN
   CONFORM(TckRcDL, TckKind);
   RestNbr_StraightInput(TckRcDL.RestNbr);
   REPLACE(TckRcDL);
  ELSE
   L_General.Assert(Str.Match(cfn, "v_RestNbr_*"), "  孨 ");
   ci:=L_WDO.getCurFldIdx();
   SEARCH(TckKind, TckKind, , v_TckKind[ci]);
   RestNbr_StraightInput(v_RestNbr[ci]);
  END;
 END {v_RestNbr_StraightInput};

 PRIVATE PROCEDURE SetColor(fn: STRING[]; color: NUMERIC[0]; ActFldName: STRING[]);
  VAR
   f : FORM_FIELD;
 BEGIN
  IF fn # ActFldName THEN
   f:=L_WDO.getFieldInActiveZone(fn);
   IF (color = FORM_FIELD.Color_ActiveHighlightBar) | f.Modifiable THEN
    f.Color:=color;
   ELSE
    f.Color:=FORM_FIELD.Color_Field4;
   END;
  END;
 END {SetColor};

 PRIVATE PROCEDURE atrs_SetColorInLine(l, color: NUMERIC[0]; ActFldName: STRING[]);
 BEGIN
  SetColor(L_WDO.Fld_wIdx("v_TRDLNbr",      l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_TckKind",      l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_TckKind_Name", l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_Series",       l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_RestNbr",      l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_Psg",          l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_Space",        l), color, ActFldName);
 END {atrs_SetColorInLine};

 PRIVATE PROCEDURE atb_SetColorInLine(l, color: NUMERIC[0]; ActFldName: STRING[]);
 BEGIN
  SetColor(L_WDO.Fld_wIdx("v_TRDLNbr",      l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_TckKind",      l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_TckKind_Name", l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_Series",       l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_RAmount",      l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_RPsg",         l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_Space",        l), color, ActFldName);
 END {atb_SetColorInLine};

 PRIVATE PROCEDURE es_SetColorInLine(l, color: NUMERIC[0]; ActFldName: STRING[]);
 BEGIN
  SetColor(L_WDO.Fld_wIdx("v_ES_TckKind",   l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_TckKind_Name", l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_ES_Amount",    l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_ES_Psg",       l), color, ActFldName);
  SetColor(L_WDO.Fld_wIdx("v_Space",        l), color, ActFldName);
 END {es_SetColorInLine};

 PRIVATE PERMANENT VAR
  es_CurIdx,
  atb_CurIdx,
  atrs_CurIdx: NUMERIC[0];

 PRIVATE PROCEDURE TckRcS__OnGotFocus();
  VAR
   cfn,
   pId: STRING[];
   cfi: NUMERIC[0];
 BEGIN
  cfi:=L_WDO.getCurFldIdx();
  cfn:=L_WDO.getActiveField().Name;
  pId:=L_WDO.GetEnvVarValue(L_Events.ee_ProcessId);
  IF pId = L_TRS.pid_AcceptTckRcS THEN
   atrs_SetColorInLine(cfi, FORM_FIELD.Color_ActiveHighlightBar, cfn);
   IF (VAR_IMPL.Get(atrs_CurIdx).Initialized) & (atrs_CurIdx # cfi) THEN
    atrs_SetColorInLine(atrs_CurIdx, FORM_FIELD.Color_Native, cfn);
   END;
   atrs_CurIdx:=cfi;
  ELSIF pId = L_TRS.pid_EasySales THEN
   es_SetColorInLine(cfi, FORM_FIELD.Color_ActiveHighlightBar, cfn);
   IF VAR_IMPL.Get(es_CurIdx).Initialized & (es_CurIdx # cfi) THEN
    es_SetColorInLine(es_CurIdx, FORM_FIELD.Color_Native, cfn);
   END;
   es_CurIdx:=cfi;
  ELSIF pId = L_TRS.pid_AcceptTicketsBack THEN
   atb_SetColorInLine(cfi, FORM_FIELD.Color_ActiveHighlightBar, cfn);
   IF VAR_IMPL.Get(atb_CurIdx).Initialized & (atb_CurIdx # cfi) THEN
    atb_SetColorInLine(atb_CurIdx, FORM_FIELD.Color_Native, cfn);
   END;
   atb_CurIdx:=cfi;
  END;
 END {TckRcS__OnGotFocus};

 PRIVATE PROCEDURE TckRcS__OnSuccessfulChange();
  VAR
   cfn: STRING[];
   ci: NUMERIC[0];
 BEGIN
  cfn:=RTI.Get().CurZone.ActiveField.Name;
  IF    Str.Match(cfn, "v_RestNbr_*") THEN
   ci:=L_WDO.getCurFldIdx();
   SEARCH(TckKind, TckKind, , v_TckKind[ci]);
   IF L_TRS.IsBulk_wCUC() THEN
    L_General.Error("ଫ த 㯯 ஢ 筮  - . F9");
   ELSE
    L_TRS.SupportRestNbrChanging(0, L_TRS.trdt_Inventory, v_CUCopy[ci], v_RestNbr[ci]);
   END;
  ELSIF cfn = fn_EmptyInventory THEN
   HALT();
  ELSE
   L_General.CallUs(0);
  END;
 END {TckRcS__OnSuccessfulChange};

 PRIVATE PROCEDURE TckRcS__OnAskPhase1();
  VAR
   cfn: STRING[];
 BEGIN
  cfn:=RTI.Get().CurZone.ActiveField.Name;
  IF cfn = "v_ES_TckKind" THEN
   IF SEARCH(TckKind, TckKind, v_ES_TckKind) THEN
    L_WDO.PositionInOwnerZoneOfActiveField("TckKind");
   END;
  END;
 END {TckRcS__OnAskPhase1};

 PRIVATE PROCEDURE TckRcS__OnAskPhase2();
  VAR
   cfn: STRING[];
 BEGIN
  cfn:=RTI.Get().CurZone.ActiveField.Name;
  v_ES_TckKind:=TckKind.TckKind;
 END {TckRcS__OnAskPhase2};

 PRIVATE PROCEDURE atrs_BuildTckRcD();
  VAR
   n,
   SameTckKindTckRcDLCnt: NUMERIC[0];
 BEGIN
  n:=0;
  WHILE (n < L_TRS.trdl_Amount) & ~!v_TRDLNbr[n] DO
   SEARCH(TckKind, TckKind, , v_TckKind[n]);
   IF L_TRS.IsDevice(TckKind.Type) THEN
    SEARCH(TckRcD, TckRcD, , L_TRS.TckRcD2DeviceReturn);
    L_TRS.InsTckRcDLForDeviceMovement(TckKind.Type, L_TRS.trdt_Return, v_TRDLNbr[n], TckRcS.TckRcS,
                                      TckRcS.Storage, v_CUCopy[n], v_RestNbr[n], v_Psg[n]);
   ELSIF ~L_TRS.IsBulk_wCUC() THEN
    SEARCH(TckRcD, TckRcD, , L_TRS.TckRcD2Accept);
    SameTckKindTckRcDLCnt:=0;
    IF (TckKind.Type = L_TRS.tkt_PieceTck) & !v_RestNbr[n] THEN
     CONFORM(TckRcD, TckRcDL);
     WHILE OCCURE(TckRcDL) DO
      INC(SameTckKindTckRcDLCnt, TckRcDL.TckKind = TckKind.TckKind);
      NEXT(TckRcDL);
     END; (* WHILE OCCURE(TckRcDL) ... *)
    END;
    IF SameTckKindTckRcDLCnt = 0 THEN
     L_TRS.Insert_TckRcDL(v_TRDLNbr[n], v_TckKind[n], v_Series[n], v_RestNbr[n], v_Psg[n], v_CUCopy[n]);
    END;
   END;
   INC(n);
  END;
  SEARCH(TckRcD, TckRcD, , L_TRS.TckRcD2Accept);
 END {atrs_BuildTckRcD};

 PRIVATE PROCEDURE TckRcS_OnAfterEdit();
  VAR
   pId: STRING[];
 BEGIN
  pId:=L_WDO.GetEnvVarValue(L_Events.ee_ProcessId);
  L_General.CallUs((pId = L_TRS.pid_AcceptTicketsBack) |
                   (pId = L_TRS.pid_EasySales) |
                   (pId = L_TRS.pid_AcceptTckRcS));
  IF pId = L_TRS.pid_AcceptTckRcS THEN
   atrs_BuildTckRcD();
   CALL(TckRcD.Proceed(+1));
   L_TRS.AcceptTckRcS();
   CurTckRcS_XDocJrn_Stop();
 (*
   PrintReceipt(0);
 *)
   TckRcSToPrintRelated:=TckRcS.TckRcS;
   IF (L_General.GetAPSiteNumber() = 84) THEN
    LIKEMENU(RunProg, "BegTRS 087", CALL, "Tck20.CheckEnoughTck("+TckRcS.Storage+")");
   ELSE
    LIKEMENU(RunProg, "BegTRS 087");
   END;
  ELSIF pId = L_TRS.pid_EasySales THEN
   L_TRS.s_ES_TckKind:=v_ES_TckKind;
   L_TRS.s_ES_Amount :=v_ES_Amount;
   L_TRS.s_ES_Psg    :=v_ES_Psg;
  ELSE
   L_TRS.s_TB_RAmount:=v_TB_RAmount;
   L_TRS.s_TB_RPsg   :=v_TB_RPsg;
  END;
 END {TckRcS_OnAfterEdit};

 PRIVATE PROCEDURE SetKKMRestNbrBasedOnCashAcceptance(OnTckRcSAccept: SCAL[2]);
  VAR
   Value    : NUMERIC[2];
   trcDTS,
   lastDTS  : FLOAT;
   RestNbr  : LIKE(TckRcDL.RestNbr);
   i,
   Line_wKKM: NUMERIC[0];
 BEGIN
  IF OnTckRcSAccept THEN
   i:=0; SETEMPTY(Line_wKKM);
   WHILE ~!v_TRDLNbr[i] DO
    SEARCH(TckKind, TckKind, , v_TckKind[i]);
    IF TckKind.Type = L_TRS.tkt_KKMActivities THEN
     L_General.Assert(!Line_wKKM, " 㬪 ᪮쪮 ");
     Line_wKKM:=i;
    END;
    INC(i);
   END;
   L_General.Assert(~!Line_wKKM, " 㬪  ");
   L_StdFrm.CrucialChoice("   ?" +
                          "|⠭    ᭮ ᤠ 窨", L_APtm.g_TckCashier);
   Value:=0;
   TRY
    atrs_BuildTckRcD();
    L_TRS.TckRcS_AcceptSummary(L_TRS.ass_Begining);
    L_TRS.TckRcS_AcceptSummary(L_TRS.ass_Intermediate);
    REPLACE(TckRcS);
    Value:=TckRcS.TotCash - L_Way.GetAdjustedTckRcSTotTInc();
    L_General.RaiseLockReleaseException();
   EXCEPT
   ON Exc:Exc_Root DO
    L_General.CheckIsLockReleaseException(Exc);
   END;
   IF Value > 0 THEN
    SEARCH(TckKind, TckKind, , v_TckKind[Line_wKKM]);
    v_RestNbr[Line_wKKM]:=(v_RestNbr[Line_wKKM] + Value / TckKind.FaceVal) MOD Math.Pow(10, TckKind.NbrPrc);
   ELSE
    L_General.Error("  ' 묨'  'த' ⠢ " + FLDTOSTR(Value, "2-", 0));
   END;
  ELSE
   L_General.Assert(ACCESS(TckRcDL), " ⠭ ப ");
   L_General.Assert(~!TckRcDL.TckKind, " 㪠  ஥ 㬥⮢");
   L_StdFrm.CrucialChoice("   ?" +
                          "|⠭    ᭮ ᤠ 窨", L_APtm.g_TckCashier);
   CONFORM(TckRcDL, TckKind);
   L_General.Assert(TckKind.Type = L_TRS.tkt_KKMActivities, "  ");
   RestNbr:=L_TRS.getTckLastRestNbr(1, TckRcDL.CUCopy);
   L_General.CallUs(~!RestNbr);
   CONFORM(TckRcDL, TckRcD);
   lastDTS:=0;
   Value  :=0;
   SELECT(TckRcC, TckRcS, , TckRcD.TckRcS, L_TRS.trct_CashAccept);
   WHILE OCCURE(TckRcC) DO
    IF L_XDoc.XDocSomeTimeWas(L_XDoc.xdt_TckRcC, L_XDoc.EmptyXDocKind, TckRcC.TckRcC,
                              L_XDoc.action_AutoBuild) THEN
     PackVARIANTDATE(trcDTS, XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec);
     IF (TckRcC.Status = L_TRS.trcStat_Passed) & (trcDTS > lastDTS) THEN
      lastDTS:=trcDTS;
      INC(Value, TckRcC.Total);
     END;
    END;
    NEXT(TckRcC);
   END; (* WHILE OCCURE(TckRcC) ... *)
   IF Value > 0 THEN
    TckRcDL.RestNbr:=(RestNbr + Value / TckKind.FaceVal) MOD Math.Pow(10, TckKind.NbrPrc);
    REPLACE(TckRcDL);
    L_StdFrm.Choice('|।騩 "孨"  ' + FLDTOSTR(RestNbr,         L_TRS.GetNbrFormat(RestNbr), 8, "R") +
                    '| 窨              ' + FLDTOSTR(Value,           ",2-",                       8, "R") +
                    '|' +
                    '|⠭ "孨"  ' + FLDTOSTR(TckRcDL.RestNbr, L_TRS.GetNbrFormat(RestNbr), 8, "R"));
   ELSE
    L_General.Error(" 묨 " + FLDTOSTR(Value, "2-", 0) + ".    㬥.");
   END;
  END;
 END {SetKKMRestNbrBasedOnCashAcceptance};

 PRIVATE CONST
  sra_l_TckKind = 36;
  sra_l_Sum     = 20;
  sra_l_Total   = sra_l_TckKind + sra_l_Sum + sra_l_Sum;

 PRIVATE PROCEDURE sra_OneLine(Name: STRING[]; Val1, Val2: NUMERIC[2]): STRING[];
 BEGIN
  RETURN "|" + Str.Align(Name, sra_l_TckKind, LEFT) +
               FLDTOSTR(Val1, "2-", sra_l_Sum) +
               FLDTOSTR(Val2, "2-", sra_l_Sum);
 END {sra_OneLine};

 PRIVATE PROCEDURE sra_DlmLine(): STRING[];
 BEGIN
  RETURN "|" + L_Str.Repeat("", sra_l_Total);
 END {sra_DlmLine};

 PRIVATE PROCEDURE ShowReviseAct();
  VAR
   RSumCash,
   RSumSale,
   InPay,
   InCash,
   InSale,
   cInCash,
   cInSale,
   Value     : NUMERIC[2];
   S         : STRING[];
 BEGIN
  TRY
   atrs_BuildTckRcD();
   L_TRS.TckRcS_AcceptSummary(L_TRS.ass_Begining);
   L_TRS.TckRcS_AcceptSummary(L_TRS.ass_Intermediate);
   REPLACE(TckRcS);
   S:=Str.Align(" ", sra_l_TckKind, LEFT) +
      Str.Align("⥭  ", sra_l_Sum, RIGHT) +
      Str.Align("⥭  த", sra_l_Sum, RIGHT) + sra_DlmLine();
   SETZERO(InCash, InSale, RSumCash, RSumSale, InPay);
   CONFORM(TckRcS, TckRcT);
   WHILE OCCURE(TckRcT) DO
    CONFORM(TckRcT, TckKind);
    IF TckKind.InCash = L_TRS.tkc_Cash THEN
     cInCash:=TckRcT.ExpSum;
     INC(RSumCash, TckRcT.RSum);
     INC(InCash, TckRcT.ExpSum - TckRcT.RSum);
    ELSE
     cInCash:=0;
    END;
    IF TckKind.InCash # L_TRS.tkc_No THEN
     INC(InPay, TckRcT.ExpSum - TckRcT.RSum);
    END;
    IF (TckKind.InSale # L_TRS.tks_Void) & (TckKind.InSale # L_TRS.tks_CashlessSales) THEN
     cInSale:=TckRcT.ExpSum;
     INC(RSumSale, TckRcT.RSum);
     INC(InSale, TckRcT.ExpSum - TckRcT.RSum);
    ELSE
     cInSale:=0;
    END;
    IF cInCash | cInSale THEN
     S:=S + sra_OneLine(TckKind.TckKind + " " + TckKind.Name, cInCash, cInSale);
    END;
    NEXT(TckRcT);
   END; (* WHILE OCCURE(TckRcT) ... *)
   IF RSumCash | RSumSale THEN
    S:=S + sra_DlmLine() + sra_OneLine(" ", RSumCash, RSumSale);
   END;
   S:=S + sra_DlmLine() + sra_OneLine("⮣ த",   InCash, InSale) +
                          sra_OneLine(" 묨", TckRcS.TotCash, L_General.EMPTY_NUMBER());

   Value:=TckRcS.TotCash - InCash;
   IF Value # 0 THEN
    S:=S + sra_DlmLine() +
       sra_OneLine(L_Str.PoolItem("|襪", Value > 0), Math.Abs(Value), L_General.EMPTY_NUMBER());
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc:Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
   IF (InPay = InSale) & (InCash = TckRcS.TotCash) THEN
    STDFORM(S, " ஫ ᮮ⢥⢨ த  ਭ  ", INFORM);
   ELSE
    STDFORM(S, " ஫ ᮮ⢥⢨ த  ਭ  ", STOP);
   END;
  END;
 END {ShowReviseAct};

 PRIVATE PROCEDURE RunEditProcess_wChangeableDepth(Win, Params, Id: STRING[]);
  VAR
   f       : FORM_WINDOW;
   curDepth: NUMERIC[0];
 BEGIN
  GE_APPWIN_SIZE(, curDepth);
  f:=APP.Get().Forms.Load(Win, Win, EMPTYOF(FORM_ZONE));
  IF f.Depth > curDepth THEN
   f.Depth:=curDepth;
  END;
  L_TRS.RunProcess("Edit", Win + " " + Params, Id);
 END {RunEditProcess_wChangeableDepth};

 PUBLIC PROCEDURE AcceptTckRcS();
 BEGIN
  L_General.TestIsMemberOfSpecificGroup(L_APtm.IsTicketCashier(), " ⭮ ");
  L_TRS.bc_PositionOnTckRcS(L_TRS.pid_AcceptTckRcS);
  L_TRS.CheckTckRcSRelatedDocs();
  TckRcSToAccept:=TckRcS.TckRcS;
  RunEditProcess_wChangeableDepth("Trs1E", "0 @", L_TRS.pid_AcceptTckRcS);
 END {AcceptTckRcS};

 PUBLIC PROCEDURE SetNewShift();
 BEGIN
  L_StdFrm.Question("   ᬥ");
  L_General.Assert(!L_TRS.tos_GetSwitchFactTime(SYSDATE()), " ᬥ 㦥 뫠 ");
  IF ~L_TRS.tos_ItIsTimeToSwitch() THEN
   L_StdFrm.CrucialChoice_FileExplicit("", "   ᬥ   ६", L_APtm.g_TckCashier);
  END;
  P_OwnData.SetP_TckOfficeShifts(SYSDATE(), SYSTIME());
 END {SetNewShift};

 PUBLIC PROCEDURE PrintReviseActTckLine(raPrt: PRINTJOB; n: NUMERIC[0]; VAR Y: FLOAT; ts: TEXTSTYLE;
                                        CUCStr, TckNbrStr, PsgStr: STRING[]);
 BEGIN
  IF n = 0 THEN
   INC(Y, 3);
   L_Print.TypeS(raPrt, 0, Y, "                      ", ts);
   INC(Y, 1);
   L_Print.TypeS(raPrt, 0, Y, "________________________________________", ts);
   INC(Y, 3);
  END;
  L_Print.TypeS(raPrt, 0, Y, Str.Align(CUCStr,    17, LEFT) +
                             Str.Align(TckNbrStr, 18, RIGHT) +
                             Str.Align(PsgStr,     5, RIGHT), ts);
  INC(Y, 3.5);
 END {PrintReviseActTckLine};

 PRIVATE PROCEDURE ratl_FaceValStr(): STRING[];
 BEGIN
  IF TckKind.Type = L_TRS.tkt_ZonalTicket THEN
   RETURN "     ";
  ELSIF Math.Mod(TckKind.FaceVal, 1) = 0 THEN
   RETURN FLDTOSTR(TckKind.FaceVal, "0=", 5);
  ELSE
   L_General.Assert(TckKind.FaceVal < 1, "࠭ ⮨  " + FLDTOSTR(TckKind.FaceVal, "2-"));
   RETURN FLDTOSTR(TckKind.FaceVal, "2-", 5);
  END;
 END {ratl_FaceValStr};

 PRIVATE PROCEDURE PrintCommonReviseActTckLine(raPrt: PRINTJOB; n: NUMERIC[0]; VAR Y: FLOAT; ts: TEXTSTYLE);
  VAR
   PsgStr: STRING[];
 BEGIN
  SEARCH(TckKind, TckKind, , v_TckKind[n]);
  IF L_TRS.TckKind_wPsg() THEN
   PsgStr:=L_Str.IntStr(v_Psg[n]);
  ELSE
   PsgStr:="";
  END;
  PrintReviseActTckLine(raPrt, n, Y, ts,
                        v_TRDLNbr[n] + " (" + v_CUCopy[n] + ")" + Str.Align(ratl_FaceValStr(), 5, RIGHT),
                        Str.Align(L_Str.Right(v_Series[n], 9), 9, RIGHT) +
                        Str.Align(FLDTOSTR(v_RestNbr[n], "0", TckKind.NbrPrc), 9, RIGHT),
                        PsgStr);
 END {PrintCommonReviseActTckLine};

 PRIVATE PROCEDURE PrintReviseActAcceptTicketsBack(raPrt: PRINTJOB; VAR Y: FLOAT; ts: TEXTSTYLE);
  VAR
   n,
   count        : NUMERIC[0];
   S,
   FaceValFormat: STRING[];
 BEGIN
  n:=0;
  count:=0;
  WHILE n < L_TRS.trdl_Amount DO
   IF L_TRS.s_TB_RAmount[n] # 0 THEN
    IF count = 0 THEN
     INC(Y, 3);
     L_Print.TypeS(raPrt, 0, Y, "ᠭ ⭮ த樨", ts);
     INC(Y, 3);
     L_Print.TypeS(raPrt, 0, Y, "                    ⢮", ts);
     INC(Y, 1);
     L_Print.TypeS(raPrt, 0, Y, "________________________________________", ts);
     INC(Y, 3);
    END;
 
    SEARCH(TckKind, TckKind, , v_TB_TckKind[n]);
    S:=v_TB_TRDLNbr[n] + " (" + v_TB_CUCopy[n] + ")" + ratl_FaceValStr() + " " +
       Str.Align(L_Str.Right(v_TB_Series[n], 9), 9, RIGHT) + " " +
       Str.Align(L_Str.IntStr(L_TRS.s_TB_RAmount[n]), 12, RIGHT);
    L_Print.TypeS(raPrt, 0, Y, S, ts);
    INC(Y, 3.5);
    INC(count);
   END;
   INC(n);
  END;
  IF count > 0 THEN
   L_Print.TypeS(raPrt, 0, Y-2.5, "________________________________________", ts);
  END;
 END {PrintReviseActAcceptTicketsBack};

 PRIVATE PROCEDURE PrintReviseActTRCLine(raPrt: PRINTJOB; VAR Y: FLOAT; ts: TEXTSTYLE);
  VAR
   S: STRING[];
 BEGIN
  IF TckRcC.Status # L_TRS.trcStat_Canceled THEN
   S:=TckRcC.TckRcC + " " +
      Str.Align(L_Str.PoolItem(L_TRS.trct_Pool, TckRcC.Type), 21, LEFT) + " " +
      FLDTOSTR(TckRcC.Total, "2-", 10);
   L_Print.TypeS(raPrt, 0,  Y, S, ts);
   INC(Y, 3.5);
  END;
 END {PrintReviseActTRCLine};

 PUBLIC PROCEDURE PrintReviseAct();
  VAR
   n    : NUMERIC[0];
   Y    : FLOAT;
   Pt08,
   Pt09,
   Pt11B: TEXTSTYLE;
   raPrt: PRINTJOB;
 BEGIN
  TRY
   L_TRS.AccessTckRcS();
   CONFORM(TckRcS, Staff);
   CONFORM(TckRcS, Storage);
   CONFORM(Staff, Man);

   Pt08 :=L_Print.ts_Create(08, "Lucida Console");
   IF L_General.GetOSPlatform() = L_General.osp_WinNT THEN
    Pt08.CharExtra:=-0.2;
   ELSE
    Pt08.CharExtra:=-0.3;
   END;
   Pt09 :=L_Print.ts_Resize(Pt08, 09);
   Pt11B:=L_Print.ts_Resize(Pt08, 11);
   Pt11B.Font.Weight:=FONT.Weight_SemiBold;

   raPrt:=L_Print.pj_Create_ChequeBand(" ᢥન");
   raPrt.StartPage();

   Y:=0;
   L_Print.TypeS(raPrt, 0, Y, P_Firm.FP_FirmShortName(L_Staff.GetFirmOfStaff(), SYSDATE()), Pt08);
   INC(Y, 3);
   L_Print.TypeS(raPrt, 38, Y, L_DatTim.DateTimeStr(SYSDATE(), SYSTIME()), Pt08);
   INC(Y, 7);
   L_Print.TypeS(raPrt, 4, Y, " ᢥન  ਥ ", Pt11B);
   INC(Y, 7);

   L_Print.TypeS(raPrt, 0, Y,
                 L_Str.PoolItem(L_Stock.st_Pool_SH, Storage.Type) + " " +
                 Str.Slice(Storage.Storage + " " + Storage.Name, 0, 25),
                 Pt09);
   INC(Y, 4);
   L_Print.TypeS(raPrt, 0, Y, " " + TckRcS.TckRcS + ", " +
                               L_Str.PoolItem(L_Way.trs_Pool, TckRcS.AsWho), Pt09);
   INC(Y, 3);
   L_Print.TypeS(raPrt, 0, Y, Staff.TSN + " " + Man.Name, Pt09);
   INC(Y, 2);

   n:=0;
   WHILE (n < L_TRS.trdl_Amount) & ~!v_TRDLNbr[n] DO
    PrintCommonReviseActTckLine(raPrt, n, Y, Pt08);
    INC(n);
   END;

   n:=0;
   WHILE ~!L_TRS.s_ES_TckKind[n] DO
    L_General.CallUs(SEARCH(TckKind, TckKind, L_TRS.s_ES_TckKind[n]));
    PrintReviseActTckLine(raPrt, n, Y, Pt08, "   " + TckKind.Name,
                                             FLDTOSTR(L_TRS.s_ES_Amount[n] * TckKind.FaceVal, "2-"),
                                             L_Str.IntStr(L_TRS.s_ES_Psg[n]));
    INC(n);
   END;

   IF n > 0 THEN
    L_Print.TypeS(raPrt, 0, Y-2.5, "________________________________________", Pt08);
   END;

   PrintReviseActAcceptTicketsBack(raPrt, Y, Pt08);

   INC(Y, 2);
   L_Print.TypeS(raPrt, 0, Y, "                             㬬", Pt08);
   INC(Y, 1);
   L_Print.TypeS(raPrt, 0, Y, "________________________________________", Pt08);
   INC(Y, 3);
   SELECT(TckRcC, TckRcS, , TckRcS.TckRcS);
   WHILE OCCURE(TckRcC) DO
    IF (TckRcC.Status = L_TRS.trcStat_Passed) &
       ((TckRcC.Type = L_TRS.trct_CashAccept) | (TckRcC.Type = L_TRS.trct_TckWriteOffLack)) THEN
     PrintReviseActTRCLine(raPrt, Y, Pt08);
    END;
    NEXT(TckRcC);
   END; (* WHILE OCCURE(TckRcC) ... *)
   L_Print.TypeS(raPrt, 0, Y-2.5, "________________________________________", Pt08);
   INC(Y, 1);
   L_Print.TypeS(raPrt, 0, Y-2.5, "________________________________________", Pt08);
   raPrt.EndPage();
   raPrt.Close();
  EXCEPT
  ON Exc: Exc_Root DO
   L_StdFrm.RedInform(Exc.MsgOriginalText);
  END;
 END {PrintReviseAct};

 PRIVATE PROCEDURE sobbc_Proceed(_XDocId: L_XDoc.tXDocId; _CopyCnt: NUMERIC[0]; VAR Message: STRING[]);
  VAR
   _XDocType : L_XDoc.tXDocType;
   _XDocKind : L_XDoc.tXDocKind;
   _XDoc     : L_XDoc.tXDoc;
   Msg       : STRING[];
 BEGIN
  L_XDoc.DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
  IF ~!_XDocId THEN
   Msg:="  ꥪ '" + L_XDoc.Ref_FullName(_XDocType) + "'";
   IF _XDocType = L_XDoc.xdt_CUCopy THEN
    L_XDoc.PositionOnXDoc(_XDocId);
    IF L_CUC.cucRole_IsTckBag() THEN
     Msg:="⭠ 㬪 " + CUCopy.Storage;
     IF SELECT(TckRcS, Storage, CUCopy.Storage) & LAST(TckRcS) THEN
      _XDocId:=L_XDoc.XDocId(L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, TckRcS.TckRcS);
      IF TckRcS.Status = L_TRS.trsStat_Given THEN
       Msg:=Msg + " 뤠 ( " + TckRcS.TckRcS + ")";
      ELSE
       Msg:=Msg + " ਭ ( " + TckRcS.TckRcS + ")";
      END;
     END;
    ELSE
     IF L_TRS.AccessTckKindByMath(CUCopy.Math, SYSDATE()) THEN
      IF (TckKind.Type = L_TRS.tkt_KKMActivities) | (TckKind.Type = L_TRS.tkt_VLDActivities) THEN
       Msg:="ன⢮ " + CUCopy.CUCopy;
       IF SELECT(TckRcDL, CUCopy, CUCopy.CUCopy, L_TRS.trdStat_Passed) & LAST(TckRcDL) THEN
        CONFORM(TckRcDL, TckRcD);
        CONFORM(TckRcD, TckRcS);
        IF TckRcD.Type = L_TRS.trdt_Laying THEN
         Msg:=Msg + " 뤠 ( " + TckRcS.TckRcS + ")";
        ELSE
         Msg:=Msg + " ਭ ( " + TckRcS.TckRcS + ")";
        END;
        _XDocId:=L_XDoc.XDocId(L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, TckRcS.TckRcS);
       ELSE
        Msg:=Msg + "   뤠";
       END;
      END;
     END;
    END;
   END; (* IF _XDocType = L_XDoc.xdt_CUCopy *)
   L_StdFrm.Inform(Msg);
   L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, _XDocId, "");
  END;
 END {sobbc_Proceed};

 PRIVATE PROCEDURE StandOnByBC();
 BEGIN
  L_XDoc.DoByBarCode("  ன⢠/ꥪ/㬥 ", PROCREF(sobbc_Proceed), 0);
 END {StandOnByBC};

 PRIVATE PERMANENT VAR
  v_BegStrTime               : STRING[];
  v_BegStr                   : STRING[][24];

 PRIVATE PROCEDURE ChkLated();
  CONST
   WindowName = "TRS0";
  CONST
   MaxBack = 10/60/24;
   MaxForw = 60/60/24;
   Yellow  = 30/60/24;
   Red     = 20/60/24;
  VAR
   i       : SCAL[100];
   Now     : FLOAT;
   Fields  : FORM_FIELDS;
   trgColor: NUMERIC[0];
 BEGIN
  IF (L_Way.E_TckRcLevel(SYSDATE()) >= L_TRS.il_Full) & L_WDO.WindowExists(WindowName) THEN
   L_RT.rte_Init();
   Fields:=APPLICATION.Get().Forms.Item(WindowName).Zones(0).Fields;
   i     :=0;
   WHILE i <= HIGH(v_BegStr) DO
    v_BegStr[i]:=" ";
    Fields("v_BegStr"+i).Color:=FORM_FIELD.Color_Field4; (**)
    INC(i);
   END;

   Now         :=L_DatTim.GetSysVARIANTDATE();
   v_BegStrTime:=L_DatTim.FullSystimeStr();
   TRY
    RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
    i:=0;
    SELECT(rtExit, DispDate, , L_BegRWS.DspSysDate(), 1);
    SRCINSEL(rtExit, GE, , Now-MaxBack);
    LOOP
     IF ~OCCURE(rtExit) | (i > HIGH(v_BegStr)) THEN
      EXIT;
     END;
     IF rtExit.BegDTS > (Now+MaxForw) THEN
      EXIT;
     END;
     IF ~!rtExit.RWayS & SELECT(WayLMen, RWayS, rtExit.RWayS) THEN
      WHILE OCCURE(WayLMen) DO
       IF (WayLMen.Who = L_Way.wlmwho_Guard) & ~SELECT(TckRcS, sTSN, L_TRS.trsStat_Given, WayLMen.TSN, L_BegRWS.DspSysDate()) THEN
        CONFORM(WayLMen, Staff);
        CONFORM(Staff, Man);
        CONFORM(rtExit, StExit);
        v_BegStr[i]:=L_DatTim.TimeStr(L_DatTim.GetTimeOfVARIANTDATE(rtExit.BegDTS)) +
                     " " + StExit.ExitClss +
                     " " + Staff.TSN +
                     " " + Man.Name;
        IF    rtExit.BegDTS   <= (Now  + Red) THEN
         trgColor:=FORM_FIELD.Color_Field1; (**)
        ELSIF (rtExit.BegDTS) <= (Now + Yellow) THEN
         trgColor:=FORM_FIELD.Color_Field3;(**)
        ELSE
         trgColor:=FORM_FIELD.Color_Field4;(**)
        END;
        Fields("v_BegStr"+i).Color:=trgColor;
        INC(i);
       END;
       NEXT(WayLMen);
      END; (* WHILE OCCURE(WayLMen) *)
     END; (* IF ~!rtExit.RWayS ... *)
     NEXT(rtExit);
    END; (* LOOP ... *)
   EXCEPT
   END; (* TRY *)
  END; (* IF L_Way.E_TckRcLevel(SYSDATE()) >= L_TRS.il_Full ... *)
 END {ChkLated};

 PRIVATE PROCEDURE bztg_NextSeries(ser: STRING[]): STRING[];
  VAR
   pos: NUMERIC[0];
   res: STRING[];
   num: STRING[1];
 BEGIN
  IF !ser THEN
   RETURN ser;
  END;
  pos:=Str.Length(ser) - 1;
  res:=ser;
  LOOP
   L_General.Assert(pos >= 0, '⭮,    ᫥ "' + ser + '"');
   num:=L_Str.Char(ser, pos);
   IF num = "9" THEN
    res:=Str.Slice(res, 0, pos) + "0" + Str.Slice(res, pos + 1, Str.Length(res));
    pos:=pos - 1;
   ELSE
    res:=Str.Slice(res, 0, pos) + CHR(ORD(num)+1) + Str.Slice(res, pos + 1, Str.Length(res));
    RETURN res;
   END;
  END;
 END {bztg_NextSeries};

 PRIVATE PROCEDURE tbpi_CompleteNumber(num: STRING[]): NUMERIC[0];
 BEGIN
(*
  IF Str.Length(num) < TckKind.NbrPrc THEN
   num:=num + L_Str.FixedIntStr(TckKind.FstInPck, TckKind.NbrPrc - Str.Length(num));
  END;
*)
  RETURN STRTOFLD(num, NUMERIC);
 END {tbpi_CompleteNumber};

 PRIVATE PROCEDURE tbpi_TestSeries(_Ser: STRING[]): SCAL[2];
 BEGIN
  TRY
   L_TRS.CheckTicketSeries(TckKind.TckKind, _Ser);
  EXCEPT
  ON Exc: Exc_Raise DO
   L_StdFrm.RedInform(Exc.MsgOriginalText);
   RETURN 0;
  END;
  RETURN 1;
 END {tbpi_TestSeries};

 PRIVATE PROCEDURE bztg_PrepareIndex(serB, serE, numB, numE: STRING[]): SCAL[2];
  VAR
   ser   : STRING[];
   iter,
   cnt,
   num,
   _numB,
   _numE,
   Length: NUMERIC[0];
 BEGIN
  SELECT(list, series);
  REMSEL(list);
  Length:=TckKind.NbrPrc;
  IF Length = 0 THEN
   Length:=8;
  END;
  _numB :=L_TRS.PackFirstNbr(TckKind.TckKind, tbpi_CompleteNumber(numB));
  _numE :=L_TRS.PackFirstNbr(TckKind.TckKind, tbpi_CompleteNumber(numE));
  iter  :=TckKind.PckVol;
  IF ~tbpi_TestSeries(serB) | ~tbpi_TestSeries(serE) THEN
   RETURN 0;
  END;
  ser:=serB;
  cnt:=0;
  WHILE (cnt = 0) | (~!ser) & (ser <= serE) DO
   num:=_numB;
   WHILE num <= _numE DO
    list.series :=ser;
    list.numbers:=L_Str.FixedIntStr(num, Length);
    list.include:=1;
    INSERT(list);
    PROMPT(list.series + " " + list.numbers);
    INC(num, iter);
   END;
   INC(cnt);
   ser:=bztg_NextSeries(ser);
  END;
  RETURN 1;
 END {bztg_PrepareIndex};

 PRIVATE PROCEDURE bztg_ResortList(sortby: SCAL[2]; VAR included: NUMERIC[0]): STRING[];
  VAR
   elm,
   _list: STRING[];
   Idx : NUMERIC[0];
 BEGIN
  included:=0;
  IF sortby = sb_Ser THEN
   SELECT(list, series);
  ELSE
   SELECT(list, numbers);
  END;
  _list:="";
  WHILE OCCURE(list) DO
   IF sortby = sb_Ser THEN
    elm:=Str.Align(list.series, 12, LEFT) + " " + Str.Align(list.numbers, 8, LEFT);
   ELSE
    elm:=Str.Align(list.numbers, 8, LEFT) + " " + Str.Align(list.series, 12, LEFT);
   END;
   PROMPT(elm);
   _list:=_list + elm + " [" + L_Str.PoolItem(" |x", list.include) + "]|";
   INC(included, list.include);
   NEXT(list);
  END;
  RETURN _list;
 END {bztg_ResortList};

 PRIVATE PROCEDURE bztg_Do(DoOperation: PROC; OpStr: STRING[]);
  VAR
   Cnt: NUMERIC[0];
   serial: STRING[];
 BEGIN
  Cnt:=0;
  SELECT(list, include, , 1);
  WHILE OCCURE(list) DO
   PROMPT(list.series+" "+list.numbers);
   DoOperation();
   INC(Cnt);
   NEXT(list);
  END; (* WHILE OCCURE(list) ... *)
  L_StdFrm.Inform(OpStr + " " + L_Str.IntStr(Cnt) + " " +
                  Str.EnumObject(Cnt, "||஢"));
 END {bztg_Do};

 PRIVATE PROCEDURE bztg_PutOne();
 BEGIN
  DEFAULT(TckRcDLL);
  TckRcDLL.TckRcD :=TckRcDL.TckRcD;
  TckRcDLL.TRDLNbr:=TckRcDL.TRDLNbr;
  TckRcDLL.Series :=list.series;
  TckRcDLL.RestNbr:=list.numbers;
  IF OCCURE(SnTckTrf) THEN
   TckRcDLL.SnTckTrf:=SnTckTrf.SnTckTrf;
   TckRcDLL.Sum     :=SnTckTrf.Price;
  END;
  INSERT(TckRcDLL);
  CALL(TckRcD.TckRcDLL_OnAfterInsert());
 END {bztg_PutOne};

 PRIVATE PROCEDURE bztg_RemoveOne();
 BEGIN
  SELECT(TckRcDLL, TckRcD, , TckRcDL.TckRcD, TckRcDL.TRDLNbr);
  WHILE OCCURE(TckRcDLL) DO
   IF (TckRcDLL.Series = list.series) & (TckRcDLL.RestNbr = STRTOFLD(list.numbers, SCAL)) THEN
    CALL(TckRcD.TckRcDLL_OnBeforeDelete());
    REMOVE(TckRcDLL);
    RETURN;
   END;
   NEXT(TckRcDLL);
  END; (* WHILE OCCURE(TckRcDLL) ... *)
 END {bztg_RemoveOne};

 PRIVATE PROCEDURE bztg_Put();
 BEGIN
  bztg_Do(PROCREF(bztg_PutOne), ":");
 END {bztg_Put};

 PRIVATE PROCEDURE bztg_Remove();
 BEGIN
  bztg_Do(PROCREF(bztg_RemoveOne), ":");
 END {bztg_Remove};

 PRIVATE PROCEDURE BuildZonalTicketGroup();
  VAR
   s,
   serB,
   serE,
   numB,
   numE,
   _list    : STRING[];
   Idx,
   included,
   Choice   : NUMERIC[0];
   sortby,
   IsTickets: SCAL[2];
   _OpKind  : L_CUC.tOpKind;
   Dummy    : STRING[];
   sttList,
   sttCode  : STRING[];
   sttIdx   : NUMERIC[0];
   trgSnTckTrf: LIKE(SnTckTrf.SnTckTrf);
 BEGIN
  L_General.Assert(ACCESS(TckRcDL), " ⠭ ப ");
  L_General.Assert(~!TckRcDL.TckKind, " 㪠  ⭮ த樨");
  CONFORM(TckRcDL, TckKind);
  L_General.Assert(L_TRS.IsBulk_wCUC(), "祭 ஢  ।ᬮ७");

  CONFORM(TckRcDL, TckRcD);
  SETEMPTY(sttList, sttCode, sttIdx, trgSnTckTrf);
  IF L_TRS.IsSaleTckRcD(TckRcD.Type) THEN
   SELECT(SnTckTrf, RngTyp, , TckKind.TckKind);
   WHILE OCCURE(SnTckTrf) DO
    IF L_DatTim.IsActive(TckRcD.Date, SnTckTrf.Begin, SnTckTrf.Till) THEN
     sttList:=sttList + SnTckTrf.strName + " " + L_Str.IntStr(SnTckTrf.Price) + "= " +
              L_Str.PoolItem(L_TRS.sttt_Pool, SnTckTrf.Type) + " " + SnTckTrf.SnTckTrf + "|";
     sttCode:=sttCode + SnTckTrf.SnTckTrf + "|";
    END;
    NEXT(SnTckTrf);
   END; (* WHILE OCCURE(SnTckTrf) ... *)
  END;
  L_AFM.MakeMultipleIndex("list", "series: STRING[12]; numbers: STRING[8]; include: SCAL[2]",
                          "series : series, numbers;" +
                          "numbers: numbers, series;" +
                          "include: include, series, numbers");
  SETEMPTY(serB, serE, numB, numE);
  LOOP
   LOOP
    IF ~!sttList THEN
     STDFORM(L_StdFrm.sf_Choice("|ਨ   %############%  %############%|" +
                                "|  %########%      %########%    |" +
                                "|                                     " +
                                "|%" + L_Str.Repeat("#", 40) + "%|",
                                "%I %YI %I %YI" +
                                "%AI"),
             " ⮢ ᯨ᪠ ஢ ",
             ,
             ,
             serB, serE, numB, numE, sttList, sttIdx);
    ELSE
     STDFORM(L_StdFrm.sf_Choice("|ਨ   %############%  %############%|" +
                                "|  %########%      %########%    |",
                                "%I %YI %I %YI"),
             " ⮢ ᯨ᪠ ஢ ",
             ,
             ,
             serB, serE, numB, numE);
    END;
    serB:=Str.Cap(serB);
    IF !serE THEN
     serE:=serB;
    ELSE
     serE:=Str.Cap(serE);
    END;
    IF !numE THEN
     numE:=numB;
    END;

    IF (numB > numE) | (Str.Length(numB) # Str.Length(numE)) THEN
     L_StdFrm.RedInform(" ࢠ ஢");
    ELSE
     IF (serB > serE) | (Str.Length(serB) # Str.Length(serE)) THEN
      L_StdFrm.RedInform(" ࢠ ਩");
     ELSE
      TRY
       Dummy:=L_TRS.cc_BuildSerial(serB, numB);
       Dummy:=L_TRS.cc_BuildSerial(serE, numE);
       EXIT;
      EXCEPT
      ON Exc: Exc_Root DO
       L_StdFrm.RedInform("⨬ ᨬ  ਨ / ");
      END;
     END;
    END;
   END; (* LOOP *)

   IF bztg_PrepareIndex(serB, serE, numB, numE) THEN
    sortby:=sb_Ser;
    Idx :=0;
    LOOP
     _list:=bztg_ResortList(sortby, included);
     Choice:=STDFORM(L_Str.PoolItem("            |            ", sortby) +
                     "|%25,15AI" + L_Str.Repeat("|", 15) +
                     "|祭 %6NI ஢    " +
                     "|" +
                     "|%< {} >DB  %< {} ஢ >B" +
                     "|%< {}⬥ >X  %< {} >B  %< {} >B",
                     "  ", , , _list, Idx, included);
     IF    Choice = 1 THEN
      s:=L_Str.PoolItem(_list, Idx);
      IF sortby = sb_Ser THEN
       SEARCH(list, series, , Str.Condense(Str.Slice(s, 0, 12)), Str.Condense(Str.Slice(s, 12, 8)));
      ELSE
       SEARCH(list, numbers, , Str.Condense(Str.Slice(s, 0, 8)), Str.Condense(Str.Slice(s, 8, 12)));
      END;
      list.include:=~list.include;
      REPLACE(list);
     ELSIF Choice = 2 THEN
      sortby:=~sortby;
     ELSE
      EXIT;
     END;
    END;
    IF Choice # 0 THEN
     EXIT;
    END;
   END;
  END;
  IF    Choice = 3 THEN
   IF ~!sttIdx THEN
    trgSnTckTrf:=L_Str.PoolItem(sttCode, sttIdx);
   END;
   SEARCH(SnTckTrf, SnTckTrf, , trgSnTckTrf);
   bztg_Put();
  ELSIF Choice = 4 THEN
   bztg_Remove();
  ELSE
   L_General.CallUs(0);
  END;
  L_AFM.AF_PurgeTemp("list");
 END {BuildZonalTicketGroup};

 PUBLIC PROCEDURE bullshitRenovateBegTRSPermanents();
  VAR
   i: NUMERIC[0];
 BEGIN
  IF SEARCH(TckRcDL, TckRcD, L_TRS.TckRcD2Accept, L_TRS.TRDLNbr2Accept) THEN
   i:=0;
   LOOP
    IF i = L_TRS.trdl_Amount THEN
     L_General.CallUs(0);
    ELSIF v_TRDLNbr[i] = TckRcDL.TRDLNbr THEN
     v_RestNbr[i]:=TckRcDL.RestNbr;
     CONFORM(TckRcDL, TckKind);
     IF L_TRS.TckKind_wPsg() THEN
      v_Psg    [i]:=TckRcDL.Psg;
     END;
     EXIT;
    END;
    INC(i);
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {bullshitRenovateBegTRSPermanents};

 PUBLIC PROCEDURE RollbackTRSAccept();
 BEGIN
  L_TRS.bc_PositionOnTckRcS(L_TRS.pid_RollbackTRSAccept);
  L_General.Assert(TckRcS.Status # L_TRS.trsStat_Rated, " 㦥 ⠪஢");
  L_General.Assert(TckRcS.Status = L_TRS.trsStat_Taken, "  ਭ");
  L_StdFrm.CrucialChoice_FileExplicit("TckRcS", "⬥ ਥ  " + TckRcS.TckRcS, L_APtm.g_TckCashier);
  SAVE(TckRcS);
  L_General.Assert(~SELECT(TckRcS, sTSN, L_TRS.trsStat_Given, TckRcS.TSN), " 뤠 ᫥騩 ");
  RESTORE(TckRcS);
  SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcT) DO
   SETEMPTY(TckRcT.AftNbr);
   SETZERO(TckRcT.ExpNum, TckRcT.ExpSum, TckRcT.RNum, TckRcT.RSum);
   REPLACE(TckRcT);
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
  TckRcS.Status:=L_TRS.trsStat_Given;
  REPLACE(TckRcS);
  CurTckRcS_XDocJrn_Mark(L_XDoc.action_begRcpCncl);
  SELECT(TckRcD, TckRcS, , TckRcS.TckRcS);
  LAST(TckRcD);
  SAVE(TckRcD);
  CHANGESEL(TckRcD, Storage, , TckRcD.Storage);
  L_General.Assert(~NEXT(TckRcD), " 뫨   㬪 ᫥  " + TckRcS.TckRcS);
  RESTORE(TckRcD);
  L_General.CallUs(TckRcD.Type = L_TRS.trdt_Inventory);
  L_General.CallUs(TckRcD.Status # L_TRS.trdStat_Canceled);
  TckRcD.Status:=L_TRS.trdStat_Canceled;
  REPLACE(TckRcD);
  CONFORM(TckRcD, TckRcDL);
  WHILE OCCURE(TckRcDL) DO
   L_TRS.MustBeLastCUCopyTckRcDL();
   TckRcDL.Status:=TckRcD.Status;
   REPLACE(TckRcDL);
   CONFORM(TckRcDL, TckKind);
   IF L_TRS.IsBulk() THEN
    CONFORM(TckRcDL, TckRcDLL);
    WHILE OCCURE(TckRcDLL) DO
     L_TRS.MustBeLastCUCopyTckRcDLL();
     TckRcDLL.Status:=TckRcD.Status;
     REPLACE(TckRcDLL);
     NEXT(TckRcDLL);
    END; (* WHILE OCCURE(TckRcDLL) ... *)
   END;
   NEXT(TckRcDL);
  END; (* WHILE OCCURE(TckRcDL) ... *)
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD, L_XDoc.action_AutoEdit);
  SELECT(TckRcC, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcC) DO
   IF (TckRcC.Type # L_TRS.trct_CashAccept) & (TckRcC.Status # L_TRS.trcStat_Canceled) THEN
    CALL(TckRcC, L_Events.md_SingleMakeUnDone);
    IF ~!L_XDoc.GetAllDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_TckRcC)) THEN
     L_StdFrm.Choice("㫨஢  " + TckRcC.TckRcC + ":  易 㬥");
    END;
    TckRcC.Status:=L_TRS.trcStat_Canceled;
    REPLACE(TckRcC);
    CALL(TckRcC, L_Events.md_SingleMakeDone);
    L_XDoc.XDocJrn_Mark(L_XDoc.xdt_TckRcC, L_XDoc.EmptyXDocKind, TckRcC.TckRcC, L_XDoc.action_AutoEdit);
   END;
   NEXT(TckRcC);
  END; (* WHILE OCCURE(TckRcC) ... *)
 END {RollbackTRSAccept};

 PUBLIC PROCEDURE SetTimer();
 BEGIN
  L_Timer.SetTimer(TimerId, 1, 20, "BegTRS, 097");
 END {SetTimer};

 PUBLIC PROCEDURE ResetTimer();
 BEGIN
  L_Timer.ResetTimer(TimerId);
 END {ResetTimer};

 PUBLIC PROCEDURE Laying();
 BEGIN
  BuildTckRcD(L_TRS.pid_Laying);
 END {Laying};

 PUBLIC PROCEDURE NightLaying();
 BEGIN
  BuildTckRcD(L_TRS.pid_NightLaying);
 END {NightLaying};

 PUBLIC PROCEDURE CashAccept();
 BEGIN
  BuildTckRcC(L_TRS.pid_CashAccept);
 END {CashAccept};

 PUBLIC PROCEDURE Return();
 BEGIN
  BuildTckRcD(L_TRS.pid_Return);
 END {Return};

 PUBLIC PROCEDURE TRS0_SetEmptyPermanentVar();
 BEGIN
  SETEMPTY(v_BegStrTime, v_BegStr);
 END {TRS0_SetEmptyPermanentVar};

BEGIN
 IF    L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSIF MODE = 063 THEN
  IF ~ACCESS(TckRcS) | L_XDoc.BegXDocIsVerified(L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, TckRcS.TckRcS, 2) THEN
   L_TRS.bc_PositionOnTckRcS("९⪠ ");
  END;
  L_StdFrm.Choice("  ९ ⭮-  " + TckRcS.TckRcS);
  RePrint_TckRcS(0);
 ELSIF MODE = 080 THEN
  Print(1);
 ELSIF MODE = 081 THEN
  Print(0);
 ELSIF MODE = 084 THEN
  BuildZonalTicketGroup();
 ELSIF MODE = 085 THEN
  PrintReceipt(1);
 ELSIF MODE = 086 THEN
  PrintReceipt(0);
 ELSIF MODE = 087 THEN
  PrintTckRcSRelatedDocs(TckRcSToPrintRelated);
 ELSIF MODE = 090 THEN
  RunEditProcess_wChangeableDepth("Trs1ATB", "0 Trs1E 0", L_TRS.pid_AcceptTicketsBack);
 ELSIF MODE = 091 THEN
  SetKKMRestNbrBasedOnCashAcceptance(1);
 ELSIF MODE = 092 THEN
  SetKKMRestNbrBasedOnCashAcceptance(0);
 ELSIF MODE = 093 THEN
  ShowReviseAct();
 ELSIF MODE = 094 THEN
  L_TRS.RunProcess("Edit", "Trs1ES 0 Trs1E 0", L_TRS.pid_EasySales);
 ELSIF MODE = 095 THEN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  StandOnByBC();
 ELSIF MODE = 097 THEN
  ChkLated();
 ELSIF MODE = 100 THEN
  IF    RTI.Get().CurZone.ActiveField.Name = fn_EmptyInventory THEN
   L_General.Error("㤠 த  ⮩ 㬪?");
  ELSIF SEARCH(TckRcD, TckRcD, L_TRS.TckRcD2Accept) &
        SEARCH(TckRcDL, TckRcD, TckRcD.TckRcD, v_TRDLNbr[L_WDO.getCurFldIdx()]) THEN
   L_TRS.TRDLNbr2Accept:=TckRcDL.TRDLNbr;
   CONFORM(TckRcDL, TckKind);
   L_General.CallUs(L_TRS.IsBulk_wCUC());
   L_TRS.RunProcess("View", "TckRcDLEE 1 Trs1E 0", L_TRS.pid_AcceptTKGroup);
  ELSE
   L_StdFrm.Inform("  㯯 ஢ 筮 ");
  END;
 ELSE
  L_General.BadMode(MODE);
 END;
END.
