(*
%Copyright   (c) Polak Computer System
%Author      19.02.2003 16:06:58 POLAK\GAV
%Purpose      ᢥન    ਮ
%Type        report
%Specific    AP_PT
%Modified    10.04.2012 12:01:55 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, L_General, L_OwnData, L_DatTim, D_TP, L_AFM, E_Utils;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
##################################################################### ########## #####
=#####================================================================================
|####################################################################################|
}
*)

(*
$P{ RDOTop:
?, L, "0"
?, L, ""
@
|====================================================================================|
|  - ##  ####################################################################|
|------------------------------------------------------------------------------------|
}
*)

(*
$P{ Hat:
?, L, ""
@
|          |        |         |      ஡ -        | ஡ -   |
|##########|   | -|--------------------------------|---------------------|
|          |        |         |     騩| ᠦ|   㫥|     騩|   㫥|
}
*)

(*
$P{ Delimiter_Plus:
@
|++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|
}
*)


(*
$P{ Delimiter_Tilda:
@
|~~~~~~~~~~|~~~~~~~~|~~~~~~~~~|~~~~~~~~~~|~~~~~~~~~~|~~~~~~~~~~|~~~~~~~~~~|~~~~~~~~~~|
}
*)

(*
$P{ Delimiter_Line:
@
|----------|--------|---------|----------|----------|----------|----------|----------|
}
*)

(*
$P{ Delimiter_DblLine:
@
|==========|========|=========|==========|==========|==========|==========|==========|
}
*)

(*
$P{ Line:
?, L, ""
?, R, "1."
?, R, "1."
?, R, "1."
?, R, "1."
?, R, "1."
@
|##########|########|#########|##########|##########|##########|          |          |
}
*)

(*
$P{ Bot:
@
=(c) Polak============================================================================
}
*)

 PRIVATE PROCEDURE Grp_Route(): STRING[];
 BEGIN
  RETURN TP.Route;
 END {Grp_Route};

 PRIVATE PROCEDURE Grp_Modif(): STRING[];
 BEGIN
  SEARCH(RoutMod, Route, , TP.Route, TP._Modif);
  RETURN RoutMod.Modif + FLDTOSTR(RoutMod.Run, "1.", 7);
 END {Grp_Modif};

 PRIVATE PROCEDURE Grp_BoxNbr(): STRING[];
 BEGIN
  RETURN TP.BoxNbr;
 END {Grp_BoxNbr};

 PRIVATE PROCEDURE Grp_BoxNbrStr(): STRING[];
 BEGIN
  RETURN ". " + TP.BoxNbr;
 END {Grp_BoxNbrStr};

 PRIVATE PROCEDURE Grp_MarkG(): STRING[];
 BEGIN
  RETURN TP.MarkG;
 END {Grp_MarkG};

 PRIVATE PROCEDURE Grp_MarkGName(): STRING[];
 BEGIN
  SEARCH(MarkG, MarkG, , TP.MarkG);
  RETURN MarkG.Name;
 END {Grp_MarkGName};

 PRIVATE PROCEDURE TMP_Create(tmp2Name, tmpName, TotName: STRING[]);
 BEGIN
  CreateFILE(^tmp2Name);
  CreateFIELD(^tmp2Name, VCor,      LIKE(Route.VCor));
  CreateFIELD(^tmp2Name, Grp,       STRING[10]);
  CreateFIELD(^tmp2Name, SubGrp,    STRING[10]);
  CreateFIELD(^tmp2Name, aSubGrp,   STRING[10]);
  CreateFIELD(^tmp2Name, Name,      STRING[10]);
  CreateFIELD(^tmp2Name, GoodTrips, NUMERIC[1]);
  CreateFIELD(^tmp2Name, WrkTim,    NUMERIC[3]);
  CreateFIELD(^tmp2Name, FullRun,   NUMERIC[2]);
  CreateFIELD(^tmp2Name, RunPass,   NUMERIC[2]);
  CreateFIELD(^tmp2Name, ZeroRun,   NUMERIC[2]);
  CreateINDEX(^tmp2Name, GrpStr, UNIQUE, , , VCor, Grp, SubGrp, aSubGrp);
  SetVersionOfFILE(^tmp2Name, 1);
  L_AFM.AF_CreateTemp(tmp2Name, tmp2Name);

  CreateFILE(^tmpName);
  CreateFIELD(^tmpName, VCor,      LIKE(Route.VCor));
  CreateFIELD(^tmpName, Grp,       STRING[10]);
  CreateFIELD(^tmpName, SubGrp,    STRING[10]);
  CreateFIELD(^tmpName, Name,      STRING[10]);
  CreateFIELD(^tmpName, GoodTrips, NUMERIC[1]);
  CreateFIELD(^tmpName, WrkTim,    NUMERIC[3]);
  CreateFIELD(^tmpName, FullRun,   NUMERIC[2]);
  CreateFIELD(^tmpName, RunPass,   NUMERIC[2]);
  CreateFIELD(^tmpName, ZeroRun,   NUMERIC[2]);
  CreateINDEX(^tmpName, GrpStr, UNIQUE, , , VCor, Grp, SubGrp);
  SetVersionOfFILE(^tmpName, 1);
  L_AFM.AF_CreateTemp(tmpName, tmpName);

  CreateFILE(^TotName);
  CreateFIELD(^TotName, VCor,      LIKE(Route.VCor));
  CreateFIELD(^TotName, Grp,       STRING[10]);
  CreateFIELD(^TotName, Name,      STRING[10]);
  CreateFIELD(^TotName, GoodTrips, NUMERIC[1]);
  CreateFIELD(^TotName, WrkTim,    NUMERIC[3]);
  CreateFIELD(^TotName, FullRun,   NUMERIC[2]);
  CreateFIELD(^TotName, RunPass,   NUMERIC[2]);
  CreateFIELD(^TotName, ZeroRun,   NUMERIC[2]);
  CreateINDEX(^TotName, GrpStr, UNIQUE, , , VCor, Grp);
  SetVersionOfFILE(^TotName, 1);
  L_AFM.AF_CreateTemp(TotName, TotName);
 END {TMP_Create};

 PRIVATE PROCEDURE _Add(tmp2Name,
                tmpName,
                TotName             : STRING[];
                Grp,     GrpName,
                SubGrp,  SubGrpName,
                aSubGrp, aSubGrpName: PROC);
 BEGIN
  IF ~!aSubGrp THEN
   IF ~ADD(^tmp2Name, GrpStr, Route.VCor, Grp(), SubGrp(), aSubGrp(),
               ^tmp2Name.GoodTrips, TP.GoodTrips,
               ^tmp2Name.WrkTim,    TP.WrkTim,
               ^tmp2Name.FullRun,   TP.FullRun,
               ^tmp2Name.RunPass,   TP.RunPass,
               ^tmp2Name.ZeroRun,   TP.ZeroRun) THEN
    ^tmp2Name.Name:=aSubGrpName();
    REPLACE(^tmp2Name);
   END;
  END;

  IF ~!SubGrp THEN
   IF ~ADD(^tmpName, GrpStr, Route.VCor, Grp(), SubGrp(),
               ^tmpName.GoodTrips, TP.GoodTrips,
               ^tmpName.WrkTim,    TP.WrkTim,
               ^tmpName.FullRun,   TP.FullRun,
               ^tmpName.RunPass,   TP.RunPass,
               ^tmpName.ZeroRun,   TP.ZeroRun) THEN
    ^tmpName.Name:=SubGrpName();
    REPLACE(^tmpName);
   END;
  END;

  IF ~ADD(^TotName, GrpStr, Route.VCor, Grp(),
              ^TotName.GoodTrips, TP.GoodTrips,
              ^TotName.WrkTim,    TP.WrkTim,
              ^TotName.FullRun,   TP.FullRun,
              ^TotName.RunPass,   TP.RunPass,
              ^TotName.ZeroRun,   TP.ZeroRun) THEN
   ^TotName.Name:=GrpName();
   REPLACE(^TotName);
  END;
 END {_Add};

 PRIVATE PROCEDURE _MakeLine(tmpName: STRING[]);
 BEGIN
  MAKEPART(R, Line, ^tmpName.Name, ^tmpName.GoodTrips,
                                   ^tmpName.WrkTim,
                                   ^tmpName.FullRun,
                                   ^tmpName.RunPass,
                                   ^tmpName.ZeroRun);
 END {_MakeLine};

 PRIVATE PROCEDURE AllExits(): SCAL[2];
 BEGIN
  RETURN 1;
 END {AllExits};

 PRIVATE PROCEDURE E_NeedExit(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.ForRDO_NeedExit);
  IF ~!Local THEN
   RETURN Local();
  END;
  RETURN ((TP.Exit MOD 1E6 DIV 1E3) = 002);
 END {E_NeedExit};

 PRIVATE PROCEDURE MakeRep(RepName,
                   SubTitle,
                   Hat1DetailName,
                   Hat2DetailName         : STRING[];
                   NeedExit,
                   Grp1,     Grp1Name,
                   SubGrp1,  SubGrp1Name,
                   aSubGrp1, aSubGrp1Name,
                   Grp2,     Grp2Name,
                   SubGrp2,  SubGrp2Name,
                   aSubGrp2, aSubGrp2Name : PROC);
  VAR
   _GoodTrips: NUMERIC[1];
   _WrkTim   : NUMERIC[3];
   _FullRun,
   _RunPass,
   _ZeroRun  : NUMERIC[2];
   LineCnt1,
   LineCnt2,
   LineCnt3  : NUMERIC[0];
 BEGIN
  SAVE(Route);
  D_TP.PrepareTPwRDO();
  RESTORE(Route);
  TMP_Create("tmp1a", "tmp1", "tmp1T");
  TMP_Create("tmp2a", "tmp2", "tmp2T");
  WHILE OCCURE(Route) DO
   IF L_DatTim.IsActive(Memo.ud_ut(), Route.Begin, Route.Till) & (Route.VCor # 0) THEN
    SELECT(TP, Route, , Route.Route);
    WHILE OCCURE(TP) DO
     PROMPT(TP.Route + " " + TP._Modif + " " + TP.Mark);
     IF NeedExit() THEN
      _Add("tmp1a", "tmp1", "tmp1T", Grp1,     Grp1Name,
                                     SubGrp1,  SubGrp1Name,
                                     aSubGrp1, aSubGrp1Name);
      _Add("tmp2a", "tmp2", "tmp2T", Grp2,     Grp2Name,
                                     SubGrp2,  SubGrp2Name,
                                     aSubGrp2, aSubGrp2Name);
     END;
     NEXT(TP);
    END; (* WHILE OCCURE(TP) ... *)
   END;
   NEXT(Route);
  END; (* WHILE OCCURE(Route) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, " ᢥન    ਮ  " +
                            L_DatTim.DateStr(Memo.ud_fr()) + "  " +
                            L_DatTim.DateStr(Memo.ud_ut()));

  SELECT(tmp1T, GrpStr);
  WHILE OCCURE(tmp1T) DO
   SELECT(tmp1T, GrpStr, , tmp1T.VCor);
   SAVE(tmp1T);

   SETZERO(_GoodTrips, _WrkTim, _FullRun, _RunPass, _ZeroRun);
   WHILE OCCURE(tmp1T) DO
    INC(_GoodTrips, tmp1T.GoodTrips);
    INC(_WrkTim,    tmp1T.WrkTim);
    INC(_FullRun,   tmp1T.FullRun);
    INC(_RunPass,   tmp1T.RunPass);
    INC(_ZeroRun,   tmp1T.ZeroRun);
    NEXT(tmp1T);
   END; (* WHILE OCCURE(tmp1T) ... *)
   RESTORE(tmp1T);
   IF (_WrkTim > 0) | (_FullRun > 0) THEN
    SAVE(tmp1T);
    MAKEPART(R, RDOTop, tmp1T.VCor, SubTitle);
    MAKEPART(R, Hat, Hat1DetailName);
    LineCnt1:=0;
    WHILE OCCURE(tmp1T) DO
     IF (tmp1T.WrkTim > 0) | (tmp1T.FullRun > 0) THEN
      IF (LineCnt1 = 0) | ~!SubGrp1 THEN
       MAKEPART(R, Delimiter_DblLine);
      END;
      INC(LineCnt1);
      _MakeLine("tmp1T");
      SELECT(tmp1, GrpStr, , tmp1T.VCor, tmp1T.Grp);
      LineCnt2:=0;
      WHILE OCCURE(tmp1) DO
       IF (tmp1.WrkTim > 0) | (tmp1.FullRun > 0) THEN
        IF (LineCnt2 = 0) | ~!aSubGrp1 THEN
         MAKEPART(R, Delimiter_Tilda);
        END;
        INC(LineCnt2);
        _MakeLine("tmp1");
        SELECT(tmp1a, GrpStr, , tmp1.VCor, tmp1.Grp, tmp1.SubGrp);
        LineCnt3:=0;
        WHILE OCCURE(tmp1a) DO
         IF (tmp1a.WrkTim > 0) | (tmp1a.FullRun > 0) THEN
          IF (LineCnt3 = 0) THEN
           MAKEPART(R, Delimiter_Line);
          END;
          INC(LineCnt3);
          _MakeLine("tmp1a");
         END;
         NEXT(tmp1a);
        END; (* WHILE OCCURE(tmp1a) ... *)
       END;
       NEXT(tmp1);
      END; (* WHILE OCCURE(tmp1) ... *)
     END;
     NEXT(tmp1T);
    END; (* WHILE OCCURE(tmp1T) ... *)
    MAKEPART(R, Delimiter_DblLine);
    MAKEPART(R, Line, "⮣", _GoodTrips, _WrkTim, _FullRun, _RunPass,
                               _ZeroRun);
    RESTORE(tmp1T);
 
    SELECT(tmp2T, GrpStr, , tmp1T.VCor);
    MAKEPART(R, Delimiter_Plus);
    MAKEPART(R, Hat, Hat2DetailName);
    LineCnt1:=0;
    WHILE OCCURE(tmp2T) DO
     IF tmp2T.WrkTim > 0 THEN
      IF (LineCnt1 = 0) | ~!SubGrp2 THEN
       MAKEPART(R, Delimiter_DblLine);
      END;
      INC(LineCnt1);
      _MakeLine("tmp2T");
      SELECT(tmp2, GrpStr, , tmp1T.VCor, tmp2T.Grp);
      LineCnt2:=0;
      WHILE OCCURE(tmp2) DO
       IF (LineCnt2 = 0) | ~!aSubGrp2 THEN
        MAKEPART(R, Delimiter_Tilda);
       END;
       INC(LineCnt2);
       _MakeLine("tmp2");
       SELECT(tmp2a, GrpStr, , tmp1T.VCor, tmp2.Grp, tmp2.SubGrp);
       LineCnt3:=0;
       WHILE OCCURE(tmp2a) DO
        IF (LineCnt3 = 0) THEN
         MAKEPART(R, Delimiter_Line);
        END;
        INC(LineCnt3);
        _MakeLine("tmp2a");
        NEXT(tmp2a);
       END; (* WHILE OCCURE(tmp2a) ... *)
       NEXT(tmp2);
      END; (* WHILE OCCURE(tmp2) ... *)
     END;
     NEXT(tmp2T);
    END; (* WHILE OCCURE(tmp2T) ... *)
   END;
   LAST(tmp1T);
   CHANGESEL(tmp1T, GrpStr);
   NEXT(tmp1T);
  END; (* WHILE OCCURE(tmp1T) ... *)

  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("tmp1a");
  L_AFM.AF_PurgeTemp("tmp1");
  L_AFM.AF_PurgeTemp("tmp1T");
  L_AFM.AF_PurgeTemp("tmp2a");
  L_AFM.AF_PurgeTemp("tmp2");
  L_AFM.AF_PurgeTemp("tmp2T");
  D_TP.PurgeTP();
 END {MakeRep};

BEGIN
 IF    (MODE = 100) THEN
  SELECT(Route, Route);
  MakeRep("FrRDO", "", "", "ઠ", PROCREF(AllExits),
          PROCREF(Grp_Route),     PROCREF(Grp_Route),
          PROCREF(Grp_MarkG),     PROCREF(Grp_MarkGName),
          L_General.EMPTY_PROC(), L_General.EMPTY_PROC(),
          PROCREF(Grp_MarkG),     PROCREF(Grp_MarkGName),
          PROCREF(Grp_Route),     PROCREF(Grp_Route),
          L_General.EMPTY_PROC(), L_General.EMPTY_PROC());
 ELSIF (MODE = 101) THEN
  L_General.Assert(ACCESS(Route), " ⠭ ");
  SELECT(Route, Route, , Route.Route);
  MakeRep("FRDOx", " " + Route.Route + " " + Route.Name,
          "䨪.", "ઠ",    PROCREF(AllExits),
          PROCREF(Grp_Modif),     PROCREF(Grp_Modif),
          PROCREF(Grp_MarkG),     PROCREF(Grp_MarkGName),
          L_General.EMPTY_PROC(), L_General.EMPTY_PROC(),
          PROCREF(Grp_MarkG),     PROCREF(Grp_MarkGName),
          PROCREF(Grp_BoxNbr),    PROCREF(Grp_BoxNbrStr),
          L_General.EMPTY_PROC(), L_General.EMPTY_PROC());
 ELSIF (MODE = 102) THEN
  SELECT(Route, Route);
  MakeRep("FrRDO", "", "", "ઠ", PROCREF(AllExits),
          PROCREF(Grp_Route),     PROCREF(Grp_Route),
          L_General.EMPTY_PROC(), L_General.EMPTY_PROC(),
          L_General.EMPTY_PROC(), L_General.EMPTY_PROC(),
          PROCREF(Grp_MarkG),     PROCREF(Grp_MarkGName),
          PROCREF(Grp_Route),     PROCREF(Grp_Route),
          L_General.EMPTY_PROC(), L_General.EMPTY_PROC());
 ELSIF (MODE = 103) THEN
  SELECT(Route, Route);
  MakeRep("FRDOa", "(  ⥫ 室)",
          "", "ઠ", PROCREF(E_NeedExit),
          PROCREF(Grp_Route),  PROCREF(Grp_Route),
          PROCREF(Grp_MarkG),  PROCREF(Grp_MarkGName),
          PROCREF(Grp_BoxNbr), PROCREF(Grp_BoxNbrStr),
          PROCREF(Grp_MarkG),  PROCREF(Grp_MarkGName),
          PROCREF(Grp_Route),  PROCREF(Grp_Route),
          L_General.EMPTY_PROC(), L_General.EMPTY_PROC());
 ELSE
  L_General.BadMode(MODE);
 END;
END.
