(*
%Copyright   (c) Polak IT
%Author      05.05.2003 17:02:48 POLAK\SAN
%Purpose       
%Type        library
%Specific    AP
%Modified    10.09.2014 10:57:10 POLAK\Bor
%Environment
*)

 MODULE L_TRS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tTckSeries          = STRING[12];
  tTckNumber          = SCAL[1E8];
  tTckAmount          = SCAL[1E4];
  tTckPsg             = SCAL[1E4];
  tTckRcDType         = SCAL[6];
  tTckRcCType         = SCAL[4];
  tImpLevel           = SCAL[4];
  tPackedTck          = STRING[];
  tTckState           = SCAL[4];
  tBagState           = SCAL[2];
  tTckKindType        = SCAL[9];
  tNumbersDir         = SCAL[3];
  tAcceptSummaryStage = SCAL[3];
  tOBK02Sum           = NUMERIC[6];
  tTckRcDSaleType     = SCAL[4];

 PUBLIC CONST
  trdt_Laying     = 0;
  trdt_Inventory  = 1;
  trdt_Return     = 2;
  trdt_Sale       = 3;
  trdt_Pool    = "|ਧ||த";
  trdt_Pool_SH = "|||";

  trsStat_Ordered = 0;
  trsStat_Given   = 1;
  trsStat_Taken   = 2;
  trsStat_Rated   = 3;
  trsStat_Pool = "殮|뤠|ਭ|஢";

  trcStat_Prepared = 0; (*TckRcC.Status*)
  trcStat_Passed   = 1;
  trcStat_Canceled = 2;

  trdStat_Prepared = 0; (*TckRcD.Status*)
  trdStat_Passed   = 1;
  trdStat_Canceled = 2;
  trdStat_Pool = "⮢|஢|㫨஢";

  il_None    = 0;
  il_woBeg   = 1;
  il_offLine = 2;
  il_Full    = 3;

  trct_CashAccept      = 0;
  trct_DeficitAct      = 1;
  trct_SurPlusAct      = 2;
  trct_TckWriteOffLack = 3;
  trct_Pool    = "ਥ |  |  誥|  ᯨᠭ ";
  trct_Pool_SH = "|||";

  tkt_Ticket           = 0; (*TckKind.Type*)
  tkt_PieceTck         = 1;
  tkt_KKMActivities    = 2;
  tkt_OutsideSales     = 3;
  tkt_VLDActivities    = 4;
  tkt_EasySales        = 5;
  tkt_ZonalTicket      = 6;
  tkt_PieceTck_wCUC    = 7;
  tkt_BankCardTerminal = 8;
  tkt_Pool = "|筠 | |㦨 த|| த| |筠    ⮬|ନ ਥ ᪨ ";

  tks_Void          = 0; (*TckKind.InSale*)
  tks_Sales         = 1;
  tks_Prepayment    = 2;
  tks_CashlessSales = 3;
  tks_Goods         = 4;
  tks_Pool = "|த|।|  ।|";

  tkc_No       = 0; (*TckKind.InCash*)
  tkc_Cash     = 1;
  tkc_Cashless = 2;

  nd_None = 0;
  nd_Incr = 1;
  nd_Decr = 2;

  ts_New      = 0;
  ts_inBag    = 1;
  ts_Ended    = 2;
  ts_Returned = 3;

  bs_AtTckOffice = 0;
  bs_GivenOut    = 1;

  pid_CashAccept        = "ਥ ";
  pid_AcceptTckRcS      = "ਥ ";
  pid_Laying            = " ";
  pid_Return            = " ";
  pid_NightLaying       = "筠 ";
  pid_AcceptTicketsBack = "ᠭ ";
  pid_EasySales         = " த";
  pid_AcceptTKGroup     = "ਥ 㯯 ";
  pid_Sale              = "த ";
  pid_RollbackTRSAccept = "⬥ ਥ ";

  trdl_Amount = 39;
  trjl_Amount = 14;

  ass_Begining     = 0;
  ass_Intermediate = 1;
  ass_Finishing    = 2;

  sojbet_NotFound  = 0;
  sojbet_Found     = 1;
  sojbet_HasNoJobs = 2;

  trjstm_StartT    = 0; (*TRJStartTMeaning*)
  trjstm_Departure = 1;
  trjstm_StopT     = 2;

  sttt_Pool = " ।⥫||죮|"; (*SnTckTrf.Type*)
  sttt_ToBearer     = 0;
  sttt_FullPrice    = 1;
  sttt_ReducedPrice = 2;
  sttt_Scool        = 3;

  trdst_Retail       = 0; (*tTckRcDSaleType*)
  trdst_Firm         = 1;
  trdst_Staff        = 2;
  trdst_Distribution = 3;

  tk_MscSocTP        = 0799; (*樠쭠  , 죮*)
  tk_MscRegionSoc    = 0800; (*樠쭠  , 죮*)
  tk_MscSoc          = 0801; (*樠쭠  , 죮*)
  tk_MscSocTmp       = 0802; (*६  樠 , 죮*)
  tk_MscRegionSocTmp = 0813; (*६  樠 , 죮*)
  tk_OneTripInOffice = 0803; (*  த  *)
  tk_OneTripInBus    = 0804; (*  த  ᠫ*)
  tk_TKDD            = 0814; (* ६ ⢨ *)

 IMPORT L_General, Math, E_Way, Str, L_XDoc, L_Str, L_BarCode, L_Stock,
        L_FIO, L_RWayS, L_CI, L_DatTim, L_Way, P_Math, L_StdFrm, L_Env,
        L_Staff, L_Events, Memo, L_AFM, L_lsStore, P_OwnData, L_EC, E_TRS, P_Firm,
        FIO, P_Car, L_CUC, L_Car, L_BegRWS, L_two, P_CUC, L_AR, L_SysLog, L_APtm,
        L_AcsPnt, L_Prop;

 PUBLIC PERMANENT VAR
  s_TB_RAmount: tTckNumber[trdl_Amount];
  s_TB_RPsg   : tTckPsg   [trdl_Amount];

  s_ES_TckKind: LIKE(TckKind.TckKind)[trdl_Amount];
  s_ES_Amount : tTckNumber           [trdl_Amount];
  s_ES_Psg    : tTckPsg              [trdl_Amount];

  TckRcD2Accept,
  TckRcD2DeviceReturn: LIKE(TckRcD.TckRcD);
  TRDLNbr2Accept     : LIKE(TckRcDL.TRDLNbr);

 PRIVATE PROCEDURE IsMainTckCashier(): SCAL[2];
 BEGIN
  RETURN L_AR.IsManagerOfGroupN(L_APtm.g_TckCashier) | L_General.IsAdmin();
 END {IsMainTckCashier};

 PUBLIC PROCEDURE IsMainTckKind(_TckKind: LIKE(TckKind.TckKind); D: DATE; _Route: LIKE(Route.Route)): SCAL[2];
  VAR
   OD_MainTckKind: STRING[];
   MainTckKind   : LIKE(TckKind.TckKind);
   Idx           : NUMERIC[0];
   default       : SCAL[2];
   Local         : PROC;
 BEGIN
  L_General.CallUs(SEARCH(TckKind, TckKind, _TckKind));
  default:=P_OwnData.IsMainTckKind(_TckKind, D);

  Local:=PROCREF(E_TRS.IsMainTckKind);
  IF ~!Local THEN
   default:=Local(default, _TckKind, D, _Route);
  END;
  RETURN default;
 END {IsMainTckKind};

 PUBLIC PROCEDURE IsDevice(trgType: tTckKindType): SCAL[2];
 BEGIN
  RETURN (trgType = tkt_KKMActivities) | (trgType = tkt_VLDActivities) | (trgType = tkt_BankCardTerminal);
 END {IsDevice};

 PUBLIC PROCEDURE StandOnNextJob(): SCAL[2];
 BEGIN
  RETURN CHANGESEL(TckRcJ, TckRcS, TckRcJ.TckRcS) & NEXT(TckRcJ);
 END {StandOnNextJob};

 PUBLIC PROCEDURE IsLastJob(): SCAL[2];
  VAR
   ItIs: SCAL[2];
 BEGIN
  SAVE(TckRcJ);
  ItIs:=~StandOnNextJob();
  RESTORE(TckRcJ);
  RETURN ItIs;
 END {IsLastJob};

 PUBLIC PROCEDURE IsFirstJob(): SCAL[2];
  VAR
   ItIs: SCAL[2];
 BEGIN
  SAVE(TckRcJ);
  ItIs:=~StandOnPrevJob();
  RESTORE(TckRcJ);
  RETURN ItIs;
 END {IsFirstJob};

 PUBLIC PROCEDURE StandOnPrevJob(): SCAL[2];
 BEGIN
  RETURN CHANGESEL(TckRcJ, TckRcS, TckRcJ.TckRcS) & PREV(TckRcJ);
 END {StandOnPrevJob};

 PRIVATE PROCEDURE Is55ChopperKKM(): SCAL[2];
 BEGIN
  RETURN (L_General.GetAPSiteID() = "55") & OCCURE(TckRcS) & (TckRcS.AsWho = L_Way.trs_Chopper) &
         (TckKind.Type = tkt_KKMActivities) & (TckKind.InSale > tks_Void);
 END {Is55ChopperKKM};

 PUBLIC PROCEDURE E_SpecialTckRcTCheck(): SCAL[2];
  VAR
   _TckAmnt, _TckPsg, _TckRAmnt, _TckRPsg: NUMERIC[0];
 BEGIN
  IF Is55ChopperKKM() THEN
   SETZERO(_TckAmnt, _TckPsg, _TckRAmnt, _TckRPsg);
   SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
   WHILE OCCURE(TckRcJ) DO
    INC(_TckAmnt,  TckRcJ.TckNbrs[TckRcT.Number-1]);
    INC(_TckPsg,   TckRcJ.TckPsg[TckRcT.Number-1]);
    INC(_TckRAmnt, TckRcJ.TckRAmnt[TckRcT.Number-1]);
    INC(_TckRPsg,  TckRcJ.TckRPsg[TckRcT.Number-1]);
    NEXT(TckRcJ);
   END; (* WHILE OCCURE(TckRcJ) ... *)

   L_General.Assert((TckRcT.BefNbr + _TckAmnt) = TckRcT.AftNbr,
                    " ᮢ     " + TckRcT.Number);
   IF _TckPsg # TckRcT.ExpNum THEN
    L_General.Assert_wReferToAdmin(0, " ᮢ ⢮ ᠦ஢    " + TckRcT.Number);
    L_StdFrm.CrucialChoice(" ᮢ ⢮ ᠦ஢    " + TckRcT.Number +
                           "||ࠢ쭮 ⢮ ᠦ஢ "+L_Str.IntStr(_TckPsg), L_APtm.g_RWOp);
   END;
   L_General.Assert(TckRcT.RNum = _TckRPsg,
                    " ᮢ ⢮ ᠦ஢  ᯨᠭ   " + TckRcT.Number);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {E_SpecialTckRcTCheck};

 PUBLIC PROCEDURE NumbersDir(): tNumbersDir;
 BEGIN
  IF Is55ChopperKKM() THEN
   RETURN nd_None;
  END;
  RETURN TckKind.NbrsDir;
 END {NumbersDir};

 PUBLIC PROCEDURE ResetNumbersAtTaxing(): SCAL[2];
 BEGIN
  IF    TckKind.Type = tkt_KKMActivities THEN
   L_General.Assert(TckKind.NbrsDir = nd_Incr,
                    "ࠪ  ஢  |  '稢'");
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {ResetNumbersAtTaxing};

 PUBLIC PROCEDURE IsEasySalesTck(): SCAL[2];
 BEGIN
  RETURN TckKind.Type = tkt_EasySales;
 END {IsEasySalesTck};

 PUBLIC PROCEDURE IsCashWithoutSale(): SCAL[2];
 BEGIN
(* . 0076341
  RETURN (TckKind.Type = tkt_KKMActivities) & (TckKind.InSale = tks_Void);
*)
  RETURN (TckKind.InSale = tks_Void) & (TckKind.InCash # tkc_No);
 END {IsCashWithoutSale};

 PUBLIC PROCEDURE IsSpecialNoSaleTckKind(): SCAL[2];
 BEGIN
  RETURN (TckKind.Type = tkt_VLDActivities) | IsCashWithoutSale();
 END {IsSpecialNoSaleTckKind};

 PUBLIC PROCEDURE E_TckRcJTckNbrIsAmountOnTrip(): SCAL[2];
 BEGIN
  RETURN (NumbersDir() = nd_None) |
         (TckKind.Type = tkt_KKMActivities) & (L_General.GetAPSiteID() = "84") & (TckRcS.Date >= 01\12\2009);
 END {E_TckRcJTckNbrIsAmountOnTrip};

 PUBLIC PROCEDURE GetPrvJobInfo(VAR _TckNbrs : LIKE(TckRcJ.TckNbrs);
                                VAR _TckPsg  : LIKE(TckRcJ.TckPsg));
  VAR
   _Route: LIKE(TckRcJ.Route);
 BEGIN
  _Route:=TckRcJ.Route;
  SAVE(TckRcJ);
  SAVE(TckRcT);
  IF StandOnPrevJob() THEN
   _TckNbrs :=TckRcJ.TckNbrs;
   _TckPsg  :=TckRcJ.TckPsg;
  ELSE
   SETEMPTY(_TckNbrs, _TckPsg);
  END;

  CONFORM(TckRcS, TckRcT);
  WHILE OCCURE(TckRcT) DO
   CONFORM(TckRcT, TckKind);
   IF ~!TckRcT.Number THEN
    IF TckKind.Type = tkt_VLDActivities THEN
     SETEMPTY(_TckNbrs[TckRcT.Number-1]);
    ELSIF E_TckRcJTckNbrIsAmountOnTrip() THEN
     _TckNbrs[TckRcT.Number-1]:=0;
    ELSIF !_TckNbrs[TckRcT.Number-1] THEN
     IF ResetNumbersAtTaxing() THEN
      _TckNbrs[TckRcT.Number-1]:=0;
     ELSE
      _TckNbrs[TckRcT.Number-1]:=TckRcT.BefNbr;
     END;
    END;
    IF IsMainTckKind(TckKind.TckKind, TckRcS.Date, _Route) |
       TckKind_wPsg() & (!_TckPsg[TckRcT.Number-1] | E_TckRcJTckNbrIsAmountOnTrip()) THEN
     _TckPsg[TckRcT.Number-1]:=0;
    END;
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)
  RESTORE(TckRcT);
  RESTORE(TckRcJ);
 END {GetPrvJobInfo};

 PUBLIC PROCEDURE GetPrvNbrs(): LIKE(TckRcJ.TckNbrs);
  VAR
   _TckNbrs : LIKE(TckRcJ.TckNbrs);
   _TckPsg  : LIKE(TckRcJ.TckPsg);
 BEGIN
  GetPrvJobInfo(_TckNbrs, _TckPsg);
  RETURN _TckNbrs;
 END {GetPrvNbrs};

 PUBLIC PROCEDURE PackFirstNbr(_TckKind: LIKE(TckKind.TckKind); _Nbr: tTckNumber): tTckNumber;
  VAR
   Result: tTckNumber;
 BEGIN
  SAVE(TckKind);
  L_General.CallUs(SEARCH(TckKind, TckKind, _TckKind));
  IF TckKind.Type = tkt_Ticket THEN
   IF    NumbersDir() = nd_Incr THEN
    Result:=(_Nbr - TckKind.FstInPck) DIV TckKind.PckVol * TckKind.PckVol + TckKind.FstInPck;
   ELSIF NumbersDir() = nd_Decr THEN
    L_General.CallUs(0);
   ELSE
    L_General.Error("୮  ᠭ ' ஥ 㬥' " + TckKind.TckKind);
   END;
  ELSIF IsBulk() THEN
    Result:=_Nbr;
  ELSE
   SETEMPTY(Result);
  END;
  RESTORE(TckKind);
  RETURN Result;
 END {PackFirstNbr};

 PUBLIC PROCEDURE PackLastNbr(_TckKind: LIKE(TckKind.TckKind); _Nbr: tTckNumber): tTckNumber;
  VAR
   Result: tTckNumber;
 BEGIN
  SAVE(TckKind);
  L_General.CallUs(SEARCH(TckKind, TckKind, _TckKind));
  IF TckKind.Type = tkt_Ticket THEN
   IF    NumbersDir() = nd_Incr THEN
    Result:=(_Nbr - TckKind.FstInPck) DIV TckKind.PckVol * TckKind.PckVol + TckKind.PckVol + TckKind.FstInPck;
   ELSIF NumbersDir() = nd_Decr THEN
    L_General.CallUs(0);
   ELSE
    L_General.Error("୮  ᠭ ' ஥ 㬥' " + TckKind.TckKind);
   END;
  ELSIF IsBulk() THEN
   Result:=0;
  ELSE
   SETEMPTY(Result);
  END;
  RESTORE(TckKind);
  RETURN Result;
 END {PackLastNbr};

 PRIVATE PROCEDURE cnc_Assert(cond: SCAL[2]; curNbr, prvNbr: tTckNumber; msg: STRING[]);
 BEGIN
  IF ~cond THEN
   L_General.Error(msg + "||" + TckKind.Name +
                   "|:            " + FLDTOSTR(curNbr, GetNbrFormat(curNbr), 8, "R") +
                   "|।騩 : " + FLDTOSTR(prvNbr, GetNbrFormat(prvNbr), 8, "R"));
  END;
 END {cnc_Assert};

 PRIVATE PROCEDURE CheckNbrsConsecution(curNbr, prvNbr: tTckNumber);
 BEGIN
  IF NumbersDir() # nd_None THEN
   IF NumbersDir() = nd_Incr THEN
    cnc_Assert(curNbr >= prvNbr, curNbr, prvNbr, "     ।饣");
    cnc_Assert(curNbr <= PackLastNbr(TckKind.TckKind, prvNbr), curNbr, prvNbr, " ௠");
   ELSE
    cnc_Assert(curNbr <= prvNbr, curNbr, prvNbr, "     ।饣");
    cnc_Assert(curNbr >= PackLastNbr(TckKind.TckKind, prvNbr), curNbr, prvNbr, " ௠");
   END;
  END;
 END {CheckNbrsConsecution};

 PUBLIC PROCEDURE TckKind_wPsg(): SCAL[2];
 BEGIN
  RETURN TckKind.wPsg;
 END {TckKind_wPsg};

 PUBLIC PROCEDURE Calc2NumbersDifference(    _TckKind: LIKE(TckKind.TckKind);
                                             _prvNbr,
                                             _curNbr : tTckNumber;
                                         VAR Amount  : NUMERIC[0];
                                         VAR Sum     : NUMERIC[2]);
  VAR
   _Sum: NUMERIC[2];
 BEGIN
  L_General.CallUs(SEARCH(TckKind, TckKind, _TckKind));
  IF TckKind.Type # tkt_VLDActivities THEN
   IF (TckKind.Type = tkt_KKMActivities) & (NumbersDir() = nd_Incr) & (_curNbr < _prvNbr) THEN
    Amount:=_curNbr + Math.Pow(10, TckKind.NbrPrc) - _prvNbr;
   ELSE
    CheckNbrsConsecution(_curNbr, _prvNbr);
    Amount:=Math.Abs(_curNbr - _prvNbr);
   END;
   IF IsBulk_wCUC() THEN
    _Sum:=Amount;
   ELSE
    _Sum:=Amount*TckKind.FaceVal;
   END;
   L_General.Assert(_Sum <= MAXOF(TckRcT.ExpSum),
                    "  " + TckKind.TckKind + " " + TckKind.Name + ":" +
                    "|ࠢ 孨  " + _curNbr +
                    " (窠 " + L_Str.IntStr(_Sum) + " ?)");
   Sum:=_Sum;
  ELSE
   SETZERO(Amount, Sum);
  END;
 END {Calc2NumbersDifference};

 PRIVATE PROCEDURE prwjp_Add(VAR _RWJPro  : LIKE(RWJPro.RWJPro)[];
                             VAR _Value   : LIKE(RWayJP.Value)[];
                                 curRWJPro: LIKE(RWayJP.RWJPro);
                                 curValue : LIKE(RWayJP.Value));
  VAR
   i: NUMERIC[0];
 BEGIN
  L_General.CallUs(curValue # 0);
  L_General.CallUs(~!curRWJPro);
  i:=0;
  WHILE ~!_RWJPro[i] & (_RWJPro[i] # curRWJPro) DO
   INC(i);
  END;
  IF !_RWJPro[i] THEN
   _RWJPro[i]:=curRWJPro;
  END;
  INC(_Value[i], curValue);
 END {prwjp_Add};

 PUBLIC PROCEDURE E_NeedAutoTaxTckRcJR(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_TRS.NeedAutoTaxTckRcJR), 0);
 END {E_NeedAutoTaxTckRcJR};

 PUBLIC PROCEDURE E_MakeVldPsgRWJP(D: DATE; trgTckKind: LIKE(TckKind.TckKind)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_TRS.MakeVldPsgRWJP);
  IF ~!Local THEN
   RETURN Local(D, trgTckKind);
  ELSIF D >= 01\11\2013 THEN
   RETURN trgTckKind # tk_OneTripInBus;
  ELSE
   RETURN 1;
  END;
 END {E_MakeVldPsgRWJP};

 PRIVATE PROCEDURE E_GetRWJProForAmount(D       : DATE;
                                        _TckKind: LIKE(TckKind.TckKind);
                                        _Who    : LIKE(TckRcS.AsWho);
                                        _Number : LIKE(WayLMen.Number)): LIKE(RWJPro.RWJPro);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.TckRcS_GetRWJProForAmount);
  IF ~!Local THEN
   RETURN Local(D, _TckKind, _Who, _Number);
  ELSE
   RETURN EMPTYOF(RWJPro.RWJPro);
  END;
 END {E_GetRWJProForAmount};

 PRIVATE PROCEDURE E_GetRWJProForBefNbr(D       : DATE;
                                        _TckKind: LIKE(TckKind.TckKind);
                                        _Who    : LIKE(TckRcS.AsWho);
                                        _Number : LIKE(WayLMen.Number)): LIKE(RWJPro.RWJPro);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.TckRcS_GetRWJProForBefNbr);
  IF ~!Local THEN
   RETURN Local(D, _TckKind, _Who, _Number);
  ELSE
   RETURN EMPTYOF(RWJPro.RWJPro);
  END;
 END {E_GetRWJProForBefNbr};

 PRIVATE PROCEDURE GetTRJBulkAmount(trgTckRcT: LIKE(TckRcT.TckRcT)): NUMERIC[0];
  VAR
   Cnt: NUMERIC[0];
 BEGIN
  Cnt:=0;
  SELECT(TckRcD, TckRcS, , TckRcJ.TckRcS);
  WHILE OCCURE(TckRcD) DO
   IF (TckRcD.Type # trdt_Laying) & SEARCH(TckRcDL, TckRcD, TckRcD.TckRcD, trgTckRcT) THEN
    CONFORM(TckRcDL, TckRcDLL);
    WHILE OCCURE(TckRcDLL) DO
     INC(Cnt, (TckRcDLL.Day = TckRcJ.Day) & (TckRcDLL.Time = TckRcJ.StartT) & ~!TckRcDLL.Sum);
     NEXT(TckRcDLL);
    END; (* WHILE OCCURE(TckRcDLL) ... *)
   END;
   NEXT(TckRcD);
  END; (* WHILE OCCURE(TckRcD) ... *)
  RETURN Cnt;
 END {GetTRJBulkAmount};

 PUBLIC PROCEDURE PrepareRWayJP(    _Number: LIKE(WayLMen.Number);
                                VAR _RWJPro: LIKE(RWJPro.RWJPro)[];
                                VAR _Value : LIKE(RWayJP.Value)[]);
  VAR
   _prvNbrs : LIKE(TckRcJ.TckNbrs);
   _prvPsg  : LIKE(TckRcJ.TckPsg);
   Amount   : NUMERIC[0];
   curRWJPro: LIKE(RWayJP.RWJPro);
   curValue : LIKE(RWayJP.Value);
   _Who     : L_Way.tRWSWho;
 BEGIN
  SETEMPTY(_RWJPro);
  SETZERO(_Value);
  GetPrvJobInfo(_prvNbrs, _prvPsg);
  SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcT) DO
   CONFORM(TckRcT, TckKind);
   IF ~!TckRcT.Number & ~IsSpecialNoSaleTckKind() & (TckKind.InSale # tks_Goods) THEN
    Calc2NumbersDifference(TckRcT.TckKind, _prvNbrs[TckRcT.Number-1], TckRcJ.TckNbrs[TckRcT.Number-1],
                           Amount, curValue);
(*
    IF IsBulk_wCUC() THEN
     Amount:=GetTRJBulkAmount(TckRcT.TckRcT);
    ELSE
*)
     Amount  :=Amount - TckRcJ.TckRAmnt[TckRcT.Number-1];
(*
    END;
*)
    Amount  :=Amount - TckRcJ.TckRAmnt[TckRcT.Number-1];
    IF TckKind.Type = tkt_ZonalTicket THEN
     curValue:=curValue - TckRcJ.TckRAmnt[TckRcT.Number-1];
    ELSE
     curValue:=curValue - TckRcJ.TckRAmnt[TckRcT.Number-1] * TckKind.FaceVal;
    END;
    IF curValue # 0 THEN
     prwjp_Add(_RWJPro, _Value,
               E_Way.TckRcS_GetRWJProForIncome(TckRcS.Date, TckRcT.TckKind, TckRcS.AsWho, _Number), curValue);
    END;
    IF Amount # 0 THEN
     curRWJPro:=E_GetRWJProForAmount(TckRcS.Date, TckRcT.TckKind, TckRcS.AsWho, _Number);
     IF ~!curRWJPro THEN
      IF IsBulk_wCUC() THEN
       Amount:=GetTRJBulkAmount(TckRcT.TckRcT);
         (* ࠢ쭮   (  ஢),   ண,
            ⮬ ⠥ ⮫쪮 ᫨  ⢨⥫쭮 㦭 *)
      END;
      prwjp_Add(_RWJPro, _Value, curRWJPro, Amount);
     END;
    END;

    IF IsMainTckKind(TckKind.TckKind, TckRcS.Date, TckRcJ.Route) | TckKind_wPsg() THEN
     curValue:=TckRcJ.TckPsg[TckRcT.Number-1] - _prvPsg[TckRcT.Number-1] - TckRcJ.TckRPsg[TckRcT.Number-1];
     IF curValue # 0 THEN
      prwjp_Add(_RWJPro, _Value,
                E_Way.TckRcS_GetRWJProForPsg(TckRcS.Date, TckRcT.TckKind, TckRcS.AsWho, _Number), curValue);
     END;
    END;
   END;
   curRWJPro:=E_GetRWJProForBefNbr(TckRcS.Date, TckRcT.TckKind, TckRcS.AsWho, _Number);
   IF ~!curRWJPro & (TckRcT.BefNbr # 0) THEN
    prwjp_Add(_RWJPro, _Value, curRWJPro, TckRcT.BefNbr);
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) ... *)

  CONFORM(TckRcJ, TckRcJR);
  WHILE OCCURE(TckRcJR) DO
   IF TckRcS.AsWho = L_Way.trs_Chopper THEN
    _Who:=L_Way.rwswho_Chopper;
   ELSE
    _Who:=TckRcS.AsWho;
   END;
   IF E_MakeVldPsgRWJP(TckRcS.Date, TckRcJR.TckKind) & (TckRcJR.Psg # 0) THEN
    prwjp_Add(_RWJPro, _Value,
              L_Way.GetVldPsgRWJPro(VldPsgKindOfTckKind(TckRcJR.TckKind), _Who, _Number), TckRcJR.Psg);
   END;
   NEXT(TckRcJR);
  END; (* WHILE OCCURE(TckRcJR) ... *)
 END {PrepareRWayJP};

 PUBLIC PROCEDURE EndOfPack(): tTckNumber;
 BEGIN
  IF    TckKind.Type = tkt_PieceTck THEN
   RETURN 0;
  ELSIF TckKind.Type = tkt_BankCardTerminal THEN
   RETURN MAXOF(TckRcT.AftNbr);
  ELSIF TckKind.Type = tkt_KKMActivities THEN
   RETURN MAXOF(TckRcT.AftNbr);
  END;
  L_General.CallUs(NumbersDir() # nd_None);
  IF NumbersDir() = nd_Incr THEN
   RETURN (TckRcT.BefNbr - TckKind.FstInPck) DIV TckKind.PckVol * TckKind.PckVol +
          TckKind.PckVol + TckKind.FstInPck;
  ELSE
   IF TckKind.FstInPck = 0 THEN
    RETURN (TckRcT.BefNbr - 1) DIV TckKind.PckVol * TckKind.PckVol;
   ELSE
    RETURN TckRcT.BefNbr DIV TckKind.PckVol * TckKind.PckVol -
           TckKind.PckVol + TckKind.FstInPck;
   END;
  END;
 END {EndOfPack};

 PUBLIC PROCEDURE GetNbrFactLength(_Nbr: tTckNumber): NUMERIC[0];
 BEGIN
  RETURN Str.Length(FLDTOSTR(_Nbr, "N", 0));
 END {GetNbrFactLength};

 PUBLIC PROCEDURE GetNbrFormat(_Nbr: tTckNumber): STRING[];
  CONST
   maxNbrPrc = 8 (* sic! *);
  VAR
   Result: STRING[];
 BEGIN
  IF (NumbersDir() = nd_None) | ResetNumbersAtTaxing() THEN
   Result:="N";
  ELSE
   L_General.Assert(TckKind.NbrPrc <= maxNbrPrc,
                    "來 ॢ蠥 ᨬ "+L_Str.IntStr(maxNbrPrc)+"|  "+TckKind.TckKind+" "+TckKind.Name);
   L_General.Assert(GetNbrFactLength(_Nbr) <= TckKind.NbrPrc,
                    "來   ॢ蠥 "+L_Str.IntStr(TckKind.NbrPrc)+"|  "+TckKind.TckKind+" "+TckKind.Name);
   Result:=Str.Slice("        ", 0, maxNbrPrc-TckKind.NbrPrc) +
           Str.Slice("00000000", 0,           TckKind.NbrPrc) ;
  END;
  RETURN Result;
 END {GetNbrFormat};

 PUBLIC PROCEDURE IsSaleTckRcD(trdType: tTckRcDType): SCAL[2];
 BEGIN
  RETURN (trdType = trdt_Sale);
 END {IsSaleTckRcD};

 PUBLIC PROCEDURE TckRcDSaleType(): tTckRcDSaleType;
 BEGIN
  IF     !TckRcD.Firm &  !TckRcD.TSN THEN RETURN trdst_Retail;
  ELSIF  !TckRcD.Firm & ~!TckRcD.TSN THEN RETURN trdst_Staff;
  ELSIF ~!TckRcD.Firm &  !TckRcD.TSN THEN RETURN trdst_Firm;
  ELSIF ~!TckRcD.Firm & ~!TckRcD.TSN THEN RETURN trdst_Distribution;
  ELSE
   L_General.CallUs(0);
  END;
 END {TckRcDSaleType};

 PUBLIC PROCEDURE trdl_ia_Set(    trdType    : tTckRcDType;
                                  tckKind    : LIKE(TckKind.TckKind);
                              VAR ia_TckKind,
                                  ia_Series,
                                  ia_RestNbr,
                                  ia_Psg     : SCAL[2];
                              VAR nbrFormat  : STRING[]);
 BEGIN
  ia_TckKind:=(trdType = trdt_Laying) | IsSaleTckRcD(trdType);
  ia_Series :=(trdType = trdt_Laying) | IsSaleTckRcD(trdType);
  ia_RestNbr:=1;
  ia_Psg    :=(trdType = trdt_Inventory) | (trdType = trdt_Return);
  IF ~!tckKind THEN
   L_General.CallUs(SEARCH(TckKind, TckKind, tckKind));

   IF ia_TckKind THEN
    ia_TckKind:=~IsDevice(TckKind.Type);
   END;
   IF ia_Series THEN
    ia_Series :=TckKind.Type = tkt_Ticket;
   END;
   IF    IsSaleTckRcD(trdType) THEN
    ia_RestNbr:=TckKind.Type = tkt_EasySales;
    ia_Psg    :=(TckKind.Type = tkt_EasySales) | (TckKind.Type = tkt_PieceTck);
   ELSE
    ia_RestNbr:=(trdType = trdt_Inventory) | (trdType = trdt_Return) | ~IsBulk_wCUC() & (TckKind.NbrsDir # nd_None);
    ia_Psg    :=ia_Psg & TckKind_wPsg();
   END;
   nbrFormat  :=GetNbrFormat(EMPTYOF(tTckNumber));
  ELSE
   nbrFormat:="N";
  END;
 END {trdl_ia_Set};

 PUBLIC PROCEDURE CompleteNumber(VAR curNbr: tTckNumber; prvNbr: tTckNumber);
  VAR
   l: NUMERIC[0];
 BEGIN
  IF NumbersDir() # nd_None THEN
   IF NumbersDir() = nd_Incr THEN
    l:=GetNbrFactLength(curNbr);
    IF (l <= TckKind.NbrPrc) THEN
     INC(curNbr, prvNbr DIV Math.Pow(10, l) * Math.Pow(10, l));
    END;
   ELSE
    L_General.CallUs(TckKind.Type # tkt_Ticket);
    l:=Math.Max(GetNbrFactLength(TckKind.PckVol-1), GetNbrFactLength(curNbr));
   END;
   CheckNbrsConsecution(curNbr, prvNbr);
  END;
 END {CompleteNumber};

 PRIVATE PROCEDURE AccessLastTckRcDL(atTckRcDL: SCAL[2]; trgCUCopy: LIKE(TckRcDL.CUCopy)): SCAL[2];
 BEGIN
  IF atTckRcDL THEN
   CHANGESEL(TckRcDL, CUCopy, , TckRcDL.CUCopy, TckRcDL.Status);
   PREV(TckRcDL);
  ELSE
   SELECT(TckRcDL, CUCopy, , trgCUCopy, trdStat_Passed);
   LAST(TckRcDL);
  END;
  RETURN OCCURE(TckRcDL);
 END {AccessLastTckRcDL};

 PRIVATE PROCEDURE AccessLastTckRcDLL(atTckRcDLL: SCAL[2]; trgCUCopy: LIKE(TckRcDL.CUCopy)): SCAL[2];
 BEGIN
  IF atTckRcDLL THEN
   CHANGESEL(TckRcDLL, CUCopy, , TckRcDLL.CUCopy, TckRcDLL.Status);
   PREV(TckRcDLL);
  ELSE
   SELECT(TckRcDLL, CUCopy, , trgCUCopy, trdStat_Passed);
   LAST(TckRcDLL);
  END;
  RETURN OCCURE(TckRcDLL);
 END {AccessLastTckRcDLL};

 PUBLIC PROCEDURE DefineTckState(): tTckState;
 BEGIN
  IF    (TckRcD.Type = trdt_Return) THEN
   RETURN ts_Returned;
  ELSIF (TckRcD.Type = trdt_Laying) | ~!TckRcDL.RestNbr THEN
   RETURN ts_inBag;
  ELSE
   RETURN ts_Ended;
  END;
 END {DefineTckState};

 PUBLIC PROCEDURE getTckLastLocation(    atTckRcDL: SCAL[2];
                                         trgCUCopy: LIKE(TckRcDL.CUCopy);
                                     VAR ts       : tTckState;
                                     VAR _Storage : LIKE(Storage.Storage);
                                     VAR _TckRcS  : LIKE(TckRcS.TckRcS));
 BEGIN
  SETEMPTY(_Storage, _TckRcS);
  SAVE(TckRcD);
  SAVE(TckRcDL);
  SAVE(TckRcDLL);
  IF    (atTckRcDL & (TckRcDL.CUCopy  = trgCUCopy) | ~atTckRcDL) & AccessLastTckRcDL(atTckRcDL, trgCUCopy) THEN
   CONFORM(TckRcDL, TckRcD);
   ts:=DefineTckState();
  ELSIF (atTckRcDL & OCCURE(TckRcDLL) & (TckRcDLL.CUCopy = trgCUCopy) | ~atTckRcDL) & AccessLastTckRcDLL(atTckRcDL, trgCUCopy) THEN
   CONFORM(TckRcDLL, TckRcD);
   IF    ~!TckRcDLL.Sum THEN
    ts:=ts_Ended;
   ELSIF TckRcD.Type = trdt_Return THEN
    ts:=ts_Returned;
   ELSE
    ts:=ts_inBag;
   END;
  ELSE
   ts:=ts_New;
  END;
  IF ts = ts_inBag THEN
   _Storage:=TckRcD.Storage;
   _TckRcS :=TckRcD.TckRcS;
  END;
  RESTORE(TckRcDLL);
  RESTORE(TckRcDL);
  RESTORE(TckRcD);
 END {getTckLastLocation};

 PUBLIC PROCEDURE getTckLastRestNbr(atTckRcDL: SCAL[2]; trgCUCopy: LIKE(TckRcDL.CUCopy)): tTckNumber;
  VAR
   Result: tTckNumber;
   InvTRD: LIKE(TckRcD.TckRcD);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   IF atTckRcDL THEN
    CONFORM(TckRcDL, TckKind);
   END;
   IF    (atTckRcDL & (TckRcDL.CUCopy  = trgCUCopy) | ~atTckRcDL) & AccessLastTckRcDL(atTckRcDL, trgCUCopy) THEN
    CONFORM(TckRcDL, TckKind);
    IF TckKind.Type = tkt_PieceTck THEN
     Result:=0;
     SETEMPTY(InvTRD);
     LOOP
      CONFORM(TckRcDL, TckRcD);
      IF (TckRcD.Type # trdt_Return) & ~!TckRcDL.RestNbr THEN
       INC(Result, TckRcDL.RestNbr);
      END;
      IF TckRcD.Type # trdt_Laying THEN
       EXIT;
      END;
      IF ~AccessLastTckRcDL(1, trgCUCopy) THEN
       EXIT;
      END;
     END;
     IF Result = 0 THEN
      SETEMPTY(Result);
     END;
    ELSIF TckKind.NbrsDir = nd_None THEN
     Result:=0;
    ELSE
     Result:=TckRcDL.RestNbr;
    END;
   ELSIF (atTckRcDL & OCCURE(TckRcDLL) & (TckRcDLL.CUCopy = trgCUCopy) | ~atTckRcDL) & AccessLastTckRcDLL(atTckRcDL, trgCUCopy) THEN
    Result:=TckRcDLL.RestNbr;
   ELSE
    IF ~atTckRcDL THEN
     SEARCH(CUCopy, CUCopy, , trgCUCopy);
     L_General.CallUs(AccessTckKindByMath(CUCopy.Math, GetTRDOnDate()));
    END;
    IF TckKind.NbrsDir = nd_None THEN
     Result:=0;
    ELSE
     SETEMPTY(Result);
    END;
   END;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {getTckLastRestNbr};

 PUBLIC PROCEDURE getBagLastLocation(    trgStorage: LIKE(Storage.Storage);
                                     VAR bs        : tTckState;
                                     VAR trgTckRcS : LIKE(TckRcS.TckRcS));
  VAR
   minStatus: LIKE(TckRcS.Status);
 BEGIN
  SAVE(TckRcS);
  IF SELECT(TckRcS, Storage, trgStorage) & LAST(TckRcS) THEN
   minStatus:=trsStat_Rated;
   CHANGESEL(TckRcS, Storage, , TckRcS.Storage, TckRcS.Date);
   WHILE OCCURE(TckRcS) DO
    IF TckRcS.Status <= minStatus THEN
     minStatus:=TckRcS.Status;
     trgTckRcS:=TckRcS.TckRcS;
     IF TckRcS.Status = trsStat_Given THEN
      bs:=bs_GivenOut;
     ELSE
      bs:=bs_AtTckOffice;
     END;
    END;
    PREV(TckRcS);
   END; (* WHILE OCCURE(TckRcS) *)
  ELSE
   SETEMPTY(trgTckRcS);
   bs:=bs_AtTckOffice;
  END;
  RESTORE(TckRcS);
 END {getBagLastLocation};

 PUBLIC PROCEDURE SupportRestNbrChanging(    atTckRcDL: SCAL[2];
                                             trdt     : tTckRcDType;
                                             trgCUCopy: LIKE(TckRcDL.CUCopy);
                                         VAR RestNbr  : tTckNumber);
  VAR
   PackNbr: tTckNumber;
 BEGIN
  IF ~!RestNbr THEN
   L_General.Assert(TckKind.Type # tkt_VLDActivities, "''  ᥣ   ");
   IF (trdt = trdt_Return) | (trdt = trdt_Inventory) THEN
    L_General.CallUs(~!trgCUCopy);
    PackNbr:=getTckLastRestNbr(atTckRcDL, trgCUCopy);
    L_General.CallUs(~!PackNbr);
    CompleteNumber(RestNbr, PackNbr);
    L_General.Assert(RestNbr # PackLastNbr(TckKind.TckKind, PackNbr),
                     "砭 誨 ⬥砥  祭 ");
   ELSE
    IF (TckKind.Type = tkt_KKMActivities) THEN
     PackNbr:=getTckLastRestNbr(atTckRcDL, trgCUCopy);
     L_General.Assert_wReferToAdmin(!PackNbr |
                                    (RestNbr = getTckLastRestNbr(atTckRcDL, trgCUCopy)),
                                    "   KKM  ");
    END;
   END;
  ELSE
   L_General.Assert(TckKind.Type # tkt_KKMActivities, " '稫'?");
   L_General.Assert(TckKind.Type # tkt_BankCardTerminal, "ନ '稫'?");
   L_General.Assert(trdt # trdt_Return, " 稢襩 誨?");
  END;
 END {SupportRestNbrChanging};

 PRIVATE PROCEDURE pt_AddSingle(VAR pt: tPackedTck);
  VAR
   _TRDLNbr: LIKE(TckRcDL.TRDLNbr);
   _TckKind: LIKE(TckRcDL.TckKind);
   _Series : LIKE(TckRcDL.Series );
   _RestNbr: LIKE(TckRcDL.RestNbr);
   _CUCopy : STRING[];
   _Psg    : LIKE(TckRcDL.Psg);
   ts      : tTckState;
 BEGIN
  _TRDLNbr :=L_Str.AnyItem(pt, "|", 0);
  _TckKind :=L_Str.AnyItem(pt, "|", 1);
  _Series  :=L_Str.AnyItem(pt, "|", 2);
  _CUCopy  :=L_Str.AnyItem(pt, "|", 3);
  ts       :=L_Str.AnyItem(pt, "|", 4);
  _RestNbr :=L_Str.AnyItem(pt, "|", 5);
  _Psg     :=L_Str.AnyItem(pt, "|", 6);
  L_General.CallUs((_TckKind = TckRcDL.TckKind) &
                   (_Series  = TckRcDL.Series) &
                   (_CUCopy  = Str.Condense(FLDTOSTR(TckRcDL.CUCopy))) &
                   (ts       = DefineTckState()));
  pt:=_TRDLNbr + "|" + _TckKind + "|" + _Series + "|" + _CUCopy + "|" + ts + "|";
  IF    !_RestNbr THEN
   pt:=pt + TckRcDL.RestNbr + "|";
  ELSIF ~!TckRcDL.RestNbr THEN
   INC(_RestNbr, TckRcDL.RestNbr);
   pt:=pt + _RestNbr + "|";
  ELSE
   pt:=pt + "|";
  END;
  IF    !_Psg THEN
   _Psg:=TckRcDL.Psg;
  ELSIF ~!TckRcDL.Psg THEN
   INC(_Psg, TckRcDL.Psg);
  END;
  IF    ~!_Psg THEN
   pt:=pt + _Psg;
  END;
 END {pt_AddSingle};

 PRIVATE PROCEDURE pt_AnyBuildSingle(_TRDLNbr: LIKE(TckRcDL.TRDLNbr);
                                     ts      : tTckState;
                                     _RestNbr: LIKE(TckRcDL.RestNbr);
                                     _Psg    : LIKE(TckRcDL.Psg);
                                     sAmount : STRING[]): tPackedTck;
 BEGIN
  RETURN _TRDLNbr                               + "|" +
         TckRcDL.TckKind                        + "|" +
         TckRcDL.Series                         + "|" +
         Str.Condense(FLDTOSTR(TckRcDL.CUCopy)) + "|" +
         ts                                     + "|" +
         Str.Condense(FLDTOSTR(_RestNbr))       + "|" +
         Str.Condense(FLDTOSTR(_Psg))           + "|" +
         sAmount;
 END {pt_AnyBuildSingle};

 PRIVATE PROCEDURE pt_BuildSingle(_TRDLNbr: LIKE(TckRcDL.TRDLNbr); isPreviousInventory: SCAL[2]): tPackedTck;
 BEGIN
  CONFORM(TckRcDL, TckKind);
  IF IsBulk_wCUC() THEN
   IF isPreviousInventory THEN
    RETURN pt_AnyBuildSingle(_TRDLNbr, DefineTckState(), 0,               0,           L_Str.IntStr(BulkCUCAmount()));
   ELSE
    RETURN pt_AnyBuildSingle(_TRDLNbr, DefineTckState(), TckRcDL.RestNbr, TckRcDL.Psg, L_Str.IntStr(BulkCUCAmount()));
   END;
  ELSE
   RETURN  pt_AnyBuildSingle(_TRDLNbr, DefineTckState(), TckRcDL.RestNbr, TckRcDL.Psg, "");
  END;
 END {pt_BuildSingle};

 PUBLIC PROCEDURE pt_Unpack(    pt      : tPackedTck;
                            VAR _TRDLNbr: LIKE(TckRcDL.TRDLNbr);
                            VAR _TckKind: LIKE(TckRcDL.TckKind);
                            VAR _Series : LIKE(TckRcDL.Series);
                            VAR _RestNbr: LIKE(TckRcDL.RestNbr);
                            VAR _CUCopy : LIKE(TckRcDL.CUCopy);
                            VAR _Psg    : LIKE(TckRcDL.Psg));
 BEGIN
  _TRDLNbr :=L_Str.AnyItem(pt, "|", 0);
  _TckKind :=L_Str.AnyItem(pt, "|", 1);
  _Series  :=L_Str.AnyItem(pt, "|", 2);
  _CUCopy  :=L_Str.AnyItem(pt, "|", 3);
  _RestNbr :=L_Str.AnyItem(pt, "|", 5);
  _Psg     :=L_Str.AnyItem(pt, "|", 6);
 END {pt_Unpack};

 PRIVATE PROCEDURE pt_GetTckKind(pt: tPackedTck): LIKE(TckRcDL.TckKind);
  VAR
   _TRDLNbr: LIKE(TckRcDL.TRDLNbr);
   _TckKind: LIKE(TckRcDL.TckKind);
   _Series : LIKE(TckRcDL.Series);
   _RestNbr: LIKE(TckRcDL.RestNbr);
   _CUCopy : LIKE(TckRcDL.CUCopy);
   _Psg    : LIKE(TckRcDL.Psg);
 BEGIN
  pt_Unpack(pt, _TRDLNbr, _TckKind, _Series, _RestNbr, _CUCopy, _Psg);
  RETURN _TckKind;
 END {pt_GetTckKind};

 PUBLIC PROCEDURE pt_GetState(pt: tPackedTck): tTckState;
 BEGIN
  RETURN L_Str.AnyItem(pt, "|", 4);
 END {pt_GetState};

 PRIVATE PROCEDURE IsPreviousInventory(_TckRcS: LIKE(TckRcS.TckRcS)): SCAL[2];
 BEGIN
  RETURN (TckRcD.Status = trdStat_Passed) & (TckRcD.Type = trdt_Inventory) & (TckRcD.TckRcS # _TckRcS);
 END {IsPreviousInventory};

 PRIVATE PROCEDURE PosToFirstTckRcD(_Storage: LIKE(Storage.Storage));
 BEGIN
  SELECT(TckRcD, Storage, , _Storage);
  LOOP
   L_General.Assert(OCCURE(TckRcD), "  㬥    ࠭ " + _Storage);
   IF TckRcD.Status # trdStat_Canceled THEN
    EXIT;
   END;
   NEXT(TckRcD);
  END;
 END {PosToFirstTckRcD};

 PRIVATE PROCEDURE gsts_IsNotEmptyTckRcDL(): SCAL[2];
 BEGIN
  IF IsBulk_wCUC() THEN
   SELECT(TckRcDLL, TckRcD, , TckRcDL.TckRcD, TckRcDL.TRDLNbr);
   WHILE OCCURE(TckRcDLL) DO
    IF !TckRcDLL.Sum THEN
     RETURN 1;
    END;
    NEXT(TckRcDLL);
   END; (* WHILE OCCURE(TckRcDLL) ... *)
   RETURN 0;
  ELSE
   RETURN ~!TckRcDL.RestNbr;
  END;
 END {gsts_IsNotEmptyTckRcDL};

 PUBLIC PROCEDURE GetStorageTckSummary(    _Storage : LIKE(Storage.Storage);
                                           _TckRcS  : LIKE(TckRcS.TckRcS);
                                           curTckRcD: LIKE(TckRcD.TckRcD);
                                           atEnd    : SCAL[2];
                                       VAR Result   : tPackedTck[]);
  VAR
   fndCur  : SCAL[2];
   i, j    : NUMERIC[0];
 BEGIN
  SAVE(Storage);
  SETEMPTY(Result);
  SEARCH(Storage, Storage, , _Storage);
  IF Storage.Type = L_Stock.st_TckBag THEN
   SAVE(TckRcD);
   PosToFirstTckRcD(_Storage);
   fndCur:=!curTckRcD;
   LAST(TckRcD);
   LOOP
    IF ~OCCURE(TckRcD) THEN
     PosToFirstTckRcD(_Storage);
     L_General.Assert(TckRcD.Type = trdt_Laying, " 㬥  㬪 - ''");
     EXIT;
    END;
    IF ~fndCur THEN
     fndCur:=TckRcD.TckRcD = curTckRcD;
    END;
    IF fndCur & IsPreviousInventory(_TckRcS) THEN
     EXIT;
    END;
    PREV(TckRcD);
   END; (* LOOP *)
   i:=0;
   WHILE OCCURE(TckRcD) & (TckRcD.TckRcD # curTckRcD) DO
    IF (TckRcD.Status = trdStat_Passed) THEN
     CONFORM(TckRcD, TckRcDL);
     IF IsPreviousInventory(_TckRcS) THEN
      L_AFM.MakeIndex("byFV", "FaceVal : LIKE(TckKind.FaceVal);"+
                              "CUCopy  : LIKE(CUCopy.CUCopy);"+
                              "TRDLNbr : LIKE(TckRcDL.TRDLNbr);");
      WHILE OCCURE(TckRcDL) DO
       CONFORM(TckRcDL, TckKind);
       IF gsts_IsNotEmptyTckRcDL() THEN
        byFV.FaceVal:=(-1)*TckKind.FaceVal;
        byFV.CUCopy :=TckRcDL.CUCopy;
        byFV.TRDLNbr:=TckRcDL.TRDLNbr;
        INSERT(byFV);
       END;
       NEXT(TckRcDL);
      END; (* WHILE OCCURE(TckRcDL) ... *)
      SELECT(byFV, byFV);
      WHILE OCCURE(byFV) DO
       SEARCH(TckRcDL, TckRcD, , TckRcD.TckRcD, byFV.TRDLNbr);
       CONFORM(TckRcDL, TckKind);
       Result[i]:=pt_BuildSingle(i+1, 1);
       IF TckKind.Type = tkt_PieceTck THEN
        NARROWSEL(byFV, FaceVal, CUCopy);
        WHILE NEXT(byFV) DO
         SEARCH(TckRcDL, TckRcD, , TckRcD.TckRcD, byFV.TRDLNbr);
         pt_AddSingle(Result[i]);
        END; (* WHILE OCCURE(byFV) ... *)
        LAST(byFV);
        CHANGESEL(byFV, byFV);
       END;
       INC(i);
       NEXT(byFV);
      END; (* WHILE OCCURE(byFV) ... *)
      L_AFM.AF_PurgeTemp("byFV");
     ELSIF atEnd | (TckRcD.Type = trdt_Laying) THEN
      WHILE OCCURE(TckRcDL) DO
       Result[TckRcDL.TRDLNbr-1]:=pt_BuildSingle(TckRcDL.TRDLNbr, 0);
       IF TckKind.Type = tkt_PieceTck THEN
        j:=0;
        WHILE j < TckRcDL.TRDLNbr - 1 DO
         IF (pt_GetTckKind(Result[j]) = TckKind.TckKind) & (pt_GetState(Result[j]) = DefineTckState()) THEN
          pt_AddSingle(Result[j]);
          IF atEnd THEN
           Result[TckRcDL.TRDLNbr-1]:=pt_AnyBuildSingle(TckRcDL.TRDLNbr, ts_Ended, EMPTYOF(TckRcDL.RestNbr), EMPTYOF(TckRcDL.Psg), "");
          ELSE
           Result[TckRcDL.TRDLNbr-1]:=pt_AnyBuildSingle(TckRcDL.TRDLNbr, DefineTckState(), 0, 0, "");
          END;
          j:=TckRcDL.TRDLNbr - 1;
         END;
         INC(j);
        END;
       END;
       NEXT(TckRcDL);
      END; (* WHILE OCCURE(TckRcDL) ... *)
     END;
    END; (* IF TckRcD.Status ... *)
    NEXT(TckRcD);
   END; (* WHILE OCCURE(TckRcD) ... *)
   RESTORE(TckRcD);
  END;
  RESTORE(Storage);
 END {GetStorageTckSummary};

 PUBLIC PROCEDURE E_HasTckAtStorage(D: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.HasTckAtStorage);
  IF ~!Local THEN
   RETURN Local(D);
  ELSE
   RETURN 0;
  END;
 END {E_HasTckAtStorage};

 PUBLIC PROCEDURE E_TckMovementMDocCostItem(D: DATE): LIKE(CostItem.CostItem);
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_TRS.TckMovementMDocCostItem), EMPTYOF(CostItem.CostItem));
 END {E_TckMovementMDocCostItem};

 PUBLIC PROCEDURE TckOfficeStorage(D: DATE; _MyFirm: P_Firm.tMyFirm): LIKE(Storage.Storage);
 BEGIN
  RETURN L_Stock.GetAnyStoringTypeStorage(D, _MyFirm, L_Stock.storingType_TckOffice);
 END {TckOfficeStorage};

 PUBLIC PROCEDURE GetTckRcDMyFirm(): P_Firm.tMyFirm;
  VAR
   Result: P_Firm.tMyFirm;
 BEGIN
  SAVE(Staff);
  CONFORM(TckRcD, Staff);
  Result:=Staff.MyFirm;
  RESTORE(Staff);
  RETURN Result;
 END {GetTckRcDMyFirm};

 PRIVATE CONST
  ccSerialDlm = " ";

 PRIVATE PROCEDURE cc_CheckSeries(_Series : tTckSeries);
  VAR
   i: NUMERIC[0];
   c: STRING[1];
 BEGIN
  i:=Str.Length(_Series);
  WHILE i > 0 DO
   DEC(i);
   c:=L_Str.Char(_Series, i);
   L_General.Assert(~L_Str.TestStrAlowChar(c, ccSerialDlm) &
                    (L_Str.TestStrAlowChar(c, "") |
                     L_Str.TestStrAlowChar(c, "09") |
                     L_Str.TestStrAlowChar(c, "--") ),
                    " ਨ  ⨬ ᨬ '" + c + "'");
  END;
 END {cc_CheckSeries};

 PRIVATE PROCEDURE cc_BuildGroupSerial(_Storage: LIKE(Storage.Storage)): STRING[];
  VAR
   i,
   cnt,
   _TRDLNbr: NUMERIC[0];
   StTStr,
   result  : STRING[];
   pta     : tPackedTck[1E2];
   _TckRcT : LIKE(TckRcT.TckRcT);
   _TckKind: LIKE(TckRcT.TckKind);
   _Series : LIKE(TckRcT.Series);
   _AftNbr : LIKE(TckRcT.AftNbr);
   _CUCopy : LIKE(CUCopy.CUCopy);
   _Psg    : LIKE(TckRcDL.Psg);
 BEGIN
  SAVE(TckRcDL);
  SAVE(TckKind);
  SEARCH(Storage, Storage, , _Storage);
  StTStr:=L_Str.PoolItem(L_Stock.st_Pool_SH, Storage.Type);
  result:="㯯  " + TckKind.TckKind + "  " + StTStr + " " + _Storage;
  IF TckKind.Type = tkt_PieceTck THEN
   result:="㯯  " + TckKind.TckKind + "  " + StTStr + " " + _Storage + " #1";
   CHANGESEL(TckRcDL, TckRcD, , TckRcDL.TckRcD);
   FIRST(TckRcDL);
   WHILE OCCURE(TckRcDL) DO
    IF ~!TckRcDL.CUCopy & (TckRcDL.TckKind = TckKind.TckKind) THEN
     CONFORM(TckRcDL, CUCopy);
     L_General.Assert(CUCopy.Serial # result, "祬 뢠 " + TckKind.Name + "  㯯?");
    END;
    NEXT(TckRcDL);
   END; (* WHILE OCCURE(TckRcDL) ... *)
  ELSE
   i:=0;
   GetStorageTckSummary(TckRcD.Storage, TckRcD.TckRcS, EMPTYOF(TckRcD.TckRcD), 1, pta);
   LOOP
    INC(i);
    _TRDLNbr:=0;
    cnt     :=0;
    WHILE ~!pta[_TRDLNbr] DO
     pt_Unpack(pta[_TRDLNbr], _TckRcT, _TckKind, _Series, _AftNbr, _CUCopy, _Psg);
     IF SEARCH(CUCopy, CUCopy, _CUCopy) & (CUCopy.Serial = result + " #" + L_Str.IntStr(i)) THEN
      INC(cnt);
     END;
     INC(_TRDLNbr);
    END;
    IF cnt = 0 THEN
     result:=result + " #" + L_Str.IntStr(i);
     EXIT;
    END;
   END;
  END;

  RESTORE(TckRcDL);
  RESTORE(TckKind);
  RETURN result;
 END {cc_BuildGroupSerial};

 PUBLIC PROCEDURE cc_BuildSerial(trgSer: tTckSeries; trgNbr: tTckNumber): STRING[];
  VAR
   Result: STRING[];
   local : PROC;
 BEGIN
  IF    (TckKind.Type = tkt_Ticket) | IsBulk_wCUC() THEN
   cc_CheckSeries(trgSer);
   Result:=trgSer + ccSerialDlm + FLDTOSTR(trgNbr, "L", TckKind.NbrPrc);
   local:=PROCREF(E_TRS.cc_BuildSerial);
   IF ~!local THEN
    Result:=local(trgSer, trgNbr, Result);
   END;
  ELSE
   L_General.Error("⨬ ⨯  ஥ 㬥");
  END;
  RETURN Result;
 END {cc_BuildSerial};

 PUBLIC PROCEDURE cc_SplitTckSerial(Serial: STRING[]; VAR trgSer: tTckSeries; VAR trgNbr: tTckNumber);
  VAR
   local : PROC;
 BEGIN
  IF    (TckKind.Type = tkt_Ticket) | IsBulk_wCUC() THEN
   trgSer:=Str.Item(Serial, ccSerialDlm, 0);
   trgNbr:=Str.Item(Serial, ccSerialDlm, 1);
   local:=PROCREF(E_TRS.cc_SplitTckSerial);
   IF ~!local THEN
    local(Serial, trgSer, trgNbr);
   END;
  ELSE
   L_General.Error("⨬ ⨯  ஥ 㬥");
  END;
 END {cc_SplitTckSerial};

 PRIVATE PROCEDURE cc_GetPackNbr(_Serial: STRING[]): tTckNumber;
 BEGIN
  IF    TckKind.Type = tkt_Ticket THEN
   RETURN Str.Item(_Serial, ccSerialDlm, 1);
  ELSE
   L_General.Error("⨬ ⨯  ஥ 㬥");
  END;
 END {cc_GetPackNbr};

 PRIVATE PROCEDURE cc_HasOnlyEntry(_CUCopy: LIKE(CUCopy.CUCopy)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(TckRcDL);
  SAVE(TckRcDLL);
  IF SELECT(TckRcDL, CUCopy, _CUCopy) THEN
   Result:=~NEXT(TckRcDL) & ~SELECT(TckRcDLL, CUCopy, _CUCopy);
  ELSE
   Result:=SELECT(TckRcDLL, CUCopy, _CUCopy) & ~NEXT(TckRcDLL);
  END;
  RESTORE(TckRcDLL);
  RESTORE(TckRcDL);
  RETURN Result;
 END {cc_HasOnlyEntry};

 PRIVATE PROCEDURE cc_Free(_CUCopy: LIKE(CUCopy.CUCopy));
 BEGIN
  IF cc_HasOnlyEntry(_CUCopy) THEN
   L_General.CallUs(SEARCH(CUCopy, CUCopy, _CUCopy));
   SETEMPTY(CUCopy.Serial);
   REPLACE(CUCopy);
  END;
 END {cc_Free};

 PRIVATE PROCEDURE cc_New(_Begin: DATE; _Serial: LIKE(CUCopy.Serial); _Math: LIKE(CUCopy.Math)): LIKE(CUCopy.CUCopy);
 BEGIN
  TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
   IF SELECT(CUCopy, Serial, "", _Math) THEN
    CUCopy.Serial:=_Serial;
    REPLACE(CUCopy);
   ELSE
    RAISE(, " ⠢   CUCopy");
   END;
  EXCEPT
  ELSE
   DEFAULT(CUCopy);
   CUCopy.Math   :=_Math;
   CUCopy.Serial :=_Serial;
   CUCopy.Begin  :=_Begin;
   INSERT(CUCopy);
  END; (* TRY *)
  RETURN CUCopy.CUCopy;
 END {cc_New};

 PRIVATE PROCEDURE Setup_TckRcDL_GroupCUCopy(_Dir: NUMERIC[0]);
  VAR
   Serial : LIKE(CUCopy.Serial);
 BEGIN
  IF _Dir = -1 THEN
   IF ~!TckRcDL.CUCopy THEN
    IF ~E_HasTckAtStorage(TckRcDL.Date) THEN
     cc_Free(TckRcDL.CUCopy);
    END;
    SETEMPTY(TckRcDL.CUCopy);
    REPLACE(TckRcDL);
   END;
  ELSIF _Dir = +1 THEN
   CONFORM(TckRcDL, TckRcD);
   L_General.Assert(~!TckKind.Math, "室 㪠   ' ஥ 㬥⮢' " + TckKind.TckKind);
   Serial :=cc_BuildGroupSerial(TckRcD.Storage);
   IF SELECT(CUCopy, Serial, Serial, TckKind.Math) THEN
    TckRcDL.CUCopy:=CUCopy.CUCopy;
   ELSE
    TckRcDL.CUCopy:=cc_New(TckRcDL.Date, Serial, TckKind.Math);
   END;
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(TckRcDL);
 END {Setup_TckRcDL_GroupCUCopy};

 PUBLIC PROCEDURE Setup_TckRcDLL_CUCopy(_Dir: NUMERIC[0]);
  VAR
   _Serial: LIKE(CUCopy.Serial);
 BEGIN
  L_General.CallUs(~!TckRcDLL.CUCopy | ~(!TckRcDLL.Series | !TckRcDLL.RestNbr ));
  IF _Dir = -1 THEN
   IF ~!TckRcDLL.CUCopy THEN
    IF ~E_HasTckAtStorage(TckRcDL.Date) THEN
     cc_Free(TckRcDLL.CUCopy);
    END;
    SETEMPTY(TckRcDLL.CUCopy);
    REPLACE(TckRcDLL);
   END;
  ELSIF _Dir = +1 THEN
   IF !TckRcDLL.CUCopy THEN
    L_General.Assert(~!TckKind.Math, "室 㪠   ' ஥ 㬥⮢' " + TckKind.TckKind);
    _Serial :=cc_BuildSerial(TckRcDLL.Series, TckRcDLL.RestNbr);
    IF SELECT(CUCopy, Serial, _Serial, TckKind.Math) THEN
     TckRcDLL.CUCopy:=CUCopy.CUCopy;
    ELSE
     L_General.Assert(~E_HasTckAtStorage(TckRcDL.Date), " ⭮ த樨  ਥ, ஬ " + _Serial);
     TckRcDLL.CUCopy:=cc_New(TckRcDL.Date, _Serial, TckKind.Math);
    END;
    REPLACE(TckRcDLL);
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {Setup_TckRcDLL_CUCopy};

 PUBLIC PROCEDURE Setup_TckRcDL_CUCopy(_Dir: NUMERIC[0]);
  VAR
   _PackNbr : tTckNumber;
   _Serial  : LIKE(CUCopy.Serial);
  BEGIN
  L_General.CallUs(ACCESS(TckRcDL));
  L_General.CallUs(~!TckRcDL.TckKind);
  SAVE(TckKind);
  SAVE(CUCopy);
  CONFORM(TckRcDL, TckKind);
  IF    IsBulk_wCUC() THEN
   Setup_TckRcDL_GroupCUCopy(_Dir);
   CONFORM(TckRcDL, TckRcDLL);
   WHILE OCCURE(TckRcDLL) DO
    Setup_TckRcDLL_CUCopy(_Dir);
    NEXT(TckRcDLL);
   END; (* WHILE OCCURE(TckRcDLL) ... *)
  ELSIF TckKind.Type = tkt_PieceTck THEN
   Setup_TckRcDL_GroupCUCopy(_Dir);
  ELSIF TckKind.Type = tkt_EasySales THEN
   (* Nothing *)
  ELSIF ~IsDevice(TckKind.Type) THEN
   L_General.CallUs(~!TckRcDL.CUCopy | ~(!TckRcDL.Series | !TckRcDL.RestNbr ));
   IF _Dir = -1 THEN
    IF ~!TckRcDL.CUCopy THEN
     IF ~E_HasTckAtStorage(TckRcDL.Date) THEN
      cc_Free(TckRcDL.CUCopy);
     END;
     SETEMPTY(TckRcDL.CUCopy);
     REPLACE(TckRcDL);
    END;
   ELSIF _Dir = +1 THEN
    L_General.Assert(~!TckKind.Math, "室 㪠   ' ஥ 㬥⮢' " + TckKind.TckKind);
    _PackNbr:=PackFirstNbr(TckRcDL.TckKind, TckRcDL.RestNbr);
    _Serial :=cc_BuildSerial(TckRcDL.Series, _PackNbr);
    IF SELECT(CUCopy, Serial, _Serial, TckKind.Math) THEN
     TckRcDL.CUCopy:=CUCopy.CUCopy;
    ELSE
     L_General.Assert(~E_HasTckAtStorage(TckRcDL.Date), " ⭮ த樨  ਥ, ஬ " + _Serial);
     IF TckRcDL.RestNbr # _PackNbr THEN
      L_StdFrm.Choice(" 㯠?");
     END;
     TckRcDL.CUCopy:=cc_New(TckRcDL.Date, _Serial, TckKind.Math);
    END;
   ELSE
    L_General.CallUs(0);
   END;
   REPLACE(TckRcDL);
  ELSE
   L_General.CallUs(~!TckRcDL.CUCopy);
  END;
  RESTORE(CUCopy);
  RESTORE(TckKind);
 END {Setup_TckRcDL_CUCopy};

 PUBLIC PROCEDURE E_TckRcS_AsWhoCnd_GetPool(D: DATE; _AsWho: LIKE(TckRcS.AsWho)): STRING[];
  VAR
   default: STRING[];
   Local  : PROC;
 BEGIN
  default:="";
  Local:=PROCREF(E_Way.TckRcS_AsWhoCnd_GetPool);
  IF ~!Local THEN
   RETURN Local(default, D, _AsWho);
  ELSE
   RETURN default;
  END;
 END {E_TckRcS_AsWhoCnd_GetPool};

 PUBLIC PROCEDURE GetBarCode_bck_IdIn20(): STRING[];
 BEGIN
  RETURN L_BarCode.toFont_IntP36DlTt(L_XDoc.BarCode(L_XDoc.bck_IdIn20,
                                                    L_XDoc.xdt_TckRcS,
                                                    L_XDoc.EmptyXDocKind,
                                                    TckRcS.TckRcS,
                                                    TckRcS.CopyCnt));
 END {GetBarCode_bck_IdIn20};

 PUBLIC PROCEDURE bc_PositionOnTckRcS(Title: STRING[]);
 BEGIN
  L_XDoc.PositionOnNonEmptyXDoc(L_XDoc.GetRequiredTypeXDocIdByBC(Title + ":  ⭮-⭮ ", L_XDoc.xdt_TckRcS, 0));
 END {bc_PositionOnTckRcS};

 PUBLIC PROCEDURE bc_PositionOnTckBag(Title: STRING[]);
 BEGIN
  LOOP
   L_XDoc.PositionOnNonEmptyXDoc(L_XDoc.GetRequiredTypeXDocIdByBC(Title + ":  ⭮ 㬪", L_XDoc.xdt_CUCopy, 1));
   IF ~!CUCopy.Storage THEN
    CONFORM(CUCopy, Storage);
    IF Storage.Type = L_Stock.st_TckBag THEN
     EXIT
    END;
   END;
   L_StdFrm.RedInform(" ਫ ᪠   㬪");
  END; (* LOOP *)
 END {bc_PositionOnTckBag};

 PUBLIC PROCEDURE TckMath(trgMath: LIKE(Math.Math); D: DATE): LIKE(Math.Math);
  VAR
   PMath: LIKE(Math.Math);
 BEGIN
  PMath:=P_Math.GetParentMath(trgMath, D);
  IF ~!PMath THEN
   RETURN PMath;
  ELSE
   RETURN trgMath;
  END;
 END {TckMath};

 PUBLIC PROCEDURE AccessTckKindByMath(trgMath: LIKE(Math.Math); D: DATE): SCAL[2];
  VAR
   cucPMath  : LIKE(Math.Math);
   trgTckKind: LIKE(TckKind.TckKind);
 BEGIN
  IF !trgMath THEN
   RETURN 0;
  END;
  SETEMPTY(trgTckKind);
  SELECT(TckKind, Math, , TckMath(trgMath, D));
  WHILE OCCURE(TckKind) DO
   IF L_DatTim.IsActive(D, TckKind.Begin, TckKind.Till) THEN
    L_General.Assert(!trgTckKind,
                     " ᪮쪮   ஥ 㬥⮢  뫪   " + TckKind.Math);
    trgTckKind:=TckKind.TckKind;
   END;
   NEXT(TckKind);
  END; (* WHILE OCCURE(TckKind) ... *)
  RETURN ~!trgTckKind & SEARCH(TckKind, TckKind, trgTckKind);
 END {AccessTckKindByMath};

 PUBLIC PROCEDURE GetMathTckKind(_Math: LIKE(Math.Math); trgType: tTckKindType; D: DATE): LIKE(TckKind.TckKind);
  VAR
   Result: LIKE(TckKind.TckKind);
 BEGIN
  SAVE(TckKind);
  IF AccessTckKindByMath(_Math, D) & (TckKind.Type = trgType) THEN
   Result:=TckKind.TckKind;
  ELSE
   SETEMPTY(Result);
  END;
  RESTORE(TckKind);
  RETURN Result;
 END {GetMathTckKind};

 PUBLIC PROCEDURE GetDeviceName(trgType: tTckKindType): STRING[];
 BEGIN
  IF    trgType = tkt_KKMActivities    THEN RETURN "";
  ELSIF trgType = tkt_VLDActivities    THEN RETURN "";
  ELSIF trgType = tkt_BankCardTerminal THEN RETURN "ନ ਥ ᪨ ";
  ELSE                                      RETURN ",   ନ ਥ ᪨ ";
  END;
 END {GetDeviceName};

 PUBLIC PROCEDURE bc_PositionOnDevice(Title: STRING[]; VAR trgType: tTckKindType; IsLaying: SCAL[2]);
  VAR
   deviceName: STRING[];
 BEGIN
  deviceName:="ன⢠ (" + GetDeviceName(trgType) + ")";
  LOOP
   L_XDoc.PositionOnNonEmptyXDoc(L_XDoc.GetRequiredTypeXDocIdByBC(Title + ":  " + deviceName, L_XDoc.xdt_CUCopy, 1));
   TRY
    IF !trgType THEN
     IF    ~!GetMathTckKind(CUCopy.Math, tkt_KKMActivities,    SYSDATE()) THEN
      trgType:=tkt_KKMActivities;
     ELSIF ~!GetMathTckKind(CUCopy.Math, tkt_VLDActivities,    SYSDATE()) THEN
      trgType:=tkt_VLDActivities;
     ELSIF ~!GetMathTckKind(CUCopy.Math, tkt_BankCardTerminal, SYSDATE()) THEN
      trgType:=tkt_BankCardTerminal;
     ELSE
      L_General.Error(" ਫ ᪠    " + deviceName);
     END;
     deviceName:="ன⢠ (" + GetDeviceName(trgType) + ")";
    ELSIF !GetMathTckKind(CUCopy.Math, trgType, SYSDATE()) THEN
     L_General.Error(" ਫ ᪠    " + deviceName);
    END;
    IF IsLaying THEN
     IF ~L_DatTim.IsActive(SYSDATE(), CUCopy.Begin, CUCopy.Till) THEN
      L_StdFrm.WrongDB("ᯮ짢 ⮣ " + deviceName + " 饭" + L_StdFrm.HR() +
                       "ਮ ਬ :  " + L_DatTim.DateStr(CUCopy.Begin) + "  " + L_DatTim.DateStr(CUCopy.Till));
     END;
     L_General.Assert(L_Prop.getRES(P_CUC.GetCUCProSoft(CUCopy.CUCopy, SYSDATE(), P_CUC.P_UsingOptions), 0) # L_Str.PoolItem(P_CUC.uu_Pool, 0),
                      "⠭  뤠  " + deviceName);
    END;
    EXIT;
   EXCEPT
   ON Exc: Exc_Raise DO
    L_StdFrm.RedInform(Exc.MsgOriginalText);
   END;
  END; (* LOOP *)
 END {bc_PositionOnDevice};

 PUBLIC PROCEDURE E_RequiredKKM(_TSN    : LIKE(TckRcS.TSN);
                                _AsWho  : LIKE(TckRcS.AsWho);
                                _AsRWayS: LIKE(TckRcS.asRWayS)): SCAL[2];
  VAR
   default: SCAL[2];
   Local  : PROC;
 BEGIN
  default:=0;
  Local:=PROCREF(E_TRS.RequiredKKM);
  IF ~!Local THEN
   default:=Local(default, _TSN, _AsWho, _AsRWayS);
  END;
  RETURN default;
 END {E_RequiredKKM};

 PUBLIC PROCEDURE E_RequiredVLD(_TSN    : LIKE(TckRcS.TSN);
                                _AsWho  : LIKE(TckRcS.AsWho);
                                _AsRWayS: LIKE(TckRcS.asRWayS)): SCAL[2];
  VAR
   default: SCAL[2];
   Local  : PROC;
 BEGIN
  default:=0;
  Local:=PROCREF(E_TRS.RequiredVLD);
  IF ~!Local THEN
   default:=Local(default, _TSN, _AsWho, _AsRWayS);
  END;
  RETURN default;
 END {E_RequiredVLD};

 PUBLIC PROCEDURE E_RequiredBCT(_TSN    : LIKE(TckRcS.TSN);
                                _AsWho  : LIKE(TckRcS.AsWho);
                                _AsRWayS: LIKE(TckRcS.asRWayS)): SCAL[2];
  VAR
   default: SCAL[2];
   Local  : PROC;
 BEGIN
  default:=0;
  Local:=PROCREF(E_TRS.RequiredBCT);
  IF ~!Local THEN
   default:=Local(default, _TSN, _AsWho, _AsRWayS);
  END;
  RETURN default;
 END {E_RequiredBCT};

 PUBLIC PROCEDURE Get_trsDevice(trgStorage: LIKE(TckRcS.Storage);
                                trgTckRcS : LIKE(TckRcS.TckRcS);
                                trgType   : tTckKindType): LIKE(CUCopy.CUCopy);
  VAR
   pta      : tPackedTck[1E2];
   i        : NUMERIC[0];
   _Number  : LIKE(TckRcDL.RestNbr);
   _TckKind : LIKE(TckRcDL.TckKind);
   _Series  : LIKE(TckRcDL.Series);
   _AftNbr  : LIKE(TckRcDL.RestNbr);
   _CUCopy  : LIKE(TckRcDL.CUCopy);
   _Psg     : LIKE(TckRcDL.Psg);
   Result   : LIKE(CUCopy.CUCopy);
 BEGIN
  SETEMPTY(Result);
  SAVE(TckKind);
  GetStorageTckSummary(trgStorage, trgTckRcS, EMPTYOF(TckRcD.TckRcD), 1, pta);
  i:=0;
  WHILE ~!pta[i] & !Result DO
   IF pt_GetState(pta[i]) = ts_inBag THEN
    pt_Unpack(pta[i], _Number, _TckKind, _Series, _AftNbr, _CUCopy, _Psg);
    SEARCH(TckKind, TckKind, , _TckKind);
    IF TckKind.Type = trgType THEN
     Result:=_CUCopy;
    END;
   END;
   INC(i);
  END; (* WHILE ~!pta[i ... *)
  RESTORE(TckKind);
  RETURN Result;
 END {Get_trsDevice};

 PUBLIC PROCEDURE CheckAcceptableTckRcSStatus(_Action: LIKE(XDocJrn.Action);
                                              _Status: LIKE(TckRcS.Status));
 BEGIN
  L_General.Assert(TckRcS.Status = _Status,
                   " '" + L_Str.PoolItem(L_XDoc.action_Pool, _Action) + "' |" +
                   "⮫쪮    ᮬ '" + L_Str.PoolItem(trsStat_Pool, _Status) + "'");
 END {CheckAcceptableTckRcSStatus};

 PUBLIC PROCEDURE CheckTckRcS_StorageConsistency();
  VAR
   TckRcDs: LIKE(TckRcD.TckRcD)[48];
   i,
   invCnt : NUMERIC[0];
 BEGIN
  SAVE(TckRcD);
  IF SELECT(TckRcD, TckRcS, TckRcS.TckRcS) THEN
   invCnt:=0;
   i:=0;
   SETEMPTY(TckRcDs);
   WHILE OCCURE(TckRcD) DO
    IF TckRcD.Status = trdStat_Passed THEN
     TckRcDs[i]:=TckRcD.TckRcD;
     INC(invCnt, TckRcD.Type = trdt_Inventory);
     INC(i);
    END;
    NEXT(TckRcD);
   END; (* WHILE OCCURE(TckRcD) ... *)
   L_General.Assert(invCnt <= 1, "     ⢥ 㬥 ਧ樨");
   i:=0;
   FIRST(TckRcD);
   CHANGESEL(TckRcD, Storage, , TckRcD.Storage);
   WHILE ~!TckRcDs[i] DO
    IF TckRcD.Status = trdStat_Passed THEN
     L_General.Assert(OCCURE(TckRcD) & (TckRcD.TckRcD = TckRcDs[i]),
                      " 㬪 -   !");
     INC(i);
    END;
    NEXT(TckRcD);
   END; (* WHILE OCCURE(TckRcD) ... *)
  END;
  RESTORE(TckRcD);
 END {CheckTckRcS_StorageConsistency};

 PUBLIC PROCEDURE MustBeLastCUCopyTckRcDL();
 BEGIN
  IF (TckRcDL.Status = trdStat_Passed) & ~!TckRcDL.CUCopy THEN
   CONFORM(TckRcDL, TckKind);
   IF ~IsBulk_wCUC() THEN
    SAVE(TckRcDL);
    CHANGESEL(TckRcDL, CUCopy, , TckRcDL.CUCopy, TckRcDL.Status);
    IF NEXT(TckRcDL) THEN
     L_General.Error("᫥⥫쭠 䨪    '誨' " + TckRcDL.CUCopy);
    END;
    RESTORE(TckRcDL);
   END;
  END;
 END {MustBeLastCUCopyTckRcDL};

 PUBLIC PROCEDURE MustBeLastCUCopyTckRcDLL();
 BEGIN
  IF TckRcDLL.Status = trdStat_Passed THEN
   SAVE(TckRcDLL);
   CHANGESEL(TckRcDLL, CUCopy, , TckRcDLL.CUCopy, TckRcDLL.Status);
   IF NEXT(TckRcDLL) THEN
    L_General.Error("᫥⥫쭠 䨪    '誨' " + TckRcDLL.CUCopy);
   END;
   RESTORE(TckRcDLL);
  END;
 END {MustBeLastCUCopyTckRcDLL};

 PUBLIC PROCEDURE AssignTckRcDL_TckNbr();
  VAR
   _TRDLNbr: LIKE(TckRcDL.TRDLNbr);
   pta     : tPackedTck[1E2];
 BEGIN
  SAVE(TckRcDL);
  CHANGESEL(TckRcDL, TckRcD, , TckRcDL.TckRcD);
  IF PREV(TckRcDL) THEN
   _TRDLNbr:=TckRcDL.TRDLNbr;
  ELSE
   GetStorageTckSummary(TckRcD.Storage, TckRcD.TckRcS, TckRcD.TckRcD, 1, pta);
   _TRDLNbr:=0;
   WHILE ~!pta[_TRDLNbr] DO
    INC(_TRDLNbr);
   END;
  END;
  RESTORE(TckRcDL);
  INC(_TRDLNbr);
  L_General.Assert(_TRDLNbr <= trdl_Amount, "誮  㯠 ⭮ த樨   㬪");
  TckRcDL.TRDLNbr:=_TRDLNbr;
  REPLACE(TckRcDL);
 END {AssignTckRcDL_TckNbr};

 PUBLIC PROCEDURE CompleteTckRcDLL();
 BEGIN
  MustBeLastCUCopyTckRcDLL();
  TckRcDLL.Date   :=TckRcD.Date;
  TckRcDLL.PassDTS:=TckRcD.PassDTS;
  TckRcDLL.Status :=TckRcD.Status;
  REPLACE(TckRcDLL);
  IF TckRcDLL.Status = trdStat_Passed THEN
   MustBeLastCUCopyTckRcDLL();
  END;
 END {CompleteTckRcDLL};

 PUBLIC PROCEDURE CompleteTckRcDL();
 BEGIN
  MustBeLastCUCopyTckRcDL();
  TckRcDL.Date   :=TckRcD.Date;
  TckRcDL.PassDTS:=TckRcD.PassDTS;
  TckRcDL.Status :=TckRcD.Status;
  REPLACE(TckRcDL);
  MustBeLastCUCopyTckRcDL();
  CONFORM(TckRcDL, TckRcDLL);
  WHILE OCCURE(TckRcDLL) DO
   CompleteTckRcDLL();
   NEXT(TckRcDLL);
  END; (* WHILE OCCURE(TckRcDLL) ... *)
 END {CompleteTckRcDL};

 PUBLIC PROCEDURE RunProcess(Name, Params, Id: STRING[]);
 BEGIN
  LIKEMENU(^Name, Params + ' ' + L_Events.ee_ProcessId + '="' + Id + '"');
 END {RunProcess};

 PRIVATE PROCEDURE getNextStorageTckRcD(): LIKE(TckRcD.TckRcD);
  VAR
   Result: LIKE(TckRcD.TckRcD);
 BEGIN
  SAVE(TckRcD);
  CHANGESEL(TckRcD, Storage, , TckRcD.Storage);
  REPEAT
   NEXT(TckRcD);
  UNTIL ~OCCURE(TckRcD) | (TckRcD.Status = trdStat_Passed);
  IF OCCURE(TckRcD) THEN
   Result:=TckRcD.TckRcD;
  ELSE
   SETEMPTY(Result);
  END;
  RESTORE(TckRcD);
  RETURN Result;
 END {getNextStorageTckRcD};

 PUBLIC PROCEDURE InSale(): SCAL[2];
 BEGIN
  RETURN (TckKind.InSale > tks_Void) & (TckKind.InSale # tks_CashlessSales);
 END {InSale};

 PRIVATE PROCEDURE SetTckRcTNumber(VAR _Number: NUMERIC[0]);
 BEGIN
  L_General.Assert(_Number <= trjl_Amount, "⨬ த  祬  " + L_Str.IntStr(trjl_Amount) +
                                           "   ");
  TckRcT.Number:=_Number;
  INC(_Number);
 END {SetTckRcTNumber};

 PUBLIC PROCEDURE TckRcS_AcceptSummary(as: tAcceptSummaryStage);
  VAR
   curTckRcD: LIKE(TckRcD.TckRcD);
   pta      : tPackedTck[1E2];
   i        : NUMERIC[0];
   _TckRcT  : LIKE(TckRcT.TckRcT);
   RNum,
   _Number  : NUMERIC[0];
   _TckKind : LIKE(TckRcT.TckKind);
   _Series  : LIKE(TckRcT.Series);
   _AftNbr  : LIKE(TckRcT.AftNbr);
   _Psg     : LIKE(TckRcDL.Psg);
   _Amount  : NUMERIC[0];
   _asCUCopy: LIKE(CUCopy.CUCopy);
   RSum,
   InCashSum,
   InCashRSum,
   InSaleSum: NUMERIC[2];
 BEGIN
  L_General.CallUs(~!TckRcS.Storage);
  IF TckRcS.TSN # L_Stock.GetStorageFixedStaff(TckRcS.Storage, TckRcS.Date) THEN
   L_General.Error(" ९ 㬪  ࠡ⭨?");
  END;
  IF SELECT(TckRcD, TckRcS, TckRcS.TckRcS) THEN
   CheckTckRcS_StorageConsistency();
   LAST(TckRcD);
   L_General.Assert(TckRcD.Storage = TckRcS.Storage,
                    "冷  ९ 㬪  ࠡ⭨");
   WHILE OCCURE(TckRcD) & (TckRcD.Status # trdStat_Passed) DO
    PREV(TckRcD);
   END; (* WHILE OCCURE(TckRcD) *)
  END;
  IF as > ass_Begining THEN
   L_General.Assert(OCCURE(TckRcD) & (TckRcD.Type = trdt_Inventory),
                    "᫥    - 'ਧ'");
   curTckRcD:=getNextStorageTckRcD();
  ELSE
   IF OCCURE(TckRcD) THEN
    IF (TckRcD.Type = trdt_Inventory) THEN
     curTckRcD:=TckRcD.TckRcD;
    ELSE
     curTckRcD:=getNextStorageTckRcD();
    END;
   ELSE
    SETEMPTY(curTckRcD);
   END;
  END;
  GetStorageTckSummary(TckRcS.Storage, TckRcS.TckRcS, curTckRcD, as > ass_Begining, pta);
  SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
  IF as > ass_Begining THEN
   i:=0;
   _Number:=1;
   WHILE OCCURE(TckRcT) DO
    L_General.CallUs(~!pta[i]);
    pt_Unpack(pta[i], _TckRcT, _TckKind, _Series, _AftNbr, _asCUCopy, _Psg);
    L_General.CallUs(TckRcT.TckRcT = _TckRcT);
    L_General.CallUs(TckRcT.asCUCopy = _asCUCopy);
    TckRcT.AftNbr:=_AftNbr;
    CONFORM(TckRcT, TckKind);
    IF    pt_GetState(pta[i]) = ts_Ended THEN
     TckRcT.AftNbr:=EndOfPack();
    END;
    Calc2NumbersDifference(TckRcT.TckKind, TckRcT.BefNbr, TckRcT.AftNbr, _Amount, TckRcT.ExpSum);
    IF as = ass_Finishing THEN
     IF TckKind_wPsg() | IsBulk_wCUC() THEN
      L_General.CallUs(~!_Psg);
      TckRcT.ExpNum:=_Psg;
      RNum  :=s_TB_RPsg[i];
      IF TckKind.Type = tkt_ZonalTicket THEN
       RSum:=s_TB_RAmount[i];
      ELSE
       RSum:=s_TB_RAmount[i] * TckKind.FaceVal;
      END;
     ELSIF (TckKind.Type = tkt_KKMActivities) |
           (TckKind.Type = tkt_OutsideSales)  |
           (TckKind.Type = tkt_VLDActivities) |
           (TckKind.Type = tkt_BankCardTerminal) |
           (TckKind.Type = tkt_EasySales)     THEN
      TckRcT.ExpNum:=0;
      RNum  :=0;
      RSum:=s_TB_RAmount[i] * TckKind.FaceVal;
     ELSE
      L_General.CallUs(!_Psg);
      TckRcT.ExpNum:=_Amount;
      RNum  :=s_TB_RAmount[i];
      RSum  :=s_TB_RAmount[i] * TckKind.FaceVal;
     END;
     IF L_General.GetAPSiteID() = "84" THEN
      IF ((TckRcT.TckKind = 0008) & (TckRcT.ExpNum > 150)) |
         ((TckRcT.TckKind = 0009) & (TckRcT.ExpNum > 200)) |
         ((TckRcT.TckKind = 0010) & (TckRcT.ExpNum > 600)) |
         ((TckRcT.TckKind = 0013) & (TckRcT.ExpNum > 150)) |
         ((TckRcT.TckKind = 0014) & (TckRcT.ExpNum > 400)) THEN
       L_StdFrm.CrucialChoice("ப " + TckRcT.TckRcT + ": ⨬  (" + L_Str.IntStr(TckRcT.ExpNum) + ") த" +
                              "|   " + TckRcT.TckKind + " " + TckKind.Name, L_APtm.g_TckCashier);
      END;
     END;
    ELSE
     TckRcT.ExpNum:=0;
     RNum  :=0;
     IF TckKind.Type = tkt_ZonalTicket THEN
      RSum:=s_TB_RAmount[i];
     ELSE
      RSum:=s_TB_RAmount[i] * TckKind.FaceVal;
     END;
    END;
    L_General.Assert((RNum <= TckRcT.ExpNum) & (RSum <= TckRcT.ExpSum),
                     "ப " + TckRcT.TckRcT + ": ᠭ , 祬 த.   " + TckRcT.TckKind);
    TckRcT.RNum:=RNum;
    TckRcT.RSum:=RSum;
    IF ~IsCashWithoutSale() & ((TckRcT.ExpNum # 0) | (TckRcT.ExpSum # 0)) THEN
     SetTckRcTNumber(_Number);
    ELSE
     SETEMPTY(TckRcT.Number);
    END;
    REPLACE(TckRcT);
    NEXT(TckRcT);
    INC(i);
   END; (* WHILE OCCURE(TckRcT) *)

   i:=0;
   WHILE ~!s_ES_TckKind[i] DO
    L_General.CallUs(SEARCH(TckKind, TckKind, s_ES_TckKind[i]));
    DEFAULT(TckRcT);
    TckRcT.TckRcS :=TckRcS.TckRcS;
    TckRcT.TckKind:=s_ES_TckKind[i];
    SETEMPTY(TckRcT.Series, TckRcT.asCUCopy);
    TckRcT.AftNbr :=s_ES_Amount[i];
    TckRcT.ExpNum :=s_ES_Psg[i];
    SETZERO(TckRcT.BefNbr, TckRcT.RNum, TckRcT.RSum);
    Calc2NumbersDifference(TckRcT.TckKind, TckRcT.BefNbr, TckRcT.AftNbr, _Amount, TckRcT.ExpSum);

    IF (TckRcT.AftNbr # 0) | (TckRcT.ExpNum # 0) | (TckRcT.ExpSum # 0) THEN
     IF ~IsCashWithoutSale() THEN
      SetTckRcTNumber(_Number);
     END;
     INSERT(TckRcT);
    END;
    INC(i);
   END;

   IF as = ass_Finishing THEN
    SETZERO(InCashSum, InCashRSum, InSaleSum);
    SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
    WHILE OCCURE(TckRcT) DO
     CONFORM(TckRcT, TckKind);
     IF TckKind.wPsg THEN
      L_General.Assert((TckRcT.ExpSum # 0) | (TckRcT.ExpNum = 0),
                       "   ᠦ஢  祣  த.  " + TckRcT.TckRcT);
      IF (TckRcT.ExpSum # 0) & (TckRcT.ExpNum = 0) THEN
       L_StdFrm.CrucialChoice(" 㪠 ᠦ   " + TckRcT.TckRcT, L_APtm.g_TckCashier);
      END;
     END;
     IF TckKind.InCash # tkc_No THEN
      INC(InCashSum,  TckRcT.ExpSum);
      INC(InCashRSum, TckRcT.RSum);
     END;
     IF InSale() THEN
      INC(InSaleSum, TckRcT.ExpSum - TckRcT.RSum);
     END;
     NEXT(TckRcT);
     INC(i);
    END; (* WHILE OCCURE(TckRcT) *)
    IF L_EC.ExecE_Func_Scal2(TckRcS.Date, PROCREF(E_TRS.MustInputEasySalesOnTckRcSAccept), 1) THEN
     L_General.Assert(InCashSum - InCashRSum = InSaleSum,
                      "|ࠦ , 饩            "+FLDTOSTR(InCashSum - InCashRSum, "2-", 8) +
                      "|ࠦ , 饩   த "+FLDTOSTR(InSaleSum, "2-", 8));
    END;
   END;

  ELSE
   REMSEL(TckRcT);
   i:=0;
   WHILE ~!pta[i] DO
    DEFAULT(TckRcT);
    TckRcT.TckRcS:=TckRcS.TckRcS;
    pt_Unpack(pta[i], TckRcT.TckRcT, TckRcT.TckKind, TckRcT.Series, TckRcT.BefNbr, TckRcT.asCUCopy, _Psg);
    INSERT(TckRcT);
    INC(i);
   END; (* WHILE i ... *)
  END;
 END {TckRcS_AcceptSummary};

 PUBLIC PROCEDURE CheckTckRcSRelatedDocs();
  VAR
   hasCashAccept: SCAL[2];
 BEGIN
  SELECT(TckRcD, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcD) DO
   L_General.Assert(TckRcD.Status # trdStat_Prepared,
                    "   ﭨ '⮢' - " + TckRcD.TckRcD);
   NEXT(TckRcD);
  END; (* WHILE OCCURE(TckRcD) ... *)
  hasCashAccept:=0;
  SELECT(TckRcC, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcC) DO
   L_General.Assert(TckRcC.Status # trcStat_Prepared,
                    "   ﭨ '⮢' - " + TckRcC.TckRcC);
   IF (TckRcC.Status = trcStat_Passed) & (TckRcC.Type = trct_CashAccept) THEN
    hasCashAccept:=1;
   END;
   NEXT(TckRcC);
  END; (* WHILE OCCURE(TckRcC) ... *)
  L_General.Assert(hasCashAccept, "   䨪஢ 'ਥ '");
 END {CheckTckRcSRelatedDocs};

 PRIVATE VAR
  prvOnDate: DATE;

 PUBLIC PROCEDURE tos_GetSwitchFactTime(OnDate: DATE): TIME;
  VAR
   D   : DATE;
   Plan,
   Fact: TIME;
 BEGIN
  P_OwnData.GetP_TckOfficeShifts(OnDate, D, Plan, Fact);
  IF D = OnDate THEN
   RETURN Fact;
  ELSE
   RETURN EMPTYOF(TIME);
  END;
 END {tos_GetSwitchFactTime};

 PRIVATE PROCEDURE tos_GetSwitchPlanTime(OnDate: DATE): TIME;
  VAR
   D   : DATE;
   Plan,
   Fact: TIME;
 BEGIN
  P_OwnData.GetP_TckOfficeShifts(OnDate, D, Plan, Fact);
  RETURN Plan;
 END {tos_GetSwitchPlanTime};

 PUBLIC PROCEDURE tos_ItIsTimeToSwitch(): SCAL[2];
  VAR
   D   : DATE;
   Plan,
   Fact: TIME;
 BEGIN
  P_OwnData.GetP_TckOfficeShifts(SYSDATE(), D, Plan, Fact);
  RETURN Math.Abs(SYSTIMESTAMP()-PackTIMESTAMP(SYSDATE(), Plan)) < 0.5/24;
 END {tos_ItIsTimeToSwitch};

 PRIVATE PROCEDURE tos_IsWorkingInCorrectShift(): SCAL[2];
 BEGIN
  IF !tos_GetSwitchFactTime(SYSDATE()) &
     (SYSTIME() > tos_GetSwitchPlanTime(SYSDATE())) &
     ~tos_ItIsTimeToSwitch() THEN
   RETURN 0
  ELSE
   RETURN 1;
  END;
 END {tos_IsWorkingInCorrectShift};

 PUBLIC PROCEDURE GetTRCOnDate(): DATE;
  CONST
   badDate = "⠭ ୠ ⥪ :|";
  VAR
   Result: DATE;
 BEGIN
  IF (L_Way.E_TckRcLevel(SYSDATE()) = il_Full) | (L_Way.E_TckRcLevel(SYSDATE()+1) = il_Full) THEN
   Result:=SYSDATE();
   IF !tos_GetSwitchFactTime(Result) THEN
    DEC(Result);
   END;
   IF (Result # prvOnDate) & ~tos_IsWorkingInCorrectShift() THEN
    L_StdFrm.CrucialChoice(" ६  ᬥ 諮. ,  뫨 ' ᬥ'",
                           L_APtm.g_TckCashier);
   END;
  ELSE
   Result:=Memo.ud_cd();
   IF    Result < (SYSDATE()-1) THEN
    IF IsMainTckCashier() THEN
     IF Result # prvOnDate THEN
      L_StdFrm.Question(", 訩  , ࠡ⠥  " + L_DatTim.DateStr(Result));
     END;
    ELSE
     L_General.Error(badDate + " ࠡ ⮫쪮  ''.|  襬 ⭮ ");
    END;
   ELSIF Result = SYSDATE() THEN
    L_General.Error(badDate + "ࠡ '  ' 饭");
   ELSIF Result > SYSDATE() THEN
    L_General.Error(badDate + "ࠡ  '饬' ");
   END;
  END;
  prvOnDate:=Result;
  RETURN Result;
 END {GetTRCOnDate};

 PUBLIC PROCEDURE GetTRDOnDate(): DATE;
  VAR
   Result: DATE;
 BEGIN
  Result:=L_BegRWS.DspSysDate();
  IF ~E_HasTckAtStorage(Result) THEN
   Result:=GetTRCOnDate();
  END;
  RETURN Result;
 END {GetTRDOnDate};

 PRIVATE PROCEDURE Build_DfSpAct();
  VAR
   Value: NUMERIC[2];
 BEGIN
  L_General.Assert(TckRcS.TotCash >= 0, " 묨   < 0");
  Value:=L_Way.GetAdjustedTckRcSTotTInc() - TckRcS.TotCash;
  IF Value # 0 THEN
   DEFAULT(TckRcC);
   TckRcC.Total :=Math.Abs(Value);
   TckRcC.Date  :=GetTRCOnDate();
   TckRcC.TSN   :=TckRcS.TSN;
   TckRcC.TckRcS:=TckRcS.TckRcS;
   IF Value > 0 THEN
    TckRcC.Type:=trct_DeficitAct;
   ELSE
    TckRcC.Type:=trct_SurPlusAct;
   END;
   INSERT(TckRcC);
(*
   IF STDFORM("|⮢  ᢥન||" +
              L_StdFrm.DrawButton(" {} ", 0, "X") + "   " +
              L_StdFrm.DrawButton(" {}⮢ ", 0, "FDB"), , INFORM) THEN
    SAVE(TckRcC);
    CALL(BegTRS.PrintReviseActTckLine());
    RESTORE(TckRcC);
   END;
*)
   L_StdFrm.CrucialChoice("㤥 ନ஢ '" + L_Str.PoolItem(trct_Pool, TckRcC.Type) +
                          "'  㬬 " + FLDTOSTR(TckRcC.Total, "2-", 0) +
                          "||( ஢ન १⮢   ' ᢥન'. . F9)",
                          L_APtm.g_TckCashier);
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_TckRcC, L_XDoc.EmptyXDocKind, TckRcC.TckRcC, L_XDoc.action_AutoBuild);
   CALL(TckRcC, L_Events.md_SingleMakeDone);
  END; (* IF Value # 0 ... *)
 END {Build_DfSpAct};

 PRIVATE PROCEDURE Build_TckWrOffLack();
  VAR
   InCashRSum: NUMERIC[2];
 BEGIN
  SETZERO(InCashRSum);
  SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcT) DO
   CONFORM(TckRcT, TckKind);
   IF TckKind.InCash # tkc_No THEN
    INC(InCashRSum, TckRcT.RSum);
   END;
   NEXT(TckRcT);
  END; (* WHILE OCCURE(TckRcT) *)

  IF InCashRSum > 0 THEN
   DEFAULT(TckRcC);
   TckRcC.Total :=InCashRSum;
   TckRcC.Date  :=GetTRCOnDate();
   TckRcC.TSN   :=TckRcS.TSN;
   TckRcC.TckRcS:=TckRcS.TckRcS;
   TckRcC.Type  :=trct_TckWriteOffLack;
   INSERT(TckRcC);
   L_StdFrm.Choice("㤥 ନ஢ '" + L_Str.PoolItem(trct_Pool, TckRcC.Type) +
                   "'  㬬 " + FLDTOSTR(TckRcC.Total, "2-", 0) +
                   "||( ஢ન १⮢   ' ᢥન'. . F9)");
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_TckRcC, L_XDoc.EmptyXDocKind, TckRcC.TckRcC, L_XDoc.action_AutoBuild);
   CALL(TckRcC, L_Events.md_SingleMakeDone);
  END;
 END {Build_TckWrOffLack};

 PUBLIC PROCEDURE AcceptTckRcS();
 BEGIN
  TckRcS_AcceptSummary(ass_Begining);
  TckRcS_AcceptSummary(ass_Finishing);
  TckRcS.Status:= trsStat_Taken;
  REPLACE(TckRcS);
  Build_TckWrOffLack();
  Build_DfSpAct();
 END {AcceptTckRcS};

 PUBLIC PROCEDURE CheckStaffAdaptability(_TSN: LIKE(Staff.TSN); D: DATE);
 BEGIN
  L_General.CallUs(SEARCH(Staff, TSN, _TSN));
  L_General.Assert(L_Env.RealTSN(Staff.TSN), "  㪠 ॠ ࠡ⭨");
  IF ~L_Staff.rInState(D) THEN
   L_AcsPnt.PassAccessPoint(0000061);
  END;
 END {CheckStaffAdaptability};

 PUBLIC PROCEDURE E_GetDefaultAsWho(_TSN: LIKE(Staff.TSN); D: DATE): LIKE(TckRcS.AsWho);
  VAR
   AsWho: LIKE(TckRcS.AsWho);
   local: PROC;
 BEGIN
  L_Staff.PosToStaffLog(_TSN, D, 1);
  CONFORM(StaffLog, Officer);
  IF    L_Env.IsDriver() THEN
   AsWho:=L_Way.trs_Driver;
  ELSIF L_Env.IsGuard() THEN
   AsWho:=L_Way.trs_Guard;
  ELSE
   SETEMPTY(AsWho);
  END;
  local:=PROCREF(E_TRS.GetDefaultAsWho);
  IF ~!local THEN
   RETURN local(_TSN, D, AsWho);
  ELSE
   RETURN AsWho;
  END;
 END {E_GetDefaultAsWho};

 PUBLIC PROCEDURE E_GetDefaultAsWhoCnd(_TSN: LIKE(Staff.TSN); D: DATE): LIKE(TckRcS.AsWhoCnd);
  VAR
   AsWhoCnd: LIKE(TckRcS.AsWhoCnd);
   local   : PROC;
 BEGIN
  SETEMPTY(AsWhoCnd);
  local:=PROCREF(E_TRS.GetDefaultAsWhoCnd);
  IF ~!local THEN
   RETURN local(_TSN, D, AsWhoCnd);
  ELSE
   RETURN AsWhoCnd;
  END;
 END {E_GetDefaultAsWhoCnd};

 PUBLIC PROCEDURE GetDefaultToSheetSign(): LIKE(TckRcS.ToSheet);
 BEGIN
  IF    (TckRcS.AsWho = L_Way.trs_Chopper) THEN
   RETURN L_Way.toSheet_Dummy;
  ELSIF (TckRcS.AsWho = L_Way.trs_Guard) & L_Way.E_TckRcSIsMainForGuard(TckRcS.Date) THEN
   IF L_BegRWS.E_TWOLevel(TckRcS.Date) & ~!TckRcS.Date THEN
    TRY
     L_two.StandOnMtwo(TckRcS.TSN, L_two.who_Guard, L_DatTim.Per(TckRcS.Date));
     IF Mtwo.HldOff[L_two.Date2Idx(TckRcS.Date)] THEN
      RETURN L_Way.toSheet_Holid;
     END;
    EXCEPT
    ON Exc: Exc_Syntax DO
     RAISE();
    ELSE
    END; (* TRY *)
   END;
   RETURN L_Way.toSheet_Sheet;
  ELSE
   RETURN L_Way.toSheet_SeeRsp;
  END;
 END {GetDefaultToSheetSign};

 PUBLIC PROCEDURE E_SetDefaultTckRcS_Signs(D: DATE);
  VAR
   local: PROC;
 BEGIN
  TckRcS.ToSheet :=GetDefaultToSheetSign();
  IF    (TckRcS.AsWho = L_Way.trs_Chopper) THEN
   TckRcS.Gap    :=0;
   TckRcS.ToPay  :=1;
  ELSIF (TckRcS.AsWho = L_Way.trs_Guard) & L_Way.E_TckRcSIsMainForGuard(D) THEN
   TckRcS.Gap    :=L_Way.trsGap_SeeRsp;
   TckRcS.ToPay  :=1;
  ELSE
   TckRcS.Gap    :=L_Way.trsGap_SeeRsp;
   TckRcS.ToPay  :=L_Way.toPay_SeeRsp;
  END;
  local:=PROCREF(E_TRS.SetDefaultTckRcS_Signs);
  IF ~!local THEN
   local(D);
  END;
 END {E_SetDefaultTckRcS_Signs};

 PUBLIC PROCEDURE Insert_TckRcS(D        : DATE;
                                _TSN     : LIKE(Staff.TSN);
                                _Storage : LIKE(Storage.Storage);
                                _AsWho   : LIKE(TckRcS.AsWho);
                                _AsWhoCnd: LIKE(TckRcS.AsWhoCnd);
                                _asRWayS : LIKE(TckRcS.asRWayS);
                                _asBoxNbr: LIKE(TckRcS.asBoxNbr);
                                _Message : STRING[]);
 BEGIN
  L_General.Assert(~(SELECT(TckRcS, Storage, _Storage) & LAST(TckRcS) & (TckRcS.Status < trsStat_Taken)),
                   "⨬ ଫ   㬪 " + _Storage +
                   "|( ਭ   㪠 㬪");
  DEFAULT(TckRcS);
  TckRcS.Date    :=D;
  TckRcS.TSN     :=_TSN;
  TckRcS.Storage :=_Storage;
  TckRcS.AsWho   :=_AsWho;
  TckRcS.AsWhoCnd:=_AsWhoCnd;
  TckRcS.asRWayS :=_asRWayS;
  TckRcS.asBoxNbr:=_asBoxNbr;
  SETZERO(TckRcS.TotCash, TckRcS.CopyCnt);
  TckRcS.Done    :=0;
  TckRcS.Status  :=trsStat_Ordered;
  TckRcS.Conv    :=0;
  E_SetDefaultTckRcS_Signs(D);
  TckRcS.PlAsFc:=0;
  TckRcS.Message :=L_lsStore.Insert(_Message);
  INSERT(TckRcS);
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, TckRcS.TckRcS,
                      L_XDoc.action_AutoBuild);
 END {Insert_TckRcS};

 PUBLIC PROCEDURE Correct_TckRcD_PassDTS();
  VAR
   _TckRcD   : LIKE(TckRcD.TckRcD);
   curTRDDate: DATE;
 BEGIN
  L_General.CallUs(OCCURE(TckRcD));
  _TckRcD   :=TckRcD.TckRcD;
  curTRDDate:=TckRcD.Date;
  IF IsSaleTckRcD(TckRcD.Type) THEN
   TckRcD.PassDTS:=SYSTIMESTAMP();
   REPLACE(TckRcD);
  ELSE
   LOOP
    SAVE(TckRcD);
    CHANGESEL(TckRcD, Storage, , TckRcD.Storage);
    LAST(TckRcD);
    IF (TckRcD.Date > curTRDDate) & ~IsSaleTckRcD(TckRcD.Type) THEN
     L_General.CallUs(L_Way.E_TckRcLevel(TckRcD.Date) < il_Full);
     L_General.Error(" ନ   ⮩ " + L_DatTim.DateStr(curTRDDate) + "," +
                     "|..  ⭮ 㬪    " + L_DatTim.DateStr(TckRcD.Date) + "." +
                     "||室 ⠭  ⥪ .");
    END;
    IF TckRcD.TckRcD = _TckRcD THEN
     RESTORE(TckRcD);
     EXIT;
    ELSE
     RESTORE(TckRcD);
    END;
    SLEEP(0.1);
    TckRcD.PassDTS:=SYSTIMESTAMP();
    REPLACE(TckRcD);
   END; (*LOOP*)
  END;
 END {Correct_TckRcD_PassDTS};

 PUBLIC PROCEDURE Insert_TckRcD(trdt    : tTckRcDType;
                                _TckRcS : LIKE(TckRcS.TckRcS);
                                _Storage: LIKE(Storage.Storage));
 BEGIN
  DEFAULT(TckRcD);
  TckRcD.Date   :=GetTRDOnDate();
  TckRcD.Storage:=_Storage;
  TckRcD.Type   :=trdt;
  TckRcD.TckRcS :=_TckRcS;
  IF SEARCH(TckRcS, TckRcS, _TckRcS) THEN
   TckRcD.TSN   :=TckRcS.TSN;
  END;
  TckRcD.CopyCnt:=1;
  TckRcD.Status :=trdStat_Passed;
  SLEEP(0.001); (* sic! *)
  TckRcD.PassDTS:=SYSTIMESTAMP();
  TckRcD.Done   :=0;
  INSERT(TckRcD);
  Correct_TckRcD_PassDTS();
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD, L_XDoc.action_AutoBuild);
 END {Insert_TckRcD};

 PUBLIC PROCEDURE Insert_TckRcDL(_TRDLNbr: LIKE(TckRcDL.TRDLNbr);
                                 _TckKind: LIKE(TckRcDL.TckKind);
                                 _Series : STRING[];
                                 _RestNbr: LIKE(TckRcDL.RestNbr);
                                 _Psg    : LIKE(TckRcDL.Psg);
                                 _CUCopy : LIKE(TckRcDL.CUCopy));
 BEGIN
  DEFAULT(TckRcDL);
  TckRcDL.TckRcD:=TckRcD.TckRcD;
  TckRcDL.TRDLNbr:=_TRDLNbr;
  TckRcDL.TckKind:=_TckKind;
  TckRcDL.Series :=L_Str.Right(_Series, Str.MaxLength(TckRcDL.Series));
  TckRcDL.RestNbr:=_RestNbr;
  TckRcDL.Psg    :=_Psg;
  TckRcDL.CUCopy :=_CUCopy;
  INSERT(TckRcDL);
  IF !TckRcDL.TRDLNbr THEN
   AssignTckRcDL_TckNbr();
  END;
  CompleteTckRcDL();
 END {Insert_TckRcDL};

 PUBLIC PROCEDURE PositionOnTckRcS(_TSN    : LIKE(Staff.TSN);
                                   _Storage: LIKE(Storage.Storage);
                                   D       : DATE;
                                   _Status : LIKE(TckRcS.Status)): SCAL[2];
  VAR
   emptyTckRcS: LIKE(TckRcS.TckRcS);
 BEGIN
  SELECT(TckRcS, sTSN, , _Status, _TSN, D);
  IF ~!_Storage THEN
   SETEMPTY(emptyTckRcS);
   WHILE OCCURE(TckRcS) & (TckRcS.Storage # _Storage) DO
    IF !TckRcS.Storage THEN
     emptyTckRcS:=TckRcS.TckRcS;
    END;
    NEXT(TckRcS);
   END;
   IF ~OCCURE(TckRcS) & ~!emptyTckRcS THEN
    SEARCH(TckRcS, TckRcS, , emptyTckRcS);
   END;
  END;
  RETURN OCCURE(TckRcS);
 END {PositionOnTckRcS};

 PUBLIC PROCEDURE CheckDeviceMovementFeasibility(_CUCopy : LIKE(CUCopy.CUCopy);
                                                 tkType  : tTckKindType;
                                                 trdType : tTckRcDType;
                                                 _TckRcS : LIKE(TckRcD.TckRcS);
                                                 _Storage: LIKE(TckRcD.Storage));
  VAR
   ts          : tTckState;
   curStorage  : LIKE(Storage.Storage);
   curTckRcS   : LIKE(TckRcS.TckRcS);
   trsCUCopy   : LIKE(CUCopy.CUCopy);
   deviceName  : STRING[];
 BEGIN
  deviceName:="ன⢮ (" + GetDeviceName(tkType) + ")";
  getTckLastLocation(0, _CUCopy, ts, curStorage, curTckRcS);
  IF trdType = trdt_Laying THEN
   IF ~!curTckRcS THEN
    L_General.Error(" " + deviceName + " 뤠   " + curTckRcS);
   END;
(*
   trsCUCopy:=Get_trsDevice(_Storage, _TckRcS, tkType);
   IF ~!trsCUCopy THEN
    L_General.Error(" 㬪 㦥   " + deviceName + " - " + trsCUCopy);
   END;
*)
  ELSE
   L_General.Assert(_TckRcS = curTckRcS, " " + deviceName + "  뫮 뤠  㪠 ");
  END;
 END {CheckDeviceMovementFeasibility};

 CONST
  ed_NoRemovableDrive = "04.01.2007 18:54:41 POLAK\GAV";

 PRIVATE PROCEDURE GetDrive(Id: STRING[]): STRING[];
  CONST
   idFileExt = "ID";
   dt_Removable = 1;
  VAR
   fso,
   Drive     : OBJECT;
   Files,
   Drives    : ENUMERATOR;
   FileName,
   FileExt,
   Result    : STRING[];
   BadIdCnt,
   GoodIdCnt,
   totalCnt,
   errorCnt,
   Delay     : NUMERIC[0];
 BEGIN
  fso:=CreateOBJECT("Scripting.FileSystemObject");
  LOOP
   SETZERO(totalCnt, errorCnt);
   Drives    :=CreateENUMERATOR(fso.Drives);
   WHILE ~Drives.AtEnd() DO
    Drive:=Drives.Item();
    PROMPT(" ன⢠ ꥬ : " + Drive.DriveLetter);
    IF (Drive.DriveLetter > "B") &
       (Drive.DriveType = dt_Removable) &
       (Drive.IsReady = -1(*True -  ।  100 !*)) THEN
     INC(totalCnt);
     Result:=Drive.DriveLetter+":\";
     Files:=CreateENUMERATOR(fso.GetFolder(Result).Files);
     SETZERO(BadIdCnt, GoodIdCnt);
     WHILE ~Files.AtEnd() & ~BadIdCnt DO
      FileName:=Str.Cap(Files.Item().Name);
      PROMPT(" ன⢠ ꥬ : " + Result + FileName);
      FIO.SplitPath(FileName, FileName, FileExt);
      IF FileExt = idFileExt THEN
       IF FileName = Str.Cap(Id) THEN
        INC(GoodIdCnt);
       ELSE
        INC(BadIdCnt);
       END;
      END;
      Files.MoveNext();
     END;
     IF BadIdCnt = 0 THEN
      IF GoodIdCnt = 1 THEN
       RETURN Result;
      END;
     ELSE
      INC(errorCnt);
     END;
    END;
    Drives.MoveNext();
   END; (* WHILE ~Drives.AtEnd()...*)
   Delay:=5;
   IF STDFORM("|" +
              "㦥 ன ꥬ : " + L_Str.IntStr(totalCnt) +
              "|" +
              "       ..  䠩 䨪樨: " + L_Str.IntStr(errorCnt) +
              "||" +
              "ன⢮  ॡ㥬 䠩  㦥" +
              "|" +
              "(" + Id + ")" +
              "||" +
              "%< {} %T >DB %< {}⬥ >X",
              "  ⮢ ன⢮ ꥬ  ",
              STOP, , Delay) = 0 THEN
    RAISE(-1, ed_NoRemovableDrive);
   END;
  END;
 END {GetDrive};

 PUBLIC PROCEDURE KKMAdditionalActions(trgType: tTckRcDType;
                                       _CUCopy: LIKE(CUCopy.CUCopy);
                                       _TckRcS: LIKE(TckRcS.TckRcS));
  CONST
   TripFN = "trip.txt";
  VAR
   Dummy,
   SrcFile,
   DstFile,
   FlashDrive: STRING[];
   fso       : OBJECT;
 BEGIN
  TRY
   IF L_General.GetAPSiteNumber() = 50 THEN
    IF ~!_CUCopy THEN
     L_General.CallUs(SEARCH(TckRcS, TckRcS, _TckRcS));

     L_General.Assert(SEARCH(RWayS, RWayS, TckRcS.asRWayS[0]), " 㪠 ⥢ ");

     IF    P_Car.HasActualCarPro(RWayS.BoxNbr, TckRcS.Date, P_Car.P_WithASCP) THEN
      L_General.Assert(L_CUC.AccessLastMDocLCU(_CUCopy) & L_CUC.IsCUAtCar(MDocLCU.OpKind),
                       "  ⠭  ");
      L_General.Assert(RWayS.BoxNbr = MDocLCU.BoxNbr,
                       " ⠭  㣮  (" + MDocLCU.BoxNbr + ")");
      L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
      CONFORM(CarLog, Mark);
      CONFORM(RWayS, Staff);
      CONFORM(Staff, Man);
  
      FlashDrive:=GetDrive(_CUCopy);
      IF    trgType = trdt_Laying THEN
       SrcFile:=FIO.BuildPath(TripFN, , "REP\ZVEZDA");
       PROMPT("஢ " + SrcFile);
       DstFile:=FIO.BuildPath(TripFN, , FlashDrive);
       FIO.Open(Src, SrcFile, , Input);
       FIO.Open(Dst, DstFile, , Create);
       FIO.SetCP(Dst, FIO.CP_WindowsRussian);
       FIO.WrStr(Dst, "=" + Man.Name);                          FIO.WrLn(Dst);
       FIO.WrStr(Dst, "="   + Mark.Name + " " + CarLog.StateNbr); FIO.WrLn(Dst);
       FIO.WrStr(Dst, "=" + RWayS.BoxNbr);                      FIO.WrLn(Dst);
       FIO.Copy(Src, Dst);
       FIO.Close(Src);
       FIO.Close(Dst);
  
       SrcFile:=FIO.BuildPath("*", "*", "REP\ZVEZDA\UPDATE");
       IF FIO.Exists(SrcFile) THEN
        PROMPT("஢ ");
        fso:=CreateOBJECT("Scripting.FileSystemObject");
        fso.CopyFile(FIO.BuildPath(SrcFile, , FIO.AsbSpecialFolders("ClientProjectRoot")), FlashDrive);
       END;
      ELSE
       WHILE FIO.Exists(FIO.BuildPath("*", "log", FlashDrive), , SrcFile) DO
        FIO.SplitPath(SrcFile, DstFile, , Dummy);
        DstFile:=FIO.BuildPath(DstFile, , "REP\ZVEZDA\LOG");
        PROMPT("஢ " + DstFile);
        L_FIO.FileCopy(SrcFile, DstFile);
        PROMPT(" " + SrcFile);
        FIO.Erase(SrcFile);
       END;
      END;
      L_StdFrm.Inform("஢  襭");
     ELSE
      IF L_CUC.AccessLastMDocLCU(_CUCopy) & L_CUC.IsCUAtCar(MDocLCU.OpKind) THEN
       IF RWayS.BoxNbr = MDocLCU.BoxNbr THEN
        L_General.Error(" "+ MDocLCU.BoxNbr + "  㤮 ???");
       ELSE
        L_General.Error(" ⠭  㣮  ("+ MDocLCU.BoxNbr + ")");
       END;
      END;
     END;
    END;
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   L_SysLog.ELN_Put("KKMAdditionalActions", Exc.Description);
(*
   IF (Exc.ErrorCode # -1) | (Exc.MsgOriginalText # ed_NoRemovableDrive) THEN
    L_StdFrm.RedInform(Exc.MsgOriginalText);
   END;
*)
   L_StdFrm.CrucialChoice("|" + L_Str.PoolItem(trdt_Pool, trgType) + " ." +
                          "| 믮 ⥫ 権 ந諠 訡:" +
                          "|" +
                          "|" + Exc.MsgOriginalText +
                          L_StdFrm.HR() +
                          "த ?", L_APtm.g_TckCashier);
  END; (* TRY *)
 END {KKMAdditionalActions};

 PUBLIC PROCEDURE VLDAdditionalActions(trgType: tTckRcDType;
                                       _CUCopy: LIKE(CUCopy.CUCopy);
                                       _TckRcS: LIKE(TckRcS.TckRcS));
  VAR
   kskd_Path,
   kskd_FilesMask: STRING[];
   kskd_Folder   : FOLDERENTRY;
   kskd_Files    : ENUMERATOR;
   kskd_File     : OBJECT;
   kskd_maxDTS   : FLOAT;
 BEGIN
  TRY
   IF L_General.GetAPSiteID() = "SP" THEN
    IF ~!_CUCopy THEN
     IF trgType = trdt_Return THEN
      L_General.CallUs(SEARCH(TckRcS, TckRcS, _TckRcS));
      IF P_CUC.HasActualCUCPro(_CUCopy, SYSDATE(), P_CUC.P_AdditionalId) THEN
       L_General.CallUs(SEARCH(CUCopy, CUCopy, _CUCopy));
       IF CUCopy.Math = 05120 THEN
        kskd_Path:="\\Kaskad\terminals\DATA\USK-07\Poezdki\Kond";
       ELSE
        kskd_Path:="\\Kaskad\terminals\DATA\Bort\Poezdki\Bort";
       END;
       kskd_maxDTS:=0;
       IF SYSTIME() < 05:00 THEN
        kskd_FilesMask:=FLDTOSTR(SYSDATE()-1, "YND", 0) + CUCPro.Value + ".P??";
       ELSE
        kskd_FilesMask:=FLDTOSTR(SYSDATE(),   "YND", 0) + CUCPro.Value + ".P??";
       END;
       L_General.Assert(FIO.DirExists(kskd_Path), "   ||" + kskd_Path + "||" +
                                                  " 稭: ६ ⥢ ஡");
       kskd_Folder   :=FOLDERENTRY.Create(kskd_Path);
       kskd_Files    :=CreateENUMERATOR(kskd_Folder.FolderContent);
       WHILE ~kskd_Files.AtEnd() DO
        kskd_File:=kskd_Files.Item();
        IF Str.Match(kskd_File.Path, "*"+kskd_FilesMask) THEN
         kskd_maxDTS:=Math.Max(kskd_maxDTS, kskd_File.DateLastModified);
        END;
        kskd_Files.MoveNext();
       END; (* WHILE ~kskd_Files.AtEnd()...*)
       IF kskd_maxDTS = 0 THEN
        L_General.Error(" 㦥   䠩 ਥ   ");
       ELSE
        IF L_DatTim.GetSysVARIANTDATE() > (kskd_maxDTS + 45 * (1/24/60)) THEN
         L_General.Error("  ᫥ ꥬ    諮 " +
                         FLDTOSTR(L_DatTim.GetVARIANTDATEPeriod_Hour(kskd_maxDTS, L_DatTim.GetSysVARIANTDATE()), "3.", 0)  + " ");

        END;
       END;
      ELSE
       L_General.Error(" 㪠      " + _CUCopy);
      END;
     END;
    END;
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   L_SysLog.ELN_Put("VLDAdditionalActions", Exc.Description + " (" + _CUCopy + ")");
   L_StdFrm.Choice(Exc.MsgOriginalText);
  END; (* TRY *)
 END {VLDAdditionalActions};

 PUBLIC PROCEDURE InsTckRcDLForDeviceMovement(tkt     : tTckKindType;
                                              trgType : tTckRcDType;
                                              _TRDLNbr: LIKE(TckRcDL.TRDLNbr);
                                              _TckRcS : LIKE(TckRcS.TckRcS);
                                              _Storage: LIKE(Storage.Storage);
                                              _CUCopy : LIKE(CUCopy.CUCopy);
                                              _RestNbr: tTckNumber;
                                              _Psg    : LIKE(TckRcDL.Psg));
 BEGIN
  CALL(TckRcD.Proceed(-1));
  CheckDeviceMovementFeasibility(_CUCopy, tkt, trgType, _TckRcS, _Storage);
  SEARCH(CUCopy, CUCopy, , _CUCopy);
  SEARCH(TckKind, TckKind, , GetMathTckKind(CUCopy.Math, tkt, TckRcD.Date));
  IF ((tkt = tkt_KKMActivities) | (tkt = tkt_BankCardTerminal)) & !_RestNbr THEN
   IF TckKind.NbrsDir = nd_None THEN
    _RestNbr:=0;
   ELSE
    _RestNbr:=getTckLastRestNbr(0, CUCopy.CUCopy);
   END;
   L_General.Assert(~!_RestNbr, " 뤠 ன⢠ ᫥ ஢ ᫥ 뤠  㬥⮬ ");
  END;
  L_General.CallUs(SEARCH(CUCopy, CUCopy, _CUCopy));
  Insert_TckRcDL(_TRDLNbr, TckKind.TckKind, CUCopy.Serial, _RestNbr, _Psg, CUCopy.CUCopy);
  IF    tkt = tkt_KKMActivities THEN
   KKMAdditionalActions(trgType, _CUCopy, _TckRcS);
  ELSIF tkt = tkt_VLDActivities THEN
   VLDAdditionalActions(trgType, _CUCopy, _TckRcS);
  END;
  CALL(TckRcD.Proceed(+1));
 END {InsTckRcDLForDeviceMovement};

 PUBLIC PROCEDURE TckRcSLevel(): tImpLevel;
 BEGIN
  IF ~!TckRcS.Storage THEN
   RETURN L_Way.E_TckRcLevel(TckRcS.Date);
  ELSIF L_Way.E_TckRcLevel(TckRcS.Date) # il_None THEN
   RETURN il_woBeg;
  ELSE
   RETURN il_None;
  END;
 END {TckRcSLevel};

 PUBLIC PROCEDURE SetupShiftBorders(D: DATE;
                                    VAR shiftBegDate, shiftEndDate: DATE;
                                    VAR shiftBegTime, shiftEndTime: TIME);
 BEGIN
  shiftBegDate:=D;
  shiftBegTime:=tos_GetSwitchFactTime(shiftBegDate);
  L_General.Assert(~!shiftBegTime, L_DatTim.DateStr(shiftBegDate) + " - ᬥ   砫");
  shiftEndDate:=shiftBegDate+1;
  shiftEndTime:=tos_GetSwitchFactTime(shiftEndDate);
 END {SetupShiftBorders};

 PUBLIC PROCEDURE SetupTicketKassaShiftBorders(D: DATE;
                                               VAR shiftBegDate, shiftEndDate: DATE;
                                               VAR shiftBegTime, shiftEndTime: TIME);
 BEGIN
  IF E_HasTckAtStorage(D) THEN
   shiftBegDate:=D;
   shiftBegTime:=P_OwnData.DspRepTime(shiftBegDate);
   L_General.Assert(shiftBegDate <= GetTRDOnDate(),
                    L_DatTim.DateStr(shiftBegDate) + " - ᬥ   砫");
   shiftEndDate:=shiftBegDate+1;
   shiftEndTime:=P_OwnData.DspRepTime(shiftEndDate);
  ELSE
   SetupShiftBorders(D, shiftBegDate, shiftEndDate, shiftBegTime, shiftEndTime);
  END;
 END {SetupTicketKassaShiftBorders};

 PUBLIC PROCEDURE AccessTckRcS();
 BEGIN
  L_General.Assert(ACCESS(TckRcS), " ࠭ ⭮- ");
 END {AccessTckRcS};

 PUBLIC PROCEDURE CheckTicketSeries(_TckKind: LIKE(TckKind.TckKind); _Series: tTckSeries);
  VAR
   Err: STRING[];
 BEGIN
  SAVE(TckKind);
  L_General.CallUs(SEARCH(TckKind, TckKind, _TckKind));
  IF (TckKind.Type = tkt_Ticket) & ~!TckKind.SrsPat THEN
   Err:=L_Str.TestStrWMask("  ", _Series, TckKind.SrsPat, TckKind.SrsPat);
   L_General.Assert(!Err, Err);
  END;
  RESTORE(TckKind);
 END {CheckTicketSeries};

 PUBLIC PROCEDURE CheckGivenTckRcS(_TSN: LIKE(Staff.TSN));
 BEGIN
  IF SELECT(TckRcS, sTSN, L_Way.rwsStat_Given, _TSN) THEN
   L_General.Error(" 뤠  (" +
                   TckRcS.TckRcS + "  " + L_DatTim.DateStr(TckRcS.Date) + ")");
  END;
 END {CheckGivenTckRcS};

 PUBLIC PROCEDURE IsGoodRWayJForIncome(): SCAL[2];
 BEGIN
  L_General.Assert(~!RWayJ.Quality, " " + RWayJ.Trip + "  । ⢮");
  CONFORM(RWayJ, Quality, Route, WJMode);
  RETURN L_Way.RWayJWithPlIncome();
 END {IsGoodRWayJForIncome};

 PUBLIC PROCEDURE IsStandOnRWaySExit(): SCAL[2];
 BEGIN
  CONFORM(RWayS, StExit, ExitClss);
  IF ExitClss.BegType = L_Way.ecbt_Line THEN
   RETURN 1;
  ELSE
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   WHILE OCCURE(RWayJ) DO
    CONFORM(RWayJ, SEJobs, StExit, ExitClss);
    IF ExitClss.BegType = L_Way.ecbt_Line THEN
     RETURN 1;
    END;
    NEXT(RWayJ);
   END; (* WHILE OCCURE(RWayJ) ... *)
  END;
  RETURN 0;
 END {IsStandOnRWaySExit};

 PUBLIC PROCEDURE IsStandOnTckRcSExit(): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(TckRcS.asRWayS) DO
   IF ~!TckRcS.asRWayS[i] & SEARCH(RWayS, RWayS, TckRcS.asRWayS[i]) & IsStandOnRWaySExit() THEN
    RETURN 1;
   END;
   INC(i);
  END;
  RETURN 0;
 END {IsStandOnTckRcSExit};

 PUBLIC PROCEDURE IsVldTckKind(_TckKind: LIKE(TckKind.TckKind)): SCAL[2];
 BEGIN
  RETURN (_TckKind >= tk_MscSocTP) & (_TckKind <= tk_TKDD);
 END {IsVldTckKind};

 PUBLIC PROCEDURE VldPsgKindOfTckKind(_TckKind: LIKE(TckKind.TckKind)): L_Way.tVldPsgKind;
 BEGIN
  L_General.CallUs(IsVldTckKind(_TckKind));
  IF    _TckKind = tk_MscRegionSoc    THEN RETURN L_Way.vpk_MoscowRegion;
  ELSIF _TckKind = tk_MscSoc          THEN RETURN L_Way.vpk_Moscow;
  ELSIF _TckKind = tk_MscSocTP        THEN RETURN L_Way.vpk_Moscow;
  ELSIF _TckKind = tk_MscSocTmp       THEN RETURN L_Way.vpk_OtherSocial;
  ELSIF _TckKind = tk_MscRegionSocTmp THEN RETURN L_Way.vpk_OtherSocial;
  ELSE
   RETURN L_Way.vpk_Paid;
  END;
 END {VldPsgKindOfTckKind};

 PUBLIC PROCEDURE TckKindOfVldCardType(CardType: SCAL[1E2]): LIKE(TckKind.TckKind);
 BEGIN
  IF    (CardType = 23)  THEN RETURN tk_MscRegionSoc;
  ELSIF (CardType = 22)  THEN RETURN tk_MscSoc;
  ELSIF (CardType = 24)  THEN RETURN tk_MscSocTmp;
  ELSIF (CardType = 25)  THEN RETURN tk_MscRegionSocTmp;

  ELSIF (CardType = 01)  THEN RETURN tk_OneTripInOffice; (*  த  *)
  ELSIF (CardType = 03)  THEN RETURN tk_OneTripInBus;    (*  த  ᠫ*)
  ELSIF (CardType = 04)  THEN RETURN 0805; (*஥ த*)
  ELSIF (CardType = 05)  THEN RETURN 0806; (*஥ 饣 த*)
  ELSIF (CardType = 06)  THEN RETURN 0807; (*஥ ਣத*)
  ELSIF (CardType = 07)  THEN RETURN 0808; (*஥ 饣 ਣத*)
  ELSIF (CardType = 08)  THEN RETURN 0809; (*஥ 誮쭨 ᥫ᪮ ⭮*)
  ELSIF (CardType = 09)  THEN RETURN 0810; (* 樠 ஥ *)
  ELSIF (CardType = 11)  THEN RETURN 0811; (*࠭ᯮ⭠  㤭  *)
  ELSIF (CardType = 12)  THEN RETURN 0812; (*஭ 襫*)
  ELSIF (CardType = 26)  THEN RETURN tk_TKDD; (* ६ ⢨ *)
  ELSIF (CardType = 28)  THEN RETURN tk_MscSocTP; (*()*)
  ELSE
   L_General.Error(" ⨯  " + CardType);
  END;
 END {TckKindOfVldCardType};

 PUBLIC PROCEDURE VldPsgKindOfVldCardType(CardType: SCAL[1E2]): L_Way.tVldPsgKind;
 BEGIN
  IF    (CardType = 22)  THEN RETURN L_Way.vpk_Moscow;
  ELSIF (CardType = 23)  THEN RETURN L_Way.vpk_MoscowRegion;
  ELSIF (CardType = 24)  THEN RETURN L_Way.vpk_OtherSocial;
  ELSIF (CardType = 25)  THEN RETURN L_Way.vpk_OtherSocial;
  ELSIF (CardType = 28)  THEN RETURN L_Way.vpk_MoscowRegion;
  ELSE                        RETURN L_Way.vpk_Paid;
  END;
 END {VldPsgKindOfVldCardType};

 PUBLIC PROCEDURE E_IsGoodRouteForElTck(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_TRS.IsGoodRouteForElTck), TckRcJ.Route = ElTck.Route);
 END {E_IsGoodRouteForElTck};

 PUBLIC PROCEDURE E_TRJStartTMeaning(): SCAL[3];
  VAR
   local: PROC;
 BEGIN
  local:=PROCREF(E_TRS.TRJStartTMeaning);
  IF ~!local THEN
   RETURN local(TckRcS.Date);
  ELSE
   RETURN trjstm_Departure;
  END;
 END {E_TRJStartTMeaning};

 PUBLIC PROCEDURE StandOnJobByElTck(wCheckRoute: SCAL[2]): SCAL[3];
  CONST
   Delta = 15/60;
  VAR
   _Day        : LIKE(TckRcJ.Day)[2];
   _StartT     : LIKE(TckRcJ.StartT)[2];
   GoodRoute   : SCAL[2][2];
   Result      : SCAL[3];
   BoardingTime: FLOAT;
 BEGIN
  SETEMPTY(_Day, _StartT);
  SETZERO(GoodRoute);
  IF    E_TRJStartTMeaning() = trjstm_Departure THEN
   BoardingTime:=5/60;
  ELSE
   L_General.Assert(E_TRJStartTMeaning() # trjstm_StopT,
                    "ᥭ     ঠ  㪠  ३ ६ 砭 ३");
   BoardingTime:=0;
  END;
  SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
  SRCINSEL(TckRcJ, LE, , ElTck.DateIn - ElTck.Date + 1, ElTck.TimeIn);
  WHILE OCCURE(TckRcJ) & L_Way.E_IsImaginaryRoute(TckRcS.Date, TckRcJ.Route) DO
   PREV(TckRcJ);
  END;
  IF OCCURE(TckRcJ) THEN
   _Day[0]     :=TckRcJ.Day;
   _StartT[0]  :=TckRcJ.StartT;
   GoodRoute[0]:=~wCheckRoute | E_IsGoodRouteForElTck(TckRcS.Date);
  END;

  IF ~OCCURE(TckRcJ) THEN
   FIRST(TckRcJ);
  ELSE
   NEXT(TckRcJ);
  END;
  WHILE OCCURE(TckRcJ) & L_Way.E_IsImaginaryRoute(TckRcS.Date, TckRcJ.Route) DO
   NEXT(TckRcJ);
  END;

  IF OCCURE(TckRcJ) THEN
   _Day[1]     :=TckRcJ.Day;
   _StartT[1]  :=TckRcJ.StartT;
   GoodRoute[1]:=(~wCheckRoute | E_IsGoodRouteForElTck(TckRcS.Date)) &
                 ((L_Way.FullBegTime(TckRcJ.Day, TckRcJ.StartT) - Delta) <
                   L_Way.FullBegTime(ElTck.DateIn - ElTck.Date + 1, ElTck.TimeIn));
  END;

  IF GoodRoute[0] THEN
   IF GoodRoute[1] & ((L_Way.FullBegTime(_Day[1], _StartT[1]) - BoardingTime) <
                      L_Way.FullBegTime(ElTck.DateIn - ElTck.Date + 1, ElTck.TimeIn)) THEN
    SRCINSEL(TckRcJ, EQ, , _Day[1], _StartT[1]);
   ELSE
    SRCINSEL(TckRcJ, EQ, , _Day[0], _StartT[0]);
   END;
   Result:=sojbet_Found;
  ELSE
   IF GoodRoute[1] THEN
    SRCINSEL(TckRcJ, EQ, , _Day[1], _StartT[1]);
    Result:=sojbet_Found;
   ELSE
    IF !_Day[0] & !_Day[1] THEN
     Result:=sojbet_HasNoJobs;
    ELSE
     Result:=sojbet_NotFound;
    END;
   END;
  END;
(*
  IF Result = sojbet_Found THEN
   IF (L_Way.FullBegTime(ElTck.DateIn - ElTck.Date + 1, ElTck.TimeIn) - L_Way.FullBegTime(TckRcJ.Day, TckRcJ.StartT)) > 2 THEN
    Result:=sojbet_NotFound;
   END;
  END;
*)
  RETURN Result;
 END {StandOnJobByElTck};

 PUBLIC PROCEDURE IsPartialDoneTRS(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  L_General.CallUs(~TckRcS.Done);
  Result:=0;
  SAVE(TckRcJ);
  SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
  WHILE OCCURE(TckRcJ) & ~Result DO
   Result:=~!TckRcJ.asDay;
   NEXT(TckRcJ);
  END; (* WHILE OCCURE(TckRcJ) ... *)
  RESTORE(TckRcJ);
  RETURN Result;
 END {IsPartialDoneTRS};

 PUBLIC PROCEDURE ReplaceElTckAfterBind();
 BEGIN
  TRY
   L_AR.GrantRightsUnconditionally();
   REPLACE(ElTck);
  EXCEPT
  END; (* TRY *)
 END {ReplaceElTckAfterBind};

 PUBLIC PROCEDURE Unbind_ElTck();
 BEGIN
  IF ~!ElTck.TckRcS THEN
   L_General.Assert(~E_FillRWJP(ElTck.Date), " ஢   ० ' '");
   CONFORM(ElTck, TckRcS);
   REPLACE(TckRcS); (*⠢ ஢  㤥 ஢ BORROW*)
   IF TckRcS.Done | IsPartialDoneTRS() THEN
    SAVE(ElTck);
    CALL(TckRcS.SingleMakeUnDone());
    RESTORE(ElTck);
   END;
   SETSEL(TckRcJR, TckRcS, ElTck.TckRcS);
   REMSEL(TckRcJR);
   SAVE(ElTck);
   WHILE SELECT(ElTck, TckRcS, TckRcS.TckRcS) DO
    SETEMPTY(ElTck.TckRcS);
    ElTck.badRoute:=0;
    ReplaceElTckAfterBind();
   END; (* WHILE SELECT(ElTck ... *)
   RESTORE(ElTck);
  END;
 END {Unbind_ElTck};

 PUBLIC PROCEDURE E_FillRWJP(D: DATE): SCAL[2];
 BEGIN
  IF    L_General.GetAPSiteID() = "KL" THEN
   RETURN D < 18\07\2007;
  ELSIF L_General.GetAPSiteID() = "SP" THEN
   RETURN D < 08\10\2007;
  ELSIF L_General.GetAPSiteID() = "ML" THEN
   RETURN D < 18\02\2008;
  ELSIF L_General.GetAPSiteID() = "55" THEN
   RETURN D < 01\03\2008;
  ELSIF L_General.GetAPSiteID() = "OD" THEN
   RETURN D < 01\06\2009;
  ELSIF L_General.GetAPSiteID() = "53" THEN
   RETURN D < 01\10\2009;
  ELSE
   RETURN (L_Way.E_TckRcLevel(D) = il_None) | (L_Way.E_TckRcLevel(D) = il_offLine) | (L_Way.E_TckRcLevel(D) = il_woBeg);
  END;
 END {E_FillRWJP};

 PUBLIC PROCEDURE E_CheckStaffByCard(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_TRS.CheckStaffByCard), 0);
 END {E_CheckStaffByCard};

 PUBLIC PROCEDURE IsBulk_wCUC(): SCAL[2];
 BEGIN
  RETURN (TckKind.Type = tkt_ZonalTicket) | (TckKind.Type = tkt_PieceTck_wCUC);
 END {IsBulk_wCUC};

 PUBLIC PROCEDURE IsBulk(): SCAL[2];
 BEGIN
  RETURN IsBulk_wCUC() | (TckKind.Type = tkt_PieceTck);
 END {IsBulk};

 PUBLIC PROCEDURE RestNbrIsAmount(): SCAL[2];
 BEGIN
  RETURN TckKind.Type = tkt_PieceTck;
 END {RestNbrIsAmount};

 PUBLIC PROCEDURE BulkCUCAmount(): NUMERIC[0];
  VAR
   result: NUMERIC[0];
 BEGIN
  result:=0;
  CONFORM(TckRcDL, TckRcDLL);
  WHILE OCCURE(TckRcDLL) DO
   INC(result, !TckRcDLL.Sum);
   NEXT(TckRcDLL);
  END; (* WHILE OCCURE(TckRcDLL) ... *)
  RETURN result;
 END {BulkCUCAmount};

 PUBLIC PROCEDURE bc_CheckDevices_Init();
 BEGIN
  IF ~!DATABASE.Get().Tables("bccd") THEN
   SETSEL(bccd, bccd);
   REMSEL(bccd);
  ELSE
   L_AFM.MakeIndex("bccd", "_Type: LIKE(TckKind.Type); _CUCopy: LIKE(CUCopy.CUCopy)");
  END;
 END {bc_CheckDevices_Init};

 PUBLIC PROCEDURE bc_CheckDevices_Add(trgType: LIKE(TckKind.Type); _CUCopy: LIKE(CUCopy.CUCopy));
 BEGIN
  bccd._Type  :=trgType;
  bccd._CUCopy:=_CUCopy;
  INSERT(bccd);
 END {bc_CheckDevices_Add};

 PRIVATE PROCEDURE bc_CheckDevices_CheckType(trgType: LIKE(TckKind.Type); ProcessName: STRING[]);
 BEGIN
  WHILE SELECT(bccd, bccd, trgType) DO
   bc_PositionOnDevice(ProcessName, trgType, 0);
   L_General.Assert(SRCINSEL(bccd, EQ, CUCopy.CUCopy),
                    " 㪠 " + GetDeviceName(trgType) + ",   뤠   ");
   REMOVE(bccd);
  END;
 END {bc_CheckDevices_CheckType};

 PUBLIC PROCEDURE bc_CheckDevices_Check(ProcessName: STRING[]);
 BEGIN
  bc_CheckDevices_CheckType(tkt_KKMActivities, ProcessName);
  bc_CheckDevices_CheckType(tkt_VLDActivities, ProcessName);
 END {bc_CheckDevices_Check};

 PUBLIC PROCEDURE bc_CheckDevices_Deinit();
 BEGIN
  L_AFM.AF_PurgeTemp("bccd");
 END {bc_CheckDevices_Deinit};

 PUBLIC PROCEDURE GetIncomesCosItemForTckRcJ(): LIKE(CostItem.CostItem);
  VAR
   byCar  : SCAL[2];
   _MyFirm: LIKE(MyFirm.MyFirm);
 BEGIN
  SAVE(Staff);
  CONFORM(TckRcS, Staff);
  _MyFirm:=Staff.MyFirm;
  RESTORE(Staff);
  CONFORM(TckRcJ, Route);
  L_Way.PositionOnRouteLog(Route.Route, TckRcS.Date);
  IF L_Way.E_IsImaginaryRoute(TckRcS.Date, TckRcJ.Route) | !TckRcJ.asRWayS THEN
   byCar:=0;
  ELSE
   byCar:=1;
   L_RWayS.PositionOnRWayS(TckRcJ.asRWayS);
   CONFORM(RWayS, Car);
  END;
  L_General.Assert(~!RouteLog.CostItem, " ਨ  "+RouteLog.Route+"  㪠   "+L_DatTim.DateStr(TckRcS.Date));
  RETURN L_CI.GetElementOfActivityCostItem(RouteLog.CostItem, TckRcS.Date, _MyFirm, L_CI.erkn_Incomes, byCar);
 END {GetIncomesCosItemForTckRcJ};

 PUBLIC PROCEDURE CorrectPsg(trgTckKind: LIKE(TckKind.TckKind); From: DATE);
  VAR
   BefNbr: LIKE(TckRcT.BefNbr);
   Amount: NUMERIC[0];
   Dummy : NUMERIC[2];
   IsMain: SCAL[2];
 BEGIN
  SEARCH(TckKind, TckKind, , trgTckKind);
  APP.Get().NewPrompt(" ᠦ஢." + TckKind.TckKind);
  SELECT(TckRcS, Date);
  SRCINSEL(TckRcS, GE, , From);
  WHILE OCCURE(TckRcS) DO
   PROMPT(TckRcS.TckRcS);
   SELECT(TckRcT, TckRcS, , TckRcS.TckRcS);
   WHILE OCCURE(TckRcT) DO
    IF TckRcT.TckKind = trgTckKind THEN
     IF ~!TckRcT.Number THEN
      L_General.Assert(~TckRcS.Done, "    ࠡ⠭");
      BefNbr:=TckRcT.BefNbr;
      SELECT(TckRcJ, TckRcS, , TckRcS.TckRcS);
      WHILE OCCURE(TckRcJ) DO
       IsMain:=IsMainTckKind(TckKind.TckKind, TckRcS.Date, TckRcJ.Route);
       Calc2NumbersDifference(TckRcT.TckKind, BefNbr, TckRcJ.TckNbrs[TckRcT.Number-1], Amount, Dummy);
       IF ~!TckRcJ.TckPsg[TckRcT.Number-1] THEN
        DEC(TckRcJ.Psg, TckRcJ.TckPsg[TckRcT.Number-1]);
       END;
       IF IsMain THEN
        TckRcJ.TckPsg[TckRcT.Number-1]:=Amount;
        INC(TckRcJ.Psg, TckRcJ.TckPsg[TckRcT.Number-1]);
       ELSE
        TckRcJ.TckPsg[TckRcT.Number-1]:=0;
       END;
       DEC(TckRcJ.RPsg, TckRcJ.TckRPsg[TckRcT.Number-1]);
       TckRcJ.TckRPsg[TckRcT.Number-1]:=TckRcJ.TckRAmnt[TckRcT.Number-1];
       INC(TckRcJ.RPsg, TckRcJ.TckRPsg[TckRcT.Number-1]);
       REPLACE(TckRcJ);
       BefNbr:=TckRcJ.TckNbrs[TckRcT.Number-1];
       NEXT(TckRcJ);
      END; (* WHILE OCCURE(TckRcJ) ... *)
     END;
    END;
    NEXT(TckRcT);
   END; (* WHILE OCCURE(TckRcT) ... *)
   NEXT(TckRcS);
  END; (* WHILE OCCURE(TckRcS) ... *)
 END {CorrectPsg};

 PUBLIC PROCEDURE CheckDone(B, E: DATE);
  VAR
   Msg   : STRING[];
   Timing: NUMERIC[0];
 BEGIN
  Timing:=60;
  TRY [ABORT_AFTER(AA_ON)]
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   SETSEL(TckRcS, Done, 0);
   SRCINSEL(TckRcS, GE, , B);
   LOOP
    IF ~OCCURE(TckRcS) THEN
     EXIT;
    ELSIF TckRcS.Date <= E THEN
     Msg:="| ࠡ⠭  ("+ TckRcS.TckRcS +")"+
          "||" + "%<    ⬥    >Z    %< 믮 (%T) >FD";
     STDFORM(Msg, " ஢ઠ ࠡ⪨  ", INFORM, , Timing);
     EXIT;
    END;
    NEXT(TckRcS);
   END;
  EXCEPT
  END; (* TRY *)
 END {CheckDone};

 PUBLIC PROCEDURE CheckSwitchMonthRWS(InTRSAccept: SCAL[2]);
  VAR
   rws : LIKE(RWayS.RWayS);
   todo: STRING[];
   B,
   E   : DATE;
 BEGIN
  B:=TckRcS.Date;
  IF L_DatTim.MonthBeg(L_BegRWS.DspSysDate()) # L_DatTim.MonthBeg(B) THEN
   E:=TckRcS.Date;
   FOR_EACH rws IN TckRcS.asRWayS DO
    IF ~!rws THEN
     SEARCH(RWayS, RWayS, , rws);
     CONFORM(RWayS, StExit);
     CONFORM(StExit, SEJobs);
     LAST(SEJobs);
     E:=Math.Max(E, RWayS.Date + SEJobs.Day - (SEJobs.StartT < SEJobs.StopT));
    END;
   END; (* FOR_EACH *)
   IF L_DatTim.MonthBeg(E) # L_DatTim.MonthBeg(B) THEN
    IF InTRSAccept THEN
     todo:="ਭ   ﬨ 楢 ⮢" +
           "|(-⮣ )    뤠 ," +
           "| ⥬ 뤠  ";
    ELSE
     todo:="ਭ ⮫쪮 , 祭   뤠 " +
           "|( ࢮ ᫠ ᫥饣 )";
    END;
    L_StdFrm.Inform(" " + TckRcS.TckRcS + " 뤠  諮 ." +
                    "|᫨ ॠ ⭮ த樨 (த  )" +
                    "|뫠    뤠 , ⠪   ᫥饬 ," +
                    "|᫥ " + todo);
   END; (* IF L_DatTim.MonthBeg(E)... *)
  END; (* IF L_DatTim.MonthBeg(L_BegRWS.DspSysDate())... *)
 END {CheckSwitchMonthRWS};

BEGIN
 SETEMPTY(prvOnDate);
END.
