(*
%Copyright   (c) Polak Computer System
%Author      20.01.2003 18:39:33 POLAK\GAV
%Purpose     ஡  ਮ
%Type        report
%Specific    AP
%Modified    10.04.2012 12:05:25 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, L_General, L_OwnData, L_Car, Math, L_DatTim, L_Env, L_StdFrm,
        L_Str, Str, L_PagePr;

 CONST
  RepName = "RunDy";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
############################################################################################################################################################################################################################################################### ########## #####
=#####==========================================================================================================================================================================================================================================================================
|##############################################################################################################################################################################################################################################################################|
}
*)

(*
$P{ ColumnSubTop:
Car.Column, L, ""
@
|==============================================================================================================================================================================================================================================================================|
| ##                                                                                                                                                                                                                                                                    |
}
*)

(*
$P{ SubTop:
@
|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|.|   .|  01  |  02  |   03  |   04  |   05  |   06  |   07  |   08  |   09  |   10  |   11  |   12  |   13  |   14  |   15  |   16  |   17  |   18  |   19  |   20  |   21  |   22  |   23  |   24  |   25  |   26  |   27  |   28  |   29  |   30  |   31  |  |
}
*)

(*
$P{ BreakLine:
@
|----|---------|------|------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|---------|
}
*)

(*
$P{ Line:
?, L, ""
?, R, "1."
@
|####|#########|}
*)

(*
$P{ DayRun0102:
?, R, "1."
?, R, "1."
@
######|######|}
*)

(*
$P{ DayRun:
?, R, "1."
@
#######|}
*)

(*
$P{ LineEnd:
?, R, "1."
@
#########|
}
*)

(*
$P{ Bot:
@
=(c) Polak======================================================================================================================================================================================================================================================================
}
*)

 VAR
  RepTitleStr      : STRING[];
  GroupByColumn,
  CommonPurposeOnly: SCAL[2];
  Count            : NUMERIC[0];

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode # L_PagePr.m_Print THEN
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Print THEN
   IF Count > 0 THEN
    NewGroupOrPage();
   END;
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Bot));
  ELSIF Mode = L_PagePr.m_Print THEN
   IF Count > 0 THEN
    MAKEPART(R, Bot);
   END;
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(0);
  ELSIF Mode = L_PagePr.m_Print THEN
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(0);
  ELSIF Mode = L_PagePr.m_Print THEN
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE NewGroupOrPage();
 BEGIN
  IF Count = 0 THEN
   MAKEPART(R, Top, RepName, RepTitleStr);
  END;
  IF GroupByColumn THEN
   MAKEPART(R, ColumnSubTop);
  END;
  MAKEPART(R, SubTop);
 END {NewGroupOrPage};

 PRIVATE PROCEDURE MakeRunLine(Arr: NUMERIC[2][32]);
  VAR
   i: NUMERIC[0];
 BEGIN
  MAKEPART(R, DayRun0102, Arr[1], Arr[2]);
  i:=3;
  WHILE i <= 31 DO
   MAKEPART(R, DayRun, Arr[i]);
   INC(i);
  END;
 END {MakeRunLine};

 PRIVATE PROCEDURE MakeBySelection();
  VAR
   Run,
   RAtBeg   : NUMERIC[2];
   DayRuns,
   TotRuns  : NUMERIC[2][32];
   LineDepth: NUMERIC[0];
 BEGIN
  Count:=0;
  LineDepth:=DEPTH(BreakLine) + 2 * DEPTH(LineEnd);
  WHILE OCCURE(Car) DO
   PROMPT(Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr) &
      (~CommonPurposeOnly | (Car.Purpose = L_Car.purp_Common)) &
      L_DatTim.IsActiveInIntvl(Memo.ud_fr(), Memo.ud_ut(),
                               Car.BegDate, Car.EndDate) THEN
    RAtBeg:=L_Car.GetGlobalRun(Car.BoxNbr, Math.Max(Memo.ud_fr(), Car.BegDate));
    Run   :=0;
    SETEMPTY(DayRuns, TotRuns);
    SELECT(CarRun, BoxNbr, , Car.BoxNbr);
    SRCINSEL(CarRun, GE, , Memo.ud_fr());
    WHILE OCCURE(CarRun) & (CarRun.Date <= Memo.ud_ut()) DO
     IF L_Car.CarIsInOperation(Car.BoxNbr, CarRun.Date) THEN
      DayRuns[L_DatTim.DAY(CarRun.Date)]:=CarRun.Run;
      INC(Run, CarRun.Run);
      TotRuns[L_DatTim.DAY(CarRun.Date)]:=Run;
     END;
     NEXT(CarRun);
    END; (* WHILE OCCURE(CarRun) ... *)

    IF Count = 0 THEN
     IF GroupByColumn THEN
      L_PagePr.PagePr_BeforePrintLine(DEPTH(Top) + DEPTH(SubTop) +
                                      DEPTH(ColumnSubTop) + LineDepth);
     ELSE
      L_PagePr.PagePr_BeforePrintLine(DEPTH(Top) + DEPTH(SubTop) + LineDepth);
     END;
     NewGroupOrPage();
    ELSE
     L_PagePr.PagePr_BeforePrintLine(LineDepth);
    END;
    MAKEPART(R, BreakLine);

    MAKEPART(R, Line, Car.BoxNbr, RAtBeg);
    MakeRunLine(DayRuns);
    MAKEPART(R, LineEnd, RAtBeg + Run);

    MAKEPART(R, Line);
    MakeRunLine(TotRuns);
    MAKEPART(R, LineEnd);

    INC(Count);
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
  MAKEPART(R, Bot);
 END {MakeBySelection};

 PRIVATE PROCEDURE MakeRep();
 BEGIN
  L_General.Assert(L_DatTim.Per(Memo.ud_fr()) = L_DatTim.Per(Memo.ud_ut()),
                   "ਮ    ।  ");
  OPENREP(R, L_General.NameConnection(RepName), Create,
          TopMargin,       0,
          BottomMargin,    0,
          LeftMargin,      0,
          RightMargin,     0);
  RepTitleStr:="஡  ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) +
                               "  " + L_DatTim.DateStr(Memo.ud_ut());
  STDFORM("|" + "%" + L_Str.IntStr(Str.Length(RepTitleStr) - 4) +
          "<㯯஢   >E|" +
          "%" + L_Str.IntStr(Str.Length(RepTitleStr) - 4) +
          "<쪮 饣 짮>E||" +
          L_StdFrm.DrawButton("⬥",    10, "X") + "  " +
          L_StdFrm.DrawButton("⮢", 13, "DB"),
          " " + RepTitleStr + " ", , 1, GroupByColumn, CommonPurposeOnly);
  Count:=0;

  L_PagePr.PagePr_Init("R", 65, PROCREF(_RprtTop),
                                PROCREF(_PageTop),
                                PROCREF(_PageBot),
                                PROCREF(_RprtBot),
                                PROCREF(_Filling));

  IF GroupByColumn THEN
   SELECT(Car, Column);
   WHILE OCCURE(Car) DO
    CHANGESEL(Car, Column, , Car.Column);
    MakeBySelection();
    LAST(Car);
    CHANGESEL(Car, Column);
    NEXT(Car);
   END; (* WHILE OCCURE(Car) ... *)
  ELSE
   SELECT(Car, BoxNbr);
   MakeBySelection();
  END;
  L_PagePr.PagePr_Done();
  CLOSEREP(R);
 END {MakeRep};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
 IF    MODE = 100 THEN
  GroupByColumn    :=0;
  CommonPurposeOnly:=0;
 ELSIF MODE = 101 THEN
  GroupByColumn    :=0;
  CommonPurposeOnly:=1;
 ELSIF MODE = 110 THEN
  GroupByColumn    :=1;
  CommonPurposeOnly:=0;
 ELSIF MODE = 111 THEN
  GroupByColumn    :=1;
  CommonPurposeOnly:=1;
 ELSE
  L_General.BadMode(MODE);
 END;
 MakeRep();
END.
