(*
%Copyright   (c) Polak Computer System
%Author
%Purpose     ନ஢ ਪ  ᫥ ணᨢ
%Type        operation
%Specific    LOC
%Modified    17.06.2014 22:58:11 POLAK\Gina
%Environment
*)

 MODULE FO_Mch [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Staff, L_PRoll, L_OwnData, L_Money, L_Str, P_OwnData, L_EDO,
        E_PRoll, P_MCList, L_EC, L_StdFrm, L_Env, P_Firm;

 PRIVATE CONST
  RepName = "FoMCH";

(*$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
FOrder.Period, L, "N.y"
L_EDO.FOrderName()+" ( "+FOrder.FOrder+")", C, ""
@
##################################################################################################### ########## #####
=#####================================================================================================================
|                                    ⮪ ᫥ ணᨢ  #######                                     |
|####################################################################################################################|
|--------------------------------------------------------------------------------------------------------------------|
|. |             |        |  ६|業|  㬬|       ६|ਬ砭                    |
|-----|----------------|-----------------|-------|-------|--------------|-------------|------------------------------|
}
*)

(*
$P{ Line:
Staff.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Post.Name, L, ""
?, R, "3."
?, R, "3."
?, R, ",2-"
?, R, ",2-"
?, L, ""
@
|#####|################|#################|#######|#######|##############|#############|##############################|
}
*)

(*
$P{ Bot:
?, R, ",2-"
FOrder.Sum, R, ",2-"
@
|--------------------------------------------------------|--------------|-------------|------------------------------|
|⮣                                                   |##############|#############|                              |
=(c) Polak============================================================================================================
}
*)

 PRIVATE PROCEDURE MCH_NeedLog(D: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PRoll.MCH_NeedLog);
  IF !Local THEN
   L_General.InformUs("祭 ⥣਩ ࠡ⭨,  ६");
  END;
  CONFORM(StaffLog, Officer);
  RETURN Local(D);
 END {MCH_NeedLog};

 PRIVATE PROCEDURE E_MCH_MoneyCond(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_PRoll.MCH_MoneyCond), P_MCList.inBonus(MCList.MCode, P, 0));
 END {E_MCH_MoneyCond};

 PRIVATE PROCEDURE AddTrgM(VAR S   : LIKE(Money.Sum);
                           VAR T   : LIKE(Money.Tim);
                               TrgM: DATE);
 BEGIN
  APP.Get().NewPrompt(" 㬬");
  L_PRoll.StaffCountUp(Staff.TSN, TrgM);

  IF L_General.GetAPSiteNumber() = 82 THEN
   SELECT(Money, TSN, , Staff.TSN, TrgM); (*     ⥪騩*)
  ELSE
   SELECT(Money, PayFor, , Staff.TSN, TrgM);
  END;
  WHILE OCCURE(Money) DO
   PROMPT("  " + Money.MCode);
   IF (Money.Period = TrgM) & (Money.ODate = StaffLog.Date) THEN
    CONFORM(Money, MCList);
    IF E_MCH_MoneyCond(Money.Period) THEN
     INC(S, L_General.Denominate(Money.Closed, L_PRoll.Salary_ClcPer(), Money.Sum));
     IF MCList.TimeType = L_PRoll.tt_Production THEN
      INC(T, Money.Tim);
     END;
    END;
   END;
   NEXT(Money);
  END;
 END {AddTrgM};

 PRIVATE PROCEDURE Note(curEndDate: DATE): STRING[];
 BEGIN
  IF !curEndDate THEN
   RETURN "";
  ELSE
   RETURN " "+L_DatTim.DateStr(curEndDate);
  END;
 END {Note};

 PRIVATE PROCEDURE E_MCH_Prc(DefaultPrc: NUMERIC[3]; P: DATE): NUMERIC[3];
  VAR
   Result: NUMERIC[3];
   Local : PROC;
 BEGIN
  Result:=DefaultPrc;
  Local:=PROCREF(E_PRoll.MCH_Prc);
  IF ~!Local THEN
   Result:=Local(P, DefaultPrc);
  END;
  RETURN Result;
 END {E_MCH_Prc};

 PRIVATE PROCEDURE GoodMyFirm(): SCAL[2];
 BEGIN
  IF P_Firm.E_wMultipleMyFirm(FOrder.Date) THEN
   RETURN Staff.MyFirm = FOrder.MyFirm;
  ELSE
   RETURN 1;
  END;
 END {GoodMyFirm};

 PUBLIC PROCEDURE FO_Mch();
  VAR
   Prc,
   BasePrc   : NUMERIC[2];
   TrgM,
   TrgME     : DATE;
   Sum       : LIKE(Money.Sum);
   Tim       : LIKE(Money.Tim);
   NoPay     : SCAL[2];
   TotBase   : NUMERIC[2];
   CurEndDate: LIKE(Staff.EndDate);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  TABLE.Get("FOrder" ).AccessDataMode:=AccessDataMode_RIDGE;
  TABLE.Get("FOrderL").AccessDataMode:=AccessDataMode_RIDGE;
  TABLE.Get("PCalc"  ).AccessDataMode:=AccessDataMode_RIDGE;
  L_EDO.InitPrepareFOrder();
  TrgM :=FOrder.Period;
  TrgME:=L_DatTim.MonthEnd(TrgM);
  BasePrc:=STRTOFLD(P_OwnData.GetOwnDProStrong(TrgM, P_OwnData.P_ProgressBonus), NUMERIC);
  LOOP
   STDFORM(L_StdFrm.sf_Choice("|᫨ ணᨢ  "+L_DatTim.PeriodStr(TrgM)+"  ࠧ %#######%|",
                              "%RI"),
           "ନ஢ ਪ  ᫥",
           ,
           ,
           BasePrc);
   IF BasePrc > 0 THEN
    EXIT;
   ELSE
    L_StdFrm.RedInform("業 ६    㫥");
   END;
  END; (* LOOP *)
  APP.Get().NewPrompt("("+RepName+")");
  L_General.Assert(FOrder.Type = L_PRoll.fot_BySum, "ਪ     㬬");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top);
  TotBase:=0;
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT("⭨ "+Staff.TSN);
   IF (Staff.Contract # L_Staff.cnt_OutStaff) & L_Env.RealTSN(Staff.TSN) & GoodMyFirm() & L_Staff.InStateInPer(TrgM, TrgME) THEN
    CONFORM(Staff, Man);
    SETEMPTY(CurEndDate); SETZERO(NoPay);
    L_Staff.PosToStaffLog(Staff.TSN, TrgME, 0);
    REPEAT
     SETZERO(Sum, Tim);
     IF MCH_NeedLog(TrgM) THEN
      AddTrgM(Sum, Tim, TrgM);
      IF ~NoPay & L_Staff.IsDischargeStaffLog() THEN
       CONFORM(StaffLog, SLKind);
       CurEndDate:=StaffLog.Date - 1;
       NoPay     :=SLKind.IsGodRsn = 0;
      END;
      IF Sum > 0 THEN
       Prc:=E_MCH_Prc(BasePrc, TrgM);
       INC(TotBase, Sum);
       CONFORM(StaffLog, Post);
       IF NoPay & ~P_MCList.GetPayOnDischarge(FOrder.MCode, TrgM) THEN
        MAKEPART(R, Line, Tim, Prc, Sum, 0, Note(CurEndDate));
       ELSE
        L_EDO.AppendFOrderL(Tim, Sum * Prc / 100);
        MAKEPART(R, Line, Tim, Prc, Sum, FOrderL.Value, Note(CurEndDate));
       END; (* IF NoPay... *)
      END; (* IF Sum > 0... *)
     END; (* IF MCH_NeedLog... *)
    UNTIL ~PREV(StaffLog) | (StaffLog.DateE < TrgM);
   END; (* IF L_Env.RealTSN... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)

  CONFORM(FOrder, FOrderL);
  WHILE OCCURE(FOrderL) DO
   CONFORM(FOrderL, Staff);
   L_PRoll.ShtDone_AP(FOrder.Closed, 0);
   NEXT(FOrderL);
  END; (* WHILE OCCURE(FOrderL) ... *)

  MAKEPART(R, Bot, TotBase);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {FO_Mch};

END.
