(*
%Copyright   (c) Polak IT
%Author      29.09.2007 20:31:22 POLAK\Gina
%Purpose     ஢ 窨  
%Type        report
%Specific    LOC
%Modified    29.05.2013 13:03:14 POLAK\Gina
%Environment
*)

 MODULE Ipl10 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Basis, L_StdFrm, Memo, L_DatTim, L_AFM, D_TP, L_Env, FIO, L_Str, L_Way,
        P_Firm, Math, L_bp;

 CONST
  CurYearCurMonthS ="";  (*騩/  騩/ *)
  CurYearPrvMonthS ="";
  PrvYearCurMonthS ="";
  PrvYearPrvMonthS ="";

 VAR
  wMF : SCAL[2];
  CurYearCurMonth,
  CurYearPrvMonth,
  PrvYearCurMonth,
  PrvYearPrvMonth: DATE;
  PlanIncDay,
  FactIncDay     : NUMERIC[2];
  WorkDaysInMonth: NUMERIC[0][8];

 PRIVATE PROCEDURE MakeHeaderOneMonth(F: STRING[]; MonthPrefix: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "℮"      +MonthPrefix);
  L_Basis.wb_WrInQM(F, "६"    +MonthPrefix);
  L_Basis.wb_WrInQM(F, "६" +MonthPrefix);
  L_Basis.wb_WrInQM(F, "␥"    +MonthPrefix);
  L_Basis.wb_WrInQM(F, "℮/" +MonthPrefix);

  L_Basis.wb_WrInQM(F, ""      +MonthPrefix);
  L_Basis.wb_WrInQM(F, "६"    +MonthPrefix);
  L_Basis.wb_WrInQM(F, "६" +MonthPrefix);
  L_Basis.wb_WrInQM(F, ""    +MonthPrefix);
  L_Basis.wb_WrInQM(F, "/" +MonthPrefix);
 END {MakeHeaderOneMonth};

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "஢");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, " ");

  MakeHeaderOneMonth(F, PrvYearPrvMonthS);
  MakeHeaderOneMonth(F, PrvYearCurMonthS);
  MakeHeaderOneMonth(F, CurYearPrvMonthS);

  L_Basis.wb_WrInQM(F, "६室"+CurYearCurMonthS);
  L_Basis.wb_WrInQM(F, "६室"+CurYearCurMonthS);
  L_Basis.wb_WrInQM(F, "室"+CurYearCurMonthS);

  L_Basis.wb_WrInQM(F, ""      +CurYearCurMonthS);
  L_Basis.wb_WrInQM(F, "६"    +CurYearCurMonthS);
  L_Basis.wb_WrInQM(F, "६" +CurYearCurMonthS);
  L_Basis.wb_WrInQM(F, ""    +CurYearCurMonthS);

  L_Basis.wb_WrInQM(F, "/" +CurYearCurMonthS);
  L_Basis.wb_WrInQM(F, ""    +CurYearCurMonthS);
  L_Basis.wb_WrInQM(F, "/"+CurYearCurMonthS);

  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakeLine(F: STRING[]; DNStr: STRING[]);
 BEGIN
  IF wMF THEN
   TRY
    P_Firm.PositionOnMyFirm(L_Way.GetMyFirmOfExit(StExit.Exit, CurYearCurMonth));
   EXCEPT
   ON Exc: Exc_Raise DO
    P_Firm.PositionOnMyFirm(P_Firm.mf_Fict);
   END;
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.tkrgn_Pool, TKind.Rgn));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Way.tkfnm_Pool, TKind.FnMode));
  L_Basis.wb_WrScl(F, TKind.TKind);
  L_Basis.wb_WrStr(F, TKind.Name);
  L_Basis.wb_WrStr(F, Route.Route);
  L_Basis.wb_WrStr(F, Route.Name);
  CONFORM(StExit, ExitClss);
  L_Basis.wb_WrScl(F, ExitClss.ExitClss);
  L_Basis.wb_WrScl(F, ExitClss.Name);
  L_Basis.wb_WrScl(F, StExit.Change);
  L_Basis.wb_WrScl(F, StExit.Exit);
  L_Basis.wb_WrStr(F, DNStr);
 END {MakeLine};

 PRIVATE PROCEDURE PerUnit(X1, X2: NUMERIC[3]): NUMERIC[3];
 BEGIN
  IF X2 = 0 THEN
   RETURN 0;
  ELSE
   RETURN X1/X2;
  END;
 END {PerUnit};

 PRIVATE PROCEDURE GetPlanTrip(): NUMERIC[3];
 BEGIN
  IF SEARCH(Tmp02, Route, Tmp.Route, Tmp.Exit, Tmp.DN) THEN
   RETURN Tmp02.TripAm;
  ELSE
   RETURN 0;
  END;
 END {GetPlanTrip};

 PRIVATE PROCEDURE MakeLineOneMonth(F: STRING[]);
 BEGIN
  L_Basis.wb_WrNum(F, Tmp.FactIncome,  3); (* "℮" *)
  L_Basis.wb_WrNum(F, Tmp.FactPaidTim, 3); (* "६" *)

  L_Basis.wb_WrNum(F, Tmp.FactOrdTim,  3);   (* "६" *)

  L_Basis.wb_WrNum(F, Tmp.FactTrip,    3); (* "␥" *)
  FactIncDay:=PerUnit(Tmp.FactIncome, Tmp.FactTrip)*GetPlanTrip();
  L_Basis.wb_WrNum(F, FactIncDay,      3); (* "℮/" *)

  L_Basis.wb_WrNum(F, Tmp.PlanIncome,  3); (* "" *)
  L_Basis.wb_WrNum(F, Tmp.PlanPaidTim, 3); (* "६" *)

  L_Basis.wb_WrNum(F, Tmp.PlanOrdTim,  3);  (* "६" *)

  L_Basis.wb_WrNum(F, Tmp.PlanTrip,    3); (* "" *)
  PlanIncDay:=PerUnit(Tmp.PlanIncome, Tmp.PlanTrip)*GetPlanTrip();
  L_Basis.wb_WrNum(F, PlanIncDay,      3); (* "/" *)
 END {MakeLineOneMonth};

 PRIVATE PROCEDURE MakeLineOneMonthZero(F: STRING[]);
 BEGIN
  L_Basis.wb_WrNum(F, 0, 3); (* "℮" *)
  L_Basis.wb_WrNum(F, 0, 3); (* "६" *)

  L_Basis.wb_WrNum(F, 0, 3); (* "६" *)

  L_Basis.wb_WrNum(F, 0, 3); (* "␥" *)
  L_Basis.wb_WrNum(F, 0, 3); (* "℮/" *)
  L_Basis.wb_WrNum(F, 0, 3); (* "" *)
  L_Basis.wb_WrNum(F, 0, 3); (* "६" *)

  L_Basis.wb_WrNum(F, 0, 3); (* "६" *)

  L_Basis.wb_WrNum(F, 0, 3); (* "" *)
  L_Basis.wb_WrNum(F, 0, 3); (* "/" *)
 END {MakeLineOneMonthZero};

 PRIVATE PROCEDURE MakeLinePlanZero(F: STRING[]);
 BEGIN
  L_Basis.wb_WrNum(F, 0, 3); (*"६室"   +CurYearCurMonth *)

  L_Basis.wb_WrNum(F, 0, 3); (*"६室"+CurYearCurMonth *)

  L_Basis.wb_WrNum(F, 0, 3); (*"室"   +CurYearCurMonth *)

  L_Basis.wb_WrNum(F, 0, 3); (*""          +CurYearCurMonthS *)
  L_Basis.wb_WrNum(F, 0, 3); (*"६"        +CurYearCurMonthS *)

  L_Basis.wb_WrNum(F, 0, 3); (*"६"     +CurYearCurMonthS *)

  L_Basis.wb_WrNum(F, 0, 3); (*""        +CurYearCurMonthS *)

  L_Basis.wb_WrNum(F, 0, 3); (*"//"    +CurYearCurMonth *)
  L_Basis.wb_WrNum(F, 0, 3); (*"/"       +CurYearCurMonth *)
  L_Basis.wb_WrNum(F, 0, 3); (*"//"   +CurYearCurMonth *)
 END {MakeLinePlanZero};

 PRIVATE PROCEDURE MakeLinePrvYearPrvMonth(F: STRING[]);
 BEGIN
  MakeLineOneMonth(F);       (* PrvYearPrvMonthS *)
  MakeLineOneMonthZero(F);   (* PrvYearCurMonthS *)
  MakeLineOneMonthZero(F);   (* CurYearPrvMonth *)

  MakeLinePlanZero(F);

  L_Basis.wb_TermLine(F);

  ADD(Tmp02, Route, , Tmp.Route, Tmp.Exit, Tmp.DN,
                      Tmp02.FactIncomePrvYearPrvMonth,  Tmp.FactIncome,
                      Tmp02.FactPaidTimPrvYearPrvMonth, Tmp.FactPaidTim);
 END {MakeLinePrvYearPrvMonth};

 PRIVATE PROCEDURE MakeLinePrvYearCurMonth(F: STRING[]);
 BEGIN
  MakeLineOneMonthZero(F);   (* PrvYearPrvMonthS *)
  MakeLineOneMonth(F);       (* PrvYearCurMonthS *)
  MakeLineOneMonthZero(F);   (* CurYearPrvMonth *)

  MakeLinePlanZero(F);

  L_Basis.wb_TermLine(F);

  ADD(Tmp02, Route, , Tmp.Route, Tmp.Exit, Tmp.DN,
                      Tmp02.FactIncomePrvYearCurMonth,  Tmp.FactIncome,
                      Tmp02.FactPaidTimPrvYearCurMonth, Tmp.FactPaidTim);
 END {MakeLinePrvYearCurMonth};

 PRIVATE PROCEDURE MakeLineCurYearPrvMonth(F: STRING[]);
 BEGIN
  CONFORM(Tmp, StExit);
  MakeLineOneMonthZero(F);   (* PrvYearPrvMonthS *)
  MakeLineOneMonthZero(F);   (* PrvYearCurMonthS *)
  MakeLineOneMonth(F);       (* CurYearPrvMonth *)

  MakeLinePlanZero(F);

  L_Basis.wb_TermLine(F);

  ADD(Tmp02, Route, , Tmp.Route, Tmp.Exit, Tmp.DN,
                   Tmp02.FactIncDay, FactIncDay);
 END {MakeLineCurYearPrvMonth};

 PRIVATE PROCEDURE TripAm(): LIKE(StExit.TripAm);
 BEGIN
  IF WJMode.RunSel = L_Way.runsel_Work THEN
   RETURN 1;
  ELSE
   RETURN 0;
  END; (* IF WJMode ... *)
 END {TripAm};

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "६ 䠩", "");
  CreateFIELD(Tmp, Route,       LIKE(Route.Route),   "", "",  "", "", "");
  CreateFIELD(Tmp, Exit,        LIKE(StExit.Exit),   "", "",  "", "室", "");
  CreateFIELD(Tmp, DN,          L_DatTim.tWeekday,   "", "",  "", " ", "");
  CreateFIELD(Tmp, FactIncome,  NUMERIC[2],          "", "0", "", "室 (䠪)", "");
  CreateFIELD(Tmp, FactTrip,    NUMERIC[1],          "", "0", "", " (䠪)", "");
  CreateFIELD(Tmp, FactPaidTim, NUMERIC[3],          "", "0", "", "६   (䠪)", "");
  CreateFIELD(Tmp, FactOrdTim,  NUMERIC[3],          "", "0", "", "६    拉 (䠪)", "");

  CreateFIELD(Tmp, PlanIncome,  NUMERIC[2],          "", "0", "", "室 ()", "");
  CreateFIELD(Tmp, PlanTrip,    NUMERIC[1],          "", "0", "", " ()", "");
  CreateFIELD(Tmp, PlanPaidTim, NUMERIC[3],          "", "0", "", "६   ()", "");
  CreateFIELD(Tmp, PlanOrdTim,  NUMERIC[3],          "", "0", "", "६    拉 ()", "");

  CreateINDEXandLINK(Tmp, Route,    UNIQUE, Route,  Route, USER, "", "", Route, Exit, DN);
  CreateINDEXandLINK(Tmp, Exit,     PLURAL, StExit, Exit,  USER, "", "", Exit);
  SetVersionOfFILE(Tmp, 0);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE _PaidTim(): NUMERIC[3];
 BEGIN
  IF WJMode.IncSel THEN
   RETURN TP002.WrkTim;
  ELSE
   RETURN 0;
  END;
 END {_PaidTim};

 PROCEDURE ConvertDNtoWD(DN: L_DatTim.tWeekday): L_DatTim.tWeekday;
 BEGIN
  IF    DN = 0(*㤭*)   THEN RETURN L_DatTim.wd_Mon;
  ELSIF DN = 1(*⭨*) THEN RETURN L_DatTim.wd_Fri;
  ELSIF DN = 2(*㡡*) THEN RETURN L_DatTim.wd_Sat;
  ELSIF DN = 3(**) THEN RETURN L_DatTim.wd_Sun;
  ELSIF DN = 4(*ࠧ*) THEN RETURN L_DatTim.wd_Hol;
  ELSE
   L_General.CallUs(0);
  END;
 END {ConvertDNtoWD};

 PRIVATE PROCEDURE GetExit(WD: L_DatTim.tWeekday): LIKE(StExit.Exit);
 BEGIN
  SELECT(ExitL, ExitClss, , StExit.ExitClss, StExit.Change);
  WHILE OCCURE(ExitL) DO
   IF ExitL.OnDays[ConvertDNtoWD(WD)] THEN
    RETURN ExitL.Exit;
   END;
   NEXT(ExitL);
  END;
  RETURN StExit.Exit;
 END {GetExit};

 PRIVATE PROCEDURE MustReBuild(Condition: SCAL[2]; FileName: STRING[]; CurMonth: DATE);
 BEGIN
  L_General.Assert(Condition,
                   ' ६ ⮢ 䠩 "' + FileName + '"' +
                   '|ᥭ     室.' +
                   '|| ⮢  䠩   '+L_DatTim.PeriodStr(CurMonth));

 END {MustReBuild};

 PRIVATE PROCEDURE Prepare_Tmp(CurMonth: DATE);
 BEGIN
  SELECT(TP002, Route);
  WHILE OCCURE(TP002) DO
   PROMPT(" (䠪): " + L_DatTim.PeriodStr(CurMonth) + " " + TP002.Route + " " + TP002.BoxNbr + " " + TP002.Exit);
   CONFORM(TP002, Route);
   IF L_DatTim.IsActiveInIntvl(CurYearCurMonth, L_DatTim.MonthEnd(CurYearCurMonth), Route.Begin, Route.Till) THEN
    IF L_Env.RealBoxNbr(TP002.BoxNbr) & ((TP002.OrdTim # 0) | (TP002.FullRun # 0)) THEN
     CONFORM(TP002, StExit);
     MustReBuild(OCCURE(StExit), "᪨ ", CurMonth);
     IF StExit.Strict = L_Way.ExitStrict_Reg THEN
      CONFORM(TP002, WJMode);
      ADD(Tmp, Route, , TP002.Route, GetExit(TP002.DN), TP002.DN,
                        Tmp.FactIncome,  TP002.IncCnt,
                        Tmp.FactTrip,    TP002.GoodTrips,
                        Tmp.FactPaidTim, _PaidTim(),
                        Tmp.FactOrdTim,  D_TP.E_GetOrdTim(TP002.OrdTim, D_TP.otp_Whl));
     END; (* IF StExit.Strict... *)
    END; (* IF L_Env.RealBoxNbr(TP002.BoxNbr)... *)
   END;
   NEXT(TP002);
  END; (* WHILE OCCURE(TP002) ... *)

  SELECT(SEJ01, Route);
  WHILE OCCURE(SEJ01) DO
   PROMPT(" (): " + L_DatTim.PeriodStr(CurMonth) + " " + SEJ01.Route + " " + " " + SEJ01.Exit);
   CONFORM(SEJ01, Route);
   IF L_DatTim.IsActiveInIntvl(CurYearCurMonth, L_DatTim.MonthEnd(CurYearCurMonth), Route.Begin, Route.Till) THEN
    CONFORM(SEJ01, StExit);
    MustReBuild(OCCURE(StExit), " ", CurMonth);
    ADD(Tmp, Route, , SEJ01.Route, GetExit(SEJ01.WDWay), SEJ01.WDWay,
                      Tmp.PlanIncome,  SEJ01.IncPlan,
                      Tmp.PlanTrip,    SEJ01.WrkTrp,
                      Tmp.PlanPaidTim, SEJ01.IncTim,
                      Tmp.PlanOrdTim,  SEJ01.OrdTim);
   END;
   NEXT(SEJ01);
  END; (* WHILE OCCURE(SEJ01) ... *)

  SELECT(Tmp, Route);
  WHILE OCCURE(Tmp) DO
   PROMPT(" "+Tmp.Route+" "+Tmp.Exit);
   IF (Tmp.FactIncome#0) | (Tmp.FactTrip#0) | (Tmp.FactPaidTim#0) |
      (Tmp.PlanIncome#0) | (Tmp.PlanTrip#0) | (Tmp.PlanPaidTim#0) THEN
    CONFORM(Tmp, Route, StExit);
    L_Way.StandOnRouteTKind(CurMonth);
    MakeLine("R", L_Way.E_ConvertWDStr(Memo.ud_me(), Tmp.DN));
    IF    CurMonth = PrvYearPrvMonth THEN
     MakeLinePrvYearPrvMonth("R");
    ELSIF CurMonth = PrvYearCurMonth THEN
     MakeLinePrvYearCurMonth("R");
    ELSIF CurMonth = CurYearPrvMonth THEN
     MakeLineCurYearPrvMonth("R");
    END;
   END;
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
 END {Prepare_Tmp};

 PRIVATE PROCEDURE Create_ExitL();
 BEGIN
  CreateFILE(ExitL, "", "᮪ 室", "");
  CreateFIELD(ExitL, ExitClss,  LIKE(StExit.ExitClss), "", "", "", " 室", "");
  CreateFIELD(ExitL, Change,    LIKE(StExit.Change),   "", "", "", "", "");
  CreateFIELD(ExitL, OnDays,    LIKE(StExit.OnDays),   "", "", "", "  ", "");
  CreateFIELD(ExitL, Exit,      LIKE(StExit.Exit),     "", "", "", "室", "");

  CreateINDEXandLINK(ExitL, ExitClss, PLURAL, ExitClss, ExitClss, USER, "", "", ExitClss, Change, Exit);
  SetVersionOfFILE(ExitL, 0);
  L_AFM.AF_CreateTemp("ExitL", "ExitL");
 END {Create_ExitL};

 PRIVATE PROCEDURE Create_Tmp02();
 BEGIN
  CreateFILE(Tmp02, "", "६ 䠩 , 室", "");
  CreateFIELD(Tmp02, Route,      LIKE(Route.Route),   "", "",  "", "", "");
  CreateFIELD(Tmp02, Exit,       LIKE(StExit.Exit),   "", "",  "", "室", "");
  CreateFIELD(Tmp02, DN,         L_DatTim.tWeekday,   "", "",  "", " ", "");
  CreateFIELD(Tmp02, PaidT,      LIKE(StExit.PaidT),  "", "0", "", "६   (  室)", "");
  CreateFIELD(Tmp02, OrdT,       LIKE(StExit.PaidT),  "", "0", "", "६   (  室)", "");

  CreateFIELD(Tmp02, TripAm,     LIKE(StExit.TripAm), "", "0", "", " (  室)", "");
  CreateFIELD(Tmp02, FactIncDay, NUMERIC[2],          "", "0", "", "室/ (䠪)", ""); (*ࠤ 饭   ⮢  室, ⮡ ⮣ 㬬 . ᫨   ⮣ -  ,    Excel*)

  CreateFIELD(Tmp02, PlanIncome, NUMERIC[2],          "", "0", "", "室 (  ਮ)", "");
  CreateFIELD(Tmp02, PlanTrip,   NUMERIC[2],          "", "0", "", " (  ਮ)", "");
  CreateFIELD(Tmp02, PlanPaidT,  NUMERIC[3],          "", "0", "", "६ (  ਮ)", "");
  CreateFIELD(Tmp02, PlanOrdT,   NUMERIC[3],          "", "0", "", "६  (  ਮ)", "");

  CreateFIELD(Tmp02, WorkDays,   NUMERIC[0],          "", "0", "", "   ਮ", "");

  CreateFIELD(Tmp02, FactIncomePrvYearPrvMonth,  NUMERIC[2],  "", "0", "", "室 (䠪)", "");
  CreateFIELD(Tmp02, FactPaidTimPrvYearPrvMonth, NUMERIC[3],  "", "0", "", "६ (䠪)", "");
  CreateFIELD(Tmp02, FactIncomePrvYearCurMonth,  NUMERIC[2],  "", "0", "", "室 (䠪)", "");
  CreateFIELD(Tmp02, FactPaidTimPrvYearCurMonth, NUMERIC[3],  "", "0", "", "६ (䠪)", "");

  CreateINDEXandLINK(Tmp02, Route, UNIQUE, Route, Route, USER, "", "", Route, Exit, DN);
  CreateINDEXandLINK(Tmp02, Exit,  PLURAL, StExit, Exit,  USER, "", "", Exit);
  SetVersionOfFILE(Tmp02, 0);
  L_AFM.CreateTemp("Tmp02");
 END {Create_Tmp02};

 PRIVATE PROCEDURE Prepare_Tmp02();
  VAR
   _DN,
   _WD  : L_DatTim.tWeekday;
   _Date,
   _PerB,
   _PerE: DATE;
   WorkDays: NUMERIC[0][MAXOF(L_DatTim.tWeekday)+1];
   Done    : SCAL[2][MAXOF(L_DatTim.tWeekday)+1];
 BEGIN
  CONFORM(StExit, SEJobs);
  WHILE OCCURE(SEJobs) DO
   CONFORM(SEJobs, WJMode, Route);
   CONFORM(Route,  TKind);
   IF L_Way.SEJobsWithPlIncome(StExit.FromD) THEN
    SETZERO(WorkDays);
    IF ~SELECT(Tmp02, Route, SEJobs.Route, SEJobs.Exit) THEN
     IF L_DatTim.InPatIntvl(StExit.FromD, StExit.UpDate, CurYearCurMonth, L_DatTim.MonthEnd(CurYearCurMonth)) THEN
      FOR_EACH _WD DO
       IF StExit.OnDays[_WD] THEN
        _DN:=L_Way.E_ConvertWD(Memo.ud_me(), _WD);
        INC(WorkDays[_DN], WorkDaysInMonth[_WD]);
       END;
      END;
     ELSE
      _PerB:=Math.Max(StExit.FromD, CurYearCurMonth);
      _PerE:=Math.Min(StExit.UpDate, L_DatTim.MonthEnd(CurYearCurMonth)+1)-1;
      _Date:=_PerB;
      WHILE _Date <= _PerE DO
       L_General.Assert(SEARCH(Calendar, Date, _Date), "    "+L_DatTim.DateStr(_Date));
       IF StExit.OnDays[Calendar.WDInc] THEN
        _DN:=L_Way.E_ConvertWD(Memo.ud_me(), Calendar.WDInc);
        INC(WorkDays[_DN]);
       END;
       INC(_Date);
      END;
     END;
    END; (* IF ~SELECT(Tmp02 ... *)
    SETZERO(Done);
    FOR_EACH _WD DO
     _DN:=L_Way.E_ConvertWD(Memo.ud_me(), _WD);
     IF StExit.OnDays[_WD] & ~Done[_DN] THEN
      ADD(Tmp02, Route, , SEJobs.Route, SEJobs.Exit, _DN,
                          Tmp02.PaidT,  SEJobs.StopT - SEJobs.StartT,                             (* "६室"    +CurYearCurMonth *)
                          Tmp02.OrdT,   D_TP.E_GetOrdTim(SEJobs.StopT - SEJobs.StartT, D_TP.otp_Whl), (* "६室" +CurYearCurMonth *)
                          Tmp02.TripAm, TripAm(),                                                 (* "室"    +CurYearCurMonth *)
                          Tmp02.WorkDays, WorkDays[_DN]);
      Done[_DN]:=1;
     END;
    END;
   END; (* IF L_Way.SEJobsWithPlIncome ... *)
   NEXT(SEJobs);
  END; (* WHILE OCCURE(SEJobs) ... *)
 END {Prepare_Tmp02};

 PRIVATE PROCEDURE Prepare_ExitL();
 BEGIN
  SETZERO(WorkDaysInMonth);
  L_General.Assert(SELECT(Calendar, Period, CurYearCurMonth), "    "+L_DatTim.PeriodStr(CurYearCurMonth));
  WHILE OCCURE(Calendar) DO
   INC(WorkDaysInMonth[Calendar.WDInc]);
   NEXT(Calendar);
  END; (* WHILE OCCURE(Calendar) ... *)

  SELECT(StExit, Exit);
  WHILE OCCURE(StExit) DO
   PROMPT(" " + StExit.Exit);
   IF L_DatTim.IsActiveInIntvl(CurYearCurMonth, L_DatTim.MonthEnd(CurYearCurMonth), StExit.FromD, StExit.UpDate) THEN
    ExitL.ExitClss:=StExit.ExitClss;
    ExitL.Change  :=StExit.Change;
    ExitL.OnDays  :=StExit.OnDays;
    ExitL.Exit    :=StExit.Exit;
    INSERT(ExitL);
    IF StExit.Strict = L_Way.ExitStrict_Reg THEN
     Prepare_Tmp02();
    END;
   END;
   NEXT(StExit);
  END; (* WHILE OCCURE(StExit) ... *)
 END {Prepare_ExitL};

 PRIVATE PROCEDURE PrintTmp02(F: STRING[]);
  VAR
   Coef: NUMERIC[3];
 BEGIN
  SELECT(SEJ01, Route);
  WHILE OCCURE(SEJ01) DO
   PROMPT(" (): " + " " + SEJ01.Route + " " + " " + SEJ01.Exit);
   CONFORM(SEJ01, Route);
   IF L_DatTim.IsActiveInIntvl(CurYearCurMonth, L_DatTim.MonthEnd(CurYearCurMonth), Route.Begin, Route.Till) THEN
    ADD(Tmp02, Route, , SEJ01.Route, SEJ01.Exit, SEJ01.WDWay,
                        Tmp02.PlanIncome, SEJ01.IncPlan,
                        Tmp02.PlanTrip,   SEJ01.WrkTrp,
                        Tmp02.PlanPaidT,  SEJ01.IncTim,
                        Tmp02.PlanOrdT,   SEJ01.OrdTim);
   END;
   NEXT(SEJ01);
  END; (* WHILE OCCURE(SEJ01) ... *)

  SELECT(Tmp02, Route);
  WHILE OCCURE(Tmp02) DO
   PROMPT(" "+Tmp02.Route);
   CONFORM(Tmp02, Route, StExit);
   MustReBuild(OCCURE(Route) & OCCURE(StExit), " ", CurYearCurMonth);
   L_Way.StandOnRouteTKind(CurYearCurMonth);

   MakeLine(F, L_Way.E_ConvertWDStr(Memo.ud_me(), Tmp02.DN));

   MakeLineOneMonthZero(F);   (* PrvYearPrvMonthS *)
   MakeLineOneMonthZero(F);   (* PrvYearCurMonthS *)
   MakeLineOneMonthZero(F);   (* CurYearPrvMonth *)
 
   L_Basis.wb_WrNum(F, Tmp02.PaidT,  3); (* "६室"    +CurYearCurMonth *)
   L_Basis.wb_WrNum(F, Tmp02.OrdT,   3); (* "६室" +CurYearCurMonth *)
   L_Basis.wb_WrNum(F, Tmp02.TripAm, 3); (* "室"    +CurYearCurMonth *)

   Coef:=PerUnit(PerUnit(Tmp02.FactIncomePrvYearCurMonth, Tmp02.FactPaidTimPrvYearCurMonth),
                 PerUnit(Tmp02.FactIncomePrvYearPrvMonth, Tmp02.FactPaidTimPrvYearPrvMonth));

   L_Basis.wb_WrNum(F, Tmp02.PlanIncome, 3);
   L_Basis.wb_WrNum(F, Tmp02.PlanPaidT,  3);
   L_Basis.wb_WrNum(F, Tmp02.PlanOrdT,   3);
   L_Basis.wb_WrNum(F, Tmp02.PlanTrip,   3);

   L_Basis.wb_WrNum(F, Tmp02.FactIncDay * Coef,  3);
   L_Basis.wb_WrNum(F, Tmp02.WorkDays,  0);
   L_Basis.wb_WrNum(F, Tmp02.FactIncDay * Coef*Tmp02.WorkDays, 3);

   L_Basis.wb_TermLine(F);
   NEXT(Tmp02);
  END; (* WHILE OCCURE(Tmp02) ... *)
 END {PrintTmp02};

 PRIVATE PROCEDURE CurYearPrvMonthEndPer(): DATE;
  VAR D, M, Y: NUMERIC[0];
 BEGIN
  UnPkDATE(CurYearPrvMonth, D, M, Y); RETURN PackDATE(25, M, Y);
 END {CurYearPrvMonthEndPer};

 PRIVATE PROCEDURE OpenBasises(From, UpTo: DATE; Silent: SCAL[2]);
 BEGIN
  L_AFM.Init();
  D_TP.extPrepareTP002(From, UpTo, Silent);
  D_TP.extPrepareSEJ01(From, UpTo, 0, 1, Silent, 1);
 END {OpenBasises};

 PRIVATE PROCEDURE PreparePer(From, UpTo: DATE);
 BEGIN
  OpenBasises(From, UpTo, 0);
  D_TP.PurgeTP002();
  D_TP.PurgeSEJ01();
 END {PreparePer};

 PRIVATE PROCEDURE MakePer(From, UpTo: DATE);
 BEGIN
  OpenBasises(From, UpTo, 1);
  Prepare_Tmp(From);
  D_TP.PurgeTP002();
  D_TP.PurgeSEJ01();
  SELECT(Tmp, Route);
  REMSEL(Tmp);
 END {MakePer};

 PUBLIC PROCEDURE IPL10();
  CONST
   bpId = "Ipl10";
 BEGIN
  L_bp.Begin(bpId, "஢ 窨", L_bp.t_Basis, L_General.timeCond_InMonth);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  CurYearCurMonth:=Memo.ud_mb();
  L_StdFrm.Question("஢ 室  " + L_DatTim.PeriodStr(CurYearCurMonth));
  CurYearPrvMonth:=L_DatTim.IncMonth(CurYearCurMonth, -1);
  PrvYearCurMonth:=L_DatTim.IncMonth(CurYearCurMonth, -12);
  PrvYearPrvMonth:=L_DatTim.IncMonth(CurYearCurMonth, -13);
  IF SYSDATE() <= CurYearPrvMonthEndPer() THEN
   L_StdFrm.Choice("  訫 25  諮 |஢  襬 ਮ");
  END;

  PreparePer(PrvYearPrvMonth, L_DatTim.MonthEnd(PrvYearPrvMonth));
  PreparePer(PrvYearCurMonth, L_DatTim.MonthEnd(PrvYearCurMonth));
  PreparePer(CurYearPrvMonth, CurYearPrvMonthEndPer());
  L_AFM.Init();
  D_TP.extPrepareSEJ01(CurYearCurMonth, L_DatTim.MonthEnd(CurYearCurMonth), 0, 1, 0, 0);
  D_TP.PurgeSEJ01();

  Create_Tmp();
  Create_ExitL();
  Create_Tmp02();
  Prepare_ExitL();

  FIO.Open(R, L_General.NameConnection("Ipl10"), "REP", Create);
  MakeHeader("R");
  MakePer(PrvYearPrvMonth, L_DatTim.MonthEnd(PrvYearPrvMonth));
  MakePer(PrvYearCurMonth, L_DatTim.MonthEnd(PrvYearCurMonth));
  MakePer(CurYearPrvMonth, CurYearPrvMonthEndPer());

  L_AFM.Init();
  D_TP.extPrepareSEJ01(CurYearCurMonth, L_DatTim.MonthEnd(CurYearCurMonth), 0, 1, 1, 0);
  PrintTmp02("R");

  FIO.Close(R);
  D_TP.PurgeSEJ01();
  L_AFM.AF_PurgeTemp("Tmp");
  L_bp.End();
 END {IPL10};

END.