(*
%Copyright   (c) Polak Computer System
%Author      02.03.2001 13:48:16 SAN
%Purpose     ஫ 䨪樨 AcCut
%Type        control
%Specific    SYS
%Modified    29.08.2014 16:20:20 POLAK\GAV
%Environment
*)

 MODULE AcCut [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_AcCut, L_Events, L_APtm, L_StdFrm, L_DBD, L_Str, Str, Memo,
        DBD, L_WDO, L_XObj, L_r2r;

 PRIVATE PROCEDURE SetTill();
  VAR
   _Till: DATE;
 BEGIN
  IF SELECT(ACLog, AcCut, AcCut.AcCut) THEN
   AcCut.Begin:=ACLog.Date;
   REPLACE(AcCut);
   _Till:=AcCut.Till;
   LAST(ACLog);
   REPEAT
    ACLog.Till:=_Till;
    REPLACE(ACLog);
    _Till:=ACLog.Date;
   UNTIL ~PREV(ACLog);
  END;
 END {SetTill};

 PRIVATE PROCEDURE CopyRecord(Interactive: SCAL[2]; oldValue: LIKE(AcCut2.AcCut2); New: SCAL[2]);
  VAR
   i: NUMERIC[0];
 BEGIN
  TRY [INTEGRITY(INTEGRITY_ON)]
   IF SELECT(ACLog, AcCut, AcCut.AcCut) THEN
    SetTill();
   ELSE
    L_General.Assert(~Interactive, " ࠧ१   !");
   END;
   IF ~!oldValue THEN
    SETSEL(AC2Log, AcCut2, oldValue);
    REMSEL(AC2Log);
   END;
   i:=0;
   WHILE i < DBD.FieldAmount(AcCut) DO
    ^(DBD.FieldFullName(AcCut2, i)):=^(DBD.FieldFullName(AcCut, i));
    INC(i);
   END;
   IF New THEN
    INSERT(AcCut2);
   ELSE
    REPLACE(AcCut2);
   END;
   SETSEL(ACLog, AcCut, AcCut.AcCut);
   FOR_EACH ACLog DO
    i:=0;
    WHILE i < DBD.FieldAmount(AC2Log) DO
     ^(DBD.FieldFullName(AC2Log, i)):=^(DBD.FieldFullName(ACLog, i));
     INC(i);
    END;
    INSERT(AC2Log);
   END; (* FOR_EACH ACLog *)
  EXCEPT
  END; (* TRY *)
 END {CopyRecord};

 PRIVATE PROCEDURE SetAcCutSign();
 BEGIN
  SAVE(ACLog);
  SETSEL(ACLog, AcCut, AcCut.AcCut);
  IF LAST(ACLog) THEN
   AcCut.Sign:=ACLog.Sign;
  ELSE
   SETEMPTY(AcCut.Sign);
  END;
  REPLACE(AcCut);
  RESTORE(ACLog);
 END {SetAcCutSign};

 PRIVATE PROCEDURE CheckACLogSign();
  VAR
   _AcCut: LIKE(AcCut.AcCut);
   _Date,
   _Till : DATE;
 BEGIN
  SAVE(ACLog);
  SetTill();
  RESTORE(ACLog);
  SAVE(ACLog);
  SAVE(AcCut);
  _AcCut:=AcCut.AcCut;
  _Date :=ACLog.Date;
  _Till :=ACLog.Till;
  SETSEL(ACLog, Sign, ACLog.Sign);
  FOR_EACH ACLog DO
   IF ACLog.AcCut # _AcCut THEN
    CONFORM(ACLog, AcCut);
    L_General.Assert((AcCut.Sign # ACLog.Sign) & ~L_DatTim.IsActiveInIntvl(_Date, _Till, ACLog.Date, ACLog.Till),
                     " 祭 "+ACLog.Sign+" 㦥 ਬ"+
                     "| ࠧ१ " + ACLog.AcCut + "  " +L_DatTim.DateStr(ACLog.Date));
   END;
  END; (* FOR_EACH ACLog *)
  RESTORE(AcCut);
  RESTORE(ACLog);
 END {CheckACLogSign};

 PRIVATE PROCEDURE AccessAcCut2(_AcCut: LIKE(AcCut.AcCut));
 BEGIN
  L_General.CallUs(SEARCH(AcCut2, AcCut2, _AcCut));
 END {AccessAcCut2};

 PRIVATE PROCEDURE CheckRightsModif();
 BEGIN
  IF (AcCut.AcCut = 000) | ((AcCut.AcCut >= 100) & (AcCut.AcCut <= 120)) THEN
   L_General.PrgsOnly_wMes("  ࠧ१ 000, 100..120 १ࢨ஢ ⮏");
  END;
 END {CheckRightsModif};

 PRIVATE PROCEDURE AcCut_OnBeforeEdit();
 BEGIN
  CheckRightsModif();
 END {AcCut_OnBeforeEdit};

 PRIVATE PROCEDURE AcCut_OnAfterEdit();
 BEGIN
  AccessAcCut2(GE_PVALUE(AcCut.AcCut));
  CopyRecord(1, AcCut2.AcCut2, 0);
  L_DBD.CheckValidity("AcCut");
  L_DBD.CheckUsersValidity("AcCut2");
 END {AcCut_OnAfterEdit};

 PUBLIC PROCEDURE AcCut_OnAfterNoninteractiveEdit();
 BEGIN
  AccessAcCut2(AcCut.AcCut);
  CopyRecord(0, AcCut.AcCut, 0);
 END {AcCut_OnAfterNoninteractiveEdit};

 PUBLIC PROCEDURE AcCut_OnAfterNoninteractiveInsert();
 BEGIN
  CopyRecord(0, EMPTYOF(AcCut.AcCut), 1);
 END {AcCut_OnAfterNoninteractiveInsert};

 PRIVATE PROCEDURE AcCut_OnAfterInsert();
 BEGIN
  CheckRightsModif();
  CopyRecord(1, EMPTYOF(AcCut.AcCut), 1);
  L_DBD.CheckValidity("AcCut");
 END {AcCut_OnAfterInsert};

 PRIVATE PROCEDURE AcCut_OnBeforeDelete();
 BEGIN
  CheckRightsModif();
  AccessAcCut2(AcCut.AcCut);
  TRY [INTEGRITY(INTEGRITY_ON)]
   REMOVE(AcCut2);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_NoDeleteUser THEN
    L_General.Error("   㤠, ⮬ " +
                    "|  뫠  㣮 䠩");
   ELSE
    RAISE();
   END;
  END;
 END {AcCut_OnBeforeDelete};

 PRIVATE PROCEDURE AcCut_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "AcCutE");
  L_WDO.iField       (1, "AcCut.SldType").Format:=L_AcCut.sldt_PoolShort;
 END {AcCut_OnInitializeWindow};

 PRIVATE PROCEDURE AcCutE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeEdit]);
  L_WDO.iUnmodifiable(0, ["AcCut.Sign", "AcCut.Begin"]);
  L_WDO.iMayBeEmpty  (0, ["AcCut.Till"]);
  L_WDO.iField       (0, "AcCut.SldType").Format:=L_AcCut.sldt_Pool;
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterEdit, L_WDO.e_OnAfterInsert, L_WDO.e_OnAfterDelete]);
  L_WDO.iScsChange   (1, ["ACLog.Sign", "ACLog.CAcnt"]);
  L_WDO.iField       (1, "ACLog.DoAcnt").Format:="-||";
  L_WDO.iProgs       (1, "AcCut");
 END {AcCutE_OnInitializeWindow};

 PRIVATE PROCEDURE AcCut2E_OnInitializeWindow();
 BEGIN
  L_WDO.iZone        (0).ViewOnly:=1;
  L_WDO.iField       (0, "AcCut2.SldType").Format:=L_AcCut.sldt_Pool;
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iField       (1, "AC2Log.DoAcnt").Format:="-||";
 END {AcCut2E_OnInitializeWindow};

 PRIVATE PROCEDURE AcCutLog_OnAfterEdIns();
 BEGIN
  CheckACLogSign();
  SetAcCutSign();
 END {AcCutLog_OnAfterEdIns};

 PRIVATE PROCEDURE CheckACLogDoAcnt();
 BEGIN
  IF ACLog.DoAcnt = L_XObj.acda_Ignore THEN
   L_General.PrgsOnly();
   L_StdFrm.Choice("஢  ࠧ१  ஢!");
  END;
 END {CheckACLogDoAcnt};

 PRIVATE PROCEDURE ACLog_OnAfterEdit();
 BEGIN
  IF ACLog.DoAcnt # GE_PVALUE(ACLog.DoAcnt) THEN
   L_General.Assert_wReferToAdmin(0, " 祭  'ந '");
   IF    ACLog.DoAcnt = L_XObj.acda_Yes THEN
    L_StdFrm.JustQuestion(" '稫'   ࠧ१  " + L_DatTim.PeriodStr(ACLog.Date));
   ELSE
    CheckACLogDoAcnt();
   END;
  END;
  AcCutLog_OnAfterEdIns();
 END {ACLog_OnAfterEdit};

 PRIVATE PROCEDURE ACLog_OnAfterInsert();
 BEGIN
  CheckACLogDoAcnt();
  AcCutLog_OnAfterEdIns();
 END {ACLog_OnAfterInsert};

 PRIVATE PROCEDURE ACLog_OnAfterDelete();
 BEGIN
  SELECT(ACLog, AcCut, , AcCut.AcCut);
  WHILE OCCURE(ACLog) DO
   CheckACLogSign();
   NEXT(ACLog);
  END; (* WHILE OCCURE(ACLog) ... *)
  SetAcCutSign();
 END {ACLog_OnAfterDelete};

 PRIVATE PROCEDURE CheckSignsMatching();
 BEGIN
  IF Str.Slice(ACLog.Sign, 0, Str.Length(CAcnt.Sign)) # CAcnt.Sign THEN
   L_StdFrm.Choice(" 祭   ࠧ१");
  END;
 END {CheckSignsMatching};

 PRIVATE PROCEDURE ACLog_CAcnt_OnSuccessfulChange();
 BEGIN
  IF ~!ACLog.CAcnt THEN
   CONFORM(ACLog, CAcnt);
   IF !ACLog.Sign THEN
    ACLog.Sign:=CAcnt.Sign;
    REPLACE(ACLog);
   ELSE
    CheckSignsMatching();
   END;
  END;
 END {ACLog_CAcnt_OnSuccessfulChange};

 PRIVATE PROCEDURE ACLog_Sign_OnSuccessfulChange();
 BEGIN
  IF ~!ACLog.Sign & ~!ACLog.CAcnt THEN
   CONFORM(ACLog, CAcnt);
   CheckSignsMatching();
  END;
 END {ACLog_Sign_OnSuccessfulChange};

 PRIVATE PROCEDURE IsSTxAcCut(trgAcCut: LIKE(AcCut.AcCut)): SCAL[2];
 BEGIN
  RETURN (trgAcCut >= 102) & (trgAcCut <= 120);
 END {IsSTxAcCut};

 PRIVATE PROCEDURE CheckSrcAcCutApp(trgAcCut: LIKE(AcCut.AcCut));
 BEGIN
  APP.Get().NewPrompt("஢ઠ ஢  ࠧ१ "+trgAcCut);
  L_General.Assert(~SELECT(XCalc, AcCut, trgAcCut), "१ "+trgAcCut+" ᯮ  室");

  SELECT(XApport, AcCut2, , trgAcCut);
  WHILE OCCURE(XApport) DO
   PROMPT(" "+XApport.XObject);
   CONFORM(XApport, XObject);
   CONFORM(XApport, AcCut);
   IF (XObject.Origin # L_XObj.o_Staff) &
      ((XObject.Origin # L_XObj.o_Man) | ~IsSTxAcCut(XApport.AcCut)) &
      ((XObject.Origin # L_XObj.o_Global) | ~L_kn.Is(SYSDATE(), L_AcCut.erkn_VacationProvision)) THEN
    L_General.Error("१ "+trgAcCut+" ᯮ  ᯮ騩  ஢    ந宦 '"+
                    L_Str.PoolItem(L_XObj.o_Pool, XObject.Origin)+"'");
   END;
   NEXT(XApport);
  END; (* WHILE OCCURE(XApport) ... *)
 END {CheckSalDstAcCut};

 PRIVATE PROCEDURE CheckDstAcCutApp(trgAcCut: LIKE(AcCut.AcCut));
 BEGIN
  APP.Get().NewPrompt("஢ઠ ஢  ࠧ१ "+trgAcCut);
  SELECT(XCalc, AcCut, , trgAcCut);
  WHILE OCCURE(XCalc) DO
   PROMPT(" "+XCalc.XObject);
   NARROWSEL(XCalc, XObject);
   CONFORM(XCalc, XObject);
   L_General.Assert((XObject.Origin # L_XObj.o_Staff) &
                    (XObject.Origin # L_XObj.o_Man)   &
                    (XObject.Origin # L_XObj.o_Global), "१ "+trgAcCut+" ᯮ  室|"+
                                                        "   ந宦 '"+L_Str.PoolItem(L_XObj.o_Pool, XObject.Origin)+"'");
   NEXTINEXTENDEDSEL(XCalc, XObject);
  END; (* WHILE OCCURE(XCalc) *)
 END {CheckDstAcCutApp};

 PRIVATE PROCEDURE MergeCalc(_XObject: LIKE(XObject.XObject);
                             OldAcCut,
                             NewAcCut: LIKE(AcCut.AcCut);
                             Silent  : SCAL[2]);
  VAR
   curSldSum,
   curRSlSum,
   curDbtSum,
   curCrdSum,
   curSum    : L_XObj.tSum;
   curSldQnt,
   curRSlQnt,
   curDbtQnt,
   curCrdQnt,
   curQnt    : L_XObj.tQnt;
   HaveNew   : SCAL[2];
   P         : DATE;
   i         : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" ஢");
  TRY [INTEGRITY(INTEGRITY_ON)]
   IF SELECT(XCalc, AcCut, OldAcCut) THEN
    i:=0;
    IF ~!_XObject THEN
     SELECT(XObject, XObject, , _XObject);
    ELSE
     SELECT(XObject, XObject);
    END;
    WHILE OCCURE(XObject) DO
     INC(i);
     PROMPT(" "+XObject.XObject + " " + FLDTOSTR(i/AMOUNT(XObject)*100, "", 3)+"%");
   
     HaveNew:=SELECT(XCalc, XObject, XObject.XObject, NewAcCut);
     IF SELECT(XCalc, XObject, XObject.XObject, OldAcCut) THEN
      P:=XCalc.XDat;
  
      WHILE OCCURE(XCalc) DO
       curSldSum:=XCalc.SldSum;
       curSldQnt:=XCalc.SldQnt;
       curRSlSum:=XCalc.RSlSum;
       curRSlQnt:=XCalc.RSlQnt;
       curDbtSum:=XCalc.DbtSum;
       curDbtQnt:=XCalc.DbtQnt;
       curCrdSum:=XCalc.CrdSum;
       curCrdQnt:=XCalc.CrdQnt;
       SAVE(XCalc);
       ADD(XCalc, XObject, , XCalc.XObject, NewAcCut, XCalc.XDat,
                          XCalc.SldSum, curSldSum,
                          XCalc.SldQnt, curSldQnt,
                          XCalc.RSlSum, curRSlSum,
                          XCalc.RSlQnt, curRSlQnt,
                          XCalc.DbtSum, curDbtSum,
                          XCalc.DbtQnt, curDbtQnt,
                          XCalc.CrdSum, curCrdSum,
                          XCalc.CrdQnt, curCrdQnt);
       RESTORE(XCalc);
  
       CONFORM(XCalc, XApport);
       WHILE OCCURE(XApport) DO
        SAVE(XApport);
        curSum:=XApport.Sum;
        curQnt:=XApport.Qnt;
        ADD(XApport, XObject, , XApport.XObject, NewAcCut, XApport.XDat,
                             XApport.Apport, XApport.AcCut2,
                             XApport.WFDate, XApport.Source,
                             XApport.Sum, curSum,
                             XApport.Qnt, curQnt);
        RESTORE(XApport);
        REMOVE(XApport);
       END; (* WHILE OCCURE(XApport) ... *)
       REMOVE(XCalc);
      END; (* WHILE OCCURE(XCalc) ... *)
      IF HaveNew THEN
       SETSEL(XCalc, XObject, XObject.XObject, NewAcCut);
       IF ~SRCINSEL(XCalc, LT, P) THEN
        SRCINSEL(XCalc, EQ, , P);
       END;
       Memo.gl_SetCurDate(XCalc.XDat);
       L_XObj.extBalXCalc(Silent);
       IF L_XObj.IsMaterialXObject() THEN
        L_XObj.ResetXObjectDone(P, L_XObj.SectionOfXObjectAcCut(XCalc.AcCut), 0);
       END;
      END;
     END;
     NEXT(XObject);
    END; (* WHILE OCCURE(XObject) ... *)
   END;
 
   IF ~!_XObject THEN
    SELECT(XApport, XObject, , _XObject);
   ELSE
    SELECT(XApport, AcCut2, , OldAcCut);
   END;
   WHILE OCCURE(XApport) DO
    IF XApport.AcCut2 = OldAcCut THEN
     SAVE(XApport);
     curSum:=XApport.Sum;
     curQnt:=XApport.Qnt;
     ADD(XApport, XObject, , XApport.XObject, XApport.AcCut, XApport.XDat,
                          XApport.Apport, NewAcCut,
                          XApport.WFDate, XApport.Source,
                          XApport.Sum, curSum,
                          XApport.Qnt, curQnt);
     RESTORE(XApport);
     REMOVE(XApport);
    ELSE
     NEXT(XApport);
    END;
   END; (* WHILE OCCURE(XApport) ... *)
  EXCEPT
  END; (* TRY *)
 END {MergeCalc};

 PRIVATE PROCEDURE CheckAcnt(_AcCut, _AcCut2: LIKE(AcCut.AcCut));
  CONST
   Msg = " ᮢ  ⮢";
 BEGIN
  SETSEL(ACLog, AcCut, _AcCut);
  SETSEL(AC2Log, AcCut2, _AcCut2);
  IF SRCINSEL(ACLog, LE, SYSDATE()) & SRCINSEL(AC2Log, LE, SYSDATE()) THEN
   WHILE OCCURE(ACLog) & OCCURE(AC2Log) DO
    IF ACLog.CAcnt # AC2Log.CAcnt THEN
     L_StdFrm.ConditionalCHOICE(Msg, L_General.IsProgrammer());
     RETURN;
    END;
    PREV(ACLog);
    PREV(AC2Log);
   END;
  END;
  IF OCCURE(ACLog) | OCCURE(AC2Log) THEN
   L_StdFrm.ConditionalCHOICE(Msg, L_General.IsProgrammer());
  END;
 END {CheckAcnt};

 PUBLIC PROCEDURE extMergeAcCut(srcAcCut, dstAcCut: LIKE(AcCut.AcCut); wCheck, Silent: SCAL[2]);
 BEGIN
  APP.Get().NewPrompt(" ᯮ짮 ࠧ१ " + srcAcCut + "  " + dstAcCut);
  SEARCH(AcCut,  AcCut, ,  srcAcCut);
  L_r2r.Owner_OnBeforeDelete("AcCut");
  SEARCH(AcCut2, AcCut2, , srcAcCut);
  SEARCH(AcCut,  AcCut, ,  dstAcCut);

  IF ~Silent THEN
   L_StdFrm.Choice(" ᯮ짮 ࠧ१" +
                   "| |" +
                   AcCut2.AcCut2 + " " + AcCut2.Name +
                   "|" +
                   "" +
                   "|" +
                   AcCut.AcCut + " " + AcCut.Name);
  END;

  FLOCK(XCalc,   Monopol);
  FLOCK(XApport, Monopol);
  FLOCK(AcMthL,  Monopol);

  IF ~L_General.IsProgrammer() | L_StdFrm.Alternative("믮 ஢  ᯮ짮 ࠧ१ ᪫⥫쭮  । ?") THEN
   CheckSrcAcCutApp(srcAcCut);
   CheckDstAcCutApp(dstAcCut);
  END;

  IF wCheck THEN
   CheckAcnt(dstAcCut, srcAcCut);
  END;

  MergeCalc(EMPTYOF(XObject.XObject), srcAcCut, dstAcCut, Silent);

  TRY [INTEGRITY(INTEGRITY_OFF)]
   SEARCH(AcCut2, AcCut2, , srcAcCut);
   REMOVE(AcCut2);
   SETSEL(AC2Log, AcCut2, srcAcCut);
   REMSEL(AC2Log);
   SEARCH(AcCut,  AcCut, , srcAcCut);
   REMOVE(AcCut);
   SETSEL(ACLog, AcCut, srcAcCut);
   REMSEL(ACLog);
 
   SEARCH(AcCut2, AcCut2, , dstAcCut);
   AcCut2.AcCut2:=srcAcCut;
   REPLACE(AcCut2);
   SEARCH(AcCut, AcCut, , dstAcCut);
   AcCut.AcCut:=srcAcCut;
   REPLACE(AcCut);
  EXCEPT
  END;

  TRY [INTEGRITY(INTEGRITY_ON)]
   AcCut2.AcCut2:=dstAcCut;
   REPLACE(AcCut2);
   AcCut.AcCut  :=dstAcCut;
   REPLACE(AcCut);
  EXCEPT
  END;
 END {extMergeAcCut};

 PUBLIC PROCEDURE MergeAcCut(srcAcCut, dstAcCut: LIKE(AcCut.AcCut));
 BEGIN
  extMergeAcCut(srcAcCut, dstAcCut, 1, 0);
 END {MergeAcCut};

 PUBLIC PROCEDURE MergeCurrentAcCut();
  VAR
   srcAcCut: LIKE(AcCut.AcCut);
   dstAcCut: LIKE(AcCut2.AcCut2);
 BEGIN
  L_General.AdminOnly();
  SETEMPTY(srcAcCut, dstAcCut);
  L_General.Assert(ACCESS(AcCut), " ⠭ ⥪騩 ࠧ१");
  srcAcCut:=AcCut.AcCut;
  STDFORM(L_StdFrm.sf_Choice("|  ࠧ१ "+AcCut.AcCut+"  ७ᥭ,"+
                             "|᫥ 祣  ࠧ१ 㤥 㤠."+
                             "||,  ⢨  ⨬!"+
                             "||  ࠧ१ ꥤ ?||%###%",
                             "%I"),
          " ﭨ ࠧ१ ",
          CHOICE,
          -1,
          dstAcCut);
  MergeAcCut(srcAcCut, dstAcCut);
  SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), AcCut);
 END {MergeCurrentAcCut};

BEGIN
 L_Events.ExecuteHandler();
END.
