(*
%Copyright   (c) Polak Computer System
%Author      15.10.1997 18:39:57 SAN
%Purpose     ஫ 䨪樨 AcMth
%Type        control
%Specific    SYS
%Modified    05.09.2014 12:54:52 POLAK\San
%Environment
*)

 MODULE AcMth [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, L_OwnData, L_MathR, L_Acnt,
        L_XObj, L_Str, Memo, L_APtm, L_XDR, L_Dest, Math, L_PDoc,
        SysLog, L_MDoc, L_StdFrm, L_AcMth, L_AcCut, FIO, Str, L_DBD,
        L_r2r, L_WDO, L_kn;

 PRIVATE PERMANENT VAR
  CheckedAcMth: LIKE(AcMth.AcMth);
  CheckedPer  : DATE;

 PRIVATE PROCEDURE SupportBeginTill();
  VAR
   curTill: DATE;
 BEGIN
  L_General.Assert(SELECT(AcMthH, AcMth, AcMth.AcMth),
                   "      䨪");
  AcMth.Begin:=AcMthH.Date;
  REPLACE(AcMth);
  LAST(AcMthH);
  L_General.Assert(AcMthH.Date < AcMth.Till,
                   "|ਮ ⢨ 樨  稢" +
                   "|  ᫥ 䨪樨");
  curTill:=AcMth.Till;
  REPEAT
   AcMthH.Till:=curTill;
   REPLACE(AcMthH);
   curTill:=AcMthH.Date;
  UNTIL ~PREV(AcMthH);
 END {SupportBeginTill};

 PRIVATE PROCEDURE MDocKindCond(): SCAL[2];
 BEGIN
  RETURN MDocKind.DGroup = AcMth.DGroup;
 END {MDocCond};

 PRIVATE PROCEDURE MDocCond(): SCAL[2];
 BEGIN
  IF ~MDoc.Done | (MDoc.Status # L_MDoc.st_Passed) THEN
   RETURN 0;
  END;
  IF ~!MDoc.Math THEN
   CONFORM(MDoc, Math);
   SELECT(AcMthA, AcMth, , AcMth.AcMth);
   WHILE OCCURE(AcMthA) DO
    IF Math.MathType = AcMthA.MathType THEN
     RETURN 1;
    END;
    NEXT(AcMthA);
   END; (* WHILE OCCURE(AcMthA) ... *)
   RETURN 0;
  END;
  RETURN 1;
 END {MDocCond};

 PRIVATE PROCEDURE MDocListCond(): SCAL[2];
 BEGIN
  IF RTI.Get().CurZone.MasterTable.Name = "AcMthA" THEN
   RETURN (MDocList.MMode = AcMthA.MMode) & (Math.MathType = AcMthA.MathType);
  ELSE
   SELECT(AcMthA, AcMth, , AcMth.AcMth);
   WHILE OCCURE(AcMthA) DO
    IF (MDocList.MMode = AcMthA.MMode) & (~OCCURE(Math) | (Math.MathType = AcMthA.MathType)) THEN
     RETURN 1;
    END;
    NEXT(AcMthA);
   END; (* WHILE OCCURE(AcMthA) ... *)
  END;
  RETURN 0;
 END {MDocListCond};

 PRIVATE PROCEDURE PDocCond(): SCAL[2];
 BEGIN
  RETURN PDoc.Done & (PDoc.Status = L_PDoc.st_Passed);
 END {PDocCond};

 PRIVATE PROCEDURE PDocKindCond(): SCAL[2];
 BEGIN
  RETURN PDocKind.DGroup = AcMth.DGroup;
 END {PDocKindCond};

 PRIVATE PROCEDURE HasUndoneDocuments(From, UpTo: DATE): SCAL[2];
 BEGIN
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   RETURN L_AcMth.ltbam_Has(From, UpTo, AcMth.Dest,
                            PROCREF(MDocKindCond), PROCREF(MDocCond), PROCREF(MDocListCond),
                            PROCREF(PDocKindCond), PROCREF(PDocCond));
  EXCEPT
  END;
 END {HasUndoneDocuments};

 PRIVATE PROCEDURE intCheckDocumentsIsUndone(From, UpTo: DATE; IsBeforeModification: SCAL[2]);
  VAR
   BarkMsg: STRING[];
 BEGIN
  IF (CheckedAcMth # AcMth.AcMth) | (CheckedPer > From) THEN
   IF HasUndoneDocuments(From, UpTo) THEN
    BarkMsg:=" ࠡ⠭ 㬥  " + L_DatTim.PeriodStr(From) + "   ( " + L_DatTim.PeriodStr(UpTo) + ")." +
             "|। 䨪樥 樨 ᫥ ⪠ 㬥.";
    IF IsBeforeModification THEN
     BarkMsg:=BarkMsg + "||᫨ 㦭 ⮫쪮 ᬮ, ᯮ ShiftEnter.";
    END;
    IF L_General.IsProgrammer() THEN
     BarkMsg:=BarkMsg + "||, ணࠬ,  ஢ ."+
                        "| 䨪樨 樨  稨 ࠡ⠭ 㬥⮢" +
                        "|㤥 䨪஢  ⥬ ୠ." +
                        "|   㤥    樨.";
    END;
    L_StdFrm.ConditionalCHOICE(BarkMsg, L_General.IsProgrammer());
    SysLog.Mark("AcMth", " " + AcMth.AcMth + " " + L_DatTim.PeriodStr(From) + "/" + L_DatTim.PeriodStr(UpTo) +
                         ": 䨪  ⪠祭 㬥");
   END;
   IF (RTI.Get().CurZone.MasterTable.Name # "AcMthA") & (UpTo = L_DatTim.MAXDATE()) THEN
    CheckedAcMth:=AcMth.AcMth;
    CheckedPer  :=From;
   END;
  END;
 END {intCheckDocumentsIsUndone};

 PRIVATE PROCEDURE CheckDocumentsIsUndone(P: DATE; IsBeforeModification: SCAL[2]);
 BEGIN
  intCheckDocumentsIsUndone(P, L_DatTim.MAXDATE(), IsBeforeModification);
 END {CheckDocumentsIsUndone};

 PUBLIC PROCEDURE NextLog();
  VAR
   trgDate: LIKE(AcMthH.Date);
 BEGIN
  trgDate:=Memo.ud_mb();
  L_StdFrm.Question(" 䨪  " + L_DatTim.PeriodStr(trgDate));
  L_General.Assert(ACCESS(AcMthH), " ⠭ ⥪ 䨪");
  CONFORM(AcMthH, AcMth);

  SAVE(AcMthH);
  CHANGESEL(AcMthH, AcMth, , AcMthH.AcMth);
  IF NEXT(AcMthH) THEN
   L_StdFrm.Choice("    ᫥ 䨪樨");
  ELSE
   LAST(AcMthH);
   L_General.Assert(trgDate < AcMth.Till,
                    "    " + L_DatTim.PeriodStr(trgDate));
  END;
  L_General.Assert(~SRCINSEL(AcMthH, EQ, trgDate),
                   "  䨪  " + L_DatTim.PeriodStr(trgDate));
  RESTORE(AcMthH);

  CheckDocumentsIsUndone(trgDate, 0);

  CONFORM(AcMthH, AcMthL);
  WHILE OCCURE(AcMthL) DO
   SAVE(AcMthL);
   AcMthL.Date:=trgDate;
   AcMthL.aSaleTax:=L_Acnt.cccm_Not;
   INSERT(AcMthL);
   RESTORE(AcMthL);
   NEXT(AcMthL);
  END; (* WHILE OCCURE(AcMthL) ... *)
  AcMthH.Date:=trgDate;
  INSERT(AcMthH);
  SE_WZD_POSITION(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number, AcMthH);
 END {NextLog};

 PRIVATE PROCEDURE intMakeCopy(srcAcMth: LIKE(AcMth.AcMth));
 BEGIN
  L_DBD.CopyFromSrcRecord_wExclude("AcMth", srcAcMth, "Till|Dest");
  REPLACE(AcMth);
  SELECT(AcMthH, AcMth, , srcAcMth);
  WHILE OCCURE(AcMthH) DO
   SAVE(AcMthH);
   CONFORM(AcMthH, AcMthL);
   AcMthH.AcMth:=AcMth.AcMth;
   INSERT(AcMthH);
   WHILE OCCURE(AcMthL) DO
    SAVE(AcMthL);
    AcMthL.AcMth:=AcMth.AcMth;
    AcMthL.aSaleTax:=L_Acnt.cccm_Not;
    INSERT(AcMthL);
    RESTORE(AcMthL);
    NEXT(AcMthL);
   END; (* WHILE OCCURE(AcMthL) ... *)
   RESTORE(AcMthH);
   NEXT(AcMthH);
  END; (* WHILE OCCURE(AcMthH) ... *)
  SELECT(AcMthA, AcMth, , srcAcMth);
  WHILE OCCURE(AcMthA) DO
   SAVE(AcMthA);
   AcMthA.AcMth:=AcMth.AcMth;
   INSERT(AcMthA);
   RESTORE(AcMthA);
   NEXT(AcMthA);
  END; (* WHILE OCCURE(AcMthA) ... *)
 END {intMakeCopy};

 PRIVATE PROCEDURE CheckLastAcMthH();
 BEGIN
  L_General.Assert(ACCESS(AcMthH), " ⠭ ⥪ 䨪");
  SAVE(AcMthH);
  CHANGESEL(AcMthH, AcMth, , AcMthH.AcMth);
  IF NEXT(AcMthH) THEN
   L_StdFrm.Choice("   ᫥ 䨪");
  END;
  RESTORE(AcMthH);
 END {CheckLastAcMthH};

 PRIVATE PROCEDURE AcMthL_ACPrp_OnSuccessfulChange();
 BEGIN
  IF AcMthL.ACPrp # L_Acnt.acp_Nothing THEN
   SETEMPTY(AcMthL.AcCut);
   REPLACE(AcMthL);
  END;
  RTI.Get().CurZone.Fields("AcMthL.AcCut").Modifiable:=(AcMthL.ACPrp = L_Acnt.acp_Nothing);
 END {AcMthL_ACPrp_OnSuccessfulChange};

 PRIVATE PROCEDURE AcMthL_ACPrp2_OnSuccessfulChange();
 BEGIN
  IF AcMthL.ACPrp2 # L_Acnt.acp_Nothing THEN
   SETEMPTY(AcMthL.AcCut2);
   REPLACE(AcMthL);
  END;
  RTI.Get().CurZone.Fields("AcMthL.AcCut2").Modifiable:=(AcMthL.ACPrp2 = L_Acnt.acp_Nothing);
 END {AcMthL_ACPrp2_OnSuccessfulChange};

 PRIVATE PROCEDURE AcMthL_OnBeforeEdIns();
 BEGIN
  CheckLastAcMthH();
  RTI.Get().CurZone.Fields("AcMthL.AcCut" ).Modifiable:=(AcMthL.ACPrp  = L_Acnt.acp_Nothing);
  RTI.Get().CurZone.Fields("AcMthL.AcCut2").Modifiable:=(AcMthL.ACPrp2 = L_Acnt.acp_Nothing);
 END {AcMthL_OnBeforeEdIns};

 PRIVATE PROCEDURE AcMthL_OnBeforeInsert();
 BEGIN
  AcMthL_OnBeforeEdIns();
  CheckDocumentsIsUndone(AcMthH.Date, 0);
 END {AcMthL_OnBeforeInsert};

 PRIVATE PROCEDURE AcMthL_OnBeforeEdit();
 BEGIN
  AcMthL_OnBeforeEdIns();
  CheckDocumentsIsUndone(AcMthH.Date, 1);
 END {AcMthL_OnBeforeEdit};

 PRIVATE PROCEDURE AcMthL_OnBeforeDelete();
 BEGIN
  CheckLastAcMthH();
  CheckDocumentsIsUndone(AcMthH.Date, 0);
 END {AcMthL_OnBeforeDelete};

 PUBLIC PROCEDURE AcMthE_OnConformToWindow();
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = "AcMthA" THEN
   ACCESS(AcMthA);
   CONFORM(AcMthA, AcMth);
   CHANGESEL(AcMth, AcMth, , AcMth.AcMth);
   SE_WWD_CURSOR("AcMthE", AcMth);
  ELSE
   L_General.CallUs(0);
  END;
 END {AcMthE_OnConformToWindow};

 PRIVATE PROCEDURE intAssert(_Cond: SCAL[2]; Msg: STRING[]);
 BEGIN
  IF ~_Cond THEN
   L_StdFrm.Choice(Msg);
  END;
 END {intAssert};

 PRIVATE PROCEDURE CheckApport(trgOrigin :  L_Acnt.tAcMthOrigin;
                               trgAcCut  : LIKE(AcCut.AcCut);
                               trgACPrp  : LIKE(AcMthL.ACPrp);
                               trgApport :  LIKE(AcMthL.Apport);
                               trgCirKind: LIKE(Apport.CirKind));
  VAR
   MsgMustBeInstead,
   MsgImpossible    : STRING[];
   curPriceGrp      : LIKE(AcCut.PriceGrp);
 BEGIN
  L_General.CallUs(SEARCH(Apport, Apport, trgApport));
  MsgMustBeInstead:=" "+trgApport+"   ᯮ  ⨯|";
  CONFORM(AcMthL, AcMthH);
  CONFORM(AcMthH, AcMth);

  MsgImpossible:="ᯮ  ⨯ '"+L_Str.PoolItem(L_Acnt.ck_Pool, trgCirKind)+"' ("+trgApport+")|⨬ ";
  IF L_Acnt.isMathFamilyOrigin(trgOrigin) THEN
   IF (AcMthL.aNetto   # L_Acnt.cccm_Not) |
      (AcMthL.aVAT     # L_Acnt.cccm_Not) |
      (AcMthL.aSaleTax # L_Acnt.cccm_Not) THEN
    IF ~!trgAcCut THEN
     L_General.CallUs(SEARCH(AcCut, AcCut, trgAcCut));
     curPriceGrp:=AcCut.PriceGrp;
    ELSE
     curPriceGrp:=00;
    END;

    IF (AcMthL.aAmount # L_Acnt.cccm_Not) & (curPriceGrp # 00) THEN
     intAssert(trgCirKind = L_Acnt.ck_ExplicitCir,
               MsgMustBeInstead+"'"+L_Str.PoolItem(L_Acnt.ck_Pool, L_Acnt.ck_ExplicitCir)+"'");
    END;
   ELSE
    intAssert((trgCirKind = L_Acnt.ck_EstimatedCir) | (trgCirKind = L_Acnt.ck_SpecialCir),
              MsgMustBeInstead+"'"+L_Str.PoolItem(L_Acnt.ck_Pool, L_Acnt.ck_EstimatedCir)+"'  '"+L_Str.PoolItem(L_Acnt.ck_Pool, L_Acnt.ck_SpecialCir)+"'");
   END;
   IF trgOrigin # L_Acnt.amo_Math THEN
    intAssert(trgCirKind # L_Acnt.ck_MoneyOnly,
              MsgImpossible+" ⠭  ꥪ⮬ '"+L_Str.PoolItem(L_Acnt.amo_Pool, trgOrigin)+"'");
   END;
  ELSE
   intAssert(trgCirKind = L_Acnt.ck_MoneyOnly, MsgMustBeInstead+L_Str.PoolItem(L_Acnt.ck_Pool, L_Acnt.ck_MoneyOnly));
  END;
  IF (AcMthL.aAmount = L_Acnt.cccm_Not) &
     (AcMthL.CirSrc  # L_Acnt.cs_XCalc) THEN
   intAssert(trgCirKind # L_Acnt.ck_EstimatedCir,
             MsgImpossible+' 㪠 "⢮" = "'+L_Str.PoolItem(L_Acnt.cccm_Pool, AcMthL.aAmount)+'"');
  END;
 END {CheckApport};

 PRIVATE PROCEDURE CheckAcCutwAmount(NeedwAmount: SCAL[2]; ObjName: STRING[]);
  VAR
   Msg: STRING[];
 BEGIN
  Msg:=" ࠧ१| ⨯ ⨬ ᠫ줮 '"+L_Str.PoolItem(L_AcCut.sldt_Pool, L_AcCut.sldt_wAmount)+"'";
  IF (AcCut.SldType = L_AcCut.sldt_wAmount) | (AcCut.SldType = L_AcCut.sldt_wAmountCredit) THEN
   intAssert( NeedwAmount, ObjName+" ⨬ 㪠뢠"+Msg)
  ELSE
   intAssert(~NeedwAmount, ObjName+"   㪠"+Msg);
  END;
 END {CheckAcCutwAmount};

 PRIVATE PROCEDURE cac_Assert(ACPCond: SCAL[2]; trgOrigin: L_Acnt.tAcMthOrigin; trgACPrp: LIKE(AcMthL.ACPrp));
 BEGIN
  IF ~ACPCond THEN
   L_General.Error(" ꥪ '" + L_Str.PoolItem(L_Acnt.amo_Pool, trgOrigin) + "' ⨬ " +
                   "|㪠뢠 ࠧ१ '" + L_Str.PoolItem(L_Acnt.acp_Pool, trgACPrp) + "'");
  END;
 END {cac_Assert};

 PRIVATE PROCEDURE CheckAcCut(trgOrigin: L_Acnt.tAcMthOrigin; trgAcCut: LIKE(AcMthL.AcCut); trgACPrp: LIKE(AcMthL.ACPrp));
 BEGIN
  IF (trgACPrp = L_Acnt.acp_Nothing) THEN
   L_General.Assert(~!trgAcCut, " 㪠 '' ࠧ१");
  END;
  IF trgAcCut = L_Acnt.fictAcCut THEN
   intAssert(!trgOrigin, "   ᪮   ࠧ१ "+trgAcCut);
  ELSIF ~!trgOrigin & ~!trgAcCut THEN
   CONFORM(AcMthL, AcMthH);

   SETSEL(ACLog, AcCut, trgAcCut);
   L_General.Assert(SRCINSEL(ACLog, LE, AcMthH.Till), "१ "+trgAcCut+"    "+L_DatTim.DateStr(AcMthH.Date));
   CONFORM(ACLog, CAcnt);
   IF CAcnt.Type # L_Acnt.catyp_Online THEN
    CONFORM(ACLog, AcCut);
    CheckAcCutwAmount((trgOrigin = L_Acnt.amo_MathByStr) |
                      (trgOrigin = L_Acnt.amo_MathByStr2) |
                      (trgOrigin = L_Acnt.amo_MathInAH) |
                      (trgOrigin = L_Acnt.amo_MathByCntr) |
                      (trgOrigin = L_Acnt.amo_MathByCar),
                      " ꥪ '"+L_Str.PoolItem(L_Acnt.amo_Pool, trgOrigin)+"'");

    IF AcMthL.aAmount # L_Acnt.cccm_Not THEN
     intAssert(trgOrigin # L_Acnt.amo_Math, " ꥪ '"+L_Str.PoolItem(L_Acnt.amo_Pool, trgOrigin)+"' 㪠 ⢠|"+
                                            "⨬ ⮫쪮  ࠧ१  ⨯  '"+L_Str.PoolItem(L_Acnt.catyp_Pool, L_Acnt.catyp_Online)+"'");
    END;
   END; (* IF trgAcCut = L_Acnt.fictAcCut ... *)
  END;
  IF ~!trgOrigin & (~!trgACPrp & (trgACPrp # L_Acnt.acp_Nothing)) THEN
   IF (trgOrigin = L_Acnt.amo_Contract) THEN
    cac_Assert((trgACPrp = L_Acnt.acp_Contract_Netto), trgOrigin, trgACPrp);
   ELSIF (trgOrigin = L_Acnt.amo_CostItem) |
         (trgOrigin = L_Acnt.amo_CostItemByMDL) THEN
    cac_Assert((trgACPrp = L_Acnt.acp_CostItem_Default) |
               (trgACPrp = L_Acnt.acp_CostItemSale) |
               (trgACPrp = L_Acnt.acp_RecExpSaldo), trgOrigin, trgACPrp);
   ELSIF (trgOrigin = L_Acnt.amo_MathInAH) THEN
    cac_Assert((trgACPrp = L_Acnt.acp_MathInAdvHld), trgOrigin, trgACPrp);
   ELSIF (trgOrigin = L_Acnt.amo_MathByStr) |
         (trgOrigin = L_Acnt.amo_MathByStr2) THEN
    cac_Assert((trgACPrp = L_Acnt.acp_Math_Netto) |
               (trgACPrp = L_Acnt.acp_MathInAdvHld), trgOrigin, trgACPrp);
   ELSIF (trgOrigin = L_Acnt.amo_Math) THEN
    cac_Assert((trgACPrp = L_Acnt.acp_Math_VAT) |
               (trgACPrp = L_Acnt.acp_MathSale_Netto) |
               (trgACPrp = L_Acnt.acp_MathSale_VAT) |
               (trgACPrp = L_Acnt.acp_Math_Netto), trgOrigin, trgACPrp);
   ELSIF (trgOrigin = L_Acnt.amo_MathByCntr) THEN
    cac_Assert((trgACPrp = L_Acnt.acp_MathOffSite), trgOrigin, trgACPrp);
   ELSE
    cac_Assert(0, trgOrigin, trgACPrp);
   END;
  END;
 END {CheckAcCut};

 PRIVATE PROCEDURE CheckAcMthLnA(trgOrigin  : L_Acnt.tAcMthOrigin;
                                 trgACPrp   : LIKE(AcMthL.ACPrp);
                                 trgMathType: LIKE(AcMthA.MathType));
  VAR
   ErrorPoint: STRING[];
 BEGIN
  SEARCH(MathType, MathType, , trgMathType);
  ErrorPoint:="䨪  "+L_DatTim.PeriodStr(AcMthL.Date)+", ஢ "+AcMthL.RuleNbr+":||"+
              "   "+MathType.MathType+" "+MathType.Name+"|";
  IF (MathType.Category # L_Acnt.mtc_Inventories) THEN
   IF ~!trgOrigin THEN
    L_General.Assert((trgOrigin # L_Acnt.amo_MathInAH)   &
                     (trgOrigin # L_Acnt.amo_MathByStr)  &
                     (trgOrigin # L_Acnt.amo_MathByStr2), ErrorPoint+
                                                          "⨬ 㪠뢠 ꥪ '"+L_Str.PoolItem(L_Acnt.amo_Pool, trgOrigin)+"'");
   END;
  END;
  IF (MathType.MathType = L_MathR.mtyp_KeyAssets) THEN
   IF ~!trgOrigin THEN
    L_General.Assert((trgOrigin # L_Acnt.amo_MathInAH), ErrorPoint+
                                                        "⨬ 㪠뢠 ꥪ '"+L_Str.PoolItem(L_Acnt.amo_Pool, trgOrigin)+"'");
   END;
   IF ~!trgACPrp THEN
    L_General.Assert((trgACPrp # L_Acnt.acp_Math_Netto), ErrorPoint+
                                                         "⨬ 㪠뢠 ࠧ१ '"+
                                                         L_Str.PoolItem(L_Acnt.acp_Pool, trgACPrp) + "'");
   END;
  END;
 END {CheckAcMthLnA};

 PRIVATE PROCEDURE CheckAcMthA();
 BEGIN
  SELECT(AcMthH, AcMth, , AcMthA.AcMth);
  WHILE OCCURE(AcMthH) DO
   IF L_DatTim.IsActiveInIntvl(AcMthA.Begin, AcMthA.Till, AcMthH.Date, AcMthH.Till) THEN
    CONFORM(AcMthH, AcMthL);
    WHILE OCCURE(AcMthL) DO
     CheckAcMthLnA(AcMthL.Origin1, AcMthL.ACPrp,  AcMthA.MathType);
     CheckAcMthLnA(AcMthL.Origin2, AcMthL.ACPrp2, AcMthA.MathType);
     NEXT(AcMthL);
    END; (* WHILE OCCURE(AcMthL) ... *)
   END;
   NEXT(AcMthH);
  END; (* WHILE OCCURE(AcMthH) ... *)
 END {CheckAcMthA};

 PRIVATE PROCEDURE AcMthL_OnAfterEditInsert();
 BEGIN
  IF (!AcMthL.Origin1 # !AcMthL.Apport ) | (!AcMthL.Origin2 # !AcMthL.Apport2) THEN
   L_General.Error("ꥪ  ᯮ   ஭ ஢||    ,   ");
  END;
  IF !AcMthL.Origin1 & !AcMthL.Origin2 THEN
   L_General.Error(" ନ    ஭ ஢");
  ELSIF !AcMthL.Origin1 | !AcMthL.Origin2 THEN
   L_StdFrm.Question(" ᠫ ஭ ஢");
  END;
  L_General.Assert((AcMthL.CirSrc   = L_Acnt.cs_MDoc)  | (AcMthL.aAmount = L_Acnt.cccm_Not), '⢮   ⮫쪮  筨 ⮢|"ப ⮢୮ 㬥"');
  L_General.Assert((AcMthL.aVAT     = L_Acnt.cccm_Not) | (AcMthL.aAmount = L_Acnt.cccm_Not), '   ६ 㪠 ⢮  ');
  L_General.Assert((AcMthL.aSaleTax = L_Acnt.cccm_Not) | (AcMthL.aAmount = L_Acnt.cccm_Not), '   ६ 㪠 ⢮  ');
  CheckAcCut(AcMthL.Origin1, AcMthL.AcCut, AcMthL.ACPrp);
  IF ~!AcMthL.Apport THEN
   CONFORM(AcMthL, Apport);
   CheckApport(AcMthL.Origin1, AcMthL.AcCut, AcMthL.ACPrp, AcMthL.Apport, Apport.CirKind);
  END;
  CheckAcCut(AcMthL.Origin2, AcMthL.AcCut2, AcMthL.ACPrp2);
  IF ~!AcMthL.Apport2 THEN
   CONFORM(AcMthL, Apport2);
   L_General.Assert(!AcMthL.Apport | (Apport.CirType # Apport2.CirType), "ᯮ樨   묨");
   CheckApport(AcMthL.Origin2, AcMthL.AcCut2, AcMthL.ACPrp2, AcMthL.Apport2, Apport2.CirKind);
  END;

  CONFORM(AcMthL, AcMthH);
  SELECT(AcMthA, AcMth, , AcMthL.AcMth);
  WHILE OCCURE(AcMthA) DO
   IF L_DatTim.IsActiveInIntvl(AcMthA.Begin, AcMthA.Till, AcMthH.Date, AcMthH.Till) THEN
    CheckAcMthLnA(AcMthL.Origin1, AcMthL.ACPrp,  AcMthA.MathType);
    CheckAcMthLnA(AcMthL.Origin2, AcMthL.ACPrp2, AcMthA.MathType);
   END;
   NEXT(AcMthA);
  END; (* WHILE OCCURE(AcMthA) ... *)
 END {AcMthL_OnAfterEditInsert};

 PRIVATE PROCEDURE AcMthL_OnAfterInsert();
 BEGIN
  AcMthL_OnAfterEditInsert();
 END {AcMthL_OnAfterInsert};

 PRIVATE PROCEDURE AcMthL_OnAfterEdit();
 BEGIN
  AcMthL_OnAfterEditInsert();
 END {AcMthL_OnAfterEdit};

 PRIVATE PROCEDURE AcMth_OnBeforeEdit();
 BEGIN
  SETEMPTY(CheckedAcMth, CheckedPer);
 END {AcMth_OnBeforeEdit};

 PRIVATE PROCEDURE AcMth_OnBeforeInsert();
  VAR
   srcAcMth: LIKE(AcMth.AcMth);
 BEGIN
  srcAcMth:=L_WDO.GetInsertionSource();
  IF ~!srcAcMth THEN
   intMakeCopy(srcAcMth);
  END;
  SETEMPTY(CheckedAcMth, CheckedPer);
 END {AcMth_OnBeforeInsert};

 PRIVATE PROCEDURE AcMth_OnBeforeDelete();
 BEGIN
  SETEMPTY(CheckedAcMth, CheckedPer);
  CheckDocumentsIsUndone(AcMth.Begin, 0);
 END {AcMth_OnBeforeDelete};

 PRIVATE PROCEDURE IsPDocAcMth(): SCAL[2];
 BEGIN
  RETURN SELECT(PDocKind, DGroup, AcMth.DGroup);
 END {IsPDocAcMth};

 PRIVATE PROCEDURE AcMth_OnAfterEdIns();
 BEGIN
  L_General.Assert(AcMth.Dest # L_Dest.PDocwMDocDest(), " 樨 "+L_Dest.PDocwMDocDest()+" ਬ ⮫쪮    뫪  |   奬 権  ⠪ ");
  SupportBeginTill();

  IF SELECT(AcMthA, AcMth, AcMth.AcMth) THEN
   L_General.Assert(~IsPDocAcMth(), "奬 権     ᮤঠ 'ਬ'");
   WHILE OCCURE(AcMthA) DO
    AcMthA.DGroup:=AcMth.DGroup;
    AcMthA.Dest  :=AcMth.Dest;
    IF ~!AcMth.Till & !AcMthA.Till THEN
     AcMthA.Till:=AcMth.Till;
    END;
    REPLACE(AcMthA);
    NEXT(AcMthA);
   END; (* WHILE OCCURE(AcMthA) ... *)
  END; (*  IF SELECT(AcMthA ... *)
  L_DBD.CheckValidity("AcMth");
  L_AcMth.CheckDupCurAcMth(AcMth.DGroup, AcMth.Dest);
 END {AcMth_OnAfterEdIns};

 PRIVATE PROCEDURE AcMth_OnAfterInsert();
 BEGIN
  AcMth_OnAfterEdIns();
 END {AcMth_OnAfterInsert};

 PRIVATE PROCEDURE AcMth_OnAfterEdit();
 BEGIN
  AcMth_OnAfterEdIns();
 END {AcMth_OnAfterEdit};

 PRIVATE PROCEDURE AcMth_DGroup_OnSuccessfulChange();
 BEGIN
  AcMth.DGroup:=GE_PVALUE(AcMth.DGroup); (* REPLACE, ⮫쪮  CheckDocumentsIsUndone*)
  CheckDocumentsIsUndone(AcMth.Begin, 0);
 END {AcMth_DGroup_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckAcMthForDestNecessary(trgNotion: L_kn.tNotion);
 BEGIN
  IF L_kn.Is(SYSDATE(), trgNotion) THEN
   L_kn.StandOnERKN(trgNotion);
   L_General.Error("ଫ 奬 権   権" +
                   '| 祭 "' + ERKN.Name + '"' + "  ॡ");
  END;
 END {CheckAcMthForDestNecessary};

 PRIVATE PROCEDURE AcMth_Dest_OnSuccessfulChange();
 BEGIN
  CONFORM(AcMth, Dest);
  CheckAcMthForDestNecessary(L_Dest.erkn_Salary);
  CheckAcMthForDestNecessary(L_Dest.erkn_PDocwMDoc);

  AcMth.Dest:=GE_PVALUE(AcMth.Dest); (* REPLACE, ⮫쪮  CheckDocumentsIsUndone*)
  CheckDocumentsIsUndone(AcMth.Begin, 0);
 END {AcMth_Dest_OnSuccessfulChange};

 PRIVATE PROCEDURE AcMth_Till_OnSuccessfulChange();
 BEGIN
  CheckDocumentsIsUndone(AcMth.Till, 0);
 END {AcMth_Till_OnSuccessfulChange};

 PRIVATE PROCEDURE Dest_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "DestE");
  L_WDO.iProgs       (1, "AcMth");
 END {Dest_OnInitializeWindow};

 PRIVATE PROCEDURE DestE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents    (0, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeInsert]);
  L_WDO.iMayBeEmpty(0, ["Dest.Till"]);
  L_WDO.iField     (0, "Dest.Type").Format:=L_Acnt.dt_Pool;
  L_WDO.iProgs     (0, "AcMth");
 END {DestE_OnInitializeWindow};

 PRIVATE PROCEDURE Dest_OnAfterEdIns();
 BEGIN
  L_DBD.CheckValidity("Dest");
 END {Dest_OnAfterEdIns};

 PRIVATE PROCEDURE Dest_OnAfterEdit();
 BEGIN
  Dest_OnAfterEdIns();
 END {Dest_OnAfterEdit};

 PRIVATE PROCEDURE Dest_OnAfterInsert();
 BEGIN
  Dest_OnAfterEdIns();
 END {Dest_OnAfterInsert};

 PRIVATE PROCEDURE Dest_OnBeforeInsert();
 BEGIN
 END {Dest_OnBeforeInsert};

 PRIVATE PROCEDURE Dest_OnBeforeDelete();
 BEGIN
  L_DBD.CheckUsers(RTI.Get().CurZone.MasterTable.Name);
  L_r2r.Owner_OnBeforeDelete("Dest");
 END {Dest_OnBeforeDelete};

 PRIVATE PROCEDURE AcMthE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (0, ["AcMth.Till", "AcMth.Dest", "AcMth.DGroup"]);
  L_WDO.iUnmodifiable(0, ["AcMth.Begin", "AcMth.AcMth"]);
  L_WDO.iMayBeEmpty  (0, ["AcMth.Till", "AcMth.Comment"]);
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterMdf]);
  L_WDO.iMayBeEmpty  (1, ["AcMthH.Comment"]);
  L_WDO.iProgs       (1, "AcMth");
  L_WDO.iSubwindow   (2, "AcMthEE");
  L_WDO.iField       (2, "AcMthL.CirSrc" ).Format:=L_Acnt.cs_Pool_SH;
  L_WDO.iField       (2, "AcMthL.Origin1").Format:=L_Acnt.amo_Pool_SH;
  L_WDO.iField       (2, "AcMthL.Origin2").Format:=L_Acnt.amo_Pool_SH;
  L_WDO.iField       (2, "AcMthL.ACPrp"  ).Format:=L_Acnt.acp_Pool_SH;
  L_WDO.iField       (2, "AcMthL.ACPrp2" ).Format:=L_Acnt.acp_Pool_SH;
  L_WDO.iField       (2, "AcMthL.aNetto" ).Format:=L_Acnt.cccm_Pool_SH;
  L_WDO.iField       (2, "AcMthL.aVAT"   ).Format:=L_Acnt.cccm_Pool_SH;
  L_WDO.iField       (2, "AcMthL.aAmount").Format:=L_Acnt.cccm_Pool_SH;
  L_WDO.iField       (2, "AcMthL.cVAT"   ).Format:=L_Acnt.cvat_Pool_SH;
  L_WDO.iEvents      (3, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (3, ["AcMthA.Till", "AcMthA.Begin", "AcMthA.MMode", "AcMthA.MathType"]);
  L_WDO.iMayBeEmpty  (3, ["AcMthA.Till"]);
  L_WDO.iProgs       (3, "AcMth");
 END {AcMthE_OnInitializeWindow};

 PRIVATE PROCEDURE AcMthEE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (0, ["AcMthL.ACPrp2", "AcMthL.ACPrp"]);
  L_WDO.iMayBeEmpty  (0, ["AcMthL.Apport2", "AcMthL.AcCut2", "AcMthL.Origin2", "AcMthL.Apport", "AcMthL.AcCut", "AcMthL.Origin1", "AcMthL.RulePar", "AcMthL.Rule"]);
  L_WDO.iField       (0, "AcMthL.CirSrc"  ).Format:=L_Acnt.cs_Pool;
  L_WDO.iField       (0, "AcMthL.Origin1" ).Format:=L_Acnt.amo_Pool;
  L_WDO.iField       (0, "AcMthL.Origin2" ).Format:=L_Acnt.amo_Pool;
  L_WDO.iField       (0, "AcMthL.ACPrp"   ).Format:=L_Acnt.acp_Pool;
  L_WDO.iField       (0, "AcMthL.ACPrp2"  ).Format:=L_Acnt.acp_Pool;
  L_WDO.iField       (0, "AcMthL.aNetto"  ).Format:=L_Acnt.cccm_Pool;
  L_WDO.iField       (0, "AcMthL.aVAT"    ).Format:=L_Acnt.cccm_Pool;
  L_WDO.iField       (0, "AcMthL.aAmount" ).Format:=L_Acnt.cccm_Pool;
  L_WDO.iField       (0, "AcMthL.cVAT"    ).Format:=L_Acnt.cvat_Pool;
  L_WDO.iField       (0, "Apport.CirType" ).Format:=L_Acnt.ct_Pool;
  L_WDO.iField       (0, "Apport2.CirType").Format:=L_Acnt.ct_Pool;
  L_WDO.iProgs       (0, "AcMth");
 END {AcMthEE_OnInitializeWindow};

 PUBLIC PROCEDURE InitiateByShowList();
 BEGIN
  L_XDR.sl_Show();
  SEARCH(AcMth, AcMth, , L_XDR.pvs_AcMth);
  L_WDO.PosToCurRecord("AcMth", "", 0);
 END {InitiateByShowList};

 PUBLIC PROCEDURE MergeCurrentDest();
  VAR
   dstDest: LIKE(Dest.Dest);
 BEGIN
  L_General.AdminOnly();
  L_General.Assert(ACCESS(Dest), " ⠭  樨");
  SETEMPTY(dstDest);
  STDFORM(L_StdFrm.sf_Choice("! । ꥤ  権|" +
                             "४ ᮧ १ࢭ   | |" +
                             "|   樨 " + Dest.Dest + " '" + Dest.Name + "'" +
                             "| ७ᥭ, ᫥ 祣   樨 㤥 㤠." +
                             "|| 樨,   室 ꥤ : %###%",
                             "%I"),
          " ꥤ  権 ",
          CHOICE,
          -1,
          dstDest);
  L_Dest.MergeDest(Dest.Dest, dstDest, 0);
  SE_WZD_POSITION(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number, Dest);
 END {MergeCurrentDest};

 PRIVATE PROCEDURE AcMthH_OnAfterEdit();
 BEGIN
  CheckDocumentsIsUndone(Math.Min(AcMthH.Date, GE_PVALUE(AcMthH.Date)), 0);
 END {AcMthH_OnAfterEdit};

 PRIVATE PROCEDURE AcMthH_OnAfterInsert();
 BEGIN
  CheckDocumentsIsUndone(AcMthH.Date, 0);
 END {AcMthH_OnAfterInsert};

 PRIVATE PROCEDURE AcMthH_OnBeforeDelete();
 BEGIN
  CheckDocumentsIsUndone(AcMthH.Date, 0);
 END {AcMthH_OnBeforeDelete};

 PRIVATE PROCEDURE ACSet_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurWindow.Zones(1).Fields("ACSet.Kind"  ).Format:=L_Acnt.acsk_Pool;
  RTI.Get().CurWindow.Zones(2).Fields("ACSetL.ACPrp").Format:=L_Acnt.acp_Pool;
 END {ACSet_1_OnZoneOpen};

 PRIVATE PROCEDURE CheckSingleACSetL();
 BEGIN
  L_General.Assert(AllowedACSetLACPrpForACSetKind(ACSet.Kind, ACSetL.ACPrp),
                   "⨬ ਬ 뫪  ࠧ१  祭 '" +
                   L_Str.PoolItem(L_Acnt.acp_Pool, ACSetL.ACPrp) + "'|  ࠧ१  '" +
                   L_Str.PoolItem(L_Acnt.acsk_Pool, ACSet.Kind) + "'");
 END {CheckSingleACSetL};

 PRIVATE PROCEDURE ACSet_OnAfterEdIns();
 BEGIN
  SELECT(ACSetL, ACSet, , ACSet.ACSet);
  WHILE OCCURE(ACSetL) DO
   CheckSingleACSetL();
   NEXT(ACSetL);
  END; (* WHILE OCCURE(ACSetL) ... *)
 END {ACSet_OnAfterEdIns};

 PRIVATE PROCEDURE ACSet_OnAfterEdit();
 BEGIN
  ACSet_OnAfterEdIns();
 END {ACSet_OnAfterEdit};

 PRIVATE PROCEDURE ACSet_OnAfterInsert();
 BEGIN
  ACSet_OnAfterEdIns();
 END {ACSet_OnAfterInsert};

 PRIVATE PROCEDURE AllowedACSetLACPrpForACSetKind(_Kind: LIKE(ACSet.Kind); trgACPrp: LIKE(ACSetL.ACPrp)): SCAL[2];
 BEGIN
  IF    _Kind = L_Acnt.acsk_Math THEN
   RETURN (trgACPrp = L_Acnt.acp_Math_Netto)       |
          (trgACPrp = L_Acnt.acp_Math_VAT)         |
          (trgACPrp = L_Acnt.acp_MathSale_Netto)   |
          (trgACPrp = L_Acnt.acp_MathSale_VAT)     |
          (trgACPrp = L_Acnt.acp_MathInAdvHld)     |
          (trgACPrp = L_Acnt.acp_MathInKeeping)    |
          (trgACPrp = L_Acnt.acp_MathOffSite);
  ELSIF _Kind = L_Acnt.acsk_CostItem THEN
   RETURN (trgACPrp = L_Acnt.acp_CostItem_Default) |
          (trgACPrp = L_Acnt.acp_RecExpSaldo)      |
          (trgACPrp = L_Acnt.acp_CostItemSale)     |
          (trgACPrp = L_Acnt.acp_MathSale_Netto)   |
          (trgACPrp = L_Acnt.acp_CostItemDfrls)    |
          (trgACPrp = L_Acnt.acp_CostPrice);
  ELSIF _Kind = L_Acnt.acsk_Contract THEN
   RETURN trgACPrp = L_Acnt.acp_Contract_Netto;
  ELSE
   L_General.CallUs(0);
  END;
 END {AllowedACSetLACPrpForACSetKind};

 PRIVATE PROCEDURE ACSetL_OnBeforeModification();
 BEGIN
  CONFORM(ACSetL, ACSet);
  IF    ACSet.Kind = L_Acnt.acsk_CostItem THEN
   SELECT(CostItem, ACSet, , ACSet.ACSet);
   WHILE OCCURE(CostItem) DO
    PROMPT("஢ઠ  " + CostItem.CostItem);
    IF CostItem.Leaf = 1 THEN
     L_XObj.CheckXCalcIsZero(CostItem.XObject);
    END;
    NEXT(CostItem);
   END; (* WHILE OCCURE(CostItem) ... *)
  ELSIF ACSet.Kind = L_Acnt.acsk_Contract THEN
   SELECT(Contract, ACSet, , ACSet.ACSet);
   WHILE OCCURE(Contract) DO
    PROMPT("஢ઠ  " + Contract.Contract);
    IF Contract.Leaf = 1 THEN
     L_XObj.CheckXCalcIsZero(Contract.XObject);
    END;
    NEXT(Contract);
   END; (* WHILE OCCURE(Contract) ... *)
  END;
 END {ACSetL_OnBeforeModification};

 PRIVATE PROCEDURE ACSetL_OnBeforeEdit();
 BEGIN
  ACSetL_OnBeforeModification();
 END {ACSetL_OnBeforeEdit};

 PRIVATE PROCEDURE ACSetL_OnBeforeDelete();
 BEGIN
  ACSetL_OnBeforeModification();
 END {ACSetL_OnBeforeDelete};

 PRIVATE PROCEDURE ACSetL_OnAfterEdIns();
 BEGIN
  ACCESS(ACSet);
  CheckSingleACSetL();
  CONFORM(ACSetL, AcCut);
  CheckAcCutwAmount((ACSetL.ACPrp = L_Acnt.acp_Math_Netto) |
                    (ACSetL.ACPrp = L_Acnt.acp_MathInAdvHld) |
                    (ACSetL.ACPrp = L_Acnt.acp_MathInKeeping) |
                    (ACSetL.ACPrp = L_Acnt.acp_MathOffSite),
                    " 祭 '"+L_Str.PoolItem(L_Acnt.acp_Pool, ACSetL.ACPrp)+"'");
 END {ACSetL_OnAfterEdIns};

 PRIVATE PROCEDURE ACSetL_OnAfterInsert();
 BEGIN
  ACSetL_OnAfterEdIns();
 END {ACSetL_OnAfterInsert};

 PRIVATE PROCEDURE ACSetL_OnAfterEdit();
 BEGIN
  ACSetL_OnAfterEdIns();
 END {ACSetL_OnAfterEdit};

 PRIVATE PROCEDURE MTMM_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurWindow.Zones(2).Fields("ACSetL.ACPrp").Format:=L_Acnt.acp_Pool;
 END {MTMM_1_OnZoneOpen};

 PRIVATE PROCEDURE AcMthA_OnBeforeInsert();
 BEGIN
 END {AcMthA_OnBeforeInsert};

 PRIVATE PROCEDURE AcMthA_OnBeforeEdit();
 BEGIN
 END {AcMthA_OnBeforeEdit};

 PRIVATE PROCEDURE AcMthA_OnBeforeDelete();
 BEGIN
  CheckDocumentsIsUndone(AcMthA.Begin, 0);
 END {AcMthA_OnBeforeDelete};

 PRIVATE PROCEDURE AcMthA_OnAfterEdIns();
 BEGIN
  CONFORM(AcMthA, AcMth);
  AcMthA.DGroup:=AcMth.DGroup;
  AcMthA.Dest  :=AcMth.Dest;
  REPLACE(AcMthA);
  L_AcMth.CheckDupCurAcMthA(AcMthA.DGroup, AcMthA.Dest, AcMthA.MathType, AcMthA.MMode);
  CheckAcMthA();
 END {AcMthA_OnAfterEdIns};

 PRIVATE PROCEDURE AcMthA_OnAfterInsert();
 BEGIN
  AcMthA_OnAfterEdIns();
 END {AcMthA_OnAfterInsert};

 PRIVATE PROCEDURE AcMthA_OnAfterEdit();
 BEGIN
  AcMthA_OnAfterEdIns();
 END {AcMthA_OnAfterEdit};

 PRIVATE PROCEDURE AcMthA_MathType_OnSuccessfulChange();
 BEGIN
  AcMthA.MathType:=GE_PVALUE(AcMthA.MathType); (* REPLACE, ⮫쪮  CheckDocumentsIsUndone*)
  CheckDocumentsIsUndone(AcMthA.Begin, 0);
 END {AcMthA_MathType_OnSuccessfulChange};

 PRIVATE PROCEDURE AcMthA_MMode_OnSuccessfulChange();
 BEGIN
  AcMthA.MMode:=GE_PVALUE(AcMthA.MMode); (* REPLACE, ⮫쪮  CheckDocumentsIsUndone*)
  CheckDocumentsIsUndone(AcMthA.Begin, 0);
 END {AcMthA_MMode_OnSuccessfulChange};

 PRIVATE PROCEDURE AcMthA_Begin_OnSuccessfulChange();
 BEGIN
  IF AcMthA.Begin > GE_PVALUE(AcMthA.Begin) THEN
   intCheckDocumentsIsUndone(GE_PVALUE(AcMthA.Begin), AcMthA.Begin, 0);
  END;
 END {AcMthA_Begin_OnSuccessfulChange};

 PRIVATE PROCEDURE AcMthA_Till_OnSuccessfulChange();
 BEGIN
  CheckDocumentsIsUndone(AcMthA.Till, 0);
 END {AcMthA_Till_OnSuccessfulChange};

 PRIVATE PROCEDURE MTMM_OnBeforeAnyModification();
 BEGIN
  L_General.SilentAdminOnly();
 END {MTMM_OnBeforeAnyModification};

 PRIVATE PROCEDURE MTMM_OnBeforeInsert();
 BEGIN
  MTMM_OnBeforeAnyModification();
 END {MTMM_OnBeforeInsert};

 PRIVATE PROCEDURE MTMM_OnBeforeEdit();
 BEGIN
  MTMM_OnBeforeAnyModification();
 END {MTMM_OnBeforeEdit};

 PRIVATE PROCEDURE MTMM_OnBeforeDelete();
 BEGIN
  MTMM_OnBeforeAnyModification();
 END {MTMM_OnBeforeDelete};

 PRIVATE PROCEDURE MTMM_OnAfterEdIns();
  VAR
   _MTMM  : LIKE(MTMM.MTMM);
   _Begin,
   _Till  : DATE;
 BEGIN
  SAVE(MTMM);
  CHANGESEL(MTMM, MathType, , MTMM.MathType, MTMM.MMode);
  FIRST(MTMM);
  WHILE OCCURE(MTMM) DO
   SAVE(MTMM);
   _MTMM :=MTMM.MTMM;
   _Begin:=MTMM.Begin;
   _Till :=MTMM.Till;
   NEXT(MTMM);
   WHILE OCCURE(MTMM) DO
    L_General.Assert(~L_DatTim.IsActiveInIntvl(_Begin, _Till, MTMM.Begin, MTMM.Till),
                     "᪮쪮  奬 ६.|| 奬 " + _MTMM + "  " + MTMM.MTMM);
    NEXT(MTMM);
   END;
   RESTORE(MTMM);
   NEXT(MTMM);
  END;
  RESTORE(MTMM);
 END {MTMM_OnAfterEdIns};

 PRIVATE PROCEDURE MTMM_OnAfterInsert();
 BEGIN
  MTMM_OnAfterEdIns();
 END {MTMM_OnAfterInsert};

 PRIVATE PROCEDURE MTMM_OnAfterEdit();
 BEGIN
  MTMM_OnAfterEdIns();
 END {MTMM_OnAfterEdit};

 PRIVATE PROCEDURE MTMM_ACSet_OnAskPhase1();
 BEGIN
  IF SELECT(ACSet, Kind, L_Acnt.acsk_Math) THEN
   SE_WZD_CURSOR(RTI.Get().TrgWindow.Name, 1, ACSet);
   IF ~!MTMM.ACSet THEN
    SEARCH(ACSet, KindACS, , L_Acnt.acsk_Math, MTMM.ACSet);
    SE_WZD_POSITION(RTI.Get().TrgWindow.Name, RTI.Get().TrgZone.Number, ACSet);
   END;
  ELSE
   L_StdFrm.Inform("祣 室饣!");
  END;
 END {MTMM_ACSet_OnAskPhase1};

 PRIVATE PROCEDURE MTMM_ACSet_OnAskPhase2();
 BEGIN
  IF ACCESS(ACSet) THEN
   MTMM.ACSet:=ACSet.ACSet;
   REPLACE(MTMM);
  END;
 END {MTMM_ACSet_OnAskPhase2};

 PRIVATE PROCEDURE MTMM_ACSet_OnSuccessfulChange();
 BEGIN
  IF ~!MTMM.ACSet THEN
   CONFORM(MTMM, ACSet);
   L_General.Assert(ACSet.Kind = L_Acnt.acsk_Math, " 奬     㪠|" +
                                                   "  ࠧ१ ⮫쪮  '" + L_Str.PoolItem(L_Acnt.acsk_Pool, L_Acnt.acsk_Math) + "'");
  END;
 END {MTMM_ACSet_OnSuccessfulChange};

 PRIVATE PROCEDURE MTMM_ACSet_OnAskForViewPhase1();
 BEGIN
 END {MTMM_ACSet_OnAskForViewPhase1};

 PRIVATE PROCEDURE MTMM_ACSet_OnAskForViewPhase2();
 BEGIN
  IF ACCESS(ACSet) THEN
   SETSEL(MTMM, ACSet);
   IF SRCINSEL(MTMM, GE, ACSet.ACSet) THEN
    SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), MTMM);
   END;
  END;
 END {MTMM_ACSet_OnAskForViewPhase2};

 PRIVATE PROCEDURE DH_MakeTop();
 BEGIN
  FIO.WrStr(R, "{{P_AcMthL");
  FIO.WrLn(R);
  FIO.WrStr(R, "| name=");
  FIO.WrLn(R);
 END {DH_MakeTop};

 PRIVATE PROCEDURE DH_MakeLine(S: STRING[]);
 BEGIN
  FIO.WrStr(R, "| "+S);
  FIO.WrLn(R);
 END {DH_MakeLine};

 PRIVATE PROCEDURE DH_MakeBot();
 BEGIN
  FIO.WrStr(R, "}}");
  FIO.WrLn(R);
 END {DH_MakeBot};

 PRIVATE PROCEDURE DH_MakeSide(Dbt: SCAL[2]; trgOrigin: LIKE(AcMthL.Origin1);
                                     trgAcCut: LIKE(AcMthL.AcCut);
                                     trgACPrp: LIKE(AcMthL.ACPrp);
                                     trgApport: LIKE(AcMthL.Apport));
  VAR
   Prfx: STRING[];
 BEGIN
  IF Dbt THEN
   Prfx:="dbt";
  ELSE
   Prfx:="crd";
  END;
  IF ~!trgOrigin THEN
   DH_MakeLine(Prfx+"Object="+L_Str.PoolItem(L_Acnt.amo_Pool_ConstName, trgOrigin));
  END;
  IF ~!trgApport THEN
   SEARCH(Apport, Apport, , trgApport);
   DH_MakeLine(Prfx+"Apport="+L_Str.PoolItem(L_Acnt.ck_Pool_ConstName, Apport.CirKind)+" "+trgApport+" '"+Apport.Name+"'");
  END;
  IF ~!trgACPrp THEN
   DH_MakeLine(Prfx+"ACPrp="+L_Str.PoolItem(L_Acnt.acp_Pool_ConstName, trgACPrp));
  END;
  IF ~!trgAcCut THEN
   L_AcCut.PositionOnAcCut(trgAcCut);
   IF ~!AcCut.ERKN THEN
    CONFORM(AcCut, ERKN);
    DH_MakeLine(Prfx+"AcCut="+trgAcCut+" ERKN "+ERKN.Name);
   ELSE
    DH_MakeLine(Prfx+"AcCut="+trgAcCut+" "+AcCut.Name);
   END;
  END;
 END {DH_MakeSide};

 PRIVATE PROCEDURE DH_MakeOneAcMthL();
  VAR
   FDb: SCAL[2];
 BEGIN
  DH_MakeTop();

  IF ~!AcMthL.Rule THEN
   DH_MakeLine("Rule='"+AcMthL.Rule+"'");
  END;
  IF ~!AcMthL.RulePar THEN
   DH_MakeLine("RulePar='"+AcMthL.RulePar+"'");
  END;
 
  DH_MakeLine("CirSrc="+L_Str.PoolItem(L_Acnt.cs_Pool_ConstName, AcMthL.CirSrc));
  DH_MakeLine("cVAT="+L_Str.PoolItem(L_Acnt.cvat_Pool_ConstName, AcMthL.cVAT));
  IF AcMthL.aNetto # L_Acnt.cccm_Not THEN
   DH_MakeLine("aNetto="+L_Str.PoolItem(L_Acnt.cccm_Pool, AcMthL.aNetto));
  END;
  IF AcMthL.aVAT # L_Acnt.cccm_Not THEN
   DH_MakeLine("aVAT="+L_Str.PoolItem(L_Acnt.cccm_Pool, AcMthL.aVAT));
  END;
  IF AcMthL.aAmount # L_Acnt.cccm_Not THEN
   DH_MakeLine("aAmount="+L_Str.PoolItem(L_Acnt.cccm_Pool, AcMthL.aAmount));
  END;
 
  IF ~!AcMthL.Apport THEN
   CONFORM(AcMthL, Apport);
   IF Apport.CirType = L_Acnt.ct_Debit THEN
    FDb:=1;
   ELSE
    FDb:=0;
   END;
  ELSE
   CONFORM(AcMthL, Apport2);
   IF Apport2.CirType = L_Acnt.ct_Debit THEN
    FDb:=0;
   ELSE
    FDb:=1;
   END;
  END;
  IF FDb THEN
   DH_MakeSide(1, AcMthL.Origin1, AcMthL.AcCut, AcMthL.ACPrp, AcMthL.Apport);
   DH_MakeSide(0, AcMthL.Origin2, AcMthL.AcCut2, AcMthL.ACPrp2, AcMthL.Apport2);
  ELSE
   DH_MakeSide(1, AcMthL.Origin2, AcMthL.AcCut2, AcMthL.ACPrp2, AcMthL.Apport2);
   DH_MakeSide(0, AcMthL.Origin1, AcMthL.AcCut, AcMthL.ACPrp, AcMthL.Apport);
  END;
 
  DH_MakeBot();
 END {DH_MakeOneAcMthL};

 PUBLIC PROCEDURE MakeDocHelp();
  VAR
   Single: SCAL[2];
 BEGIN
  IF ACCESS(AcMthL) THEN
   Single:=1;
  ELSE
   L_General.Assert(ACCESS(AcMthH), " ࠭  䨪  ப 奬 権");
   Single:=0;
  END;
  OPENREP(R, L_General.NameConnection("tHlpA"), Create);
  IF Single THEN
   DH_MakeOneAcMthL();
  ELSE
   CONFORM(AcMthH, AcMthL);
   WHILE OCCURE(AcMthL) DO
    DH_MakeOneAcMthL();
    NEXT(AcMthL);
   END; (* WHILE OCCURE(AcMthL) ... *)
  END;
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MakeDocHelp};

 PUBLIC PROCEDURE MergeACSet(srcACSet, dstACSet: LIKE(ACSet.ACSet); Silent: SCAL[2]);
  VAR
   ErrMsg  : STRING[];
   DstName : LIKE(ACSet.Name);
   DstKind : LIKE(ACSet.Kind);
   SrcAcCut,
   DstAcCut: LIKE(AcCut.AcCut);
   HasSameACSetL: SCAL[2];
 BEGIN
  APP.Get().NewPrompt("  ࠧ१ " + srcACSet + "  " + dstACSet);
  L_General.SilentPrgsOnly();
  ErrMsg:="訡  ꥤ ஢ ࠧ१ "+srcACSet+"  "+dstACSet+"| |";
  SEARCH(ACSet, ACSet, , dstACSet);
  DstName:=ACSet.Name;
  DstKind:=ACSet.Kind;
  SEARCH(ACSet, ACSet, , srcACSet);
  L_r2r.Owner_OnBeforeDelete("ACSet");

  IF ~Silent THEN
   L_StdFrm.Question(" ᯮ짮  ࠧ१" +
                     "| |" +
                     ACSet.ACSet + " " + Str.Align(ACSet.Name, Str.MaxLength(ACSet.Name), LEFT) +
                     "|" +
                     "" +
                     "|" +
                     dstACSet + " " + Str.Align(DstName, Str.MaxLength(ACSet.Name), LEFT));
  END;
  L_General.Assert(DstKind = ACSet.Kind, ErrMsg+" ᮢ ");

  SELECT(ACSetL, ACSet, , srcACSet);
  WHILE OCCURE(ACSetL) DO
   HasSameACSetL:=0;
   SAVE(ACSetL);
   SrcAcCut:=ACSetL.AcCut;
   IF SEARCH(ACSetL, ACSet, dstACSet, ACSetL.ACPrp) THEN
    HasSameACSetL:=1;
    L_General.Assert(SrcAcCut=ACSetL.AcCut, " ࠧ१  祭 '"+L_Str.PoolItem(L_Acnt.acp_Pool, ACSetL.ACPrp)+"'");
   END;
   RESTORE(ACSetL);
   IF HasSameACSetL THEN
    REMOVE(ACSetL);
   ELSE
    NEXT(ACSetL);
   END;
  END; (* WHILE OCCURE(ACSetL) ... *)

  TRY [INTEGRITY(INTEGRITY_OFF)]
   SEARCH(ACSet, ACSet, , srcACSet);
   REMOVE(ACSet);
   SEARCH(ACSet, ACSet, , dstACSet);
   ACSet.ACSet:=srcACSet;
   REPLACE(ACSet);
  EXCEPT
  END;

  TRY [INTEGRITY(INTEGRITY_ON)]
   ACSet.ACSet:=dstACSet;
   REPLACE(ACSet);
  EXCEPT
  END;
 END {MergeACSet};

 PUBLIC PROCEDURE MergeCurrentACSet();
  VAR
   srcACSet,
   dstACSet: LIKE(ACSet.ACSet);
 BEGIN
  SETEMPTY(srcACSet, dstACSet);
  L_General.Assert(ACCESS(ACSet), " ⠭ ⥪騩  ࠧ१");
  srcACSet:=ACSet.ACSet;
  STDFORM(L_StdFrm.sf_Choice("|   "+ACSet.ACSet+"  ७ᥭ,"+
                             "|᫥ 祣   㤥 㤠."+
                             "||,  ⢨  ⨬!"+
                             "||  ஬ ꥤ ?|| %####% ",
                             "%I"),
          " ﭨ ஢ ࠧ१ ",
          CHOICE,
          -1,
          dstACSet);
  MergeACSet(srcACSet, dstACSet, 0);
  L_WDO.PosToCurRecord("ACSet", "", 0);
 END {MergeCurrentACSet};

 PUBLIC PROCEDURE MakeCopy();
 BEGIN
  ACCESS(AcMth);
  L_WDO.LaunchInsertBySource(AcMth.AcMth, "");
 END {MakeCopy};

BEGIN
 L_Events.ExecuteHandler();
END.
