(*
%Copyright   (c) Polak IT
%Author      05.02.2008 12:11:29 POLAK\kns
%Purpose
%Type        control,operation,
%Specific    SYS
%Modified    12.03.2013 11:32:45 POLAK\GAV
%Environment
*)

 MODULE ACSEvent [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_WDO, L_Events, L_Str, L_DatTim, L_ACS, L_AcsPnt, P_OwnData, Math, L_bp;

 PUBLIC PROCEDURE FillACSEvent();
 BEGIN
  L_ACS.Fill_ACSEvent(Memo.ud_fr(), Memo.ud_ut(), "");
 END {FillACSEvent};

 PUBLIC PROCEDURE RemoveACSEvent();
  VAR
   From,
   UpTo : DATE;
 BEGIN
  From:=Memo.ud_fr();
  UpTo:=Memo.ud_ut();
  L_General.SilentAdminOnly();
  SELECT(ACSEvent, Date);
  SRCINSEL(ACSEvent, GE, , From);
  WHILE OCCURE(ACSEvent) & (ACSEvent.Date <= UpTo) DO
   PROMPT(L_Str.IntStr(ACSEvent.Man) + ", " + L_DatTim.DTStampStr(ACSEvent.DTS));
   REMOVE(ACSEvent);
  END; (* WHILE OCCURE(ACSEvent) ... *)
  L_ACS.Correct_sesfLastLoadUnloaded(From, UpTo, 0);
 END {RemoveACSEvent};

 PRIVATE PROCEDURE ACSEvent_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ACSEvent";
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iZone(1).Fields("ACSEvent.Event").Format  :=L_ACS.EventTypPool;
  L_WDO.iZone(1).Fields("ACSEvent.Outpost").Format:=L_ACS.OutpostPool();
 END {ACSEvent_OnInitializeWindow};

 PRIVATE PROCEDURE ACSEMan_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ACSEMan";
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iZone        (1).Narrowing:="ACSEvent.Man=Man.Man";
  L_WDO.iZone(1).Fields("ACSEvent.Event").Format  :=L_ACS.EventTypPool;
  L_WDO.iZone(1).Fields("ACSEvent.Outpost").Format:=L_ACS.OutpostPool();
 END {ACSEMan_OnInitializeWindow};

 PUBLIC PROCEDURE ManLoad(byPer: SCAL[2]);
  VAR
   From, UpTo: DATE;
 BEGIN
  IF ~ACCESS(Man) THEN
   L_General.Assert(ACCESS(Staff), " ࠭  ,  ࠡ⭨!");
   CONFORM(Staff, Man);
  END;
  IF byPer THEN
   From:=Memo.ud_fr();
   UpTo:=Memo.ud_ut();
  ELSE
   UpTo:=SYSDATE();
   IF SELECT(ACSEvent, ManDTS, Man.Man) THEN
    LAST(ACSEvent);
    From:=ACSEvent.Date;
   ELSE
    From:=UpTo - 90;
   END;
  END;
  From:=Math.Max(From, P_OwnData.GetACSAccountDate(SYSDATE()));
  L_ACS.Fill_ACSEvent(From, UpTo, Man.Man);
 END {ManLoad};

 PUBLIC PROCEDURE ACSEr();
  CONST
   bpId = "ACSEr";
 BEGIN
  L_bp.extBegin(bpId, "㧪 㦥 室 ",
                L_bp.t_Prc_wRp, L_General.tc_Entire, L_bp.pt_StrictlyInTime);
  L_AcsPnt.PassAccessPoint(0000009);
  L_ACS.LoadUnloaded();
  L_bp.End();
 END {ACSEr};

BEGIN
 L_Events.ExecuteHandler();
END.
