(*
%Copyright   (c) Polak IT
%Author      02.10.2008 10:59:38 POLAK\San
%Purpose     ஫  ࢨ ⭮襭 AcsObj
%Type        control
%Specific    SYS
%Modified    05.02.2014 17:00:06 POLAK\LDA
%Environment
*)

 MODULE AcsObj [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, L_AR, L_APAR, Str, DBD, L_PCS, L_Str,
        L_AcsPnt, FIO, L_StdFrm, L_OwnData, L_AFM, L_WDO, Math,
        L_DatTim, L_Guard;

 PUBLIC PROCEDURE AcsObj_OnAfterNoninteractiveEdit();
 BEGIN
  L_AR.AccessAcsObj2(AcsObj.AcsObj);
  L_AR.CopyRecordToAcsObj2(0, 0);
 END {AcsObj_OnAfterNoninteractiveEdit};

 PUBLIC PROCEDURE AcsObj_OnAfterNoninteractiveInsert();
 BEGIN
  L_AR.CopyRecordToAcsObj2(0, 1);
 END {AcsObj_OnAfterNoninteractiveInsert};

 PUBLIC PROCEDURE Renovate_dbFile();
  VAR
   i      : NUMERIC[0];
   _Name  : LIKE(dbFile.Name);
   _dbFile: LIKE(dbFile.dbFile);
   _Parent: LIKE(dbFile.Parent);
   fd     : OBJECT;
 BEGIN
  fd:=L_General.CreateDictionary();
  i:=DBD.FileAmount();
  WHILE i > 0 DO
   DEC(i);
   _Name:=DBD.FileName(i);
   PROMPT(_Name);
   IF DBD.FileIsRegular(^_Name) THEN
    _dbFile:=DBD.FileNameToId(_Name);
    IF ~SEARCH(dbFile, dbFile, _dbFile) THEN
     DEFAULT(dbFile);
     dbFile.dbFile:=_dbFile;
     INSERT(dbFile);
    END;
    SETEMPTY(dbFile.Parent);
    dbFile.Name :=_Name;
    dbFile.Dscrp:=DBD.FileDescription(^_Name);
    REPLACE(dbFile);
    fd.Add(dbFile.dbFile, "");
   END;
  END;
  (* 㤠 ॢ訥 䠩 -  - ⮬ 15.10.2008 17:33:54 POLAK\San *)
  SELECT(dbFile, dbFile);
  WHILE OCCURE(dbFile) DO
   PROMPT(" ॢ 䠩: " + dbFile.Name);
   IF ~fd.Exists(dbFile.dbFile) THEN
    SE_INTEGRITY(1);
    SELECT(aofr, db1, , dbFile.dbFile);
    REMSEL(aofr);

    SELECT(dbRights, dbFile, , dbFile.dbFile);
    REMSEL(dbRights);

    SAVE(dbFile);
    WHILE SELECT(dbFile, PrnName, dbFile.dbFile) DO
     SETEMPTY(dbFile.Parent);
     REPLACE(dbFile);
    END; (* WHILE OCCURE(dbFile) ... *)
    RESTORE(dbFile);

    REMOVE(dbFile);
    SE_INTEGRITY(0);
   ELSE
    NEXT(dbFile);
   END;
  END; (* WHILE OCCURE(dbFile) ... *)
  L_AR.ft_Init();
  L_APAR.AddUnconditionallyRelatedFiles();

  SELECT(L_AR_rlf, Master);
  WHILE OCCURE(L_AR_rlf) DO
   NARROWSEL(L_AR_rlf, Master);
   IF SELECT(dbFile, Name, L_AR_rlf.Master) THEN
    _Parent:=dbFile.dbFile;
    WHILE OCCURE(L_AR_rlf) DO
     IF SELECT(dbFile, Name, L_AR_rlf.File) THEN
      L_General.CallUs(!dbFile.Parent);
      dbFile.Parent:=_Parent;
      REPLACE(dbFile);
     END;
     NEXT(L_AR_rlf);
    END; (* WHILE OCCURE(L_AR_rlf) ... *)
   END;
   NEXTINEXTENDEDSEL(L_AR_rlf, Master);
  END; (* WHILE OCCURE(L_AR_rlf) ... *)
  L_AR.ft_DeInit();
 END {Renovate_dbFile};

 PRIVATE PROCEDURE AcsObj_OnBeforeEdit();
 BEGIN
  L_General.SilentAdminOnly();
 END {AcsObj_OnBeforeEdit};

 PRIVATE PROCEDURE AcsObj_OnBeforeInsert();
 BEGIN
  L_General.Error("⠢ 饭");
 END {AcsObj_OnBeforeInsert};

 PRIVATE PROCEDURE AcsObj_OnAfterEdit();
  VAR
   aoGuard: LIKE(AcsObj.AcsObj);
 BEGIN
  IF AcsObj.Type = L_AR.aot_User THEN
   SAVE(AcsObj);
   aoGuard:=L_Guard.AcsObjOfGuard();
   RESTORE(AcsObj);
   IF AcsObj.AcsObj = aoGuard THEN
    L_General.Assert(AcsObj.ManAssT = L_AR.aomat_Robot, " ⥫    ᮯ⠢  '஡'");
   END;
   IF (AcsObj.ManAssT = L_AR.aomat_NotMan) | (AcsObj.ManAssT = L_AR.aomat_Robot) THEN
    L_General.Assert(!AcsObj.Man, "⠢  ,   㪠??");
   ELSE
    L_General.Assert(~!AcsObj.Man, " 㪠 ");
   END;
   IF (AcsObj.Begin # GE_PVALUE(AcsObj.Begin)) | (AcsObj.Till # GE_PVALUE(AcsObj.Till)) THEN
    L_AR.UpdateUserAOMem();
   END;
  END;
  L_AR.AccessAcsObj2(AcsObj.AcsObj);
  L_AR.CopyRecordToAcsObj2(1, 0);
 END {AcsObj_OnAfterEdit};

 PRIVATE PROCEDURE AcsObj_OnBeforeDelete();
 BEGIN
  L_General.SilentAdminOnly();
  IF AcsObj.Type = L_AR.aot_Group THEN
   L_General.Error("⠢ 㯯 । 묨 Active Directory.  饭");
  ELSE
   CALL(ccCnct.RefreshAll(0));
   L_General.Assert(~SELECT(ccCnct, Login, L_WDO.v_dbConnection, AcsObj.Name),
                    "짮⥫  ⨢ 祭.  ");
  END;

  L_AR.AccessAcsObj2(AcsObj.AcsObj);
  TRY
   SE_INTEGRITY(1);
   WHILE SELECT(aofr, ao1, AcsObj.AcsObj) & REMOVE(aofr) DO
   END;
   WHILE SELECT(ccCnct, AcsObj, AcsObj.AcsObj) & REMOVE(ccCnct) DO
   END;
   WHILE SELECT(AOMem, AcsObj, AcsObj.AcsObj) & REMOVE(AOMem) DO
   END;
   WHILE SELECT(AOMem, AcsObj2, AcsObj2.AcsObj2) & REMOVE(AOMem) DO
   END;
   REMOVE(AcsObj2);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_NoDeleteUser THEN
    L_General.Error("   㤠, ⮬ |  뫠  㣮 䠩");
   ELSE
    RAISE();
   END;
  END;
 END {AcsObj_OnBeforeDelete};

 PRIVATE PROCEDURE dbRights_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="dbRights";
  L_WDO.iField       (0, "dbRights.Permanent").Format:="६|ﭭ";
  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete]);
  L_WDO.iSubwindow   (1, "dbRightsE");
  L_WDO.iField       (1, "dbRights.Rights").Format:=L_AR.fr_Pool;
  L_WDO.iField       (1, "dbRights.AOType").Format:=L_AR.aot_Pool;
  L_WDO.iProgs       (1, "AcsObj");
 END {dbRights_OnInitializeWindow};

 PRIVATE PROCEDURE dbR_AO_1_OnZoneOpen();
 BEGIN
  ACCESS(AcsObj);
  IF OCCURE(AcsObj) & (AcsObj.Type = L_AR.aot_Group) THEN
   L_WDO.iField(1, "dbRights.Manager").Format:="ᥩ 㯯|ࠬ";
  ELSE
   L_WDO.iField(1, "dbRights.Manager").Format:=" | ";
  END;
 END {dbR_AO_1_OnZoneOpen};

 PRIVATE PROCEDURE dbRights_AcsObj_OnSuccessfulChange();
 BEGIN
  CONFORM(dbRights, AcsObj);
  L_WDO.iField(0, "dbRights.Manager").Visible:=~!dbRights.AcsObj & (AcsObj.Type = L_AR.aot_Group);
 END {dbRights_AcsObj_OnSuccessfulChange};

 PRIVATE PROCEDURE dbRightsE_0_OnReposition();
 BEGIN
  CONFORM(dbRights, AcsObj);
  L_WDO.iField(0, "dbRights.Manager").Visible:=~!dbRights.AcsObj & (AcsObj.Type = L_AR.aot_Group);
 END {dbRightsE_0_OnReposition};

 PRIVATE PROCEDURE dbRights_OnBeforeInsert();
 BEGIN
  dbRights.Source:=0;
  REPLACE(dbRights);
 END {dbRights_OnBeforeInsert};

 PRIVATE PROCEDURE dbRights_OnAfterEdIns();
 BEGIN
  CONFORM(dbRights, dbFile);
  L_General.Assert(dbFile.Name # "iga", "饭  ࠢ   䠩");
  CONFORM(dbRights, AcsObj);
  dbRights.AOType:=AcsObj.Type;
  IF AcsObj.Type # L_AR.aot_Group THEN
   dbRights.Manager:=0;
  END;
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   REPLACE(dbRights);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_UniquenessViolation THEN
    L_General.Error("  ⠭ 짮⥫ " + dbRights.AcsObj +
                    "|ࠢ  䠩   " + dbRights.dbFile);
   ELSE
    RAISE();
   END;
  END;

  IF DBD.FileExist(dbRDtl) THEN
   SELECT(dbRDtl, dbRights, , dbRights.dbRights);
   WHILE OCCURE(dbRDtl) DO
    CONFORM(dbRDtl, Group);
    L_General.Assert(Group.Owner = dbRights.dbFile,
                     "㯯 ᥩ  " + Group.Group + "  ⭮  䠩 " + dbFile.Name);
    NEXT(dbRDtl);
   END; (* WHILE OCCURE(dbRDtl) ... *)
  END;
 END {dbRights_OnAfterEdIns};

 PRIVATE PROCEDURE dbRights_OnAfterInsert();
 BEGIN
  dbRights_OnAfterEdIns();
 END {dbRights_OnAfterInsert};

 PRIVATE PROCEDURE dbRights_CheckSource();
 BEGIN
  L_General.Assert(dbRights.Source = 0, "䨪 ࠢ, ।⠢ ⮏, 饭");
 END {dbRights_CheckSource};

 PRIVATE PROCEDURE dbRights_OnBeforeEdit();
 BEGIN
  dbRights_CheckSource();
 END {dbRights_OnBeforeEdit};

 PRIVATE PROCEDURE dbRights_OnAfterEdit();
 BEGIN
  dbRights_OnAfterEdIns();
 END {dbRights_OnAfterEdit};

 PRIVATE PROCEDURE dbRights_OnBeforeDelete();
 BEGIN
  dbRights_CheckSource();
 END {dbRights_OnBeforeDelete};

 PRIVATE PROCEDURE aofr_ao_1_OnZoneOpen();
 BEGIN
  L_WDO.SetFieldFormat("aofr.Rights", L_AR.fr_Pool);
  L_WDO.z_SetFieldFormat(2, "aofrl.Rights", L_AR.fr_Pool);
  L_WDO.SetFieldFormat("aofr.Source", L_AR.rs_Pool);
  L_WDO.z_SetFieldFormat(2, "aofrl.Source", L_AR.rs_Pool);
  L_WDO.z_SetFieldFormat(2, "aofrl.Origin", L_AR.ro_Pool);
  L_WDO.z_SetFieldFormat(2, "aofrl.AOType", L_AR.aot_Pool);
  L_WDO.z_SetFieldFormat(0, "aofr_aoTitle",         L_AR.aot_Pool);
  L_WDO.z_SetFieldFormat(0, "aofr_aoFullNameTitle", " |਩");
 END {aofr_ao_1_OnZoneOpen};

 PRIVATE PROCEDURE aofr_db_1_OnZoneOpen();
 BEGIN
  L_WDO.SetFieldFormat("AcsObj.Type", L_AR.aot_Pool_Short);
  L_WDO.SetFieldFormat("aofr.Rights", L_AR.fr_Pool);
  L_WDO.SetFieldFormat("aofr.Source", L_AR.rs_Pool);
  L_WDO.SetFieldFormat("aofr.Origin", L_AR.ro_Pool);
  L_WDO.z_SetFieldFormat(2, "aofrl.Rights", L_AR.fr_Pool);
  L_WDO.z_SetFieldFormat(2, "aofrl.Source", L_AR.rs_Pool);
  L_WDO.z_SetFieldFormat(2, "aofrl.Origin", L_AR.ro_Pool);
  L_WDO.z_SetFieldFormat(2, "aofrl.AOType", L_AR.aot_Pool);
 END {aofr_db_1_OnZoneOpen};

 PRIVATE PROCEDURE Ins_aofrl();
 BEGIN
  aofrl.aofr   :=aofr.aofr;
  aofrl.AcsObj :=L_AR_frt.AcsObj;
  aofrl.AOType :=L_AR_frt.AOType;
  aofrl.Manager:=L_AR_frt.Manager;
  aofrl.Rights :=L_AR_frt.Rights;
  aofrl.Source :=L_AR_frt.Source;
  aofrl.Origin :=L_AR_frt.Origin;
  aofrl.Master :=L_AR_frt.Master;
  INSERT(aofrl);
 END {Ins_aofrl};

 PRIVATE PROCEDURE aofrRenew_OneAcsObj();
  VAR
   cgRights  : L_AR.tFileRights;
   cgOrigin  : L_AR.tRightsOrigin;
   cgSource  : L_AR.tRightsSource;
   curManager: SCAL[2];
 BEGIN
  PROMPT(AcsObj.AcsObj + ". 樠");
  SAVE(AcsObj);
  L_APAR.PrepareFilesRightsTable(L_AR.srm_ShowSpecifiedAcsObj);
  RESTORE(AcsObj);
  SAVE(AcsObj);
  FOR_EACH curManager DO
   IF (curManager = 0) | (AcsObj.Type = L_AR.aot_Group) THEN
    SELECT(dbFile, dbFile);
    WHILE OCCURE(dbFile) DO
     PROMPT(AcsObj.AcsObj + ". . " + dbFile.dbFile);
     IF curManager = 1 THEN
      SELECT(aofr, ao6, , AcsObj.AcsObj, 0, dbFile.Name);
      cgRights:=aofr.Rights;
      cgSource:=aofr.Source;
      cgOrigin:=aofr.Origin;
     END;
     SETEMPTY(aofr.aofr);
     aofr.AcsObj :=AcsObj.AcsObj;
     aofr.Manager:=curManager;
     aofr.AOType :=AcsObj.Type;
     aofr.aoName :=AcsObj.Name;
     IF AcsObj.Type = L_AR.aot_Group THEN
      aofr.Rights:=L_AR.ft_GetSingleFileRights4Group(dbFile.Name, AcsObj.AcsObj, curManager);
     ELSE
      aofr.Rights:=L_AR.ft_GetSingleFileRights(dbFile.Name, AcsObj.AcsObj);
     END;
     aofr.dbFile :=dbFile.dbFile;
     aofr.File   :=dbFile.Name;
     aofr.Source :=L_AR.rs_System;
     aofr.Origin :=L_AR.ro_Prime;
     INSERT(aofr);
     SELECT(L_AR_frt, toShow, , dbFile.Name);
     WHILE OCCURE(L_AR_frt) DO
      IF L_AR_frt.Manager <= curManager THEN
       IF (L_AR_frt.Source = L_AR.rs_Admin) & (L_AR_frt.Rights = aofr.Rights) THEN
        IF (aofr.Source # L_AR.rs_Admin) | (aofr.Origin # L_AR.ro_Prime) THEN
         aofr.Origin:=L_AR_frt.Origin;
         aofr.Source:=L_AR.rs_Admin;
         REPLACE(aofr);
        END;
       END;
       Ins_aofrl();
      END;
      NEXT(L_AR_frt);
     END;
     IF (curManager = 1) & (aofr.Rights = cgRights) & (aofr.Source = cgSource) & (aofr.Origin = cgOrigin) THEN
      SELECT(aofrl, aofr, , aofr.aofr);
      REMSEL(aofrl);
      REMOVE(aofr);
     END;
     NEXT(dbFile);
    END; (* WHILE OCCURE(dbFile) ... *)
   END; (* IF (curManager = 0) | (AcsObj.Type = aot_Group) *)
  END; (* FOR_EACH curManager *)
  L_AR.ft_DeInit();
  RESTORE(AcsObj);
 END {aofrRenew_OneAcsObj};

 PUBLIC PROCEDURE aofrRenew_All();
  VAR
   _aofr: LIKE(aofr.aofr);
 BEGIN
  APP.Get().NewPrompt("");
  PROMPT("⪠");
  IF L_General.IsAcceptableProcessorVersion(14122010) THEN
   SELECT(aofrl, aofr);
   REMSEL(aofrl);
   SELECT(aofr, aofr);
   REMSEL(aofr);
  ELSE
   SELECT(aofr, aofr);
   LAST(aofr);
   _aofr:=aofr.aofr;
  END;

  SELECT(AcsObj, AcsObj);
  WHILE OCCURE(AcsObj) DO
   IF L_DatTim.IsActive(SYSDATE(), AcsObj.Begin, AcsObj.Till) THEN
    aofrRenew_OneAcsObj();
   END;
   NEXT(AcsObj);
  END; (* WHILE OCCURE(AcsObj) ... *)

  IF ~L_General.IsAcceptableProcessorVersion(14122010) THEN
   SE_INTEGRITY(1);
   SELECT(aofr, aofr);
   WHILE OCCURE(aofr) & (aofr.aofr <= _aofr) DO
    REMOVE(aofr);
   END; (* WHILE OCCURE(aofr) ... *)
   SE_INTEGRITY(0);
  END;
 END {aofrRenew_All};

 PRIVATE PROCEDURE aofrRenew_GetOneGroupRights(    trgManager: SCAL[2];
                                               VAR Rights    : L_AR.tFileRights;
                                               VAR Origin    : L_AR.tRightsOrigin;
                                               VAR Source    : L_AR.tRightsSource;
                                                   DoInsert  : SCAL[2]);
  VAR
   maxLevel,
   curLevel : NUMERIC[0];
 BEGIN
  maxLevel:=0;
  SELECT(L_AR_frt, toShow, , dbFile.Name, AcsObj.Type, AcsObj.AcsObj);
  WHILE OCCURE(L_AR_frt) DO
   IF L_AR_frt.Manager <= trgManager THEN
    curLevel:=L_AR.FileRightsLevel();
    IF    (curLevel > maxLevel) | (curLevel = maxLevel) & (L_AR_frt.Rights > Rights) THEN
     Rights  :=L_AR_frt.Rights;
     Origin  :=L_AR_frt.Origin;
     Source  :=L_AR_frt.Source;
     maxLevel:=curLevel;
    END;
    IF DoInsert THEN
     Ins_aofrl();
    END;
   END;
   NEXT(L_AR_frt);
  END; (* WHILE OCCURE(L_AR_frt) *)
 END {aofrRenew_GetOneGroupRights};

 PRIVATE PROCEDURE aofrRenew(srm: L_AR.tSetRightsMode);
  VAR
   cgRights   : L_AR.tFileRights;
   cgOrigin   : L_AR.tRightsOrigin;
   cgSource   : L_AR.tRightsSource;
   curManager,
   NeedIns    : SCAL[2];
 BEGIN
  APP.Get().NewPrompt("");
  PROMPT("⪠");

  IF srm = L_AR.srm_ShowSpecifiedFile THEN
   L_General.Assert(ACCESS(dbFile), " ⠭ ⥪騩 䠩");
   SE_INTEGRITY(1);
   SELECT(aofr, db1, , dbFile.dbFile);
   REMSEL(aofr);
   SE_INTEGRITY(0);
   PROMPT("樠");
   SAVE(AcsObj);
   SAVE(dbFile);
   L_APAR.PrepareFilesRightsTable(srm);
   RESTORE(AcsObj);
   RESTORE(dbFile);
   SELECT(AcsObj, AcsObj);
   WHILE OCCURE(AcsObj) DO
    IF L_DatTim.IsActive(SYSDATE(), AcsObj.Begin, AcsObj.Till) THEN
     PROMPT(AcsObj.AcsObj + ". . " + dbFile.dbFile);
     FOR_EACH curManager DO
      cgRights:=L_AR.fr_Nothing;
      cgOrigin:=L_AR.ro_Prime;
      cgSource:=L_AR.rs_System;
      IF AcsObj.Type = L_AR.aot_Group THEN
       aofrRenew_GetOneGroupRights(curManager, cgRights, cgOrigin, cgSource, 0);
       IF curManager = 1 THEN
        SELECT(aofr, ao6, , AcsObj.AcsObj, 0, dbFile.Name);
        NeedIns:=~((aofr.Rights = cgRights) & (aofr.Source = cgSource) & (aofr.Origin = cgOrigin));
       ELSE
        NeedIns:=1;
       END;
      ELSE
       NeedIns:=curManager = 0;
      END;
      IF NeedIns THEN
       SETEMPTY(aofr.aofr);
       aofr.AcsObj :=AcsObj.AcsObj;
       aofr.Manager:=curManager;
       aofr.AOType :=AcsObj.Type;
       aofr.aoName :=AcsObj.Name;
       aofr.dbFile :=dbFile.dbFile;
       aofr.File   :=dbFile.Name;
       aofr.Rights :=cgRights;
       aofr.Origin :=cgOrigin;
       aofr.Source :=cgSource;
       INSERT(aofr);
       IF AcsObj.Type = L_AR.aot_Group THEN
        aofrRenew_GetOneGroupRights(curManager, aofr.Rights, aofr.Origin, aofr.Source, 1);
        REPLACE(aofr);
       ELSE
        SAVE(AcsObj);
        SELECT(AOMem, AcsObj2, , AcsObj.AcsObj);
        WHILE OCCURE(AOMem) DO
         CONFORM(AOMem, AcsObj);
         cgRights:=L_AR.fr_Nothing;
         cgOrigin:=L_AR.ro_Prime;
         cgSource:=L_AR.rs_System;
         aofrRenew_GetOneGroupRights(AOMem.Manager, cgRights, cgOrigin, cgSource, 1);
         IF (cgRights > aofr.Rights) | (cgRights = aofr.Rights) & (cgSource > aofr.Source) THEN
          aofr.Rights :=cgRights;
          aofr.Origin :=cgOrigin;
          aofr.Source :=cgSource;
          REPLACE(aofr);
         END;
         NEXT(AOMem);
        END; (* WHILE OCCURE(AOMem) ... *)
        RESTORE(AcsObj);
        IF SELECT(L_AR_frt, toSetF, dbFile.Name, L_AR.aot_User, AcsObj.AcsObj) THEN
         aofr.Rights:=L_AR_frt.Rights;
         aofr.Origin:=L_AR_frt.Origin;
         aofr.Source:=L_AR_frt.Source;
         REPLACE(aofr);
         Ins_aofrl();
        END;
       END;
      END; (* IF (curManager = 0) | (AcsObj.Type = aot_Group) *)
     END; (* FOR_EACH curManager *)
    END;
    NEXT(AcsObj);
   END; (* WHILE OCCURE(AcsObj) ... *)
  ELSE
   L_General.Assert(ACCESS(AcsObj), " ⠭ 짮⥫(㯯)");
   SE_INTEGRITY(1);
   SELECT(aofr, ao1, , AcsObj.AcsObj);
   REMSEL(aofr);
   SE_INTEGRITY(0);
   aofrRenew_OneAcsObj();
  END;
 END {aofrRenew};

 PUBLIC PROCEDURE ao_StandOnCurUSER();
 BEGIN
  SEARCH(AcsObj, AcsObj, , L_General.curUSER);
  IF L_AR.SessionHasAssignedGroup() THEN
   L_StdFrm.Inform("  ࠢ 짮⥫ " + AcsObj.Name + ".||" +
                   " ⮏ 饭  ࠢ 㣮 짮⥫ (㯯)");
  END;
  SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), AcsObj);
 END {ao_StandOnCurUSER};

 PUBLIC PROCEDURE RunAutoparkAsMemberOfGroup();
  VAR
   msg,
   params: STRING[];
   MCnt,
   Dummy : NUMERIC[0];
 BEGIN
  L_General.Assert(ACCESS(AcsObj), " ⠭ 짮⥫(㯯)");
  L_General.SilentAdminOnly();
  params:=DBD.BaseName();
  IF L_StdFrm.wGUI() THEN     
   params:=params + " -gui";
  END;
  SETEMPTY(msg);
  IF AcsObj.Type = L_AR.aot_User THEN
   IF SELECT(dbRights, AcsObj, AcsObj.AcsObj) THEN
    INC(msg, " ࠢ  䠩, ⠭ ᮭ쭮 짮⥫.|");
   END;
   MCnt:=0;
   SELECT(AOMem, AcsObj2, , AcsObj.AcsObj);
   WHILE OCCURE(AOMem) DO
    CONFORM(AOMem, AcsObj);
    INC(MCnt, AOMem.Manager);
    params:=params + ' -G:"' + AcsObj.Name + '"';
    NEXT(AOMem);
   END; (* WHILE OCCURE(AOMem) ... *)
   IF MCnt > 0 THEN
    INC(msg, "짮⥫   ࠢ  䠩    㯯.|");
   END;
  ELSE
   params:=params + ' -G:" + L_General.UsersGroupName() + " -G:"' + AcsObj.Name + '"';
  END;
  IF ~!msg THEN
   INC(msg, "|⮏ 㤥 饭    ࠢ");
  END;

  IF SELECT(dbRights, AcsObj, L_General.curUSER) THEN
   msg:=L_Str.AddStrDlm(msg, L_StdFrm.HR()) +
        " ࠢ  䠩, ⠭ ᮭ쭮 ." +
        "||⮏ 㤥 饭  ⮬  ࠢ";
  END;
  IF ~!msg THEN
   L_StdFrm.Question(msg);
  END;
  IF APP.Get().SupportMode THEN
   INC(params, " -G:AP_Support");
  END;
  Dummy:=L_General.ExecEP(L_General.ept_Internal, "v32.exe", params,
                          FIO.AsbSpecialFolders("ClientRedFileDir"),
                          L_General.ws_Normal, 0, L_General.eprc_Normal);
 END {RunAutoparkAsMemberOfGroup};

 PUBLIC PROCEDURE aofr_RenewByAcsObj();
 BEGIN
  L_General.Assert(ACCESS(AcsObj), " ⠭ 짮⥫/㯯");
  aofrRenew(L_AR.srm_ShowSpecifiedAcsObj);
 END {aofr_RenewByAcsObj};

 PUBLIC PROCEDURE aofr_RenewByFile();
 BEGIN
  L_General.Assert(ACCESS(dbFile), " ⠭ 䠩  ");
  aofrRenew(L_AR.srm_ShowSpecifiedFile);
 END {aofr_RenewByFile};

 PUBLIC PROCEDURE SeedbRightsCurFile();
 BEGIN
  LIKEMENU(View, "dbRigCF 1 " + RTI.Get().CurWindow.Name + " " + L_Str.IntStr(RTI.Get().CurZone.Number));
 END {SeedbRightsCurFile};

 PRIVATE PROCEDURE dbRigCF_OnConformToWindow();
 BEGIN
  SEARCH(dbFile, dbFile, , DBD.FileNameToId(GE_CURFILE()));
  SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, dbFile);
 END {dbRigCF_OnConformToWindow};

 PUBLIC PROCEDURE SeeFinalRightsCurFile();
  VAR
   f: FORMWINDOW;
 BEGIN
  L_General.Assert(~!GE_CURFILE(), " ⠭ ⥪騩 䠩");
  SEARCH(dbFile, dbFile, , DBD.FileNameToId(GE_CURFILE()));
  f:=APPLICATION.Get().Forms.Load("aofr_db");
  f.Isolated:=1;
  SE_WWD_CURSOR(f.Name, dbFile);
  aofr_RenewByFile();
  LIKEMENU(View, "aofr_db 1 " + RTI.Get().CurWindow.Name + " " + L_Str.IntStr(RTI.Get().CurZone.Number));
 END {SeeFinalRightsCurFile};

 PUBLIC PROCEDURE RUBAD();
  VAR
   frn: STRING[];
 BEGIN
  frn:=L_AR.RenovateUsersByAD();
  LIKEMENU(Survey, frn);
 END {RUBAD};

 PRIVATE PROCEDURE aoUser_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="AcsObj";
  L_WDO.iZone        (1).Narrowing:="AcsObj.Type=" + L_Str.IntStr(L_AR.aot_User);
  L_WDO.iSubwindow   (1, "aoUserE");
 END {aoUser_OnInitializeWindow};

 PRIVATE PROCEDURE aoGroup_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="AcsObj";
  L_WDO.iZone        (1).Narrowing:="AcsObj.Type=" + L_Str.IntStr(L_AR.aot_Group);
  L_WDO.iSubwindow   (1, "aoGroupE");
 END {aoGroup_OnInitializeWindow};

 PRIVATE PROCEDURE aoGroupE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete]);
  L_WDO.iModifiable  (0, ["AcsObj.inXDF"]);
  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete]);
  L_WDO.iProgs       (1, "AcsObj");
  L_WDO.iUnmodifiable(1, ["AOMem.aoName2", "AOMem.aoFN2", "AOMem.AcsObj2"
                      (*, 'SELF.Zone.LinkedFieldValue("AcsObj2.Begin")', 'SELF.Zone.LinkedFieldValue("AcsObj2.Till")'*)]);
  L_WDO.iZone        (1).Narrowing:="AOMem.AcsObj=AcsObj.AcsObj";
(*
  L_WDO.iZone        (1).ViewOnly:=1;
*)
 END {aoGroupE_OnInitializeWindow};

 PRIVATE PROCEDURE aoUserE_2_OnSetSubwindow();
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_ShowWin THEN
   RTI.Get().CurZone.SubwindowOriginalName:="StaffE";
  ELSE
   RTI.Get().CurZone.SubwindowOriginalName:="";
  END;
 END {aoUserE_2_OnSetSubwindow};

 PRIVATE PROCEDURE aoUserE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete]);
  L_WDO.iField       (0, "AcsObj.FullName").LineBreakEnable:=1;
  L_WDO.iUnmodifiable(0, ["AcsObj.FullName", "AcsObj.Name", "AcsObj.AcsObj", "AcsObj.Begin", "AcsObj.Till"]);
  L_WDO.iMayBeEmpty  (0, ["AcsObj.MCSngSt", "AcsObj.MCTotal", "AcsObj.Man"]);
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iZone        (1).Narrowing:="AOMem.AcsObj2=AcsObj.AcsObj";
  IF ~!DATABASE.Get().Tables("Staff") THEN
   L_WDO.iEvents      (2, [L_WDO.e_OnSetSubwindow]);
   L_WDO.iZone        (2).ViewOnly:=1;
   L_WDO.iZone        (2).ZLevProg:="AcsObj";
   L_WDO.iZone        (2).Narrowing:="Staff.Man=AcsObj.Man";
  END;
 END {aoUserE_OnInitializeWindow};

 PRIVATE PROCEDURE AOMem_OnBeforeInsert();
 BEGIN
  L_General.Error('⠢ 饭.||ᯮ "  ᭮  Active Directory"');
 END {AOMem_OnBeforeInsert};

 PRIVATE PROCEDURE AOMem_OnBeforeDelete();
 BEGIN
  L_General.Error(' 饭.||ᯮ "  ᭮  Active Directory"');
 END {AOMem_OnBeforeDelete};

 PUBLIC PROCEDURE RenovateRights();
 BEGIN
  L_PCS.GrantRights(L_AR.srm_Renovate);
  L_StdFrm.Inform(" ࠢ ");
 END {RenovateRights};

 PUBLIC PROCEDURE scs_GetFilters_dbRights_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "짮⥫", "(dbRights.AOType=" + L_Str.IntStr(L_AR.aot_User)  + ")", 1);
  L_WDO.PutNewFilter(Filters, "㯯",       "(dbRights.AOType=" + L_Str.IntStr(L_AR.aot_Group) + ")", 1);
 END {scs_GetFilters_dbRights_1};

 PUBLIC PROCEDURE scs_GetFilters_aofr_db_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "짮⥫", "(aofr.AOType=" + L_Str.IntStr(L_AR.aot_User)  + ")", 1);
  L_WDO.PutNewFilter(Filters, "㯯",       "(aofr.AOType=" + L_Str.IntStr(L_AR.aot_Group) + ")", 1);
 END {scs_GetFilters_aofr_db_1};

BEGIN
 L_Events.ExecuteHandler();
END.
