(*
%Copyright   (c) Polak IT
%Author      10.02.2009 10:36:52 POLAK\LDA
%Purpose     ஫ ࠡ  窠 㯠
%Type        control
%Specific    AP
%Modified    25.06.2014 15:40:12 POLAK\LDA
%Environment
*)

 MODULE AcsPnt [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PRIVATE PROCEDURE AcsPntE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete]);
  L_WDO.iUnmodifiable(0, ["AcsPnt.Descr", "AcsPnt.Name", "AcsPnt.AcsPnt"]);
  L_WDO.iMayBeEmpty  (0, ["AcsPnt.AddText"]);
  L_WDO.iSubwindow   (1, "AcsPntR");
  L_WDO.iField       (1, "AcsPntR.Source").Format:="|";
  L_WDO.iField       (1, "AcsObj.Type").Format:=L_AR.aot_Pool;
  L_WDO.iField       (1, "AcsPntR.Access" ).Format:=L_AcsPnt.apr_AccessPool;
  L_WDO.iField       (1, "AcsPntR.Message").Format:=L_AcsPnt.apr_MessagePool;
  L_WDO.iProgs       (1, "AcsPnt");
  L_WDO.iZone        (2).ViewOnly:=1;
 END {AcsPntE_OnInitializeWindow};

 PRIVATE PROCEDURE AcsPntR_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeEdit]);
  L_WDO.iScsChange   (0, ["AcsPntR.Access"]);
  L_WDO.iUnmodifiable(0, ["AcsPntR.Source"]);
  L_WDO.iMayBeEmpty  (0, ["AcsPntR.Comment"]);
  L_WDO.iField       (0, "AcsPntR.Source").Format:="|⥬";
  L_WDO.iField       (0, "AcsObj.Type").Format:=L_AR.aot_Pool;
  L_WDO.iField       (0, "AcsPntR.Access" ).Format:=L_AcsPnt.apr_AccessPool;
  L_WDO.iField       (0, "AcsPntR.Message").Format:=L_AcsPnt.apr_MessagePool;
  L_WDO.iProgs       (0, "AcsPnt");
 END {AcsPntR_OnInitializeWindow};

 PRIVATE PROCEDURE AcsPntE_OnConformToWindow();
  VAR
   trgProc: FORM_PROCESS;
 BEGIN
  trgProc:=RTI.Get().ConformTargetWindow.Zones(0).Processes(0);
  IF trgProc.Kind = FORM_PROCESS.Kind_Insert THEN
   SETSEL(AcsPnt, AcsPnt);
   SE_WWD_CURSOR(GE_CONFORMTARGETWINDOW(), AcsPnt);
  ELSE
   IF ~!trgProc.Env.Item("bp") THEN
    L_General.CallUs(SEARCH(bp, bp, trgProc.Env.Item("bp").Value));
    CONFORM(bp, AcsPnt);
    SE_WWD_CURSOR(GE_CONFORMTARGETWINDOW(), AcsPnt);
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {AcsPntE_OnConformToWindow};

 PRIVATE PROCEDURE sap_Choose(sap_Pool        : STRING[];
                              sap_AlreadyExist: SCAL[2]): NUMERIC[0];
 BEGIN
  IF sap_AlreadyExist THEN
   L_StdFrm.BlueStop("  ᯥ樠  㦥 ଫ");
  END;

  IF L_Str.CntItemsInPool(sap_Pool) = 1 THEN
   RETURN 0;
  ELSE
   RETURN L_StdFrm.ShowListAsMenu(sap_Pool, "⠭ ᯥ樠 稩");
  END;
 END {sap_Choose};

 PRIVATE PROCEDURE sap_Insert(VAR trgAcsPnt: LIKE(AcsPnt.AcsPnt);
                                  sap_Pool : STRING[];
                                  choice   : NUMERIC[0];
                                  sap_Descr: STRING[]);
  VAR
   sap_Name: STRING[];
 BEGIN
  sap_Name:=L_Str.PoolItem(sap_Pool, choice);
  L_General.Assert(!trgAcsPnt, "C樠  '" + sap_Name + "' 㦥 ଫ");
  IF ~L_AcsPnt.IsUserDefined(AcsPnt.AcsPnt) THEN
   AcsPnt.AcsPnt:=L_AcsPnt.NewUserDefinedAcsPnt();
   REPLACE(AcsPnt);
  END;
  L_AcsPnt.SetAcsPnt(AcsPnt.AcsPnt, sap_Name, sap_Name + " " + sap_Descr, "", L_AcsPnt.aprm_None);

  trgAcsPnt:=AcsPnt.AcsPnt;
 END {sap_Insert};

 PRIVATE PROCEDURE ssap_Property();
  CONST
   sap_Property_Pool = "䨪|䨪  ᫮";
  VAR
   choice   : NUMERIC[0];
   sap_Descr: STRING[];
 BEGIN
  choice   :=sap_Choose(sap_Property_Pool, ~!Property.apModify & ~!Property.apBDMdf);
  sap_Descr:="᢮⢠ '"+Property.Name+"' ("+Property.Property+")";

  IF   choice = 0 THEN
   sap_Insert(Property.apModify, sap_Property_Pool, choice, sap_Descr);
  ELSIF choice = 1 THEN
   IF !Property.AlwDelay THEN
    L_StdFrm.BlueStop("  ᯥ樠 稩  䨪樨 ᢮⢠" +
                      "| ᫮ ᭠砫 室 ⠭ ⢮ , " +
                      "| 祭  㤥 ࠧ襭  䨪");
   END;
   sap_Insert(Property.apBDMdf, sap_Property_Pool, choice, sap_Descr);
  ELSE
   L_General.CallUs(0);
  END;

  REPLACE(Property);
  FIX_ALTERING();
 END {ssap_Property};

 PRIVATE PROCEDURE ssap_EDOSrc();
  CONST
   sap_EDOSrc_Pool = "ਪ  ᫥/㤥ঠ: 䨪|ਪ  ᫥/㤥ঠ: ᬮ|" +
                     "ਪ  ᮭ: 䨪|ਪ  ᮭ: ᬮ";
  VAR
   choice   : NUMERIC[0];
   sap_Descr: STRING[];
 BEGIN
  choice   :=sap_Choose(sap_EDOSrc_Pool, ~!EDOSrc.apVFO & ~!EDOSrc.apVEDO & ~!EDOSrc.apMFO & ~!EDOSrc.apMEDO);
  sap_Descr:=" 筨 '" + EDOSrc.Name + "' (" + EDOSrc.EDOSrc + ")";
  IF    choice = 0 THEN
   sap_Insert(EDOSrc.apMFO,  sap_EDOSrc_Pool, choice, sap_Descr);
  ELSIF choice = 1 THEN
   sap_Insert(EDOSrc.apVFO,  sap_EDOSrc_Pool, choice, sap_Descr);
  ELSIF choice = 2 THEN
   sap_Insert(EDOSrc.apMEDO, sap_EDOSrc_Pool, choice, sap_Descr);
  ELSIF choice = 3 THEN
   sap_Insert(EDOSrc.apVEDO, sap_EDOSrc_Pool, choice, sap_Descr);
  ELSE
   L_General.CallUs(0);
  END;

  REPLACE(EDOSrc);
  FIX_ALTERING();
 END {ssap_EDOSrc};

 PRIVATE PROCEDURE ssap_AveType();
  CONST
   sap_AveType_Pool = "஢";
  VAR
   choice   : NUMERIC[0];
   sap_Descr: STRING[];
 BEGIN
  choice   :=sap_Choose(sap_AveType_Pool, ~!AveType.apEstmt);
  sap_Descr:="  '" + AveType.Name + "' (" + AveType.AveType + ")";
  IF    choice = 0 THEN
   sap_Insert(AveType.apEstmt, sap_AveType_Pool, choice, sap_Descr);
  ELSE
   L_General.CallUs(0);
  END;

  REPLACE(AveType);
  FIX_ALTERING();
 END {ssap_AveType};

 PRIVATE PROCEDURE AcsPnt_OnBeforeInsert();
 BEGIN
  IF    ~!L_WDO.GetEnvVarValue("bp") THEN
   L_General.CallUs(SEARCH(bp, bp, L_WDO.GetEnvVarValue("bp")));
   L_General.CallUs(!bp.AcsPnt);
   IF ~L_AcsPnt.IsUserDefined(AcsPnt.AcsPnt) THEN
    AcsPnt.AcsPnt:=L_AcsPnt.NewUserDefinedAcsPnt();
    REPLACE(AcsPnt);
   END;
   bp.AcsPnt:=AcsPnt.AcsPnt;
   REPLACE(bp);

   L_AcsPnt.SetAcsPnt(bp.AcsPnt, bp.Id + " " + bp.Name,
                                 "믮  楤 (" + bp.Id + ")",
                                 "", L_AcsPnt.aprm_None);
  ELSIF OCCURE(Property) THEN
   ssap_Property();
  ELSIF OCCURE(EDOSrc) THEN
   ssap_EDOSrc();
  ELSIF OCCURE(AveType) THEN
   ssap_AveType();
  ELSIF OCCURE(AcsPnt) THEN
   L_General.Error("⠢ 祪 㯠 饭");
  ELSE
   L_General.CallUs(0);
  END;
 END {AcsPnt_OnBeforeInsert};

 PRIVATE PROCEDURE AcsPnt_OnBeforeEdit();
 BEGIN
  (*㦭  ⬥⪨  SysLog_ *)
 END {AcsPnt_OnBeforeEdit};

 PRIVATE PROCEDURE AcsPnt_OnBeforeDelete();
 BEGIN
  IF    OCCURE(Property) THEN
   IF    Property.apModify = AcsPnt.AcsPnt THEN SETEMPTY(Property.apModify);
   ELSIF Property.apBDMdf = AcsPnt.AcsPnt THEN  SETEMPTY(Property.apBDMdf);
   ELSE                                         L_General.CallUs(0);
   END;
   REPLACE(Property);
  ELSIF OCCURE(EDOSrc) THEN
   IF    EDOSrc.apVFO = AcsPnt.AcsPnt THEN SETEMPTY(EDOSrc.apVFO);
   ELSIF EDOSrc.apVEDO = AcsPnt.AcsPnt THEN SETEMPTY(EDOSrc.apVEDO);
   ELSIF EDOSrc.apMFO = AcsPnt.AcsPnt THEN SETEMPTY(EDOSrc.apMFO);
   ELSIF EDOSrc.apMEDO = AcsPnt.AcsPnt THEN SETEMPTY(EDOSrc.apMEDO);
   ELSE L_General.CallUs(0);
   END;
   REPLACE(EDOSrc);
  ELSE
   L_General.Error(" 窨 㯠 饭");
  END;
 END {AcsPnt_OnBeforeInsert};

 PRIVATE PROCEDURE AcsPnt_OnAfterEdit();
 BEGIN
  (*㦭  ⬥⪨  SysLog_ *)
 END {AcsPnt_OnAfterEdit};

 PRIVATE PROCEDURE AcsPnt_1_OnZoneOpen();
 BEGIN
  L_WDO.InstallPermanentFilter("AcsPnt.AcsPnt < " + FLDTOSTR(L_AcsPnt.MinUserDefinedAcsPnt));
 END {AcsPnt_1_OnZoneOpen};

 PRIVATE PROCEDURE AcsPntR_CheckSource();
 BEGIN
  L_General.Assert(AcsPntR.Source = L_AcsPnt.aprsrc_Operator, "䨪 稩, ।⠢ ⮏, 饭");
 END {AcsPntR_CheckSource};

 PRIVATE PROCEDURE SetAcsPntRFieldFlagEdit();
 BEGIN
  L_WDO.SetFieldModifiable("AcsPntR.Message", AcsPntR.Access # L_AcsPnt.apra_Denied);
 END {SetAcsPntRFieldFlagEdit};

 PRIVATE PROCEDURE AcsPntR_OnBeforeEdit();
 BEGIN
  AcsPntR_CheckSource();
  SetAcsPntRFieldFlagEdit();
 END {AcsPntR_OnBeforeEdit};

 PRIVATE PROCEDURE AcsPntR_OnAfterEdIns();
 BEGIN
  IF    AcsPntR.Access = L_AcsPnt.apra_4Manager THEN
   CONFORM(AcsPntR, AcsObj);
   L_General.Assert(AcsObj.Type = L_AR.aot_Group,
                    ' "쪮 " ⨬ ⮫쪮  㯯 짮⥫');
  ELSIF AcsPntR.Access = L_AcsPnt.apra_Denied THEN
   AcsPntR.Message:=L_AcsPnt.aprm_None;
   REPLACE(AcsPntR);
  END;
 END {AcsPntR_OnAfterEdIns};

 PRIVATE PROCEDURE AcsPntR_OnAfterEdit();
 BEGIN
  AcsPntR_OnAfterEdIns();
 END {AcsPntR_OnAfterEdit};

 PRIVATE PROCEDURE AcsPntR_OnAfterInsert();
 BEGIN
  AcsPntR_OnAfterEdIns();
 END {AcsPntR_OnAfterInsert};

 PRIVATE PROCEDURE AcsPntR_OnBeforeDelete();
 BEGIN
  AcsPntR_CheckSource();
 END {AcsPntR_OnBeforeDelete};

 PRIVATE PROCEDURE AcsPntR_Access_OnSuccessfulChange();
 BEGIN
  SetAcsPntRFieldFlagEdit();
 END {AcsPntR_Access_OnSuccessfulChange};

BEGIN
 L_Events.ExecuteHandler();
END.