(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     䨪 Adding
%Type        control
%Specific    SYS
%Modified    24.01.2014 13:52:36 POLAK\MLB
%Environment
*)

 MODULE Adding [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_EDO, L_PRoll, L_DatTim, L_General, L_Env, L_Adding, L_Events, L_WDO, L_StdFrm, Math, L_DBD;

 PRIVATE VAR
  wSetAffectTo: SCAL[2];

 PRIVATE PROCEDURE _ShtDone();
  VAR
   P: DATE;
 BEGIN
  P:=L_Adding.Adding_GetActualPer();
  CONFORM(Adding, Staff);
  IF P < L_DatTim.Per(Staff.BegDate) THEN
   L_StdFrm.Choice("⭨   ਭ  " + L_DatTim.PeriodStr(P));
   L_General.SilentAdminOnly();
   P:=L_DatTim.Per(Staff.BegDate);
  END;
  IF P < L_PRoll.Salary_ClcPer() THEN
   L_StdFrm.Choice(" ਢ   ௫  "+L_DatTim.PeriodStr(P));
  END;
  P:=Math.Max(L_Env.aptm_Start, P);
  IF wSetAffectTo  THEN
   EDOrderL.AffectTo:=P;
   REPLACE(EDOrderL);
  END;
  L_PRoll.ShtDone_AP(P, 0);
 END {_ShtDone};

 PRIVATE PROCEDURE CheckCross(_From, _UpTo: DATE; Dir: STRING[]);
 BEGIN
  SAVE(Adding);
  CHANGESEL(Adding, TSN, , Adding.TSN, Adding.AddKind);
  WHILE ^Dir(Adding) DO
   L_General.Assert(~L_DatTim.IsActiveInIntvl_Inc(_From, _UpTo, Adding.From, Adding.UpTo),
                    "祭 ⨬|" +
                    "    " + L_DatTim.DateStr(Adding.From));
  END; (* WHILE OCCURE(Adding)... *)
  RESTORE(Adding);
 END {CheckCross};

 PRIVATE PROCEDURE Adding_OnAfterEdIns();
 BEGIN
  CONFORM(Adding, AddKind);
  L_DBD.CheckValidity("Adding");
  IF ~AddKind.CrossSt THEN
   CheckCross(Adding.From, Adding.UpTo, "PREV");
   CheckCross(Adding.From, Adding.UpTo, "NEXT");
  END;
 END {Adding_OnAfterEdIns};

 PRIVATE PROCEDURE CheckSource();
 BEGIN
  IF ~!Adding._EDOrder THEN
   L_EDO.StandOnEDOrder(Adding._EDOrder, Adding._Row);
   L_General.Error("  ଫ ᮣ᭮ ਪ|" + L_EDO.EDOrderName());
  END;
 END {CheckSource};

 PRIVATE PROCEDURE Adding_OnBeforeEdit();
 BEGIN
  CheckSource();
 END {Adding_OnBeforeEdit};

 PRIVATE PROCEDURE Adding_OnAfterEdit();
 BEGIN
  Adding_OnAfterEdIns();
  L_General.CallUs(L_Adding.Adding_EditMode());
  L_Adding.Adding_SavePrvAsPValues();
  _ShtDone();
 END {Adding_OnAfterEdit};

 PRIVATE PROCEDURE Adding_OnAfterInsert();
 BEGIN
  Adding_OnAfterEdIns();
  IF L_Adding.Adding_EditMode() THEN
   L_Adding.Adding_SaveEmptyPrv();
  END;
  _ShtDone();
 END {Adding_OnAfterInsert};

 PRIVATE PROCEDURE Adding_OnBeforeDelete();
  VAR
   fromEDOrder: SCAL[2];
 BEGIN
  CheckSource();
  fromEDOrder:=~L_Adding.Adding_EditMode();
  IF ~fromEDOrder THEN
   L_Adding.Adding_SaveEmptyPrv();
  END;
  _ShtDone();
  IF fromEDOrder (* ᪮ _ShtDone  L_Adding.IsSaved *) THEN
   L_Adding.Adding_SavePrvAsAdding();
  END;
 END {Adding_OnBeforeDelete};

 PUBLIC PROCEDURE EDOrderL_OnAfterInsert();
 BEGIN
  wSetAffectTo:=1;
  Adding_OnAfterInsert();
 END {EDOrderL_OnAfterInsert};

 PUBLIC PROCEDURE EDOrderL_OnBeforeDelete();
 BEGIN
  Adding_OnBeforeDelete();
 END {EDOrderL_OnBeforeDelete};

 PRIVATE PROCEDURE Adding_1_OnSetSubwindow();
 BEGIN
  RTI.Get().CurZone.HasVariousSubwindows:=1;
  L_EDO.gbo_SetSubwindow("");
 END {Adding_1_OnSetSubwindow};

 PUBLIC PROCEDURE scs_GetFilters_Adding_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "騥  ⥪饬 ", "(Adding.From<=Memo.MonthE) & (Adding.UpTo>=Memo.MonthB)", 1);
 END {scs_GetFilters_Adding_1};

 PRIVATE PROCEDURE Adding_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeEdit, L_WDO.e_OnSetSubwindow]);
  L_WDO.iMayBeEmpty  (1, ["Adding.UpTo"]);
 END {Adding_OnInitializeWindow};

 PRIVATE PROCEDURE AddKind_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterEdit, L_WDO.e_OnAfterInsert]);
  L_WDO.iMayBeEmpty  (1, ["AddKind.Till"]);
  L_WDO.iField       (1, "AddKind.ValType").Format:=L_Adding.vt_Pool;
  L_WDO.iProgs       (1, "Adding");
 END {AddKind_OnInitializeWindow};

 PRIVATE PROCEDURE AddKind_OnAfterEdIns();
 BEGIN
  L_DBD.CheckValidity("AddKind");
 END {AddKind_OnAfterEdIns};

 PRIVATE PROCEDURE AddKind_OnAfterInsert();
 BEGIN
  AddKind_OnAfterEdIns();
 END {AddKind_OnAfterInsert};

 PRIVATE PROCEDURE AddKind_OnAfterEdit();
 BEGIN
  AddKind_OnAfterEdIns();
 END {AddKind_OnAfterEdit};

BEGIN
 wSetAffectTo:=0;
 L_Events.ExecuteHandler();
END.
