(*
%Copyright   (c) Polak Computer System
%Author      06.07.2001 22:47:23 GINA
%Purpose     PASTE  Add_Doc - dbf 䠩   ஦
%Type        to_paste
%Specific    SYS
%Modified    24.04.2012 15:18:36 POLAK\GAV
%Environment
*)

 IMPORT DBF, Str, FIO, L_PDoc, L_General, L_Man, L_DatTim, E_PDoc,
        L_EC, DBD, L_PayP, L_FIO, L_Russia, L_Excel;

 CONST
  _FNP = "packet_p";
  SavePath = "REP\PACKET";
  WorkPath = "REP\TO_BVZR";

 VAR
  TotSum      : NUMERIC[2];
  Count       : NUMERIC[0];
  ptrFileName,
  trnFileName : STRING[];

  objXL,
  objWB,
  objWS       : OBJECT;
  xlsFileName : STRING[];


(*------ Subsidiary procedures -------------------------------------*)

 PRIVATE PROCEDURE GetAdrStr(_Man: LIKE(Man.Man); D: DATE): STRING[];
  VAR
   S: STRING[];
 BEGIN
  S:=L_Man.GetAdr_asShortStr(_Man, D, L_Russia.at_RgMA);
  RETURN Str.Slice(S, Str.Pos(S, ",")+2, Str.Length(S));
 END {GetAdrStr};

(*------------------------------------------------------------------*)

 PRIVATE PROCEDURE E_ADP_BVZR_NeedAdd_Doc(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PDoc.ADP_BVZR_NeedAdd_Doc), 1);
 END {E_ADP_BVZR_NeedAdd_Doc};

 PRIVATE PROCEDURE E_ADP_BVZR_ExcelForm(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PDoc.ADP_BVZR_ExcelForm), 0);
 END {E_ADP_BVZR_ExcelForm};

 PUBLIC PROCEDURE GetItemForIndex(): STRING[250];
 BEGIN
  RETURN "Deduct.Person";
 END {GetItemForIndex};

 PUBLIC PROCEDURE MayCreateInAutoMode(): SCAL[2];
 BEGIN
  RETURN ~L_PDoc.IsSingleTSN_PDoc() & E_ADP_BVZR_NeedAdd_Doc(SYSDATE());
 END {MayCreateInAutoMode};

 PUBLIC PROCEDURE PrologForDeduct();
 BEGIN
  L_General.Error("祭 ⥦ " + PayP.PayP + " " + PayP.Name + "." +
                  "|饭 ᮧ . 㬥⮢  筮 㤥ঠ");
 END {PrologForDeduct};

 PUBLIC PROCEDURE EpilogForDeduct();
 BEGIN
 END {EpilogForDeduct};

 PRIVATE PROCEDURE GetPDocFileName(s: STRING[3]): STRING[8];
 BEGIN
  RETURN s+Str.Slice(PDoc.PDoc, Str.Length(PDoc.PDoc)-5, 5);
 END {GetPDocFileName};

 PROCEDURE E_ClientBankUploadNameForAdd_Doc(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_PDoc.ClientBankUploadNameForAdd_Doc), "packet");
 END {E_ClientBankUploadNameForAdd_Doc};

 PRIVATE PROCEDURE E_VTYPEFieldForAdd_Doc(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_PDoc.VTYPEFieldForAdd_Doc), "003");
 END {E_VTYPEFieldForAdd_Doc};

 PRIVATE PROCEDURE E_PASPORTFieldForAdd_Doc(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_PDoc.PASPORTFieldForAdd_Doc), Man.PspSer+"  "+Man.PspNbr+" 뤠 "+L_DatTim.DateStr(Man.PspGiveD)+" "+Man.PspGiveS);
 END {E_PASPORTFieldForAdd_Doc};

 PUBLIC PROCEDURE PrologForPDoc();
  VAR
   curCB: NUMERIC[0];
 BEGIN
  IF E_ADP_BVZR_ExcelForm(PDoc.Date) THEN
   curCB:=L_PDoc.CB_GetPDocClientBank(PDoc.PDocKind, PDoc.PDoc);
   xlsFileName:=FIO.BuildPath(FIO.MakePath(E_ClientBankUploadNameForAdd_Doc(SYSDATE()),
                                           "xls",
                                           E_PDoc.ClientBankUploadPathForAdd_Doc(curCB)),
                              ,
                              FIO.AsbSpecialFolders("ClientProjectRoot"));
   IF (curCB # 0) & FIO.Exists(xlsFileName) THEN
    L_StdFrm.Choice("  䠩 " + xlsFileName +
                    "| 㤥 㤠  ᮧ ." +
                    "|,     ଠ  ।  ");
   END;
 
   L_General.Assert(L_Excel.ExcelInstalled(), " ⠭ MS Excel");
 
   objXL:=CreateOBJECT("Excel.Application");
   objXL.ScreenUpdating:=L_Excel.xlFalse;
   objWB:=L_Excel.NewWorkbook(objXL, 1);
   objWS:=L_Excel.NewWorksheet(objWB, 0, "1");
   L_Excel.ws_Init(objWS);
   objWS.Cells(1, 1).EntireColumn.NumberFormat:="@";
   objWS.Cells(1, 2).EntireColumn.NumberFormat:="@";
  ELSE
   ptrFileName:=FIO.MakePath(_FNP, "DBF", "TXT");
   L_General.Assert(FIO.Exists(ptrFileName), " 䠩-蠡 "+ptrFileName);
   FIO.Open(Dbf_P, ptrFileName, , Input);
   Count:=0; TotSum:=0;
 
   curCB:=L_PDoc.CB_GetPDocClientBank(PDoc.PDocKind, PDoc.PDoc);
 
   trnFileName:=L_PDoc.E_FileNameForAdd_Doc(PDoc.Date,
                                            curCB,
                                            FIO.MakePath(GetPDocFileName("pac"), "dbf", WorkPath));
 
   IF (curCB # 0) & FIO.Exists(trnFileName) THEN
    STDMSG("  䠩 " + trnFileName+"| 㤥 㤠  ᮧ .|,     ଠ  ।  ", CHOICE);
   END;
   FIO.Open(Dbf, trnFileName, , Create); (*ᮧ*)
   FIO.Copy(Dbf_P, Dbf);
   FIO.Close(Dbf_P);
   FIO.Close(Dbf);
   DBF.Open(Dbf, trnFileName, Output); (*  dbf*)
   DBF.SetAmount(Dbf, 0);            (**)
   DBF.SetAmount(Dbf, 1);
  END; (*   IF E_ADP_BVZR_ExcelForm(PDoc.Date) *)
 END {PrologForPDoc};

 PUBLIC PROCEDURE EpilogForPDoc();
  VAR
   checkFileName,
   saveFileName,
   tFileName,
   tPath         : STRING[];
 BEGIN
  IF E_ADP_BVZR_ExcelForm(PDoc.Date) THEN
   objWS.UsedRange.EntireColumn.AutoFit();
   TRY
    objWB.SaveAs(xlsFileName);
   EXCEPT
   ELSE
   END;
   objXL.Visible       :=L_Excel.xlTrue;
   objXL.ScreenUpdating:=L_Excel.xlTrue;
  ELSE
   DBF.Close(Dbf);
   L_General.Assert(TotSum = PDoc.Total, " ᮢ 㬬:|"+
                                         "         "+FLDTOSTR(PDoc.Total, "2.", 0)+
                                         "  "+FLDTOSTR(TotSum, "2.", 0));
   saveFileName:=FIO.MakePath(GetPDocFileName(FLDTOSTR(PDoc.Date, "Y_", 3)), "DBF", L_FIO.MakeDir(SavePath));
   IF FIO.Exists(saveFileName) THEN
    STDMSG("  䠩 " + saveFileName, CHOICE);
   END;
   L_FIO.FileCopy(trnFileName, saveFileName);
   IF Str.Cap(DBD.BaseName()) = "SP" THEN
    checkFileName:="Kntrsumm";
   ELSE
    checkFileName:=GetPDocFileName("Knt");
   END;
   FIO.SplitPath(trnFileName, tFileName, , tPath);
   checkFileName:=FIO.MakePath(checkFileName, "txt", tPath);
 
   FIO.Open(Tmp, checkFileName, , Create);
   FIO.WrStr(Tmp, " "+tFileName+" ᮤন "+FLDTOSTR(Count, "0", 0) + " " +
                  Str.EnumObject(Count, "||ᥩ") +
                  "  㬬 "+FLDTOSTR(PDoc.Total, "2.", 0));
   FIO.Close(Tmp);
  END; (*   IF E_ADP_BVZR_ExcelForm(PDoc.Date) *)
 END {EpilogForPDoc};

 PUBLIC PROCEDURE CreateDocument();
  VAR
   Sum : NUMERIC[2] [L_PayP.MaxSumAmnt];
   _Sum: LIKE(PDocList.Sum);
 BEGIN
  SEARCH(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc, Deduct.TSN);
  PROMPT(" ⥫쭮 㬥: "+PDocList.TSN);

  IF E_ADP_BVZR_ExcelForm(PDoc.Date) THEN
   L_Excel.ws_WrStr(objWS, Str.Cap(Deduct.Person));
   L_Excel.ws_WrStr(objWS, Deduct.PCode);
   IF L_PDoc.IsSalPDoc() THEN
    _Sum:=PDocList.Sum;
   ELSE
    L_PayP.GetDedAcntDebts(Sum[0], Sum[1]);
    _Sum:=Sum[0]+Sum[1];
   END;
   L_Excel.ws_WrNum(objWS, _Sum);
   L_Excel.ws_TermLine(objWS);
  ELSE
   DBF.SetAmount(Dbf, Count+1);
   DBF.Seek(Dbf, Count);
 
   DBF.SetField(Dbf, "FIOOWNER", Str.Cap(Deduct.Person));
   DBF.SetField(Dbf, "PASPORT",  E_PASPORTFieldForAdd_Doc(PDoc.Date));
 (*
   DBF.SetField(Dbf, "ADDRESS",  GetAdrStr(Man.Man, SYSDATE()));
   IF L_Man.AccessManAdr(Man.Man, SYSDATE(), L_Russia.at_RgMA) THEN
    DBF.SetField(Dbf, "INDEX",   ManAdr.Zip);
   END;
   IF ~!Man.Telephon THEN
    DBF.SetField(Dbf, "PHONENM", Man.Telephon);
   END;
 *)
   DBF.SetField(Dbf, "VTYPE", E_VTYPEFieldForAdd_Doc(PDoc.Date));
   DBF.SetField(Dbf, "ACCOUNT", Deduct.PCode);
   IF L_PDoc.IsSalPDoc() THEN
    _Sum:=PDocList.Sum;
   ELSE
    L_PayP.GetDedAcntDebts(Sum[0], Sum[1]);
    _Sum:=Sum[0]+Sum[1];
   END;
   INC(TotSum, _Sum);
   DBF.SetField(Dbf, "CASHVAL", _Sum);
 
   DBF.SetDeleted(Dbf, 0);
   DBF.Update(Dbf);
   INC(Count);
  END; (*   IF E_ADP_BVZR_ExcelForm(PDoc.Date) *)
 END {CreateDocument};

END.
