(*
%Copyright   (c) Polak IT
%Author      12.05.2003 09:57:10 POLAK\LDA
%Purpose     PASTE  Add_Doc - txt 䠩  ࠭ᡠ
%Type        to_paste
%Specific    SYS
%Modified    06.07.2011 18:21:45 POLAK\LDA
%Environment
*)

 IMPORT FIO, Str, L_General, L_PDoc, L_Money, E_PDoc, L_Man, L_EC, L_PayP, L_Str;

 CONST
  FileName_P = "MTB";

 PROCEDURE GetItemForIndex(): STRING[250];
 BEGIN
  RETURN "Deduct.Person";
 END {GetItemForIndex};

 PROCEDURE MayCreateInAutoMode(): SCAL[2];
 BEGIN
  RETURN ~L_PDoc.IsSingleTSN_PDoc();
 END {MayCreateInAutoMode};

 PROCEDURE GetFileName(): STRING[];
 BEGIN
  RETURN FIO.MakePath(FileName_P + Str.Delete(PDoc.PDoc, 0, 4),
                      "TXT",
                      L_EC.ExecE_Func_String(SYSDATE(), PROCREF(E_PDoc.b_MTB_ExchangeDir),
                                             "REP\TO_BANK"));
 END {GetFileName};

 PROCEDURE PrologForPDoc();
  VAR
   FileName: STRING[];
 BEGIN
  FileName:=GetFileName();
  IF FIO.Exists(FileName) THEN
   STDMSG("  䠩 " + FileName, CHOICE);
  END;
  FIO.Open(F, FileName, , Create);
 END {PrologForPDoc};

 PROCEDURE AddStr(_Value: STRING[];
                  Size  : NUMERIC[0];
                  Alignment: STRING[]): STRING[];
 BEGIN
  RETURN Str.Align(_Value, Size, ^Alignment);
 END {AddStr};

 PROCEDURE EpilogForPDoc();
 BEGIN
  FIO.WrStr(F, "_____________________________________________________________________________________________");
  FIO.WrLn(F);
  FIO.WrStr(F, AddStr(":",                       8, "RIGHT") +
               AddStr(FLDTOSTR(PDoc.Total, "2.", 0), 31, "RIGHT"));
  FIO.Close(F);
  STDMSG("ନ஢ 䠩 " + GetFileName(), INFORM);
 END {EpilogForPDoc};

 PROCEDURE CreateDocument();
  VAR
   Sum       : NUMERIC[2] [L_PayP.MaxSumAmnt];
   _Sum      : LIKE(PDocList.Sum);
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  L_General.ConsultToUs(SELECT(PDocList, PDoc, PDoc.PDocKind, PDoc.PDoc, Deduct.TSN),
                        "Adp_MTB.CreateDocument: Error 5");
  PROMPT("ࠡ⪠: " + Deduct.TSN);
  IF L_PDoc.IsSalPDoc() THEN
   _Sum:=PDocList.Sum;
  ELSE
   L_PayP.GetDedAcntDebts(Sum[0], Sum[1]);
   _Sum:=Sum[0]+Sum[1];
  END;
  L_Str.SplitManName(Deduct.Person, Surname, FirstName, Patronymic);
  FIO.WrStr(F,  AddStr(Deduct.PCode,                    22, "RIGHT") +
                AddStr(FLDTOSTR(_Sum,         "2.", 0), 17, "RIGHT") +
                "   " +
                AddStr(Surname, 16, "LEFT") +
                AddStr(FirstName, 15, "LEFT") +
                Patronymic);
  FIO.WrLn(F);
 END {CreateDocument};

END.
