(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose     PASTE  Add_Doc - ⮢ ॢ
%Type        to_paste
%Specific    SYS
%Modified    14.05.2013 21:21:50 POLAK\Gina
%Environment
%Codepage    866
*)

 IMPORT L_Money, P_Firm, L_Str, L_DatTim, L_EC, E_PDoc, L_PayP, Str, L_MSO, L_ctc;

 VAR
  _SYSDATE : DATE;
  _SYSTIME : TIME;
  _Debt    : LIKE(DedAcnt.TotDebt);
  PayStrByMon: STRING[];

  PayStrByWord : STRING[89];
  _ToPayStr: STRING[8];
  SrcObj1,
  SrcAdr1  : STRING[];
  SrcObj2,
  SrcAdr2,
  DstObj2  : STRING[];
  DstAdr2  : STRING[];
  SrcBnRq  : STRING[];

 PROCEDURE GetItemForIndex(): STRING[250];
 BEGIN
  RETURN "Deduct.PAddr[0]";
 END {GetItemForIndex};

 PROCEDURE MayCreateInAutoMode(): SCAL[2];
 BEGIN
  RETURN 0;
 END {MayCreateInAutoMode};

(*------------------------------------------------------------------*)

 PROCEDURE InformMess(ObjName: STRING[]);
 BEGIN
  STDMSG("ன ਭ  |" + ObjName, INFORM);
 END {InformMess};

 PROCEDURE PrologForPDoc();
 BEGIN
  InformMess("⮢ ॢ ⠥   ஭ ");
 END {PrologForPDoc};

 PROCEDURE EpilogForPDoc();
 BEGIN
 END {EpilogForPDoc};

 PROCEDURE PrologForDeduct();
 BEGIN
  InformMess("⮢ ॢ ⠥   ஭ ");
 END {PrologForDeduct};

 PROCEDURE EpilogForDeduct();
 BEGIN
 END {EpilogForDeduct};

 PROCEDURE E_ADP_POST_OnA5(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_PDoc.ADP_POST_OnA5), 0);
 END {E_ADP_POST_OnA5};

 PROCEDURE CutIndex(VAR Adr, Idx: STRING[]);
  VAR
   _Idx: STRING[6];
 BEGIN
  _Idx:=Adr;
  IF L_Str.TestStrAlowChar(_Idx, "09") THEN
   Adr:=Str.Slice(Adr, 7, Str.Length(Adr));
  ELSE
   SETEMPTY(_Idx);
  END;
  Idx:=_Idx;
 END {CutIndex};

 PROCEDURE PreparePstObjects();
  VAR
   Collect,
   Transfer: NUMERIC[2];
   _Firm   : LIKE(Firm.Firm);
   _Name: STRING[];
   _Bank: STRING[];
   _Acnt: STRING[][2];
   _BIC_: STRING[];
   _INN_: STRING[];
   DstINN: STRING[];
   DstIdx,
   SrcIdx1,
   SrcIdx2: STRING[6];
   wCmpByBIC: SCAL[2];
 BEGIN
  L_MSO.wordSetVarsByFile_wPrefixE("Deduct",   "Pst.", ~OCCURE(Deduct));
  L_MSO.wordSetVarsByFile_wPrefixE("DedAcnt",  "Pst.", ~OCCURE(DedAcnt));

  _SYSDATE:=SYSDATE();
  _SYSTIME:=SYSTIME();
  IF P_Firm.E_wMultipleMyFirm(_SYSDATE) THEN
   _Firm:=P_Firm.fomf(Staff.MyFirm);
  ELSE
   _Firm:=P_Firm.OWN_FIRM;
  END;
  L_MSO.wordSetVar("Pst.Firm", _Firm);

  CONFORM(Deduct, PayP);
  L_MSO.wordSetVarsByFile_wPrefixE("PayP",   "Pst.", ~OCCURE(PayP));
  L_PayP.GetDedAcntDebts(Transfer, Collect);
  PayStrByMon :=L_Money.MoneyToSpecStr(L_DatTim.Per(_SYSDATE), "", Transfer);
  L_MSO.wordSetVar("Pst.PayStrByMon", PayStrByMon);
  PayStrByWord:=L_Money.ByWord(Transfer);
  L_MSO.wordSetVar("Pst.PayStrByWord", PayStrByWord);
  SrcObj1:=P_Firm.FP_FirmShortName(_Firm, _SYSDATE);
  SrcAdr1:=L_ctc.GetAdr_Fct(_SYSDATE, _Firm);
  SrcObj2:=P_Firm.FP_FirmShortName(_Firm, _SYSDATE);
  SrcAdr2:=L_ctc.GetAdr_Fct(_SYSDATE, _Firm);
  DstObj2:=Deduct.Person;
  DstAdr2:=Deduct.PAddr[0]+" "+Deduct.PAddr[1];
  SrcBnRq:=P_Firm.FP_BankReq(_Firm, _SYSDATE);
  P_Firm.PositionOnMyFirm(_Firm);
  P_Firm.GetFirmData(_SYSDATE, _Name, _Bank, _Acnt, _BIC_, _INN_, 1);
  L_MSO.wordSetVar("Pst._Bank", _Bank);
  L_MSO.wordSetVar("Pst._Acnt[0]", _Acnt[0]);
  L_MSO.wordSetVar("Pst._Acnt[1]", _Acnt[1]);
  L_MSO.wordSetVar("Pst._BIC_", _BIC_);
  L_MSO.wordSetVar("Pst._INN_", _INN_);

  CutIndex(DstAdr2, DstIdx);
  CutIndex(SrcAdr1, SrcIdx1);
  CutIndex(SrcAdr2, SrcIdx2);

  L_MSO.wordSetVar("Pst.DstIdx",  DstIdx);
  L_MSO.wordSetVar("Pst.SrcIdx1", SrcIdx1);
  L_MSO.wordSetVar("Pst.SrcIdx2", SrcIdx2);
  L_MSO.wordSetVar("Pst.SrcObj1", SrcObj1);
  L_MSO.wordSetVar("Pst.SrcObj2", SrcObj2);
  L_MSO.wordSetVar("Pst.SrcAdr1", SrcAdr1);
  L_MSO.wordSetVar("Pst.SrcAdr2", SrcAdr2);
  L_MSO.wordSetVar("Pst.DstObj2", DstObj2);
  L_MSO.wordSetVar("Pst.DstAdr2", DstAdr2);
  L_MSO.wordSetVar("Pst.SrcBnRq", SrcBnRq);
  L_MSO.wordSetVar("Pst.PayPer" , FLDTOSTR(DedAcnt.Period, "N.y"));

  L_MSO.wordSetVar("Pst.PayMan" , L_Str.ShortName(Man.Name));

  IF DedType.BaseNo # 0 THEN   (* 業 㤥ঠ *)
   _ToPayStr:="(" + FLDTOSTR(DedAcnt.ToPay, "2.", 5) + "%)";
  ELSE
   _ToPayStr:="";
  END;
  L_MSO.wordSetVar("Pst._ToPayStr", _ToPayStr);
 END {PreparePstObjects};

 PROCEDURE CreateDocument();
 BEGIN
  L_MSO.wordInitDocument(SYSDATE());
  L_MSO.IsDuplexDoc:=1;

  PreparePstObjects();
  L_MSO.MakeWordDocument("F112ef", 1, L_MSO.PrpMode_Print, "");
 END {CreateDocument};

END.
