(*
%Copyright   (c) Polak Computer System
%Author      POLAK\GAV
%Purpose     PASTE  Add_Doc - ⮢ 䠩  ᡥઠ
%Type        to_paste
%Specific    SYS
%Modified    10.04.2012 08:41:29 POLAK\LDA
%Environment
*)

 IMPORT L_DatTim, L_General, L_PDoc, L_Man, Str, FIO, P_Firm, Add_Doc,
        DBF, L_Str, L_EC, E_PDoc, L_PayP, L_FIO;

 CONST
  _FNP = "sbnkroll";
  Path = "REP\PACKET";

 VAR
  Count    : NUMERIC[0];
  _FileName_P,
  _FileName: STRING[];
  TotSum   : NUMERIC[2];

 PROCEDURE GetItemForIndex(): STRING[];
 BEGIN
  RETURN "Deduct.PCode";
 END {GetItemForIndex};

 PROCEDURE MayCreateInAutoMode(): SCAL[2];
 BEGIN
  RETURN ~L_PDoc.IsSingleTSN_PDoc();
 END {MayCreateInAutoMode};

(*------ Empty procedures ------------------------------------------*)

 PROCEDURE PrologForPayP();
 BEGIN
 END {PrologForPayP};

 PROCEDURE EpilogForPayP();
 BEGIN
 END {EpilogForPayP};

 PROCEDURE EpilogForDeduct();
 BEGIN
 END {EpilogForDeduct};

(*------------------------------------------------------------------*)

 PROCEDURE AddComent(Text: STRING[]);
 BEGIN
  FIO.WrLn(P);
  FIO.WrStr(P, ";" + Text);
 END {AddComent};

 PROCEDURE PrologForDeduct();
 BEGIN
  L_General.Error("祭 ⥦ "+PayP.PayP+" "+PayP.Name+"|饭 ᮧ .㬥⮢  筮 㤥ঠ");
 END {PrologForDeduct};

 PROCEDURE FirmAcntBankRegion(_Date: DATE): LIKE(BankLog.Region);
 BEGIN
  IF ~!FirmAcnt.BankBrn THEN
   CONFORM(FirmAcnt, BankBrn);
   HISTCONF(_Date, BankBrn, BankBrnL);
   IF ~!BankBrnL.Region THEN
    RETURN BankBrnL.Region;
   END;
  END; (* IF ~!FirmAcnt.BankBrn... *)
  CONFORM(FirmAcnt, Bank);
  HISTCONF(_Date, Bank, BankLog);
  IF OCCURE(BankLog) THEN
   RETURN BankLog.Region;
  END;
  RETURN "";
 END {FirmAcntBankRegion};

 PROCEDURE EncodeDate(D: DATE): STRING[3];
  VAR
   days, i, v: NUMERIC[0];
   r: STRING[];
 BEGIN
  i:=0;
  r:="";
  days:=D - 01\01\2007;
  WHILE i < 3 DO
   v:=days MOD (10+26);
   days:=days DIV (10+26);
   IF v <= 9 THEN
    r:=L_Str.IntStr(v)+r;
   ELSE
    r:=CHR(ORD("A")+v-10)+r;
   END;
   INC(i);
  END;
  L_General.ConsultToUs(days = 0, " 㦥  祬 '姭'");
  RETURN r;
 END {EncodeDate};

 PROCEDURE PrologForPDoc();
  VAR
   _Depart: STRING[];
 BEGIN
  _Depart:=P_Firm.GetDepart(Firm.Firm, PDoc.Date);
  L_General.Assert(Str.Length(_Depart) = 4,
                   " 䨫 ⤥ ࡠ|" +
                   " ࠧ     ");
  CONFORM(PDoc, FirmAcnt);
  IF Str.Match(Str.Cap(FirmAcntBankRegion(PDoc.Date)), "**") THEN
   _FileName:="f";
  ELSE
   _FileName:="t";
  END;
  _FileName:=FIO.MakePath(_FileName + _Depart + EncodeDate(PDoc.Date), "DBF", Path);
  IF FIO.Exists(_FileName) THEN
   STDMSG("  䠩 " + _FileName+
          "| 㤥 㤠  ᮧ ." +
          "|,     ଠ  ।  ", CHOICE);
  END;

  _FileName_P:=FIO.MakePath(_FNP, "DBF", "TXT");
  L_FIO.FileCopy(_FileName_P, _FileName);
  DBF.Open(Dbf, _FileName, Output); (*  dbf*)
  DBF.SetAmount(Dbf, 0);            (**)
  DBF.SetAmount(Dbf, 6);

  DBF.Seek(Dbf, 0);
  DBF.SetField(Dbf, "A", P_Firm.FP_ContractorBriefName(Firm.Firm, PDoc.Date));
  DBF.SetField(Dbf, "B", "");
  DBF.SetField(Dbf, "C", "");
  DBF.SetField(Dbf, "D", "");
  DBF.SetField(Dbf, "E", "");
  DBF.SetField(Dbf, "F", "");
  DBF.SetField(Dbf, "G", "");
  DBF.SetDeleted(Dbf, 0);
  DBF.Update(Dbf);

  DBF.Seek(Dbf, 1);
  DBF.SetField(Dbf, "A", " ⥦ 祭 ");
  DBF.SetField(Dbf, "B", PDoc.SrcNbr);
  DBF.SetField(Dbf, "C", "");
  DBF.SetField(Dbf, "D", L_DatTim.DateStr(PDoc.Date));
  DBF.SetField(Dbf, "E", "");
  DBF.SetField(Dbf, "F", "");
  DBF.SetField(Dbf, "G", "");
  DBF.SetDeleted(Dbf, 0);
  DBF.Update(Dbf);

  DBF.Seek(Dbf, 2);
  DBF.SetField(Dbf, "A", "᫥");
  DBF.SetField(Dbf, "B", "01");
  DBF.SetField(Dbf, "C", "");
  DBF.SetField(Dbf, "D", "");
  DBF.SetField(Dbf, "E", "");
  DBF.SetField(Dbf, "F", "");
  DBF.SetField(Dbf, "G", "");
  DBF.SetDeleted(Dbf, 0);
  DBF.Update(Dbf);

  DBF.Seek(Dbf, 3);
  DBF.SetField(Dbf, "A", " (),  ᪮  । (࣠樨)"); (* ॡ ଠ -   C30  70 㪢*)
  P_Firm.AccessOwnFirm(PDoc.MyFirm);
  DBF.SetField(Dbf, "B", P_Firm.FP_ContractorBriefName(Firm.Firm, PDoc.Date) + ", " +
                         P_Firm.FP_OGRN(Firm.Firm, PDoc.Date));
  L_PDoc.AccessPDocOwnFirmAcnt();
  DBF.SetField(Dbf, "C", FirmAcnt.AcntA);
  DBF.SetField(Dbf, "D", "");
  DBF.SetField(Dbf, "E", "");
  DBF.SetField(Dbf, "F", "");
  DBF.SetField(Dbf, "G", "");
  DBF.SetDeleted(Dbf, 0);
  DBF.Update(Dbf);

  DBF.Seek(Dbf, 4);
  DBF.SetField(Dbf, "A", " :");
  DBF.SetField(Dbf, "B", L_EC.ExecE_Func_String(PDoc.Date, PROCREF(E_PDoc.ADP_SBN1_ContractNbr), ""));
  DBF.SetField(Dbf, "C", "");
  DBF.SetField(Dbf, "D", L_EC.ExecE_Func_String(PDoc.Date, PROCREF(E_PDoc.ADP_SBN1_ContractDateStr), ""));
  DBF.SetField(Dbf, "E", "");
  DBF.SetField(Dbf, "F", "");
  DBF.SetField(Dbf, "G", "");
  DBF.SetDeleted(Dbf, 0);
  DBF.Update(Dbf);

  DBF.Seek(Dbf, 5);
  DBF.SetField(Dbf, "A", " /");
  DBF.SetField(Dbf, "B", " ");
  DBF.SetField(Dbf, "C", "");
  DBF.SetField(Dbf, "D", "");
  DBF.SetField(Dbf, "E", "⢮");
  DBF.SetField(Dbf, "F", "㬬");
  DBF.SetField(Dbf, "G", "ਬ砭");
  DBF.SetDeleted(Dbf, 0);
  DBF.Update(Dbf);
  Count:=0; TotSum:=0;
 END {PrologForPDoc};

 PROCEDURE EpilogForPDoc();
 BEGIN
  L_General.ConsultToUs(TotSum = PDoc.Total, " ᮢ 㬬:|"+
                                             "         "+FLDTOSTR(PDoc.Total, "2.", 0)+
                                             "  "+FLDTOSTR(TotSum, "2.", 0));
  DBF.SetAmount(Dbf, Count+1+6);
  DBF.Seek(Dbf, Count+6);

  DBF.SetField(Dbf, "A", "");
  DBF.SetField(Dbf, "B", ":");
  DBF.SetField(Dbf, "C", "");
  DBF.SetField(Dbf, "D", "");
  DBF.SetField(Dbf, "E", "");
  DBF.SetField(Dbf, "F", FLDTOSTR(PDoc.Total, "2.", 0));
  DBF.SetField(Dbf, "G", "");

  DBF.SetDeleted(Dbf, 0);
  DBF.Update(Dbf);
  DBF.Close(Dbf);
 END {EpilogForPDoc};

 PROCEDURE CreateDocument();
  VAR
   Sum       : NUMERIC[2] [L_PayP.MaxSumAmnt];
   _Sum      : LIKE(PDocList.Sum);
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  SEARCH(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc, Deduct.TSN);
  PROMPT(" ⥫쭮 㬥 "+_FileName+": "+PDocList.TSN);
  DBF.SetAmount(Dbf, Count+1+6);
  DBF.Seek(Dbf, Count+6);

  DBF.SetField(Dbf, "A", L_Str.IntStr(Count+1));
  DBF.SetField(Dbf, "B", Deduct.PCode);
  L_Str.SplitManName(Deduct.Person, Surname, FirstName, Patronymic);
  DBF.SetField(Dbf, "C", Surname);
  DBF.SetField(Dbf, "D", FirstName);
  DBF.SetField(Dbf, "E", Patronymic);
  IF L_PDoc.IsSalPDoc() THEN
   _Sum:=PDocList.Sum;
  ELSE
   L_PayP.GetDedAcntDebts(Sum[0], Sum[1]);
   _Sum:=Sum[0]+Sum[1];
  END;
  INC(TotSum, _Sum);
  DBF.SetField(Dbf, "F", FLDTOSTR(_Sum, "2.", 0));
  DBF.SetField(Dbf, "G", "");

  DBF.SetDeleted(Dbf, 0);
  DBF.Update(Dbf);
  INC(Count);
 END {CreateDocument};

END.
