(*
%Copyright   (c) Polak IT
%Author      18.12.2008 19:06:57 POLAK\Gina
%Purpose     PASTE  Add_Doc - ⥪⮢ 䠩  ࡠ 
%Type        to paste
%Specific    LOC
%Modified    13.04.2012 01:05:59 POLAK\Gina
%Environment
*)

 IMPORT L_General, L_PDoc, L_Man, Str, FIO, L_PayP, L_Str, P_Firm, L_DatTim, E_PDoc, DBD;

 CONST
  WorkPath = "REP\TO_SBNK";

 VAR
  TotSum   : NUMERIC[2];
  Count    : NUMERIC[0];
  SbnDepart: STRING[];

 PUBLIC PROCEDURE GetItemForIndex(): STRING[];
 BEGIN
  RETURN "Deduct.PCode";
 END {GetItemForIndex};

 PUBLIC PROCEDURE MayCreateInAutoMode(): SCAL[2];
 BEGIN
  RETURN ~L_PDoc.IsSingleTSN_PDoc();
 END {MayCreateInAutoMode};

 PUBLIC PROCEDURE PrologForDeduct();
 BEGIN
  L_General.Error("祭 ⥦ " + PayP.PayP + " " + PayP.Name +
                  "|饭 ᮧ . 㬥⮢  筮 㤥ঠ");
 END {PrologForDeduct};

 PUBLIC PROCEDURE EpilogForDeduct();
 BEGIN
 END {EpilogForDeduct};

 PRIVATE PROCEDURE CheckSbrfDepart(SbnDep, Text: STRING[]);
 BEGIN
  L_General.Assert((Str.Length(SbnDep) = 4) & L_Str.TestStrAlowChar(SbnDep, "09"),
                   " 䨫 ⤥ ࡠ|" +
                   " ࠧ     .||" + Text);
 END {CheckSbrfDepart};

 PRIVATE PROCEDURE E_UploadNameForAdd_Doc(Ext: STRING[]): STRING[];
  VAR
   DefaultFileName: STRING[];
   Local          : PROC;
 BEGIN
  SbnDepart:=P_Firm.GetDepart(PDoc.Firm, PDoc.Date);
  CheckSbrfDepart(SbnDepart, "ࠣ " + PDoc.Firm + ", ᢮⢮ " + FLDTOSTR(P_Firm.P_Depart, "0", 0) +
                             "  " + L_DatTim.DateStr(PDoc.Date));
  DefaultFileName:=SbnDepart + L_Str.Right(PDoc.PDoc, 4) + "." + Ext + FLDTOSTR(PDoc.Date, "D", 2);
  Local:=PROCREF(E_PDoc.UploadNameForAdd_Doc);
  IF ~!Local THEN
   DefaultFileName:=Local(DefaultFileName);
  END;
  RETURN FIO.MakePath(DefaultFileName, , WorkPath);
 END {E_UploadNameForAdd_Doc};

 PRIVATE PROCEDURE Put(_S: STRING[]; _L: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Str.Align(_S, _L, LEFT);
 END {Put};

 PUBLIC PROCEDURE PrologForPDoc();
  VAR
   _FileName: STRING[];
 BEGIN
  _FileName:=E_UploadNameForAdd_Doc("S");
  FIO.Open(FlLst, _FileName, , Create);
  Count:=1; TotSum:=0;
 END {PrologForPDoc};

 PUBLIC PROCEDURE EpilogForPDoc();
  VAR
   OurCode,
   _FileName: STRING[];
 BEGIN
  FIO.WrLn(FlLst);
  FIO.Close(FlLst);
  L_General.ConsultToUs(TotSum = PDoc.Total, " ᮢ 㬬:" +
                                             "|         " + FLDTOSTR(PDoc.Total, "2.", 18) +
                                             "|  " + FLDTOSTR(TotSum, "2.", 18));
  _FileName:=E_UploadNameForAdd_Doc("K");

  OurCode:=P_Firm.GetOurCode(PDoc.Firm, PDoc.Date);
  L_General.Assert(L_Str.TestStrAlowChar(OurCode, "09"),
                   " 䨫 ⤥ ࡠ|" +
                   "'   '    .||" +
                   "ࠣ " + PDoc.Firm + ", ᢮⢮ " + FLDTOSTR(P_Firm.P_OurCode, "0", 0) +
                    "  " + L_DatTim.DateStr(PDoc.Date));
  OurCode:=L_Str.IntStr(STRTOFLD(OurCode, NUMERIC));

  FIO.Open(FlCnt, _FileName, , Create);
  FIO.WrStr(FlCnt, Put(P_Firm.FP_FirmShortName(P_Firm.fomf(PDoc.MyFirm), PDoc.Date), 30) +
                   Put(OurCode, 4) +
                   Put(FLDTOSTR(Count - 1, "0", 0), 7) +
                   Str.Align(FLDTOSTR(TotSum, "2.", 0), 15, RIGHT));
  FIO.WrLn(FlCnt);
  FIO.Close(FlCnt);
 END {EpilogForPDoc};

 PRIVATE PROCEDURE UnknownSign(): STRING[];
 BEGIN
  IF DBD.BaseName() = "84" THEN
   RETURN "48 1";
  ELSE
   RETURN "";
  END;
 END {UnknownSign};

 PUBLIC PROCEDURE CreateDocument();
  VAR
   Sum       : NUMERIC[2][L_PayP.MaxSumAmnt];
   _Sum      : LIKE(PDocList.Sum);
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  SEARCH(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc, Deduct.TSN);
  PROMPT(" ⥫쭮 㬥 : " + PDocList.TSN);
  IF Count # 1 THEN
   FIO.WrLn(FlLst);
  END;
  IF L_PDoc.IsSalPDoc() THEN
   _Sum:=PDocList.Sum;
  ELSE
   L_PayP.GetDedAcntDebts(Sum[0], Sum[1]);
   _Sum:=Sum[0] + Sum[1];
  END;
  CheckSbrfDepart(Deduct.PAddr[0],
                  ". " +Deduct.TSN + " 㤥ঠ  " + Deduct.DedNbr + ", .  ''");
  INC(TotSum, _Sum);
  L_Str.SplitManName(Deduct.Person, Surname, FirstName, Patronymic);
  FIO.WrStr(FlLst, Put(FLDTOSTR(Count, "0", 0), 10) +
                   Put(SbnDepart + Deduct.PAddr[0], 28) +      (*⤥ ࡠ*)
                   Put(Surname, 30) +
                   Put(FirstName, 30) +
                   Put(Patronymic, 35) +
                   Put(Deduct.PCode + UnknownSign(), 24) +
                   Str.Align(FLDTOSTR(_Sum, "2.", 0), 19, RIGHT) +
                   "810");
  INC(Count);
 END {CreateDocument};

END.