(*
%Copyright   (c) Polak IT
%Author      13.10.2011 12:33:59 POLAK\Gina
%Purpose      Add_Doc xml 䠩  ࡠ 
%Type        to paste
%Specific    SYS
%Modified    02.11.2012 11:44:11 POLAK\GAV
%Environment
*)

 IMPORT L_General, L_PDoc, Str, FIO, L_PayP, L_Str, P_Firm, L_DatTim, E_PDoc, L_StdFrm, L_XML, L_EC;

 CONST
  WorkPath = "REP\TO_SBNK";

 VAR
  TotSum   : NUMERIC[2];
  Count    : NUMERIC[0];
  SbnDepart: STRING[];
  rootNode,
  subNode0,
  subNode1 : L_XML.tNode;

 PUBLIC PROCEDURE GetItemForIndex(): STRING[];
 BEGIN
  RETURN "Deduct.PCode";
 END {GetItemForIndex};

 PUBLIC PROCEDURE MayCreateInAutoMode(): SCAL[2];
 BEGIN
  RETURN ~L_PDoc.IsSingleTSN_PDoc();
 END {MayCreateInAutoMode};

 PUBLIC PROCEDURE PrologForDeduct();
 BEGIN
  L_General.Error("祭 ⥦ " + PayP.PayP + " " + PayP.Name +
                  "|饭 ᮧ . 㬥⮢  筮 㤥ঠ");
 END {PrologForDeduct};

 PUBLIC PROCEDURE EpilogForDeduct();
 BEGIN
 END {EpilogForDeduct};

 PRIVATE PROCEDURE CheckSbrfDepart(SbnDep, Text: STRING[]);
 BEGIN
  L_General.Assert((Str.Length(SbnDep) = 4) & L_Str.TestStrAlowChar(SbnDep, "09"),
                   " 䨫 ⤥ ࡠ|" +
                   " ࠧ     .||" + Text);
 END {CheckSbrfDepart};

 PRIVATE PROCEDURE EncodeNum(n: NUMERIC[0]): STRING[3];
  VAR
   i, v: NUMERIC[0];
   r: STRING[];
 BEGIN
  i:=0;
  r:="";
  WHILE i < 3 DO
   v:=n MOD (10+26);
   n:=n DIV (10+26);
   IF v <= 9 THEN
    r:=L_Str.IntStr(v)+r;
   ELSE
    r:=CHR(ORD("A")+v-10)+r;
   END;
   INC(i);
  END;
  RETURN r;
 END {EncodeNum};

 PRIVATE PROCEDURE E_UploadNameForAdd_Doc(): STRING[];
  VAR
   trnFilePath,
   trnFileName: STRING[];
 BEGIN
  trnFilePath:=FIO.BuildPath(WorkPath, , FIO.AsbSpecialFolders("ClientProjectRoot"));
  SbnDepart:=P_Firm.GetDepart(PDoc.Firm, PDoc.Date);
  CheckSbrfDepart(SbnDepart, "ࠣ " + PDoc.Firm + ", ᢮⢮ " + FLDTOSTR(P_Firm.P_Depart, "0", 0) +
                             "  " + L_DatTim.DateStr(PDoc.Date));
  trnFileName:=SbnDepart + EncodeNum(PDoc.PDoc) + "z";
  trnFileName:=L_PDoc.E_FileNameForAdd_Doc(PDoc.Date,
                                           L_PDoc.CB_GetPDocClientBank(PDoc.PDocKind, PDoc.PDoc),
                                           FIO.MakePath(trnFileName, "xml", trnFilePath));
  RETURN trnFileName;
 END {E_UploadNameForAdd_Doc};

 PRIVATE PROCEDURE PosToFirmAcnt();
  VAR
   trgFirmAcnt: LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  trgFirmAcnt:=L_EC.ExecE_Func_String(PDoc.Date, PROCREF(E_PDoc.ADP_SBN1_ContractFirmAcnt), "");
  IF ~!trgFirmAcnt THEN
   P_Firm.CheckFirmAcnt(PDoc.Date, L_PDoc.GetPDocOwnFirm(), trgFirmAcnt);
  ELSE
   P_Firm.AccessSilentFirmAcnt(L_PDoc.GetPDocOwnFirm(), PDoc.Date);
  END;
 END {PosToFirmAcnt};

 PUBLIC PROCEDURE PrologForPDoc();
  VAR
   curFileName: STRING[];
 BEGIN
  curFileName:=E_UploadNameForAdd_Doc();
  IF FIO.Exists(curFileName) THEN
   L_StdFrm.Choice("  䠩 " + curFileName+
                   "| 㤥 㤠  ᮧ ." +
                   "|,     ଠ  ।  ");
  END;
  Count:=1; TotSum:=0;
  P_Firm.AccessOwnFirm(PDoc.MyFirm);
  rootNode:=L_XML.bd_Create("⠏");
  L_XML.bd_SetAttribute(rootNode, "⠔ନ஢", FLDTOSTR(SYSDATE(), "y-N-D", 10));
  L_XML.bd_SetAttribute(rootNode, "",
                        L_Str.ExclQM(L_EC.ExecE_Func_String(PDoc.Date, PROCREF(E_PDoc.ADP_SBN1_ContractNbr), "")));
  L_XML.bd_SetAttribute(rootNode, "࣠樨", L_Str.ExclQM(P_Firm.FP_ContractorBriefName(Firm.Firm, PDoc.Date)));
  L_XML.bd_SetAttribute(rootNode, "", P_Firm.FP_INN(Firm.Firm, PDoc.Date));
  PosToFirmAcnt();
  L_XML.bd_SetAttribute(rootNode, "멑࣠樨", FirmAcnt.AcntA);
  L_XML.bd_SetAttribute(rootNode, "", P_Firm.FirmAcntBIC(SYSDATE()));
  subNode0:=L_XML.bd_PutNode(rootNode, "᫥௫", "");
 END {PrologForPDoc};

 PUBLIC PROCEDURE EpilogForPDoc();
  VAR
   curFileName: STRING[];
 BEGIN
  L_General.Assert(TotSum = PDoc.Total, " ᮢ 㬬:" +
                                        "|         " + FLDTOSTR(PDoc.Total, "2.", 18) +
                                        "|  " + FLDTOSTR(TotSum, "2.", 18));

  curFileName:=E_UploadNameForAdd_Doc();
  subNode0:=L_XML.bd_PutNode(rootNode, "஫륑㬬", "");
  L_XML.bd_PutLeafNode(subNode0, "⢮ᥩ", FLDTOSTR(Count - 1, "0", 0));
  L_XML.bd_PutLeafNode(subNode0, "㬬⮣", FLDTOSTR(TotSum, "2.", 0));
  L_XML.bd_Save(L_XML.bd_GetDocument(rootNode), curFileName);

  L_StdFrm.Inform("ନ஢ 䠩 " + curFileName);
 END {EpilogForPDoc};

 PUBLIC PROCEDURE CreateDocument();
  VAR
   SumArr    : NUMERIC[2][L_PayP.MaxSumAmnt];
   curSum    : LIKE(PDocList.Sum);
   RcvDepart,
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  SEARCH(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc, Deduct.TSN);
  PROMPT(" ⥫쭮 㬥 : " + PDocList.TSN);
  IF L_PDoc.IsSalPDoc() THEN
   curSum:=PDocList.Sum;
  ELSE
   L_PayP.GetDedAcntDebts(SumArr[0], SumArr[1]);
   curSum:=SumArr[0] + SumArr[1];
  END;
  IF L_PDoc.IsActiveSpecDeduct(PDoc.Date) & !Deduct.PAddr[0] THEN
   RcvDepart:=SbnDepart;
  ELSE
   RcvDepart:=Deduct.PAddr[0];
   CheckSbrfDepart(RcvDepart,
                   ". " +Deduct.TSN + " 㤥ঠ  " + Deduct.DedNbr + ", .  ''");
  END;
  INC(TotSum, curSum);
  L_Str.SplitManName(Deduct.Person, Surname, FirstName, Patronymic);

  subNode1:=L_XML.bd_PutNode(subNode0, "㤭", "");
  L_XML.bd_SetAttribute(subNode1, "",                  FLDTOSTR(Count, "0", 0));
  L_XML.bd_PutLeafNode(subNode1,  "",              Surname);
  L_XML.bd_PutLeafNode(subNode1,  "",                  FirstName);
  L_XML.bd_PutLeafNode(subNode1,  "⢮",             Patronymic);
  L_XML.bd_PutLeafNode(subNode1,  "⤥",       SbnDepart);
  L_XML.bd_PutLeafNode(subNode1,  "⤥", RcvDepart);
  L_XML.bd_PutLeafNode(subNode1,  "楢",          Deduct.PCode);
  L_XML.bd_PutLeafNode(subNode1,  "㬬",                FLDTOSTR(curSum, "2.", 0));
  INC(Count);
 END {CreateDocument};

END.
