(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose     PASTE  Add_Doc - ⮢ 䠩  ᡥઠ
%Type        to_paste
%Specific    SYS
%Modified    10.04.2012 08:50:46 POLAK\LDA
%Environment
*)

 IMPORT L_DatTim, L_General, L_PDoc, L_Man, Str, FIO, P_Firm, Add_Doc, L_Str;

 VAR
  Count    : NUMERIC[0];
  _FileName: STRING[];

 PROCEDURE GetItemForIndex(): STRING[];
 BEGIN
  RETURN "Deduct.PCode";
 END {GetItemForIndex};

 PROCEDURE MayCreateInAutoMode(): SCAL[2];
 BEGIN
  RETURN ~L_PDoc.IsSingleTSN_PDoc();
 END {MayCreateInAutoMode};

 PROCEDURE GetYearCode(): STRING[1];
  VAR
   y: NUMERIC[0];
 BEGIN
  y:=L_DatTim.YEAR(PDoc.Date);
  IF y < 2000 THEN
   L_General.Assert(y>=1990, "誮 쪨 ");
   RETURN CHR(ORD("0")+y-1990);
  ELSE
   L_General.Assert(y<=2000+ORD("Z"), "誮 让 ");
   RETURN CHR(ORD("A")+y-2000);
  END;
 END {GetYearCode};

(*------ Empty procedures ------------------------------------------*)

 PROCEDURE PrologForPayP();
 BEGIN
 END {PrologForPayP};

 PROCEDURE EpilogForPayP();
 BEGIN
 END {EpilogForPayP};

 PROCEDURE EpilogForDeduct();
 BEGIN
 END {EpilogForDeduct};

(*------------------------------------------------------------------*)

 PROCEDURE AddComent(Text: STRING[]);
 BEGIN
  FIO.WrLn(P);
  FIO.WrStr(P, ";" + Text);
 END {AddComent};

 PROCEDURE PrologForDeduct();
 BEGIN
  L_General.Error("祭 ⥦ "+PayP.PayP+" "+PayP.Name+"|饭 ᮧ .㬥⮢  筮 㤥ঠ");
 END {PrologForDeduct};

 PROCEDURE PrologForPDoc();
  CONST
   DepartLen = 9;
  VAR
   _Depart: STRING[];
 BEGIN
  _Depart:=P_Firm.GetDepart(Firm.Firm, PDoc.Date);
  L_General.Assert(Str.Length(_Depart) = DepartLen,
                   " 䨫 ⤥ ᡥࡠ  ࠧ|" +
                   "    ");
  _FileName:=GetYearCode() +
             Str.Slice(PDoc.PDoc, Str.Length(PDoc.PDoc) - 5, 5) +
             Str.Slice(_Depart, DepartLen - 2, 2);
  FIO.Open(P, _FileName, "TFZ", Create);
  Count:=0;
 END {PrologForPDoc};

 PROCEDURE EpilogForPDoc();
 BEGIN
  AddComent(" ᮧ "+L_DatTim.DateStr(SYSDATE())+"  "+L_DatTim.TimeStr(SYSTIME()));
  AddComent(" "+FULLNAME()+" - "+LOGINNAME());
  AddComent(" ᭮ ⥦ 㬥 "+PDoc.SrcNbr+"  "+L_DatTim.DateStr(PDoc.Date));
  AddComent("  㬬 "+FLDTOSTR(PDoc.Total, ",2-", 20, "L"));
  AddComent(L_PDoc.GetPDocComment());
  FIO.Close(P);
 END {EpilogForPDoc};

 PROCEDURE CreateDocument();
  VAR
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  SEARCH(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc, Deduct.TSN);
  PROMPT(" ⥫쭮 㬥 "+_FileName+": "+PDocList.TSN);
  IF Count # 0 THEN
   FIO.WrLn(P);
  END;
  L_Str.SplitManName(Deduct.Person, Surname, FirstName, Patronymic);
  FIO.WrStr(P, Str.Slice(P_Firm.GetDepart(Firm.Firm, PDoc.Date), 4, 5)+","
              +Surname+","
              +FirstName+","
              +Patronymic+","
              +Deduct.PCode+","
              +FLDTOSTR(PDocList.Sum, "2.", 0)+","
              +FLDTOSTR(SYSDATE(), "DNY", 6));
  INC(Count);
 END {CreateDocument};

END.
