(*
%Copyright   (c) Polak Computer System
%Author      02.08.2003 19:51:51 POLAK\San
%Purpose     ஫ 䨪樨 Apport
%Type        control
%Specific    SYS
%Modified    20.03.2013 09:26:16 POLAK\LDA
%Environment
*)

 MODULE Apport [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_Acnt, DBD, L_WDO;

 PRIVATE PROCEDURE CopyRecord(Interactive: SCAL[2]; oldValue: LIKE(Apport2.Apport2));
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i < DBD.FieldAmount(Apport) DO
   ^(DBD.FieldFullName(Apport2, i)):=^(DBD.FieldFullName(Apport, i));
   INC(i);
  END;
 END {CopyRecord};

 PRIVATE PROCEDURE StandOnInMirror(_Apport: LIKE(Apport.Apport));
 BEGIN
  L_General.Assert(SEARCH(Apport2, Apport2, _Apport), "    ઠ");
 END {StandOnInMirror};

 PRIVATE PROCEDURE Apport_OnAfterEdit();
 BEGIN
  StandOnInMirror(GE_PVALUE(Apport.Apport));
  CopyRecord(1, Apport.Apport);
  REPLACE(Apport2);
 END {Apport_OnAfterEdit};

 PRIVATE PROCEDURE Apport_OnAfterInsert();
 BEGIN
  CopyRecord(1, "");
  INSERT(Apport2);
 END {Apport_OnAfterInsert};

 PRIVATE PROCEDURE Apport_OnBeforeDelete();
 BEGIN
  StandOnInMirror(Apport.Apport);
  TRY
   REMOVE(Apport2);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = 223 THEN
    L_General.Error("   㤠, ⮬ " +
                    "|  뫠  㣮 䠩");
   ELSE
    RAISE();
   END;
  END;
 END {Apport_OnBeforeDelete};

 PRIVATE PROCEDURE Apport_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, "");
  L_WDO.iSubwindow   (1, "ApportE");
  L_WDO.iField       (1, "Apport.CirKind").Format:=L_Acnt.ck_Pool;
 END {Apport_OnInitializeWindow};

 PRIVATE PROCEDURE ApportE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf]);
  L_WDO.iMayBeEmpty  (0, ["Apport.Till"]);
  L_WDO.iField       (0, "Apport.CirKind").Format:=L_Acnt.ck_Pool;
 END {ApportE_OnInitializeWindow};

 PRIVATE PROCEDURE Apport2_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, "");
  L_WDO.iSubwindow   (1, "Apport2E");
  L_WDO.iField       (1, "Apport2.CirKind").Format:=L_Acnt.ck_Pool;
 END {Apport2_OnInitializeWindow};

 PRIVATE PROCEDURE Apport2E_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf]);
  L_WDO.iMayBeEmpty  (0, ["Apport2.Till"]);
  L_WDO.iField       (0, "Apport2.CirKind").Format:=L_Acnt.ck_Pool;
 END {Apport2E_OnInitializeWindow};

BEGIN
 INTEGRITY(NoAsk);
 IF L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSIF MODE = 030 THEN
  StandOnInMirror(Apport.Apport);
  CopyRecord(0, Apport.Apport);
  REPLACE(Apport2);
 ELSIF MODE = 031 THEN
  CopyRecord(0, "");
  INSERT(Apport2);
 ELSE
  L_General.BadMode(MODE);
 END;
END.
