(*
%Copyright   (c) Polak IT
%Author      29.10.2004 15:10:29 POLAK\GAV
%Specific    SYS
%Modified    08.10.2013 12:08:54 POLAK\Gina
%Environment
*)

 MODULE AP_Util [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, L_Str, L_DatTim, L_General, P_OwnData, FIO, Shell, Memo, L_HTTP, L_bp, L_StdFrm;

 PRIVATE PROCEDURE GetSection(value, Tag: STRING[]; VAR Pos: NUMERIC[0]): STRING[];
  VAR
   Value  : STRING[];
   lvl,
   pOpen,
   pClose,
   p      : NUMERIC[0];
 BEGIN
  Value:=Str.Cap(value);
  Tag  :=Str.Cap(Tag);
  Pos:=Str.Pos(Value, "<" + Tag, Pos);
  IF Pos < Str.Length(Value) THEN
   Pos:=Str.Pos(Value, ">", Pos) + 1;
   lvl:=1;
   p:=Pos;
   WHILE lvl > 0 DO
    pOpen :=Str.Pos(Value, "<" + Tag, p);
    pClose:=Str.Pos(Value, "</" + Tag, p);
    IF pClose = Str.Length(Value) THEN
     (* ,  *)
     lvl:=0;
     p:=pClose + 1;
    ELSIF pClose < pOpen THEN
     DEC(lvl);
     p:=pClose + 1;
    ELSE
     INC(lvl);
     p:=pOpen + 1;
    END;
   END;
   RETURN Str.Slice(value, Pos, p - Pos - 1);
  ELSE
   RETURN "";
  END;
 END {GetSection};

 PRIVATE PROCEDURE GetUSDRate_FromStr(Value: STRING[]): STRING[];
  VAR
   p,
   Pos: NUMERIC[0];
   result,
   table,
   tr,
   td    : STRING[];
 BEGIN
  Pos:=0;
  table:=GetSection(Value, "table", Pos);
  WHILE ~!table DO
   p:=0;
   IF ~!GetSection(table, "table", p) THEN
    result:=GetUSDRate_FromStr(table);
    IF ~!result THEN
     RETURN result;
    END;
   ELSE
    p:=0;
    tr:=GetSection(table, "tr", p);
    WHILE ~!tr DO
     td:=GetSection(table, "td", p);
     IF td = "840" THEN
      td:=GetSection(table, "td", p); (*&nbsp;&nbsp;USD*)
      td:=GetSection(table, "td", p); (*1*)
      td:=GetSection(table, "td", p); (*&nbsp;&nbsp; *)
      result:=GetSection(table, "td", p); (**)
      RETURN result;
     END;
     tr:=GetSection(table, "tr", p);
    END;
   END;
   table:=GetSection(Value, "table", Pos);
  END;
  RETURN "";
 END {GetUSDRate_FromStr};

 PRIVATE PROCEDURE CreateLink(D: DATE): STRING[];
 BEGIN
  RETURN "http://www.cbr.ru/currency_base/D_print.aspx?date_req=" + FLDTOSTR(D, "D/N/y");
 END {CreateLink};

 PRIVATE PROCEDURE ConvMsg(Msg: STRING[]): STRING[];
  CONST
   MaxLength = 70;
  VAR
   i        : NUMERIC[0];
   Result,
   SingleStr: STRING[];
 BEGIN
  SETEMPTY(Result);
  i:=0;
  LOOP
   SingleStr:=L_Str.PoolItem(Msg, i);
   IF !SingleStr THEN
    EXIT;
   END;
   Result:=Result + Str.Align(SingleStr, MaxLength, LEFT) + "|";
   INC(i);
  END; (* LOOP *)
  RETURN Result;
 END {ConvMsg};

 PRIVATE PROCEDURE AddMsg(trgDate: DATE; Msg, Text: STRING[]): STRING[];
 BEGIN
  RETURN Msg + L_DatTim.DateStr(trgDate) + ": " + Text + "|";
 END {AddMsg};

 PUBLIC PROCEDURE LoadUSDRate();
  CONST
   DaysBefore = 15;
   bpId       = "ldUSD";
  VAR
   D,
   trgDate    : DATE;
   Msg,
   Value,
   Warning,
   USDRate_Org: STRING[];
   HasError,
   HasWarning : SCAL[2];
   CurValue,
   PrvValue   : FLOAT;
 BEGIN
  L_bp.extBegin(bpId, "㧪  USD", L_bp.t_Process, L_General.tc_Entire, L_bp.pt_StrictlyInTime);
  L_General.Assert(SEARCH(Property, Property, P_OwnData.P_USDRate),
                   '  ன "    "');
  D:=L_DatTim.IncWorkDay(Memo.ud_cd() - DaysBefore, -1);
  USDRate_Org:=FIO.MakePath("USDRate", "txt", Shell.SpecialFolders("Temp"));
  HasError   :=0;
  HasWarning :=0;
  PrvValue   :=STRTOFLD(P_OwnData.GetOwnDProSoft(D - 1, P_OwnData.P_USDRate), NUMERIC);
  SETEMPTY(Value, Msg);
  REPEAT
   PROMPT(" 㧪    ...");
   trgDate:=D + 1;
   IF ~SEARCH(OwnDPro, Property, P_OwnData.P_USDRate, trgDate) THEN
    IF L_DatTim.IsWorkDay(D) THEN
     PROMPT(" 㧪      " + L_DatTim.DateStr(trgDate));
     IF L_HTTP.httpGet(CreateLink(trgDate), USDRate_Org) THEN
      FIO.Open(F, USDRate_Org, , Input);
      L_General.Assert(FIO.RdByte(F, Value, FIO.Size(F)), "訡 ⥭  䠩");
      FIO.Close(F);
     ELSE
      SETEMPTY(Value);
     END;
     IF    Str.Match(Value, "*Курсы валют за * не зарегистрированы.*") THEN
      Msg     :=AddMsg(trgDate, Msg, "    ⠭");
      HasError:=1;
     ELSIF ~!Value THEN
      Value:=GetUSDRate_FromStr(Value);
      IF ~!Value THEN
       CurValue:=STRTOFLD(Value, NUMERIC, "4,");
       TRY [TRANSACTION(TRANSACTION_SLAVE)]
        P_OwnData.InsertProperty(trgDate,
                                 P_OwnData.P_USDRate,
                                 FLDTOSTR(CurValue, "4.", 0),
                                 0,
                                 "",
                                 "",
                                 EMPTYOF(DATE),
                                 EMPTYOF(DATE));
        HasWarning:=~!PrvValue & ((PrvValue / CurValue < 0.99) | (CurValue / PrvValue < 0.99));
        IF HasWarning THEN
         Warning:="   1%!";
        ELSE
         SETEMPTY(Warning);
        END;
        Msg     :=AddMsg(OwnDPro.Date, Msg, "⠭     " + OwnDPro.Value + Warning);
        PrvValue:=CurValue;
       EXCEPT
       ON Exc: Exc_Root DO
        Msg     :=AddMsg(trgDate, Msg, Exc.MsgOriginalText);
        HasError:=1;
       END; (* TRY *)
      ELSE
       Msg    :=AddMsg(trgDate, Msg, " 㤠     ");
       HasError:=1;
      END;
     ELSE
      Msg     :=AddMsg(trgDate, Msg, " 㤠 㧨  ");
      HasError:=1;
     END;
    END;
   END;
   INC(D);
   PrvValue:=STRTOFLD(P_OwnData.GetOwnDProSoft(D, P_OwnData.P_USDRate), NUMERIC);
  UNTIL (D > Memo.ud_cd()) & L_DatTim.IsWorkDay(D);

  IF ~!Msg THEN
   Msg:="⮪ 㧪     ||" + ConvMsg(Msg);
   IF    HasError THEN
    L_General.Error(Msg);
   ELSIF HasWarning THEN
    L_StdFrm.Warning(Msg);
   ELSE
    L_StdFrm.Inform(Msg);
   END;
  ELSE
   L_StdFrm.Inform("     㦥 ⠭");
  END;
  L_bp.End();
 END {LoadUSDRate};

END.
