(*
%Copyright   (c) Polak IT
%Author      29.04.2010 11:45:02 POLAK\MLB
%Purpose     ࠭樨
%Type        operation
%Specific    SYS
%Modified    10.06.2013 12:47:48 POLAK\LDA
%Environment
*)

 MODULE ASBTools [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, L_Str, L_General, L_Basis, FIO, L_FIO, L_AFM, L_StdFrm, DBD, L_DatTim;

 PRIVATE TYPE
  tFileType       = SCAL[2];
  tClass          = SCAL[3];
  tViewArr        = SCAL[2][3];

 PRIVATE CONST
  idx_ShowECN     = 0;
  idx_ShowTRNs    = 1;
  idx_ShowEAD     = 2;
  idx_RunGuard    = 3;
  idx_NPM         = 4;

  idx_Pool = "⥭ 䠩 .ecn| 樨 ࠭権|⥭ 䠩 .ead|믮 Guard|NPM  ࠡ ";

  ftECN           = 0;
  ftEAD           = 1;

  ec_Warning      = 0;
  ec_Notification = 1;
  ec_Exception    = 2;

 PRIVATE PROCEDURE ShowTransactions();
  CONST
   rbi_Active    = 0;
   rbi_NotActive = 1;
   rbi_All       = 2;

   reg_Exit      = 0;
   reg_Update    = 1;
   reg_Export    = 2;

   BlSize        = 2048;
   UnKnownValue  = "祭  ।";
   title_pool    = "⨢ ࠭樨|祭 ࠭樨| ࠭樨";
   Rep           = "TRNsDial";
  
  VAR
   oTRNs       : TRANSACTIONS;
   oTRN        : TRANSACTION;
   oConn       : ASBCONNECTION;

   nOldTRNtBeg,
   nOldTRNtEnd : TIMESTAMP;

   saOldTRNtEnd,
   snOldTRNtEnd,
   snAllocMem,
   snOccupMem,
   curTRN,
   sActive,
   sConnNo,
   sUserName,
   sSlice      : STRING[];
   sTRNsList   : STRING[][rbi_All + 1];
 
   i,
   rbi,
   aCnt,
   nCnt,
   aAllocMem,
   aOccupMem,
   nAllocMem,
   nOccupMem,
   Reg         : NUMERIC[0];
 BEGIN
  rbi:=rbi_Active;
  SETEMPTY(nOldTRNtBeg, nOldTRNtEnd);
  LOOP
   SETEMPTY(sTRNsList);
   SETZERO(aCnt, nCnt, aOccupMem, nOccupMem, aAllocMem, nAllocMem, i);
   IF rbi = rbi_Active THEN
    oTRNs:=TRANSACTIONS.Get(TRANSACTIONS.Subset_Active);
   ELSE
    oTRNs:=TRANSACTIONS.Get(TRANSACTIONS.Subset_All);
   END;
   REPEAT
    oTRN:=oTRNs.Item(i);
    PROMPT("oTRN " + L_Str.IntStr(i + 1) + "  " + L_Str.IntStr(oTRNs.Count));
    IF oTRN.Active THEN
     INC(aCnt);
     INC(aOccupMem, oTRN.DataSize);
     INC(aAllocMem, ((oTRN.DataSize - 1) DIV BlSize + 1) * BlSize);
     sActive  :="";
     oConn    :=oTRN.Connection;
     sConnNo  :=L_Str.IntStr(oConn.ConnectionNo);
     sUserName:=oConn.LoginName;
     IF ~!oConn.UserDomain THEN
      sUserName:=oConn.UserDomain + "\" + sUserName;
     END;
     IF (sConnNo[0] # CHR(0)) & (sConnNo[1] = CHR(0)) THEN
      sConnNo:="0" + sConnNo;
     END;
     IF oConn.My THEN
      sConnNo:="*" + sConnNo;
     ELSE
      sConnNo:=" " + sConnNo;
     END;
    ELSE
     INC(nCnt);
     INC(nOccupMem, oTRN.DataSize);
     INC(nAllocMem, ((oTRN.DataSize-1) DIV BlSize + 1) * BlSize);
     sActive:="-";
     IF oTRN.CreateDTS < nOldTRNtBeg THEN
      nOldTRNtBeg:=oTRN.CreateDTS;
      nOldTRNtEnd:=oTRN.MySliceDTS;
     END;
     sConnNo  :="---";
     sUserName:=oTRN.UserDomain + "\" + oTRN.LoginName;
    END;
    IF     oTRN.Active & ~!oTRN.BaseSlice THEN
     sSlice:=       FLDTOSTR(oTRN.BaseSlice,    "",            07, "R") +
             " (" + FLDTOSTR(oTRN.BaseSliceDTS, "D.N.Y H:M:S", 17, "L") + ")";
    ELSIF ~oTRN.Active & ~!oTRN.MySlice THEN
     sSlice:=       FLDTOSTR(oTRN.MySlice,      "",            07, "R") +
             " (" + FLDTOSTR(oTRN.MySliceDTS,   "D.N.Y H:M:S", 17, "L") + ")";
    ELSE
     sSlice:="                           ";
    END;
    curTRN:="|"+
            Str.Align(Str.Align(sActive,                               02, LEFT) +
                      Str.Align(sConnNo,                               05, LEFT) +
                      Str.Align(sUserName,                             19, LEFT) +
                      FLDTOSTR(oTRN.CreateDTS, "D.N.Y H:M:S", 17, "L")           + " " +
                      sSlice                                                     + " " +
                      Str.Align(L_Str.IntStr(oTRN.DataSize),           08, RIGHT)+ " " +
                      Str.Align(oTRN.CompositeDescr,                   25, LEFT),
                      106,
                      LEFT);
    IF sActive = "" THEN
     INC(sTRNsList[rbi_Active],    curTRN);
    ELSE
     INC(sTRNsList[rbi_NotActive], curTRN);
    END;
    INC(sTRNsList[rbi_All],        curTRN);
    INC(i);
   UNTIL (i = oTRNs.Count) | ((rbi = rbi_Active) & (~oTRN.Active));

   saOldTRNtEnd:=UnKnownValue;
   IF (rbi = rbi_Active) THEN
    nCnt:=oTRNs.Count - aCnt;
    snOccupMem  :=UnKnownValue;
    snAllocMem  :=UnKnownValue;
    snOldTRNtEnd:=UnKnownValue;
   ELSE
    snOccupMem  :=FLDTOSTR(nOccupMem, ",0", 0);
    snAllocMem  :=FLDTOSTR(nAllocMem, ",0", 0);
    IF nCnt = 0 THEN
     snOldTRNtEnd:=UnKnownValue;
    ELSE
     snOldTRNtEnd:=FLDTOSTR(nOldTRNtEnd, "D.N.Y H:M:S", 17, "L");
    END;
   END;

   IF !sTRNsList[rbi] THEN
    sTRNsList[rbi]:=Str.Align("| ", 107, LEFT);
   END;
 
   i:=0;
   Reg:=0;
   Reg:=STDFORM("|" +
                Str.Align(" ", 38, LEFT)                   + "⨢ ࠭樨               " + "祭 ࠭樨          " + "|"  +
                "⢮ ࠭権                   " + "%R31NI "                            + "%R32NI "                          + "||" +
                "ꥬ ⮩                     " + "%R31NI "                            + "%R32NI "                          + "||" +
                "ꥬ 뤥                  " + "%R31NI "                            + "%R32NI "                          + "||" +
                "६ 砭 ᠬ ன ࠭樨 " + "%R31NI "                            + "%R32NI "                          + "||" +
                "|" +
                "A Conn User Name                        १ /ᮡ⢥    ᠭ                 "           + "|"  +
                "%,30AI||||||||||||||||||||||||||||||||"  +
                "%102<" + title_pool + ">O||"             +
                "%<   >X   "                   +
                "%<   >DB   "               +
                "%< Export to csv >B",
                " " + L_Str.PoolItem(title_pool, rbi) + " ",
                INFORM_NEUTRAL,
                ,
                L_Str.IntStr(aCnt),           L_Str.IntStr(nCnt),
                FLDTOSTR(aOccupMem, ",0", 0), snOccupMem,
                FLDTOSTR(aAllocMem, ",0", 0), snAllocMem,
                saOldTRNtEnd,                 snOldTRNtEnd,
                sTRNsList[rbi], Reg, rbi);
   IF Reg = reg_Exit THEN
    EXIT;
   ELSIF Reg = reg_Export THEN
    FIO.Open(F, L_General.NameConnection(Rep), "rep", Create);
    L_Basis.wb_WrInQM("F", "A");
    L_Basis.wb_WrInQM("F", "ConnNo");
    L_Basis.wb_WrInQM("F", "UserName");
    L_Basis.wb_WrInQM("F", "Date/Time Create");
    L_Basis.wb_WrInQM("F", "Slice");
    L_Basis.wb_WrInQM("F", "Occuped memory");
    L_Basis.wb_WrInQM("F", "Description");
    L_Basis.wb_TermLine("F");
    i:=0;
    WHILE i < oTRNs.Count DO
     oTRN:=oTRNs.Item(i);
     PROMPT("oTRN " + L_Str.IntStr(i + 1) + "  " + L_Str.IntStr(oTRNs.Count));
     IF  ((rbi = rbi_Active)    &  oTRN.Active) |
         ((rbi = rbi_NotActive) & ~oTRN.Active) |
         ((rbi = rbi_All)                     )THEN
      L_Basis.wb_WrStr("F", L_Str.PoolItem("-|A", oTRN.Active));
      IF oTRN.Active THEN
       sConnNo  :=L_Str.IntStr(oTRN.Connection.ConnectionNo);
       sUserName:=oTRN.Connection.LoginName;
       IF ~!oTRN.Connection.UserDomain THEN
        sUserName:=oTRN.Connection.UserDomain + "\" + sUserName;
       END;
      ELSE
       sConnNo  :="---";
       sUserName:=oTRN.UserDomain + "\" + oTRN.LoginName;
      END;
      L_Basis.wb_WrStr("F", sConnNo);
      L_Basis.wb_WrStr("F", sUserName);
      L_Basis.wb_WrStr("F", FLDTOSTR(oTRN.CreateDTS, "D.N.Y H:M:S"));
      IF     oTRN.Active & ~!oTRN.BaseSlice THEN
       sSlice:=L_Str.IntStr(oTRN.BaseSlice) + " (" + FLDTOSTR(oTRN.BaseSliceDTS, "D.N.Y H:M:S") + ")";
      ELSIF ~oTRN.Active & ~!oTRN.MySlice THEN
       sSlice:=L_Str.IntStr(oTRN.MySlice)   + " (" + FLDTOSTR(oTRN.MySliceDTS,   "D.N.Y H:M:S") + ")";
      ELSE
       sSlice:="";
      END;
      L_Basis.wb_WrStr("F", sSlice);
      L_Basis.wb_WrStr("F", L_Str.IntStr(oTRN.DataSize));
      L_Basis.wb_WrStr("F", oTRN.CompositeDescr);
      L_Basis.wb_TermLine("F");
     END;(* IF (oTRN.Active & rbi  ...*)
     INC(i);
    END; (* WHILE i < oTRNs.Count DO ... *)
    FIO.Close(F);
   END;
  END; (*LOOP*)
 END {ShowTransactions};

 (* ****************** ᬮ ECN/EAD 䠩 ********************** *)

 PRIVATE PROCEDURE EE_CreateTemp(FileType: SCAL[2]);
 BEGIN
  CreateFILE(EE, "", "", "");
  CreateFIELD(EE, Number,      NUMERIC[0],  "", "", "", "", "");
  CreateFIELD(EE, Doubled,     SCAL[2],     "", "", "", "", "");
  CreateFIELD(EE, DateTime,    TIMESTAMP,   "", "", "", "", "");
  CreateFIELD(EE, Description, STRING[512], "", "", "", "", "");
  CreateFIELD(EE, Class,       tClass,      "", "", "", "", "");
  CreateFIELD(EE, Stack,       STRING[100], "", "", "", "", "");
  CreateFIELD(EE, MachineName, STRING[12],  "", "", "", "", "");
  CreateFIELD(EE, UserName,    STRING[12],  "", "", "", "", "");
  CreateFIELD(EE, ModuleName,  STRING[17],  "", "", "", "", "");
  CreateFIELD(EE, Row,         NUMERIC[0],  "", "", "", "", "");
  CreateFIELD(EE, Column,      NUMERIC[0],  "", "", "", "", "");
  CreateFIELD(EE, ModuleTime,  TIMESTAMP,   "", "", "", "", "");
  CreateFIELD(EE, ModuleSize,  NUMERIC[0],  "", "", "", "", "");
  IF FileType = ftEAD THEN
   CreateFIELD(EE, Stack2,       STRING[100], "", "", "", "", "");
   CreateFIELD(EE, UserName2,    STRING[12],  "", "", "", "", "");
  END;
  CreateINDEX(EE, Number, UNIQUE, "", "", Number);
  IF FileType = ftECN THEN
   CreateINDEX(EE, Module, PLURAL, "", "", ModuleName, Row, Column, ModuleTime, ModuleSize);
  ELSE
   IF FileType = ftEAD THEN
    CreateINDEX(EE, Module, PLURAL, "", "",
                ModuleName, Row, Column, ModuleTime, ModuleSize, UserName2,
               );
   END;
  END;
  SetVersionOfFILE(EE, 01);
  L_AFM.AF_CreateTemp("EE", "EE");
 END {EE_CreateTemp};

 PRIVATE PROCEDURE GetDateFromStr(S: STRING[]): DATE;
  VAR
   Result   : DATE;
 BEGIN
  SETEMPTY(Result);
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   Result:=L_DatTim.GetDateOfTIMESTAMP(STRTOFLD(S, TIMESTAMP, "D/N/y H:M:S"));
  EXCEPT
  ON Exc: Exc_Root DO
  END; (* TRY *)
  RETURN Result;
 END {GetDateFromStr};

 PRIVATE PROCEDURE PosInFile(Shift: NUMERIC[0]);
  CONST
   Rows           = 100;
   ApproxLineSize = 256;
  VAR
   S        : STRING[];
   Found,
   FirstPass: SCAL[2];
   start,
   prvStart : NUMERIC[0];
   trgDate  : DATE;
   dstDate  : DATE;
 BEGIN
  dstDate  :=SYSDATE()-Shift;
  Found    :=0;
  prvStart :=0;
  FirstPass:=1;
  start    := FIO.Size(F) - ApproxLineSize * Rows;
  LOOP
   IF start < 0 THEN
    start:=prvStart;
    FIO.Seek(F, start);
    EXIT;
   ELSE
    prvStart:=start;
    FIO.Seek(F, start);
    IF FIO.RdStr(F, S) THEN
     (* ய᪠ 1 ப *)
    END;
    LOOP
     IF ~FIO.RdStr(F, S) THEN
      EXIT;
     ELSE
      trgDate:=GetDateFromStr(Str.Replace(Str.Item(S, ";", 0, , 1), '"', ''));
      PROMPT(" " + L_DatTim.DateStr(trgDate));
      IF    ~!trgDate & (trgDate > dstDate) THEN
       IF ~FirstPass THEN
        Found:=1;
       END;
       EXIT;
      ELSIF ~FirstPass & (trgDate = dstDate) THEN
       Found:=1;
       EXIT;
      ELSIF FirstPass & (trgDate <= dstDate) THEN
       FirstPass:=0;
       EXIT;
      END;
     END;
    END; (* LOOP *)
   END;
   IF Found THEN
    EXIT;
   END;
   start := start - ApproxLineSize * Rows;
  END; (* LOOP *)
 END {PosInFile};

 PRIVATE PROCEDURE EE_ConvertFile(FileType        : SCAL[2];
                                  inFile          : STRING[];
                                  ViewAll         : SCAL[2];
                                  View            : tViewArr;
                                  Shift           : NUMERIC[0];
                                  wAP_SupportError: SCAL[2]);
  VAR
   S,
   FullFileName,
   trgDescription: STRING[];
   trgClass      : tClass;
   Pos, Line     : NUMERIC[0];
 BEGIN
  IF FIO.Exists(inFile) THEN
   EE_CreateTemp(FileType);
   FIO.Open(F, inFile, , Input);

   PosInFile(Shift);

   Line:=0;
   WHILE FIO.RdStr(F, S) DO
    PROMPT(S);
    S:=Str.Replace(S, '"', '');
    Pos:=Str.ItemPos(S, ";", 9, , 1);
    IF Pos < Str.Length(S) (* ଠ ecn*) THEN
     trgDescription:=Str.Slice(S, Pos, Str.Length(S) - Pos);
     IF    Str.Match(trgDescription, "।०:*") THEN
      trgClass:=ec_Warning;
     ELSIF Str.Match(trgDescription, ":*") THEN
      trgClass:=ec_Notification;
     ELSE
      trgClass:=ec_Exception;
     END;
     IF ViewAll | View[trgClass] THEN
      FullFileName:=Str.Item(S, ";", 4, , 1);
      IF (FileType = ftEAD) |
         wAP_SupportError   |
         ~L_General.IsAPSupportFolder(FullFileName) THEN
       EE.Description:=trgDescription;
       EE.Class      :=trgClass;
       EE.Number     :=Line;
       EE.Doubled    :=0;
       EE.DateTime   :=STRTOFLD(Str.Item(S, ";", 0, , 1), TIMESTAMP, "D/N/y H:M:S");
       EE.MachineName:=Str.Item(S, ";", 2, , 1);
       EE.UserName   :=Str.Item(Str.Item(S, ";", 1, , 1), "\", 1);
       EE.ModuleName :=L_FIO.effp_FileName(FullFileName);
       EE.Row        :=STRTOFLD(Str.Item(S, ";", 7, , 1), SCAL);
       EE.Column     :=STRTOFLD(Str.Item(S, ";", 8, , 1), SCAL);
       TRY
        EE.ModuleTime:=STRTOFLD(Str.Item(S, ";", 5, , 1), TIMESTAMP, "D/N/y H:M:S");
       EXCEPT
        ON Exc: Exc_Root DO
         EE.ModuleTime:=L_DatTim.GetTIMESTAMP(01\01\1900, 00:00);
       END;
       EE.ModuleSize:=STRTOFLD(Str.Item(S, ";", 6, , 1), SCAL);
       EE.Stack     :=Str.Item(S, ";", 3, , 1);
   
       IF FileType = ftEAD THEN
        EE.Stack2:=Str.Item(S, ";", 10, , 1);
        EE.UserName2:="";
        IF Str.Length(EE.Stack2) > 0 THEN
         EE.Description:=EE.Description+" ["+EE.Stack2 + "]";
        END;
       END;
       INSERT(EE);
       INC(Line);
      END; (* IF wAP_SupportError |... *)
     END; (* IF ViewAll | View[EE.Class]... *)
    END;
   END; (* WHILE FIO ... *)
  ELSE
   L_General.Error(" "+inFile+"  ");
  END;
 END {EE_ConvertFile};

(*
$P{ ecnHeader:
?, L, ""
?, L, ""
@
: ##############  ᬮ: ########################################################################
==============================================================================================================
}
*)

(*
$P{ ecnTop:
@
६   |ᠭ                                                     |
}
*)

(*
$P{ ecnLine:
?, L, "D.N.Y"
?, L, ""
?, L, ""
?, R, ""
?, R, "H:M:S"
?, L, ""
?, L, "D.N.y H:M:S"
?, R, ""
@
--------|-------------------------------------------------------------|---------------------------------------
########|#############################################################|     ################# ################
########|#############################################################|################### ######
}
*)

(*
$P{ ecnLine2:
?, L, ""
@
        |#############################################################|
}
*)

(*
$P{ ecnDoubled_short:
?, L, ""
?, L, ""
?, L, ""
@
        |################# ###########################################|#######################################
}
*)

(*
$P{ ecnDoubled_long:
?, L, ""
?, L, ""
?, L, ""
@
        |################# ###########################################|#####################################################################################################################
}
*)

(*
$P{ ecnBot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE EE_BuildReportLine(dbl: NUMERIC[0]);
  CONST
   CharInLine         = 61;
   MaxExceptionLength = 768;
   ShortStackRowSize  = 39;
  VAR
   i                : NUMERIC[0];
   Desc             : STRING[][MaxExceptionLength/CharInLine+1];
   DateTimeAsStr,
   RowAndColumnAsStr: STRING[];
 BEGIN
  IF dbl=0 THEN
   L_Str.FormatStr(Desc, EE.Description, CharInLine);
   SETEMPTY(RowAndColumnAsStr);
   IF ~!EE.Row THEN
    RowAndColumnAsStr:=L_Str.IntStr(EE.Row) + ", " + L_Str.IntStr(EE.Column);
   END;
   MAKEPART(R, ecnLine,
              EE.DateTime, Desc[0], EE.ModuleName, RowAndColumnAsStr,
              EE.DateTime, Desc[1], EE.ModuleTime, EE.ModuleSize);

   i:=2;
   WHILE (i <= HIGH(Desc)) & ~!Desc[i] DO
    MAKEPART(R, ecnLine2, Desc[i]);
    INC(i);
   END; (* WHILE (i < HIGH) ... *)

   SETEMPTY(DateTimeAsStr);
  ELSE
   DateTimeAsStr:=FLDTOSTR(EE.DateTime, "D.N.Y H:M:S");
  END; (* IF dbl *)

  IF Str.Length(EE.Stack) <= ShortStackRowSize THEN
   MAKEPART(R, ecnDoubled_short, DateTimeAsStr, EE.MachineName+", "+EE.UserName, EE.Stack);
  ELSE
   MAKEPART(R, ecnDoubled_long,  DateTimeAsStr, EE.MachineName+", "+EE.UserName, EE.Stack);
  END;
 END {EE_BuildReportLine};

 PRIVATE PROCEDURE EE_CreateReport(FileType: tFileType; inFile: STRING[]);
  CONST
   lk_Pool       = "।०||᪫祭";
   lk_Pool_Short = "W|N|E";

   FieldWidth = 29;
  VAR
   i,
   dbl,
   Shift           : NUMERIC[0];
   View            : tViewArr;
   ViewAll,
   wAP_SupportError: SCAL[2];
   Sign,
   Descr,
   Title,
   RepName,
   Body,
   FieldList,
   VariableList    : STRING[];
 BEGIN
  Shift           :=14;
  wAP_SupportError:=0;
  IF FileType = ftECN THEN
   View[ec_Warning]     :=1;
   View[ec_Notification]:=0;
   View[ec_Exception]   :=1;

   SETEMPTY(Body, FieldList, VariableList);
   Body        :="|  ᫥ %###% |";
   FieldList   :="%I";

   SETEMPTY(VariableList);
   i:=0;
   WHILE i <= HIGH(View) DO
    FieldList   :=FieldList + "%<" + Str.Align(L_Str.PoolItem(lk_Pool, i), FieldWidth, LEFT) + ">E";
    Body        :=Body + "|%" + L_Str.Repeat("#", FieldWidth) + "%";
    VariableList:=L_Str.AddStrDlm(VariableList, ",") + "View[" + L_Str.IntStr(i) + "]";
    INC(i);
   END; (* WHILE i <= HIGH(View)...*)
   IF APP.Get().SupportMode THEN
    FieldList   :=FieldList + "%< 訡  AP_Support>E";
    Body        :=Body + "||%" + L_Str.Repeat("#", FieldWidth) + "%";
    VariableList:=L_Str.AddStrDlm(VariableList, ",") + "wAP_SupportError";
   END;

   STDFORM(L_StdFrm.sf_Choice(Body, FieldList),
                              "⥭ 䠩 ecn",
                              INFORM_NEUTRAL,
                              ,
                              Shift, ^(VariableList));

   SETEMPTY(Sign, Title);
   ViewAll:=1;
   i      :=0;
   WHILE i <= HIGH(View) DO
    IF View[i] THEN
     Sign :=Sign + L_Str.PoolItem(lk_Pool_Short, i);
     Title:=L_Str.AddStrDlm(Title, ", ") + Str.Small(L_Str.PoolItem(lk_Pool, i));
    END;
    ViewAll:=ViewAll & View[i];
    INC(i);
   END; (* WHILE i <= HIGH(View)...*)
   L_General.Assert(~!Sign, " ࠭   ⨯  ୠ 訡");
   RepName:="ecn_" + Sign;
  ELSE
   ViewAll:=1;
   SETEMPTY(View);
   RepName:="ead01";
  END;
  EE_ConvertFile(FileType, inFile, ViewAll, View, Shift, wAP_SupportError);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF FileType = ftECN THEN
   MAKEPART(R, ecnHeader, inFile, "(" + Title + "), ਮ ᬮ " + L_Str.IntStr(Shift) + " .");
  END;
  MAKEPART(R, ecnTop);

  SELECT(EE, Number);
  LAST(EE);
  WHILE OCCURE(EE) DO
   PROMPT(": ப " + L_Str.IntStr(EE.Number));
   SAVE(EE);
   Descr:=EE.Description;
   SELECT(EE, Module, , EE.ModuleName, EE.Row, EE.Column, EE.ModuleTime, EE.ModuleSize);
   LAST(EE);
   dbl:=0;
   WHILE OCCURE(EE) DO
    IF (~EE.Doubled) & (EE.Description = Descr) THEN
     EE.Doubled:=1;
     REPLACE(EE);
     EE_BuildReportLine(dbl);
     INC(dbl);
    END;
    PREV(EE);
   END;
   RESTORE(EE);
   PREV(EE);
  END;
  MAKEPART(R, ecnBot);
  L_General.SurveyLastReport();
 END {EE_CreateReport};

 PRIVATE CONST
  PrivateSign = "19.09.2012 18:23:19 POLAK\San  ⠪ 祭 ࠬ 筮   맮!";

 PUBLIC PROCEDURE RestoreSupportMode(Sign: STRING[]);
 BEGIN
  IF Sign = PrivateSign THEN
   APP.Get().SupportMode:=1;
  ELSE
   L_General.CallUs(0);
  END;
 END {RestoreSupportMode};

 PUBLIC PROCEDURE Do();
  VAR
   Idx  : NUMERIC[0];
   Name,
   Path : STRING[];
 BEGIN
  Idx:=L_StdFrm.ShowListAsMenu(idx_Pool, "㬥");
  IF    Idx = idx_ShowTRNs THEN
   ShowTransactions();
  ELSIF Idx = idx_RunGuard THEN
   LIKEMENU(CALL, "Guard.Play()");
  ELSIF Idx = idx_NPM THEN
   IF APP.Get().SupportMode THEN
    APP.Get().SupportMode:=0;
    LIKEMENU(EditText, "*.asl", CALL, "ASBTools.RestoreSupportMode('" + PrivateSign + "')");
   ELSE
    L_StdFrm.BlueHalt("   ⮣   SupportMode");
   END;
  ELSE
   IF Idx = idx_ShowECN THEN
    EE_CreateReport(ftECN, DBD.BaseName()+".ecn");
   ELSE
    IF Idx = idx_ShowEAD THEN
     FIO.SplitPath(FIO.FirstPath("*.ecn"), Name, , Path);
     EE_CreateReport(ftEAD, FIO.BuildPath(DBD.BaseName(), "ead", Path));
    ELSE
     (* nothing *)
    END;
   END;
  END;
 END {Do};

(*
$P{ Line:
?, L, ""
?, L, ""
@
############################### ####################################################
}
*)


 PRIVATE TYPE
  tArray = STRING[][512];

 PRIVATE VAR
  W     : FORM_WINDOW;
  Z     : FORM_ZONE;
  F     : FORM_FIELD;
  aEvents,
  aSC,
  aMD,
  aNE   : tArray;

 PRIVATE PROCEDURE append2Array(Cond: SCAL[2]; VAR a: tArray; v: STRING[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  IF Cond THEN
   i:=0;
   WHILE ~!a[i] DO
    INC(i);
   END;
   a[i]:=v;
  END;
 END {append2Array};

 PRIVATE PROCEDURE dcw_PutEvent(O: OBJECT; A: STRING[]);
 BEGIN
  append2Array(O.^A, aEvents, A);
 END {dcw_PutEvent};

 PRIVATE PROCEDURE dcw_WrWindowLine(S: STRING[]);
 BEGIN
  FIO.WrStr(R, '  L_WDO.iWindow().' + S + ';'); FIO.WrLn(R);
 END {dcw_WrWindowLine};

 PRIVATE PROCEDURE dcw_WrLine(Prefix, Suffix: STRING[]);
 BEGIN
  FIO.WrStr(R, '  L_WDO.' + Str.Align(Prefix, 13, LEFT) + '(' + Z.Number + Suffix + ';'); FIO.WrLn(R);
 END {dcw_WrLine};

 PRIVATE PROCEDURE dcw_WrEvents();
  VAR
   S: STRING[];
   i: NUMERIC[0];
 BEGIN
  S:="";
  i:=0;
  WHILE ~!aEvents[i] DO
   IF i > 0 THEN
    INC(S, ", ");
   END;
   INC(S, "L_WDO.e_" + aEvents[i]);
   INC(i);
  END;
  IF ~!S THEN
   S:="[" + S + "]";
   dcw_WrLine('iEvents', ', ' + S + ')');
  END;
 END {dcw_WrEvents};

 PRIVATE PROCEDURE IsCalculatedField_woName(FieldName: STRING[]): SCAL[2];
  VAR
   i     : NUMERIC[0];
   Char  : STRING[];
   Result: SCAL[2];
 BEGIN
  Result:=0;
  i     :=0;
  LOOP
   Char:=L_Str.Char(FieldName, i);
   IF !Char | Result THEN
    EXIT;
   END;
   Result:=(Char = "+") | (Char = "-") | (Char = "*") | (Char = "/") | (Char = "(") | (Char = ")");
   INC(i);
  END; (* LOOP *)
  RETURN Result;
 END {IsCalculatedField_woName};

 PRIVATE PROCEDURE IsZoneWSubWindow(Z: FORM_ZONE): SCAL[2];
 BEGIN
  RETURN (Z.Number # 0) & (~!Z.SubwindowOriginalName | Z.OnSetSubwindow);
 END {IsZoneWSubWindow};

 PRIVATE PROCEDURE dcw_WrFieldAttrArray(a: tArray; P: STRING[]; Z: FORM_ZONE; VAR FirstPass: SCAL[2]);
  VAR
   S: STRING[];
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE ~!a[i] DO
   IF IsCalculatedField_woName(a[i]) THEN
    FIO.WrStr(R, '  !!! 饭   塞  FieldName=' + a[i]); FIO.WrLn(R);
   END;
   INC(i);
  END;

  S:="";
  i:=0;
  WHILE ~!a[i] DO
   IF i > 0 THEN
    INC(S, ", ");
   END;
   INC(S, '"'+ a[i] + '"');
   INC(i);
  END;
  IF i > 0 THEN
   IF FirstPass & IsZoneWSubWindow(F.Zone) THEN
    FIO.WrStr(R, ' SubWindow  ࠡ⪠ OnSetSubWindow.  ⥫쭮 ஢ 室 祪  '); FIO.WrLn(R);
    FirstPass:=0;
   END;
   S:="[" + S + "]";
   dcw_WrLine(P, ', ' + S + ')');
  END;
 END {dcw_WrFieldAttrArray};

 PRIVATE PROCEDURE dcw_WrSingleFieldAttr(F: FORM_FIELD; A: STRING[]; Value: STRING[]);
 BEGIN
  dcw_WrLine('iField', ', "' + F.Name + '").' + A + ':=' + Value);
 END {dcw_WrSingleFieldAttr};

 PRIVATE PROCEDURE dcw_WrSingleFieldScal2Attr_Ext(F: FORM_FIELD; A: STRING[]; wCheckZone: SCAL[2]; VAR FirstPass: SCAL[2]);
 BEGIN
  IF F.^A THEN
   IF wCheckZone & FirstPass & IsZoneWSubWindow(F.Zone) THEN
    FIO.WrStr(R, ' SubWindow  ࠡ⪠ OnSetSubWindow.  ⥫쭮 ஢ 室 祪  '); FIO.WrLn(R);
    FirstPass:=0;
   END;
   dcw_WrSingleFieldAttr(F, A, "1");
  END;
 END {dcw_WrSingleFieldScal2Attr_Ext};

 PRIVATE PROCEDURE dcw_WrSingleFieldScal2Attr(F: FORM_FIELD; A: STRING[]);
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=0;
  dcw_WrSingleFieldScal2Attr_Ext(F, A, 0, Dummy);
 END {dcw_WrSingleFieldScal2Attr};

 PRIVATE PROCEDURE dcw_WrSingleFieldStrAttr(F: FORM_FIELD; A: STRING[]);
 BEGIN
  IF ~!F.^A THEN
   dcw_WrSingleFieldAttr(F, A, '"' + F.^A + '"');
  END;
 END {dcw_WrSingleFieldStrAttr};

 PRIVATE PROCEDURE dcw_WrSingleFieldNumAttr(F: FORM_FIELD; A: STRING[]);
 BEGIN
  IF ~!F.^A THEN
   dcw_WrSingleFieldAttr(F, A, L_Str.IntStr(F.^A));
  END;
 END {dcw_WrSingleFieldNumAttr};

 PRIVATE PROCEDURE dcw_WrSingleFieldFormat(F: FORM_FIELD);
  VAR
   trgFormat: STRING[];
 BEGIN
  trgFormat:=F.Format;
  IF ~!trgFormat & (Str.Pos(trgFormat, "|") # Str.Length(trgFormat)) THEN
   dcw_WrSingleFieldAttr(F, "Format", '"' + trgFormat + '"');
  END;
 END {dcw_WrSingleFieldFormat};

 PRIVATE PROCEDURE IsUniqueField(FieldsNames: STRING[][]; curFieldName: STRING[]): SCAL[2];
  VAR
   i     : NUMERIC[0];
   Result: SCAL[2];
 BEGIN
  Result:=1;
  i     :=0;
  WHILE (i <= HIGH(FieldsNames)) & ~!FieldsNames[i] & Result DO
   Result:=FieldsNames[i] # curFieldName;
   INC(i);
  END; (* WHILE (i <= HIGH(FieldsNames)) &...*)
  RETURN Result;
 END {IsUniqueField};

 PRIVATE PROCEDURE HasZone_wPanelMaster(W: FORM_WINDOW): SCAL[2];
  VAR
   Z          : FORM_ZONE;
   PanelMaster: STRING[];
 BEGIN
  SETEMPTY(PanelMaster);
  FOR_EACH Z IN W.Zones DO
   IF    Z.Number = 0 THEN
    IF ~!Z.MasterTable THEN
     PanelMaster:=Z.MasterTable.Name;
    END;
   ELSIF Z.MasterTable.Name = PanelMaster THEN
    RETURN 1;
   END;
  END; (* FOR_EACH *)
  RETURN 0;
 END {HasZone_wPanelMaster};

 PRIVATE PROCEDURE IsNotEditableZone(W: FORM_WINDOW;
                                     Z: FORM_ZONE): SCAL[2];
 BEGIN
  RETURN Z.ViewOnly | ((Z.Number = 0) & HasZone_wPanelMaster(W));
 END {IsNotEditableZone};

 PRIVATE PROCEDURE IsAcceptableLevProg(Z: FORM_ZONE; trgLevProg: STRING[]): SCAL[2];
 BEGIN
  RETURN !Z.MasterTable | (trgLevProg # Z.MasterTable.Name);
 END {IsAcceptableLevProg};

 PRIVATE PROCEDURE dcw_PutZone(W: FORM_WINDOW; Number: SCAL[10]);
  VAR
   i          : NUMERIC[0];
   FirstPass  : SCAL[2];
   FieldsNames: STRING[][512];
   curProgName: STRING[];
 BEGIN
  Z:=W.Zones(Number);
  IF ~!Z THEN
   SETEMPTY(curProgName, aEvents, aSC, aMD, aNE);
   IF ~!Z.RLevProg THEN
    IF IsAcceptableLevProg(Z, Z.RLevProg) THEN
     curProgName:=Z.RLevProg;
    END;
    IF    Z.OnBeforeEdit   & Z.OnAfterEdit   &
          Z.OnBeforeInsert & Z.OnAfterInsert &
          Z.OnBeforeDelete THEN
     IF IsZoneWSubWindow(Z) THEN
      FIO.WrStr(R, ' SubWindow  ࠡ⪠ OnSetSubWindow.  ⥫쭮 ஢ 室  ᮡ⨩ ஢ '); FIO.WrLn(R);
     END;
     append2Array(1, aEvents, "OnAnyModification");
     dcw_PutEvent(Z, "OnAfterDelete");
    ELSIF Z.OnAfterEdit & Z.OnAfterInsert & Z.OnBeforeDelete THEN
     IF IsZoneWSubWindow(Z) THEN
      FIO.WrStr(R, ' SubWindow  ࠡ⪠ OnSetSubWindow.  ⥫쭮 ஢ 室  ᮡ⨩ ஢ '); FIO.WrLn(R);
     END;
     append2Array(1, aEvents, "OnAfterMdf");
     dcw_PutEvent(Z, "OnBeforeEdit");
     dcw_PutEvent(Z, "OnBeforeInsert");
     dcw_PutEvent(Z, "OnAfterDelete");
    ELSE
     IF IsZoneWSubWindow(Z) THEN
      FIO.WrStr(R, ' SubWindow  ࠡ⪠ OnSetSubWindow.  ⥫쭮 ஢ 室  ᮡ⨩ ஢ '); FIO.WrLn(R);
     END;
     dcw_PutEvent(Z, "OnBeforeEdit");
     dcw_PutEvent(Z, "OnAfterEdit");
     dcw_PutEvent(Z, "OnBeforeInsert");
     dcw_PutEvent(Z, "OnAfterInsert");
     dcw_PutEvent(Z, "OnBeforeDelete");
     dcw_PutEvent(Z, "OnAfterDelete");
    END;
    dcw_PutEvent(Z, "OnReposition");
   END;
   IF ~!Z.FLevProg THEN
    IF    ~!curProgName & (curProgName # Z.FLevProg) THEN
     FIO.WrStr(R, '  !!! FieldLev=' + Z.FLevProg + ' curProgName=' +  curProgName); FIO.WrLn(R);
    ELSIF IsAcceptableLevProg(Z, Z.FLevProg) THEN
     curProgName:=Z.FLevProg;
    END;
   END;
   IF ~!Z.ZLevProg THEN
    IF    ~!curProgName & (curProgName # Z.ZLevProg) THEN
     FIO.WrStr(R, '  !!! ZoneLev=' + Z.ZLevProg + ' curProgName=' +  curProgName); FIO.WrLn(R);
    ELSIF IsAcceptableLevProg(Z, Z.ZLevProg)  THEN
     curProgName:=Z.ZLevProg;
    END;
    dcw_PutEvent(Z, "OnOpenZone");
    dcw_PutEvent(Z, "OnChangeIndex");
    dcw_PutEvent(Z, "OnSetSubwindow");
   END;

   dcw_WrEvents();

   IF Z.ViewOnly THEN
    dcw_WrLine('iZone', ').ViewOnly:=1');
   END;
   IF ~!Z.ParentZone THEN
    dcw_WrLine('iZone', ').ParentZone:=L_WDO.iZone(' + Z.ParentZone.Number + ')');
   END;

   IF ~!Z.Narrowing THEN
    dcw_WrLine('iZone', ').Narrowing:="' + Z.Narrowing + '"');
   END;

   IF ~!Z.HierarchicLink THEN
    dcw_WrLine('iZone', ').HierarchicLink:=LINK.Get("' + Z.MasterTable.Name + '", "' + Z.HierarchicLink.Name + '")');
   END;

   IF ~!Z.PermanentFilter THEN
    dcw_WrLine('iZone', ').PermanentFilter:="' + Z.PermanentFilter + '"');
   END;

   IF (Z.Number # 0) & ~!Z.SubwindowOriginalName THEN
    dcw_WrLine('iSubwindow', ', "' + Z.SubwindowOriginalName + '")');
   END;

   FirstPass:=1;
   FOR_EACH F IN Z.Fields DO
    dcw_WrSingleFieldScal2Attr(F, "Hierarchic");
    dcw_WrSingleFieldScal2Attr(F, "ReverseSorting");
    IF !F.TableField | (F.TableField.Table = Z.MasterTable) THEN
     IF ~!Z.FLevProg THEN
      dcw_WrSingleFieldScal2Attr(F, "OnBeforeAsk");
      dcw_WrSingleFieldScal2Attr(F, "AskMode");
      IF ~IsNotEditableZone(W, Z) THEN
       append2Array(F.OnSuccessfulChange, aSC, F.Name);
      END;
     END;
     IF !F.OwnerWindowOriginalName # !F.OwnerZoneNumber THEN
      FIO.WrStr(R, '  OWNERWINDOW!!! OwnerWindow="' + F.OwnerWindowOriginalName + '" OwnerZone=' + FLDTOSTR(F.OwnerZoneNumber, "0")); FIO.WrLn(R);
     END;
     dcw_WrSingleFieldStrAttr(F, "OwnerWindowOriginalName");
     dcw_WrSingleFieldNumAttr(F, "OwnerZoneNumber");

     dcw_WrSingleFieldScal2Attr_Ext(F, "LineBreakEnable", 1, FirstPass);
     IF ~IsNotEditableZone(W, Z) THEN
      dcw_WrSingleFieldScal2Attr_Ext(F, "First", 1, FirstPass);
      dcw_WrSingleFieldScal2Attr_Ext(F, "Last", 1, FirstPass);
      dcw_WrSingleFieldScal2Attr_Ext(F, "ScrollDisable", 1, FirstPass);
      append2Array(~F.MustBeNonempty & F.Modifiable, aNE, F.Name);
      append2Array(~F.Modifiable, aMD, F.Name);
     END;
    END;
   END; (* FOR_EACH F *)
   dcw_WrFieldAttrArray(aSC, "iScsChange", Z, FirstPass);
   i:=0;
   WHILE ~!aSC[i] DO
    IF ~Z.Fields(aSC[i]).Modifiable THEN
     FIO.WrStr(R, ',   !!! ࠡ稪 OnSuccessfulChange  㯭  FieldName=' + aSC[i]); FIO.WrLn(R);
    END;
    INC(i);
   END;

   dcw_WrFieldAttrArray(aMD, "iUnmodifiable", Z, FirstPass);
   dcw_WrFieldAttrArray(aNE, "iMayBeEmpty", Z, FirstPass);

   SETEMPTY(FieldsNames);
   i:=0;
   FOR_EACH F IN Z.Fields DO
    IF ~IsUniqueField(FieldsNames, F.Name) THEN
     FIO.WrStr(R, '  !!!      ' + F.Name); FIO.WrLn(R);
    END;
    FieldsNames[i]:=F.Name;
    INC(i);
    dcw_WrSingleFieldFormat(F);
   END; (* FOR_EACH F *)

   IF ~!curProgName THEN
    dcw_WrLine('iProgs', ', "' + curProgName + '")');
   END;
  END; (* IF ~!Z *)
 END {dcw_PutZone};

 PUBLIC PROCEDURE intDumpCurrentWindow(W: FORM_WINDOW);
  VAR
   ZN: SCAL[10];
 BEGIN
  FIO.WrStr(R, ' PRIVATE PROCEDURE ' + W.OriginalName + '_OnInitializeWindow();'); FIO.WrLn(R);
  FIO.WrStr(R, ' BEGIN'); FIO.WrLn(R);
  IF ~!W.MNUFileName THEN
   dcw_WrWindowLine('MNUFileName:="' + W.MNUFileName + '"');
  END;
  IF W.IgnoreProjectPal THEN
   dcw_WrWindowLine('IgnoreProjectPal:=1');
  END;
  FOR_EACH ZN DO
   dcw_PutZone(W, ZN);
  END;
  FIO.WrStr(R, ' END {' + W.OriginalName + '_OnInitializeWindow};'); FIO.WrLn(R);
  FIO.WrLn(R);
 END {intDumpCurrentWindow};

 PUBLIC PROCEDURE DumpCurrentWindow();
  VAR
   W: WINDOW;
 BEGIN
  W:=APP.Get().TopWindow;
  IF !W |(W.Type = WINDOW.Type_Survey) | (W.Type = WINDOW.Type_Browse) THEN
   L_General.Error("⮢   ");
  END;
(*
  W:=APP.Get().Forms.Load(W.OriginalName, W.OriginalName + "<७  >"(*, EMPTYOF(FORM_ZONE)*));
*)
  W:=APP.Get().Forms.LoadBlank(W.OriginalName, W.OriginalName + "<७  >"(*, EMPTYOF(FORM_ZONE)*));
  OPENREP(R, L_General.NameConnection("DmpCW"), Create);
  intDumpCurrentWindow(W);
  L_General.SurveyLastReport();
 END {DumpCurrentWindow};

END.
