(*
%Copyright   (c) Polak IT
%Author      19.04.2007 17:49:52 POLAK\San
%Purpose     㧪 ⮢   ⭮  XML, MS Word
%Type        operation
%Specific    SYS
%Modified    22.07.2014 08:42:51 POLAK\LDA
%Environment
*)

 MODULE ATER_Up2 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Packet, P_Firm, Str, L_Str, L_DatTim, L_MSO, L_StdFrm, FIO, L_XML, L_ATER, L_FIO;

 PRIVATE CONST
  TablesAmnt = 10;

 PRIVATE VAR
  MultiTables: LIKE(ATERAttr.Table)[TablesAmnt];

 PRIVATE PROCEDURE conv2Upload(Value: STRING[]): STRING[];
 BEGIN
  IF    L_ATER.IsEmptyValueForFSS_Sheet(Value) THEN
   RETURN "-";
  ELSIF (ATERAttr.Type = L_General.ft_NUMERIC) THEN
   RETURN FLDTOSTR(STRTOFLD(Value, NUMERIC), L_Packet.GetATERAttrFormat(), 0);
  ELSE
   RETURN Value;
  END;
 END {conv2Upload};

 PRIVATE PROCEDURE _ATERAttrInMultiTable(MultiTable: LIKE(ATERAttr.Table)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(ATERAttr);
  LOOP
   IF    ATERAttr.Table = MultiTable THEN
    Result:=1;
    EXIT;
   ELSIF ATERAttr.Table < MultiTable THEN
    Result:=0;
    EXIT;
   END;
   SELECT(ATERAttr, ATER, , ATERAttr.ATER, ATERAttr.xmlPrnTb);
  END; (* LOOP *)
  RESTORE(ATERAttr);
  RETURN Result;
 END {_ATERAttrInMultiTable};

 PRIVATE PROCEDURE ATERAttrInMultiTable(): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE ~!MultiTables[i] DO
   IF _ATERAttrInMultiTable(MultiTables[i]) THEN
    RETURN 1;
   END;
   INC(i);
  END; (* WHILE ~! ...*)
  RETURN 0;
 END {ATERAttrInMultiTable};

 PRIVATE PROCEDURE CreateNewWordDocument();
  VAR
   OnDate: DATE;
 BEGIN
  OnDate:=L_DatTim.MonthEnd(Packet.PerE);
  L_MSO.wordInitDocument(OnDate);
  L_MSO.wordSetVarsByFile_wPrefix("Packet", "");
  P_Firm.SetFirmData("Own", L_Packet.GetPacketOwnFirm(), OnDate, L_General.EMPTY_NUMBER(), L_MSO.fps_Soft_asStr);
 END {CreateNewWordDocument};

 PRIVATE PROCEDURE TableInMultiTable(trgTable: LIKE(ATERAttr.Table)): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE ~!MultiTables[i] DO
   IF MultiTables[i] = trgTable THEN
    RETURN 1;
   END;
   INC(i);
  END; (* WHILE ~! ...*)
  RETURN 0;
 END {TableInMultiTable};

 PRIVATE PROCEDURE CheckIsEmptyTable(_Table: LIKE(ATERAttr.Table); VAR Result: SCAL[2]; CheckWholeTable: SCAL[2]);
 BEGIN
  SAVE(ATERAttr);
  IF CheckWholeTable THEN
   SELECT(ATERAttr, ATER, , ATER.ATER, _Table);
  END;
  WHILE OCCURE(ATERAttr) & Result DO
   IF (ATERAttr.xmlElmTp = L_ATER.xet_xmlAttribute) | (ATERAttr.xmlElmTp = L_ATER.xet_SimpleElm) THEN
    Result:=!L_ATER.GetSingleAttr(L_ATER.ZeroTable, L_ATER.ZeroRow2);
   END;
   NEXT(ATERAttr);
  END; (* WHILE OCCURE(ATERAttr) ... *)
  IF Result THEN
   SELECT(ATERAttr, xmlPrnTb, , ATER.ATER, _Table);
   WHILE OCCURE(ATERAttr) & Result DO
    IF ATERAttr.Table # ATERAttr.xmlPrnTb THEN
     CHANGESEL(ATERAttr, xmlPrnTb, , ATERAttr.ATER, ATERAttr.xmlPrnTb, ATERAttr.Table);
     CheckIsEmptyTable(ATERAttr.Table, Result, 1);
     LAST(ATERAttr);
     CHANGESEL(ATERAttr, xmlPrnTb, , ATERAttr.ATER, ATERAttr.xmlPrnTb);
    END;
    NEXT(ATERAttr);
   END; (* WHILE OCCURE(ATERAttr) ... *)
  END;
  RESTORE(ATERAttr);
 END {CheckIsEmptyTable};

 PRIVATE PROCEDURE EmptyNode(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF    L_Packet.FSS_SheetwXML(ATERAttr.ATER) THEN
   IF ATERAttr.xmlElmTp = L_ATER.xet_ComplexElm THEN
    IF (ATERAttr.ATERAttr = "F4INF1") | (ATERAttr.ATERAttr = "F4INFO") THEN
    ELSE
     SAVE(PckATER);
     IF SELECT(PckATER, PckATER, Packet.Packet, ATERAttr.Table) THEN
      Result:=!PckATER.Value;
      WHILE OCCURE(PckATER) DO
       Result:=Result & !PckATER.Value;
       NEXT(PckATER);
      END; (* WHILE OCCURE(PckATER) ... *)
     ELSE
      Result:=~ATERAttr.NotEmpty;
     END;
     RESTORE(PckATER);
    END;
   END;
  ELSIF L_ATER.IsAcceptableFormatATER(ATERAttr.ATER) THEN
   IF ~ATERAttr.NotEmpty THEN
    Result:=1;
    CheckIsEmptyTable(ATERAttr.Table, Result, 0)
   END;
  END;
  RETURN Result;
 END {EmptyNode};

 PRIVATE PROCEDURE UploadInWord_wPn(): SCAL[2];
 BEGIN
  RETURN L_ATER.UploadInWord & L_ATER.CalcByPublicName();
 END {UploadInWord_wPn};

 PRIVATE PROCEDURE UploadSingleATERAttr(Table2: LIKE(PckATER.Table2));
  VAR
   Value  : STRING[];
   VarName: STRING[];
   PrnTbKey: STRING[];
   curNode: L_XML.tNode;
 BEGIN
  IF Table2 = L_ATER.ZeroTable THEN
   PROMPT(ATERAttr.ATERAttr);
  ELSE
   PROMPT(ATERAttr.ATERAttr + " ("+Table2+")");
  END;
  IF (ATERAttr.Kind # L_ATER.aak_System) &
     (((ATERAttr.xmlElmTp # L_ATER.xet_NotUpLoad) & ~EmptyNode()) | L_ATER.UploadInWord) THEN
   IF ~UploadInWord_wPn() THEN
    IF    ATERAttr.xmlElmTp = L_ATER.xet_ComplexElm THEN
     IF TableInMultiTable(ATERAttr.Table) THEN
      PrnTbKey:=L_ATER.Key(ATERAttr.xmlPrnTb, L_ATER.ZeroTable);
     ELSE
      PrnTbKey:=L_ATER.Key(ATERAttr.xmlPrnTb, Table2);
     END;
     L_General.CallUs(L_ATER.tblNodes.Exists(PrnTbKey) # 0);
     L_General.CallUs(L_ATER.tblNodes.Exists(L_ATER.Key(ATERAttr.Table, Table2)) = 0);
     L_ATER.tblNodes.Add(L_ATER.Key(ATERAttr.Table, Table2), L_XML.bd_PutNode(L_ATER.tblNodes(PrnTbKey), ATERAttr.ATERAttr, ""));
    ELSE
     Value:=conv2Upload(L_ATER.GetSingleAttr(Table2, L_ATER.ZeroRow2));
     IF ~!Value | ATERAttr.NotEmpty | L_ATER.UploadInWord THEN
      PrnTbKey:=L_ATER.Key(ATERAttr.xmlPrnTb, Table2);
      L_General.CallUs(L_ATER.tblNodes.Exists(PrnTbKey) # 0);
      curNode:=L_ATER.tblNodes(PrnTbKey);
      VarName:=ATERAttr.ATERAttr;
      IF    ATERAttr.xmlElmTp = L_ATER.xet_SimpleElm THEN
       L_XML.bd_PutLeafNode(curNode, ATERAttr.ATERAttr, Value);
      ELSIF (ATERAttr.xmlElmTp = L_ATER.xet_xmlAttribute) | (L_ATER.UploadInWord & (ATERAttr.xmlElmTp = L_ATER.xet_NotUpLoad)) THEN
       L_XML.bd_SetAttribute(curNode, ATERAttr.ATERAttr, Value);
      ELSE
       L_General.CallUs(0);
      END;
     END;
     IF L_ATER.UploadInWord THEN
      REPEAT
       VarName:=curNode.nodeName + "." + VarName;
       curNode:=curNode.parentNode;
      UNTIL curNode.nodeTypeString = "document";
      IF ATERAttrInMultiTable() THEN
       VarName:=VarName + L_MSO.IndexStr(Table2);
      END;
      L_MSO.wordSetVar(VarName, Value);
     END;
    END;
   ELSE
    IF ~!ATERAttr.PublicNm THEN
     VarName:=ATERAttr.PublicNm;
     IF ATERAttrInMultiTable() THEN
      VarName:=VarName + L_MSO.IndexStr(Table2);
     END;
     L_MSO.wordSetVar(VarName, conv2Upload(L_ATER.GetSingleAttr(Table2, L_ATER.ZeroRow2)));
    END;
   END;
  END;
 END {UploadSingleATERAttr};

 PRIVATE PROCEDURE PutBlinWordVars();
  VAR
   asExtNbr: NUMERIC[0];
 BEGIN
  IF ATER.ATER < 27 THEN
   asExtNbr:=STRTOFLD(Packet.ExtNbr, NUMERIC);
   IF asExtNbr > 1 THEN
    L_MSO.wordSetVar("ਧ", "3");
    L_MSO.wordSetVar("",  L_Str.IntStr(asExtNbr-1));
   ELSE
    L_MSO.wordSetVar("ਧ", "1");
    L_MSO.wordSetVar("",  "");
   END;
   L_MSO.wordSetVar("", P_Firm.FP_TaxDepCode(L_Packet.GetPacketOwnFirm(), SYSDATE()));
 
   IF ATER.Kind = L_Packet.knd_TT_AdvRep THEN
    L_MSO.wordSetVar(".㬥.Ꮵ.ਮ", L_Str.IntStr((L_DatTim.MONTH(Packet.PerE)+1)));
   END;
  END;
 END {PutBlinWordVars};

 PRIVATE PROCEDURE HasMultiTablePckATER(_Table, _Table2: LIKE(ATERAttr.Table)): SCAL[2];
 BEGIN
  SELECT(PckATER, Table2, , Packet.Packet, _Table2);
  WHILE OCCURE(PckATER) DO
   SEARCH(ATERAttr, ATER, , PckATER.ATER, PckATER.Table, PckATER.Row, PckATER.ATERAttr);
   IF _ATERAttrInMultiTable(_Table) THEN
    RETURN 1;
   END;
   NEXT(PckATER);
  END; (* WHILE OCCURE(PckATER) ... *)
  RETURN 0;
 END {HasMultiTablePckATER};

 PRIVATE PROCEDURE XMLFileRequiredXMLSchema(): SCAL[2];
 BEGIN
  RETURN ~L_Packet.FSS_SheetwXML(ATER.ATER) & (ATER.Kind # L_Packet.knd_RSV_1);
 END {XMLFileRequiredXMLSchema};

 PRIVATE PROCEDURE CreateRootNode();
  VAR
   Target, ExtDeclaration: STRING[];
 BEGIN
  IF L_Packet.FSS_SheetwXML(ATER.ATER) THEN
   Target        :='F4FORM';
   ExtDeclaration:='version="' + ATER.Version + '"';
  ELSE
   SETEMPTY(Target, ExtDeclaration);
  END;

  L_ATER.tblNodes.Add(L_ATER.Key(ATERAttr.Table, L_ATER.ZeroTable), L_XML.bd_Create_wExtDeclaration(ATERAttr.ATERAttr, Target, ExtDeclaration));
  IF XMLFileRequiredXMLSchema() THEN
   L_XML.bd_SetAttribute(L_ATER.tblNodes(L_ATER.Key(ATERAttr.Table, L_ATER.ZeroTable)), "xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
   IF STRTOFLD(ATER.Version, NUMERIC) < 5.0 THEN
    L_XML.bd_SetAttribute(L_ATER.tblNodes(L_ATER.Key(ATERAttr.Table, L_ATER.ZeroTable)), "xsi:noNamespaceSchemaLocation", ATER.xmlSchm);
   END;
  END;
  L_XML.NeedConvertStringVal:=0;
 END {CreateRootNode};

 PRIVATE PROCEDURE MergeMultiTableRequired(trgTable: LIKE(ATERAttr.Table)): SCAL[2];
 BEGIN
  RETURN L_ATER.UploadInWord & L_Packet.FSS_SheetwXML(ATER.ATER) &
         ((trgTable = 00004) | (trgTable = 00007));
 END {MergeMultiTableRequired};

 PRIVATE PROCEDURE UploadTable(trgTable, trgTable2: LIKE(ATERAttr.Table));
  VAR
   Value,
   PDocNum: STRING[];
 BEGIN
  APP.Get().NewPrompt("㧪.  " + trgTable);
  SETEMPTY(Value);
  SAVE(ATERAttr);
  REPEAT
   SELECT(ATERAttr, ATER, , ATER.ATER, trgTable);
   WHILE OCCURE(ATERAttr) DO
    IF ~UploadInWord_wPn() & (L_ATER.tblNodes.Count = 0) THEN
     CreateRootNode();
     NEXT(ATERAttr);
    END;

    IF MergeMultiTableRequired(trgTable) THEN
     IF    (ATERAttr.ATERAttr = "NUM") THEN
      PDocNum:=conv2Upload(L_ATER.GetSingleAttr(trgTable2, L_ATER.ZeroRow2));
     ELSIF (ATERAttr.ATERAttr = "DT") THEN
      Value:=L_Str.AddStrDlm(Value, L_MSO.L_MSO_wordNL()) + conv2Upload(L_ATER.GetSingleAttr(trgTable2, L_ATER.ZeroRow2)) + " " + PDocNum;
     END;
    ELSE
     UploadSingleATERAttr(trgTable2);
    END;
    NEXT(ATERAttr);
   END; (* WHILE OCCURE(ATERAttr) ... *)

   SELECT(ATERAttr, ATER, , ATER.ATER, trgTable);
   PROMPT(ATERAttr.Name);
   SELECT(ATERAttr, xmlPrnTb, , ATER.ATER, trgTable);
   WHILE OCCURE(ATERAttr) DO
    IF ATERAttr.Table # ATERAttr.xmlPrnTb THEN
     CHANGESEL(ATERAttr, xmlPrnTb, , ATERAttr.ATER, ATERAttr.xmlPrnTb, ATERAttr.Table);
     UploadTable(ATERAttr.Table, trgTable2);
     LAST(ATERAttr);
     CHANGESEL(ATERAttr, xmlPrnTb, , ATERAttr.ATER, ATERAttr.xmlPrnTb);
    END;
    NEXT(ATERAttr);
   END; (* WHILE OCCURE(ATERAttr) ... *)
   INC(trgTable2);
  UNTIL ~TableInMultiTable(trgTable) | ~HasMultiTablePckATER(trgTable, trgTable2);

  IF MergeMultiTableRequired(trgTable) THEN
   L_MSO.wordSetVar("PDoc" + trgTable, Value);
  END;

  RESTORE(ATERAttr);
 END {UploadTable};

 PRIVATE PROCEDURE extUploadPacket(PacketFName: STRING[]): STRING[];
  VAR
   wUseTmpDot         : SCAL[2];
   MainTemplate       : STRING[];
   Templates,
   NeedInsertPageBreak: STRING[][TablesAmnt];
   i, Row             : NUMERIC[0];
   _Table2            : LIKE(ATERAttr.Table);
   tmpPacketFName     : STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  IF ~L_ATER.TestUpload THEN
   L_General.Assert(SELECT(PckATER, Packet, Packet.Packet), "  ନ஢");
  END;
  CONFORM(Packet, ATER);
  L_General.Assert(~!Packet.ExtNbr, "   ");
  IF Packet.Receiver # L_Packet.rcv_e_TaxDep THEN
   L_General.CallUs(0);
  END;
  L_Packet.GetATERDescr(MainTemplate, MultiTables, Templates, NeedInsertPageBreak, wUseTmpDot);

  IF L_ATER.UploadInWord THEN
   L_General.Assert(~!MainTemplate, "㧪  MS Word  ।ᬮ७.|᫨  ⠥,   訡,   ");
   L_General.CallUs(~wUseTmpDot);
   CreateNewWordDocument();
   SETEMPTY(tmpPacketFName);
  ELSE
   tmpPacketFName:=L_FIO.tf_GetFullPath(L_FIO.effp_FileName_woExt(PacketFName), L_FIO.effp_FileExt(PacketFName));
  END;

  L_ATER.tblNodes:=L_General.CreateDictionary();
  IF SELECT(ATERAttr, ATER, ATER.ATER) THEN
   UploadTable(ATERAttr.Table, L_ATER.ZeroTable);
  ELSE
   L_General.Error("⮥ ᠭ ???");
  END;

  IF L_ATER.UploadInWord THEN
   i:=0;
   WHILE ~!MultiTables[i] DO
    IF ~MergeMultiTableRequired(MultiTables[i]) THEN
     _Table2:=00001;
     WHILE HasMultiTablePckATER(MultiTables[i], _Table2) DO
      INC(_Table2);
     END;
     L_MSO.SetWordTable("Table" + MultiTables[i], _Table2);
    END;
    INC(i);
   END; (* WHILE i <= HIGH(MultiTables) ...*)

   PutBlinWordVars();
   L_MSO.UseTmpDot:=wUseTmpDot;
   L_MSO.MakeWordDocument(MainTemplate, 1, L_MSO.PrpMode_ToDoc, "");
  ELSE
   FIRST(ATERAttr);
   L_XML.bd_Save(L_XML.bd_GetDocument(L_ATER.tblNodes(L_ATER.Key(ATERAttr.Table, L_ATER.ZeroTable))), tmpPacketFName);
  END;
  RETURN tmpPacketFName;
 END {extUploadPacket};

 PUBLIC PROCEDURE UploadPacket();
  VAR
   dstPacketFName: STRING[];
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭ ");
  L_ATER.TestUpload  :=0;
  L_ATER.UploadInWord:=0;
  dstPacketFName:=L_Packet.PacketTrnFullName(Packet.Receiver);

  L_FIO.ExactFileCopy(extUploadPacket(dstPacketFName), dstPacketFName);
  FIO.Erase(extUploadPacket(dstPacketFName));
 END {UploadPacket};

 PUBLIC PROCEDURE TestUploadPacket();
  VAR
   dstPacketFName: STRING[];
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭ ");
  L_ATER.TestUpload  :=1;
  L_ATER.UploadInWord:=0;
  dstPacketFName:=L_Packet.PacketTrnFullName(Packet.Receiver);

  FIO.Rename(extUploadPacket(dstPacketFName), , dstPacketFName);
  L_StdFrm.Inform("ନ஢ 䠩 " + dstPacketFName);
 END {TestUploadPacket};

 PUBLIC PROCEDURE UploadPacket_InWord();
  VAR
   Dummy: STRING[];
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭ ");
  L_ATER.TestUpload  :=0;
  L_ATER.UploadInWord:=1;
  Dummy:=extUploadPacket("");
 END {UploadPacket_InWord};

END.
