(*
%Copyright   (c) Polak IT
%Author      25.03.2004 10:42:41 POLAK\LDA
%Purpose     ࠢ ⠬    壠᪮ ⭮
%Type        control
%Specific    SYS
%Modified    22.09.2014 16:48:08 POLAK\Bor
%Environment
*)

 MODULE ATER_Lnc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Packet, L_Str, L_AFM, L_Excel, L_StdFrm, FIO, L_DatTim, L_FIO, L_ATER;

 PRIVATE CONST
  o_Upload = 0;
  o_Print  = 1;

 PUBLIC PROCEDURE MakePacket();
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭ ");
  L_General.Assert(Packet.Status = L_Packet.st_InProcess, " 묨  ⮫쪮    ﭨ ' ࠡ'");
  CONFORM(Packet, ATER);
  IF    ATER.Kind = L_Packet.knd_TT_Decl THEN
   IF L_DatTim.YEAR(Packet.PerB) >= 2012 THEN
    CALL(XOMN14.XOMN14());
   ELSE
    CALL(XOMN7.XOMN7());
   END;
  ELSIF ATER.Kind = L_Packet.knd_TT_AdvRep THEN
   CALL(XOMN7.XOMN7());
  ELSIF (ATER.Kind = L_Packet.knd_FSS_Sheet) THEN
   CALL(XOMN8.MakeFSSSheet());
  ELSIF (ATER.Kind = L_Packet.knd_CPT_AdvRep) | (ATER.Kind = L_Packet.knd_CPT_Decl) THEN
   CALL(XOMN9.XOMN9());
  ELSIF ATER.Kind = L_Packet.knd_USNO_Decl THEN
   CALL(XOMN10.XOMN10());
  ELSIF ATER.Kind = L_Packet.knd_RSV_1 THEN
   IF    L_DatTim.YEAR(Packet.PerB) >= 2014 THEN
    CALL(XOMN16.XOMN16());
   ELSIF L_DatTim.YEAR(Packet.PerB) >= 2013 THEN
    CALL(XOMN15.XOMN15());
   ELSIF L_DatTim.YEAR(Packet.PerB) >= 2012 THEN
    CALL(XOMN13.XOMN13());
   ELSE
    CALL(XOMN11.XOMN11());
   END;
  ELSIF ATER.Kind = L_Packet.knd_AvgCnt THEN
   CALL(XOMN12.XOMN12());
  ELSIF ATER.Kind = L_Packet.knd_VAT THEN
   CALL(VAT02.DoATER());
  ELSIF (ATER.Kind = L_Packet.knd_ESN_AdvRep) | (ATER.Kind = L_Packet.knd_ESN_Decl) |
        (ATER.Kind = L_Packet.knd_VPS_AdvRep) | (ATER.Kind = L_Packet.knd_VPS_Decl) THEN
   CheckAcceptableFormatATER(ATER.ATER, "  묨")
   L_General.CallUs(0); (*CALL(XOMN6.XOMN6());*)
  ELSE
   L_General.Error(" ଠ ");
  END;
 END {MakePacket};

 PUBLIC PROCEDURE ClearPacket();
 BEGIN
  L_Packet.ClearATER(1);
 END {ClearPacket};

 PRIVATE PROCEDURE HasActualPFRPacket(PFRDTStamp: LIKE(Packet.DTStamp)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(Packet);
  IF SELECT(Packet, PckDTSPk, L_Packet.rcv_PensFund, PFRDTStamp) THEN
   Result:=1;
   WHILE OCCURE(Packet) & Result DO
    IF (Packet.Status = L_Packet.st_Rejected) | (Packet.Status = L_Packet.st_Canceled) THEN
     Result:=0;
    END;
    NEXT(Packet);
   END; (* WHILE OCCURE(Packet) ... *)
  ELSE
   Result:=0;
  END;
  RESTORE(Packet);
  RETURN Result;
 END {HasActualPFRPacket};

 PRIVATE PROCEDURE CheckPFRPacket();
  VAR
   PFRDTStamp: LIKE(Packet.DTStamp);
 BEGIN
  PFRDTStamp:=L_Packet.GetPFRDTStampFromRSV();
  IF ~!PFRDTStamp & ~HasActualPFRPacket(PFRDTStamp) THEN
   L_General.Error("  ᮭ஢ ⮬ 뫨 .|" +
                   "室  믮 楤   묨 ⥬");
  END;
 END {CheckPFRPacket};

 PRIVATE PROCEDURE CheckAcceptableFormatATER(trgATER: LIKE(ATER.ATER); Action: STRING[]);
 BEGIN
  IF ~L_ATER.IsAcceptableFormatATER(trgATER) THEN
   L_General.Error("ଠ   ॢ訬,|" +
                   Action + " " + L_StdFrm.HR() +
                   "᫨  㢥७  ࠢ쭮 ᢮ ⢨,|" +
                   "  ");
  END;
 END {CheckAcceptableFormatATER};

 PRIVATE PROCEDURE CheckAcceptablePacket(wCheckATER: SCAL[2]; Action: STRING[]);
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭ ");
  L_General.Assert(Packet.DTStamp # 0, " 믮  ");
  IF wCheckATER THEN
   CheckAcceptableFormatATER(Packet.ATER, Action);
  END;
  CheckPFRPacket();
 END {CheckAcceptablePacket};

 PRIVATE PROCEDURE DoAnyPacketOperation(Operation: SCAL[2]);
 BEGIN
  CheckAcceptablePacket(1, L_Str.PoolItem("ନ஢ ࠭ᯮ⭮ 䠩|  䠩", Operation));
  IF    Operation = o_Upload THEN
   CALL(ATER_Up2.UploadPacket());
  ELSIF Operation = o_Print THEN
   CALL(ATER_Up2.UploadPacket_InWord());
  ELSE
   L_General.CallUs(0);
  END;
 END {DoAnyPacketOperation};

 PUBLIC PROCEDURE CreateTransportFile();
 BEGIN
  DoAnyPacketOperation(o_Upload);
 END {CreateTransportFile};

 PUBLIC PROCEDURE UploadPacket();
  VAR
   Msg: STRING[];
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭ ");
  IF Packet.Status # L_Packet.st_Prepared THEN
   Msg:="  ﭨ '" + L_Str.PoolItem(L_Packet.st_Pool, Packet.Status) + "'";
   IF APP.Get().ProductiveCopy THEN
    L_General.Error(Msg);
   ELSE
    L_StdFrm.Choice(Msg + "|| ୮  - ");
   END;
  END;
  L_General.Assert(SELECT(PckATER, PckATER, Packet.Packet), " 믮 楤   묨");
  CheckPFRPacket();
  L_Packet.CopyPacketTrn();
 END {UploadPacket};

 PUBLIC PROCEDURE PrintPacket();
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭ ");
  IF Packet.Status = L_Packet.st_InProcess THEN
   L_StdFrm.Choice("  ﭨ ' ࠡ'");
  END;
  DoAnyPacketOperation(o_Print);
 END {PrintPacket};

 PUBLIC PROCEDURE PrintPacket_InExcel();
 BEGIN
  L_General.TellThisReportIsToRemoveCandidate(01\06\2015); (* 0104552 22.09.2014 16:48:04 POLAK\Bor *)
  CheckAcceptablePacket(0, "");
  L_General.Assert(SELECT(PckATER, Packet, Packet.Packet), "   ");
  L_AFM.AF_MakeDataBaseStructureCopy("PckATER", "PckAt", "NumValue: NUMERIC[3]", L_AFM.tdm_CurSelect);

  SELECT(PckATER, Packet, , Packet.Packet);
  WHILE OCCURE(PckATER) DO
   PROMPT("ࠡ⪠ " + PckATER.ATERAttr);
   CONFORM(PckATER, ATERAttr);
   IF ATERAttr.Type = L_General.ft_NUMERIC THEN
    SEARCH(PckAt, Table, , Packet.Packet, PckATER.Table, PckATER.Table2, PckATER.Row2, PckATER.Row, PckATER.ATERAttr);
    PckAt.NumValue:=STRTOFLD(PckATER.Value, NUMERIC);
    REPLACE(PckAt);
   END;
   NEXT(PckATER);
  END; (* WHILE OCCURE(PckATER) ... *)
  L_Excel.UploadFileToExcel(1, 1, "PckATER");
 END {PrintPacket_InExcel};

END.
