(*
%Copyright   (c) Polak Computer System
%Author      SAN
%Purpose     ⠭ ⥬   ਡ⮢ ⠭樨  Memo
%Type        operation
%Specific    SYS
%Modified    23.09.2014 12:37:51 POLAK\LDA
%Environment
*)

 MODULE AutoExec [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_ACL, L_DatTim, L_Str, L_Timer, L_WDO,
        L_APtm, L_StdFrm, L_NetWrk, L_SES, L_Msg, FIO, Math, Str,
        SysLog, E_Utils, L_PCS, L_AR, L_Guard,
        P_Man, L_Staff, L_SprtCrsp, L_Events, L_Prop, L_APMsg;

 PRIVATE CONST
  BackupPeriodicity = 1;

 PRIVATE PROCEDURE _MaxConnAssert(Cond: SCAL[2]; Max: NUMERIC[0]; Subj: STRING[]);
 BEGIN
  L_General.Assert_wReferToAdmin(Cond,
                                 "⨣ ᨬ쭮 ⢮ 祭 (" + L_Str.IntStr(Max) + ")" +
                                 "| " + Subj);
 END {_MaxConnAssert};

 PRIVATE PROCEDURE CheckRights();
  VAR
   ErrMsg: STRING[];
   curMan: LIKE(Man.Man);
   curTSN: LIKE(Staff.TSN);
 BEGIN
  IF ~L_General.IsOurSite() THEN
   ErrMsg:="";
   IF    ~L_General.IsMemberOf(L_APtm.g_APSupport) THEN
    IF L_General.IsProgrammer() THEN
     ErrMsg:=" ਧ  ࠢ .";
    END;
   ELSIF ~Str.Match(LOGINNAME(), "*.Polak") THEN
    ErrMsg:="⨬ ⨥ 짮⥫ " + LOGINNAME() + "  㯯 " + L_APtm.g_APSupport;
   END;
   IF ~!ErrMsg THEN
    L_StdFrm.Inform(ErrMsg + "|饭 ࠡ  ⮏થ");
    ABORTASBPROCESSOR();
   END;
  END;
  TRY
   L_AR.GrantRightsUnconditionally();
   IF ~(L_General.IsOurEngineeringCopy() | L_General.IsProgrammer() | L_General.IsAdmin()) THEN
    IF L_AR.StandOnUser(LOGINNAME()) THEN
     L_General.Assert_wReferToAdmin(L_DatTim.IsActive(SYSDATE(), AcsObj.Begin, AcsObj.Till),
                                    "  '짮⥫' '" + LOGINNAME() + "'  ");
     curMan:=P_Man.Try_curUSER2Man();
     IF ~!curMan THEN
      IF AcsObj.ManAssT = L_AR.aomat_Staff THEN
       SEARCH(Man, Man, , curMan);
       curTSN:=L_Staff.Man2TSN(SYSDATE(), curMan, "", 0, 0);
       L_General.Assert_wReferToAdmin(~!curTSN & SEARCH(Staff, TSN, curTSN) & L_Staff.rInState(SYSDATE()),
                                      "饭 ࠡ   䨧,  饣  " +
                                      "|(" + Man.Name + ")");
      END;
     ELSE
      IF (AcsObj.ManAssT # L_AR.aomat_NotMan) & (AcsObj.ManAssT # L_AR.aomat_Robot) & ~L_APtm.IsOutPost() THEN
       L_StdFrm.RedInform(" ࠢ筨 '짮⥫'  ஥   '" + LOGINNAME() + "'.|" +
                          "믮  権  ⮏ 㤥 .||" +
                          ",     ன 襩 .");
      END;
     END;
     _MaxConnAssert(!AcsObj.MCTotal | (L_NetWrk.GetTotalMyConnectionsAmount() <= AcsObj.MCTotal),
                    AcsObj.MCTotal, "짮⥫ " + LOGINNAME());
     _MaxConnAssert(!AcsObj.MCSngSt | (L_NetWrk.GetTheStationMyConnectionsAmount() <= AcsObj.MCSngSt),
                    AcsObj.MCSngSt, "짮⥫ " + LOGINNAME() + "   ");
    ELSE
     L_General.Assert_wReferToAdmin(0, " ࠢ筨 '짮⥫'    '" + LOGINNAME() + "'");
    END;
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   IF ~L_General.IsLockReleaseException(Exc) THEN
    L_StdFrm.TimedINFORM_AsSTOP(Exc.MsgOriginalText, 10);
    IF ~L_General.IsProgrammer() THEN
     ABORTASBPROCESSOR();
    END;
   END;
  END; (* TRY *)
 END {CheckRights};

 PRIVATE PROCEDURE GetEnvRunProgAtStart(): ENVVAR;
 BEGIN
  RETURN APP.Get().SesEnv.Item("RunProgAtStart");
 END {GetEnvRunProgAtStart};

 PRIVATE PROCEDURE CheckExpireSprtCrspRequired(): SCAL[2];
  CONST
   ESPSD = "LastExpSpCrShowDate";
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=1;
  TRY
   TABLE.Get("SES").AccessDataMode:=adm_HOTTEST;
   Result:=L_SES.GetFieldValue_asDATE(L_SES.sit_User, ESPSD, L_DatTim.MINDATE()) < SYSDATE();
  EXCEPT
  ON Exc: Exc_AccessDeny DO
  END; (* TRY *)
  IF Result THEN
   L_SES.PutValueAtSlaveTrn(L_SES.sit_User, ESPSD, FLDTOSTR(SYSDATE()));
  END;
  RETURN Result;
 END {CheckExpireSprtCrspRequired};

 PRIVATE PROCEDURE CheckExpireSprtCrsp();
 BEGIN
  IF L_General.IsAdmin() & !GetEnvRunProgAtStart() & ~L_General.IsOurEngineeringCopy() THEN
   TRY
    IF CheckExpireSprtCrspRequired() THEN
     CALL(SprtCrsp.ShowExpireSprtCrsp_AtAutoexec());
    END;
   EXCEPT
   ON Exc: Exc_AccessDeny DO
   END; (* TRY *)
  END;
 END {CheckExpireSprtCrsp};

 PRIVATE PROCEDURE E_LaunchAtLast();
  VAR
   local  : PROC;
   default: STRING[];
 BEGIN
  IF L_Guard.IsGuardConnection(APP.Get().MyConnection) THEN
   LIKEMENU(CALL, "Guard.Play()");
  ELSIF L_Guard.IsJobConnection(APP.Get().MyConnection) THEN
   L_Guard.ExecuteMyself();
  ELSE
   IF ~L_General.IsLocalMode() THEN
    L_Guard.SetGuard();
   END;
   IF ~!GetEnvRunProgAtStart() THEN
    LIKEMENU(CALL, "AutoExec.RunProgAtStart()");
   ELSE
    IF APP.Get().ProductiveCopy & ~L_General.IsMemberOf(L_APtm.g_APSupport) THEN
     CheckBackupRemoteness();
     CheckExpireSprtCrsp();
     IF ~L_General.IsLocalMode() THEN
      CALL(UIStat.Gather());
     END;
     L_APMsg.MakeCongratulationMessages(1, L_General.curUSER);
    END;
    SETEMPTY(default);
    IF USERDOMAIN() # "UNDEFINED" THEN
     IF    L_General.IsEndUser() THEN
      default:='CALL, "Ksk.Kiosk()"';
     ELSIF L_APtm.IsOutPost() THEN
      default:='CALL, "BegRWS.OutPost_SetTimer()", ShowWin, "OutPost 0", CALL, "BegRWS.OutPost()"';
     END;
    END;
    local:=PROCREF(E_Utils.AutoExec_LaunchAtLast);
    IF ~!local THEN
     default:=local(default);
    END;
    L_ACL.ProceedFromAutoExec(default);
    L_Msg.CheckIncomingMessage(L_Msg.mi_Low);
   END;
  END;
 END {E_LaunchAtLast};

 PRIVATE PROCEDURE SetMemoDate();
  VAR
   sysPeriod,
   curPeriod,
   endPeriod: DATE;
 BEGIN
  TRY [TRANSACTION(TRANSACTION_SLAVE)]
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   L_AR.GrantRightsUnconditionally();
   sysPeriod:=L_DatTim.Per(SYSDATE());
   endPeriod:=L_DatTim.IncMonth(sysPeriod, +18);
   IF ~SEARCH(Month, Period, endPeriod) THEN
    IF SELECT(Month, Period) THEN
     L_General.Assert(sysPeriod >= Month.Period, "⥬ ६  ࢮ   Month");
     LAST(Month);
     curPeriod:=Month.Period;
    ELSE
     curPeriod:=L_DatTim.IncYear(sysPeriod, -3);
    END;
    WHILE curPeriod < endPeriod DO
     curPeriod:=L_DatTim.IncMonth(curPeriod, +1);
     DEFAULT(Month);
     Month.Period:=curPeriod;
     INSERT(Month);
     CALL(Month.FillCalendar());
     CALL(Month.CalcBalInfo());
    END; (* WHILE curPeriod # sysPeriod... *)
   END; (* IF ~SEARCH(Month, Period, endPeriod) ... *)
  EXCEPT
  ON Exc: Exc_AccessDeny DO
  END; (* TRY *)
  TRY [TRANSACTION(TRANSACTION_SLAVE2)]
   Memo.ud_SetCurDate(SYSDATE());
  EXCEPT
  END; (* TRY *)
 END {SetMemoDate};

 PRIVATE PROCEDURE CheckBackupRemoteness();
  CONST
   DayPat  = "ࠡ稩 |ࠡ |ࠡ ";
   PassPat = "襫|諮|諮";
  VAR
   Days: NUMERIC[0];
 BEGIN
  IF !GetEnvRunProgAtStart() & L_General.IsAdmin() & ~L_General.IsOurEngineeringCopy() THEN
   Days:=0;
   TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    IF SELECT(SYSLOG, SYSLOG1, SysLog.UserEvent, "BACKUP") & LAST(SYSLOG) THEN
     Days:=L_DatTim.WorkDaysInIntvl_Inc(SYSLOG.Date + (SYSLOG.ETime > 08:00), SYSDATE() - 1);
    END;
   EXCEPT
   ON Exc: Exc_AccessDeny DO
    IF Exc.ErrorCode # L_General.ec_ad_IsLockedByOtherConnection THEN
     RAISE();
    END;
   END; (* TRY *)
   IF (Days > 0) & (Days >= BackupPeriodicity) THEN
    L_StdFrm.TimedINFORM_AsSTOP("|  ᫥ ᮧ १ࢭ  |" +
                                Str.EnumObject(Days, PassPat) + " 㦥 " + L_Str.IntStr(Days) + " " +
                                Str.EnumObject(Days, DayPat), 60);
   END;
  END;
 END {CheckBackupRemoteness};

 PUBLIC PROCEDURE RunProgAtStart();
  CONST
   w_EnvPrm   = 78;
   ErrMsgHead = " ६ ᪠ ⮏  ࠬࠬ ந諠 訡.||";
  VAR
   evRPAS,
   evEARn,
   evCmnt     : ENVVAR;
   i          : NUMERIC[0];
   Msg,
   CurParam,
   MarkComment: STRING[];
 BEGIN
  TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)]
   SE_APPWIN_SIZE(L_General.MainWindowStandartWidth(), L_General.MainWindowStandartHeight());
 
   SETZERO(i);
   SETEMPTY(evRPAS, evEARn, evCmnt);
   Msg:="||" +
        Str.Align("ࠬ:", w_EnvPrm, LEFT) +
        "||";
   WHILE i < APP.Get().SesEnv.Count DO
    CurParam:=APP.Get().SesEnv.Item(i).Name;
    IF    CurParam = "RunProgAtStart" THEN
     evRPAS:=APP.Get().SesEnv.Item(i);
    ELSIF CurParam = "ExitAfterRun" THEN
     evEARn:=APP.Get().SesEnv.Item(i);
    ELSIF CurParam = "Comment" THEN
     evCmnt:=APP.Get().SesEnv.Item(i);
    ELSE
     IF ~!CurParam THEN
      L_General.Error(ErrMsgHead + " ࠬ: " + CurParam);
     ELSE
      L_General.Error(ErrMsgHead + "ᯮ짮 -SesEnv:   ࠬ஬");
     END;
    END;
    Msg:=Msg + Str.Align(CurParam + "='" + APP.Get().SesEnv.Item(i).Value + "'", w_EnvPrm, LEFT) + "|";
    INC(i);
   END (*WHILE i < APP.Get().SesEnv.Count*);
 
   L_General.Assert(~!evRPAS, ErrMsgHead + " 易⥫ ࠬ RunProgAtStart");
   IF ~!evEARn & ~!evEARn.Value & (Str.Cap(evEARn.Value) # "NO") & (Str.Cap(evEARn.Value) # "SILENT") THEN
    L_General.Error(ErrMsgHead +
                    "⭮ 祭 ࠬ ExitAfterRun:" + CHR(34) + evEARn.Value + CHR(34));
   END;
   IF ~!evCmnt THEN
    L_PCS.CurrentProcess:=evCmnt.Value;
    L_PCS.SetApplicationTitle();
    MarkComment:=evCmnt.Value;
   ELSE
    MarkComment:="";
   END;
IF Str.Match(Str.Cap(evRPAS.Value), "*I_SOCPSG3*") & Str.Match(Str.Cap(evRPAS.Value), "*202*") THEN
 L_General.Error(ErrMsgHead +
                 "맮 '" + evRPAS.Value + "'  ॢ訬, ᫥    'i_SocPsg3.ImportForYesterday()'");
END;
   TRY
    SysLog.Mark(evRPAS.Value, MarkComment, L_General.sle_RunProgAtStart);
    L_General.BatchExecution_Begin(L_General.curUSER);
    CALL(^(evRPAS.Value));
    L_General.BatchExecution_End();
 
    IF    !evEARn | !evEARn.Value THEN
     L_StdFrm.TimedINFORM(" ⮏  ࠬࠬ 믮 ᯥ譮." + Msg +
                          "||⮏ 㤥 .", 30);
     LIKEMENU(Exit, "");
    ELSIF Str.Cap(evEARn.Value) = "SILENT" THEN
     LIKEMENU(Exit, "");
    ELSE
     L_StdFrm.Inform(" ⮏  ࠬࠬ 믮 ᯥ譮." + Msg);
    END;
   EXCEPT
   ON Exc:Exc_Root DO
    L_StdFrm.RedInform(ErrMsgHead + Exc.MsgOriginalText + Msg);
   END; (* TRY *)
   L_PCS.CurrentProcess:="";
   L_PCS.SetApplicationTitle();
  EXCEPT
  END; (* TRY *)
 END {RunProgAtStart};

 PRIVATE PROCEDURE SetTitleComment();
  VAR
   i: NUMERIC[0];
 BEGIN
  L_PCS.CurrentProcess:="";
  i:=0;
  WHILE i < APP.Get().SesEnv.Count DO
   IF APP.Get().SesEnv.Item(i).Name = "Comment" THEN
    L_PCS.CurrentProcess:=APP.Get().SesEnv.Item(i).Value;
   END;
   INC(i);
  END (*WHILE i < APP.Get().SesEnv.Count*);
  L_PCS.SetApplicationTitle();
 END {SetTitleComment};

 PRIVATE PROCEDURE CheckDebugModules();
  CONST
   a_Modified = "%Modified    ";
  VAR
   S,
   fName,
   _Path,
   SavePath,
   FormStr,
   List,
   FileList,
   BadFileList: STRING[];
   fso        : OBJECT;
   Files      : ENUMERATOR;
   i,
   Pos,
   React,
   MaxLength  : NUMERIC[0];
 BEGIN
  IF APP.Get().SupportMode THEN
   APP.Get().NewPrompt(" AP_SUPPORT");
   _Path:=FIO.AsbSpecialFolders("ClientRedFileDir");
   fso:=CreateOBJECT("Scripting.FileSystemObject");
   Files:=CreateENUMERATOR(fso.GetFolder(_Path).Files);
   MaxLength:=40;
   List    :="";
   FileList:="";
   WHILE ~Files.AtEnd() DO
    fName:=Files.Item().Name;
    PROMPT(fName);
    IF  Str.Match(Str.Cap(fName), "*.ASL") |
        Str.Match(Str.Cap(fName), "*.WDO") |
        Str.Match(Str.Cap(fName), "*.MNU") |
        Str.Match(Str.Cap(fName), "*.DOT") THEN
     SETEMPTY(S);
     TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
      FIO.Open(F, FIO.BuildPath(fName, , _Path), , Input);
      IF FIO.RdByte(F, S, Files.Item().Size) THEN
       Pos:=Str.Pos(S, a_Modified)+Str.Length(a_Modified);
       IF Pos < Str.Length(S) THEN
        S:=Str.Slice(S, Pos, Str.Pos(S, L_Str.CRLF, Pos)-Pos);
       ELSE
        SETEMPTY(S);
       END;
      END;
      FIO.Close(F);
     EXCEPT
     ON Exc: Exc_Root DO
      (*祣  *)
     END; (* TRY *)

     IF !S THEN
      S:=FLDTOSTR(Files.Item().DateLastModified, "D.N.y H:M:S") + " ⭮ ";
     END;
     S:=Str.Align(fName, 16, LEFT) + " " + S;
     List:=List + "|"+ S;
     FileList:=FileList+"|"+fName;
     MaxLength:=Math.Max(MaxLength, Str.Length(S));
    END;
    Files.MoveNext();
   END;

   PROMPT("");

   IF ~!List THEN
    SavePath:=FIO.BuildPath("SAVE", , _Path);
    IF ~FIO.DirExists(SavePath) THEN
     FIO.MkDir(SavePath);
    END;
    SavePath:=FIO.BuildPath(L_DatTim.SysDateTimeStamp(), , SavePath);
    MaxLength:=Math.Max(MaxLength, Str.Length(SavePath));
    FormStr:=" ⠫ " + _Path + "  㫨:";
    MaxLength:=Math.Max(MaxLength, Str.Length(FormStr));
    FormStr:=Str.Align(FormStr, MaxLength, LEFT) + "|";
    i:=0;
    WHILE ~!L_Str.PoolItem(List, i) DO
     FormStr:=FormStr + "|" + Str.Align(L_Str.PoolItem(List, i), MaxLength, LEFT);
     INC(i);
    END;
    FormStr:=FormStr + "||" + Str.Align(" ६  ", MaxLength, LEFT) +
             "|" + Str.Align(SavePath, MaxLength, LEFT) +
             "|| %< {} ६ >DX   %< {}६ >B";
    IF STDFORM(FormStr) THEN
     IF ~FIO.DirExists(SavePath) THEN
      FIO.MkDir(SavePath);
     END;
     SETEMPTY(BadFileList);
     i:=0;
     fName:=L_Str.PoolItem(FileList, i);
     WHILE ~!fName DO
      PROMPT("६饭 " + fName);
      LOOP
       TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
        FIO.RenMov(FIO.BuildPath(fName, , _Path), , FIO.BuildPath(fName, , SavePath));
        EXIT;
       EXCEPT
       ON Exc: Exc_Root DO
        BadFileList:=BadFileList + fName + "|";
        React:=STDFORM(" 㤠 ६ 䠩 " + fName + "||" +
                       "ᠭ 訡:|" +
                       Exc.MsgOriginalText + "||" +
                       "|| %<  ⬥  >X  %<   >FDB  %< ய >B", "", INFORM_RED, 1);

       END; (* TRY *)
       IF React = 2 THEN
        EXIT;
       END;
      END; (* LOOP *)
      INC(i);
      fName:=L_Str.PoolItem(FileList, i);
     END; (* WHILE ~!fName...*)
     IF ~!BadFileList THEN
      L_StdFrm.RedInform(" 㤠 ६ ᫥騥 䠩:||" + BadFileList);
     END;
    END;
   END;
  END; (* IF (L_General.IsOurSite() & L_General.IsProgrammer()...*)
 END {CheckDebugModules};

 PRIVATE PROCEDURE GetUser();
 BEGIN
  TRY [TRANSACTION(TRANSACTION_SLAVE), MSG_SUPPRESSION(MSG_SUPPRESSION_NONE)]
   L_AR.GrantRightsUnconditionally();
   L_General.curUSER:=L_AR.GetUser(LOGINNAME());
   L_PCS.GrantRights(L_AR.srm_Autoexec);
  EXCEPT
  END; (* TRY *)
 END {GetUser};

 PRIVATE PROCEDURE SetCacheableTables();
 BEGIN
  IF L_General.IsAcceptableProcessorVersion(14260140) THEN
   TABLE.Get("Alower"  ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("Apport"  ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("CarUnit" ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("Column"  ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("ClmnPro" ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("Dest"    ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("DstMode" ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("ERKN"    ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("erkns"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("JMode"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("JRegime" ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("Mark"    ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MarkFuel").Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MathType").Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MCList"  ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MCGroup" ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MCPro"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MDMth"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MDocKind").Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MMode"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MoneyRul").Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MyFirm"  ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MFPro"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MyPlace" ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MPPro"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MtyIdx"  ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MySite"  ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MSPro"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("MUnit"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("Officer" ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("OfcDst"  ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("OwnDPro" ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("PDocKind").Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("Quality" ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("Route"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("RouteLog").Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("RoutMod" ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("Sort"    ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("SortPro" ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("SLKind"  ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("TKind"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("WJMode"  ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("WJMethod").Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("WJMty"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("AcCut"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("ACLog"   ).Cacheable:=TABLE.Cacheable_ON;
   TABLE.Get("CAcnt"   ).Cacheable:=TABLE.Cacheable_ON;
  END;
 END {SetCacheableTables};

 PUBLIC PROCEDURE Start();
 BEGIN
  TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)] (*   .  Esc,   , ࢥ. *)
   APP.Get().ProductiveCopy:=~L_General.IsOurEngineeringCopy();
   APP.Get().SupportMode   :=APP.Get().ProductiveCopy &
                             L_General.IsMemberOf(L_APtm.g_APSupport) &
                             L_General.IsAPSupportFolder(FIO.AsbSpecialFolders("ClientRedFileDir"));
   IF L_General.IsAcceptableProcessorVersion(14216090) & L_StdFrm.wGUI() THEN
    APP.Get().OnOpenCalendar:="clnd.OnOpenCalendar";
   END;
   IF L_NetWrk.IsAutomationServer() THEN
    GetUser();
   ELSE
    APP.Get().NewPrompt("믮 室  ⮏");
    TRY
     GetUser();
     CheckRights();
     Memo.DefineSesValues();
     L_WDO.v_dbConnection:=APP.Get().MyConnection.Number;
     SetMemoDate();
     APP.Get().OnAfterInteractiveModification:="CallStub.OnAfterInteractiveModification";
     APP.Get().OnCallAuthor                  :="CallStub.HandleException";
     APP.Get().OnInitializeZoneFilters       :="CallStub.OnInitializeZoneFilters";
     L_Timer.InitTimers();
     SetTitleComment();
     CheckDebugModules();
     SetCacheableTables();
    EXCEPT
    ON Exc: Exc_Root DO
     IF L_General.IsProgrammer() THEN
      L_StdFrm.RedInform(L_General.ExcDescription(Exc));
     ELSE
      L_StdFrm.RedInform(L_General.ExcDescription(Exc) +
                         "||㤥 믮 १ ⮏");
      ABORTASBPROCESSOR(RESTART);
     END;
    END; (* TRY *)
   END;
  EXCEPT
  END; (* TRY *)
  IF ~L_NetWrk.IsAutomationServer() THEN
   E_LaunchAtLast();
  END;
 END {Start};

BEGIN
 TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)] (*   .  Esc,   , ࢥ. *)
  IF    !MODE THEN
   Start();
  ELSIF MODE # L_Events.md_InIMPORT THEN
   L_General.BadMode(MODE);
  END;
 EXCEPT
 END; (* TRY *)
END.
