(*
%Copyright   (c) Polak Computer System
%Author      SAN
%Purpose      ᪠, 쭨筮,  ।
%Type        control
%Specific    SYS
%Modified    14.08.2014 16:20:01 POLAK\Gina
%Environment
*)

 MODULE AvePay [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, L_XDoc, L_EC, L_AvePay, L_PRoll,
        L_Card, L_Sheet, L_OwnData, L_AFM, L_Staff, L_Man, L_APtm,
        P_Union, Math, Memo, E_PRoll, L_Env, P_AveP, L_EDO, L_two,
        L_StdFrm, L_AcsPnt, L_AR, P_MCList, L_Str, P_Officer, P_Firm,
        L_SysLog, L_WDO;

 PRIVATE TYPE
  tPreciseAvr = NUMERIC[5];
  tDays       = NUMERIC[3];

 PRIVATE CONST
  DisNE = 0;
  SisNE = 1;
  HisNE = 2;
  AisNE = 3;
  MaxDaily = 366;
  IdentAveragePer = 01\01\2004;

  acspnt_AvePayModify = 0000018;

 PRIVATE VAR
  ProcDo,
  ProtDo,
  ToWord,
  TrialAvepayMode,
  StreamMode: SCAL[2];
  ToWordHistIdx,
  Store     : NUMERIC[0];

  Date,
  ActPer    : DATE;

  DayCount,
  MonDays,
  TotDays   : tDays;
  HDCount,
  MonLineCnt: NUMERIC[0];
  MonTime,
  TotTime   : L_PRoll.tTime;
  TotSum    : L_PRoll.tSum;
  ToWordDays: tDays[2];
  ToWordHistSum    : L_PRoll.tSum;
  ToWordSumFromFOT,
  ToWordSumOther   : L_PRoll.tSum[2];
  ToWordMonthName  : STRING[][2];

  DailyTime : NUMERIC[3][MaxDaily];
  DailyDay  : tDays[MaxDaily];
  ActPerDayCount,
  PaidDaysByFirm    : tDays;
  TimeInLastStaffLog: SCAL[2];

(*
$P {Top:
P_Firm.FP_ContractorBriefName(P_Firm.fomf(Staff.MyFirm), AvePay.Period), L, ""
AvePay.AvePay, L, ""
AveType.AveType, L, ""
AveType.Name, L, ""
AvePay.DocNum, L, ""
AvePay.Period, L, "N.y"
Staff.TSN, L, ""
Man.Name, L, ""
Officer.Post, L, ""
Post.Name, L, ""
Officer.Union, L, ""
Union.Name, L, ""
StaffLog.Sort, L, ""
Sort.Name, L, ""
@
###########################################################
===========================================================
|                   ⮪ ࠡ⪨                    |
|  㬥  ⢨/ -। #######  |
|------------------------------------------ਮ-|
| ## ############################### ############ ####### |
|---------------------------------------------------|
| ##### ################################################# |
|------------------------------------------------|
| ### ################################################### |
|-⥣-----------------------------------------------|
| ##  ################################################### |
|---------------------------------------------------|
| ### ################################################### |
}

$P { MonCap:
?, R, ""
?, R, "3."
?, R, "2-"
AvePay.Average, R, "2-"
@
|-।-----------------६-- 㬬-㬬  ####-|
|                      ######## ############ ############ |
}

$P { LimMonCap:
?, R, ""
?, R, "5-"
@                                              
|-।  ࠭祭---------------------㬬  ####-|
|                                         ############### |
}

$P { HstTop:
@
|------------६--------㬬--------------|
}

$P { HstLine:
?, L, "N.y"
?, R, "3."
?, R, "2."
?, R, "2-"
@
|       #######  ###### ####### ############              |
}

$P { HstTop1:
@
|---ਪ--------६-- -- --|
}

$P { HstLine1:
?, L, "N.y"
?, L, "D.N.y"
?, R, "3."
?, R, "2-"
?, R, "2-"
?, R, "3."
@
|####### ########## ######## ########### ########### #####|
}

$P {LPBTop:
@
|६--------室--ଠ-ࠡ.--- --|
}

$P {LPBLine:
MCList.MCode, L, ""
?, L, "N.y"
?, R, "2-"
?, R, "1."
?, R, "1."
?, R, "2-"
?, R, "3."
@
|  ###  #######  ########## ###### ###### ########## #####|
}

$P { CurSal:
WagePayL.Type, L, "|"
?, R, ""
?, L, "N.y"
?, R, "1."
?, R, "2."
?, R, "2-"
?, R, "2-"
@
|-#####--------६--------㬬-㬬  ####-|
|       #######  ###### ####### ############ ############ |
}

$P { HandAve:
AvePay.Average, R, "2-"
@
|-।-------------------------------------------㬬-|
|                                            ############ |
}

$P { Infl:
?, L, "N.y"
?, R, "3."
AvePay.Average, R, "2-"
@
|------------------४஢ ।-|
|       #######  ######                      ############ |
}

$P { MonTop:
@
|---ਮ---% .-------------ᮢ--------㬬-|
}

$P { MonLine:
?, L, ""
ActPer, L, "N.y"
AvePayP.Percent, R, "2."
?, R, L_AvePay.DaysFormat()
?, R, "3."
?, R, "2-"
@
|  ### #######  ######  ####### ############ ############ |
}
*)

(*
$P{ Features:
?, L, ""
@
|-⢠------------------------------------------------|
| ####################################################### |
}
*)

(*
$P { Itog:
L_Str.PoolItem("  ⮣|!   ⠡", AveType.Pass), L, ""
TotDays, R, "0"
TotTime, R, "3."
TotSum, R, "2-"
@
|---------------------------------------------------------|
|######################### #### ############ ############ |
}
*)

(*
$P { ItogSick:
TotSum*0.87, R, "2-"
TotSum*0.70, R, "2-"
@
|---------------------------------------------------------|
|  "⮣*0.87"                              ############ |
|  "⮣*0.70"                              ############ |
}
*)

(*
$P { ItogAmount:
AvePay.StartD, L, "D.N.y"
AvePay.StopD, L, "D.N.y"
AvePay.Amount, R, "0"
HDCount, R, "0"
@
|-砫------砭---------------------. -|
| ##########  ##########              ########   ######## |
}
*)

(*
$P{ ItogVctDSaldo:
AvePay.StopD + 1, L, "D.N.y"
?, R, "1."
@
|---------------------------------------------------------|
|  ########## ⠥  ᪠         ######## |
}
*)


(*
$P { EndRep:
FULLNAME(), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
|-c⥫--------------------------------------|
| ######################################## |              |
=(c) Polak===============================##########=#####==
}
*)

(*
$P { EndRep_EU:
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
=(c) Polak===============================##########=#####==

}
*)

(*
$P{ EmptyRep_EU:
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Memo.ud_mb(), L, "D.N.y"
Memo.ud_me(), L, "D.N.y"
@
=========================================##########=#####==
|                   ⮪ ࠡ⪨                   |
|      㬥⮢  ⢨/ -।     |
|            ਮ  ##########  ##########          |
=(c) Polak=================================================
}
*)

 PRIVATE PROCEDURE ProtFeatures();
  VAR
   _Str           : STRING[];
   PayMode        : P_AveP.tftPayMode;
   Limit,
   FirstDaysByFirm: STRING[];
   Year_0,
   Year_1         : P_AveP.tftYear;
 BEGIN
  P_AveP.Decode_Features(P_AveP.GetProValueSoft(AvePay.AvePay, P_AveP.P_Features), Limit, FirstDaysByFirm, Year_0, Year_1, PayMode);
  SETEMPTY(_Str);
  IF ~!Limit THEN
   _Str:=_Str + "࠭祭() " + Limit;
  END;
  IF ~!FirstDaysByFirm THEN
   _Str:=L_Str.AddStrDlm(_Str, "; ") + ". ࠡ. " + FirstDaysByFirm;
  END;
  IF ~!Year_0 THEN
   _Str:=L_Str.AddStrDlm(_Str, "; ") + ". . " + L_Str.IntStr(Year_0) + " " + L_Str.IntStr(Year_1);
  END;
  IF ~!PayMode THEN
   _Str:=L_Str.AddStrDlm(_Str, "; ") + "冷 " + L_Str.PoolItem(P_AveP.ft_PayMode_Pool, PayMode);
  END;
  IF ~!_Str THEN
   MAKEPART(R, Features, _Str);
  END;
 END {ProtFeatures};

 PRIVATE PROCEDURE ProtMonTop();
 BEGIN
  IF ProtDo THEN
   ProtFeatures();
   MAKEPART(R, MonTop);
   INC(MonLineCnt);
  END;
 END {ProtMonTop};

 PRIVATE PROCEDURE __MoneyMan(s, t: FLOAT; _Source: LIKE(Money.Source); days: tDays);
  VAR
   Idx: SCAL[2];
 BEGIN
  IF ProtDo THEN
   IF MonLineCnt = 0 THEN
    ProtFeatures();
    MAKEPART(R, MonTop);
   END;
   CONFORM(MoneyRul, MCList);
   IF MCList.TimeType > L_PRoll.tt_Exclude THEN
    INC(TotDays, days);
    INC(TotTime, t);
   END;
   MAKEPART(R, MonLine, MoneyRul.MCode, days, t, s);
   INC(MonLineCnt);
  END;
  INC(TotSum, s);
  IF ToWord THEN
   Idx:=ActPer > AvePay.Period;
   CONFORM(MoneyRul, MCList, MCGroup);
   IF MCList.TimeType > L_PRoll.tt_Exclude THEN
    INC(ToWordDays[Idx], days);
   END;
   IF MCGroup.FOT = 0 THEN
    INC(ToWordSumOther[Idx], s);
   ELSE
    INC(ToWordSumFromFOT[Idx], s);
   END;
   IF ~Str.Match(ToWordMonthName[Idx], "*" + L_DatTim.MonthStr(ActPer, 0) + "*") THEN
    ToWordMonthName[Idx]:=L_Str.AddStrDlm(ToWordMonthName[Idx], ", ") + L_DatTim.MonthStr(ActPer, 0);
   END;
  END;
  IF ProcDo THEN
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    IF AvePay.Period >= 01\04\2012 THEN
     L_PRoll.detailedSaveMoney(Store, MoneyRul.MCode, ActPer, StaffLog.Date, _Source,
                               L_XDoc.curXDocId(L_XDoc.xdt_AvePay),
                               EMPTYOF(MoneyDst.XObject),
                               L_PRoll.GetMCListAcCut(MoneyRul.MCode, L_PRoll.Salary_ClcPer()),
                               s, t);
    ELSE
     L_PRoll.SaveMoney(Store, MoneyRul.MCode, ActPer, _Source, s, t);
    END;
   EXCEPT
   ON Exc: Exc_RunTime DO
    IF Exc.ErrorCode = 46(*९*) THEN
     L_General.Error("㬥 ᫨誮 让. 室 ࠧ    㬥 ( ),|"+
                     "⮡ ⢮     ॢ蠫 150");
    ELSE
     RAISE();
    END;
   END; (* TRY *)
  END; (* IF ProcDo *)
 END {__MoneyMan};

 PRIVATE PROCEDURE _MoneyMan(s, t: FLOAT; _Source: LIKE(Money.Source));
 BEGIN
  __MoneyMan(s, t, _Source, MonDays);
 END {_MoneyMan};

 PRIVATE PROCEDURE MoneyMan(s, t: FLOAT);
 BEGIN
  _MoneyMan(s, t, L_PRoll.src_AvePay);
 END {MoneyMan};

 PRIVATE PROCEDURE GetPastMCode(Fr, Up: DATE; _MCode: LIKE(MCList.MCode); VAR _Sum: NUMERIC[2]);
 BEGIN
  _Sum:=0;
  SETSEL(Money, TSN, Staff.TSN);
  SRCINSEL(Money, GE, , Fr);
  WHILE OCCURE(Money) & (Money.Closed < Up) DO
   NARROWSEL(Money, Closed, WFPeriod, ODate, Period);
   SRCINSEL(Money, GE, , _MCode);
   WHILE OCCURE(Money) & (Money.MCode = _MCode) DO
    INC(_Sum, L_General.Denominate(Money.Closed, AvePay.Period, Money.Sum));
    NEXT(Money);
   END;
   NEXTINEXTENDEDSEL(Money, Closed, WFPeriod, ODate, Period);
  END; (* WHILE OCCURE(Money) ... *)
 END {GetPastMCode};

 PRIVATE PROCEDURE CheckAveNo();
 BEGIN
  L_General.Assert(AveType.AveNo # L_AvePay.aveno_None,
                   " 㬥  ⢨/ -।," +
                   " ,   ਬ ⨯ । '':" +
                   "| 㬥 " + AveType.AveType + " " + AveType.Name);
 END {CheckAveNo};

 PRIVATE PROCEDURE GetAveNoByAveTypeAveNo(): LIKE(AveType.AveNo);
 BEGIN
  IF (_GetFirstM()>=IdentAveragePer) & (AveType.AveNo = L_AvePay.aveno_Sick) THEN
   RETURN L_AvePay.aveno_Avrg;
  ELSE
   CheckAveNo();
   RETURN AveType.AveNo;
  END;
 END {GetAveNoByAveTypeAveNo};

 PRIVATE PROCEDURE E_IndexHistSupport(_MCode: LIKE(MCList.MCode); _IndexDefault: LIKE(MCList.Index[0])): LIKE(MCList.Index[0]);
 BEGIN
  IF ~!PROCREF(IndexHistSupport) THEN  (*avp_*)
   RETURN IndexHistSupport(_MCode, _GetFirstM(), _IndexDefault);
  END;
  RETURN _IndexDefault;
 END {E_IndexHistSupport};

 PRIVATE PROCEDURE NeedTimeType(): SCAL[2];
 BEGIN
  IF (AvePay.StartD >= 01\01\2011) & (AveType.AveNo = L_AvePay.aveno_Sick) &
     (P_AveP.Get_ft_PayMode() = P_AveP.ft_PayMode_2011) THEN
   RETURN 1;
  ELSE
   RETURN MCList.TimeType#L_PRoll.tt_Include(*   ..*);
  END;
 END {NeedTimeType};

 PRIVATE PROCEDURE GetMCListIndexByAveTypeAveNo(D: DATE): LIKE(MCList.Index[0]);
  VAR
   _IndexDefault: LIKE(MCList.Index[0]);
 BEGIN
  IF    (AvePay.StartD >= 01\01\2010) & (AveType.AveNo = L_AvePay.aveno_Sick) THEN
   IF (P_MCList.a2sf_Attitude(MCList.MCode, AvePay.StartD) >= P_MCList.a2sf_Taxable) &
      NeedTimeType() THEN
    _IndexDefault:=L_PRoll.mci_Include;
   ELSE
    _IndexDefault:=L_PRoll.mci_Exclude;
   END;
  ELSIF L_AvePay.SpecialSick() THEN
   IF (MCList.InSign[1] (**)) & (MCList.TimeType#L_PRoll.tt_Include(*   ..*)) THEN
    _IndexDefault:=L_PRoll.mci_Include;
   ELSE
    _IndexDefault:=L_PRoll.mci_Exclude;
   END;
  ELSIF (_GetFirstM()>=IdentAveragePer) & (AveType.AveNo = L_AvePay.aveno_Sick) THEN
   IF MCList.Index[L_AvePay.aveno_Avrg] THEN
    _IndexDefault:=L_PRoll.mci_Include;
   ELSE
    _IndexDefault:=L_PRoll.mci_Exclude;
   END;
  ELSE
   CheckAveNo();
   _IndexDefault:=MCList.Index[AveType.AveNo];
  END;
  RETURN E_IndexHistSupport(MCList.MCode, _IndexDefault);
 END {GetMCListIndexByAveTypeAveNo};

 PRIVATE PROCEDURE E_NeedDecrAccordingTim(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(NeedDecrAccordingTim);  (*avp_*)
  IF ~!Local THEN
   RETURN Local(AvePay.StartD);
  ELSE
   RETURN 1;
  END;
 END {E_NeedDecrAccordingTim};

 PRIVATE PROCEDURE DecrBonusAccordingTimDone(P: DATE; S: NUMERIC[2]; Inf: P_Union.tAveIndexation): NUMERIC[2];
  VAR
   _FullBal,
   _CorBal,
   _TimDone,
   RealTime: NUMERIC[3];
   s       : NUMERIC[2];
 BEGIN
  IF S # 0 THEN
   _CorBal :=GetCorBal(P);
   _FullBal:=GetHBal(P);
   _TimDone:=GetTimDone(P);
   RealTime:=Math.Min(_TimDone, _CorBal);
   IF E_NeedDecrAccordingTim() THEN
    IF _FullBal = 0 THEN
     L_General.Assert(RealTime = 0, "㫥 ଠ ६  " + L_DatTim.PeriodStr(P));
     s:=0;
    ELSE
     s:=S * RealTime / _FullBal;
    END;
   ELSE
    s:=S;
   END;
   IF ProtDo THEN
    MAKEPART(R, LPBLine, P, S, _FullBal, RealTime, s, Inf);
   END;
   RETURN s;
  ELSE
   RETURN 0;
  END;
 END {DecrBonusAccordingTimDone};

 PRIVATE PROCEDURE E_FirstMForLongPer(P: DATE): DATE;
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(FirstMForLongPer);  (*avp_*)
  IF ~!Local THEN
   RETURN Local(P);
  ELSE
   RETURN P;
  END;
 END {E_FirstMForLongPer};

 PRIVATE PROCEDURE _AddLongPerBonuses(LPB        : NUMERIC[2];
                                      FirstTotim : DATE;
                                      PerNum     : NUMERIC[0];
                                      WithInfl   : SCAL[2]): NUMERIC[2];
  VAR
   S   : NUMERIC[2];
   i   : NUMERIC[0];
   P   : DATE;
   Inf : P_Union.tAveIndexation;
 BEGIN
  S:=0;
  IF LPB # 0 THEN
   IF ProtDo THEN
    MAKEPART(R, LPBTop);
   END;
   i:=0; P:=FirstTotim;
   WHILE (i < PerNum) & (P > L_DatTim.Per(Staff.BegDate)) DO
    P:=L_DatTim.IncMonth(P, -1);
    IF WithInfl THEN
     IF L_General.NeedExecuteArchaicCode(AvePay.Period, 01\11\2013) THEN
      Inf:=GetAccumulatedInflation(Math.Max(P, Staff.BegDate), _GetFirstM(), P);
     ELSE
      Inf:=GetAccumulatedInflation(L_DatTim.MonthEnd(P), _GetFirstM(), P);
     END;
    ELSE
     Inf:=1;
    END;
    INC(S, DecrBonusAccordingTimDone(P, LPB, Inf) * Inf);
    INC(i);
   END;
  END; (* IF LongPerBonus # 0 ... *)
  RETURN S;
 END {_AddLongPerBonuses};

 PRIVATE PROCEDURE AddLongPerBonuses(First   : DATE;
                                     PerNum  : NUMERIC[0];
                                     WithInfl: SCAL[2]): NUMERIC[2];
  VAR
   LPB,
   _Tot: NUMERIC[2];
   i   : NUMERIC[0];
   LastToSum,
   FirstToSum: DATE;
   _WithInfl : SCAL[2];
   MCLIndex  : LIKE(MCList.Index[0]);
 BEGIN
  SETZERO(_Tot);
  SETSEL(MCList, MCPerNum);
  LAST(MCList);
  WHILE OCCURE(MCList) & (MCList.PerNum > 01) DO
   MCLIndex:=GetMCListIndexByAveTypeAveNo(First);
   IF MCLIndex > L_PRoll.mci_Exclude THEN
    _WithInfl:=WithInfl & (MCLIndex=L_PRoll.mci_Indexed);
    i:=0; FirstToSum:=First;
    WHILE PerNum-(MCList.PerNum*i) > 0 DO
     INC(i);
     LastToSum :=FirstToSum;
     FirstToSum:=E_FirstMForLongPer(L_DatTim.IncMonth(First, -(MCList.PerNum*i)));
     GetPastMCode(FirstToSum, LastToSum, MCList.MCode, LPB);
     INC(_Tot, _AddLongPerBonuses(LPB/MCList.PerNum, LastToSum, Math.Min(PerNum, MCList.PerNum), _WithInfl));
    END;
   END;
   PREV(MCList);
  END; (* WHILE OCCURE(MCList) ... *)
  RETURN _Tot;
 END {AddLongPerBonuses};

 PRIVATE PROCEDURE E_Cancel_13_4(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(Cancel_13_4); (*avp_*) (*  㬬.   ᮡ⥩,  ᥬ*)
  IF ~!Local THEN
   RETURN Local(AvePay.StartD);
  ELSIF AvePay.StartD >= 13\07\2006 THEN
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {E_Cancel_13_4};

 PRIVATE PROCEDURE E_IsSummationSheet(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(IsSummationSheet); (*avp_*)
  IF ~!Local THEN
   CONFORM(AvePay, Staff);
   L_Staff.PosToStaffLog(Staff.TSN, AvePay.StartD, 1);
   CONFORM(StaffLog, Officer);
   RETURN Local(AvePay.StartD);
  ELSE
   RETURN L_PRoll.E_IsSummationSheet(AvePay.StartD);
  END;
 END {E_IsSummationSheet};

 PRIVATE PROCEDURE E_IsBaseSheet(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(IsBaseSheet); (*avp_*)
  IF ~!Local THEN
   CONFORM(AvePay, Staff);
   L_Staff.PosToStaffLog(Staff.TSN, AvePay.StartD, 1);
   CONFORM(StaffLog, Officer);
   RETURN Local(AvePay.StartD);
  ELSE
   RETURN 0;
  END;
 END {E_IsBaseSheet};

 PRIVATE PROCEDURE E_CanCalcBeforeStart(D: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(CanCalcBeforeStart); (*avp_*)
  IF ~!Local THEN
   RETURN Local(D);
  ELSE
   RETURN 0;
  END;
 END {E_CanCalcBeforeStart};

 PRIVATE PROCEDURE E_NeedCorrBonSum(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(NeedCorrBonSum), 0); (*avp_*)
 END {E_NeedCorrBonSum};

 PRIVATE PROCEDURE GetAve(P: DATE; VAR S, A: NUMERIC[2]; VAR T, W: NUMERIC[3]);
  VAR
   Inf   : P_Union.tAveIndexation;
   _SumNotI,
   _SumWithI,
   _Sum  : NUMERIC[2];
   _T    : NUMERIC[3];
   MCLIndex: LIKE(MCList.Index[0]);
 BEGIN
  L_AFM.MakeMultipleIndex("Tmp01", "_ODate : LIKE(Money.ODate);"+
                                   "_MCode : LIKE(Money.MCode);"+
                                   "_Closed: LIKE(Money.Closed);"+
                                   "_Tim   : LIKE(Money.Tim);"+
                                   "_Sum   : LIKE(Money.Sum)",
                                   "Tmp01: _ODate, _MCode, _Closed"
                         );
  SELECT(Money, PayFor, , Staff.TSN, P);
  WHILE OCCURE(Money) DO
   IF L_AvePay.E_IsAcceptableMoneyAsPayFor() THEN
    ADD(Tmp01, Tmp01, , Money.ODate, Money.MCode, Money.Closed,
                        Tmp01._Tim, Money.Tim,
                        Tmp01._Sum, Money.Sum);
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)

  SETZERO(S, A, T, W);
  SELECT(Tmp01, Tmp01);
  WHILE OCCURE(Tmp01) DO
   SETZERO(_SumNotI, _SumWithI, _T);
   NARROWSEL(Tmp01, _ODate);
   WHILE OCCURE(Tmp01) DO
    Inf:=GetAccumulatedInflation(Tmp01._ODate, _GetFirstM(), P);
    SEARCH(MCList, MCode, , Tmp01._MCode);
    MCLIndex:=GetMCListIndexByAveTypeAveNo(Tmp01._Closed);
    IF (MCLIndex > L_PRoll.mci_Exclude) & (MCList.PerNum = 01) THEN
     _Sum:=L_General.Denominate(Tmp01._Closed, AvePay.Period, Tmp01._Sum);
     IF MCList.MCTyp = L_PRoll.mct_Credit THEN
      IF MCLIndex = L_PRoll.mci_Indexed THEN
       INC(_SumWithI, _Sum);
       _Sum:=_Sum*Inf;
      ELSE
       INC(_SumNotI, _Sum);
      END;
      IF MCList.TimeType > L_PRoll.tt_Exclude THEN
       INC(_T, Tmp01._Tim);
       INC(T,  Tmp01._Tim);
       INC(S,  _Sum);
      ELSE
       INC(A, _Sum);
      END;
     ELSE
      DEC(S, _Sum);
     END;
    END;
    IF MCList.TimeType = L_PRoll.tt_Production THEN
     INC(W, Tmp01._Tim);
    END;
    NEXT(Tmp01);
   END; (* WHILE OCCURE(Tmp01) ... *)
   LAST(Tmp01);
   ProtHist1(P, Tmp01._ODate, _T, _SumWithI, Inf, _SumNotI);
   NEXTINEXTENDEDSEL(Tmp01, _ODate);
  END; (* WHILE OCCURE(Tmp01) ... *)
  L_AFM.AF_PurgeTemp("Tmp01");
 END {GetAve};

 PRIVATE PROCEDURE GetAveIndexation(trgUnion  : LIKE(Union.Union);
                                    trgSort   : LIKE(Officer.Sort);
                                    trgOfficer: LIKE(Officer.Officer);
                                    trgDate   : DATE;
                                    trgAveNo  : LIKE(AveType.AveNo)): P_Union.tAveIndexation;
 BEGIN
  IF P_Officer.HasActualPro_Normal(trgSort, trgOfficer, trgDate, P_Officer.P_AveIndexation) THEN
   IF ~P_Union.HasActualPro_Normal(trgUnion, trgDate, P_Union.P_AveIndexation) | (OfcPro.Date>=UnionPro.Date) THEN
    RETURN P_Officer.GetAveIndexation(trgSort, trgOfficer, trgDate, trgAveNo);
   ELSE
    L_General.CallUs(SEARCH(Officer, Officer, trgSort, trgOfficer));
    L_General.Assert(~L_DatTim.IsActive(trgDate, Officer.Begin, Officer.Till),
                     "⨬ ६ ⢨ ᢮ ''|"+
                     " ࠡ祬    ⥣ਨ  "+L_DatTim.PeriodStr(trgDate)+".|"+
                     "⭮, 室  ᢮⢮  :|"+
                     " " + trgSort + ", ࠡ祥  " + trgOfficer+", ᢮⢮   "+L_DatTim.DateStr(OfcPro.Date)+";|"+
                     "⥣ "+trgUnion+", ᢮⢮   "+L_DatTim.DateStr(UnionPro.Date));
    RETURN P_Union.GetAveIndexation(trgUnion, trgDate, trgAveNo);
   END;
  ELSE
   RETURN P_Union.GetAveIndexation(trgUnion, trgDate, trgAveNo);
  END;
 END {GetAveIndexation};

 PRIVATE PROCEDURE GetInf(P: DATE): P_Union.tAveIndexation;
  VAR
   Local: PROC;
   Inflt: P_Union.tAveIndexation;
 BEGIN
  Inflt:=GetAveIndexation(Officer.Union, Officer.Sort, Officer.Officer, P, GetAveNoByAveTypeAveNo());
  Local:=PROCREF(E_PRoll.GetSpecificInflation);
  IF ~!Local THEN
   RETURN Local(P, Inflt);
  ELSE
   RETURN Inflt;
  END;
 END {GetInf};

 PRIVATE PROCEDURE GetAccumulatedInflation(ODate,
                                           Now,
                                           From  : DATE): P_Union.tAveIndexation;
  VAR
   Inf: P_Union.tAveIndexation;
 BEGIN
  Inf:=1;
  SAVE(StaffLog);
  L_Staff.PosToStaffLog(Staff.TSN, ODate, 0);
  CONFORM(StaffLog, Officer);
  WHILE Now > From DO
   Inf:=Inf * GetInf(Now);
   Now:=L_DatTim.IncMonth(Now, -1);
  END;
  RESTORE(StaffLog);
  CONFORM(StaffLog, Officer); (* restore condition *)
  RETURN Inf;
 END {GetAccumulatedInflation};

 PRIVATE PROCEDURE RealBegDate(D: DATE): DATE;
 BEGIN
  IF _GetFirstM() >= 01\08\2004 THEN
   RETURN L_Man.GetTakeOnDate(L_DatTim.MonthEnd(D));
  ELSE
   RETURN Staff.BegDate;
  END;
 END {RealBegDate};

 PRIVATE PROCEDURE GetAveAve(    Now,
                                 From    : DATE;
                                 CPrc    : PROC;
                                 ToCorB  : SCAL[2];
                                 WithInfl: SCAL[2];
                             VAR Sum     : NUMERIC[2];
                             VAR Tim     : NUMERIC[3]);
  VAR
   ODate      : DATE;
   S,
   A,
   STI,
   CorS       : NUMERIC[2];
   Inf,
   WrkT,
   FulB,
   CorB,
   excludedWT,
   _FullBal,
   T, xT,
   D, xD       : NUMERIC[3];
   _RealBegPer : DATE;
   MCLIndex    : LIKE(MCList.Index[0]);
   oPrompt     : PROMPT_LINE;
 BEGIN
  _RealBegPer:=RealBegDate(From);
  SETEMPTY(ODate);
  SETZERO(Sum, Tim, T, D, A, S, STI, WrkT, excludedWT);
  TimeInLastStaffLog:=0;
  Inf:=1;
  CorB:=GetCorBal(From);
  FulB:=GetFulBal(From);
  SELECT(Money, TSN, , Staff.TSN, From);
  WHILE OCCURE(Money) DO
   oPrompt:=PROMPT_LINE.Create(" ।: "+L_DatTim.PeriodStr(From));
   SETZERO(CorS);
   CONFORM(Money, MCList);
   MCLIndex:=GetMCListIndexByAveTypeAveNo(Money.Closed);
   IF (MCLIndex > L_PRoll.mci_Exclude) & (MCList.PerNum = 01) THEN
    L_General.Assert(MCList.TimeType # L_PRoll.tt_Include,
                     "୮ ଫ  ᫥||" +
                     MCList.MCode + " '" + MCList.Name + "'.||" +
                     " ᫥ ।   ᯮ짮|" +
                     " ᫥ c ६ '뢠'.");
    IF !ODate | (ODate # Money.ODate) THEN
     IF ~!ODate THEN
      xT:=T;
      xD:=D;
      CPrc(From, WrkT, FulB, CorB, xT, xD);
      IF (AvePay.StartD >= 01\01\2008) & TimeInLastStaffLog THEN
       ProtHist1(From, ODate, EMPTYOF(L_PRoll.tTime), STI, Inf, S);
       INC(WrkT, T);
      ELSE
       T:=xT;
       D:=xD;
       ProtHist1(From, ODate, D, STI, Inf, S);
       INC(WrkT, T);
      END;
      INC(Sum, S + STI*Inf);
      SETZERO(T, D, S, STI);
     END;
     ODate:=Money.ODate;
     IF WithInfl THEN
      Inf:=GetAccumulatedInflation(ODate, _GetFirstM(), From);
     ELSE
      Inf:=1;
     END;
    END; (* IF !ODate ... *)
    IF Money.ODate>=_RealBegPer THEN
     IF (MCList.TimeType = L_PRoll.tt_Production) THEN
      INC(T, Money.Tim);
     END;
     CorS:=L_General.Denominate(Money.Closed, AvePay.Period, Money.Sum);
     IF E_NeedCorrBonSum(From) THEN
      IF (MCList.TimeType = L_PRoll.tt_Exclude) & (Money.Period < From) THEN
       _FullBal:=GetHBal(From);
       IF _FullBal > 0 THEN
        CorS:=CorS * Math.Min(CorB, GetTimDone(From)) / _FullBal;
       ELSE
        CorS:=0;
       END;
      END;
     END;
     IF MCLIndex = L_PRoll.mci_Include THEN
      INC(  S, CorS);
     ELSE
      INC(STI, CorS);
     END;
    END;
   ELSIF (MCList.TimeType = L_PRoll.tt_Production) THEN
    INC(excludedWT, Money.Tim);
   END; (* IF (MCLIndex > L_PRoll.mci_Exclude) ... *)
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
  INC(Sum, S + STI*Inf);
  CPrc(From, WrkT, FulB, CorB, T, D);
  ProtHist1(From, ODate, D, STI, Inf, S);
  INC(WrkT, T);
  CPrc(From, 0, FulB, CorB, WrkT, WrkT);
  CPrc(From, 0, FulB, CorB, CorB, CorB);
  IF ToCorB THEN
   IF (_GetFirstM()>=01\10\2007) & (excludedWT # 0) THEN
    CPrc(From, 0, FulB, 0, excludedWT, excludedWT);
   END;
   IF (WrkT+excludedWT) < CorB THEN
    ProtHist1(From, StaffLog.Date, CorB-(WrkT+excludedWT), 0, 1.0, 0);
    WrkT:=CorB-excludedWT;
   END;
  END;
  Tim:=WrkT;
 END {GetAveAve};

 PRIVATE PROCEDURE AccessRegHead(P: DATE);
 BEGIN
  L_General.Assert(SEARCH(RegHead, HumReg, StaffLog.Regime, P), " 䨪 "+StaffLog.Regime+"  "+L_DatTim.PeriodStr(P));
 END {AccessRegHead};

 PRIVATE PROCEDURE AccessRegList(Cond: SCAL[2]; D: DATE);
 BEGIN
  L_General.Assert(Cond, " 䨪  ଠ樨  ⠪ ப|  䨪 "+StaffLog.Regime+"  "+L_DatTim.DateStr(D));
 END {AccessRegList};

 PRIVATE PROCEDURE CheckReg(Cond: SCAL[2]; D: DATE; Text: STRING[]);
 BEGIN
  L_General.Assert(Cond, "㫥 ଠ ६  "+L_DatTim.PeriodStr(D)+Text);
 END {CheckReg};

 PRIVATE PROCEDURE _GetRegBal(P: DATE; ChkZero: SCAL[2]): LIKE(PCalc.HBal);
 BEGIN
  AccessRegHead(P);
  IF    StaffLog.DutyDgr >= 1.0 THEN
   CheckReg(~ChkZero | (RegHead.FullBal>0), P, ":|० ࠡ "+RegHead.Regime);
   RETURN RegHead.FullBal;
  ELSIF RegHead.GrTime = 0 THEN
   CheckReg(~ChkZero | (RegHead.FullBal>0), P, ":|㫥 䨪  ଠ  ० ࠡ "+RegHead.Regime);
   CheckReg(~ChkZero | (StaffLog.DutyDgr>0), P, ":|㫥 䨪   ࠡ⭨ -   "+L_DatTim.DateStr(StaffLog.Date));
   RETURN RegHead.FullBal*StaffLog.DutyDgr;
  ELSE
   CheckReg(~ChkZero | (RegHead.GrTime>0), P, ":|㫥 䨪 - ० ࠡ "+RegHead.Regime);
   RETURN RegHead.GrTime;
  END;
 END {_GetRegBal};

 PRIVATE PROCEDURE GetRegBal(P: DATE): LIKE(PCalc.HBal);
 BEGIN
  RETURN _GetRegBal(P, 0);
 END {GetRegBal};

 PRIVATE PROCEDURE AccessPCalc(P: DATE);
 BEGIN
  L_General.Assert(SEARCH(PCalc, TSN, Staff.TSN, P), " ப   " + L_DatTim.PeriodStr(P));
 END {AccessPCalc};

 PRIVATE PROCEDURE GetBal(D1, D2: DATE; VAR _TimDone, _CorBal, _HBal: L_PRoll.tTime);
  VAR
   CurDate   : DATE;
   _Tim      : LIKE(Sheet.Tim);
 BEGIN
  SETZERO(_TimDone, _CorBal, _HBal);
  IF E_CanCalcBeforeStart(AvePay.Period) & (D2 < L_Env.aptm_Start) & E_IsBaseSheet() THEN
   RETURN;
  END;
  SAVE(StaffLog);
  CurDate:=D1;
  WHILE CurDate <= D2 DO
   HISTCONF(CurDate, Staff, StaffLog);
   L_General.Assert(SEARCH(RegList, HumReg, StaffLog.Regime, L_DatTim.Per(CurDate), L_DatTim.DAY(CurDate)),
                    " ࠡ "+StaffLog.Regime+"    "+L_DatTim.DateStr(CurDate));
   IF ~SEARCH(Sheet, TSN, StaffLog.TSN, L_DatTim.Per(CurDate), L_DatTim.DAY(CurDate)) THEN
    L_General.Error("   ⠡  "+L_DatTim.DateStr(CurDate) +
                    "||" +
                    " 믮   ࠡ⭨  " + L_DatTim.PeriodStr(CurDate));
   END;
   _Tim:=Sheet.Tim;
   CONFORM(Sheet, JMode);
   IF JMode.InFirm THEN
    INC(_HBal, RegList.Durat);
    IF JMode.Type = L_Sheet.jmType_TimDone THEN
     INC(_TimDone, _Tim);
    END;

    IF (_Tim#0) & JMode.DecrBal THEN
     DEC(_CorBal, _Tim);
    END;
   END; (* IF JMode.InFirm ... *)
   INC(CurDate);
  END;

  INC(_CorBal,  _HBal);
  L_General.Assert(_CorBal>=0, "⥫  ࠡ祣 ६");
  RESTORE(StaffLog);
 END {GetBal};

 PRIVATE PROCEDURE CalculatePCalc(P: DATE; VAR _TimDone, _CorBal, _HBal: L_PRoll.tTime);
 BEGIN
  SAVE(PCalc);
  IF L_PRoll.IsShtD_AP(P) THEN
   _TimDone:=PCalc.TimDone;
   _CorBal :=PCalc.CorBal;
   _HBal   :=PCalc.HBal;
  ELSE
   GetBal(P, L_DatTim.MonthEnd(P), _TimDone, _CorBal, _HBal);
  END;
  RESTORE(PCalc);
 END {CalculatePCalc};

 PRIVATE PROCEDURE GetCorBal(P: DATE): LIKE(PCalc.CorBal);
  VAR
   _RealBegDate: DATE;
   _HBal,
   _TimDone,
   _CorBal     : L_PRoll.tTime;
 BEGIN
  _RealBegDate:=RealBegDate(P);
  IF P < L_DatTim.Per(Staff.BegDate) THEN
   RETURN 0;
  ELSIF P < _RealBegDate THEN
   GetBal(_RealBegDate, Math.Min(Staff.EndDate, L_DatTim.MonthEnd(P)), _TimDone, _CorBal, _HBal);
   RETURN _CorBal;
  ELSE
   AccessPCalc(P);
   CalculatePCalc(P, _TimDone, _CorBal, _HBal);
   RETURN _CorBal;
  END;
 END {GetCorBal};

 PRIVATE PROCEDURE HasDischargeInMonth(P: DATE): SCAL[2];
  VAR
   Has: SCAL[2];
 BEGIN
  SAVE(StaffLog);
  HISTCONF(P, Staff, StaffLog);
  Has:=~OCCURE(StaffLog);
  WHILE OCCURE(StaffLog) & (StaffLog.Date<=L_DatTim.MonthEnd(P)) DO
   IF L_Staff.IsDischargeStaffLog() THEN
    Has:=1;
    LAST(StaffLog);
   END;
   NEXT(StaffLog);
  END; (* WHILE OCCURE(StaffLog) & ... *)
  RESTORE(StaffLog);
  IF (_GetFirstM() >= 01\01\2007) & ~Has THEN
   SAVE(Sheet);
   SELECT(Sheet, TSN, , Staff.TSN, P);
   WHILE OCCURE(Sheet) & ~Has DO
    CONFORM(Sheet, JMode);
    Has:=~JMode.InFirm;
    NEXT(Sheet);
   END; (* WHILE OCCURE(Sheet) ... *)
   RESTORE(Sheet);
  END;
  RETURN Has;
 END {HasDischargeInMonth};

 PRIVATE PROCEDURE GetFulBal(P: DATE): LIKE(PCalc.HBal);
  VAR
   _HBal,
   _TimDone,
   _CorBal     : L_PRoll.tTime;
 BEGIN
  IF E_CanCalcBeforeStart(AvePay.Period) & (P < L_Env.aptm_Start) & E_IsBaseSheet() THEN
   RETURN 0;
  END;
  IF P < L_DatTim.Per(Staff.BegDate) THEN
   RETURN 174;
  ELSIF HasDischargeInMonth(P) THEN
   SAVE(StaffLog);
   L_Staff.PosToStaffLog(Staff.TSN, L_DatTim.MonthEnd(P), 1);
   AccessRegHead(P);
   RESTORE(StaffLog);
   RETURN RegHead.FullBal;
  ELSE
   AccessPCalc(P);
   CalculatePCalc(P, _TimDone, _CorBal, _HBal);
   IF _HBal = 0 THEN
    RETURN 174;
   ELSE
    RETURN _HBal;
   END;
  END;
 END {GetFulBal};

 PRIVATE PROCEDURE GetTimDone(P: DATE): LIKE(PCalc.TimDone);
  VAR
   _RealBegDate: DATE;
   _HBal,
   _TimDone,
   _CorBal     : L_PRoll.tTime;
 BEGIN
  _RealBegDate:=RealBegDate(P);
  IF P < _RealBegDate THEN
   GetBal(_RealBegDate, Math.Min(Staff.EndDate, L_DatTim.MonthEnd(P)), _TimDone, _CorBal, _HBal);
   RETURN _TimDone;
  ELSE
   AccessPCalc(P);
   CalculatePCalc(P, _TimDone, _CorBal, _HBal);
   RETURN _TimDone;
  END;
 END {GetTimDone};

 PRIVATE PROCEDURE GetRegDays(P: DATE): tDays;
  VAR
   Days : tDays;
 BEGIN
  SETZERO(Days);
  SELECT(RegList, HumReg, , StaffLog.Regime, P);
  WHILE OCCURE(RegList) DO
   IF L_AvePay.RegListIsInNet() THEN
    INC(Days);
   END;
   NEXT(RegList);
  END;
  RETURN Days;
 END {GetRegDays};

 PRIVATE PROCEDURE GetHBal(P: DATE): LIKE(PCalc.HBal);
  VAR
   _HBal,
   _TimDone,
   _CorBal     : L_PRoll.tTime;
 BEGIN
  IF SEARCH(PCalc, TSN, Staff.TSN, P) THEN
   CalculatePCalc(P, _TimDone, _CorBal, _HBal);
   RETURN _HBal;
  ELSE
   RETURN GetRegBal(P);
  END;
 END {GetHBal};

 PRIVATE PROCEDURE GetAnyHMPay(P: DATE; HBal: LIKE(PCalc.HBal); VAR Pay, HPay, MPay: NUMERIC[3]);
 BEGIN
  IF P < WagePayL.Period THEN
   SAVE(WagePayL);
   HISTCONF(P, WagePay, WagePayL);
   L_PRoll.GetHMPay(P, HBal, HPay, MPay);
   Pay:=WagePayL.Pay[StaffLog.Class];
   RESTORE(WagePayL);
  ELSE
   L_PRoll.GetHMPay(P, HBal, HPay, MPay);
   Pay:=WagePayL.Pay[StaffLog.Class];
  END;
 END {GetAnyHMPay};

 PRIVATE PROCEDURE GetPay(P: DATE; type: STRING[4]; TUnit: NUMERIC[1]): NUMERIC[3];
  VAR
   bal     : NUMERIC[1];
   Pay,
   _Result,
   HPay,
   MPay    : NUMERIC[3];         (* ??? *)
 BEGIN
  bal:=GetRegBal(P);
  GetAnyHMPay(P, bal, Pay, HPay, MPay);
  _Result:=L_General.Denominate(P, AvePay.Period, MPay)/TUnit;
  IF ProtDo THEN
   MAKEPART(R, CurSal, type,
                       P,
                       TUnit,
                       bal,
                       L_General.Denominate(P, AvePay.Period, Pay),
                       _Result);
  END;
  RETURN _Result;
 END {GetPay};

 PRIVATE PROCEDURE _GetFirstM(): DATE;
 BEGIN
  IF !AvePay.FirstM THEN
   RETURN L_DatTim.Per(AvePay.StartD);
  ELSE
   RETURN AvePay.FirstM;
  END;
 END {_GetFirstM};

 PRIVATE PROCEDURE GetFirstM(): DATE;
  VAR P: DATE;
 BEGIN
  P:=_GetFirstM();
  L_General.Assert(P <= AvePay.Period, "  㬥     ⥪饣");
  RETURN P;
 END {GetFirstM};

 PRIVATE PROCEDURE ProtHist(Prd: DATE; Inf: NUMERIC[3]; Tim: NUMERIC[3]; Sum: NUMERIC[2]);
 BEGIN
  IF ProtDo THEN
   MAKEPART(R, HstLine, Prd, Inf, Tim, Sum);
  END;
 END {ProtHist};

 PRIVATE PROCEDURE ProtHstTop(Part: STRING[]);
 BEGIN
  IF ProtDo THEN
   MAKEPART(R, ^Part);
  END;
 END {ProtHstTop};

 PRIVATE PROCEDURE ProtHist1(Prd,
                             ODate  : DATE;
                             Tim    : NUMERIC[3];
                             Sum    : NUMERIC[2];
                             Inf    : NUMERIC[3];
                             S_to_I : NUMERIC[2]);
 BEGIN
  IF ProtDo THEN
   MAKEPART(R, HstLine1, Prd, ODate, Tim, Sum, S_to_I, Inf);
  END;
  IF ToWord THEN
   L_MSO.wordSetDateVar ("AvePay.HistPer" + L_MSO.IndexStr(ToWordHistIdx) + ".Period", Prd);
   L_MSO.wordSetMoneyVar("AvePay.HistPer" + L_MSO.IndexStr(ToWordHistIdx) + ".Sum",    Prd, Sum*Inf+S_to_I);
   L_MSO.wordSetVar     ("AvePay.HistPer" + L_MSO.IndexStr(ToWordHistIdx) + ".Tim",    L_Str.NumericStr(Tim, 3));
   INC(ToWordHistIdx);
   INC(ToWordHistSum, Sum*Inf+S_to_I);
  END;
 END {ProtHist1};

 PRIVATE PROCEDURE ProtAvrg(Unit: STRING[4]; Tim: NUMERIC[3]; Sum: NUMERIC[2]);
 BEGIN
  IF ProtDo THEN
   MAKEPART(R, MonCap, Unit, Tim, Sum);
  END;
  IF ToWord THEN
   IF Unit = "" THEN
    L_MSO.wordSetVar("AvePay.Average.Days",  L_Str.NumericStr(Tim, 3));
   ELSE
    L_MSO.wordSetVar("AvePay.Average.Hours", L_Str.NumericStr(Tim, 3));
   END;
  END;
 END {ProtAvrg};

 PRIVATE PROCEDURE ProtInfl(Prd: DATE; Inf: NUMERIC[3]);
 BEGIN
  IF ProtDo THEN
   MAKEPART(R, Infl, Prd, Inf);
   MonLineCnt:=0;
  END;
 END {ProtInfl};

 PRIVATE PROCEDURE ProtLim(Unit: STRING[4]; LimAverage: tPreciseAvr);
 BEGIN
  IF ProtDo THEN
   MAKEPART(R, LimMonCap, Unit, LimAverage);
  END;
 END {ProtLim};

 (*-------------------------------------------------------------*)

 PRIVATE PROCEDURE ByStop(): SCAL[2];
 BEGIN
  RETURN Date <= AvePayP.StopD;
 END {ByStop};

 PRIVATE PROCEDURE ByAmnt(): SCAL[2];
 BEGIN
  RETURN DayCount < AvePayP.Amount;
 END {ByAmnt};

 PRIVATE PROCEDURE SimpleProceedRule();
  VAR
   Proc: PROC;
 BEGIN
  Proc:=PROCREF(^MoneyRul.Rule);
  IF ~!Proc THEN
   Proc();
  ELSE
   CONFORM(AvePay, AveType);
   L_StdFrm.WrongDB(" 㬥 "+AveType.AveType+" "+AveType.Name+"."+
                    "|ࠢ ᫥ '"+MoneyRul.Rule+"'  ।ᬮ७  ࠡ⪨ ."+
                    "|, ୮ ଫ  ਬ   㬥 ");
  END;
 END {SimpleProceedRule};

 PRIVATE PROCEDURE AvePaySpecialCheck(): SCAL[2];
  VAR
   P: DATE;
 BEGIN
  IF OCCURE(MoneyRul) & (AvePay.Status = L_AvePay.st_Estimated) THEN
   P:=L_DatTim.IncMonth(AvePay.Period, -1);
   L_General.Assert((AvePay.Period = L_DatTim.Per(Staff.BegDate)) |
                    (AvePay.Period = L_Env.aptm_Start) |
                    (L_APtm.MonthIsClosed(P, L_APtm.system_Salary) & (_GetFirstM()>=IdentAveragePer)) |
                    L_PRoll.IsDedD_AP(P),
                    " c⠭  ।騥 ");
   RETURN 1;
  ELSIF ProtDo THEN
   MAKEPART(R, MonTop);
  END;
  RETURN 0;
 END {AvePaySpecialCheck};

 PRIVATE PROCEDURE DontNeedRegList(): SCAL[2];
 BEGIN
  RETURN (L_AvePay.GetRealNetNo() = L_AvePay.nn_AllDays) &
         ((AveTypeP.JMode = L_Sheet.jm_ParentalLeave) | (AveTypeP.JMode = L_Sheet.jm_ParentalLeaveUntil3Y));
 END {DontNeedRegList};

 PRIVATE PROCEDURE DayTime(ForceFromRegList: SCAL[2]; curJMode: LIKE(Sheet.JMode)): LIKE(RegList.Durat);
  VAR
   curType   : LIKE(JMode.Type);
   curDecrBal: LIKE(JMode.DecrBal);
 BEGIN
  IF    DontNeedRegList() THEN
   RETURN 0;
  ELSIF !AvePayP.Hours | ForceFromRegList THEN
   IF ~!curJMode THEN
    SAVE(JMode);
    L_General.CallUs(SEARCH(JMode, JMode, curJMode));
    curType   :=JMode.Type;
    curDecrBal:=JMode.DecrBal;
    RESTORE(JMode);
   ELSE
    SETEMPTY(curType, curDecrBal);
   END;
   IF curType = L_Sheet.jmType_HolTime THEN
    L_General.CallUs(~curDecrBal);
    RETURN 0;
   ELSE
    IF   StaffLog.DutyDgr >= 1.0 THEN
     RETURN RegList.Durat;
    ELSIF RegHead.GrTime = 0 THEN
     RETURN RegList.Durat*StaffLog.DutyDgr;
    ELSE
     RETURN RegList.GrTime;
    END;
   END;
  ELSIF L_AvePay.RegListIsInNet() THEN
   RETURN AvePayP.Hours;
  ELSE
   RETURN 0;
  END;
 END {DayTime};

 PRIVATE PROCEDURE GetPartOfWhole(_ActPer: DATE): FLOAT;
 BEGIN
  RETURN L_DatTim.DATEINT(L_DatTim.MonthBeg(_ActPer), L_DatTim.MonthEnd(_ActPer),
                          AvePayP.StartD, AvePayP.StopD) / (AvePayP.StopD-AvePayP.StartD+1);
 END {GetPartOfWhole};

 PRIVATE PROCEDURE IsNotEmptyAvePayP(): SCAL[2];
 BEGIN
  RETURN ~!AvePayP.StopD | ~!AvePayP.Amount;
 END {IsNotEmptyAvePayP};

 PRIVATE PROCEDURE IsFirstAvePayP(): SCAL[2];
  VAR
   Is: SCAL[2];
 BEGIN
  SAVE(AvePayP);
  Is:=~PREV(AvePayP);
  RESTORE(AvePayP);
  RETURN Is;
 END {IsFirstAvePayP};

 PRIVATE PROCEDURE GetDailyArrayIdx(Idx: NUMERIC[0]): NUMERIC[0];
 BEGIN
  RETURN Math.Min(Idx, MaxDaily - 2);
 END {GetDailyArrayIdx};

 PRIVATE PROCEDURE FillDailyByAvrg(_MonDays: tDays; _MonTime: L_PRoll.tTime);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= GetDailyArrayIdx(_MonDays) DO
   IF _MonDays > 0 THEN
    DailyTime[i]:=_MonTime / _MonDays;
    DailyDay [i]:=1;
   ELSE
    DailyTime[i]:=0;
    DailyDay [i]:=0;
   END;
   INC(i);
  END;
 END {FillDailyByAvrg};

 PRIVATE PROCEDURE AvePayPoint(): STRING[];
 BEGIN
  RETURN "㬥  ⢨/ -।:|" +
         AveType.Name + ", 稭騩  " + L_DatTim.DateStr(AvePay.StartD);
 END {AvePayPoint};

 PRIVATE PROCEDURE SetAccessDataMode();
 BEGIN
  TABLE.Get("RegList").AccessDataMode:=AccessDataMode_SOFT;
  TABLE.Get("RegHead").AccessDataMode:=AccessDataMode_SOFT;
 END {SetAccessDataMode};

 PRIVATE PROCEDURE NeedCalcByRegList(): SCAL[2];
 BEGIN
  IF (AvePay.Period >= 01\08\2012) & ~P_AveP.HasActualPro(AvePay.AvePay, P_AveP.P_DaysAmount) THEN
   RETURN 1;
  ELSE
   RETURN ~!AveTypeP.JMode | (AveType.Pass = L_AvePay.avepass_bySheet);
  END;
 END {NeedCalcByRegList};

 PRIVATE PROCEDURE CalculateByNetNo();
  VAR
   WrkDays: tDays;
 BEGIN
  L_General.Assert(~!AvePay.TSN, "室 㪠 ࠡ⭨");
  CONFORM(AvePay, Staff);
  L_Staff.PosToStaffLog(Staff.TSN, AvePayP.StartD, 1);
  AccessRegHead(L_DatTim.Per(AvePayP.StartD));
  IF NeedCalcByRegList() THEN
   SETZERO(WrkDays);
   Date:=AvePayP.StartD;
   SELECT(RegList, HumReg, , StaffLog.Regime);
   WHILE (~!AvePayP.StopD  & (Date <= AvePayP.StopD))      |
         (~!AvePayP.Amount & (WrkDays < AvePayP.Amount)) DO
    IF DontNeedRegList() THEN
     INC(WrkDays);
    ELSE
     AccessRegList(SRCINSEL(RegList, EQ, L_DatTim.Per(Date), L_DatTim.DAY(Date)), Date);
     IF L_AvePay.RegListIsInNet() THEN
      INC(WrkDays);
     END;
    END;
    INC(Date);
   END; (* WHILE ... *)
   IF !AvePayP.Amount THEN
    IF WrkDays > MAXOF(AvePayP.Amount) THEN
     L_General.Error(" ᫨誮  ਮ");
    END;
    AvePayP.Amount:=WrkDays;
   ELSIF !AvePayP.StopD THEN
    AvePayP.StopD :=Date-1;
   END;
  END;
 END {CalculateByNetNo};

 PRIVATE PROCEDURE SetPar(_Flags: LIKE(AvePay.Flags); n: SCAL[8]; Name: STRING[20]);
 BEGIN
  IF ~INBITSET(_Flags, n) THEN
   SETEMPTY(^Name);
  END;
 END {SetPar};

 PRIVATE PROCEDURE TstPar(VAR _Flags: LIKE(AvePay.Flags); n: SCAL[8]; Name: STRING[20]);
 BEGIN
  IF ~!^Name THEN
   INCL(_Flags, n);
  END;
 END {TstPar};

 PRIVATE PROCEDURE AvePay_SetAllPar();
 BEGIN
  SetPar(AvePay.Flags, AisNE, "AvePay.Average");
 END {AvePay_SetAllPar};

 PRIVATE PROCEDURE AvePay_TstAllPar();
 BEGIN
  AvePay.Flags:=0;
  TstPar(AvePay.Flags, AisNE, "AvePay.Average");
 END {AvePay_TstAllPar};

 PRIVATE PROCEDURE AvePayP_SetAllPar();
 BEGIN
  SetPar(AvePayP.Flags, DisNE, "AvePayP.Amount");
  SetPar(AvePayP.Flags, SisNE, "AvePayP.StopD");
  SetPar(AvePayP.Flags, HisNE, "AvePayP.Hours");
 END {AvePayP_SetAllPar};

 PRIVATE PROCEDURE AvePayP_TstAllPar();
 BEGIN
  AvePayP.Flags:=0;
  TstPar(AvePayP.Flags, DisNE, "AvePayP.Amount");
  TstPar(AvePayP.Flags, SisNE, "AvePayP.StopD");
  TstPar(AvePayP.Flags, HisNE, "AvePayP.Hours");
 END {AvePayP_TstAllPar};

 PRIVATE PROCEDURE AvePayP_Open();
 BEGIN
  AvePayP_SetAllPar();
  REPLACE(AvePayP);
 END {AvePayP_Open};

 PRIVATE PROCEDURE CheckAvePayPeriod(Silent: SCAL[2]; _StartD: DATE);
 BEGIN
  CONFORM(AvePay, AveType);
  IF (AveType.Pass = L_AvePay.avepass_byDocs) & (L_DatTim.Per(_StartD) > AvePay.Period) THEN
   IF ~Silent THEN
    L_StdFrm.Choice("ਮ 砫 㬥  ⢨/ -।  ⥪饣");
   END;
  ELSE
   L_General.Assert(L_DatTim.Per(_StartD) = AvePay.Period,
                    "㬥  ⢨/ -।|  ଫ   砫");
  END;
 END {CheckAvePayPeriod};

 PRIVATE PROCEDURE SetAvePayDates();
 BEGIN
  SAVE(AvePayP);
  CONFORM(AvePay, AvePayP);
  AvePay.StartD:=AvePayP.StartD;
  SETZERO(AvePay.Amount);
  WHILE OCCURE(AvePayP) & IsNotEmptyAvePayP() DO
   INC(AvePay.Amount, AvePayP.Amount);
   AvePay.StopD:=AvePayP.StopD;
   NEXT(AvePayP);
  END;
  RESTORE(AvePayP);
  IF !AvePay.StopD THEN
   AvePay.StopD:=AvePay.StartD+AvePay.Amount-1;
  END;
 END {SetAvePayDates};

 PUBLIC PROCEDURE AvePayP_Close(Silent: SCAL[2]);
  VAR
   trgStartD: DATE;
 BEGIN
  SetAccessDataMode();
  L_General.Assert(~!AvePayP.StartD, "室 ᫥⥫쭮 ନ  'ਮ' (譨  㤠)");
  CONFORM(AvePayP, AveTypeP);
  CONFORM(AveTypeP, AveType);
  IF IsFirstAvePayP() THEN
   CheckAvePayPeriod(Silent, AvePayP.StartD);
   IF AveType.Pass = L_AvePay.avepass_bySheet THEN
    L_General.Assert(~!AvePayP.StopD,
                     " ⮬  㬥  ⢨/ -।" +
                     "| 㪠뢠  砭");
    L_General.Assert(L_DatTim.Per(AvePayP.StartD) = L_DatTim.Per(AvePayP.StopD),
                     "㬥  ⢨/ -।" +
                     "|  ଫ  ।  ");
   END;
  END;
  L_General.Assert(NeedCalcByRegList() | ~!AvePayP.Amount,
                   " ⮬  㬥  ⢨/ -।" +
                   "|㪠뢠 ⮫쪮 ⢮ ");
  L_General.Assert(AvePayP.StartD<=AvePayP.StopD, " 砫 ਮ      砭");
  L_General.Assert(!AvePayP.Amount | (AvePayP.Amount>=0), "⢮     ⥫");
  L_General.Assert(!AvePayP.Hours  | (AvePayP.Hours >=0), "⢮ ᮢ    ⥫");

  IF    ~!AvePayP.StopD & ~!AvePayP.Amount THEN
   IF ~Silent THEN
    L_StdFrm.Choice(" 㪠   砭  ⢮ !" +
                    "|| ⮬ ०   㤥 ਭ 㪠  ⢮ ," +
                    "|஥, , ⫨砥  ⢠   䨪");
   END;
   L_General.Assert(~!AvePayP.Hours,
                    " ࠭  ० 室 㪠 ⢮ ᮢ  ");
  ELSIF ~!AvePayP.Hours THEN
   IF ~Silent THEN
    L_StdFrm.Choice(" ࠡ稥   " + FLDTOSTR(AvePayP.Hours, "3.", 0) + " ᮢ?");
   END;
  END;
  AvePayP_TstAllPar();
  CalculateByNetNo();
  REPLACE(AvePayP);
  SAVE(AvePayP);
  IF ~!AvePayP.StopD THEN
   trgStartD:=AvePayP.StopD + 1;
  ELSE
   trgStartD:=AvePayP.StartD + Math.Trunc(AvePayP.Amount + 1);
  END;
  IF NEXT(AvePayP) THEN
   IF IsNotEmptyAvePayP() THEN
    AvePayP_Open();
    AvePayP.StartD:=trgStartD;
    REPLACE(AvePayP);
    AvePayP_Close(Silent);
   ELSE
    AvePayP.StartD:=trgStartD;
    REPLACE(AvePayP);
   END;
  END; (* IF NEXT(AvePayP) ... *)
  RESTORE(AvePayP);

  SetAvePayDates();
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   REPLACE(AvePay);
  EXCEPT
  ON Exc: Exc_Root DO
   IF L_General.IsUniquenessViolationException(Exc) THEN
    L_General.Error("  ⠪ 㬥  ⢨/ -।");
   ELSE
    RAISE();
   END;
  END; (* TRY *)
 END {AvePayP_Close};

 PRIVATE PROCEDURE m_AsAvePayPAmount(): NUMERIC[3];
 BEGIN
  IF ~P_AveP.HasActualPro(AvePayP.AvePay, P_AveP.P_DaysAmount) THEN
   RETURN AvePayP.Amount;
  ELSE
   RETURN AvePayP.Amount * P_AveP.Get_DaysAmount() / AvePay.Amount;
  END;
 END {m_AsAvePayPAmount};

 PRIVATE PROCEDURE Make(Dir: NUMERIC[0]; Pass: LIKE(AveType.Pass));
  VAR
   ContPass  : PROC;
   curJMode  : LIKE(Sheet.JMode);
   NeedHJMode: LIKE(JMode.JMode);
   HlMustZero,
   ManualMode: SCAL[2];
   _MonDays  : tDays;
   _MonTime  : L_PRoll.tTime;
   NeedSpecChk: SCAL[2];
   totSum    : L_PRoll.tSum;
   totTim    : L_PRoll.tTime;
   curDayTime: LIKE(RegList.Durat);
   vdSaldo   : FLOAT;
 BEGIN
  IF ~L_AvePay.IsRealAvePay() THEN
   IF ProtDo THEN
    L_StdFrm.BlueHalt("⮪  㫨஢ 㬥  ନ");
   ELSE
    RETURN;
   END;
  END;
  SetAccessDataMode();
  IF ~StreamMode THEN
   L_General.SetConcurrentMode();
   Memo.gl_SetCurDate(AvePay.Period);
   IF ProcDo THEN
    L_APtm.ANYSystem_CheckClcPer(L_APtm.system_Salary);
   END;
  ELSE
   L_General.CallUs(AvePay.Period = Memo.gl_mb());
  END;
  L_General.CallUs((Dir = +1) | (Dir = -1));
  Store:=Dir;
  L_General.Assert(OCCURE(Staff) & (AvePay.TSN = Staff.TSN), "⨬ 맮");

  CONFORM(AvePay, AveType);
  L_General.Assert(L_DatTim.IsActive(AvePay.Period, AveType.Begin, AveType.Till),
                   " 㬥  ⢨/ -।" +
                   "|   " + L_DatTim.PeriodStr(AvePay.Period));

  L_General.Assert(~!AvePay.StartD,
                   "  ਮ ⢨ 㬥| ⢨/ -।");

  IF AveType.Pass = Pass THEN
   IF AvePay.Period >= 01\05\2000 THEN
    PASTE(^(L_Card.GetCardName(L_Card.t_AVT, AvePay.Period)));
   END;
   PASTE(^(L_Card.GetCardName(L_Card.t_AVP, AvePay.Period)));
 
   CONFORM(AvePay, Staff);
   L_Staff.PosToStaffLog(Staff.TSN, AvePay.StartD, 1);
   CONFORM(StaffLog, Sort, Officer, Union, Post, WagePay);
   HISTCONF(AvePay.StartD, WagePay, WagePayL);

   CONFORM(Staff, Man);
   IF ProtDo THEN
    IF ~L_General.KioskExecution_IsRunning() THEN
     OPENREP(R, L_General.NameConnection("AvPay_" + AveType.AveType), Create);
     IF L_PRoll.E_FitOnA5_AvePayReport(SYSDATE()) THEN
      SetPrintAttr(R, Orientation, Landscape,
                      TopMargin, 20,
                      BottomMargin, (297/2+20)(*   A5*),
                      RightMargin, 5);
     END;
    END;
    MAKEPART(R, Top);
    IF INBITSET(AvePay.Flags, AisNE) THEN
     MAKEPART(R, HandAve);
    END;
   END; (* IF ProtDo ... *)
 
   SETZERO(MonLineCnt, TotDays, TotTime, TotSum, HDCount);
   CONFORM(AvePay, AvePayP);
   IF Dir = +1 THEN
    L_General.Assert(OCCURE(AvePayP), "室,  ࠩ ,  ");
    AvePayP_Open();
    AvePayP_Close(1);
   END;
   IF ProtDo & (AveType.LimType = L_AvePay.avelim_Hldy) THEN
    SAVE(AvePay);
    SAVE(StaffLog);
    vdSaldo:=L_AvePay.GetVacationDaysSaldo(AvePay.TSN, AvePay.StopD + 1);
    RESTORE(StaffLog);
    RESTORE(AvePay);
   END;
   CONFORM(AvePay, AvePayP);
   CONFORM(AvePay, AveType);
   WHILE OCCURE(AvePayP) DO
    CONFORM(AvePayP, JMode);
    ManualMode:=0;
    IF    INBITSET(AvePayP.Flags, DisNE) & INBITSET(AvePayP.Flags, SisNE) THEN
     ContPass:=PROCREF(ByStop);
     ManualMode:=1;
     _MonDays  :=m_AsAvePayPAmount();
     _MonTime  :=AvePayP.Hours;
    ELSIF INBITSET(AvePayP.Flags, SisNE) | ((Dir = -1) & ~!AvePayP.StopD) THEN
     ContPass:=PROCREF(ByStop);
    ELSIF INBITSET(AvePayP.Flags, DisNE) THEN
     ContPass:=PROCREF(ByAmnt);
    ELSE
     L_General.Error("  砭 / ⢮ ");
    END;
    SETZERO(PaidDaysByFirm);
    SETEMPTY(NeedHJMode);

    IF ~NeedCalcByRegList() THEN
     SETEMPTY(DailyTime, DailyDay);
     ActPer  :=L_DatTim.Per(AvePayP.StartD);
     MonDays :=m_AsAvePayPAmount();
     IF ManualMode THEN
      MonTime:=AvePayP.Hours;
     ELSIF ~!AvePayP.Hours THEN
      MonTime:=MonDays*AvePayP.Hours;
     ELSE
      MonTime:=MonDays*GetRegBal(ActPer)/GetRegDays(ActPer);
     END;
     DayCount:=MonDays;
     ActPerDayCount:=MonDays;
     FillDailyByAvrg(MonDays, MonTime);
     HDCount :=0;
     L_PRoll.ExecMethod(AvePay.Period,
                        L_PRoll.GetMethod(AvePay.Period, AveTypeP.MthType),
                        PROCREF(SimpleProceedRule), PROCREF(AvePaySpecialCheck));
    ELSE
     IF ~DontNeedRegList() THEN
      AccessRegHead(L_DatTim.Per(AvePayP.StartD));
     END;
     SETZERO(DayCount);
     NeedSpecChk:=~StreamMode;
     Date:=AvePayP.StartD;

     LOOP
      IF ~ContPass() THEN
       EXIT;
      END;
      CONFORM(AvePayP, JMode);
      ActPer:=L_DatTim.Per(Date);
      SETZERO(MonTime, MonDays, ActPerDayCount);
      SETEMPTY(DailyTime, DailyDay);
      WHILE ContPass() & (L_DatTim.Per(Date) = ActPer) DO
       IF ~DontNeedRegList() THEN
        SETSEL(RegList, HumReg, StaffLog.Regime, ActPer);
        AccessRegList(SRCINSEL(RegList, EQ, L_DatTim.DAY(Date)), Date);
       END;
       IF L_AvePay.RegListIsInNet() THEN
        INC(DayCount);
        curJMode:=AveTypeP.JMode;
        IF ~ManualMode THEN
         curDayTime:=DayTime(0, curJMode);
         INC(MonDays);
         INC(MonTime, curDayTime);
         DailyTime[GetDailyArrayIdx(ActPerDayCount)]:=curDayTime;
         DailyDay [GetDailyArrayIdx(ActPerDayCount)]:=1;
        END;
       ELSE
        INC(HDCount);
        IF !NeedHJMode THEN
         IF !AveTypeP.JMode THEN
          NeedHJMode:=L_Sheet.jm_Hld(ActPer);    HlMustZero:=0;
         ELSIF JMode.InFirm & JMode.DecrBal & (JMode.Type = L_Sheet.jmType_PaidAbsent) THEN
          NeedHJMode:=L_Sheet.jm_HldAvp(ActPer); HlMustZero:=0;
         ELSE
          NeedHJMode:=L_Sheet.jm_Hld(ActPer);    HlMustZero:=1;
         END;
        END; (* IF !NeedHJMode ... *)
        curJMode:=NeedHJMode; (*室*);
        curDayTime:=DayTime(0, curJMode);
        L_General.Assert(~HlMustZero | (curDayTime = 0),
                         " ० ࠡ " + RegList.Regime + "  " +
                         RegList.Day+"."+L_DatTim.PeriodStr(RegList.Period) +
                         "| 室  㪠 ६  ଥ");
        IF ~HlMustZero THEN
         INC(MonTime, curDayTime);
        END;
        DailyTime[GetDailyArrayIdx(ActPerDayCount)]:=curDayTime;
        DailyDay [GetDailyArrayIdx(ActPerDayCount)]:=0;
       END;
       INC(ActPerDayCount);
       IF ProcDo & ~!AveTypeP.JMode THEN
        IF Dir # -1 THEN
         L_Sheet.MayREPSheet(Date);
         IF NeedSpecChk & ~!L_EDO.sra_GetSpecifiedJMode(Staff.TSN, Date) THEN
          L_StdFrm.Choice(" ६ ⢨ 㬥  ⢨/ -।" +
                          "| ७ᥭ 室, ਬ "+L_DatTim.DateStr(Date));
          NeedSpecChk:=0;
         END;
         L_Sheet.UpdateSheet(Date, curJMode, DayTime((JMode.Type # L_Sheet.jmType_TimDone) | ManualMode, curJMode),
                             0, 0, EMPTYOF(Sheet.DayTime), L_Sheet.src_AvePay);
        ELSIF SEARCH(Sheet, TSN, Staff.TSN, L_DatTim.Per(Date), L_DatTim.DAY(Date)) THEN
         REMOVE(Sheet);
        END;
       END; (* IF ProcDo... *)
       INC(Date);
      END; (* WHILE ContPass() & (L_DatTim.Per(Date) = ActPer) *)
      IF ManualMode THEN
       IF ActPer = L_DatTim.Per(AvePayP.StopD) THEN
        MonDays:=_MonDays;
        MonTime:=_MonTime;
        FillDailyByAvrg(_MonDays, _MonTime);
       ELSE
        MonDays:=m_AsAvePayPAmount() * GetPartOfWhole(ActPer);
        MonTime:=AvePayP.Hours  * GetPartOfWhole(ActPer);
        DEC(_MonDays, MonDays);
        DEC(_MonTime, MonTime);
        FillDailyByAvrg(MonDays, MonTime);
       END;
      END;
      L_PRoll.ExecMethod(AvePay.Period,
                         L_PRoll.GetMethod(AvePay.Period, AveTypeP.MthType),
                         PROCREF(SimpleProceedRule), PROCREF(AvePaySpecialCheck));
     END; (* LOOP *)
     IF ~ManualMode THEN
      IF (m_AsAvePayPAmount() # DayCount) | (AvePayP.StopD # (Date-1)) THEN
       L_General.CallUs(Dir = -1); (*  㬥  ᮮ⢥ *)
       L_StdFrm.ConditionalCHOICE("ॡ   㬥⠬,  ࠩ " +
                                  "| ࠡ⭨ " + Staff.TSN + "." +
                                  "|, ந諮  䨪  ᫮",
                                  L_General.IsAdmin());
      END;
     END;
    END; (* IF !AveTypeP.JMode ... *)
    L_General.Assert(!AveTypeP.JMode | (Dir = -1) |
                     (AvePayP.StopD <= StaffLog.DateE),
                     "㬥  ⢨/ -।" +
                     "|   ।  ਪ  /.||" + AvePayPoint());
    NEXT(AvePayP);
   END; (* WHILE OCCURE(AvePayP) ... *)

   IF ProcDo THEN
    REPLACE(AvePay);
    IF (Dir = -1) & SELECT(MoneyDst, XDocId, L_XDoc.curXDocId(L_XDoc.xdt_AvePay)) THEN
     SETZERO(totSum, totTim);
     REPEAT
      GETLASTVERSION(MoneyDst);
      INC(totSum, MoneyDst.Sum);
      INC(totTim, MoneyDst.Tim);
     UNTIL ~NEXT(MoneyDst);
     IF (totSum # 0) | (totTim # 0) THEN
      L_General.Error("ॡ  ' 㬥⠬'  " + L_DatTim.PeriodStr(AvePay.Period));
     END;
    END; (* IF Dir = -1 ... *)
   END; (* IF ProcDo ... *)
   IF ProtDo THEN
    IF ManualMode THEN
     HDCount:=AvePay.StopD-AvePay.StartD+1-AvePay.Amount;
    END;
    MAKEPART(R, Itog);
    IF (AvePay.StartD < 01\05\2012) & (AvePay.StartD >= 01\01\2011) &
       (AveType.AveNo = L_AvePay.aveno_Sick) & (TotSum # 0) THEN
     MAKEPART(R, ItogSick);
    END;
    IF L_AvePay.AvePayHasJMode() THEN
     MAKEPART(R, ItogAmount);
    END;
    IF AveType.LimType = L_AvePay.avelim_Hldy THEN
     MAKEPART(R, ItogVctDSaldo, vdSaldo);
    END;
    IF L_General.KioskExecution_IsRunning() THEN
     MAKEPART(R, EndRep_EU);
    ELSE
     MAKEPART(R, EndRep);
     CLOSEREP(R);
    END;
   END;
  END; (* IF AveType.Pass ... *)
 END {Make};

 PRIVATE PROCEDURE AvePay_Proceed(Dir: NUMERIC[0]);
 BEGIN
  CONFORM(AvePay, Staff);
  TrialAvepayMode:=0;
  ProcDo:=1; StreamMode:=0;
  ToWord:=0;
  IF Dir = +1 THEN
   PROMPT("⨥  "+AvePay.AvePay);
   CONFORM(AvePay, AveType);
   ProtDo:=(AveType.Pass = L_AvePay.avepass_byDocs) & (AvePay.Status = L_AvePay.st_Estimated);
   AvePay_TstAllPar();
   REPLACE(AvePay);
   Make(+1, L_AvePay.avepass_byDocs);
  ELSE
   PROMPT("⨥  "+AvePay.AvePay);
   ProtDo:=0;
   Make(-1, L_AvePay.avepass_byDocs);
   AvePay_SetAllPar();
   REPLACE(AvePay);
  END;
  IF L_AvePay.IsRealAvePay() THEN
   IF AvePay.Status = L_AvePay.st_Estimated THEN
    L_PRoll.ShtDone(0);
   ELSE
    L_PRoll.AveDone(0);
   END;
   L_two.m_MarkAsNotActual(Staff.TSN, AvePay.StartD, AvePay.StopD);
  END;
 END {AvePay_Proceed};

 PUBLIC PROCEDURE AvePay_OnStreamingProceed(IsTrialAvepayMode: SCAL[2]);
 BEGIN
  IF ~IsTrialAvepayMode THEN
   PROMPT("  "+AvePay.AvePay);
  END;
  L_General.Assert((AvePay.Status # L_AvePay.st_Prepared) |
                   ((L_PRoll.curCountUp = L_PRoll.cu_strmUpToDate) & (AvePay.StartD > Memo.ud_cd())),
                   "室 ⠪஢|㬥  ⢨/ -।  " + L_DatTim.DateStr(AvePay.StartD));
  TrialAvepayMode:=IsTrialAvepayMode;
  ProcDo:=1;
  ProtDo:=0;
  ToWord:=0;
  StreamMode:=1;
  AvePay_SetAllPar();
  CONFORM(AvePay, AveType);
  Make(+1, AveType.Pass);
 END {AvePay_OnStreamingProceed};

 PRIVATE PROCEDURE AccessAvePay();
 BEGIN
  L_General.Assert(ACCESS(AvePay), " ⠭ 㬥  ⢨/ -।");
 END {AccessAvePay};

 PRIVATE PROCEDURE AvePay_OnMakeProtocol(inModifing: SCAL[2]);
 BEGIN
  AccessAvePay();
  CONFORM(AvePay, AveType);
  CONFORM(AvePay, Staff);
  PROMPT("⮪ ࠡ⪨  "+AvePay.AvePay);
  TrialAvepayMode:=0;
  ProcDo:=0; ProtDo:=1; StreamMode:=0; ToWord:=0;
  IF inModifing THEN
   AvePay_TstAllPar();
  END;
  AvePay_SetAllPar();
  Make(+1, AveType.Pass);
  IF ~L_General.KioskExecution_IsRunning() & ~StreamMode THEN
   L_General.HaltAndSurveyLastReport(EMPTYOF(Exc_Root));
  ELSE
   HALT();
  END;
 END {AvePay_OnMakeProtocol};

 PUBLIC PROCEDURE MakeProtocol();
 BEGIN
  AvePay_OnMakeProtocol(0);
 END {MakeProtocol};

 PUBLIC PROCEDURE MakeProtocol_WhileEdIns();
 BEGIN
  L_General.Assert(~!AvePay.AveType, " 㪠  㬥  ⢨/ -।");
  L_General.Assert(~!AvePay.TSN, " 㪠 ⠡ ");
  AvePay_OnMakeProtocol(1);
 END {MakeProtocol_WhileEdIns};

 PUBLIC PROCEDURE MakeProtocol2Word();
  VAR
   sum13: NUMERIC[0];
   IsStorno: SCAL[2];
 BEGIN
  TRY [ABORT_AFTER(AA_ON)]
   L_MSO.wordSetVar("AvePay.Average.Hours", "");
   L_MSO.wordSetVar("AvePay.Average.Days",  "");
   SETZERO(ToWordHistIdx, ToWordHistSum, ToWordDays, ToWordSumFromFOT, ToWordSumOther);
   SETEMPTY(ToWordMonthName);
   AccessAvePay();
   CONFORM(AvePay, AveType);
   CONFORM(AvePay, Staff);
   PROMPT("⮪ ࠡ⪨  "+AvePay.AvePay);
   TrialAvepayMode:=0;
   ProcDo:=0; ProtDo:=0; StreamMode:=0; ToWord:=1;
   AvePay_SetAllPar();
   Make(+1, AveType.Pass);
   IF ToWordHistIdx = 0 THEN
    WHILE ToWordHistIdx < 12 DO
     L_MSO.wordSetDateVar ("AvePay.HistPer" + L_MSO.IndexStr(ToWordHistIdx) + ".Period", EMPTYOF(DATE));
     L_MSO.wordSetMoneyVar("AvePay.HistPer" + L_MSO.IndexStr(ToWordHistIdx) + ".Sum",    AvePay.Period, EMPTYOF(FLOAT));
     L_MSO.wordSetVar     ("AvePay.HistPer" + L_MSO.IndexStr(ToWordHistIdx) + ".Tim",    "");
     INC(ToWordHistIdx);
    END;
    L_MSO.wordSetMoneyVar("AvePay.HistTotSum", AvePay.Period, EMPTYOF(FLOAT));
   ELSE
    L_MSO.wordSetMoneyVar("AvePay.HistTotSum", AvePay.Period, ToWordHistSum);
   END;
   L_MSO.SetWordTable("AvHistory", ToWordHistIdx);

   L_MSO.wordSetVar("AvePay.CurMonth.Name", ToWordMonthName[0]);
   L_MSO.wordSetVar("AvePay.CurMonth.Days", FLDTOSTR(ToWordDays[0], L_AvePay.DaysFormat()));
   L_MSO.wordSetMoneyVar("AvePay.CurMonth.SumFromFOT", AvePay.Period, ToWordSumFromFOT[0]);
   L_MSO.wordSetMoneyVar("AvePay.CurMonth.SumOther",   AvePay.Period, ToWordSumOther[0]);
   L_MSO.wordSetVar("AvePay.FutMonth.Name", ToWordMonthName[1]);
   L_MSO.wordSetVar("AvePay.FutMonth.Days", FLDTOSTR(ToWordDays[1], L_AvePay.DaysFormat()));
   L_MSO.wordSetMoneyVar("AvePay.FutMonth.SumFromFOT", AvePay.Period, ToWordSumFromFOT[1]);
   L_MSO.wordSetMoneyVar("AvePay.FutMonth.SumOther",   AvePay.Period, ToWordSumOther[1]);
   L_MSO.wordSetMoneyVar("AvePay.TotalSum", AvePay.Period, TotSum);
   sum13:=TotSum*0.13;
   L_MSO.wordSetMoneyVar("AvePay.TotalSum.13Prc", AvePay.Period, sum13);
   L_MSO.wordSetMoneyVar("AvePay.TotalSum.87Prc", AvePay.Period, TotSum - sum13);
   IsStorno:=TotSum < 0;
   L_MSO.wordSetVar("AvePay.IsStorno", IsStorno);
  EXCEPT
  END; (* TRY *)
 END {MakeProtocol2Word};

 PUBLIC PROCEDURE AvePay_OnReproceedAll();
  VAR
   d: DATE;
 BEGIN
  PROMPT("  㬥⠬");
  L_PRoll.ClearMoney(L_PRoll.src_AvePay);
  SELECT(AvePay, Period, , Memo.gl_mb(), Staff.TSN);
  WHILE OCCURE(AvePay) DO
   CONFORM(AvePay, AveType);
   IF AveType.Pass = L_AvePay.avepass_byDocs THEN
    IF L_AvePay.IsRealAvePay() THEN
     CONFORM(AvePay, AvePayP);
     WHILE OCCURE(AvePayP) DO
      CONFORM(AvePayP, AveTypeP);
      IF ~!AveTypeP.JMode THEN
       d:=AvePayP.StartD;
       WHILE d <= AvePayP.StopD DO
        IF SEARCH(Sheet, TSN, Staff.TSN, L_DatTim.Per(d), L_DatTim.DAY(d)) THEN
         REMOVE(Sheet);
        END;
        INC(d);
       END;
      END; (* IF !AvePayP.StopD ... *)
      NEXT(AvePayP);
     END; (* WHILE OCCURE(AvePayP) ... *)
    END;
    AvePay_OnStreamingProceed(0);
   END; (* IF AveType.Pass ... *)
   NEXT(AvePay);
  END; (* WHILE OCCURE(AvePay ... *)
  L_PRoll.AveDone(1);
 END {AvePay_OnReproceedAll};

 PRIVATE PROCEDURE MayEstimate(): SCAL[2];
  VAR
   AddGroups: STRING[];
 BEGIN
  IF ~!AvePay.AveType THEN
   CONFORM(AvePay, AveType);
   IF ~!AveType.apEstmt THEN
    RETURN L_AcsPnt.MayPassAccessPoint(AveType.apEstmt);
   END;
  END;
  RETURN L_General.SilentCheckRightsByMEMBEROF("PAYROLL", "");
 END {MayEstimate};

 PRIVATE PROCEDURE PassEstimateAccessPoint();
  VAR
   advice: STRING[];
 BEGIN
  CONFORM(AvePay, AveType);
  advice:="(ன  ࠢ筨 ' 㬥⮢  ⢨/ -।', " + AveType.AveType + ")";
  IF ~!AveType.apEstmt THEN
   L_AcsPnt.fullPassAccessPoint(AveType.apEstmt, "", advice);
  ELSIF L_General.IsAdmin() | L_General.IsMemberOf("PAYROLL") THEN
   L_AR.GrantRightsForInteractiveModification();
  ELSE
   L_General.Error("   稩 ⠪஢|" + advice);
  END;
 END {PassEstimateAccessPoint};

 PRIVATE PROCEDURE pap_AnyModification();
 BEGIN
  IF MayEstimate() THEN
   L_AR.GrantRightsForInteractiveModification();
   (* .. ⠥,  ᫨  ࠢ (   CrucialCHOICE)  ⠪஢ ,
        䨪 ⠪஢ ࠢ   ᮢ *)
  END;
  L_AcsPnt.PassAccessPointIfAllowed(acspnt_AvePayModify);
 END {pap_AnyModification};

 PRIVATE PROCEDURE AvePay_OnAfterEdIns();
 BEGIN
  pap_AnyModification();
  CONFORM(AvePay, AveType);
  IF AveType.LimType # L_AvePay.avelim_None THEN
   L_General.Assert(~!AvePay.PFFrom & ~!AvePay.PFTill, "室   ' ਮ , '");
   L_General.Assert(AvePay.PFFrom < AvePay.PFTill,     "୮  ' ਮ':"+
                                                       "|砫   ࠭ 砭");
  END;
  L_General.Assert(Math.Abs(P_AveP.Get_DaysAmount() - AvePay.Amount) < 1,
                   "  ᢮⢥ ⢮   " +
                   "| ⫨    㬥  祬  1 ");
  AvePay_Proceed(+1);
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_AvePay, L_XDoc.EmptyXDocKind, AvePay.AvePay);
  IF ProtDo THEN
   LIKEMENU(Survey, "");
  END;
 END {AvePay_OnAfterEdIns};

 PRIVATE PROCEDURE AvePay_OnBeforeEdIns();
 BEGIN
  RTI.Get().CurZone.Fields("AvePay.TSN"    ).First:=!RTI.Get().CurWindow.ParentZone.Window.ParentZone;
(* 0091539  ࠢ ਠ, ᫥ 믮 0090706
  RTI.Get().CurZone.Fields("AvePay.TSN"    ).First:=RTI.Get().CurZone.Fields("AvePay.TSN").Modifiable;
*)
  RTI.Get().CurZone.Fields("AvePay.AveType").First:=~RTI.Get().CurZone.Fields("AvePay.TSN").First;
 END {AvePay_OnBeforeEdIns};

 PRIVATE PROCEDURE AvePay_OnBeforeEdit();
 BEGIN
  AvePay_OnBeforeEdIns();
  IF AvePay.Status = L_AvePay.st_Estimated THEN
   PassEstimateAccessPoint();
  ELSE
   pap_AnyModification();
  END;
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_AvePay, L_XDoc.EmptyXDocKind, AvePay.AvePay, L_XDoc.action_Edit);
  IF ~MayEstimate() & (AvePay.Status > L_AvePay.st_Prepared) THEN
   L_StdFrm.Choice("  㬥  ⢨/ -।");
  END;
  AvePay_Proceed(-1);
 END {AvePay_OnBeforeEdit};

 PRIVATE PROCEDURE AvePay_OnAfterEdit();
  VAR
   _Status: LIKE(AvePay.Status);
 BEGIN
  _Status:=GetDefaultStatus();
  IF (_Status = L_AvePay.st_Prepared) & (AvePay.Status = L_AvePay.st_Estimated) THEN
   L_StdFrm.Choice("ﭨ 㬥  ⢨/ -।" +
                   "|㤥 ॢ  '" + L_AvePay.GetAvePayStatus_asStr() + "'  '⮢'");
   AvePay.Status:=_Status;
   REPLACE(AvePay);
  END;
  AvePay_OnAfterEdIns();
 END {AvePay_OnAfterEdit};

 PRIVATE PROCEDURE GetDefaultStatus(): LIKE(AvePay.Status);
 BEGIN
  IF MayEstimate() THEN
   RETURN L_AvePay.st_Estimated;
  ELSE
   RETURN L_AvePay.st_Prepared;
  END;
 END {GetDefaultStatus};

 PRIVATE PROCEDURE AvePay_OnBeforeInsert();
 BEGIN
  AvePay_OnBeforeEdIns();
  pap_AnyModification();
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_AvePay, L_XDoc.EmptyXDocKind, AvePay.AvePay, L_XDoc.action_Insert);
  AvePay.Period:=Memo.ud_mb();
  AvePay.Status:=GetDefaultStatus();
  REPLACE(AvePay);
 END {AvePay_OnBeforeInsert};

 PRIVATE PROCEDURE AvePay_OnAfterInsert();
 BEGIN
  AvePay_OnAfterEdIns();
 END {AvePay_OnAfterert};

 PRIVATE PROCEDURE AvePay_OnBeforeDelete();
 BEGIN
  L_General.Error(" 㬥⮢  ⢨/ -। 饭." +
                  "|ᯮ '㫨஢'");
 END {AvePay_OnBeforeDelete};

 PRIVATE PROCEDURE GetPrevStopD(): DATE;
  VAR
   Result: DATE;
 BEGIN
  SETEMPTY(Result);
  SAVE(AvePayP);
  CHANGESEL(AvePayP, AvePay, , AvePayP.AvePay);
  IF PREV(AvePayP) & IsNotEmptyAvePayP() THEN
   IF ~!AvePayP.StopD THEN
    Result:=AvePayP.StopD + 1;
   ELSE
    Result:=AvePayP.StartD + Math.Trunc(AvePayP.Amount + 1);
   END;
  END;
  RESTORE(AvePayP);
  RETURN Result;
 END {GetPrevStopD};

 PUBLIC PROCEDURE FillAvePayP();
 BEGIN
  L_General.Assert(~!AvePay.AveType, "室   㬥  ⢨/ -।");
  CONFORM(AvePay, AveType);
  CONFORM(AveType, AveTypeP);
  WHILE OCCURE(AveTypeP) DO
   IF ~SEARCH(AvePayP, AvePay, AvePay.AvePay, AveTypeP.AveTypeP) THEN
    DEFAULT(AvePayP);
    AvePayP.AvePay  :=AvePay.AvePay;
    AvePayP.AveType :=AvePay.AveType;
    AvePayP.AveTypeP:=AveTypeP.AveTypeP;
    AvePayP.Flags   :=0;
    INSERT(AvePayP);
    AvePayP.StartD  :=GetPrevStopD();
    REPLACE(AvePayP);
   END;
   NEXT(AveTypeP);
  END; (* WHILE OCCURE(AveTypeP) ... *)
 END {FillAvePayP};

 PRIVATE PROCEDURE SetAvePayConditionalFieldsModifiable();
  VAR
   Fields    : FORM_FIELDS;
   Modifiable: SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF ~!AvePay.AveType THEN
   CONFORM(AvePay, AveType);
   Modifiable:=AveType.LimType # L_AvePay.avelim_None;
  ELSE
   Modifiable:=0;
  END;
  Fields("AvePay.PFFrom").Modifiable                          :=Modifiable;
  Fields("AvePay.PFTill").Modifiable                          :=Modifiable;
  RTI.Get().CurWindow.Zones(1).Fields("AvePayP.Amount").Format:="0";
 END {SetAvePayConditionalFieldsModifiable};

 PRIVATE PROCEDURE AvePay_AveType_OnSuccessfulChange();
  VAR
   _Status: LIKE(AvePay.Status);
 BEGIN
  L_General.Assert(~!AvePay.AveType, "饭 ⠢ ");
  L_General.Assert(AvePay.Status # L_AvePay.st_Canceled,
                   "饭   㫨஢|㬥  ⢨/ -।");
  _Status:=GetDefaultStatus();
  IF _Status # AvePay.Status THEN
   L_StdFrm.Inform("㤥  ﭨ 㬥  ⢨/ -।");
   AvePay.Status:=_Status;
   REPLACE(AvePay);
  END;
  CONFORM(AvePay, AveType);
  IF ~!GE_PVALUE(AvePay.AveType) THEN
   L_StdFrm.Choice("騥   ਮ  㤠");
   IF P_AveP.SearchPro(AvePay.AvePay, P_AveP.P_Features) THEN
    REMOVE(AvePPro);
   END;
   SETEMPTY(AvePay.StartD, AvePay.StopD, AvePay.Amount);
   IF AveType.LimType = L_AvePay.avelim_None THEN
    SETEMPTY(AvePay.PFFrom, AvePay.PFTill);
   END;
   REPLACE(AvePay);
   SELECT(AvePayP, AvePay, , AvePay.AvePay);
   WHILE OCCURE(AvePayP) DO
    REMOVE(AvePayP);
   END;
  END; (* IF ~!GE_PVALUE ... *)
  FillAvePayP();
  SetAvePayConditionalFieldsModifiable();
 END {AvePay_AveType_OnSuccessfulChange};

 PRIVATE PROCEDURE AvePay_PFFrom_OnSuccessfulChange();
 BEGIN
  IF ~!AvePay.PFFrom & !AvePay.PFTill THEN
   AvePay.PFTill:=L_DatTim.IncYear(L_DatTim.Per(AvePay.PFFrom), 1)+L_DatTim.DAY(AvePay.PFFrom)-1;
   REPLACE(AvePay);
  END;
 END {AvePay_PFFrom_OnSuccessfulChange};

 PRIVATE PROCEDURE AvePay_Status_OnSuccessfulChange();
  VAR
   prvStatus: LIKE(AvePay.Status);
 BEGIN
  L_General.Assert(~!AvePay.AveType, " 㪠  㬥");
  prvStatus:=GE_PVALUE();
  IF    (AvePay.Status = L_AvePay.st_Estimated) | (prvStatus = L_AvePay.st_Estimated) THEN
   PassEstimateAccessPoint();
  END;
  IF    prvStatus = L_AvePay.st_Canceled THEN
   L_StdFrm.Choice("  ⬥ 㫨஢|㬥  ⢨/ -।?");
  ELSIF AvePay.Status = L_AvePay.st_Canceled THEN
   L_StdFrm.Choice("  㫨஢ 㬥  ⢨/ -।?");
  END;
 END {AvePay_Status_OnSuccessfulChange};

 PRIVATE PROCEDURE AvePayP_OnBeforeInsert();
 BEGIN
  L_General.Error("饭 . ᯮ ' ਮ'");
 END {AvePayP_OnBeforeInsert};

 PRIVATE PROCEDURE AvePayP_OnBeforeEdit();
 BEGIN
  RTI.Get().CurZone.Fields("AvePayP.StartD").Modifiable:=IsFirstAvePayP();
  AvePayP_Open();
 END {AvePayP_OnBeforeEdit};

 PRIVATE PROCEDURE AvePayP_OnAfterEdit();
 BEGIN
  L_General.Assert(AvePayP.Amount # 0, "   㦭 ਮ");
  AvePayP_Close(0);
 END {AvePayP_OnAfterEdit};

 PRIVATE PROCEDURE AvePayP_OnBeforeDelete();
 BEGIN
  IF ~!AvePayP.StartD THEN
   AvePayP_Open();
   SETEMPTY(AvePayP.StopD);
   AvePayP.Amount:=0;
   REPLACE(AvePayP);
   AvePayP_Close(1);
  END;
 END {AvePayP_OnBeforeDelete};

 PRIVATE PROCEDURE AveTypeE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterMdf, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["AveType.Name", "AveType.AveType", "apEstmt"]);
  L_WDO.iUnmodifiable(0, ["AveTypeNetNo_2"]);
  L_WDO.iMayBeEmpty  (0, ["AveType.Till"]);
  L_WDO.iField       (0, "apEstmt").Format:="|";
  L_WDO.iField       (0, "AveType.NetNo").Format:=L_AvePay.nn_Pool;
  L_WDO.iProgs       (0, "AvePay");
  L_WDO.iSubwindow   (1, "ATPE");
  L_WDO.iZone        (2).ParentZone:=L_WDO.iZone(0);
  L_WDO.iZone        (2).PermanentFilter:="(AcsPnt.AcsPnt = AveType.apEstmt)";
  L_WDO.iSubwindow   (2, "AcsPntE");
 END {AveTypeE_OnInitializeWindow};

 PRIVATE PROCEDURE AveTypeE_0_OnReposition();
 BEGIN
  IF ACCESS(AveType) THEN
   RTI.Get().CurZone.Fields("apEstmt").Value:=~!AveType.apEstmt;
  END;
 END {AveTypeE_0_OnReposition};

 PRIVATE PROCEDURE SetAcsPnt();
 BEGIN
  IF ~!AveType.apEstmt THEN
   L_AcsPnt.SetAcsPnt(AveType.apEstmt,
                      "஢",
                      "஢   '" + AveType.Name + "' (" + AveType.AveType + ")",
                      "PayRoll",
                      L_AcsPnt.aprm_None);
  END;
 END {SetAcsPnt};

 PRIVATE PROCEDURE AveType_apEstmt_OnSuccessfulChange();
 BEGIN
  IF RTI.Get().CurZone.ActiveField.Value THEN
   L_General.CallUs(!AveType.apEstmt);
   DEFAULT(AcsPnt);
   INSERT(AcsPnt);
   IF ~L_AcsPnt.IsUserDefined(AcsPnt.AcsPnt) THEN
    AcsPnt.AcsPnt:=L_AcsPnt.NewUserDefinedAcsPnt();
    REPLACE(AcsPnt);
   END;
   AveType.apEstmt:=AcsPnt.AcsPnt;
   REPLACE(AveType);
   SetAcsPnt();
  ELSE
   L_General.CallUs(~!AveType.apEstmt & SEARCH(AcsPnt, AcsPnt, AveType.apEstmt));
   IF SELECT(AcsPntR, AcsPnt, AcsPnt.AcsPnt) & NEXT(AcsPntR) THEN
    L_StdFrm.Question("祭 ᯥ樠   㤠");
   END;
   SETEMPTY(AveType.apEstmt);
   REPLACE(AveType);
   SE_INTEGRITY(1);
   REMOVE(AcsPnt);
   SE_INTEGRITY(0);
  END;
 END {AveType_apEstmt_OnSuccessfulChange};

 PRIVATE PROCEDURE AveType_AveType_OnSuccessfulChange();
  VAR
   srcAveType: LIKE(AveType.AveType);
   srcapEstmt: LIKE(AveType.apEstmt);
 BEGIN
  srcAveType:=L_WDO.GetInsertionSource();
  IF ~!srcAveType THEN
   L_General.Assert(~!AveType.AveType, "  㬥 室 㪠   ।");
   SETSEL(AveTypeP, AveType, srcAveType);
   FOR_EACH AveTypeP DO
    PROMPT("஢  " + AveTypeP.AveTypeP);
    AveTypeP.AveType:=AveType.AveType;
    INSERT(AveTypeP);
   END; (* FOR_EACH AveTypeP *)

   IF ~!AveType.apEstmt THEN
    srcapEstmt:=AveType.apEstmt;
    DEFAULT(AcsPnt);
    INSERT(AcsPnt);
    AveType.apEstmt:=AcsPnt.AcsPnt;
    REPLACE(AveType);
    SETSEL(AcsPntR, AcsPnt, srcapEstmt);
    FOR_EACH AcsPntR DO
     PROMPT("஢ 窨 㯠 " + AcsPntR.AcsPnt);
     AcsPntR.AcsPnt:=AveType.apEstmt;
     INSERT(AcsPntR);
    END; (* FOR_EACH AcsPntR *)
   END; (* IF ~!AveType.apEstmt... *)
  END;
  SetAcsPnt();
 END {AveType_AveType_OnSuccessfulChange};

 PRIVATE PROCEDURE AveType_Name_OnSuccessfulChange();
 BEGIN
  SetAcsPnt();
 END {AveType_Name_OnSuccessfulChange};

 PRIVATE PROCEDURE AveType_OnAfterEdIns();
 BEGIN
  CONFORM(AveType, AveTypeP);
  L_General.Assert(OCCURE(AveTypeP),
                   "     |㬥  ⢨/ -।");
  IF AveType.Pass = L_AvePay.avepass_bySheet THEN
   WHILE OCCURE(AveTypeP) DO
    L_General.Assert(!AveTypeP.JMode, " ⠤  ' ⠡' ⨬ ⬥⪨  ⠡");
    NEXT(AveTypeP);
   END; (* WHILE OCCURE(AveTypeP) ... *)
  END;
 END {AveType_OnAfterEdIns};

 PRIVATE PROCEDURE AveType_OnAfterInsert();
 BEGIN
  AveType_OnAfterEdIns();
 END {AveType_OnAfterInsert};

 PRIVATE PROCEDURE AveType_OnAfterEdit();
 BEGIN
  AveType_OnAfterEdIns();
 END {AveType_OnAfterEdit};

 PRIVATE PROCEDURE AveType_OnBeforeDelete();
 BEGIN
  IF ~!AveType.apEstmt THEN
   SE_INTEGRITY(1);
   SEARCH(AcsPnt, AcsPnt, , AveType.apEstmt);
   SETEMPTY(AveType.apEstmt);
   REPLACE(AveType);
   REMOVE(AcsPnt);
  END;
 END {AveType_OnBeforeDelete};

 PRIVATE PROCEDURE Shift(Dir: NUMERIC[0]);
  VAR
   oldPeriod: DATE;
 BEGIN
  AccessAvePay();
  IF AvePay.Status = L_AvePay.st_Estimated THEN
   L_General.Error("஢ 㬥 饭 ७  㣮 ."+
                   "|室 ॢ 㬥  '⮢'");
  ELSE
   IF MayEstimate() THEN
    L_AR.GrantRightsUnconditionally();
   ELSE
    L_AcsPnt.PassAccessPoint(acspnt_AvePayModify);
   END;
  END;
  L_SysLog.SingleMark_Init("AvePay");
  oldPeriod    :=AvePay.Period;
  AvePay.Period:=L_DatTim.IncMonth(AvePay.Period, Dir);
  REPLACE(AvePay);
  CheckAvePayPeriod(0, AvePay.StartD);
  CONFORM(AvePay, Staff);
  L_PRoll.AveDone_AP(Math.Min(oldPeriod, AvePay.Period), 0);
  L_XDoc.Jrn_Mark(L_XDoc.curXDocId(L_XDoc.xdt_AvePay), L_XDoc.action_AutoEdit);
  L_SysLog.SingleMark_Done("AvePay");
 END {Shift};

(*
$P{ AvPDs_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
Staff.TSN, L, ""
Man.Name, L, ""
@
############################################################# ########## #####
=#####========================================================================
|      ⢮   㬥⠬  ⢨/ -।     |
|                     ਮ  ##########  ##########                    |
|----------------------------------------------------------------------------|
|⭨ ##### #############################################################|
|----------------------------------------------------------------------------|
| ࠡ  ⠡ ( 㬥)                |  ''||
|----------------------------------------------------|-----------|-----------|
}
*)

(*
$P{ AvPDs_Line:
?, L, ""
?, R, "0"
?, R, "0"
@
|####################################################|###########|###########|
}
*)

(*
$P{ AvPDs_Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE CreateTmp();
 BEGIN
  CreateFILE(Tmp, "", "", "");
  CreateFIELD(Tmp, Name, STRING[35], "", "",  "", "", "");
  CreateFIELD(Tmp, Days, tDays[2],   "", "0", "", "", "");

  CreateINDEX(Tmp, Tmp, UNIQUE, "", "", Name);

  SetVersionOfFILE(Tmp, 0000);
  L_AFM.CreateTemp("Tmp");
 END {CreateTmp};

 CONST
  d_Paid  = 0;
  d_Clndr = 1;

 PRIVATE PROCEDURE MakeTmp(trgFrom, trgUpTo: DATE);
  VAR
   _Name: STRING[35];
 BEGIN
  CreateTmp();
  SELECT(AvePay, EBDTSN, , Staff.TSN);
  SRCINSEL(AvePay, GE, , trgFrom);
  WHILE OCCURE(AvePay) DO
   IF L_AvePay.IsRealAvePay() &
      L_DatTim.IsActiveInIntvl_Inc(trgFrom, trgUpTo, AvePay.StartD, AvePay.StopD) THEN
    CONFORM(AvePay, AvePayP);
    WHILE OCCURE(AvePayP) DO
     CONFORM(AvePayP, AveTypeP);
     IF !AveTypeP.JMode THEN
      _Name:="   " + AveTypeP.Name;
     ELSE
      CONFORM(AveTypeP, JMode);
      _Name:=JMode.JMode + " " + JMode.Name;
     END;
     IF ~!AvePayP.StopD THEN
      ADD(Tmp, Tmp, , _Name, Tmp.Days[d_Clndr], AvePayP.StopD-AvePayP.StartD+1,
                             Tmp.Days[d_Paid],  AvePayP.Amount);
     ELSE
      ADD(Tmp, Tmp, , _Name, Tmp.Days[d_Clndr], AvePayP.Amount,
                             Tmp.Days[d_Paid],  AvePayP.Amount);
     END;
     NEXT(AvePayP);
    END; (* WHILE OCCURE(AvePayP) ... *)
   END; (* IF L_AvePay.IsRealAvePay()... *)
   NEXT(AvePay);
  END; (* WHILE OCCURE(AvePay) ... *)
 END {MakeTmp};

 PUBLIC PROCEDURE AvPDs();
  CONST
   RepName ="AvPDs";
 BEGIN
  AccessAvePay();
  CONFORM(AvePay, Staff);
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
  MakeTmp(Memo.ud_fr(), Memo.ud_ut());

  OPENREP(R, L_General.NameConnection(RepName), Create);
  CONFORM(Staff, Man);
  MAKEPART(R, AvPDs_Top, RepName);
  SELECT(Tmp, Tmp);
  WHILE OCCURE(Tmp) DO
   MAKEPART(R, AvPDs_Line, Tmp.Name, Tmp.Days[d_Paid], Tmp.Days[d_Clndr]);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, AvPDs_Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {AvPDs};

 PRIVATE PROCEDURE Mtwo_AP_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.PermanentFilter:="(AvePay.StopD>Memo.MonthB)&(AvePay.Status#2)";
 END {Mtwo_AP_1_OnZoneOpen};

 PRIVATE PROCEDURE ATPE_0_OnReposition();
 BEGIN
  IF ACCESS(AveTypeP) THEN
   CONFORM(AveTypeP, AveType);
   RTI.Get().CurZone.Fields("AveTypeP.DrtnIdx").Modifiable:=AveType.LimType = L_AvePay.avelim_Hldy;
  END;
 END {ATPE_0_OnReposition};

 PRIVATE PROCEDURE ATPE_0_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("AveTypeP.DrtnIdx").Format:=L_AvePay.vt_Pool;
 END {ATPE_0_OnZoneOpen};

 PUBLIC PROCEDURE MakeProtocol_EU();
  VAR
   AvePayCnt: NUMERIC[0];
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
  AvePayCnt:=0;
  SETSEL(AvePay, TSN, Staff.TSN);
  SRCINSEL(AvePay, GE, , Memo.ud_mb());
  WHILE OCCURE(AvePay) & (AvePay.StartD<=Memo.ud_me()) DO
   IF AvePay.Status = L_AvePay.st_Estimated THEN
    INC(AvePayCnt);
    TRY
     AvePay_OnMakeProtocol(0);
    EXCEPT
    ON Exc: Exc_Halt DO
    END; (* TRY *)
   END;
   NEXT(AvePay);
  END; (* WHILE OCCURE(AvePay) ... *)
  IF AvePayCnt = 0 THEN
   MAKEPART(R, EmptyRep_EU);
  END;
 END {MakeProtocol_EU};

 PUBLIC PROCEDURE FillPF();
 BEGIN
  AccessAvePay();
  CONFORM(AvePay, AveType);
  L_General.Assert(AveType.LimType # L_AvePay.avelim_None, " ⮬ 㬥  㦭 㪠뢠 ' ਮ'");
  LIKEMENU(Edit, "AVP_PF 0");
 END {FillPF};

 PUBLIC PROCEDURE MoveAvePayInNextMonth();
 BEGIN
  L_StdFrm.Choice("७ 㬥  ⢨/ -।  ᫥騩 ?");
  Shift(+1);
 END {MoveAvePayInNextMonth};

 PUBLIC PROCEDURE MoveAvePayInPrevMonth();
 BEGIN
  L_StdFrm.Choice("७ 㬥  ⢨/ -।  ।騩 ?");
  Shift(-1);
 END {MoveAvePayInPrevMonth};

 PRIVATE PROCEDURE AvePayE_0_OnReposition();
 BEGIN
  SetAvePayConditionalFieldsModifiable();
  CALL(ObjPro.UpdateCurObjectVal2Show("AvePay", "AvePPro"));
 END {AvePayE_0_OnReposition};

 PRIVATE PROCEDURE AvePayE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["AvePay.PFFrom", "AvePay.AveType", "AvePay.Status"]);
  L_WDO.iUnmodifiable(0, ["AvePay.Period", "AvePay.AvePay", "AvePay.StartD", "AvePay.StopD", "AvePay.Amount"]);
  L_WDO.iMayBeEmpty  (0, ["AvePay.FirstM", "AvePay.Average", "AvePay.PFTill", "AvePay.PFFrom",
                          "AvePay.DocDate", "AvePay.DocNum"]);
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  L_WDO.iUnmodifiable(1, ["AvePayP.AveTypeP"]);
  L_WDO.iMayBeEmpty  (1, ["AvePayP.Amount", "AvePayP.StopD", "AvePayP.Hours"]);
  L_WDO.iProgs       (1, "AvePay");
  L_WDO.iZone        (2).ViewOnly:=1;
 END {AvePayE_OnInitializeWindow};

 PRIVATE PROCEDURE AvePay_OnInitializeWindow();
 BEGIN
(*
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
*)
  L_WDO.iSubwindow   (1, "AvePayE");
  L_WDO.iZone        (1).Narrowing:="AvePay.TSN=Staff.TSN";
 END {AvePay_OnInitializeWindow};

 PRIVATE PROCEDURE AvpAll_OnInitializeWindow();
 BEGIN
(*
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
*)
  L_WDO.iWindow().MNUFileName:="AvePay";
  L_WDO.iSubwindow   (1, "AvePayE");
  L_WDO.iZone        (1).Narrowing:="AvePay.Period=Memo.MonthB";
 END {AvpAll_OnInitializeWindow};

 PRIVATE PROCEDURE AveType_OnBeforeInsert();
  VAR
   srcAveType: LIKE(AveType.AveType);
 BEGIN
  srcAveType:=L_WDO.GetInsertionSource();
  IF ~!srcAveType THEN
   L_DBD.CopyFromSrcRecord("AveType", srcAveType);
   REPLACE(AveType);
  END;
 END {AveType_OnBeforeInsert};

 PUBLIC PROCEDURE MakeCopy();
 BEGIN
  ACCESS(AveType);
  L_WDO.LaunchInsertBySource(AveType.AveType, "");
 END {MakeCopy};

BEGIN
 L_Events.ExecuteHandler();
END.
