(*
%Copyright   (c) Polak IT
%Author      12.11.2003 11:56:52 POLAK\GAV
%Purpose      ᪮
%Type        report
%Specific    SYS
%Modified    07.07.2014 11:47:02 POLAK\GAV
%Environment
*)

 MODULE AVP03 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Basis, L_General, L_Staff, L_DatTim, L_Str, L_Man, Memo,
        FIO, L_AvePay, L_Env, P_Firm, Math, L_bp, P_Man, L_Sheet,
        L_AFM, DBD, L_OwnData, Str;

 PRIVATE CONST
  bpId = "AVP03";

  IdxAmount       = 100;
  AVP03_IdxAmount = 5;
  IdxPool         = "ᥣ|3|2|諃||㤃";

  likeZero = 0.0005;

 TYPE
  tArr     = FLOAT[IdxAmount+1];
  tPlanArr = FLOAT[(IdxAmount + 1) * L_Staff.ati_Amount];

 PRIVATE PROCEDURE WithMF(): SCAL[2];
 BEGIN
  RETURN P_Firm.E_wMultipleMyFirm(SYSDATE());
 END {WithMF};

 PRIVATE PROCEDURE MakeTop();
  VAR
   i: NUMERIC[0];
 BEGIN
  IF WithMF() THEN
   L_Basis.wb_WrInQM("F", "");
   L_Basis.wb_WrInQM("F", "");
  END;
  L_Basis.wb_WrStr("F", ".");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "⠏ਥ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "㬥");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "㬥");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "⠄");
  L_Basis.wb_WrStr("F", " 砫");
  L_Basis.wb_WrStr("F", "ਮ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "⪠");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "᭮");
  L_Basis.wb_WrStr("F", "ᥣ");
  L_Basis.wb_WrStr("F", "।");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "ଐ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "᭮");
  L_Basis.wb_WrStr("F", "℮ᥣ");
  L_Basis.wb_WrStr("F", "℮।");
  L_Basis.wb_WrStr("F", "℮");
  L_Basis.wb_WrStr("F", "℮ଐ");
  L_Basis.wb_WrStr("F", "℮");
  i:=1;
  WHILE i <= AVP03_IdxAmount DO
   L_Basis.wb_WrStr("F", L_Str.PoolItem(IdxPool, i));
   INC(i);
  END;
  L_Basis.wb_WrStr("F", "㦡");
  L_Basis.wb_WrStr("F", "㦡");
  L_Basis.wb_WrStr("F", "⤥");
  L_Basis.wb_WrStr("F", "⤥");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "⥣");
  L_Basis.wb_WrStr("F", "⥣");
  L_Basis.wb_WrStr("F", "ᮡ।⠢᪠");
  L_Basis.wb_WrStr("F", "ᮡ।⠢᪠");
  L_Basis.wb_TermLine("F");
 END {MakeTop};

 PRIVATE PROCEDURE sumAdds(x: L_AvePay.tDaysArr): FLOAT;
 BEGIN
  RETURN x[L_Staff.ati_HarmPwr] + x[L_Staff.ati_Continuity] + x[L_Staff.ati_UnNorm] + x[L_Staff.ati_Other];
 END {sumAdds};

 PRIVATE PROCEDURE sumAll(x: L_AvePay.tDaysArr): FLOAT;
 BEGIN
  RETURN x[L_Staff.ati_Main] + sumAdds(x);
 END {sumAll};

 PRIVATE PROCEDURE ml_OutDays(Days: FLOAT);
 BEGIN
  L_Basis.wb_WrNum("F", Days, 4);
 END {ml_OutDays};

 PRIVATE PROCEDURE MakeLine(RealBeg, StartD: DATE);
  VAR
   i,
   Idx: NUMERIC[0];
 BEGIN
  IF WithMF() THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl("F", MyFirm.MyFirm);
   L_Basis.wb_WrStr("F", MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl("F", Staff.TSN);
  L_Basis.wb_WrStr("F", Man.Name);
  L_Basis.wb_WrDat("F", RealBeg);
  L_Basis.wb_WrStr("F", L_Staff.GetStaffContract_asStr());
  L_Basis.wb_WrScl("F", Post.Post);
  L_Basis.wb_WrStr("F", Post.Name);
  IF ~!StfVD.AvePay THEN
   L_General.CallUs(SEARCH(AvePayP, AvePay, StfVD.AvePay, StfVD.AveTypeP));
   CONFORM(AvePayP, AvePay);
   CONFORM(AvePay, AveType);
   CONFORM(AvePayP, AveTypeP);
   L_Basis.wb_WrStr("F", AvePay.AveType);
   L_Basis.wb_WrStr("F", AveType.Name);
   L_Basis.wb_WrStr("F", AvePayP.AveTypeP);
   L_Basis.wb_WrStr("F", AveTypeP.Name);
   L_Basis.wb_WrStr("F", AvePay.DocNum);
   L_Basis.wb_WrDat("F", AvePay.DocDate);
   L_Basis.wb_WrDat("F", AvePay.StartD);
   L_Basis.wb_WrStr("F", L_DatTim.DateStr(AvePay.PFFrom) + "-" + L_DatTim.DateStr(AvePay.PFTill));
   L_Basis.wb_WrNum("F", StfVD.Year, 0);
   L_Basis.wb_WrStr("F", L_AvePay.GetAveTypeNetNo_asStr());
  ELSE
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrDat("F", EMPTYOF(DATE));
   L_Basis.wb_WrDat("F", EMPTYOF(DATE));
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrNum("F", StfVD.Year, 0);
   L_Basis.wb_WrStr("F", "");
  END;

  ml_OutDays(sumAll(StfVD.PlanOnD));
  ml_OutDays(StfVD.PlanOnD[L_Staff.ati_Main]);
  ml_OutDays(sumAdds(StfVD.PlanOnD));
  ml_OutDays(StfVD.PlanOnD[L_Staff.ati_HarmPwr]);
  ml_OutDays(StfVD.PlanOnD[L_Staff.ati_Continuity]);
  ml_OutDays(StfVD.PlanOnD[L_Staff.ati_UnNorm]);
  ml_OutDays(StfVD.PlanOnD[L_Staff.ati_Other]);

  ml_OutDays(sumAll(StfVD.FactOnD));
  ml_OutDays(StfVD.FactOnD[L_Staff.ati_Main]);
  ml_OutDays(sumAdds(StfVD.FactOnD));
  ml_OutDays(StfVD.FactOnD[L_Staff.ati_HarmPwr]);
  ml_OutDays(StfVD.FactOnD[L_Staff.ati_Continuity]);
  ml_OutDays(StfVD.FactOnD[L_Staff.ati_UnNorm]);
  ml_OutDays(StfVD.FactOnD[L_Staff.ati_Other]);
  IF !StfVD.Year THEN
   Idx:=0;
  ELSE
   Idx:=StfVD.Year - L_DatTim.YEAR(StartD) + 1;
  END;
  i:=1;
  WHILE i <= AVP03_IdxAmount DO
   IF i = Idx THEN
    L_Basis.wb_WrStr("F", "1");
   ELSE
    L_Basis.wb_WrStr("F", "0");
   END;
   INC(i);
  END;
  L_Basis.wb_WrScl("F", L_Staff.getService());
  L_Basis.wb_WrStr("F", L_Staff.getServiceName());
  L_Basis.wb_WrScl("F", L_Staff.getDepart());
  L_Basis.wb_WrStr("F", L_Staff.getDepartName());
  L_Basis.wb_WrScl("F", Sort.Sort);
  L_Basis.wb_WrStr("F", Sort.Name);
  L_Basis.wb_WrScl("F", Union.Union);
  L_Basis.wb_WrStr("F", Union.Name);
  L_General.CallUs(SEARCH(AlType, AlType, StfVD.AlType));
  L_Basis.wb_WrScl("F", AlType.AlType);
  L_Basis.wb_WrStr("F", AlType.Name);
  L_Basis.wb_TermLine("F");
 END {MakeLine};

 PRIVATE PROCEDURE MakeAVP03(D: DATE);
  VAR
   Dummy,
   StartD,
   RealBeg : DATE;
   yPlan,
   yFact   : L_AvePay.tDaysArr;
   BaseYear: NUMERIC[0];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  MakeTop();
  StartD:=L_DatTim.IncYear(L_DatTim.YearBeg(D), -3);
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Staff.rInState(D) THEN
    RealBeg:=L_Man.GetTakeOnDate(D);
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, Union);
    CONFORM(Officer, Post);
    CONFORM(Officer, Sort);
    CONFORM(Staff, Man);
    Dummy:=L_AvePay.extFillStaffVacationData(RealBeg, D, 0, 0, 1, BaseYear);
    IF SELECT(StfVD, Year) THEN
     LAST(StfVD);
     WHILE OCCURE(StfVD) & (StfVD.Year >= BaseYear) DO
      CHANGESEL(StfVD, Year, , StfVD.Year);
      SETZERO(yPlan, yFact);
      WHILE OCCURE(StfVD) DO
       MakeLine(RealBeg, StartD);
       Inc(yFact, StfVD.FactOnD);
       Inc(yPlan, StfVD.PlanOnD);
       PREV(StfVD);
      END; (* WHILE OCCURE(StfVD) ... *)
      FIRST(StfVD);
      CHANGESEL(StfVD, Year);
      PREV(StfVD);
     END; (* WHILE StfVD.Year >= BaseYear *)
    END; (* IF SELECT(StfVD, Year) *)
   END; (* IF L_Staff.rInState(D) ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  FIO.Close(F);
 END {MakeAVP03};

 PUBLIC PROCEDURE AVP03();
 BEGIN
  L_bp.Begin(bpId, " ᯮ짮 ᪮", L_bp.t_Basis, L_General.timeCond_OnDate);
  MakeAVP03(Memo.ud_cd());
  L_bp.End();
 END {AVP03};

 CONST
  AvPLs_RepName ="AvPLs";

(*
$P{ AvPLs_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
AvPLs_RepName, L, ""
Staff.TSN, L, ""
Man.Name, L, ""
?, L, "D.N.y"
Post.Post, L, ""
Post.Name, L, ""
?, L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                                   ﭨ ⮢    ᪠                                    |
|⭨  ##### ########################################################################## ਭ ##########|
| ### ############################################################################  ##########|
}
*)

(*
$P{ AvPLs_yTop:
?, L, "D.N.y"
@
|============================================================================================================|
|                                 ᪠  ##########                               |
|------------------------------------------------------------------------------------------------------------|
|   |          '줮'   ⢮  ᪠  , ਭ  ᬮ७           |-|
|  |-------------------------------------------------------------------------------------------------|  |
|     |    ᥣ    |  ᭮   |⥫.|। ᫮|.⠦|ନ.  |   稥    ||
}
*)

(*
$P{ AvPLs_yDlm:
@
|-----|-------------|-------------|-------------|-------------|-------------|-------------|-------------|----|
}
*)

(*
$P{ AvPLs_yLine:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, R, "0"
@
|#####|#############|#############|#############|#############|#############|#############|#############|####|
}
*)

(*
$P{ AvPLs_yBot:
?, L, "N.y"
?, R, "2."
?, R, "0"
?, R, "0"
@
|------------------------------------------------------------------------------------------------------------|
| ####### ###### (줮  壠᪮ ,  ####-#### )                                         |
}
*)

(*
$P{ AvPLs_Top2:
@
|============================================================================================================|
|                                          ।⠢ ᪠                                           |
|------------------------------------------------------------------------------------------------------------|
|    |       |                    |                    |ਮ               | ||
}
*)

(*
$P{ AvPLs_Dlm:
@
|---------|----------|--------------------------|-----------------------------|---------------------|----|---|
}
*)

(*
$P{ AvPLs_Dlm2:
@
|=========|==========|==========================|=============================|=====================|====|===|
}
*)

(*
$P{ AvPLs_Line:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
AvePayP.StartD, L, "D.N.y"
AvePayP.StopD, L, "D.N.y"
?, R, "0"
?, R, "0"
@
|#########|##########|## #######################|## ##########################|########## ##########|####|###|
}
*)

(*
$P{ AvPLs_MayGiveDays:
?, L, "D.N.y"
?, L, ""
?, R, "2."
@
|------------------------------------------------------------------------------------------------------------|
| 砥 ।⠢ ᪠  ##########  ######## ᠫ줮   ᪠ ⠢ ######            |
}
*)

(*
$P{ AvPLs_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE Inc(VAR tot: L_AvePay.tDaysArr; x: L_AvePay.tDaysArr);
  VAR
   i: SCAL[MAXOF(AveTypeP.DrtnIdx)+1];
 BEGIN
  FOR_EACH i DO
   INC(tot[i], x[i]);
  END;
 END {Inc};

 PRIVATE PROCEDURE YearStr(y: NUMERIC[0]): STRING[];
 BEGIN
  IF !y THEN
   RETURN " 㪠";
  ELSE
   RETURN L_Str.IntStr(StfVD.Year);
  END;
 END {YearStr};

 PRIVATE PROCEDURE AvPLs_Saldo_Plan_Str(p, f: FLOAT): STRING[];
 BEGIN
  IF (p = 0) & (f = 0) THEN
   RETURN "";
  ELSE
   RETURN FLDTOSTR(p-f, "2.", 6) + " " + FLDTOSTR(p, "2.", 6);
  END;
 END {AvPLs_Saldo_Plan_Str};

 PRIVATE PROCEDURE AvPLs_Saldo_Str(p, f: FLOAT): STRING[];
 BEGIN
  IF (p = 0) & (f = 0) THEN
   RETURN "";
  ELSE
   RETURN FLDTOSTR(p-f, "2.", 6);
  END;
 END {AvPLs_Saldo_Str};

 PRIVATE PROCEDURE AvPLs_OneYear(VAR yPlan, yFact: L_AvePay.tDaysArr);
  VAR
   yStr: STRING[];
   i: SCAL[MAXOF(AveTypeP.DrtnIdx)+1];
 BEGIN
  yStr:=YearStr(StfVD.Year);
  PROMPT(" 'ᠫ줮'. " + yStr);
  SETZERO(yPlan, yFact);
  WHILE OCCURE(StfVD) DO
   Inc(yFact, StfVD.FactOnD);
   Inc(yPlan, StfVD.PlanOnD);
   NEXT(StfVD);
  END; (* WHILE OCCURE(File) *)
  IF (Math.Abs(yPlan[L_Staff.ati_Main]       - yFact[L_Staff.ati_Main]      ) > likeZero) |
     (Math.Abs(yPlan[L_Staff.ati_HarmPwr]    - yFact[L_Staff.ati_HarmPwr]   ) > likeZero) |
     (Math.Abs(yPlan[L_Staff.ati_Continuity] - yFact[L_Staff.ati_Continuity]) > likeZero) |
     (Math.Abs(yPlan[L_Staff.ati_UnNorm]     - yFact[L_Staff.ati_UnNorm]    ) > likeZero) |
     (Math.Abs(yPlan[L_Staff.ati_Other]      - yFact[L_Staff.ati_Other]     ) > likeZero) THEN
   MAKEPART(R, AvPLs_yLine, yStr,
            AvPLs_Saldo_Plan_Str(sumAll(yPlan),                 sumAll(yFact)),
            AvPLs_Saldo_Plan_Str(yPlan[L_Staff.ati_Main],       yFact[L_Staff.ati_Main]),
            AvPLs_Saldo_Plan_Str(sumAdds(yPlan),                sumAdds(yFact)),
            AvPLs_Saldo_Plan_Str(yPlan[L_Staff.ati_HarmPwr],    yFact[L_Staff.ati_HarmPwr]),
            AvPLs_Saldo_Plan_Str(yPlan[L_Staff.ati_Continuity], yFact[L_Staff.ati_Continuity]),
            AvPLs_Saldo_Plan_Str(yPlan[L_Staff.ati_UnNorm],     yFact[L_Staff.ati_UnNorm]),
            AvPLs_Saldo_Plan_Str(yPlan[L_Staff.ati_Other],      yFact[L_Staff.ati_Other]),
            yFact[L_Staff.ati_OverNorm]);
  END; (* IF yPlan[0] | yFact[0] *)
 END {AvPLs_OneYear};

 PRIVATE PROCEDURE AvPLs_Make(OnDate: DATE);
  VAR
   RealBeg,
   RealEnd,
   P,
   SLBeg        : DATE;
   TotPlan,
   TotFact,
   yPlan  ,
   yFact        : L_AvePay.tDaysArr;
   days,
   DaysAcntSaldo: FLOAT;
   yStr         : STRING[];
   atDur,
   vacDays,
   fYear,
   BaseYear,
   actnBaseYear,
   LastYear     : NUMERIC[0];
   j            : SCAL[L_Staff.ati_Amount];
   HasFactAfter : SCAL[2];
 BEGIN
  IF ~ACCESS(Staff) THEN
   L_General.Assert(ACCESS(AvePay), " ⠭ 㬥");
   CONFORM(AvePay, Staff);
  END;
  PROMPT(" ...");
  HISTCONF(SYSDATE(), Staff, StaffLog);
  L_General.Assert(OCCURE(StaffLog), "⭨    ");
  CONFORM(StaffLog, Post);
  CONFORM(Staff, Man);
  RealBeg:=L_Man.GetTakeOnDate(L_DatTim.MonthEnd(OnDate));
  RealEnd:=L_Man.GetRealEndDate(L_DatTim.MonthEnd(OnDate));
  OPENREP(R, L_General.NameConnection(AvPLs_RepName), Create);
  MAKEPART(R, AvPLs_Top, RealBeg, RealEnd);

  P:=L_DatTim.Per(OnDate);
  DaysAcntSaldo:=L_AvePay.extGetVacationDaysAcntSaldo(Staff.TSN, P, actnBaseYear);
  LastYear:=L_DatTim.YEAR(P);
  IF P <= L_DatTim.IncCalendarMonth(RealBeg, 12 * (L_DatTim.YEAR(P) - L_DatTim.YEAR(RealBeg))) THEN
   DEC(LastYear);
  END;
  SLBeg:=L_AvePay.extFillStaffVacationData(RealBeg, OnDate, 0, ~!RealEnd, 1, BaseYear);
  MAKEPART(R, AvPLs_yTop, OnDate);
  MAKEPART(R, AvPLs_yDlm);
  SETZERO(TotPlan, TotFact);
  SETEMPTY(fYear);
  HasFactAfter:=0;
  IF SELECT(StfVD, Year) THEN
   LAST(StfVD);
   REPEAT
    CHANGESEL(StfVD, Year, , StfVD.Year);
    FIRST(StfVD);
    SAVE(StfVD);
    fYear:=StfVD.Year;
    AvPLs_OneYear(yPlan, yFact);
    Inc(TotFact, yFact);
    Inc(TotPlan, yPlan);
    FIRST(StfVD);
    WHILE OCCURE(StfVD) & ~HasFactAfter DO
     NARROWSEL(StfVD, AvePay);
     IF ~!StfVD.AvePay THEN
      SEARCH(AvePay, AvePay, , StfVD.AvePay);
      HasFactAfter:=AvePay.StopD >= OnDate;
     END;
     NEXTINEXTENDEDSEL(StfVD, AvePay);
    END; (* WHILE OCCURE(StfVD) *)
    RESTORE(StfVD);
    CHANGESEL(StfVD, Year);
   UNTIL ~PREV(StfVD) | (StfVD.Year < BaseYear) | !StfVD.Year;
  END; (* IF SELECT(StfVD, Year) *)

  MAKEPART(R, AvPLs_yDlm);
  MAKEPART(R, AvPLs_yLine, "⮣",
           AvPLs_Saldo_Str(sumAll(TotPlan),                 sumAll(TotFact)),
           AvPLs_Saldo_Str(TotPlan[L_Staff.ati_Main],       TotFact[L_Staff.ati_Main]),
           AvPLs_Saldo_Str(sumAdds(TotPlan),                sumAdds(TotFact)),
           AvPLs_Saldo_Str(TotPlan[L_Staff.ati_HarmPwr],    TotFact[L_Staff.ati_HarmPwr]),
           AvPLs_Saldo_Str(TotPlan[L_Staff.ati_Continuity], TotFact[L_Staff.ati_Continuity]),
           AvPLs_Saldo_Str(TotPlan[L_Staff.ati_UnNorm],     TotFact[L_Staff.ati_UnNorm]),
           AvPLs_Saldo_Str(TotPlan[L_Staff.ati_Other],      TotFact[L_Staff.ati_Other]),
           TotFact[L_Staff.ati_OverNorm]);
  days:=sumAll(TotPlan) - sumAll(TotFact);
  IF ~HasFactAfter THEN
   L_Staff.PosToStaffLog(Staff.TSN, OnDate, 0);
   IF ~L_Staff.IsDischargeStaffLog() THEN
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, AlType);
    SETSEL(AlTypeL, AlType, AlType.AlType);
    L_General.Assert(SRCINSEL(AlTypeL, LE, OnDate),
                     "ᮡ ।⠢ ᪮ " + AlType.AlType +
                     "    " + L_DatTim.PeriodStr(OnDate));
    days   :=days + days * sumAll(AlTypeL.Duration) / (365.25 - sumAll(AlTypeL.Duration));
    vacDays:=days;
    MAKEPART(R, AvPLs_MayGiveDays, OnDate, L_Str.IntStr(vacDays) + Str.EnumObject(vacDays, " | | "),
             L_AvePay.GetVacationDaysSaldo(Staff.TSN, OnDate + vacDays) - vacDays);
   END;
  END;
  MAKEPART(R, AvPLs_yBot, P, DaysAcntSaldo, actnBaseYear, LastYear);

  MAKEPART(R, AvPLs_Top2);
  SELECT(StfVD, Year);
  LAST(StfVD);
  WHILE OCCURE(StfVD) DO
   CHANGESEL(StfVD, Year, , StfVD.Year);
   yStr:=YearStr(StfVD.Year);
   WHILE OCCURE(StfVD) DO
    PROMPT(" ᯨ᪠ . " + yStr);
    CHANGESEL(StfVD, Year, , StfVD.Year, StfVD.AvePay);
    IF ~!StfVD.AvePay THEN
     FIRST(StfVD);
     SEARCH(AvePayP, AvePay, , StfVD.AvePay, StfVD.AveTypeP);
     CONFORM(AvePayP, AvePay);
     CONFORM(AvePay, AveType);
     CONFORM(AvePayP, AveTypeP);
     IF ~!yStr THEN
      IF StfVD.Year = fYear - 1 THEN
       MAKEPART(R, AvPLs_Dlm2);
      ELSE
       MAKEPART(R, AvPLs_Dlm);
      END;
     END;
     MAKEPART(R, AvPLs_Line, yStr, AvePay.DocNum, AveType.AveType, AveType.Name, AveTypeP.AveTypeP,
                             AveTypeP.Name, sumAll(StfVD.Fact), StfVD.Fact[L_Staff.ati_OverNorm]);
     yStr:="";
     WHILE NEXT(StfVD) DO
      SEARCH(AvePayP, AvePay, , StfVD.AvePay, StfVD.AveTypeP);
      CONFORM(AvePayP, AveTypeP);
      MAKEPART(R, AvPLs_Line, , , , , AveTypeP.AveTypeP,
                             AveTypeP.Name, sumAll(StfVD.Fact), StfVD.Fact[L_Staff.ati_OverNorm]);
     END; (* WHILE OCCURE(File) *)
    END; (* IF ~!StfVD.AvePay *)
    FIRST(StfVD);
    CHANGESEL(StfVD, Year, , StfVD.Year);
    PREV(StfVD);
   END; (* WHILE OCCURE(StfVD) *)
   FIRST(StfVD);
   CHANGESEL(StfVD, Year);
   PREV(StfVD);
  END; (* WHILE OCCURE(StfVD) *)
  MAKEPART(R, AvPLs_Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {AvPLs_Make};

 PUBLIC PROCEDURE AvPLs(mode: NUMERIC[0]);
 BEGIN
  IF mode = 0 THEN
   AvPLs_Make(Memo.ud_cd());
  ELSE
   AvPLs_Make(SYSDATE());
  END;
 END {AvPLs};

END.
