(*
%Copyright   (c) Polak IT
%Author      17.03.2005 17:30:21 POLAK\GAV
%Purpose      
%Type        report
%Specific    SYS
%Modified    03.12.2013 15:15:53 POLAK\Gina
%Environment
*)

 MODULE AVP04 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Staff, FIO, L_AvePay, L_Basis, L_DatTim, L_General, L_Str, L_Env, Memo, L_bp;

 PRIVATE PROCEDURE GetPrv(VAR PrvDate   : DATE;
                          VAR PrvAveType: LIKE(AveType.AveType);
                          VAR PrvAveNo  : LIKE(AveType.AveNo));
 BEGIN
  SAVE(AvePay);
  CHANGESEL(AvePay, TSN, , AvePay.TSN);
  WHILE PREV(AvePay) & ~L_AvePay.IsRealAvePay() DO
  END;
  IF OCCURE(AvePay) THEN
   CONFORM(AvePay, AveType);
   PrvDate   :=AvePay.StopD;
   PrvAveType:=AveType.AveType;
   PrvAveNo  :=AveType.AveNo;
  ELSE
   SETEMPTY(PrvDate, PrvAveType, PrvAveNo);
  END;
  RESTORE(AvePay);
 END {GetPrv};

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrStr(F, ".");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "㬥");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "⠄");
  L_Basis.wb_WrStr(F, "ਮ");
  L_Basis.wb_WrStr(F, "ਮ");
  L_Basis.wb_WrStr(F, "।");
  L_Basis.wb_WrStr(F, "⪠");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "᫥।");
  L_Basis.wb_WrStr(F, "।");
  L_Basis.wb_WrStr(F, "।");
  L_Basis.wb_WrStr(F, "।।");
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE AveNoStr(AveNo: LIKE(AveType.AveNo)): STRING[];
 BEGIN
  IF ~!AveNo THEN
   RETURN L_Str.PoolItem(L_AvePay.aveno_Pool, AveNo);
  ELSE
   RETURN "";
  END;
 END {AveNoStr};

 PRIVATE PROCEDURE MakeLine(F: STRING[]);
  VAR
   PrvDate   : DATE;
   PrvAveType: LIKE(AveType.AveType);
   PrvAveNo  : LIKE(AveType.AveNo);
 BEGIN
  CONFORM(AvePay, AveType);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  IF L_Staff.IsDischargeStaffLog() THEN
   L_Basis.wb_WrNum(F, 0, 0);
  ELSE
   L_Basis.wb_WrNum(F, 1, 0);
  END;
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrScl(F, AveType.AveType);
  L_Basis.wb_WrStr(F, AveType.Name);
  L_Basis.wb_WrStr(F, AvePay.DocNum);
  L_Basis.wb_WrDat(F, AvePay.DocDate);
  L_Basis.wb_WrDat(F, AvePay.StartD);
  L_Basis.wb_WrDat(F, AvePay.StopD);
  L_Basis.wb_WrStr(F, AveNoStr(AveType.AveNo));
  L_Basis.wb_WrStr(F, L_AvePay.GetAveTypeNetNo_asStr());
  L_Basis.wb_WrNum(F, AvePay.Amount, 0);
  GetPrv(PrvDate, PrvAveType, PrvAveNo);
  IF ~!PrvDate THEN
   L_Basis.wb_WrNum(F, AvePay.StartD - PrvDate, 0);
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrScl(F, PrvAveType);
  IF ~!PrvAveType THEN
   L_Basis.wb_WrStr(F, AveType.Name);
   L_Basis.wb_WrStr(F, AveNoStr(PrvAveNo));
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PUBLIC PROCEDURE AVP04();
  CONST
   bpId = "AVP04";
  VAR
   First: SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " 㬥⮢  ⢨/ -।", L_bp.t_Basis, L_General.timeCond_InIntvl);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  MakeTop("F");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   First:=1;
   IF L_Env.RealTSN(Staff.TSN) THEN
    SETSEL(AvePay, EBDTSN, Staff.TSN);
    SRCINSEL(AvePay, GE, , Memo.ud_fr());
    WHILE OCCURE(AvePay) DO
     PROMPT(Staff.TSN + " : " + L_DatTim.DateStr(AvePay.StartD));
     IF L_AvePay.IsRealAvePay() &
        L_DatTim.IsActiveInIntvl_Inc(Memo.ud_fr(), Memo.ud_ut(), AvePay.StartD, AvePay.StopD) THEN
      IF First THEN
       CONFORM(Staff, Man);
       L_Staff.PosToStaffLog(Staff.TSN, Memo.ud_ut(), 0);
       CONFORM(StaffLog, Officer);
       CONFORM(Officer, Union);
       CONFORM(Officer, Post);
       CONFORM(Officer, Sort);
       First:=0;
      END;
      MakeLine("F");
     END;
     NEXT(AvePay);
    END; (* WHILE OCCURE(AvePay) ... *)
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  FIO.Close(F);
  L_bp.End();
 END {AVP04};

END.
