(*
%Copyright   (c) Polak Computer System
%Author      02.07.2000 19:11:16 SAN
%Purpose       AvP_0005
%Type        to paste
%Specific    SYS
%Modified    24.07.2013 12:40:14 POLAK\Gina
%Environment
*)

 IMPORT L_General, L_OwnData, L_DatTim, L_AvePay, L_APtm, L_PRoll, L_Sheet,
        L_Man, L_Str, P_AveP, Math, E_PRoll, L_Env, L_Hld, L_SFee, Str, L_StdFrm;

 TYPE
  tMaxPay = SCAL[2];

 CONST
  Infl_Off = 0;
  Infl_On  = 1;

  MaxPay_SickOrdinary  = 0;
  MaxPay_SickPregnancy = 1;

 VAR
  DaysInMonth_6day,
  DaysInMonth_7day: NUMERIC[3];

 PROCEDURE MonthLenForSick(P: DATE):  NUMERIC[0]; (* .  *)
 BEGIN
  RETURN L_DatTim.MonthLen(P);
 END {MonthLenForSick};

 PROCEDURE GetDaysInMonth(P: DATE): NUMERIC[2];
 BEGIN
  IF AvePayP.StartD >= 01\02\2002 THEN
   IF    L_AvePay.GetRealNetNo()  = L_AvePay.nn_AllDays THEN  (* .   01.01.2007 *)
    RETURN L_DatTim.MonthLen(P);
   ELSIF L_AvePay.GetRealNetNo()  = L_AvePay.nn_7Days THEN
    RETURN DaysInMonth_7day;
   ELSIF L_AvePay.GetRealNetNo() <= L_AvePay.nn_Regime THEN
    L_APtm.MonthAccess(P);
    RETURN Month.WD6;
   ELSE
    L_General.Error("⨬ ⨯  ⪨");
   END;
  ELSIF AvePayP.StartD >= 01\09\2000 THEN
   IF    L_AvePay.GetRealNetNo() <= L_AvePay.nn_Regime THEN
    L_APtm.MonthAccess(P);
    RETURN Month.WD6;
   ELSIF L_AvePay.GetRealNetNo()  = L_AvePay.nn_AllDays THEN
    RETURN L_DatTim.MonthLen(P);
   ELSIF L_AvePay.GetRealNetNo()  = L_AvePay.nn_7Days THEN (*SAN: Pit*)
    RETURN L_DatTim.MonthLen(P);
   ELSE
    L_General.Error("⨬ ⨯  ⪨");
   END;
  ELSE
   IF    L_AvePay.GetRealNetNo() <= L_AvePay.nn_Regime THEN
    RETURN DaysInMonth_6day;
   ELSIF L_AvePay.GetRealNetNo()  = L_AvePay.nn_AllDays THEN
    RETURN DaysInMonth_7day;
   ELSE
    L_General.Error("⨬ ⨯  ⪨");
   END;
  END;
 END {GetDaysInMonth};

 PROCEDURE E_IsBussinesTripJMode(D: DATE; _JMode: LIKE(Sheet.JMode)): SCAL[2];
  VAR
   Local: PROC;
   Ok: SCAL[2];
 BEGIN
  Local:=PROCREF(E_PRoll.IsBussinesTripJMode);
  IF ~!Local THEN
   Ok:=Local(D, _JMode);
  ELSE
   Ok:=_JMode = 11;
  END;
  IF Ok THEN
   L_General.CallUs(SEARCH(JMode, JMode, _JMode));
   RETURN JMode.Type # L_Sheet.jmType_TimDone;
  ELSE
   RETURN 0;
  END;
 END {E_IsBussinesTripJMode};

 PRIVATE PROCEDURE DaysInState(P: DATE): NUMERIC[0]; (*      P *)
 BEGIN
  RETURN L_DatTim.DATEINT(P, L_DatTim.MonthEnd(P), Staff.BegDate, Staff.EndDate);
 END {DaysInState};

 PROCEDURE WorkTimeByStaff(From, UpTo: DATE): FLOAT;
  VAR
   Months: FLOAT;
   _Per  : DATE;
 BEGIN
  Months:=0;
  _Per:=From;
  WHILE _Per < Math.Min(L_Env.aptm_Start, UpTo) DO
   INC(Months, Math.Min(DaysInState(_Per)/L_DatTim.MonthLen(_Per), 1));
   _Per:=L_DatTim.IncMonth(_Per, +1);
  END;
  SAVE(PCalc);
  CONFORM(Staff, PCalc);
  SRCINSEL(PCalc, GE, , _Per);
  WHILE OCCURE(PCalc) & (PCalc.Period<=UpTo) DO
   SAVE(PCalc);
   IF PCalc.TimDone # 0 THEN
    INC(Months, Math.Min(PCalc.TimDone/GetFulBal(PCalc.Period), 1));
   END;
   RESTORE(PCalc);
   NEXT(PCalc);
  END; (* WHILE OCCURE(PCalc) ... *)
  RESTORE(PCalc);
  RETURN Months;
 END {WorkTimeByStaff};

 PROCEDURE WorkTimeByStaffInBussinesTrip(From, UpTo: DATE): FLOAT;
  VAR
   FulBal: LIKE(PCalc.HBal);
   BTim  : L_PRoll.tTime;
   Months: FLOAT;
 BEGIN
  Months:=0;
  SAVE(PCalc);
  CONFORM(Staff, PCalc);
  SRCINSEL(PCalc, GE, , From);
  WHILE OCCURE(PCalc) & (PCalc.Period<=UpTo) DO
   SAVE(PCalc);
   FulBal:=GetFulBal(PCalc.Period);
   IF PCalc.TimDone < FulBal THEN
    BTim:=0;
    SELECT(Sheet, TSN, , Staff.TSN, PCalc.Period);
    WHILE OCCURE(Sheet) DO
     IF E_IsBussinesTripJMode(Sheet.Period+Sheet.Day-1, Sheet.JMode) THEN
      INC(BTim, Sheet.Tim);
     END;
     NEXT(Sheet);
    END; (* WHILE OCCURE(Sheet) ... *)
    INC(Months, Math.Min(FulBal-PCalc.TimDone, BTim)/FulBal);
   END;
   RESTORE(PCalc);
   NEXT(PCalc);
  END; (* WHILE OCCURE(PCalc) ... *)
  RESTORE(PCalc);
  RETURN Months;
 END {WorkTimeByStaffInBussinesTrip};

 PROCEDURE GetMonthsByManActv(From, UpTo: DATE): FLOAT;
  VAR
   Months: FLOAT;
 BEGIN
  Months:=0;
  SELECT(ManActv, Man, , Staff.Man, L_Man.actvk_Work);
  IF ~SRCINSEL(ManActv, LE, From) THEN
   FIRST(ManActv);
  END;
  WHILE OCCURE(ManActv) & (ManActv.BegDate<=UpTo) DO
   IF (ManActv.EndDate>=From) & (ManActv.SenAddS=0(*   室  쬨*)) THEN
    INC(Months, L_DatTim.MonthsInIntvl(Math.Max(From, ManActv.BegDate), Math.Min(UpTo, ManActv.EndDate)));
   END;
   NEXT(ManActv);
  END; (* WHILE OCCURE(ManActv) ... *)
  RETURN Months;
 END {GetMonthsByManActv};

 PROCEDURE CheckWorkTime(): SCAL[2];
  VAR
   Months: FLOAT;
   CurTSN: LIKE(Staff.TSN);
   TM    : NUMERIC[0];
   From,
   UpTo,
   TakeOn: DATE;
 BEGIN
  IF L_AvePay.SpecialSick() THEN
   TM:=6;
   From  :=MINOF(DATE);
   UpTo  :=L_AvePay.SickAvePaySequenceStart() - 1;
   TakeOn:=L_Man.GetTakeOnDate(UpTo + 1);
   Months:=L_DatTim.DaysToMonths(L_Man.GetContractsLengthOfMan(Staff.Man, TakeOn, UpTo, 0, 0));
   IF Months >= TM THEN
    RETURN 1;
   END;
   INC(Months, GetMonthsByManActv(From, TakeOn - 1));
   RETURN Months >= TM;
  ELSE
   TM:=3;
   UpTo:=GetFirstM() - 1;
   From:=L_DatTim.IncMonth(UpTo + 1, -12);
   Months:=WorkTimeByStaff(From, UpTo);
   IF Months >= TM THEN
    RETURN 1;
   END;
   INC(Months, WorkTimeByStaffInBussinesTrip(From, UpTo));
   IF Months >= TM THEN
    RETURN 1;
   END;
   CurTSN:=Staff.TSN;
   SAVE(Staff);
   SELECT(Staff, Man, , Staff.Man);
   WHILE OCCURE(Staff) DO
    IF (Staff.TSN # CurTSN) & L_DatTim.IsActiveInIntvl_Inc(From, UpTo, Staff.BegDate, Staff.EndDate) &
       ((Staff.Contract = L_Staff.cnt_Basic) |
        (Staff.Contract = L_Staff.cnt_ContractorsAgreement)) THEN
     INC(Months, WorkTimeByStaff(From, UpTo));
     IF Months >= TM THEN
      RESTORE(Staff);
      RETURN 1;
     END;
     INC(Months, WorkTimeByStaffInBussinesTrip(From, UpTo));
     IF Months >= TM THEN
      RESTORE(Staff);
      RETURN 1;
     END;
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   RESTORE(Staff);
   IF Months >= TM THEN
    RETURN 1;
   END;
   INC(Months, GetMonthsByManActv(From, UpTo));
   RETURN Months >= TM;
  END;
 END {CheckWorkTime};

 PRIVATE CONST
  NoLimit_AvePay_Average = 01\06\2004;

 PROCEDURE SetLimit(Ins: SCAL[2]);
  VAR
   PayMode        : P_AveP.tftPayMode;
   Limit,
   FirstDaysByFirm: STRING[];
   Year_0,
   Year_1         : P_AveP.tftYear;
 BEGIN
  IF (AvePayP.StartD >= 01\09\2004) & ProcDo & ~StreamMode & (Store = +1) THEN
   L_StdFrm.Inform(" " + L_DatTim.DateStr(L_AvePay.SickAvePaySequenceStart()) + " ࠡ⭨  ࠡ⠫"+
                   "|    ६."+
                   "||㤥 ਬ ࠭祭 ।"+
                   "|(. ᢮⢮ 㬥 " + FLDTOSTR(P_AveP.P_Features, "") + ")");
   IF Ins THEN
    P_AveP.Add_Features(AvePay.AvePay,
                        L_Str.PoolItem(P_AveP.ft_Limit_Pool, P_AveP.ft_Limit_Yes),
                        EMPTYOF(STRING[]),
                        EMPTYOF(P_AveP.tftYear),
                        EMPTYOF(P_AveP.tftYear),
                        EMPTYOF(P_AveP.tftPayMode));
   ELSE
    P_AveP.Decode_Features(AvePPro.Value, Limit, FirstDaysByFirm, Year_0, Year_1, PayMode);
    P_AveP.Encode_Features(AvePPro.Value,
                           L_Str.PoolItem(P_AveP.ft_Limit_Pool, P_AveP.ft_Limit_Yes),
                           FirstDaysByFirm,
                           Year_0,
                           Year_1,
                           PayMode));
   END;
  END;
 END {SetLimit};

 PROCEDURE GetSickLimit(MaxPay: tMaxPay): tPreciseAvr;
  VAR
   StartD,
   FirstM         : DATE;
   Prc            : NUMERIC[3];
   NeedLim        : SCAL[2];
   PayMode        : P_AveP.tftPayMode;
   Limit,
   FirstDaysByFirm: STRING[];
   Year_0,
   Year_1         : P_AveP.tftYear;
 BEGIN
  FirstM:=GetFirstM();
  IF    FirstM >= 01\01\2004 THEN
   Prc:=1;
   IF (FirstM >= 01\03\2004) & (FirstM < NoLimit_AvePay_Average) & (*ࠢ쭮 ࠭ ᫥ ᫥ 業,  03\2004 㬥  ண*)
      (AvePayP.Percent # 0) THEN
    Prc:=Math.Min(1, AvePayP.Percent/100);
   END;
   CONFORM(AvePay, Staff);
   NeedLim:=0;
   IF P_AveP.HasActualPro(AvePay.AvePay, P_AveP.P_Features) THEN
    P_AveP.Decode_Features(AvePPro.Value, Limit, FirstDaysByFirm, Year_0, Year_1, PayMode);
    IF !Limit & (FirstM >= 01\01\2005) & ~CheckWorkTime() THEN
     SetLimit(0);
     NeedLim:=1;
    ELSE
     NeedLim:=L_Str.PositionInPool(P_AveP.ft_Limit_Pool, Limit) = P_AveP.ft_Limit_Yes;
    END;
   ELSIF ~CheckWorkTime() THEN
    SetLimit(1);
    NeedLim:=1;
   END;
   IF NeedLim THEN
    IF    ActPer >= 01\01\2010 THEN
     IF AvePayP.Percent # 0 THEN
      Prc:=Math.Min(1, AvePayP.Percent/100);
     END;
     RETURN L_OwnData.ODMROT(ActPer) * L_PRoll.RegionalCoeff(ActPer) / Prc / MonthLenForSick(ActPer);
    ELSIF FirstM >= 01\09\2005 THEN
     RETURN L_OwnData.ODMROT(ActPer) * L_PRoll.RegionalCoeff(ActPer) / Prc;
    ELSE
     RETURN L_OwnData.ODMROT(AvePayP.StartD) / Prc;
    END;
   ELSE
    IF    ActPer >= 01\01\2010 THEN
     RETURN L_SFee.GetOvrQuota(ActPer) / 365;
    ELSIF (ActPer >= 01\01\2009) & (MaxPay = MaxPay_SickPregnancy) THEN
     RETURN 25390 * L_PRoll.RegionalCoeff(ActPer) / Prc;
    ELSIF (ActPer >= 01\09\2007) & (MaxPay = MaxPay_SickPregnancy) THEN
     RETURN 23400 * L_PRoll.RegionalCoeff(ActPer) / Prc;
    ELSIF ActPer >= 01\01\2009 THEN
     RETURN 18720 * L_PRoll.RegionalCoeff(ActPer) / Prc;
    ELSIF ActPer >= 01\01\2008 THEN
     RETURN 17250 * L_PRoll.RegionalCoeff(ActPer) / Prc;
    ELSIF ActPer >= 01\01\2007 THEN
     RETURN 16125 / Prc;
    ELSIF ActPer >= 01\01\2006 THEN
     RETURN 15000 / Prc;
    ELSIF ActPer >= 01\01\2005 THEN
     RETURN 12480 / Prc;
    ELSE
     RETURN 11700 / Prc;
    END;
   END;
  ELSIF AvePayP.StartD >= 01\02\2002 (*BOR: StartD   FirstM - ன 筮*)THEN
   RETURN 11700;
  ELSE
   RETURN 85*L_OwnData.ODMROT(L_DatTim.Per(StartD));
  END;
 END {GetSickLimit};

 PROCEDURE AssertNoAverage(Cond: SCAL[2]);
 BEGIN
  L_General.Assert(Cond, " ଠ樨  ⭮ ਮ. 室 㪠 ।.");
 END {AssertNoAverage};

 PROCEDURE CheckLastMonth(VAR LastMonth: DATE);
  VAR
   RealBegPer: DATE;
 BEGIN
  IF ~E_CanCalcBeforeStart(AvePay.Period) & (LastMonth < L_Env.aptm_Start) & (Staff.BegDate < L_Env.aptm_Start) THEN
   AssertNoAverage(ProtDo & ~ProcDo);
   LastMonth:=L_Env.aptm_Start;
  ELSE
   RealBegPer:=L_DatTim.Per(L_Man.GetTakeOnDate(AvePay.StartD));
   IF (LastMonth < RealBegPer) THEN
    IF ~StreamMode & (RealBegPer # L_DatTim.Per(Staff.BegDate)) &
       (RealBegDate(AvePay.StartD) = Staff.BegDate) THEN
     L_StdFrm.Choice("⭨ ୮ ਭ  ⭮ ਮ." +
                     "| |" +
                     "室 ஢ 稭 ।");
    END;
    LastMonth:=RealBegPer;
   END;
  END;
 END {CheckLastMonth};

 PROCEDURE SetAccountPeriodValues(VAR _First, _Last: DATE;
                                  VAR _PerNum: NUMERIC[0]);
 BEGIN
  _First:=GetFirstM();
  _Last :=L_DatTim.IncMonth(_First, -_PerNum);
  CheckLastMonth(_Last);
  _PerNum:=L_DatTim.MonthsInIntvl(_Last, _First);
 END {SetAccountPeriodValues};

 PROCEDURE IndexedAverage(): NUMERIC[2];
  VAR
   CurInf  : NUMERIC[3];
   _Average: NUMERIC[2];
 BEGIN
  _Average:=AvePay.Average;
  CurInf  :=1;
  IF ActPer >= 01\06\2001 THEN
   CurInf:=GetAccumulatedInflation(StaffLog.Date, ActPer, _GetFirstM());
   IF CurInf # 1 THEN
    AvePay.Average:=AvePay.Average * CurInf;
    ProtInfl(ActPer, CurInf);
    AvePay.Average:=_Average;
   END;
  END;
  RETURN CurInf * _Average;
 END {IndexedAverage};

 PROCEDURE LimitAverage(Print: SCAL[2]; MaxPay: tMaxPay): tPreciseAvr;
  VAR
   LimAverage: tPreciseAvr;
 BEGIN
  IF   L_AvePay.SpecialSick() THEN
   IF ActPer >= 01\01\2010 THEN
    LimAverage:=GetSickLimit(MaxPay);
    IF AvePay.Average > LimAverage THEN
     IF Print THEN
      ProtLim("", LimAverage);
      ProtMonTop();
     END;
     RETURN LimAverage * AvePayP.Percent / 100;
    END;
   ELSE
    LimAverage:=GetSickLimit(MaxPay) / MonthLenForSick(ActPer);
    IF (AvePay.Average * AvePayP.Percent / 100) > LimAverage THEN
     IF Print THEN
      ProtLim("", LimAverage / Math.Min(1, AvePayP.Percent/100));
      ProtMonTop();
     END;
     RETURN LimAverage;
    END;
   END;
  ELSIF (AvePay.Period >= NoLimit_AvePay_Average) &
        ((AvePay.Period>=01\09\2005) | ~INBITSET(AvePay.Flags, AisNE)) THEN
   LimAverage:=GetSickLimit(MaxPay) / _GetRegBal(ActPer, 1);
   IF (AvePay.Average * AvePayP.Percent / 100) > LimAverage THEN
    IF Print THEN
     ProtLim("", LimAverage);
     ProtMonTop();
    END;
    RETURN LimAverage;
   END;
  END;
  RETURN AvePay.Average * AvePayP.Percent / 100;
 END {LimitAverage};

 PROCEDURE CorDaysBySheet(From: DATE; TimDoneOnly: SCAL[2]): NUMERIC[0];
  VAR
   CorDays: NUMERIC[0];
   _RealBegPer : DATE;
 BEGIN
  TimeInLastStaffLog:=1; (* SIC!!! 0065590 *)
  _RealBegPer:=RealBegDate(From);
  SETZERO(CorDays);
  SAVE(Sheet);
  SAVE(JMode);
  IF _RealBegPer <= L_DatTim.MonthEnd(From) THEN
   SELECT(Sheet, TSN, , Staff.TSN, L_DatTim.Per(From));
   IF L_DatTim.Per(_RealBegPer) = L_DatTim.Per(From) THEN
    SRCINSEL(Sheet, EQ, , L_DatTim.DAY(_RealBegPer));
   END;
   WHILE OCCURE(Sheet) DO
    CONFORM(Sheet, JMode);
    IF TimDoneOnly THEN
     INC(CorDays, JMode.Type=L_Sheet.jmType_TimDone);
    ELSE
     INC(CorDays, JMode.InFirm & ~JMode.DecrBal);
    END;
    NEXT(Sheet);
   END; (* WHILE OCCURE(Sheet) ... *)
  END;
  RESTORE(Sheet);
  RESTORE(JMode);
  RETURN CorDays;
 END {CorDaysBySheet};

 PROCEDURE Convert_AT_DaysBySheet(From: DATE; W, F, C: NUMERIC[3]; VAR T, TC: NUMERIC[3]);
 BEGIN
  TC:=CorDaysBySheet(From, 0);
 END {Convert_AT_DaysBySheet};

 PROCEDURE AveSick(wLim: SCAL[2]);
  VAR
   PerNum     : NUMERIC[0];
   curHrs,
   totHrs,
   w          : L_PRoll.tTime;
   curSum,
   totSum,
   s, a       : L_PRoll.tSum;
   LimAverage : NUMERIC[3];
   curInf,
   totInf     : NUMERIC[3];
   First,
   Current,
   Last       : DATE;
 BEGIN
  IF !AvePay.Average THEN
   First:=GetFirstM();
   IF    L_AvePay.SpecialSick() THEN
    PerNum:=12;
    IF (AvePay.StartD >= 01\01\2008) & E_IsBaseSheet() THEN
     AveHldy(PROCREF(Convert_AT_DaysBySheet), 1, PerNum, Infl_Off);
    ELSE
     AveHldy(PROCREF(Convert_AT0), 1, PerNum, Infl_Off);
    END;
   ELSIF First >= 01\01\2004 THEN
    PerNum:=12;
    AveCAve(PerNum, Infl_Off);
   ELSE
    PerNum:=2;
    ProtHstTop("HstTop1");
    SETZERO(AvePay.Average, totSum, totHrs);
    totInf:=1;
    SetAccountPeriodValues(First, Last, PerNum);
    Current:=First;
    WHILE Current > Last DO
     Current:=L_DatTim.IncMonth(Current, -1);
     GetAve(Current, s, a, curHrs, w);
     curSum:=s+a;
     INC(totSum, curSum);
     INC(totHrs, curHrs);
    END; (* WHILE Current > ... *)
    AssertNoAverage((totHrs > 0) & (totSum > 0));
    INC(totSum, AddLongPerBonuses(First, PerNum, Infl_On));
    AvePay.Average:=totSum/totHrs;
    ProtAvrg("", totHrs, totSum);
   END;
   IF wLim & (AvePay.Period < NoLimit_AvePay_Average) THEN
    REPLACE(AvePay);
    LimAverage:=GetSickLimit(MaxPay_SickOrdinary) / _GetRegBal(L_DatTim.Per(AvePayP.StartD), 1);
    IF AvePay.Average > LimAverage THEN
     AvePay.Average:=LimAverage;
     ProtLim("", AvePay.Average);
    END;
   END; (* IF wLim ... *)
   REPLACE(AvePay);
  END; (* IF !AvePay.Average ... *)
 END {AveSick};

 PROCEDURE Convert_AT0(From: DATE; W, F, C: NUMERIC[3]; VAR T, TC: NUMERIC[3]);
 BEGIN
  IF C > 0 THEN
   IF W >= C THEN
    T:=0;
   ELSIF (W+T) >= C THEN
    T:=C-W;
   END;
  END;
  TC:=T / F * GetDaysInMonth(From);
  IF L_AvePay.SpecialSick() THEN
   TC:=Math.Round(TC);
  END;
 END {Convert_AT0};

 PROCEDURE Convert_AT_Base(From: DATE; W, F, C: NUMERIC[3]; VAR T, TC: NUMERIC[3]);
  VAR
   k       : NUMERIC[2];
   WorkTime: L_PRoll.tTime;
   WorkDays,
   MonthDays: NUMERIC[3];
 BEGIN
  MonthDays:=GetDaysInMonth(From);
  IF AvePay.StartD >= 01\01\2008 THEN
   TC:=MonthDays / L_DatTim.MonthLen(From) * CorDaysBySheet(From, 0);
  ELSE
   IF C > 0 THEN
    IF (W >= F) | (T = 0) THEN
     TC:=0;
    ELSIF (T < F) | (C < F) THEN
     SETZERO(WorkDays, WorkTime);
     SAVE(Sheet);
     SAVE(JMode);
     SELECT(Sheet, TSN, , Staff.TSN, L_DatTim.Per(From));
     WHILE OCCURE(Sheet) DO
      CONFORM(Sheet, JMode);
      IF JMode.Type = L_Sheet.jmType_TimDone THEN
       INC(WorkDays);
       INC(WorkTime, Sheet.Tim);
      END;
      NEXT(Sheet);
     END; (* WHILE OCCURE(Sheet) ... *)
     RESTORE(Sheet);
     RESTORE(JMode);
     IF    AveType.NetNo = L_AvePay.nn_6Days THEN
      k:=1.2 (* 6/5 *);
     ELSIF AveType.NetNo = L_AvePay.nn_7Days THEN
      k:=1.4 (* 7/5 *);
     ELSE
      L_General.Error(' 㬥 '+AveType.AveType+':  । 樥   |   ࠡ⠭   ⪨ "'+L_Str.PoolItem(L_AvePay.nn_Pool, AveType.NetNo)+'".| ᪮ ᪠ ⪠ "⨤"  ""');
     END;
     IF    WorkTime = 0 THEN
      TC:=0;
     ELSIF WorkTime < F THEN
      TC:=T / WorkTime * WorkDays*k;
     ELSE
      TC:=T / WorkTime * MonthDays;
     END;
    ELSE
     TC:=T / F * MonthDays;
    END;
   ELSE
    TC:=T / F * MonthDays;
   END;
  END;
  TC:=Math.Min(MonthDays, TC);
 END {Convert_AT_Base};

 PROCEDURE Convert_AT_Base1(From: DATE; W, F, C: NUMERIC[3]; VAR T, TC: NUMERIC[3]);
 BEGIN
  TC:=CorDaysBySheet(From, 1);
 END {Convert_AT_Base1};

 PROCEDURE AveHldy(ConvertProc: PROC; ToCorB: SCAL[2]; PerNum: NUMERIC[0]; WithInfl: SCAL[2]);
  VAR
   BUG      : NUMERIC[2];
   curDays,
   totDays  : NUMERIC[3];
   curSum,
   totSum   : L_PRoll.tSum;
   First,
   Current,
   Last     : DATE;
 BEGIN
  IF !AvePay.Average THEN
   ProtHstTop("HstTop1");
   SETZERO(AvePay.Average, totSum, totDays);
   SetAccountPeriodValues(First, Last, PerNum);
   Current:=First;
   WHILE Current > Last DO
    Current:=L_DatTim.IncMonth(Current, -1);
    GetAveAve(ActPer, Current, ConvertProc, ToCorB, WithInfl, curSum, curDays);
    IF L_General.NeedExecuteArchaicCode(AvePay.Period, 01\04\2006) THEN
     BUG:=curDays; curDays:=BUG; (* 訡 curDays 뫠 NUMERIC[2]*)
    END;
    INC( totSum,  curSum);
    INC(totDays, curDays);
   END; (* WHILE Current > ... *)
   AssertNoAverage((totDays > 0) & (totSum > 0));
   INC(totSum, AddLongPerBonuses(First, PerNum, WithInfl));
   AvePay.Average:=totSum/totDays;
   ProtAvrg("", totDays, totSum);
  END; (* IF !AvePay.Average ... *)
 END {AveHldy};

 PROCEDURE Convert_AT1(From: DATE; W, F, C: NUMERIC[3]; VAR T, TC: NUMERIC[3]);
 BEGIN
  TC:=T;
 END {Convert_AT1};

 PROCEDURE AveCAve(PerNum: NUMERIC[0]; WithInfl: SCAL[2]);
  VAR
   curHrs,
   totHrs   : L_PRoll.tTime;
   curSum,
   totSum   : L_PRoll.tSum;
   First,
   Current,
   Last     : DATE;
 BEGIN
  IF !AvePay.Average THEN
   ProtHstTop("HstTop1");
   SETZERO(AvePay.Average, totSum, totHrs);
   SetAccountPeriodValues(First, Last, PerNum);
   Current:=First;
   WHILE Current > Last DO
    Current:=L_DatTim.IncMonth(Current, -1);
    GetAveAve(ActPer, Current, PROCREF(Convert_AT1), 0, WithInfl, curSum, curHrs);
    INC(totSum, curSum);
    INC(totHrs, curHrs);
   END; (* WHILE Current > ... *)
   AssertNoAverage((totHrs > 0) & (totSum > 0));
   INC(totSum, AddLongPerBonuses(First, PerNum, WithInfl));
   AvePay.Average:=totSum/totHrs;
   ProtAvrg("", totHrs, totSum);
  END; (* IF !AvePay.Average ... *)
 END {AveCAve};

 PROCEDURE Convert_AT2(From: DATE; W, F, C: NUMERIC[3]; VAR T,  TC: NUMERIC[3]);
 BEGIN
  IF C > 0 THEN
   IF W >= C THEN
    T:=0;
   ELSIF (W+T) >= C THEN
    T:=C-W;
   END;
  END;
  TC:=T;
 END {Convert_AT2};

 PROCEDURE AveBAve(PerNum: NUMERIC[0]);
  VAR
   curHrs,
   totHrs  : L_PRoll.tTime;
   curSum,
   totSum  : L_PRoll.tSum;
   First,
   Current,
   Last    : DATE;
 BEGIN
  IF !AvePay.Average THEN
   ProtHstTop("HstTop1");
   SETZERO(AvePay.Average, totSum, totHrs);
   SetAccountPeriodValues(First, Last, PerNum);
   Current:=First;
   WHILE Current > Last DO
    Current:=L_DatTim.IncMonth(Current, -1);
    GetAveAve(ActPer, Current, PROCREF(Convert_AT2), 1, Infl_On, curSum, curHrs);
    INC(totSum, curSum);
    INC(totHrs, curHrs);
   END; (* WHILE Current > ... *)
   AssertNoAverage((totHrs > 0) & (totSum > 0));
   INC(totSum, AddLongPerBonuses(First, PerNum, Infl_On));
   AvePay.Average:=totSum/totHrs;
   ProtAvrg("", totHrs, totSum);
  END; (* IF !AvePay.Average ... *)
 END {AveBAve};

 PROCEDURE GetDeltaToFitToAve(PerNum : NUMERIC[0];
                              VAR Sum: NUMERIC[2];
                              VAR Tim: NUMERIC[3];
                              IsSummSht: SCAL[2]);
  VAR
   mSum: L_PRoll.tSum;
   mTim: L_PRoll.tTime;
   Msg : STRING[];
 BEGIN
  Msg := "| ४⭮    ।"+
         "|㬥  "+AvePay.AveType+"  "+AvePay.DocNum+"  "+L_DatTim.DateStr(AvePay.DocDate)+
         "| ਮ  "+L_DatTim.DateStr(AvePay.StartD)+"  "+L_DatTim.DateStr(AvePay.StopD);
  L_General.Assert(L_DatTim.Per(AvePay.StartD) = L_DatTim.Per(AvePay.StopD), "㬥   ।|  ଫ  । ");
  L_Staff.PosToStaffLog(AvePay.TSN, AvePayP.StartD, 1);
  L_General.Assert((AvePayP.StartD = L_DatTim.MonthBeg(AvePayP.StartD)) |
                   (AvePayP.StartD = StaffLog.Date), " ਪ  ਥ/ॢ  "+L_DatTim.DateStr(AvePayP.StartD)+Msg);
  L_General.Assert((AvePayP.StopD  = L_DatTim.MonthEnd(AvePayP.StopD)) |
                   (AvePayP.StopD  = StaffLog.DateE), "ਪ  ਥ/ॢ  "+L_DatTim.DateStr(StaffLog.Date)+"| 稢 "+L_DatTim.DateStr(AvePayP.StopD)+Msg);
  IF IsSummSht THEN
   AveCAve(PerNum, Infl_On);
  ELSE
   AveBAve(PerNum);
  END;
  SETZERO(mSum, mTim);
  HISTCONF(AvePayP.StartD, AvePay, Staff, StaffLog);
  SELECT(Money, PayFor, , Staff.TSN, L_DatTim.Per(AvePayP.StartD));
  WHILE OCCURE(Money) DO
   IF L_AvePay.E_IsAcceptableMoneyAsPayFor() THEN
    IF Money.ODate = StaffLog.Date THEN
     CONFORM(Money, MCList);
     IF (MCList.PerNum = 1) | (Money.Period < 01\09\2006) THEN (* 0052621 *)
      IF MCList.Index[L_AvePay.aveno_Avrg] > 0 THEN
       INC(mSum, Money.Sum);
       IF MCList.TimeType > 0 THEN
        INC(mTim, Money.Tim);
       END;
      END;
     END;
    END;
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
  SETZERO(Tim);
  SELECT(Sheet, TSN, , Staff.TSN, L_DatTim.Per(AvePayP.StartD));
  SRCINSEL(Sheet, EQ, , L_DatTim.DAY(AvePayP.StartD));
  WHILE OCCURE(Sheet) & (Sheet.Day <= L_DatTim.DAY(AvePayP.StopD)) DO
   CONFORM(Sheet, JMode);
   IF JMode.Type = 2 THEN
    INC(Tim, Sheet.Tim);
   END;
   NEXT(Sheet);
  END; (* WHILE OCCURE(Sheet) ... *)
  IF mTim > 0 THEN
   Sum:=(AvePay.Average - (mSum/mTim)) * Tim;
  ELSE
   Sum:=AvePay.Average * Tim;
  END;
 END {GetDeltaToFitToAve};

(*--ࠢ--------------------------------------------------*)

 PROCEDURE ।();
  VAR
   Sum: L_PRoll.tSum;
   Tim: L_PRoll.tTime;
 BEGIN
  GetDeltaToFitToAve(3, Sum, Tim, 0);
  IF Sum > 0 THEN
   _MoneyMan(Sum, Tim, L_PRoll.src_Sheet);
  END;
 END {।};

 PROCEDURE ।();   (* 㬬஢ ⮬ ६*)
  VAR
   Sum: L_PRoll.tSum;
   Tim: L_PRoll.tTime;
 BEGIN
  GetDeltaToFitToAve(3, Sum, Tim, E_IsSummationSheet());
  IF Sum > 0 THEN
   _MoneyMan(Sum, Tim, L_PRoll.src_Sheet);
  END;
 END {।};

 PROCEDURE ।12();
  VAR
   Sum: L_PRoll.tSum;
   Tim: L_PRoll.tTime;
 BEGIN
  GetDeltaToFitToAve(12, Sum, Tim, 0);
  IF Sum > 0 THEN
   _MoneyMan(Sum, Tim, L_PRoll.src_Sheet);
  END;
 END {।12};

 PROCEDURE ।12();   (* 㬬஢ ⮬ ६*)
  VAR
   Sum: L_PRoll.tSum;
   Tim: L_PRoll.tTime;
 BEGIN
  GetDeltaToFitToAve(12, Sum, Tim, E_IsSummationSheet());
  IF Sum > 0 THEN
   _MoneyMan(Sum, Tim, L_PRoll.src_Sheet);
  END;
 END {।12};

 PROCEDURE ।();
 BEGIN AveBAve(3);
  MoneyMan(IndexedAverage() * MonTime * AvePayP.Percent / 100, MonTime);
 END {।};

 PROCEDURE ।();     (* 㬬஢ ⮬ ६*)
 BEGIN
  IF E_IsSummationSheet() THEN
   AveCAve(3, Infl_On);
   MoneyMan(IndexedAverage() * MonTime * AvePayP.Percent / 100, MonTime);
  ELSE
   ।();
  END;
 END {।};

 PROCEDURE ।12();
 BEGIN AveBAve(12);
  MoneyMan(IndexedAverage() * MonTime * AvePayP.Percent / 100, MonTime);
 END {।12};

 PROCEDURE ।12();     (* 㬬஢ ⮬ ६*)
 BEGIN
  IF E_IsSummationSheet() THEN
   AveCAve(12, Infl_On);
   MoneyMan(IndexedAverage() * MonTime * AvePayP.Percent / 100, MonTime);
  ELSE
   ।12();
  END;
 END {।12};

 PROCEDURE ।12();     (* 㬬஢ ⮬ ६ ।  *)
 BEGIN
  IF E_IsSummationSheet() THEN
   AveCAve(12, Infl_On);
   MoneyMan(IndexedAverage() * MonTime * AvePayP.Percent / 100, MonTime);
  ELSIF E_IsBaseSheet() THEN
   AveHldy(PROCREF(Convert_AT_Base1), 1, 12, Infl_On);
   MoneyMan(IndexedAverage() * MonDays * AvePayP.Percent / 100, MonTime);
  ELSE
   AveHldy(PROCREF(Convert_AT0), 1, 12, Infl_On);
   MoneyMan(IndexedAverage() * MonDays * AvePayP.Percent / 100, MonTime);
  END;
 END {।12};

 PROCEDURE 쭒();
 BEGIN
  AveSick(1);
  IF L_AvePay.SpecialSick() THEN
   MoneyMan(LimitAverage(1, MaxPay_SickOrdinary) * MonDays, MonTime);
  ELSE
   MoneyMan(LimitAverage(1, MaxPay_SickOrdinary) * MonTime, MonTime);
  END;
 END {쭒};

 PROCEDURE 쭁();
 BEGIN
  L_General.Assert(AvePay.Period >= 01\09\2007, "ࠢ '쭁'    09.2007");
  AveSick(1);
  IF L_AvePay.SpecialSick() THEN
   MoneyMan(LimitAverage(1, MaxPay_SickPregnancy) * MonDays, MonTime);
  ELSE
   MoneyMan(LimitAverage(1, MaxPay_SickPregnancy) * MonTime, MonTime);
  END;
 END {쭁};

 PROCEDURE InformPrevSickList(_DaysByFirm: NUMERIC[0]);
 BEGIN
  IF _DaysByFirm=0 THEN
   L_StdFrm.Choice(" ।騩 쭨 |"+
                   "   । । ");
  END;
 END {InformPrevSickList};

 PRIVATE PROCEDURE GetFirstDaysByFirm(PlnDaysByFirm: NUMERIC[0]): STRING[];
  VAR
   pi: SCAL[10];
 BEGIN
  InformPrevSickList(PlnDaysByFirm);
  IF    PlnDaysByFirm = 0 THEN
   pi:=0;
  ELSIF PlnDaysByFirm = 2 THEN
   pi:=1;
  ELSIF PlnDaysByFirm = 3 THEN
   L_General.Assert(AvePay.StartD >= 01\01\2011, "    ࠡ⮤⥫ ਬ  01.2011");
   pi:=3;
  ELSE
   L_General.CallUs();
  END;
  RETURN L_Str.PoolItem(P_AveP.ft_FirstDaysByFirm_Pool, pi);
 END {GetFirstDaysByFirm};

 PROCEDURE PartSick1(First : SCAL[2];
                     VAR _T: L_PRoll.tTime;
                     VAR _D: NUMERIC[0]);
  VAR
   HasPrevSickList : SCAL[2];
   i,
   FctDaysByFirm,
   PlnDaysByFirm   : NUMERIC[0];
   PayMode         : P_AveP.tftPayMode;
   Limit,
   FirstDaysByFirm : STRING[];
   Year_0,
   Year_1          : P_AveP.tftYear;
 BEGIN
  IF ((ActPer - AvePay.StartD) >= 2) | ((AvePayP.StartD - AvePay.StartD) >= 2) THEN
   SETZERO(_T, _D);
   RETURN;
  END;
  HasPrevSickList:=0;
  PlnDaysByFirm:=0;
  IF GetFirstM() >= 01\01\2005 THEN
   IF First THEN
    HasPrevSickList:=L_AvePay.SickAvePayIsSequel();
    IF HasPrevSickList THEN
     PlnDaysByFirm:=0;
    ELSE
     PlnDaysByFirm:=2;
    END;
   END;
   P_AveP.Decode_Features(P_AveP.GetProValueSoft(AvePay.AvePay, P_AveP.P_Features), Limit, FirstDaysByFirm, Year_0, Year_1, PayMode);
   IF !FirstDaysByFirm THEN
    IF OCCURE(AvePPro) THEN
     P_AveP.Encode_Features(AvePPro.Value, Limit, GetFirstDaysByFirm(PlnDaysByFirm), Year_0, Year_1, PayMode);
    ELSE
     L_General.Assert(First, "  ᢮⢮ 㬥 "+L_Str.IntStr(P_AveP.P_Features));
     P_AveP.Add_Features(AvePay.AvePay, Limit, GetFirstDaysByFirm(PlnDaysByFirm), Year_0, Year_1, PayMode);
    END;
   ELSE
    IF    FirstDaysByFirm = L_Str.PoolItem(P_AveP.ft_FirstDaysByFirm_Pool, 0) THEN
     FctDaysByFirm:=0;
    ELSIF FirstDaysByFirm = L_Str.PoolItem(P_AveP.ft_FirstDaysByFirm_Pool, 1) THEN
     FctDaysByFirm:=2;
    ELSIF FirstDaysByFirm = L_Str.PoolItem(P_AveP.ft_FirstDaysByFirm_Pool, 2) THEN
     FctDaysByFirm:=1;
    ELSE
     L_General.CallUs(0);
    END;
    IF ProcDo & ~StreamMode & (Store = +1) &
       (FctDaysByFirm # PlnDaysByFirm) & First THEN
     L_StdFrm.Choice(" ᢮⢠ 㬥 㪠 "+
                     L_Str.IntStr(FctDaysByFirm)+" "+Str.EnumObject(FctDaysByFirm, "||")+
                     "    ।|"+
                     L_Str.PoolItem("|", HasPrevSickList)+" ।騩 㬥|"+
                     ", ᫥ 㪠 "+
                     L_Str.IntStr(PlnDaysByFirm)+" "+Str.EnumObject(PlnDaysByFirm, "||"));
    END;
    PlnDaysByFirm:=FctDaysByFirm;
   END;
  END;

  FctDaysByFirm:=Math.Min(PlnDaysByFirm-PaidDaysByFirm, ActPerDayCount);
  SETZERO(_T, _D);
  i:=0;
  WHILE i<FctDaysByFirm DO
   INC(_T, DailyTime[i]);
   INC(_D, DailyDay [i]);
   IF ~First THEN
    INC(PaidDaysByFirm);  (*騥 , 騥    ।*)
   END;
   INC(i);
  END;
 END {PartSick1};

 PROCEDURE 쭒1();
  VAR
   _t: L_PRoll.tTime;
   _d: NUMERIC[0];
 BEGIN
  AveSick(1);
  PartSick1(1, _t, _d);
  IF L_AvePay.SpecialSick() THEN
   __MoneyMan(LimitAverage(1, MaxPay_SickOrdinary) * _d, _t, L_PRoll.src_AvePay, _d);
  ELSE
   __MoneyMan(LimitAverage(1, MaxPay_SickOrdinary) * _t, _t, L_PRoll.src_AvePay, _d);
  END;
 END {쭒1};

 PROCEDURE 쭒2();
  VAR
   _t: L_PRoll.tTime;
   _d: NUMERIC[0];
 BEGIN
  (*AvePay.Average   ⮢  ࠢ 쭒1*)
  L_General.Assert(~!AvePay.Average, " । ।  | 襭 ᫥⥫쭮 ࠢ  ⮤");
  PartSick1(0, _t, _d);
  _t:=MonTime-_t;
  _d:=MonDays-_d;
  IF L_AvePay.SpecialSick() THEN
   __MoneyMan(LimitAverage(0, MaxPay_SickOrdinary) * _d, _t, L_PRoll.src_AvePay, _d);
  ELSE
   __MoneyMan(LimitAverage(0, MaxPay_SickOrdinary) * _t, _t, L_PRoll.src_AvePay, _d);
  END;
 END {쭒2};

 PROCEDURE 쭁();
 BEGIN
  AveSick(0);
  IF L_AvePay.SpecialSick() THEN
   MoneyMan(AvePay.Average * MonDays * AvePayP.Percent / 100, MonTime);
  ELSE
   MoneyMan(AvePay.Average * MonTime * AvePayP.Percent / 100, MonTime);
  END;
 END {쭁};

 PROCEDURE SumPerAvpENVD(ByMROT: SCAL[2]; Print: SCAL[2]): LIKE(Money.Sum);
  VAR
   SumPerHour: FLOAT;
 BEGIN
  IF L_AvePay.SpecialSick() THEN
   IF ByMROT THEN
    SumPerHour:=L_OwnData.ODMROT(ActPer)/MonthLenForSick(ActPer);
   ELSE
    SumPerHour:=AvePay.Average;
   END;
   RETURN Math.Min(LimitAverage(Print, MaxPay_SickOrdinary), SumPerHour) * MonDays;
  ELSE
   IF ByMROT THEN
    SumPerHour:=L_OwnData.ODMROT(ActPer)/_GetRegBal(ActPer, 1);
   ELSE
    SumPerHour:=AvePay.Average;
   END;
   RETURN Math.Min(LimitAverage(Print, MaxPay_SickOrdinary), SumPerHour) * MonTime;
  END;
 END {SumPerAvpENVD};

 PROCEDURE 쭅1();
 BEGIN
  AveSick(1);
  MoneyMan(SumPerAvpENVD(1, 1), MonTime);
 END {쭅1};

 PROCEDURE 쭅2();
  VAR
   _Sum: LIKE(Money.Sum);
 BEGIN
  (*AvePay.Average   ⮢  ࠢ 쭅1*)
  L_General.Assert(~!AvePay.Average, " । ।  | 襭 ᫥⥫쭮 ࠢ  ⮤");
  _Sum:=SumPerAvpENVD(0, 0) - SumPerAvpENVD(1, 1);
  IF _Sum > 0 THEN
   MoneyMan(_Sum, 0);
  END;
 END {쭅2};

 PROCEDURE _(s: NUMERIC[0]; PerNum: NUMERIC[0]);
 BEGIN
  DaysInMonth_6day:=25.25;
  IF AvePay.StartD >= 01\01\2007 THEN
   DaysInMonth_7day:=29.40;
  ELSE
   IF   PerNum = 12 THEN
    DaysInMonth_7day:=29.40;
   ELSE
    DaysInMonth_7day:=29.60;
   END;
  END;
  IF E_IsSummationSheet() & ~E_Cancel_13_4() THEN
   AveCAve(PerNum, Infl_On);
   MonTime:=MonDays*40/7;
   MoneyMan(s * IndexedAverage() * MonTime * AvePayP.Percent / 100, MonTime);
  ELSIF E_IsBaseSheet() THEN
   AveHldy(PROCREF(Convert_AT_Base), 0, PerNum, Infl_On);
   MoneyMan(s * IndexedAverage() * MonDays * AvePayP.Percent / 100, MonTime);
  ELSE
   AveHldy(PROCREF(Convert_AT0), 1, PerNum, Infl_On);
   MoneyMan(s * IndexedAverage() * MonDays * AvePayP.Percent / 100, MonTime);
  END;
 END {_};

 PROCEDURE ();
 BEGIN
  _(+1, 3);
 END {};

 PROCEDURE ();
 BEGIN
  _(-1, 3);
 END {};

 PROCEDURE 12();
 BEGIN
  IF AvePay.StartD >= 06\10\2006 THEN
   _(+1, 12);
  ELSE
   _(+1,  3);
  END;
 END {12};

 PROCEDURE 12();
 BEGIN
  IF AvePay.StartD >= 06\10\2006 THEN
   _(-1, 12);
  ELSE
   _(-1,  3);
  END;
 END {12};

 PROCEDURE RatioTimDoneCorBal(PerB, PerE: DATE): NUMERIC[3];
  VAR
   _CorBal,
   _TimDone: L_PRoll.tTime;
   _P      : DATE;
 BEGIN
  SETZERO(_CorBal, _TimDone);
  _P:=L_DatTim.Per(Math.Max(Staff.BegDate, PerB));
  WHILE _P < L_DatTim.Per(PerE) DO
   AccessPCalc(_P);
   INC(_CorBal,  PCalc.CorBal);
   INC(_TimDone, PCalc.TimDone);
   _P:=L_DatTim.IncMonth(_P, +1);
  END;
  IF _CorBal > 0 THEN
   RETURN _TimDone / _CorBal;
  ELSE
   RETURN 0;
  END;
 END {RatioTimDoneCorBal};

END.
