(*
%Copyright   (c) Polak Computer System
%Author      02.09.2008 20:19:21 POLAK\Gina
%Purpose        AvePay
%Type        to paste
%Specific    SYS
%Modified    05.06.2014 16:50:38 POLAK\Gina
%Environment
*)

 IMPORT L_General, L_OwnData, L_DatTim, L_AvePay, L_APtm, L_PRoll, L_Sheet,
        L_Man, L_Str, P_AveP, Math, L_Env, L_StdFrm, L_SFee, P_Man, Str, E_Staff, L_Packet;

 TYPE
  tSick = SCAL[2];

 CONST
  Infl_Off = 0;
  Infl_On  = 1;

  sick_Ordinary  = 0; (* tSick *)
  sick_Pregnancy = 1;

(*
$P { HstTopSick:
@
|---------------------------------६--------㬬-|
}
*)

(*
$P { HstLineSick:
?, L, "N.y"
?, R, "3."
?, R, "2-"
@
| #######                           ######## ############ |
}
*)

(*
$P { TotSumTopSickByYears:
@
|- ---------------------------------------㬬-|
}
*)

(*
$P { TotSumSickByYears:
?, L, ""
?, R, ""
?, R, "2-"
@
| ##################################### #### ############ |
}
*)

(*
$P { TopSalaryInAPFY:
@
|-㣨 ࠡ⮤⥫----------------------------㬬 |
}
*)

(*
$P { DaysInInAPFY:
?, L, "0"
@
|      㤮ᯮᮡ  .. ###                   |
}
*)

(*
$P { AverageSick:
?, R, ""
AvePay.Average, R, "2-"
?, R, "3."
?, R, "2-"
@
|-।------------㬬  ####------६-- 㬬-|
|                    ############   ######## ############ |
}
*)

(*
$P{ MinMonCapSick:
?, R, ""
?, R, "2-"
@
|-।  ----㬬  ####-------------------------|
|                 ###############                         |
}
*)

(*
$P { LimMonCap2011:
?, R, ""
?, R, "5-"
@                                              
|-।  ࠭祭----------------------------------|
|                    㬬  ####                         |
|                 ###############                         |
}
*)

 PRIVATE PROCEDURE DaysInMonth_7day(): NUMERIC[1];
 BEGIN
  IF AvePay.StartD >= 02\04\2014 THEN
   RETURN 29.3;
  ELSE
   RETURN 29.4;
  END;
 END {DaysInMonth_7day};

 PRIVATE PROCEDURE GetDaysInMonth(P: DATE): NUMERIC[2];
 BEGIN
  IF    (AvePay.StartD >= 01\06\2012) & (AveType.AveNo = L_AvePay.aveno_Hldy) &
        (AveType.LimType = L_AvePay.avelim_EdHldy) THEN
   RETURN DaysInMonth_7day();
  ELSIF L_AvePay.GetRealNetNo()  = L_AvePay.nn_AllDays THEN  (* .   01.01.2007 *)
   RETURN L_DatTim.MonthLen(P);
  ELSIF L_AvePay.GetRealNetNo()  = L_AvePay.nn_7Days THEN
   RETURN DaysInMonth_7day();
  ELSIF L_AvePay.GetRealNetNo() <= L_AvePay.nn_Regime THEN
   L_APtm.MonthAccess(P);
   RETURN Month.WD6;
  ELSE
   L_General.Error("⨬ ⨯  ⪨");
  END;
 END {GetDaysInMonth};

 PRIVATE PROCEDURE GetMonthsByManActv(From, UpTo: DATE): FLOAT;
  VAR
   Months: FLOAT;
 BEGIN
  Months:=0;
  SELECT(ManActv, Man, , Staff.Man, L_Man.actvk_Work);
  IF ~SRCINSEL(ManActv, LE, From) THEN
   FIRST(ManActv);
  END;
  WHILE OCCURE(ManActv) & (ManActv.BegDate<=UpTo) DO
   IF (ManActv.EndDate>=From) & (ManActv.SenAddS=0(*   室  쬨*)) THEN
    INC(Months, L_DatTim.MonthsInIntvl(Math.Max(From, ManActv.BegDate), Math.Min(UpTo, ManActv.EndDate)));
   END;
   NEXT(ManActv);
  END; (* WHILE OCCURE(ManActv) ... *)
  RETURN Months;
 END {GetMonthsByManActv};

 PRIVATE PROCEDURE CheckWorkTime(): SCAL[2];
  VAR
   Months: FLOAT;
   TM    : NUMERIC[0];
   From,
   UpTo,
   TakeOn: DATE;
 BEGIN
  TM:=6;
  From  :=MINOF(DATE);
  UpTo  :=L_AvePay.SickAvePaySequenceStart() - 1;
  TakeOn:=L_Man.GetTakeOnDate(UpTo + 1);
  Months:=L_DatTim.DaysToMonths(L_Man.GetContractsLengthOfMan(Staff.Man, TakeOn, UpTo, 0, 0));
  IF Months >= TM THEN
   RETURN 1;
  END;
  INC(Months, GetMonthsByManActv(From, TakeOn - 1));
  RETURN Months >= TM;
 END {CheckWorkTime};

 PRIVATE PROCEDURE SetLimit(): SCAL[2];
  VAR
   Result,
   NeedInf        : SCAL[2];
   PayMode        : P_AveP.tftPayMode;
   Limit,
   FirstDaysByFirm: STRING[];
   Year_0,
   Year_1         : P_AveP.tftYear;
 BEGIN
  Result:=0; NeedInf:=ProcDo & ~StreamMode & (Store = +1);
  IF P_AveP.HasActualPro(AvePay.AvePay, P_AveP.P_Features) THEN
   P_AveP.Decode_Features(AvePPro.Value, Limit, FirstDaysByFirm, Year_0, Year_1, PayMode);
   IF !Limit & ~CheckWorkTime() THEN
    Result:=1;
    P_AveP.Encode_Features(AvePPro.Value,
                           L_Str.PoolItem(P_AveP.ft_Limit_Pool, P_AveP.ft_Limit_Yes),
                           FirstDaysByFirm,
                           Year_0,
                           Year_1,
                           PayMode);
   ELSE
    Result:=L_Str.PositionInPool(P_AveP.ft_Limit_Pool, Limit) = P_AveP.ft_Limit_Yes;
    NeedInf:=0;
   END;
  ELSIF ~CheckWorkTime() THEN
   Result:=1;
   P_AveP.Add_Features(AvePay.AvePay,
                       L_Str.PoolItem(P_AveP.ft_Limit_Pool, P_AveP.ft_Limit_Yes),
                       EMPTYOF(STRING[]),
                       EMPTYOF(P_AveP.tftYear),
                       EMPTYOF(P_AveP.tftYear),
                       EMPTYOF(P_AveP.tftPayMode));
  END;
  IF Result & NeedInf THEN
   L_StdFrm.Inform(" " + L_DatTim.DateStr(L_AvePay.SickAvePaySequenceStart()) + " ࠡ⭨  ࠡ⠫"+
                   "|    ६."+
                   "||㤥 ਬ ࠭祭 ।"+
                   "|(. ᢮⢮ 㬥 " + FLDTOSTR(P_AveP.P_Features, "") + ")");
  END;
  RETURN Result;
 END {SetLimit};

 PUBLIC PROCEDURE GetSickLimit(curSick: tSick): tPreciseAvr;
  VAR
   Prc: NUMERIC[3];
 BEGIN
  Prc:=1;
  IF AvePayP.Percent # 0 THEN
   Prc:=Math.Min(1, AvePayP.Percent/100);
  END;
  CONFORM(AvePay, Staff);
  IF SetLimit() THEN
   IF    AvePay.Period >= 01\08\2013 THEN
    RETURN L_OwnData.ODMROT(ActPer) * L_PRoll.RegionalCoeff(ActPer) / Prc / L_DatTim.MonthLen(ActPer);
   ELSIF AvePay.StartD >= 01\01\2011 THEN
    RETURN L_OwnData.ODMROT(ActPer) * L_PRoll.RegionalCoeff(ActPer) / Prc * 24 / 730;
   ELSE
    RETURN L_OwnData.ODMROT(ActPer) * L_PRoll.RegionalCoeff(ActPer) / Prc / L_DatTim.MonthLen(ActPer);
   END;
  ELSE
   IF    (_GetFirstM() >= 01\01\2013) & (curSick = sick_Pregnancy) THEN
    RETURN Math.Round((L_SFee.GetOvrQuota(L_DatTim.IncYear(L_DatTim.YearBeg(_GetFirstM()), -1)) +
                       L_SFee.GetOvrQuota(L_DatTim.IncYear(L_DatTim.YearBeg(_GetFirstM()), -2))) / 730, 0.01);
   ELSIF (AvePay.StartD >= 01\01\2011) & (P_AveP.Get_ft_PayMode() = P_AveP.ft_PayMode_2011) THEN
    RETURN 99999999;
   ELSIF (AvePay.StartD >= 01\01\2011) & (P_AveP.Get_ft_PayMode() = P_AveP.ft_PayMode_2010) THEN
    RETURN L_SFee.GetOvrQuota(31\12\2010) / 365;
   ELSE
    RETURN L_SFee.GetOvrQuota(AvePay.StartD) / 365;
   END;
  END;
 END {GetSickLimit};

 PRIVATE PROCEDURE AssertNoAverage(Cond: SCAL[2]; Comment, AlternativeRecommendation: STRING[]);
 BEGIN
  IF ~Cond THEN
   L_StdFrm.WrongDB(" 㬥  ⢨/ -। "+
                    "|'"+AveType.Name+"'  "+L_DatTim.DateStr(AvePay.StartD)+
                    "|  । ⮬᪨."+"|"+Str.Condense(Comment)+"."+
                    "|室  ।   㪠  㬥"+
                    "|"+AlternativeRecommendation);
  END;
 END {AssertNoAverage};

 PRIVATE PROCEDURE CheckLastMonth(FirstMonth: DATE; VAR LastMonth: DATE);
  VAR
   BegDate,
   RealBegPer: DATE;
 BEGIN
  IF ~E_CanCalcBeforeStart(AvePay.Period) & (LastMonth < L_Env.aptm_Start) & (Staff.BegDate < L_Env.aptm_Start) THEN
   AssertNoAverage(ProtDo & ~ProcDo, " ਮ , ࠭祭 楬 ᪠ ", "");
   LastMonth:=L_Env.aptm_Start;
  ELSE
   BegDate:=L_Man.GetTakeOnDate(AvePay.StartD);
   RealBegPer:=L_DatTim.Per(BegDate);
   IF LastMonth < RealBegPer THEN
    IF ~StreamMode & (RealBegPer # L_DatTim.Per(Staff.BegDate)) &
       (RealBegDate(AvePay.StartD) = Staff.BegDate) THEN
     L_StdFrm.Choice("⭨ ୮ ਭ  ⭮ ਮ." +
                     "| |" +
                     "室 ஢ 稭 ।");
    END;
    LastMonth:=RealBegPer;
    AssertNoAverage(TrialAvepayMode | (FirstMonth > LastMonth),
                    " 㤮   "+L_DatTim.DateStr(BegDate)+"  ࠡ⪠  "+L_DatTim.PeriodStr(LastMonth)+
                    L_Str.PoolItem(" |,   㤮 ", Staff.BegDate = BegDate),
                    L_Str.PoolItem(" ନ 㬥  㣮 㤮 |", Staff.BegDate = BegDate));
   END;
  END;
 END {CheckLastMonth};

 PRIVATE PROCEDURE SetAccountPeriodValues(VAR trgFirst, trgLast: DATE;
                                          VAR trgPerNum: NUMERIC[0]);
 BEGIN
  trgFirst:=GetFirstM();
  trgLast :=L_DatTim.IncMonth(trgFirst, -trgPerNum);
  CheckLastMonth(trgFirst, trgLast);
  trgPerNum:=L_DatTim.MonthsInIntvl(trgLast, trgFirst);
 END {SetAccountPeriodValues};

 PUBLIC PROCEDURE IndexedAverage(): NUMERIC[2];
  VAR
   CurInf  : NUMERIC[3];
   _Average: NUMERIC[2];
 BEGIN
  _Average:=AvePay.Average;
  CurInf  :=1;
  CurInf:=GetAccumulatedInflation(StaffLog.Date, ActPer, _GetFirstM());
  IF CurInf # 1 THEN
   AvePay.Average:=AvePay.Average * CurInf;
   ProtInfl(ActPer, CurInf);
   AvePay.Average:=_Average;
  END;
  RETURN CurInf * _Average;
 END {IndexedAverage};

 PRIVATE PROCEDURE GetDutyDgr(): LIKE(StaffLog.DutyDgr);
 BEGIN
  RETURN 1.000;
 END {GetDutyDgr};

 PRIVATE PROCEDURE LimitAverage(Print, MinAverageOnly: SCAL[2]; curSick: tSick): tPreciseAvr;
  VAR
   MinAverage,
   LimAverage: tPreciseAvr;
 BEGIN
  LimAverage:=GetSickLimit(curSick);
  IF    AvePay.StartD >= 01\01\2013 THEN
   MinAverage:=Math.Round(L_OwnData.ODMROT(_GetFirstM()) * L_PRoll.RegionalCoeff(AvePay.StartD) * GetDutyDgr() * 24 / 730, 0.01);
  ELSIF AvePay.StartD >= 01\04\2011 THEN
   MinAverage:=Math.Round(L_OwnData.ODMROT(AvePay.StartD) * L_PRoll.RegionalCoeff(AvePay.StartD) * GetDutyDgr() * 24 / 730, 0.01);
  ELSE
   MinAverage:=Math.Round(L_OwnData.ODMROT(AvePay.StartD) * GetDutyDgr() * 24 / 730, 0.01);
  END;
  IF (AvePay.StartD >= 01\01\2011) & (AvePay.Average < MinAverage) THEN
   IF Print THEN
    IF ProtDo THEN
     MAKEPART(R, MinMonCapSick, "", MinAverage);
    END;
    ProtMonTop();
   END;
   RETURN MinAverage * AvePayP.Percent / 100;
  ELSIF ~MinAverageOnly & (AvePay.Average > LimAverage) THEN
   IF Print THEN
    IF AvePay.StartD >= 01\01\2011 THEN
     IF ProtDo THEN
      MAKEPART(R, LimMonCap2011, "", LimAverage);
     END;
    ELSE
     ProtLim("", LimAverage);
    END;
    ProtMonTop();
   END;
   RETURN LimAverage * AvePayP.Percent / 100;
  END;
  RETURN AvePay.Average * AvePayP.Percent / 100;
 END {LimitAverage};

 PRIVATE PROCEDURE CorDaysBySheet(From: DATE; TimDoneOnly: SCAL[2]): NUMERIC[0];
  VAR
   CorDays: NUMERIC[0];
   _RealBegPer : DATE;
 BEGIN
  TimeInLastStaffLog:=1; (* SIC!!! 0065590 *)
  _RealBegPer:=RealBegDate(From);
  SETZERO(CorDays);
  SAVE(Sheet);
  SAVE(JMode);
  IF _RealBegPer <= L_DatTim.MonthEnd(From) THEN
   SELECT(Sheet, TSN, , Staff.TSN, L_DatTim.Per(From));
   IF L_DatTim.Per(_RealBegPer) = L_DatTim.Per(From) THEN
    SRCINSEL(Sheet, EQ, , L_DatTim.DAY(_RealBegPer));
   END;
   WHILE OCCURE(Sheet) DO
    CONFORM(Sheet, JMode);
    IF TimDoneOnly THEN
     INC(CorDays, JMode.Type=L_Sheet.jmType_TimDone);
    ELSE
     INC(CorDays, JMode.InFirm & ~JMode.DecrBal);
    END;
    NEXT(Sheet);
   END; (* WHILE OCCURE(Sheet) ... *)
  END;
  RESTORE(Sheet);
  RESTORE(JMode);
  RETURN CorDays;
 END {CorDaysBySheet};

 PRIVATE PROCEDURE Convert_AT_DaysBySheet(From: DATE; W, F, C: NUMERIC[3]; VAR T, TC: NUMERIC[3]);
 BEGIN
  TC:=CorDaysBySheet(From, 0);
 END {Convert_AT_DaysBySheet};

 PRIVATE PROCEDURE GetExclDays(curSick: tSick; P: DATE): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=0;
  IF (AvePay.StartD >= 01\01\2013) & (curSick = sick_Pregnancy) THEN
   SELECT(Sheet, TSN, , Staff.TSN, P);
   WHILE OCCURE(Sheet) DO
    INC(Result, (Sheet.JMode=L_Sheet.jm_MaternityLeave) |
                (Sheet.JMode=L_Sheet.jm_ParentalLeave) | (Sheet.JMode=L_Sheet.jm_ParentalLeaveUntil3Y) |
                (E_Staff.SpecStage2ForPens(Sheet.Period, Sheet.JMode)=L_Packet.miat_Disability));
    NEXT(Sheet);
   END; (* WHILE OCCURE(Sheet) ... *)
  END;
  RETURN Result;
 END {GetExclDays};

 CONST
  YearAmnt = 2;

 PRIVATE PROCEDURE GetAPFYIdent(VAR FirstAPFY: SCAL[2]): STRING[];
 BEGIN
  IF FirstAPFY THEN
   FirstAPFY:=0;
   RETURN Str.Condense(ManPro.DocNum+" "+ManPro.DocGiveS);
  ELSE
   RETURN "";
  END;
 END {GetAPFYIdent};

 PRIVATE PROCEDURE GetSalaryInAPFY(VAR curSumYear : NUMERIC[2][YearAmnt];
                                   VAR curAPFYDays: NUMERIC[0][YearAmnt];
                                       curYear    : DATE      [YearAmnt];
                                       curSick    : tSick);
  VAR
   curYearIdx: SCAL[YearAmnt];
   curAPFYIdx: SCAL[P_Man.apfy_Amount];
   FirstAPFY,
   First     : SCAL[2];
   APFYYear  : SCAL[1E4][P_Man.apfy_Amount];
   APFYSal   : NUMERIC[2][P_Man.apfy_Amount];
   APFYDays  : NUMERIC[0][P_Man.apfy_Amount];
 BEGIN
  First:=1;
  SELECT(ManPro, Man, , Staff.Man, P_Man.P_SalaryInAPFY);
  WHILE OCCURE(ManPro) DO
   FirstAPFY:=1;
   P_Man.sapfy_DecodeValue(APFYYear, APFYSal, APFYDays);
   FOR_EACH curYearIdx DO
    FOR_EACH curAPFYIdx DO
     IF L_DatTim.YEAR(curYear[curYearIdx]) = APFYYear[curAPFYIdx] THEN
      APFYSal[curAPFYIdx]:=L_General.Denominate(curYear[curYearIdx], AvePay.Period, APFYSal[curAPFYIdx]);
      INC(curSumYear[curYearIdx], APFYSal[curAPFYIdx]);
      IF ProtDo THEN
       IF First THEN
        MAKEPART(R, TopSalaryInAPFY);
        First:=0;
       END;
       MAKEPART(R, TotSumSickByYears, GetAPFYIdent(FirstAPFY), APFYYear[curAPFYIdx], APFYSal[curAPFYIdx]);
      END;
      IF (AvePay.StartD >= 01\01\2013) & (curSick = sick_Pregnancy) &
         ~!APFYDays[curAPFYIdx] & (APFYDays[curAPFYIdx]#0) THEN
       IF ProtDo THEN
        MAKEPART(R, DaysInInAPFY, APFYDays[curAPFYIdx]);
       END;
       INC(curAPFYDays[curYearIdx], APFYDays[curAPFYIdx]);
      END;
     END;
    END; (* FOR_EACH curAPFYIdx *)
   END; (* FOR_EACH curYearIdx *)
   NEXT(ManPro);
  END; (* WHILE OCCURE(ManPro) ... *)
 END {GetSalaryInAPFY};

 PRIVATE PROCEDURE AveSick2011(wLim: SCAL[2]; curSick: tSick);
  VAR
   totExclDays,
   curExclDays,
   totDays        : NUMERIC[3];
   curSum,
   totSum         : L_PRoll.tSum;
   Current        : DATE;
   curYearIdx     : SCAL[YearAmnt];
   curSumYear     : L_PRoll.tSum[YearAmnt];
   curAPFYDays    : NUMERIC[0]  [YearAmnt];
   curYear        : DATE        [YearAmnt];
   YearFirstM     : DATE;
   PayMode        : P_AveP.tftPayMode;
   Limit,
   FirstDaysByFirm: STRING[];
   Year_0,
   Year_1         : P_AveP.tftYear;
 BEGIN
  IF !AvePay.Average THEN
   IF ProtDo THEN
    MAKEPART(R, HstTopSick);
   END;
   SETZERO(AvePay.Average, totSum, totDays, curSumYear, totExclDays, curAPFYDays);
   P_AveP.Decode_Features(P_AveP.GetProValueSoft(AvePay.AvePay, P_AveP.P_Features), Limit, FirstDaysByFirm, Year_0, Year_1, PayMode);
   IF ~!Year_0 & ~!Year_1 THEN
    curYear[0]:=PackDATE(1, 0, Year_0);
    curYear[1]:=PackDATE(1, 0, Year_1);
    YearFirstM:=L_DatTim.YearBeg(_GetFirstM());
    L_General.Assert((curYear[0] < YearFirstM) & (curYear[1] < YearFirstM),
                     " ਮ ()    "+FLDTOSTR(YearFirstM, "y")+
                     "|(  㯫 ᮡ)");
   ELSE
    IF AvePay.StartD >= 01\01\2012 THEN
     curYear[0]:=L_DatTim.IncYear(L_DatTim.YearBeg(_GetFirstM()), -1);
     curYear[1]:=L_DatTim.IncYear(L_DatTim.YearBeg(_GetFirstM()), -2);
    ELSE
     curYear[0]:=L_DatTim.IncYear(L_DatTim.YearBeg(AvePay.StartD), -1);
     curYear[1]:=L_DatTim.IncYear(L_DatTim.YearBeg(AvePay.StartD), -2);
    END;
   END;
   FOR_EACH curYearIdx DO
    Current:=L_DatTim.MonthBeg(L_DatTim.YearEnd(curYear[curYearIdx]));
    WHILE Current >= L_DatTim.YearBeg(curYear[curYearIdx]) DO
     SETZERO(curSum);
     SAVE(Staff);
     SELECT(Staff, Man, , Staff.Man);
     WHILE OCCURE(Staff) DO
      IF (Staff.Contract # L_Staff.cnt_ContractorsAgreement) | ~L_SFee.E_IsRealContractorsAgreement(Current) THEN
       SELECT(Money, TSN, , Staff.TSN, Current);
       WHILE OCCURE(Money) DO
        CONFORM(Money, MCList);
        IF GetMCListIndexByAveTypeAveNo(Money.Closed) > L_PRoll.mci_Exclude THEN
         INC(curSum, L_General.Denominate(Money.Closed, AvePay.Period, Money.Sum));
        END;
        NEXT(Money);
       END; (* WHILE OCCURE(Money) ... *)
      END;
      NEXT(Staff);
     END; (* WHILE OCCURE(Staff) ... *)
     RESTORE(Staff);
     curExclDays:=GetExclDays(curSick, Current);
     IF ProtDo THEN
      MAKEPART(R, HstLineSick, Current, GetDaysInMonth(Current)-curExclDays, curSum);
     END;
     INC(curSumYear[curYearIdx], curSum);
     INC(totExclDays, curExclDays);
     Current:=L_DatTim.IncMonth(Current, -1);
    END; (* WHILE Current > ... *)
   END;
   IF (Staff.Contract # L_Staff.cnt_ExternalCombine) |
      L_General.NeedExecuteArchaicCode(AvePay.Period, 01\11\2013) THEN
    GetSalaryInAPFY(curSumYear, curAPFYDays, curYear, curSick);
   END;
   IF ProtDo THEN
    MAKEPART(R, TotSumTopSickByYears);
   END;
   FOR_EACH curYearIdx DO
    IF wLim | L_General.NeedExecuteArchaicCode(AvePay.Period, 01\07\2011) THEN
     curSumYear[curYearIdx]:=Math.Min(curSumYear[curYearIdx],
                                      L_SFee.GetOvrQuota(Math.Max(curYear[curYearIdx], L_SFee.TheStartingPoint)));
    END;
    INC(totSum, curSumYear[curYearIdx]);
    INC(totDays, L_DatTim.YearLen(curYear[curYearIdx]));
    INC(totExclDays, curAPFYDays[curYearIdx]);
    IF ProtDo THEN
     MAKEPART(R, TotSumSickByYears, "", L_DatTim.YEAR(curYear[curYearIdx]), curSumYear[curYearIdx]);
    END;
   END;
   IF (AvePay.StartD >= 01\01\2013) & (curSick = sick_Pregnancy) THEN
    totDays:=totDays-totExclDays;
    L_General.Assert(totDays > 0, " ⭮ ਮ  .  ᫥   ਮ.");
   ELSE
    totDays:=730;
   END;
   AvePay.Average:=totSum/totDays;
   IF ProtDo THEN
    MAKEPART(R, AverageSick, "", totDays, totSum);
   END;
  END; (* IF !AvePay.Average ... *)
 END {AveSick2011};

 PRIVATE PROCEDURE AveSick(wLim: SCAL[2]; curSick: tSick);
  VAR
   PerNum: NUMERIC[0];
 BEGIN
  IF !AvePay.Average THEN
   IF (AvePay.StartD >= 01\01\2011) & (P_AveP.Get_ft_PayMode() = P_AveP.ft_PayMode_2011) THEN
    AveSick2011(wLim, curSick);
   ELSE
    PerNum:=12;
    IF E_IsBaseSheet() THEN
     AveHldy(PROCREF(Convert_AT_DaysBySheet), 1, PerNum, Infl_Off);
    ELSE
     AveHldy(PROCREF(Convert_AT0), 1, PerNum, Infl_Off);
    END;
   END;
   REPLACE(AvePay);
  END; (* IF !AvePay.Average ... *)
  IF (AvePay.Average > 0) & ~L_SFee.ManCitizenship(Staff.Man, _GetFirstM()) &
     ProcDo & ~StreamMode & (Store = +1) THEN
   L_StdFrm.Question("   ࠢ  ᮡ  㤮ᯮᮡ|, ᫥ 㪠 㫥 ।");
  END;
 END {AveSick};

 PUBLIC PROCEDURE Convert_AT0(From: DATE; W, F, C: NUMERIC[3]; VAR T, TC: NUMERIC[3]);
 BEGIN
  IF C > 0 THEN
   IF W >= C THEN
    T:=0;
   ELSIF (W+T) >= C THEN
    T:=C-W;
   END;
  END;
  IF T # 0 THEN
   TC:=T / F * GetDaysInMonth(From);
  ELSE
   TC:=0;
  END;
  IF AveType.AveNo = L_AvePay.aveno_Sick THEN
   TC:=Math.Round(TC);
  END;
 END {Convert_AT0};

 PRIVATE PROCEDURE Convert_AT_Base(From: DATE; W, F, C: NUMERIC[3]; VAR T, TC: NUMERIC[3]);
  VAR
   MonthDays: NUMERIC[3];
 BEGIN
  MonthDays:=GetDaysInMonth(From);
  TC:=MonthDays / L_DatTim.MonthLen(From) * CorDaysBySheet(From, 0);
  TC:=Math.Min(MonthDays, TC);
 END {Convert_AT_Base};

 PRIVATE PROCEDURE Convert_AT_Base1(From: DATE; W, F, C: NUMERIC[3]; VAR T, TC: NUMERIC[3]);
 BEGIN
  TC:=CorDaysBySheet(From, 1);
 END {Convert_AT_Base1};

 PUBLIC PROCEDURE AveHldy(ConvertProc: PROC; ToCorB: SCAL[2]; PerNum: NUMERIC[0]; WithInfl: SCAL[2]);
  VAR
   curDays,
   totDays  : NUMERIC[3];
   curSum,
   totSum   : L_PRoll.tSum;
   First,
   Current,
   Last     : DATE;
 BEGIN
  IF !AvePay.Average THEN
   ProtHstTop("HstTop1");
   SETZERO(AvePay.Average, totSum, totDays);
   SetAccountPeriodValues(First, Last, PerNum);
   Current:=First;
   WHILE Current > Last DO
    Current:=L_DatTim.IncMonth(Current, -1);
    GetAveAve(ActPer, Current, ConvertProc, ToCorB, WithInfl, curSum, curDays);
    INC( totSum, curSum);
    INC(totDays, curDays);
   END; (* WHILE Current > ... *)
   IF (totDays > 0) & (totSum > 0) THEN
    INC(totSum, AddLongPerBonuses(First, PerNum, WithInfl));
    AvePay.Average:=totSum/totDays;
    ProtAvrg("", totDays, totSum);
   ELSE
    AssertNoAverage(TrialAvepayMode, "    ࠡ⪠  ࠡ⠭ ६  ⭮ ਮ", "");
    GetAveAve(ActPer, AvePay.Period, ConvertProc, ToCorB, WithInfl, totSum, totDays);
    IF (totDays > 0) & (totSum > 0) THEN
     AvePay.Average:=totSum/totDays;
    ELSE
     AvePay.Average:=GetPay(AvePay.Period, "", DaysInMonth_7day());
    END;
   END;
  END; (* IF !AvePay.Average ... *)
 END {AveHldy};

 PRIVATE PROCEDURE Convert_AT1(From: DATE; W, F, C: NUMERIC[3]; VAR T, TC: NUMERIC[3]);
 BEGIN
  TC:=T;
 END {Convert_AT1};

 PRIVATE PROCEDURE Convert_AT2(From: DATE; W, F, C: NUMERIC[3]; VAR T,  TC: NUMERIC[3]);
 BEGIN
  IF C > 0 THEN
   IF W >= C THEN
    T:=0;
   ELSIF (W+T) >= C THEN
    T:=C-W;
   END;
  END;
  TC:=T;
 END {Convert_AT2};

 PUBLIC PROCEDURE AveCAve(ConvertProc: PROC; ToCorB: SCAL[2]; PerNum: NUMERIC[0]; WithInfl: SCAL[2]);
  VAR
   curHrs,
   totHrs   : L_PRoll.tTime;
   curSum,
   totSum   : L_PRoll.tSum;
   First,
   Current,
   Last     : DATE;
 BEGIN
  IF !AvePay.Average THEN
   ProtHstTop("HstTop1");
   SETZERO(AvePay.Average, totSum, totHrs);
   SetAccountPeriodValues(First, Last, PerNum);
   Current:=First;
   WHILE Current > Last DO
    Current:=L_DatTim.IncMonth(Current, -1);
    GetAveAve(ActPer, Current, ConvertProc, ToCorB, WithInfl, curSum, curHrs);
    INC(totSum, curSum);
    INC(totHrs, curHrs);
   END; (* WHILE Current > ... *)
   IF (totHrs > 0) & (totSum > 0) THEN
    INC(totSum, AddLongPerBonuses(First, PerNum, WithInfl));
    AvePay.Average:=totSum/totHrs;
    ProtAvrg("", totHrs, totSum);
   ELSE
    AssertNoAverage(TrialAvepayMode, "    ࠡ⪠  ࠡ⠭ ६  ⭮ ਮ", "");
    AvePay.Average:=0;
   END;
  END; (* IF !AvePay.Average ... *)
 END {AveCAve};

 PUBLIC PROCEDURE GetDeltaToFitToAve(    PerNum : NUMERIC[0];
                                     VAR Sum: NUMERIC[2];
                                     VAR Tim: NUMERIC[3];
                                         IsSummSht: SCAL[2]);
  VAR
   mSum: L_PRoll.tSum;
   mTim: L_PRoll.tTime;
 BEGIN
  L_General.Assert(L_DatTim.Per(AvePay.StartD) = L_DatTim.Per(AvePay.StopD), "㬥   ।|  ଫ  । ");
  L_Staff.PosToStaffLog(AvePay.TSN, AvePayP.StartD, 1);
  L_General.Assert(((AvePayP.StartD = L_DatTim.MonthBeg(AvePayP.StartD)) | (AvePayP.StartD = StaffLog.Date)) &
                   ((AvePayP.StopD  = L_DatTim.MonthEnd(AvePayP.StopD)) | (AvePayP.StopD  = StaffLog.DateE)),
                   " ४⭮    ।   , "+
                   "|㬥  "+AvePay.AveType+"  "+AvePay.DocNum+"  "+L_DatTim.DateStr(AvePay.DocDate)+"."+
                   "|| ਮ  ॡ ନ ਪ"+
                   "| ਥ/ॢ  "+L_DatTim.DateStr(AvePay.StartD)+"  "+L_DatTim.DateStr(AvePay.StopD));
  IF IsSummSht THEN
   AveCAve(PROCREF(Convert_AT1), 0, PerNum, Infl_On);
  ELSE
   AveCAve(PROCREF(Convert_AT2), 1, PerNum, Infl_On);
  END;
  SETZERO(mSum, mTim);
  HISTCONF(AvePayP.StartD, AvePay, Staff, StaffLog);
  SELECT(Money, PayFor, , Staff.TSN, L_DatTim.Per(AvePayP.StartD));
  WHILE OCCURE(Money) DO
   IF L_AvePay.E_IsAcceptableMoneyAsPayFor() THEN
    IF Money.ODate = StaffLog.Date THEN
     CONFORM(Money, MCList);
     IF (MCList.PerNum = 1) | (Money.Period < 01\09\2006) THEN (* 0052621 *)
      IF MCList.Index[L_AvePay.aveno_Avrg] > 0 THEN
       INC(mSum, Money.Sum);
       IF MCList.TimeType > 0 THEN
        INC(mTim, Money.Tim);
       END;
      END;
     END;
    END;
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
  SETZERO(Tim);
  SELECT(Sheet, TSN, , Staff.TSN, L_DatTim.Per(AvePayP.StartD));
  SRCINSEL(Sheet, EQ, , L_DatTim.DAY(AvePayP.StartD));
  WHILE OCCURE(Sheet) & (Sheet.Day <= L_DatTim.DAY(AvePayP.StopD)) DO
   CONFORM(Sheet, JMode);
   IF JMode.Type = L_Sheet.jmType_TimDone THEN
    INC(Tim, Sheet.Tim);
   END;
   NEXT(Sheet);
  END; (* WHILE OCCURE(Sheet) ... *)
  IF mTim > 0 THEN
   Sum:=(AvePay.Average - (mSum/mTim)) * Tim;
  ELSE
   Sum:=AvePay.Average * Tim;
  END;
 END {GetDeltaToFitToAve};

(*--ࠢ--------------------------------------------------*)

 PUBLIC PROCEDURE ।();
  VAR
   Sum: L_PRoll.tSum;
   Tim: L_PRoll.tTime;
 BEGIN
  GetDeltaToFitToAve(3, Sum, Tim, 0);
  IF Sum > 0 THEN
   _MoneyMan(Sum, Tim, L_PRoll.src_Sheet);
  END;
 END {।};

 PUBLIC PROCEDURE ।();   (* 㬬஢ ⮬ ६*)
  VAR
   Sum: L_PRoll.tSum;
   Tim: L_PRoll.tTime;
 BEGIN
  GetDeltaToFitToAve(3, Sum, Tim, E_IsSummationSheet());
  IF Sum > 0 THEN
   _MoneyMan(Sum, Tim, L_PRoll.src_Sheet);
  END;
 END {।};

 PUBLIC PROCEDURE ।12();
  VAR
   Sum: L_PRoll.tSum;
   Tim: L_PRoll.tTime;
 BEGIN
  GetDeltaToFitToAve(12, Sum, Tim, 0);
  IF Sum > 0 THEN
   _MoneyMan(Sum, Tim, L_PRoll.src_Sheet);
  END;
 END {।12};

 PUBLIC PROCEDURE ।12();   (* 㬬஢ ⮬ ६*)
  VAR
   Sum: L_PRoll.tSum;
   Tim: L_PRoll.tTime;
 BEGIN
  GetDeltaToFitToAve(12, Sum, Tim, E_IsSummationSheet());
  IF Sum > 0 THEN
   _MoneyMan(Sum, Tim, L_PRoll.src_Sheet);
  END;
 END {।12};

 PUBLIC PROCEDURE ।();
 BEGIN
  AveCAve(PROCREF(Convert_AT2), 1, 3, Infl_On);
  MoneyMan(IndexedAverage() * MonTime * AvePayP.Percent / 100, MonTime);
 END {।};

 PUBLIC PROCEDURE ।();     (* 㬬஢ ⮬ ६*)
 BEGIN
  IF E_IsSummationSheet() THEN
   AveCAve(PROCREF(Convert_AT1), 0, 3, Infl_On);
   MoneyMan(IndexedAverage() * MonTime * AvePayP.Percent / 100, MonTime);
  ELSE
   ।();
  END;
 END {।};

 PUBLIC PROCEDURE ।12();
 BEGIN
  AveCAve(PROCREF(Convert_AT2), 1, 12, Infl_On);
  MoneyMan(IndexedAverage() * MonTime * AvePayP.Percent / 100, MonTime);
 END {।12};

 PUBLIC PROCEDURE ।12();     (* 㬬஢ ⮬ ६*)
 BEGIN
  IF E_IsSummationSheet() THEN
   AveCAve(PROCREF(Convert_AT1), 0, 12, Infl_On);
   MoneyMan(IndexedAverage() * MonTime * AvePayP.Percent / 100, MonTime);
  ELSE
   ।12();
  END;
 END {।12};

 PUBLIC PROCEDURE ।12();     (* 㬬஢ ⮬ ६ ।  *)
 BEGIN
  IF E_IsSummationSheet() THEN
   AveCAve(PROCREF(Convert_AT1), 0, 12, Infl_On);
   MoneyMan(IndexedAverage() * MonTime * AvePayP.Percent / 100, MonTime);
  ELSIF E_IsBaseSheet() THEN
   AveHldy(PROCREF(Convert_AT_Base1), 1, 12, Infl_On);
   MoneyMan(IndexedAverage() * MonDays * AvePayP.Percent / 100, MonTime);
  ELSE
   AveHldy(PROCREF(Convert_AT0), 1, 12, Infl_On);
   MoneyMan(IndexedAverage() * MonDays * AvePayP.Percent / 100, MonTime);
  END;
 END {।12};

 PUBLIC PROCEDURE 쭒();
 BEGIN
  AveSick(1, sick_Ordinary);
  MoneyMan(LimitAverage(1, 0, sick_Ordinary) * MonDays, MonTime);
 END {쭒};

 PUBLIC PROCEDURE 쭁();
 BEGIN
  L_General.Assert(AvePay.Period >= 01\09\2007, "ࠢ '쭁'    09.2007");
  AveSick(1, sick_Pregnancy);
  MoneyMan(LimitAverage(1, 0, sick_Pregnancy) * MonDays, MonTime);
 END {쭁};

 PRIVATE PROCEDURE InformPrevSickList(_DaysByFirm: NUMERIC[0]);
 BEGIN
  IF _DaysByFirm=0 THEN
   L_StdFrm.Choice(" ।騩 쭨 |"+
                   "   । । ");
  END;
 END {InformPrevSickList};

 PRIVATE PROCEDURE GetFirstDaysByFirm(PlnDaysByFirm: NUMERIC[0]): STRING[];
  VAR
   pi: SCAL[10];
 BEGIN
  InformPrevSickList(PlnDaysByFirm);
  IF    PlnDaysByFirm = 0 THEN
   pi:=0;
  ELSIF PlnDaysByFirm = 2 THEN
   pi:=1;
  ELSIF PlnDaysByFirm = 3 THEN
   L_General.Assert(AvePay.StartD >= 01\01\2011, "    ࠡ⮤⥫ ਬ  01.2011");
   pi:=3;
  ELSE
   L_General.CallUs();
  END;
  RETURN L_Str.PoolItem(P_AveP.ft_FirstDaysByFirm_Pool, pi);
 END {GetFirstDaysByFirm};

 PRIVATE PROCEDURE DaysByFirm(): NUMERIC[0];
 BEGIN
  IF AvePay.StartD >= 01\01\2011 THEN
   RETURN 3;
  ELSE
   RETURN 2;
  END;
 END {DaysByFirm};

 PRIVATE PROCEDURE PartSick1(        First: SCAL[2];
                             VAR _T: L_PRoll.tTime;
                             VAR _D: NUMERIC[0]);
  VAR
   HasPrevSickList: SCAL[2];
   i,
   FctDaysByFirm,
   PlnDaysByFirm   : NUMERIC[0];
   PayMode         : P_AveP.tftPayMode;
   Limit,
   FirstDaysByFirm : STRING[];
   Year_0,
   Year_1          : P_AveP.tftYear;
 BEGIN
  IF ((ActPer - AvePay.StartD) >= DaysByFirm()) | ((AvePayP.StartD - AvePay.StartD) >= DaysByFirm()) THEN
   SETZERO(_T, _D);
   RETURN;
  END;
  HasPrevSickList:=0;
  PlnDaysByFirm:=0;
  IF First THEN
   HasPrevSickList:=L_AvePay.SickAvePayIsSequel();
   IF HasPrevSickList THEN
    PlnDaysByFirm:=0;
   ELSE
    PlnDaysByFirm:=DaysByFirm();
   END;
  END;
  P_AveP.Decode_Features(P_AveP.GetProValueSoft(AvePay.AvePay, P_AveP.P_Features), Limit, FirstDaysByFirm, Year_0, Year_1, PayMode);
  IF !FirstDaysByFirm THEN
   IF OCCURE(AvePPro) THEN
    P_AveP.Encode_Features(AvePPro.Value, Limit, GetFirstDaysByFirm(PlnDaysByFirm), Year_0, Year_1, PayMode);
   ELSE
    L_General.Assert(First, "  ᢮⢮ 㬥 "+L_Str.IntStr(P_AveP.P_Features));
    P_AveP.Add_Features(AvePay.AvePay, Limit, GetFirstDaysByFirm(PlnDaysByFirm), Year_0, Year_1, PayMode);
   END;
  ELSE
   FctDaysByFirm:=P_AveP.Get_ft_FirstDaysByFirm();
   IF ProcDo & ~StreamMode & (Store = +1) &
      (FctDaysByFirm # PlnDaysByFirm) & First THEN
    L_StdFrm.Choice(" ᢮⢠ 㬥 㪠 "+
                    L_Str.IntStr(FctDaysByFirm)+" "+Str.EnumObject(FctDaysByFirm, "||")+
                    "    ।|"+
                    L_Str.PoolItem("|", HasPrevSickList)+" ।騩 㬥|"+
                    ", ᫥ 㪠 "+
                    L_Str.IntStr(PlnDaysByFirm)+" "+Str.EnumObject(PlnDaysByFirm, "||"));
   END;
   PlnDaysByFirm:=FctDaysByFirm;
  END;

  FctDaysByFirm:=Math.Min(PlnDaysByFirm-PaidDaysByFirm, ActPerDayCount);
  SETZERO(_T, _D);
  i:=0;
  WHILE i<FctDaysByFirm DO
   INC(_T, DailyTime[i]);
   INC(_D, DailyDay [i]);
   IF ~First THEN
    INC(PaidDaysByFirm);  (*騥 , 騥    ।*)
   END;
   INC(i);
  END;
 END {PartSick1};

 PUBLIC PROCEDURE 쭒1();
  VAR
   _t: L_PRoll.tTime;
   _d: NUMERIC[0];
 BEGIN
  AveSick(1, sick_Ordinary);
  PartSick1(1, _t, _d);
  __MoneyMan(LimitAverage(1, 0, sick_Ordinary) * _d, _t, L_PRoll.src_AvePay, _d);
 END {쭒1};

 PUBLIC PROCEDURE 쭒2();
  VAR
   _t: L_PRoll.tTime;
   _d: NUMERIC[0];
 BEGIN
  (*AvePay.Average   ⮢  ࠢ 쭒1*)
  L_General.Assert(~!AvePay.Average, " । ।  | 襭 ᫥⥫쭮 ࠢ  ⮤");
  PartSick1(0, _t, _d);
  _t:=MonTime-_t;
  _d:=MonDays-_d;
  __MoneyMan(LimitAverage(0, 0, sick_Ordinary) * _d, _t, L_PRoll.src_AvePay, _d);
 END {쭒2};

 PUBLIC PROCEDURE 쭁();
 BEGIN
  AveSick(0, sick_Ordinary);
  IF AvePay.StartD >= 01\07\2011 THEN
   MoneyMan(LimitAverage(1, 1, sick_Ordinary) * MonDays, MonTime);
  ELSE
   MoneyMan(AvePay.Average * MonDays * AvePayP.Percent / 100, MonTime);
  END;
 END {쭁};

 PRIVATE PROCEDURE SumPerAvpENVD(ByMROT: SCAL[2]; Print: SCAL[2]): LIKE(Money.Sum);
  VAR
   _Average: FLOAT(*!!!*);
 BEGIN
  IF ByMROT THEN
   _Average:=L_OwnData.ODMROT(ActPer)/L_DatTim.MonthLen(ActPer);
  ELSE
   _Average:=AvePay.Average;
  END;
  RETURN Math.Min(LimitAverage(Print, 0, sick_Ordinary), _Average) * MonDays;
 END {SumPerAvpENVD};

 PUBLIC PROCEDURE 쭅1();
 BEGIN
  L_General.Assert(AvePay.StartD < 01\01\2010, "  ᯥ. ⥬     01\2010");
  AveSick(1, sick_Ordinary);
  MoneyMan(SumPerAvpENVD(1, 1), MonTime);
 END {쭅1};

 PUBLIC PROCEDURE 쭅2();
  VAR
   _Sum: LIKE(Money.Sum);
 BEGIN
  L_General.Assert(AvePay.StartD < 01\01\2010, "  ᯥ. ⥬     01\2010");
  (*AvePay.Average   ⮢  ࠢ 쭅1*)
  L_General.Assert(~!AvePay.Average, " । ।  | 襭 ᫥⥫쭮 ࠢ  ⮤");
  _Sum:=SumPerAvpENVD(0, 0) - SumPerAvpENVD(1, 1);
  IF _Sum > 0 THEN
   MoneyMan(_Sum, 0);
  END;
 END {쭅2};

 PRIVATE PROCEDURE _(s: NUMERIC[0]; PerNum: NUMERIC[0]);
 BEGIN
  IF E_IsSummationSheet() & ~E_Cancel_13_4() THEN
   AveCAve(PROCREF(Convert_AT1), 0, PerNum, Infl_On);
   MonTime:=MonDays*40/7;
   MoneyMan(s * IndexedAverage() * MonTime * AvePayP.Percent / 100, MonTime);
  ELSIF E_IsBaseSheet() THEN
   AveHldy(PROCREF(Convert_AT_Base), 0, PerNum, Infl_On);
   MoneyMan(s * IndexedAverage() * MonDays * AvePayP.Percent / 100, MonTime);
  ELSE
   AveHldy(PROCREF(Convert_AT0), 1, PerNum, Infl_On);
   MoneyMan(s * IndexedAverage() * MonDays * AvePayP.Percent / 100, MonTime);
  END;
 END {_};

 PUBLIC PROCEDURE ();
 BEGIN
  _(+1, 3);
 END {};

 PUBLIC PROCEDURE ();
 BEGIN
  _(-1, 3);
 END {};

 PUBLIC PROCEDURE 12();
 BEGIN
  _(+1, 12);
 END {12};

 PUBLIC PROCEDURE 12();
 BEGIN
  _(-1, 12);
 END {12};

END.
