(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose      ௫,   ⮢
%Purpose     ᮪ ࠡ⭨  믮 ⮬
%Type        operation, report
%Specific    SYS
%Modified    22.05.2014 11:52:26 POLAK\San
%Environment
*)

 MODULE A_CalcDed [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_PRoll, L_Staff, L_Print, L_Way, L_AcsPnt,
        L_AFM, L_PDoc, L_OwnData, L_APtm, L_Str, L_StdFrm, L_XDoc,
        E_PRoll, L_Env, FIO, L_bp;

 PRIVATE VAR
  Cond       : STRING[30];
  curMPacket : LIKE(TimeKeep.MPacket);
  curTimeKeep: LIKE(TimeKeep.TimeKeep);
  SaveCDate  : DATE;
  AmountPrb  : NUMERIC[0];
  Title,
  ToSurveyCmd: STRING[];

(*
$P { Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Title, C, ""
Memo.gl_mb(), L, "N.y"
@
#################################################################################################################### ########## #####
=#####===============================================================================================================================
|###################################################################################################################################|
|                                   ⭨,    믮  ௫  #######                                   |
|-----------------------------------------------------------------------------------------------------------------------------------|
|. |                  |             |ᠭ ஡                                                               |
}
*)

(*
$P { Dlm:
@
|-----|---------------------|----------------------|--------------------------------------------------------------------------------|
}
*)

(*
$P { Line:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|#####|#####################|######################|################################################################################|
}
*)

(*
$P { Bot:
SYSDATE(), C, "D.N.y"
SYSTIME(), C, "H:M"
@
=(c) Polak===========================================================================================================########## #####
}
*)

 PRIVATE PROCEDURE E_A_CalcDedCond_01(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PRoll.A_CalcDedCond_01);
  RETURN ~!Local & Local();
 END {E_A_CalcDedCond_01};

 PRIVATE PROCEDURE All(): SCAL[2];
 BEGIN
  RETURN 1;
 END {All};

 PRIVATE PROCEDURE A_CalcDedCond_LeaveOnly(): SCAL[2];
 BEGIN
  RETURN ~!Staff.EndDate &
         ((L_DatTim.Per(Staff.EndDate) >= L_DatTim.Per(SaveCDate)) & (L_DatTim.Per(Staff.EndDate) <= L_DatTim.Per(SYSDATE())));
 END {A_CalcDedCond_LeaveOnly};

 PRIVATE PROCEDURE TimeKeepCond(): SCAL[2];
 BEGIN
  HISTCONF(Memo.gl_me(), Staff, StaffLog);
  WHILE OCCURE(StaffLog) DO
   CONFORM(StaffLog, Officer);
   IF (Officer.TimeKeep = curTimeKeep) &
      L_Staff.OrderInMonth(Memo.gl_mb()) THEN
    RETURN 1;
   END;
   PREV(StaffLog);
  END;
  RETURN 0;
 END {TimeKeepCond};

 PRIVATE PROCEDURE StaffMustBeCountUp(): SCAL[2];
 BEGIN
  IF L_PRoll.curCountUp = L_PRoll.cu_strmUpToDate THEN
   RETURN ~L_PRoll.IsDedD_OnDate(Memo.gl_cd());
  ELSE
   RETURN ~L_PRoll.IsDedD_AP(Memo.gl_mb());
  END;
 END {StaffMustBeCountUp};

 PRIVATE PROCEDURE ProcessSingeTSN();
 BEGIN
  CALL(CalcDed.CountUp_Stream());
 END {ProcessSingeTSN};

 PRIVATE PROCEDURE MakeOneTSN(wPrint: SCAL[2]);
  VAR
   rem: L_General.tRidgeExecuteMode;
 BEGIN
  CONFORM(Staff, Man);
  PROMPT(Staff.TSN);
  IF L_Staff.IsBegan(Memo.gl_mb()) THEN
   IF ^Cond() THEN
    IF StaffMustBeCountUp() THEN
     IF L_PRoll.curCountUp = L_PRoll.cu_strmFinal THEN
      rem:=L_General.rem_SameTRN;
     ELSE
      rem:=L_General.rem_Isolated;
     END;
     TRY
      L_General.RidgeExecute("Staff", PROCREF(ProcessSingeTSN), rem);
     EXCEPT
     ON Exc: Exc_Root DO
      INC(AmountPrb);
      IF L_PRoll.curCountUp = L_PRoll.cu_strmFinal THEN
       L_General.Error(" ⠭  ࠡ⭨ " + Staff.TSN +
                       "||" + ": ᫥ ।⥫쭮 믮  ");
      ELSE
       RAISE();
      END;
     END; (* TRY *)
    END;
    IF wPrint THEN
     CONFORM(Staff, Man);
     CALL(SMPrint.SMPrint_Stream());
    END; (* IF ~IsDedD() *)
   END; (* IF Cond ... *)
  END; (* IF IsBegan(Memo.gl_mb()) ... *)
 END {MakeOneTSN};

(*
$P { BadSL_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_mb(), R, "N.y"
@
################################################################# ########## #####
=#####============================================================================
|                       襭  ௫  #######                     |
|--------------------------------------------------------------------------------|
|. |  ⢮                                    | ⠭    |
|-----|--------------------------------------------------------|-----------------|
}

$P { BadSL_Line:
Staff.TSN, L, ""
Man.Name, L, ""
?, L, ""
@
|#####|########################################################|#################|
}

$P { BadSL_Bot:
@
=(c) Polak========================================================================
}
*)

 PUBLIC PROCEDURE NotDoneList();
  CONST
   RepName = "BadSL";
  VAR
   Msg: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, BadSL_Top, RepName);

IF L_General.IsAcceptableProcessorVersion(14254090) THEN
  SELECT(Staff, TSN);
  FOR_EACH Staff DO
   PROMPT(Staff.TSN);
   IF L_Staff.IsBegan(Memo.ud_mb()) THEN
    IF ~L_PRoll.IsDedD() THEN
     CONFORM(Staff, Man);
     IF    ~L_PRoll.IsPrvD() THEN Msg:="  ";
     ELSIF ~L_PRoll.IsAveD() THEN Msg:=" 㬥⠬";
     ELSIF ~L_PRoll.IsShtD() THEN Msg:=" ⠡";
     ELSIF ~L_PRoll.IsDedD() THEN Msg:="ঠ";
     END;
     MAKEPART(R, BadSL_Line, Msg);
    END;
   END;
  END; (* FOR_EACH *)
ELSE
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Staff.IsBegan(Memo.ud_mb()) THEN
    IF ~L_PRoll.IsDedD() THEN
     CONFORM(Staff, Man);
     IF    ~L_PRoll.IsPrvD() THEN Msg:="  ";
     ELSIF ~L_PRoll.IsAveD() THEN Msg:=" 㬥⠬";
     ELSIF ~L_PRoll.IsShtD() THEN Msg:=" ⠡";
     ELSIF ~L_PRoll.IsDedD() THEN Msg:="ঠ";
     END;
     MAKEPART(R, BadSL_Line, Msg);
    END;
   END;
   NEXT(Staff);
  END;
END;
  MAKEPART(R, BadSL_Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {NotDoneList};

 PRIVATE PROCEDURE intMakeErrorPart(ErrorDescription: STRING[]);
  VAR
   curTSN,
   curManName,
   curPostName : STRING[];
   i           : NUMERIC[0];
   StrArr      : STRING[][20];
 BEGIN
  HISTCONF(Memo.gl_me(), Staff, Man, Post);
  curTSN     :=Staff.TSN;
  curManName :=L_Str.ShortName(Man.Name);
  curPostName:=Post.Name;
  MAKEPART(T, Dlm);
  L_StdFrm.PrepareLongStringForASLPART(ErrorDescription, StrArr, 80);
  i:=0;
  WHILE ~!StrArr[i] DO
   MAKEPART(T, Line, curTSN, curManName, curPostName, StrArr[i]);
   SETEMPTY(curTSN, curManName, curPostName);
   INC(i);
  END;
 END {intMakeErrorPart};

 PRIVATE PROCEDURE CalculateSalary(RepName: STRING[]);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  AmountPrb:=0;

  OPENREP(T, L_General.NameConnection(RepName), Create);
  MAKEPART(T, Top, RepName);
  SELECT(Staff, TSN);

  WHILE OCCURE(Staff) DO
   TRY
    MakeOneTSN(0);
   EXCEPT
   ON Exc: Exc_Root DO
    INC(AmountPrb);
    L_XDoc.sl_AddItem(L_XDoc.curXDocId(L_XDoc.xdt_Staff), Staff.TSN + " " + Staff.Name);
    intMakeErrorPart(Exc.Description);
   END; (* TRY *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  MAKEPART(T, Bot);
  CLOSEREP(T);
 END {CalculateSalary};

 PRIVATE PROCEDURE tst_RWayS();
 BEGIN
  IF SELECT(RWayS, Done, 0) & (RWayS.Date <= Memo.ud_me()) THEN
   L_XDoc.tst_Check(L_XDoc.curXDocId(L_XDoc.xdt_RWayS), RWayS.Status = L_Way.rwsStat_Rated, 0);
  END;
 END {tst_RWayS};

 PRIVATE PROCEDURE MakeOneMPck();
 BEGIN
  NARROWSEL(_MPck, _MPck);
  WHILE OCCURE(_MPck) DO
   L_General.CallUs(SEARCH(Staff, TSN, _MPck._TSN));
   MakeOneTSN(1);
   NEXT(_MPck);
  END; (* WHILE OCCURE(_MPck) ... *)
 END {MakeOneMPck};

 PRIVATE PROCEDURE StartNewRep(Start: SCAL[2]);
  VAR
   SufRep,
   RepName: STRING[];
 BEGIN
  IF Start THEN
   IF !curMPacket THEN
    IF L_PRoll.E_PrintMoneyForStaff(Memo.gl_mb(), 0) = 1 THEN
     SufRep:=_MPck._MPck;
    ELSE
     SufRep:="00";
    END;
   ELSE
    SufRep:=curMPacket;
   END;
   RepName:=FIO.FirstPath(L_General.rfn_byMonth("Money_" + SufRep, Memo.gl_mb()), "rep");
   OPENREP(Mon, RepName, Create);
   ToSurveyCmd:=L_Str.AddStrDlm(ToSurveyCmd, ", ") + 'Survey, "' + RepName + '"';
   L_Print.SetPageNbr(0);
  END;
 END {StartNewRep};

 PRIVATE PROCEDURE CloseNewRep(Close : SCAL[2]);
 BEGIN
  IF Close THEN
   CLOSEREP(Mon);
  END;
 END {CloseNewRep};

 PUBLIC PROCEDURE CountUp_All();
  CONST
   bpId = "NSh01";
 BEGIN
  Cond:="All";
  L_PRoll.curCountUp:=L_PRoll.cu_strmFull;
  Title:=" ௫   ( ࠡ⭨)";
  L_bp.Begin(bpId, Title, L_bp.t_Prc_wF3, L_General.tc_inMonth);
  CalculateSalary(bpId);
  L_bp.End();
 END {CountUp_All};

 PUBLIC PROCEDURE CountUp_AllOnDate();
  CONST
   bpId = "NSh02";
 BEGIN
  L_bp.Begin(bpId, " ௫   ( ࠡ⭨)", L_bp.t_Prc_wF3, L_General.tc_onDate);
  Cond:="All";
  L_PRoll.curCountUp:=L_PRoll.cu_strmUpToDate;
  Title:=" ௫  " + L_DatTim.DateStr(Memo.ud_cd()) + " ( ࠡ⭨)";
  L_StdFrm.Question(Title);
  L_General.Assert(L_DatTim.Per(Memo.ud_cd()) >= L_DatTim.Per(SYSDATE()),
                   "    襤訩   ந");
  CalculateSalary(bpId);
  L_bp.End();
 END {CountUp_AllOnDate};

 PUBLIC PROCEDURE CountUp_LeaveOnly();
 BEGIN
  Cond:="A_CalcDedCond_LeaveOnly";
  L_PRoll.curCountUp:=L_PRoll.cu_strmFull;
  SaveCDate:=Memo.gl_cd();
  Title:=" ࠡ⭨, 㢮  ਮ  "+L_DatTim.PeriodStr(SaveCDate) + "  "+L_DatTim.PeriodStr(SYSDATE());
  Memo.gl_SetCurDate(SYSDATE());
  L_XDoc.sl_Init(Title);
  CalculateSalary("NSh03");
  Memo.gl_SetCurDate(SaveCDate);
  IF AmountPrb > 0 THEN
   L_StdFrm.RedInform(" 믮  ௫ 㢮");
   L_General.HaltAndBrowseLastReport(EMPTYOF(Exc_Root));
  END;
 END {CountUp_LeaveOnly};

 PUBLIC PROCEDURE CountUp_TimeKeep();
 BEGIN
  Cond:="TimeKeepCond";
  L_PRoll.curCountUp:=L_PRoll.cu_strmFull;
  L_General.Assert(ACCESS(TimeKeep), " ⠭ ⠡騪");
  Title:=" ࠡ⭨  ⠡騪 "+TimeKeep.TimeKeep + " "+TimeKeep.Name;
  curTimeKeep:=TimeKeep.TimeKeep;
  L_XDoc.sl_Init(Title);
  CalculateSalary("NSh03");
  L_XDoc.sl_Done();
 END {CountUp_TimeKeep};

 PUBLIC PROCEDURE CountUp_Selective();
 BEGIN
  Cond:="E_A_CalcDedCond_01";
  L_PRoll.curCountUp:=L_PRoll.cu_strmFull;
  Title:=" ࠡ⭨ (롮筮)";
  L_XDoc.sl_Init(Title);
  CalculateSalary("NSh04");
  L_XDoc.sl_Done();
 END {CountUp_Selective};

 PUBLIC PROCEDURE CloseMonth();
 BEGIN
  L_General.Assert(SYSDATE() >= L_PRoll.GetFinalCalcDate(Memo.ud_mb()),
                   "⨥    믮 "+L_DatTim.DateStr(L_PRoll.GetFinalCalcDate(Memo.ud_mb()))+"  ");
  Cond:="All";
  AmountPrb:=0;
  L_PRoll.curCountUp:=L_PRoll.cu_strmFinal;
  L_StdFrm.Choice("⨥  - " + L_DatTim.PeriodStr(Memo.ud_mb()));
  L_AcsPnt.PassAccessPoint(0000025);
  L_APtm.MonthAccess(Memo.ud_mb());
  REPLACE(Month); (* ⠢ ஢ *)
  tst_RWayS();
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   MakeOneTSN(0);
   SELECT(PDocList, TSN, , Staff.TSN);
   SRCINSEL(PDocList, GE, , Memo.ud_mb());
   WHILE OCCURE(PDocList) & (PDocList.PDocDate <= Memo.ud_me()) DO
    CONFORM(PDocList, PDoc);
    IF L_PDoc.IsSalPDoc() THEN
     L_XDoc.tst_Check(L_XDoc.curXDocId(L_XDoc.xdt_PDoc), PDoc.Status#L_PDoc.st_Prepared, PDoc.Done);
    END;
    NEXT(PDocList);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  L_APtm.MonthAccess(Memo.ud_mb());
  CALL(Month.CloseMonth(L_APtm.system_Salary));
 END {CloseMonth};

 PRIVATE PROCEDURE intPrint();
  VAR
   MainTSN    : LIKE(Staff.TSN);
   MainMPacket: LIKE(TimeKeep.MPacket);
 BEGIN
  AmountPrb:=0;
  L_AFM.MakeIndex("_MPck", "_MPck    : LIKE(TimeKeep.MPacket);"+
                           "MainTSN  : LIKE(Staff.TSN);"+
                           "AfterMain: SCAL[2];"+
                           "_TSN     : LIKE(Staff.TSN)");

  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(" "+Staff.TSN);
   IF L_Staff.IsBegan(Memo.ud_mb()) & L_Env.RealTSN(Staff.TSN) THEN
    MainTSN    :=L_PDoc.GetStaffMainTSN(Staff.TSN, Memo.ud_me());
    MainMPacket:=L_PDoc.GetStaffMPacket(Memo.ud_me());
    IF !curMPacket | (MainMPacket = curMPacket) THEN
     _MPck._MPck    :=MainMPacket;
     _MPck.MainTSN  :=MainTSN;
     _MPck.AfterMain:=Staff.TSN # MainTSN;
     _MPck._TSN     :=Staff.TSN;
     INSERT(_MPck);
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)

  ToSurveyCmd:="";
  L_PRoll.curCountUp:=L_PRoll.cu_strmFinal;

  SELECT(_MPck, _MPck);
  IF OCCURE(_MPck) THEN
   StartNewRep(~L_PRoll.E_PrintMoneyForStaff(Memo.gl_mb(), 0));
   WHILE OCCURE(_MPck) DO
    StartNewRep(L_PRoll.E_PrintMoneyForStaff(Memo.gl_mb(), 0));
    MakeOneMPck();
    CloseNewRep(L_PRoll.E_PrintMoneyForStaff(Memo.gl_mb(), 0));
    NEXTINEXTENDEDSEL(_MPck, _MPck);
   END; (* WHILE OCCURE(_MPck)... *)
   CloseNewRep(~L_PRoll.E_PrintMoneyForStaff(Memo.gl_mb(), 0));
  END; (* IF OCCURE(_MPck) ... *)

  L_AFM.AF_PurgeTemp("_MPck");
  IF ~!ToSurveyCmd THEN
   LIKEMENU(^ToSurveyCmd);
  ELSE
   L_StdFrm.Inform("   ࠡ⭨");
  END;
 END {intPrint};

 PUBLIC PROCEDURE Print_All();
 BEGIN
  Cond:="All";
  SETEMPTY(curMPacket);
  intPrint();
 END {Print_All};

 PUBLIC PROCEDURE Print_MPacket();
 BEGIN
  L_General.Assert(ACCESS(TimeKeep), " ⠭ ⠡騪");
  Cond:="All";
  curMPacket:=TimeKeep.MPacket;
  intPrint();
 END {Print_MPacket};

END.
