(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     ࠡ⪠  㬥⮢    
%Type        operation
%Specific    sys
%Modified    14.02.2014 16:33:56 POLAK\GAV
*)

 MODULE A_MDoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_OwnData, L_APtm, L_Events, L_MathR, L_StdFrm, L_AcsPnt, L_MDoc, L_XDoc,
        L_XObj, L_Pmnt, L_Fuel, L_Way, L_AFM, L_Str, L_JDoc, L_Acnt, L_AR, L_bp, L_iga,
        Str, SysLog, Math;

 PRIVATE CONST
  MsgLen = 79;

(*
$P{ MostTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
?, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|㬥       |    |C|O|ਬ砭                                                                     |
|---------------|--------|-|-|-------------------------------------------------------------------------------|
}
*)

(*
$P { Line:
L_XDoc.XDocStr(L_XDoc.XDocId(_AMDc.XDocType, _AMDc.XDocKind, _AMDc.XDoc)), L, ""
_AMDc.Date, L, "D.N.Y"
_AMDc.Status, L , "||"
_AMDc.Done, L, " |"
?, L, ""
@
|###############|########|#|#|###############################################################################|
}
*)

(*
$P { LineAdd:
?, L, ""
@
|               |        | | |###############################################################################|
}
*)

(*
$P{ MsgLine:
?, C, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
}
*)

(*
$P { PageBot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE IsOldPreparedMDoc(): SCAL[2];
 BEGIN
  IF ~L_General.IsPolakSpecific() THEN
   RETURN (MDoc.Status = L_MDoc.st_Prepared) &
          (MDoc.Date < L_DatTim.Per(SYSDATE()));
  ELSE
   RETURN 0;
  END;
 END {IsOldPreparedMDoc};

 PRIVATE PROCEDURE IsOldPreparedJDoc(): SCAL[2];
 BEGIN
  IF ~L_General.IsPolakSpecific() THEN
   RETURN (JDoc.Status = L_JDoc.st_Prepared) &
          (JDoc.Date < L_DatTim.Per(SYSDATE()));
  ELSE
   RETURN 0;
  END;
 END {IsOldPreparedJDoc};

 PRIVATE PROCEDURE Create__AMDc();
 BEGIN
  IF !DATABASE.Get().Tables("_AMDc") THEN
   CREATE_TABLE(_AMDc, , "⮪ ࠡ⪨/⪠ 㬥⮢");
   CREATE_FIELD(_AMDc, XDocType, L_XDoc.tXDocType,    , , , " 㬥");
   CREATE_FIELD(_AMDc, XDocKind, LIKE(MDoc.MDocKind), , , , " 㬥");
   CREATE_FIELD(_AMDc, XDoc,     LIKE(MDoc.MDoc),     , , , " 㬥");
   CREATE_FIELD(_AMDc, Date,     LIKE(MDoc.Date),     , , , " 㬥");
   CREATE_FIELD(_AMDc, Msg,      STRING[256],         , , , "ਬ砭");
   CREATE_FIELD(_AMDc, Status,   LIKE(MDoc.Status),   , , , "ﭨ");
   CREATE_FIELD(_AMDc, Done,     LIKE(MDoc.Done),     , , , "ࠡ⠭");
   CREATE_FIELD(_AMDc, DoneDTS,  L_XDoc.tDoneDTS,     , , , "/६ ࠡ⪨");
   CREATE_FIELD(_AMDc, Success,  SCAL[2],             , "0", , " ⪠/ࠡ");
 
   CREATE_INDEX(_AMDc, XDoc,    UNIQUE, , , XDocType, XDocKind, XDoc);
   CREATE_INDEX(_AMDc, Date,    PLURAL, , , Date, DoneDTS);
   CREATE_INDEX(_AMDc, Success, UNIQUE, , , Success, Date, DoneDTS, XDocType, XDocKind, XDoc);
 
   SET_VERSION_OF_TABLE(_AMDc, 000);
  END;
  L_AFM.CreateTemp("_AMDc");
 END {Create__AMDc};

 PRIVATE PROCEDURE intAdd_AMDc(_XDocType: L_XDoc.tXDocType; Msg: STRING[]; _Success: SCAL[2]);
 BEGIN
  L_General.CLEAR("_AMDc");
  _AMDc.XDocType:=_XDocType;
  IF    _XDocType = L_XDoc.xdt_MDoc THEN
   _AMDc.XDocKind:=MDoc.MDocKind;
   _AMDc.XDoc    :=MDoc.MDoc;
   _AMDc.Date    :=MDoc.Date;
   _AMDc.Msg     :=Msg;
   _AMDc.Status  :=MDoc.Status;
   _AMDc.Done    :=MDoc.Done;
   _AMDc.DoneDTS :=MDoc.DoneDTS;
  ELSIF _XDocType = L_XDoc.xdt_JDoc THEN
   _AMDc.XDocKind:=JDoc.JDocKind;
   _AMDc.XDoc    :=JDoc.JDoc;
   _AMDc.Date    :=JDoc.Date;
   _AMDc.Msg     :=Msg;
   _AMDc.Status  :=JDoc.Status;
   _AMDc.Done    :=JDoc.Done;
   _AMDc.DoneDTS :=L_JDoc.GetJDocDoneDTS();
  END;
  _AMDc.Success :=_Success;
  INSERT(_AMDc);
 END {intAdd_AMDc};

 PRIVATE PROCEDURE Add_ErrAMDc(_XDocType: L_XDoc.tXDocType; Msg: STRING[]);
 BEGIN
  intAdd_AMDc(_XDocType, Msg, 0);
 END {Add_ErrAMDc};

 PRIVATE PROCEDURE Add_AMDc(_XDocType: L_XDoc.tXDocType);
 BEGIN
  intAdd_AMDc(_XDocType, "", 0);
 END {Add_AMDc};

 PRIVATE PROCEDURE XDocClearError(trgXDocId: L_XDoc.tXDocId);
 BEGIN
  L_General.Error(" ६    ⠢ 㬥 "+L_XDoc.XDocStr(trgXDocId)+"|"+
                  "  믮"+L_StdFrm.HR()+"室  楤  ");
 END {XDocClearError};

 PRIVATE VAR
  Clear_wRWayF: SCAL[2];

 PRIVATE PROCEDURE Clear_Docs(From: DATE; Through: SCAL[2]; CheckOnly: SCAL[2]);
  VAR
   savedMemoDate,
   UpTo: DATE;
 BEGIN
  savedMemoDate:=Memo.gl_cd();
  IF Through THEN
   UpTo:=L_DatTim.MAXDATE();
  ELSE
   UpTo:=L_DatTim.MonthEnd(From);
  END;

  IF Clear_wRWayF & L_Fuel.TanksIsStockInMonth(Memo.gl_mb()) & ~CheckOnly THEN
   SETSEL(RWayS, Date);
   SRCINSEL(RWayS, GE, , From);
   WHILE OCCURE(RWayS) & (RWayS.Date <= UpTo) DO
    PROMPT(" "+RWayS.RWayS+ "  "+L_DatTim.DateStr(RWayS.Date));
    IF RWayS.Done THEN
     TRY [TRANSACTION(TRANSACTION_SLAVE2)]
      CALL(RWayS, L_Events.md_StreamMakeUnDone);
     EXCEPT
     END; (* TRY *)
    END;
    L_General.CallUs(~RWayS.Done);
    CONFORM(RWayS, RWayF);
    WHILE OCCURE(RWayF) DO
     IF (RWayS.Status=L_Way.rwsStat_Given) | !RWayF.RemEntr(*sic!*) | ((RWayF.RemExit=0)&(RWayF.RemEntr=0)) THEN
      REMOVE(RWayF);
     ELSE
      SETZERO(RWayF.FuelTake, RWayF.FuelRet);
      REPLACE(RWayF);
      NEXT(RWayF);
     END;
    END;
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
  END;

  SETSEL(MDoc, Date);
  SRCINSEL(MDoc, GE, , From);
  WHILE OCCURE(MDoc) & (MDoc.Date <= UpTo) DO
   PROMPT(L_MDoc.GetMDocStrNbr());
   IF L_DatTim.Per(MDoc.Date) # Memo.gl_mb() THEN
    Memo.gl_SetCurDate(MDoc.Date);
   END;
   IF MDoc.Done | ((MDoc.doneRWF = 1) & Clear_wRWayF) THEN
    IF ~CheckOnly THEN
     MDoc.Done:=0;
     IF Clear_wRWayF THEN
      MDoc.doneRWF:=0;
     END;
     REPLACE(MDoc);
    ELSE
     XDocClearError(MDoc.XDocId);
    END;
   END; (* IF MDoc.Done ... *)
   IF ~CheckOnly THEN
    L_XObj.ClearXDocApr(MDoc.XDocId, Memo.gl_mb());
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc)... *)

  SELECT(JDocKind, JDocKind);
  WHILE OCCURE(JDocKind) DO
   IF (JDocKind.JDocKind = L_JDoc.jd_Manual) | (JDocKind.JDocKind = L_JDoc.jd_MDoc ) |
      (JDocKind.JDocKind = L_JDoc.jd_Dfrls ) | (JDocKind.JDocKind = L_JDoc.jd_Distr) |
      (JDocKind.JDocKind = L_JDoc.jd_RWayS ) THEN
    SETSEL(JDoc, JDKDate, JDocKind.JDocKind);
    SRCINSEL(JDoc, GE, , From);
    WHILE OCCURE(JDoc) & (JDoc.Date <= UpTo) DO
     PROMPT(L_JDoc.GetJDocStrNbr());
     IF L_DatTim.Per(JDoc.Date) # Memo.gl_mb() THEN
      Memo.gl_SetCurDate(JDoc.Date);
     END;
     IF JDoc.Done THEN
      IF ~CheckOnly THEN
       JDoc.Done :=0;
       REPLACE(JDoc);
      ELSE
       XDocClearError(JDoc.XDocId);
      END;
     END; (* IF JDoc.Done ... *)
     IF ~CheckOnly THEN
      L_XObj.ClearXDocApr(JDoc.XDocId, Memo.gl_mb());
     END;
     NEXT(JDoc);
    END; (* WHILE OCCURE(JDoc)... *)
   ELSE
    L_General.CallUs(JDocKind.JDocKind = L_JDoc.jd_PDoc);
   END;
   NEXT(JDocKind);
  END; (* WHILE OCCURE(JDocKind) ... *)
  Memo.gl_SetCurDate(savedMemoDate);
 END {Clear_Docs};

 PRIVATE PROCEDURE Clear_XApport(Through: SCAL[2]);
  VAR
   SourcesToClear: SCAL[2][100];
 BEGIN
  SETZERO(SourcesToClear);
  SourcesToClear[L_XObj.src_MDoc]  :=1;
  SourcesToClear[L_XObj.src_KAMDoc]:=1;
  SourcesToClear[L_XObj.src_JDoc]  :=1;

  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Math,     L_XObj.s_Math,     SourcesToClear, Through);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_KeyAss,   L_XObj.s_KeyAss,   SourcesToClear, Through);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Global,   L_XObj.s_Payments, SourcesToClear, Through);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Contract, L_XObj.s_Payments, SourcesToClear, Through);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_CostItem, L_XObj.s_Payments, SourcesToClear, Through);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Man,      L_XObj.s_Payments, SourcesToClear, Through);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Staff,    L_XObj.s_Payments, SourcesToClear, Through);
 END {Clear_XApport};

 PUBLIC PROCEDURE Clear();
  VAR
   PerB,
   PerE     : DATE;
   Through  : SCAL[2];
   newXDocId: L_XDoc.tXDocId;
 BEGIN
  L_AR.CheckDatabaseTransparency();
  L_AcsPnt.PassAccessPoint(0000020);
  PerB:=Memo.ud_mb();
  IF L_XDoc.AskForXDocProceed(L_XDoc.pm_Clear, "⮢ 㬥", L_MDoc.E_NeedMDocProceedQueueControl(PerB)) THEN
   PerE:=L_DatTim.Per(SYSDATE());
  ELSE
   PerE:=PerB;
  END;
  APP.Get().NewPrompt("   ਮ  " + L_DatTim.PeriodStr(PerB) + "  " + L_DatTim.PeriodStr(PerE));
  SysLog.Mark("MDoc", L_DatTim.PeriodStr(PerB)+" : "+" ⮢ 㬥⮢ ( " + L_DatTim.PeriodStr(PerE) + ")");
  L_MathR.CheckMDocProceedAllowed(L_MathR.mathk_Math);
  L_MathR.CheckMDocProceedAllowed(L_MathR.mathk_KeyAs);
  L_APtm.ANYSystem_CheckClcPer(L_APtm.system_Payments);
  Clear_wRWayF:=0;
  IF L_Fuel.TanksIsStockInMonth(PerE) THEN
   STDFORM(L_StdFrm.sf_Choice( "%########################################%" +
                              "|" +
                              "|  %###################################%   " +
                              "|  %###################################%   ",
                              "%,4AO%AM%AM"),
                             "  ਠ ",
                             CHOICE,
                             1,
                             "  䨪樨  | ",
                             Clear_wRWayF,
                             "   ॡ",
                             "।⥫쭮 믮  ");
  ELSE
   Clear_wRWayF:=1; (*   *)
  END;

  Through:=PerE>PerB;
  Clear_Docs(PerB, Through, 0);
  Clear_XApport(Through);
  Clear_Docs(PerB, Through, 1); (* ஢塞,  뫮  ⠢   襫  *)
 END {Clear};

 PRIVATE PROCEDURE intCountUpInit(From, UpTo: DATE; Done: SCAL[2]; RepName, AddMsg: STRING[]);
  VAR
   HeaderStr: STRING[];
 BEGIN
  HeaderStr:=" 㤠 " + L_Str.PoolItem("⪠|ࠡ", Done) + " ⮢ 㬥" +
             "  ਮ  " + L_DatTim.PeriodStr(From) + "  " + L_DatTim.PeriodStr(UpTo);
  L_XDoc.sl_Init(HeaderStr);
  Create__AMDc();
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, MostTop, RepName, HeaderStr, AddMsg);
 END {intCountUpInit};

 PRIVATE PROCEDURE CountUpInit(VAR From, UpTo: DATE; Done: SCAL[2]; RepName, AddMsg: STRING[]);
  VAR
   pm : L_XDoc.tProceedManner;
   Msg: STRING[];
 BEGIN
  L_General.Assert(Memo.ud_mb() <= SYSDATE(), L_DatTim.PeriodStr(Memo.ud_mb()) + "   㯨");

  From:=Memo.ud_mb();
  IF L_General.BatchExecution_IsRunning() THEN
   UpTo:=L_DatTim.MonthEnd(SYSDATE());
  ELSE
   IF Done THEN
    pm:=L_XDoc.pm_Proceed;
   ELSE
    pm:=L_XDoc.pm_Backtracking;
   END;
   Msg:="⮢ 㬥";
   IF ~!AddMsg THEN
    Msg:=Msg + "|" + AddMsg;
   END;
   IF L_XDoc.AskForXDocProceed(pm, Msg, L_MDoc.E_NeedMDocProceedQueueControl(From)) THEN
    UpTo:=L_DatTim.MonthEnd(SYSDATE());
    IF ~!L_bp.getCurId() THEN
     L_bp.oncretizeBPName(" ( " + L_DatTim.PeriodStr(UpTo) + ")");
    END;
   ELSE
    UpTo:=Memo.ud_me();
   END;
  END;

  intCountUpInit(From, UpTo, Done, RepName, AddMsg);
 END {CountUpInit};

 PRIVATE PROCEDURE CountUpPrint(Exc: Exc_Root);
  VAR
   i,
   TotalErrorCnt: NUMERIC[0];
   MsgArr       : STRING[MsgLen][5];
 BEGIN
  TotalErrorCnt:=0;
  IF SELECT(_AMDc, Success, 0) THEN
   WHILE OCCURE(_AMDc) DO
    Str.Format(MsgArr, _AMDc.Msg, MsgLen, LEFT);
    MAKEPART(R, Line, MsgArr[0]);
    i:=1;
    WHILE ~!MsgArr[i] & (i < RANGEOF(MsgArr)) DO
     MAKEPART(R, LineAdd, MsgArr[i]);
     INC(i);
    END;
    L_XDoc.sl_AddItem(L_XDoc.XDocId(_AMDc.XDocType, _AMDc.XDocKind, _AMDc.XDoc),
                      L_XDoc.XDocStr(L_XDoc.XDocId(_AMDc.XDocType, _AMDc.XDocKind, _AMDc.XDoc)) +
                      " " + L_DatTim.DateStr(_AMDc.Date));
    INC(TotalErrorCnt);
    NEXT(_AMDc);
   END; (* WHILE OCCURE(_AMDc) ... *)
  END;
  IF ~!Exc THEN
   MAKEPART(R, MsgLine, " ࢠ: " + Exc.Description);
  ELSIF (TotalErrorCnt = 0) THEN
   MAKEPART(R, MsgLine, "஡ 㬥⮢ ");
  END;
  MAKEPART(R, PageBot);
  CLOSEREP(R);
  IF ~!Exc THEN
   L_General.HaltAndBrowseLastReport(Exc);
  ELSIF (TotalErrorCnt = 0) THEN
   L_StdFrm.Inform("஡ 㬥⮢ ");
  ELSIF !L_bp.getCurId() THEN
   L_StdFrm.RedInform("  ஡ (. ⮪)");
   L_General.BrowseLastReport();
  END;
 END {CountUpPrint};

 PRIVATE PROCEDURE rep_JDoc_StreamMakeDone();
 BEGIN
  CALL(JDoc.StreamMakeDone());
 END {rep_JDoc_StreamMakeDone};

 PRIVATE PROCEDURE rep_MDoc_InternalStreamMakeDone();
 BEGIN
  CALL(MDoc.InternalStreamMakeDone());
 END {rep_MDoc_InternalStreamMakeDone};

 PRIVATE PROCEDURE CountUpAll(From, UpTo: DATE);
  VAR
   TimeOut  : NUMERIC[0];
   NeedAgain: SCAL[2];
   badMDocId: L_XDoc.tXDocId;
   tryCnt,
   Queue    : NUMERIC[0];
   Err      : STRING[];
 BEGIN
  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   SELECT(JDocKind, JDocKind);
   WHILE OCCURE(JDocKind) DO
    IF (JDocKind.JDocKind = L_JDoc.jd_Manual) | (JDocKind.JDocKind = L_JDoc.jd_Dfrls) |
       (JDocKind.JDocKind = L_JDoc.jd_RWayS ) THEN
     SETSEL(JDoc, JDKDate, JDocKind.JDocKind);
     SRCINSEL(JDoc, GE, , From);
     WHILE OCCURE(JDoc) & (JDoc.Date <= UpTo) DO
      PROMPT(L_JDoc.GetJDocStrNbr());
      IF ~JDoc.Done THEN
       TRY
        L_General.RidgeExecute("JDoc", PROCREF(rep_JDoc_StreamMakeDone), L_General.rem_Isolated);
       EXCEPT
       ON Exc:Exc_TermByUser DO
        RAISE();
       ON Exc:Exc_Root DO
        Err:=Exc.Description;
       END; (* TRY *)
      END;
      IF IsOldPreparedJDoc() THEN
       Add_ErrAMDc(L_XDoc.xdt_JDoc, '㬥  ﭨ "⮢"');
      ELSIF ~JDoc.Done THEN
       Add_ErrAMDc(L_XDoc.xdt_JDoc, Err);
      END;
      NEXT(JDoc);
     END; (* WHILE OCCURE(JDoc)... *)
    END;
    NEXT(JDocKind);
   END; (* WHILE OCCURE(JDocKind) ... *)
   SETEMPTY(badMDocId);
   REPEAT
    SETSEL(_AMDc, XDoc, L_XDoc.xdt_MDoc);
    REMSEL(_AMDc);
    NeedAgain:=0;
    SETSEL(MDoc, Date);
    SRCINSEL(MDoc, GE, , From);
    LOOP
     IF ~OCCURE(MDoc) | (MDoc.Date > UpTo) THEN
      EXIT;
     END;
     NARROWSEL(MDoc, Date);
     Queue:=0;
     WHILE Queue <= MAXOF(L_MDoc.fmdc_tQueue) DO
      FIRST(MDoc);
      WHILE OCCURE(MDoc) DO
       PROMPT(L_MDoc.GetMDocStrNbr());
       IF L_MDoc.fmdc_GetQueue() = Queue THEN
        IF ~MDoc.Done THEN
         TRY
          L_General.RidgeExecute("MDoc", PROCREF(rep_MDoc_InternalStreamMakeDone), L_General.rem_Isolated);
         EXCEPT
         ON Exc:Exc_TermByUser DO
          RAISE();
         ON Exc:Exc_AccessDeny DO
          Err:=Exc.Description;
          NeedAgain:=1;
         ON Exc:Exc_Root DO
          Err:=Exc.Description;
          NeedAgain:=0;
         END; (* TRY *)
        END;
   
        IF IsOldPreparedMDoc() THEN
         Add_ErrAMDc(L_XDoc.xdt_MDoc, '㬥  ﭨ "⮢"');
        ELSIF ~MDoc.Done THEN
         Add_ErrAMDc(L_XDoc.xdt_MDoc, Err);
         IF L_MDoc.E_NeedMDocProceedQueueControl(MDoc.Date) | L_General.IsPolakSpecific() THEN
          IF L_MDoc.fmdc_HasFollowingMDoc() THEN
           IF L_XDoc.curXDocId(L_XDoc.xdt_MDoc) # badMDocId THEN
            badMDocId:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
            tryCnt:=3;
           END;
           TimeOut:=10;
           IF NeedAgain & (tryCnt > 0) &
              STDFORM("| ६ ࠡ⪨ "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+" ந諠 訡||"+
                       Err+"||"+
                      L_StdFrm.DrawButton(" ஡ ᭮ %T ", 22, "DB")+" "+
                      L_StdFrm.DrawButton(" ⮯ ", 15, "X"),
                      "ࠡ⪠ 㬥⮢",
                      STOP,
                      ,
                      TimeOut) THEN
            DEC(tryCnt);
           ELSE
            NeedAgain:=0;
            L_General.Error(" 㤠 ࠡ "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
           END;
           EXIT;
          END; (* IF L_MDoc.fmdc_HasFollowingMDoc() ... *)
         END; (* IF L_MDoc.E_NeedMDocProceedQueueControl() ... *)
        END; (* IF IsOldPreparedMDoc() ... *)
       END; (* IF L_MDoc.fmdc_GetQueue() = Queue ... *)
       NEXT(MDoc);
      END; (* WHILE OCCURE(File) *)
      INC(Queue);
     END; (* WHILE Queue <= ... *)
     NEXTINEXTENDEDSEL(MDoc, Date);
    END; (* LOOP *)
   UNTIL ~NeedAgain;
  EXCEPT
  ON Exc:Exc_Root DO
   CountUpPrint(Exc);
   L_General.CallUs(0);
  END; (* TRY *)
  CountUpPrint(EMPTYOF(Exc_Root));
 END {CountUpAll};

 PUBLIC PROCEDURE BdMDc();
  CONST
   bpId = "BdMDc";
  VAR
   From,
   UpTo: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_FINISHED;
  L_bp.Begin(bpId, "ࠡ⪠ ⮢ 㬥⮢", L_bp.t_Prc_wF3, L_General.tc_inMonth);
  CountUpInit(From, UpTo, 1, bpId, "");
  CountUpAll(From, UpTo);
  L_bp.End();
 END {BdMDc};

 PRIVATE PROCEDURE mom_NeedMDoc(_Done: LIKE(MDoc.Done); _From, _UpTo: DATE): SCAL[2];
 BEGIN
  RETURN ((MDoc.Done # _Done) | (MDoc.Status = L_MDoc.st_Prepared)) &
         L_DatTim.IsActive_Inc(MDoc.Date, _From, _UpTo);
 END {mom_NeedMDoc};

 PRIVATE PROCEDURE rep_MDoc_StreamMakeDone();
 BEGIN
  CALL(MDoc.StreamMakeDone());
 END {rep_MDoc_StreamMakeDone};

 PRIVATE PROCEDURE rep_MDoc_StreamMakeUnDone();
 BEGIN
  CALL(MDoc.StreamMakeUnDone());
 END {rep_MDoc_StreamMakeUnDone};

 PRIVATE PROCEDURE CountUpAMDc(_Done, Strong: LIKE(MDoc.Done); _From, _UpTo: DATE);
  VAR
   _XDocId: L_XDoc.tXDocId;
   Err: STRING[];
 BEGIN
  SELECT(_AMDc, Date);
  IF ~_Done THEN
   LAST(_AMDc);
  END;
  WHILE OCCURE(_AMDc) DO
   _XDocId:=L_XDoc.XDocId(_AMDc.XDocType, _AMDc.XDocKind, _AMDc.XDoc);
   PROMPT(L_XDoc.XDocStr(_XDocId));
   L_XDoc.PositionOnXDoc(_XDocId);
   TRY
    IF _Done THEN
     L_General.RidgeExecute("MDoc", PROCREF(rep_MDoc_StreamMakeDone), L_General.rem_Isolated);
    ELSE
     L_General.RidgeExecute("MDoc", PROCREF(rep_MDoc_StreamMakeUnDone), L_General.rem_Isolated);
    END;
   EXCEPT
   ON Exc:Exc_TermByUser DO
    RAISE();
   ON Exc:Exc_Root DO
    IF Strong THEN
     RAISE();
    ELSE
     Err:=Exc.Description;
    END;
   END; (* TRY *)
   _AMDc.Done   :=MDoc.Done;
   _AMDc.Success:=~mom_NeedMDoc(_Done, _From, _UpTo);
   IF _AMDc.Done # _Done THEN
    _AMDc.Msg:=Err;
   END;
   REPLACE(_AMDc);
   IF _Done THEN
    NEXT(_AMDc);
   ELSE
    PREV(_AMDc);
   END;
  END; (* WHILE OCCURE(_AMDc) ... *)
 END {CountUpAMDc};

 PRIVATE PROCEDURE CountUpAMDc_w_Print(_Done: LIKE(MDoc.Done); _From, _UpTo: DATE);
 BEGIN
  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   CountUpAMDc(_Done, 0, _From, _UpTo);
  EXCEPT
  ON Exc:Exc_Root DO
   CountUpPrint(Exc);
   L_General.CallUs(0);
  END; (* TRY *)
  CountUpPrint(EMPTYOF(Exc_Root));
 END {CountUpAMDc_w_Print};

 PRIVATE PROCEDURE MakeOneMath(_Done: LIKE(MDoc.Done));
  VAR
   _From,
   _UpTo: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_FINISHED;
  L_General.Assert(ACCESS(Math), " ⠭ ꥪ ");
  CountUpInit(_From, _UpTo, _Done, "BadMD", "( "+Math.Math+" "+Math.Name+")");
  APP.Get().NewPrompt(L_Str.PoolItem("⪠|ࠡ⪠", _Done)+" .  "+Math.Math);

  SETSEL(MDocList, Math, Math.Math);
  SRCINSEL(MDocList, GE, , _From);
  WHILE OCCURE(MDocList) & (MDocList.Date <= _UpTo)  DO
   PROMPT(" "+L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc));
   IF ~SEARCH(_AMDc, XDoc, L_XDoc.xdt_MDoc, MDocList.MDocKind, MDocList.MDoc) THEN
    CONFORM(MDocList, MDoc);
    IF mom_NeedMDoc(_Done, _From, _UpTo) THEN
     Add_AMDc(L_XDoc.xdt_MDoc);
    END;
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)

  SETSEL(MDoc, Math, Math.Math);
  SRCINSEL(MDoc, GE, , _From);
  WHILE OCCURE(MDoc) & (MDoc.Date <= _UpTo)  DO
   PROMPT(" "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   IF ~SEARCH(_AMDc, XDoc, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc) &
      mom_NeedMDoc(_Done, _From, _UpTo) THEN
    Add_AMDc(L_XDoc.xdt_MDoc);
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)

  CountUpAMDc_w_Print(_Done, _From, _UpTo);
 END {MakeOneMath};

 PRIVATE PROCEDURE MakeOneCostItem(_Done: LIKE(MDoc.Done));
  VAR
   _From,
   _UpTo  : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_FINISHED;
  L_General.Assert(ACCESS(CostItem), " ⠭ ");
  CountUpInit(_From, _UpTo, _Done, "BadMD", "( "+CostItem.CostItem+" "+CostItem.Name+")");

  APP.Get().NewPrompt(L_Str.PoolItem("⪠|ࠡ⪠", _Done)+" .  "+CostItem.CostItem);

  SETSEL(MDocList, CostItem, CostItem.CostItem);
  SRCINSEL(MDocList, GE, , _From);
  WHILE OCCURE(MDocList) & (MDocList.Date <= _UpTo)  DO
   PROMPT(" "+L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc));
   IF ~SEARCH(_AMDc, XDoc, L_XDoc.xdt_MDoc, MDocList.MDocKind, MDocList.MDoc) THEN
    CONFORM(MDocList, MDoc);
    IF mom_NeedMDoc(_Done, _From, _UpTo) THEN
     Add_AMDc(L_XDoc.xdt_MDoc);
    END;
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)

  SETSEL(MDoc, CostItem, CostItem.CostItem);
  SRCINSEL(MDoc, GE, , _From);
  WHILE OCCURE(MDoc) & (MDoc.Date <= _UpTo)  DO
   PROMPT(" "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   IF ~SEARCH(_AMDc, XDoc, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc) &
      mom_NeedMDoc(_Done, _From, _UpTo) THEN
    Add_AMDc(L_XDoc.xdt_MDoc);
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)

  CountUpAMDc_w_Print(_Done, _From, _UpTo);
 END {MakeOneCostItem};

 PRIVATE PROCEDURE MakeOneContract(_Done: LIKE(MDoc.Done));
  VAR
   _From,
   _UpTo  : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_FINISHED;
  L_General.Assert(ACCESS(Contract), " ⠭ ");
  CountUpInit(_From, _UpTo, _Done, "BadMD", "( "+Contract.Contract+" "+Contract.Name+")");

  APP.Get().NewPrompt(L_Str.PoolItem("⪠|ࠡ⪠", _Done)+" .  "+Contract.Contract);

  SELECT(MDoc, Contract, , Contract.Contract);
  WHILE OCCURE(MDoc) DO
   NARROWSEL(MDoc, MDocKind);
   SRCINSEL(MDoc, GE, , _From);
   WHILE OCCURE(MDoc) & (MDoc.Date <= _UpTo) DO
    PROMPT(" "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
    IF mom_NeedMDoc(_Done, _From, _UpTo) THEN
     Add_AMDc(L_XDoc.xdt_MDoc);
    END;
    NEXT(MDoc);
   END; (* WHILE OCCURE(MDoc) ... *)
   NEXTINEXTENDEDSEL(MDoc, MDocKind);
  END; (* WHILE OCCURE(MDoc) ... *)

  CountUpAMDc_w_Print(_Done, _From, _UpTo);
 END {MakeOneContract};

 PRIVATE PROCEDURE IsMDocWithVATDistr(): SCAL[2];
 BEGIN
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   IF (MDocList.VAT # 0) & (MDocList.VATMode = L_MDoc.vatm_Distribution) THEN
    RETURN 1;
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  RETURN 0;
 END {IsMDocWithVATDistr};

 PUBLIC PROCEDURE MDDsU();
  CONST
   bpId  = "MDDsU";
   MDVATDistrAddStr = "  ⮤   '।'";
  VAR
   sav_cd: DATE;
   From,
   UpTo  : DATE;
   PerStr,
   DoneMsg: STRING[];
   arvat_HasAction: SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_FINISHED;

  sav_cd:=Memo.ud_cd();
  TRY [TRANSACTION(TRANSACTION_SLAVE), MSG_SUPPRESSION(MSG_SUPPRESSION_NONE)]
   L_bp.Begin(bpId, "९஢   '।'", L_bp.t_Process, L_General.tc_inMonth);
   From:=L_Pmnt.ConvPer2VATClcPer(Memo.gl_mb());
   UpTo:=Math.Min(L_Pmnt.GetVATClcPerLastDay(Memo.gl_mb()), L_DatTim.MonthEnd(SYSDATE()));
   PerStr:=" "+L_DatTim.PeriodStr(From)+"  "+L_DatTim.PeriodStr(UpTo);
   DoneMsg:=MDVATDistrAddStr+" "+PerStr+"|㤥 饭 楤 ࠡ⪨  c "+L_DatTim.PeriodStr(From);
   arvat_HasAction:=L_iga.HasAction(L_iga.a_RedistributeVAT, From);
   IF ~arvat_HasAction THEN
    L_StdFrm.Confirm("९஢ "+MDVATDistrAddStr+"| |"+PerStr);
   END;

   Memo.UIP_SetCurDate(From);

   IF ~arvat_HasAction THEN
    Create__AMDc();
  
    SELECT(MDocKind, MDocKind);
    WHILE OCCURE(MDocKind) DO
     IF L_MDoc.IsAvailableVATModeMDocKind(MDocKind.MDocKind) THEN
      SETSEL(MDoc, MDKStat, MDocKind.MDocKind, L_MDoc.st_Passed, 1);
      SRCINSEL(MDoc, GE, , From);
      WHILE OCCURE(MDoc) & (MDoc.Date <= UpTo) DO
       PROMPT(" "+L_MDoc.GetMDocStrNbr());
       IF (L_MDoc.CalculateVAT() # L_MDoc.cvat_Impossible) & IsMDocWithVATDistr() THEN
        L_General.Assert(L_Acnt.E_DoXDocApr(L_DatTim.Per(MDoc.Date), L_MDoc.GetMDocSource(MDoc.MDocKind), L_XDoc.curXDocId(L_XDoc.xdt_MDoc)), " 믮  '।'   "+L_DatTim.PeriodStr(MDoc.Date)+"|믮   ࠡ   ");
        Add_AMDc(L_XDoc.xdt_MDoc);
       END;
       NEXT(MDoc);
      END; (* WHILE OCCURE(File) *)
     END;
     NEXT(MDocKind);
    END; (* WHILE OCCURE(MDocKind) ... *)
    CountUpAMDc(0, 1, From, UpTo);
    L_AFM.AF_PurgeTemp("_AMDc");
    L_iga.Put(L_iga.a_RedistributeVAT, From, "");
   END; (* IF ~arvat_HasAction ... *)
   L_bp.End();
  EXCEPT
  FINALLY
   Memo.UIP_SetCurDate(sav_cd);
  END; (* TRY *)

  IF ~arvat_HasAction THEN
   L_StdFrm.TimedINFORM("믮  "+DoneMsg, 10);
  ELSE
   L_StdFrm.TimedINFORM(" 室  "+DoneMsg, 10);
  END; (* IF ~L_iga.HasAction() ... *)

  UpTo:=L_DatTim.MonthEnd(SYSDATE());
  intCountUpInit(From, UpTo, 1, "BadMD", "");
  CountUpAll(From, UpTo);
 END {MDDsU};

 PRIVATE PROCEDURE extBdMDc(From: DATE);
  VAR
   sav_cd: DATE;
 BEGIN
  sav_cd:=Memo.ud_cd();
  TRY
   Memo.UIP_SetCurDate(From);
   CALL(A_MDoc.BdMDc());
  EXCEPT
  FINALLY
   Memo.UIP_SetCurDate(sav_cd);
  END; (* TRY *)
 END {extBdMDc};

 PUBLIC PROCEDURE OneMathMDocDone();
 BEGIN
  MakeOneMath(1);
 END {OneMathMDocDone};

 PUBLIC PROCEDURE OneMathMDocUnDone();
 BEGIN
  MakeOneMath(0);
 END {OneMathMDocUnDone};

 PUBLIC PROCEDURE OneContractMDocDone();
 BEGIN
  MakeOneContract(1);
 END {OneContractMDocDone};

 PUBLIC PROCEDURE OneContractMDocUnDone();
 BEGIN
  MakeOneContract(0);
 END {OneContractMDocUnDone};

 PUBLIC PROCEDURE OneCostItemMDocDone();
 BEGIN
  MakeOneCostItem(1);
 END {OneCostItemMDocDone};

 PUBLIC PROCEDURE OneCostItemMDocUnDone();
 BEGIN
  MakeOneCostItem(0);
 END {OneCostItemMDocUnDone};

END.
