(*
%Copyright   (c) Polak Computer System
%Author      17.07.1998 15:25:15 GINA
%Purpose      ⥦ 㬥⮢  
%Type        operation
%Specific    SYS
%Modified    18.07.2013 12:28:37 POLAK\Bor
%Environment
*)

 MODULE A_PDoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_APtm, L_Events, L_OwnData, L_DatTim, L_XObj, L_AFM, L_AR,
        L_PDoc, L_XDoc, L_PRoll, L_Staff, L_Str, Str, Memo, SysLog, L_JDoc, L_bp, L_StdFrm, Math;

 PRIVATE CONST
  RepName="BdPDc";
  MsgLen = 80;

(*
$P{ MostTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
?, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|㬥      |    |C|O|ਬ砭                                                                      |
|--------------|--------|-|-|--------------------------------------------------------------------------------|
}
*)

(*
$P { Line:
L_PDoc.PDocStr(_APDc.PDocKind, _APDc.PDoc), L, ""
_APDc.Date, L, "D.N.Y"
_APDc.Status, L , "||"
_APDc.Done, L, " |"
?, L, ""
@
|##############|########|#|#|################################################################################|
}
*)

(*
$P { LineAdd:
?, L, ""
@
|              |        | | |################################################################################|
}
*)

(*
$P{ MsgLine:
?, C, ""
@
|------------------------------------------------------------------------------------------------------------|
|                                                                                                            |
|############################################################################################################|
|                                                                                                            |
}
*)

(*
$P { PageBot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE IsOldPreparedPDoc(): SCAL[2];
 BEGIN
  IF ~L_General.IsPolakSpecific() THEN
   RETURN (PDoc.Status = L_PDoc.st_Prepared) & (PDoc.Date < L_DatTim.Per(SYSDATE()));
  ELSE
   RETURN 0;
  END;
 END {IsOldPreparedPDoc};

 PRIVATE PROCEDURE Create__APDc();
 BEGIN
  CreateFILE(_APDc, "", "⮪ ࠡ⪨/⪠ 㬥⮢", "");
  CreateFIELD(_APDc, PDocKind, LIKE(PDoc.PDocKind), "", "", "", " 㬥", "");
  CreateFIELD(_APDc, PDoc,     LIKE(PDoc.PDoc),     "", "", "", " 㬥", "");
  CreateFIELD(_APDc, Date,     LIKE(PDoc.Date),     "", "", "", " 㬥", "");
  CreateFIELD(_APDc, Msg,      STRING[256],         "", "", "", "ਬ砭", "");
  CreateFIELD(_APDc, Status,   LIKE(PDoc.Status),   "", "", "", "ﭨ", "");
  CreateFIELD(_APDc, Done,     LIKE(PDoc.Done),     "", "", "", "ࠡ⠭", "");
  CreateFIELD(_APDc, DoneDTS,  LIKE(PDoc.DoneDTS),  "", "", "", "/६ ࠡ⪨", "");
  CreateFIELD(_APDc, Success,  SCAL[2],             "", "0", "", " ⪠/ࠡ", "");

  CreateINDEXandLINK(_APDc, PDoc,     PLURAL, PDoc,     PDoc,       USER, "", "", PDocKind, PDoc);
  CreateINDEX(_APDc, Date, PLURAL, "", "", Date, DoneDTS);
  CreateINDEX(_APDc, Success, PLURAL, "", "", Success, PDocKind, PDoc);

  SetVersionOfFILE(_APDc, 000);
 END {Create__APDc};

 PRIVATE PROCEDURE Add_APDc(Msg: STRING[]);
 BEGIN
  L_General.CLEAR("_APDc");
  _APDc.PDocKind:=PDoc.PDocKind;
  _APDc.PDoc    :=PDoc.PDoc;
  _APDc.Date    :=PDoc.Date;
  _APDc.Msg     :=Msg;
  _APDc.Status  :=PDoc.Status;
  _APDc.Done    :=PDoc.Done;
  _APDc.DoneDTS :=PDoc.DoneDTS;
  _APDc.Success :="";
  INSERT(_APDc);
 END {Add_APDc};

 PRIVATE PROCEDURE XDocClearError(trgXDocId: L_XDoc.tXDocId);
 BEGIN
  L_General.Error(" ६    ⠢ 㬥 "+L_XDoc.XDocStr(trgXDocId)+"|"+
                  "  믮"+L_StdFrm.HR()+"室  楤  ");
 END {XDocClearError};

 PRIVATE PROCEDURE E_NeedCorrectPCalc(From, UpTo: DATE): SCAL[2];
  VAR
   P: DATE;
   prvNCP,
   curNCP: SCAL[2];
 BEGIN
  UpTo:=Math.Min(SYSDATE(), UpTo);
  SETEMPTY(prvNCP, curNCP);
  P:=From;
  REPEAT
   curNCP:=L_PDoc.E_NeedCorrectPCalc(P);
   IF ~!prvNCP & (prvNCP # curNCP) THEN
    L_General.Error("⠭ ᯥ樠 ०    䨪樨  ⮢|室 믮     ⤥쭮");
   END;
   prvNCP:=curNCP;
   P:=L_DatTim.NextPer(P);
  UNTIL P > UpTo;
  RETURN curNCP;
 END {E_NeedCorrectPCalc};

 PRIVATE PROCEDURE Clear_Docs(From: DATE; Through: SCAL[2]; CheckOnly: SCAL[2]);
  VAR
   ncp: SCAL[2];
   savedMemoDate,
   P,
   UpTo: DATE;
 BEGIN
  savedMemoDate:=Memo.gl_cd();
  IF Through THEN
   UpTo:=L_DatTim.MAXDATE();
  ELSE
   UpTo:=L_DatTim.MonthEnd(From);
  END;
  SETSEL(PDoc, Date);
  SRCINSEL(PDoc, GE, , From);
  WHILE OCCURE(PDoc) & (PDoc.Date <= UpTo) DO
   PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc) + "  " + L_DatTim.DateStr(PDoc.Date));
   IF L_DatTim.Per(PDoc.Date) # Memo.gl_mb() THEN
    Memo.gl_SetCurDate(PDoc.Date);
   END;
   IF PDoc.Done THEN
    IF ~CheckOnly THEN
     PDoc.Done:=0;
     REPLACE(PDoc);
    ELSE
     XDocClearError(PDoc.XDocId);
    END;
   END; (* IF PDoc.Done ... *)
   IF ~CheckOnly THEN
    L_XObj.ClearXDocApr(PDoc.XDocId, Memo.gl_mb());
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc ... *)

  SETSEL(JDoc, JDKDate, L_JDoc.jd_PDoc);
  SRCINSEL(JDoc, GE, , From);
  WHILE OCCURE(JDoc) & (JDoc.Date <= UpTo) DO
   PROMPT(L_JDoc.GetJDocStrNbr());
   IF L_DatTim.Per(JDoc.Date) # Memo.gl_mb() THEN
    Memo.gl_SetCurDate(JDoc.Date);
   END;
   IF JDoc.Done THEN
    IF ~CheckOnly THEN
     JDoc.Done :=0;
     REPLACE(JDoc);
    ELSE
     XDocClearError(JDoc.XDocId);
    END;
   END; (* IF JDoc.Done ... *)
   IF ~CheckOnly THEN
    L_XObj.ClearXDocApr(JDoc.XDocId, Memo.gl_mb());
   END;
   NEXT(JDoc);
  END; (* WHILE OCCURE(JDoc)... *)

  IF ~CheckOnly & E_NeedCorrectPCalc(From, UpTo) THEN
   Memo.gl_SetCurDate(From);
   L_PRoll.Salary_CheckNoTouch(From);
   SELECT(Staff, TSN);
   WHILE OCCURE(Staff) DO
    PROMPT("⭨ "+Staff.TSN+" : ⪠  ⮢");
    IF Through THEN
     Memo.gl_SetCurDate(Math.Max(Staff.BegDate, From));
     L_PRoll.xClearMoney(L_PRoll.src_PDoc, 1);
     L_PRoll.ShtDone(0);
    ELSE
     IF L_Staff.IsBegan(Memo.gl_mb()) THEN
      L_PRoll.ClearMoney(L_PRoll.src_PDoc);
      L_PRoll.ShtDone(0);
     END;
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff)... *)
  END;
  Memo.gl_SetCurDate(savedMemoDate);
 END {Clear_Docs};

 PRIVATE PROCEDURE Clear_XApport(Through: SCAL[2]);
  VAR
   SourcesToClear: SCAL[2][100];
 BEGIN
  SETZERO(SourcesToClear);
  SourcesToClear[L_XObj.src_PDoc    ]:=1;
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Global,   L_XObj.s_Payments, SourcesToClear, Through);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Man,      L_XObj.s_Payments, SourcesToClear, Through);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Contract, L_XObj.s_Payments, SourcesToClear, Through);
 END {Clear_XApport};

 PRIVATE PROCEDURE ClearPDocResults();
  VAR
   PerB,
   PerE,
   P      : DATE;
   Through: SCAL[2];
 BEGIN
  L_AR.CheckDatabaseTransparency();
  PerB:=Memo.ud_mb();
  IF L_XDoc.AskForXDocProceed(L_XDoc.pm_Clear, "⥦ 㬥", 0) THEN
   PerE:=L_DatTim.Per(SYSDATE());
  ELSE
   PerE:=PerB;
  END;
  APP.Get().NewPrompt("   ਮ  " + L_DatTim.PeriodStr(PerB) + "  " + L_DatTim.PeriodStr(PerE));
  SysLog.Mark("PDoc", L_DatTim.PeriodStr(PerB)+" : "+" ⥦ 㬥⮢ ( " + L_DatTim.PeriodStr(PerE) + ")");

  Through:=PerE>PerB;
  Clear_Docs(PerB, Through, 0);
  Clear_XApport(Through);
  Clear_Docs(PerB, Through, 1); (* ஢塞,  뫮  ⠢   襫  *)
 END {ClearPDocResults};

 PRIVATE PROCEDURE CountUpInit(VAR _From, _UpTo: DATE; _Done: SCAL[2]; AddMsg: STRING[]; NeedHalt: SCAL[2]);
  VAR
   Msg,
   HeaderStr: STRING[];
   pm       : L_XDoc.tProceedManner;
 BEGIN
  _From:=Memo.ud_mb();
  IF NeedHalt THEN
   _UpTo:=Memo.ud_me();
  ELSE
   IF _Done THEN
    pm:=L_XDoc.pm_Proceed;
   ELSE
    pm:=L_XDoc.pm_Backtracking;
   END;
   Msg:="⥦ 㬥";
   IF ~!AddMsg THEN
    Msg:=Msg + "|" + AddMsg;
   END;
   IF L_XDoc.AskForXDocProceed(pm, Msg, 0) THEN
    _UpTo:=L_DatTim.MonthEnd(SYSDATE());
   ELSE
    _UpTo:=Memo.ud_me();
   END;
  END;
  HeaderStr:=" 㤠 " + L_Str.PoolItem("⪠|ࠡ", _Done) + " ⥦ 㬥" +
             "  ਮ  " + L_DatTim.PeriodStr(_From) + "  " + L_DatTim.PeriodStr(_UpTo);
  L_XDoc.sl_Init(HeaderStr);
  Create__APDc(); L_AFM.AF_CreateTemp("_APDc", "_ApDc");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, MostTop, HeaderStr, AddMsg);
 END {CountUpInit};

 PRIVATE PROCEDURE CountUpPrint(Exc: Exc_Root);
  VAR
   TotalErrorCnt: NUMERIC[0];
   MsgArr       : STRING[MsgLen][5];
   i            : NUMERIC[0];
 BEGIN
  TotalErrorCnt:=0;
  IF SELECT(_APDc, Success, 0) THEN
   WHILE OCCURE(_APDc) DO
    Str.Format(MsgArr, _APDc.Msg, MsgLen, LEFT);
    MAKEPART(R, Line, MsgArr[0]);
    i:=1;
    WHILE ~!MsgArr[i] & (i < RANGEOF(MsgArr)) DO
     MAKEPART(R, LineAdd, MsgArr[i]);
     INC(i);
    END;
    L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_PDoc, _APDc.PDocKind, _APDc.PDoc),
                      L_PDoc.PDocStr(_APDc.PDocKind, _APDc.PDoc) +
                      " " + L_DatTim.DateStr(_APDc.Date) +
                      " " + Str.Align(L_PDoc.PDocAbout(_APDc.PDocKind, _APDc.PDoc), 45, LEFT));
    INC(TotalErrorCnt);
    NEXT(_APDc);
   END; (* WHILE OCCURE(_APDc) ... *)
  END;
  IF ~!Exc THEN
   MAKEPART(R, MsgLine, " ࢠ: " + Exc.Description);
  ELSIF (TotalErrorCnt = 0) THEN
   MAKEPART(R, MsgLine, "஡ 㬥⮢ ");
  END;
  MAKEPART(R, PageBot);
  CLOSEREP(R);
  IF ~!Exc THEN
   L_General.HaltAndBrowseLastReport(Exc);
  ELSIF TotalErrorCnt = 0 THEN
   L_StdFrm.Inform("஡ 㬥⮢ ");
  ELSIF !L_bp.getCurId() THEN
   L_StdFrm.RedInform("  ஡ (. ⮪)");
   L_General.BrowseLastReport();
  END;
 END {CountUpPrint};

 PRIVATE PROCEDURE rep_PDoc_StreamMakeDone();
 BEGIN
  CALL(PDoc.StreamMakeDone());
 END {rep_PDoc_StreamMakeDone};

 PRIVATE PROCEDURE rep_PDoc_StreamMakeUnDone();
 BEGIN
  CALL(PDoc.StreamMakeUnDone());
 END {rep_PDoc_StreamMakeUnDone};

 PRIVATE PROCEDURE CountUpAPDc(_Done: LIKE(PDoc.Done); _From, _UpTo: DATE);
  VAR
   Err: STRING[];
 BEGIN
  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   SELECT(_APDc, Date);
   IF ~_Done THEN
    LAST(_APDc);
   END;
   WHILE OCCURE(_APDc) DO
    PROMPT(L_DatTim.DateStr(_APDc.Date)+" "+L_PDoc.PDocStr(_APDc.PDocKind, _APDc.PDoc));
    CONFORM(_APDc, PDoc);
    TRY
     IF _Done THEN
      L_General.RidgeExecute("PDoc", PROCREF(rep_PDoc_StreamMakeDone), L_General.rem_Isolated);
     ELSE
      L_General.RidgeExecute("PDoc", PROCREF(rep_PDoc_StreamMakeUnDone), L_General.rem_Isolated);
     END;
    EXCEPT
    ON Exc:Exc_TermByUser DO
     RAISE();
    ON Exc:Exc_Root DO
     Err:=Exc.Description;
    END; (* TRY *)
    _APDc.Done   :=PDoc.Done;
    _APDc.Success:=(PDoc.Done = _Done) & ~IsOldPreparedPDoc();
    IF _APDc.Done # _Done THEN
     _APDc.Msg:=Err;
    END;
    REPLACE(_APDc);
    IF _Done THEN
     NEXT(_APDc);
    ELSE
     PREV(_APDc);
    END;
   END; (* WHILE OCCURE(_APDc) ... *)
  EXCEPT
  ON Exc:Exc_Root DO
   CountUpPrint(Exc);
   L_General.CallUs(0);
  END; (* TRY *)
  CountUpPrint(EMPTYOF(Exc_Root));
 END {CountUpAPDc};

 PRIVATE PROCEDURE MakeByPeriod(_Done: LIKE(PDoc.Done); NeedHalt: SCAL[2]);
  VAR
   _From,
   _UpTo  : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_FINISHED;

  IF _Done = 0 THEN
   L_APtm.ANYSystem_CheckClcPer(L_APtm.system_PDoc);
  END;
  CountUpInit(_From, _UpTo, _Done, "", NeedHalt);

  APP.Get().NewPrompt(L_Str.PoolItem("⪠|ࠡ⪠", _Done)+" ");

  SETSEL(PDoc, Date);
  SRCINSEL(PDoc, GE, , _From);
  WHILE OCCURE(PDoc) & (PDoc.Date <= _UpTo) DO
   PROMPT(" " + L_DatTim.DateStr(PDoc.Date));
   Add_APDc("");
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc ... *)

  CountUpAPDc(_Done, _From, _UpTo);
 END {MakeByPeriod};

 PUBLIC PROCEDURE StreamMakeDone_ByMonth();
 BEGIN
  MakeByPeriod(1, 0);
 END {StreamMakeDone_ByMonth};

 PUBLIC PROCEDURE StreamMakeUnDone_ByMonth();
 BEGIN
  MakeByPeriod(0, 0);
 END {StreamMakeUnDone_ByMonth};

 PUBLIC PROCEDURE Clear_ByMonth();
 BEGIN
  L_APtm.ANYSystem_CheckClcPer(L_APtm.system_PDoc);
  ClearPDocResults();
 END {Clear_ByMonth};

 PUBLIC PROCEDURE ProceedByContract(_Done: LIKE(PDoc.Done); NeedHalt: SCAL[2]);
  VAR
   _From,
   _UpTo  : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_FINISHED;
  L_General.Assert(ACCESS(Contract), " ⠭ ");
  CountUpInit(_From, _UpTo, _Done, "( "+Contract.Contract+" "+Contract.Name+")", NeedHalt);

  APP.Get().NewPrompt(L_Str.PoolItem("⪠|ࠡ⪠", _Done)+" .  "+Contract.Contract);

  SETSEL(PDocMDoc, Contract, Contract.Contract);
  SRCINSEL(PDocMDoc, GE, , _From);
  WHILE OCCURE(PDocMDoc) & (PDocMDoc.PDocDate <= _UpTo) DO
   CONFORM(PDocMDoc, PDoc);
   PROMPT(": "+L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   Add_APDc("");
   NEXT(PDocMDoc);
  END; (* WHILE OCCURE(PDocMDoc) ... *)

  CountUpAPDc(_Done, _From, _UpTo);
 END {ProceedByContract};

END.
