(*
%Copyright   (c) Polak IT
%Author      19.02.2004 11:43:10 POLAK\San
%Purpose     ⮪ 楤 ࠡ⪨//  
%Type        operation
%Specific    SYS
%Modified    24.09.2014 16:14:00 LDA
%Environment
*)

 MODULE A_Pmnt [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, Memo, L_Str, L_DatTim, P_Firm, L_APtm, L_Acnt,
        L_MathR, L_XObj, L_XDoc, L_MDoc, L_PDoc, L_Fuel, L_Pmnt, P_OwnData,
        L_Way, L_AcsPnt, L_StdFrm, L_AFM, L_bp, L_JDoc, L_iga;

 PRIVATE TYPE
  tAction = SCAL[3];

 PRIVATE CONST

  theSection = L_XObj.s_Payments;

  a_CountingUp = 0;
  a_Clearing   = 1;
  a_Closing    = 2;

  ErrRepName = "BadXO";

 PRIVATE VAR
  TotalErrorCnt: NUMERIC[0];
  newXOCnt     : NUMERIC[0];
  curAction    : tAction;

(*
$P { PageTop:
P_Firm.FP_FirmName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
ErrRepName, L, ""
Memo.gl_mb(), L, "N.y"
?, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                                ꥪ  믮 ⮬  #######                                 |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|ꥪ                          |ᠭ ஡                                                          |
}
*)

(*
$P { Line:
L_XObj.GetXObjectOriginName(), L, ""
?, L, ""
@
|--------------------------------|---------------------------------------------------------------------------|
|################################|###########################################################################|
}
*)

(*
$P { AddLine:
?, L, ""
@
|                                |###########################################################################|
}
*)

(*
$P{ Dlm:
@
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ ExcDsc:
?, C, ""
@
|############################################################################################################|
}
*)

(*
$P{ Final:
?, C, ""
@
|------------------------------------------------------------------------------------------------------------|
|                                                                                                            |
|############################################################################################################|
|                                                                                                            |
}
*)

(*
$P { PageBot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE ProcessSingleMath();
 BEGIN
  IF curAction = a_Closing THEN CALL(MCM.SingleCountUp(TRANSACTION_CURRENT));
  ELSE                          CALL(MCM.SingleCountUp(TRANSACTION_SLAVE));
  END;
 END {ProcessSingleMath};

 PRIVATE PROCEDURE ProcessSingleXObject();
 BEGIN
  IF curAction = a_Closing THEN CALL(MXO.SingleCountUp(TRANSACTION_CURRENT));
  ELSE                          CALL(MXO.SingleCountUp(TRANSACTION_SLAVE));
  END;
 END {ProcessSingleXObject};

 PRIVATE PROCEDURE locRidgeExecute(): STRING[];
  VAR
   rem: L_General.tRidgeExecuteMode;
 BEGIN
  IF curAction = a_Closing THEN
   rem:=L_General.rem_SameTRN;
  ELSE
   rem:=L_General.rem_Isolated;
  END;
  TRY
   IF (XObject.Origin = L_XObj.o_Math) | (XObject.Origin = L_XObj.o_KeyAss) THEN
    L_General.RidgeExecute("Math", PROCREF(ProcessSingleMath), rem);
   ELSE
    L_General.RidgeExecute("XObject", PROCREF(ProcessSingleXObject), rem);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   IF curAction = a_Closing THEN
    L_General.Error(Exc.MsgOriginalText + "||" + ": ᫥ ।⥫쭮 믮  ");
   ELSE
    RETURN Exc.Description;
   END
  END;
  RETURN "";
 END {locRidgeExecute};

 PRIVATE PROCEDURE CountUpSingleOrigin(_Origin: L_XObj.tOrigin; _MyFirm: P_Firm.tMyFirm);
  VAR
   curXObject: LIKE(XObject.XObject);
   curPeriod : DATE;
   curError  : STRING[];
 BEGIN
  curPeriod:=MINOF(DATE);
  WHILE SELECT(XODone, Done, _Origin, 0) & SRCINSEL(XODone, GT, curPeriod) & (XODone.Period <= Memo.gl_mb()) DO
   curXObject:=0000000;
   curPeriod :=XODone.Period;
   WHILE SELECT(XODone, Done, _Origin, 0, curPeriod) & SRCINSEL(XODone, GE, curXObject) DO
    PROMPT(" : " + XODone.XObject);
    curXObject:=XODone.XObject+1;
    IF ~SEARCH(ErrXO, XObject, XODone.XObject) THEN
     IF L_XObj.SrcXObject(XODone.XObject) THEN
      IF (XObject.Origin = L_XObj.o_Math) | (XObject.Origin = L_XObj.o_KeyAss) THEN
       SEARCH(mItem, XObject, , XObject.XObject);
       CONFORM(mItem, Math);
       INC(newXOCnt);
       curError:=locRidgeExecute();
      ELSE
       IF !_MyFirm | (XObject.MyFirm = _MyFirm) THEN
        INC(newXOCnt);
        curError:=locRidgeExecute();
       ELSE
        SETEMPTY(curError);
       END;
      END;
      IF ~!curError THEN
       ErrXO.XObject:=XObject.XObject;
       ErrXO.Id     :=L_XObj.GetXObjectOriginName();
       ErrXO.ErrDsc :=curError;
       INSERT(ErrXO);
       INC(TotalErrorCnt);
       SLEEP(0.01); (* 0067521 - Esc  ࠡ⠥  ⮣ *)
      END; (* IF ~Done *)
     END;
    END; (* IF ~SEARCH(ErrXO ... *)
   END; (* WHILE SELECT & SRCINSEL ... *)
  END; (* WHILE SELECT ... *)
 END {CountUpSingleOrigin};

 PRIVATE PROCEDURE Do_XObjects(_Origin: L_XObj.tOrigin; _MyFirm: P_Firm.tMyFirm);
 BEGIN
  IF curAction = a_Clearing THEN
   IF ~!_MyFirm THEN
    SELECT(XObject, MyFirm, , _MyFirm, _Origin);
   ELSE
    SELECT(XObject, Origin, , _Origin);
   END;
   WHILE OCCURE(XObject) DO
    PROMPT(": " + XObject.XObject);
    L_XObj.ResetXObjectDone(Memo.gl_mb(), theSection, 0);
    NEXT(XObject);
   END; (* WHILE OCCURE(XObject) ... *)
  ELSE
   CountUpSingleOrigin(_Origin, _MyFirm);
  END;
 END {Do_XObjects};

 PRIVATE PROCEDURE DoByOriginsMap(trgOM: L_XObj.tOriginsMap; trgMyFirm: P_Firm.tMyFirm);
  VAR
   curOrigin: L_XObj.tOrigin;
 BEGIN
  REPEAT
   RENEWDATALAYER();
   newXOCnt:=0;
   FOR_EACH curOrigin DO
    IF trgOM[curOrigin] THEN
     Do_XObjects(curOrigin, trgMyFirm);
    END;
   END;
  UNTIL newXOCnt = 0;
 END {DoByOriginsMap};

 PRIVATE PROCEDURE tst_RWayS();
 BEGIN
  IF L_Fuel.TanksIsStockInMonth(Memo.gl_mb()) THEN
   IF SELECT(RWayS, Done, 0) & (RWayS.Date <= Memo.gl_me()) THEN
    L_XDoc.tst_Check(L_XDoc.curXDocId(L_XDoc.xdt_RWayS), RWayS.Status = L_Way.rwsStat_Rated, 0);
   END;
   IF L_Fuel.E_DoJDocByRWayS(Memo.gl_mb()) THEN
    IF SELECT(JDoc, JDKReady, L_JDoc.jd_RWayS, 0) & (JDoc.Date <= Memo.gl_me()) THEN
     L_General.Error("   ୠ 㬥  '室  '." +
                     "||" +
                     " 믮 'ࠡ '  " + L_DatTim.PeriodStr(JDoc.Date));
    END;
   END;
  END;
 END {tst_RWayS};

 PRIVATE PROCEDURE tst_MDoc();
 BEGIN
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF SELECT(MDoc, MDKStat, MDocKind.MDocKind, L_MDoc.st_Prepared, 1) & SRCINSEL(MDoc, LE, Memo.gl_me()) |
      SELECT(MDoc, MDKStat, MDocKind.MDocKind, L_MDoc.st_Prepared, 0) & SRCINSEL(MDoc, LE, Memo.gl_me()) THEN
    L_XDoc.tst_Check(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), 0, 1);
   END;
   IF SELECT(MDoc, MDKStat, MDocKind.MDocKind, L_MDoc.st_Passed, 0) & (MDoc.Date <= Memo.gl_me()) THEN
    L_XDoc.tst_Check(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), 1, 0);
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
 END {tst_MDoc};

 PRIVATE PROCEDURE tst_JDoc();
 BEGIN
  SELECT(JDocKind, JDocKind);
  WHILE OCCURE(JDocKind) DO
   IF SELECT(JDoc, JDKStat, JDocKind.JDocKind, L_JDoc.st_Prepared, 1) & SRCINSEL(JDoc, LE, Memo.gl_me()) |
      SELECT(JDoc, JDKStat, JDocKind.JDocKind, L_JDoc.st_Prepared, 0) & SRCINSEL(JDoc, LE, Memo.gl_me()) THEN
    L_XDoc.tst_Check(L_XDoc.curXDocId(L_XDoc.xdt_JDoc), 0, 1);
   END;
   IF SELECT(JDoc, JDKStat, JDocKind.JDocKind, L_JDoc.st_Passed, 0) & (JDoc.Date <= Memo.gl_me()) THEN
    L_XDoc.tst_Check(L_XDoc.curXDocId(L_XDoc.xdt_JDoc), 1, 0);
   END;
   NEXT(JDocKind);
  END; (* WHILE OCCURE(JDocKind) ... *)
 END {tst_JDoc};

 PRIVATE PROCEDURE tst_PDoc();
  VAR
   _Queue: LIKE(PDoc.Queue)[128];
   ErrMsg: STRING[];
 BEGIN
  SELECT(PDocKind, PDocKind);
  WHILE OCCURE(PDocKind) DO
   IF SELECT(PDoc, PDKStat, PDocKind.PDocKind, L_PDoc.st_Prepared, 1) & SRCINSEL(PDoc, LE, Memo.gl_me()) |
      SELECT(PDoc, PDKStat, PDocKind.PDocKind, L_PDoc.st_Prepared, 0) & SRCINSEL(PDoc, LE, Memo.gl_me()) THEN
    L_XDoc.tst_Check(L_XDoc.curXDocId(L_XDoc.xdt_PDoc), 0, 1);
   END;
   IF SELECT(PDoc, PDKStat, PDocKind.PDocKind, L_PDoc.st_Passed, 0) & (PDoc.Date <= Memo.gl_me()) THEN
    L_XDoc.tst_Check(L_XDoc.curXDocId(L_XDoc.xdt_PDoc), 1, 0);
   END;
   NEXT(PDocKind);
  END; (* WHILE OCCURE(PDocKind) ... *)
  IF L_XObj.GetBeginOfAccountingOnAcCut(L_kn.Get(Memo.gl_me(), L_AcCut.erkn_CentralCashOffice)) <= Memo.gl_mb() THEN
   SETSEL(PDoc, Date);
   SRCINSEL(PDoc, GE, , Memo.gl_mb());
   WHILE OCCURE(PDoc) & (PDoc.Date <= Memo.gl_me()) DO
    SETEMPTY(_Queue);
    NARROWSEL(PDoc, Date);
    PROMPT("஢ઠ ⮢ ᮢ : " + L_DatTim.DateStr(PDoc.Date));
    WHILE OCCURE(PDoc) DO
     IF L_PDoc.IsCashOfficePDoc(PDoc.PDocKind) THEN
      IF !_Queue[PDoc.MyFirm] THEN
       _Queue[PDoc.MyFirm]:=PDoc.Queue;
      END;
      IF (PDoc.Queue # _Queue[PDoc.MyFirm]) | !_Queue[PDoc.MyFirm] THEN
       ErrMsg:="室 ⮢ ᮢ   " + L_DatTim.DateStr(PDoc.Date);
       IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
        ErrMsg:=ErrMsg + "||" + "' ࣠' - " + PDoc.MyFirm;
       END;
       L_General.Error(ErrMsg);
      END;
     END;
     NEXT(PDoc);
    END; (* WHILE OCCURE(PDoc) ... *)
    NEXTINEXTENDEDSEL(PDoc, Date);
   END; (* WHILE OCCURE(PDoc) ... *)
  END;
 END {tst_PDoc};

 PRIVATE PROCEDURE CheckRedistributeVAT(P: DATE);
 BEGIN
  IF P >= 01\04\2011 THEN
   IF P_OwnData.HasActualOwnDPro(P, P_OwnData.P_SalesVolumes) THEN
    IF (P = L_DatTim.Per(L_Pmnt.GetVATClcPerLastDay(P))) | ~L_Acnt.E_IsAlternateVATDistr(P) | L_Acnt.E_IsMonthlyKeyAssVATDistr(P) THEN
     L_General.Assert(L_iga.HasAction(L_iga.a_RedistributeVAT, L_Pmnt.ConvPer2VATClcPer(P)), " 믮 楤 ९஢   '।'");
    END;
   END;
  END;
 END {CheckRedistributeVAT};

 PRIVATE PROCEDURE PrintErrLine(ErrorDescr: STRING[]; IsException: SCAL[2]);
  CONST
   MaxDescriptionRows   = 10;
  VAR
   Idx,
   DescriptionRowLength: NUMERIC[0];
   Part                : STRING[];
   Desc                : STRING[][MaxDescriptionRows];
 BEGIN
  IF IsException THEN
   DescriptionRowLength:=108;
  ELSE
   DescriptionRowLength:=75;
  END;
  L_StdFrm.PrepareLongStringForASLPART(ErrorDescr, Desc, DescriptionRowLength);
  IF IsException THEN
   MAKEPART(ErrRep, Dlm);
   MAKEPART(ErrRep, ExcDsc, Desc[0]);
  ELSE
   MAKEPART(ErrRep, Line, Desc[0]);
  END;

  Idx:=1;
  WHILE (Idx<=HIGH(Desc)) & ~!Desc[Idx] DO
   IF IsException THEN
    MAKEPART(ErrRep, ExcDsc, Desc[Idx]);
   ELSE
    MAKEPART(ErrRep, AddLine, Desc[Idx]);
   END;
   INC(Idx);
  END;
 END {PrintErrLine};

 PRIVATE PROCEDURE AtFinalOfCountUp(trgOM: L_XObj.tOriginsMap; trgMyFirm: P_Firm.tMyFirm; Exc: Exc_Root);
 BEGIN
  OPENREP(ErrRep, L_General.rfn_byConnection(ErrRepName), Create);
  MAKEPART(ErrRep, PageTop, L_XObj.GetOriginsStr(trgOM, trgMyFirm));
  SELECT(ErrXO, toPrint);
  WHILE OCCURE(ErrXO) DO
   SEARCH(XObject, XObject, , ErrXO.XObject);
   PROMPT("⮢  " + ErrXO.Id);
   PrintErrLine(ErrXO.ErrDsc, 0);
   NEXT(ErrXO);
  END; (* WHILE OCCURE(ErrXO) ... *)
  IF    ~!Exc THEN
   PrintErrLine(" ࢠ: " + Exc.Description, 1);
  ELSIF ~SELECT(ErrXO, toPrint) THEN
   MAKEPART(ErrRep, Final, " 믮");
  END;
  MAKEPART(ErrRep, PageBot);
  CLOSEREP(ErrRep);
  IF    ~!Exc THEN
   L_General.HaltAndSurveyLastReport(Exc);
  ELSIF !L_bp.getCurId() & (curAction # a_Closing) THEN
   L_General.SurveyLastReport();
  END;
 END {AtFinalOfCountUp};

 PRIVATE PROCEDURE intCountUp(Selective: SCAL[2]);
  VAR
   trgOM    : L_XObj.tOriginsMap;
   trgMyFirm: P_Firm.tMyFirm;
 BEGIN
  L_General.SetCacheables(["mItem", "Storage"(*, "XObject"*)]);
  L_XObj.SetupOrigins(Selective, trgOM, trgMyFirm);
  L_AFM.MakeMultipleIndex("ErrXO", "XObject: " + TYPENAMEOF(XObject.XObject) + ";"+
                                   "Id     : " + TYPENAMEOF(STRING[16])      + ";"+
                                   "ErrDsc : " + TYPENAMEOF(STRING[1024]),
                           "XObject: XObject; toPrint: Id");
  TRY [TERMBYUSERMODE(TERMBYUSERMODE_THROW)]
   TotalErrorCnt:=0;
   DoByOriginsMap(trgOM, trgMyFirm);
  EXCEPT
  ON Exc:Exc_Root DO
   AtFinalOfCountUp(trgOM, trgMyFirm, Exc);
   L_General.CallUs(0);
  END;
  AtFinalOfCountUp(trgOM, trgMyFirm, EMPTYOF(Exc_Root));
 END {intCountUp};

 VAR
  oPrompt: OBJECT; (* PROMPTLINE *)

 PRIVATE PROCEDURE Setup(ProcDescr: STRING[]; wMsg: SCAL[3]);
 BEGIN
  oPrompt:=PROMPTLINE.Create(ProcDescr);
  IF    wMsg = 1 THEN
   L_StdFrm.Question(ProcDescr);
  ELSIF wMsg = 2 THEN
   L_StdFrm.Choice(ProcDescr);
  END;
 END {Setup};

 PUBLIC PROCEDURE CountUp();
  CONST
   bpId = "BadXO";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "  ", L_bp.t_Prc_wRp, L_General.tc_inMonth);
  curAction:=a_CountingUp;
  intCountUp(0);
  L_bp.End();
 END {CountUp};

 PUBLIC PROCEDURE SelectiveCountUp();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Setup("롮  楢 ⮢ ", 0);
  curAction:=a_CountingUp;
  intCountUp(1);
 END {SelectiveCountUp};

 PUBLIC PROCEDURE Clear();
  VAR
   trgOM    : L_XObj.tOriginsMap;
   trgMyFirm: P_Firm.tMyFirm;
 BEGIN
  curAction:=a_Clearing;
  Setup("C 楢 ⮢", 0);
  L_XObj.CheckClcPer(theSection);
  L_XObj.SetupOrigins(1, trgOM, trgMyFirm);
  L_AcsPnt.PassAccessPoint(0000038);
  L_General.SetCacheables(["XObject"]);
  DoByOriginsMap(trgOM, trgMyFirm);
 END {Clear};

 PRIVATE PROCEDURE intClose(P: DATE);
 BEGIN
  curAction:=a_Closing;
  intCountUp(0);
  IF TotalErrorCnt > 0 THEN
   L_StdFrm.RedInform(" 믮  楢 ⮢ ");
   L_General.HaltAndSurveyLastReport(EMPTYOF(Exc_Root));
  ELSE
   L_APtm.MonthAccess(P);
   CALL(Month.CloseMonth(L_APtm.system_Payments));
  END;
 END {intClose};

 PUBLIC PROCEDURE Close();
  VAR
   P : DATE;
 BEGIN
  L_AcsPnt.PassAccessPoint(0000027);
  P:=Memo.gl_mb();
  Setup("壠᪨ : ⨥  " + L_DatTim.PeriodStr(P), 2);
  L_APtm.MonthAccess(P);
  REPLACE(Month);

  CheckRedistributeVAT(P);
  L_Pmnt.CheckSpecialVATMDocDoneAll(L_General.EMPTY_NUMBER(), P);

  tst_RWayS();
  tst_JDoc();
  tst_MDoc();
  tst_PDoc();
  intClose(P);
  L_StdFrm.TimedINFORM(" " + L_DatTim.PeriodStr(P), 10);
 END {Close};

 PUBLIC PROCEDURE InternalClose();
  VAR
   P: DATE;
 BEGIN
  P:=Memo.gl_mb();
  Setup("⨥  " + L_DatTim.PeriodStr(P), 0);
  L_APtm.MonthAccess(P);
  REPLACE(Month);
  intClose(P);
 END {InternalClose};

 PRIVATE PROCEDURE CloseVATClcPer();
  VAR
   M, P: DATE;
   Text: STRING[];
 BEGIN
  curAction:=a_Closing;
  L_General.SilentAdminOnly();
  M:=Memo.gl_mb();
  Text:=" : ⨥  " + L_DatTim.PeriodStr(M);
  Setup(Text, 2);
  L_General.Assert(M = L_DatTim.Per(L_Pmnt.GetVATClcPerLastDay(M)),
                   "⨥    ᫥ ந  ᫥   ਮ");
  P:=L_Pmnt.ConvPer2VATClcPer(M);
  M:=P;
  WHILE L_Pmnt.ConvPer2VATClcPer(M) = P DO
   L_APtm.MonthAccess(M);
   REPLACE(Month);
   L_Pmnt.CheckSpecialVATMDocDoneAll(L_General.EMPTY_NUMBER(), M);
   L_APtm.MonthAccess(M);
   CALL(Month.CloseMonth(L_APtm.system_VAT));
   M:=L_DatTim.IncMonth(M, +1);
  END;
 END {CloseVATClcPer};

END.
