(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     C ਧ  ௫   㤭
%Type        operation
%Specific    SYS
%Modified    29.11.2013 19:31:01 POLAK\Gina
%Environment
*)

 MODULE A_ResSal [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_PRoll, L_Staff, L_DatTim, Memo, SysLog, L_General, L_bp, L_APtm, L_StdFrm, Math;

 PRIVATE PROCEDURE HasSomething(trgPer: DATE): SCAL[2];
 BEGIN
  RETURN SELECT(Money,   TSN,    Staff.TSN,    trgPer) |
         SELECT(Sheet,   TSN,    Staff.TSN,    trgPer) |
         SELECT(Monthly, TSN,    Staff.TSN,    trgPer) |
         SELECT(AvePay,  Period, trgPer, Staff.TSN);
 END {HasSomething};

 PRIVATE PROCEDURE Reset(M: STRING[]; P: PROC);
 VAR
  TotCnt,
  RealCnt: NUMERIC[0];
  DeadLineDate,
  curPer : DATE;
 BEGIN
  curPer:=Memo.ud_mb();
  L_StdFrm.Confirm(" १⮢  " + M + "  "+L_DatTim.PeriodStr(curPer));
  IF L_APtm.MonthIsClosed(curPer, L_APtm.system_Salary) THEN
   L_StdFrm.Confirm(L_DatTim.PeriodStr(curPer) + " ");
  END;

  DeadLineDate:=Math.Min(L_DatTim.IncMonth(curPer, -2), L_DatTim.YearBeg(curPer));
  SETZERO(TotCnt, RealCnt);
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN + " :  १⮢  " + M);
   INC(TotCnt);
   IF L_Staff.InStateInPer(DeadLineDate, Memo.ud_me()) | HasSomething(curPer) THEN
    INC(RealCnt);
    P(Math.Max(curPer, L_DatTim.Per(Staff.BegDate)), 0);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)

  L_StdFrm.Inform("ᥣ    "  + FLDTOSTR( TotCnt, "0", 6) +
                  "|襭 " + FLDTOSTR(RealCnt, "0", 6));
 END {Reset};

 PUBLIC PROCEDURE Reset_byTable();
 BEGIN
  L_bp.Begin("RSalT", "  ௫  ⠡", L_bp.t_Process, L_General.tc_inMonth);
  Reset(" ⠡", PROCREF(L_PRoll.ShtDone_AP));
  L_bp.End();
 END {Reset_byTable};

 PUBLIC PROCEDURE Reset_byDocs();
 BEGIN
  L_bp.Begin("RSalD", "  ௫  㬥⠬", L_bp.t_Process, L_General.tc_inMonth);
  SysLog.Mark("AvePay", L_DatTim.PeriodStr(Memo.ud_mb())+" : "+" १⮢   㬥⠬");
  Reset(" 㬥⠬", PROCREF(L_PRoll.AveDone_AP));
  L_bp.End();
 END {Reset_byDocs};

 PUBLIC PROCEDURE ResetDeducts();
 BEGIN
  Reset("㤥ঠ", PROCREF(L_PRoll.DedDone_AP));
 END {ResetDeduct};

 PUBLIC PROCEDURE ResetAVP();
 VAR
  TotCnt,
  RealCnt  : NUMERIC[0];
  PerReset,
  MonthB,
  MonthE   : DATE;
  NeedReset: SCAL[2];
 BEGIN
  MonthB:=Memo.ud_mb();
  MonthE:=L_DatTim.MonthEnd(MonthB);
  L_StdFrm.Confirm(" १⮢   㬥⠬|"+
                   "  㬥⮢  樥, ⠭  "+L_DatTim.PeriodStr(MonthB));
  IF L_APtm.MonthIsClosed(MonthB, L_APtm.system_Salary) THEN
   L_StdFrm.Confirm(L_DatTim.PeriodStr(MonthB) + " ");
  END;
  SysLog.Mark("AvePay", " १⮢   㬥⠬  裡  樥  "+L_DatTim.PeriodStr(MonthB));

  SETZERO(TotCnt, RealCnt);
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN + " :  १⮢ ");
   INC(TotCnt);

   NeedReset:=0; PerReset:=MAXOF(DATE);
   SETSEL(AvePay, EBDTSN, Staff.TSN);
   SRCINSEL(AvePay, GE, , MonthB);
   WHILE OCCURE(AvePay) DO
    IF L_DatTim.IsActiveInIntvl_Inc(MonthB, MonthE, AvePay.StartD, AvePay.StopD) > 0 THEN
     NeedReset:=1;
     PerReset :=Math.Min(PerReset, AvePay.Period);
    END;
    NEXT(AvePay);
   END; (* WHILE OCCURE(AvePay) ... *)

   IF NeedReset THEN
    INC(RealCnt);
    L_PRoll.AveDone_AP(PerReset, 0);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)

  L_StdFrm.Inform("ᥣ    "  + FLDTOSTR( TotCnt, "0", 6) +
                  "|襭 " + FLDTOSTR(RealCnt, "0", 6));
 END {ResetAVP};

END.
