(*
%Copyright   (c) Polak IT
%Author      04.06.2004 17:22:02 POLAK\ATS
%Purpose      ࠢ
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:13:35 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_Basis, L_Dspt, FIO, L_Str, P_DsptM, P_Firm, L_DatTim,
        Memo, DBD, L_XDoc, L_bp, L_ctc, L_ODoc;

 CONST
  e_Expired = 0;
  e_Absent  = 1;

 PRIVATE PROCEDURE BadDs_MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, " ࠢ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "室 ");
  L_Basis.wb_WrInQM(F, "ᮡ ࠢ");
  L_Basis.wb_WrInQM(F, "ᮡ ࠢ");
  L_Basis.wb_WrInQM(F, "ﭨ ⠢");
  L_Basis.wb_WrInQM(F, " ࣠");
  L_Basis.wb_WrInQM(F, " ࣠");
  L_Basis.wb_WrInQM(F, " ࣠ ( )");
  L_Basis.wb_WrInQM(F, " 襩 ࣠樨");
  L_Basis.wb_WrInQM(F, "㦠 ࣠");
  L_Basis.wb_WrInQM(F, "㦠 ࣠");
  L_Basis.wb_WrInQM(F, "㦠 ࣠ ( )");
  L_Basis.wb_WrInQM(F, " 㦮 ࣠樨");
  L_Basis.wb_WrInQM(F, " 裡");
  L_Basis.wb_WrInQM(F, " 裡");
  L_Basis.wb_WrInQM(F, " 裡 ( )");
  L_Basis.wb_WrInQM(F, "  裡");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "/६");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, " ᪮쪮");
  L_Basis.wb_WrInQM(F, "਩");
  L_Basis.wb_TermLine(F);
 END {BadDs_MakeHeader};

 PRIVATE PROCEDURE PutFirmData(F: STRING[]; _Firm: LIKE(Firm.Firm); _Date: DATE);
 BEGIN
  L_Basis.wb_WrScl(F, _Firm);
  IF ~!_Firm THEN
   L_Basis.wb_WrStr(F, P_Firm.FP_FirmShortName(_Firm, _Date));
   L_Basis.wb_WrStr(F, P_Firm.FP_FirmName(_Firm, _Date));
   L_Basis.wb_WrStr(F, L_ctc.GetAdr_Pst(_Date, _Firm));
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
 END {PutFirmData};

 PRIVATE PROCEDURE BadDs_MakePart(F          : STRING[];
                          curFirm,
                          curCSFirm  : LIKE(Firm.Firm);
                          curRefPoint: LIKE(DsptTime.RefPoint);
                          D          : DATE;
                          T          : TIME;
                          Problem    : SCAL[2];
                          Day        : NUMERIC[0]);
 BEGIN
  L_Basis.wb_WrStr(F, L_Dspt.GetDsptType_asStr());
  L_Basis.wb_WrScl(F, Dspt.DsptPck);
  L_Basis.wb_WrScl(F, Dspt.Dspt);
  L_Basis.wb_WrStr(F, Dspt.SrcNbr);
  L_Basis.wb_WrScl(F, Dspt.DsptMode);
  L_Basis.wb_WrStr(F, DsptMode.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Dspt.st_Pool, Dspt.Status));
  CONFORM(Dspt, MyFirm);
  PutFirmData(F, MyFirm.Firm, Dspt.Date);
  PutFirmData(F, curFirm,     Dspt.Date);
  PutFirmData(F, curCSFirm,   Dspt.Date);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Dspt.dt_RefPointPool, curRefPoint));
  L_Basis.wb_WrDat(F, D);
  L_Basis.wb_WrTim(F, T);
  L_Basis.wb_WrStr(F, L_DatTim.DateTimeStr(D, T));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("祭|", Problem));
  L_Basis.wb_WrNum(F, Day, 0);
  L_Basis.wb_WrStr(F, Dspt.Comment);
  L_Basis.wb_TermLine(F);
 END {BadDs_MakePart};

 PRIVATE PROCEDURE BadDs_MakeError(_RefPoint: LIKE(DsptTime.RefPoint);
                           Error    : SCAL[2];
                           _Day     : NUMERIC[0]);
  VAR
   _Date: DATE;
   _Time: TIME;
 BEGIN
  IF Error = e_Expired THEN
   _Date:=DsptTime.Date;
   _Time:=DsptTime.Time;
  ELSE
   SETEMPTY(_Date, _Time);
  END;
  BadDs_MakePart("R", Dspt.Firm, Dspt.CSFirm, _RefPoint, _Date, _Time, Error, _Day);
 END {BadDs_MakeError};

 PRIVATE PROCEDURE BadDs_MakeSingleType(_Type: LIKE(Dspt.Type));
  VAR
   DeadLines : P_DsptM.tDeadLine;
   Dummy     : P_DsptM.tTimeReq;
   LastDate  : DATE;
   i,
   Expiration: NUMERIC[0];
 BEGIN
  SELECT(Dspt, Date, , _Type);
  SRCINSEL(Dspt, GE, , Memo.ud_fr());
  WHILE OCCURE(Dspt) & (Dspt.Date <= Memo.ud_ut()) DO
   PROMPT(Dspt.Dspt);
   CONFORM(Dspt, DsptMode);
   P_DsptM.GetDeadline(Dspt.DsptMode, Dspt.Date, DeadLines, Dummy);
   SETEMPTY(LastDate);
   i:=0;
   WHILE i < L_Dspt.rp_Amount DO
    IF     ~!DeadLines[i] THEN
     IF SEARCH(DsptTime, Dspt, Dspt.Type, Dspt.Dspt, i) THEN
      IF !LastDate THEN
       LastDate:=Dspt.Date;
      END;
      Expiration:=DsptTime.Date - LastDate;
      IF Expiration > DeadLines[i] THEN
       BadDs_MakeError(DsptTime.RefPoint, e_Expired, Expiration-DeadLines[i]);
      END;
      LastDate:=DsptTime.Date;
     ELSIF !LastDate | (LastDate - Dspt.Date > DeadLines[i]) THEN
      BadDs_MakeError(i, e_Absent, 0);
      i:=L_Dspt.rp_Amount;
     END; (* IF SEARCH(DsptTime...*)
    END; (* IF ~!DeadLines[i]...*)
    INC(i);
   END; (* WHILE i < L_Dspt.rp_Amount...*)
   NEXT(Dspt);
  END; (* WHILE OCCURE(Dspt) ... *)
 END {BadDs_MakeSingleType};

 PRIVATE PROCEDURE BadDs();
  CONST
   bpId = "BadDs";
 BEGIN
  L_bp.Begin(bpId, " ࠢ  襭", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  BadDs_MakeHeader("R");
  BadDs_MakeSingleType(L_Dspt.t_Outgoing);
  BadDs_MakeSingleType(L_Dspt.t_Incoming);
  FIO.Close(R);
  L_bp.End();
 END {BadDs};

 PRIVATE PROCEDURE Dspt1_MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, " ࠢ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室 ");
  L_Basis.wb_WrInQM(F, "ᮡ ࠢ");
  L_Basis.wb_WrInQM(F, "ᮡ ࠢ");
  L_Basis.wb_WrInQM(F, "ﭨ ⠢");
  L_Basis.wb_WrInQM(F, " ࣠");
  L_Basis.wb_WrInQM(F, " ࣠");
  L_Basis.wb_WrInQM(F, " ࣠ ( )");
  L_Basis.wb_WrInQM(F, " 襩 ࣠樨");
  L_Basis.wb_WrInQM(F, "㦠 ࣠");
  L_Basis.wb_WrInQM(F, "㦠 ࣠");
  L_Basis.wb_WrInQM(F, "㦠 ࣠ ( )");
  L_Basis.wb_WrInQM(F, " 㦮 ࣠樨");
  L_Basis.wb_WrInQM(F, " 裡");
  L_Basis.wb_WrInQM(F, " 裡");
  L_Basis.wb_WrInQM(F, " 裡 ( )");
  L_Basis.wb_WrInQM(F, "  裡");
  L_Basis.wb_WrInQM(F, "਩");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "ਥ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "卮");
  L_Basis.wb_WrInQM(F, "儠⠄");
  L_Basis.wb_TermLine(F);
 END {Dspt1_MakeHeader};

 PRIVATE PROCEDURE SetFirmData(_Firm: LIKE(Firm.Firm); _Date: DATE; VAR _ShortName, _Name, _Addr: STRING[]);
 BEGIN
  IF ~!_Firm THEN
   _ShortName:=P_Firm.FP_FirmShortName(_Firm, _Date);
   _Name     :=P_Firm.FP_FirmName(_Firm, _Date);
   _Addr     :=L_ctc.GetAdr_Pst(_Date, _Firm);
  ELSE
   SETEMPTY(_ShortName, _Name, _Addr);
  END;
 END {SetFirmData};

 PRIVATE PROCEDURE Dspt1_MakePart(F: STRING[]; curFirm: LIKE(Firm.Firm));
  VAR
   OwnFirm,
   OwnFirm_ShortName,
   OwnFirm_Name,
   OwnFirm_Addr,
   Firm_ShortName,
   Firm_Name,
   Firm_Addr,
   CSFirm_ShortName,
   CSFirm_Name,
   CSFirm_Addr,
   SendDT,
   DeliveryDT,
   DocFile           : STRING[];
 BEGIN
  IF !curFirm | (Dspt.Firm = curFirm) THEN
   CONFORM(Dspt, DsptMode);
   CONFORM(Dspt, MyFirm);
   OwnFirm:=MyFirm.Firm;
   SetFirmData(OwnFirm,     Dspt.Date, OwnFirm_ShortName, OwnFirm_Name, OwnFirm_Addr);
   SetFirmData(Dspt.Firm,   Dspt.Date, Firm_ShortName,    Firm_Name,    Firm_Addr);
   SetFirmData(Dspt.CSFirm, Dspt.Date, CSFirm_ShortName,  CSFirm_Name,  CSFirm_Addr);
 
   IF SEARCH(DsptTime, Dspt, Dspt.Type, Dspt.Dspt, L_Dspt.rp_Send) THEN
    SendDT:=L_DatTim.DateTimeStr(DsptTime.Date, DsptTime.Time);
   ELSE
    SendDT:="";
   END;
 
   IF    Dspt.Type = L_Dspt.t_Outgoing THEN
    IF SEARCH(DsptTime, Dspt, Dspt.Type, Dspt.Dspt, L_Dspt.rp_Delivery) THEN
     DeliveryDT:=L_DatTim.DateTimeStr(DsptTime.Date, DsptTime.Time);
    ELSE
     DeliveryDT:="";
    END;
   ELSIF Dspt.Type = L_Dspt.t_Incoming THEN
    IF SELECT(DsptTime, Dspt, Dspt.Type, Dspt.Dspt) THEN
     LAST(DsptTime);
     DeliveryDT:=L_DatTim.DateTimeStr(DsptTime.Date, DsptTime.Time);
    ELSE
     DeliveryDT:="";
    END;
   ELSE
    L_General.CallUs(0);
   END;
 
   SELECT(DsptDoc, Dspt, , Dspt.Type, Dspt.Dspt);
   WHILE OCCURE(DsptDoc) DO
    L_Basis.wb_WrStr(F, L_Dspt.GetDsptType_asStr());
    L_Basis.wb_WrScl(F, Dspt.DsptPck);
    L_Basis.wb_WrScl(F, Dspt.Dspt);
    L_Basis.wb_WrDat(F, Dspt.Date);
    L_Basis.wb_WrStr(F, Dspt.SrcNbr);
    L_Basis.wb_WrScl(F, Dspt.DsptMode);
    L_Basis.wb_WrStr(F, DsptMode.Name);
    L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Dspt.st_Pool, Dspt.Status));
 
    L_Basis.wb_WrScl(F, OwnFirm);
    L_Basis.wb_WrStr(F, OwnFirm_ShortName);
    L_Basis.wb_WrStr(F, OwnFirm_Name);
    L_Basis.wb_WrStr(F, OwnFirm_Addr);
    L_Basis.wb_WrScl(F, Dspt.Firm);
    L_Basis.wb_WrStr(F, Firm_ShortName);
    L_Basis.wb_WrStr(F, Firm_Name);
    L_Basis.wb_WrStr(F, Firm_Addr);
    L_Basis.wb_WrScl(F, Dspt.CSFirm);
    L_Basis.wb_WrStr(F, CSFirm_ShortName);
    L_Basis.wb_WrStr(F, CSFirm_Name);
    L_Basis.wb_WrStr(F, CSFirm_Addr);
    L_Basis.wb_WrStr(F, Dspt.Comment);
    L_Basis.wb_WrStr(F, SendDT);
    L_Basis.wb_WrStr(F, DeliveryDT);
 
    L_XDoc.PositionOnXDoc(DsptDoc.XDocId);
    L_Basis.wb_WrStr(F, L_XDoc.Ref_FullName(DsptDoc.DocType));
    L_Basis.wb_WrScl(F, DsptDoc.DocKind);
    L_Basis.wb_WrStr(F, L_ODoc.GetXDocKindName(DsptDoc.XDocId));
    L_Basis.wb_WrStr(F, L_ODoc.GetXDocSrcNbr(DsptDoc.XDocId));
    L_Basis.wb_WrDat(F, L_ODoc.GetXDocSrcDate(DsptDoc.XDocId));
    L_Basis.wb_TermLine(F);
    NEXT(DsptDoc);
   END; (* WHILE OCCURE(DsptDoc) ... *)
  END;
 END {Dspt1_MakePart};

 PRIVATE PROCEDURE Dspt1_MakeRep(curFirm: LIKE(Firm.Firm));
 BEGIN
  Dspt1_MakeHeader("F");
  SELECT(Dspt, Date);
  WHILE OCCURE(Dspt) DO
   CHANGESEL(Dspt, Date, , Dspt.Type);
   SRCINSEL(Dspt, GE, , Memo.ud_fr());
   WHILE OCCURE(Dspt) & (Dspt.Date <= Memo.ud_ut()) DO
    PROMPT(Dspt.Dspt);
    Dspt1_MakePart("F", curFirm);
    NEXT(Dspt);
   END; (* WHILE OCCURE(Dspt) ... *)
   LAST(Dspt);
   CHANGESEL(Dspt, Date);
   NEXT(Dspt);
  END; (* WHILE OCCURE(Dspt) ... *)
 END {Dspt1_MakeRep};

 PRIVATE PROCEDURE Dspt1();
  CONST
   bpId = "Dspt1";
 BEGIN
  L_bp.Begin(bpId, " ࠢ", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  Dspt1_MakeRep(L_General.EMPTY_NUMBER());
  FIO.Close(F);
  L_bp.End();
 END {Dspt1};

 PRIVATE PROCEDURE Dspt1_ByCurFirm();
  CONST
   RepName = "Dspt1";
  VAR
   Title: STRING[];
 BEGIN
  L_General.Assert(ACCESS(Firm), " ⠭ ⥪騩 'ࠣ'");
  Title:=" ࠢ  ࠣ " + Firm.Firm + " " + Firm.Name;
  FIO.Open(F, L_General.NameConnection(RepName), "REP", Create);
  Dspt1_MakeRep(Firm.Firm);
  FIO.Close(F);
  L_Basis.PlayMakedRunTimeRep(RepName, L_General.timeCond_InIntvl, Title, 0);
 END {Dspt1_ByCurFirm};

END.
