(*
%Copyright   (c) Polak Computer System
%Author      26.12.1997 21:26:49 GINA
%Purpose     ஫  ப Bank,   
%Type        control,operation
%Specific    SYS
%Modified    21.03.2014 15:50:45 POLAK\San
%Environment MODE = 090 -   
*)

 MODULE Bank [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_DatTim, L_General, Str, L_Str, L_OwnData, L_Events, L_AFM,
        P_Firm;

 VAR
  _Date,
  _Till : DATE;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
############################################################# ########## #####
==============================================================================
|                    ᮪ ,   #########                    |
|############################################################################|
|----------------------------------------------------------------------------|
|                   ||      |ᯮ.  |  |    |
|-----------------------|---|---------|--------------------|--------|--------|
}
*)

(*
$P{ Line:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, "DNy"
?, L, "DNy"
@
|### ###################|###|#########|####################|########|########|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE lb_OnDateCond(BegD, EndD: DATE): SCAL[2];
 BEGIN
  RETURN L_DatTim.IsActive(Memo.ud_cd(), BegD, EndD);
 END {lb_OnDateCond};

 PRIVATE PROCEDURE lb_InPeriodCond(BegD, EndD: DATE): SCAL[2];
 BEGIN
  RETURN L_DatTim.IsActiveInIntvl_Inc(BegD, EndD, Memo.ud_fr(), Memo.ud_ut());
 END {lb_InPeriodCond};

 PRIVATE PROCEDURE lb_AllCond(BegD, EndD: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {lb_AllCond};

 PRIVATE PROCEDURE lb_AfterEdInsCond(BegD, EndD: DATE): SCAL[2];
 BEGIN
  RETURN L_DatTim.IsActiveInIntvl_Inc(BegD, EndD, _Date, _Till);
 END {lb_AfterEdInsCond};

 PRIVATE PROCEDURE _LookBIC(_Str, File: STRING[]; FullBIC, ToPrint: SCAL[2]; Cond: PROC);
  VAR
   _BankBrn: LIKE(BankBrnL.BankBrn);
   _Bank   : LIKE(Bank.Bank);
 BEGIN
  IF ~!_Str THEN
   IF ~ToPrint THEN
    _Bank:=Bank.Bank;
   END;
   IF FullBIC THEN
    SELECT(^File, BIC, , _Str);
   ELSE
    SELECT(^File, Bank);
   END;
   WHILE OCCURE(^File) DO
    IF Str.Match(^File.BIC, _Str) & Cond(^File.Date, ^File.Till) THEN
     IF ToPrint THEN
      SETEMPTY(_BankBrn);
      IF File = "BankBrnL" THEN
       _BankBrn:=BankBrnL.BankBrn;
      END;
      MAKEPART(R, Line, ^File.Bank, ^File.RegName[0], _BankBrn, ^File.BIC,
                        ^File.CorAcnt, ^File.Date, ^File.Till);
     ELSIF (_Bank # ^File.Bank) THEN
      IF    File="BankLog" THEN
       L_General.Error("  㦥   |" +
                       BankLog.Bank + " " + BankLog.RegName[0]);
      ELSIF File="BankBrnL" THEN
       CONFORM(BankBrnL, BankBrn, Bank);
       L_General.Error(" " + _Str +  " 㦥   䨫:" + "|" +
                        BankBrn.BankBrn + " " + BankBrn.Name + "|" +
                       ":" + "|" +
                       Bank.Bank + " " + Bank.Name);
      ELSE
       L_General.Error("  㦥   |" +
                       ^File.Bank + " " + ^File.RegName[0]);
      END;
     END;
    END;
    NEXT(^File);
   END; (* WHILE OCCURE(^File) ... *)
  END;
 END {_LookBIC};

 PRIVATE PROCEDURE LookBIC(_Str: STRING[]);
 BEGIN
  _LookBIC(_Str, "BankLog",  1, 0, PROCREF(lb_AfterEdInsCond));
  _LookBIC(_Str, "BankBrnL", 1, 0, PROCREF(lb_AfterEdInsCond));
 END {LookBIC};

 PUBLIC PROCEDURE LookBIC_ToPrint();
  VAR
   Cond    : PROC;
   _Str    : LIKE(BIC.BIC);
   CondPool: STRING[];
   Choice  : NUMERIC[0];
   FullBIC : SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Choice:=0;
  _Str:="";
  CondPool:="  " + L_DatTim.DateStr(Memo.tmp_cd()) + "|" +
            " ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut()) + "|" +
            "  ";
  STDFORM("|᪮  %9FI %AI||%< ᪠ >DB  %< ⬥ >X",
          "  , 騥  ", INFORM, -1, _Str, CondPool, Choice);
  IF    Choice = 0 THEN
   Cond:=PROCREF(lb_OnDateCond);
  ELSIF Choice = 1 THEN
   Cond:=PROCREF(lb_InPeriodCond);
  ELSIF Choice = 2 THEN
   Cond:=PROCREF(lb_AllCond);
  END;
  OPENREP(R, L_General.NameConnection("LkBIC"), Create);
  MAKEPART(R, Top, _Str, L_Str.PoolItem(CondPool, Choice));
  FullBIC:=Str.Length(_Str) = 9;
  IF ~FullBIC THEN
   _Str:="*" + _Str + "*";
  END;
  _LookBIC(_Str, "BankLog",  FullBIC, 1, Cond);
  _LookBIC(_Str, "BankBrnL", FullBIC, 1, Cond);
  MAKEPART(R, Bot);
  CLOSEREP(R);
  LIKEMENU(Survey, "");
 END {LookBIC_ToPrint};

 PRIVATE PROCEDURE SupportBankBrnLTill(WithCur: SCAL[2]);
  VAR
   CurDate,
   _Date: DATE;
 BEGIN
  CurDate:=BankBrnL.Date;
  SAVE(BankBrnL);
  SETSEL(BankBrnL, Bank, BankBrnL.Bank, BankBrnL.BankBrn);
  IF LAST(BankBrnL) & ~WithCur & (BankBrnL.Date = CurDate) THEN
   PREV(BankBrnL);
  END;
  IF OCCURE(BankBrnL) THEN
   BankBrnL.Till:=BankBrn.Till;
   REPLACE(BankBrnL);
   _Date:=BankBrnL.Date;
   WHILE PREV(BankBrnL) DO
    IF WithCur | (BankBrnL.Date # CurDate) THEN
     BankBrnL.Till:=_Date;
     REPLACE(BankBrnL);
     _Date:=BankBrnL.Date;
    END;
   END; (* WHILE  ... *)
   BankBrn.Begin:=_Date;
   REPLACE(BankBrn);
  END;
  RESTORE(BankBrnL);
 END {SupportBankBrnLTill};

 PRIVATE PROCEDURE SupportBankLogTill(WithCur: SCAL[2]);
  VAR
   CurDate,
   _Date: DATE;
 BEGIN
  CurDate:=BankLog.Date;
  SAVE(BankLog);
  SETSEL(BankLog, Bank, BankLog.Bank);
  IF LAST(BankLog) & ~WithCur & (BankLog.Date = CurDate) THEN
   PREV(BankLog);
  END;
  IF OCCURE(BankLog) THEN
   BankLog.Till:=Bank.Till;
   REPLACE(BankLog);
   _Date:=BankLog.Date;
   WHILE PREV(BankLog) DO
    IF WithCur | (BankLog.Date # CurDate) THEN
     BankLog.Till:=_Date;
     REPLACE(BankLog);
     _Date:=BankLog.Date;
    END;
   END; (* WHILE  ... *)
   Bank.Begin:=_Date;
   REPLACE(Bank);
  END;
  RESTORE(BankLog);
 END {SupportBankLogTill};

 PRIVATE PROCEDURE TheSameBICasBankBIC(_Date: LIKE(BankBrnL.Date); _BIC: LIKE(BankBrnL.BIC)): SCAL[2];
  VAR
   Found: SCAL[2];
 BEGIN
  Found:=0;
  IF ~!_BIC THEN
   SAVE(BankLog);
   SETSEL(BankLog, Bank, Bank.Bank);
   SRCINSEL(BankLog, LE, , _Date);
   WHILE OCCURE(BankLog) & (BankLog.BIC # _BIC) DO
    NEXT(BankLog);
   END; (* WHILE OCCURE(BankLog) ... *)
   Found:=OCCURE(BankLog);
   RESTORE(BankLog);
   RETURN Found;
  END;
  RETURN Found;
 END {TheSameBICasBankBIC};

 PRIVATE PROCEDURE TheSameCorAcntasBankCorAcnt(_Date   : LIKE(BankBrnL.Date);
                                               _CorAcnt: LIKE(BankBrnL.CorAcnt)): SCAL[2];
  VAR
   Found: SCAL[2];
 BEGIN
  Found:=0;
  IF ~!_CorAcnt THEN
   SAVE(BankLog);
   SETSEL(BankLog, Bank, Bank.Bank);
   SRCINSEL(BankLog, LE, , _Date);
   WHILE OCCURE(BankLog) & (BankLog.CorAcnt # _CorAcnt) DO
    NEXT(BankLog);
   END; (* WHILE OCCURE(BankLog) ... *)
   Found:=OCCURE(BankLog);
   RESTORE(BankLog);
  END;
  RETURN Found;
 END {TheSameCorAcntasBankCorAcnt};

 PRIVATE PROCEDURE _Assert(Cond: SCAL[2]; ErrText: STRING[]);
 BEGIN
  L_General.Assert(Cond, " ᫥ 㪠뢠 " + ErrText + " 䨫,|" +
                         "ᮢ騩   ⤥");
 END {_Assert};

 PRIVATE PROCEDURE SplitBICName(VAR Name, Region: STRING[]);
  CONST
   PType = "  | | - |  |  ";
  VAR
   i,
   p  : NUMERIC[0];
   Tmp: STRING[];
 BEGIN
  SETEMPTY(Region);
  i:=0;
  LOOP
   Tmp:=L_Str.PoolItem(PType, i);
   IF !Tmp THEN
    RETURN;
   END;
   p:=Str.Pos(Str.Cap(Name), Tmp, , BACKWARD);
   IF p < Str.Length(Name) THEN
    Region:=Str.Slice(Name, p, Str.Length(Name));
    IF  Str.Match(Str.Small(Region), "*᪢*") &
       ~Str.Match(Str.Small(Region), "*᪢*") THEN
     SETEMPTY(Region);
    ELSE
     IF L_Str.Right(Name, 1) = "," THEN
      DEC(p);
     END;
     Name:=Str.Delete(Name, p, Str.Length(Name));
    END;
    Name  :=Str.Condense(Name);
    Region:=Str.Condense(Region);
    RETURN;
   END;
   INC(i);
  END; (* LOOP ... *)
 END {SplitBICName};

 PRIVATE PROCEDURE ANY_BIC_OnSuccessfulChange();
  VAR
   curTable          : TABLE;
   curFieldExpression,
   curName,
   curRegion         : STRING[];
 BEGIN
  curFieldExpression:=RTI.Get().CurZone.ActiveField.Expression;
  IF ~!^(curFieldExpression) THEN
   IF SEARCH(BIC, BIC, ^(curFieldExpression)) THEN
    curTable:=RTI.Get().CurZone.MasterTable;
    curName:=BIC.Name;
    SplitBICName(curName, curRegion);
    ^(curTable.Fields("CorAcnt").ObtainName()):=BIC.CorAcnt;
    ^(curTable.Fields("Region" ).ObtainName()):=curRegion;
    L_Str.FormatStr(^(curTable.Fields("RegName").ObtainName()),
                    curName,
                    Str.MaxLength(^(curTable.Fields("RegName").ObtainName(0))));
    REPLACE(^(curTable.Name));
   END;
  END;
 END {ANY_BIC_OnSuccessfulChange};

 PRIVATE PROCEDURE BankBrnL_BIC_OnSuccessfulChange();
 BEGIN
  ANY_BIC_OnSuccessfulChange();
 END {BankBrnL_BIC_OnSuccessfulChange};

 PRIVATE PROCEDURE BankLog_BIC_OnSuccessfulChange();
 BEGIN
  ANY_BIC_OnSuccessfulChange();
 END {BankLog_BIC_OnSuccessfulChange};

 PRIVATE PROCEDURE BankLog_Date_OnSuccessfulChange();
 BEGIN
  L_General.Assert(BankLog.Date < Bank.Till,
                   " " + L_DatTim.DateStr(BankLog.Date) + "  㦥 ");
 END {BankLog_Date_OnSuccessfulChange};

 PRIVATE PROCEDURE Bank_Till_OnSuccessfulChange();
 BEGIN
  IF SELECT(BankLog, Bank, Bank.Bank) THEN
   L_General.Assert(~SRCINSEL(BankLog, GE, Bank.Till),
                    "   ਨ ४⮢  " +
                    L_DatTim.DateStr(Bank.Till));
   SELECT(BankLog, Bank, , Bank.Bank);
   SupportBankLogTill(1);
  END;
 END {Bank_Till_OnSuccessfulChange};

 PRIVATE PROCEDURE BankBrnL_Date_OnSuccessfulChange();
 BEGIN
  L_General.Assert(BankBrnL.Date < BankBrn.Till,
                   " " + L_DatTim.DateStr(BankBrnL.Date) + "  㦥 ");
 END {BankBrnL_Date_OnSuccessfulChange};

 PRIVATE PROCEDURE BankBrn_Till_OnSuccessfulChange();
 BEGIN
  IF SELECT(BankBrnL, Bank, BankBrn.Bank, BankBrn.BankBrn) THEN
   L_General.Assert(~SRCINSEL(BankBrnL, GE, BankBrn.Till),
                    "   ਨ ४⮢  " +
                    L_DatTim.DateStr(BankBrn.Till));
   SELECT(BankBrnL, Bank, , BankBrn.Bank, BankBrn.BankBrn);
   SupportBankBrnLTill(1);
  END;
 END {BankBrn_Till_OnSuccessfulChange};

(*
$P{ Using_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
Bank.Bank, L, ""
Bank.Name, L, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|----------------------------------------------------------------------------|
| ### ###################################################################|
|----------------------------------------------------------------------------|
|ࠣ                        |-|                   |     |    |
|----------------------------------|---|-----------------------|------|------|
}
*)

(*
$P{ Using_Line:
Firm.Firm, L, ""
Firm.Name, L, ""
FirmAcnt.BankBrn, L, ""
FirmAcnt.FirmAcnt, L, ""
FirmAcnt.AcntA, L, ""
FirmAcnt.Begin, L, "DNY"
FirmAcnt.Till, L, "DNY"
@
|#### #############################|###|## ####################|######|######|
}
*)

(*
$P{ Using_Bot:
?, R, "0"
@
|----------------------------------------------------------------------------|
|⮣ ࠣ⮢ ####                                                     |
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE PrepareTmp(Cond: PROC);
 BEGIN
  CreateFILE(Tmp, "", "஢", "");
  CreateFIELD(Tmp, Firm,      LIKE(FirmAcnt.Firm),     "", "", "", "", "");
  CreateFIELD(Tmp, FirmAcnt,  LIKE(FirmAcnt.FirmAcnt), "", "", "", "", "");
  CreateINDEXandLINK(Tmp, FirmAcnt, PLURAL, FirmAcnt, FirmAcnt, USER, "", "",
                     Firm, FirmAcnt);
  SetVersionOfFILE(Tmp, 0000);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");

  SELECT(FirmAcnt, Bank, , Bank.Bank);
  WHILE OCCURE(FirmAcnt) DO
   PROMPT("C஢ - " + FirmAcnt.Firm + " " + FirmAcnt.FirmAcnt);
   IF Cond() THEN
    Tmp.Firm    :=FirmAcnt.Firm;
    Tmp.FirmAcnt:=FirmAcnt.FirmAcnt;
    INSERT(Tmp);
   END;
   NEXT(FirmAcnt);
  END; (* WHILE OCCURE(FirmAcnt) ... *)
 END {PrepareTmp};

 PRIVATE PROCEDURE MakeUsing_Rep(RepName, RepCondStr: STRING[]; Cond: PROC);
  VAR
   Count: NUMERIC[0];
 BEGIN
  L_General.Assert(ACCESS(Bank), " ⠭ ");
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  PrepareTmp(Cond);

  Count:=0;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Using_Top, RepName, "ᯮ짮  " + RepCondStr);

  SELECT(Tmp, FirmAcnt);
  WHILE OCCURE(Tmp) DO
   PROMPT(Tmp.Firm + " " + Tmp.FirmAcnt);
   CONFORM(Tmp, FirmAcnt);
   CONFORM(FirmAcnt, Firm);
   MAKEPART(R, Using_Line);
   INC(Count);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)

  MAKEPART(R, Using_Bot, Count);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("Tmp");
  LIKEMENU(Survey, "");
 END {MakeUsing_Rep};

 PRIVATE PROCEDURE CurDateCond(): SCAL[2];
 BEGIN
  RETURN L_DatTim.IsActive(Memo.ud_cd(), FirmAcnt.Begin, FirmAcnt.Till);
 END {CurDateCond};

 PRIVATE PROCEDURE PeriodCond(): SCAL[2];
 BEGIN
  RETURN L_DatTim.IsActiveInIntvl(FirmAcnt.Begin, FirmAcnt.Till, Memo.ud_fr(), Memo.ud_ut());
 END {PeriodCond};

 PRIVATE PROCEDURE AlltimeCond(): SCAL[2];
 BEGIN
  RETURN 1;
 END {AlltimeCond};

 PRIVATE PROCEDURE Bank_OnAfterEdIns();
 BEGIN
  (*dummy 0093370 30.08.2012 14:13:07 POLAK\Bor*)
 END {Bank_OnAfterEdIns};

 PRIVATE PROCEDURE Bank_OnAfterEdit();
 BEGIN
  Bank_OnAfterEdIns();
 END {Bank_OnAfterEdit};

 PRIVATE PROCEDURE Bank_OnAfterInsert();
 BEGIN
  Bank_OnAfterEdIns();
 END {Bank_OnAfterInsert};

 PRIVATE PROCEDURE BankLog_OnAfterEdIns();
 BEGIN
  P_Firm.CheckCorAcnt(BankLog.BIC, BankLog.CorAcnt);
  SupportBankLogTill(1);
  _Date:=BankLog.Date;
  _Till:=BankLog.Till;
  LookBIC(BankLog.BIC);
 END {BankLog_OnAfterEdIns};

 PRIVATE PROCEDURE BankLog_OnAfterInsert();
 BEGIN
  BankLog_OnAfterEdIns();
 END {BankLog_OnAfterInsert};

 PRIVATE PROCEDURE BankLog_OnAfterEdit();
 BEGIN
  BankLog_OnAfterEdIns();
 END {BankLog_OnAfterEdit};

 PRIVATE PROCEDURE BankBrnL_OnAfterEdIns();
 BEGIN
  CONFORM(BankBrnL, BankBrn, Bank);
  HISTCONF(BankBrnL.Date, Bank, BankLog);
  IF OCCURE(BankLog) THEN
   L_General.Assert(~P_Firm.IsRKC(BankLog.BIC), "    䨫");
  END;
  _Assert(~TheSameBICasBankBIC(BankBrnL.Date, BankBrnL.BIC), "");
  IF ~!BankBrnL.BIC THEN
   L_General.Assert(~!BankBrnL.CorAcnt, " 稨 ᮡ⢥      . ");
  END;
  _Assert(~TheSameCorAcntasBankCorAcnt(BankBrnL.Date, BankBrnL.CorAcnt), ". ");
  IF ~!BankBrnL.CorAcnt THEN
   IF !BankBrnL.BIC THEN
    SETSEL(BankLog, Bank, Bank.Bank);
    L_General.Assert(SRCINSEL(BankLog, LE, BankBrnL.Date) &
                     (BankLog.Till > BankBrnL.Date) &
                     ~!BankLog.BIC, "    ⤥  " +
                                    L_DatTim.DateStr(BankBrnL.Date));
    P_Firm.CheckCorAcnt(BankLog.BIC, BankBrnL.CorAcnt);
   ELSE
    P_Firm.CheckCorAcnt(BankBrnL.BIC, BankBrnL.CorAcnt);
   END;
  END;
  SupportBankBrnLTill(1);
  _Date:=BankBrnL.Date;
  _Till:=BankBrnL.Till;
  LookBIC(BankBrnL.BIC);
 END {BankBrnL_OnAfterEdIns};

 PRIVATE PROCEDURE BankBrnL_OnAfterInsert();
 BEGIN
  BankBrnL_OnAfterEdIns();
 END {BankBrnL_OnAfterInsert};

 PRIVATE PROCEDURE BankBrnL_OnAfterEdit();
 BEGIN
  BankBrnL_OnAfterEdIns();
 END {BankBrnL_OnAfterEdit};

 PRIVATE PROCEDURE BankLog_OnBeforeDelete();
 BEGIN
  SupportBankLogTill(0);
 END {BankLog_OnBeforeDelete};

 PRIVATE PROCEDURE BankBrnL_OnBeforeDelete();
 BEGIN
  SupportBankBrnLTill(0);
 END {BankBrnL_OnBeforeDelete};

 PUBLIC PROCEDURE UsingOnDay();
 BEGIN
  MakeUsing_Rep("CBanD", " " + L_DatTim.DateStr(Memo.tmp_cd()), PROCREF(CurDateCond));
 END {UsingOnDay};

 PUBLIC PROCEDURE UsingForPeriod();
 BEGIN
  MakeUsing_Rep("CBanM", " ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) +
                "  " + L_DatTim.DateStr(Memo.ud_ut()),
                PROCREF(PeriodCond));
 END {UsingForPeriod};

 PUBLIC PROCEDURE UsingForAllHistory();
 BEGIN
  MakeUsing_Rep("CBanP", "  ", PROCREF(AlltimeCond));
 END {UsingForAllHistory};

BEGIN
 L_Events.ExecuteHandler();
END.
