(*
%Copyright   (c) Polak Computer System
%Author      12.01.2001 19:26:01 GINA
%Purpose       BIC
%Type        control,operation
%Specific    SYS
%Modified    15.05.2014 17:42:55 POLAK\Gina
%Environment
*)

 MODULE BIC [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, DBF, Str, FIO, L_ExtDB, L_HTTP, L_Str, L_StdFrm, L_DatTim, L_bp, L_Events, L_FIO, L_WDO;

 PRIVATE PROCEDURE BIC_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Bank";
  L_WDO.iZone(0).OnRedraw:=1;
  L_WDO.iZone(1).ViewOnly:=1;
 END {BIC_OnInitializeWindow};

 PRIVATE PROCEDURE BIC_0_OnRedraw();
 BEGIN
  RTI.Get().CurZone.Fields("ff_FileTime").Value:=GETFILETIME(BIC);
 END {BIC_0_OnRedraw};

 PUBLIC PROCEDURE Clear();
 BEGIN
  FLOCK(BIC, Monopol);
  INTEGRITY(NoAsk);
  SELECT(BIC, BIC);
  WHILE OCCURE(BIC) DO
   PROMPT("⪠ ० : " + BIC.BIC);
   REMOVE(BIC);
  END; (* WHILE OCCURE(BIC) ... *)
  INTEGRITY(Off);
 END {Clear};

 PUBLIC PROCEDURE BICImport();
  CONST
   bpId = "BICIm";
   tnpCodes_Pool = "1|2|3|4|5|6|7";
   tnpNames_Pool = "||||-||";

   zipURL = "http://www.cbr.ru/mcirabis/BIK/";
(*
   zipURL = "http://www.mybank-nsk.ru/downloads/bnkseek.zip";
   zipURL = "http://www.pay.avtobank.ru/elclient/BIC/cat_bic.zip";
   zipURL = "http://polakit.narod.ru/cat_bic.zip";
   zipURL = "http://autopark.ru/store/sic/cat_bic.zip";
*)
   RussianBICMask = "04???????";
  VAR
   i, BICCntInDbf : NUMERIC[0];
   zipFullURL,
   dbf_BIC,
   dbf_CorAcnt    : STRING[];
   asName,
   zipFN,
   zipFullFN,
   dbfFullFN,
   tmpFolder      : STRING[];
   tnpCode        : NUMERIC[0];
   tnpName        : STRING[];
   insCnt,
   rplCnt,
   delCnt         : NUMERIC[0];
   trgDate,
   DbfFileDate    : DATE;
   SuccessDownload: SCAL[2];
 BEGIN
  L_bp.extBegin(bpId, " ", L_bp.t_Process, L_General.tc_Entire, L_bp.pt_Low);
  FLOCK(BIC, Monopol);

  trgDate  :=SYSDATE();
  tmpFolder:=FIO.MakePath(FLDTOSTR(trgDate, "DNy"), , FIO.AsbSpecialFolders("ASBTemp"));
  L_FIO.MakeSubDirs(tmpFolder);

  SuccessDownload:=0;
  i              :=0;
  WHILE (i < 10) & ~SuccessDownload DO
   IF L_DatTim.IsWorkDay(trgDate) THEN
    zipFN     :="bik_db_"+FLDTOSTR(trgDate, "DNy") + ".zip";
    zipFullFN :=FIO.MakePath(zipFN, , tmpFolder);
    zipFullURL:=zipURL + zipFN;
    PROMPT("㧪  ୥: " + zipFullURL);
    SuccessDownload:=L_HTTP.httpGetFile(zipFullURL, zipFullFN);
    INC(i);
   END;
   DEC(trgDate);
  END; (* WHILE i < 10...*)

  dbfFullFN:=FIO.MakePath("bnkseek", "dbf", tmpFolder);
  IF SuccessDownload THEN
   PROMPT("祭  娢: " + zipFN);
   IF L_General.Launch_PKUNZIP("-over=all -nofix -nozip -mask=none",
                               zipFullFN,
                               tmpFolder) = L_General.eprc_Normal THEN
    DbfFileDate:=L_DatTim.GetDateOfTIMESTAMP(L_FIO.GetFileLastModifiedDTS(dbfFullFN));

    TRY
     IF (DbfFileDate + 10) < SYSDATE() THEN
      L_StdFrm.Choice("㦠 䠩  ᫨誮 ॢ : " + L_DatTim.DateStr(DbfFileDate));
     END;
     L_ExtDB.MakeDBFMirror("_bic", dbfFullFN, "newnum");
    EXCEPT
    FINALLY
     L_FIO.RemoveDir(tmpFolder);
    END; (* TRY *)

    SETZERO(insCnt, rplCnt, delCnt);
    SELECT(_bic, newnum);
    SELECT(BIC, BIC);
    BICCntInDbf := AMOUNT(_bic);
    i           := 0;
    WHILE OCCURE(_bic) DO
     PROMPT("ࠡ⪠ ப " + FLDTOSTR(i, "0", 0) + " (" + FLDTOSTR(i/BICCntInDbf*100, "0", 0) + "%)");
     dbf_BIC := _bic.newnum;
     IF Str.Match(dbf_BIC, RussianBICMask) THEN
      WHILE OCCURE(BIC) & (BIC.BIC < dbf_BIC) DO
       REMOVE(BIC);
       INC(delCnt);
      END;
      asName:=_bic.namep;
      IF ~!_bic.nnp THEN
       IF ~!_bic.tnp THEN
        tnpCode  := L_Str.PositionInPool(tnpCodes_Pool, _bic.tnp);
        L_General.CallUs(~!tnpCode);
        tnpName   := L_Str.PoolItem(tnpNames_Pool, tnpCode);
        asName:=asName + " " + tnpName;
       END;
       asName := asName + " " + _bic.nnp;
      END;
      dbf_CorAcnt := _bic.ksnp;
      IF OCCURE(BIC) & (BIC.BIC = dbf_BIC) THEN
       IF (BIC.CorAcnt # dbf_CorAcnt) | (BIC.Name # asName) THEN
        BIC.CorAcnt := dbf_CorAcnt;
        BIC.Name    := asName;
        IF BIC.Name # asName THEN
         L_General.CallUs(BIC.Name = asName);
        END;
        REPLACE(BIC);
        INC(rplCnt);
       END;
      ELSE
       BIC.BIC     := dbf_BIC;
       BIC.CorAcnt := dbf_CorAcnt;
       BIC.Name    := asName;
       INSERT(BIC);
       INC(insCnt);
      END;
      NEXT(BIC);
     END;
     NEXT(_bic); INC(i);
    END;
    L_ExtDB.PurgeDBFMirror("_bic");

    L_StdFrm.Inform(" १  ࠢ筨 " +
                    "||" +
                    " "  + L_Str.IntStr(insCnt) +
                    ",  " + L_Str.IntStr(rplCnt) +
                    ", 㤠 "  + L_Str.IntStr(delCnt) + " ᥩ");
   END; (* IF *)
  ELSE
   L_General.Error(" 㤠  㠫 ࠢ筨   " + L_DatTim.DateStr(SYSDATE()) + ".||" +
                   "  ୥: " + zipURL);
  END; (* IF *)
  L_bp.End();
 END {BICImport};

BEGIN
 L_Events.ExecuteHandler();
END.
