(*
%Copyright   (c) Polak IT
%Author      06.08.2010 13:02:44 POLAK\ssv
%Purpose     ࠢ 믮  楤
%Type
%Specific    SYS
%Modified    13.11.2013 11:44:18 POLAK\LDA
%Environment
*)

 MODULE bp [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, L_DatTim, L_Str, L_bp, Memo, Str, L_StdFrm,
        L_AcsPnt, Math, P_OwnData, L_Msg, L_FIO, L_Basis, FIO, L_lsStore,
        L_AFM, L_WDO, Shell, L_AR, L_ACL, L_Timer, L_Guard, L_SysLog;

 PRIVATE TYPE
  tQueueAction    = SCAL[2];
  tSetupAction    = SCAL[6];

 PRIVATE CONST
  act_Delete      = 0;
  act_Edit        = 1;

  act_Pool        = "㤠|஢";

  ap_MayInsert    = 0000047;
  ap_MayModify    = 0000048;

  spe_ExecCurPacket = 0;
  spe_AddPacket     = 1;
  spe_AddCurrentBP  = 2;
  spe_EditQueueBP   = 3;
  spe_ViewQueueBP   = 4;
  spe_Add_bpRT      = 5;

  Timer_bpSh  = "View_bpSh";

 PRIVATE VAR
  sav_cd,
  sav_fr,
  sav_ut : DATE;

 PRIVATE PROCEDURE GetMemoDates(VAR cd, fr, ut: DATE);
 BEGIN
  cd:=Memo.ud_cd();
  fr:=Memo.ud_fr();
  ut:=Memo.ud_ut();
 END {GetMemoDates};

 PRIVATE PROCEDURE SetMemoDates(cd, fr, ut: DATE);
 BEGIN
  IF ~!cd THEN
   Memo.UIP_SetCurDate(cd);
  END;
  L_General.CallUs(!fr = !ut);
  IF ~!fr THEN
   Memo.UIP_SetIntvl(fr, ut);
  END;
 END {SetMemoDates};

 PRIVATE PROCEDURE Batch_Begin();
 BEGIN
  L_General.BatchExecution_Begin(EMPTYOF(AcsObj.AcsObj));
  GetMemoDates(sav_cd, sav_fr, sav_ut);
 END {Batch_Begin};

 PRIVATE PROCEDURE Batch_End();
 BEGIN
  SetMemoDates(sav_cd, sav_fr, sav_ut);
  L_General.BatchExecution_End();
 END {Batch_End};

 PRIVATE PROCEDURE initTimes_Single(VAR cd, fr, ut: DATE);
 BEGIN
  L_bp.convTimes(bp.TimeCond, cd, fr, ut);
 END {initTimes};

 PRIVATE PROCEDURE initTimes_Packet(VAR cd, fr, ut: DATE);
  VAR
   tmp_cd,
   tmp_fr,
   tmp_ut : DATE;
   cnt_cd,
   cnt_pd : NUMERIC[0];
 BEGIN
  SETZERO(cnt_cd, cnt_pd);
  SELECT(bpPL, bpP, , bpP.bpP);
  WHILE OCCURE(bpPL) & (~cnt_cd | ~cnt_pd) DO
   tmp_cd:=cd;
   tmp_fr:=fr;
   tmp_ut:=ut;
   CONFORM(bpPL, bp);
   L_bp.convTimes(bp.TimeCond, tmp_cd, tmp_fr, tmp_ut);
   INC(cnt_cd, ~!tmp_cd);
   INC(cnt_pd, ~!tmp_fr);
   NEXT(bpPL);
  END;
  IF ~cnt_cd THEN
   SETEMPTY(cd);
  END;
  IF ~cnt_pd THEN
   SETEMPTY(fr, ut);
  END;
 END {initTimes_Packet};

 PRIVATE PROCEDURE initTimes_Existing(VAR cd, fr, ut: DATE);
 BEGIN
  cd:=bpRT.cd;
  fr:=bpRT.fr;
  ut:=bpRT.ut;
 END {initTimes_Existing};

 PRIVATE PROCEDURE SetupFormZoneFields(Fields: FORM_FIELDS);
  VAR
   IsEdInsAction: SCAL[2];
 BEGIN
  IsEdInsAction:=(Fields("Action").Value = spe_EditQueueBP ) |
                 (Fields("Action").Value = spe_AddCurrentBP) |
                 (Fields("Action").Value = spe_Add_bpRT    ) ;
  Fields("EndNtf"  ).First:=(Fields("Action").Value = spe_AddCurrentBP) | (Fields("Action").Value = spe_Add_bpRT);
  Fields("AcsObj"  ).Modifiable:=IsEdInsAction & L_General.IsAdmin();
  Fields("EndNtf"  ).Modifiable:=(Fields("Action").Value # spe_ViewQueueBP) & (L_General.IsAdmin() | (Fields("AcsObj").Value = L_General.curUSER));
  Fields("curDate" ).Modifiable:=(Fields("Action").Value # spe_ViewQueueBP) & ~!Fields("curDate").Value & (Fields("Repeat").Value # L_bp.r_Always);
  Fields("curFrom" ).Modifiable:=(Fields("Action").Value # spe_ViewQueueBP) & ~!Fields("curFrom").Value & (Fields("Repeat").Value # L_bp.r_Always);
  Fields("curUpTo" ).Modifiable:=(Fields("Action").Value # spe_ViewQueueBP) & Fields("curFrom").Modifiable;
  Fields("Repeat"  ).Modifiable:=IsEdInsAction;
  Fields("TimeTune").Modifiable:=(Fields("Action").Value # spe_ViewQueueBP) &
                                 Fields("Repeat").Modifiable &
                                 (Fields("Repeat").Value # L_bp.r_None) & (Fields("Repeat").Value # L_bp.r_Always) &
                                 (Fields("curDate").Modifiable | Fields("curFrom").Modifiable);
  Fields("execDate").Modifiable:=Fields("Action").Value # spe_ViewQueueBP;
  Fields("execTime").Modifiable:=Fields("Action").Value # spe_ViewQueueBP;
 END {SetupFormZoneFields};

 PRIVATE PROCEDURE SetupPacketExecution(Title,
                                        Header,
                                        EnvStr    : STRING[];
                                        aoAth     : LIKE(AcsObj.AcsObj);
                                        spe_Action: tSetupAction;
                                        InitTime  : PROC);
  VAR
   Form   : FORM_WINDOW;
   Fields : FORMFIELDS;
   cur_cd,
   cur_fr,
   cur_ut : DATE;
 BEGIN
  GetMemoDates(cur_cd, cur_fr, cur_ut);
  InitTime(cur_cd, cur_fr, cur_ut);
  Form:=APP.Get().Forms.Load("bpQPrep", , EMPTYOF(FORM_ZONE));
  Form.Title:=Title;
  Fields:=Form.Zones(0).Fields;
  Fields("Action" ).Value:=spe_Action;
  Fields("Header" ).Value:=Header;
  IF spe_Action = spe_Add_bpRT THEN
   Fields("curDate" ).Value:=bpRT.cd;
   Fields("curFrom" ).Value:=bpRT.fr;
   Fields("curUpTo" ).Value:=bpRT.ut;
   Fields("execTime").Value:=SYSTIME();
   Fields("execDate").Value:=SYSDATE();
   Fields("Repeat"  ).Value:=L_bp.r_None;
   Fields("TimeTune").Value:=L_bp.tt_None;
   Fields("EndNtf"  ).Value:=bpRT.EndNtf;
  ELSE
   Fields("curDate").Value:=cur_cd;
   Fields("curFrom").Value:=cur_fr;
   Fields("curUpTo").Value:=cur_ut;
   IF (spe_Action = spe_EditQueueBP) | (spe_Action = spe_ViewQueueBP) THEN
    Fields("execTime").Value:=L_DatTim.GetTimeOfTIMESTAMP(bpRT.BegTime);
    Fields("execDate").Value:=L_DatTim.GetDateOfTIMESTAMP(bpRT.BegTime);
    Fields("Repeat"  ).Value:=bpRT.Repeat;
    Fields("TimeTune").Value:=bpRT.TimeTune;
    Fields("EndNtf"  ).Value:=bpRT.EndNtf;
   ELSE
    Fields("execTime").Value:=SYSTIME();
    Fields("execDate").Value:=SYSDATE();
    Fields("Repeat"  ).Value:=L_bp.r_None;
    Fields("TimeTune").Value:=L_bp.tt_None;
    Fields("EndNtf"  ).Value:=L_bp.en_Error;
   END;
  END;
  Fields("AcsObj").Value:=aoAth;
  SetupFormZoneFields(Fields);
  IF spe_Action = spe_ViewQueueBP THEN
   LIKEMENU(ShowWin, Form.Name + " 0 " + EnvStr + " ActionAfter=" + L_Str.IntStr(spe_Action));
  ELSE
   LIKEMENU(Edit,    Form.Name + " 0 " + EnvStr + " ActionAfter=" + L_Str.IntStr(spe_Action));
  END;
 END {SetupPacketExecution};

 PRIVATE PROCEDURE bp_Access();
 BEGIN
  IF ~L_bp.bp_AccessByMenu() THEN
   ACCESS(bp);
  END;
 END {bp_Access};

 PUBLIC PROCEDURE ExecCurrent();
 BEGIN
  bp_Access();
  L_bp.MustBeActive(SYSDATE());
  LIKEMENU(CallBP, bp.ProcName + "()");
 END {ExecCurrent};

 PUBLIC PROCEDURE EditSource();
 BEGIN
  L_General.SilentPrgsOnly();
  IF ~L_bp.bp_AccessByMenu() THEN
   ACCESS(^(GE_CURFILE()));
   CONFORM(^(GE_CURFILE()), bp);
  END;
  LIKEMENU(EditText, Str.Item(bp.ProcName, ".", 0) + " /S:PROCEDURE\c" + Str.Item(bp.ProcName, ".", 1) + "(");
 END {EditSource};

 PRIVATE PROCEDURE bpRT_PutMessage(Text: STRING[]; NeedNotify: SCAL[2]);
 BEGIN
  IF bpRT.aoAth = L_General.curUSER THEN
   L_Msg.MakeCurRecordMsg_bpResult(bpRT.aoAth, "bpRT", Text);
  ELSE
   SEARCH(AcsObj, AcsObj, , bpRT.aoAth);
   IF ~L_DatTim.IsActive(SYSDATE(), AcsObj.Begin, AcsObj.Till) THEN
    Text:=" 稫  ᮮ饭 ⮬,   믮﫠  " + L_Str.CRLF +
          "饣 짮⥫ " + AcsObj.AcsObj + " " + AcsObj.Name + L_Str.CRLF +
          L_Str.CRLF + Text;
    L_General.CallUs(L_AR.StandOnGroup(L_General.AdminGroupName()));
   END;

   L_Msg.MakeCurRecordMsg_bpResult(AcsObj.AcsObj, "bpRT", Text);
   IF NeedNotify THEN
    L_Msg.NotifyCurMessage(1);
   ELSE
    SELECT(Message, RecordId, , TABLE.Get("bpRT").Id, bpRT.RECORDID);
    WHILE OCCURE(Message) DO
     Message.Status:=L_Msg.ms_Read;
     REPLACE(Message);
     NEXT(Message);
    END; (* WHILE OCCURE(Message) ... *)
   END;
  END;
 END {bpRT_PutMessage};

 PRIVATE PROCEDURE bpRT_PutErrorMessage(Exc: Exc_Root);
  VAR
   Text: STRING[];
   p   : PROMPT_LINE;
 BEGIN
  L_General.CallUs(OCCURE(bpRT));
  Text:="--- ᮮ饭  ஡---" +
        L_Str.CRLF + Exc.Description;
  IF ~!Exc.PromptLines THEN
   INC(Text, L_Str.CRLF +
             L_Str.CRLF + "---ঠ ' ப'---");
   FOR_EACH p IN Exc.PromptLines DO
    INC(Text, L_Str.CRLF + Str.Align(p.FullText, 74, LEFT));
   END;
  END;
  bpRT_PutMessage(Text, bpRT.EndNtf # L_bp.en_Never);
 END {bpRT_PutErrorMessage};

 PRIVATE PROCEDURE bpRT_PutMessageAboutSuccessfulEnd();
  VAR
   Text: STRING[];
 BEGIN
  L_General.CallUs(OCCURE(bpRT));
  IF bpRT.EndNtf = L_bp.en_Always THEN
   CONFORM(bpRT, bp);
   Text:=               "---饭  ᯥ譮 믮 ---"
         + L_Str.CRLF + bp.Id + " '" + bp.Name + "'"
                      + " (" + L_bp.convTimeCond2Str(bp.TimeCond, bpRT.cd, bpRT.fr, bpRT.ut) + ")";
   IF ~!L_StdFrm.Warnings THEN
    INC(Text, L_Str.CRLF + "--- ।०---" + L_Str.CRLF + L_StdFrm.Warnings);
   END;
   bpRT_PutMessage(Text, 1);
  END;
 END {bpRT_PutMessageAboutSuccessfulEnd};

 PRIVATE PROCEDURE bpRT_FinishRunning(tr: NUMERIC[0]; rslState: LIKE(bpRT.State); Exc: Exc_Root);
 BEGIN
  TRY [TRANSACTION(tr), TERMBYUSERMODE(TERM_BY_USER_IGNORE)]
   bpRT.aoExc  :=L_General.curUSER;
   bpRT.State  :=rslState;
   bpRT.EndTime:=SYSTIMESTAMP();
   REPLACE(bpRT);
   IF rslState = L_bp.s_Fail THEN
    IF ~!Exc THEN
     bpRT_PutErrorMessage(Exc);
    END;
   ELSE
    bpRT_PutMessageAboutSuccessfulEnd();
   END;
  EXCEPT
  END; (* TRY *)
 END {bpRT_FinishRunning};

 PRIVATE PROCEDURE ExecCurrentRT(tr: NUMERIC[0]);
  VAR
   rslState: LIKE(bpRT.State);
 BEGIN
  TRY
   RTI.Get().TryBlock.CurTransaction.Description:=L_bp.Get_bpRT_JobName();
   SetMemoDates(bpRT.cd, bpRT.fr, bpRT.ut);
   L_General.BatchExecution_Begin(bpRT.aoAth);
   CALL(^bp.ProcName());
   IF !L_StdFrm.Warnings THEN
    bpRT_FinishRunning(tr, L_bp.s_Done, EMPTYOF(Exc_Root));
   ELSE
    bpRT_FinishRunning(tr, L_bp.s_Done_wWarnings, EMPTYOF(Exc_Root));
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   bpRT_FinishRunning(tr, L_bp.s_Fail, Exc);
  END; (* TRY *)
 END {ExecCurrentRT};

 PUBLIC PROCEDURE ExecCurrentPacket();
 BEGIN
  L_General.Assert(ACCESS(bpP), " ࠭   楤");
  SetupPacketExecution("믮   楤", bpP.Name, "bpP=" + bpP.bpP,
                       L_General.curUSER, spe_ExecCurPacket, PROCREF(initTimes_Packet));
 END {ExecCurrentPacket};

 PRIVATE PROCEDURE intExecCurrentPacket(cur_cd, cur_fr, cur_ut: DATE; execTime: TIMESTAMP; curEndNtf: LIKE(bpRT.EndNtf));
 BEGIN
  WHILE execTime > SYSTIMESTAMP() DO
   PROMPT("믮  १ " + L_Str.IntStr((execTime-SYSTIMESTAMP())*60*24) + " .");
   SLEEP(5);
  END;

  Batch_Begin();
  TRY [TERMBYUSERMODE(TERMBYUSERMODE_THROW)]
   SELECT(bpPL, bpP, , bpP.bpP);
   WHILE OCCURE(bpPL) DO
    CONFORM(bpPL, bp);
    TRY [TRANSACTION(TRANSACTION_SLAVE), TERMBYUSERMODE(TERMBYUSERMODE_ABORT)]
     L_bp.PutRT(cur_cd, cur_fr, cur_ut, curEndNtf);
     L_AFM.Init();
     ExecCurrentRT(TRANSACTION_CURRENT);
    EXCEPT
    END;
    NEXT(bpPL);
   END;
  EXCEPT
  FINALLY
   Batch_End();
  END; (* TRY *)
 END {intExecCurrentPacket};

 PUBLIC PROCEDURE ExecGivenRT(trgRECORDID: LIKE(bpRT.RECORDID));
  VAR
   oPrompt: PROMPT_LINE;
 BEGIN
  L_General.CallUs(SEARCH(bpRT, RECORDID, trgRECORDID));
  IF bpRT.State # L_bp.s_Running THEN
   L_General.CallUs(0);
  END;
  CONFORM(bpRT, bp);
  oPrompt:=PROMPTLINE.Create("믮  (" + bp.Id + ")");
  TRY [TERMBYUSERMODE(TERMBYUSERMODE_THROW)]
   Batch_Begin();
   TRY [TRANSACTION(TRANSACTION_SLAVE)]
    bpRT.aoExc:=L_General.curUSER;
    REPLACE(bpRT);
   EXCEPT
   END;
   APP.Get().MyConnection.Job.Apply();
   CONFORM(bpRT, bp);
   ExecCurrentRT(TRANSACTION_SLAVE);
  EXCEPT
  ON Exc: Exc_Root DO
   IF bpRT.State = L_bp.s_Running THEN
    bpRT_FinishRunning(TRANSACTION_SLAVE, L_bp.s_Fail, Exc);
   END;
  FINALLY
   IF bpRT.State = L_bp.s_Running THEN
    bpRT_FinishRunning(TRANSACTION_SLAVE, L_bp.s_Fail, EMPTYOF(Exc_Root));
   END;
   Batch_End();
  END; (* TRY *)
 END {ExecGivenRT};

 PRIVATE PROCEDURE HasRights(act: tQueueAction; wMsg: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=(bpRT.aoAth = L_General.curUSER);
  IF ~Result THEN
   Result:=L_AcsPnt.MayPassAccessPoint(ap_MayModify);
   IF wMsg THEN
    L_AcsPnt.PassAccessPoint(ap_MayModify);
   END;
  END;
  RETURN Result;
 END {HasRights};

 PRIVATE PROCEDURE CheckRights(act: tQueueAction);
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=HasRights(act, 1);
 END {CheckRights};

 PRIVATE PROCEDURE Queue_HasSameCurrentBP(cd, fr, ut: DATE; rep: L_bp.tRepeat): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF rep = L_bp.r_None THEN
   SAVE(bpRT);
   SELECT(bpRT, State, , L_bp.s_InQueue);
   WHILE OCCURE(bpRT) & ~Result DO
    IF bpRT.bp = bp.bp THEN
     Result:=(bpRT.Repeat = L_bp.r_None) &
             (L_bp.convTimeCond2Str(bp.TimeCond, cd, fr, ut) = L_bp.convTimeCond2Str(bp.TimeCond, bpRT.cd, bpRT.fr, bpRT.ut));
    END;
    NEXT(bpRT);
   END; (* WHILE OCCURE(bpRT) *)
   RESTORE(bpRT);
  END;
  RETURN Result;
 END {Queue_HasSameCurrentBP};

 PUBLIC PROCEDURE Queue_AddPacket();
 BEGIN
  IF ACCESS(bpP) THEN
   L_AcsPnt.PassAccessPoint(ap_MayInsert);
   SetupPacketExecution(" 楤    ।", bpP.Name, "bpP=" + bpP.bpP,
                        L_General.curUSER, spe_AddPacket, PROCREF(initTimes_Packet));
  END;
 END {Queue_AddPacket};

 PRIVATE PROCEDURE StandOnCurrentInShedulerWindow();
 BEGIN
  TRY [MSGSUPPRESSIONMODE(MSGSUPPRESS_ALL), EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   SE_WZD_POSITION("bpSh", 1, bpRT);
  EXCEPT
  ELSE
  END; (* TRY *)
 END {StandOnCurrentInShedulerWindow};

 PRIVATE PROCEDURE intQueue_AddPacket(cur_cd, cur_fr, cur_ut: DATE;
                                      execTime : TIMESTAMP;
                                      cur_rep  : L_bp.tRepeat;
                                      cur_tt   : L_bp.tTimeTuning;
                                      curEndNtf: LIKE(bpRT.EndNtf));
  VAR
   Cnt: NUMERIC[0];
 BEGIN
  Cnt:=0;
  SELECT(bpPL, bpP, , bpP.bpP);
  WHILE OCCURE(bpPL) DO
   CONFORM(bpPL, bp);
   IF ~Queue_HasSameCurrentBP(cur_cd, cur_fr, cur_ut, cur_rep)  THEN
    L_bp.PutQueue(execTime, cur_cd, cur_fr, cur_ut, cur_rep, cur_tt, L_General.curUSER, curEndNtf);
    IF Cnt = 0 THEN
     StandOnCurrentInShedulerWindow();
    END;
    INC(execTime, 1/24/60);
    INC(Cnt);
   ELSE
    L_StdFrm.TimedINFORM("楤 " + bp.Id + " (" + L_bp.convTimeCond2Str(bp.TimeCond, cur_cd, cur_fr, cur_ut) + ") " +
                         "㦥 室  ।", 10);
   END;
   NEXT(bpPL);
  END; (* WHILE OCCURE(bpPL) *)
  IF Cnt = 0 THEN
   L_StdFrm.TimedINFORM("    ", 10);
  ELSE
   L_StdFrm.TimedINFORM(" " + L_Str.IntStr(Cnt) + " ", 10);
  END;
 END {intQueue_AddPacket};

 PUBLIC PROCEDURE BckpS();
 BEGIN
  L_bp.extBegin(L_bp.i_BckpS, "ࢭ ஢", L_bp.t_Process, L_General.tc_Entire, L_bp.pt_StrictlyInTime);
  IF L_General.BatchExecution_IsRunning() THEN
   CALL(Sys_Util.BackupByGuard());
  ELSE
   CALL(Sys_Util.Backup());
  END;
  L_bp.End();
 END {BckpS};

 PRIVATE PROCEDURE bpRT_OnBeforeEdit();
  VAR
   dmy_cd,
   dmy_fr,
   dmy_ut: DATE;
 BEGIN
  CheckRights(act_Edit);
  dmy_cd:=SYSDATE();
  dmy_fr:=dmy_cd;
  dmy_ut:=dmy_cd;
  CONFORM(bpRT, bp);
  L_bp.convTimes(bp.TimeCond, dmy_cd, dmy_fr, dmy_ut);
  RTI.Get().CurZone.Fields("bpRT.cd").Modifiable:=~!dmy_cd;
  RTI.Get().CurZone.Fields("bpRT.fr").Modifiable:=~!dmy_fr;
  RTI.Get().CurZone.Fields("bpRT.ut").Modifiable:=~!dmy_ut;
  RTI.Get().CurZone.Fields("bpRT.BegTime").Modifiable:=1;
 END {bpRT_OnBeforeEdit};

 PRIVATE PROCEDURE bpRT_OnBeforeDelete();
 BEGIN
  L_General.CallUs(bpRT.State = L_bp.s_InQueue);
  CheckRights(act_Delete);
 END {bpRT_OnBeforeDelete};

 PRIVATE PROCEDURE bp_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="bp";
  L_WDO.iField(0, "bp.TimeCond" ).Format:=L_General.tc_Pool;
  L_WDO.iField(0, "bp.PriorityT").Format:=L_bp.pt_Pool();
  L_WDO.iZone (1).ViewOnly:=1;
  L_WDO.iZone (1).PermanentFilter:="bp.Type#" + L_Str.IntStr(L_bp.t_PassOnly);
  L_WDO.iField(1, "bp.Type"     ).Format:=L_bp.t_Pool_Short;
  L_WDO.iField(1, "ff_HasAcsPnt").Format:=" |!";
 END {bp_OnInitializeWindow};

 PRIVATE PROCEDURE bpSh_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="bp";
  L_WDO.iWindow().OnCloseWindow:=1;
  L_WDO.iZone  (0).ParentZone:=L_WDO.iZone(1);
  L_WDO.iField (0, "bpRT.Repeat"  ).Format:=L_bp.r_Pool;
  L_WDO.iField (0, "bpRT.TimeTune").Format:=L_bp.tt_Pool;
  L_WDO.iField (0, "bpRT.EndNtf"  ).Format:=L_bp.en_Pool;
  L_WDO.iField (0, "bp.PriorityT").Format:=L_bp.pt_Pool();
  L_WDO.iEvents(1, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeDelete, L_WDO.e_OnReposition, L_WDO.e_OnOpenZone]);
  L_WDO.iZone  (1).Narrowing:="bpRT.State=" + L_Str.IntStr(L_bp.s_InQueue);
  L_WDO.iField (1, "bpRT.BegTime" ).ReverseSorting:=1;
  L_WDO.iField (1, "bp.Type"      ).Format:=L_bp.t_Pool_Short;
  L_WDO.iProgs (1, "bp");
  L_WDO.iZone  (2).Narrowing:="bpRT.State=" + L_Str.IntStr(L_bp.s_Running);
  L_WDO.iZone  (2).ViewOnly:=1;
  L_WDO.iField (2, "bpRT.BegTime" ).ReverseSorting:=1;
  L_WDO.iField (2, "bp.Type"      ).Format:=L_bp.t_Pool_Short;
  L_WDO.iField (2, "FromLine"     ).Format:=" |";
 END {bpSh_OnInitializeWindow};

 PRIVATE PROCEDURE bpQPrep_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="bp";
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit]);
  L_WDO.iScsChange   (0, ["Repeat", "execDate", "execTime", "Action", "AcsObj"]);
  L_WDO.iUnmodifiable(0, ["Action", "Header"]);
  L_WDO.iProgs       (0, "bp");

  L_WDO.CreateFormLink("AcsObj", "");
  L_WDO.iField (0, "Action"  ).Visible:=0;
  L_WDO.iField (0, "Repeat"  ).Format :=L_bp.r_Pool;
  L_WDO.iField (0, "EndNtf"  ).Format :=L_bp.en_Pool;
  L_WDO.iField (0, "TimeTune").Format :=L_bp.tt_Pool;
 END {bpQPrep_OnInitializeWindow};

 PUBLIC PROCEDURE ShowAcsPnt();
  VAR
   dependenceSign: STRING[];
 BEGIN
  IF L_bp.bp_AccessByMenu() THEN
   dependenceSign:=" @";
  ELSE
   dependenceSign:="";
  END;
  bp_Access();
  IF !bp.AcsPnt THEN
   L_StdFrm.Question(" ᯥ樠   믮  " + bp.Id + "  ⠭." +
                     "||" +
                     "   ନ?");
   LIKEMENU(Ins, "AcsPntE 0" + dependenceSign + " bp="+bp.bp);
  END;
  LIKEMENU(Edit, "AcsPntE 0" + dependenceSign + " bp="+bp.bp);
 END {ShowAcsPnt};

 PRIVATE PROCEDURE bpJrn_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="bp";
  L_WDO.iZone        (0).ParentZone:=L_WDO.iZone(1);
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iZone        (1).PermanentFilter:="(bpRT.State#0) & (bpRT.State#1)";
  L_WDO.iProgs       (1, "bp");
  L_WDO.iField       (1, "bp.Type"   ).Format:=L_bp.t_Pool_Short;
  L_WDO.iField       (1, "bpRT.State").Format:=L_bp.s_Pool_Short;
 END {bpJrn_OnInitializeWindow};

 PRIVATE PROCEDURE bpJrnC_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="bp";
  L_WDO.iUnmodifiable(0, ["bp.bp", "bp.Type", "bp.Name", "bp.Id"]);
  L_WDO.iField       (0, "bp.Type"   ).Format:=L_bp.t_Pool_Short;
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iZone        (1).Narrowing:="bpRT.bp=bp.bp";
  L_WDO.iZone        (1).PermanentFilter:="";
  L_WDO.iField       (1, "bpRT.State").Format:=L_bp.s_Pool_Short;
 END {bpJrnC_OnInitializeWindow};

 PRIVATE PROCEDURE bpJrnC_OnConformToWindow();
  VAR
   bpId: ENVVAR;
 BEGIN
  bpId:=L_WDO.fz_AccessEnvVar(RTI.Get().TrgWindow.Zones(1), "bpId");
  L_General.CallUs(~!bpId);
  L_General.CallUs(SEARCH(bp, Id, bpId.Value));
  SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, bp);
 END {bpJrnC_OnConformToWindow};

 PRIVATE PROCEDURE bpSh_1_OnZoneOpen();
 BEGIN
  L_Timer.SetTimer(Timer_bpSh, 5, 5, "");
 END {bpSh_1_OnZoneOpen};

 PRIVATE PROCEDURE bpSh_OnCloseWindow();
 BEGIN
  L_Timer.ResetTimer(Timer_bpSh);
 END {bpSh_OnCloseWindow};

 PRIVATE PROCEDURE bpRT_Access();
 BEGIN
  L_General.Assert(ACCESS(bpRT), "   ।");
 END {bpRT_Access};

 PRIVATE PROCEDURE DrawTimeCondValue(trgZone: FORM_ZONE);
  VAR
   tcv: STRING[];
 BEGIN
  IF ACCESS(bpRT) THEN
   CONFORM(bpRT, bp);
   tcv:=L_bp.convTimeCond2Str(bp.TimeCond, bpRT.cd, bpRT.fr, bpRT.ut);
  ELSE
   SETEMPTY(tcv);
  END;
  trgZone.Fields("ff_TimeCond").Value:=tcv;
 END {DrawTimeCondValue};

 PRIVATE PROCEDURE bpSh_1_OnReposition();
 BEGIN
  DrawTimeCondValue(RTI.Get().CurWindow.Zones(0));
 END {bpSh_1_OnReposition};

 PRIVATE PROCEDURE bpJrn_1_OnReposition();
 BEGIN
  DrawTimeCondValue(RTI.Get().CurWindow.Zones(0));
 END {bpJrn_1_OnReposition};

 PRIVATE PROCEDURE Check_bpHasAnyRT();
 BEGIN
  IF ~SELECT(bpRT, bp, bp.bp) THEN
   L_StdFrm.BlueStop(" " + bp.Id + "   ࠧ  믮﫠");
  END;
 END {Check_bpHasAnyRT};

 PUBLIC PROCEDURE ShowRT();
  CONST
   trgWindowName = "bpJrnC";
  VAR
   fw: FORM_WINDOW;
 BEGIN
  IF L_bp.bp_AccessByMenu() THEN
   Check_bpHasAnyRT();
   fw:=APP.Get().Forms.Load(trgWindowName, trgWindowName + "<byMenu/" + bp.Id + ">", EMPTYOF(FORM_ZONE));
   fw.Title:="ୠ 믮  楤 " + bp.Id;
   LIKEMENU(View, fw.Name + " 1 @ bpId=" + bp.Id);
  ELSE
   LIKEMENU(View, trgWindowName + " 1");
  END;
 END {ShowRT};

 PUBLIC PROCEDURE Queue_AddCurrent();
 BEGIN
  bp_Access();
  L_bp.MustBeActive(SYSDATE());
  L_AcsPnt.PassAccessPoint(ap_MayInsert);
  SetupPacketExecution(" 楤  ।", bp.Id + " " + bp.Name, "bp=" + bp.bp,
                       L_General.curUSER, spe_AddCurrentBP, PROCREF(initTimes_Single));
 END {Queue_AddCurrent};

 PUBLIC PROCEDURE Queue_AddBy_bpRT();
 BEGIN
  ACCESS(bpRT);
  CONFORM(bpRT, bp);
  L_bp.MustBeActive(SYSDATE());
  L_AcsPnt.PassAccessPoint(ap_MayInsert);
  SetupPacketExecution(" 楤  ।", bp.Id + " " + bp.Name, "bp=" + bp.bp,
                       L_General.curUSER, spe_Add_bpRT, PROCREF(initTimes_Single));
 END {Queue_AddBy_bpRT};

 PRIVATE PROCEDURE intQueue_AddCurrent(cur_cd,
                                       cur_fr,
                                       cur_ut   : DATE;
                                       execTime : TIMESTAMP;
                                       cur_rep  : L_bp.tRepeat;
                                       cur_tt   : L_bp.tTimeTuning;
                                       cur_aoAth: LIKE(AcsObj.AcsObj);
                                       curEndNtf: LIKE(bpRT.EndNtf));
 BEGIN
  IF ~Queue_HasSameCurrentBP(cur_cd, cur_fr, cur_ut, cur_rep) THEN
   L_bp.PutQueue(execTime, cur_cd, cur_fr, cur_ut, cur_rep, cur_tt, cur_aoAth, curEndNtf);
   StandOnCurrentInShedulerWindow();
   TOOLTIP("楤 ", 0);
  ELSE
   L_StdFrm.TimedINFORM("楤 " + bp.Id + " (" + L_bp.convTimeCond2Str(bp.TimeCond, cur_cd, cur_fr, cur_ut) + ") " +
                        "㦥 室  ।", 10);
  END;
 END {intQueue_AddCurrent};

 PUBLIC PROCEDURE Queue_Edit();
 BEGIN
  bpRT_Access();
  L_General.Assert(bpRT.State = L_bp.s_InQueue, " ࠬ஢ 㦥 ");
  L_AcsPnt.PassAccessPoint(ap_MayModify);
  CONFORM(bpRT, bp);
  SetupPacketExecution(" ࠬ஢ ᯮ  楤", bp.Id + " " + bp.Name,
                       "ri=" + bpRT.RECORDID, bpRT.aoAth,
                       spe_EditQueueBP, PROCREF(initTimes_Existing));
 END {Queue_Edit};

 PUBLIC PROCEDURE Queue_View();
 BEGIN
  bpRT_Access();
  CONFORM(bpRT, bp);
  SetupPacketExecution("ᬮ ࠬ஢ ᯮ  楤", bp.Id + " " + bp.Name,
                       "ri=" + bpRT.RECORDID, bpRT.aoAth,
                       spe_ViewQueueBP, PROCREF(initTimes_Existing));
 END {Queue_View};

 PRIVATE PROCEDURE intQueue_Edit(cur_cd, cur_fr, cur_ut: DATE;
                                 execTime : TIMESTAMP;
                                 cur_rep  : L_bp.tRepeat;
                                 cur_tt   : L_bp.tTimeTuning;
                                 cur_aoAth: LIKE(AcsObj.AcsObj);
                                 curEndNtf: LIKE(bpRT.EndNtf));
 BEGIN
  bpRT.cd      :=cur_cd;
  bpRT.fr      :=cur_fr;
  bpRT.ut      :=cur_ut;
  bpRT.BegTime :=execTime;
  bpRT.aoAth   :=cur_aoAth;
  bpRT.Repeat  :=cur_rep;
  bpRT.TimeTune:=cur_tt;
  bpRT.EndNtf  :=curEndNtf;
  REPLACE(bpRT);
 END {intQueue_Edit};

 PRIVATE PROCEDURE spe_GetEnvVarValue(EnvVar: STRING[]): STRING[];
  VAR
   Value: STRING[];
 BEGIN
  Value:=L_WDO.GetEnvVarValue(EnvVar);
  L_General.CallUs(~!Value);
  RETURN Value;
 END {spe_GetEnvVarValue};

 PRIVATE PROCEDURE bpQPrep_OnBeforeEdit();
 BEGIN
  IF STRTOFLD(spe_GetEnvVarValue("ActionAfter"), SCAL) # spe_EditQueueBP THEN
   FIX_ALTERING();
  END;
 END {bpQPrep_OnBeforeEdit};

 PRIVATE PROCEDURE bpQPrep_OnAfterEdit();
  VAR
   spe_Action: tSetupAction;
   execTime  : TIMESTAMP;
   cur_cd,
   cur_fr,
   cur_ut    : DATE;
   cur_rep   : L_bp.tRepeat;
   cur_tt    : L_bp.tTimeTuning;
   curEndNtf : LIKE(bpRT.EndNtf);
   Fields    : FORMFIELDS;
 BEGIN
  Fields   :=RTI.Get().CurZone.Fields;
  cur_cd   :=Fields("curDate").Value;
  cur_fr   :=Fields("curFrom").Value;
  cur_ut   :=Fields("curUpTo").Value;
  curEndNtf:=Fields("EndNtf").Value;
  L_General.Assert(cur_fr <= cur_ut, " 砫 ਮ   砭 ਮ");
  execTime:=PackTIMESTAMP(Fields("execDate").Value, Fields("execTime").Value);
  cur_rep :=Fields("Repeat").Value;
  cur_tt  :=Fields("TimeTune").Value;
  IF (cur_rep = L_bp.r_Always) THEN
   SETEMPTY(cur_cd, cur_fr, cur_ut);
   cur_tt:=L_bp.tt_None;
  ELSE
   L_General.Assert((cur_rep = L_bp.r_None) | !cur_cd & !cur_fr | (cur_tt # L_bp.tt_None),
                    "室 㪠 ᯮᮡ  ६ ࠬ஢  ୮ 믮");
  END;
  spe_Action:=L_WDO.GetEnvVarValue("ActionAfter");
  IF    spe_Action = spe_ExecCurPacket THEN
   SEARCH(bpP, bpP, , spe_GetEnvVarValue("bpP"));
   intExecCurrentPacket(cur_cd, cur_fr, cur_ut, execTime, curEndNtf);
  ELSIF spe_Action = spe_AddPacket THEN
   SEARCH(bpP, bpP, , spe_GetEnvVarValue("bpP"));
   intQueue_AddPacket(cur_cd, cur_fr, cur_ut, execTime, cur_rep, cur_tt, curEndNtf);
  ELSIF (spe_Action = spe_AddCurrentBP) | (spe_Action = spe_Add_bpRT) THEN
   SEARCH(bp, bp, , spe_GetEnvVarValue("bp"));
   L_bp.spe_CheckRepeatingCompliance(cur_cd, cur_fr, cur_ut, execTime, cur_rep, cur_tt);
   intQueue_AddCurrent(cur_cd, cur_fr, cur_ut, execTime, cur_rep, cur_tt, Fields("AcsObj").Value, curEndNtf);
  ELSIF spe_Action = spe_EditQueueBP THEN
   SEARCH(bpRT, RECORDID, , spe_GetEnvVarValue("ri"));
   CONFORM(bpRT, bp);
   L_bp.spe_CheckRepeatingCompliance(cur_cd, cur_fr, cur_ut, execTime, cur_rep, cur_tt);
   intQueue_Edit(cur_cd, cur_fr, cur_ut, execTime, cur_rep, cur_tt, Fields("AcsObj").Value, curEndNtf);
   DrawTimeCondValue(APP.Get().Forms("bpSh").Zones(0)); (* .6 0093218 *)
  ELSE
   L_General.CallUs(0);
  END;
 END {bpQPrep_OnAfterEdit};

 PRIVATE PROCEDURE bpQPrep_execDateTime_OnSuccessfulChange();
  VAR
   T: TIME;
   D: DATE;
 BEGIN
  T:=RTI.Get().CurZone.Fields("execTime").Value;
  D:=RTI.Get().CurZone.Fields("execDate").Value;
  IF D <= SYSDATE() THEN
   IF T < SYSTIME() THEN
    D:=SYSDATE()+1;
   ELSE
    D:=SYSDATE();
   END;
   RTI.Get().CurZone.Fields("execDate").Value:=D;
  END;
 END {bpQPrep_execDateTime_OnSuccessfulChange};

 PRIVATE PROCEDURE bpQPrep_execTime_OnSuccessfulChange();
 BEGIN
  bpQPrep_execDateTime_OnSuccessfulChange();
 END {bpQPrep_execTime_OnSuccessfulChange};

 PRIVATE PROCEDURE bpQPrep_execDate_OnSuccessfulChange();
 BEGIN
  bpQPrep_execDateTime_OnSuccessfulChange();
 END {bpQPrep_execDate_OnSuccessfulChange};

 PRIVATE PROCEDURE bpQPrep_Repeat_OnSuccessfulChange();
 BEGIN
  SetupFormZoneFields(RTI.Get().CurZone.Fields);
 END {bpQPrep_Repeat_OnSuccessfulChange};

 PRIVATE PROCEDURE bpQPrep_AcsObj_OnSuccessfulChange();
 BEGIN
  SEARCH(AcsObj, AcsObj, , RTI.Get().CurZone.ActiveField.Value);
  L_bp.Check_aoAth(AcsObj.AcsObj);
  L_General.Assert(L_DatTim.IsActive(SYSDATE(), AcsObj.Begin, AcsObj.Till),
                   L_DatTim.DateStr(SYSDATE()) + " -  ਮ ਬ   짮⥫ " + AcsObj.AcsObj);
  IF AcsObj.Type = L_AR.aot_Group THEN
   L_StdFrm.Choice("࠭ 㯯 짮⥫.|饭  ஡ ᯮ   뫠 ᥬ 童 㯯");
  END;
 END {bpQPrep_AcsObj_OnSuccessfulChange};

 PUBLIC PROCEDURE Queue_Add();
 BEGIN
  IF L_StdFrm.ShowListAsMenu("  楤| 楤  ", "   ।  ") = 0 THEN
   LIKEMENU(View, ">bp 1", SC, "View_bpQ");
  ELSE
   LIKEMENU(View, ">bpP 1", SC, "View_bpPQ");
  END;
 END {Queue_Add};

 TYPE
  tbpr_Source = SCAL[2];

 CONST
  bprS_bpRT = 0; (* tbpr_Source*)
  bprS_bp   = 1;

 PRIVATE PROCEDURE bpr_List_Put(    Name    : STRING[];
                                    Path    : STRING[];
                                    DTS     : TIMESTAMP;
                                VAR PathList: STRING[];
                                VAR NameList: STRING[]);
 BEGIN
  PathList:=PathList + Path + "|";
  NameList:=NameList + Str.Align(Name, 48, LEFT) + " " +
                       Str.Align(FLDTOSTR(DTS, "D.N.y H:M:S"),    19, LEFT) + "|";
 END {bpr_List_Put};

 PRIVATE PROCEDURE bpr_List_Get(RepPathList,
                                RepNameList : STRING[];
                                NeedShowList: SCAL[2]): STRING[];
  VAR
   Idx: NUMERIC[0];
 BEGIN
  IF ~NeedShowList THEN
   Idx:=0;
  ELSE
   L_General.Assert(~!RepNameList, "   . ,  㤠  ६饭");
   Idx:=L_StdFrm.ShowListAsMenu_wCaption(RepNameList,
                                         " , ନ஢  "+ bp.Id + " ",
                                         Str.Align(" ", 48, LEFT) + " " +
                                         Str.Align("६ ⮢", 19, LEFT) +
                                         "|" +
                                         L_Str.Repeat("", 48) + " " +
                                         L_Str.Repeat("", 19));
  END;
  RETURN L_Str.PoolItem(RepPathList, Idx);
 END {bpr_List_Get};

 PRIVATE PROCEDURE bpr_BasisExists(FName: STRING[]): SCAL[2];
 BEGIN
  RETURN (FIO.Exists(FName + "." + L_Basis.BasExt)) & (FIO.Exists(FName + "." + L_Basis.APIExt));
 END {bpr_BasisExists};

 PRIVATE PROCEDURE bpr_Do(Source: tbpr_Source);
  VAR
   Cnt          : NUMERIC[0];
   File         : FOLDERENTRY;
   FName,
   XLTPath,
   RepPath,
   RepPathMask,
   RepPathList,
   RepNameList  : STRING[];
   TimeCondAsStr: STRING[];
 BEGIN
  IF    bp.Type = L_bp.t_Basis THEN
   IF Source = bprS_bp THEN
    Cnt:=0;
    SETEMPTY(RepNameList, RepPathList);
    L_AFM.MakeMultipleIndex("tmpFile", "Id: STRING[64]", "Id: Id");
    SELECT(bpRT, bp, , bp.bp);
    LAST(bpRT);
    WHILE OCCURE(bpRT) & (Cnt < 10) DO
     PROMPT(bp.Id + " " + bpRT.RECORDID);
     IF (bpRT.State = L_bp.s_Done) | (bpRT.State = L_bp.s_Done_wWarnings) THEN
      FName:=L_Basis.GetFullPath(L_Basis.CurrentBranch(), bp.Id, bp.TimeCond, bpRT.cd, bpRT.fr, bpRT.ut, 0);
      IF bpr_BasisExists(FName) THEN
       TimeCondAsStr:=L_bp.convTimeCond2Str(bp.TimeCond, bpRT.cd, bpRT.fr, bpRT.ut);
       IF ~SEARCH(tmpFile, Id, TimeCondAsStr) THEN
        tmpFile.Id:=TimeCondAsStr;
        INSERT(tmpFile);
        bpr_List_Put(TimeCondAsStr, bpRT.RECORDID, bpRT.BegTime, RepPathList, RepNameList);
        INC(Cnt);
       END;
      END;
     END;
     PREV(bpRT);
    END; (* WHILE OCCURE(bpRT) ... *)
    L_General.CallUs(SEARCH(bpRT, RECORDID, bpr_List_Get(RepPathList, RepNameList, 1)));
   END;
   GetMemoDates(sav_cd, sav_fr, sav_ut);
   TRY
    SetMemoDates(bpRT.cd, bpRT.fr, bpRT.ut);
    L_Basis.TryExisting_woRemakeBasis(bp.Id, bp.Name, bp.TimeCond);
   EXCEPT
   FINALLY
    SetMemoDates(sav_cd, sav_fr, sav_ut);
   END; (* TRY *)
  ELSIF (bp.Type = L_bp.t_RTBasis) |
        (bp.Type = L_bp.t_Report)  |
        (bp.Type = L_bp.t_Prc_wRp) |
        (bp.Type = L_bp.t_Prc_wF3) THEN
   IF bp.Type = L_bp.t_RTBasis THEN
    XLTPath:=L_Basis.ChoiceRTBXLT(bp.Id, bp.Name);
    RepPathMask:=L_Basis.GetBasisPath_wMask(L_Basis.CurrentBranch(),
                                            bp.Id, XLTPath, bp.TimeCond,
                                            L_General.EMPTY_DATE(),
                                            L_General.EMPTY_DATE(),
                                            L_General.EMPTY_DATE()) + "*." + L_Basis.APIExt;
   ELSE
    RepPathMask:=bp.Id + "*.REP";
    TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
     CALL(^(L_bp.mn_ResultPathMask())(RepPathMask));
    EXCEPT
    ON Exc:Exc_Syntax DO
     IF Exc.ErrorCode # L_General.ec_rt_UnknownIdentifier THEN
      RAISE();
     END;
    END; (* TRY *)
   END;
   SETEMPTY(RepNameList, RepPathList);
   Cnt:=0;
   IF    Source = bprS_bpRT THEN
    FOR_EACH File IN FOLDERENTRY.CreateRedirector(RepPathMask).FolderContent DO
     PROMPT(File.Path);
     IF L_DatTim.DTSIsActive_Inc(File.TimeLastModified, bpRT.BegTime, bpRT.EndTime+3/(60*24)) &
      ((bp.Type # L_bp.t_RTBasis) | bpr_BasisExists(Str.Slice(File.Path, 0, Str.Length(File.Path) - 4))) THEN
      INC(Cnt);
      bpr_List_Put(L_FIO.effp_FileName_woExt(File.Path), File.Path, File.TimeLastModified, RepPathList, RepNameList);
     END;
    END; (* FOR_EACH *)
   ELSIF Source = bprS_bp   THEN
    L_AFM.MakeMultipleIndex("tmpFile", "DTS : TIMESTAMP;"+
                                       "Name: STRING[64];"+
                                       "Path: STRING[2048]",
                            "DTS: DTS, Name");
    FOR_EACH File IN FOLDERENTRY.CreateRedirector(RepPathMask).FolderContent DO
     PROMPT(File.Path);
     IF ((bp.Type # L_bp.t_RTBasis) | bpr_BasisExists(Str.Slice(File.Path, 0, Str.Length(File.Path) - 4))) THEN
      tmpFile.DTS :=File.TimeLastModified;
      tmpFile.Name:=L_FIO.effp_FileName_woExt(File.Path);
      tmpFile.Path:=File.Path;
      INSERT(tmpFile);
     END;
    END; (* FOR_EACH *)
    SELECT(tmpFile, DTS);
    LAST(tmpFile);
    WHILE OCCURE(tmpFile) & ((Source = bprS_bpRT) | (Cnt <= 10)) DO
     INC(Cnt);
     PROMPT(L_Str.IntStr(Cnt) + " " + tmpFile.Path);
     bpr_List_Put(tmpFile.Name, tmpFile.Path, tmpFile.DTS, RepPathList, RepNameList);
     PREV(tmpFile);
    END; (* WHILE OCCURE(tmpFile) ... *)
   ELSE
    L_General.CallUs(0);
   END;
   RepPath:=bpr_List_Get(RepPathList, RepNameList, (Source = bprS_bp) | (Cnt # 1));
   IF bp.Type = L_bp.t_RTBasis THEN
    L_Basis.TryExistingRunTimeRep_woRemakeBasis(XLTPath,
                                                Str.Slice(RepPath, 0, Str.Length(RepPath) - 4) + "." + L_Basis.XLSExt,
                                                RepPath, bp.Name, bp.TimeCond);
   ELSE
    LIKEMENU(Survey, RepPath);
   END;
  ELSIF  Source = bprS_bpRT THEN
   L_StdFrm.TimedINFORM(" " + bp.Id + " '" + bp.Name + "'|믮 ᯥ譮", 60);
  ELSE
   L_StdFrm.Inform(" 楤 " + bp.Id + " '" + bp.Name + "'  ନ ⮢");
  END;
 END {bpr_Do};

 PUBLIC PROCEDURE bpr_View_bpRT();
  VAR
   ErrorDsc: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  TABLE.Get("bpRT").AccessDataMode :=adm_HOTTEST;
  bpRT_Access();
  CONFORM(bpRT, bp);
  IF    bpRT.State = L_bp.s_Fail THEN
   L_General.CallUs(bpRT.State # L_bp.s_Running);
   SETEMPTY(ErrorDsc);
   IF SELECT(Message, RecordId, TABLE.Get("bpRT").Id, bpRT.RECORDID) THEN
    WHILE OCCURE(Message) DO
     IF Message.Kind = L_Msg.mk_bpResult THEN
      ErrorDsc:=Str.Replace(L_lsStore.Get(Message.Text), "|", " ");
     END;
     NEXT(Message);
    END; (* WHILE OCCURE(Message) ... *)
   END;
   L_StdFrm.TimedINFORM_AsSTOP(" " + bp.Id + " '" + bp.Name + "'| 믮.||"+ ErrorDsc, 60);
  ELSIF bpRT.State = L_bp.s_Running THEN
   L_StdFrm.Inform("  믮 אַ ᥩ");
  ELSIF bpRT.State = L_bp.s_InQueue THEN
   L_StdFrm.Inform("   室  ।");
  ELSE
   bpr_Do(bprS_bpRT);
  END; (* IF bpRT.State = L_bp.s_Fail ... *)
 END {bpr_View_bpRT};

 PRIVATE PROCEDURE Get_bpRTConnection(Interactive: SCAL[2]): ASBCONNECTION;
  VAR
   curConn,
   Result   : ASBCONNECTION;
   oTRN     : TRANSACTION;
   trgTrnDsc: STRING[];
   doIt     : SCAL[2];
 BEGIN
  SETEMPTY(Result);
  IF !bpRT.aoExc THEN
   IF (SYSTIMESTAMP() - bpRT.BegTime) > 2/24/60 THEN
    TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL), TRANSACTION(TRANSACTION_SLAVE)]
     GETLASTVERSION(bpRT);
     bpRT.aoExc:=L_Guard.AcsObjOfGuard();
     REPLACE(bpRT);
    EXCEPT
    END; (* TRY *)
   END;
   IF Interactive THEN
    L_StdFrm.BlueStop("믮 ⮩    砫.   १ ᪮쪮 ᥪ㭤.");
   END;
  ELSIF bpRT.aoExc = L_Guard.AcsObjOfGuard() THEN
   FOR_EACH curConn IN ASBCONNECTIONS.Create() DO
    IF ~!curConn.Job & L_bp.bpRT_IsMyJob(curConn.Job) THEN
     Result:=curConn;
     EXIT;
    END;
   END; (* FOR_EACH *)
  ELSE
   trgTrnDsc:=L_bp.Get_bpRT_JobName();
   SEARCH(AcsObj, AcsObj, , bpRT.aoExc);
   FOR_EACH oTRN IN TRANSACTIONS.Get() DO
    IF (oTRN.Description = trgTrnDsc) & (oTRN.Connection.LoginName = AcsObj.Name) THEN
     Result:=oTRN.Connection;
     EXIT;
    END;
   END; (* FOR_EACH *)
  END;
  IF !Result THEN
   TRY
    GETLASTVERSION(bpRT);
    TRY
     L_General.Error("믮  뫮 ࢠ  ࠧ. 稭   ࠧ묨. ਬ,"
                   + " 祭 뫮 ਭ㤨⥫쭮 襭 ஬  ⠭ ."
                   + "  祭 訫 ᫥⢨ ஡  ⠭⭮  (Window  ..)."
                   + "  - ,   ⭮");
    EXCEPT
    ON Exc: Exc_Raise DO
     IF Interactive THEN
      L_StdFrm.Question(Exc.Description + L_StdFrm.HR() + "  ⮬ 믮 㤥 祭   㤠");
     END;
     bpRT_FinishRunning(TRANSACTION_SLAVE, L_bp.s_Fail, Exc);
    ELSE
    END;
   EXCEPT
   ON Exc: Exc_Root DO
   END; (* TRY *)
  END;
  RETURN Result;
 END {Get_bpRTConnection};

 PUBLIC PROCEDURE ClearDeads();
 BEGIN
  TRY
   PROMPT(" '' ");
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   TABLE.Get("bpRT").AccessDataMode :=adm_HOTTEST;
   SELECT(bpRT, State, , L_bp.s_Running);
   WHILE OCCURE(bpRT) DO
    IF !Get_bpRTConnection(0) THEN
     SELECT(bpRT, State, , L_bp.s_Running);
    ELSE
     NEXT(bpRT);
    END;
   END; (* WHILE OCCURE(bpRT) ... *)
  EXCEPT
  END; (* TRY *)
 END {ClearDeads};

 PRIVATE PROCEDURE ViewJob(Control: SCAL[2]);
  VAR
   oConn: ASBCONNECTION;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  TABLE.Get("bpRT").AccessDataMode :=adm_HOTTEST;
  bpRT_Access();
  L_General.Assert(bpRT.State = L_bp.s_Running, "    믮");

  oConn:=Get_bpRTConnection(1);
  IF ~!oConn THEN
   IF Control THEN
    L_General.SilentAdminOnly();
    oConn.Watch(1);
   ELSE
    oConn.Watch(0);
   END;
  END;
 END {ViewJob};

 PUBLIC PROCEDURE bpr_ViewJob();
 BEGIN
  ViewJob(0);
 END {bpr_ViewJob};

 PUBLIC PROCEDURE bpr_ControlJob();
 BEGIN
  ViewJob(1);
 END {bpr_ControlJob};

 PUBLIC PROCEDURE bpr_View_bp();
 BEGIN
  bp_Access();
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Check_bpHasAnyRT();
  bpr_Do(bprS_bp);
 END {bpr_View_bp};

 PRIVATE PROCEDURE bpPL_OnAfterEdIns();
 BEGIN
  CONFORM(bpPL, bp);
  L_bp.MustBeActive(SYSDATE());
 END {bpPL_OnAfterEdIns};

 PRIVATE PROCEDURE bpPL_OnAfterEdit();
 BEGIN
  bpPL_OnAfterEdIns();
 END {bpPL_OnAfterEdit};

 PRIVATE PROCEDURE bpPL_OnAfterInsert();
 BEGIN
  bpPL_OnAfterEdIns();
 END {bpPL_OnAfterInsert};

BEGIN
 L_Events.ExecuteHandler();
END.
