(*
%Copyright   (c) Polak Computer System
%Author      22.02.1995 15:01:53 SAN
%Specific    SYS
%Modified    14.07.2014 16:54:54 POLAK\LDA
%Environment
*)

 MODULE CAcnt [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_OwnData, L_Events, L_DatTim, L_Acnt, L_WDO, L_DBD, L_StdFrm,
        L_AFM, L_Str, L_Excel, L_AcCut;

 PRIVATE PROCEDURE CAcnt_OnAfterEditInsert();
  VAR
   _CAcnt: LIKE(CAcnt.CAcnt);
   _Begin: LIKE(CAcnt.Begin);
   _Till : LIKE(CAcnt.Till);
 BEGIN
  _CAcnt:=CAcnt.CAcnt;
  _Begin:=CAcnt.Begin;
  _Till :=CAcnt.Till;
  SAVE(CAcnt);
  SELECT(CAcnt, Sign, , CAcnt.Sign);
  WHILE OCCURE(CAcnt) DO
   IF CAcnt.CAcnt # _CAcnt THEN
    L_General.Assert(~L_DatTim.IsActiveInIntvl(CAcnt.Begin, CAcnt.Till, _Begin, _Till),
                     "    ⠪ 祭|騩  ਮ  "+L_DatTim.DateStr(CAcnt.Begin)+"  "+L_DatTim.DateStr(CAcnt.Till)+" ("+CAcnt.CAcnt+")");
   END;
   NEXT(CAcnt);
  END; (* WHILE OCCURE(CAcnt) ... *)
  RESTORE(CAcnt);
  L_DBD.CheckValidity("CAcnt");
 END {CAcnt_OnAfterEditInsert};

 PRIVATE PROCEDURE CAcnt_OnAfterEdit();
 BEGIN
  CAcnt_OnAfterEditInsert();
 END {CAcnt_OnAfterEdit};

 PRIVATE PROCEDURE CAcnt_OnAfterInsert();
 BEGIN
  CAcnt_OnAfterEditInsert();
 END {CAcnt_OnAfterInsert};

 PRIVATE PROCEDURE CAcnt_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "CAcntE");
 END {CAcnt_OnInitializeWindow};

 PRIVATE PROCEDURE CAcntE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit, L_WDO.e_OnAfterInsert]);
  L_WDO.iMayBeEmpty  (0, "CAcnt.Till");
  L_WDO.iField       (0, "CAcnt.Type").Format:=L_Acnt.catyp_Pool;
 END {CAcntE_OnInitializeWindow};

 PRIVATE PROCEDURE CA_AC_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, L_WDO.e_OnSetSubwindow);
  L_WDO.iZone        (1).Narrowing:="ACLog.CAcnt=CAcnt.CAcnt";
  L_WDO.iProgs       (1, "CAcnt");
 END {CA_AC_OnInitializeWindow};

 PRIVATE PROCEDURE CA_AC_1_OnSetSubwindow();
 BEGIN
  IF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_ShowWin) |
     (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit   ) THEN
   RTI.Get().CurZone.SubwindowOriginalName:="AcCutE";
  ELSE
   L_StdFrm.BlueStop(" ⢨ ⨬   ⥪");
  END;
 END {CA_AC_1_OnSetSubwindow};

 PRIVATE PROCEDURE intAcPln(objWB: OBJECT);
  CONST
   totC = 6;
  VAR
   objWS: OBJECT;
   CurRange: OBJECT;
   i    : NUMERIC[0];
 BEGIN
  objWS:=L_Excel.NewWorksheet(objWB, 0, " ⮢");

  PROMPT("ଫ ...");
  objWS.Cells.EntireColumn.NumberFormat:="@";
  objWS.Cells.EntireColumn.HorizontalAlignment:=L_Excel.xlLeft;

  L_Excel.ws_Init(objWS);

  L_Excel.ws_WrStr(objWS, L_OwnData.ODFirmName(SYSDATE()));
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);


  CurRange:=objWS.Range(objWS.Cells(3, 1), objWS.Cells(3, totC));
  CurRange.MergeCells:=L_Excel.xlTrue;
  CurRange.WrapText  :=L_Excel.xlTrue;
  CurRange.Value     :=" ⮢  "+L_DatTim.DateStr(Memo.ud_cd());
  CurRange.HorizontalAlignment:=L_Excel.xlCenter;
  L_Excel.ws_SkipCols(objWS, totC-1);
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);

  L_Excel.ws_StartHeader(objWS);

  L_Excel.ws_AddHeaderItem(objWS, "",                   7, 0);
  L_Excel.ws_AddHeaderItem(objWS, " ",     60, 0);
  L_Excel.ws_AddHeaderItem(objWS, " ࠧ१",         11, 0);
  L_Excel.ws_AddHeaderItem(objWS, " ࠧ१",   60, 0);
  L_Excel.ws_AddHeaderItem(objWS, " ⨬ ᠫ줮", 30, 0);
  L_Excel.ws_AddHeaderItem(objWS, "",                    20, 0);

  L_Excel.ws_StopHeader(objWS);

  L_AFM.MakeMultipleIndex("_Acnt", "Type   : LIKE(CAcnt.Type);"+
                                   "CAcntS : LIKE(CAcnt.Sign);"+
                                   "CAcntN : LIKE(CAcnt.Name);"+
                                   "ACutS  : LIKE(ACLog.Sign);"+
                                   "ACutN  : LIKE(AcCut.Name);"+
                                   "SldType: LIKE(AcCut.SldType)",
                          "_Acnt: Type, CAcntS, ACutS");

  SELECT(AcCut, AcCut);
  WHILE OCCURE(AcCut) DO
   IF (AcCut.AcCut # L_AcCut.Fictive()) &
      (AcCut.AcCut # L_AcCut.erkn_GetSoft(Memo.ud_cd(), L_AcCut.erkn_OnlineBalance)) &
      L_DatTim.IsActive(Memo.ud_cd(), AcCut.Begin, AcCut.Till) THEN
    HISTCONF(Memo.ud_cd(), AcCut, ACLog);
    CONFORM(ACLog, CAcnt);
    DEFAULT(_Acnt);
    _Acnt.Type   :=CAcnt.Type;
    _Acnt.CAcntS :=CAcnt.Sign;
    _Acnt.CAcntN :=CAcnt.Name;
    _Acnt.ACutS  :=ACLog.Sign;
    _Acnt.ACutN  :=AcCut.Name;
    _Acnt.SldType:=AcCut.SldType;
    INSERT(_Acnt);
   END;
   NEXT(AcCut);
  END; (* WHILE OCCURE(AcCut) ... *)

  SELECT(_Acnt, _Acnt);
  WHILE OCCURE(_Acnt) DO
   PROMPT(":  "+_Acnt.CAcntS);
   L_Excel.ws_WrStr(objWS, _Acnt.CAcntS);
   L_Excel.ws_WrStr(objWS, _Acnt.CAcntN);
   L_Excel.ws_WrStr(objWS, _Acnt.ACutS);
   L_Excel.ws_WrStr(objWS, _Acnt.ACutN);
   L_Excel.ws_WrStr(objWS, L_Str.PoolItem(L_AcCut.sldt_Pool, _Acnt.SldType));
   L_Excel.ws_WrStr(objWS, L_Str.PoolItem(L_Acnt.catyp_Pool, _Acnt.Type));

   L_Excel.ws_TermLine(objWS);
   NEXT(_Acnt);
  END; (* WHILE OCCURE(_Acnt) ... *)

  L_Excel.ws_PaintGrid(objWS, L_Excel.xlThin, 1);
 END {intAcPln};

 PUBLIC PROCEDURE AcPln();
  CONST
   RepName = "AcPln";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Excel.BuildRep(PROCREF(intAcPln), "", RepName, 0, 0);
 END {AcPln};

BEGIN
 L_Events.ExecuteHandler();
END.
