(*
%Copyright   (c) Polak IT
%Author      08.11.2011 09:37:59 POLAK\San
%Purpose      - ""  ᯮ짮 孮᪨ CALL
%Type        library
%Specific    Core
%Modified    23.09.2014 11:30:02 POLAK\LDA
%Environment
*)

 MODULE CallStub [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_PCS, L_SprtCrsp, L_StdFrm, L_DatTim, Memo, L_DBD, L_Str,
        L_lsStore, L_AR, Str, L_XDoc, L_WDO;

 PUBLIC PROCEDURE AppendMacro(Text: STRING[]);
 BEGIN
  LIKEMENU(^(Text));
 END {AppendMacro};

 PUBLIC PROCEDURE c_sl_Done();
 BEGIN
  L_XDoc.sl_Done();
 END {c_sl_Done};

 PUBLIC PROCEDURE c_SurveyLastReport();
 BEGIN
  L_General.SurveyLastReport();
 END {c_SurveyLastReport};

 PUBLIC PROCEDURE c_extPosToCurRecordOfTable(trgTable: TABLE);
 BEGIN
  L_DBD.extPosToCurRecordOfTable(trgTable);
 END {c_extPosToCurRecordOfTable};

 PUBLIC PROCEDURE OnAfterInteractiveModification();
 BEGIN
  IF    RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit   THEN L_PCS.SysLogHandler(001);
  ELSIF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert THEN L_PCS.SysLogHandler(003);
  ELSIF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Delete THEN L_PCS.SysLogHandler(004);
  ELSE
   L_General.CallUs(0);
  END;
 END {OnAfterInteractiveModification};

 PUBLIC PROCEDURE OnInitializeZoneFilters();
 BEGIN
  L_WDO.OnInitializeZoneFilters();
 END {OnInitializeZoneFilters};

 PRIVATE PROCEDURE he_PrepareMessageText(SC_AlreadyExists: SCAL[2]): STRING[];
  VAR
   Msg,
   ProgsAlreadyKnow: STRING[];
 BEGIN
  L_General.CallUs(OCCURE(SprtCrsp));
  IF ~L_General.IsLocalMode() THEN
   Msg:=L_Str.PoolItem("ࠡ稪  饭  ஡  祭 5- .|" +
                       "ࠡ稪 㦥   ⮩ ஡  ࠡ  .",
                        SC_AlreadyExists) + "||" +
        " ᮦ    ."
  ELSE
   Msg:=" ਠ  ⠫樨 |" +
        "⮬᪨   訡 ନ,|" +
        " ࠡ稪  ࠢ";
  END;
  RETURN " ६ ᯮ ணࠬ ந諠 訡." + "||" +
         Msg +
         L_StdFrm.HR() +
         "(" + SprtCrsp.SprtCrsp + " " + SprtCrsp.Name + ")";
 END {he_PrepareMessageText};

 PRIVATE PROCEDURE he_GetZoneId(Z: FORM_ZONE): STRING[];
 BEGIN
  RETURN Z.Window.Name + ", " + Z.Number + ", " + L_Str.PoolItem("???|Edit|Insert|Delete|View|Ask|Show|VOID", Z.Processes(0).Kind);
 END {he_GetZoneId};

 PRIVATE PROCEDURE he_GetContext(VAR HasCurWindow: SCAL[2]): STRING[];
  CONST
   ProcessKind_Pool = "Nothing|Edit|Insert|Delete|View|Ask|ShowWin|Void";
  VAR
   Point         : CALL_STACK_CELL;
   curZone       : FORM_ZONE;
   curTable      : TABLE;
   curWindow     : WINDOW;
   ZonePrefix,
   ThisModuleName,
   Result        : STRING[];
   FirstPass     : SCAL[2];
 BEGIN
  HasCurWindow:=0;
  Result:=L_Str.CRLF + L_Str.CRLF + "RTI:";
  IF ~!RTI.Get().CurProcess THEN
   INC(Result, L_Str.CRLF + "CurProcess.Kind: " + L_Str.PoolItem(ProcessKind_Pool, RTI.Get().CurProcess.Kind));
  END;
  IF ~!RTI.Get().CurZone THEN
   curZone:=RTI.Get().CurZone;
   IF ~!curZone.ActiveField THEN
    INC(Result, L_Str.CRLF + "CurZone.ActiveField.Name: " + curZone.ActiveField.Name);
   END;
  ELSE
   SETEMPTY(curZone);
  END;

  TRY [ABORT_AFTER(AA_ON)]
   FirstPass:=1;
   SE_ACCESSDATAMODE(adm_HOTTEST);
   FOR_EACH curWindow IN APP.Get().VisibleWindows DO
    IF curWindow.Type = WINDOW.Type_Loadable THEN
     IF FirstPass THEN
      INC(Result, L_Str.CRLF + L_Str.CRLF + ":");
      FirstPass:=0;
     END;
     IF ~!curZone & (curWindow.ActiveZone = curZone) THEN
      ZonePrefix  :="*** ";
      HasCurWindow:=1;
     ELSIF curWindow = APP.Get().TopWindow THEN
      ZonePrefix:="+++ ";
     ELSE
      ZonePrefix:="";
     END;
     INC(Result, L_Str.CRLF + ZonePrefix + he_GetZoneId(curWindow.ActiveZone));
     curTable:=curWindow.ActiveZone.MasterTable;
     IF ~!curTable THEN
      GE_WZD_CURSOR(curWindow.Name, curWindow.ActiveZone.Number, ^(curTable.Name));
      IF OCCURE(^(curTable.Name)) THEN
       INC(Result, ": " + L_DBD.GetPrimaryIndexValue(curTable.Name));
      ELSE
       INC(Result, ": ⥪   ।");
      END;
     END;
    END;
   END; (* FOR_EACH curWindow ... *)
  EXCEPT
  END; (* TRY *)

  INC(Result, L_Str.CRLF + L_Str.CRLF + "⥪ 맮:");
  ThisModuleName:=RTI.Get().Stack.Item(0).Proc.Module.Name;
  FOR_EACH Point IN RTI.Get().Stack DO
   IF Point.Proc.Module.Name # ThisModuleName THEN
    Result:=L_Str.AddStrDlm(Result, L_Str.CRLF) + Point.Proc.FullName + ", " + L_Str.IntStr(Point.Row);
   END;
  END;

  INC(Result, L_Str.CRLF + L_Str.CRLF + ":");
  FOR_EACH curTable IN DATABASE.Get().Tables DO
   IF curTable.Regular & OCCURE(^(curTable.Name)) THEN
    INC(Result, L_Str.CRLF + curTable.Name + ": " + L_DBD.GetPrimaryIndexValue(curTable.Name));
   END;
  END; (* FOR_EACH curTable ... *)

  RETURN Result;
 END {he_GetContext};

 PRIVATE PROCEDURE he_GetPrompt(PromptLines: PROMPT_LINES): STRING[];
  VAR
   p     : PROMPT_LINE;
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  FOR_EACH p IN PromptLines DO
   Result:=L_Str.AddStrDlm(Result, " _ ") + p.FullText;
  END; (* FOR_EACH *)
  IF !Result THEN
   Result:="";
  END;
  RETURN Result
 END {he_GetPrompt};

 PUBLIC PROCEDURE HandleException(Exc: Exc_Root): STRING[];
  VAR
   trgPrompt,
   trgPurpose,
   trgSubject,
   trgContext  : STRING[];
   HasCurWindow: SCAL[2];
 BEGIN
  L_General.Assert((* L_General.Debug(1) |*) APP.Get().ProductiveCopy,
                   "  ୮    ");
  L_General.Assert(~APP.Get().SupportMode, "  ६ ⫠   ");
  IF (L_General.GetAPSiteNumber() = 10) | (L_General.GetAPSiteNumber() = 90) THEN
   L_General.Error("⮒  ନ");
  END;
  TRY
   TABLE.Get("SprtCrsp").AccessDataMode:=adm_SOFT;
   L_AR.GrantRightsUnconditionally();
   trgSubject:=" " + Exc.ProgramFile + "." + L_Str.IntStr(Exc.Row) + "." + L_Str.IntStr(Exc.Column) + " (" + L_Str.IntStr(Exc.ErrorCode) + ")";
   trgSubject:=L_Str.CutLongStr(Str.Flatten(Exc.Description), 90 - Str.Length(trgSubject)) + trgSubject;
   trgContext:=he_GetContext(HasCurWindow);
   trgPrompt :=he_GetPrompt(Exc.PromptLines);
   SETSEL(SprtCrsp, PrpDate);
   LAST(SprtCrsp);
   LOOP
    IF ~OCCURE(SprtCrsp) | (SprtCrsp.PrpDate < (SYSDATE()-30)) |
       ((SprtCrsp.DoneType = L_SprtCrsp.dt_DoneAsIs) | (SprtCrsp.DoneType = L_SprtCrsp.dt_DoneWAddIns)) THEN
     TRY [TRANSACTION(TRANSACTION_SLAVE2)]
      DEFAULT(SprtCrsp);
      SprtCrsp.Leaf    :=0;
      SprtCrsp.Name    :=trgSubject;
      SprtCrsp.RequestT:=L_SprtCrsp.rt_AutoBuild;
      SprtCrsp.Author  :=L_SprtCrsp.GetAuthorName();
      SprtCrsp.PrpDate :=SYSDATE();
      SprtCrsp.PrpTime :=SYSTIME();
      SprtCrsp.DeadLine:=L_SprtCrsp.dl_Immediately;
      SprtCrsp.RequestT:=L_SprtCrsp.rt_AutoBuild;
      SprtCrsp.Status:=L_SprtCrsp.st_Prepared;
      INSERT(SprtCrsp);
      trgPurpose:=L_SprtCrsp.h_Action  + " " + Exc.TransactionDescr                     + L_Str.CRLF +
                  L_SprtCrsp.h_Object  + " " + L_Str.AnyItem("|. ''  '***'. ", "|", HasCurWindow) +
                                               "騥 /ਮ: " +
                                               L_DatTim.DateStr(Memo.ud_cd()) + ",  " +
                                               L_DatTim.DateStr(Memo.ud_fr()) + "  " +
                                               L_DatTim.DateStr(Memo.ud_ut())           + L_Str.CRLF +
                  L_SprtCrsp.h_Prompt  + " " + trgPrompt                                + L_Str.CRLF +
                  L_SprtCrsp.h_Purpose + " " + Str.Flatten(Exc.Description) + " " +
                                               Exc.ProgramFile              + "." +
                                               L_Str.IntStr(Exc.Row)        + "." +
                                               L_Str.IntStr(Exc.Column)     +
                                               " (" + L_Str.IntStr(Exc.ErrorCode) + ")" +
                                               trgContext;

      SprtCrsp.Purpose :=L_lsStore.Replace(SprtCrsp.Purpose, trgPurpose);
      REPLACE(SprtCrsp);
      L_XDoc.Jrn_Mark(L_XDoc.curXDocId(L_XDoc.xdt_SprtCrsp), L_XDoc.action_AutoBuild);
     EXCEPT
     END; (* TRY *)
     RETURN he_PrepareMessageText(0);
    ELSIF (SprtCrsp.RequestT = L_SprtCrsp.rt_AutoBuild) & (SprtCrsp.Name  = trgSubject) THEN
     RETURN he_PrepareMessageText(1);
    END; (* IF ... *)
    PREV(SprtCrsp);
   END; (* LOOP *)
  EXCEPT
  END; (* TRY *)
 END {HandleException};

END.
