(*
%Copyright   (c) Polak IT
%Author      19.02.2007 19:45:41 POLAK\Bor
%Purpose      ࠡ 
%Type        report
%Specific    AP
%Modified    18.09.2014 11:28:36 POLAK\Bor
%Environment
*)

 MODULE Car05 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_bp, L_General, L_DatTim, L_Car, L_Basis, L_Str, L_Way, L_AFM, L_MathR, L_Acnt, L_Fuel, L_XObj,
        L_CI, L_SFee, L_OTx, L_PRoll, L_EC, L_Staff,
        D_TP, D_Fl, D_RWS, D_XObj, D_Stock, P_Route, P_Car, P_Firm, FIO, Math, Str, E_Stock, L_Env, L_Man;

 CONST
  RepName = "Car05";

 VAR
  From,
  UpTo: DATE;
  wMF : SCAL[2];

 TYPE
  tKeyVal   = SCAL[(Math.Max(MAXOF(Car.BoxNbr)+1, (MAXOF(Mark.Mark)+1)*MAXOF(TKind.TKind)+1))*10];
  tWeight   = SCAL[8];
  tValue    = NUMERIC[3];
  tCostType = SCAL[10];
  tCostId   = SCAL[1e12];
  tDistr    = SCAL[3];
  tTmpFlNam = STRING[8];

 CONST
  w_CarRun         = 0;
  w_MrkTKRun       = 1;
  w_MarkRun        = 2;
  w_AnyRun         = 3;
  w_StfSalary      = 4;
  w_ManSalary      = 5;
  w_WhoSrtSalary   = 6;
  w_StfLikeNonPSal = 7;

  kv_Any    = MAXOF(tKeyVal);

  ct_Salary    = 0;
  ct_Math      = 1;
  ct_FO        = 2;
  ct_Amrt      = 3;
  ct_Income    = 4;
  ct_Run       = 5;
  ct_CI        = 6;
  ct_Provision = 7;
  ct_SFee      = 8;
  ct_Travm     = 9;
  ct_Pool = "௫|||⨧|室|஡|???| । 室|客 |客 ";

  cid_Only = 0;

  cid_FO_Fuel = 0;
  cid_FO_Oil  = 1;
  cid_FO_Pool = "|᫠";

  d_Direct   = 0;
  d_Real     = 1;
  d_Main     = 2;
  d_Pool     = "|| ॢ";

  WeightTmpFl  = "TP002";
  SWeightTmpFl = "RWM02";

 PRIVATE PROCEDURE CostName(trgCostType: tCostType; trgCostId: tCostId): STRING[];
 BEGIN
  IF    trgCostType = ct_Salary THEN
   RETURN L_Str.PoolItem("ﬠ|ﬠ|ந⢥", trgCostId); (*RWM02.Direct*)
  ELSIF trgCostType = ct_Math   THEN
   SEARCH(MathType, MathType, , trgCostId);
   RETURN MathType.Name;
  ELSIF trgCostType = ct_FO     THEN
   RETURN L_Str.PoolItem(cid_FO_Pool, trgCostId);
  ELSIF trgCostType = ct_Amrt   THEN
   SEARCH(AcCut, AcCut, , trgCostId);
   RETURN AcCut.Name;
  ELSIF trgCostType = ct_Income THEN
   RETURN "室";
  ELSIF trgCostType = ct_Run    THEN
   RETURN "஡";
  ELSIF trgCostType = ct_CI     THEN
   SEARCH(CIKind, CIKind, , trgCostId);
   RETURN CIKind.Name;
  ELSIF trgCostType = ct_Provision THEN
   SEARCH(AcCut, AcCut, , trgCostId);
   IF L_kn.Is(UpTo, L_AcCut.erkn_VacationProvision) THEN
    L_kn.AccessERKN("AcCut", L_AcCut.erkn_VacationProvision);
    RETURN ERKN.Name;
   ELSE
    RETURN AcCut.Name;
   END;
  ELSIF trgCostType = ct_SFee THEN
   RETURN L_Str.PoolItem(L_SFee.p_Pool, trgCostId);
  ELSIF trgCostType = ct_Travm THEN
   RETURN " 'ࠢ⨧'";
  ELSE
   L_General.CallUs(0);
  END; (* IF trgCostType = *)
 END {CostName};

 PRIVATE PROCEDURE CostTypeName(trgCostType: tCostType; trgCostId: tCostId): STRING[];
 BEGIN
  IF (trgCostType = ct_CI) THEN
   RETURN CostName(trgCostType, trgCostId);
  ELSE
   RETURN L_Str.PoolItem(ct_Pool, trgCostType);
  END;
 END {CostTypeName};

 PRIVATE PROCEDURE KindName(trgCostType: tCostType): STRING[];
 BEGIN
  IF (trgCostType = ct_Income) THEN RETURN "室";
  ELSE                              RETURN "室";
  END;
 END {KindName};

 PRIVATE PROCEDURE IsSalaryLikeCostType(trgCostType: tCostType): SCAL[2];
 BEGIN
  RETURN (trgCostType = ct_Salary);
 END {IsSalaryLikeCostType};

 PRIVATE PROCEDURE IsSalaryWeight(trgWeight: tWeight): SCAL[2];
 BEGIN
  RETURN (trgWeight = w_StfSalary)    | (trgWeight = w_ManSalary) |
         (trgWeight = w_WhoSrtSalary) | (trgWeight = w_StfLikeNonPSal);
 END {IsSalaryWeight};

 PRIVATE PROCEDURE intStandOnRoute(trgRoute: LIKE(Route.Route); trgTmpFlNam: tTmpFlNam);
 BEGIN
  IF ~SEARCH(Route, Route, trgRoute) THEN
   L_General.Error("   " + trgRoute + " - ᫥  ⮢ ࠭ 䠩|"+TABLE.Get(trgTmpFlNam).Description);
  END;
 END {intStandOnRoute};

 PRIVATE PROCEDURE MakeHeader();
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrStr('R', "");
   L_Basis.wb_WrStr('R', "");
  END;
  L_Basis.wb_WrInQM('R', "");
  L_Basis.wb_WrInQM('R', "᭮");
  L_Basis.wb_WrInQM('R', "");
  L_Basis.wb_WrInQM('R', "祭");
  L_Basis.wb_WrInQM('R', "९멂ॢ");
  L_Basis.wb_WrInQM('R', "९멂ॢ");
  L_Basis.wb_WrInQM('R', "९멌");
  L_Basis.wb_WrInQM('R', "९멌");
  L_Basis.wb_WrInQM('R', "ઠ");
  L_Basis.wb_WrInQM('R', "ઠ");
  L_Basis.wb_WrInQM('R', "㯯 ப");
  L_Basis.wb_WrInQM('R', "㯯 ப");
  L_Basis.wb_WrInQM('R', "㯯 ⮢");
  L_Basis.wb_WrInQM('R', "");
  L_Basis.wb_WrInQM('R', "");
  L_Basis.wb_WrInQM('R', "ॢ");
  L_Basis.wb_WrInQM('R', "ॢ");
  L_Basis.wb_WrInQM('R', "஢");
  L_Basis.wb_WrInQM('R', " ");
  L_Basis.wb_WrInQM('R', "");
  L_Basis.wb_WrInQM('R', " ⥫");
  L_Basis.wb_WrInQM('R', "⥫");
  L_Basis.wb_WrInQM('R', "ᮡ ।");
  L_Basis.wb_WrInQM('R', "㬬");
  L_Basis.wb_WrInQM('R', "஡");
  L_Basis.wb_TermLine('R');
 END {MakeHeader};

 PRIVATE PROCEDURE MakeLine();
  VAR
   curCostTypeName,
   curCostName    : STRING[];
   FixedRoute     : LIKE(Route.Route);
 BEGIN
  IF Tmp02.Cir # 0 THEN
   curCostTypeName:=CostTypeName(Tmp02.CostType, Tmp02.CostId);
   curCostName    :=CostName(Tmp02.CostType, Tmp02.CostId);
   IF wMF THEN
    L_Basis.wb_WrScl('R', MyFirm.MyFirm);
    L_Basis.wb_WrStr('R', MyFirm.vzSign);
   END;
   IF OCCURE(CarLog) THEN
    PROMPT(" " + CarLog.BoxNbr + ", " + curCostTypeName + ", " + curCostName + ",  " + Tmp02.Route);
    L_Basis.wb_WrScl('R', CarLog.BoxNbr);
    L_Basis.wb_WrStr('R', CarLog.StateNbr);
    L_Basis.wb_WrScl('R', CarLog.Column);
    L_Basis.wb_WrStr('R', L_Str.PoolItem("|", CarLog.Purpose));
    IF ~!CarLog.TKind THEN
     SAVE(TKind);
     L_Basis.wb_WrScl('R', CarLog.TKind);
     CONFORM(CarLog, TKind);
     L_Basis.wb_WrStr('R', TKind.Name);
     RESTORE(TKind);
    ELSE
     L_Basis.wb_WrStr('R', "---");
     L_Basis.wb_WrStr('R', "---");
    END;
    IF P_Car.HasActualCarPro(CarLog.BoxNbr, Memo.ud_fr(), P_Car.P_FixedRoute) THEN
     FixedRoute:=P_Car.GetCarProSoft(CarLog.BoxNbr, Memo.ud_fr(), P_Car.P_FixedRoute);
     SAVE(Route);
     L_General.Assert(SEARCH(Route, Route, FixedRoute), "  ९  . " + CarLog.BoxNbr + "  " + FixedRoute);
     L_Basis.wb_WrStr('R', FixedRoute);
     L_Basis.wb_WrStr('R', Route.Name);
     RESTORE(Route);
    ELSE
     L_Basis.wb_WrStr('R', "---");
     L_Basis.wb_WrStr('R', "---");
    END;
   ELSE
    PROMPT(" ----" + ", " + curCostTypeName + ", " + curCostName + ", : " + Tmp02.Route);
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
   END;
   IF OCCURE(Mark) THEN
    L_Basis.wb_WrStr('R', Mark.Mark);
    L_Basis.wb_WrStr('R', Mark.Name);
    IF OCCURE(MarkG) THEN
     L_Basis.wb_WrStr('R', MarkG.MarkG);
     L_Basis.wb_WrStr('R', MarkG.Name);
    ELSE
     L_Basis.wb_WrStr('R', "---");
     L_Basis.wb_WrStr('R', "---");
    END;
   ELSE
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
   END;
   IF OCCURE(Route) THEN
    L_Basis.wb_WrStr('R', P_Route.GetRouteProSoft(Route.Route, UpTo, P_Route.P_Group));
    L_Basis.wb_WrStr('R', Route.Route);
    L_Basis.wb_WrStr('R', Route.Name);
   ELSE
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
   END;
   IF OCCURE(TKind) THEN
    L_Basis.wb_WrScl('R', TKind.TKind);
    L_Basis.wb_WrStr('R', TKind.Name);
    L_Basis.wb_WrStr('R', L_Str.PoolItem(L_Way.tkfnm_Pool, TKind.FnMode));
   ELSE
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
    L_Basis.wb_WrStr('R', "---");
   END;
   L_Basis.wb_WrStr('R', L_Str.PoolItem("|", ~!Tmp02.Route & IsRealRoute(Tmp02.Route)));
   L_Basis.wb_WrStr('R', KindName(Tmp02.CostType));
   L_Basis.wb_WrStr('R', curCostTypeName);
   L_Basis.wb_WrStr('R', curCostName);
   L_Basis.wb_WrStr('R', L_Str.PoolItem(d_Pool, Tmp02.Distr));

   IF Tmp02.CostType = ct_Run THEN
    L_Basis.wb_WrNum('R', 0,         2);
    L_Basis.wb_WrNum('R', Tmp02.Cir, 2); (*஡*)
   ELSE
    L_Basis.wb_WrNum('R', Tmp02.Cir, 2);
    L_Basis.wb_WrNum('R', 0,         2);
   END;
   L_Basis.wb_TermLine('R');
  END;
 END {MakeLine};

 PRIVATE PROCEDURE Print();
 BEGIN
  SELECT(Tmp02, Tmp02);
  WHILE OCCURE(Tmp02) DO
   L_General.CallUs(SEARCH(MyFirm, MyFirm, Tmp02.MyFirm));
   NARROWSEL(Tmp02, MyFirm);
   WHILE OCCURE(Tmp02) DO
    IF ~!Tmp02.Mark THEN
     SEARCH(Mark, Mark, , Tmp02.Mark);
     SEARCH(MarkG, MarkG, , L_Way.GetMarkG_Soft(Mark.Mark, L_Way.mgt_Math));
    ELSE
     SETSEL(Mark, Mark);
    END;
    NARROWSEL(Tmp02, Mark);
    WHILE OCCURE(Tmp02) DO
     IF ~!Tmp02.BoxNbr THEN
      L_Car.StandOnCarLog(Tmp02.BoxNbr, UpTo);
     ELSE
      SETSEL(CarLog, BoxNbr);
     END;
     NARROWSEL(Tmp02, BoxNbr);
     WHILE OCCURE(Tmp02) DO
      IF ~!Tmp02.TKind THEN
       L_General.CallUs(SEARCH(TKind, TKind, Tmp02.TKind));
      ELSE
       SETSEL(TKind, TKind);
      END;
      NARROWSEL(Tmp02, TKind);
      WHILE OCCURE(Tmp02) DO
       IF ~!Tmp02.Route THEN
        intStandOnRoute(Tmp02.Route, Tmp02.TmpFlNam);
       ELSE
        SETSEL(Route, Route);
       END;
       NARROWSEL(Tmp02, Route);
       FOR_EACH Tmp02 DO
        MakeLine();
       END; (* FOR_EACH Tmp02 ... *)
       NEXTINEXTENDEDSEL(Tmp02, Route);
      END; (* WHILE OCCURE(Tmp02) *)
      NEXTINEXTENDEDSEL(Tmp02, TKind);
     END; (* WHILE OCCURE(Tmp02) *)
     NEXTINEXTENDEDSEL(Tmp02, BoxNbr);
    END; (* WHILE OCCURE(Tmp02) *)
    NEXTINEXTENDEDSEL(Tmp02, Mark);
   END; (* WHILE OCCURE(Tmp02) *)
   NEXTINEXTENDEDSEL(Tmp02, MyFirm);
  END; (* WHILE OCCURE(Tmp02) *)
 END {Print};

 PRIVATE PROCEDURE IsRealRoute(trgRoute: LIKE(Route.Route)): SCAL[2];
 BEGIN
  RETURN ~!trgRoute & D_RWS.E_IsRoute2Distribute(trgRoute, UpTo);
 END {IsRealRoute};

 PRIVATE PROCEDURE IsMainTKind(trgTKind: LIKE(Route.Route)): SCAL[2];
 BEGIN
  SEARCH(TKind, TKind, , trgTKind);
  RETURN (TKind.FnMode = L_Way.tkfnm_Subsidy) | (TKind.FnMode = L_Way.tkfnm_Commerce);
 END {IsMainTKind};

 PRIVATE PROCEDURE PosToMarkAndMyFirm(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE);
 BEGIN
  L_Car.StandOnCarLog(trgBoxNbr, D);
  CONFORM(CarLog, Mark);
  CONFORM(CarLog, Column);
  CONFORM(Column, MyFirm);
 END {PosToMarkAndMyFirm};

 PRIVATE PROCEDURE GetCarLogTKind(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE): LIKE(TKind.TKind);
  VAR
   Result: LIKE(TKind.TKind);
 BEGIN
  SAVE(CarLog);
  L_Car.StandOnCarLog(trgBoxNbr, D);
  Result:=CarLog.TKind;
  RESTORE(CarLog);
  RETURN Result;
 END {GetCarLogTKind};

 PRIVATE PROCEDURE GetRouteLogTKind(trgRoute: LIKE(Route.Route); D: DATE): LIKE(TKind.TKind);
  VAR
   Result: LIKE(TKind.TKind);
 BEGIN
  IF ~!trgRoute THEN
   SAVE(Route);
   L_Way.PositionOnRouteLog(trgRoute, D);
   Result:=RouteLog.TKind;
   RESTORE(Route);
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetRouteLogTKind};

 PRIVATE PROCEDURE WeightForSpread(trgDistr: tDistr; trgCostType: tCostType; trgCostId: tCostId): tWeight;
 BEGIN
  IF IsSalaryLikeCostType(trgCostType) THEN
   L_General.CallUs(trgDistr = d_Main);
   RETURN w_CarRun;
  ELSIF trgCostType = ct_Math THEN
   IF trgCostId = L_MathR.mtyp_Tyres THEN    RETURN w_CarRun;
   ELSE                                      RETURN w_MarkRun;
   END;
  ELSIF trgCostType = ct_Amrt THEN           RETURN w_CarRun;
  ELSIF trgCostType = ct_CI   THEN           RETURN w_CarRun;
  ELSE
   L_General.CallUs(trgDistr # d_Direct);
   RETURN w_CarRun;
  END; (* IF trgCostType = ... *)
 END {WeightForSpread};

 PRIVATE PROCEDURE SpreadByWeight(trgDistr   : tDistr;
                                  trgMyFirm  : LIKE(MyFirm.MyFirm);
                                  trgMark    : LIKE(Mark.Mark);
                                  trgBoxNbr  : LIKE(Car.BoxNbr);
                                  trgCostType: tCostType;
                                  trgCostId  : tCostId;
                                  trgWeight  : tWeight;
                                  trgKeyVal  : tKeyVal;
                                  TotCir     : NUMERIC[2]);
  VAR
   TotVal  : tValue;
   Rest,
   PrtCir,
   maxCir  : L_XObj.tSum;
   maxRoute: LIKE(Route.Route);
   maxTKind: LIKE(TKind.TKind);
 BEGIN
  IF TotCir # 0 THEN
   L_General.CallUs(~IsSalaryWeight(trgWeight));
   Rest:=TotCir;
   SETEMPTY(maxRoute, maxTKind);
   SETSEL(_Wght, Weight, trgDistr, trgMyFirm, trgWeight, trgKeyVal);
   IF SRCINSEL(_Wght, EQ, 1, EMPTYOF(TKind.TKind), EMPTYOF(Route.Route)) THEN
    TotVal:=_Wght.Value;
    maxCir:=0;
    SETSEL(_Wght, Weight, trgDistr, trgMyFirm, trgWeight, trgKeyVal, 0);
    FOR_EACH _Wght DO
     PrtCir:=TotCir*_Wght.Value/TotVal;
     IF Math.Abs(PrtCir) >= maxCir THEN
      maxRoute:=_Wght.Route;
      maxTKind:=_Wght.TKind;
      maxCir  :=Math.Abs(PrtCir);
     END;
     DEC(Rest, PrtCir);
     ADD(Tmp02, Tmp02, , trgMyFirm, trgMark, trgBoxNbr, _Wght.TKind, _Wght.Route,
                         trgCostType, trgCostId, trgDistr, WeightTmpFl,
         Tmp02.Cir, PrtCir);
    END; (* FOR_EACH _Wght ... *)
   END; (* IF SRCINSEL(_Wght ... *)
   IF Rest # 0 THEN
    ADD(Tmp02, Tmp02, , trgMyFirm, trgMark, trgBoxNbr, maxTKind, maxRoute,
                        trgCostType, trgCostId, trgDistr, WeightTmpFl,
        Tmp02.Cir, Rest);
   END;
  END;
 END {SpreadByWeight};

 PRIVATE PROCEDURE HasBasisForSpread(trgDistr : tDistr;
                                     trgMyFirm: LIKE(MyFirm.MyFirm);
                                     trgWeight: tWeight;
                                     trgKeyVal: tKeyVal): SCAL[2];
 BEGIN
  RETURN SELECT(_Wght, Weight, trgDistr, trgMyFirm, trgWeight, trgKeyVal, 1);
 END {HasBasisForSpread};

 PRIVATE PROCEDURE HasSBasisForSpread(trgMyFirm: LIKE(MyFirm.MyFirm);
                                      trgWeight: tWeight;
                                      trgKeyVal: tKeyVal): SCAL[2];
 BEGIN
  RETURN SELECT(SWght, SWght, trgMyFirm, trgWeight, trgKeyVal);
 END {HasSBasisForSpread};

 PRIVATE PROCEDURE Spread(trgDistr   : tDistr;
                          trgMyFirm  : LIKE(MyFirm.MyFirm);
                          trgMark    : LIKE(Mark.Mark);
                          trgBoxNbr  : LIKE(Car.BoxNbr);
                          trgCostType: tCostType;
                          trgCostId  : STRING[];
                          trgCir     : NUMERIC[2]);
  VAR
   curWeight : tWeight;
   curCLTKind: LIKE(TKind.TKind);
   curKeyVal : tKeyVal;
   Ok        : SCAL[2]; (* ᠬ஫*)
 BEGIN
  Ok:=0;
  curWeight:=WeightForSpread(trgDistr, trgCostType, trgCostId);
  IF curWeight = w_CarRun THEN
   IF ~!trgBoxNbr THEN
    curKeyVal:=trgBoxNbr;
    Ok:=HasBasisForSpread(trgDistr, trgMyFirm, curWeight, curKeyVal);
   END;
   IF ~Ok & ~!trgMark THEN (*᫨  ஡  - ஡ ન  ९   *)
    curCLTKind:=GetCarLogTKind(trgBoxNbr, UpTo);
    IF ~!curCLTKind THEN
     curWeight:=w_MrkTKRun;
     curKeyVal:=GetMrkAndTKindKeyVal(trgMark, curCLTKind);
     Ok:=HasBasisForSpread(trgDistr, trgMyFirm, curWeight, curKeyVal);
    END;
   END; (* IF ~Ok ... *)
   IF ~Ok & ~!trgMark THEN (*᫨   ஡ ન  ९    - 騥 ஡ ⥪饩 ન*)
    curWeight:=w_MarkRun;
   END;
  END;
  IF (curWeight = w_MarkRun) & ~!trgMark THEN
   curKeyVal:=trgMark;
   Ok:=(trgDistr # d_Main) |
       HasBasisForSpread(trgDistr, trgMyFirm, curWeight, curKeyVal);
  END;
  IF ~Ok THEN
   L_General.CallUs(trgDistr = d_Main);
   curWeight:=w_AnyRun;
   curKeyVal:=kv_Any;
  END;

  SpreadByWeight(trgDistr, trgMyFirm, trgMark, trgBoxNbr, trgCostType, trgCostId,
                                      curWeight, curKeyVal, trgCir)
 END {Spread};

 PRIVATE PROCEDURE SpreadBySalary(trgMyFirm  : LIKE(MyFirm.MyFirm);
                                  trgCostType: tCostType;
                                  trgCostId  : tCostId;
                                  trgWeight  : tWeight;
                                  trgKeyVal  : tKeyVal;
                                  TotCir     : NUMERIC[2]);
  VAR
   TotVal   : tValue;
   Rest,
   PrtCir,
   maxCir   : L_XObj.tSum;
   maxBoxNbr: LIKE(Car.BoxNbr);
   maxMark  : LIKE(Mark.Mark);
   maxRoute : LIKE(Route.Route);
   maxTKind : LIKE(TKind.TKind);
 BEGIN
  IF TotCir # 0 THEN
   L_General.CallUs(IsSalaryWeight(trgWeight));
   Rest:=TotCir;
   SETEMPTY(maxBoxNbr, maxMark, maxRoute, maxTKind);
   SETSEL(SWght, SWght, trgMyFirm, trgWeight, trgKeyVal);
   IF SRCINSEL(SWght, EQ, 1, EMPTYOF(tDistr), EMPTYOF(Car.BoxNbr), EMPTYOF(Mark.Mark), EMPTYOF(TKind.TKind), EMPTYOF(Route.Route)) THEN
    TotVal:=SWght.Value;
    IF TotVal # 0 THEN
     maxCir:=0;
     SETSEL(SWght, SWght, trgMyFirm, trgWeight, trgKeyVal, 0);
     FOR_EACH SWght DO
      IF SWght.Value # 0 THEN
       PrtCir:=TotCir*SWght.Value/TotVal;
       IF (SWght.Distr = d_Direct) & (Math.Abs(PrtCir) >= maxCir) THEN
        maxBoxNbr:=SWght.BoxNbr;
        maxMark  :=SWght.Mark;
        maxRoute :=SWght.Route;
        maxTKind :=SWght.TKind;
        maxCir   :=Math.Abs(PrtCir);
       END;
       DEC(Rest, PrtCir);
       ADD(Tmp02, Tmp02, , trgMyFirm, SWght.Mark, SWght.BoxNbr, SWght.TKind, SWght.Route,
                           trgCostType, trgCostId, SWght.Distr, SWeightTmpFl,
           Tmp02.Cir, PrtCir);
      END;
     END; (* FOR_EACH SWght ... *)
    END; (* IF TotVal # 0 *)
   END; (* IF SRCINSEL(SWght, ... *)
   IF Rest # 0 THEN
    ADD(Tmp02, Tmp02, , trgMyFirm, maxMark, maxBoxNbr, maxTKind, maxRoute,
                        trgCostType, trgCostId, d_Direct, SWeightTmpFl,
        Tmp02.Cir, Rest);
   END;
  END;
 END {SpreadBySalary};

 PRIVATE PROCEDURE Put(trgDistr   : tDistr;
                       trgMyFirm  : LIKE(MyFirm.MyFirm);
                       trgMark    : LIKE(Mark.Mark);
                       trgBoxNbr  : LIKE(Car.BoxNbr);
                       trgCostType: tCostType;
                       trgCostId  : tCostId;
                       trgRoute   : LIKE(Route.Route);
                       trgCir     : NUMERIC[2];
                       trgTmpFlNam: tTmpFlNam);
 BEGIN
  ADD(Tmp02, Tmp02, , trgMyFirm, trgMark, trgBoxNbr, GetRouteLogTKind(trgRoute, UpTo), trgRoute,
                      trgCostType, trgCostId, trgDistr, trgTmpFlNam,
      Tmp02.Cir, trgCir);
 END {Put};

 PRIVATE PROCEDURE PutDirect(trgMyFirm  : LIKE(MyFirm.MyFirm);
                             trgMark    : LIKE(Mark.Mark);
                             trgBoxNbr  : LIKE(Car.BoxNbr);
                             trgCostType: tCostType;
                             trgCostId  : tCostId;
                             trgRoute   : LIKE(Route.Route);
                             trgCir     : NUMERIC[2];
                             trgTmpFlNam: tTmpFlNam);
 BEGIN
  Put(d_Direct, trgMyFirm, trgMark, trgBoxNbr, trgCostType, trgCostId, trgRoute, trgCir, trgTmpFlNam);
 END {PutDirect};

 PRIVATE PROCEDURE OutKeyAssAcCuts(trgAcCuts: L_MathR.tMathAcCutCollection);
  VAR
   curAcCut: LIKE(AcCut.AcCut);
   curCrd  : L_XObj.tSum;
 BEGIN
  CONFORM(CarLog, Math);
  L_MathR.CountUpMath(Math.Math, L_DatTim.Per(UpTo));
  IF L_MathR.SoftAccessKeyAssXObject() THEN
   FOR_EACH curAcCut IN trgAcCuts DO
    curCrd:=0;
    SETSEL(XApport, XObject, XObject.XObject, curAcCut);
    SRCINSEL(XApport, GE, , From);
    WHILE OCCURE(XApport) &  (XApport.XDat <= UpTo) DO
     INC(curCrd, L_MathR.XApportAmortSum());
     NEXT(XApport);
    END; (* WHILE OCCURE(XApport) ... *)
 
    IF curCrd # 0 THEN
     Spread(d_Direct, Math.MyFirm, CarLog.Mark, CarLog.BoxNbr, ct_Amrt, curAcCut, curCrd);
    END;
   END; (* FOR_EACH curAcCut ... *)
  END;
 END {OutKeyAssAcCuts};

 PRIVATE PROCEDURE OutElementCostItem(trgBoxNbr: LIKE(Car.BoxNbr));
  VAR
   curDbt: L_XObj.tSum;
 BEGIN
  IF SEARCH(ACSetL, ACSet, CostItem.ACSet, L_Acnt.acp_CostItem_Default) THEN
   curDbt:=0;
   SETSEL(XCalc, XObject, CostItem.XObject, ACSetL.AcCut);
   SRCINSEL(XCalc, GE, , From);
   WHILE OCCURE(XCalc) &  (XCalc.XDat <= UpTo) DO
    INC(curDbt, XCalc.DbtSum);
    NEXT(XCalc);
   END; (* WHILE OCCURE(XCalc) ... *)
   IF curDbt # 0 THEN
    L_General.Assert(~!trgBoxNbr, " "+CostItem.Parent+"  ᮯ⠢   "+L_DatTim.DateStr(UpTo));
    L_Car.StandOnCarLog(trgBoxNbr, UpTo);
    Spread(d_Direct, CostItem.MyFirm, CarLog.Mark, CarLog.BoxNbr, ct_CI, CostItem.CIKind,
           curDbt);
   END;
  END;
 END {OutElementCostItem};

 PRIVATE PROCEDURE OutCostItem(CarCostItem: LIKE(CostItem.CostItem));
  VAR
   curBoxNbr: LIKE(Car.BoxNbr);
 BEGIN
  curBoxNbr:=L_CI.GetCarByCostItem(CarCostItem, UpTo);
  SAVE(CostItem);
  SETSEL(CostItem, Parent, CarCostItem);
  FOR_EACH CostItem DO
   IF CostItem.Leaf & ~!CostItem.CIKind & L_DatTim.IsActiveInIntvl_Inc(From, UpTo, CostItem.Begin, CostItem.Till) THEN
    PROMPT(" "+CostItem.CostItem);
    CONFORM(CostItem, CIKind);
    IF CIKind.Type = L_CI.cikt_Element THEN
     OutElementCostItem(curBoxNbr);
    END;
   END;
  END; (* FOR_EACH CostItem ... *)
  RESTORE(CostItem);
 END {OutCostItem};

 PRIVATE PROCEDURE CreateTmp();
 BEGIN
  L_AFM.MakeMultipleIndex("_Wght", "Distr   : "+GET_TYPE_SPEC(tDistr).Name+";"+
                                   "MyFirm  : "+GET_TYPE_SPEC(P_Firm.tMyFirm).Name+";"+
                                   "Weight  : "+GET_TYPE_SPEC(tWeight).Name+";"+
                                   "KeyVal  : "+GET_TYPE_SPEC(tKeyVal).Name+";"+
                                   "IsTotal : SCAL[2];"+
                                   "TKind   : LIKE(TKind.TKind);"+
                                   "Route   : LIKE(Route.Route);"+
                                   "Value   : "+GET_TYPE_SPEC(tValue).Name,
                          "Weight: Distr, MyFirm, Weight, KeyVal, IsTotal, TKind, Route");

  L_AFM.MakeMultipleIndex("SWght", "Distr   : "+GET_TYPE_SPEC(tDistr).Name+";"+
                                   "MyFirm  : "+GET_TYPE_SPEC(P_Firm.tMyFirm).Name+";"+
                                   "Weight  : "+GET_TYPE_SPEC(tWeight).Name+";"+
                                   "KeyVal  : "+GET_TYPE_SPEC(tKeyVal).Name+";"+
                                   "BoxNbr  : LIKE(Car.BoxNbr);"+
                                   "Mark    : LIKE(Mark.Mark);"+
                                   "TKind   : LIKE(TKind.TKind);"+
                                   "Route   : LIKE(Route.Route);"+
                                   "IsTotal : SCAL[2];"+
                                   "Value   : "+GET_TYPE_SPEC(tValue).Name,
                          "SWght: MyFirm, Weight, KeyVal, IsTotal, Distr, BoxNbr, Mark, TKind, Route");

  L_AFM.MakeMultipleIndex("Tmp02", "MyFirm  : "+GET_TYPE_SPEC(P_Firm.tMyFirm).Name+";"+
                                   "Mark    : LIKE(Mark.Mark);"+
                                   "BoxNbr  : LIKE(Car.BoxNbr);"+
                                   "TKind   : LIKE(TKind.TKind);"+
                                   "Route   : LIKE(Route.Route);"+
                                   "CostType: "+GET_TYPE_SPEC(tCostType).Name+";"+
                                   "CostId  : "+GET_TYPE_SPEC(tCostId).Name+";"+
                                   "Distr   : "+GET_TYPE_SPEC(tDistr).Name+";"+
                                   "TmpFlNam: "+GET_TYPE_SPEC(tTmpFlNam).Name+";"+
                                   "Cir     : NUMERIC[2]",
                          "Tmp02   : MyFirm, Mark, BoxNbr, TKind, Route, CostType, CostId, Distr, TmpFlNam;"+
                          "Distr   : Distr, CostType, Route");
 END {CreateTmp};

 PRIVATE PROCEDURE AddWeight(trgDistr : tDistr;
                             trgWeight: tWeight;
                             trgKeyVal: tKeyVal;
                             trgMyFirm: LIKE(MyFirm.MyFirm);
                             trgTKind : LIKE(TKind.TKind);
                             trgRoute : LIKE(Route.Route);
                             trgValue : tValue);
 BEGIN
  IF trgValue # 0 THEN
   L_General.CallUs(~IsSalaryWeight(trgWeight));
   ADD(_Wght, Weight, , trgDistr, trgMyFirm, trgWeight, trgKeyVal, 0, trgTKind, trgRoute,
              _Wght.Value, trgValue);
   ADD(_Wght, Weight, , trgDistr, trgMyFirm, trgWeight, trgKeyVal, 1, EMPTYOF(trgTKind), EMPTYOF(trgRoute),
              _Wght.Value, trgValue);
  END;
 END {AddWeight};

 PRIVATE PROCEDURE AddSWeight(trgDistr : tDistr;
                              trgWeight: tWeight;
                              trgKeyVal: tKeyVal;
                              trgMyFirm: LIKE(MyFirm.MyFirm);
                              trgBoxNbr: LIKE(Car.BoxNbr);
                              trgMark  : LIKE(Mark.Mark);
                              trgTKind : LIKE(TKind.TKind);
                              trgRoute : LIKE(Route.Route);
                              trgValue : tValue);
 BEGIN
  IF trgValue # 0 THEN
   L_General.CallUs(IsSalaryWeight(trgWeight));
   ADD(SWght, SWght, , trgMyFirm, trgWeight, trgKeyVal, 0, trgDistr, trgBoxNbr, trgMark, trgTKind, trgRoute,
              SWght.Value, trgValue);
   ADD(SWght, SWght, , trgMyFirm, trgWeight, trgKeyVal, 1, EMPTYOF(trgDistr), EMPTYOF(trgBoxNbr), EMPTYOF(trgMark), EMPTYOF(trgTKind), EMPTYOF(trgRoute),
              SWght.Value, trgValue);
  END;
 END {AddSWeight};

 PRIVATE PROCEDURE RealRedistribute();
 BEGIN
  APP.Get().NewPrompt("।  ॠ ");
  SELECT(Tmp02, Distr, , d_Direct);
  WHILE OCCURE(Tmp02) DO
   NARROWSEL(Tmp02, CostType);
   IF (Tmp02.CostType # ct_Run) &
      ~IsSalaryLikeCostType(Tmp02.CostType (* 㦥 ।  D_RWS*)) THEN
    WHILE OCCURE(Tmp02) DO
     PROMPT(" "+Tmp02.Route);
     NARROWSEL(Tmp02, Route);
     IF ~!Tmp02.Route & ~IsRealRoute(Tmp02.Route) THEN
      FOR_EACH Tmp02 DO
       SAVE(Tmp02);
       ADD(Tmp02, Tmp02, , Tmp02.MyFirm, Tmp02.Mark, Tmp02.BoxNbr, Tmp02.TKind, Tmp02.Route,
                           Tmp02.CostType, Tmp02.CostId, d_Real, Tmp02.TmpFlNam,
           Tmp02.Cir, -Tmp02.Cir);
       RESTORE(Tmp02);
       SAVE(Tmp02);
       Spread(d_Real, Tmp02.MyFirm, Tmp02.Mark, Tmp02.BoxNbr, Tmp02.CostType, Tmp02.CostId,
              Tmp02.Cir);
       RESTORE(Tmp02);
      END; (* FOR_EACH Tmp02 ... *)
     END; (* IF ~IsRealRoute(Tmp02.Route) ... *)
     NEXTINEXTENDEDSEL(Tmp02, Route);
    END; (* WHILE OCCURE(Tmp02) ... *)
   END; (* IF Tmp02.CostType # ct_Run ... *)
   NEXTINEXTENDEDSEL(Tmp02, CostType);
  END; (* WHILE OCCURE(Tmp02) ... *)
 END {RealRedistribute};

 PRIVATE PROCEDURE intMainRedistribute(trgDistr: tDistr);
 BEGIN
  APP.Get().NewPrompt("।  ᭮  ॢ. 室  室 '"+L_Str.PoolItem(d_Pool, trgDistr)+"'");
  SELECT(Tmp02, Distr, , trgDistr);
  WHILE OCCURE(Tmp02) DO
   NARROWSEL(Tmp02, CostType);
   IF Tmp02.CostType # ct_Run THEN
    WHILE OCCURE(Tmp02) DO
     PROMPT(" "+Tmp02.Route);
     NARROWSEL(Tmp02, Route);
     IF !Tmp02.TKind | (IsRealRoute(Tmp02.Route) & ~IsMainTKind(Tmp02.TKind)) THEN
      FOR_EACH Tmp02 DO
       SAVE(Tmp02);
       ADD(Tmp02, Tmp02, , Tmp02.MyFirm, Tmp02.Mark, Tmp02.BoxNbr, Tmp02.TKind, Tmp02.Route,
                           Tmp02.CostType, Tmp02.CostId, d_Main, Tmp02.TmpFlNam,
           Tmp02.Cir, -Tmp02.Cir);
       RESTORE(Tmp02);
       SAVE(Tmp02);
       Spread(d_Main, Tmp02.MyFirm, Tmp02.Mark, Tmp02.BoxNbr, Tmp02.CostType, Tmp02.CostId,
                      Tmp02.Cir);
       RESTORE(Tmp02);
      END; (* FOR_EACH Tmp02 ... *)
     END; (* IF IsMainTKind(Tmp02.TKind) ... *)
     NEXTINEXTENDEDSEL(Tmp02, Route);
    END; (* WHILE OCCURE(Tmp02) ... *)
   END; (* IF Tmp02.CostType # ct_Run ... *)
   NEXTINEXTENDEDSEL(Tmp02, CostType);
  END; (* WHILE OCCURE(Tmp02) ... *)
 END {intMainRedistribute};

 PRIVATE PROCEDURE MainRedistribute();
 BEGIN
  intMainRedistribute(d_Direct);
  intMainRedistribute(d_Real);
 END {MainRedistribute};

 PRIVATE PROCEDURE PurgeTmp();
 BEGIN
  L_AFM.AF_PurgeTemp("Tmp02");
  L_AFM.AF_PurgeTemp("_Wght");
 END {PurgeTmp};

 PRIVATE PROCEDURE NeedKeyAss(): SCAL[2];
 BEGIN
  RETURN (L_Env.KeyAssAcntLev(UpTo) # L_MathR.kaal_NoKeyAssets) &
         ~L_MathR.E_NotFullActiveKeyAssSystem(UpTo);
 END {NeedKeyAss};

 PRIVATE PROCEDURE GetMrkAndTKindKeyVal(trgMark: LIKE(Mark.Mark); trgTKind: LIKE(TKind.TKind)): tKeyVal;
 BEGIN
  RETURN trgMark*(MAXOF(trgTKind)+1) + trgTKind;
 END {GetMrkAndTKindKeyVal};

 PRIVATE PROCEDURE GetWhoSrtKeyVal(trgWho: L_Way.tRWSWho; trgSort: LIKE(Sort.Sort)): tKeyVal;
 BEGIN
  RETURN trgWho*(MAXOF(trgSort)+1) + trgSort;
 END {GetWhoSrtKeyVal};

 PRIVATE PROCEDURE IsFuelOrOilMath(trgMark: LIKE(Mark.Mark); trgMath: LIKE(Math.Math)): SCAL[2];
 BEGIN
  SETSEL(MarkFuel, Mark, trgMark, trgMath);
  FOR_EACH MarkFuel DO
   IF L_DatTim.IsActiveInIntvl_Inc(From, UpTo, MarkFuel.Begin, L_DatTim.till2ED(MarkFuel.Till)) THEN
    IF L_Fuel.IsAnyFuel(MarkFuel.InMix) | L_Fuel.IsAnyOil(MarkFuel.InMix) THEN
     RETURN 1;
    END;
   END;
  END; (* FOR_EACH MarkFuel ... *)
  RETURN 0;
 END {IsFuelOrOilMath};

 PRIVATE PROCEDURE SpreadCurStaffLikeNonProduction(trgWho: L_Way.tRWSWho;
                                                   trgCostType: tCostType;
                                                   trgCostId: tCostId;
                                                   trgSum: L_XObj.tSum);
  VAR
   curWhoSrtKeyVal: tKeyVal;
 BEGIN
  IF ~HasSBasisForSpread(Staff.MyFirm, w_StfLikeNonPSal, Staff.TSN) THEN
   curWhoSrtKeyVal:=GetWhoSrtKeyVal(trgWho, Officer.Sort);
   SETSEL(SWght, SWght, Staff.MyFirm, w_WhoSrtSalary, curWhoSrtKeyVal, 0);
   FOR_EACH SWght DO
    IF (SWght.Value # 0) & D_RWS.E_RWDst_NeedRouteForCurStaffSpread(SWght.Route, trgWho) THEN
     AddSWeight(SWght.Distr, w_StfLikeNonPSal, Staff.TSN, SWght.MyFirm, EMPTYOF(Car.BoxNbr), SWght.Mark, SWght.TKind, SWght.Route, SWght.Value);
    END;
   END; (* FOR_EACH SWght ... *)
  END; (* IF ~HasSBasisForSpread ... *)
  SpreadBySalary(Staff.MyFirm, trgCostType, trgCostId, w_StfLikeNonPSal, Staff.TSN, trgSum);
 END {SpreadCurStaffLikeNonProduction};

 PRIVATE PROCEDURE Prepare_Weight();
  VAR
   curRouteIsReal: SCAL[2];
 BEGIN
  APP.Get().NewPrompt("⮢   ।  ஡");
  SELECT(TP002, Route);
  WHILE OCCURE(TP002) DO
   PROMPT(" "+TP002.Route+",  "+TP002.BoxNbr);
   L_Way.PositionOnRouteLog(TP002.Route, UpTo);
   curRouteIsReal:=IsRealRoute(TP002.Route);
   NARROWSEL(TP002, Route);
   WHILE OCCURE(TP002) DO
    L_Car.StandOnCarLog(TP002.BoxNbr, TP002.clDate);
    NARROWSEL(TP002, BoxNbr, clDate);
    FOR_EACH TP002 DO
     IF TP002.FullRun # 0 THEN
      PutDirect(TP002.MyFirm, CarLog.Mark, TP002.BoxNbr, ct_Run, cid_Only, TP002.Route,
                TP002.FullRun, "TP002");
      AddWeight(d_Direct, w_CarRun,   TP002.BoxNbr, TP002.MyFirm, RouteLog.TKind, TP002.Route, TP002.FullRun);
      AddWeight(d_Direct, w_MrkTKRun, GetMrkAndTKindKeyVal(CarLog.Mark, RouteLog.TKind),
                                      TP002.MyFirm, RouteLog.TKind, TP002.Route, TP002.FullRun);
      AddWeight(d_Direct, w_MarkRun,  CarLog.Mark,  TP002.MyFirm, RouteLog.TKind, TP002.Route, TP002.FullRun);
      IF curRouteIsReal THEN
       AddWeight(d_Real, w_CarRun,   TP002.BoxNbr, TP002.MyFirm, RouteLog.TKind, TP002.Route, TP002.FullRun);
       AddWeight(d_Real, w_MrkTKRun, GetMrkAndTKindKeyVal(CarLog.Mark, RouteLog.TKind),
                                     TP002.MyFirm, RouteLog.TKind, TP002.Route, TP002.FullRun);
       AddWeight(d_Real, w_MarkRun, CarLog.Mark,  TP002.MyFirm, RouteLog.TKind, TP002.Route, TP002.FullRun);
       IF IsMainTKind(RouteLog.TKind) THEN
        AddWeight(d_Main, w_CarRun,   TP002.BoxNbr, TP002.MyFirm, RouteLog.TKind, TP002.Route, TP002.FullRun);
        AddWeight(d_Main, w_MrkTKRun, GetMrkAndTKindKeyVal(CarLog.Mark, RouteLog.TKind),
                                      TP002.MyFirm, RouteLog.TKind, TP002.Route, TP002.FullRun);
        AddWeight(d_Main, w_MarkRun,  CarLog.Mark, TP002.MyFirm, RouteLog.TKind, TP002.Route, TP002.FullRun);
        AddWeight(d_Main, w_AnyRun,   kv_Any, TP002.MyFirm, RouteLog.TKind, TP002.Route, TP002.FullRun);
       END; (* IF IsMainTKind( ... *)
      END; (* IF curRouteIsReal ... *)
     END; (* IF TP002.FullRun # 0 ... *)
    END; (* FOR_EACH TP002 ... *)
    NEXTINEXTENDEDSEL(TP002, BoxNbr, clDate);
   END; (* WHILE OCCURE(TP002) *)
   NEXTINEXTENDEDSEL(TP002, Route);
  END; (* WHILE OCCURE(TP002) ... *)
 END {Prepare_Weight};

 PRIVATE PROCEDURE Prepare_SWeight();
  VAR
   curDistr: tDistr;
 BEGIN
  APP.Get().NewPrompt("⮢   ।  ௫");
  SETSEL(RWM02, TSN);
  FOR_EACH RWM02 DO
   PROMPT("⭨ " + FLDTOSTR(RWM02.TSN));
   IF RWM02.Sum # 0 THEN
    IF RWM02.IsDistr = 2 THEN
     curDistr:=d_Real;
    ELSE
     curDistr:=d_Direct;
    END;
    Put(curDistr, RWM02.MyFirm, RWM02.Mark, RWM02.BoxNbr, ct_Salary, RWM02.Direct, RWM02.Route,
        RWM02.Sum, "RWM02");

    IF ~!RWM02.TSN THEN
     AddSWeight(curDistr, w_StfSalary, RWM02.TSN, RWM02.MyFirm, RWM02.BoxNbr, RWM02.Mark, GetRouteLogTKind(RWM02.Route, UpTo), RWM02.Route, RWM02.Sum);

     SEARCH(Staff, TSN, , RWM02.TSN);
     AddSWeight(curDistr, w_ManSalary, Staff.Man, RWM02.MyFirm, RWM02.BoxNbr, RWM02.Mark, GetRouteLogTKind(RWM02.Route, UpTo), RWM02.Route, RWM02.Sum);
     IF (RWM02.IsDistr = 0) & (RWM02.Direct = D_RWS.sd_Yes) & IsRealRoute(RWM02.Route) THEN
      AddSWeight(curDistr, w_WhoSrtSalary, GetWhoSrtKeyVal(RWM02.Who, RWM02.Sort), RWM02.MyFirm, RWM02.BoxNbr, RWM02.Mark, GetRouteLogTKind(RWM02.Route, UpTo), RWM02.Route, RWM02.Sum);
     END;
    END;
   END; (* IF RWM02.Sum # 0 ... *)
  END; (* FOR_EACH RWM02 ... *)
 END {Prepare_SWeight};

 PRIVATE PROCEDURE Distr_96();
  VAR
   curSum: L_XObj.tSum;
   curWho: L_Way.tRWSWho;
 BEGIN
  APP.Get().NewPrompt("। १ࢮ  ᪠");
  SETSEL(Staff, TSN);
  FOR_EACH Staff DO
   PROMPT("⭨ "+Staff.TSN);
   IF Staff.BegDate <= UpTo THEN
    L_Staff.PosToStaffLog(Staff.TSN, UpTo, 1);
    CONFORM(StaffLog, Officer);
    IF    D_RWS.NeedWho(L_Way.rwswho_Driver) THEN curWho:=L_Way.rwswho_Driver;
    ELSIF D_RWS.NeedWho(L_Way.rwswho_Guard)  THEN curWho:=L_Way.rwswho_Guard;
    ELSE                                          curWho:=EMPTYOF(L_Way.tRWSWho);
    END;
    IF ~!curWho THEN
     SELECT(XCalc, XObject, , Staff.XObject);
     WHILE OCCURE(XCalc) DO
      NARROWSEL(XCalc, AcCut);
      CONFORM(XCalc, AcCut);
      IF Str.Match(AcCut.Sign, "96*") THEN
       curSum:=0;
       SRCINSEL(XCalc, GE, , From);
       WHILE OCCURE(XCalc) &  (XCalc.XDat <= UpTo) DO
        SETSEL(XApport, XObject, XCalc.XObject, XCalc.AcCut, XCalc.XDat);
        FOR_EACH XApport DO
         CONFORM(XApport, Apport);
         IF (Apport.CirType = L_Acnt.ct_Credit) & ~L_Acnt.IsEntranceApport(XApport.Apport) THEN
          INC(curSum, XApport.Sum);
         END;
        END; (* FOR_EACH XApport ... *)
        NEXT(XCalc);
       END; (* WHILE OCCURE(XCalc) *)
       IF curSum # 0 THEN
        SpreadCurStaffLikeNonProduction(curWho, ct_Provision, AcCut.AcCut, curSum);
       END;
      END;
      NEXTINEXTENDEDSEL(XCalc, AcCut);
     END; (* WHILE OCCURE(XCalc) *)
    END; (* IF ~!curWho ... *)
   END; (* IF L_Man.GetRealBegDate ... *)
  END; (* FOR_EACH Staff ... *)
 END {Distr_96};

 PRIVATE PROCEDURE Distr_ManSFee();
  VAR
   pIdx: SCAL[L_SFee.p_Amount];
 BEGIN
  APP.Get().NewPrompt("। 客 ᮢ");
  SELECT(ManSFee, Actual, , 1);
  WHILE OCCURE(ManSFee) DO
   PROMPT(" "+ManSFee.Man);
   NARROWSEL(ManSFee, MyFirm, Man);
   IF HasSBasisForSpread(ManSFee.MyFirm, w_ManSalary, ManSFee.Man) THEN
    SRCINSEL(ManSFee, GE, , From);
    WHILE OCCURE(ManSFee) & (ManSFee.Period <= UpTo) DO
     FOR_EACH pIdx DO
      SpreadBySalary(ManSFee.MyFirm, ct_SFee, pIdx, w_ManSalary, ManSFee.Man, ManSFee.Fee[pIdx]);
     END;
     NEXT(ManSFee);
    END; (* WHILE OCCURE(ManSFee) *)
   END; (* IF HasSBasisForSpread( ... *)
   NEXTINEXTENDEDSEL(ManSFee, MyFirm, Man);
  END; (* WHILE OCCURE(ManSFee) *)
 END {Distr_ManSFee};

 PRIVATE PROCEDURE E_ApplyDstModeMthForTravmOblig(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_PRoll.ApplyDstModeMthForTravmOblig), 0);
 END {E_ApplyDstModeMthForTravmOblig};

 PRIVATE PROCEDURE TravmObligBase(P: DATE): L_PRoll.tSum;
 BEGIN
  IF E_ApplyDstModeMthForTravmOblig(P) THEN
   RETURN L_SFee_M.asSum;
  ELSE
   RETURN L_SFee_M.Sum;
  END;
 END {TravmObligBase};

 PRIVATE PROCEDURE Distr_Travm();
  VAR
   curSum             : L_PRoll.tSum;
   curTravmObligTariff: P_MyFirm.tTravmObligTariff;
 BEGIN
  APP.Get().NewPrompt("। ᮢ  ࠢ⨧");
  SELECT(L_SFee_M, MyFirm);
  WHILE OCCURE(L_SFee_M) DO
   NARROWSEL(L_SFee_M, MyFirm, Man);
   IF HasSBasisForSpread(L_SFee_M.MyFirm, w_ManSalary, L_SFee_M.Man) THEN
    PROMPT(" " + L_SFee_M.Man);
    curSum:=0;
    WHILE OCCURE(L_SFee_M) DO
     NARROWSEL(L_SFee_M, Period);
     curTravmObligTariff:=L_OTx.TravmObligTariff_InvalidCoef(L_SFee_M.MyFirm, L_SFee_M.Period, L_SFee_M.Man);
     FOR_EACH L_SFee_M DO
      SEARCH(MCList, MCode, , L_SFee_M.MCode);
      IF L_OTx.TravmOblig_MCList_Attitude(L_SFee_M.Period) THEN
       INC(curSum, curTravmObligTariff * TravmObligBase(L_SFee_M.Period) / 100);
      END;
     END; (* FOR_EACH L_SFee_M ... *)
     NEXTINEXTENDEDSEL(L_SFee_M, Period);
    END; (* WHILE OCCURE(L_SFee_M) ... *)
    IF curSum # 0 THEN
     LAST(L_SFee_M);
     SpreadBySalary(L_SFee_M.MyFirm, ct_Travm, cid_Only, w_ManSalary, L_SFee_M.Man, curSum);
    END;
   END; (* IF HasSBasisForSpread ... *)
   NEXTINEXTENDEDSEL(L_SFee_M, MyFirm, Man);
  END; (* WHILE OCCURE(L_SFee_M) ... *)
 END {Distr_Travm};

 PRIVATE PROCEDURE Distr_Math();
 BEGIN
  APP.Get().NewPrompt("। 室 ");

  L_AFM.MakeMultipleIndex("Tmp01", "MyFirm  : "+GET_TYPE_SPEC(P_Firm.tMyFirm).Name+";"+
                                   "BoxNbr  : LIKE(Car.BoxNbr);"+
                                   "Mark    : LIKE(Mark.Mark);"+
                                   "MathType: LIKE(MathType.MathType);"+
                                   "Cir     : NUMERIC[2]",
                          "Tmp01 : MyFirm, Mark, BoxNbr, MathType;"+
                          "BoxNbr: BoxNbr");

  SETSEL(MDL, BoxNbr);
  FOR_EACH MDL DO
   PROMPT(".  " + FLDTOSTR(MDL.BoxNbr));
   IF ~IsFuelOrOilMath(MDL.Mark, MDL.Math) THEN
    IF !MDL.CostItem | !L_CI.GetCarByCostItem(MDL.CostItem, MDL.clDate) THEN
     ADD(Tmp01, Tmp01, , MDL.MyFirm, MDL.Mark, MDL.BoxNbr, MDL.MathType,
         Tmp01.Cir, MDL.Sum);
    END;
   END;
  END; (* FOR_EACH MDL ... *)

  SELECT(Tmp01, BoxNbr);
  WHILE OCCURE(Tmp01) DO
   PROMPT(" "+Tmp01.BoxNbr);
   NARROWSEL(Tmp01, BoxNbr);
   FOR_EACH Tmp01 DO
    Spread(d_Direct, Tmp01.MyFirm, Tmp01.Mark, Tmp01.BoxNbr, ct_Math, Tmp01.MathType,
           Tmp01.Cir);
   END; (* FOR_EACH Tmp01 ... *)
   NEXTINEXTENDEDSEL(Tmp01, BoxNbr);
  END; (* WHILE OCCURE(Tmp01) ... *)
  L_AFM.AF_PurgeTemp("Tmp01");
 END {Distr_Math};

 PRIVATE PROCEDURE Distr_Income();
 BEGIN
  APP.Get().NewPrompt("। 室");
  SETSEL(IN001, BoxNbr);
  FOR_EACH IN001 DO
   PROMPT(" " + IN001.BoxNbr);
   IF IN001.Who # L_Way.rwswho_Dr_W_Gu THEN
    PosToMarkAndMyFirm(IN001.BoxNbr, IN001.Date);
    PutDirect(MyFirm.MyFirm, Mark.Mark, IN001.BoxNbr, ct_Income, cid_Only, IN001.Route,
              IN001.IncFct, "IN001");
   END;
  END; (* FOR_EACH IN001 ... *)
 END {Distr_Income};

 PRIVATE PROCEDURE Distr_KeyAss();
  VAR
   BAcCuts: L_MathR.tMathAcCutCollection;
 BEGIN
  IF NeedKeyAss() THEN
   APP.Get().NewPrompt("। ⨧樨 ");
   E_Stock.GetKeyAssWearAcCuts(UpTo, BAcCuts, L_MathR.KA_BalDepr, L_MathR.KA_All, L_MathR.KA_All);
   SETSEL(Car, BoxNbr);
   FOR_EACH Car DO
    PROMPT(" "+Car.BoxNbr);
    IF Car.BegDate <= UpTo THEN
     L_Car.StandOnCarLog(Car.BoxNbr, UpTo);
     IF ~!CarLog.Math THEN
      OutKeyAssAcCuts(BAcCuts);
     END;
    END;
   END; (* FOR_EACH Car ... *)
  END;
 END {Distr_KeyAss};

 PRIVATE PROCEDURE Distr_Fuel();
  VAR
   FuelPrice: FLOAT;
 BEGIN
  APP.Get().NewPrompt("। 室 ⮯");
  SELECT(FL1_1, BoxNbr);
  WHILE OCCURE(FL1_1) DO
   NARROWSEL(FL1_1, BoxNbr, clDate);
   PosToMarkAndMyFirm(FL1_1.BoxNbr, FL1_1.clDate);
   WHILE OCCURE(FL1_1) DO
    PROMPT(" "+FL1_1.BoxNbr+",  "+FL1_1.Math);
    FuelPrice:=L_MathR.GetANYMathPrice(UpTo, FL1_1.Math, MyFirm.MyFirm, 01(*!!!*));
    NARROWSEL(FL1_1, Math);
    FOR_EACH FL1_1 DO
     PutDirect(MyFirm.MyFirm, Mark.Mark, FL1_1.BoxNbr, ct_FO, cid_FO_Fuel, FL1_1.Route,
               FL1_1.FFact * FuelPrice, "FL1_1");
    END; (* FOR_EACH FL1_1 ... *)
    NEXTINEXTENDEDSEL(FL1_1, Math);
    END; (* WHILE OCCURE(FL1_1) ... *)
   NEXTINEXTENDEDSEL(FL1_1, BoxNbr, clDate);
  END; (* WHILE OCCURE(FL1_1) ... *)
 END {Distr_Fuel};

 PRIVATE PROCEDURE Distr_Oil();
  VAR
   FuelPrice: FLOAT;
 BEGIN
  APP.Get().NewPrompt("। 室 ᬠ ਠ");
  SELECT(OIL01, BoxNbr);
  WHILE OCCURE(OIL01) DO
   NARROWSEL(OIL01, BoxNbr, clDate);
   PosToMarkAndMyFirm(OIL01.BoxNbr, OIL01.clDate);
   WHILE OCCURE(OIL01) DO
    PROMPT(" "+OIL01.BoxNbr+",  "+OIL01.Math);
    FuelPrice:=L_MathR.GetANYMathPrice(UpTo, OIL01.Math, MyFirm.MyFirm, 01(*!!!*));
    NARROWSEL(OIL01, Math);
    FOR_EACH OIL01 DO
     PutDirect(MyFirm.MyFirm, Mark.Mark, OIL01.BoxNbr, ct_FO, cid_FO_Oil, OIL01.Route,
               OIL01.MFact*FuelPrice, "OIL01");
    END; (* FOR_EACH OIL01 ... *)
    NEXTINEXTENDEDSEL(OIL01, Math);
   END; (* WHILE OCCURE(OIL01) ... *)
   NEXTINEXTENDEDSEL(OIL01, BoxNbr, clDate);
  END; (* WHILE OCCURE(OIL01) ... *)
 END {Distr_Oil};

 PRIVATE PROCEDURE Distr_CostItem();
 BEGIN
  APP.Get().NewPrompt("। ⥩ 室");
  SETSEL(CIKind, Type, L_CI.cikt_Car);
  FOR_EACH CIKind DO
   SETSEL(CostItem, CIKind, CIKind.CIKind);
   FOR_EACH CostItem DO
    IF ~CostItem.Leaf & L_DatTim.IsActiveInIntvl_Inc(From, UpTo, CostItem.Begin, CostItem.Till) THEN
     OutCostItem(CostItem.CostItem);
    END;
   END; (* FOR_EACH CostItem ... *)
  END; (* FOR_EACH CIKind ... *)
 END {Distr_CostItem};

 PRIVATE PROCEDURE Car05_PRF();
  VAR
   trgOM    : L_XObj.tOriginsMap;
   trgMyFirm: P_Firm.tMyFirm;
 BEGIN
  D_TP.PrepareTP002(); (* ஡*)
  D_RWS.PrepareRWM02(0);
  D_RWS.Prepare_IN001(1);
  D_Fl.Prepare_FL1();
  D_Fl.Prepare_OIL01();
  D_Stock.PrepareMDL();
 END {Car05_PRF};

 PRIVATE PROCEDURE MakeRep();
 BEGIN
  MakeHeader();

  L_AFM.rf_PrepareAll(PROCREF(Car05_PRF), L_General.tc_inMonth);

  L_SFee.PrepareForDistribution(From, L_DatTim.MonthBeg(UpTo));

  CreateTmp();

  Prepare_SWeight();

  Distr_96();
  Distr_ManSFee();
  Distr_Travm();

  Prepare_Weight();

  Distr_Math();
  Distr_Income();
  Distr_KeyAss();
  Distr_Fuel();
  Distr_Oil();
  Distr_CostItem();

  RealRedistribute();
  MainRedistribute();
  Print();

  D_TP.PurgeTP002();
  D_RWS.PurgeRWM02();
  L_AFM.AF_PurgeTemp("MDL");
  D_RWS.Purge_IN001();
  D_Fl.Purge_OIL01();
  D_Fl.Purge_FL1();
  PurgeTmp();
 END {MakeRep};

 PUBLIC PROCEDURE Car05();
  CONST
   bpId = "Car05";
  VAR
   sav_fr,
   sav_ut: DATE;
 BEGIN
  sav_fr:=Memo.ud_fr();
  sav_ut:=Memo.ud_ut();
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   L_General.SetCacheables(["CarLog", "CarPro", "OfcDst", "RoutePro", "SortPro", "Staff", "StaffLog"]);
   L_bp.Begin(bpId, "室  室  ⠬", L_bp.t_Basis, L_General.tc_inMonth);
   Memo.UIP_SetIntvl(Memo.ud_mb(), Memo.ud_me());
   From:=Memo.ud_fr();
   UpTo:=Memo.ud_ut();
   wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  
   FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
   MakeRep();
   FIO.Close(R);
   L_bp.End();
  EXCEPT
  FINALLY
   Memo.UIP_SetIntvl(sav_fr, sav_ut);
  END;
 END {Car05};

END.
