(*
%Copyright   (c) Polak Computer System
%Author      16.05.1998 20:36:09 SAN
%Purpose       ⮢ ᮢ 
%Type        report
%Specific    SYS
%Modified    24.09.2014 16:14:05 LDA
%Environment
*)

 MODULE CashBook [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Str, L_Money, L_DatTim, L_XObj, L_PDoc, L_Acnt, P_Firm, Str, Memo, E_PDoc,
        L_StdFrm, P_Man;

 PRIVATE TYPE
  tMode = SCAL[2];

 PRIVATE CONST
  LinesInPage = 30;
  AbLen       = 85;
  m_CurDay    = 0;
  m_Period    = 1;

 PRIVATE VAR
  CBName,
  CRName       : STRING[];
  _InSaldo,
  _OutSaldo    : NUMERIC[2];
  FirstPage,
  PagesInYear,
  PagesInMonth,
  PagesInDate  : NUMERIC[0];
  IsLast       : SCAL[2];
  _Cir         : NUMERIC[2][2];
  _Amn         : NUMERIC[0][2];
  CurLine      : NUMERIC[0];
  _About       : STRING[AbLen][10];
  _Date        : DATE;

  curFirmAcnt  : LIKE(FirmAcnt.FirmAcnt);
  curMoneyKind : L_PDoc.tMoneyKind;

(*
$P{ TopMost:
?, L, ""
?, L, ""
L_APtm.GetTheDocCause(PDoc.Date, "⢥ত ⠭ ᪮ ᨨ  18.08.98 N 88"), R, ""
P_Firm.MyFirmName(P_Firm.curMyFirm, _Date), L, ""
P_Firm.FP_OKPO(P_Firm.fomf(P_Firm.curMyFirm), _Date), L, ""
?, C, ""
@
#########################################################################################
#########################################################################################           ஢ ଠ N -4
################################################################################################################################
                                                                                                                      ----------
                                                                                                        ଠ   | 0310004|
#############################################################################################################   |########|
_________________________________________________________________                                                     |        |
                    ୮ ࠧ                                                                         ----------



















################################################################################################################################

}
*)

(*
$P{ BotMost:
PagesInYear, R, "0"
P_Firm.FP_LeadPostName1(P_Firm.fomf(P_Firm.curMyFirm), _Date), L, ""
P_Firm.FP_LeadName(P_Firm.fomf(P_Firm.curMyFirm), _Date), R, ""
P_Firm.FP_AcntName(P_Firm.fomf(P_Firm.curMyFirm), _Date), R, ""
@










































                                                                           ⮩  ஭㬥஢  ஢ #### ⮢.


                                                                         .. (⠬)


         㪮⥫ ࣠樨 ###################################### ___________________ ###################################
                                                                                                   ஢ 
                                                              
          壠                                               ___________________ ###################################
                                                                                                   ஢ 

                                                                                       "_______"_____________________ _______ .
}
*)

(*
$P{ Top:
?, R, ""
?, C, ""
?, L, ""
?, R, ""
@
                                                                                                                      N ####
################################################################################################################################
--------------------------------------------------------------------------------------------------------------------------------
|            |                                                                                 ||            |            |
|       |  祭   뤠                                                 |.|     室,|     室,|
|   㬥|                                                                                 ||    ..|    ..|
|            |                                                                                 ||            |            |
|------------|---------------------------------------------------------------------------------|-----|------------|------------|
|            |#################################################################################|     |############|      x     |
|============|=================================================================================|=====|============|============|
}
*)

(*
$P{ Line:
L_PDoc.PDocKindNick(PDoc.PDocKind, 1), L, ""
PDoc.SrcNbr, L, ""
_About[0], L, ""
L_PDoc.GetCorAcnt(PDoc.PDocKind, PDoc.PDoc), L, ""
?, R, ""
?, R, ""
@
|### ########|#################################################################################|#####|############|############|
}
*)

(*
$P{ Line1:
?, L, ""
@
|            |#################################################################################|     |            |            |
}
*)

(*
$P{ EndOfPage:
_MoneyToStr(_OutSaldo), L, ""
?, R, ""
?, R, ""
@
|============|=================================================================================|=====|============|============|
|            |७  ᫥ ࠭                                                    |     |############|#      #####|
--------------------------------------------------------------------------------------------------------------------------------
}
*)

(*
$P{ EndOfDay:
_MoneyToStr(_Cir[1]), R, ""
_MoneyToStr(_Cir[0]), R, ""
_MoneyToStr(_OutSaldo), R, ""
?, R, ""
?, L, ""
GetCashierName(), R, ""
@
|============|=================================================================================|=====|============|============|
|            |⮣                                                                      |     |############|############|
|------------|---------------------------------------------------------------------------------|-----|------------|------------|
|            |⮪                                                                |     |############|      x     |
|------------|---------------------------------------------------------------------------------|-----|------------|------------|
|            | ⮬ ᫥  ࠡ , 믫 樠쭮 ࠪ  ⨯       |     |############|      x     |
--------------------------------------------------------------------------------------------------------------------------------
################################################################################################################################

                                                                    __________________ ###################################
                                                                                                   ஢ 
}
*)

(*
$P{ CBBot:
Str.NumByWord(_Amn[1]), L, ""
Str.NumByWord(_Amn[0]), L, ""
P_Firm.FP_AcntCashName(P_Firm.fomf(P_Firm.curMyFirm), _Date), R, ""
@
  ᮢ  ஢ਫ  稫 㬥  ⢥:
室 - #########################################################
室 - #########################################################

                                                               壠  __________________ ###################################
                                                                                                   ஢ 
--------------------------------------------------------------------------------------------------------------------------------
}
*)

 PRIVATE PROCEDURE GetCashierName(): STRING[];
 BEGIN
  IF curFirmAcnt = L_PDoc.fa_CashOffice THEN
   RETURN P_Firm.FP_CashName(P_Firm.fomf(P_Firm.curMyFirm), _Date);
  ELSE
   RETURN P_Man.GetFullNameOfCurrentUser(SYSDATE());
  END;
 END {GetCashierName};

 PRIVATE PROCEDURE extIsAcceptablePDoc(wCheck, wCanceled: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF (PDoc.MyFirm = P_Firm.curMyFirm) &
     (L_PDoc.MoneyKind(PDoc.PDocKind) = curMoneyKind) & ((curMoneyKind = L_PDoc.mk_Cash) | (PDoc.OwnAcnt = curFirmAcnt)) &
     ((PDoc.Status # L_PDoc.st_Canceled) | wCanceled) THEN
   IF wCheck THEN
    L_PDoc.CheckTaxed();
    L_PDoc.CheckDone();
   END;
   Result:=1;
  END;
  RETURN Result;
 END {extIsAcceptablePDoc};

 PRIVATE PROCEDURE IsAcceptablePDoc(): SCAL[2];
 BEGIN
  RETURN extIsAcceptablePDoc(1, 0);
 END {IsAcceptablePDoc};

 PRIVATE PROCEDURE SetInSaldo(_Date: DATE);
 BEGIN
  APP.Get().NewPrompt("祭 室饣 ᠫ줮");
  IF curMoneyKind = L_PDoc.mk_Cash THEN
   _InSaldo:=L_XObj.mo_GetOutSaldo(L_kn.Get(_Date, L_AcCut.erkn_CentralCashOffice), L_DatTim.IncMonth(L_DatTim.Per(_Date), -1));
  ELSE
   _InSaldo:=L_XObj.mo_GetOutSaldo(L_kn.Get(_Date, L_AcCut.erkn_OperationalCashOffices), L_DatTim.IncMonth(L_DatTim.Per(_Date), -1));
  END;
  SAVE(PDoc);
  SELECT(PDoc, Date);
  SRCINSEL(PDoc, GE, , L_DatTim.Per(_Date));
  WHILE OCCURE(PDoc) & (PDoc.Date < _Date) DO
   PROMPT(L_DatTim.DateStr(_Date) + " " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   IF ~L_PDoc.IsUnClosedSalPDoc(PDoc.mfNbr) THEN
    IF IsAcceptablePDoc() THEN
     IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
      DEC(_InSaldo, PDoc.Total);
     ELSE
      INC(_InSaldo, PDoc.Total);
     END;
    END;
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc)... *)
  RESTORE(PDoc);
  L_General.Assert(_InSaldo>=0, "⥫쭮 ᠫ줮  砫  " + _MoneyToStr(_InSaldo));
 END {SetInSaldo};

 PRIVATE PROCEDURE E_CashBookPagesShift(CurDate: DATE; VAR StartP: DATE; VAR PagesShift: NUMERIC[0]);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PDoc.CashBookPagesShift);
  IF ~!Local THEN
   Local(CurDate, StartP, PagesShift);
   IF L_DatTim.YEAR(StartP) = L_DatTim.YEAR(CurDate) THEN
    RETURN;
   END;
  END;
  StartP:=L_DatTim.YearBeg(CurDate);
  PagesShift:=0;
 END {E_CashBookPagesShift};

 PRIVATE PROCEDURE SetFirstPage(_Date: DATE);
  VAR
   _Queue    : LIKE(PDoc.Queue);
   StartP    : DATE;
   PagesShift: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("祭  ࠭");
  FirstPage:=1;
  PagesInMonth:=0;
  E_CashBookPagesShift(_Date, StartP, PagesShift);
  SAVE(PDoc);
  SELECT(PDoc, Date);
  SRCINSEL(PDoc, GE, , StartP);
  WHILE OCCURE(PDoc) & (PDoc.Date < _Date) DO
   PROMPT(L_DatTim.DateStr(_Date) + " " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   CHANGESEL(PDoc, Date, , PDoc.Date);
   WHILE OCCURE(PDoc) & ~IsAcceptablePDoc() DO
    NEXT(PDoc);
   END;
   IF OCCURE(PDoc) THEN
    L_General.Assert(~!PDoc.Queue, "室 ᫥⥫쭮 ⮢ ⮢."+
                                   "|  " + L_DatTim.DateStr(PDoc.Date));
    IF PDoc.Date >= L_PDoc.PDoc_ClcPer() THEN
     SAVE(PDoc);
     _Queue:=PDoc.Queue;
     WHILE OCCURE(PDoc) DO
      L_General.Assert(~IsAcceptablePDoc() | (PDoc.Queue = _Queue),
                       "室 ᫥⥫쭮 ⮢ ⮢."+
                       "|  " + L_DatTim.DateStr(PDoc.Date));
      NEXT(PDoc);
     END; (* WHILE OCCURE(PDoc) ... *)
     RESTORE(PDoc);
    END; (* IF PDoc.Date >= ... *)
    INC(FirstPage, PDoc.Queue);
    IF L_DatTim.Per(PDoc.Date) = L_DatTim.Per(_Date) THEN
     INC(PagesInMonth, PDoc.Queue);
    END;
   END;
   LAST(PDoc);
   CHANGESEL(PDoc, Date);
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc)... *)
  INC(FirstPage, PagesShift);
  RESTORE(PDoc);
 END {SetFirstPage};

 PRIVATE PROCEDURE GetSumOfPagesStr(_Date: DATE): STRING[];
  VAR
   CheckDate,
   StartD,
   StartC: DATE;
   dummy : NUMERIC[0];
 BEGIN
  SELECT(PDoc, Date);
  SRCINSEL(PDoc, GT, , _Date);
  WHILE OCCURE(PDoc) & ~extIsAcceptablePDoc(0, 0) DO
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc)... *)
  IF ~OCCURE(PDoc) THEN
   CheckDate:=SYSDATE();
  ELSE
   CheckDate:=L_DatTim.Per(PDoc.Date);
  END;
  IsLast:=L_DatTim.Per(CheckDate) > L_DatTim.Per(_Date);
  IF IsLast THEN
   E_CashBookPagesShift(_Date,     StartD, dummy);
   E_CashBookPagesShift(CheckDate, StartC, dummy);

   IF StartD # StartC THEN
    PagesInYear:=FirstPage+(PagesInDate-1);
    RETURN " " + FLDTOSTR(_Date, "y", 4) + "  - " +
           Str.NumByWord(PagesInYear             , MASCULINE, "⮢");
   ELSE
    RETURN " " + L_DatTim.MonthStr(_Date, 0) + " - " +
           Str.NumByWord(PagesInMonth+PagesInDate, MASCULINE, "⮢");
   END;
  ELSE
   RETURN " ";
  END;
 END {GetSumOfPagesStr};

 PRIVATE PROCEDURE _MoneyToStr(M: NUMERIC[2]): STRING[100];
 BEGIN
  RETURN L_Money.MoneyToStr(_Date, "", M);
 END {_MoneyToStr};

 PRIVATE PROCEDURE SetCurOutSaldo();
 BEGIN
  _OutSaldo:=_InSaldo+_Cir[1]-_Cir[0];
  L_General.Assert(_OutSaldo>=0, "⥫쭮 ᠫ줮" + _MoneyToStr(_OutSaldo));
 END {SetCurOutSaldo};

 PRIVATE PROCEDURE AddOprDsk(S: STRING[]): STRING[];
  VAR
   p: NUMERIC[0];
 BEGIN
  p:=Str.Pos(S, "@");
  L_General.CallUs(p < Str.Length(S));
  S:=Str.Delete(S, p, 1);
  IF curFirmAcnt # L_PDoc.fa_CashOffice THEN
   SAVE(FirmAcnt);
   SEARCH(FirmAcnt, FirmAcnt, , P_Firm.fomf(P_Firm.curMyFirm), curFirmAcnt);
   S:=Str.Insert(S, " (: " + FirmAcnt.FirmAcnt + " " + FirmAcnt.Name + ")", p);
   RESTORE(FirmAcnt);
  END;
  RETURN S;
 END {AddOprDsk};

 PRIVATE PROCEDURE TypeTopMost(_Date: DATE);
  CONST
   dcm_Len = 89;
  VAR
   DocDraftsman: STRING[dcm_Len][2];
 BEGIN
  L_Str.FormatStr(DocDraftsman, L_APtm.GetTheDocDraftsman(PDoc.Date, ""), dcm_Len);
  MAKEPART(R, TopMost, DocDraftsman[0], DocDraftsman[1], AddOprDsk("ᮢ @  " + FLDTOSTR(_Date, "y", 4) + " ."));
  FORMFEED(R);
 END {TypeTopMost};

 PRIVATE PROCEDURE TypeBotMost(_Date: DATE);
 BEGIN
  MAKEPART(R, BotMost);
  FORMFEED(R);
 END {TypeBotMost};

 PRIVATE PROCEDURE GetAbout();
  VAR
   S: STRING[];
 BEGIN
  S:=L_Str.AddStrDlm(L_PDoc.GetPDocCommentPart(0),  "; ") + L_PDoc.GetPDocCommentPart(1);
  IF ~P_Firm.IsOwnFirm(PDoc.Firm) THEN
   CONFORM(PDoc, Firm);
   S:=S + "; " + P_Firm.FP_ContractorBriefName(Firm.Firm, PDoc.PrpDate);
  END;
  Str.Format(_About, S, AbLen, LEFT);
 END {GetAbout};

 PRIVATE PROCEDURE MakeNextLine();
  VAR
   DocTotStr : STRING[30][2];
   i         : NUMERIC[0];
   _CirType  : LIKE(Apport.CirType);
 BEGIN
  IF CurLine = 0 THEN
   IF PagesInDate = 0 THEN
    L_XObj.AccessXObject(L_PDoc.GetGlobalXObject(P_Firm.curMyFirm, curFirmAcnt));
    SetInSaldo(_Date);
    SetFirstPage(_Date);
    IF FirstPage = 1 THEN
     TypeTopMost(_Date);
    END;
    MAKEPART(R, Top, FirstPage,
             AddOprDsk("  ᮢ @  " + L_DatTim.DateStr(_Date)),
             "⮪  砫 ", _MoneyToStr(_InSaldo));
    MAKEPART(Q, Top, FirstPage,
             AddOprDsk("   @  " + L_DatTim.DateStr(_Date)),
             "⮪  砫 ", _MoneyToStr(_InSaldo));
   ELSE
    SetCurOutSaldo();
    MAKEPART(R, EndOfPage);
    MAKEPART(Q, EndOfPage);
    FORMFEED(R);
    FORMFEED(Q);
    MAKEPART(R, Top, FirstPage + PagesInDate,
             AddOprDsk("  ᮢ @  " + L_DatTim.DateStr(_Date)),
             "७  ।饩 ࠭", _MoneyToStr(_OutSaldo));
    MAKEPART(Q, Top, FirstPage + PagesInDate,
             AddOprDsk("   @  " + L_DatTim.DateStr(_Date)),
             "७  ।饩 ࠭", _MoneyToStr(_OutSaldo));
   END;
   INC(PagesInDate);
  END;
  IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
   _CirType:=L_Acnt.ct_Credit;
  ELSE
   _CirType:=L_Acnt.ct_Debit;
  END;
  INC(_Cir[_CirType], PDoc.Total);
  INC(_Amn[_CirType]            );
  SETEMPTY(DocTotStr);
  DocTotStr[_CirType]:=_MoneyToStr(PDoc.Total);
  GetAbout();
  MAKEPART(R, Line,
           DocTotStr[1],
           DocTotStr[0]);
  MAKEPART(Q, Line,
           DocTotStr[1],
           DocTotStr[0]);
  CurLine:=(CurLine + 1) MOD LinesInPage;
  i:=1;
  WHILE ~!_About[i] DO
   MAKEPART(R, Line1, _About[i]);
   MAKEPART(Q, Line1, _About[i]);
   CurLine:=(CurLine + 1) MOD LinesInPage;
   INC(i);
  END;
 END {MakeNextLine};

 PRIVATE PROCEDURE GetSumForSalary(): NUMERIC[2];
  VAR
   S: NUMERIC[2];
 BEGIN S:=0;
  APP.Get().NewPrompt(" ' ⮬ ᫥  ௫'");
  SELECT(PDoc, mfNbr, , L_PDoc.pd_RKO, P_Firm.curMyFirm);
  SRCINSEL(PDoc, GE, , L_PDoc.UnClosedSalPDoc_MinNum());
  WHILE OCCURE(PDoc) & L_PDoc.IsUnClosedSalPDoc(PDoc.mfNbr) DO
   PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   IF (PDoc.PrpDate<=_Date) & extIsAcceptablePDoc(0, 0) THEN
    SELECT(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc);
    WHILE OCCURE(PDocList) DO
     INC(S, PDocList.Sum);
     NEXT(PDocList);
    END; (* WHILE OCCURE(PDocList) ... *)
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc)... *)

  SELECT(PDoc, PDKDate, , L_PDoc.pd_RKO);
  SRCINSEL(PDoc, GT, , _Date);
  WHILE OCCURE(PDoc) DO
   PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   IF ~L_PDoc.IsUnClosedSalPDoc(PDoc.mfNbr) &
      (PDoc.PrpDate<=_Date) & extIsAcceptablePDoc(0, 0) THEN
    SELECT(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc);
    WHILE OCCURE(PDocList) DO
     INC(S, PDocList.Sum);
     NEXT(PDocList);
    END; (* WHILE OCCURE(PDocList) ... *)
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc)... *)
  RETURN S;
 END {GetSumForSalary};

 PRIVATE PROCEDURE PassOnePDocKind(_PDocKind: LIKE(PDoc.PDocKind));
 BEGIN
  APP.Get().NewPrompt(" ");
  SELECT(PDoc, PDKDate, , _PDocKind, _Date);
  WHILE OCCURE(PDoc) DO
   PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   IF ~L_PDoc.IsUnClosedSalPDoc(PDoc.mfNbr) THEN
    IF IsAcceptablePDoc() THEN
     MakeNextLine();
    END;
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc)... *)
 END {PassOnePDocKind};

 PRIVATE PROCEDURE StorePagesInDate();
 BEGIN
  SELECT(PDoc, Date, , _Date);
  WHILE OCCURE(PDoc) DO
   IF extIsAcceptablePDoc(1, 1) THEN
    PDoc.Queue   :=PagesInDate;
    PDoc.PmntKind:=IsLast;
    REPLACE(PDoc);
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc)... *)
 END {StorePagesInDate};

 PRIVATE PROCEDURE CheckPrv();
 BEGIN
  SELECT(PDoc, Date);
  SRCINSEL(PDoc, LE, , _Date-1);
  WHILE OCCURE(PDoc) DO
   IF IsAcceptablePDoc() THEN
    IF L_DatTim.Per(PDoc.Date) # L_DatTim.Per(_Date) THEN
     IF PDoc.PmntKind = 0 THEN
      L_StdFrm.Confirm("  " + L_DatTim.DateStr(PDoc.Date) + "   ⯥⠭  ᫥  ");
     END;
    ELSE
     IF PDoc.PmntKind = 1 THEN
      L_StdFrm.Confirm("  " + L_DatTim.DateStr(PDoc.Date) + "  ୮ ⯥⠭  ᫥  ");
     END;
    END;
    RETURN;
   END;
   PREV(PDoc);
  END; (* WHILE OCCURE(PDoc) ... *)
 END {CheckPrv};

 PRIVATE PROCEDURE MakePDocKind(IsOutPDocKind: SCAL[2]);
 BEGIN
  SELECT(PDocKind, PDocKind);
  WHILE OCCURE(PDocKind) DO
   IF (L_PDoc.MoneyKind(PDocKind.PDocKind) = curMoneyKind) &
      (L_PDoc.IsOutPDoc(PDocKind.PDocKind) = IsOutPDocKind) THEN
    SAVE(PDocKind);
    PassOnePDocKind(PDocKind.PDocKind);
    RESTORE(PDocKind);
   END;
   NEXT(PDocKind);
  END; (* WHILE OCCURE(PDocKind) ... *)
 END {MakePDocKind};

 PRIVATE PROCEDURE MakeOneDay();
  VAR
   SfS   : NUMERIC[2];
   SofPS : STRING[];
 BEGIN
  SETZERO(_Cir, _Amn, PagesInDate, CurLine);
  MakePDocKind(0);
  MakePDocKind(1);
  IF PagesInDate > 0 THEN
   CheckPrv();
   SetCurOutSaldo();
   SfS  :=GetSumForSalary();
   SofPS:=GetSumOfPagesStr(_Date);
   StorePagesInDate();
   MAKEPART(R, EndOfDay, _MoneyToStr(SfS), SofPS);
   MAKEPART(Q, EndOfDay, _MoneyToStr(SfS), SofPS);
   MAKEPART(R, CBBot);
   MAKEPART(Q, CBBot);
   FORMFEED(R);
   FORMFEED(Q);
   IF ~!PagesInYear THEN
    TypeBotMost(_Date);
   END;
  ELSE
   IsLast:=0;
   StorePagesInDate();
  END;
 END {MakeOneDay};

 PRIVATE PROCEDURE CashBook(Mode: tMode);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
 
  IF L_PDoc.dodAssigned THEN
   P_Firm.curMyFirm:=L_PDoc.dodMyFirm;
   curFirmAcnt     :=L_PDoc.dodFirmAcnt;
   curMoneyKind    :=L_PDoc.mk_OprDskCash;
  ELSE
   IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
    P_Firm.curMyFirm:=P_Firm.ChoiceMyFirm();
   ELSE
    P_Firm.curMyFirm:=P_Firm.mf_Own;
   END;
   curFirmAcnt     :=L_PDoc.fa_CashOffice;
   curMoneyKind    :=L_PDoc.mk_Cash;
  END;
 
  IF curFirmAcnt = L_PDoc.fa_CashOffice THEN
   CBName:=L_General.NameConnection("CshBk");
   CRName:=L_General.NameConnection("CshRp");
  ELSE
   CBName:=L_General.NameConnection("CBk"+curFirmAcnt);
   CRName:=L_General.NameConnection("CRp"+curFirmAcnt);
  END;
 
  OPENREP(R, CBName, Create, MinCharsPerLine, 114,
                             SpreadChrInLine, 128);
  OPENREP(Q, CRName, Create, MinCharsPerLine, 114,
                             SpreadChrInLine, 128);
 
  SETEMPTY(PagesInYear);
 
  IF    Mode = m_CurDay THEN
   L_StdFrm.Question(AddOprDsk(" @  " + L_DatTim.DateStr(Memo.ud_cd())));
   _Date:=Memo.ud_cd();
   MakeOneDay();
  ELSIF Mode = m_Period THEN
   L_StdFrm.Question(AddOprDsk(" @") + "| ਮ  " +
                               L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut()));
   _Date:=Memo.ud_fr();
   WHILE _Date <= Memo.ud_ut() DO
    MakeOneDay();
    INC(_Date);
   END;
  ELSE
   L_General.CallUs(0);
  END;
 
  CLOSEREP(R);
  CLOSEREP(Q);
 
  LIKEMENU(Survey, CBName, Survey, CRName);
 END {CashBook};

 PUBLIC PROCEDURE CBook_ByCurDay();
 BEGIN
  CashBook(m_CurDay);
 END {CBook_ByCurDay};

 PUBLIC PROCEDURE CBook_ByPeriod();
 BEGIN
  CashBook(m_Period);
 END {CBook_ByPeriod};

END.
