(*
%Copyright   (c) Polak IT
%Author      09.10.2008 14:52:56 POLAK\GAV
%Purpose     ⨢ 祭
%Type        control
%Specific    SYS
%Modified    05.06.2014 19:24:10 ?
%Environment
*)

 MODULE ccCnct [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_AR, Str, L_Str, L_WDO, L_AFM, L_DatTim,
        FIO, L_StdFrm, L_NetWrk, L_NTF, L_AcsPnt, L_Guard, L_SysLog;

 PRIVATE CONST
  OutAPEPState_Prohibit = "室 짮⥫ ";
  OutAPEPState_Permit   = "室 짮⥫ ࠧ襭";

  ntfName_ProhibitStart = "OutAPEP";
  ntfName_GetOutSoft    = "OutAP1";
  ntfName_GetOutStrong  = "OutAP2";

 PRIVATE PROCEDURE SetOutAPState();
  VAR
   fields         : FORM_FIELDS;
   StartProhibited: SCAL[2];
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = "ccCnct" THEN
   StartProhibited:=FIO.Exists(L_NTF.GetFullNTFName(ntfName_ProhibitStart));
   fields:=RTI.Get().CurWindow.Zones(0).Fields;
   IF FIO.Exists(L_NTF.GetFullNTFName(ntfName_GetOutSoft)) THEN
    fields("v_OutAP1").Visible:=1;
    StartProhibited:=1;
   ELSE
    fields("v_OutAP1").Visible:=0;
   END;
   IF FIO.Exists(L_NTF.GetFullNTFName(ntfName_GetOutStrong)) THEN
    fields("v_OutAP2").Visible:=1;
    StartProhibited:=1;
   ELSE
    fields("v_OutAP2").Visible:=0;
   END;
   IF StartProhibited THEN
    fields("v_OutAPEP").Value:=OutAPEPState_Prohibit;
   ELSE
    fields("v_OutAPEP").Value:=OutAPEPState_Permit;
   END;
  END;
 END {SetOutAPState};

 PRIVATE PROCEDURE ccCnct_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().OnOpenWindow:=1;
  L_WDO.iField       (0, "v_AdminGroupName").Value:=L_General.AdminGroupName();
  L_WDO.iField       (0, "v_OutAP1").Visible:=0;
  L_WDO.iField       (0, "v_OutAP1").Value:="  ";
  L_WDO.iField       (0, "v_OutAP2").Visible:=0;
  L_WDO.iField       (0, "v_OutAP2").Value:=" ";
  L_WDO.iField       (0, "ccCnct.TrnsDesc").LineBreakEnable:=1;
  L_WDO.iZone        (1).Narrowing:="ccCnct.curCnct=L_WDO.v_dbConnection";
  L_WDO.iField       (1, "ccCnct.Type").Format    :="???|???|   |||||???|???|???|";
  L_WDO.iField       (1, "ccCnct.HasATrns").Format:=" |!";
  L_WDO.iSubwindow   (1, "aoUserE");
 END {ccCnct_OnInitializeWindow};

 PRIVATE PROCEDURE ccCnct_OnOpenWindow();
 BEGIN
  IF !RTI.Get().CurWindow.ParentZone THEN
   Refresh(0);
  ELSE
   SetOutAPState();
  END;
 END {ccCnct_OnOpenWindow};

 PRIVATE PROCEDURE checkASBC_All(c: ASBCONNECTION): SCAL[2];
 BEGIN
  RETURN 1;
 END {checkASBC_All};

 PRIVATE VAR
  curGroupAcsObj: LIKE(AcsObj.AcsObj);

 PRIVATE PROCEDURE checkASBC_curGroup(c: ASBCONNECTION): SCAL[2];
 BEGIN
  RETURN SEARCH(AcsObj, TNAME, L_AR.aot_User, Str.Cap(c.LoginName)) &
         SEARCH(AOMem, AcsObj, curGroupAcsObj, AcsObj.AcsObj);
 END {checkASBC_curGroup};

 PRIVATE PROCEDURE CreateTransactionsList();
  VAR
   oTRN: TRANSACTION;
 BEGIN
  L_AFM.MakeMultipleIndex("ActTrnLst", "ConNo: NUMERIC[0];" +
                                       "Descr: STRING[1024]",
                          "ConNo: ConNo");
  FOR_EACH oTRN IN TRANSACTIONS.Get() DO
   PROMPT("⮢ ᯨ᪠ ࠭権 " + L_DatTim.TimestampStr(oTRN.CreateDTS));
   IF ~!oTRN.Description THEN
    IF SEARCH(ActTrnLst, ConNo, oTRN.Connection.Number) THEN
     IF ~L_Str.IsStrInStr(ActTrnLst.Descr, oTRN.Description) THEN
      ActTrnLst.Descr:=L_Str.AddStrDlm(ActTrnLst.Descr, "; ") + oTRN.Description;
      REPLACE(ActTrnLst);
     END;
    ELSE
     ActTrnLst.ConNo:=oTRN.Connection.Number;
     ActTrnLst.Descr:=oTRN.Description;
     INSERT(ActTrnLst);
    END;
   END; (* IF ~!oTRN.Description *)
  END;
 END {CreateTransactionsList};

 PRIVATE PROCEDURE intRefresh(wGroups: SCAL[2]; checkASBCProc: PROC);
  CONST
   GuardNameInRussian = "'⥫ ⮏'";
  VAR
   ins,
   found      : SCAL[2];
   oConn      : ASBCONNECTION;
   curAcsObj  : LIKE(AcsObj.AcsObj);
   oTokenGroup: TOKENGROUP;
   grpName,
   CnctNoLst,
   trgSign,
   trgTrnsDesc: STRING[];
   trgHasATrns: LIKE(ccCnct.HasATrns);
   curIP      : LIKE(ccCnct.IP);
   curLogin   : LIKE(ccCnct.Login);
   curCnctNo  : LIKE(ccCnct.CnctNo);
 BEGIN
  CreateTransactionsList();
  CnctNoLst:="";
  FOR_EACH oConn IN ASBCONNECTIONS.Create() DO
   curCnctNo:=oConn.Number;
   PROMPT(curCnctNo);
   IF checkASBCProc(oConn) THEN
    curIP    :=oConn.IPAddress;
    curLogin :=oConn.LoginName;
    CnctNoLst:=CnctNoLst + "|" + curCnctNo;
    found:=SELECT(ccCnct, IP, L_WDO.v_dbConnection, curIP, curCnctNo) & (curLogin = ccCnct.Login);
    IF ~found | wGroups THEN
     ins:=~SELECT(ccCnct, CnctNo, L_WDO.v_dbConnection, curCnctNo);
     curAcsObj:=L_AR.GetUser(oConn.LoginName);
     SETZERO(ccCnct.SpcRight);
     SETEMPTY(ccCnct.Groups);
     ccCnct.curCnct:=L_WDO.v_dbConnection;
     ccCnct.CnctNo :=oConn.Number;
     ccCnct.Domain :=oConn.UserDomain;
     ccCnct.AcsObj :=curAcsObj;
     SEARCH(AcsObj, AcsObj, , curAcsObj);
     IF ~!oConn.Job THEN
      IF L_Guard.IsGuardConnection(oConn) THEN
       ccCnct.Name:=GuardNameInRussian;
      ELSE
       ccCnct.Name:=oConn.Job.Name;
      END;
     ELSE
      ccCnct.Name   :=AcsObj.FullName;
     END;
     ccCnct.Name:=Str.Align(ccCnct.Name, 40, LEFT) + " " + L_Str.PoolItem("t| ", oConn.GUI);
     ccCnct.IP     :=oConn.IPAddress;
     ccCnct.My     :=oConn.My;
     ccCnct.Login  :=oConn.LoginName;
     ccCnct.Type   :=oConn.ConnectionType;
     SETEMPTY(ccCnct.HasATrns, ccCnct.TrnsDesc, ccCnct.Sign);
     IF ins THEN
      INSERT(ccCnct);
     END;

     IF ~L_General.IsLocalMode() THEN
      FOR_EACH oTokenGroup IN oConn.TokenGroups DO
       grpName:=Str.Cap(oTokenGroup.Name);
       IF    grpName = "PROGRAMMERS" THEN
        ccCnct.SpcRight[0]:=1;
       ELSIF grpName = L_General.AdminGroupName() THEN
        ccCnct.SpcRight[1]:=1;
       END;
      END;
     ELSE
      ccCnct.SpcRight[1]:=1;
     END;
     ccCnct.SpcRight[3]:=oConn.ProgrammerPrivilege;
     ccCnct.SpcRight[4]:=oConn.AdminPrivilege;
     REPLACE(ccCnct);
    END; (* IF ~found | wGroups...*)

    SETEMPTY(trgTrnsDesc);
    trgHasATrns:=0;
    IF ~oConn.My THEN
     IF SEARCH(ActTrnLst, ConNo, oConn.Number) THEN
      trgTrnsDesc:=ActTrnLst.Descr;
      trgHasATrns:=1;
     ELSE
      trgTrnsDesc:="祣";
     END;
    END;
    IF    oConn.My THEN
     trgSign:="*";
    ELSIF FIO.Exists(L_NTF.GetFullNTFName(ntfName_GetOutStrong + "_" + ccCnct.CnctNo)) THEN
     trgSign:="!";
    ELSIF FIO.Exists(L_NTF.GetFullNTFName(ntfName_GetOutSoft + "_" + ccCnct.CnctNo)) THEN
     trgSign:="?";
    ELSE
     trgSign:=" ";
    END;

    IF (ccCnct.TrnsDesc # trgTrnsDesc) | (ccCnct.Sign # trgSign) THEN
     ccCnct.TrnsDesc:=trgTrnsDesc;
     ccCnct.HasATrns:=trgHasATrns;
     ccCnct.Sign    :=trgSign;
     REPLACE(ccCnct);
    END;
   END;
  END; (* FOR_EACH oConn *)

  SELECT(ccCnct, CnctNo, , L_WDO.v_dbConnection);
  WHILE OCCURE(ccCnct) DO
   IF Str.Pos(CnctNoLst, ccCnct.CnctNo) < Str.Length(CnctNoLst) THEN
    NEXT(ccCnct);
   ELSE
    REMOVE(ccCnct);
   END;
  END; (* WHILE OCCURE(ccCnct) ... *)
 END {intRefresh};

 PUBLIC PROCEDURE RefreshAll(wGroups: SCAL[2]);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  intRefresh(wGroups, PROCREF(checkASBC_All));
 END {RefreshAll};

 PUBLIC PROCEDURE Refresh(wGroups: SCAL[2]);
  VAR
   w            : FORM_WINDOW;
   pz           : FORM_ZONE;
   checkASBCProc: PROC;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  w:=RTI.Get().CurWindow;
  IF    !w THEN
   checkASBCProc:=PROCREF(checkASBC_All);
  ELSIF w.OriginalName = "aoGroup" THEN
   curGroupAcsObj:=AcsObj.AcsObj;
   checkASBCProc:=PROCREF(checkASBC_curGroup);
  ELSIF w.OriginalName = "ccCnct" THEN
   pz:=w.ParentZone;
   IF !pz THEN
    checkASBCProc:=PROCREF(checkASBC_All);
   ELSE
    L_General.CallUs(pz.Window.OriginalName = "aoGroup");
    GE_WZD_CURSOR(pz.Window.Name, pz.Number, AcsObj);
    curGroupAcsObj:=AcsObj.AcsObj;
    checkASBCProc:=PROCREF(checkASBC_curGroup);
   END;
  END;
  intRefresh(wGroups, checkASBCProc);
  SetOutAPState();
 END {Refresh};

 PRIVATE PROCEDURE getFullURI(Name: STRING[]): STRING[];
 BEGIN
  RETURN "WinNT://" + USERDOMAIN() + "/" + Name;
 END {getFullURI};

 PRIVATE PROCEDURE Access_ccCnct();
 BEGIN
  L_General.CallUs(ACCESS(ccCnct));
 END {Access_ccCnct};

 PRIVATE PROCEDURE CheckCanWatchConn(trgConn: SCAL[1E4]; Type: NUMERIC[0]);
 BEGIN
  IF (Type = ASBCONNECTION.Type_TerminalAgent)    |
     (Type = ASBCONNECTION.Type_AutomationServer) |
     (Type = ASBCONNECTION.Type_Utility)          THEN
   L_General.Error("祭 " + trgConn + " - " +
                   L_Str.PoolItem("???|???|   |ନ (⮭)  ⮏|"+
                                  "ࢥ ⮬⨧樨 ⮏|" +
                                  "⨫  ப||???|???|???|", Type) + "." +
                   "|  ࠢ ⨬ ᥠᮬ .");
  END;
 END {CheckCanWatchConn};

 PRIVATE PROCEDURE GetASBCONNECTION(trgConn: SCAL[1E4]; trgIP, trgLogin: STRING[]): ASBCONNECTION;
  VAR
   oConn,
   Result: ASBCONNECTION;
 BEGIN
  SETEMPTY(Result);
  FOR_EACH oConn IN ASBCONNECTIONS.Create() DO
   IF oConn.Number = trgConn THEN
    IF (!trgIP    | (oConn.IPAddress = trgIP)) &
       (!trgLogin | (oConn.LoginName = trgLogin)) THEN
     Result:=oConn;
    END;
    EXIT;
   END;
  END;
  IF !Result THEN
   L_StdFrm.Inform("祭 " + trgConn + " 㦥 ");
  END;
  RETURN Result;
 END {GetASBCONNECTION};

 PUBLIC PROCEDURE WatchByInvite(Control: SCAL[2]; trgConn: SCAL[1E4]; trgAcsObj: LIKE(AcsObj.AcsObj));
  VAR
   oConn: ASBCONNECTION;
 BEGIN
  SEARCH(AcsObj, AcsObj, , trgAcsObj);
  oConn:=GetASBCONNECTION(trgConn, "", AcsObj.Name);
  IF ~!oConn THEN
   CheckCanWatchConn(trgConn, oConn.Type);
   oConn.Watch(Control);
  END;
 END {WatchByInvite};

 PUBLIC PROCEDURE Watch(Control: SCAL[2]);
  VAR
   oConn: ASBCONNECTION;
 BEGIN
  Access_ccCnct();
  IF ccCnct.My THEN
   L_StdFrm.BlueStop("  祭");
  END;
  CheckCanWatchConn(ccCnct.CnctNo, ccCnct.Type);
  oConn:=GetASBCONNECTION(ccCnct.CnctNo, "", "");
  IF ~!oConn THEN
   IF ~ISPROGRAMMER() THEN
    IF Control THEN
     L_AcsPnt.PassAccessPoint(0000040);
    ELSE
     L_AcsPnt.PassAccessPoint(0000041);
    END;
   END;
   oConn.Watch(Control);
  END;
  Refresh(0);
 END {Watch};

 PUBLIC PROCEDURE Kill();
  VAR
   oConn: ASBCONNECTION;
 BEGIN
  Access_ccCnct();
  L_General.Assert(~ccCnct.My, "  祭");
  oConn:=GetASBCONNECTION(ccCnct.CnctNo, ccCnct.IP, ccCnct.Login);
  IF ~!oConn THEN
   IF ~ISPROGRAMMER() & (ccCnct.AcsObj # L_General.curUSER) THEN
    L_AcsPnt.PassAccessPoint(0000040);
   END;
   L_StdFrm.Choice("⪫ 짮⥫ '" + ccCnct.Login + "'?");
   IF ccCnct.HasATrns THEN
    L_StdFrm.Choice(" 짮⥫ '" + ccCnct.Login + "' 믮:" +
                    L_StdFrm.HR() +
                    L_StdFrm.AlignPoolItems(Str.Replace(ccCnct.TrnsDesc, "; ", "|"), "LEFT") +
                    L_StdFrm.HR() +
                    " ࠢ ⪫?");
   END;
   IF ~!oConn.Job THEN
    L_SysLog.ELN_Put("Job.Killed", oConn.Job.Name)
   END;
   oConn.Kill();
   Refresh(0);
  END;
 END {Kill};

 PUBLIC PROCEDURE PutMessage();
 BEGIN
  Access_ccCnct();
  CONFORM(ccCnct, AcsObj);
  LIKEMENU(Ins, "MessageE 0 @ toLogin=" + AcsObj.AcsObj);
 END {PutMessage};

 PRIVATE PROCEDURE NTF_TmpFN(FN: STRING[]): STRING[];
 BEGIN
  RETURN L_NTF.intGetFullNTFName(FN, "tmp");
 END {NTF_TmpFN};

 PUBLIC PROCEDURE InviteToWatch();
 BEGIN
  Access_ccCnct();
  IF ccCnct.My | (ccCnct.AcsObj = L_General.curUSER) THEN
   L_StdFrm.BlueStop("  祭");
  ELSE
   LIKEMENU(Ins, "MessageE 0 @ toLogin=" + ccCnct.AcsObj + " WatchInvite=1");
  END;
 END {InviteToWatch};

 PRIVATE PROCEDURE PutGetOutNTF(Level: SCAL[3]; ConnNo: L_NetWrk.tConnectionNo; FN: STRING[]; OnlyOne: SCAL[2]);
  VAR
   Who,
   Msg : STRING[];
   wRestart: SCAL[2];
 BEGIN
  IF (Level = 1) & FIO.Exists(L_NTF.GetFullNTFName(ntfName_GetOutStrong)) THEN
   L_StdFrm.RedInform('  "᭨ "');
   RETURN;
  END;
  IF OnlyOne & ~FIO.Exists(L_NTF.GetFullNTFName(ntfName_ProhibitStart)) &
               ~FIO.Exists(L_NTF.GetFullNTFName(ntfName_GetOutSoft)) &
               ~FIO.Exists(L_NTF.GetFullNTFName(ntfName_GetOutStrong)) THEN
   L_StdFrm.Question("   ⮏ ⭮ 짮⥫  ᫮," +
                     "| 室 ᥬ 짮⥫ ࠧ襭." +
                     "|।⥫쭮, ⮬,  짮⥫ 蠥  /  ࠡ⠬." +
                     "|| ஡ ,  짮⥫  ࠢ." +
                     "||᫨   ࠢ 祭  砥, " +
                     '|᪮॥ ᥣ,   ""  ᭨  ⨬ ᯮᮡ  .');
   wRestart:=0;
  ELSE
   wRestart:=1;
  END;
  L_NTF.PutNTF(FN,
               'IMPORT L_NTF;' + L_Str.CRLF +
               'BEGIN' + L_Str.CRLF +
               ' L_NTF.GetOut(' + Level + ', ' + ConnNo + ', ' + OnlyOne + ', ' + wRestart + ');' + L_Str.CRLF +
               'END.' + L_Str.CRLF);

  Msg:=" 䠩 " + L_NTF.GetFullNTFName(FN);
  IF    Level = 0 THEN
   Msg:=Msg + ",|騩 室  ⮏";
  ELSE
   IF OnlyOne THEN
    Who:="|짮⥫  ஬ ᮥ " + ConnNo;
   ELSE
    Who:="  짮⥫";
   END;
   IF    Level = 1 THEN
    Msg:=Msg + ",|    ⮏ઠ" + Who;
   ELSIF Level = 2 THEN
    Msg:=Msg + ",| ᫮ ᭨  ⮏ઠ" + Who;
   END;
  END;
  STDMSG(Msg, INFORM);
 END {PutGetOutNTF};

 PRIVATE PROCEDURE ClearNTFs(Mask: STRING[]);
  VAR
   filePath: STRING[];
 BEGIN
  WHILE FIO.Exists(L_NTF.GetFullNTFName(Mask), , filePath) DO
   FIO.Erase(filePath);
  END;
 END {ClearNTFs};

 PRIVATE PROCEDURE SilentAdminOrProgrammerOnly();
 BEGIN
  IF ~ISPROGRAMMER() THEN
   L_General.SilentAdminOnly();
  END;
 END {SilentAdminOrProgrammerOnly};

 PUBLIC PROCEDURE ProhibitStartAP();
 BEGIN
  SilentAdminOrProgrammerOnly();
  PutGetOutNTF(0, L_NetWrk.GetMyConnectionNo(), ntfName_ProhibitStart, 0);
  SetOutAPState();
 END {ProhibitStartAP};

 PUBLIC PROCEDURE PermitStartAP();
 BEGIN
  SilentAdminOrProgrammerOnly();
  ClearNTFs(ntfName_ProhibitStart);
  ClearNTFs(ntfName_GetOutSoft + "*");
  ClearNTFs(ntfName_GetOutStrong + "*");
  PROMPT(" ᯨ᪠ 짮⥫...");
  SLEEP(3);
  Refresh(1);
 END {PermitStartAP};

 PRIVATE PROCEDURE MakeGetOutNTF(OnlyOne: SCAL[2]; Level: SCAL[3]; FN: STRING[]);
 BEGIN
  SilentAdminOrProgrammerOnly();
  IF OnlyOne THEN
   Access_ccCnct();
   IF ccCnct.My THEN
    L_StdFrm.RedInform("  祭");
   ELSE
    PutGetOutNTF(Level, ccCnct.CnctNo, FN + "_" + ccCnct.CnctNo, OnlyOne);
    IF    Level = 1 THEN
     ccCnct.Sign:="?";
    ELSIF Level = 2 THEN
     ccCnct.Sign:="!";
    END;
    REPLACE(ccCnct);
   END;
  ELSE
   PutGetOutNTF(Level, L_NetWrk.GetMyConnectionNo(), FN, OnlyOne);
   SetOutAPState();
  END;
 END {MakeGetOutNTF};

 PUBLIC PROCEDURE AskToGetOut(OnlyOne: SCAL[2]);
 BEGIN
  MakeGetOutNTF(OnlyOne, 1, ntfName_GetOutSoft);
 END {AskToGetOut};

 PUBLIC PROCEDURE ForceGetOut(OnlyOne: SCAL[2]);
 BEGIN
  MakeGetOutNTF(OnlyOne, 2, ntfName_GetOutStrong);
 END {ForceGetOut};

 PRIVATE PROCEDURE ccCnct_OnConformToWindow();
 BEGIN
  RTI.Get().TrgWindow.Title:="⨢ 祭 짮⥫ 㯯 " + AcsObj.Name;
  Refresh(0);
  SELECT(ccCnct, Login, , L_WDO.v_dbConnection);
  SE_WWD_CURSOR(GE_CONFORMTARGETWINDOW(), ccCnct);
 END {ccCnct_OnConformToWindow};

 PUBLIC PROCEDURE Show4aoGroup();
  VAR
   fw: FORM_WINDOW;
 BEGIN
  fw:=APPLICATION.Get().Forms.Load("ccCnct", "ccCnct<aoGroup>");
  LIKEMENU(ShowWin, fw.Name + " 1 " + RTI.Get().CurWindow.Name + " " + L_Str.IntStr(RTI.Get().CurZone.Number));
 END {Show4aoGroup};

BEGIN
 L_Events.ExecuteHandler();
END.
