(*
%Copyright   (c) Polak IT
%Author      01.04.2003 13:55:28 POLAK\LDA
%Purpose     ᯮ짮   ⮢ 㬥.
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:15:00 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, Math, L_AFM, L_DatTim, L_Str, L_OwnData, L_MDoc, L_MathR,
        L_Pmnt, Memo, L_Acnt;

 TYPE
  tObject = SCAL[3];

 CONST
  curMath      = 0;
  curCstDclr   = 1;
  all_wProblem = 2;

 VAR
  Object : tObject;

 PRIVATE PROCEDURE GetRepTitle(): STRING[];
 BEGIN
  IF Object = curMath THEN
   RETURN "ᯮ짮    " + Math.Math + " " + Math.Name;
  ELSIF Object = curCstDclr THEN
   RETURN "ᯮ짮  " + CstDclr.CstDclr + " " + CstDclr.Number;
  ELSE
   RETURN "஡ ";
  END;
 END {GetRepTitle};

 PRIVATE PROCEDURE byPeriod(): SCAL[2];
 BEGIN
  RETURN Math.Mod(MODE, 10);
 END {byPeriod};

 PRIVATE PROCEDURE GetRepPer(): STRING[];
 BEGIN
  IF byPeriod() THEN
   RETURN " ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut());
  ELSE
   RETURN "  ";
  END;
 END {GetRepPer};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
GetRepTitle(), C, ""
GetRepPer(), C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|############################################################################|
}
*)

(*
$P{ SubTop:
@
|----------------------------------------------------------------------------|
|      ||  ||               ⢮|                   줮|
}
*)

(*
$P{ Dlm:
@
|----------|---|-------|-|-------------------------|-------------------------|
}
*)

(*
$P{ SubTitle0:
?, L, ""
?, L, ""
@
|----------------------------------------------------------------------------|
|########################################## #################################|
}
*)

(*
$P{ SubTitle1:
Math.Math, L, ""
Math.Name, L, ""
L_MathR.DefaultMUnitSign(Math.Math), L, ""
@
|----------------------------------------------------------------------------|
|##### ################################################################ (###)|
}
*)

(*
$P{ Line:
TmpMD.Date, L, "D.N.y"
L_MDoc.MDocKindNick(TmpMD.MDocKind, 1), L, ""
TmpMD.MDoc, L, ""
MDoc.Status, L, "||"
?, R, ""
?, R, ""
@
|##########|###|#######|#|#########################|#########################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Create_TmpMD();
 BEGIN
  CreateFILE(TmpMD, "", "६ 䠩", "");

  CreateFIELD(TmpMD, MDocKind, LIKE(MDoc.MDocKind),   "", "", "", " 㬥", "");
  CreateFIELD(TmpMD, MDoc,     LIKE(MDoc.MDoc),       "", "", "", "㬥", "");
  CreateFIELD(TmpMD, Date,     DATE,                  "", "", "", " 㬥", "");
  CreateFIELD(TmpMD, CstDclr,  LIKE(CstDclr.CstDclr), "", "", "", "", "");
  CreateFIELD(TmpMD, Math,     LIKE(Math.Math),       "", "", "", "", "");
  CreateFIELD(TmpMD, Cir,      NUMERIC[2],            "", "", "", "-", "");
  CreateFIELD(TmpMD, mft,      L_MDoc.tMathFlowType,  "", "", "", "  ", "");

  CreateINDEXandLINK(TmpMD, MDoc,     PLURAL, MDoc,     MDoc,     USER, "", "", MDocKind, MDoc, Date);
  CreateINDEXandLINK(TmpMD, MDocKind, PLURAL, MDocKind, MDocKind, USER, "", "", MDocKind);
  CreateINDEXandLINK(TmpMD, CstDclr,  PLURAL, CstDclr,  CstDclr,  USER, "", "", CstDclr, Math, Date, mft, MDoc, MDocKind);
  CreateINDEXandLINK(TmpMD, Math,     PLURAL, Math,     Math,     USER, "", "", Math, Date, mft, MDoc, MDocKind);

  SetVersionOfFILE(TmpMD, 0);
  L_AFM.AF_CreateTemp("TmpMD", "TmpMD");
 END {Create_TmpMD};

 PRIVATE PROCEDURE MakeIndex();
 BEGIN
  Create_TmpMD();
  IF    Object = curMath THEN
   SELECT(MDocList, Math, , Math.Math);
  ELSIF Object = curCstDclr THEN
   SELECT(MDocList, CstDclr, , CstDclr.CstDclr);
  ELSE
   SELECT(MDocList, Math);
  END;
  WHILE OCCURE(MDocList) DO
   PROMPT(L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc));
   CONFORM(MDocList, MDoc);
   CONFORM(MDocList, Math);
   IF L_Pmnt.IsMDocListWithSignificantCstDclr()    &
      (MDoc.Status # L_MDoc.st_Canceled)   THEN
    TmpMD.MDocKind:=MDoc.MDocKind;
    TmpMD.MDoc    :=MDoc.MDoc;
    TmpMD.Date    :=MDoc.Date;
    TmpMD.CstDclr :=MDocList.CstDclr;
    TmpMD.Math    :=MDocList.Math;
    TmpMD.Cir     :=L_MDoc.GetMDocListCir2();
    TmpMD.mft     :=L_MDoc.getMDocListMathFlowType();
    INSERT(TmpMD);
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE PrintRep();
  VAR
   _Sign,
   RepName,
   _CstDclr,
   _Country: STRING[];
   _Saldo  : NUMERIC[3];
   Dir     : NUMERIC[0];
   BPer,
   EPer    : DATE;
   DoIt    : SCAL[2];
 BEGIN
  IF byPeriod() THEN
   BPer:=Memo.ud_fr();
   EPer:=Memo.ud_ut();
  ELSE
   BPer:=L_DatTim.MINDATE();
   EPer:=L_DatTim.MAXDATE();
  END;
  RepName:=L_Str.PoolItem("Mt|Cd|Ap", Object) +
           L_Str.PoolItem("All|Per", byPeriod());
  OPENREP(R, L_General.NameConnection(RepName), Create);

  MAKEPART(R, Top, RepName);
  IF    (Object = curMath) | (Object = all_wProblem) THEN
   SELECT(TmpMD, CstDclr);
  ELSIF Object = curCstDclr THEN
   SELECT(TmpMD, Math);
  ELSE
   SELECT(TmpMD, CstDclr);
  END;
  WHILE OCCURE(TmpMD) DO
   DoIt:=1;
   IF Object = all_wProblem THEN
    IF ~!TmpMD.CstDclr THEN
     DoIt:=0;
     CHANGESEL(TmpMD, CstDclr, , TmpMD.CstDclr, TmpMD.Math);
     CONFORM(TmpMD, Math);
     CONFORM(Math, MathType);
     IF MathType.Category = L_Acnt.mtc_Inventories THEN
      _Saldo:=0;
      WHILE OCCURE(TmpMD) DO
       PROMPT("஢ઠ " + TmpMD.MDoc);
       IF    TmpMD.mft = L_MDoc.mft_Debit THEN
        Dir:=+1;
       ELSE
        Dir:=-1;
       END;
       INC(_Saldo, Dir * TmpMD.Cir);
       IF _Saldo < 0 THEN
        DoIt:=1;
       END;
       NEXT(TmpMD);
      END; (* WHILE OCCURE(TmpMD) ... *)
     END;
     FIRST(TmpMD);
    END;
   END; (* IF Object *)
   IF DoIt THEN
    IF ~!TmpMD.CstDclr THEN
     CONFORM(TmpMD, CstDclr);
     CONFORM(CstDclr, Country);
    END;
    CONFORM(TmpMD, Math);
    IF Object = curMath THEN
     IF ~!TmpMD.CstDclr THEN
      MAKEPART(R, SubTitle0, CstDclr.CstDclr + " " + CstDclr.Number, Country.Name);
     ELSE
      MAKEPART(R, SubTitle0, "  㪠");
     END;
     CHANGESEL(TmpMD, CstDclr, , TmpMD.CstDclr);
    ELSIF Object = curCstDclr THEN
     MAKEPART(R, SubTitle1);
     CHANGESEL(TmpMD, Math, , TmpMD.Math);
    ELSE
     IF ~!TmpMD.CstDclr THEN
      MAKEPART(R, SubTitle0, CstDclr.CstDclr + " " + CstDclr.Number, Country.Name);
     ELSE
      MAKEPART(R, SubTitle0, "  㪠");
     END;
     MAKEPART(R, SubTitle1);
     CHANGESEL(TmpMD, CstDclr, , TmpMD.CstDclr, TmpMD.Math);
    END;
    MAKEPART(R, SubTop);
    MAKEPART(R, Dlm);
    SETZERO(_Saldo);
    WHILE OCCURE(TmpMD) DO
     PROMPT(" " + TmpMD.MDoc);
     CONFORM(TmpMD, MDocKind);
     IF Object = curMath THEN
      _Sign:=" " + L_MathR.DefaultMUnitSign(TmpMD.Math);
     ELSE
      _Sign:="";
     END;
     IF    TmpMD.mft = L_MDoc.mft_Debit THEN
      Dir:=+1;
     ELSE
      Dir:=-1;
     END;
     INC(_Saldo, Dir * TmpMD.Cir);
     IF L_DatTim.IsActive_Inc(TmpMD.Date, BPer, EPer) THEN
      CONFORM(TmpMD, MDoc);
      MAKEPART(R, Line, L_MathR.DefaultFormatCir(TmpMD.Math, TmpMD.Cir) + _Sign,
                        L_MathR.DefaultFormatCir(TmpMD.Math, _Saldo)    + _Sign);
     END;
     NEXT(TmpMD);
    END; (* WHILE OCCURE(TmpMD) ... *)
   END; (* IF DoIt *)
   LAST(TmpMD);
   IF (Object = curMath) | (Object = all_wProblem) THEN
    CHANGESEL(TmpMD, CstDclr);
   ELSE
    CHANGESEL(TmpMD, Math);
   END;
   NEXT(TmpMD);
  END; (* WHILE OCCURE(TmpMD) ... *)
  MAKEPART(R, Bot);
 END {PrintRep};

 PRIVATE PROCEDURE GetRepObject(): tObject;
 BEGIN
  RETURN Math.Mod(Math.Div(MODE, 10), 5);
 END {GetRepObject};

BEGIN
 Object:=GetRepObject();
 IF    Object = curMath THEN
  L_General.Assert(ACCESS(Math), " ࠭ ");
 ELSIF Object = curCstDclr THEN
  L_General.Assert(ACCESS(CstDclr), " ࠭ ");
 END;
 MakeIndex();
 PrintRep();
 L_AFM.AF_PurgeTemp("TmpMD");
END.
