(*
%Copyright   (c) Polak IT
%Author      01.09.2010 11:25:58 POLAK\SSV
%Purpose     ⢮   ୮ 
%Type        report
%Specific    SYS
%Modified    11.10.2013 16:41:44 POLAK\GAV
%Environment
*)

 IMPORT L_CUC, L_General, L_Car, L_AFM, L_OwnData, L_Str, L_DatTim;

 CONST
  bcm_diffNmb     = 0;
  bcm_noEngineCUC = 1;
  bcm_hasNoMDLCU  = 2;
  bcm_onlyMention = 3;

  bcm_Pool = " XXXX   ⥫ XXXXXXXXXXXX|  |   |   ⮫쪮 ''";

  ChCUC_RepName = "ChCUC";
  mc_All     = 0;
  mc_CarUnit = 1;

 VAR
  EngineMathCnt: NUMERIC[0];

(*
$P{ ChCUC_top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
ChCUC_RepName, L, ""
?, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|    |᪮       |                             |訡                                       |
|-------|---------------------|--------------------------------|---------------------------------------------|
}
*)

(*
$P{ ChCUC_row:
BadCUC.CUCopy, L, ""
CUCopy.Serial, L, ""
CUCopy.Math, L, ""
Math.Name, L, ""
?, L, ""
@
|#######|#####################|##### ##########################|#############################################|
}
*)

(*
$P{ ChCUC_badvehpasp:
BadCUC.EnginNum, L, ""
BadCUC.VehPasp, L, ""
BadCUC.BoxNbr, L, ""
@
| |                     | ⥫ ####################|   ###### TC ####                  |
}
*)

(*
$P{ ChCUC_bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE InsertBadCUCMsgId(MsgId: SCAL[5]);
 BEGIN
  SETEMPTY(BadCUC.BoxNbr, BadCUC.Serial, BadCUC.VehPasp, BadCUC.EnginNum);
  BadCUC.CUCopy:=CUCopy.CUCopy;
  BadCUC.MsgId :=MsgId;
  INSERT(BadCUC);
 END {InsertBadCUCMsgId};

 PRIVATE PROCEDURE AddEngineFromVehPasp(D: DATE);
 BEGIN
  L_Car.AccessVehPasp(Car.BoxNbr, D);
  IF OCCURE(VehPasp) & ~!VehPasp.EnginNum & ~!L_Car.VehPaspStateNbr(D) THEN
   SETEMPTY(BadCUC.CUCopy, BadCUC.BoxNbr, BadCUC.Serial);
   BadCUC.EnginNum:=VehPasp.EnginNum;
   BadCUC.VehPasp :=VehPasp.VehPasp;
   BadCUC.BoxNbr  :=Car.BoxNbr;
   BadCUC.MsgId   :=bcm_noEngineCUC;
   INSERT(BadCUC);
  END;
 END {AddEngineFromVehPasp};

 PRIVATE PROCEDURE CheckEngineCUCopy(D: DATE);
 BEGIN
  IF L_CUC.AccessLastMDocLCU(CUCopy.CUCopy) & L_CUC.IsCUAtCar(MDocLCU.OpKind) (*~!MDocLCU.BoxNbr*) THEN
   L_Car.AccessVehPasp(MDocLCU.BoxNbr, D);
   IF SEARCH(BadCUC, VehPasp, VehPasp.VehPasp) THEN
    IF BadCUC.EnginNum = CUCopy.Serial THEN
     REMOVE(BadCUC);
    ELSE
     BadCUC.CUCopy:=CUCopy.CUCopy;
     BadCUC.MsgId :=bcm_diffNmb;
     BadCUC.BoxNbr:=MDocLCU.BoxNbr;
     BadCUC.Serial:=CUCopy.Serial;
     REPLACE(BadCUC);
    END;
   END; (* IF IsEngine & L_CUC.AccessLastMDocLCU(CUCopy.CUCopy) *)
  END;
 END {CheckEngineCUCopy};

 PRIVATE PROCEDURE cucRoleIsNot4MDocLCU(): SCAL[2];
 BEGIN
  RETURN L_CUC.cucRole_IsTckBag() |
         L_CUC.cucRole_IsCar()    |
         L_CUC.cucRole_IsOutCar() |
         (CUCopy.Origin = L_CUC.o_OutCBlc) |
         (CUCopy.Origin = L_CUC.o_Math);
 END {cucRoleIsNot4MDocLCU};

 PRIVATE PROCEDURE CheckCUCopyIsUsed();
 BEGIN
  IF ~SELECT(MDocLCU, CUCopy, CUCopy.CUCopy) THEN
   IF ~SELECT(TckRcDL, CUCopy, CUCopy.CUCopy) &
      ~SELECT(TckRcDLL, CUCopy, CUCopy.CUCopy) &
      ~cucRoleIsNot4MDocLCU() THEN
    InsertBadCUCMsgId(bcm_hasNoMDLCU);
   END;
  ELSE
   WHILE OCCURE(MDocLCU) & (MDocLCU.OpKind = L_CUC.ok_Mentioning) DO
    NEXT(MDocLCU);
   END;
   IF ~OCCURE(MDocLCU) THEN
    InsertBadCUCMsgId(bcm_onlyMention);
   END;
  END; (* IF ~SELECT(MDocLCU, CUCopy, CUCopy.CUCopy) *)
 END {CheckCUCopyIsUsed};

 PRIVATE PROCEDURE ChCUCRep_Print(mode: SCAL[2]);
  VAR
   Title,
   RepName: STRING[];
 BEGIN
  IF    mode = mc_CarUnit THEN
   RepName:=ChCUC_RepName + "_" + CarUnit.CarUnit;
   Title  :="訡 ୮   ॣ " + CarUnit.CarUnit + " " + CarUnit.Name;
  ELSIF mode = mc_All THEN
   RepName:=ChCUC_RepName;
   Title  :="訡 ୮  ( ॣ)";
  END;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, ChCUC_top, Title);
  SELECT(BadCUC, BadCUC);
  WHILE OCCURE(BadCUC) DO
   IF ~!BadCUC.CUCopy THEN
    PROMPT(BadCUC.CUCopy);
    SEARCH(CUCopy, CUCopy, , BadCUC.CUCopy);
    CONFORM(CUCopy, Math);
    IF BadCUC.MsgId = bcm_diffNmb THEN
     MAKEPART(R, ChCUC_row, " " + FLDTOSTR(BadCUC.BoxNbr) + "   ⥫ " + BadCUC.EnginNum);
    ELSE
     MAKEPART(R, ChCUC_row, L_Str.PoolItem(bcm_Pool, BadCUC.MsgId));
    END;
   ELSE
    MAKEPART(R, ChCUC_badvehpasp);
   END;
   NEXT(BadCUC);
  END;
  MAKEPART(R, ChCUC_bot);
  CLOSEREP(R);
 END {ChCUCRep_Print};

 PRIVATE PROCEDURE GatherCarUnit(D: DATE);
  VAR
   IsEngine: SCAL[2];
 BEGIN
  SELECT(Math, CarUnit, , CarUnit.CarUnit);
  WHILE OCCURE(Math) DO
   IF SELECT(CUCopy, Math, Math.Math) THEN
    SAVE(Math);
    IsEngine:=L_CUC.cucRole_IsEngine();
    RESTORE(Math);
    IF IsEngine THEN
     IF EngineMathCnt = 0 THEN
      IF L_CUC.EngineAcntLev() THEN
       SELECT(Car, BoxNbr);
       WHILE OCCURE(Car) DO
        PROMPT(Car.BoxNbr);
        IF L_DatTim.IsActive_Inc(D, Car.BegDate, Car.EndDate) THEN
         AddEngineFromVehPasp(D);
        END;
        NEXT(Car);
       END;
      END;
     END;
     INC(EngineMathCnt);
    END;
    WHILE OCCURE(CUCopy) DO
     PROMPT(FLDTOSTR(CUCopy.Math) + " " + CUCopy.CUCopy);
     IF IsEngine THEN
      CheckEngineCUCopy(D);
     END;
     CheckCUCopyIsUsed();
     NEXT(CUCopy);
    END; (* WHILE OCCURE(CUCopy) *)
   END; (* IF SELECT(CUCopy, Math, Math.Math) *)
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)
 END {GatherCarUnit};

 PUBLIC PROCEDURE intMakeChCUCRep(mode: SCAL[2]);
  VAR
   D       : DATE;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);

  L_AFM.MakeMultipleIndex("BadCUC", "CUCopy  : " + TYPENAMEOF(LIKE(CUCopy.CUCopy))    + ";" +
                                    "VehPasp : " + TYPENAMEOF(LIKE(VehPasp.VehPasp))  + ";" +
                                    "EnginNum: " + TYPENAMEOF(LIKE(VehPasp.EnginNum)) + ";" +
                                    "BoxNbr  : " + TYPENAMEOF(LIKE(Car.BoxNbr))       + ";" +
                                    "Serial  : " + TYPENAMEOF(LIKE(CUCopy.Serial))    + ";" +
                                    "MsgId   : SCAL[5]",
                             "VehPasp: VehPasp;" +
                             "BadCUC : CUCopy, MsgId");
  EngineMathCnt:=0;
  D:=SYSDATE();
  IF    mode = mc_CarUnit THEN
   L_General.Assert(ACCESS(CarUnit), " ⠭ ॣ");
   GatherCarUnit(D);
  ELSIF mode = mc_All THEN
   SELECT(CarUnit, CarUnit);
   WHILE OCCURE(CarUnit) DO
    GatherCarUnit(D);
    NEXT(CarUnit);
   END; (* WHILE OCCURE(CarUnit) ... *)
  END;
  ChCUCRep_Print(mode);
  LIKEMENU(Survey, "");
 END {intMakeChCUCRep};

 PUBLIC PROCEDURE MakeChCUCRep();
 BEGIN
  intMakeChCUCRep(mc_All);
 END {MakeChCUCRep};

 PUBLIC PROCEDURE MakeChCUC_CarUnit();
 BEGIN
  intMakeChCUCRep(mc_CarUnit);
 END {MakeChCUC_CarUnit};
END.