(*
%Copyright   (c) Polak IT
%Author      21.04.2004 16:23:10 POLAK\Bor
%Purpose     宦  ᠭ ⮢ 㬥⮢  㬥⮢  
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:15:05 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_DatTim, L_OwnData, L_MDoc, L_XDoc, L_Pmnt, L_MathR, L_Dest, L_Str, L_XObj,
        L_AFM, L_Acnt, L_Prop,
        P_MDoc, P_Cntr, P_Math, Memo, Str, Math;

 TYPE
  tCond      = SCAL[2];
  tMDLnsType = SCAL[4];

 CONST
  byAll      = 0;
  byContract = 1;

  mdlt_vr_00            = 0;
  mdlt_MustBeWithoutVAT = 1;
  mdlt_CalculatedNotEQ  = 2;
  mdlt_DefVATModeNotEQ  = 3;

  mdlt_Headers = [ "  ⠢ 0%|",
                   "㫥  ⨬|",
                   "稭   ᮢ  ⭮|                   ",
                   "ᮡ    ᮢ  ਭ  㬮砭|ᮡ    㬮砭" ];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                     宦  ᠭ ⮢ 㬥⮢  㬥⮢                        |
}
*)

(*
$P{ TopContract:
"( "+Contract.Contract+" "+Contract.Name+")", C, ""
@
|############################################################################################################|
}
*)

(*
$P{ Top1:
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
|                                     ਮ  ##########  ##########                                    |
|------------------------------------------------------------------------------------------------------------|
|. 㬥 |      ||.|  |||. 㬥|ᮮ⢥⢨                            |
|--------------|----------|-------|----|-----|---|-|--------------|------------------------------------------|
}
*)

(*
$P{ Line:
?, L, ""
?, L, ""
?, L, ""
?, L, "D.N.y"
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|## ### #######|##########|#######|####|#####|###|#|## ### #######|##########################################|
}
*)

(*
$P{ Top2:
?, C, ""
?, L, ""
@
|============================================================================================================|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|㬥      |      ||.|  |ᮡ  |           |###############################|
|--------------|----------|-------|----|-----|----------------|--------------|-------------------------------|
}
*)

(*
$P{ Line2:
MDoc.MDocKind, L, ""
L_MDoc.MDocKindNick(MDoc.MDocKind, 1), L, ""
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.y"
MDoc.Contract, L, ""
MDocList.MDLNbr, L, ""
MDocList.Math, L, ""
MDocList.VATMode, L, L_MDoc.Get_vatm_Pool(0)
MDocList.VAT, R, "2-"
?, L, ""
@
|## ### #######|##########|#######|####|#####|################|##############|###############################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE MakeLine(srcMDocKind: LIKE(MDoc.MDocKind);
                    srcMDoc    : LIKE(MDoc.MDoc);
                    srcDate    : LIKE(MDoc.Date);
                    srcContract: LIKE(MDoc.Contract);
                    trgMDLNbr  : LIKE(MDocList.MDLNbr);
                    trgMath    : LIKE(MDocList.Math);
                    trgMMode   : LIKE(MDocList.MMode);
                    trgVATMode : LIKE(MDocList.VATMode);
                    dstMDocKind: LIKE(MDoc.MDocKind);
                    dstMDoc    : LIKE(MDoc.MDoc);
                    Msg        : STRING[]);
  VAR
   dstMDocKindNick: STRING[];
   trgVATModeStr,
   trgMModeStr: STRING[];
 BEGIN
  ADD(MDocs, MDocs, , srcMDocKind, srcMDoc);
  IF ~!dstMDocKind THEN
   dstMDocKindNick:=L_MDoc.MDocKindNick(dstMDocKind, 1);
   ADD(MDocs, MDocs, , dstMDocKind, dstMDoc);
  ELSE
   dstMDocKindNick:="";
  END;
  SETEMPTY(trgVATModeStr, trgMModeStr);
  IF ~!trgMMode THEN
   trgMModeStr:=L_MathR.MModeStr(trgMMode);
  END;
  IF ~!trgVATMode THEN
   trgVATModeStr:=L_Str.PoolItem(L_MDoc.Get_vatm_Pool(1), trgVATMode);
  END;
  MAKEPART(R, Line, srcMDocKind, L_MDoc.MDocKindNick(srcMDocKind, 1), srcMDoc,
                    srcDate, srcContract, trgMDLNbr, trgMath, trgMModeStr,
                    trgVATModeStr,
                    dstMDocKind, dstMDocKindNick, dstMDoc, Msg);
 END {MakeLine};

 PRIVATE PROCEDURE AddMDLns(trgType: tMDLnsType; Msg: STRING[]);
 BEGIN
  ADD(MDLns, MDLns, , trgType, MDocList.MDocKind, MDocList.MDoc, MDocList.MDLNbr, Msg);
 END {AddMDLns};

 PRIVATE PROCEDURE CheckVATMode();
  VAR
   defVATMode: LIKE(MDocList.VATMode);
 BEGIN
  IF ~!MDocList.VATMode THEN
   defVATMode:=L_MDoc.GetVATModeDefinedByPro(MDoc.Contract, MDoc.CostItem, MDocList.Math, MDocList.Date);
   IF ~!defVATMode & (MDocList.VATMode # defVATMode) THEN
    AddMDLns(mdlt_DefVATModeNotEQ, L_Str.PoolItem(L_MDoc.Get_vatm_Pool(0), defVATMode))
   END;
  END;
 END {CheckVATMode};

 PRIVATE PROCEDURE EQVAT(_VAT1, _VAT2: L_XObj.tSum): SCAL[2];
  VAR
   MiscalculationAllow: SCAL[2];
   Dif: L_XObj.tSum;
 BEGIN
  SAVE(MDocKind);
  CONFORM(MDoc, MDocKind);
  MiscalculationAllow:=L_MDoc.IsPrchMDocKind();
  RESTORE(MDocKind);
  IF MiscalculationAllow THEN
   Dif:=Math.Abs(_VAT1 - _VAT2);
   RETURN (Dif <= 0.01);
  ELSE
   RETURN (_VAT1 = _VAT2);
  END;
 END {EQVAT};

 PRIVATE PROCEDURE CheckVATValue();
  VAR
   curVATRate: L_Pmnt.tVATRates;
 BEGIN
  curVATRate:=L_Pmnt.GetMDocListVATRate();
  IF    curVATRate = L_Pmnt.vr_00 THEN
   AddMDLns(mdlt_vr_00, "");
  ELSIF (curVATRate = L_Pmnt.vr_20) |
        (curVATRate = L_Pmnt.vr_10) |
        (curVATRate = L_Pmnt.vr_18) |
        (curVATRate = L_Pmnt.vr_UK) THEN
   IF ~L_MDoc.MDocListVATPossible() THEN
    AddMDLns(mdlt_MustBeWithoutVAT, "");
   ELSIF ~EQVAT(MDocList.VAT, L_Acnt.GetExclMathVAT(MDocList.Math, MDoc.Date, MDocList.Sum)) &
         ~EQVAT(MDocList.VAT, L_Acnt.GetInclMathVAT(MDocList.Math, MDoc.Date, MDocList.Sum+MDocList.VAT)) THEN
    AddMDLns(mdlt_CalculatedNotEQ, FLDTOSTR(L_Acnt.GetExclMathVAT(MDocList.Math, MDoc.Date, MDocList.Sum), "2-", 31));
   END;
  ELSE
   L_General.CallUs((curVATRate = L_Pmnt.vr_NV) |
                    (curVATRate = L_Pmnt.vroNV));
  END;
 END {CheckVATValue};

 PRIVATE PROCEDURE CheckMDocListVAT();
  VAR
   Msg: STRING[];
 BEGIN
  SAVE(MDoc);
  CONFORM(MDocList, MDoc);
  CheckVATMode();
  CheckVATValue();
  RESTORE(MDoc);
 END {CheckMDocListVAT};

 PRIVATE PROCEDURE MakeOneMDoc();
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
   curMDocKind,
   dstMDocKind   : LIKE(MDoc.MDocKind);
   curMDoc,
   dstMDoc       : LIKE(MDoc.MDoc);
   curDate       : LIKE(MDoc.Date);
   curContract   : LIKE(MDoc.Contract);
   curMDLNbr     : LIKE(MDocList.MDLNbr);
   specMath      : LIKE(MDocList.Math);
   curMMode      : LIKE(MDocList.MMode);
   curCstDclr    : LIKE(MDocList.CstDclr);
   Msg           : STRING[];
   CheckedNbr    : LIKE(MDocList.MDLNbr)[MAXOF(MDocList.MDLNbr)];
   HasVATMDoc,
   NeedCondenseMDL: SCAL[2];
 BEGIN
  PROMPT(L_MDoc.GetMDocStrNbr());
  IF P_MDoc.DoSpecVATMDoc(MDoc.MDocKind, MDoc.MDoc) = P_MDoc.dsvmd_Auto THEN
   curMDocKind:=MDoc.MDocKind;
   curMDoc    :=MDoc.MDoc;
   curDate    :=MDoc.Date;
   curContract:=MDoc.Contract;
   SAVE(MDoc);
   HasVATMDoc:=0;
   i:=0;
   DependentMDocs:=L_MDoc.GetDependentMDocXDC();
   WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
    IF L_Pmnt.IsVATMDocKind(MDoc.MDocKind) &
       (MDoc.Status # L_MDoc.st_Canceled) &
       L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Acceptance) THEN
     IF HasVATMDoc THEN
      MakeLine(curMDocKind, curMDoc, curDate, curContract,
               L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(),
               L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(),
               MDoc.MDocKind, MDoc.MDoc,
               "᪮쪮 ");
     END;
     IF L_MDoc.CalculateVAT() = L_MDoc.cvat_Impossible THEN
      MakeLine(curMDocKind, curMDoc, curDate, curContract,
               L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(),
               L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(),
               MDoc.MDocKind, MDoc.MDoc,
               "     ");
     END;
     HasVATMDoc:=1;
     dstMDocKind:=MDoc.MDocKind;
     dstMDoc    :=MDoc.MDoc;
     IF curDate # MDoc.Date THEN
      MakeLine(curMDocKind, curMDoc, curDate, curContract,
               L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(),
               L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(),
               MDoc.MDocKind, MDoc.MDoc,
               " ᮢ ");
     END;
     specMath:=P_Cntr.GetCntrProSoft(MDoc.Contract, MDoc.Date, P_Cntr.P_SingleMath);
     NeedCondenseMDL:=L_Pmnt.NeedCondenseSingleMathMDocList(specMath, MDoc.Contract);
 
     curMDLNbr:=0;
     SETZERO(CheckedNbr);

     SETSEL(_CMDL, _CMDL);
     REMSEL(_CMDL);
     SELECT(MDocList, MDoc, , curMDocKind, curMDoc);
     WHILE OCCURE(MDocList) DO
      Msg:="";
      IF ~!specMath & (MDocList.Math # specMath) THEN
       Msg:=specMath+"   - . । ";
      END;
      IF L_Pmnt.IsAcptToVATMDocList() THEN
       CheckMDocListVAT();
       IF NeedCondenseMDL THEN
        curMDLNbr:=1;
        curMMode:=L_MathR.mm_New;
       ELSIF (MDocKind.Dir = L_MDoc.mdd_Outgoing) THEN
        INC(curMDLNbr);
        curMMode:=MDocList.MMode;
       ELSE
        SETEMPTY(curMDLNbr);
        curMMode:=MDocList.MMode;
        L_General.CallUs(!MDocList.CstDclr); (*室騩  㧪 - 㤠 ?*)
       END;
       IF !MDocList.CstDclr & L_Pmnt.E_MDocListMustHasCstDclr() THEN
        Msg:=" 室   㪠 ";
       END;
       ADD(_CMDL, _CMDL, , curMDLNbr, MDocList.Math, curMMode, MDocList.VATMode, MDocList.CstDclr,
                           _CMDL.HasAcpMD, 1,
                           _CMDL.HasVATMD, 0,
                           _CMDL.Netto, MDocList.Sum,
                           _CMDL.VAT,   MDocList.VAT);
      END;
      IF ~!Msg THEN
       MakeLine(curMDocKind, curMDoc, curDate, curContract,
                MDocList.MDLNbr, MDocList.Math, MDocList.MMode, MDocList.VATMode,
                MDoc.MDocKind, MDoc.MDoc, Msg);
      END;
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList) ... *)
     SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
     WHILE OCCURE(MDocList) DO
      Msg:="";
      IF MDocKind.Dir = L_MDoc.mdd_Outgoing THEN
       curMDLNbr:=MDocList.MDLNbr;
       IF ~SELECT(_CMDL, _CMDL, MDocList.MDLNbr) THEN
        MakeLine(curMDocKind, curMDoc, curDate, curContract,
                 MDocList.MDLNbr, MDocList.Math, MDocList.MMode, MDocList.VATMode,
                 MDoc.MDocKind, MDoc.MDoc, " ப");
       ELSE
        IF    _CMDL.Math # MDocList.Math THEN
         Msg:="㣮  : "+MDocList.Math;
        ELSIF _CMDL.MMode # MDocList.MMode THEN
         Msg:=" ᮢ ०: '"+L_MathR.MModeStr(MDocList.MMode)+"'";
        ELSIF _CMDL.VATMode # MDocList.VATMode THEN
         Msg:=" ᮢ ᯮᮡ  ";
        ELSIF _CMDL.VAT # MDocList.VAT THEN
         Msg:=" ᮢ ";
        ELSIF _CMDL.Netto # MDocList.Sum THEN
         Msg:=" ᮢ 㬬";
        ELSIF L_Pmnt.E_MDocListMustHasCstDclr() THEN
         IF !MDocList.CstDclr THEN
          Msg:=" 易   㪠 ";
         ELSIF ~!_CMDL.CstDclr & (_CMDL.CstDclr # MDocList.CstDclr) THEN
          Msg:=" ᮢ ";
         END;
        END;
        IF ~!Msg THEN
         MakeLine(curMDocKind, curMDoc, curDate, curContract,
                  _CMDL.MDLNbr, _CMDL.Math, _CMDL.MMode, _CMDL.VATMode,
                  MDoc.MDocKind, MDoc.MDoc, Msg);
        END;
        REMOVE(_CMDL);
       END;
      ELSE
       SETEMPTY(curMDLNbr, curCstDclr);
       ADD(_CMDL, _CMDL, , curMDLNbr, MDocList.Math, MDocList.MMode, MDocList.VATMode, curCstDclr,
                           _CMDL.HasAcpMD, 0,
                           _CMDL.HasVATMD, 1,
                           _CMDL.Netto, -MDocList.Sum,
                           _CMDL.VAT,   -MDocList.VAT);
      END;
      NEXT(MDocList);
     END;
     SELECT(_CMDL, _CMDL);
     WHILE OCCURE(_CMDL) DO
      Msg:="";
      IF    _CMDL.HasAcpMD = 0 THEN
       Msg:=" ப";
      ELSIF _CMDL.HasVATMD = 0 THEN
       Msg:=" ⠪ ப";
      ELSIF (_CMDL.Netto # 0) & (_CMDL.VAT # 0) THEN
       Msg:=" ᮢ 㬬  ";
      ELSIF (_CMDL.Netto # 0) THEN
       Msg:=" ᮢ 㬬";
      ELSIF (_CMDL.VAT # 0) THEN
       Msg:=" ᮢ ";
      END;
      IF ~!Msg THEN
       MakeLine(curMDocKind, curMDoc, curDate, curContract,
                _CMDL.MDLNbr, _CMDL.Math, _CMDL.MMode, _CMDL.VATMode,
                MDoc.MDocKind, MDoc.MDoc, Msg);
      END;
      NEXT(_CMDL);
     END; (* WHILE OCCURE(_CMDL) ... *)

    END;
    INC(i);
   END;
   RESTORE(MDoc);
   IF ~HasVATMDoc & (MDoc.Status = L_MDoc.st_Passed) THEN
    IF L_Pmnt.NeedOnlineVATMDoc() THEN
     MakeLine(curMDocKind, curMDoc, curDate, curContract,
              L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(),
              L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(),
              L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(),
              " ନ஢ 㬥   ");
    END;
   ELSIF HasVATMDoc & (MDoc.Status = L_MDoc.st_Canceled) THEN
    MakeLine(curMDocKind, curMDoc, curDate, curContract,
             L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(),
             L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(),
             dstMDocKind, dstMDoc,
             ". 㬥 㫨஢");
   END;
  END;
 END {MakeOneMDoc};

 PRIVATE PROCEDURE MakeRep(RepName: STRING[]; Cond: tCond);
  VAR
   CurContract: LIKE(Contract.Contract);
   oPrompt: PROMPTLINE;
   i: NUMERIC[0];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  oPrompt:=PROMPTLINE.Create(RepName);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  IF Cond = byContract THEN
   L_General.Assert(ACCESS(Contract), " ࠭ ");
   CurContract:=Contract.Contract;
   MAKEPART(R, TopContract);
  END;
 
  MAKEPART(R, Top1);
 
  L_AFM.MakeIndex("MDocs", "MDocKind: LIKE(MDoc.MDocKind);"+
                           "MDoc    : LIKE(MDoc.MDoc)");
 
  L_AFM.MakeIndex("MDLns", "Type    : "+GET_TYPE_SPEC(tMDLnsType).Name+";"+
                           "MDocKind: LIKE(MDocList.MDocKind);"+
                           "MDoc    : LIKE(MDocList.MDoc);"+
                           "MDLNbr  : LIKE(MDocList.MDLNbr);"+
                           "Msg     : STRING[64]");
 
  L_AFM.MakeMultipleIndex("_CMDL", "MDLNbr  : LIKE(MDocList.MDLNbr);"+
                                   "Math    : LIKE(MDocList.Math);"+
                                   "MMode   : LIKE(MDocList.MMode);"+
                                   "VATMode : LIKE(MDocList.VATMode);"+
                                   "CstDclr : LIKE(MDocList.CstDclr);"+
                                   "HasAcpMD: NUMERIC[0];"+
                                   "HasVATMD: NUMERIC[0];"+
                                   "Netto   : LIKE(MDocList.Sum);"+
                                   "VAT     : LIKE(MDocList.VAT)",
                                "_CMDL: MDLNbr, Math, MMode, VATMode, CstDclr");
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF L_Pmnt.IsAcptMDocKind(MDocKind.MDocKind) THEN
    IF    Cond = byAll THEN
     SETSEL(MDoc, MDKDate, MDocKind.MDocKind);
    ELSIF Cond = byContract THEN
     SETSEL(MDoc, Contract, CurContract, MDocKind.MDocKind);
    ELSE
     L_General.CallUs(0);
    END;
    SRCINSEL(MDoc, GE, , Memo.ud_fr());
    WHILE OCCURE(MDoc) & (MDoc.Date<=Memo.ud_ut()) DO
     MakeOneMDoc();
     NEXT(MDoc);
    END; (* WHILE OCCURE(MDoc) ... *)
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
 
  L_XDoc.sl_Init(" 㬥");
 
  SELECT(MDocs, MDocs);
  WHILE OCCURE(MDocs) DO
   SEARCH(MDoc, MDoc, , MDocs.MDocKind, MDocs.MDoc);
   CONFORM(MDoc, Dest);
   L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc),
                     "1 "+
                     L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) +
                     " " + L_DatTim.DateStr(MDoc.Date) +
                     " " + MDoc.Contract +
                     " " + MDoc.Firm +
                     " " + Dest.Dest + " " + Str.Align(Dest.Name, 20, LEFT));
   NEXT(MDocs);
  END; (* WHILE OCCURE(MDocs) ... *)
 
  i:=1;
  SELECT(MDLns, MDLns);
  WHILE OCCURE(MDLns) DO
   INC(i);
   MAKEPART(R, Top2, L_Str.PoolItem(mdlt_Headers[MDLns.Type], 0), L_Str.PoolItem(mdlt_Headers[MDLns.Type], 1));
   NARROWSEL(MDLns, Type);
   WHILE OCCURE(MDLns) DO
    SEARCH(MDocList, MDoc, , MDLns.MDocKind, MDLns.MDoc, MDLns.MDLNbr);
    CONFORM(MDocList, MDoc);
    MAKEPART(R, Line2, MDLns.Msg);
  
    CONFORM(MDoc, Dest);
    L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc),
                      L_Str.IntStr(i)+" "+
                      L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) +
                      " " + L_DatTim.DateStr(MDoc.Date) +
                      " " + Dest.Dest + " " + Str.Align(Dest.Name, 20, LEFT));
    NEXT(MDLns);
   END; (* WHILE OCCURE(MDLns) ... *)
   NEXTINEXTENDEDSEL(MDLns, Type);
  END; (* WHILE OCCURE(MDLns) ... *)
 
  L_AFM.AF_PurgeTemp("_CMDL");
  L_AFM.AF_PurgeTemp("MDLns");
  L_AFM.AF_PurgeTemp("MDocs");
  MAKEPART(R, Bot);
  CLOSEREP(R);
 
  L_XDoc.sl_Done();
 END {MakeRep};

 PUBLIC PROCEDURE CCVAT();
 BEGIN
  MakeRep("CCVAT", byContract);
 END {CCVAT};

 PUBLIC PROCEDURE ChVAT();
 BEGIN
  MakeRep("ChVAT", byAll);
 END {ChVAT};

BEGIN
 IF    MODE = 100 THEN
  ChVAT()
 ELSIF MODE = 101 THEN
  CCVAT();
 ELSE
  L_General.BadMode(MODE);
 END;
END.
