(*
%Copyright   (c) Polak Computer System
%Author      08.11.2001 18:07:39 GAV
%Purpose     ஢ઠ    
%Type        report
%Specific    AP
%Modified    24.01.2013 10:34:19 POLAK\Gina
%Environment
*)

 MODULE Ch_Man [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_DatTim, L_Str, L_Env, L_StdFrm, Memo, Str, L_Man, L_Russia;

 CONST
  RepName = "ChMan";

 PRIVATE VAR
  RepTitle: STRING[];
  numErr  : SCAL[1E2];

(*
$P{Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), R, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
RepTitle, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|᪮             |஡                                                                        |
}
*)

(*
$P{TopLine:
Man.Man, R, ""
L_Str.ShortName(Man.Name), L, ""
L_Str.IntStr(numErr), R, ""
?, L, ""
@
|---------------------------|--------------------------------------------------------------------------------|
|##### #####################|## #############################################################################|
}
*)

(*
$P{Line:
?, R, ""
?, L, ""
@
|                           |## #############################################################################|
}
*)

(*
$P{Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE MakeLine(ErrorStr: STRING[]);
  VAR
   ErrorStrArray: STRING[][10];
   Idx          : NUMERIC[0];
 BEGIN
  ErrorStr:=Str.Replace(ErrorStr, "|", " ");
  SETEMPTY(ErrorStrArray);
  INC(numErr);
  L_Str.SplitStr(ErrorStrArray, ErrorStr, 77, 10);
  Idx:=0;
  WHILE ~!ErrorStrArray[Idx] DO
   IF (Idx = 0) & (numErr = 1) THEN
    MAKEPART(R, TopLine, ErrorStrArray[Idx]);
   ELSE
    IF Idx = 0 THEN
     MAKEPART(R, Line, L_Str.IntStr(numErr), ErrorStrArray[Idx]);
    ELSE
     MAKEPART(R, Line, , ErrorStrArray[Idx]);
    END;
   END;
   INC(Idx);
  END;
 END {MakeLine};

 PRIVATE PROCEDURE TestImpossible();
 BEGIN
  IF !Man.Birth THEN
   MakeLine("   ஦");
  END;
  IF !Man.Sex THEN
   MakeLine("  ");
  END;
  IF !Man.Name THEN
   MakeLine("   ");
  END;
  IF !Man.FmlState THEN
   MakeLine("  ᥬ ");
  END;
 END {TestImpossible};

 PRIVATE PROCEDURE GetAdrDate(): STRING[];
 BEGIN
  IF (ManAdr.AdrType = L_Russia.at_RgMA) | (ManAdr.AdrType = L_Russia.at_DwMA) THEN
   RETURN "  "+L_DatTim.DateStr(ManAdr.Date);
  ELSE
   RETURN "";
  END;
 END {GetAdrDate};

 PUBLIC PROCEDURE Ch_Man();
  VAR
   SkipOldLvd,
   SkipOldAdr : SCAL[2];
 BEGIN
  SkipOldLvd:=0;
  SkipOldAdr:=0;
  STDFORM(L_StdFrm.sf_Choice("|:     %####################################%" +
                             "|" +
                             "|: %####################################%",
                             "%<஢ | ஢ 㢮  " + L_DatTim.DateStr(Memo.ud_cd()) + ">I"+
                             "%<஢ | ஢   " + L_DatTim.DateStr(Memo.ud_cd()) + ">I"),
          " ஢ઠ     ", , 1,
          SkipOldLvd, SkipOldAdr);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepTitle:="஡    ";
  IF SkipOldLvd | SkipOldAdr THEN
   RepTitle:=RepTitle + " (஬ ";
   IF SkipOldLvd & SkipOldAdr THEN
    RepTitle:=RepTitle + " ᮢ  㢮";
   ELSIF SkipOldLvd THEN
    RepTitle:=RepTitle + "㢮";
   ELSE
    RepTitle:=RepTitle + "ᮢ, ";
   END;
   RepTitle:=RepTitle + "  " + L_DatTim.DateStr(Memo.ud_cd()) + ")";
  END;

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top);
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   PROMPT(L_Man.Man_ManAsStr());
   numErr:=0;
   SELECT(Staff, Man, , Man.Man);
   WHILE OCCURE(Staff) & SkipOldLvd & (Staff.EndDate < Memo.ud_cd()) DO
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   IF OCCURE(Staff) & L_Env.RealTSN(Staff.TSN) THEN
    TestImpossible();
    IF ~SELECT(ManAdr, Man, Man.Man) THEN
     MakeLine("   ");
    ELSE
     WHILE OCCURE(ManAdr) DO
      IF ~SkipOldAdr | (ManAdr.EndDate > Memo.ud_cd()) THEN
       TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
        CALL(ManAdr.ManAdr_AfterEdIns());
       EXCEPT
       ON Exc: Exc_Raise DO
        MakeLine(L_Str.PoolItem("|․|․|ত", ManAdr.AdrType) + GetAdrDate() + ": " + Exc.Description);
       END; (* TRY *)
      END;
      NEXT(ManAdr);
     END; (* WHILE OCCURE(ManAdr)... *)
    END;
    TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
     CALL(Man.CheckAllData());
    EXCEPT
    ON Exc: Exc_Raise DO
     MakeLine(Exc.Description);
    ON Exc: Exc_RunTime DO
     MakeLine(Exc.Description);
    END; (* TRY *)
   END;
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {Ch_Man};

END.
