(*
%Copyright   (c) Polak IT
%Author      24.02.2013 18:09:00 POLAK\MLB
%Purpose
%Type        operation
%Specific    SYS
%Modified    09.01.2014 13:03:48 POLAK\MLB
%Environment
*)

 MODULE clnd [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_GUI, L_General, L_Str, L_DatTim, L_AFM, Str, L_Hld;

 PRIVATE CONST
  DayTypeAmnt = 5;

 PRIVATE TYPE
  tDayType = SCAL[DayTypeAmnt];

 PRIVATE CONST
  pPool    = "Date|Month|Year|Decade|Century|Calc|Main";
  pDate    = 0;
  pMonth   = 1;
  pYear    = 2;
  pDecade  = 3;
  pCentury = 4;
  pCalc    = 5;
  pMain    = 6;
  id_ClndBig    = "BigClnd";
  id_ClndSrc    = "SrcClnd";
  id_ClndRes    = "ResClnd";
  id_Calc       = "pb_Calc";
  id_STSrcDate  = "st_SrcDate";
  id_STResDate  = "st_ResDate";
  id_EInputDate = "e_InputDate";
  id_EResDate   = "e_ResDate";
  id_STOffset   = "st_Offset";
  id_Offset     = "e_Offset";
  id_Days       = "e_Days";

  refreshCycle_Renew = 1;

  clnd_MinDate = 01\01\1900;
  clnd_MaxDate = 31\12\2999;
  MaxMonthAmnt = 3;

  clnd_ColumnInMonth      = 7;
  clnd_RowInMonth         = 6;
  clnd_btnAmount          = clnd_ColumnInMonth * clnd_RowInMonth;
  clnd_BodyColumnsAmount  = 4;
  clnd_BodyRowsAmount     = 3;
  clnd_BodyBtnAmount      = clnd_BodyColumnsAmount*clnd_BodyRowsAmount;


  sW_MainShift     = 2;
  sH_MainShift     = 2;
  sW_SpaceBtwMonth = 10;
  sW_SpaceBtwPrevNext     = 10;
  sW_SpaceBtwBodyBtns     = 1;
  sH_SpaceBtwBodyBtns     = 1;
  sH_SpaceBtwMonthWeekDay = 1;

  dt_Pool      = "ࠡ稩|ࠧ|७ᥭ 室|७ᥭ ࠡ稩|室";
  dt_FontWeight = [FONT.Weight_Normal, FONT.Weight_Bold, FONT.Weight_Bold, FONT.Weight_Bold, FONT.Weight_Bold];
  dt_WorkDay   = 0; (* tDayDype *)
  dt_Holiday   = 1;
  dt_TransHol  = 2;
  dt_TransWork = 3;
  dt_Rest      = 4;

  os_Pool       = " | ";
  os_IncWorkD   = 0;
  os_IncCalD    = 1;

  ct_Calc  = "=";
  ct_Close = ""; (*   Wingdings 2*)

 PRIVATE PERMANENT VAR
  dlg               : DIALOG;
  CurClndId         : STRING[];
  PermDate          : DATE;
  PermPageId,
  PermMonthIdx      : NUMERIC[0];
  dlgPagesCollection: OBJECT;

 PRIVATE VAR
  HRT_Renew      : FLOAT;
  clTitleBtn,
  clTitleBtnF,
  clBlack,
  clGray,
  clAqua,
  clBabyBlue,
  clWhite,
  clNumeric,
  clDate         : RGBCOLOR;
  bfs,
  pPoolCntItems  : NUMERIC[0];
  dt_ArrColor    : RGBCOLOR[DayTypeAmnt];
  sW,
  sH,
  sW_Month,
  fs_DayBtn,
  fs_MonthBtn,
  fs_YearBtn,
  fs_DecadeBtn,
  fS_CalcBtn,
  fS_CalcEdit,
  fS_CalcST,
  fS_CalcDays    : FLOAT;
  ResDate        : DATE;
  NeedRepaintDlg : SCAL[2];

 PRIVATE PROCEDURE getControl(Id: STRING[]): CONTROL;
 BEGIN
  RETURN dlg.Controls.Item(Id);
 END {getControl};

 PRIVATE PROCEDURE CreateColorsAndSizes();
  VAR
   clRed,
   clDarkRed,
   clLightRed: RGBCOLOR;
 BEGIN
  clBlack    :=RGBCOLOR.Create(0,     0,   0);
  clGray     :=RGBCOLOR.Create(195, 195, 195);
  clBabyBlue :=RGBCOLOR.Create(224,  255, 255);
  clAqua     :=RGBCOLOR.Create(00,  255, 255);
  clWhite    :=RGBCOLOR.Create(255, 255, 255);
  clRed      :=RGBCOLOR.Create(255,   0,   0);
  clDarkRed  :=RGBCOLOR.Create(160,   0,   0);
  clLightRed :=RGBCOLOR.Create(255,  90,  90);
  clDate     :=RGBCOLOR.Create(128,  00,  00);
  clNumeric  :=RGBCOLOR.Create(00,  128,  00);
  clTitleBtn :=RGBCOLOR.Create();
  clTitleBtnF:=RGBCOLOR.Create();
  clTitleBtn :=clWhite;
  clTitleBtnF:=clBlack;

  dt_ArrColor[dt_WorkDay]  :=clBlack;
  dt_ArrColor[dt_Holiday]  :=clRed;
  dt_ArrColor[dt_TransHol] :=clDarkRed;
  dt_ArrColor[dt_TransWork]:=clBlack;
  dt_ArrColor[dt_Rest]     :=clLightRed;

  bfs          := APP.Get().BasicFontSize;
  fs_DayBtn    := bfs*1.5;
  fs_MonthBtn  := bfs*1.6;
  fs_YearBtn   := bfs*1.6;
  fs_DecadeBtn := bfs*1.6;
  fS_CalcBtn   := bfs*1.5;
  fS_CalcEdit  := bfs*1.2;
  fS_CalcST    := bfs*1.46;
  fS_CalcDays  := bfs*2.0
 END {CreateColorsAndSizes};

 PRIVATE PROCEDURE GetPStr(Idx: NUMERIC[0]): STRING[];
 BEGIN
  L_General.CallUs(Idx < pPoolCntItems);
  RETURN L_Str.PoolItem(pPool, Idx);
 END {GetPStr};

 PRIVATE PROCEDURE GetObjectClndId(ObjectId: STRING[]): STRING[];
 BEGIN
  RETURN Str.Item(ObjectId, "_", 0);
 END {GetObjectClndId};

 PRIVATE PROCEDURE GetPId(PStr: STRING[]): NUMERIC[0];
 BEGIN
  RETURN L_Str.PositionInPool(pPool, PStr);
 END {GetPId};

 PRIVATE PROCEDURE GetObjectClndPageId(ObjectId: STRING[]): NUMERIC[0];
 BEGIN
  RETURN GetPId(Str.Item(ObjectId, "_", 1));
 END {GetObjectClndPageId};

 PRIVATE PROCEDURE GetObjectClndMonthIdx(ObjectId: STRING[]): NUMERIC[0];
 BEGIN
  RETURN STRTOFLD(Str.Item(ObjectId, "_", 2), NUMERIC);
 END {GetObjectClndMonthIdx};

 PRIVATE PROCEDURE GetObjectClndBodyBtnIdx(ObjectId: STRING[]): NUMERIC[0];
 BEGIN
  RETURN STRTOFLD(Str.Item(ObjectId, "_", 3), NUMERIC);
 END {GetObjectClndBodyBtnIdx};

 PRIVATE PROCEDURE clnd_GetTitleBtnId(clnd_Id, Prefix: STRING[]; IdxMonth: NUMERIC[0]): STRING[];
 BEGIN
  RETURN clnd_Id + "_" + Prefix + "_" + L_Str.IntStr(IdxMonth);
 END {clnd_GetTitleBtnId};

 PRIVATE PROCEDURE clnd_GetBodyBtnId(clnd_Id, Prefix: STRING[]; IdxMonth, IdxBodyBtn: NUMERIC[0]): STRING[];
 BEGIN
  RETURN clnd_Id + "_" + Prefix + "_" + L_Str.IntStr(IdxMonth) + "_" + L_Str.IntStr(IdxBodyBtn);
 END {clnd_GetBodyBtnId};

 PRIVATE PROCEDURE PosToClnd(clnd_Id: STRING[]);
 BEGIN
  L_General.CallUs(SEARCH(clnd, Id, clnd_Id));
 END {PosToClnd};

 PRIVATE PROCEDURE clnd_GetDateFromBtn(SLF: OBJECT): DATE;
  VAR
   CurMonthBeg: DATE;
   WD         : L_DatTim.tWeekday;
 BEGIN
  L_General.CallUs(GetObjectClndPageId(SLF.Id) = pDate);
  CurMonthBeg:=L_DatTim.MonthBeg(L_DatTim.IncMonth(clnd.MinD, GetObjectClndMonthIdx(SLF.Id)));
  WD         :=L_DatTim.WEEKDAY(CurMonthBeg);
  RETURN CurMonthBeg - 7*(WD = L_DatTim.wd_Mon) - WD + GetObjectClndBodyBtnIdx(SLF.Id);
 END {clnd_GetDateFromBtn};

 PRIVATE PROCEDURE GetClndWD(D: DATE): tDayType;
  VAR
   WD,
   WDTrans  : L_DatTim.tWeekday;
   IsWorkDay,
   WasWorkDay,
   IsHoliday: SCAL[2];
 BEGIN
  IF SEARCH(ClndWD, D, D) THEN
   RETURN ClndWD.DayType;
  ELSE
   WD        :=L_DatTim.WEEKDAY(D);
   WDTrans   :=L_Hld.WeekDay_TransfersConsidered(D);
   WasWorkDay:=WD      <= L_DatTim.wd_Fri;
   IsWorkDay :=WDTrans <= L_DatTim.wd_Fri;
   IsHoliday :=WDTrans  = L_DatTim.wd_Hol;

   IF    WasWorkDay & IsWorkDay  THEN ClndWD.DayType:=dt_WorkDay;
   ELSIF IsHoliday               THEN ClndWD.DayType:=dt_Holiday;
   ELSIF WasWorkDay & ~IsWorkDay THEN ClndWD.DayType:=dt_TransHol;
   ELSIF ~WasWorkDay & IsWorkDay THEN ClndWD.DayType:=dt_TransWork;
   ELSIF ~WasWorkDay             THEN ClndWD.DayType:=dt_Rest;
   ELSE                               L_General.CallUs(0);
   END;

   ClndWD.D:=D;
   INSERT(ClndWD);
   RETURN ClndWD.DayType;
  END;
 END {GetClndWD};

 PRIVATE PROCEDURE clnd_SetBtnColor(SLF: OBJECT; Selected: SCAL[2]; IsCurMonth: SCAL[2]);
  VAR
   D        : DATE;
   FontSizeStndrt,
   PageId   : NUMERIC[0];
   DayType  : tDayType;
   color    : RGBCOLOR;
 BEGIN
  PageId:=GetObjectClndPageId(SLF.Id);
  IF    PageId = pDate   THEN FontSizeStndrt:=fs_DayBtn;
  ELSIF PageId = pMonth  THEN FontSizeStndrt:=fs_MonthBtn;
  ELSIF PageId = pYear   THEN FontSizeStndrt:=fs_YearBtn;
  ELSIF PageId = pDecade THEN FontSizeStndrt:=fs_DecadeBtn;
  ELSE
   L_General.CallUs(0);
  END;
  IF Selected & IsCurMonth THEN
   L_GUI.SetControlBkColor(SLF, clAqua);
   L_GUI.SetControlFgColor(SLF, clBlack);
   SLF.Style.Font.Size:=FontSizeStndrt;
   IF PageId = pDate THEN
    D              :=clnd_GetDateFromBtn(SLF);
    SLF.ToolTipText:=L_DatTim.DateStr(D);
   END;
  ELSE
   L_GUI.SetControlBkColor(SLF, clWhite);
   IF ~IsCurMonth THEN
    L_GUI.SetControlFgColor(SLF, clGray);
    SLF.Style.Font.Size  :=FontSizeStndrt*0.80;
    SLF.Style.Font.Weight:=FONT.Weight_Normal;
    IF PageId = pDate THEN
     D              :=clnd_GetDateFromBtn(SLF);
     SLF.ToolTipText:=L_DatTim.DateStr(D);
    END;
   ELSE
    SLF.Style.Font.Size:=FontSizeStndrt;
    IF PageId = pDate THEN
     D                    :=clnd_GetDateFromBtn(SLF);
     DayType              :=GetClndWD(D);
     color                :=dt_ArrColor[DayType];
     SLF.ToolTipText      :=L_DatTim.DateStr(D) + " " + L_Str.PoolItem(dt_Pool, DayType) + " ";
     SLF.Style.Font.Weight:=dt_FontWeight[DayType];
     IF D = SYSDATE() THEN
      L_GUI.SetControlBkColor(SLF, clBabyBlue);
     END;
    ELSE
     color:=clBlack;
    END; (* IF PageId = pDate ... *)
    L_GUI.SetControlFgColor(SLF, color);
   END;
  END;
 END {clnd_SetBtnColor};

 PRIVATE PROCEDURE clnd_FindBtnByDate(D: DATE; clnd_Id: STRING[]): OBJECT;
  VAR
   WD      : L_DatTim.tWeekday;
   IdxMonth,
   IdxDay  : NUMERIC[0];
   Result  : OBJECT;
 BEGIN
  PosToClnd(clnd_Id);
  IF (D >= clnd.MinD) & (D <= clnd.MaxD) THEN
   IdxMonth:=L_DatTim.MONTH(D) - L_DatTim.MONTH(clnd.MinD);
   IF IdxMonth < 0 THEN
    INC(IdxMonth, 12);
   END;
   WD    :=L_DatTim.WEEKDAY(L_DatTim.MonthBeg(D));
   IdxDay:=7*(WD = L_DatTim.wd_Mon) + WD + L_DatTim.DAY(D) - 1;
   Result:=getControl(clnd_GetBodyBtnId(clnd.Id, GetPStr(pDate), IdxMonth, IdxDay));
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {clnd_FindBtnByDate};

 PRIVATE PROCEDURE clnd_UpdateMinMaxDates(MonthIdx, PageId: NUMERIC[0]);
  CONST
   YearAmntArr = [0, 1, 10, 100];
 BEGIN
  IF    PageId = pDate   THEN
   clnd.MinD:=L_DatTim.MonthBeg(L_DatTim.IncMonth(clnd.D, -MonthIdx));
   clnd.MaxD:=L_DatTim.MonthEnd(L_DatTim.IncMonth(clnd.D,  MonthIdx));
   IF clnd.Id = id_ClndBig THEN
    PermMonthIdx:=MonthIdx;
   END;
  ELSE
   clnd.MinD:=L_DatTim.IncYear(clnd.D, -MonthIdx*YearAmntArr[PageId]);
   clnd.MaxD:=L_DatTim.IncYear(clnd.D, (clnd.MonthAmnt - MonthIdx - 1)*YearAmntArr[PageId]);
   IF    PageId = pMonth   THEN
    clnd.MinD:=L_DatTim.YearBeg(clnd.MinD);
    clnd.MaxD:=L_DatTim.YearEnd(clnd.MaxD);
   ELSIF PageId = pYear  THEN
    clnd.MinD:=L_DatTim.DecadeBeg(clnd.MinD);
    clnd.MaxD:=L_DatTim.DecadeEnd(clnd.MaxD);
   ELSIF PageId = pDecade THEN
    clnd.MinD:=L_DatTim.CenturyBeg(clnd.MinD);
    clnd.MaxD:=L_DatTim.CenturyEnd(clnd.MaxD);
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {clnd_UpdateMinMaxDates};

 PRIVATE PROCEDURE clnd_UpdateControls(Page: NUMERIC[0]; clnd_Id: STRING[]; NeedRedraw: SCAL[2]);
  VAR
   IdxDay,
   IdxMonth,
   IdxYear,
   IdxDecade,
   IdxCentury: NUMERIC[0];
   D         : DATE;
   pb        : CONTROL;
   BodyPStr  : STRING[];
   CurMonth  : L_DatTim.tMonth;
   CurYear   : NUMERIC[0];
 BEGIN
  PosToClnd(clnd_Id);
  BodyPStr:=GetPStr(Page);
  IF clnd_Id # id_ClndRes THEN
   getControl(clnd.Id + "_Prev" + GetPStr(Page+1)).Enable:=(clnd.MinD > clnd_MinDate);
   getControl(clnd.Id + "_Next" + GetPStr(Page+1)).Enable:=(clnd.MaxD < clnd_MaxDate);
  END;
  IF    Page = pDate   THEN
   IdxMonth:=0;
   D       :=clnd.MinD;
   WHILE IdxMonth < clnd.MonthAmnt DO
    D:=L_DatTim.IncMonth(clnd.MinD, IdxMonth);
    SetTitleBtnText(Page, clnd.Id, IdxMonth, D);
    D:=D-7*(L_DatTim.WEEKDAY(D)=L_DatTim.wd_Mon)-L_DatTim.WEEKDAY(D);
    L_General.CallUs(L_DatTim.WEEKDAY(D)=L_DatTim.wd_Mon);
    CurMonth:=L_DatTim.MONTH(L_DatTim.IncMonth(clnd.MinD, IdxMonth));
    IdxDay  :=0;
    WHILE IdxDay < clnd_btnAmount DO
     pb            :=getControl(clnd_GetBodyBtnId(clnd.Id, BodyPStr, IdxMonth, IdxDay));
     pb.Text       :=L_Str.IntStr(L_DatTim.DAY(D));
     clnd_SetBtnColor(pb, D = clnd.D, CurMonth = L_DatTim.MONTH(D));
     pb.Enable:=(D >= clnd_MinDate) & (D <= clnd_MaxDate);
     INC(D);
     INC(IdxDay);
    END; (* WHILE IdxDay < ... *)
    INC(IdxMonth);
   END; (* WHILE IdxMonth ... *)
  ELSIF Page = pMonth  THEN
   CurMonth:=L_DatTim.MONTH(clnd.D);
   CurYear :=L_DatTim.YEAR(clnd.D);
   D       :=L_DatTim.YearBeg(clnd.MinD);
   IdxYear :=0;
   WHILE IdxYear < clnd.MonthAmnt DO
    D:=L_DatTim.IncYear(L_DatTim.YearBeg(clnd.MinD), IdxYear);
    SetTitleBtnText(Page, clnd.Id, IdxYear, D);
    IdxMonth:=0;
    WHILE IdxMonth < clnd_BodyBtnAmount DO
     D      :=L_DatTim.IncMonth(L_DatTim.IncYear(L_DatTim.YearBeg(clnd.MinD), IdxYear), IdxMonth);
     pb     :=getControl(clnd_GetBodyBtnId(clnd.Id, BodyPStr, IdxYear, IdxMonth));
     pb.Text:=Str.Slice(L_DatTim.MonthStr(D, 0), 0, 3);
     clnd_SetBtnColor(pb, (CurMonth = L_DatTim.MONTH(D)) & (CurYear = L_DatTim.YEAR(D)), 1);
     INC(IdxMonth);
    END; (* WHILE IdxMonth < ... *)
    INC(IdxYear);
   END; (* WHILE IdxYear ... *)
  ELSIF Page = pYear   THEN
   CurYear  :=L_DatTim.YEAR(clnd.D);
   D        :=L_DatTim.DecadeBeg(clnd.MinD);
   IdxDecade:=0;
   WHILE IdxDecade < clnd.MonthAmnt DO
    D:=L_DatTim.IncYear(L_DatTim.YearBeg(clnd.MinD), IdxDecade*10);
    SetTitleBtnText(Page, clnd.Id, IdxDecade, D);
    IdxYear:=0;
    WHILE IdxYear < clnd_BodyBtnAmount DO
     D      :=L_DatTim.IncYear(L_DatTim.IncYear(L_DatTim.YearBeg(clnd.MinD-1), IdxDecade*10), IdxYear);
     pb     :=getControl(clnd_GetBodyBtnId(clnd.Id, BodyPStr, IdxDecade, IdxYear));
     pb.Text:=L_Str.IntStr(L_DatTim.YEAR(D));
     clnd_SetBtnColor(pb, L_DatTim.YEAR(D) = CurYear, (D >= clnd.MinD) & (D <= clnd.MaxD));
     pb.Visible:=((IdxDecade=0)&(D<clnd.MinD)) |
                 ((IdxDecade=clnd.MonthAmnt-1)&(D>clnd.MaxD)) |
                 (L_DatTim.DecadeBeg(D) = L_DatTim.DecadeBeg(L_DatTim.IncYear(clnd.MinD, IdxDecade*10)));
     pb.Enable:=(D >= clnd_MinDate) & (D <= clnd_MaxDate);
     INC(IdxYear);
    END; (* WHILE IdxYear < ... *)
    INC(IdxDecade);
   END; (* WHILE IdxDecade < ... *)
  ELSIF Page = pDecade THEN
   IdxCentury:=0;
   D         :=L_DatTim.CenturyBeg(clnd.MinD);
   WHILE IdxCentury < clnd.MonthAmnt DO
    D:=L_DatTim.IncYear(L_DatTim.YearBeg(clnd.MinD), IdxCentury*100);
    SetTitleBtnText(Page, clnd.Id, IdxCentury, D);
    IdxDecade:=0;
    WHILE IdxDecade < clnd_BodyBtnAmount DO
     D      :=L_DatTim.IncYear(L_DatTim.IncYear(L_DatTim.YearBeg(clnd.MinD-1), IdxCentury*100), IdxDecade*10);
     pb     :=getControl(clnd_GetBodyBtnId(clnd.Id, BodyPStr, IdxCentury, IdxDecade));
     pb.Text:=L_Str.IntStr(L_DatTim.YEAR(L_DatTim.DecadeBeg(D))) + "-" + L_Str.CRLF + L_Str.IntStr(L_DatTim.YEAR(L_DatTim.DecadeEnd(D)));
     clnd_SetBtnColor(pb, L_DatTim.DecadeBeg(D) = L_DatTim.DecadeBeg(clnd.D), (D >= clnd.MinD) & (D <= clnd.MaxD));
     pb.Visible:=((IdxCentury=0)&(D<clnd.MinD)) |
                 ((IdxCentury=clnd.MonthAmnt-1)&(D>clnd.MaxD)) |
                 (L_DatTim.CenturyBeg(D) = L_DatTim.CenturyBeg(L_DatTim.IncYear(clnd.MinD, IdxCentury*100)));
     pb.Enable:=(D >= clnd_MinDate) & (D <= clnd_MaxDate);
     INC(IdxDecade);
    END; (* WHILE IdxDecade < ... *)
    INC(IdxCentury);
   END; (* WHILE IdxCentury < ... *)
  ELSE
   L_General.CallUs(0);
  END;
  IF NeedRedraw THEN
   dlg.Redraw();
  END;
 END {clnd_UpdateControls};

 PRIVATE PROCEDURE GetControlVisible(DisplayedPageId: NUMERIC[0]; DisplayedClndId, ControlPage, ControlId: STRING[]): SCAL[2];
  VAR
   Result       : SCAL[2];
   DisplayedPage,
   ControlClndId: STRING[];
 BEGIN
  IF (ControlPage = GetPStr(pMain)) |
     ((ControlPage = GetPStr(pCalc)) & (DisplayedClndId = id_ClndSrc)) THEN
   Result:=1;
  ELSE
   ControlClndId:=GetObjectClndId(ControlId);
   DisplayedPage:=GetPStr(DisplayedPageId);
   IF ControlPage = DisplayedPage THEN
    Result:=(DisplayedClndId = ControlClndId) |
            ((DisplayedClndId = id_ClndSrc) & ((ControlClndId = id_ClndSrc) | (ControlClndId = id_ClndRes)));
   ELSE
    Result:=0;
   END;
  END;
  RETURN Result;
 END {GetControlVisible};

 PRIVATE PROCEDURE ShowPage(P: NUMERIC[0]; clnd_Id: STRING[]);
  VAR
   Idx: NUMERIC[0];
   c  : CONTROL;
 BEGIN
  PosToClnd(clnd_Id);
  Idx:=0;
  WHILE Idx < dlg.Controls.Count DO
   c:=dlg.Controls.Item(Idx);
   c.Visible:=GetControlVisible(P, clnd_Id, dlgPagesCollection.Item(c.Id), c.Id);
   INC(Idx);
  END; (* WHILE Idx < ... *)

  IF clnd_Id = id_ClndSrc THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    clnd_UpdateControls(P, id_ClndSrc, 0);
    clnd_UpdateControls(P, id_ClndRes, 1);
   EXCEPT
   END;
  ELSE
   clnd_UpdateControls(P, clnd_Id, 1);
  END;
 END {ShowPage};

 PRIVATE PROCEDURE Calculate(PageClnd2: NUMERIC[0]);
  VAR
   SrcDate,
   NewDate: DATE;
   Days,
   Offset  : NUMERIC[0];
   MonthIdx: NUMERIC[0];
 BEGIN
  SrcDate:=getControl(id_EInputDate).Value;
  Offset :=getControl(id_Offset).Value;
  Days   :=getControl(id_Days).Value;
  IF Offset = os_IncWorkD   THEN
   NewDate:=L_DatTim.IncWorkDay(SrcDate, Days);
  ELSIF Offset = os_IncCalD    THEN
   NewDate:=SrcDate + Days;
  ELSE
   L_General.CallUs(0);
  END;
  getControl(id_EResDate).Value:=NewDate;

  PosToClnd(id_ClndRes);
  clnd.D  :=NewDate;
  MonthIdx:=(clnd.MonthAmnt-1) DIV 2;
  clnd_UpdateMinMaxDates(MonthIdx, PageClnd2);
  REPLACE(clnd);
  ShowPage(PageClnd2, id_ClndSrc);
 END {Calculate};

 PRIVATE PROCEDURE clnd_ChangeSrcD(NewDate: DATE; PageClnd2: NUMERIC[0]);
  VAR
   MonthIdx: NUMERIC[0];
 BEGIN
  IF CurClndId = id_ClndSrc THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    getControl(id_EInputDate).Value:=NewDate;
    PosToClnd(id_ClndSrc);
    MonthIdx:=(clnd.MonthAmnt-1) DIV 2;
    clnd_UpdateMinMaxDates(MonthIdx, PageClnd2);
    REPLACE(clnd);
    Calculate(PageClnd2);
   EXCEPT
   END;
  END;
 END {clnd_ChangeSrcD};

 PRIVATE PROCEDURE ShowErrorAboutClickClndRes();
 BEGIN
  L_GUI.Error(dlg, "  㦨 ⮫쪮  ⮡ࠦ १");
 END {ShowErrorAboutClickClndRes};

 PRIVATE PROCEDURE OnClick_Date(SLF: OBJECT);
  VAR
   BtnDate,
   CurMonth  : DATE;
   CurBtnD,
   PrevBtnD  : OBJECT;
   ClndId    : STRING[];
   MonthIdx  : NUMERIC[0];
 BEGIN
  ClndId :=GetObjectClndId(SLF.Id);
  PosToClnd(ClndId);
  BtnDate :=clnd_GetDateFromBtn(SLF);
  PrevBtnD:=clnd_FindBtnByDate(clnd.D, ClndId);
  IF ~!PrevBtnD THEN
   clnd_SetBtnColor(PrevBtnD, 0, 1);
  END;
  MonthIdx    :=GetObjectClndMonthIdx(SLF.Id);
  IF ClndId = id_ClndBig THEN
   PermMonthIdx:=MonthIdx;
  END;
  CurMonth    :=L_DatTim.IncMonth(clnd.MinD, MonthIdx);
  clnd.D      :=BtnDate;
  REPLACE(clnd);
  IF    (MonthIdx = 0) & (clnd.D < L_DatTim.MonthBeg(CurMonth)) THEN
   clnd.MinD:=L_DatTim.MonthBeg(L_DatTim.IncMonth(clnd.MinD, -1));
   clnd.MaxD:=L_DatTim.MonthEnd(L_DatTim.IncMonth(clnd.MaxD, -1));
   REPLACE(clnd);
  ELSIF (MonthIdx = clnd.MonthAmnt-1) & (clnd.D > L_DatTim.MonthEnd(CurMonth)) THEN
   clnd.MinD:=L_DatTim.MonthBeg(L_DatTim.IncMonth(clnd.MinD, +1));
   clnd.MaxD:=L_DatTim.MonthEnd(L_DatTim.IncMonth(clnd.MaxD, +1));
   REPLACE(clnd);
  ELSIF (MonthIdx >= 0) & (MonthIdx <= clnd.MonthAmnt-1) &
        ((clnd.D < L_DatTim.MonthBeg(CurMonth)) | (clnd.D > L_DatTim.MonthEnd(CurMonth))) THEN
   CurBtnD:=clnd_FindBtnByDate(clnd.D, ClndId);
   clnd_SetBtnColor(CurBtnD, 1, 1);
  ELSE
   clnd_SetBtnColor(SLF, 1, 1);
  END;
  clnd_ChangeSrcD(clnd.D, pDate);
  IF ClndId # id_ClndRes THEN
   UpdateLastClndHist(ClndId);
  END;
  IF ClndId # id_ClndSrc THEN
   ResDate:=BtnDate;
   dlg.OnClose(dlg);
  END;
 END {OnClick_Date};

 PRIVATE PROCEDURE clnd_GetD(d, m, y: NUMERIC[0]): DATE;
  VAR
   Result,
   MonthBeg: DATE;
 BEGIN
  MonthBeg:=PackDATE(01, m, y);
  IF d <= L_DatTim.MonthLen(MonthBeg) THEN
   Result:=PackDATE(d, m, y);
  ELSE
   Result:=PackDATE(L_DatTim.MonthLen(MonthBeg), m, y);
  END;
  RETURN Result;
 END {clnd_GetD};

 PRIVATE PROCEDURE GetNewIdHist(clnd_Id: STRING[10]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  SAVE(ClndHist);
  IF PosToClndHist(clnd_Id) THEN
   Result:=ClndHist.IdHist + 1;
  ELSE
   Result:=0;
  END;
  RESTORE(ClndHist);
  RETURN Result;
 END {GetNewIdHist};

 PRIVATE PROCEDURE InsertClndHist(clnd_Id: STRING[10]; PageId: NUMERIC[0]);
 BEGIN
  PosToClnd(clnd_Id);
  PermPageId      :=PageId;
  ClndHist.IdHist :=GetNewIdHist(clnd.Id);
  ClndHist.IdClnd :=clnd.Id;
  ClndHist.CurPage:=PageId;
  ClndHist.D      :=clnd.D;
  ClndHist.MinD   :=clnd.MinD;
  ClndHist.MaxD   :=clnd.MaxD;
  INSERT(ClndHist);
 END {InsertClndHist};

 PRIVATE PROCEDURE UpdateLastClndHist(clnd_Id: STRING[10]);
 BEGIN
  PosToClnd(clnd_Id);
  L_General.CallUs(PosToClndHist(clnd_Id));
  ClndHist.D      :=clnd.D;
  ClndHist.MinD   :=clnd.MinD;
  ClndHist.MaxD   :=clnd.MaxD;
  REPLACE(ClndHist);
 END {UpdateLastClndHist};

 PRIVATE PROCEDURE RemoveLastClndHist(clnd_Id: STRING[10]);
 BEGIN
  L_General.CallUs(PosToClndHist(clnd_Id));
  REMOVE(ClndHist);
 END {RemoveLastClndHist};

 PRIVATE PROCEDURE OnClick_Month(SLF: OBJECT);
  VAR
   ClndId    : STRING[];
   Year,
   MonthIdx,
   BodyBtnIdx: NUMERIC[0];
 BEGIN
  ClndId:=GetObjectClndId(SLF.Id);
  IF ClndId = id_ClndRes THEN
   ShowErrorAboutClickClndRes();
  ELSE
   PosToClnd(ClndId);
   MonthIdx  :=GetObjectClndMonthIdx(SLF.Id);
   BodyBtnIdx:=GetObjectClndBodyBtnIdx(SLF.Id);
   Year      :=L_DatTim.YEAR(L_DatTim.IncYear(clnd.MinD, MonthIdx));
   clnd.D    :=clnd_GetD(L_DatTim.DAY(clnd.D), BodyBtnIdx, Year);
   REPLACE(clnd);
   IF ClndId = id_ClndBig THEN
    clnd_UpdateMinMaxDates(MonthIdx, pDate);
    REPLACE(clnd);
    ShowPage(pDate, ClndId);
   END;
   clnd_ChangeSrcD(clnd.D, pDate);
   InsertClndHist(ClndId, pDate);
  END;
 END {OnClick_Month};

 PRIVATE PROCEDURE OnClick_Year(SLF: OBJECT);
  VAR
   ClndId    : STRING[];
   MonthIdx,
   BodyBtnIdx: NUMERIC[0];
   D         : DATE;
 BEGIN
  ClndId:=GetObjectClndId(SLF.Id);
  IF ClndId = id_ClndRes THEN
   ShowErrorAboutClickClndRes();
  ELSE
   PosToClnd(ClndId);
   MonthIdx  :=GetObjectClndMonthIdx(SLF.Id);
   BodyBtnIdx:=GetObjectClndBodyBtnIdx(SLF.Id);
   D         :=L_DatTim.IncYear(L_DatTim.IncYear(L_DatTim.YearBeg(clnd.MinD-1), MonthIdx*10), BodyBtnIdx);
   clnd.D    :=clnd_GetD(L_DatTim.DAY(clnd.D), L_DatTim.MONTH(clnd.D), L_DatTim.YEAR(D));
   REPLACE(clnd);
   IF ClndId = id_ClndBig THEN
    clnd_UpdateMinMaxDates(MonthIdx, pMonth);
    REPLACE(clnd);
    ShowPage(pMonth, ClndId);
   END;
   clnd_ChangeSrcD(clnd.D, pMonth);
   InsertClndHist(ClndId, pMonth);
  END;
 END {OnClick_Year};

 PRIVATE PROCEDURE OnClick_Decade(SLF: OBJECT);
  VAR
   ClndId    : STRING[];
   MonthIdx,
   BodyBtnIdx: NUMERIC[0];
   D         : DATE;
 BEGIN
  ClndId:=GetObjectClndId(SLF.Id);
  IF ClndId = id_ClndRes THEN
   ShowErrorAboutClickClndRes();
  ELSE
   PosToClnd(ClndId);
   MonthIdx  :=GetObjectClndMonthIdx(SLF.Id);
   BodyBtnIdx:=GetObjectClndBodyBtnIdx(SLF.Id);
   D         :=L_DatTim.IncYear(L_DatTim.IncYear(L_DatTim.YearBeg(clnd.MinD-1), MonthIdx*100), BodyBtnIdx*10);
   clnd.D    :=clnd_GetD(L_DatTim.DAY(clnd.D), L_DatTim.MONTH(clnd.D), (L_DatTim.YEAR(D) DIV 10)*10 + (L_DatTim.YEAR(clnd.D) MOD 10));
   REPLACE(clnd);
   IF ClndId = id_ClndBig THEN
    clnd_UpdateMinMaxDates(MonthIdx, pYear);
    REPLACE(clnd);
    ShowPage(pYear, ClndId);
   END;
   clnd_ChangeSrcD(clnd.D, pYear);
   InsertClndHist(ClndId, pYear);
  END;
 END {OnClick_Decade};

 PRIVATE PROCEDURE OnClick_Title(SLF: OBJECT; PageId: NUMERIC[0]);
  VAR
   ClndId  : STRING[];
   MonthIdx: NUMERIC[0];
 BEGIN
  ClndId:=GetObjectClndId(SLF.Id);
  IF ClndId = id_ClndRes THEN
   ShowErrorAboutClickClndRes();
  ELSE
   PosToClnd(ClndId);
   MonthIdx:=GetObjectClndMonthIdx(SLF.Id);
   clnd_UpdateMinMaxDates(MonthIdx, PageId);
   REPLACE(clnd);
   InsertClndHist(ClndId, PageId);
   IF ClndId = id_ClndSrc THEN
    PosToClnd(id_ClndRes);
    clnd_UpdateMinMaxDates((clnd.MonthAmnt-1) DIV 2, PageId);
    REPLACE(clnd);
   END;
   ShowPage(PageId, ClndId);
  END;
 END {OnClick_Title};

 PRIVATE PROCEDURE OnClick_MonthTitle(SLF: OBJECT);
 BEGIN
  OnClick_Title(SLF, pMonth);
 END {OnClick_MonthTitle};

 PRIVATE PROCEDURE OnClick_YearTitle(SLF: OBJECT);
 BEGIN
  OnClick_Title(SLF, pYear);
 END {OnClick_YearTitle};

 PRIVATE PROCEDURE OnClick_DecadeTitle(SLF: OBJECT);
 BEGIN
  OnClick_Title(SLF, pDecade);
 END {OnClick_DecadeTitle};

 PRIVATE PROCEDURE clnd_ChangeYear(SLF: OBJECT; YearAmnt, PageId: NUMERIC[0]);
  VAR
   ClndId: STRING[];
 BEGIN
  ClndId:=GetObjectClndId(SLF.Id);
  PosToClnd(ClndId);
  clnd.MinD:=L_DatTim.YearBeg(L_DatTim.IncYear(clnd.MinD, YearAmnt));
  clnd.MaxD:=L_DatTim.YearEnd(L_DatTim.IncYear(clnd.MaxD, YearAmnt));
  REPLACE(clnd);
  IF (clnd.D < clnd.MinD) | (clnd.D > clnd.MaxD) THEN
   clnd.D:=PackDATE(L_DatTim.DAY(clnd.D), L_DatTim.MONTH(clnd.D), L_DatTim.YEAR(clnd.MinD));
   REPLACE(clnd);
   clnd_ChangeSrcD(clnd.D, PageId);
  END;
  UpdateLastClndHist(clnd.Id);
  clnd_UpdateControls(PageId, ClndId, 1);
 END {clnd_ChangeYear};

 PRIVATE PROCEDURE OnClick_ChangeMonth(SLF: OBJECT; Direction: NUMERIC[0]);
  VAR
   ClndId: STRING[];
 BEGIN
  ClndId:=GetObjectClndId(SLF.Id);
  PosToClnd(ClndId);
  clnd.MinD:=L_DatTim.MonthBeg(L_DatTim.IncMonth(clnd.MinD, Direction));
  clnd.MaxD:=L_DatTim.MonthEnd(L_DatTim.IncMonth(clnd.MaxD, Direction));
  REPLACE(clnd);
  IF (clnd.D < clnd.MinD) | (clnd.D > clnd.MaxD) THEN
   clnd.D:=clnd.MinD;
   REPLACE(clnd);
   clnd_ChangeSrcD(clnd.D, pDate);
  END;
  UpdateLastClndHist(clnd.Id);
  clnd_UpdateControls(pDate, ClndId, 1);
 END {OnClick_ChangeMonth};

 PRIVATE PROCEDURE OnClick_PrevMonth(SLF: OBJECT);
 BEGIN
  OnClick_ChangeMonth(SLF, -1);
 END {OnClick_PrevMonth};

 PRIVATE PROCEDURE OnClick_NextMonth(SLF: OBJECT);
 BEGIN
  OnClick_ChangeMonth(SLF, +1);
 END {OnClick_NextMonth};

 PRIVATE PROCEDURE OnClick_ChangeYear(SLF: OBJECT; Direction: NUMERIC[0]);
 BEGIN
  clnd_ChangeYear(SLF, Direction*1, pMonth);
 END {OnClick_ChangeYear};

 PRIVATE PROCEDURE OnClick_PrevYear(SLF: OBJECT);
 BEGIN
  OnClick_ChangeYear(SLF, -1);
 END {OnClick_PrevYear};

 PRIVATE PROCEDURE OnClick_NextYear(SLF: OBJECT);
 BEGIN
  OnClick_ChangeYear(SLF, +1);
 END {OnClick_NextYear};

 PRIVATE PROCEDURE OnClick_ChangeDecade(SLF: OBJECT; Direction: NUMERIC[0]);
 BEGIN
  clnd_ChangeYear(SLF, Direction*10, pYear);
 END {OnClick_ChangeDecade};

 PRIVATE PROCEDURE OnClick_PrevDecade(SLF: OBJECT);
 BEGIN
  OnClick_ChangeDecade(SLF, -1);
 END {OnClick_PrevDecade};

 PRIVATE PROCEDURE OnClick_NextDecade(SLF: OBJECT);
 BEGIN
  OnClick_ChangeDecade(SLF, +1);
 END {OnClick_NextDecade};

 PRIVATE PROCEDURE OnClick_ChangeCentury(SLF: OBJECT; Direction: NUMERIC[0]);
 BEGIN
  clnd_ChangeYear(SLF, Direction*100, pDecade);
 END {OnClick_ChangeCentury};

 PRIVATE PROCEDURE OnClick_PrevCentury(SLF: OBJECT);
 BEGIN
  OnClick_ChangeCentury(SLF, -1);
 END {OnClick_PrevCentury};

 PRIVATE PROCEDURE OnClick_NextCentury(SLF: OBJECT);
 BEGIN
  OnClick_ChangeCentury(SLF, +1);
 END {OnClick_NextCentury};

 PRIVATE PROCEDURE GetDlgCaptionText(IsCalc: SCAL[2]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=L_General.GetAPSiteID() + ' - "⮏"';
  IF IsCalc THEN
   Result:=Result + "  .";
  ELSE
   Result:=Result + " ந⢥ .";
  END;
  Result:=Result + "  " + L_DatTim.DateStr(SYSDATE());
  RETURN Result;
 END {GetDlgCaptionText};

 PRIVATE PROCEDURE OnClick_Calc(SLF: OBJECT);
  VAR
   CurPage: NUMERIC[0];
   CurD   : DATE;
 BEGIN
  L_General.CallUs(PosToClndHist(CurClndId));
  CurPage:=ClndHist.CurPage;
  CurD   :=ClndHist.D;
  dlg.CaptionText:=GetDlgCaptionText(SLF.Text = ct_Calc);
  IF SLF.Text = ct_Calc THEN
   SLF.Text :=ct_Close;
   SLF.Style.Font.Face:="Wingdings 2";
   CurClndId:=id_ClndSrc;
  ELSE
   SLF.Text :=ct_Calc;
   SLF.Style.Font.Face:=APP.Get().ProportionalFontFace;
   CurClndId:=id_ClndBig;
  END;
  PosToClnd(CurClndId);
  clnd.D:=CurD;
  REPLACE(clnd);

  IF CurClndId = id_ClndBig THEN
   clnd_UpdateMinMaxDates((clnd.MonthAmnt-1) DIV 2, CurPage);
   REPLACE(clnd);
   ShowPage(CurPage, id_ClndBig);
  END;
  clnd_ChangeSrcD(CurD, CurPage);

  L_General.CallUs(PosToClndHist(CurClndId));
  IF ClndHist.CurPage = CurPage THEN
   UpdateLastClndHist(CurClndId);
  ELSE
   InsertClndHist(CurClndId, CurPage);
  END;
 END {OnClick_Calc};

 PRIVATE PROCEDURE clnd_CreateTitleBtns(Page                                : NUMERIC[0];
                                        clnd_Id                             : STRING[];
                                        Num                                 : NUMERIC[0];
                                        pT, pL_Prev, pL_Cur, pL_Next,
                                        sH, sW_PrevNext, sW_Cur,
                                        fs_PrevNext, fs_Cur                 : FLOAT;
                                        OnClickPrev, OnClickCur, OnClickNext: PROC);
  CONST
   fn = "Wingdings";
  VAR
   bId : STRING[];
 BEGIN
  PosToClnd(clnd_Id);
  IF Num = 0 THEN
   IF clnd_Id # id_ClndRes THEN
    bId:=clnd_Id+ "_Prev" + GetPStr(Page+1);
    L_GUI.put_ColorButton(dlg,
                          GetPStr(Page),
                          bId,
                          "", (*५ *)
                          pL_Prev, pT, sW_PrevNext, sH,
                          fs_PrevNext,
                          clTitleBtn,
                          OnClickPrev);
    getControl(bId).Style.Color.Copy(clTitleBtnF);
    getControl(bId).Style.Font.Face:=fn;
    IF clnd.MonthAmnt # 1 THEN
     sW_Cur:=pL_Next + sW_PrevNext - pL_Cur;
    END;
   END; (* IF clnd_Id # id_ClndRes ... *)
  END;
  IF Num = clnd.MonthAmnt-1 THEN
   IF clnd_Id # id_ClndRes THEN
    bId:=clnd_Id+ "_Next" + GetPStr(Page+1);
    L_GUI.put_ColorButton(dlg,
                          GetPStr(Page),
                          bId,
                          "", (*५ ࠢ*)
                          pL_Next, pT, sW_PrevNext, sH,
                          fs_PrevNext,
                          clTitleBtn,
                          OnClickNext);
    getControl(bId).Style.Color.Copy(clTitleBtnF);
    getControl(bId).Style.Font.Face:=fn;
    IF clnd.MonthAmnt # 1 THEN
     sW_Cur:=pL_Next + sW_PrevNext - pL_Cur;
     pL_Cur:=pL_Prev;
    END;
   END; (* IF clnd_Id # id_ClndRes ... *)
  END;
  IF (Num # 0) & (Num # clnd.MonthAmnt-1) THEN
   sW_Cur:=pL_Next + sW_PrevNext - pL_Cur;
   pL_Cur:=pL_Prev;
  END;
  bId:=clnd_Id+ "_Cur" + GetPStr(Page+1) + "_" + L_Str.IntStr(Num);
  IF clnd_Id = id_ClndRes THEN
   sW_Cur:=pL_Next + sW_PrevNext - pL_Prev;
   pL_Cur:=pL_Prev;
  END;
  L_GUI.put_ColorButton(dlg,
                        GetPStr(Page),
                        bId,
                        EMPTYOF(STRING[]),
                        pL_Cur, pT, sW_Cur, sH,
                        fs_Cur,
                        clTitleBtn,
                        OnClickCur);
  getControl(bId).Enable:=~!OnClickCur;
  getControl(bId).Style.Color.Copy(clTitleBtnF);
  getControl(bId).Style.Font.Face:=APP.Get().ProportionalFontFace;
 END {clnd_CreateTitleBtns};

 PRIVATE PROCEDURE clnd_CreateBodyBtns(Page              : NUMERIC[0];
                                       clnd_Id           : STRING[];
                                       Num               : NUMERIC[0];
                                       BtnAmount,
                                       ColumnAmount      : NUMERIC[0];
                                       pL_Beg, pT_Beg,
                                       sW, sH,
                                       sW_Space, sH_Space,
                                       fs                : FLOAT;
                                       OnClick           : PROC);
  VAR
   Idx,
   pL,
   pT  : FLOAT;
   bId : STRING[];
   PStr: STRING[];
 BEGIN
  pL  :=pL_Beg;
  pT  :=pT_Beg;
  Idx :=0;
  PStr:=GetPStr(Page);
  WHILE Idx < BtnAmount DO
   bId:=clnd_Id+ "_" + PStr + "_" + L_Str.IntStr(Num) + "_" + L_Str.IntStr(Idx);
   L_GUI.put_ColorButton(dlg,
                         PStr,
                         bId,
                         EMPTYOF(STRING[]),
                         pL, pT, sW, sH,
                         fs,
                         clWhite,
                         OnClick);
   getControl(bId).Style.Font.Face:=L_GUI.fn_CourierNew;
   IF ((Idx + 1) MOD ColumnAmount) = 0 THEN
    pL:=pL_Beg;
    INC(pT, sH + sH_Space);
   ELSE
    INC(pL, sW + sW_Space);
   END;
   INC(Idx);
  END; (* WHILE Idx ... *)
 END {clnd_CreateBodyBtns};

 PRIVATE PROCEDURE clnd_GetSizeBodyBtns(sW_Body, sH_Body,
                                        sW_Space, sH_Space  : FLOAT;
                                        cntColumns, cntRows : NUMERIC[0];
                                        VAR sW_Btn, sH_Btn  : FLOAT);
 BEGIN
  sW_Btn:=(sW_Body - (cntColumns - 1)*sW_Space) / cntColumns;
  sH_Btn:=(sH_Body - (cntRows    - 1)*sH_Space) / cntRows;
 END {clnd_GetSizeBodyBtns};

 PRIVATE PROCEDURE CurClnd_SetSize();
  VAR
   sH_Month: FLOAT;
 BEGIN
  L_General.CallUs(OCCURE(clnd));
  clnd.sWMonth:=(clnd.sW - (clnd.MonthAmnt - 1)*sW_SpaceBtwMonth) / clnd.MonthAmnt;
  sH_Month:=0;
  clnd_GetSizeBodyBtns(clnd.sWMonth, sH_Month,
                       sW_SpaceBtwBodyBtns, sH_SpaceBtwBodyBtns,
                       clnd_ColumnInMonth, clnd_RowInMonth,
                       clnd.sWDayBtn, clnd.sHDayBtn);
  clnd.sWMonth      :=clnd.sWDayBtn*clnd_ColumnInMonth + (clnd_ColumnInMonth-1)*sW_SpaceBtwBodyBtns;
  clnd.sWPrevNextBtn:=clnd.sWDayBtn + sW_SpaceBtwBodyBtns - sW_SpaceBtwPrevNext;
  clnd.sWCurBtn     :=clnd.sWMonth - 2*(clnd.sWPrevNextBtn + sW_SpaceBtwPrevNext);
  clnd.sWWeekDay    :=clnd.sWDayBtn;
  clnd.sHDayBtn     :=clnd.sWDayBtn;
  REPEAT
   IF sH_Month > clnd.sH THEN
    DEC(clnd.sHDayBtn);
   END;
   clnd.sHCurBtn :=clnd.sHDayBtn*0.7;
   clnd.sHWeekDay:=clnd.sHDayBtn / 2;
   sH_Month      :=clnd.sHCurBtn + sH_SpaceBtwMonthWeekDay + clnd.sHWeekDay+ sH_SpaceBtwBodyBtns +
                   clnd.sHDayBtn*clnd_RowInMonth + (clnd_RowInMonth-1)*sH_SpaceBtwBodyBtns;
  UNTIL sH_Month <= clnd.sH;
  clnd.sH:=sH_Month;
  clnd.sW:=clnd.sWMonth*clnd.MonthAmnt + (clnd.MonthAmnt-1)*sW_SpaceBtwMonth;
 END {CurClnd_SetSize};

 PRIVATE PROCEDURE CreateCalendar(clnd_id: STRING[]);
  CONST
   clnd_WDPrefix      = "WD_";

   fs_WeekDay         = 18;
   fs_PrevNextBtn     = 22;
   fs_MonthTitleBtn   = 22;
   fs_YearTitleBtn    = 22;
   fs_DecadeTitleBtn  = 22;
   fs_CenturyTitleBtn = 22;

  VAR
   IdxWeekDay       : SCAL[clnd_ColumnInMonth];
   IdxMonth         : NUMERIC[0];
   pL_Month,
   pT_CurBtn,
   pL_WeekDay,
   pT_WeekDay,
   pL_Prev,
   pL_Cur,
   pL_Next,
   pL_BegBody,
   pT_BegBody,
   sW_BodyBtn,
   sH_BodyBtn       : FLOAT;
   stId,
   dummy            : STRING[];
   OnClick_Prev,
   OnClick_Cur,
   OnClick_Next,
   OnClick_BodyBtn  : PROC[5];
   fs_TitleBtn,
   fs_BodyBtn       : FLOAT[5];
   IdxPage          : NUMERIC[0];
   fn               : STRING[];
 BEGIN
  dummy:=L_Str.CheckIllegalChars(clnd_id, "_");
  fn   :=APP.Get().ProportionalFontFace;
  PosToClnd(clnd_id);
  L_General.CallUs(clnd.MonthAmnt <= MaxMonthAmnt);

  OnClick_Prev   [pDate]:=PROCREF(OnClick_PrevMonth);
  OnClick_Cur    [pDate]:=PROCREF(OnClick_MonthTitle);
  OnClick_Next   [pDate]:=PROCREF(OnClick_NextMonth);
  OnClick_BodyBtn[pDate]:=PROCREF(OnClick_Date);
  fs_TitleBtn    [pDate]:=fs_MonthTitleBtn;
  fs_BodyBtn     [pDate]:=fs_DayBtn;

  OnClick_Prev   [pMonth]:=PROCREF(OnClick_PrevYear);
  OnClick_Cur    [pMonth]:=PROCREF(OnClick_YearTitle);
  OnClick_Next   [pMonth]:=PROCREF(OnClick_NextYear);
  OnClick_BodyBtn[pMonth]:=PROCREF(OnClick_Month);
  fs_TitleBtn    [pMonth]:=fs_YearTitleBtn;
  fs_BodyBtn     [pMonth]:=fs_MonthBtn;

  OnClick_Prev   [pYear]:=PROCREF(OnClick_PrevDecade);
  OnClick_Cur    [pYear]:=PROCREF(OnClick_DecadeTitle);
  OnClick_Next   [pYear]:=PROCREF(OnClick_NextDecade);
  OnClick_BodyBtn[pYear]:=PROCREF(OnClick_Year);
  fs_TitleBtn    [pYear]:=fs_DecadeTitleBtn;
  fs_BodyBtn     [pYear]:=fs_YearBtn;

  OnClick_Prev   [pDecade]:=PROCREF(OnClick_PrevCentury);
  OnClick_Cur    [pDecade]:=EMPTYOF(PROC);
  OnClick_Next   [pDecade]:=PROCREF(OnClick_NextCentury);
  OnClick_BodyBtn[pDecade]:=PROCREF(OnClick_Decade);
  fs_TitleBtn    [pDecade]:=fs_CenturyTitleBtn;
  fs_BodyBtn     [pDecade]:=fs_DecadeBtn;

  pL_Month:=clnd.pL;
  IdxMonth:=0;
  WHILE IdxMonth < clnd.MonthAmnt DO
   IdxPage:=pDate;
   WHILE IdxPage <= pDecade DO
    IF IdxPage = pDate THEN
     pT_CurBtn :=clnd.pT;
     pL_BegBody:=pL_Month;
     pL_Prev   :=pL_BegBody;
     pL_Cur    :=pL_Prev + clnd.sWPrevNextBtn + sW_SpaceBtwPrevNext;
     pL_Next   :=pL_Cur + clnd.sWCurBtn + sW_SpaceBtwPrevNext;
     pL_WeekDay:=pL_BegBody;
     pT_WeekDay:=pT_CurBtn + clnd.sHCurBtn+ sH_SpaceBtwMonthWeekDay;
     FOR_EACH IdxWeekDay DO
      stId:=clnd.Id+ "_" + clnd_WDPrefix + L_Str.IntStr(IdxMonth) + "_"+ L_Str.IntStr(IdxWeekDay);
      L_GUI.put_StaticText(dlg,
                           GetPStr(pDate), stId, L_DatTim.WeekDayShortStr(IdxWeekDay),
                           pL_WeekDay, pT_WeekDay, clnd.sWWeekDay, clnd.sHWeekDay, fs_WeekDay,
                           CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
      getControl(stId).Style.Font.Face:=fn;
      INC(pL_WeekDay, clnd.sWWeekDay + sW_SpaceBtwBodyBtns);
     END; (* FOR_EACH IdxWeekDay ... *)
  
     pT_BegBody:=pT_WeekDay + clnd.sHWeekDay + sH_SpaceBtwBodyBtns;
     sW_BodyBtn:=0; sH_BodyBtn:=0;
    ELSIF IdxPage = pMonth THEN
     pT_BegBody:=pT_WeekDay;
     clnd_GetSizeBodyBtns(clnd.sWMonth, clnd.sH - clnd.sHCurBtn - sH_SpaceBtwMonthWeekDay,
                          sW_SpaceBtwBodyBtns, sH_SpaceBtwBodyBtns,
                          clnd_BodyColumnsAmount, clnd_BodyRowsAmount,
                          sW_BodyBtn, sH_BodyBtn);
    END;
    clnd_CreateTitleBtns(IdxPage, clnd.Id,
                         IdxMonth,
                         pT_CurBtn, pL_Prev, pL_Cur, pL_Next,
                         clnd.sHCurBtn, clnd.sWPrevNextBtn, clnd.sWCurBtn,
                         fs_PrevNextBtn, fs_TitleBtn[IdxPage],
                         OnClick_Prev[IdxPage], OnClick_Cur[IdxPage], OnClick_Next[IdxPage]);
    clnd_CreateBodyBtns(IdxPage, clnd.Id,
                        IdxMonth,
                        clnd_btnAmount    *(IdxPage=pDate) + clnd_BodyBtnAmount    *(IdxPage#pDate),
                        clnd_ColumnInMonth*(IdxPage=pDate) + clnd_BodyColumnsAmount*(IdxPage#pDate),
                        pL_BegBody, pT_BegBody,
                        clnd.sWDayBtn*(IdxPage=pDate) + sW_BodyBtn*(IdxPage#pDate),
                        clnd.sHDayBtn*(IdxPage=pDate) + sH_BodyBtn*(IdxPage#pDate),
                        sW_SpaceBtwBodyBtns, sH_SpaceBtwBodyBtns,
                        fs_BodyBtn[IdxPage],
                        OnClick_BodyBtn[IdxPage]);
    INC(IdxPage);
   END; (* WHILE IdxPage <=  ... *)
   INC(pL_Month, clnd.sWMonth + sW_SpaceBtwMonth);
   INC(IdxMonth);
  END; (* WHILE IdxMonth ... *)
 END {CreateCalendar};

 PRIVATE PROCEDURE SetTitleBtnText(Page: NUMERIC[0]; clnd_Id: STRING[]; IdxBtn: NUMERIC[0]; D: DATE);
  VAR
   pb: CONTROL;
 BEGIN
  pb:=getControl(clnd_GetTitleBtnId(clnd_Id, "Cur" + GetPStr(Page+1), IdxBtn));
  IF    Page = pDate   THEN
   pb.Text:=Str.Cap(L_DatTim.MonthStr(D, 0), 0, 1) + " " + L_Str.IntStr(L_DatTim.YEAR(D));
  ELSIF Page = pMonth  THEN
   pb.Text:=L_Str.IntStr(L_DatTim.YEAR(D));
  ELSIF Page = pYear   THEN
   pb.Text:=L_Str.IntStr(L_DatTim.YEAR(D)) + "-" + L_Str.IntStr(L_DatTim.YEAR(L_DatTim.DecadeEnd(D)));
  ELSIF Page = pDecade THEN
   pb.Text:=L_Str.IntStr(L_DatTim.YEAR(D)) + "-" + L_Str.IntStr(L_DatTim.YEAR(L_DatTim.CenturyEnd(D)));
  END;
 END {SetTitleBtnText};

 PRIVATE PROCEDURE EInputDate_OnSuccessfulChange(SLF: EDIT; PrvValue: DATE);
 BEGIN
  IF !SLF.Value THEN
   SLF.Value:=PrvValue;
  END;
  PosToClnd(CurClndId);
  clnd.D:=SLF.Value;
  REPLACE(clnd);
  L_General.CallUs(PosToClndHist(CurClndId));
  clnd_ChangeSrcD(SLF.Value, ClndHist.CurPage);
 END {EInputDate_OnSuccessfulChange};

 PRIVATE PROCEDURE Offset_OnSuccessfulChange(SLF: EDIT; PrvValue: NUMERIC[0]);
 BEGIN
  IF !SLF.Value THEN
   SLF.Value:=PrvValue;
  END;
  L_General.CallUs(PosToClndHist(id_ClndSrc));
  Calculate(ClndHist.CurPage);
 END {Offset_OnSuccessfulChange};

 PRIVATE PROCEDURE Days_OnSuccessfulChange(SLF: EDIT; PrvValue: NUMERIC[0]);
 BEGIN
  IF !SLF.Value THEN
   SLF.Value:=PrvValue;
  END;
  L_General.CallUs(PosToClndHist(id_ClndSrc));
  Calculate(ClndHist.CurPage);
 END {Days_OnSuccessfulChange};

 PRIVATE PROCEDURE GetSizeCalcBtn(VAR pL, pT, sW, sH: FLOAT);
 BEGIN
  PosToClnd(id_ClndBig);
  pL:=clnd.pL + clnd.sWMonth + sW_SpaceBtwMonth + clnd.sWPrevNextBtn + clnd.sWCurBtn + 2*sW_SpaceBtwPrevNext;
  pT:=clnd.pT;
  sW:=clnd.sWPrevNextBtn;
  sH:=clnd.sHCurBtn;
 END {GetSizeCalcBtn};

 PRIVATE PROCEDURE ClndBig_GetSize(VAR sH, sWPrevNextBtn, sWCurBtn, sHCurBtn, sWWeekDay, sHWeekDay, sWDayBtn, sHDayBtn: FLOAT);
 BEGIN
  SAVE(clnd);
  PosToClnd(id_ClndBig);
  sH           :=clnd.sH;
  sWPrevNextBtn:=clnd.sWPrevNextBtn;
  sWCurBtn     :=clnd.sWCurBtn;
  sHCurBtn     :=clnd.sHCurBtn;
  sWWeekDay    :=clnd.sWWeekDay;
  sHWeekDay    :=clnd.sHWeekDay;
  sWDayBtn     :=clnd.sWDayBtn;
  sHDayBtn    :=clnd.sHDayBtn;
  RESTORE(clnd);
 END {ClndBig_GetSize};

 PRIVATE PROCEDURE ClndBig_GetSizeMonth(VAR sW, sH, sW_Month: FLOAT);
 BEGIN
  SAVE(clnd);
  PosToClnd(id_ClndBig);
  sW      :=clnd.sW;
  sH      :=clnd.sH;
  sW_Month:=clnd.sWMonth;
  RESTORE(clnd);
 END {ClndBig_GetSizeMonth};

 PRIVATE PROCEDURE CreateCalc(sW, sH: FLOAT);
  CONST
   sW_ShiftBtwnCalcBtn = 2*sW_MainShift;
   sH_ShiftBtwnCalcBtn = 2*sH_MainShift;
   sW_Days       = 60;

  VAR
   sH_Days,
   sH_CalcBtn,
   sH_CalcST,
   sW_STOffset,
   sW_STSrcDate,
   sW_STResDate,
   sW_EInputDate,
   sW_EResDate,
   sW_Offset,
   pL_STSrcDate,
   pL_STResDate,
   pL_EInputDate,
   pL_EResDate,
   pL_STOffset,
   pL_Offset,
   pL_Days,
   pT_STSrcDate,
   pT_STResDate,
   pT_EInputDate,
   pT_EResDate,
   pT_STOffset,
   pT_Offset,
   pT_Days,
   pL_CalcButton,
   pT_CalcButton,
   sW_CalcButton,
   sH_CalcButton: FLOAT;
   fn           : STRING[];
 BEGIN
  fn:=APP.Get().ProportionalFontFace;
  GetSizeCalcBtn(pL_CalcButton, pT_CalcButton, sW_CalcButton, sH_CalcButton);
  sH_CalcBtn    := fS_CalcBtn;
  sH_CalcST     := fS_CalcST;
  sH_Days       := fS_CalcDays + 10;
  sW_STSrcDate  := (sW - 3*sW_ShiftBtwnCalcBtn) DIV 2;
  sW_STResDate  := sW_STSrcDate;
  sW_EInputDate := sW_STSrcDate;
  sW_EResDate   := sW_STSrcDate;
  sW_STOffset   := sW - 2*sW_ShiftBtwnCalcBtn;
  sW_Offset     := sW_STOffset - sW_Days - sW_ShiftBtwnCalcBtn;
  pL_STSrcDate  := sW_MainShift + sW + sW_SpaceBtwMonth + sW_ShiftBtwnCalcBtn;
  pL_STResDate  := sW_MainShift + sW + sW_SpaceBtwMonth + sW - sW_EInputDate - sW_ShiftBtwnCalcBtn;
  pL_EInputDate := pL_STSrcDate;
  pL_EResDate   := pL_STResDate;
  pL_STOffset   := pL_STSrcDate;
  pL_Days       := pL_STSrcDate;
  pL_Offset     := pL_Days + sW_Days + sW_ShiftBtwnCalcBtn;

  pT_STSrcDate :=sH_MainShift + sH_CalcButton + sH_ShiftBtwnCalcBtn;
  pT_EInputDate:=pT_STSrcDate + sH_CalcST    + sH_ShiftBtwnCalcBtn;
  pT_STResDate :=pT_STSrcDate;
  pT_EResDate  :=pT_EInputDate;
  pT_STOffset  :=sH - sH_CalcST - sH_Days - sH_ShiftBtwnCalcBtn - sH_MainShift;
  pT_Days      :=pT_STOffset + sH_CalcST   + sH_ShiftBtwnCalcBtn;
  pT_Offset    :=pT_Days     + (sH_Days DIV 2) - (sH_CalcBtn DIV 2);

  L_GUI.put_ColorButton(dlg,
                        GetPStr(pMain), id_Calc, ct_Calc,
                        pL_CalcButton, pT_CalcButton, sW_CalcButton, sH_CalcButton,
                        fS_CalcBtn, clTitleBtn, PROCREF(OnClick_Calc));
  getControl(id_Calc).Style.Font.Face:=fn;
  getControl(id_Calc).Style.Color.Copy(clTitleBtnF);
  getControl(id_Calc).Style.Font.Weight:=FONT.Weight_Bold;

  L_GUI.put_StaticText(dlg,
                       GetPStr(pCalc), id_STSrcDate, "室",
                       pL_STSrcDate, pT_STSrcDate, sW_STSrcDate, sH_CalcST,
                       fS_CalcST, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  getControl(id_STSrcDate).Style.Font.Face:=fn;
  L_GUI.put_Edit(dlg,
                 GetPStr(pCalc), id_EInputDate,
                 pL_EInputDate, pT_EInputDate, sW_EInputDate, sH_CalcBtn, fS_CalcEdit,
                 CONTROL.HorizontalAlignment_Left, L_GUI.br_st_Solid);
  getControl(id_EInputDate).Style.Font.Face:=L_GUI.fn_CourierNew;
  getControl(id_EInputDate).Style.Color.Copy(clDate);
  getControl(id_EInputDate).OnSuccessfulChange:=PROCREF(EInputDate_OnSuccessfulChange);
  getControl(id_EInputDate).Value:=SYSDATE();
  getControl(id_EInputDate).Format:="D.N.y";

  L_GUI.put_StaticText(dlg,
                       GetPStr(pCalc), id_STResDate, "",
                       pL_STResDate, pT_STResDate, sW_STResDate, sH_CalcST,
                       fS_CalcST, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  getControl(id_STResDate).Style.Font.Face:=fn;
  L_GUI.put_Edit(dlg,
                 GetPStr(pCalc), id_EResDate,
                 pL_EResDate, pT_EResDate, sW_EResDate, sH_CalcBtn, fS_CalcEdit,
                 CONTROL.HorizontalAlignment_Left, L_GUI.br_st_Solid);
  getControl(id_EResDate).Style.Font.Face:=L_GUI.fn_CourierNew;
  getControl(id_EResDate).Style.Color.Copy(clDate);
  getControl(id_EResDate).Format:="D.N.y";
  getControl(id_EResDate).Enable:=0;

  L_GUI.put_StaticText(dlg,
                       GetPStr(pCalc), id_STOffset, " 室  ",
                       pL_STOffset, pT_STOffset, sW_STOffset, sH_CalcST,
                       fS_CalcST, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);
  getControl(id_STOffset).Style.Font.Face:=fn;
  L_GUI.put_Edit(dlg,
                 GetPStr(pCalc), id_Days,
                 pL_Days, pT_Days, sW_Days, sH_Days, fS_CalcDays,
                 CONTROL.HorizontalAlignment_Right, L_GUI.br_st_Solid);
  getControl(id_Days).Style.Font.Face:=L_GUI.fn_CourierNew;
  getControl(id_Days).Style.Color.Copy(clNumeric);
  getControl(id_Days).OnSuccessfulChange:=PROCREF(Days_OnSuccessfulChange);
  getControl(id_Days).Value:=0;
  L_GUI.put_Edit(dlg,
                 GetPStr(pCalc), id_Offset,
                 pL_Offset, pT_Offset, sW_Offset, sH_CalcBtn, fS_CalcEdit,
                 CONTROL.HorizontalAlignment_Left, L_GUI.br_st_Solid);
  getControl(id_Offset).Style.Font.Face:=fn;
  getControl(id_Offset).OnSuccessfulChange:=PROCREF(Offset_OnSuccessfulChange);
  getControl(id_Offset).Value :=os_IncWorkD;
  getControl(id_Offset).Format:=os_Pool;
 END {CreateCalc};

 PRIVATE PROCEDURE CreateTempFiles();
 BEGIN
  IF !DATABASE.Get().Tables("clnd") THEN
   CreateFILE(clnd, "", "", "");
   CreateFIELD(clnd, Id,        STRING[10], "", "", "", "Id", "");
   CreateFIELD(clnd, MonthAmnt, NUMERIC[0], "", "", "", "⢮ 楢", "");
   CreateFIELD(clnd, D,         DATE,       "", "", "", " ", "");
   CreateFIELD(clnd, MinD,      DATE,       "", "", "", "쭠 ", "");
   CreateFIELD(clnd, MaxD,      DATE,       "", "", "", "ᨬ쭠 ", "");
   CreateFIELD(clnd, pL,        FLOAT, "", "0", "", "Left  孥 㣫", "");
   CreateFIELD(clnd, pT,        FLOAT, "", "0", "", "Top   孥 㣫", "");
   CreateFIELD(clnd, sW,        FLOAT, "", "0", "", "ਭ", "");
   CreateFIELD(clnd, sH,        FLOAT, "", "0", "", "", "");
   CreateFIELD(clnd, sWMonth,   FLOAT, "", "0", "", "ਭ ", "");
   CreateFIELD(clnd, sWDayBtn,  FLOAT, "", "0", "", "ਭ -", "");
   CreateFIELD(clnd, sHDayBtn,  FLOAT, "", "0", "", " -", "");
   CreateFIELD(clnd, sWPrevNextBtn, FLOAT, "", "0", "", "ਭ  <>", "");
   CreateFIELD(clnd, sWCurBtn,  FLOAT, "", "0", "", "ਭ    /", "");
   CreateFIELD(clnd, sHCurBtn,  FLOAT, "", "0", "", "    /", "");
   CreateFIELD(clnd, sWWeekDay, FLOAT, "", "0", "", "ਭ  ", "");
   CreateFIELD(clnd, sHWeekDay, FLOAT, "", "0", "", "  ", "");
   CreateINDEX(clnd, Id,  UNIQUE, "", "", Id);
   SetVersionOfFILE(clnd, 0000);
  END;
  L_AFM.AF_CreateTemp("clnd", "clnds");

  IF !DATABASE.Get().Tables("ClndHist") THEN
   CreateFILE(ClndHist, "", " 饭 ࠭", "");
   CreateFIELD(ClndHist, IdClnd,  STRING[10], "", "", "", "Id ", "");
   CreateFIELD(ClndHist, IdHist,  NUMERIC[0], "", "", "", "Id ਨ", "");
   CreateFIELD(ClndHist, CurPage, NUMERIC[0], "", "", "", " ࠭", "");
   CreateFIELD(ClndHist, D,       DATE,       "", "", "", " ", "");
   CreateFIELD(ClndHist, MinD,    DATE,       "", "", "", "쭠 ", "");
   CreateFIELD(ClndHist, MaxD,    DATE,       "", "", "", "ᨬ쭠 ", "");
   CreateINDEX(ClndHist, IdClnd,  UNIQUE, "", "", IdClnd, IdHist);
   SetVersionOfFILE(ClndHist, 0000);
  END;
  L_AFM.AF_CreateTemp("ClndHist", "ClndH");

  IF !DATABASE.Get().Tables("ClndWD") THEN
   CreateFILE(ClndWD, "", "", "");
   CreateFIELD(ClndWD, D,       DATE,       "", "", "", "", "");
   CreateFIELD(ClndWD, DayType, tDayType,   "", "", "", " ", "");
   CreateINDEX(ClndWD, D,  UNIQUE, "", "", D);
   SetVersionOfFILE(ClndWD, 0000);
  END;
  L_AFM.AF_CreateTemp("ClndWD", "ClndW");
 END {CreateTempFiles};

 PRIVATE PROCEDURE Gather_Clnd(SrcDate: DATE; VAR sW, sH, sW_Month: FLOAT);
  VAR
   cw, ch: NUMERIC[2];
 BEGIN
  DEFAULT(clnd);
  clnd.Id       :=id_ClndBig;
  clnd.pL       :=sW_MainShift;
  clnd.pT       :=sH_MainShift;
  GE_APPWIN_SIZE(cw, ch);
  clnd.sW       :=cw*bfs*3/5*5/6;
  clnd.sH       :=ch*bfs*5/6;
  clnd.D        :=SrcDate;
  clnd.MonthAmnt:=3;
  INSERT(clnd);
  clnd_UpdateMinMaxDates(1, pDate);
  CurClnd_SetSize();
  REPLACE(clnd);
  ClndBig_GetSizeMonth(sW, sH, sW_Month);

  ClndBig_GetSize(clnd.sH, clnd.sWPrevNextBtn, clnd.sWCurBtn, clnd.sHCurBtn, clnd.sWWeekDay, clnd.sHWeekDay, clnd.sWDayBtn, clnd.sHDayBtn);
  clnd.Id       :=id_ClndSrc;
  clnd.pL       :=sW_MainShift;
  clnd.pT       :=sH_MainShift;
  clnd.sW       :=sW_Month;
  clnd.sWMonth  :=sW_Month;
  clnd.D        :=SrcDate;
  clnd.MonthAmnt:=1;
  clnd_UpdateMinMaxDates(0, pDate);
  INSERT(clnd);

  ClndBig_GetSize(clnd.sH, clnd.sWPrevNextBtn, clnd.sWCurBtn, clnd.sHCurBtn, clnd.sWWeekDay, clnd.sHWeekDay, clnd.sWDayBtn, clnd.sHDayBtn);
  clnd.Id       :=id_ClndRes;
  clnd.pL       :=sW_MainShift + 2*(sW_Month + sW_SpaceBtwMonth);
  clnd.pT       :=sH_MainShift;
  clnd.sW       :=sW_Month;
  clnd.sWMonth  :=sW_Month;
  clnd.D        :=SrcDate;
  clnd.MonthAmnt:=1;
  clnd_UpdateMinMaxDates(0, pDate);
  INSERT(clnd);
 END {Gather_Clnd};

 PRIVATE PROCEDURE dlg_Resize();
 BEGIN
  dlg.StandardClientWidth :=sW + 2*sW_MainShift;
  dlg.StandardClientHeight:=sH + 2*sH_MainShift;
  dlg.ClientRect.Right    :=dlg.ClientRect.Left + dlg.StandardClientWidth;
  dlg.ClientRect.Bottom   :=dlg.ClientRect.Top  + dlg.StandardClientHeight;
 END {dlg_Resize};

 PRIVATE PROCEDURE CreateMainPage();
 BEGIN
  CreateCalendar(id_ClndBig);
  CreateCalendar(id_ClndSrc);
  CreateCalendar(id_ClndRes);
  CreateCalc(sW_Month, sH);
  dlg_Resize();
 END {CreateMainPage};

 PRIVATE PROCEDURE PosToClndHist(clnd_Id: STRING[10]): SCAL[2];
 BEGIN
  RETURN SELECT(ClndHist, IdClnd, clnd_Id) & LAST(ClndHist);
 END {PosToClndHist};

 PRIVATE PROCEDURE CreateDialog();
  VAR
   pl: PROMPT_LINE;
 BEGIN
  IF ~VAR_IMPL.Get(dlg).Initialized | !dlg THEN
   TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
    pl:=PROMPT_LINE.Create("  . ⮢ 㠫 ꥪ⮢ (  ⥫쭮 ६)");
    dlg                  :=L_GUI.CreateDialog(0);
    dlg.ReplaceMainWindow:=0;
    dlg.CaptionText      :=GetDlgCaptionText(0);
    dlg.ShowMouseCursor  :=1;
    dlg.WindowSizeStatus :=DIALOG.WindowSizeStatus_Restored;
    dlg.OnClose          :=PROCREF(OnClose_Dialog);
    CreateMainPage();
    dlgPagesCollection   :=L_GUI.pc_Get();
   EXCEPT
   ON Exc: Exc_TermByUser DO
    SETEMPTY(dlg);
    RAISE();
   END; (* TRY *)
  ELSE
   pl:=PROMPT_LINE.Create("⮢ 㠫 ꥪ⮢");
   L_GUI.pc_Set(dlgPagesCollection);
   getControl(id_Calc).Text:=ct_Calc;
   dlg.Visible:=1;
  END;
 END {CreateDialog};

 PRIVATE PROCEDURE OnClose_Dialog(d: DIALOG);
 BEGIN
  L_GUI.SetTaskBarVisible(1);
  d.Visible:=0;
 END {OnClose_Dialog};

 PRIVATE PROCEDURE SecondsLeft(prvHRT: FLOAT): NUMERIC[3];
 BEGIN
  RETURN HIGH_RESOLUTION_TIMER() - prvHRT;
 END {SecondsLeft};

 PRIVATE PROCEDURE idleProc();
 BEGIN
  IF SecondsLeft(HRT_Renew) >= refreshCycle_Renew THEN
   HRT_Renew:=HIGH_RESOLUTION_TIMER();
  END;
 END {idleProc};

 PRIVATE PROCEDURE PlayDialog();
 BEGIN
  HRT_Renew:=0;
  IF NeedRepaintDlg THEN
   ShowPage(pDate, CurClndId);
  END;

  dlg.Visible:=1;
  dlg.Redraw();
  TRY
   WHILE dlg.Visible DO
    idleProc();
    TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL), TERM_BY_USER(TERM_BY_USER_THROW)]
     dlg.Wait(0.5);
    EXCEPT
    ON Exc: Exc_TermByUser DO
     L_General.CallUs(PosToClndHist(CurClndId));
     IF ClndHist.CurPage = pDate THEN
      IF CurClndId = id_ClndBig THEN
       dlg.OnClose(dlg);
      ELSE
       OnClick_Calc(getControl(id_Calc));
      END;
     ELSE
      RemoveLastClndHist(CurClndId);
      L_General.CallUs(PosToClndHist(CurClndId));
      PosToClnd(CurClndId);
      PermPageId:=ClndHist.CurPage;
      clnd.D    :=ClndHist.D;
      clnd.MinD :=ClndHist.MinD;
      clnd.MaxD :=ClndHist.MaxD;
      REPLACE(clnd);
      clnd_ChangeSrcD(clnd.D, ClndHist.CurPage);
      ShowPage(ClndHist.CurPage, CurClndId);
     END;
    END;
   END; (* WHILE dlg.Visible *)
  EXCEPT
  FINALLY
   getControl(id_Calc).Style.Font.Face:=APP.Get().ProportionalFontFace;
   dlg.CaptionText:=GetDlgCaptionText(0);
   dlg.Visible:=0;
   dlg.Redraw();
  END;
 END {PlayDialog};

 PUBLIC PROCEDURE OnOpenCalendar(SrcDate: DATE): DATE;
 BEGIN
  ResDate:=SrcDate;
  NeedRepaintDlg:=~VAR_IMPL.Get(CurClndId).Initialized    |
                  ~VAR_IMPL.Get(PermDate).Initialized     |
                  ~VAR_IMPL.Get(PermPageId).Initialized   |
                  ~VAR_IMPL.Get(PermMonthIdx).Initialized |
                  (CurClndId    <> id_ClndBig)            |
                  (PermDate     <> SrcDate)               |
                  (PermPageId   <> pDate)                 |
                  (PermMonthIdx <> 1);
  IF !SrcDate THEN
   SrcDate:=SYSDATE();
  END;
  CurClndId    :=id_ClndBig;
  pPoolCntItems:=L_Str.CntItemsInPool(pPool);
  CreateColorsAndSizes();
  CreateTempFiles();
  Gather_Clnd(SrcDate, sW, sH, sW_Month);
  InsertClndHist(id_ClndBig, pDate);
  InsertClndHist(id_ClndSrc, pDate);
 
  CreateDialog();
  PlayDialog();
  PermDate:=ResDate;
  RETURN ResDate;
 END {OnOpenCalendar};

END.
