(*
%Copyright   (c) Polak Computer System
%Author      14.05.2002 14:35:58 SAN
%Type        report
%Specific    SYS
%Modified    18.08.2014 17:49:54 POLAK\Bor
%Environment
*)

 MODULE CN001 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_Basis, L_Str, L_XObj, L_Acnt, L_MathR, D_XObj, L_XDoc, L_JDoc, L_AFM,
        P_Firm, Str, FIO, L_bp;

 VAR
  curReportId : STRING[];
  curObjOrigin: STRING[];
  curObject   : STRING[];
  curObjName  : STRING[];
  curObjType  : STRING[];
  curOTName   : STRING[];
  curStorage  : LIKE(Storage.Storage);

  ac_AcCutName: LIKE(AcCut.Name) [MAXOF(AcCut.AcCut)+1];
  ac_CAcntSign: LIKE(CAcnt.Sign) [MAXOF(AcCut.AcCut)+1];
  ac_ACLogSign: LIKE(ACLog.Sign) [MAXOF(AcCut.AcCut)+1];
  ac_CAcntType: LIKE(CAcnt.Type) [MAXOF(AcCut.AcCut)+1];

  wMF         : SCAL[2];

 PRIVATE PROCEDURE MakeHeader();
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(curReportId, "");
   L_Basis.wb_WrInQM(curReportId, "");
  END;
  L_Basis.wb_WrInQM(curReportId, " ꥪ");
  L_Basis.wb_WrInQM(curReportId, "ꥪ");
  L_Basis.wb_WrInQM(curReportId, "ꥪ");
  L_Basis.wb_WrInQM(curReportId, "࣠");
  L_Basis.wb_WrInQM(curReportId, "࣠");
  L_Basis.wb_WrInQM(curReportId, " ꥪ⠊");
  L_Basis.wb_WrInQM(curReportId, " ꥪ");
  L_Basis.wb_WrInQM(curReportId, "吠१");
  L_Basis.wb_WrInQM(curReportId, "吠१");
  L_Basis.wb_WrInQM(curReportId, "吠१");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_WrInQM(curReportId, " ࠭");
  L_Basis.wb_WrInQM(curReportId, " ࠭");
  L_Basis.wb_WrInQM(curReportId, " 㬬");
  L_Basis.wb_WrInQM(curReportId, "㬬");
  L_Basis.wb_WrInQM(curReportId, "⢮");
  L_Basis.wb_WrInQM(curReportId, "㬬");
  L_Basis.wb_WrInQM(curReportId, "⢮");
  L_Basis.wb_WrInQM(curReportId, "१");
  L_Basis.wb_WrInQM(curReportId, "१");
  L_Basis.wb_WrInQM(curReportId, "१");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_TermLine(curReportId);
 END {MakeHeader};

 PRIVATE PROCEDURE AccessAcCut(trgAcCut: LIKE(AcCut.AcCut); D: DATE);
 BEGIN
  IF !ac_AcCutName[trgAcCut] THEN
   SEARCH(AcCut, AcCut, , trgAcCut);
   ac_AcCutName[trgAcCut]:=AcCut.Name;
   L_Acnt.StandOnCAcnt(D, trgAcCut);
   ac_CAcntSign[trgAcCut]:=CAcnt.Sign;
   ac_CAcntType[trgAcCut]:=CAcnt.Type;
   ac_ACLogSign[trgAcCut]:=L_Acnt.GetAcCutSign(D, trgAcCut);
  END;
 END {AccessAcCut};

 PRIVATE PROCEDURE MakePart(From,
                            UpTo    : DATE;
                            uavp    : L_Acnt.tUnfoldedAcntVectorPart;
                            _AcCut,
                            _AcCut2 : LIKE(AcCut.AcCut);
                            Shift   : NUMERIC[0];
                            frPYears: SCAL[2];
                            acnSum,
                            taxSum  : L_XObj.tSum;
                            acnQnt,
                            taxQnt  : L_XObj.tQnt);
 BEGIN
  IF (acnQnt # 0) | (acnSum # 0) | (taxQnt # 0) | (taxSum # 0) THEN
   IF wMF THEN
    L_Basis.wb_WrScl(curReportId, MyFirm.MyFirm);
    L_Basis.wb_WrStr(curReportId, MyFirm.vzSign);
   END;
   L_Basis.wb_WrStr(curReportId, curObjOrigin);
   L_Basis.wb_WrScl(curReportId, curObject);
   L_Basis.wb_WrStr(curReportId, curObjName);
   L_Basis.wb_WrScl(curReportId, Firm.Firm);
   L_Basis.wb_WrStr(curReportId, Firm.Name);
   L_Basis.wb_WrScl(curReportId, curObjType);
   L_Basis.wb_WrStr(curReportId, curOTName);
   AccessAcCut(_AcCut, UpTo);
   L_Basis.wb_WrScl(curReportId, _AcCut);
   L_Basis.wb_WrStr(curReportId, ac_AcCutName[_AcCut]);
   L_Basis.wb_WrStr(curReportId, ac_ACLogSign[_AcCut]);
   L_Basis.wb_WrStr(curReportId, ac_CAcntSign[_AcCut]);
   L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_Acnt.catyp_Pool, ac_CAcntType[_AcCut]));
   IF ~!curStorage THEN
    L_General.CallUs(SEARCH(Storage, Storage, curStorage));
    CONFORM(Storage, StrgKind);
    L_Basis.wb_WrStr(curReportId, StrgKind.Name);
    L_Basis.wb_WrScl(curReportId, Storage.Storage);
    L_Basis.wb_WrStr(curReportId, Storage.Name);
   ELSE
    L_Basis.wb_WrStr(curReportId, "---");
    L_Basis.wb_WrStr(curReportId, "---");
    L_Basis.wb_WrStr(curReportId, "---");
   END;
   L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_Acnt.uavp_Pool, uavp));
   L_Basis.wb_WrNum(curReportId, acnSum, 2);
   L_Basis.wb_WrNum(curReportId, acnQnt, GET_TYPE_SPEC(L_XObj.tQnt).Precision);
   L_Basis.wb_WrNum(curReportId, taxSum, 2);
   L_Basis.wb_WrNum(curReportId, taxQnt, GET_TYPE_SPEC(L_XObj.tQnt).Precision);
   IF (uavp = L_Acnt.uavp_CirCrd) | (uavp = L_Acnt.uavp_CirDbt) THEN
    AccessAcCut(_AcCut2, UpTo);
    L_Basis.wb_WrScl(curReportId, _AcCut2);
    L_Basis.wb_WrStr(curReportId, ac_AcCutName[_AcCut2]);
    L_Basis.wb_WrStr(curReportId, ac_ACLogSign[_AcCut2]);
    L_Basis.wb_WrStr(curReportId, ac_CAcntSign[_AcCut2]);
    L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_Acnt.catyp_Pool, ac_CAcntType[_AcCut2]));
   ELSE
    L_Basis.wb_WrStr(curReportId, "---");
    L_Basis.wb_WrStr(curReportId, "---");
    L_Basis.wb_WrStr(curReportId, "---");
    L_Basis.wb_WrStr(curReportId, "---");
    L_Basis.wb_WrStr(curReportId, "---");
   END;
   L_Basis.wb_WrNum(curReportId, Shift, 0);
   L_Basis.wb_WrStr(curReportId, L_Str.PoolItem("-|+", frPYears));
   L_Basis.wb_TermLine(curReportId);
  END;
 END {MakePart};

 PRIVATE PROCEDURE PrepareCurrents(From, UpTo: DATE; _XObject: LIKE(XObject.XObject));
  VAR
   _Firm  : LIKE(Firm.Firm);
   Section: L_XObj.tSection;
 BEGIN
  _Firm:=P_Firm.OWN_FIRM;
  SETEMPTY(curStorage);
  IF SEARCH(XObject, XObject, _XObject) THEN
   curObjOrigin:=L_Str.PoolItem(L_XObj.o_Pool, XObject.Origin);
   IF    XObject.Origin = L_XObj.o_Global THEN
    curObject :=XObject.XObject;
    curObjName:=L_XObj.GetXObjectOriginName();
    curObjType:=XObject.XObject;
    curOTName :="/";
   ELSE
    L_XObj.AccessOrigin();
    IF XObject.Origin = L_XObj.o_Contract THEN
     CONFORM(Contract, CntrT);
     curObject :=Contract.Contract;
     curObjName:=Contract.Name;
     _Firm     :=Contract.Firm;
     curObjType:=CntrT.CntrT;
     curOTName :=CntrT.Name;
    ELSIF (XObject.Origin = L_XObj.o_Math) | (XObject.Origin = L_XObj.o_KeyAss) THEN
     curStorage:=mItem.Storage;
     CONFORM(mItem, Math);
     curObject :=Math.Math;
     curObjName:=Math.Name;
     IF XObject.Origin = L_XObj.o_KeyAss THEN
      IF L_MathR.PosToKAGSoft(Math.Math, UpTo) THEN
       curObjType:=DeprecT.DeprecT;
       curOTName :=DeprecT.Name;
      ELSE
       curObjType:="--";
       curOTName :="---";
      END;
     ELSE
      CONFORM(Math, MathType);
      curObjType:=MathType.MathType;
      curOTName :=MathType.Name;
     END;
    ELSIF XObject.Origin = L_XObj.o_Man THEN
     L_XObj.AccessManByXObject(XObject.XObject);
     curObject :=Man.Man;
     curObjName:=Man.Name;
     curObjType:="--";
     curOTName :="--";
    ELSIF XObject.Origin = L_XObj.o_CostItem THEN
     curObject :=CostItem.CostItem;
     curObjName:=CostItem.Name;
     IF ~!CostItem.CIKind THEN
      CONFORM(CostItem, CIKind);
      curObjType:=CIKind.CIKind;
      curOTName :=CIKind.Name;
     ELSE
      curObjType:="";
      curOTName :="";
     END;
    ELSIF XObject.Origin = L_XObj.o_Staff THEN
     curObject:=Staff.TSN;
     CONFORM(Staff, Man);
     curObjName:=Man.Name;
     curObjType:="";
     curOTName :="";
    ELSE
     L_General.CallUs(0);
    END;
   END;
  ELSE
   Section:=L_XObj.DecodeConciseXOId(_XObject);
   IF ~!Section THEN
    curObject :=_XObject;
    curObjName:=" ꥪ";
    curObjType:="--";
    curOTName :="--";
    IF Section = L_XObj.s_Salary THEN
     curObjOrigin:="௫";
    ELSE
     L_General.CallUs(0);
    END;
   ELSE
    L_General.CallUs(0);
   END;
  END;
  L_General.CallUs(SEARCH(Firm, Firm, _Firm));
 END {PrepareCurrents};

 PRIVATE PROCEDURE MakeXObject(From, UpTo: DATE; _XObject: LIKE(XObject.XObject));
 BEGIN
  PrepareCurrents(From, UpTo, _XObject);
  L_Basis.wb_WrStr(curReportId, curObjOrigin);
  L_Basis.wb_WrScl(curReportId, curObject);
  L_Basis.wb_WrStr(curReportId, curObjName);
  L_Basis.wb_WrScl(curReportId, Firm.Firm);
  L_Basis.wb_WrStr(curReportId, Firm.Name);
  L_Basis.wb_WrScl(curReportId, curObjType);
  L_Basis.wb_WrStr(curReportId, curOTName);
  IF ~!curStorage THEN
   L_General.CallUs(SEARCH(Storage, Storage, curStorage));
   CONFORM(Storage, StrgKind);
   L_Basis.wb_WrStr(curReportId, StrgKind.Name);
   L_Basis.wb_WrScl(curReportId, Storage.Storage);
   L_Basis.wb_WrStr(curReportId, Storage.Name);
  ELSE
   L_Basis.wb_WrStr(curReportId, "---");
   L_Basis.wb_WrStr(curReportId, "---");
   L_Basis.wb_WrStr(curReportId, "---");
  END;
 END {MakeXObject};

 PRIVATE PROCEDURE MakeSaldo(From, UpTo: DATE; uavp: L_Acnt.tUnfoldedAcntVectorPart);
 BEGIN
  MakePart(From, UpTo, uavp,  XC001.Cut1, EMPTYOF(AcCut.AcCut), 0, 0,
           XC001.uav_aSum[uavp], XC001.uav_bSum[uavp], XC001.uav_aQnt[uavp], XC001.uav_bQnt[uavp]);
 END {MakeSaldo};

 PRIVATE PROCEDURE MakeCir(From, UpTo: DATE; uavp: L_Acnt.tUnfoldedAcntVectorPart);
  VAR
   fromPastYears: SCAL[2];
   ShiftValue   : NUMERIC[0];
 BEGIN
  fromPastYears:=0;
  IF XA001.WFDate  < From THEN
   ShiftValue:=-L_DatTim.MonthsInIntvl(XA001.WFDate, From);
   IF XA001.WFDate < L_DatTim.YearBeg(From) THEN
    fromPastYears:=1;
   END;
  ELSIF XA001.WFDate > UpTo THEN
   ShiftValue:=L_DatTim.MonthsInIntvl(UpTo, XA001.WFDate);
  ELSE
   ShiftValue:=0;
  END;
  IF    XA001.AK = L_Acnt.ak_Acn THEN
   MakePart(From, UpTo,
            uavp, XC001.Cut1, XA001.Cut2, ShiftValue, fromPastYears,
            XA001.Sum, 0,
            XA001.Qnt, 0);
  ELSIF XA001.AK = L_Acnt.ak_Tax THEN
   MakePart(From, UpTo,
            uavp, XC001.Cut1, XA001.Cut2, ShiftValue, fromPastYears,
            0, XA001.Sum,
            0, XA001.Qnt);
  ELSIF XA001.AK = L_Acnt.ak_Bth THEN
   MakePart(From, UpTo,
            uavp, XC001.Cut1, XA001.Cut2, ShiftValue, fromPastYears,
            XA001.Sum, XA001.Sum,
            XA001.Qnt, XA001.Qnt);
  ELSE
   L_General.CallUs(0);
  END;
 END {MakeCir};

 PRIVATE PROCEDURE DoXObject(From, UpTo: DATE; trgOM: L_XObj.tOriginsMap; trgMyFirm: P_Firm.tMyFirm);
 BEGIN
  D_XObj.PointwiseBuildXC001(D_XObj.XCC_FullWealth,
                             EMPTYOF(L_XObj.tSection),
                             L_Acnt.ak_Bth,
                             trgOM,
                             trgMyFirm,
                             D_XObj.XST_ByXObj,
                             D_XObj.XST_ByAcCut,
                             D_XObj.XST_ByAcCut2);
  SELECT(XC001, mfObject);
  WHILE OCCURE(XC001) DO
   PROMPT("㧪: " + XC001.Object + " " + XC001.Cut1);
   IF wMF THEN
    SEARCH(MyFirm, MyFirm, , XC001.MyFirm);
   END;
   PrepareCurrents(From, UpTo, XC001.Object);
   MakeSaldo(From, UpTo, L_Acnt.uavp_ISlDbt);
   MakeSaldo(From, UpTo, L_Acnt.uavp_ISlCrd);
   SELECT(XA001, mfObject, , XC001.MyFirm, XC001.Object, XC001.Cut1);
   WHILE OCCURE(XA001) DO
    IF XA001.CirType = L_Acnt.ct_Credit THEN
     MakeCir(From, UpTo, L_Acnt.uavp_CirCrd);
    ELSE
     MakeCir(From, UpTo, L_Acnt.uavp_CirDbt);
    END;
    NEXT(XA001);
   END; (* WHILE OCCURE(XA001)...*)
   MakeSaldo(From, UpTo, L_Acnt.uavp_OSlDbt);
   MakeSaldo(From, UpTo, L_Acnt.uavp_OSlCrd);
   NEXT(XC001);
  END; (* WHILE OCCURE(XC001) ... *)
  D_XObj.PurgeXC001();
 END {DoByXObject};

 PRIVATE PROCEDURE DoCN001(RepName: STRING[]; Selective: SCAL[2]);
  VAR
   trgOM    : L_XObj.tOriginsMap;
   trgMyFirm: P_Firm.tMyFirm;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_XObj.SetupOrigins(Selective, trgOM, trgMyFirm);
  SETEMPTY(ac_AcCutName);
  curReportId:="R";
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeHeader();
  DoXObject(Memo.ud_fr(), Memo.ud_ut(), trgOM, trgMyFirm);
  FIO.Close(R);
 END {DoCN001};

 PRIVATE PROCEDURE MakeCN020Header();
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(curReportId, "");
   L_Basis.wb_WrInQM(curReportId, "");
  END;
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, " ꥪ");
  L_Basis.wb_WrInQM(curReportId, " ꥪ⠊");
  L_Basis.wb_WrInQM(curReportId, " ꥪ");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, "吠१");
  L_Basis.wb_WrInQM(curReportId, "吠१");
  L_Basis.wb_WrInQM(curReportId, "吠१");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_WrInQM(curReportId, "१");
  L_Basis.wb_WrInQM(curReportId, "१");
  L_Basis.wb_WrInQM(curReportId, "१");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_WrInQM(curReportId, " 㬬");
  L_Basis.wb_WrInQM(curReportId, "㬬");
  L_Basis.wb_TermLine(curReportId);
 END {MakeCN020Header};

 PRIVATE PROCEDURE MakeCN020Part(From, UpTo: DATE);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrScl(curReportId, MyFirm.MyFirm);
   L_Basis.wb_WrStr(curReportId, MyFirm.vzSign);
  END;
  L_Basis.wb_WrDat(curReportId, XC020.P);
  L_Basis.wb_WrStr(curReportId, XC020.ObjOrigin);
  L_Basis.wb_WrScl(curReportId, XC020.ObjType);
  L_Basis.wb_WrStr(curReportId, XC020.OTName);
  L_Basis.wb_WrStr(curReportId, L_Str.PoolItem("-|+", XC020.DoAcnt));
  AccessAcCut(XC020.AcCut, UpTo);
  L_Basis.wb_WrScl(curReportId, XC020.AcCut);
  L_Basis.wb_WrStr(curReportId, ac_AcCutName[XC020.AcCut]);
  L_Basis.wb_WrStr(curReportId, ac_ACLogSign[XC020.AcCut]);
  L_Basis.wb_WrStr(curReportId, ac_CAcntSign[XC020.AcCut]);
  L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_Acnt.catyp_Pool, ac_CAcntType[XC020.AcCut]));

  IF (XC020.uavp = L_Acnt.uavp_CirCrd) | (XC020.uavp = L_Acnt.uavp_CirDbt) THEN
   AccessAcCut(XC020.AcCut2, UpTo);
   L_Basis.wb_WrScl(curReportId, XC020.AcCut2);
   L_Basis.wb_WrStr(curReportId, ac_AcCutName[XC020.AcCut2]);
   L_Basis.wb_WrStr(curReportId, ac_ACLogSign[XC020.AcCut2]);
   L_Basis.wb_WrStr(curReportId, ac_CAcntSign[XC020.AcCut2]);
   L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_Acnt.catyp_Pool, ac_CAcntType[XC020.AcCut2]));
  ELSE
   L_Basis.wb_WrStr(curReportId, "---");
   L_Basis.wb_WrStr(curReportId, "---");
   L_Basis.wb_WrStr(curReportId, "---");
   L_Basis.wb_WrStr(curReportId, "---");
   L_Basis.wb_WrStr(curReportId, "---");
  END;

  L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_Acnt.uavp_Pool, XC020.uavp));
  L_Basis.wb_WrNum(curReportId, XC020.Sum, 2);
  L_Basis.wb_TermLine(curReportId);
 END {MakeCN020Part};

 PRIVATE PROCEDURE AddXC020Saldo(P: DATE; uavp: L_Acnt.tUnfoldedAcntVectorPart);
 BEGIN
  ADD(XC020, XC020, , XC001.MyFirm, P, curObjOrigin, curObjType, curOTName, 1, XC001.Cut1, EMPTYOF(AcCut.AcCut), uavp,
                      XC020.Sum, XC001.uav_aSum[uavp]);
 END {AddXC020Saldo};

 PRIVATE PROCEDURE AddXC020Cir(P: DATE; uavp: L_Acnt.tUnfoldedAcntVectorPart);
 BEGIN
  ADD(XC020, XC020, , XA001.MyFirm, P, curObjOrigin, curObjType, curOTName, 1, XA001.Cut1, XA001.Cut2, uavp,
                      XC020.Sum, XA001.Sum);
 END {AddXC020Cir};

 PRIVATE PROCEDURE rev_uavp(cur_uavp: L_Acnt.tUnfoldedAcntVectorPart): L_Acnt.tUnfoldedAcntVectorPart;
 BEGIN
  IF    cur_uavp = L_Acnt.uavp_CirCrd THEN RETURN L_Acnt.uavp_CirDbt;
  ELSIF cur_uavp = L_Acnt.uavp_CirDbt THEN RETURN L_Acnt.uavp_CirCrd;
  ELSE
   L_General.CallUs(0);
  END;
 END {rev_uavp};

 PRIVATE PROCEDURE DoCN020(RepName: STRING[]);
  VAR
   trgOM     : L_XObj.tOriginsMap;
   trgMyFirm : P_Firm.tMyFirm;
   P,
   sav_fr,
   sav_ut    : DATE;
   cur_uavp  : L_Acnt.tUnfoldedAcntVectorPart;
   revSum    : L_XObj.tSum;
   oPrompt   : PROMPT_LINE;
 BEGIN
  sav_fr:=Memo.ud_fr();
  sav_ut:=Memo.ud_ut();
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

   L_AFM.MakeMultipleIndex("XC020", "MyFirm   : LIKE(MyFirm.MyFirm);" +
                                    "P        : DATE;" +
                                    "ObjOrigin: STRING[32];" +
                                    "ObjType  : STRING[9];" +
                                    "OTName   : STRING[64];" +
                                    "DoAcnt   : SCAL[2];" +
                                    "AcCut    : LIKE(AcCut.AcCut);" +
                                    "AcCut2   : LIKE(AcCut.AcCut);" +
                                    "uavp     : " + GET_TYPE_SPEC(L_Acnt.tUnfoldedAcntVectorPart).Name + ";" +
                                    "Sum      : " + GET_TYPE_SPEC(L_XObj.tSum).Name + ";",
                           "XC020: MyFirm, P, ObjOrigin, ObjType, OTName, DoAcnt, AcCut, AcCut2, uavp");


   L_AFM.MakeMultipleIndex("XA020", "MyFirm: LIKE(MyFirm.MyFirm);"+
                                    "P     : DATE;"+
                                    "AcCut : LIKE(AcCut.AcCut);"+
                                    "AcCut2: LIKE(AcCut.AcCut);"+
                                    "uavp  : "+GET_TYPE_SPEC(L_Acnt.tUnfoldedAcntVectorPart).Name+";"+
                                    "Sum   : "+GET_TYPE_SPEC(L_XObj.tSum).Name+";",
                           "XA020: MyFirm, P, AcCut, AcCut2, uavp");


   L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
   wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
   L_XObj.SetupOrigins(0, trgOM, trgMyFirm);
   curReportId:="R";
   FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
   MakeCN020Header();

   oPrompt:=PROMPT_LINE.Create("");
 
   P:=sav_fr;
   WHILE P < sav_ut DO
    oPrompt.Title:=L_DatTim.PeriodStr(P);

    Memo.UIP_SetIntvl(P, L_DatTim.MonthEnd(P));
    SETEMPTY(ac_AcCutName);
    D_XObj.extPointwiseBuildXC001(D_XObj.XCC_FullWealth,
                                  EMPTYOF(L_XObj.tSection),
                                  L_Acnt.ak_Bth,
                                  trgOM,
                                  trgMyFirm,
                                  D_XObj.XST_ByXObj,
                                  D_XObj.XST_ByAcCut,
                                  D_XObj.XST_ByAcCut2, 0);
 
    SELECT(XC001, mfObject);
    WHILE OCCURE(XC001) DO
     PrepareCurrents(P, L_DatTim.MonthEnd(P), XC001.Object);
     NARROWSEL(XC001, MyFirm, Object);
     WHILE OCCURE(XC001) DO
      PROMPT(XC001.MyFirm + " " + XC001.Object + " " + XC001.Cut1);

      AddXC020Saldo(P, L_Acnt.uavp_ISlDbt);
      AddXC020Saldo(P, L_Acnt.uavp_ISlCrd);
      AddXC020Saldo(P, L_Acnt.uavp_OSlDbt);
      AddXC020Saldo(P, L_Acnt.uavp_OSlCrd);

      SELECT(XA001, mfObject, , XC001.MyFirm, XC001.Object, XC001.Cut1);
      WHILE OCCURE(XA001) DO
       IF XA001.CirType = L_Acnt.ct_Credit THEN
        cur_uavp:=L_Acnt.uavp_CirCrd;
       ELSE
        cur_uavp:=L_Acnt.uavp_CirDbt;
       END;
       AddXC020Cir(P, cur_uavp);
       ADD(XA020, XA020, , XA001.MyFirm, P, XA001.Cut2, XA001.Cut1, rev_uavp(cur_uavp),
                           XA020.Sum, XA001.Sum);
       NEXT(XA001);
      END; (* WHILE OCCURE(XA001)...*)
      NEXT(XC001);
     END; (* WHILE OCCURE(XC001) ... *)
     NEXTINEXTENDEDSEL(XC001, MyFirm, Object);
    END; (* WHILE OCCURE(XC001) ... *)
    D_XObj.PurgeXC001();
    P:=L_DatTim.NextPer(P);
   END;
  EXCEPT
  FINALLY
   Memo.UIP_SetIntvl(sav_fr, sav_ut);
  END;

  SELECT(XA020, XA020);
  WHILE OCCURE(XA020) DO
   SAVE(XA020);
   IF SEARCH(XA020, XA020, XA020.MyFirm, XA020.P, XA020.AcCut2, XA020.AcCut, rev_uavp(XA020.uavp)) THEN
    revSum:=XA020.Sum;
   ELSE
    revSum:=0;
   END;
   RESTORE(XA020);
   IF XA020.Sum # revSum THEN
    ADD(XC020, XC020, , XA020.MyFirm, XA020.P, "---", "--", "--", 0, XA020.AcCut, XA020.AcCut2, XA020.uavp,
                        XC020.Sum, XA020.Sum - revSum);
   END;
   NEXT(XA020);
  END; (* WHILE OCCURE(XA020) ... *)

  oPrompt.Title:="㧪";
  SELECT(XC020, XC020);
  WHILE OCCURE(XC020) DO
   PROMPT(XC020.MyFirm+" "+L_DatTim.PeriodStr(XC020.P)+" "+XC020.ObjOrigin);
   SEARCH(MyFirm, MyFirm, , XC020.MyFirm);
   NARROWSEL(XC020, MyFirm, P, ObjOrigin);
   WHILE OCCURE(XC020) DO
    MakeCN020Part(Memo.ud_fr(), Memo.ud_ut());
    NEXT(XC020);
   END; (* WHILE OCCURE(XC020) ... *)
   NEXTINEXTENDEDSEL(XC020, MyFirm, P, ObjOrigin);
  END; (* WHILE OCCURE(XC020) ... *)
  FIO.Close(R);
 END {DoCN020};

 PRIVATE PROCEDURE MakeCN011Header();
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(curReportId, "");
   L_Basis.wb_WrInQM(curReportId, "");
  END;
  L_Basis.wb_WrInQM(curReportId, " 㬥");
  L_Basis.wb_WrInQM(curReportId, " 㬥");
  L_Basis.wb_WrInQM(curReportId, "㬥");
  L_Basis.wb_WrInQM(curReportId, " 㬥");
  L_Basis.wb_WrInQM(curReportId, " ꥪ");
  L_Basis.wb_WrInQM(curReportId, "ꥪ");
  L_Basis.wb_WrInQM(curReportId, "ꥪ");
  L_Basis.wb_WrInQM(curReportId, "࣠");
  L_Basis.wb_WrInQM(curReportId, "࣠");
  L_Basis.wb_WrInQM(curReportId, " ꥪ⠊");
  L_Basis.wb_WrInQM(curReportId, " ꥪ");
  L_Basis.wb_WrInQM(curReportId, "吠१");
  L_Basis.wb_WrInQM(curReportId, "吠१");
  L_Basis.wb_WrInQM(curReportId, "吠१");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_WrInQM(curReportId, " ࠭");
  L_Basis.wb_WrInQM(curReportId, " ࠭");
  L_Basis.wb_WrInQM(curReportId, " 㬬");
  L_Basis.wb_WrInQM(curReportId, "㬬");
  L_Basis.wb_WrInQM(curReportId, "⢮");
  L_Basis.wb_WrInQM(curReportId, "१");
  L_Basis.wb_WrInQM(curReportId, "१");
  L_Basis.wb_WrInQM(curReportId, "१");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_TermLine(curReportId);
 END {MakeCN011Header};

 PRIVATE PROCEDURE MakeCN011Part(From, UpTo: DATE; leftSide, Shift: NUMERIC[0]; frPYears: SCAL[2]);
  VAR
   _XObject : LIKE(XObject.XObject);
   _AcCut,
   _AcCut2  : LIKE(AcCut.AcCut);
   _Apport  : LIKE(Apport.Apport);
   _wQnt    : SCAL[2];
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
   _XDoc    : L_XDoc.tXDoc;
 BEGIN
  IF leftSide THEN
   _XObject:=XDocApr.XObject;
   _AcCut  :=XDocApr.AcCut;
   _AcCut2 :=XDocApr.AcCut2;
   _Apport :=XDocApr.Apport;
   _wQnt   :=XDocApr.wQnt MOD 2;
  ELSE
   _XObject:=XDocApr.XObject2;
   _AcCut  :=XDocApr.AcCut2;
   _AcCut2 :=XDocApr.AcCut;
   _Apport :=XDocApr.Apport2;
   _wQnt   :=XDocApr.wQnt DIV 2;
  END;
  IF ~!_XObject & ((XDocApr.Sum # 0) | (_wQnt & (XDocApr.Qnt # 0))) THEN
   PrepareCurrents(From, UpTo, _XObject);
   IF wMF THEN
    L_Basis.wb_WrScl(curReportId, MyFirm.MyFirm);
    L_Basis.wb_WrStr(curReportId, MyFirm.vzSign);
   END;

   L_XDoc.DecodeXDocId(XDocApr.XDocId, _XDocType, _XDocKind, _XDoc);
   L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_XDoc.ref_ShortNames, _XDocType));
   L_Basis.wb_WrStr(curReportId, L_XDoc.GetDocKindDescription(_XDocType, L_XDoc.xdast_Simple));
   L_Basis.wb_WrStr(curReportId, _XDoc);
   L_Basis.wb_WrDat(curReportId, L_XDoc.GetXDocDate(XDocApr.XDocId));
   L_Basis.wb_WrStr(curReportId, curObjOrigin);
   L_Basis.wb_WrScl(curReportId, curObject);
   L_Basis.wb_WrStr(curReportId, curObjName);
   L_Basis.wb_WrScl(curReportId, Firm.Firm);
   L_Basis.wb_WrStr(curReportId, Firm.Name);
   L_Basis.wb_WrScl(curReportId, curObjType);
   L_Basis.wb_WrStr(curReportId, curOTName);
   AccessAcCut(_AcCut, UpTo);
   L_Basis.wb_WrScl(curReportId, _AcCut);
   L_Basis.wb_WrStr(curReportId, ac_AcCutName[_AcCut]);
   L_Basis.wb_WrStr(curReportId, ac_ACLogSign[_AcCut]);
   L_Basis.wb_WrStr(curReportId, ac_CAcntSign[_AcCut]);
   L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_Acnt.catyp_Pool, ac_CAcntType[_AcCut]));
   IF ~!curStorage THEN
    L_General.CallUs(SEARCH(Storage, Storage, curStorage));
    CONFORM(Storage, StrgKind);
    L_Basis.wb_WrStr(curReportId, StrgKind.Name);
    L_Basis.wb_WrScl(curReportId, Storage.Storage);
    L_Basis.wb_WrStr(curReportId, Storage.Name);
   ELSE
    L_Basis.wb_WrStr(curReportId, "---");
    L_Basis.wb_WrStr(curReportId, "---");
    L_Basis.wb_WrStr(curReportId, "---");
   END;
   SEARCH(Apport, Apport, , _Apport);
   IF Apport.CirType = L_Acnt.ct_Credit THEN
    L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_Acnt.uavp_Pool, L_Acnt.uavp_CirCrd));
   ELSE
    L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_Acnt.uavp_Pool, L_Acnt.uavp_CirDbt));
   END;
   L_Basis.wb_WrNum(curReportId, XDocApr.Sum, 2);
   IF _wQnt THEN
    L_Basis.wb_WrNum(curReportId, XDocApr.Qnt, GET_TYPE_SPEC(L_XObj.tQnt).Precision);
   ELSE
    L_Basis.wb_WrNum(curReportId, 0, GET_TYPE_SPEC(L_XObj.tQnt).Precision);
   END;
   AccessAcCut(_AcCut2, UpTo);
   L_Basis.wb_WrScl(curReportId, _AcCut2);
   L_Basis.wb_WrStr(curReportId, ac_AcCutName[_AcCut2]);
   L_Basis.wb_WrStr(curReportId, ac_ACLogSign[_AcCut2]);
   L_Basis.wb_WrStr(curReportId, ac_CAcntSign[_AcCut2]);
   L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_Acnt.catyp_Pool, ac_CAcntType[_AcCut2]));
   L_Basis.wb_WrNum(curReportId, Shift, 0);
   L_Basis.wb_WrStr(curReportId, L_Str.PoolItem("-|+", frPYears));
   L_Basis.wb_TermLine(curReportId);
  END;
 END {MakeCN011Part};

 PRIVATE PROCEDURE DoXDocAprs(From, UpTo: DATE);
  VAR
   ShiftValue: NUMERIC[0];
   fromPastYears: SCAL[2];
 BEGIN
  SELECT(XDocApr, AcCut);
  WHILE OCCURE(XDocApr) DO
   NARROWSEL(XDocApr, AcCut);
   SRCINSEL(XDocApr, GE, , From);
   WHILE OCCURE(XDocApr) & (XDocApr.XDat <= UpTo) DO
    PROMPT("१ " + XDocApr.AcCut + " " +  XDocApr.XDocId);
    IF (XDocApr.Sum # 0) | (XDocApr.Qnt # 0) THEN
     L_XDoc.PositionOnXDoc(XDocApr.XDocId);
     P_Firm.PositionOnMyFirm(L_XDoc.GetMyFirmByXDocId(XDocApr.XDocId));
     ShiftValue:=L_DatTim.MonthsInIntvl(XDocApr.XDat, XDocApr.WFDate);
     fromPastYears:=(XDocApr.WFDate < L_DatTim.YearBeg(From));
     MakeCN011Part(From, UpTo, 0, ShiftValue, fromPastYears);
     MakeCN011Part(From, UpTo, 1, ShiftValue, fromPastYears);
    END;
    NEXT(XDocApr);
   END; (* WHILE OCCURE(XDocApr) ... *)
   NEXTINEXTENDEDSEL(XDocApr, AcCut);
  END; (* WHILE OCCURE(XDocApr) ... *)
 END {DoXDocAprs};

 PUBLIC PROCEDURE DoCN011();
  CONST
   bpId = "CN011";
 BEGIN
  L_bp.Begin(bpId, "஢  㬥⠬", L_bp.t_Basis, L_General.tc_inMonth);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());

  SETEMPTY(ac_AcCutName);
  curReportId:="R";
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeCN011Header();
  DoXDocAprs(Memo.ud_mb(), Memo.ud_me());
  FIO.Close(R);
  L_bp.End();
 END {DoCN011};

 PRIVATE PROCEDURE MakeJD001Header();
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(curReportId, "");
   L_Basis.wb_WrInQM(curReportId, "");
  END;

  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, "室 ");
  L_Basis.wb_WrInQM(curReportId, "室 ");

  L_Basis.wb_WrInQM(curReportId, " ப");
  L_Basis.wb_WrInQM(curReportId, "騩");

  L_Basis.wb_WrInQM(curReportId, " ꥪ");
  L_Basis.wb_WrInQM(curReportId, "ꥪ");
  L_Basis.wb_WrInQM(curReportId, "ꥪ");
  L_Basis.wb_WrInQM(curReportId, "࣠");
  L_Basis.wb_WrInQM(curReportId, "࣠");
  L_Basis.wb_WrInQM(curReportId, " ꥪ⠊");
  L_Basis.wb_WrInQM(curReportId, " ꥪ");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_WrInQM(curReportId, " ࠭");
  L_Basis.wb_WrInQM(curReportId, " ࠭");
  L_Basis.wb_WrInQM(curReportId, "吠१");
  L_Basis.wb_WrInQM(curReportId, "吠१");
  L_Basis.wb_WrInQM(curReportId, "吠१");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_WrInQM(curReportId, "१");
  L_Basis.wb_WrInQM(curReportId, "१");
  L_Basis.wb_WrInQM(curReportId, "१");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, " ");

  L_Basis.wb_WrInQM(curReportId, " 㬬");
  L_Basis.wb_WrInQM(curReportId, "㬬");
  L_Basis.wb_WrInQM(curReportId, "⢮");

  L_Basis.wb_TermLine(curReportId);
 END {MakeJD001Header};

 PRIVATE PROCEDURE MakeAcCut(trgAcCut: LIKE(AcCut.AcCut); D: DATE);
 BEGIN
  AccessAcCut(trgAcCut, D);
  L_Basis.wb_WrScl(curReportId, trgAcCut);
  L_Basis.wb_WrStr(curReportId, ac_AcCutName[trgAcCut]);
  L_Basis.wb_WrStr(curReportId, ac_ACLogSign[trgAcCut]);
  L_Basis.wb_WrStr(curReportId, ac_CAcntSign[trgAcCut]);
  L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_Acnt.catyp_Pool, ac_CAcntType[trgAcCut]));
 END {MakeAcCut};

 PRIVATE PROCEDURE GetCirType(curApport, corApport: LIKE(Apport.Apport)): LIKE(Apport.CurType);
 BEGIN
  IF    ~!curApport THEN
   SEARCH(Apport, Apport, , curApport);
   RETURN Apport.CirType;
  ELSIF ~!corApport THEN
   SEARCH(Apport, Apport, , corApport);
   RETURN ~Apport.CirType;
  ESLE
   L_General.CallUs(0);
  END;
 END {GetCirType};

 PRIVATE PROCEDURE MakeJD001Part(From, UpTo: DATE; leftSide: SCAL[2]);
  VAR
   curXObject: LIKE(XObject.XObject);
   curAcCut: LIKE(AcCut.AcCut);
   corXObject: LIKE(XObject.XObject);
   corAcCut: LIKE(AcCut.AcCut);
   _wQnt: LIKE(JDocList.wQnt);
   _Qnt: LIKE(JDocList.Qnt);
   _Apport: LIKE(JDocList.Apport);
 BEGIN
  IF leftSide THEN
   curXObject:=JDocList.XObject;
   curAcCut:=JDocList.AcCut;
   _wQnt:=JDocList.wQnt;
   _Apport:=JDocList.Apport;

   corXObject:=JDocList.XObject2;
   corAcCut:=JDocList.AcCut2;
  ELSE
   curXObject:=JDocList.XObject2;
   curAcCut:=JDocList.AcCut2;
   _wQnt:=JDocList.wQnt2;
   _Apport:=JDocList.Apport2;

   corXObject:=JDocList.XObject;
   corAcCut:=JDocList.AcCut;
  END;
  IF _wQnt THEN
   _Qnt:=JDocList.Qnt;
  ELSE
   _Qnt:=0;
  END;

  IF ~!curXObject THEN
   IF wMF THEN
    CONFORM(JDoc, MyFirm);
    L_Basis.wb_WrScl(curReportId, MyFirm.MyFirm);
    L_Basis.wb_WrStr(curReportId, MyFirm.vzSign);
   END;
 
   L_Basis.wb_WrStr(curReportId, L_JDoc.JDocKindNick(JDoc.JDocKind));
   L_Basis.wb_WrScl(curReportId, JDoc.JDoc);
   L_Basis.wb_WrDat(curReportId, JDoc.Date);
   L_Basis.wb_WrStr(curReportId, JDoc.SrcNbr);
   L_Basis.wb_WrDat(curReportId, JDoc.SrcDate);
 
   L_Basis.wb_WrScl(curReportId, JDocList.JDLNbr);
   L_Basis.wb_WrStr(curReportId, L_Str.PoolItem("-|+", JDoc.SubstAM));
   MakeXObject(From, UpTo, curXObject);
   MakeAcCut(curAcCut, UpTo);
   MakeAcCut(corAcCut, UpTo);
 
   SEARCH(Apport, Apport, , _Apport);
   IF Apport.CirType = L_Acnt.ct_Credit THEN
    L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_Acnt.uavp_Pool, L_Acnt.uavp_CirCrd));
   ELSE
    L_Basis.wb_WrStr(curReportId, L_Str.PoolItem(L_Acnt.uavp_Pool, L_Acnt.uavp_CirDbt));
   END;
   L_Basis.wb_WrNum(curReportId, JDocList.Sum, 2);
   L_Basis.wb_WrNum(curReportId, _Qnt, GET_TYPE_SPEC(L_XObj.tQnt).Precision);
   L_Basis.wb_TermLine(curReportId);
  END;
 END {MakeJD001Part};

 PRIVATE PROCEDURE MakeOneJDocList(From, UpTo: DATE);
 BEGIN
  MakeJD001Part(From, UpTo, 1);
  MakeJD001Part(From, UpTo, 0);
 END {MakeOneJDocList};

 PUBLIC PROCEDURE DoJD001();
  CONST
   bpId = "JD001";
 BEGIN
  L_bp.Begin(bpId, "ୠ 㬥", L_bp.t_Basis, L_General.tc_inIntvl);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  SETEMPTY(ac_AcCutName);
  curReportId:="R";
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeJD001Header();
 
  SETSEL(JDoc, Date);
  SRCINSEL(JDoc, GE, , Memo.ud_fr());
  WHILE OCCURE(JDoc) & (JDoc.Date <= Memo.ud_ut()) DO
   PROMPT(L_DatTim.DateStr(JDoc.Date)+" "+L_JDoc.JDocStr(JDoc.JDocKind, JDoc.JDoc));
   IF JDoc.Status = L_JDoc.st_Passed THEN
    CONFORM(JDoc, JDocList);
    WHILE OCCURE(JDocList) DO
     MakeOneJDocList(Memo.ud_fr(), Memo.ud_ut());
     NEXT(JDocList);
    END; (* WHILE OCCURE(JDocList) ... *)
   END;
   NEXT(JDoc);
  END; (* WHILE OCCURE(JDoc) ... *)
  FIO.Close(R);
  L_bp.End();
 END {DoJD001};

 PUBLIC PROCEDURE CN001();
  CONST
   bpId = "CN001";
 BEGIN
  L_bp.Begin(bpId, " ⮢", L_bp.t_Basis, L_General.tc_inIntvl);
  DoCN001(bpId, 0);
  L_bp.End();
 END {CN001};

 PUBLIC PROCEDURE CN001_Custom();
  CONST
   RepName  = "CN001";
   RepTitle = "롮  ⮢";
 BEGIN
  APP.Get().NewPrompt("("+RepName+") "+RepTitle);
  DoCN001(RepName, 1);
  L_Basis.PlayMakedRunTimeRep(RepName, L_General.tc_inIntvl, RepTitle, 0);
 END {CN001_Custom};

 PUBLIC PROCEDURE CN020();
  CONST
   bpId = "CN020";
 BEGIN
  L_bp.Begin(bpId, " ⮢ (ᢥ)", L_bp.t_Basis, L_General.tc_inIntvl);
  DoCN020(bpId);
  L_bp.End();
 END {CN020};

END.
