(*
%Copyright   (c) Polak Computer System
%Author      27.08.2002 13:25:28 SAN
%Purpose     ନ஢  㯮  த
%Type        report
%Specific    SYS
%Modified    05.09.2014 14:10:05 POLAK\Bor
%Environment
*)

 MODULE Cn002 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_AFM, L_DatTim, L_Str, L_XDoc, L_MDoc, L_PDoc, L_Pmnt, L_Russia, L_Excel,
        L_StdFrm, L_MSO, L_APtm, L_AcCut, L_Cntr, L_XObj, L_Acnt, L_ExtDB, L_FIO,
        P_Firm, P_Math, P_Cntr, P_MDoc, Str, FIO, DBF, E_Utils;

 PRIVATE TYPE
  tWFStyle = SCAL[4];

 PRIVATE CONST
  DEBUG = 0;
  ItogoDest = 000;

  wfs_Book     = 0;
  wfs_AddSheet = 1;
  wfs_AS_Itogo = 2;
  wfs_Inquiry  = 3;

  wfs_Pool = ["", "", "'⮣'  ", "ࠢ筮"];

 PRIVATE VAR
  Cn002_From,
  Cn002_UpTo,
  Cn002_WFPeriod : DATE;
  wMF            : SCAL[2];

 PRIVATE PROCEDURE Create_TemporaryFiles();
 BEGIN
  CREATE_TABLE(MDIdx);
  CREATE_FIELD(MDIdx, pblDate,     DATE);
  CREATE_FIELD(MDIdx, Period,      DATE);
  CREATE_FIELD(MDIdx, WFPeriod,    DATE);
  CREATE_FIELD(MDIdx, ItWas,       SCAL[2]);
  CREATE_FIELD(MDIdx, srcMDocKind, SCAL[1E2]);
  CREATE_FIELD(MDIdx, srcMDoc,     SCAL[1E7]);
  CREATE_FIELD(MDIdx, BldMode,     L_Pmnt.tVATMDocBuildMode);
  CREATE_FIELD(MDIdx, MDocKind,    SCAL[1E2]);
  CREATE_FIELD(MDIdx, MDoc,        SCAL[1E7]);
  CREATE_INDEX(MDIdx, ToPrint,  PLURAL, , , WFPeriod, Period, pblDate, srcMDoc);
  CREATE_INDEX(MDIdx, ToInquir, PLURAL, , , Period, pblDate, srcMDoc);
  CREATE_INDEX(MDIdx, ItWas, PLURAL, , , Period, ItWas, pblDate, srcMDoc);
  CREATE_INDEX_AND_LINK(MDIdx, MDoc, PLURAL, MDoc, MDoc, USER, , , MDocKind, MDoc);
  SET_VERSION_OF_TABLE(MDIdx, 0000);

  CREATE_TABLE(DsTot);
  CREATE_FIELD(DsTot, Dest,    SCAL[1E3]);
  CREATE_FIELD(DsTot, Overall, L_XObj.tSum, ,             "0");
  CREATE_FIELD(DsTot, Netto,   L_Pmnt.tValuesByVATRate, , "0");
  CREATE_FIELD(DsTot, VAT,     L_Pmnt.tValuesByVATRate, , "0");
  CREATE_FIELD(DsTot, rbVAT,   L_XObj.tSum, ,             "0");
  CREATE_INDEX_AND_LINK(DsTot, Dest, UNIQUE, Dest, Dest, USER, , , Dest);
  SET_VERSION_OF_TABLE(DsTot, 0000);

  CREATE_TABLE(CntrV);
  CREATE_FIELD(CntrV, Contract,  LIKE(Contract.Contract));
  CREATE_FIELD(CntrV, InitIsDn,   SCAL[2], ,     "0");
  CREATE_FIELD(CntrV, ded_xc_d68, L_XObj.tSum, , "0", , "⫮  室   .   楢 ", "");
  CREATE_FIELD(CntrV, ded_rs_d68, L_XObj.tSum, , "0", , "⮪  ded_xc_d68 ᫥ । ", "");
  CREATE_FIELD(CntrV, atc_xc_d68, L_XObj.tSum, , "0", , "⫮  室   ⮨.   楢 ", "");
  CREATE_FIELD(CntrV, atc_rs_d68, L_XObj.tSum, , "0", , "⮪  atc_xc_d68 ᫥ । ", "");
  CREATE_FIELD(CntrV, xc_rbV,     L_XObj.tSum, , "0", , "    楢 ", "");
  CREATE_FIELD(CntrV, pb_rbV,     L_XObj.tSum, , "0", , "    㯮", "");
  CREATE_INDEX_AND_LINK(CntrV, Contract, UNIQUE, Contract, Contract, USER, , , Contract);
  SET_VERSION_OF_TABLE(CntrV, 0000);

(*
  CREATE_TABLE(ASPer, , "ਮ,     ਮ  ");
  CREATE_FIELD(ASPer, Per, DATE);
  CREATE_FIELD(ASPer, WFPeriod, DATE);
*)
 END {Create_TemporaryFiles};

 PRIVATE PROCEDURE CteateTemp();
 BEGIN
  L_AFM.CreateTemp("MDIdx");
  L_AFM.CreateTemp("DsTot");
  L_AFM.CreateTemp("CntrV");
 END {CteateTemp};

 PRIVATE PROCEDURE ClearTemp();
 BEGIN
  SETSEL(MDIdx, MDoc);
  REMSEL(MDIdx);
  SETSEL(DsTot, Dest);
  REMSEL(DsTot);
  SETSEL(CntrV, Contract);
  REMSEL(CntrV);
 END {ClearTemp};

 PRIVATE PROCEDURE Purge_TemporaryFiles();
 BEGIN
  L_AFM.AF_PurgeTemp("DsTot");
  L_AFM.AF_PurgeTemp("MDIdx");
  L_AFM.AF_PurgeTemp("CntrV");
 END {Purge_TemporaryFiles};

 PRIVATE PROCEDURE PutInMDIdx(srcMDocKind: LIKE(MDoc.MDocKind);
                              srcMDoc    : LIKE(MDoc.MDoc);
                              BldMode    : L_Pmnt.tVATMDocBuildMode);
 BEGIN
  DEFAULT(MDIdx);
  MDIdx.srcMDocKind:=srcMDocKind;
  MDIdx.srcMDoc    :=srcMDoc;
  MDIdx.BldMode    :=BldMode;
  MDIdx.pblDate    :=MDoc.Date;
  MDIdx.Period     :=L_Pmnt.ConvPer2VATClcPer(L_DatTim.Per(MDoc.Date));
  MDIdx.WFPeriod   :=MDoc.WFPeriod;
  MDIdx.ItWas      :=(MDIdx.WFPeriod >= MDIdx.Period) & (MDIdx.WFPeriod < Cn002_WFPeriod);
  MDIdx.MDocKind   :=MDoc.MDocKind;
  MDIdx.MDoc       :=MDoc.MDoc;
  INSERT(MDIdx);
 END {PutInMDIdx};

 PRIVATE PROCEDURE FindSrcMDoc(VAR srcMDocKind: LIKE(MDoc.MDocKind);
                               VAR srcMDoc    : LIKE(MDoc.MDoc));
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
 BEGIN
  SAVE(MDoc);
  SETEMPTY(srcMDoc);
  IF (MDoc.Status = L_MDoc.st_Passed) & L_Pmnt.E_IsAcptMDoc() THEN
   CONFORM(MDoc, Contract);
   i:=0;
   DependentMDocs:=L_MDoc.GetDependentMDocXDC();
   WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) & !srcMDoc DO
    IF (MDoc.Status = L_MDoc.st_Passed) &
       L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Acceptance) THEN
     srcMDocKind:=MDoc.MDocKind;
     srcMDoc    :=MDoc.MDoc;
    END;
    INC(i);
   END; (* WHILE L_XDoc.xdc_PositionOn ... *)
(* 0067963 19.01.2009 13:59:23 POLAK\Bor
   L_General.Assert(~!srcMDoc, " ନ஢ 㬥      ॠ樨");
*)
  ELSE
   i:=0;
   DependentMDocs:=L_MDoc.GetDependentMDocXDC();
   WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) & !srcMDoc DO
    FindSrcMDoc(srcMDocKind, srcMDoc);
    INC(i);
   END; (* WHILE OCCURE(MDoc) ... *)
  END;
  RESTORE(MDoc);
 END {FindSrcMDoc};

 PRIVATE PROCEDURE PutByRef(bm: L_Pmnt.tVATMDocBuildMode);
  VAR
   refToXDocId: L_XDoc.tXDocId;
   srcMDocKind: LIKE(MDoc.MDocKind);
   srcMDoc    : LIKE(MDoc.MDoc);
   _Contract  : LIKE(MDoc.Contract);
   RefToXDC   : L_XDoc.tXDocCollection;
   rbm        : L_Pmnt.tVATMDocBuildMode;
   i          : NUMERIC[0];
 BEGIN
  refToXDocId:=L_XDoc.GetBaseOnXDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
  IF L_XDoc.ExtractXDocType(refToXDocId) = L_XDoc.xdt_PDoc THEN
   rbm:=L_Pmnt.vmdbm_GetRelatedBM(bm);
   IF ~!rbm THEN
    SETEMPTY(refToXDocId);
    SAVE(MDoc);
    i:=0;
    RefToXDC:=L_XDoc.GetRefToXDC(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_MDoc);
    WHILE L_XDoc.xdc_PositionOn(RefToXDC, i) & !refToXDocId DO
     IF L_Pmnt.IsSpecifiedVATMDoc(rbm) THEN
      refToXDocId:=L_XDoc.GetBaseOnXDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
     END;
     INC(i);
    END;
    RESTORE(MDoc);
   END;
  END;
  L_General.Assert(~!refToXDocId,
                   L_XDoc.XDocStr(L_XDoc.curXDocId(L_XDoc.xdt_MDoc)) + " - 㬥   ஢  'த⥫'");
  SAVE(MDoc);
  _Contract:=MDoc.Contract;
  L_XDoc.PositionOnXDoc(refToXDocId);
  IF    L_XDoc.ExtractXDocType(refToXDocId) = L_XDoc.xdt_MDoc THEN
   FindSrcMDoc(srcMDocKind, srcMDoc);
  ELSIF L_XDoc.ExtractXDocType(refToXDocId) = L_XDoc.xdt_PDoc THEN
   SETEMPTY(srcMDoc);
   CONFORM(PDoc, PDocMDoc);
   WHILE OCCURE(PDocMDoc) & !srcMDoc DO
    CONFORM(PDocMDoc, MDoc);
    IF (MDoc.Contract = _Contract) THEN
     FindSrcMDoc(srcMDocKind, srcMDoc);
    END;
    NEXT(PDocMDoc);
   END; (* WHILE OCCURE(PDocMDoc) ... *)
  ELSE
   L_General.CallUs(0);
  END;
  RESTORE(MDoc);
  IF ~!srcMDoc THEN
   PutInMDIdx(srcMDocKind, srcMDoc, bm);
  ELSE
   (* ⮫쪮    㦥  祬 *)
   PutInMDIdx(EMPTYOF(MDoc.MDocKind), EMPTYOF(MDoc.MDoc), bm);
  END;
 END {PutByRef};

 PRIVATE PROCEDURE Put(Sale: SCAL[2]);
  CONST
   PutPrpReturnInPrcBookBegDate = 01\08\2002;
 BEGIN
  IF Sale THEN
   IF    L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Acceptance) THEN
    PutInMDIdx(MDoc.MDocKind, MDoc.MDoc, L_Pmnt.vmdbm_Acceptance);
   ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Prepayment) THEN
    PutInMDIdx(MDoc.MDocKind, MDoc.MDoc, L_Pmnt.vmdbm_Prepayment);
   ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Underpay) THEN
    PutByRef(L_Pmnt.vmdbm_Underpay);
   ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Pstpayment) THEN
    PutByRef(L_Pmnt.vmdbm_Pstpayment);
   ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_OnPrpShpmt) THEN
    IF MDoc.Date < PutPrpReturnInPrcBookBegDate THEN
     PutByRef(L_Pmnt.vmdbm_OnPrpShpmt);
    ELSE
     (* PUT THIS IN PURCHASE *)
    END;
   ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrpReturn) THEN
    IF MDoc.Date < PutPrpReturnInPrcBookBegDate THEN
     PutByRef(L_Pmnt.vmdbm_PrpReturn);
    ELSE
     (* PUT THIS IN PURCHASE *)
    END;
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   IF MDoc.MDocKind = L_MDoc.md_DPr THEN
    IF    L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrpReturn) THEN
     PutByRef(L_Pmnt.vmdbm_PrpReturn);
    ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_OnPrpShpmt) THEN
     PutByRef(L_Pmnt.vmdbm_OnPrpShpmt);
    END;
   ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Acceptance) THEN
    PutInMDIdx(MDoc.MDocKind, MDoc.MDoc, L_Pmnt.vmdbm_Acceptance);
   ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrchPstpay) THEN
    PutByRef(L_Pmnt.vmdbm_PrchPstpay);
   ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrchUndpay) THEN
    PutByRef(L_Pmnt.vmdbm_PrchUndpay);
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {Put};

 PRIVATE PROCEDURE PassSingleMDocKind(Sale, SingleContract: SCAL[2]; WFStyle: tWFStyle; _MDocKind: LIKE(MDoc.MDocKind));
  VAR
   vtb: L_Pmnt.tValuesToBalance;
   fr,
   ut : DATE;
 BEGIN
  APP.Get().NewPrompt("⮢ ");
  IF WFStyle # wfs_AddSheet THEN
   fr:=Cn002_From;
   ut:=Cn002_UpTo;
  END;
  IF SingleContract THEN
   IF WFStyle = wfs_AddSheet THEN
    fr:=L_DatTim.MINDATE();
    ut:=L_Pmnt.GetVATClcPerLastDay(Cn002_WFPeriod);
   END;
   SETSEL(MDoc, Contract, Contract.Contract, _MDocKind);
  ELSE
   IF WFStyle = wfs_AddSheet THEN
    fr:=L_DatTim.MINDATE();
    ut:=Cn002_WFPeriod-1;
    SETSEL(MDoc, MDKWFP, _MDocKind, Cn002_WFPeriod);
   ELSE
    SETSEL(MDoc, MDKDate, _MDocKind);
   END;
  END;
  SRCINSEL(MDoc, GE, , fr);
  WHILE OCCURE(MDoc) & (MDoc.Date <= ut) DO
   PROMPT(wfs_Pool[WFStyle] + ": " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   IF (MDoc.Status # L_MDoc.st_Canceled) THEN
    IF (WFStyle = wfs_Book    ) & ((MDoc.WFPeriod = Cn002_WFPeriod) &
                                   (L_Pmnt.ConvPer2VATClcPer(L_DatTim.Per(MDoc.Date)) = MDoc.WFPeriod)) |
       (WFStyle = wfs_AddSheet) & ((MDoc.WFPeriod = Cn002_WFPeriod) &
                                   (L_Pmnt.ConvPer2VATClcPer(L_DatTim.Per(MDoc.Date)) < MDoc.WFPeriod)) |
       (WFStyle = wfs_AS_Itogo) & (MDoc.WFPeriod < Cn002_WFPeriod) |
       (WFStyle = wfs_Inquiry)  THEN
     IF L_Pmnt.IsVATMDocToKeepInBook() & (~wMF | (MDoc.MyFirm = P_Firm.curMyFirm)) &
        HasMDocListToShowInBook() THEN
      IF ~L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Acceptance) THEN
       vtb:=L_Pmnt.GetMDocAcpt();
       IF vtb[L_Pmnt.vtb_VAT] # 0 THEN
        Put(Sale);
       END;
      ELSE
       Put(Sale);
      END;
     END;
    END;
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {PassSingleMDocKind};

 PRIVATE PROCEDURE word_PutSingle(Name: STRING[]; Value: L_XObj.tSum);
 BEGIN
  IF ~!Value THEN
   L_MSO.wordSetMoneyVar(Name, Cn002_WFPeriod, Value);
  ELSE
   L_MSO.wordSetVar(Name, "-");
  END;
 END {word_PutSingle};

 PRIVATE PROCEDURE word_PutSums(Sale     : SCAL[2];
                                Prefix   : STRING[];
                                _Overall,
                                _rbVAT   : L_XObj.tSum;
                                _Netto,
                                _VAT     : L_Pmnt.tValuesByVATRate);
 BEGIN
  word_PutSingle(Prefix + ".Overall", _Overall);
  word_PutSingle(Prefix + ".rbVAT"  , _rbVAT);
  word_PutSingle(Prefix + ".Netto18", _Netto[L_Pmnt.vr_18]);
  word_PutSingle(Prefix + ".VAT18"  , _VAT  [L_Pmnt.vr_18]);
  word_PutSingle(Prefix + ".Netto20", _Netto[L_Pmnt.vr_20]);
  word_PutSingle(Prefix + ".VAT20"  , _VAT  [L_Pmnt.vr_20]);
  word_PutSingle(Prefix + ".Netto10", _Netto[L_Pmnt.vr_10]);
  word_PutSingle(Prefix + ".VAT10"  , _VAT  [L_Pmnt.vr_10]);
  word_PutSingle(Prefix + ".NettoNV", _Netto[L_Pmnt.vr_NV]);
  L_General.Assert(_Netto[L_Pmnt.vr_00] = 0, "㤠   ⠢ 0%?");
  IF Sale THEN
   L_General.Assert(_Netto[L_Pmnt.vr_10] = 0, "㤠   ⠢ 10%?");
  END;
 END {word_PutSums};

 TYPE
  tExistanceOfSpecifiedVATMDoc = SCAL[3];

 CONST
  eosvmd_HasNot       = 0;
  eosvmd_HasDifferent = 1;
  eosvmd_HasTheSame   = 2;

 PRIVATE PROCEDURE FindGenerated(bm: L_Pmnt.tVATMDocBuildMode;
                                 Vl: L_Pmnt.tValuesToBalance): tExistanceOfSpecifiedVATMDoc;
  VAR
   Dummy         : L_Pmnt.tValuesToBalance;
   Result        : tExistanceOfSpecifiedVATMDoc;
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
 BEGIN
  Result:=eosvmd_HasNot;
  SAVE(MDoc);
  IF L_Pmnt.E_IsAcptMDoc() THEN
   Vl:=L_Pmnt.GetMDocAcpt();
  END;
  i:=0;
  DependentMDocs:=L_MDoc.GetDependentMDocXDC();
  WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) & (Result = eosvmd_HasNot) DO
   IF L_Pmnt.IsSpecifiedVATMDoc(bm) THEN
    Dummy:=L_Pmnt.GetMDocAcpt();
    IF Vl[L_Pmnt.vtb_VAT] = Dummy[L_Pmnt.vtb_VAT] THEN
     Result:=eosvmd_HasTheSame;
    ELSE
     Result:=eosvmd_HasDifferent;
    END;
   ELSE
    Result:=FindGenerated(bm, Vl);
   END;
   INC(i);
  END; (* WHILE L_XDoc.xdc_PositionOn ... *)
  RESTORE(MDoc);
  RETURN Result;
 END {FindGenerated};

 PRIVATE PROCEDURE MDocHasGeneratedSpecifiedVATMDoc(_MDocKind: LIKE(MDoc.MDocKind);
                                                    _MDoc    : LIKE(MDoc.MDoc);
                                                    bm       : L_Pmnt.tVATMDocBuildMode): tExistanceOfSpecifiedVATMDoc;
  VAR
   Dummy : L_Pmnt.tValuesToBalance;
   Result: tExistanceOfSpecifiedVATMDoc;
 BEGIN
  Result:=0;
  SAVE(MDoc);
  SAVE(MDocList);
  L_General.CallUs(SEARCH(MDoc, MDoc, _MDocKind, _MDoc));
  SETZERO(Dummy);
  Result:=FindGenerated(bm, Dummy);
  RESTORE(MDocList);
  RESTORE(MDoc);
  RETURN Result;
 END {MDocHasGeneratedSpecifiedVATMDoc};

 PRIVATE PROCEDURE IsAfter2004(): SCAL[2];
 BEGIN
  RETURN Cn002_UpTo >= 01\01\2004;
 END {IsAfter2004};

 PRIVATE PROCEDURE IsAfter20060530(): SCAL[2];
 BEGIN
  RETURN Cn002_UpTo >= 30\05\2006;
 END {IsAfter2004};

 PRIVATE PROCEDURE IsAfter201204(): SCAL[2];
 BEGIN
  RETURN Cn002_UpTo >= 01\04\2012;
 END {IsAfter201204};

 PRIVATE PROCEDURE piw_AddDst(_Dest  : LIKE(Dest.Dest);
                              VATRate: L_Pmnt.tVATRates;
                              _Total,
                              rbVAT,
                              _Netto,
                              _VAT   : L_XObj.tSum);
 BEGIN
  ADD(DsTot, Dest, , _Dest,
      DsTot.Overall,        _Total,
      DsTot.rbVAT,           rbVAT,
      DsTot.Netto[VATRate], _Netto,
      DsTot.VAT  [VATRate],   _VAT);
 END {piw_AddDst};

 PRIVATE PROCEDURE piw_SingleMDocList(Sale          : SCAL[2];
                                      List          : STRING[];
                                      VATRate       : L_Pmnt.tVATRates;
                                      vtb_ByMDocList: L_Pmnt.tValuesToBalance;
                                      rbVAT         : L_XObj.tSum;
                                      ReallyPut     : SCAL[2]);
  VAR
   _Total     : L_XObj.tSum;
   _Netto,
   _VAT       : L_Pmnt.tValuesByVATRate;
   wEmptyNetto: SCAL[2];
 BEGIN
  SETZERO(_Netto, _VAT, wEmptyNetto);
  _Total         :=vtb_ByMDocList[L_Pmnt.vtb_Total];
  _Netto[VATRate]:=vtb_ByMDocList[L_Pmnt.vtb_Netto];
  _VAT  [VATRate]:=vtb_ByMDocList[L_Pmnt.vtb_VAT  ];
  IF L_APtm.IsMGT() THEN
   IF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Prepayment) |
      L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_OnPrpShpmt) THEN
    wEmptyNetto:=1;
    _Netto[VATRate]:=0;
   ELSIF rbVAT # 0 THEN
    L_General.CallUs(_VAT[VATRate] # 0);
    _Netto[VATRate]:=_Netto[VATRate] * (rbVAT/_VAT[VATRate]);
    _VAT  [VATRate]:=rbVAT;
    _Total         :=_Netto[VATRate] + _VAT[VATRate];
   END;
  END;
  piw_AddDst(         MDoc.Dest, VATRate, _Total, rbVAT, _Netto[VATRate], _VAT[VATRate]);
  piw_AddDst(EMPTYOF(Dest.Dest), VATRate, _Total, rbVAT, _Netto[VATRate], _VAT[VATRate]);
  IF ReallyPut THEN
   IF wEmptyNetto THEN
    SETEMPTY(_Netto);
   END;
   word_PutSums(Sale, List, _Total, rbVAT, _Netto, _VAT);
  ELSE
   piw_AddDst(ItogoDest, VATRate, _Total, rbVAT, _Netto[VATRate], _VAT[VATRate]);
  END;
 END {piw_SingleMDocList};

 PRIVATE PROCEDURE IsNegative(Sale: SCAL[2]): SCAL[2];
 BEGIN
  RETURN ( Sale & ((MDIdx.BldMode = L_Pmnt.vmdbm_Underpay  )|
                   (MDIdx.BldMode = L_Pmnt.vmdbm_PrpReturn )|
                   (MDIdx.BldMode = L_Pmnt.vmdbm_OnPrpShpmt)) ) |
         (~Sale & (MDIdx.BldMode = L_Pmnt.vmdbm_PrchUndpay));
 END {IsNegative};

 PRIVATE PROCEDURE crv_PutBySingleAcCut(_Notion: L_APtm.tNotion; _VATMode: LIKE(MDocList.VATMode));
  VAR
   _d68: L_XObj.tSum;
 BEGIN
  _d68:=0;
  IF SELECT(XApport, WFD, XObject.XObject, L_AcCut.erkn_GetSoft(MDoc.Date, _Notion), L_DatTim.Per(MDoc.Date)) THEN
   WHILE OCCURE(XApport) DO
    IF  XApport.Source = L_XObj.src_Payments THEN
     INC(_d68, XApport.Sum);
    END;
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
  END;
  IF _VATMode = L_MDoc.vatm_Deduction THEN
   ADD(CntrV, Contract, , Contract.Contract,
       CntrV.ded_xc_d68, _d68,
       CntrV.ded_rs_d68, _d68);
  ELSE
   ADD(CntrV, Contract, , Contract.Contract,
       CntrV.atc_xc_d68, _d68,
       CntrV.atc_rs_d68, _d68);
  END;
 END {crv_PutBySingleAcCut};

 PRIVATE PROCEDURE crv_GetBy_d68(): L_XObj.tSum;
  VAR
   Sign        : NUMERIC[0];
   tot_rs_d68,
   tot_xc_d68,
   Result      : L_XObj.tSum;
 BEGIN
  IF  ~SEARCH(CntrV, Contract, Contract.Contract) | ~CntrV.InitIsDn THEN
   L_XObj.AccessXObject(Contract.XObject);
   L_XObj.CheckXObjectDone(MDoc.Date, L_XObj.s_Payments);
   crv_PutBySingleAcCut(L_AcCut.erkn_BoughtVATInCost,    L_MDoc.vatm_AddToCost);
   crv_PutBySingleAcCut(L_AcCut.erkn_BoughtKeyAssVAT,    L_MDoc.vatm_Deduction);
   crv_PutBySingleAcCut(L_AcCut.erkn_BoughtInventoryVAT, L_MDoc.vatm_Deduction);
   crv_PutBySingleAcCut(L_AcCut.erkn_BoughtGoodsVAT,     L_MDoc.vatm_Deduction);
   SEARCH(CntrV, Contract, , Contract.Contract);
   CntrV.InitIsDn:=1;
   REPLACE(CntrV);
  END;
  tot_xc_d68:=CntrV.ded_xc_d68+CntrV.atc_xc_d68;
  IF tot_xc_d68 = 0 THEN
   Result:=MDocList.VAT;
  ELSE
   tot_rs_d68:=CntrV.ded_rs_d68+CntrV.atc_rs_d68;
   IF MDocList.VAT = tot_rs_d68 THEN
    Result:=CntrV.ded_rs_d68;
   ELSE
    Result:=MDocList.VAT * (CntrV.ded_xc_d68/tot_xc_d68);
   END;
   IF IsNegative(0) THEN
    Sign:=+1;
   ELSE
    Sign:=-1;
   END;
   ADD(CntrV, Contract, , Contract.Contract,
       CntrV.ded_rs_d68, Sign*(Result),
       CntrV.atc_rs_d68, Sign*(MDocList.VAT-Result));
  END;
  RETURN Result;
 END {crv_GetBy_d68};

 PRIVATE PROCEDURE CalcRebateVAT(): L_XObj.tSum;
 BEGIN
  IF   !MDocList.VATMode THEN
   IF Contract.Type = L_Cntr.ct_Sell THEN
    RETURN MDocList.VAT;
   ELSE
    RETURN crv_GetBy_d68();
   END;
  ELSE
   RETURN MDocList.VAT - L_Acnt.VATPartInCost(L_Acnt.cvat_Allow, MDocList.VAT, MDocList.VATMode);
  END;
 END {CalcRebateVAT};

 PRIVATE PROCEDURE TestCntrV();
 BEGIN
  SELECT(CntrV, Contract);
  WHILE OCCURE(CntrV) DO
   IF (CntrV.ded_rs_d68 # 0) | (CntrV.atc_rs_d68 # 0) THEN
(* ??? *)
    L_StdFrm.Inform("ਢ ᯨᠭ " + CntrV.Contract +
                    " " + FLDTOSTR(CntrV.ded_rs_d68, "2.") +
                    " " + FLDTOSTR(CntrV.atc_rs_d68, "2."));
   END;
(*
   IF (CntrV.xc_rbV # CntrV.pb_rbV) THEN
    L_StdFrm.Inform("ਢ  " + CntrV.Contract +
                    " " + FLDTOSTR(CntrV.xc_rbV, "2.") +
                    " " + FLDTOSTR(CntrV.pb_rbV, "2."));
   END;
*)
   NEXT(CntrV);
  END; (* WHILE OCCURE(CntrV) ... *)
 END {TestCntrV};

 PRIVATE PROCEDURE VATRateToShowInBook(_VATRate: L_Pmnt.tVATRates): SCAL[2];
 BEGIN
  RETURN (_VATRate # L_Pmnt.vroNV) &
         ((_VATRate # L_Pmnt.vr_NV) |
          (~L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Prepayment) &
           ~L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_OnPrpShpmt) &
           ~L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrpReturn)));
 END {VATRateToShowInBook};

 PRIVATE PROCEDURE HasMDocListToShowInBook(): SCAL[2];
 BEGIN
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   IF VATRateToShowInBook(L_Pmnt.GetMDocListVATRate()) THEN
    RETURN 1;
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  RETURN 0;
 END {HasMDocListToShowInBook};

 PRIVATE PROCEDURE GetXDocDate(trgXDocId: L_XDoc.tXDocId): DATE;
  VAR
   trgXDocType: L_XDoc.tXDocType;
   Result: DATE;
 BEGIN
  trgXDocType:=L_XDoc.ExtractXDocType(trgXDocId);
  IF trgXDocType = L_XDoc.xdt_PDoc THEN
   SAVE(PDoc);
   L_XDoc.PositionOnXDoc(trgXDocId);
   Result:=PDoc.Date;
   RESTORE(PDoc);
  ELSIF trgXDocType = L_XDoc.xdt_MDoc THEN
   SAVE(MDoc);
   L_XDoc.PositionOnXDoc(trgXDocId);
   Result:=MDoc.Date;
   RESTORE(MDoc);
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {GetXDocDate};

 PRIVATE PROCEDURE CheckRefXDocDate(trgXDocType: L_XDoc.tXDocType; trgXDocKind: L_XDoc.tXDocKind; trgXDoc: L_XDoc.tXDoc);
  VAR
   RefXDocId  : L_XDoc.tXDocId;
   RefXDocDate: DATE;
 BEGIN
  RefXDocId:=L_XDoc.XDocId(trgXDocType, trgXDocKind, trgXDoc);
  RefXDocDate:=GetXDocDate(RefXDocId);
  L_General.Assert(RefXDocDate <= MDoc.Date, " 㬥   ("+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+"  "+L_DatTim.DateStr(MDoc.Date)+")"+
                                             "|   ࠭  室 㬥 ("+L_XDoc.XDocStr(RefXDocId)+"  "+L_DatTim.DateStr(RefXDocDate)+")");
 END {CheckRefXDocDate};

 PRIVATE PROCEDURE PutInWord(Sale, DoAddSheets, ReallyPut: SCAL[2]);
  VAR
   Root,
   List,
   TemplateName,
   Prompt             : STRING[];
   vtb_ByMDocList     : L_Pmnt.tValuesToBalance;
   rbVAT              : L_XObj.tSum;
   mdlIdx,
   ttlIdx             : NUMERIC[0];
   _CstDclr           : LIKE(MDocList.CstDclr);
   _VATMode           : LIKE(MDocList.VATMode);
   _VATRate           : L_Pmnt.tVATRates;
   _SrcDate           : DATE;
   _MDLNbr            : LIKE(MDocList.MDLNbr);
   refToXDocType      : L_XDoc.tXDocType;
   refToXDocKind      : L_XDoc.tXDocKind;
   refToXDoc          : L_XDoc.tXDoc;
   PrtnrTyp           : P_Firm.tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
 BEGIN
  IF ReallyPut THEN
   L_MSO.wordInitDocument(Cn002_WFPeriod);
   IF Sale THEN
    Root        :="SellBook";
    IF DoAddSheets THEN
     TemplateName:="SlAS_01";
    ELSE
     IF    IsAfter201204() THEN TemplateName:="SlBk_03";
     ELSIF IsAfter2004()   THEN TemplateName:="SlBk_02";
     ELSE                       TemplateName:="SlBk_01";
     END;
    END;
   ELSE
    Root        :="PrchBook";
    IF DoAddSheets THEN
     TemplateName:="PcAS_01";
    ELSE
     IF    IsAfter201204()   THEN TemplateName:="PcBk_04";
     ELSIF IsAfter20060530() THEN TemplateName:="PcBk_03";
     ELSIF IsAfter2004()     THEN TemplateName:="PcBk_02";
     ELSE                         TemplateName:="PcBk_01";
     END;
    END;
   END;
   L_MSO.wordSetDateVar(Root + ".From",       Cn002_From);
   L_MSO.wordSetDateVar(Root + ".UpTo",       Cn002_UpTo);
   L_MSO.wordSetDateVar(Root + ".WFPeriod",   Cn002_WFPeriod);
   L_MSO.wordSetDateVar(Root + ".WFPLastDay", L_Pmnt.GetVATClcPerLastDay(Cn002_WFPeriod));
   IF wMF THEN
    P_Firm.SetFirmData("Own", P_Firm.fomf(P_Firm.curMyFirm), Cn002_UpTo, "", "");
   ELSE
    P_Firm.SetFirmData("Own", P_Firm.OWN_FIRM, Cn002_UpTo, "", "");
   END;
  ELSE
   Root:="";
  END;
  mdlIdx:=0;
  WHILE OCCURE(MDIdx) DO
   CONFORM(MDIdx, MDoc);
   IF ReallyPut THEN
    Prompt:="⮢  㧪";
   ELSE
    Prompt:=" '⮣'  ਮ";
   END;
   PROMPT(Prompt + ": " + L_DatTim.DateStr(MDIdx.pblDate) + ", " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   CONFORM(MDoc, Dest);
   CONFORM(MDoc, Contract);
   CONFORM(Contract, Firm);
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) DO
    _VATRate:=L_Pmnt.GetMDocListVATRate();
    IF VATRateToShowInBook(_VATRate) THEN
     _MDLNbr:=MDocList.MDLNbr;
     _CstDclr:=MDocList.CstDclr;
     _VATMode:=MDocList.VATMode;
     SETZERO(vtb_ByMDocList, rbVAT);
     LOOP
      IF ~OCCURE(MDocList) THEN
       EXIT;
      END;
      IF VATRateToShowInBook(L_Pmnt.GetMDocListVATRate()) THEN
       IF (MDIdx.BldMode = L_Pmnt.vmdbm_Acceptance) &
            (MDocList.CstDclr # _CstDclr) &
            (~Sale | ~IsAfter2004()) |
            (L_Pmnt.GetMDocListVATRate() # _VATRate) |
            (MDocList.VATMode # _VATMode) THEN
        EXIT;
       END;
       vtb_ByMDocList:=L_Pmnt.vtbAdd(vtb_ByMDocList, L_Pmnt.GetMDocListAcpt());
       IF ~Sale THEN
        INC(rbVAT, CalcRebateVAT());
       END;
       _MDLNbr:=MDocList.MDLNbr;
      END;
      NEXT(MDocList);
     END; (* LOOP ... *)
     SRCINSEL(MDocList, EQ, , _MDLNbr);
     IF Sale | ~L_APtm.IsMGT() | (rbVAT # 0) THEN
      IF IsNegative(Sale) THEN
       vtb_ByMDocList:=L_Pmnt.vtbInv(vtb_ByMDocList);
       rbVAT:=-rbVAT;
      END;
      ADD(CntrV, Contract, , Contract.Contract,
          CntrV.pb_rbV, rbVAT);
      List:=Root+".MDocList"+L_MSO.IndexStr(mdlIdx);
      piw_SingleMDocList(Sale, List, _VATRate, vtb_ByMDocList, rbVAT, ReallyPut);
      IF ReallyPut THEN
       L_MSO.wordSetVar(List + ".Pos", L_Str.IntStr(mdlIdx+1));
       L_MSO.wordSetVar(List + ".CstDclr",              "");
       L_MSO.wordSetVar(List + ".CstDclr.Number",       "");
       L_MSO.wordSetVar(List + ".CstDclr.Country.Name", "");
       IF ~!MDocList.CstDclr THEN
        CONFORM(MDocList, CstDclr);
        IF CstDclr.Country # L_Russia.c_Russia THEN
         CONFORM(MDocList, Country);
         L_MSO.wordSetVar(List + ".CstDclr", MDocList.CstDclr);
         L_MSO.wordSetVar(List + ".CstDclr.Number", CstDclr.Number);
         L_MSO.wordSetVar(List + ".CstDclr.Country.Name", Country.Name);
        END;
       END;
       SAVE(MDoc);
       IF ~!MDIdx.srcMDoc THEN
        SEARCH(MDoc, MDoc, , MDIdx.srcMDocKind, MDIdx.srcMDoc);
        _SrcDate:=MDoc.SrcDate;
        L_MSO.wordSetVar(List + ".Source.MDoc", MDoc.MDoc);
        L_MSO.wordSetVar(List + ".Source.SrcNbr", MDoc.SrcNbr);
        L_MSO.wordSetDateVar(List + ".Source.SrcDate", MDoc.SrcDate);
        L_MSO.wordSetDateVar(List + ".Source.Date",    MDoc.Date);
       ELSE
        SETEMPTY(_SrcDate);
        L_MSO.wordSetVar(List + ".Source.MDoc", "");
        IF ~Sale & L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrchPstpay) THEN
         L_MSO.wordSetVar(List + ".Source.SrcNbr", "");
        ELSE
         L_MSO.wordSetVar(List + ".Source.SrcNbr", "");
        END;
        L_MSO.wordSetDateVar(List + ".Source.SrcDate", EMPTYOF(DATE));
        L_MSO.wordSetDateVar(List + ".Source.Date",    EMPTYOF(DATE));
       END;
       RESTORE(MDoc);
       L_MSO.wordSetDateVar(List + ".PblDate", MDIdx.pblDate);
       L_XDoc.DecodeXDocId(L_XDoc.GetBaseOnXDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc)),
                           refToXDocType, refToXDocKind, refToXDoc);
       L_General.Assert(~!refToXDocType, " 易 㬥 "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
       CheckRefXDocDate(refToXDocType, refToXDocKind, refToXDoc);
       IF refToXDocType = L_XDoc.xdt_PDoc THEN
        IF Sale | (MDoc.MDocKind # L_MDoc.md_DPr) | L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrpReturn) THEN
         L_MSO.wordSetDateVar(List + ".PaidDate", MDoc.Date);
        ELSE
         L_MSO.wordSetDateVar(List + ".PaidDate", EMPTYOF(DATE));
        END;
       ELSE
        L_MSO.wordSetDateVar(List + ".PaidDate", EMPTYOF(DATE));
        IF ~Sale THEN
         IF (MDoc.MDocKind # L_MDoc.md_DPr) THEN
          IF ~L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrchUndpay) THEN
           IF (refToXDocType = L_XDoc.xdt_MDoc) THEN
            IF     MDocHasGeneratedSpecifiedVATMDoc(refToXDocKind, refToXDoc, L_Pmnt.vmdbm_PrchUndpay) = eosvmd_HasNot THEN
             L_MSO.wordSetVar(List + ".PaidDate", "।");
            ELSIF  MDocHasGeneratedSpecifiedVATMDoc(refToXDocKind, refToXDoc, L_Pmnt.vmdbm_PrchUndpay) = eosvmd_HasDifferent THEN
             L_MSO.wordSetVar(List + ".PaidDate", "");
            END;
           END;
          END;
         END;
        END;
       END;
       IF ~Sale THEN
        IF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Acceptance) THEN
         L_MSO.wordSetDateVar(List + ".AcptDate", MDoc.Date);
        ELSIF MDoc.MDocKind # L_MDoc.md_DPr THEN
         L_MSO.wordSetDateVar(List + ".AcptDate", _SrcDate);
        ELSE
         L_MSO.wordSetDateVar(List + ".AcptDate", EMPTYOF(DATE));
        END;
       END;
       List:=List+".MDoc";
       L_MSO.wordSetVar(List + ".RefDocT.FullName", L_XDoc.Ref_FullName(refToXDocType));
       IF refToXDocType = L_XDoc.xdt_PDoc THEN
        L_MSO.wordSetVar(List + ".RefDoc.XDocKind.Sign", L_PDoc.PDocKindNick(refToXDocKind, 1));
       ELSE
        L_MSO.wordSetVar(List + ".RefDoc.XDocKind.Sign", L_MDoc.MDocKindNick(refToXDocKind, 1));
       END;
       L_MSO.wordSetVar(List + ".RefDoc.XDoc", refToXDoc);
       L_MSO.wordSetVarsByFile_wAlias("Dest", List+".Dest");
 
       List:=List+".Contract.Firm";
       P_Firm.GetRegNameValues(Firm.Firm, MDoc.Date, PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
     
       L_MSO.wordSetVar(List+".RegName",             ContractorBriefName); (*প  蠡*)
       IF    ~!BranchFullName THEN
        L_MSO.wordSetVar(List+".PersonFullName_wBranchName", BranchFullName);
       ELSIF ~!BranchName THEN
        L_MSO.wordSetVar(List+".PersonFullName_wBranchName", PersonFullName + ", " + BranchName);
       ELSE
        L_MSO.wordSetVar(List+".PersonFullName_wBranchName", PersonFullName);
       END;
       L_MSO.wordSetVar(List+".PersonFullName",      PersonFullName);
       L_MSO.wordSetVar(List+".BranchName",          BranchName);
       L_MSO.wordSetVar(List+".ContractorBriefName", ContractorBriefName);
       L_MSO.wordSetVar(List+".ContractorIsPhysicalBody", P_Firm.PartnerTypeIsPhysicalBody(PrtnrTyp));
 
       L_MSO.wordSetVar(List+".INN", P_Firm.GetFirmPro_PartnerTypeDepend(Firm.Firm, MDoc.Date, P_Firm.P_INN));
       IF IsAfter2004() THEN
        L_MSO.wordSetVar(List+".KPP", P_Firm.GetFirmProSoft(Firm.Firm, MDoc.Date, P_Firm.P_KPP));
       END;
      END;
      INC(mdlIdx);
     END;
    END; (* IF VATRateToShowInBook(_VATRate) ... *)
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
   NEXT(MDIdx);
  END; (* WHILE OCCURE(MDIdx) ... *)
  IF ReallyPut THEN
   ttlIdx:=0;
   SELECT(DsTot, Dest);
   WHILE OCCURE(DsTot) DO
    IF !DsTot.Dest THEN
     word_PutSums(Sale, Root+".Totals.Final",
                  DsTot.Overall, DsTot.rbVAT, DsTot.Netto, DsTot.VAT);
    ELSIF DsTot.Dest = ItogoDest THEN
     word_PutSums(Sale, Root+".Totals.Itogo",
                  DsTot.Overall, DsTot.rbVAT, DsTot.Netto, DsTot.VAT);
    ELSE
     List:=Root+".Totals"+L_MSO.IndexStr(ttlIdx);
     CONFORM(DsTot, Dest);
     L_MSO.wordSetVarsByFile_wAlias("Dest", List+".Dest");
     word_PutSums(Sale, List,
                  DsTot.Overall, DsTot.rbVAT, DsTot.Netto, DsTot.VAT);
     INC(ttlIdx);
    END;
    NEXT(DsTot);
   END; (* WHILE OCCURE(DsTot) ... *)
   TestCntrV();
   L_MSO.SetWordTable("table1", mdlIdx);
   L_MSO.SetWordTable("table2", ttlIdx);
   L_MSO.PutInTables:=L_MSO.Put_Values;
   L_MSO.MakeWordDocument(TemplateName, 1, L_MSO.PrpMode_ToDoc, "");
  END;
 END {PutInWord};

 PRIVATE PROCEDURE SetCurMyFirm(SingleContract: SCAL[2]);
 BEGIN
  IF SingleContract THEN
   L_General.Assert(ACCESS(Contract), " ⠭ ⥪騩 ");
  END;
  wMF:=P_Firm.E_wMultipleMyFirm(Cn002_WFPeriod);
  IF wMF THEN
   IF SingleContract THEN
    P_Firm.curMyFirm:=Contract.MyFirm;
   ELSE
    P_Firm.curMyFirm:=L_Pmnt.DefineMyFirm_wVAT(Cn002_WFPeriod);
   END;
  ELSE
   P_Firm.curMyFirm:=P_Firm.mf_Own;
  END;
 END {SetCurMyFirm};

 PRIVATE PROCEDURE PrepareBook(Sale, SingleContract: SCAL[2]; WFStyle: tWFStyle);
 BEGIN
  IF Sale THEN
   PassSingleMDocKind(Sale, SingleContract, WFStyle, L_MDoc.md_ISF);
   PassSingleMDocKind(Sale, SingleContract, WFStyle, L_MDoc.md_DPr);
  ELSE
   PassSingleMDocKind(Sale, SingleContract, WFStyle, L_MDoc.md_VSF);
   PassSingleMDocKind(Sale, SingleContract, WFStyle, L_MDoc.md_DPk);
   PassSingleMDocKind(Sale, SingleContract, WFStyle, L_MDoc.md_DPr);
  END;
 END {PrepareBook};

 PRIVATE PROCEDURE CheckSpecialVATMDocDone(SingleContract: SCAL[2]; P: DATE);
 BEGIN
  IF SingleContract THEN
   L_Pmnt.CheckSpecialVATMDocDone(Contract.Contract, L_DatTim.MonthEnd(P));
  ELSE
   L_Pmnt.CheckSpecialVATMDocDoneAll(P_Firm.curMyFirm, L_DatTim.MonthEnd(P));
  END;
 END {CheckSpecialVATMDocDone};

 PRIVATE PROCEDURE MakeBook(Sale, SingleContract, DoAddSheets, MonthInquiry: SCAL[2]);
  VAR
   _Period: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.SetCacheables(["Contract"]);

  Create_TemporaryFiles();
  CteateTemp();

  Cn002_WFPeriod:=L_Pmnt.ConvPer2VATClcPer(Memo.ud_mb());
  SetCurMyFirm(SingleContract);

  IF DoAddSheets THEN
   CheckSpecialVATMDocDone(SingleContract, L_Pmnt.GetVATClcPerLastDay(Cn002_WFPeriod));
   PrepareBook(Sale, SingleContract, wfs_AddSheet);
   IF SELECT(MDIdx, ToPrint, Cn002_WFPeriod) THEN
    WHILE OCCURE(MDIdx) DO
     NARROWSEL(MDIdx, Period);
     _Period:=MDIdx.Period;
     SAVE(MDIdx);
     Cn002_From:=_Period;
     Cn002_UpTo:=L_Pmnt.GetVATClcPerLastDay(Cn002_From);
     PrepareBook(Sale, SingleContract, wfs_AS_Itogo);
     SETSEL(DsTot, Dest);
     REMSEL(DsTot);
     SELECT(MDIdx, ItWas, , _Period, 1);
     PutInWord(Sale, 1, 0);
     RESTORE(MDIdx);
     PutInWord(Sale, 1, 1);
     NEXTINEXTENDEDSEL(MDIdx, Period);
    END; (* WHILE OCCURE(MDIdx) *)
   ELSE
    L_StdFrm.BlueHalt(" 室  ⮢ ⮢");
   END;
  ELSE
   IF MonthInquiry THEN
    Cn002_From:=Memo.ud_mb();
    Cn002_UpTo:=Memo.ud_me();
    CheckSpecialVATMDocDone(SingleContract, Cn002_UpTo);
    PrepareBook(Sale, SingleContract, wfs_Inquiry);
    SELECT(MDIdx, ToInquir, , Cn002_WFPeriod);
   ELSE
    Cn002_From:=Cn002_WFPeriod;
    Cn002_UpTo:=Memo.ud_me();
    CheckSpecialVATMDocDone(SingleContract, Cn002_UpTo);
    PrepareBook(Sale, SingleContract, wfs_Book);
    SELECT(MDIdx, ToPrint, , Cn002_WFPeriod, Cn002_From);
   END;
   L_General.Assert(OCCURE(MDIdx), "     ப");
   PutInWord(Sale, 0, 1);
  END;

  Purge_TemporaryFiles();
 END {MakeBook};

 PRIVATE PROCEDURE pid_SingleMDocList(VATRate       : L_Pmnt.tVATRates;
                                      vtb_ByMDocList: L_Pmnt.tValuesToBalance;
                                      rbVAT         : L_XObj.tSum;
                                      VAR
                                       summa,
                                       sum20,
                                       nds20,
                                       sum18,
                                       nds18,
                                       sum10,
                                       nds10,
                                       sum0,
                                       sum00: L_XObj.tSum;
                                       AddDtsTot: SCAL[2]);
  VAR
   curTotal   : L_XObj.tSum;
   curNetto,
   curVAT     : L_Pmnt.tValuesByVATRate;
   wEmptyNetto: SCAL[2];
 BEGIN
  SETZERO(curNetto, curVAT, wEmptyNetto);
  curTotal         :=vtb_ByMDocList[L_Pmnt.vtb_Total];
  curNetto[VATRate]:=vtb_ByMDocList[L_Pmnt.vtb_Netto];
  curVAT  [VATRate]:=vtb_ByMDocList[L_Pmnt.vtb_VAT  ];
  IF L_APtm.IsMGT() THEN
   IF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Prepayment) |
      L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_OnPrpShpmt) THEN
    wEmptyNetto:=1;
    curNetto[VATRate]:=0;
   ELSIF rbVAT # 0 THEN
    L_General.CallUs(curVAT[VATRate] # 0);
    curNetto[VATRate]:=curNetto[VATRate] * (rbVAT/curVAT[VATRate]);
    curVAT  [VATRate]:=rbVAT;
    curTotal         :=curNetto[VATRate] + curVAT[VATRate];
   END;
  END;
  IF AddDtsTot THEN
   ADD(DsTot, Dest, , MDoc.Dest,
                      DsTot.Overall,        curTotal,
                      DsTot.rbVAT,          rbVAT,
                      DsTot.Netto[VATRate], curNetto[VATRate],
                      DsTot.VAT  [VATRate], curVAT  [VATRate]);
   ADD(DsTot, Dest, , EMPTYOF(Dest.Dest),
                      DsTot.Overall,        curTotal,
                      DsTot.rbVAT,          rbVAT,
                      DsTot.Netto[VATRate], curNetto[VATRate],
                      DsTot.VAT  [VATRate], curVAT  [VATRate]);
  END;
  IF wEmptyNetto THEN
   SETEMPTY(_Netto);
  END;

  INC(summa, curTotal);
  INC(sum20, curNetto[L_Pmnt.vr_20]);
  INC(nds20, curVAT  [L_Pmnt.vr_20]);
  INC(sum18, curNetto[L_Pmnt.vr_18]);
  INC(nds18, curVAT  [L_Pmnt.vr_18]);
  INC(sum10, curNetto[L_Pmnt.vr_10]);
  INC(nds10, curVAT  [L_Pmnt.vr_10]);
  INC(sum0 , curNetto[L_Pmnt.vr_00]);
  INC(sum00, curNetto[L_Pmnt.vr_NV]);
 END {pid_SingleMDocList};

 PRIVATE PROCEDURE E_CN002_KOD_PRED(): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.CN002_KOD_PRED);
  IF !Local THEN
   IF L_General.GetAPSiteID() = "X1" THEN
    RETURN "106";
   ELSE
    L_General.SetupRequired();
   END;
  END;
  RETURN Local();
 END {E_CN002_KOD_PRED};

 PRIVATE PROCEDURE MDocId(): STRING[];
 BEGIN
  RETURN FLDTOSTR(MDoc.MDocKind)+FLDTOSTR(MDoc.MDoc);
 END {MDocId};

 PRIVATE PROCEDURE ExpBook(Sale: SCAL[2]);
  VAR
   _kodpred: STRING[];
   _nsf : STRING[];
   _dsf : DATE;
   _p_name,
   _p_inn,
   _p_kpp: STRING[];
   _dopl,
   _dotg : DATE;
   _tovar: STRING[];
    _city,
    _gtd : STRING[];
   summa,
   sum20,
   nds20,
   sum18,
   nds18,
   sum10,
   nds10,
   sum0,
   sum00,
   isumma,
   inds: L_XObj.tSum;
   _SrcDate: LIKE(MDoc.SrcDate);
   _CstDclr           : LIKE(MDocList.CstDclr);
   curVATMode         : LIKE(MDocList.VATMode);
   _VATRate           : L_Pmnt.tVATRates;
   _MDLNbr            : LIKE(MDocList.MDLNbr);
   vtb_ByMDocList     : L_Pmnt.tValuesToBalance;
   rbVAT              : L_XObj.tSum;
   refToXDocType      : L_XDoc.tXDocType;
   refToXDocKind      : L_XDoc.tXDocKind;
   refToXDoc          : L_XDoc.tXDoc;
   PrtnrTyp           : P_Firm.tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
   procent,
   avans: SCAL[2];
 BEGIN
  APP.Get().NewPrompt(" "+L_Str.PoolItem("㯮|த", Sale));
  IF SELECT(MDIdx, ToPrint) THEN
   WHILE OCCURE(MDIdx) DO
    CONFORM(MDIdx, MDoc);
    PROMPT(L_DatTim.DateStr(MDIdx.pblDate) + ", " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
    IF ~L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrpReturn) & ~L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_OnPrpShpmt) THEN (*㦠  SXxxxx*)
     CONFORM(MDoc, Dest);
     CONFORM(MDoc, Contract);
     CONFORM(Contract, Firm);
     CONFORM(MDoc, MDocList);
 
     _tovar:=P_Cntr.ppi_DescriptionOfGoods(Contract.Contract, MDoc.Date);
     IF !_tovar THEN
      _tovar:=Contract.Name;
     END;
 
     WHILE OCCURE(MDocList) DO
      _VATRate:=L_Pmnt.GetMDocListVATRate();
      IF (MDocList.VATMode # L_MDoc.vatm_AddToCost) & VATRateToShowInBook(_VATRate) THEN
       _MDLNbr:=MDocList.MDLNbr;
       _CstDclr:=MDocList.CstDclr;
       curVATMode:=MDocList.VATMode;
       SETZERO(vtb_ByMDocList, rbVAT);
       LOOP
        IF ~OCCURE(MDocList) THEN
         EXIT;
        END;
        IF VATRateToShowInBook(L_Pmnt.GetMDocListVATRate()) THEN
         IF (MDIdx.BldMode = L_Pmnt.vmdbm_Acceptance) &
            (MDocList.CstDclr # _CstDclr) &
            (~Sale | ~IsAfter2004()) |
            (L_Pmnt.GetMDocListVATRate() # _VATRate) |
            (MDocList.VATMode # curVATMode) THEN
          EXIT;
         END;
         vtb_ByMDocList:=L_Pmnt.vtbAdd(vtb_ByMDocList, L_Pmnt.GetMDocListAcpt());
         IF ~Sale THEN
          INC(rbVAT, CalcRebateVAT());
         END;
         _MDLNbr:=MDocList.MDLNbr;
        END;
        NEXT(MDocList);
       END; (* LOOP ... *)
       SRCINSEL(MDocList, EQ, , _MDLNbr);
       IF Sale | ~L_APtm.IsMGT() | (rbVAT # 0) THEN
        IF IsNegative(Sale) THEN
         vtb_ByMDocList:=L_Pmnt.vtbInv(vtb_ByMDocList);
         rbVAT:=-rbVAT;
        END;
        ADD(CntrV, Contract, , Contract.Contract, CntrV.pb_rbV, rbVAT);
        _kodpred:=E_CN002_KOD_PRED();
  
        SETZERO(summa, sum20, nds20, sum18, nds18, sum10, nds10, sum0, sum00);
        pid_SingleMDocList(_VATRate, vtb_ByMDocList, rbVAT,
                           summa, sum20, nds20, sum18, nds18, sum10, nds10, sum0, sum00, 1);
  
        isumma:=summa;
        inds  :=nds20+nds18+nds10;
  
        _city:="";
        _gtd:="";
        IF ~!MDocList.CstDclr THEN
         CONFORM(MDocList, CstDclr);
         IF CstDclr.Country # L_Russia.c_Russia THEN
          CONFORM(MDocList, Country);
          _city:=Country.Name;
          _gtd   :=CstDclr.Number;
         END;
        END;
        SAVE(MDoc);
        IF ~!MDIdx.srcMDoc THEN
         SEARCH(MDoc, MDoc, , MDIdx.srcMDocKind, MDIdx.srcMDoc);
         _SrcDate:=MDoc.SrcDate;
        ELSE
         SETEMPTY(_SrcDate);
        END;
        RESTORE(MDoc);
        L_XDoc.DecodeXDocId(L_XDoc.GetBaseOnXDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc)),
                            refToXDocType, refToXDocKind, refToXDoc);
        L_General.Assert(~!refToXDocType, " 易 㬥 "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
        CheckRefXDocDate(refToXDocType, refToXDocKind, refToXDoc);
 
        SETEMPTY(_dopl);
        IF refToXDocType = L_XDoc.xdt_PDoc THEN
         IF Sale | (MDoc.MDocKind # L_MDoc.md_DPr) |
            L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Prepayment) | L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrpReturn) THEN
          _dopl:=MDoc.Date;
         END;
        END;
 
        SETEMPTY(_dotg);
        IF ~Sale THEN
         IF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Acceptance) THEN
          _dotg:=MDoc.Date;
         ELSIF (MDoc.MDocKind # L_MDoc.md_DPr) & ~!_SrcDate THEN
          _dotg:=_SrcDate;
         ELSIF ~L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Prepayment) THEN
          _dotg:=MDoc.Date;
         END;
        END;
 
        _nsf:=MDoc.SrcNbr;
        IF Sale THEN
         _dsf :=MDoc.Date;
        ELSE
         _dsf :=MDoc.SrcDate;
        END;
  
        P_Firm.GetRegNameValues(Firm.Firm, MDoc.Date, PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
  
        _p_name:=ContractorBriefName;
        _p_inn:=P_Firm.GetFirmPro_PartnerTypeDepend(Firm.Firm, MDoc.Date, P_Firm.P_INN);
        IF IsAfter2004() THEN
         _p_kpp:=P_Firm.GetFirmProSoft(Firm.Firm, MDoc.Date, P_Firm.P_KPP);
        ELSE
         _p_kpp:="";
        END;
        procent:=(curVATMode=L_MDoc.vatm_Distribution);
        avans:=L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrpReturn) |
               L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_OnPrpShpmt) |
               L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Prepayment);
  
        L_ExtDB.AddRecord("dbfFile");
  
        DBF.SetField(dbfFile, "id", MDocId());
        IF Sale THEN
         DBF.SetField(dbfFile, "nsf", _nsf);
         DBF.SetField(dbfFile, "dsf", _dsf);
         DBF.SetField(dbfFile, "p_kod", "");       (* த  ᫮ ࠣ⮢*)
         DBF.SetField(dbfFile, "p_name", _p_name);
         DBF.SetField(dbfFile, "p_inn", _p_inn);
         DBF.SetField(dbfFile, "p_kpp", _p_kpp);
         DBF.SetField(dbfFile, "tovar", _tovar);   (* 70   *)
        ELSE
         DBF.SetField(dbfFile, "pid", "");        (* 10  *)
         DBF.SetField(dbfFile, "piddoplist", ""); (* 10  *)
         DBF.SetField(dbfFile, "dopl", _dopl);
         DBF.SetField(dbfFile, "dotg", _dotg);
        END;
        DBF.SetField(dbfFile, "sum20", sum20);
        DBF.SetField(dbfFile, "nds20", nds20);
        DBF.SetField(dbfFile, "sum18", sum18);
        DBF.SetField(dbfFile, "nds18", nds18);
        DBF.SetField(dbfFile, "sum10", sum10);
        DBF.SetField(dbfFile, "nds10", nds10);
        DBF.SetField(dbfFile, "sum0",  sum0);
        DBF.SetField(dbfFile, "sum00", sum00);
  
        IF Sale THEN
         DBF.SetField(dbfFile, "isum",    isumma-inds);   (*᫮ 15.2 㬬 㯪 ᥣ,  *)
         DBF.SetField(dbfFile, "inds",    inds);          (*᫮ 15.2 㬬 *)
         DBF.SetField(dbfFile, "isumma",  isumma);        (*᫮ 15.2 㬬 㯪 ᥣ,  *)
         DBF.SetField(dbfFile, "avans",   avans);         (*ਧ  祭 (.T. - , .F. - )*)
         DBF.SetField(dbfFile, "kp",      1);             (*ਧ 祭   த*)
         DBF.SetField(dbfFile, "avansv",  0);             (*ਧ  뤠 (.T. - , .F. - )*)
         DBF.SetField(dbfFile, "nsfa",    "");            (*  -䠪  뤠  *)
         DBF.SetField(dbfFile, "dsfa",    EMPTYOF(DATE)); (*  -䠪  뤠  *)
         DBF.SetField(dbfFile, "dkniga",  EMPTYOF(DATE)); (* 8  祭   (  ⥫쭮 ).
                                                                ⮬ 砥, ᫨  祭   (  ⥫  )
                                                            ⫨砥  ⭮  祭, ࠢ:
                                                             ⠢ (DATE_VIST) ᫨  ,
                                                              ࠢ (DATE_ISPR), ᫨  ,
                                                              -䠪 (DSF).*)
         DBF.SetField(dbfFile, "id_corr", "");            (* 10 ID- -䠪, ४஢ . ਧ ४஢筮 -䠪.*)
         DBF.SetField(dbfFile, "id_ispr", "");            (* 10 ID- -䠪,   ࠢ. ਧ ࠢ饣 -䠪.*)
         DBF.SetField(dbfFile, "id_nxtcorr", "");         (* 10 ID- -䠪, ४஢筮  . ਧ ⪮४஢ -䠪.   *)
         DBF.SetField(dbfFile, "id_nxtispr", "");         (* 10 ID- 襣 ࠢ -䠪. ਧ 㫨஢ -䠪.   *)
         DBF.SetField(dbfFile, "n_ispr", EMPTYOF(SCAL[100])); (*᫮ 2  ࠢ*)
         DBF.SetField(dbfFile, "date_ispr", EMPTYOF(DATE));   (* 8  ࠢ*)
         DBF.SetField(dbfFile, "date_vist", EMPTYOF(DATE));   (* 8  ⠢*)
         DBF.SetField(dbfFile, "sposob", "1");              (* 1  ᯮᮡ । (1-㬠, 2-஭)*)
         DBF.SetField(dbfFile, "kvo", "");                  (* 11   権 ( ᯨ᮪  १ ).*)
         DBF.SetField(dbfFile, "kodval", "643");            (* 3  .*)
         DBF.SetField(dbfFile, "dopl", _dopl);              (* 8   砥 室*)
        ELSE
         DBF.SetField(dbfFile, "city", _city);
         DBF.SetField(dbfFile, "gtd",  _gtd);
         DBF.SetField(dbfFile, "procent", procent);
         DBF.SetField(dbfFile, "d_dopl_old", EMPTYOF(DATE)); (* 8 , ।  ਮ,  ஬ ⭥ᥭ ⥫  (  砥 室)*)
         DBF.SetField(dbfFile, "d_dopl_new", EMPTYOF(DATE)); (* 8 , ।  ⥫쭮  (  砥 室)*)
        END;
  
        L_ExtDB.RepRecord("dbfFile");
       END;
      END; (* IF VATRateToShowInBook(_VATRate) ... *)
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList) ... *)
    END;
    NEXT(MDIdx);
   END; (* WHILE OCCURE(MDIdx) ... *)
   TestCntrV();
  END; (* IF SELECT(MDIdx) ... *)
 END {ExpBook};

 PRIVATE PROCEDURE GetwRelToXDocId(trgXDocId: L_XDoc.tXDocId): L_XDoc.tXDocId;
  VAR
   Result: L_XDoc.tXDocId;
 BEGIN
  SETEMPTY(Result);
  SELECT(XDocRef, bXDocId, , trgXDocId);
  WHILE OCCURE(XDocRef) DO
   IF XDocRef.RefType = L_XDoc.rft_wRelTo THEN
    IF !Result THEN
     Result:=XDocRef.rXDocId;
    ELSE
     SETEMPTY(Result);
     LAST(XDocRef);
    END;
   END;
   NEXT(XDocRef);
  END; (* WHILE OCCURE(XDocRef) *)
  RETURN Result;
 END {GetwRelToXDocId};

 PRIVATE PROCEDURE ExpAdvance(Sale: SCAL[2]);
  VAR
   id            : STRING[];
   summa,
   sum20,
   nds20,
   sum18,
   nds18,
   sum10,
   nds10,
   sum0,
   sum00         : L_XObj.tSum;
   curVATRate    : L_Pmnt.tVATRates;
   vtb_ByMDocList: L_Pmnt.tValuesToBalance;
   rbVAT         : L_XObj.tSum;
   wRelToXDocId  : L_XDoc.tXDocId;
 BEGIN
  APP.Get().NewPrompt("饭 ᮢ "+L_Str.PoolItem("뤠|祭", Sale));
  SELECT(MDIdx, ToPrint);
  WHILE OCCURE(MDIdx) DO
   CONFORM(MDIdx, MDoc);
   PROMPT(L_DatTim.DateStr(MDIdx.pblDate) + ", " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   IF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrpReturn) | L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_OnPrpShpmt) THEN
    L_ExtDB.AddRecord("dbfFile");
 
    CONFORM(MDoc, Firm);
    CONFORM(MDoc, Contract);
    SETZERO(summa, sum20, nds20, sum18, nds18, sum10, nds10, sum0, sum00);
    CONFORM(MDoc, MDocList);
    WHILE OCCURE(MDocList) DO
     curVATRate:=L_Pmnt.GetMDocListVATRate();
     IF VATRateToShowInBook(curVATRate) THEN
      SETZERO(vtb_ByMDocList, rbVAT);
      vtb_ByMDocList:=L_Pmnt.vtbAdd(vtb_ByMDocList, L_Pmnt.GetMDocListAcpt());
      IF ~Sale THEN
       INC(rbVAT, CalcRebateVAT());
      END;
      pid_SingleMDocList(curVATRate, vtb_ByMDocList, rbVAT,
                         summa, sum20, nds20, sum18, nds18, sum10, nds10, sum0, sum00, 0);
     END; (* IF VATRateToShowInBook(curVATRate) ... *)
     NEXT(MDocList);
    END; (* LOOP ... *)
 
 (* BX  뤠    
    DBF.SetField(dbfFile, "id", ); (* 10 , ࠢ ID  䠩 B_BOOK1.dbf  ⭮ -䠪   (  ୠ)*)
    DBF.SetField(dbfFile, "pid", ); (* 10  祢 *)
    DBF.SetField(dbfFile, "piddoplist", ""); (* 10  *)
    DBF.SetField(dbfFile, "dopl", ); (* 8  *)
    DBF.SetField(dbfFile, "dotg", ); (* 8  饭*)
    DBF.SetField(dbfFile, "sum20", ); (*᫮ 15.2 㬬 饭  ⠢ 20% ( )*)
    DBF.SetField(dbfFile, "nds20", ); (*᫮ 15.2 㬬 饭   ⠢ 20%*)
    DBF.SetField(dbfFile, "sum18", ); (*᫮ 15.2 㬬 饭  ⠢ 18% ( )*)
    DBF.SetField(dbfFile, "nds18", ); (*᫮ 15.2 㬬 饭   ⠢ 18%*)
    DBF.SetField(dbfFile, "sum10", ); (*᫮ 15.2 㬬 饭  ⠢ 10% ( )*)
    DBF.SetField(dbfFile, "nds10", ); (*᫮ 15.2 㬬 饭   ⠢ 10%*)
    DBF.SetField(dbfFile, "sum0", );  (*᫮ 15.2 㬬 饭  ⠢ 0%*)
    DBF.SetField(dbfFile, "sum00", ); (*᫮ 15.2 㬬 饭, ᢮  *)
    DBF.SetField(dbfFile, "city", ""); (* 30  *)
    DBF.SetField(dbfFile, "gtd", ""); (* 30  *)
    DBF.SetField(dbfFile, "procent", EMPTYOF(SCAL[2])); (*L 1  *)
 *)
    wRelToXDocId:=GetwRelToXDocId(MDoc.XDocId);
    IF ~!wRelToXDocId THEN
     L_General.CallUs(L_XDoc.ExtractXDocType(wRelToXDocId) = L_XDoc.xdt_MDoc);
     SAVE(MDoc);
     L_XDoc.PositionOnXDoc(wRelToXDocId);
     id:=MDocId();
     RESTORE(MDoc);
    ELSE
     L_General.CallUs(~L_XDoc.XDocWasAutoBuild(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc));
     SETEMPTY(id);
    END;
 (* SX *)
    DBF.SetField(dbfFile, "id", id); (* 10 , ࠢ ID  䠩 B_BOOK1.dbf  ⭮ -䠪   (  ୠ)*)
    DBF.SetField(dbfFile, "pid", MDocId()); (* 10  祢 *)
(*  ଠ  ,  䠩 - ॠ쭮 
    DBF.SetField(dbfFile, "piddoplist", ""); (* 10  *)
*)
    DBF.SetField(dbfFile, "dopl",  MDoc.Date); (* 8  饭 (祭   㯮)*)
    DBF.SetField(dbfFile, "dkniga", EMPTYOF(DATE)); (* 8       ந쭮*)
    DBF.SetField(dbfFile, "sum20", sum20); (*᫮ 15.2 㬬 饭 த  ⠢ 20% ( )*)
    DBF.SetField(dbfFile, "nds20", nds20); (*᫮ 15.2 㬬 饭    ⠢ 20%*)
    DBF.SetField(dbfFile, "sum18", sum18); (*᫮ 15.2 㬬 饭த  ⠢ 18% ( )*)
    DBF.SetField(dbfFile, "nds18", nds18); (*᫮ 15.2 㬬 饭   ⠢ 18%*)
    DBF.SetField(dbfFile, "sum10", sum10); (*᫮ 15.2 㬬 饭த  ⠢ 10% ( )*)
    DBF.SetField(dbfFile, "nds10", nds10); (*᫮ 15 2 㬬 饭   ⠢ 10%*)
    DBF.SetField(dbfFile, "sum0",  sum0);  (*᫮ 15.2 㬬 饭த  ⠢ 0%*)
    DBF.SetField(dbfFile, "sum00", sum00); (*᫮ 15.2 㬬 饭, ᢮த, ᢮  *)
 
    L_ExtDB.RepRecord("dbfFile");
   END;
   NEXT(MDIdx);
  END; (* WHILE OCCURE(MDIdx) ... *)
 END {ExpAdvance};

 PRIVATE PROCEDURE ExpInvoicesJrn(Sale: SCAL[2]);
  VAR
   _p_inn,
   _p_kpp,
   _kodpred: STRING[];
   _dreg  : DATE;
   _nsf   : STRING[];
   _dsf   : DATE;
   _p_name,
   _tovar : STRING[];
   summa,
   sum20,
   nds20,
   sum18,
   nds18,
   sum10,
   nds10,
   sum0,
   sum00,
   isumma,
   inds  : L_XObj.tSum;
   PrtnrTyp           : P_Firm.tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
   curVATRate         : L_Pmnt.tVATRates;
   vtb_ByMDocList     : L_Pmnt.tValuesToBalance;
   rbVAT              : L_XObj.tSum;
   avans              : SCAL[2];
   curFirm            : LIKE(Firm.Firm);
 BEGIN
  APP.Get().NewPrompt("ୠ  "+L_Str.PoolItem("祭|⠢", Sale)+" ⮢-䠪");
  SELECT(MDIdx, ToPrint);
  WHILE OCCURE(MDIdx) DO
   CONFORM(MDIdx, MDoc);
   PROMPT(L_DatTim.DateStr(MDIdx.pblDate) + ", " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   IF ~L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrpReturn) & ~L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_OnPrpShpmt) THEN
    L_ExtDB.AddRecord("dbfFile");
 
    _kodpred:=E_CN002_KOD_PRED();

    IF P_MDoc.HasMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_PcBkData) THEN
     P_MDoc.Decode_PcBkData(MDocPro.Value, _p_inn, _p_name, curFirm, _nsf, _dsf);
     _p_kpp:=""; (* 24.01.2013 12:21:02 POLAK\Bor 0095656 .8 *)
    ELSE
     IF Sale THEN
      _dsf:=MDoc.Date;
      _nsf:=MDoc.MDoc;
     ELSE
      _dsf:=MDoc.SrcDate;
      _nsf:=MDoc.SrcNbr;
     END;
     CONFORM(MDoc, Firm);
     P_Firm.GetRegNameValues(Firm.Firm, MDoc.Date, PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
     _p_name:=ContractorBriefName;
     _p_inn:=P_Firm.GetFirmPro_PartnerTypeDepend(Firm.Firm, MDoc.Date, P_Firm.P_INN);
     IF IsAfter2004() THEN
      _p_kpp:=P_Firm.GetFirmProSoft(Firm.Firm, MDoc.Date, P_Firm.P_KPP);
     ELSE
      _p_kpp:="";
     END;
    END; (* IF P_MDoc.HasMDocPro( ... *)

    _dreg:=MDoc.Date;
    IF ~Sale THEN
     IF _dsf > _dreg THEN
      _dreg:=_dsf
     END;
    END;

    CONFORM(MDoc, Contract);
    _tovar:=P_Cntr.ppi_DescriptionOfGoods(Contract.Contract, MDoc.Date);
    IF !_tovar THEN
     _tovar:=Contract.Name;
    END;
    isumma:=MDoc.Total;
 
    SETZERO(summa, sum20, nds20, sum18, nds18, sum10, nds10, sum0, sum00);
    inds:=0;
    CONFORM(MDoc, MDocList);
    WHILE OCCURE(MDocList) DO
     curVATRate:=L_Pmnt.GetMDocListVATRate();
     IF VATRateToShowInBook(curVATRate) THEN
      INC(inds, MDocList.VAT);
  
      SETZERO(vtb_ByMDocList, rbVAT);
      vtb_ByMDocList:=L_Pmnt.vtbAdd(vtb_ByMDocList, L_Pmnt.GetMDocListAcpt());
      IF ~Sale THEN
       INC(rbVAT, CalcRebateVAT());
      END;
      IF Sale | ~L_APtm.IsMGT() | (rbVAT # 0) THEN
       IF ~Sale & L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrchUndpay) THEN
        vtb_ByMDocList:=L_Pmnt.vtbInv(vtb_ByMDocList);
        rbVAT:=-rbVAT;
       END;
  
       pid_SingleMDocList(curVATRate, vtb_ByMDocList, rbVAT,
                          summa, sum20, nds20, sum18, nds18, sum10, nds10, sum0, sum00, 0);
      END;
     END; (* IF VATRateToShowInBook(curVATRate) ... *)
     NEXT(MDocList);
    END; (* LOOP ... *)
 
    avans:=L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrpReturn) |
           L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_OnPrpShpmt) |
           L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Prepayment);
 
    DBF.SetField(dbfFile, "id",     MDocId()); (*  -䠪*)
    DBF.SetField(dbfFile, "nreg",   MDocId()); (* 10 樮  -䠪*)
    DBF.SetField(dbfFile, "dreg",   _dreg);    (* 8  ॣ樨 -䠪*)
    DBF.SetField(dbfFile, "nsf",    _nsf);     (* 10  -䠪 த*)
    DBF.SetField(dbfFile, "dsf",    _dsf);     (* 8     -䠪 த*)
    DBF.SetField(dbfFile, "p_kod",  "");       (* த  ᫮ ࠣ⮢*)
    DBF.SetField(dbfFile, "p_name", _p_name);  (* 200  த*)
    DBF.SetField(dbfFile, "p_inn",  _p_inn);
    DBF.SetField(dbfFile, "p_kpp",  _p_kpp);
    DBF.SetField(dbfFile, "tovar",  _tovar);   (* 70   *)
    DBF.SetField(dbfFile, "sum20",  sum20);
    DBF.SetField(dbfFile, "nds20",  nds20);
    DBF.SetField(dbfFile, "sum18",  sum18);
    DBF.SetField(dbfFile, "nds18",  nds18);
    DBF.SetField(dbfFile, "sum10",  sum10);
    DBF.SetField(dbfFile, "nds10",  nds10);
    DBF.SetField(dbfFile, "sum0",   sum0);
    DBF.SetField(dbfFile, "sum00",  sum00);
    DBF.SetField(dbfFile, "isum",   isumma-inds);  (*᫮ 15.2 㬬 㯪 ᥣ,  *)
    DBF.SetField(dbfFile, "inds",   inds);    (*᫮ 15.2 㬬 *)
    DBF.SetField(dbfFile, "isumma", isumma);  (*᫮ 15.2 㬬 㯪 ᥣ,  *)
    DBF.SetField(dbfFile, "kp",     1);      (*ਧ 祭   㯮(T- , F- )*)
    DBF.SetField(dbfFile, "vtip",   "1");      (* '1'*)
    DBF.SetField(dbfFile, "pclose", EMPTYOF(SCAL[2]));  (* *)
    DBF.SetField(dbfFile, "avans",  avans);   (*ਧ  祭 (.T. - , .F. - )*)
    DBF.SetField(dbfFile, "avansv", 0);        (*ਧ  뤠 (.T. - , .F. - )*)
    DBF.SetField(dbfFile, "id_corr", "");      (* 10 ID- -䠪, ४஢ . ਧ ४஢筮 -䠪.*)
    DBF.SetField(dbfFile, "id_ispr", "");      (* 10 ID- ࢨ筮 -䠪, ࠢ  ⮬-䠪ன (  ࠢ). ਧ ࠢ饣 -䠪.*)
    DBF.SetField(dbfFile, "id_nxtcorr", ""); (* 10 ID- -䠪, ४஢筮  . ਧ ⪮४஢ -䠪.   *)
    DBF.SetField(dbfFile, "id_nxtispr", ""); (* 10 ID- 襣 ࠢ -䠪. ਧ 㫨஢ -䠪.   *)
    DBF.SetField(dbfFile, "n_ispr",    EMPTYOF(SCAL[100])); (*᫮ 2  ࠢ*)
    DBF.SetField(dbfFile, "date_ispr", EMPTYOF(DATE)); (*  ࠢ*)
    DBF.SetField(dbfFile, "sposob", "1"); (* 1  ᯮᮡ । (1-㬠, 2-஭)*)
    DBF.SetField(dbfFile, "kvo", ""); (* 11   権 ( ᯨ᮪  १ ).*)
    DBF.SetField(dbfFile, "kodval", "643"); (* 3  .*)
 
    L_ExtDB.RepRecord("dbfFile");
   END; (* IF ~L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrpReturn) & ~L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_OnPrpShpmt) ... *)
   NEXT(MDIdx);
  END; (* WHILE OCCURE(MDIdx) ... *)
 END {ExpInvoicesJrn};

 PRIVATE CONST
  MTA_Books_Path = "REP\MTA_BOOKS\";

 PRIVATE PROCEDURE TempDBFFileName(FileName: STRING[]): STRING[];
 BEGIN
  RETURN L_FIO.tf_GetFullPath(FileName, "DBF");
 END {TempDBFFileName};

 PRIVATE PROCEDURE CreateDBF(FileName: STRING[]);
  VAR
   DstDir,
   DstFile,
   SrcFile: STRING[];
 BEGIN
  SrcFile:=FIO.BuildPath(FileName, "DBF", MTA_Books_Path);
  L_General.Assert(FIO.Exists(SrcFile), "  䠩 ࠧ|"+SrcFile);

  DstFile:=TempDBFFileName(FileName);

  FIO.Open(fSrc, SrcFile, , Input);
  FIO.Open(fDst, DstFile, , Create);
  FIO.Copy(fSrc, fDst);
  FIO.Close(fDst);
  FIO.Close(fSrc);
  DBF.Open(dbfFile, DstFile, Output);
  DBF.SetAmount(dbfFile, 0);
 END {CreateDBF};

 PRIVATE PROCEDURE DoneDBF(DBFFiles: STRING[][]);
  VAR
   DstDir,
   DstFile,
   SrcFile,
   curDBFFile: STRING[];
 BEGIN
  DstDir:=MTA_Books_Path+FLDTOSTR(Cn002_UpTo, "yN");
  IF ~FIO.DirExists(DstDir) THEN
   FIO.MkDir(DstDir);
  END;
  DstDir:=DstDir+"\"+L_DatTim.SysDateTimeStamp();
  IF ~FIO.DirExists(DstDir) THEN
   FIO.MkDir(DstDir);
  END;
  FOR_EACH curDBFFile IN DBFFiles DO
   SrcFile:=TempDBFFileName(curDBFFile);
   DstFile:=FIO.BuildPath(Str.Slice(curDBFFile, 0, 2)+FLDTOSTR(Cn002_UpTo, "NY"), "DBF", DstDir);
   FIO.RenMov(SrcFile, , DstFile);
  END;
 END {DoneDBF};

 PRIVATE PROCEDURE intExpBooks2Konto(SingleContract: SCAL[2]);
  CONST
   DBFFiles = [ "BK0000", "BG0000", "SG0000", "SX0000" ];
   dbf_BK = 0;
   dbf_BG = 1;
   dbf_SG = 2;
   dbf_SX = 3;
 BEGIN
  APP.Get().NewPrompt("㧪  㯮  த");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.SetCacheables(["Contract"]);

  L_General.SetIntvlByMonth(Cn002_From, Cn002_UpTo);
  Cn002_WFPeriod:=L_Pmnt.ConvPer2VATClcPer(Memo.ud_mb());
  SetCurMyFirm(SingleContract);
  CheckSpecialVATMDocDone(SingleContract, Cn002_UpTo);
  Create_TemporaryFiles();
  CteateTemp();
  PrepareBook(0, SingleContract, wfs_Book);

  CreateDBF(DBFFiles[dbf_BK]);
  ExpBook(0);
  DBF.Close(dbfFile);

  CreateDBF(DBFFiles[dbf_BG]);
  ExpInvoicesJrn(0);
  DBF.Close(dbfFile);

  CreateDBF(DBFFiles[dbf_SX]);
  ExpAdvance(0);
  DBF.Close(dbfFile);

  ClearTemp();

  PrepareBook(1, SingleContract, wfs_Book);
  CreateDBF(DBFFiles[dbf_SG]);
  ExpBook(1);
  DBF.Close(dbfFile);

  DoneDBF(DBFFiles);
  Purge_TemporaryFiles();
 END {intExpBooks2Konto};

 PUBLIC PROCEDURE SlBk();
 BEGIN
  MakeBook(1, 0, 0, 0);
 END {SlBk};

 PUBLIC PROCEDURE PcBk();
 BEGIN
  MakeBook(0, 0, 0, 0);
 END {PcBk};

 PUBLIC PROCEDURE SlBk_MonthInquiry();
 BEGIN
  MakeBook(1, 0, 0, 1);
 END {SlBk_MonthInquiry};

 PUBLIC PROCEDURE PcBk_MonthInquiry();
 BEGIN
  MakeBook(0, 0, 0, 1);
 END {PcBk_MonthInquiry};

 PUBLIC PROCEDURE SlBk_SingleContract();
 BEGIN
  MakeBook(1, 1, 0, 0);
 END {SlBk_SingleContract};

 PUBLIC PROCEDURE PcBk_SingleContract();
 BEGIN
  MakeBook(0, 1, 0, 0);
 END {PcBk_SingleContract};

 PUBLIC PROCEDURE SlBk_SingleContract_MonthInquiry();
 BEGIN
  MakeBook(1, 1, 0, 1);
 END {SlBk_SingleContract_MonthInquiry};

 PUBLIC PROCEDURE PcBk_SingleContract_MonthInquiry();
 BEGIN
  MakeBook(0, 1, 0, 1);
 END {PcBk_SingleContract_MonthInquiry};

 PUBLIC PROCEDURE ExpBooks2Konto();
 BEGIN
  intExpBooks2Konto(0);
 END {ExpBooks2Konto};

END.
