(*
%Copyright   (c) Polak Computer System
%Author      27.08.2002 13:25:28 SAN
%Purpose     ନ஢  㯮  த
%Type        report
%Specific    SYS
%Modified    18.03.2013 10:12:45 POLAK\San
%Environment
*)

 MODULE Cn003;

 IMPORT L_General, L_AFM, L_DatTim, L_Str, L_XDoc, L_MDoc, L_PDoc, L_Pmnt,
        P_Firm, L_MSO, P_Math, L_APtm, L_AcCut, L_Cntr, L_XObj, L_Acnt, L_Russia, L_Env, Memo, P_MyFirm;

 TYPE
  tQuarter = SCAL[4];
  tVector  = NUMERIC[2][5];

 CONST
  v_AllRec = 0;
  v_PayRec = 1;
  v_ShpRec = 2;
  v_CorRec = 3;
  v_TaxRec = 4;

 VAR
  Cn003_From,
  Cn003_UpTo : DATE;
  wMF        : SCAL[2];

 PRIVATE PROCEDURE E_PrepaymentAsRecYear(): DATE;
 BEGIN
  RETURN 01\01\2012;
 END {E_PrepaymentAsRecYear};

 PRIVATE PROCEDURE IsNotTaxedContract(): SCAL[2];
 BEGIN
 (* 0059529 !!! *)
 (* 0064751 !!! *)
  RETURN (Contract.CntrT=24) | (Contract.CntrT=27) | (Contract.CntrT=22);
 END {IsNotTaxedContract};

 PRIVATE PROCEDURE Create_TemporaryFiles();
 BEGIN
  CreateFILE(MDIdx, "", "", "");
  CreateFIELD(MDIdx, sXDocId,  L_XDoc.tXDocId, "", "", "", "", "");
  CreateFIELD(MDIdx, sXDDate,  DATE, "", "", "", "", "");
  CreateFIELD(MDIdx, sXDDTS,   FLOAT, "", "", "", "", "");
  CreateFIELD(MDIdx, BldMode,  L_Pmnt.tVATMDocBuildMode, "", "", "", "", "");
  CreateFIELD(MDIdx, MDocKind, SCAL[1E2], "", "", "", "", "");
  CreateFIELD(MDIdx, MDoc,     SCAL[1E7], "", "", "", "", "");
  CreateFIELD(MDIdx, Total,    tVector, "", "", "", "", "");

  CreateINDEX(MDIdx, ToPrint, PLURAL, "", "", sXDDate, sXDDTS);
  CreateINDEXandLINK(MDIdx, MDoc, PLURAL, MDoc, MDoc, USER, "", "", MDocKind, MDoc);
  SetVersionOfFILE(MDIdx, 0000);

  CreateFILE(DsTot, "", "", "");
  CreateFIELD(DsTot, Quarter,  tQuarter,   "", "", "", "", "");
  CreateFIELD(DsTot, Dest,     SCAL[1E3],  "", "", "", "", "");
  CreateFIELD(DsTot, OpName,   STRING[32],  "", "", "", "", "");
  CreateFIELD(DsTot, Total,    tVector,    "", "0", "", "", "");

  CreateINDEX(DsTot, Quarter, UNIQUE, "", "", Quarter, Dest, OpName);

  SetVersionOfFILE(DsTot, 0000);

  L_AFM.AF_CreateTemp("MDIdx", "MDIdx");
  L_AFM.AF_CreateTemp("DsTot", "DsTot");
 END {Create_TemporaryFiles};

 PRIVATE PROCEDURE Purge_TemporaryFiles();
 BEGIN
  L_AFM.AF_PurgeTemp("DsTot");
  L_AFM.AF_PurgeTemp("MDIdx");
 END {Purge_TemporaryFiles};

 PRIVATE PROCEDURE PutInMDIdx(sXDocId : L_XDoc.tXDocId;
                              sXDDate : DATE;
                              sXDDTS  : FLOAT;
                              BldMode : L_Pmnt.tVATMDocBuildMode;
                              Total   : tVector);
 BEGIN
  DEFAULT(MDIdx);
  MDIdx.sXDocId :=sXDocId;
  MDIdx.sXDDate :=sXDDate;
  MDIdx.sXDDTS  :=sXDDTS;
  MDIdx.BldMode :=BldMode;
  MDIdx.MDocKind:=MDoc.MDocKind;
  MDIdx.MDoc    :=MDoc.MDoc;
  MDIdx.Total   :=Total;
  INSERT(MDIdx);
 END {PutInMDIdx};

 PUBLIC PROCEDURE GetUncoveredMDocAcpt(trgMDocKind: LIKE(MDoc.MDocKind); CtrlDate: DATE): L_Pmnt.tValuesToBalance;
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
   Result        : L_Pmnt.tValuesToBalance;
 BEGIN
  SAVE(MDoc);
  Result:=L_Pmnt.GetMDocAcpt();
  DependentMDocs:=L_XDoc.GetDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_MDoc);
  i:=0;
  WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
   IF (MDoc.MDocKind = trgMDocKind) & (MDoc.Date < CtrlDate) & (MDoc.Status#L_MDoc.st_Canceled) THEN
    Result:=L_Pmnt.vtbSub(Result, L_Pmnt.GetMDocAcpt());
   END;
   INC(i);
  END; (* WHILE L_XDoc.xdc_PositionOn ... *)
  RESTORE(MDoc);
  L_General.CallUs(Result[L_Pmnt.vtb_Total] >= 0);
  RETURN Result;
 END {GetUncoveredMDocAcpt};


 PRIVATE PROCEDURE PutByRef(bm: L_Pmnt.tVATMDocBuildMode; Full: SCAL[2]);
  VAR
   sXDocId    : L_XDoc.tXDocId;
   sXDDate    : DATE;
   sXDDTS     : FLOAT;
   Total      : tVector;
   trgValue   : L_Pmnt.tValuesToBalance;
 BEGIN
  SETEMPTY(Total);
  IF Full THEN
   Total[v_AllRec]:=MDoc.Total;
   sXDDate:=MDoc.Date;
   sXDDTS :=MDoc.DoneDTS;
  ELSE
   TRY [RESTORE_CURSORS(RC_ON)]
    CONFORM(MDoc, Contract);
    trgValue:=GetUncoveredMDocAcpt(L_Pmnt.E_GetVATMDocMDocKind(MDoc.Date, L_Pmnt.vmdbm_OnPrpShpmt),
                                   E_PrepaymentAsRecYear());
    Total[v_AllRec]:=trgValue[L_Pmnt.vtb_Total];
    IF Total[v_AllRec] = 0 THEN
     RETURN;
    ELSE
     L_General.CallUs(Total[v_AllRec] > 0);
     sXDDate:=E_PrepaymentAsRecYear();
     sXDDTS :=MINOF(MDoc.DoneDTS);
    END;
   EXCEPT
   END;
  END;
  IF bm = L_Pmnt.vmdbm_Acceptance THEN
   sXDocId:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
  ELSE
   sXDocId:=L_XDoc.GetBaseOnXDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
   L_General.CallUs(~!sXDocId);
  END;
  PutInMDIdx(sXDocId, sXDDate, sXDDTS, bm, Total);
 END {PutByRef};

 PRIVATE PROCEDURE Put(Full: SCAL[2]);
 BEGIN
  PROMPT(L_DatTim.DateStr(MDoc.Date) + " " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
  IF (MDoc.Status # L_MDoc.st_Canceled) THEN
   IF ~wMF | (MDoc.MyFirm = P_Firm.curMyFirm) THEN
    IF    L_Pmnt.IsAcptMDocKind(MDoc.MDocKind) THEN
     PutByRef(L_Pmnt.vmdbm_Acceptance, Full);
    ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Acceptance) THEN
     L_General.CallUs(0);
    ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Prepayment) THEN
     PutByRef(L_Pmnt.vmdbm_Prepayment, Full);
    ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Underpay) THEN
     PutByRef(L_Pmnt.vmdbm_Underpay, Full);
    ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Pstpayment) THEN
     PutByRef(L_Pmnt.vmdbm_Pstpayment, Full);
    ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrpReturn) THEN
     PutByRef(L_Pmnt.vmdbm_PrpReturn, Full);
    ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_OnPrpShpmt) THEN
     PutByRef(L_Pmnt.vmdbm_OnPrpShpmt, Full);
    ELSE
     L_General.CallUs(0);
    END;
   END;
  END;
 END {Put};

 PRIVATE PROCEDURE PassSingleMDocKind(SingleContract: SCAL[2]; _MDocKind: LIKE(MDoc.MDocKind));
  VAR
   vtb: L_Pmnt.tValuesToBalance;
 BEGIN
  IF SingleContract THEN
   SELECT(MDoc, Contract, , Contract.Contract, _MDocKind);
  ELSE
   SELECT(MDoc, MDKDate, , _MDocKind);
  END;
  SRCINSEL(MDoc, GE, , Cn003_From);
  WHILE OCCURE(MDoc) & (MDoc.Date <= Cn003_UpTo) DO
   Put(1);
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {PassSingleMDocKind};

 PRIVATE PROCEDURE Jump2PrepaymentAsRec(SingleContract: SCAL[2]);
  VAR
   vtb: L_Pmnt.tValuesToBalance;
 BEGIN
  APP.Get().NewPrompt("室   '।'='室'");
  IF SingleContract THEN
   SELECT(MDoc, Contract, , Contract.Contract, L_MDoc.md_DPr);
  ELSE
   IF wMF THEN
    SELECT(MDoc, mfNbr, , L_MDoc.md_DPr, P_Firm.curMyFirm);
   ELSE
    SELECT(MDoc, MDocKind, , L_MDoc.md_DPr);
   END;
  END;
  WHILE OCCURE(MDoc) DO
   IF MDoc.Date < E_PrepaymentAsRecYear() THEN
    IF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Prepayment) THEN
     CONFORM(MDoc, Contract);
     IF ~IsNotTaxedContract() THEN
      Put(0);
     END;
    END;
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {Jump2PrepaymentAsRec};

 PRIVATE PROCEDURE word_PutSingle(Name: STRING[]; Value: NUMERIC[2]);
 BEGIN
  IF ~!Value THEN
   L_MSO.wordSetMoneyVar(Name, Cn003_UpTo, Value);
  ELSE
   L_MSO.wordSetVar(Name, "-");
  END;
 END {word_PutSingle};

 PRIVATE PROCEDURE word_PutSums(Prefix       : STRING[];
                        Total        : tVector);
 BEGIN
  word_PutSingle(Prefix + ".PayRec", Total[v_PayRec]);
  word_PutSingle(Prefix + ".ShpRec", Total[v_ShpRec]);
  word_PutSingle(Prefix + ".CorRec", Total[v_CorRec]);
  word_PutSingle(Prefix + ".TaxRec", Total[v_TaxRec]);
 END {word_PutSums};

 PRIVATE PROCEDURE IncVector(VAR dst: tVector; src: tVector);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(dst) DO
   INC(dst[i], src[i]);
   INC(i);
  END;
 END {IncVector};

 PRIVATE PROCEDURE PutInWord();
  VAR
   Root,
   List,
   TemplateName  : STRING[];
   curV,
   quaV,
   totV          : tVector;
   OpName        : STRING[];
   mdlIdx        : NUMERIC[0][4];
   ttlIdx        : NUMERIC[0];
   Quarter       : tQuarter;
 BEGIN
  IF SELECT(MDIdx, ToPrint) THEN
   L_MSO.wordInitDocument(Cn003_UpTo);
   Root        :="RcExBook";
   TemplateName:="REBk_01";

   L_MSO.wordSetVar(Root + ".멏ਮ",
       L_Str.IntStr((L_DatTim.QUARTAL(Cn003_UpTo)+1)*3) + "  " + FLDTOSTR(Cn003_UpTo, "y", 4) + " ");
   L_MSO.wordSetDateVar(Root + ".⠏᫥᫥", Cn003_UpTo+1);
   L_MSO.wordSetDateVar(Root + ".From", Cn003_From);
   L_MSO.wordSetDateVar(Root + ".UpTo", Cn003_UpTo);
   L_General.Assert(P_MyFirm.HasActualPro(P_Firm.curMyFirm, Cn003_UpTo, P_MyFirm.P_TaxationMode),
                    "  ᢮⢮ " + L_Str.FixedIntStr(P_MyFirm.P_TaxationMode, 4) + " ' ࣠樨'");
   L_MSO.wordSetDateVar(Root + ".USNOAdvice.Date", MFPro.DocGiveD);
   L_MSO.wordSetVar    (Root + ".USNOAdvice.Number", MFPro.DocNum);
   P_Firm.SetFirmDefaultData("Own", P_Firm.fomf(P_Firm.curMyFirm), Cn003_UpTo, "");

   SETZERO(mdlIdx);
   WHILE OCCURE(MDIdx) DO
    curV:=MDIdx.Total;
    IF    (MDIdx.BldMode = L_Pmnt.vmdbm_Acceptance) THEN
     OpName:="";
     curV[v_TaxRec]:=curV[v_AllRec];
     curV[v_ShpRec]:=curV[v_AllRec];
    ELSIF (MDIdx.BldMode = L_Pmnt.vmdbm_Prepayment) THEN
     OpName:="। (祭)";
     IF MDIdx.sXDDate >= E_PrepaymentAsRecYear() THEN
      curV[v_TaxRec]:=curV[v_AllRec];
     ELSE
      curV[v_TaxRec]:=0;
     END;
     curV[v_PayRec]:=curV[v_AllRec];
    ELSIF (MDIdx.BldMode = L_Pmnt.vmdbm_OnPrpShpmt) THEN
     OpName:="। (४)";
     IF MDIdx.sXDDate >= E_PrepaymentAsRecYear() THEN
      curV[v_TaxRec]:=(-1) * curV[v_AllRec];
     ELSE
      curV[v_TaxRec]:=0;
     END;
     curV[v_CorRec]:=(-1) * curV[v_AllRec];
    ELSIF (MDIdx.BldMode = L_Pmnt.vmdbm_Underpay) THEN
     OpName:=" ( )";
     curV[v_TaxRec]:=(-1) * curV[v_AllRec];
     curV[v_CorRec]:=(-1) * curV[v_AllRec];
    ELSIF (MDIdx.BldMode = L_Pmnt.vmdbm_Pstpayment) THEN
     OpName:="";
     curV[v_TaxRec]:=curV[v_AllRec];
     curV[v_PayRec]:=curV[v_AllRec];
    ELSIF (MDIdx.BldMode = L_Pmnt.vmdbm_PrpReturn) THEN
     OpName:=" ।";
     curV[v_AllRec]:=(-1) * curV[v_AllRec];
     IF MDIdx.sXDDate >= E_PrepaymentAsRecYear() THEN
      curV[v_TaxRec]:=curV[v_AllRec];
     ELSE
      curV[v_TaxRec]:=0;
     END;
     curV[v_PayRec]:=curV[v_AllRec];
    ELSE
     L_General.CallUs(0);
    END;
    PROMPT("⮢  㧪 " + L_DatTim.DateStr(MDIdx.sXDDate) + ", " + L_XDoc.XDocStr(MDIdx.sXDocId));
    CONFORM(MDIdx, MDoc);
    CONFORM(MDoc, Contract);
    CONFORM(MDoc, Dest);
    IF IsNotTaxedContract() THEN
     curV[v_TaxRec]:=0;
    END;
    CONFORM(Contract, Firm);
    Quarter:=L_DatTim.QUARTAL(MDIdx.sXDDate);
    List:=Root+".List"+L_Str.IntStr(Quarter)+L_MSO.IndexStr(mdlIdx[Quarter]);
    L_MSO.wordSetVar(List + ".Pos", L_Str.IntStr(mdlIdx[Quarter]+1));
    List:=List + ".XDoc";
    SAVE(MDoc);
    L_XDoc.PositionOnXDoc(MDIdx.sXDocId);
    IF L_XDoc.ExtractXDocType(MDIdx.sXDocId) = L_XDoc.xdt_PDoc THEN
     L_MSO.wordSetVar(List + ".XDoc",   FLDTOSTR(PDoc.PDoc, "", 7));
     L_MSO.wordSetVar(List + ".SrcNbr", PDoc.SrcNbr);
     L_MSO.wordSetDateVar(List + ".SrcDate", PDoc.PrpDate);
     L_MSO.wordSetVar(List + ".XDocKind.Sign", L_PDoc.PDocKindNick(PDoc.PDocKind, 1));
    ELSE
     L_MSO.wordSetVar(List + ".XDoc",   MDoc.MDoc);
     L_MSO.wordSetVar(List + ".SrcNbr", MDoc.SrcNbr);
     L_MSO.wordSetDateVar(List + ".SrcDate", MDoc.SrcDate);
     L_MSO.wordSetVar(List + ".XDocKind.Sign", L_MDoc.MDocKindNick(MDoc.MDocKind, 1));
    END;
    RESTORE(MDoc);
    L_MSO.wordSetDateVar(List + ".Date", MDIdx.sXDDate);
    L_MSO.wordSetVar(List + ".OpName", OpName);
    L_MSO.wordSetVarsByFile_wAlias("Contract", List+".Contract");
    L_MSO.wordSetVarsByFile_wAlias("Firm",     List+".Contract.Firm");
    word_PutSums(List, curV);
    IF !curV[v_PayRec] THEN curV[v_PayRec]:=0; END;
    IF !curV[v_ShpRec] THEN curV[v_ShpRec]:=0; END;
    IF !curV[v_CorRec] THEN curV[v_CorRec]:=0; END;
    ADD(DsTot, Quarter, , Quarter, MDoc.Dest, OpName,
        DsTot.Total[v_AllRec], curV[v_AllRec],
        DsTot.Total[v_PayRec], curV[v_PayRec],
        DsTot.Total[v_ShpRec], curV[v_ShpRec],
        DsTot.Total[v_CorRec], curV[v_CorRec],
        DsTot.Total[v_TaxRec], curV[v_TaxRec]);
    INC(mdlIdx[Quarter]);
    NEXT(MDIdx);
   END; (* WHILE OCCURE(MDIdx) ... *)
   SETZERO(ttlIdx, Quarter, totV);

   FOR_EACH Quarter DO
    SETZERO(quaV);
    SELECT(DsTot, Quarter, , Quarter);
    WHILE OCCURE(DsTot) DO
     List:=Root+".byDest"+L_MSO.IndexStr(ttlIdx);
     SEARCH(Dest, Dest, , DsTot.Dest);
     L_MSO.wordSetVar(List+".Quarter", L_Str.IntStr(Quarter+1));
     L_MSO.wordSetVarsByFile_wAlias("Dest", List+".Dest");
     L_MSO.wordSetVar(List+".OpName", DsTot.OpName);
     word_PutSums(List, DsTot.Total);
     IncVector(quaV, DsTot.Total);
     IncVector(totV, DsTot.Total);
     INC(ttlIdx);
     NEXT(DsTot);
    END; (* WHILE OCCURE(DsTot) ... *)
    word_PutSums(Root + ".Quarter"     + L_Str.IntStr(Quarter), quaV);
    word_PutSums(Root + ".FromYearBeg" + L_Str.IntStr(Quarter), totV);
    L_MSO.extSetWordTable("table"+L_Str.IntStr(Quarter), mdlIdx[Quarter], L_MSO.tt_Soft);
   END;
   L_MSO.SetWordTable("tableD", ttlIdx);
   L_MSO.PutInTables:=L_MSO.Put_Values;
   L_MSO.MakeWordDocument(TemplateName, 1, L_MSO.PrpMode_ToDoc, "");
  ELSE
   STDMSG("     ப", STOP);
  END; (* IF SELECT(MDIdx) ... *)
 END {PutInWord};

 PRIVATE PROCEDURE MakeBook(SingleContract: SCAL[2]);
 BEGIN
  Cn003_From:=L_DatTim.YearBeg(Memo.ud_mb());
  Cn003_UpTo:=Memo.ud_me();
  IF SingleContract THEN
   ACCESS(Contract);
  END;
  wMF:=P_Firm.E_wMultipleMyFirm(Cn003_UpTo);
  IF wMF THEN
   IF SingleContract THEN
    P_Firm.curMyFirm:=Contract.MyFirm;
   ELSE
    P_Firm.curMyFirm:=P_Firm.DefineMyFirm();
   END;
  ELSE
   P_Firm.curMyFirm:=P_Firm.mf_Own;
  END;
  L_General.Assert(P_Firm.FirmHasSimplifiedTaxation(P_Firm.fomf(P_Firm.curMyFirm), Cn003_UpTo),
                   "࠭ ' ࣠'  ਬ ");

  IF SingleContract THEN
   L_Pmnt.CheckSpecialVATMDocDone(Contract.Contract, Cn003_UpTo);
  ELSE
   L_Pmnt.CheckSpecialVATMDocDoneAll(P_Firm.curMyFirm, Cn003_UpTo);
  END;

  Create_TemporaryFiles();
  IF Cn003_From = E_PrepaymentAsRecYear() THEN
   Jump2PrepaymentAsRec(SingleContract);
  END;
  PassSingleMDocKind(SingleContract, L_MDoc.md_DPr);
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF L_MDoc.IsOutgoingMDocKind(MDocKind.MDocKind) & L_Pmnt.IsAcptMDocKind(MDocKind.MDocKind) THEN
    PassSingleMDocKind(SingleContract, MDocKind.MDocKind);
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
  PutInWord();
  Purge_TemporaryFiles();
 END {MakeBook};

 PUBLIC PROCEDURE Cn003_SingleContract();
 BEGIN
  MakeBook(1);
 END {Cn003_SingleContract};

 PUBLIC PROCEDURE Cn003();
 BEGIN
  MakeBook(0);
 END {Cn003};

END.
