(*
%Copyright   (c) Polak IT
%Author      26.08.2009 12:03:53 POLAK\San
%Purpose      
%Type        report
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    10.04.2012 12:15:30 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_Basis, L_DatTim, P_Firm, FIO, Memo, Math, L_CI, L_bp;

 VAR
  curReportId  : STRING[];
  wMF          : SCAL[2];

 PRIVATE PROCEDURE Cn004_MakeHeader();
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(curReportId, "");
   L_Basis.wb_WrInQM(curReportId, "");
  END;
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_WrInQM(curReportId, " ");
  L_Basis.wb_WrInQM(curReportId, "_1");
  L_Basis.wb_WrInQM(curReportId, "_2");
  L_Basis.wb_WrInQM(curReportId, "_3");
  L_Basis.wb_WrInQM(curReportId, "⑄");
  L_Basis.wb_WrInQM(curReportId, "⑄");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, "");
  L_Basis.wb_WrInQM(curReportId, "㬬");
  L_Basis.wb_WrInQM(curReportId, " 砫 ਮ ⢨ ᯨᠭ");
  L_Basis.wb_WrInQM(curReportId, " ࠢ");
  L_Basis.wb_WrInQM(curReportId, "室 ");
  L_Basis.wb_TermLine(curReportId);
 END {Cn004_MakeHeader};

 PRIVATE PROCEDURE GetCIParentName(Level: NUMERIC[0]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  SAVE(CostItem);
  WHILE ~!CostItem.Parent & (Level > 0) DO
   SEARCH(CostItem, CostItem, , CostItem.Parent);
   Result:=CostItem.Name;
   DEC(Level);
  END; (* WHILE *)
  RESTORE(CostItem);
  RETURN Result;
 END {GetCIParentName};

 PRIVATE PROCEDURE Cn004_MakePart(trnCostItem : LIKE(CostItem.CostItem);
                          trnCIName   : STRING[];
                          M           : DATE;
                          Sum         : NUMERIC[2];
                          MonthBeg    : DATE;
                          _Dfrls      : LIKE(Dfrls.Dfrls);
                          _SrcNbr     : LIKE(Dfrls.SrcNbr));
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrScl(curReportId, MyFirm.MyFirm);
   L_Basis.wb_WrStr(curReportId, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(curReportId, CostItem.CostItem);
  L_Basis.wb_WrStr(curReportId, CostItem.Name);
  IF OCCURE(CIKind) THEN
   L_Basis.wb_WrScl(curReportId, CIKind.CIKind);
   L_Basis.wb_WrStr(curReportId, CIKind.Name);
  ELSE
   L_Basis.wb_WrScl(curReportId, "");
   L_Basis.wb_WrStr(curReportId, "");
  END;
  L_Basis.wb_WrStr(curReportId, GetCIParentName(1));
  L_Basis.wb_WrStr(curReportId, GetCIParentName(2));
  L_Basis.wb_WrStr(curReportId, GetCIParentName(3));
  L_Basis.wb_WrScl(curReportId, trnCostItem);
  L_Basis.wb_WrStr(curReportId, trnCIName);
  L_Basis.wb_WrDat(curReportId, M);
  L_Basis.wb_WrDat(curReportId, L_DatTim.YearBeg(M));
  L_Basis.wb_WrNum(curReportId, Sum, 2);
  L_Basis.wb_WrDat(curReportId, MonthBeg);
  L_Basis.wb_WrScl(curReportId, _Dfrls);
  L_Basis.wb_WrStr(curReportId, _SrcNbr);
  L_Basis.wb_TermLine(curReportId);
 END {Cn004_MakePart};

 PRIVATE PROCEDURE Cn004_DoSingleDfrls(P: DATE);
  VAR
   trnCostItem: LIKE(CostItem.CostItem);
   trnCIName  : STRING[];
   M          : DATE;
 BEGIN
  IF (Dfrls.Status = L_CI.dfst_Passed) & (L_DatTim.Per(Dfrls.EndDate) >= P) THEN
   CONFORM(Dfrls, CostItem);
   trnCostItem:=CostItem.CostItem;
   trnCIName  :=CostItem.Name;
   CONFORM(Dfrls, MyFirm);
   SELECT(DfrlsL, Dfrls, , Dfrls.Dfrls);
   WHILE OCCURE(DfrlsL) DO
    CONFORM(DfrlsL, CostItem);
    CONFORM(CostItem, CIKind);
    SELECT(DfrlsLD, Dfrls, , DfrlsL.Dfrls, DfrlsL.DfrlsL);
    M:=Math.Max(P, L_DatTim.Per(Dfrls.BegDate));
    WHILE M <= L_DatTim.Per(Dfrls.EndDate) DO
     PROMPT(DfrlsL.Dfrls + ", " + DfrlsL.DfrlsL + ", " + L_DatTim.PeriodStr(M));
     IF SRCINSEL(DfrlsLD, LE, M) THEN
      Cn004_MakePart(trnCostItem, trnCIName, M, DfrlsLD.Sum, L_DatTim.Per(Dfrls.BegDate), Dfrls.Dfrls, Dfrls.SrcNbr);
     ELSE
      L_General.ConsultToUs(0, "Cn004_DoSingleDfrls.Error 123");
     END;
     M:=L_DatTim.IncMonth(M, +1);
    END; (* WHILE M ... *)
    NEXT(DfrlsL);
   END; (* WHILE OCCURE(DfrlsL) ... *)
  END;
 END {Cn004_DoSingleDfrls};

 PUBLIC PROCEDURE Cn004_Do();
  CONST
   RepName = "CN004";
  VAR
   oPrompt: OBJECT;
 BEGIN
  L_bp.Begin("CN004", " ", L_bp.t_Basis, L_General.timeCond_OnMonthBeg);
  oPrompt:=PROMPTLINE.Create("⮢ Cn004");
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  curReportId:="R";
  FIO.Open(^curReportId, L_General.NameConnection(RepName), "REP", Create);
  Cn004_MakeHeader();
  SELECT(Dfrls, Dfrls);
  WHILE OCCURE(Dfrls) DO
   Cn004_DoSingleDfrls(Memo.ud_mb());
   NEXT(Dfrls);
  END; (* WHILE OCCURE(Dfrls) ... *)
  FIO.Close(^curReportId);
  L_bp.End();
 END {Cn004_Do};

END.
