(*
%Copyright   (c) Polak IT
%Author      09.09.2009 12:40:48 POLAK\Bor
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    15.08.2014 18:51:00 POLAK\Bor
%Environment
*)

 MODULE CN010;

 IMPORT L_General, L_OwnData, L_DatTim, L_XObj, L_XDoc, L_AcCut, L_AFM, L_Acnt, L_Str, L_MathR, P_Firm;

 CONST
  RepName="CN010";

 VAR
  From,
  UpTo: DATE;
  Title,
  XOName: STRING[];

(*
$P{ Top:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
From, L, "D.N.y"
UpTo, L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                                           ⠢ ⮢                                           |
|############################################################################################################|
|                                     ਮ  ##########  ##########                                    |
}
*)

(*
$P{ ObjTop:
_XDAp.XOName, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
}
*)

(*
$P{ XAppTop:
@
|------------------------------------------------------------------------------------------------------------|
| |㥬 ࠧ१                  |।㥬 ࠧ१                |         |        ।|
|-------|-----------------------------------|----------------------------------|--------------|--------------|
}
*)

(*
$P{ XAppLine:
_XDAp.AcCut, L, ""
_XDAp.AcCut2, L, ""
OutAcCut(_XDAp.AcCut), L, ""
OutAcCut(_XDAp.AcCut2), L, ""
OutSum(_XDAp.Dbt), R, "2."
OutSum(_XDAp.Crd), R, "2."
@
|### ###|###################################|##################################|##############|##############|
}
*)

(*
$P{ XDApTop:
@
|-------|----------------------------------------------------------------------|--------------|--------------|
|       |ᯮ騩 ꥪ                            |㬥         |              |              |
|-------|----------------------------------------------------|-----------------|--------------|--------------|
}
*)

(*
$P{ XDApLine:
?, L, ""
?, L, ""
?, L, ""
L_XDoc.XDocStr(_XDAp.XDocId), L, ""
OutSum(_XDAp.Dbt), R, "2."
OutSum(_XDAp.Crd), R, "2."
@
|### ###|####################################################|#################|##############|##############|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE OutSum(_Sum: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF _Sum = 0 THEN
   RETURN L_General.EMPTY_NUMBER();
  ELSE
   RETURN _Sum;
  END;
 END {OutSum};

 PRIVATE PROCEDURE OutAcCut(_AcCut: LIKE(AcCut.AcCut)): STRING[];
 BEGIN
  L_AcCut.PositionOnAcCut(_AcCut);
  RETURN L_Acnt.GetCAcntSign(UpTo, _AcCut)+" "+AcCut.Name;
 END {OutAcCut};

 PRIVATE PROCEDURE AddXDAp(_CorXObj: LIKE(XObject.XObject);
                   _XDocId : LIKE(XDocApr.XDocId);
                   _Sum    : LIKE(XDocApr.Sum));
  VAR
   _Dbt,
   _Crd  : LIKE(XDocApr.Sum);
   dAcCut,
   cAcCut: LIKE(AcCut.AcCut);
 BEGIN
  SETZERO(_Dbt, _Crd);
  IF Apport.CirType = L_Acnt.ct_Debit THEN
   _Dbt:=_Sum;
   dAcCut:=XApport.AcCut;
   cAcCut:=XApport.AcCut2;
  ELSE
   _Crd:=_Sum;
   dAcCut:=XApport.AcCut2;
   cAcCut:=XApport.AcCut;
  END;
  ADD(_XDAp, _XDAp, , XObject.MyFirm, XOName, XObject.XObject, dAcCut, cAcCut, _CorXObj, _XDocId,
                      _XDAp.Dbt, _Dbt,
                      _XDAp.Crd, _Crd);
 END {AddXDAp};

 PRIVATE PROCEDURE PrepareOneXApport(leftSide: SCAL[2]);
  VAR
   CorXObject: LIKE(XObject.XObject);
 BEGIN
  L_XObj.SelectXDocAprByXApport(leftSide);
  WHILE OCCURE(XDocApr) DO
   IF leftSide THEN
    CorXObject:=XDocApr.XObject2;
   ELSE
    CorXObject:=XDocApr.XObject;
   END;
   AddXDAp(CorXObject, XDocApr.XDocId, XDocApr.Sum);
   NEXT(XDocApr);
  END; (* WHILE OCCURE(XDocApr) ... *)
 END {PrepareOneXApport};

 PRIVATE PROCEDURE PrepareOneXObject();
 BEGIN
  APP.Get().NewPrompt("");
  PROMPT(L_XObj.GetXObjectOriginName());
  SELECT(XApport, XObject, , XObject.XObject);
  WHILE OCCURE(XApport) DO
   NARROWSEL(XApport, AcCut);
   SRCINSEL(XApport, GE, , From);
   WHILE OCCURE(XApport) & (XApport.XDat<=UpTo) DO
    CONFORM(XApport, Apport);
    AddXDAp("", "", XApport.Sum);
    PrepareOneXApport(1);
    PrepareOneXApport(0);
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
   NEXTINEXTENDEDSEL(XApport, AcCut);
  END; (* WHILE OCCURE(XApport) ... *)
 END {PrepareOneXObject};

 PRIVATE PROCEDURE PrintRep();
  VAR
   First    : SCAL[2];
   _AcCut,
   _AcCut2  : LIKE(AcCut.AcCut);
   CorXOName: STRING[];
 BEGIN
  APP.Get().NewPrompt("");
  OPENREP(R, L_General.NameConnection(RepName), Create);

  SELECT(_XDAp, _XDAp);
  WHILE OCCURE(_XDAp) DO
   MAKEPART(R, Top, P_Firm.MyFirmName(_XDAp.MyFirm, UpTo), Title);
   NARROWSEL(_XDAp, MyFirm);
   WHILE OCCURE(_XDAp) DO
    NARROWSEL(_XDAp, XOName, XObject);
    L_XObj.AccessXObject(_XDAp.XObject);
    IF ~!XOName THEN
     MAKEPART(R, ObjTop);
    END;
    MAKEPART(R, XAppTop);
    WHILE OCCURE(_XDAp) DO
     PROMPT(_XDAp.AcCut+" "+_XDAp.AcCut2);
     NARROWSEL(_XDAp, AcCut, AcCut2);
     SRCINSEL(_XDAp, EQ, , "", "");
     MAKEPART(R, XAppLine);
     NEXTINEXTENDEDSEL(_XDAp, AcCut, AcCut2);
    END; (* WHILE OCCURE(_XDAp) ... *)
    First:=1;
    FIRST(_XDAp);
    WHILE OCCURE(_XDAp) DO
     PROMPT(_XDAp.AcCut+" "+_XDAp.AcCut2);
     _AcCut :=_XDAp.AcCut;
     _AcCut2:=_XDAp.AcCut2;
     NARROWSEL(_XDAp, AcCut, AcCut2);
     WHILE OCCURE(_XDAp) DO
      NARROWSEL(_XDAp, CorXObj);
      IF ~!_XDAp.CorXObj THEN
       L_XObj.AccessXObject(_XDAp.CorXObj);
       CorXOName:=L_XObj.GetXObjectOriginName();
       WHILE OCCURE(_XDAp) DO
        IF First THEN
         MAKEPART(R, XDApTop);
         First:=0;
        END;
        MAKEPART(R, XDApLine, _AcCut, _AcCut2, CorXOName);
        SETEMPTY(_AcCut, _AcCut2, CorXOName);
        NEXT(_XDAp);
       END; (* WHILE OCCURE(_XDAp) ... *)
      END;
      NEXTINEXTENDEDSEL(_XDAp, CorXObj);
     END; (* WHILE OCCURE(_XDAp) ... *)
     NEXTINEXTENDEDSEL(_XDAp, AcCut, AcCut2);
    END; (* WHILE OCCURE(_XDAp) ... *)
    NEXTINEXTENDEDSEL(_XDAp, XOName, XObject);
   END; (* WHILE OCCURE(_XDAp) ... *)
   MAKEPART(R, Bot);
   NEXTINEXTENDEDSEL(_XDAp, MyFirm);
  END; (* WHILE OCCURE(_XDAp) ... *)
  CLOSEREP(R);
 END {PrintRep};

 PUBLIC PROCEDURE MakeRep(_Origin: L_XObj.tOrigin);
 BEGIN
  APP.Get().NewPrompt("("+RepName+")");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AFM.MakeMultipleIndex("_XDAp", "MyFirm : LIKE(MyFirm.MyFirm);"+
                                   "XOName : STRING[128];"+
                                   "XObject: LIKE(XObject.XObject);"+
                                   "AcCut  : LIKE(AcCut.AcCut);"+
                                   "AcCut2 : LIKE(AcCut2.AcCut2);"+
                                   "CorXObj: LIKE(XObject.XObject);"+
                                   "XDocId : LIKE(XDocApr.XDocId);"+
                                   "Dbt    : LIKE(XDocApr.Sum);"+
                                   "Crd    : LIKE(XDocApr.Sum)",
                             "_XDAp: MyFirm, XOName, XObject, AcCut, AcCut2, CorXObj, XDocId;"+
                             "XDocId: XDocId");
  L_General.SetIntvlByIntvl(From, UpTo);
  L_DatTim.CheckWMIntvl(From, UpTo);
  SETEMPTY(XOName);
  IF    (_Origin = L_XObj.o_Man) THEN
   L_XObj.PassManXCalcViewAcsPnt();
   L_General.Assert(ACCESS(Man), " । 䨧᪮ ");
   Title:=" "+Man.Man+" "+Man.Name;
   SETSEL(mfMan, Man, Man.Man);
   FOR_EACH mfMan DO
    SEARCH(XObject, XObject, , mfMan.XObject);
    PrepareOneXObject();
   END; (* FOR_EACH mfMan *)
  ELSIF _Origin = L_XObj.o_Contract THEN
   L_General.Assert(ACCESS(Contract), " । ");
   Title:=" "+Contract.Contract+" "+Contract.Name;
   CONFORM(Contract, XObject);
   PrepareOneXObject();
  ELSIF (_Origin = L_XObj.o_Math) |
        (_Origin = L_XObj.o_KeyAss) THEN
   IF    _Origin = L_XObj.o_Math THEN
    L_General.Assert(ACCESS(Math) & (Math.MathKind = L_MathR.mathk_Math), " । ");
    Title:=" "+Math.Math+" "+Math.Name;
   ELSIF _Origin = L_XObj.o_KeyAss THEN
    L_General.Assert(ACCESS(Math) & (Math.MathKind = L_MathR.mathk_KeyAs), " । ");
    Title:=" "+Math.Math+" "+Math.Name;
   ELSE
    L_General.ConsultToUs(0, "CN010.MakeRep: Error "+_Origin);
   END;
   SELECT(mItem, Math, , Math.Math);
   WHILE OCCURE(mItem) DO
    CONFORM(mItem, XObject);
    IF _Origin = L_XObj.o_Math THEN
     CONFORM(mItem, Storage);
     XOName:="  ࠭ "+Storage.Storage+" "+Storage.Name;
    END;
    SAVE(mItem);
    PrepareOneXObject();
    RESTORE(mItem);
    NEXT(mItem);
   END; (* WHILE OCCURE(mItem) ... *)
  ELSIF _Origin = L_XObj.o_CostItem THEN
   L_General.Assert(ACCESS(CostItem), " । ");
   Title:=" "+CostItem.CostItem+" "+CostItem.Name;
   CONFORM(CostItem, XObject);
   PrepareOneXObject();
  END;

  PrintRep();

  L_XDoc.sl_Init("ࢨ 㬥");
  SELECT(_XDAp, XDocId);
  WHILE OCCURE(_XDAp) DO
   NARROWSEL(_XDAp, XDocId);
   IF ~!_XDAp.XDocId THEN
    L_XDoc.sl_AddItem(_XDAp.XDocId, L_XDoc.extXDocStr(_XDAp.XDocId, L_XDoc.xdast_wStatus));
   END;
   NEXTINEXTENDEDSEL(_XDAp, XDocId);
  END; (* WHILE OCCURE(_XDAp) ... *)
  L_XDoc.sl_Done();
 END {MakeRep};

END.
