(*
%Copyright   (c) Polak IT
%Author      11.12.2007 18:15:09 POLAK\GAV
%Purpose
%Type        report
%Specific    SYS
%Modified    07.05.2013 17:33:05 POLAK\Bor
%Environment
*)

 IMPORT L_MDoc, L_DatTim, Memo, L_AFM, L_General, L_Basis, FIO, Math, L_bp, P_Firm,
        L_Acnt, L_XObj, L_MathR, L_AR;

 VAR
  wMF : SCAL[2];

 PRIVATE PROCEDURE CreateTmp();
 BEGIN
  CreateFILE(tmp);
  CreateFIELD(tmp, Math,     LIKE(Math.Math));
  CreateFIELD(tmp, MMode,    LIKE(MMode.MMode));
  CreateFIELD(tmp, MyFirm,   LIKE(MyFirm.MyFirm));
  CreateFIELD(tmp, OutQnt,   L_XObj.tQnt, , "0");
  CreateFIELD(tmp, Out1Qnt,  L_XObj.tQnt, , "0");
  CreateFIELD(tmp, Out2Qnt,  L_XObj.tQnt, , "0");
  CreateFIELD(tmp, Out3Qnt,  L_XObj.tQnt, , "0");
  CreateFIELD(tmp, FstPrice, L_XObj.tSum, , "0");
  CreateFIELD(tmp, LstPrice, L_XObj.tSum, , "0");
  CreateFIELD(tmp, FPDocStr, STRING[32]);
  CreateFIELD(tmp, LPDocStr, STRING[32]);
  CreateFIELD(tmp, InQnt,    L_XObj.tQnt, , "0");
  CreateFIELD(tmp, In1Sum,   L_XObj.tSum, , "0");
  CreateFIELD(tmp, In1Qnt,   L_XObj.tQnt, , "0");
  CreateFIELD(tmp, In2Sum,   L_XObj.tSum, , "0");
  CreateFIELD(tmp, In2Qnt,   L_XObj.tQnt, , "0");
  CreateFIELD(tmp, In3Sum,   L_XObj.tSum, , "0");
  CreateFIELD(tmp, In3Qnt,   L_XObj.tQnt, , "0");
  CreateINDEXandLINK(tmp, Math,   UNIQUE, Math,  Math,  USER, "", "", Math, MMode, MyFirm);
  CreateINDEXandLINK(tmp, MMode,  PLURAL, MMode, MMode, USER, "", "", MMode);
  CreateINDEXandLINK(tmp, MyFirm, PLURAL, MyFirm, MyFirm, USER, "", "", MyFirm, Math);
  SetVersionOfFILE(tmp, 1);

  CreateFILE(prc);
  CreateFIELD(prc, Math,     LIKE(Math.Math));
  CreateFIELD(prc, MMode,    LIKE(MMode.MMode));
  CreateFIELD(prc, Price,    L_XObj.tSum);
  CreateINDEXandLINK(prc, Math, PLURAL, Math,  Math,  USER, "", "", Math, MMode);
  SetVersionOfFILE(prc, 0);

  L_AFM.CreateTemp("tmp");
  L_AFM.CreateTemp("prc");
 END {CreateTmp};

 PUBLIC PROCEDURE GetOutSaldo_ByAcCut(trgMath   : LIKE(Math.Math);
                                      trgMyFirm : LIKE(MyFirm.MyFirm);
                                      trgAcCut  : LIKE(AcCut.AcCut);
                                      P         : DATE;
                                      VAR resSum: L_XObj.tSum;
                                      VAR resQnt: L_XObj.tQnt);
  VAR
   curSum: L_XObj.tSum;
   curQnt: L_XObj.tQnt;
 BEGIN
  SETZERO(resSum, resQnt);
  SELECT(mItem, Math, , trgMath);
  WHILE OCCURE(mItem) DO
   IF mItem.MyFirm = trgMyFirm THEN
    SETSEL(XCalc, XObject, mItem.XObject, trgAcCut);
    IF SRCINSEL(XCalc, LE, P) THEN
     L_XObj.OutSaldo(curSum, curQnt);
     INC(resSum, curSum);
     INC(resQnt, curQnt);
    END;
   END;
   NEXT(mItem);
  END; (* WHILE OCCURE(mItem) ... *)
 END {GetOutSaldo_ByAcCut};

 PRIVATE PROCEDURE MakeOneMath(From, UpTo: DATE);
  VAR
   BegOfLast1Month,
   BegOfLast2Month,
   BegOfLast3Month: DATE;
   Cir0,
   Cir2,
   Price: NUMERIC[2];
 BEGIN
  APP.Get().NewPrompt(" "+Math.Math);
  BegOfLast1Month:=L_DatTim.MonthBeg(UpTo);
  BegOfLast2Month:=L_DatTim.IncMonth(BegOfLast1Month, -1);
  BegOfLast3Month:=L_DatTim.IncMonth(BegOfLast2Month, -1);
  SETSEL(MDocList, Math, Math.Math);
  SRCINSEL(MDocList, GE, , From);
  WHILE OCCURE(MDocList) & (MDocList.Date <= UpTo) DO
   PROMPT(L_DatTim.DateStr(MDocList.Date));
   CONFORM(MDocList, MDoc);
   IF OCCURE(MDoc) THEN

    CONFORM(MDoc, MDocKind);
    IF (MDoc.Status = L_MDoc.st_Passed) & MDocKind.Activity THEN
     IF    (L_MDoc.getMDocListMathFlowType() = L_MDoc.mdd_Outgoing) THEN
      ADD(tmp, Math, , MDocList.Math, MDocList.MMode, MDoc.MyFirm);
      INC(tmp.OutQnt, L_MDoc.GetMDocListCir2());
      IF (MDocList.Date >= BegOfLast1Month) THEN
       INC(tmp.Out1Qnt, L_MDoc.GetMDocListCir2());
      ELSIF (MDocList.Date >= BegOfLast2Month) THEN
       INC(tmp.Out2Qnt, L_MDoc.GetMDocListCir2());
      ELSIF (MDocList.Date >= BegOfLast3Month) THEN
       INC(tmp.Out3Qnt, L_MDoc.GetMDocListCir2());
      END;
      REPLACE(tmp);
     ELSIF L_MDoc.IsExternalMDocKind() & (MDocList.Sum > 0) &
           (L_MDoc.getMDocListMathFlowType() = L_MDoc.mdd_Ingoing) THEN
      ADD(tmp, Math, , MDocList.Math, MDocList.MMode, MDoc.MyFirm);
      SETZERO(Cir0, Cir2);
      SAVE(MDocList);
      SELECT(MDocList, MDLMath, , MDocList.MDocKind, MDocList.MDoc, MDocList.Math, MDocList.MMode);
      WHILE OCCURE(MDocList) DO
       INC(Cir0, MDocList.Sum);
       INC(Cir2, L_MDoc.GetMDocListCir2());
       NEXT(MDocList);
      END; (* WHILE OCCURE(MDocList) ... *)
      RESTORE(MDocList);
      IF Cir2 # 0 THEN
       Price:=Math.Max(0.01, Cir0 / Cir2);
      ELSE
       Price:=0;
      END;
      IF Price > 0 THEN
       prc.Math :=MDocList.Math;
       prc.MMode:=MDocList.MMode;
       prc.Price:=Price;
       INSERT(prc);
      END;
      IF tmp.FstPrice = 0 THEN
       tmp.FstPrice:=Price;
       tmp.FPDocStr:=L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + " " + L_DatTim.DateStr(MDoc.Date);
      END;
      tmp.LstPrice:=Price;
      tmp.LPDocStr:=L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + " " + L_DatTim.DateStr(MDoc.Date);
      Cir0:=MDocList.Sum;
      Cir2:=L_MDoc.GetMDocListCir2();
      INC(tmp.InQnt, Cir2);
      IF (MDocList.Date >= BegOfLast1Month) THEN
       INC(tmp.In1Qnt, Cir2);
       INC(tmp.In1Sum, Cir0);
      ELSIF (MDocList.Date >= BegOfLast2Month) THEN
       INC(tmp.In2Qnt, Cir2);
       INC(tmp.In2Sum, Cir0);
      ELSIF (MDocList.Date >= BegOfLast3Month) THEN
       INC(tmp.In3Qnt, Cir2);
       INC(tmp.In3Sum, Cir0);
      END;
      REPLACE(tmp);
     END;
    END;
   ELSE
    L_General.ConsultToUs(~L_AR.DatabaseIsTransparent(), "MakeOneMath.㯭  MDoc");
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
 END {MakeOneMath};

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "⮢⥫");
  L_Basis.wb_WrInQM(F, "⮢⥫");
  L_Basis.wb_WrInQM(F, "⠫");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "楢");
  L_Basis.wb_WrInQM(F, "室");
  L_Basis.wb_WrInQM(F, "⮪");
  L_Basis.wb_WrInQM(F, "⮪㬬");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⮪");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室3፠");
  L_Basis.wb_WrInQM(F, "室2፠");
  L_Basis.wb_WrInQM(F, "室1፠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "3፠");
  L_Basis.wb_WrInQM(F, "2፠");
  L_Basis.wb_WrInQM(F, "1፠");
  L_Basis.wb_WrInQM(F, "室3፠");
  L_Basis.wb_WrInQM(F, "室2፠");
  L_Basis.wb_WrInQM(F, "室1፠");
  L_Basis.wb_WrInQM(F, "⭮襭돮᫥ࢮ");
  L_Basis.wb_WrInQM(F, "㬥돥ࢮ᫥㯪");
  L_Basis.wb_WrInQM(F, "ᯥ㯮喥");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE _Divide(a, b: FLOAT): FLOAT;
 BEGIN
  IF ~!a & ~!b & (b # 0) THEN
   RETURN a / b;
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {_Divide};

 PRIVATE PROCEDURE _Multiply(a, b: FLOAT): FLOAT;
 BEGIN
  IF ~!a & ~!b THEN
   RETURN a*b;
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {_Multiply};

 PRIVATE PROCEDURE AcCutForMMode(D          : DATE;
                                 trgMathType: LIKE(MathType.MathType);
                                 trgMMode   : LIKE(MMode.MMode)): LIKE(AcCut.AcCut);
  VAR
   Result: LIKE(AcCut.AcCut);
 BEGIN
  SETEMPTY(Result);
  TRY
   Result:=L_Acnt.GetSpecificAcCutForMTMM(D, trgMathType, trgMMode, L_Acnt.acp_Math_Netto);
  EXCEPT
  ON Exc: Exc_Raise DO

  END;
  RETURN Result;
 END {AcCutForMMode};

 PRIVATE PROCEDURE MakeLine(F: STRING[]; From, UpTo: DATE; HasMove: SCAL[2]);
  VAR
   Cnt,
   months  : NUMERIC[0];
   _AcCut  : LIKE(AcCut.AcCut);
   rstSum  : L_XObj.tSum;
   rstQnt  : L_XObj.tQnt;
   AveCrd,
   Price   : NUMERIC[6];
   Disprs  : FLOAT;
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  CONFORM(Math, MUnit);
  CONFORM(Math, Vendor);
  CONFORM(Math, CarUnit);
  CONFORM(Math, MathType);
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrScl(F, MathType.MathType);
  L_Basis.wb_WrStr(F, MathType.Name);
  L_Basis.wb_WrScl(F, CarUnit.CarUnit);
  L_Basis.wb_WrStr(F, CarUnit.Name);
  L_Basis.wb_WrScl(F, Vendor.Vendor);
  L_Basis.wb_WrStr(F, Vendor.Name);
  L_Basis.wb_WrStr(F, Math.UnitedC);
  L_Basis.wb_WrScl(F, MMode.MMode);
  L_Basis.wb_WrStr(F, MMode.Sign);
  L_Basis.wb_WrStr(F, MUnit.Sign);
  IF HasMove THEN
   L_Basis.wb_WrNum(F, tmp.OutQnt, 2);
   L_Basis.wb_WrNum(F, tmp.InQnt, 2);
   months:=L_DatTim.CompleteMonthsInIntvl(L_DatTim.MonthBeg(Math.Max(Math.Begin, From)), UpTo);
   L_Basis.wb_WrNum(F, months, 0);
   AveCrd:=_Divide(tmp.OutQnt, months);
   L_Basis.wb_WrNum(F, AveCrd, 3);
  ELSE
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 0);
   L_Basis.wb_WrNum(F, 0, 3);
  END;
  _AcCut:=AcCutForMMode(UpTo, Math.MathType, MMode.MMode);
  IF ~!_AcCut THEN
   GetOutSaldo_ByAcCut(Math.Math, MyFirm.MyFirm, _AcCut, UpTo, rstSum, rstQnt);
   IF rstQnt > 0 THEN
    Price:=rstSum / rstQnt;
   ELSE
    SEARCH(AcCut, AcCut, , _AcCut);
    Price:=L_MathR.GetANYMathPrice(UpTo + 1, Math.Math, MyFirm.MyFirm, AcCut.PriceGrp);
   END;
  ELSE
   SETZERO(rstSum, rstQnt, Price);
  END;
  L_Basis.wb_WrNum(F, rstQnt, 2);
  L_Basis.wb_WrNum(F, rstSum, 2);
  L_Basis.wb_WrNum(F, Price, 2);

  IF HasMove THEN
   L_Basis.wb_WrNum(F, _Divide(rstQnt, _Divide(tmp.OutQnt, months)), 3);
   L_Basis.wb_WrNum(F, _Multiply(Price, AveCrd), 2);
   L_Basis.wb_WrNum(F, tmp.In3Qnt, 2);
   L_Basis.wb_WrNum(F, tmp.In2Qnt, 2);
   L_Basis.wb_WrNum(F, tmp.In1Qnt, 2);
 
   _AcCut:=AcCutForMMode(L_DatTim.IncMonth(L_DatTim.Per(UpTo), -12), Math.MathType, MMode.MMode);
   IF ~!_AcCut THEN
    GetOutSaldo_ByAcCut(Math.Math, MyFirm.MyFirm, _AcCut, L_DatTim.IncMonth(UpTo + 1, -12), rstSum, rstQnt);
    IF rstQnt > 0 THEN
     Price:=rstSum / rstQnt;
    ELSE
     SEARCH(AcCut, AcCut, , _AcCut);
     Price:=L_MathR.GetANYMathPrice(L_DatTim.IncMonth(UpTo + 1, -12), Math.Math, MyFirm.MyFirm, AcCut.PriceGrp);
    END;
   ELSE
    SETZERO(Price);
   END;
   L_Basis.wb_WrNum(F, Price, 2);
   L_Basis.wb_WrNum(F, _Divide(tmp.In3Sum, tmp.In3Qnt), 2);
   L_Basis.wb_WrNum(F, _Divide(tmp.In2Sum, tmp.In2Qnt), 2);
   L_Basis.wb_WrNum(F, _Divide(tmp.In1Sum, tmp.In1Qnt), 2);
   L_Basis.wb_WrNum(F, tmp.Out3Qnt, 2);
   L_Basis.wb_WrNum(F, tmp.Out2Qnt, 2);
   L_Basis.wb_WrNum(F, tmp.Out1Qnt, 2);
   L_Basis.wb_WrNum(F, _Divide(tmp.LstPrice, tmp.FstPrice), 2);
   L_Basis.wb_WrStr(F, tmp.FPDocStr + " - " + tmp.LPDocStr);
 
   Cnt:=0;
   Price:=0;
   SELECT(prc, Math, , tmp.Math, tmp.MMode);
   WHILE OCCURE(prc) DO
    INC(Cnt);
    INC(Price, prc.Price);
    NEXT(prc);
   END; (* WHILE OCCURE(prc) ... *)
   IF Cnt > 0 THEN
    Price :=Price / Cnt;
    Disprs:=0;
    FIRST(prc);
    WHILE OCCURE(prc) DO
     INC(Disprs, Math.Pow(prc.Price - Price, 2));
     NEXT(prc);
    END; (* WHILE OCCURE(prc) ... *)
    Disprs:=Disprs / Cnt;
   ELSE
    SETEMPTY(Disprs);
   END;
   L_Basis.wb_WrNum(F, Disprs, 3);
  ELSE
   L_Basis.wb_WrNum(F, 0, 3);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrNum(F, 0, 2);
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrNum(F, 0, 3);
  END;
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PRIVATE PROCEDURE MakeBySelect(RepName: STRING[]);
 BEGIN
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  CreateTmp();
  WHILE OCCURE(Math) DO
   IF Math.Leaf THEN
    MakeOneMath(Memo.ud_fr(), Memo.ud_ut());
   END;
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)

  FIO.Open(F, L_General.NameConnection(RepName), "REP", Create);
  MakeTop("F");
  FIRST(Math);
  WHILE OCCURE(Math) DO
   PROMPT(".  " + Math.Math);
   IF Math.Leaf & L_DatTim.IsActive_Inc(Memo.ud_ut(), Math.Begin, Math.Till) THEN
    L_MathR.CountUpMath(Math.Math, Memo.ud_ut());
    SELECT(MyFirm, MyFirm);
    WHILE OCCURE(MyFirm) DO
     IF (MyFirm.MyFirm # P_Firm.mf_Fict) & L_DatTim.IsActive(Memo.ud_ut(), MyFirm.Begin, MyFirm.Till) THEN
      IF SELECT(tmp, MyFirm, MyFirm.MyFirm, Math.Math) THEN
       WHILE OCCURE(tmp) DO
        CONFORM(tmp, MMode);
        MakeLine("F", Memo.ud_fr(), Memo.ud_ut(), 1);
        NEXT(tmp);
       END; (* WHILE OCCURE(tmp) ... *)
      ELSE
       SELECT(MMode, MMode);
       WHILE OCCURE(MMode) DO
        IF ~!AcCutForMMode(Memo.ud_ut(), Math.MathType, MMode.MMode) THEN
         MakeLine("F", Memo.ud_fr(), Memo.ud_ut(), 0);
        END;
        NEXT(MMode);
       END; (* WHILE OCCURE(MMode) ... *)
      END;
     END; (* IF (MyFirm.MyFirm ... *)
     NEXT(MyFirm);
    END; (* WHILE OCCURE(MyFirm) ... *)
   END; (* IF Math.Leaf & ... *)
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)
  FIO.Close(F);

  L_AFM.AF_PurgeTemp("tmp");
  L_AFM.AF_PurgeTemp("prc");
 END {MakeBySelect};

 PUBLIC PROCEDURE CnsMA_byMath();
  CONST
   RepName = "CnsMA";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Math), " ⠭ ");
  APP.Get().NewPrompt("("+RepName+")  "+Math.Math);
  SELECT(Math, Math, , Math.Math);
  MakeBySelect(RepName);
  FIRST(Math);
  L_Basis.ExtPlayMakedRunTimeRep(RepName, "Math_" + Math.Math, L_General.tc_inIntvl,
                                 " ।筮 室   " + Math.Math + " " + Math.Name, 0);
 END {CnsMA_byMath};

 PUBLIC PROCEDURE CnsMA_byMathType();
  CONST
   RepName = "CnsMA";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(MathType), " ⠭  ");
  APP.Get().NewPrompt("("+RepName+")   "+MathType.MathType);
  SAVE(MathType);
  SELECT(Math, MathType, , MathType.MathType);
  MakeBySelect(RepName);
  RESTORE(MathType);
  L_Basis.ExtPlayMakedRunTimeRep(RepName, "MathType_" + MathType.MathType, L_General.tc_inIntvl,
                                 " ।筮 室    " + MathType.MathType + " " + MathType.Name, 0);
 END {CnsMA_byMathType};

 PUBLIC PROCEDURE CnsMA();
  CONST
   RepName = "CnsMA";
 BEGIN
  L_bp.Begin(RepName, " ।筮 室 ", L_bp.t_Basis, L_General.tc_inIntvl);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  SELECT(Math, LeafMK, , 1, L_MathR.mathk_Math);
  MakeBySelect(RepName);
  L_bp.End();
 END {CnsMA};

END.