(*
%Copyright   (c) Polak IT
%Author      25.09.2013 12:15:54 POLAK\Bor
%Purpose      ஢
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    25.09.2013 18:47:56 POLAK\Bor
%Environment
*)

 MODULE CNT01 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_Cntr, L_Str, L_Basis, L_bp, P_Cntr, FIO;

 PRIVATE PROCEDURE MakeHeader(R: STRING[]);
 BEGIN
  L_Basis.wb_WrStr(R, "");
  L_Basis.wb_WrStr(R, "");
  L_Basis.wb_WrStr(R, " ");
  L_Basis.wb_WrStr(R, "");
  L_Basis.wb_WrStr(R, "儠");
  L_Basis.wb_WrStr(R, "");
  L_Basis.wb_WrStr(R, "");
  L_Basis.wb_WrStr(R, "ப ⢨ ");
  L_Basis.wb_WrStr(R, "ப ⢨ ");
  L_Basis.wb_WrStr(R, "  砭 ப ⢨");
  L_Basis.wb_WrStr(R, "ப ਮ᪮ ॠ樨 ");
  L_Basis.wb_WrStr(R, "ப ਮ᪮ ॠ樨 ");
  L_Basis.wb_WrStr(R, "  砭 ப ਮ᪮ ॠ樨");
  L_Basis.wb_WrStr(R, "㬬");
  L_Basis.wb_WrStr(R, "ࠢ");
  L_Basis.wb_WrStr(R, " ");
  L_Basis.wb_WrStr(R, "易 ");
  L_Basis.wb_WrStr(R, " ࠊ");
  L_Basis.wb_WrStr(R, " ");
  L_Basis.wb_WrStr(R, "࣠");
  L_Basis.wb_WrStr(R, "࣠");

  L_Basis.wb_TermLine(R);
 END {exl_MakeHeader};

 PRIVATE PROCEDURE MakeLine(R: STRING[]; D: DATE);
  CONST
   DaysToEmptyTill = 99999;
  VAR
   CntrSum : STRING[];
   durBegin,
   durTill : DATE;
 BEGIN
  L_Basis.wb_WrScl(R, Contract.Contract);
  L_Basis.wb_WrStr(R, Contract.Name);
  L_Basis.wb_WrDat(R, Contract.Date);
  L_Basis.wb_WrStr(R, Contract.SrcNbr);
  L_Basis.wb_WrDat(R, Contract.SrcDate);
  L_Basis.wb_WrDat(R, Contract.Begin);
  L_Basis.wb_WrDat(R, Contract.Till);

  P_Cntr.GetContractDuration(Contract.Contract, D, durBegin, durTill);
  L_Basis.wb_WrDat(R, durBegin);
  L_Basis.wb_WrDat(R, durTill);
  IF ~!durTill THEN
   L_Basis.wb_WrNum(R, durTill-D, 0);
  ELSE
   L_Basis.wb_WrNum(R, DaysToEmptyTill, 0);
  END;

  P_Cntr.GetPeriodicAcptDuration(Contract.Contract, D, durBegin, durTill);
  L_Basis.wb_WrDat(R, durBegin);
  L_Basis.wb_WrDat(R, durTill);
  IF ~!durTill THEN
   L_Basis.wb_WrNum(R, durTill-D, 0);
  ELSE
   L_Basis.wb_WrNum(R, DaysToEmptyTill, 0);
  END;

  CntrSum:=P_Cntr.GetCntrProSoft(Contract.Contract, Contract.Date, P_Cntr.P_Sum);
  IF ~!CntrSum THEN
   L_Basis.wb_WrNum(R,  STRTOFLD(CntrSum, NUMERIC), 2);
  ELSE
   L_Basis.wb_WrNum(R,  0, 2);
  END;
  L_Basis.wb_WrStr(R, L_Cntr.GetContractType_asStr());
  L_Basis.wb_WrStr(R, L_Str.PoolItem(P_Cntr.ctbt_Pool, P_Cntr.GetBalanceType(Contract.Contract, D)));
  L_Basis.wb_WrStr(R, L_Str.PoolItem("|", P_Cntr.GetPayOblg(Contract.Contract, D)));
  L_Basis.wb_WrScl(R, CntrT.CntrT);
  L_Basis.wb_WrStr(R, CntrT.Name);
  L_Basis.wb_WrScl(R, Firm.Firm);
  L_Basis.wb_WrStr(R, Firm.Name);

  L_Basis.wb_TermLine(R);
 END {MakeLine};


 PUBLIC PROCEDURE CNT01();
  CONST
   bpId = "CNT01";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, ", , ॡ騥 ", L_bp.t_Basis, L_General.tc_onDate);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);

  MakeHeader("R");
  SELECT(Contract, Leaf, , 1);
  WHILE OCCURE(Contract) DO
   PROMPT(" " + Contract.Contract);
   IF L_DatTim.IsActive(Memo.ud_cd(), Contract.Begin, Contract.Till) THEN
    IF P_Cntr.HasActualPro(Contract.Contract, Memo.ud_cd(), P_Cntr.P_Duration) |
       P_Cntr.HasActualPro(Contract.Contract, Memo.ud_cd(), P_Cntr.P_PeriodicAcptDuration) THEN
     CONFORM(Contract, Firm);
     CONFORM(Contract, CntrT);
 
     MakeLine("R", Memo.ud_cd());
    END;
   END;
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)


  FIO.Close(R);
  L_bp.End();
 END {CNT01};

END.