(*
%Copyright   (c) Polak IT
%Author      24.12.2013 19:54:41 POLAK\Bor
%Purpose
%Type        report
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    05.08.2014 14:33:00 POLAK\Bor
%Environment
*)

 MODULE Cnt02 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo,L_General, L_DatTim, L_Excel, L_AFM, L_Str, L_XObj, L_Acnt, L_Cntr, L_AcCut,
        P_Firm, P_Cntr, L_OwnData, Str;

 PRIVATE PROCEDURE Cnt02_ExcelTop(objWS: OBJECT);
  CONST
   Width = 13;
  VAR
   CurRange: OBJECT;
 BEGIN
  APP.Get().NewPrompt("ଫ ...");
  objWS.Cells.EntireColumn.NumberFormat:="@";
  objWS.Cells.EntireColumn.HorizontalAlignment:=L_Excel.xlCenter;
  objWS.Cells.EntireColumn.WrapText    :=L_Excel.xlTrue;

  L_Excel.ws_Init(objWS);
  L_Excel.ws_WrStr(objWS, L_OwnData.ODFirmName(SYSDATE()));
  L_Excel.ws_SkipCols(objWS, Width-2);
  L_Excel.ws_WrStr(objWS, L_DatTim.CompleteSystimeStr());
  L_Excel.ws_TermLine(objWS);

  objWS.Range(objWS.Cells(1), objWS.Cells(7)).HorizontalAlignment:=L_Excel.xlCenter;
  objWS.Cells( 3).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Cells( 8).HorizontalAlignment:=L_Excel.xlRight;
  objWS.Cells( 9).HorizontalAlignment:=L_Excel.xlRight;
  objWS.Cells(10).HorizontalAlignment:=L_Excel.xlRight;
  objWS.Cells(1, 1).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Rows(1).WrapText               :=L_Excel.xlFalse;

  CurRange:=objWS.Range(objWS.Cells(2, 1), objWS.Cells(2, Width));
  CurRange.MergeCells:=L_Excel.xlTrue;
  CurRange.WrapText  :=L_Excel.xlTrue;
  CurRange.Value     :="ᯮ ஢  "+L_DatTim.PeriodStr(Memo.ud_mb());

  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_StartHeader(objWS);
  L_Excel.ws_AddHeaderItem(objWS, " /", 4, 0);
  L_Excel.ws_AddHeaderItem(objWS, "   祭 ", 15, 0);
  L_Excel.ws_AddHeaderItem(objWS, "ࠣ   ( 㪠  )", 30, 0);
  L_Excel.ws_AddHeaderItem(objWS, " ", 15, 0);
  L_Excel.ws_AddHeaderItem(objWS, "। ", 20, 0);
  L_Excel.ws_AddHeaderItem(objWS, "ப ⢨ ", 10, 0);
  L_Excel.ws_AddHeaderItem(objWS, "冷 ⮢", 20, 0);
  L_Excel.ws_AddHeaderItem(objWS, "稥 ॠ쭮 ", 10, 2);
  L_Excel.ws_AddHeaderItem(objWS, "⭮襭  䨫", 10, 2);
  L_Excel.ws_AddHeaderItem(objWS, "  ⮬", 10, 0);
  L_Excel.ws_AddHeaderItem(objWS, "  (. .)", 15, 0);
  L_Excel.ws_AddHeaderItem(objWS, "㬬 䠪᪮   ", 15, 0);
  L_Excel.ws_AddHeaderItem(objWS, "ᯮ 易⥫ ஭ ", 15, 0);
  L_Excel.ws_AddHeaderItem(objWS, "稥 ⥭ ࠡ", 15, 0);
  L_Excel.ws_StopHeader(objWS);

  objWS.Range(objWS.Cells(1), objWS.Cells(8)).HorizontalAlignment:=L_Excel.xlCenter;
  objWS.Cells( 3).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Cells( 9).HorizontalAlignment:=L_Excel.xlRight;
  objWS.Cells(10).HorizontalAlignment:=L_Excel.xlRight;
  objWS.Cells(11).HorizontalAlignment:=L_Excel.xlRight;
  objWS.Cells(1, 1).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Rows(1).WrapText               :=L_Excel.xlFalse;
  objWS.Columns(1).WrapText            :=L_Excel.xlFalse;

 END {Cnt02_ExcelTop};

 PRIVATE PROCEDURE Cnt02_ExcelLine(objWS: OBJECT; D: DATE; i: NUMERIC[0]);
  VAR
   TSN        : LIKE(Staff.TSN);
   DocType,
   DocSer,
   DocNum,
   DocGiveS   : STRING[];
   dmyBegin,
   Till,
   DocGiveD,
   DocExpD    : DATE;
   CntrSum    : NUMERIC[2];
   curBal     : L_XObj.tSum[2];
   balAcCut   : LIKE(AcCut.AcCut);
   tmpNum     : NUMERIC[0];
 BEGIN
  SEARCH(Contract, Contract, , Cnt02.Contract);
  L_Excel.ws_WrNum(objWS, i);
  L_Excel.ws_WrScl(objWS, Contract.SrcNbr+" "+L_DatTim.DateStr(Contract.SrcDate));
  IF ~!P_Firm.GetFirmProSoft(Contract.Firm, D, P_Firm.P_INN) THEN
   L_Excel.ws_WrStr(objWS, P_Firm.FP_ContractorBriefName(Contract.Firm, D)+ " ( "+P_Firm.FP_INN(Contract.Firm, D)+")");
  ELSE
   L_Excel.ws_WrStr(objWS, P_Firm.FP_ContractorBriefName(Contract.Firm, D));
  END;
  L_Excel.ws_WrStr(objWS, L_Str.PoolItem(L_Cntr.ct_Pool, Contract.Type));
  L_Excel.ws_WrStr(objWS, P_Cntr.ppi_DescriptionOfGoods(Contract.Contract, D));
  P_Cntr.GetContractDuration(Contract.Contract, D, dmyBegin, Till);
  L_Excel.ws_WrDat(objWS, Till);
  L_Excel.ws_WrStr(objWS, L_Str.PoolItem(P_Cntr.ctbt_Pool, P_Cntr.GetBalanceType(Contract.Contract, D)));
  L_Excel.ws_WrStr(objWS, L_Str.PoolItem(P_Cntr.GetPool(P_Cntr.P_ExistanceReal), P_Cntr.GetReal(Contract.Contract, D)));
  L_Excel.ws_WrStr(objWS, L_Str.PoolItem(P_Cntr.GetPool(P_Cntr.P_InHouse), P_Cntr.GetInHouse(Contract.Contract, D)));
  L_Excel.ws_WrStr(objWS, L_Str.PoolItem("|", L_Cntr.IsBudgetContract(Contract.Contract, D)));
  P_Cntr.Get_FullOwnAgentInfo(Contract.Contract, Math.Max(Contract.SrcDate, Contract.Begin),
                              TSN, DocType, DocSer, DocNum, DocGiveS, DocGiveD, DocExpD, CntrSum);
  IF ~!CntrSum THEN
   tmpNum:=CntrSum/1000;
  ELSE
   tmpNum:=EMPTYOF(NUMERIC[0]);
  END;
  L_Excel.ws_WrNum(objWS, tmpNum);

  balAcCut:=L_AcCut.erkn_Get(SYSDATE(), L_AcCut.erkn_OnlineBalance);

  SETZERO(curBal);
  SELECT(XApport, WFD, , Contract.XObject, balAcCut);
  WHILE OCCURE(XApport) & (XApport.WFDate <= D) DO
   CONFORM(XApport, Apport);
   INC(curBal[Apport.CirType], XApport.Sum);
   NEXT(XApport);
  END; (* WHILE OCCURE(XApport) ... *)

  IF Contract.Type = L_Cntr.ct_Sell THEN
   tmpNum:=curBal[L_Acnt.ct_Credit]/1000; L_Excel.ws_WrNum(objWS, tmpNum);
   tmpNum:=curBal[L_Acnt.ct_Debit]/1000; L_Excel.ws_WrNum(objWS, tmpNum);
  ELSE
   tmpNum:=curBal[L_Acnt.ct_Debit]/1000; L_Excel.ws_WrNum(objWS, tmpNum);
   tmpNum:=curBal[L_Acnt.ct_Credit]/1000; L_Excel.ws_WrNum(objWS, tmpNum);
  END;
  L_Excel.ws_TermLine(objWS);
 END {Cnt02_ExcelLine};

 PRIVATE PROCEDURE Cnt02_ExcelBot(objWS: OBJECT);
 BEGIN
  L_Excel.ws_PaintGrid(objWS, L_Excel.xlThin, 1);
 END {Cnt02_ExcelBot};

 PRIVATE PROCEDURE Cnt02_MakeIndex();
 BEGIN
  APP.Get().NewPrompt("");
  L_AFM.MakeIndex("Cnt02", "SrcDate: DATE;"+
                           "Contract: LIKE(Contract.Contract)");
  SELECT(Contract, Leaf, , 1);
  WHILE OCCURE(Contract) DO
   PROMPT(" "+Contract.Contract);
   IF L_DatTim.IsActiveInIntvl(Memo.ud_mb(), Memo.ud_me(), Contract.Begin, Contract.Till) THEN
    ADD(Cnt02, Cnt02, , Contract.SrcDate, Contract.Contract);
   END;
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
 END {Cnt02_MakeIndex};

 PRIVATE PROCEDURE Cnt02_MakeExcel(objWB: OBJECT);
  VAR
   objWS: OBJECT;
   i    : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("");
  objWS:=L_Excel.NewWorksheet(objWB, 0, "ᯮ ஢");
  Cnt02_ExcelTop(objWS);

  i:=1;
  SELECT(Cnt02, Cnt02);
  WHILE OCCURE(Cnt02) DO
   PROMPT(L_DatTim.DateStr(Cnt02.SrcDate)+"  "+Cnt02.Contract);
   Cnt02_ExcelLine(objWS, Memo.ud_me(), i);
   INC(i);
   NEXT(Cnt02);
  END; (* WHILE OCCURE(Cnt02) ... *)

  Cnt02_ExcelBot(objWS);
 END {Cnt02_MakeExcel};

 PUBLIC PROCEDURE Cnt02();
  CONST
   RepName = "Cnt02";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt("("+RepName+")");
  Cnt02_MakeIndex();
  L_Excel.MakeRep(PROCREF(Cnt02_MakeExcel), RepName);
 END {Cnt02};


(* ---------------- Cnt03 ----------------- *)
 PRIVATE PROCEDURE Cnt03_ExcelTop(objWS: OBJECT);
  CONST
   Width = 7;
  VAR
   CurRange: OBJECT;
 BEGIN
  APP.Get().NewPrompt("ଫ ...");
  objWS.Cells.EntireColumn.NumberFormat:="@";
  objWS.Cells.EntireColumn.HorizontalAlignment:=L_Excel.xlCenter;
  objWS.Cells.EntireColumn.WrapText    :=L_Excel.xlTrue;

  L_Excel.ws_Init(objWS);
  L_Excel.ws_WrStr(objWS, L_OwnData.ODFirmName(SYSDATE()));
  L_Excel.ws_SkipCols(objWS, Width-2);
  L_Excel.ws_WrStr(objWS, L_DatTim.CompleteSystimeStr());
  L_Excel.ws_TermLine(objWS);


  CurRange:=objWS.Range(objWS.Cells(2, 1), objWS.Cells(2, Width));
  CurRange.MergeCells:=L_Excel.xlTrue;
  CurRange.WrapText  :=L_Excel.xlTrue;
  CurRange.Value     :=" 室 易⥫  "+L_Str.IntStr(L_DatTim.YEAR(Memo.ud_mb()));

  objWS.Columns( 1).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Columns( 2).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Columns( 3).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Columns( 6).HorizontalAlignment:=L_Excel.xlRight;
  objWS.Columns( 7).HorizontalAlignment:=L_Excel.xlLeft;

  objWS.Cells(1,     1).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Cells(1, Width).HorizontalAlignment:=L_Excel.xlRight;
  objWS.Rows(1).WrapText               :=L_Excel.xlFalse;
  objWS.Columns(1).WrapText               :=L_Excel.xlFalse;

  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);

  objWS.Rows(4).WrapText:=L_Excel.xlFalse;
  objWS.Rows(5).WrapText:=L_Excel.xlFalse;
  objWS.Rows(6).WrapText:=L_Excel.xlFalse;
  L_Excel.ws_StartHeader(objWS);
  L_Excel.ws_AddHeaderItem(objWS, " ", 25, 0);
  L_Excel.ws_AddHeaderItem(objWS, " ࠣ", 30, 0);

  L_Excel.ws_AddHeaderItem(objWS, " ", 35, 0);

  L_Excel.ws_AddHeaderSubItem(objWS);
  L_Excel.ws_AddHeaderItem(objWS, "   祭 ", 15, 0);
  L_Excel.ws_AddHeaderItem(objWS, "ப ⢨ ", 20, 0);

  L_Excel.ws_AddHeaderSubItem(objWS);
  L_Excel.ws_AddHeaderItem(objWS, "砫",    10, 0);
  L_Excel.ws_AddHeaderItem(objWS, "砭", 10, 0);
  L_Excel.ws_HeaderReturnFromSubItem(objWS);

  L_Excel.ws_HeaderReturnFromSubItem(objWS);

  L_Excel.ws_AddHeaderItem(objWS, "㬬 易⥫  , ᥣ, ..", 15, 0);
  L_Excel.ws_AddHeaderItem(objWS, "᭮  ਭ 室 易⥫⢠ (।ᠭ, ७, ଠ⨢ 㬥  .)", 15, 0);
  L_Excel.ws_StopHeader(objWS);
  objWS.Rows(4).WrapText:=L_Excel.xlTrue;
  objWS.Rows(5).WrapText:=L_Excel.xlTrue;
  objWS.Rows(6).WrapText:=L_Excel.xlTrue;

 END {Cnt03_ExcelTop};

 PRIVATE PROCEDURE Cnt03_ExcelLine(objWS: OBJECT; D: DATE);
  VAR
   TSN        : LIKE(Staff.TSN);
   DocType,
   DocSer,
   DocNum,
   DocGiveS,
   DocStr     : STRING[];
   Begin,
   Till,
   DocGiveD,
   DocExpD    : DATE;
   CntrSum    : NUMERIC[2];
   curBal     : L_XObj.tSum[2];
   balAcCut   : LIKE(AcCut.AcCut);
   tmpNum     : NUMERIC[0];
 BEGIN
  SEARCH(Contract, Contract, , Cnt03.Contract);
  L_Excel.ws_WrStr(objWS, Contract.Name);
  L_Excel.ws_WrStr(objWS, P_Firm.FP_ContractorBriefName(Contract.Firm, D));
  L_Excel.ws_WrScl(objWS, Contract.SrcNbr+" "+L_DatTim.DateStr(Contract.SrcDate));
  P_Cntr.GetContractDuration(Contract.Contract, D, Begin, Till);
  L_Excel.ws_WrDat(objWS, Begin);
  L_Excel.ws_WrDat(objWS, Till);
  P_Cntr.Get_FullOwnAgentInfo(Contract.Contract, Math.Max(Contract.SrcDate, Contract.Begin),
                              TSN, DocType, DocSer, DocNum, DocGiveS, DocGiveD, DocExpD, CntrSum);
  IF ~!CntrSum THEN
   tmpNum:=CntrSum/1000;
  ELSE
   tmpNum:=EMPTYOF(NUMERIC[0]);
  END;
  L_Excel.ws_WrNum(objWS, tmpNum);
  DocStr:=Str.Condense(DocType+" "+DocSer+" "+DocNum);
  IF ~!DocGiveD THEN
   DocStr:=DocStr+"  "+L_DatTim.DateStr(DocGiveD);
  END;
  L_Excel.ws_WrStr(objWS, DocStr);

  L_Excel.ws_TermLine(objWS);
 END {Cnt03_ExcelLine};

 PRIVATE PROCEDURE Cnt03_ExcelBot(objWS: OBJECT);
 BEGIN
  L_Excel.ws_PaintGrid(objWS, L_Excel.xlThin, 1);
 END {Cnt03_ExcelBot};

 PRIVATE PROCEDURE Cnt03_MakeIndex();
 BEGIN
  APP.Get().NewPrompt("");
  L_AFM.MakeIndex("Cnt03", "Centralized: SCAL[3];"+
                           "SrcDate    : DATE;"+
                           "Contract   : LIKE(Contract.Contract)");
  SELECT(Contract, Type, , L_Cntr.ct_Prch);
  WHILE OCCURE(Contract) DO
   IF Contract.Leaf THEN
    PROMPT("ࠣ "+Contract.Firm+"  "+Contract.Contract);
    IF L_DatTim.IsActiveInIntvl(L_DatTim.YearBeg(Memo.ud_mb()), Memo.ud_me(), Contract.Begin, Contract.Till) &
      ~P_Cntr.GetInHouse(Contract.Contract, Memo.ud_me()) &
      ~L_Cntr.IsBudgetContract(Contract.Contract, Memo.ud_me()) THEN
     ADD(Cnt03, Cnt03, , 0(* 䨫஢ ᠬ   ஢*), Contract.SrcDate, Contract.Contract);
    END;
   END;
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
 END {Cnt03_MakeIndex};

 PRIVATE PROCEDURE Cnt03_MakeExcel(objWB: OBJECT);
  VAR
   objWS : OBJECT;
 BEGIN
  APP.Get().NewPrompt("");
  objWS:=L_Excel.NewWorksheet(objWB, 0, " 室 易⥫");
  Cnt03_ExcelTop(objWS);

  SELECT(Cnt03, Cnt03);
  WHILE OCCURE(Cnt03) DO
   PROMPT(L_DatTim.DateStr(Cnt03.SrcDate)+"  "+Cnt03.Contract);
   Cnt03_ExcelLine(objWS, Memo.ud_me());
   NEXT(Cnt03);
  END; (* WHILE OCCURE(Cnt03) ... *)

  Cnt03_ExcelBot(objWS);
 END {Cnt03_MakeExcel};

 PUBLIC PROCEDURE Cnt03();
  CONST
   RepName = "Cnt03";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt("("+RepName+")");

  Cnt03_MakeIndex();
  L_Excel.BuildRep(PROCREF(Cnt03_MakeExcel), "", RepName, 0, 0);
 END {Cnt03};


 PRIVATE PROCEDURE Cnt04_ExcelTop(objWS: OBJECT);
  CONST
   Width = 7;
  VAR
   CurRange: OBJECT;
 BEGIN
  APP.Get().NewPrompt("ଫ ...");
  objWS.Cells.EntireColumn.NumberFormat:="@";
  objWS.Cells.EntireColumn.HorizontalAlignment:=L_Excel.xlCenter;
  objWS.Cells.EntireColumn.WrapText    :=L_Excel.xlTrue;

  L_Excel.ws_Init(objWS);
  L_Excel.ws_WrStr(objWS, L_OwnData.ODFirmName(SYSDATE()));
  L_Excel.ws_SkipCols(objWS, Width-2);
  L_Excel.ws_WrStr(objWS, L_DatTim.CompleteSystimeStr());
  L_Excel.ws_TermLine(objWS);


  CurRange:=objWS.Range(objWS.Cells(2, 1), objWS.Cells(2, Width));
  CurRange.MergeCells:=L_Excel.xlTrue;
  CurRange.WrapText  :=L_Excel.xlTrue;
  CurRange.Value     :="ଠ  祭 ࠬ  ਮ  "+L_DatTim.PeriodStr(L_DatTim.YearBeg(Memo.ud_mb()))+"  "+L_DatTim.PeriodStr(Memo.ud_mb());

  objWS.Columns( 1).HorizontalAlignment:=L_Excel.xlRight;
  objWS.Columns( 2).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Columns( 3).HorizontalAlignment:=L_Excel.xlCenter;
  objWS.Columns( 4).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Columns( 5).HorizontalAlignment:=L_Excel.xlRight;
  objWS.Columns( 7).HorizontalAlignment:=L_Excel.xlLeft;

  objWS.Cells(1,     1).HorizontalAlignment:=L_Excel.xlLeft;
  objWS.Cells(1, Width).HorizontalAlignment:=L_Excel.xlRight;
  objWS.Rows(1).WrapText               :=L_Excel.xlFalse;
  objWS.Columns(1).WrapText               :=L_Excel.xlFalse;

  L_Excel.ws_TermLine(objWS);
  L_Excel.ws_TermLine(objWS);

  objWS.Rows(4).WrapText:=L_Excel.xlFalse;
  objWS.Rows(5).WrapText:=L_Excel.xlFalse;
  objWS.Rows(6).WrapText:=L_Excel.xlFalse;
  L_Excel.ws_StartHeader(objWS);
  L_Excel.ws_AddHeaderItem(objWS, " /", 4, 0);
  L_Excel.ws_AddHeaderItem(objWS, "   祭 ", 15, 0);
  L_Excel.ws_AddHeaderItem(objWS, "ப ⢨ ", 20, 0);

  L_Excel.ws_AddHeaderItem(objWS, "।  (   㯠 ⮢, ࠡ, 㣨)", 25, 0);

  L_Excel.ws_AddHeaderItem(objWS, " 㬬 , .", 15, 0);
  L_Excel.ws_AddHeaderItem(objWS, " 㯮筮 楤", 15, 0);
  L_Excel.ws_AddHeaderItem(objWS, "ਬ砭 (᫨ )", 50, 0);
  L_Excel.ws_StopHeader(objWS);
  objWS.Rows(4).WrapText:=L_Excel.xlTrue;
  objWS.Rows(5).WrapText:=L_Excel.xlTrue;
  objWS.Rows(6).WrapText:=L_Excel.xlTrue;

 END {Cnt04_ExcelTop};

 PRIVATE PROCEDURE Cnt04_ExcelLine(objWS: OBJECT; D: DATE; i: NUMERIC[0]);
  VAR
   TSN        : LIKE(Staff.TSN);
   DocType,
   DocSer,
   DocNum,
   DocGiveS,
   DocStr     : STRING[];
   Begin,
   Till,
   DocGiveD,
   DocExpD    : DATE;
   CntrSum    : NUMERIC[2];
   curBal     : L_XObj.tSum[2];
   balAcCut   : LIKE(AcCut.AcCut);
   tmpNum     : NUMERIC[0];
 BEGIN
  SEARCH(Contract, Contract, , Cnt04.Contract);
  L_Excel.ws_WrNum(objWS, i);
  L_Excel.ws_WrScl(objWS, Contract.SrcNbr+"  "+L_DatTim.DateStr(Contract.SrcDate));
  P_Cntr.GetContractDuration(Contract.Contract, D, Begin, Till);
  IF !Till THEN
   Till:=Contract.Till;
  END;
  L_Excel.ws_WrDat(objWS, Till);
  L_Excel.ws_WrStr(objWS, P_Cntr.ppi_DescriptionOfGoods(Contract.Contract, D));
  P_Cntr.Get_FullOwnAgentInfo(Contract.Contract, Math.Max(Contract.SrcDate, Contract.Begin),
                              TSN, DocType, DocSer, DocNum, DocGiveS, DocGiveD, DocExpD, CntrSum);
  IF ~!CntrSum THEN
   tmpNum:=CntrSum;
  ELSE
   tmpNum:=EMPTYOF(NUMERIC[0]);
  END;
  L_Excel.ws_WrNum(objWS, tmpNum);
  L_Excel.ws_WrStr(objWS, "");
  L_Excel.ws_WrStr(objWS, P_Firm.FP_ContractorBriefName(Contract.Firm, D));

  L_Excel.ws_TermLine(objWS);
 END {Cnt04_ExcelLine};

 PRIVATE PROCEDURE Cnt04_ExcelBot(objWS: OBJECT);
 BEGIN
  L_Excel.ws_PaintGrid(objWS, L_Excel.xlThin, 1);
 END {Cnt04_ExcelBot};

 PRIVATE PROCEDURE Cnt04_MakeIndex();
 BEGIN
  APP.Get().NewPrompt("");
  L_AFM.MakeIndex("Cnt04", "FirmName: STRING[100];"+
                           "SrcDate : DATE;"+
                           "Contract: LIKE(Contract.Contract)");
  SELECT(Contract, Type, , L_Cntr.ct_Prch);
  WHILE OCCURE(Contract) DO
   IF Contract.Leaf THEN
    PROMPT("ࠣ "+Contract.Firm+"  "+Contract.Contract);
    IF L_DatTim.IsActiveInIntvl(L_DatTim.YearBeg(Memo.ud_mb()), Memo.ud_me(), Contract.Begin, Contract.Till) &
      (Contract.SrcDate >= L_DatTim.YearBeg(Memo.ud_mb())) &
      ~P_Cntr.GetInHouse(Contract.Contract, Memo.ud_me()) &
      ~L_Cntr.IsBudgetContract(Contract.Contract, Memo.ud_me()) THEN
      CONFORM(Contract, Firm);
     ADD(Cnt04, Cnt04, , P_Firm.FP_ContractorBriefName(Contract.Firm, Memo.ud_me()), Contract.SrcDate, Contract.Contract);
    END;
   END;
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
 END {Cnt04_MakeIndex};

 PRIVATE PROCEDURE Cnt04_MakeExcel(objWB: OBJECT);
  VAR
   objWS: OBJECT;
   i    : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("");
  objWS:=L_Excel.NewWorksheet(objWB, 0, "ଠ  祭 ࠬ");
  Cnt04_ExcelTop(objWS);

  i:=1;
  SETSEL(Cnt04, Cnt04);
  FOR_EACH Cnt04 DO
   PROMPT(L_DatTim.DateStr(Cnt04.SrcDate)+"  "+Cnt04.Contract);
   Cnt04_ExcelLine(objWS, Memo.ud_me(), i);
   INC(i);
  END; (* FOR_EACH Cnt04 ... *)

  Cnt04_ExcelBot(objWS);
 END {Cnt04_MakeExcel};

 PUBLIC PROCEDURE Cnt04();
  CONST
   RepName = "Cnt04";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt("("+RepName+")");

  Cnt04_MakeIndex();
  L_Excel.BuildRep(PROCREF(Cnt04_MakeExcel), "", RepName, 0, 0);
 END {Cnt04};


END.