(*
%Copyright   (c) Polak IT
%Author      27.01.2006 12:53:06 POLAK\Bor
%Purpose     Excel,  ﭨ ⮢    砫 
%Type        report
%Specific    SYS
%Modified    04.01.2013 16:31:24 POLAK\LDA
%Environment
*)

 MODULE CnVAT [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Basis, L_DatTim, L_XDoc, L_Cntr, L_Pmnt, L_XObj, L_MDoc, L_AcCut, L_Str, L_AFM,
        P_Firm, P_Cntr, L_bp, FIO, Memo;

 PRIVATE CONST
  st_CntrBal   = 0;
  st_DocBal    = 1;
  st_ChargeOff = 2;
  st_Pool    = " | 㬥| ";
 PRIVATE TYPE
  tSaldoType = SCAL[3];

 PRIVATE VAR
  wMF: SCAL[2];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ࠊ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, " 㬥");
  L_Basis.wb_WrInQM(F, " ᠫ줮");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]; SaldoType: tSaldoType;
                                         basXDocId: L_XDoc.tXDocId;
                                         Total, Netto, VAT: L_XObj.tSum;
                                         Trouble: SCAL[2]);
 BEGIN
  IF wMF THEN
   CONFORM(Contract, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Firm.Firm);
  L_Basis.wb_WrStr(F, Firm.Name);
  L_Basis.wb_WrScl(F, Contract.Contract);
  L_Basis.wb_WrStr(F, Contract.Name);
  L_Basis.wb_WrStr(F, Contract.SrcNbr);
  L_Basis.wb_WrStr(F, L_Cntr.GetContractType_asStr());
  L_Basis.wb_WrScl(F, CntrT.CntrT);
  L_Basis.wb_WrStr(F, CntrT.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", Trouble));
  IF (SaldoType = st_DocBal) | (SaldoType = st_ChargeOff) THEN
   L_Basis.wb_WrStr(F, L_MDoc.MDocKindNick(MDoc.MDocKind, 1));
   L_Basis.wb_WrScl(F, MDoc.MDoc);
   L_Basis.wb_WrDat(F, MDoc.Date);
   L_Basis.wb_WrScl(F, Dest.Dest);
   L_Basis.wb_WrStr(F, Dest.Name);
   IF ~!basXDocId THEN
    L_Basis.wb_WrStr(F, L_XDoc.extXDocStr(basXDocId, L_XDoc.xdast_wDate));
   ELSE
    L_Basis.wb_WrStr(F, "---");
   END;
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem(st_Pool, SaldoType));
  L_Basis.wb_WrNum(F, Total, 2);
  L_Basis.wb_WrNum(F, Netto, 2);
  L_Basis.wb_WrNum(F, VAT, 2);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE GetSVATMDocBuilMode(): L_Pmnt.tVATMDocBuildMode;
  VAR
   BM,
   relBM: L_Pmnt.tVATMDocBuildMode;
 BEGIN
  FOR_EACH BM DO
   relBM:=L_Pmnt.vmdbm_GetRelatedBM(BM);
   IF ~!relBM & L_Pmnt.IsSpecifiedVATMDoc(relBM) THEN
    RETURN BM;
   END;
  END;
  RETURN "";
 END {GetSVATMDocBuilMode};

 PRIVATE PROCEDURE Create_SVAT();
 BEGIN
  CREATE_TABLE(_SVAT);

  CREATE_FIELD(_SVAT, Contract, LIKE(Contract.Contract), , , , "");
  CREATE_FIELD(_SVAT, MDocKind, LIKE(MDoc.MDocKind),     , , , " 㬥 ");
  CREATE_FIELD(_SVAT, MDoc,     LIKE(MDoc.MDoc),         , , , " 㬥 ");
  CREATE_FIELD(_SVAT, Balance,  L_Pmnt.tValuesToBalance, , , , "줮");

  CREATE_INDEX_AND_LINK(_SVAT, Contract, UNIQUE, Contract, Contract, USER, , , Contract, MDocKind, MDoc);
  CREATE_INDEX_AND_LINK(_SVAT, MDoc, PLURAL, MDoc, MDoc, USER, , , MDocKind, MDoc);
  SET_VERSION_OF_TABLE(_SVAT, 0);
 END {Create_SVAT};

 PRIVATE PROCEDURE MakeOneMDoc(VAR docValue: L_Pmnt.tValuesToBalance);
  VAR
   trgBM   : L_Pmnt.tVATMDocBuildMode;
   trgValue: L_Pmnt.tValuesToBalance;
 BEGIN
  IF MDoc.Date < Memo.ud_mb() THEN
   trgBM:=GetSVATMDocBuilMode();
   IF ~!trgBM THEN
    trgValue:=L_Pmnt.GetUncoveredMDocAcpt(L_Pmnt.E_GetVATMDocMDocKind(MDoc.Date, trgBM), L_Pmnt.E_GetVATMDocDest(MDoc.Date, trgBM));
    IF (trgValue[L_Pmnt.vtb_Total] # 0) | (trgValue[L_Pmnt.vtb_Netto] # 0) | (trgValue[L_Pmnt.vtb_VAT] # 0) THEN
     ADD(_SVAT, Contract, , MDoc.Contract, MDoc.MDocKind, MDoc.MDoc,
                            _SVAT.Balance[L_Pmnt.vtb_Total], trgValue[L_Pmnt.vtb_Total],
                            _SVAT.Balance[L_Pmnt.vtb_Netto], trgValue[L_Pmnt.vtb_Netto],
                            _SVAT.Balance[L_Pmnt.vtb_VAT],   trgValue[L_Pmnt.vtb_VAT]);
     INC(docValue[L_Pmnt.vtb_Total], trgValue[L_Pmnt.vtb_Total]);
     INC(docValue[L_Pmnt.vtb_Netto], trgValue[L_Pmnt.vtb_Netto]);
     INC(docValue[L_Pmnt.vtb_VAT],   trgValue[L_Pmnt.vtb_VAT]);
    END;
   END;
  END;
 END {MakeOneMDoc};

 PRIVATE PROCEDURE MakeOneMDocKind(_MDocKind: LIKE(MDocKind.MDocKind); VAR docValue: L_Pmnt.tValuesToBalance);
 BEGIN
  SELECT(MDoc, CntrClsd, , Contract.Contract, _MDocKind, EMPTYOF(MDoc.Closed));
  WHILE OCCURE(MDoc) DO
   PROMPT(Contract.Contract+": "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   MakeOneMDoc(docValue);
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {MakeOneMDocKind};

 PRIVATE PROCEDURE Calc_VATPrc(VAR ChOffVAT, TotVAT: L_XObj.tSum);
  VAR
   P: DATE;
 BEGIN
  P:=L_DatTim.IncMonth(Memo.ud_mb(), -1);
  L_XObj.AccessXObject(Contract.XObject);
  ChOffVAT:=0;
  INC(ChOffVAT, L_XObj.mo_GetOutRSaldo(L_AcCut.erkn_GetSoft(P, L_AcCut.erkn_BoughtKeyAssVAT   ), P));
  INC(ChOffVAT, L_XObj.mo_GetOutRSaldo(L_AcCut.erkn_GetSoft(P, L_AcCut.erkn_BoughtInventoryVAT), P));
  INC(ChOffVAT, L_XObj.mo_GetOutRSaldo(L_AcCut.erkn_GetSoft(P, L_AcCut.erkn_BoughtGoodsVAT    ), P));
  TotVAT:=ChOffVAT;
  INC(TotVAT,   L_XObj.mo_GetOutRSaldo(L_AcCut.erkn_GetSoft(P, L_AcCut.erkn_BoughtVATInCost   ), P));
 END {Calc_VATPrc};

 PRIVATE PROCEDURE Inv(N: L_XObj.tSum): L_XObj.tSum; (*06.02.2006 21:42:02 POLAK\Bor . 0048961*)
 BEGIN
  IF N # 0 THEN
   RETURN -N;
  ELSE
   RETURN N;
  END;
 END {Inv};

 PRIVATE PROCEDURE MakeOneContract();
  VAR
   ChOffValue,
   docValue,
   trgValue  : L_Pmnt.tValuesToBalance;
   ChOffVAT,
   TotVAT,
   RemVAT,
   MaxVAT    : L_XObj.tSum;
   basXDocId,
   MaxDocId  : L_XDoc.tXDocId;
   HasSVAT,
   NeedOut,
   Trouble   : SCAL[2];
 BEGIN
  CONFORM(Contract, Firm);
  CONFORM(Contract, CntrT);
  Calc_VATPrc(ChOffVAT, TotVAT);
  RemVAT:=ChOffVAT;

  SETEMPTY(MaxDocId);
  MaxVAT:=0;

  SETZERO(docValue);
  MakeOneMDocKind(L_MDoc.md_DPk, docValue);
  MakeOneMDocKind(L_MDoc.md_DPr, docValue);

  trgValue:=L_Pmnt.GetContractBalance(Contract.Contract, Memo.ud_mb(), L_XDoc.max_DoneDTS, L_XDoc.max_DoneDTS);

  HasSVAT:=SELECT(_SVAT, Contract, Contract.Contract);
  IF CntrT.Type = L_Cntr.ct_Prch THEN
   NeedOut:=~P_Cntr.GetInHouse(Contract.Contract, Memo.ud_mb()) &
            (trgValue[L_Pmnt.vtb_Total] < 0);
   Trouble:=(Inv(docValue[L_Pmnt.vtb_Total]) # trgValue[L_Pmnt.vtb_Total]) |
            (Inv(docValue[L_Pmnt.vtb_Netto]) # trgValue[L_Pmnt.vtb_Netto]) |
            (Inv(docValue[L_Pmnt.vtb_VAT])   # trgValue[L_Pmnt.vtb_VAT])   |
            (~NeedOut & HasSVAT);
  ELSE
   NeedOut:=1;
   Trouble:=0;
  END;
  WHILE OCCURE(_SVAT) DO
   IF TotVAT # 0 THEN
    ChOffValue[L_Pmnt.vtb_Netto]:=_SVAT.Balance[L_Pmnt.vtb_Netto]*ChOffVAT/TotVAT;
    ChOffValue[L_Pmnt.vtb_VAT]  :=_SVAT.Balance[L_Pmnt.vtb_VAT]  *ChOffVAT/TotVAT;
    ChOffValue[L_Pmnt.vtb_Total]:=ChOffValue[L_Pmnt.vtb_Netto]+ChOffValue[L_Pmnt.vtb_VAT];
   ELSE
    SETZERO(ChOffValue);
   END;
   DEC(RemVAT, ChOffValue[L_Pmnt.vtb_VAT]);
   CONFORM(_SVAT, MDoc);
   CONFORM(MDoc, Dest);
   basXDocId:=L_XDoc.GetBaseOnXDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
   MakePart("R", st_DocBal, basXDocId,
                 _SVAT.Balance[L_Pmnt.vtb_Total], _SVAT.Balance[L_Pmnt.vtb_Netto], _SVAT.Balance[L_Pmnt.vtb_VAT], Trouble);
   MakePart("R", st_ChargeOff, basXDocId,
                 ChOffValue[L_Pmnt.vtb_Total], ChOffValue[L_Pmnt.vtb_Netto], ChOffValue[L_Pmnt.vtb_VAT], Trouble);
   IF (MaxVAT < _SVAT.Balance[L_Pmnt.vtb_VAT]) | !MaxDocId THEN
    MaxVAT  :=_SVAT.Balance[L_Pmnt.vtb_VAT];
    MaxDocId:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
   END;
   NEXT(_SVAT);
  END; (* WHILE OCCURE(_SVAT) ... *)

  IF HasSVAT | Trouble |
     (NeedOut & ((trgValue[L_Pmnt.vtb_Total] # 0) | (trgValue[L_Pmnt.vtb_Netto] # 0) | (trgValue[L_Pmnt.vtb_VAT] # 0))) THEN
   MakePart("R", st_CntrBal,   "---", trgValue[L_Pmnt.vtb_Total], trgValue[L_Pmnt.vtb_Netto], trgValue[L_Pmnt.vtb_VAT], Trouble);
  END;
  IF (RemVAT # 0) & ~!MaxDocId THEN
   L_XDoc.PositionOnXDoc(MaxDocId);
   MakePart("R", st_ChargeOff, L_XDoc.GetBaseOnXDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc)),
                 0, 0, RemVAT, Trouble);
  END;
 END {MakeOneContract};

 PUBLIC PROCEDURE CnVAT();
  CONST
   bpId = "CnVAT";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());

  L_bp.Begin(bpId, " ﭨ ⮢  ", L_bp.t_Basis, L_General.tc_onMonthBeg);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
 
  Create_SVAT(); L_AFM.AF_CreateTemp("_SVAT", "_SVAT");
  SELECT(Contract, Leaf, , 1);
  WHILE OCCURE(Contract) DO
   PROMPT(Contract.Contract);
   MakeOneContract();
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
  L_AFM.AF_PurgeTemp("_SVAT");
  FIO.Close(R);
  L_bp.End();
 END {CnVAT};

END.