(*
%Copyright   (c) Polak IT
%Author      23.07.2009 20:26:52 POLAK\Bor
%Purpose     ᮪ 易  ⥪騬 ꥪ⮢
%Type        report
%Specific    SYS
%Modified    30.09.2013 11:19:15 POLAK\Bor
%Environment
*)

 MODULE Concern [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_OwnData, L_AFM, L_XDoc, Math, Str;

 PRIVATE TYPE
  tCond = SCAL[3];

 PRIVATE CONST
  c_OnDate = 0;
  c_InPer  = 1;
  c_All    = 2;

 PRIVATE VAR
  RepName: STRING[];
  LocalFrom,
  LocalUpTo,
  GlobalFrom,
  GlobalUpTo: DATE;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
?, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|ꥪ                                                                                |         |        |
}
*)

(*
$P{ SubTop:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ Line:
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
@
|######################################################################################|##########|##########|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE Need(VAR DB, DE: DATE): SCAL[2];
 BEGIN
  DB:=Math.Max(LocalFrom, DB);
  DE:=Math.Min(LocalUpTo, DE);
  RETURN DE >= DB;
 END {Need};

 PRIVATE PROCEDURE Add(_XDocType: L_XDoc.tXDocType; DB, DE: DATE);
  VAR
   _XDocId: L_XDoc.tXDocId;
 BEGIN
  IF Need(DB, DE) THEN
   _XDocId:=L_XDoc.curXDocId(_XDocType);
   IF SEARCH(_CFls, XDocId, _XDocId, DB) THEN
    IF _CFls.DateE < DE THEN
     _CFls.DateE:=DE;
     REPLACE(_CFls);
    END;
   ELSE
    _CFls.XDocType:=_XDocType;
    _CFls.XDocId  :=_XDocId;
    _CFls.Date    :=DB;
    _CFls.DateE   :=DE;
    INSERT(_CFls);
   END;
  END;
 END {Add};

 PRIVATE PROCEDURE CostItem_To_Math();
 BEGIN
  APP.Get().NewPrompt("");
  SELECT(MathKAGL, CostItem, , CostItem.CostItem);
  WHILE OCCURE(MathKAGL) DO
   PROMPT(MathKAGL.Math);
   CONFORM(MathKAGL, Math);
   Add(L_XDoc.xdt_Math, MathKAGL.Date, MathKAGL.DateE);
   NEXT(MathKAGL);
  END; (* WHILE OCCURE(MathKAGL) ... *)
 END {CostItem_To_Math};

 PRIVATE PROCEDURE Math_To_CostItem();
 BEGIN
  APP.Get().NewPrompt("");
  SELECT(MathKAGL, Math, , Math.Math);
  WHILE OCCURE(MathKAGL) DO
   IF ~!MathKAGL.CostItem THEN
    PROMPT(MathKAGL.CostItem);
    CONFORM(MathKAGL, CostItem);
    Add(L_XDoc.xdt_CostItem, MathKAGL.Date, MathKAGL.DateE);
   END;
   NEXT(MathKAGL);
  END; (* WHILE OCCURE(MathKAGL) ... *)
 END {Math_To_CostItem};

 PRIVATE PROCEDURE CostItem_To_Route();
 BEGIN
  APP.Get().NewPrompt("");
  SELECT(RouteLog, CostItem, , CostItem.CostItem);
  WHILE OCCURE(RouteLog) DO
   PROMPT(RouteLog.Route);
   CONFORM(RouteLog, Route);
   Add(L_XDoc.xdt_Route, RouteLog.Date, L_DatTim.till2ED(RouteLog.Till));
   NEXT(RouteLog);
  END; (* WHILE OCCURE(RouteLog) ... *)
 END {CostItem_To_Route};

 PRIVATE PROCEDURE CostItem_To_Dfrls();
 BEGIN
  APP.Get().NewPrompt("ࠢ ᯨᠭ ");
  SELECT(Dfrls, CostItem, , CostItem.CostItem);
  WHILE OCCURE(Dfrls) DO
   PROMPT(Dfrls.Dfrls);
   Add(L_XDoc.xdt_Dfrls, Dfrls.BegDate, Dfrls.EndDate);
   NEXT(Dfrls);
  END; (* WHILE OCCURE(Dfrls) ... *)

  SELECT(DfrlsL, CostItem, , CostItem.CostItem);
  WHILE OCCURE(DfrlsL) DO
   PROMPT(DfrlsL.Dfrls);
   CONFORM(DfrlsL, Dfrls);
   Add(L_XDoc.xdt_Dfrls, Dfrls.BegDate, Dfrls.EndDate);
   NEXT(DfrlsL);
  END; (* WHILE OCCURE(DfrlsL) ... *)
 END {CostItem_To_Dfrls};

 PRIVATE PROCEDURE Math_To_Car();
 BEGIN
  APP.Get().NewPrompt("");
  SELECT(CarLog, Math, , Math.Math);
  WHILE OCCURE(CarLog) DO
   PROMPT(CarLog.BoxNbr);
   CONFORM(CarLog, Car);
   Add(L_XDoc.xdt_Car, CarLog.Date, CarLog.DateE);
   NEXT(CarLog);
  END; (* WHILE OCCURE(CarLog) ... *)
 END {Math_To_Car};

 PRIVATE PROCEDURE Car_To_Math();
 BEGIN
  APP.Get().NewPrompt("");
  SELECT(CarLog, BoxNbr, , Car.BoxNbr);
  WHILE OCCURE(CarLog) DO
   IF ~!CarLog.Math THEN
    PROMPT(CarLog.Math);
    CONFORM(CarLog, Math);
    Add(L_XDoc.xdt_Math, CarLog.Date, CarLog.DateE);
   END;
   NEXT(CarLog);
  END; (* WHILE OCCURE(CarLog) ... *)
 END {Car_To_Math};

 PRIVATE PROCEDURE CondenseCFls(_XDocType: L_XDoc.tXDocType);
  VAR
   _XDocId: L_XDoc.tXDocId;
   _DateE: DATE;
 BEGIN
  SETEMPTY(_XDocId);
  IF ~!_XDocType THEN
   SELECT(_CFls, XDocType, , _XDocType);
  ELSE
   SELECT(_CFls, XDocType);
  END;
  WHILE OCCURE(_CFls) DO
   IF _CFls.XDocId # _XDocId THEN
    _XDocId:=_CFls.XDocId;
    _DateE :=_CFls.DateE;
    NEXT(_CFls);
   ELSIF _DateE >= (_CFls.Date-1) THEN
    _DateE:=Math.Max(_DateE, _CFls.DateE);
    PREV(_CFls);
    _CFls.DateE:=_DateE;
    REPLACE(_CFls);
    NEXT(_CFls);
    REMOVE(_CFls);
   ELSE
    NEXT(_CFls);
   END;
  END; (* WHILE OCCURE(_CFls) ... *)
 END {CondenseCFls};

 PRIVATE PROCEDURE MakeByCFls(_XDocType: L_XDoc.tXDocType; Proc: PROC);
 BEGIN
  CondenseCFls(_XDocType);
  SELECT(_CFls, XDocType, , _XDocType);
  WHILE OCCURE(_CFls) DO
   LocalFrom:=Math.Max(GlobalFrom, _CFls.Date);
   LocalUpTo:=Math.Min(GlobalUpTo, _CFls.DateE);
   L_XDoc.PositionOnXDoc(_CFls.XDocId);
   SAVE(_CFls);
   Proc();
   RESTORE(_CFls);
   NEXT(_CFls);
  END; (* WHILE OCCURE(_CFls) ... *)
  LocalFrom:=GlobalFrom;
  LocalUpTo:=GlobalUpTo;
 END {MakeByCFls};

 PRIVATE PROCEDURE Init(_XDocType: L_XDoc.tXDocType; Cond: tCond);
  VAR
   RepTitle,
   CondName: STRING[];
   _XDocId: L_XDoc.tXDocId;
 BEGIN
  APP.Get().NewPrompt("");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  L_General.Assert(ACCESS(^(L_XDoc.Ref_FileName(_XDocType))), " । ⥪   '"+L_XDoc.Ref_FullName(_XDocType)+"'");
  _XDocId:=L_XDoc.curXDocId(_XDocType);

  IF    Cond = c_OnDate THEN
   GlobalFrom:=Memo.ud_cd();
   GlobalUpTo:=BD;
   RepName:="CFlsD";
   CondName:=" "+L_DatTim.DateStr(GlobalFrom);
  ELSIF Cond = c_InPer THEN
   GlobalFrom:=Memo.ud_fr();
   GlobalUpTo:=Memo.ud_ut();
   RepName:="CFlsP";
   CondName:=" ਮ  "+L_DatTim.DateStr(GlobalFrom)+"  "+L_DatTim.DateStr(GlobalUpTo);
  ELSIF Cond = c_All THEN
   GlobalFrom:=MINOF(DATE);
   SETEMPTY(GlobalUpTo);
   RepName:="CFlsA";
   CondName:="( )";
  END;

  L_AFM.MakeMultipleIndex("_CFls", "XDocType: " + TYPENAMEOF(L_XDoc.tXDocType) + ";" +
                                   "XDocId  : " + TYPENAMEOF(L_XDoc.tXDocId) + ";" +
                                   "Date    : DATE;" +
                                   "DateE   : DATE",
                          "XDocId  : XDocId, Date;" +
                          "XDocType: XDocType, XDocId, Date");
  LocalFrom:=GlobalFrom;
  LocalUpTo:=GlobalUpTo;

  RepTitle:="ꥪ, 易  "+L_XDoc.extXDocStr(_XDocId, L_XDoc.xdast_wStatus);

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepTitle, CondName);
  L_XDoc.sl_Init("ꥪ, 易   "+L_XDoc.XDocStr(_XDocId));
 END {Init};

 PRIVATE PROCEDURE PrintRep();
  VAR
   _XDocStr: STRING[];
 BEGIN
  APP.Get().NewPrompt("");

  CondenseCFls("");
  SELECT(_CFls, XDocType);
  WHILE OCCURE(_CFls) DO
   NARROWSEL(_CFls, XDocType);
   MAKEPART(R, SubTop, L_XDoc.Ref_FullName(_CFls.XDocType));
   WHILE OCCURE(_CFls) DO
    NARROWSEL(_CFls, XDocId);
    _XDocStr:=L_XDoc.extXDocStr(_CFls.XDocId, L_XDoc.xdast_wStatus);
    PROMPT(_XDocStr);
    L_XDoc.sl_AddItem(_CFls.XDocId, Str.Slice(_XDocStr, 0, 70));
    WHILE OCCURE(_CFls) DO
     MAKEPART(R, Line, _XDocStr, _CFls.Date, _CFls.DateE);
     NEXT(_CFls);
    END; (* WHILE OCCURE(_CFls) ... *)
    NEXTINEXTENDEDSEL(_CFls, XDocId);
   END; (* WHILE OCCURE(_CFls) ... *)
   NEXTINEXTENDEDSEL(_CFls, XDocType);
  END; (* WHILE OCCURE(_CFls) ... *)

  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {PrintRep};

 PRIVATE PROCEDURE Done();
 BEGIN
  PrintRep();
  L_AFM.AF_PurgeTemp("_CFls");
  SETEMPTY(GlobalFrom, GlobalUpTo, LocalFrom, LocalUpTo);
  L_XDoc.sl_Done();
 END {Done};

 PUBLIC PROCEDURE Concern();
  VAR
   CurFileName: STRING[];
 BEGIN
  CurFileName:=L_General.GetCurWinMasterTable();

  IF (RTI.Get().CurZone.Processes(0).Kind # FORM_PROCESS.Kind_View) &
     (RTI.Get().CurZone.Processes(0).Kind # FORM_PROCESS.Kind_ShowWin) THEN
   L_General.Error("ନ஢   ⮬ ⥪ 饭");
  END;

  IF    CurFileName = "CostItem" THEN
   Init(L_XDoc.xdt_CostItem, c_All);
   LOOP
    CostItem_To_Route();
    CostItem_To_Math();
    CostItem_To_Dfrls();
    MakeByCFls(L_XDoc.xdt_Math, PROCREF(Math_To_Car));
    IF ~!CostItem.Parent THEN
     SEARCH(CostItem, CostItem, , CostItem.Parent);
    ELSE
     EXIT;
    END;
   END;
  ELSIF CurFileName = "Car" THEN
   Init(L_XDoc.xdt_Car, c_All);
   Car_To_Math();
   MakeByCFls(L_XDoc.xdt_Math, PROCREF(Math_To_CostItem));
  ELSIF CurFileName = "Math" THEN
   Init(L_XDoc.xdt_Math, c_All);
   Math_To_Car();
   Math_To_CostItem();
  ELSE
   L_General.Error("  䠩 '"+TABLE.Get(CurFileName).Description+"'   ஥");
  END;
  Done();
 END {Concern};

END.
