(*
%Copyright   (c) Polak IT
%Author      05.12.2006 09:07:59 POLAK\San
%Purpose     䨪 ⠪⮢ ࠣ
%Type        control
%Specific    SYS
%Modified    19.09.2014 20:04:56 POLAK\Bor
%Environment
*)

 MODULE Contact [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_WDO, L_ctc, Str, L_Str, L_StdFrm, L_DatTim, P_Firm, L_r2r, L_DBD,
        Math, Shell, L_PDoc, L_Prop, L_Russia, L_Rpr, L_CUC, L_AFM, L_SysLog;

 PRIVATE TYPE
  tWindowMode = SCAL[3];
  tIdFirmCtc  = LIKE(FirmCtc.Id);

 PRIVATE CONST
  im_AddNewFirmCtc     = "AddNewFirmCtc";
  im_AddFirmCtcVersion = "AddFirmCtcVersion";
  env_curCtcAdr        = "curCtcAdr";

  wm_View        = 0;
  wm_Ask_Usual   = 1;
  wm_Ask_hParent = 2;

  w_FName    = 32;

  pool_CKT   = "㯯|ᮭ";

 PRIVATE PROCEDURE SetupContactWinFields(MainZone: NUMERIC[0]);
  VAR
   Zones : FORM_ZONES;
   Fields: FORM_FIELDS;
 BEGIN
  Zones:=RTI.Get().CurWindow.Zones;
  Fields:=Zones(MainZone).Fields;
  IF ~!Fields("Contact.Origin") THEN
   Fields("Contact.Origin").Format:=L_ctc.o_Pool;
  END;
  Fields:=Zones(MainZone + 1).Fields;
  Fields("CtcVal.Coverage").Format      :=L_ctc.cvc_Pool;
  Fields("CtcVal.Type").Format          :=L_ctc.cvt_Pool;
  IF ~!Zones(MainZone + 2) THEN
   Fields:=Zones(MainZone + 2).Fields;
   Fields("CtcAdr.Type").Format    :=L_ctc.cat_Pool;
   Fields("CtcAdr.PostKind").Format:=L_Russia.capk_PoolForWdo;
   Fields("v_Address").Expression:="CtcAdr.RegionN + ', ' + CtcAdr.Town + ', '" +
                                   "+ CtcAdr.Village + ', ' + CtcAdr.Street  + ', ' + CtcAdr.House   + ', '" +
                                   "+ CtcAdr.Block  + ', ' + CtcAdr.Build   + ', ' + CtcAdr.Flat";
  END;
 END {SetupContactWinFields};

 PRIVATE PROCEDURE Contact_1_OnZoneOpen();
 BEGIN
  SetupContactWinFields(1);
 END {Contact_1_OnZoneOpen};

 PRIVATE PROCEDURE GetFirmCtcWindowMode(): tWindowMode;
 BEGIN
  IF L_WDO.IsLoadableAskClone() THEN
   IF (RTI.Get().CurWindow.AskSourceField.Name = "FirmCtc.Parent") THEN
    RETURN wm_Ask_hParent;
   ELSE
    RETURN wm_Ask_Usual;
   END;
  ELSE
   RETURN wm_View;
  END;
 END {GetFirmCtcWindowMode};

 PRIVATE PROCEDURE FirmCtc_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Firm";
  L_WDO.iSubwindow   (1, "FirmCtcE");
  L_WDO.iZone        (1).HierarchicLink:=LINK.Get("FirmCtc", "Parent");
  L_WDO.iField       (1, "FirmCtc.Name").Hierarchic:=1;
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).Narrowing:="CtcVal.Contact=FirmCtc.Contact";
  L_WDO.iZone        (3).ViewOnly:=1;
  L_WDO.iZone        (3).Narrowing:="CtcAdr.Contact=FirmCtc.Contact";

  IF GetFirmCtcWindowMode() = wm_Ask_hParent THEN
   L_WDO.iZone        (1).PermanentFilter:="(FirmCtc.Leaf=0)";
  ELSE
   L_WDO.iZone        (1).OpenAllParentsInHierarchicView();
  END;
  SetupContactWinFields(1);
 END {FirmCtc_OnInitializeWindow};

 PRIVATE PROCEDURE FirmCtcE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Firm";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (0, ["FirmCtc.Parent", "FirmCtc.Begin", "FirmCtc.Contact", "FirmCtc.CtcKind"]);
  L_WDO.iUnmodifiable(0, ["FirmCtc.Id", "FirmCtc.FirmCtc"]);
  L_WDO.iMayBeEmpty  (0, ["FirmCtc.Parent", "FirmCtc.Comment", "FirmCtc.Till", "FirmCtc.Contact"]);
  L_WDO.iProgs       (0, "Contact");
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  L_WDO.iZone        (1).Narrowing:="CtcVal.Contact=FirmCtc.Contact";
  L_WDO.iField       (1, "CtcVal.Inherit").OnBeforeAsk:=1;
  L_WDO.iScsChange   (1, ["CtcVal.Type"]);
  L_WDO.iMayBeEmpty  (1, ["CtcVal.Comment", "CtcVal.Till"]);
  L_WDO.iProgs       (1, "Contact");
  L_WDO.iZone        (2).Narrowing:="CtcAdr.Contact=FirmCtc.Contact";
  L_WDO.iSubwindow   (2, "CtcAdrE");
  SetupContactWinFields(0);
 END {FirmCtcE_OnInitializeWindow};

 PRIVATE PROCEDURE FirmCtcHasParent():SCAL[2];
 BEGIN
  RETURN ~!FirmCtc.Parent;
 END {FirmCtcHasParent};

 PRIVATE PROCEDURE FirmCtc_Parent_OnSuccessfulChange();
  VAR
   trgId: LIKE(FirmCtc.Id);
 BEGIN
  SAVE(FirmCtc);
  IF ~!FirmCtc.Parent THEN
   SELECT(FirmCtc, Id, , FirmCtc.Firm, FirmCtc.Parent);
   L_General.Assert(~FirmCtc.Leaf, " ⠭  ⢥ ࠡ祩 㯯 ᮭ ⠪");
  END;
  RESTORE(FirmCtc);

  trgId:=FirmCtc.Id;
  SAVE(FirmCtc);
  WHILE ~!FirmCtc.Parent DO
   L_General.Assert(FirmCtc.Parent # trgId, " ⠭  ⢥ ࠡ祩 㯯  童");
   SEARCH(FirmCtc, Id, , FirmCtc.Firm, FirmCtc.Parent);
  END;
  RESTORE(FirmCtc);
 END {FirmCtc_Parent_OnSuccessfulChange};

 PRIVATE PROCEDURE ContactE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Firm";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (0, ["Contact.IsPerson"]);
  L_WDO.iUnmodifiable(0, ["IsPerson_asNameTitle", "Contact.Origin", "Contact.Contact"]);
  L_WDO.iMayBeEmpty  (0, ["Contact.FirmName", "Contact.Till"]);
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (1, ["CtcVal.Type"]);
  L_WDO.iMayBeEmpty  (1, ["CtcVal.Comment", "CtcVal.Till"]);
  L_WDO.iProgs       (1, "Contact");
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iSubwindow   (2, "CtcAdrE");
  SetupContactWinFields(0);
 END {ContactE_OnInitializeWindow};

 PRIVATE PROCEDURE CtcKind_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("CtcKind.Type").Format:=L_ctc.ckt_Pool;
 END {CtcKind_1_OnZoneOpen};

 PRIVATE PROCEDURE CtcKind_Type_OnSuccessfulChange();
 BEGIN
  SELECT(FirmCtc, CtcKind, , CtcKind.CtcKind);
  WHILE OCCURE(FirmCtc) DO
   FirmCtc.CKType:=CtcKind.Type;
   REPLACE(FirmCtc);
   NEXT(FirmCtc);
  END; (* WHILE OCCURE(FirmCtc) ... *)
 END {CtcKind_Type_OnSuccessfulChange};

 PRIVATE CONST
  ev_InsContactFromInsFirmCtc = "IsFromFirmCtc";
  ev_InsContactFromInsOfficer = "IsFromOfficer";

 PRIVATE PROCEDURE Contact_IsPerson_OnSuccessfulChange();
 BEGIN
  IF ~!GE_PVALUE() & ~GE_PVALUE() THEN
   SELECT(CtcVal, Contact, , Contact.Contact);
   WHILE OCCURE(CtcVal) DO
    IF CtcVal.Inherit = L_ctc.cvi_Inherit THEN
     CtcVal.Inherit:=L_ctc.cvi_NotInherit;
     REPLACE(CtcVal);
    END;
    NEXT(CtcVal);
   END; (* WHILE OCCURE(CtcVal) ... *)
  END;
 END {Contact_IsPerson_OnSuccessfulChange};

 PRIVATE PROCEDURE Contact_OnBeforeInsert();
  VAR
   pz    : FORM_ZONE;
   asf   : FORM_FIELD;
   Fields: FORM_FIELDS;
   origin: LIKE(Contact.Origin);
 BEGIN
  SETEMPTY(origin);
  pz:=RTI.Get().CurWindow.ParentZone;
  IF    ~!pz & ~!pz.Window.AskSourceField THEN
   asf:=pz.Window.AskSourceField;
   IF asf.Name = "FirmCtc.Contact" THEN
    TABLE.Get("FirmCtc").AccessDataMode:=adm_HOTTEST;
    GE_WZD_CURSOR(asf.Zone.Window.Name, asf.Zone.Number, FirmCtc);
    origin:=L_ctc.o_FirmCtc;
   ELSIF asf.Name = "Officer.Contact" THEN
    TABLE.Get("Officer").AccessDataMode:=adm_HOTTEST;
    GE_WZD_CURSOR(asf.Zone.Window.Name, asf.Zone.Number, Officer);
    origin:=L_ctc.o_Officer;
   END;
  ELSIF ~!L_WDO.AccessEnvVar(ev_InsContactFromInsFirmCtc) THEN
   ACCESS(FirmCtc);
   FirmCtc.Contact:=Contact.Contact;
   REPLACE(FirmCtc);
   origin:=L_ctc.o_FirmCtc;
  ELSIF ~!L_WDO.AccessEnvVar(ev_InsContactFromInsOfficer) THEN
   ACCESS(Officer);
   Officer.Contact:=Contact.Contact;
   REPLACE(Officer);
   origin:=L_ctc.o_Officer;
  END;
  IF    origin = L_ctc.o_FirmCtc THEN
   Contact.Begin:=FirmCtc.Begin;
   CONFORM(FirmCtc, Firm);
   Contact.FirmName:=Firm.Name;
   IF ~!FirmCtc.CtcKind THEN
    CONFORM(FirmCtc, CtcKind);
    Contact.IsPerson:=L_ctc.CtcTypeIsPerson(CtcKind.Type);
    IF ~Contact.IsPerson THEN
     Contact.Name:=CtcKind.DflName;
    END;
   END;
   Contact.Origin:=L_ctc.o_FirmCtc;
   REPLACE(Contact);
   FIXALTERING();
  ELSIF origin = L_ctc.o_Officer THEN
   IF ~!Officer.Post THEN
    CONFORM(Officer, Post);
    Contact.Name:=Post.Name;
   END;
   Contact.Begin   :=Officer.Begin;
   Contact.IsPerson:=0;
   Contact.Origin  :=L_ctc.o_Officer;
   REPLACE(Contact);
   FIXALTERING();
  ELSE
   L_StdFrm.Choice("  ନ '⠪',  㤥   祬  ᮮ⭥ᥭ?");
  END;
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Contact.Origin").Modifiable  :=0;
  Fields("Contact.IsPerson").Modifiable:=!Contact.IsPerson;
  Fields("Contact.Name").Modifiable    :=~L_ctc.IsDependentContact();
  Fields("Contact.FirmName").Modifiable:=!Contact.FirmName & (Contact.Origin # L_ctc.o_Officer);
 END {Contact_OnBeforeInsert};

 PRIVATE PROCEDURE Contact_OnBeforeEdit();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Contact.Origin").Modifiable  :=~!Contact.Origin;
  Fields("Contact.IsPerson").Modifiable:=~(L_ctc.IsDependentContact() | (Contact.Origin = L_ctc.o_Officer));
  Fields("Contact.Name").Modifiable    :=~L_ctc.IsDependentContact();
  Fields("Contact.FirmName").Modifiable:=~(L_ctc.IsDependentContact() | (Contact.Origin = L_ctc.o_Officer));
 END {Contact_OnBeforeEdit};

 PRIVATE PROCEDURE Contact_OnAfterEdit();
 BEGIN
  L_DBD.CheckValidity("Contact");
  L_ctc.SetupContactNames(0);
 END {Contact_OnAfterEdit};

 PRIVATE PROCEDURE Contact_OnAfterInsert();
 BEGIN
  L_ctc.SetupContactNames(0);
 END {Contact_OnAfterInsert};

 PRIVATE PROCEDURE Contact_OnBeforeDelete();
 BEGIN
 END {Contact_OnBeforeDelete};

 PRIVATE PROCEDURE IsAcceptableModifiableInherit(): SCAL[2];
 BEGIN
  CONFORM(CtcVal, Contact);
  RETURN ~Contact.IsPerson | (Contact.IsPerson & L_ctc.CtcValIswApplExtPhone());
 END {IsAcceptableModifiableInherit};

 PRIVATE PROCEDURE Set_Inherit_Modifiable();
 BEGIN
  RTI.Get().CurZone.Fields("CtcVal.Inherit").Modifiable:=IsAcceptableModifiableInherit();
 END {Set_Inherit_Modifiable};

 PRIVATE PROCEDURE Set_Inherit_Template();
  VAR
   Template: STRING[];
 BEGIN
  CONFORM(CtcVal, Contact);
  IF Contact.IsPerson THEN
   IF L_ctc.CtcValIswApplExtPhone() THEN
    Template:="-||";
   ELSE
    Template:="-";
   END;
  ELSE
   IF L_ctc.CtcValIswApplExtPhone() THEN
    Template:="-||";
   ELSE
    Template:="-|";
   END;
  END;
  RTI.Get().CurZone.Fields("CtcVal.Inherit").Template        :=Template;
  RTI.Get().CurZone.Fields("CtcVal.Inherit").TemplateIsStrict:=1;
 END {Set_Inherit_Template};

 PRIVATE PROCEDURE CtcVal_Inherit_OnBeforeAsk();
 BEGIN
  Set_Inherit_Template();
 END {CtcVal_Inherit_OnBeforeAsk};

 PRIVATE PROCEDURE CtcVal_Type_OnSuccessfulChange();
 BEGIN
  IF    ~!GE_PVALUE() &
        ((GE_PVALUE() = L_ctc.cvt_PhonePST) | (GE_PVALUE() = L_ctc.cvt_PhoneClr)) &
        (CtcVal.Inherit = L_ctc.cvi_wApplExt) THEN
   CtcVal.Inherit:=L_ctc.cvi_Inherit;
   REPLACE(CtcVal);
  ELSIF ~IsAcceptableModifiableInherit() THEN
   CtcVal.Inherit:=L_ctc.cvi_NotInherit;
   REPLACE(CtcVal);
  END;
  Set_Inherit_Modifiable();
  Set_Inherit_Template();
 END {CtcVal_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE CtcVal_OnBeforeEdIns();
 BEGIN
  Set_Inherit_Modifiable();
  Set_Inherit_Template();
 END {CtcVal_OnBeforeEdIns};

 PRIVATE PROCEDURE CtcVal_OnBeforeEdit();
 BEGIN
  CtcVal_OnBeforeEdIns();
 END {CtcVal_OnBeforeEdit};

 PRIVATE PROCEDURE CtcVal_OnBeforeInsert();
 BEGIN
  CONFORM(CtcVal, Contact);
  CtcVal.Begin:=Contact.Begin;
  REPLACE(CtcVal);
  CtcVal_OnBeforeEdIns();
 END {CtcVal_OnBeforeInsert};

 PRIVATE PROCEDURE CtcValTypesShouldNotBeDuplicated(Type1,
                                                    Type2    : LIKE(CtcVal.Type);
                                                    Contact1,
                                                    Contact2 : LIKE(Contact.Contact)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF Type1 = Type2 THEN
   IF Contact1 = Contact2 THEN
    Result:=1;
   ELSE
    IF ~((Type1 = L_ctc.cvt_PhoneLoc) | (Type1 = L_ctc.cvt_Extension)) THEN
     Result:=1;
    ELSE
    END;
   END;
  ELSE
   Result:=((Type1=L_ctc.cvt_PhonePST) & (Type2 = L_ctc.cvt_PhoneClr)) |
           ((Type2=L_ctc.cvt_PhonePST) & (Type1 = L_ctc.cvt_PhoneClr));
  END;
  RETURN Result;
 END {CtcValTypeShouldNotBeDuplicatedWithCurCtcValType};

 PRIVATE PROCEDURE CtcVal_OnAfterEdIns();
  VAR
  curContact : LIKE(CtcVal.Contact);
  curCtcVal  : LIKE(CtcVal.CtcVal);
  curType    : LIKE(CtcVal.Type);
  curBegin,
  curTill    : DATE;
  curValue   : LIKE(CtcVal.Value);
  Duplicate  : STRING[];
 BEGIN
  L_DBD.CheckValidity("CtcVal");
  IF (CtcVal.Type = L_ctc.cvt_PhonePST) |
     (CtcVal.Type = L_ctc.cvt_PhoneClr) |
     (CtcVal.Type = L_ctc.cvt_Fax) THEN
   L_ctc.CheckPhoneFormat(CtcVal.Value);
  ELSIF (CtcVal.Type = L_ctc.cvt_Email)  |
        (CtcVal.Type = L_ctc.cvt_SMSEml) THEN
   L_ctc.CheckEMailFormat(CtcVal.Value);
  END;
  L_ctc.SetCtcValInvValue();

  curContact:=CtcVal.Contact;
  curCtcVal :=CtcVal.CtcVal;
  curBegin  :=CtcVal.Begin;
  curTill   :=CtcVal.Till;
  curValue  :=CtcVal.Value;
  curType   :=CtcVal.Type;
  SETEMPTY(Duplicate);

  SAVE(CtcVal);
  IF ~!CtcVal.InvValue THEN
   SELECT(CtcVal, InvValue, , CtcVal.InvValue);
  ELSE
   SELECT(CtcVal, Value,    , CtcVal.Value);
  END;
  WHILE OCCURE(CtcVal) DO
   IF L_DatTim.IsActiveInIntvl(curBegin, curTill, CtcVal.Begin, CtcVal.Till) THEN
    CONFORM(CtcVal, Contact);
    IF ~((curContact = CtcVal.Contact) & (curCtcVal  = CtcVal.CtcVal)) & CtcValTypesShouldNotBeDuplicated(curType, CtcVal.Type, curContact, CtcVal.Contact) THEN
     Duplicate:=Duplicate + "|" + FLDTOSTR(CtcVal.Contact)          + " " +
                                  Str.Align(Contact.Name, 30, LEFT) + " " +
                                  L_Str.PoolItem(L_ctc.cvt_Pool, CtcVal.Type)  + " " +
                                  "(" + L_DatTim.DateStr(CtcVal.Begin) + "-" + L_DatTim.DateStr(CtcVal.Till) + ")";
    END;
   END;
   NEXT(CtcVal);
  END;
  IF ~!Duplicate THEN
   L_StdFrm.Choice("㡫஢ ⠪⭮ ଠ樨.|" +
                   "'" + curValue + "' 㦥   ⠪():" +
                   Duplicate);
  END;
  RESTORE(CtcVal);
 END {CtcVal_OnAfterEdIns};

 PRIVATE PROCEDURE CtcVal_OnAfterInsert();
 BEGIN
  CtcVal_OnAfterEdIns();
 END {CtcVal_OnAfterInsert};

 PRIVATE PROCEDURE CtcVal_OnAfterEdit();
 BEGIN
  CtcVal_OnAfterEdIns();
 END {CtcVal_OnAfterEdit};

 PRIVATE PROCEDURE CtcVal_OnBeforeDelete();
 BEGIN
  (* nothing - 0059285 *)
 END {CtcVal_OnBeforeDelete};

 PRIVATE PROCEDURE GetCheckDate(): DATE;
  VAR
   Result: DATE;
 BEGIN
  Result:=FirmCtc.Begin;
  IF ~P_Firm.HasActualFirmPro(FirmCtc.Firm, Result, P_Firm.P_RegName) THEN
   IF SELECT(FirmPro, Firm, FirmCtc.Firm, P_Firm.P_RegName) THEN
    Result:=FirmPro.Date;
   END;
  END;
  RETURN Result;
 END {GetCheckDate};

 PRIVATE PROCEDURE FirmCtcHasECKName(): SCAL[2];
 BEGIN
  L_General.Assert(~!FirmCtc.Begin, " 㪠  砫 ਮ ਬ ");
  RETURN L_ctc.CtcTypeIsPerson(FirmCtc.CKType) &
         ((FirmCtc.CKType # L_ctc.ckt_Leader) | ~P_Firm.ContractorIsPhysicalBody(FirmCtc.Firm, GetCheckDate()));
 END {FirmCtcHasECKName};

 PRIVATE PROCEDURE FirmCtc_OnBeforeInsert();
  VAR
   trgId   : tIdFirmCtc;
   _FirmCtc: LIKE(FirmCtc.FirmCtc);
   _CtcKind: LIKE(FirmCtc.CtcKind);
   _CKType : LIKE(FirmCtc.CKType);
   _ECKName: LIKE(FirmCtc.ECKName);
   _Comment: LIKE(FirmCtc.Comment);
   _Parent : LIKE(FirmCtc.Parent);
 BEGIN
  SAVE(FirmCtc);
  IF    ~!L_WDO.AccessEnvVar(im_AddNewFirmCtc) THEN
   SETEMPTY(_CtcKind, _CKType, _ECKName, _Comment);
   _Parent:=FirmCtc.Parent;
   IF CHANGESEL(FirmCtc, Firm, FirmCtc.Firm) & PREV(FirmCtc) THEN
    _FirmCtc:=FirmCtc.FirmCtc+1;
   ELSE
    _FirmCtc:=1;
   END;
  ELSE
   L_General.Assert(~!L_WDO.AccessEnvVar(im_AddFirmCtcVersion), "⨬ ᯮᮡ  ⠪. ᯮ F9");

   trgId:=STRTOFLD(L_WDO.AccessEnvVar(im_AddFirmCtcVersion).Value, SCAL);

   SELECT(FirmCtc, Id, , FirmCtc.Firm, trgId);
   _FirmCtc:=FirmCtc.FirmCtc;
   _CtcKind:=FirmCtc.CtcKind;
   _CKType :=FirmCtc.CKType;
   _ECKName:=FirmCtc.ECKName;
   _Comment:=FirmCtc.Comment;
   _Parent :=FirmCtc.Parent;
  END;
  RESTORE(FirmCtc);
  FirmCtc.Begin  :=SYSDATE();
  FirmCtc.FirmCtc:=_FirmCtc;
  FirmCtc.CtcKind:=_CtcKind;
  FirmCtc.CKType :=_CKType;
  FirmCtc.ECKName:=_ECKName;
  FirmCtc.Comment:=_Comment;
  FirmCtc.Parent :=_Parent;
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   REPLACE(FirmCtc);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF L_General.IsUniquenessViolationException(Exc) THEN
    SAVE(FirmCtc);
    SELECT(FirmCtc, Id, , FirmCtc.Firm, trgId);
    IF CHANGESEL(FirmCtc, Firm, FirmCtc.Firm) & PREV(FirmCtc) THEN
     _FirmCtc:=FirmCtc.FirmCtc+1;
    ELSE
     _FirmCtc:=1;
    END;
    RESTORE(FirmCtc);
    SETEMPTY(FirmCtc.Begin);
    FirmCtc.FirmCtc:=_FirmCtc;
    FirmCtc.Parent :=_Parent;
    REPLACE(FirmCtc);
   ELSE
    RAISE();
   END;
  END; (* TRY *)
  RTI.Get().CurZone.Fields("FirmCtc.ECKName").Modifiable:=~!FirmCtc.CKType & FirmCtcHasECKName();
 END {FirmCtc_OnBeforeInsert};

 PRIVATE PROCEDURE IsLastFirmCtc(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(FirmCtc);
  TRY
   TABLE.Get("FirmCtc").AccessDataMode:=adm_SOFT;
   CHANGESEL(FirmCtc, Firm, , FirmCtc.Firm, FirmCtc.FirmCtc);
   Result:=~NEXT(FirmCtc);
  EXCEPT
  END; (* TRY *)
  RESTORE(FirmCtc);
  RETURN Result;
 END {IsLastFirmCtc};

 PRIVATE PROCEDURE CheckFirmPDoc(Begin, Till: DATE);
 BEGIN
  SELECT(PDoc, Firm, , FirmCtc.Firm);
  WHILE OCCURE(PDoc) DO
   IF L_DatTim.IsActive(PDoc.Date, Begin, Till) & (PDoc.Status = L_PDoc.st_Passed) & PDoc.Done & L_PDoc.IsPDocwMDoc() THEN
    L_General.Error(" ࠡ⠭   ࠣ " + Firm.Firm +
                    "  " + L_DatTim.DateStr(Begin) + "  " + L_DatTim.DateStr(Till) +
                    "|ਬ, " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc) ... *)
 END {CheckFirmPDoc};

 PRIVATE PROCEDURE FirmCtc_OnBeforeEdit();
 BEGIN
  IF ~IsLastFirmCtc() THEN
   L_StdFrm.Question("  ᫥  ⠪ " + FirmCtc.FirmCtc);
  END;
  RTI.Get().CurZone.Fields("FirmCtc.Till").Modifiable   :=IsLastFirmCtc();
  RTI.Get().CurZone.Fields("FirmCtc.ECKName").Modifiable:=FirmCtcHasECKName();
 END {FirmCtc_OnBeforeEdit};

 PRIVATE PROCEDURE CopyChildren(srcId: tIdFirmCtc);
  VAR
   dstBegin: DATE;
   dstTill : DATE;
   dstId   : tIdFirmCtc;
 BEGIN
  dstId   :=FirmCtc.Id;
  dstBegin:=FirmCtc.Begin;
  dstTill :=FirmCtc.Till;
  SELECT(FirmCtc, Parent, , FirmCtc.Firm, srcId);
  WHILE OCCURE(FirmCtc) DO
   IF FirmCtc.Till >= dstBegin THEN
    SAVE(FirmCtc);
    srcId:=FirmCtc.Id;
    SETEMPTY(FirmCtc.Id);
    FirmCtc.Begin :=dstBegin;
    FirmCtc.Till  :=dstTill;
    FirmCtc.Parent:=dstId;
    TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     INSERT(FirmCtc);
     CopyChildren(srcId);
    EXCEPT
    ON Exc: Exc_RunTime DO
     IF L_General.IsUniquenessViolationException(Exc) THEN
      L_General.Error(" ࠧ ᨨ  " + FirmCtc.FirmCtc + "  㪠 ");
     ELSE
      RAISE();
     END;
    END;
    RESTORE(FirmCtc);
   END; (* TRY *)
   NEXT(FirmCtc);
  END; (* WHILE OCCURE(FirmCtc) ... *)
 END {CopyChildren};

 PRIVATE PROCEDURE CloseChildren();
  VAR
   curTill: DATE;
   curId  : LIKE(FirmCtc.Id);
 BEGIN
  curTill:= FirmCtc.Till;
  curId  := FirmCtc.Id;
  SAVE(FirmCtc);
  SELECT(FirmCtc, Parent, , FirmCtc.Firm, curId);
  WHILE OCCURE(FirmCtc) DO
   IF FirmCtc.Till > curTill THEN
    FirmCtc.Till:=curTill;
    REPLACE(FirmCtc);
    CloseChildren();
   END;
   NEXT(FirmCtc);
  END; (* WHILE OCCURE(FirmCtc) ... *)
  RESTORE(FirmCtc);
 END {CloseChildren};

 PRIVATE PROCEDURE FirmCtc_OnAfterEdIns(IsAfterInsertEvent: SCAL[2]);
  VAR
   curBegin,
   curTill  : DATE;
   curId    : LIKE(FirmCtc.Id);
 BEGIN
  L_General.Assert(~!FirmCtc.Contact, "   ' ⠪'");
  L_General.Assert(FirmCtc.Till >= FirmCtc.Begin, " 'ਮ ਬ ()'   'ਮ ਬ (C)'");
  CONFORM(FirmCtc, Firm);
  IF Firm.PrtnrTyp = P_Firm.pt_Man THEN
   L_General.Assert(FirmCtc.CKType # L_ctc.ckt_Common,
                    " ᯮ짮  ⠪ '" + L_Str.PoolItem(L_ctc.ckt_Pool, FirmCtc.CKType) + "'|" +
                    " ࠣ⮢  ⨯ '" + P_Firm.GetPartnerType_AsStr(P_Firm.pt_Man)+"'");
  END;

  CONFORM(FirmCtc, CtcKind);
  FirmCtc.Leaf:=L_ctc.CtcTypeIsPerson(CtcKind.Type);
  REPLACE(FirmCtc);
  IF IsAfterInsertEvent | (GE_PVALUE(FirmCtc.Begin) # FirmCtc.Begin) THEN
   SAVE(FirmCtc);
   CHANGESEL(FirmCtc, Firm, , FirmCtc.Firm, FirmCtc.FirmCtc);
   curTill:=FirmCtc.Begin;
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    IF PREV(FirmCtc) THEN
     FirmCtc.Till:=curTill;
     REPLACE(FirmCtc);
     CloseChildren();
    END;
   EXCEPT
   ON Exc: Exc_AccessDeny DO
    IF Exc.ErrorCode = L_General.ec_ad_IsLockedByOtherConnection THEN
     RAISE(Exc.ErrorCode, " 室 䨪樨 ।饩 ᨨ . , " + Str.Small(Exc.MsgOriginalText, 0, 1));
    ELSE
     RAISE();
    END;
   ELSE
    RAISE();
   END; (* TRY *)
   RESTORE(FirmCtc);
  END;

  CONFORM(FirmCtc, CtcKind);
  IF L_ctc.CtcTypeMustBeUnique(CtcKind.Type) THEN
   SAVE(FirmCtc);
   CHANGESEL(FirmCtc, fCKType, , FirmCtc.Firm, FirmCtc.CKType);
   curBegin:=FirmCtc.Begin;
   curTill :=FirmCtc.Till;
   curId   :=FirmCtc.Id;
   FIRST(FirmCtc);
   WHILE OCCURE(FirmCtc) DO
    IF (FirmCtc.Id # curId) & L_DatTim.IsActiveInIntvl(curBegin, curTill, FirmCtc.Begin, FirmCtc.Till) THEN
     L_General.Error("⠪ ⨯ '" + L_Str.PoolItem(L_ctc.ckt_Pool, FirmCtc.CKType) + "'" +
                     "|  ⮫쪮     ६");
    END;
    NEXT(FirmCtc);
   END;
   RESTORE(FirmCtc);
  END;
  L_DBD.CheckValidity("FirmCtc");

  IF ~!L_WDO.AccessEnvVar(im_AddFirmCtcVersion) THEN
   CopyChildren(L_WDO.AccessEnvVar(im_AddFirmCtcVersion).Value);
  END;
 END {FirmCtc_OnAfterEdIns};

 PRIVATE PROCEDURE FirmCtc_OnAfterEdit();
  VAR
   Begin,
   Till : DATE;
 BEGIN
  L_General.Assert(~!FirmCtc.Contact, "   ' ⠪'");
  SETEMPTY(Begin);
  IF P_Firm.IsFirmCtcOfManOfFirm(FirmCtc.Contact, FirmCtc.CKType) |
     P_Firm.IsFirmCtcOfManOfFirm(GE_PVALUE(FirmCtc.Contact), GE_PVALUE(FirmCtc.CKType)) THEN
   IF (FirmCtc.Contact # GE_PVALUE(FirmCtc.Contact)) |
      (FirmCtc.CKType  # GE_PVALUE(FirmCtc.CKType))  |
      (FirmCtc.Begin   # GE_PVALUE(FirmCtc.Begin)) THEN
    Begin:=Math.Min(FirmCtc.Begin, GE_PVALUE(FirmCtc.Begin));
   ELSIF FirmCtc.Till # GE_PVALUE(FirmCtc.Till) THEN
    Begin:=Math.Min(FirmCtc.Till, GE_PVALUE(FirmCtc.Till));
   END;
   IF ~!Begin THEN
    Till:=Math.Max(FirmCtc.Till, GE_PVALUE(FirmCtc.Till));
    CheckFirmPDoc(Begin, Till);
   END;
  END;
  FirmCtc_OnAfterEdIns(0);
 END {FirmCtc_OnAfterEdit};

 PRIVATE PROCEDURE FirmCtc_OnAfterInsert();
  VAR
   trgId      : LIKE(FirmCtc.Id);
   patIsPerson: SCAL[2];
 BEGIN
  L_General.Assert(~!FirmCtc.Contact, "   ' ⠪'");
  IF P_Firm.IsFirmCtcOfManOfFirm(FirmCtc.Contact, FirmCtc.CKType) THEN
   CheckFirmPDoc(FirmCtc.Begin, FirmCtc.Till);
  END;

  IF ~!L_WDO.AccessEnvVar(im_AddFirmCtcVersion) THEN
   trgId:=STRTOFLD(L_WDO.AccessEnvVar(im_AddFirmCtcVersion).Value, SCAL);
   SAVE(FirmCtc);
   SELECT(FirmCtc,Id, , FirmCtc.Firm, trgId);
   CONFORM(FirmCtc, CtcKind);
   patIsPerson:=L_ctc.CtcTypeIsPerson(CtcKind.Type);
   RESTORE(FirmCtc);
   CONFORM(FirmCtc, CtcKind);
   L_General.Assert(patIsPerson= L_ctc.CtcTypeIsPerson(CtcKind.Type),
                                                       " ᮧ  ᨨ ⠪  ⨯  ⠪ |" +
                                                       "c '"   + L_Str.PoolItem(pool_CKT,  patIsPerson) + "'" +
                                                       "  '" + L_Str.PoolItem(pool_CKT, ~patIsPerson) + "' 饭");
  END;
  FirmCtc_OnAfterEdIns(1);
 END {FirmCtc_OnAfterInsert};

 PRIVATE PROCEDURE StandOnPrvVersion(): SCAL[2];
 BEGIN
  CHANGESEL(FirmCtc, Firm, , FirmCtc.Firm, FirmCtc.FirmCtc);
  RETURN PREV(FirmCtc);
 END {StandOnPrvVersion};

 PRIVATE PROCEDURE HasPrvVersion(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(FirmCtc);
  Result:=StandOnPrvVersion();
  RESTORE(FirmCtc);
  RETURN Result;
 END {HasPrvVersion};

 PRIVATE PROCEDURE OpenPrvVersion();
  VAR
   UnbindCurrent: SCAL[2];
 BEGIN
  SAVE(FirmCtc);
  IF StandOnPrvVersion() THEN
   SETEMPTY(FirmCtc.Till);
   REPLACE(FirmCtc);
   IF ~!FirmCtc.Parent THEN
    SAVE(FirmCtc);
    SEARCH(FirmCtc, Id, , FirmCtc.Firm, FirmCtc.Parent);
    UnbindCurrent:=~!FirmCtc.Till;
    RESTORE(FirmCtc);
    IF UnbindCurrent THEN
     SETEMPTY(FirmCtc.Parent);
     REPLACE(FirmCtc);
    END;
   END;
  END;
  RESTORE(FirmCtc);
 END {OpenPrvVersion};

 PRIVATE PROCEDURE GetParentFirmCtc(): LIKE(FirmCtc.FirmCtc);
  VAR
   Result: LIKE(FirmCtc.FirmCtc);
 BEGIN
  IF ~!FirmCtc.Parent THEN
   SAVE(FirmCtc);
   SEARCH(FirmCtc, Id, , FirmCtc.Firm, FirmCtc.Parent);
   Result:=FirmCtc.FirmCtc;
   RESTORE(FirmCtc);
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetParentFirmCtc};

 PRIVATE PROCEDURE PrvVersionIsIdentical(): SCAL[2];
  VAR
   _FirmCtc,
   pFirmCtc: LIKE(FirmCtc.FirmCtc);
   _Name   : LIKE(FirmCtc.Name);
   _CtcKind: LIKE(FirmCtc.CtcKind);
   _CKType : LIKE(FirmCtc.CKType);
   _ECKName: LIKE(FirmCtc.ECKName);
   _Comment: LIKE(FirmCtc.Comment);
   _Parent : LIKE(FirmCtc.Parent);
   Result  : SCAL[2];
 BEGIN
  SAVE(FirmCtc);
  _Parent :=FirmCtc.Parent;
  _CtcKind:=FirmCtc.CtcKind;
  _ECKName:=FirmCtc.ECKName;
  _Comment:=FirmCtc.Comment;
  _Name   :=FirmCtc.Name;
  _FirmCtc:=FirmCtc.FirmCtc;
  pFirmCtc:=GetParentFirmCtc();
  L_General.CallUs(StandOnPrvVersion());
  Result:=(GetParentFirmCtc() = pFirmCtc) &
          (FirmCtc.CtcKind    = _CtcKind) &
          (FirmCtc.ECKName    = _ECKName) &
          (FirmCtc.FirmCtc    = _FirmCtc) &
          (FirmCtc.Comment    = _Comment) ;
  RESTORE(FirmCtc);
  RETURN Result;
 END {PrvVersionIsIdentical};

 PRIVATE PROCEDURE FreeChildren();
  VAR
   trgFirm: LIKE(FirmCtc.Firm);
   trgId  : LIKE(FirmCtc.Id);
 BEGIN
  SAVE(FirmCtc);
  trgFirm:=FirmCtc.Firm;
  trgId  :=FirmCtc.Id;
  WHILE SELECT(FirmCtc, Parent, trgFirm, trgId) DO
   FreeChildren();
   IF HasPrvVersion() THEN
    IF PrvVersionIsIdentical() THEN
     OpenPrvVersion();
     REMOVE(FirmCtc);
    ELSE
     SETEMPTY(FirmCtc.Parent);
     REPLACE(FirmCtc);
    END;
   ELSE
    SETEMPTY(FirmCtc.Parent);
    REPLACE(FirmCtc);
   END;
  END;
  RESTORE(FirmCtc);
 END {FreeChildren};

 PRIVATE PROCEDURE FirmCtc_OnBeforeDelete();
 BEGIN
  L_General.Assert(IsLastFirmCtc(), "  ᫥  ⠪.  饭");
  IF P_Firm.IsFirmCtcOfManOfFirm(FirmCtc.Contact, FirmCtc.CKType) THEN
   CheckFirmPDoc(FirmCtc.Begin, FirmCtc.Till);
  END;
  L_ctc.BeforeOriginDelete(L_ctc.o_FirmCtc);
  IF HasPrvVersion() THEN
   OpenPrvVersion();
  END;
  FreeChildren();
  IF HasPrvVersion() THEN
   L_StdFrm.Inform("  ।  ⠪ ࠣ");
  END;
 END {FirmCtc_OnBeforeDelete};

 PRIVATE PROCEDURE FirmCtc_Begin_OnSuccessfulChange();
  VAR
   isLast,
   wasLast : SCAL[2];
 BEGIN
  isLast:=IsLastFirmCtc();
  TRY [ABORT_AFTER(AA_ON)]
   FirmCtc.Begin:=GE_PVALUE();
   REPLACE(FirmCtc);
   wasLast:=IsLastFirmCtc();
  EXCEPT
  END; (* TRY *)
  IF isLast # wasLast THEN
   L_StdFrm.Choice("  冷 ᫥ ᨩ ⠪");
  END;
 END {FirmCtc_Begin_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckFirmCtcConsistency();
 BEGIN
  IF ~!FirmCtc.CKType & ~!FirmCtc.Contact THEN
   CONFORM(FirmCtc, Contact);
   CONFORM(FirmCtc, CtcKind);
   IF L_ctc.CtcTypeIsPerson(CtcKind.Type) # Contact.IsPerson THEN
    IF     Contact.IsPerson & ~L_ctc.CtcTypeIsPerson(CtcKind.Type) THEN
     L_General.Error("⨬ ᯮ짮 ⠪ 祫");
    ELSIF ~Contact.IsPerson &  L_ctc.CtcTypeIsPerson(CtcKind.Type) THEN
     L_General.Error("⨬ ᯮ짮 ⠪ ࠡ祩 㯯");
    END;
   END;
  END;
 END {CheckFirmCtcConsistency};

 PRIVATE PROCEDURE FirmCtc_CtcKind_OnSuccessfulChange();
  VAR
   HasECKName    : SCAL[2];
   prvCtcKindName: STRING[];
 BEGIN
  CheckFirmCtcConsistency();

  IF SEARCH(CtcKind, CtcKind, GE_PVALUE()) THEN
   prvCtcKindName:=CtcKind.DflName;
  ELSE
   prvCtcKindName:="";
  END;
  CONFORM(FirmCtc, CtcKind);
  FirmCtc.CKType:=CtcKind.Type;

  FirmCtc.Leaf:=L_ctc.CtcTypeIsPerson(CtcKind.Type);

  IF FirmCtcHasECKName() THEN
   RTI.Get().CurZone.Fields("FirmCtc.ECKName").Modifiable:=1;
   IF ~!CtcKind.DflName & (!FirmCtc.ECKName | (FirmCtc.ECKName = prvCtcKindName)) THEN
    FirmCtc.ECKName:=CtcKind.DflName;
   END;
  ELSE
   IF ~!FirmCtc.ECKName THEN
    L_StdFrm.Choice("㤥 饭 '譥  '");
   END;
   SETEMPTY(FirmCtc.ECKName);
   RTI.Get().CurZone.Fields("FirmCtc.ECKName").Modifiable:=0;
  END;
  REPLACE(FirmCtc);
 END {FirmCtc_CtcKind_OnSuccessfulChange};

 PRIVATE PROCEDURE FirmCtc_Contact_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!FirmCtc.Contact, "     ");
  L_General.Assert(~!FirmCtc.CtcKind, " 㪠  ⠪");
  CheckFirmCtcConsistency();
  CONFORM(FirmCtc, Contact);
  FirmCtc.Name   :=Contact.Name;
  REPLACE(FirmCtc);
 END {FirmCtc_Contact_OnSuccessfulChange};

 PUBLIC PROCEDURE NewContact();
  VAR
   Choice: NUMERIC[0];
 BEGIN
  Choice:=L_StdFrm.ShowListAsMenu("  ⠪ ࠣ|"+
                                  "  ⥪饣 ⠪ ࠣ",
                                  "롮 ᯮᮡ  ⠪");
  IF    Choice = 0 THEN
   LIKEMENU(Ins, "@ " + im_AddNewFirmCtc + "=True");
  ELSIF Choice = 1 THEN
   ACCESS(FirmCtc);
   L_General.Assert(!FirmCtc.Till, "    ⮢ ⮫쪮  ᭮ ⮩ ᨨ ⠪");
   LIKEMENU(Ins, "@ " + im_AddFirmCtcVersion+ "=" + FirmCtc.Id);
  END;
 END {NewContact};

 PUBLIC PROCEDURE ShowUsage();
  CONST
   NoXDocId = "X";
  VAR
   List,
   Ids      : STRING[];
   curRecord,
   curFileName,
   curRECORDID: STRING[];
 BEGIN
  ACCESS(Contact);
  SETEMPTY(List, Ids);
  IF SELECT(Man, Contact, Contact.Contact) THEN
   List:=List + " " + L_Str.FixedIntStr(Man.Man, 6) + " " + Man.Name + "|";
   Ids:=Ids + "Man;" + Man.RECORDID + "|";
  END;
  IF SELECT(FirmCtc, Contact, Contact.Contact) THEN
   WHILE OCCURE(FirmCtc) DO
    CONFORM(FirmCtc, Firm);
    CONFORM(FirmCtc, CtcKind);
    List:=List + "" + " " + Firm.Firm +
                        " " + Str.Align(Firm.Name, w_FName, LEFT) +
                        " " + CtcKind.CtcKind +
                        " " + Str.Align(CtcKind.Name, 24, LEFT) +
                        " " + Str.Align(FirmCtc.ECKName, 21, LEFT) +
                        " " + L_DatTim.DateStr(FirmCtc.Begin) + "|";
    Ids:=Ids + "Firm;" + Firm.RECORDID + "|";
    NEXT(FirmCtc);
   END; (* WHILE OCCURE(FirmCtc) ... *)
  END;

  SELECT(Officer, Contact, , Contact.Contact);
  WHILE OCCURE(Officer) DO
   CONFORM(Officer, Sort);
   CONFORM(Officer, Post);
   CONFORM(Sort, MyFirm);

   List:=List + "" + " " + Sort.Sort +
                       " " + Str.Align(Sort.Name, 29, LEFT) +
                       " " + MyFirm.vzSign +
                       " " + Officer.Officer +
                       " " + Str.Align(Post.Name, 29, LEFT) + "|";
   Ids:=Ids + "Officer;" + Officer.RECORDID + "|";

   NEXT(Officer);
  END; (* WHILE OCCURE(Officer) ... *)

  curRecord:=L_Str.PoolItem(Ids, L_StdFrm.ShowListAsMenu(List, " " + "ᯮ짮 ⠪ " + Contact.Contact + " "));
  curFileName:=Str.Item(curRecord, ";", 0);
  curRECORDID:=Str.Item(curRecord, ";", 1);
  L_General.CallUs(SEARCH(^curFileName, RECORDID, STRTOFLD(curRECORDID, NUMERIC)));

  L_WDO.PosToCurRecord(curFileName, "", 0);
 END {ShowUsage};

 PUBLIC PROCEDURE ShowContactByPhone();
  VAR
   inpPhone,
   cnvPhone: STRING[];
   List    : STRING[];
   Dummy   : NUMERIC[0];
 BEGIN
  inpPhone:="";
  STDFORM(L_StdFrm.sf_Choice("| ⥫䮭 (᫥ ᪮쪮 ) %#############%|",
                             "%LI"),
          "  ⠪⮢ ",
          ,
          1,
          inpPhone);
  cnvPhone:=L_ctc.GetInvValue(inpPhone);
  IF Str.Length(cnvPhone) >= 3 THEN
   List:="";
   SETSEL(CtcVal, InvValue);
   SRCINSEL(CtcVal, GE, , cnvPhone);
   WHILE OCCURE(CtcVal) & Str.Match(CtcVal.InvValue, cnvPhone+"*") DO
    CONFORM(CtcVal, Contact);
    List:=List + Contact.Contact +
           " " + Str.Align(Contact.Name, 32, LEFT) +
           " " + Str.Align(Contact.FirmName, 24, LEFT) +
           " " + L_Str.PoolItem(L_ctc.cvc_PoolShort, CtcVal.Coverage) +
           " " + CtcVal.Value +
           "|" ;
    NEXT(CtcVal);
   END; (* WHILE OCCURE(CtcVal) ... *)
   IF ~!List THEN
    Dummy:=L_StdFrm.ShowListAsMenu(List, "  ⠪⮢. 砭  ⥫䮭 - '" + inpPhone + "' ");
   ELSE
    L_StdFrm.RedInform(" 祣 室饣");
   END;
  ELSE
   L_StdFrm.RedInform("   3 ");
  END;
 END {ShowContactByPhone};

 PRIVATE PROCEDURE cl_AlignSingleLine(S: STRING[]): STRING[];
 BEGIN
  RETURN Str.Align(S, L_ctc.cl_w_Total(), LEFT);
 END {cl_AlignSingleLine};

 PRIVATE PROCEDURE ShowCallList(trgFirm: LIKE(Firm.Firm); trgId: LIKE(FirmCtc.Id); Caption: STRING[]);
  VAR
   CoveragePool,
   TypePool,
   Prefixes,
   List1,
   curAdr,
   s            : STRING[];
   maxL,
   maxX,
   maxY,
   Count1,
   Count2,
   j,
   prfIdx,
   ctcIdx       : NUMERIC[0];
   trgValue     : STRING[L_ctc.cl_w_Value];
   oPrompt      : PROMPT_LINE;
 BEGIN
  oPrompt:=PROMPT_LINE.Create("⮢ ''");
  SETZERO(maxL, Count1);
  SETEMPTY(List1);
  IF SELECT(FCtcLst, toShow, trgId) THEN
   WHILE OCCURE(FCtcLst) DO
    IF ~!FCtcLst.Adr THEN
     IF FCtcLst.Source = L_ctc.cls_CtcVal THEN
      CoveragePool:=L_ctc.cvc_PoolShort;
      TypePool    :=L_ctc.cvt_PoolShort;
     ELSE
      CoveragePool:=L_ctc.cat_PoolShort;
      TypePool    :="";
     END;
     s:= L_Str.Repeat(" ", (FCtcLst.RelationDegree+1)*2)            +
         L_Str.PoolItem(CoveragePool, FCtcLst.Coverage)             +
         " " + L_Str.PoolItem(TypePool, FCtcLst.Type)               +
         " " + Str.Align(FCtcLst.Value,   L_ctc.cl_w_Value,   LEFT) +
         " " + Str.Align(FCtcLst.Comment, L_ctc.cl_w_Comment, LEFT);
     IF Str.Length(s) > L_ctc.cl_w_Total() THEN
      s:=Str.Slice(s, 0, L_ctc.cl_w_Total() - 3) + "...";
     END;
     s:=cl_AlignSingleLine(s);
     PROMPT(s);
     List1:=s + '|' + List1;
     maxL :=Math.Max(maxL, Str.Length(s));
     INC(Count1);
    END; (* IF ~!FCtcLst.Adr ... *)
    NEXT(FCtcLst);
   END; (* WHILE OCCURE(FCtcLst) ... *)
  END; (* IF SELECT(FCtcLst ... *)
  SETEMPTY(oPrompt);
  IF Count1 = 0 THEN
   L_StdFrm.BlueStop("  ⠪⭮ ଠ樨");
  ELSE
   L_ctc.E_GetPrefixes(trgFirm, Prefixes, prfIdx);
   Count2:=0;
   LOOP
    s:=L_Str.PoolItem(Prefixes, Count2);
    IF !s THEN
     EXIT;
    END;
    maxL:=Math.Max(maxL, Str.Length(s));
    INC(Count2);
   END; (* LOOP *)

   GE_APPWIN_SIZE(maxX, maxY);

   ctcIdx:=0;
   j:=Math.Min(Math.Max(Count1, 2), maxY*0.8);
   L_General.CallUs(maxL <= maxX - 4);
   STDFORM(Caption + "|" +
           L_Str.Repeat("", maxL+2) + "|" +
           "%" + L_Str.IntStr(maxL) + "," + L_Str.IntStr(j) + "AI" +
           L_Str.Repeat("|", j) + L_Str.Repeat("", maxL+2) + "|" +
           "%" + L_Str.IntStr(maxL-4) + "," + L_Str.IntStr(Count2) + "<" + Prefixes + ">O",
           " 易, ᬮ  , ३  ᠩ ", ^(L_StdFrm.SFMenuStyle()), -1, List1, ctcIdx, prfIdx);
   ctcIdx:=Count1 - ctcIdx - 1;
   FIRST(FCtcLst);
   WHILE ctcIdx > 0 DO
    IF ~!FCtcLst.Adr THEN
     DEC(ctcIdx);
    END;
    NEXT(FCtcLst);
   END;
   WHILE !FCtcLst.Adr DO
    NEXT(FCtcLst);
   END;

   curAdr:=FCtcLst.Adr;
   IF    FCtcLst.MthConnect = 0 THEN
    IF prfIdx > 0 THEN
     curAdr:=Str.Item(L_Str.PoolItem(Prefixes, prfIdx), ";", 0) + curAdr;
    END;
    L_ctc.Call(curAdr, FCtcLst.CallerId);
   ELSIF FCtcLst.MthConnect = 1 THEN
    L_ctc.Call(curAdr, FCtcLst.CallerId);
   ELSIF FCtcLst.MthConnect = 2 THEN
    Shell.Execute("open", curAdr);
   ELSE
    Shell.Execute("open", L_Str.PoolItem(curAdr, 0));
    Shell.Execute("open", L_Str.PoolItem(curAdr, 1));
   END;
  END; (* IF Count1 = 0 ... *)
 END {ShowCallList};

 PRIVATE PROCEDURE GetCtcName(): STRING[];
  VAR
   Result:STRING[];
 BEGIN
  IF L_ctc.CtcTypeIsPerson(FirmCtc.CKType) THEN
   IF ~!FirmCtc.ECKName THEN
    Result:=FirmCtc.ECKName;
   ELSE
    CONFORM(FirmCtc, CtcKind);
    Result:=CtcKind.Name;
   END;
  ELSE
   Result:=FirmCtc.Name;
  END;
  RETURN Result;
 END {GetCtcName};

 TYPE
  tSource = SCAL[2];

 CONST
  s_Contact = 0;
  s_FirmCtc = 1;

 PRIVATE PROCEDURE CallToContact(Source: SCAL[2]);
  VAR
   trgFirm     : LIKE(Firm.Firm);
   trgId       : LIKE(FirmCtc.Id);
   _Caption,
   poolFirmList: STRING[];
   cntFirm,
   _Nbr        : NUMERIC[0];
 BEGIN
  IF Source = s_FirmCtc THEN
   CONFORM(FirmCtc, Contact);
   trgFirm   :=FirmCtc.Firm;
   trgId     :=FirmCtc.Id;
   cntFirm :=1;
  ELSE
   L_AFM.MakeMultipleIndex("FirmList", "Name    : LIKE(Firm.Name);"       +
                                       "Firm    : LIKE(Firm.Firm);"       +
                                       "Id      : LIKE(FirmCtc.Id);"      +
                                       "ECKName : LIKE(FirmCtc.ECKName);" +
                                       "CtcKind : LIKE(CtcKind.CtcKind);" +
                                       "CtcName : LIKE(CtcKind.Name);"    +
                                       "Nbr     : NUMERIC[0];",
                            "Firm: Firm, Id;" +
                            "Nbr : Nbr");

   cntFirm:=0;
   SELECT(FirmCtc, CtcFirm, , Contact.Contact);
   WHILE OCCURE(FirmCtc) DO
    IF L_DatTim.IsActive(SYSDATE(), FirmCtc.Begin, FirmCtc.Till) THEN
     CONFORM(FirmCtc, Firm);
     FirmList.Id      :=FirmCtc.Id;
     FirmList.Firm    :=Firm.Firm;
     FirmList.Name    :=Firm.Name;
     CONFORM(FirmCtc, CtcKind);
     FirmList.CtcKind :=CtcKind.CtcKind;
     FirmList.CtcName :=CtcKind.Name;
     FirmList.ECKName :=GetCtcName();
     SETEMPTY(FirmList.Nbr);
     INSERT(FirmList);
     INC(cntFirm);
    END;
    NEXT(FirmCtc);
   END; (* WHILE OCCURE(FirmCtc) ... *)

   IF    cntFirm = 0 THEN
    SETEMPTY(trgFirm, trgId);
   ELSIF cntFirm = 1 THEN
    SELECT(FirmList, Firm);
    trgFirm:=FirmList.Firm;
    trgId  :=FirmList.Id;
   ELSE
    _Nbr:=0;
    SETEMPTY(poolFirmList);
    SELECT(FirmList, Firm);
    WHILE OCCURE(FirmList) DO
     poolFirmList:=poolFirmList + FirmList.Firm    + " " + Str.Align(FirmList.Name, w_FName, LEFT) +
                            " " + FirmList.CtcKind + " " + Str.Align(FirmList.CtcName, 24, LEFT)   +
                            " " + FirmList.ECKName + "|";
     FirmList.Nbr:=_Nbr;
     REPLACE(FirmList);
     INC(_Nbr);
     NEXT(FirmList);
    END; (* WHILE OCCURE(FirmList) ... *)
    SELECT(FirmList, Nbr, , L_StdFrm.ShowListAsMenu(poolFirmList, " 롮 ࠣ "));
    trgFirm:=FirmList.Firm;
    trgId  :=FirmList.Id;
   END;
  END;

  IF !trgFirm THEN
   _Caption:=Contact.Name;
   L_ctc.MakeFCtcLst(L_ctc.ls_Contact, SYSDATE());
  ELSE
   IF SELECT(FirmCtc, Id, trgFirm, trgId) THEN
    L_ctc.MakeFCtcLst(L_ctc.ls_FirmCtc, SYSDATE());
    _Caption:=L_Str.Repeat(" ", (L_ctc.cl_CntParents()+1)*2) + FirmCtc.Name;
    IF !FirmCtc.ECKName THEN
     _Caption:=cl_AlignSingleLine(_Caption);
    ELSE
     _Caption:=cl_AlignSingleLine(_Caption + " (" + FirmCtc.ECKName + ")");
    END;

    SAVE(FirmCtc);
    WHILE ~!FirmCtc.Parent DO
     SELECT(FirmCtc, Id, , trgFirm, FirmCtc.Parent);
     _Caption:=cl_AlignSingleLine(L_Str.Repeat(" ", (L_ctc.cl_CntParents()+1)*2) + FirmCtc.Name) + L_Str.CRLF + _Caption;
    END; (* WHILE ~!FirmCtc.Parent *)
    RESTORE(FirmCtc);

    CONFORM(FirmCtc, Firm);
    _Caption:=cl_AlignSingleLine(Firm.Name) + L_Str.CRLF + _Caption;
   END; (* SELECT(FirmCtc, Id, trgFirm, trgId) ... *)
  END;(*IF !Firm ...*)

  ShowCallList(trgFirm, trgId, _Caption);
 END {CallToContact};

 PUBLIC PROCEDURE CallToCurrentContact();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(Contact);
  L_General.Assert(L_DatTim.IsActive(SYSDATE(), Contact.Begin, Contact.Till),
                   "࠭ 騩 ⠪");
  CallToContact(s_Contact);
 END {CallToCurrentContact};

 PUBLIC PROCEDURE CallToCurrentFirmCtc();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(FirmCtc);
  L_General.Assert(L_DatTim.IsActive(SYSDATE(), FirmCtc.Begin, FirmCtc.Till),
                   "࠭ 騩 ⠪ ࠣ");
  CallToContact(s_FirmCtc);
 END {CallToCurrentFirmCtc};

 PUBLIC PROCEDURE MergeCurrentContact();
  VAR
   srcContact,
   dstContact: LIKE(Contact.Contact);
   Msg       : STRING[];
 BEGIN
  ACCESS(Contact);
  L_r2r.Owner_OnBeforeDelete("Contact");
  srcContact:=Contact.Contact;
  SETEMPTY(dstContact);
  STDFORM(L_StdFrm.sf_Choice("! ﭨ ⨬!" +
                             "||" +
                             Contact.Contact + " '" + Contact.Name + "'" +
                             "||" +
                             "  ⠪  ७ᥭ, ᫥ 祣 ⠪ 㤥 㤠." +
                             "||" +
                             "  ⠪,   室 ꥤ : %#######%",
                             "%I"),
          " ﭨ ⠪⮢ ", CHOICE, 1, dstContact);
  Msg:="ﭨ ⠪⮢:" +
       "||"+
       Str.Align(Contact.Contact + " " + Contact.Name, 56, LEFT);
  L_General.Assert(SEARCH(Contact, Contact, dstContact), "   ⠪");
  Msg:=Msg +
       "||"+
       Str.Align(Contact.Contact + " " + Contact.Name, 56, LEFT);
  SEARCH(Contact, Contact, , srcContact);
  Msg:=Msg +
       "||"+
       "㤥 㤠:" +
       "||" +
       Str.Align(Contact.Contact + " " + Contact.Name, 56, LEFT);

  L_StdFrm.Choice(Msg);

  WHILE SELECT(CtcVal, Contact, srcContact) DO
   CtcVal.Contact:=dstContact;
   SETEMPTY(CtcVal.CtcVal);
   REPLACE(CtcVal);
  END; (* WHILE OCCURE(CtcVal) ... *)

  TRY [INTEGRITY(INTEGRITY_OFF)]
   REMOVE(Contact);
   SEARCH(Contact, Contact, , dstContact);
   Contact.Contact:=srcContact;
   REPLACE(Contact);
  EXCEPT
  END;

  TRY [INTEGRITY(INTEGRITY_ON)]
   Contact.Contact:=dstContact;
   REPLACE(Contact);
 
   SELECT(FirmCtc, Contact, , dstContact);
   WHILE OCCURE(FirmCtc) DO
    FirmCtc.Name:=Contact.Name;
    REPLACE(FirmCtc);
    NEXT(FirmCtc);
   END; (* WHILE OCCURE(FirmCtc) ... *)
  EXCEPT
  END;

  SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), Contact);
 END {MergeCurrentContact};

 PRIVATE PROCEDURE BeforeReplaceCtcValContact();
 BEGIN
  L_General.CallUs(ACCESS(Contact));
  L_SysLog.SingleMark_BeforeDelete("CtcVal");
 END {BeforeReplaceCtcValContact};

 PRIVATE PROCEDURE ReplaceCtcValContact(trgContact: LIKE(Contact.Contact));
 BEGIN
  SEARCH(Contact, Contact, , trgContact);
  CtcVal.Contact:=Contact.Contact;
  SETEMPTY(CtcVal.CtcVal);
  REPLACE(CtcVal);
  L_SysLog.SingleMark_AfterInsert("CtcVal");
 END {ReplaceCtcValContact};

 PUBLIC PROCEDURE MoveCurCtcValToParentFirmCtc();
 BEGIN
  ACCESS(CtcVal);
  ACCESS(FirmCtc);
  L_General.Assert(FirmCtcHasParent(), "騩 ⠪ ࠣ 室  孥 ஢ 娨");
  BeforeReplaceCtcValContact();
  SAVE(FirmCtc);
  SEARCH(FirmCtc, Id, , FirmCtc.Firm, FirmCtc.Parent);
  ReplaceCtcValContact(FirmCtc.Contact);
  RESTORE(FirmCtc);
 END {MoveCurCtcValToParentFirmCtc};

 PRIVATE PROCEDURE GetChildrenList(    trgFirm    : LIKE(FirmCtc.Firm);
                                       trgId      : LIKE(FirmCtc.Id);
                                       MaxLevel   : NUMERIC[0];
                                   VAR ChildList,
                                       ChildIdList: STRING[];
                                   VAR curLevel   : NUMERIC[0]);
  VAR
   CurChildListItem: STRING[];
 BEGIN
  INC(curLevel);
  SAVE(FirmCtc);
  SELECT(FirmCtc, Parent, , trgFirm, trgId);
  WHILE OCCURE(FirmCtc) DO
   CONFORM(FirmCtc, CtcKind);
   ChildIdList:=ChildIdList + FirmCtc.Id + "|";
   CurChildListItem:=FirmCtc.FirmCtc                   + " " +
                     Str.Align(FirmCtc.Name, 30, LEFT) + " " +
                     Str.Align(CtcKind.Name, 30, LEFT) + " " +
                     L_DatTim.DateStr(FirmCtc.Begin)   + " " +
                     L_DatTim.DateStr(FirmCtc.Till)    + "|";
   IF Str.Length(CurChildListItem) > L_ctc.cl_w_Total() THEN
    CurChildListItem:=Str.Slice(CurChildListItem, 0, L_ctc.cl_w_Total()-3) + "...";
   END;
   ChildList  :=ChildList + CurChildListItem;
   IF curLevel < MaxLevel THEN
    GetChildrenList(trgFirm, FirmCtc.Id, MaxLevel, ChildList, ChildIdList, curLevel);
   END;
   NEXT(FirmCtc);
  END; (* WHILE OCCURE(FirmCtc) *)
  RESTORE(FirmCtc);
 END {GetChildrenList};

 PUBLIC PROCEDURE MoveCurCtcValToChildFirmCtc();
  VAR
   ChildId    : LIKE(FirmCtc.Id);
   ChildList,
   ChildIdList: STRING[];
   curLevel   : NUMERIC[0];
 BEGIN
  ACCESS(CtcVal);
  ACCESS(FirmCtc);
  L_General.Assert(L_ctc.FirmCtcHasChild(), "騩 ⠪ ࠣ 室   ஢ 娨");
  BeforeReplaceCtcValContact();
  SETEMPTY(ChildList, ChildIdList);
  curLevel:=0;
  GetChildrenList(FirmCtc.Firm, FirmCtc.Id, 1, ChildList, ChildIdList, curLevel);
  ChildId:=L_Str.PoolItem(ChildIdList, L_StdFrm.ShowListAsMenu(ChildList, "롮 ⠪ ࠣ"));
  SAVE(FirmCtc);
  SEARCH(FirmCtc, Id, , FirmCtc.Firm, ChildId);
  CONFORM(FirmCtc, Contact);
  IF Contact.IsPerson THEN
   CtcVal.Inherit:=L_ctc.cvi_NotInherit;
  END;
  ReplaceCtcValContact(FirmCtc.Contact);
  RESTORE(FirmCtc);
 END {MoveCurCtcValToChildFirmCtc};

 PUBLIC PROCEDURE MoveCurrentCtcVal();
  VAR
   dstContact: LIKE(Contact.Contact);
 BEGIN
  ACCESS(CtcVal);
  CONFORM(CtcVal, Contact);
  SETEMPTY(dstContact);
  STDFORM(L_StdFrm.sf_Choice(Contact.Contact + " '" + Contact.Name + "'" +
                             "||" +
                             "'" + L_ctc.GetCtcValCoverage_asStr() + " " + L_ctc.GetCtcValType_asStr() + "' " + CtcVal.Value +
                             "||" +
                             " 㤥 ७  㪠 ⠪ %#######%",
                             "%I"),
          " ७ ⥪饣 ४ ⠪  ",
          STOP,
          1,
          dstContact);
  BeforeReplaceCtcValContact();
  L_General.Assert(SEARCH(Contact, Contact, dstContact), "   ⠪");
  ReplaceCtcValContact(dstContact);
 END {MoveCurrentCtcVal};

 PRIVATE PROCEDURE scfci_FileHasNotEmptyField(File, Field: STRING[]): SCAL[2];
 BEGIN
  IF ~!TABLE.Get(File).Fields(Field) THEN
   IF ~!^File.^Field THEN
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {scfci_FileHasNotEmptyField};

 PRIVATE PROCEDURE ViewCurContact();
  CONST
   trgWindow = "ContactE";
  VAR
   trgFormWindow: FORM_WINDOW;
 BEGIN
  trgFormWindow:=APP.Get().Forms.Load(trgWindow, trgWindow+"<"+RTI.Get().CurWindow.Name+">");
  trgFormWindow.Zones(0).ViewOnly:=1;
  LIKEMENU(View, trgFormWindow.Name+" 1");
 END {ViewCurContact};

 PUBLIC PROCEDURE ShowCurrentFileContactInfo();
  VAR
   curFile: STRING[];
 BEGIN
  IF ~!RTI.Get().CurZone.MasterTable THEN
   curFile:=RTI.Get().CurZone.MasterTable.Name;
   IF ACCESS(^curFile) THEN
    IF    curFile = "FirmCtc" THEN
     LIKEMENU(View, "Contact 1");
    ELSIF curFile = "Staff" THEN
     ViewCurContact();
    ELSIF (curFile = "RprS") | (curFile = "Dspt") THEN
     LIKEMENU(View, "FirmCtc 1 " + RTI.Get().CurWindow.OriginalName + " " + L_Str.IntStr(RTI.Get().CurZone.Number));
    ELSIF scfci_FileHasNotEmptyField(curFile, "Firm") | scfci_FileHasNotEmptyField(curFile, "Contract") THEN
     LIKEMENU(View, "FirmCtc 1");
    ELSIF scfci_FileHasNotEmptyField(curFile, "TSN") | scfci_FileHasNotEmptyField(curFile, "Man") THEN
     ViewCurContact();
    ELSIF curFile = "Officer" THEN
     IF ~!Officer.Contact THEN
      ViewCurContact();
     END;
    END; (* IF curFile ... *)
   END; (* IF ACCESS(^curFile) *)
  END; (* IF ~!RTI.Get().CurZone.MasterTable *)
  LIKEMENU(View, "Contact 1");
 END {ShowCurrentFileContactInfo};

 CONST
  MaxCntFirmInRoute = 10;

 PRIVATE PROCEDURE FirmCtcR_OnInitializeWindow();
  VAR
   Idx: NUMERIC[0];
 BEGIN
  L_WDO.iWindow().MNUFileName:="Firm";
  L_WDO.iWindow().OnOpenWindow:=1;
  L_WDO.iEvents      (0, [L_WDO.e_OnOpenZone]);
  L_WDO.iScsChange   (0, ["Firm_5", "Firm_0", "Id_9", "Firm_9", "Id_8", "Firm_8", "Id_7", "Firm_7", "Id_6", "Firm_6", "Id_5", "Id_4", "Firm_4", "Id_3", "Firm_3", "Id_2", "Firm_2", "Id_1", "Firm_1", "Id_0"]);
  L_WDO.iUnmodifiable(0, ["FirmCtc_Name_9", "Firm_Name_9", "FirmCtc_Name_8", "Firm_Name_8", "FirmCtc_Name_7", "Firm_Name_7", "FirmCtc_Name_6", "Firm_Name_6", "FirmCtc_Name_5", "Firm_Name_5", "FirmCtc_Name_4", "Firm_Name_4", "FirmCtc_Name_3", "Firm_Name_3", "FirmCtc_Name_2", "Firm_Name_2", "FirmCtc_Name_1", "Firm_Name_1", "FirmCtc_Name_0", "Firm_Name_0", "v_Point_9", "v_Point_8", "v_Point_7", "v_Point_6", "v_Point_5", "v_Point_4", "v_Point_3", "v_Point_2", "v_Point_1", "v_Point_0"]);
  L_WDO.iMayBeEmpty  (0, ["Firm_5", "Firm_0", "Id_9", "Firm_9", "Id_8", "Firm_8", "Id_7", "Firm_7", "Id_6", "Firm_6", "Id_5", "Id_4", "Firm_4", "Id_3", "Firm_3", "Id_2", "Firm_2", "Id_1", "Firm_1", "Id_0"]);
  L_WDO.iProgs       (0, "Contact");

  Idx:=0;
  WHILE Idx < MaxCntFirmInRoute DO
   L_WDO.extCreateFormLink("Firm",    "", Idx);
   L_WDO.extCreateFormLink("FirmCtc", "", Idx);
   INC(Idx);
  END;
 END {FirmCtcR_OnInitializeWindow};

 PRIVATE PROCEDURE FirmCtcR_OnOpenWindow();
 BEGIN
  RTI.Get().CurWindow.Isolated:=FORM_WINDOW.Isolated_Full;
 END {FirmCtcR_OnOpenWindow};

 PRIVATE PROCEDURE CurFirmCtc_StandOnAdr_Fct();
 BEGIN
  CONFORM(FirmCtc, Firm);
  L_General.Assert(L_ctc.CurFirmCtc_StandOnAdr_Fct(SYSDATE(), 0),
                   "  |" +
                   " ⠪ " + FirmCtc.Id  + " '" + FirmCtc.Name + "'|" +
                   "ࠣ " + Firm.Firm + " '"+ Firm.Name + "'");
 END {CurFirmCtc_StandOnAdr_Fct};

 PRIVATE PROCEDURE FirmCtcR_0_OnZoneOpen();
  VAR
   Fields: FORM_FIELDS;
   Idx   : NUMERIC[0];
   dummy : SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  ACCESS(FirmCtc);
  Fields(L_WDO.Fld_wIdx("Firm", 1)).Value:=FirmCtc.Firm;
  Fields(L_WDO.Fld_wIdx("Id",   1)).Value:=FirmCtc.Id;
  CurFirmCtc_StandOnAdr_Fct();
  Fields(L_WDO.Fld_wIdx("Id",   1)).Modifiable:=(L_ctc.StandOnAnyFCtc_wAdrFct(SYSDATE(), FirmCtc.Firm) > 1);
  dummy:=P_Firm.StandOnFirmCtcByKindType(1, P_Firm.OWN_FIRM, SYSDATE(), L_ctc.ckt_Common);
  Fields(L_WDO.Fld_wIdx("Firm", 0)).Value:=P_Firm.OWN_FIRM;
  Fields(L_WDO.Fld_wIdx("Id",   0)).Value:=FirmCtc.Id;
  Fields(L_WDO.Fld_wIdx("Id",   0)).Modifiable:=(L_ctc.StandOnAnyFCtc_wAdrFct(SYSDATE(), P_Firm.OWN_FIRM) > 1);
  CurFirmCtc_StandOnAdr_Fct();
  Idx:=2;
  WHILE Idx < MaxCntFirmInRoute DO
   SETEMPTY(Fields(L_WDO.Fld_wIdx("Firm",    Idx)).Value,
            Fields(L_WDO.Fld_wIdx("Id", Idx)).Value);
   Fields(L_WDO.Fld_wIdx("Firm",         Idx)).Visible:=Idx=2;
   Fields(L_WDO.Fld_wIdx("Id",           Idx)).Visible:=0;
   Fields(L_WDO.Fld_wIdx("Firm_Name",    Idx)).Visible:=0;
   Fields(L_WDO.Fld_wIdx("FirmCtc_Name", Idx)).Visible:=0;
   INC(Idx);
  END;
  Fields(L_WDO.Fld_wIdx("Firm", 2)).First:=1;
  RTI.Get().CurWindow.Depth:=10;
 END {FirmCtcR_0_OnZoneOpen};

 PRIVATE PROCEDURE __OnSuccessfulChange();
  VAR
   Fields        : FORM_FIELDS;
   Idx,
   CntNotEmptyIdx,
   MaxNotEmptyIdx: NUMERIC[0];
   NeedVisNextF  : SCAL[2];
   CntAdr        : NUMERIC[0];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Idx   :=L_Prop.GetCurVideoFieldArrIdx();
  IF    L_Prop.GetCurVideoFieldArrName() = "Firm"      THEN
   IF ~!Fields(L_WDO.Fld_wIdx("Firm", Idx)).Value THEN
    SEARCH(Firm, Firm, , Fields(L_WDO.Fld_wIdx("Firm", Idx)).Value);
    CntAdr:=L_ctc.StandOnAnyFCtc_wAdrFct(SYSDATE(), Firm.Firm);
    IF CntAdr = 0 THEN
     L_StdFrm.WrongDB(" ࠣ" +
                      "|" + Firm.Firm + " '" + Firm.Name + "'" +
                      "|" + "   饣 ");
    END;
    Fields(L_WDO.Fld_wIdx("Id", Idx)).Value:=FirmCtc.Id;
    Fields(L_WDO.Fld_wIdx("Id", Idx)).Modifiable:=(CntAdr > 1);
   END;
  ELSIF L_Prop.GetCurVideoFieldArrName() = "Id" THEN
   IF ~!Fields(L_WDO.Fld_wIdx("Id", Idx)).Value THEN
    L_General.CallUs(SEARCH(FirmCtc, Id, Fields(L_WDO.Fld_wIdx("Firm", Idx)).Value, Fields(L_WDO.Fld_wIdx("Id", Idx)).Value));
    CurFirmCtc_StandOnAdr_Fct();
   END;
  END;
  Fields(L_WDO.Fld_wIdx("Firm_Name",    Idx)).Visible:=~!Fields(L_WDO.Fld_wIdx("Firm", Idx)).Value;
  Fields(L_WDO.Fld_wIdx("Id",           Idx)).Visible:=~!Fields(L_WDO.Fld_wIdx("Firm", Idx)).Value;
  Fields(L_WDO.Fld_wIdx("FirmCtc_Name", Idx)).Visible:=~!Fields(L_WDO.Fld_wIdx("Id",   Idx)).Value;
  IF !Fields(L_WDO.Fld_wIdx("Firm", Idx)).Value THEN
   SETEMPTY(Fields(L_WDO.Fld_wIdx("Id",   Idx)).Value);
  END;
  SETZERO(Idx, MaxNotEmptyIdx);
  WHILE Idx < MaxCntFirmInRoute DO
   IF ~!Fields(L_WDO.Fld_wIdx("Id", Idx)).Value THEN
    MaxNotEmptyIdx:=Idx;
   END;
   INC(Idx);
  END; (* WHILE Idx ... *)
  CntNotEmptyIdx:=MaxNotEmptyIdx + 1;
  IF CntNotEmptyIdx <= MaxCntFirmInRoute THEN
   NeedVisNextF:=~!Fields(L_WDO.Fld_wIdx("Id", MaxNotEmptyIdx)).Value;
   Fields(L_WDO.Fld_wIdx("Firm", CntNotEmptyIdx)).Visible:=NeedVisNextF;
   RTI.Get().CurWindow.Depth:=1 + 2 + (CntNotEmptyIdx + NeedVisNextF)*2 + 1;
  END;
 END {__OnSuccessfulChange};

 PUBLIC PROCEDURE TraceRoute();
  VAR
   cntNotEmptyFirm,
   Idx            : NUMERIC[0];
   Fields         : FORM_FIELDS;
   Yandex_RouteStr,
   Google_RouteStr,
   curAdr,
   prevAdr,
   IdxStr         : STRING[];
   curFirm        : LIKE(Firm.Firm);
   curFCtcId      : LIKE(FirmCtc.Id);
   dummy          : SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  SETZERO(Idx, cntNotEmptyFirm);
  SETEMPTY(Yandex_RouteStr, Google_RouteStr, prevAdr, curAdr);
  WHILE Idx < MaxCntFirmInRoute DO
   curFirm  :=Fields(L_WDO.Fld_wIdx("Firm", Idx)).Value;
   curFCtcId:=Fields(L_WDO.Fld_wIdx("Id",   Idx)).Value;
   L_General.Assert(!curFirm = !curFCtcId, "㭪 " + CHR(65+Idx) +"|ࠣ  ⠪ ࠣ|    ६");
   IF ~!curFirm THEN
    L_General.CallUs(SEARCH(FirmCtc, Id, curFirm, curFCtcId));
    dummy:=L_ctc.CurFirmCtc_StandOnAdr_Fct(SYSDATE(), 1);
    L_ctc.curCtcAdr_Set_glb_AdrVar();
    curAdr:=L_ctc.CurCtcAdrForViewInBrowser(L_ctc.m_Yandex);
    L_General.Assert(prevAdr # curAdr, " ᥤ 㭪    묨");
    prevAdr        :=curAdr;
    Yandex_RouteStr:=Yandex_RouteStr + "~"    + curAdr;
    Google_RouteStr:=Google_RouteStr + "+to:" + L_ctc.CurCtcAdrForViewInBrowser(L_ctc.m_Google);
    INC(cntNotEmptyFirm);
   END;
   INC(Idx);
  END;
  L_General.Assert(cntNotEmptyFirm >= 2, " ப  室 稥   2 㭪⮢");
  Yandex_RouteStr:=Str.Slice(Yandex_RouteStr, 1, Str.Length(Yandex_RouteStr) - 1);
  Yandex_RouteStr:=Str.Replace(Yandex_RouteStr, "", ""); (* 19.07.2011 19:35:36 POLAK\San - bug  IE+Yandex *)
(*
  Google_RouteStr:=Str.Slice(Google_RouteStr, 4, Str.Length(Google_RouteStr) - 4);
  Shell.Execute("open", "http://maps.google.ru/maps?saddr=" + Google_RouteStr);
*)
  Shell.Execute("open", "http://maps.yandex.ru/?rt="        + Yandex_RouteStr);
  LIKEMENU(Cancel, "NoSave");
 END {TraceRoute};

 PRIVATE PROCEDURE FirmCtc_OnConformToWindow();
 BEGIN
  IF    (RTI.Get().CurWindow.OriginalName = "RprSO") | (RTI.Get().CurWindow.OriginalName = "RprS") THEN
   ACCESS(RprS);
   IF    L_Rpr.IsRprS_w_OutCar() THEN
    L_Rpr.AccessOrigin();
    CONFORM(OutCar, Firm);
   ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
    L_Rpr.AccessOrigin();
    CONFORM(OutCBlc, Firm);
   ELSE
    SELECT(Firm, Firm); (* 0104938 *)
   END;
   SE_WWD_CURSOR("FirmCtc", Firm);
  ELSIF (RTI.Get().CurWindow.OriginalName = "DsptO") | (RTI.Get().CurWindow.OriginalName = "DsptI")   THEN
   ACCESS(Dspt);
   IF ~!Dspt.Firm THEN
    L_General.CallUs(SEARCH(Firm, Firm, Dspt.Firm));
   ELSE
    SELECT(Firm, Firm); (* 0104938 *)
   END;
   SE_WWD_CURSOR("FirmCtc", Firm);
  END;
 END {FirmCtc_OnConformToWindow};

 PUBLIC PROCEDURE RegNewContactFromFirmCtc();
 BEGIN
  ACCESS(FirmCtc);
  IF ~!FirmCtc.Contact THEN
   L_StdFrm.Choice(" 뫪  ⠪ 㤥 㤠");
   SETEMPTY(FirmCtc.Contact);
   REPLACE(FirmCtc);
  END;
  LIKEMENU(Ins, "ContactE 0 " + ev_InsContactFromInsFirmCtc + "=True");
 END {RegNewContactFromFirmCtc};

 PUBLIC PROCEDURE RegNewContactFromOfficer();
 BEGIN
  ACCESS(Officer);
  IF ~!Officer.Contact THEN
   L_StdFrm.Choice(" 뫪  ⠪ 㤥 㤠");
   SETEMPTY(Officer.Contact);
   REPLACE(Officer);
  END;
  LIKEMENU(Ins, "ContactE 0 " + ev_InsContactFromInsOfficer + "=True");
 END {RegNewContactFromOfficer};

 PUBLIC PROCEDURE CtcAdr_MakeCopy();
 BEGIN
  ACCESS(CtcAdr);
  LIKEMENU(Ins, "@ " + env_curCtcAdr + "=" + CtcAdr.CtcAdr);
 END {CtcAdr_MakeCopy};

 PRIVATE PROCEDURE IsEdgeCtcAdr(Operation: STRING[]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(CtcAdr);
  CHANGESEL(CtcAdr, TypeBeg, , CtcAdr.Contact, CtcAdr.Type);
  Result:=^Operation;
  RESTORE(CtcAdr);
  RETURN Result;
 END {IsEdgeCtcAdr};

 PRIVATE PROCEDURE IsLastCtcAdr(): SCAL[2];
 BEGIN
  RETURN IsEdgeCtcAdr("~NEXT(CtcAdr)");
 END {IsLastCtcAdr};

 PRIVATE PROCEDURE IsFirstCtcAdr(): SCAL[2];
 BEGIN
  RETURN IsEdgeCtcAdr("~PREV(CtcAdr)");
 END {IsFirstCtcAdr};

 PRIVATE PROCEDURE CtcAdr_CheckIsLast();
 BEGIN
  L_General.Assert(IsLastCtcAdr(), "  ᫥   ᭮ ଠ樨|"+
                                   " ⨯ '" + L_Str.PoolItem(L_ctc.cat_Pool, CtcAdr.Type) + "'");
 END {CtcAdr_CheckIsLast};

 PRIVATE PROCEDURE CtcAdr_SetFieldsModifiable();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("CtcAdr.StreetT").Modifiable  :=CtcAdr.PostKind = L_Russia.capk_Stndr;
  Fields("CtcAdr.Street").Modifiable   :=CtcAdr.PostKind = L_Russia.capk_Stndr;
  Fields("CtcAdr.House").Modifiable    :=CtcAdr.PostKind = L_Russia.capk_Stndr;
  Fields("CtcAdr.Block").Modifiable    :=CtcAdr.PostKind = L_Russia.capk_Stndr;
  Fields("CtcAdr.Build").Modifiable    :=CtcAdr.PostKind = L_Russia.capk_Stndr;
  Fields("CtcAdr.Flat").Modifiable     :=CtcAdr.PostKind = L_Russia.capk_Stndr;
  Fields("CtcAdr.PostBox").Modifiable  :=CtcAdr.PostKind = L_Russia.capk_PostBox;
  Fields("CtcAdr.Region").Modifiable   :=CtcAdr.Country  = L_Russia.c_Russia;
  Fields("CtcAdr.RegionN").Modifiable  :=CtcAdr.Country  # L_Russia.c_Russia;
  Fields("CtcAdr.Latitude").Modifiable :=CtcAdr.PostKind = L_Russia.capk_Stndr;
  Fields("CtcAdr.Longitude").Modifiable:=CtcAdr.PostKind = L_Russia.capk_Stndr;
  Fields("CtcAdr.Till").Modifiable     :=IsLastCtcAdr();
 END {CtcAdr_SetFieldsModifiable};

 PRIVATE PROCEDURE CtcAdr_SetFieldsVisible();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("CtcAdr.PostKind").Visible:=CtcAdr.Type     = L_ctc.cat_Pst;
  Fields("CtcAdr.PostBox").Visible :=CtcAdr.PostKind = L_Russia.capk_PostBox;
  Fields("CtcAdr.NotKLADR").Visible:=CtcAdr.Country  = L_Russia.c_Russia;
 END {CtcAdr_SetFieldsVisible};

 PRIVATE PROCEDURE CtcAdr_OnBeforeEdIns();
 BEGIN
  CtcAdr_SetFieldsModifiable();
  CtcAdr_SetFieldsVisible();
 END {CtcAdr_OnBeforeEdIns};

 PRIVATE PROCEDURE CtcAdr_OnBeforeInsert();
  VAR
   curCtcAdr   : LIKE(CtcAdr.CtcAdr);
   trgType     : LIKE(CtcAdr.Type);
   trgCountry  : LIKE(CtcAdr.Country);
   trgRegion   : LIKE(CtcAdr.Region);
   trgRegionN  : LIKE(CtcAdr.RegionN);
   trgZip      : LIKE(CtcAdr.Zip);
   trgDistr    : LIKE(CtcAdr.Distr);
   trgVillageT : LIKE(CtcAdr.VillageT);
   trgVillage  : LIKE(CtcAdr.Village);
   trgTownT    : LIKE(CtcAdr.TownT);
   trgTown     : LIKE(CtcAdr.Town);
   trgStreetT  : LIKE(CtcAdr.StreetT);
   trgStreet   : LIKE(CtcAdr.Street);
   trgHouse    : LIKE(CtcAdr.House);
   trgBlock    : LIKE(CtcAdr.Block);
   trgBuild    : LIKE(CtcAdr.Build);
   trgFlat     : LIKE(CtcAdr.Flat);
   trgNotKLADR : LIKE(CtcAdr.NotKLADR);
   trgLatitude : LIKE(CtcAdr.Latitude);
   trgLongitude: LIKE(CtcAdr.Longitude);
   trgPostBox  : LIKE(CtcAdr.PostBox);
   trgPostKind : LIKE(CtcAdr.PostKind);
   trgComment  : LIKE(CtcAdr.Comment);
   trgTill     : LIKE(CtcAdr.Till);
 BEGIN
  IF ~!L_WDO.AccessEnvVar(env_curCtcAdr) THEN
   curCtcAdr:=L_WDO.GetEnvVarValue(env_curCtcAdr);
   SAVE(CtcAdr);
   SEARCH(CtcAdr, Contact, , CtcAdr.Contact, curCtcAdr);
   trgTill     := CtcAdr.Till;
   trgType     := CtcAdr.Type;
   trgCountry  := CtcAdr.Country;
   trgRegion   := CtcAdr.Region;
   trgRegionN  := CtcAdr.RegionN;
   trgZip      := CtcAdr.Zip;
   trgDistr    := CtcAdr.Distr;
   trgVillageT := CtcAdr.VillageT;
   trgVillage  := CtcAdr.Village;
   trgTownT    := CtcAdr.TownT;
   trgTown     := CtcAdr.Town;
   trgStreetT  := CtcAdr.StreetT;
   trgStreet   := CtcAdr.Street;
   trgHouse    := CtcAdr.House;
   trgBlock    := CtcAdr.Block;
   trgBuild    := CtcAdr.Build;
   trgFlat     := CtcAdr.Flat;
   trgNotKLADR := CtcAdr.NotKLADR;
   trgLatitude := CtcAdr.Latitude;
   trgLongitude:= CtcAdr.Longitude;
   trgPostBox  := CtcAdr.PostBox;
   trgPostKind := CtcAdr.PostKind;
   trgComment  := CtcAdr.Comment;
   RESTORE(CtcAdr);
   IF trgPostKind = L_Russia.capk_Stndr THEN
    CtcAdr.Type    :=trgType;
   END;
   CtcAdr.Till     :=trgTill;
   CtcAdr.Country  :=trgCountry;
   CtcAdr.Region   :=trgRegion;
   CtcAdr.RegionN  :=trgRegionN;
   CtcAdr.Zip      :=trgZip;
   CtcAdr.Distr    :=trgDistr;
   CtcAdr.VillageT :=trgVillageT;
   CtcAdr.Village  :=trgVillage;
   CtcAdr.TownT    :=trgTownT;
   CtcAdr.Town     :=trgTown;
   CtcAdr.StreetT  :=trgStreetT;
   CtcAdr.Street   :=trgStreet;
   CtcAdr.House    :=trgHouse;
   CtcAdr.Block    :=trgBlock;
   CtcAdr.Build    :=trgBuild;
   CtcAdr.Flat     :=trgFlat;
   CtcAdr.NotKLADR :=trgNotKLADR;
   CtcAdr.Latitude :=trgLatitude;
   CtcAdr.Longitude:=trgLongitude;
   CtcAdr.PostBox  :=trgPostBox;
   CtcAdr.PostKind :=trgPostKind;
   CtcAdr.Comment  :=trgComment;
   REPLACE(CtcAdr);
   FIXALTERING();
  END;
  CtcAdr_OnBeforeEdIns();
 END {CtcAdr_OnBeforeInsert};

 PRIVATE PROCEDURE CtcAdr_OnBeforeEdit();
 BEGIN
  CtcAdr_OnBeforeEdIns();
 END {CtcAdr_OnBeforeEdit};

 PRIVATE PROCEDURE CtcAdr_Begin_Replicate(prevBegin, curBegin: DATE);
 BEGIN
  SAVE(CtcAdr);
  CHANGESEL(CtcAdr, TypeBeg, , CtcAdr.Contact, CtcAdr.Type);
  IF PREV(CtcAdr) THEN
   IF !CtcAdr.Till | (~!prevBegin & (CtcAdr.Till = prevBegin))THEN
    CtcAdr.Till:=curBegin;
    REPLACE(CtcAdr);
   ELSE
    L_General.Assert(~L_DatTim.IsActive(curBegin, CtcAdr.Begin, CtcAdr.Till),
                     L_DatTim.DateStr(curBegin) + "|  ਮ ਬ (" + L_DatTim.DateStr(CtcAdr.Begin) + " - " + L_DatTim.DateStr(CtcAdr.Till) +  ")|।饩   ᭮ ଠ樨");
   END;
  END;
  RESTORE(CtcAdr);
 END {CtcAdr_Begin_Replicate};

 PRIVATE PROCEDURE CtcAdr_OnBeforeDelete();
 BEGIN
  CtcAdr_CheckIsLast();
  CtcAdr_Begin_Replicate(CtcAdr.Begin, EMPTYOF(DATE));
 END {CtcAdr_OnBeforeDelete};

 PRIVATE PROCEDURE CtcAdrE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Firm";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iField       (0, "CtcAdr.Village").OnBeforeAsk:=1;
  L_WDO.iField       (0, "CtcAdr.Town").OnBeforeAsk:=1;
  L_WDO.iField       (0, "CtcAdr.Street").OnBeforeAsk:=1;
  L_WDO.iField       (0, "CtcAdr.Distr").OnBeforeAsk:=1;
  L_WDO.iScsChange   (0, ["CtcAdr.Begin", "CtcAdr.RegionN", "CtcAdr.Region", "CtcAdr.Country", "CtcAdr.PostKind", "CtcAdr.Type"]);
  L_WDO.iMayBeEmpty  (0, ["CtcAdr.Till", "CtcAdr.TownT", "CtcAdr.VillageT", "CtcAdr.StreetT", "CtcAdr.Village", "CtcAdr.Town", "CtcAdr.Street", "CtcAdr.Comment", "CtcAdr.House", "CtcAdr.Build", "CtcAdr.Block", "CtcAdr.Flat", "CtcAdr.Longitude", "CtcAdr.Latitude", "CtcAdr.Distr", "CtcAdr.RegionN", "CtcAdr.Zip", "CtcAdr.PostBox"]);
  L_WDO.iField       (0, "CtcAdr.Type").Format    :=L_ctc.cat_Pool;
  L_WDO.iField       (0, "CtcAdr.PostKind").Format:=L_Russia.capk_Pool;
  L_WDO.iField       (0, "CtcAdr.TownT").Format   :=L_Russia.c_TownT;
  L_WDO.iField       (0, "CtcAdr.VillageT").Format:=L_Russia.c_VillageT;
  L_WDO.iField       (0, "CtcAdr.StreetT").Format :=L_Russia.c_StreetT;
  L_WDO.iProgs       (0, "Contact");
 END {CtcAdrE_OnInitializeWindow};

 PRIVATE PROCEDURE CtcAdr_Any_OnSuccessfulChange();
 BEGIN
  CtcAdr_SetFieldsModifiable();
  CtcAdr_SetFieldsVisible();
 END {CtcAdr_Any_OnSuccessfulChange};

 PRIVATE PROCEDURE CtcAdr_ClearSomeFieldsForSomePostKind(NeedAsk: SCAL[2]);
  VAR
   FieldsList: STRING[];
 BEGIN
  SETEMPTY(FieldsList);
  IF (CtcAdr.PostKind = L_Russia.capk_PostRest) | (CtcAdr.PostKind = L_Russia.capk_PostBox) THEN
   IF ~!CtcAdr.Street | ~!CtcAdr.StreetT THEN
    SETEMPTY(CtcAdr.Street, CtcAdr.StreetT); INC(FieldsList, " ");
   END;
   IF ~!CtcAdr.House THEN
    SETEMPTY(CtcAdr.House); INC(FieldsList, " ");
   END;
   IF ~!CtcAdr.Block THEN
    SETEMPTY(CtcAdr.Block); INC(FieldsList, " ");
   END;
   IF ~!CtcAdr.Build THEN
    SETEMPTY(CtcAdr.Build); INC(FieldsList, "஥ ");
   END;
   IF ~!CtcAdr.Flat THEN
    SETEMPTY(CtcAdr.Flat); INC(FieldsList, " ");
   END;
   IF ~!CtcAdr.Latitude THEN
    SETEMPTY(CtcAdr.Latitude); INC(FieldsList, " ");
   END;
   IF ~!CtcAdr.Longitude THEN
    SETEMPTY(CtcAdr.Longitude); INC(FieldsList, " ");
   END;
  END;
  IF (CtcAdr.PostKind # L_Russia.capk_PostBox) THEN
   IF ~!CtcAdr.PostBox THEN
    SETEMPTY(CtcAdr.PostBox);  INC(FieldsList, "᪨ 騪 ");
   END;
  END;
  IF ~!FieldsList THEN
   IF NeedAsk THEN
    L_StdFrm.Question(" 饭 :||" + FieldsList);
   END;
   REPLACE(CtcAdr);
  END;
 END {CtcAdr_ClearSomeFieldsForSomePostKind};

 PRIVATE PROCEDURE PrevCtcAdr(): LIKE(CtcAdr.CtcAdr);
  VAR
   Result: LIKE(CtcAdr.CtcAdr);
 BEGIN
  SAVE(CtcAdr);
  CHANGESEL(CtcAdr, Type, , CtcAdr.Contact, CtcAdr.Type);
  IF PREV(CtcAdr) THEN
   Result:=CtcAdr.CtcAdr;
  ELSE
   SETEMPTY(Result);
  END;
  RESTORE(CtcAdr);
  RETURN Result;
 END {PrevCtcAdr};

 PRIVATE PROCEDURE CtcAdr_Type_OnSuccessfulChange();
  VAR
   trgType: LIKE(CtcAdr.Type);
 BEGIN
  TRY [ABORT_AFTER(AA_ON)]
   IF ~!GE_PVALUE() THEN
    CtcAdr.Type:=GE_PVALUE();
    REPLACE(CtcAdr);
    CtcAdr_CheckIsLast();
   END;
  EXCEPT
  END; (* TRY *)
  IF IsFirstCtcAdr() THEN
   CONFORM(CtcAdr, Contact);
   CtcAdr.Begin:=Contact.Begin;
  ELSE
   CtcAdr.Begin:=SYSDATE();
  END;
  REPLACE(CtcAdr);
  CtcAdr_CheckIsLast();
  IF CtcAdr.PostKind # L_Russia.capk_Stndr THEN
   CtcAdr.PostKind:= L_Russia.capk_Stndr;
   REPLACE(CtcAdr);
  END;
  IF ~!GE_PVALUE() THEN
   trgType:=CtcAdr.Type;
   CtcAdr.Type:=GE_PVALUE();
   REPLACE(CtcAdr);
   CtcAdr_Begin_Replicate(CtcAdr.Begin, EMPTYOF(DATE));
   CtcAdr.Type:=trgType;
   REPLACE(CtcAdr);
  END;
  CtcAdr_Begin_Replicate(EMPTYOF(DATE), CtcAdr.Begin);
  CtcAdr_ClearSomeFieldsForSomePostKind(1);
  CtcAdr_Any_OnSuccessfulChange();
 END {CtcAdr_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE CtcAdr_PostKind_OnSuccessfulChange();
 BEGIN
  CtcAdr_ClearSomeFieldsForSomePostKind(1);
  CtcAdr_Any_OnSuccessfulChange();
 END {CtcAdr_PostKind_OnSuccessfulChange};

 PRIVATE PROCEDURE CtcAdr_Ask(Lev: LIKE(KlAdr.Level); VAR trgName: LIKE(KlAdr.Name); VAR trgType: LIKE(KlAdr.Type));
 BEGIN
  L_Russia.CheckKLADRState();
  L_Russia.Set_glb_AdrVar(CtcAdr.Country, CtcAdr.Zip, CtcAdr.Region, CtcAdr.RegionN, CtcAdr.Distr, CtcAdr.Town, CtcAdr.Village,
                          CtcAdr.Street, CtcAdr.TownT, CtcAdr.VillageT, CtcAdr.StreetT, CtcAdr.House,
                          CtcAdr.Block, CtcAdr.Build, CtcAdr.Flat, CtcAdr.PostBox, CtcAdr.PostKind, CtcAdr.Begin);
  L_Russia.PosToFieldKlAdr(Lev);
  IF (KlAdr.Name # trgName) | (KlAdr.Type # trgType) THEN
   trgName:=KlAdr.Name;
   trgType:=KlAdr.Type;
   REPLACE(CtcAdr);
  END;
 END {CtcAdr_Ask};

 PRIVATE PROCEDURE CtcAdr_Distr_OnBeforeAsk();
  VAR
   dmyType: LIKE(KlAdr.Type);
 BEGIN
  SETEMPTY(dmyType);
  CtcAdr_Ask(L_Russia.lv_District, CtcAdr.Distr, dmyType);
 END {CtcAdr_Distr_OnBeforeAsk};

 PRIVATE PROCEDURE CtcAdr_Town_OnBeforeAsk();
 BEGIN
  CtcAdr_Ask(L_Russia.lv_City, CtcAdr.Town, CtcAdr.TownT);
 END {CtcAdr_Town_OnBeforeAsk};

 PRIVATE PROCEDURE CtcAdr_Village_OnBeforeAsk();
 BEGIN
  CtcAdr_Ask(L_Russia.lv_Village, CtcAdr.Village, CtcAdr.VillageT);
 END {CtcAdr_Village_OnBeforeAsk};

 PRIVATE PROCEDURE CtcAdr_Street_OnBeforeAsk();
 BEGIN
  CtcAdr_Ask(L_Russia.lv_Street, CtcAdr.Street, CtcAdr.StreetT);
 END {CtcAdr_Street_OnBeforeAsk};

 PRIVATE PROCEDURE CtcAdr_Country_OnSuccessfulChange();
 BEGIN
  L_Russia.Check_MayChooseCountry("CtcAdr", CtcAdr.Country);
  IF ~!CtcAdr.Country THEN
   CONFORM(CtcAdr, Country);
   IF ~!Country.EndDate THEN
    L_General.Assert(Country.EndDate >= CtcAdr.Till, "᫥ " + L_DatTim.DateStr(Country.EndDate) + " ⨬ 㪠뢠  ࠭ "+CtcAdr.Country);
   END;
  END;
  IF GE_PVALUE() = L_Russia.c_Russia THEN
   CtcAdr.Region:= 00;
   SETEMPTY(CtcAdr.NotKLADR);
   REPLACE(CtcAdr);
  END;
  CtcAdr_Any_OnSuccessfulChange();
 END {CtcAdr_Country_OnSuccessfulChange};

 PRIVATE PROCEDURE CtcAdr_Region_OnSuccessfulChange();
 BEGIN
  IF ~!CtcAdr.Region THEN
   IF CtcAdr.Region # 00 THEN
    CONFORM(CtcAdr, Region);
    CtcAdr.RegionN:=Region.Name;
    REPLACE(CtcAdr);
   END;
  END;
  CtcAdr_Any_OnSuccessfulChange();
 END {CtcAdr_Region_OnSuccessfulChange};

 PRIVATE PROCEDURE CtcAdr_RegionN_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!CtcAdr.Country, "砫 㪠 ࠭");
  L_General.Assert(CtcAdr.Country # L_Russia.c_Russia, "⨬   ॣ ᨨ");
  CtcAdr_Any_OnSuccessfulChange();
 END {CtcAdr_RegionN_OnSuccessfulChange};

 PUBLIC PROCEDURE CtcAdr_SetZip();
 BEGIN
  L_Russia.Set_glb_AdrVar(CtcAdr.Country, CtcAdr.Zip, CtcAdr.Region, CtcAdr.RegionN, CtcAdr.Distr,
                          CtcAdr.Town, CtcAdr.Village, CtcAdr.Street, CtcAdr.TownT, CtcAdr.VillageT,
                          CtcAdr.StreetT, CtcAdr.House, CtcAdr.Block, CtcAdr.Build, CtcAdr.Flat, CtcAdr.PostBox, CtcAdr.PostKind, CtcAdr.Begin);
  CtcAdr.Zip:=L_Russia.GetZipByKlAdr();
  REPLACE(CtcAdr);
 END {CtcAdr_SetZip};

 PUBLIC PROCEDURE CtcAdr_SetByZip();
  VAR
   dummyD: DATE;
 BEGIN
  L_StdFrm.Question("    ?");
  L_Russia.Set_glb_AdrVar(CtcAdr.Country, CtcAdr.Zip, CtcAdr.Region, CtcAdr.RegionN, CtcAdr.Distr,
                          CtcAdr.Town, CtcAdr.Village, CtcAdr.Street, CtcAdr.TownT, CtcAdr.VillageT,
                          CtcAdr.StreetT, CtcAdr.House, CtcAdr.Block, CtcAdr.Build, CtcAdr.Flat, CtcAdr.PostBox, CtcAdr.PostKind, CtcAdr.Begin);
  L_Russia.SetAdrByZip(CtcAdr.Zip);
  L_Russia.Get_glb_AdrVar(CtcAdr.Country, CtcAdr.Zip, CtcAdr.Region, CtcAdr.RegionN, CtcAdr.Distr,
                          CtcAdr.Town, CtcAdr.Village, CtcAdr.Street, CtcAdr.TownT, CtcAdr.VillageT,
                          CtcAdr.StreetT, CtcAdr.House, CtcAdr.Block, CtcAdr.Build, CtcAdr.Flat, CtcAdr.PostBox, CtcAdr.PostKind, dummyD);
  REPLACE(CtcAdr);
  CtcAdr_ClearSomeFieldsForSomePostKind(0);
  CtcAdr_Any_OnSuccessfulChange();
 END {CtcAdr_SetByZip};

 PRIVATE PROCEDURE CtcAdr_GetKLADRLev():LIKE(KlAdr.Level);
 BEGIN
  IF CtcAdr.PostKind = L_Russia.capk_Stndr THEN
   RETURN L_Russia.lv_All;
  ELSE
   RETURN L_Russia.lv_Village;
  END;
 END {CtcAdr_GetKLADRLev};

 PRIVATE PROCEDURE intCheckAdr(InformType, OnAfterEdIns: SCAL[2]);
 BEGIN
  L_Russia.Set_glb_AdrVar(CtcAdr.Country, CtcAdr.Zip, CtcAdr.Region, CtcAdr.RegionN, CtcAdr.Distr,
                          CtcAdr.Town, CtcAdr.Village, CtcAdr.Street, CtcAdr.TownT, CtcAdr.VillageT,
                          CtcAdr.StreetT, CtcAdr.House, CtcAdr.Block, CtcAdr.Build, CtcAdr.Flat, CtcAdr.PostBox, CtcAdr.PostKind, CtcAdr.Begin);
  L_Russia.TestAdr(L_Russia.ao_CtcAdr, CtcAdr.Type, CtcAdr.PostKind);

  IF L_Russia.intCheckKLADRState(OnAfterEdIns) THEN
   L_Russia.CheckAdrByKlAdr(InformType, CtcAdr.NotKLADR, CtcAdr_GetKLADRLev());
  END;
 END {intCheckAdr};

 PUBLIC PROCEDURE CtcAdr_Check();
 BEGIN
  intCheckAdr(L_Russia.tit_Choice, 0);
 END {CtcAdr_Check};

 PRIVATE PROCEDURE CtcAdr_CheckThatSequenceWasChange();
  VAR
   curPrevCtcAdr,
   oldPrevCtcAdr: LIKE(CtcAdr.CtcAdr);
 BEGIN
  curPrevCtcAdr:=PrevCtcAdr();
  TRY [ABORT_AFTER(AA_ON)]
   CtcAdr.Begin:=GE_PVALUE();
   REPLACE(CtcAdr);
   oldPrevCtcAdr:=PrevCtcAdr();
  EXCEPT
  END; (* TRY *)
  IF curPrevCtcAdr # oldPrevCtcAdr THEN
   L_General.Error("  冷 ᫥ ᥩ  ᭮ ଠ樨");
  END;
 END {CtcAdr_CheckThatSequenceWasChange};

 PRIVATE PROCEDURE CtcAdr_Begin_OnSuccessfulChange();
 BEGIN
  CtcAdr_CheckThatSequenceWasChange();
  CtcAdr_Begin_Replicate(GE_PVALUE(), CtcAdr.Begin);
 END {CtcAdr_Begin_OnSuccessfulChange};

 PUBLIC PROCEDURE CtcAdr_OnAfterEdIns();
 BEGIN
  L_DBD.CheckValidity("CtcAdr");

  IF CtcAdr.PostKind = L_Russia.capk_PostBox THEN
   L_General.Assert(~!CtcAdr.PostBox, "  '᪨ 騪'");
  END;
  L_General.Assert(~!CtcAdr.Latitude = ~!CtcAdr.Longitude, "   /  ");

  intCheckAdr(L_Russia.tit_Error, 1);
 END {CtcAdr_OnAfterEdIns};

 PRIVATE PROCEDURE CtcAdr_OnAfterEdit();
 BEGIN
  CtcAdr_OnAfterEdIns();
 END {CtcAdr_OnAfterEdit};

 PRIVATE PROCEDURE CtcAdr_OnAfterInsert();
 BEGIN
  CtcAdr_OnAfterEdIns();
 END {CtcAdr_OnAfterInsert};

 PRIVATE PROCEDURE BeforeReplaceCtcAdrContact();
 BEGIN
  L_General.CallUs(ACCESS(Contact));
  L_SysLog.SingleMark_BeforeDelete("CtcAdr");
 END {BeforeReplaceCtcAdrContact};

 PRIVATE PROCEDURE ReplaceCtcAdrContact(trgContact: LIKE(Contact.Contact));
 BEGIN
  SEARCH(Contact, Contact, , trgContact);
  CtcAdr.Contact:=Contact.Contact;
  SETEMPTY(CtcAdr.CtcAdr);
  REPLACE(CtcAdr);
  L_SysLog.SingleMark_AfterInsert("CtcAdr");
 END {ReplaceCtcAdrContact};

 PUBLIC PROCEDURE MoveCurCtcAdrToParentFirmCtc();
 BEGIN
  ACCESS(CtcAdr);
  ACCESS(FirmCtc);
  L_General.Assert(FirmCtcHasParent(), "騩 ⠪ ࠣ 室  孥 ஢ 娨");
  BeforeReplaceCtcAdrContact();
  SAVE(FirmCtc);
  SEARCH(FirmCtc, Id, , FirmCtc.Firm, FirmCtc.Parent);
  ReplaceCtcAdrContact(FirmCtc.Contact);
  RESTORE(FirmCtc);
 END {MoveCurCtcAdrToParentFirmCtc};

 PUBLIC PROCEDURE MoveCurCtcAdrToChildFirmCtc();
  VAR
   ChildId    : LIKE(FirmCtc.Id);
   ChildList,
   ChildIdList: STRING[];
   curLevel   : NUMERIC[0];
 BEGIN
  ACCESS(CtcAdr);
  ACCESS(FirmCtc);
  L_General.Assert(L_ctc.FirmCtcHasChild(), "騩 ⠪ ࠣ 室   ஢ 娨");
  BeforeReplaceCtcAdrContact();
  SETEMPTY(ChildList, ChildIdList);
  curLevel:=0;
  GetChildrenList(FirmCtc.Firm, FirmCtc.Id, 1, ChildList, ChildIdList, curLevel);
  ChildId:=L_Str.PoolItem(ChildIdList, L_StdFrm.ShowListAsMenu(ChildList, "롮 ⠪ ࠣ"));
  SAVE(FirmCtc);
  SEARCH(FirmCtc, Id, , FirmCtc.Firm, ChildId);
  CONFORM(FirmCtc, Contact);
  ReplaceCtcAdrContact(FirmCtc.Contact);
  RESTORE(FirmCtc);
 END {MoveCurCtcAdrToChildFirmCtc};

 PRIVATE PROCEDURE FirmCtcR_OnConformToWindow();
 BEGIN
  (* nothing *)
 END {FirmCtcR_OnConformToWindow};

BEGIN
 L_Events.ExecuteHandler();
END.
