(*
%Copyright   (c) Polak Computer System
%Author      02.08.2001 17:13:47 SAN
%Purpose     ஫ 䨪樨 ஢
%Type        control
%Specific    SYS
%Modified    22.09.2014 17:53:04 POLAK\LDA
%Environment
*)

 MODULE Contract [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_XObj, P_Firm, L_Str, L_Pmnt, L_XDoc, L_Stock,
        L_MDoc, L_PDoc, L_StdFrm, L_DatTim, L_AFM, L_Acnt, Str, Memo,
        L_WDO, P_Cntr, L_Prop, L_Cntr, L_OwnData, L_APtm, L_AR, L_AcsPnt,
        Math, L_lsStore, L_DBD;

 PRIVATE TYPE
  tContractShowMode = SCAL[4];

 PRIVATE CONST
  csm_FirmName             = 0;
  csm_SrcNbr               = 1;
  csm_CntrT                = 2;
  csm_ContractTemplateName = 3;

  csm_Pool = "᪨   ࠣ⮢|쪮   室 ஬|᪨    ஢|᪨   蠡 ஢";

 PRIVATE PROCEDURE t_OnAfterModification_CntrPro();
 BEGIN
  CALL(ObjPro.UpdateVal2Show("CntrPro"));
 END {t_OnAfterModification_CntrPro};

 PUBLIC PROCEDURE t_OnAfterInsert_CntrPro();
 BEGIN
  t_OnAfterModification_CntrPro();
 END {t_OnAfterInsert_CntrPro};

 PRIVATE PROCEDURE t_OnAfterReplace_CntrPro();
 BEGIN
  t_OnAfterModification_CntrPro();
 END {t_OnAfterReplace_CntrPro};

 PRIVATE PROCEDURE ModifyProExtraProc();
 BEGIN
  IF CntrPro.Property = P_Cntr.P_CntrAddendum THEN
   IF ~!CntrPro.Value THEN
    CntrPro.Value:=L_lsStore.Insert(L_lsStore.Get(CntrPro.Value));
    REPLACE(CntrPro);
   END;
  END;
 END {ModifyProExtraProc};

 PRIVATE PROCEDURE csm_GetFilter(Mode: tContractShowMode; defaultFilter: STRING[]): STRING[];
 BEGIN
  defaultFilter:=L_Str.AddStrDlm(defaultFilter, "&");
  IF    Mode =  csm_FirmName THEN
   RETURN  defaultFilter + "(Contract.iiType#1)&(Contract.iiType#2)";
  ELSIF Mode =  csm_SrcNbr THEN
   RETURN  defaultFilter + "(Contract.iiType=0)";
  ELSIF Mode =  csm_CntrT THEN
   RETURN  defaultFilter + "(Contract.iiType#1)&(Contract.iiType#3)";
  ELSIF Mode = csm_ContractTemplateName THEN
   RETURN  defaultFilter + "(Contract.iiType#2)&(Contract.iiType#3)";
  END;
 END {csm_GetFilter};

 PRIVATE PROCEDURE csm_GetMode(): tContractShowMode;
  VAR
   Value: STRING[];
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Value:=Str.Replace(L_WDO.getActiveForm().Zones(0).Fields("csm_Name").Value, CHR(255), "");
   Value:=Str.Condense(Str.Item(Value, "(", 0));
   RETURN L_Str.PositionInPool(csm_Pool, Value);
  EXCEPT
  ON Exc:Exc_RunTime DO
   IF Exc.ErrorCode = 154 THEN
    RETURN csm_ContractTemplateName;
   ELSE
    RAISE();
   END;
  END; (* TRY *)
 END {csm_GetMode};

 PRIVATE TYPE
  tWindowMode = SCAL[3];

 PRIVATE CONST
  wm_View        = 0;
  wm_Ask_Usual   = 1;
  wm_Ask_hParent = 2;

 PRIVATE PROCEDURE GetContractWindowMode(): tWindowMode;
 BEGIN
  IF L_WDO.IsLoadableAskClone() THEN
   IF (L_WDO.getActiveForm().AskSourceField.Name = "Contract.Parent") |
      (L_WDO.getActiveForm().AskSourceField.Name = "ParentContract") (*   *) THEN
    RETURN wm_Ask_hParent;
   ELSE
    RETURN wm_Ask_Usual;
   END;
  ELSE
   RETURN wm_View;
  END;
 END {GetContractWindowMode};

 PRIVATE PROCEDURE Contract_1_ChangeMainField(Mode: tContractShowMode);
  CONST
   fName   = "Main";
   fAddInf = "AddInf";
  VAR
   trgZone       : FORM_ZONE;
   mainField     : FORM_FIELD;
   _Filter,
   hl_Filter     : STRING[];
 BEGIN
  IF RTI.Get().CurWindow.OriginalName # "Contract" THEN
   L_StdFrm.BlueStop("    ।ᬮ७  ० ⮡ࠦ  ᪠");
  END;
  trgZone:=RTI.Get().CurWindow.Zones(1);
  mainField:=trgZone.Fields(fName);
  trgZone.BanHierarchicView         :=0;
  trgZone.ShowLeavesInHierarchicView:=1;
  _Filter:="";
  IF    Mode = csm_FirmName THEN
   L_WDO.SetFieldExpression_wTitle(1, fName,   "Contract.Name",     "");
   L_WDO.SetFieldExpression_wTitle(1, fAddInf, "Contract.SrcNbr",   "室 ");
   trgZone.HierarchicLink:=LINK.Get("Contract", "prnFirm");
  ELSIF Mode = csm_SrcNbr THEN
   L_WDO.SetFieldExpression_wTitle(1, fName,   "Contract.SrcNbr", "室 ");
   L_WDO.SetFieldExpression_wTitle(1, fAddInf, "Contract.Name",   " ");
   trgZone.BanHierarchicView:=1;
   IF GetContractWindowMode() # wm_Ask_Usual THEN
    _Filter:="(~!Contract.SrcNbr)";
   END;
  ELSIF Mode = csm_CntrT THEN
   L_WDO.SetFieldExpression_wTitle(1, fName,   "Contract.Name",   "");
   L_WDO.SetFieldExpression_wTitle(1, fAddInf, "Contract.AddInf", "⥫쭠 ଠ");
   trgZone.HierarchicLink:=LINK.Get("Contract", "prnCntrT");
  ELSIF Mode = csm_ContractTemplateName THEN
   L_WDO.SetFieldExpression_wTitle(1, fName,   "Contract.Name",   "");
   L_WDO.SetFieldExpression_wTitle(1, fAddInf, "Contract.AddInf", "⥫쭠 ଠ");
   trgZone.HierarchicLink:=LINK.Get("Contract", "Parent");
   IF GetContractWindowMode() = wm_Ask_hParent THEN
    trgZone.ShowLeavesInHierarchicView:=0;
    _Filter:="(Contract.Leaf=0)";
   END;
  END;
  trgZone.PermanentFilter:=csm_GetFilter(Mode, _Filter);
  RTI.Get().CurWindow.Zones(0).Fields("csm_Name").Value:=CHR(255) + L_Str.PoolItem(csm_Pool, Mode) + " (F4)" + CHR(255);
  IF    Mode = csm_FirmName THEN
   mainField.AskMode:=FORM_FIELD.AskMode_Manual;
   mainField.OwnerWindowOriginalName:="Firm";
   mainField.OwnerZoneNumber        :=1;
  ELSIF Mode = csm_CntrT THEN
   mainField.AskMode:=FORM_FIELD.AskMode_Manual;
   mainField.OwnerWindowOriginalName:="CntrT";
   mainField.OwnerZoneNumber        :=1;
  ELSE
   mainField.AskMode:=FORM_FIELD.AskMode_System;
   mainField.OwnerWindowOriginalName:="";
  END;
 END {Contract_1_ChangeMainField};

 PRIVATE PROCEDURE Contract_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Contract";
  L_WDO.iField       (0, "v_Parent").LineBreakEnable:=1;
  L_WDO.iField       (0, "CntrT.Type").Format:=L_Cntr.ct_Pool;
  L_WDO.iField       (0, "csm_Name").FontSize:=FORM_FIELD.fs_Small;
  L_WDO.iField       (0, "Contract.iiType").Format:=L_Cntr.iit_Pool;
  L_WDO.iEvents      (1, [L_WDO.e_OnReposition, L_WDO.e_OnOpenZone, L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).HierarchicLink:=LINK.Get("Contract", "Parent");
  L_WDO.iField       (1, "Main").Hierarchic:=1;
  IF GetContractWindowMode() = wm_Ask_hParent THEN
   Contract_1_ChangeMainField(csm_ContractTemplateName);
  ELSE
   Contract_1_ChangeMainField(csm_FirmName);
  END;
 END {Contract_OnInitializeWindow};

 PRIVATE PROCEDURE SetFieldVisible(Name: STRING[]; Visible: SCAL[2]);
  VAR
   f: FORM_FIELD;
 BEGIN
  f:=RTI.Get().CurZone.Fields(Name);
  IF ~!f THEN
   f.Visible:=Visible;
  END;
 END {SetFieldVisible};

 PRIVATE PROCEDURE setFieldValue(Name: STRING[]; Value: ANYTYPE);
 BEGIN
  RTI.Get().CurWindow.Zones(0).Fields(Name).Value:=Value;
 END {setFieldValue};

 PRIVATE PROCEDURE Contract_1_OnReposition();
  VAR
   ffv_SrcNbr,
   ffv_CntrT,
   ffv_Firm,
   ffv_Parent : SCAL[2];
   ParentAsStr,
   ParentPrfx : STRING[];
   Cnt        : NUMERIC[0];
 BEGIN
  SETZERO(ffv_SrcNbr, ffv_CntrT, ffv_Firm, ffv_Parent);
  IF ACCESS(Contract) THEN
   ffv_SrcNbr:=Contract.iiType = 0(*L_Cntr.iit_Contract*);
   ffv_CntrT :=Contract.iiType # 3(*L_Cntr.iit_FirmGroup*);
   ffv_Firm  :=(Contract.iiType = 0(*L_Cntr.iit_Contract*)) | (Contract.iiType = 3(*L_Cntr.iit_FirmGroup*));
   ffv_Parent:=(Contract.iiType = 0(*L_Cntr.iit_Contract*)) | (Contract.iiType = 1(*L_Cntr.iit_ContractTemplate*));
  END;

  setFieldValue("v_SrcNbr_Title" , "室 ");
  SetFieldVisible("v_SrcNbr_Title",  ffv_SrcNbr);
  SetFieldVisible("Contract.SrcNbr", ffv_SrcNbr);

  setFieldValue("v_Date_Title" , "");
  SetFieldVisible("v_Date_Title",  ffv_SrcNbr);
  SetFieldVisible("Contract.Date", ffv_SrcNbr);

  setFieldValue("v_CntrT_Title" , " ");
  SetFieldVisible("v_CntrT_Title",  ffv_CntrT);
  SetFieldVisible("Contract.CntrT", ffv_CntrT);
  SetFieldVisible("CntrT.Name",     ffv_CntrT);
  SetFieldVisible("CntrT.Type",     ffv_CntrT);

  setFieldValue("v_Firm_Title" , "ࠣ");
  SetFieldVisible("v_Firm_Title",  ffv_Firm);
  SetFieldVisible("Contract.Firm", ffv_Firm);
  SetFieldVisible("Firm.Name",     ffv_Firm);
  SetFieldVisible("Firm._INN",     ffv_Firm);

  setFieldValue("v_Parent_Title" , "");
  ParentAsStr:="";
  IF ffv_Parent THEN
   Cnt:=0;
   SAVE(Contract);
   WHILE ~!Contract.Parent & (Cnt < 3) DO
    SEARCH(Contract, Contract, , Contract.Parent);
    INC(Cnt);
   END;
   RESTORE(Contract);
   SAVE(Contract);
   WHILE ~!Contract.Parent & (Cnt > 0) DO
    DEC(Cnt);
    SEARCH(Contract, Contract, , Contract.Parent);
    ParentAsStr:=Str.Slice("       ", 0, Cnt) + Str.Slice(Contract.Name, 0, 80) + CHR(13)+CHR(10) + ParentAsStr;
   END;
   RESTORE(Contract);
  ELSE
   setFieldValue("v_Parent" , "");
  END;
  setFieldValue("v_Parent" , ParentAsStr);

  SetFieldVisible("v_Parent_Title", ffv_Parent);
  SetFieldVisible("v_Parent", ffv_Parent);

  IF GetContractWindowMode() = wm_View THEN
   IF ACCESS(Contract) THEN
    IF Contract.Leaf = 1 THEN
     RTI.Get().CurProcess.ReplaceContexts("View_Contract_1_RCD_Contract");
    ELSE
     IF    Contract.iiType = 1(*L_Cntr.iit_ContractTemplate*) THEN
      RTI.Get().CurProcess.ReplaceContexts("View_Contract_1_RCD_Template");
     ELSIF Contract.iiType = 3(*L_Cntr.iit_FirmGroup*) THEN
      RTI.Get().CurProcess.ReplaceContexts("View_Contract_1_RCD_FirmGroup");
     ELSE
      RTI.Get().CurProcess.ReplaceContexts("View_Contract_1_RCD_Group");
     END;
    END;
   ELSE
    RTI.Get().CurProcess.ReplaceContexts("View_Contract_1_RCD_Group");
   END;
  END; (* IF ... *)
 END {Contract_1_OnReposition};

 PRIVATE PROCEDURE Contract_1_OnZoneOpen();
 BEGIN
  IF ~ACCESS(Contract) THEN
   RTI.Get().CurProcess.ReplaceContexts("View_Contract_1_RCD_Group");
  END;
 END {Contract_1_OnZoneOpen};

 PRIVATE PROCEDURE GetSubWindowName(forcedType: LIKE(Contract.iiType)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF !forcedType THEN
   IF ACCESS(Contract) THEN
    forcedType:=Contract.iiType;
   ELSE
    forcedType:=L_Cntr.iit_ContractTemplate;
   END;
  END;
  SETEMPTY(Result);
  IF    forcedType = L_Cntr.iit_Contract THEN
   Result:="CntrE";
  ELSIF forcedType = L_Cntr.iit_ContractTemplate THEN
   Result:="TplCntrE";
  ELSIF forcedType = L_Cntr.iit_FirmGroup THEN
   Result:="FirmAcnt";
  ELSE
   L_StdFrm.BlueStop("㯯஢    ᬮ / 䨪樨");
  END;
  RETURN Result;
 END {GetSubWindowName};

 PRIVATE PROCEDURE AnyContract_OnSetSubwindow();
  VAR
   SubWindow: STRING[];
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert THEN
   IF L_WDO.InHierarchyInsMode() |
      (~!L_WDO.GetInsertionSource() & ACCESS(Contract) & (Contract.iiType = L_Cntr.iit_ContractTemplate)) THEN
    SubWindow:=GetSubWindowName(L_Cntr.iit_ContractTemplate);
   ELSE
    SubWindow:=GetSubWindowName(L_Cntr.iit_Contract);
   END;
  ELSE
   SubWindow:=GetSubWindowName(EMPTYOF(Contract.iiType));
  END;
  RTI.Get().CurZone.HasVariousSubwindows :=1;
  RTI.Get().CurZone.SubwindowOriginalName:=SubWindow;
  RTI.Get().CurZone.SubwindowAssignedName:=SubWindow + "<" + RTI.Get().CurWindow.AssignedName + ">";
  APP.Get().Forms.Load(RTI.Get().CurZone.SubwindowOriginalName, RTI.Get().CurZone.SubwindowAssignedName).Zones(0).OnReposition:=1;
 END {AnyContract_OnSetSubwindow};

 PRIVATE PROCEDURE Contract_1_OnSetSubwindow();
 BEGIN
  AnyContract_OnSetSubwindow();
 END {Contract_1_OnSetSubwindow};

 PRIVATE PROCEDURE FirmCntr_1_OnSetSubwindow();
 BEGIN
  AnyContract_OnSetSubwindow();
 END {FirmCntr_1_OnSetSubwindow};

 PRIVATE PROCEDURE Contract2_2_OnSetSubwindow();
 BEGIN
  AnyContract_OnSetSubwindow();
 END {Contract2_2_OnSetSubwindow};

(*
 PRIVATE PROCEDURE Contract2_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Contract";
  L_WDO.iZone        (1).HierarchicLink:=LINK.Get("Contract", "Parent");
  L_WDO.iSubwindow   (1, "TplCntrE");
  L_WDO.iField       (1, "Main").Hierarchic:=1;
  L_WDO.iZone        (1).PermanentFilter:=csm_GetFilter(csm_ContractTemplateName, "(Contract.Leaf=0)");
  L_WDO.iEvents      (2, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (2).ParentZone:=L_WDO.iZone(1);
 END {Contract2_OnInitializeWindow};
*)

 PRIVATE PROCEDURE Contract2_1_OnZoneOpen();
 BEGIN
  L_WDO.InstallPermanentFilter(csm_GetFilter(csm_ContractTemplateName, "(Contract.Leaf=0)"));
 END {Contract2_1_OnZoneOpen};

 PRIVATE PROCEDURE TplCntrE_0_OnZoneOpen();
 BEGIN
  RTI.Get().CurWindow.Zones(1).Fields("CntrPro.Redefine").Format:=L_Prop.rd_PoolShort;
 END {TplCntrE_0_OnZoneOpen};

 PRIVATE PROCEDURE CntrE_0_OnZoneOpen();
 BEGIN
  RTI.Get().CurWindow.Zones(1).Fields("CntrPro.Redefine").Format:=L_Prop.rd_PoolShort;
 END {CntrE_0_OnZoneOpen};

 PRIVATE PROCEDURE SetContractFieldModifiable(trgLeaf, IsInsert: SCAL[2]);
  VAR
   mfFlagModifiable: SCAL[2];
 BEGIN
  L_WDO.cField("Contract.Parent").Modifiable:=1;

  mfFlagModifiable:=0;
  IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   IF trgLeaf = 0 THEN
    mfFlagModifiable:=1;
   ELSE
    mfFlagModifiable:=IsInsert;
   END;
  END;
  L_WDO.cField("Contract.MyFirm").Modifiable:=mfFlagModifiable;
 END {SetContractFieldModifiable};

 PRIVATE PROCEDURE SetContractFieldFlagFirst(IsInsert: SCAL[2]);
  CONST
   idx_Parent = 0;
   idx_MyFirm = 1;
   idx_Name   = 2;
  VAR
   FlagsFirst: SCAL[2][3];
   MyFirmFieldFlagFirst: SCAL[2];
 BEGIN
  IF IsInsert THEN
   IF !Contract.Parent THEN
    FlagsFirst[idx_Parent]:=1;
    FlagsFirst[idx_MyFirm]:=0;
    FlagsFirst[idx_Name]  :=0;
   ELSE
    MyFirmFieldFlagFirst:=(Contract.Leaf = 1) & (!Contract.MyFirm | (Contract.MyFirm = P_Firm.mf_Fict));
    FlagsFirst[idx_Parent]:=0;
    FlagsFirst[idx_MyFirm]:=MyFirmFieldFlagFirst;
    FlagsFirst[idx_Name]  :=~MyFirmFieldFlagFirst;
   END;
  ELSE
   FlagsFirst[idx_Parent]:=0;
   FlagsFirst[idx_MyFirm]:=0;
   FlagsFirst[idx_Name]  :=1;
  END;

  L_WDO.cField("Contract.Parent").First:=FlagsFirst[idx_Parent];
  L_WDO.cField("Contract.MyFirm").First:=FlagsFirst[idx_MyFirm];
  L_WDO.cField("Contract.Name").First  :=FlagsFirst[idx_Name];
 END {SetContractFieldFlagFirst};

 PRIVATE PROCEDURE GetContractParentMyFirm(_Parent: LIKE(Contract.Parent)): P_Firm.tMyFirm;
  VAR
   parentMyFirm: P_Firm.tMyFirm;
 BEGIN
  SETEMPTY(parentMyFirm);
  IF ~!_Parent THEN
   SAVE(Contract);
   SEARCH(Contract, Contract, , _Parent);
   parentMyFirm:=Contract.MyFirm;
   RESTORE(Contract);
  END;
  RETURN parentMyFirm;
 END {GetContractParentMyFirm};

 PRIVATE PROCEDURE GetContractParentACSet(_Parent: LIKE(Contract.Parent)): LIKE(ACSet.ACSet);
  VAR
   _ACSet: LIKE(ACSet.ACSet);
 BEGIN
  SETEMPTY(_ACSet);
  IF ~!_Parent THEN
   SAVE(Contract);
   SEARCH(Contract, Contract, , _Parent);
   _ACSet:=Contract.ACSet;
   RESTORE(Contract);
  END;
  RETURN _ACSet;
 END {GetContractParentACSet};

 PRIVATE PROCEDURE CntrE_0_OnReposition();
 BEGIN
  CALL(ObjPro.UpdateCurObjectVal2Show("Contract", "CntrPro"));
 END {CntrE_0_OnReposition};

 PRIVATE PROCEDURE TplCntrE_0_OnReposition();
 BEGIN
  CALL(ObjPro.UpdateCurObjectVal2Show("Contract", "CntrPro"));
 END {TplCntrE_0_OnReposition};

 PRIVATE PROCEDURE SetupContractByParent();
  VAR
   _CntrT: LIKE(CntrT.CntrT);
   _Type : LIKE(Contract.Type);
 BEGIN
  IF ~!Contract.Parent THEN
   SAVE(Contract);
   L_General.CallUs(SEARCH(Contract, Contract, Contract.Parent));
   _CntrT:=Contract.CntrT;
   _Type :=Contract.Type;
   RESTORE(Contract);
  ELSE
   SETEMPTY(_CntrT, _Type);
  END;
  L_General.Assert_wReferToAdmin(~SELECT(MDoc, Contract, Contract.Contract) &
                                 ~SELECT(PDocMDoc, Contract, Contract.Contract),
                                 "       !");
  Contract.Type  :=_Type;
  Contract.CntrT :=_CntrT;
  REPLACE(Contract);
 END {SetupContractByParent};

 PRIVATE PROCEDURE CheckTemplateModificationAllowed();
 BEGIN
  IF ~Contract.Leaf THEN
   L_AcsPnt.PassAccessPoint(0000024);
  END;
 END {CheckTemplateModificationAllowed};

 PRIVATE PROCEDURE Contract_OnBeforeInsert();
  VAR
   srcContract  : LIKE(Contract.Contract);
   parentACSet  : LIKE(ACSet.ACSet);
   parentMyFirm : P_Firm.tMyFirm;
   _Firm        : LIKE(Firm.Firm);
 BEGIN
  L_General.SetSoftAccessDataModeForInteractiveModification();
  srcContract:=L_WDO.GetInsertionSource();
  IF ~!srcContract THEN
   L_DBD.CopyFromSrcRecord_wExclude("Contract", srcContract,
                                    "SrcNbr|SrcDate|AddInf|Date|_PayMode|Begin|Till|XObject|_PayP|Storage|Closed");
   REPLACE(Contract);
  ELSE
   IF L_WDO.InHierarchyInsMode() THEN
    L_General.CallUs(RTI.Get().CurWindow.OriginalName = GetSubWindowName(L_Cntr.iit_ContractTemplate));
    SETEMPTY(Contract.prnCntrT, Contract.prnFirm, Contract.Firm);
   END;
   parentMyFirm:=GetContractParentMyFirm(Contract.Parent);
   parentACSet :=GetContractParentACSet(Contract.Parent);
   IF ~!Contract.Parent THEN
    L_General.Assert(~!parentACSet, " 蠡 " + Contract.Parent + "  㪠   ࠧ१");
   END;
   IF L_WDO.InHierarchyInsMode() THEN
    Contract.Leaf  :=0;
    Contract.iiType:=L_Cntr.iit_ContractTemplate;
   ELSE
    Contract.Leaf  :=1;
    Contract.iiType:=L_Cntr.iit_Contract;
   END;
 
   IF ~P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
    Contract.MyFirm  :=P_Firm.DefineMyFirm();
   ELSE
    IF (parentMyFirm # P_Firm.mf_Fict) | (Contract.Leaf = 0) THEN
     Contract.MyFirm:=parentMyFirm;
    END;
   END;
   Contract.ACSet:=parentACSet;
   REPLACE(Contract);
   IF    ~!Contract.Parent THEN
    SetupContractByParent();
   ELSIF ~!Contract.prnFirm THEN
    SAVE(Contract);
    L_General.CallUs(SEARCH(Contract, Contract, Contract.prnFirm));
    _Firm:=Contract.Firm;
    RESTORE(Contract);
    Contract.Firm:=_Firm;
    REPLACE(Contract);
   END; 
  END; (* IF srcContract ... *)
  CheckTemplateModificationAllowed();
  SetContractFieldModifiable(Contract.Leaf, 1);
  SetContractFieldFlagFirst(1);
  L_AR.GrantRightsForInteractiveModification();
 END {Contract_OnBeforeInsert};

 PRIVATE PROCEDURE Contract_OnBeforeEdit();
 BEGIN
  L_General.SetSoftAccessDataModeForInteractiveModification();
  L_General.Assert((Contract.iiType = L_Cntr.iit_Contract) | (Contract.iiType = L_Cntr.iit_ContractTemplate),
                   "䨪 㯯஢ ᥩ 饭");
  CheckTemplateModificationAllowed();
  SetContractFieldModifiable(Contract.Leaf, 0);
  SetContractFieldFlagFirst(0);
  L_AR.GrantRightsForInteractiveModification();
 END {Contract_OnBeforeEdit};

 PRIVATE PROCEDURE UpdateGroupParents(AfterModification: SCAL[2]);
 BEGIN
  L_Cntr.UpdateGroupParent(L_Cntr.iit_FirmGroup,  Contract.Firm,  AfterModification);
  L_Cntr.UpdateGroupParent(L_Cntr.iit_CntrTGroup, Contract.CntrT, AfterModification);
  IF Contract.iiType = L_Cntr.iit_ContractTemplate THEN
   SETEMPTY(Contract.prnCntrT, Contract.prnFirm);
   REPLACE(Contract);
  END;
 END {UpdateGroupParents};

 PRIVATE PROCEDURE Contract_OnBeforeDelete();
 BEGIN
  CheckTemplateModificationAllowed();
  L_XDoc.XDoc_OnBeforeDelete(L_XDoc.curXDocId(L_XDoc.xdt_Contract));
  IF Contract.Leaf = 1 THEN
   L_XObj.BeforeOriginDelete(L_XObj.o_Contract);
  END;
  SAVE(Contract);
  L_General.Assert(~SELECT(Contract, Parent, Contract.Contract),
                   " 蠡  뫪 稭 蠡  ஢");
  RESTORE(Contract);
  IF Contract.iiType # L_Cntr.iit_ContractTemplate THEN
   UpdateGroupParents(0);
  END;
 END {Contract_OnBeforeDelete};

 PRIVATE PROCEDURE IsContractRequiredProperty(_Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN (_Property = P_Cntr.P_ExistanceReal)    |
         (_Property = P_Cntr.P_BalanceType)      |
         (_Property = P_Cntr.P_InHouse)          |
         (_Property = P_Cntr.P_PayOblg)          |
         (_Property = P_Cntr.P_MakeBillsSetting) |
         (_Property = P_Cntr.P_PayP);
 END {IsContractRequiredProperty};

 PRIVATE PROCEDURE intGetRequiredPropertyListFromTemplate(_Parent: LIKE(Contract.Parent));
  VAR
   _Property: LIKE(Property.Property);
 BEGIN
  SAVE(Contract);
  IF ~!_Parent  THEN
   SELECT(CntrPro, Contract, , _Parent);
   WHILE OCCURE(CntrPro) DO
    NARROWSEL(CntrPro, Property);
    LAST(CntrPro);
    IF ~SEARCH(RqPrp, Property, CntrPro.Property) THEN
     RqPrp.Property:=CntrPro.Property;
     RqPrp.Redefine:=CntrPro.Redefine;
     RqPrp.Date    :=CntrPro.Date;
     RqPrp.EndDate :=CntrPro.EndDate;
     INSERT(RqPrp);
    END;
    NEXTINEXTENDEDSEL(CntrPro, Property);
   END; (* WHILE OCCURE(CntrPro) ... *)
   SEARCH(Contract, Contract, , _Parent);
   intGetRequiredPropertyListFromTemplate(Contract.Parent);
  END;
  RESTORE(Contract);
 END {intGetRequiredPropertyListFromTemplate};

 PRIVATE PROCEDURE GetRequiredPropertyListFromTemplate(_Parent: LIKE(Contract.Parent));
 BEGIN
  L_AFM.MakeMultipleIndex("RqPrp", "Property: LIKE(Property.Property);" +
                                   "Redefine: LIKE(CntrPro.Redefine);" +
                                   "Date    : DATE;" +
                                   "EndDate : DATE",
                          "Property: Property");

  intGetRequiredPropertyListFromTemplate(_Parent);

  SELECT(Property, PropObj, , L_Prop.CntrProObj);
  WHILE OCCURE(Property) DO
   IF IsContractRequiredProperty(Property.Property) & ~SEARCH(RqPrp, Property, Property.Property) THEN
     RqPrp.Property:=Property.Property;
     RqPrp.Redefine:=L_Prop.rd_Necessary;
     RqPrp.Date    :=Contract.Begin;
     SETEMPTY(RqPrp.EndDate);
     INSERT(RqPrp);
   END;
   NEXT(Property);
  END; (* WHILE OCCURE(Property) ... *)

  SELECT(RqPrp, Property);
  WHILE OCCURE(RqPrp) DO
   IF RqPrp.Redefine # L_Prop.rd_Necessary THEN
    REMOVE(RqPrp);
   ELSE
    NEXT(RqPrp);
   END;
  END; (* WHILE OCCURE(RqPrp) ... *)
 END {GetRequiredPropertyListFromTemplate};

 PRIVATE PROCEDURE intInsertRequiredContractProperty(_Parent: LIKE(Contract.Parent); Strong, Force: SCAL[2]);
  VAR
   PropDate : DATE;
 BEGIN
  IF Force | Contract.Leaf | !_Parent THEN
   PropDate:=Contract.Begin;
   IF ~!PropDate THEN
    GetRequiredPropertyListFromTemplate(_Parent);
 
    SELECT(RqPrp, Property);
    WHILE OCCURE(RqPrp) DO
     IF ~SELECT(CntrPro, Contract, Contract.Contract, RqPrp.Property) THEN
      P_Cntr.InsertNewProperty(Contract.Contract, PropDate, RqPrp.Property, L_Prop.rd_No);
     END;
     NEXT(RqPrp);
    END; (* WHILE OCCURE(RqPrp) ... *)
   ELSE
    L_General.Assert(~Strong, "   砫 ਮ ਬ " + L_Str.PoolItem("蠡 |", Contract.Leaf));
   END;
  END;
 END {intInsertRequiredContractProperty};

 PRIVATE PROCEDURE AllowedChangeMyFirm(parentMyFirm: P_Firm.tMyFirm; wChangeMyFirm: SCAL[2]);
 BEGIN
  IF Contract.Leaf THEN
   IF ~!Contract.MyFirm & (Contract.MyFirm # P_Firm.mf_Fict) THEN
    L_General.Assert(~!parentMyFirm, "   蠡");
    IF (parentMyFirm # P_Firm.mf_Fict) & (Contract.MyFirm # parentMyFirm) THEN
     L_General.Error("  " + Contract.Parent + " ᮯ⠢  㣮 ' ࣠樥' (" + parentMyFirm + ")");
    END;
   END;
  ELSE
   IF ~!parentMyFirm    & (parentMyFirm # P_Firm.mf_Fict) &
      ~!Contract.MyFirm & (Contract.MyFirm # P_Firm.mf_Fict) &
      (Contract.MyFirm # parentMyFirm) THEN
    L_General.Error(" 蠡  㪠 㣠 ");
   END;

   IF wChangeMyFirm THEN
    IF ~!Contract.MyFirm & (Contract.MyFirm # P_Firm.mf_Fict) THEN
     parentMyFirm:=Contract.MyFirm;
     SAVE(Contract);
     IF SELECT(Contract, Parent, Contract.Contract) THEN
      WHILE OCCURE(Contract) DO
       L_General.Assert(parentMyFirm = Contract.MyFirm, " ⥪饬 蠡  ||饭 䨪,  ' ࣠'");
       NEXT(Contract);
      END; (* WHILE OCCURE(Contract)...*)
     END;
     RESTORE(Contract);
    END;
   END;
  END;
 END {AllowedChangeMyFirm};

 PRIVATE PROCEDURE GetBeginOfAccountingOnACSet(_ACSet: LIKE(ACSet.ACSet)): DATE;
  VAR
   Result: DATE;
 BEGIN
  L_General.Assert(SEARCH(ACSetL, ACSet, _ACSet, L_Acnt.acp_Contract_Netto),
                   "   ࠧ१ "+_ACSet+"  । 祭 '" +
                   L_Str.PoolItem(L_Acnt.acp_Pool, L_Acnt.acp_Contract_Netto) + "'");
  Result:=L_DatTim.MINDATE();
  SELECT(ACLog, AcCut, , ACSetL.AcCut);
  WHILE OCCURE(ACLog) DO
   IF ACLog.DoAcnt # L_XObj.acda_Yes THEN
    Result:=L_DatTim.MAXDATE();
   ELSIF Result = L_DatTim.MAXDATE() THEN
    Result:=ACLog.Date;
   END;
   NEXT(ACLog);
  END; (* WHILE OCCURE(ACLog) ... *)
  RETURN Result;
 END {GetBeginOfAccountingOnACSet};

 PRIVATE PROCEDURE ChangeACSet(oldACSet, newACSet: LIKE(ACSet.ACSet); wInform: SCAL[2]);
  VAR
   curContract: LIKE(Contract.Contract);
 BEGIN
  IF (RTI.Get().CurProcess.Kind # FORM_PROCESS.Kind_Insert) & ~!oldACSet THEN
   curContract:=Contract.Contract;
   IF Math.Max(Contract.Begin, GetBeginOfAccountingOnACSet(oldACSet)) #
      Math.Max(Contract.Begin, GetBeginOfAccountingOnACSet(newACSet)) THEN
    L_General.Error("१   "+oldACSet+"  "+newACSet+"  ࠧ  砫 ");
   END;
   SAVE(Contract);
   SELECT(Contract, Parent, , curContract);
   IF wInform & OCCURE(Contract) THEN
    L_StdFrm.Choice("  ࠧ१ " + oldACSet + " 㤥 " +
                    "|" +
                    "  稭 蠡     ஬");
   END;
   WHILE OCCURE(Contract) DO
    PROMPT(" "+Contract.Contract);
    IF ~Contract.Leaf THEN
     ChangeACSet(oldACSet, newACSet, 0);
    ELSE
     IF Contract.ACSet = oldACSet THEN
      L_XObj.CheckXCalcIsZero(Contract.XObject);
      Contract.ACSet:=newACSet;
      REPLACE(Contract);
     END;
    END;
    NEXT(Contract);
   END; (* WHILE OCCURE(Contract) ... *)
   RESTORE(Contract);
  END;
 END {ChangeACSet};

 PRIVATE PROCEDURE Contract_Parent_OnSuccessfulChange();
  VAR
   parentMyFirm: P_Firm.tMyFirm;
   newACSet,
   oldACSet    : LIKE(Contract.ACSet);
 BEGIN
  IF ~!Contract.Parent THEN
   L_General.Assert(Contract.Parent # Contract.Contract, " ᯮ짮 ⥪ ");

   SAVE(Contract);
   SEARCH(Contract, Contract, , Contract.Parent);
   L_General.Assert(~Contract.Leaf & (Contract.iiType = L_Cntr.iit_ContractTemplate), "室 㪠뢠 蠡 ");
   RESTORE(Contract);

   parentMyFirm:=GetContractParentMyFirm(Contract.Parent);
   IF !Contract.MyFirm | (Contract.MyFirm = P_Firm.mf_Fict) THEN
    AllowedChangeMyFirm(parentMyFirm, 1);
    Contract.MyFirm:=parentMyFirm;
    REPLACE(Contract);
   ELSE
    AllowedChangeMyFirm(parentMyFirm, 0);
   END;
 
   oldACSet      :=Contract.ACSet;
   newACSet      :=GetContractParentACSet(Contract.Parent);
   L_General.Assert(~!newACSet, " 蠡 " + Contract.Parent + "  㪠   ࠧ१");
   IF oldACSet # newACSet THEN
    IF Contract.Leaf THEN
     L_XObj.CheckXCalcIsZero(Contract.XObject);
    END;
    Contract.ACSet:=newACSet;
    REPLACE(Contract);
    ChangeACSet(oldACSet, newACSet, 1);
   END;
   SetupContractByParent();
  END;
  intInsertRequiredContractProperty(Contract.Parent, 0, 0);
 END {Contract_Parent_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckNotEmptyLeafParent();
 BEGIN
  L_General.Assert(~Contract.Leaf | ~!Contract.Parent, " 㪠 蠡 ");
 END {CheckNotEmptyLeafParent};

 PRIVATE PROCEDURE Contract_MyFirm_OnSuccessfulChange();
 BEGIN
  CheckNotEmptyLeafParent();
  AllowedChangeMyFirm(GetContractParentMyFirm(Contract.Parent), 1);
 END {Contract_MyFirm_OnSuccessfulChange};

 PRIVATE PROCEDURE Contract_SrcNbr_OnSuccessfulChange();
 BEGIN
  L_Cntr.ReplicationFirmNameToContract();
 END {Contract_SrcNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE Contract_Firm_OnSuccessfulChange();
  VAR
   Warned: SCAL[2];
 BEGIN
  L_Cntr.UpdateGroupParent(L_Cntr.iit_FirmGroup, Contract.Firm, 1);

  IF SELECT(MDoc, Contract, Contract.Contract) THEN
   L_General.Assert_wReferToAdmin(0, "  ࠣ  ,  ஬  ");
   Warned:=0;
   WHILE OCCURE(MDoc) DO
    PROMPT("஫ ⮢  ⥦ 㬥⮢: " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
    MDoc.Firm:=Contract.Firm;
    REPLACE(MDoc);
    SELECT(PDocMDoc, MDoc, , MDoc.MDocKind, MDoc.MDoc);
    WHILE OCCURE(PDocMDoc) DO
     CONFORM(PDocMDoc, PDoc);
     IF (PDoc.Firm # Contract.Firm) & ~P_Cntr.IsPaymentAgent(Contract.Contract, PDoc.Date, PDoc.Firm) THEN
      IF ~Warned & (PDoc.Status = L_PDoc.st_Passed) THEN
       L_StdFrm.CrucialChoice("⥦ 㬥 "+L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+": ࠣ " + PDoc.Firm +
                              "|  ⥦ ⮬     "+L_DatTim.DateStr(PDoc.Date) +
                              "| ࠣ  ?" +
                              "|| ⢨ 㤥 ਬ  ᥬ  㬥⠬",
                              L_APtm.g_Acnt);
       Warned:=1;
      END;
(*
      L_General.Assert((PDoc.Status # L_PDoc.st_Passed) | ~PDoc.Done,
                       "⥦ 㬥 " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+"|   ࠡ⠭");
*)
      IF ~!PDoc.FirmAcnt THEN
       L_General.Assert(SEARCH(FirmAcnt, FirmAcnt, Contract.Firm, PDoc.FirmAcnt),
                        "⥦ 㬥 "+L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+
                        ":|  "+PDoc.FirmAcnt+"  ࠣ "+Contract.Firm);
      END;
      PDoc.Firm:=Contract.Firm;
      REPLACE(PDoc);
      IF PDoc.Status = L_PDoc.st_Passed THEN
       SAVE(MDoc);
       SAVE(PDocMDoc);
       CONFORM(PDoc, PDocMDoc);
       WHILE OCCURE(PDocMDoc) DO
        CONFORM(PDocMDoc, MDoc);
        L_General.Assert((PDoc.Firm = Contract.Firm) |
                         P_Cntr.IsPaymentAgent(MDoc.Contract, PDoc.Date, PDoc.Firm),
                         " ᮢ ࠣ  ⥦  ⮢୮ 㬥.|" +
                         "⥦ 㬥 " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc) +
                         "| 㬥 " + L_MDoc.MDocKindNick(MDoc.MDocKind, 1) + " " + MDoc.MDoc);
        NEXT(PDocMDoc);
       END; (* WHILE OCCURE(PDocMDoc) ... *)
       RESTORE(PDocMDoc);
       RESTORE(MDoc);
      END;
     END;
     NEXT(PDocMDoc);
    END; (* WHILE OCCURE(PDocMDoc) ... *)
    NEXT(MDoc);
   END; (* WHILE OCCURE(MDoc) ... *)
  END;
  L_Cntr.ReplicationFirmNameToContract();
 END {Contract_Firm_OnSuccessfulChange};

 PUBLIC PROCEDURE ReplicationFirmNameToContracts(_Firm: LIKE(Firm.Firm));
 BEGIN
  SELECT(Contract, Firm, , _Firm);
  WHILE OCCURE(Contract) DO
   L_Cntr.ReplicationFirmNameToContract();
   L_Stock.SetName_ContractStorage();
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
 END {ReplicationFirmNameToContracts};

 PRIVATE PROCEDURE Contract_ACSet_OnAskPhase1();
 BEGIN
  IF SELECT(ACSet, Kind, L_Acnt.acsk_Contract) THEN
   SE_WZD_CURSOR(RTI.Get().TrgWindow.Name, 1, ACSet);
   IF ~!Contract.ACSet THEN
    SEARCH(ACSet, KindACS, , L_Acnt.acsk_Contract, Contract.ACSet);
    SE_WZD_POSITION(RTI.Get().TrgWindow.Name, RTI.Get().TrgZone.Number, ACSet);
   END;
  ELSE
   L_StdFrm.Inform("祣 室饣!");
  END;
 END {Contract_ACSet_OnAskPhase1};

 PRIVATE PROCEDURE Contract_ACSet_OnAskPhase2();
 BEGIN
  IF ACCESS(ACSet) THEN
   Contract.ACSet:=ACSet.ACSet;
   REPLACE(Contract);
  END;
 END {Contract_ACSet_OnAskPhase2};

 PRIVATE PROCEDURE Contract_ACSet_OnSuccessfulChange();
 BEGIN
  IF Contract.Leaf THEN
   L_General.Error("    饭");
  ELSE
   CONFORM(Contract, ACSet);
   L_General.Assert((ACSet.Kind = L_Acnt.acsk_Contract),
                    " 蠡    㪠|" +
                    "  ࠧ१ ⮫쪮  '" + L_Str.PoolItem(L_Acnt.acsk_Pool, L_Acnt.acsk_Contract) + "'");
   ChangeACSet(GE_PVALUE(), Contract.ACSet, 1);
  END;
 END {Contract_ACSet_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckSingleContractIntervals(_Begin,
                                                _Till                    : DATE;
                                                _Contract                : LIKE(Contract.Contract);
                                                _Leaf                    : LIKE(Contract.Leaf);
                                                CheckIntvlInContractIntvl: SCAL[2]);
  CONST
   ci_Pool = " |";
  VAR
   Result: SCAL[2];
 BEGIN
  IF CheckIntvlInContractIntvl THEN
   Result:=L_DatTim.InPatIntvl(Contract.Begin, Contract.Till, _Begin, _Till);
  ELSE
   Result:=L_DatTim.InPatIntvl(_Begin, _Till, Contract.Begin, Contract.Till);
  END;
  L_General.Assert(Result,
                  " ᮢ ਮ ਬ:||" +
                  L_Str.PoolItem(ci_Pool, _Leaf)         + " (" + _Contract         + ")  " + L_DatTim.DateStr(_Begin)         + "  " + L_DatTim.DateStr(_Till) + "|" +
                  L_Str.PoolItem(ci_Pool, Contract.Leaf) + " (" + Contract.Contract + ")  " + L_DatTim.DateStr(Contract.Begin) + "  " + L_DatTim.DateStr(Contract.Till));
 END {CheckSingleContractIntervals};

 PRIVATE PROCEDURE CheckContractIntervals();
  VAR
   _Begin,
   _Till    : DATE;
   _Contract: LIKE(Contract.Contract);
   _Leaf    : LIKE(Contract.Leaf);
 BEGIN
  SAVE(Contract);
  _Contract:=Contract.Contract;
  _Begin   :=Contract.Begin;
  _Till    :=Contract.Till;
  _Leaf    :=Contract.Leaf;

  IF _Leaf THEN
   SELECT(Contract, Contract, , Contract.Parent);
   CheckSingleContractIntervals(_Begin, _Till, _Contract, _Leaf, 1);
  ELSE
   IF SELECT(Contract, Contract, Contract.Parent) THEN
    CheckSingleContractIntervals(_Begin, _Till, _Contract, _Leaf, 1);
   END;
   SELECT(Contract, Parent, , _Contract);
   WHILE OCCURE(Contract) DO
    CheckSingleContractIntervals(_Begin, _Till, _Contract, _Leaf, 0);
    NEXT(Contract);
   END; (* WHILE OCCURE(Contract) ... *)
  END;
  RESTORE(Contract);
 END {CheckContractIntervals};

 PRIVATE PROCEDURE CheckCntrProIsFirst(oldDate: DATE; Text: STRING[]);
  VAR
   _Property: LIKE(Property.Property);
 BEGIN
  _Property:=CntrPro.Property;
  SAVE(CntrPro);
  L_General.Assert(~PREV(CntrPro), "  ᢮⢠ " + _Property + "  " + L_DatTim.DateStr(oldDate) + " :|" +
                                   Text);
  RESTORE(CntrPro);
 END {CheckCntrProIsFirst};

 PRIVATE PROCEDURE Contract_Date_OnSuccessfulChange();
 BEGIN
  CheckNotEmptyLeafParent();
  IF ~!Contract.Date & !Contract.Begin THEN
   Contract.Begin:=Contract.Date;
   REPLACE(Contract);
   intContract_Begin_OnSuccessfulChange(EMPTYOF(Contract.Begin));
  END;
  IF    !Contract.SrcDate THEN
   Contract.SrcDate:=Contract.Date;
   REPLACE(Contract);
  END;
 END {Contract_Date_OnSuccessfulChange};

 PRIVATE PROCEDURE CntrT_Type_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~SELECT(Contract, CntrT, CntrT.CntrT),
                   "    㦥  |" +
                   "饭  ⨯ ");
 END {CntrT_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE UpdateContractCntrT(_Parent: LIKE(Contract.Parent); _prnCntrT: LIKE(Contract.prnCntrT));
 BEGIN
  APP.Get().NewPrompt("  ");
  SAVE(Contract);
  SELECT(Contract, Parent, , _Parent);
  WHILE OCCURE(Contract) DO
   PROMPT(" " + Contract.Contract);
   Contract.CntrT   :=CntrT.CntrT;
   IF Contract.iiType # L_Cntr.iit_ContractTemplate THEN
    Contract.prnCntrT:=_prnCntrT;
   END;
   REPLACE(Contract);
   IF ~Contract.Leaf THEN
    UpdateContractCntrT(Contract.Contract, _prnCntrT);
   END;
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
  RESTORE(Contract);
 END {UpdateContractCntrT};

 PRIVATE PROCEDURE Contract_CntrT_OnSuccessfulChange();
  VAR
   _Parent,
   _prnCntrT: LIKE(Contract.Contract);
 BEGIN
  L_Cntr.UpdateGroupParent(L_Cntr.iit_CntrTGroup, Contract.CntrT, 1);

  _Parent  :=Contract.Contract;
  _prnCntrT:=Contract.prnCntrT;
  CONFORM(Contract, CntrT);

(* 蠡     Contract.prnCntrT*)
  SETEMPTY(Contract.prnCntrT);
  Contract.Type:=CntrT.Type;
  REPLACE(Contract);

  L_Cntr.ReplicationCntrTNameToContract();

  IF ~!GE_PVALUE() THEN
   IF ~!Contract.Parent | (RTI.Get().CurProcess.Kind # FORM_PROCESS.Kind_Insert) THEN
    SAVE(CntrT);
    SEARCH(CntrT, CntrT, , GE_PVALUE());
    L_General.Assert(Contract.Type = CntrT.Type,
                     "   |   ⨯ ");
    RESTORE(CntrT);
   END;

   IF SELECT(Contract, Parent, _Parent) THEN
    L_StdFrm.Choice("     稭 蠡  ?");
    UpdateContractCntrT(_Parent, _prnCntrT);
   END;
  END;
 END {Contract_CntrT_OnSuccessfulChange};

 PRIVATE PROCEDURE intContract_Begin_OnSuccessfulChange(prvValue: LIKE(Contract.Begin));
  VAR
   srcContract: LIKE(Contract.Contract);
   srcRI      : LIKE(Contract.RECORDID);
 BEGIN
  CheckNotEmptyLeafParent();
  CheckContractIntervals();
  srcContract:=L_WDO.GetInsertionSource();
  IF ~!srcContract THEN
   TRY
    L_AR.GrantRightsUnconditionally();
    IF ~!prvValue THEN
     L_StdFrm.Choice(" ᢮⢠  㤠  ⠢ , 㠫  " + L_DatTim.DateStr(Contract.Begin));
     SELECT(CntrPro, Contract, , Contract.Contract);
     WHILE OCCURE(CntrPro) DO
      L_Prop.RemoveCurrentPro("CntrPro");
     END; (* WHILE OCCURE(CntrPro) ... *)
    END;
    SAVE(Contract);
    SEARCH(Contract, Contract, , srcContract);
    srcRI:=Contract.RECORDID;
    RESTORE(Contract);
    L_Prop.extCopyProRecords("Contract", srcRI, Contract.RECORDID, 0, PROCREF(ModifyProExtraProc));
   EXCEPT
   END; (* TRY *)
  ELSE
   IF !prvValue THEN
    intInsertRequiredContractProperty(Contract.Parent, 1, 0);
   ELSE
    L_Prop.AnyProBeginChange("Contract", prvValue);
   END; (* IF ~!prvValue *)
  END; (* IF ~!srcContract *)
 END {intContract_Begin_OnSuccessfulChange};

 PRIVATE PROCEDURE Contract_Begin_OnSuccessfulChange();
 BEGIN
  intContract_Begin_OnSuccessfulChange(GE_PVALUE());
 END {Contract_Begin_OnSuccessfulChange};

 PRIVATE PROCEDURE crp_CheckOne(    _Property: LIKE(CntrPro.Property);
                                    _Date,
                                    _EndDate : DATE;
                                    _Redefine: LIKE(CntrPro.Redefine);
                                VAR Msg      : STRING[]);
  CONST
   ci_Name = "蠡|";
  VAR
   EndDate  : DATE;
 BEGIN
  SETSEL(CntrPro, Contract, Contract.Contract, _Property);
  IF    _Redefine = L_Prop.rd_No THEN
   IF SRCINSEL(CntrPro, LE, _EndDate) & (CntrPro.EndDate >= _Date) & (Contract.Till > _Date) THEN
    Msg:=L_Str.AddStrDlm(Msg, "|") +
         " " + L_Str.PoolItem(ci_Name, Contract.Leaf) + " " + Contract.Contract + "    ८। ᢮⢮ " + _Property +
         "  " + L_DatTim.DateStr(_Date);
    IF ~!_EndDate THEN
     Msg:=Msg + "  " + L_DatTim.DateStr(_EndDate);
    END;
   END;
  ELSIF _Redefine = L_Prop.rd_Necessary THEN
   IF ~SRCINSEL(CntrPro, LE, _Date) | (Contract.Leaf & !CntrPro.Value) THEN
    Msg:=L_Str.AddStrDlm(Msg, "|") +
         " " + L_Str.PoolItem(ci_Name, Contract.Leaf) + " " + Contract.Contract + "   । ᢮⢮ " + _Property +
         "  " + L_DatTim.DateStr(_Date);
   END;
   WHILE OCCURE(CntrPro) & (CntrPro.EndDate < _EndDate) DO
    EndDate:=CntrPro.EndDate;
    IF ~NEXT(CntrPro) | !CntrPro.Value | (CntrPro.Date > (EndDate + 1)) THEN
     Msg:=L_Str.AddStrDlm(Msg, "|") +
          " " + L_Str.PoolItem(ci_Name, Contract.Leaf) + " " + Contract.Contract + "   । ᢮⢮ " + _Property +
          "  " + L_DatTim.DateStr(EndDate + 1);
    END;
   END;
  END;
 END {crp_CheckOne};

 PRIVATE PROCEDURE CheckRequiredProperty(VAR Msg: STRING[]);
 BEGIN
  IF Contract.Leaf | !Contract.Parent THEN
   GetRequiredPropertyListFromTemplate(Contract.Parent);
   SELECT(RqPrp, Property);
   WHILE OCCURE(RqPrp) DO
    crp_CheckOne(RqPrp.Property, L_DatTim.MaxDATE(RqPrp.Date, Contract.Begin),
                 RqPrp.EndDate, RqPrp.Redefine, Msg);
    NEXT(RqPrp);
   END; (* WHILE OCCURE(RqPrp) ... *)
   L_AFM.AF_PurgeTemp("RqPrp");
  END;
 END {CheckRequiredProperty};

 PRIVATE PROCEDURE CheckContract();
  VAR
   _InHouse  : P_Cntr.tInHouse;
   _Real     : P_Cntr.tReal;
   _Begin,
   _Till     : DATE;
   Msg,
   TmpMsg    : STRING[];
   OnlyCHOICE: SCAL[2];
 BEGIN
  L_General.Assert(~!Contract.ACSet, " 㪠   ࠧ१");
  CheckNotEmptyLeafParent();

  IF Contract.Leaf THEN
   L_General.Assert(Contract.MyFirm # P_Firm.mf_Fict, "   ⭮   0000");
  END;

  CheckContractIntervals();

  OnlyCHOICE:=0;
  SETEMPTY(Msg);
  IF Contract.Leaf THEN
   IF P_Cntr.HasActualPro(Contract.Contract, Contract.Begin, P_Cntr.P_ExistanceReal) THEN
    _Real:=P_Cntr.GetReal(Contract.Contract, Contract.Begin);
    IF !Contract.SrcNbr THEN
     IF _Real = L_Pmnt.ctr_Yes THEN
      Msg:=L_Str.AddStrDlm(Msg, "|") +
           "     室 ";
     ELSIF _Real # L_Pmnt.ctr_No THEN
      OnlyCHOICE:=!Msg;
      Msg:=L_Str.AddStrDlm(Msg, "|") +
           "    室 ?";
     END;
    ELSE
     IF _Real = L_Pmnt.ctr_No THEN
      Msg:=L_Str.AddStrDlm(Msg, "|") +
           "      室 ";
     END;
    END;
   ELSE
    Msg:=L_Str.AddStrDlm(Msg, "|") + "  । 祭 ᢮⢠ " + L_Str.IntStr(P_Cntr.P_ExistanceReal) + "  " + L_DatTim.DateStr(Contract.Begin);
   END;

   IF P_Cntr.HasActualPro(Contract.Contract, Contract.Begin, P_Cntr.P_InHouse) THEN
    _InHouse:=P_Firm.GetFirmProSoft(Contract.Firm, Contract.Begin, P_Firm.P_INN) =
              P_Firm.FP_INN(P_Firm.fomf(Contract.MyFirm), Contract.Begin);
    IF _InHouse # P_Cntr.GetInHouse(Contract.Contract, Contract.Begin) THEN
     OnlyCHOICE:=OnlyCHOICE | !Msg;
     Msg:=L_Str.AddStrDlm(Msg, "|") +
          "ਧ '⭮襭  䨫' |" +
          "  ࠣ " + Contract.Firm + " ᮣᮢ";
    END;
   ELSE
    Msg:=L_Str.AddStrDlm(Msg, "|") + "  । 祭 ᢮⢠ " + L_Str.IntStr(P_Cntr.P_InHouse) + "  " + L_DatTim.DateStr(Contract.Begin);
   END;
  END;

  SETEMPTY(TmpMsg);
  CheckRequiredProperty(TmpMsg);
  IF ~!TmpMsg THEN
   Msg:=L_Str.AddStrDlm(Msg, "|") + TmpMsg;
   OnlyCHOICE:=0;
  END;

  IF Contract.Leaf THEN
   CONFORM(Contract, Firm);
   IF    Contract.Begin < Firm.Begin THEN
    Msg:=L_Str.AddStrDlm(Msg, "|") + " 砫 ਮ ਬ ࠣ " + L_DatTim.DateStr(Firm.Begin) + "    " + L_DatTim.DateStr(Contract.Begin);
    OnlyCHOICE:=0;
   END;
   OnlyCHOICE:=OnlyCHOICE | !Msg;
  END;
  IF ~!Msg THEN
   IF OnlyCHOICE THEN
    L_StdFrm.Choice(Msg);
   ELSE
    L_General.Error(Msg);
   END;
  END;
 END {CheckContract};

 PUBLIC PROCEDURE DeleteContractProfile();
  VAR
   Cnt: NUMERIC[0];
 BEGIN
  Cnt:=0;
  CONFORM(Contract, CntrPro);
  WHILE OCCURE(CntrPro) DO
   IF CntrPro.Redefine = L_Prop.rd_TransferFromTemplate THEN
    L_Prop.RemoveCurrentPro("CntrPro");
    INC(Cnt);
   ELSE
    NEXT(CntrPro);
   END;
  END; (* WHILE OCCURE(CntrPro) ... *)
  IF Cnt > 0 THEN
   L_StdFrm.TimedINFORM("᫥  ᮧ 䨫 ᢮⢠  㤠", 10);
  END;
 END {DeleteContractProfile};

 PRIVATE PROCEDURE Contract_OnAfterEdIns();
 BEGIN
  DeleteContractProfile();

  CheckContract();
  UpdateGroupParents(1);
 END {Contract_OnAfterEdIns};

 PRIVATE PROCEDURE Contract_OnAfterInsert();
 BEGIN
  IF Contract.Leaf THEN
   L_XObj.AfterOriginInsert(L_XObj.o_Contract, Contract.MyFirm);
  END;
  Contract_OnAfterEdIns();
 END {Contract_OnAfterInsert};

 PRIVATE PROCEDURE CheckXDocDateValidityByContract(usrTable: STRING[]);
 BEGIN
  IF OCCURE(^usrTable) THEN
   L_XDoc.CheckXDocDateValidity(TABLE.Get(usrTable), TABLE.Get("Contract"));
  END;
 END {CheckXDocDateValidityByContract};

 PRIVATE PROCEDURE CheckContractBeforeSetTill(): SCAL[2];
  VAR
   curContractBalance: L_Pmnt.tValuesToBalance;
 BEGIN
  curContractBalance:=L_Pmnt.GetContractBalance(Contract.Contract, SYSDATE(), L_XDoc.max_DoneDTS, L_XDoc.max_DoneDTS);
  IF (curContractBalance[L_Pmnt.vtb_Total] # 0) THEN
   L_StdFrm.Choice("뢠   㫥 ᠫ줮");
   RETURN 0;
  END;

  IF P_Cntr.GetBalanceType(Contract.Contract, SYSDATE()) = P_Cntr.ctbt_ByDeal THEN
   SELECT(MDocKind, MDocKind);
   WHILE OCCURE(MDocKind) DO
    IF L_Pmnt.IsMayBePaidMDocKind(MDocKind.MDocKind) THEN
     SETSEL(MDoc, CntrClsd, Contract.Contract, MDocKind.MDocKind);
     SRCINSEL(MDoc, GE, , SYSDATE());
     WHILE OCCURE(MDoc) DO
      PROMPT("஢ઠ ᯮ ᤥ "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
      IF L_Pmnt.ipic_CheckMDoc(L_Pmnt.ipic_AutoPay) THEN
       L_StdFrm.Choice("      ⮩|ਬ "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
       RETURN 0;
      END;
      NEXT(MDoc);
     END; (* WHILE OCCURE(MDoc) ... *)
    END;
    NEXT(MDocKind);
   END; (* WHILE OCCURE(MDocKind) ... *)
  END;
  RETURN 1;
 END {CheckContractBeforeSetTill};

 PRIVATE PROCEDURE Contract_OnAfterEdit();
 BEGIN
  L_Stock.SetName_ContractStorage();
  IF Contract.Firm # GE_PVALUE(Contract.Firm) THEN
   L_Cntr.UpdateGroupParent(L_Cntr.iit_FirmGroup, GE_PVALUE(Contract.Firm), 0);
  END;
  IF Contract.CntrT # GE_PVALUE(Contract.CntrT) THEN
   L_Cntr.UpdateGroupParent(L_Cntr.iit_CntrTGroup, GE_PVALUE(Contract.CntrT), 0);
  END;
  IF Contract.iiType = L_Cntr.iit_ContractTemplate THEN
   SETEMPTY(Contract.prnCntrT, Contract.prnFirm);
   REPLACE(Contract);
  END;
  IF Contract.Leaf THEN
   IF SELECT(PDocMDoc, Contract, Contract.Contract) THEN
    REPEAT
     CONFORM(PDocMDoc, PDoc);
    UNTIL (PDoc.Status # L_PDoc.st_Canceled) | ~NEXT(PDocMDoc);
    CheckXDocDateValidityByContract("PDoc");
    IF ~!Contract.Till & OCCURE(PDocMDoc) & LAST(PDocMDoc) THEN
     REPEAT
      CONFORM(PDocMDoc, PDoc);
     UNTIL (PDoc.Status # L_PDoc.st_Canceled) | ~PREV(PDocMDoc);
     CheckXDocDateValidityByContract("PDoc");
    END;
   END;
   IF SELECT(MDoc, Contract, Contract.Contract) THEN
    WHILE OCCURE(MDoc) DO
     NARROWSEL(MDoc, MDocKind);
     WHILE OCCURE(MDoc) & (MDoc.Status = L_MDoc.st_Canceled) DO
      NEXT(MDoc);
     END;
     CheckXDocDateValidityByContract("MDoc");
     IF ~!Contract.Till & OCCURE(MDoc) & LAST(MDoc) THEN
      WHILE OCCURE(MDoc) & (MDoc.Status = L_MDoc.st_Canceled) DO
       PREV(MDoc);
      END;
      CheckXDocDateValidityByContract("MDoc");
     END;
     NEXTINEXTENDEDSEL(MDoc, MDocKind);
    END; (* WHILE OCCURE(MDoc) ... *)
   END;
   IF    Contract.Till <= SYSDATE() THEN
    IF (Contract.Till # GE_PVALUE(Contract.Till)) &
       CheckContractBeforeSetTill() THEN
     Contract.Closed:=1;
     REPLACE(Contract);
    END;
   ELSIF Contract.Closed THEN
    Contract.Closed:=0;
    REPLACE(Contract);
   END;
  END; (* IF Contract.Leaf *)
  Contract_OnAfterEdIns();
 END {Contract_OnAfterEdit};

 PRIVATE PROCEDURE CntrT_OnAfterEdIns();
 BEGIN
  SELECT(Contract, CntrT, , CntrT.CntrT);
  WHILE OCCURE(Contract) DO
   L_Cntr.ReplicationCntrTNameToContract();
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
 END {CntrT_OnAfterEdIns};

 PRIVATE PROCEDURE CntrT_OnAfterEdit();
 BEGIN
  CntrT_OnAfterEdIns();
 END {CntrT_OnAfterEdit};

 PRIVATE PROCEDURE CntrT_OnAfterInsert();
 BEGIN
  CntrT_OnAfterEdIns();
 END {CntrT_OnAfterInsert};

(*---------------------------------------------------------------------------------------------------------*)

 PRIVATE PROCEDURE ShowContractBalance(Full: SCAL[2]);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(Contract);
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_Pmnt.ShowContractBalanceHistory(Contract.Contract, Full), "");
 END {ShowContractBalance};

 PUBLIC PROCEDURE ShowContractBalance_Short();
 BEGIN
  ShowContractBalance(0);
 END {ShowContractBalance_Short};

 PUBLIC PROCEDURE ShowContractBalance_Full();
 BEGIN
  ShowContractBalance(1);
 END {ShowContractBalance_Full};

(*
$P{ pcb_Top:
P_Firm.MyFirmName(Contract.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
?, C, ""
?, C, ""
?, R, ""
?, R, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|                                                        |##########################|########################|
|--------------------------------------------------------|--------------------------|------------------------|
}
*)

(*
$P{ pcb_Dlm:
@
|--------------------------------------------------------|--------------------------|------------------------|
}
*)

(*
$P{ Line:
?, L, ""
?, L, "|"
?, R, ",2-"
?, R, ",2-"
@
|########################################################|# ########################|########################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE pcb_PrintLine(wSaldo  : SCAL[2];
                                 _CirType: SCAL[2];
                                 Text    : STRING[];
                                 _Value,
                                 _Saldo  : L_Pmnt.tValuesToBalance);
 BEGIN
  IF !_CirType THEN
   IF _Value[L_Pmnt.vtb_Total] < 0 THEN
    _CirType:=L_Acnt.ct_Credit;
    _Value:=L_Pmnt.vtbInv(_Value);
   ELSE
    _CirType:=L_Acnt.ct_Debit
   END;
  ELSE
   Text:=L_DatTim.DateStr(CnBHs.Date) + " " + Text;
  END;
  IF wSaldo THEN
   IF ~!_Saldo[L_Pmnt.vtb_Total] THEN
    MAKEPART(R, Line, Text, CnBHs.CirType, _Value[L_Pmnt.vtb_Total], _Saldo[L_Pmnt.vtb_Total]);
   ELSE
    MAKEPART(R, Line, Text, _CirType,      _Value[L_Pmnt.vtb_Total],                         );
   END;
  ELSE
   IF _CirType = L_Acnt.ct_Debit THEN
    MAKEPART(R, Line, Text, , _Value[L_Pmnt.vtb_Total],                         );
   ELSE
    MAKEPART(R, Line, Text, ,                         , _Value[L_Pmnt.vtb_Total]);
   END;
  END;
 END {pcb_PrintLine};

 PRIVATE PROCEDURE intPrintContractBalance(wSaldo: SCAL[2]);
  VAR
   InB,
   dCir,
   cCir   : L_Pmnt.tValuesToBalance;
   Alive  : SCAL[2];
   RepName: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(Contract);
  CONFORM(Contract, Firm);
  PROMPT("");
  IF wSaldo THEN
   RepName:="CnBlH";
  ELSE
   RepName:="CnBlP";
  END;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, pcb_Top, RepName,
                       L_Str.PoolItem("| ", wSaldo) +
                         "  ਮ  "  + L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut()),
                       "  " + L_Cntr.ContractNbr() + "  " +  L_DatTim.DateStr(Contract.SrcDate) + " " + Contract.Name,
                       "ࠣ " + Firm.Firm + " " + P_Firm.FP_FirmName(Firm.Firm, Memo.ud_ut()),
                       L_Str.PoolItem("|  樨", wSaldo),
                       L_Str.PoolItem("।|ᠫ줮 ᫥ 樨", wSaldo));
  L_Pmnt.PrepareContractBalanceHistory(Contract.Contract,
                                       L_DatTim.IncMonth(L_DatTim.Per(Memo.ud_fr()), -1),
                                       Memo.ud_ut());
  IF SELECT(CnBHs, CnBHs, Contract.XObject) THEN
   IF SRCINSEL(CnBHs, LT, Memo.ud_fr()) THEN
    InB:=CnBHs.Balance;
   ELSE
    SETZERO(InB);
   END;
   IF InB[L_Pmnt.vtb_Total] = 0 THEN
    Alive:=SRCINSEL(CnBHs, GE, Memo.ud_fr());
   ELSE
    Alive:=1;
   END;
   IF Alive THEN
    SETZERO(dCir, cCir);
    pcb_PrintLine(wSaldo, EMPTYOF(CnBHs.CirType), "줮  " + L_DatTim.DateStr(Memo.ud_fr()), InB, L_Pmnt.vtb_EmptyValue());
    IF SRCINSEL(CnBHs, GE, Memo.ud_fr()) THEN
     MAKEPART(R, pcb_Dlm);
     WHILE OCCURE(CnBHs) DO
      IF CnBHs.CirType = L_Acnt.ct_Debit THEN
       dCir:=L_Pmnt.vtbAdd(dCir, CnBHs.Value);
      ELSE
       cCir:=L_Pmnt.vtbAdd(cCir, CnBHs.Value);
      END;
      IF  L_Str.TestStrAlowChar(CnBHs.XDocId, "09") THEN
       pcb_PrintLine(wSaldo, CnBHs.CirType, L_XDoc.extXDocStr(CnBHs.XDocId, L_XDoc.xdast_wSrcNbr), CnBHs.Value, CnBHs.Balance);
      ELSE
       pcb_PrintLine(wSaldo, CnBHs.CirType, CnBHs.XDocId,                                          CnBHs.Value, CnBHs.Balance);
      END;
      NEXT(CnBHs);
     END; (* WHILE OCCURE(CnBHs) *)
    END;
    LAST(CnBHs);
    IF ~wSaldo THEN
     MAKEPART(R, pcb_Dlm);
     MAKEPART(R, Line, "⮣   ਮ", ,
              dCir[L_Pmnt.vtb_Total], cCir[L_Pmnt.vtb_Total]);
    END;
    MAKEPART(R, pcb_Dlm);
    pcb_PrintLine(wSaldo, EMPTYOF(CnBHs.CirType), "줮  " + L_DatTim.DateStr(Memo.ud_ut()+1), CnBHs.Balance, L_Pmnt.vtb_EmptyValue());
   END;
  END;
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {intPrintContractBalance};

 PUBLIC PROCEDURE PrintContractBalance();
 BEGIN
  intPrintContractBalance(0);
 END {PrintContractBalance};

 PUBLIC PROCEDURE PrintContractBalance_wSaldo();
 BEGIN
  intPrintContractBalance(1);
 END {PrintContractBalance_wSaldo};

 PUBLIC PROCEDURE MakeContractProfile();
  VAR
   curRI: LIKE(Contract.RECORDID);
 BEGIN
  IF ~!Contract.Parent THEN
   curRI:=Contract.RECORDID;
   LOOP
    SELECT(Contract, Contract, , Contract.Parent);
    L_Prop.extCopyProRecords("Contract", Contract.RECORDID, curRI, 1, PROCREF(ModifyProExtraProc));
    IF !Contract.Parent THEN
     EXIT;
    END;
   END; (* LOOP *)
  END;
 END {MakeContractProfile};

 PUBLIC PROCEDURE MakeContractCopy();
 BEGIN
  ACCESS(Contract);
  L_WDO.LaunchInsertBySource(Contract.Contract, "");
 END {MakeContractCopy};

(*
$P{ CacTm_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Contract.Contract + " " + Contract.Name, C, ""
@
#############################################################                                 ########## #####
=#####========================================================================================================
|                                 ஢ઠ ஢  ᮮ⢥⢨ 蠡                                 |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
||稭                                                                                             |
|-------|----------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ CacTm_Line:
?, L, ""
?, L, ""
@
|#######|####################################################################################################|
}
*)

(*
$P{ CacTm_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PUBLIC PROCEDURE CheckAccordanceOfTemplate();
  CONST
   RepName = "CAcTm";
  VAR
   i    : NUMERIC[0];
   Lines: STRING[][50];
   _Till: DATE;
 BEGIN
  ACCESS(Contract);
  L_General.Assert(Contract.iiType = L_Cntr.iit_ContractTemplate, "쪮  蠡 ");
  _Till       :=L_DatTim.IncYear(SYSDATE(), -1);

  STDFORM(L_StdFrm.sf_Choice("| ஢ , 騥  %##########%|",
                             "%<D.N.y>YI"),
          " ஢ઠ ஢  ᮮ⢥⢨ ",
          ,
          ,
          _Till);
  APP.Get().NewPrompt("("+RepName+")");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, CacTm_Top, RepName);
  SELECT(Contract, Parent, , Contract.Contract);
  WHILE OCCURE(Contract) DO
   PROMPT(" " + Contract.Contract);
   IF !_Till | (Contract.Till >= _Till) THEN
    TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
     CheckContract();
    EXCEPT
    ON Exc: Exc_Root DO
     Str.Format(Lines, Exc.Description, 100, LEFT);
     MAKEPART(R, CacTm_Line, Contract.Contract, Lines[0]);
     i:=1;
     WHILE ~!Lines[i] DO
      MAKEPART(R, CacTm_Line, "", Lines[i]);
      INC(i);
     END;
    END; (* TRY*)
   END;
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
  MAKEPART(R, CacTm_Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {CheckAccordanceOfTemplate};

 PRIVATE PROCEDURE Contract_Name_OnAskForViewPhase1();
 BEGIN
  IF ACCESS(Contract) THEN
   IF    csm_GetMode() = csm_FirmName THEN
    SEARCH(Firm, Firm, , Contract.Firm);
    L_WDO.PositionInOwnerZoneOfActiveField("Firm");
   ELSIF csm_GetMode() = csm_CntrT THEN
    SEARCH(CntrT, CntrT, , Contract.CntrT);
    L_WDO.PositionInOwnerZoneOfActiveField("CntrT");
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {Contract_Name_OnAskForViewPhase1};

 PRIVATE PROCEDURE Contract_Name_OnAskForViewPhase2();
 BEGIN
  IF    csm_GetMode() = csm_FirmName THEN
   IF SELECT(Contract, Firm, Firm.Firm, 0) THEN
    SE_WZD_POSITION(RTI.Get().CurWindow.Name, 1, Contract);
   ELSE
    L_StdFrm.Inform("   ");
   END;
  ELSIF csm_GetMode() = csm_CntrT THEN
   SELECT(Contract, CntrT, , CntrT.CntrT, EMPTYOF(Contract.Firm));
   WHILE OCCURE(Contract) & (Contract.iiType # L_Cntr.iit_CntrTGroup) DO
    NEXT(Contract);
   END;
   IF OCCURE(Contract) THEN
    SE_WZD_POSITION(RTI.Get().CurWindow.Name, 1, Contract);
   ELSE
    L_StdFrm.Inform("   ");
   END;
  END;
 END {Contract_Name_OnAskForViewPhase2};

 PUBLIC PROCEDURE ShowContract_ByFirmName();
 BEGIN
  Contract_1_ChangeMainField(csm_FirmName);
 END {ShowContract_ByFirmName};

 PUBLIC PROCEDURE ShowContract_BySrcNbr();
 BEGIN
  Contract_1_ChangeMainField(csm_SrcNbr);
 END {ShowContract_BySrcNbr};

 PUBLIC PROCEDURE ShowContract_ByCntrT();
 BEGIN
  Contract_1_ChangeMainField(csm_CntrT);
 END {ShowContract_ByCntrT};

 PUBLIC PROCEDURE ShowContract_ByTemplate();
 BEGIN
  Contract_1_ChangeMainField(csm_ContractTemplateName);
 END {ShowContract_ByTemplate};

 PUBLIC PROCEDURE ShowContract_RotateMode();
 BEGIN
  IF GetContractWindowMode() # wm_Ask_hParent THEN
   IF csm_GetMode() = csm_FirmName THEN
    Contract_1_ChangeMainField(csm_ContractTemplateName);
   ELSE
    Contract_1_ChangeMainField(csm_FirmName);
   END;
  ELSE
   L_StdFrm.Inform(" ० ⮡ࠦ ");
  END;
 END {ShowContract_RotateMode};

 PUBLIC PROCEDURE CheckContractAfterInsert();
 BEGIN
  L_XObj.AfterOriginInsert(L_XObj.o_Contract, Contract.MyFirm);
  CheckContract();
 END {CheckContractAfterInsert};

 PUBLIC PROCEDURE InsertRequiredContractProperty();
 BEGIN
  ACCESS(Contract);
  intInsertRequiredContractProperty(Contract.Parent, 1, 1);
 END {InsertRequiredContractProperty};

 PUBLIC PROCEDURE CheckCurContract();
 BEGIN
  ACCESS(Contract);
  CheckContract();
  L_StdFrm.Inform("஡  㦥");
 END {CheckCurContract};

BEGIN
 L_Events.ExecuteHandler();
END.
