(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose      ०  । , ᮢ ⪠ ०,
%Purpose     ஫ 䨪樨 ०
%Type        operation, control
%Specific    SYS
%Modified    14.08.2014 12:57:16 POLAK\Gina
*)

 MODULE ContReg [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_DatTim, L_Str, L_StdFrm, L_Hld, L_OwnData,
        L_PRoll, P_Staff, Math, Memo, L_AvePay, L_WDO, L_Sheet, L_r2r, L_APtm, L_SysLog;

 PRIVATE CONST
  regim_RepName = "REGIM";
  tregm_RepName = "TRegm";
  MaxCycle      = 100;

 PRIVATE VAR
  gt,
  dr,
  st,
  dt        : LIKE(RegList.GrTime)[MaxCycle];
  sk        : LIKE(RegList.SpKind)[MaxCycle];
  jm        : LIKE(RegList.JMode) [MaxCycle];
  jm_DayOff : LIKE(RegList.JMode);

  bt,
  et,
  db0,
  db1,
  db2,
  de0,
  de1,
  de2       : TIME[MaxCycle];
  WeekDayIdx: NUMERIC[0][8];

 PRIVATE PERMANENT VAR
  v_rhsh_SheduleType    : LIKE(RegHead.ShdlType);
  v_rhsh_SheduleBegTime,
  v_rhsh_SheduleEndTime : TIME;
  v_rhsh_SheduleDnrBegT,
  v_rhsh_SheduleDnrEndT : TIME[3];

 PRIVATE PROCEDURE CheckClosed(P: DATE);
 BEGIN
  L_General.Assert_wReferToAdmin(~L_APtm.MonthIsClosed(L_DatTim.Per(P), L_APtm.system_Salary),
                                 L_DatTim.PeriodStr(P) + " -  ("+L_APtm.SystemName(L_APtm.system_Salary)+")");
 END {CheckClosed};

 PRIVATE PROCEDURE RegMain_OnAfterEdIns(pvMassDrv: LIKE(RegMain.MassDrv); pvSlipGr: LIKE(RegMain.SlipGr));
 BEGIN
  IF RegMain.MassDrv & (RegMain.SlipGr # L_PRoll.rgt_SlipGr) &
     ((RegMain.MassDrv # pvMassDrv) | (RegMain.SlipGr # pvSlipGr)) THEN
   L_General.Assert(L_General.IsAdmin(),
                    "ᮢ   ᪮饣 ० ࠡ| ⠭ ⮫쪮 ");
  END;
 END {RegMain_OnAfterEdIns};

 PRIVATE PROCEDURE RegMain_OnAfterEdit();
 BEGIN
  RegMain_OnAfterEdIns(GE_PVALUE(RegMain.MassDrv), GE_PVALUE(RegMain.SlipGr));
 END {RegMain_OnAfterEdit};

 PRIVATE PROCEDURE RegMain_OnAfterInsert();
 BEGIN
  RegMain_OnAfterEdIns(0, L_PRoll.rgt_BaseGr);
 END {RegMain_OnAfterInsert};

 PRIVATE PROCEDURE RegMain_OnBeforeDelete();
 BEGIN
  L_r2r.Owner_OnBeforeDelete("RegMain");
 END {RegMain_OnBeforeDelete};

 PRIVATE PROCEDURE ChangeTimeBefHld(VAR Tim: NUMERIC[3]);
  CONST
   Delta = 1;
 BEGIN
  Tim:=Math.Max(0, Tim - Delta);
 END {ChangeTimeBefHld};

 PRIVATE PROCEDURE IsNullGr(): SCAL[2];
 BEGIN
  RETURN RegHead.GrTime = 0;
 END {IsNullGr};

 PRIVATE PROCEDURE SetNets();
 BEGIN
  RegList.Net[L_AvePay.nn_6Days]  :=L_Hld.WeekDay_TransfersConsidered(RegList.Period + RegList.Day - 1) < L_DatTim.wd_Sun;
  IF IsNullGr() THEN
   RegList.Net[L_AvePay.nn_Regime]:=RegList.Durat#0;
  ELSE
   RegList.Net[L_AvePay.nn_Regime]:=RegList.GrTime#0;
  END;
  RegList.Net[L_AvePay.nn_AllDays]:=1;
  REPLACE(RegList);
 END {SetNets};

 PRIVATE PROCEDURE SetWeekDayIdx(D: DATE; _i: NUMERIC[0]);
 BEGIN
  WeekDayIdx[L_Hld.WeekDay_TransfersConsidered(D)]:=_i;
 END {SetWeekDayIdx};

 PRIVATE PROCEDURE ScanOldDays(VAR i: NUMERIC[0]; Cycle: NUMERIC[0]);
  VAR
   IsBHol: SCAL[2];
   Date  : DATE;
 BEGIN
  SETEMPTY(gt, jm_DayOff, bt, et, db0, db1, db2, de0, de1, de2);
  i:=0;
  WHILE OCCURE(RegList) & (i < Cycle) DO
   Date:=RegList.Period+(RegList.Day-1);
   PROMPT(RegMain.Regime+" "+L_DatTim.DateStr(Date));
   SETZERO(IsBHol);
   IF    (RegMain.SlipGr = L_PRoll.rgt_OtherGr) | (RegMain.SlipGr = L_PRoll.rgt_BaseGr) THEN
    IsBHol:=L_Hld.DayIsBeforeHoliday(Date);
    IF RegList.GrTime = 0 THEN
     L_General.Assert(~L_Hld.DayIsHoliday(Date),
                      " 横  ࠧ .|" +
                      "  ० " + RegHead.Regime + " ⮬᪨.|" +
                      "   ०  ᫥騩  ");
     jm_DayOff:=RegList.JMode;
    END;
   END;
   gt[i]:=RegList.GrTime   + IsBHol*(RegList.GrTime>0);
   dr[i]:=RegList.Durat    + IsBHol*(RegList.Durat>0);
   st[i]:=RegList.SpTime;
   IF ~!RegList.DayTime THEN
    dt[i]:=RegList.DayTime + IsBHol*(RegList.DayTime>0);
   ELSE
    SETEMPTY(dt[i]);
   END;
   sk[i]:=RegList.SpKind;
   jm[i]:=RegList.JMode;

   bt[i]:=RegList.BegTime;
   IF ~!RegList.EndTime THEN
    et[i]:=RegList.EndTime + IsBHol;
   END;
   db0[i]:=RegList.DnrBegT[0];
   db1[i]:=RegList.DnrBegT[1];
   db2[i]:=RegList.DnrBegT[2];
   de0[i]:=RegList.DnrEndT[0];
   de1[i]:=RegList.DnrEndT[1];
   de2[i]:=RegList.DnrEndT[2];

   SetWeekDayIdx(Date, i);
   INC(i);
   NEXT(RegList);
  END; (* WHILE OCCURE(RegList) ... *)
 END {ScanOldDays};

 PRIVATE PROCEDURE CalendarAccess(P: DATE);
 BEGIN
  SETSEL(Calendar, Period, P);
  L_General.Assert(SRCINSEL(Calendar, EQ, 01), "   ᠭ "+L_DatTim.PeriodStr(P));
 END {CalendarAccess};

 PRIVATE PROCEDURE CalculateRegHead();
 BEGIN
  SETZERO(RegHead.FullBal, RegHead.RDay,
          RegHead.GrTime,  RegHead.GDay, RegHead.SpTime);
  SELECT(RegList, HumReg, , RegHead.Regime, RegHead.Period);
  WHILE OCCURE(RegList) DO
   PROMPT(RegHead.Regime+" "+L_DatTim.DateStr(RegHead.Period+(RegList.Day-1)));
   IF RegList.Durat # 0 THEN
    INC(RegHead.FullBal, RegList.Durat);
    INC(RegHead.RDay);
   END;
   INC(RegHead.GrTime, RegList.GrTime);
   IF RegList.GrTime # 0 THEN
    INC(RegHead.GDay);
    INC(RegHead.SpTime[RegList.SpKind], RegList.SpTime);
   END;
   NEXT(RegList);
  END; (* WHILE OCCURE(RegList) ... *)
  REPLACE(RegHead);
  SELECT(RegList, HumReg, , RegHead.Regime, RegHead.Period);
  WHILE OCCURE(RegList) DO
   PROMPT(RegHead.Regime+" "+L_DatTim.DateStr(RegHead.Period+(RegList.Day-1)));
   SetNets();
   NEXT(RegList);
  END; (* WHILE OCCURE(RegList) ... *)
 END {CalculateRegHead};

 PRIVATE PROCEDURE CheckRegListFilling();
  CONST
   FillingErr = "  ० ࠡ   ";
  VAR
   i: NUMERIC[0];
 BEGIN
  SAVE(RegList);
  SELECT(RegList, HumReg, , RegHead.Regime, RegHead.Period);
  SETZERO(i);
  WHILE OCCURE(RegList) DO
   INC(i);
   IF i # RegList.Day THEN
    IF i < RegList.Day - 1 THEN
     L_StdFrm.Choice(FillingErr + " " + L_Str.IntStr(i) + "  " + L_Str.IntStr(RegList.Day - 1));
    ELSE
     L_StdFrm.Choice(FillingErr + "  " + L_Str.IntStr(i));
    END;
    i:=L_DatTim.MonthLen(RegHead.Period);
    LAST(RegList);
   END;
   NEXT(RegList);
  END; (* WHILE OCCURE(RegList) ... *)
  IF i < L_DatTim.MonthLen(RegHead.Period) THEN
   L_StdFrm.Choice(FillingErr + "稭  "  + L_Str.IntStr(i + 1));
  END;
  RESTORE(RegList);
 END {CheckRegListFilling};

 PRIVATE PROCEDURE CheckRegHead();
  VAR
   i: NUMERIC[0];
 BEGIN
  IF RegHead.FullBal = 0 THEN
   L_StdFrm.Choice("⠭ 㫥 ଠ ६.  㢥७?");
  ELSIF  RegHead.FullBal # RegHead.GrTime THEN
   L_StdFrm.Choice("ଠ ६  ᮮ⢥ ६  䨪");
  END;
  i:=0;
  WHILE i <= HIGH(RegHead.DnrBegT) DO
   L_General.Assert(!RegHead.DnrBegT[i] = !RegHead.DnrEndT[i],
                    "砫  砭 뢠  ६");
   INC(i);
  END;
  CheckRegListFilling();
 END {CheckRegHead};

 PRIVATE PROCEDURE TransferedWeekDay(D: DATE): SCAL[2];
 BEGIN
  RETURN L_DatTim.WEEKDAY(D) # L_Hld.WeekDay_TransfersConsidered(D);
 END {TransferedWeekDay};

 PRIVATE PROCEDURE MakeNewDays();
  VAR
   j, _j : NUMERIC[0];
   IsBHol: SCAL[2];
   _Weekday: L_DatTim.tWeekday;
 BEGIN
  j:=0;
  WHILE OCCURE(Calendar) DO
   PROMPT(RegMain.Regime+" "+L_DatTim.DateStr(Calendar.Date));
   RegList.Regime:=RegHead.Regime;
   RegList.Period:=RegHead.Period;
   RegList.Day   :=Calendar.Day;
   IF j >= RegHead.Cycle THEN
    j:=0;
   END;
   IF (((RegMain.SlipGr = L_PRoll.rgt_OtherGr) | (RegMain.SlipGr = L_PRoll.rgt_BaseGr)) &
      L_Hld.DayIsHoliday(Calendar.Date)) THEN
    L_General.Assert(~!jm_DayOff,  "   室 ");
    RegList.GrTime :=0;
    RegList.Durat  :=0;
    RegList.SpTime :=0;
    IF ~!dt[j] THEN
     RegList.DayTime:=0;
    ELSE
     SETEMPTY(RegList.DayTime);
    END;
    SETEMPTY(RegList.BegTime, RegList.EndTime, RegList.DnrBegT, RegList.DnrEndT);
    RegList.SpKind :=0;
    RegList.JMode  :=jm_DayOff;
   ELSE
    _j:=j;
    _Weekday:=L_Hld.WeekDay_TransfersConsidered(Calendar.Date);
    IF (RegMain.SlipGr = L_PRoll.rgt_BaseGr) & (L_DatTim.WEEKDAY(Calendar.Date) # _Weekday) THEN (*७ᥭ 室*)
     L_General.Assert(L_General.VariableIsInitialized(WeekDayIdx[_Weekday]),
                      "  ७ 室 ."+
                      "|஢ 横   ० ࠡ (  7)");
     j:=WeekDayIdx[_Weekday];
    END;
    RegList.GrTime :=gt[j];
    RegList.Durat  :=dr[j];
    RegList.SpTime :=st[j];
    RegList.DayTime:=dt[j];
    RegList.SpKind :=sk[j];
    RegList.JMode  :=jm[j];

    RegList.BegTime:=bt[j];
    RegList.EndTime:=et[j];
    RegList.DnrBegT[0]:=db0[j];
    RegList.DnrBegT[1]:=db1[j];
    RegList.DnrBegT[2]:=db2[j];
    RegList.DnrEndT[0]:=de0[j];
    RegList.DnrEndT[1]:=de1[j];
    RegList.DnrEndT[2]:=de2[j];

    j:=_j;
   END;
   IsBHol:=0;
   IF ((RegMain.SlipGr = L_PRoll.rgt_OtherGr) | (RegMain.SlipGr = L_PRoll.rgt_BaseGr)) &
      ((RegList.GrTime > 0) | (IsNullGr() & RegList.Durat > 0)) THEN
    IsBHol:=L_Hld.DayIsBeforeHoliday(Calendar.Date);
   END;
   IF IsBHol THEN
    ChangeTimeBefHld(RegList.GrTime);
    ChangeTimeBefHld(RegList.Durat);
    IF ~!RegList.DayTime THEN
     ChangeTimeBefHld(RegList.DayTime);
    END;
    IF ~!RegList.EndTime THEN
     DEC(RegList.EndTime, 1);
    END;
   END;
   SETEMPTY(RegList.Net);
   INSERT(RegList);
   SetNets();
   INC(j);
   NEXT(Calendar);
  END; (* WHILE OCCURE(Calendar) ... *)
 END {MakeNewDays};

 PRIVATE PROCEDURE SrcRegList(_Regime: LIKE(RegHead.Regime); D: DATE): SCAL[2];
 BEGIN
  SETSEL(RegList, HumReg, _Regime);
  RETURN SRCINSEL(RegList, EQ, L_DatTim.Per(D), L_DatTim.DAY(D));
 END {SrcRegList};

 PRIVATE PROCEDURE AccessRegList(): SCAL[2];
  VAR
   LastDate,
   Date           : DATE;
   GoodCycle      : SCAL[2];
   NumCycle,
   NumDayInCycle  : NUMERIC[0];
 BEGIN
  L_General.Assert(SELECT(RegList, HumReg, RegHead.Regime, RegHead.Period),
                   "  ० ࠡ " + RegHead.Regime + "  " + L_DatTim.PeriodStr(RegHead.Period));
  LAST(RegList);
  LastDate:=RegHead.Period + RegList.Day - 1;
  Date:=LastDate - RegHead.Cycle + 1;
  IF    (RegMain.SlipGr = L_PRoll.rgt_OtherGr) | (RegMain.SlipGr = L_PRoll.rgt_BaseGr) THEN
   NumCycle:=1;
   WHILE SrcRegList(RegHead.Regime, Date) DO
    NumDayInCycle:=1; GoodCycle:=1;
    REPEAT
     PROMPT(RegMain.Regime+" "+L_DatTim.DateStr(Date));
     IF L_Hld.DayIsHoliday(Date) | TransferedWeekDay(Date) THEN
      GoodCycle:=0;
     END;
     INC(NumDayInCycle);
     INC(Date);
    UNTIL (NumDayInCycle > RegHead.Cycle) | ~GoodCycle;
 
    IF GoodCycle THEN
     RETURN 1;
    END;
    INC(NumCycle);
    Date:=LastDate - RegHead.Cycle * NumCycle + 1;
   END;
  ELSE
   RETURN SrcRegList(RegHead.Regime, Date);
  END;
  RETURN 0;
 END {AccessRegList};

 PRIVATE PROCEDURE MakeMonth(P: DATE);
 BEGIN
  L_General.Assert(AccessRegList(), "  ࠧ");
  ScanOldDays(RegHead.Cycle, RegHead.Cycle);
  RegHead.Period:=P;
  INSERT(RegHead);
  CalendarAccess(RegHead.Period);
  MakeNewDays();
  CalculateRegHead();
 END {MakeMonth};

 PRIVATE PROCEDURE CleanMonth();
 BEGIN
  SELECT(RegList, HumReg, , RegHead.Regime, RegHead.Period);
  REMSEL(RegList);
  REMOVE(RegHead);
 END {CleanMonth};

 PUBLIC PROCEDURE EraseRegListFromCurrentDay();
  VAR
   _Day: LIKE(RegList.Day);
 BEGIN
  IF ACCESS(RegList) THEN
   CheckClosed(RegList.Period);
   _Day:=RegList.Day;
   REMOVE(RegList);
   WHILE OCCURE(RegList) & (RegList.Day > _Day) DO
    PROMPT(FLDTOSTR(RegList.Period+(RegList.Day-1)));
    _Day:=RegList.Day;
    REMOVE(RegList);
   END; (* WHILE OCCURE(RegList ... *)
   LAST(RegList);
  END;
 END {EraseRegListFromCurrentDay};

 PUBLIC PROCEDURE MakeNewMonthOnSingleRegime();
 BEGIN
  SETSEL(RegHead, HumReg, RegMain.Regime);
  IF LAST(RegHead) THEN
   CheckClosed(L_DatTim.IncMonth(RegHead.Period, +1));
   MakeMonth(L_DatTim.IncMonth(RegHead.Period, +1));
   SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), RegHead);
  END; (* IF OCCURE(RegHead) ... *)
 END {MakeNewMonthOnSingleRegime};

 PUBLIC PROCEDURE FillByExample();
  VAR
   cycle: LIKE(RegHead.Cycle);
 BEGIN
  L_General.Assert(ACCESS(RegList), " ⠭ ப 䨪");
  CheckClosed(RegList.Period);
  SAVE(RegList);
  CalculateRegHead();
  RESTORE(RegList);
  cycle:=RegHead.Cycle;
  SAVE(RegList);
  ScanOldDays(cycle, MaxCycle);
  RESTORE(RegList);
  IF RegHead.Cycle # cycle THEN
   L_StdFrm.Question(" 䨪  ࠧ:" +
                     "|| " + L_Str.IntStr(cycle) +
                     ", ਮ  " + L_DatTim.DateStr(RegList.Period+RegList.Day-1) +
                             "  " + L_DatTim.DateStr(RegList.Period+RegList.Day-1+cycle-1));
   RegHead.Cycle:=cycle;
   REPLACE(RegHead);
  END;

  CalendarAccess(RegHead.Period);
  FIRST(RegList);
  WHILE OCCURE(RegList) & OCCURE(Calendar) DO
   PROMPT(L_DatTim.DateStr(Calendar.Date));
   L_General.Assert(RegList.Day=Calendar.Day, "  ० ࠡ   ᫥⥫");
   SetNets();
   NEXT(Calendar);
   NEXT(RegList);
  END; (* WHILE OCCURE(RegList) ... *)

  MakeNewDays();
  CalculateRegHead();
 END {FillByExample};

 PRIVATE PROCEDURE DoMakeMonth();
 BEGIN
  IF SEARCH(RegHead, HumReg, RegMain.Regime,
                             L_DatTim.IncMonth(Memo.ud_mb(), -1)) THEN
   L_APtm.SysLogHandler("RegHead", L_SysLog.knd_AutoBuild);
   MakeMonth(Memo.ud_mb());
  END;
 END {DoMakeMonth};

 PUBLIC PROCEDURE MakeNewMonthOnAllRegime();
  VAR
   OverwriteOldRegime,
   AskForOverwrite    :SCAL[2];
 BEGIN
  L_StdFrm.Question(" ० ࠡ  "+L_DatTim.PeriodStr(Memo.ud_mb()));
  CheckClosed(Memo.ud_mb());
  OverwriteOldRegime:=0;
  AskForOverwrite:=1;

  SELECT(RegMain, HumReg);
  WHILE OCCURE(RegMain) DO
   PROMPT(RegMain.Regime);
   IF RegMain.MassDrv & L_DatTim.IsActiveInIntvl(Memo.ud_mb(), Memo.ud_me(), RegMain.Begin, RegMain.Till) &
      SEARCH(RegHead, HumReg, RegMain.Regime,
                              L_DatTim.IncMonth(Memo.ud_mb(), -1)) THEN
    IF SEARCH(RegHead, HumReg, RegMain.Regime, Memo.ud_mb()) THEN
     IF AskForOverwrite THEN
      AskForOverwrite   :=0;
      OverwriteOldRegime:=L_StdFrm.RedAlternative(" ०  " + L_DatTim.PeriodStr(Memo.ud_mb()) + " 㦥 .||"+
                                                  "  ?");
     END;
     IF OverwriteOldRegime THEN
      CleanMonth();
      DoMakeMonth();
     END;
    ELSE
     DoMakeMonth();
    END;
   END;
   NEXT(RegMain);
  END; (* WHILE OCCURE(RegMain)... *)
 END {MakeNewMonthOnAllRegime};

 PRIVATE PROCEDURE PushRegHeadTimes();
  VAR
   _BegTime: LIKE(RegHead.BegTime);
   _EndTime: LIKE(RegHead.EndTime);
   _DnrBegT: LIKE(RegHead.DnrBegT);
   _DnrEndT: LIKE(RegHead.DnrEndT);
 BEGIN
  IF ~!RegHead.BegTime THEN
   SAVE(RegHead);
   _BegTime:=RegHead.BegTime;
   _EndTime:=RegHead.EndTime;
   _DnrBegT:=RegHead.DnrBegT;
   _DnrEndT:=RegHead.DnrEndT;
   CHANGESEL(RegHead, HumReg, , RegHead.Regime);
   NEXT(RegHead);
   WHILE OCCURE(RegHead) & !RegHead.BegTime DO
    RegHead.BegTime:=_BegTime;
    RegHead.EndTime:=_EndTime;
    RegHead.DnrBegT:=_DnrBegT;
    RegHead.DnrEndT:=_DnrEndT;
    REPLACE(RegHead);
    NEXT(RegHead);
   END; (* WHILE OCCURE(RegHead) ... *)
   RESTORE(RegHead);
  END;
 END {PushRegHeadTimes};

 PRIVATE PROCEDURE ShdlFilled(_ShdlType: LIKE(RegHead.ShdlType)): SCAL[2];
  VAR
   _BegTime: LIKE(RegHead.BegTime);
   _EndTime: LIKE(RegHead.EndTime);
   _DnrBegT: LIKE(RegHead.DnrBegT);
   _DnrEndT: LIKE(RegHead.DnrEndT);
 BEGIN
  L_PRoll.FillShedule(_ShdlType, _BegTime, _EndTime, _DnrBegT, _DnrEndT);
  RETURN ~!_BegTime & ~!_EndTime;
 END {ShdlFilled};

 PRIVATE PROCEDURE GetInc(i: SCAL[4]): SCAL[4];
 BEGIN
  RETURN i+1;
 END {GetInc};

 PRIVATE PROCEDURE CheckDnr(_ShdlType: LIKE(RegHead.ShdlType));
  VAR
   i,
   j      : SCAL[4];
   ct,
   db     : FLOAT;
   cd     : DATE;
   OverDay: SCAL[2];
   DayNum : SCAL[2];

   _BegTime: LIKE(RegHead.BegTime);
   _EndTime: LIKE(RegHead.EndTime);
   _DnrBegT: LIKE(RegHead.DnrBegT);
   _DnrEndT: LIKE(RegHead.DnrEndT);
 BEGIN
  IF ShdlFilled(_ShdlType) THEN
   L_PRoll.FillShedule(_ShdlType, _BegTime, _EndTime, _DnrBegT, _DnrEndT);
   cd:=01\01\1900;
   DayNum:=0;
   SETZERO(ct);
   db:=L_DatTim.GetVARIANTDATE(cd, _BegTime, 0);
   ct:=db;
   SETZERO(i);
   SETEMPTY(j);
   WHILE i < 3 DO
    IF ~!(_DnrBegT[i]) THEN
     IF ~DayNum & (L_DatTim.GetVARIANTDATE(cd, _DnrBegT[i], 0) < ct) THEN
      L_StdFrm.Choice("ᯨᠭ 墠뢠 ᫥騥 ⪨");
      INC(cd);
      DayNum:=1;
     END;
     IF ~!j THEN
      L_General.Assert(ct < L_DatTim.GetVARIANTDATE(cd, _DnrBegT[i], 0),
                       " " + GetInc(i) + " 稭  砭 뢠 " + GetInc(j));
     ELSE
      L_General.Assert(db < L_DatTim.GetVARIANTDATE(cd, _DnrBegT[i], 0),
                       " " + GetInc(i) + " 稭  砫 ᬥ");
     END;
     ct:=L_DatTim.GetVARIANTDATE(cd, _DnrBegT[i], 0);
     IF ~DayNum & (L_DatTim.GetVARIANTDATE(cd, _DnrEndT[i], 0) < ct) THEN
      L_StdFrm.Choice("ᯨᠭ 墠뢠 ᫥騥 ⪨");
      INC(cd);
      DayNum:=1;
     END;
     L_General.Assert(ct < L_DatTim.GetVARIANTDATE(cd, _DnrEndT[i], 0),
                      "砫 뢠 " + GetInc(i) + "  襭");
     ct:=L_DatTim.GetVARIANTDATE(cd, _DnrEndT[i], 0);
     j:=i;
    END;
    INC(i);
   END;
   IF ~DayNum & (L_DatTim.GetVARIANTDATE(cd, _EndTime, 0) < ct) THEN
    L_StdFrm.Choice("ᯨᠭ 墠뢠 ᫥騥 ⪨");
    INC(cd);
    DayNum:=1;
   END;
   IF ~!j THEN
    L_General.Assert(ct < L_DatTim.GetVARIANTDATE(cd, _EndTime, 0),
                     " " + GetInc(j) + " 蠥  砭 ᬥ");
   ELSE
    L_General.Assert(ct < L_DatTim.GetVARIANTDATE(cd, _EndTime, 0),
                     "砫 ᬥ ᮢ  砭  ");
   END;
  END;
 END {CheckDnr};

 PRIVATE PROCEDURE RegHead_OnAfterEdIns();
 BEGIN
  IF L_WDO.getActiveForm().OriginalName = "RegME1" THEN
   RegHead.ShdlType  :=v_rhsh_SheduleType;
   RegHead.BegTime   :=v_rhsh_SheduleBegTime;
   RegHead.EndTime   :=v_rhsh_SheduleEndTime;
   RegHead.DnrBegT[0]:=v_rhsh_SheduleDnrBegT[0];
   RegHead.DnrBegT[1]:=v_rhsh_SheduleDnrBegT[1];
   RegHead.DnrBegT[2]:=v_rhsh_SheduleDnrBegT[2];
   RegHead.DnrEndT[0]:=v_rhsh_SheduleDnrEndT[0];
   RegHead.DnrEndT[1]:=v_rhsh_SheduleDnrEndT[1];
   RegHead.DnrEndT[2]:=v_rhsh_SheduleDnrEndT[2];

   CheckDnr(L_PRoll.rgs_Month);
   REPLACE(RegHead);
  ELSE
   CalculateRegHead();
   CheckRegHead();
   PushRegHeadTimes();

   IF    RegHead.ShdlType = L_PRoll.rgs_Month THEN
    L_General.Assert(ShdlFilled(RegHead.ShdlType), "  ᯨᠭ  !");
   ELSIF RegHead.ShdlType = L_PRoll.rgs_Daily THEN
    SAVE(RegList);
    SELECT(RegList, HumReg, , RegHead.Regime, RegHead.Period);
    WHILE OCCURE(RegList) DO
     IF    RegList.GrTime > 0 THEN
      L_General.Assert(ShdlFilled(RegHead.ShdlType),
                      " " + RegList.Day + ":   ᯨᠭ!");
     ELSIF ~!RegList.BegTime THEN
      L_StdFrm.Choice(" " + RegList.Day + ":  ᯨᠭ  ࠡ祣 !");
     END;
     NEXT(RegList);
    END; (*OCCURE(RegList)*)
    RESTORE(RegList);
   END;
  END;
 END {RegHead_OnAfterEdIns};

 PRIVATE PROCEDURE RegHead_OnAfterEdit();
 BEGIN
  RegHead_OnAfterEdIns();
 END {RegHead_OnAfterEdit};

 PRIVATE PROCEDURE RegHead_OnAfterInsert();
 BEGIN
  RegHead_OnAfterEdIns();
 END {RegHead_OnAfterInsert};

 PRIVATE PROCEDURE RegHead_OnBeforeInsert();
  VAR
   _BegTime: LIKE(RegHead.BegTime);
   _EndTime: LIKE(RegHead.EndTime);
   _DnrBegT: LIKE(RegHead.DnrBegT);
   _DnrEndT: LIKE(RegHead.DnrEndT);
 BEGIN
  SETEMPTY(_BegTime, _EndTime, _DnrBegT, _DnrEndT);
  SAVE(RegHead);
  CHANGESEL(RegHead, HumReg, , RegHead.Regime);
  IF PREV(RegHead) THEN
   _BegTime:=RegHead.BegTime;
   _EndTime:=RegHead.EndTime;
   _DnrBegT:=RegHead.DnrBegT;
   _DnrEndT:=RegHead.DnrEndT;
  END;
  RESTORE(RegHead);
  RegHead.BegTime:=_BegTime;
  RegHead.EndTime:=_EndTime;
  RegHead.DnrBegT:=_DnrBegT;
  RegHead.DnrEndT:=_DnrEndT;
  REPLACE(RegHead);
 END {RegHead_OnBeforeInsert};

 PRIVATE PROCEDURE RegList_GrTime_OnSuccessfulChange();
 BEGIN
  IF !RegList.Durat | (RegList.Durat = GE_PVALUE(RegList.GrTime)) THEN
   RegList.Durat:=RegList.GrTime;
   REPLACE(RegList);
  END;
 END {RegList_GrTime_OnSuccessfulChange};

 PRIVATE PROCEDURE RegList_OnAfterEdIns();
 BEGIN
  L_General.Assert(RegList.GrTime  <= 32, "६  䨪   ॢ 32 ");
  L_General.Assert(RegList.SpTime  <= 32, "⥫쭮 ६   ॢ 32 ");
  L_General.Assert(RegList.DayTime <= 24, "६  ⪨   ॢ 24 ");
  L_General.Assert(RegList.Durat   <= 32, "६  ଥ   ॢ 32 ");
  CONFORM(RegList, JMode);
  L_General.Assert(L_DatTim.InPatIntvl(JMode.Begin, JMode.Till,
                                       RegList.Period, L_DatTim.MonthEnd(RegList.Period)),
                                       " ࠡ  ⠡ " + JMode.JMode + "    " + L_DatTim.PeriodStr(RegList.Period));
  CheckDnr(L_PRoll.rgs_Daily);
  SetNets();
  IF ~!RegList.DayTime THEN
   L_General.Assert(RegList.DayTime<=RegList.GrTime, "६  ⪨     ६  ᬥ");
  END;
 END {RegList_OnAfterEdIns};

 PRIVATE PROCEDURE RegList_OnBeforeEdit();
 BEGIN
  CheckClosed(RegList.Period);
 END {RegList_OnBeforeEdit};

 PRIVATE PROCEDURE RegList_OnBeforeInsert();
 BEGIN
  CheckClosed(RegList.Period);
 END {RegList_OnBeforeInsert};

 PRIVATE PROCEDURE RegList_OnBeforeDelete();
 BEGIN
  CheckClosed(RegList.Period);
 END {RegList_OnBeforeDelete};

 PRIVATE PROCEDURE RegList_OnAfterEdit();
 BEGIN
  RegList_OnAfterEdIns();
 END {RegHead_OnAfterEdit};

 PRIVATE PROCEDURE RegList_OnAfterInsert();
 BEGIN
  RegList_OnAfterEdIns();
 END {RegHead_OnAfterEdit};

 PRIVATE PROCEDURE RegMain_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow(1, "RegME");
  L_WDO.iField    (1, "RegMain.SlipGr").Format:=L_PRoll.rgt_Pool;
 END {RegMain_OnInitializeWindow};

 PRIVATE PROCEDURE RegMEE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterInsert]);
  L_WDO.iScsChange   (0, ["RegHead.ShdlType", "RegHead.Period"]);
  L_WDO.iUnmodifiable(0, ["RegHead.Regime"]);
  L_WDO.iProgs       (0, "ContReg");
  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete,
                          L_WDO.e_OnAfterEdit, L_WDO.e_OnAfterInsert]);
  L_WDO.iScsChange   (1, ["RegList.GrTime"]);
  L_WDO.iUnmodifiable(1, ["Shedule", "RegList.Net[2]", "RegList.Net[1]", "RegList.Net[0]"]);
  L_WDO.iMayBeEmpty  (1, ["RegList.DayTime"]);
  L_WDO.iField       (1, "Calendar.WeekDay").Format:=L_DatTim.WDStr_Pool_Short;
  L_WDO.iField       (1, "Shedule").Format:="-|";
  L_WDO.iProgs       (1, "ContReg");
 END {RegMEE_OnInitializeWindow};

 PRIVATE PROCEDURE RegHead_SetupWin();
  VAR
   Mdf: SCAL[2];
 BEGIN
  Mdf:=v_rhsh_SheduleType = L_PRoll.rgs_Month;
  L_WDO.SetFieldModifiable("v_rhsh_SheduleBegTime",   Mdf);
  L_WDO.SetFieldModifiable("v_rhsh_SheduleEndTime",   Mdf);
  L_WDO.SetFieldModifiable("v_rhsh_SheduleDnrBegT_0", Mdf);
  L_WDO.SetFieldModifiable("v_rhsh_SheduleDnrBegT_1", Mdf);
  L_WDO.SetFieldModifiable("v_rhsh_SheduleDnrBegT_2", Mdf);
  L_WDO.SetFieldModifiable("v_rhsh_SheduleDnrEndT_0", Mdf);
  L_WDO.SetFieldModifiable("v_rhsh_SheduleDnrEndT_1", Mdf);
  L_WDO.SetFieldModifiable("v_rhsh_SheduleDnrEndT_2", Mdf);
 END {RegHead_SetupWin};

 PRIVATE PROCEDURE RegME1_0_OnZoneOpen();
 BEGIN
  ACCESS(RegHead);
  L_WDO.SetFieldFormat("v_rhsh_SheduleType", L_PRoll.rgs_Pool);
  v_rhsh_SheduleType      :=RegHead.ShdlType;
  v_rhsh_SheduleBegTime   :=RegHead.BegTime;
  v_rhsh_SheduleEndTime   :=RegHead.EndTime;
  v_rhsh_SheduleDnrBegT[0]:=RegHead.DnrBegT[0];
  v_rhsh_SheduleDnrBegT[1]:=RegHead.DnrBegT[1];
  v_rhsh_SheduleDnrBegT[2]:=RegHead.DnrBegT[2];
  v_rhsh_SheduleDnrEndT[0]:=RegHead.DnrEndT[0];
  v_rhsh_SheduleDnrEndT[1]:=RegHead.DnrEndT[1];
  v_rhsh_SheduleDnrEndT[2]:=RegHead.DnrEndT[2];
  RegHead_SetupWin();
 END {RegME1_0_OnZoneOpen};

 PRIVATE PROCEDURE RegHead__OnSuccessfulChange();
 BEGIN
  IF v_rhsh_SheduleType # L_PRoll.rgs_Month THEN
   SETEMPTY(v_rhsh_SheduleBegTime, v_rhsh_SheduleEndTime,
            v_rhsh_SheduleDnrBegT, v_rhsh_SheduleDnrEndT);
  END;
  RegHead_SetupWin();
 END {RegHead__OnSuccessfulChange};

 PRIVATE PROCEDURE RegHead_ShdlType_OnSuccessfulChange();
 BEGIN
  IF RegHead.ShdlType # L_PRoll.rgs_Month THEN
   IF (GE_PVALUE(RegHead.ShdlType) = L_PRoll.rgs_Month) & ShdlFilled(L_PRoll.rgs_Month) THEN
    L_StdFrm.Choice(" ᬥ ⨯ ᯨᠭ, ᯨᠭ   㤥 饭!");
   END;
   SETEMPTY(RegHead.BegTime, RegHead.EndTime, RegHead.DnrBegT, RegHead.DnrEndT);
   REPLACE(RegHead);
  END;
 END {RegHead_ShdlType_OnSuccessfulChange};

 PRIVATE PROCEDURE RegHead_Period_OnSuccessfulChange();
  VAR
   WasChoice: SCAL[2];
 BEGIN
  IF ~!GE_PVALUE(RegHead.Period) THEN
   CheckClosed(GE_PVALUE(RegHead.Period));
  END;
  CheckClosed(RegHead.Period);
  IF SELECT(RegList, HumReg, RegHead.Regime, RegHead.Period) THEN
   IF SRCINSEL(RegList, GT, L_DatTim.MonthLen(RegHead.Period)) THEN
    WasChoice:=0;
    WHILE OCCURE(RegList) DO
     IF ~WasChoice &
        ((~!RegList.GrTime  & (RegList.GrTime # 0))  |
         (~!RegList.DayTime & (RegList.DayTime # 0)) |
         (~!RegList.SpTime  & (RegList.SpTime # 0))  |
         (~!RegList.Durat   & (RegList.Durat # 0))) THEN
      L_StdFrm.Choice(" ᫥ 砭   㤠.");
      WasChoice:=1;
     END;
     REMOVE(RegList);
    END; (* WHILE OCCURE(RegList) ... *)
   ELSE
    CheckRegListFilling();
   END;
  END;
 END {RegHead_Period_OnSuccessfulChange};

 PRIVATE PROCEDURE INCRLTime(VAR DayNum: SCAL[2]; CurEvent: TIME; VAR LastEventDT: FLOAT; VAR CurDay: DATE);
 BEGIN
  IF ~DayNum & (L_DatTim.GetVARIANTDATE(CurDay, CurEvent, 0) < LastEventDT) THEN
   INC(RegList.DayTime, (L_DatTim.GetVARIANTDATE(CurDay, 23:59, 59) - LastEventDT) * 24);
   INC(CurDay);
   DayNum:=1;
  END;
  INC(RegList.GrTime, (L_DatTim.GetVARIANTDATE(CurDay, CurEvent, 0) - LastEventDT) * 24);
  INC(RegList.DayTime, ~DayNum * (L_DatTim.GetVARIANTDATE(CurDay, CurEvent, 0) - LastEventDT) * 24);
  INC(RegList.SpTime,
      24 *
      ((LastEventDT <= L_DatTim.GetVARIANTDATE(CurDay + ~DayNum, 06:00, 0)) &
       (L_DatTim.GetVARIANTDATE(CurDay, CurEvent, 0) >= L_DatTim.GetVARIANTDATE(CurDay - DayNum, 22:00, 0))) *
      (Math.Min(L_DatTim.GetVARIANTDATE(CurDay, CurEvent, 0),
                L_DatTim.GetVARIANTDATE(CurDay + ~DayNum, 06:00, 0)) -
       Math.Max(LastEventDT, L_DatTim.GetVARIANTDATE(CurDay - DayNum, 22:00, 0))));
  LastEventDT:=L_DatTim.GetVARIANTDATE(CurDay, CurEvent, 0);
 END {INCRLTime};

 PUBLIC PROCEDURE FillRegListTimeByShdl();
  VAR
   i      : SCAL[4];
   ct     : FLOAT;
   cd     : DATE;
   DurateIsEqGrTime,
   DayNum : SCAL[2];

   _BegTime: LIKE(RegHead.BegTime);
   _EndTime: LIKE(RegHead.EndTime);
   _DnrBegT: LIKE(RegHead.DnrBegT);
   _DnrEndT: LIKE(RegHead.DnrEndT);
 BEGIN
  L_General.Assert(ACCESS(RegList), " ⠭ ப 䨪");
  CheckClosed(RegList.Period);
  CONFORM(RegList, RegHead);
  L_PRoll.FillShedule(RegHead.ShdlType, _BegTime, _EndTime, _DnrBegT, _DnrEndT);
  L_General.Assert(ShdlFilled(RegHead.ShdlType), "ᯨᠭ  ");

  L_General.Assert(SEARCH(JMode, JMode, RegList.JMode) &
                   (JMode.Type = L_Sheet.jmType_TimDone),
                   " ⮫쪮  ࠡ ");
  DurateIsEqGrTime:=RegList.Durat = RegList.GrTime;
  SETZERO(RegList.DayTime, RegList.GrTime, RegList.SpTime, RegList.SpKind);
  SETZERO(ct);
  cd:=10\01\1900;
  ct:=L_DatTim.GetVARIANTDATE(cd, _BegTime, 0);
  SETZERO(i);
  DayNum:=0;
  WHILE i < 3 DO
   IF ~!(_DnrBegT[i]) THEN
    INCRLTime(DayNum, _DnrBegT[i], ct, cd);
    IF ~DayNum & (L_DatTim.GetVARIANTDATE(cd, _DnrEndT[i], 0) < ct) THEN
     INC(RegList.DayTime, (L_DatTim.GetVARIANTDATE(cd, _DnrBegT[i], 0) - ct) * 24);
     DayNum:=1;
     INC(cd);
    END;
    ct:=L_DatTim.GetVARIANTDATE(cd, _DnrEndT[i], 0);
   END;
   INC(i);
  END;
  INCRLTime(DayNum, _EndTime, ct, cd);
  IF RegList.SpTime > 0 THEN
   RegList.SpKind:=L_Sheet.spk_Night;
  END;
  IF DurateIsEqGrTime THEN
   RegList.Durat:=RegList.GrTime;
  END;
  REPLACE(RegList);
 END {FillRegListTimeByShdl};

 PRIVATE PROCEDURE FillGrap(BegValue, EndValue: NUMERIC[0]): STRING[];
  VAR
   GrapStr : STRING[];
 BEGIN
  SETEMPTY(GrapStr);
  WHILE BegValue < EndValue DO
   GrapStr := GrapStr + "         ";
   INC(BegValue);
  END; (* WHILE BegValue < EndValue  ... *)
  RETURN GrapStr;
 END {FillGrap};

 PRIVATE PROCEDURE GetGrTimeAsStr(): STRING[];
 BEGIN
  IF RegList.GrTime = 0 THEN
   RETURN "    ";
  ELSE
   RETURN FLDTOSTR(RegList.GrTime, "1.", 4);
  END;
 END {GetGrTimeAsStr};

 PRIVATE PROCEDURE GetButtonType(Dir: NUMERIC[0]; P: DATE) : STRING[2];
  VAR
   ButtonType : STRING[2];
 BEGIN
  SAVE(RegMain);
  REPEAT
   IF Dir = +1 THEN NEXT(RegMain);
   ELSE             PREV(RegMain);
   END;
  UNTIL ~OCCURE(RegMain) | L_DatTim.IsActive(P, RegMain.Begin, RegMain.Till);
  IF ~OCCURE(RegMain) THEN ButtonType:="NB";
  ELSE                     ButtonType:="B";
  END;
  RESTORE(RegMain);
  RETURN ButtonType;
 END {GetButtonType};

 PUBLIC PROCEDURE ShowRegime(ShowSingleRegime: SCAL[2]);
  CONST
   NormalExitPattern = "ଠ쭮 襭 05.12.2001 15:29:00 SAN";
  VAR
   _WeekDay   : NUMERIC[0];
   PrvBut,
   NxtBut,
   TextInForm : STRING[];
   trgRegime    : LIKE(RegMain.Regime);
   _Day,
   React,
   trgShift,
   _MonthLen  : NUMERIC[0];
   P,
   D          : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  IF ShowSingleRegime THEN
   P_Staff.GetDataFromForm(P_Staff.P_RegimeForMkBegRWS);
   L_General.Assert(~!StaffPro.Date, "室  ");
   P:=Math.Max(L_DatTim.Per(StaffPro.Date), Memo.ud_mb());
   P_Staff.GetP_RegimeForMkBegRWS(StaffPro.TSN, StaffPro.Date, trgRegime, trgShift);
   IF ~!trgRegime THEN
    SEARCH(RegMain, HumReg, , trgRegime);
   END;
  ELSE
   P       :=Memo.ud_mb();
   trgShift:=0;
  END;
  L_General.Assert(ACCESS(RegMain), " । ० ࠡ");
  L_General.Assert(~!trgShift, " 㪠 ᤢ ० ࠡ");
  LOOP
   TRY
    _WeekDay := L_DatTim.WEEKDAY(P);
    D        :=P;
    _MonthLen:=L_DatTim.MonthLen(P);
    _Day     :=1;
    INC(D, trgShift);
    SETSEL(RegList, HumReg, RegMain.Regime);
    IF ~SRCINSEL(RegList, LE, L_DatTim.Per(D), L_DatTim.DAY(D)) THEN
     TextInForm:=" " + RegMain.Regime + "    " + L_DatTim.PeriodStr(P) + "||";
    ELSE
     TextInForm:= FillGrap(0, _WeekDay);
     WHILE OCCURE(RegList) & (_Day <= _MonthLen) DO
      CONFORM(RegList, JMode);
      IF _WeekDay > 6 THEN
       TextInForm := TextInForm + "|" +
                    "Ĵ|";
       SETZERO(_WeekDay);
      END;
      TextInForm := TextInForm + "" +
                    L_Str.FixedIntStr(_Day, 2) + " " +
                    JMode.ShtSign + " " +
                    GetGrTimeAsStr();
      INC(_WeekDay);
      NEXT(RegList);
      INC(_Day);
     END; (* WHILE OCCURE(RegList) &... *)
 
     IF _WeekDay # 0 THEN
      TextInForm := TextInForm + FillGrap(_WeekDay, 7);
      TextInForm := TextInForm + "|";
     END;
     TextInForm:="͸|"+
                 "                                                 |"+
                 "͵|"+
                 TextInForm +
                 ";||";
    END;
    IF ~ShowSingleRegime THEN
     PrvBut:=L_StdFrm.DrawButton("{}।騩 ०", 24, GetButtonType(-1, P));
     NxtBut:=L_StdFrm.DrawButton("{}騩 ० ", 24, GetButtonType(+1, P));
    ELSE
     PrvBut:="";
     NxtBut:="";
    END;
    React := STDFORM( "|" + RegMain.Regime + "    " + RegMain.Name + "  " + L_DatTim.PeriodStr(P) + "|" +
                      "|" +
                     TextInForm +
                     PrvBut +
                     "%< 믮 >FDX" +
                     NxtBut,
                     " ࠡ"
                     );
    RAISE(, NormalExitPattern);
   EXCEPT
   ON Exc: Exc_Raise DO
    IF Exc.MsgOriginalText # NormalExitPattern THEN
     RAISE();
    END;
   END; (* TRY *)
   IF    (React = 0)  THEN
    EXIT;
   ELSIF (React = 1) THEN
    REPEAT
     PREV(RegMain);
    UNTIL ~OCCURE(RegMain) | L_DatTim.IsActive(P, RegMain.Begin, RegMain.Till);
   ELSIF (React = 2) THEN
    REPEAT
     NEXT(RegMain);
    UNTIL ~OCCURE(RegMain) | L_DatTim.IsActive(P, RegMain.Begin, RegMain.Till);
   ELSE
    L_General.CallUs(0);
   END;
  END; (* LOOP *);
  IF ~ShowSingleRegime & OCCURE(RegMain) THEN
   SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), RegMain);
  END;
 END {ShowRegime};

(*
$P{ regim_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
regim_RepName, L, ""
@
############################################################# ########## #####
=#####========================================================================
|                              C᮪ 䨪                               |
|----------------------------------------------------------------------------|
| |                              |騩 䨪|⪠ |
|----|------------------------------------------|-----------------|----------|
}
*)

(*
$P{ regim_Line:
RegMain.Regime, L, ""
RegMain.Name, L, ""
RegMain.SlipGr, L, "-|"
RegMain.MassDrv, L, "  |"
@
|####|##########################################|        #        |    ##    |
}
*)

(*
$P{ regim_Bot:
@
=(c) Polak====================================================================
}
*)

 PUBLIC PROCEDURE REGIM();
 BEGIN
  OPENREP(R, L_General.NameConnection(regim_RepName), Create);
  MAKEPART(R, regim_Top);
  SELECT(RegMain, HumReg);
  WHILE OCCURE(RegMain) DO
   PROMPT(RegMain.Regime);
   IF L_DatTim.IsActive(Memo.ud_cd(), RegMain.Begin, RegMain.Till) THEN
    MAKEPART(R, regim_Line);
   END;
   NEXT(RegMain);
  END; (* WHILE OCCURE(RegMain) ... *)
  MAKEPART(R, regim_Bot);
  CLOSEREP(R);
 END {REGIM};

(*
$P{ tregm_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
tregm_RepName, L, ""
RegMain.Regime, L, ""
RegMain.Name, L, ""
Memo.ud_cd(), L, "y "
@
#################################################### ########## #####
=#####===============================================================
| ࠡ #### #################################################|
|                           ########                              |
|-------------------------------------------------------------------|
|       |          |               ࠡ             |
|       |-------------------|---------------------------------------|
|  |       ଠ       |       ଠ       |       䨪      |
|       |-------------------|-------------------|-------------------|
|       |     |      |     |      |     |      |
|-------|---------|---------|---------|---------|---------|---------|
}
*)

(*
$P{ tregm_Line:
Month.Period, L, "N.y"
Month.HBal, R, "3."
Month.WorkDays, R, "0"
?, R, "3."
?, R, "0"
?, R, "3."
?, R, "0"
@
|#######|#########|#########|#########|#########|#########|#########|
}
*)

(*
$P{ tregm_Bot:
?, R, "3."
?, R, "0"
?, R, "3."
?, R, "0"
?, R, "3."
?, R, "0"
@
|-------|---------|---------|---------|---------|---------|---------|
|⮣  |#########|#########|#########|#########|#########|#########|
=(c) Polak===========================================================
}
*)

 PUBLIC PROCEDURE TRegm();
  VAR
   HBal    : NUMERIC[2];
   RDay,
   GDay,
   WorkDays: NUMERIC[0];
   GrTime,
   FullBal : NUMERIC[3];
 BEGIN
  L_General.Assert(ACCESS(RegMain), " ⠭ ० ࠡ");
  OPENREP(R, L_General.NameConnection(tregm_RepName), Create);
  MAKEPART(R, tregm_Top);
  SETSEL(Month, Period);
  SRCINSEL(Month, GE, , Memo.YearB());
  SETZERO(HBal, WorkDays, FullBal, RDay, GrTime, GDay);
  WHILE OCCURE(Month) & (L_DatTim.YearBeg(Month.Period) = Memo.YearB()) DO
   IF SEARCH(RegHead, HumReg, RegMain.Regime, Month.Period) THEN
    MAKEPART(R, tregm_Line, RegHead.FullBal, RegHead.RDay, RegHead.GrTime, RegHead.GDay);
    INC(FullBal, RegHead.FullBal);
    INC(RDay,    RegHead.RDay);
    INC(GrTime,  RegHead.GrTime);
    INC(GDay,    RegHead.GDay);
   ELSE
    MAKEPART(R, tregm_Line);
   END;
   INC(HBal,     Month.HBal);
   INC(WorkDays, Month.WorkDays);
   NEXT(Month);
  END; (* WHILE OCCURE(Month) ... *)
  MAKEPART(R, tregm_Bot, HBal, WorkDays, FullBal, RDay, GrTime, GDay);
  CLOSEREP(R);
 END {TRegm};

 PUBLIC PROCEDURE CalcDuratfromBaseNorm();
  VAR
   LastDay: LIKE(RegList.Day);
 BEGIN
  L_General.Assert(ACCESS(RegHead), " ⠭ ० ࠡ");
  CheckClosed(RegHead.Period);
  L_General.Assert(SEARCH(Month, Period, RegHead.Period), "    "+L_DatTim.PeriodStr(RegHead.Period));
  L_StdFrm.Question("   "+L_DatTim.PeriodStr(RegHead.Period)+"  ⮬ 䨪");
  CalculateRegHead();
  L_General.Assert(RegHead.GrTime # 0, "㫥 ६  䨪");
  SETEMPTY(LastDay);
  L_General.Assert(SELECT(RegList, HumReg, RegHead.Regime, RegHead.Period), "  ० ࠡ  "+L_DatTim.PeriodStr(RegHead.Period));
  WHILE OCCURE(RegList) DO
   RegList.Durat:=Month.HBal / RegHead.GrTime * RegList.GrTime;
   REPLACE(RegList);
   IF RegList.Durat # 0 THEN
    LastDay:=RegList.Day;
   END;
   NEXT(RegList);
  END; (* WHILE OCCURE(RegList) ... *)
  CalculateRegHead();
  IF ~!LastDay & ((Month.HBal - RegHead.FullBal) # 0) THEN
   SRCINSEL(RegList, EQ, , LastDay);
   INC(RegList.Durat, Month.HBal - RegHead.FullBal);
   REPLACE(RegList);
   CalculateRegHead();
  END;
 END {CalcDuratfromBaseNorm};

BEGIN
 L_Events.ExecuteHandler();
END.
