(*
%Copyright   (c) Polak IT
%Author      24.03.2004 23:03:28 POLAK\GAV
%Purpose
%Type        report
%Specific    SYS
%Modified    26.02.2014 17:13:04 POLAK\Gina
%Environment
*)

 MODULE CrMTA [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_OwnData, L_AFM, Memo, L_Str, L_Staff, L_Tax, L_StdFrm;

 CONST
  RepName = "CrMTA";

  tc_OnDate  = 0;
  tc_InIntvl = 1;
  tc_Entire  = 2;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
"᮪ 䨧᪨    "+TaxAdv.TaxAdv+" "+TaxAdv.Name, C, ""
?, C, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|############################################################################|
|############################################################################|
|----------------------------------------------------------------------------|
||                               ||         |     |         㬬|
|-----|----------------------------------|-|----------|-------|--------------|
}
*)

(*
$P{ Line:
?, L, ""
?, L, ""
TaxInq.InqType, L, "||| | |||"
ManTA.StartD, L, "D.N.y"
ManTA.StopD, L, "N.y"
ManTA.Value, R, ",2-"
@
|#####|##################################|#|##########|#######|##############|
}
*)

(*
$P{ Totals:
?, R, ",2-"
@
|-------------------------------------------------------------|--------------|
|⮣                                                        |##############|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE ModeCond(TimeCond: SCAL[3]; InStateCond, wAutoCond: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF ~wAutoCond & (TaxInq.InqType = L_Tax.inqt_Auto) THEN
   RETURN 0;
  END;
  IF    TimeCond = tc_InIntvl THEN
   Result:=L_DatTim.IsActiveInIntvl_Inc(Memo.ud_fr(), Memo.ud_ut(), L_DatTim.Per(ManTA.StartD), ManTA.StopD);
  ELSIF TimeCond = tc_OnDate THEN
   Result:=L_DatTim.IsActive_Inc(Memo.ud_cd(), L_DatTim.Per(ManTA.StartD), ManTA.StopD);
  ELSE
   Result:=1;
  END;
  IF Result & InStateCond THEN
   SELECT(Staff, Man, , TaxInq.Man);
   WHILE OCCURE(Staff) DO
    IF    TimeCond = tc_InIntvl THEN
     L_Staff.PosToStaffLog(Staff.TSN, Memo.ud_ut(), 1);
     IF L_Staff.OrderInIntvl(Memo.ud_fr(), Memo.ud_ut()) THEN
      RETURN 1;
     END;
    ELSIF TimeCond = tc_OnDate THEN
     IF L_Staff.rInState(Memo.ud_cd()) THEN
      RETURN 1;
     END;
    ELSE
     IF L_Staff.rInState(SYSDATE()) THEN
      RETURN 1;
     END;
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   RETURN 0;
  ELSE
   RETURN Result;
  END;
 END {ModeCond};

 PUBLIC PROCEDURE CrMTA();
  CONST
   wac_Pool = "  ⮬᪨ ࠢ| ⮬ ⮬᪨ ࠢ";
   isc_Pool = " |騥   ";
  VAR
   Total      : NUMERIC[2];
   First      : SCAL[2];
   TimeCond   : SCAL[3];
   tc_Pool    : STRING[];
   InStateCond: SCAL[2];
   wAutoCond  : SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(TaxAdv), " ⠭  䨪樨 ");
  tc_Pool:=" " + L_DatTim.DateStr(Memo.ud_cd()) +
           "| ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut()) +
           "|  ";
  TimeCond   :=tc_OnDate;
  InStateCond:=1;
  wAutoCond  :=1;
  STDFORM(L_StdFrm.sf_Choice("|                                                               "+
                             "|࠭祭  ६ %####################################%"+
                             "|                                                               "+
                             "|᪨         %####################################%"+
                             "|                                                               "+
                             "|⮬᪨ ࠢ %####################################%",
                             "%L<"+tc_Pool+">I"+
                             "%L<"+isc_Pool+">I"+
                             "%L<"+wac_Pool+">I"),
          " ᮪ 䨧᪨    ", INFORM, -1, TimeCond, InStateCond, wAutoCond);
  Total:=0;
  L_AFM.MakeIndex("tmp", "Man    : LIKE(TaxInq.Man);" +
                         "InqType: LIKE(TaxInq.InqType);" +
                         "Date   : LIKE(TaxInq.Date);" +
                         "StartD : LIKE(ManTA.StartD);" +
                         "TaxInq : LIKE(TaxInq.TaxInq)");

  SELECT(ManTA, TaxAdv, , TaxAdv.TaxAdv);
  WHILE OCCURE(ManTA) DO
   CONFORM(ManTA, TaxInq);
   PROMPT(TaxInq.Man);
   IF ModeCond(TimeCond, InStateCond, wAutoCond) THEN
    ADD(tmp, tmp, , TaxInq.Man, TaxInq.InqType, TaxInq.Date, ManTA.StartD, TaxInq.TaxInq);
   END;
   NEXT(ManTA);
  END; (* WHILE OCCURE(ManTA) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);

  MAKEPART(R, Top, L_Str.PoolItem(wac_Pool, wAutoCond) + ", " + L_Str.PoolItem(isc_Pool, InStateCond),
                   L_Str.PoolItem(tc_Pool, TimeCond));
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   First:=1;
   CHANGESEL(tmp, tmp, , tmp.Man);
   PROMPT(tmp.Man);
   WHILE OCCURE(tmp) DO
    SEARCH(TaxInq, TaxInq, , tmp.TaxInq);
    SELECT(ManTA, TaxInq, , tmp.TaxInq, TaxAdv.TaxAdv, tmp.StartD);
    WHILE OCCURE(ManTA) DO
     IF ModeCond(TimeCond, InStateCond, wAutoCond) THEN
      IF First THEN
       SEARCH(Man, Man, , tmp.Man);
       MAKEPART(R, Line, Man.Man, Man.Name);
       First:=0;
      ELSE
       MAKEPART(R, Line);
      END;
      IF ~!ManTA.Value THEN
       INC(Total, ManTA.Value);
      END;
     END;
     NEXT(ManTA);
    END; (* WHILE OCCURE(ManTA) ... *)
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
   LAST(tmp);
   CHANGESEL(tmp, tmp);
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)

  MAKEPART(R, Totals, Total);
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("tmp");
 END {CrMTA};

END.
