(*
%Copyright   (c) Polak IT
%Author      21.10.2004 11:55:18 POLAK\San
%Purpose       ஬
%Type        control
%Specific    SYS
%Modified    21.07.2014 13:10:49 POLAK\LDA
%Environment
*)

 MODULE CUCopy [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_CUC, L_XDoc, L_OwnData, L_MDoc, L_Car, L_Acnt,
        L_DatTim, L_AFM, L_TRS, L_Str, L_Way, P_CUC, P_MDoc, E_Utils, L_Env, L_BarCode, L_Stock,
        L_AR, P_Rpr, L_StdFrm, L_Rpr, L_WDO;

 PRIVATE PROCEDURE CUCopy_OnReposition();
  VAR
   Modifiable: SCAL[2];
 BEGIN
  IF ACCESS(CUCopy) THEN
   Modifiable:=~SELECT(MDocLCU, CUCopy, CUCopy.CUCopy, L_MDoc.st_Passed);
   RTI.Get().CurZone.Fields("CUCopy.Begin").Modifiable:=Modifiable;
   RTI.Get().CurZone.Fields("CUCopy.Till" ).Modifiable:=Modifiable;
  END;
 END {CUCopy_OnReposition};

 PRIVATE PROCEDURE CheckAutomaticCUCopy();
 BEGIN
  IF L_CUC.cucRole_IsCar() |
     L_CUC.cucRole_IsOutCar() |
     L_CUC.cucRole_IsTckBag() |
     L_CUC.cucRole_IsKeyAss() THEN
   L_General.Assert_wReferToAdmin(0,
                                  " ⮬᪨ ᮧ  (" + L_Str.PoolItem(L_CUC.o_Pool, CUCopy.Origin) + ")");
  END;
  L_General.Assert(~L_CUC.cucRole_IsBulkOfTck(0),
                   " ⮬᪨ ᮧ  㯯 ஢ ");
  L_General.Assert_wReferToAdmin(~L_CUC.cucRole_IsTck(),
                                 " ⮬᪨ ᮧ  '誨' ⭮ த樨");
 END {CheckAutomaticCUCopy};

 PRIVATE PROCEDURE CUCopy_OnBeforeInsert();
 BEGIN
  CUCopy.Serial:=L_CUC.GetDefaultSerial(CUCopy.CUCopy);
  REPLACE(CUCopy);
 END {CUCopy_OnBeforeInsert};

 PRIVATE PROCEDURE CUCopy_OnBeforeEdit();
 BEGIN
  CheckAutomaticCUCopy();
 END {CUCopy_OnBeforeEdit};

 PRIVATE PROCEDURE CUCopy_OnAfterEdit();
 BEGIN
  IF CUCopy.Serial # GE_PVALUE(CUCopy.Serial) THEN
   IF L_CUC.cucRole_IsTck() THEN
    L_StdFrm.Choice("   /  '誨' ⭮ த樨");
   END;
  END;
 END {CUCopy_OnAfterEdit};

 PRIVATE PROCEDURE CUCopy_OnBeforeAnyDelete();
 BEGIN
  IF ~!CUCopy.Storage THEN
   CONFORM(CUCopy, Storage);
   L_General.Error(" ᮮ⭥ᥭ   " +
                   L_Str.PoolItem(L_Stock.st_Pool, Storage.Type) + " " + Storage.Storage);
  END;
 END {CUCopy_OnBeforeAnyDelete};

 PRIVATE PROCEDURE CUCopy_OnBeforeDelete();
 BEGIN
  CheckAutomaticCUCopy();
  CUCopy_OnBeforeAnyDelete();
 END {CUCopy_OnBeforeDelete};

 PUBLIC PROCEDURE CUCopy_OnBeforeNoninteractiveDelete();
 BEGIN
  CUCopy_OnBeforeAnyDelete();
 END {CUCopy_OnBeforeNoninteractiveDelete};

 PRIVATE PROCEDURE SetMDocLCUOpKindPool(ZoneNbr: NUMERIC[0]);
 BEGIN
  RTI.Get().CurWindow.Zones(ZoneNbr).Fields("MDocLCU.OpKind").Format:=L_CUC.ok_Pool;
 END {SetMDocLCUOpKindPool};

 PRIVATE PROCEDURE CUCopyA_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="CUCopy";
  L_WDO.iZone        (1).PermanentFilter:="(CUCopy.Origin="+L_Str.IntStr(L_CUC.o_Other)+")|" +
                                          "(CUCopy.Origin="+L_Str.IntStr(L_CUC.o_KeyAss)+")";
  L_WDO.iSubwindow   (1, "CUCopyE");
  L_WDO.iZone        (2).Narrowing:="MDocLCU.CUCopy=CUCopy.CUCopy";
  L_WDO.iZone        (2).ViewOnly:=1;
  SetMDocLCUOpKindPool(2);
 END {CUCopyA_OnInitializeWindow};

 PRIVATE PROCEDURE CUCopyE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="CUCopy";
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete, L_WDO.e_OnReposition]);
  L_WDO.iUnmodifiable(0, ["CUCopy.Math", "CUCopy.CUCopy"]);
  L_WDO.iMayBeEmpty  (0, ["CUCopy.InitRun", "CUCopy.Comment", "CUCopy.Serial", "CUCopy.Begin", "CUCopy.Till", "CUCopy.MnfDate"]);
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iZone        (1).Narrowing:="MDocLCU.CUCopy=CUCopy.CUCopy";
  L_WDO.iProgs       (1, "CUCopy");
  SetMDocLCUOpKindPool(1);
 END {CUCopyE_OnInitializeWindow};

 PRIVATE PROCEDURE CUCopy_OnInitializeWindow();
 BEGIN
  L_WDO.iField       (0, "Math.Name").LineBreakEnable:=1;
  L_WDO.iZone        (1).Narrowing:="CUCopy.Math=Math.Math";
  L_WDO.iZone        (1).PermanentFilter:="(CUCopy.Origin="+L_Str.IntStr(L_CUC.o_Other)+")|" +
                                          "(CUCopy.Origin="+L_Str.IntStr(L_CUC.o_KeyAss)+")";
  L_WDO.iSubwindow   (1, "CUCopyE");
 END {CUCopy_OnInitializeWindow};

 PUBLIC PROCEDURE StandOnCarUntDoc();
 BEGIN
  L_General.Assert(ACCESS(MDocLCU), " ⠭    ");
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDocLCU.MDocKind, MDocLCU.MDoc), "");
 END {StandOnCarUntDoc};

(*
$P{ fc_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
CUCopy.CUCopy, L, ""
SYSDATE(), L, "D.N.y"
CUCopy.Serial, L, ""
Math.Math, L, ""
Math.Name, L, ""
Vendor.Vendor, L, ""
Vendor.Name, L, ""
CUCopy.MnfDate, L, "D.N.y"
?, L, L_CUC.cnd_Pool
?, L, L_CUC.cnd_Pool
CUCopy.InitRun, L, "0"
?, L, L_CUC.l_Pool
@
############################################################# ########## #####
=#####========================================================================
|             楢 窠  #######  ##########              |
|----------------------------------------------------------------------------|
|᪮           ################################################   |
|                      ##### #############################################|
|⮢⥫             ### ###############################################|
| ᪠             ##########                                         |
|ࢮ砫쭮 ﭨ ###                                                |
|饥 ﭨ        ###                                                |
|砫 ஡         ########                                           |
|⮭宦          ##########################                         |
|============================================================================|
|      |㬥   |.|ਬ砭                                |
|----------|-----------|----------|------------------------------------------|
}
*)

(*
$P{ fc_Line:
MDocLCU.Date, L, "D.N.y"
L_MDoc.MDocStr(MDocLCU.MDocKind, MDocLCU.MDoc), L, ""
MDocLCU.OpKind, L, L_CUC.ok_Pool
?, L, ""
@
|##########|###########|##########|##########################################|
}
*)

(*
$P{ fc_rbn_Top:
@
|============================================================================|
|          |          |                     |   ஡, .   |६,  |
|      |.|T࠭ᯮ⭮ ।⢮|--------------------|-----------|
|          |          |                     | ।|.| ᥣ| .|ᥣ|
}
*)

(*
$P{ fc_rbn_Dlm:
@
|----------|----------|---------------------|------|------|------|-----|-----|
}
*)


(*
$P{ fc_rbn_Line:
?, L, "D.N.y"
?, L, L_CUC.ok_Pool
?, L, ""
Mark.Name, L, ""
?, R, "1."
?, R, "1."
?, R, "1."
?, R, "1."
?, R, "1."
@
|##########|##########|#### ################|######|######|######|#####|#####|
}
*)

(*
$P{ fc_RetirementReason:
P_CUC.GetRetirementReason(CUCopy.CUCopy, SYSDATE()), L, ""
P_CUC.GetRetirementDescription(CUCopy.CUCopy, SYSDATE()), L, ""
P_CUC.GetRetirementComments(CUCopy.CUCopy, SYSDATE()), L, ""
?, L, ""
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
@
|----------------------------------------------------------------------------|
|稭 ᯨᠭ ###################                                        |
|ᠭ         ###########################################################|
|ਨ      ###########################################################|
|----------------------------------------------------------------------------|
|㬥                                                                    |
|,      ########################                                   |
|뤠            ###########################################################|
| 뤠      ##########   ⢨⥫  ##########                    |
}
*)

(*
$P{ fc_Bot:
@
|----------------------------------------------------------------------------|
|ᮡ ⬥⪨                                                              |
|                                                                            |
|                                                                            |
|                                                                            |
|                                                                            |
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE E_fc_MakeBot();
  VAR
   local: PROC;
 BEGIN
  local:=PROCREF(E_Utils.cucfc_SpecialBot);
  IF ~!local THEN
   local()
  ELSE
   MAKEPART(R, fc_Bot);
  END;
 END {E_fc_MakeBot};

 PRIVATE PROCEDURE fc_Make_RBNLine(_BoxNbr: LIKE(Car.BoxNbr);
                                   OnDate : DATE;
                                   _OpKind: LIKE(MDocLCU.OpKind);
                                   VAR
                                    lastDateRun: NUMERIC[0]);
  VAR
   onDateRun: NUMERIC[0];
 BEGIN
  L_Car.AccessMark(_BoxNbr, OnDate);
  onDateRun:=L_CUC.GetCUCopyTotalRun(CUCopy.CUCopy, OnDate, 1);
  MAKEPART(R, fc_rbn_Line,
           OnDate,
           _OpKind,
           _BoxNbr,
           (onDateRun - lastDateRun)/1000,
           L_CUC.GetCUCopyLastBoxNbrRun(CUCopy.CUCopy, OnDate, 1)/1000,
           onDateRun/1000,
           L_DatTim.DaysToMonths(L_CUC.GetCUCopyLastBoxNbrTim(CUCopy.CUCopy, OnDate, 1)),
           L_DatTim.DaysToMonths(L_CUC.GetCUCopyTotalTim(CUCopy.CUCopy, OnDate, 1)));
  lastDateRun:=onDateRun;
 END {fc_Make_RBNLine};

 PRIVATE PROCEDURE IsMDocLCU_w_RealBoxNbr(): SCAL[2];
 BEGIN
  RETURN ~!MDocLCU.BoxNbr & L_Env.RealBoxNbr(MDocLCU.BoxNbr);
 END {IsMDocLCU_w_RealBoxNbr};

 PUBLIC PROCEDURE MakeFaceCard();
  CONST
   RepName = "CUCFC";
  VAR
   lastDateRun,
   RealBNCnt: NUMERIC[0];
   _Location: L_CUC.tLocation;
   InitCond,
   CurCond  : L_CUC.tCondition;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(CUCopy), " ⠭ ");
  L_General.Assert(~!CUCopy.Math, "楢      ।ᬮ७");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF L_CUC.AccessMDocLCU(CUCopy.CUCopy, SYSDATE()) THEN
   _Location:=L_CUC.DefineCULocation(MDocLCU.OpKind);
   InitCond:=L_CUC.GetInitCUCondition(CUCopy.CUCopy);
   CurCond :=L_CUC.GetCUCondition(CUCopy.CUCopy, SYSDATE());
  ELSE
   _Location:=L_CUC.l_Others;
   SETEMPTY(InitCond, CurCond);
  END;
  CONFORM(CUCopy, Math);
  CONFORM(Math, Vendor);
  MAKEPART(R, fc_Top, RepName, InitCond, CurCond, _Location);
  RealBNCnt:=0;
  SELECT(MDocLCU, CUCopy, , CUCopy.CUCopy, L_MDoc.st_Passed);
  WHILE OCCURE(MDocLCU) DO
   IF IsMDocLCU_w_RealBoxNbr() THEN
    INC(RealBNCnt);
   END;
   CONFORM(MDocLCU, MDoc);
   CONFORM(MDoc, MDocKind);
   IF L_MDoc.IsExternalMDocKind() THEN
    CONFORM(MDoc, Firm);
    MAKEPART(R, fc_Line, Firm.Firm + " " + Firm.Name);
   ELSE
    MAKEPART(R, fc_Line, P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Note));
   END;
   NEXT(MDocLCU);
  END; (* WHILE OCCURE(MDocLCU) ... *)
  IF ~!CUCopy.InitRun THEN
   lastDateRun:=CUCopy.InitRun;
  ELSE
   lastDateRun:=0;
  END;
  IF RealBNCnt > 0 THEN
   MAKEPART(R, fc_rbn_Top);
   MAKEPART(R, fc_rbn_Dlm);
   SELECT(MDocLCU, CUCopy, , CUCopy.CUCopy, L_MDoc.st_Passed);
   WHILE OCCURE(MDocLCU) DO
    IF IsMDocLCU_w_RealBoxNbr() THEN
     fc_Make_RBNLine(MDocLCU.BoxNbr, MDocLCU.Date, MDocLCU.OpKind, lastDateRun);
    END;
    NEXT(MDocLCU);
   END; (* WHILE OCCURE(MDocLCU) ... *)
   IF LAST(MDocLCU) & (L_CUC.DefineCULocation(MDocLCU.OpKind) = L_CUC.l_inExpl) THEN
    IF IsMDocLCU_w_RealBoxNbr() THEN
     MAKEPART(R, fc_rbn_Dlm);
     fc_Make_RBNLine(MDocLCU.BoxNbr, SYSDATE(), EMPTYOF(MDocLCU.OpKind), lastDateRun);
    END;
   END;
  END;
  IF _Location = L_CUC.l_WrittenOff THEN
   IF P_CUC.HasActualCUCPro(CUCopy.CUCopy, SYSDATE(), P_CUC.P_RetirementReason) THEN
    MAKEPART(R, fc_RetirementReason, CUCPro.DocNum, CUCPro.DocGiveS, CUCPro.DocGiveD, CUCPro.DocExpD);
   ELSE
    MAKEPART(R, fc_RetirementReason);
   END;
  END;
  E_fc_MakeBot();
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MakeFaceCard};

(*
$P{ m_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
CUCopy.Serial, L, ""
Math.Math, L, ""
Math.Name, L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|᪮   ###############################################################                            |
|              ##### #####################################################################################|
|============================================================================================================|
|C|      |㬥                 |.|  ६    |ਬ砭                               |
|-|----------|-------------------------|----------|----------------|-----------------------------------------|
}
*)

(*
$P{ m_Line:
?, L, "||"
?, L, "D.N.y"
?, L, ""
?, L, ""
?, L, "D.N.y"
?, L, "H:M"
?, L, ""
@
|#|##########|#########################|##########|########## #####|#########################################|
}
*)

(*
$P{ mp_Top:
@
|============================================================================================================|
|                                                 ⠢                                                     |
|------------------------------------------------------------------------------------------------------------|
|                                             饥 ﭨ                                              |
|------------------------------------------------------------------------------------------------------------|
}
*)


(*
$P{ mp_Line:
CUCopy.CUCopy, L, ""
CUCopy.Serial, L, ""
Math.Math, L, ""
Math.Name, L, ""
@
|####### ###################################|##### ##########################################################|
}
*)

(*
$P{ mpd_Top:
@
|------------------------------------------------------------------------------------------------------------|
|                                                 㬥                                                  |
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ mpd_Line:
MDoc.Date, L, "D.N.y"
L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L, ""
MDoc.Dest, L, ""
Dest.Name, L, ""
@
|##########|############|### ################################################################################|
}
*)

(*
$P{ m_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE IsGatheringMDocLCU(): SCAL[2];
 BEGIN
  RETURN MDocLCU.OpKind = L_CUC.ok_Complexing;
 END {IsGatheringMDocLCU};

 PRIVATE PROCEDURE IsCannibalisationMDocLCU(): SCAL[2];
 BEGIN
  RETURN MDocLCU.OpKind = L_CUC.ok_Cannibalisation;
 END {IsCannibalisationMDocLCU};

 PRIVATE PROCEDURE mpd_Type(): STRING[];
 BEGIN
  IF    IsGatheringMDocLCU() THEN
   RETURN "⮢";
  ELSIF IsCannibalisationMDocLCU() THEN
   RETURN "㪮⮢";
  ELSE
   RETURN "祥";
  END;
 END {mpd_Type};

 PRIVATE PROCEDURE RestNbrStr(): STRING[];
 BEGIN
  CONFORM(TckRcDL, TckKind);
  IF L_TRS.IsBulk_wCUC() THEN
   IF L_CUC.cucRole_IsBulkOfTck(1) THEN
    RETURN L_Str.IntStr(L_TRS.BulkCUCAmount()) + " ";
   ELSE
    RETURN "";
   END;
  ELSIF TckKind.NbrPrc > 0 THEN
   IF ~!TckRcDL.RestNbr THEN
    RETURN L_Str.FixedIntStr(TckRcDL.RestNbr, TckKind.NbrPrc) + " ";
   ELSE
    RETURN L_Str.Repeat(" ", TckKind.NbrPrc + 1);
   END;
  ELSE
   RETURN L_Str.IntStr(TckRcDL.RestNbr) + " ";
  END;
 END {RestNbrStr};

 PRIVATE PROCEDURE GetDateJrn(    trgXDocType: L_XDoc.tXDocType;
                          trgXDocKind: LIKE(XDocJrn.XDocKind);
                          trgXDoc    : LIKE(XDocJrn.XDoc);
                      VAR D          : LIKE(XDocJrn.Date);
                      VAR T          : LIKE(XDocJrn.BegTime));
 BEGIN
  SETEMPTY(D, T);
  IF SELECT(XDocJrn, XDocJrn, trgXDocType, trgXDocKind, trgXDoc) THEN
   D:=XDocJrn.Date;
   T:=XDocJrn.BegTime;
  ELSE
   L_XDoc.CheckXDocJrnNeed(trgXDocType, trgXDocKind, trgXDoc);
  END;
 END {GetDateJrn};

 PRIVATE PROCEDURE Movement_CheckTooManyData(VAR Count: NUMERIC[0]; VAR AlreadyAsked: SCAL[2]; VAR From: DATE);
  CONST
   TooMany = 40;
  VAR
   Msg    : STRING[];
   Timeout: NUMERIC[0];
 BEGIN
  INC(Count);
  IF ~AlreadyAsked & (Count > TooMany) THEN
   AlreadyAsked:=1;
   Msg:=" ਨ 㦥   " + L_Str.IntStr(TooMany) + " 㬥⮢." +
        "||⮢  ?";
   Timeout:=10;
   TRY
    STDMSG(Msg, QUESTION, , Timeout);
   EXCEPT
   ON Exc: Exc_Raise DO
    From:=tmp.Date;
   END; (* TRY *)
  END;
 END {Movement_CheckTooManyData};

 PUBLIC PROCEDURE Movement();
  CONST
   RepName = "CUCMv";
  VAR
   Comment     : STRING[];
   D,
   From        : DATE;
   T           : TIME;
   trds        : LIKE(TckRcD.Status);
   mds         : LIKE(MDoc.Status);
   Count       : NUMERIC[0];
   AlreadyAsked: SCAL[2];
 BEGIN
  APP.Get().NewPrompt("("+RepName+")");
  TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_OFF)]
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   L_AR.GrantRightsUnconditionally();
   L_General.Assert(ACCESS(CUCopy), " ⠭ ");
   L_AFM.MakeIndex("tmp", "Status : SCAL[3]; " +
                          "Date   : DATE; " +
                          "PassDTS: TIMESTAMP; " +
                          "XDocId : " + GET_TYPE_SPEC(L_XDoc.tXDocId).Name + ";" +
                          "LNbr   : SCAL[1E4]");

   SETEMPTY(From);
   SETZERO(Count, AlreadyAsked);
   FOR_EACH trds DO
    SETSEL(TckRcDL, CUCopy, CUCopy.CUCopy, trds);
    LAST(TckRcDL);
    WHILE OCCURE(TckRcDL) & (!From | (TckRcDL.Date >= From)) DO
     CONFORM(TckRcDL, TckRcD);
     PROMPT(":" + TckRcD.TckRcD);
     ADD(tmp, tmp, , TckRcD.Status, TckRcD.Date, TckRcD.PassDTS,
                     L_XDoc.curXDocId(L_XDoc.xdt_TckRcD), TckRcDL.TRDLNbr);
     Movement_CheckTooManyData(Count, AlreadyAsked, From);
     PREV(TckRcDL);
    END; (* WHILE OCCURE(TckRcDL) ... *)
    SETSEL(TckRcDLL, CUCopy, CUCopy.CUCopy, trds);
    LAST(TckRcDLL);
    WHILE OCCURE(TckRcDLL) & (!From | (TckRcDLL.Date >= From))  DO
     CONFORM(TckRcDLL, TckRcD);
     PROMPT(":" + TckRcD.TckRcD);
     ADD(tmp, tmp, , TckRcD.Status, TckRcD.Date, TckRcD.PassDTS,
                     L_XDoc.curXDocId(L_XDoc.xdt_TckRcD), TckRcDLL.TRDLNbr);
     Movement_CheckTooManyData(Count, AlreadyAsked, From);
     PREV(TckRcDLL);
    END; (* WHILE OCCURE(TckRcDLL) ... *)
   END; (* FOR_EACH *)

   FOR_EACH mds DO
    SETSEL(MDocLCU, CUCopy, CUCopy.CUCopy, mds);
    LAST(MDocLCU);
    WHILE OCCURE(MDocLCU) & (!From | (MDocLCU.Date >= From))  DO
     PROMPT(L_MDoc.MDocStr(MDocLCU.MDocKind, MDocLCU.MDoc));
     ADD(tmp, tmp, , MDocLCU.Status, MDocLCU.Date, MDocLCU.PassDTS,
                     L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDocLCU.MDocKind, MDocLCU.MDoc),
                     MDocLCU.MDLNbr);
     Movement_CheckTooManyData(Count, AlreadyAsked, From);
     PREV(MDocLCU);
    END; (* WHILE OCCURE(MDocLCU) ... *)
   END; (* FOR_EACH *)
 
   SETSEL(RprS, CUCopy, CUCopy.CUCopy);
   LAST(RprS);
   WHILE OCCURE(RprS) & (!From | (RprS.OrdDate >= From)) DO
    PROMPT(":" + RprS.RprS);
    IF RprS.Status # L_Rpr.ms_Cancel THEN
     ADD(tmp, tmp, , L_MDoc.st_Passed(*sic!*), RprS.OrdDate, PackTIMESTAMP(RprS.OrdDate, RprS.OrdTime),
                     L_XDoc.curXDocId(L_XDoc.xdt_RprS), 0001);
     Movement_CheckTooManyData(Count, AlreadyAsked, From);
    END;
    PREV(RprS);
   END; (* WHILE OCCURE(RprS) ... *)
 
   L_XDoc.sl_Init("  " + CUCopy.CUCopy);
   OPENREP(R, L_General.NameConnection(RepName), Create);
   CONFORM(CUCopy, Math);

   IF !From THEN
    MAKEPART(R, m_Top, RepName, "  " + CUCopy.CUCopy);
   ELSE
    MAKEPART(R, m_Top, RepName, "  " + CUCopy.CUCopy + " (c " + L_DatTim.DateStr(From) + ")");
   END;
   SELECT(tmp, tmp);
   LAST(tmp);
   WHILE OCCURE(tmp) DO
    PROMPT(". " + L_XDoc.XDocStr(tmp.XDocId));
    L_XDoc.sl_AddItem(tmp.XDocId, L_XDoc.extXDocStr(tmp.XDocId, L_XDoc.xdast_wStatus));
    L_XDoc.PositionOnXDoc(tmp.XDocId);
 
    IF    L_XDoc.ExtractXDocType(tmp.XDocId) = L_XDoc.xdt_MDoc THEN
     Comment:="";
     IF ~!MDoc.BoxNbr THEN
      L_Car.AccessMark(MDoc.BoxNbr, MDoc.Date);
      Comment:=MDoc.BoxNbr + " " + Mark.Name;
     ELSIF L_MDoc.IsMDocToTransferBetweenAdvanceHolders() THEN
      CONFORM(MDoc, Dest);
      IF Dest.Type = L_Acnt.dt_Debit THEN
       SELECT(Staff, Storage, , MDoc.Storage);
      ELSE
       SELECT(Staff, Storage, , MDoc.Storage2);
      END;
      CONFORM(Staff, Man);
      Comment:=Staff.TSN + " " + L_Str.ShortName(Man.Name);
     ELSIF ~!MDoc.TSN THEN
      CONFORM(MDoc, Staff);
      CONFORM(Staff,  Man);
      Comment:=Staff.TSN + " " + L_Str.ShortName(Man.Name);
     END;
     GetDateJrn(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, D, T);
     SELECT(MDocLCU, MDoc, , MDoc.MDocKind, MDoc.MDoc, tmp.LNbr, CUCopy.CUCopy);
     MAKEPART(R, m_Line, tmp.Status, tmp.Date, L_XDoc.XDocStr(tmp.XDocId),
                         L_Str.PoolItem(L_CUC.ok_Pool, MDocLCU.OpKind), D, T, Comment);
    ELSIF L_XDoc.ExtractXDocType(tmp.XDocId) = L_XDoc.xdt_TckRcD THEN
     SEARCH(TckRcDL, TckRcD, , TckRcD.TckRcD, tmp.LNbr);
     SETEMPTY(D, T);
     GetDateJrn(L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD, D, T);
     IF L_TRS.IsSaleTckRcD(TckRcD.Type) THEN
      CONFORM(XDocJrn, AcsObj);
      Comment:=AcsObj.FullName;
     ELSE
      CONFORM(TckRcD, TckRcS);
      CONFORM(TckRcS, Staff);
      CONFORM(Staff,  Man);
      Comment:=RestNbrStr() + Staff.TSN + " " + L_Str.ShortName(Man.Name);
     END;
     MAKEPART(R, m_Line, tmp.Status, tmp.Date, L_XDoc.XDocStr(tmp.XDocId),
                         L_Str.PoolItem(L_TRS.trdt_Pool, TckRcD.Type), D, T, Comment);
    ELSIF L_XDoc.ExtractXDocType(tmp.XDocId) = L_XDoc.xdt_RprS THEN
     MAKEPART(R, m_Line, tmp.Status, tmp.Date, L_XDoc.XDocStr(tmp.XDocId),
                         "", RprS.OrdDate, RprS.OrdTime, P_Rpr.GetShortRprSDescr(RprS.RprS));
    ELSE
     L_General.CallUs(0);
    END;
    PREV(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
 
   L_AFM.MakeIndex("_MDoc", "Date    : LIKE(MDoc.Date);" +
                            "DoneDTS : LIKE(MDoc.DoneDTS);" +
                            "MDocKind: LIKE(MDoc.MDocKind);" +
                            "MDoc    : LIKE(MDoc.MDoc)");
 
   L_AFM.MakeIndex("_Part", "CUCopy: LIKE(CUCopy.CUCopy)");
 
   SELECT(MDoc, CUCopy, , CUCopy.CUCopy);
   WHILE OCCURE(MDoc) DO
    PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
    IF MDoc.Status = L_MDoc.st_Passed THEN
     ADD(_MDoc, _MDoc, , MDoc.Date, MDoc.DoneDTS, MDoc.MDocKind, MDoc.MDoc);
    END;
    NEXT(MDoc);
   END; (* WHILE OCCURE(MDoc) ... *)
 
   IF SELECT(_MDoc, _MDoc) THEN
    PROMPT(L_MDoc.MDocStr(_MDoc.MDocKind, _MDoc.MDoc));
    WHILE OCCURE(_MDoc) DO
     SEARCH(MDoc, MDoc, , _MDoc.MDocKind, _MDoc.MDoc);
  
     SELECT(MDocLCU, MDoc, , _MDoc.MDocKind, _MDoc.MDoc);
     WHILE OCCURE(MDocLCU) DO
      IF    IsGatheringMDocLCU() THEN
       ADD(_Part, _Part, , MDocLCU.CUCopy);
      ELSIF IsCannibalisationMDocLCU() THEN
       IF SEARCH(_Part, _Part, MDocLCU.CUCopy) THEN
        REMOVE(_Part);
       END;
      END;
      NEXT(MDocLCU);
     END; (* WHILE OCCURE(MDocLCU) ... *)
     NEXT(_MDoc);
    END; (* WHILE OCCURE(_MDoc) ... *)
  
    MAKEPART(R, mp_Top);
    SELECT(_Part, _Part);
    WHILE OCCURE(_Part) DO
     PROMPT(_Part.CUCopy);
     SEARCH(CUCopy, CUCopy, , _Part.CUCopy);
     SAVE(Math);
     CONFORM(CUCopy, Math);
     MAKEPART(R, mp_Line);
     RESTORE(Math);
     NEXT(_Part);
    END; (* WHILE OCCURE(_Part) ... *)
  
    MAKEPART(R, mpd_Top);
    SELECT(_MDoc, _MDoc);
    LAST(_MDoc);
    WHILE OCCURE(_MDoc) DO
     PROMPT(L_MDoc.MDocStr(_MDoc.MDocKind, _MDoc.MDoc));
     SEARCH(MDoc, MDoc, , _MDoc.MDocKind, _MDoc.MDoc);
     CONFORM(MDoc, Dest);
     MAKEPART(R, mpd_Line);
     PREV(_MDoc);
    END; (* WHILE OCCURE(_MDoc) ... *)
   END;
   MAKEPART(R, m_Bot);
   CLOSEREP(R);
   L_XDoc.sl_Done();
  EXCEPT
  END;  (* TRY *)
 END {Movement};

 PRIVATE PROCEDURE CarUnit_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "CarUnitE");
  L_WDO.iProgs       (1, "CUCopy");
 END {CarUnit_OnInitializeWindow};

 PRIVATE PROCEDURE CarUnitE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterMdf]);
  L_WDO.iMayBeEmpty  (0, ["CarUnit.SNDate"]);
  L_WDO.iField       (0, "CarUnit.Type").Format:=L_CUC.cut_Pool;
  L_WDO.iProgs       (0, "CUCopy");
 END {CarUnitE_OnInitializeWindow};

 PRIVATE PROCEDURE CheckIsFictCarUnit(trgCarUnit: LIKE(CarUnit.CarUnit));
  CONST
   cu_Fict = 00;
 BEGIN
  L_General.Assert(trgCarUnit # cu_Fict, " ॣ " + FLDTOSTR(cu_Fict, "L0", 4) + " १ࢨ஢ ⮏");
 END {CheckIsFictCarUnit};

 PRIVATE PROCEDURE CarUnit_OnBeforeEdit();
 BEGIN
  CheckIsFictCarUnit(CarUnit.CarUnit);
 END {CarUnit_OnBeforeEdit};

 PRIVATE PROCEDURE CarUnit_OnBeforeDelete();
 BEGIN
  CheckIsFictCarUnit(CarUnit.CarUnit);
 END {CarUnit_OnBeforeDelete};

 PRIVATE PROCEDURE CarUnit_OnAfterInsert();
 BEGIN
  CheckIsFictCarUnit(CarUnit.CarUnit);
 END {CarUnit_OnAfterInsert};

 PRIVATE PROCEDURE CarUnit_OnAfterEdit();
 BEGIN
  CheckIsFictCarUnit(GE_PVALUE(CarUnit.CarUnit));
 END {CarUnit_OnAfterEdit};

 PUBLIC PROCEDURE InputSerialFromBCS();
  VAR
   Dummy: L_BarCode.tBarCodeType;
 BEGIN
  L_General.Assert(ACCESS(CUCopy), " ⠭ ");
  L_BarCode.GetBarCode("᪮  ", "", "", 0, 1, CUCopy.Serial, Dummy);
  REPLACE(CUCopy);
 END {InputSerialFromBCS};

BEGIN
 L_Events.ExecuteHandler();
END.
