(*
%Copyright   (c) Polak IT
%Author      20.10.2004 11:58:16 POLAK\GAV
%Purpose     ᮪ ࠡ⭨   ࠡ  ⠡
%Type        report
%Specific    SYS
%Modified    22.07.2013 12:56:16 POLAK\LDA
%Environment
*)

 MODULE C_JMode [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_OwnData, L_General, Memo, L_DatTim, L_AFM, L_Staff, L_Sheet, L_Env;

 PRIVATE CONST
  pt_Month  = 0;
  pt_Period = 1;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
JMode.JMode, L, ""
JMode.Name, L, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
| ࠡ  ⠡ ## ##################################                  |
}
*)

(*
$P{ SubTop:
Sort.Sort, L, ""
Sort.Name, L, ""
?, R, "1."
?, R, "0"
@
|----------------------------------------------------------------------------|
| ### ###################################                 |#######|####|
|---------------------------------------------------------------|-------|----|
|  |                        |                    |  ६| |
|-----|---------------------------|-----------------------------|-------|----|
}
*)

(*
$P{ Line:
?, L, ""
Man.Name, L, ""
Post.Post, L, ""
Post.Name, L, ""
?, R, "1."
?, R, "0"
@
|#####|###########################|### #########################|#######|####|
}
*)

(*
$P{ Bot:
?, R, "1."
?, R, "0"
@
|---------------------------------------------------------------|-------|----|
|⮣  ।                                           |#######|####|
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Make(PerType: SCAL[2]);
  VAR
   D,
   Beg,
   End      : DATE;
   tottim   : NUMERIC[3];
   totdays  : NUMERIC[0];
   _Tim     : LIKE(Sheet.Tim);
   _ShtSign : LIKE(JMode.ShtSign);
   Need,
   IsHole,
   fromSheet: SCAL[2];
   _JMode   : LIKE(JMode.JMode);
   RepName  : STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(JMode), " ⠭  ࠡ");
  _JMode:=JMode.JMode;

  RepName:="CJMd" + PerType;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF PerType = pt_Month THEN
   Beg:=Memo.tmp_mb();
   End:=Memo.tmp_me();
   MAKEPART(R, Top, RepName, "⢮   ६  " + L_DatTim.PeriodStr(Beg));
  ELSE
   Beg:=Memo.From();
   End:=Memo.UpTo();
   MAKEPART(R, Top, RepName, "⢮   ६  ਮ  " + L_DatTim.DateStr(Beg) + "  " + L_DatTim.DateStr(End));
  END;
  L_AFM.MakeMultipleIndex("tot", "Sort: LIKE(Sort.Sort);" +
                                 "tim : NUMERIC[3];" +
                                 "days: NUMERIC[0]",
                             "tot: Sort");
  L_AFM.MakeMultipleIndex("tmp", "Sort: LIKE(Sort.Sort);" +
                                 "Post: LIKE(Post.Post);" +
                                 "Man : LIKE(Man.Man);" +
                                 "TSN : LIKE(Staff.TSN);" +
                                 "tim : NUMERIC[3];" +
                                 "days: NUMERIC[0]",
                             "tmp: Sort, TSN");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Env.RealTSN(Staff.TSN) THEN
    SELECT(StaffLog, TSN, , Staff.TSN);
    IF StaffLog.Date < Beg THEN
     SRCINSEL(StaffLog, LE, , Beg);
    END;
    WHILE OCCURE(StaffLog) & (StaffLog.Date <= End) DO
     D:=L_DatTim.MaxDATE(StaffLog.Date, Beg);
     WHILE D <= L_DatTim.MinDATE(StaffLog.DateE, End) DO
      IF ~L_Staff.IsDischargeStaffLog() THEN
       L_General.Assert(SEARCH(RegList, HumReg, StaffLog.Regime, L_DatTim.Per(D), L_DatTim.DAY(D)),
                        " ᠭ ० ࠡ " + StaffLog.Regime + "  " +
                        L_DatTim.DateStr(D));
       L_Sheet.GetRealSheet(IsHole, _Tim, _ShtSign, fromSheet);
       Need:=JMode.JMode = _JMode;
      ELSE
       Need:=SEARCH(Sheet, TSN, Staff.TSN, L_DatTim.Per(D), L_DatTim.DAY(D)) &
             (Sheet.JMode = _JMode);
      END;
      IF Need THEN
       IF ~ADD(tmp, tmp, StaffLog.Sort, Staff.TSN,
               tmp.tim,  _Tim,
               tmp.days, 1) THEN
        CONFORM(StaffLog, Officer);
        tmp.Post:=Officer.Post;
        tmp.Man :=Staff.Man;
        REPLACE(tmp);
       END;
       ADD(tot, tot, , StaffLog.Sort,
           tot.tim,  _Tim,
           tot.days, 1);
      END;
      INC(D);
     END;
     NEXT(StaffLog);
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)

  tottim :=0;
  totdays:=0;
  SELECT(tot, tot);
  WHILE OCCURE(tot) DO
   SEARCH(Sort, Sort, , tot.Sort);
   MAKEPART(R, SubTop, tot.tim, tot.days);
   INC(tottim,  tot.tim);
   INC(totdays, tot.days);
   SELECT(tmp, tmp, , tot.Sort);
   WHILE OCCURE(tmp) DO
    SEARCH(Post, Post, , tmp.Post);
    SEARCH(Man,  Man, ,  tmp.Man);
    MAKEPART(R, Line, tmp.TSN, tmp.tim, tmp.days);
    NEXT(tmp);
   END; (* WHILE OCCURE(tmp) ... *)
   NEXT(tot);
  END; (* WHILE OCCURE(tot) ... *)
  MAKEPART(R, Bot, tottim, totdays);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {Make};

 PUBLIC PROCEDURE CJMd0();
 BEGIN
  Make(pt_Month);
 END {CJMd0};

 PUBLIC PROCEDURE CJMd1();
 BEGIN
  Make(pt_Period);
 END {CJMd1};

END.
