(*
%Copyright   (c) Polak Computer System
%Author      30.08.2001 15:38:38 SAN
%Purpose       ⭮ ᯨᠭ
%Type        report
%Specific    SYS
%Modified    08.08.2013 10:44:45 POLAK\MLB
%Environment
*)

 IMPORT L_General, L_OwnData, D_Staff, P_Officer, L_DatTim, Str, L_StdFrm,
        DBD, L_Math, L_Staff, Math, L_XDoc, Memo, L_AP, L_Events, P_MCList;

 TYPE
  t_ViewCondition          = SCAL[4];
  t_VacancyDetailCondition = SCAL[3];

 CONST
  vc_ByOfficer   = 0;
  vc_ByTSN       = 1;
  vc_OfficerOnly = 2;
  vc_Absences    = 3;

  vdc_No          = 0;
  vdc_VacancyOnly = 1;
  vdc_Explicitly  = 2;

  RepNamePool = "All|Srt|Pst|WgP|Uni|TKp|PKn|Dpr|Csh|Off|AcC|Shi|Reg|DtT|DsM";

  VcDtPool = "|⮫쪮 ᨨ|ᨨ  ⠡";

 VAR
  CurSubject: D_Staff.t_ofcSubject;
  RepName   : STRING[5];
  TimeTitle,
  Title     : STRING[];
  TimeCond  : L_General.tTimeCond;
  ViewCond  : t_ViewCondition;
  VcDtCond  : t_VacancyDetailCondition;
  wStaffLog : D_Staff.t_StaffLogDetail;
  Total     : NUMERIC[0][10];
  OfcFact   : NUMERIC[5][P_Officer.ClassAmount];
  OfcVacancy: STRING[][P_Officer.ClassAmount];
  SrcFiles  : D_Staff.t_FileId[100];
  curSrcF,
  CntSrcF   : NUMERIC[0];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Title, C, ""
TimeTitle, C, ""
"(஫ ᯮ ⭮ ᯨᠭ: " + Str.Item(VcDtPool, "|", VcDtCond)+")", C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
|############################################################################################################|
}
*)

(*
$P{ SubTop:
?, C, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
}
*)

(*
$P{ Top_vc_ByOfficer:
Officer.Sort, L, ""
Sort.Name, L, ""
Officer.Officer, L, ""
Post.Post, L, ""
Post.Name, L, ""
@
|------------------------------------------------------------------------------------------------------------|
| ### #############################  ####  ### ##########################################|
|------------------------------------------------------------------------------------------------------------|
|  |                                                                  ||| |         |        |
|-----|---------------------------------------------------------------------|---|-|----|----------|----------|
}
*)

(*
$P{ Top_vc_ByOfficer_wShift:
Officer.Sort, L, ""
Sort.Name, L, ""
Officer.Officer, L, ""
Post.Post, L, ""
Post.Name, L, ""
Shift.Shift, L, ""
Shift.Name, L, ""
Shift.Number, L, ""
@
|------------------------------------------------------------------------------------------------------------|
| ### #############################  ####  ### ##########################################|
|: ## ##########################################################################################  #|
|------------------------------------------------------------------------------------------------------------|
|  |                                                                  ||| |         |        |
|-----|---------------------------------------------------------------------|---|-|----|----------|----------|
}
*)

(*
$P{ Line_vc_ByOfficer:
Staff.TSN, L, ""
Man.Name, L, ""
Stl01.Source, L, D_Staff.ofcs_ShortPool
Stl01.Class, L, ""
Stl01.DutyDgr, R, "2."
?, L, "D.N.y"
?, L, "D.N.y"
@
|#####|#####################################################################|###|#|####|##########|##########|
}
*)

(*
$P{ Top_vc_ByTSN:
@
|------------------------------------------------------------------------------------------------------------|
|  |                                         |                      ||         |        |
|-----|--------------------------------------------|-------------------------------|---|----------|----------|
}
*)

(*
$P{ Line_vc_ByTSN:
Staff.TSN, L, ""
Man.Name, L, ""
Post.Name, L, ""
Stl01.Source, L, D_Staff.ofcs_ShortPool
Stl01.OBegDate, L, "D.N.y"
Stl01.OEndDate, L, "D.N.y"
@
|#####|############################################|###############################|###|##########|##########|
}
*)

(*
$P{ Top_vc_OfficerOnly:
@
|------------------------------------------------------------------------------------------------------------|
|                                      |  |                         ||   |뢥  |
}
*)

(*
$P{ Line_vc_OfficerOnly:
Sort.Sort, L, ""
Sort.Name, L, ""
Officer.Officer, L, ""
Post.Post, L, ""
Post.Name, L, ""
?, L, ""
Officer.Begin, L, "D.N.y"
Officer.Till, L, "D.N.y"
@
|--------------------------------------------|----|----------------------------------|-|----------|----------|
|### ########################################|####|### ##############################|#|##########|##########|
}
*)

(*
$P{ Top_vc_OfficerOnly_MPG_WP:
@
|============================================================================================================|
|                                   ᯮ짮   㯯 ப                                   |
|------------------------------------------------------------------------------------------------------------|
|㯯 ப                      |      |ਠ      |ந  |C         |        |
}
*)

(*
$P{ Line_vc_OfficerOnly_MPG_WP:
MarkG.MarkG, L, ""
MarkG.Name, L, ""
MPG_WP.Who, L, L_AP.mpgWho_Poll
JRgPayT.JRgPayT, L, ""
JRgPayT.Name, L, ""
RWPay.RWPay, L, ""
RWPay.Name, L, ""
MPG_WP.Begin, L, "D.N.y"
MPG_WP.Till, L, "D.N.y"
@
|----------------------------------|---------|-------------------|---------------------|----------|----------|
|#### #############################|#########|## ################|## ##################|##########|##########|
}
*)

(*
$P{ VacPart:
OfcVacancy[1], L, ""
OfcVacancy[2], L, ""
OfcVacancy[3], L, ""
OfcVacancy[4], L, ""
OfcVacancy[5], L, ""
OfcVacancy[6], L, ""
OfcVacancy[7], L, ""
OfcVacancy[8], L, ""
OfcVacancy[0], L, ""
@
|------------------------------------------------------------------------------------------------------------|
|ᨨ      1 ######     2 ######     3 ######     4 ######                                               |
|              5 ######     6 ######     7 ######     8 ######  ᥣ ######                                 |
}
*)

(*
$P{ TotalPart:
?, R, "0"
D_Staff.ofcs_Contract,        L, D_Staff.ofcs_Pool
D_Staff.ofcs_Contract,        L, D_Staff.ofcs_ShortPool
Total[D_Staff.ofcs_Contract], R, "0"
D_Staff.ofcs_Acting,          L, D_Staff.ofcs_Pool
D_Staff.ofcs_Acting,          L, D_Staff.ofcs_ShortPool
Total[D_Staff.ofcs_Acting],   R, "0"
D_Staff.ofcs_Temp,            L, D_Staff.ofcs_Pool
D_Staff.ofcs_Temp,            L, D_Staff.ofcs_ShortPool
Total[D_Staff.ofcs_Temp],     R, "0"
D_Staff.ofcs_byEDO,           L, D_Staff.ofcs_Pool
D_Staff.ofcs_byEDO,           L, D_Staff.ofcs_ShortPool
Total[D_Staff.ofcs_byEDO],    R, "0"
@
|------------------------------------------------------------------------------------------------------------|
|⮣ ࠡ⭨:                                                                                     ######|
|                                                         ⮬ ᫥,   ####################### (###)  ######|
|                                                                       ####################### (###)  ######|
|                                                                       ####################### (###)  ######|
|                                                                       ####################### (###)  ######|
}
*)

(*
$P{ u_MCPTop:
@
|------------------------------------------------------------------------------------------------------------|
|                                          ᫥/㤥ঠ                                          |
|------------------------------------------------------------------------------------------------------------|
| /                                                                                     |      |     |
|--------------------------------------------------------------------------------------------|-------|-------|
}
*)

(*
$P{ u_MCPLine:
MCList.MCode, L, <>
MCList.Name, L, <>
MCPro.Date, L, <N.y>
?, L, <N.y>
@
|### ########################################################################################|#######|#######|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE GetSubjectByMode():D_Staff.t_ofcSubject;
 BEGIN
  RETURN (MODE - 100);
 END {GetSubjectByMode};

 PRIVATE PROCEDURE SetCurSubject(trgSubject: D_Staff.t_ofcSubject);
 BEGIN
  CurSubject:=trgSubject;
 END {SetCurSubject};

 PRIVATE PROCEDURE GetDifference(F, P: FLOAT): STRING[];
 BEGIN
  IF    F < P THEN
   RETURN "+" + FLDTOSTR(P-F, "2.", 0);
  ELSIF F > P THEN
   RETURN "-" + FLDTOSTR(F-P, "2.", 0);
  ELSE
   RETURN "";
  END;
 END {GetDifference};

 PRIVATE PROCEDURE TypeVacancySummary(_Fact, _Plan: NUMERIC[3][]);
  VAR
   _Class: SCAL[P_Officer.ClassAmount+1];
   tFact,
   tPlan : NUMERIC[3];
 BEGIN
  SETZERO(tFact, tPlan);
  _Class:=1;
  WHILE _Class < P_Officer.ClassAmount DO
   INC(tFact, _Fact[_Class]);
   INC(tPlan, _Plan[_Class]);
   OfcVacancy[_Class]:=GetDifference(_Fact[_Class], _Plan[_Class]);
   INC(_Class);
  END;
  OfcVacancy[0]:=GetDifference(tFact, _Plan[0]);
  MAKEPART(R, VacPart);
 END {TypeVacancySummary};

 PRIVATE PROCEDURE TypeZeroVacancySummary(_Fact: NUMERIC[3][]);
  VAR
   _Plan: NUMERIC[3][P_Officer.ClassAmount];
 BEGIN
  SETZERO(_Plan);
  TypeVacancySummary(_Fact, _Plan);
 END {TypeZeroVacancySummary};

 PRIVATE PROCEDURE TypeTotalSummary();
 BEGIN
  IF (wStaffLog # D_Staff.sld_No) &
     (ViewCond # vc_Absences) &
     (TimeCond = L_General.timeCond_OnDate) THEN
   MAKEPART(R, TotalPart,
            Total[D_Staff.ofcs_Contract]+
            Total[D_Staff.ofcs_Acting]  +
            Total[D_Staff.ofcs_Temp]    +
            Total[D_Staff.ofcs_byEDO]
           );
  END;
 END {TypeTotalSummary};

 PRIVATE PROCEDURE Build();
  CONST
   ViewPool = "ࠡ⭨  ࠡ稬 ⠬|"+
              "ࠡ⭨ ᯫ ᯨ᪮|"+
              "⮫쪮 ࠡ稥 |"+
              "  ࠡ稬 ⠬";
  VAR
   TimePool: STRING[];
 BEGIN
  IF    CurSubject = D_Staff.ofc_ByOfficer THEN
   ACCESS(Officer);
   Title:="祥 : ᥪ " + Officer.Sort + "  " + Officer.Officer;
  ELSIF CurSubject = D_Staff.ofc_BySort THEN
   ACCESS(Sort);
   Title:="ࠧ: " + Sort.Sort + " " + Sort.Name;
  ELSIF CurSubject = D_Staff.ofc_ByPost THEN
   L_General.Assert(ACCESS(Post), " ⠭ ⥪  - ");
   Title:=": " + Post.Post + " " + Post.Name;
  ELSIF CurSubject = D_Staff.ofc_ByWagePay THEN
   L_General.Assert(ACCESS(WagePay), " ⠭ ⥪  - 䭠 ⪠");
   Title:="䭠 ⪠: " + WagePay.WagePay + " " + WagePay.Name;
  ELSIF CurSubject = D_Staff.ofc_ByUnion THEN
   L_General.Assert(ACCESS(Union), " ⠭ ⥪  - ⥣");
   Title:="⥣: " + Union.Union + " " + Union.Name;
  ELSIF CurSubject = D_Staff.ofc_ByTimeKeep THEN
   L_General.Assert(ACCESS(TimeKeep), " ⠭ ⥪  - ⠡騪");
   Title:="騪: " + TimeKeep.TimeKeep + " " + TimeKeep.Name;
  ELSIF CurSubject = D_Staff.ofc_ByPayKind THEN
   L_General.Assert(ACCESS(PayKind), " ⠭ ⥪  -   ௫");
   Title:="  ௫: " + PayKind.PayKind + " " + PayKind.Name;
  ELSIF CurSubject = D_Staff.ofc_ByCash THEN
   L_General.Assert(ACCESS(Cash), " ⠭ ⥪  - ");
   Title:=": " + Cash.Cash + " " + Cash.Name;
  ELSIF CurSubject = D_Staff.ofc_ByAcCut THEN
   L_General.Assert(ACCESS(AcCut), " ⠭ ⥪  -  ࠧ१");
   Title:=" ࠧ१: " + AcCut.AcCut + " " + AcCut.Name;
  ELSIF CurSubject = D_Staff.ofc_ByShift THEN
   L_General.Assert(ACCESS(Shift), " ⠭ ⥪  - ᬥ");
   Title:=": " + Shift.Shift + " " + Shift.Name;
  ELSIF CurSubject = D_Staff.ofc_ByRegime THEN
   L_General.Assert(ACCESS(RegMain), " ⠭ ⥪  - ० ࠡ");
   Title:=" ࠡ: " + RegMain.Regime + " " + RegMain.Name;
  ELSIF CurSubject = D_Staff.ofc_ByDirtyTyp THEN
   L_General.Assert(ACCESS(DirtyTyp), " ⠭ ⥪  - । ᫮ 㤠");
   Title:="। ᫮ 㤠: " + DirtyTyp.DirtyTyp + " " + DirtyTyp.Name;
  ELSIF CurSubject = D_Staff.ofc_DstMode THEN
   L_General.Assert(ACCESS(DstMode), " ⠭ ⥪  - ᯮᮡ । ௫");
   Title:="ᮡ । ௫: " + DstMode.DstMode + " " + DstMode.Name;
  ELSIF CurSubject = D_Staff.ofc_SalDSet THEN
   ACCESS(SalDSet);
   Title:=" ᯮᮡ । ௫: " + SalDSet.SalDSet + " " + SalDSet.Name;
  ELSE
   L_General.CallUs(0);
  END;
  TimeCond:=L_General.timeCond_OnDate;
  ViewCond:=vc_ByTSN;
  VcDtCond:=vdc_No;
  TimePool:=" " + L_DatTim.DateStr(Memo.ud_cd()) + "|" +
            " ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut()) + "|"+
            "  ";
  LOOP
   STDFORM(L_StdFrm.sf_Choice("|                                                               "+
                              "|࠭祭  ६ %####################################%"+
                              "|                                                               "+
                              "|              %####################################%"+
                              "|                                                               "+
                              "|஫ ᯮ  %####################################%",
                              "%L<"+TimePool+">I"+
                              "%L<"+ViewPool+">I"+
                              "%L<"+VcDtPool+">I"),
           " " + Title + " ",
           ,
           ,
           TimeCond, ViewCond, VcDtCond);
   IF    (ViewCond=vc_ByTSN) & (VcDtCond#vdc_No) THEN
    L_StdFrm.RedInform("  ᯫ ᯨ᪮     ᨩ");
(*
   ELSIF (ViewCond=vc_OfficerOnly) & (VcDtCond=vdc_No) THEN
    L_StdFrm.RedInform("⠭  ஫ ⭮ ᯨᠭ");
*)
   ELSE
    EXIT;
   END;
  END; (* LOOP *)
  IF    ViewCond = vc_OfficerOnly THEN
   TimeTitle:="ᯮ짮  ⭮ ᯨᠭ";
  ELSIF ViewCond = vc_Absences THEN
   TimeTitle:="祭 ";
   VcDtCond :=vdc_Explicitly;
  ELSE
   TimeTitle:="祭 ࠪ⮢";
  END;
  TimeTitle:=TimeTitle+" "+Str.Item(TimePool, "|", TimeCond);
  RepName  :="C"+Str.Item(RepNamePool, "|", CurSubject)+Str.Item("D|P|A", "|", TimeCond);
  IF VcDtCond = vdc_Explicitly THEN
   wStaffLog:=D_Staff.sld_wSheet;
  ELSIF (VcDtCond # vdc_No) | (ViewCond # vc_OfficerOnly) THEN
   wStaffLog:=D_Staff.sld_Simple;
  ELSE
   wStaffLog:=D_Staff.sld_No;
  END;
  D_Staff.Prepare_Stl01(TimeCond, CurSubject, wStaffLog);
 END {Build};

 PRIVATE PROCEDURE WithShift(_Sort    : LIKE(Sort.Sort);
                     _Officer : LIKE(Officer.Officer);
                     _Number  : LIKE(Shift.Number)): SCAL[2];
  VAR
   _Shift: LIKE(Shift.Shift);
 BEGIN
  IF DBD.FileExist(OfcShift) &
     SELECT(OfcShift, Officer, _Sort, _Officer) THEN
   L_Staff.StandOnShiftByShiftNum(_Sort, _Officer, _Number);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {WithShift};

 PRIVATE PROCEDURE NotDummyOfc01(): SCAL[2];
 BEGIN
  RETURN  ((ViewCond = vc_OfficerOnly) & (VcDtCond = vdc_No)) |
          (L_Math.Math_GetArraySum(Ofc01.Vacancy, HIGH(Ofc01.Vacancy)+1) # 0) |
          SELECT(Stl01, SrcFile, SrcFiles[curSrcF], Ofc01.Sort, Ofc01.Officer, Ofc01.ShiftNum);
 END {NotDummyOfc01};

 PRIVATE PROCEDURE TypeAbsencesInGate();
  VAR
   B,
   E      : DATE;
   HasLine: SCAL[2];
 BEGIN
  SETEMPTY(B, E);
  HasLine:=0;
  SELECT(Sheet, TSN, , Stl01.TSN);
  SRCINSEL(Sheet, GE, , L_DatTim.Per(Math.Max(Stl01.OBegDate, D_Staff.Stl01_IntvlB)),
                        L_DatTim.DAY(Math.Max(Stl01.OBegDate, D_Staff.Stl01_IntvlB)));
  WHILE OCCURE(Sheet) &
        ((Sheet.Period + Sheet.Day - 1) <= Math.Min(Stl01.OEndDate,
                                                    D_Staff.Stl01_IntvlE)) DO
   CONFORM(Sheet, JMode);
   IF D_Staff.JModeIsAbsence() THEN
    IF !B THEN
     B:=Sheet.Period+Sheet.Day-1;
     E:=B;
    ELSIF (E+1) # (Sheet.Period+Sheet.Day-1) THEN
     MAKEPART(R, Line_vc_ByOfficer, B, E);
     HasLine:=1;
     SETEMPTY(B, E);
    ELSE
     INC(E);
    END;
   ELSIF ~!B THEN
    MAKEPART(R, Line_vc_ByOfficer, B, E);
    HasLine:=1;
    SETEMPTY(B, E);
   END;
   NEXT(Sheet);
  END; (* WHILE OCCURE(Sheet) ... *)
  IF ~!B THEN
   MAKEPART(R, Line_vc_ByOfficer, B, E);
   HasLine:=1;
  END;
  IF HasLine THEN
   L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_Staff,
                                   L_XDoc.EmptyXDocKind,
                                   Staff.TSN),
                     Staff.TSN + " " + Man.Name);
  END;
 END {TypeAbsencesInGate};

 PRIVATE PROCEDURE TCond(timeCond: L_General.tTimeCond; Begin, Till: DATE): SCAL[2];
 BEGIN
  IF timeCond = L_General.timeCond_OnDate  THEN
   RETURN L_DatTim.IsActive(Memo.ud_cd(), Begin, Till);
  ELSIF timeCond = L_General.timeCond_InIntvl THEN
   RETURN L_DatTim.IsActiveInIntvl(Memo.ud_fr(), Memo.ud_ut()+1, Begin, Till);
  ELSE
   RETURN 1;
  END;
 END {TCond};

 PRIVATE PROCEDURE PrintBodyReport();
  VAR
   TopByOfficerAlreadyPut: SCAL[2];
 BEGIN
  MAKEPART(R, SubTop, DBD.FileDescription(^(DBD.FileIdToName(SrcFiles[curSrcF]))));
  SETZERO(Total);
  IF ViewCond = vc_ByOfficer THEN
   SELECT(Ofc01, SrcFile, , SrcFiles[curSrcF]);
   WHILE OCCURE(Ofc01) DO
    IF NotDummyOfc01() THEN
     CONFORM(Ofc01, Officer, Sort, Post);
     SETZERO(OfcFact);
     TopByOfficerAlreadyPut:=0;
     SELECT(Stl01, SrcFile, , SrcFiles[curSrcF], Ofc01.Sort, Ofc01.Officer, Ofc01.ShiftNum);
     WHILE OCCURE(Stl01) DO
      CONFORM(Stl01, Man);
      PROMPT(" " + Stl01.TSN);
      IF ~TopByOfficerAlreadyPut THEN
       TopByOfficerAlreadyPut:=1;
       IF WithShift(Ofc01.Sort, Ofc01.Officer, Ofc01.ShiftNum) THEN
        MAKEPART(R, Top_vc_ByOfficer_wShift);
       ELSE
        MAKEPART(R, Top_vc_ByOfficer);
       END;
      END;
      MAKEPART(R, Line_vc_ByOfficer, Stl01.OBegDate, Stl01.OEndDate);
      L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_Staff,
                                      L_XDoc.EmptyXDocKind,
                                      Staff.TSN),
                        Staff.TSN + " " + Man.Name);
      INC(OfcFact[Stl01.Class], Stl01.RealDD);
      INC(Total[Stl01.Source]);
      NEXT(Stl01);
     END; (* WHILE OCCURE(Stl01) ... *)
     IF VcDtCond # vdc_No THEN
      TypeVacancySummary(OfcFact, Ofc01.Vacancy);
     END;
    END;
    NEXT(Ofc01);
   END; (* WHILE OCCURE(Ofc01) ... *)
  ELSIF ViewCond = vc_Absences THEN
   SELECT(Ofc01, SrcFile, , SrcFiles[curSrcF]);
   WHILE OCCURE(Ofc01) DO
    IF NotDummyOfc01() THEN
     CONFORM(Ofc01, Officer, Sort, Post);
     SETZERO(OfcFact);
     IF WithShift(Ofc01.Sort, Ofc01.Officer, Ofc01.ShiftNum) THEN
      MAKEPART(R, Top_vc_ByOfficer_wShift);
     ELSE
      MAKEPART(R, Top_vc_ByOfficer);
     END;
     SELECT(Stl01, SrcFile, , SrcFiles[curSrcF], Ofc01.Sort, Ofc01.Officer, Ofc01.ShiftNum);
     WHILE OCCURE(Stl01) DO
      IF Stl01.RealDD < Stl01.AsRealDD THEN
       CONFORM(Stl01, Man);
       PROMPT(" " + Stl01.TSN);
       TypeAbsencesInGate();
       INC(OfcFact[Stl01.Class], Stl01.RealDD-Stl01.AsRealDD);
      END;
      NEXT(Stl01);
     END; (* WHILE OCCURE(Stl01) ... *)
     TypeZeroVacancySummary(OfcFact);
    END;
    NEXT(Ofc01);
   END; (* WHILE OCCURE(Ofc01) ... *)
  ELSIF ViewCond = vc_ByTSN THEN
   MAKEPART(R, Top_vc_ByTSN);
   SELECT(Stl01, SrcFTSN, , SrcFiles[curSrcF]);
   WHILE OCCURE(Stl01) DO
    CONFORM(Stl01, Officer, Sort, Post);
    CONFORM(Stl01, Man);
    PROMPT(" " + Stl01.TSN);
    MAKEPART(R, Line_vc_ByTSN);
    L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_Staff,
                                    L_XDoc.EmptyXDocKind,
                                    Staff.TSN),
                      Staff.TSN + " " + Man.Name);
    INC(Total[Stl01.Source]);
    NEXT(Stl01);
   END; (* WHILE OCCURE(Stl01) ... *)
  ELSIF ViewCond = vc_OfficerOnly THEN
   MAKEPART(R, Top_vc_OfficerOnly);
   SELECT(Ofc01, SrcFile, , SrcFiles[curSrcF]);
   WHILE OCCURE(Ofc01) DO
    PROMPT(" " + Ofc01.Sort);
    IF NotDummyOfc01() THEN
     CONFORM(Ofc01, Officer, Sort, Post);
     MAKEPART(R, Line_vc_OfficerOnly, Ofc01.ShiftNum);
     IF VcDtCond # vdc_No THEN
      SELECT(Stl01, SrcFile, , SrcFiles[curSrcF], Ofc01.Sort, Ofc01.Officer, Ofc01.ShiftNum);
      SETZERO(OfcFact);
      WHILE OCCURE(Stl01) DO
       INC(OfcFact[Stl01.Class], Stl01.RealDD);
       INC(Total[Stl01.Source]);
       NEXT(Stl01);
      END; (* WHILE OCCURE(Stl01) ... *)
      IF VcDtCond # vdc_No THEN
       TypeVacancySummary(OfcFact, Ofc01.Vacancy);
      END;
     END; (* IF VcDt ... *)
    END;
    NEXT(Ofc01);
   END; (* WHILE OCCURE(Ofc01) ... *)
  END;
  TypeTotalSummary();
 END {PrintBodyReport};

 PRIVATE PROCEDURE PrintBodyReportSuppl();
 BEGIN
  IF (ViewCond = vc_OfficerOnly) & (CurSubject = D_Staff.ofc_ByWagePay) THEN
   IF SELECT(MPG_WP, WagePay, WagePay.WagePay) THEN
    MAKEPART(R, Top_vc_OfficerOnly_MPG_WP);
    WHILE OCCURE(MPG_WP) DO
     IF TCond(TimeCond, MPG_WP.Begin, MPG_WP.Till) THEN
      CONFORM(MPG_WP, MarkG, JRgPayT, RWPay);
      MAKEPART(R, Line_vc_OfficerOnly_MPG_WP);
     END;
     NEXT(MPG_WP);
    END; (* WHILE OCCURE(MPG_WP) ... *)
   END;
  END;
 END {PrintBodyReportSuppl};

 PUBLIC PROCEDURE Usage(trgSubject: D_Staff.t_ofcSubject);
  VAR
   trgTill: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  SetCurSubject(trgSubject);
  Build();
 
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top);
  IF ViewCond # vc_OfficerOnly THEN
   L_XDoc.sl_Init("᮪ ࠡ⭨");
  END;
  SETEMPTY(SrcFiles);
  CntSrcF:=0;
  SELECT(Ofc01, SrcFile);
  WHILE OCCURE(Ofc01) DO
   NARROWSEL(Ofc01, SrcFile);
   SrcFiles[CntSrcF]:=Ofc01.SrcFile;
   INC(CntSrcF);
   NEXTINEXTENDEDSEL(Ofc01, SrcFile);
  END; (* WHILE OCCURE(Ofc01) ... *)
 
  curSrcF:=0;
  WHILE curSrcF < CntSrcF DO
   PrintBodyReport();
   INC(curSrcF);
  END;
  PrintBodyReportSuppl();
  IF (trgSubject = D_Staff.ofc_DstMode) &
       SELECT(r2r, byOwn, TABLE.Get("DstMode").Id, DstMode.RECORDID, TABLE.Get("MCPro").Id) |
     (trgSubject = D_Staff.ofc_ByAcCut) &
       SELECT(r2r, byOwn, TABLE.Get("AcCut"  ).Id, AcCut.RECORDID,   TABLE.Get("MCPro").Id) THEN
   MAKEPART(R, u_MCPTop);
   WHILE OCCURE(r2r) DO
    PROMPT(r2r.RECORDID);
    SEARCH(MCPro, RECORDID, , r2r.riUsr);
    CONFORM(MCPro, MCList);
    IF ~!MCPro.EndDate THEN
     trgTill:=MCPro.EndDate+1;
    ELSE
     trgTill:=MCList.Till;
    END;
    MAKEPART(R, u_MCPLine, trgTill);
    NEXT(r2r);
   END; (* WHILE OCCURE(r2r) ... *)
  END;
  MAKEPART(R, Bot);
  CLOSEREP(R);
  D_Staff.Purge_Stl01();
 
  IF ViewCond # vc_OfficerOnly THEN
   L_XDoc.sl_Done();
  ELSE
   LIKEMENU(Survey, "");
  END;
 END {Usage};

 PUBLIC PROCEDURE u_DstMode();
 BEGIN
  Usage(D_Staff.ofc_DstMode);
 END {u_DstMode};

 PUBLIC PROCEDURE u_SalDSet();
 BEGIN
  Usage(D_Staff.ofc_SalDSet);
 END {u_SalDSet};

BEGIN
 IF MODE # L_Events.md_InIMPORT THEN
  Usage(GetSubjectByMode());
 END;
END.

