(*
%Copyright   (c) Polak Computer System
%Author      29.05.2000 16:07:14 SAM
%Purpose     稥/⢨ ᢮⢠  ꥪ⮢
%Type        report
%Specific    SYS
%Modified    11.09.2014 10:29:16 POLAK\Bor
%Environment
*)

 MODULE C_Prop [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_Prop, L_Str, L_OwnData, L_DatTim, L_Staff, L_PDoc, L_General, L_DBD, L_PCS,
        L_Car, L_StdFrm, L_AFM, Str, L_Excel, L_Stock, L_Env,
        (* 㫨 P_* ᯮ  १ ^.  㤠. *)
        P_Staff, P_Car, P_Mark, P_Route, P_EDOL, P_Officer, P_EDOKnd, P_Math, P_Man,
        P_MDoc, P_Firm, P_Union, P_Sort, P_PDoc, P_Cntr, P_Post, P_AveP, P_OwnData,
        P_DsptM, P_CUC, P_Storage, P_Exit, P_MyFirm, P_TKind, P_Rpr, P_CI,
        P_ODoc, P_MCList, P_Column, P_MyPlc, P_MySite, P_MarkG;

 PRIVATE TYPE
  tObjChoiceMode = SCAL[3];
  tPrpChoiceMode = SCAL[6];
  tDateMode      = SCAL[2];

 PRIVATE CONST
  Reg_Cancel     = -1;
  Reg_OutPut     =  1;
  Reg_ToExcel    =  2;

  ocm_AllObj       = 0;
  ocm_ActualObj    = 1;

  pcm_HasPrp          = 0;
  pcm_NoPrp           = 1;
  pcm_HasActualPrp    = 2;
  pcm_NoActualPrp     = 3;
  pcm_HasNotActualPrp = 4;
  pcm_FullDump        = 5;

  dm_OnTheDate        = 0;
  dm_ForThePeriod     = 1;
  Sign_Pool           = "|᭮ ઠ|||.  ਪ|" +
                        ",  ࠡ祣 ||||" +
                        ". ||||.|" +
                        "|||㬥| |᪮ |" +
                        " | | | |";

 PRIVATE VAR
  obj_FileName,
  prp_FileName,
  RepName,
  ue_FileList,
  obj_Key      : STRING[];
  ocm          : tObjChoiceMode;
  pcm          : tPrpChoiceMode;
  dm           : tDateMode;
  RepDateB,
  RepDateE     : DATE;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
?, C, ""
?, C, ""
?, L, ""
Property.Object, L, Sign_Pool
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|##################|##############################|祭                            |         |        |
|------------------|------------------------------|------------------------------------|----------|----------|
}
*)

(*
$P{ TopNo:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
?, C, ""
?, C, ""
?, L, ""
Property.Object, L, Sign_Pool
@
############################################################ ########### #####
=#####========================================================================
|############################################################################|
|############################################################################|
|############################################################################|
|----------------------------------------------------------------------------|
|##################|#########################################################|
|------------------|---------------------------------------------------------|
}
*)

(*
$P{ Line:
?, L, ""
?, L, "| "
?, L, ""
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
@
|################ #|##############################|####################################|##########|##########|
}
*)

(*
$P{ LineNo:
?, L, ""
?, L, "| "
?, L, ""
@
|################ #|#########################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

(*
$P{ BotNo:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE obj_IsActualOneDay(): SCAL[2];
 BEGIN
  RETURN (Property.Object = L_Prop.MDocProObj) |
         (Property.Object = L_Prop.PDocProObj) |
         (Property.Object = L_Prop.ODocProObj) |
         (Property.Object = L_Prop.EDOLProObj) |
         (Property.Object = L_Prop.RprProObj);
 END {obj_IsActualOneDay};

 PRIVATE PROCEDURE obj_FileDateIndex(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF (Property.Object = L_Prop.AvePProObj)  THEN
   Result:="Period";
  ELSE
   Result:=L_PCS.DateIndexName(L_Prop.ObjectFileName(Property.Object));
   L_General.CallUs(~!Result);
  END;
  RETURN Result;
 END {obj_FileDateIndex};

 PRIVATE PROCEDURE obj_FileDateField(): STRING[];
 BEGIN
  RETURN TABLE.Get(L_Prop.ObjectFileName(Property.Object)).Indexes(obj_FileDateIndex()).Fields(0).ObtainName();
 END {obj_FileDateField};

 PRIVATE PROCEDURE Get_obj_FileIndex(): STRING[];
  VAR
   curLink: LINK;
 BEGIN
  FOR_EACH curLink IN TABLE.Get(prp_FileName).Links DO
   IF curLink.CooIndex.Table.Name = obj_FileName THEN
    RETURN curLink.CooIndex.Name;
   END;
  END;
  L_General.CallUs(0);
 END {Get_obj_FileIndex};

 PRIVATE PROCEDURE obj_UniqIndexFields(): STRING[];
  VAR
   keyStr: STRING[];
   idx   : NUMERIC[0];
 BEGIN
  keyStr:=TABLE.Get(obj_FileName).Indexes(obj_Key).Fields(0).ObtainName();
  idx:=1;
  WHILE idx < TABLE.Get(obj_FileName).Indexes(obj_Key).Fields.Count DO
   keyStr:=keyStr + ", " + TABLE.Get(obj_FileName).Indexes(obj_Key).Fields(idx).ObtainName();
   INC(idx);
  END;
  RETURN keyStr;
 END {obj_UniqIndexFields};

 PRIVATE PROCEDURE obj_ID(): STRING[];
  VAR
   ID,
   FieldName: STRING[];
   idx      : NUMERIC[0];
 BEGIN
  ID:=^(Str.Item(obj_UniqIndexFields(), ", ", 0));
  idx:=1;
  FieldName:=Str.Item(obj_UniqIndexFields(), ", ", 1);
  WHILE ~!FieldName DO
   ID:=ID + " " + ^FieldName;
   INC(idx);
   FieldName:=Str.Item(obj_UniqIndexFields(), ", ", idx);
  END;
  RETURN ID;
 END {obj_ID};

 PRIVATE PROCEDURE obj_Name(): STRING[];
 BEGIN
  IF    Property.Object = L_Prop.StaffProObj THEN CONFORM(Staff, Man);
                                          RETURN Man.Name;
  ELSIF Property.Object = L_Prop.CarProObj   THEN L_Car.StandOnCarLog(Car.BoxNbr, RepDateB);
                                          CONFORM(CarLog, Mark);
                                          RETURN CarLog.StateNbr + " " + Mark.Mark + " " + Mark.Name;
  ELSIF Property.Object = L_Prop.EDOLProObj  THEN CONFORM(EDOrderL, EDOrder);
                                          RETURN EDOrder.SrcNum;
  ELSIF Property.Object = L_Prop.OfcProObj   THEN CONFORM(Officer, Sort);
                                          RETURN Sort.Name +" "+ Officer.Officer;
  ELSIF Property.Object = L_Prop.MDocProObj  THEN CONFORM(MDoc, MDocKind);
                                          RETURN MDocKind.Sign + " " + MDoc.SrcNbr;
  ELSIF Property.Object = L_Prop.ODocProObj  THEN CONFORM(ODoc, ODocKind);
                                          RETURN ODocKind.Sign + " " + ODoc.SrcNbr;
  ELSIF Property.Object = L_Prop.PDocProObj  THEN RETURN L_PDoc.PDocKindNick(PDoc.PDocKind, 1) + " " + PDoc.SrcNbr;
  ELSIF Property.Object = L_Prop.CntrProObj  THEN RETURN Contract.SrcNbr + " " + Contract.Name;
  ELSIF Property.Object = L_Prop.AvePProObj  THEN RETURN AvePay.DocNum + "  " + L_DatTim.DateStr(AvePay.DocDate);
  ELSIF Property.Object = L_Prop.StrgProObj  THEN RETURN L_Str.PoolItem(L_Stock.st_Pool_SH, Storage.Type) + " " + Storage.Name;
  ELSIF Property.Object = L_Prop.CUCProObj   THEN RETURN CUCopy.Serial;
  ELSIF Property.Object = L_Prop.RprProObj   THEN RETURN "";
  ELSE                                            RETURN ^(obj_FileName + ".Name");
  END;
 END {obj_Name};

 PRIVATE PROCEDURE obj_HasAnyPrp(CheckActual: SCAL[2]): SCAL[2];
  VAR
   obj_CheckPrpModule,
   BaseProcName       : STRING[];
   p                  : PROC;
   Result             : SCAL[2];
   D                  : DATE;
BEGIN
  IF dm = dm_OnTheDate THEN
   D:=RepDateB;
  ELSE
   D:=RepDateE;
  END;
  IF CheckActual THEN
   BaseProcName:="HasActual";
  ELSE
   IF    Property.Object = L_Prop.AvePProObj THEN
    BaseProcName:="HasActual";
   ELSIF Property.Object = L_Prop.EDOLProObj THEN
    BaseProcName:="HasAny";
   ELSIF Property.Object = L_Prop.RprProObj THEN
    BaseProcName:="HasRprS";
   ELSE
    BaseProcName:="Has";
   END;
  END;
  obj_CheckPrpModule:=L_Prop.GetModuleName(Property.Object);
  p  :=PROCREF(^(obj_CheckPrpModule + "." + BaseProcName + prp_FileName));
  IF !p THEN
   p :=PROCREF(^(obj_CheckPrpModule + "." + BaseProcName + "Pro_Normal"));
   IF !p THEN
    p:=PROCREF(^(obj_CheckPrpModule + "." + BaseProcName + "Pro"));
    L_General.CallUs(~!p);
   END;
  END;
  SAVE(^prp_FileName);
  IF    (Property.Object = L_Prop.OfcProObj) & ~CheckActual THEN
   Result:=p(^(obj_UniqIndexFields()), D, Property.Property, L_Prop.dsc_Normal);
  ELSIF (Property.Object = L_Prop.PostProObj) & ~CheckActual THEN
   Result:=p(^(obj_UniqIndexFields()), D, Property.Property, L_Prop.dsc_Normal);
  ELSE
   IF obj_IsActualOneDay() | (Property.Object = L_Prop.AvePProObj) THEN
    Result:=p(^(obj_UniqIndexFields()), Property.Property);
   ELSE
    Result:=p(^(obj_UniqIndexFields()), D, Property.Property);
   END;
  END;
  RESTORE(^prp_FileName);
  RETURN Result;
 END {obj_HasAnyPrp};

 PRIVATE PROCEDURE obj_HasPrp(): SCAL[2];
 BEGIN
  RETURN obj_HasAnyPrp(0);
 END {obj_HasPrp};

 PRIVATE PROCEDURE obj_HasActualPrp(): SCAL[2];
 BEGIN
  RETURN obj_HasAnyPrp(1);
 END {obj_HasActualPrp};

 PRIVATE PROCEDURE CanHaveProSoft(trgProperty: LIKE(Property.Property); D: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  TRY
   L_Prop.PositionOnProperty(trgProperty);
   Local:=PROCREF(^(L_Prop.GetModuleName(Property.Object) + ".CanHavePro"));
   IF ~!Local THEN
    Local(trgProperty, D);
   END;
   RETURN 1;
  EXCEPT
  ON Exc: Exc_Raise DO
   IF Exc.ErrorCode = -1 THEN
    RETURN 0;
   ELSE
    RAISE();
   END
  END;
 END {CanHaveProSoft};

 PRIVATE PROCEDURE obj_CanHaveProp(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF dm = dm_OnTheDate THEN
   Result:=CanHaveProSoft(Property.Property, RepDateB);
  ELSE
   Result:=CanHaveProSoft(Property.Property, RepDateB) &
           CanHaveProSoft(Property.Property, RepDateE);
  END;
  RETURN Result;
 END {obj_CanHaveProp};

 PRIVATE PROCEDURE dbFileHasPeriod(FileName: STRING[]): SCAL[2];
  VAR
   BFN,
   EFN : STRING[];
 BEGIN
  SETEMPTY(BFN, EFN);
  L_DBD.CollateValidityFieldNames(FileName, BFN, EFN);
  RETURN ~!BFN & ~!EFN;
 END {dbFileHasPeriod};

 PRIVATE PROCEDURE obj_HasPeriod(): SCAL[2];
 BEGIN
  RETURN (Property.Object = L_Prop.ManProObj) | obj_IsActualOneDay() | dbFileHasPeriod(obj_FileName);
 END {obj_HasPeriod};

 PRIVATE PROCEDURE prp_HasPeriod(): SCAL[2];
 BEGIN
  RETURN dbFileHasPeriod(prp_FileName);
 END {prp_HasPeriod};

 PRIVATE PROCEDURE ManInStateInDate(): SCAL[2];
 BEGIN
  IF Man.rStaff THEN
   SELECT(Staff, Man, , Man.Man);
   WHILE OCCURE(Staff) DO
    IF L_Staff.rInState(RepDateB) THEN
     RETURN 1;
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {ManInStateInDate};

 PRIVATE PROCEDURE obj_IsFictCar(): SCAL[2];
 BEGIN
  RETURN (Property.Object = L_Prop.CarProObj) & ~L_Env.RealBoxNbr(Car.BoxNbr);
 END {obj_IsFictCar};

 PRIVATE PROCEDURE obj_IsActualOnDate(): SCAL[2];
 BEGIN
  IF     Property.Object = L_Prop.StaffProObj  THEN RETURN L_Staff.rInState(RepDateB);
  ELSIF  Property.Object = L_Prop.ManProObj    THEN RETURN ManInStateInDate();
  ELSIF  obj_IsFictCar()                       THEN RETURN 0;
  ELSIF  obj_IsActualOneDay() |
         (Property.Object = L_Prop.AvePProObj) THEN RETURN ^(obj_FileDateField()) = RepDateB;
  ELSE                                              RETURN L_DBD.RecordIsActive(RepDateB, obj_FileName);
  END;             
 END {obj_IsActualOnDate};

 PRIVATE PROCEDURE StaffInStateInPer(): SCAL[2];
 BEGIN
  IF ~L_Env.RealTSN(Staff.TSN) | (Staff.BegDate > RepDateE) | (Staff.EndDate < RepDateB) THEN
   RETURN 0;
  ELSE
   SELECT(StaffLog, TSN, , Staff.TSN);
   WHILE OCCURE(StaffLog) DO
    IF L_Staff.OrderInIntvl(RepDateB, RepDateE) THEN
     RETURN 1;
    END;
    NEXT(StaffLog);
   END; (* WHILE OCCURE(StaffLog) ... *)
   RETURN 0;
  END;
 END {StaffInStateInPer};

 PRIVATE PROCEDURE ManInStateInPer(): SCAL[2];
 BEGIN
  SELECT(Staff, Man, , Man.Man);
  WHILE OCCURE(Staff) DO
   IF StaffInStateInPer() THEN
    RETURN 1;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RETURN 0;
 END {ManInStateInPer};

 PRIVATE PROCEDURE obj_IsActualInPer(): SCAL[2];
  VAR
   BDField, EDField: STRING[];
 BEGIN
  IF     Property.Object = L_Prop.StaffProObj  THEN RETURN StaffInStateInPer();
  ELSIF  Property.Object = L_Prop.ManProObj    THEN RETURN ManInStateInPer();
  ELSIF  obj_IsFictCar()                       THEN RETURN 0;
  ELSIF  obj_IsActualOneDay() | (Property.Object = L_Prop.AvePProObj) THEN
   RETURN L_DatTim.IsActive_Inc(^(obj_FileDateField()), RepDateB, RepDateE);
  ELSE
   L_DBD.CollateValidityFieldNames(obj_FileName, BDField, EDField);
   RETURN L_DBD.xRecordIsActiveInIntvl(RepDateB, RepDateE, obj_FileName, BDField, EDField);
  END;
 END {obj_IsActualInPer};

 PRIVATE PROCEDURE obj_IsActual(): SCAL[2];
 BEGIN
  IF dm = dm_OnTheDate THEN
   RETURN obj_IsActualOnDate();
  ELSE
   RETURN obj_IsActualInPer();
  END;
 END {obj_IsActual};

 PRIVATE PROCEDURE prp_IsActual(BDField, EDField: STRING[]): SCAL[2];
 BEGIN
  IF !(^(prp_FileName+"." + EDField))            &
     ~!TABLE.Get(prp_FileName).Fields("DocExpD") &
     ~!(^(prp_FileName + ".DocExpD"))            THEN
   EDField:="DocExpD";
  END;
  IF dm = dm_OnTheDate THEN
   RETURN L_DBD.xRecordIsActive(RepDateB, prp_FileName, BDField, EDField);
  ELSE
   RETURN L_DBD.xRecordIsActiveInIntvl(RepDateB, RepDateE, prp_FileName, BDField, EDField);
  END;
 END {prp_IsActual};

 PRIVATE PROCEDURE prp_WasClosed(BDField, EDField: STRING[]): SCAL[2];
  VAR
   EndDate: DATE;
 BEGIN
  IF !(^(prp_FileName+"." + EDField))            &
     ~!TABLE.Get(prp_FileName).Fields("DocExpD") &
     ~!(^(prp_FileName + ".DocExpD"))            THEN
   EndDate:=^(prp_FileName + ".DocExpD") - 1;
  ELSE
   EndDate:=^(prp_FileName + "." + EDField);
  END;
  IF dm = dm_OnTheDate THEN
   RETURN RepDateB >= EndDate;
  ELSE
   RETURN L_DatTim.IsActive_Inc(EndDate, RepDateB, RepDateE);
  END;
 END {prp_WasClosed};

 PRIVATE PROCEDURE obj_Get(ObjId: STRING[16]);
 BEGIN
  IF ~!Str.Item(ObjId, " ", 1) THEN
   SEARCH(^obj_FileName, ^obj_Key, , Str.Item(ObjId, " ", 0), Str.Item(ObjId, " ", 1));
  ELSE
   SEARCH(^obj_FileName, ^obj_Key, , ObjId);
  END;
 END {obj_Get};

 PRIVATE PROCEDURE MarkForUploadToExcel(ue_FileList: STRING[]);
  VAR
   Idx     : NUMERIC[0];
   FileName: STRING[];
 BEGIN
  L_Excel.ue_MarkRecord(prp_FileName);
  L_Excel.ue_MarkRecord(obj_FileName);
  Idx:=2;
  FileName:=L_Str.PoolItem(ue_FileList, Idx);
  WHILE ~!FileName DO
   CONFORM(^obj_FileName, ^FileName);
   L_Excel.ue_MarkRecord(FileName);
   INC(Idx);
   FileName:=L_Str.PoolItem(ue_FileList, Idx);
  END;
 END {MarkForUploadToExcel};

 PRIVATE PROCEDURE IsLeaf(): SCAL[2];
  VAR
   LendFile: STRING[];
   LendLink: OBJECT;
 BEGIN
  LendLink:=TABLE.Get(prp_FileName).LendLink;
  IF ~!LendLink THEN
   LendFile:=LendLink.CooIndex.Table.Name;
   IF ~!TABLE.Get(LendFile).Fields("Leaf") THEN
    RETURN ^(LendFile+".Leaf");
   END;
  END;
  RETURN 1;
 END {IsLeaf};

 PRIVATE PROCEDURE MakeRepLine();
 BEGIN
  IF (pcm = pcm_NoActualPrp) | (pcm = pcm_NoPrp) THEN
   MAKEPART(R, LineNo, ObjID.ObjID, IsLeaf(), obj_Name());
  ELSE
   MAKEPART(R, Line, ObjID.ObjID, IsLeaf(), obj_Name(), Str.Replace(ObjID.Value, L_Str.CRLF, ""), ObjID.Date, ObjID.EndDate);
  END;
 END {MakeRepLine};

 PRIVATE PROCEDURE IsRequiredObject(): SCAL[2];
 BEGIN
  RETURN (ocm = ocm_AllObj) | obj_IsActual();
 END {IsRequiredObject};

 PRIVATE PROCEDURE ProceedOneObject(Reg: NUMERIC[0]);
 BEGIN
  IF IsRequiredObject() &
     obj_CanHaveProp()  &
     ((pcm = pcm_NoPrp)       & ~obj_HasPrp() |
      (pcm = pcm_NoActualPrp) & ~obj_HasActualPrp()) THEN
   IF Reg = Reg_ToExcel THEN
    MarkForUploadToExcel(ue_FileList);
   ELSE
    DEFAULT(ObjID);
    ObjID.ObjID:=obj_ID();
    INSERT(ObjID);
   END;
  END;
 END {ProceedOneObject};

 PRIVATE PROCEDURE ProceedOneProperty(Reg: NUMERIC[0]; BFN, EFN : STRING[]);
 BEGIN
  IF (( pcm = pcm_HasNotActualPrp                           )  |
      ((pcm = pcm_HasPrp)          & obj_HasPrp()           )  |
      ( pcm = pcm_FullDump                                  )  |
      ((pcm = pcm_HasActualPrp)    & prp_IsActual(BFN, EFN)))  THEN
   IF Reg = Reg_ToExcel THEN
    MarkForUploadToExcel(ue_FileList);
   ELSE
    DEFAULT(ObjID);
    ObjID.ObjID :=obj_ID();
    IF ~!TABLE.Get(prp_FileName).Fields("Val2Show") THEN
     CALL(ObjPro.UpdateVal2Show(prp_FileName));
     ObjID.Value :=^(prp_FileName + ".Val2Show");
    ELSE
     ObjID.Value :=^(prp_FileName + ".Value");
    END;
    IF ~!TABLE.Get(prp_FileName).Fields("PropRow") THEN
     ObjID.PropRow:=^(prp_FileName + ".PropRow");
    END;
    IF ~!BFN & ~!EFN THEN
     ObjID.Date:=^(prp_FileName+"." + BFN);
     IF !(^(prp_FileName+"." + EFN))                &
        ~!TABLE.Get(prp_FileName).Fields("DocExpD") &
        ~!(^(prp_FileName + ".DocExpD"))            THEN
      ObjID.EndDate:=^(prp_FileName+"." + "DocExpD") - 1;
     ELSE
      ObjID.EndDate:=^(prp_FileName+"." + EFN);
     END;
    END;
    INSERT(ObjID);
   END;
  END;
 END {ProceedOneProperty};

 PRIVATE PROCEDURE CheckPeriod(): SCAL[2];
 BEGIN
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   IF (Property.Object = L_Prop.EDOLProObj) |
      (Property.Object = L_Prop.AvePProObj)   THEN
    L_DatTim.CheckWMIntvl(RepDateB, RepDateE);
   END;
  EXCEPT
  ON Exc: Exc_Raise DO
   IF Exc.ErrorCode = -1 THEN
    RETURN 0;
   ELSE
    RAISE();
   END;
  END;
  RETURN 1;
 END {CheckPeriod};

 PRIVATE PROCEDURE SelectPropertyByObj_IsActualOneDay();
  VAR
   trgObj_ID: STRING[];
 BEGIN
  trgObj_ID:=Str.Replace(obj_ID(), " ", ", ");
  IF    Property.Object = L_Prop.MDocProObj THEN
   SELECT(MDocPro, MDoc, , ^trgObj_ID);
  ELSIF Property.Object = L_Prop.PDocProObj THEN
   SELECT(PDocPro, PDoc, , ^trgObj_ID);
  ELSIF Property.Object = L_Prop.ODocProObj THEN
   SELECT(ODocPro, ODoc, , ^trgObj_ID);
  ELSIF Property.Object = L_Prop.EDOLProObj THEN
   SELECT(EDOLPro, EDOrder, , ^trgObj_ID);
  ELSIF Property.Object = L_Prop.RprProObj  THEN
   SELECT(RprPro, RprS, , ^trgObj_ID);
  ELSIF Property.Object = L_Prop.AvePProObj  THEN
   SELECT(AvePPro, AvePay, , ^trgObj_ID);
  ELSE
   L_General.CallUs(0);
  END;
 END {SelectPropertyByObj_IsActualOneDay};

 PUBLIC PROCEDURE Make_CPro();
  VAR
   curLink         : LINK;
   Reg             : NUMERIC[0];
   Top,
   Bot,
   Form,
   Title,
   CooIndexFields,
   PropStr,
   PrpTitle,
   DateCondTitle,
   NoProPool,
   ocm_Pool,
   ocm_ShortPool,
   objID           : STRING[];
   NeedUpload,
   CorrectValues   : SCAL[2];
   prp_BegDateField,
   prp_EndDateField: STRING[];
   trgDate         : DATE;
   curPropTable    : TABLE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Property), " ⠭ ᢮⢮ ꥪ");
  L_General.Assert(Property.Object # L_Prop.OwnDProObj, " ஥ ⮏     ᫠");
  obj_FileName:=L_Prop.ObjectFileName(Property.Object);
  prp_FileName:=L_Prop.ObjectFileProName(Property.Object);
  IF obj_IsActualOneDay() | (Property.Object = L_Prop.AvePProObj) THEN
   ocm_Pool     :="Bce ꥪ|ꥪ  ਮ";
   ocm_ShortPool:="ce| ਮ";
   RepDateB     :=Memo.ud_fr();
   RepDateE     :=Memo.ud_ut();
  ELSE
   ocm_Pool     :="Bce ꥪ|騥 ꥪ";
   ocm_ShortPool:="ce|騥";
   RepDateB     :=Memo.ud_cd();
   SETEMPTY(RepDateE);
  END;
  IF obj_HasPeriod() | obj_IsActualOneDay() THEN
   ocm:=ocm_ActualObj;
  ELSE
   ocm:=ocm_AllObj;
  END;
  dm :=dm_OnTheDate;

  IF prp_HasPeriod() THEN
   NoProPool:=" 騥|騥 饥| 騥 饥|騥 ⥪饥| ";
   pcm:=pcm_HasActualPrp - 1;
  ELSE
   NoProPool:="騥| 騥";
   pcm:=pcm_HasPrp;
  END;

  Form:=L_StdFrm.PartForm("%<D.N.y>YI" +
                          "%<D.N.y>YI" +
                          "%<ꥪ>M" +
                          "%<⢮>M" +
                          "%<"+L_Str.PoolItem(L_Prop.po_Pool, Property.Object)+">T"+
                          "%AT" +
                          "%,5A" + L_Str.PoolItem("NO|O", obj_HasPeriod()) +
                          "%,5AO" +
                          "%C<{}뢥  >DB  %C<㧨  {E}xcel>B  %C<{}⬥>X" +
                          "@"+
                           "                                              Ŀ" +
                          "|                                                /    /     " +
                          "|                                               %##########% %##########% " +
                          "|                                              " +
                          "|%######%                    %######%                                       " +
                          "|%#########################% %#############################################%" +
                          "|%#########################% %#############################################%" +
                          "|||||" +
                          "|%#####################% %#####################% %#####################%");
  LOOP
   CorrectValues:=1;
   Reg:=STDFORM(Form, " ⠢ ᢮⢠ ꥪ⮢ ", , -1, RepDateB, RepDateE,
                Property.Property + " " + Property.Name, ocm_ShortPool, ocm, NoProPool, pcm);
   IF prp_HasPeriod() THEN
    INC(pcm);
   END;
   IF    (ocm = ocm_AllObj) & (~prp_HasPeriod() | (pcm = pcm_FullDump)) THEN
    EXIT;
   ELSIF !RepDateE THEN
    dm:=dm_OnTheDate;
    IF ~(~obj_IsActualOneDay() | (Property.Object = L_Prop.AvePProObj)) THEN
     CorrectValues:=0;
     L_StdFrm.RedInform(" ᢮⢠|" + Property.Property + " '" + Property.Name + "'|" +
                        "ନ஢   ⮫쪮  ਮ");
    END;
   ELSE
    dm:=dm_ForThePeriod;
    IF (ocm = ocm_ActualObj) & ~CheckPeriod() THEN
     CorrectValues:=0;
     L_StdFrm.RedInform("ਮ   楫 ᫮ 楢");
    END;
   END;
   IF CorrectValues THEN
    IF   (Reg = Reg_ToExcel) & ((pcm = pcm_NoActualPrp) | (pcm = pcm_NoPrp)) THEN
     L_StdFrm.RedInform(" Excel  㧨 ⮫쪮 騥 ᢮⢠");
    ELSIF RepDateE < RepDateB THEN
     L_StdFrm.RedInform(" ''   ''");
    ELSIF ~!RepDateB THEN
     EXIT;
    ELSE
     L_StdFrm.RedInform("   ");
    END;
   END;
  END;
  
  RepName :="CPro" + pcm;
  Top     :=L_Str.PoolItem("Top|TopNo|Top|TopNo|Top|Top", pcm);
  Bot     :=L_Str.PoolItem("Bot|BotNo|Bot|BotNo|Bot|Bot", pcm);
  Title   :=L_Str.PoolItem(ocm_Pool, ocm) +
            L_Str.PoolItem(", 騥 |,  騥 |, 騥 饥 |,  騥 饥 |, 騥 ⥪饥 | -   ", pcm);
  PropStr :="᢮⢮ " + Property.Property + " " + Property.Name;
  PrpTitle:=Str.Align(L_Str.PoolItem(L_Prop.po_Pool, Property.Object), 18, LEFT);
  obj_Key:=Get_obj_FileIndex();
 
  IF Reg = Reg_ToExcel THEN
   L_Excel.ue_Create_Rows();
   ue_FileList:=prp_FileName + "|" + obj_FileName;

   FOR_EACH curLink IN TABLE.Get(obj_FileName).Links DO
    IF (curLink.Kind = LINK.Kind_User) |
       (curLink.Kind = LINK.Kind_Borrow) |
       (curLink.Kind = LINK.Kind_History) THEN
     IF curLink.CooIndex.Table.Name # obj_FileName(* 뫪  ᠬ ᥡ -  *) THEN
      ue_FileList:=ue_FileList + "|" + curLink.CooIndex.Table.Name;
     END;
    END;
   END; (* FOR_EACH curLink IN ... *)
  ELSE
   L_AFM.MakeMultipleIndex("ObjID", "ObjID  : STRING[16];"  +
                                    "Value  : STRING[1024];"+
                                    "PropRow: NUMERIC[0];"   +
                                    "Date   : DATE;"        +
                                    "EndDate: DATE",
                           "ObjID: ObjID, PropRow, Date, EndDate");
   IF    (ocm = ocm_AllObj) & (~prp_HasPeriod() | (pcm = pcm_FullDump)) THEN
    DateCondTitle:="";
   ELSIF dm = dm_OnTheDate THEN
    DateCondTitle:=" " + L_DatTim.DateStr(RepDateB);
   ELSE
    DateCondTitle:=" " + L_DatTim.DateStr(RepDateB) + "  " + L_DatTim.DateStr(RepDateE);
   END;
   OPENREP(R, L_General.NameConnection(RepName), Create);
   MAKEPART(R, ^Top, Title, PropStr, DateCondTitle, PrpTitle);
  END;

  IF (pcm = pcm_NoPrp) | (pcm = pcm_NoActualPrp) THEN
   SETSEL((obj_FileName), ^obj_Key);
   FOR_EACH ^obj_FileName DO
    PROMPT(" : " + obj_ID());
    ProceedOneObject(Reg);
   END; (* FOR_EACH ^obj_FileName *)
  ELSIF pcm = pcm_HasNotActualPrp THEN
   L_DBD.CollateValidityFieldNames(prp_FileName, prp_BegDateField, prp_EndDateField);
   SETSEL((obj_FileName), ^obj_Key);
   FOR_EACH ^obj_FileName DO
    objID:=obj_ID();
    PROMPT(" : " + objID);
    IF IsRequiredObject() & ~obj_HasActualPrp() THEN
     SELECT(^prp_FileName, ^obj_Key, , objID, Property.Property);
     WHILE OCCURE(^prp_FileName) DO
      IF prp_WasClosed(prp_BegDateField, prp_EndDateField) THEN
       NeedUpload:=1;
       trgDate:=^(prp_FileName + "." + prp_BegDateField);
       SAVE(^prp_FileName);
       SELECT(^prp_FileName, ^obj_Key, , objID, Property.Property);
       WHILE OCCURE(^prp_FileName) & NeedUpload DO
        NeedUpload:=~((^(prp_FileName + "." + prp_BegDateField) > trgDate) & prp_WasClosed(prp_BegDateField, prp_EndDateField));
        NEXT(^prp_FileName);
       END; (* WHILE OCCURE(^prp_FileName) ... *)
       RESTORE(^prp_FileName);
       IF NeedUpload THEN
        ProceedOneProperty(Reg, prp_BegDateField, prp_EndDateField);
       END;
      END; (* IF prp_WasClosed(prp_BegDateField, prp_EndDateField) ... *)
      NEXT(^prp_FileName);
     END; (* WHILE OCCURE(^prp_FileName) ... *)
    END; (* IF IsRequiredObject() & ~obj_HasActualPrp() ... *)
   END; (* FOR_EACH ^obj_FileName *)
  ELSE
   L_DBD.CollateValidityFieldNames(prp_FileName, prp_BegDateField, prp_EndDateField);
   IF (ocm = ocm_ActualObj) & (obj_IsActualOneDay() | (Property.Object = L_Prop.AvePProObj)) THEN
    SETSEL((obj_FileName), ^(obj_FileDateIndex()));
    SRCINSEL((obj_FileName), GE, , RepDateB);
    WHILE OCCURE(^obj_FileName) & (^(obj_FileDateField()) <= RepDateE) DO
     PROMPT(" : " + obj_ID());
     IF IsRequiredObject() THEN
      SelectPropertyByObj_IsActualOneDay();
      WHILE OCCURE(^prp_FileName) DO
       IF ^(prp_FileName + ".Property") = Property.Property THEN
        ProceedOneProperty(Reg, prp_BegDateField, prp_EndDateField);
       END;
       NEXT(^prp_FileName);
      END; (* WHILE OCCURE(^prp_FileName) ... *)
     END; (* IF IsRequiredObject() ... *)
     NEXT(^obj_FileName);
    END; (* WHILE OCCURE(^obj_FileName) *)
   ELSE
    curPropTable:=DATABASE.Get().Tables.Item(prp_FileName);
    IF (pcm = pcm_HasActualPrp) & ~!curPropTable.Indexes.Item("PrpOwnD") THEN
     CooIndexFields:=L_DBD.GetIndexFieldsName(curPropTable.LendLink.CooIndex);
     SELECT(^prp_FileName, PrpOwnD, , Property.Property);
     WHILE OCCURE(^prp_FileName) DO
      NARROWSEL(^prp_FileName, ^(CooIndexFields));
      CONFORM(^prp_FileName, ^obj_FileName);
      PROMPT(" : " + obj_ID());
      IF IsRequiredObject() THEN
       IF dm = dm_OnTheDate THEN
        IF SRCINSEL(^prp_FileName, LE, RepDateB) THEN
         ProceedOneProperty(Reg, prp_BegDateField, prp_EndDateField);
        END;
       ELSE
        SRCINSEL(^prp_FileName, LE, , RepDateE);
        WHILE OCCURE(^prp_FileName) & (^(prp_FileName + "." + prp_EndDateField) >= RepDateB) DO
         ProceedOneProperty(Reg, prp_BegDateField, prp_EndDateField);
         PREV(^prp_FileName);
        END; (* WHILE OCCURE(^prp_FileName) ... *)
       END;
      END; (* IF IsRequiredObject() ... *)
      NEXTINEXTENDEDSEL(^prp_FileName, ^(CooIndexFields));
     END; (* WHILE OCCURE(^prp_FileName) ... *)
    ELSE
     SELECT(^prp_FileName, Property, , Property.Property);
     WHILE OCCURE(^prp_FileName) DO
      CONFORM(^prp_FileName, ^obj_FileName);
      PROMPT(" : " + obj_ID());
      IF IsRequiredObject() THEN
       ProceedOneProperty(Reg, prp_BegDateField, prp_EndDateField);
      END;
      NEXT(^prp_FileName);
     END; (* WHILE OCCURE(^prp_FileName) ... *)
    END;
   END;
  END;
 
  IF Reg = Reg_ToExcel THEN
   L_Excel.ue_DoUpload(prp_FileName, ue_FileList);
   L_Excel.ue_Purge_Rows();
  ELSE
   SELECT(ObjID, ObjID);
   WHILE OCCURE(ObjID) DO
    obj_Get(ObjID.ObjID);
    PROMPT("뢮 : " + ObjID.ObjID);
    MakeRepLine();
    NEXT(ObjID);
   END; (* WHILE OCCURE(ObjID) ... *)
   MAKEPART(R, ^Bot);
   CLOSEREP(R);
   L_General.SurveyLastReport();
  END; (* IF Reg = Reg_ToExcel *)
 END {Make_CPro};

END.

