(*
%Copyright   (c) Polak IT
%Author      15.06.2004 10:52:31 POLAK\GAV
%Purpose      㤥ঠ
%Type        report
%Specific    SYS
%Modified    20.11.2012 14:05:15 POLAK\Gina
%Environment
*)

 MODULE Ded01 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Basis, L_Staff, L_General, Memo, FIO, L_DatTim, P_Firm, L_bp, L_Str;

 VAR
  wMF: SCAL[2];

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
  END;
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, " 㤥ঠ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_WrStr(F, "⥣");
  L_Basis.wb_WrStr(F, "ঊ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "⠍");
  L_Basis.wb_WrStr(F, "⠎");
  L_Basis.wb_WrStr(F, "࣠");
  L_Basis.wb_WrStr(F, "࣠");
  L_Basis.wb_WrStr(F, "ঊ");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "⥫");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "줮");
  L_Basis.wb_WrStr(F, "⮥");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE MakeLine(F: STRING[]; Saldo: LIKE(DedAcnt.Saldo); isActive: SCAL[2]);
 BEGIN
  CONFORM(Deduct, MCList);
  CONFORM(Deduct, Firm);
  CONFORM(Deduct, DedType);
  CONFORM(Deduct, PayP);

  IF wMF THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl("F", MyFirm.MyFirm);
   L_Basis.wb_WrStr("F", MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrScl(F, Deduct.DedNbr);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrScl(F, Sort.Name);
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrScl(F, Union.Name);
  L_Basis.wb_WrScl(F, Deduct.MCode);
  L_Basis.wb_WrStr(F, MCList.Name);
  L_Basis.wb_WrDat(F, Deduct.BegDate);
  L_Basis.wb_WrDat(F, Deduct.EndDate);
  L_Basis.wb_WrScl(F, Deduct.Firm);
  L_Basis.wb_WrStr(F, Firm.Name);
  L_Basis.wb_WrScl(F, Deduct.DedType);
  L_Basis.wb_WrStr(F, DedType.Name);
  L_Basis.wb_WrScl(F, Deduct.PayP);
  L_Basis.wb_WrStr(F, PayP.Name);
  L_Basis.wb_WrStr(F, Deduct.Person);
  L_Basis.wb_WrStr(F, Deduct.PCode);
  L_Basis.wb_WrStr(F, Deduct.PAddr[0] + " " + Deduct.PAddr[1]);
  L_Basis.wb_WrNum(F, Saldo, 2);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("+|-", isActive));
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PRIVATE PROCEDURE GetSaldo(D: DATE): LIKE(DedAcnt.Saldo);
  VAR
   Result: LIKE(DedAcnt.Saldo);
 BEGIN
  SELECT(DedAcnt, TSN, , Deduct.TSN, Deduct.DedNbr);
  IF SRCINSEL(DedAcnt, LT, L_DatTim.Per(D)) THEN
   Result:=L_General.Denominate(DedAcnt.Period, L_DatTim.Per(D), DedAcnt.Saldo + DedAcnt.NetDebt - DedAcnt.Cred);
  ELSIF SRCINSEL(DedAcnt, EQ, L_DatTim.Per(D)) THEN
   Result:=L_General.Denominate(DedAcnt.Period, L_DatTim.Per(D), DedAcnt.Saldo);
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {GetSaldo};

 PUBLIC PROCEDURE Ded01();
  CONST
   bpId = "Ded01";
  VAR
   isActive: SCAL[2];
   curSaldo: LIKE(DedAcnt.Saldo);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_bp.Begin(bpId, " 㤥ঠ", L_bp.t_Basis, L_General.tc_onDate);
  FIO.Open(F, L_General.NameConnection("DED01"), "REP", Create);
  MakeTop("F");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   CONFORM(Staff, Man);
   SELECT(Deduct, TSN, , Staff.TSN);
   WHILE OCCURE(Deduct) DO
    CONFORM(Deduct, DedType);
    isActive:=L_DatTim.IsActive_Inc(Memo.ud_cd(), Deduct.BegDate, Deduct.EndDate);
    curSaldo:=GetSaldo(Memo.ud_cd());
    IF (L_Staff.rInState(Memo.ud_cd()) & isActive) |
       ((DedType.Limited) & (curSaldo < 0) & (L_DatTim.CompleteYearsInIntvl(Deduct.EndDate, Memo.ud_cd()) < 3)) THEN
     CONFORM(StaffLog, Post, Sort, Union);
     MakeLine("F", curSaldo, isActive);
    END;
    NEXT(Deduct);
   END; (* WHILE OCCURE(Deduct) ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  FIO.Close(F);
  L_bp.End();
 END {Ded01};

END.