(*
%Copyright   (c) Polak Computer System  
%Author      SAN                        
%Purpose     ⥬ ⠤  ௫
%Type        operation
%Specific    SYS
%Modified    03.09.2014 13:51:14 POLAK\San
%Environment
*)

 MODULE DedF [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_MathR, L_Tax, L_STx, L_StdFrm,
        Math, L_PRoll, L_Staff, L_EC, L_Money, L_APtm, L_AcCut,
        L_PayPRl, L_XObj, D_XObj, L_OwnData, Memo, E_PRoll, L_Env,
        L_PayP, L_Acnt, P_Firm, P_MCList, L_Str, L_XDoc, L_Stock,
        L_SysLog;

 CONST
  DedNbr = 7;

 VAR
  DedBase, _DedBase   : NUMERIC[2][DedNbr+1];
  DedTime, _DedTime   : NUMERIC[3][DedNbr+1];
  Pos, _Pos,
  Neg, _Neg,
  _FutInc             : NUMERIC[2];
  _TimDone            : LIKE(PCalc.TimDone);
  PureIncr            : NUMERIC[2];

 PRIVATE PROCEDURE Prompt(Msg: STRING[]);
 BEGIN
  PROMPT("⥬ ⠤, " + Msg);
 END {Prompt};

 PRIVATE PROCEDURE PutMoneyInAnyPeriod(InFuture: SCAL[2];
                                       Sign    : NUMERIC[0];
                                       _Period,
                                       _ODate  : DATE;
                                       _MCode  : LIKE(Money.MCode);
                                       _Tim    : LIKE(Money.Tim);
                                       _Sum    : LIKE(Money.Sum);
                                       _Source : LIKE(Money.Source));
  VAR
   _Closed: DATE;
 BEGIN
  IF InFuture THEN
   _Closed:=_Period;
  ELSE
   _Closed:=Memo.gl_mb();
  END;
  L_PRoll.detailedSaveMoney_AP(Sign, 0, _Closed, _MCode, _Period, _ODate, _Source,
                               EMPTYOF(MoneyDst.XDocId), EMPTYOF(MoneyDst.XObject), EMPTYOF(MoneyDst.AcCut),
                               _Sum, _Tim);
 END {PutMoneyInAnyPeriod};

 PRIVATE PROCEDURE GetManMonthSum(_Man: LIKE(Man.Man); _MyFirm: P_Firm.tMyFirm; _MCode: LIKE(MCList.MCode); P: DATE): LIKE(Money.Sum);
  VAR
   Result: LIKE(Money.Sum);
 BEGIN
  Result:=0;
  SAVE(Staff);
  SELECT(Staff, MyFirm, , _MyFirm, _Man);
  WHILE OCCURE(Staff) DO
   IF SELECT(Money, MCode, _MCode, P, Staff.TSN) THEN
    WHILE OCCURE(Money) DO
     IF Money.Source # L_PRoll.src_System THEN
      INC(Result, Money.Sum);
     END;
     NEXT(Money);
    END; (* WHILE OCCURE(Money) *)
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RESTORE(Staff);
  RETURN Result;
 END {GetManMonthSum};

 PRIVATE PROCEDURE ConvertSomeMoney();
  VAR
   P       : DATE;
   curMCode,
   corMCode: LIKE(MCList.MCode);
   curSum,
   prvSum,
   curCnv  : LIKE(Money.Sum);
 BEGIN
  IF L_Staff.IsMainForTax(Memo.gl_me()) THEN
   SELECT(MCPro, Property, , P_MCList.P_Attitude2SFee, L_Str.PoolItem(P_MCList.a2sf_Pool, P_MCList.a2sf_LimitedTaxable));
   WHILE OCCURE(MCPro) DO
    IF L_DatTim.IsActive_Inc(Memo.gl_mb(), MCPro.Date, MCPro.EndDate) THEN
     curMCode:=MCPro.MCode;
     curSum:=GetManMonthSum(Staff.Man, Staff.MyFirm, curMCode, Memo.gl_mb());
     IF curSum # 0 THEN
      prvSum:=0;
      P:=Memo.gl_mb();
      WHILE P > L_DatTim.YearBeg(Memo.gl_mb()) DO
       P:=L_DatTim.IncMonth(P, -1);
       INC(prvSum, GetManMonthSum(Staff.Man, Staff.MyFirm, curMCode, P));
      END;
      L_General.Assert((prvSum+curSum)>=0, "᫥   " + curMCode + "    楫    ⥫묨");
      IF curSum >= 0 THEN
       curCnv:=Math.Min(curSum, Math.Max(0, P_MCList.a2sf_Limit(curMCode, Memo.gl_mb()) - prvSum));
      ELSE
       curCnv:=Math.Max(curSum, Math.Min(0, (prvSum + curSum) - P_MCList.a2sf_Limit(curMCode, Memo.gl_mb())));
      END;
      IF curCnv # 0 THEN
       corMCode:=P_MCList.a2sf_CorMCode(curMCode, Memo.gl_mb());
       L_PRoll.SaveMoney(+1, corMCode, Memo.gl_mb(), L_PRoll.src_System, curCnv, 0);
       curCnv:=(-1)*curCnv;
       L_PRoll.SaveMoney(+1, curMCode, Memo.gl_mb(), L_PRoll.src_System, curCnv, 0);
      END;
     END; (* IF curSum ... *)
    END; (* IF L_DatTim.IsActive_Inc ... *)
    NEXT(MCPro);
   END; (* WHILE OCCURE(MCPro) ... *)
  END;
 END {ConvertSomeMoney};

 PRIVATE PROCEDURE ExcludeFuture();
  VAR
   _ODate  : LIKE(Money.ODate);
   _Period : LIKE(Money.Period);
   _MCode,
   futMCode: LIKE(Money.MCode);
   futPay  : P_MCList.tForFuture;
   _Sum    : NUMERIC[2];
   _Tim    : NUMERIC[3];
 BEGIN
  SETSEL(Money, PayFor, Staff.TSN);
  SRCINSEL(Money, GE, , L_DatTim.NextPer(Memo.gl_mb()));
  WHILE OCCURE(Money) DO
   IF (Money.Closed = Memo.gl_mb()) &
      (Money.Source # L_PRoll.src_FtSys) &
      (Money.Source # L_PRoll.src_System) &
      (Money.Source # L_PRoll.src_XCalc) THEN
    IF (Money.Sum # 0) | (Money.Tim # 0) THEN
     _Sum   :=Money.Sum;
     _Tim   :=Money.Tim;
     _Period:=Money.Period;
     _MCode :=Money.MCode;
     _ODate :=Money.ODate;
     CONFORM(Money, MCList);
     futPay:=P_MCList.GetForFuture(MCList.MCode, Memo.gl_mb());
     IF futPay = P_MCList.mcfp_inNextPeriod THEN
      L_General.Assert(MCList.MCTyp=0, "७ ᫥  ਮ 믮  㤥ঠ| 㤥ঠ "+Money.MCode);
      SAVE(Money);
      L_PRoll.FixPCalc(_Period);
      PutMoneyInAnyPeriod(1, +1, _Period, _ODate,
                          _MCode, _Tim, _Sum, L_PRoll.src_FtSys);
      PutMoneyInAnyPeriod(0, -1, _Period, _ODate,
                          _MCode, _Tim, _Sum, L_PRoll.src_FtSys);
      RESTORE(Money);
     ELSIF futPay = P_MCList.mcfp_ChangeMCode THEN
      L_General.Assert((Memo.gl_mb() < 01\04\2012) | (*09.07.2012 20:03:32 POLAK\Gina ࠢ쭮 < 01\04\2011,     ६ ந *)
                       (L_General.GetAPSiteID() = "10"),
                       "८ࠧ  ᫥  ਮ|  ਬ  04.2012| "+Money.MCode);
      L_General.Assert(MCList.MCTyp=0, "८ࠧ  ᫥  ਮ 믮  㤥ঠ| 㤥ঠ "+Money.MCode);
      SAVE(Money);
      futMCode:=E_PRoll.FutMCode(_MCode);
      PutMoneyInAnyPeriod(0, -1, _Period, _ODate,
                            _MCode, _Tim, _Sum, L_PRoll.src_System);
      PutMoneyInAnyPeriod(0, +1, _Period, _ODate,
                          futMCode, _Tim, _Sum, L_PRoll.src_System);
      PutMoneyInAnyPeriod(1, +1, _Period, _ODate,
                            _MCode, _Tim, _Sum, L_PRoll.src_FtSys);
      PutMoneyInAnyPeriod(1, -1, _Period, _ODate,
                          futMCode, _Tim, _Sum, L_PRoll.src_FtSys);
      RESTORE(Money);
     END; (* IF futPay = P_MCList.mcfp_inNextPeriod ... *)
    END; (* IF Money.Sum ... *)
   END; (* IF Money.Closed ... *)
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
 END {ExcludeFuture};

 PRIVATE PROCEDURE CorBases(_Sum   : LIKE(Money.Sum);
                            _Tim   : LIKE(Money.Tim);
                            _Source: LIKE(Money.Source));
  VAR
   i: NUMERIC[0];
 BEGIN
  IF MCList.MCTyp = 0 THEN
   INC(Pos, _Sum);
  ELSE
   INC(Neg, _Sum); _Sum:=-_Sum;
  END;
  i:=0;
  WHILE i <= DedNbr DO
   IF MCList.ForDed[i] THEN
    INC(DedBase[i], _Sum);
    IF (MCList.TimeType > 0(* 뢠*)) THEN
     INC(DedTime[i], _Tim);
    END;
    IF (MCList.MCTyp = 0) & (i = 0) & (_Source # L_PRoll.src_FtSys) THEN
     INC(PureIncr,  _Sum);
    END;
   END;
   INC(i);
  END;
 END {CorBases};

 PRIVATE PROCEDURE KeepMoneyForOuters(_Sum: LIKE(Money.Sum));
 BEGIN
  L_Tax.Tax_FormTaxAdvByMoney(_Sum);
  L_STx.STx_KeepForSTax(_Sum);
  L_PRoll.KeepMoneyInXCalc(_Sum);
 END {KeepMoneyForOuters};

 PRIVATE PROCEDURE SumForDeduction();
 BEGIN
  L_Tax.Tax2001_InitCodes(Memo.gl_mb());
  SETZERO(DedBase, DedTime,
          Pos, Neg, PCalc.PurToTax, _TimDone, PureIncr);
  SETSEL(Money, TSN, Staff.TSN, Memo.gl_mb());
  FOR_EACH Money DO
   Prompt("ᡮ ஢   " + Money.MCode);
   IF !Money.ODate THEN
    L_General.CallUs(Money.Source = L_PRoll.src_Operator);
    L_General.Error("室 ⠢  ਪ  /  ஢ ");
   END;
   IF (Money.Sum # 0) | (Money.Tim # 0) THEN
    CONFORM(Money, MCList);
    L_General.Assert(L_DatTim.InPatIntvl(MCList.Begin, MCList.Till, Money.WFPeriod, L_DatTim.MonthEnd(Money.WFPeriod)),
                     " / " + MCList.MCode+"    "+L_DatTim.PeriodStr(Money.WFPeriod));
    CorBases(Money.Sum, Money.Tim, Money.Source);
    KeepMoneyForOuters(Money.Sum);
    IF (MCList.TimeType = L_PRoll.tt_Production) &
       (Money.Period = Memo.gl_mb()) THEN
     INC(_TimDone, Money.Tim);
    END;
    L_PRoll.ClearZeroMoneyDst();
   ELSE
    L_PRoll.extRemove_Money(1, 1);
   END;
  END; (* FOR_EACH Money *)
  REPLACE(PCalc);
 END {SumForDeduction};

 PRIVATE PROCEDURE GetFutBases(P: DATE);
 BEGIN
  (*    / (।,  , ࠡ⪠  ) *)
  SETZERO(DedBase, DedTime, Pos, Neg);
  SELECT(Money, TSN, , Staff.TSN, P);
  WHILE OCCURE(Money) DO
   IF (Money.Source = L_PRoll.src_FtSys) &
      (Money.WFPeriod <= Memo.gl_mb()) THEN
    CONFORM(Money, MCList);
    CorBases(Money.Sum, Money.Tim, Money.Source);
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
 END {GetFutBases};

 PRIVATE PROCEDURE PutMoney(sm: SCAL[2]; c: LIKE(Money.MCode); s: LIKE(Money.Sum); xo: LIKE(XObject.XObject));
 BEGIN
  SEARCH(MCList, MCode, , c);
  IF sm THEN
   L_PRoll.detailedSaveMoney(+1, c, Memo.gl_mb(), StaffLog.Date, L_PRoll.src_System,
                             EMPTYOF(MoneyDst.XDocId), xo, EMPTYOF(MoneyDst.AcCut),
                             s, 0);
   IF s # 0 THEN
    KeepMoneyForOuters(s);
   END;
  ELSE
   s:=L_Money.RoundMoney(Memo.gl_mb(), s);
  END;
  CorBases(s, 0, L_PRoll.src_System);
 END {PutMoney};

 PRIVATE PROCEDURE TRUNC(Value, Step: NUMERIC[2]): NUMERIC[2];
  VAR t1, t2: NUMERIC[0];
 BEGIN
  t1:=Value*100; t2:=Step*100; RETURN t1 DIV t2 * Step;
 END {TRUNC};

 PRIVATE PROCEDURE TruncSaldo();
  VAR
   Module: NUMERIC[2];
 BEGIN
  Module:=PCalc.Saldo-TRUNC(PCalc.Saldo, L_Money.GetBusinessAccountingPrecision(Memo.gl_mb()));
  L_General.CallUs(Module = 0);
 END {TruncSaldo};

 PRIVATE PROCEDURE Calc_Pns(sm: SCAL[2]; P: DATE);
  VAR
   Prc    : NUMERIC[5];
   _MCode : LIKE(MCList.MCode);
 BEGIN
  E_PRoll.GetPnsPrc(P, 0, Prc, _MCode);
  IF (_MCode # 0) & (Prc # 0) THEN
   PutMoney(sm, _MCode, DedBase[2]*Prc, EMPTYOF(XObject.XObject));
  END;
  E_PRoll.GetPnsPrc(P, 2, Prc, _MCode);
  IF (_MCode # 0) & (Prc # 0) THEN
   PutMoney(sm, _MCode, DedBase[2]*Prc, EMPTYOF(XObject.XObject));
  END;
 END {Calc_Pns};

 PRIVATE PROCEDURE GetPureIncr(P: DATE): NUMERIC[2];
  VAR
   _MainTSN  : LIKE(Staff.TSN);
   _PureIncr : NUMERIC[2];
 BEGIN
  IF L_Staff.IsMainForTax(L_DatTim.MonthEnd(P)) THEN
   _MainTSN :=Staff.TSN;
   _PureIncr:=0;
   SAVE(Staff);
   SELECT(Staff, MyFirm, , Staff.MyFirm, Staff.Man);
   WHILE OCCURE(Staff) DO
    IF Staff.TSN # _MainTSN THEN
     SELECT(Money, TSN, , Staff.TSN, P);
     WHILE OCCURE(Money) DO
      CONFORM(Money, MCList);
      IF (MCList.MCTyp = 0) & MCList.ForDed[0] & (Money.Source # L_PRoll.src_FtSys) THEN
       INC(_PureIncr,  Money.Sum);
      END;
      NEXT(Money);
     END; (* WHILE OCCURE(Money) ... *)
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   RESTORE(Staff);
   RETURN PureIncr + _PureIncr;
  ELSE
   RETURN PureIncr;
  END;
 END {GetPureIncr};

 PRIVATE PROCEDURE SysDeduct(sm: SCAL[2]; P: DATE);
  CONST
   TaxesNum = 2; (* ⭮    sic! *)
  VAR
   Taxes: NUMERIC[2][TaxesNum];
   i    : NUMERIC[0];
 BEGIN
  Prompt("⥬ 㤥ঠ");
  IF Memo.gl_mb() >= 01\01\2001 THEN
   L_STx.STx_PutTaxes(P);
  ELSE
   Calc_Pns(sm, P);
  END;
  L_Tax.Tax_Calc_Tax(P, GetPureIncr(P), Taxes);
  i:=0;
  WHILE i < TaxesNum DO
   IF Taxes[i] # 0 THEN
    PutMoney(sm, L_Tax.Tax_Get_mc_Tax(P, i), Taxes[i], EMPTYOF(XObject.XObject));
   END;
   INC(i);
  END; (* WHILE i < ... *)
 END {SysDeduct};

 PRIVATE PROCEDURE BalDedAcnt(): LIKE(DedAcnt.Saldo);
  VAR
   _Saldo: LIKE(DedAcnt.Saldo);
   _ToPay: LIKE(DedAcnt.ToPay);
 BEGIN
  LOOP
   _Saldo :=L_General.DenominateNM(DedAcnt.Period,
                                   DedAcnt.Saldo + DedAcnt.NetDebt - DedAcnt.Cred);
   IF DedType.BaseNo = L_PRoll.dtbn_Sum THEN
    _ToPay:=L_General.DenominateNM(DedAcnt.Period, DedAcnt.ToPay);
   ELSE
    _ToPay:=DedAcnt.ToPay;
   END;
   IF NEXT(DedAcnt) THEN
    DedAcnt.Saldo:=_Saldo;
(*
    DedAcnt.ToPay:=_ToPay;    (*㦭  室  .⠡ 業*)
*)
    REPLACE(DedAcnt); 
   ELSE
    EXIT;
   END;
  END;
  RETURN _Saldo;
 END {BalDedAcnt};

 PRIVATE PROCEDURE ProlongDedAcnt(P: DATE);
  VAR
   _Saldo: LIKE(DedAcnt.Saldo);
   _ToPay: LIKE(DedAcnt.ToPay);
 BEGIN
  _Saldo:=BalDedAcnt();
  LAST(DedAcnt);
  IF DedAcnt.Period = P THEN
   _ToPay:=DedAcnt.ToPay;
   DEFAULT(DedAcnt);
   DedAcnt.Period:= L_DatTim.IncMonth(P, +1);  (* c        *)
   DedAcnt.Saldo := _Saldo;           (* 室 ᠫ줮 *)
   DedAcnt.ToPay :=_ToPay;
   IF DedType.BaseNo = L_PRoll.dtbn_Sum THEN
    DedAcnt.ToPay:=L_General.DenominateNM(P, DedAcnt.ToPay);
   END;
   DedAcnt.Cred  :=0;
   INSERT(DedAcnt);
  END;
 END {ProlongDedAcnt};

 PRIVATE PROCEDURE TruncateDedAcnt();
 BEGIN
  NEXT(DedAcnt);
  WHILE OCCURE(DedAcnt) DO
   REMOVE(DedAcnt);
  END;
 END {TruncateDedAcnt};

 PRIVATE PROCEDURE GetFromCorDeduct(P: DATE): NUMERIC[2];
  VAR
   CR: NUMERIC[0];
 BEGIN
  L_General.Assert(~!Deduct.CorDedNb, " 㤥ঠ N " + Deduct.DedNbr + "| 㪠  ᯮ饣 㤥ঠ");
  SAVE(DedAcnt);
  L_General.Assert(SELECT(DedAcnt, TSN, Deduct.TSN, Deduct.CorDedNb),
                   " 㤥ঠ " + Deduct.DedNbr + " 㪠 饥 ᯮ饥 㤥ঠ " + Deduct.CorDedNb);
  IF DedType.BaseNo = L_PRoll.dtbn_OnRest THEN
   L_General.Assert(SRCINSEL(DedAcnt, LE, P), "ঠ N " + Deduct.CorDedNb + "| ப   " + L_DatTim.PeriodStr(P));
   IF DedAcnt.Period = P THEN
    CR:=(-DedAcnt.Saldo) + DedAcnt.Cred;
   ELSE
    CR:=(-DedAcnt.Saldo) + DedAcnt.NetDebt;
   END;
   IF P = Memo.gl_mb() THEN
    L_General.Assert(CR > 0,
                     " ⪠  㤥ঠ N " + Deduct.CorDedNb + "." +
                     "|室  㤥ঠ 業⮢  "+L_DatTim.DateStr(Memo.gl_mb()-1));
   ELSE
    CR:=Math.Min(CR, 0);
   END;
  ELSIF DedType.BaseNo = L_PRoll.dtbn_OnDept THEN
   L_General.Assert(SRCINSEL(DedAcnt, EQ, P), "ঠ N " + Deduct.CorDedNb + "| ப   " + L_DatTim.PeriodStr(P));
   CR:=DedAcnt.NetDebt;
  ELSE
   L_General.CallUs(0);
  END;
  RESTORE(DedAcnt);
  RETURN CR;
 END {GetFromCorDeduct};

 PRIVATE PROCEDURE DeductAccess(_TSN: LIKE(Deduct.TSN); _CorDedNb: LIKE(Deduct.CorDedNb));
 BEGIN
  L_General.Assert(~!Deduct.CorDedNb,
                   " 㤥ঠ N " + Deduct.DedNbr +
                   "| 㪠  ᯮ饣 㤥ঠ");
  L_General.Assert(Deduct.CorDedNb < Deduct.DedNbr,
                   " 㤥ঠ N " + Deduct.DedNbr +
                   "| ᯮ饣 㤥ঠ   ");
  L_General.Assert(SEARCH(Deduct, TSN, _TSN, _CorDedNb),
                   " 㤥ঠ N " + _CorDedNb);
 END {DeductAccess};

 PRIVATE PROCEDURE CheckPaidDeduct(P: DATE; FinalPass: SCAL[2]);
  VAR
   S: NUMERIC[2];
 BEGIN
  IF FinalPass & DedType.Limited & L_Staff.IsLeaveFinally(P) & L_DatTim.IsActive(Staff.EndDate+1, Deduct.BegDate, Deduct.EndDate) THEN
   S:=DedAcnt.Saldo+DedAcnt.NetDebt-DedAcnt.Cred;
   L_General.Assert(S >= 0,
                    " " + Staff.TSN +
                    " 㤥ঠ N " + Deduct.DedNbr +
                    "|騩 ࠡ⭨  믫祭 㤥ঠ" +
                    "| ࠭祭 㬬." +
                    "|믫祭 㬬 " +
                    L_Money.MoneyToStr(Memo.gl_mb(), ",", S));
  END;
 END {CheckPaidDeduct};

 PRIVATE PROCEDURE E_Dedf_DeductTakeLvd(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.Dedf_DeductTakeLvd), 0);
 END {E_Dedf_DeductTakeLvd};

 PRIVATE PROCEDURE SingleDeduct(P: DATE; FinalPass: SCAL[2]): NUMERIC[2];
  VAR
   Paid          : SCAL[2];
   _Saldo        : LIKE(DedAcnt.Saldo);
   _Debt         : LIKE(DedAcnt.TotDebt);
   _ToPay        : LIKE(DedAcnt.ToPay);
   Days,
   InFirm        : NUMERIC[0];
   ToPrc,
   Collect,
   Profit        : NUMERIC[2];
   _TaxAdv       : LIKE(TaxAdv.TaxAdv);
   _CorDeductBegD: DATE;
   _LstProc      : PROC;
   RfRtPortion   : FLOAT;
 BEGIN
  IF L_Staff.IsWorking(P) THEN
   Days  :=L_DatTim.DATEINT(Math.Max(P, Staff.BegDate), Math.Min(L_DatTim.MonthEnd(P), Staff.EndDate),
                            Deduct.BegDate,             Deduct.EndDate);
   InFirm:=L_DatTim.DATEINT(P, L_DatTim.MonthEnd(P), Staff.BegDate, Staff.EndDate);
  ELSE
   Days  :=L_DatTim.DATEINT(P, L_DatTim.MonthEnd(P), Deduct.BegDate, Deduct.EndDate);
   InFirm:=Days;
  END;
  CONFORM(Deduct, DedAcnt, DedType);
  IF (Deduct.DedType # 00) & (L_Staff.IsWorking(P) | E_Dedf_DeductTakeLvd(P)) & (Days > 0) THEN
   IF ~SRCINSEL(DedAcnt, EQ, P) THEN
    L_General.CallUs(SRCINSEL(DedAcnt, LE, P));
    _Saldo:=L_General.Denominate(DedAcnt.Period, P,
                                 DedAcnt.Saldo + DedAcnt.NetDebt - DedAcnt.Cred);
    IF DedType.BaseNo = L_PRoll.dtbn_Sum THEN
     _ToPay:=L_General.Denominate(DedAcnt.Period, P, DedAcnt.ToPay);
    ELSE
     _ToPay:=DedAcnt.ToPay;
    END;
    DEFAULT(DedAcnt);
    DedAcnt.Period:=P;
    DedAcnt.Saldo :=_Saldo;
    DedAcnt.ToPay :=_ToPay;
    DedAcnt.Cred  :=0;
    INSERT(DedAcnt);
   END;
   IF    DedType.BaseNo = L_PRoll.dtbn_Sum THEN
    _Debt:=DedAcnt.ToPay;
   ELSIF DedType.BaseNo = L_PRoll.dtbn_OnRest THEN
    _Debt:=GetFromCorDeduct(P) * (DedAcnt.ToPay / 100 / 12);
   ELSIF DedType.BaseNo = L_PRoll.dtbn_OnDept THEN
    _Debt:=GetFromCorDeduct(P) * (DedAcnt.ToPay / 100);
   ELSE
    ToPrc:=DedBase[DedType.BaseNo];
    IF ToPrc > 0 THEN
     _Debt:=ToPrc * (DedAcnt.ToPay / 100);
    ELSE
     _Debt:=0;
    END; (* IF ToPrc > 0 ... *)
   END; (* IF DedType.BaseNo ... *)
   IF FinalPass & DedType.UpToBal & (PCalc.CorBal > PCalc.TimDone) &
      (PCalc.HBal-(PCalc.CorBal-PCalc.TimDone) > 0) THEN
    _Debt:=_Debt * PCalc.HBal / (PCalc.HBal-(PCalc.CorBal-PCalc.TimDone));
   END; (* IF DedType.UpToBal ... *)
(*
   IF FinalPass & DedType.UpToBal & (DedTime[DedType.BaseNo] < PCalc.HBal) & (DedTime[DedType.BaseNo] > 0) THEN
    _Debt:=_Debt * (PCalc.HBal / DedTime[DedType.BaseNo]);
   END; (* IF DedType.UpToBal ... *)
*)
   IF DedType.Dayly THEN
    IF    DedType.BaseNo = L_PRoll.dtbn_Sum THEN
     _Debt:=_Debt*Days/L_DatTim.MonthLen(P);
    ELSE
     _Debt:=_Debt*Days/InFirm;
    END;
   END;
   CONFORM(Deduct, PayP);
   INC(_Debt, DedAcnt.Corr);
   IF ~DedType.OnCredit & FinalPass THEN
    _Debt:=Math.Min(DedBase[0] + PCalc.FutInc, _Debt);
   END;
   Paid:=0;
   IF DedType.Limited THEN
    _Saldo:=DedAcnt.Saldo-DedAcnt.Cred;
    IF    _Saldo = 0 THEN
     Paid :=1;
     _Debt:=0;
    ELSE
     L_General.Assert(_Saldo < 0, "ঠ # " + Deduct.DedNbr +
                      "|ঠ  ࠭祭 㬬    ⥫쭮 ᠫ줮");
     _Debt:=Math.Min(_Debt, -_Saldo);
    END;
   END; (* IF DedType.Limited ... *)
   IF _Debt > 0 THEN
    IF    DedType.RountMth = 1(* 楫*)      THEN
     _Debt:=TRUNC(_Debt, 1);
    ELSIF DedType.RountMth = 2(* . *) THEN
     _Debt:=L_PRoll.TruncMoney(P, _Debt);
    END;
   ELSIF (DedAcnt.Corr >= 0) THEN
    _Debt:=0;
   END;
   IF !PayP.LstProc THEN
    Collect:=0;
   ELSE
    _LstProc:=L_PayP.GetPayPLstProc();
    _LstProc(1, _Debt, _Debt, Collect);
   END;
   DedAcnt.NetDebt:=_Debt;
   DedAcnt.TotDebt:=_Debt+Collect;
   REPLACE(DedAcnt);
   _Debt:=DedAcnt.TotDebt;
   CheckPaidDeduct(P, FinalPass);
   IF Paid THEN
    TruncateDedAcnt();
   ELSE
    ProlongDedAcnt(P);
   END;
   IF FinalPass & (DedType.BaseNo = L_PRoll.dtbn_OnRest) THEN
    IF    Memo.gl_mb() >= 01\01\2009 THEN RfRtPortion:=2/3;
    ELSIF Memo.gl_mb() >= 01\01\2001 THEN RfRtPortion:=3/4;
    ELSE                                  RfRtPortion:=2/3;
    END;
    IF Memo.gl_mb() >= 01\01\2001 THEN
     IF    Memo.gl_mb() >= 01\01\2008 THEN
      _CorDeductBegD:=Math.Min(L_DatTim.MonthEnd(P), Staff.EndDate);
     ELSIF Memo.gl_mb() >= 01\01\2002 THEN
      SAVE(Deduct);
      DeductAccess(Deduct.TSN, Deduct.CorDedNb);
      _CorDeductBegD:=Deduct.BegDate;
      RESTORE(Deduct);
     ELSE
      _CorDeductBegD:=Memo.gl_mb();
     END;
     Profit:=GetFromCorDeduct(P)*
             (L_OwnData.RefinancingRate(_CorDeductBegD)/100*(Days/L_DatTim.YearLen(Memo.gl_mb()))*RfRtPortion);
    ELSE
     Profit:=GetFromCorDeduct(P)*
             (L_OwnData.RefinancingRate(Memo.gl_mb())/100/12*RfRtPortion);
     IF DedType.Dayly THEN
      Profit:=Profit*Days/InFirm;
     END;
    END;
    DEC(Profit, _Debt);
    IF Profit > 0 THEN
     IF Memo.gl_mb() >= 01\01\2001 THEN
      PutMoney(1, L_Tax.Tax_GetLoanProfitMCode(Memo.gl_mb()), -Profit, EMPTYOF(XObject.XObject));
      PutMoney(1,                               Deduct.MCode,  Profit, L_XObj.GetXObjectBy_fi_ri(Deduct.fiCO, Deduct.riCO));
     ELSE
      L_Tax.Tax_SaveLoanProfit(Memo.gl_mb(), Profit);
     END;
    END;
   END;
  ELSE
   _Debt:=0;
   IF P <= Deduct.EndDate THEN
    LAST(DedAcnt);
    CheckPaidDeduct(P, FinalPass);
   END;
   IF SRCINSEL(DedAcnt, EQ, P) THEN
    DedAcnt.TotDebt   :=_Debt;
    DedAcnt.NetDebt:=_Debt;
    REPLACE(DedAcnt);
    TruncateDedAcnt();
   END;
  END; (* IF Days > 0 ... *)
  RETURN _Debt;
 END {SingleDeduct};

 PRIVATE PROCEDURE UsrDeduct(sm: SCAL[2]; FirstQueue: SCAL[2]; P: DATE);
 BEGIN
  Prompt("稥 㤥ঠ");
  SELECT(Deduct, TSN, , Staff.TSN);
  WHILE OCCURE(Deduct) DO
   CONFORM(Deduct, DedType);
   IF FirstQueue = DedType.BfSysDed THEN
    PutMoney(sm, Deduct.MCode, SingleDeduct(P, sm), L_XObj.GetXObjectBy_fi_ri(Deduct.fiCO, Deduct.riCO));
   END;
   NEXT(Deduct);
  END; (* WHILE OCCURE(Deduct) ... *)
 END {UsrDeduct};

 PRIVATE PROCEDURE PCalcMod();
  VAR
   _Saldo : LIKE(PCalc.Saldo);
 BEGIN
  L_PRoll.FixPCalc(Memo.gl_mb());
  PCalc.Incr   :=Pos;
  PCalc.Decr   :=Neg;
  PCalc.FutInc :=_FutInc;
  REPLACE(PCalc);
  L_PRoll.SetFinalDone();
  _Saldo:=L_PRoll.BalPCalc();
  LAST(PCalc);
  IF PCalc.Period = Memo.gl_mb() THEN
   DEFAULT(PCalc);
   PCalc.Period:=L_DatTim.NextPer(Memo.gl_mb());
   PCalc.Saldo :=_Saldo;
   INSERT(PCalc);
  END;
 END {PCalcMod};

 PRIVATE PROCEDURE GetFutInc(): NUMERIC[2];
  VAR
   P: DATE;
   _FutTake: NUMERIC[2];
 BEGIN
  P:=Memo.gl_mb(); SETZERO(_FutTake);
  LOOP
   P:=L_DatTim.NextPer(P);
   SETSEL(Money, TSN, Staff.TSN);
   IF ~SRCINSEL(Money, GE, P) THEN
    EXIT;
   END;
   P:=Money.Closed;
   GetFutBases(P);
   IF Pos # 0 THEN
    L_PRoll.FixPCalc(P);
    UsrDeduct(0, 1, P);
    UsrDeduct(0, 0, P);
    IF Pos>Neg THEN
     INC(_FutTake, Pos-Neg);
    END;
   END; (* IF Pos ... *)
  END; (* LOOP *)
  RETURN _FutTake;
 END {GetFutInc};

 PRIVATE PROCEDURE E_NeedCheckMathRest(D: DATE; trgMathKind: LIKE(Math.MathKind)): SCAL[2];
  VAR
   Need : SCAL[2];
   Local: PROC;
 BEGIN
  IF    trgMathKind = L_MathR.mathk_Math THEN
   Need:=1;
  ELSIF trgMathKind = L_MathR.mathk_KeyAs THEN
   Need:=(L_Env.KeyAssAcntLev(D) # L_MathR.kaal_NoKeyAssets) & ~L_MathR.E_NotFullActiveKeyAssSystem(D);
  ELSE
   L_General.CallUs(0);
  END;
  IF Need THEN
   Local:=PROCREF(E_PRoll.NeedCheckMathRest);
   IF ~!Local THEN
    RETURN Local(D, trgMathKind);
   END;
  END;
  RETURN Need;
 END {E_NeedCheckMathRest};

 PRIVATE PROCEDURE CheckInUse();
 BEGIN
  IF ~!Staff.Storage &
     E_NeedCheckMathRest(Memo.gl_mb(), L_MathR.mathk_Math) &
     L_Staff.IsLeaveFinally(Memo.gl_mb()) THEN
   D_XObj.SMC01_Prepare(D_XObj.XCC_SingleTSN, 1);
   SELECT(SMC01, TSN, , Staff.TSN);
   WHILE OCCURE(SMC01) & ((SMC01.SldQnt + SMC01.DbtQnt - SMC01.CrdQnt) = 0) DO
    NEXT(SMC01);
   END; (* WHILE OCCURE(SMC01) ... *)
   L_General.Assert_wReferToAdmin(~OCCURE(SMC01),
                                  " " + Staff.TSN +
                                  "|㢮騩 ࠡ⭨  業  ");
   CONFORM(Staff, Storage);
   IF    !Storage.Till & ~OCCURE(SMC01) THEN
    L_SysLog.SingleMark_Init("Storage");
    Storage.Till:=L_DatTim.NextPer(Memo.gl_mb());
    L_Stock.Replace_Storage();
    L_SysLog.SingleMark_Done("Storage");
   ELSIF ~!Storage.Till & OCCURE(SMC01) THEN
    L_SysLog.SingleMark_Init("Storage");
    SETEMPTY(Storage.Till);
    L_Stock.Replace_Storage();
    L_SysLog.SingleMark_Done("Storage");
   END;
   D_XObj.SMC01_Purge();
  END;
 END {CheckInUse};

 PRIVATE PROCEDURE CheckKeyAss();
 BEGIN
  IF E_NeedCheckMathRest(Memo.gl_mb(), L_MathR.mathk_KeyAs) & L_Staff.IsLeaveFinally(Memo.gl_mb()) THEN
   L_MathR.StfKA_Prepare(Staff.TSN, MAXOF(DATE));
   L_General.Assert_wReferToAdmin(~SELECT(StfKA, StfKA),
                                  " " + Staff.TSN +
                                  "|騩 ࠡ⭨  ९ ");
   L_MathR.StfKA_Purge();
  END;
 END {CheckKeyAss};

 PRIVATE PROCEDURE E_CheckTime(D: DATE; _PCalcTim, _MonTim: NUMERIC[3]);
  VAR
   Local  : PROC;
   Default: SCAL[2];
 BEGIN
  IF ~L_General.KioskExecution_IsRunning() THEN
   Default:=Math.Abs(_PCalcTim - _MonTim) > 0.05 * _MonTim;
   Local:=PROCREF(E_PRoll.HasTimeMismatch);
   IF ~!Local THEN
    Default:=Local(D, _PCalcTim, _MonTim, Default);
   END;
   IF Default THEN
    L_StdFrm.Choice("ᮮ⢥⢨  ⠡   ⮬");
   END;
  END; (* IF ~L_General.KioskExecution_IsRunning() *)
 END {E_CheckTime};

 PRIVATE PROCEDURE IsLastOfAnyMainContract(): SCAL[2];
  VAR
   lastTSN: LIKE(Staff.TSN);
 BEGIN
  SAVE(Staff);
  L_Staff.StandOnAnyMainContract(Staff.Man, MAXOF(DATE));
  lastTSN:=Staff.TSN;
  RESTORE(Staff);
  RETURN (Staff.TSN = lastTSN);
 END {IsLastOfAnyMainContract};

 PRIVATE PROCEDURE intCheckXCalc();
  VAR
   curSaldo: L_XObj.tSum;
   mfMsg   : STRING[];
 BEGIN
  curSaldo:=L_XObj.mo_GetOutSaldo(AcCut.AcCut, L_DatTim.Per(SYSDATE()));
  IF Staff.MyFirm # XObject.MyFirm THEN
   SAVE(MyFirm);
   CONFORM(XObject, MyFirm);
   mfMsg:="| ' ࣠樨' " + MyFirm.vzSign + " '" + MyFirm.Name + "'";
   RESTORE(MyFirm);
  ELSE
   mfMsg:="";
  END;
  L_General.Assert_wReferToAdmin(curSaldo = 0,
                                 " " + Staff.TSN +
                                 "|騩 ࠡ⭨  襭 "+
                                 "| ࠧ१ "+AcCut.AcCut+" ("+AcCut.Sign+") '"+AcCut.Name+"'"+
                                 mfMsg+
                                 "|(ᠫ줮 "+FLDTOSTR(curSaldo, "2-")+")");
 END {intCheckXCalc};

 PRIVATE PROCEDURE CheckXCalc();
  VAR
   curAcCut: LIKE(AcCut.AcCut);
 BEGIN
  IF L_Staff.IsLeaveFinally(Memo.gl_mb()) & L_Staff.IsMainForTax(MAXOF(DATE)) THEN
   IF IsLastOfAnyMainContract() THEN
    SETSEL(mfMan, Man, Staff.Man);
    FOR_EACH mfMan DO
     SEARCH(XObject, XObject, , mfMan.XObject);
     curAcCut:=L_kn.GetSoft(Memo.gl_me(), L_AcCut.erkn_AccountableMan);
     IF ~!curAcCut THEN
      SEARCH(AcCut, AcCut, , curAcCut);
      intCheckXCalc();
     END;
    END; (* FOR_EACH mfMan *)
   END;
   L_XObj.AccessManXObject(Staff.Man, Staff.MyFirm);
   FOR_EACH curAcCut IN L_XObj.GetXObjectAcCutCollection(XObject.XObject) DO
    SEARCH(AcCut, AcCut, , curAcCut);
    IF ~L_kn.Is(Memo.gl_me(), L_AcCut.erkn_AccountableMan) &
       ~L_kn.Is(Memo.gl_me(), L_AcCut.erkn_Salary)         &
       ~L_kn.Is(Memo.gl_me(), L_AcCut.erkn_Salary_CA)      &
       ~L_kn.Is(Memo.gl_me(), L_AcCut.erkn_SalaryDeposit)  &
       ~L_kn.Is(Memo.gl_me(), L_AcCut.erkn_LeavedManDebts) THEN
     intCheckXCalc();
    END;
   END;
  END;
 END {CheckXCalc};

 PRIVATE PROCEDURE HasFutureMonthMoney(): SCAL[2];
 BEGIN
  SETSEL(Money, TSN, Staff.TSN);
  SRCINSEL(Money, GT, , Memo.gl_mb());
  WHILE OCCURE(Money) DO
   IF (Money.WFPeriod = Memo.gl_mb()) & (Money.Sum # 0) THEN
    RETURN 1;
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
  RETURN 0;
 END {HasFutureMonthMoney};

 PRIVATE PROCEDURE CheckFutureMonthMoney();
  CONST
   Msg = "᫥   ⠫ ஢   ਮ|室 믮 ";
 BEGIN
  IF L_PRoll.Salary_Clc_CntIsEqual() THEN
   IF HasFutureMonthMoney() THEN
    IF (Money.Source = L_PRoll.src_FtSht) |
       (Money.Source = L_PRoll.src_FtSys) THEN
     RETURN;
    ELSIF    Money.Source = L_PRoll.src_Operator THEN
     L_General.CallUs(0);
    ELSIF (Money.Source = L_PRoll.src_System)   |
          (Money.Source = L_PRoll.src_Sheet)    |
          (Money.Source = L_PRoll.src_SheetDec) |
          (Money.Source = L_PRoll.src_OrderP)   |
          (Money.Source = L_PRoll.src_OrderS)   |
          (Money.Source = L_PRoll.src_XCalc) THEN
     L_General.Error(Msg+" ௫ ࠡ⭨ "+Staff.TSN+"  ⠡  "+L_DatTim.PeriodStr(Memo.gl_mb()));
    ELSIF Money.Source = L_PRoll.src_AvePay THEN
     L_General.Error(Msg+" ௫ ࠡ⭨ "+Staff.TSN+"  㬥⠬  "+L_DatTim.PeriodStr(Memo.gl_mb()));
    ELSIF Money.Source = L_PRoll.src_RWayS THEN
     L_General.Error(Msg+"   "+L_DatTim.PeriodStr(Memo.gl_mb()));
    ELSIF Money.Source = L_PRoll.src_KTU THEN
     L_General.Error(Msg+"   ਣ   "+L_DatTim.PeriodStr(Memo.gl_mb()));
    ELSIF Money.Source = L_PRoll.src_PDoc THEN
     L_General.Error(Msg+" ⥦ 㬥⮢  "+L_DatTim.PeriodStr(Memo.gl_mb()));
    ELSE
     L_General.CallUs(0);
    END;
   END;
  END;
 END {CheckFutureMonthMoney};

 PRIVATE PROCEDURE SimpleProceedRule();
 BEGIN
  ^MoneyRul.Rule();
 END {SimpleProceedRule};

 PRIVATE PROCEDURE int_(limPrc: NUMERIC[2]);
  VAR
   limSum,
   trgSum     : L_XObj.tSum;
   trgApport  : LIKE(Apport.Apport);
   trgAcCut   : LIKE(MoneyDst.AcCut);
 BEGIN
  IF L_Staff.IsMainForTax(L_DatTim.MonthEnd(Memo.gl_mb())) THEN
   CONFORM(MoneyRul, MCList);
   trgAcCut:=L_PRoll.GetMCListAcCut(MCList.MCode, Memo.gl_mb());
   L_XObj.AccessManXObject(Staff.Man, Staff.MyFirm);
   trgSum:=L_XObj.mo_GetOutSaldo(trgAcCut, Memo.gl_mb());
   IF trgSum # 0 THEN
    IF ~!limPrc THEN
     SAVE(MCList);
     limSum:=0;
     SELECT(Money, TSN, , Staff.TSN, Memo.gl_mb());
     WHILE OCCURE(Money) DO
      CONFORM(Money, MCList);
      IF (MCList.MCTyp = L_PRoll.mct_Credit) & MCList.ForDed[0] & (Money.Source # L_PRoll.src_FtSys) THEN
       INC(limSum, Money.Sum);
      END;
      NEXT(Money);
     END; (* WHILE OCCURE(Money) ... *)
     RESTORE(MCList);
     trgSum:=Math.Min(limSum*limPrc, trgSum);
    END;
    IF trgSum # 0 THEN
     L_PRoll.detailedSaveMoney_AP(+1, 0, Memo.gl_mb(), MCList.MCode, Memo.gl_mb(), StaffLog.Date, L_PRoll.src_XCalc,
                                  EMPTYOF(L_XDoc.tXDocId), XObject.XObject, trgAcCut,
                                  trgSum, 0);
     IF Memo.gl_mb() < L_PRoll.E_DoSecondSide() THEN
      IF MCList.MCTyp = L_PRoll.mct_Credit THEN
       trgApport:=L_Acnt.E_Apport_MoneyDebit(Money.Closed);
      ELSE
       trgApport:=L_Acnt.E_Apport_MoneyCredit(Money.Closed);
      END;
      L_XObj.mo_MakeCir(+1,
                        trgAcCut,
                        Money.Closed,
                        trgApport,
                        L_PRoll.GetSalaryAcCut(Money.Closed),
                        trgSum,
                        L_XObj.src_Salary);
     END; (* IF Memo.gl_mb < E_DoSecondSide() *)
    END; (* IF trgSum # 0 *)
   END; (* IF trgSum # 0 *)
  END; (* IF L_Staff.IsMainForTax *)
 END {int_};

 PUBLIC PROCEDURE _();
 BEGIN
  int_(EMPTYOF(NUMERIC[2]));
 END {_};

 PUBLIC PROCEDURE _20();
 BEGIN
  int_(0.20);
 END {_20};

 PUBLIC PROCEDURE DedF();
 BEGIN
  Prompt("砫");
  CheckInUse();
  CheckKeyAss();
  L_APtm.MonthAccess(Memo.gl_mb());
  IF SEARCH(MthType, MthType, L_PRoll.mthtyp_BeforeDedF) THEN
   L_PRoll.ExecMethod(Memo.gl_mb(), L_PRoll.GetMethod(Memo.gl_mb(), L_PRoll.mthtyp_BeforeDedF),
                      PROCREF(SimpleProceedRule), EMPTYOF(PROC));
  END;
  ConvertSomeMoney();
  ExcludeFuture();
  L_PRoll.FixPCalc(Memo.gl_mb());
  L_STx.STx_StaffProceedInit(Memo.gl_mb());
  SumForDeduction();
  IF (Memo.gl_me() < SYSDATE()) THEN
   E_CheckTime(Memo.gl_mb(), PCalc.TimDone, _TimDone);
  END;
  TruncSaldo();
  UsrDeduct(1, 1, Memo.gl_mb());
  L_STx.STx_StaffProceedDone();
  SysDeduct(1, Memo.gl_mb());
  _DedBase:=DedBase;
  _DedTime:=DedTime;
  _Pos:=Pos;
  _Neg:=Neg;
  UsrDeduct(0, 0, Memo.gl_mb());
  _FutInc:=L_General.UnDenominate(L_DatTim.NextPer(Memo.gl_mb()), Memo.gl_mb(), GetFutInc());
  L_PRoll.FixPCalc(Memo.gl_mb());
  DedBase:=_DedBase;
  DedTime:=_DedTime;
  Pos:=_Pos;
  Neg:=_Neg;
  UsrDeduct(1, 0, Memo.gl_mb());
  CheckFutureMonthMoney();
  CheckXCalc();
  PCalcMod();
  L_PRoll.Make70Cir(Staff.TSN);
 END {DedF};

 PUBLIC PROCEDURE DedF_BeforeClcPer();
 BEGIN
  L_PRoll.FixPCalc(Memo.gl_mb());
  L_PRoll.SetFinalDone();
  REPLACE(PCalc);
 END {DedF_BeforeClcPer};

END.
