(*
%Copyright   (c) Polak Computer System  
%Author      30.11.1993 17:51:24 MOG                        
%Purpose     ஫ 䨪樨 Deduct
%Type        control
%Specific    SYS
%Modified    04.09.2014 13:18:52 POLAK\Gina
*)

 MODULE Deduct [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_DatTim, L_General, L_PRoll, L_PDoc, L_Staff, L_PayP, L_Str,
        L_APtm, L_Events, Str, Math, P_Firm, Memo, L_Env, E_PRoll, L_StdFrm, L_kn;

 CONST
  StandartPCode     = "40817810";
  StandartPCodeList = "423??810*|426??810*|40817810*|40820810*";

 PRIVATE PROCEDURE _CheckBegDate(Strong: SCAL[2]);
 BEGIN
  Memo.gl_SetCurDate(Math.Max(Deduct.BegDate, L_Env.aptm_Start));
  IF Strong THEN
   IF Deduct.BegDate < L_Env.aptm_Start THEN
    L_StdFrm.Choice("ঠ   砫 ᯫ樨 ⮏");
   END;
   L_APtm.ANYSystem_CheckClcPer(L_APtm.system_Salary);
  END;
 END {_CheckBegDate};

 PUBLIC PROCEDURE GetStaffName();
 BEGIN
  IF OCCURE(Deduct) THEN
   CONFORM(Deduct, Staff, Man);
   Deduct.Person:=Man.Name;
   REPLACE(Deduct);
  END;
 END {GetStaffName};

 PRIVATE PROCEDURE E_CheckDeduct();
 BEGIN
  IF ~!PROCREF(E_PRoll.CheckDeduct) THEN
   E_PRoll.CheckDeduct(Deduct.BegDate);
  END;
 END {E_CheckDeduct};

 PRIVATE PROCEDURE CheckPCode(trgPCode: LIKE(Deduct.PCode));
  VAR
   _Ptrn: STRING[];
   i    : NUMERIC[0];
   D    : DATE;
 BEGIN
  IF ~!trgPCode THEN
   i:=0;
   LOOP
    _Ptrn:=L_Str.PoolItem(StandartPCodeList, i);
    IF !_Ptrn THEN
     IF Deduct.DedType = L_PDoc.SPC_DEDTYPE THEN
      L_StdFrm.Choice("/c  㤮⢮ 蠡");
     END;
     EXIT;
    ELSIF Str.Match(trgPCode, _Ptrn) THEN
     D:=Math.Max(L_DatTim.Per(Deduct.BegDate), L_Env.aptm_Start);
     SEARCH(FirmAcnt, FirmAcnt, , Deduct.Firm, L_PDoc.GetFirmAcnt(D, Deduct.Firm, Deduct.FirmAcnt));
     P_Firm.CheckDigitBankAccount(D, trgPCode, "⭨ "+Deduct.TSN+", 㤥ঠ  "+Deduct.DedNbr+",  "+trgPCode);
     EXIT;
    END;
    INC(i);
   END; (* LOOP *)
  END;
 END {CheckPCode};

 PRIVATE PROCEDURE CheckPayPAttr(Bit: SCAL[250]; Value, Descr, FullValue: STRING[]);
  VAR
   MaxLen,
   Index : NUMERIC[0];
 BEGIN
  L_General.Assert(~INBITSET(PayP.AttrMap, Bit) | ~!Value,
                   " 祭 ⥦ " + PayP.PayP + " " + PayP.Name +
                   '|     "' + Descr + '"');
  IF ~!FullValue THEN
   Index:=0;
   WHILE Index<L_PayP.MaxAttrAmnt DO
    IF PayP.LstAttr[Index] = Bit THEN
     MaxLen:=L_PayP.GetObjLen(Bit, Index);
     IF Str.Length(FullValue) > MaxLen THEN
      L_StdFrm.Choice('  "'+Descr+'" '+L_Str.IntStr(Str.Length(FullValue))+' ॢ蠥 '+L_Str.IntStr(MaxLen)+',|㪠  祭 ⥦');
     END;
    END;
    INC(Index);
   END; (* WHILE (Index < ... *)
  END;
 END {CheckPayPAttr};

 PRIVATE PROCEDURE MustHaveDedAcnt(BegDate: DATE);
 BEGIN
  L_General.Assert(OCCURE(DedAcnt) & (DedAcnt.Period <= BegDate),
                   "室 ନ    "+L_DatTim.PeriodStr(BegDate));
 END {MustHaveDedAcnt};

 PRIVATE PROCEDURE AfterModificationEvent();
  VAR
   trg_iri: L_General.tInternalRecordId;
 BEGIN
  CheckPCode(Deduct.PCode);
  CONFORM(Deduct, MCList);
  L_General.Assert(MCList.MCTyp = L_PRoll.mct_Debit,
                   "ঠ  ଫ ⮫쪮   㤥ঠ");
  L_General.Assert(L_DatTim.InPatIntvl(MCList.Begin, MCList.Till, Deduct.BegDate, Deduct.EndDate),
                   " " + MCList.MCode + "    ਮ ⢨ 㤥ঠ");
  L_General.Assert(~!Deduct.PAddr[0] | !Deduct.PAddr[1], " 室   ࢮ ப");
  CONFORM(Deduct, Staff, DedAcnt, PayP, Firm);
  IF Deduct.DedType # L_PDoc.SPC_DEDTYPE THEN
   L_PRoll.CheckMCodeLegality(Deduct.MCode, L_DatTim.Per(Deduct.BegDate));
   L_General.Assert(L_Staff.InStateInPer(L_DatTim.MonthBeg(Deduct.BegDate), L_DatTim.MonthEnd(Deduct.BegDate)),
                    "⭨  ⮨    " + L_DatTim.PeriodStr(Deduct.BegDate));
   L_PRoll.DedDone_AP(L_APtm.ANYSystem_ClcPer(L_APtm.system_Salary), 0);
   MustHaveDedAcnt(Math.Max(L_DatTim.Per(Deduct.BegDate), L_Env.aptm_Start));
   L_General.Assert(~L_PDoc.IsSalaryDest(PayP.Dest),
                    ' 㤥ঠ  ⨯ ' + Deduct.DedType + '  ᯮ짮' +
                    '|祭 ⥦,  ஬ 㪠  樨' +
                    '| 祭 "  ࠡ⭮ "');
  ELSE
   L_General.Assert(Deduct.MCode = L_kn.GetSoft(L_DatTim.Per(Deduct.BegDate), L_PRoll.erkn_MCList_PaidByBank),
                    ' 㤥ঠ  ⨯ ' + Deduct.DedType + ' ᫥ ᯮ짮' +
                    '|  祭 "᫥  ᪨ "');
   L_General.Assert(L_PDoc.IsSalaryDest(PayP.Dest),
                    ' 㤥ঠ  ⨯ ' + Deduct.DedType + ' ᫥ ᯮ짮' +
                    '|祭 ⥦,  ஬ 㪠  樨' +
                    '| 祭 "  ࠡ⭮ "');
   L_General.Assert(Deduct.PayP # L_PDoc.EOR_PAYP, " ⨯ 㤥ঠ "+Deduct.DedType+" 㦭 㪠뢠|" +
                    "祭 ⥦ 㣮, 祬 10 (௫ १ )");
  END;
  L_General.Assert(~P_Firm.IsOwnFirm(Deduct.Firm) | ((Deduct.PayP = 00) | L_PDoc.IsDeductPayP(Deduct.PayP)),
                   " ࠣ " + Deduct.Firm + " " + Firm.Name +
                   "|ࠧ襭 ᯮ짮 ⮫쪮 祭 ⥦ 00  50");
  L_General.Assert(P_Firm.IsOwnFirm(Deduct.Firm) | ((Deduct.PayP # 00) & ~L_PDoc.IsDeductPayP(Deduct.PayP)),
                   "祭 ⥦ " + Deduct.PayP + " " + PayP.Name +
                   "|ࠧ襭 ᯮ짮 ⮫쪮  '' ࣠権");

  CheckPayPAttr(L_PayP.a_Name,      Deduct.Person,   "", Deduct.Person);
  CheckPayPAttr(L_PayP.a_Account,   Deduct.PCode,    "/",     Deduct.PCode);
  CheckPayPAttr(L_PayP.a_Address,   Deduct.PAddr[0], "",   Deduct.PAddr[0]+Deduct.PAddr[1]);
  CheckPayPAttr(L_PayP.a_ShortName, Deduct.Person,   "", Deduct.Person);
  IF !RTI.Get().CurZone.Fields("COOrigin").Value # !RTI.Get().CurZone.Fields("CO").Value THEN
   L_StdFrm.WrongDB("ᠭ ᯮ饣 ꥪ ᫥ ᤥ ,    ");
  END;
  IF    RTI.Get().CurZone.Fields("COOrigin").Value = L_PRoll.m2xo_Contract THEN
   SEARCH(Contract, Contract, , RTI.Get().CurZone.Fields("CO").Value);
   trg_iri:=L_General.iri_GetCurrent("Contract");
  ELSIF RTI.Get().CurZone.Fields("COOrigin").Value = L_PRoll.m2xo_CostItem THEN
   SEARCH(CostItem, CostItem, , RTI.Get().CurZone.Fields("CO").Value);
   trg_iri:=L_General.iri_GetCurrent("CostItem");
  ELSE
   SETEMPTY(trg_iri);
  END;
  IF ~!trg_iri THEN
   CONFORM(Deduct, Staff);
   IF ^(L_DBD.GetTable(L_General.iri_fi(trg_iri)).Fields("MyFirm").ObtainName()) # Staff.MyFirm THEN
    L_StdFrm.WrongDB(" ᯮ饣 ꥪ  ᮮ⢥  ࠡ⭨");
   END;
  END;
  Deduct.fiCO:=L_General.iri_fi(trg_iri);
  Deduct.riCO:=L_General.iri_ri(trg_iri);
  REPLACE(Deduct);
  E_CheckDeduct();
 END {AfterModificationEvent};

 PRIVATE PROCEDURE Deduct_OnAfterInsert();
 BEGIN
  _CheckBegDate(1);
  AfterModificationEvent();
 END {Deduct_OnAfterInsert};

 PRIVATE PROCEDURE SetupCOFields();
  VAR
   curModifiable: SCAL[2];
 BEGIN
  curModifiable:=Math.Min(Deduct.EndDate, SYSDATE()) >= L_PRoll.E_DoSecondSide();
  IF Deduct.DedType = L_PDoc.SPC_DEDTYPE THEN
   curModifiable:=0;
  ELSIF ~!Deduct.MCode THEN
   P_MCList.StandOnDstMode(Deduct.MCode, Math.Min(Deduct.EndDate, SYSDATE()));
   IF (DstMode.MnMth = L_PRoll.dmmm_byContract) | (DstMode.MnMth = L_PRoll.dmmm_byManXCalc) THEN
    curModifiable:=0;
   END;
  END;
  RTI.Get().CurZone.Fields("COOrigin").Modifiable:=curModifiable;
  RTI.Get().CurZone.Fields("CO"      ).Modifiable:=curModifiable;
  RTI.Get().CurZone.Fields("COName"  ).Visible   :=curModifiable;
  IF curModifiable THEN
   IF    RTI.Get().CurZone.Fields("COOrigin").Value = L_PRoll.m2xo_Contract THEN
    L_WDO.CreateFormLink_Simple("Contract", "CO");
   ELSIF RTI.Get().CurZone.Fields("COOrigin").Value = L_PRoll.m2xo_CostItem THEN
    L_WDO.CreateFormLink_Simple("CostItem", "CO");
   END;
  ELSE
   SETEMPTY(RTI.Get().CurZone.Fields("COOrigin").Value, RTI.Get().CurZone.Fields("CO").Value);
  END;
 END {SetupCOFields};

 PRIVATE PROCEDURE Deduct_DedType_OnSuccessfulChange();
 BEGIN
  IF Deduct.DedType = L_PDoc.SPC_DEDTYPE THEN
   Deduct.PCode:=StandartPCode;
  ELSE
   SETEMPTY(Deduct.PCode);
  END;
  REPLACE(Deduct);
  SetupCOFields();
 END {Deduct_DedType_OnSuccessfulChange};

 PRIVATE PROCEDURE Deduct_OnAfterEdit();
 BEGIN
  _CheckBegDate(0);
  AfterModificationEvent();
 END {Deduct_OnAfterEdit};

 PRIVATE PROCEDURE Deduct_OnBeforeDelete();
 BEGIN
  CONFORM(Deduct, Staff, DedAcnt);
  _CheckBegDate(1);
  WHILE OCCURE(DedAcnt) DO
   L_PRoll.Salary_CheckNoTouch(DedAcnt.Period);
   L_PRoll.DedDone_AP(DedAcnt.Period, 0);
   NEXT(DedAcnt);
  END; (* WHILE OCCURE(DedAcnt) ... *)
  IF Deduct.DedType # L_PDoc.SPC_DEDTYPE THEN
   L_PRoll.DedDone_AP(L_APtm.ANYSystem_ClcPer(L_APtm.system_Salary), 0);
  END;
 END {Deduct_OnBeforeDelete};

 PRIVATE PROCEDURE DedE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "Deduct.DedNbr").First:=1;
  L_WDO.iField       (0, "Deduct.DedNbr").First:=1;
  L_WDO.iField       (0, "Deduct.FirmAcnt").OwnerWindowOriginalName:="XFA";
  L_WDO.iScsChange   (0, ["Deduct.DedType", "Deduct.MCode", "COOrigin"]);
  L_WDO.iUnmodifiable(0, ["Deduct.TSN"]);
  L_WDO.iMayBeEmpty  (0, ["Deduct.PAddr[0]", "Deduct.Person", "Deduct.PCode", "Deduct.EndDate", "Deduct.CorDedNb",
                          "Deduct.CorDedNb", "Deduct.PAddr[1]", "Deduct.FirmAcnt",
                          "COOrigin", "CO"]);
  L_WDO.iField       (0, "DedType.BaseNo").Format:="㬬|%|%|%|%|%|%|%|% |%| | | | | | ";
  L_WDO.iField       (0, "COOrigin").Format:=L_PRoll.m2xo_Pool;
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  L_WDO.iField       (1, "DedAcnt.Corr").Last:=1;
  L_WDO.iUnmodifiable(1, ["DedAcnt.NetDebt", "DedAcnt.TotDebt", "DedAcnt.Saldo", "DedAcnt.Period"]);
 END {DedE_OnInitializeWindow};

 PRIVATE PROCEDURE DedE_0_OnReposition();
 BEGIN
  IF ~!Deduct.fiCO THEN
   L_DBD.StandOnRecord(L_General.iri_Pack(Deduct.fiCO, Deduct.riCO));
   CONFORM((L_DBD.GetTable(Deduct.fiCO).Name), XObject);
   IF    XObject.Origin = L_XObj.o_Contract THEN
    RTI.Get().CurZone.Fields("COOrigin").Value:=L_PRoll.m2xo_Contract;
    RTI.Get().CurZone.Fields("CO"      ).Value:=Contract.Contract;
   ELSIF XObject.Origin = L_XObj.o_CostItem THEN
    RTI.Get().CurZone.Fields("COOrigin").Value:=L_PRoll.m2xo_CostItem;
    RTI.Get().CurZone.Fields("CO"      ).Value:=CostItem.CostItem;
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   SETEMPTY(RTI.Get().CurZone.Fields("COOrigin").Value, RTI.Get().CurZone.Fields("CO").Value);
  END;
  SetupCOFields();
 END {DedE_0_OnReposition};

 PRIVATE PROCEDURE Deduct_COOrigin_OnSuccessfulChange();
 BEGIN
  SETEMPTY(RTI.Get().CurZone.Fields("CO").Value);
  SetupCOFields();
 END {Deduct_COOrigin_OnSuccessfulChange};

 PRIVATE PROCEDURE Deduct_MCode_OnSuccessfulChange();
 BEGIN
  SetupCOFields();
 END {Deduct_MCode_OnSuccessfulChange};

BEGIN
 L_Events.ExecuteHandler();
END.
