(*
%Copyright   (c) Polak IT
%Author      13.04.2009 11:11:54 POLAK\San
%Purpose     ஫ 䨪樨 Dfrls
%Type        control
%Specific    SYS
%Modified    11.03.2014 20:41:49 Bor
%Environment
*)

 MODULE Dfrls [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, L_MDoc, L_XObj, L_DatTim, L_StdFrm, L_XDoc, L_lsStore, L_WDO, L_CI, L_DBD;

 TYPE
  tDfrlsWriteOfMethod = SCAL[3];

 CONST
  dwom_byDays   = 0;
  dwom_byMonths = 1;
  dwom_Special  = 2;

 PRIVATE PROCEDURE DfrlsE_OnConformToWindow();
 BEGIN
  IF RTI.Get().TrgWindow.Zones(0).Processes(0).Kind = FORM_PROCESS.Kind_Insert THEN
   L_General.Error("⠢    饭");
  END;
  GE_WZD_CURSOR(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number, DfrlsL);
  SELECT(Dfrls, Dfrls, , DfrlsL.Dfrls);
  SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, Dfrls);
 END {DfrlsE_OnConformToWindow};

 PRIVATE PROCEDURE ResetDone(P: DATE);
 BEGIN
  CONFORM(Dfrls, CostItem);
  L_XObj.AccessXObjectByOrigin(L_XObj.o_CostItem);
  REPEAT
   L_XObj.XODone_Set(P, 0, 1);
   P:=L_DatTim.IncMonth(P, +1);
  UNTIL P > Dfrls.EndDate;
 END {ResetDone};

 PRIVATE PROCEDURE Dfrls_OnReposition();
 BEGIN
  L_WDO.setFieldValue("wv_Comment", L_lsStore.Get(Dfrls.Comment));
 END {Dfrls_OnReposition};

 PRIVATE PROCEDURE CheckDfrlsPeriod();
 BEGIN
  L_General.Assert(~!Dfrls.BegDate, " 㪠  砫 ਮ ᯨᠭ");
  L_General.Assert(~!Dfrls.EndDate, " 㪠  砭 ਮ ᯨᠭ");
  L_General.Assert(Dfrls.BegDate < Dfrls.EndDate, "४ ਮ ᯨᠭ");
 END {CheckDfrlsPeriod};

 PRIVATE PROCEDURE intFillDfrlsLD(CheckOnly: SCAL[2]);
  CONST
  VAR
   tSum,
   pSum      : L_XObj.tSum;
   P         : DATE;
   ErrMsg    : STRING[];
 BEGIN
  CheckDfrlsPeriod();
  IF DfrlsL.AutoClc & ~!DfrlsL.Sum THEN
   ErrMsg:=" "+DfrlsL.CostItem+ ": '冷 ᯨᠭ'  ᮮ⢥ ४⠬ ࠢ" +
           L_StdFrm.HR() + "室 믮 ।";
   L_General.Assert(~!Dfrls.WOMthd, " 㪠 ᯮᮡ ᯨᠭ");
   L_General.Assert(Dfrls.WOMthd # dwom_Special, "'樠 冷' ।  ࠢ  ( "+DfrlsL.CostItem+")");
   tSum:=DfrlsL.Sum;
   P:=L_DatTim.MonthBeg(Dfrls.BegDate);
   SETSEL(DfrlsLD, Dfrls, DfrlsL.Dfrls, DfrlsL.DfrlsL);
   IF ~CheckOnly THEN
    REMSEL(DfrlsLD);
   ELSE
    L_General.Assert(FIRST(DfrlsLD) & (DfrlsLD.Prd=P), ErrMsg);
   END;
   IF Dfrls.WOMthd = dwom_byMonths THEN
    pSum:=DfrlsL.Sum / L_DatTim.MonthsInIntvl(L_DatTim.MonthBeg(Dfrls.BegDate), L_DatTim.MonthEnd(Dfrls.EndDate));
   END;
   WHILE L_DatTim.IsActive(P, L_DatTim.MonthBeg(Dfrls.BegDate), L_DatTim.MonthEnd(Dfrls.EndDate)) DO
    IF L_DatTim.IsActive(L_DatTim.NextPer(P), L_DatTim.MonthBeg(Dfrls.BegDate), L_DatTim.MonthEnd(Dfrls.EndDate)) THEN
     IF    Dfrls.WOMthd = dwom_byDays THEN
      pSum:=DfrlsL.Sum * (L_DatTim.DATEINT(P, L_DatTim.MonthEnd(P), Dfrls.BegDate, Dfrls.EndDate)/(Dfrls.EndDate-Dfrls.BegDate+1));
     END;
    ELSE
     pSum:=tSum;
    END;
    IF ~CheckOnly THEN
     IF ~LAST(DfrlsLD) | (pSum # DfrlsLD.Sum) THEN
      DfrlsLD.Dfrls  :=DfrlsL.Dfrls;
      DfrlsLD.DfrlsL :=DfrlsL.DfrlsL;
      DfrlsLD.Prd    :=P;
      DfrlsLD.Sum    :=pSum;
      INSERT(DfrlsLD);
     END;
    ELSE
     IF pSum # DfrlsLD.Sum THEN
      L_General.Assert(NEXT(DfrlsLD) & (DfrlsLD.Prd=P) & (DfrlsLD.Sum=pSum), ErrMsg);
     END;
    END;
    DEC(tSum, pSum);
    P:=L_DatTim.IncMonth(P, +1);
   END; (* WHILE IsActive ... *)
   IF CheckOnly THEN
    L_General.Assert(~NEXT(DfrlsLD), ErrMsg);
   END;
   L_General.CallUs(tSum = 0);
  END;
 END {intFillDfrlsLD};

 PRIVATE PROCEDURE FillDfrlsLD();
 BEGIN
  intFillDfrlsLD(0);
 END {FillDfrlsLD};

 PRIVATE PROCEDURE Dfrls_WOMthd_OnSuccessfulChange();
 BEGIN
  IF Dfrls.WOMthd # dwom_Special THEN
   SELECT(DfrlsL, Dfrls, , Dfrls.Dfrls);
   WHILE OCCURE(DfrlsL) DO
    FillDfrlsLD();
    NEXT(DfrlsL);
   END; (* WHILE OCCURE(DfrlsL) ... *)
  END;
 END {Dfrls_WOMthd_OnSuccessfulChange};

 PRIVATE PROCEDURE Dfrls_OnBeforeInsert();
 BEGIN
  Dfrls.Status:=L_CI.dfst_Passed;
  REPLACE(Dfrls);
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_Dfrls, L_XDoc.EmptyXDocKind, Dfrls.Dfrls, L_XDoc.action_Insert);
 END {Dfrls_OnBeforeInsert};

 PRIVATE PROCEDURE Dfrls_OnBeforeEdit();
 BEGIN
  ResetDone(L_DatTim.Per(Dfrls.BegDate));
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_Dfrls, L_XDoc.EmptyXDocKind, Dfrls.Dfrls, L_XDoc.action_Edit);
 END {Dfrls_OnBeforeEdit};

 PRIVATE PROCEDURE Get_DfrlsL_SumByDfrlsLD(): L_XObj.tSum;
  VAR
   P     : DATE;
   Result: L_XObj.tSum;
 BEGIN
  Result:=0;
  SETSEL(DfrlsLD, Dfrls, DfrlsL.Dfrls, DfrlsL.DfrlsL);
  P:=L_DatTim.MonthBeg(Dfrls.BegDate);
  WHILE L_DatTim.IsActive(P, L_DatTim.MonthBeg(Dfrls.BegDate), L_DatTim.MonthEnd(Dfrls.EndDate)) DO
   IF SRCINSEL(DfrlsLD, LE, P) THEN
    INC(Result, DfrlsLD.Sum);
   END;
   P:=L_DatTim.IncMonth(P, +1);
  END; (* WHILE IsActive ... *)
  RETURN Result;
 END {Get_DfrlsL_SumByDfrlsLD};

 PRIVATE PROCEDURE Check_DfrlsL_Sum();
  VAR
   tSum: L_XObj.tSum;
 BEGIN
  tSum:=Get_DfrlsL_SumByDfrlsLD();
  IF DfrlsL.Sum # tSum THEN
   L_General.Error(" '浪 ᯨᠭ' ᫥  㬬 ( " + DfrlsL.CostItem + "): " +
                   "||" +
                   ": " + FLDTOSTR(DfrlsL.Sum, "2-", 15) +
                   "|" +
                   " : " + FLDTOSTR(      tSum, "2-", 15));
  END;
 END {Check_DfrlsL_Sum};

 PRIVATE PROCEDURE Dfrls_OnAfterEdIns();
  VAR
   CommentAsStr: STRING[];
   _Sum        : LIKE(Dfrls.Sum);
 BEGIN
  CheckDfrlsPeriod();
  L_CI.CheckRequiredCostItem(Dfrls.CostItem, 1, EMPTYOF(L_CI.tCIKType));
  L_DBD.CheckOwnersValidity("Dfrls");

  L_WDO.getFieldValue("wv_Comment", CommentAsStr);
  Dfrls.Comment:=L_lsStore.Replace(Dfrls.Comment, CommentAsStr);
  REPLACE(Dfrls);
  _Sum:=0;
  SELECT(DfrlsL, Dfrls, , Dfrls.Dfrls);
  WHILE OCCURE(DfrlsL) DO
   Check_DfrlsL_Sum();
   intFillDfrlsLD(1);
   INC(_Sum, DfrlsL.Sum);
   NEXT(DfrlsL);
  END; (* WHILE OCCURE(DfrlsL) ... *)
  L_General.Assert(_Sum = Dfrls.Sum, "㬬  ப  ࠢ 㬬 'ᥣ'  ࠢ");
  ResetDone(L_DatTim.Per(Dfrls.BegDate));
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_Dfrls, L_XDoc.EmptyXDocKind, Dfrls.Dfrls);
 END {Dfrls_OnAfterEdIns};

 PRIVATE PROCEDURE Dfrls_OnAfterEdit();
 BEGIN
  Dfrls_OnAfterEdIns();
 END {Dfrls_OnAfterEdit};

 PRIVATE PROCEDURE Dfrls_OnAfterInsert();
 BEGIN
  Dfrls_OnAfterEdIns();
 END {Dfrls_OnAfterInsert};

 PRIVATE PROCEDURE Dfrls_OnBeforeDelete();
 BEGIN
  L_General.Error(" 饭. ᯮ '㫨஢'");
 END {Dfrls_OnBeforeDelete};

 PUBLIC PROCEDURE Dfrls_OnAfterNoninteractiveInsert();
  VAR
   totSum: LIKE(Dfrls.Sum);
 BEGIN
  totSum:=0;
  SELECT(DfrlsL, Dfrls, , Dfrls.Dfrls);
  WHILE OCCURE(DfrlsL) DO
   FillDfrlsLD();
   INC(totSum, DfrlsL.Sum);
   NEXT(DfrlsL);
  END; (* WHILE OCCURE(DfrlsL) ... *)
  L_General.CallUs(totSum = Dfrls.Sum);
  ResetDone(L_DatTim.Per(Dfrls.BegDate));
 END {Dfrls_OnAfterNoninteractiveInsert};

 PRIVATE PROCEDURE DfrlsL_AutoClc_OnSuccessfulChange();
 BEGIN
  FillDfrlsLD();
 END {DfrlsL_AutoClc_OnSuccessfulChange};

 PRIVATE PROCEDURE DfrlsL_OnAfterEdIns();
 BEGIN
  L_CI.CheckRequiredCostItem(DfrlsL.CostItem, 1, L_CI.cikt_Element);
  CONFORM(DfrlsL, Dfrls);
  L_General.Assert(~!DfrlsL.Sum, "   '㬬 ᥣ'");
  IF ~DfrlsL.AutoClc THEN
   Check_DfrlsL_Sum();
  END;
 END {DfrlsL_OnAfterEdIns};

 PRIVATE PROCEDURE DfrlsL_OnAfterInsert();
 BEGIN
  DfrlsL_OnAfterEdIns();
 END {DfrlsL_OnAfterInsert};

 PRIVATE PROCEDURE DfrlsL_OnAfterEdit();
 BEGIN
  DfrlsL_OnAfterEdIns();
 END {DfrlsL_OnAfterEdit};

 PRIVATE PROCEDURE DfrlsLD_OnBeforeAnyModification();
 BEGIN
  CONFORM(DfrlsLD, DfrlsL);
  CONFORM(DfrlsL,  Dfrls);
  IF Dfrls.WOMthd # dwom_Special THEN
   L_General.Assert(~DfrlsL.AutoClc, " ந ⮬᪨");
  ELSE
   L_General.Error("樠 冷  ঠ");
  END;
 END {DfrlsLD_OnBeforeAnyModification};

 PRIVATE PROCEDURE DfrlsLD_OnBeforeInsert();
 BEGIN
  DfrlsLD_OnBeforeAnyModification();
 END {DfrlsLD_OnBeforeInsert};

 PRIVATE PROCEDURE DfrlsLD_OnBeforeEdit();
 BEGIN
  DfrlsLD_OnBeforeAnyModification();
 END {DfrlsLD_OnBeforeEdit};

 PRIVATE PROCEDURE DfrlsLD_OnBeforeDelete();
 BEGIN
  DfrlsLD_OnBeforeAnyModification();
 END {DfrlsLD_OnBeforeDelete};

 PUBLIC PROCEDURE CalculateDfrls();
  VAR
   Cnt : NUMERIC[0];
   tSum,
   pSum: L_XObj.tSum;
   P   : DATE;
 BEGIN
  L_General.CallUs(ACCESS(Dfrls));
  IF !Dfrls.WOMthd | !Dfrls.BegDate | !Dfrls.EndDate | !Dfrls.Sum THEN
   L_General.Error("     ࠢ");
  END;
  IF Dfrls.WOMthd # dwom_Special THEN
   L_StdFrm.Choice("। 㬬 ⮬᪨?  ।饣 ।  㤠");
   Cnt:=0;
   SELECT(DfrlsL, Dfrls, , Dfrls.Dfrls);
   WHILE OCCURE(DfrlsL) DO
    INC(Cnt);
    NEXT(DfrlsL);
   END; (* WHILE OCCURE(DfrlsL) ... *)
   L_General.Assert(Cnt > 0, "    楫 ");
   tSum:=Dfrls.Sum;
   pSum:=tSum / Cnt;
   FIRST(DfrlsL);
   WHILE OCCURE(DfrlsL) DO
    SETEMPTY(DfrlsL.Mul, DfrlsL.Div);
    IF Cnt > 1 THEN
     DfrlsL.Sum:=pSum;
    ELSE
     DfrlsL.Sum:=tSum;
    END;
    REPLACE(DfrlsL);
    DEC(Cnt);
    DEC(tSum, DfrlsL.Sum);
    NEXT(DfrlsL);
   END; (* WHILE OCCURE(DfrlsL) ... *)
   L_General.CallUs(tSum = 0);
   FIRST(DfrlsL);
   WHILE OCCURE(DfrlsL) DO
    FillDfrlsLD();
    NEXT(DfrlsL);
   END; (* WHILE OCCURE(DfrlsL) ... *)
  ELSE
   L_General.Error("'樠 冷' ।  ࠢ ");
  END;
 END {CalculateDfrls};

 PRIVATE PROCEDURE DfrlsL_Sum_OnSuccessfulChange();
 BEGIN
  CONFORM(DfrlsL, Dfrls);
  FillDfrlsLD();
 END {DfrlsL_Sum_OnSuccessfulChange};

 PUBLIC PROCEDURE Calculate_Dfrls_Sum();
 BEGIN
  L_General.CallUs(ACCESS(Dfrls));
  L_StdFrm.Question(" 祭 㬬 'ᥣ'?");
  Dfrls.Sum:=0;
  SELECT(DfrlsL, Dfrls, , Dfrls.Dfrls);
  WHILE OCCURE(DfrlsL) DO
   IF ~!DfrlsL.Sum THEN
    INC(Dfrls.Sum, DfrlsL.Sum);
   ELSE
    L_General.Error("   ப ࠢ");
   END;
   NEXT(DfrlsL);
  END; (* WHILE OCCURE(DfrlsL) ... *)
  REPLACE(Dfrls);
 END {Calculate_Dfrls_Sum};

 PUBLIC PROCEDURE Calculate_DfrlsL_Sum();
 BEGIN
  L_General.CallUs(ACCESS(DfrlsL));
  L_StdFrm.Question(" 祭 㬬 'ᥣ'?");
  DfrlsL.Sum:=Get_DfrlsL_SumByDfrlsLD();
  REPLACE(DfrlsL);
 END {Calculate_DfrlsL_Sum};

BEGIN
 L_Events.ExecuteHandler();
END.