(*
%Copyright   (c) Polak IT
%Author      13.01.2012 21:19:59 POLAK\Bor
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    09.07.2012 17:58:52 POLAK\Bor
%Environment
*)

 MODULE DfrlsInv [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_MathR, L_MSO, L_XObj, L_CI, L_Str, P_Firm, P_MyFirm;

 PRIVATE PROCEDURE PrintInvCommittee(D: DATE; CommTSN: LIKE(Staff.TSN)[]; ChTSN: LIKE(Staff.TSN));
  VAR
   icommIdx: SCAL[L_MathR.icomNum];
   MemberName,
   Prefix_wIdx,
   curPostN,
   curManN : STRING[];
 BEGIN
  FOR_EACH icommIdx DO
   Prefix_wIdx:="Comm"+L_MSO.IndexStr(icommIdx);
   CALL(MS_Inven.extGetPostAndName(D, CommTSN[icommIdx], curPostN, curManN));
   IF (icommIdx > 3) & !curManN THEN
    EXIT;
   ELSIF icommIdx = 0 THEN
    MemberName:="।ᥤ⥫ ᨨ";
   ELSIF icommIdx = 1 THEN
    MemberName:=" ᨨ";
   ELSE
    MemberName:="";
   END;
   L_MSO.wordSetVar(Prefix_wIdx+".MemberName", MemberName);
   L_MSO.wordSetVar(Prefix_wIdx+".Post.Name", curPostN);
   L_MSO.wordSetVar(Prefix_wIdx+".Man.Name",  curManN);
  END;
  L_MSO.SetWordTable("table2", icommIdx);

  CALL(MS_Inven.extGetPostAndName(D, ChTSN, curPostN, curManN));
  L_MSO.wordSetVar("ChTSN.Post.Name", curPostN);
  L_MSO.wordSetVar("ChTSN.Man.Name",  curManN);
 END {PrintInvCommittee};

 PUBLIC PROCEDURE DfrlsInv(trgMyFirm     : P_Firm.tMyFirm;
                           trgInvCommType: L_MathR.tInvCommitteeType;
                           OnPerFact,
                           OnDateRep,
                           curDate       : DATE);
  VAR
   Count     : NUMERIC[0];
   InvFrom,
   InvUpTo   : DATE;
   InvDocName,
   InvDocNum : STRING[];
   InvDocDate: DATE;
   ChTSN     : LIKE(Staff.TSN);
   CommTSN   : LIKE(Staff.TSN)[L_MathR.icomNum];
   curPostN  : STRING[];
   curManN   : STRING[];
   PostName,
   ManName   : STRING[];
   fybDate,
   M         : DATE;
   doneTerm,
   restTerm,
   fullTerm  : NUMERIC[0];
   Monthly,
   FromYearBegSum,
   totFromYearBegSum,
   totSum,
   doneSum,
   restSum,
   totMonthly,
   tot_doneSum,
   tot_restSum: L_XObj.tSum;
   Root,
   Prefix_wIdx,
   TemplateName: STRING[];
   oPrompt: PROMPT_LINE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  P_Firm.curMyFirm:=trgMyFirm;
  oPrompt:=PROMPT_LINE.Create("DfInv");

  L_MSO.wordInitDocument(curDate);
  TemplateName:="DfInv_01";
  Root:="DfInv";

  P_Firm.SetFirmData("Own", P_Firm.fomf(trgMyFirm), curDate, EMPTYOF(FirmAcnt.FirmAcnt), "");
  L_MSO.wordSetVar("OwnFirm.OKVED", P_MyFirm.OKVED_Code(trgMyFirm, curDate));

  L_MathR.GetCommitteeFromSES(trgMyFirm, trgInvCommType, EMPTYOF(Storage.Storage),
                              InvFrom, InvUpTo, InvDocName, InvDocNum, InvDocDate, CommTSN, ChTSN);

  L_MSO.wordSetDateVar(Root + ".InvFrom",     InvFrom);
  L_MSO.wordSetDateVar(Root + ".InvUpTo",     InvUpTo);
  L_MSO.wordSetVar    (Root + ".InvDocName",  InvDocName);
  L_MSO.wordSetVar    (Root + ".InvDocNum",   InvDocNum);
  L_MSO.wordSetDateVar(Root + ".InvDocDate",   InvDocDate);
  L_MSO.wordSetDateVar(Root + ".PrepareDate", curDate);
  L_MSO.wordSetDateVar(Root + ".OnDate",      OnDateRep);

  IF (OnPerFact = L_DatTim.YearBeg(OnPerFact)) & (OnDateRep < OnPerFact) THEN
   fybDate:=(OnPerFact-1);
  ELSE
   fybDate:=OnPerFact;
  END;

  SETZERO(totSum, totMonthly, tot_doneSum, tot_restSum, totFromYearBegSum);
  Count:=0;
  SELECT(Dfrls, Dfrls);
  WHILE OCCURE(Dfrls) DO
   PROMPT(Dfrls.Dfrls);
   IF (Dfrls.Status = L_CI.dfst_Passed) & (L_DatTim.IsActive_Inc(OnPerFact, Dfrls.BegDate+1, Dfrls.EndDate)) THEN
    CONFORM(Dfrls, CostItem);
    IF CostItem.MyFirm = trgMyFirm THEN
     CONFORM(Dfrls, DfrlsL);
     WHILE OCCURE(DfrlsL) DO
      Prefix_wIdx:="DfrlsL"+L_MSO.IndexStr(Count);
      L_MSO.wordSetVar(Prefix_wIdx+".Idx", L_Str.IntStr(Count+1));
      L_MSO.wordSetVarsByFile_wIndex("Dfrls", Count, 0);
      L_MSO.wordSetVarsByFile_wIndex("DfrlsL", Count, 0);
      CONFORM(DfrlsL, CostItem);
      L_MSO.wordSetVarsByFile_wIndexedPrefixE("CostItem", "DfrlsL", Count, 0);

      IF Dfrls.WOMthd = 1 (*dwom_byMonths*) THEN
       fullTerm:=L_DatTim.MonthsInIntvl(L_DatTim.MonthBeg(Dfrls.BegDate), L_DatTim.MonthEnd(Dfrls.EndDate));
      ELSE
       fullTerm:=L_DatTim.MonthsInIntvl(Dfrls.BegDate, Dfrls.EndDate);
      END;
      doneTerm:=L_DatTim.MonthsInIntvl(L_DatTim.MonthBeg(Dfrls.BegDate), OnPerFact-1);
      Monthly:=DfrlsL.Sum/fullTerm;

      FromYearBegSum:=0;
      doneSum:=0;
      SELECT(DfrlsLD, Dfrls, , DfrlsL.Dfrls, DfrlsL.DfrlsL);
      M:=L_DatTim.Per(Dfrls.BegDate);
      WHILE M < OnPerFact DO
       SRCINSEL(DfrlsLD, LE, , M);
       INC(doneSum, DfrlsLD.Sum);
       IF L_DatTim.YEAR(M) = L_DatTim.YEAR(fybDate) THEN
        INC(FromYearBegSum, DfrlsLD.Sum);
       END;
       M:=L_DatTim.NextPer(M);
      END; (* WHILE M ... *)
      restSum:=DfrlsL.Sum-doneSum;
      restTerm:=fullTerm-doneTerm;
      L_MSO.wordSetVar(Prefix_wIdx+".fullTerm", L_Str.IntStr(fullTerm));
      L_MSO.wordSetVar(Prefix_wIdx+".doneTerm", L_Str.IntStr(doneTerm));
      L_MSO.wordSetVar(Prefix_wIdx+".restTerm", L_Str.IntStr(restTerm));
      L_MSO.wordSetMoneyVar(Prefix_wIdx+".Monthly", SYSDATE(), Monthly);
      L_MSO.wordSetMoneyVar(Prefix_wIdx+".doneSum", SYSDATE(), doneSum);
      L_MSO.wordSetMoneyVar(Prefix_wIdx+".restSum", SYSDATE(), restSum);
      L_MSO.wordSetMoneyVar(Prefix_wIdx+".FromYearBeg", SYSDATE(), FromYearBegSum);

      INC(totSum, DfrlsL.Sum);
      INC(tot_doneSum, doneSum);
      INC(tot_restSum, restSum);
      INC(totMonthly, Monthly);
      INC(totFromYearBegSum, FromYearBegSum);
      INC(Count);
      NEXT(DfrlsL);
     END; (* WHILE OCCURE(DfrlsL) ... *)
    END; (* IF CostTitem.MyFirm = trgMyFirm ... *)
   END; (* IF L_DatTim.IsActive_Inc(OnPerFact ... *)
   NEXT(Dfrls);
  END; (* WHILE OCCURE(File) *)
  L_MSO.SetWordTable("table1", Count);

  L_MSO.wordSetMoneyVar(Root+".Monthly", SYSDATE(), totMonthly);
  L_MSO.wordSetMoneyVar(Root+".Sum",     SYSDATE(), totSum);
  L_MSO.wordSetMoneyVar(Root+".doneSum", SYSDATE(), tot_doneSum);
  L_MSO.wordSetMoneyVar(Root+".restSum", SYSDATE(), tot_restSum);
  L_MSO.wordSetMoneyVar(Root+".FromYearBeg", SYSDATE(), totFromYearBegSum);

  PrintInvCommittee(curDate, CommTSN, ChTSN);
  L_MSO.wordSetVar(Root+".OnPerFact", FLDTOSTR(OnPerFact, "YND"));

  L_MSO.MakeWordDocument(TemplateName, 1, L_MSO.PrpMode_ToDoc, "");
 END {DfrlsInv};

END.