(*
%Copyright   (c) Polak IT
%Author      17.12.2003 18:05:55 POLAK\LDA
%Purpose        ਮ
%Type        report
%Specific    SYS
%Modified    05.04.2013 14:21:17 POLAK\GAV
%Environment
*)

 MODULE Dis01 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Basis, L_Staff, L_Man, L_Str,
        L_AFM, P_AveP, Memo, L_AvePay, L_bp, P_Firm, FIO;

 PRIVATE TYPE
  tData = NUMERIC[0][10];

 PRIVATE CONST
  e_Total = 0;
  d_Total = 5;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥫쭮");
  L_Basis.wb_WrInQM(F, "業 ");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⢥⢥");
  L_Basis.wb_WrInQM(F, "  ਮ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE GetAvePLength(): NUMERIC[0];
 BEGIN
  RETURN L_DatTim.DATEINT(_AveP.StartD, _AveP.StopD, Memo.ud_fr(), Memo.ud_ut());
 END {GetAvePLength};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|", Man.Sex));
  L_Basis.wb_WrNum(F, L_DatTim.CompleteYearsInIntvl(Man.Birth, _AveP.StopD), 0);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrScl(F, _AveP.AvePay);
  L_Basis.wb_WrScl(F, _AveP.DocNum);
  L_Basis.wb_WrDat(F, _AveP.StartD);
  L_Basis.wb_WrDat(F, _AveP.StopD);
  L_Basis.wb_WrNum(F, _AveP.Amount, 0);
  L_Basis.wb_WrNum(F, _AveP.Percent, 0);
  L_Basis.wb_WrScl(F, _AveP.Firm);
  L_Basis.wb_WrStr(F, _AveP.Name);
  L_Basis.wb_WrScl(F, _AveP.Disease);
  L_Basis.wb_WrScl(F, _AveP.Sign);
  L_Basis.wb_WrStr(F, _AveP.RespPers);
  L_Basis.wb_WrNum(F, GetAvePLength(), 0);
  L_Basis.wb_WrDat(F, _AveP.Period);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE Create_AveP();
 BEGIN
  CreateFILE(_AveP, "", "쭨 ", "");

  CreateFIELD(_AveP, AvePay,   LIKE(AvePay.AvePay),   "", "", "", "", "");
  CreateFIELD(_AveP, DocNum,   STRING[32],            "", "", "", " 㬥", "");
  CreateFIELD(_AveP, TSN,      LIKE(Staff.TSN),       "", "", "", "", "");
  CreateFIELD(_AveP, StartD,   DATE,                  "", "", "", "", "");
  CreateFIELD(_AveP, StopD,    DATE,                  "", "", "", "", "");
  CreateFIELD(_AveP, Amount,   NUMERIC[0],            "", "", "", "", "");
  CreateFIELD(_AveP, Percent,  LIKE(AvePayP.Percent), "", "", "", "業 ", "");
  CreateFIELD(_AveP, Disease,  LIKE(Disease.Disease), "", "", "", "", "");
  CreateFIELD(_AveP, Sign,     LIKE(Disease.Sign),    "", "", "", "祭 ", "");
  CreateFIELD(_AveP, Firm,     LIKE(Firm.Firm),       "", "", "", "࣠", "");
  CreateFIELD(_AveP, Name,     STRING[128],           "", "", "", " ࣠樨", "");
  CreateFIELD(_AveP, RespPers, STRING[64],            "", "", "", "⢥⢥ ", "");
  CreateFIELD(_AveP, Period,   DATE,                  "", "", "", "", "");

  CreateINDEXandLINK(_AveP, TSN,  UNIQUE, Staff, TSN, USER, "", "", TSN, StopD, Disease, Firm);
  CreateINDEX       (_AveP, Sign, PLURAL,                   "", "", Sign, TSN, StopD);

  SetVersionOfFILE(_AveP, 1);
  L_AFM.CreateTemp("_AveP");
 END {Create_AveP};

 PRIVATE PROCEDURE GetPercent(): LIKE(AvePayP.Percent);
 BEGIN
  IF SELECT(AvePayP, AvePay, AvePay.AvePay) THEN
   RETURN AvePayP.Percent;
  ELSE
   RETURN EMPTYOF(AvePayP.Percent);
  END;
 END {GetPercent};

 PRIVATE PROCEDURE GetDiseaseSign(trgDisease: LIKE(Disease.Disease)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF ~!trgDisease THEN
   SAVE(Disease);
   L_General.Assert(SEARCH(Disease, Disease, trgDisease), "   " + trgDisease);
   Result:=Disease.Sign;
   RESTORE(Disease);
  END;
  RETURN Result;
 END {GetDiseaseSign};

 PRIVATE PROCEDURE GetFirmName(trgFirm: LIKE(Firm.Firm)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF ~!trgFirm THEN
   SAVE(Firm);
   Result:=P_Firm.FP_FirmShortName(trgFirm, SYSDATE());
   RESTORE(Firm);
  END;
  RETURN Result;
 END {GetFirmName};

 PRIVATE PROCEDURE MakeIndex();
  VAR
   _StopD              : DATE;
   curDisease          : LIKE(Disease.Disease);
   curFirm             : LIKE(Firm.Firm);
   curResponsiblePerson,
   curMode             : STRING[];
   curManFmlRID,
   curManFmlRID2       : LIKE(ManFml.RECORDID);
 BEGIN
  SELECT(AvePay, TSN);
  WHILE OCCURE(AvePay) DO
   PROMPT(" " + AvePay.TSN);
   NARROWSEL(AvePay, TSN);
   SRCINSEL(AvePay, GE, , Memo.ud_fr() - 90); (* ⠥  砢訥    㦥 稫 *)
   WHILE OCCURE(AvePay) & (AvePay.StartD <= Memo.ud_ut()) DO
    _StopD:=L_AvePay.GetAvePayStopD();
    IF L_DatTim.IsActiveInIntvl_Inc(AvePay.StartD, _StopD, Memo.ud_fr(), Memo.ud_ut()) &
       L_AvePay.IsRealAvePay() THEN
     IF P_AveP.HasActualPro(AvePay.AvePay, P_AveP.P_SickList) THEN
      P_AveP.sl_DecodeValue(curDisease, curFirm, curResponsiblePerson, curMode, curManFmlRID, curManFmlRID2);
      IF SEARCH(_AveP, TSN, AvePay.TSN,
                            AvePay.StartD - 1,
                            curDisease,
                            curFirm) THEN
       (*   砭     砫 㣮  *)
       (* (    ࣠樨) -    *)
       _AveP.StopD   :=_StopD;
       INC(_AveP.Amount, AvePay.Amount);
       REPLACE(_AveP);
      ELSE
       DEFAULT(_AveP);
       _AveP.AvePay  :=AvePay.AvePay;
       _AveP.DocNum  :=AvePay.DocNum;
       _AveP.TSN     :=AvePay.TSN;
       _AveP.StartD  :=AvePay.StartD;
       _AveP.StopD   :=_StopD;
       _AveP.Amount  :=AvePay.Amount;
       _AveP.Percent :=GetPercent();
       _AveP.Disease :=curDisease;
       _AveP.Sign    :=GetDiseaseSign(curDisease);
       _AveP.Firm    :=curFirm;
       _AveP.Name    :=GetFirmName(curFirm);
       _AveP.RespPers:=curResponsiblePerson;
       _AveP.Period  :=AvePay.Period;
       INSERT(_AveP);
      END;
     ELSE
      CONFORM(AvePay, AveType);
      IF AveType.AveNo = L_AvePay.aveno_Sick THEN
       DEFAULT(_AveP);
       _AveP.AvePay  :=AvePay.AvePay;
       _AveP.DocNum  :=AvePay.DocNum;
       _AveP.TSN     :=AvePay.TSN;
       _AveP.StartD  :=AvePay.StartD;
       _AveP.StopD   :=_StopD;
       _AveP.Amount  :=AvePay.Amount;
       _AveP.Percent :=GetPercent();
       _AveP.Period  :=AvePay.Period;
       INSERT(_AveP);
      END;
     END; (* IF P_AveP.HasActualPro(AvePay.AvePay, P_AveP.P_SickList)...*)
    END;
    NEXT(AvePay);
   END; (* WHILE OCCURE(AvePay) ... *)
   NEXTINEXTENDEDSEL(AvePay, TSN);
  END; (* WHILE OCCURE(AvePay) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE MakeExcel();
 BEGIN
  MakeHeader("R");
  SELECT(_AveP, TSN);
  WHILE OCCURE(_AveP) DO
   PROMPT(" " + _AveP.TSN);
   CONFORM(_AveP, Staff);
   HISTCONF(_AveP.StartD, Staff, StaffLog);
   L_General.Assert(OCCURE(StaffLog), " 뤠 ࠭  ਥ  ࠡ");
   CONFORM(Staff, Man);
   CONFORM(StaffLog, Officer);
   CONFORM(Officer, Sort);
   CONFORM(Officer, Union);
   CONFORM(Officer, Post);
   MakePart("R");
   NEXT(_AveP);
  END; (* WHILE OCCURE(_AveP) ... *)
 END {MakeExcel};

 PUBLIC PROCEDURE Dis01();
  CONST
   bpId = "Dis01";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " ", L_bp.t_Basis, L_General.tc_inIntvl);
  Create_AveP();
  MakeIndex();
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeExcel();
  FIO.Close(R);
  L_AFM.AF_PurgeTemp("_AveP");
  L_bp.End();
 END {Dis01};

END.
