(*
%Copyright   (c) Polak IT
%Author      13.02.2004 14:17:49 POLAK\LDA
%Purpose      樭樨
%Type        report
%Specific    LOC
%Modified    10.04.2012 12:17:45 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_Basis, L_General, FIO, P_Man, L_DatTim, L_Staff, L_Str, Memo, L_Man, L_AFM, L_Russia;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ஦");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " 樭樨");
  L_Basis.wb_WrInQM(F, "樭");
  L_Basis.wb_WrInQM(F, " 樭樨");
  L_Basis.wb_WrInQM(F, " 樭樨");
  L_Basis.wb_WrInQM(F, "ப  樭");
  L_Basis.wb_WrInQM(F, "⏮᫂樭樨");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F                  : STRING[];
                    Kind               : STRING[];
                    Possibility        : SCAL[3];
                    YearsLeft          : NUMERIC[6];
                    Age                : NUMERIC[0];
                    Address            : STRING[]);
  CONST
   PossibilityPool=P_Man.v_PossibilityPool + "| ਢ";
  VAR
   i: NUMERIC[0];
 BEGIN
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrDat(F, Man.Birth);
  L_Basis.wb_WrNum(F, Age, 0);
  L_Basis.wb_WrStr(F, Kind);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(PossibilityPool, Possibility));
  IF Possibility = 1 THEN
   L_Basis.wb_WrDat(F, VcInf.Date);
   L_Basis.wb_WrStr(F, VcInf.SerNbr);
   L_Basis.wb_WrDat(F, VcInf.UsefulTm);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrNum(F, YearsLeft, 6);
  L_Basis.wb_WrStr(F, Address);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE Create_VcInf();
 BEGIN
  CreateFILE(VcInf, "", "", "");

  CreateFIELD(VcInf, Kind,     STRING[32], "", "", "", " 樭樨", "");
  CreateFIELD(VcInf, Possblty, SCAL[2],    "", "", "", "樭 ࠧ襭", "");
  CreateFIELD(VcInf, Date,     DATE,       "", "", "", " 樭樨", "");
  CreateFIELD(VcInf, SerNbr,   STRING[32], "", "", "", ",  樭", "");
  CreateFIELD(VcInf, UsefulTm, DATE,       "", "", "", "ப  樭", "");

  CreateINDEX(VcInf, VcInf, UNIQUE, "", "", Kind, Possblty, Date, SerNbr, UsefulTm);

  SetVersionOfFILE(VcInf, 0001);
  L_AFM.AF_CreateTemp("VcInf", "VcInf");
 END {Create_VcInf};

 PRIVATE PROCEDURE GetLastVaccinationDate(): DATE;
  VAR
   Result: DATE;
 BEGIN
  SAVE(VcInf);
  LAST(VcInf);
  Result:=VcInf.Date;
  RESTORE(VcInf);
  RETURN Result;
 END {GetLastVaccinationDate};

 PRIVATE PROCEDURE MakeRep(OnDate: DATE);
  CONST
   RepName = "Dis03";
   psblt_NoVaccination = 2;
  VAR
   Possibility: SCAL[2][P_Man.v_Amnt];
   Kind       : STRING[][P_Man.v_Amnt];
   Date       : DATE[P_Man.v_Amnt];
   SerNbr     : STRING[][P_Man.v_Amnt];
   UsefulTime : DATE[P_Man.v_Amnt];
   _Kind,
   Address    : STRING[];
   i, Age     : NUMERIC[0];
 BEGIN
  Create_VcInf();
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeHeader("R");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Staff.rInState(OnDate) THEN
    CONFORM(Staff, Man);
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, Union);
    CONFORM(Officer, Sort);

    SELECT(VcInf, VcInf);
    REMSEL(VcInf);
    SELECT(ManPro, Man, , Man.Man, P_Man.P_Vaccination);
    WHILE OCCURE(ManPro) DO
     SETEMPTY(Kind, Possibility, Date, SerNbr, UsefulTime);
     P_Man.Decode_Vaccination(Kind, Possibility, Date, SerNbr, UsefulTime);
     i:=0;
     WHILE i < P_Man.v_Amnt DO
      IF ~!Possibility[i] THEN
       IF ~SEARCH(VcInf, VcInf, Kind[i], Possibility[i], Date[i], SerNbr[i], UsefulTime[i]) THEN
        VcInf.Kind    :=Kind[i];
        VcInf.Possblty:=Possibility[i];
        VcInf.Date    :=Date[i];
        VcInf.SerNbr  :=SerNbr[i];
        VcInf.UsefulTm:=UsefulTime[i];
        INSERT(VcInf);
       END;
      END;
      INC(i);
     END; (* WHILE i < P_Man.v_Amnt...*)
     NEXT(ManPro);
    END; (* WHILE OCCURE(ManPro) ... *)

    SETEMPTY(Address);
    IF (L_Man.AccessManAdr(Man.Man, OnDate, L_Russia.at_RgMA)) |
       (L_Man.AccessManAdr(Man.Man, OnDate, L_Russia.at_DwMA)) THEN
     Address:=L_Man.GetPostAdr_asStr(1);
    END;
    Age:=L_DatTim.YEAR(OnDate)-L_DatTim.YEAR(Man.Birth);
    i:=0;
    WHILE i < P_Man.v_Amnt DO
     _Kind:=L_Str.PoolItem(P_Man.v_KindPool, i);
     IF SELECT(VcInf, VcInf, _Kind) THEN
      WHILE OCCURE(VcInf) DO
       CHANGESEL(VcInf, VcInf, , VcInf.Kind, VcInf.Possblty);
       WHILE OCCURE(VcInf) DO
        IF VcInf.Possblty THEN
         MakePart("R", _Kind, VcInf.Possblty, L_DatTim.YearsInIntvl(GetLastVaccinationDate(), OnDate), Age, Address);
        ELSE
         MakePart("R", _Kind, VcInf.Possblty, 0, Age, Address);
        END;
        NEXT(VcInf);
       END; (* WHILE OCCURE(VcInf) ... *)
       LAST(VcInf);
       CHANGESEL(VcInf, VcInf, , VcInf.Kind);
       NEXT(VcInf);
      END; (* WHILE OCCURE(VcInf) ... *)
     ELSE
      MakePart("R", _Kind, psblt_NoVaccination, 0, Age, Address);
     END;
     INC(i);
    END; (* WHILE i < P_Man.v_Amnt...*)
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  L_AFM.AF_PurgeTemp("VcInf");
  FIO.Close(R);
 END {MakeRep};

BEGIN
 MakeRep(Memo.ud_cd());
END.
