(*
%Copyright   (c) Polak Computer System
%Author      24.08.1998 10:23:27 SAN
%Purpose      ।
%Type        report
%Specific    SYS
%Modified    24.09.2014 16:14:09 LDA
%Environment
*)

 IMPORT L_General, L_DatTim, L_OwnData, L_Acnt, L_AFM, L_EC, L_APtm, L_Staff, L_Money, L_Str,
        L_XObj, L_STx, L_AcCut, L_Man, L_PRoll, L_Basis, Str, Math, FIO, Memo, E_PRoll,
        P_Firm, L_OTx, P_Man, L_StdFrm;

 CONST
  RepName = "Dst";

 TYPE
  tSumType = SCAL[7];

 CONST
  st_CirCrd = L_Acnt.ct_Credit;
  st_CirDbt = L_Acnt.ct_Debit;
  st_ISlCrd = 2;
  st_ISlDbt = 3;
  st_OSlCrd = 4;
  st_OSlDbt = 5;

  st_Pool = Str.Item(L_Acnt.uavp_Pool, "|", L_Acnt.uavp_CirCrd)+"|"+
            Str.Item(L_Acnt.uavp_Pool, "|", L_Acnt.uavp_CirDbt)+"|"+
            Str.Item(L_Acnt.uavp_Pool, "|", L_Acnt.uavp_ISlCrd)+"|"+
            Str.Item(L_Acnt.uavp_Pool, "|", L_Acnt.uavp_ISlDbt)+"|"+
            Str.Item(L_Acnt.uavp_Pool, "|", L_Acnt.uavp_OSlCrd)+"|"+
            Str.Item(L_Acnt.uavp_Pool, "|", L_Acnt.uavp_OSlDbt)+"|";

 VAR
  BPer,
  EPer,
  _From,
  _UpTo    : DATE;

  _InSaldo,
  _OutSaldo: L_PRoll.tSum[2];
             
 PRIVATE PROCEDURE ExcelMode(): SCAL[2];
 BEGIN
  RETURN MODE = 121;
 END {ExcelMode};

 PRIVATE PROCEDURE GetColumnNames(Column: SCAL[32]): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(" | |||ࠢ⨧|ࠢ⨧ |客 |⥫쭠|客 ᥣ",
                        Column);
 END {GetColumnNames};

(*
$P{ Top:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
BPer, L, "N.y"
EPer, L, "N.y"
(" ⮬ " + L_PRoll.E_DistrVersionName(EPer)), C, ""
_InSaldo[L_Acnt.ct_Credit], R, "2-"
_InSaldo[L_Acnt.ct_Debit], R, "2-"
@
#############################################################################################################################                                                                                                       ########## #####
=#####==============================================================================================================================================================================================================================================
|                                                                                    । ⮢  ࠡ⭮   ਮ  #######  #######                                                                                     |
|##################################################################################################################################################################################################################################################|
|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 줮  砫 ਮ   ################                                                                                                                                                                                                |
|                             ################                                                                                                                                                                                                |
}
*)

(*
$P{ MiddleTop:
?, L, "  ।|  "
?, L, ""
GetColumnNames(0), R, ""
GetColumnNames(1), R, ""
GetColumnNames(2), R, ""
GetColumnNames(3), R, ""
GetColumnNames(4), R, ""
GetColumnNames(5), R, ""
GetColumnNames(6), R, ""
GetColumnNames(7), R, ""
GetColumnNames(8), R, ""
@
|==================================================================================================================================================================================================================================================|
|################################################                                                                                                                                                                                                  |
|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|##################################|          㬬|㬬 c .|     ᫥|###############|###############|###############|###############|###############|###############|###############|###############|###############|               |
}
*)

 TYPE
  tResults = L_PRoll.tSum[16];

 VAR
  _Res,
  Tots  : tResults;

 CONST
  MoneySumIdx = 00;
  ExtraTotIdx = 14;
  FullTotIdx  = 15;

(*
$P{ Line:
?, L, ""
_Res[00], R, "2-"
_Res[FullTotIdx], R, "2-"
_Res[ExtraTotIdx], R, "2-"
_Res[01], R, "2-"
_Res[02], R, "2-"
_Res[03], R, "2-"
_Res[04], R, "2-"
_Res[05], R, "2-"
_Res[06], R, "2-"
_Res[07], R, "2-"
_Res[08], R, "2-"
_Res[09], R, "2-"
@
|----------------------------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|
|##################################|###############|###############|###############|###############|###############|###############|###############|###############|###############|###############|###############|###############|               |
}
*)

(*
$P{ MiddleBot:
?, L, " ।| "
Tots[00], R, "2-"
Tots[FullTotIdx], R, "2-"
Tots[ExtraTotIdx], R, "2-"
Tots[01], R, "2-"
Tots[02], R, "2-"
Tots[03], R, "2-"
Tots[04], R, "2-"
Tots[05], R, "2-"
Tots[06], R, "2-"
Tots[07], R, "2-"
Tots[08], R, "2-"
Tots[09], R, "2-"
@
|----------------------------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|
|ᥣ ############################|###############|###############|###############|###############|###############|###############|###############|###############|###############|###############|###############|###############|               |
}
*)

(*
$P{ DebtBot:
?, L, " ।| "
Tots[00], R, "2-"
Tots[FullTotIdx], R, "2-"
Tots[ExtraTotIdx], R, "2-"
Tots[01], R, "2-"
Tots[02], R, "2-"
Tots[03], R, "2-"
Tots[04], R, "2-"
Tots[05], R, "2-"
Tots[06], R, "2-"
Tots[07], R, "2-"
Tots[08], R, "2-"
Tots[09], R, "2-"
@
|----------------------------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|---------------|
|ᥣ ############################|###############|###############|###############|###############|###############|###############|###############|###############|###############|###############|###############|###############|               |
}
*)

(*
$P{ Bot:
_OutSaldo[L_Acnt.ct_Credit], R, "2-"
_OutSaldo[L_Acnt.ct_Debit], R, "2-"
@
|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 줮   ਮ    ################                                                                                                                                                                                                |
|                             ################                                                                                                                                                                                                |
=(c) Polak==========================================================================================================================================================================================================================================
}
*)

 PRIVATE PROCEDURE PrintETop(F: STRING[]);
 BEGIN
  IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "१0");
  L_Basis.wb_WrInQM(F, "१1");
  L_Basis.wb_WrInQM(F, "१2");
  L_Basis.wb_WrInQM(F, "१3");
  L_Basis.wb_WrInQM(F, "१4");
  L_Basis.wb_WrInQM(F, "१5");
  L_Basis.wb_WrInQM(F, "१6");
  L_Basis.wb_WrInQM(F, "१7");
  L_Basis.wb_WrInQM(F, "१-1");
  L_Basis.wb_WrInQM(F, "१-2");
  L_Basis.wb_WrInQM(F, "१-3");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " /");
  L_Basis.wb_WrInQM(F, " /");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ' ࠢ⨧'");
  L_Basis.wb_WrInQM(F, "믫  ᯥ樠  ०");
  L_Basis.wb_WrInQM(F, "㬬");
  L_Basis.wb_WrInQM(F, GetColumnNames(0));
  L_Basis.wb_WrInQM(F, GetColumnNames(1));
  L_Basis.wb_WrInQM(F, GetColumnNames(2));
  L_Basis.wb_WrInQM(F, GetColumnNames(3));
  L_Basis.wb_WrInQM(F, GetColumnNames(4));
  L_Basis.wb_WrInQM(F, GetColumnNames(5));
  L_Basis.wb_WrInQM(F, GetColumnNames(6));
  L_Basis.wb_WrInQM(F, GetColumnNames(7));
  L_Basis.wb_WrInQM(F, GetColumnNames(8));
  L_Basis.wb_WrInQM(F, "।"+L_Str.PoolItem(L_STx.stxp_Pool, L_STx.stxp_PFIn));
  L_Basis.wb_WrInQM(F, "।"+L_Str.PoolItem(L_STx.stxp_Pool, L_STx.stxp_PFAc));
  L_Basis.wb_TermLine(F);
 END {PrintETop};

 PRIVATE PROCEDURE PrintELine(F       : STRING[];
                      _Sums   : L_PRoll.tSum[16]);
 BEGIN
  IF (_Sums[0]  # 0) | (_Sums[1]  # 0) | (_Sums[2] # 0) | (_Sums[3] # 0) | (_Sums[4] # 0) |
     (_Sums[5]  # 0) | (_Sums[6]  # 0) | (_Sums[7] # 0) | (_Sums[8] # 0) | (_Sums[9] # 0) |
     (_Sums[10] # 0) | (_Sums[11] # 0) THEN
   IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
    L_General.ConsultToUs(SEARCH(MyFirm, MyFirm, _Aprt.MyFirm), "PrintELine.Error 234");
    L_Basis.wb_WrScl(F, MyFirm.MyFirm);
    L_Basis.wb_WrStr(F, MyFirm.vzSign);
   END;
   L_Basis.wb_WrScl(F, Man.Man);
   L_Basis.wb_WrScl(F, Man.Name);
   L_Basis.wb_WrStr(F, L_Str.PoolItem(st_Pool, _Aprt.SumType));
   IF (_Aprt.SumType = st_CirDbt) | (_Aprt.SumType = st_CirCrd) THEN
    L_AcCut.PositionOnAcCut(_Aprt.AcCut);
    L_Basis.wb_WrScl(F, AcCut.AcCut);
    L_Basis.wb_WrStr(F, _Aprt.AC_Sign);
    L_Basis.wb_WrStr(F, GetAcntPart(_Aprt.AC_Sign, 0, 0));
    L_Basis.wb_WrStr(F, GetAcntPart(_Aprt.AC_Sign, 1, 0));
    L_Basis.wb_WrStr(F, GetAcntPart(_Aprt.AC_Sign, 2, 0));
    L_Basis.wb_WrStr(F, GetAcntPart(_Aprt.AC_Sign, 3, 0));
    L_Basis.wb_WrStr(F, GetAcntPart(_Aprt.AC_Sign, 4, 0));
    L_Basis.wb_WrStr(F, GetAcntPart(_Aprt.AC_Sign, 5, 0));
    L_Basis.wb_WrStr(F, GetAcntPart(_Aprt.AC_Sign, 6, 0));
    L_Basis.wb_WrStr(F, GetAcntPart(_Aprt.AC_Sign, 7, 0));
    L_Basis.wb_WrStr(F, GetAcntPart(_Aprt.AC_Sign, 1, 1));
    L_Basis.wb_WrStr(F, GetAcntPart(_Aprt.AC_Sign, 2, 1));
    L_Basis.wb_WrStr(F, GetAcntPart(_Aprt.AC_Sign, 3, 1));
    L_Basis.wb_WrStr(F, AcCut.Name);
    L_Basis.wb_WrStr(F, _Aprt.CA_Sign);
   ELSE
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
   END;
   IF ~!_Aprt.MCode THEN
    SEARCH(MCList, MCode, , _Aprt.MCode);
    L_Basis.wb_WrScl(F, MCList.MCode);
    L_Basis.wb_WrStr(F, MCList.Name);
    L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", MCList.InSign[1(*SIC! 11.04.2007 18:01:08 POLAK\San*)]));
    L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", L_OTx.TravmOblig_MCList_Attitude(EPer)));
    L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", _Aprt.wSpecTax));
   ELSE
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "?");
    L_Basis.wb_WrStr(F, "?");
    L_Basis.wb_WrStr(F, "?");
   END;
   L_Basis.wb_WrNum(F, _Sums[00], 2);
   L_Basis.wb_WrNum(F, _Sums[01], 2);
   L_Basis.wb_WrNum(F, _Sums[02], 2);
   L_Basis.wb_WrNum(F, _Sums[03], 2);
   L_Basis.wb_WrNum(F, _Sums[04], 2);
   L_Basis.wb_WrNum(F, _Sums[05], 2);
   L_Basis.wb_WrNum(F, _Sums[06], 2);
   L_Basis.wb_WrNum(F, _Sums[07], 2);
   L_Basis.wb_WrNum(F, _Sums[08], 2);
   L_Basis.wb_WrNum(F, _Sums[09], 2);
   L_Basis.wb_WrNum(F, _Sums[10], 2);
   L_Basis.wb_WrNum(F, _Sums[11], 2);
   L_Basis.wb_TermLine(F);
  END;
 END {PrintELine};

 TYPE
  tAcCutId = LIKE(MCList.AcCut);

 CONST
  ArrSize = MAXOF(MCList.MCode)+1;

 VAR
  MCL_AcCut  : tAcCutId[ArrSize];
  MCL_DstMode: LIKE(DstMode.DstMode)[ArrSize];

 PRIVATE PROCEDURE Create_Distr();
 BEGIN
  CreateFILE(Distr, "", "।", "");

  CreateFIELD(Distr, TSN,   LIKE(Staff.TSN), "", "", "", " ", "");
  CreateFIELD(Distr, ODate, DATE, "", "", "", " ਪ  ਥ/ॢ", "");
  CreateFIELD(Distr, AcCut, LIKE(AcCut.AcCut)[100], "", "", "", "ᨢ ࠧ१", "");

  CreateINDEXandLINK(Distr, TSN, UNIQUE, Staff, TSN, USER, " ", "", TSN, ODate);

  SetVersionOfFILE(Distr, 0000);
  L_AFM.AF_CreateTemp("Distr", "Distr");
 END {Create_Distr};

 PRIVATE PROCEDURE FillMCL_AcCutIds();
 BEGIN
  SETEMPTY(MCL_DstMode, MCL_AcCut);
  SELECT(MCList, MCode);
  WHILE OCCURE(MCList) DO
   PROMPT(MCList.MCode);
   L_PRoll.CheckMCListDistr(0);
   MCL_AcCut[MCList.MCode]  :=MCList.AcCut;
   MCL_DstMode[MCList.MCode]:=MCList.DstMode;
   NEXT(MCList);
  END; (* WHILE OCCURE(MCList)... *)
 END {FillMCL_AcCutIds};

 PRIVATE PROCEDURE CProc04(): SCAL[2]; (*  *)
  VAR
   _Prc   : NUMERIC[5];
   _MCode : LIKE(MCList.MCode);
 BEGIN
  E_PRoll.GetPnsPrc(Money.Closed, 1, _Prc, _MCode);
  RETURN _Prc # 0;
 END {CProc04};

 PRIVATE PROCEDURE intIns_Aprt(P       : DATE;
                       _MyFirm : P_Firm.tMyFirm;
                       _Man    : LIKE(Man.Man);
                       _MCode  : LIKE(MCList.MCode);
                       wSpecTax: SCAL[2];
                       SumType : tSumType;
                       _AcCut  : LIKE(AcCut.AcCut);
                       Idx     : SCAL[16];
                       Val     : L_PRoll.tSum);
  VAR
   CA_Sign : LIKE(CAcnt.Sign);
   AC_Sign : LIKE(AcCut.Sign);
 BEGIN
  IF ~!_AcCut THEN
   CA_Sign:=L_Acnt.GetCAcntSign(P, _AcCut);
   AC_Sign:=L_Acnt.GetAcCutSign(P, _AcCut);
  ELSE
   SETEMPTY(CA_Sign, AC_Sign);
  END;
  IF ExcelMode() THEN
   ADD(_Aprt, _Man, , 0, _MyFirm, _Man, SumType, CA_Sign, AC_Sign, _AcCut, _MCode, wSpecTax,
                      _Aprt.App_Sums[Idx], Val);
  ELSE
   ADD(_Aprt, _ASig, , _MyFirm, SumType, CA_Sign, AC_Sign, _AcCut, _Man,
                       _Aprt.App_Sums[Idx], Val);
  END;
 END {intIns_Aprt};

 PRIVATE PROCEDURE Ins_Aprt(P       : DATE;
                    _MyFirm : P_Firm.tMyFirm;
                    _Man    : LIKE(Man.Man);
                    SumType : tSumType;
                    _AcCut  : LIKE(AcCut.AcCut);
                    Idx     : SCAL[16];
                    Val     : L_PRoll.tSum);
 BEGIN
  intIns_Aprt(P, _MyFirm, _Man, L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(), SumType, _AcCut, Idx, Val);
 END {Ins_Aprt};

 PRIVATE PROCEDURE Add();
  VAR
   SumType : tSumType;
   _AcCut  : LIKE(AcCut.AcCut);
   wSpecTax: SCAL[2];
 BEGIN
  CONFORM(Money, MCList);
  SumType:=MCList.MCTyp;
  IF MCL_AcCut[Money.MCode] = 000 THEN
   _AcCut:=Distr.AcCut[MCL_DstMode[Money.MCode]];
  ELSE
   _AcCut:=MCL_AcCut[Money.MCode];
  END;
  L_General.Assert(~!_AcCut,
         " 㪠 ࠧ१  ᯮᮡ । " + MCL_DstMode[Money.MCode] +
         "| " + Distr.TSN + " ਪ  / "+L_DatTim.DateStr(Distr.ODate)+"  / "+Money.MCode);
  wSpecTax:=L_STx.IsSpecSTxOfficer(Money.Closed);
  intIns_Aprt(Money.Closed, Staff.MyFirm, Staff.Man, MCList.MCode, wSpecTax, SumType, _AcCut, MoneySumIdx, Money.Sum);
  IF L_OTx.TravmOblig_MCList_Attitude(EPer) THEN
   IF L_STx.E_ApplySTxBenefitToInvalid(Money.Closed) &
      P_Man.HasActualManPro(Staff.Man, L_DatTim.MonthEnd(Money.Closed), P_Man.P_Invalid) THEN
    intIns_Aprt(Money.Closed, Staff.MyFirm, Staff.Man, MCList.MCode, wSpecTax, SumType, _AcCut, 06, Money.Sum);
   ELSE
    intIns_Aprt(Money.Closed, Staff.MyFirm, Staff.Man, MCList.MCode, wSpecTax, SumType, _AcCut, 05, Money.Sum);
   END;
  END;
 END {Add};

 PRIVATE PROCEDURE Fill_Distr();
 BEGIN
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(" ࠡ⭨: " +Staff.TSN);
   SELECT(StaffLog, TSN, , Staff.TSN);
   WHILE OCCURE(StaffLog) DO
    IF L_PRoll.E_DistrNeedOfficer(BPer, StaffLog.Sort, StaffLog.Officer) THEN
     SETEMPTY(Distr.AcCut);
     Distr.TSN  :=StaffLog.TSN;
     Distr.ODate:=StaffLog.Date;
     SELECT(OfcDst, Officer, , StaffLog.Sort, StaffLog.Officer);
     WHILE OCCURE(OfcDst) DO
(*
      L_General.Assert(OfcDst.AcCut # 000, "饭 ᯮ짮 ࠧ१ 000  ⭮ ᯨᠭ. " + OfcDst.Sort);
*)
      CONFORM(OfcDst, AcCut);
      Distr.AcCut[OfcDst.DstMode]:=OfcDst.AcCut;
      NEXT(OfcDst);
     END; (* WHILE OCCURE(OfcDst) ... *)
     INSERT(Distr);
    END;
    NEXT(StaffLog);
   END; (* WHILE OCCURE(StaffLog) ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {Fill_Distr};

 PRIVATE PROCEDURE _GetSaldo(SumType: tSumType): L_PRoll.tSum;
  VAR
   Saldo: L_PRoll.tSum;
 BEGIN
  Saldo:=0;
  SELECT(_Aprt, _ASig, , P_Firm.curMyFirm, SumType);
  WHILE OCCURE(_Aprt) DO
   INC(Saldo, _Aprt.App_Sums[0]);
   NEXT(_Aprt);
  END; (* WHILE OCCURE(_Aprt) ... *)
  RETURN Saldo;
 END {_GetSaldo};

 PRIVATE PROCEDURE GetSaldo();
 BEGIN
  IF (L_PRoll.GetDistrVersion() # 0) THEN
   SETEMPTY(_InSaldo, _OutSaldo);
  ELSE
   _InSaldo[L_Acnt.ct_Credit] :=_GetSaldo(st_ISlCrd);
   _InSaldo[L_Acnt.ct_Debit]  :=_GetSaldo(st_ISlDbt);
   _OutSaldo[L_Acnt.ct_Credit]:=_GetSaldo(st_OSlCrd);
   _OutSaldo[L_Acnt.ct_Debit] :=_GetSaldo(st_OSlDbt);
  END;
 END {GetSaldo};

 PRIVATE PROCEDURE SpreadByMCode(_MyFirm: P_Firm.tMyFirm; _Man: LIKE(Man.Man));
  VAR
   Total   : L_PRoll.tSum;
   Rest,
   toSpread: tResults;
   toPut   : L_PRoll.tSum;
   maxVal  : L_PRoll.tSum;
   i       : NUMERIC[0];
 BEGIN
  SELECT(_Aprt, _Man, , 0, _MyFirm, _Man);
  WHILE OCCURE(_Aprt) DO
   CHANGESEL(_Aprt, _Man, , _Aprt.byDst, _Aprt.MyFirm, _Aprt.Man, _Aprt.SumType, _Aprt.CA_Sign, _Aprt.AC_Sign, _Aprt.AcCut);
   Total:=0;
   WHILE OCCURE(_Aprt) DO
    IF ~!_Aprt.MCode THEN
     INC(Total, _Aprt.App_Sums[MoneySumIdx]);
    END;
    NEXT(_Aprt);
   END; (* WHILE OCCURE(_Aprt) *)
   IF (Total # 0) & SRCINSEL(_Aprt, EQ, L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER()) THEN
    SAVE(_Aprt);
    toSpread:=_Aprt.App_Sums;
    Rest    :=toSpread;
    maxVal  :=0;
    FIRST(_Aprt);
    WHILE OCCURE(_Aprt) DO
     IF ~!_Aprt.MCode THEN
      IF Math.Abs(_Aprt.App_Sums[MoneySumIdx]) > maxVal THEN
       maxVal:=Math.Abs(_Aprt.App_Sums[MoneySumIdx]);
      END;
      i:=0;
      WHILE i <= HIGH(toSpread) DO
       IF i # MoneySumIdx THEN
        toPut:=toSpread[i]*(_Aprt.App_Sums[MoneySumIdx]/Total);
        IF toPut # 0 THEN
         sbmc_AddByCurrent(i, toPut);
         DEC(Rest[i], toPut);
        END;
       END;
       INC(i);
      END; (* WHILE i <= ... *)
     END; (* IF IF ~!_Aprt.MCode *)
     NEXT(_Aprt);
    END; (* WHILE OCCURE(_Aprt) *)
    FIRST(_Aprt);
    LOOP
     IF ~OCCURE(_Aprt) THEN
      L_General.ConsultToUs(0, "SpreadByMCode.Error 123");
     ELSIF ~!_Aprt.MCode & (maxVal = Math.Abs(_Aprt.App_Sums[MoneySumIdx])) THEN
      i:=0;
      WHILE i <= HIGH(Rest) DO
       IF (i # MoneySumIdx) & (Rest[i] # 0) THEN
        sbmc_AddByCurrent(i, Rest[i]);
       END;
       INC(i);
      END; (* WHILE i <= ... *)
      EXIT;
     END;
     NEXT(_Aprt);
    END; (* LOOP *)
    RESTORE(_Aprt);
    REMOVE(_Aprt);
   END;
   LAST(_Aprt);
   CHANGESEL(_Aprt, _Man, , _Aprt.byDst, _Aprt.MyFirm, _Aprt.Man);
   NEXT(_Aprt);
  END; (* WHILE OCCURE(_Aprt) ... *)
 END {SpreadByMCode};

 PRIVATE PROCEDURE SpreadPFRPart(_Sum_PFRParts: L_PRoll.tSum;
                         _AcCut_PFRF: LIKE(AcCut.AcCut)[];
                         _Sum_PFRF  : L_PRoll.tSum[];
                         _Total_PFRF: L_PRoll.tSum;
                         _Column    : SCAL[15];
                         _TaxAcCut  : LIKE(AcCut.AcCut));
  VAR
   _Sum,
   _SumToSpread: L_PRoll.tSum;
   IdxMaxSum,
   i           : SCAL[100];
 BEGIN
  _SumToSpread:=_Sum_PFRParts;
  SETZERO(i); IdxMaxSum:=i;
  WHILE ~!_AcCut_PFRF[i] DO
   IF Math.Abs(_Sum_PFRF[i]) > _Sum_PFRF[IdxMaxSum] THEN
    IdxMaxSum:=i;
   END;
   IF _Total_PFRF # 0 THEN
    _Sum:=_Sum_PFRF[i] / _Total_PFRF * _Sum_PFRParts;
   ELSE
    _Sum:=0;
   END;
   Ins_Aprt(EPer, XObject.MyFirm, Man.Man, st_CirCrd, _AcCut_PFRF[i], _Column, _Sum);
   DEC(_SumToSpread, _Sum);
   INC(i);
  END;
  IF _SumToSpread # 0 THEN
   IF ~!_AcCut_PFRF[IdxMaxSum] THEN
    Ins_Aprt(EPer, XObject.MyFirm, Man.Man, st_CirCrd, _AcCut_PFRF[IdxMaxSum], _Column, _SumToSpread);
   ELSE                             (* ,       -0.02*)
    Ins_Aprt(EPer, XObject.MyFirm, Man.Man, st_CirCrd, _TaxAcCut, _Column, _SumToSpread);
   END;
  END;
 END {SpreadPFRPart};

 PRIVATE PROCEDURE Gather();
  VAR
   P         : DATE;
   _ODate    : LIKE(Money.ODate);
   Do        : SCAL[2];
   i         : SCAL[100];
   Idx       : SCAL[16];
   Saldo,
   Sum_PFIn,
   Sum_PFAc,
   Total_PFRF: L_PRoll.tSum;
   AcCut_PFRF: LIKE(AcCut.AcCut)[100];
   Sum_PFRF  : L_PRoll.tSum[100];
 BEGIN
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT("⮢   ࠧ१ ࠡ⭨: " + Staff.TSN);
   IF SELECT(Distr, TSN, Staff.TSN) THEN
    CONFORM(Staff, Man);
    SETEMPTY(_ODate);
    P:=BPer;
    WHILE P <= EPer DO
     SELECT(Money, TSN, , Staff.TSN, P);
     WHILE OCCURE(Money) DO
      IF Money.ODate # _ODate THEN
       IF ~SRCINSEL(Distr, EQ, Money.ODate) THEN
        L_General.Assert(L_PRoll.GetDistrVersion()#0, "  ਪ  "+Staff.TSN+"  "+L_DatTim.DateStr(Money.ODate));
        Do:=0; (*   ॢ,  ⭮騥   ᨨ । *)
       ELSE
        Do:=1;
       END;
       _ODate:=Money.ODate;
      END;
      IF Do THEN
       HISTCONF(Money.ODate, Staff, StaffLog);
       CONFORM(StaffLog, Sort);
       Add();
      END;
      NEXT(Money);
     END; (* WHILE OCCURE(Money)... *)
     P:=L_DatTim.IncMonth(P, +1);
    END;     
    Saldo:=L_PRoll.GetInSaldo(BPer);
    IF Saldo >= 0 THEN
     Ins_Aprt(BPer, Staff.MyFirm, Staff.Man, st_ISlCrd, "", 0, +Saldo);
    ELSE
     Ins_Aprt(BPer, Staff.MyFirm, Staff.Man, st_ISlDbt, "", 0, -Saldo);
    END;
    Saldo:=L_PRoll.GetOutSaldo(EPer);
    IF Saldo >= 0 THEN
     Ins_Aprt(EPer, Staff.MyFirm, Staff.Man, st_OSlCrd, "", 0, +Saldo);
    ELSE
     Ins_Aprt(EPer, Staff.MyFirm, Staff.Man, st_OSlDbt, "", 0, -Saldo);
    END;
   END; (* IF SELECT ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)

  SETSEL(XObject, Origin, L_XObj.o_ESN);
  FOR_EACH XObject DO
   PROMPT("⮢ ᫥ . ꥪ : " + XObject.XObject);
   IF L_XObj.SoftAccessOrigin() & SEARCH(Man, Man, mfMan.Man) & L_PRoll.IsAcceptableManForCurrentDistrVersion() THEN
    SETZERO(i, Total_PFRF, Sum_PFIn, Sum_PFAc); SETEMPTY(AcCut_PFRF, Sum_PFRF);
    SELECT(XCalc, XObject, , XObject.XObject);
    WHILE OCCURE(XCalc) DO
     NARROWSEL(XCalc, AcCut);
     IF L_STx.STx_IsTaxAcCut(XCalc.AcCut) THEN
      SRCINSEL(XCalc, GE, , BPer);
      WHILE OCCURE(XCalc) & (XCalc.XDat <= EPer) DO
       SETSEL(XApport, XObject, XCalc.XObject, XCalc.AcCut, XCalc.XDat);
       FOR_EACH XApport DO
        CONFORM(XApport, Apport);
        IF Apport.CirType = L_Acnt.ct_Credit THEN
         IF    XCalc.AcCut = L_STx.STx_GetTaxAcCut(L_STx.stxp_PFRF) THEN
          Idx:=01;
          IF ExcelMode() THEN
           AcCut_PFRF[i]:=XApport.AcCut2;
           Sum_PFRF[i]  :=XApport.Sum;
           INC(Total_PFRF, XApport.Sum);
           INC(i);
          END;
         ELSIF XCalc.AcCut = L_STx.STx_GetTaxAcCut(L_STx.stxp_SSRF) THEN
          Idx:=02;
         ELSIF XCalc.AcCut = L_STx.STx_GetTaxAcCut(L_STx.stxp_MSFF) THEN
          Idx:=03;
         ELSIF XCalc.AcCut = L_STx.STx_GetTaxAcCut(L_STx.stxp_MSTF) THEN
          Idx:=04;
         ELSIF XCalc.AcCut = L_STx.STx_GetTaxAcCut(L_STx.stxp_PFIn) THEN
          Idx:=07;
         ELSIF XCalc.AcCut = L_STx.STx_GetTaxAcCut(L_STx.stxp_PFAc) THEN
          Idx:=08;
         ELSE
          L_General.Error(" । ࠧ१ "+XCalc.AcCut);
         END;
         Ins_Aprt(XApport.XDat, XObject.MyFirm, Man.Man, Apport.CirType, XApport.AcCut2, Idx, XApport.Sum);
         IF (Idx = 07) | (Idx = 08) THEN
          Ins_Aprt(XApport.XDat, XObject.MyFirm, Man.Man, Apport.CirType, XApport.AcCut2, 9, XApport.Sum);
          IF ExcelMode() THEN
           IF L_STx.STx_IsTaxAcCut(XApport.AcCut2) THEN
            IF Idx = 07 THEN
             INC(Sum_PFIn, XApport.Sum);
            ELSE
             INC(Sum_PFAc, XApport.Sum);
            END;
           ELSE
            IF Idx = 07 THEN
             Idx:=10;
            ELSE
             Idx:=11;
            END;
            Ins_Aprt(XApport.XDat, XObject.MyFirm, Man.Man, Apport.CirType, XApport.AcCut2, Idx, XApport.Sum);
           END;
          END;
         END;
        END;
       END; (* FOR_EACH XApport *)
       NEXT(XCalc);
      END; (* WHILE OCCURE(XCalc) ... *)
     END;
     NEXTINEXTENDEDSEL(XCalc, AcCut);
    END; (* WHILE OCCURE(XCalc) ... *)
    IF ExcelMode() THEN
     SpreadPFRPart(Sum_PFIn, AcCut_PFRF, Sum_PFRF, Total_PFRF, 10, L_STx.STx_GetTaxAcCut(L_STx.stxp_PFIn));
     SpreadPFRPart(Sum_PFAc, AcCut_PFRF, Sum_PFRF, Total_PFRF, 11, L_STx.STx_GetTaxAcCut(L_STx.stxp_PFAc));
     SpreadByMCode(XObject.MyFirm, Man.Man);
    END;
   END;
  END; (* FOR_EACH XObject *)
 END {Gather};

 PRIVATE PROCEDURE IncRes(MF: LIKE(MyFirm.MyFirm)): SCAL[2];
  VAR
   _Tmp: tResults;
 BEGIN
  SETZERO(_Tmp);
  _Tmp[00]:=_Aprt.App_Sums[00];

  _Tmp[01]:=_Aprt.App_Sums[01];
  _Tmp[02]:=_Aprt.App_Sums[02];
  _Tmp[03]:=_Aprt.App_Sums[03];
  _Tmp[04]:=_Aprt.App_Sums[04];
  IF (_Aprt.App_Sums[05] # 0) | (_Aprt.App_Sums[06] # 0) THEN
   _Tmp[05]:=L_Money.RoundMoney(EPer, _Aprt.App_Sums[05] * (L_OTx.TravmObligTariff(MF, _UpTo) / 100));
   _Tmp[06]:=L_Money.RoundMoney(EPer, _Aprt.App_Sums[06] * (L_OTx.TravmObligTariff(MF, _UpTo) * L_OTx.TravmOblig_InvalidCoef / 100));
  ELSE
   SETZERO(_Tmp[05], _Tmp[06]);
  END;
  _Tmp[07]:=_Aprt.App_Sums[07];
  _Tmp[08]:=_Aprt.App_Sums[08];
  _Tmp[09]:=_Aprt.App_Sums[09];
  _Tmp[10]:=_Aprt.App_Sums[10];
  _Tmp[11]:=_Aprt.App_Sums[11];

  IF _Tmp[00] | _Tmp[01] | _Tmp[02] | _Tmp[03] | _Tmp[04] |
     _Tmp[05] | _Tmp[06] | _Tmp[09] | _Tmp[10] | _Tmp[11] THEN
   _Tmp[ExtraTotIdx]:=_Tmp[01]+_Tmp[02]+_Tmp[03]+ _Tmp[04]+_Tmp[05]+_Tmp[06];
   INC(_Res[00], _Tmp[00]);
   INC(_Res[01], _Tmp[01]);
   INC(_Res[02], _Tmp[02]);
   INC(_Res[03], _Tmp[03]);
   INC(_Res[04], _Tmp[04]);
   INC(_Res[05], _Tmp[05]);
   INC(_Res[06], _Tmp[06]);
   INC(_Res[07], _Tmp[07]);
   INC(_Res[08], _Tmp[08]);
   INC(_Res[09], _Tmp[09]);
   INC(_Res[10], _Tmp[10]);
   INC(_Res[11], _Tmp[11]);

   INC(_Res[ExtraTotIdx], _Tmp[ExtraTotIdx]);
   INC(_Res[FullTotIdx], _Tmp[00]+_Tmp[ExtraTotIdx]);
 
   INC(Tots[00], _Tmp[00]);
   INC(Tots[01], _Tmp[01]);
   INC(Tots[02], _Tmp[02]);
   INC(Tots[03], _Tmp[03]);
   INC(Tots[04], _Tmp[04]);
   INC(Tots[05], _Tmp[05]);
   INC(Tots[06], _Tmp[06]);
   INC(Tots[07], _Tmp[07]);
   INC(Tots[08], _Tmp[08]);
   INC(Tots[09], _Tmp[09]);

   INC(Tots[ExtraTotIdx], _Tmp[ExtraTotIdx]);
   INC(Tots[FullTotIdx],  _Tmp[00]+_Tmp[ExtraTotIdx]);

   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {IncRes};

 PRIVATE PROCEDURE Create_Aprt();
 BEGIN
  CreateFILE(_Aprt, "", "   ࠧ१", "");

  CreateFIELD(_Aprt, MyFirm,   P_Firm.tMyFirm,    "", "", "", " ࣠", "");
  CreateFIELD(_Aprt, Man,      LIKE(Man.Man),     "", "", "", "", "");
  CreateFIELD(_Aprt, SumType,  tSumType,          "", "", "", " 祭", "||%|ᠫ줮...");
  CreateFIELD(_Aprt, AcCut,    LIKE(AcCut.AcCut), "", "", "", " ࠧ१", "");
  CreateFIELD(_Aprt, CA_Sign,  LIKE(CAcnt.Sign),  "", "", "", "祭 ", "");
  CreateFIELD(_Aprt, AC_Sign,  LIKE(AcCut.Sign),  "", "", "", "祭 ࠧ१", "");
  CreateFIELD(_Aprt, byDst,    SCAL[2],           "", "", "", "ப 祭 ।", "");
  CreateFIELD(_Aprt, MCode,    LIKE(MCList.MCode), "", "", "", " ᫥/㤥ঠ", "");
  CreateFIELD(_Aprt, wSpecTax,    SCAL[2],         "", "", "", "  ᯥ樠  ०", "");
  CreateFIELD(_Aprt, App_Sums, L_PRoll.tSum[16],  "", "0", "", "", "");

  IF ExcelMode() THEN
   CreateINDEX(_Aprt, _Man,   UNIQUE, "", "", byDst, MyFirm, Man, SumType, CA_Sign, AC_Sign, AcCut, MCode, wSpecTax);
  ELSE
   CreateINDEX(_Aprt, _ASig, UNIQUE, "", "", MyFirm, SumType, CA_Sign, AC_Sign, AcCut, Man);
  END;

  SetVersionOfFILE(_Aprt, 1);
  L_AFM.AF_CreateTemp("_Aprt", "_Aprt");
 END {Create_Aprt};

 PRIVATE PROCEDURE PrintTop();
 BEGIN
  MAKEPART(R, Top, P_Firm.MyFirmName(P_Firm.curMyFirm, SYSDATE()));
 END {PrintTop};

 PRIVATE PROCEDURE PrintMiddleTop(SumType: tSumType; Txt: STRING[]);
 BEGIN
  MAKEPART(R, MiddleTop, SumType, Txt);
 END {PrintMiddleTop};

 PRIVATE PROCEDURE _PrintApp(SumType: tSumType);
  VAR
   TypeCount,
   CirCount : NUMERIC[0];
 BEGIN
  SETZERO(Tots, CirCount);
  SELECT(_Aprt, _ASig, , P_Firm.curMyFirm, SumType);
  WHILE OCCURE(_Aprt) DO
   L_AcCut.PositionOnAcCut(_Aprt.AcCut);
   PROMPT("  ࠧ१ "+AcCut.AcCut);
   CHANGESEL(_Aprt, _ASig, , _Aprt.MyFirm, _Aprt.SumType, _Aprt.CA_Sign, _Aprt.AC_Sign, _Aprt.AcCut);
   SETZERO(TypeCount, _Res);
   WHILE OCCURE(_Aprt) DO
    INC(TypeCount, IncRes(_Aprt.MyFirm));
    NEXT(_Aprt);
   END; (* WHILE OCCURE(_Aprt)... *)
   LAST(_Aprt);
   IF TypeCount > 0 THEN
    IF CirCount = 0 THEN
     PrintMiddleTop(SumType, "१");
    END;
    MAKEPART(R, Line, _Aprt.AC_Sign + " " + AcCut.AcCut + " " + AcCut.Name);
    INC(CirCount);
   END;
   CHANGESEL(_Aprt, _ASig, , _Aprt.MyFirm, _Aprt.SumType);
   NEXT(_Aprt);
  END; (* WHILE OCCURE(_Aprt)... *)
  IF CirCount > 0 THEN
   MAKEPART(R, MiddleBot, SumType);
  END;
 END {_PrintApp};

 PRIVATE PROCEDURE PrintApp();
 BEGIN
  PrintTop();
  _PrintApp(st_CirCrd);
  _PrintApp(st_CirDbt);
  MAKEPART(R, Bot);
  FORMFEED(R);
 END {PrintApp};

 PRIVATE PROCEDURE _StandOnCAcnt(D: DATE; _AcCut: LIKE(AcCut.AcCut); CA_Sign: LIKE(CAcnt.Sign));
 BEGIN
  L_Acnt.AccessACLog(D, _AcCut);
  CONFORM(ACLog, CAcnt);
  WHILE OCCURE(ACLog) & (CAcnt.Sign#CA_Sign) DO
   IF PREV(ACLog) THEN
    CONFORM(ACLog, CAcnt);
   END;
  END;
  L_General.Assert(OCCURE(ACLog), "  ᨭ᪨ |ࠧ१ "+_AcCut+" 祭 "+CA_Sign);
 END {_StandOnCAcnt};

 PRIVATE PROCEDURE _PrintAcn(SumType: tSumType);
  VAR
   TypeCount,
   CirCount  : NUMERIC[0];
 BEGIN
  SETZERO(Tots, CirCount);
  SELECT(_Aprt, _ASig, , P_Firm.curMyFirm, SumType);
  WHILE OCCURE(_Aprt) DO
   PROMPT("  ⠬/⠬ "+_Aprt.CA_Sign);
   CHANGESEL(_Aprt, _ASig, , _Aprt.MyFirm, _Aprt.SumType, _Aprt.CA_Sign);
   SETZERO(TypeCount, _Res);
   WHILE OCCURE(_Aprt) DO
    INC(TypeCount, IncRes(_Aprt.MyFirm));
    NEXT(_Aprt);
   END; (* WHILE OCCURE(_Aprt)... *)
   LAST(_Aprt);
   IF TypeCount > 0 THEN
    IF CirCount = 0 THEN
     PrintMiddleTop(SumType, "/");
    END;
    _StandOnCAcnt(EPer, _Aprt.AcCut, _Aprt.CA_Sign);
    MAKEPART(R, Line, CAcnt.Sign + " " + CAcnt.Name);
    INC(CirCount);
   END;
   CHANGESEL(_Aprt, _ASig, , _Aprt.MyFirm, _Aprt.SumType);
   NEXT(_Aprt);
  END; (* WHILE OCCURE(_Aprt)... *)
  IF CirCount > 0 THEN
   MAKEPART(R, MiddleBot, SumType);
  END;
 END {_PrintAcn};

 PRIVATE PROCEDURE PrintAcn();
 BEGIN
  PrintTop();
  _PrintAcn(st_CirCrd);
  _PrintAcn(st_CirDbt);
  MAKEPART(R, Bot);
  FORMFEED(R);
 END {PrintAcn};

 PRIVATE PROCEDURE GetAcntPart(_Sign: STRING[]; Lev: NUMERIC[0]; bySeparator: SCAL[2]): STRING[];
  CONST
   Separator = "./-";
 BEGIN
  IF    Lev = 0 THEN
   RETURN Str.Item(_Sign, Separator, 0);
  ELSIF bySeparator THEN
   RETURN Str.Slice(_Sign, 0, Str.ItemPos(_Sign, Separator, Lev)+Str.ItemLen(_Sign, Separator, Lev));
  ELSE
   RETURN Str.Slice(_Sign, 0, Str.ItemPos(_Sign, Separator, 1)+Lev);
  END;
 END {GetAcntPart};

 PRIVATE PROCEDURE GetBaseAcnt(CA_Sign: LIKE(CAcnt.Sign)): STRING[2];
 BEGIN
  RETURN GetAcntPart(CA_Sign, 0, 0);
 END {GetBaseAcnt};

 PRIVATE PROCEDURE _PrintAcn1(_SumType: tSumType);
  VAR
   PrvSign   : LIKE(CAcnt.Sign);
   TypeCount,
   CirCount  : NUMERIC[0];
 BEGIN
  PrintMiddleTop(_SumType, "");
  SETZERO(Tots, CirCount);
  SETZERO(_Res, TypeCount);
  IF SELECT(_Aprt, _ASig, P_Firm.curMyFirm, _SumType) THEN
   PrvSign:=_Aprt.CA_Sign;
   WHILE OCCURE(_Aprt) DO
    PROMPT("  ⠬ "+_Aprt.CA_Sign);
    IF (GetBaseAcnt(PrvSign) # GetBaseAcnt(_Aprt.CA_Sign)) THEN
     MAKEPART(R, Line, GetBaseAcnt(PrvSign));
     INC(CirCount);
     SETZERO(_Res, TypeCount);
    END;
    CHANGESEL(_Aprt, _ASig, , _Aprt.MyFirm, _Aprt.SumType, _Aprt.CA_Sign);
    WHILE OCCURE(_Aprt) DO
     INC(TypeCount, IncRes(_Aprt.MyFirm));
     NEXT(_Aprt);
    END; (* WHILE OCCURE(_Aprt)... *)
    LAST(_Aprt);
    CHANGESEL(_Aprt, _ASig, , _Aprt.MyFirm, _Aprt.SumType);
    PrvSign:=_Aprt.CA_Sign;
    NEXT(_Aprt);
   END; (* WHILE OCCURE(_Aprt)... *)
  END; (* IF SELECT(_Aprt... *)
  IF TypeCount > 0 THEN
   MAKEPART(R, Line, GetBaseAcnt(PrvSign));
   INC(CirCount);
  END;
  IF CirCount > 0 THEN
   IF _SumType = st_CirCrd THEN
    MAKEPART(R, DebtBot, _SumType);
   ELSE
    MAKEPART(R, MiddleBot, _SumType);
   END;
  END;
 END {_PrintAcn1};

 PRIVATE PROCEDURE PrintAcn1();
 BEGIN
  PrintTop();
  _PrintAcn1(st_CirCrd);
  _PrintAcn1(st_CirDbt);
  MAKEPART(R, Bot);
 END {PrintAcn1};

 PRIVATE PROCEDURE sbmc_AddByCurrent(i: NUMERIC[0]; Val: L_PRoll.tSum);
 BEGIN
  SAVE(_Aprt);
  ADD(_Aprt, _Man, , 1, _Aprt.MyFirm, _Aprt.Man, _Aprt.SumType,
                     _Aprt.CA_Sign, _Aprt.AC_Sign, _Aprt.AcCut, _Aprt.MCode, _Aprt.wSpecTax,
                     _Aprt.App_Sums[i], Val);
  RESTORE(_Aprt);
 END {sbmc_AddByCurrent};

 PRIVATE PROCEDURE PrintForExcel();
 BEGIN
  FIO.Open(E, L_General.NameConnection("Distr"), "REP", Create);
  SETZERO(Tots);
  PrintETop("E");
  SELECT(_Aprt, _Man);
  WHILE OCCURE(_Aprt) DO
   CHANGESEL(_Aprt, _Man, , _Aprt.byDst, _Aprt.MyFirm, _Aprt.Man);
   WHILE OCCURE(_Aprt) DO
    L_Man.AccessMan(_Aprt.Man);
    PROMPT("㧪. : " + L_Str.IntStr(Man.Man));
    SETZERO(_Res);
    IF IncRes(_Aprt.MyFirm) THEN
     PrintELine("E", _Res);
    END;
    NEXT(_Aprt);
   END; (* WHILE OCCURE(_Aprt)... *)
   LAST(_Aprt);
   CHANGESEL(_Aprt, _Man);
   NEXT(_Aprt);
  END; (* WHILE OCCURE(_Aprt)... *)
  FIO.Close(E);
 END {PrintForExcel};

 PRIVATE PROCEDURE CheckCalendar();
 BEGIN
  L_DatTim.CheckWMIntvl(_From, _UpTo);
  L_General.Assert(L_DatTim.YEAR(_From) = L_DatTim.YEAR(_UpTo),
         "⨬ ਬ ⮫쪮  । ");
  IF ~L_APtm.MonthIsClosed(EPer, L_APtm.system_Salary) THEN
   STDMSG(" "+L_DatTim.PeriodStr(EPer)+"  ", CHOICE);
   L_General.AdminOnly();
  END;
 END {CheckCalendar};

BEGIN

 _From:=Memo.From();
 _UpTo:=Memo.UpTo();
 BPer :=L_DatTim.MonthBeg(_From);
 EPer :=L_DatTim.MonthBeg(_UpTo);

 RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
 L_StdFrm.JustQuestion("⮢ ।  ਮ|c "+L_DatTim.PeriodStr(BPer)+"  "+L_DatTim.PeriodStr(EPer));

 L_General.Assert(BPer >= 01\01\2001, "।  ਮ  2001   ঠ");
 L_General.Assert(EPer <  01\01\2010, "।  ਮ  2010  . Dst10");
 L_PRoll.SetDistrVersion(EPer, "⮢ ।  ⮬");

 CheckCalendar();

 Create_Distr();
 Create_Aprt();
 FillMCL_AcCutIds();
 Fill_Distr();

 Gather();

 IF ~ExcelMode() THEN
  OPENREP(R, L_General.NameAnyMonth(RepName, EPer), Create);
  SetPrintAttr(R, FontEnlargement, 1.2,
                  TopMargin,       0,
                  BottomMargin,    0);
  SELECT(_Aprt, _ASig);
  WHILE OCCURE(_Aprt) DO
   P_Firm.curMyFirm:=_Aprt.MyFirm;
   SAVE(_Aprt);
   GetSaldo();
   PrintApp();
   PrintAcn();
   PrintAcn1();
   RESTORE(_Aprt);
   CHANGESEL(_Aprt, _ASig, , _Aprt.MyFirm);
   LAST(_Aprt);
   FORMFEED(R);
   CHANGESEL(_Aprt, _ASig);
   NEXT(_Aprt);
  END; (* WHILE OCCURE(_Aprt) ... *)
 ELSE
  PrintForExcel();
 END;

 L_AFM.AF_PurgeTemp("Distr");
 L_AFM.AF_PurgeTemp("_Aprt");

END.
