(*
%Copyright   (c) Polak Computer System
%Author      24.01.2003 15:55:52 POLAK\GAV
%Purpose      ਠ 業⥩, ᮤঠ ࠣ⠫
%Type        report
%Specific    SYS
%Modified    11.06.2013 16:11:51 POLAK\Bor
%Environment
*)

 MODULE DrgMv [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_MathR, L_Basis, L_MDoc, L_Str, P_Math, FIO, Memo, L_Acnt, L_bp, L_XObj, D_XObj;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");

  L_Basis.wb_WrInQM(F, "ࠣ⠫");
  L_Basis.wb_WrInQM(F, "줮  砫");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "।");
  L_Basis.wb_WrInQM(F, "줮  ");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]; _BoxNbr,
                                         _Column,
                                         _Mark        : STRING[];
                                         _MarkName    : LIKE(Mark.Name);
                                         _MetalName   : STRING[];
                                         _InSaldo,
                                         _Debet,
                                         _Credit,
                                         _OutSaldo    : P_Math.tPreciousMetals);
 BEGIN
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrStr(F, L_MathR.DefaultMUnitSign(Math.Math));
  L_Basis.wb_WrScl(F, _BoxNbr);
  L_Basis.wb_WrScl(F, _Column);
  L_Basis.wb_WrScl(F, _Mark);
  L_Basis.wb_WrStr(F, _MarkName);
  L_Basis.wb_WrStr(F, FLDTOSTR(Math.MathKind, "|"));
  L_Basis.wb_WrScl(F, Math.MathType);
  L_Basis.wb_WrStr(F, MathType.Name);
  L_Basis.wb_WrStr(F, _MetalName);
  L_Basis.wb_WrNum(F, _InSaldo,  PRECISIONOF(P_Math.tPreciousMetals));
  L_Basis.wb_WrNum(F, _Debet,    PRECISIONOF(P_Math.tPreciousMetals));
  L_Basis.wb_WrNum(F, _Credit,   PRECISIONOF(P_Math.tPreciousMetals));
  L_Basis.wb_WrNum(F, _OutSaldo, PRECISIONOF(P_Math.tPreciousMetals));
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE NeedMath(VAR PreciousMetals: P_Math.tPreciousMetals[P_Math.pm_Amount]): SCAL[2];
  VAR
   i   : SCAL[P_Math.pm_Amount];
   Need: SCAL[2];
 BEGIN
  IF P_Math.HasActualMathPro(Math.Math, Memo.UpTo(), P_Math.P_PreciousMetals) THEN
   P_Math.Decode_PreciousMetals(MathPro.Value, PreciousMetals);
   Need:=0;
   FOR_EACH i DO
    IF   !PreciousMetals[i] THEN
     PreciousMetals[i]:=0;
    ELSIF PreciousMetals[i] # 0 THEN
     Need:=1;
    END;
   END; (* FOR_EACH i ... *)
   RETURN Need;
  ELSE
   SETZERO(PreciousMetals);
   RETURN 0;
  END;
 END {NeedMath};

 PRIVATE PROCEDURE MakeRep();
  VAR
   SI,
   SO,
   CC,
   CD       : NUMERIC[2];
   _BoxNbr  : STRING[];
   _Column  : STRING[];
   _Mark    : STRING[];
   _MarkName: LIKE(Mark.Name);
   i        : SCAL[P_Math.pm_Amount];
   trgMyFirm: LIKE(MyFirm.MyFirm);
   trgOM    : L_XObj.tOriginsMap;
   PreciousMetals: P_Math.tPreciousMetals[P_Math.pm_Amount];
 BEGIN
  L_XObj.SetupOrigins(0, trgOM, trgMyFirm);

  SELECT(Math, Leaf, , 1);
  WHILE OCCURE(Math) DO
   PROMPT(" "+Math.Math);
   IF NeedMath(PreciousMetals) THEN
    _BoxNbr  :="---";
    _Column  :="--";
    _Mark    :="---";
    _MarkName:="---";

    IF Math.MathKind = L_MathR.mathk_Math THEN
     D_XObj.PointwiseBuildXC001(D_XObj.XCC_SingleMath,
                                EMPTYOF(L_XObj.tSection),
                                L_Acnt.ak_Acn,
                                trgOM,
                                trgMyFirm,
                                D_XObj.XST_ByXObj,
                                D_XObj.XST_ByAcCut,
                                D_XObj.XST_ByAcCut2);

     SETZERO(SI, CD, CC);
     SELECT(XC001, mfObject);
     WHILE OCCURE(XC001) DO
      IF L_MathR.AcCutOfRealStock(XC001.Cut1) THEN
       INC(SI, XC001.uav_aQnt[L_Acnt.uavp_ISlDbt]-XC001.uav_aQnt[L_Acnt.uavp_ISlCrd]);
       INC(CD, XC001.uav_aQnt[L_Acnt.uavp_CirDbt]);
       INC(CC, XC001.uav_aQnt[L_Acnt.uavp_CirCrd]);
      END;
      NEXT(XC001);
     END; (* WHILE OCCURE(XC001) ... *)

     D_XObj.PurgeXC001();
    ELSIF Math.MathKind = L_MathR.mathk_KeyAs THEN
     IF L_MathR.PosToLastCarLog(Math.Math, Memo.UpTo()) THEN
      CONFORM(CarLog, Car);
      CONFORM(CarLog, Mark);
      _BoxNbr  :=Car.BoxNbr;
      _Column  :=CarLog.Column;
      _Mark    :=CarLog.Mark;
      _MarkName:=Mark.Name;
     END;
     IF L_MDoc.PosToLastKeyAssMDoc(Math.Math, Memo.UpTo()) THEN
      SO:=~L_MDoc.md_asASp(MDoc.MDocKind);
      IF L_MDoc.PosToLastKeyAssMDoc(Math.Math, Memo.From()-1) THEN
       IF ~L_MDoc.md_asASp(MDoc.MDocKind) THEN
        SI:=1;
        CD:=0;
        CC:=SI-SO;
       ELSE
        SETZERO(SI, CD, CC);
       END;
      ELSE
       SI:=0;
       CD:=1;
       CC:=CD-SO;
      END;
     END;
    ELSE
     L_General.Error(" ⨯  "+Math.MathKind+" ("+Math.Math+")");
    END;

    IF (SI # 0) | (CD # 0) | (CC # 0) THEN
     CONFORM(Math, MathType);
     SO:=SI + CD - CC;
     MakePart("R", _BoxNbr, _Column, _Mark, _MarkName, " ⢮", SI, CD, CC, SO);
     FOR_EACH i DO
      MakePart("R", _BoxNbr, _Column, _Mark, _MarkName,
                    L_Str.PoolItem(P_Math.PreciousMetalsPool, i),
                    PreciousMetals[i] * SI,
                    PreciousMetals[i] * CD,
                    PreciousMetals[i] * CC,
                    PreciousMetals[i] * SO);
     END;
    END;
   END; (* IF NeedMath(PreciousMetals) ... *)
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)
 END {MakeRep};

 PUBLIC PROCEDURE DrgMv();
  CONST
   bpId = "DrgMv";
 BEGIN
  L_bp.Begin(bpId, "  ࠣ.⠫    ", L_bp.t_Basis, L_General.tc_inIntvl);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
  MakeRep();
  FIO.Close(R);
  L_bp.End();
 END {DrgMv};

END.
