(*
%Copyright   (c) Polak IT
%Author      07.06.2004 11:25:10 POLAK\ATS
%Purpose      ࠢ, ⮢   㬥⮢.
%Type        operation
%Specific    SYS
%Modified    02.11.2012 12:14:16 POLAK\GAV
%Environment
*)

 IMPORT L_General, L_Dspt, P_Firm, L_MSO, L_XDoc, L_Events, L_DatTim, L_Str, L_ODoc,
        Str, P_Man, Memo, DBD, L_Acnt, Math, P_Staff, L_Staff, L_ctc, L_StdFrm;

 CONST
  fd_Condition = "";

 PRIVATE PROCEDURE SetDsptFirm(Root: STRING[]; D: DATE);
 BEGIN
  P_Firm.SetFirmData(Root, Dspt.Firm, D, "", "");
  IF ~!Dspt.FCId THEN
   P_Firm.SetFirmContactPersonData_wAlias(Root + "Firm", Dspt.Firm, Dspt.FCId, D);
  END;
  CONFORM(Dspt, MyFirm);
  P_Firm.SetFirmData(Root+"Own", MyFirm.Firm, D, "", "");
  IF ~!Dspt.CSFirm THEN
   P_Firm.SetFirmData(Root+"CS", Dspt.CSFirm, D, "", "");
  ELSE
   P_Firm.SetEmptyFirmData(Root+"CS", "");
  END;
 END {SetDsptFirm};

 PRIVATE PROCEDURE SetOneDsptStfVars(Root, Suffix: STRING[]; D: DATE; Who: LIKE(DsptStf.Who));
  VAR
   RealDsptStf: SCAL[2];
   ShortManName: STRING[];
 BEGIN
  SETEMPTY(ShortManName);
  RealDsptStf:=SELECT(DsptStf, Dspt, Dspt.Type, Dspt.Dspt, Who);
  IF RealDsptStf THEN
   CONFORM(DsptStf, Staff);
   CONFORM(Staff, Man);
   ShortManName:=L_Str.ShortName(Man.Name);
  END;
  L_MSO.wordSetVarsByFile_wAliasE("DsptStf", Root, ~RealDsptStf);
  Root:=Root + Suffix + ".";
(*
  L_Staff.StaffFileFamily(D, D, Root);
*)
  L_MSO.wordSetVarsByFile_wAliasE("Staff", Root + "Staff", ~RealDsptStf);
  L_MSO.wordSetVarsByFile_wAliasE("Man",   Root + "Staff.Man", ~RealDsptStf);
  L_MSO.wordSetVar(Root + "Man.Name.Short", ShortManName);       
 END {SetOneDsptStfVars};

 PRIVATE PROCEDURE SetDsptStfVars(Root: STRING[]; D: DATE);
 BEGIN
  SetOneDsptStfVars(Root, "Courier", D, L_Dspt.dsptwho_Courier);
  SetOneDsptStfVars(Root, "Sender",  D, L_Dspt.dsptwho_Sender);
 END {SetDsptStfVars};

 PRIVATE PROCEDURE SetDsptDocVars(r: STRING[]);
  VAR
   trgDate     : DATE;
   trgSrcNbr   : STRING[];
   trgXDoc     : L_XDoc.tXDoc;
   trgXDocType : L_XDoc.tXDocType;
   trgXDocKind : L_XDoc.tXDocKind;
 BEGIN
  SAVE(Dspt);
  L_General.Assert(L_XDoc.StandOnXDoc(DsptDoc.XDocId),
                    "㤠  㬥 ࠢ " + L_XDoc.XDocStr(DsptDoc.XDocId));

  L_XDoc.PositionOnXDoc(DsptDoc.XDocId);
  L_XDoc.DecodeXDocId(DsptDoc.XDocId, trgXDocType, trgXDocKind, trgXDoc);
  IF L_XDoc.Ref_KindName(trgXDocType) # L_ODoc.fld_None THEN
   CONFORM(^(L_XDoc.Ref_FileName(trgXDocType)), ^(L_XDoc.Ref_KindName(trgXDocType)));
  END;
  IF trgXDocType = L_XDoc.xdt_Contract THEN
   CONFORM(Contract, CntrT);
  END;

  trgDate  :=L_ODoc.GetXDocDate(DsptDoc.XDocId);
  trgSrcNbr:=L_ODoc.GetXDocSrcNbr(DsptDoc.XDocId);
  L_MSO.wordSetVar(r + ".XDoc.XDocId",         DsptDoc.XDocId);
  L_MSO.wordSetVar(r + ".XDoc.XDocType",       trgXDocType);
  L_MSO.wordSetVar(r + ".XDoc.XDocKind",       trgXDocKind);
  L_MSO.wordSetVar(r + ".XDoc.XDocKind.Name",  L_ODoc.GetXDocKindName(DsptDoc.XDocId));
  L_MSO.wordSetVar(r + ".XDoc.EName"   ,       L_XDoc.Ref_FileName(trgXDocType));
  L_MSO.wordSetVar(r + ".XDoc.XDTSName",       L_XDoc.Ref_FullName(trgXDocType));
  L_MSO.wordSetVar(r + ".XDoc.XDoc",           trgXDoc);
  L_MSO.wordSetVar(r + ".XDoc.Name",           L_ODoc.GetXDocName(DsptDoc.XDocId));
  L_MSO.wordSetVar(r + ".XDoc.Name.Full",      L_ODoc.GetXDocName_Full(DsptDoc.XDocId));
  L_MSO.wordSetVar(r + ".XDoc.Name.Short",     L_ODoc.GetXDocName_Short(DsptDoc.XDocId));
  L_MSO.wordSetDateVar(r + ".XDoc.Date",       trgDate);
  L_MSO.wordSetVar(r + ".XDoc.SrcNbr",         trgSrcNbr);
  L_MSO.wordSetVar(r + ".XDoc.Sign",           L_ODoc.GetXDocSign(DsptDoc.XDocId));
  L_MSO.wordSetVar(r + ".XDoc.Status",         L_ODoc.GetXDocField(trgXDocType, "Status"));
  L_MSO.wordSetVarsByFile_wAliasE("MDoc",     r + ".XDoc.Successor.MDoc",           trgXDocType #  L_XDoc.xdt_MDoc);
  L_MSO.wordSetVarsByFile_wAliasE("MDocKind", r + ".XDoc.Successor.MDoc.MDocKind",  trgXDocType #  L_XDoc.xdt_MDoc);
  L_MSO.wordSetVarsByFile_wAliasE("PDoc",     r + ".XDoc.Successor.PDoc",           trgXDocType #  L_XDoc.xdt_PDoc);
  L_MSO.wordSetVarsByFile_wAliasE("PDocKind", r + ".XDoc.Successor.PDoc.PDocKind",  trgXDocType #  L_XDoc.xdt_PDoc);
  L_MSO.wordSetVarsByFile_wAliasE("ODoc",     r + ".XDoc.Successor.ODoc",           trgXDocType #  L_XDoc.xdt_ODoc);
  L_MSO.wordSetVarsByFile_wAliasE("ODocKind", r + ".XDoc.Successor.ODoc.ODocKind",  trgXDocType #  L_XDoc.xdt_ODoc);
  L_MSO.wordSetVarsByFile_wAliasE("Contract", r + ".XDoc.Successor.Contract",       trgXDocType #  L_XDoc.xdt_Contract);
  L_MSO.wordSetVarsByFile_wAliasE("CntrT",    r + ".XDoc.Successor.Contract.CntrT", trgXDocType #  L_XDoc.xdt_Contract);
  RESTORE(Dspt);
 END {SetDsptDocVars};

 PRIVATE PROCEDURE dspt_SetDocVars(D: DATE; TmpDotPrepared: SCAL[2]);
  VAR
   Root,
   r: STRING[];
   i,
   _PaperNum: NUMERIC[0];
 BEGIN
  Root:="Dspt.";
  r:=Root;
  SetDsptFirm(r, D);
  SetDsptStfVars(r, D);
  L_MSO.wordSetVarsByFile("Dspt");
  CONFORM(Dspt, DsptMode);
  L_MSO.wordSetVarsByFile_wPrefix("DsptMode", r);

  CONFORM(Dspt, EnvlLttr);
  L_MSO.wordSetVarsByFile_wPrefixE("EnvlLttr", r, ~OCCURE(EnvlLttr));

  L_MSO.wordSetVar(r+"DsptTime.Date", L_DatTim.DateStr(D)); (* ??? Mog*)
  L_MSO.wordSetVar(r+"BarCode", L_XDoc.BarCode(L_XDoc.bck_IdIn17, L_XDoc.xdt_Dispatch, Dspt.Type, Dspt.Dspt, Dspt.CopyCnt));
  i:=0; _PaperNum:=0;
  CONFORM(Dspt, DsptDoc);
  WHILE OCCURE(DsptDoc) DO
   PROMPT("㧪 : " + DsptDoc.Nbr);
   r:=Root+"DsptDoc"+L_MSO.IndexStr(i);
   L_MSO.wordSetVarsByFile_wAlias("DsptDoc", r);
   SetDsptDocVars(r);
   INC(i);
   INC(_PaperNum, DsptDoc.PaperNum);
   NEXT(DsptDoc);
  END; (* WHILE OCCURE(DsptDoc) ... *)
  r:=Root;
  L_MSO.wordSetVar(r+"PaperNum", L_Str.IntStr(_PaperNum));
  L_MSO.wordSetVar(r+"DocCount", L_Str.IntStr(i));
  IF ~TmpDotPrepared THEN
   L_MSO.extSetWordTable("Table1", i, L_MSO.tt_Soft);
  END;
  L_MSO.extSetWordTable("DsptDoc_2", i, L_MSO.tt_Soft);
 END {dspt_SetDocVars};

 PRIVATE PROCEDURE E_GetTemplateVersion(D: DATE): STRING[2];
 BEGIN
  IF D >= 14\11\2007 THEN
   RETURN "02";
  ELSE
   RETURN "01";
  END;
 END {E_GetTemplateVersion};

 PRIVATE PROCEDURE PrintDspt(Preview: SCAL[2]);
  VAR
   D     : DATE;
   DsptDot   : STRING[];
   wUseTmpDot: SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(Dspt), " ⠭ ࠢ");
  IF L_Dspt.IsPostalDspt() THEN
   DsptDot:=L_MSO.BuildTemplateName("Dspt_##", E_GetTemplateVersion(Dspt.Date));
  ELSE
   DsptDot:="DsptC";
  END;
  IF ~Preview THEN
   L_General.Assert(Dspt.Status # L_Dspt.st_Canceled, "ࠢ 㫨஢");
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_Dispatch, Dspt.Type, Dspt.Dspt, L_XDoc.action_Reprint);
   INC(Dspt.CopyCnt); (* : 孨 ࠡ  ⨬ *)
   REPLACE(Dspt);
  END;
  IF ((Dspt.Type = L_Dspt.t_Incoming) & SEARCH(DsptTime, Dspt, Dspt.Type, Dspt.Dspt, L_Dspt.rp_Delivery)) |
     ((Dspt.Type = L_Dspt.t_Outgoing) & SEARCH(DsptTime, Dspt, Dspt.Type, Dspt.Dspt, L_Dspt.rp_Send)) THEN
   D:=DsptTime.Date;
  ELSE
   D:=Dspt.Date;
  END;
  IF L_Dspt.IsPostalWorthDspt() THEN
   L_MSO.CreateTmpDot(DsptDot);
   L_MSO.wordInitDocument(D);
   PROMPT("㧪 ");
   dspt_SetDocVars(D, 0);
   L_MSO.MakeWordDocument("DsptList", 1, L_MSO.PrpMode_ToTmpDot, DsptDot + ";" + L_MSO.ipb_BeforePaste_AsStr);
   wUseTmpDot:=1;
  ELSE
   wUseTmpDot:=0;
  END;
  L_MSO.wordInitDocument(D);
  L_MSO.UseTmpDot:=wUseTmpDot;
  PROMPT("㧪 ");
  dspt_SetDocVars(D, wUseTmpDot);
  IF Preview THEN
   L_MSO.MakeWordDocument(DsptDot, 1, L_MSO.PrpMode_ToDoc, "");
  ELSE
   L_MSO.MakeWordDocument(DsptDot, 1, L_MSO.PrpMode_Print, "");
  END;
 END {PrintDspt};

 PRIVATE PROCEDURE GetCurSignature(): STRING[];
  VAR
   CurTSN: LIKE(Staff.TSN);
 BEGIN
  SEARCH(Man, Man, , P_Man.curUSER2Man());
  IF P_Firm.StandOnFirmCtcByKindType(0, P_Firm.fomf(DsptPck.MyFirm), DsptPck.Date, L_ctc.ckt_Leader) &
     (FirmCtc.Contact = Man.Contact) THEN
   RETURN FirmCtc.ECKName + " " + Man.Name;
  ELSE
   CurTSN:=L_Staff.Man2TSN(Memo.ud_cd(), Man.Man, DsptPck.MyFirm, 0, 0);
   IF ~!CurTSN & P_Staff.HasActualStaffPro(CurTSN, DsptPck.Date, P_Staff.P_PowerSubscribeDsptPck) THEN
    CONFORM(StaffPro, Staff);
    L_Staff.PosToStaffLog(Staff.TSN, DsptPck.Date, 1);
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, Post);
    RETURN " ७ " + StaffPro.DocNum + "  " +
           L_DatTim.DateStr(StaffPro.DocGiveD) + " " + Post.Name + " " + Man.Name;
   ELSE
    RETURN "????????????????????????????????????";
   END;
  END;
 END {GetCurSignature};

 PRIVATE PROCEDURE PrintDsptPck(Preview: SCAL[2]);
  VAR
   i       : NUMERIC[0];
   TWeight : LIKE(Dspt.Weight);
   TFreight: LIKE(Dspt.Freight);
   TWorth  : LIKE(Dspt.Worth);
   r,
   Root    : STRING[];
 BEGIN
  L_General.Assert(ACCESS(DsptPck), " ⠭ ");
  L_General.Assert(DsptPck.MyFirm # P_Firm.mf_Fict, " ⠭ '' ࣠ ");
  SETZERO(TWeight, TFreight, TWorth);
  L_MSO.wordInitDocument(Memo.ud_cd());
  i:=0;
  Root:="DsptPck";
  L_MSO.wordSetVarsByFile_wAlias("DsptPck", Root);
  L_MSO.wordSetVar(Root + ".BarCode", L_XDoc.BarCode(L_XDoc.bck_IdIn17, L_XDoc.xdt_DsptPck, L_XDoc.EmptyXDocKind, DsptPck.DsptPck, 00));
  L_General.Assert(SELECT(Dspt, DsptPck, DsptPck.DsptPck), "⠥ ⮩ ?");

  L_General.ConsultToUs(~!Dspt.CSFirm, " 㪠  裡  ࠢ " + Dspt.Dspt);
  P_Firm.SetFirmData(Root+".Post", Dspt.CSFirm, DsptPck.Date, "", "");
  WHILE OCCURE(Dspt) DO
   PROMPT("㧪 : " + Dspt.Dspt);
   r:=Root+".Dspt"+L_MSO.IndexStr(i);
   P_Firm.SetFirmData(r + ".", Dspt.Firm, Dspt.Date, "", fd_Condition);
   IF ~!Dspt.FCId THEN
    P_Firm.SetFirmContactPersonData_wAlias(r + ".Firm", Dspt.Firm, Dspt.FCId, Dspt.Date);
   END;
   L_MSO.wordSetVar(r+".Pos", L_Str.IntStr(i+1));
   L_MSO.wordSetVar(r+".Weight.Gram", L_Str.NumericStr(Dspt.Weight, 3));
   L_MSO.wordSetVarsByFile_wAlias("Dspt", r);
   CONFORM(Dspt, DsptMode);
   L_MSO.wordSetVarsByFile_wAlias("DsptMode", r + ".DsptMode");
   IF ~!Dspt.Weight THEN
    INC(TWeight, Dspt.Weight);
   END;
   IF ~!Dspt.Worth THEN
    INC(TWorth , Dspt.Worth);
   END;
   IF ~!Dspt.Freight THEN
    INC(TFreight, Dspt.Freight);
   END;
   INC(i);
   NEXT(Dspt);
  END; (* WHILE OCCURE(Dspt) ... *)
  IF TWeight=0 THEN
   SETEMPTY(TWeight);
  END;
  IF TWorth=0 THEN
   SETEMPTY(TWorth);
  END;
  IF TFreight=0 THEN
   SETEMPTY(TFreight);
  END;
  L_MSO.wordSetVar(Root+".Amount", L_Str.IntStr(i));
  L_MSO.wordSetVar(Root+".Amount.ByWord", Str.NumByWord(i, FEMININE, "㪠|㪨|"));
  L_MSO.wordSetVar(Root+".Weight", L_Str.NumericStr(TWeight, 3));
  L_MSO.wordSetMoneyVar(Root+".Worth", DsptPck.Date, TWorth);
  L_MSO.wordSetMoneyVar(Root+".Freight", DsptPck.Date, TFreight);
  IF ~!TFreight THEN
   L_MSO.wordSetMoneyVar(Root+".Freight.VAT", DsptPck.Date,
                         L_Acnt.GetExclVAT(DsptPck.Date, TFreight));
   L_MSO.wordSetMoneyVar(Root+".Freight.Total", DsptPck.Date,
                         TFreight + L_Acnt.GetExclVAT(DsptPck.Date, TFreight));
  ELSE
   L_MSO.wordSetMoneyVar(Root+".Freight.VAT", DsptPck.Date, TFreight);
   L_MSO.wordSetMoneyVar(Root+".Freight.Total", DsptPck.Date, TFreight);
  END;
  L_MSO.wordSetVar("TheDoc.Signature", GetCurSignature());
  P_Firm.SetFirmData("Own", P_Firm.fomf(DsptPck.MyFirm), DsptPck.Date, "", "");
  L_MSO.SetWordTable("Table1", i);
  IF Preview THEN
   L_MSO.MakeWordDocument("DsptPck", 1, L_MSO.PrpMode_ToDoc, "");
  ELSE
   L_MSO.MakeWordDocument("DsptPck", 1, L_MSO.PrpMode_Print, "");
  END;
 END {PrintDsptPck};

 PRIVATE PROCEDURE StreamPrint();
  VAR
   curDsptDate: DATE;
   curDsptMode: LIKE(Dspt.DsptMode);
 BEGIN
  L_General.Assert(ACCESS(Dspt), " ⠭ ࠢ");
  curDsptDate:=Dspt.Date;
  curDsptMode:=Dspt.DsptMode;
  CONFORM(Dspt, DsptMode);
  L_StdFrm.JustQuestion(" ࠢ 㬥⮢  " + L_DatTim.DateStr(curDsptDate) + "|" +
                        " ᯮᮡ '" + curDsptMode + " " + DsptMode.Name + "'");
  SELECT(Dspt, DsptSt, , L_Dspt.t_Outgoing, L_Dspt.st_Prepared, curDsptDate);
  WHILE OCCURE(Dspt) DO
   IF Dspt.DsptMode = curDsptMode THEN
    TRY [TRANSACTION(TRANSACTION_SLAVE)]
     PrintDspt(0);
    EXCEPT
    ELSE
     L_StdFrm.OrdinaryCHOICE(" 㤠 ᯥ ࠢ " + Dspt.Dspt + "|" + "த ?");
    END;
   END;
   NEXT(Dspt);
  END; (* WHILE OCCURE(Dspt) ... *)
 END {StreamPrint};

END.
