(*
%Copyright   (c) Polak Computer System
%Author      02.06.2010 12:45:34 POLAK\MLB
%Purpose     Data Warehouse
%Type        operation
%Specific    SYS
%Modified    05.02.2014 19:06:33 POLAK\LDA
%Environment
*)

 IMPORT Memo, Str, L_Events, L_General, L_Str, L_DBD, L_APtm, L_StdFrm, L_DatTim,
        L_dwh, L_Excel, Math, P_Man, P_Firm, dwhIFunc, L_Prop, L_SysLog, L_AFM, L_OwnData, L_WDO;

 TYPE
  tWindowMode     = SCAL[4];
  tBtnExprBuilder = SCAL[3];

 CONST
  wm_View        = 0;
  wm_Ask_Usual   = 1;
  wm_Ask_hParent = 2;
  wm_Ask_hEqual  = 3;

  btn_Cancel = 0; (* tBtnExprBuilder *)
  btn_Save   = 1;
  btn_Clear  = 2;
  buttons    = "|||||||||||%<  ࠭   >B %<    >B %<   ⬥   >X|";

  separators_pool = "+-*/()";

 PRIVATE PROCEDURE AccessDWH();
 BEGIN
  L_General.Assert(ACCESS(DWH), " । ⥪騩 ");
 END {AccessDWH};

 PRIVATE PROCEDURE AccessDWHP();
 BEGIN
  L_General.Assert(ACCESS(DWHP), " । ⥪ ࠭");
 END {AccessDWHP};

 PRIVATE PROCEDURE CheckStringLegChars_Strong(_Str, LegChar, PrefMsg, SuffMsg: STRING[]);
  VAR
   i,
   Result,
   Num     : NUMERIC[0];
   low,
   hig,
   _LegChar: STRING[];
 BEGIN
  _Str := Str.Cap(_Str);
  i:=0;
  WHILE i < Str.Length(_Str) DO
   SETZERO(Num, Result);
   LOOP
    _LegChar:=Str.Item(LegChar, "|", Num);
    IF !_LegChar THEN
     EXIT;
    END;
    low:=Str.Slice(_LegChar, 0, 1);
    IF Str.Length(_LegChar) = 1 THEN
     hig:=low;
    ELSE
     hig:=Str.Slice(_LegChar, 1, 1);
    END;
    IF (Str.Slice(_Str, i, 1)<low) | (Str.Slice(_Str, i, 1)>hig) THEN
     INC(Result);
    END;
    INC(Num);
   END; (* LOOP ... *)
   L_General.Assert(Result # Num, PrefMsg + " '" + _Str[i] + "' " + SuffMsg);
   INC(i);
  END; (* WHILE i < ... *)
 END {CheckStringLegChars_Strong};

 PRIVATE PROCEDURE dwhI_SetFieldModifiable();
  VAR
   Fields: FORMFIELDS;
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  Fields("dwhI.Formula").Modifiable :=dwhI.Calc & (dwhI.Origin # L_dwh.dwhiorig_Sys);
  Fields("dwhI.MustPlan").Modifiable:=~dwhI.Calc;
  Fields("dwhI.MustFact").Modifiable:=~dwhI.Calc;
  Fields("dwhI.Unit").Modifiable    :=dwhI.Origin # L_dwh.dwhiorig_Sys;
  Fields("dwhI.Name").Modifiable    :=dwhI.Origin # L_dwh.dwhiorig_Sys;
  Fields("dwhI.ShortN").Modifiable  :=dwhI.Origin # L_dwh.dwhiorig_Sys;
  Fields("dwhI.Identif").Modifiable :=dwhI.Origin # L_dwh.dwhiorig_Sys;
  Fields("dwhI.Calc").Modifiable    :=dwhI.Origin # L_dwh.dwhiorig_Sys;
  Fields("dwhI.MthCalc").Modifiable :=~dwhI.Calc;
 END {dwhI_SetFieldModifiable};

 PRIVATE PROCEDURE dwhIE_0_OnZoneOpen();
  VAR
   Fields: FORMFIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("dwhI.Type").Format      :=L_dwh.dwhiType_Pool;
  Fields("dwhI.Type").Template    :=L_dwh.dwhiType_Pool;
  Fields("dwhI.MthCalc").Format   :=L_dwh.MC_Pool;
  Fields("dwhI.MthCalc").Template :=L_dwh.MC_Pool;
  Fields("dwhI.MthAdd").Format    :=L_dwh.MA_Pool;
  Fields("dwhI.MthAdd").Template  :=L_dwh.MA_Pool;
  Fields("dwhI.Origin").Format    :=L_dwh.dwhiorig_Pool;
  Fields("dwhI.Origin").Template  :=L_dwh.dwhiorig_Pool;
  Fields("dwhI.SpecCond").Format  :=L_dwh.dwhiSC_Pool;
  Fields("dwhI.SpecCond").Template:=L_dwh.dwhiSC_Pool;
 END {dwhIE_0_OnZoneOpen};

 PRIVATE PROCEDURE dwhI_OnReposition();
 BEGIN
  IF ACCESS(dwhI) THEN
   dwhI_SetFieldModifiable();
  END;
 END {dwhI_OnReposition};

 PRIVATE PROCEDURE dwhSP_OnReposition();
 BEGIN
  IF ACCESS(dwhSP) THEN
   dwhSP_SetFieldModifiable();
  END;
 END {dwhSP_OnReposition};

 PRIVATE PROCEDURE dwhI_Identif_OnSuccessfulChange();
 BEGIN
  CheckStringLegChars_Strong(dwhI.Identif[0], "|AZ", "䨪   稭 ", "");
  CheckStringLegChars_Strong(dwhI.Identif, "|AZ|09", "", " 饭");
  Check_All_dwhI_Formula();
 END {dwhI_Identif_OnSuccessfulChange};

 PRIVATE PROCEDURE dwhSP_Identif_OnSuccessfulChange();
 BEGIN
  CheckStringLegChars_Strong(dwhSP.Identif[0], "|AZ", "䨪   稭 ", "");
  CheckStringLegChars_Strong(dwhSP.Identif, "|AZ|09", "", " 饭");
  Check_All_dwhSP_Formula();
 END {dwhSP_Identif_OnSuccessfulChange};

 PRIVATE PROCEDURE dwhI_Calc_OnSuccessfulChange();
 BEGIN
  dwhI_SetFieldModifiable();
  IF dwhI.Calc THEN
   SETEMPTY(dwhI.MustPlan, dwhI.MustFact, dwhI.MthCalc);
  ELSE
   SETEMPTY(dwhI.Formula);
  END;
  dwhI.NumCycle:=0;
  REPLACE(dwhI);
 END {dwhI_Calc_OnSuccessfulChange};

  PRIVATE PROCEDURE dwhSP_SetFieldModifiable();
   VAR
    Fields: FORMFIELDS;
  BEGIN
   Fields:=RTI.Get().CurWindow.Zones(0).Fields;
   Fields("dwhSP.Formula").Modifiable:=dwhSP.Calc;
   Fields("dwhSP.PlCanBe").Modifiable:=~dwhSP.Calc;
  END {dwhSP_SetFieldModifiable};

 PRIVATE PROCEDURE dwhSP_Calc_OnSuccessfulChange();
 BEGIN
  dwhSP_SetFieldModifiable();
  IF ~dwhSP.Calc THEN
   SETEMPTY(dwhSP.Formula);
  ELSE
   SETEMPTY(dwhSP.PlCanBe);
  END;
  dwhSP.NumCycle:=0;
  REPLACE(dwhSP);
 END {dwhSP_Calc_OnSuccessfulChange};

 PRIVATE PROCEDURE dwhI_OnBeforeInsert();
 BEGIN
  dwhI.Calc    :=0;
  dwhI.NumCycle:=0;
  dwhI.SpecCond:=L_dwh.dwhiSC_No;
  dwhI.Origin  :=L_dwh.dwhiorig_Opr;
  REPLACE(dwhI);
  dwhI_SetFieldModifiable();
 END {dwhI_OnBeforeInsert};

 PRIVATE PROCEDURE GetdwhIConsist(trg_dwhI: LIKE(dwhI.dwhI)): STRING[];
  VAR
   SubStr : STRING[];
   i      : NUMERIC[0];
   Consist: STRING[];
 BEGIN
  L_General.CallUs(SEARCH(dwhI, dwhI, trg_dwhI));
  i:=0;
  SETEMPTY(Consist);
  REPEAT
   SubStr:=Str.Item(dwhI.Formula, separators_pool, i);
   SAVE(dwhI);
   IF ~!SubStr & ~ThisIsFloat(SubStr) & SEARCH(dwhI, Identif, SubStr) THEN
    Consist:=Consist + SubStr + "|";
   END;
   RESTORE(dwhI);
   INC(i);
  UNTIL !SubStr;
  RETURN Consist;
 END {GetdwhIConsist};

 PRIVATE PROCEDURE dwhI_OnBeforeDelete();
  VAR
   trgIdentif: LIKE(dwhI.Identif);
   trgShortN : LIKE(dwhI.ShortN);
   trg_dwhI  : LIKE(dwhI.dwhI);
   Consist   : STRING[];
 BEGIN
  L_dwh.CheckdwhIIsNotSys();

  trgIdentif:=dwhI.Identif;
  trgShortN :=dwhI.ShortN;
  trg_dwhI  :=dwhI.dwhI;
  SAVE(dwhI);
  SELECT(dwhI, dwhI);
  WHILE OCCURE(dwhI) DO
   IF dwhI.Calc THEN
    L_General.Assert(!L_Str.PositionInPool(GetdwhIConsist(dwhI.dwhI), trgIdentif),
                     " " + trg_dwhI + " '" + trgShortN + "' ᯮ  㫥  ᫥|" +
                     "祭  " + dwhI.dwhI + " '" + dwhI.ShortN + "'.|" +
                     " 饭");
   END;
   NEXT(dwhI);
  END; (* WHILE OCCURE(dwhI) ... *)
  RESTORE(dwhI);

  IF SELECT(dwhSI, dwhI, dwhI.dwhI) THEN
   CONFORM(dwhSI, dwhS);
   L_General.Error(" ᯮ  ப ᯥ䨪樨  " + dwhS.dwhS + " '" + dwhS.Name + "'");
  END;
 END {dwhI_OnBeforeDelete};

 PRIVATE PROCEDURE GetdwhIList(VAR List, Name : STRING[]; VAR Cnt: NUMERIC[0]);
  VAR
   CurIdentif: STRING[];
 BEGIN
  SAVE(dwhI);
  Cnt:=0;
  CurIdentif:=dwhI.Identif;
  SETEMPTY(List, Name);
  SELECT(dwhI, Identif);
  WHILE OCCURE(dwhI) DO
   IF dwhI.Identif # CurIdentif THEN
    INC(List, Str.Align(dwhI.Identif, 16, LEFT) + dwhI.ShortN + "|");
    INC(Name, dwhI.Identif + "|");
    INC(Cnt);
   END;
   NEXT(dwhI);
  END; (* WHILE OCCURE(dwhI) ... *)
  RESTORE(dwhI);
 END {GetdwhIList};

 PRIVATE PROCEDURE ThisIsFloat(_Str: STRING[]): SCAL[2];
 BEGIN
  RETURN L_Prop.IsNumericValue(_Str, "");
 END {ThisIsFloat};

 PRIVATE PROCEDURE CntCharsInStr(_Str: STRING[]; Chr: STRING[1]): NUMERIC[0];
  VAR
   i,
   lng,
   Result: NUMERIC[0];
 BEGIN
  SETZERO(Result, i);
  lng:=Str.Length(_Str);
  WHILE i < lng DO
   IF _Str[i] = Chr[0] THEN
    INC(Result);
   END;
   INC(i);
  END; (* WHILE i < ... *)
  RETURN Result;
 END {CntCharsInStr};

 PRIVATE PROCEDURE CheckCycleRef(_Formula, _Identif, _File: STRING[]);
  VAR
   i     : NUMERIC[0];
   SubStr: STRING[];
 BEGIN
  i:=0;
  LOOP
   SubStr:=Str.Item(_Formula, separators_pool, i);
   IF !SubStr THEN
    EXIT;
   END;
   IF ~ThisIsFloat(SubStr) THEN
    SAVE(^(_File));
    IF _File = "dwhI" THEN
     SEARCH(^(_File), Identif, , SubStr);
    ELSE
     SEARCH(^(_File), Identif, , dwhSP.dwhSPSet, SubStr);
    END;
    L_General.Assert(SubStr # _Identif, "ࠦ ᮤন 横 뫪");
    CheckCycleRef(^(L_DBD.GetFieldName(_File, "Formula")), _Identif, _File);
    RESTORE(^(_File));
   END;
   INC(i);
  END; (* LOOP ... *)
 END {CheckCycleRef};

 PRIVATE PROCEDURE SyntacticAnalysisFormula(_Formula                   : STRING[];
                                            NameMem                    : STRING[];
                                            StrongPoolString           : STRING[];
                                            StrongPoolFirstCharInString: STRING[];
                                            _Identif                   : STRING[]);

  VAR
   i,
   _Pos,
   LngFormula,
   CntBrackL,
   CntBrackR  : NUMERIC[0];
   SubStr     : STRING[];
 BEGIN
  CheckStringLegChars_Strong(_Formula, StrongPoolString, "", " 饭");
  CheckStringLegChars_Strong(_Formula[0], StrongPoolFirstCharInString, "㫠   稭 ", "");
  LngFormula:=Str.Length(_Formula);
  CheckStringLegChars_Strong(_Formula[LngFormula-1], "|AZ|09|)", "㫠   稢 ", "");
  SETZERO(i, CntBrackL, CntBrackR);
  WHILE i < LngFormula DO
   IF _Formula[i] = "(" THEN
    INC(CntBrackL);
   ELSIF _Formula[i] = ")" THEN
    INC(CntBrackR);
    L_General.Assert(CntCharsInStr(Str.Slice(_Formula, 0, i), "(") >= CntCharsInStr(Str.Slice(_Formula, 0, i + 1), ")"),
                     "㤠 ')' ࠭ '('");
   END;
   INC(i);
  END; (* WHILE i < ... *)
  L_General.Assert(CntBrackL = CntBrackR, "⢮ 뢠  뢠 ᪮ .. ");
  i:=0;
  LOOP
   SubStr:=Str.Item(_Formula, separators_pool, i);
   IF !SubStr THEN
    EXIT;
   END;
   L_General.Assert(ThisIsFloat(SubStr) | ~!L_Str.PositionInPool(NameMem, SubStr),
                    " 㫥 '" + _Formula + "'  '" + _Identif + "'|   '" + SubStr + "'");
   _Pos:=Str.ItemPos(_Formula, separators_pool, i) + Str.Length(SubStr);
   IF _Pos < LngFormula THEN
    CheckStringLegChars_Strong(_Formula[_Pos], ")|*+|-|/", "", "᫥ '" + SubStr + "' ⨬");
   END;
   INC(i);
  END; (* LOOP ... *)
 END {SyntacticAnalysisFormula};

 PRIVATE PROCEDURE Check_dwhI_Formula();
  VAR
   i,
   DummyNum,
   _NumCycle : NUMERIC[0];
   Dummy,
   trgFormula,
   NameMem,
   SubStr     : STRING[];
   DummyFloat : NUMERIC[2];
 BEGIN
  IF (~!dwhI.Formula) THEN
   trgFormula:= dwhI.Formula;
   GetdwhIList(Dummy, NameMem, DummyNum);
   SyntacticAnalysisFormula(trgFormula, NameMem, "|AZ|09|()|*+|-|.|/", "|AZ|09|(|-", dwhI.Identif);
   CheckCycleRef(trgFormula, dwhI.Identif, "dwhI");

   i:=0;
   _NumCycle:=0;
   Dummy:=trgFormula;
   LOOP
    SubStr:=Str.Item(trgFormula, separators_pool, i);
    IF !SubStr THEN
     EXIT;
    END;
    SAVE(dwhI);
    IF (~ThisIsFloat(SubStr)) & SELECT(dwhI, Identif, SubStr) & (dwhI.NumCycle>=_NumCycle) THEN
     _NumCycle:= dwhI.NumCycle + 1;
    END;
    RESTORE(dwhI);
    Dummy:=Str.Replace(Dummy, SubStr, "1");
    INC(i);
   END; (* LOOP ... *)
   TRY
    DummyFloat:=^Dummy;
   EXCEPT
   ON Exc: Exc_Syntax DO
    L_General.Error("ࠦ ᮤন 訡");
   END;

   IF _NumCycle # dwhI.NumCycle THEN
    dwhI.NumCycle:=_NumCycle;
    REPLACE(dwhI);
   END;
  END; (* IF (~!dwhI.Formula) *)
 END {Check_dwhI_Formula};

 PRIVATE PROCEDURE PeriodStr(PerB, PerE: DATE): STRING[];
 BEGIN
  RETURN " " + L_DatTim.PeriodStr(PerB) + "  " + L_DatTim.PeriodStr(PerE);
 END {PeriodStr};

 PRIVATE PROCEDURE Check_dwhSP_Formula();
  VAR
   i,
   DummyNum,
   _NumCycle : NUMERIC[0];
   Dummy,
   trgFormula,
   NameMem,
   SubStr     : STRING[];
   DummyFloat : NUMERIC[2];
   trgBegin,
   trgTill    : DATE;
   trg_dwhSP  : LIKE(dwhSP.dwhSP);
   trgName    : LIKE(dwhSP.Name);
 BEGIN
  IF (~!dwhSP.Formula) THEN
   trgFormula:= dwhSP.Formula;
   trgBegin  :=dwhSP.Begin;
   trgTill   :=dwhSP.Till;
   trg_dwhSP :=dwhSP.dwhSP;
   trgName   :=dwhSP.Name;
   GetdwhSPList(Dummy, NameMem, DummyNum);
   SyntacticAnalysisFormula(trgFormula, NameMem, "|AZ|09|+|-", "|AZ|09", dwhSP.Identif);
   CheckCycleRef(trgFormula, dwhSP.Identif, "dwhSP");

   i:=0;
   _NumCycle:=0;
   Dummy:=trgFormula;
   LOOP
    SubStr:=Str.Item(trgFormula, separators_pool, i);
    IF !SubStr THEN
     EXIT;
    END;
    L_General.Assert(~ThisIsFloat(SubStr), "ᯮ짮 ᫮ ⠭  㫠  ᫥|" +
                                           "⮢ ᢮ ࠭ ⨬");
    SAVE(dwhSP);
    IF SELECT(dwhSP, Identif, dwhSP.dwhSPSet, SubStr) & (dwhSP.NumCycle>=_NumCycle) THEN
     IF ~L_DatTim.IsActiveInIntvl(trgBegin, trgTill, dwhSP.Begin, dwhSP.Till) THEN
      L_StdFrm.OrdinaryCHOICE("࠭-᫠|" + dwhSP.dwhSP + " '" + dwhSP.Name + "'|" +
                              "  ⨢  ਮ ਬ 塞 ࠭|" +
                              trg_dwhSP + " '" + trgName + "'|" +
                              PeriodStr(trgBegin, trgTill));
     END;
     _NumCycle:= dwhSP.NumCycle + 1;
    END;
    RESTORE(dwhSP);
    Dummy:=Str.Replace(Dummy, SubStr, "1");
    INC(i);
   END; (* LOOP ... *)
   TRY
    DummyFloat:=^Dummy;
   EXCEPT
   ON Exc: Exc_Syntax DO
    L_General.Error("ࠦ ᮤন 訡");
   END;

   IF _NumCycle # dwhSP.NumCycle THEN
    dwhSP.NumCycle:=_NumCycle;
    REPLACE(dwhSP);
   END;
  END; (* IF (~!dwhSP.Formula) *)
 END {Check_dwhSP_Formula};

 PRIVATE PROCEDURE Check_All_dwhI_Formula();
 BEGIN
  Check_dwhI_Formula();
  SAVE(dwhI);
  SELECT(dwhI, NumCycle, , 1);
  WHILE OCCURE(dwhI) DO
   Check_dwhI_Formula();
   NEXT(dwhI);
  END; (* WHILE OCCURE(dwhI) ... *)
  RESTORE(dwhI);
 END {Check_All_dwhI_Formula};

 PRIVATE PROCEDURE Check_All_dwhSP_Formula();
 BEGIN
  Check_dwhSP_Formula();
  SAVE(dwhSP);
  SELECT(dwhSP, NumCycle, , dwhSP.dwhSPSet, 1);
  WHILE OCCURE(dwhSP) DO
   Check_dwhSP_Formula();
   NEXT(dwhSP);
  END; (* WHILE OCCURE(dwhSP) ... *)
  RESTORE(dwhSP);
 END {Check_All_dwhSP_Formula};

 PRIVATE PROCEDURE GetExpressionBuilderResult(    ListMem : STRING[];
                                                  NameMem : STRING[];
                                                  CntMem  : NUMERIC[0];
                                              VAR _Formula: STRING[]   ): tBtnExprBuilder;
  VAR
   Result: tBtnExprBuilder;
   MemNum: NUMERIC[0];
 BEGIN
  Result:=btn_Cancel;
  LOOP
   MemNum:=-1;
   Result:=STDFORM(Str.Align("㫠:", 40, LEFT) + "|%L40,5I||||||" + Str.Align("㯭  㫥 :", 40, LEFT) + "|%40,10AI" + buttons , " ந⥫ ࠦ ", , , _Formula, ListMem, MemNum);
   IF (MemNum > -1) & (MemNum < CntMem) THEN
    _Formula := _Formula + L_Str.PoolItem(NameMem, MemNum);
   ELSE
    IF (Result = btn_Clear) THEN
     SETEMPTY(_Formula);
    ELSE
     EXIT;
    END;
   END;
  END; (* LOOP ... *)
  RETURN Result;
 END {GetExpressionBuilderResult};

 PRIVATE PROCEDURE dwhI_Formula_OnBeforeAskForEdit();
  VAR
   CntMem  : NUMERIC[0];
   trgFormula,
   ListMem,
   NameMem : STRING[];
 BEGIN
  trgFormula := dwhI.Formula;
  GetdwhIList(ListMem, NameMem, CntMem);
  L_General.Assert(CntMem#0, "  㯭 ");
  IF GetExpressionBuilderResult(ListMem, NameMem, CntMem, trgFormula) = btn_Save THEN
   dwhI.Formula:=trgFormula;
   REPLACE(dwhI);
   Check_All_dwhI_Formula();
  END;
 END {dwhI_Formula_OnBeforeAskForEdit};

 PRIVATE PROCEDURE dwhI_Formula_OnSuccessfulChange();
 BEGIN
  Check_All_dwhI_Formula();
 END {dwhI_Formula_OnSuccessfulChange};

 PRIVATE PROCEDURE GetdwhSPList(VAR List, Name : STRING[]; VAR Cnt: NUMERIC[0]);
  VAR
   CurIdentif: STRING[];
 BEGIN
  SAVE(dwhSP);
  Cnt:=0;
  CurIdentif:=dwhSP.Identif;
  SETEMPTY(List, Name);
  SELECT(dwhSP, Identif, , dwhSP.dwhSPSet);
  WHILE OCCURE(dwhSP) DO
   IF dwhSP.Identif # CurIdentif THEN
    INC(List, Str.Align(dwhSP.Identif, 16, LEFT) + Str.Align(dwhSP.Name, 32, LEFT) + "|");
    INC(Name, dwhSP.Identif + "|");
    INC(Cnt);
   END;
   NEXT(dwhSP);
  END; (* WHILE OCCURE(dwhSP) ... *)
  RESTORE(dwhSP);
 END {GetdwhSPList};

 PRIVATE PROCEDURE dwhSP_Formula_OnBeforeAskForEdit();
  VAR
   CntMem  : NUMERIC[0];
   trgFormula,
   ListMem,
   NameMem : STRING[];
 BEGIN
  trgFormula := dwhSP.Formula;
  GetdwhSPList(ListMem, NameMem, CntMem);
  L_General.Assert(CntMem#0, "  㯭 ");
  IF GetExpressionBuilderResult(ListMem, NameMem, CntMem, trgFormula) = btn_Save THEN
   dwhSP.Formula:=trgFormula;
   REPLACE(dwhSP);
   Check_All_dwhSP_Formula();
  END;
 END {dwhSP_Formula_OnBeforeAskForEdit};

 PRIVATE PROCEDURE dwhSP_Formula_OnSuccessfulChange();
 BEGIN
  Check_All_dwhSP_Formula();
 END {dwhSP_Formula_OnSuccessfulChange};

 PRIVATE PROCEDURE ReplicateCurdwhIToDWHPL(OnlyReplicate: SCAL[2]);
 BEGIN
  IF SELECT(DWHPL, dwhI, dwhI.dwhI) THEN
   WHILE OCCURE(DWHPL) DO
    IF (DWHPL.Type # dwhI.Type)         |
       (DWHPL.MthCalc # dwhI.MthCalc)   | (DWHPL.MthAdd # dwhI.MthAdd) |
       (DWHPL.NumCycle # dwhI.NumCycle) | (DWHPL.Calc # dwhI.Calc)     |
       (GE_PVALUE(dwhI.Formula) # dwhI.Formula) |
       (GE_PVALUE(dwhI.SpecCond) # dwhI.SpecCond) THEN
     DWHPL.Type    :=dwhI.Type;
     DWHPL.MthCalc :=dwhI.MthCalc;
     DWHPL.MthAdd  :=dwhI.MthAdd;
     DWHPL.NumCycle:=dwhI.NumCycle;
     DWHPL.Calc    :=dwhI.Calc;
     REPLACE(DWHPL);
     IF ~OnlyReplicate THEN
      CONFORM(DWHPL, DWHP);
      ChangeCurDWHPState(L_dwh.ste_Prepared, 1);
      ApplyStateDWHPToDependentDWHP();
     END;
    END;
    NEXT(DWHPL);
   END; (* WHILE OCCURE(DWHPL) ... *)
  END;
 END {ReplicateCurdwhIToDWHPL};

 PRIVATE PROCEDURE IsRequired(): SCAL[2];
 BEGIN
  RETURN ~dwhSP.Calc & ~dwhI.Calc & DWHPL.IsPrimary & (dwhI.Origin = L_dwh.dwhiorig_Opr);
 END {IsRequired};

 PRIVATE PROCEDURE PlanIsRequired(): SCAL[2];
 BEGIN
  IF ~dwhSP.Calc & ~dwhSP.PlCanBe THEN
   SETEMPTY(DWHPL.PlanSys, DWHPL.PlanOper);
  END;
  RETURN IsRequired() & dwhSP.PlCanBe & (dwhI.MustPlan = L_dwh.mstPln_Required);
 END {PlanIsRequired};

 PRIVATE PROCEDURE FactIsRequired(): SCAL[2];
 BEGIN
  RETURN IsRequired() & (dwhI.MustFact = L_dwh.mstFct_Required);
 END {FactIsRequired};

 PRIVATE PROCEDURE dwhI_OnAfterEdit();
 BEGIN
  ReplicateCurdwhIToDWHPL((GE_PVALUE(dwhI.Formula)  = dwhI.Formula)   &
                          (GE_PVALUE(dwhI.MthCalc)  = dwhI.MthCalc)   &
                          (GE_PVALUE(dwhI.SpecCond) = dwhI.SpecCond) );
  SELECT(DWHPL, dwhI, , dwhI.dwhI);
  WHILE OCCURE(DWHPL) DO
   PROMPT("䨪 ᫮ 室  ப  (, ࠭, ப):" +
          DWHPL.DWH + ", " + DWHPL.DWHP + ", " + DWHPL.DWHPL);
   L_General.CallUs(SEARCH(dwhSP, dwhSPSet, DWHPL.dwhSPSet, DWHPL.dwhSP));
   DWHPL.PlanIsReq:=PlanIsRequired();
   DWHPL.FactIsReq:=FactIsRequired();
   REPLACE(DWHPL);
   NEXT(DWHPL);
  END; (* WHILE OCCURE(DWHPL) ... *)
 END {dwhI_OnAfterEdit};

 PRIVATE PROCEDURE dwhS_OnBeforeInsert();
 BEGIN
  dwhS.Begin:=L_DatTim.MINDATE();
  REPLACE(dwhS);
 END {dwhS_OnBeforeInsert};

 PRIVATE PROCEDURE CheckNotZerodwhSArrPer();
  VAR
   i: NUMERIC[0];
 BEGIN
  L_General.CallUs(ACCESS(dwhS));
  SETZERO(i);
  WHILE i < L_dwh.period_Amount DO
   IF dwhS.ArrPer[i] THEN
    RETURN;
   END;
   INC(i);
  END;
  L_General.Error("  㯭 ਮ ନ஢  ");
 END {CheckNotZerodwhSArrPer};

 PRIVATE PROCEDURE dwhS_OnAfterEdit();
  VAR
   i             : NUMERIC[0];
   _CntMonthInPer: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i < L_dwh.period_Amount DO
   IF GE_PVALUE(dwhS.ArrPer[i]) & (GE_PVALUE(dwhS.ArrPer[i]) # dwhS.ArrPer[i]) THEN
    _CntMonthInPer:=STRTOFLD(L_Str.PoolItem(L_dwh.pool_CntMonthInPer, i), NUMERIC, "0.");
    SELECT(DWH, dwhS, , dwhS.dwhS);
    WHILE OCCURE(DWH) DO
     L_General.Assert(L_DatTim.MonthsInIntvl(DWH.PerB, DWH.PerE) # _CntMonthInPer,
                      "  " + DWH.DWH + " ⮢  " + L_Str.PoolItem(L_dwh.pool_period, i) +
                      " (" + PeriodStr(DWH.PerB, DWH.PerE) + ")");
     NEXT(DWH);
    END; (* WHILE OCCURE(DWH) ... *)
   END;
   INC(i);
  END;
  CheckNotZerodwhSArrPer();
 END {dwhS_OnAfterEdit};

 PRIVATE PROCEDURE dwhS_OnAfterInsert();
 BEGIN
  CheckNotZerodwhSArrPer();
 END {dwhS_OnAfterInsert};

 PRIVATE PROCEDURE CurdwhIBydwhSIIsCalc(): LIKE(dwhI.Calc);
  VAR
   Result: LIKE(dwhI.Calc);
 BEGIN
  Result:=0;
  IF ACCESS(dwhSI) & ~!dwhSI.dwhI THEN
   CONFORM(dwhSI, dwhI);
   Result:=dwhI.Calc;
  END;
  RETURN Result;
 END {CurdwhIBydwhSIIsCalc};

 PRIVATE PROCEDURE dwhSE_0_OnZoneOpen();
  VAR
   Fields: FORMFIELDS;
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(1).Fields;
  Fields("dwhSP.Calc").Format    :=L_dwh.dwhCalc_Pool;
  Fields("dwhSP.Calc").Template  :=L_dwh.dwhCalc_Pool;
  Fields:=RTI.Get().CurWindow.Zones(2).Fields;
  Fields("dwhSI.Format").Format  :=L_dwh.pool_dwhSIWDOFormat;
  Fields("dwhSI.Format").Template:=L_dwh.pool_dwhSIWDOFormat;
 END {dwhSE_0_OnZoneOpen};

 PRIVATE PROCEDURE GetNEWdwhSINumber(): NUMERIC[0];
  VAR
   NewNumber: NUMERIC[0];
 BEGIN
  NewNumber:=0;
  SAVE(dwhSI);
  ACCESS(dwhS);
  SELECT(dwhSI, Number, , dwhS.dwhS);
  WHILE OCCURE(dwhSI) DO
   IF ~!dwhSI.Number & (dwhSI.Number > NewNumber) THEN
    NewNumber:=dwhSI.Number;
   END;
   NEXT(dwhSI);
  END; (* WHILE OCCURE(dwhSI) ... *)
  RESTORE(dwhSI);
  RETURN NewNumber - Math.Mod(NewNumber, 100) + 100;
 END {GetNEWdwhSINumber};

 PRIVATE PROCEDURE Get_dwhSI_Primary_dwhS(): LIKE(dwhS.dwhS);
  VAR
   curBegin: DATE;
   curTill : DATE;
   Result  : LIKE(dwhS.dwhS);
 BEGIN
  SETEMPTY(Result);
  IF ~dwhSI.IsPrimary THEN
   curBegin   :=dwhSI.Begin;
   curTill    :=dwhSI.Till;
   SAVE(dwhSI);
   SELECT(dwhSI, IsPrimary, , dwhSI.dwhSPSet, 1, dwhSI.dwhI);
   WHILE OCCURE(dwhSI) DO
    IF L_DatTim.IsActiveInIntvl(curBegin, curTill, dwhSI.Begin, dwhSI.Till) THEN
     IF ~!Result THEN
      CONFORM(dwhSI, dwhI);
      CONFORM(dwhSI, dwhS);
      L_General.Error(" " + dwhI.dwhI + " " + dwhI.Name +
                      "||㦥 祭  ⢥ ࢨ筮  ᯥ䨪 " +
                      "||"  + dwhS.dwhS + " " + dwhS.Name);
     END;
     Result:=dwhSI.dwhS;
    END;
    NEXT(dwhSI);
   END;
   RESTORE(dwhSI);
   IF !Result THEN
    CONFORM(dwhSI, dwhI);
    L_General.Error(" " + dwhI.dwhI + " " + dwhI.Name +
                    "|| 祭  ⢥ ࢨ筮    ᯥ䨪 ");
   END;
  ELSE
   Result:=dwhSI.dwhS;
  END; (* IF ~dwhSI.IsPrimary *)
  RETURN Result;
 END {Get_dwhSI_Primary_dwhS};

 PRIVATE PROCEDURE CheckIsPrimary(Operation: L_SysLog.tKind);
  VAR
   dummy_dwhS: LIKE(dwhS.dwhS);
 BEGIN
  TRY
   TRY
    IF    Operation = L_SysLog.knd_Delete THEN
     IF dwhSI.IsPrimary THEN
      dwhSI.IsPrimary:=0;
      REPLACE(dwhSI);
     END;
    END;
    dummy_dwhS:=Get_dwhSI_Primary_dwhS();
   EXCEPT
   ON Exc: Exc_Raise DO
    L_StdFrm.JustQuestion(Exc.MsgOriginalText);
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
 END {CheckIsPrimary};

 PRIVATE PROCEDURE dwhSI_IsPrimary_OnSuccessfulChange();
 BEGIN
  CheckIsPrimary(L_SysLog.knd_Edit);
 END {dwhSI_IsPrimary_OnSuccessfulChange};

 PRIVATE PROCEDURE Compare2dwhsIFormats(PrimFormat,
                                        NotPrimFormat : LIKE(dwhSI.Format);
                                        Prim_dwhISN   : LIKE(dwhI.ShortN);
                                        Prim_dwhS     : LIKE(dwhS.dwhS);
                                        Prim_dwhSN    : LIKE(dwhS.Name);
                                        NotPrim_dwhISN: LIKE(dwhI.ShortN);
                                        NotPrim_dwhS  : LIKE(dwhS.dwhS);
                                        NotPrim_dwhSN : LIKE(dwhS.Name));

  VAR
   Compatible: SCAL[2];
 BEGIN
  IF PrimFormat = NotPrimFormat THEN
   Compatible:=1;
  ELSE
   IF    PrimFormat = L_dwh.dwhsIFrm_NumPrec1 THEN
    Compatible:= (NotPrimFormat = L_dwh.dwhsIFrm_NumPrec0);
   ELSIF PrimFormat = L_dwh.dwhsIFrm_NumPrec2 THEN
    Compatible:= (NotPrimFormat = L_dwh.dwhsIFrm_NumPrec1) |
                 (NotPrimFormat = L_dwh.dwhsIFrm_NumPrec0);
   ELSIF PrimFormat = L_dwh.dwhsIFrm_NumPrec3 THEN
    Compatible:= (NotPrimFormat = L_dwh.dwhsIFrm_NumPrec2) |
                 (NotPrimFormat = L_dwh.dwhsIFrm_NumPrec1) |
                 (NotPrimFormat = L_dwh.dwhsIFrm_NumPrec0);
   ELSE
    Compatible:=0;
   END;
  END;
  L_General.Assert(Compatible,
                   "ଠ ࢨ筮  '" + Prim_dwhISN + "'|" +
                   " ᯥ䨪樨 ࠭ " + Prim_dwhS + " '" + Prim_dwhSN +"'|" +
                   " ᮢ⨬  ଠ⮬  '" + NotPrim_dwhISN + "'|" +
                   " ᯥ䨪樨 ࠭ " + NotPrim_dwhS + " '" + NotPrim_dwhSN +"'");
 END {Compare2dwhsIFormats};

 PRIVATE PROCEDURE dwhSI_Format_OnSuccessfulChange();
  VAR
   tgrFormat : LIKE(dwhSI.Format);
   tgr_dwhISN: LIKE(dwhI.ShortN);
   tgr_dwhS  : LIKE(dwhS.dwhS);
   tgr_dwhSN : LIKE(dwhS.Name);
 BEGIN
  SAVE(dwhSI);
  SAVE(dwhI);
  SAVE(dwhS);
  CONFORM(dwhSI, dwhS);
  CONFORM(dwhSI, dwhI);
  tgrFormat :=dwhSI.Format;
  tgr_dwhISN:=dwhI.ShortN;
  tgr_dwhS  :=dwhS.dwhS;
  tgr_dwhSN :=dwhS.Name;
  IF dwhSI.IsPrimary THEN
   SELECT(dwhSI, IsPrimary, , dwhSI.dwhSPSet, 0, dwhSI.dwhI);
   WHILE OCCURE(dwhSI) DO
    CONFORM(dwhSI, dwhI);
    CONFORM(dwhSI, dwhS);
    Compare2dwhsIFormats(tgrFormat, dwhSI.Format, tgr_dwhISN, tgr_dwhS, tgr_dwhSN, dwhI.ShortN, dwhS.dwhS, dwhS.Name);
    NEXT(dwhSI);
   END; (* WHILE OCCURE(dwhSI) ... *)
  ELSE
   L_General.CallUs(SELECT(dwhSI, IsPrimary, dwhSI.dwhSPSet, 1, dwhSI.dwhI));
   SAVE(dwhI);
   SAVE(dwhS);
   CONFORM(dwhSI, dwhS);
   CONFORM(dwhSI, dwhI);
   Compare2dwhsIFormats(dwhSI.Format, tgrFormat, dwhI.ShortN, dwhS.dwhS, dwhS.Name, tgr_dwhISN, tgr_dwhS, tgr_dwhSN);
   L_General.CallUs(~NEXT(dwhSI));
   RESTORE(dwhS);
   RESTORE(dwhI);
  END;
  RESTORE(dwhS);
  RESTORE(dwhI);
  RESTORE(dwhSI);
 END {dwhSI_Format_OnSuccessfulChange};

 PRIVATE PROCEDURE dwhSI_OnBeforeInsert();
 BEGIN
  dwhSI.Number  :=GetNEWdwhSINumber();
  dwhSI.dwhSPSet:=dwhS.dwhSPSet;
  REPLACE(dwhSI);
 END {dwhSI_OnBeforeInsert};

 PRIVATE PROCEDURE HasOtherActualdwhSI(trgBegin, trgTill: DATE): SCAL[2];
  VAR
   Result   : SCAL[3];
   trg_dwhS : LIKE(dwhSI.dwhS);
   trg_dwhSI: LIKE(dwhSI.dwhSI);
 BEGIN
  trg_dwhS :=dwhSI.dwhS;
  trg_dwhSI:=dwhSI.dwhSI;
  Result:=0;
  SAVE(dwhSI);
  SELECT(dwhSI, dwhI, , dwhSI.dwhI, trg_dwhS);
  WHILE OCCURE(dwhSI) & ~Result DO
   IF    L_DatTim.IsActiveInIntvl(trgBegin, trgTill, dwhSI.Begin, dwhSI.Till) THEN
    Result:=~((trg_dwhS=dwhSI.dwhS) & (trg_dwhSI=dwhSI.dwhSI));
   END;
   NEXT(dwhSI);
  END; (* WHILE OCCURE(dwhSI) ... *)
  RESTORE(dwhSI);
  RETURN Result;
 END {HasOtherActualdwhSI};

 PRIVATE PROCEDURE CheckHasOtherActualdwhSI();
 BEGIN
  CONFORM(dwhSI, dwhI);
  L_General.Assert(~HasOtherActualdwhSI(dwhSI.Begin, dwhSI.Till), " ६ 騥 ப ᯥ䨪樨|" +
                                                                  " ⮬ " + dwhI.dwhI + " '" + dwhI.ShortN + "'");
 END {CheckHasOtherActualdwhSI};

 PRIVATE PROCEDURE CheckHasAlldwhIFromFormulaInAnydwhS();
  VAR
   Consist     : STRING[];
   dwhSBegin,
   dwhSTill,
   trgBegin,
   trgTill     : DATE;
   trg_dwhI    : LIKE(dwhI.dwhI);
   i           : NUMERIC[0];
   Find        : SCAL[2];
   trgShortN   : LIKE(dwhI.ShortN);
   trg_dwhSPSet: LIKE(dwhSPSet.dwhSPSet);
   trgSPSetName: LIKE(dwhSPSet.Name);
   trgdwhS     : LIKE(dwhS.dwhS);
   trgdwhSName : LIKE(dwhS.Name);
 BEGIN
  trgBegin:=dwhSI.Begin;
  trgTill :=dwhSI.Till;
  SAVE(dwhSI);
  IF dwhI.Calc THEN
   Consist:=GetdwhIConsist(dwhI.dwhI);
   CONFORM(dwhSI, dwhS);
   CONFORM(dwhS, dwhSPSet);
   dwhSBegin   :=dwhS.Begin;
   dwhSTill    :=dwhS.Till;
   trgdwhS     :=dwhS.dwhS;
   trgdwhSName :=dwhS.Name;
   trg_dwhSPSet:=dwhSPSet.dwhSPSet;
   trgSPSetName:=dwhSPSet.Name;
   i:=0;
   WHILE ~!L_Str.PoolItem(Consist, i) DO
    SAVE(dwhI);
    L_General.CallUs(SEARCH(dwhI, Identif, L_Str.PoolItem(Consist, i)));
    trg_dwhI :=dwhI.dwhI;
    trgShortN:=dwhI.ShortN;
    RESTORE(dwhI);
    Find:=0;
    SAVE(dwhS);
    SELECT(dwhS, dwhSPSet, , trg_dwhSPSet);
    WHILE OCCURE(dwhS) & ~Find DO
     IF (dwhS.Begin = dwhSBegin) & (dwhS.Till = dwhSTill) THEN
      SELECT(dwhSI, dwhI, , trg_dwhI, dwhS.dwhS);
      WHILE OCCURE(dwhSI) & ~Find DO
       Find:=L_DatTim.InPatIntvl(dwhSI.Begin, dwhSI.Till, trgBegin, trgTill) & dwhSI.IsPrimary;
       NEXT(dwhSI);
      END; (* WHILE OCCURE(dwhSI) ... *)
     END;
     NEXT(dwhS);
    END; (* WHILE OCCURE(dwhS) ... *)
    RESTORE(dwhS);
    L_General.Assert(Find, " ᫥ 祭  " + dwhI.dwhI + " '" + dwhI.ShortN + "'|" +
                           "   ᯥ䨪樥 " + trgdwhS + " '" + trgdwhSName + "'|" +
                           "室 稥  " + trg_dwhI + " '" + trgShortN + "'|" +
                           "饣 " + PeriodStr(trgBegin, trgTill) + "|" +
                           " - ᯥ䨪樨 , ஥   ᯥ䨪権|" +
                           "࠭ " + trg_dwhSPSet + " '" + trgSPSetName + "'");
    INC(i);
   END;
  END; (* IF dwhI.Calc *)
  RESTORE(dwhSI);
 END {CheckHasAlldwhIFromFormulaInAnydwhS};

 PRIVATE PROCEDURE InsertCurdwhSIinDWH();
 BEGIN
  SAVE(DWHP);
  IF L_DatTim.IsActiveInIntvl(DWH.PerB, DWH.PerE, dwhSI.Begin, dwhSI.Till) THEN
   L_General.Assert(~HasOtherActualdwhSI(DWH.PerB, DWH.PerE),
                    " ਮ ⢨  " + DWH.DWH + " " + PeriodStr(DWH.PerB, DWH.PerE) + "|" +
                    " 2    " + dwhI.dwhI + " " + dwhI.ShortN);
   SELECT(DWHP, DWH, , DWH.DWH);
   WHILE OCCURE(DWHP) DO
    IF ~SELECT(DWHPL, dwhSI2, DWH.DWH, DWHP.DWHP, dwhSI.dwhSI) THEN
     SETEMPTY(DWHPL.DWHPL, DWHPL.PlanSys, DWHPL.FactSys, DWHPL.PlanOper, DWHPL.FactOper);
     DWHPL.DWH      := DWH.DWH;
     DWHPL.DWHP     := DWHP.DWHP;
     DWHPL.dwhS     := DWH.dwhS;
     DWHPL.dwhI     := dwhI.dwhI;
     DWHPL.dwhSI    := dwhSI.dwhSI;
     DWHPL.IsPrimary:= dwhSI.IsPrimary;
     DWHPL.dwhSPSet := DWHP.dwhSPSet;
     DWHPL.dwhSP    := DWHP.dwhSP;
     DWHPL.Calc     := dwhI.Calc;
     DWHPL.NumCycle := dwhI.NumCycle;
     DWHPL.Number   := dwhSI.Number;
     DWHPL.Type     := dwhI.Type;
     DWHPL.MthCalc  := dwhI.MthCalc;
     DWHPL.MthAdd   := dwhI.MthAdd;
     DWHPL.Format   := dwhSI.Format;
     L_General.CallUs(SEARCH(dwhSP, dwhSPSet, DWHPL.dwhSPSet, DWHPL.dwhSP));
     DWHPL.PlanIsReq:=PlanIsRequired();
     DWHPL.FactIsReq:=FactIsRequired();
     INSERT(DWHPL);
    END;
    NEXT(DWHP);
   END; (* WHILE OCCURE(DWHP) ... *)
  END;
  RESTORE(DWHP);
 END {InsertCurdwhSIinDWH};

 PRIVATE PROCEDURE dwhSI_OnAfterInsert();
 BEGIN
  CheckHasOtherActualdwhSI();
  CheckIsPrimary(L_SysLog.knd_Insert);
  CheckHasAlldwhIFromFormulaInAnydwhS();
  SELECT(DWH, dwhS, , dwhS.dwhS);
  WHILE OCCURE(DWH) DO
   InsertCurdwhSIinDWH();
   NEXT(DWH);
  END; (* WHILE OCCURE(DWH) ... *)
 END {dwhSI_OnAfterInsert};

 PRIVATE PROCEDURE ChangeCurDWHPState(newState: LIKE(DWHP.State); NeedInform: SCAL[2]);
 BEGIN
  DWHP.State:=newState;
  REPLACE(DWHP);
  SAVE(DWH);
  CONFORM(DWHP, DWH);
  IF (DWHP.State # L_dwh.ste_Calculate) & (DWH.Status = L_dwh.st_Passed) THEN
   DWH.Status:=L_dwh.st_Prepared;
   REPLACE(DWH);
   IF NeedInform THEN
    CONFORM(DWH, dwhS);
    STDMSG(" |" +
           DWH.DWH + " " + dwhS.Name +
           "|  '" + L_Str.PoolItem(L_dwh.st_Pool, L_dwh.st_Prepared) + "'| 裡  室 ", INFORM);
   END;
  END;
  RESTORE(DWH);
 END {ChangeCurDWHPState};

 PRIVATE PROCEDURE dwhSI_OnAfterEdit();
  VAR
   NeedAsk,
   FormatIsChange: SCAL[2];
   tgrState      : LIKE(DWHP.State);
   trgBegin,
   trgTill       : DATE;
   PeriodIsChange: SCAL[2];
   trgdwhSPSet   : LIKE(dwhSPSet.dwhSPSet);
   trgdwhS       : LIKE(dwhS.dwhS);
 BEGIN
  CheckHasOtherActualdwhSI();
  trgBegin   :=dwhSI.Begin;
  trgTill    :=dwhSI.Till;
  trgdwhSPSet:=dwhSI.dwhSPSet;
  trgdwhS    :=dwhSI.dwhS;
  FormatIsChange:=dwhSI.Format # GE_PVALUE(dwhSI.Format);
  PeriodIsChange:=(dwhSI.Till  # GE_PVALUE(dwhSI.Till)) | (dwhSI.Begin # GE_PVALUE(dwhSI.Begin));
  NeedAsk:=1;
  SELECT(DWH, dwhS, , dwhSI.dwhS);
  WHILE OCCURE(DWH) DO
   IF PeriodIsChange THEN
    InsertCurdwhSIinDWH();
   END;
   SELECT(DWHP, DWH, , DWH.DWH);
   WHILE OCCURE(DWHP) DO
    IF SEARCH(DWHPL, dwhSI2, DWH.DWH, DWHP.DWHP, dwhSI.dwhSI) THEN
     CONFORM(dwhSI, dwhI);
     L_General.Assert(L_General.IsLegalRecordModification("dwhSI", "Number|Format|Begin|Till"),
                      " " + dwhI.dwhI + " '" + dwhI.ShortN + "'|" +
                      "祭   " + DWHP.DWH + "  ਮ " + PeriodStr(DWHP.PerB, DWHP.PerE) + "|" +
                      "஢ ࠧ襭 ⮫쪮 : 'N', 'ଠ', 'C', ''");
     IF PeriodIsChange & ~L_DatTim.IsActiveInIntvl(DWHP.PerB, DWHP.PerE, trgBegin, trgTill) THEN
      L_General.Error(" ⠪  ਮ ਬ ப ᯥ䨪樨 ⮢ .|" +
                      " " + dwhI.dwhI + " '" + dwhI.ShortN + "'|" +
                      "祭   " + DWHP.DWH + "  ਮ " + PeriodStr(DWHP.PerB, DWHP.PerE));
     END;
     DWHPL.Number   :=dwhSI.Number;
     DWHPL.Format   :=dwhSI.Format;
     DWHPL.IsPrimary:=dwhSI.IsPrimary;
     REPLACE(DWHPL);
     IF FormatIsChange & ~DWHP.Calc THEN
      tgrState:=L_dwh.ste_Prepared;
      IF DWHP.State > tgrState THEN
       IF NeedAsk THEN
        L_General.CallUs(SEARCH(dwhSPSet, dwhSPSet, DWHP.dwhSPSet));
        L_StdFrm.JustQuestion("࠭ ⮢ , ஥   ᯥ䨪権|" +
                              dwhSPSet.dwhSPSet + " '" + dwhSPSet.Name + "'|" +
                              " ॢ  ﭨ '" + L_Str.PoolItem(L_dwh.ste_Pool, tgrState) + "'.|" +
                              "ਬ,   " + DWH.DWH);
        NeedAsk:=0;
       END;
       ChangeCurDWHPState(tgrState, 1);
       ApplyStateDWHPToDependentDWHP();
      END;
     END; (* IF FormatIsChange ... *)
    END; (* IF SEARCH(DWHPL ... *)
    NEXT(DWHP);
   END; (* WHILE OCCURE(DWHP) ... *)
   NEXT(DWH);
  END; (* WHILE OCCURE(DWH) ... *)

  CheckHasAlldwhIFromFormulaInAnydwhS();
  SELECT(dwhSI, IsPrimary, , trgdwhSPSet, 1);
  WHILE OCCURE(dwhSI) DO
   CONFORM(dwhSI, dwhI);
   CheckHasAlldwhIFromFormulaInAnydwhS();
   NEXT(dwhSI);
  END; (* WHILE OCCURE(dwhSI) ... *)
 END {dwhSI_OnAfterEdit};

 PRIVATE PROCEDURE dwhSI_OnBeforeDelete();
 BEGIN
  SELECT(DWH, dwhS, , dwhSI.dwhS);
  WHILE OCCURE(DWH) DO
   SELECT(DWHP, DWH, , DWH.DWH);
   WHILE OCCURE(DWHP) DO
    IF SEARCH(DWHPL, dwhSI2, DWH.DWH, DWHP.DWHP, dwhSI.dwhSI) THEN
     CONFORM(DWHPL, dwhI);
     L_General.Error(" " + dwhI.dwhI + " '" + dwhI.ShortN + "'|" +
                     "祭   " + DWHP.DWH + "  ਮ " + PeriodStr(DWHP.PerB, DWHP.PerE) + "|" +
                     " 饭");
    END;
    NEXT(DWHP);
   END; (* WHILE OCCURE(DWHP) ... *)
   NEXT(DWH);
  END; (* WHILE OCCURE(DWH) ... *)
  CheckIsPrimary(L_SysLog.knd_Delete);
 END {dwhSI_OnBeforeDelete};

 PRIVATE PROCEDURE dwhSP_OnBeforeInsert();
 BEGIN
  dwhSP.Calc    :=0;
  dwhSP.NumCycle:=0;
  REPLACE(dwhSP);
 END {dwhSP_OnBeforeInsert};

 PRIVATE PROCEDURE ApplyStateDWHPToDependentDWHP();
  VAR
   trgIdentif  : LIKE(DWHP.Identif);
   trg_dwhSPSet: LIKE(DWHP.dwhSPSet);
   trgState    : LIKE(DWHP.State);
   trgPerB,
   trgPerE     : DATE;
   trgDWH      : LIKE(DWH.DWH);
 BEGIN
  trgIdentif  :=DWHP.Identif;
  trg_dwhSPSet:=DWHP.dwhSPSet;
  trgState    :=DWHP.State;
  trgPerB     :=DWHP.PerB;
  trgPerE     :=DWHP.PerE;
  trgDWH      :=DWHP.DWH;
  SAVE(DWHP);
  SELECT(DWHP, dwhSPPer, , trg_dwhSPSet, trgPerB, trgPerE);
  WHILE OCCURE(DWHP) DO
   IF (DWHP.DWH = trgDWH) & DWHP.Calc & (DWHP.State > trgState) & (DWHP.Identif # trgIdentif) &
      ~!L_Str.PositionInPool(GetdwhSPConsist(DWHP.dwhSPSet, DWHP.dwhSP), trgIdentif) THEN
    ChangeCurDWHPState(trgState, 0);
    ApplyStateDWHPToDependentDWHP();
   END; (* IF DWHP.Calc *)
   NEXT(DWHP);
  END; (* WHILE OCCURE(DWHP) ... *)
  RESTORE(DWHP);
 END {ApplyStateDWHPToDependentDWHP};

 PRIVATE PROCEDURE ApplyChanges_dwhSP(ApplyStateOnly: SCAL[2]);
  VAR
   NeedAsk        : SCAL[2];
   NeedChangeState: SCAL[2];
 BEGIN
  IF ApplyStateOnly THEN
   NeedChangeState:=1;
  ELSE
   NeedChangeState:=~L_General.IsLegalRecordModification("dwhSP", "Name|Number|Begin|Till");
  END;
  NeedAsk:=1;
  SELECT(DWHP, dwhSP, , dwhSP.dwhSPSet, dwhSP.dwhSP);
  WHILE OCCURE(DWHP) DO
   IF NeedChangeState THEN
    IF DWHP.State # L_dwh.ste_Prepared THEN
     CONFORM(DWHP, DWH);
     IF NeedAsk THEN
      L_StdFrm.JustQuestion(" ᯥ䨪樨 " + dwhSP.dwhSP + "     ࠭  ﭨ '"  + L_Str.PoolItem(L_dwh.ste_Pool, DWHP.State) + "'.|" +
                            "ਬ, ࠭ '" + DWHP.Name + "'   " + DWH.DWH + ".|" +
                            "࠭  ॢ  ﭨ '" + L_Str.PoolItem(L_dwh.ste_Pool, L_dwh.ste_Prepared) + "'");
      NeedAsk:=0;
     END;
     ChangeCurDWHPState(L_dwh.ste_Prepared, 1);
     ApplyStateDWHPToDependentDWHP();
    END;
   END; (* IF NeedChangeState *)
   IF ~ApplyStateOnly THEN
    DWHP.Number :=dwhSP.Number;
    DWHP.Name   :=dwhSP.Name;
    DWHP.Identif:=dwhSP.Identif;
    DWHP.Calc   :=dwhSP.Calc;
    REPLACE(DWHP);
   END;
   NEXT(DWHP);
  END; (* WHILE OCCURE(DWHP) ... *)
 END {ApplyChanges_dwhSP};

 PRIVATE PROCEDURE dwhSP_OnAfterEdit();
  VAR
   trgdwhSPSet: LIKE(dwhSPSet.dwhSPSet);
   trgdwhSP   : LIKE(dwhSP.dwhSP);
   trgName    : LIKE(dwhSP.Name);
   trgBegin,
   trgTill    : DATE;
   NeedAsk    : SCAL[2];
 BEGIN
  trgdwhSPSet:=dwhSP.dwhSPSet;
  trgdwhSP   :=dwhSP.dwhSP;
  trgName    :=dwhSP.Name;
  trgBegin   :=dwhSP.Begin;
  trgTill    :=dwhSP.Till;
  IF (GE_PVALUE(dwhSP.Begin) # dwhSP.Begin) |
     (GE_PVALUE(dwhSP.Till)  # dwhSP.Till )   THEN
   Check_All_dwhSP_Formula();
   SELECT(DWH, dwhSPSet, , trgdwhSPSet);
   NeedAsk:=1;
   WHILE OCCURE(DWH) DO
    IF L_DatTim.IsActiveInIntvl(DWH.PerB, DWH.PerE, trgBegin, trgTill) THEN
     IF ~SEARCH(DWHP, dwhSP, trgdwhSPSet, trgdwhSP, DWH.DWH) THEN
      InsertDWHP();
     END;
    ELSE
     IF SEARCH(DWHP, dwhSP, trgdwhSPSet, trgdwhSP, DWH.DWH) THEN
      IF ~!DWHP.StmpFill & NeedAsk THEN
       L_StdFrm.JustQuestion("ਮ ਬ " + PeriodStr(trgBegin, trgTill) + " ᯥ䨪樨 ࠭|" +
                             trgdwhSP + " '" + trgName + "'|" +
                             "     " + DWH.DWH + "  ਮ " + PeriodStr(DWH.PerB, DWH.PerE) + "|" +
                             "࠭ 㤥 㤠");
       NeedAsk:=0;
      END;
      SE_INTEGRITY(1);
      REMOVE(DWHP);
     END;
    END;
    NEXT(DWH);
   END; (* WHILE OCCURE(DWH) ... *)
   CheckThatAlldwhSPFromFormulaIsActive("");
   CheckThatAlldwhSPFromFormulaDependdwhSPIsActive();
  END;
  ApplyChanges_dwhSP(0);

  IF (GE_PVALUE(dwhSP.PlCanBe) # dwhSP.PlCanBe) |
     (GE_PVALUE(dwhSP.Calc)    # dwhSP.Calc    ) THEN
   SELECT(DWHPL, DWHP);
   WHILE OCCURE(DWHPL) DO
    IF (DWHPL.dwhSPSet = dwhSP.dwhSPSet) & (DWHPL.dwhSP = dwhSP.dwhSP) THEN
     PROMPT("䨪 ᫮ 室  ப  (, ࠭, ப):" +
            DWHPL.DWH + ", " + DWHPL.DWHP + ", " + DWHPL.DWHPL);
     CONFORM(DWHPL, dwhI);
     DWHPL.PlanIsReq:=PlanIsRequired();
     IF DWHPL.PlanIsReq = L_dwh.mstPln_NoPlan THEN
      SETEMPTY(DWHPL.PlanSys, DWHPL.PlanOper);
     END;
     REPLACE(DWHPL);
    END;
    NEXT(DWHPL);
   END; (* WHILE OCCURE(DWHPL) ... *)
  END;
 END {dwhSP_OnAfterEdit};

 PRIVATE PROCEDURE CheckThatAlldwhSPFromFormulaIsActive(checkdwhSP: LIKE(dwhSP.dwhSP));
  VAR
   Consist    : STRING[];
   i          : NUMERIC[0];
   trgdwhSPSet: LIKE(dwhSPSet.dwhSPSet);
   trgIdentif : LIKE(dwhSP.Identif);
   trgName    : LIKE(dwhSP.Name);
   trgdwhSP   : LIKE(dwhSP.dwhSP);
   trgBegin,
   trgTill    : DATE;
 BEGIN
  IF dwhSP.Calc THEN
   SAVE(dwhSP);
   trgBegin   :=dwhSP.Begin;
   trgTill    :=dwhSP.Till;
   trgdwhSPSet:=dwhSP.dwhSPSet;
   trgdwhSP   :=dwhSP.dwhSP;
   trgName    :=dwhSP.Name;
   Consist:=GetdwhSPConsist(dwhSP.dwhSPSet, trgdwhSP);
   i:=0;
   WHILE ~!L_Str.PoolItem(Consist, i) DO
    trgIdentif:=L_Str.PoolItem(Consist, i);
    L_General.CallUs(SEARCH(dwhSP, Identif, trgdwhSPSet, trgIdentif));
    IF !checkdwhSP | (dwhSP.dwhSP = checkdwhSP) THEN
     IF ~L_DatTim.IsActiveInIntvl(trgBegin, trgTill, dwhSP.Begin, dwhSP.Till) THEN
      L_StdFrm.OrdinaryCHOICE(" ᫥ 祭  ࠭  ᯥ䨪樥|" +
                              trgdwhSP + " '" + trgName + "'|" +
                              "室 稥 ࠭|" +
                              dwhSP.dwhSP + " '" + dwhSP.Name + "',|" +
                              "饩 " + PeriodStr(trgBegin, trgTill));
     END;
    END;
    INC(i);
   END;
   RESTORE(dwhSP);
  END;
 END {CheckThatAlldwhSPFromFormulaIsActive};

 PRIVATE PROCEDURE CheckThatAlldwhSPFromFormulaDependdwhSPIsActive();
  VAR
   trgdwhSPSet: LIKE(dwhSPSet.dwhSPSet);
   trgIdentif : LIKE(dwhSP.Identif);
   trgdwhSP   : LIKE(dwhSP.dwhSP);
 BEGIN
  SAVE(dwhSP);
  trgdwhSPSet:=dwhSP.dwhSPSet;
  trgIdentif :=dwhSP.Identif;
  trgdwhSP   :=dwhSP.dwhSP;
  SELECT(dwhSP, dwhSPSet, , trgdwhSPSet);
  WHILE OCCURE(dwhSP) DO
   IF dwhSP.Calc & ~!L_Str.PositionInPool(GetdwhSPConsist(trgdwhSPSet, dwhSP.dwhSP), trgIdentif) THEN
    CheckThatAlldwhSPFromFormulaIsActive(trgdwhSP);
   END;
   NEXT(dwhSP);
  END; (* WHILE OCCURE(dwhSP) ... *)
  RESTORE(dwhSP);
 END {CheckThatAlldwhSPFromFormulaDependdwhSPIsActive};

 PRIVATE PROCEDURE dwhSP_OnAfterInsert();
  VAR
   NeedAsk: SCAL[2];
 BEGIN
  CheckThatAlldwhSPFromFormulaIsActive("");
  CheckThatAlldwhSPFromFormulaDependdwhSPIsActive();
  NeedAsk:=1;
  SELECT(DWH, dwhSPSet, , dwhSP.dwhSPSet);
  WHILE OCCURE(DWH) DO
   IF (DWH.Status = L_dwh.st_Passed) & NeedAsk &
      L_DatTim.IsActiveInIntvl(DWH.PerB, DWH.PerE, dwhSP.Begin, dwhSP.Till) THEN
    L_StdFrm.OrdinaryCHOICE("  ࠭   ᯥ䨪権 ࠭ ⮢,|" +
                            " ஬     ᮬ '" + L_Str.PoolItem(L_dwh.st_Pool, L_dwh.st_Passed) + "'.|" +
                            "ਬ,  " + DWH.DWH + "  ਮ " + PeriodStr(DWH.PerB, DWH.PerB) + ".|" +
                            "       ࠭|" +
                            " ᯥ䨪樥 " + dwhSP.dwhSP + " '" + dwhSP.Name + "'");
    NeedAsk:=0;
   END;
   InsertDWHP();
   NEXT(DWH);
  END; (* WHILE OCCURE(DWH) ... *)
 END {dwhSP_OnAfterInsert};

 PRIVATE PROCEDURE CheckFieldType(FieldN: STRING[]): SCAL[2];
  VAR
   Result   : SCAL[2];
   FieldT   : TYPESPEC;
   FieldTId : NUMERIC[0];
 BEGIN
  Result  :=0;
  FieldT  :=FIELD.Get(FieldN).Type;
  FieldTId:=TYPEOF(^(FieldN));
  IF (FieldTId = L_General.ft_NUMERIC) |
     (FieldTId = L_General.ft_SCAL)    |
     (FieldTId = L_General.ft_STRING)   THEN
   Result:=1;
  END;
  RETURN Result;
 END {CheckFieldType};

 PRIVATE PROCEDURE INCValFloat(VAR IsEmpty: SCAL[2]; VAR Val: STRING[]; Float1, Float2: NUMERIC[2]; Mult: NUMERIC[0]);
  VAR
   Float: NUMERIC[2];
 BEGIN
  IF ~!Float1 THEN
   IsEmpty:=0;
   Float:=Float1
  ELSE
   Float:=Float2;
  END;
  IF !Float & ~!Val THEN
   Float:=0;
  END;
  IF ~!Float THEN
   Val:=Val + "(" + L_Str.NumericStr(Float*Mult,  2) + ")";
  END;
 END {INCValFloat};

 PRIVATE PROCEDURE Div1000_2_Number(Div1000  : LIKE(dwhI.Div1000)): NUMERIC[0];
 BEGIN
  IF Div1000 THEN
   RETURN 1000;
  ELSE
   RETURN 1;
  END;
 END {Div1000_2_Number};

 PRIVATE PROCEDURE UseFormat(Value    : L_dwh.tItemValue;
                             Format   : LIKE(DWHPL.Format);
                             Div1000  : LIKE(dwhI.Div1000);
                             SpecCond : LIKE(dwhI.SpecCond)): L_dwh.tItemValue;
  VAR
   Result   : L_dwh.tItemValue;
   StepRound: NUMERIC[3];
 BEGIN
  Result:=Value;
  IF ~!Result THEN
   Result:=Result / Div1000_2_Number(Div1000);
   StepRound:=STRTOFLD(L_Str.PoolItem(L_dwh.pool_StepRound, Format), FLOAT);
   IF Format = L_dwh.dwhsIFrm_Percent THEN
    Result:=Math.Round(Result*100, StepRound);
   ELSE
    Result:=Math.Round(Result, StepRound);
   END;
  END;
  IF (SpecCond = L_dwh.dwhiSC_NotNegative) & (Result < 0) THEN
   Result:=0;
  END;
  RETURN Result;
 END {UseFormat};

 PRIVATE PROCEDURE WritingVal(    ValIsEmpty : SCAL[2];
                                  SourceVal  : STRING[];
                              VAR ReceiverVal: L_dwh.tItemValue;
                                  Format     : LIKE(DWHPL.Format);
                                  Div1000    : SCAL[2];
                                  SpecCond   : LIKE(dwhI.SpecCond));
 BEGIN
  SETEMPTY(ReceiverVal);
  IF ~!SourceVal & ~ValIsEmpty THEN
   TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
    ReceiverVal:=UseFormat(^(SourceVal), Format, Div1000, SpecCond);
   EXCEPT
   ON Exc: Exc_Root DO
   END;
  END;
 END {WritingVal};

 PRIVATE PROCEDURE PosDWHPL(trg_dwhSPSet: LIKE(dwhSPSet.dwhSPSet);
                            trg_dwhSP   : LIKE(dwhSP.dwhSP);
                            trgMyFirm   : LIKE(MyFirm.MyFirm);
                            trgPerB     : LIKE(DWH.PerB);
                            trgPerE     : LIKE(DWH.PerE);
                            trg_dwhI    : LIKE(dwhI.dwhI);
                            trgNumCycle : LIKE(dwhI.NumCycle)): SCAL[2];
  VAR
   trgDWH: LIKE(DWH.DWH);
 BEGIN
  trgDWH:=DWH.DWH;
  SAVE(dwhI);
  SAVE(dwhSPSet);
  SAVE(DWH);
  SAVE(DWHP);
  SELECT(DWH, dwhSPSet, , trg_dwhSPSet);
  WHILE OCCURE(DWH) DO
   IF (DWH.Status = L_dwh.st_Passed) & (DWH.MyFirm = trgMyFirm) & (DWH.PerB = trgPerB) & (DWH.PerE=trgPerE) THEN
    L_General.CallUs(SEARCH(DWHP, dwhSP, trg_dwhSPSet, trg_dwhSP, DWH.DWH));
    IF SEARCH(DWHPL, dwhI, trg_dwhI, DWHP.DWHP, DWH.DWH) &
      (DWHPL.IsPrimary | ((DWH.DWH = trgDWH) & (SEARCH(dwhI, dwhI, trg_dwhI) & dwhI.NumCycle < trgNumCycle))) THEN
     RESTORE(DWHP);
     RESTORE(DWH);
     RESTORE(dwhSPSet);
     RESTORE(dwhI);
     RETURN 1;
    END;
   END;
   NEXT(DWH);
  END; (* WHILE OCCURE(DWH) ... *)
  RESTORE(DWHP);
  RESTORE(DWH);
  RESTORE(dwhSPSet);
  RESTORE(dwhI);
  RETURN 0;
 END {PosDWHPL};

 PRIVATE PROCEDURE StandOnPrimaryDWHPL();
  VAR
   trg_dwhS     : LIKE(dwhS.dwhS);
   cur_dwhI     : LIKE(dwhI.dwhI);
   cur_dwhSPSet : LIKE(dwhSPSet.dwhSPSet);
   cur_dwhSP    : LIKE(dwhSP.dwhSP);
   cur_PerB     : LIKE(DWH.PerB);
   cur_PerE     : LIKE(DWH.PerE);
   cur_MyFirm   : LIKE(MyFirm.MyFirm);
 BEGIN
  SAVE(dwhI);
  SAVE(DWH);
  SAVE(DWHP);
  trg_dwhS     :=Get_dwhSI_Primary_dwhS();
  cur_dwhSPSet :=DWHPL.dwhSPSet;
  cur_dwhSP    :=DWHPL.dwhSP;
  cur_dwhI     :=dwhSI.dwhI;
  cur_MyFirm   :=DWH.MyFirm;
  cur_PerB     :=DWH.PerB;
  cur_PerE     :=DWH.PerE;
  SELECT(DWH, dwhS, , trg_dwhS, cur_MyFirm, cur_PerB, cur_PerE);
  LOOP
   IF ~OCCURE(DWH) THEN
    SEARCH(dwhS, dwhS, , trg_dwhS);
    CONFORM(dwhSI, dwhI);
    L_General.Error(" ஢   ᯥ䨪樨" +
                    "|" + dwhS.dwhS + " " + dwhS.Name + "," +
                    "|| 室  祭 " +
                    "|" + dwhI.dwhI + " " + dwhI.Name);
   ELSIF DWH.Status = L_dwh.st_Passed THEN
    L_General.CallUs(SEARCH(DWHP, dwhSP, cur_dwhSPSet, cur_dwhSP, DWH.DWH));
    SAVE(dwhS);
    SAVE(dwhSP);
    CONFORM(DWH, dwhS);
    CONFORM(DWHP, dwhSP);
    L_General.Assert(DWHP.State=L_dwh.ste_Calculate, "࠭ " + DWHP.Number + " '" + dwhSP.Name + "'|" +
                                                     "  " + DWH.DWH     + " '" + dwhS.Name  + "'|" +
                                                     "   ﭨ " + L_Str.PoolItem(L_dwh.ste_Pool, L_dwh.ste_Calculate));
    RESTORE(dwhSP);
    RESTORE(dwhS);
    L_General.CallUs(SEARCH(DWHPL, dwhI, cur_dwhI, DWHP.DWHP, DWHP.DWH));
    RESTORE(DWHP);
    RESTORE(DWH);
    RESTORE(dwhI);
    RETURN ;
   END;
   NEXT(DWH);
  END; (* WHILE LOOP *)
 END {StandOnPrimaryDWHPL};

 PRIVATE PROCEDURE UsePrimaryFormat(Value      : L_dwh.tItemValue;
                                    PrimFormat : LIKE(DWHPL.Format);
                                    curFormat  : LIKE(DWHPL.Format)): L_dwh.tItemValue;
  VAR
   Result   : L_dwh.tItemValue;
   StepRound: NUMERIC[3];
 BEGIN
  Result:=Value;
  IF ~!Result & (PrimFormat # curFormat) THEN
   StepRound:=STRTOFLD(L_Str.PoolItem(L_dwh.pool_StepRound, curFormat), FLOAT);
   Result   :=Math.Round(Result, StepRound);
  END;
  RETURN Result;
 END {UsePrimaryFormat};

 PRIVATE PROCEDURE ApplyPrimaryDWHPLToTheOthers(NeedChangeState: SCAL[2]);
  VAR
   tgrFormat   : LIKE(dwhSI.Format);
   trg_dwhI    : LIKE(dwhI.dwhI);
   trgDWH      : LIKE(DWH.DWH);
   trgPlanOper,
   trgFactOper,
   trgPlanSys,
   trgFactSys  : L_dwh.tItemValue;
   trgPerB,
   trgPerE     : DATE;
 BEGIN
  IF DWHPL.IsPrimary THEN
   SAVE(DWHP);
   SAVE(dwhI);
   CONFORM(DWHPL, dwhI);
   CONFORM(DWHPL, DWHP);
   CONFORM(DWHP,  DWH);
   trgPerB    :=DWH.PerB;
   trgPerE    :=DWH.PerE;
   trgDWH     :=DWH.DWH;
   trg_dwhI   :=DWHPL.dwhI;
   tgrFormat  :=DWHPL.Format;
   trgPlanOper:=DWHPL.PlanOper;
   trgFactOper:=DWHPL.FactOper;
   trgPlanSys :=DWHPL.PlanSys;
   trgFactSys :=DWHPL.FactSys;
   RESTORE(dwhI);
   SELECT(DWHP, dwhSPPer, , DWHPL.dwhSPSet, trgPerB, trgPerE, DWHPL.dwhSP);
   WHILE OCCURE(DWHP) DO
    SAVE(DWH);
    CONFORM(DWHP, DWH);
    IF (DWH.DWH # trgDWH) THEN
     SAVE(DWHPL);
     IF SEARCH(DWHPL, dwhI, trg_dwhI, DWHP.DWHP, DWH.DWH) & ~DWHPL.IsPrimary THEN
      IF NeedChangeState THEN
       ChangeCurDWHPState(L_dwh.ste_Prepared, 1);
       ApplyStateDWHPToDependentDWHP();
      END;
      SAVE(dwhI);
      CONFORM(DWHPL, dwhI);
      DWHPL.PlanOper:=UsePrimaryFormat(trgPlanOper, tgrFormat, DWHPL.Format);
      DWHPL.FactOper:=UsePrimaryFormat(trgFactOper, tgrFormat, DWHPL.Format);
      DWHPL.PlanSys :=UsePrimaryFormat(trgPlanSys,  tgrFormat, DWHPL.Format);
      DWHPL.FactSys :=UsePrimaryFormat(trgFactSys,  tgrFormat, DWHPL.Format);
      RESTORE(dwhI);
      REPLACE(DWHPL);
     END;
     RESTORE(DWHPL);
    END;
    RESTORE(DWH);
    NEXT(DWHP);
   END; (* WHILE OCCURE(DWHP) ... *)
   RESTORE(DWHP);
  END; (* IF DWHPL.IsPrimary ... *)
 END {ApplyPrimaryDWHPLToTheOthers};

 PRIVATE PROCEDURE DWHP_Calculate();
  VAR
   PosSepar,
   PosSubStr,
   i          : NUMERIC[0];
   Separators,
   SubStr,
   ValPlnOper,
   ValFctOper,
   ValPlnSys,
   ValFctSys : STRING[];
   PlnOperIsEmpty,
   PlnSysIsEmpty,
   FctOperIsEmpty,
   FctSysIsEmpty  : SCAL[2];
 BEGIN
  SAVE(DWH);
  IF ~DWHP.Calc THEN
   L_General.Assert(~!DWHP.StmpFill, "࠭ " + DWHP.Number + " 室  묨 ⮏");
  END;
  SAVE(DWHPL);
  SELECT(DWHPL, NumCycle, , DWHP.DWH, DWHP.DWHP);
  WHILE OCCURE(DWHPL) DO
   PROMPT(":  " + DWHPL.DWH + " ࠭ " + DWHPL.DWHP + " ப " + DWHPL.DWHPL);
   IF ~DWHPL.IsPrimary THEN
    SAVE(DWH);
    SAVE(DWHPL);
    CONFORM(DWHPL, dwhSI);
    StandOnPrimaryDWHPL();
    ApplyPrimaryDWHPLToTheOthers(0);
    RESTORE(DWHPL);
    RESTORE(DWH);
   ELSIF DWHPL.Calc THEN
    SETEMPTY(ValPlnOper, ValFctOper, ValPlnSys, ValFctSys);
    SETZERO(i, PosSepar);
    PlnOperIsEmpty:=1; PlnSysIsEmpty:=1; FctOperIsEmpty:=1; FctSysIsEmpty:=1;
    CONFORM(DWHPL, dwhI);
    LOOP
     SubStr:=Str.Item(dwhI.Formula, separators_pool, i);
     IF ~!SubStr THEN
      PosSubStr:=Str.ItemPos(dwhI.Formula, separators_pool, i);
     ELSE
      PosSubStr:=Str.Length(dwhI.Formula);
     END;
     Separators:=Str.Slice(dwhI.Formula, PosSepar, PosSubStr - PosSepar);
     PosSepar  :=PosSubStr + Str.ItemLen(dwhI.Formula, separators_pool, i);
     IF ~!Separators THEN
      INC(ValPlnOper, Separators);
      INC(ValFctOper, Separators);
      INC(ValPlnSys,  Separators);
      INC(ValFctSys,  Separators);
     END;
     IF !SubStr THEN
      EXIT;
     END;
     IF ThisIsFloat(SubStr) THEN
      INCValFloat(PlnOperIsEmpty, ValPlnOper, STRTOFLD(SubStr, FLOAT), L_General.EMPTY_NUMBER(), 1);
      INCValFloat(FctOperIsEmpty, ValFctOper, STRTOFLD(SubStr, FLOAT), L_General.EMPTY_NUMBER(), 1);
      INCValFloat(PlnSysIsEmpty,  ValPlnSys,  STRTOFLD(SubStr, FLOAT), L_General.EMPTY_NUMBER(), 1);
      INCValFloat(FctSysIsEmpty,  ValFctSys,  STRTOFLD(SubStr, FLOAT), L_General.EMPTY_NUMBER(), 1);
     ELSE
      SAVE(dwhI);
      SAVE(DWHPL);
      L_General.CallUs(SEARCH(dwhI, Identif, SubStr));
      IF ~SEARCH(DWHPL, dwhI, dwhI.dwhI, DWHPL.DWHP, DWHPL.DWH) THEN
       (*   塞  室 室  㣮  *)
       L_General.CallUs(0);
      END;
      CONFORM(DWHPL, dwhSI);
      IF ~dwhSI.IsPrimary THEN
       StandOnPrimaryDWHPL();
      ELSE
      END;
      INCValFloat(PlnOperIsEmpty, ValPlnOper, DWHPL.PlanOper, DWHPL.PlanSys,            Div1000_2_Number(dwhI.Div1000));
      INCValFloat(FctOperIsEmpty, ValFctOper, DWHPL.FactOper, DWHPL.FactSys,            Div1000_2_Number(dwhI.Div1000));
      INCValFloat(PlnSysIsEmpty,  ValPlnSys,  DWHPL.PlanSys,  L_General.EMPTY_NUMBER(), Div1000_2_Number(dwhI.Div1000));
      INCValFloat(FctSysIsEmpty,  ValFctSys,  DWHPL.FactSys,  L_General.EMPTY_NUMBER(), Div1000_2_Number(dwhI.Div1000));
      RESTORE(DWHPL);
      RESTORE(dwhI);
     END;
     INC(i);
    END; (* LOOP ... *)
    ValPlnOper:="(" + ValPlnOper + ")";
    ValFctOper:="(" + ValFctOper + ")";
    ValPlnSys :="(" + ValPlnSys + ")";
    ValFctSys :="(" + ValFctSys + ")";
 
    WritingVal(PlnOperIsEmpty, ValPlnOper, DWHPL.PlanOper, DWHPL.Format, dwhI.Div1000, dwhI.SpecCond);
    WritingVal(FctOperIsEmpty, ValFctOper, DWHPL.FactOper, DWHPL.Format, dwhI.Div1000, dwhI.SpecCond);
    WritingVal(PlnSysIsEmpty,  ValPlnSys,  DWHPL.PlanSys,  DWHPL.Format, dwhI.Div1000, dwhI.SpecCond);
    WritingVal(FctSysIsEmpty,  ValFctSys,  DWHPL.FactSys,  DWHPL.Format, dwhI.Div1000, dwhI.SpecCond);
    REPLACE(DWHPL);
   END; (* IF dwhI.Calc ...*)
   NEXT(DWHPL);
  END; (* WHILE OCCURE(DWHPL) ... *)
  RESTORE(DWHPL);
  DWHP.State:=L_dwh.ste_Calculate;
  REPLACE(DWHP);
  RESTORE(DWH);
 END {DWHP_Calculate};

 PRIVATE PROCEDURE GetDWHPLVal(    dstIdentif  : LIKE(DWHP.Identif);
                                   dstDWH      : LIKE(DWH.DWH);
                                   srcIdentif  : LIKE(DWHP.Identif);
                                   src_dwhI    : LIKE(dwhI.dwhI);
                               VAR dstPlanOper,
                                   dstFactOper,
                                   dstPlanSys,
                                   dstFactSys  : L_dwh.tItemValue);
  VAR
   srcDWHP: LIKE(dwhSP.dwhSP);
 BEGIN
  SAVE(DWHP);
  SAVE(DWHPL);
  SEARCH(DWHP, Identif, , srcIdentif, dstDWH);
  L_General.Assert(DWHP.State = L_dwh.ste_Calculate, " ᫥ ࠭ " + dstIdentif +
                                                     "|室 ᭠砫 ᫨ ࠭ " + srcIdentif);
  srcDWHP:=DWHP.DWHP;
  SEARCH(DWHPL, dwhI, , src_dwhI, srcDWHP, dstDWH);
  dstPlanOper:=DWHPL.PlanOper;
  dstFactOper:=DWHPL.FactOper;
  dstPlanSys :=DWHPL.PlanSys;
  dstFactSys :=DWHPL.FactSys;
  RESTORE(DWHPL);
  RESTORE(DWHP);
 END {GetDWHPLVal};

 PRIVATE PROCEDURE INCSum(VAR IsEmpty  : SCAL[2];
                          VAR Sum      : NUMERIC[6];
                              Item1    : L_dwh.tItemValue;
                              Item2    : L_dwh.tItemValue;
                              Separator: STRING[1];
                              divisor  : NUMERIC[0]);
  VAR
   Item: NUMERIC[6];
 BEGIN
  IF ~!Item1 THEN
   IsEmpty:=0;
   Item:=Item1
  ELSE
   Item:=Item2;
  END;

  IF ~!Item THEN
   IF DWHPL.MthCalc = L_dwh.MC_Average THEN
    Item:=Item/divisor;
   END;
   IF !Sum & !Separator THEN
    Sum:=Item;
   ELSE
    IF !Sum THEN
     Sum:=0;
    END;
    IF (Separator = "+") | (DWHPL.MthCalc = L_dwh.MC_Average) THEN
     INC(Sum, Item);
    ELSIF Separator = "-" THEN
     DEC(Sum, Item);
    ELSE
     L_General.CallUs(0);
    END;
   END;
  END; (* IF ~!Item *)
 END {INCSum};

 PRIVATE PROCEDURE CalculateSummaryDWHP(trgDWH:LIKE(DWH.DWH); trgDWHP:LIKE(DWHP.DWHP));
  VAR
   SumPlanOper,
   SumFactOper,
   SumPlanSys,
   SumFactSys,
   trgPlanOper,
   trgFactOper,
   trgPlanSys,
   trgFactSys     : L_dwh.tItemValue;
   trgIdentif     : LIKE(dwhSP.Identif);
   PosIdentif,
   PosSepar,
   CntdwhSPFc,
   CntdwhSPPl,
   i              : NUMERIC[0];
   Separator      : STRING[1];
   PlnOperIsEmpty,
   PlnSysIsEmpty,
   FctOperIsEmpty,
   FctSysIsEmpty  : SCAL[2];
   trgBegin,
   trgTill        : DATE;
   dwhSPIsActive  : SCAL[2];
 BEGIN
  SAVE(dwhSP);
  SELECT(DWHPL, DWHP, , trgDWH, trgDWHP);
  WHILE OCCURE(DWHPL) DO
   PROMPT(":  " + DWHPL.DWH + " ࠭ " + DWHPL.DWHP + " ப " + DWHPL.DWHPL);
   CONFORM(DWHPL, dwhI);
   CONFORM(DWHPL, DWHP);
   CONFORM(DWHP, dwhSP);
   IF ~dwhI.Calc THEN
    trgBegin:=DWHP.PerB;
    trgTill :=DWHP.PerE;
    SETZERO(i, PosSepar, CntdwhSPFc, CntdwhSPPl);
    WHILE ~!Str.Item(dwhSP.Formula, "+-", i) DO
     trgIdentif:=Str.Item(dwhSP.Formula, "+-", i);
     SAVE(dwhSP);
     L_General.CallUs(SEARCH(dwhSP, Identif, dwhSP.dwhSPSet, trgIdentif));
     dwhSPIsActive:=L_DatTim.IsActiveInIntvl(trgBegin, trgTill, dwhSP.Begin, dwhSP.Till);
     RESTORE(dwhSP);
     IF dwhSPIsActive THEN
      L_General.CallUs(SEARCH(DWHP,  Identif, trgIdentif, trgDWH));
      SAVE(dwhSP);
      CONFORM(DWHP, dwhSP);
      IF dwhSP.Calc | dwhSP.PlCanBe THEN
       INC(CntdwhSPPl);
      END;
      RESTORE(dwhSP);
      INC(CntdwhSPFc);
     END;
     INC(i);
    END;
    i:=0;
    SETEMPTY(SumPlanOper, SumFactOper, SumPlanSys, SumFactSys);
    PlnOperIsEmpty:=1; PlnSysIsEmpty:=1; FctOperIsEmpty:=1; FctSysIsEmpty:=1;
    LOOP
     trgIdentif:=Str.Item(dwhSP.Formula, "+-", i);
     IF !trgIdentif THEN
      EXIT;
     END;
     SAVE(dwhSP);
     L_General.CallUs(SEARCH(dwhSP, Identif, dwhSP.dwhSPSet, trgIdentif));
     dwhSPIsActive:=L_DatTim.IsActiveInIntvl(trgBegin, trgTill, dwhSP.Begin, dwhSP.Till);
     RESTORE(dwhSP);
     PosIdentif:=Str.ItemPos(dwhSP.Formula, "+-", i);
     Separator :=Str.Slice(dwhSP.Formula, PosSepar, PosIdentif - PosSepar);
     PosSepar  :=PosIdentif + Str.Length(trgIdentif);
     IF dwhSPIsActive THEN
      SETEMPTY(trgPlanOper, trgFactOper, trgPlanSys, trgFactSys);
      GetDWHPLVal(DWHP.Identif, trgDWH, trgIdentif, dwhI.dwhI, trgPlanOper, trgFactOper, trgPlanSys, trgFactSys);
      INCSum(PlnOperIsEmpty, SumPlanOper, trgPlanOper, trgPlanSys,               Separator, CntdwhSPPl);
      INCSum(FctOperIsEmpty, SumFactOper, trgFactOper, trgFactSys,               Separator, CntdwhSPFc);
      INCSum(PlnSysIsEmpty,  SumPlanSys,  trgPlanSys,  L_General.EMPTY_NUMBER(), Separator, CntdwhSPPl);
      INCSum(FctSysIsEmpty,  SumFactSys,  trgFactSys,  L_General.EMPTY_NUMBER(), Separator, CntdwhSPFc);
     END;
     INC(i);
    END; (* LOOP ...*)

    WritingVal(PlnOperIsEmpty, FLDTOSTR(SumPlanOper), DWHPL.PlanOper, DWHPL.Format, 0, dwhI.SpecCond);
    WritingVal(FctOperIsEmpty, FLDTOSTR(SumFactOper), DWHPL.FactOper, DWHPL.Format, 0, dwhI.SpecCond);
    WritingVal(PlnSysIsEmpty,  FLDTOSTR(SumPlanSys),  DWHPL.PlanSys,  DWHPL.Format, 0, dwhI.SpecCond);
    WritingVal(FctSysIsEmpty,  FLDTOSTR(SumFactSys),  DWHPL.FactSys,  DWHPL.Format, 0, dwhI.SpecCond);
    REPLACE(DWHPL);
   END;
   NEXT(DWHPL);
  END; (* WHILE OCCURE(DWHPL) ... *)
  RESTORE(dwhSP);
  SAVE(DWHP);
  SEARCH(DWHP, DWH, , trgDWH, trgDWHP);
  CONFORM(DWHP, DWH);
  SAVE(DWH);
  DWHP_Calculate();
  RESTORE(DWH);
  RESTORE(DWHP);
 END {CalculateSummaryDWHP};

 PRIVATE PROCEDURE CheckAllFieldsDWH();
 BEGIN
  L_General.Assert(~!DWH.PerB,   "  ''");
  L_General.Assert(~!DWH.PerE,   "  ''");
  L_General.Assert(~!DWH.dwhS,   "  '䨪  '");
 END {CheckAllFieldsDWH};

 PRIVATE PROCEDURE CalculateCurDWHP();
  VAR
   dummy: SCAL[2];
 BEGIN
  AccessDWHP();
  dummy:=L_dwh.Check_dwhSPIsActive(1);
  IF DWHP.Calc THEN
   CalculateSummaryDWHP(DWHP.DWH, DWHP.DWHP);
  ELSE
   DWHP_Calculate();
  END;
 END {CalculateCurDWHP};

 PUBLIC PROCEDURE CalculateCurDWH();
 BEGIN
  AccessDWH();
  CheckAllFieldsDWH();
  SELECT(dwhSP, NumCycle, , DWH.dwhSPSet);
  WHILE OCCURE(dwhSP) DO
   IF L_DatTim.IsActiveInIntvl(DWH.PerB, DWH.PerE, dwhSP.Begin, dwhSP.Till) THEN
    L_General.CallUs(SEARCH(DWHP, dwhSP, dwhSP.dwhSPSet, dwhSP.dwhSP, DWH.DWH));
    CalculateCurDWHP();
   END;
   NEXT(dwhSP);
  END; (* WHILE OCCURE(dwhSP) ... *)
 END {CalculateCurDWH};

 PRIVATE PROCEDURE CheckPerCurDWH();
  VAR
   Per,
   i : NUMERIC[0];
 BEGIN
  IF ~!DWH.dwhS THEN
   CONFORM(DWH, dwhS);
   i:=0; Per:=-1;
   WHILE (i < L_dwh.period_Amount) & (Per=-1)  DO
    IF dwhS.ArrPer[i] &
       (STRTOFLD(L_Str.PoolItem(L_dwh.pool_CntMonthInPer, i), NUMERIC, "0.") = L_DatTim.MonthsInIntvl(DWH.PerB, DWH.PerE)) THEN
     Per:=i;
    END;
    INC(i);
   END;
   L_General.Assert(Per#-1, "ਮ " + PeriodStr(DWH.PerB, DWH.PerE) +
                            "  ᮮ⢥     |" +
                            "ᯥ䨪樨 " + dwhS.dwhS + "'" + dwhS.Name + "'|" +
                            " ਮ ନ஢ ");
   IF    Per = L_dwh.perQuarter THEN
    IF ~((L_DatTim.MONTH(DWH.PerB) = 0) | (L_DatTim.MONTH(DWH.PerB) = 3) |
         (L_DatTim.MONTH(DWH.PerB) = 6) | (L_DatTim.MONTH(DWH.PerB) = 9) ) THEN
     L_General.Error("砫 ⠫    " + L_DatTim.MonthStr(DWH.PerB, 0));
    END;
   ELSIF Per = L_dwh.perHalfYear THEN
    IF ~((L_DatTim.MONTH(DWH.PerB) = 0) | (L_DatTim.MONTH(DWH.PerB) = 6)) THEN
     L_General.Error("砫 㣮    " + L_DatTim.MonthStr(DWH.PerB, 0));
    END;
   ELSIF Per = L_dwh.perYear THEN
    IF L_DatTim.MONTH(DWH.PerB) # 0 THEN
     L_General.Error("砫     " + L_DatTim.MonthStr(DWH.PerB, 0));
    END;
   END;
  END;
 END {CheckPerCurDWH};

 PRIVATE PROCEDURE InsertDWHP();
 BEGIN
  IF L_DatTim.IsActiveInIntvl(DWH.PerB, DWH.PerE, dwhSP.Begin, dwhSP.Till) THEN
   SETEMPTY(DWHP.DWHP, DWHP.StmpFill);
   DWHP.DWH     :=DWH.DWH;
   DWHP.PerB    :=DWH.PerB;
   DWHP.PerE    :=DWH.PerE;
   DWHP.dwhSPSet:=dwhSPSet.dwhSPSet;
   DWHP.dwhSP   :=dwhSP.dwhSP;
   DWHP.Calc    :=dwhSP.Calc;
   DWHP.Name    :=dwhSP.Name;
   DWHP.Identif :=dwhSP.Identif;
   DWHP.Number  :=dwhSP.Number;
   DWHP.State   :=L_dwh.ste_Prepared;
   INSERT(DWHP);
 
   L_General.Assert(SELECT(dwhSI, dwhS, DWH.dwhS), " ᯥ䨪樨  ᠭ   ப");
   WHILE OCCURE(dwhSI) DO
    PROMPT(" ࠭ " + dwhSP.dwhSP + ",  " + dwhSI.dwhSI);
    IF L_DatTim.IsActiveInIntvl(dwhSI.Begin, dwhSI.Till, DWH.PerB, DWH.PerE) THEN
     CONFORM(dwhSI, dwhI);
     L_General.Assert(~HasOtherActualdwhSI(DWH.PerB, DWH.PerE),
                      " ਮ " + PeriodStr(DWH.PerB, DWH.PerE) + "  2  |" +
                      " " + dwhI.dwhI + " " + dwhI.ShortN);
     SETEMPTY(DWHPL.DWHPL, DWHPL.PlanSys, DWHPL.FactSys, DWHPL.PlanOper, DWHPL.FactOper);
     DWHPL.DWH      :=DWH.DWH;
     DWHPL.DWHP     :=DWHP.DWHP;
     DWHPL.dwhS     :=DWH.dwhS;
     DWHPL.dwhI     :=dwhSI.dwhI;
     DWHPL.dwhSI    :=dwhSI.dwhSI;
     DWHPL.dwhSPSet :=DWHP.dwhSPSet;
     DWHPL.dwhSP    :=DWHP.dwhSP;
     DWHPL.Number   :=dwhSI.Number;
     DWHPL.Calc     :=dwhI.Calc;
     DWHPL.IsPrimary:=dwhSI.IsPrimary;
     DWHPL.Format   :=dwhSI.Format;
     DWHPL.NumCycle :=dwhI.NumCycle;
     DWHPL.Type     :=dwhI.Type;
     DWHPL.MthCalc  :=dwhI.MthCalc;
     DWHPL.MthAdd   :=dwhI.MthAdd;
     DWHPL.PlanIsReq:=PlanIsRequired();
     DWHPL.FactIsReq:=FactIsRequired();
     INSERT(DWHPL);
    END;
    NEXT(dwhSI);
   END; (* WHILE OCCURE(dwhSI) ... *)
  END;
 END {InsertDWHP};

 PUBLIC PROCEDURE PrepareDWH();
 BEGIN
  L_General.Assert(~SELECT(DWHP, DWH, DWH.DWH), "  ");
  CheckAllFieldsDWH();

  CheckPerCurDWH();
  CONFORM(DWH, dwhSPSet);
  L_General.Assert(SELECT(dwhSP, dwhSPSet, dwhSPSet.dwhSPSet), " ᯥ䨪樨  ᠭ   ࠭");

  CONFORM(DWH, dwhSPSet);
  SELECT(dwhSP, dwhSPSet, , dwhSPSet.dwhSPSet);
  WHILE OCCURE(dwhSP) DO
   InsertDWHP();
   NEXT(dwhSP);
  END; (* WHILE OCCURE(dwhSP) ... *)
 END {PrepareDWH};

 PRIVATE PROCEDURE DWH_OnAfterEdIns();
  VAR
   trgPerB,
   trgPerE : DATE;
   trgDWH  : LIKE(DWH.DWH);
 BEGIN
  trgPerB:=DWH.PerB;
  trgPerE:=DWH.PerE;
  trgDWH :=DWH.DWH;
  SAVE(DWH);
  SELECT(DWH, dwhS, , DWH.dwhS, DWH.MyFirm, trgPerB, trgPerE);
  WHILE OCCURE(DWH) DO
   IF (DWH.DWH#trgDWH) & (DWH.Status#L_dwh.st_Canceled) THEN
    CONFORM(DWH, dwhSPSet);
    L_General.Error("   ஥  ᯥ䨪樨|" +
                    dwhS.dwhS + " '" + dwhS.Name + "'|" +
                    " ਮ " + PeriodStr(trgPerB, trgPerE));
   END;
   NEXT(DWH);
  END; (* WHILE OCCURE(DWH) ... *)
  RESTORE(DWH);
 END {DWH_OnAfterEdIns};

 PRIVATE PROCEDURE DWH_OnAfterInsert();
 BEGIN
  DWH_OnAfterEdIns();
  IF ~SELECT(DWHP, DWH, DWH.DWH) THEN
   PrepareDWH();
  END;
  IF DWH.Status = L_dwh.st_Passed THEN
   CalculateCurDWH();
  END;
 END {DWH_OnAfrerInsert};

 PRIVATE PROCEDURE DWH_OnAfterEdit();
  VAR
   NeedAsk   : SCAL[2];
   NeedRemSel: SCAL[2];
   Message   : STRING[];
 BEGIN
  DWH_OnAfterEdIns();
  CheckPerCurDWH();
  NeedRemSel:=0;
  IF ~!GE_PVALUE(DWH.dwhS) & (GE_PVALUE(DWH.dwhS) # DWH.dwhS) THEN
   NeedRemSel:=1;
   Message   :="  ᯥ䨪 ";
  END;
  IF ~!GE_PVALUE(DWH.PerB) & ~!GE_PVALUE(DWH.PerE) &
    ((GE_PVALUE(DWH.PerB) # DWH.PerB) | (GE_PVALUE(DWH.PerE) # DWH.PerE)) THEN
   IF NeedRemSel THEN
    Message:=Message + "  ਮ ";
   ELSE
    Message:="  ਮ ";
   END;
   NeedRemSel:=1;
  END;
  IF NeedRemSel THEN
   NeedAsk:=1;
   SELECT(DWHP, DWH, , DWH.DWH);
   WHILE OCCURE(DWHP) DO
    SAVE(DWHPL);
    IF SELECT(DWHPL, DWHP, DWH.DWH, DWHP.DWHP) THEN
     IF NeedAsk THEN
      L_StdFrm.JustQuestion(Message + ".|騥    㤠");
      NeedAsk:=0;
     END;
     REMSEL(DWHPL);
    END;
    RESTORE(DWHPL);
    NEXT(DWHP);
   END; (* WHILE OCCURE(DWHP) ... *)
   REMSEL(DWHP);
  END;
  IF (DWH.Status # L_dwh.st_Canceled) & SELECT(DWHP, State, DWH.DWH, L_dwh.ste_Prepared) THEN
   CalculateCurDWH();
  END;
 END {DWH_OnAfterEdit};

 PRIVATE PROCEDURE DWH_OnBeforeEdIns();
 BEGIN
  DWH.CrtDate:= SYSDATE();
  REPLACE(DWH);
 END {DWH_OnBeforeEdIns};

 PRIVATE PROCEDURE DWH_OnBeforeInsert();
 BEGIN
  DWH.MyFirm  :=P_Firm.DefineMyFirm();
  DWH.Status  :=L_dwh.st_Prepared;
  DWH_OnBeforeEdIns();
 END {DWH_OnBeforeInsert};

 PRIVATE PROCEDURE DWH_OnBeforeEdit();
 BEGIN
  DWH_OnBeforeEdIns();
 END {DWH_OnBeforeEdit};

 PRIVATE PROCEDURE DWH_OnBeforeDelete();
 BEGIN
  L_General.Error(" ⮢ 饭");
 END {DWH_OnBeforeDelete};

 PRIVATE PROCEDURE DWH_dwhS_OnSuccessfulChange();
 BEGIN
  CONFORM(DWH, dwhS);
  DWH.dwhSPSet:=dwhS.dwhSPSet;
  REPLACE(DWH);
 END {DWH_dwhS_OnSuccessfulChange};

 PRIVATE PROCEDURE DWH_PerE_OnSuccessfulChange();
 BEGIN
  DWH.PerE:=L_DatTim.MonthEnd(DWH.PerE);
  REPLACE(DWH);
 END {DWH_PerE_OnSuccessfulChange};

 PRIVATE PROCEDURE DWH_Status_OnSuccessfulChange();
 BEGIN
  IF DWH.Status = L_dwh.st_Passed THEN
   IF SELECT(DWHP, DWH, DWH.DWH) THEN
    WHILE OCCURE(DWHP) DO
     IF ~DWHP.Calc THEN
      CONFORM(DWHP, dwhSP);
      SELECT(DWHPL, DWHP, , DWH.DWH, DWHP.DWHP);
      WHILE OCCURE(DWHPL) DO
       IF (!DWHPL.PlanOper & DWHPL.PlanIsReq) | (!DWHPL.FactOper & DWHPL.FactIsReq) THEN
        CONFORM(DWHPL, dwhI);
        L_General.Error(" ࠭ " + DWHP.Number + " '" + DWHP.Name + "'|" +
                        "   ࢨ ப,|" +
                        "    ஬.|" +
                        "ਬ, " + DWHPL.Number + " '" + dwhI.Name + "'.");
       END;
       NEXT(DWHPL);
      END; (* WHILE OCCURE(DWHPL) ... *)
     END; (* IF ~DWHP.Calc *)
     NEXT(DWHP);
    END; (* WHILE OCCURE(DWHP) ... *)
   ELSE
    L_General.Error("      ࠭");
   END;
  END;
 END {DWH_Status_OnSuccessfulChange};

 PRIVATE PROCEDURE DWHPL_OnBeforeInsert();
 BEGIN
  L_General.Error("⠢ ப   饭");
 END {DWHPL_OnBeforeInsert};

 PRIVATE PROCEDURE DWHPL_OnBeforeDelete();
 BEGIN
  L_General.Error(" ப   饭");
 END {DWHPL_OnBeforeDelete};

 PRIVATE PROCEDURE Editing_cur_dwhIAllowed(): SCAL[2];
 BEGIN
  RETURN ~(dwhI.ShortN = "");
 END {Editing_cur_dwhIAllowed};

 PRIVATE PROCEDURE DWHPL_OnBeforeEdit();
 BEGIN
  CONFORM(DWHPL, DWHP);
  L_General.Assert(~DWHP.Calc, " ᢮ ࠭");
  L_General.Assert(~!DWHP.StmpFill, "࠭ " + DWHP.Number + " 室  묨 ⮏");
  CONFORM(DWHPL, dwhI);
  L_General.Assert(~dwhI.Calc, " 塞 ");
  L_General.Assert(Editing_cur_dwhIAllowed(), "祭 ⮣ ⥫ ࠢ 饭");
  CONFORM(DWHPL, dwhSI);
  IF ~dwhSI.IsPrimary THEN
   SEARCH(dwhS, dwhS, , Get_dwhSI_Primary_dwhS());
   L_General.Error("       ᯥ䨪樥" +
                   "||" + dwhS.dwhS + " " + dwhS.Name);
  ELSE
   L_General.CallUs(SEARCH(dwhSP, dwhSPSet, DWHPL.dwhSPSet, DWHPL.dwhSP));
   RTI.Get().CurZone.Fields("DWHPL.PlanOper").Modifiable:=dwhSP.PlCanBe & (dwhI.MustPlan # L_dwh.mstPln_NoPlan);
  END;
 END {DWHPL_OnBeforeEdit};

 PRIVATE PROCEDURE DWHPL_OnAfterEdit();
 BEGIN
  SAVE(DWH);
  CONFORM(DWHPL, DWHP);
  IF DWHP.State = L_dwh.ste_Calculate THEN
   ChangeCurDWHPState(L_dwh.ste_Prepared, 0);
   ApplyStateDWHPToDependentDWHP();
  END;
  ApplyPrimaryDWHPLToTheOthers(1);
  CONFORM(DWHP, DWH);
  DWHP_Calculate();
  RESTORE(DWH);
 END {DWHPL_OnAfterEdit};

 PRIVATE PROCEDURE GetdwhSPConsist(_dwhSPSet:LIKE(dwhSPSet.dwhSPSet); _dwhSP: LIKE(dwhSP.dwhSP)): STRING[];
  VAR
   SubStr : STRING[];
   i      : NUMERIC[0];
   Consist: STRING[];
 BEGIN
  SAVE(dwhSP);
  L_General.CallUs(SEARCH(dwhSP, dwhSPSet, _dwhSPSet, _dwhSP));
  i:=0;
  SETEMPTY(Consist);
  REPEAT
   SubStr:=Str.Item(dwhSP.Formula, separators_pool, i);
   SAVE(dwhSP);
   IF ~!SubStr & SEARCH(dwhSP, Identif, _dwhSPSet, SubStr) THEN
    Consist:=Consist + SubStr + "|";
   END;
   RESTORE(dwhSP);
   INC(i);
  UNTIL !SubStr;
  RESTORE(dwhSP);
  RETURN Consist;
 END {GetdwhSPConsist};

 PRIVATE PROCEDURE dwhSP_OnBeforeDelete();
  VAR
   trgIdentif  : LIKE(dwhSP.Identif);
   trgName     : LIKE(dwhSP.Name);
   trgdwhSP    : LIKE(dwhSP.dwhSP);
   tgrDWH      : LIKE(DWH.DWH);
   tgrDWHP     : LIKE(DWHP.DWHP);
   trgdwhSPSet : LIKE(dwhSPSet.dwhSPSet);
   DWHPWereFill: SCAL[2];
 BEGIN
  trgIdentif :=dwhSP.Identif;
  trgName    :=dwhSP.Name;
  trgdwhSP   :=dwhSP.dwhSP;
  trgdwhSPSet:=dwhSP.dwhSPSet;
  SAVE(dwhSP);
  SELECT(dwhSP, dwhSPSet, , trgdwhSPSet);
  WHILE OCCURE(dwhSP) DO
   IF dwhSP.Calc THEN
    L_General.Assert(!L_Str.PositionInPool(GetdwhSPConsist(dwhSP.dwhSPSet, dwhSP.dwhSP), trgIdentif),
                     "࠭ " + trgdwhSP + " '" + trgName + "' ᯮ  㫥  ᫥|" +
                     "祭 ⮢  ࠭ " + dwhSP.dwhSP + " '" + dwhSP.Name + "'.|" +
                     " 饭");
   END;
   NEXT(dwhSP);
  END; (* WHILE OCCURE(dwhSP) ... *)
  RESTORE(dwhSP);

  IF SELECT(DWHP, dwhSP, trgdwhSPSet, trgdwhSP) THEN
   DWHPWereFill:=0;
   WHILE OCCURE(DWHP) & ~DWHPWereFill DO
    DWHPWereFill:= ~!DWHP.StmpFill;
    IF DWHPWereFill THEN
     L_StdFrm.OrdinaryCHOICE("࠭ " + trgdwhSP + " '" + trgName + "'|" +
                             "  " + DWHP.DWH + "  ਮ " + PeriodStr(DWHP.PerB, DWHP.PerE) + " 뫠  묨 ⮏.|" +
                             "࠭ 㤥 㤠");
    END;
    NEXT(DWHP);
   END; (* WHILE OCCURE(DWHP) ... *)
  END;
  SE_INTEGRITY(1);
  SELECT(DWHP, dwhSP, , dwhSP.dwhSPSet, dwhSP.dwhSP);
  REMSEL(DWHP);
 END {dwhSP_OnBeforeDelete};

 PRIVATE PROCEDURE dwhSP_Name_OnSuccessfulChange();
 BEGIN
  SELECT(DWH, dwhSPSet, , dwhSP.dwhSPSet);
  WHILE OCCURE(DWH) DO
   SELECT(DWHP, dwhSP, , dwhSP.dwhSPSet, dwhSP.dwhSP, DWH.DWH);
   WHILE OCCURE(DWHP) DO
    DWHP.Name:=dwhSP.Name;
    REPLACE(DWHP);
    NEXT(DWHP);
   END; (* WHILE OCCURE(DWHP) ... *)
   NEXT(DWH);
  END; (* WHILE OCCURE(DWH) ... *)
 END {dwhSP_Name_OnSuccessfulChange};

 PRIVATE PROCEDURE dwhSP_Type_OnSuccessfulChange();
  VAR trg_dwhS : LIKE(dwhS.dwhS);
      trg_dwhSP: LIKE(dwhSP.dwhSP);
 BEGIN
  dwhSP.Leaf:=(dwhSP.Type = L_dwh.dwhSPT_Filled) | (dwhSP.Type = L_dwh.dwhSPT_Equal);
  REPLACE(dwhSP);
  RTI.Get().CurWindow.Zones(0).Fields("dwhSP.EqldwhSP").Modifiable:=dwhSP.Type = L_dwh.dwhSPT_Equal;
  IF GE_PVALUE() = L_dwh.dwhSPT_Summary THEN
   trg_dwhS :=dwhSP.dwhS;
   trg_dwhSP:=dwhSP.dwhSP;
   WHILE SELECT(dwhSP, SumdwhSP, trg_dwhS, trg_dwhSP) DO
    SETEMPTY(dwhSP.SumdwhSP);
    REPLACE(dwhSP);
   END;
  ELSIF GE_PVALUE() = L_dwh.dwhSPT_Equal THEN
   SETEMPTY(dwhSP.EqldwhSP);
   REPLACE(dwhSP);
  END;
  IF dwhSP.Type = L_dwh.dwhSPT_Summary THEN
   IF SELECT(dwhSPG, dwhS, dwhSP.dwhS, dwhSP.dwhSP) THEN
    L_StdFrm.JustQuestion("㯯 ᥩ , 室騥  ᯥ䨪 ࠭  㤠  ᯥ䨪樨");
    REMSEL(dwhSPG);
   END;
  END;
 END {dwhSP_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE DWHE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="DWH";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (0, ["DWH.Status", "DWH.PerE", "DWH.dwhS"]);
  L_WDO.iUnmodifiable(0, "DWH.DWH");
  L_WDO.iField       (0, "DWH.Status").Format:=L_dwh.st_Pool;
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iField       (1, "DWHP.State").Format:=L_dwh.ste_Pool;
  L_WDO.iField       (1, "DWHP.Calc").Format:=L_dwh.dwhCalc_Pool;
  L_WDO.iProgs       (1, "DWH");
  L_WDO.iEvents      (2, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete]);
  L_WDO.iUnmodifiable(2, ["DWHPL.IsPrimary", "DWHPL.Calc", "DWHPL.dwhI", "DWHPL.Number", "DWHPL.PlanSys", "DWHPL.FactSys"]);
  L_WDO.iMayBeEmpty  (2, ["DWHPL.PlanOper", "DWHPL.FactOper"]);
  L_WDO.iProgs       (2, "DWH");
 END {DWHE_OnInitializeWindow};

 PRIVATE PROCEDURE dwhSPG_OnAfterEdit();
 BEGIN
  CONFORM(dwhSPG, dwhSP);
  ApplyChanges_dwhSP(1);
 END {dwhSPG_OnAfterEdit};

 PRIVATE PROCEDURE dwhSPG_OnBeforeInsert();
 BEGIN
  CONFORM(dwhSPG, dwhSP);
  L_General.Assert(~dwhSP.Calc, "㯭  塞 ࠭");
 END {dwhSPG_OnBeforeInsert};

 PRIVATE PROCEDURE dwhSPG_OnAfterInsert();
 BEGIN
  CONFORM(dwhSPG, Group);
  L_dwh.CheckLegalOwnerCurGroup();
  CONFORM(dwhSPG, dwhSP);
  ApplyChanges_dwhSP(1);
 END {dwhSPG_OnAfterInsert};

 PRIVATE PROCEDURE dwhSPG_OnBeforeDelete();
 BEGIN
  CONFORM(dwhSPG, dwhSP);
  ApplyChanges_dwhSP(1);
 END {dwhSPG_OnBeforeDelete};

 PRIVATE PROCEDURE SetCurCellNumberFormat(objWS: OBJECT; _Format: STRING[]);
  VAR
   objCell: OBJECT;
   _Row,
   _Col   : NUMERIC[0];
 BEGIN
  L_Excel.ws_GetCurPos(objWS, _Row, _Col);
  objCell:=objWS.Cells(_Row, _Col);
  objCell.NumberFormat:=_Format;
  objCell.EntireColumn.AutoFit();
 END {SetCurCellNumberFormat};

 PRIVATE PROCEDURE dwhSPE_0_OnZoneOpen();
  VAR
   Fields: FORMFIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("dwhSP.Calc").Format  :=L_dwh.dwhCalc_Pool;
  Fields("dwhSP.Calc").Template:=L_dwh.dwhCalc_Pool;
 END {dwhSPE_0_OnZoneOpen};

 PUBLIC PROCEDURE scs_GetFilters_DWHE_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "࠭, ॡ騥 ", "(DWHP.Calc=0)", 1);
 END {scs_GetFilters_DWHE_1};

 PUBLIC PROCEDURE scs_GetFilters_DWHE_2(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "ப,   ",
                              "(DWHPL.Calc=0) & (DWHPL.IsPrimary=1) & (DWHPL.dwhI#3)", 1);
  L_WDO.PutNewFilter(Filters, "ப, 易⥫  ",
                              "((DWHPL.PlanIsReq=1) | (DWHPL.FactIsReq=1))", 1);
 END {scs_GetFilters_DWHE_2};

 PRIVATE PROCEDURE InformAboutShiftTab();
 BEGIN
  L_StdFrm.Inform("ᯮ ShiftTab.  01.03.2013 ⡮  㤥 ᤥ ⮫쪮 ⠬");
 END {InformAboutShiftTab};

 PUBLIC PROCEDURE DWHPL_RemoveAllUserFilters();
 BEGIN
  InformAboutShiftTab();
 END {DWHPL_RemoveAllUserFilters};

 PUBLIC PROCEDURE DWHPL_SetUserFilter_LinesThatCanBeFilled();
 BEGIN
  InformAboutShiftTab();
 END {DWHPL_SetUserFilter_LinesThatCanBeFilled};

 PUBLIC PROCEDURE DWHPL_SetUserFilter_LinesThatAreRequired();
 BEGIN
  InformAboutShiftTab();
 END {DWHPL_SetUserFilter_LinesThatAreRequired};

 PUBLIC PROCEDURE DWHP_ToggleFilter();
 BEGIN
  InformAboutShiftTab();
 END {DWHP_ToggleFilter};

 PRIVATE PROCEDURE DWHPL_SetSysValues();
  VAR
   P: PROC;
 BEGIN
  P:=PROCREF("dwhIFunc."+dwhI.ShortN);
  L_General.CallUs(~!P);
  L_General.CallUs(SEARCH(dwhSP, dwhSPSet, DWHPL.dwhSPSet, DWHPL.dwhSP));
  IF dwhSP.PlCanBe & (dwhI.MustPlan # L_dwh.mstPln_NoPlan) THEN
   DWHPL.PlanSys:=UseFormat(P(0), DWHPL.Format, dwhI.Div1000, dwhI.SpecCond);
  END;
  DWHPL.FactSys:=UseFormat(P(1), DWHPL.Format, dwhI.Div1000, dwhI.SpecCond);
  REPLACE(DWHPL);
 END {DWHPL_SetSysValues};

 PRIVATE PROCEDURE CompleteDWHPNeedAsk(VAR NeedAsk: SCAL[2]);
  VAR
   oPrompt: PROMPTLINE;
   dummy  : SCAL[2];
 BEGIN
  AccessDWHP();
  dummy:=L_dwh.Check_dwhSPIsActive(1);
  L_General.Assert(~DWHP.Calc, "㯭  塞 ࠭");
  IF NeedAsk & (DWHP.State > L_dwh.ste_Prepared) THEN
   L_StdFrm.JustQuestion("࠭ " + DWHP.Number + " 㦥 .| ⢨⥫쭮    ?");
   NeedAsk:=0;
  END;
  oPrompt:=PROMPTLINE.Create("  ⥫");
  SELECT(DWHPL, DWHP, , DWHP.DWH, DWHP.DWHP);
  WHILE OCCURE(DWHPL) DO
   IF DWHPL.IsPrimary THEN    (* ? *)
    CONFORM(DWHPL, dwhI);
    IF dwhI.Origin = L_dwh.dwhiorig_Sys THEN
     PROMPT("࠭ " + FLDTOSTR(DWHP.Number) + " ⥫ '" + dwhI.Name + "'");
     DWHPL_SetSysValues();
    END;
   END;
   NEXT(DWHPL);
  END; (* WHILE OCCURE(DWHPL) ... *)
  DWHP.StmpFill:= SYSTIMESTAMP();
  REPLACE(DWHP);
  DWHP_Calculate();
 END {CompleteDWHPNeedAsk};

 PUBLIC PROCEDURE CompleteDWHP();
  VAR
   NeedAsk: SCAL[2];
 BEGIN
  NeedAsk:=1;
  CompleteDWHPNeedAsk(NeedAsk);
  CalculateCurDWHP();
 END {CompleteDWHP};

 PUBLIC PROCEDURE CompleteDWH();
  VAR
   NeedAsk: SCAL[2];
 BEGIN
  AccessDWH();
  CheckAllFieldsDWH();
  IF ~SELECT(DWHP, DWH, DWH.DWH) THEN
   PrepareDWH();
  END;

  NeedAsk:=1;
  WHILE OCCURE(DWHP) DO
   CONFORM(DWHP, dwhSP);
   IF ~DWHP.Calc & L_dwh.Check_dwhSPIsActive(0) THEN
    CompleteDWHPNeedAsk(NeedAsk);
   END; (* IF ~DWHP.Calc & ... *)
   NEXT(DWHP);
  END; (* WHILE OCCURE(DWHP) ... *)

  CalculateCurDWH();
  STDMSG(" ", INFORM);
 END {CompleteDWH};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
############################################################# ########## #####

=#####========================================================================
|                          ᯮ짮                             |
|############################################################################|
|                                 㫠                                  |
|----------------------------------------------------------------------------|
|                                      |㫠                       |
|---------------------------------------------|------------------------------|
}
*)

(*
$P{ Line:
dwhI.dwhI, L, ""
dwhI.Identif, L, ""
dwhI.ShortN, L, ""
dwhI.Formula, L, ""
@
|### ######## ################################|##############################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 PUBLIC PROCEDURE UseInFormulas();
  CONST
   RepName = "UseFl";
  VAR
   trgIdentif: LIKE(dwhI.Identif);
   trgShortN : LIKE(dwhI.ShortN);
   trg_dwhI  : LIKE(dwhI.dwhI);
   Consist   : STRING[];
 BEGIN
  L_General.Assert(ACCESS(dwhI), "騩    ।");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, dwhI.dwhI + " " + dwhI.ShortN + " (" + dwhI.Identif + ")");
  trgIdentif:=dwhI.Identif;
  trgShortN :=dwhI.ShortN;
  trg_dwhI  :=dwhI.dwhI;
  SAVE(dwhI);
  SELECT(dwhI, dwhI);
  WHILE OCCURE(dwhI) DO
   IF dwhI.Calc THEN
    IF ~!L_Str.PositionInPool(GetdwhIConsist(dwhI.dwhI), trgIdentif) THEN
     MAKEPART(R, Line);
    END;
   END;
   NEXT(dwhI);
  END; (* WHILE OCCURE(dwhI) ... *)
  RESTORE(dwhI);
  MAKEPART(R, Bot);
  CLOSEREP(R);
  LIKEMENU(Survey, "");
 END {UseInFormulas};

BEGIN
 L_Events.ExecuteHandler();
END.



