(*
%Copyright   (c) Polak Computer System
%Author      22.07.2010 19:37:18 POLAK\MLB
%Purpose     Data Warehouse
%Type        operation
%Specific    SYS
%Modified    15.12.2010 11:07:20 POLAK\MLB
%Environment
*)
 MODULE DWH01;

 IMPORT
  L_General, L_dwh, L_Basis, FIO, L_Str, L_DatTim, L_AFM;

  CONST
   RepName = "DWH01";

 PRIVATE PROCEDURE Create_tmpDWHPL();
 BEGIN
  CreateFILE(tmpDWHPL, "", "", "");

  CreateFIELD(tmpDWHPL, dwhSPSet,    SCAL[1E3],  "", "", "", "", "");
  CreateFIELD(tmpDWHPL, dwhSP,       SCAL[1E3],  "", "", "", "", "");
  CreateFIELD(tmpDWHPL, dwhI,        SCAL[1E3],  "", "", "", "", "");
  CreateFIELD(tmpDWHPL, Number,      SCAL[1E4],  "", "", "", "", "");
  CreateFIELD(tmpDWHPL, Plan,        NUMERIC[3], "", "", "", "", "");
  CreateFIELD(tmpDWHPL, Fact,        NUMERIC[3], "", "", "", "", "");
  CreateFIELD(tmpDWHPL, FactPrevPer, NUMERIC[3], "", "", "", "", "");

  CreateINDEX(tmpDWHPL, Number, UNIQUE, "", "", dwhSPSet, dwhSP, Number, dwhI);

  SetVersionOfFILE(tmpDWHPL, 0);
  L_AFM.AF_CreateTemp("tmpDWHPL", "tmpDWHPL");
 END {Create_tmpDWHPL};

 PRIVATE PROCEDURE MakeTop();
 BEGIN
  L_Basis.wb_WrInQM('R', "࠭ ");
  L_Basis.wb_WrInQM('R', "࠭ ");
  L_Basis.wb_WrInQM('R', " ⥫");
  L_Basis.wb_WrInQM('R', "N/");
  L_Basis.wb_WrInQM('R', "⥫");
  L_Basis.wb_WrInQM('R', " ७");
  L_Basis.wb_WrInQM('R', " 諮 ");
  L_Basis.wb_WrInQM('R', "");
  L_Basis.wb_WrInQM('R', "");
  L_Basis.wb_WrInQM('R', "%");
  L_Basis.wb_WrInQM('R', " 諮 , %");
  L_Basis.wb_TermLine('R');
 END {MakeTop};

 PRIVATE PROCEDURE Devide(Value1, Value2: NUMERIC[3]): NUMERIC[3];
 BEGIN
  IF !Value1 & !Value2 THEN
   RETURN L_General.EMPTY_NUMBER();
  ELSIF ~!Value1 & ~!Value2 & (Value2 # 0) THEN
   RETURN Value1/Value2;
  ELSE
   RETURN 0;
  END;
 END {ChooseValueByCondition};

 PRIVATE PROCEDURE WriteNumericValueToExcel(Value: NUMERIC[3]);
 BEGIN
  IF ~!Value THEN
   L_Basis.wb_WrNum('R', Value, 3);
  ELSE
   L_Basis.wb_WrStr('R', "");
  END;
 END {WriteNumericValueToExcel};

 PRIVATE PROCEDURE MakeLine();
 BEGIN
  L_General.CallUs(SEARCH(dwhSP, dwhSPSet, tmpDWHPL.dwhSPSet, tmpDWHPL.dwhSP));
  L_General.CallUs(SEARCH(dwhI, dwhI,  tmpDWHPL.dwhI));
  L_Basis.wb_WrNum('R', dwhSP.Number, 0);
  L_Basis.wb_WrStr('R', dwhSP.Name);
  L_Basis.wb_WrStr('R', L_Str.PoolItem(L_dwh.dwhiType_Pool, dwhI.Type));
  L_Basis.wb_WrNum('R', tmpDWHPL.Number, 0);
  L_Basis.wb_WrStr('R', dwhI.Name);
  L_Basis.wb_WrStr('R', L_Str.PoolItem(" | ", dwhI.Div1000) + dwhI.Unit);
  WriteNumericValueToExcel(tmpDWHPL.FactPrevPer);
  WriteNumericValueToExcel(tmpDWHPL.Plan);
  WriteNumericValueToExcel(tmpDWHPL.Fact);
  WriteNumericValueToExcel(Devide(tmpDWHPL.Fact, tmpDWHPL.Plan));
  WriteNumericValueToExcel(Devide(tmpDWHPL.Fact, tmpDWHPL.FactPrevPer));
  L_Basis.wb_TermLine('R');
 END {MakeLine};

 PRIVATE PROCEDURE GetDWHPoolByThePeriod(B,
                                         E        : DATE;
                                         trgdwhS  : LIKE(dwhS.dwhS);
                                         trgMyFirm: LIKE(MyFirm.MyFirm)): STRING[];
  VAR
   D             : DATE;
   Result        : STRING[];
   trgDWH        : LIKE(DWH.DWH);
   trgMonthsInDWH: NUMERIC[0];
 BEGIN
  SETEMPTY(Result);
  IF ~!B & ~!E THEN
   D             :=B;
   trgMonthsInDWH:=0;
   SAVE(DWH);
   WHILE D<=E DO
    L_General.Assert(SELECT(DWH, dwhS, trgdwhS, trgMyFirm, D), "   " + L_DatTim.PeriodStr(D));
    SETEMPTY(trgDWH);
    trgMonthsInDWH:=0;
    WHILE OCCURE(DWH) & (DWH.PerB <= E) DO
     IF (DWH.PerE <= E) & (DWH.Status = L_dwh.st_Passed) THEN
      IF !trgDWH | (L_DatTim.MonthsInIntvl(DWH.PerB, DWH.PerE) > trgMonthsInDWH) THEN
       trgDWH        :=DWH.DWH;
       trgMonthsInDWH:=L_DatTim.MonthsInIntvl(DWH.PerB, DWH.PerE);
      END;
     END;
     NEXT(DWH);
    END; (* WHILE OCCURE(DWH) ... *)
    L_General.Assert(~!trgDWH, "   " + L_DatTim.PeriodStr(D) + ",  , 騩  ਮ  ஢");
    SEARCH(DWH, DWH, , trgDWH);
    D:=DWH.PerE + 1;
    IF !Result THEN
     Result:=trgDWH
    ELSE
     Result:=Result + "|" + trgDWH;
    END;
   END;
   RESTORE(DWH);
  END;
  RETURN Result;
 END {GetDWHPoolByThePeriod};

 PRIVATE PROCEDURE GetPlan(): LIKE(DWHPL.PlanOper);
 BEGIN
  IF    ~!DWHPL.PlanOper THEN
   RETURN DWHPL.PlanOper;
  ELSE
   RETURN DWHPL.PlanSys;
  END;
 END {GetPlan};

 PRIVATE PROCEDURE GetFact(): LIKE(DWHPL.FactOper);
 BEGIN
  IF    ~!DWHPL.FactOper THEN
   RETURN DWHPL.FactOper;
  ELSE
   RETURN DWHPL.FactSys;
  END;
 END {GetFact};

 PRIVATE PROCEDURE ThisIsLastDWHInPool(DWH_Pool: STRING[]; Idx: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN !L_Str.PoolItem(DWH_Pool, Idx + 1);
 END {ThisIsLastDWHInPool};

 PRIVATE PROCEDURE Inc_tmpDWHPL(VAR Value    : NUMERIC[3];
                                    Increment: NUMERIC[3]);
 BEGIN
  IF ~!Value THEN
   Value:=Value + Increment;
  ELSE
   Value:=Increment;
  END;
  REPLACE(tmpDWHPL);
 END {Inc_tmpDWHPL};

 PRIVATE PROCEDURE AddTotmpDWHPL(DWH_Pool: STRING[]; ThisIsCurPer: SCAL[2]);
  VAR
   trgDWH : LIKE(DWH.DWH);
   trgDWHP: LIKE(DWHP.DWHP);
   Idx    : NUMERIC[0];
   Plan,
   Fact   : NUMERIC[3];
   Find   : SCAL[2];
 BEGIN
  Idx:=0;
  WHILE ~!L_Str.PoolItem(DWH_Pool, Idx) DO
   trgDWH:=L_Str.PoolItem(DWH_Pool, Idx);
   SELECT(DWHP, DWH, , trgDWH);
   WHILE OCCURE(DWHP) DO
    trgDWHP:=DWHP.DWHP;
    PROMPT(": " + FLDTOSTR(DWHP.Number));
    SELECT(DWHPL, Number, , trgDWH, trgDWHP);
    WHILE OCCURE(DWHPL) DO
     IF ( DWHPL.MthAdd = L_dwh.MA_Sum) |
        ((DWHPL.MthAdd = L_dwh.MA_Last) & ThisIsLastDWHInPool(DWH_Pool, Idx)) THEN
      Plan:=GetPlan();
      Fact:=GetFact();
      IF SEARCH(tmpDWHPL, Number, DWHPL.dwhSPSet, DWHPL.dwhSP, DWHPL.Number, DWHPL.dwhI) THEN
       IF ~!Plan & ThisIsCurPer THEN
        Inc_tmpDWHPL(tmpDWHPL.Plan, Plan);
       END;
       IF ~!Fact THEN
        IF ThisIsCurPer THEN
         Inc_tmpDWHPL(tmpDWHPL.Fact, Fact);
        ELSE
         Inc_tmpDWHPL(tmpDWHPL.FactPrevPer, Fact);
        END;
       END;
      ELSE
       DEFAULT(tmpDWHPL);
       tmpDWHPL.dwhSPSet    :=DWHPL.dwhSPSet;
       tmpDWHPL.dwhSP       :=DWHPL.dwhSP;
       tmpDWHPL.Number      :=DWHPL.Number;
       tmpDWHPL.dwhI        :=DWHPL.dwhI;
       IF ThisIsCurPer THEN
        tmpDWHPL.Plan       :=Plan;
        tmpDWHPL.Fact       :=Fact;
       ELSE
        tmpDWHPL.FactPrevPer:=Fact;
       END;
       INSERT(tmpDWHPL);
      END;
     END;
     NEXT(DWHPL);
    END; (* WHILE OCCURE(DWHPL) ... *)
    NEXT(DWHP);
   END; (* WHILE OCCURE(DWHP) ... *)
   INC(Idx);
  END;
 END {AddTotmpDWHPL};

 PRIVATE PROCEDURE MakeExcel();
  TYPE
   tPerIdx   = SCAL[3];
   tYearsIdx = SCAL[2];

  CONST
   pid_DWHPer     = 0; (* tPerIdx *)
   pid_Quartal    = 1;
   pid_Cumulative = 2;

   yid_OneYear    = 0; (* tYearsIdx *)
   yid_TwoYear    = 1;

  VAR
   PerIdx         : tPerIdx;
   YearsIdx       : tYearsIdx;
   CurPerB,
   CurPerE,
   PrevPerB,
   PrevPerE       : DATE;
   PrevPerStr     : STRING[];
   trgDWH         : LIKE(DWH.DWH);
   trgName        : LIKE(dwhS.Name);
   DWHCurPer_Pool,
   DWHPrevPer_Pool: STRING[];
   oPrompt        : PROMPTLINE;
   PrevYearStr,
   CurQuartalStr,
   CurYearFromBegStr: STRING[];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.Assert(ACCESS(DWH), " ⠭ ⥪騩  ");
  L_General.Assert(DWH.Status = L_dwh.st_Passed, "  ஢");
  trgDWH:=DWH.DWH;
  CONFORM(DWH, dwhS);
  trgName:=dwhS.Name;
  SETZERO(PerIdx, YearsIdx);
  PrevYearStr      :=L_Str.IntStr(L_DatTim.YEAR(L_DatTim.IncYear(DWH.PerB, -1)));
  CurQuartalStr    :=L_Str.PoolItem("I|II|III|IV", L_DatTim.QUARTAL(DWH.PerB)) +" ⠫ " + L_Str.IntStr(L_DatTim.YEAR(DWH.PerB)) + " ";
  CurYearFromBegStr:=" 01." + L_Str.IntStr(L_DatTim.YEAR(DWH.PerB)) + "  " + L_DatTim.PeriodStr(DWH.PerE);
  STDFORM("|" +
          "                            ࠢ  " + PrevYearStr + " |" +
          "%22,3<騩 |" + CurQuartalStr + "|" + CurYearFromBegStr  + ">O" +
          " " +
          "%20,3<|>O" +
          "|||" +
          "|%< {}믮 >DB       %< {}⬥ >X",
          "롮 ⭮ ", , -1, PerIdx, YearsIdx);
  IF    PerIdx = pid_DWHPer THEN
   CurPerB:=DWH.PerB;
   CurPerE:=DWH.PerE;
  ELSIF PerIdx = pid_Quartal THEN
   CurPerB:= L_DatTim.MonthBeg(STRTOFLD("01\" + L_Str.FixedIntStr(L_DatTim.QUARTAL(DWH.PerB) * 3 + 1, 2) + "\" + L_Str.IntStr(L_DatTim.YEAR(DWH.PerB)), DATE));
   CurPerE:= L_DatTim.MonthEnd(STRTOFLD("01\" + L_Str.FixedIntStr(L_DatTim.QUARTAL(DWH.PerB) * 3 + 3, 2) + "\" + L_Str.IntStr(L_DatTim.YEAR(DWH.PerB)), DATE));
  ELSIF PerIdx = pid_Cumulative THEN
   CurPerB:=STRTOFLD("01\01\" + L_Str.IntStr(L_DatTim.YEAR(DWH.PerB)), DATE);
   CurPerE:=DWH.PerE;
  ELSE
   L_General.CallUs(0);
  END;
  IF    YearsIdx = yid_OneYear THEN
   SETEMPTY(PrevPerB, PrevPerE, PrevPerStr);
  ELSIF YearsIdx = yid_TwoYear THEN
   PrevPerB  := L_DatTim.IncYear(CurPerB, -1);
   PrevPerE  := L_DatTim.MonthEnd(L_DatTim.IncYear(L_DatTim.MonthBeg(CurPerE), -1));
   PrevPerStr:= " ( ࠢ  ਮ  " + L_DatTim.DateStr(PrevPerB) + "  " + L_DatTim.DateStr(PrevPerE) + ")";
  ELSE
   L_General.CallUs(0);
  END;
  DWHCurPer_Pool :=GetDWHPoolByThePeriod(CurPerB,  CurPerE,  dwhS.dwhS, DWH.MyFirm);
  DWHPrevPer_Pool:=GetDWHPoolByThePeriod(PrevPerB, PrevPerE, dwhS.dwhS, DWH.MyFirm);
  Create_tmpDWHPL();
  oPrompt:=PROMPTLINE.Create("㧪  MS Excel (᢮ ⠡)");
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeTop();
  AddTotmpDWHPL(DWHCurPer_Pool, 1);
  AddTotmpDWHPL(DWHPrevPer_Pool, 0);
  SELECT(tmpDWHPL, Number);
  WHILE OCCURE(tmpDWHPL) DO
   PROMPT("㧪: " + L_Str.IntStr(tmpDWHPL.Number));
   MakeLine();
   NEXT(tmpDWHPL);
  END; (* WHILE OCCURE(tmpDWHPL) ... *)
  FIO.Close(R);
  L_AFM.AF_PurgeTemp("tmpDWHPL");
  L_Basis.ExtPlayMakedRunTimeRep(RepName,
                                 trgDWH,
                                 L_General.timeCond_Entire,
                                 trgName +
                                 "  ਮ  " + L_DatTim.PeriodStr(CurPerB) +
                                 "  "          + L_DatTim.PeriodStr(CurPerE) +
                                 PrevPerStr,
                                 0);
 END {MakeExcel};

BEGIN
END.