(*
%Copyright   (c) Polak Computer System
%Author      23.07.2010 18:18:45 POLAK\MLB
%Purpose      ⮢ 묨 ⮏. ᯮ  ⥪ ⥪饩 ࠭.
%Type        operation
%Specific    SYS
%Modified    05.02.2014 19:07:08 POLAK\LDA
%Environment
*)

 MODULE dwhIFunc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_dwh, L_General, Str, DBD, L_Str, L_DBD, L_DatTim, L_Env, L_AFM, D_CarTb,
        D_TP, L_Car, L_Way;

 PRIVATE TYPE
  tItemIntermediateValue = NUMERIC[6];

 CONST
  b_Amount = 3;
  b_CarTb2 = 0;
  b_TP002  = 1;
  b_T2102  = 2;

 PRIVATE VAR
  SysdwhI_Is_Allready_Filled: SCAL[2][b_Amount];
  AllBasisPrepared          : SCAL[2];


(* ------------- PRIVATE PROCS ----------------------- *)
 PRIVATE PROCEDURE Create_dwhSPGE();
 BEGIN
  CreateFILE(dwhSPGE, "", "", "ন 㯯 ᥩ  ᯥ䨪樨 ࠭");

  CreateFIELD(dwhSPGE, dwhSP,    LIKE(dwhSP.dwhSP),       "", "", "", "", "");
  CreateFIELD(dwhSPGE, Owner,    LIKE(Group.Owner),       "", "", "", "", "");
  CreateFIELD(dwhSPGE, riOwner,  LIKE(GroupE.riOwner),    "", "", "", "", "");
  CreateFIELD(dwhSPGE, Check,    SCAL[2],              "", "", "", "", "");

  CreateINDEX(dwhSPGE, dwhSPGE,   UNIQUE, "", "", dwhSP, Owner, Check, riOwner);

  SetVersionOfFILE(dwhSPGE, 0001);
  L_AFM.AF_CreateTemp("dwhSPGE", "dwhSPGE");
 END {Create_dwhSPGE};

 PRIVATE PROCEDURE Create_SysdwhI();
 BEGIN
  CreateFILE(SysdwhI, "", "", "");

  CreateFIELD(SysdwhI, dwhSP,  LIKE(dwhSP.dwhSP),       "", "", "", "", "");
  CreateFIELD(SysdwhI, dwhISN, LIKE(dwhI.ShortN),       "", "", "", "", "");
  CreateFIELD(SysdwhI, Plan,   tItemIntermediateValue,  "", "", "", "", "");
  CreateFIELD(SysdwhI, Fact,   tItemIntermediateValue,  "", "", "", "", "");

  CreateINDEX(SysdwhI, dwhSP,  UNIQUE,   "", "", dwhSP, dwhISN);
  CreateINDEX(SysdwhI, dwhISN, PLURAL,   "", "", dwhISN);

  SetVersionOfFILE(SysdwhI, 0001);
  L_AFM.AF_CreateTemp("SysdwhI", "SysdwhI");
 END {Create_SysdwhI};

 PRIVATE PROCEDURE Check_riOwner(): SCAL[2];
  VAR
   Result  : SCAL[2];
   trgRI   : LIKE(GroupE.riOwner);
   trgOwner: LIKE(Group.Owner);
 BEGIN
  trgRI   :=GroupE.riOwner;
  trgOwner:=GroupE.Owner;
  SAVE(GroupE);
  SAVE(dwhSPG);
  Result:=1;
  SELECT(dwhSPG, dwhSP, , dwhSP.dwhSPSet, dwhSP.dwhSP);
  WHILE OCCURE(dwhSPG) & Result DO
   CONFORM(dwhSPG, Group);
   IF Group.Owner = trgOwner THEN
    Result:=SELECT(GroupE, GriO, Group.Group, trgRI);
   END;
   NEXT(dwhSPG);
  END; (* WHILE OCCURE(dwhSPG) *)
  RESTORE(dwhSPG);
  RESTORE(GroupE);
  RETURN Result;
 END {Check_riOwner};

 PRIVATE PROCEDURE Fill_dwhSPGE(trg_dwhSPSet: LIKE(dwhSPSet.dwhSPSet));
 BEGIN
  SELECT(dwhSP, dwhSPSet, , trg_dwhSPSet);
  WHILE OCCURE(dwhSP) DO
   IF ~dwhSP.Calc THEN
    SELECT(dwhSPG, dwhSP, , dwhSP.dwhSPSet, dwhSP.dwhSP);
    WHILE OCCURE(dwhSPG) DO
     SELECT(GroupE, Group, , dwhSPG.Group);
     WHILE OCCURE(GroupE) DO
      IF L_DatTim.IsActiveInIntvl(DWH.PerB, DWH.PerE, GroupE.Begin, GroupE.Till) THEN
       ADD(dwhSPGE, dwhSPGE, ,
           dwhSPG.dwhSP, GroupE.Owner, Check_riOwner(), GroupE.riOwner);
      END;
      NEXT(GroupE);
     END; (* WHILE OCCURE(GroupE) ... *)
     NEXT(dwhSPG);
    END; (* WHILE OCCURE(dwhSPG) *)

    SELECT(dwhSPGE, dwhSPGE, , dwhSP.dwhSP);
    WHILE OCCURE(dwhSPGE) DO
     NARROWSEL(dwhSPGE, Owner);
     SAVE(dwhSPGE);
     L_General.Assert(SELECT(dwhSPGE, dwhSPGE, dwhSP.dwhSP, dwhSPGE.Owner, 1),
                      "㯯 ᥩ  ᯥ䨪樨 ࠭ " + dwhSP.dwhSP + " '" + dwhSP.Name+ "'|" +
                      " ᮤঠ ");
     RESTORE(dwhSPGE);
     NEXTINEXTENDEDSEL(dwhSPGE, Owner);
    END; (* WHILE OCCURE(dwhSPGE) ... *)
   END; (* IF ~dwhSP.Calc *)
   NEXT(dwhSP);
  END; (* WHILE OCCURE(dwhSP) ... *)
 END {Fill_dwhSPGE};

 PRIVATE PROCEDURE BasisRecordIsInPage(trg_dwhSP: LIKE(dwhSP.dwhSP)): SCAL[2];
  VAR
   Result     : SCAL[2];
   OwnerName  : STRING[];
   trg_riOwner: LIKE(GroupE.riOwner);
 BEGIN
  IF SELECT(dwhSPGE, dwhSPGE, trg_dwhSP) THEN
   Result:=1;
  ELSE
   Result:=0;
  END;
  WHILE OCCURE(dwhSPGE) & Result DO
   NARROWSEL(dwhSPGE, Owner);
   OwnerName  :=DBD.FileIdToName(dwhSPGE.Owner);
   IF OCCURE(^(OwnerName)) THEN
    trg_riOwner:=^(OwnerName).RECORDID;
    IF ~SRCINSEL(dwhSPGE, EQ, 1, trg_riOwner) THEN
     Result:=0;
    END;
   ELSE
    Result:=0;
   END;
   NEXTINEXTENDEDSEL(dwhSPGE, Owner);
  END; (* WHILE OCCURE(dwhSPGE) ... *)
  RETURN Result;
 END {BasisRecordIsInPage};

 PRIVATE PROCEDURE PrepareAllBasisForCurDWH();
  VAR
   b_Num: NUMERIC[0];
 BEGIN
  IF ~L_General.VariableIsInitialized(AllBasisPrepared) THEN
   Create_dwhSPGE();
   Create_SysdwhI();
 
   Fill_dwhSPGE(DWH.dwhSPSet);

   SE_ACCESSDATAMODE(AccessDataMode_SOFT);
   D_CarTb.Prepare_CarTb2(DWH.PerB, DWH.PerE);
   D_TP.extPrepareTP002(DWH.PerB, DWH.PerE, 0);
   D_TP._PrepareSEJ01(DWH.PerB, DWH.PerE, 0, 1);
   D_TP._Prepare_T2102(DWH.PerB, DWH.PerE);;

   AllBasisPrepared:=1;
 
   b_Num:=0;
   WHILE b_Num < b_Amount DO
    SysdwhI_Is_Allready_Filled[b_Num]:=0;
    INC(b_Num);
   END;
  END;
 END {PrepareAllBasisForCurDWH};

 PRIVATE PROCEDURE Add(ShortN: STRING[]; Value: tItemIntermediateValue);
 BEGIN
  ADD(SysdwhI, dwhSP, , dwhSP.dwhSP, ShortN, SysdwhI.Fact, Value);
 END {Add};

 PRIVATE PROCEDURE TP002_GetValue(ShortName: STRING[]): L_dwh.tItemValue;
  VAR
   Cnt    : NUMERIC[0];
   oPrompt: PROMPTLINE;
 BEGIN
  PrepareAllBasisForCurDWH();

  IF ~SysdwhI_Is_Allready_Filled[b_TP002] THEN
   oPrompt:=PROMPTLINE.Create("஢ ࠭ 䠩 TP002");
   Cnt:=0;
   SELECT(TP002, TP002);
   WHILE OCCURE(TP002) DO
    PROMPT(" " + TP002.BoxNbr);
    IF (TP002.MyFirm = DWH.MyFirm) & L_Env.RealBoxNbr(TP002.BoxNbr) THEN
     L_Car.StandOnCarLog(TP002.BoxNbr, TP002.clDate);
     CONFORM(CarLog, Mark);
     CONFORM(TP002, Route);
     CONFORM(Route, TKind);
     CONFORM(TP002, WJMode);
     SEARCH(TPD01, TP002, , TP002.TP002);
     SELECT(dwhSP, dwhSPSet, , DWH.dwhSPSet);
     WHILE OCCURE(dwhSP) DO
      IF ~dwhSP.Calc & BasisRecordIsInPage(dwhSP.dwhSP)THEN
       INC(Cnt);
       Add("஡ᠦ",     TP002.RunPass);
       Add("ᠦ댎",     TP002.VldPsg[L_Way.vpk_MoscowRegion] + TP002.VldPsg[L_Way.vpk_OtherSocial]);
       Add("ᠦ",      TP002.VldPsg[L_Way.vpk_Moscow]);
       Add("ᠦ",     0);
       Add("ᠦ돫",   TP002.Pass + TP002.VldPsg[L_Way.vpk_Paid]);
       Add("Ꭱ",       TP002.PassRound + TP002.VldPsgRound);
       Add("믁",  TP002.GoodTrips);
       Add("믑",    TP002.BadTrips);
       Add("",        D_TP.TPD01_FullOrdTim(D_TP.otp_WIM));
       Add("⮥", D_TP.TPD01_FullOrdTim(D_TP.otp_Whl) - D_TP.TPD01_FullOrdTim(D_TP.otp_WIM));
       IF (WJMode.WJType = L_Way.WJType_Repair) & L_Way.E_IsRepInLine(DWH.PerE) THEN
        Add("",   TP002.OrdTim);
       ELSE
        Add("",   0);
       END;
      END; (* IF ~dwhSP.Calc *)
      NEXT(dwhSP);
     END; (* WHILE OCCURE(dwhSP) *)
    END; (* IF L_Env.RealBoxNbr(TP002.BoxNbr) ... *)
    NEXT(TP002);
   END; (* WHILE OCCURE(TP002) *)

   IF (Cnt > 0) & ~SELECT(SysdwhI, dwhISN, ShortName) THEN
    L_General.CallUs(0);
   END;
   SysdwhI_Is_Allready_Filled[b_TP002]:=1;
  END; (* IF ~SysdwhI_Is_Allready_Filled *)

  IF SEARCH(SysdwhI, dwhSP, DWHP.dwhSP, ShortName) THEN
   RETURN SysdwhI.Fact;
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {TP002_GetValue};

 PRIVATE PROCEDURE CarTb2_GetValue(ShortName: STRING[]): L_dwh.tItemValue;
  VAR
   Cnt    : NUMERIC[0];
   oPrompt: PROMPTLINE;
 BEGIN
  PrepareAllBasisForCurDWH();

  IF ~SysdwhI_Is_Allready_Filled[b_CarTb2] THEN
   oPrompt:=PROMPTLINE.Create("஢ ࠭ 䠩 CarTb2");
   Cnt:=0;
   SELECT(CarTb2, BoxNbr);
   WHILE OCCURE(CarTb2) DO
    IF (CarTb2.MyFirm = DWH.MyFirm) &  L_Env.RealBoxNbr(CarTb2.BoxNbr) THEN
     IF ~!CarTb2.BoxNbr THEN
      PROMPT(" " + CarTb2.BoxNbr);
     END;
     IF ~!CarTb2.TKind THEN
      CONFORM(CarTb2, TKind);
      CONFORM(CarTb2, Mark);
      CONFORM(CarTb2, Route);
      SELECT(dwhSP, dwhSPSet, , DWH.dwhSPSet);
      WHILE OCCURE(dwhSP) DO
       IF ~dwhSP.Calc & BasisRecordIsInPage(dwhSP.dwhSP) THEN
        INC(Cnt);
        Add("஡",            CarTb2.Run);
        Add("",           CarTb2.DIO);
        Add("",           CarTb2.RCarDays[D_CarTb.rcd_Line]);
        Add("₈", CarTb2.RCarDays[D_CarTb.rcd_Outage]);
        Add("ℭ",        D_CarTb.PVSitting(CarTb2.DIO, DWH.PerE));
        Add("ℭ",        D_CarTb.PVSitting(CarTb2.RCarDays[D_CarTb.rcd_Line], DWH.PerE));
        Add("",  CarTb2.RCarDays[D_CarTb.rcd_Repair]);
        Add("।ℭ",   D_CarTb.PVLim(CarTb2.DIO, DWH.PerE));
       END; (* IF ~dwhSP.Calc *)
       NEXT(dwhSP);
      END; (* WHILE OCCURE(dwhSP) *)
     END;
    END; (* IF L_Env.RealBoxNbr(CarTb2.BoxNbr) ... *)
    NEXT(CarTb2);
   END; (* WHILE OCCURE(CarTb2) *)
   IF (Cnt > 0) & ~SELECT(SysdwhI, dwhISN, ShortName) THEN
    L_General.CallUs(0);
   END;
   SysdwhI_Is_Allready_Filled[b_CarTb2]:=1;
  END; (* IF ~SysdwhI_Is_Allready_Filled *)

  IF SEARCH(SysdwhI, dwhSP, DWHP.dwhSP, ShortName) THEN
   RETURN SysdwhI.Fact;
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {CarTb2_GetValue};

 PRIVATE PROCEDURE T2102_GetValue(ShortName: STRING[]): L_dwh.tItemValue;
  VAR
   Cnt    : NUMERIC[0];
   oPrompt: PROMPTLINE;
 BEGIN
  PrepareAllBasisForCurDWH();

  IF ~SysdwhI_Is_Allready_Filled[b_T2102] THEN
   oPrompt:=PROMPTLINE.Create("롮ઠ   T2102");
   Cnt:=0;
   SELECT(T2102, Route);
   WHILE OCCURE(T2102) DO
    IF T2102.MyFirm = DWH.MyFirm THEN
     CONFORM(T2102, TKind);
     CONFORM(T2102, Route);
     PROMPT(" " + Route.Route);
     L_General.CLEAR("Mark");
     SELECT(dwhSP, dwhSPSet, , DWH.dwhSPSet);
     WHILE OCCURE(dwhSP) DO
      IF ~dwhSP.Calc & BasisRecordIsInPage(dwhSP.dwhSP) THEN
       INC(Cnt);
       Add("믐Ꮻ", T2102.WrkTrp[D_TP.idx_Plan]);
      END; (* IF ~dwhSP.Calc *)
      NEXT(dwhSP);
     END; (* WHILE OCCURE(dwhSP) *)
    END;
    NEXT(T2102);
   END; (* WHILE OCCURE(T2102) *)
   IF (Cnt > 0) & ~SELECT(SysdwhI, dwhISN, ShortName) THEN
    L_General.CallUs(0);
   END;
   SysdwhI_Is_Allready_Filled[b_T2102]:=1;
  END; (* IF ~SysdwhI_Is_Allready_Filled *)

  IF SEARCH(SysdwhI, dwhSP, DWHP.dwhSP, ShortName) THEN
   RETURN SysdwhI.Fact;
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {T2102_GetValue};
(* ------------- PUBLIC PROCS ----------------------- *)


 PUBLIC PROCEDURE (getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  RETURN DWH.PerE - DWH.PerB + 1;
 END {};

 PUBLIC PROCEDURE ᯫ(getFact: SCAL[2]): L_dwh.tItemValue;
  VAR
   Result: L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   PrepareAllBasisForCurDWH();
   Result:=0;
   SAVE(Car);
   SELECT(Car, BoxNbr);
   WHILE OCCURE(Car) DO
    PROMPT(" " + Car.BoxNbr);
    IF Car.BoxNbr # L_Car.E_GetFictiveBoxNbr(DWH.MyFirm) THEN
     SAVE(CarLog);
     HISTCONF(DWH.PerE, Car, CarLog);
     IF OCCURE(CarLog) &
        (CarLog.Status = L_Car.carst_InOperat) &
        (L_Car.GetCarMyFirm(Car.BoxNbr, CarLog.Date) = DWH.MyFirm) THEN
      CONFORM(CarLog, VehPasp);
      IF OCCURE(VehPasp) & (VehPasp.OwnerShp = 1) THEN
       CONFORM(CarLog, TKind);
       L_General.CallUs(OCCURE(TKind));
       CONFORM(CarLog, Mark);
       IF SEARCH(dwhSP, dwhSPSet, DWHP.dwhSPSet, DWHP.dwhSP) THEN
        IF ~dwhSP.Calc & BasisRecordIsInPage(dwhSP.dwhSP) THEN
         INC(Result);
        END; (* IF ~dwhSP.Calc *)
       END;
      END;
     END;
     RESTORE(CarLog);
    END; (* IF Car.BoxNbr # E_GetFictiveBoxNbr(DWH.MyFirm) *)
    NEXT(Car);
   END; (* WHILE OCCURE(Car) ... *)
   RESTORE(Car);
  ELSE
   Result:=L_General.EMPTY_NUMBER();
  END;
  RETURN Result;
 END {ᯫ};

 PUBLIC PROCEDURE ।ℭ(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN CarTb2_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {।ℭ};

 PUBLIC PROCEDURE (getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN CarTb2_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {};

 PUBLIC PROCEDURE (getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN TP002_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {};

 PUBLIC PROCEDURE (getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN TP002_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {};

 PUBLIC PROCEDURE ₈(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN CarTb2_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {₈};

 PUBLIC PROCEDURE ℭ(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN TP002_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {ℭ};

 PUBLIC PROCEDURE ℭ(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN CarTb2_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {ℭ};

 PUBLIC PROCEDURE (getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN TP002_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {};

 PUBLIC PROCEDURE ஡(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN CarTb2_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {஡};

 PUBLIC PROCEDURE ஡ᠦ(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN TP002_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {஡ᠦ};

 PUBLIC PROCEDURE ᠦ댎(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN TP002_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {ᠦ댎};

 PUBLIC PROCEDURE ᠦ(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN TP002_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {ᠦ};

 PUBLIC PROCEDURE ᠦ(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN TP002_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {ᠦ};

 PUBLIC PROCEDURE ᠦ돫(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN TP002_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {ᠦ돫};

 PUBLIC PROCEDURE Ꭱ(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN TP002_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {Ꭱ};

 PUBLIC PROCEDURE 믁(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN TP002_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {믁};

 PUBLIC PROCEDURE 믑(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN TP002_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {믑};

 PUBLIC PROCEDURE 믐Ꮻ(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN T2102_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {믐Ꮻ};

 PUBLIC PROCEDURE (getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN CarTb2_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {};

 PUBLIC PROCEDURE ⮥(getFact: SCAL[2]): L_dwh.tItemValue;
 BEGIN
  IF getFact THEN
   RETURN TP002_GetValue(RTI.Get().Stack(0).Proc.Name);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {⮥};

END.
