(*
%Copyright   (c) Polak Computer System
%Author      30.07.2000 14:44:15 SAN
%Purpose     ᠭ  ⥫ 䠩 - ௫
%Type        library
%Specific    SYS
%Modified    19.09.2014 17:36:05 POLAK\Gina
%Environment
*)

 MODULE D_Slr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_AFM, Math, E_Utils, L_Staff, L_Man,
        L_EC, L_Env, L_Str, P_Firm, L_STx, P_MCList, L_Way, L_Sheet, L_SFee, L_PRoll;

 PUBLIC TYPE
  tAvgCount = NUMERIC[3];

 PUBLIC CONST
  act_Total   = 0;
  act_SpecTax = 1;
  act_Invalid = 2;
  act_Harm    = 3;

 VAR
  SL001_From,
  SL001_UpTo : DATE;

 PRIVATE PROCEDURE Create_SL001();
 BEGIN
  CreateFILE(SL001, "", "ࠡ⠭ ६ ࠡ⭨", "");

  CreateFIELD(SL001, TSN,      LIKE(Staff.TSN),       "", "", "", " ", "");
  CreateFIELD(SL001, ODate,    DATE,                  "", "", "", " ਪ  ६饭", "");
  CreateFIELD(SL001, DateE,    DATE,                  "", "", "", " 砭 ࠡ", "");
  CreateFIELD(SL001, MyFirm,   P_Firm.tMyFirm,        "", "", "", "'' ࣠", "");
  CreateFIELD(SL001, FullBal,  NUMERIC[8, 3],         "", "", "", "  ࠡ祣 ६", "");
  CreateFIELD(SL001, CorrBal,  NUMERIC[8, 3],         "", "", "", "४஢  ࠡ祣 ६", "");
  CreateFIELD(SL001, TimDone,  NUMERIC[8, 3],         "", "", "", "ࠡ⠭ ᮢ", "");
  CreateFIELD(SL001, Sort,     LIKE(Sort.Sort),       "", "", "", "ࠧ", "");
  CreateFIELD(SL001, Officer,  LIKE(Officer.Officer), "", "", "", " ࠡ祣   । ᥪ", "");
  CreateFIELD(SL001, DutyDgr,  LIKE(StaffLog.DutyDgr),"", "", "", "⥯  - ⭠  / ( <1 -  )", "");
  CreateFIELD(SL001, Post,     LIKE(Post.Post),       "", "", "", " ", "");
  CreateFIELD(SL001, Union,    LIKE(Union.Union),     "", "", "", "⥣", "");
  CreateFIELD(SL001, Citizen,  SCAL[4],               "", "", "", "ࠦ⢮", "");
  CreateFIELD(SL001, _InState, SCAL[2],               "", "", "", "    ਮ", "");
  CreateFIELD(SL001, IsMain,   SCAL[2],               "", "", "", " ६ ॢ", "");

  CreateINDEXandLINK(SL001, TSN,     UNIQUE, Staff,   TSN,     HISTORY, "", "", TSN, ODate);
  CreateINDEXandLINK(SL001, Officer, PLURAL, Officer, Officer, USER,    "", "", Sort, Officer, TSN);
  CreateINDEXandLINK(SL001, Post,    PLURAL, Post,    Post,    USER,    "", "", Post, Sort, Officer, TSN);
  CreateINDEXandLINK(SL001, Union,   PLURAL, Union,   Union,   USER,    "", "", Union, Sort, Officer, TSN);
  CreateINDEXandLINK(SL001, MyFirm, PLURAL, MyFirm,  MyFirm,  USER,    "", "", MyFirm);

  SetVersionOfFILE(SL001, 0005);

 END {Create_SL001};

 PRIVATE PROCEDURE Create_Sh001();
 BEGIN
  CreateFILE(Sh001, "", "६ ࠡ⭨   ࠡ", "");

  CreateFIELD(Sh001, TSN,   LIKE(Staff.TSN), "", "",  "", " ", "");
  CreateFIELD(Sh001, ODate, DATE,            "", "",  "", " ਪ  ६饭", "");
  CreateFIELD(Sh001, JMode, SCAL[99],        "", "",  "", " ࠡ  ⠡", "");
  CreateFIELD(Sh001, Hours, NUMERIC[8, 3],   "", "0", "", "ࠡ⠭ ᮢ", "");
  CreateFIELD(Sh001, Days,  NUMERIC[8, 3],   "", "0", "", "ࠡ⠭ ", "");

  CreateINDEXandLINK(Sh001, TSN,   UNIQUE, SL001, TSN,   BORROW, "", "", TSN, ODate, JMode);
  CreateINDEXandLINK(Sh001, JMode, PLURAL, JMode, JMode, USER,   "", "", JMode);

  SetVersionOfFILE(Sh001, 0000);

 END {Create_Sh001};

 PRIVATE PROCEDURE _SL001_Insert(_UpTo: DATE);
 BEGIN
  CONFORM(StaffLog, Officer);
  SL001.TSN     :=Staff.TSN;
  SL001.ODate   :=StaffLog.Date;
  SL001.DateE   :=StaffLog.DateE;
  SL001.Sort    :=StaffLog.Sort;
  SL001.Officer :=StaffLog.Officer;
  SL001.Post    :=Officer.Post;
  SL001.Union   :=Officer.Union;
  SL001.DutyDgr :=StaffLog.DutyDgr;
  SL001.Citizen :=L_Man.Man_Citizen(Staff.Man, Math.Min(_UpTo, SL001_UpTo));
  SL001.MyFirm  :=L_Staff.GetStaffMyFirm();
  INSERT(SL001);
 END {_SL001_Insert};

 PUBLIC PROCEDURE IsPermanentMove(): SCAL[2];
 BEGIN
  RETURN (SLKind.Type = L_Staff.slkt_TakeOn) |
         (SLKind.Type = L_Staff.slkt_Prolongation) |
         (SLKind.Type = L_Staff.slkt_TakeOnWithDischarge) |
         ((SLKind.Type = L_Staff.slkt_Move) & ~SLKind.IsTemp & ~SLKind.IsActing);
 END {IsPermanentMove};

 PRIVATE PROCEDURE SL001_Insert();
  VAR
   _DateE: DATE;
 BEGIN
  SL001._InState:=L_Staff.InOrder(SL001_UpTo) & ~L_Staff.IsDischargeStaffLog();
  SL001.IsMain  :=SL001._InState & IsPermanentMove();
  _SL001_Insert(StaffLog.DateE);
  IF SL001._InState & ~SL001.IsMain THEN
   _DateE:=StaffLog.DateE;
   SAVE(StaffLog);
   WHILE PREV(StaffLog) & ~SL001.IsMain DO
    CONFORM(StaffLog, SLKind);
    IF IsPermanentMove() THEN
     IF SEARCH(SL001, TSN, Staff.TSN, StaffLog.Date) THEN
      L_General.CallUs(~SL001._InState);
      SL001.IsMain:=1;
      REPLACE(SL001);
     ELSE
      SETZERO(SL001.TimDone, SL001.CorrBal, SL001.FullBal);
      SL001._InState:=0;
      SL001.IsMain  :=1;
      _SL001_Insert(_DateE);
     END;
    END;
   END; (* WHILE PREV(StaffLog) ... *)
   RESTORE(StaffLog);
   L_General.Assert(SL001.IsMain, " ਪ  ਥ  ﭭ  ࠡ. . " + Staff.TSN);
  END;
 END {SL001_Insert};

 PRIVATE PROCEDURE E_NeedPrepare(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_Utils.Labour_NeedPrepare), 0);
 END {NeedPrepare};

 PRIVATE PROCEDURE Labour_PrepareSh();
  VAR
   _OtherDay,
   DayInFirm,
   VacationDay,
   WorkDay,
   OtherDay,
   RestDays    : NUMERIC[0];
   WorkTime,
   OtherTime   : NUMERIC[3];
   _HoursInDay : NUMERIC[3];
 BEGIN
  _HoursInDay:=E_Utils.Labour_HoursInDay(SL001_From, SL001_UpTo);
  SETZERO(DayInFirm, VacationDay, WorkDay, WorkTime, OtherTime);
  SELECT(Sh001, TSN, , Staff.TSN, StaffLog.Date);
  WHILE OCCURE(Sh001) DO
   CONFORM(Sh001, JMode);
   IF JMode.InFirm THEN
    INC(DayInFirm, Sh001.Days);
    IF E_Utils.Labour_IsHolidayMode() THEN
     REMOVE(Sh001);
    ELSE
     IF E_Utils.Labour_IsVacationMode() THEN
      INC(VacationDay, Sh001.Days);
     ELSIF JMode.Type = L_Sheet.jmType_TimDone THEN
      INC(WorkTime, Sh001.Hours);
      INC(WorkDay, Sh001.Days);
     ELSE
      INC(OtherTime, Sh001.Hours);
     END;
     NEXT(Sh001);
    END;
   ELSE
    NEXT(Sh001);
   END;
  END; (* WHILE OCCURE(Sh001) ... *)
  RestDays:=DayInFirm - VacationDay;
  IF E_Utils.Labour_ConvWorkDays() THEN
   WorkDay:=Math.Min(RestDays, Math.Min(WorkTime, SL001.CorrBal) /_HoursInDay);
  END;
  DEC(RestDays, WorkDay);
  OtherDay:=Math.Min(RestDays, OtherTime/_HoursInDay);
  DEC(RestDays, OtherDay);
  _OtherDay:=OtherDay;
  SETSEL(Sh001, TSN, Staff.TSN, StaffLog.Date);
  FOR_EACH Sh001 DO
   CONFORM(Sh001, JMode);
   IF JMode.InFirm THEN
    IF JMode.Type = L_Sheet.jmType_TimDone THEN
     IF E_Utils.Labour_ConvWorkDays() THEN
      IF WorkTime # 0 THEN
       Sh001.Days:=Math.Round(Sh001.Hours * WorkDay/WorkTime);
      ELSE
       Sh001.Days:=0;
      END;
     END;
    ELSIF ~E_Utils.Labour_IsVacationMode() & ~E_Utils.Labour_IsHolidayMode() THEN
     IF OtherTime # 0 THEN
      Sh001.Days:=Math.Min(Math.Round(Sh001.Hours * OtherDay/OtherTime), _OtherDay);
      DEC(_OtherDay, Sh001.Days);
     ELSE
      Sh001.Days:=0;
     END;
    END;
    REPLACE(Sh001);
   END;
  END; (* FOR_EACH Sh001 *)
  WHILE RestDays < 0 DO
   SELECT(Sh001, TSN, , Staff.TSN, StaffLog.Date);
   WHILE OCCURE(Sh001) & (RestDays < 0) DO
    DEC(Sh001.Days);
    REPLACE(Sh001);
    INC(RestDays);
    NEXT(Sh001);
   END; (* WHILE OCCURE(Sh001) ... *)
  END;
  REP(Sh001, TSN, , Staff.TSN, StaffLog.Date, 01,
      Sh001.Hours, 0,
      Sh001.Days, RestDays);
 END {Labour_PrepareSh};

 PRIVATE PROCEDURE SL001_MakeOneTSN();
  VAR
   B, E, P  : DATE;
 BEGIN
  PROMPT(Staff.TSN);
  SELECT(StaffLog, TSN, , Staff.TSN);
  SRCINSEL(StaffLog, LE, , Math.Max(SL001_From, Staff.BegDate));
  WHILE OCCURE(StaffLog) & (StaffLog.Date <= SL001_UpTo) DO
   CONFORM(StaffLog, SLKind);
   IF SLKind.Type # L_Staff.slkt_Discharge THEN
    SETZERO(SL001.TimDone, SL001.FullBal);
    B:=Math.Max(SL001_From, StaffLog.Date);
    E:=Math.Min(StaffLog.DateE, SL001_UpTo);
    P:=L_DatTim.Per(B);
    WHILE P <= L_DatTim.Per(E) DO
     SELECT(Sheet, TSN, , Staff.TSN, P);
     SRCINSEL(Sheet, GE, , L_DatTim.DAY(B));
     WHILE OCCURE(Sheet) & (Sheet.Period + Sheet.Day -1 <= E) DO
      ADD(Sh001, TSN, , Staff.TSN, StaffLog.Date, Sheet.JMode,
          Sh001.Hours, Sheet.Tim,
          Sh001.Days, 1);
      NEXT(Sheet);
     END; (* WHILE OCCURE(Sheet) ... *)
     IF (StaffLog.Date <= P) & (StaffLog.DateE >= L_DatTim.MonthEnd(P)) THEN
      L_General.Assert(SEARCH(RegHead, HumReg, StaffLog.Regime, P),
                       "  䨪 " + StaffLog.Regime + "  " +
                       L_DatTim.PeriodStr(P));
      INC(SL001.FullBal, RegHead.FullBal);
     ELSE
      L_General.Assert(SELECT(RegList, HumReg, StaffLog.Regime, P) &
                       SRCINSEL(RegList, EQ, L_DatTim.DAY(B)),
                       "  䨪 " + StaffLog.Regime + "  " +
                       L_DatTim.DateStr(B));
      WHILE OCCURE(RegList) & (RegList.Period + RegList.Day - 1 <= E) DO
       INC(SL001.FullBal, RegList.Durat);
       NEXT(RegList);
      END; (* WHILE OCCURE(RegList) ... *)
     END;
     P:=L_DatTim.IncMonth(P, +1);
     B:=P;
    END;
    SL001.CorrBal:=SL001.FullBal;
    SETSEL(Sh001, TSN, Staff.TSN, StaffLog.Date);
    FOR_EACH Sh001 DO
     CONFORM(Sh001, JMode);
     IF    JMode.Type = L_Sheet.jmType_TimDone THEN
      INC(SL001.TimDone, Sh001.Hours);
     ELSIF JMode.DecrBal THEN
      DEC(SL001.CorrBal, Sh001.Hours);
     END;
    END; (* FOR_EACH Sh001 *)
    SL001_Insert();
    IF E_NeedPrepare(SL001_From) THEN
     Labour_PrepareSh();
    END;
   END;
   NEXT(StaffLog);
  END; (* WHILE OCCURE(StaffLog) ... *)
  IF OCCURE(StaffLog) & (StaffLog.Date = SL001_UpTo+1) THEN
   SETZERO(SL001.TimDone, SL001.CorrBal, SL001.FullBal);
   SL001_Insert();
  END;
 END {SL001_MakeOneTSN};

 PUBLIC PROCEDURE _Prepare_SL001(_From, _UpTo: DATE; Rebuild, Silent: SCAL[2]);
 BEGIN
  SL001_From:=_From;
  SL001_UpTo:=_UpTo;
  L_DatTim.CheckWMIntvl(SL001_From, SL001_UpTo);
  L_Way.WarnUnDoneRWayS(SL001_From, SL001_UpTo);

  Create_SL001();
  Create_Sh001();

  L_AFM.NewReusableFile("SL001", "SL001", L_General.timeCond_InIntvl, SL001_From, SL001_UpTo);
  L_AFM.NewReusableFile("Sh001", "Sh001", L_General.timeCond_InIntvl, SL001_From, SL001_UpTo);
  IF Rebuild |
     ~(L_AFM.CanReuseFile("SL001", 1) &
       L_AFM.CanReuseFile("Sh001", Silent)) THEN
   L_AFM.CreateReusableFile("SL001");
   L_AFM.CreateReusableFile("Sh001");
   SETSEL(Staff, TSN);
   FOR_EACH Staff DO
    IF L_Env.RealTSN(Staff.TSN) & L_Staff.InStateInPer(SL001_From, SL001_UpTo) THEN
     SL001_MakeOneTSN();
    END;
   END; (* FOR_EACH Staff *)
   L_AFM.ReAttachReusableFile("SL001");
   L_AFM.ReAttachReusableFile("Sh001");
  END; (* IF ~CanReuseFile ... *)
 END {_Prepare_SL001};

 PUBLIC PROCEDURE Prepare_SL001(_From, _UpTo: DATE);
 BEGIN
  _Prepare_SL001(_From, _UpTo, 0, 0);
 END {Prepare_SL001};

 PRIVATE PROCEDURE Rebuild_SL001(_From, _UpTo: DATE);
 BEGIN
  _Prepare_SL001(_From, _UpTo, 1, 0);
 END {Rebuild_SL001};

 VAR
  Mn001_From,
  Mn001_UpTo : DATE;
  Mn001_byTSN: SCAL[2];

 PRIVATE PROCEDURE Create_Mn001();
 BEGIN

  CreateFILE(Mn001, "", "  ௫", "");

  CreateFIELD(Mn001, Period,   DATE,                   "", "", "", "  ਮ", "");
  CreateFIELD(Mn001, MCode,    LIKE(MCList.MCode),     "", "", "", " ᫥/㤥ঠ", "");
  CreateFIELD(Mn001, FOT,      LIKE(MCGroup.FOT),      "", "", "", "室  ", "");
  CreateFIELD(Mn001, Sort,     LIKE(Sort.Sort),        "", "", "", "", "");
  CreateFIELD(Mn001, Class,    LIKE(StaffLog.Class),   "", "", "", "", "");
  CreateFIELD(Mn001, DutyDgr,  LIKE(StaffLog.DutyDgr), "", "", "", "", "");
  CreateFIELD(Mn001, Contract, LIKE(Staff.Contract),   "", "", "", " 㤮 ", "");
  CreateFIELD(Mn001, ContDTyp, LIKE(StaffLog.ContDTyp),"", "", "", "  (/)", "");
  CreateFIELD(Mn001, Sex,      LIKE(Man.Sex),          "", "", "", "", "");
  CreateFIELD(Mn001, MyFirm,   P_Firm.tMyFirm,         "", "", "", "'' ࣠", "");
  CreateFIELD(Mn001, Tim,      NUMERIC[10, 3],         "", "", "", "६", "");
  CreateFIELD(Mn001, Sum,      NUMERIC[12,2],          "", "", "", "㬬", "");
  CreateFIELD(Mn001, Citizen,  SCAL[4],                "", "", "", "ࠦ⢮", "");
  CreateFIELD(Mn001, Officer,  LIKE(Officer.Officer),  "", "", "", " ", "");
  CreateFIELD(Mn001, Post,     LIKE(Post.Post),        "", "", "", " ", "");
  CreateFIELD(Mn001, Union,    LIKE(Union.Union),      "", "", "", "⥣", "");
  CreateFIELD(Mn001, Shift,    LIKE(Shift.Shift),      "", "", "", "", "");
  CreateFIELD(Mn001, WFPeriod, DATE,                   "", "", "", "  ਮ", "");
  CreateFIELD(Mn001, AcCut,    LIKE(AcCut.AcCut),      "", "", "", " ࠧ१", "");
  CreateFIELD(Mn001, Closed,   DATE,                   "", "", "", "  ", "");
  IF Mn001_byTSN THEN
   CreateFIELD(Mn001, TSN,   LIKE(Staff.TSN), "", "", "", " ", "");
   CreateFIELD(Mn001, ODate, DATE,            "", "", "", " ਪ  ६饭", "");
   CreateFIELD(Mn001, Source, LIKE(Money.Source), "", "", "", "筨 ", "");
   CreateFIELD(Mn001, Sign,   SCAL[2],            "", "", "", " 㬬", "");

   CreateINDEX(Mn001, Mn001, UNIQUE, "", "", TSN, ODate, Period, MCode, WFPeriod, Source, Sign, MyFirm, AcCut, Closed);
   CreateINDEXandLINK(Mn001, TSN, PLURAL, Staff, TSN, HISTORY, "", "", TSN, ODate);
  ELSE
   CreateINDEX(Mn001, Mn001, UNIQUE, "", "", Period, MCode, Sort, Class, DutyDgr, Contract, ContDTyp, Sex, Citizen, Officer, Post, Union, FOT, Shift, WFPeriod, MyFirm, AcCut, Closed);
  END;
  CreateINDEXandLINK(Mn001, MCode,   PLURAL, MCList,  MCode,   USER, "", "", MCode, Union);
  CreateINDEXandLINK(Mn001, Officer, PLURAL, Officer, Officer, USER, "", "", Sort,  Officer);
  CreateINDEXandLINK(Mn001, Post,    PLURAL, Post,    Post,    USER, "", "", Post,  Sort, Officer);
  CreateINDEXandLINK(Mn001, Union,   PLURAL, Union,   Union,   USER, "", "", Union, Sort, Officer);
  CreateINDEXandLINK(Mn001, MyFirm, PLURAL, MyFirm,  MyFirm,   USER, "", "", MyFirm);

  SetVersionOfFILE(Mn001, 0013);
 END {Create_Mn001};

 PRIVATE PROCEDURE Mn001_Period(): DATE;
 BEGIN
  RETURN Money.Period;
 END {Mn001_Period};

 PRIVATE PROCEDURE Mn001_WFPeriod(): DATE;
 BEGIN
  RETURN Money.WFPeriod;
 END {Mn001_WFPeriod};

 PRIVATE PROCEDURE Mn001_PutSingleMoney(VAR curCitizen: SCAL[4];
                                        VAR curODate  : LIKE(StaffLog.Date);
                                        VAR curShift  : LIKE(OfcShift.Shift));
  VAR
   curAcCut: LIKE(AcCut.AcCut);
 BEGIN
  IF !curCitizen THEN
   curCitizen:=L_Man.Man_Citizen(Man.Man, L_DatTim.MonthEnd(Money.Closed));
  END;
  IF !curODate | (Money.ODate # curODate) THEN
   L_General.Assert(SEARCH(StaffLog, TSN, Staff.TSN, Money.ODate),
                    "   䠩 StaffLog ⠡. "+Staff.TSN+"  "+L_DatTim.DateStr(Money.ODate));
   curODate:=StaffLog.Date;
   CONFORM(StaffLog, Officer, TimeKeep);
   IF SEARCH(OfcShift, Officer, StaffLog.Sort,
                                StaffLog.Officer,
                                StaffLog.Regime) THEN
    curShift:=OfcShift.Shift;
   ELSE
    SETEMPTY(curShift);
   END;
  END;
  curAcCut:=L_PRoll.GetMCListAcCut(Money.MCode, Money.Closed);
  IF !curAcCut THEN
   IF SELECT(MoneyDst, MoneyDst, Money.RECORDID) THEN
    curAcCut:=MoneyDst.AcCut;
   ELSE
    L_General.CallUs(0);
   END;
  END;
  IF Mn001_byTSN THEN
   ADD(Mn001, Mn001, , StaffLog.TSN, StaffLog.Date,
                       Mn001_Period(), Money.MCode,  Mn001_WFPeriod(), Money.Source, Money.Sum>0,
                       L_Staff.GetStaffMyFirm(), curAcCut, Money.Closed,
       Mn001.Tim, Money.Tim,
       Mn001.Sum, Money.Sum);
   Mn001.Sex     :=Man.Sex;
   Mn001.Citizen :=curCitizen;
   Mn001.Contract:=Staff.Contract;
   Mn001.ContDTyp:=StaffLog.ContDTyp;
   Mn001.Sort    :=StaffLog.Sort;
   Mn001.Officer :=StaffLog.Officer;
   Mn001.Class   :=StaffLog.Class;
   Mn001.DutyDgr :=StaffLog.DutyDgr;
   Mn001.Shift   :=curShift;
   Mn001.FOT     :=MCGroup.FOT;
   REPLACE(Mn001);
  ELSE
   ADD(Mn001, Mn001, , Mn001_Period(), Money.MCode, Officer.Sort,
                       StaffLog.Class, StaffLog.DutyDgr, Staff.Contract,
                       StaffLog.ContDTyp, Man.Sex, curCitizen, StaffLog.Officer,
                       Officer.Post, Officer.Union, MCGroup.FOT, curShift, Mn001_WFPeriod(),
                       L_Staff.GetStaffMyFirm(), curAcCut, Money.Closed,
       Mn001.Tim, Money.Tim,
       Mn001.Sum, Money.Sum);
  END;
 END {Mn001_PutSingleMoney};

 PRIVATE PROCEDURE Mn001_MakeOneTSN(P: DATE; forFOT: SCAL[2]);
  VAR
   curCitizen: SCAL[4];
   curODate  : LIKE(StaffLog.Date);
   curShift  : LIKE(OfcShift.Shift);
   trgSSV    : LIKE(MCPro.SpdSrchV);
 BEGIN
  PROMPT(L_DatTim.PeriodStr(P) + ":" + Staff.TSN);
  SETEMPTY(curODate, curCitizen);
  IF SELECT(Money, TSN, Staff.TSN, P) THEN
   CONFORM(Staff, Man);
   WHILE OCCURE(Money) DO
    CONFORM(Money, MCList, MCGroup);
    IF ~forFOT | (P_MCList.GetForFuture(MCList.MCode, P) # P_MCList.mcfp_OnlyInFOT) | (Money.Period <= Money.Closed) THEN
     Mn001_PutSingleMoney(curCitizen, curODate, curShift);
    END;
    NEXT(Money);
   END; (* WHILE OCCURE(Money) ... *)
  END; (* IF SELECT(Money, ... *)
  IF forFOT THEN
   trgSSV:=L_Str.PoolItem(P_MCList.mcfp_Pool, P_MCList.mcfp_OnlyInFOT);
   SETSEL(MCPro, Property, P_MCList.P_ForFuture, trgSSV);
   FOR_EACH MCPro DO
    IF SELECT(Money, PayFor, Staff.TSN, P, MCPro.MCode) THEN
     CONFORM(Money, MCList, MCGroup);
     WHILE OCCURE(Money) DO
      IF Money.Period > Money.Closed THEN
       Mn001_PutSingleMoney(curCitizen, curODate, curShift);
      END;
      NEXT(Money);
     END; (* WHILE OCCURE(Money) ... *)
    END;
   END; (* FOR_EACH MCPro *)
  END;
 END {Mn001_MakeOneTSN};

 PUBLIC PROCEDURE extPrepare_Mn001(_From, _UpTo: DATE; byTSN, Rebuild, Silent, forFOT: SCAL[2]);
  VAR
   P        : DATE;
   trgRFName: STRING[];
 BEGIN
  Mn001_From :=_From;
  Mn001_UpTo :=_UpTo;
  Mn001_byTSN:=byTSN;

  L_DatTim.CheckWMIntvl(Mn001_From, Mn001_UpTo);

  Create_Mn001();

  IF forFOT THEN
   IF Mn001_byTSN THEN trgRFName:="Mn191";
   ELSE                trgRFName:="Mn101";
   END;
  ELSE
   IF Mn001_byTSN THEN trgRFName:="Mn091";
   ELSE                trgRFName:="Mn001";
   END;
  END;
  L_AFM.NewReusableFile("Mn001", trgRFName, L_General.timeCond_InIntvl, Mn001_From, Mn001_UpTo);
  IF Rebuild | ~L_AFM.CanReuseFile("Mn001", Silent) THEN
   L_AFM.CreateReusableFile("Mn001");
   P:=Mn001_From;
   WHILE P < Mn001_UpTo DO
    SETSEL(Staff, TSN);
    FOR_EACH Staff DO
     Mn001_MakeOneTSN(P, forFOT);
    END; (* FOR_EACH Staff *)
    P:=L_DatTim.IncMonth(P, +1);
   END; (* WHILE P < ... *)
   L_AFM.ReAttachReusableFile("Mn001");
  END; (* IF ~CanReuseFile ... *)
 END {extPrepare_Mn001};

 PUBLIC PROCEDURE Prepare_MnXXX(_From, _UpTo: DATE; byTSN: SCAL[2]);
 BEGIN
  extPrepare_Mn001(_From, _UpTo, byTSN, 0, 0, 0);
 END {Prepare_MnXXX};

 PRIVATE PROCEDURE Prepare_Mn001(_From, _UpTo: DATE);
 BEGIN
  extPrepare_Mn001(_From, _UpTo, 0, 0, 0, 0);
 END {Prepare_Mn001};

 PRIVATE PROCEDURE Rebuild_Mn001(_From, _UpTo: DATE);
 BEGIN
  extPrepare_Mn001(_From, _UpTo, 0, 1, 0, 0);
 END {Rebuild_Mn001};

 PRIVATE PROCEDURE ac_CreateTmpFiles();
 BEGIN
  CreateFILE(SL002, "", "ࠡ⠭ ६", "");

  CreateFIELD(SL002, MyFirm,   P_Firm.tMyFirm, "", "", "", "'' ࣠", "");
  CreateFIELD(SL002, Sex,      LIKE(Man.Sex),  "", "", "", "", "");
  CreateFIELD(SL002, SpecTax,  SCAL[2],        "", "", "", ". ", "");
  CreateFIELD(SL002, Invalid,  SCAL[2],        "", "", "", "", "");
  CreateFIELD(SL002, Harm,     SCAL[2],        "", "", "", "।", "");
  CreateFIELD(SL002, DaysInF,  NUMERIC[3],     "", "", "", "  宧⢥", "");
  CreateFIELD(SL002, xDays,    NUMERIC[3],     "", "", "", "ࠡ⠭ ", "");

  CreateINDEX(SL002, Union, UNIQUE, "", "", MyFirm, SpecTax, Invalid, Sex, Harm);

  SetVersionOfFILE(SL002, 2);
  L_AFM.AF_CreateTemp("SL002", "SL002");

  CreateFILE(AvgCnt, "", "।ᯨ筠 ᫥", "");

  CreateFIELD(AvgCnt, Type,    SCAL[9],       "", "",  "", "''", "0-ᥣ, 1-ᯥ., 2-, 3-।");
  CreateFIELD(AvgCnt, Count,   NUMERIC[3][2], "", "0", "", "।ᯨ筠 ᫥", "");

  CreateINDEX(AvgCnt, AvgCnt, UNIQUE, "", "", Type);

  SetVersionOfFILE(AvgCnt, 2);
  L_AFM.AF_CreateTemp("AvgCnt", "AvgCnt");
 END {ac_CreateTmpFiles};

 PUBLIC PROCEDURE GetFromSh001(VAR DaysInFirm, DaysNotFullDuty: tAvgCount; Proc: PROC);
  VAR
   ct,
   TimsInFirm: tAvgCount;
 BEGIN
  SETZERO(TimsInFirm, DaysInFirm, DaysNotFullDuty);
  SETSEL(Sh001, TSN, SL001.TSN, SL001.ODate);
  FOR_EACH Sh001 DO
   CONFORM(Sh001, JMode);
   IF JMode.InFirm THEN
    INC(TimsInFirm, Sh001.Hours);
    INC(DaysInFirm, Sh001.Days)
   END;
   IF ~!Proc THEN
    Proc();
   END;
  END; (* FOR_EACH Sh001 *)
  IF (SL001.DutyDgr < 1) & (SL001.FullBal > 0) THEN
   ct:=Math.Min(TimsInFirm, SL001.FullBal);
   DaysNotFullDuty:=DaysInFirm-DaysInFirm*(ct/SL001.FullBal);
  END;
 END {GetFromSh001};

 PRIVATE PROCEDURE ac_Prepare_SL002(EPer: DATE);
  VAR
   curDaysNotFullDuty,
   curDaysInFirm: tAvgCount;
   IsInvalid,
   IsSpecificSTx: SCAL[2];
 BEGIN
  SETSEL(SL001, TSN);
  FOR_EACH SL001 DO
   PROMPT(" " + SL001.TSN);
   CONFORM(SL001, Staff);
   CONFORM(Staff, Man);
   L_General.Assert(SEARCH(StaffLog, TSN, SL001.TSN, SL001.ODate),
                    ' ६ ⮢ 䠩 "ࠡ⠭ ६ ࠡ⭨"' +
                    '|ᥭ   ६饭 ࠡ⭨.' +
                    '|| ⮢  䠩 .');

   IF EPer >= L_SFee.TheStartingPoint THEN
    IsInvalid    :=L_SFee.ManIsInvalid(Man.Man, EPer);
    IsSpecificSTx:=0;
   ELSE
    IsInvalid    :=L_STx.STx_Man_IsInvalid(EPer, Man.Man);
    IsSpecificSTx:=L_STx.SpecificSTx(StaffLog.Sort, StaffLog.Officer, EPer, Staff.MyFirm) > L_STx.SpcSTx_None;
   END;

   GetFromSh001(curDaysInFirm, curDaysNotFullDuty, EMPTYOF(PROC));
   CONFORM(StaffLog, Officer);
   ADD(SL002, Union, , SL001.MyFirm, IsSpecificSTx, IsInvalid, Man.Sex, L_Staff.OfficerHarmPwr(EPer) > L_Staff.dtpwr_Acceptable,
              SL002.DaysInF, curDaysInFirm,
              SL002.xDays,   curDaysNotFullDuty);
  END; (* FOR_EACH SL001 *)
 END {ac_Prepare_SL002};

 PRIVATE PROCEDURE CalcAverageCount_PurgeFile(File: STRING[]);
 BEGIN
  IF DBD.FileExist(^File) THEN
   L_AFM.AF_PurgeTemp(File);
  END;
 END {CalcAverageCount_PurgeFile};

 PUBLIC PROCEDURE CalcAverageCount_PurgeFiles();
 BEGIN
  CalcAverageCount_PurgeFile("SL001");
  CalcAverageCount_PurgeFile("Sh001");
  CalcAverageCount_PurgeFile("SL002");
 END {CalcAverageCount_PurgeFiles};

 PUBLIC PROCEDURE CalcAverageCount(BPer, EPer: DATE; MyFirm: P_Firm.tMyFirm);
  VAR
   AvgCount: tAvgCount;
 BEGIN
  Prepare_SL001(BPer, EPer);
  ac_CreateTmpFiles();

  ac_Prepare_SL002(EPer);

  SETSEL(SL002, Union, MyFirm);
  FOR_EACH SL002 DO
   PROMPT(" ।ᯨ筮 ᫥");
   AvgCount:=(SL002.DaysInF-SL002.xDays)/(EPer-BPer+1);

   IF SL002.SpecTax THEN
    ADD(AvgCnt, AvgCnt, , act_SpecTax,
        AvgCnt.Count[SL002.Sex], AvgCount);
   ELSE
    ADD(AvgCnt, AvgCnt, , act_Total,
        AvgCnt.Count[SL002.Sex], AvgCount);
   END;
   IF SL002.Invalid THEN
    ADD(AvgCnt, AvgCnt, , act_Invalid,
        AvgCnt.Count[SL002.Sex], AvgCount);
   END;
   IF SL002.Harm THEN
    ADD(AvgCnt, AvgCnt, , act_Harm,
        AvgCnt.Count[SL002.Sex], AvgCount);
   END;
  END; (* FOR_EACH SL002 *)

  CalcAverageCount_PurgeFiles();
 END {CalcAverageCount};

END.
