(*
%Copyright   (c) Polak Computer System
%Author      28.06.2000 13:18:42 SAN
%Purpose     ᠭ  ⥫ 䠩 - ᮭ
%Type        library
%Specific    SYS
%Modified    18.09.2014 14:14:36 POLAK\Gina
%Environment
*)

 MODULE D_Staff [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  t_ofcSubject     = SCAL[32];
  t_ofcSource      = SCAL[5];
  t_StaffLogDetail = SCAL[3];
  t_FileId         = LIKE(dbFile.dbFile);

 PUBLIC CONST
  ofc_All        =  0;
  ofc_BySort     =  1;
  ofc_ByPost     =  2;
  ofc_ByWagePay  =  3;
  ofc_ByUnion    =  4;
  ofc_ByTimeKeep =  5;
  ofc_ByPayKind  =  6;
  ofc_ByCash     =  8;
  ofc_ByOfficer  =  9;
  ofc_ByAcCut    = 10;
  ofc_ByShift    = 11;
  ofc_ByRegime   = 12;
  ofc_ByDirtyTyp = 13;
  ofc_DstMode    = 14;
  ofc_SalDSet    = 15;

  ofcs_Contract  = 0; (* t_ofcSource *)
  ofcs_Acting    = 1;
  ofcs_Temp      = 2;
  ofcs_byEDO     = 3;
  ofcs_ShortPool = "|||";
  ofcs_Pool      = "ࠪ|ᯮ騥 易|६|ᮢ饭";

  sld_No        = 0;
  sld_Simple    = 1;
  sld_wSheet    = 2;

  smt_Union     = 0;
  smt_Sort      = 1;

 IMPORT DBD, L_General, L_Man, L_AFM, L_Staff, P_Officer, L_DatTim, Math, Str, L_DBD,
        L_Str, E_Staff, L_Env, L_EDO, Memo, L_PRoll;

 PRIVATE CONST
  SMTNum   = 2;

 TYPE
  tSMObjects     = SCAL[SMTNum];
  tStaffMoveType = SCAL[2][SMTNum];

 PRIVATE PROCEDURE Create_StMov();
 BEGIN
  CreateFILE(StMov, "", " ᮭ", "");

  CreateFIELD(StMov, TSN,         LIKE(Staff.TSN),       "", "", "", " ", "");
  CreateFIELD(StMov, Date,        DATE,                  "", "", "", " ਪ  ६饭", "");
  CreateFIELD(StMov, DateE,       DATE,                  "", "", "", " 砭 ࠡ", "");
  CreateFIELD(StMov, RealDE,      DATE,                  "", "", "", "쭠  砭 ࠡ", "");
  CreateFIELD(StMov, TCntDE,      DATE,                  "", "", "", " 砭 ࠪ", "");
  CreateFIELD(StMov, Sort,        LIKE(Sort.Sort),       "", "", "", "ࠧ", "");
  CreateFIELD(StMov, Officer,     LIKE(Officer.Officer), "", "", "", " ࠡ祣   । ᥪ", "");
  CreateFIELD(StMov, SLKind,      LIKE(SLKind.SLKind),   "", "", "", " ६饭", "");
  CreateFIELD(StMov, DutyDgr, NUMERIC[4, 2],             "", "", "", "⥯  - ⭠  / ( <1 -  )", "");

  CreateFIELD(StMov, WasAtBeg,    SCAL[2],               "", "0", "", "  砫", "");
  CreateFIELD(StMov, WasBegan,    SCAL[2],               "", "0", "", " ਭ", "");
  CreateFIELD(StMov, WasLeaved,   SCAL[2],               "", "0", "", " 㢮", "");
  CreateFIELD(StMov, MustBeLeave, SCAL[2],               "", "0", "", "  㢮", "");
  CreateFIELD(StMov, WasAtEnd,    SCAL[2],               "", "0", "", "  ", "");
  CreateFIELD(StMov, WasIn,       tStaffMoveType,        "", "0", "", "室 ॢ", "");
  CreateFIELD(StMov, WasOut,      tStaffMoveType,        "", "0", "", "室 ॢ", "");

  CreateINDEXandLINK(StMov, TSN,     UNIQUE, Staff,   TSN,     USER, "", "", TSN,  Date, RealDE);
  CreateINDEXandLINK(StMov, Officer, PLURAL, Officer, Officer, USER, "", "", Sort, Officer, TSN);
  CreateINDEXandLINK(StMov, Sort,    PLURAL, Sort,    Sort,    USER, "", "", Sort);
  CreateINDEXandLINK(StMov, SLKind,  PLURAL, SLKind,  SLKind,  USER, "", "", SLKind);

  SetVersionOfFILE(StMov, 0000);
 END {Create_StMov};

 PRIVATE PROCEDURE TestMove(Dir    : NUMERIC[0];
                            _From,
                            _UpTo  : DATE;
                            VAR _Moving: tStaffMoveType);
  VAR
   _Union: LIKE(Union.Union);
   _Sort : LIKE(Sort.Sort);
   LookIt: SCAL[2];
 BEGIN
  CONFORM(StaffLog, Officer);
  _Union:=Officer.Union;
  _Sort :=Officer.Sort;
  LookIt:=1;
  SAVE(StaffLog);
  SAVE(SLKind);
  IF (Dir = +1) THEN
   LookIt:=NEXT(StaffLog) &
           L_DatTim.IsActive_Inc(StaffLog.Date, _From, _UpTo) &
           ~L_Staff.IsDischargeStaffLog();
  ELSIF (Dir = -1) THEN
   LookIt:=L_DatTim.IsActive_Inc(StaffLog.Date, _From, _UpTo) &
           PREV(StaffLog) &
           ~L_Staff.IsDischargeStaffLog();
  END;
  IF LookIt THEN
   CONFORM(StaffLog, Officer);
   _Moving[smt_Union]:=_Union # Officer.Union;
   _Moving[smt_Sort ]:=_Sort  # Officer.Sort;
  END;
  RESTORE(SLKind);
  RESTORE(StaffLog);
 END {TestMove};

 PRIVATE PROCEDURE WasAtFrontiers(D: DATE): SCAL[2];
  VAR
   _Date: DATE;
   _Was : SCAL[2];
 BEGIN
  DEC(D); (*   -  ᬥ ﭨ *)
  SAVE(StaffLog);
  SAVE(SLKind);
  _Date:=StaffLog.Date;
  _Was:=SRCINSEL(StaffLog, LE, D) & (StaffLog.Date = _Date) & ~L_Staff.IsDischargeStaffLog();
  RESTORE(SLKind);
  RESTORE(StaffLog);
  RETURN _Was;
 END {WasAtFrontiers};

 PRIVATE PROCEDURE bsf_AddDischarge(_From, _UpTo: DATE);
 BEGIN
  IF StaffLog.Date >= _From THEN
   DEFAULT(StMov);
   StMov.WasLeaved:=1;
   StMov.RealDE   :=StaffLog.Date - 1;
   StMov.TSN      :=StaffLog.TSN;
   StMov.Date     :=StaffLog.Date;
   StMov.DateE    :=StaffLog.DateE;
   StMov.SLKind   :=StaffLog.SLKind;
   SAVE(StaffLog);
   PREV(StaffLog);
   StMov.Sort     :=StaffLog.Sort;
   StMov.Officer  :=StaffLog.Officer;
   StMov.DutyDgr  :=StaffLog.DutyDgr;
   RESTORE(StaffLog);
   INSERT(StMov);
  END;
 END {bsf_AddDischarge};

 PRIVATE PROCEDURE bsf_AddTakeOnOrMove(_From, _UpTo: DATE);
  VAR
   _DateE: DATE;
 BEGIN
  DEFAULT(StMov);
  StMov.WasAtBeg:=WasAtFrontiers(  _From);
  StMov.WasAtEnd:=WasAtFrontiers(_UpTo+1);
  StMov.WasBegan :=(StaffLog.Date >= _From) &
                   ((SLKind.Type = L_Staff.slkt_TakeOn) |
                    (SLKind.Type = L_Staff.slkt_TakeOnWithDischarge));
  TestMove(-1, _From, _UpTo, StMov.WasIn);
  TestMove(+1, _From, _UpTo, StMov.WasOut);
  StMov.RealDE  :=L_Man.GetRealEndDate(StaffLog.Date);
  IF StMov.WasAtEnd THEN
   _DateE:=L_Man.GetTimedContractEndDate(_UpTo);
   IF (_DateE <= _UpTo) & (_DateE <= StMov.RealDE) THEN
    StMov.MustBeLeave:=WasAtFrontiers(_UpTo+2);
    StMov.RealDE     :=_DateE;
   END;
  END;
  StMov.TSN    :=StaffLog.TSN;
  StMov.Date   :=StaffLog.Date;
  StMov.DateE  :=StaffLog.DateE;
  StMov.Sort   :=StaffLog.Sort;
  StMov.Officer:=StaffLog.Officer;
  StMov.SLKind :=StaffLog.SLKind;
  StMov.DutyDgr:=StaffLog.DutyDgr;
  INSERT(StMov);
 END {bsf_AddTakeOnOrMove};

 PUBLIC PROCEDURE BuildStaffMove(_From, _UpTo: DATE);
 BEGIN
  APP.Get().NewPrompt("஥ ");
  Create_StMov();
  L_AFM.AF_CreateTemp("StMov", "StMov");

  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Env.RealTSN(Staff.TSN) &
      L_Staff.InStateInPer(_From-1(*᪮ 㢮 31  㦥*), _UpTo) THEN
    SETSEL(StaffLog, TSN, Staff.TSN);
    SRCINSEL(StaffLog, LE, , Math.Max(Staff.BegDate, _From-1));
    WHILE OCCURE(StaffLog) & (StaffLog.Date <= _UpTo) DO
     CONFORM(StaffLog, SLKind);
     IF SLKind.Type = L_Staff.slkt_Discharge THEN
      bsf_AddDischarge(_From, _UpTo);
     ELSIF SLKind.Type = L_Staff.slkt_TakeOnWithDischarge THEN
      bsf_AddDischarge(_From, _UpTo);
      bsf_AddTakeOnOrMove(_From, _UpTo);
     ELSE
      bsf_AddTakeOnOrMove(_From, _UpTo);
     END; (* IF SLKind ... *)
     NEXT(StaffLog);
    END; (* WHILE OCCURE(StaffLog)... *)
   END; (* IF L_Staff.InStateInPer ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff)... *)
 END {BuildStaffMove};

 PUBLIC PROCEDURE PurgeStaffMove();
 BEGIN
  L_AFM.AF_PurgeTemp("StMov");
 END {PurgeStaffMove};

 PUBLIC VAR
  Stl01_IntvlB,
  Stl01_IntvlE,
  Stl01_ReferenceDate: DATE;

 PRIVATE VAR
  FixedShiftNum      : SCAL[1E1];

 PRIVATE PROCEDURE Create_Ofc01();
 BEGIN
  IF ~DBD.FileExist(Ofc01) THEN
   CreateFILE(Ofc01, "", "祭 ࠡ   ᬮ७", "");
 
   CreateFIELD(Ofc01, SrcFile,  t_FileId,                             "", "", "", "-筨", "");
   CreateFIELD(Ofc01, Sort,     LIKE(Sort.Sort),                      "", "", "", "", "");
   CreateFIELD(Ofc01, Officer,  LIKE(Officer.Officer),                "", "", "", "祥 ", "");
   CreateFIELD(Ofc01, ShiftNum, SCAL[1E1],                            "", "", "", " ᬥ", "");
   CreateFIELD(Ofc01, Vacancy,  NUMERIC[8, 3][P_Officer.ClassAmount], "", "", "", "⢮ ", "");
 
   CreateINDEX(       Ofc01, SrcFile, UNIQUE,                         "", "", SrcFile, Sort, Officer, ShiftNum);
   CreateINDEXandLINK(Ofc01, Officer, PLURAL, Officer, Officer, USER, "", "", Sort, Officer, ShiftNum);
 
   SetVersionOfFILE(Ofc01, 0000);
  END;
  L_AFM.AF_CreateTemp("Ofc01", "Ofc01");
 END {Create_Ofc01};

 PRIVATE PROCEDURE Create_Stl01();
 BEGIN
  IF ~DBD.FileExist(Stl01) THEN
   CreateFILE(Stl01, "", "ਪ  //  ᬮ७", "");
 
   CreateFIELD(Stl01, TSN,      LIKE(StaffLog.TSN),     "", "", "", " ", "");
   CreateFIELD(Stl01, Sort,     LIKE(StaffLog.Sort),    "", "", "", "", "");
   CreateFIELD(Stl01, Officer,  LIKE(StaffLog.Officer), "", "", "", "祥 ", "");
   CreateFIELD(Stl01, BegDate,  DATE,                   "", "", "", "ਭ", "");
   CreateFIELD(Stl01, EndDate,  DATE,                   "", "", "", "", "");
   CreateFIELD(Stl01, OBegDate, DATE,                   "", "", "", " ࠡ祬  ''", "");
   CreateFIELD(Stl01, OEndDate, DATE,                   "", "", "", " ࠡ祬  ''", "");
   CreateFIELD(Stl01, Source,   t_ofcSource,            "", "", "", "筨", "");
   CreateFIELD(Stl01, Class,    LIKE(StaffLog.Class),   "", "", "", "䨪", "");
   CreateFIELD(Stl01, Regime,   LIKE(StaffLog.Regime),  "", "", "", "䨪", "");
   CreateFIELD(Stl01, DutyDgr,  LIKE(StaffLog.DutyDgr), "", "", "", "", "");
   CreateFIELD(Stl01, AsRealDD, NUMERIC[6, 4],          "", "", "", "⥯   ⮬ ਮ ࠡ", "");
   CreateFIELD(Stl01, RealDD,   NUMERIC[6, 4],          "", "", "", "䥪⨢ ⥯ ", "");
   CreateFIELD(Stl01, ShiftNum, SCAL[1E1],              "", "", "", " ᬥ", "");
   CreateFIELD(Stl01, SrcFile,  t_FileId,               "", "", "", "-筨", "");
 
   CreateINDEX(       Stl01, SrcFile, PLURAL,                         "", "", SrcFile, Sort, Officer, ShiftNum, Source, TSN, OBegDate);
   CreateINDEXandLINK(Stl01, Officer, PLURAL, Officer, Officer, USER, "", "", Sort, Officer, ShiftNum, Source, TSN, OBegDate);
   CreateINDEXandLINK(Stl01, TSN,     PLURAL, Staff,   TSN,     USER, "", "", TSN, Source);
   CreateINDEX(       Stl01, SrcFTSN, PLURAL,                         "", "", SrcFile, TSN, Source);
   CreateINDEXandLINK(Stl01, Sort,    PLURAL, Sort,    Sort,    USER, "", "", Sort, TSN);
 
   SetVersionOfFILE(Stl01, 0001);
  END;
  L_AFM.AF_CreateTemp("Stl01", "Stl01");
 END {Create_Stl01};

 PRIVATE PROCEDURE GetShiftNumber(_Sort   : LIKE(Officer.Sort);
                                  _Officer: LIKE(Officer.Officer);
                                  _Regime : LIKE(RegMain.Regime)): SCAL[1E1];
 BEGIN
  IF SEARCH(OfcShift, Officer, _Sort, _Officer, _Regime) THEN
   CONFORM(OfcShift, Shift);
   RETURN Shift.Number;
  ELSE
   RETURN P_Officer.ost_NoShift;
  END;
 END {GetShiftNumber};

 PRIVATE PROCEDURE Ins_Ofc01(trgSrcFile: t_FileId);
  VAR
   _Class     : LIKE(StaffLog.Class);
   ShiftAmount: NUMERIC[0];
   VC         : P_Officer.tVacancyConception;
   HasVC      : SCAL[2];
 BEGIN
  HasVC:=P_Officer.PrepareVacancyConception(Officer.Sort, Officer.Officer, Stl01_ReferenceDate, VC);
  ShiftAmount:=P_Officer.GetRealShiftAmount();
  WHILE ShiftAmount >= 0 DO
   IF !FixedShiftNum | (ShiftAmount = FixedShiftNum) THEN
    ADD(Ofc01, SrcFile, , trgSrcFile, Officer.Sort, Officer.Officer, ShiftAmount);
    SETZERO(Ofc01.Vacancy);
    FOR_EACH _Class DO (* _Class:=0;  뢠 ᢮⢠ "ࠡ  ᥣ *)
     IF HasVC THEN
      Ofc01.Vacancy[_Class]:=P_Officer.extGetVacancyAmount(VC, _Class, ShiftAmount);
     ELSE
      Ofc01.Vacancy[_Class]:=0;
     END;
    END; (* FOR_EACH _Class *)
    REPLACE(Ofc01);
   END;
   DEC(ShiftAmount);
  END;
 END {Ins_Ofc01};

 PRIVATE PROCEDURE GatherOfc01_ByCurrentSelect();
 BEGIN
  WHILE OCCURE(Officer) DO
   PROMPT("⮢ ᯨ᪠ ࠡ  " + Officer.Sort + " " + Officer.Officer);
   Ins_Ofc01(TABLE.Get("StaffLog").Id);
   NEXT(Officer);
  END; (* WHILE OCCURE(Officer) ... *)
 END {GatherOfc01_ByCurrentSelect};

 PRIVATE PROCEDURE pOfc1_bySort(curSort: LIKE(Sort.Sort));
 BEGIN
  IF ~!TABLE.Get("Sort").Fields("Leaf") THEN
   SAVE(Sort);
   IF ~SELECT(Sort, Parent, curSort) THEN
    SELECT(Officer, Officer, , curSort);
    GatherOfc01_ByCurrentSelect();
   ELSE
    WHILE OCCURE(Sort) DO
     pOfc1_bySort(Sort.Sort);
     NEXT(Sort);
    END; (* WHILE OCCURE(Sort) *)
   END; (* IF ~SELECT(Sort, Parent ... *)
   RESTORE(Sort);
  ELSE
   SELECT(Officer, Sort, , Sort.Sort);
   GatherOfc01_ByCurrentSelect();
  END;
 END {pOfc1_bySort};

 PRIVATE PROCEDURE pOfc1_ByDirtyTyp();
  VAR
   curDirtyTyp           : LIKE(DirtyTyp.DirtyTyp);
   dummySpecialEvaluation: P_Officer.tSpecialEvaluation;
 BEGIN
  SETSEL(OfcPro, Property, P_Officer.P_LabourConditions);
  FOR_EACH OfcPro DO
   PROMPT("⮢ ᯨ᪠ ࠡ  " + OfcPro.Sort + " " + OfcPro.Officer);
   P_Officer.Decode_LabourConditions(OfcPro.Value, curDirtyTyp, dummySpecialEvaluation);
   IF curDirtyTyp = DirtyTyp.DirtyTyp THEN
    CONFORM(OfcPro, Officer);
    Ins_Ofc01(TABLE.Get("StaffLog").Id);
   END;
  END; (* FOR_EACH OfcPro *)
 END {pOfc1_ByDirtyTyp};

 PRIVATE PROCEDURE Prepare_Ofc01(byWhat: t_ofcSubject);
 BEGIN
  Create_Ofc01();
  SETEMPTY(FixedShiftNum);
  IF    byWhat = ofc_ByCash THEN
   SELECT(TimeKeep, Cash, , Cash.Cash);
   WHILE OCCURE(TimeKeep) DO
    SELECT(Officer, TimeKeep, , TimeKeep.TimeKeep);
    GatherOfc01_ByCurrentSelect();
    NEXT(TimeKeep);
   END; (* WHILE OCCURE(TimeKeep) ... *)
  ELSIF byWhat = ofc_ByAcCut THEN
   IF ~L_PRoll.UseSalDSet() THEN
    SELECT(OfcDst, AcCut, , AcCut.AcCut);
    WHILE OCCURE(OfcDst) DO
     IF ~SELECT(Ofc01, Officer, OfcDst.Sort, OfcDst.Officer) THEN
      SELECT(Officer, Officer, , OfcDst.Sort, OfcDst.Officer);
      GatherOfc01_ByCurrentSelect();
     END;
     NEXT(OfcDst);
    END; (* WHILE OCCURE(OfcDst) ... *)
   END;
  ELSIF byWhat = ofc_ByShift THEN
   FixedShiftNum:=Shift.Number;
   SELECT(OfcShift, Shift, , Shift.Shift);
   WHILE OCCURE(OfcShift) DO
    SAVE(OfcShift);
    IF ~SELECT(Ofc01, Officer, OfcShift.Sort, OfcShift.Officer) THEN
     SELECT(Officer, Officer, , OfcShift.Sort, OfcShift.Officer);
     GatherOfc01_ByCurrentSelect();
    END;
    RESTORE(OfcShift);
    NEXT(OfcShift);
   END; (* WHILE OCCURE(OfcShift) ... *)
  ELSIF byWhat = ofc_ByRegime THEN
   SELECT(StaffLog, HumReg, , RegMain.Regime);
   WHILE OCCURE(StaffLog) DO
    IF ~SELECT(Ofc01, Officer, StaffLog.Sort, StaffLog.Officer) &
       ~L_Staff.IsDischargeStaffLog() &
        L_Staff.OrderInIntvl(Stl01_IntvlB, Stl01_IntvlE) THEN
     SAVE(StaffLog);
     SELECT(Officer, Officer, , StaffLog.Sort, StaffLog.Officer);
     GatherOfc01_ByCurrentSelect();
     RESTORE(StaffLog);
    END;
    NEXT(StaffLog);
   END; (* WHILE OCCURE(StaffLog) ... *)
  ELSIF byWhat = ofc_DstMode THEN
   SELECT(OfcDst, DstMode, , DstMode.DstMode);
   WHILE OCCURE(OfcDst) DO
    SELECT(Officer, Officer, , OfcDst.Sort, OfcDst.Officer);
    GatherOfc01_ByCurrentSelect();
    NEXT(OfcDst);
   END; (* WHILE OCCURE(OfcDst) ... *)
  ELSIF byWhat = ofc_BySort THEN
   pOfc1_bySort(Sort.Sort);
  ELSIF byWhat = ofc_ByDirtyTyp THEN
   pOfc1_ByDirtyTyp();
  ELSE
   IF byWhat = ofc_All THEN
    SELECT(Officer, Officer);
   ELSIF byWhat = ofc_ByPost THEN
    SELECT(Officer, Post, , Post.Post);
   ELSIF byWhat = ofc_ByWagePay THEN
    SELECT(Officer, WagePay, , WagePay.WagePay);
   ELSIF byWhat = ofc_ByUnion THEN
    SELECT(Officer, Union, , Union.Union);
   ELSIF byWhat = ofc_ByTimeKeep THEN
    SELECT(Officer, TimeKeep, , TimeKeep.TimeKeep);
   ELSIF byWhat = ofc_ByPayKind THEN
    SELECT(Officer, PayKind, , PayKind.PayKind);
   ELSIF byWhat = ofc_ByOfficer THEN
    CHANGESEL(Officer, Officer, , Officer.Sort, Officer.Officer);
   ELSIF byWhat = ofc_SalDSet THEN
    SELECT(Officer, SalDSet, , SalDSet.SalDSet);
   ELSE
    L_General.CallUs(0);
   END;
   GatherOfc01_ByCurrentSelect();
  END;
 END {Prepare_Ofc01};

 PRIVATE PROCEDURE GetGateByCurrentOfficer(VAR _OBegDate, _OEndDate: DATE);
  VAR
   _Sort   : LIKE(StaffLog.Sort);
   _Officer: LIKE(StaffLog.Officer);
 BEGIN
  SAVE(StaffLog);
  CHANGESEL(StaffLog, TSN, , StaffLog.TSN);
  _Sort   :=StaffLog.Sort;
  _Officer:=StaffLog.Officer;
  WHILE OCCURE(StaffLog) & ~L_Staff.IsDischargeStaffLog() &
        (StaffLog.Sort = _Sort) & (StaffLog.Officer = _Officer) DO
   _OBegDate:=StaffLog.Date;
   PREV(StaffLog);
  END;
  RESTORE(StaffLog);
  SAVE(StaffLog);
  CHANGESEL(StaffLog, TSN, , StaffLog.TSN);
  WHILE OCCURE(StaffLog) & ~L_Staff.IsDischargeStaffLog() &
       (StaffLog.Sort = _Sort) & (StaffLog.Officer = _Officer) DO
   _OEndDate:=StaffLog.DateE;
   NEXT(StaffLog);
  END;
  RESTORE(StaffLog);
 END {GetGateByCurrentOfficer};

 PUBLIC PROCEDURE JModeIsAbsence(): SCAL[2];
 BEGIN
  RETURN ((JMode.Type = L_Sheet.jmType_NonPAbsent) | (JMode.Type = L_Sheet.jmType_PaidAbsent)) &
         ((JMode.JMode # 01(*sic         室!*)) &
          (JMode.JMode # 20(*sic ப  㯨!*)));
 END {JModeIsAbsence};

 PRIVATE PROCEDURE _Ins_Stl01(_TSN      : LIKE(StaffLog.TSN);
                              _OBegDate : DATE;
                              _OEndDate : DATE;
                              _Source   : t_ofcSource;
                              _Class    : LIKE(StaffLog.Class);
                              _Regime   : LIKE(StaffLog.Regime);
                              _DutyDgr  : LIKE(StaffLog.DutyDgr);
                              _sld      : t_StaffLogDetail;
                              trgSrcFile: t_FileId);
  VAR
   realB,
   realE      : DATE;
   daysInWork : NUMERIC[0];
 BEGIN
  SEARCH(Staff, TSN, , _TSN);
  Stl01.TSN     :=Staff.TSN;
  Stl01.Sort    :=Ofc01.Sort;
  Stl01.Officer :=Ofc01.Officer;
  Stl01.BegDate :=L_Man.GetTakeOnDate(Stl01_ReferenceDate);
  Stl01.EndDate :=L_Man.GetRealEndDate(Stl01_ReferenceDate);
  Stl01.OBegDate:=_OBegDate;
  Stl01.OEndDate:=_OEndDate;
  Stl01.Source  :=_Source;
  Stl01.Class   :=_Class;
  Stl01.Regime  :=_Regime;
  Stl01.DutyDgr :=_DutyDgr;
  Stl01.SrcFile :=trgSrcFile;
  realB:=Math.Max(Stl01.OBegDate, Stl01_IntvlB);
  realE:=Math.Min(Stl01.OEndDate, Stl01_IntvlE);
  daysInWork:=realE-realB+1;
  Stl01.AsRealDD:=Stl01.DutyDgr * (daysInWork/(Stl01_IntvlE-Stl01_IntvlB+1));
  IF _sld = sld_wSheet THEN
   SETSEL(Sheet, TSN, Staff.TSN);
   SRCINSEL(Sheet, GE, , L_DatTim.Per(realB), L_DatTim.DAY(realB));
   WHILE OCCURE(Sheet) & ((Sheet.Period + Sheet.Day - 1) <= realE) DO
    CONFORM(Sheet, JMode);
    IF JModeIsAbsence() THEN
     DEC(daysInWork);
    END;
    NEXT(Sheet);
   END; (* WHILE OCCURE(Sheet) ... *)
  END;
  Stl01.RealDD:=Stl01.DutyDgr * (daysInWork/(Stl01_IntvlE-Stl01_IntvlB+1));
  Stl01.ShiftNum:=Ofc01.ShiftNum;
  INSERT(Stl01);
 END {_Ins_Stl01};

 PRIVATE PROCEDURE Ins_Stl01(_TSN      : LIKE(StaffLog.TSN);
                             _OBegDate : DATE;
                             _OEndDate : DATE;
                             _Source   : t_ofcSource;
                             _Class    : LIKE(StaffLog.Class);
                             _Regime   : LIKE(StaffLog.Regime);
                             _DutyDgr  : LIKE(StaffLog.DutyDgr);
                             _sld      : t_StaffLogDetail;
                             trgSrcFile: t_FileId);
 BEGIN
  IF Ofc01.ShiftNum = GetShiftNumber(Ofc01.Sort, Ofc01.Officer, _Regime) THEN
   _Ins_Stl01(_TSN, _OBegDate, _OEndDate, _Source, _Class, _Regime, _DutyDgr, _sld, trgSrcFile);
  END;
 END {Ins_Stl01};

 PRIVATE PROCEDURE E_EDOrderLForOverlaping(D: DATE; Type: SCAL[2]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Staff.EDOrderLForOverlaping);
  IF ~!Local THEN
   RETURN Local(D, Type);
  ELSE
   RETURN 1;
  END;
 END {E_EDOrderLForOverlaping};

 PRIVATE PROCEDURE ByRegimeCond(_byWhat: t_ofcSubject): SCAL[2];
 BEGIN
  RETURN (_byWhat # ofc_ByRegime) | (StaffLog.Regime=RegMain.Regime);
 END {ByRegimeCond};

 PRIVATE PROCEDURE GetOfcSource(): t_ofcSource;
  VAR
   Result: t_ofcSource;
 BEGIN
  CONFORM(StaffLog, SLKind);
  IF    SLKind.IsActing THEN
   Result:=ofcs_Acting;
  ELSIF SLKind.IsTemp | (StaffLog.ContDTyp = L_Staff.cdt_FixedDate) THEN
   Result:=ofcs_Temp;
  ELSE
   Result:=ofcs_Contract;
  END;
  RETURN Result;
 END {GetOfcSource};

 PRIVATE PROCEDURE Process_r2r_Users(byWhat   : t_ofcSubject;
                                     wStaffLog: t_StaffLogDetail);
 BEGIN
  IF    byWhat = ofc_ByRegime THEN
   SELECT(r2r, byOwn, , TABLE.Get("RegMain").Id, RegMain.RECORDID, TABLE.Get("StaffPro").Id);
   WHILE OCCURE(r2r) DO
    PROMPT(r2r.RECORDID);
    TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_THROW)]
     SEARCH(StaffPro, RECORDID, , r2r.riUsr);
     CONFORM(StaffPro, Staff);
     IF L_DatTim.IsActiveInIntvl_Inc(Stl01_IntvlB, Stl01_IntvlE, StaffPro.Date, StaffPro.EndDate) THEN
      SAVE(StaffLog);
      L_Staff.PosToStaffLog(Staff.TSN, Stl01_IntvlE, 1);
      WHILE OCCURE(StaffLog) & L_Staff.OrderInIntvl(Stl01_IntvlB, Stl01_IntvlE) DO
       IF ~L_Staff.IsDischargeStaffLog() THEN
        SELECT(Officer, Officer, , StaffLog.Sort, StaffLog.Officer);
        Ins_Ofc01(r2r.fiUsr);
        Ins_Stl01(StaffLog.TSN, Math.Max(StaffPro.Date, StaffLog.Date), Math.Min(StaffPro.EndDate, StaffLog.DateE), GetOfcSource(), StaffLog.Class,
                  RegMain.Regime, StaffLog.DutyDgr, wStaffLog, r2r.fiUsr);
       END;
       PREV(StaffLog);
      END;
      RESTORE(StaffLog);
     END;
    EXCEPT
    ON Exc:Exc_NoRights DO
    END;
    NEXT(r2r);
   END; (* WHILE OCCURE(r2r) ... *)
  END;
 END {Process_r2r_Users};

 PRIVATE PROCEDURE ProcessOneStaffLog(timeCond : L_General.tTimeCond;
                                      byWhat   : t_ofcSubject;
                                      wStaffLog: t_StaffLogDetail);
  VAR
   _OBegDate,
   _OEndDate : DATE;
 BEGIN
  IF (timeCond = L_General.timeCond_OnDate) & (byWhat # ofc_ByRegime) THEN
   GetGateByCurrentOfficer(_OBegDate, _OEndDate);
  ELSE
   _OBegDate:=StaffLog.Date;
   _OEndDate:=StaffLog.DateE;
  END;
  IF byWhat = ofc_All THEN
   _Ins_Stl01(StaffLog.TSN, _OBegDate, _OEndDate, GetOfcSource(), StaffLog.Class,
              StaffLog.Regime, StaffLog.DutyDgr, wStaffLog, TABLE.Get("StaffLog").Id);
  ELSE
   Ins_Stl01(StaffLog.TSN, _OBegDate, _OEndDate, GetOfcSource(), StaffLog.Class,
             StaffLog.Regime, StaffLog.DutyDgr, wStaffLog, TABLE.Get("StaffLog").Id);
  END;
 END {ProcessOneStaffLog};

 PUBLIC PROCEDURE Prepare_Stl01(timeCond : L_General.tTimeCond;
                                byWhat   : t_ofcSubject;
                                wStaffLog: t_StaffLogDetail);
  VAR
   OBegDate,
   OEndDate : DATE;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  IF    timeCond = L_General.timeCond_OnDate  THEN
   Stl01_IntvlB       :=Memo.ud_cd();
   Stl01_IntvlE       :=Memo.ud_cd();
   Stl01_ReferenceDate:=Memo.ud_cd();
  ELSIF timeCond = L_General.timeCond_InIntvl THEN
   Stl01_IntvlB       :=Memo.ud_fr();
   Stl01_IntvlE       :=Memo.ud_ut();
   Stl01_ReferenceDate:=Memo.ud_ut();
  ELSE
   Stl01_IntvlB       :=MINOF(DATE);
   Stl01_IntvlE       :=MAXOF(DATE);
   Stl01_ReferenceDate:=SYSDATE();
  END;

  Prepare_Ofc01(byWhat);
  Create_Stl01();

  IF wStaffLog # sld_No THEN
   IF byWhat = ofc_All THEN
    SELECT(Staff, TSN);
    WHILE OCCURE(Staff) DO
     IF L_Env.RealTSN(Staff.TSN) & (Staff.BegDate <= Stl01_IntvlE) THEN
      PROMPT("஥ : ࠪ " + Staff.TSN);
      L_Staff.PosToStaffLog(Staff.TSN, Stl01_IntvlE, 1);
      WHILE OCCURE(StaffLog) & (StaffLog.DateE >= Stl01_IntvlB) DO
       IF ~L_Staff.IsDischargeStaffLog() &
          ByRegimeCond(byWhat) THEN
        SEARCH(Ofc01, SrcFile, , TABLE.Get("StaffLog").Id, StaffLog.Sort, StaffLog.Officer,
               GetShiftNumber(StaffLog.Sort, StaffLog.Officer, StaffLog.Regime));
        ProcessOneStaffLog(timeCond, byWhat, wStaffLog);
       END; (* IF ... *)
       PREV(StaffLog);
      END;
     END;
     NEXT(Staff);
    END; (* WHILE OCCURE(Staff) ... *)
   ELSE
    SELECT(Ofc01, SrcFile, , TABLE.Get("StaffLog").Id);
    WHILE OCCURE(Ofc01) DO
     CONFORM(Ofc01, Officer);
     SELECT(StaffLog, Officer, , Ofc01.Sort, Ofc01.Officer);
     WHILE OCCURE(StaffLog) DO
      PROMPT("஥ : ࠪ " + StaffLog.TSN + " (" + Ofc01.Sort + " " + Ofc01.Officer + ")");
      IF L_Env.RealTSN(StaffLog.TSN) & ~L_Staff.IsDischargeStaffLog() &
         L_Staff.OrderInIntvl(Stl01_IntvlB, Stl01_IntvlE) &
         ByRegimeCond(byWhat) THEN
       ProcessOneStaffLog(timeCond, byWhat, wStaffLog);
      END; (* IF ... *)
      NEXT(StaffLog);
     END; (* WHILE OCCURE(StaffLog) ... *)
     NEXT(Ofc01);
    END; (* WHILE OCCURE(Ofc01) ... *)
   END; (* IF byWhat = ... *)
  END; (* IF wStaffLog # sld_No ... *)

  SELECT(Ofc01, SrcFile, , TABLE.Get("StaffLog").Id);
  WHILE OCCURE(Ofc01) DO
   CONFORM(Ofc01, Officer);
   SELECT(EDOrderL, Officer, , Ofc01.Sort, Ofc01.Officer);
   SRCINSEL(EDOrderL, GE, , Stl01_IntvlB);
   WHILE OCCURE(EDOrderL) DO
    PROMPT("஥ : ᮢ饭 " + EDOrderL.RECORDID);
    IF EDOrderL.EDOGrp = L_EDO.grp_Combining THEN
     CONFORM(EDOrderL, Staff);
     IF (EDOrderL.Status  = L_EDO.st_Passed)            &
        (EDOrderL.Type    # L_EDO.type_Cancel)          &
        E_EDOrderLForOverlaping(Stl01_ReferenceDate,
                                wStaffLog = sld_wSheet) THEN
      OBegDate:=EDOrderL.OcrDate;
      OEndDate:=Math.Min(EDOrderL.EndDate, Staff.EndDate);
      IF L_DatTim.IsActiveInIntvl_Inc(Stl01_IntvlB, Stl01_IntvlE, OBegDate, OEndDate) THEN
       HISTCONF(Stl01_ReferenceDate, Staff, StaffLog);
       IF ByRegimeCond(byWhat) THEN
        SAVE(Ofc01);
        IF ~SELECT(Ofc01, SrcFile, TABLE.Get("StaffLog").Id, Officer.Sort, Officer.Officer) THEN
         Ins_Ofc01(TABLE.Get("StaffLog").Id);
        END;
        RESTORE(Ofc01);
        IF wStaffLog # sld_No THEN
         Ins_Stl01(EDOrderL.TSN, OBegDate, OEndDate,
                   ofcs_byEDO, EDOrderL.Class, StaffLog.Regime, EDOrderL.ByPrc/100, wStaffLog, TABLE.Get("StaffLog").Id);
        END;
       END; (* IF ByRegimeCond(byWhat) ... *)
      END;
     END;
    END; (* IF EDOrderL.EDOGrp = L_EDO.grp_Combining ... *)
    NEXT(EDOrderL);
   END; (* WHILE OCCURE(EDOrderL) ... *)
   IF ~L_DatTim.IsActiveInIntvl_Inc(Stl01_IntvlB, Stl01_IntvlE,
                                    Officer.Begin, L_DatTim.till2ED(Officer.Till)) THEN
    IF SELECT(Stl01, SrcFile, TABLE.Get("StaffLog").Id, Officer.Sort, Officer.Officer) THEN
     L_General.Error("ਮ ਬ ਪ "+L_Str.PoolItem(" | ᮢ饭", Stl01.Source=ofcs_byEDO)+
                     "  ࠡ祣   ᮣᮢ"+
                     "||"+
                     Str.Align("⭨: "+Stl01.TSN, 71, LEFT)+
                     "||"+
                     Str.Align("祥 : "+L_DBD.RecordToStr(TABLE.Get("Officer")), 71, LEFT)+
                     "|"+
                     Str.Align("ਮ ਬ:  "+L_DatTim.DateStr(Officer.Begin)+"  "+L_DatTim.DateStr(Officer.Till), 71, LEFT));
    END;
    REMOVE(Ofc01);
   ELSE
    NEXT(Ofc01);
   END;
  END; (* WHILE OCCURE(Ofc01) ... *)

  Process_r2r_Users(byWhat, wStaffLog);
 END {Prepare_Stl01};

 PUBLIC PROCEDURE Purge_Stl01();
 BEGIN
  L_AFM.AF_PurgeTemp("Stl01");
  L_AFM.AF_PurgeTemp("Ofc01");
 END {Purge_Stl01};

END.
