(*
%Copyright   (c) Polak Computer System
%Author      01.06.2000 20:55:06 SAN
%Purpose     ᠭ  ⥫ 䠩 - ᪫
%Type        library
%Specific    SYS
%Modified    04.12.2013 13:58:16 POLAK\LDA
%Environment
*)

 MODULE D_Stock [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_AFM, L_MathR, L_Car, L_MDoc, L_XObj, Math;

 PRIVATE PROCEDURE Create_MDL();
 BEGIN
  CREATE_TABLE(MDL, , "室   ");

  CREATE_FIELD(MDL, MyFirm,   LIKE(MyFirm.MyFirm),     ,    , , "'' ࣠");
  CREATE_FIELD(MDL, BoxNbr,   LIKE(Car.BoxNbr),        ,    , , "ࠦ");
  CREATE_FIELD(MDL, clDate,   DATE,                    ,    , , " CarLog");
  CREATE_FIELD(MDL, Mark,     LIKE(Mark.Mark),         ,    , , " ન");
  CREATE_FIELD(MDL, Math,     LIKE(Math.Math),         ,    , , "");
  CREATE_FIELD(MDL, MathType, LIKE(MathType.MathType), ,    , , " ");
  CREATE_FIELD(MDL, FlowType, L_MDoc.tMathFlowType,    ,    , , "ࠢ");
  CREATE_FIELD(MDL, CostItem, LIKE(CostItem.CostItem), ,    , , "");
  CREATE_FIELD(MDL, Sum,      L_XObj.tSum,             , "0", , "稭  (㬬)");

  CREATE_INDEX_AND_LINK(MDL, BoxNbr, UNIQUE, Car, BoxNbr, USER, , , BoxNbr, clDate, Mark, MyFirm, MathType, Math, CostItem, FlowType);
  SET_VERSION_OF_TABLE(MDL, 0009);
 END {Create_MDL};

 PRIVATE PROCEDURE Make_MDL(glbFrom, glbUpTo: DATE);
  VAR
   trgFrom,
   trgUpTo: DATE;
   curSum : NUMERIC[2];
 BEGIN
  TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_THROW)]
   SELECT(Car, BoxNbr);
   WHILE OCCURE(Car) DO
    PROMPT(" " + Car.BoxNbr);
    SELECT(CarLog, BoxNbr, , Car.BoxNbr);
    WHILE OCCURE(CarLog) DO
     trgFrom:=Math.Max(CarLog.Date,  glbFrom);
     IF (CarLog.Status # L_Car.carst_Retired) THEN
      trgUpTo:=Math.Min(CarLog.DateE, glbUpTo);
     ELSE
      trgUpTo:=Memo.ud_ut();
     END;
     IF trgFrom <= trgUpTo THEN
      SETSEL(MDoc, BoxNbr, Car.BoxNbr);
      SRCINSEL(MDoc, GE, , trgFrom);
      WHILE OCCURE(MDoc) & (MDoc.Date <= trgUpTo) DO
       PROMPT(" " + Car.BoxNbr + ",  " + L_MDoc.GetMDocStrNbr());
       IF (MDoc.Status = L_MDoc.st_Passed) & (MDoc.MDocKind # L_MDoc.md_MSP) THEN
        SELECT(MDocList, MDLMath, , MDoc.MDocKind, MDoc.MDoc);
        WHILE OCCURE(MDocList) DO
         IF ~!MDocList.Math & (L_MDoc.getMDocListMathFlowType() = L_MDoc.mft_Credit) THEN
          CONFORM(MDocList, Math);
          IF (MDocList.Sum # 0) & ~!MDocList.Sum THEN
           curSum:=MDocList.Sum;
          ELSIF MDocList.Qnt # 0 THEN
           curSum:=MDocList.Qnt * L_MathR.GetMDLMathPrice();
          ELSE
           curSum:=0;
          END;
          IF curSum # 0 THEN
           ADD(MDL, BoxNbr, , CarLog.BoxNbr, CarLog.Date, CarLog.Mark, MDoc.MyFirm,
                              Math.MathType, MDocList.Math, MDoc.CostItem, L_MDoc.mft_Credit,
               MDL.Sum,  curSum);
          END; (* IF curSum # 0 *)
         END; (* IF ~!MDocList.Math ... *)
         NEXT(MDocList);        
        END; (* WHILE OCCURE(MDocList) ... *)
       END; (* IF MDoc.Status ... *)
       NEXT(MDoc);
      END; (* WHILE OCCURE(MDoc) ... *)
     END; (* IF trgFrom <= trgUpTo *)
     NEXT(CarLog);
    END; (* WHILE OCCURE(CarLog) ... *)
    NEXT(Car);
   END; (* WHILE OCCURE(Car) ... *)
  EXCEPT
  END; (* TRY *)
 END {Make_MDL};

 PUBLIC PROCEDURE PrepareMDL();
 BEGIN
  IF L_AFM.inRegistering() THEN
   Create_MDL();
   L_AFM.msrf_Register("MDL", "MDL", L_General.tc_inIntvl, Memo.ud_fr(), Memo.ud_ut());
  END;
  IF L_AFM.inAttaching() THEN
   IF ~L_AFM.msrf_Reuse("MDL", 0) THEN
    APP.Get().NewPrompt(L_AFM.rf_PreparePromptStr("MDL"));
    L_AFM.msrf_Create("MDL");
    Make_MDL(Memo.ud_fr(), Memo.ud_ut());
    L_AFM.msrf_Store("MDL");
   END; (* IF ~msrf_Reuse ... *)
  END;
 END {PrepareMDL};

END.
