(*
%Copyright   (c) Polak Computer System
%Author      06.04.2001 18:55:18 RSN
%Purpose     ᠭ  ⥫ 䠩 - ꥪ 
%Type        library
%Specific    SYS
%Modified    15.08.2014 18:25:31 POLAK\Bor
%Environment
*)

 MODULE D_XObj [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  XCContentType = SCAL[20];
  XCSortType    = SCAL[11];
  XCLevelType   = SCAL[7];

 PUBLIC CONST
  XCC_FullWealth     =  0;
  XCC_SingleXObject  =  1;
  XCC_SingleAcCut    =  2;
  XCC_SingleTSN      =  4;
  XCC_SingleMath     =  5;
  XCC_SingleSort     =  6;
  XCC_SingleAcCut2   =  7;
  XCC_SingleFirm     =  8;
  XCC_FullMath       =  9;
  XCC_SingleMathType = 10;
  XCC_FullKA         = 11;
  XCC_FP_Math        = 12;
  XCC_SingleDeprecT  = 13;
  XCC_FP_KA          = 14;
  XCC_SingleStorage  = 15;
  XCC_WholeAcnt      = 16;
  XCC_WholeAcCut     = 17;
  XCC_SingleMan      = 18;
  XCC_SingleCostItem = 19;

  XST_TheSingle  =  0;
  XST_ByAcCut    =  1;
  XST_ByApport   =  2;
  XST_ByAcnt     =  3;
  XST_ByMan      =  4;
  XST_ByXObj     =  5;
  XST_ByTSN      =  6;
  XST_ByMath     =  7;
  XST_ByMathType =  8;
  XST_BySort     =  9;
  XST_ByAcCut2   = 10;

  XCL_Object = 0;
  XCL_Cut1   = 1;
  XCL_Cut2   = 2;
  XCL_Tot1   = 3;
  XCL_Tot2   = 4;
  XCL_Srt1   = 5;
  XCL_Srt2   = 6;

 IMPORT Str, L_General, L_Acnt, L_XObj, L_Str, L_PRoll, L_Staff, L_DatTim, L_OwnData, L_AFM, L_MathR, Memo, L_Stock, P_Firm, L_APtm;

 PRIVATE CONST
  IdLength = 9;

 PRIVATE TYPE
  tId = STRING[IdLength];

 PRIVATE VAR
  XC001_From,
  XC001_UpTo,
  XC001_NxtM : DATE;

 PRIVATE PROCEDURE Create_XC001();
 BEGIN
  IF !DATABASE.Get().Tables("XC001") THEN
   CREATE_TABLE(XC001, "", "楢  ꥪ⮢ ", "");
 
   CREATE_FIELD(XC001, MyFirm,   P_Firm.tMyFirm,                     ,    , , " ࣠");
   CREATE_FIELD(XC001, Object,   tId,                                ,    , , "ꥪ");
   CREATE_FIELD(XC001, Cut1,     tId,                                ,    , , "१ 1");
   CREATE_FIELD(XC001, uav_aSum, L_Acnt.tUnfoldedAcntVector,         , "0", , " 㬬.    㬮砭");
   CREATE_FIELD(XC001, uav_aQnt, L_Acnt.tUnfoldedAcntQuantityVector, , "0", , " .    㬮砭");
   CREATE_FIELD(XC001, uav_bSum, L_Acnt.tUnfoldedAcntVector,         , "0", , " 㬬. ୠ⨢ ࠧ ");
   CREATE_FIELD(XC001, uav_bQnt, L_Acnt.tUnfoldedAcntQuantityVector, , "0", , " . ୠ⨢ ࠧ ");

   CREATE_INDEX(XC001, mfObject, UNIQUE, , , MyFirm, Object, Cut1);
   CREATE_INDEX(XC001, Object,   PLURAL, , , Object, Cut1);
   CREATE_INDEX(XC001, Cut1,     PLURAL, , , Cut1, Object);

   SET_VERSION_OF_TABLE(XC001, 0000);
  END;

  IF !DATABASE.Get().Tables("XA001") THEN
   CREATE_TABLE(XA001, , "  ꥪ⠬ ");
 
   CREATE_FIELD(XA001, MyFirm,  P_Firm.tMyFirm,         ,    , , " ࣠");
   CREATE_FIELD(XA001, Object,  tId,                    ,    , , "ꥪ");
   CREATE_FIELD(XA001, Cut1,    tId,                    ,    , , "१ 1");
   CREATE_FIELD(XA001, Cut2,    tId,                    ,    , , "१ 2");
   CREATE_FIELD(XA001, CirType, LIKE(Apport.CirType),   ,    , , " ", "0 - ।, 1 - ");
   CREATE_FIELD(XA001, Sum,     L_XObj.tSum,            , "0", , "稭 , 㬬");
   CREATE_FIELD(XA001, Qnt,     L_XObj.tQnt,            , "0", , "稭 , ⢮");
   CREATE_FIELD(XA001, WFDate,  DATE,                   , "0", , " ");
   CREATE_FIELD(XA001, AK,      L_Acnt.tAccountingKind, , "0", , " ", "0 -  ਮ, 1 -  ਮ, 2 - ");
 
   CREATE_INDEX(XA001, mfObject, UNIQUE, , , MyFirm, Object, Cut1, CirType, Cut2, WFDate, AK);
 
   SET_VERSION_OF_TABLE(XA001, 0000);
  END;
 END {Create_XC001};

 PRIVATE PROCEDURE Create_Cut();
 BEGIN
  IF !DATABASE.Get().Tables("Cut") THEN
   CREATE_TABLE(Cut, , "१");
   CREATE_FIELD(Cut, Cut,   tId,         , , , "१");
   CREATE_FIELD(Cut, Level, XCLevelType, , , , " ࠧ१");
   CREATE_FIELD(Cut, Name,  STRING[90],  , , , "");
 
   CREATE_INDEX(Cut, Cut, UNIQUE, , , Cut, Level);
 
   SET_VERSION_OF_TABLE(Cut, 0000);
  END;
  L_AFM.CreateTemp("Cut");
 END {Create_Cut};

 PRIVATE PROCEDURE GetCut(trgLevel   : XCLevelType;
                          trgSortType: XCSortType;
                          trgOrigin  : L_XObj.tOrigin): STRING[];
  VAR
   baseAcCut: LIKE(AcCut.AcCut);
   curCut   : tId;
   curName  : STRING[];
   curCAcnt : LIKE(CAcnt.CAcnt);
 BEGIN
  SAVE(AcCut);
  SETEMPTY(curName);
  IF    (trgLevel = XCL_Cut1) | (trgLevel = XCL_Object) THEN
   baseAcCut:=XCalc.AcCut;
  ELSIF trgLevel = XCL_Cut2 THEN
   baseAcCut:=XApport.AcCut2;
  END;
  IF    trgSortType = XST_ByXObj THEN
   curCut:=XObject.XObject;
  ELSIF trgSortType = XST_TheSingle THEN
   curCut :="1";
   curName:=" ";
  ELSIF trgSortType = XST_ByAcnt THEN
   L_Acnt.StandOnCAcnt(XC001_UpTo, baseAcCut);
   curCut :=Str.Slice(CAcnt.Sign, 0, 2);
   SAVE(CAcnt);
   curCAcnt:=CAcnt.CAcnt DIV 1000 * 1000;
   L_General.Assert(SEARCH(CAcnt, CAcnt, curCAcnt),
                    " ᠭ  " + curCut + "  ᨭ᪮  " + curCAcnt);
   curName:=CAcnt.Name;
   RESTORE(CAcnt);
  ELSIF (trgSortType = XST_ByAcCut) |
        (trgSortType = XST_ByAcCut2) THEN
   curCut :=baseAcCut;
  ELSIF trgSortType = XST_ByApport THEN
   SEARCH(AcCut, AcCut, , baseAcCut);
   L_Acnt.StandOnCAcnt(XC001_UpTo, baseAcCut);
   curCut :=FLDTOSTR(CAcnt.Sign, "", 5) + " " + baseAcCut; (* ???? *)
   IF (trgOrigin = L_XObj.o_Man) | (trgOrigin = L_XObj.o_Global) THEN
    curName:=AcCut.Name;
   ELSE
    curName:=CAcnt.Name;
   END;
  ELSIF trgSortType = XST_ByMan THEN
   L_XObj.AccessManByXObject(XCalc.XObject);
   curCut :=Str.Slice(Man.Man, Str.Length(Man.Man) - IdLength, IdLength);
   curName:=Man.Name;
  ELSE
   L_General.CallUs(0)
  END;
  IF ~SEARCH(Cut, Cut, curCut, trgLevel) THEN
   Cut.Cut  :=curCut;
   Cut.Level:=trgLevel;
   IF !curName THEN
    IF    (trgSortType = XST_ByAcCut) | (trgSortType = XST_ByAcCut2) THEN
     SEARCH(AcCut, AcCut, , baseAcCut);
     curName:="("+AcCut.Sign+") "+AcCut.Name;
    ELSIF trgSortType = XST_ByXObj THEN
     curName:=L_XObj.GetXObjectOriginName();
    ELSE
     L_General.CallUs(0);
    END;
   END;
   Cut.Name :=curName;
   INSERT(Cut);
  END;
  RESTORE(AcCut);
  RETURN curCut;
 END {GetCut};

 PUBLIC PROCEDURE GetCutName(curCut: tId; trgLevel: XCLevelType): STRING[];
 BEGIN
  SEARCH(Cut, Cut, , curCut, trgLevel);
  RETURN Cut.Name;
 END {GetCutName};

 PRIVATE PROCEDURE IsAcceptableXApport(XCC: XCContentType; AK: L_Acnt.tAccountingKind): SCAL[2];
  VAR
   P: DATE;
 BEGIN
  IF (XApport.Sum#0) | (XApport.Qnt#0) THEN
   IF ((XCC # XCC_FP_Math) & (XCC # XCC_FP_KA) | (XApport.XDat # XApport.WFDate)) THEN
    IF    AK = L_Acnt.ak_Acn THEN
     P:=XApport.XDat;
    ELSIF AK = L_Acnt.ak_Tax THEN
     P:=XApport.WFDate;
    ELSIF AK = L_Acnt.ak_Bth THEN
     RETURN 1;
    ELSE
     L_General.CallUs(0);
    END;
    RETURN L_DatTim.IsActive_Inc(P, XC001_From, XC001_UpTo);
   ELSE
    RETURN 0;
   END;
  ELSE
   RETURN 0;
  END;
 END {IsAcceptableXApport};

 PRIVATE PROCEDURE gXA001_AddXApportCir(VAR DbtSum: L_XObj.tSum;
                                        VAR DbtQnt: L_XObj.tQnt;
                                        VAR CrdSum: L_XObj.tSum;
                                        VAR CrdQnt: L_XObj.tQnt);
 BEGIN
  IF Apport.CirType = L_Acnt.ct_Debit THEN
   INC(DbtSum, XApport.Sum);
   INC(DbtQnt, XApport.Qnt);
  ELSE
   INC(CrdSum, XApport.Sum);
   INC(CrdQnt, XApport.Qnt);
  END;
 END {gXA001_AddXApportCir};

 PRIVATE PROCEDURE gXA001_PutXApportCir(xapAK   : L_Acnt.tAccountingKind;
                                        _Object,
                                        _Cut1   : tId;
                                        XST_Cut2: XCSortType);
 BEGIN
  IF XST_Cut2 # XST_TheSingle THEN
   ADD(XA001, mfObject, , XObject.MyFirm, _Object, _Cut1, Apport.CirType,
                        GetCut(XCL_Cut2, XST_Cut2, XObject.Origin), XApport.WFDate, xapAK,
           XA001.Sum, XApport.Sum,
           XA001.Qnt, XApport.Qnt);
  END;
 END {gXA001_PutXApportCir};

 PRIVATE PROCEDURE gXC001_DefineCuts(XST_Object,
                                     XST_Cut1   : XCSortType;
                                     ConciseXOId: tId;
                                     VAR
                                      _Object,
                                      _Cut1     : tId);
 BEGIN
  IF !_Cut1 THEN
   IF ~!ConciseXOId THEN
    IF XST_Object = XST_ByXObj THEN
     _Object:=ConciseXOId;
     _Cut1:=GetCut(XCL_Cut1, XST_Cut1, XObject.Origin);
    ELSE
     _Object:=GetCut(XCL_Object, XST_Object, XObject.Origin);
     _Cut1  :=ConciseXOId;
    END;
   ELSE
    _Object:=GetCut(XCL_Object, XST_Object, XObject.Origin);
    _Cut1:=GetCut(XCL_Cut1, XST_Cut1, XObject.Origin);
   END;
  END;
 END {gXC001_DefineCuts};

 PRIVATE PROCEDURE gXC001_SingleXOAC(XCC        : XCContentType;
                                     Section    : L_XObj.tSection;
                                     AK         : L_Acnt.tAccountingKind;
                                     XST_Object,
                                     XST_Cut1,
                                     XST_Cut2   : XCSortType);
  VAR
   _Object,
   _Cut1      : tId;
   uavp       : L_Acnt.tUnfoldedAcntVectorPart;
   aSldSum,
   bSldSum,
   aDbtSum,
   aCrdSum,
   bDbtSum,
   bCrdSum    : L_XObj.tSum;
   aSldQnt,
   bSldQnt,
   aDbtQnt,
   aCrdQnt,
   bDbtQnt,
   bCrdQnt    : L_XObj.tQnt;
   xapAK      : L_Acnt.tAccountingKind;
   _s         : NUMERIC[0];
   ConciseXOId: tId;
 BEGIN
  PROMPT(" "+XObject.XObject);
  IF L_XObj.IsAppropriateSection(XCalc.AcCut, Section) THEN
   SETEMPTY(ConciseXOId);
   IF !Section & (XCC = XCC_FullWealth) & (L_XObj.SectionOfXObjectAcCut(XCalc.AcCut) = L_XObj.s_Salary) THEN
    ConciseXOId:=L_XObj.DefineConciseXOId(L_XObj.s_Salary);
   END;
   SETEMPTY(_Cut1);
   IF SRCINSEL(XCalc, LE, XC001_From) THEN
    IF XCalc.XDat = XC001_From THEN
     IF    AK = L_Acnt.ak_Acn THEN
      aSldSum:=XCalc.SldSum;
      aSldQnt:=XCalc.SldQnt;
      bSldSum:=aSldSum;
      bSldQnt:=aSldQnt;
     ELSIF AK = L_Acnt.ak_Tax THEN
      aSldSum:=XCalc.RSlSum;
      aSldQnt:=XCalc.RSlQnt;
      bSldSum:=aSldSum;
      bSldQnt:=aSldQnt;
     ELSE
      aSldSum:=XCalc.SldSum;
      aSldQnt:=XCalc.SldQnt;
      bSldSum:=XCalc.RSlSum;
      bSldQnt:=XCalc.RSlQnt;
     END;
    ELSE
     IF    AK = L_Acnt.ak_Acn THEN
      L_XObj.OutSaldo(aSldSum, aSldQnt);
      bSldSum:=aSldSum;
      bSldQnt:=aSldQnt;
     ELSIF AK = L_Acnt.ak_Tax THEN
      L_XObj.OutRSaldo(aSldSum, aSldQnt);
      bSldSum:=aSldSum;
      bSldQnt:=aSldQnt;
     ELSE
      L_XObj.OutSaldo(aSldSum, aSldQnt);
      L_XObj.OutRSaldo(bSldSum, bSldQnt);
     END;
    END;
    IF aSldSum | aSldQnt | bSldSum | bSldQnt THEN
     gXC001_DefineCuts(XST_Object, XST_Cut1, ConciseXOId, _Object, _Cut1);
     IF aSldSum >= 0 THEN uavp:=L_Acnt.uavp_ISlDbt; _s:=+1;
     ELSE                 uavp:=L_Acnt.uavp_ISlCrd; _s:=-1;
     END;
     ADD(XC001, mfObject, , XObject.MyFirm, _Object, _Cut1, XC001.uav_aSum[uavp], _s*aSldSum,
                                                            XC001.uav_aQnt[uavp], _s*aSldQnt);
     IF bSldSum >= 0 THEN uavp:=L_Acnt.uavp_ISlDbt; _s:=+1;
     ELSE                 uavp:=L_Acnt.uavp_ISlCrd; _s:=-1;
     END;
     ADD(XC001, mfObject, , XObject.MyFirm, _Object, _Cut1, XC001.uav_bSum[uavp], _s*bSldSum,
                                                            XC001.uav_bQnt[uavp], _s*bSldQnt);
    END;
    IF XCalc.XDat < XC001_From THEN
     NEXT(XCalc);
    END;
   ELSE
    SETZERO(aSldSum, aSldQnt, bSldSum, bSldQnt);
    FIRST(XCalc);
   END; (* IF SRCINSEL(XCalc, LE, XC001_From) *)
   SETZERO(aDbtSum, aDbtQnt, aCrdSum, aCrdQnt,
           bDbtSum, bDbtQnt, bCrdSum, bCrdQnt);
   IF (AK = L_Acnt.ak_Acn) & (XST_Cut2 = XST_TheSingle) THEN
    WHILE OCCURE(XCalc) & (XCalc.XDat <= XC001_UpTo) DO
     gXC001_DefineCuts(XST_Object, XST_Cut1, ConciseXOId, _Object, _Cut1);
     INC(aDbtSum, XCalc.DbtSum);
     INC(aDbtQnt, XCalc.DbtQnt);
     INC(aCrdSum, XCalc.CrdSum);
     INC(aCrdQnt, XCalc.CrdQnt);
     NEXT(XCalc);
    END; (* WHILE OCCURE(XCalc) *)
   ELSE
    IF AK # L_Acnt.ak_Tax THEN
     WHILE OCCURE(XCalc) & (XCalc.XDat <= XC001_UpTo) DO
      SETEMPTY(_Object, _Cut1);
      SETSEL(XApport, XObject, XCalc.XObject, XCalc.AcCut, XCalc.XDat);
      FOR_EACH XApport DO
       IF IsAcceptableXApport(XCC, AK) THEN
        IF !_Object & !_Cut1 THEN
         gXC001_DefineCuts(XST_Object, XST_Cut1, ConciseXOId, _Object, _Cut1);
        END;
        SEARCH(Apport, Apport, , XApport.Apport);
        gXA001_AddXApportCir(aDbtSum, aDbtQnt, aCrdSum, aCrdQnt);
        IF XApport.WFDate >= XC001_From THEN
         gXA001_AddXApportCir(bDbtSum, bDbtQnt, bCrdSum, bCrdQnt);
         xapAK:=L_Acnt.ak_Bth;
        ELSE
         xapAK:=L_Acnt.ak_Acn;
        END;
        gXA001_PutXApportCir(xapAK, _Object, _Cut1, XST_Cut2);
       END;
      END; (* FOR_EACH XApport *)
      NEXT(XCalc);
     END; (* WHILE OCCURE(XCalc) *)
    END;
    IF AK # L_Acnt.ak_Acn THEN
     FIRST(XCalc);
     SETSEL(XApport, WFD, XCalc.XObject, XCalc.AcCut);
     SRCINSEL(XApport, GE, , XC001_From);
     WHILE OCCURE(XApport) & (XApport.WFDate <= XC001_UpTo) DO
      gXC001_DefineCuts(XST_Object, XST_Cut1, ConciseXOId, _Object, _Cut1);
      NARROWSEL(XApport, WFDate);
      IF AK = L_Acnt.ak_Bth THEN
       SRCINSEL(XApport, GE, , XC001_NxtM);
      END;
      WHILE OCCURE(XApport) DO
       IF IsAcceptableXApport(XCC, AK) THEN
        SEARCH(Apport, Apport, , XApport.Apport);
        IF AK = L_Acnt.ak_Bth THEN
         gXA001_AddXApportCir(bDbtSum, bDbtQnt, bCrdSum, bCrdQnt);
        ELSE
         gXA001_AddXApportCir(aDbtSum, aDbtQnt, aCrdSum, aCrdQnt);
        END;
        gXA001_PutXApportCir(L_Acnt.ak_Tax, _Object, _Cut1, XST_Cut2);
       END;
       NEXT(XApport);
      END; (* WHILE OCCURE(XApport) *)
      NEXTINEXTENDEDSEL(XApport, WFDate);
     END; (* WHILE OCCURE(XApport) ... *)
    END;
   END; (* IF AK ... *)
   IF AK # L_Acnt.ak_Bth THEN
    bDbtSum:=aDbtSum;
    bDbtQnt:=aDbtQnt;
    bCrdSum:=aCrdSum;
    bCrdQnt:=aCrdQnt;
   END;
   IF ~!_Cut1 THEN
    ADD(XC001, mfObject, , XObject.MyFirm, _Object, _Cut1,
         XC001.uav_aSum[L_Acnt.uavp_CirDbt], aDbtSum,
         XC001.uav_aQnt[L_Acnt.uavp_CirDbt], aDbtQnt,
         XC001.uav_aSum[L_Acnt.uavp_CirCrd], aCrdSum,
         XC001.uav_aQnt[L_Acnt.uavp_CirCrd], aCrdQnt,
         XC001.uav_bSum[L_Acnt.uavp_CirDbt], bDbtSum,
         XC001.uav_bQnt[L_Acnt.uavp_CirDbt], bDbtQnt,
         XC001.uav_bSum[L_Acnt.uavp_CirCrd], bCrdSum,
         XC001.uav_bQnt[L_Acnt.uavp_CirCrd], bCrdQnt);
    INC(aSldSum, aDbtSum); INC(aSldQnt, aDbtQnt);
    DEC(aSldSum, aCrdSum); DEC(aSldQnt, aCrdQnt);
    INC(bSldSum, bDbtSum); INC(bSldQnt, bDbtQnt);
    DEC(bSldSum, bCrdSum); DEC(bSldQnt, bCrdQnt);
   END;
   IF ~!_Cut1 THEN
    IF aSldSum >= 0 THEN uavp:=L_Acnt.uavp_OSlDbt; _s:=+1;
    ELSE                 uavp:=L_Acnt.uavp_OSlCrd; _s:=-1;
    END;
    ADD(XC001, mfObject, , XObject.MyFirm, _Object, _Cut1,  XC001.uav_aSum[uavp], _s*aSldSum,
                                                            XC001.uav_aQnt[uavp], _s*aSldQnt);
    IF bSldSum >= 0 THEN uavp:=L_Acnt.uavp_OSlDbt; _s:=+1;
    ELSE                 uavp:=L_Acnt.uavp_OSlCrd; _s:=-1;
    END;
    ADD(XC001, mfObject, , XObject.MyFirm, _Object, _Cut1,  XC001.uav_bSum[uavp], _s*bSldSum,
                                                            XC001.uav_bQnt[uavp], _s*bSldQnt);
   END;
  END; (* IF XCC ... *)
 END {gXC001_SingleXOAC};

 PRIVATE PROCEDURE GatherXC001_SingleXObject(XCC        : XCContentType;
                                             Section    : L_XObj.tSection;
                                             AK         : L_Acnt.tAccountingKind;
                                             XST_Object,
                                             XST_Cut1,
                                             XST_Cut2   : XCSortType);
 BEGIN
  SELECT(XCalc, XObject, , XObject.XObject);
  WHILE OCCURE(XCalc) DO
   NARROWSEL(XCalc, AcCut);
   gXC001_SingleXOAC(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
   NEXTINEXTENDEDSEL(XCalc, AcCut);
  END; (* WHILE OCCURE(XCalc) ... *)
 END {GatherXC001_SingleXObject};

 PRIVATE PROCEDURE GatherXC001_SingleMath(XCC        : XCContentType;
                                          Section    : L_XObj.tSection;
                                          AK         : L_Acnt.tAccountingKind;
                                          XST_Object,
                                          XST_Cut1,
                                          XST_Cut2   : XCSortType);
 BEGIN
  SETSEL(mItem, Math, Math.Math);
  FOR_EACH mItem DO
   IF L_XObj.SrcXObject(mItem.XObject) THEN
    GatherXC001_SingleXObject(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
   END;
  END; (* FOR_EACH mItem *)
 END {GatherXC001_SingleMath};

 PRIVATE PROCEDURE GatherXC001_SelectedMath(XCC        : XCContentType;
                                            Section    : L_XObj.tSection;
                                            AK         : L_Acnt.tAccountingKind;
                                            XST_Object,
                                            XST_Cut1,
                                            XST_Cut2   : XCSortType);
 BEGIN
  FOR_EACH Math DO
   IF Math.Leaf THEN
    GatherXC001_SingleMath(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
   END;
  END; (* FOR_EACH Math *)
 END {GatherXC001_SelectedMath};

 PRIVATE PROCEDURE GatherXC001_SingleAcCut(XCC        : XCContentType;
                                           Section    : L_XObj.tSection;
                                           AK         : L_Acnt.tAccountingKind;
                                           trgOM      : L_XObj.tOriginsMap;
                                           trgMyFirm  : P_Firm.tMyFirm;
                                           XST_Object,
                                           XST_Cut1,
                                           XST_Cut2   : XCSortType);
 BEGIN
  L_General.Assert(ACCESS(AcCut), " ⠭ ⥪騩 ࠧ१");
  SELECT(XCalc, AcCut, , AcCut.AcCut);
  WHILE OCCURE(XCalc) DO
   NARROWSEL(XCalc, XObject);
   IF L_XObj.SrcXObject(XCalc.XObject) THEN
    PROMPT(" "+XObject.XObject);
    IF trgOM[XObject.Origin] & (!trgMyFirm | (XObject.MyFirm = trgMyFirm)) THEN
     gXC001_SingleXOAC(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
    END;
   END;
   NEXTINEXTENDEDSEL(XCalc, XObject);
  END; (* WHILE OCCURE(XCalc) *)
 END {GatherXC001_SingleAcCut};

 PRIVATE PROCEDURE GatherXC001_SingleAcCut2(XCC        : XCContentType;
                                            Section    : L_XObj.tSection;
                                            AK         : L_Acnt.tAccountingKind;
                                            trgOM      : L_XObj.tOriginsMap;
                                            trgMyFirm  : P_Firm.tMyFirm;
                                            forWhole   : SCAL[2]);
  VAR
   curObject,
   curCut1   : tId;
 BEGIN
  L_General.Assert(ACCESS(AcCut), " ⠭ ⥪騩 ࠧ१");
  SETSEL(XApport, AcCut2, AcCut.AcCut);
  SRCINSEL(XApport, LE, , XC001_UpTo);
  WHILE OCCURE(XApport) & ((AK = L_Acnt.ak_Acn) | (XApport.WFDate >= XC001_From)) DO
   CHANGESEL(XApport, AcCut2, , XApport.AcCut2, XApport.WFDate);
   IF AK = L_Acnt.ak_Acn THEN
    SRCINSEL(XApport, LE, , XC001_UpTo);
   ELSE
    LAST(XApport);
   END;
   WHILE OCCURE(XApport) & (XApport.XDat >= XC001_From) DO
    IF IsAcceptableXApport(XCC, AK) THEN
     IF L_XObj.SrcXObject(XApport.XObject) THEN
      PROMPT(" "+XObject.XObject);
      IF trgOM[XObject.Origin] & (!trgMyFirm | (XObject.MyFirm = trgMyFirm)) THEN
       SEARCH(Apport, Apport, , XApport.Apport);
       IF forWhole THEN
        curObject :=XApport.AcCut;
        curCut1   :=XApport.XObject;
       ELSE
        curObject :=XApport.XObject;
        curCut1   :=XApport.AcCut;
       END;
       IF (~forWhole | ~SELECT(XC001, mfObject, XObject.MyFirm, curObject, curCut1)) THEN
        ADD(XA001, mfObject, , XObject.MyFirm, curObject, curCut1, Apport.CirType,
                               XApport.AcCut2, XApport.WFDate, AK,
                XA001.Sum, XApport.Sum,
                XA001.Qnt, XApport.Qnt);
       END;
      END;
     END;
    END;
    PREV(XApport);
   END;
   FIRST(XApport);
   CHANGESEL(XApport, AcCut2, , XApport.AcCut2);
   PREV(XApport);
  END; (* WHILE OCCURE(XApport) ... *)
 END {GatherXC001_SingleAcCut2};

 PRIVATE PROCEDURE GatherXC001_WholeCAcnt(XCC        : XCContentType;
                                          Section    : L_XObj.tSection;
                                          AK         : L_Acnt.tAccountingKind;
                                          trgOM      : L_XObj.tOriginsMap;
                                          trgMyFirm  : P_Firm.tMyFirm;
                                          XST_Object,
                                          XST_Cut1,
                                          XST_Cut2   : XCSortType);
  VAR
   curSign: LIKE(CAcnt.Sign);
 BEGIN
  L_General.Assert(ACCESS(CAcnt), " ⠭ ⥪騩 ");
  curSign:=CAcnt.Sign;
  CHANGESEL(CAcnt, Sign);
  WHILE OCCURE(CAcnt) & (Str.Pos(CAcnt.Sign, curSign) = 0) DO
   IF L_DatTim.IsActiveInIntvl(CAcnt.Begin, CAcnt.Till, XC001_From, XC001_UpTo+1) THEN
    SETSEL(ACLog, CAcnt, CAcnt.CAcnt);
    FOR_EACH ACLog DO
     IF L_DatTim.IsActiveInIntvl(ACLog.Date, ACLog.Till, XC001_From, XC001_UpTo+1) THEN
      CONFORM(ACLog, AcCut);
      GatherXC001_SingleAcCut (XCC, Section, AK, trgOM, trgMyFirm, XST_Object, XST_Cut1, XST_Cut2);
     END;
    END; (* FOR_EACH ACLog *)
    FOR_EACH ACLog DO
     IF L_DatTim.IsActiveInIntvl(ACLog.Date, ACLog.Till, XC001_From, XC001_UpTo+1) THEN
      CONFORM(ACLog, AcCut);
      GatherXC001_SingleAcCut2(XCC, Section, AK, trgOM, trgMyFirm, 1);
     END;
    END; (* FOR_EACH ACLog *)
   END;
   NEXT(CAcnt);
  END; (* WHILE OCCURE(CAcnt) ... *)
 END {GatherXC001_WholeCAcnt};

 PRIVATE PROCEDURE GatherXC001_SingleCostItem(XCC        : XCContentType;
                                              Section    : L_XObj.tSection;
                                              AK         : L_Acnt.tAccountingKind;
                                              trgOM      : L_XObj.tOriginsMap;
                                              trgMyFirm  : P_Firm.tMyFirm;
                                              XST_Object,
                                              XST_Cut1,
                                              XST_Cut2   : XCSortType);
 BEGIN
  IF ~!CostItem.XObject THEN
   CONFORM(CostItem, XObject);
   IF !trgMyFirm | (CostItem.MyFirm = trgMyFirm) THEN
    GatherXC001_SingleXObject(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
   END;
  END;
  IF ~CostItem.Leaf THEN
   SETSEL(CostItem, Parent, CostItem.CostItem);
   FOR_EACH CostItem DO
    GatherXC001_SingleCostItem(XCC, Section, AK, trgOM, trgMyFirm, XST_Object, XST_Cut1, XST_Cut2);
   END;
  END;
 END {GatherXC001_SingleCostItem};

 PRIVATE PROCEDURE IsCurrentDeprecT(_Math: LIKE(Math.Math)): SCAL[2];
 BEGIN
  SETSEL(MathKAGL, Math, _Math);
  IF SRCINSEL(MathKAGL, LE, Memo.ud_ut()) THEN
   CONFORM(MathKAGL, KAGroup);
   HISTCONF(Memo.ud_ut(), KAGroup, KAGLog);
   L_General.Assert(OCCURE(KAGLog), " ਨ  㯯  " +
                    KAGroup.KAGroup + "  " + L_DatTim.DateStr(Memo.ud_ut()));
   RETURN KAGLog.DeprecT = DeprecT.DeprecT;
  ELSE
   RETURN 0;
  END; (* IF OCCURE(MathKAGL) ... *)
 END {IsCurrentDeprecT};

 PRIVATE PROCEDURE IsReattachXC001(XCC       : XCContentType;
                                   Section   : L_XObj.tSection;
                                   AK        : L_Acnt.tAccountingKind;
                                   trgOM     : L_XObj.tOriginsMap;
                                   trgMyFirm : P_Firm.tMyFirm;
                                   XST_Object,
                                   XST_Cut1,
                                   XST_Cut2  : XCSortType): SCAL[2];
  VAR
   curOrigin: L_XObj.tOrigin;
 BEGIN
  IF (XCC = XCC_FullWealth) &
     !Section &
     (AK = L_Acnt.ak_Bth) &
     !trgMyFirm &
     (XST_Object = XST_ByXObj) &
     (XST_Cut1 = XST_ByAcCut) &
     (XST_Cut2 = XST_ByAcCut2) &
     (Memo.ud_fr() = L_DatTim.MonthBeg(Memo.ud_ut())) THEN
   FOR_EACH curOrigin DO
    IF ~trgOM[curOrigin] THEN
     RETURN 0;
    END;
   END;
   RETURN 1;
  END;
  RETURN 0;
 END {IsReattachXC001};

 PUBLIC PROCEDURE extPointwiseBuildXC001(XCC       : XCContentType;
                                         Section   : L_XObj.tSection;
                                         AK        : L_Acnt.tAccountingKind;
                                         trgOM     : L_XObj.tOriginsMap;
                                         trgMyFirm : P_Firm.tMyFirm;
                                         XST_Object,
                                         XST_Cut1,
                                         XST_Cut2  : XCSortType;
                                         Rebuild   : SCAL[2]);
  VAR
   curOrigin : L_XObj.tOrigin;
   IsReattach,
   NeedMake  : SCAL[2];
   clsDTS    : TIMESTAMP;
 BEGIN
  L_General.CallUs((AK # L_Acnt.ak_Bth) | (XCC = XCC_FullWealth));
  XC001_From:=Memo.ud_fr();
  XC001_UpTo:=Memo.ud_ut();
  XC001_NxtM:=L_DatTim.NextPer(XC001_UpTo);
  L_DatTim.CheckWMIntvl(XC001_From, XC001_UpTo);
  Create_XC001();
  Create_Cut();

  IsReattach:=IsReattachXC001(XCC, Section, AK, trgOM, trgMyFirm, XST_Object, XST_Cut1, XST_Cut2);

  IF IsReattach THEN
   L_AFM.Init();
   L_AFM.msrf_Register("XC001", "XC001", L_General.tc_inMonth, Memo.ud_fr(), Memo.ud_ut());
   L_AFM.msrf_Register("XA001", "XA001", L_General.tc_inMonth, Memo.ud_fr(), Memo.ud_ut());

   L_APtm.MonthAccess(Memo.ud_fr());
   IF !Month.NoTouchD[L_APtm.system_Payments] THEN
    clsDTS:=MAXOF(TIMESTAMP);
   ELSE
    clsDTS:=PackTIMESTAMP(Month.NoTouchD[L_APtm.system_Payments], Month.NoTouchT[L_APtm.system_Payments]);
   END;

   IF Rebuild |
      ~L_AFM.ext_msrf_Reuse("XC001", 1, clsDTS) |
      ~L_AFM.ext_msrf_Reuse("XA001", 1, clsDTS) THEN
    L_AFM.msrf_Create("XC001");
    L_AFM.msrf_Create("XA001");
    NeedMake:=1;
   ELSE
    NeedMake:=0;
   END;
  ELSE
   L_AFM.CreateTemp("XC001");
   L_AFM.CreateTemp("XA001");
   NeedMake:=1;
  END;

  IF NeedMake THEN
   APP.Get().NewPrompt(TABLE.Get("XC001").Description);
   IF    XCC = XCC_SingleAcCut THEN
    GatherXC001_SingleAcCut(XCC, Section, AK, trgOM, trgMyFirm, XST_Object, XST_Cut1, XST_Cut2);
   ELSIF XCC = XCC_WholeAcCut THEN
    GatherXC001_SingleAcCut (XCC, Section, AK, trgOM, trgMyFirm, XST_Object, XST_Cut1, XST_Cut2);
    GatherXC001_SingleAcCut2(XCC, Section, AK, trgOM, trgMyFirm, 1);
   ELSIF XCC = XCC_WholeAcnt THEN
    GatherXC001_WholeCAcnt(XCC, Section, AK, trgOM, trgMyFirm, XST_Object, XST_Cut1, XST_Cut2);
   ELSIF XCC = XCC_SingleAcCut2 THEN
    GatherXC001_SingleAcCut2(XCC, Section, AK, trgOM, trgMyFirm, 0);
   ELSIF XCC = XCC_SingleMath THEN
    L_General.CallUs(ACCESS(Math));
    GatherXC001_SingleMath(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
   ELSIF XCC = XCC_SingleMathType THEN
    L_General.CallUs(ACCESS(MathType));
    SELECT(Math, MathType, , MathType.MathType);
    GatherXC001_SelectedMath(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
   ELSIF (XCC = XCC_FullMath) | (XCC = XCC_FP_Math) THEN
    SELECT(Math, LeafMK, , 1, L_MathR.mathk_Math);
    GatherXC001_SelectedMath(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
   ELSIF (XCC = XCC_FullKA) | (XCC = XCC_FP_KA) THEN
    SELECT(Math, LeafMK, , 1, L_MathR.mathk_KeyAs);
    GatherXC001_SelectedMath(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
   ELSIF XCC = XCC_SingleDeprecT THEN
    L_General.Assert(ACCESS(DeprecT), " ⠭ ⥪騩  ");
    SETSEL(Math, LeafMK, 1, L_MathR.mathk_KeyAs);
    FOR_EACH Math DO
     IF IsCurrentDeprecT(Math.Math) THEN
      GatherXC001_SingleMath(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
     END;
    END; (* FOR_EACH Math *)
   ELSIF XCC = XCC_SingleStorage THEN
    L_General.CallUs(ACCESS(Storage));
    SETSEL(mItem, Storage, Storage.Storage);
    FOR_EACH mItem DO
     IF L_XObj.SrcXObject(mItem.XObject) THEN
      GatherXC001_SingleXObject(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
     END;
    END; (* FOR_EACH mItem *)
   ELSE
    FOR_EACH curOrigin DO
     IF trgOM[curOrigin] THEN
      IF    XCC = XCC_SingleXObject THEN
       L_General.Assert(ACCESS(XObject), " ⠭ ⥪騩 ");
       GatherXC001_SingleXObject(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
       EXIT; (* !!!! *)
      ELSIF XCC = XCC_SingleFirm THEN
       L_General.CallUs(ACCESS(Firm));
       SETSEL(Contract, Firm, Firm.Firm, 1);
       FOR_EACH Contract DO
        IF L_XObj.SrcXObject(Contract.XObject) THEN
         GatherXC001_SingleXObject(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
        END;
       END; (* FOR_EACH Contract *)
       EXIT; (* !!!! *)
      ELSIF XCC = XCC_SingleMan THEN
       L_General.CallUs(ACCESS(Man));
       IF ~!trgMyFirm THEN
        SETSEL(mfMan, Man, Man.Man, trgMyFirm);
       ELSE
        SETSEL(mfMan, Man, Man.Man);
       END;
       FOR_EACH mfMan DO
        SEARCH(XObject, XObject, , mfMan.XObject);
        GatherXC001_SingleXObject(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
       END; (* FOR_EACH mfMan *)
       EXIT; (* !!!! *)
      ELSIF XCC = XCC_SingleCostItem THEN
       L_General.CallUs(ACCESS(CostItem));
       GatherXC001_SingleCostItem(XCC, Section, AK, trgOM, trgMyFirm, XST_Object, XST_Cut1, XST_Cut2);
       EXIT; (* !!!! *)
      ELSE
       L_General.CallUs(XCC = XCC_FullWealth);
       IF ~!trgMyFirm THEN
        SETSEL(XObject, MyFirm, trgMyFirm, curOrigin);
       ELSE
        SETSEL(XObject, Origin, curOrigin);
       END;
       FOR_EACH XObject DO
        GatherXC001_SingleXObject(XCC, Section, AK, XST_Object, XST_Cut1, XST_Cut2);
       END; (* FOR_EACH XObject *)
      END;
     END; (* IF trgOM[curOrigin] *)
    END; (* FOR_EACH curOrigin *)
   END;

   IF IsReattach THEN
    L_AFM.msrf_Store("XC001");
    L_AFM.msrf_Store("XA001");
   END;
  END; (* IF NeedMake ... *)
 END {extPointwiseBuildXC001};

 PUBLIC PROCEDURE PointwiseBuildXC001(XCC        : XCContentType;
                                      Section    : L_XObj.tSection;
                                      AK         : L_Acnt.tAccountingKind;
                                      trgOM      : L_XObj.tOriginsMap;
                                      trgMyFirm  : P_Firm.tMyFirm;
                                      XST_Object,
                                      XST_Cut1,
                                      XST_Cut2   : XCSortType);
 BEGIN
  extPointwiseBuildXC001(XCC, Section, AK, trgOM, trgMyFirm, XST_Object, XST_Cut1, XST_Cut2, 1);
 END {extPointwiseBuildXC001};

 PUBLIC PROCEDURE PurgeXC001();
 BEGIN
  L_AFM.AF_PurgeTemp("XC001");
  L_AFM.AF_PurgeTemp("XA001");
  L_AFM.AF_PurgeTemp("Cut");
 END {PurgeXC001};

 PRIVATE PROCEDURE Create_SMC01();
 BEGIN
  IF !DATABASE.Get().Tables("SMC01") THEN
   CREATE_TABLE(SMC01, , " 楢  ꥪ⮢ ");
 
   CREATE_FIELD(SMC01, TSN,    LIKE(Staff.TSN),   ,    , , " ");
   CREATE_FIELD(SMC01, Math,   LIKE(Math.Math),   ,    , , "ꥪ /");
   CREATE_FIELD(SMC01, AcCut,  LIKE(AcCut.AcCut), ,    , , " ࠧ१");
   CREATE_FIELD(SMC01, SldSum, L_XObj.tSum,       , "0", , "줮, 㬬");
   CREATE_FIELD(SMC01, SldQnt, L_XObj.tQnt,       , "0", , "줮, ⢮");
   CREATE_FIELD(SMC01, DbtSum, L_XObj.tSum,       , "0", , "⮢ , 㬬");
   CREATE_FIELD(SMC01, DbtQnt, L_XObj.tQnt,       , "0", , "⮢ , ⢮");
   CREATE_FIELD(SMC01, CrdSum, L_XObj.tSum,       , "0", , "।⮢ , 㬬");
   CREATE_FIELD(SMC01, CrdQnt, L_XObj.tQnt,       , "0", , "।⮢ , ⢮");
 
   CREATE_INDEX_AND_LINK(SMC01, TSN,   UNIQUE, Staff, TSN,   USER, , , TSN, Math, AcCut);
   CREATE_INDEX_AND_LINK(SMC01, Math,  PLURAL, Math,  Math,  USER, , , Math);
   CREATE_INDEX_AND_LINK(SMC01, AcCut, PLURAL, AcCut, AcCut, USER, , , AcCut);
 
   SET_VERSION_OF_TABLE(SMC01, 0000);
  END;
  L_AFM.CreateTemp("SMC01");
 END {Create_SMC01};

 PRIVATE PROCEDURE Create_SMC02();
 BEGIN
  IF !DATABASE.Get().Tables("SMC02") THEN
   CREATE_TABLE(SMC02, , " 楢   ਮ");
 
   CREATE_FIELD(SMC02, Cut1,   tId,         ,    , , "1 ⮣ ஢");
   CREATE_FIELD(SMC02, Cut2,   tId,         ,    , , "2 ⮣ ஢");
   CREATE_FIELD(SMC02, Cut3,   tId,         ,    , , "1 ஢ ஢");
   CREATE_FIELD(SMC02, Cut4,   tId,         ,    , , "2 ஢ ஢");
   CREATE_FIELD(SMC02, SldSum, L_XObj.tSum, , "0", , "줮, 㬬");
   CREATE_FIELD(SMC02, SldQnt, L_XObj.tQnt, , "0", , "줮, ⢮");
   CREATE_FIELD(SMC02, DbtSum, L_XObj.tSum, , "0", , "⮢ , 㬬");
   CREATE_FIELD(SMC02, DbtQnt, L_XObj.tQnt, , "0", , "⮢ , ⢮");
   CREATE_FIELD(SMC02, CrdSum, L_XObj.tSum, , "0", , "।⮢ , 㬬");
   CREATE_FIELD(SMC02, CrdQnt, L_XObj.tQnt, , "0", , "।⮢ , ⢮");
 
   CREATE_INDEX(SMC02, Cut1, UNIQUE, , , Cut1, Cut2, Cut3, Cut4);
 
   SET_VERSION_OF_TABLE(SMC02, 0001);
  END;
  L_AFM.CreateTemp("SMC02");
 END {Create_SMC02};

 PRIVATE PROCEDURE MakeSMC_SingleXObject(_XObject: LIKE(XObject.XObject); OnDay: SCAL[2]);
  VAR
   sldSum: L_XObj.tSum;
   sldQnt: L_XObj.tQnt;
   _From,
   _UpTo : DATE;
 BEGIN
  IF L_XObj.SrcXObject(_XObject) THEN
   IF OnDay THEN
    L_General.SetIntvlByMonth(_From, _UpTo);
   ELSE
    L_General.SetIntvlByIntvl(_From, _UpTo);
   END;
   L_DatTim.CheckWMIntvl(_From, _UpTo);
   SELECT(XCalc, XObject, , _XObject);
 (*
   L_MathR.CheckMathDone(_UpTo);
 *)
   WHILE OCCURE(XCalc) DO
    NARROWSEL(XCalc, AcCut);
    PROMPT("⭨ " + Staff.TSN + ",  " + Math.Math);
    IF SRCINSEL(XCalc, LT, _From) THEN
     L_XObj.OutSaldo(sldSum, sldQnt);
     IF sldSum | sldQnt THEN
      ADD(SMC01, TSN, , Staff.TSN, Math.Math, XCalc.AcCut,
             SMC01.SldSum, sldSum,
             SMC01.SldQnt, sldQnt);
     END;
     NEXT(XCalc);
    ELSE
     SRCINSEL(XCalc, GE, , _From);
    END;
    WHILE OCCURE(XCalc) & (XCalc.XDat <= _UpTo) DO
     ADD(SMC01, TSN, , Staff.TSN, Math.Math, XCalc.AcCut,
             SMC01.DbtSum, XCalc.DbtSum,
             SMC01.DbtQnt, XCalc.DbtQnt,
             SMC01.CrdSum, XCalc.CrdSum,
             SMC01.CrdQnt, XCalc.CrdQnt);
     NEXT(XCalc);
    END;
    NEXTINEXTENDEDSEL(XCalc, AcCut);
   END; (* WHILE OCCURE(XCalc) ... *)
   LAST(XCalc);
  END;
 END {MakeSMC_SingleXObject};

 PRIVATE PROCEDURE MakeSMC_SingleTSN(OnDay: SCAL[2]);
 BEGIN
  IF ~!Staff.Storage THEN
   SELECT(mItem, Storage, , Staff.Storage);
   WHILE OCCURE(mItem) DO
    CONFORM(mItem, Math);
    MakeSMC_SingleXObject(mItem.XObject, OnDay);
    NEXT(mItem);
   END; (* WHILE OCCURE(mItem) ... *)
  END;
 END {MakeSMC_SingleTSN};

 PRIVATE PROCEDURE PosToStorageStaff();
 BEGIN
  IF ~SELECT(Staff, Storage, Storage.Storage) THEN
   TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_THROW)]
    L_General.CallUs(SELECT(Staff, Storage, Storage.Storage));
   EXCEPT
   END; (* TRY *)
  END;
 END {PosToStorageStaff};

 PUBLIC PROCEDURE SMC01_Prepare(XCC: XCContentType; OnDay: SCAL[2]);
 BEGIN
  Create_SMC01();
  IF    XCC = XCC_FullWealth THEN
   SELECT(Storage, TpStrg, , L_Stock.st_AdvHolder);
   WHILE OCCURE(Storage) DO
    PosToStorageStaff();
    SELECT(mItem, Storage, , Storage.Storage);
    WHILE OCCURE(mItem) DO
     CONFORM(mItem, Math);
     MakeSMC_SingleXObject(mItem.XObject, OnDay);
     NEXT(mItem);
    END; (* WHILE OCCURE(mItem) ... *)
    NEXT(Storage);
   END; (* WHILE OCCURE(Storage) ... *)
  ELSIF XCC = XCC_SingleMath THEN
   L_General.Assert(ACCESS(Math), " ⠭ ");
   SELECT(mItem, Math, , Math.Math);
   WHILE OCCURE(mItem) DO
    CONFORM(mItem, Storage);
    IF Storage.Type = L_Stock.st_AdvHolder THEN
     PosToStorageStaff();
     MakeSMC_SingleXObject(mItem.XObject, OnDay);
    END;
    NEXT(mItem);
   END; (* WHILE OCCURE(mItem) ... *)
  ELSIF XCC = XCC_SingleTSN THEN
   L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
   MakeSMC_SingleTSN(OnDay);
  ELSIF XCC = XCC_SingleSort THEN
   L_General.Assert(ACCESS(Sort), " ⠭ ᥪ");
   SELECT(Staff, TSN);
   WHILE OCCURE(Staff) DO
    PROMPT("⭨ "+Staff.TSN);
    HISTCONF(Memo.ud_ut(), Staff, StaffLog);
    IF OCCURE(StaffLog) & (StaffLog.Sort = Sort.Sort) THEN
     MakeSMC_SingleTSN(OnDay);
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
  ELSE
   L_General.CallUs(0);
  END;
 END {SMC01_Prepare};

 PRIVATE PROCEDURE GetSMC01Cut(_Level   : XCLevelType;
                               _SortType: XCSortType): STRING[];
  VAR
   _Cut : tId;
   _Name: STRING[];
 BEGIN
  SAVE(AcCut);
  _Cut :="1";
  SETEMPTY(_Name);
  IF _Level = XCL_Tot1 THEN
   CONFORM(SMC01, Math, MathType);
   _Cut :=Math.MathType;
   _Name:=MathType.Name;
  ELSIF _Level = XCL_Tot2 THEN
   IF _SortType = XST_BySort THEN
    CONFORM(SMC01, Staff);
    HISTCONF(Memo.ud_ut(), Staff, StaffLog);
    _Cut :=StaffLog.Sort;
    CONFORM(StaffLog, Sort);
    _Name:=Sort.Name;
   END;
  ELSIF _Level = XCL_Srt1 THEN
   IF    _SortType = XST_ByTSN THEN
    CONFORM(SMC01, Staff, Man);
    _Cut :=Staff.TSN;
    _Name:=Man.Name;
   ELSIF _SortType = XST_ByMath THEN
    CONFORM(SMC01, Math);
    _Cut :=Math.Math;
    _Name:=FLDTOSTR(Math.Name, "", 36) + " " +
           L_MathR.DefaultMUnitSign(Math.Math);
   END;
  ELSIF _Level = XCL_Srt2 THEN
   IF    _SortType = XST_ByTSN THEN
    CONFORM(SMC01, Staff, Man);
    _Cut :=Staff.TSN;
    _Name:=Man.Name;
   ELSIF _SortType = XST_ByMath THEN
    CONFORM(SMC01, Math);
    _Cut :=Math.Math;
    _Name:=FLDTOSTR(Math.Name, "", 36)+ " "+
           L_MathR.DefaultMUnitSign(Math.Math);
   END;
  END;
  IF ~SEARCH(Cut, Cut, _Cut, _Level) THEN
   Cut.Cut  :=_Cut;
   Cut.Level:=_Level;
   Cut.Name :=_Name;
   INSERT(Cut);
  END;
  RESTORE(AcCut);
  RETURN _Cut;
 END {GetSMC01Cut};

 PUBLIC PROCEDURE SMC02_Prepare(XCC       : XCContentType;
                                _TotType1 : XCSortType;
                                _TotType2 : XCSortType;
                                _SortType1: XCSortType;
                                _SortType2: XCSortType;
                                OnDay     : SCAL[2]);
 BEGIN
  SMC01_Prepare(XCC, OnDay);

  Create_SMC02();
  Create_Cut();

  SELECT(SMC01, TSN);
  WHILE OCCURE(SMC01) DO
   PROMPT("⭨ "+SMC01.TSN + ",  " + SMC01.Math);
   SMC02.Cut1:=GetSMC01Cut(XCL_Tot1, _TotType1);
   SMC02.Cut2:=GetSMC01Cut(XCL_Tot2, _TotType2);
   SMC02.Cut3:=GetSMC01Cut(XCL_Srt1, _SortType1);
   SMC02.Cut4:=GetSMC01Cut(XCL_Srt2, _SortType2);
   ADD(SMC02, Cut1, , SMC02.Cut1, SMC02.Cut2, SMC02.Cut3, SMC02.Cut4,
            SMC02.SldSum, SMC01.SldSum,
            SMC02.SldQnt, SMC01.SldQnt,
            SMC02.DbtSum, SMC01.DbtSum,
            SMC02.DbtQnt, SMC01.DbtQnt,
            SMC02.CrdSum, SMC01.CrdSum,
            SMC02.CrdQnt, SMC01.CrdQnt);
   NEXT(SMC01);
  END; (* WHILE OCCURE(SMC01) ... *)
 END {SMC02_Prepare};

 PUBLIC PROCEDURE SMC01_Purge();
 BEGIN
  L_AFM.AF_PurgeTemp("SMC01");
 END {SMC01_Purge};

 PUBLIC PROCEDURE SMC02_Purge();
 BEGIN
  L_AFM.AF_PurgeTemp("SMC01");
  L_AFM.AF_PurgeTemp("SMC02");
  L_AFM.AF_PurgeTemp("Cut");
 END {SMC02_Purge};
END.
