(*
%Copyright   (c) Polak Computer System
%Author      28.10.1997 12:22:05 SAN
%Purpose      ਪ  ᮭ
%Type        report
%Specific    SYS
%Modified    22.07.2014 19:15:57 POLAK\Bor
%Environment
*)

 MODULE EDOPrint [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Str, Str, L_EDO, FIO, L_PagePr, L_StdFrm, L_MSO, E_Staff, L_EC, L_Money,
        L_DatTim, L_Staff, P_EDOL, L_XDoc, P_EDOKnd, L_Car, P_Firm, P_Man, L_AR, L_Prop, Math, L_APtm;

 PRIVATE TYPE
  tPrintMode = SCAL[3];

 PRIVATE CONST
  StrLen = 78;
  Type0Pattern =
   "\$[0\SRW. \$]0";
  Type1Pattern =
   "\$[0\SRW. \$]0㭪 \ROW   ᫥饩 ।樨:"+
   "\NLN";
  Type2Pattern =
   "\$[0\SRW. \$]0㭪 \ROW ⬥.";
  NoticePattern =
   "\NLN"+
   "\NLN"+
   "㪮⥫ ⤥ \DPN(\DPC)"+
   "\NLN"+
   "\NLN"+
   "'____.____._________' __________________ /___________________________________/"+
   "\NLN";

  pm_Original = 0;
  pm_Preview  = 1;
  pm_Notice   = 2;

 PRIVATE VAR
  UseWord,
  ItemKind,
  OmitCurItem  : SCAL[2];

  SrcStr,
  ItmStr,
  RawStr,
  wordBodyStr,
  TemplateName : STRING[];

  CntRow,
  CurItmStrP,
  PageNumInCopy: NUMERIC[0];

  PrintMode    : tPrintMode;

(*
$P{ Line:
?, L, ""
@
##############################################################################
}
*)

(*
$P{PageTop:
P_Firm.MyFirmName(EDOrder.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
PrintMode, L, "==================|=       ==|        "
EDOrder.SrcNum+"________",L, ""
EDOrder.Date, L, "D.N.y"
EDOrder.EDOrder, L, ""
EDOrder.CopyCnt L, ""
?, L, ""
?, C, ""
EDOrder.About, C, ""
@
############################################################# ########## #####
============================##################================================
ਫ 1  ਪ ########  ########## ( #######,  ##) ࠭ ###
##############################################################################
##############################################################################
------------------------------------------------------------------------------
}

$P{Filling:
@

}

$P{PageBot:
@
=(c) Polak====================================================================}

$P{Bot:
?, C, ""
?, C, ""
@
------------------------------------------------------------------------------

ᯮ⥫______________/#############################(####################)/

=(c) Polak====================================================================}
*)

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   (* nothing *)
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF (Mode = L_PagePr.m_Print) | (Mode = L_PagePr.m_RDoneTop) THEN
   CONFORM(EDOrder, EDOGrp);
   IF OCCURE(EDOGrp) THEN
    MAKEPART(R, PageTop, FLDTOSTR(L_PagePr.PagePr_CurrentPage()-PageNumInCopy, "L0", 3), EDOGrp.Descr);
   ELSE
    MAKEPART(R, PageTop, FLDTOSTR(L_PagePr.PagePr_CurrentPage()-PageNumInCopy, "L0", 3));
   END;
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(PageBot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, PageBot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Bot));
  ELSIF Mode = L_PagePr.m_Print THEN
   CONFORM(EDOrder, EDOSrc);
   MAKEPART(R, Bot, P_Man.GetFullNameOfCurrentUser(SYSDATE()), EDOSrc.Name);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Fill);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Filling));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Filling);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE EDOL_Date(): DATE;
 BEGIN
  IF    ~!EDOrderL.OcrDate THEN
   RETURN EDOrderL.OcrDate;
  ELSIF ~!EDOrderL.EndDate THEN
   RETURN EDOrderL.EndDate;
  ELSE
   L_General.Error("  |ப ਪ - " + EDOrderL.Row);
  END;
 END {EDOL_Date};

 PRIVATE PROCEDURE GetAttrCode(VAR Idx: NUMERIC[0];
                               VAR AC : STRING[3];
                               VAR MD : NUMERIC[0];
                               VAR Inv: SCAL[3]);
  VAR
   i   : NUMERIC[3];
   tmp : STRING[7];
 BEGIN
  SETZERO(MD, Inv);
  IF ~!SrcStr[Idx] & (SrcStr[Idx] = "\") THEN
   AC:="\";
  ELSE
   IF    ~!SrcStr[Idx] & (SrcStr[Idx] = "~") THEN
    Inv:=1; INC(Idx);
   ELSIF ~!SrcStr[Idx] & (SrcStr[Idx] = "?") THEN
    Inv:=2; INC(Idx);
   END;
   i:=0;
   WHILE ~!SrcStr[Idx] & (i < 3) DO
    AC[i]:=SrcStr[Idx]; INC(i); INC(Idx);
   END;
   L_General.Assert(i = 3, "  ࠬ   >= 3");
   IF (AC = "PRP") | (AC = "PRN") | (AC = "EKP") THEN
    i:=0;
    WHILE ~!SrcStr[Idx] & (i < 4) DO
     tmp[i]:=SrcStr[Idx];
     INC(i);
     INC(Idx);
    END;
    tmp:=Str.Condense(tmp);
    IF ~L_Prop.IsNumericValue(tmp, "") THEN
     L_General.Error("  蠡  '" + AC  + "'  4- ᨬ  ᢮⢠.|" +
                     "祭 祭: '" + tmp + "'.||" +
                     " ஢ ࠢ쭮 ᠭ 蠡  ਪ");
    END;
    L_General.Assert(Str.Length(tmp) = 4, " 蠡  '" + AC + tmp + "': 室 ᯮ짮 4- ᨬ  ᢮⢠");
    MD:=STRTOFLD(tmp, NUMERIC);
   END;
  END;
 END {GetAttrCode};

 PRIVATE PROCEDURE _PutCh(Ch: STRING[1]);
 BEGIN
  ItmStr[CurItmStrP]:=Ch;
  INC(CurItmStrP);
 END {_PutCh};

 PRIVATE PROCEDURE _PutStr(str: STRING[]);
  VAR
   i, l : NUMERIC[0];
 BEGIN
  i:=0; l:=Str.Length(str);
  WHILE i < l DO
   _PutCh(str[i]); INC(i);
  END;
 END {_PutStr};

 PRIVATE PROCEDURE GetByEDOrderLTSN(ValName: STRING[]): STRING[];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   IF ~!EDOrderL.Officer THEN
    CONFORM(StaffLog, Officer, Sort, Post);
   END;
   RETURN ^ValName;
  EXCEPT
  END; (* TRY *)
 END {GetByEDOrderLTSN};

 PRIVATE PROCEDURE _EDOCauses(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="";
  SELECT(EDOLC, edcType, , EDOrderL.EDOrder, EDOrderL.Row);
  WHILE OCCURE(EDOLC) DO
   IF ~!Result THEN
    Result:=Result + "; ";
   END;
   CONFORM(EDOLC, EDOCause);
   Result:=Result + EDOCause.Name;
   IF ~!EDOLC.XDocId THEN
    Result:=Result + " (" + L_XDoc.XDocStr(EDOLC.XDocId) + ")";
   END;
   NEXT(EDOLC);
  END; (* WHILE OCCURE(EDOLC) ... *)
  RETURN Result;
 END {_EDOCauses};

 PRIVATE PROCEDURE GetAttrValue(AC: STRING[3]; MD: NUMERIC[0]): STRING[];
  VAR
   _Value: STRING[];
   tmp   : STRING[];
   BT,
   ET    : TIME;
   DBT,
   DET   : TIME[3];
   i     : NUMERIC[0];
 BEGIN
  IF    AC = "ROW" THEN RETURN FLDTOSTR(EDOrderL.Row, "N", 0);
  ELSIF AC = "SRW" THEN
   IF UseWord THEN
    RETURN "";
   ELSE
    RETURN FLDTOSTR(CntRow, "N", 0);
   END;
  ELSIF AC = "TSN" THEN RETURN EDOrderL.TSN;
  ELSIF AC = "NAM" THEN RETURN Man.Name;
  ELSIF AC = "BGD" THEN
   IF ~!EDOrderL.OcrDate THEN
    RETURN FLDTOSTR(EDOrderL.OcrDate, "D.N.y", 0);
   END;
  ELSIF AC = "EDD" THEN
   IF ~!EDOrderL.EndDate THEN
    RETURN FLDTOSTR(EDOrderL.EndDate, "D.N.y", 0);
   END;
  ELSIF AC = "EKC" THEN RETURN EDOKind.EDOKind;
  ELSIF AC = "EKN" THEN
   tmp:=EDOKind.RegName[0];
   IF ~!EDOKind.RegName[1] THEN
    tmp:=tmp + " " + EDOKind.RegName[1];
   END;
   RETURN tmp;
  ELSIF AC = "ECC" THEN RETURN L_EDO.EDOCauseCodes();
  ELSIF AC = "ECN" THEN RETURN _EDOCauses();
  ELSIF AC = "SRC" THEN RETURN Sort.Sort;
  ELSIF AC = "SRN" THEN RETURN Sort.Name;
  ELSIF AC = "DPC" THEN RETURN L_Staff.getDepart();
  ELSIF AC = "DPN" THEN RETURN L_Staff.getDepartName();
  ELSIF AC = "PSC" THEN RETURN Post.Post;
  ELSIF AC = "PSN" THEN RETURN Post.Name;
  ELSIF AC = "OFC" THEN RETURN EDOrderL.Officer;
  ELSIF AC = "CLS" THEN RETURN EDOrderL.Class;
  ELSIF AC = "CSC" THEN RETURN GetByEDOrderLTSN("Sort.Sort");
  ELSIF AC = "CSN" THEN RETURN GetByEDOrderLTSN("Sort.Name");
  ELSIF AC = "CPC" THEN RETURN GetByEDOrderLTSN("Post.Post");
  ELSIF AC = "CPN" THEN RETURN GetByEDOrderLTSN("Post.Name");
  ELSIF AC = "CCL" THEN RETURN GetByEDOrderLTSN("StaffLog.Class");
  ELSIF AC = "CDC" THEN RETURN GetByEDOrderLTSN("L_Staff.getDepart()");
  ELSIF AC = "CDN" THEN RETURN GetByEDOrderLTSN("L_Staff.getDepartName()");
  ELSIF AC = "PER" THEN RETURN FLDTOSTR(EDOrder.Closed, "N.y", 0);
  ELSIF AC = "PRC" THEN                 
   IF EDOrderL.ByPrc # 0 THEN
    RETURN FLDTOSTR(EDOrderL.ByPrc, "2.", 0);
   END;
  ELSIF AC = "SUM" THEN
   IF EDOrderL.BySum # 0  THEN
    RETURN FLDTOSTR(EDOrderL.BySum, "2-", 0);
   END;
  ELSIF AC = "FPC" THEN
   RETURN Str.Small(Str.Condense(L_EDO.GetFixInPC_byStr(EDOKind.EDOGrp, EDOrderL.FixInPC)));
  ELSIF AC = "PRP" THEN
   L_EDO.GetEDOLPropValue(MD, _Value);
   IF ~!_Value THEN
    RETURN _Value;
   END;
  ELSIF AC = "EKP" THEN
   RETURN P_EDOKnd.GetEDOKProSoft(EDOKind.EDOKind, EDOrder.PrpDate, MD);
  ELSIF AC = "PRN" THEN
   SETEMPTY(_Value);
   IF MD = P_EDOL.P_RegimeTimes THEN
    IF P_EDOL.GetRegimeTimes(BT, ET, DBT, DET) THEN
     IF ~!BT THEN
      _Value:=_Value + " " + L_DatTim.TimeStr(BT) + " - " + L_DatTim.TimeStr(ET);
     END;
     i:=0;
     WHILE i < 3 DO
      IF ~!DBT[i] THEN
       _Value:=_Value + ",  " + L_DatTim.TimeStr(DBT[i]) + " - " + L_DatTim.TimeStr(DET[i]);
      END;
      INC(i);
     END;
    END;
   ELSE
    L_EDO.GetEDOLPropVal2Show(MD, _Value);
   END;
   RETURN _Value;
  ELSIF AC = "TKN" THEN
   IF P_EDOL.HasAnyEDOLPro(EDOrderL.EDOrder, EDOrderL.Row, P_EDOL.P_BoxNbr) THEN
    L_Car.StandOnCarLog(P_EDOL.Decode_CurEDOLPro(), EDOrder.Date);
    CONFORM(CarLog, TKind);
    RETURN TKind.Name;
   ELSE
    RETURN "";
   END;
  ELSE
   RETURN AC;
  END;
  RETURN "";
 END {GetAttrValue};

 PRIVATE PROCEDURE PutAttr(AC: STRING[3]; MD: NUMERIC[0]; Inv: SCAL[3]);
  VAR
   R: STRING[];
 BEGIN
  IF    AC = "\" THEN
   _PutCh("\");
  ELSIF AC = "NLN" THEN
   _PutCh(L_MSO.L_MSO_wordNL());
  ELSE
   R:=GetAttrValue(AC, MD);
   IF ~!R THEN
    IF Inv = 1 THEN
     OmitCurItem:=1;
    ELSIF Inv = 2 THEN
     (* dont put *)
    ELSE
     _PutStr(R);
    END;
   ELSIF Inv # 1 THEN
    OmitCurItem:=1;
   END;
  END;
 END {PutAttr};

 PRIVATE PROCEDURE TermItem();
 BEGIN
  IF (CurItmStrP # 0) & ~OmitCurItem THEN
   ItmStr[CurItmStrP]:=CHR(0);
   RawStr:=RawStr+ItmStr;
  END;
  SETZERO(CurItmStrP);
  ItemKind:=~ItemKind;
  OmitCurItem:=0;
 END {TermItem};

 PRIVATE PROCEDURE Morph();
  VAR
   i, l      : NUMERIC[0];
   AC        : STRING[3];
   MD        : NUMERIC[0];
   Inv       : SCAL[3];
 BEGIN
  PROMPT(SrcStr);
  i:=0; l:=Str.Length(SrcStr);
  WHILE i < l DO
   IF SrcStr[i] = "\" THEN
    INC(i); GetAttrCode(i, AC, MD, Inv);
    IF    AC = "$[0" THEN
     L_General.Assert(ItemKind=0, "⨬  ᫮ ࠦ");
     TermItem();
    ELSIF AC = "$]0" THEN
     L_General.Assert(ItemKind=1, "ୠ 뢠 ᪮ ᫮ ࠦ");
     TermItem();
    ELSE
     PutAttr(AC, MD, Inv);
    END;
   ELSE
    _PutCh(SrcStr[i]);
    INC(i);
   END;
  END;
 END {Morph};

 PRIVATE PROCEDURE MorphItem(I: STRING[]);
 BEGIN
  SETZERO(ItemKind, OmitCurItem);
  SrcStr:=I;
  Morph();
  TermItem();
  SETZERO(ItemKind, OmitCurItem);
 END {MorphItem};

 PRIVATE PROCEDURE WriteOut(Pattern: STRING[128]);
  VAR
   i, j,
   pos,
   oldPos,
   rawLen   : NUMERIC[0];
   TmpStr,
   PrtStr   : STRING[StrLen][64];
   LinesNum : NUMERIC[0];
   Dummy    : STRING[];
 BEGIN
  SETEMPTY(RawStr, ItmStr);

  SETZERO(CurItmStrP, ItemKind, OmitCurItem);

  IF EDOrderL.Type = L_EDO.type_Cancel THEN
   MorphItem(Type2Pattern);
  ELSE
   IF    EDOrderL.Type = L_EDO.type_Initial THEN
    MorphItem(Type0Pattern);
   ELSIF EDOrderL.Type = L_EDO.type_Correct THEN
    MorphItem(Type1Pattern);
   END;
   FIO.Open(I, Pattern, "", Input);
   WHILE FIO.RdStr(I, SrcStr) DO
    Morph();
   END;
   TermItem();
   FIO.Close(I);
  END; (* IF EDOrderL.Type ... *)

  IF PrintMode = pm_Notice THEN
   MorphItem(NoticePattern);
  END;

  SETEMPTY(PrtStr);
  SETZERO(i, oldPos, LinesNum);
  rawLen:=Str.Length(RawStr);
  WHILE oldPos < rawLen DO
   pos:=Str.Pos(RawStr, L_MSO.L_MSO_wordNL(), oldPos);
   Dummy:=Str.Slice(RawStr, oldPos, pos-oldPos);
   IF !Dummy THEN
    PrtStr[LinesNum]:=Dummy;
    INC(LinesNum);
   ELSE
    Str.Format(TmpStr, Dummy, StrLen, LEFT);
    j:=0;
    WHILE ~!TmpStr[j] DO
     PrtStr[LinesNum]:=TmpStr[j];
     INC(LinesNum);
     INC(j);
    END;
   END;
   oldPos:=pos+1;
   INC(i);
  END; (* WHILE oldPos < rawLen ...  *)
  IF UseWord THEN
   IF ~!wordBodyStr THEN
    wordBodyStr:=wordBodyStr+L_MSO.L_MSO_wordCRLF();
   END;
   wordBodyStr:=wordBodyStr+RawStr;
  ELSE
   L_PagePr.PagePr_BeforePrintLine(LinesNum+1);
   MAKEPART(R, Line, " ");
   i:=0;
   WHILE i <= LinesNum DO
    MAKEPART(R, Line, PrtStr[i]);
    INC(i);
   END;
  END;
 END {WriteOut};

 PRIVATE PROCEDURE GetPatternName(): STRING[128];
  VAR
   P: STRING[128];
 BEGIN
  P:=P_EDOKnd.GetEDOKProSoft(EDOKind.EDOKind, EDOrder.PrpDate, P_EDOKnd.P_TemplateTXT);
  IF !P THEN
   P:="EDO"+EDOKind.EDOGrp+"001";
  END;
  P:=P+".TXT";
  L_General.Assert(FIO.Exists(P),
                  "  䠩-蠡   ਪ."+
                  "| 䠩 - " + P +
                  "|ப ਪ - " + EDOrderL.Row);
  RETURN P;
 END {GetPatternName};

 PRIVATE PROCEDURE MakeOneEDOrderL();
 BEGIN
  CONFORM(EDOrderL, EDOKind);
  CONFORM(EDOrderL, Staff, Man);
  L_Staff.PosToStaffLog(Staff.TSN, EDOL_Date(), 1);
  IF ~!EDOrderL.Officer THEN
   CONFORM(EDOrderL, Officer);
  ELSE
   CONFORM(StaffLog, Officer);
  END;
  CONFORM(Officer, Sort, Post);
  WriteOut(GetPatternName());
 END {MakeOneEDOrderL};

 PRIVATE PROCEDURE E_T11_ExtraFooter(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_Staff.T11_ExtraFooter), "");
 END {E_T11_ExtraFooter};

 PRIVATE PROCEDURE E_T11x_ExtraFooter(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_Staff.T11x_ExtraFooter), "");
 END {E_T11x_ExtraFooter};

 PRIVATE PROCEDURE E_comb_ExtraFooter(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_Staff.comb_ExtraFooter), "");
 END {E_comb_ExtraFooter};

 PRIVATE PROCEDURE Prepare_Standart(VAR OnDate: DATE);
 BEGIN
  IF UseWord THEN
   SETEMPTY(wordBodyStr);
   L_MSO.wordSetVarsByFile("EDOrder");
   CONFORM(EDOrder, EDOSrc);
   L_MSO.wordSetVarsByFile("EDOSrc"); (*!*)
   L_MSO.wordSetVarsByFile_wAlias("EDOSrc", "EDOrder.EDOSrc");
   CONFORM(EDOrder, EDOGrp);
   L_MSO.wordSetVarsByFile_wAliasE("EDOGrp", "EDOrder.EDOGrp", ~OCCURE(EDOGrp));
  ELSE
   L_PagePr.PagePr_Init("R", 64,
                        PROCREF(_RprtTop),
                        PROCREF(_PageTop),
                        PROCREF(_PageBot),
                        PROCREF(_RprtBot),
                        PROCREF(_Filling));
  END;
  SETZERO(CntRow);
  SELECT(EDOrderL, EDOrder, , EDOrder.EDOrder);
  WHILE OCCURE(EDOrderL) DO
   PROMPT(" ਪ: ப " + EDOrderL.Row);
   INC(CntRow);
   MakeOneEDOrderL();
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
  IF UseWord THEN
   L_MSO.wordSetBkm("EDOrderBody", wordBodyStr);
  ELSE
   L_PagePr.PagePr_Done();
  END; (* IF UseWord ... *)
 END {Prepare_Standart};

 PRIVATE PROCEDURE Prepare_T11a(VAR OnDate: DATE);
  VAR
  Root,
  EDOKindN,
  _Reward  : STRING[];
  Cnt      : NUMERIC[0];
 BEGIN
  L_General.Assert(L_EDO.CanPrintAsT11a(),
                   "  ப ਪ   㪠 :"+
                   "|  ᭮,  ⠪  ७");

  L_APtm.wordSetTheDocCauseAndDraftsman(OnDate, "⢥ত ⠭ ᪮ ᨨ  05.01.2004  1", "");

  SELECT(EDOrderL, EDOrder, , EDOrder.EDOrder);
  L_MSO.wordSetVar("TheDoc.InternalNumber", EDOrder.EDOrder);
  L_MSO.wordSetVar("TheDoc.CopyCnt", L_Str.IntStr(EDOrder.CopyCnt));
  CONFORM(EDOrder, EDOSrc);
  L_MSO.wordSetVarsByFile_wPrefix("EDOSrc", "Order.");
  Root:="Order";
  CONFORM(EDOrderL, EDOKind);
  EDOKindN:=Str.Condense(EDOKind.RegName[0] + " " + EDOKind.RegName[1]);
  L_MSO.wordSetVar(Root+".EDOKind.RegName", EDOKindN);
  L_MSO.wordSetVar(Root+".EDOKind.EDOKind", EDOKind.EDOKind);
  L_MSO.wordSetVarsByFile_wAlias("EDOrder", "Order");
  L_MSO.wordSetVar("Order.Reason", Str.Condense(EDOKindN + " (" + EDOrder.About+")"));
  L_MSO.wordSetVar("Order.Cause", Str.Small(_EDOCauses(), 0, 1));
  _Reward:=L_Str.PoolItem("ਭ  | ୮|ࠤ ⭮ ࠬ⮩|ࠤ 業 મ",
                          EDOrderL.FixInPC);
  IF (EDOrderL.BySum # 0) & (EDOrderL.FixInPC # 3) THEN
   _Reward:=_Reward + ", 뤠 ६";
  END;
  IF EDOrderL.EDOGrp = L_EDO.grp_BonusFee THEN
   CONFORM(EDOKind, MoneyMth);
   L_General.Assert(SELECT(MoneyRul, MoneyMth, MoneyMth.Method),
                    "     ࠢ 䨪樨 ⮤ ");
   CONFORM(MoneyRul, MCList);
   L_MSO.wordSetVar("Order.Reward", MCList.Name);
  ELSE
   L_MSO.wordSetVar("Order.Reward", _Reward);
  END;
  Cnt      :=0;
  WHILE OCCURE(EDOrderL) DO
   PROMPT(" ਪ: ப " + EDOrderL.Row);
   CONFORM(EDOrderL, Staff);
   L_Staff.PosToStaffLog(Staff.TSN, EDOL_Date(), 1);
   CONFORM(StaffLog, Officer, Sort, Post);
   CONFORM(Staff, Man);
   Root:="OrderL"+L_MSO.IndexStr(Cnt);
   L_MSO.wordSetVar(Root+".Staff.TSN",      EDOrderL.TSN);
   L_MSO.wordSetVar(Root+".Man.Name.Short", L_Str.ShortName(Man.Name));
   L_MSO.wordSetVar(Root+".Post.Name",      Post.Name);
   L_MSO.wordSetVar(Root+".Depart.Name",    L_Staff.getDepartName());
   L_MSO.wordSetVar(Root+".Sort.Name",      Sort.Name);
   IF EDOrderL.BySum = 0 THEN
    L_MSO.wordSetVar(Root+".Value", "");
   ELSE
    L_MSO.wordSetVar(Root+".Value", L_Money.MoneyToStr(EDOrder.Closed, " ", EDOrderL.BySum));
   END;
   INC(Cnt);
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
  L_MSO.wordSetVar("TheDoc.Delivery", "⤥ ஢");
  L_MSO.SetWordTable("manlist", Cnt);
  L_MSO.PutInTables:=L_MSO.Put_Values;
  L_MSO.wordSetVar("E_T11_ExtraFooter", E_T11_ExtraFooter(EDOrder.PrpDate));
 END {Prepare_T11a};

 PRIVATE PROCEDURE Prepare_T9_10(VAR OnDate: DATE);
  VAR
   Root,
   PropValue: STRING[];
   Cnt      : NUMERIC[0];
 BEGIN
  L_General.Assert(L_EDO.CanPrintAsT9(), "ਪ    ⠭  ଥ T9");
  L_MSO.IsDuplexDoc:=0;
  L_MSO.wordSetVarsByFile("EDOrder");
  CONFORM(EDOrder, EDOSrc);
  L_MSO.wordSetVarsByFile("EDOSrc"); (*!*)
  L_MSO.wordSetVarsByFile_wAlias("EDOSrc", "EDOrder.EDOSrc");
  L_MSO.wordSetVarsByFile_wPrefix("EDOSrc", "Order.");
  CONFORM(EDOrder, EDOGrp);
  L_MSO.wordSetVarsByFile_wAliasE("EDOGrp", "EDOrder.EDOGrp", ~OCCURE(EDOGrp));
  L_MSO.wordSetVar("TheDoc.InternalNumber", EDOrder.EDOrder);
  L_MSO.wordSetVar("TheDoc.CopyCnt", L_Str.IntStr(EDOrder.CopyCnt));
  Cnt:=0;
  SELECT(EDOrderL, EDOrder, , EDOrder.EDOrder);
  WHILE OCCURE(EDOrderL) DO
   PROMPT(" ਪ: ப " + EDOrderL.Row);
   CONFORM(EDOrderL, Staff);
   Root:="EDOrder.EDOrderL" + L_MSO.IndexStr(Cnt);
   L_MSO.wordSetVarsByFile_wAlias('EDOrderL', Root);
   L_MSO.wordSetVar(Root+".Cause", Str.Small(_EDOCauses(), 0, 1));
   L_EDO.GetEDOLPropValue(P_EDOL.P_Destination,   PropValue);
   L_MSO.wordSetVar(Root + ".Destination",   PropValue);
   L_EDO.GetEDOLPropValue(P_EDOL.P_Purpose,       PropValue);
   L_MSO.wordSetVar(Root + ".Purpose",       PropValue);
   L_EDO.GetEDOLPropValue(P_EDOL.P_FundingSource, PropValue);
   L_MSO.wordSetVar(Root + ".FundingSource", PropValue);
   L_MSO.wordSetVar(Root + ".CalendarDays",  L_Str.IntStr(EDOrderL.EndDate - EDOrderL.OcrDate + 1));
   Root:=Root + ".Staff";
   L_Staff.StaffFileFamily(EDOrderL.OcrDate, EDOrderL.OcrDate, Root);
   CONFORM(Staff, Man);
   L_MSO.wordSetVarsByFile_wPrefix('Man', Root + ".");
   INC(Cnt);
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
 END {Prepare_T9};

 PRIVATE PROCEDURE GetOrderType_asStr(): STRING[];
  VAR
   asStr: STRING[];
 BEGIN
  IF EDOrderL.Type = L_EDO.type_Initial THEN
   asStr:="";
  ELSE
   SAVE(EDOrder);
   SAVE(EDOrderL);
   L_EDO.StandOnEDOrder(EDOrder.MEDOrder, EDOrderL.Row);
   asStr:="ਪ  " + EDOrder.SrcNum +
          "  " + L_DatTim.DateStr(EDOrder.Date) +
          " ( " + EDOrder.EDOrder + ")";
   RESTORE(EDOrderL);
   RESTORE(EDOrder);
   IF    EDOrderL.Type = L_EDO.type_Correct THEN
    asStr:=asStr + "   ᫥饩 ।樨:";
   ELSIF EDOrderL.Type = L_EDO.type_Cancel  THEN
    asStr:=asStr + " .  ⬥塞 ਪ:";
   ELSE
    L_General.Error("⨬ ⨯ ப ਪ");
   END;
  END;
  RETURN asStr;
 END {GetOrderType_asStr};

 PRIVATE PROCEDURE Prepare_T11x(VAR OnDate: DATE);
  VAR
  Root,
  Comment: STRING[];
 BEGIN
  L_General.Assert(SELECT(EDOrderL, EDOrder, EDOrder.EDOrder),
                   "祬  ⮩ ਪ");
  L_MSO.wordSetVar("TheDoc.InternalNumber", EDOrder.EDOrder);
  L_MSO.wordSetVar("TheDoc.CopyCnt", L_Str.IntStr(EDOrder.CopyCnt));
  CONFORM(EDOrder, EDOSrc);
  CONFORM(EDOrderL, EDOKind);
  Root:="Order";
  L_MSO.wordSetVarsByFile_wPrefix("EDOSrc", Root + ".");
  L_MSO.wordSetVarsByFile_wAlias("EDOrder", Root);
  L_MSO.wordSetVar(Root+".Type", GetOrderType_asStr());
  L_MSO.wordSetVar(Root+".Cause", Str.Small(_EDOCauses(), 0, 1));
  CONFORM(EDOrderL, Staff);
  L_Staff.PosToStaffLog(Staff.TSN, EDOL_Date(), 1);
  CONFORM(StaffLog, Officer, Sort, Post);
  CONFORM(Staff, Man);
  L_MSO.wordSetVar(Root+".Staff.TSN",       EDOrderL.TSN);
  L_MSO.wordSetVar(Root+".Man.Name",        Man.Name);
  L_MSO.wordSetVar(Root+".Man.Name.Short",  L_Str.ShortName(Man.Name));
  L_MSO.wordSetVar(Root+".Post.Name",       Post.Name);
  L_MSO.wordSetVar(Root+".Post.Post",       Post.Post);
  L_MSO.wordSetVar(Root+".Depart.Depart",   L_Staff.getDepart());
  L_MSO.wordSetVar(Root+".Depart.Name",     L_Staff.getDepartName());
  L_MSO.wordSetVar(Root+".Sort.Name",       Sort.Name);
  L_MSO.wordSetVar(Root+".Sort.Sort",       Sort.Sort);
  L_MSO.wordSetVar(Root+".EDOKind.RegName",
                   Str.Condense(Str.Condense(EDOKind.RegName[0]) + " " +
                                Str.Condense(EDOKind.RegName[1])));
  L_MSO.wordSetVar(Root+".EDOKind.EDOKind", EDOKind.EDOKind);
  Comment:="";
  CONFORM(EDOrderL, EDOLPro);
  WHILE OCCURE(EDOLPro) DO
   IF ~!EDOLPro.Value THEN
    CONFORM(EDOLPro, Property);
    IF ~!P_EDOL.IsSimpleUserOf(EDOLPro.Property) THEN
     Comment:=Comment + Property.Name + ": " + P_EDOL.Decode_CurEDOLPro() + ". ";
    ELSE
     Comment:=Comment + Property.Name + ": " + Str.Small(EDOLPro.Value, 0, 1) + ". ";
    END;
   END;
   NEXT(EDOLPro);
  END; (* WHILE OCCURE(EDOLPro) ... *)
  IF    ~!EDOrderL.EndDate THEN
   Comment:=Comment + "ਮ ᮡ:  " +
            L_DatTim.DateStr(EDOrderL.OcrDate) + "  " +
            L_DatTim.DateStr(EDOrderL.EndDate) + ".";
  ELSIF ~!EDOrderL.OcrDate THEN
   Comment:=Comment + " ᮡ: " +
            L_DatTim.DateStr(EDOrderL.OcrDate) + ".";
  END;
  L_MSO.wordSetVar(Root+".Comment", Comment);
  IF EDOrderL.ByPrc = 0 THEN
   L_MSO.wordSetVar(Root+".Value", L_Money.MoneyToStr(EDOrder.Closed, " ", EDOrderL.BySum));
   L_MSO.wordSetVar(Root+".Value.Unit", "㡫");
  ELSE
   L_MSO.wordSetVar(Root+".Value", L_Str.NumericStr(EDOrderL.ByPrc, 2));
   L_MSO.wordSetVar(Root+".Value.Unit", "%  筮 ");
  END;
  L_MSO.wordSetVar(Root+".Penalty",
                   Str.Small(L_Str.PoolItem(L_EDO.GetFixInPCPool(L_EDO.grp_Violation), EDOrderL.FixInPC)));
  L_MSO.wordSetVar("TheDoc.Delivery", "⤥ ஢");
  L_MSO.wordSetVar("E_T11x_ExtraFooter", E_T11x_ExtraFooter(EDOrder.PrpDate));
 END {Prepare_T11x};

 PRIVATE PROCEDURE Prepare_Combining(VAR OnDate: DATE);
  VAR
   Root,
   Comment,
   PropValue: STRING[];
   _EDOKind : LIKE(EDOrderL.EDOKind);
   Idx      : NUMERIC[0];
 BEGIN
  L_General.Assert(SELECT(EDOrderL, EDOrder, EDOrder.EDOrder), "祬  ⮩ ਪ");
  L_MSO.wordSetVar("TheDoc.InternalNumber", EDOrder.EDOrder);
  L_MSO.wordSetVar("TheDoc.CopyCnt", L_Str.IntStr(EDOrder.CopyCnt));
  CONFORM(EDOrder, EDOSrc);
  L_MSO.wordSetVarsByFile_wPrefix("EDOSrc", "Order.");
  L_MSO.wordSetVarsByFile("EDOrder");
  SETEMPTY(_EDOKind);
  Idx:=0;
  WHILE OCCURE(EDOrderL) DO
   CONFORM(EDOrderL, EDOKind);
   IF !_EDOKind THEN
    _EDOKind:=EDOKind.EDOKind;
   ELSE
    L_General.Assert(EDOKind.EDOKind = _EDOKind, "  ਪ  ப ਪ");
   END;
   Root:="EDOrder.EDOrderL" + L_MSO.IndexStr(Idx);
   CONFORM(EDOrderL, Staff);
   L_Staff.PosToStaffLog(Staff.TSN, EDOL_Date(), 1);
   CONFORM(StaffLog, Officer, Sort, Post);
   CONFORM(Staff, Man);
   L_MSO.wordSetVar(Root+".Staff.TSN",       EDOrderL.TSN);
   L_MSO.wordSetVar(Root+".Man.Name",        Man.Name);
   L_MSO.wordSetVar(Root+".Man.Name.Short",  L_Str.ShortName(Man.Name));
   L_MSO.wordSetVar(Root+".EDOKind.EDOKind", EDOKind.EDOKind);

   L_EDO.GetEDOLPropValue(P_EDOL.P_TSN, PropValue);
   IF SEARCH(Staff, TSN, PropValue) THEN
    CONFORM(Staff, Man);
    L_MSO.wordSetVar(Root+".ReplacedStaff.TSN",             Staff.TSN);
    L_MSO.wordSetVar(Root+".ReplacedStaff.Man.Name",        Man.Name);
    L_MSO.wordSetVar(Root+".ReplacedStaff.Man.Name.Short",  L_Str.ShortName(Man.Name));
   ELSE
    L_MSO.wordSetVar(Root+".ReplacedStaff.TSN",             "");
    L_MSO.wordSetVar(Root+".ReplacedStaff.Man.Name",        "");
    L_MSO.wordSetVar(Root+".ReplacedStaff.Man.Name.Short",  "");
   END;
   CONFORM(EDOrderL, Officer);
   CONFORM(Officer, Sort);
   CONFORM(Officer, Post);
   L_General.Assert(SELECT(WagePayL, WagePay, Officer.WagePay) & SRCINSEL(WagePayL, LE, EDOL_Date()),
                    " ଠ樨  䭮 ⪥ " + Officer.WagePay +
                    "  " + L_DatTim.PeriodStr(EDOL_Date()));
   L_MSO.wordSetVar(Root+".Sort.Name", Sort.Name);
   L_MSO.wordSetVar(Root+".Post.Name", Post.Name);
   L_MSO.wordSetDateVar(Root+".OcrDate", EDOrderL.OcrDate);
   L_MSO.wordSetDateVar(Root+".EndDate", EDOrderL.EndDate);
   L_MSO.wordSetMoneyVar(Root + ".WagePay.Pay", OnDate, WagePayL.Pay[EDOrderL.Class]);
   L_MSO.wordSetVar    (Root + ".WagePay.Type", L_Staff.GetWagePayLType_AsStr());
   IF EDOrderL.ByPrc = 0 THEN
    L_MSO.wordSetMoneyVar(Root+".Value",     EDOrder.Closed, EDOrderL.BySum);
    L_MSO.wordSetMoneyVar(Root+".Value.Sum", EDOrder.Closed, EDOrderL.BySum);
    L_MSO.wordSetVar(Root+".Value.Unit", ".");
   ELSE
    L_MSO.wordSetVar(Root+".Value", L_Str.NumericStr(EDOrderL.ByPrc, 2));
    L_MSO.wordSetVar(Root+".Value.Unit", "%");
    L_MSO.wordSetMoneyVar(Root + ".Value.Sum", OnDate, WagePayL.Pay[EDOrderL.Class] * EDOrderL.ByPrc / 100);
   END;
   INC(Idx);
   NEXT(EDOrderL);
  END (*WHILE OCCURE(EDOrderL)*);
  L_MSO.wordSetVar("TheDoc.Delivery", "⤥ ஢");
  L_MSO.SetWordTable("manlist", Idx);
  L_MSO.wordSetVar("EDOKind.Name", Str.Small(EDOKind.RegName[0] + EDOKind.RegName[1]));
  L_MSO.wordSetVar("TheDoc.Delivery", "⤥ ஢");
  L_MSO.wordSetVar("comb_ExtraFooter", E_comb_ExtraFooter(EDOrder.PrpDate));
 END {Prepare_Combining};

 PRIVATE PROCEDURE cp_CPI(): SCAL[2];
 BEGIN
  L_General.Assert(~NEXT(EDOrderL), "ਪ   ᮭ   ᮤঠ  ");
  RETURN 1;
 END {cp_CPI};

 PRIVATE PROCEDURE E_EDOGetSpecialTemplate(): STRING[];
  VAR
   Local       : PROC;
   TemplateName: STRING[];
 BEGIN
  TemplateName:="";
  Local       :=PROCREF(E_Staff.EDOGetSpecialTemplate);
  IF ~!Local THEN
   TemplateName:=Local();
  END;
  IF !TemplateName THEN
   IF    L_EDO.CanPrintAsT9() THEN
    TemplateName:=L_EDO.tn_T9_10;
   ELSIF L_EDO.CanPrintAsT11a() THEN
    TemplateName:=L_EDO.tn_T11a;
   ELSIF L_EDO.CanPrintAsTForm(L_EDO.grp_ChangePersonalInfo, PROCREF(cp_CPI)) THEN
    TemplateName:=L_EDO.tn_CPI;
   END;
  END; (* IF !TemplateName *)
  RETURN TemplateName;
 END {E_EDOGetSpecialTemplate};

 PUBLIC PROCEDURE Prepare_ChangePersonalInfo(OnDate: DATE);
  CONST
   Preffix = "EDOrder.EDOrderL.Staff";
  VAR
   Cause,
   OldManName,
   NewManName: STRING[];
 BEGIN
  L_MSO.wordSetVarsByFile("EDOrder");
  CONFORM(EDOrder, EDOSrc);
  L_MSO.wordSetVarsByFile_wAlias("EDOSrc", "EDOrder.EDOSrc");
  SELECT(EDOrderL, EDOrder, , EDOrder.EDOrder);
  CONFORM(EDOrderL, Staff);
  L_Staff.StaffFileFamily(EDOL_Date(), Math.Max(EDOL_Date(), Staff.BegDate), Preffix);

  NewManName:=P_EDOL.GetEDOLProStrong(EDOrderL.EDOrder, EDOrderL.Row, P_EDOL.P_PersonalInfo, 01);
  L_EDO.GetEDOLPropValue(P_EDOL.P_CauseEntry, Cause);
  L_General.CallUs(SELECT(EDOLC, edcType, EDOrderL.EDOrder, EDOrderL.Row, L_EDO.edoct_Initial));
  CONFORM(EDOLC, EDOCause);
  Cause     :=EDOCause.Name + "  " + L_Prop.getRecordElement(Cause, 0) + "  " + L_Prop.getRecordElement(Cause, 1) + " 뤠 " + L_Prop.getRecordElement(Cause, 3) + " " + L_Prop.getRecordElement(Cause, 2);
  OldManName:=P_EDOL.GetEDOLProStrong(EDOrderL.EDOrder, EDOrderL.Row, P_EDOL.P_PersonalInfo, 00);
  L_MSO.SetValueDerivativesOnDate(Preffix + ".Man.OldName", OldManName, "SetManNameVar", OnDate);
  L_MSO.SetValueDerivativesOnDate(Preffix + ".Man.NewName", NewManName, "SetManNameVar", OnDate);
  L_MSO.wordSetVar(Preffix + ".TSN",          EDOrderL.TSN);
  L_MSO.wordSetVar("EDOrder.EDOrderL.Cause", Cause);
 END {Prepare_ChangePersonalInfo};

 PUBLIC PROCEDURE Print(_PrintMode: tPrintMode);
  CONST
   RepName = "EDOrd";
  VAR
   Local   : PROC;
   OnDate  : DATE;
   _MaxCopi: NUMERIC[0];
 BEGIN
  L_General.Assert(ACCESS(EDOrder), " ⠭ ਪ  ᮭ");
  L_AR.GrantRightsUnconditionally();
  PrintMode:=_PrintMode;
  SETEMPTY(TemplateName);
  IF PrintMode # pm_Notice THEN
   TemplateName:=E_EDOGetSpecialTemplate();
   IF !TemplateName & L_EDO.E_UseDefaultEDOrderTemplate(SYSDATE()) THEN
    TemplateName:=L_EDO.tn_Standart;
   END;
  END;
  IF ~!TemplateName THEN
   UseWord     :=1;
  ELSE
   UseWord     :=0;
   TemplateName:=L_EDO.tn_NoTemplate;
  END; (* IF ~!TemplateName... *)

  IF ~!EDOrder.Date THEN
   OnDate:=EDOrder.Date;
  ELSE
   OnDate:=EDOrder.PrpDate;
  END;
  CONFORM(EDOrder, EDOSrc);
  IF PrintMode = pm_Original THEN
   _MaxCopi:=EDOSrc.MaxCopi;
  ELSE
   _MaxCopi:=1;
  END;
  IF _MaxCopi > 1 THEN
   LOOP
    STDFORM(L_StdFrm.sf_Choice("|⢮  ஢ (ᨬ "+L_Str.IntStr(EDOSrc.MaxCopi)+") %##%",
                               "%L<0>I"),
            " ਪ  ", INFORM, , _MaxCopi);
    IF _MaxCopi > 0 THEN
     IF _MaxCopi > EDOSrc.MaxCopi THEN
      L_StdFrm.RedInform(" ⢮  ஢|ॢ蠥 ᨬ쭮 ⨬");
     ELSE
      EXIT;
     END;
    ELSE
     L_StdFrm.RedInform("⢮  ஢    㫥");
    END;
   END; (* LOOP *)
  END;
  IF UseWord THEN
   L_MSO.wordInitDocument(OnDate);
   P_Firm.SetMyFirmDefaultData(EDOrder.MyFirm, OnDate, "");
   IF    TemplateName = L_EDO.tn_T11a THEN
    Prepare_T11a(OnDate);
   ELSIF TemplateName = L_EDO.tn_T11x THEN
    Prepare_T11x(OnDate);
   ELSIF TemplateName = L_EDO.tn_T9_10 THEN
    Prepare_T9_10(OnDate);
   ELSIF TemplateName = L_EDO.tn_Combining THEN
    Prepare_Combining(OnDate);
   ELSIF TemplateName = L_EDO.tn_CPI THEN
    Prepare_ChangePersonalInfo(OnDate);
   ELSE
    Prepare_Standart(OnDate);
   END;
   Local:=PROCREF(E_Staff.EDOSpecialPrepare);
   IF ~!Local THEN
    Local(OnDate, TemplateName);
   END;
   IF PrintMode = pm_Original THEN
    L_MSO.MakeWordDocument(TemplateName, _MaxCopi, L_MSO.PrpResult_Original, "");
   ELSE
    L_MSO.MakeWordDocument(TemplateName, _MaxCopi, L_MSO.PrpResult_Preview, "");
   END;
  ELSE
   IF PrintMode = pm_Original THEN
    OPENREP(R, L_General.NameConnection(RepName), Print);
   ELSE
    OPENREP(R, L_General.NameConnection(RepName), Create);
   END;
   PageNumInCopy:=0;
   WHILE _MaxCopi > 0 DO
    Prepare_Standart(OnDate);
    PageNumInCopy:=L_PagePr.PagePr_CurrentPage()-1;
    DEC(_MaxCopi);
   END;
   IF (PrintMode # pm_Original) THEN
    L_General.SurveyLastReport();
   END;
  END;
 END {Print};

 PRIVATE PROCEDURE CheckLeaved();
  VAR
   List: STRING[];
   Few : SCAL[2];
   D   : DATE;
 BEGIN
  IF ~!EDOrder.Date THEN
   D:=EDOrder.Date;
  ELSE
   D:=SYSDATE();
  END;
  List:="";
  Few:=0;
  CONFORM(EDOrder, EDOrderL);
  WHILE OCCURE(EDOrderL) DO
   CONFORM(EDOrderL, Staff);
   IF ~L_Staff.rInState(D) THEN
    IF ~!List THEN
     Few:=1;
     List:=List+"|";
    END;
    CONFORM(Staff, Man);
    List:=List+Staff.TSN+" "+FLDTOSTR(Man.Name, "", 48);
   END;
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
  IF ~!List THEN
   L_StdFrm.Question(List+"||"+L_Str.PoolItem(" ⮨| ", Few)+"    "+L_DatTim.DateStr(D));
  END;
 END {CheckLeaved};

 PUBLIC PROCEDURE PrintForSignature();
 BEGIN
  L_General.Assert(ACCESS(EDOrder), " ⠭ ਪ  ᮭ");
  L_EDO.EDO_MayModify(0);
  CheckLeaved();
  L_StdFrm.Choice("ਪ 㤥 뢥  .|ᯮ ⮢ , ᫨  ⮫쪮   ");
  INC(EDOrder.CopyCnt);
  EDOrder.State:=1;
  REPLACE(EDOrder);
  LIKEMENU(CALL, "EDOPrint.Print("+L_Str.IntStr(pm_Original)+")");
 END {PrintForSignature};

 PUBLIC PROCEDURE PrintForPreview();
 BEGIN
  Print(pm_Preview);
 END {PrintForPreview};

 PUBLIC PROCEDURE PrintForNotice();
 BEGIN
  Print(pm_Notice);
 END {PrintForNotice};

END.
