(*
%Copyright   (c) Polak Computer System
%Author      14.01.1999 17:10:18 SAN
%Purpose     ஫ 䨪樨 EDOrder
%Type        control
%Specific    SYS
%Modified    25.06.2014 18:12:39 POLAK\LDA
%Environment
*)

 MODULE EDOrder [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_APtm, L_Events, L_DatTim, L_EDO, L_Staff, L_WDO,
        L_PRoll, L_StdFrm, L_Str, L_XDoc, P_Firm, Str, Math, L_MSO, L_Man,
        E_Staff, P_EDOL, L_AR, L_AcsPnt, L_XDF, L_OwnData, L_AFM, L_SysLog, L_Env;

 PRIVATE PERMANENT VAR
  EDOrderToPos: LIKE(EDOrder.EDOrder);

 PUBLIC PROCEDURE MakeCorEDOrder();
  VAR
   _MEDOrder: LIKE(EDOrder.EDOrder);
   EDOrders : LIKE(EDOrder.EDOrder)[100];
   List     : STRING[];
   Count,
   Choice   : NUMERIC[0];
 BEGIN
  L_General.Assert(ACCESS(EDOrder), " ⠭ ਪ");
  L_General.Assert(EDOrder.State = L_EDO.st_ordSigned, "쪮  ᠭ ਪ");
  _MEDOrder:=EDOrder.EDOrder;
  SETEMPTY(List, EDOrders);
  Count:=0;
  SELECT(EDOrder, MEDOrder, , _MEDOrder);
  WHILE OCCURE(EDOrder) DO
   IF (EDOrder.Closed = L_DatTim.Per(SYSDATE())) &
      ((EDOrder.State = L_EDO.st_ordPrepared) |
       (L_EDO.E_EDO_Level(EDOrder.PrpDate) = 0) & (EDOrder.State = L_EDO.st_ordPrinted)) THEN
    EDOrders[Count]:=EDOrder.EDOrder;
    List:=List + Str.Align("३  饬 ਪ " +
                           EDOrder.EDOrder + " " + EDOrder.SrcNum + EDOrder.About, 72, LEFT) + "|";
    INC(Count);
   END;
   NEXT(EDOrder);
  END; (* WHILE OCCURE(EDOrder) ... *)
  List:=List + "ନ஢  ਪ  |";
  Choice:=L_StdFrm.ShowListAsMenu(List, "");
  IF Choice < Count THEN
   SEARCH(EDOrder, EDOrder, , EDOrders[Choice]);
  ELSE
   SEARCH(EDOrder, EDOrder, , _MEDOrder);
   EDOrder.About:="   ਪ " + L_EDO.EDOrderName();
   SETEMPTY(EDOrder.EDOrder, EDOrder.SrcNum, EDOrder.Date);
 
   EDOrder.MEDOrder:=_MEDOrder;
   EDOrder.PrpDate :=SYSDATE();
   EDOrder.Closed  :=L_DatTim.Per(EDOrder.PrpDate);
   EDOrder.CopyCnt :=0;
   EDOrder.State   :=L_EDO.st_ordPrepared;
   INSERT(EDOrder);
   EDOrder_OnAfterInsert();
  END;
  L_APtm.SetUserDefinedCurDate(SYSDATE());
  EDOrderToPos:=EDOrder.EDOrder;
 END {MakeCorEDOrder};

 PUBLIC PROCEDURE PositionOnEDO();
 BEGIN
  L_General.CallUs(L_General.VariableIsInitialized(EDOrderToPos));
  L_General.CallUs(SEARCH(EDOrder, EDOrder, EDOrderToPos));
  SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), EDOrder);
 END {PositionOnEDO};

 PUBLIC PROCEDURE PositionOnEDO_InEDOrder1();
 BEGIN
  L_General.CallUs(L_General.VariableIsInitialized(L_EDO.curEDOrder));
  L_General.CallUs(SEARCH(EDOrder, EDOrder, L_EDO.curEDOrder));
  L_WDO.InstallPermanentFilter("(EDOrder.EDOSrc="+EDOrder.EDOSrc+")");
  SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), EDOrder);
 END {PositionOnEDO_InEDOrder1};

 PUBLIC PROCEDURE gbo_JumpToEDOrderWindow();
 BEGIN
  IF L_EDO.gbo_SetCurrentEDOrder() THEN
   CONFORM(EDOrder, EDOSrc);
   L_EDO.PassAccessPoint(EDOSrc.apMEDO);
   LIKEMENU(View, "EDOrder1 1", CALL, "EDOrder.PositionOnEDO_InEDOrder1()");
  ELSE
   L_StdFrm.RedInform("    ਪ");
  END;
 END {gbo_JumpToEDOrderWindow};

 PRIVATE PROCEDURE Shift(Dir: NUMERIC[0]);
  VAR
   PrevEDOrderClosed: DATE;
 BEGIN
  L_General.Assert(ACCESS(EDOrder), " । ਪ");
  L_SysLog.SingleMark_Init("EDOrder");
  PrevEDOrderClosed:=EDOrder.Closed;
  EDOrder.Closed:=L_DatTim.IncMonth(EDOrder.Closed, Dir);
  REPLACE(EDOrder);
  CONFORM(EDOrder, EDOrderL);
  WHILE OCCURE(EDOrderL) DO
   PROMPT(EDOrderL.TSN);
   EDOrderL.Closed:=EDOrder.Closed;
   REPLACE(EDOrderL);
   IF L_EDO.HasAffectOnPayRoll() THEN
    CONFORM(EDOrderL, Staff);
    L_PRoll.ShtDone_AP(Math.Min(PrevEDOrderClosed, EDOrder.Closed), 0);
   END;
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
  L_XDoc.Jrn_Mark(L_XDoc.curXDocId(L_XDoc.xdt_EDOrder), L_XDoc.action_AutoEdit);
  L_SysLog.SingleMark_Done("EDOrder");
 END {Shift};

 PRIVATE PROCEDURE ChoiceEDOGrp();
  CONST
   All=MAXOF(LIKE(EDOGrp.EDOGrp)) + 1;
  VAR
   UserChoice: STRING[];
   i         : NUMERIC[0];
   _EDOGrpArr: LIKE(EDOSrc.EDOSrc)[All];
 BEGIN
  IF !EDOrder.EDOGrp THEN
   UserChoice:="";
   i:=0;
   SELECT(EDOGrp, EDOGrp);
   WHILE OCCURE(EDOGrp) DO
    UserChoice:=UserChoice + "|" + EDOGrp.Name;
    _EDOGrpArr[i]:=EDOGrp.EDOGrp;
    INC(i);
    NEXT(EDOGrp);
   END; (* WHILE OCCURE(EDOGrp)... *)
   i:=L_StdFrm.ShowListAsMenu(UserChoice, "㯯 ਪ");
   L_General.CallUs(SEARCH(EDOGrp, EDOGrp, _EDOGrpArr[i]));
  ELSE
   CONFORM(EDOrder, EDOGrp);
  END;
  L_EDO.curEDOGrp:=EDOGrp.EDOGrp;
 END {ChoiceEDOGrp};

 PRIVATE PROCEDURE Setup_EDOrder_SrcNum();
 BEGIN
  RTI.Get().CurZone.Fields("EDOrder.SrcNum").Modifiable:=~L_EDO.IsAutoNumeratedEDOrder();
 END {Setup_EDOrder_SrcNum};

 PRIVATE PROCEDURE EDOrder_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow      ().OnOpenWindow:=1;
  L_WDO.iZone        (1).Narrowing:="(EDOrder.Closed=Memo.MonthB)&(EDOrder.EDOSrc=EDOSrc.EDOSrc)";
  L_WDO.iSubwindow   (1, "EDOrderE");
  L_WDO.iZone        (2).ViewOnly:=1;
 END {EDOrder_OnInitializeWindow};

 PRIVATE PROCEDURE EDOrder_OnOpenWindow();
  VAR
   Filter: STRING[];
   SrcCnt: NUMERIC[0];
 BEGIN
  L_EDO.GetEDOSrcPermanentFilter(L_EDO.ot_EDO, Filter, SrcCnt);
  L_General.Assert(SrcCnt > 0, " 筨 ਪ,  ᬮ     ");
  RTI.Get().CurWindow.Zones(2).PermanentFilter:=Filter;

  IF (SrcCnt = 1) & (RTI.Get().CurZone.Number = 2) THEN
   LIKEMENU(View, RTI.Get().CurWindow.Name +" 1");
  END;
 END {EDOrder_OnOpenWindow};

 PRIVATE PROCEDURE EDOrder_OnBeforeInsert();
 BEGIN
  CONFORM(EDOrder, EDOSrc);
  L_EDO.PassAccessPoint(EDOSrc.apMEDO);
  EDOrder.MyFirm:=P_Firm.DefineMyFirm();
  EDOrder.PrpDate:=Memo.ud_cd();
  REPLACE(EDOrder);
  Setup_EDOrder_SrcNum();
  L_WDO.cField("EDOrder.EDOGrp").Modifiable:=1;
 END {EDOrder_OnBeforeInsert};

 PRIVATE PROCEDURE EDOrder_OnBeforeEdit();
 BEGIN
  CONFORM(EDOrder, EDOSrc);
  L_EDO.PassAccessPoint(EDOSrc.apMEDO);
  L_EDO.EDO_MayModify(0);
  RTI.Get().CurZone.Fields("EDOrder.EDOGrp").Modifiable:=!EDOrder.MEDOrder;
 END {EDOrder_OnBeforeEdit};

 PRIVATE PROCEDURE CheckEDOGroup();
 BEGIN
  IF ~!EDOrder.EDOGrp THEN
   CONFORM(EDOrder, EDOGrp);
   SELECT(EDOrderL, EDOrder, , EDOrder.EDOrder);
   WHILE OCCURE(EDOrderL) DO
    PROMPT(EDOrderL.Row + " " + EDOrderL.TSN);
    L_General.Assert(EDOrderL.EDOGrp = EDOGrp.EDOGrp, "᫨  ਪ 㪠 㯯 ਪ,"+
                     "|  ப ਪ ⨬ ਬ 㣨 㯯 ਪ");
    NEXT(EDOrderL);
   END; (* WHILE OCCURE(EDOrderL) ... *)
  END;
 END {CheckEDOGroup};

 PRIVATE PROCEDURE CheckContinuousNumbering();
  VAR
   curRow: LIKE(EDOrderL.Row);
 BEGIN
  IF !EDOrder.MEDOrder THEN
   curRow:=1;
   CONFORM(EDOrder, EDOrderL);
   WHILE OCCURE(EDOrderL) DO
    L_General.Assert(curRow = EDOrderL.Row, "㬥 ப ਪ   ᫥⥫쭠 ( ப "+curRow +")");
    INC(curRow);
    NEXT(EDOrderL);
   END; (* WHILE OCCURE(EDOrderL) ... *)
  END;
 END {CheckContinuousNumbering};

 PRIVATE PROCEDURE EDOrder_OnAfterEdIns();
 BEGIN
  CheckEDOGroup();
  CheckContinuousNumbering();
 END {EDOrder_OnAfterEdIns};

 PRIVATE PROCEDURE EDOrder_OnAfterInsert();
 BEGIN
  EDOrder_OnAfterEdIns();
  IF L_EDO.E_EDO_Level(EDOrder.PrpDate) = 0 THEN
   EDOrder.State:=L_EDO.st_ordPrinted;
   REPLACE(EDOrder);
  END;
 END {EDOrder_OnAfterInsert};

 PRIVATE PROCEDURE EDOrder_OnAfterEdit();
 BEGIN
  EDOrder_OnAfterEdIns();
 END {EDOrder_OnAfterEdit};

 PRIVATE PROCEDURE EDOrder_OnBeforeDelete();
 BEGIN
  L_EDO.EDO_MayModify(0);
  L_General.Assert(~SELECT(EDOrderL, EDOrder, EDOrder.EDOrder), "ਪ  ");
 END {EDOrder_OnBeforeDelete};

 PRIVATE PROCEDURE EDOrder_PrpDate_OnSuccessfulChange();
 BEGIN
  Setup_EDOrder_SrcNum();
  SELECT(EDOLC, EDOrder, , EDOrder.EDOrder);
  WHILE OCCURE(EDOLC) DO
   CONFORM(EDOLC, EDOCause);
   L_General.Assert(L_DatTim.IsActive(EDOrder.PrpDate, EDOCause.Begin, EDOCause.Till),
                    "Cப ਪ " + EDOLC.Row + ":" +
                    "|᭮ " + EDOCause.EDOCause + "    " + L_DatTim.DateStr(EDOrder.PrpDate));
   NEXT(EDOLC);
  END;
 END {EDOrder_PrpDate_OnSuccessfulChange};

 PRIVATE PROCEDURE XDocKind_SetFormat();
  VAR
   _XDocType: L_XDoc.tXDocType;
   flagEdit : SCAL[2];
   Fields   : FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit) |
     (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert) THEN
   IF !Fields("v_DocType").Value THEN
    flagEdit:=0;
   ELSE
    _XDocType:=L_Str.PoolItem(L_EDO.edocxdt_XDocTypes(EDOCause.Type), Fields("v_DocType").Value);
    flagEdit :=_XDocType = L_XDoc.xdt_ODoc;
   END;
   Fields("EDOCause.XDocKind").Modifiable:=flagEdit;
   IF flagEdit THEN
    IF (_XDocType = L_XDoc.xdt_ODoc) THEN
     Fields("EDOCause.XDocKind").OwnerWindowOriginalName:="ODocKind";
     Fields("EDOCause.XDocKind").OwnerZoneNumber        :=1;
     Fields("EDOCause.XDocKind").AskMode                :=1;
    ELSE
     SETEMPTY(Fields("EDOCause.XDocKind").OwnerWindowOriginalName);
    END;
   END;
  END;
 END {XDocKind_SetFormat};

 PRIVATE PROCEDURE EDOCause_XDocKind_OnAskPhase1();
  VAR
   _XDocType: L_XDoc.tXDocType;
 BEGIN
  _XDocType:=L_Str.PoolItem(L_EDO.edocxdt_XDocTypes(EDOCause.Type), RTI.Get().CurZone.Fields("v_DocType").Value);
  IF (_XDocType = L_XDoc.xdt_ODoc) THEN
   IF ~!EDOCause.XDocKind & SEARCH(ODocKind, ODocKind, EDOCause.XDocKind) THEN
    SE_WZD_POSITION(RTI.Get().TrgWindow.Name, RTI.Get().TrgZone.Number, ODocKind);
   END;
  END;
 END {EDOCause_XDocKind_OnAskPhase1};

 PRIVATE PROCEDURE EDOCause_XDocKind_OnAskPhase2();
  VAR
   _XDocType: L_XDoc.tXDocType;
 BEGIN
  _XDocType:=L_Str.PoolItem(L_EDO.edocxdt_XDocTypes(EDOCause.Type), RTI.Get().CurZone.Fields("v_DocType").Value);
  IF (_XDocType = L_XDoc.xdt_ODoc) THEN
   EDOCause.XDocKind:=ODocKind.ODocKind;
   REPLACE(EDOCause);
   RTI.Get().CurZone.Fields("v_DocKindStr").Value:=ODocKind.Name;
  END;
 END {EDOCause_XDocKind_OnAskPhase2};

 PRIVATE PROCEDURE XDocType_SetFormat();
  VAR
   Pool: STRING[];
 BEGIN
  IF ACCESS(EDOCause) THEN
   IF ~!EDOCause.Type THEN
    Pool:=L_EDO.edocxdt_FullNames(EDOCause.Type);
    RTI.Get().CurZone.Fields("v_DocType").Format:=Pool;
   END;
   RTI.Get().CurZone.Fields("v_DocType").Modifiable:=~!EDOCause.Type;
   XDocKind_SetFormat();
  END;
 END {XDocType_SetFormat};

 PRIVATE PROCEDURE EDOCE_0_OnReposition();
 BEGIN
  IF !EDOCause.Type | !EDOCause.XDocType THEN
   SETEMPTY(RTI.Get().CurZone.Fields("v_DocType").Value);
  ELSE
   RTI.Get().CurZone.Fields("v_DocType").Value:=L_Str.PositionInPool(L_EDO.edocxdt_XDocTypes(EDOCause.Type),
                                                                     EDOCause.XDocType);
  END;
  XDocType_SetFormat();
  XDocKind_SetVideoVar();
 END {EDOCE_0_OnReposition};

 PRIVATE PROCEDURE EDOCE_0_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("EDOCause.Type").Format:=L_EDO.edoctPool;
 END {EDOCE_0_OnZoneOpen};

 PRIVATE PROCEDURE EDOCause_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "EDOCE");
  L_WDO.iField       (1, "EDOCause.Type").Format:=L_EDO.edoctPool;
  L_WDO.iProgs       (1, "EDOrder");
 END {EDOCause_OnInitializeWindow};

 PRIVATE PROCEDURE EDOCause_Type_OnSuccessfulChange();
 BEGIN
  SETEMPTY(RTI.Get().CurZone.Fields("v_DocType").Value, EDOCause.XDocKind, RTI.Get().CurZone.Fields("v_DocKindStr").Value);
  REPLACE(EDOCause);
  XDocType_SetFormat();
 END {EDOCause_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE XDocKind_SetVideoVar();
  VAR
   _XDocType: L_XDoc.tXDocType;
 BEGIN
  SETEMPTY(RTI.Get().CurZone.Fields("v_DocKindStr").Value);
  IF ~!RTI.Get().CurZone.Fields("v_DocType").Value THEN
   _XDocType:=L_Str.PoolItem(L_EDO.edocxdt_XDocTypes(EDOCause.Type), RTI.Get().CurZone.Fields("v_DocType").Value);
   IF (_XDocType = L_XDoc.xdt_ODoc) THEN
    IF ~!EDOCause.XDocKind & SEARCH(ODocKind, ODocKind, EDOCause.XDocKind) THEN
     RTI.Get().CurZone.Fields("v_DocKindStr").Value:=ODocKind.Name;
    END;
   ELSIF EDOCause.XDocKind = L_XDoc.EmptyXDocKind THEN
    RTI.Get().CurZone.Fields("v_DocKindStr").Value:=" ᯮ";
   END;
  END;
 END {XDocKind_SetVideoVar};

 PRIVATE PROCEDURE EDOCause_v_DocType_OnSuccessfulChange();
  VAR
   _XDocType: L_XDoc.tXDocType;
 BEGIN
  IF ~!RTI.Get().CurZone.Fields("v_DocType").Value THEN
   _XDocType:=L_Str.PoolItem(L_EDO.edocxdt_XDocTypes(EDOCause.Type), RTI.Get().CurZone.Fields("v_DocType").Value);
   IF (_XDocType = L_XDoc.xdt_ODoc) THEN
    SETEMPTY(EDOCause.XDocKind);
   ELSE
    EDOCause.XDocKind:=L_XDoc.EmptyXDocKind;
   END;
  ELSE
   SETEMPTY(EDOCause.XDocKind);
  END;
  REPLACE(EDOCause);
  XDocType_SetFormat();
  XDocKind_SetVideoVar();
 END {EDOCause_v_DocType_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOCause_XDocKind_OnSuccessfulChange();
 BEGIN
  XDocKind_SetVideoVar();
 END {EDOCause_XDocKind_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOCause_OnAfterEdIns();
 BEGIN
  IF ~!EDOCause.Type & ~!RTI.Get().CurZone.Fields("v_DocType").Value THEN
   EDOCause.XDocType:=L_Str.PoolItem(L_EDO.edocxdt_XDocTypes(EDOCause.Type),
                                     RTI.Get().CurZone.Fields("v_DocType").Value);
  ELSE
   SETEMPTY(EDOCause.XDocType);
  END;
  REPLACE(EDOCause);
 END {EDOCause_OnAfterEdIns};

 PRIVATE PROCEDURE EDOCause_OnAfterEdit();
 BEGIN
  EDOCause_OnAfterEdIns();
 END {EDOCause_OnAfterEdit};

 PRIVATE PROCEDURE EDOCause_OnAfterInsert();
 BEGIN
  EDOCause_OnAfterEdIns();
 END {EDOCause_OnAfterInsert};

 PRIVATE PROCEDURE EDOGrp_OnBeforeInsert();
 BEGIN
  L_General.Error("⠢ 㯯  ਪ 饭");
 END {EDOGrp_OnBeforeInsert};

 PRIVATE PROCEDURE EDOGrp_OnBeforeDelete();
 BEGIN
  L_General.Error(" 㯯  ਪ 饭");
 END {EDOGrp_OnBeforeDelete};

 PRIVATE PROCEDURE GetPrepareProc(): PROC;
  VAR
   ProcName: STRING[];
 BEGIN
  ProcName:=MSODL.Proc;
  IF !ProcName THEN
   ProcName:=MSODL.Template;
  END;
  RETURN PROCREF(^ProcName);
 END {GetPrepareProc};

 PRIVATE PROCEDURE GetEDOderDocDate(DateDef: STRING[]): DATE;
  VAR
   Result: DATE;
 BEGIN
  IF    DateDef = "EDOrderL.OcrDate" THEN
   Result:=EDOrderL.OcrDate;
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {GetEDOderDocDate};

 PRIVATE PROCEDURE DefineFullDocList();
  VAR
   addDocProc: PROC;
 BEGIN
  IF EDOrderL.EDOGrp = L_EDO.grp_BusinessTrip THEN
   L_MSO.dl_AddDoc("㦥  (-10)", "T10a", "", "EDOrderL.OcrDate");
  END;
  addDocProc:=PROCREF(E_Staff.EDOrderL_DefineAdditionalDocList);
  IF ~!addDocProc THEN
   addDocProc();
  END;
 END {DefineFullDocList};

 PRIVATE PROCEDURE EDOCauses(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="";
  SELECT(EDOLC, edcType, , EDOrderL.EDOrder, EDOrderL.Row);
  WHILE OCCURE(EDOLC) DO
   IF ~!Result THEN
    Result:=Result + "; ";
   END;
   CONFORM(EDOLC, EDOCause);
   Result:=Result + EDOCause.Name;
   IF ~!EDOLC.XDocId THEN
    Result:=Result + " (" + L_XDoc.XDocStr(EDOLC.XDocId) + ")";
   END;
   NEXT(EDOLC);
  END; (* WHILE OCCURE(EDOLC) ... *)
  RETURN Result;
 END {EDOCauses};

 PRIVATE PROCEDURE T10a();
  VAR
   BossName,
   trgFundingSource,
   trgDestination,
   trgPurpose    : STRING[];
   BossSort      : LIKE(Officer.Sort);
   BossOfficer   : LIKE(Officer.Officer);
 BEGIN
  L_EDO.GetEDOLPropValue(P_EDOL.P_Destination,   trgDestination);
  L_EDO.GetEDOLPropValue(P_EDOL.P_Purpose,       trgPurpose);
  L_EDO.GetEDOLPropValue(P_EDOL.P_FundingSource, trgFundingSource);
  L_MSO.wordSetVar("EDOrderL.CalendarDays",  L_Str.IntStr(EDOrderL.EndDate-EDOrderL.OcrDate+1));
  L_MSO.wordSetVar("EDOrderL.Destination",   trgDestination);
  L_MSO.wordSetVar("EDOrderL.Purpose",       trgPurpose);
  L_MSO.wordSetVar("EDOrderL.FundingSource", trgFundingSource);
  L_MSO.wordSetVar("EDOrderL.Cause",         EDOCauses());

  L_Staff.GetDepartBossOfficer(Officer.Sort, Officer.Officer, BossSort, BossOfficer);
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH(Officer, Officer, , BossSort, BossOfficer);
   CONFORM(Officer, Post);
   L_MSO.wordSetVar("Staff.Boss.Post.Name", Post.Name);

   SETEMPTY(BossName);
   SELECT(StaffLog, Officer, , BossSort, BossOfficer);
   WHILE OCCURE(StaffLog) & !BossName DO
    IF L_Staff.InOrder(EDOrderL.OcrDate) & ~L_Staff.IsDischargeStaffLog() THEN
     CONFORM(StaffLog, Staff);
     CONFORM(Staff, Man);
     BossName:=Man.Name;
    END; (* IF ... *)
    NEXT(StaffLog);
   END; (* WHILE OCCURE(StaffLog) ... *)
   L_MSO.wordSetVar("Staff.Boss.Name.Short", L_Str.ShortName(BossName));
  EXCEPT
  END; (* TRY *)
 END {T10a};

 PRIVATE PROCEDURE PrepareEDOrderObjects(D: DATE; ProcName: PROC);
 BEGIN
  L_MSO.wordSetVar("TheDoc.InternalNumber", EDOrder.EDOrder);
  CONFORM(EDOrderL, Staff);
  CONFORM(Staff, Man);
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  CONFORM(StaffLog, Officer);
  P_Firm.SetFirmDefaultData("Own", L_Staff.GetFirmOfStaff(), D, "");
  L_Staff.StaffFileFamily(EDOrderL.OcrDate, EDOrderL.OcrDate, "Staff");
  L_MSO.wordSetVarsByFile("Man");
  L_MSO.wordSetVarsByFile("EDOrder");
  L_MSO.wordSetVarsByFile("EDOrderL");

  IF ~!ProcName THEN
   ProcName();
  END;
 END {PrepareEDOrderObjects};

 PRIVATE PROCEDURE MakeDoc(PrpMode: L_MSO.PrpModeType);
  VAR
   docD           : DATE;
   wGrantAllRights: SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(EDOrder), " ⠭ ਪ");
  L_General.Assert(ACCESS(EDOrderL), " ⠭ ப ਪ");
  DefineFullDocList();
  L_MSO.dl_SelectDoc(PrpMode);
  docD:=GetEDOderDocDate(MSODL.DateDef);
  wGrantAllRights:=MSODL.IsLocal;
  IF wGrantAllRights THEN
   L_AR.GrantRightsUnconditionally();
  END;
  L_MSO.wordInitDocument(docD);
  PrepareEDOrderObjects(docD, GetPrepareProc());
  L_MSO.UseTmpDot:=0;
  L_MSO.MakeWordDocument(MSODL.Template, 1, PrpMode, "");
 END {MakeDoc};

 PUBLIC PROCEDURE Print();
 BEGIN
  MakeDoc(L_MSO.PrpMode_Print);
 END {Print};

 PUBLIC PROCEDURE Print_InFile();
 BEGIN
  MakeDoc(L_MSO.PrpMode_ToDoc);
 END {Print_InFile};

 PRIVATE PROCEDURE EDOSrc_OnAfterModification();
  VAR
   Msg: STRING[];
 BEGIN
  SETEMPTY(Msg);
  IF    !EDOSrc.apVFO & !EDOSrc.apVEDO & !EDOSrc.apMFO & !EDOSrc.apMEDO THEN
   Msg:=" 祭  ᯥ樠 稩.|" +
        "ᬮ  䨪 ਪ ⨬ 筨 㯭 ⮫쪮  ";
  ELSE
   IF !EDOSrc.apMFO THEN
    Msg:=L_Str.AddStrDlm(Msg, "||") +
         " 祭 ᯥ樠 稩  䨪 ਪ  ᫥/㤥ঠ.|" +
         "䨪 ਪ 㯭 ⮫쪮  ";
   END;

   IF !EDOSrc.apVFO & !EDOSrc.apMFO THEN
    Msg:=" 祭 ᯥ樠 稩  ᬮ ਪ  ᫥/㤥ঠ.|" +
         "ਪ  ⮡ࠦ  ᯨ᪥ ⮫쪮  ";
   END;

   IF !EDOSrc.apMEDO THEN
    Msg:=L_Str.AddStrDlm(Msg, "||") +
         " 祭 ᯥ樠 稩  䨪 ਪ  ᮭ.|" +
         "䨪 ਪ 㯭 ⮫쪮  ";
   END;

   IF !EDOSrc.apVEDO & !EDOSrc.apMEDO THEN
    Msg:=L_Str.AddStrDlm(Msg, "||") +
         " 祭 ᯥ樠 稩  ᬮ ਪ  ᮭ.|" +
         "ਪ  ⮡ࠦ  ᯨ᪥ ⮫쪮  ";
   END;
  END;
  IF ~!Msg THEN
   L_StdFrm.Question(Msg);
  END;
 END {EDOSrc_OnAfterModification};

 PRIVATE PROCEDURE EDOSrc_OnAfterInsert();
 BEGIN
  EDOSrc_OnAfterModification();
 END {EDOSrc_OnAfterInsert};

 PRIVATE PROCEDURE EDOSrc_OnAfterEdit();
 BEGIN
  EDOSrc_OnAfterModification();
 END {EDOSrc_OnAfterEdit};

 PRIVATE PROCEDURE EDOSrc_OnBeforeDelete();
 BEGIN
  SE_INTEGRITY(1);
  SEARCH(AcsPnt, AcsPnt, , EDOSrc.apVFO);
  SETEMPTY(EDOSrc.apVFO);
  REPLACE(EDOSrc);
  REMOVE(AcsPnt);
  SEARCH(AcsPnt, AcsPnt, , EDOSrc.apVEDO);
  SETEMPTY(EDOSrc.apVEDO);
  REPLACE(EDOSrc);
  REMOVE(AcsPnt);
  SEARCH(AcsPnt, AcsPnt, , EDOSrc.apMFO);
  SETEMPTY(EDOSrc.apMFO);
  REPLACE(EDOSrc);
  REMOVE(AcsPnt);
  SEARCH(AcsPnt, AcsPnt, , EDOSrc.apMEDO);
  SETEMPTY(EDOSrc.apMEDO);
  REPLACE(EDOSrc);
  REMOVE(AcsPnt);
 END {EDOSrc_OnBeforeDelete};

 PRIVATE PROCEDURE EDOrderE_0_OnReposition();
 BEGIN
  Setup_EDOrder_SrcNum();
 END {EDOrderE_0_OnReposition};

 PUBLIC PROCEDURE Sign();
 BEGIN
  ACCESS(EDOrder);
  L_General.Assert(EDOrder.State = L_EDO.st_ordPrinted, "쪮  ⯥⠭ ਪ");
  L_General.Assert(~!EDOrder.Date, " 㪠  ᠭ");
  CONFORM(EDOrder, EDOSrc);
  L_EDO.PassAccessPoint(EDOSrc.apMEDO);
  L_SysLog.SingleMark_Init("EDOrder");
  IF L_EDO.IsAutoNumeratedEDOrder() THEN
   IF ~!EDOrder.SrcNum THEN
    L_StdFrm.Choice("  ਪ  㤥   ⮬᪨ (७)");
   END;
   EDOrder.SrcNum:="#"+EDOrder.EDOrder;
   REPLACE(EDOrder);
  ELSE
   L_General.Assert(~!EDOrder.SrcNum, "  ");
  END;
  L_StdFrm.Choice("ਪ ᠭ " + L_DatTim.DateStr(EDOrder.Date));
  L_StdFrm.Choice("⬥⪠  ᠭ - ⨬ ⢨");
  L_StdFrm.Choice("⢨⥫쭮 ᠭ " + L_DatTim.DateStr(EDOrder.Date));
  EDOrder.State:=L_EDO.st_ordSigned;
  REPLACE(EDOrder);

  SELECT(EDOrderL, EDOrder, , EDOrder.EDOrder);
  WHILE OCCURE(EDOrderL) DO
   IF L_EDO.HasAffectOnPayRoll() THEN
    CONFORM(EDOrderL, Staff);
    L_EDO.ShtDoneFromEDOrderLClosed();
   END;
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
  L_SysLog.SingleMark_Done("EDOrder");
 END {Sign};

 PUBLIC PROCEDURE MoveEDOrderInNextMonth();
 BEGIN
  L_StdFrm.Choice("७ ਪ  ᫥騩 ?");
  Shift(+1);
 END {MoveEDOrderInNextMonth};

 PUBLIC PROCEDURE MoveEDOrderInPrevMonth();
 BEGIN
  L_StdFrm.Choice("७ ਪ  ।騩 ?");
  Shift(-1);
 END {MoveEDOrderInPrevMonth};

 PRIVATE PROCEDURE E_IsEDOrderL2Acquaintance(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF EDOrder.State = L_EDO.st_ordSigned THEN
   IF L_General.GetAPSiteNumber() = 10 THEN
    IF (EDOrderL.Closed >= 01\05\2012) & (EDOrderL.EDOGrp = L_EDO.grp_Violation) THEN
     Result:=1;
    END;
   END;
  END;
  RETURN Result;
 END {E_IsEDOrderL2Acquaintance};

 PRIVATE PROCEDURE IsAcquaintedEDorder(trgTSN: LIKE(Staff.TSN)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF SELECT(XDocFlow, XDocFlow, L_XDoc.curXDocId(L_XDoc.xdt_EDOrder)) THEN
   LOOP
    IF ~OCCURE(XDocFlow) THEN
     EXIT;
    ELSIF (XDocFlow.Action = L_XDF.a_Acquaint) & (XDocFlow.Author = trgTSN) THEN
     Result:=1;
     EXIT;
    END;
    NEXT(XDocFlow);
   END; (* LOOP *)
  END;
  RETURN Result;
 END {IsAcquaintedEDorder};

 PRIVATE PROCEDURE EDOrderLDescription(curXDocId: L_XDoc.tXDocId): STRING[];
  VAR
   ValueStr,
   Result: STRING[];
 BEGIN
  Result:="" + L_XDoc.Ref_ShortName(L_XDoc.ExtractXDocType(curXDocId)) + "" + Str.Align(EDOKind.Name, 30, LEFT) + "" + Str.Align(EDOrder.SrcNum, 8, RIGHT) + "" + L_DatTim.DateStr(EDOrder.Date) + "";
  IF EDOrderL.EDOGrp = L_EDO.grp_Violation THEN
   IF ~!EDOrderL.BySum & (EDOrderL.BySum # 0) THEN
    ValueStr:=Str.Align(L_Str.NumericStr(EDOrderL.BySum, 2), 17, RIGHT) + "";
   ELSIF ~!EDOrderL.ByPrc & (EDOrderL.ByPrc # 0) THEN
    ValueStr:=Str.Align(L_Str.NumericStr(EDOrderL.ByPrc, 1), 17, RIGHT) + "%";
   ELSE
    SETEMPTY(ValueStr);
   END;
   INC(Result, Str.Align(L_EDO.GetFixInPC_byStr(EDOrderL.EDOGrp, EDOrderL.FixInPC), 15, LEFT) + "" + ValueStr + "");
  END;
  RETURN Result;
 END {EDOrderLDescription};

 PUBLIC PROCEDURE ShowEDorderL2Acquaintance();
  VAR
   Caption,
   Bot,
   List,
   Ids,
   Rows     : STRING[];
   curXDocId: L_XDoc.tXDocId;
   Num,
   Cnt      : NUMERIC[0];
   oPrompt  : PROMPT_LINE;
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪   '⭨'");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  Caption:="Ŀ" + L_Str.CRLF +
           "       ਪ  ᮭ   .                   稭 ᪠" + L_Str.CRLF +
           "Ĵ";
  Bot    :="";
  LOOP
   oPrompt:=PROMPT_LINE.Create("⮢  ਪ");
   Cnt:=0;
   SETEMPTY(List, Ids, Rows);
   SETSEL(EDOrderL, TSN, Staff.TSN);
   SRCINSEL(EDOrderL, GE, , L_DatTim.IncMonth(SYSDATE(), -4));
   WHILE OCCURE(EDOrderL) DO
    PROMPT(L_DatTim.PeriodStr(EDOrderL.Closed) + ", " + EDOrderL.EDOKind);
    CONFORM(EDOrderL, EDOrder);
    CONFORM(EDOrderL, EDOKind);
    IF E_IsEDOrderL2Acquaintance() & ~IsAcquaintedEDorder(Staff.TSN) THEN
     curXDocId:=L_XDoc.curXDocId(L_XDoc.xdt_EDOrder);
     INC(Ids,  curXDocId    + "|");
     INC(Rows, EDOrderL.Row + "|");
     INC(List, EDOrderLDescription(curXDocId) + "|");
     INC(Cnt);
    END;
    NEXT(EDOrderL);
   END; (* WHILE OCCURE(EDOrderL) ... *)
   oPrompt  :=EMPTYOF(oPrompt);
   Num      :=L_StdFrm.ShowListAsMenu_wCaption(List, "롮 ਪ  ", Caption);
   curXDocId:=L_Str.PoolItem(Ids, Num);
   L_XDoc.PositionOnXDoc(curXDocId);
   TRY [TRANSACTION(TRANSACTION_SLAVE2)]
    XDocFlow.XDocId  :=curXDocId;
    XDocFlow.Executor:=L_General.curUSER;
    XDocFlow.Author  :=Staff.TSN;
    XDocFlow.Action  :=L_XDF.a_Acquaint;
    XDocFlow.SrcDate :=SYSDATE();
    XDocFlow.AuthKind:=L_XDF.ak_Internal;
    XDocFlow.SignDTS :=L_DatTim.GetSysTIMESTAMP();
    SETEMPTY(XDocFlow.TrgDate, XDocFlow.riDlv, XDocFlow.riAddr, XDocFlow.OnBehalf, XDocFlow.To, XDocFlow.RslTxt);
    INSERT(XDocFlow);
    L_General.CallUs(SEARCH(EDOrderL, EDOrder, EDOrder.EDOrder, L_Str.PoolItem(Rows, Num)));
    CONFORM(EDOrderL, EDOKind);
    L_StdFrm.Confirm(", , " + Staff.Name + ", ⢨⥫쭮   ਪ"  + L_Str.CRLF +
                     Caption + L_Str.CRLF +
                     EDOrderLDescription(curXDocId) + L_Str.CRLF +
                     Bot);
   EXCEPT
   END;
   IF Cnt = 1 THEN
    EXIT;
   END;
  END; (* LOOP *)
 END {ShowEDorderL2Acquaintance};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                   㬥, ॡ騥 ஢   ﭨ  ##########                  |
}
*)

(*
$P{ SubTop:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|ॡ   ###################################################################################|
|------------------------------------------------------------------------------------------------------------|
|஫쭠 |㬥                                            |⭨                              |
|---------------------------------------------------------------------|--------------------------------------|
}
*)

(*
$P{ Line:
XDF02.CDate, L, "D.N.y"
L_XDoc.extXDocStr(XDF02.XDocId, L_XDoc.xdast_wStatus), L, ""
Staff.TSN, L, ""
Man.Name, L, ""
@
|   ##########   |####################################################|##### ################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PUBLIC PROCEDURE XDF02();
  TYPE
   tTypeAcq = SCAL[2];
  CONST
   RepName = "XDF02";
   ta_Acquaint       = 0;
   ta_AcquaintElCopy = 1;
   ta_Pool = "㬥⮬|஭  㬥";
  VAR
   From,
   D         : DATE;
   trgSignDTS: LIKE(XDocFlow.SignDTS);
   trgAcsObj : LIKE(AcsObj.AcsObj);
 BEGIN
  D   :=Memo.ud_cd();
  From:=L_DatTim.IncMonth(D, -4);
  L_AFM.MakeMultipleIndex("XDF02", "XDocId : " + TYPENAMEOF(L_XDoc.tXDocId) + ";" +
                                   "TSN    : LIKE(Staff.TSN);" +
                                   "TypeAcq: " + TYPENAMEOF(tTypeAcq) + ";" +
                                   "CntDays: NUMERIC[0];" +
                                   "CDate  : DATE",
                          "XDF02 : TypeAcq, XDocId, TSN, CDate;" +
                          "ForRep: TypeAcq, CntDays, XDocId, TSN");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(" : " + Staff.TSN);
   IF L_Staff.rInState(D) THEN
    SETSEL(EDOrderL, TSN, Staff.TSN);
    SRCINSEL(EDOrderL, GE, , From);
    WHILE OCCURE(EDOrderL) DO
     PROMPT(" : " + Staff.TSN + " " + L_DatTim.PeriodStr(EDOrderL.Closed) + ", " + EDOrderL.EDOKind);
     CONFORM(EDOrderL, EDOrder);
     IF E_IsEDOrderL2Acquaintance() & ~IsAcquaintedEDorder(Staff.TSN) THEN
      ADD(XDF02, XDF02, , ta_Acquaint, L_XDoc.curXDocId(L_XDoc.xdt_EDOrder), Staff.TSN, EDOrder.Date,
                          XDF02.CntDays, -(D - EDOrder.Date));
     END;
     NEXT(EDOrderL);
    END; (* WHILE OCCURE(EDOrderL) ... *)

    CONFORM(Staff, Man);
    IF SELECT(AcsObj, Man, Man.Man) THEN
     trgAcsObj:=AcsObj.AcsObj;
     SETSEL(XDocFlow, To, trgAcsObj);
     LAST(XDocFlow);
     WHILE OCCURE(XDocFlow) & (XDocFlow.SrcDate >= From) DO
      PROMPT(" : " + Staff.TSN + " " + L_DatTim.TimestampStr(XDocFlow.SignDTS));
      IF (XDocFlow.Action = L_XDF.a_HandElCopy) &
         ~L_XDF.HasAcquaintElCopyByCurHandElCopy(XDocFlow.XDocId, trgAcsObj, trgSignDTS) THEN
       ADD(XDF02, XDF02, , ta_AcquaintElCopy, XDocFlow.XDocId, Staff.TSN, L_DatTim.GetDateOfTIMESTAMP(XDocFlow.SignDTS),
                           XDF02.CntDays, -(D - L_DatTim.GetDateOfTIMESTAMP(XDocFlow.SignDTS)));
      END;
      PREV(XDocFlow);
     END; (* WHILE OCCURE(XDocFlow) ... *)
    END;
   END; (* IF L_Staff.rInState(D) ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)

  IF ~SELECT(XDF02, ForRep) THEN
   L_StdFrm.Inform(" ﭨ  " + L_DatTim.DateStr(D) + "   㬥, ॡ饣 ஢ ");
  ELSE
   OPENREP(R, L_General.NameConnection(RepName), Create);
   L_XDoc.sl_Init("㬥, ॡ騥 ஢ ");
   MAKEPART(R, Top, RepName, D);
   WHILE OCCURE(XDF02) DO
    NARROWSEL(XDF02, TypeAcq);
    MAKEPART(R, SubTop, L_Str.PoolItem(ta_Pool, XDF02.TypeAcq));
    WHILE OCCURE(XDF02) DO
     PROMPT("㧪: " + XDF02.XDocId + " " + XDF02.TSN);
     L_General.CallUs(SEARCH(Staff, TSN, XDF02.TSN));
     CONFORM(Staff, Man);
     MAKEPART(R, Line);
     L_XDoc.PositionOnXDoc(XDF02.XDocId);
     L_XDoc.sl_AddCurrentXDoc(L_XDoc.ExtractXDocType(XDF02.XDocId));
     NEXT(XDF02);
    END; (* WHILE OCCURE(XDF02) ... *)
    NEXTINEXTENDEDSEL(XDF02, TypeAcq);
   END; (* WHILE OCCURE(XDF02) ... *)
   MAKEPART(R, Bot);
   L_XDoc.sl_Done();
  END;
 END {XDF02};

 PUBLIC PROCEDURE MakeEDOrderL();
 BEGIN
  ACCESS(EDOrder);
  IF !EDOrder.MEDOrder THEN
   ChoiceEDOGrp();
   LIKEMENU(Ins, "@");
  ELSE
   LIKEMENU(View, "MEDO 1", SC, "EDOrder.View_MEDO_1");
  END;
 END {MakeEDOrderL};

 PUBLIC PROCEDURE MakeCorEDOrderL();
 BEGIN
  L_General.Assert(ACCESS(EDOrder),  " ⠭ ⥪騩 ਪ");
  L_General.Assert(ACCESS(EDOrderL), " ⠭ ⥪ ப ਪ");
  L_General.Assert(EDOrderL.Type # L_EDO.type_Cancel,
                   "⬥騩 ਪ    ");
  SAVE(EDOrder);
  SAVE(EDOrderL);
  L_EDO.curEDOrder:=EDOrderL.EDOrder;
  L_EDO.curRow    :=EDOrderL.Row;
  L_General.Assert(~SEARCH(EDOrderL, EDOrder, EDOrder.EDOrder, L_EDO.curRow),
                   " 㭪 㦥 饭  ਪ  ");
  SELECT(EDOrder, MEDOrder, , L_EDO.curEDOrder);
  WHILE OCCURE(EDOrder) DO
   L_General.Assert(~SEARCH(EDOrderL, EDOrder, EDOrder.EDOrder, L_EDO.curRow),
                    "  ਪ, ४騩  㭪");
   NEXT(EDOrder);
  END; (* WHILE OCCURE(EDOrder) ... *)
  RESTORE(EDOrder);
  RESTORE(EDOrderL);
  L_General.CallUs(EDOrderL.Status # L_EDO.st_Canceled);

  L_EDO.SetCurrentEDOGrpByEDOrderL();
  LIKEMENU(Cancel, "", Ins, "@");
 END {MakeCorEDOrderL};

 PUBLIC PROCEDURE PositionOnEDO_ByEDOTSN();
 BEGIN
  L_General.Assert(ACCESS(EDOrderL), " ⠭ ਪ");
  CONFORM(EDOrderL, EDOrder);
  CONFORM(EDOrder, EDOSrc);
  IF L_AcsPnt.MayPassAccessPoint(EDOSrc.apMEDO) THEN
   L_EDO.PassAccessPoint(EDOSrc.apMEDO);
  ELSE
   L_EDO.PassAccessPoint(EDOSrc.apVEDO);
  END;
  L_EDO.curEDOrder:=EDOrderL.EDOrder;
  LIKEMENU(View, "EDOrder1 1", CALL, "EDOrder.PositionOnEDO_InEDOrder1()");
 END {PositionOnEDO_ByEDOTSN};

 PUBLIC PROCEDURE OnSetEDOrderSubwindow(ShowWinOnly: SCAL[2]);
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert THEN
   L_General.Assert(SEARCH(EDOGrp, EDOGrp, L_EDO.curEDOGrp), " ⠭ ⥪ 㯯");
  ELSE
   L_EDO.SetCurrentEDOGrpByEDOrderL();
  END;
  RTI.Get().CurZone.HasVariousSubwindows:=1;
  IF ~ShowWinOnly | (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_ShowWin) THEN
   RTI.Get().CurZone.SubwindowOriginalName:=EDOGrp.EWin;
   RTI.Get().CurZone.SubwindowAssignedName:=RTI.Get().CurZone.SubwindowOriginalName +
                                            "<" + RTI.Get().CurWindow.AssignedName + ">";
   APP.Get().Forms.Load(RTI.Get().CurZone.SubwindowOriginalName,
                        RTI.Get().CurZone.SubwindowAssignedName).WLevProg:="EDOrderL";
  ELSE
   RTI.Get().CurZone.SubwindowOriginalName:="";
  END;
 END {OnSetEDOrderSubwindow};

 PRIVATE PROCEDURE EDOrderE_1_OnSetSubwindow();
 BEGIN
  OnSetEDOrderSubwindow(0);
 END {EDOrderE_1_OnSetSubwindow};

 PRIVATE PROCEDURE EDOSrc_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="EDOrder";
  L_WDO.iEvents      (1, "");
  L_WDO.iSubwindow   (1, "EDOSrcE");
 END {EDOSrc_OnInitializeWindow};

 PRIVATE PROCEDURE EDOSrcE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf]);
  L_WDO.iMayBeEmpty  (0, ["EDOSrc.AutoNumD"]);
  L_WDO.iProgs       (0, "EDOrder");
  L_WDO.iSubwindow   (1, "AcsPntE");
  L_WDO.iZone        (1).PermanentFilter:="(AcsPnt.AcsPnt = EDOSrc.apVFO) |" +
                                          "(AcsPnt.AcsPnt = EDOSrc.apVEDO)|" +
                                          "(AcsPnt.AcsPnt = EDOSrc.apMFO) |" +
                                          "(AcsPnt.AcsPnt = EDOSrc.apMEDO)";
 END {EDOSrcE_OnInitializeWindow};

BEGIN
 L_Events.ExecuteHandler();
END.
