(*
%Copyright   (c) Polak Computer System
%Author      21.10.1997 18:05:21 SAN
%Purpose     ஫ 䨪樨 ப ਪ  ᮭ
%Type        control
%Specific    SYS
%Modified    30.12.2013 18:07:41 POLAK\LDA
%Environment
*)

 MODULE EDOrderL [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_EDO, L_Events, L_General, L_Card, L_DatTim,
        L_Staff, L_PRoll, P_EDOKnd, L_Adding, Str, L_Str, L_StdFrm,
        L_Prop, P_EDOL, L_Car, L_Way, L_XDoc, L_WDO, L_BegRWS, Math,
        L_AcsPnt, P_Staff, P_Man, L_Man, L_r2r, L_qs, P_Firm;

 PRIVATE CONST
  CntRouteInEDOL = 10;

 PRIVATE VAR
  PPP         : LIKE(Property.Property)[100];
  PPV         : STRING[][100];
  PrvProsCount: NUMERIC[0];

 PRIVATE PROCEDURE t_OnAfterInsert_EDOLPro();
 BEGIN
  CALL(ObjPro.UpdateVal2Show("EDOLPro"));
 END {t_OnAfterInsert_EDOLPro};

 PRIVATE PROCEDURE t_OnBeforeRemove_EDOLPro();
 BEGIN
  L_r2r.User_OnBeforeModify("EDOLPro");
  L_qs.OnBeforeDelete("EDOLPro");
 END {t_OnBeforeRemove_EDOLPro};

 PRIVATE PROCEDURE SavePrvPros();
 BEGIN
  PrvProsCount:=0;
  SELECT(EDOLPro, EDOrder, , EDOrderL.EDOrder, EDOrderL.Row);
  WHILE OCCURE(EDOLPro) DO
   IF ~!EDOLPro.Value THEN
    PPP[PrvProsCount]:=EDOLPro.Property;
    IF !P_EDOL.IsSimpleUserOf(EDOLPro.Property) THEN
     PPV[PrvProsCount]:=EDOLPro.Value;
    ELSE
     PPV[PrvProsCount]:=P_EDOL.Decode_CurEDOLPro();
    END;
    INC(PrvProsCount);
   END;
   t_OnBeforeRemove_EDOLPro();
   REMOVE(EDOLPro);
  END; (* WHILE OCCURE(EDOLPro)... *)
 END {SavePrvPros};

 PRIVATE PROCEDURE GetPrvProValue(_Property: LIKE(Property.Property)): STRING[];
  VAR
   i: NUMERIC[0];
 BEGIN i:=0;
  WHILE i < PrvProsCount DO
   IF PPP[i] = _Property THEN
    PPP[i]:=9999;
    RETURN PPV[i];
   END;
   INC(i);
  END;
  RETURN "";
 END {GetPrvProValue};

 PRIVATE PROCEDURE InsertEDOLPro(trgProperty: LIKE(Property.Property);
                                 trgNbr     : LIKE(EDOLPro.Nbr);
                                 trgValue   : STRING[]);
  VAR
   trgPropRow: LIKE(EDOLPro.PropRow);
 BEGIN
  SAVE(EDOLPro);
  SETSEL(EDOLPro, EDOrder, EDOrderL.EDOrder, EDOrderL.Row, trgProperty);
  IF LAST(EDOLPro) THEN
   trgPropRow:=EDOLPro.PropRow + 1;
  ELSE
   trgPropRow:=00;
  END;
  RESTORE(EDOLPro);

  EDOLPro.EDOrder :=EDOrderL.EDOrder;
  EDOLPro.Row     :=EDOrderL.Row;
  EDOLPro.Property:=trgProperty;
  EDOLPro.PropRow :=trgPropRow;
  EDOLPro.Nbr     :=trgNbr;
  SETEMPTY(EDOLPro.Value, EDOLPro.Val2Show);
  INSERT(EDOLPro);
  IF !P_EDOL.IsSimpleUserOf(trgProperty) THEN
   EDOLPro.Value:=trgValue;
  ELSE
   EDOLPro.Value:=P_EDOL.Encode_EDOLPro(trgValue, trgProperty);
  END;
  REPLACE(EDOLPro);
  P_EDOL.EDOLPro_Check(EDOLPro.Property);
  t_OnAfterInsert_EDOLPro();
 END {InsertEDOLPro};

 PRIVATE PROCEDURE SetEDOLPro(_Property: LIKE(Property.Property);
                              _Nbr     :  LIKE(EDOLPro.Nbr));
 BEGIN
  L_General.CallUs(SEARCH(Property, Property, _Property));
  InsertEDOLPro(_Property, _Nbr, GetPrvProValue(_Property));
 END {SetEDOLPro};

 PRIVATE PROCEDURE DontTouchInMEDO();
 BEGIN
  L_General.Assert(!EDOrder.MEDOrder, "饭     ४饬 ਪ");
 END {DontTouchInMEDO};

 PRIVATE PROCEDURE CheckAll();
  VAR
   trgTSN: LIKE(Staff.TSN);
 BEGIN
  IF EDOrderL.EDOGrp # L_EDO.grp_SingleRegimeAlteration THEN
   L_General.Assert(EDOrderL.OcrDate <= EDOrderL.EndDate, "砭 ࠭ 砫???");
  END;
  IF ~!EDOrderL.OcrDate & ~L_Staff.rInState(EDOrderL.OcrDate) THEN
   L_StdFrm.Choice(L_DatTim.DateStr(EDOrderL.OcrDate) + " ࠡ⭨  ⮨  ");
  END;
  IF ~!EDOrderL.EndDate & ~L_Staff.rInState(EDOrderL.EndDate) THEN
   L_StdFrm.Choice(L_DatTim.DateStr(EDOrderL.EndDate) + " ࠡ⭨  ⮨  ");
  END;
  CONFORM(EDOrderL, Officer);
  IF OCCURE(Officer) THEN
   L_General.Assert(L_DatTim.InPatIntvl(Officer.Begin, Officer.Till,  EDOrderL.OcrDate, EDOrderL.EndDate),
                   "ਮ ᮢ饭  ᮢ  ਮ ⢨  " + EDOrderL.Officer);
  END;
  IF EDOrderL.EDOGrp = L_EDO.grp_Probation THEN
   L_EDO.GetEDOLPropValue(P_EDOL.P_TSN, trgTSN);
   IF ~!trgTSN THEN
    L_General.Assert(P_Staff.HasActualStaffPro(trgTSN, EDOrderL.OcrDate, P_Staff.P_DrvInstructor),
                     "⭨ " + trgTSN + "   饣  " + L_DatTim.DateStr(EDOrderL.OcrDate) +
                     " ᢮⢠ " + L_Str.FixedIntStr(P_Staff.P_DrvInstructor, 4));
   END;
  END;
 END {CheckAll};

 PRIVATE PROCEDURE PositionOnMEDOrderL(_Row: LIKE(EDOrderL.Row));
 BEGIN
  L_General.CallUs(SEARCH(EDOrderL, EDOrder, EDOrder.MEDOrder, _Row));
 END {PositionOnMEDOrderL};

 PRIVATE PROCEDURE Proceed(_s: NUMERIC[0]);
  VAR
   CardName: STRING[];
 BEGIN
  PASTE(^(L_Card.GetCardName(L_Card.t_EDT, EDOrder.Closed)));
  CardName:=L_Card.GetCardNameSoft(L_Card.t_EDO, EDOrder.Closed);
  IF ~!CardName THEN
   PASTE(^CardName);
  END;
  CONFORM(EDOrderL, EDOrder);
  CONFORM(EDOrderL, EDOKind);
  CONFORM(EDOrderL, Staff);
  IF _s = +1 THEN
   CheckAll();
  END;
  SAVE(EDOrder);
  SAVE(EDOrderL);
  ^EDOKind.Rule(_s);
  RESTORE(EDOrder);
  RESTORE(EDOrderL);
  IF ~!EDOrder.MEDOrder THEN
   SAVE(EDOrderL);
   PositionOnMEDOrderL(EDOrderL.Row);
   IF _s = +1 THEN
    EDOrderL.Status:=L_EDO.st_Canceled;
   ELSE
    EDOrderL.Status:=L_EDO.st_Passed;
   END;
   REPLACE(EDOrderL);
   RESTORE(EDOrderL);
  END;
 END {Proceed};

 PRIVATE PROCEDURE FillFromMEDOL();
  VAR
   srcTSN     : LIKE(EDOrderL.TSN);
   srcEDOKind : LIKE(EDOrderL.EDOKind);
   srcOcrDate : LIKE(EDOrderL.OcrDate);
   srcEndDate : LIKE(EDOrderL.EndDate);
   srcBySum   : LIKE(EDOrderL.BySum);
   srcByPrc   : LIKE(EDOrderL.ByPrc);
   srcSort    : LIKE(EDOrderL.Sort);
   srcOfficer : LIKE(EDOrderL.Officer);
   srcClass   : LIKE(EDOrderL.Class);
   srcFixInPC : LIKE(EDOrderL.FixInPC);
   srcODate   : LIKE(EDOrderL.ODate);
   srcRI      : LIKE(EDOrderL.RECORDID);
   curAllODate: LIKE(EDOrderL.AllODate);
   curEDOGrp  : LIKE(EDOrderL.EDOGrp);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   PositionOnMEDOrderL(L_EDO.curRow);
   srcTSN    :=EDOrderL.TSN;
   srcEDOKind:=EDOrderL.EDOKind;
   srcOcrDate:=EDOrderL.OcrDate;
   srcEndDate:=EDOrderL.EndDate;
   srcByPrc  :=EDOrderL.ByPrc;
   srcBySum  :=EDOrderL.BySum;
   srcSort   :=EDOrderL.Sort;
   srcOfficer:=EDOrderL.Officer;
   srcClass  :=EDOrderL.Class;
   srcFixInPC:=EDOrderL.FixInPC;
   srcODate  :=EDOrderL.ODate;
   srcRI   :=EDOrderL.RECORDID;
   curAllODate:=EDOrderL.AllODate;
   curEDOGrp  :=EDOrderL.EDOGrp;
  EXCEPT
  END; (* TRY *)
  EDOrderL.Row    :=L_EDO.curRow;
  EDOrderL.Type   :=L_EDO.type_Correct;
  SETEMPTY(EDOrderL.EDOCause);
  EDOrderL.TSN    :=srcTSN;
  EDOrderL.EDOKind:=srcEDOKind;
  EDOrderL.OcrDate:=srcOcrDate;
  EDOrderL.EndDate:=srcEndDate;
  EDOrderL.ByPrc  :=srcByPrc;
  EDOrderL.BySum  :=srcBySum;
  EDOrderL.Sort   :=srcSort;
  EDOrderL.Officer:=srcOfficer;
  EDOrderL.Class  :=srcClass;
  EDOrderL.FixInPC:=srcFixInPC;
  EDOrderL.ODate  :=srcODate;
  EDOrderL.AllODate:=curAllODate;
  EDOrderL.EDOGrp  :=curEDOGrp;
  REPLACE(EDOrderL);

  L_Prop.CopyProRecords("EDOrderL", srcRI, EDOrderL.RECORDID);
 END {FillFromMEDOL};

 PRIVATE PROCEDURE CheckManyInEDOrder();
  VAR
   Cnt: NUMERIC[0];
 BEGIN
  SAVE(EDOrderL);
  Cnt:=0;
  CHANGESEL(EDOrderL, EDOLTSN, , EDOrderL.EDOrder, EDOrderL.TSN);
  FIRST(EDOrderL);
  WHILE OCCURE(EDOrderL) DO
   INC(Cnt);
   NEXT(EDOrderL);
  END; (* WHILE OCCURE ... *)
  RESTORE(EDOrderL);
  IF Cnt > 1 THEN
   L_StdFrm.Choice(" " + EDOrderL.TSN + " 㦥 " + L_Str.IntStr(Cnt) + " ࠧ 㯮  ਪ");
  END;
 END {CheckManyInEDOrder};

 PRIVATE PROCEDURE SetSumFields_FLAG_EDIT(ForceEnable: SCAL[2]);
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF EDOrderL.EDOGrp = L_EDO.grp_Adding THEN
   IF ForceEnable THEN
    Fields("EDOrderL.BySum").Modifiable:=1;
    Fields("EDOrderL.ByPrc").Modifiable:=1;
   ELSE
    L_EDO.AccessAddKind(EDOrderL.EDOKind, EDOrder.PrpDate);
    Fields("EDOrderL.BySum").Modifiable:=AddKind.ValType = L_Adding.vt_Sum;
    Fields("EDOrderL.ByPrc").Modifiable:=AddKind.ValType = L_Adding.vt_Prc;
   END;
  END;
 END {SetSumFields_FLAG_EDIT};

 PRIVATE PROCEDURE SetTypeFields_FLAG_EDIT();
  VAR
   Fields  : FORM_FIELDS;
   FlagEdit: SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  CONFORM(EDOrderL, EDOrder);
  FlagEdit:=~!EDOrder.MEDOrder;
  Fields("EDOrderL.Type").Modifiable   :=FlagEdit;
  Fields("EDOrderL.Row").Modifiable    :=~FlagEdit;
  Fields("EDOrderL.TSN").Modifiable    :=~FlagEdit;
  Fields("EDOrderL.EDOKind").Modifiable:=EDOrderL.Type # L_EDO.type_Cancel;
  Fields("EDOrderL.TSN").First         :=~FlagEdit;
 END {SetTypeFields_FLAG_EDIT};

 PRIVATE PROCEDURE EDOGrpWSpecForm(trgEDOGrp: LIKE(EDOrderL.EDOGrp)): SCAL[2];
 BEGIN
  RETURN (trgEDOGrp = L_EDO.grp_Combining)          |
         (trgEDOGrp = L_EDO.grp_ChangePersonalInfo) |
         (trgEDOGrp = L_EDO.grp_Probation)          |
         (trgEDOGrp = L_EDO.grp_Permit)             |
         (trgEDOGrp = L_EDO.grp_CancelPermit)       |
         (trgEDOGrp = L_EDO.grp_MCFix)              |
         (trgEDOGrp = L_EDO.grp_BusinessTrip)       |
         (trgEDOGrp = L_EDO.grp_RegimeAlteration);
 END {EDOGrpWSpecForm};

 PRIVATE PROCEDURE ep_SetFieldValue(FieldName: STRING[]; trgValue: STRING[]);
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF    FieldName = "Cause_DocGiveD" THEN
   Fields(FieldName).Value:=STRTOFLD(trgValue, DATE);
  ELSIF Str.Slice(FieldName, 0, Str.Length("ShdlTime")) = "ShdlTime" THEN
   Fields(FieldName).Value:=STRTOFLD(trgValue, TIME);
  ELSE
   Fields(FieldName).Value:=trgValue;
  END;
 END {ep_SetFieldValue};

 PRIVATE PROCEDURE ep_SetFieldValue_FromProperty(FieldName: STRING[]; trgProperty: LIKE(Property.Property); _PropRow: LIKE(EDOLPro.PropRow); wModify: SCAL[2]);
  VAR
   trgValue: LIKE(EDOLPro.Value);
 BEGIN
  trgValue:=P_EDOL.GetEDOLProSoft(EDOrderL.EDOrder, EDOrderL.Row, trgProperty, _PropRow);
  IF !trgValue | !P_EDOL.IsSimpleUserOf(trgProperty) THEN
   ep_SetFieldValue(FieldName, trgValue);
  ELSE
   ep_SetFieldValue(FieldName, P_EDOL.Decode_CurEDOLPro());
  END;
  IF wModify & OCCURE(EDOLPro) THEN
   t_OnBeforeRemove_EDOLPro();
   REMOVE(EDOLPro);
  END;
 END {ep_SetFieldValue_FromProperty};

 PRIVATE PROCEDURE CreateFormLink2MarkG();
 BEGIN
  L_WDO.CreateFormLink("MarkG", "");
  L_Way.v_MarkGT:=P_EDOL.MarkGTForEDOGrp();
 END {CreateFormLink2MarkG};

 PRIVATE PROCEDURE ep_PutDataInForm(wModify: SCAL[2]);
  VAR
   S         : STRING[];
   CurProcess: NUMERIC[0];
   Idx       : NUMERIC[0];
   Fields    : FORM_FIELDS;
   BT,
   ET        : TIME;
   DBT,
   DET       : TIME[3];
 BEGIN
  IF EDOGrpWSpecForm(EDOrderL.EDOGrp) THEN
   CurProcess:=RTI.Get().CurProcess.Kind;
   IF wModify = ((CurProcess = FORM_PROCESS.Kind_Edit) | (CurProcess = FORM_PROCESS.Kind_Insert)) THEN
    SEARCH(EDOGrp, EDOGrp, , EDOrderL.EDOGrp);
    IF EDOGrp.EWin = RTI.Get().CurWindow.OriginalName THEN
     IF ~!RTI.Get().CurZone.Fields("EDOrderLTSNManName") THEN
      IF ~!EDOrderL.TSN THEN
       CONFORM(EDOrderL, Staff);
       CONFORM(Staff, Man);
       RTI.Get().CurZone.Fields("EDOrderLTSNManName").Value:=Man.Name;
      ELSE
       SETEMPTY(RTI.Get().CurZone.Fields("EDOrderLTSNManName").Value);
      END;
     END;
     IF    EDOrderL.EDOGrp = L_EDO.grp_MCFix              THEN
      L_WDO.extCreateFormLink("Car", "mcf_", 1);
      L_WDO.extCreateFormLink("Car", "mcf_", 2);
      L_WDO.CreateFormLink("JRegime", "mcf_");
      ep_SetFieldValue_FromProperty("mcf_BoxNbr_1", P_EDOL.P_BoxNbr,  00, wModify);
      ep_SetFieldValue_FromProperty("mcf_BoxNbr_2", P_EDOL.P_BoxNbr,  01, wModify);
      ep_SetFieldValue_FromProperty("mcf_JRegime",  P_EDOL.P_JRegime, 00, wModify);
     ELSIF EDOrderL.EDOGrp = L_EDO.grp_ChangePersonalInfo THEN
      ep_SetFieldValue_FromProperty("Cause_DocSer",   P_EDOL.P_CauseEntry,   00, wModify);
      ep_SetFieldValue_FromProperty("Cause_DocNum",   P_EDOL.P_CauseEntry,   01, wModify);
      ep_SetFieldValue_FromProperty("Cause_DocGiveD", P_EDOL.P_CauseEntry,   02, wModify);
      ep_SetFieldValue_FromProperty("Cause_DocGiveS", P_EDOL.P_CauseEntry,   03, wModify);
      ep_SetFieldValue_FromProperty("OldManName",     P_EDOL.P_PersonalInfo, 00, wModify);
      ep_SetFieldValue_FromProperty("NewManName",     P_EDOL.P_PersonalInfo, 01, wModify);
     ELSIF EDOrderL.EDOGrp = L_EDO.grp_Combining          THEN
      ep_SetFieldValue_FromProperty("InsteadTSN", P_EDOL.P_TSN,   00, wModify);
     ELSIF EDOrderL.EDOGrp = L_EDO.grp_Probation          THEN
      L_WDO.CreateFormLink("Staff", "Preceptor");
      L_WDO.CreateFormLink("Car",   "");
      CreateFormLink2MarkG();
      ep_SetFieldValue_FromProperty("PreceptorTSN",  P_EDOL.P_TSN,           00, wModify);
      ep_SetFieldValue_FromProperty("BoxNbr",        P_EDOL.P_BoxNbr,        00, wModify);
      ep_SetFieldValue_FromProperty("ProbationTime", P_EDOL.P_ProbationTime, 00, wModify);
      ep_SetFieldValue_FromProperty("MarkG",         P_EDOL.P_MarkG,         00, wModify);
      Idx:=0;
      WHILE Idx < CntRouteInEDOL DO
       L_WDO.extCreateFormLink("Route", "", Idx);
       ep_SetFieldValue_FromProperty(L_Prop.BuildVideoFieldName("Route", Idx), P_EDOL.P_Route, Idx, wModify);
       INC(Idx);
      END; (* WHILE Idx < ...*)
      Fields:=RTI.Get().CurZone.Fields;
      Fields("MarkG").Modifiable :=!Fields("BoxNbr").Value;
      Fields("BoxNbr").Modifiable:=!Fields("MarkG").Value | ~!Fields("BoxNbr").Value;
     ELSIF (EDOrderL.EDOGrp = L_EDO.grp_Permit) |
           (EDOrderL.EDOGrp = L_EDO.grp_CancelPermit)     THEN
      CreateFormLink2MarkG();
      ep_SetFieldValue_FromProperty("MarkG",         P_EDOL.P_MarkG,         00, wModify);
      Idx:=0;
      WHILE Idx < CntRouteInEDOL DO
       L_WDO.extCreateFormLink("Route", "", Idx);
       ep_SetFieldValue_FromProperty(L_Prop.BuildVideoFieldName("Route", Idx), P_EDOL.P_Route, Idx, wModify);
       INC(Idx);
      END; (* WHILE Idx < ...*)
     ELSIF EDOrderL.EDOGrp = L_EDO.grp_BusinessTrip       THEN
      ep_SetFieldValue_FromProperty("Destination",   P_EDOL.P_Destination,   00, wModify);
      ep_SetFieldValue_FromProperty("Purpose",       P_EDOL.P_Purpose,       00, wModify);
      ep_SetFieldValue_FromProperty("FundingSource", P_EDOL.P_FundingSource, 00, wModify);
     ELSIF EDOrderL.EDOGrp = L_EDO.grp_RegimeAlteration   THEN
      IF P_EDOL.GetRegimeTimes(BT, ET, DBT, DET) & wModify THEN
       t_OnBeforeRemove_EDOLPro();
       REMOVE(EDOLPro);
      END; (* IF P_EDOL.HasEDOLPro ... *)
      ep_SetFieldValue(L_Prop.BuildVideoFieldName("ShdlTime", 0), L_DatTim.TimeStr(BT));
      ep_SetFieldValue(L_Prop.BuildVideoFieldName("ShdlTime", 1), L_DatTim.TimeStr(ET));
      ep_SetFieldValue(L_Prop.BuildVideoFieldName("ShdlTime", 2), L_DatTim.TimeStr(DBT[0]));
      ep_SetFieldValue(L_Prop.BuildVideoFieldName("ShdlTime", 3), L_DatTim.TimeStr(DET[0]));
      ep_SetFieldValue(L_Prop.BuildVideoFieldName("ShdlTime", 4), L_DatTim.TimeStr(DBT[1]));
      ep_SetFieldValue(L_Prop.BuildVideoFieldName("ShdlTime", 5), L_DatTim.TimeStr(DET[1]));
      ep_SetFieldValue(L_Prop.BuildVideoFieldName("ShdlTime", 6), L_DatTim.TimeStr(DBT[2]));
      ep_SetFieldValue(L_Prop.BuildVideoFieldName("ShdlTime", 7), L_DatTim.TimeStr(DET[2]));
     ELSE
      L_General.CallUs(0);
     END;
    END;
   END;
  END; (* IF EDOGrpWSpecForm() ... *)
 END {ep_PutDataInForm};

 PRIVATE PROCEDURE ep_InsertEDOLPro_FromField(FieldName: STRING[]; _Property: LIKE(Property.Property); VAR LastNbr: LIKE(EDOLPro.Nbr));
  VAR
   trgValue: STRING[];
 BEGIN
  SETEMPTY(trgValue);
  IF ~!RTI.Get().CurZone.Fields(FieldName).Value THEN
   trgValue:=FLDTOSTR(RTI.Get().CurZone.Fields(FieldName).Value);
  END;
  InsertEDOLPro(_Property, LastNbr, trgValue);
  INC(LastNbr);
 END {ep_InsertEDOLPro_FromField};

 PRIVATE PROCEDURE ep_InsertEDOLPro_FromNotEmptyField(FieldName: STRING[]; trgProperty: LIKE(Property.Property); VAR LastNbr: LIKE(EDOLPro.Nbr));
 BEGIN
  IF ~!RTI.Get().CurZone.Fields(FieldName).Value THEN
   ep_InsertEDOLPro_FromField(FieldName, trgProperty, LastNbr);
  END;
 END {ep_InsertEDOLPro_FromNotEmptyField};

 PRIVATE PROCEDURE ep_GetDataFromForm();
  VAR
   Idx    : NUMERIC[0];
   LastNbr: LIKE(EDOLPro.Nbr);
   S      : STRING[];
 BEGIN
  IF EDOGrpWSpecForm(EDOrderL.EDOGrp) THEN
   SETSEL(EDOLPro, Nbr, EDOrderL.EDOrder, EDOrderL.Row);
   IF LAST(EDOLPro) THEN
    LastNbr:=EDOLPro.Nbr+1;
   ELSE
    LastNbr:=1;
   END;
   IF    EDOrderL.EDOGrp = L_EDO.grp_MCFix              THEN
    L_General.Assert(~!RTI.Get().CurZone.Fields("mcf_BoxNbr_1").Value, " 㪠 ࠦ  ࢮ ");
    ep_InsertEDOLPro_FromField("mcf_BoxNbr_1", P_EDOL.P_BoxNbr,  LastNbr);
    ep_InsertEDOLPro_FromField("mcf_BoxNbr_2", P_EDOL.P_BoxNbr,  LastNbr);
    ep_InsertEDOLPro_FromField("mcf_JRegime",  P_EDOL.P_JRegime, LastNbr);
   ELSIF EDOrderL.EDOGrp = L_EDO.grp_ChangePersonalInfo THEN
    ep_InsertEDOLPro_FromField("Cause_DocSer",   P_EDOL.P_CauseEntry,   LastNbr);
    ep_InsertEDOLPro_FromField("Cause_DocNum",   P_EDOL.P_CauseEntry,   LastNbr);
    ep_InsertEDOLPro_FromField("Cause_DocGiveD", P_EDOL.P_CauseEntry,   LastNbr);
    ep_InsertEDOLPro_FromField("Cause_DocGiveS", P_EDOL.P_CauseEntry,   LastNbr);
    ep_InsertEDOLPro_FromField("OldManName",     P_EDOL.P_PersonalInfo, LastNbr);
    ep_InsertEDOLPro_FromField("NewManName",     P_EDOL.P_PersonalInfo, LastNbr);
   ELSIF EDOrderL.EDOGrp = L_EDO.grp_Combining          THEN
    ep_InsertEDOLPro_FromField("InsteadTSN", P_EDOL.P_TSN, LastNbr);
   ELSIF EDOrderL.EDOGrp = L_EDO.grp_Probation          THEN
    ep_InsertEDOLPro_FromNotEmptyField("PreceptorTSN",  P_EDOL.P_TSN,           LastNbr);
    ep_InsertEDOLPro_FromNotEmptyField("BoxNbr",        P_EDOL.P_BoxNbr,        LastNbr);
    Idx:=0;
    WHILE Idx < CntRouteInEDOL DO
     ep_InsertEDOLPro_FromNotEmptyField(L_Prop.BuildVideoFieldName("Route", Idx), P_EDOL.P_Route,  LastNbr);
     INC(Idx);
    END; (* WHILE Idx < ...*)
    ep_InsertEDOLPro_FromNotEmptyField("ProbationTime", P_EDOL.P_ProbationTime, LastNbr);
    ep_InsertEDOLPro_FromNotEmptyField("MarkG",         P_EDOL.P_MarkG,         LastNbr);
   ELSIF (EDOrderL.EDOGrp = L_EDO.grp_Permit) |
         (EDOrderL.EDOGrp = L_EDO.grp_CancelPermit)     THEN
    ep_InsertEDOLPro_FromNotEmptyField("MarkG",         P_EDOL.P_MarkG,         LastNbr);
    Idx:=0;
    WHILE Idx < CntRouteInEDOL DO
     ep_InsertEDOLPro_FromNotEmptyField(L_Prop.BuildVideoFieldName("Route", Idx), P_EDOL.P_Route, LastNbr);
     INC(Idx);
    END; (* WHILE Idx < ...*)
   ELSIF EDOrderL.EDOGrp = L_EDO.grp_BusinessTrip       THEN
    ep_InsertEDOLPro_FromNotEmptyField("Destination",   P_EDOL.P_Destination,   LastNbr);
    ep_InsertEDOLPro_FromNotEmptyField("Purpose",       P_EDOL.P_Purpose,       LastNbr);
    ep_InsertEDOLPro_FromNotEmptyField("FundingSource", P_EDOL.P_FundingSource, LastNbr);
   ELSIF EDOrderL.EDOGrp = L_EDO.grp_RegimeAlteration   THEN
    Idx:=0;
    SETEMPTY(S);
    WHILE Idx < 8 DO
     L_Prop.putRecordElement_T(S, RTI.Get().CurZone.Fields(L_Prop.BuildVideoFieldName("ShdlTime", Idx)).Value);
     INC(Idx);
    END; (* WHILE Idx < ...*)
    InsertEDOLPro(P_EDOL.P_RegimeTimes, LastNbr, S);
    INC(LastNbr);
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {ep_GetDataFromForm};

 PRIVATE PROCEDURE GetOfficerDescr(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="";
  IF ~!EDOrderL.TSN THEN
   IF EDOrderL.AllODate THEN
    Result:="  /  "+L_DatTim.PeriodStr(EDOrderL.Closed);
   ELSIF ~!EDOrderL.ODate THEN
    SEARCH(StaffLog, TSN, , EDOrderL.TSN, EDOrderL.ODate);
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, Post);
    Result:=L_Str.Left(Post.Name, 25)+", "+StaffLog.Sort+", "+StaffLog.Officer+", "+StaffLog.Regime+", "+StaffLog.Class;
   END;
  END;
  RETURN Result;
 END {GetOfficerDescr};

 PRIVATE PROCEDURE SetupODate(wModify: SCAL[2]);
 BEGIN
  IF    L_EDO.IsGroup_wAllODate(EDOrderL.EDOGrp) | L_EDO.IsGroup_wPay(EDOrderL.EDOGrp) THEN
   IF wModify THEN
    IF ~L_EDO.EDO_AllODateAllowed() THEN
     EDOrderL.AllODate:=0;
    END;
    IF EDOrderL.AllODate THEN
     SETEMPTY(EDOrderL.ODate);
    ELSIF ~!EDOrderL.TSN & ~!EDOrderL.OcrDate THEN
     CONFORM(EDOrderL, Staff);
     L_Staff.PosToStaffLog(EDOrderL.TSN, Math.Min(EDOrderL.OcrDate, L_DatTim.MonthEnd(EDOrderL.Closed)), 1);
     EDOrderL.ODate:=StaffLog.Date;
    END;
    REPLACE(EDOrderL);
   END;
   L_WDO.cField("StaffLog_Name").Value:=GetOfficerDescr();
   L_WDO.cField("EDOrderL.AllODate").Modifiable:=L_EDO.EDO_AllODateAllowed();
   L_WDO.cField("EDOrderL.ODate"   ).Modifiable:=~EDOrderL.AllODate;
  END;
 END {SetupODate};

 PRIVATE PROCEDURE EDOrderL_OnBeforeInsert();
 BEGIN
  L_EDO.EDO_MayModify(1);
  IF ~!EDOrder.MEDOrder THEN
   L_General.Assert(~!L_EDO.curRow, " ਪ   ਪ ⠢ ⠪ ᯮᮡ 饭");
   FillFromMEDOL();
   SETEMPTY(L_EDO.curRow);
   SetSumFields_FLAG_EDIT(0);
  ELSE
   EDOrderL.EDOGrp:=L_EDO.curEDOGrp;
   SetSumFields_FLAG_EDIT(1);
  END;
  SetTypeFields_FLAG_EDIT();

  EDOrderL.Closed:=EDOrder.Closed;
  EDOrderL.EDOSrc:=EDOrder.EDOSrc;
  IF !EDOrder.MEDOrder THEN
   EDOrderL.AllODate:=L_EDO.IsGroup_wAllODate(EDOrderL.EDOGrp);
  END;
  REPLACE(EDOrderL);
  SetupODate(1);
  ep_PutDataInForm(1);
 END {EDOrderL_OnBeforeInsert};

 PRIVATE PROCEDURE EDOrderL_OnBeforeEdDel();
 BEGIN
  L_EDO.EDO_MayModify(1);
  Proceed(-1);
 END {EDOrderL_OnBeforeEdDel};

 PRIVATE PROCEDURE EDOrderL_OnBeforeEdit();
 BEGIN
  IF RTI.Get().CurWindow.ParentZone.MasterTable.Name # "EDOrderL" THEN
   L_General.Error(" ⮬ ⥪ 䨪 ப ਪ 饭")
  END;
  SAVE(EDOrderL);
  EDOrderL_OnBeforeEdDel();
  RESTORE(EDOrderL);
  SetSumFields_FLAG_EDIT(0);
  SetTypeFields_FLAG_EDIT();
  L_General.Assert((EDOrderL.EDOGrp # L_EDO.grp_Adding) |
                   (AddKind.ValType = L_Adding.vt_Sum) & (EDOrderL.ByPrc = 0) |
                   (AddKind.ValType = L_Adding.vt_Prc) & (EDOrderL.BySum = 0),
                   " ᫮   ᯮ饩 |" +
                   "  ਪ    㣮 ⨯.| |" +
                   "஢ .");
  ep_PutDataInForm(1);
 END {EDOrderL_OnBeforeEdit};

 PRIVATE PROCEDURE EDOrderL_OnBeforeDelete();
 BEGIN
  EDOrderL_OnBeforeEdDel();
 END {EDOrderL_OnBeforeDelete};

 PRIVATE PROCEDURE _sra_CheckCorrectDate(_Date: DATE);
  CONST
   sra_AcceptablePeriod = 2;
  VAR
   BPer, EPer: DATE;
 BEGIN
  IF ~!_Date THEN
   BPer:=L_DatTim.IncMonth(L_DatTim.Per(EDOrderL.Closed), -sra_AcceptablePeriod);
   EPer:=L_DatTim.IncMonth(L_DatTim.Per(EDOrderL.Closed), +sra_AcceptablePeriod);
   L_General.Assert(L_DatTim.IsActive_Inc(_Date, BPer, EPer),
                    "  ⮬ ਪ  室  | " +
                    L_DatTim.DateStr(BPer) + "  " + L_DatTim.DateStr(EPer));
  END;
 END {_sra_CheckCorrectDate};

 PRIVATE PROCEDURE sra_CheckCorrectDate();
 BEGIN
  L_General.Assert(~!EDOrderL.EndDate | ~!EDOrderL.OcrDate,
                   "室      ");
  _sra_CheckCorrectDate(EDOrderL.EndDate);
  _sra_CheckCorrectDate(EDOrderL.OcrDate);
 END {sra_CheckCorrectDate};

 PUBLIC PROCEDURE EDOLC_Save();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  IF ~Fields("MultiCause").Value THEN
   IF !Fields("v_EDOCause").Value THEN
    IF SELECT(EDOLC, EDOrder, EDOrderL.EDOrder, EDOrderL.Row) THEN
     REMSEL(EDOLC);
    END;
   ELSE
    IF ~SELECT(EDOLC, EDOrder, EDOrderL.EDOrder, EDOrderL.Row) THEN
     DEFAULT(EDOLC);
     EDOLC.EDOrder:=EDOrderL.EDOrder;
     EDOLC.Row    :=EDOrderL.Row;
     INSERT(EDOLC);
    END;
    L_General.Assert(SEARCH(EDOCause, EDOCause, Fields("v_EDOCause").Value), "᭮  ");
    EDOLC.EDOCause:=EDOCause.EDOCause;
    EDOLC.edcType :=EDOCause.Type;
    EDOLC.XDocType:=EDOCause.XDocType;
    EDOLC.XDocKind:=EDOCause.XDocKind;
    REPLACE(EDOLC);
   END;
  END;
 END {EDOLC_Save};

 PRIVATE PROCEDURE EDOrderL_OnAfterEdIns();
  VAR
   _EDOKind    : LIKE(EDOrderL.EDOKind);
   _EDOrderList: STRING[];
   Dummy,
   LinesAmount : NUMERIC[0];
   _TSN        : LIKE(Staff.TSN);
 BEGIN
  CONFORM(EDOrderL, Staff);
  L_EDO.EDO_CheckAllODate();
  IF    EDOrderL.EDOGrp = L_EDO.grp_SingleRegimeAlteration THEN
   sra_CheckCorrectDate();
  ELSIF EDOrderL.EDOGrp = L_EDO.grp_ChangePersonalInfo     THEN
   L_General.Assert(L_Man.E_ManNameModificationThroughEDOrder(),
                    " ঠ ᮧ ਪ |'  ᮭ '| ﭨ  " + L_DatTim.DateStr(EDOrderL.OcrDate));
  END;
  ep_GetDataFromForm();
  IF EDOrderL.Type = L_EDO.type_Cancel THEN
   SETEMPTY(_EDOrderList);
   LinesAmount:=0;
   _TSN:=EDOrderL.TSN;
   SAVE(EDOrderL);
   WHILE ~!EDOrder.MEDOrder DO
    SEARCH(EDOrder, EDOrder, , EDOrder.MEDOrder);
    SELECT(EDOrderL, EDOLTSN, , EDOrder.EDOrder, _TSN);
    _EDOrderList:=_EDOrderList +
                  L_Str.PoolItem("||", EDOrderL.Type) + " " +
                  EDOrder.EDOrder + "  " +
                  L_DatTim.DateStr(EDOrder.Date) + "|";
    INC(LinesAmount);
   END; (* WHILE ~!EDOrder.MEDOrder...*)
   RESTORE(EDOrderL);
   L_General.Assert(~!_EDOrderList, "  室 ਪ");
   SETZERO(Dummy);
   IF LinesAmount > 10 THEN
    LinesAmount:=10;
   END;
   STDFORM(L_StdFrm.sf_Choice("|  ⬥  楯" +
                              "|ਪ  ࠡ⭨ " + _TSN + ":|" +
                              "|%##########################%"+
                              "|",
                              "%L,"+L_Str.IntStr(LinesAmount) + "<" + _EDOrderList  + ">I"),
           "  ⬥饣 ਪ ",
           STOP,
           1,
           Dummy);
  END;

  IF L_EDO.IsGroup_wPay(EDOrderL.EDOGrp) THEN
   CONFORM(EDOrderL, Staff);
   IF ~!EDOrderL.ODate THEN
    L_Staff.PosToStaffLog(EDOrderL.TSN, EDOrderL.ODate, 0);
    L_Staff.CheckManyStaffLog(EDOrderL.ODate);
   ELSE
    IF ~L_Staff.InStateInPer(EDOrderL.Closed, L_DatTim.MonthEnd(EDOrderL.Closed)) THEN
     L_StdFrm.Choice("⭨  ⮨    "+L_DatTim.PeriodStr(EDOrderL.Closed));
    END;
   END;
   IF EDOrderL.Type # L_EDO.type_Cancel THEN
    L_General.Assert((EDOrderL.BySum = 0) | (EDOrderL.ByPrc = 0), "⨬ ਬ   ਪ   ᪠ -  㬬,  業");
   END;
  END;

  CheckManyInEDOrder();
  CONFORM(EDOrderL, EDOrder);
  IF ~!EDOrder.MEDOrder & (EDOrderL.Type = L_EDO.type_Cancel) THEN
   SAVE(EDOrderL);
   PositionOnMEDOrderL(EDOrderL.Row);
   _EDOKind:=EDOrderL.EDOKind;
   RESTORE(EDOrderL);
   L_General.Assert(EDOrderL.EDOKind = _EDOKind,
                    "⨬   ਪ  ⬥饬 ਪ");
  END;
  EDOLC_Save();
  EDOLC_Check(1);
  Proceed(+1);
 END {EDOrderL_OnAfterEdIns};

 PUBLIC PROCEDURE MakeDone();
 BEGIN
  Proceed(+1);
 END {MakeDone};

 PRIVATE PROCEDURE EDOrderL_OnAfterEdit();
 BEGIN
  EDOrderL_OnAfterEdIns();
 END {EDOrderL_OnAfterEdit};

 PRIVATE PROCEDURE EDOrderL_OnAfterInsert();
 BEGIN
  EDOrderL_OnAfterEdIns();
 END {EDOrderL_OnAfterInsert};

 PRIVATE PROCEDURE IsInternalProperty(trgProperty: LIKE(Property.Property); trgEDOGrp: LIKE(EDOrderL.EDOGrp)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF    trgEDOGrp = L_EDO.grp_Combining          THEN
   Result:=(trgProperty = P_EDOL.P_TSN);
  ELSIF trgEDOGrp = L_EDO.grp_Probation          THEN
   Result:=(trgProperty = P_EDOL.P_TSN)           |
           (trgProperty = P_EDOL.P_BoxNbr)        |
           (trgProperty = P_EDOL.P_ProbationTime) |
           (trgProperty = P_EDOL.P_MarkG)         |
           (trgProperty = P_EDOL.P_Route);
  ELSIF (trgEDOGrp = L_EDO.grp_Permit) |
        (trgEDOGrp = L_EDO.grp_CancelPermit)     THEN
   Result:=(trgProperty = P_EDOL.P_MarkG)         |
           (trgProperty = P_EDOL.P_Route);
  ELSIF trgEDOGrp = L_EDO.grp_BusinessTrip       THEN
   Result:=(trgProperty = P_EDOL.P_Destination)   |
           (trgProperty = P_EDOL.P_Purpose)       |
           (trgProperty = P_EDOL.P_FundingSource);
  ELSIF trgEDOGrp = L_EDO.grp_RegimeAlteration   THEN
   Result:=(trgProperty = P_EDOL.P_RegimeTimes);
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {IsInternalProperty};

 PRIVATE PROCEDURE CheckEDOKPro(trgProperty: LIKE(Property.Property));
  VAR
   trgName: LIKE(Property.Name);
 BEGIN
  IF EDOGrpWSpecForm(EDOrderL.EDOGrp) & IsInternalProperty(trgProperty, EDOrderL.EDOGrp) THEN
   SAVE(Property);
   L_General.CallUs(SEARCH(Property, Property, P_EDOKnd.P_PropertyList));
   trgName:=FLDTOSTR(P_EDOKnd.P_PropertyList, "L0000", 4) + "'" + Property.Name + "'";
   RESTORE(Property);
   L_General.Error("⢮ " + trgProperty + "  ७  㯯" +
                   "|ਪ " + EDOrderL.EDOGrp + "      㪠   ᢮⢥" +
                   "|" + trgName);
  END;
 END {CheckEDOKPro};

 PRIVATE PROCEDURE EDOrderL_EDOKind_OnSuccessfulChange();
  VAR
   Idx        : NUMERIC[0];
   arrProperty: LIKE(Property.Property)[P_EDOKnd.MaxCntProperty];
 BEGIN
  IF EDOrderL.Type = L_EDO.type_Cancel THEN
   DontTouchInMEDO();
  END;
  CONFORM(EDOrderL, EDOKind);
  L_General.Assert(EDOKind.EDOGrp = EDOrderL.EDOGrp,
                  "⨬ 㪠뢠  ਪ  㣮 㯯");
  L_General.Assert(L_DatTim.IsActive(EDOrder.PrpDate, EDOKind.Begin, EDOKind.Till),
                   " ਪ " + EDOKind.EDOKind + " " + EDOKind.Name +
                   "|   " + L_DatTim.DateStr(EDOrder.PrpDate));
  P_EDOKnd.Decode_PropertyList(P_EDOKnd.GetEDOKProSoft(EDOKind.EDOKind, EDOrder.PrpDate, P_EDOKnd.P_PropertyList), arrProperty);
  IF ~!arrProperty[0] THEN
   SavePrvPros();
   Idx:=0;
   WHILE ~!arrProperty[Idx] DO
    CheckEDOKPro(arrProperty[Idx]);
    SetEDOLPro(arrProperty[Idx], Idx);
    INC(Idx);
   END; (* WHILE ~!arrProperty[Idx] ... *)
  END;
  L_EDO.SetSum_Prc();
  SetSumFields_FLAG_EDIT(0);
  REPLACE(EDOrderL);
  SetupODate(1);
 END {EDOrderL_EDOKind_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Row_OnSuccessfulChange();
 BEGIN
  DontTouchInMEDO();
 END {EDOrderL_Row_OnSuccessfulChange};

 PUBLIC PROCEDURE EDOrderL_OcrDate_OnSuccessfulChange();
 BEGIN
  SetupODate(1);
 END {EDOrderL_OcrDate_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_TSN_OnSuccessfulChange();
 BEGIN
  CONFORM(EDOrderL, Staff);
  CONFORM(EDOrderL, EDOrder);
  L_General.Assert(Staff.MyFirm = EDOrder.MyFirm, "'' ࣠樨  ਪ  㤮 ࠪ ࠧ");
  EDOrderL.AllODate:=L_EDO.EDO_AllODateAllowed();
  REPLACE(EDOrderL);
  SetupODate(1);
  DontTouchInMEDO();
  CONFORM(Staff, Man);
  IF ~!RTI.Get().CurZone.Fields("EDOrderLTSNManName") THEN
   RTI.Get().CurZone.Fields("EDOrderLTSNManName").Value:=Man.Name;
  END;
  IF ~!RTI.Get().CurZone.Fields("OldManName") THEN
   RTI.Get().CurZone.Fields("OldManName").Value:=Man.Name;
  END;
 END {EDOrderL_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Type_OnSuccessfulChange();
 BEGIN
  L_General.Assert((!EDOrder.MEDOrder = (EDOrderL.Type = L_EDO.type_Initial)),
                   "⨬ 祭");

  RTI.Get().CurZone.Fields("EDOrderL.EDOKind").Modifiable:=EDOrderL.Type # L_EDO.type_Cancel;
 END {EDOrderL_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Sort_OnSuccessfulChange();
 BEGIN
  CONFORM(EDOrderL, Sort);
  L_Staff.CheckVeritableSort("");
 END {EDOrderL_Sort_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Sort_OnAskPhase1();
 BEGIN
 END {EDOrderL_Sort_OnAskPhase1};

 PRIVATE PROCEDURE EDOrderL_Sort_OnAskPhase2();
  VAR
   trgSort   : LIKE(Officer.Sort);
   trgOfficer: LIKE(Officer.Officer);
 BEGIN
  IF RTI.Get().TrgZone.MasterTable.Name = "Officer" THEN
   SAVE(Officer);
   GE_WZD_CURSOR(RTI.Get().TrgZone.Window.Name, RTI.Get().TrgZone.Number, Officer);
   trgSort   :=Officer.Sort;
   trgOfficer:=Officer.Officer;
   RESTORE(Officer);
  ELSE
   trgSort:=Sort.Sort;
   SETEMPTY(trgOfficer);
  END;
  EDOrderL.Sort   :=trgSort;
  EDOrderL.Officer:=trgOfficer;
  REPLACE(EDOrderL);
 END {EDOrderL_Sort_OnAskPhase2};

 PRIVATE PROCEDURE EDOrderL_Officer_OnAskPhase1();
 BEGIN
  LIKEMENU(Ask, ". 2");
 END {EDOrderL_Officer_OnAskPhase1};

 PRIVATE PROCEDURE EDOrderL_Officer_OnAskPhase2();
 BEGIN
  EDOrderL_Sort_OnAskPhase2();
 END {EDOrderL_Officer_OnAskPhase2};

 PRIVATE PROCEDURE EDO_XX_OnInitializeWindow();
 BEGIN
  L_WDO.CreateFormLink("EDOCause", "v_");
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "MultiCause").Format:="᭮|᭮";
  L_WDO.iScsChange   (0, ["v_EDOCause", "EDOrderL.TSN", "EDOrderL.EDOKind", "EDOrderL.Type", "EDOrderL.Row"]);
  L_WDO.iUnmodifiable(0, ["MultiCause", "v_EDOCause_Name"]);
  IF ~!L_WDO.iField(0, "EDOrderL.ODate") THEN
   L_WDO.iField      (0, "EDOrderL.ODate").AskMode:=1;
   L_WDO.iField      (0, "EDOrderL.ODate").OwnerWindowOriginalName:="StaffE";
   L_WDO.iField      (0, "EDOrderL.ODate").OwnerZoneNumber:=1;
   L_WDO.iField      (0, "EDOrderL.ODate").OnSuccessfulChange:=1;
   L_WDO.iField      (0, "EDOrderL.ODate").MustBeNonempty:=0;
  END;
  IF ~!L_WDO.iField(0, "EDOrderL.AllODate") THEN
   L_WDO.iField      (0, "EDOrderL.AllODate").OnSuccessfulChange:=1;
  END;
  L_WDO.iField       (0, "EDOrderL.EDOKind").OwnerWindowOriginalName:="EDOKGrp";
  L_WDO.iField       (0, "EDOrderL.EDOKind").OwnerZoneNumber:=1;
  L_WDO.iField       (0, "EDOrderL.Type").First:=1;
  L_WDO.iField       (0, "EDOrderL.Type").Format:=L_EDO.type_Pool;
  IF ~!L_WDO.iZone(1) THEN
   L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
   L_WDO.iProgs       (1, "ObjPro");
  END;
 END {EDO_XX_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_01_OnInitializeWindow();
 BEGIN
  EDO_XX_OnInitializeWindow();
  L_WDO.CreateFormLink("Staff", "Instead");
  L_WDO.iScsChange   (0, ["EDOrderL.Sort"]);
  L_WDO.iUnmodifiable(0, ["InsteadStaff_Name", "EDOrderLTSNManName"]);
  L_WDO.iMayBeEmpty  (0, ["InsteadTSN"]);
  L_WDO.iField       (0, "WagePayL.Type").Format:=" .| ";
  L_WDO.iFieldAskMode(0, "EDOrderL.Sort",    FORM_FIELD.AskMode_Manual, "Sort", 1);
  L_WDO.iFieldAskMode(0, "EDOrderL.Officer", FORM_FIELD.AskMode_Manual, "Sort", 1);
 END {EDO_01_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_02_OnInitializeWindow();
 BEGIN
  EDO_XX_OnInitializeWindow();
  L_WDO.iMayBeEmpty  (0, ["EDOrderL.EndDate"]);
 END {EDO_02_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_03_OnInitializeWindow();
 BEGIN
  EDO_XX_OnInitializeWindow();
  L_WDO.iMayBeEmpty  (0, ["EDOrderL.EndDate", "EDOrderL.OcrDate"]);
 END {EDO_03_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_04_OnInitializeWindow();
 BEGIN
  EDO_XX_OnInitializeWindow();
  L_WDO.iMayBeEmpty  (0, ["ShdlTime_0", "ShdlTime_1", "ShdlTime_2", "ShdlTime_3",
                          "ShdlTime_4", "ShdlTime_5", "ShdlTime_6", "ShdlTime_7",
                          "EDOrderL.EndDate"]);
 END {EDO_04_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_10_OnInitializeWindow();
 BEGIN
  EDO_XX_OnInitializeWindow();
  L_WDO.iScsChange   (0, ["EDOrderL.BySum", "EDOrderL.OcrDate"]);
  L_WDO.iUnmodifiable(0, ["StaffLog_Name"]);
  L_WDO.iMayBeEmpty  (0, ["EDOrderL.EndDate"]);
  L_WDO.iField       (0, "EDOrderL.FixInPC").Format:=L_EDO.GetFixInPCPool(10);
 END {EDO_10_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_12_OnInitializeWindow();
 BEGIN
  EDO_XX_OnInitializeWindow();
  L_WDO.iScsChange   (0, ["EDOrderL.OcrDate"]);
  L_WDO.iUnmodifiable(0, ["StaffLog_Name"]);
  L_WDO.iMayBeEmpty  (0, ["EDOrderL.EndDate"]);
  L_WDO.iField       (0, "EDOrderL.FixInPC").Format:=L_EDO.GetFixInPCPool(12);
 END {EDO_12_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_20_OnInitializeWindow();
 BEGIN
  EDO_XX_OnInitializeWindow();
  L_WDO.iUnmodifiable(0, ["OldManName"]);
  L_WDO.iMayBeEmpty  (0, ["Cause_DocGiveS", "Cause_DocGiveD", "Cause_DocNum", "Cause_DocSer"]);
 END {EDO_20_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_30_OnInitializeWindow();
 BEGIN
  EDO_XX_OnInitializeWindow();
  L_WDO.iScsChange   (0, ["MarkG", "BoxNbr",
                          "Route_0", "Route_1", "Route_2", "Route_3", "Route_4",
                          "Route_5", "Route_6", "Route_7", "Route_8", "Route_9"]);
  L_WDO.iUnmodifiable(0, ["MarkG_Name", "Car_Name", "PreceptorStaff_Name", "EDOrderLTSNManName",
                          "Route_Name_0", "Route_Name_1", "Route_Name_2", "Route_Name_3", "Route_Name_4",
                          "Route_Name_5", "Route_Name_6", "Route_Name_7", "Route_Name_8", "Route_Name_9"]);
  L_WDO.iMayBeEmpty  (0, ["MarkG", "EDOrderL.EndDate", "BoxNbr", "PreceptorTSN",
                          "Route_0", "Route_1", "Route_2", "Route_3", "Route_4",
                          "Route_5", "Route_6", "Route_7", "Route_8", "Route_9"]);
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).PermanentFilter:="(EDOKPro.Date<=EDOrder.PrpDate)&"+
                                          "(EDOKPro.EndDate>=EDOrder.PrpDate)&(EDOKPro.Property=0007)";
 END {EDO_30_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_31_32_OnInitializeWindow();
 BEGIN
  EDO_XX_OnInitializeWindow();
  L_WDO.iScsChange   (0, ["MarkG",
                          "Route_0", "Route_1", "Route_2", "Route_3", "Route_4",
                          "Route_5", "Route_6", "Route_7", "Route_8", "Route_9"]);
  L_WDO.iUnmodifiable(0, ["MarkG_Name",
                          "Route_Name_0", "Route_Name_1", "Route_Name_2", "Route_Name_3", "Route_Name_4",
                          "Route_Name_5", "Route_Name_6", "Route_Name_7", "Route_Name_8", "Route_Name_9"]);
  L_WDO.iMayBeEmpty  (0, ["MarkG",
                          "Route_0", "Route_1", "Route_2", "Route_3", "Route_4",
                          "Route_5", "Route_6", "Route_7", "Route_8", "Route_9"]);
 END {EDO_31_32_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_31_OnInitializeWindow();
 BEGIN
  EDO_31_32_OnInitializeWindow();
 END {EDO_31_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_32_OnInitializeWindow();
 BEGIN
  EDO_31_32_OnInitializeWindow();
 END {EDO_32_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_40_OnInitializeWindow();
 BEGIN
  EDO_XX_OnInitializeWindow();
  L_WDO.iUnmodifiable(0, ["mcf_JRegime_Name", "mcf_Car_Name_2", "mcf_Car_Name_1"]);
  L_WDO.iMayBeEmpty  (0, ["mcf_BoxNbr_2", "mcf_JRegime", "mcf_BoxNbr_1", "EDOrderL.EndDate"]);
 END {EDO_40_OnInitializeWindow};

 PRIVATE PROCEDURE GetMyFirmNamePool(D: DATE): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF (MyFirm.MyFirm # P_Firm.mf_Fict) & L_DatTim.IsActive(D, MyFirm.Begin, MyFirm.Till) THEN
    CONFORM(MyFirm, Firm);
    Result:=Result + P_Firm.FP_ContractorBriefName(Firm.Firm, D) + "|";
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
  RETURN Result;
 END {GetMyFirmNamePool};

 PRIVATE PROCEDURE EDO_50_OnInitializeWindow();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  EDO_XX_OnInitializeWindow();
  L_WDO.iMayBeEmpty  (0, ["Purpose", "FundingSource", "Destination"]);
  L_WDO.iField(0, "FundingSource").Template        :=GetMyFirmNamePool(SYSDATE());
  L_WDO.iField(0, "FundingSource").TemplateIsStrict:=0;
 END {EDO_50_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_60_OnInitializeWindow();
 BEGIN
  EDO_XX_OnInitializeWindow();
  L_WDO.iScsChange   (0, ["EDOrderL.BySum", "EDOrderL.OcrDate"]);
  L_WDO.iUnmodifiable(0, ["StaffLog_Name"]);
 END {EDO_60_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_61_OnInitializeWindow();
 BEGIN
  EDO_XX_OnInitializeWindow();
  L_WDO.iScsChange   (0, ["EDOrderL.BySum", "EDOrderL.OcrDate"]);
  L_WDO.iUnmodifiable(0, ["StaffLog_Name"]);
 END {EDO_61_OnInitializeWindow};

 PRIVATE PROCEDURE EDO_XX_OnConformToWindow();
  VAR
   curTable  : TABLE;
   curEDOrder: LIKE(EDOrder.EDOrder);
   curRow    : LIKE(EDOrderL.Row);
 BEGIN
  curTable:=RTI.Get().CurZone.MasterCursor.TABLE;
  GE_WZD_CURSOR(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number, ^(curTable.Name));
  IF OCCURE(^(curTable.Name)) THEN
   curEDOrder:=^(curTable.Fields("_EDOrder").ObtainName());
   curRow    :=^(curTable.Fields("_Row").ObtainName());
   IF ~!curEDOrder THEN
    L_EDO.StandOnEDOrder(curEDOrder, curRow);
    CHANGESEL(EDOrderL, EDOrder, , EDOrderL.EDOrder, EDOrderL.Row);
    SE_WWD_CURSOR(RTI.Get().ConformTargetWindow.Name, EDOrderL);
   END;
  END;
 END {EDO_XX_OnConformToWindow};

 PRIVATE PROCEDURE EDO_01_OnConformToWindow();
 BEGIN
  EDO_XX_OnConformToWindow();
 END {EDO_01_OnConformToWindow};

 PRIVATE PROCEDURE EDO_02_OnConformToWindow();
 BEGIN
  EDO_XX_OnConformToWindow();
 END {EDO_02_OnConformToWindow};

 PUBLIC PROCEDURE EDO_12_OnConformToWindow();
 BEGIN
  EDO_XX_OnConformToWindow();
 END {EDO_12_OnConformToWindow};

 PRIVATE PROCEDURE EDO_40_OnConformToWindow();
 BEGIN
  EDO_XX_OnConformToWindow();
 END {EDO_40_OnConformToWindow};

 PRIVATE PROCEDURE EDOKind_OnBeforeInsert();
 BEGIN
  RTI.Get().CurZone.Fields("EDOKind.EDOGrp").Modifiable:=1;
 END {EDOKind_OnBeforeInsert};

 PRIVATE PROCEDURE EDOKind_OnBeforeEdit();
 BEGIN
  RTI.Get().CurZone.Fields("EDOKind.EDOGrp").Modifiable:=~SELECT(EDOrderL, EDOKind, EDOKind.EDOKind);
 END {EDOKind_OnBeforeEdit};

 PRIVATE PROCEDURE EDOKind_OnAfterEdIns();
 BEGIN
  IF SELECT(MoneyRul, MoneyMth, EDOKind.Method) THEN
   CONFORM(EDOKind, MoneyMth);
   L_EDO.CheckMthType(EDOKind.EDOKind, MoneyMth.MthType);
   L_General.Assert(EDOKind.Rule # "稥", '⨬ 㪠뢠 ࠢ "稥"|' +
                                               ' ਪ   ⮤ ࠦ  ');
  END;
 END {EDOKind_OnAfterEdIns};

 PRIVATE PROCEDURE EDOKind_OnAfterInsert();
 BEGIN
  EDOKind_OnAfterEdIns();
 END {EDOKind_OnAfterInsert};

 PRIVATE PROCEDURE EDOKind_OnAfterEdit();
 BEGIN
  EDOKind_OnAfterEdIns();
  SELECT(EDOrderL, EDOKind, , EDOKind.EDOKind);
  WHILE OCCURE(EDOrderL) DO
   CONFORM(EDOrderL, EDOrder);
   L_General.Assert(L_DatTim.IsActive(EDOrder.PrpDate, EDOKind.Begin, EDOKind.Till),
                    ' ਪ "' + EDOKind.Name + '"|' +
                    "ਬ  ਪ  " + L_DatTim.DateStr(EDOrder.PrpDate));
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
 END {EDOKind_OnAfterEdit};

 PUBLIC PROCEDURE RenovateCauseVideoFields();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  IF ~SELECT(EDOLC, edcType, EDOrderL.EDOrder, EDOrderL.Row) THEN
   SETEMPTY(Fields("v_EDOCause").Value);
   Fields("MultiCause").Value:=0;
  ELSE
   Fields("v_EDOCause").Value:=EDOLC.EDOCause;
   Fields("MultiCause").Value:=~!EDOLC.XDocId | NEXT(EDOLC);
  END;
  Fields("v_EDOCause").Modifiable:=~Fields("MultiCause").Value;
 END {RenovateCauseVideoFields};

 PRIVATE PROCEDURE AnyEDOrderL_OnReposition();
  VAR
   D: DATE;
 BEGIN
  IF ACCESS(EDOrderL) THEN
   CONFORM(EDOrderL, EDOSrc);
   IF L_AcsPnt.MayPassAccessPoint(EDOSrc.apMEDO) THEN
    L_EDO.PassAccessPoint(EDOSrc.apMEDO);
   ELSE
    L_EDO.PassAccessPoint(EDOSrc.apVEDO);
   END;
   RenovateCauseVideoFields();
   ep_PutDataInForm(0);
   CALL(ObjPro.UpdateCurObjectVal2Show("EDOrderL", "EDOLPro"));
  END;
  SetupODate(0);
  IF ACCESS(EDOrderL) THEN
   D:=EDOrderL.OcrDate;
  ELSE
   D:=SYSDATE();
  END;
  L_WDO.SetFieldModifiable("mcf_JRegime", L_PRoll.E_UseMCFixPay(1, D));
 END {AnyEDOrderL_OnReposition};

 PRIVATE PROCEDURE EDO_01_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_01_0_OnReposition};

 PRIVATE PROCEDURE EDO_02_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_02_0_OnReposition};

 PRIVATE PROCEDURE EDO_03_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_03_0_OnReposition};

 PRIVATE PROCEDURE EDO_04_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_04_0_OnReposition};

 PRIVATE PROCEDURE EDO_10_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_10_0_OnReposition};

 PRIVATE PROCEDURE EDO_12_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_12_0_OnReposition};

 PRIVATE PROCEDURE EDO_20_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_20_0_OnReposition};

 PRIVATE PROCEDURE EDO_30_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_30_0_OnReposition};

 PRIVATE PROCEDURE EDO_31_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_31_0_OnReposition};

 PRIVATE PROCEDURE EDO_32_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_32_0_OnReposition};

 PRIVATE PROCEDURE EDO_40_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_40_0_OnReposition};

 PRIVATE PROCEDURE EDO_50_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_50_0_OnReposition};

 PRIVATE PROCEDURE EDO_60_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_60_0_OnReposition};

 PRIVATE PROCEDURE EDO_61_0_OnReposition();
 BEGIN
  AnyEDOrderL_OnReposition();
 END {EDO_61_0_OnReposition};

 PRIVATE PROCEDURE EDOLC_SetVF();
  VAR
   XDoc_Flag: SCAL[2];
   OwnerWin : STRING[];
   OwnerZone: NUMERIC[0];
   Fields   : FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  CONFORM(EDOLC, EDOCause);
  Fields("EDOLC.XDocKind").Modifiable:=~!EDOLC.EDOCause & ~!EDOLC.XDocType &
                                        (EDOLC.XDocType = L_XDoc.xdt_ODoc) &
                                        !EDOCause.XDocKind;
  SETEMPTY(OwnerWin, OwnerZone);
  IF ~!EDOLC.XDocType & !EDOCause.XDocKind & (EDOLC.XDocType = L_XDoc.xdt_ODoc) THEN
   OwnerWin :="ODocKind";
   OwnerZone:=1;
  END;
  Fields("EDOLC.XDocKind").OwnerWindowOriginalName:=OwnerWin;
  Fields("EDOLC.XDocKind").OwnerZoneNumber        :=OwnerZone;
  IF !EDOLC.XDocKind THEN
   SETEMPTY(Fields("v_DocKindStr").Value);
  ELSIF (EDOLC.XDocKind = L_XDoc.EmptyXDocKind) THEN
   Fields("v_DocKindStr").Value:=" ᯮ";
  ELSE
   L_General.CallUs(EDOLC.XDocType = L_XDoc.xdt_ODoc);
   L_General.Assert(SEARCH(ODocKind, ODocKind, EDOLC.XDocKind),
                    "    㬥⮢ " + EDOLC.XDocKind);
   Fields("v_DocKindStr").Value:=ODocKind.SName;
  END;
  XDoc_Flag:=~!EDOLC.EDOCause & ~!EDOCause.XDocType &
             ((EDOLC.XDocType # L_XDoc.xdt_ODoc) | ~!EDOLC.XDocKind);

  Fields("EDOLC.XDoc").Modifiable    :=XDoc_Flag;
  Fields("EDOLC.XDoc").MustBeNonempty:=XDoc_Flag;
 END {EDOLC_SetVF};

 PRIVATE PROCEDURE EDOLCA_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("EDOLC.edcType").Format :=L_EDO.edoctPool;
  RTI.Get().CurZone.Fields("EDOLC.XDocType").Format:=L_XDoc.ref_ShortNames;
 END {EDOLCA_1_OnZoneOpen};

 PRIVATE PROCEDURE EDOLCE_0_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("EDOLC.edcType").Format :=L_EDO.edoctPool;
  RTI.Get().CurZone.Fields("EDOLC.XDocType").Format:=L_XDoc.ref_FullNames;
  IF ACCESS(EDOLC) THEN
   EDOLC_SetVF();
  END;
 END {EDOLCE_0_OnZoneOpen};

 PRIVATE PROCEDURE EDOLC_OnBeforeInsert();
 BEGIN
  EDOLC_SetVF();
 END {EDOLC_OnBeforeInsert};

 PRIVATE PROCEDURE EDOLC_OnAfterEdIns();
 BEGIN
  IF ~!EDOLC.XDoc THEN
   EDOLC.XDocId:=L_XDoc.XDocId(EDOLC.XDocType, EDOLC.XDocKind, EDOLC.XDoc);
  ELSE
   SETEMPTY(EDOLC.XDocId);
  END;
  REPLACE(EDOLC);
 END {EDOLC_OnAfterEdIns};

 PRIVATE PROCEDURE EDOLC_OnAfterEdit();
 BEGIN
  EDOLC_OnAfterEdIns();
 END {EDOLC_OnAfterEdit};

 PRIVATE PROCEDURE EDOLC_OnAfterInsert();
 BEGIN
  EDOLC_OnAfterEdIns();
 END {EDOLC_OnAfterInsert};

 PRIVATE PROCEDURE EDOLC_EDOCause_OnSuccessfulChange();
 BEGIN
  IF ~!EDOLC.EDOCause THEN
   L_General.Assert(SEARCH(EDOCause, EDOCause, EDOLC.EDOCause),
                    "᭮  ");
   EDOLC.edcType :=EDOCause.Type;
   EDOLC.XDocType:=EDOCause.XDocType;
   EDOLC.XDocKind:=EDOCause.XDocKind;
  ELSE
   SETEMPTY(EDOLC.edcType, EDOLC.XDocType, EDOLC.XDocKind);
  END;
  SETEMPTY(EDOLC.XDoc);
  REPLACE(EDOLC);
  EDOLC_SetVF();
 END {EDOLC_EDOCause_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOLC_XDocKind_OnSuccessfulChange();
 BEGIN
  SETEMPTY(EDOLC.XDoc);
  REPLACE(EDOLC);
  IF EDOLC.XDocType = L_XDoc.xdt_ODoc THEN
   L_General.Assert(!EDOLC.XDocKind | SEARCH(ODocKind, ODocKind, EDOLC.XDocKind),
                    " 㬥⮢  ");
  END;
  EDOLC_SetVF();
 END {EDOLC_XDocKind_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOLC_XDocKind_OnAskPhase1();
 BEGIN
  IF ~!EDOLC.XDocKind & SEARCH(ODocKind, ODocKind, EDOLC.XDocKind) THEN
   L_WDO.PositionInOwnerZoneOfActiveField("ODocKind");
  END;
 END {EDOLC_XDocKind_OnAskPhase1};

 PRIVATE PROCEDURE EDOLC_XDocKind_OnAskPhase2();
 BEGIN
  EDOLC.XDocKind:=ODocKind.ODocKind;
  REPLACE(EDOLC);
  EDOLC_XDocKind_OnSuccessfulChange();
 END {EDOLC_XDocKind_OnAskPhase2};

 PRIVATE PROCEDURE EDOLC_XDoc_OnBeforeAskForEdit();
 BEGIN
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_WaitUserChoice,
                               L_XDoc.XDocId(EDOLC.XDocType, EDOLC.XDocKind, EDOLC.XDoc),
                               "EDOrderL.EDOLC_XDoc_OnAfterAsk()");
 END {EDOLC_XDoc_OnBeforeAskForEdit};

 PUBLIC PROCEDURE EDOLC_XDoc_OnAfterAsk();
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
   _XDoc    : L_XDoc.tXDoc;
 BEGIN
  L_XDoc.DecodeXDocId(L_XDoc.ref_XDocId, _XDocType, _XDocKind, _XDoc);
  EDOLC.XDoc:=_XDoc;
  REPLACE(EDOLC);
 END {EDOLC_XDoc_OnAfterAsk};

 PRIVATE PROCEDURE EDOrderL_v_EDOCause_OnSuccessfulChange();
  VAR
   ActiveField: FORM_FIELD;
 BEGIN
  ActiveField:=RTI.Get().CurZone.ActiveField;
  IF   ~!ActiveField.Value THEN
   L_General.CallUs(SEARCH(EDOCause, EDOCause, ActiveField.Value));
   L_General.Assert(EDOCause.Type = L_EDO.edoct_Initial, "  ᭮");
  END;
 END {EDOrderL_v_EDOCause_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_MarkG_OnSuccessfulChange();
  VAR
   ActiveField: FORM_FIELD;
 BEGIN
  ActiveField:=RTI.Get().CurZone.ActiveField;
  IF   ~!ActiveField.Value THEN
   L_General.CallUs(SEARCH(MarkG, MarkG, ActiveField.Value));
   L_General.Assert(MarkG.MarkGT = P_EDOL.MarkGTForEDOGrp(), "  㯯 ப");
   IF    EDOrderL.EDOGrp = L_EDO.grp_Probation THEN
    RTI.Get().CurZone.Fields("BoxNbr").Modifiable:=!ActiveField.Value;
   ELSIF EDOrderL.EDOGrp = L_EDO.grp_CancelPermit THEN
    SAVE(EDOrderL);
    SAVE(EDOLPro);
    L_General.Assert(~!L_BegRWS.GetPermit2MarkGDate(EDOrderL.OcrDate, EDOrderL.TSN, ActiveField.Value),
                     "⭨   ᪠  㯯 ப " + ActiveField.Value);
    RESTORE(EDOrderL);
    RESTORE(EDOLPro);
   END;
  ELSE
   IF    EDOrderL.EDOGrp = L_EDO.grp_Probation THEN
    RTI.Get().CurZone.Fields("BoxNbr").Modifiable:=1;
   END;
  END;
 END {EDOrderL_MarkG_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_BoxNbr_OnSuccessfulChange();
  VAR
   Fields     : FORM_FIELDS;
   ActiveField: FORM_FIELD;
 BEGIN
  Fields     :=RTI.Get().CurZone.Fields;
  ActiveField:=RTI.Get().CurZone.ActiveField;
  IF    EDOrderL.EDOGrp = L_EDO.grp_Probation THEN
   Fields("MarkG").Modifiable:=!ActiveField.Value;
   IF   ~!ActiveField.Value THEN
    L_General.Assert(~!EDOrderL.OcrDate, " 㪠  砫 ⠦஢");
    L_Car.AccessMark(ActiveField.Value, EDOrderL.OcrDate);
    Fields("MarkG").Value:=L_Way.GetMarkG_Soft(Mark.Mark, L_Way.mgt_AccessDriving);
   ELSE
    SETEMPTY(Fields("MarkG").Value);
   END;
  END;
 END {EDOrderL_BoxNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Route_ANY_OnSuccessfulChange();
  VAR
   ActiveField: FORM_FIELD;
 BEGIN
  ActiveField:=RTI.Get().CurZone.ActiveField;
  IF    EDOrderL.EDOGrp = L_EDO.grp_CancelPermit THEN
   IF ~!ActiveField.Value THEN
    SAVE(EDOrderL);
    SAVE(EDOLPro);
    L_General.Assert(~!L_BegRWS.GetPermit2RouteDate(EDOrderL.OcrDate, EDOrderL.TSN, ActiveField.Value),
                     "⭨   ᪠   " + ActiveField.Value);
    RESTORE(EDOrderL);
    RESTORE(EDOLPro);
   END;
  END;
 END {EDOrderL_Route_ANY_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Route_0_OnSuccessfulChange();
 BEGIN
  EDOrderL_Route_ANY_OnSuccessfulChange();
 END {EDOrderL_Route_0_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Route_1_OnSuccessfulChange();
 BEGIN
  EDOrderL_Route_ANY_OnSuccessfulChange();
 END {EDOrderL_Route_1_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Route_2_OnSuccessfulChange();
 BEGIN
  EDOrderL_Route_ANY_OnSuccessfulChange();
 END {EDOrderL_Route_2_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Route_3_OnSuccessfulChange();
 BEGIN
  EDOrderL_Route_ANY_OnSuccessfulChange();
 END {EDOrderL_Route_3_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Route_4_OnSuccessfulChange();
 BEGIN
  EDOrderL_Route_ANY_OnSuccessfulChange();
 END {EDOrderL_Route_4_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Route_5_OnSuccessfulChange();
 BEGIN
  EDOrderL_Route_ANY_OnSuccessfulChange();
 END {EDOrderL_Route_5_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Route_6_OnSuccessfulChange();
 BEGIN
  EDOrderL_Route_ANY_OnSuccessfulChange();
 END {EDOrderL_Route_6_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Route_7_OnSuccessfulChange();
 BEGIN
  EDOrderL_Route_ANY_OnSuccessfulChange();
 END {EDOrderL_Route_7_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Route_8_OnSuccessfulChange();
 BEGIN
  EDOrderL_Route_ANY_OnSuccessfulChange();
 END {EDOrderL_Route_8_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_Route_9_OnSuccessfulChange();
 BEGIN
  EDOrderL_Route_ANY_OnSuccessfulChange();
 END {EDOrderL_Route_9_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_BySum_OnSuccessfulChange();
 BEGIN
  EDOrderL.AllODate:=L_EDO.EDO_AllODateAllowed();
  REPLACE(EDOrderL);
  SetupODate(1);
 END {EDOrderL_BySum_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_AllODate_OnSuccessfulChange();
 BEGIN
  SetupODate(1);
 END {EDOrderL_AllODate_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_ODate_OnSuccessfulChange();
 BEGIN
  IF ~!EDOrderL.ODate THEN
   L_General.Assert(SEARCH(StaffLog, TSN, EDOrderL.TSN, EDOrderL.ODate),
                    " 㪠 ( ) ࠢ  /");
  END;
  SetupODate(0);
 END {EDOrderL_ODate_OnSuccessfulChange};

 PUBLIC PROCEDURE EDOLC_Check(Final: SCAL[2]);
 BEGIN
  ACCESS(EDOrderL);
  IF    SELECT(EDOLC, edcType, EDOrderL.EDOrder, EDOrderL.Row, L_EDO.edoct_Initial) THEN
   L_General.Assert(~NEXT(EDOLC),
                    "  ਪ    ᪮쪮|᭮  ⨯ " +
                    L_Str.PoolItem(L_EDO.edoctPool, L_EDO.edoct_Initial));
  ELSIF Final THEN
   L_General.Error(" 㪠 ᭮");
  END;
  SELECT(EDOLC, EDOrder, , EDOrderL.EDOrder, EDOrderL.Row);
  WHILE OCCURE(EDOLC) DO
   CONFORM(EDOLC, EDOCause);
   L_General.Assert(!EDOLC.XDocType | ~!EDOLC.XDocKind & ~!EDOLC.XDoc,
                    " ᭮ " + EDOLC.EDOCause + "  㪠 㬥");
   L_General.Assert(L_DatTim.IsActive(EDOrder.PrpDate, EDOCause.Begin, EDOCause.Till),
                    "᭮ " + EDOLC.EDOCause + "    " + L_DatTim.DateStr(EDOrder.PrpDate));
   NEXT(EDOLC);
  END; (* WHILE OCCURE(EDOLC) ... *)
 END {EDOLC_Check};

 PUBLIC PROCEDURE AddRoutesFromCauseEDO();
  VAR
   curTSN    : LIKE(Staff.TSN);
   Idx       : NUMERIC[0];
   AlreadyHas: SCAL[2];
   trgVal    : LIKE(EDOLPro.Value);
   curEDOrder: LIKE(EDOrder.EDOrder);
   curRow    : LIKE(EDOrderL.Row);
   LastNbr   : LIKE(EDOLPro.Nbr);
 BEGIN
  curTSN    :=EDOrderL.TSN;
  curEDOrder:=EDOrderL.EDOrder;
  curRow    :=EDOrderL.Row;
  LastNbr   :=0;
  L_General.Assert(~!curTSN, " 㪠 ࠡ⭨");
  SAVE(EDOrderL);
  SELECT(EDOLC, EDOrder, , curEDOrder, curRow);
  WHILE OCCURE(EDOLC) DO
   IF EDOLC.XDocType = L_XDoc.xdt_EDOrder THEN
    SELECT(EDOrderL, EDOLTSN, , EDOLC.XDoc, curTSN);
    WHILE OCCURE(EDOrderL) DO
     IF EDOrderL.EDOGrp = L_EDO.grp_Probation THEN
      SELECT(EDOLPro, EDOrder, , EDOrderL.EDOrder, EDOrderL.Row, P_EDOL.P_Route);
      WHILE OCCURE(EDOLPro) DO
       PROMPT(EDOLPro.EDOrder + " " + EDOLPro.Row + " " + EDOLPro.Property + " " + EDOLPro.PropRow);
       trgVal    :=P_EDOL.Decode_CurEDOLPro();
       AlreadyHas:=0;
       SAVE(EDOLPro);
       SELECT(EDOLPro, EDOrder, , curEDOrder, curRow, P_EDOL.P_Route);
       WHILE OCCURE(EDOLPro) & ~AlreadyHas DO
        AlreadyHas:=(P_EDOL.Decode_CurEDOLPro() = trgVal);
        NEXT(EDOLPro);
       END;
       RESTORE(EDOLPro);
       IF ~AlreadyHas THEN
        SAVE(EDOLPro);
        SETSEL(EDOLPro, Nbr, curEDOrder, curRow);
        IF LAST(EDOLPro) THEN
         LastNbr:=EDOLPro.Nbr + 1;
        END;
        RESTORE(EDOLPro);
        SAVE(EDOrderL);
        L_General.CallUs(SEARCH(EDOrderL, EDOrder, curEDOrder, curRow));
        SAVE(EDOLPro);
        InsertEDOLPro(P_EDOL.P_Route, LastNbr, trgVal);
        RESTORE(EDOLPro);
        RESTORE(EDOrderL);
       END; (* IF ~AlreadyHas ... *)
       NEXT(EDOLPro);
      END; (* WHILE OCCURE(EDOLPro) ... *)
     END; (* IF EDOrderL.EDOGrp = L_EDO.grp_Probation ... *)
     NEXT(EDOrderL);
    END; (* WHILE OCCURE(EDOrderL) ... *)
   END;
   NEXT(EDOLC);
  END; (* WHILE OCCURE(EDOLC) ... *)
  RESTORE(EDOrderL);
  IF ~!RTI.Get().CurZone.Fields("MarkG").Value THEN
   IF LastNbr#0 THEN
    INC(LastNbr);
   ELSE
    SETSEL(EDOLPro, Nbr, curEDOrder, curRow);
    IF LAST(EDOLPro) THEN
     LastNbr:=EDOLPro.Nbr + 1;
    END;
   END;
   ep_InsertEDOLPro_FromField("MarkG", P_EDOL.P_MarkG, LastNbr);
  END;
  ep_PutDataInForm(1);
 END {AddRoutesFromCauseEDO};

 PRIVATE PROCEDURE EDOrderL_ODate_OnAskPhase1();
 BEGIN
  L_General.Assert(~!EDOrderL.TSN, "।⥫쭮 㦭  ࠡ⭨");
 END {EDOrderL_ODate_OnAskPhase1};

 PRIVATE PROCEDURE EDOrderL_ODate_OnAskPhase2();
 BEGIN
  IF EDOrderL.ODate # StaffLog.Date THEN
   EDOrderL.AllODate:=0;
   EDOrderL.ODate   :=StaffLog.Date;
   REPLACE(EDOrderL);
   CONFORM(EDOrderL, Staff);
   L_PRoll.ShtDone_AP(EDOrderL.Closed, 0);
  END;
 END {EDOrderL_ODate_OnAskPhase2};

BEGIN
 L_Events.ExecuteHandler();
END.
