(*
%Copyright   (c) Polak Computer System
%Author      21.06.1999 19:01:14 SAN
%Purpose       ਪ  襭   TSN
%Type        report
%Specific    SYS
%Modified    11.03.2014 18:33:56 POLAK\GAV
%Environment
*)

 MODULE EDOTSN [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_EDO, L_General, L_DatTim, L_OwnData, Str, P_EDOL, L_XDoc, L_ODoc, L_Way,
        L_AvePay, Memo, L_kn;

 PRIVATE VAR
  SubTitle,
  EDOGrpStr: STRING[];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
SubTitle, C, ""
"⭨ " + Staff.TSN + " " + Man.Name, C, ""
EDOGrpStr, L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|                                                                       ⢮ 砥  ⨯ #########|
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ FPCLine:
?, R, ""
?, R, "0"
@
|##################################################################################################### ######|
}
*)

(*
$P{ Line1:
EDOrder.SrcNum, L, ""
EDOrder.Date, L, "D.N.y"
EDOrder.EDOSrc, L, ""
EDOSrc.Name, L, ""
EDOrderL.OcrDate, L, "D.N.y"
EDOrderL.EndDate, L, "D.N.y"
EDOrderL.EDOKind, L, ""
EDOKind.Name, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|ਪ        : ########  ##########     筨: ### ################################                   |
|ਮ ᮡ:  ##########  ##########                                                                  |
| ਪ   : #### ###############################################                                        |
}
*)

(*
$P{ Comment1:
?, L, ""
@
|਩   : ############################################################################################|
}
*)

(*
$P{ Comment2:
?, L, ""
@
|                ############################################################################################|
}
*)

(*
$P{ CauseTop:
?, L, "|"
EDOLC.EDOCause, L, ""
?, L, ""
@
|᭮#     : ### ########################################################################################|
}
*)

(*
$P{ CauseLine:
EDOLC.EDOCause, L, ""
?, L, ""
@
|                ### ########################################################################################|
}
*)

(*
$P{ CauseLine2:
?, L, ""
@
|                    ########################################################################################|
}
*)

(*
$P{ Line3:
EDOGrpStr, L, ""
?, L, ""
EDOGrpStr, L, ""
EDOrderL.BySum, R, "2-"
EDOrderL.ByPrc, R, "1."
@
| ######### : ######################      稭 #########: ######### ######%                          |
}
*)

(*
$P { ODKTop:
?, C, ""
@
|============================================================================================================|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|㬥   |      |ᠭ                                                                             |
|-----------|----------|-------------------------------------------------------------------------------------|
}
*)

(*
$P { ODKLine:
ODocKind.Sign, L, ""
ODoc.ODoc, L, ""
ODoc.Date, L, "D.N.y"
ODoc.Descript, L, ""
@
|### #######|##########|#####################################################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE MakeRepODoc();
  VAR
   From,
   UpTo: DATE;
 BEGIN
  IF SEARCH(ERKN, Notion, TABLE.Get("ODocKind").Id, L_ODoc.erkn_MedicalExaminationAct) &
     SELECT(ODocKind, ERKN, ERKN.ERKN) THEN
   PROMPT("");
   From:=Memo.ud_fr();
   UpTo:=Memo.ud_ut();
   MAKEPART(R, ODKTop, "  ࠭  ਮ  "+L_DatTim.DateStr(From)+"  "+L_DatTim.DateStr(UpTo));
   SELECT(ODoc, TSNDate, , Staff.TSN);
   WHILE OCCURE(ODoc) DO
    NARROWSEL(ODoc, ODocKind);
    IF L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct) THEN
     SRCINSEL(ODoc, LE, , UpTo);
     WHILE OCCURE(ODoc) DO
      PROMPT("." + ODoc.ODoc);
      IF (ODoc.Status # L_ODoc.ods_Canceled) &
         ((L_ODoc.amo_Kind() = L_ODoc.amok_Alcohol) | (L_ODoc.amo_Kind() = L_ODoc.amok_Drugs)) &
         L_DatTim.IsActive_Inc(ODoc.Date, From, UpTo) THEN
       MAKEPART(R, ODKLine);
      END; (* IF (ODoc.Status... *)
      PREV(ODoc);
     END; (* WHILE OCCURE(File) *)
    END; (* IF L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct) *)
    NEXTINEXTENDEDSEL(ODoc, ODocKind);
   END; (* WHILE OCCURE(ODoc) *)
  END;
 END {MakeRepODoc};

 PRIVATE PROCEDURE AcceptableEDOrderL(): SCAL[2];
 BEGIN
  RETURN (EDOrderL.Status = L_EDO.st_Passed) & (EDOrderL.Type # L_EDO.type_Cancel);
 END {AcceptableEDOrderL};

 PRIVATE PROCEDURE GetCauseForEDOL(): STRING[];
 VAR
  S: STRING[];
 BEGIN
  S:=EDOCause.Name;
  CONFORM(EDOrderL, EDOLPro);
  WHILE OCCURE(EDOLPro) DO
   IF (EDOLPro.Property = P_EDOL.P_CauseEntry) & ~!EDOLPro.Value THEN
    S:=S + " (" + EDOLPro.Value + ")";
   END;
   NEXT(EDOLPro);
  END; (* WHILE OCCURE(EDOLPro) ... *)
  RETURN S;
 END {GetCauseForEDOL};

 PRIVATE PROCEDURE GetCauseForEDOLC(): STRING[];
 VAR
  S: STRING[];
 BEGIN
  S:=EDOCause.Name;
  IF ~!EDOLC.XDocId THEN
   S:=S + " (" + L_XDoc.XDocStr(EDOLC.XDocId) + ")";
  END;
  RETURN S;
 END {GetCauseForEDOLC};

 PRIVATE PROCEDURE Make(RepName: STRING[]; trgGroup: L_EDO.tGroup);
  VAR
   EUMode      : SCAL[2];
   From,
   UpTo        : DATE;
   Total,
   i           : NUMERIC[0];
   N           : STRING[30];
   TotByFixInPC: NUMERIC[0][16];
   Rest,
   Comment     : STRING[];
   Cause,
   CommentArr  : STRING[][10];
   MultiCause  : SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Staff), " । ࠡ⭨");
  EUMode:=L_General.KioskExecution_IsRunning();
  IF    trgGroup = L_EDO.grp_Violation THEN
   IF ~EUMode THEN
    UpTo     :=SYSDATE();
    From     :=L_DatTim.IncMonth(L_DatTim.Per(UpTo), -12);
    SubTitle :="ਪ  襭 樯  ।騥 12 楢  "+L_DatTim.DateStr(UpTo);
    EDOGrpStr:="᪠";
   ELSE
    From     :=Memo.ud_fr();
    UpTo     :=Memo.ud_ut();
    SubTitle :="ਪ  襭 樯  ਮ  "+L_DatTim.DateStr(From)+"  "+L_DatTim.DateStr(UpTo);
    EDOGrpStr:="᪠";
   END;
  ELSIF trgGroup = L_EDO.grp_Reward THEN
   From     :=L_DatTim.MINDATE();
   UpTo     :=L_DatTim.MAXDATE();
   SubTitle :="ਪ  ७   ";
   EDOGrpStr:="७";
  ELSE
   L_General.CallUs(0);
  END;

  SETZERO(TotByFixInPC);
  SETSEL(EDOrderL, TSNGrCl, Staff.TSN, trgGroup);
  SRCINSEL(EDOrderL, GE, , From);
  WHILE OCCURE(EDOrderL) & (EDOrderL.Closed <= UpTo) DO
   PROMPT(EDOrderL.EDOrder);
   CONFORM(EDOrderL, EDOrder);
   CONFORM(EDOrderL, EDOKind);
   IF (EDOrder.PrpDate >= From) &
      ((L_EDO.E_EDO_Level(EDOrder.PrpDate) = 0) | (EDOrder.State = L_EDO.st_ordSigned)) &
      AcceptableEDOrderL() THEN
    INC(TotByFixInPC[EDOrderL.FixInPC]);
   END;
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL)... *)

  CONFORM(Staff, Man);
  OPENREP(R, L_General.NameConnection(RepName), Create,
          FontEnlargement, 1.2,
          RightMargin,     5);
  MAKEPART(R, Top, RepName);

  SETZERO(Total, i);
  LOOP
   N:=L_EDO.GetFixInPC_byStr(trgGroup, i);
   IF !N THEN
    EXIT;
   END;
   IF TotByFixInPC[i] # 0 THEN
    INC(Total, TotByFixInPC[i]);
    MAKEPART(R, FPCLine, N, TotByFixInPC[i]);
   END;
   INC(i);
  END; (* LOOP *)
  IF Total > 0 THEN
   MAKEPART(R, FPCLine, "ᥣ 砥", Total);
  END;

  SETSEL(EDOrderL, TSNGrCl, Staff.TSN, trgGroup);
  SRCINSEL(EDOrderL, GE, , From);
  WHILE OCCURE(EDOrderL) & (EDOrderL.Closed <= UpTo) DO
   PROMPT(EDOrderL.EDOrder);
   CONFORM(EDOrderL, EDOrder);
   IF (EDOrder.PrpDate >= From) &
      ((L_EDO.E_EDO_Level(EDOrder.PrpDate) = 0) | (EDOrder.State = L_EDO.st_ordSigned)) &
      AcceptableEDOrderL() THEN
    CONFORM(EDOrderL, EDOKind);
    CONFORM(EDOrder, EDOSrc);

    MAKEPART(R, Line1);

    L_EDO.GetEDOLPropValue(P_EDOL.P_Comments, Comment);
    Str.Format(CommentArr, Comment,  92, LEFT, Rest);
    IF ~!CommentArr[0] THEN
     MAKEPART(R, Comment1, CommentArr[0]);
     i:=1;
     WHILE (i <= HIGH(CommentArr)) & ~!CommentArr[i] DO
      MAKEPART(R, Comment2, CommentArr[i]);
      INC(i);
     END; (* WHILE (i <= HIGH(CommentArr)) &...*)
    END;

    SELECT(EDOLC, edcType, , EDOrderL.EDOrder, EDOrderL.Row);
    SAVE(EDOLC);
    MultiCause:=(~!EDOLC.XDocId | NEXT(EDOLC));
    RESTORE(EDOLC);
    CONFORM(EDOLC, EDOCause);
    IF MultiCause THEN
     Str.Format(Cause, GetCauseForEDOLC(), 88, LEFT, Rest);
    ELSE
     Str.Format(Cause, GetCauseForEDOL(),  88, LEFT, Rest);
    END;
    MAKEPART(R, CauseTop, MultiCause, Cause[0]);
    i:=1;
    WHILE (i <= HIGH(Cause)) & ~!Cause[i] DO
     MAKEPART(R, CauseLine2, Cause[i]);
     INC(i);
    END; (* WHILE (i <= DO *)
    IF MultiCause THEN
     NEXT(EDOLC);
     WHILE OCCURE(EDOLC) DO
      CONFORM(EDOLC, EDOCause);
      Str.Format(Cause, GetCauseForEDOLC(), 88, LEFT, Rest);
      MAKEPART(R, CauseLine, Cause[0]);
      i:=1;
      WHILE (i <= HIGH(Cause)) & ~!Cause[i] DO
       MAKEPART(R, CauseLine2, Cause[i]);
       INC(i);
      END; (* WHILE (i <= DO *)
      NEXT(EDOLC);
     END; (* WHILE OCCURE(EDOLC) ... *)
    END;
    MAKEPART(R, Line3, L_EDO.GetFixInPC_byStr(EDOKind.EDOGrp, EDOrderL.FixInPC));
   END;
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL)... *)
  IF (trgGroup = L_EDO.grp_Violation) & EUMode THEN
   MakeRepODoc();
  END;
  MAKEPART(R, Bot);
  CLOSEREP(R);
  IF ~EUMode THEN
   L_General.SurveyLastReport();
  END;
 END {Make};

 PUBLIC PROCEDURE EDO10();
 BEGIN
  Make("EDO10", L_EDO.grp_Violation);
 END {EDO10};

 PUBLIC PROCEDURE EDO12();
 BEGIN
  Make("EDO12", L_EDO.grp_Reward);
 END {EDO12};

END.
