(*
%Copyright   (c) Polak Computer System
%Author      10.04.1999 16:36:06 SAN
%Purpose     ࠢ  ࠡ⪨ ਪ  ᮭ
%Type        library,to paste
%Specific    16
%Modified    22.01.2014 15:16:19 POLAK\Gina
%Environment
*)

 IMPORT L_General, P_EDOKnd, L_EDO, L_DatTim, L_Adding, L_PRoll, L_Sheet, L_Str, L_Events, L_Man, L_StdFrm, P_EDOL;

 PUBLIC PROCEDURE ᄠ(_s: NUMERIC[0]);
  VAR
   PersonalInfo,
   OldManName,
   NewManName  : STRING[];
 BEGIN
  CONFORM(Staff, Man);
  L_EDO.GetEDOLPropValue(P_EDOL.P_PersonalInfo, PersonalInfo);
  P_EDOL.Decode_PersonalInfo(PersonalInfo, OldManName, NewManName);
  IF _s = +1 THEN
   Man.Name:=NewManName;
  ELSE
   Man.Name:=OldManName;
  END;
  REPLACE(Man);
  SAVE(Staff);
  SELECT(Staff, Man, , Man.Man);
  WHILE OCCURE(Staff) DO
   Staff.Name:=L_Man.GetStaffName();
   REPLACE(Staff);
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RESTORE(Staff);
 END {ᄠ};

 PUBLIC PROCEDURE (_s: NUMERIC[0]);
 BEGIN
  L_EDO.ShtDoneFromEDOrderLClosed();
  IF    _s = +1 THEN
   IF EDOrderL.Type # L_EDO.type_Cancel THEN
    L_EDO.CheckBounds();
   END;
  END;         
 END {};

 PRIVATE PROCEDURE SetManExprValue();
 BEGIN
  ManExpr.Expr:=P_EDOKnd.GetEDOKProSoft(EDOKind.EDOKind, EDOrderL.OcrDate, P_EDOKnd.P_Expr);
  IF ~!ManExpr.Expr THEN
   SEARCH(Expr, Expr, , ManExpr.Expr);
   IF Expr.Source = L_Man.expsrc_External THEN
    L_EDO.StandOnEDOLCauseODoc();
   END;
   IF (Expr.Source = L_Man.expsrc_Internal) |
      (Expr.Source = L_Man.expsrc_External) THEN
    ManExpr.ExprType:=Expr.ExprType;
    ManExpr.Man     :=Staff.Man;
    ManExpr.Date    :=EDOrderL.OcrDate;
    ManExpr._EDOrder:=EDOrderL.EDOrder;
    ManExpr._Row    :=EDOrderL.Row;
    SETEMPTY(ManExpr.DocSer, ManExpr.DocNum, ManExpr.DocGiveS, ManExpr.Comment);
    INSERT(ManExpr);
    CALL(ManExpr._ShtDone());
   END;
  END;
 END {SetManExprValue};

 PRIVATE PROCEDURE CallHandleManExprOnMEDOrderL(_s: NUMERIC[0]; Lev: NUMERIC[0]);
 BEGIN
  INC(Lev);
  IF Lev = 1 THEN
   CallOnMEDOrderL(_s, Lev, PROCREF(HandleManExpr));
  END;
 END {CallHandleManExprOnMEDOrderL};

 PRIVATE PROCEDURE HandleManExpr(_s: NUMERIC[0]; Lev: NUMERIC[0]);
  CONST
   _s_Cancel = -100;
 BEGIN
  IF    _s = +1 THEN
   IF EDOrderL.Type = L_EDO.type_Cancel THEN
    CallHandleManExprOnMEDOrderL(_s_Cancel, Lev);
   ELSE
    IF EDOrderL.Type = L_EDO.type_Correct THEN
     CallHandleManExprOnMEDOrderL(-1, Lev);
    END;
    SetManExprValue();
   END; (* IF EDOrderL.Type ... *)
  ELSIF (_s = -1) | (_s = _s_Cancel) THEN
   IF EDOrderL.Type = L_EDO.type_Cancel THEN
    CallHandleManExprOnMEDOrderL(+1, Lev);
   ELSE
    IF SELECT(ManExpr, MExprEDO, EDOrderL.EDOrder, EDOrderL.Row) THEN
     SETEMPTY(ManExpr._EDOrder, ManExpr._Row);
     REPLACE(ManExpr);
     CALL(ManExpr.EDOrderL_OnBeforeDelete());
     REMOVE(ManExpr);
    END;
    IF EDOrderL.Type = L_EDO.type_Correct THEN
     CallHandleManExprOnMEDOrderL(+1, Lev);
    END;
   END;
  END; (* IF _s = +1 ... *)
 END {HandleManExpr};

 PUBLIC PROCEDURE ७(_s: NUMERIC[0]);
 BEGIN
  L_EDO.ShtDoneFromEDOrderLClosed();
  IF    _s = +1 THEN
   IF EDOrderL.Type # L_EDO.type_Cancel THEN
    L_EDO.CheckBounds();
   END;
  END;
  HandleManExpr(_s, 0);
 END {७};

 PRIVATE PROCEDURE CallOnMEDOrderL(_s: NUMERIC[0]; Lev: NUMERIC[0]; P: PROC);
 BEGIN
  SAVE(EDOrder);
  SAVE(EDOrderL);
  L_EDO.StandOnEDOrder(EDOrder.MEDOrder, EDOrderL.Row);
  P(_s, Lev);
  RESTORE(EDOrder);
  RESTORE(EDOrderL);
 END {CallOnMEDOrderL};

 PRIVATE PROCEDURE SetAddingValues();
 BEGIN
  Adding.TSN     :=EDOrderL.TSN;
  Adding.AddKind :=P_EDOKnd.GetEDOKProStrong(EDOrderL.EDOKind, EDOrder.PrpDate, P_EDOKnd.P_AddKind);
  Adding.From    :=EDOrderL.OcrDate;
  Adding.UpTo    :=EDOrderL.EndDate;
  Adding._EDOrder:=EDOrderL.EDOrder;
  Adding._Row    :=EDOrderL.Row;
  SEARCH(AddKind, AddKind, , Adding.AddKind);
  IF    AddKind.ValType = L_Adding.vt_Prc THEN
   Adding.Value  :=EDOrderL.ByPrc;
   L_General.Assert(!EDOrderL.BySum | (EDOrderL.BySum = 0), "⨬  ⮫쪮 稭  業");
  ELSIF AddKind.ValType = L_Adding.vt_Sum THEN
   Adding.Value  :=EDOrderL.BySum;
   L_General.Assert(!EDOrderL.ByPrc | (EDOrderL.ByPrc = 0), "⨬  ⮫쪮 㬬  㡫");
  END;
 END {SetAddingValues};

 PRIVATE PROCEDURE CallHandleAddingOnMEDOrderL(_s: NUMERIC[0]; Lev: NUMERIC[0]);
 BEGIN
  INC(Lev);
  IF Lev = 1 THEN
   CallOnMEDOrderL(_s, Lev, PROCREF(HandleAdding));
  END;
 END {CallHandleAddingOnMEDOrderL};

 PRIVATE PROCEDURE HandleAdding(_s: NUMERIC[0]; Lev: NUMERIC[0]);
  CONST
   _s_Cancel = -100;
 BEGIN
  IF    _s = +1 THEN
   IF EDOrderL.Type = L_EDO.type_Cancel THEN
    CallHandleAddingOnMEDOrderL(_s_Cancel, Lev);
   ELSE
    IF EDOrderL.Type = L_EDO.type_Correct THEN
     CallHandleAddingOnMEDOrderL(-1, Lev);
    END;
    SetAddingValues();
    INSERT(Adding);
    CALL(Adding.EDOrderL_OnAfterInsert());
   END; (* IF EDOrderL.Type ... *)
  ELSIF (_s = -1) | (_s = _s_Cancel) THEN
   IF EDOrderL.Type = L_EDO.type_Cancel THEN
    CallHandleAddingOnMEDOrderL(+1, Lev);
   ELSE
    L_General.Assert(SELECT(Adding, AdngEDO, EDOrderL.EDOrder, EDOrderL.Row),
                     "  , ନ㥬 ਪ " + EDOrderL.EDOrder);
    SETEMPTY(Adding._EDOrder, Adding._Row);
    REPLACE(Adding);
    IF ((Lev > 0) | (EDOrderL.Type = L_EDO.type_Correct)) &
       (_s # _s_Cancel) THEN
     L_Adding.Adding_SavePrvAsAdding();
    END;
    CALL(Adding.EDOrderL_OnBeforeDelete());
    REMOVE(Adding);
    IF EDOrderL.Type = L_EDO.type_Correct THEN
     CallHandleAddingOnMEDOrderL(+1, Lev);
    END;
   END;
  END; (* IF _s = +1 ... *)
 END {HandleAdding};

 PRIVATE PROCEDURE SetSingleMCFix(trgNbr: LIKE(MCFix.Nbr); trgPropRow: LIKE(EDOLPro.PropRow));
  VAR
   newTill: DATE;
 BEGIN
  IF ((trgNbr = L_Car.mcfn_1) & L_Car.StandOnFirstMCFix(EDOrderL.TSN, EDOrderL.OcrDate)) |
     ((trgNbr = L_Car.mcfn_2) & L_Car.StandOnSecondaryMCFix(EDOrderL.TSN, EDOrderL.OcrDate)) THEN
   newTill:=EDOrderL.OcrDate;
   IF ~!MCFix.Till THEN
    L_StdFrm.Choice(" ९   " + MCFix.BoxNbr + "|" +
                    "।騬 ਪ ⠭   " + L_DatTim.DateStr(MCFix.Till) + ".|" +
                    "騬 ਪ 㤥 ⠭   " + L_DatTim.DateStr(newTill));
   END;
   MCFix.Till:=newTill;
   REPLACE(MCFix);
   SAVE(EDOrderL);
   CALL(MCFix.EDOrderL_OnAfterInsert());
   RESTORE(EDOrderL);
  END;

  IF ~!P_EDOL.GetEDOLProSoft(EDOrderL.EDOrder, EDOrderL.Row, P_EDOL.P_BoxNbr, trgPropRow) THEN
   MCFix.TSN     :=EDOrderL.TSN;
   MCFix.Begin   :=EDOrderL.OcrDate;
   IF !EDOrderL.EndDate THEN
    SETEMPTY(MCFix.Till);
   ELSE
    MCFix.Till   :=EDOrderL.EndDate+1;
   END;
   MCFix.Dschrg  :=Staff.EndDate;
   MCFix._EDOrder:=EDOrderL.EDOrder;
   MCFix._Row    :=EDOrderL.Row;
   MCFix.Nbr     :=trgNbr;
   MCFix.BoxNbr  :=P_EDOL.Decode_CurEDOLPro();
   IF ~!P_EDOL.GetEDOLProSoft(EDOrderL.EDOrder, EDOrderL.Row, P_EDOL.P_JRegime, 00) THEN
    MCFix.JRegime :=P_EDOL.Decode_CurEDOLPro();
   ELSE
    SETEMPTY(MCFix.JRegime);
   END;
   INSERT(MCFix);
   SAVE(EDOrderL);
   CALL(MCFix.EDOrderL_OnAfterInsert());
   RESTORE(EDOrderL);
  END;
 END {SetSingleMCFix};

 PRIVATE PROCEDURE SetMCFixValues();
 BEGIN
  CONFORM(EDOrderL, Staff);

  SetSingleMCFix(L_Car.mcfn_1, 00);
  SetSingleMCFix(L_Car.mcfn_2, 01);
 END {SetMCFixValues};

 PRIVATE PROCEDURE CallHandleMCFixOnMEDOrderL(_s: NUMERIC[0]; Lev: NUMERIC[0]);
 BEGIN
  INC(Lev);
  IF Lev = 1 THEN
   CallOnMEDOrderL(_s, Lev, PROCREF(HandleMCFix));
  END;
 END {CallHandleMCFixOnMEDOrderL};

 PRIVATE PROCEDURE HandleMCFix(_s: NUMERIC[0]; Lev: NUMERIC[0]);
  CONST
   _s_Cancel = -100;
 BEGIN
  IF    _s = +1 THEN
   IF EDOrderL.Type = L_EDO.type_Cancel THEN
    CallHandleMCFixOnMEDOrderL(_s_Cancel, Lev);
   ELSE
    IF EDOrderL.Type = L_EDO.type_Correct THEN
     CallHandleMCFixOnMEDOrderL(-1, Lev);
    END;
    SetMCFixValues();
   END; (* IF EDOrderL.Type ... *)
  ELSIF (_s = -1) | (_s = _s_Cancel) THEN
   IF EDOrderL.Type = L_EDO.type_Cancel THEN
    CallHandleMCFixOnMEDOrderL(+1, Lev);
   ELSE
    IF SELECT(MCFix, MCFixEDO, EDOrderL.EDOrder, EDOrderL.Row) THEN
     SAVE(EDOrderL);
     WHILE OCCURE(MCFix) DO
      CALL(MCFix.EDOrderL_OnBeforeDelete());
      REMOVE(MCFix);
     END; (* WHILE OCCURE(MCFix)...*)
     RESTORE(EDOrderL);

     IF !P_EDOL.GetEDOLProSoft(EDOrderL.EDOrder, EDOrderL.Row, P_EDOL.P_BoxNbr, 01) THEN
      SELECT(MCFix, TSN, , EDOrderL.TSN, L_Car.mcfn_2);
      LOOP
       IF ~OCCURE(MCFix) | (MCFix.Till = EDOrderL.OcrDate) THEN
        EXIT;
       END;
       NEXT(MCFix);
      END;
      IF OCCURE(MCFix) THEN
       SETEMPTY(MCFix.Till);
       REPLACE(MCFix);
      END;
     END;
    ELSE
     IF ~!P_EDOL.GetEDOLProSoft(EDOrderL.EDOrder, EDOrderL.Row, P_EDOL.P_BoxNbr, 00) |
        ~!P_EDOL.GetEDOLProSoft(EDOrderL.EDOrder, EDOrderL.Row, P_EDOL.P_BoxNbr, 01) THEN
      L_General.Error("  ९, ନ㥬 ਪ " + EDOrderL.EDOrder);
     END;
    END;
    IF EDOrderL.Type = L_EDO.type_Correct THEN
     CallHandleMCFixOnMEDOrderL(+1, Lev);
    END;
   END;
  END; (* IF _s = +1 ... *)
 END {HandleMCFix};

 PUBLIC PROCEDURE (_s: NUMERIC[0]);
 BEGIN
  HandleAdding(_s, 0);
 END {};

 PUBLIC PROCEDURE (_s: NUMERIC[0]);
 BEGIN
  HandleAdding(_s, 0);
 END {};

 PUBLIC PROCEDURE 稥(_s: NUMERIC[0]);
 BEGIN
  (* ⮥ ࠢ *)
 END {稥};

 PUBLIC PROCEDURE (_s: NUMERIC[0]);
 BEGIN
  L_EDO.ShtDoneFromEDOrderLClosed();

  IF L_Events.IsAfterEditInsertEvents(MODE) THEN
   IF ~!EDOrderL.EndDate THEN
    CONFORM(EDOrderL, Staff);
    HISTCONF(EDOrderL.EndDate, Staff, StaffLog);
    L_General.Assert(SEARCH(RegList, HumReg, StaffLog.Regime, L_DatTim.Per(EDOrderL.EndDate), L_DatTim.DAY(EDOrderL.EndDate)),
                     "  ० ࠡ "+StaffLog.Regime+"  "+L_DatTim.DateStr(EDOrderL.EndDate));
    IF RegList.Durat=0 THEN
     CONFORM(RegList, RegMain);
     L_StdFrm.Choice(L_DatTim.DateStr(EDOrderL.EndDate)+"  ࠡ稬 .| ࠡ "+RegMain.Regime+" "+L_Str.Left(RegMain.Name, 32));
    END;
   END;
  END;
 END {};

 PUBLIC PROCEDURE ९(_s: NUMERIC[0]);
 BEGIN
  HandleMCFix(_s, 0);
 END {९};

END.
