(*
%Copyright   (c) Polak IT
%Author      25.02.2014 12:15:19 POLAK\San
%Purpose     㦨 ERKN  erkns
%Type        control
%Specific    SYS
%Modified    18.09.2014 16:53:02 POLAK\San
%Environment
*)

 IMPORT L_Events, L_XDoc, L_General, L_WDO, L_APtm, Math, L_DBD, L_StdFrm, P_Cntr, L_DatTim;

 PRIVATE PROCEDURE ERKN_OnInitializeWindow();
 BEGIN
  L_WDO.iZone        (1).Narrowing:="ERKN.EntityId=L_APtm.CurrentEntityId";
  L_WDO.iField       (1, "ERKN.wHistory").Format:="|";
  L_WDO.iProgs       (1, "ERKN");
 END {ERKN_OnInitializeWindow};

 PRIVATE PROCEDURE ERKN_F_OnInitializeWindow();
 BEGIN
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iField       (1, "ERKN.wHistory").Format:="|";
  L_WDO.iProgs       (1, "ERKN");
  L_WDO.iEvents      (2, [L_WDO.e_OnReposition]);
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).Narrowing:="(erkns.ERKN=ERKN.ERKN)";
  L_WDO.iProgs       (2, "ERKN");
 END {ERKN_F_OnInitializeWindow};

 PRIVATE PROCEDURE ERKN_F_OnConformToWindow();
 BEGIN
  IF RTI.Get().CurZone.MasterTable.Name # "dbFile" THEN
   SEARCH(dbFile, dbFile, , RTI.Get().CurZone.MasterTable.Id);
  END;
  GE_WWD_CURSOR(RTI.Get().TrgWindow.Name, ERKN);
  IF ~OCCURE(ERKN) | (ERKN.EntityId # dbFile.dbFile) THEN
   SELECT(ERKN, Name, , dbFile.dbFile);
   SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, ERKN);
  END;
  RTI.Get().TrgWindow.Title:=", 砥 ﬨ 䠩 " + "'" + dbFile.Dscrp + "'";
 END {ERKN_F_OnConformToWindow};

 PRIVATE PROCEDURE ERKN_F_2_OnReposition();
 BEGIN
  IF ACCESS(erkns) THEN
   IF RTI.Get().CurWindow.ParentZone.MasterTable.Id = erkns.fi THEN
    SEARCH((RTI.Get().CurWindow.ParentZone.MasterTable.Name), RECORDID, , erkns.ri);
    SE_WZD_POSITION(RTI.Get().CurWindow.ParentZone.Window.Name, RTI.Get().CurWindow.ParentZone.Number, (RTI.Get().CurWindow.ParentZone.MasterTable.Name));
   END;
  END;
 END {ERKN_F_2_OnReposition};

 PRIVATE PROCEDURE erkns_ERKN_OnBeforeAsk();
 BEGIN
  L_APtm.CurrentEntityId:=RTI.Get().CurWindow.ParentZone.MasterTable.Id;
 END {erkns_ERKN_OnBeforeAsk};

 PRIVATE PROCEDURE erkns_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  L_WDO.iField       (1, "erkns.ERKN").OnBeforeAsk:=1;
  L_WDO.iMayBeEmpty  (1, ["erkns.Till"]);
  L_WDO.iScsChange   (1, ["erkns.ERKN"]);
  L_WDO.iProgs       (1, "ERKN");
 END {erkns_OnInitializeWindow};

 PRIVATE PROCEDURE erkns_OnSetupFields();
 BEGIN
  CONFORM(erkns, ERKN);
  RTI.Get().CurZone.Fields("erkns.Begin").Modifiable:=ERKN.wHistory;
  RTI.Get().CurZone.Fields("erkns.Till" ).Modifiable:=ERKN.wHistory;
 END {erkns_OnSetupFields};

 PRIVATE PROCEDURE erkns_ERKN_OnSuccessfulChange();
  VAR
   trgTable: TABLE;
   trgBegin: DATE;
   begFN,
   dmyFN: STRING[];
 BEGIN
  CONFORM(erkns, ERKN);
  IF ERKN.wHistory THEN
   trgTable:=DATABASE.Get().TableById(erkns.fi);
   L_DBD.CollateValidityFieldNames(trgTable.Name, begFN, dmyFN);
   IF ~!begFN THEN
    SEARCH((trgTable.Name), RECORDID, , erkns.ri);
    trgBegin:=^(trgTable.Fields(begFN).ObtainName());
   ELSE
    SETEMPTY(trgBegin);
   END;
   erkns.Begin:=Math.Max(trgBegin, ERKN.Begin);
   REPLACE(erkns);
  END;
  erkns_OnSetupFields();
 END {erkns_ERKN_OnSuccessfulChange};

 PRIVATE PROCEDURE erkns_OnBeforeModification();
  VAR
   fiName: STRING[];
 BEGIN
  TRY [ABORT_AFTER(AA_ON)]
   fiName:=RTI.Get().CurZone.Window.ParentZone.MasterTable.Name;
   ACCESS((fiName));
   REPLACE((fiName));
  EXCEPT
  END; (* TRY *)
 END {erkns_OnBeforeModification};

 PRIVATE PROCEDURE erkns_OnBeforeInsert();
 BEGIN
  erkns_OnBeforeModification();
 END {erkns_OnBeforeInsert};

 PRIVATE PROCEDURE erkns_OnBeforeEdit();
 BEGIN
  erkns_OnBeforeModification();
  erkns_OnSetupFields();
 END {erkns_OnBeforeEdit};

 PRIVATE PROCEDURE erkns_OnBeforeDelete();
 BEGIN
  erkns_OnBeforeModification();
 END {erkns_OnBeforeDelete};

 PRIVATE PROCEDURE erkns_OnAfterModification();
 BEGIN
  erkns.Name:=L_XDoc.Get_iri_Name(erkns.fi, erkns.ri);
  REPLACE(erkns);
 END {erkns_OnAfterModification};

 PRIVATE PROCEDURE erkns_OnAfterInsert();
 BEGIN
  erkns_OnAfterModification();
 END {erkns_OnAfterInsert};

 PRIVATE PROCEDURE erkns_OnAfterEdit();
 BEGIN
  erkns_OnAfterModification();
 END {erkns_OnAfterEdit};

PRIVATE PROCEDURE CheckConverted(File: STRING[]);
BEGIN
 IF (File = "Route")    |
    (File = "MCList")   |
    (File = "Contract") |
    (File = "ODocKind") |
    (File = "Dest")     |
    (File = "FirmCtc")  |
    (File = "ExitClss") |
    (File = "CIKind")   |
    (File = "CostItem") |
    (File = "AcCut")    THEN
 ELSE
  L_StdFrm.BlueStop("  砥 '祭' ଫ  -஬");
 END;
END {CheckConverted};

 PRIVATE PROCEDURE erkns_OnConformToWindow();
  VAR
   iri: L_General.tInternalRecordId;
 BEGIN
  iri:=L_XDoc.GetCurrent_iri();
  IF SELECT(ERKN, Notion, L_General.iri_fi(iri)) THEN
CheckConverted(DATABASE.Get().TableById(L_General.iri_fi(iri)).Name);
   SELECT(erkns, fi, , L_General.iri_fi(iri), L_General.iri_ri(iri));
   SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, erkns);
   RTI.Get().TrgWindow.Zones(0).Fields("v_OwnName").Value:=L_XDoc.Get_iri_Description(L_General.iri_fi(iri), L_General.iri_ri(iri));
  ELSE
   L_StdFrm.BlueStop("'祭'  ⥪饣 䠩   ।ᬮ७");
  END;
 END {erkns_OnConformToWindow};

 PUBLIC PROCEDURE View_erkns();
 BEGIN
  L_XDoc.LaunchViewingServiceFile("erkns");
 END {View_erkns};

 PUBLIC PROCEDURE View_ERKN_F();
  CONST
   Window2LoadName = "ERKN_F";
  VAR
   Window2Load: FORM_WINDOW;
 BEGIN
  IF SELECT(ERKN, Notion, RTI.Get().CurZone.MasterTable.Id) THEN
   Window2Load:=APP.Get().Forms.Load(Window2LoadName,
                                     Window2LoadName + "<xyz" + RTI.Get().CurWindow.AssignedName + ">",
                                     RTI.Get().CurZone);
   LIKEMENU(View, Window2Load.Name + " 1 " + RTI.Get().CurWindow.Name + " " + RTI.Get().CurZone.Number);
  ELSE
   L_StdFrm.BlueStop("'祭'  ⥪饣 䠩   ।ᬮ७");
  END;
 END {View_ERKN_F};

BEGIN
 L_Events.ExecuteHandler();
END.