(*
%Copyright   (c) Polak Computer System
%Author      01.08.1997 19:04:17 GINA
%Purpose      ணࠬ । ⥪饩 
%Type        operation
%Specific    SYS
%Modified    04.07.2014 14:57:31 POLAK\LDA
%Environment
*)

 MODULE ExpData [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PRIVATE TYPE
  tPut = SCAL[3];

 PRIVATE CONST
  p_OneRecord      = 0;
  p_Family         = 1;
  p_Family_wGuides = 2;

 PUBLIC PROCEDURE acl_CreateNew();
 BEGIN
  L_Exp.acl_CreateNew();
 END {acl_CreateNew};

 PUBLIC PROCEDURE tool_CreateNew();
 BEGIN
  L_General.SilentPrgsOnly();
  L_Exp.tool_CreateNew();
 END {tool_CreateNew};

 PUBLIC PROCEDURE Term();
 BEGIN
  L_Exp.Term();
  LIKEMENU(Survey, "");
 END {Term};

 PRIVATE PROCEDURE Put(p: tPut; ect: L_Exp.tExistanceCheckType);
 BEGIN
  L_Exp.OpenToAppend();
  L_General.Assert(~!(GE_CURFILE()) & ACCESS(^(GE_CURFILE())), " ⨬?");
  IF p = p_OneRecord         THEN
   L_Exp.PutOneRecord     (GE_CURFILE(), 0, ect);
  ELSIF p = p_Family         THEN
   L_Exp.PutFamily        (GE_CURFILE(), 0, ect);
  ELSIF p = p_Family_wGuides THEN
   L_Exp.PutFamily_wGuides(GE_CURFILE(), 0, ect);
  ELSE
   L_General.CallUs();
  END;
  L_Exp.Close();
 END {Put};

 PRIVATE PROCEDURE PutOneRecord(ect: L_Exp.tExistanceCheckType);
 BEGIN
  Put(p_OneRecord, ect);
 END {PutOneRecord};

 PUBLIC PROCEDURE PutOneRecord_Insert();
 BEGIN
  PutOneRecord(L_Exp.ect_StrongInsert);
 END {PutOneRecord_Insert};

 PUBLIC PROCEDURE PutOneRecord_Replace();
 BEGIN
  PutOneRecord(L_Exp.ect_ReplaceExistent);
 END {PutOneRecord_Replace};

 PRIVATE PROCEDURE PutFamily(ect: L_Exp.tExistanceCheckType);
 BEGIN
  Put(p_Family, ect);
 END {PutFamily};

 PUBLIC PROCEDURE PutFamily_Insert();
 BEGIN
  PutFamily(L_Exp.ect_StrongInsert);
 END {PutFamily_Insert};

 PUBLIC PROCEDURE PutFamily_Replace();
 BEGIN
  PutFamily(L_Exp.ect_ReplaceExistent));
 END {PutFamily_Replace};

 PRIVATE PROCEDURE PutFamily_wGuides(ect: L_Exp.tExistanceCheckType);
 BEGIN
  Put(p_Family_wGuides, ect);
 END {PutFamily_wGuides};

 PUBLIC PROCEDURE PutFamily_wGuides_Insert();
 BEGIN
  PutFamily_wGuides(L_Exp.ect_StrongInsert);
 END {PutFamily_wGuides_Insert};

 PUBLIC PROCEDURE PutFamily_wGuides_Replace();
 BEGIN
  PutFamily_wGuides(L_Exp.ect_ReplaceExistent));
 END {PutFamily_wGuides_Replace};

 PUBLIC PROCEDURE PutAllRecord_Replace();
  VAR
   trgFile,
   trgIndex         : STRING[];
   i, j,
   React,
   Amount           : NUMERIC[0];
   AllRecordInSelect: SCAL[2];
 BEGIN
  trgFile :=GE_CURFILE();
  trgIndex:=TABLE.Get(trgFile).Indexes(0).Name;
  SELECT(^trgFile, ^trgIndex);
  L_General.Assert(OCCURE(^trgFile), " ⠭ ⥪騩 ᥫ");
  React:=STDFORM("ᯮ ᥩ ⥪e ᥫ 䠩 " + trgFile + "|" +
                 "|%< >DB %<쪮 ⬥祭 >B %<⮯!>X",
                  trgFile,
                 INFORM,
                 1);
  AllRecordInSelect:=React = 1;

  L_Exp.OpenToAppend();

  SETZERO(i, j, Amount);
  WHILE OCCURE(^trgFile) DO
   IF i = 1000 THEN
    PROMPT("ࠡ⪠ " + L_Str.IntStr(j/1000));
    i:=0;
   END;

   IF AllRecordInSelect | WITHLAB(^trgFile, 0) THEN
    IF Amount = 0 THEN
    END;
    IF ~AllRecordInSelect THEN
     RESETLAB(^trgFile, 0);
     REPLACE(^trgFile);
    END;

    SAVE(^trgFile);
    L_Exp.PutOneRecord(trgFile, 1, L_Exp.ect_ReplaceExistent);
    RESTORE(^trgFile);
    INC(Amount);
   END;
   INC(i);
   INC(j);
   NEXT(^trgFile);
  END; (* WHILE OCCURE(^trgFile) ... *)

  IF Amount # 0 THEN
   L_StdFrm.Inform("㦥 " + L_Str.IntStr(Amount) + " ᥩ");
  ELSE
   L_StdFrm.RedInform(" ᯮ஢   ");
  END;
 END {PutAllRecord_Replace};

END.
