(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose     ஫ 
%Type        control
%Specific    SYS
%Modified    24.07.2013 13:39:02 POLAK\GAV
%Environment
*)

 MODULE Firm [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, P_Firm, L_StdFrm, Str, L_Str,
        L_Events, L_Prop, L_WDO, L_AFM, L_AR, L_Pmnt, L_Acnt,
        L_Cntr, L_XDoc, L_Math, L_PDoc, L_r2r;

 PRIVATE PROCEDURE TestSilentD();
  VAR
   _FirmAcnt: LIKE(FirmAcnt.FirmAcnt);
   _Begin,
   _Till    : DATE;
   Msg      : STRING[];
 BEGIN
  CONFORM(Firm, FirmAcnt);
  L_AFM.MakeIndex("_FAcn", "Begin   : DATE;"+
                           "Till    : DATE;"+
                           "FirmAcnt: LIKE(FirmAcnt.FirmAcnt)");
  WHILE OCCURE(FirmAcnt) DO
   IF FirmAcnt.SilentD THEN
    ADD(_FAcn, _FAcn, , FirmAcnt.Begin, FirmAcnt.Till, FirmAcnt.FirmAcnt);
   END;
   NEXT(FirmAcnt);
  END; (* WHILE OCCURE(FirmAcnt) ... *)

  Msg:="";
  IF SELECT(_FAcn, _FAcn) THEN
   SETEMPTY(_FirmAcnt);
   WHILE OCCURE(_FAcn) DO
    IF ~!_FirmAcnt THEN
     L_General.Assert(_Begin # _FAcn.Begin,
                      "᪮쪮  ⮢  "+L_DatTim.DateStr(_FAcn.Begin)+"|| "+_FirmAcnt+"  "+_FAcn.FirmAcnt);
     IF _Till < _FAcn.Begin THEN
      Msg:=Msg+"| ਮ  "+L_DatTim.DateStr(_Till)+"  "+L_DatTim.DateStr(_FAcn.Begin);
     END;
    END;
    _FirmAcnt:=_FAcn.FirmAcnt;
    _Begin   :=_FAcn.Begin;
    _Till    :=_FAcn.Till;
    NEXT(_FAcn);
   END; (* WHILE OCCURE(_FAcn) ... *)
   IF _Till < SYSDATE() THEN
    Msg:=Msg+"| "+L_DatTim.DateStr(_Till);
   END;
  ELSE
   Msg:="  "+L_DatTim.DateStr(SYSDATE());
  END;
  IF ~!Msg THEN
   L_StdFrm.Choice(" 㪠  " + Msg);
  END;
 END {TestSilentD};

 PRIVATE PROCEDURE CheckFillingINN();
  VAR
   _Firm,
   _Head,
   _Head1: LIKE(Firm.Firm);
   _INN,
   _INN1: LIKE(Firm._INN);
   _Date: DATE;
   _Cnt : NUMERIC[0];
   S    : STRING[];
 BEGIN
  SAVE(Firm);
  SETZERO(_Cnt);
  IF SELECT(FirmPro, Firm, Firm.Firm, P_Firm.P_INN) THEN
   LAST(FirmPro);
   _Date:=MAXOF(DATE);
   _INN:=Firm._INN;
   _Head:=P_Firm.FP_HeadFirm(Firm.Firm, _Date);
   _Firm:=Firm.Firm;
   IF ~!_Head THEN
    SEARCH(Firm, Firm, , _Head);
    IF _INN # Firm._INN THEN
     L_StdFrm.Choice(" 䨫 "+_Firm+"   ࣠樨 "+Firm.Firm+"  ᮢ !");
    END;
   END;
   SETEMPTY(S);
   SELECT(Firm, INN, , Firm._INN);
   WHILE OCCURE(Firm) DO
    _INN1:=P_Firm.GetFirmProSoft(Firm.Firm, _Date, P_Firm.P_INN);
    IF (Firm.Firm # _Firm) & (Firm.Firm # _Head) & (_INN1 = _INN) THEN
     _Head1:=P_Firm.FP_HeadFirm(Firm.Firm, _Date);
     IF (!_Head | (_Head # _Head1)) & (_Firm # _Head1) THEN
      INC(_Cnt);
      S:=S + Str.Align(Firm.Firm + " " + Firm.Name, 55, LEFT) +"|";
     END
    END;
    NEXT(Firm);
   END; (* WHILE OCCURE(Firm) ...*)
   IF _Cnt > 0 THEN
    SETZERO(_Cnt);
    STDFORM("%L55,10<"+ S +"|>I"+L_Str.Repeat("|", 10)+  
            "|" + L_StdFrm.DrawButton( "!", 11, "FX") + " " + L_StdFrm.DrawButton("믮", 11, "B"),
            "  ࠣ  㪠  ", STOP, -1, _Cnt);
   END;
  ELSE
   SETEMPTY(Firm._INN);
   REPLACE(Firm);
  END;
  RESTORE(Firm);
 END {CheckFillingINN};

 PRIVATE PROCEDURE CondPutFirmData(_Property: LIKE(Property.Property); _Value: STRING[]);
 BEGIN
  IF ~!_Value THEN
   IF ~SEARCH(FirmPro, Firm, Firm.Firm, _Property, Firm.Begin) THEN
    DEFAULT(FirmPro);
    FirmPro.Firm    :=Firm.Firm;
    FirmPro.Property:=_Property;
    INSERT(FirmPro);
   END;
   FirmPro.Date    :=Firm.Begin;
   FirmPro.Value   :=_Value;
   IF _Property = P_Firm.P_INN THEN
    FirmPro.SpdSrchV:=_Value;
   END;
   REPLACE(FirmPro);
   L_Prop.SupportEndDate("FirmPro", _Property, 1);
   CALL(ObjPro.UpdateVal2Show("FirmPro"));
  END; (* IF ~!_Value *)
 END {CondPutFirmData};

 PRIVATE PROCEDURE StandOnRegNameByFirmBegin(): SCAL[2];
 BEGIN
  RETURN P_Firm.HasActualFirmPro(Firm.Firm, Firm.Begin, P_Firm.P_RegName) |
         (SELECT(FirmPro, Firm, Firm.Firm, P_Firm.P_RegName) & SRCINSEL(FirmPro, GE, Firm.Begin));
 END {StandOnRegNameByFirmBegin};

 PRIVATE PROCEDURE CondPutRegName(_HeadFirm, _PersonFullName, _BranchName, _ContractorBriefName, _BranchFullName: STRING[]);
 BEGIN
  IF ~StandOnRegNameByFirmBegin() THEN
   DEFAULT(FirmPro);
   FirmPro.Firm    :=Firm.Firm;
   FirmPro.Property:=P_Firm.P_RegName;
   INSERT(FirmPro);
  END;
  FirmPro.Date  :=Firm.Begin;
  IF Firm.PrtnrTyp = P_Firm.pt_Branch THEN
   P_Firm.Encode_RegName(FirmPro.Value, Firm.PrtnrTyp, _HeadFirm, _PersonFullName, _BranchName, _ContractorBriefName, _BranchFullName);
  ELSE
   P_Firm.Encode_RegName(FirmPro.Value, Firm.PrtnrTyp, "",        _PersonFullName, "",          _ContractorBriefName, "");
  END;
  REPLACE(FirmPro);
  L_Prop.SupportEndDate("FirmPro", P_Firm.P_RegName, 1);
  CALL(ObjPro.UpdateVal2Show("FirmPro"));
 END {CondPutRegName};

 PRIVATE PROCEDURE SetWindFieldModifiable(IsInsert: SCAL[2]);
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("PrtnrTyp"           ).Modifiable:=IsInsert;
  Fields("Firm._INN"          ).Modifiable:=IsInsert & (Firm.PrtnrTyp # P_Firm.pt_Branch);
  Fields("PersonFullName"     ).Modifiable:=IsInsert & ~P_Firm.PartnerTypeIsPhysicalBody(Firm.PrtnrTyp);
  Fields("BranchName"         ).Modifiable:=IsInsert;
  Fields("BranchFullName"     ).Modifiable:=IsInsert;
  Fields("ContractorBriefName").Modifiable:=IsInsert & ~P_Firm.PartnerTypeIsPhysicalBody(Firm.PrtnrTyp);
  Fields("HeadFirm"           ).Modifiable:=IsInsert;
 END {SetWindFieldModifiable};

 PRIVATE PROCEDURE SetWindFieldVisible();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("HeadFirm"      ).Visible:=Firm.PrtnrTyp = P_Firm.pt_Branch;
  Fields("HeadFirm_Name" ).Visible:=Firm.PrtnrTyp = P_Firm.pt_Branch;
  Fields("BranchName"    ).Visible:=Firm.PrtnrTyp = P_Firm.pt_Branch;
  Fields("BranchFullName").Visible:=Firm.PrtnrTyp = P_Firm.pt_Branch;
 END {SetWindFieldVisible};

 PRIVATE PROCEDURE Firm_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "FirmAcnt");
  L_WDO.iField       (1, "PrtnrTyp").Format:=P_Firm.pt_Pool;
 END {Firm_OnInitializeWindow};

 PRIVATE PROCEDURE FirmAcnt_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Firm";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "Firm.Name").First:=1;
  L_WDO.iScsChange   (0, ["HeadFirm", "PrtnrTyp"]);
  L_WDO.iUnmodifiable(0, ["HeadFirm_Name", "Firm.Firm",
                          "asParntTyp3", "asPrtnrTyp3", "asPrtnrTyp2", "asPrtnrTyp1"]);
  L_WDO.iMayBeEmpty  (0, ["BranchFullName", "Firm._INN", "Firm.Till"]);
  L_WDO.iField       (0, "PrtnrTyp").Format:=P_Firm.pt_Pool;
  L_WDO.iSubwindow   (1, "FirmAcnE");
  L_WDO.iField       (1, "FirmAcnt.Type").Format:=P_Firm.fat_Pool;
  IF !L_WDO.iZone(1).Window.AskSourceField THEN
   L_WDO.iZone(1).PermanentFilter:=L_PDoc.GetFilterValueForOnlyBankFirmAcnt();
  END;
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.CreateFormLink("Firm", "Head");
 END {FirmAcnt_OnInitializeWindow};

 PRIVATE PROCEDURE FirmAcnE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "FirmAcnt.BankBrn").OwnerWindowOriginalName:="BankE";
  L_WDO.iField       (0, "FirmAcnt.BankBrn").OwnerZoneNumber:=2;
  L_WDO.iField       (0, "FirmAcnt.Type").Format:=P_Firm.fat_Pool;
  L_WDO.iScsChange   (0, ["FirmAcnt.Type"]);
  L_WDO.iMayBeEmpty  (0, ["FirmAcnt.Till", "FirmAcnt.Name", "FirmAcnt.BankBrn"]);
 END {FirmAcnE_OnInitializeWindow};

 PRIVATE PROCEDURE Firm_OnBeforeEdIns();
 BEGIN
  L_AR.GrantRightsForInteractiveModification();
 END {Firm_OnBeforeEdIns};

 PRIVATE PROCEDURE Firm_OnBeforeInsert();
 BEGIN
  Firm_OnBeforeEdIns();
 END {Firm_OnBeforeInsert};

 PRIVATE PROCEDURE Firm_OnBeforeEdit();
 BEGIN
  Firm_OnBeforeEdIns();
 END {Firm_OnBeforeEdit};

 PRIVATE PROCEDURE Firm_OnBeforeDelete();
 BEGIN
  L_r2r.Owner_OnBeforeDelete("Firm");
 END {Firm_OnBeforeDelete};

 PRIVATE PROCEDURE Firm_PrtnrTyp_OnSuccessfulChange();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF P_Firm.PartnerTypeIsPhysicalBody(Firm.PrtnrTyp) THEN
   L_General.Assert(!Fields("PersonFullName").Value | (Firm.Name = Fields("PersonFullName").Value),
                    "    ");
   L_General.Assert(!Fields("ContractorBriefName").Value | (Firm.Name = Fields("ContractorBriefName").Value),
                    "  ᮪饭  ࠣ");
  ELSIF Firm.PrtnrTyp = P_Firm.pt_Branch THEN
   L_General.Assert(~!Fields("HeadFirm").Value | !Firm._INN, "  ");
  END;
  SetWindFieldVisible();
  SetWindFieldModifiable(RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert);
 END {Firm_PrtnrTyp_OnSuccessfulChange};

 PRIVATE PROCEDURE Firm__OnSuccessfulChange();
  VAR
   Fields           : FORM_FIELDS;
   trgINN           : LIKE(Firm._INN);
   trgPersonFullName: STRING[];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF RTI.Get().CurZone.ActiveField.Name = "HeadFirm" THEN
   P_Firm.CheckHeadFirm(Fields("HeadFirm").Value, Firm.Begin);
   trgPersonFullName:=P_Firm.FP_PersonFullName(Fields("HeadFirm").Value, Firm.Begin);
   IF !Fields("PersonFullName").Value | (Fields("PersonFullName").Value = trgPersonFullName) |
      (STDFORM("|     :" +
               "||" + trgPersonFullName +
               "||" + L_StdFrm.DrawButton("", 12, "X") +
               L_StdFrm.DrawButton(" {}⠢ 饥 ", 23, "B") +
               L_StdFrm.DrawButton(" {} ", 12, "DB"), , INFORM, -1) = 2) THEN
    Fields("PersonFullName").Value:=trgPersonFullName;
   END;
   SAVE(Firm);
   IF ~!Fields("HeadFirm").Value & SEARCH(Firm, Firm, Fields("HeadFirm").Value) THEN
    trgINN:=Firm._INN;
   END;
   RESTORE(Firm);
   Firm._INN:=trgINN;
   REPLACE(Firm);
  END;
 END {Firm__OnSuccessfulChange};

 PRIVATE PROCEDURE ReplicationFirmNameToContracts();
 BEGIN
  L_AR.GrantRightsForInteractiveModification();
  CALL(Contract.ReplicationFirmNameToContracts(Firm.Firm));
 END {ReplicationFirmNameToContracts};

 PRIVATE PROCEDURE Firm_OnAfterEdIns();
 BEGIN
  TestSilentD();
  IF !Firm._INN THEN
   IF Firm.PrtnrTyp # P_Firm.pt_Branch THEN
    L_StdFrm.Choice("ࠣ " + Firm.Firm + ":   .|" +
                    " ⢨⥫쭮  㤥  㪠뢠 ?");
   END;
  ELSE
   P_Firm.Check_INN(Firm._INN);
  END;
  IF ~!Firm._INN | (Firm.PrtnrTyp # P_Firm.pt_Man) THEN
   CheckFillingINN();
  END;

  SELECT(MyFirm, Firm, , Firm.Firm);
  WHILE OCCURE(MyFirm) DO
   P_Firm.FillmfBnkAcn(1);
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)

  ReplicationFirmNameToContracts();
 END {Firm_OnAfterEdIns};

 PRIVATE PROCEDURE InsertRequiredFirmProperty(HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName: STRING[]);
 BEGIN
  CondPutRegName(HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
  CondPutFirmData(P_Firm.P_INN, Firm._INN);
 END {InsertRequiredFirmProperty};

 PUBLIC PROCEDURE extInsertRequiredFirmProperty();
 BEGIN
  InsertRequiredFirmProperty(Firm.Name, Firm.Name, Firm.Name, Firm.Name, Firm.Name);
 END {extInsertRequiredFirmProperty};

 PUBLIC PROCEDURE Firm_OnAfterInsert();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  IF P_Firm.PartnerTypeIsPhysicalBody(Firm.PrtnrTyp) THEN
   InsertRequiredFirmProperty("", Firm.Name, "", Firm.Name, "");
  ELSE
   Fields:=RTI.Get().CurZone.Fields;
   InsertRequiredFirmProperty(Fields("HeadFirm").Value, Fields("PersonFullName").Value, Fields("BranchName").Value, Fields("ContractorBriefName").Value, Fields("BranchFullName").Value);
  END;
  Firm_OnAfterEdIns();
 END {Firm_OnAfterInsert};

 PRIVATE PROCEDURE Firm_OnAfterEdit();
 BEGIN
  Firm_OnAfterEdIns();
 END {Firm_OnAfterEdit};

 PUBLIC PROCEDURE Firm_0_SetFields(Fields: FORM_FIELDS; Force: SCAL[2]);
  VAR
   Dummy : P_Firm.tPartnerType;
 BEGIN
  IF Force | (ACCESS(Firm) & P_Firm.HasActualFirmPro(Firm.Firm, SYSDATE()+9999, P_Firm.P_RegName)) THEN
   P_Firm.Decode_RegName(FirmPro.Value, Dummy, Fields("HeadFirm").Value, Fields("PersonFullName").Value, Fields("BranchName").Value,
                         Fields("ContractorBriefName").Value, Fields("BranchFullName").Value);
  ELSE
   SETEMPTY(Fields("HeadFirm").Value, Fields("PersonFullName").Value, Fields("BranchName").Value,
            Fields("ContractorBriefName").Value, Fields("BranchFullName").Value);
  END;
  SetWindFieldVisible();
 END {Firm_0_SetFields};

 PRIVATE PROCEDURE FirmAcnt_0_OnReposition();
 BEGIN
  Firm_0_SetFields(RTI.Get().CurZone.Fields, 0);
(*0095118*)
  SetWindFieldModifiable(~!RTI.Get().CurProcess & (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert));
 END {FirmAcnt_0_OnReposition};

(*
$P{ pcb_Top:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
?, C, ""
@
######################################################################################### ########## #####
=#####====================================================================================================
|########################################################################################################|
|########################################################################################################|
|--------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ pcb_CntrTop:
?, L, ""
@
|########################################################################################################|
}
*)

(*
$P{ pcb_SubTop:
@
|========================================================================================================|
|                                                                    |            |           ।|
|--------------------------------------------------------------------|-----------------|-----------------|
}
*)

(*
$P{ Line:
?, L, ""
?, R, ",2-"
?, R, ",2-"
@
|####################################################################|#################|#################|
}
*)

(*
$P{ Bot:
@
=(c) Polak================================================================================================
}
*)

 PRIVATE PROCEDURE pcb_PrintLine(_CirType: SCAL[2];
                                 Text    : STRING[];
                                 _Value  : L_Pmnt.tValuesToBalance);
 BEGIN
  IF !_CirType THEN
   IF _Value[L_Pmnt.vtb_Total] < 0 THEN
    _CirType:=L_Acnt.ct_Credit;
    _Value:=L_Pmnt.vtbInv(_Value);
   ELSE
    _CirType:=L_Acnt.ct_Debit;
   END;
  END;
  IF _CirType = L_Acnt.ct_Debit THEN
   MAKEPART(R, Line, Text, _Value[L_Pmnt.vtb_Total],                         );
  ELSE
   MAKEPART(R, Line, Text,                         , _Value[L_Pmnt.vtb_Total]);
  END;
 END {pcb_PrintLine};

 PRIVATE PROCEDURE pcb_PrintSaldo(Text    : STRING[];
                                  _Value  : L_Pmnt.tValuesToBalance);
 BEGIN
  pcb_PrintLine(EMPTYOF(SCAL[2]), Text, _Value);
 END {pcb_PrintSaldo};

 PUBLIC PROCEDURE MakeFrBlP();
  CONST
   RepName = "FrBlP";
  VAR
   FullInB,
   FullB,
   InB,
   dCir,
   cCir    : L_Pmnt.tValuesToBalance;
   dCirTot,
   cCirTot : NUMERIC[2];
   Alive   : SCAL[2];
   MyFirms : P_Firm.tMyFirm[64];
   mfAmount: NUMERIC[0];
   _MyFirm : LIKE(MyFirm.MyFirm);
 BEGIN
  L_General.Assert(ACCESS(Firm), " ⠭ ⥪騩 ࠣ");
  SETEMPTY(MyFirms);
  mfAmount:=0;
  L_General.Assert(SELECT(Contract, Firm, Firm.Firm), "ࠣ   ஢");
  WHILE OCCURE(Contract) DO
   L_Math.Math_InsInOrderedArray(MyFirms, mfAmount, Contract.MyFirm);
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
  IF mfAmount > 1 THEN
   _MyFirm:=P_Firm.extDefineMyFirm(SYSDATE(), MyFirms);
  ELSE
   _MyFirm:=MyFirms[0];
  END;
 
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, pcb_Top, P_Firm.MyFirmName(_MyFirm, SYSDATE()), RepName,
                       "  ਮ  "  + L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut()),
                       "ࠣ " + Firm.Firm + " " + P_Firm.FP_FirmName(Firm.Firm, Memo.ud_ut()));
  L_AFM.MakeIndex("tmp", "Contract: LIKE(Contract.Contract)");
  SETZERO(FullInB);
  SELECT(Contract, Firm, , Firm.Firm);
  WHILE OCCURE(Contract) DO
   PROMPT(Contract.Contract);
   IF Contract.MyFirm = _MyFirm THEN
    L_Pmnt.PrepareContractBalanceHistory(Contract.Contract,
                                         L_DatTim.IncMonth(L_DatTim.Per(Memo.ud_fr()), -1),
                                         Memo.ud_ut());
    Alive:=L_DatTim.IsActiveInIntvl_Inc(Memo.ud_fr(), Memo.ud_ut(), Contract.Begin, Contract.Till);
    IF SELECT(CnBHs, CnBHs, Contract.XObject) THEN
     IF SRCINSEL(CnBHs, LT, Memo.ud_fr()) THEN
      InB:=CnBHs.Balance;
     ELSE
      SETZERO(InB);
     END;
     IF InB[L_Pmnt.vtb_Total] = 0 THEN
      Alive:=SRCINSEL(CnBHs, GE, Memo.ud_fr());
     ELSE
      Alive:=1;
     END;
     IF Alive THEN
      FullInB:=L_Pmnt.vtbAdd(FullInB, InB);
      ADD(tmp, tmp, , Contract.Contract);
      MAKEPART(R, pcb_CntrTop, " " + L_Cntr.ContractNbr() + "  " +
                               L_DatTim.DateStr(Contract.SrcDate) + " " + Contract.Name);
     END;
    END;
    L_AFM.AF_PurgeTemp("CnBHs");
   END;
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)

  MAKEPART(R, pcb_SubTop);
  SETZERO(dCirTot, cCirTot, FullB);
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   SEARCH(Contract, Contract, , tmp.Contract);
   PROMPT(Contract.Contract);
   L_Pmnt.PrepareContractBalanceHistory(Contract.Contract,
                                        L_DatTim.IncMonth(L_DatTim.Per(Memo.ud_fr()), -1),
                                        Memo.ud_ut());
   SELECT(CnBHs, CnBHs, , Contract.XObject);
   MAKEPART(R, Line, " " + L_Cntr.ContractNbr() + "  " +
                            L_DatTim.DateStr(Contract.SrcDate) + " " + Contract.Name);

   IF SRCINSEL(CnBHs, LT, Memo.ud_fr()) THEN
    InB:=CnBHs.Balance;
   ELSE
    SETZERO(InB);
   END;
   SETZERO(dCir, cCir);
   pcb_PrintSaldo("   줮  " + L_DatTim.DateStr(Memo.ud_fr()), InB);
   IF SRCINSEL(CnBHs, GE, Memo.ud_fr()) THEN
    WHILE OCCURE(CnBHs) DO
     IF CnBHs.CirType = L_Acnt.ct_Debit THEN
      dCir:=L_Pmnt.vtbAdd(dCir, CnBHs.Value);
     ELSE
      cCir:=L_Pmnt.vtbAdd(cCir, CnBHs.Value);
     END;
     pcb_PrintLine(CnBHs.CirType, "     " + L_XDoc.extXDocStr(CnBHs.XDocId, L_XDoc.xdast_wSrcNbr), CnBHs.Value);
     NEXT(CnBHs);
    END; (* WHILE OCCURE(CnBHs) *)
   END;
   LAST(CnBHs);
   MAKEPART(R, Line, "   ⮣   ਮ", dCir[L_Pmnt.vtb_Total], cCir[L_Pmnt.vtb_Total]);
   pcb_PrintSaldo("   줮  " + L_DatTim.DateStr(Memo.ud_ut()+1), CnBHs.Balance);
   INC(dCirTot, dCir[L_Pmnt.vtb_Total]);
   INC(cCirTot, cCir[L_Pmnt.vtb_Total]);
   FullB:=L_Pmnt.vtbAdd(FullB, CnBHs.Balance);
   L_AFM.AF_PurgeTemp("CnBHs");
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)

  MAKEPART(R, Line, " 楫  ࠣ");
  pcb_PrintSaldo("   줮  " + L_DatTim.DateStr(Memo.ud_fr()), FullInB);
  MAKEPART(R, Line, "     ਮ", dCirTot, cCirTot);
  pcb_PrintSaldo("   줮  " + L_DatTim.DateStr(Memo.ud_ut()+1), FullB);
 
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("tmp");
  LIKEMENU(Survey, "");
 END {MakeFrBlP};

 PUBLIC PROCEDURE Fill_ContractorBriefNameInP7101();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  P_Firm.Fill_ContractorBriefName(Fields("ContractorBriefName").Value, FirmPro.Date, Fields("PrtnrTyp").Value,
                                  Fields("HeadFirm").Value, Fields("BranchName").Value, Fields("PersonFullName").Value);
  Fields("asPrtnrTyp1").Value :=Fields("PrtnrTyp").Value;
  Fields("asPrtnrTyp2").Value :=Fields("PrtnrTyp").Value;
  Fields("asPrtnrTyp3").Value :=Fields("PrtnrTyp").Value;
 END {Fill_ContractorBriefNameInP7101};

 PUBLIC PROCEDURE Fill_ContractorBriefName();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  P_Firm.Fill_ContractorBriefName(Fields("ContractorBriefName").Value, Firm.Begin, Firm.PrtnrTyp,
                                  Fields("HeadFirm").Value, Fields("BranchName").Value, Fields("PersonFullName").Value);
 END {Fill_ContractorBriefName};

BEGIN
 L_Events.ExecuteHandler();
END.
