(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose     প 楫⭮ FirmAcnt -> PDoc.OwnAcnt, ஫ 
%Type        control
%Specific    SYS
%Modified    24.07.2013 13:40:46 POLAK\GAV
%Environment PDoc.PDocKind=L_PDoc.pd_IPP - 室騥 ⥦ 祭
*)

 IMPORT Memo, L_General, L_DatTim, L_PDoc, L_Events, L_StdFrm, L_XObj, P_Firm;

 PRIVATE PROCEDURE FirmAcntChangeLegality(VAR _FirmAcnt: LIKE(FirmAcnt.FirmAcnt));
  VAR
   _MyFirm: P_Firm.tMyFirm;
   oPrompt: PROMPTLINE;
 BEGIN
  IF ~!_FirmAcnt THEN
   _MyFirm:=P_Firm.GetMyFirmOfFirm(FirmAcnt.Firm);
   IF ~!_MyFirm THEN
    P_Firm.PositionOnMyFirm(_MyFirm);
    oPrompt:=PROMPTLINE.Create("஢ઠ ᯮ짮 ⭮  "+_FirmAcnt+" ("+MyFirm.vzSign+")");
    TRY
     TABLE.Get("PDoc").AccessDataMode:=AccessDataMode_SOFT;
     SELECT(PDocKind, PDocKind);
     WHILE OCCURE(PDocKind) DO
      IF L_PDoc.MoneyKind(PDocKind.PDocKind) = L_PDoc.mk_Bank THEN
       SELECT(PDoc, MyFirm, , _MyFirm, PDocKind.PDocKind);
       WHILE OCCURE(PDoc) DO
        PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
        L_General.Assert(PDoc.OwnAcnt#_FirmAcnt, "   ,|..    㯮  ⥦ 㬥");
        NEXT(PDoc);
       END; (* WHILE OCCURE(PDoc) ... *)
      END;
      NEXT(PDocKind);
     END; (* WHILE OCCURE(PDocKind) ... *)
    EXCEPT
    END;
   END;
  END;
 END {FirmAcntChangeLegality};

 PRIVATE PROCEDURE FCh(F: STRING[32]): SCAL[2];
 BEGIN
  RETURN ^F # GE_PVALUE(^F);
 END {FCh};

 PRIVATE PROCEDURE FirmAcnt_OnAfterEdit();
  VAR
   _FirmAcnt: LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  P_Firm.CheckAcntA(FirmAcnt.Begin);
  IF FCh("FirmAcnt.FirmAcnt") | FCh("FirmAcnt.Bank") |
     FCh("FirmAcnt.Type")     | FCh("FirmAcnt.AcntA") THEN
   _FirmAcnt:=GE_PVALUE(FirmAcnt.FirmAcnt);
   FirmAcntChangeLegality(_FirmAcnt);
  END;
 END {FirmAcnt_OnAfterEdit};

 PRIVATE PROCEDURE FirmAcnt_OnAfterInsert();
 BEGIN
  P_Firm.CheckAcntA(FirmAcnt.Begin);
 END {FirmAcnt_OnAfterInsert};

 PRIVATE PROCEDURE FirmAcnt_OnBeforeDelete();
  VAR
   XObjToDel: SCAL[2];
 BEGIN
  FirmAcntChangeLegality(FirmAcnt.FirmAcnt);
  IF SEARCH(mfBnkAcn, FirmAcnt, FirmAcnt.Firm, FirmAcnt.FirmAcnt) THEN
   SAVE(mfBnkAcn);
   XObjToDel:=1;
   CHANGESEL(mfBnkAcn, XObject, , mfBnkAcn.XObject);
   FIRST(mfBnkAcn);
   WHILE OCCURE(mfBnkAcn) DO
    IF (mfBnkAcn.Firm # FirmAcnt.Firm) | (mfBnkAcn.FirmAcnt # FirmAcnt.FirmAcnt) THEN
     XObjToDel:=0;
    END;
    NEXT(mfBnkAcn);
   END; (* WHILE OCCURE(mfBnkAcn) ... *)
   RESTORE(mfBnkAcn);
   IF XObjToDel THEN
    L_XObj.BeforeOriginDelete(L_XObj.o_Global);
   END;
   SE_INTEGRITY(1);
   REMOVE(mfBnkAcn);
  END;
 END {FirmAcnt_OnBeforeDelete};

 PRIVATE PROCEDURE FirmAcnE_SetupFields();
  VAR
   mf: SCAL[2];
   f: FORM_FIELDS;
 BEGIN
  mf:=~OCCURE(FirmAcnt) | ((FirmAcnt.Type # P_Firm.fat_CashOffice) & (FirmAcnt.Type # P_Firm.fat_OprCashDsk));
  f:=RTI.Get().CurZone.Fields;
  f("FirmAcnt.Bank").Modifiable:=mf;
  f("FirmAcnt.BankBrn").Modifiable:=mf;
  f("FirmAcnt.Name").Modifiable:=mf;
 END {FirmAcnE_SetupFields};

 PRIVATE PROCEDURE FirmAcnt_Type_OnSuccessfulChange();
 BEGIN
  FirmAcnE_SetupFields();
 END {FirmAcnt_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE FirmAcnE_0_OnReposition();
 BEGIN
  FirmAcnE_SetupFields();
 END {FirmAcnE_0_OnReposition};

BEGIN
 IF    L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSE
  L_General.BadMode(MODE);
 END;
END.
