(*
%Copyright   (c) Polak Computer System
%Author      30.11.1995 12:32:37 SAN
%Purpose      ਪ
%Type        report
%Specific    SYS
%Modified    22.07.2014 19:07:26 POLAK\Bor
%Environment
*)

 MODULE FOPrint [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, Str, L_MSO, L_EC, L_Money, E_Staff, P_Firm, L_Str, L_PagePr, L_EDO,
        L_StdFrm, L_Staff, L_DatTim, L_APtm;

 PRIVATE VAR
  _Total         : LIKE(FOrder.Sum);
  Amount         : NUMERIC[0];
  ButtonLst,
  TemplateLst,
  DateDefLst,
  PrepareProcLst : STRING[];

 PRIVATE PROCEDURE ValueToStr(_Value: NUMERIC[2]): STRING[];
 BEGIN
  IF FOrder.Type = 0 THEN
   RETURN L_Money.MoneyToStr(FOrder.Closed, "", _Value);
  ELSE
   RETURN FLDTOSTR(_Value, "2.", 0);
  END;
 END {ValueToStr};

(*
$P{PageTop:
P_Firm.MyFirmName(FOrder.MyFirm, SYSDATE()), L, ""
SYSDATE(), L , "D.N.Y"
SYSTIME(), L , "H:M"
FOrder.About, C , ""
FLDTOSTR(L_PagePr.PagePr_CurrentPage(), "L0", 3), R , ""
FOrder.Name, L , ""
FOrder.FOrder, L , ""
FOrder.Date, L , "D.N.Y"
FOrder.Type, R , "㬬|%"
@
##############################################################  ######## #####
==============================================================================
|############################################################################|
|----------------------------------------------------------------------------|
| ࠭ ### (N ################ (#####))  ########                      |
|----------------------------------------------------------------------------|
|                 |       |⤥          |  ६|###########|
|-----------------------|----------------|---------------|-------|-----------|
}

$P{Line:
FOrderL.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Post.Name, L, ""
L_Staff.getDepartName(), L, ""
FOrderL.Tim, R, "3."
ValueToStr(FOrderL.Value), R, ""
@
|##### #################|################|###############|#######|###########|
}

$P{Filling:
@
|                       |                |               |       |           |
}

$P{PageBot:
@
==============================================================================
}

$P{Bot:
FLDTOSTR(Amount, "0", 0)+" "+Str.EnumObject(Amount, "祫|祫|祫"), L, ""
ValueToStr(_Total), R, ""
FULLNAME(), L, ""
@
|----------------------------------------------------------------------------|
| ⮣ #########################################################|###########|
|----------------------------------------------------------------------------|
|                                                                            |
|                                                                            |
| ᯮ⥫       _________________________/#############################/ |
|                                                                            |
|                                                                            |
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   (* nothing *)
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF (Mode = L_PagePr.m_Print) | (Mode = L_PagePr.m_RDoneTop) THEN
   MAKEPART(R, PageTop);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(PageBot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, PageBot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Bot));
  ELSIF Mode = L_PagePr.m_Print THEN
   IF FOrder.Type = 0 THEN
    L_General.Assert(FOrder.Sum = _Total, "室  㬬  थ");
   ELSE
    SETEMPTY(_Total);
   END;
   MAKEPART(R, Bot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Fill);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Filling));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Filling);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE DefineStandartList();
 BEGIN
  ButtonLst     :="ਪ  ७ ࠡ⭨|" +
                  "ਪ  ⥫쭮 ࠦ|";
  TemplateLst   :="T11a|T11z|";
  DateDefLst    :="Memo.ud_cd()|Memo.ud_cd()|";
  PrepareProcLst:="T11aPrepare|T11zPrepare|";
 END {DefineStandartList};

 PRIVATE PROCEDURE E_T11_ExtraFooter(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_Staff.T11_ExtraFooter), "");
 END {E_T11_ExtraFooter};

 PRIVATE PROCEDURE E_T11z_ExtraFooter(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_Staff.T11z_ExtraFooter), "");
 END {E_T11z_ExtraFooter};

 PRIVATE PROCEDURE E_T11_Delivery(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_Staff.T11_Delivery), "⭠ ");
 END {E_T11_Delivery};

 PRIVATE PROCEDURE SetConformForFOrderL();
 BEGIN
  L_General.Assert(~!FOrderL.ODate | FOrderL.AllODate, ". "+FOrderL.TSN+":   ਪ  ਥ ॢ");
  CONFORM(FOrderL, Staff);
  IF ~!FOrderL.ODate THEN
   HISTCONF(FOrderL.ODate, Staff, StaffLog);
  ELSE
   L_Staff.PosToStaffLog(Staff.TSN, L_DatTim.MonthEnd(FOrder.Period), 0);
  END;
  CONFORM(StaffLog, Sort);
  CONFORM(StaffLog, Post);
  CONFORM(Staff,    Man);
 END {SetConformForFOrderL};

 PRIVATE PROCEDURE T11Prepare(D: DATE);
  VAR
   Idx   : NUMERIC[0];
   OrdIdx: STRING[];
 BEGIN
  L_APtm.wordSetTheDocCauseAndDraftsman(D, "⢥ত ⠭ ᪮ ᨨ  05.01.2004  1", "");
  Idx:=0;
  SELECT(FOrderL, FOrder, , FOrder.FOrder);
  WHILE OCCURE(FOrderL) DO
   PROMPT("⮢ " + FOrderL.TSN);
   SetConformForFOrderL();
   OrdIdx:="OrderL" + L_MSO.IndexStr(Idx);
   L_MSO.wordSetVar(OrdIdx + ".Staff.TSN",      FOrderL.TSN);
   L_MSO.wordSetVar(OrdIdx + ".Man.Name.Short", L_Str.ShortName(Man.Name));
   L_MSO.wordSetVar(OrdIdx + ".Man.Name",       Man.Name);
   L_MSO.wordSetVar(OrdIdx + ".Value",          ValueToStr(FOrderL.Value) +
                                                L_Str.PoolItem(" |%", FOrder.Type));
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("Post",   "OrderL", Idx, ~OCCURE(Post));
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("Sort",   "OrderL", Idx, ~OCCURE(Sort));
   INC(Idx);
   NEXT(FOrderL);
  END; (* WHILE OCCURE(FOrderL) ... *)
  L_MSO.SetWordTable("manlist", Idx);
  L_MSO.wordSetVar("Order.LineCount", L_Str.IntStr(Idx));
  L_MSO.PutInTables:=L_MSO.Put_Values;
 END {T11Prepare};

 PRIVATE PROCEDURE T11aPrepare(D: DATE);
 BEGIN
  T11Prepare(D);
  L_MSO.wordSetVar("E_T11_ExtraFooter", E_T11_ExtraFooter(D));
 END {T11aPrepare};

 PRIVATE PROCEDURE T11zPrepare(D: DATE);
  VAR
   Idx   : NUMERIC[0];
   OrdIdx: STRING[];
 BEGIN
  T11Prepare(D);
  L_MSO.wordSetMoneyVar("Order.Value", FOrder.Closed, FOrder.Sum);
  L_MSO.wordSetVar("Order.MCList.MCode",  FOrder.MCode);
  L_MSO.wordSetVar("Order.MCList.Name",   MCList.Name);
  L_MSO.wordSetVar("t11z_ExtraFooter", E_T11z_ExtraFooter(D));
 END {T11zPrepare};

 PRIVATE PROCEDURE PrepareObjects(D: DATE; ProcName:PROC);
 BEGIN
  L_General.Assert(~!FOrder.MCode, " ਪ  㪠  ᫥/㤥ঠ");
  CONFORM(FOrder, MCList);
  L_MSO.wordSetVar("Order.SrcNum",  FOrder.Name);
  L_MSO.wordSetDateVar("Order.Date",    FOrder.Date);
  L_MSO.wordSetVar("Order.Reason",  FOrder.About);
  L_MSO.wordSetVar("Order.Reward",  MCList.Name);
  L_MSO.wordSetVar("Order.Cause",   "");
  L_MSO.wordSetVar("TheDoc.InternalNumber", FOrder.FOrder);
  L_MSO.wordSetVar("TheDoc.CopyCnt", L_Str.IntStr(1));
  CONFORM(FOrder, EDOSrc);
  L_MSO.wordSetVarsByFile_wPrefix("EDOSrc", "Order.");
  L_MSO.wordSetVar("TheDoc.Delivery", E_T11_Delivery(D));
  ProcName(D);
 END {PrepareObjects};

 PRIVATE PROCEDURE AppendSingleList(VAR rLst: STRING[]; aLst: STRING[]);
 BEGIN
  rLst:=rLst+aLst+"|";
 END {AppendSingleList};

 PRIVATE PROCEDURE AppendAdditionalList();
  VAR
   Local            : PROC;
   adtButtonLst,
   adtTemplateLst,
   adtDateDefLst,
   adtPrepareProcLst: STRING[];
 BEGIN
  Local:=PROCREF(E_Staff.GetAdditionalOrderList);
  IF ~!Local THEN
   Local(adtButtonLst, adtTemplateLst, adtDateDefLst, adtPrepareProcLst);
   AppendSingleList(     ButtonLst,      adtButtonLst);
   AppendSingleList(   TemplateLst,    adtTemplateLst);
   AppendSingleList(    DateDefLst,     adtDateDefLst);
   AppendSingleList(PrepareProcLst, adtPrepareProcLst);
  END;
 END {AppendAdditionalList};

 PUBLIC PROCEDURE FOPrint();
 BEGIN
  L_General.Assert(ACCESS(FOrder), " ⠭ ⥪騩 ਪ");
  L_General.Assert(L_EDO.IsRealFOrder(), "  믮  㫨஢ ਪ");
  OPENREP(R, L_General.NameConnection("FOrdr"), Create);
  L_PagePr.PagePr_Init("R", 60, PROCREF(_RprtTop),
                                PROCREF(_PageTop),
                                PROCREF(_PageBot),
                                PROCREF(_RprtBot),
                                PROCREF(_Filling));
  SETZERO(Amount, _Total);
  SELECT(FOrderL, FOrder, , FOrder.FOrder);
  WHILE OCCURE(FOrderL) DO
   PROMPT(" ਪ " + FOrderL.TSN);
   SetConformForFOrderL();
   INC(_Total, FOrderL.Value);
   SAVE(FOrderL);
   L_PagePr.PagePr_BeforePrintLineAtLast(~NEXT(FOrderL), DEPTH("Line"));
   RESTORE(FOrderL);
   MAKEPART(R, Line);
   INC(Amount);
   NEXT(FOrderL);
  END; (* WHILE OCCURE(FOrderL) ... *)
  L_PagePr.PagePr_Done();
 END {FOPrint};

 PUBLIC PROCEDURE FOPrintToMSWord();
  VAR
   Choice,
   _MaxCopi: NUMERIC[0];
   PreView : SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(FOrder), " ⠭ ⥪騩 ਪ");
  L_General.Assert(L_EDO.IsRealFOrder(), "  믮  㫨஢ ਪ");
  DefineStandartList();
  AppendAdditionalList();
  PreView:=L_MSO.PrpMode_Print;
  Choice :=L_MSO.SelectDoc(ButtonLst, TemplateLst, PreView) - 1;
  IF Choice >= 0 THEN
   L_MSO.wordInitDocument(FOrder.Date);
   P_Firm.SetMyFirmDefaultData(FOrder.MyFirm, FOrder.Date, "");
   PrepareObjects(FOrder.Date, PROCREF(^(L_Str.PoolItem(PrepareProcLst, Choice))));
   CONFORM(FOrder, EDOSrc);
   IF PreView = L_MSO.PrpResult_Original THEN
    _MaxCopi:=EDOSrc.MaxCopi;
   ELSE
    _MaxCopi:=1;
   END;
   IF _MaxCopi > 1 THEN
    LOOP
     STDFORM(L_StdFrm.sf_Choice("|⢮  ஢ %##%",
                                "%L<0>I"),
             "  ਪ", INFORM, , _MaxCopi);
     IF _MaxCopi>0 THEN
      IF _MaxCopi > EDOSrc.MaxCopi THEN
       STDFORM(L_StdFrm.sf_Choice("| 㪠  ᨬ쭮 ⢠ ("+FLDTOSTR(EDOSrc.MaxCopi, "0", 0) + ")" +
                                  "|" +
                                  "|⢮  ஢ %##%",
                                  "%L<0>I"),
               " ਪ", INFORM, , _MaxCopi);
       EXIT;
      ELSE
       EXIT;
      END;
     ELSE
      L_StdFrm.RedInform(" ⢮ ");
     END;
    END;
   END;
   L_MSO.MakeWordDocument(L_Str.PoolItem(TemplateLst, Choice), _MaxCopi, PreView, "");
  END;
 END {FOPrintToMSWord};

END.
