(*
%Copyright   (c) Polak Computer System
%Author      12.02.1995 16:31:26 SAN
%Purpose     ஫  ਪ  /
%Type        control
%Specific    SYS
%Modified    30.07.2014 21:18:00 POLAK\San
%Environment
*)

 MODULE FOrder [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_PRoll, L_DatTim, L_EDO, L_SysLog,
        L_APtm, L_Env, P_Firm, L_StdFrm, P_MCList, L_XDoc, E_Staff,
        L_MSO, L_WDO, L_Staff, L_DBD,
        Memo;

 PRIVATE PROCEDURE TestCorrectClosed();
  VAR
   i    : SCAL[100];
   Found: SCAL[2];
 BEGIN
  IF FOrder.Period # FOrder.Closed THEN
   L_General.Assert(~!FOrder.MCode, " ਪ  㪠  ᫥/㤥ঠ");
   CONFORM(FOrder, MCList);
   i:=0; Found:=MCList.InSign[L_PRoll.mcis_FullSalary];
   WHILE (i <= P_MCList.BonBaseAmount-1) & ~Found DO
    Found:=P_MCList.inBonus(MCList.MCode, FOrder.Period, i);
    INC(i);
   END;
   IF ~Found THEN
    SELECT(MoneyRul, MCode, , FOrder.MCode);
    WHILE OCCURE(MoneyRul) & ~Found DO
     IF (MoneyRul.Rule="") | (MoneyRul.Rule="") THEN
      CONFORM(MoneyRul, MoneyMth);
      SETSEL(MMthLog, MoneyMth, MoneyMth.Method);
      Found:=SRCINSEL(MMthLog, LE, FOrder.Period) &
             (MMthLog.Till > FOrder.Period);
     END;
     NEXT(MoneyRul);
    END; (* WHILE OCCURE(MoneyRul) ... *)
   END;
   IF Found THEN
    IF FOrder.Period >= L_Env.aptm_Start THEN
     L_StdFrm.ConditionalCHOICE("ਪ  " + L_DatTim.PeriodStr(FOrder.Period) +
                                "|  ஢  ᮮ⢥饬 " +
                                "| ࠢ쭮  ६  ⥫ ᫥",
                                ~SEARCH(MthType, MthType, L_PRoll.mthtyp_LastCalc));
    ELSE
     L_StdFrm.RedInform("६  ௫  "+L_DatTim.PeriodStr(FOrder.Period) +
                        "|᫥ ᫨  ਪ");
    END;
   END;
  END;
 END {TestCorrectClosed};

 PRIVATE PROCEDURE CheckRights();
 BEGIN
  CONFORM(FOrder, EDOSrc);
  L_EDO.PassAccessPoint(EDOSrc.apMFO);
 END {CheckRights};

 PRIVATE PROCEDURE Proceed(_Done: LIKE(FOrder.Done));
 BEGIN
  L_General.Assert(FOrder.Status # L_EDO.fost_Prepared, "㬥    ⮢");
  CheckRights();
  IF FOrder.Done # _Done THEN
   FOrder.Sum:=0;
   IF _Done = 1 THEN
    TestCorrectClosed();
   END;
   CONFORM(FOrder, FOrderL);
   L_General.Assert(OCCURE(FOrderL) | ~L_EDO.IsRealFOrder(), "ਪ  ᮤঠ  ࠩ   ப");
   WHILE OCCURE(FOrderL) DO
    PROMPT(FOrderL.FOrder + " " + FOrderL.TSN);
    L_General.Assert(~!FOrderL.ODate | FOrderL.AllODate,
                     ". "+FOrderL.TSN+": 室 㪠  /  ਪ  |" + L_EDO.FOrderName());
    CALL(FOrderL.ProceedFOrderL(_Done));
    NEXT(FOrderL);
   END; (* WHILE OCCURE(FOrderL) ... *)
   FOrder.Done:=_Done;
   REPLACE(FOrder);
  END; (* IF FOrder.Done # _Done... *)
 END {Proceed};

 PRIVATE PROCEDURE TRUNC(Value, Step: NUMERIC[2]): NUMERIC[2];
  VAR t1, t2: NUMERIC[0];
 BEGIN
  t1:=Value*100; t2:=Step*100; RETURN t1 DIV t2 * Step;
 END {TRUNC};

 PRIVATE PROCEDURE intMakeCopy(srcFOrder: LIKE(FOrder.FOrder));
  VAR
   trgClosed  : DATE;
   MinBankNote: L_PRoll.tSum;
   Coeff      : NUMERIC[6];
 BEGIN
  SAVE(FOrder);
  L_General.CallUs(SEARCH(FOrder, FOrder, srcFOrder));
  Coeff:=1;
  MinBankNote:=0.01;
  trgClosed:=FOrder.Closed;
  STDFORM(L_StdFrm.sf_Choice("|⮢  ਪ" +
                             "||" + L_EDO.FOrderName()     +
                             "||஢          %#######%" +
                             "|| 樥⮬    %#######%" +
                             "||쭠  %#######%",
                             "%<N.y>I" + "%R<6.>I" + "%R<2->I"),
          , , , trgClosed, Coeff, MinBankNote);
  RESTORE(FOrder);
  IF trgClosed # FOrder.Closed THEN
   Memo.ud_SetCurDate(trgClosed);
   TOOLTIP("騩    " + L_DatTim.PeriodStr(trgClosed), 0);
  END;
  L_DBD.CopyFromSrcRecord("FOrder", srcFOrder);
  FOrder.Closed:=trgClosed;
  FOrder.Done  :=0;
  FOrder.Sum   :=0;
  SETEMPTY(FOrder.MCode);
  SELECT(FOrderL, FOrder, , srcFOrder);
  WHILE OCCURE(FOrderL) DO
   PROMPT(FOrderL.TSN);
   SAVE(FOrderL);
   FOrderL.FOrder :=FOrder.FOrder;
   FOrderL.Value  :=TRUNC(FOrderL.Value * Coeff, MinBankNote);
   FOrderL._Closed:=trgClosed;
   IF ~!FOrderL.ODate THEN
    SEARCH(StaffLog, TSN, , FOrderL.TSN, FOrderL.ODate);
    IF ~L_Staff.OrderInMonth(FOrderL._Closed) THEN
     SETEMPTY(FOrderL.ODate);
    END;
   END;
   INSERT(FOrderL);
   IF FOrder.Type = L_PRoll.fot_BySum THEN
    INC(FOrder.Sum, FOrderL.Value);
   END;
   RESTORE(FOrderL);
   NEXT(FOrderL);
  END; (* WHILE OCCURE(FOrderL) ... *)
  REPLACE(FOrder);
 END {intMakeCopy};

 PRIVATE PROCEDURE CheckFOrderDone();
 BEGIN
  L_General.Assert(~FOrder.Done, "  室 ⪠ 㬥");
 END {CheckFOrderDone};

 PRIVATE PROCEDURE Shift(Dir: NUMERIC[0]);
 BEGIN
  L_General.Assert(L_EDO.IsRealFOrder(), "  믮  㫨஢ ਪ");
  CheckFOrderDone();
  L_SysLog.SingleMark_Init("FOrder");
  FOrder.Closed:=L_DatTim.IncMonth(FOrder.Closed, Dir);
  REPLACE(FOrder);
  CONFORM(FOrder, FOrderL);
  WHILE OCCURE(FOrderL) DO
   PROMPT(FOrderL.TSN);
   FOrderL._Closed:=FOrder.Closed;
   REPLACE(FOrderL);
   NEXT(FOrderL);
  END; (* WHILE OCCURE(FOrderL)... *)
  L_XDoc.Jrn_Mark(L_XDoc.curXDocId(L_XDoc.xdt_FOrder), L_XDoc.action_AutoEdit);
  L_SysLog.SingleMark_Done("FOrder");
 END {Shift};

 PRIVATE PROCEDURE FOrder_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow      ().MNUFileName:="FOrder";
  L_WDO.iWindow      ().OnOpenWindow:=1;
  L_WDO.iZone        (1).Narrowing:="(FOrder.EDOSrc=EDOSrc.EDOSrc)&(FOrder.Closed=Memo.MonthB)";
  L_WDO.iSubwindow   (1, "FOrderE");
  L_WDO.iField       (1, "FOrder.Status").Format:="||";
  L_WDO.iZone        (2).ViewOnly:=1;
 END {FOrder_OnInitializeWindow};

 PRIVATE PROCEDURE SetupCOFields();
  VAR
   curModifiable: SCAL[2];
 BEGIN
  curModifiable:=FOrder.Closed >= L_PRoll.E_DoSecondSide();
  IF ~!FOrder.MCode THEN
   P_MCList.StandOnDstMode(FOrder.MCode, FOrder.Closed);
   IF (DstMode.MnMth = L_PRoll.dmmm_byContract) | (DstMode.MnMth = L_PRoll.dmmm_byManXCalc) THEN
    curModifiable:=0;
   END;
  END;
  RTI.Get().CurZone.Fields("COOrigin").Modifiable:=curModifiable;
  RTI.Get().CurZone.Fields("CO"      ).Modifiable:=curModifiable;
  IF curModifiable THEN
   IF    RTI.Get().CurZone.Fields("COOrigin").Value = L_PRoll.m2xo_Contract THEN
    L_WDO.CreateFormLink_Simple("Contract", "CO");
   ELSIF RTI.Get().CurZone.Fields("COOrigin").Value = L_PRoll.m2xo_CostItem THEN
    L_WDO.CreateFormLink_Simple("CostItem", "CO");
   END;
  ELSE
   SETEMPTY(RTI.Get().CurZone.Fields("COOrigin").Value, RTI.Get().CurZone.Fields("CO").Value);
  END;
 END {SetupCOFields};

 PRIVATE PROCEDURE FOrderE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["FOrder.Status", "FOrder.Type", "FOrder.Date", "FOrder.MCode", "FOrder.Period", "COOrigin"]);
  L_WDO.iUnmodifiable(0, ["FOrder_Type_Title", "FOrder.Closed", "FOrder.Sum", "FOrder.FOrder"]);
  L_WDO.iMayBeEmpty  (0, ["COOrigin", "CO"]);
  L_WDO.iField       (0, "FOrder_Type_Title").Format:="㬬|%";
  L_WDO.iField       (0, "FOrder.Status").Format:="⮢|஢|㫨஢";
  L_WDO.iField       (0, "FOrder.Type").Format:="㬬|業";
  L_WDO.iField       (0, "MCList.MCTyp").Format:="᫨|ঠ";
  L_WDO.iField       (0, "COOrigin").Format:=L_PRoll.m2xo_Pool;
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  L_WDO.iField       (1, "FOrderL.ODate").AskMode:=1;
  L_WDO.iField       (1, "FOrderL.ODate").OwnerWindowOriginalName:="StaffE";
  L_WDO.iField       (1, "FOrderL.ODate").OwnerZoneNumber:=1;
  L_WDO.iScsChange   (1, ["FOrderL.AllODate", "FOrderL.TSN"]);
  L_WDO.iField       (1, "FOrderL.AllODate").Format:="-->|";
 END {FOrderE_OnInitializeWindow};

 PRIVATE PROCEDURE FOrder_OnOpenWindow();
  VAR
   Filter: STRING[];
   SrcCnt: NUMERIC[0];
 BEGIN
  L_EDO.GetEDOSrcPermanentFilter(L_EDO.ot_FO, Filter, SrcCnt);
  L_General.Assert(SrcCnt > 0, " 筨 ਪ,  ᬮ     ");
  RTI.Get().CurWindow.Zones(2).PermanentFilter:=Filter;

  IF (SrcCnt = 1) & (RTI.Get().CurZone.Number = 2) THEN
   LIKEMENU(View, RTI.Get().CurWindow.Name +" 1");
  END;
 END {FOrder_OnOpenWindow};

 PRIVATE PROCEDURE FOrderE_0_OnReposition();
 BEGIN
  RTI.Get().CurZone.Fields("FOrder_Type_Title").Value:=FOrder.Type;
  IF ~!FOrder.fiCO THEN
   L_DBD.StandOnRecord(L_General.iri_Pack(FOrder.fiCO, FOrder.riCO));
   CONFORM((L_DBD.GetTable(FOrder.fiCO).Name), XObject);
   IF    XObject.Origin = L_XObj.o_Contract THEN
    RTI.Get().CurZone.Fields("COOrigin").Value:=L_PRoll.m2xo_Contract;
    RTI.Get().CurZone.Fields("CO"      ).Value:=Contract.Contract;
   ELSIF XObject.Origin = L_XObj.o_CostItem THEN
    RTI.Get().CurZone.Fields("COOrigin").Value:=L_PRoll.m2xo_CostItem;
    RTI.Get().CurZone.Fields("CO"      ).Value:=CostItem.CostItem;
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   SETEMPTY(RTI.Get().CurZone.Fields("COOrigin").Value, RTI.Get().CurZone.Fields("CO").Value);
  END;
  SetupCOFields();
 END {FOrderE_0_OnReposition};

 PRIVATE PROCEDURE FOrder_OnBeforeEdit();
 BEGIN
  L_APtm.ANYDoc_CheckPer(FOrder.Closed, L_APtm.system_Salary);
  CheckRights();
  L_XDoc.Jrn_Start(L_XDoc.curXDocId(L_XDoc.xdt_FOrder), L_XDoc.action_Edit);
 END {FOrder_OnBeforeEdit};

 PRIVATE PROCEDURE FOrder_OnBeforeInsert();
  VAR
   srcFOrder: LIKE(FOrder.FOrder);
 BEGIN
  L_XDoc.Jrn_Start(L_XDoc.curXDocId(L_XDoc.xdt_FOrder), L_XDoc.action_Insert);
  srcFOrder:=L_WDO.GetInsertionSource();
  IF !srcFOrder THEN
   FOrder.MyFirm:=P_Firm.DefineMyFirm();
   CheckRights();
   FOrder.Name:=FOrder.FOrder;
   REPLACE(FOrder);
  ELSE
   intMakeCopy(srcFOrder);
  END;
 END {FOrder_OnBeforeInsert};

 PRIVATE PROCEDURE FOrder_OnBeforeDelete();
 BEGIN
  L_General.Error(" 饭. ᯮ '㫨஢'");
 END {FOrder_OnBeforeDelete};

 PRIVATE PROCEDURE FOrder_OnAfterEdIns();
  VAR
   trg_iri: L_General.tInternalRecordId;
 BEGIN
  L_APtm.ANYDoc_CheckPer(FOrder.Closed, L_APtm.system_Salary);
  L_PRoll.CheckMCodeLegality(FOrder.MCode, FOrder.Closed);
  IF FOrder.Period > FOrder.Closed THEN
   L_StdFrm.Choice("ਪ  騩 ?");
  END;
  IF !RTI.Get().CurZone.Fields("COOrigin").Value # !RTI.Get().CurZone.Fields("CO").Value THEN
   L_StdFrm.WrongDB("ᠭ ᯮ饣 ꥪ ᫥ ᤥ ,    ");
  END;
  IF    RTI.Get().CurZone.Fields("COOrigin").Value = L_PRoll.m2xo_Contract THEN
   SEARCH(Contract, Contract, , RTI.Get().CurZone.Fields("CO").Value);
   trg_iri:=L_General.iri_GetCurrent("Contract");
  ELSIF RTI.Get().CurZone.Fields("COOrigin").Value = L_PRoll.m2xo_CostItem THEN
   SEARCH(CostItem, CostItem, , RTI.Get().CurZone.Fields("CO").Value);
   trg_iri:=L_General.iri_GetCurrent("CostItem");
  ELSE
   SETEMPTY(trg_iri);
  END;
  IF ~!trg_iri THEN
   IF ^(L_DBD.GetTable(L_General.iri_fi(trg_iri)).Fields("MyFirm").ObtainName()) # FOrder.MyFirm THEN
    L_StdFrm.WrongDB(" ᯮ饣 ꥪ  ᮮ⢥  ਪ");
   END;
  END;
  FOrder.fiCO:=L_General.iri_fi(trg_iri);
  FOrder.riCO:=L_General.iri_ri(trg_iri);
  REPLACE(FOrder);
  L_XDoc.Jrn_Stop(L_XDoc.curXDocId(L_XDoc.xdt_FOrder));
  IF ~FOrder.Done & (FOrder.Status # L_EDO.fost_Prepared) & SELECT(FOrderL, FOrder, FOrder.FOrder) &
      L_StdFrm.Alternative("믮 ࠡ ਪ?") THEN
   Proceed(1);
  END;
 END {FOrder_OnAfterEdIns};

 PRIVATE PROCEDURE FOrder_OnAfterEdit();
 BEGIN
  FOrder_OnAfterEdIns();
 END {FOrder_OnAfterEdit};

 PRIVATE PROCEDURE FOrder_OnAfterInsert();
 BEGIN
  FOrder_OnAfterEdIns();
 END {FOrder_OnAfterInsert};

 PRIVATE PROCEDURE FOrder_Date_OnSuccessfulChange();
 BEGIN
  CheckFOrderDone();
 END {FOrder_Date_OnSuccessfulChange};

 PRIVATE PROCEDURE FOrder_Period_OnSuccessfulChange();
 BEGIN
  CheckFOrderDone();
 END {FOrder_Period_OnSuccessfulChange};

 PRIVATE PROCEDURE FOrder_MCode_OnSuccessfulChange();
 BEGIN
  CheckFOrderDone();
  SetupCOFields();
 END {FOrder_MCode_OnSuccessfulChange};

 PRIVATE PROCEDURE FOrder_Status_OnSuccessfulChange();
 BEGIN
  CheckFOrderDone();
  IF    GE_PVALUE() = L_EDO.fost_Canceled THEN
   L_StdFrm.Choice("  ⬥ 㫨஢ 㬥?");
  ELSIF FOrder.Status = L_EDO.fost_Canceled THEN
   L_StdFrm.Choice("  㫨஢ 㬥?");
  END;
 END {FOrder_Status_OnSuccessfulChange};

 PRIVATE PROCEDURE FOrder_Type_OnSuccessfulChange();
 BEGIN
  RTI.Get().CurZone.Fields("FOrder_Type_Title").Value:=FOrder.Type;
  CheckFOrderDone();
  IF    FOrder.Type = L_PRoll.fot_BySum THEN
   FOrder.Sum:=0;
   CONFORM(FOrder, FOrderL);
   WHILE OCCURE(FOrderL) DO
    PROMPT(FOrderL.TSN);
    L_General.Assert(~FOrderL.AllODate, " /  ⠭ ⮫쪮  ਪ 業⮬|⭨ "+ FOrderL.TSN);
    INC(FOrder.Sum, FOrderL.Value);
    NEXT(FOrderL);
   END; (* WHILE OCCURE(FOrderL)... *)
  ELSIF FOrder.Type = L_PRoll.fot_ByPrc THEN
   FOrder.Sum:=0;
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(FOrder);
 END {FOrder_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE FOrder_COOrigin_OnSuccessfulChange();
 BEGIN
  SETEMPTY(RTI.Get().CurZone.Fields("CO").Value);
  SetupCOFields();
 END {FOrder_COOrigin_OnSuccessfulChange};

 PRIVATE PROCEDURE FO_MakeAddDoc(InFile: SCAL[2]);
  VAR
   template: STRING[];
   Local   : PROC;
 BEGIN
  Local:=PROCREF(E_Staff.FO_MakeAddDoc);
  IF ~!Local THEN
   template:=Local();
  ELSE
   template:="";
  END;
  IF ~!template THEN
   L_MSO.MakeWordDocument(template, 1, InFile, "");
  ELSE
   L_StdFrm.Inform("  ।ᬮ७");
  END;
 END {FO_MakeAddDoc};

 PUBLIC PROCEDURE MakeAddDocToPrinter();
 BEGIN
  FO_MakeAddDoc(0);
 END {MakeAddDocToPrinter};

 PUBLIC PROCEDURE MakeAddDocInFile();
 BEGIN
  FO_MakeAddDoc(1);
 END {MakeAddDocInFile};

 PUBLIC PROCEDURE SingleMakeDone();
 BEGIN
  ACCESS(FOrder);
  L_APtm.ANYDoc_CheckPer(FOrder.Closed, L_APtm.system_Salary);
  Proceed(1);
 END {SingleMakeDone};

 PUBLIC PROCEDURE SingleMakeUnDone();
 BEGIN
  ACCESS(FOrder);
  L_APtm.ANYDoc_CheckPer(FOrder.Closed, L_APtm.system_Salary);
  Proceed(0);
 END {SingleMakeUnDone};

 PUBLIC PROCEDURE MoveFOrderInNextMonth();
 BEGIN
  ACCESS(FOrder);
  L_StdFrm.Choice("७ ਪ  ᫥騩 ?");
  Shift(+1);
 END {MoveFOrderInNextMonth};

 PUBLIC PROCEDURE MoveFOrderInPrevMonth();
 BEGIN
  ACCESS(FOrder);
  L_StdFrm.Choice("७ ਪ  ।騩 ?");
  Shift(-1);
 END {MoveFOrderInPrevMonth};

 PUBLIC PROCEDURE MakeCopy();
 BEGIN
  ACCESS(FOrder);
  L_WDO.LaunchInsertBySource(FOrder.FOrder, "");
 END {MakeCopy};

BEGIN
 L_Events.ExecuteHandler();
END.
