(*
%Copyright   (c) Polak Computer System
%Author      12.02.1995 16:35:06 SAN
%Purpose     ஫ ࠢ쭮  祪 ਪ
%Type        control
%Specific    SYS
%Modified    07.08.2013 11:43:46 POLAK\San
%Environment
*)

 MODULE FOrderL [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, L_PRoll, L_Staff, Math, L_AcsPnt, L_StdFrm, L_EDO, L_WDO;

 PRIVATE PROCEDURE CheckManyInFOrder();
  VAR
   Cnt: NUMERIC[0];
 BEGIN
  SAVE(FOrderL);
  Cnt:=0;
  CHANGESEL(FOrderL, FOrder, , FOrderL.FOrder, FOrderL.TSN);
  FIRST(FOrderL);
  WHILE OCCURE(FOrderL) DO INC(Cnt);
   NEXT(FOrderL);
  END; (* WHILE OCCURE ... *)
  RESTORE(FOrderL);
  IF Cnt > 1 THEN
   L_StdFrm.Choice(" " + FOrderL.TSN + " 㦥 " + FLDTOSTR(Cnt, "0", 0) + " ࠧ 㯮  ਪ");
  END;
 END {CheckManyInFOrder};

 PRIVATE PROCEDURE SetupODate(wModify: SCAL[2]);
 BEGIN
  IF wModify THEN
   IF FOrderL.AllODate THEN
    SETEMPTY(FOrderL.ODate);
   ELSIF ~!FOrderL.TSN THEN
    CONFORM(FOrderL, Staff);
    L_Staff.PosToStaffLog(FOrderL.TSN, Math.Min(FOrder.Date, L_DatTim.MonthEnd(FOrder.Period)), 1);
    FOrderL.ODate:=StaffLog.Date;
   END;
   REPLACE(FOrderL);
  END;
  L_WDO.cField("FOrderL.AllODate").Modifiable:=L_EDO.AllODateAllowed();
  L_WDO.cField("FOrderL.ODate").Modifiable:=~FOrderL.AllODate;
 END {SetupODate};

 PRIVATE PROCEDURE FOrderL_TSN_OnSuccessfulChange();
 BEGIN
  CONFORM(FOrderL, Staff);
  L_General.Assert(Staff.MyFirm = FOrder.MyFirm,
                   "'' ࣠樨  ਪ  㤮 ࠪ ࠧ");
  FOrderL.AllODate:=L_EDO.AllODateAllowed();
  REPLACE(FOrderL);
  SetupODate(1);
 END {FOrderL_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE FOrderL_AllODate_OnSuccessfulChange();
 BEGIN
  SetupODate(1);
 END {FOrderL_AllODate_OnSuccessfulChange};

 PRIVATE PROCEDURE ShtDone();
 BEGIN
  L_General.SetConcurrentMode();
  CONFORM(FOrderL, Staff);
  L_PRoll.ShtDone_AP(FOrder.Closed, 0);
 END {ShtDone};

 PUBLIC PROCEDURE ProceedFOrderL(_s: NUMERIC[0]);
 BEGIN
  IF _s = 1 THEN
   CONFORM(FOrderL, Staff);
   IF FOrder.Type = L_PRoll.fot_BySum THEN
    L_General.Assert(~!FOrder.MCode & ~!FOrder.Period, '।⥫쭮 㦭  ਮ ("")    ਪ.');
    L_PRoll.CheckMoneyLegality(FOrder.Period, FOrder.Closed, FOrder.MCode, FOrderL.Value, FOrderL.Tim);
   END; (* IF FOrder.Type = 0 ... *)
  END;
  IF FOrder.Type = L_PRoll.fot_BySum THEN
   INC(FOrder.Sum, _s * FOrderL.Value);
   REPLACE(FOrder);
  END;
  ShtDone();
 END {ProceedFOrderL};

 PRIVATE PROCEDURE FOrderL_OnBeforeEdit();
 BEGIN
  ProceedFOrderL(-1);
 END {FOrderL_OnBeforeEdit};

 PRIVATE PROCEDURE _AfterEditInsert();
 BEGIN
  CONFORM(FOrderL, Staff);
  L_EDO.CheckAllODate();
  L_General.Assert(L_Staff.IsBegan(FOrder.Closed), "⭨ "+FOrderL.TSN+"  ਭ  "+L_DatTim.PeriodStr(FOrder.Closed));
  IF ~!FOrderL.ODate THEN
   L_Staff.PosToStaffLog(FOrderL.TSN, FOrderL.ODate, 0);
   L_Staff.CheckManyStaffLog(FOrderL.ODate);
  ELSE
   IF ~L_Staff.InStateInPer(FOrder.Closed, L_DatTim.MonthEnd(FOrder.Closed)) THEN
    L_StdFrm.Choice("⭨  ⮨    "+L_DatTim.PeriodStr(FOrder.Closed));
   END;
  END;
  CheckManyInFOrder();
  ProceedFOrderL(+1);
 END {_AfterEditInsert};

 PRIVATE PROCEDURE FOrderL_OnAfterEdit();
 BEGIN
  _AfterEditInsert();
 END {FOrderL_OnAfterEdit};

 PRIVATE PROCEDURE FOrderL_OnBeforeInsert();
 BEGIN
  L_General.Assert(~!FOrder.Date & ~!FOrder.MCode & ~!FOrder.Period, '।⥫쭮 㦭  , ਮ ("")    ਪ.');
  FOrderL._Closed:=FOrder.Closed;
  FOrderL.EDOSrc :=FOrder.EDOSrc;
  FOrderL.AllODate:=L_EDO.AllODateAllowed();
  REPLACE(FOrderL);
  SetupODate(1);
 END {FOrderL_OnBeforeInsert};

 PRIVATE PROCEDURE FOrderL_OnAfterInsert();
 BEGIN
  _AfterEditInsert();
 END {FOrderL_OnAfterInsert};

 PRIVATE PROCEDURE FOrderL_OnBeforeDelete();
 BEGIN
  ProceedFOrderL(-1);
 END {FOrderL_OnBeforeDelete};

 PRIVATE PROCEDURE FOrderL_OnReposition();
 BEGIN
  IF ACCESS(FOrderL) THEN
   IF RTI.Get().CurWindow.Name = "FOrdTSN" THEN
    CHANGESEL(FOrderL, TSN, , FOrderL.TSN, FOrderL._Closed);
    FIRST(FOrderL);
    WHILE OCCURE(FOrderL) DO
     CONFORM(FOrderL, EDOSrc);
     L_General.Assert(L_AcsPnt.MayPassAccessPoint(EDOSrc.apMFO) | L_AcsPnt.MayPassAccessPoint(EDOSrc.apVFO),
                      " ਪ,  ᬮ     稩");
     NEXT(FOrderL);
    END; (* WHILE OCCURE(FOrderL) ... *)
   ELSE
    SetupODate(0);
   END;
  END;
 END {FOrderL_OnReposition};

 PRIVATE PROCEDURE FOrderL_ODate_OnAskPhase1();
 BEGIN
  L_General.Assert(~!FOrderL.TSN, "।⥫쭮 㦭  ࠡ⭨");
 END {FOrderL_ODate_OnAskPhase1};

 PRIVATE PROCEDURE FOrderL_ODate_OnAskPhase2();
 BEGIN
  IF FOrderL.ODate # StaffLog.Date THEN
   FOrderL.AllODate:=0;
   FOrderL.ODate   :=StaffLog.Date;
   REPLACE(FOrderL);
   CONFORM(FOrderL, FOrder);
   ShtDone();
  END;
 END {FOrderL_ODate_OnAskPhase2};

BEGIN
 L_Events.ExecuteHandler();
END.
