(*
%Copyright   (c) Polak IT
%Author      14.05.2012 10:41:24 POLAK\GAV
%Purpose
%Type        operation
%Specific    SYS
%Modified    04.06.2014 14:34:35 POLAK\GAV
%Environment
*)

 MODULE FO_RKeep [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_EDO, L_ExtDB, L_General, FIO, L_OwnData, L_Staff, L_FIO, P_Firm, L_PRoll, L_ctc, L_DatTim;

 CONST
  RepName = "FORKp";
  dbfPath = "TXT\RKeeper";

  VAR
   ImpFileName: STRING[];
   TotSumExcl,
   TotSum     : NUMERIC[2];
   mode       : SCAL[2];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
FOrder.Period, L, "N.y"
L_EDO.FOrderName()+" ( "+FOrder.FOrder+")", C, ""
"室 䠩 "+ImpFileName+" "+FLDTOSTR(L_FIO.GetFileLastModifiedDTS(ImpFileName), "D.N.y H:M:S"), C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                  ⮪ ନ஢ ਪ  㤥ঠ  ⠬ R-Keeper  #######                  |
|############################################################################################################|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|   |                             |    㬬|ਬ砭                                                 |
|-----|--------------------------------|---------|-----------------------------------------------------------|
}
*)

(*
$P{ Line:
Man.Man, R, ""
Man.Name, L, ""
?, R, "2-"
?, L, ""
@
|#####|################################|#########|###########################################################|
}
*)

(*
$P{ Bot:
TotSum, R, "2-"
TotSumExcl, L, "2-"
@
|--------------------------------------|---------|-----------------------------------------------------------|
|⮣                                 |#########| ⮬ ᫥ ᪫祭 ######################               |
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE ManIsLeader(): SCAL[2];
 BEGIN
  SELECT(FirmCtc, Contact, , Man.Contact);
  WHILE OCCURE(FirmCtc) DO
   IF (FirmCtc.CKType = L_ctc.ckt_Leader) &
      L_DatTim.IsActiveInIntvl(FOrder.Period, L_DatTim.MonthEnd(FOrder.Period),  FirmCtc.Begin, FirmCtc.Till) THEN
    RETURN 1;
   END;
   NEXT(FirmCtc);
  END; (* WHILE OCCURE(FirmCtc) ... *)
  RETURN 0;
 END {ManIsLeader};

 PRIVATE PROCEDURE GetSumm(): NUMERIC[2];
 BEGIN
  IF mode THEN
   RETURN summ.sumdisc;
  ELSE
   RETURN summ.sumout;
  END;
 END {GetSumm};

 PRIVATE PROCEDURE NeedSumm(): SCAL[2];
  VAR
   Result : SCAL[2];
   foMCode: LIKE(FOrder.MCode);
   P      : DATE;
   cnt    : NUMERIC[0];
 BEGIN
  Result:=1;
  IF ManIsLeader() THEN
  L_General.Assert(SEARCH(Staff, TSN, L_Staff.Man2TSN(FOrder.Date, Man.Man, FOrder.MyFirm, 1, 0)),
                   " । ࠡ⭨.  " + summ.tel2);
   MAKEPART(R, Line, -GetSumm(), "- ." + Staff.TSN + " 㪮⥫");
   Result:=0;
  ELSE
   foMCode:=FOrder.MCode;
   P      :=FOrder.Period;
   cnt    :=0;
   SAVE(FOrder);
   SELECT(Staff, Man, , Man.Man);
   WHILE OCCURE(Staff) DO
    SETSEL(FOrderL, TSN, Staff.TSN);
    SRCINSEL(FOrderL, GE, , P);
    WHILE OCCURE(FOrderL) DO
     CONFORM(FOrderL, FOrder);
     IF (FOrder.MCode = foMCode) & (FOrder.Period = P) & L_EDO.IsRealFOrder() THEN
      MAKEPART(R, Line, -GetSumm(), "- ." + FOrderL.TSN + "  ਪ " + FOrderL.FOrder +
                                      "  㬬 " + FLDTOSTR(FOrderL.Value, "2-"));
      INC(cnt);
     END;
     NEXT(FOrderL);
    END; (* WHILE OCCURE(FOrderL) ... *)
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   RESTORE(FOrder);
   Result:=cnt = 0;
  END;
  RETURN Result;
 END {NeedSumm};

 PUBLIC PROCEDURE FORKp();
 BEGIN
  mode:=0;
  mode:=L_StdFrm.ShowListAsMenu("ঠ 㬬| ᪨ ( )", " ਪ");
  L_EDO.InitPrepareFOrder();
  L_General.Assert(FOrder.Type = L_PRoll.fot_BySum, "ਪ     㬬");
  ImpFileName:=FIO.MakePath(L_Str.PoolItem("summ|disc", mode) + "_" + FLDTOSTR(FOrder.Period, "Ny"),
                            "dbf", dbfPath);
  L_General.Assert(FIO.Exists(ImpFileName), "  䠩 " + ImpFileName);
  L_ExtDB.MakeDBFMirror("summ", ImpFileName, "isdepart,tel2");
  OPENREP(R, L_General.NameConnection(RepName + "_" + mode), Create);
  MAKEPART(R, Top);
  TotSumExcl:=0; TotSum:=0;
  SELECT(summ, isdepart, , 0);
  WHILE OCCURE(summ) DO
   PROMPT(summ.tel2);
   IF ~!GetSumm() & (GetSumm() # 0) THEN
    L_General.Assert(~!summ.tel2, " 㪠 .  " + summ.card + " " + summ.name);
    L_General.Assert(SEARCH(Man, Man, summ.tel2), "   " + summ.tel2);
    IF    Man.Name # summ.name THEN
     MAKEPART(R, Line, -GetSumm(), "-   䠩 ⫨砥: " + summ.name);
    ELSIF NeedSumm() THEN
     L_General.Assert(SEARCH(Staff, TSN, L_Staff.Man2TSN(FOrder.Date, Man.Man, FOrder.MyFirm, 1, 0)),
                      " । ࠡ⭨.  " + summ.tel2);
     L_Staff.PosToStaffLog(Staff.TSN, FOrder.Date, 1);
     L_EDO.AppendFOrderL(0, -GetSumm());
     MAKEPART(R, Line, -GetSumm(), " ." + FOrderL.TSN);
    ELSE
     INC(TotSumExcl, -GetSumm());
    END;
    INC(TotSum, -GetSumm());
   END; (* IF ~!GetSumm() & (GetSumm() # 0) *)
   NEXT(summ);
  END; (* WHILE OCCURE(summ) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {FORKp};

END.