(*
%Copyright   (c) Polak Computer System
%Author      09.09.1996 17:11:12 DIM
%Purpose     ७  娢 
%Type        operation
%Specific    AP
%Modified    03.04.2013 15:45:06 POLAK\GAV
%Environment
*)

 MODULE Freeze [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_MDoc, L_Way, L_Str, L_XDoc,
        L_APtm, L_TRS, Memo, SysLog, L_Env, L_bp, L_StdFrm, L_Guard;

 PRIVATE CONST
  a_Freeze  = 0;
  a_Defrost = 1;
  a_Pool = "७  娢 |७  娢 ";

  m_TckRcS        = 059;
  m_RWayS         = 060;
  m_MDoc          = 061;
  m_SalaryFreeze  = 062;
  m_SalaryDefrost = 063;

 PRIVATE TYPE
  tAction = SCAL[2];

 PRIVATE PROCEDURE Prompt(Id: STRING[]; D: DATE);
 BEGIN
  PROMPT(L_DatTim.DateStr(D) + ", " + Id);
 END {Prompt};

 PRIVATE PROCEDURE Confirm(Subject: STRING[]; minDelta: NUMERIC[0]; Action: tAction);
 BEGIN
  L_StdFrm.Question(Subject + ":|" + L_Str.PoolItem(a_Pool, Action) + "  ਮ  " +
                    L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut()));
  IF ~L_Guard.IsJobConnection(APP.Get().MyConnection) THEN
   L_General.SilentAdminOnly();
  END;
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
  L_General.Assert(L_DatTim.CompleteMonthsInIntvl(Memo.ud_fr(), Memo.ud_ut()) <= 6,
                   "ਮ   ॢ ." +
                   "||७    ⥫ ਮ" +
                   "|᫥ 믮  ᪮쪮 ਥ.");
  IF Action = a_Freeze THEN
   L_General.Assert(Memo.ud_ut() < L_DatTim.IncMonth(L_DatTim.MonthBeg(SYSDATE()), -minDelta),
                    "砭 ਮ ७  " +
                    "| ⥬   , 祬  " + L_Str.IntStr(minDelta) + " 楢");
  END;
 END {Confirm};

 PRIVATE PROCEDURE check_Dummy(): SCAL[2];
 BEGIN
  RETURN 1;
 END {check_Dummy};

 PRIVATE PROCEDURE check_MDoc(): SCAL[2];
 BEGIN
  RETURN 1;
 END {check_MDoc};

 PRIVATE PROCEDURE check_RWayS(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(RWayS);
  CHANGESEL(RWayS, BoxNbr, , RWayS.BoxNbr);
  Result:=NEXT(RWayS) & (RWayS.Status = L_Way.rwsStat_Rated);
  RESTORE(RWayS);
  RETURN Result;
 END {check_RWayS};

 PRIVATE PROCEDURE check_TckRcS(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(TckRcS);
  CHANGESEL(TckRcS, TSN, , TckRcS.TSN);
  Result:=NEXT(TckRcS) & (TckRcS.Status = L_TRS.trsStat_Rated);
  RESTORE(TckRcS);
  RETURN Result;
 END {check_TckRcS};

 PRIVATE PROCEDURE SingleTransaction(_Mode: SCAL[255]);
 BEGIN
  IF    _Mode = m_TckRcS THEN
   FreezeXDocJrn(L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, TckRcS.TckRcS);
   FREEZE(TckRcS);
  ELSIF _Mode = m_RWayS THEN
   FreezeXDocJrn(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
   FREEZE(RWayS);
  ELSIF _Mode = m_MDoc THEN
   FreezeXDocJrn(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
   FREEZE(MDoc);
  ELSIF _Mode = m_SalaryFreeze THEN
   DoSalary(a_Freeze);
  ELSIF _Mode = m_SalaryDefrost THEN
   DoSalary(a_Defrost);
  ELSE
   L_General.BadMode(_Mode);
  END;
 END {SingleTransaction};

 PRIVATE PROCEDURE FreezeSingle(File        : STRING[];
                                SpecialCheck: PROC;
                                callMode    : NUMERIC[0]): SCAL[2];
  VAR
   MayDoIt: SCAL[2];
 BEGIN
  SAVE(^File);
  MayDoIt:=NEXT(^File);
  RESTORE(^File);
  MayDoIt:=MayDoIt & SpecialCheck();
  IF MayDoIt THEN
   TRY [TRANSACTION(TRANSACTION_SLAVE2)]
    SingleTransaction(callMode);
   EXCEPT
   ON Exc:Exc_Root DO
    L_General.Error(Exc.MsgOriginalText+"|| १  ࠧ");
   END;
   SLEEP(0.5);
  END;
  RETURN MayDoIt;
 END {FreezeSingle};

 PRIVATE PROCEDURE DoSYSLOG(VAR Cnt: NUMERIC[0]; Till: DATE);
 BEGIN
  APP.Get().NewPrompt("SYSLOG");
  SELECT(SYSLOG, SYSLOG);
  WHILE (Cnt < 500000) & OCCURE(SYSLOG) DO
   NARROWSEL(SYSLOG, User);
   IF SRCINSEL(SYSLOG, LT, Till) THEN
    TRY [TRANSACTION(TRANSACTION_SLAVE2)]
     WHILE OCCURE(SYSLOG) & ~FREEZED(SYSLOG) DO
      Prompt(SYSLOG.User, SYSLOG.Date);
      FREEZE(SYSLOG);
      IF OCCURE(SYSLOG) THEN
       PREV(SYSLOG);
       PREV(SYSLOG);
      END;
      INC(Cnt);
     END; (* WHILE OCCURE(SYSLOG) ... *)
    EXCEPT
    ELSE
    END; (* TRY *)
   END;
   NEXTINEXTENDEDSEL(SYSLOG, User);
  END; (* WHILE OCCURE(SYSLOG) ... *)
 END {DoSYSLOG};

 PRIVATE PROCEDURE DoSYSLOG_(VAR Cnt: NUMERIC[0]; Till: DATE);
 BEGIN
  APP.Get().NewPrompt("SYSLOG_");
  SELECT(SYSLOG_, AcsObj);
  WHILE (Cnt < 500000) & OCCURE(SYSLOG_) DO
   NARROWSEL(SYSLOG_, AcsObj);
   IF SRCINSEL(SYSLOG_, LT, Till) THEN
    CONFORM(SYSLOG_, AcsObj);
    TRY [TRANSACTION(TRANSACTION_SLAVE2)]
     LOOP
      IF ~OCCURE(SYSLOG_) THEN
       EXIT;
      END;
      Prompt(AcsObj.Name, SYSLOG_.Date);
      IF SYSLOG_.tmpRcCnt # 0 THEN
       PREV(SYSLOG_);
      ELSIF FREEZED(SYSLOG_) THEN
       EXIT;
      ELSE
       FREEZE(SYSLOG_);
       IF OCCURE(SYSLOG_) THEN
        PREV(SYSLOG_);
        PREV(SYSLOG_);
       END;
      END; (* IF ~OCCURE(SYSLOG_) *)
      INC(Cnt);
     END; (* LOOP *)
    EXCEPT
    ELSE
    END; (* TRY *)
   END;
   NEXTINEXTENDEDSEL(SYSLOG_, AcsObj);
  END; (* WHILE OCCURE(SYSLOG_) ... *)
 END {DoSYSLOG_};

 PRIVATE PROCEDURE FreezeSysLog(Action: tAction);
  VAR
   Cnt : NUMERIC[0];
   Till: DATE;
 BEGIN
  Cnt :=0;
  Till:=SYSDATE() - 10;
  TRY [INTEGRITY(INTEGRITY_ON)]
   SysLog.Mark("Freeze", "SYSLOG  " + L_DatTim.DateStr(Till) + ": " + L_Str.PoolItem(a_Pool, Action));
   DoSYSLOG(Cnt, Till);
   DoSYSLOG_(Cnt, Till);
  EXCEPT
  END;
 END {FreezeSysLog};

 PRIVATE PROCEDURE FreezeXDocJrn(trgXDocType: LIKE(XDocJrn.XDocType);
                                 trgXDocKind: LIKE(XDocJrn.XDocKind);
                                 trgXDoc    : LIKE(XDocJrn.XDoc));
 BEGIN
  IF SELECT(XDocJrn, XDocJrn, trgXDocType, trgXDocKind, trgXDoc) THEN
   FREEZESEL(XDocJrn);
  END;
 END {FreezeXDocJrn};

 PRIVATE PROCEDURE MarkImAction(Action: tAction; ObjName: STRING[]);
 BEGIN
  SysLog.Mark(L_Str.PoolItem("Freeze|Defrost", Action),
              ObjName + "  " + L_DatTim.PeriodStr(Memo.ud_fr()) + "-" +
              L_DatTim.PeriodStr(Memo.ud_ut()) + ": " + L_Str.PoolItem(a_Pool, Action));
 END {MarkImAction};

 PRIVATE PROCEDURE DoTckRcS();
 BEGIN
  APP.Get().NewPrompt("");
  SELECT(TckRcS, Date);
  SRCINSEL(TckRcS, GE, , Memo.ud_fr());
  WHILE OCCURE(TckRcS) & (TckRcS.Date <= Memo.ud_ut()) DO
   Prompt(TckRcS.TckRcS, TckRcS.Date);
   IF FREEZED(TckRcS) |
      ~FreezeSingle("TckRcS", PROCREF(check_TckRcS), m_TckRcS) THEN
    NEXT(TckRcS);
   END;
  END; (* WHILE OCCURE(TckRcS) ... *)
 END {DoTckRcS};

 PRIVATE PROCEDURE DoRWayS();
 BEGIN
  APP.Get().NewPrompt("⥢ ");
  SELECT(RWayS, Date);
  SRCINSEL(RWayS, GE, , Memo.ud_fr());
  WHILE OCCURE(RWayS) & (RWayS.Date <= Memo.ud_ut()) DO
   Prompt(RWayS.RWayS, RWayS.Date);
   IF FREEZED(RWayS) | ~FreezeSingle("RWayS", PROCREF(check_RWayS), m_RWayS) THEN
    NEXT(RWayS);
   END;
  END;
 END {DoRWayS};

 PUBLIC PROCEDURE DoRWS(Action: tAction);
 BEGIN
  Confirm("⥢ 㬥", L_APtm.adna_RWayS, a_Freeze);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  MarkImAction(Action, "⥢ ");
  TRY [INTEGRITY(INTEGRITY_ON)]
   DoTckRcS();
   DoRWayS();
  EXCEPT
  END;
 END {DoRWS};

 PUBLIC PROCEDURE FrRWS();
  CONST
   bpId = "FrRWS";
 BEGIN
  L_bp.extBegin(bpId, "७  娢  ⥢ 㬥樨",
                L_bp.t_Process, L_General.tc_inIntvl, L_bp.pt_Low);
  DoRWS(a_Freeze);
  FreezeSysLog(a_Freeze);
  L_bp.End();
 END {FrRWS};

 PUBLIC PROCEDURE DoMDoc(Action: tAction);
 BEGIN
  Confirm(" 㬥", L_APtm.adna_MDoc, a_Freeze);
  MarkImAction(Action, " 㬥");
  TRY [INTEGRITY(INTEGRITY_ON)]
   APP.Get().NewPrompt(" 㬥");
   SELECT(MDoc, Date);
   SRCINSEL(MDoc, GE, , Memo.ud_fr());
   WHILE OCCURE(MDoc) & (MDoc.Date <= Memo.ud_ut()) DO
    Prompt(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), MDoc.Date);
    IF FREEZED(MDoc) |
       ~FreezeSingle("MDoc", PROCREF(check_MDoc), m_MDoc) THEN
     NEXT(MDoc);
    END;
   END; (* WHILE OCCURE(MDoc) ... *)
  EXCEPT
  END;
 END {DoMDoc};

 PUBLIC PROCEDURE FrMDc();
  CONST
   bpId = "FrMDc";
 BEGIN
  L_bp.extBegin(bpId, "७  娢  ⮢ 㬥⮢",
                L_bp.t_Process, L_General.tc_inIntvl, L_bp.pt_Low);
  DoMDoc(a_Freeze);
  FreezeSysLog(a_Freeze);
  L_bp.End();
 END {FrMDc};

 PRIVATE PROCEDURE DoSalary(Action: tAction);
  VAR
   Proc: PROC;
 BEGIN
  IF    Action = a_Freeze  THEN
   FREEZE(PCalc);
   Proc:=PROCREF(FREEZESEL);
  ELSIF Action = a_Defrost THEN
   DEFROST(PCalc);
   Proc:=PROCREF(DEFROSTSEL);
  END;

  TRY [INTEGRITY(INTEGRITY_ON)]
   IF SELECT(Money, TSN, PCalc.TSN, PCalc.Period) THEN
    Proc(Money);
   END;
   IF SELECT(Sheet, TSN, PCalc.TSN, PCalc.Period) THEN
    Proc(Sheet);
   END;
   IF SELECT(Monthly, TSN, PCalc.TSN, PCalc.Period) THEN
    Proc(Monthly);
   END;
  EXCEPT
  END;
 END {DoSalary};

 PRIVATE PROCEDURE SalaryAll(Action: tAction; ProcOneMode: SCAL[255]);
 BEGIN
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
  Confirm("ଠ  ௫", L_APtm.adna_Salary, Action);
  MarkImAction(Action, "  ௫");

  APP.Get().NewPrompt("ଠ  ௫");
  SELECT(PCalc, Period);
  SRCINSEL(PCalc, GE, , Memo.ud_fr());
  WHILE OCCURE(PCalc) & (PCalc.Period <= Memo.ud_ut()) DO
   Prompt(PCalc.TSN, PCalc.Period);
   IF ~FreezeSingle("PCalc", PROCREF(check_Dummy), ProcOneMode) THEN
    NEXT(PCalc);
   END;
  END;
 END {SalaryAll};

 PUBLIC PROCEDURE FrSal();
  CONST
   bpId = "FrSal";
 BEGIN
  L_bp.extBegin(bpId, "७  娢    ௫",
                L_bp.t_Process, L_General.tc_inIntvl, L_bp.pt_Low);
  SalaryAll(a_Freeze, m_SalaryFreeze);
  FreezeSysLog(a_Freeze);
  L_bp.End();
 END {FrSal};

 PUBLIC PROCEDURE DefrostSalary();
 BEGIN
  APP.Get().NewPrompt("७  娢    ௫");
  SalaryAll(a_Defrost, m_SalaryDefrost);
 END {DefrostSalary};

 PRIVATE PROCEDURE GetFileFP(File, Field, Msg: STRING[]): DATE;
  CONST
   nToCheck    = 30;
   nHasFreesed = 20;
  VAR
   Result: DATE;
   i, a: NUMERIC[0];
   Ch: STRING[];
 BEGIN
  Result:=L_DatTim.Per(SYSDATE());
  SETSEL(^File, ^Field);
  LOOP
   IF SRCINSEL(^File, LE, L_DatTim.MonthBeg(Result)-1) THEN
    IF ^File.^Field < L_Env.aptm_Start THEN
     Result:=L_DatTim.Per(L_Env.aptm_Start-1);
     EXIT;
    END;
    Result:=L_DatTim.Per(^File.^Field);
    i:=0;
    a:=0;
    Ch:="OCCURE("+File+") & (i<nToCheck) & ("+File+"."+Field+">=Result)";
    WHILE ^Ch DO
     PROMPT(Msg+" "+L_DatTim.PeriodStr(Result));
     IF FREEZED(^File) THEN
      INC(a);
     END;
     INC(i);
     PREV(^File);
    END; (* WHILE OCCURE(^File) ... *)
    IF ((i = nToCheck) & (a>=nHasFreesed)) |
       (i=a) THEN
     EXIT;
    END;
   ELSE
    EXIT;
   END;
  END;
  RETURN L_DatTim.IncMonth(Result, +1);
 END {GetFileFP};

 PUBLIC PROCEDURE ShowFP();
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_StdFrm.Inform(" ७ᥭ  娢 :||"+
                  "⥢ 㬥:  "+L_DatTim.PeriodStr(GetFileFP("RWayS", "Date", ""))+"|"+
                  "  ௫  :  "+L_DatTim.PeriodStr(GetFileFP("PCalc", "Period", ""))+"|"+
                  " 㬥  :  "+L_DatTim.PeriodStr(GetFileFP("MDoc",  "Date", "")));
 END {ShowFP};

END.
