(*
%Copyright   (c) Polak IT
%Author      26.05.2004 15:50:47 POLAK\ATS
%Purpose     ᪮७ ଫ ஢  䨧栬.
%Type        control
%Specific    LOC
%Modified    18.09.2013 16:23:56 POLAK\Bor
%Environment
*)

 MODULE FrmManCn [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, P_Firm, Memo, L_Events, L_Cntr, L_WDO, L_Prop, Str, L_APtm, L_SysLog;

 PRIVATE PERMANENT VAR
  v_ContractForNarrowing: LIKE(Contract.Contract);

 PRIVATE CONST
  fn_v_Parent = "ParentContract";

 PUBLIC PROCEDURE SetDocReq(W: FORM_WINDOW);
  VAR
   Fields     : FORM_FIELDS;
   trgDocSer,
   trgDocNum,
   trgDocGiveS: STRING[];
   trgDocExpD,
   trgDocGiveD: DATE;
 BEGIN
  SETEMPTY(trgDocSer, trgDocNum, trgDocGiveS, trgDocExpD, trgDocGiveD);
  IF OCCURE(FirmPro) & (FirmPro.Property = P_Firm.P_RegName) &
     (FirmPro.Date <= Memo.ud_cd()) & (FirmPro.EndDate >= Memo.ud_cd()) THEN
   L_Prop.GetDocSerAndNum(FirmPro.DocNum, trgDocSer, trgDocNum);
   trgDocGiveS:=FirmPro.DocGiveS;
   trgDocGiveD:=FirmPro.DocGiveD;
   trgDocExpD :=FirmPro.DocExpD;
  END;

  Fields:=W.Zones(0).Fields;
  Fields("Firm_RegName_DocSer").Value  :=trgDocSer;
  Fields("Firm_RegName_DocNum").Value  :=trgDocNum;
  Fields("Firm_RegName_DocGiveS").Value:=trgDocGiveS;
  Fields("Firm_RegName_DocGiveD").Value:=trgDocGiveD;
  Fields("Firm_RegName_DocExpD").Value :=trgDocExpD;
 END {SetDocReq};

 PRIVATE PROCEDURE Firm_OnBeforeInsert();
 BEGIN
  Firm.PrtnrTyp:=P_Firm.pt_Man;
  Firm.Begin   :=Memo.ud_cd();
  REPLACE(Firm);

  DEFAULT(Contract);
  Contract.Firm   :=Firm.Firm;
  Contract.MyFirm :=P_Firm.DefineMyFirm();
  Contract.iiType :=L_Cntr.iit_Contract;
  Contract.SrcDate:=Memo.ud_cd();
  Contract.Begin  :=Contract.SrcDate;
  Contract.Date   :=Contract.SrcDate;
  INSERT(Contract);
  L_APtm.SysLogHandler("Contract", L_SysLog.knd_Insert);

  L_WDO.cField("Contract_Contract").Value:=Contract.Contract;
  L_WDO.cField("Contract_SrcDate").Value :=Contract.SrcDate;

  v_ContractForNarrowing:=Contract.Contract;

  SetDocReq(RTI.Get().CurWindow);
 END {Firm_OnBeforeInsert};

 PRIVATE PROCEDURE Firm_OnAfterInsert();
  VAR
   Fields     : FORM_FIELDS;
   trgDocGiveD,
   trgDocExpD: DATE;
 BEGIN
  L_General.CallUs(ACCESS(Firm));

  Fields:=RTI.Get().CurZone.Fields;
  trgDocGiveD:=Fields("Firm_RegName_DocGiveD").Value;
  trgDocExpD :=Fields("Firm_RegName_DocExpD").Value;

  IF ~!trgDocGiveD                         |
     ~!trgDocExpD                          |
     ~!Fields("Firm_RegName_DocNum").Value |
     ~!Fields("Firm_RegName_DocGiveS").Value THEN
   IF ~P_Firm.HasActualFirmPro(Firm.Firm, Firm.Begin, P_Firm.P_RegName) &
      ~(SELECT(FirmPro, Firm, Firm.Firm, P_Firm.P_RegName) & SRCINSEL(FirmPro, GE, Firm.Begin)) THEN
    DEFAULT(FirmPro);
    FirmPro.Firm    :=Firm.Firm;
    FirmPro.Property:=P_Firm.P_RegName;
    FirmPro.Date    :=Firm.Begin;
    INSERT(FirmPro);
   END;

   FirmPro.DocNum  :=Str.Condense(Fields("Firm_RegName_DocSer").Value + " " + Fields("Firm_RegName_DocNum").Value);
   FirmPro.DocGiveS:=Fields("Firm_RegName_DocGiveS").Value;
   FirmPro.DocGiveD:=Fields("Firm_RegName_DocGiveD").Value;
   FirmPro.DocExpD :=Fields("Firm_RegName_DocExpD").Value;
   REPLACE(FirmPro);
  END;

  L_General.CallUs(SEARCH(Contract, Contract, Fields("Contract_Contract").Value));
  SAVE(Contract);
  CALL(Firm.Firm_OnAfterInsert());
  RESTORE(Contract);

  Contract.Parent :=Fields(fn_v_Parent).Value;
  Contract.Name   :=Fields("Contract_Name").Value;
  Contract.SrcNbr :=Fields("Contract_SrcNbr").Value;
  Contract.SrcDate:=Fields("Contract_SrcDate").Value;
  Contract.CntrT  :=Fields("ParentContract_CntrT").Value;
  Contract.Type   :=Fields("ParentContract_Type").Value;
  Contract.ACSet  :=Fields("ParentContract_ACSet").Value;
  Contract.Begin  :=Contract.SrcDate;
  Contract.Date   :=Contract.SrcDate;
  Contract.Firm   :=Firm.Firm;
  REPLACE(Contract);

  CALL(Contract.CheckContractAfterInsert());

  L_Cntr.UpdateGroupParent(L_Cntr.iit_CntrTGroup, Contract.CntrT, 1);
  L_Cntr.UpdateGroupParent(L_Cntr.iit_FirmGroup,  Contract.Firm,  1);
 END {Firm_OnAfterInsert};

 PRIVATE PROCEDURE CheckIsContractTemplate();
 BEGIN
  L_General.Assert((Contract.Leaf = 0) & (Contract.iiType = L_Cntr.iit_ContractTemplate), "室 㪠 蠡 ");
 END {CheckIsContractTemplate};

 PRIVATE PROCEDURE Firm_ParentContract_OnSuccessfulChange();
  VAR
   curParent: LIKE(Contract.Parent);
   Fields : FORM_FIELDS;
 BEGIN
  Fields :=RTI.Get().CurZone.Fields;
  curParent:=Fields(fn_v_Parent).Value;
  IF ~!curParent THEN
   L_General.Assert(SEARCH(Contract, Contract, curParent), "  蠡 " + curParent);
   CheckIsContractTemplate();
   CONFORM(Contract, CntrT);
   Fields("ParentContract_CntrT").Value     :=CntrT.CntrT;
   Fields("ParentContract_CntrT_Name").Value:=CntrT.Name;
   Fields("ParentContract_Type").Value      :=CntrT.Type;
   L_General.Assert(~!Contract.ACSet, " 蠡  㪠   ࠧ१");
   CONFORM(Contract, ACSet);
   Fields("ParentContract_ACSet").Value     :=ACSet.ACSet;
   Fields("ParentContract_ACSet_Name").Value:=ACSet.Name;

   SEARCH(Contract, Contract, , Fields("Contract_Contract").Value);
   Contract.Type  :=CntrT.Type;
   Contract.Parent:=curParent;
   REPLACE(Contract);
  ELSE
   SETEMPTY(Fields("ParentContract_CntrT").Value,
            Fields("ParentContract_CntrT_Name").Value,
            Fields("ParentContract_Type").Value,
            Fields("ParentContract_ACSet").Value,
            Fields("ParentContract_ACSet_Name").Value);
  END;
 END {Firm_ParentContract_OnSuccessfulChange};

 PRIVATE PROCEDURE Firm_Contract_SrcDate_OnSuccessfulChange();
 BEGIN
  SEARCH(Contract, Contract, , RTI.Get().CurZone.Fields("Contract_Contract").Value);
  Contract.Begin:=RTI.Get().CurZone.ActiveField.Value;
  Contract.Date :=Contract.Begin;
  REPLACE(Contract);
 END {Firm_Contract_SrcDate_OnSuccessfulChange};

 PRIVATE PROCEDURE FrmManCn_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterInsert]);
  L_WDO.iField       (0, "ParentContract_ACSet").AskMode:=1;
  L_WDO.iField       (0, "ParentContract_Name").Visible:=0;
  L_WDO.iField       (0, "ParentContract_Type").Format:=L_Cntr.ct_Pool;
  L_WDO.iScsChange   (0, ["Contract_SrcDate", "ParentContract_ACSet", "ParentContract", "Firm._INN"]);
  L_WDO.iUnmodifiable(0, ["ParentContract_Name", "ParentContract_ACSet_Name", "ParentContract_ACSet",
                          "ParentContract_CntrT", "ParentContract_CntrT_Name", "ParentContract_Type",
                          "Contract_Contract", "Firm.Firm"]);
  L_WDO.iMayBeEmpty  (0, ["Firm_RegName_DocSer", "Firm_RegName_DocNum", "Firm_RegName_DocExpD",
                          "Firm_RegName_DocGiveD", "Contract_SrcNbr", "Firm_RegName_DocGiveS", "Firm._INN"]);
  L_WDO.iProgs       (0, "FrmManCn");
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iProgs       (1, "ObjPro");
  L_WDO.iEvents      (2, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iProgs       (2, "ObjPro");
  L_WDO.iZone        (2).Narrowing:="CntrPro.Contract=FrmManCn.v_ContractForNarrowing";
  L_WDO.iZone        (2).PermanentFilter:="CntrPro.Date>=Firm.Begin";
  L_WDO.CreateFormLink("Contract", "Parent");
 END {FrmManCn_OnInitializeWindow};

 PRIVATE PROCEDURE Firm__INN_OnSuccessfulChange();
 BEGIN
  P_Firm.Check_INN(Firm._INN);
 END {Firm__INN_OnSuccessfulChange};

BEGIN
 L_Events.ExecuteHandler();
END.
