(*
%Copyright   (c) Polak Computer System
%Author      26.05.1995 10:48:22 POLAK
%Purpose     뢠 ࠡ,  ...
%Type        operation
%Specific    SYS
%Modified    26.12.2012 21:10:21 POLAK\Gina
%Environment
*)

 MODULE GetTDone [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Str, L_DatTim, L_General, Memo, L_Sheet, Math, L_StdFrm;

 VAR UpTo: DATE;

 PRIVATE PROCEDURE GetGate(VAR D1, D2: DATE);
 BEGIN
  D1:=Math.Max(Staff.BegDate, L_DatTim.MonthBeg(UpTo));
  D2:=Math.Min(Staff.EndDate, UpTo);
 END {GetGate};

 PRIVATE PROCEDURE Make();
  VAR
   HolTime,
   TimDone,
   Bal,
   Corr,
   NightTime: NUMERIC[4];
   BegD,
   EndD     : DATE;
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  L_General.Assert(SYSDATE() >= L_DatTim.MonthBeg(UpTo), " "+L_DatTim.PeriodStr(UpTo)+"   㯨");
  SAVE(Sheet);
  GetGate(BegD, EndD);
  L_Sheet.GetBalInf(BegD, EndD, 1, TimDone, Bal, Corr, NightTime, HolTime);
  RESTORE(Sheet);
  CONFORM(Staff, Man);
  L_StdFrm.Inform(Staff.TSN + " - " + L_Str.ShortName(Man.Name) +
                  "|" +
                  "|ଠ ६  " + L_DatTim.DateStr(UpTo) +
                                              " - " + FLDTOSTR(      Bal, "3.", 7) +
                  "|४஢          - " + FLDTOSTR(     Corr, "3.", 7) +
                  "|ࠡ⠭                  - " + FLDTOSTR(  TimDone, "3.", 7) +
                  "|                      - " + FLDTOSTR(NightTime, "3.", 7) +
                  "|ࠧ                 - " + FLDTOSTR(  HolTime, "3.", 7));
 END {Make};

 PUBLIC PROCEDURE GetTDone_Month();
 BEGIN
  UpTo:=Memo.ud_me();
  Make();
 END {GetTDone_Month};

 PUBLIC PROCEDURE GetTDone_CurD();
 BEGIN
  UpTo:=Memo.ud_cd();
  Make();
 END {GetTDone_CurD};

 PUBLIC PROCEDURE GetTDone_CurSheet();
 BEGIN
  L_General.Assert(ACCESS(Sheet), " ⠭ ⥪  ⠡");
  UpTo:=Sheet.Period + Sheet.Day - 1;
  Make();
 END {GetTDone_CurSheet};

END.
