(*
%Copyright   (c) Polak Computer System
%Author      24.06.2010 20:04:38 POLAK\MLB
%Purpose     Group
%Type        operation
%Specific    SYS
%Modified    23.05.2013 17:50:09 POLAK\MLB
%Environment
*)
 IMPORT
  L_Events, L_General, Memo, L_WDO, L_APtm, DBD, L_Group, L_Str, Str, L_StdFrm, L_DatTim, L_DBD, L_AR;

 PRIVATE PROCEDURE GrantRightsByGroupTOwner();
 BEGIN
  L_General.CallUs(OCCURE(Group));
  CONFORM(Group, GroupT);
  IF TABLE.Get(DBD.FileIdToName(GroupT.Owner)).Rights = L_AR.tr_Modify THEN
   L_AR.GrantRightsForInteractiveModification();
  END;
 END {GrantRightsByGroupTOwner};

 PRIVATE PROCEDURE CheckTheRightToChangeGroupT();
  VAR
   OperationName: STRING[];
 BEGIN
  IF    MODE = 000 THEN OperationName:="।஢"
  ELSIF MODE = 002 THEN OperationName:="⠢"
  ELSIF MODE = 004 THEN OperationName:="㤠"
  END;

  L_General.Assert(~L_Group.IsProgrammerBuildGroupT(), " " + OperationName + " 㯭 ⮫쪮  짮⥫᪨ ⨯ 㯯");
 END {CheckTheRightToChangeGroup};

 PRIVATE PROCEDURE CheckTheRightToChangeGroup();
  VAR
   OperationName: STRING[];
 BEGIN
  IF    MODE = 000 THEN OperationName:="।஢"
  ELSIF MODE = 002 THEN OperationName:="⠢"
  ELSIF MODE = 004 THEN OperationName:="㤠"
  END;
  CONFORM(Group, GroupT);
  CheckTheRightToChangeGroupT();
  L_General.Assert(!GroupT.Till, " " + OperationName + " 㯭 ⮫쪮   ⨯ 㯯");
  GrantRightsByGroupTOwner();
 END {CheckTheRightToChangeGroup};

 PRIVATE PROCEDURE GroupTSetFieldsModifiable();
  VAR
   trgNotion: LIKE(ERKN.Notion);
 BEGIN
  trgNotion:=L_Group.GetCurrentGroupTNotion();
  L_WDO.SetFieldModifiable("GroupT.Name",  ~L_Group.IsNotionBasedOnScalVal(trgNotion));
  L_WDO.SetFieldModifiable("GroupT.Owner", ~L_Group.IsNotionBasedOnScalVal(trgNotion) &
                                           !L_Group.GetPropFileNameByNotion(trgNotion));
  L_WDO.SetFieldModifiable("GroupT.ERKN",  ~L_Group.IsProgrammerBuildGroupT());
 END {GroupTSetFieldsModifiable};

 PRIVATE PROCEDURE GroupT_OnReposition();
 BEGIN
  GroupTSetFieldsModifiable();
 END {GroupT_OnReposition};

 PRIVATE PROCEDURE GroupT_OnBeforeInsert();
 BEGIN
  GroupT.Begin:=L_DatTim.MINDATE();
  REPLACE(GroupT);
  GroupTSetFieldsModifiable();
 END {GroupT_OnBeforeInsert};

 PRIVATE PROCEDURE GroupT_OnBeforeEdit();
 BEGIN
  CheckTheRightToChangeGroupT();
 END {GroupT_OnBeforeEdit};

 PRIVATE PROCEDURE GroupT_OnBeforeDelete();
 BEGIN
  CheckTheRightToChangeGroupT();
 END {GroupT_OnBeforeDelete};

 PRIVATE PROCEDURE CheckLegalCountGroupT();
  VAR
   Dummy              : LIKE(GroupT.GroupT);
   CheckingGroupTBegin: DATE;
   CheckingGroupTTill : DATE;
 BEGIN
  SETEMPTY(Dummy);
  IF ~!L_Group.GetCurrentGroupTNotion() THEN
   Dummy:=L_Group.erkn_GetSoft(GroupT.Begin, DBD.FileIdToName(GroupT.Owner), L_Group.GetCurrentGroupTNotion());
  ELSE
   CheckingGroupTBegin:=GroupT.Begin;
   CheckingGroupTTill :=GroupT.Till;
   SAVE(GroupT);
   SELECT(GroupT, Owner, , GroupT.Owner);
   WHILE OCCURE(GroupT) DO
    IF (~L_Group.IsProgrammerBuildGroupT()) &
       L_DatTim.IsActiveInIntvl(CheckingGroupTBegin, CheckingGroupTTill, GroupT.Begin, GroupT.Till) THEN
     IF ~!Dummy THEN
      L_General.Error("   (" + Dummy + "," + GroupT.GroupT + ") ⨯ 㯯   ⭮襭" +
                      "|" + "'" + DBD.FileDescription(^(DBD.FileIdToName(GroupT.Owner))) + "'");
     END;
     Dummy:=GroupT.GroupT;
    END;
    NEXT(GroupT);
   END; (* OCCURE(GroupT) ... *)
   RESTORE(GroupT);
  END;
 END {CheckLegalCountGroupT};

 PRIVATE PROCEDURE CloseGroupE();
 BEGIN
  SELECT(GroupE, Group, , Group.Group);
  WHILE OCCURE(GroupE) DO
   GroupE.Till:=Group.Till;
   REPLACE(GroupE);
   NEXT(GroupE);
  END; (* WHILE OCCURE(GroupE) ... *)
 END {CloseGroupE};

 PRIVATE PROCEDURE CloseGroup();
 BEGIN
  SELECT(Group, GroupT, , GroupT.GroupT);
  WHILE OCCURE(Group) DO
   Group.Till:=GroupT.Till;
   REPLACE(Group);
   CloseGroupE();
   NEXT(Group);
  END; (* WHILE OCCURE(Group) ... *)
 END {CloseGroup};

 PRIVATE PROCEDURE GroupT_OnAfterEdit();
 BEGIN
  CheckLegalCountGroupT();
  L_General.Assert(GroupT.Begin < GroupT.Till, "' '  ' '?");
  IF (GE_PVALUE(GroupT.Owner) # GroupT.Owner) | (GE_PVALUE(GroupT.ERKN) # GroupT.ERKN) THEN
   L_General.Assert(~SELECT(Group, GroupT, GroupT.GroupT), "㥬 ⨯ 㯯  ")
  END;
  IF  (GE_PVALUE(GroupT.Till) # GroupT.Till) & (~!GroupT.Till) THEN
   CloseGroup();
  END;
 END {GroupT_OnAfterEdit};

 PRIVATE PROCEDURE Group_OnAfterEdit();
 BEGIN
  L_General.Assert(Group.Begin < Group.Till, "' '  ' '?");
  IF  (GE_PVALUE(Group.Till) # Group.Till) & (~!Group.Till) THEN
   CloseGroupE();
  END;
 END {Group_OnAfterEdit};

 PRIVATE PROCEDURE GroupT_OnAfterInsert();
 BEGIN
  CheckLegalCountGroupT();
  L_Group.InitializeCurrentGroupT();
 END {GroupT_OnAfterInsert};

 PRIVATE PROCEDURE GroupT_ERKN_OnBeforeAskForEdit();
 BEGIN
  L_APtm.CurrentEntityId:=DBD.FileNameToId(GE_CURFILE());
 END {GroupT_ERKN_OnBeforeAskForEdit};

 PRIVATE PROCEDURE GroupT_ERKN_OnSuccessfulChange();
  VAR
   Pool,
   FileName,
   FieldName : STRING[];
   trgNotion   : LIKE(ERKN.Notion);
 BEGIN
  trgNotion:=L_Group.GetCurrentGroupTNotion();
  IF L_Group.IsNotionBasedOnScalVal(trgNotion) THEN
   SETEMPTY(FileName, FieldName, Pool);
   L_Group.GetFatedNotionInfo(trgNotion, FileName, FieldName, Pool);
   GroupT.Owner:=DBD.FileNameToId(FileName);
   GroupT.Name :=L_Str.PoolItem(L_Group.pool_erknName, trgNotion);
  ELSIF ~!L_Group.GetPropFileNameByNotion(trgNotion) THEN
   GroupT.Owner:=DBD.FileNameToId(DBD.LendFile(^(L_Group.GetPropFileNameByNotion(trgNotion))));
   GroupT.Name :=L_Str.PoolItem(L_Group.pool_erknName, trgNotion);
  ELSE
   SETEMPTY(GroupT.Owner, GroupT.Name);
  END;
  REPLACE(GroupT);
  GroupTSetFieldsModifiable();
 END {GroupT_ERKN_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckFieldType(FieldN: STRING[]): SCAL[2];
  VAR
   Result   : SCAL[2];
   FieldT   : TYPESPEC;
   FieldTId : NUMERIC[0];
 BEGIN
  Result  :=0;
  FieldT  :=FIELD.Get(FieldN).Type;
  FieldTId:=TYPEOF(^(FieldN));
  IF (FieldTId = L_General.ft_NUMERIC) |
     (FieldTId = L_General.ft_SCAL)    |
     (FieldTId = L_General.ft_STRING)   THEN
   Result:=1;
  END;
  RETURN Result;
 END {CheckFieldType};


 PRIVATE PROCEDURE GroupT_Owner_OnSuccessfulChange();
 BEGIN
  L_General.Assert(L_Group.GroupTCanBeCreatedFromThisFile(GroupT.Owner),
                   " ந 㯯  ⭮襭 '" + DBD.FileDescription(^(DBD.FileIdToName(GroupT.Owner))) + "'");
 END {GroupT_Owner_OnSuccessfulChange};

 PRIVATE PROCEDURE Group_OnBeforeEdit();
 BEGIN
  CheckTheRightToChangeGroup();
 END {Group_OnBeforeEdit};

 PRIVATE PROCEDURE Group_OnBeforeInsert();
 BEGIN
  CheckTheRightToChangeGroup();
  Group.Owner:=GroupT.Owner;
  Group.Begin:=GroupT.Begin;
  REPLACE(Group);
 END {Group_OnBeforeInsert};

 PRIVATE PROCEDURE Group_OnBeforeDelete();
 BEGIN
  CheckTheRightToChangeGroup();
 END {Group_OnBeforeDelete};

 PRIVATE PROCEDURE GroupE_OnBeforeEdit();
 BEGIN
  CONFORM(GroupE, Group);
  CheckTheRightToChangeGroup();
 END {GroupE_OnBeforeEdit};

 PRIVATE PROCEDURE GroupE_OnBeforeInsert();
 BEGIN
  CONFORM(GroupE, Group);
  CheckTheRightToChangeGroup();
 END {GroupE_OnBeforeInsert};

 PRIVATE PROCEDURE GroupE_OnAfterEdIns();
  VAR
   Cnt        : NUMERIC[0];
   trg_riOwner: LIKE(GroupE.riOwner);
   trgBegin,
   trgTill    : DATE;
 BEGIN
  Cnt        := 0;
  trg_riOwner:= GroupE.riOwner;
  trgBegin   := GroupE.Begin;
  trgTill    := GroupE.Till;
  CONFORM(GroupE, Group);
  SAVE(GroupE);
  SELECT(GroupE, GriO, , Group.Group, trg_riOwner);
  WHILE OCCURE(GroupE) DO
   IF L_DatTim.IsActiveInIntvl(trgBegin, trgTill, GroupE.Begin, GroupE.Till) THEN
    INC(Cnt);
   END;
   NEXT(GroupE);
  END; (* WHILE OCCURE(GroupE) ... *)
  RESTORE(GroupE);
  L_General.Assert(Cnt = 1 , " , 騥  ਮ  " + L_DatTim.DateStr(GroupE.Begin) + "  " + L_DatTim.DateStr(GroupE.Till));
 END {GroupE_OnAfterEdIns};

 PRIVATE PROCEDURE GroupE_OnAfterInsert();
 BEGIN
  GroupE_OnAfterEdIns();
 END {GroupE_OnAfterInsert};

 PRIVATE PROCEDURE GroupE_OnAfterEdit();
 BEGIN
  GroupE_OnAfterEdIns();
 END {GroupE_OnAfterEdit};

 PRIVATE PROCEDURE GroupE_CodeOwn_OnBeforeAskForEdit();
  VAR
   OwnerFileName,
   OwnCodeField,
   OwnNameField,
   OwnIDField,
   ListOwnRecID,
   ListOwnRecords,
   ListOwnRecCode,
   ListOwnRecName  : STRING[];
   RecNum          : NUMERIC[0];
   MaxCodeOwnLng,
   MaxNameOwnLng,
   MaxriOwnerLng   : NUMERIC[0];
 BEGIN
  CONFORM(GroupE, Group);
  OwnerFileName:=DBD.FileIdToName(Group.Owner);
  OwnCodeField:=L_DBD.GetFieldName(OwnerFileName, OwnerFileName);
  OwnNameField:=L_DBD.GetFieldName(OwnerFileName, "Name");
  OwnIDField:=L_DBD.GetFieldName(OwnerFileName, "RECORDID");
  MaxCodeOwnLng:=Str.MaxLength(GroupE.CodeOwn);
  MaxNameOwnLng:=Str.MaxLength(GroupE.NameOwn);
  MaxriOwnerLng:=Str.Length(L_Str.IntStr(MAXOF(GroupE.riOwner)));
  SETEMPTY(ListOwnRecords, ListOwnRecCode, ListOwnRecName, ListOwnRecID);
  SELECT(^OwnerFileName, ^OwnerFileName);
  WHILE OCCURE(^OwnerFileName) DO
   ListOwnRecCode:=ListOwnRecCode + "|" + L_Str.Right((^OwnCodeField), MaxCodeOwnLng);
   ListOwnRecName:=ListOwnRecName + "|" + L_Str.Right((^OwnNameField), MaxNameOwnLng);
   ListOwnRecID  :=ListOwnRecID   + "|" + L_Str.Right((^OwnIDField),   MaxriOwnerLng);
   ListOwnRecords:=ListOwnRecords + "|" + Str.Align((^OwnCodeField),   MaxCodeOwnLng, LEFT) + " " + Str.Align((^OwnNameField), MaxNameOwnLng, LEFT);
   NEXT(^OwnerFileName);
  END; (* WHILE OCCURE(^OwnerFileName) ... *)
  IF !ListOwnRecords THEN
   STDMSG(" 祣", INFORM);
  ELSE
   RecNum:=L_StdFrm.ShowListAsMenu(ListOwnRecords, DBD.FileDescription(^OwnerFileName));
   L_General.Assert(RecNum # -1, "⪠  ⠢ ");
   L_General.CallUs(SEARCH(^OwnerFileName, RECORDID, L_Str.PoolItem(ListOwnRecID, RecNum)));
   GroupE.Owner  := Group.Owner;
   GroupE.riOwner:= L_Str.PoolItem(ListOwnRecID,   RecNum);
   GroupE.CodeOwn:= L_Str.Right(^(L_DBD.GetFieldName(OwnerFileName, OwnerFileName)),  Str.MaxLength(GroupE.CodeOwn));
   GroupE.NameOwn:= ^(L_DBD.GetFieldName(OwnerFileName, "Name"));
   REPLACE(GroupE);
  END;
 END {GroupE_CodeOwn_OnBeforeAskForEdit};

 PRIVATE PROCEDURE GroupE_OnBeforeDelete();
 BEGIN
  CONFORM(GroupE, Group);
  CheckTheRightToChangeGroup();
 END {GroupE_OnBeforeDelete};

 PRIVATE PROCEDURE Group_GroupT_OnSuccessfulChange();
 BEGIN
  CONFORM(Group, GroupT);
  Group.Owner:= GroupT.Owner;
  REPLACE(Group);
 END {Group_GroupT_OnSuccessfulChange};

 PRIVATE PROCEDURE GroupOwn_OnConformToWindow();
  VAR
   CodeOwn,
   OwnerName: STRING[];
 BEGIN
  IF GE_CURFILE() # "GroupE" THEN
   L_General.Assert(ACCESS(^(GE_CURFILE())), " ⠭ ꥪ");
   OwnerName:=GE_CURFILE();
   SETSEL(GroupE, OwriOwGr, DBD.FileNameToId(OwnerName), (^(L_DBD.GetFieldName(OwnerName, "RECORDID"))));
   SE_WWD_CURSOR(GE_CONFORMTARGETWINDOW(), GroupE);
   L_WDO.wz_setFieldValue("GroupOwn", 0, "v_OwnerName", DBD.FileDescription(^OwnerName) + L_Str.Repeat("", 32 - Str.Length(DBD.FileDescription(^OwnerName))));
   CodeOwn:=L_Str.Right((^(L_DBD.GetFieldName(OwnerName, OwnerName))), Str.MaxLength(GroupE.CodeOwn));
   CodeOwn:=L_Str.Repeat("0", Str.MaxLength(GroupE.CodeOwn) - Str.Length(CodeOwn)) + CodeOwn;
   L_WDO.wz_setFieldValue("GroupOwn", 0, "v_CodeOwn",   CodeOwn);
   L_WDO.wz_setFieldValue("GroupOwn", 0, "v_NameOwn",   L_Str.Left((^(L_DBD.GetFieldName(OwnerName, "Name"))), Str.MaxLength(GroupE.NameOwn)));
  END;
 END {GroupOwn_OnConformToWindow};

 PUBLIC PROCEDURE EntryRecordIntoGroups();
 BEGIN
  IF L_Group.GroupTCanBeCreatedFromThisFile(DBD.FileNameToId(GE_CURFILE())) THEN
   LIKEMENU(View, "GroupOwn 1 " + GE_CURWIN() + " " + L_Str.IntStr(GE_CURZONE()));
  ELSE
   L_General.Assert(0, " ⭮襭 |'" + DBD.FileDescription(^(GE_CURFILE())) +
                       "'|  室  㯯 ᥩ ");
  END;
 END {EntryRecordIntoGroups};

BEGIN
 IF L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSE
  L_General.BadMode(MODE);
 END;
END.

