(*
%Copyright   (c) Polak IT
%Author      12.08.2010 15:29:59 POLAK\San
%Purpose      ਤ㬠 12.08.2010 15:30:24 POLAK\San
%Type        control
%Specific    SYS
%Modified    13.03.2014 16:49:57 POLAK\GAV
%Environment
*)

 MODULE Guard [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Guard, L_Str, Math, L_Msg, L_AR, L_WDO, L_bp, L_APMsg;

 PRIVATE PROCEDURE GetGuardModuleDescr(): STRING[];
  VAR
   MyModule: MODULE_SPEC;
   Result  : STRING[];
 BEGIN
  MyModule:=RTI.Get().Stack(0).Proc.Module;
  IF Math.Abs((MyModule.TimeLastModified - FOLDERENTRY.Create(MyModule.Path).TimeLastModified)) > 2*1/24/60/60 THEN
   Result:=" ५! ";
  ELSE
   Result:="";
  END;
  INC(Result, "  " + MyModule.Name + "  " + FLDTOSTR(MyModule.TimeLastModified, "D.N.y H:M:S"));
  RETURN Result;
 END {GetGuardModuleDescr};

 PRIVATE PROCEDURE UnreadMessagesCheck();
 BEGIN
  PROMPT("஢ઠ ⠭ ᮮ饭");
  TRY
   SE_ACCESSDATAMODE(AccessDataMode_SOFT);
   TRY [TRANSACTION(TRANSACTION_SLAVE)]
    CALL(ccCnct.RefreshAll(0));
   EXCEPT
   END;
   SELECT(ccCnct, Login, , L_WDO.v_dbConnection);
   WHILE OCCURE(ccCnct) DO
    NARROWSEL(ccCnct, Login);
    WHILE OCCURE(ccCnct) DO
     IF  (ccCnct.Type = ASBCONNECTION.ConnectionType_Client) |
         (ccCnct.Type = ASBCONNECTION.ConnectionType_TerminalAgent) THEN
      L_Msg.NotifyNewMessages(ccCnct.AcsObj, L_Msg.mi_Low);
      LAST(ccCnct);
     END;
    NEXT(ccCnct);
    END;
    NEXTINEXTENDEDSEL(ccCnct, Login);
   END; (* WHILE OCCURE(ccCnct) *)
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
 END {UnreadMessagesCheck};

 PRIVATE PROCEDURE SendAutoBuildSprtCrsp();
 BEGIN
  CALL(SprtCrsp.SendAutoBuildSprtCrsp());
 END {SendAutoBuildSprtCrsp};

 PRIVATE PROCEDURE ClearDeads();
 BEGIN
  CALL(bp.ClearDeads());
 END {ClearDeads};

 PRIVATE PROCEDURE ip_DoTask(VAR CheckTime: TIMESTAMP; pM: FLOAT; Task: PROC);
 BEGIN
  IF SYSTIMESTAMP() > CheckTime THEN
   CheckTime:=CheckTime + pM/60/24;
   Task();
  END;
 END {ip_DoTask};

 PRIVATE PROCEDURE MakeCongrMsgs();
 BEGIN
  PROMPT(" ᮮ饭-ࠢ");
  TRY
   SE_ACCESSDATAMODE(AccessDataMode_SOFT);
   TRY [TRANSACTION(TRANSACTION_SLAVE)]
    CALL(ccCnct.RefreshAll(0));
   EXCEPT
   END;
   SELECT(ccCnct, Login, , L_WDO.v_dbConnection);
   WHILE OCCURE(ccCnct) DO
    NARROWSEL(ccCnct, Login);
    WHILE OCCURE(ccCnct) DO
     IF  (ccCnct.Type = ASBCONNECTION.ConnectionType_Client) |
         (ccCnct.Type = ASBCONNECTION.ConnectionType_TerminalAgent) THEN
      TRY [TRANSACTION(TRANSACTION_SLAVE)]
       L_APMsg.MakeCongratulationMessages(0, ccCnct.AcsObj);
      EXCEPT
      END;
      LAST(ccCnct);
     END;
    NEXT(ccCnct);
    END;
    NEXTINEXTENDEDSEL(ccCnct, Login);
   END; (* WHILE OCCURE(ccCnct) *)
  EXCEPT
  END;
 END {MakeCongrMsgs};

 PUBLIC PROCEDURE intPlay(FirstStart: SCAL[2]);
  CONST
   pD_Launch     = 60/60/24;
   pS_Sleep      = 10;
  VAR
   ct_CongrMsgs,
   ct_RunQueue,
   ct_MessagesCheck,
   ct_SendAutoSprt,
   ct_ClearDeads,
   launchTime     : TIMESTAMP;
   fstPrompt,
   curPrompt      : PROMPTLINE;
   s              : STRING[];
 BEGIN
  fstPrompt:=PROMPTLINE.Create(GetGuardModuleDescr());
  curPrompt:=PROMPTLINE.Create(" ");
  launchTime      :=SYSTIMESTAMP() + pD_Launch;
  ct_CongrMsgs    :=SYSTIMESTAMP();
  ct_RunQueue     :=SYSTIMESTAMP();
  ct_MessagesCheck:=SYSTIMESTAMP();
  ct_SendAutoSprt :=SYSTIMESTAMP();
  ct_ClearDeads   :=SYSTIMESTAMP();
  LOOP
   TRY [MSGSUPPRESSIONMODE(MSGSUPPRESS_ALL)]
    GRANTALLRIGHTS();
    L_Guard.IamAlive();
    fstPrompt.Text:=L_DatTim.CompleteSystimeStr();
    IF (SYSTIMESTAMP() > launchTime) | L_General.TheProjectModulesWereUpdated() THEN
     EXIT;
    END;

    ip_DoTask(ct_CongrMsgs,     60*12,                       PROCREF(MakeCongrMsgs));
    ip_DoTask(ct_RunQueue,      5/60,                        PROCREF(L_bp.RunQueue));
    ip_DoTask(ct_MessagesCheck, L_Guard.MessagesCheckPeriod, PROCREF(UnreadMessagesCheck));
    ip_DoTask(ct_SendAutoSprt,  03,                          PROCREF(SendAutoBuildSprtCrsp));
    ip_DoTask(ct_ClearDeads,    30,                          PROCREF(ClearDeads));

    PROMPT("㧠 " + L_Str.IntStr(pS_Sleep) + " ᥪ㭤");
    SLEEP(pS_Sleep);
   EXCEPT
   ON Exc: Exc_Root DO
   END;
  END; (* LOOP *)
  LIKEMENU(CALL, "Guard.intPlay(0)");
 END {intPlay};

 PUBLIC PROCEDURE Play();
 BEGIN
  intPlay(1);
 END {Play};

 PUBLIC PROCEDURE wrap_SetupGuardPassword();
 BEGIN
  L_Guard.SetupGuardPassword();
 END {wrap_SetupGuardPassword};

END.