(*
%Copyright   (c) Polak IT
%Author      09.03.2005 14:27:37 POLAK\San
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    14.03.2013 18:20:11 POLAK\LDA
%Environment
*)

 MODULE iSwap;

 IMPORT L_General, L_Events, L_iSwap, L_XDoc, L_DatTim, L_Str;

 PRIVATE PROCEDURE Agent_intChangeStatus();
 BEGIN
  L_iSwap.ChangeStatus(L_iSwap.iSwapToManipulate, L_iSwap.iSwapStatus);
 END {Agent_intChangeStatus};

 PRIVATE PROCEDURE Agent_intAppendLog();
 BEGIN
  L_iSwap.AppendLog(L_iSwap.iSwapToManipulate, L_iSwap.iSwapLogToAppend);
 END {Agent_intAppendLog};

 PRIVATE PROCEDURE Agent_intPostpone();
 BEGIN
  L_iSwap.Postpone(L_iSwap.iSwapToManipulate, L_iSwap.iSwapPostponeValue);
 END {Agent_intPostpone};

 PERMANENT VAR
  v_Body,
  v_Log      : STRING[];
  v_XDocType : L_XDoc.tXDocType;
  v_XDocKind : L_XDoc.tXDocKind;
  v_XDoc     : L_XDoc.tXDoc;
  v_SrvDTS   : STRING[];

 PRIVATE PROCEDURE iSwapE_0_OnReposition();
  VAR
   srvD: DATE;
   srvT: TIME;
 BEGIN
  IF ACCESS(iSwap) THEN
   v_Body:=L_iSwap.GetBody(iSwap.iSwap);
   v_Log :=L_iSwap.GetLog (iSwap.iSwap);
   L_XDoc.DecodeXDocId(iSwap.XDocId, v_XDocType, v_XDocKind, v_XDoc);
   IF v_XDocKind = L_XDoc.EmptyXDocKind THEN
    RTI.Get().CurZone.Fields("v_XDocKind").Format:="  ";
   END;
   UnPkVARIANTDATE(iSwap.SrvDTS, srvD, srvT);
   v_SrvDTS:=L_DatTim.DateStr(srvD) + " " + L_DatTim.TimeStr(srvT);
  END;
 END {iSwapE_0_OnReposition};

 PRIVATE PROCEDURE iSwapE_0_OnZoneOpen();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("v_XDocType").Format:=L_XDoc.ref_ShortNames;
  Fields("iSwap.Sender").Format:=L_iSwap.sp_Pool;
  Fields("iSwap.Receiver").Format:=L_iSwap.sp_Pool;
  Fields("iSwap.Kind").Format:=L_iSwap.sk_Pool;
  Fields("iSwap.Status").Format:=L_iSwap.st_Pool;
 END {iSwapE_0_OnZoneOpen};

 PRIVATE PROCEDURE iSwap_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("iSwap.Status").Format:=L_iSwap.st_Pool;
 END {iSwap_1_OnZoneOpen};

 PRIVATE PROCEDURE SetStatus(_Status: L_iSwap.tStatus);
 BEGIN
  IF ACCESS(iSwap) THEN
   L_General.Assert(iSwap.Status # _Status, "饭 㦥  ⠪ ");
   L_General.Assert(iSwap.Status # L_iSwap.st_Sent, "饭 㦥 ࠢ");
   IF _Status = L_iSwap.st_Prepared THEN
    iSwap.SndDTS:=L_DatTim.GetSysVARIANTDATE(); (* ? *)
    REPLACE(iSwap);
   END;
   L_iSwap.ChangeStatus(iSwap.iSwap, _Status);
   L_iSwap.AppendLog(iSwap.iSwap,
                     L_iSwap.FormatLogEntry("⠭  " +
                                            "'" + L_Str.PoolItem(L_iSwap.st_Pool, _Status)) + "'" +
                                            " " +
                                            "(" + LOGINNAME() + ")");
  END;
 END {SetStatus};

BEGIN
 IF L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSIF MODE = 135 THEN
  Agent_intChangeStatus();
 ELSIF MODE = 136 THEN
  Agent_intAppendLog();
 ELSIF MODE = 137 THEN
  Agent_intPostpone();
 ELSIF MODE = 138 THEN
  SetStatus(L_iSwap.st_Prepared);
 ELSIF MODE = 139 THEN
  SetStatus(L_iSwap.st_Canceled);
 ELSE
  L_General.BadMode(MODE);
 END;
END.
