(*
%Copyright   (c) Polak IT
%Author      08.05.2009 15:35:10 POLAK\LDA
%Purpose     ࠢ 䨪樥 ୠ 㬥⮢
%Type        control
%Specific    AP
%Modified    23.09.2014 12:40:25 POLAK\San
%Environment
*)

 MODULE JDoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, L_XObj, L_Acnt, L_StdFrm, L_PDoc, L_Stock, L_DBD, L_XDoc, L_lsStore, P_Firm,
        Memo, L_JDoc, L_Print, L_Str, L_WDO, L_MDoc, L_XDR, L_DatTim, L_APtm, L_MathR, L_AcsPnt, Str;

 PRIVATE TYPE
  tJDocListOrigin = SCAL[7];

 PRIVATE CONST
  jdlo_CostItem  = 0;
  jdlo_Contract  = 1;
  jdlo_Man       = 2;
  jdlo_Recast    = 3;
  jdlo_Math      = 4;
  jdlo_MathByStr = 5;
  jdlo_Staff     = 6;

  jdlo_Pool = "|||⢥ |  |  |⭨";

  EI_buildAnnex = "BuildAnnex";
  WN_JDocE      = "JDocE";

 PRIVATE PERMANENT VAR
  curJDLO: tJDocListOrigin;

 PRIVATE PROCEDURE JDocList_OnEveryInteractiveReplace();
 BEGIN
  IF ~SEARCH(ccJDL, ccJDL, L_WDO.v_dbConnection, JDoc.RECORDID, JDocList.JDLNbr) THEN
   DEFAULT(ccJDL);
   ccJDL.cc    :=L_WDO.v_dbConnection;
   ccJDL.riJDoc:=JDoc.RECORDID;
   ccJDL.JDLNbr:=JDocList.JDLNbr;
   INSERT(ccJDL);
  END;
  IF ~!JDocList.XObject THEN
   L_XObj.AccessXObject(JDocList.XObject);
   ccJDL.OrgName:=L_XObj.GetXObjectOriginName();
  ELSE
   SETEMPTY(ccJDL.OrgName);
  END;
  IF ~!JDocList.XObject2 THEN
   L_XObj.AccessXObject(JDocList.XObject2);
   ccJDL.OrgName2:=L_XObj.GetXObjectOriginName();;
  ELSE
   SETEMPTY(ccJDL.OrgName2);
  END;

  IF ~!JDocList.AcCut THEN
   ccJDL.Acnt   :=L_Acnt.GetAcCutSign(JDoc.Date, JDocList.AcCut);
   ccJDL.AcCut  :=JDocList.AcCut;
   ccJDL.Apport :=JDocList.Apport;
  ELSE
   SETEMPTY(ccJDL.Acnt, ccJDL.AcCut, ccJDL.Apport);
  END;
  IF ~!JDocList.AcCut2 THEN
   ccJDL.Acnt2  :=L_Acnt.GetAcCutSign(JDoc.Date, JDocList.AcCut2);
   ccJDL.AcCut2 :=JDocList.AcCut2;
   ccJDL.Apport2:=JDocList.Apport2;
  ELSE
   SETEMPTY(ccJDL.Acnt2, ccJDL.AcCut2, ccJDL.Apport2);
  END;

  ccJDL.Sum    :=JDocList.Sum;
ccJDL.Qnt    :=JDocList.Qnt;
ccJDL.wQnt   :=JDocList.wQnt;
ccJDL.wQnt2  :=JDocList.wQnt2;
  REPLACE(ccJDL);
  IF RTI.Get().CurWindow.ParentZone.MasterCursor.TABLE.Name = "ccJDL" THEN
   SEARCH(ccJDL, ccJDL, , L_WDO.v_dbConnection, JDoc.RECORDID, JDocList.JDLNbr);
   SE_WZD_POSITION(RTI.Get().CurWindow.ParentZone.Window.Name, RTI.Get().CurWindow.ParentZone.Number, ccJDL);
  END;
 END {JDocList_OnEveryInteractiveReplace};

 PUBLIC PROCEDURE ccJDL_Renovate();
 BEGIN
  IF ACCESS(JDoc) THEN
   TRY (*[TRANSACTION(TRANSACTION_SLAVE)]*)
    TABLE.Get("ccJDL").AccessDataMode:=adm_SOFT;
    CONFORM(JDoc, JDocList);
    WHILE OCCURE(JDocList) DO
     JDocList_OnEveryInteractiveReplace();
     NEXT(JDocList);
    END; (* WHILE OCCURE(JDocList) ... *)
    SELECT(ccJDL, ccJDL, , L_WDO.v_dbConnection, JDoc.RECORDID);
    WHILE OCCURE(ccJDL) DO
     IF ~SRCINSEL(JDocList, EQ, ccJDL.JDLNbr) THEN
      REMOVE(ccJDL);
     ELSE
      NEXT(ccJDL);
     END;
    END; (* WHILE OCCURE(ccJDL) *)
   EXCEPT
   END; (* TRY *)
  END;
 END {ccJDL_Renovate};

 PRIVATE PROCEDURE JDocE_0_OnReposition();
  VAR
   FlagEdit,
   wSubstAM: SCAL[2];
 BEGIN
  L_WDO.setFieldValue("v_JDoc_Comment", L_lsStore.Get(JDoc.Comment));
  CONFORM(JDoc, JDocKind);
  FlagEdit:=JDocKind.Features = L_JDoc.jdkf_Manual;
  L_WDO.SetFieldModifiable("JDoc.Date",    FlagEdit);
  L_WDO.SetFieldModifiable("JDoc.Status",  FlagEdit);
  L_WDO.SetFieldModifiable("JDoc.SrcNbr",  FlagEdit);
  L_WDO.SetFieldModifiable("JDoc.SrcDate", FlagEdit);
  wSubstAM:=JDocKind.Features = L_JDoc.jdkf_Annex;
  L_WDO.SetFieldVisible("JDoc_SubstAM_Value", wSubstAM);
  L_WDO.SetFieldVisible("JDoc_SubstAM_Title", wSubstAM);
  ccJDL_Renovate();
 END {JDocE_0_OnReposition};

 PRIVATE PROCEDURE CheckJDocSrcDate();
 BEGIN
  IF JDoc.SrcDate < JDoc.Date THEN
   IF STDFORM(L_StdFrm.PartForm("%< ⬥ >X" +
                                    "%< {}⠭ 室  ࠢ  㬥 >B" +
                                    "%< {}믮 >DB" +
                                    "@" +
                                    "室    㬥!" +
                                    "|"+
                                    "|%##########%  %################################################%  %###########%"),
                                    "",
                                    STOP,
                                    1) = 1 THEN
    JDoc.SrcDate:=JDoc.Date;
    REPLACE(JDoc);
   END;
  END;
 END {CheckJDocSrcDate};

 PRIVATE PROCEDURE MakeUnprinted(Force: SCAL[2]);
 BEGIN
  IF Force |
     L_XDoc.XDocIsPrinted(L_XDoc.xdt_JDoc, JDoc.JDocKind, JDoc.JDoc) THEN
   INC(JDoc.CopyCnt);
   REPLACE(JDoc);
  END;
 END {MakeUnprinted};

 PRIVATE PROCEDURE intGetBaseOfAnnexJDoc(W: FORM_WINDOW): L_XDoc.tXDocId;
  VAR
   trgEnv  : ENVVAR;
   Result  : L_XDoc.tXDocId;
 BEGIN
  SETEMPTY(Result);
  IF ~!W THEN
   trgEnv:=L_WDO.fz_AccessEnvVar(W.ActiveZone, EI_buildAnnex);
   IF ~!trgEnv THEN
    Result:=trgEnv.Value;
   END;
  END;
  RETURN Result;
 END {intGetBaseOfAnnexJDoc};

 PRIVATE PROCEDURE GetBaseOfAnnexJDoc(): L_XDoc.tXDocId;
 BEGIN
  RETURN intGetBaseOfAnnexJDoc(RTI.Get().CurWindow);
 END {GetBaseOfAnnexJDoc};

 PRIVATE PROCEDURE JDoc_OnBeforeEdIns();
 BEGIN
  L_AcsPnt.PassAccessPoint(0000039);
  CONFORM(JDoc, JDocKind);
  IF JDocKind.Features = L_JDoc.jdkf_Annex THEN
   L_General.Assert(~!GetBaseOfAnnexJDoc(), "䨪 㬥⮢-ਫ 饭");
  ELSE
   L_General.Assert(JDocKind.Features # L_JDoc.jdkf_Technological, "䨪 孮᪨  ");
  END;
 END {JDoc_OnBeforeEdIns};

 PRIVATE PROCEDURE JDoc_OnBeforeInsert();
  VAR
   basXDocId: L_XDoc.tXDocId;
   srcJDoc  : LIKE(JDoc.JDoc);
 BEGIN
  JDoc_OnBeforeEdIns();
  JDoc.Ready  :=1;
  REPLACE(JDoc);
  basXDocId:=GetBaseOfAnnexJDoc();
  IF ~!basXDocId THEN
   JDoc.XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_JDoc);
   REPLACE(JDoc);
   L_XDoc.rf_coreInsert(JDoc.XDocId, basXDocId, L_XDoc.rft_Annex);
   L_JDoc.ReplicateAnnexJDoc(basXDocId);
   IF JDoc.MyFirm = P_Firm.mf_Fict THEN
    IF L_XDoc.ExtractXDocType(basXDocId) = L_XDoc.xdt_MDoc THEN
     JDoc.MyFirm:=L_MDoc.GetMDocMyFirm();
     REPLACE(JDoc);
    ELSE
     L_General.CallUs(0);
    END;
   END;
   L_XDoc.XDocJrn_Start(L_XDoc.xdt_JDoc, JDoc.JDocKind, JDoc.JDoc, L_XDoc.action_AutoBuild);
  ELSE
   srcJDoc:=L_WDO.GetInsertionSource();
   IF ~!srcJDoc THEN
    L_DBD.CopyFromSrcRecord_wExclude("JDoc", JDoc.JDocKind + "|" + srcJDoc, "Done|XDocId|CopyCnt|Status");
    REPLACE(JDoc);
    SELECT(JDocList, JDoc, , JDoc.JDocKind, srcJDoc);
    WHILE OCCURE(JDocList) DO
     SAVE(JDocList);
     JDocList.JDoc:=JDoc.JDoc;
     INSERT(JDocList);
     RESTORE(JDocList);
     NEXT(JDocList);
    END; (* WHILE OCCURE(JDocList) ... *)
   ELSE
    L_General.CallUs(JDoc.MyFirm = P_Firm.mf_Fict);
    JDoc.MyFirm:=P_Firm.DefineMyFirm();
    JDoc.Date   :=Memo.ud_cd();
    JDoc.SrcDate:=JDoc.Date;
    JDoc.DoneDTS:=L_XDoc.max_DoneDTS;
    REPLACE(JDoc);
   END;
   JDoc.Status :=L_JDoc.st_Passed;
   JDoc.XDocId :=L_XDoc.curXDocId(L_XDoc.xdt_JDoc);
   REPLACE(JDoc);
   MakeUnprinted(1);
   L_XDoc.XDocJrn_Start(L_XDoc.xdt_JDoc, JDoc.JDocKind, JDoc.JDoc, L_XDoc.action_Insert);
  END;
 END {JDoc_OnBeforeInsert};

 PRIVATE PROCEDURE JDoc_OnBeforeEdit();
 BEGIN
  PROMPT(L_JDoc.GetJDocStrNbr()+" : ⨥");
  JDoc_OnBeforeEdIns();
  MakeUnprinted(0);
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_JDoc, JDoc.JDocKind, JDoc.JDoc, L_XDoc.action_Edit);
  IF !GetBaseOfAnnexJDoc() THEN
   L_JDoc.JDoc_OnAnyModification(-1, 1, 0);
  ELSE
   L_General.CallUs(L_XDoc.GetMainXDocIdPfAnnexXDoc(JDoc.XDocId) = GetBaseOfAnnexJDoc());
  END;
 END {JDoc_OnBeforeEdit};

 PRIVATE PROCEDURE JDoc_OnBeforeDelete();
 BEGIN
  L_General.Assert(JDoc.Status = L_JDoc.st_Canceled,
                   " 㬥 饭. ᯮ '㫨஢'");
  L_General.Error("㬥 㤠  ");
 END {JDoc_OnBeforeDelete};

 PRIVATE PROCEDURE JDoc_Status_OnSuccessfulChange();
 BEGIN
  IF    GE_PVALUE() = L_JDoc.st_Canceled THEN
   L_StdFrm.Choice("  ⬥ 㫨஢ 㬥?");
  ELSIF JDoc.Status = L_JDoc.st_Canceled THEN
   L_StdFrm.Choice("  㫨஢ 㬥?");
   IF ~!L_XDoc.GetAllDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_JDoc)) THEN
    L_StdFrm.Choice(" 易 㬥");
   END;
  ELSIF JDoc.Status = L_JDoc.st_Passed THEN

  END;
 END {JDoc_Status_OnSuccessfulChange};

 PRIVATE PROCEDURE JDoc_OnAfterEdIns();
  VAR
   basXDocId: L_XDoc.tXDocId;
 BEGIN
  CheckJDocSrcDate();
  CONFORM(JDoc, JDocList);
  IF ~OCCURE(JDocList) THEN
   L_StdFrm.Choice("⮩ 㬥?");
  ELSE
   WHILE OCCURE(JDocList) DO
    JDocList.Date:=JDoc.Date;
    JDocList.DoneDTS:=JDoc.DoneDTS;
    REPLACE(JDocList);
    NEXT(JDocList);
   END; (* WHILE OCCURE(JDocList) ... *)
  END;

  JDoc.Comment:=L_lsStore.Replace(JDoc.Comment, L_WDO.getFV_String("v_JDoc_Comment"));
  REPLACE(JDoc);
  basXDocId:=GetBaseOfAnnexJDoc();
  IF !basXDocId THEN
   L_JDoc.JDoc_OnAnyModification(+1, 1, 0);
  END;
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_JDoc, JDoc.JDocKind, JDoc.JDoc);

  IF ~!basXDocId THEN
   IF    L_XDoc.ExtractXDocType(basXDocId) = L_XDoc.xdt_PDoc THEN LIKEMENU(CALL, "PDoc.SetAnnexSign()");
   ELSIF L_XDoc.ExtractXDocType(basXDocId) = L_XDoc.xdt_MDoc THEN LIKEMENU(CALL, "MDoc.SetAnnexSign()");
   ELSE
    L_General.CallUs(0);
   END;
  END; (* IF !basXDocId *)
 END {JDoc_OnAfterEdIns};

 PRIVATE PROCEDURE JDoc_OnAfterEdit();
 BEGIN
  IF (JDoc.Status = L_JDoc.st_Passed) & (GE_PVALUE(JDoc.Status) # JDoc.Status) THEN
   JDoc.DoneDTS:=L_XDoc.GetSysDTS();
   REPLACE(JDoc);
  END;
  JDoc_OnAfterEdIns();
 END {JDoc_OnAfterEdit};

 PRIVATE PROCEDURE JDoc_OnAfterInsert();
 BEGIN
  JDoc.DoneDTS:=L_XDoc.GetSysDTS();
  REPLACE(JDoc);
  JDoc_OnAfterEdIns();
 END {JDoc_OnAfterInsert};

 PRIVATE PROCEDURE extGetXbjectOriginName(trgXObject: LIKE(XObject.XObject)): STRING[];
 BEGIN
  IF SEARCH(XObject, XObject, trgXObject) THEN
   RETURN L_XObj.GetXObjectOriginName();
  ELSE
   RETURN "";
  END;
 END {extGetXbjectOriginName};

 PRIVATE PROCEDURE SetupWindowField_JDocList_Qnt();
  VAR
   Avl: SCAL[2];
 BEGIN
  Avl:=0;
  IF OCCURE(JDocList) THEN
   IF ~!JDocList.Apport THEN
    SEARCH(Apport, Apport, , JDocList.Apport);
    Avl:=Avl | Apport.CirKind # L_Acnt.ck_MoneyOnly;
   END;
   IF ~!JDocList.Apport2 THEN
    SEARCH(Apport, Apport, , JDocList.Apport2);
    Avl:=Avl | Apport.CirKind # L_Acnt.ck_MoneyOnly;
   END;
  END;
  L_WDO.SetFieldVisible("JDocList.Qnt",       Avl);
  L_WDO.SetFieldVisible("JDocList_Qnt_Title", Avl);
 END {SetupWindowField_JDocList_Qnt};

 PRIVATE PROCEDURE gfn(left: SCAL[2]; fn: STRING[]): STRING[];
 BEGIN
  RETURN L_Str.PoolItem("c|d", left) + fn;
 END {gfn};

 PRIVATE PROCEDURE SetupOField(left: SCAL[2]; wBackConv: SCAL[2]);
  VAR
   curXObject: LIKE(XObject.XObject);
   curJDLO   : tJDocListOrigin;
   curValue  : SCAL[1E7];
   curStorage: LIKE(Storage.Storage);
 BEGIN
  IF wBackConv THEN
   IF left THEN curXObject:=JDocList.XObject;
   ELSE         curXObject:=JDocList.XObject2;
   END;
   SETEMPTY(curStorage);
   IF ~!curXObject THEN
    SEARCH(XObject, XObject, , curXObject);
    curJDLO:=getXObjectJDLO();
    L_XObj.AccessOrigin();
    IF    XObject.Origin = L_XObj.o_Global   THEN SETEMPTY(curValue);
    ELSIF XObject.Origin = L_XObj.o_Man      THEN curValue:=mfMan.Man;
    ELSIF XObject.Origin = L_XObj.o_Contract THEN curValue:=Contract.Contract;
    ELSIF XObject.Origin = L_XObj.o_Math     THEN
     curValue:=mItem.Math;
     IF ~SEARCH(MyFirm, Storage, mItem.Storage) THEN
      curStorage:=mItem.Storage;
     END;
    ELSIF XObject.Origin = L_XObj.o_KeyAss   THEN curValue:=mItem.Math;
    ELSIF XObject.Origin = L_XObj.o_CostItem THEN curValue:=CostItem.CostItem;
    ELSIF XObject.Origin = L_XObj.o_Staff    THEN curValue:=Staff.TSN;
    ELSE
     L_General.CallUs(0);
    END;
   ELSE
    SETEMPTY(curJDLO, curValue);
   END;
   RTI.Get().CurZone.Fields(gfn(left, "OOrigin")).Value:=curJDLO;
   RTI.Get().CurZone.Fields(gfn(left, "O"      )).Value:=curValue;
   RTI.Get().CurZone.Fields(gfn(left, "Storage")).Value:=curStorage;
  END;
  curJDLO:=RTI.Get().CurZone.Fields(gfn(left, "OOrigin")).Value;
  IF    curJDLO = jdlo_CostItem  THEN L_WDO.CreateFormLink_Simple("CostItem", gfn(left, "O"));
  ELSIF curJDLO = jdlo_Contract  THEN L_WDO.CreateFormLink_Simple("Contract", gfn(left, "O"));
  ELSIF curJDLO = jdlo_Man       THEN L_WDO.CreateFormLink_Simple("Man",      gfn(left, "O"));
  ELSIF curJDLO = jdlo_Math      THEN L_WDO.CreateFormLink_Simple("Math",     gfn(left, "O"));
  ELSIF curJDLO = jdlo_MathByStr THEN
   L_WDO.CreateFormLink_Simple("Math",    gfn(left, "O"));
   L_WDO.CreateFormLink_Simple("Storage", gfn(left, "Storage"));
  ELSIF curJDLO = jdlo_Staff     THEN L_WDO.CreateFormLink_Simple("Staff",    gfn(left, "O"));
  END;
  RTI.Get().CurZone.Fields(gfn(left, "Storage"     )).Visible:=curJDLO = jdlo_MathByStr;
  RTI.Get().CurZone.Fields(gfn(left, "StorageTitle")).Visible:=curJDLO = jdlo_MathByStr;
  RTI.Get().CurZone.Fields(gfn(left, "StorageName" )).Visible:=curJDLO = jdlo_MathByStr;
  RTI.Get().CurZone.Fields(gfn(left, "O"           )).Visible:=curJDLO # jdlo_Recast;
 END {SetupOField};

 PRIVATE PROCEDURE JDocEE_0_OnReposition();
 BEGIN
  RTI.Get().CurZone.Fields(gfn(1, "ObjName")).Value:=extGetXbjectOriginName(JDocList.XObject);
  RTI.Get().CurZone.Fields(gfn(0, "ObjName")).Value:=extGetXbjectOriginName(JDocList.XObject2);
  SetupWindowField_JDocList_Qnt();
  SetupOField(1, 1);
  SetupOField(0, 1);
 END {JDocEE_0_OnReposition};

 PRIVATE PROCEDURE getXObjectJDLO(): tJDocListOrigin;
 BEGIN
  IF    XObject.Origin = L_XObj.o_CostItem THEN RETURN jdlo_CostItem;
  ELSIF XObject.Origin = L_XObj.o_Contract THEN RETURN jdlo_Contract;
  ELSIF XObject.Origin = L_XObj.o_Man      THEN RETURN jdlo_Man;
  ELSIF XObject.Origin = L_XObj.o_Global   THEN RETURN jdlo_Recast;
  ELSIF XObject.Origin = L_XObj.o_KeyAss   THEN RETURN jdlo_Math;
  ELSIF XObject.Origin = L_XObj.o_Math     THEN
   L_XObj.AccessOrigin();
   IF SEARCH(MyFirm, Storage, mItem.Storage) THEN
    RETURN jdlo_Math;
   ELSE
    RETURN jdlo_MathByStr;
   END;
  ELSIF XObject.Origin = L_XObj.o_Staff    THEN RETURN jdlo_Staff;
  ELSE
   L_General.CallUs(0);
  END;
 END {getXObjectJDLO};

 PRIVATE PROCEDURE JDocList_OnBeforeDelete();
 BEGIN
  SETSEL(ccJDL, ccJDL, L_WDO.v_dbConnection, JDoc.RECORDID);
  IF SRCINSEL(ccJDL, EQ, JDocList.JDLNbr) THEN
   REMOVE(ccJDL);
  END;
 END {JDocList_OnBeforeDelete};

 PRIVATE PROCEDURE JDocList_OnBeforeEdit();
 BEGIN
 END {JDocList_OnBeforeEdit};

 PRIVATE PROCEDURE JDocList_OnBeforeInsert();
 BEGIN
  SETZERO(JDocList.wQnt, JDocList.wQnt2);
  JDocList.Apport :=L_Acnt.E_Apport_MoneyDebit(SYSDATE());
  JDocList.Apport2:=L_Acnt.E_Apport_MoneyCredit(SYSDATE());
  REPLACE(JDocList);
  JDocList_OnEveryInteractiveReplace();
 END {JDocList_OnBeforeInsert};

 PRIVATE PROCEDURE CheckAcCutAccordance(trgAcCut: LIKE(AcCut.AcCut));
 BEGIN
  IF ~!trgAcCut THEN
   ACCESS(JDoc);
   SEARCH(AcCut, AcCut, , trgAcCut);
   L_General.Assert(L_DatTim.IsActive(JDoc.Date, AcCut.Begin, AcCut.Till),
                    " ࠧ१     㬥 " + L_DatTim.DateStr(JDoc.Date));
  END;
 END {CheckAcCutAccordance};

 PRIVATE PROCEDURE JDocList_AcCut_OnSuccessfulChange();
 BEGIN
  CheckAcCutAccordance(JDocList.AcCut);
  JDocList_OnEveryInteractiveReplace();
 END {JDocList_AcCut_OnSuccessfulChange};

 PRIVATE PROCEDURE JDocList_AcCut2_OnSuccessfulChange();
 BEGIN
  CheckAcCutAccordance(JDocList.AcCut2);
  JDocList_OnEveryInteractiveReplace();
 END {JDocList_AcCut2_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckApportAccordance(reqCirType: LIKE(Apport.CirType); _Apport: LIKE(Apport.Apport));
 BEGIN
  ACCESS(JDoc);
  SEARCH(Apport, Apport, , _Apport);
  L_General.Assert(L_DatTim.IsActive(JDoc.Date, Apport.Begin, Apport.Till),
                   "ᯮ     㬥 " + L_DatTim.DateStr(JDoc.Date));
  L_General.Assert(Apport.CirType = reqCirType,
                   "  ᯮ樨   '" + L_Str.PoolItem("।|", reqCirType) + "'");
 END {CheckApportAccordance};

 PRIVATE PROCEDURE JDocList_Apport_OnSuccessfulChange();
 BEGIN
  CheckApportAccordance(L_Acnt.ct_Debit, JDocList.Apport);
  SetupWindowField_JDocList_Qnt();
  SEARCH(Apport, Apport, , JDocList.Apport);
  JDocList.wQnt:=Apport.CirKind # L_Acnt.ck_MoneyOnly;
  REPLACE(JDocList);
  JDocList_OnEveryInteractiveReplace();
 END {JDocList_Apport_OnSuccessfulChange};

 PRIVATE PROCEDURE JDocList_Apport2_OnSuccessfulChange();
 BEGIN
  CheckApportAccordance(L_Acnt.ct_Credit, JDocList.Apport2);
  SetupWindowField_JDocList_Qnt();
  SEARCH(Apport, Apport, , JDocList.Apport2);
  JDocList.wQnt2:=Apport.CirKind # L_Acnt.ck_MoneyOnly;
  REPLACE(JDocList);
  JDocList_OnEveryInteractiveReplace();
 END {JDocList_Apport2_OnSuccessfulChange};

 PRIVATE PROCEDURE JDocList_Sum_OnSuccessfulChange();
 BEGIN
  JDocList_OnEveryInteractiveReplace();
 END {JDocList_Sum_OnSuccessfulChange};

 PRIVATE PROCEDURE O_OnSuccessfulChange(left: SCAL[2]);
  VAR
   curXObject: LIKE(XObject.XObject);
   jdlOrigin : tJDocListOrigin;
   jdlValue  : SCAL[1E9];
   jdlStorage: LIKE(Storage.Storage);
 BEGIN
  jdlOrigin :=RTI.Get().CurZone.Fields(gfn(left, "OOrigin")).Value;
  jdlValue  :=RTI.Get().CurZone.Fields(gfn(left, "O"      )).Value;
  jdlStorage:=RTI.Get().CurZone.Fields(gfn(left, "Storage")).Value;
  IF (~!jdlValue & ((jdlOrigin # jdlo_MathByStr) | ~!jdlStorage)) | (jdlOrigin = jdlo_Recast) THEN
   IF jdlOrigin = jdlo_Recast   THEN
    L_XObj.AccessXObject(L_XObj.GetRecastXObject(JDoc.MyFirm));
   ELSE
    IF    jdlOrigin = jdlo_Contract THEN
     SEARCH(Contract, Contract, , jdlValue);
     IF ~Contract.Leaf THEN
      L_StdFrm.WrongDB(" ᫥ ᯮ짮 㯯 ");
     END;
    ELSIF jdlOrigin = jdlo_CostItem THEN
     SEARCH(CostItem, CostItem, , jdlValue);
     IF ~CostItem.Leaf THEN
      L_StdFrm.WrongDB(" ᫥ ᯮ짮 㯯 ");
     END;
    ELSIF jdlOrigin = jdlo_Man      THEN
     IF ~SEARCH(mfMan, Man, jdlValue, JDoc.MyFirm) THEN
      L_StdFrm.WrongDB("  " + jdlValue + "  楢    "+JDoc.MyFirm);
     END;
    ELSIF jdlOrigin = jdlo_Math THEN
     L_Stock.Obtain_mItem(jdlValue, L_Stock.Obtain_MyFirmStorage(JDoc.MyFirm, JDoc.Date));
    ELSIF jdlOrigin = jdlo_MathByStr THEN
     IF ~SEARCH(mItem, Math, jdlValue, jdlStorage) THEN
      L_StdFrm.Choice(" ⠭      뫮. 㦭?");
      L_Stock.Obtain_mItem(jdlValue, jdlStorage);
     END;
    ELSIF jdlOrigin = jdlo_Staff THEN
     SEARCH(Staff, TSN, , jdlValue);
    END;
    SEARCH(XObject, XObject, , ^(TABLE.Get(L_XObj.GetOriginFileName(convJDLO2Origin(jdlOrigin))).Fields("XObject").ObtainName()));
   END;
   IF XObject.MyFirm # JDoc.MyFirm THEN
    L_StdFrm.WrongDB(" ꥪ  ᮮ⢥  ୠ쭮 㬥");
   END;
   curXObject:=XObject.XObject;
  ELSE
   SETEMPTY(curXObject);
  END;
  IF left THEN
   JDocList.XObject:=curXObject;
  ELSE
   JDocList.XObject2:=curXObject;
  END;
  REPLACE(JDocList);
  RTI.Get().CurZone.Fields(gfn(left, "ObjName")).Value:=extGetXbjectOriginName(curXObject);
  JDocList_OnEveryInteractiveReplace();
 END {O_OnSuccessfulChange};

 PRIVATE PROCEDURE JDocList_dOOrigin_OnSuccessfulChange();
 BEGIN
  SETEMPTY(RTI.Get().CurZone.Fields("dO").Value);
  O_OnSuccessfulChange(1);
  SetupOField(1, 0);
 END {JDocList_dOOrigin_OnSuccessfulChange};

 PRIVATE PROCEDURE JDocList_dO_OnSuccessfulChange();
 BEGIN
  O_OnSuccessfulChange(1);
 END {JDocList_dO_OnSuccessfulChange};

 PRIVATE PROCEDURE JDocList_dStorage_OnSuccessfulChange();
 BEGIN
  O_OnSuccessfulChange(1);
 END {JDocList_dStorage_OnSuccessfulChange};

 PRIVATE PROCEDURE JDocList_cOOrigin_OnSuccessfulChange();
 BEGIN
  SETEMPTY(RTI.Get().CurZone.Fields("cO").Value);
  O_OnSuccessfulChange(0);
  SetupOField(0, 0);
 END {JDocList_cOOrigin_OnSuccessfulChange};

 PRIVATE PROCEDURE JDocList_cO_OnSuccessfulChange();
 BEGIN
  O_OnSuccessfulChange(0);
 END {JDocList_cO_OnSuccessfulChange};

 PRIVATE PROCEDURE JDocList_cStorage_OnSuccessfulChange();
 BEGIN
  O_OnSuccessfulChange(0);
 END {JDocList_cStorage_OnSuccessfulChange};

 PRIVATE PROCEDURE JDocEE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "dObjName").LineBreakEnable:=1;
  L_WDO.iField       (0, "cObjName").LineBreakEnable:=1;
  L_WDO.iField       (0, "JDocList.Sum").First:=1;
  L_WDO.iScsChange   (0, ["JDocList.Apport", "JDocList.Sum", "JDocList.Apport2", "JDocList.AcCut2", "JDocList.AcCut",
                          "dOOrigin", "cOOrigin", "dO", "cO", "dStorage", "cStorage"]);
  L_WDO.iUnmodifiable(0, ["dObjName", "cObjName", "JDocList.JDLNbr"]);
  L_WDO.iMayBeEmpty  (0, ["dOOrigin", "cOOrigin", "cO", "dO", "dStorage", "cStorage"]);
  L_WDO.iField       (0, "dOOrigin").Format:=jdlo_Pool;
  L_WDO.iField       (0, "cOOrigin").Format:=jdlo_Pool;
  L_WDO.iProgs       (0, "JDoc");
 END {JDocEE_OnInitializeWindow};

 PRIVATE PROCEDURE JDocEE_OnConformToWindow();
 BEGIN
  IF RTI.Get().CurZone.MasterCursor.TABLE.Name = "ccJDL" THEN
   L_General.CallUs(ACCESS(JDoc));
   SELECT(JDocList, JDoc, , JDoc.JDocKind, JDoc.JDoc);
   IF ACCESS(ccJDL) THEN
    L_General.CallUs(SRCINSEL(JDocList, EQ, ccJDL.JDLNbr));
   END;
   SE_WWD_CURSOR(RTI.Get().ConformTargetWindow.Name, JDocList);
  END;
 END {JDocEE_OnConformToWindow};

 PRIVATE PROCEDURE CheckSideAccordance(trgXObject: LIKE(XObject.XObject); trgAcCut: LIKE(AcCut.AcCut));
  VAR
   dflAcCut: LIKE(AcCut.AcCut);
 BEGIN
  IF ~!trgAcCut THEN
   IF ~!trgXObject & SEARCH(XObject, XObject, trgXObject) THEN
    IF XObject.Origin = L_XObj.o_Contract THEN
     IF L_XObj.SoftAccessOrigin() THEN
      dflAcCut:=L_Acnt.GetSpecificAcCutForContract(Contract.Contract, L_Acnt.acp_Contract_Netto);
      IF trgAcCut # dflAcCut THEN
       L_StdFrm.Choice("१  ⮢   " + Contract.Contract
                        + "  (" + dflAcCut + "), 祬 㪠 (" + trgAcCut + ")"
                        + L_StdFrm.HR()
                        + ",  訡");
      END;
     END;
    END;
   END;
  END;
 END {CheckSideAccordance};

 PRIVATE PROCEDURE JDocList_OnAfterEdIns();
 BEGIN
  CheckSideAccordance(JDocList.XObject , JDocList.AcCut );
  CheckSideAccordance(JDocList.XObject2, JDocList.AcCut2);
 END {JDocList_OnAfterEdIns};

 PRIVATE PROCEDURE JDocList_OnAfterEdit();
 BEGIN
  JDocList_OnAfterEdIns();
 END {JDocList_OnAfterEdit};

 PRIVATE PROCEDURE JDocList_OnAfterInsert();
 BEGIN
  JDocList_OnAfterEdIns();
 END {JDocList_OnAfterInsert};

 PRIVATE PROCEDURE convJDLO2Origin(_jdlo: tJDocListOrigin): L_XObj.tOrigin;
 BEGIN
  IF    _jdlo = jdlo_Recast     THEN RETURN L_XObj.o_Global;
  ELSIF _jdlo = jdlo_Contract   THEN RETURN L_XObj.o_Contract;
  ELSIF _jdlo = jdlo_Man        THEN RETURN L_XObj.o_Man;
  ELSIF _jdlo = jdlo_CostItem   THEN RETURN L_XObj.o_CostItem;
  ELSIF _jdlo = jdlo_Math       THEN RETURN L_XObj.o_Math;
  ELSIF _jdlo = jdlo_MathByStr  THEN RETURN L_XObj.o_Math;
  ELSIF _jdlo = jdlo_Staff      THEN RETURN L_XObj.o_Staff;
  ELSE
   L_General.CallUs(0);
  END;
 END {convJDLO2Origin};

 PRIVATE PROCEDURE JDocE_0_OnZoneOpen();
  VAR
   basXDocId,
   AnnexXDocId: L_XDoc.tXDocId;
 BEGIN
  basXDocId:=GetBaseOfAnnexJDoc();
  IF ~!basXDocId THEN
   AnnexXDocId:=L_XDoc.GetAnnexXDocId(basXDocId);
   IF ~!AnnexXDocId THEN
    L_XDoc.PositionOnXDoc(AnnexXDocId);
    SE_WZD_CURSOR(WN_JDocE, 0, JDoc);
    CONFORM(JDoc, JDocKind);
   END;
  END;
 END {JDocE_0_OnZoneOpen};

 PRIVATE PROCEDURE JDocE_OnConformToWindow();
  VAR
   basXDocId,
   AnnexXDocId: L_XDoc.tXDocId;
 BEGIN
  basXDocId  :=intGetBaseOfAnnexJDoc(RTI.Get().TrgWindow);
  AnnexXDocId:=L_XDoc.GetAnnexXDocId(basXDocId);
  IF ~!AnnexXDocId THEN
   L_XDoc.PositionOnXDoc(AnnexXDocId);
  ELSE
   IF    L_XDoc.ExtractXDocType(basXDocId) = L_XDoc.xdt_PDoc THEN
    SELECT(JDoc, JDoc, , L_JDoc.jd_PDoc);
   ELSIF L_XDoc.ExtractXDocType(basXDocId) = L_XDoc.xdt_MDoc THEN
    SELECT(JDoc, JDoc, , L_JDoc.jd_MDoc);
   ELSE
    L_General.CallUs(0);
   END;
  END;
  SE_WWD_CURSOR(WN_JDocE, JDoc);
 END {JDocE_OnConformToWindow};

 PRIVATE PROCEDURE Print(Stream, Preview: SCAL[2]; Template: STRING[]);
  VAR
   NeedSurvey: SCAL[2];
   _Status   : LIKE(JDoc.Status);
   Copies    : NUMERIC[0];
 BEGIN
  NeedSurvey:=1;
  TRY
   IF    JDoc.Status = L_JDoc.st_Canceled THEN
    IF ~Preview THEN
     L_Print.PrintCancelledXDoc(L_XDoc.curXDocId(L_XDoc.xdt_JDoc));
    END;
   ELSE
    CONFORM(JDoc, JDocKind);
    L_General.Assert((JDoc.Status # L_JDoc.st_Prepared),
                     " ⮢ " + JDocKind.Sign + " 饭");
    IF ~!Template THEN

     NeedSurvey:=0;
    ELSE
     Copies:=1;
     WHILE Copies > 0 DO

      DEC(Copies);
     END; (* WHILE Copies ... *)
    END;
    L_General.RaiseLockReleaseException();
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
   IF NeedSurvey & Preview THEN
    L_General.SurveyLastReport();
   END;
  END; (* TRY *)
 END {Print};

 PRIVATE PROCEDURE RePrint(Stream: SCAL[2]);
 BEGIN
  MakeUnprinted(0);
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_JDoc, JDoc.JDocKind, JDoc.JDoc, L_XDoc.action_Reprint);
  IF ~Stream THEN
   LIKEMENU(CALL, "JDoc.SinglePrint()");
  END;
 END {RePrint};

 PRIVATE PROCEDURE go2XDocAnnex(xdt: L_XDoc.tXDocType; wModify: SCAL[2]);
  VAR
   AnnexXDocId: L_XDoc.tXDocId;
   basXDocId  : L_XDoc.tXDocId;
 BEGIN
  basXDocId:=L_XDoc.curXDocId(xdt);
  L_XDoc.PositionOnXDoc(basXDocId);
  AnnexXDocId:=L_XDoc.GetAnnexXDocId(basXDocId);
  IF wModify THEN
   IF ~!AnnexXDocId THEN
    L_XDoc.PositionOnXDoc(AnnexXDocId);
    LIKEMENU(Edit, WN_JDocE + " 0 " + L_WDO.getActiveForm().Name + " 0 " + EI_buildAnnex + "=" + basXDocId, SC, "JDoc.EdIns_AnnexJDocE_0", View, ".#1");
   ELSE
    LIKEMENU(Ins,  WN_JDocE + " 0 " + L_WDO.getActiveForm().Name + " 0 " + EI_buildAnnex + "=" + basXDocId, SC, "JDoc.EdIns_AnnexJDocE_0", View, ".#1");
   END;
  ELSE
   IF ~!AnnexXDocId THEN
    LIKEMENU(ShowWin, WN_JDocE + " 1 " + L_WDO.getActiveForm().Name + " 0 " + EI_buildAnnex + "=" + basXDocId);
   ELSE
    L_StdFrm.Inform("⥫ ஢ ");
   END;
  END;
 END {go2XDocAnnex};

 PRIVATE PROCEDURE BuildXDocAnnex(xdt: L_XDoc.tXDocType);
 BEGIN
  go2XDocAnnex(xdt, 1);
 END {BuildXDocAnnex};

 PUBLIC PROCEDURE BuildPDocAnnex();
 BEGIN
  BuildXDocAnnex(L_XDoc.xdt_PDoc);
 END {BuildPDocAnnex};

 PUBLIC PROCEDURE BuildMDocAnnex();
 BEGIN
  BuildXDocAnnex(L_XDoc.xdt_MDoc);
 END {BuildMDocAnnex};

 PRIVATE PROCEDURE ShowXDocAnnex(xdt: L_XDoc.tXDocType);
 BEGIN
  L_General.CallUs(ACCESS(^(L_XDoc.Ref_FileName(xdt))));
  go2XDocAnnex(xdt, 0);
 END {ShowXDocAnnex};

 PUBLIC PROCEDURE ShowPDocAnnex();
 BEGIN
  ShowXDocAnnex(L_XDoc.xdt_PDoc);
 END {ShowPDocAnnex};

 PUBLIC PROCEDURE ShowMDocAnnex();
 BEGIN
  ShowXDocAnnex(L_XDoc.xdt_MDoc);
 END {ShowMDocAnnex};

 PRIVATE PROCEDURE CheckCurPer(_s: NUMERIC[0]; Stream: SCAL[2]);
 BEGIN
  Memo.gl_SetCurDate(JDoc.Date);
  IF (_s # 0) & (JDoc.Status = L_JDoc.st_Passed) THEN
   IF ~Stream THEN
    L_APtm.ANYSystem_CheckClcPer(L_APtm.system_Payments);
   END;
  END; (* IF _s # 0 *)
 END {CheckCurPer};

 PRIVATE PROCEDURE GetProceedName(_s: NUMERIC[0]): STRING[];
 BEGIN
  IF    _s = +1 THEN RETURN "ࠡ⪠";
  ELSIF _s = -1 THEN RETURN "⪠";
  ELSIF _s =  0 THEN RETURN "⮪";
  END;
 END {GetProceedName};

 PRIVATE PROCEDURE Proceed(_Done: LIKE(JDoc.Done); _s: NUMERIC[0]; Stream: SCAL[2]);
  VAR
   oPrompt: PROMPT_LINE;
 BEGIN
  L_JDoc.AccessJDoc();
  CheckCurPer(_s, Stream);
  oPrompt:=PROMPT_LINE.Create(L_JDoc.GetJDocStrNbr()+" : " + GetProceedName(_s));
  IF (JDoc.JDocKind # L_JDoc.jd_Dfrls) & (JDoc.JDocKind # L_JDoc.jd_Distr) THEN
   L_General.SetConcurrentMode();
  END;
  IF (_s # 0) & _Done THEN
   IF JDoc.Date > L_DatTim.MonthEnd(SYSDATE()) THEN
    IF ~Stream THEN
     L_StdFrm.Inform("ਮ 㬥   㯨. 㬥 ⠭ ࠡ⠭");
    END;
    RETURN;
   END;
  END;

  IF (_s=0) | (JDoc.Done # _Done) THEN
   L_General.Assert(JDoc.XDocId = L_JDoc.GetJDocOnBehalfOfXDocId(),
                    "믮 ᨬ 樨 '" + GetProceedName(_s) + "'  㬥⮢-ਫ 饭");
   IF (JDoc.Status = L_JDoc.st_Passed) THEN
    IF L_Acnt.E_DoXDocApr(L_DatTim.Per(JDoc.Date), L_XObj.src_JDoc, L_XDoc.curXDocId(L_XDoc.xdt_JDoc)) THEN
     IF    (_s < 0) THEN
      L_Acnt.RollbackXDoc(JDoc.XDocId);
     ELSIF (_s > 0) THEN
      L_JDoc.JDoc_Proceed(_s);
      L_Acnt.RenXDocApr(JDoc.XDocId);
     ELSIF (_s = 0) THEN
      L_General.Assert(JDoc.Done, " ।⥫쭮 ࠡ  ");
      L_XDR.XDocAprToEntryList(L_XDoc.xdt_JDoc);
     END;
    ELSE
     L_JDoc.JDoc_Proceed(_s);
    END;
   ELSE
    L_Acnt.RenXDocApr(JDoc.XDocId);
   END;
   IF _s # 0 THEN
    JDoc.Done:=_Done;
    IF _s = +1 THEN
     IF (JDoc.DoneDTS = L_XDoc.max_DoneDTS) | !JDoc.DoneDTS(*0053330*) THEN
      JDoc.DoneDTS:=L_XDoc.GetSysDTS();
     END;
    END;
    REPLACE(JDoc);
   END;
  END;
 END {Proceed};

 PUBLIC PROCEDURE BuildAddDoc();
 BEGIN
  L_General.Error(" ।ᬮ७ 稥 ⥫쭮 㬥");
 END {BuildAddDoc};

 PUBLIC PROCEDURE RemAddDoc();
 BEGIN
  L_General.Error(" ।ᬮ७ 稥 ⥫쭮 㬥");
 END {RemAddDoc};

 PUBLIC PROCEDURE MakeProtocol();
 BEGIN
  L_JDoc.AccessJDoc();
  L_XDR.sl_Init("奬 権");
  L_XDR.InitEntryList();
  L_XDR.PrepareEntryList(L_XDoc.xdt_JDoc, EMPTYOF(DATE), 0);
  L_XDR.OutEntryList(L_XDoc.xdt_JDoc);
  L_XDR.DeInitEntryList();
  L_XDR.sl_Done();
 END {MakeProtocol};

 PUBLIC PROCEDURE StreamMakeDone();
 BEGIN
  Proceed(1, +1, 1);
 END {StreamMakeDone};

 PUBLIC PROCEDURE StreamMakeUnDone();
 BEGIN
  Proceed(0, -1, 1);
 END {StreamMakeUnDone};

 PUBLIC PROCEDURE SingleMakeDone();
 BEGIN
  Proceed(1, +1, 0);
 END {SingleMakeDone};

 PUBLIC PROCEDURE SingleMakeUnDone();
 BEGIN
  Proceed(0, -1, 0);
 END {SingleMakeUnDone};

 PUBLIC PROCEDURE InternalMakeProtocol();
 BEGIN
  Proceed(1, 0, 0);
 END {InternalMakeProtocol};

 PUBLIC PROCEDURE SinglePrint();
 BEGIN
  L_General.Error("  騩  ");
  Print(0, 0, "");
 END {SinglePrint};

 PUBLIC PROCEDURE SinglePrePrint();
 BEGIN
  L_General.Error("  騩  ");
  Print(0, 1, "");
 END {SinglePrePrint};

 PUBLIC PROCEDURE SingleRePrint();
 BEGIN
  L_General.Error("  騩  ");
  RePrint(0);
 END {SingleRePrint};

 PRIVATE PROCEDURE JDoc_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="JDoc";
  L_WDO.iZone        (1).Narrowing:="JDoc.JDocKind=JDocKind.JDocKind";
  L_WDO.iSubwindow   (1, "JDocE");
  L_WDO.iField       (1, "JDoc.JDoc").ReverseSorting:=1;
  L_WDO.iZone        (2).ViewOnly:=1;
 END {JDoc_OnInitializeWindow};

 PUBLIC PROCEDURE MakeCopy();
 BEGIN
  ACCESS(JDoc);
  L_WDO.LaunchInsertBySource(JDoc.JDoc, " trgPrc=Copy");
 END {MakeCopy};

 PRIVATE PROCEDURE XDocApr_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "XDocAprE");
 END {XDocApr_OnInitializeWindow};

 PUBLIC PROCEDURE ccXDA_Renovate(trgXDocId: L_XDoc.tXDocId);
  VAR
   SwapStr: STRING[];
 BEGIN
  IF ~!trgXDocId THEN
   APP.Get().NewPrompt("⮢ ᯨ᪠ ஢  㬥 " + trgXDocId);
   TRY
    TABLE.Get("ccXDA").AccessDataMode:=adm_SOFT; (* ⮡   adm_BIZZARE *)
    SETSEL(ccXDA, dAcnt, APP.Get().MyConnection.Number, trgXDocId);
    REMSEL(ccXDA);
    SETSEL(XDocApr, Nbr, trgXDocId);
    FOR_EACH XDocApr DO
     PROMPT(XDocApr.Nbr);
     ccXDA.cc    :=APP.Get().MyConnection.Number;
     ccXDA.XDocId:=trgXDocId;
     ccXDA.Nbr   :=XDocApr.Nbr;
     ccXDA.XDat  :=XDocApr.XDat;
     ccXDA.WFDate:=XDocApr.WFDate;
     IF ~!XDocApr.XObject THEN
      L_XObj.AccessXObject(XDocApr.XObject);
      ccXDA.dOrgName:=L_XObj.GetXObjectOriginName();
     ELSE
      SETEMPTY(ccXDA.dOrgName);
     END;
     IF ~!XDocApr.XObject2 THEN
      L_XObj.AccessXObject(XDocApr.XObject2);
      ccXDA.cOrgName:=L_XObj.GetXObjectOriginName();;
     ELSE
      SETEMPTY(ccXDA.cOrgName);
     END;
     IF ~!XDocApr.AcCut THEN
      ccXDA.dAcnt :=L_Acnt.GetAcCutSign(XDocApr.XDat, XDocApr.AcCut);
      ccXDA.dAcCut:=XDocApr.AcCut;
     ELSE
      SETEMPTY(ccXDA.dAcnt, ccXDA.dAcCut);
     END;
     IF ~!XDocApr.AcCut2 THEN
      ccXDA.cAcnt :=L_Acnt.GetAcCutSign(XDocApr.XDat, XDocApr.AcCut2);
      ccXDA.cAcCut:=XDocApr.AcCut2;
     ELSE
      SETEMPTY(ccXDA.cAcnt, ccXDA.cAcCut);
     END;
     ccXDA.Sum    :=XDocApr.Sum;
     ccXDA.Qnt    :=XDocApr.Qnt * (XDocApr.wQnt > 0);
     SEARCH(Apport, Apport, , XDocApr.Apport);
     IF Apport.CirType # L_Acnt.ct_Debit THEN
      SwapStr:=ccXDA.cOrgName; ccXDA.cOrgName:=ccXDA.dOrgName; ccXDA.dOrgName:=SwapStr;
      SwapStr:=ccXDA.cAcnt   ; ccXDA.cAcnt   :=ccXDA.dAcnt   ; ccXDA.dAcnt   :=SwapStr;
      SwapStr:=ccXDA.cAcCut  ; ccXDA.cAcCut  :=ccXDA.dAcCut  ; ccXDA.dAcCut  :=SwapStr;
     END;
     INSERT(ccXDA);
    END; (* FOR_EACH XDocApr *)
   EXCEPT
   END; (* TRY *)
  END;
 END {ccXDA_Renovate};

 PRIVATE PROCEDURE XDocApr_OnConformToWindow();
  VAR
   curXDocId: L_XDoc.tXDocId;
 BEGIN
  ACCESS((RTI.Get().CurZone.MasterTable.Name));
  curXDocId:=L_XDoc.GetCurrentXDocId();
  ccXDA_Renovate(curXDocId);
  SELECT(ccXDA, dAcnt, , APP.Get().MyConnection.Number, curXDocId);
  SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, ccXDA);
  RTI.Get().TrgWindow.Zones(0).Fields("v_XDocName").Value:=L_XDoc.extXDocStr(curXDocId, L_XDoc.xdast_wDate);
 END {XDocApr_OnConformToWindow};

 PRIVATE PROCEDURE XDocAprE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnReposition]);
  L_WDO.iZone        (0).ViewOnly:=1;
  L_WDO.iField       (0, "dObjName").LineBreakEnable:=1;
  L_WDO.iField       (0, "cObjName").LineBreakEnable:=1;
  L_WDO.iField       (0, "Apport.CirType").Format:="।|";
  L_WDO.iField       (0, "Apport2.CirType").Format:="।|";
  L_WDO.iProgs       (0, "JDoc");
 END {XDocAprE_OnInitializeWindow};

 PRIVATE PROCEDURE XDocAprE_OnConformToWindow();
 BEGIN
  ACCESS((RTI.Get().CurZone.MasterTable.Name));
  SEARCH(XDocApr, Nbr, , ccXDA.XDocId, ccXDA.Nbr);
  SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, XDocApr);
 END {XDocAprE_OnConformToWindow};

 PRIVATE PROCEDURE XDocAprE_0_OnReposition();
 BEGIN
  RTI.Get().CurZone.Fields(gfn(1, "ObjName")).Value:=extGetXbjectOriginName(XDocApr.XObject);
  RTI.Get().CurZone.Fields(gfn(0, "ObjName")).Value:=extGetXbjectOriginName(XDocApr.XObject2);
 END {XDocAprE_0_OnReposition};

 PUBLIC PROCEDURE ViewXDocApr();
 BEGIN
  L_XDoc.LaunchViewingServiceFile("XDocApr");
 END {ViewXDocApr};

 PRIVATE PROCEDURE ACalc_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="JDoc";
  L_WDO.iZone      (1).ViewOnly:=1;
  L_WDO.iField     (1, "ACalc.Done").Format:="-|";
 END {ACalc_OnInitializeWindow};

 PRIVATE PROCEDURE ACalc_OnConformToWindow();
  VAR
   MasterTable: STRING[];
   trg_fi     : LIKE(ACalc.fiOwn);
   trg_ri     : LIKE(ACalc.riOwn);
 BEGIN
  MasterTable:=RTI.Get().CurZone.MasterTable.Name;
  ACCESS((MasterTable));
  trg_fi:=TABLE.Get(MasterTable).Id;
  trg_ri:=^(TABLE.Get(MasterTable).Fields("RECORDID").ObtainName());
  GE_WZD_CURSOR(RTI.Get().TrgWindow.Name, 1, ACalc);
  IF OCCURE(ACalc) & (ACalc.fiOwn = trg_fi) & (ACalc.riOwn = trg_ri) THEN
   CHANGESEL(ACalc, Own, , trg_fi, trg_ri);
  ELSE
   SELECT(ACalc, Own, , trg_fi, trg_ri);
  END;
  SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, ACalc);
  SE_WZD_CURSOR(RTI.Get().TrgWindow.Name, 1, ACalc);
  RTI.Get().TrgWindow.Zones(0).Fields("Owner").Value:=L_XDoc.Get_iri_Description(trg_fi, trg_ri);
 END {ACalc_OnConformToWindow};

BEGIN
 L_Events.ExecuteHandler();
END.
