(*
%Copyright   (c) Polak Computer System
%Author      13.03.2002 10:57:21 BOR
%Purpose
%Type        control
%Specific    SYS
%Modified    19.06.2013 17:33:39 POLAK\Bor
%Environment
*)

 MODULE KAGroup [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, L_MathR, L_Str, L_EC, L_WDO, L_StdFrm, L_DBD,
        Math, E_Stock, L_Env;

 PRIVATE PROCEDURE SupportBeginTill();
  VAR
   curTill: DATE;
 BEGIN
  L_General.Assert(SELECT(KAGLog, KAGroup, KAGroup.KAGroup),
                   "㯯 த       ப ਨ");
  KAGroup.Begin:=KAGLog.Date;
  REPLACE(KAGroup);
  LAST(KAGLog);
  L_General.Assert(KAGLog.Date < KAGroup.Till,
                   "|ਮ ਬ 㯯  稢" +
                   "|  ᫥ ப ਨ");
  curTill:=KAGroup.Till;
  REPEAT
   KAGLog.Till:=curTill;
   REPLACE(KAGLog);
   curTill:=KAGLog.Date;
  UNTIL ~PREV(KAGLog);
 END {SupportBeginTill};

 PRIVATE PROCEDURE Reset(D: DATE);
 BEGIN
  L_MathR.ResetMathDone_AP(MathKAGL.Math, L_DatTim.NextPer(D));
  L_MathR.ResetMathDone_AP(MathKAGL.Math, L_DatTim.Per(D));
 END {Reset};

 PRIVATE PROCEDURE UnDone(D: DATE);
  VAR
   DE: DATE;
 BEGIN
  D:=Math.Max(D, L_Env.aptm_Start);
  SAVE(KAGLog);
  CHANGESEL(KAGLog, KAGroup, , KAGLog.KAGroup);
  IF NEXT(KAGLog) THEN
   DE:=KAGLog.Date-1;
  ELSE
   SETEMPTY(DE);
  END;
  RESTORE(KAGLog);
  IF (DE >= D) & (L_Env.KeyAssAcntLev(DE) = L_MathR.kaal_WithActProcess) THEN
   IF SELECT(MathKAGL, KAGroup, KAGLog.KAGroup) THEN
    L_StdFrm.Choice("㤥 믮  楢 ⮢ ,|室  㯯 "+MathKAGL.KAGroup+"  "+L_DatTim.PeriodStr(D));
    WHILE OCCURE(MathKAGL) DO
     IF L_DatTim.IsActiveInIntvl_Inc(MathKAGL.Date, MathKAGL.DateE, D, DE) THEN
      CONFORM(MathKAGL, Math);
      Reset(D);
     END;
     NEXT(MathKAGL);
    END; (* WHILE OCCURE(MathKAGL) ... *)
   END;
  END;
 END {UnDone};

 PRIVATE PROCEDURE KAGroupE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterInsert, L_WDO.e_OnAfterEdit]);
  L_WDO.iUnmodifiable(0, ["KAGroup.KAGroup", "KAGroup.Begin", "v_AcnDprUnit", "v_TaxDprUnit"]);
  L_WDO.iMayBeEmpty  (0, ["KAGroup.Till"]);
  L_WDO.iField       (0, "KAGroup.AcnDprM").Format:=L_MathR.dprm_Pool;
  L_WDO.iField       (0, "KAGroup.TaxDprM").Format:=L_MathR.dprm_Pool;
  L_WDO.iField       (0, "v_AcnDprUnit").Format:=L_MathR.dpru_Pool;
  L_WDO.iField       (0, "v_TaxDprUnit").Format:=L_MathR.dpru_Pool;
  L_WDO.iSubwindow   (1, "KAGLogE");
 END {KAGroupE_OnInitializeWindow};

 PRIVATE PROCEDURE KAGroup_OnAfterEdIns();
 BEGIN
  SupportBeginTill();
  L_DBD.CheckValidity("KAGroup");
 END {KAGroup_OnAfterEdIns};

 PRIVATE PROCEDURE KAGroup_OnAfterInsert();
 BEGIN
  KAGroup_OnAfterEdIns();
 END {KAGroup_OnAfterInsert};

 PRIVATE PROCEDURE KAGroup_OnAfterEdit();
 BEGIN
  KAGroup_OnAfterEdIns();
  IF (KAGroup.AcnDprM # GE_PVALUE(KAGroup.AcnDprM)) |
     (KAGroup.TaxDprM # GE_PVALUE(KAGroup.TaxDprM)) THEN
   IF SELECT(MathKAGL, KAGroup, KAGroup.KAGroup) THEN
    L_StdFrm.Choice("㤥 믮  楢 ⮢ |   宦  㯯 "+KAGroup.KAGroup);
    WHILE OCCURE(MathKAGL) DO
     CONFORM(MathKAGL, Math);
     Reset(Math.Max(Math.Max(MathKAGL.Date, 01\01\2002), L_Env.aptm_Start));
     NEXT(MathKAGL);
    END; (* WHILE OCCURE(MathKAGL) ... *)
   END;
  END;
 END {KAGroup_OnAfterEdit};

 PRIVATE PROCEDURE KAGLogE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf]);
  L_WDO.iScsChange   (0, ["KAGLog.TaxNumb", "KAGLog.TaxUL", "KAGLog.DprGroup", "KAGLog.OKOF"]);
  L_WDO.iMayBeEmpty  (0, ["KAGLog.Number", "KAGLog.Deprec", "KAGLog.OKOF"]);
  L_WDO.iField       (0, "Deprec.Norm1000").Format:=" %  ⮨| %  ⮨ 設  1000  ஡";
  L_WDO.iField       (0, "v_AcnDprUnit").Format:=L_MathR.dpru_Pool;
  L_WDO.iField       (0, "v_TaxDprUnit").Format:=L_MathR.dpru_Pool;
  L_WDO.iProgs       (0, "KAGroup");
 END {KAGLogE_OnInitializeWindow};

 PRIVATE PROCEDURE KAGLog_OnAfterEdIns();
 BEGIN
  IF !KAGLog.OKOF THEN
   L_StdFrm.Choice(" 㪠  |⢨⥫쭮 ࠭?");
  END;
  IF KAGLog.DprGroup = 00 THEN
   L_StdFrm.Choice("࠭ 䨪⨢ 㯯 ⨧樨|  室  㯯 ꥪ⮢   㤥");
  END;
  L_General.Assert((KAGLog.AcnUL#0) & (KAGLog.TaxUL#0), "⨬ 㪠뢠 㫥 ");
 END {KAGLog_OnAfterEdIns};

 PRIVATE PROCEDURE KAGLog_OnAfterEdit();
 BEGIN
  KAGLog_OnAfterEdIns();
  IF (KAGLog.Date    # GE_PVALUE(KAGLog.Date))   |
     (KAGLog.Deprec  # GE_PVALUE(KAGLog.Deprec)) |
     (KAGLog.Number  # GE_PVALUE(KAGLog.Number)) |
     (KAGLog.AcnUL   # GE_PVALUE(KAGLog.AcnUL))  |
     (KAGLog.TaxUL   # GE_PVALUE(KAGLog.TaxUL))  |
     (KAGLog.TaxNumb # GE_PVALUE(KAGLog.TaxNumb)) THEN
   UnDone(L_DatTim.MinDATE(KAGLog.Date, GE_PVALUE(KAGLog.Date)));
  END;
 END {KAGLog_OnAfterEdit};

 PRIVATE PROCEDURE KAGLog_OnAfterInsert();
 BEGIN
  KAGLog_OnAfterEdIns();
  UnDone(KAGLog.Date);
 END {KAGLog_OnAfterInsert};

 PRIVATE PROCEDURE KAGLog_OnBeforeDelete();
 BEGIN
  UnDone(KAGLog.Date);
 END {KAGLog_OnBeforeDelete};

 PRIVATE PROCEDURE ClearIllegalUL();
 BEGIN
  IF ~L_MathR.GroupIncUL(KAGLog.DprGroup, KAGLog.TaxUL) THEN
   SETEMPTY(KAGLog.TaxUL);
   REPLACE(KAGLog);
  END;
 END {ClearIllegalUL};

 PRIVATE PROCEDURE E_dfmm_OKOFwChildIsGoodOKOF(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Stock.dfmm_OKOFwChildIsGoodOKOF), 0);
 END {E_dfmm_OKOFwChildIsGoodOKOF};

 PRIVATE PROCEDURE KAGLog_TaxNumb_OnSuccessfulChange();
 BEGIN
  L_General.Assert(KAGLog.TaxNumb#0, "樥 ᪮७ ⨧樨    ࠢ 0." +
                                     "|᫨ ⨧  ᯮ, 㦭  ᯮᮡ " +
                                     "|⨧樨 㯯 த   ' ⨧'.");
 END {KAGLog_TaxNumb_OnSuccessfulChange};

 PRIVATE PROCEDURE KAGLog_OKOF_OnSuccessfulChange();
  VAR i: SCAL[10];
 BEGIN
  IF ~!KAGLog.OKOF THEN
   CONFORM(KAGLog, OKOF);
   L_General.Assert(OKOF.Leaf | E_dfmm_OKOFwChildIsGoodOKOF(), " ᯮ짮  㯯 ");
   IF L_MathR.OKOFIsInOneGroupOnly() THEN
    i:=0;
    WHILE ~OKOF.Groups[i] DO
     INC(i);
    END;
    KAGLog.DprGroup:=i + 1;
    REPLACE(KAGLog);
   END;
   IF ~!KAGLog.DprGroup & ~L_MathR.OKOFIsInGroup(KAGLog.DprGroup) & ~L_MathR.OKOFIsInNoGroup() THEN
    SETEMPTY(KAGLog.DprGroup);
    REPLACE(KAGLog);
   END;
   ClearIllegalUL();
  END;
 END {KAGLog_OKOF_OnSuccessfulChange};

 PRIVATE PROCEDURE KAGLog_DprGroup_OnSuccessfulChange();
 BEGIN
  CONFORM(KAGLog, OKOF);
  IF ~!KAGLog.OKOF & ~L_MathR.OKOFIsInNoGroup() & ~L_MathR.OKOFIsInGroup(KAGLog.DprGroup) THEN
   L_StdFrm.Choice("⨬ 㯯   ");
  END;
  ClearIllegalUL();
 END {KAGLog_DprGroup_OnSuccessfulChange};

 PRIVATE PROCEDURE KAGLog_TaxUL_OnSuccessfulChange();
 BEGIN
  L_General.Assert(!KAGLog.TaxUL |
                   L_MathR.GroupIncUL(KAGLog.DprGroup, KAGLog.TaxUL),
                   "ப ᯮ짮  ᮮ⢥ 㯯 ⨧樨");
 END {KAGLog_TaxUL_OnSuccessfulChange};

 PRIVATE PROCEDURE MathKAGL_OnReposition();
 BEGIN
  L_MathR.RecalculateKeyAssPermanent(L_WDO.getActiveForm());
 END {MathKAGL_OnReposition};

 PUBLIC PROCEDURE ChoiceFromSameOKOFGroups(trgType: L_MathR.DprKindType);
  CONST
   _LENGTH = 100;
  VAR
   PoolUL,
   PoolCounts: NUMERIC[0][_LENGTH];
   PoolNames : STRING[][_LENGTH];
   curKAGroup: LIKE(KAGLog.KAGroup);
   curDate   : LIKE(KAGLog.Date);
   curUL,
   IDX,
   Count,
   i,
   curCount,
   tmp       : NUMERIC[0];
   Pool,
   tmpStr,
   curName   : STRING[];
   DprM      : LIKE(KAGroup.AcnDprM);
 BEGIN
  SETEMPTY(PoolUL);
  Count:=0;
  ACCESS(KAGLog);
  L_General.Assert(~!KAGLog.OKOF, " 㪠  ");
  curKAGroup:=KAGLog.KAGroup;
  curDate   :=KAGLog.Date;
  SAVE(KAGLog);
  SELECT(KAGLog, OKOF, , KAGLog.OKOF);
  WHILE OCCURE(KAGLog) DO
   IF ((trgType = L_MathR.DprK_Acn) &
       ~!KAGLog.AcnUL & ((curKAGroup # KAGLog.KAGroup) | (curDate # KAGLog.Date))) |
      ((trgType = L_MathR.DprK_Tax) &
       ~!KAGLog.TaxUL & ((curKAGroup # KAGLog.KAGroup) | (curDate # KAGLog.Date))) THEN
    IF (trgType = L_MathR.DprK_Acn) THEN
     DprM :=KAGroup.AcnDprM;
     curUL:=KAGLog.AcnUL;
    ELSE
     DprM :=KAGroup.TaxDprM;
     curUL:=KAGLog.TaxUL;
    END;
    SAVE(KAGroup);
    CONFORM(KAGLog, KAGroup);
    IF (trgType = L_MathR.DprK_Acn) & (DprM = KAGroup.AcnDprM) |
       (trgType = L_MathR.DprK_Tax) & (DprM = KAGroup.TaxDprM) THEN
     i:=0;
     curCount:=1;
     curName:=KAGroup.KAGroup + " " + KAGroup.Name;
     LOOP
      IF (curUL = PoolUL[i]) THEN
       INC(PoolCounts[i]);
       EXIT;
      END;
      IF (curUL < PoolUL[i]) THEN
       tmp:=PoolUL[i];
       PoolUL[i]:=curUL;
       curUL:=tmp;
       tmp:=PoolCounts[i];
       PoolCounts[i]:=curCount;
       curCount:=tmp;
       tmpStr:=PoolNames[i];
       PoolNames[i]:=curName;
       curName:=tmpStr;
      END;
      INC(i);
      IF (i >= Count) THEN
       PoolUL    [Count]:=curUL;
       PoolCounts[Count]:=curCount;
       PoolNames [Count]:=curName;
       INC(Count);
       EXIT;
      END;
     END;
    END;
    RESTORE(KAGroup);
   END;
   NEXT(KAGLog);
  END; (* WHILE OCCURE(KAGLog) ... *)
  RESTORE(KAGLog);
  IF (Count > 0) THEN
   SETEMPTY(Pool);
   i:=0;
   IDX:=0;
   WHILE (i < Count) DO
    IF (trgType = L_MathR.DprK_Acn) & (PoolUL[i] = KAGLog.AcnUL) |
       (trgType = L_MathR.DprK_Tax) & (PoolUL[i] = KAGLog.TaxUL) THEN
     IDX:=i;
    END;
    Pool:=Pool + FLDTOSTR(PoolUL[i], "0", 6, "R") + "" +
                   PoolNames[i] +
                   " (" + L_Str.IntStr(PoolCounts[i]) + ") |";
    INC(i);
   END;
   IF STDFORM("   ப㯯 ꥪ⮢ (⢮ 宦)                    |"+
              "|"+
              "%64,"+L_Str.IntStr(Math.Min(12, Math.Max(2, Count)))+"<"+Pool+">I",
              " ப ᯮ짮  "+FLDTOSTR(KAGLog.OKOF, "00 0000000" + " "),
              INFORM_NEUTRAL, , IDX) THEN
    IF trgType = L_MathR.DprK_Acn THEN
     KAGLog.AcnUL:=PoolUL[IDX];
    ELSE
     KAGLog.TaxUL:=PoolUL[IDX];
    END;
    REPLACE(KAGLog);
   END;
  ELSE
   L_General.Error("   㯯 த ꥪ⮢|"+
                   "    "+ FLDTOSTR(KAGLog.OKOF, "00 0000000"));
  END;
 END {ChoiceFromSameOKOFGroups};

BEGIN
 L_Events.ExecuteHandler();
END.
