(*
%Copyright   (c) Polak IT
%Author      15.01.2003 18:17:27 POLAK\BOR
%Purpose     室/室   ਮ
%Type        report
%Specific    SYS
%Modified    15.09.2014 14:12:24 POLAK\Bor
%Environment
*)

 MODULE KAInO;

 IMPORT L_General, L_DatTim, L_Basis, L_MDoc, L_MathR, L_Car, L_AFM, L_Acnt, L_XObj, L_XDoc, L_XDR, L_bp,
        P_Firm, FIO, Math, Memo, E_Stock, L_Env;

 VAR
  wMF: SCAL[2];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "᭮");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "ઠ");
  L_Basis.wb_WrInQM(F, "祭 ");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " 㬥⠊");
  L_Basis.wb_WrInQM(F, " 㬥⠎");
  L_Basis.wb_WrInQM(F, " 㬥");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "祭 ");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "ᮢ ⮨");
  L_Basis.wb_WrInQM(F, "⨧");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakeLine(F: STRING[]; D      : DATE;
                                         Direct : SCAL[2];
                                         IsMDoc,
                                         IsCar  : SCAL[2];
                                         MDKName: STRING[];
                                         _Run   : LIKE(CarRun.TotRun); _AcCut: LIKE(AcCut.AcCut);
                                         KADst  : SCAL[L_MathR.KA_NumDestinat+1];
                                         Cost,
                                         Wear   : NUMERIC[2]);
  VAR
   HasKAG: SCAL[2];
 BEGIN
  IF wMF THEN
   CONFORM(Math, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  IF IsCar THEN
   L_Basis.wb_WrScl(F, CarLog.BoxNbr);
   L_Basis.wb_WrStr(F, CarLog.StateNbr);
   L_Basis.wb_WrScl(F, CarLog.Mark);
   L_Basis.wb_WrScl(F, Mark.Name);
   L_Basis.wb_WrStr(F, FLDTOSTR(CarLog.Purpose, "|"));
   L_Basis.wb_WrNum(F, _Run, 0);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrNum(F, 0, 0);
  END;
  HasKAG:=L_MathR.PosToKAGSoft(Math.Math, D);
  IF HasKAG THEN
   L_Basis.wb_WrScl(F, DeprecT.DeprecT);
   L_Basis.wb_WrStr(F, DeprecT.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  IF IsMDoc THEN
   L_Basis.wb_WrScl(F, MDocKind.MDocKind);
   L_Basis.wb_WrScl(F, MDocKind.Sign);
   L_Basis.wb_WrStr(F, MDKName);
   L_Basis.wb_WrScl(F, MDoc.MDoc);
   L_Basis.wb_WrDat(F, MDoc.Date);
   CONFORM(MDoc, Dest);
   L_Basis.wb_WrScl(F, Dest.Dest);
   L_Basis.wb_WrStr(F, Dest.Name);
  ELSE
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, MDKName);
   L_Basis.wb_WrScl(F, "----");
   L_Basis.wb_WrDat(F, L_General.EMPTY_DATE());
   IF HasKAG THEN
    CONFORM(MathKAGL, Dest);
    L_Basis.wb_WrScl(F, Dest.Dest);
    L_Basis.wb_WrStr(F, Dest.Name);
   ELSE
    L_Basis.wb_WrStr(F, "---");
    L_Basis.wb_WrStr(F, "---");
   END;
  END;
  L_Basis.wb_WrStr(F, FLDTOSTR(Direct, "室|室"));
  L_Basis.wb_WrStr(F, FLDTOSTR(KADst, "---|ந⢥|ந⢥"));
  IF ~!_AcCut THEN
   L_General.CallUs(SEARCH(AcCut, AcCut, _AcCut));
   L_Basis.wb_WrStr(F, AcCut.AcCut);
   L_Basis.wb_WrStr(F, AcCut.Sign);
   L_Basis.wb_WrStr(F, AcCut.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_WrNum(F, Cost, 2);
  L_Basis.wb_WrNum(F, Wear, 2);
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PRIVATE PROCEDURE Create__KAIO();
 BEGIN
  CreateFILE(_KAIO, "", "஢    ਮ", "");

  CreateFIELD(_KAIO, Math,    LIKE(Math.Math),      "", "", "", "", "");
  CreateFIELD(_KAIO, AcCut,   LIKE(AcCut.AcCut),    "", "", "", "१", "");
  CreateFIELD(_KAIO, Date,    DATE,                 "", "", "", "", "");
  CreateFIELD(_KAIO, DocId,   L_XDoc.tXDocId,       "", "", "", "㬥", "");
  CreateFIELD(_KAIO, IsCost,  SCAL[2],              "", "", "", "⮨", "1-⮨;0-⨧");
  CreateFIELD(_KAIO, Product, SCAL[L_MathR.KA_NumDestinat+1], "", "", "", "ந⢥/ந⢥", "");
  CreateFIELD(_KAIO, Sum,     NUMERIC[2],           "", "", "", "㬬", "");

  CreateINDEXandLINK(_KAIO, Math,  UNIQUE, Math,  Math,  USER, "", "", Math, DocId, Date, AcCut, IsCost, Product);
  CreateINDEXandLINK(_KAIO, AcCut, PLURAL, AcCut, AcCut, USER, "", "", AcCut);

  SetVersionOfFILE(_KAIO, 000);
 END {Create__KAIO};

 PRIVATE PROCEDURE AddKAIO_byXApport(BD, ED    : DATE;
                                     trgAcCuts : L_MathR.tMathAcCutCollection;
                                     IsCost    : SCAL[2];
                                     Productive: SCAL[L_MathR.KA_NumDestinat+1]);
  VAR
   curAcCut: LIKE(AcCut.AcCut);
   AmortSum: L_XObj.tSum;
 BEGIN
  FOR_EACH curAcCut IN trgAcCuts DO
   SETSEL(XApport, WFD, XObject.XObject, curAcCut);
   SRCINSEL(XApport, GE, , BD);
   WHILE OCCURE(XApport) & (XApport.WFDate<=ED) DO
    AmortSum:=L_MathR.XApportAmortSum();
    IF AmortSum # 0 THEN
     ADD(_KAIO, Math, , Math.Math, EMPTYOF(L_XDoc.tXDocId), XApport.WFDate, XApport.AcCut, IsCost, Productive,
                        _KAIO.Sum, AmortSum);
    END;
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
  END; (* FOR_EACH curAcCut IN ... *)
 END {AddKAIO_byXApport};

 PRIVATE PROCEDURE AddKAIO_byXDE(CurDocID  : L_XDoc.tXDocId;
                                 trgAcCuts : L_MathR.tMathAcCutCollection;
                                 IsCost    : SCAL[2];
                                 Productive: SCAL[L_MathR.KA_NumDestinat+1]);
  VAR
   curAcCut: LIKE(AcCut.AcCut);
   Dir     : NUMERIC[0];
 BEGIN
  FOR_EACH curAcCut IN trgAcCuts DO
   SELECT(XDE01, AcCut, , curAcCut);
   WHILE OCCURE(XDE01) DO
    NARROWSEL(XDE01, Apport);
    CONFORM(XDE01, Apport);
    IF Apport.CirType = L_Acnt.dt_Credit THEN
     Dir:=-1;
    ELSE
     Dir:=+1;
    END;
    FOR_EACH XDE01 DO
     IF (XDE01.Prt = L_XDR.xdr_XObject) & (XDE01.XObject = XObject.XObject) THEN
      IF CurDocID = XDE01.XDocId THEN
       ADD(_KAIO, Math, , Math.Math, XDE01.XDocId, MDocList.Date, XDE01.AcCut, IsCost, Productive,
                          _KAIO.Sum, Dir*XDE01.Sum);
      END;
     END;
    END; (* FOR_EACH XDE01 *)
    NEXTINEXTENDEDSEL(XDE01, Apport);
   END; (* WHILE OCCURE(XDE01) ... *)
  END; (* FOR_EACH curAcCut IN ... *)
 END {AddKAIO_byXDE};

 PRIVATE PROCEDURE Make_KAIO(BD, ED: DATE);
  VAR
   AcCutsP,
   AcCutsN,
   AcCutsW : L_MathR.tMathAcCutCollection;
   CurDocID: L_XDoc.tXDocId;
 BEGIN
  L_MathR.AccessKeyAssXObject();
  E_Stock.GetKeyAssBalCostAcCuts(ED, AcCutsP, L_MathR.KA_All, L_MathR.KA_dst_Productive, L_MathR.KA_All);
  E_Stock.GetKeyAssBalCostAcCuts(ED, AcCutsN, L_MathR.KA_All, L_MathR.KA_dst_NonProductive, L_MathR.KA_All);
  E_Stock.GetKeyAssWearAcCuts   (ED, AcCutsW, L_MathR.KA_All, L_MathR.KA_All, L_MathR.KA_All);

  AddKAIO_byXApport(BD, ED, AcCutsP, 1, L_MathR.KA_dst_Productive);
  AddKAIO_byXApport(BD, ED, AcCutsN, 1, L_MathR.KA_dst_NonProductive);
  AddKAIO_byXApport(BD, ED, AcCutsW, 0, L_MathR.KA_All);

  SETSEL(MDocList, Math, Math.Math);
  SRCINSEL(MDocList, GE, , BD);
  WHILE OCCURE(MDocList) & (MDocList.Date <= ED) DO
   IF L_MDoc.KeyAssetsMDoc(MDocList.MDocKind) THEN
    CONFORM(MDocList, MDoc);
    CurDocID:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
    IF ~SELECT(_KAIO, Math, Math.Math, CurDocID) THEN
     SAVE(MDocList);
     L_XDR.PrepareEntryList(L_XDoc.xdt_Math, L_DatTim.Per(MDoc.Date), 0);
     RESTORE(MDocList);
     AddKAIO_byXDE(CurDocID, AcCutsP, 1, L_MathR.KA_dst_Productive);
     AddKAIO_byXDE(CurDocID, AcCutsN, 1, L_MathR.KA_dst_NonProductive);
     AddKAIO_byXDE(CurDocID, AcCutsW, 0, L_MathR.KA_All);
    END;
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
 END {Make_KAIO};

 PRIVATE PROCEDURE MakePart(F: STRING[]; BD, ED: DATE);
  VAR
   Dir    : NUMERIC[0];
   IsMDoc,
   IsCar  : SCAL[2];
   MDKName: STRING[];
   APrDate: DATE;
   _Run   : LIKE(CarRun.TotRun);
   D      : DATE;
 BEGIN
  IF SELECT(_KAIO, Math, Math.Math) THEN
   APrDate:=L_MathR.GetKeyAssAPrDate(Math.Math);
   IsCar:=L_MathR.PosToLastCarLog(Math.Math, ED);
   IF IsCar THEN
    SAVE(CarLog);
    _Run:=L_Car.GetWhiteRun(Math.Math, ED);
    RESTORE(CarLog);
    CONFORM(CarLog, Car);
    CONFORM(CarLog, Mark);
    MakeLine(F, ED, "", 0, IsCar, "", _Run, "", 0, 0, 0);
   END;
   FOR_EACH _KAIO DO
    IF _KAIO.Sum # 0 THEN
     IF ~!_KAIO.DocId THEN
      L_XDoc.PositionOnXDoc(_KAIO.DocId);
      IsMDoc:=1;
      CONFORM(MDoc, MDocKind);
      MDKName:=MDocKind.Name;
     ELSE
      IsMDoc:=0;
      MDKName:="⨧";
     END;
     IF ~!APrDate THEN
      D:=Math.Max(_KAIO.Date-1, APrDate);
     ELSE
      D:=_KAIO.Date-1;
     END;
     IF _KAIO.IsCost THEN
      MakeLine(F, D, _KAIO.Sum>0, IsMDoc, IsCar, MDKName, 0, _KAIO.AcCut, _KAIO.Product, Math.Abs(_KAIO.Sum), 0);
     ELSE
      MakeLine(F, D, _KAIO.Sum<0, IsMDoc, IsCar, MDKName, 0, _KAIO.AcCut, _KAIO.Product, 0, Math.Abs(_KAIO.Sum));
     END;
    END;
   END; (* FOR_EACH _KAIO *)
  END;
 END {MakePart};

 PUBLIC PROCEDURE KAInO();
  CONST
   bpId = "KAInO";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "室/室 ", L_bp.t_Basis, L_General.tc_inIntvl);

  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
 
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
 
  MakeHeader("R");
 
  Create__KAIO(); L_AFM.AF_CreateTemp("_KAIO", "_KAIO");
  L_XDR.InitEntryList();

  SETSEL(Math, LeafMK, 1, L_MathR.mathk_KeyAs);
  FOR_EACH Math DO
   PROMPT(" "+Math.Math);
   L_MathR.CountUpMath(Math.Math, Memo.ud_ut());
   Make_KAIO(Memo.ud_fr(), Memo.ud_ut());
   MakePart("R", Memo.ud_fr(), Memo.ud_ut());
  END; (* FOR_EACH Math *)
 
  L_XDR.DeInitEntryList();
  L_AFM.AF_PurgeTemp("_KAIO");
  FIO.Close(R);
  L_bp.End();
 END {KAInO};

END.