(*
%Copyright   (c) Polak Computer System
%Author      30.09.1999 18:22:55 BOR
%Purpose      ॣ 
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:19:40 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_DatTim, L_MathR, L_MDoc, L_Car, L_Basis, L_Acnt,
        FIO, Memo, E_Stock, L_Env;

 PRIVATE PROCEDURE IsActiveKeyAss(_Math: LIKE(Math.Math); BalCost, TaxWearPer: NUMERIC[2]): SCAL[2];
 BEGIN
  RETURN (BalCost # 0) | (TaxWearPer # 0);
 END {IsActiveKeyAss};

 CONST
  RepName  = "KATax";

 VAR
  Productive: SCAL[2];
  CTaxCost,
  CTaxWear,
  TaxWearPer: NUMERIC[2];
  _TSN      : LIKE(Staff.TSN);
  _CDate,
  _BDate    : DATE;
  BegDate   : DATE;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "㯯");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "᪠");
  L_Basis.wb_WrInQM(F, "⠂");
  L_Basis.wb_WrInQM(F, "ந⢥");
  L_Basis.wb_WrInQM(F, " 襭");
  L_Basis.wb_WrInQM(F, "⮨ ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "   ਮ");
  L_Basis.wb_WrInQM(F, "㯯");
  L_Basis.wb_WrInQM(F, "㯯");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ப ᯮ짮 ");
  L_Basis.wb_WrInQM(F, "樥 ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]; _DprGroupName: LIKE(DprGroup.Name));
 BEGIN
  L_Basis.wb_WrScl(F, E_GetFGroup());
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrStr(F, FLDTOSTR(Math.Born, "y"));
  L_Basis.wb_WrDat(F, BegDate);
  L_Basis.wb_WrStr(F, FLDTOSTR(Productive, "-|+"));
  L_Basis.wb_WrStr(F, FLDTOSTR((CTaxCost>0) & (CTaxCost=CTaxWear), "-|+"));
  L_Basis.wb_WrNum(F, CTaxCost,  2);
  L_Basis.wb_WrNum(F, CTaxWear,  2);
  L_Basis.wb_WrNum(F, TaxWearPer, 2);
  L_Basis.wb_WrScl(F, KAGLog.DprGroup);
  L_Basis.wb_WrStr(F, _DprGroupName);
  L_Basis.wb_WrScl(F, DeprecT.DeprecT);
  L_Basis.wb_WrStr(F, DeprecT.Name);
  L_Basis.wb_WrNum(F, KAGLog.TaxUL, 0);
  L_Basis.wb_WrNum(F, KAGLog.TaxNumb, 3);
  L_Basis.wb_WrStr(F, FLDTOSTR(KAGLog.OKOF, "00 0000000000"));
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE E_GetFGroup(): SCAL[4];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Stock.GetFGroup);
  IF ~!Local THEN
   RETURN E_Stock.GetFGroup(BegDate);
  ELSE
   IF    BegDate < 01\05\2001 THEN
    RETURN 1;
   ELSIF BegDate < 01\01\2002 THEN
    RETURN 2;
   ELSE
    RETURN 3;
   END;
  END;
 END {E_GetFGroup};

 PRIVATE PROCEDURE Make();
  VAR
   _Date: DATE;
   DprGroupName: LIKE(DprGroup.Name);
   ProdCost,
   NonPCost : NUMERIC[2];
 BEGIN
  SELECT(Math, LeafMK, , 1, L_MathR.mathk_KeyAs);
  WHILE OCCURE(Math) DO
   PROMPT(Math.Math);
   ProdCost  :=L_MathR.GetKeyAssBalCostR(_CDate+1, L_MathR.KA_dst_Productive);
   NonPCost  :=L_MathR.GetKeyAssBalCostR(_CDate+1, L_MathR.KA_dst_NonProductive);
   CTaxCost  :=L_MathR.GetKeyAssBalCostR(_CDate+1, L_MathR.KA_Tax);
   TaxWearPer:=L_MathR.GetKeyAssWearPerR(_BDate, _CDate, L_MathR.KA_Tax);
   IF IsActiveKeyAss(Math.Math, CTaxCost, TaxWearPer) THEN
    L_MathR.CountUpMath(Math.Math, _CDate);
    BegDate:=L_MathR.GetKeyAssAPrDate(Math.Math);
    IF (ProdCost # 0) & (NonPCost # 0) THEN
     STDMSG("ꥪ  "+Math.Math+"|६  ந⢥  ந⢥?", CHOICE);
    END;
    Productive:=ProdCost > NonPCost;
    CTaxWear  :=L_MathR.GetKeyAssWearR(_CDate+1, L_MathR.KA_Tax);
    L_MathR.PosToKAG(Math.Math, _CDate);
    CONFORM(KAGLog, DprGroup);
    IF OCCURE(DprGroup) THEN
     DprGroupName:=DprGroup.Name;
    ELSE
     DprGroupName:="";
    END;
    MakePart("R", DprGroupName);
   END;
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)
 END {Make};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
 L_General.SetIntvlByIntvl(_BDate, _CDate);
 L_DatTim.CheckWMIntvl(_BDate, _CDate);

 FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
 MakeHeader("R");

 Make();

 FIO.Close(R);
END.
