(*
%Copyright   (c) Polak IT
%Author      23.10.2003 17:15:42 POLAK\LDA
%Purpose     ଠ樮  (Web-䥩)
%Type        operation
%Specific    AP
%Modified    08.09.2014 18:02:46 POLAK\Gina
%Environment
*)

 MODULE Ksk [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, FIO, Str, L_Str, P_Firm, Math, L_DatTim, L_AFM, L_Env, L_Way, Memo, L_APtm,
        L_MathR, L_Staff, P_OwnData, E_UI, L_Basis, P_Man, L_APEMl, L_EMail,
        L_GUI, L_Rpr, L_ACS, L_FIO, L_SCAD, L_TRS, L_Kiosk, L_StdFrm, L_Man, L_SysLog, L_APMsg;

 PRIVATE TYPE
  tStatus             = SCAL[17];
  tResult             = SCAL[3];
  tObjectKind         = SCAL[4];
  tObjectAccessResult = SCAL[3];

 PRIVATE CONST
  refreshCycle_Instr      = 15;
  refreshCycle_Renew      = 1;
  refreshCycle_Renewal    = 1 * 60;
  refreshCycle_TimeOut    = 5 * 60;
  refreshCycle_Weather    = 3 * 60 * 60;
  refreshCycle_StatusFile = 20;

  p_Common            = "Page_Common";
  p_Common2           = "Page_Common2";
  p_Welcome           = "Page_Welcome";
  p_Error             = "Page_Error";
  p_Inform            = "Page_Inform";
  p_Backward          = "Page_Backward";
  p_Input             = "Page_Input";
  p_RepButtons        = "Page_RepButtons";
  p_Report            = "Page_Report";
  p_Html              = "Page_Html";
  p_ObjectsList       = "Page_ObjectsList";
  p_CongratulationBD  = "Page_Congratulation_BD";
  p_Congratulation8M  = "Page_Congratulation_8M";
  p_Congratulation23F = "Page_Congratulation_23F";
  p_CongratulationNY  = "Page_Congratulation_NY";

  id_Clock             = "st_DateTime";
  id_Instr1            = "sp_Instr1";
  id_Instr2            = "sp_Instr2";
  id_ErrorMessage      = "st_ErrorMessage";
  id_InformMessage     = "st_InformMessage";
  id_Backward          = "pb_Backward";
  id_ReportText        = "st_ReportText";
  id_ReportAsHtml      = "wb_ReportAsHtml";
  id_ManPhoto          = "sp_ManPhoto";
  id_Enter             = "bp_Enter";
  id_Weather           = "wb_Weather";
  id_Input             = "st_InputBorder";
  id_ObjectTitle       = "st_Objectitle";
  id_ObjectCode        = "st_ObjectCode";
  id_Prompt            = "st_Prompt";
  id_CongratulationBD  = "sp_Congratulation_BD";
  id_Congratulation8M  = "sp_Congratulation_8M";
  id_Congratulation23F = "sp_Congratulation_23F";
  id_CongratulationNY  = "sp_Congratulation_NY";
  id_TextCongratBD     = "st_Congratulation_BD";
  id_TextCongrat8M     = "st_Congratulation_8M";
  id_TextCongrat23F    = "st_Congratulation_23F";
  id_TextCongratNY     = "st_Congratulation_NY";
  id_StaffName         = "st_StaffName";
  id_CarName           = "st_CarName";
  id_EnterCode         = "pb_EnterCode";
  id_ChooseCar         = "pb_ChooseCar";
  id_GroupBut          = "pb_GroupBut";

  id_clndCurMonthName  = "st_clndCurMonthName";
  id_clndNxtMonth      = "pb_nxtMonth";
  id_prdCurMonth       = "pb_prdCurMonth";
  id_prdPrvMonth       = "pb_prdPrvMonth";
  id_prdNxtMonth       = "pb_prdNxtMonth";
  id_prdCurYear        = "st_prdCurYear";
  id_prdPrvYear        = "pb_prdPrvYear";
  id_prdNxtYear        = "pb_prdNxtYear";

  id_olItem            = "bp_ol_";

  o_Staff   = 0;
  o_Car     = 1;
  o_PINCode = 2;

  o_Pool = "Staff|Car|PINCode";

  rb_Column_Amnt          = 3;
  rb_ButtonsInColumn_Amnt = 5;
  rb_TotalAmnt            = rb_ButtonsInColumn_Amnt * (rb_Column_Amnt - 1);

  status_Enter                 = 0;
  status_InputTSN              = 1;
  status_InputBoxNbr           = 2;
  status_InputPIN              = 3;
  status_ViewStaffGroupBut     = 4;
  status_ChooseCarFromList     = 5;
  status_ChooseStaffFromList   = 6;
  status_ViewCarGroupBut       = 7;
  status_ShowCongratulationBD  = 8;
  status_ShowErrorMessage      = 9;
  status_ShowInformMessage     = 10;
  status_ViewRepBut            = 11;
  status_ViewReport            = 12;
  status_ViewHtml              = 13;
  status_ShowCongratulation8M  = 14;
  status_ShowCongratulation23F = 15;
  status_ShowCongratulationNY  = 16;

  oar_Done          = 0;
  oar_NotAcceptable = 1;
  oar_NotAvailable  = 2;

  sW_CommonShift = 4;
  sH_CommonShift = 3;
  pL_Most        = sW_CommonShift;
  pR_Most        = (L_GUI.normalWidth-1) - pL_Most;
  sW_Most        = pR_Most - pL_Most;
  pT_Most        = sH_CommonShift;
  pB_Most        = (L_GUI.normalHeight-1) - sH_CommonShift;

  sH_Title       = 25;
  pT_Instr       = pT_Most + sH_Title + sH_CommonShift;
  sH_Object      = 38;

  pT_O_Staff     = pT_Instr;
  pT_O_Car       = pT_O_Staff + sH_Object + 3;

  sW_ControlBut  = (sW_Most - sW_CommonShift * (rb_Column_Amnt + 1)) / rb_Column_Amnt; (*326*)
  sH_ControlBut  = 93;
  sH_ControlButBorder = sH_ControlBut + 20;
  pT_ControlButBorder = pB_Most - sH_ControlButBorder;

  pT_RepButBorder  = pT_O_Car + sH_Object + sH_CommonShift;
  sW_RepButBorder  = sW_Most;
  sH_RepButBorder  = pT_ControlButBorder - pT_RepButBorder - sH_CommonShift;

  pL_RepBut = pL_Most + sW_CommonShift + 1;
  pT_RepBut = 143;
  sW_RepBut = sW_ControlBut;
  sH_RepBut = 93;

  sW_ChooseObject      = 850;
  sH_ChooseObject      = 70;

  maxNestingLevel = 10;

  otp_Staff = "FEMALE.gif|MALE.gif";
  otp_Car   = "Bus.gif";

  clnd_DatePrefix = "Day_";
  clnd_btnColumn  = 7;
  clnd_btnRow     = 6;
  clnd_btnAmount  = clnd_btnColumn * clnd_btnRow;
  fs_ClndDayBtn   = 34;

  prd_MonthPrefix = "pb_prdMon_";

  sW_DlgClsBtn  = 60;
  sH_DlgClsBtn  = 54;
  fs_DlgClsBtn  = 50;

  r_Error  = 0;
  r_Normal = 1;
  r_NoPIN  = 2;

 PRIVATE VAR
  bbc_HasInform,
  bbc_JustColor,
  bbc_Default    : RGBCOLOR;

  DTS_Renew,
  DTS_Renewal,
  DTS_StatusFile,
  DTS_Weather,
  DTS_TimeOut,
  DTS_Instr      : TIMESTAMP;

  dlg, clnd, prd : DIALOG;
  curNestingLevel: NUMERIC[0];

  ErrorMessage,
  EncryptPIN        : STRING[];

  History           : tStatus[maxNestingLevel];
  curObject         : tObjectKind;
  ObjectCode        : STRING[];

  curTSN            : LIKE(Staff.TSN);
  curStaffIsGuard   : SCAL[2];
  curStaffPost      : LIKE(Post.Post);
  curStaffPostName  : STRING[];
  curMan            : LIKE(Man.Man);
  curManName        : STRING[];
  curManBirthDate   : DATE;

  curBoxNbr         : LIKE(Car.BoxNbr);
  curCarName        : STRING[];

  curPage           : STRING[];
  curGroupButId     : STRING[];
  CalendarRepId     : STRING[];

  aa_Nbr: NUMERIC[0];

  wTouchScreen, KioskDemoMode: SCAL[2];

  clnd_From,
  clnd_CurPer,
  clnd_ChosenDate: DATE;

  prd_CurMonthBeg,
  prd_ChosenMonthBeg: DATE;

 PRIVATE PROCEDURE E_UseProximityCard(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  IF ~L_APtm.KioskUser_WO_Authorization() THEN
   Local:=PROCREF(E_UI.UseProximityCard);
   IF ~!Local THEN
    RETURN Local();
   END;
  END;
  RETURN 0;
 END {E_UseProximityCard};

 PRIVATE PROCEDURE E_GetDeliveryContact(CheckDeliveryContactExistsOnly: SCAL[2]): L_EMail.tContact;
  VAR
   D          : DATE;
   EMailAddr,
   EMailDomain: STRING[];
 BEGIN
  IF CheckDeliveryContactExistsOnly & L_General.IsProgrammer() THEN
   RETURN L_EMail.AssembleContact("  ⨢樨 窨", "delivery@somwhere");
  END;
  D        :=SYSDATE();
  EMailAddr:=L_APEMl.CurUserEMail(~CheckDeliveryContactExistsOnly);
  IF    ~!EMailAddr THEN
   RETURN L_EMail.AssembleContact(P_Firm.FP_FirmShortName(P_Firm.OWN_FIRM, D), EMailAddr);
  ELSIF ~P_OwnData.SMTPWithAuthentication(D) & ~!P_OwnData.EMailDomain(D) THEN
   EMailAddr  :="delivery";
   EMailDomain:=P_OwnData.EMailDomain(D);
   RETURN L_EMail.AssembleContactFromParts(P_Firm.FP_FirmShortName(P_Firm.OWN_FIRM, D),
                                             EMailAddr,
                                             EMailDomain);
  ELSE
   RETURN "";
  END;
 END {E_GetDeliveryContact};

 PRIVATE PROCEDURE E_CheckPINCode_WhenInputTSN(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_UI.CheckPINCode_WhenInputTSN);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 1;
  END;
 END {E_CheckPINCode_WhenInputTSN};

 PRIVATE PROCEDURE E_PINCodeRequired(): SCAL[2];
 BEGIN
  RETURN ~(E_UseProximityCard() | L_APtm.KioskUser_WO_Authorization());
 END {E_PINCodeRequired};

 PRIVATE PROCEDURE ext_sorbd_ByNbr(Page: STRING[]; trgNbr: NUMERIC[0]; trgGroupButId: STRING[]);
 BEGIN
  SELECT(kskRepBut, kskRepBut, , Page, L_Kiosk.bt_Report, trgGroupButId, trgNbr);
 END {ext_sorbd_ByNbr};

 PRIVATE PROCEDURE sorbd_ByNbr(trgNbr: NUMERIC[0]);
 BEGIN
  ext_sorbd_ByNbr(curPage, trgNbr, curGroupButId);
 END {sorbd_ByNbr};

 PRIVATE PROCEDURE sogbd_ById(trgPage, trgId: STRING[]);
 BEGIN
  SELECT(kskRepBut, Id, , trgPage, L_Kiosk.bt_Group, trgId);
 END {sogbd_ById};

 PRIVATE PROCEDURE sorbd_ById(trgId: STRING[]);
 BEGIN
  SELECT(kskRepBut, Id, , curPage, L_Kiosk.bt_Report, trgId);
 END {sorbd_ById};

 PRIVATE PROCEDURE AuthorizationRequired(Page: STRING[]; trgNbr: NUMERIC[0]; trgGroupButId: STRING[]): SCAL[2];
 BEGIN
  IF E_PINCodeRequired() & ~E_CheckPINCode_WhenInputTSN() THEN
   IF !trgNbr THEN
    sogbd_ById(Page, trgGroupButId);
   ELSE
    ext_sorbd_ByNbr(Page, trgNbr, trgGroupButId);
   END;
   RETURN kskRepBut.AuthReq;
  ELSE
   RETURN 0;
  END;
 END {AuthorizationRequired};

 PRIVATE PROCEDURE fpn_Get(PictName: STRING[]): STRING[];
 BEGIN
  IF ~!PictName THEN
   RETURN FIO.BuildPath(PictName, , "mk:@MSITStore:" + L_FIO.rf_GetCHMFullName("ksk") + "::/");
  ELSE
   RETURN "";
  END;
 END {fpn_Get};

 PRIVATE PROCEDURE put_GroupButton(Page     : STRING[];
                                   Left, Top: NUMERIC[0]);
 BEGIN
  L_GUI.put_ImgButton(dlg,
                      Page,
                      kskRepBut.Id,
                      kskRepBut.Name,
                      fpn_Get(kskRepBut.Picture),
                      Left,
                      Top,
                      sW_RepBut,
                      sH_RepBut,
                      PROCREF(onClick_GroupBut));
 END {put_GroupButton};

 PRIVATE PROCEDURE MakeLogFileHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠦ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६ 믮");
  L_Basis.wb_WrInQM(F, " 믮");
  L_Basis.wb_TermLine(F);
 END {MakeLogFileHeader};

 PRIVATE CONST
  klfm_Mark  = 0;
  klfm_Start = 1;
  klfm_Stop  = 2;

 PRIVATE PROCEDURE MakeLogFileLine(F,
                                   Operation,
                                   ReportName: STRING[];
                                   Duration  : FLOAT;
                                   Result    : tResult;
                                   klfMode   : SCAL[3]);
  VAR
   S   : STRING[];
   Sec : SCAL[99];
   Time: TIME;
 BEGIN
  IF (klfMode = klfm_Mark) | (klfMode = klfm_Start) THEN
   FIO.Seek(^F, Math.Max(0, FIO.Size(^F)-2));
   IF FIO.RdByte(^F, S, 2) THEN
    IF S # L_Str.CRLF THEN
     L_Basis.wb_TermLine(F);
    END;
   END;

   Time:=SYSTIME(Sec);
   L_Basis.wb_WrStr(F, Operation);
   L_Basis.wb_WrDat(F, SYSDATE());
   L_Basis.wb_WrLongTim(F, Time, Sec);
   L_Basis.wb_WrScl(F, curTSN);
   L_Basis.wb_WrStr(F, curManName);
   L_Basis.wb_WrScl(F, curStaffPost);
   L_Basis.wb_WrStr(F, curStaffPostName);
   L_Basis.wb_WrScl(F, curBoxNbr);
   L_Basis.wb_WrStr(F, ReportName);
  END;
  IF (klfMode = klfm_Mark) | (klfMode = klfm_Stop) THEN
   L_Basis.wb_WrNum(F, Duration, 3);
   IF ~!Result THEN
    L_Basis.wb_WrStr(F, L_Str.PoolItem("Error|Normal|NoPIN", Result));
   ELSE
    L_Basis.wb_WrStr(F, "");
   END;
   L_Basis.wb_TermLine(F);
  END;
 END {MakeLogFileLine};

 PRIVATE PROCEDURE klf_Open(): SCAL[2];
  VAR
   KioskLogFileName: STRING[];
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
   KioskLogFileName:=FIO.BuildPath("KLog_" + COMPUTERNAME(COMPUTER_NAME_NetBIOS), "TXT", "TJR");
   IF ~FIO.Exists(KioskLogFileName) THEN
    FIO.Open(L, KioskLogFileName, , Create);
    MakeLogFileHeader("L");
   ELSE
    FIO.Open(L, KioskLogFileName, , Append);
   END;
   RETURN 1;
  EXCEPT
  ON Exc: Exc_Root DO
   RETURN 0;
  END; (* TRY *)
 END {klf_Open};

 PRIVATE PROCEDURE klf_Write(Operation,
                             ReportName  : STRING[];
                             Duration    : FLOAT;
                             Result      : tResult;
                             klfMode     : SCAL[3]);
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
   MakeLogFileLine("L", Operation, ReportName, Duration, Result, klfMode);
  EXCEPT
  ELSE
  END; (* TRY *)
 END {klf_Write};

 PRIVATE PROCEDURE klf_Close();
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
   FIO.Close(L);
  EXCEPT
  ELSE
  END; (* TRY *)
 END {klf_Close};

 PRIVATE PROCEDURE klf_Mark(Operation,
                            ReportName: STRING[];
                            Duration  : FLOAT;
                            Result    : tResult);
 BEGIN
  IF klf_Open() THEN
   klf_Write(Operation, ReportName, Duration, Result, klfm_Mark);
   klf_Close();
  END;
 END {klf_Mark};

 PUBLIC PROCEDURE klf_SimpleMark(Operation: STRING[]);
 BEGIN
  klf_Mark(Operation, "", 0, r_Normal);
 END {klf_SimpleMark};

 PRIVATE PROCEDURE klf_SimpleMarkError(Operation: STRING[]);
 BEGIN
  klf_Mark(Operation, "", 0, r_Error);
 END {klf_SimpleMarkError};

 PRIVATE PROCEDURE klf_Start(Operation, ReportName: STRING[]);
 BEGIN
  IF klf_Open() THEN
   klf_Write(Operation, ReportName, EMPTYOF(FLOAT), EMPTYOF(tResult), klfm_Start);
   klf_Close();
  END;
 END {klf_Start};

 PRIVATE PROCEDURE klf_Stop(Operation,
                            ReportName: STRING[];
                            Duration  : FLOAT;
                            Result    : tResult);
 BEGIN
  IF klf_Open() THEN
   klf_Write(Operation, ReportName, Duration, Result, klfm_Stop);
   klf_Close();
  END;
 END {klf_Stop};

 PRIVATE PROCEDURE getObjectCodeMaxLength(ok: tObjectKind): NUMERIC[0];
 BEGIN
  IF ok = o_Staff THEN
   RETURN 5;
  ELSE
   RETURN 4;
  END;
 END {getObjectCodeMaxLength};

 PRIVATE PROCEDURE IsInputDigitsStatus(trgStatus: tStatus): SCAL[2];
 BEGIN
  RETURN (trgStatus = status_InputTSN   ) |
         (trgStatus = status_InputBoxNbr) |
         (trgStatus = status_InputPIN   );
 END {IsInputDigitsStatus};

 PRIVATE PROCEDURE SecondsLeft(prvDTS: TIMESTAMP): NUMERIC[3];
 BEGIN
  IF !prvDTS THEN
   prvDTS:=L_DatTim.GetTIMESTAMP(MINOF(DATE), 00:00);
  END;
  RETURN (SYSTIMESTAMP() - prvDTS) * 24 * 60 * 60;
 END {SecondsLeft};

 PRIVATE PROCEDURE ShowPage(Page: STRING[]);
 BEGIN
  L_GUI.ShowPages(dlg, p_Common, 1);
  IF (Page # p_Welcome) & (Page # p_Report) & (Page # p_Html) THEN
   L_GUI.ShowPages(dlg, p_Common2, 0);
  END;
  L_GUI.ShowPages(dlg, Page, 0);
 END {ShowPage};

 PRIVATE PROCEDURE SetupSpecificGroupButton();
  VAR
   gb: PUSH_BUTTON;
 BEGIN
  gb:=dlg.Controls.Item(id_GroupBut);
  sogbd_ById(curPage, curGroupButId);
  gb.Text:=L_GUI.ConvText(kskRepBut.Name);
  IF ~!kskRepBut.Picture THEN
   gb.Picture:=L_GUI.SoftLoadPicture(fpn_Get(kskRepBut.Picture));
   L_GUI.internalSetupButtonRects(gb);
  END;
 END {SetupSpecificGroupButton};

 PRIVATE PROCEDURE ThroughCalendar(RepId: STRING[]): SCAL[2];
 BEGIN
  RETURN (RepId = L_Kiosk.srid_RWSMP) | (RepId = L_Kiosk.crid_RprPr);
 END {ThroughCalendar};

 PRIVATE PROCEDURE GetReportSpecificIntvl(    RepId: STRING[];
                                          VAR BPer : DATE;
                                          VAR EPer : DATE);
  VAR
   PeriodLength: NUMERIC[0];
 BEGIN
  IF    (RepId = L_Kiosk.crid_RUNBN) | (RepId = L_Kiosk.srid_EDO10) | (RepId = L_Kiosk.crid_MTBNB) THEN
   BPer:=L_DatTim.IncMonth(prd_CurMonthBeg, -11);
   EPer:=L_DatTim.MonthEnd(prd_CurMonthBeg);
  ELSIF (RepId = L_Kiosk.srid_MhTSN) | (RepId = L_Kiosk.crid_MhBNB) | (RepId = L_Kiosk.crid_RprHs) THEN
   IF RepId = L_Kiosk.crid_RprHs THEN
    PeriodLength:=3;
   ELSE
    PeriodLength:=2;
   END;
   IF prd_CurMonthBeg = L_DatTim.Per(SYSDATE()) THEN
    EPer:=SYSDATE();
   ELSE
    EPer:=L_DatTim.MonthEnd(prd_CurMonthBeg);
   END;
   BPer:=L_DatTim.IncMonth(L_DatTim.Per(EPer), -(PeriodLength-1));
  ELSIF (RepId = L_Kiosk.crid_Rpr31) THEN
   EPer:=SYSDATE()-1;
   BPer:=L_DatTim.IncMonth(L_DatTim.Per(EPer), -6);
  ELSIF ThroughCalendar(RepId) THEN
   EPer:=clnd_ChosenDate;
   BPer:=clnd_ChosenDate;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetReportSpecificIntvl};

 PRIVATE PROCEDURE GetReportDate(    RepId: STRING[];
                                 VAR D    : DATE);
 BEGIN
  IF    RepId = L_Kiosk.srid_MSStf THEN
   D:=L_DatTim.NextPer(prd_CurMonthBeg);
  ELSIF RepId = L_Kiosk.srid_DrGuS THEN
   IF prd_CurMonthBeg = L_DatTim.Per(SYSDATE()) THEN
    D:=Memo.ud_cd();
   ELSE
    D:=L_DatTim.MonthEnd(prd_CurMonthBeg);
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetReportDate};

 PRIVATE PROCEDURE GetReportSpecificMonth(ForKtmSh: SCAL[2]): DATE;
  VAR
   Result: DATE;
 BEGIN
  SETSEL(Month, Period);
  SRCINSEL(Month, EQ, , Memo.ud_fr());
  WHILE OCCURE(Month) & ~L_APtm.MonthIsClosed(Month.Period, L_APtm.system_Salary) DO
   PREV(Month);
  END; (* WHILE OCCURE(Month) ... *)
  L_General.CallUs(OCCURE(Month) & L_APtm.MonthIsClosed(Month.Period, L_APtm.system_Salary));
  Result:=Month.Period;
  IF ForKtmSh & (L_DatTim.IncMonth(Result, +1) = prd_CurMonthBeg) THEN
   Result:=L_DatTim.IncMonth(Result, +1);
  END;
  RETURN Result;
 END {GetReportSpecificMonth};

 PRIVATE PROCEDURE GetPeriodStr(P: DATE): STRING[];
  VAR
   Result : STRING[];
   trgYear: NUMERIC[0];
 BEGIN
  Result :=L_DatTim.MonthStr(P, 0);
  trgYear:=L_DatTim.YEAR(P);
  IF trgYear # L_DatTim.YEAR(SYSDATE()) THEN
   Result:=Result + " " + L_Str.IntStr(trgYear);
  END;
  RETURN Result;
 END {GetPeriodStr};

 PRIVATE PROCEDURE GetDateStr(D: DATE; Case: SCAL[6]): STRING[];
  VAR
   Result : STRING[];
   trgYear: NUMERIC[0];
 BEGIN
  Result :=L_Str.IntStr(L_DatTim.DAY(D)) + " " + L_DatTim.MonthStr(D, Case);
  trgYear:=L_DatTim.YEAR(D);
  IF trgYear # L_DatTim.YEAR(SYSDATE()) THEN
   Result:=Result + " " + L_Str.IntStr(trgYear);
  END;
  RETURN Result;
 END {GetDateStr};

 PRIVATE PROCEDURE GetFullReportButtonText(trgName: STRING[]): STRING[];
  VAR
   MonthAmount  : NUMERIC[0];
   Result       : STRING[];
   D, BPer, EPer: DATE;
   IsDateChanged: SCAL[2];
 BEGIN
  IsDateChanged:=prd_CurMonthBeg # L_DatTim.Per(SYSDATE());
  Result       :=trgName;
  IF    (kskRepBut.Id = L_Kiosk.srid_Money) | (kskRepBut.Id = L_Kiosk.srid_KtmSh) THEN
   Result:=Result + "|" + " " + GetPeriodStr(GetReportSpecificMonth(kskRepBut.Id = L_Kiosk.srid_KtmSh));
  ELSIF (kskRepBut.Id = L_Kiosk.srid_EDO10) | (kskRepBut.Id = L_Kiosk.crid_RUNBN) |
        (kskRepBut.Id = L_Kiosk.crid_MTBNB) | (kskRepBut.Id = L_Kiosk.srid_MhTSN) |
        (kskRepBut.Id = L_Kiosk.crid_MhBNB) | (kskRepBut.Id = L_Kiosk.crid_RprHs) |
        (kskRepBut.Id = L_Kiosk.crid_Rpr31) THEN
   GetReportSpecificIntvl(kskRepBut.Id, BPer, EPer);
   IF IsDateChanged THEN
    Result:=Result + "|" + " " + L_DatTim.PeriodStr(BPer) + "  " + L_DatTim.PeriodStr(EPer);
   ELSE
    MonthAmount:=L_DatTim.MonthsInIntvl(L_DatTim.MonthBeg(BPer), L_DatTim.MonthEnd(EPer));
    Result:=Result + "| " + L_Str.Months_asStr(MonthAmount);
   END;
  ELSIF kskRepBut.Id = L_Kiosk.srid_MSStf THEN
   GetReportDate(kskRepBut.Id, D);
   Result:=Result + "|" + " " + GetDateStr(D, 1);
  ELSIF kskRepBut.Id = L_Kiosk.srid_DrGuS THEN
   GetReportDate(kskRepBut.Id, D);
   IF IsDateChanged THEN
    Result:=Result + "|" + " " + GetDateStr(D, 1);
   END;
  ELSIF (kskRepBut.Id = L_Kiosk.srid_StNon) | (kskRepBut.Id = L_Kiosk.srid_EDO12) |
        (kskRepBut.Id = L_Kiosk.srid_MSSMT) | (kskRepBut.Id = L_Kiosk.crid_CStat) THEN
  (* 祣   *)
  ELSE
   IF IsDateChanged THEN
    Result:=Result + "|" + " " + GetPeriodStr(prd_CurMonthBeg);
   END;
  END;
  RETURN L_GUI.ConvText(Result);
 END {GetFullReportButtonText};

 PRIVATE PROCEDURE SetupReportButtons();
  VAR
   ButtonNbr: NUMERIC[0];
   rb       : PUSH_BUTTON;
 BEGIN
  ButtonNbr:=0;
  WHILE ButtonNbr < rb_TotalAmnt DO
   rb:=dlg.Controls.Item("pb_Report_" + L_Str.IntStr(ButtonNbr));
   sorbd_ByNbr(ButtonNbr);
   IF OCCURE(kskRepBut) THEN
    rb.Visible:=1;
    rb.Text   :=GetFullReportButtonText(kskRepBut.Name);
    rb.Enable :=kskRepBut.Enable;
    IF ~!kskRepBut.Picture THEN
     rb.Picture:=L_GUI.SoftLoadPicture(fpn_Get(kskRepBut.Picture));
     L_GUI.internalSetupButtonRects(rb);
    END;
   ELSE
    rb.Visible:=0;
   END;
   INC(ButtonNbr);
  END;
 END {SetupReportButtons};

 PRIVATE PROCEDURE CutObjectName(Text: STRING[]): STRING[];
  CONST
   MaxObjectNameLength = 40;
 BEGIN
  IF Str.Length(Text) > MaxObjectNameLength THEN
   Text:=Str.Slice(Text, 0, MaxObjectNameLength-1) + "~";
  END;
  RETURN Text;
 END {CutObjectName};

 PRIVATE PROCEDURE ShowCarListButton();
  VAR
   c: OBJECT;
   i: NUMERIC[0];
 BEGIN
  SELECT(CarLs, Amount);
  LAST(CarLs);

  i:=0;
  LOOP
   IF i < 4 THEN
    c:=dlg.Controls.Item(id_olItem + L_Str.IntStr(i));
    c.Visible:=OCCURE(CarLs);
    IF OCCURE(CarLs) THEN
     c.Text:=CutObjectName(CarLs.Name);
     PREV(CarLs);
    END;
   ELSE
    EXIT;
   END;
   INC(i);
  END; (* LOOP *)

  c:=dlg.Controls.Item(id_olItem + L_Str.IntStr(i));
  c.Text:="㣮 ࠭ᯮ⭮ ।⢮";
 END {ShowCarListButton};

 PRIVATE PROCEDURE ShowStaffListButton();
  VAR
   i: NUMERIC[0];
   c: OBJECT;
 BEGIN
  SELECT(StfLs, Contract);
  i:=0;
  LOOP
   IF i < 5 THEN
    c:=dlg.Controls.Item(id_olItem + L_Str.IntStr(i));
    c.Visible:=OCCURE(StfLs);
    IF OCCURE(StfLs) THEN
     c.Text:=CutObjectName(StfLs.Name);
     NEXT(StfLs);
    END;
   ELSE
    EXIT;
   END;
   INC(i);
  END; (* LOOP *)
 END {ShowStaffListButton};

 PRIVATE PROCEDURE IsSingleTSN(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=1;
  IF SELECT(StfLs, Contract) THEN
   SAVE(StfLs);
   Result:=~NEXT(StfLs);
   RESTORE(StfLs);
  END;
  RETURN Result;
 END {IsSingleTSN};

 PRIVATE PROCEDURE SetupBackwardButtonText(wRedraw: SCAL[2]);
  VAR
   b          : PUSH_BUTTON;
   Text       : STRING[];
   Min, Sec,
   SecondsPass: NUMERIC[0];
 BEGIN
  IF wRedraw THEN
   b:=dlg.Controls.Item(id_Backward);
   Text       :=Str.Item(b.Text, L_Str.CRLF, 0);
   SecondsPass:=refreshCycle_TimeOut - SecondsLeft(DTS_TimeOut);
   IF SecondsPass <= 60 THEN
    IF SecondsPass >= 0 THEN
     Min:=Math.Div(SecondsPass, 60);
     Sec:=SecondsPass - Min * 60;
    ELSE
     SETZERO(Min, Sec);
    END;
    Text:=Text + "|" + FLDTOSTR(Min, "L0", 2) + ":" + FLDTOSTR(Sec, "L0", 2);
   END;

   b.Text:=L_GUI.ConvText(Text);
   b.Redraw();
  END;
 END {SetupBackwardButtonText};

 PRIVATE PROCEDURE SetupBackwardButton(Text, PictName: STRING[]);
  VAR
   b: PUSH_BUTTON;
 BEGIN
  b:=dlg.Controls.Item(id_Backward);
  b.Text   :=Text;
  b.Visible:=1;
  b.Picture:=L_GUI.SoftLoadPicture(fpn_Get(PictName));
  SetupBackwardButtonText(0);
 END {SetupBackwardButton};

 PRIVATE PROCEDURE sbb_Return();
  CONST
   cbi_Return   = "Return.jpg";
 BEGIN
  SetupBackwardButton("", cbi_Return);
 END {sbb_Return};

 PRIVATE PROCEDURE sbb_Continue();
  CONST
   cbi_Continue = "Continue.jpg";
 BEGIN
  SetupBackwardButton("", cbi_Continue);
 END {sbb_Continue};

 PRIVATE PROCEDURE sbb_Exit();
  CONST
   cbi_Exit     = "Exit.jpg";
 BEGIN
  SetupBackwardButton("室  ᪠", cbi_Exit);
 END {sbb_Exit};

PRIVATE PROCEDURE PutStack(Id: STRING[]);
 VAR
  Point: CALL_STACK_CELL;
BEGIN
 FOR_EACH Point IN RTI.Get().Stack DO
  IF Point.Number > 0 THEN
   L_SysLog.ELN_Put(Id, Point.Proc.FullName + ", " + L_Str.IntStr(Point.Row));
  END;
 END;
END {PutStack};

 PRIVATE PROCEDURE ResetHistory();
 BEGIN
(*
  PutStack("Kiosk.Reset." + L_Str.IntStr(curNestingLevel) + ".Stack");
*)
  SETEMPTY(History);
  History[0]     :=status_Enter;
  curNestingLevel:=0;
 END {ResetHistory};

 PRIVATE PROCEDURE DrawPage();
  VAR
   trgStatus: tStatus;
 BEGIN
  trgStatus:=History[curNestingLevel];
  IF    trgStatus = status_Enter THEN
   SETEMPTY(curObject,
            curTSN, curMan, curManName, curStaffPost, curStaffPostName,
            curBoxNbr, curCarName);
   ResetHistory();
   ShowPage(p_Welcome);
  ELSIF IsInputDigitsStatus(trgStatus) THEN
   ShowPage(p_Input);
   IF    (trgStatus = status_InputTSN) |
         ((trgStatus = status_InputPIN) & E_CheckPINCode_WhenInputTSN()) THEN
    sbb_Exit();
   ELSE
    sbb_Return();
   END;
  ELSIF trgStatus = status_ViewStaffGroupBut THEN
   SETEMPTY(curBoxNbr, curCarName);
   ShowPage(L_Kiosk.p_Staff);
   IF IsSingleTSN() THEN
    sbb_Exit();
   ELSE
    sbb_Return();
   END;
  ELSIF trgStatus = status_ViewCarGroupBut THEN
   ShowPage(L_Kiosk.p_Car);
   sbb_Return();
  ELSIF trgStatus = status_ChooseCarFromList THEN
   ShowPage(p_ObjectsList);
   ShowCarListButton();
   sbb_Return();
  ELSIF trgStatus = status_ChooseStaffFromList THEN
   ShowPage(p_ObjectsList);
   ShowStaffListButton();
   sbb_Exit();
  ELSIF trgStatus = status_ShowCongratulationBD THEN
   ShowPage(p_CongratulationBD);
   sbb_Continue();
  ELSIF trgStatus = status_ShowCongratulation8M THEN
   ShowPage(p_Congratulation8M);
   sbb_Continue();
  ELSIF trgStatus = status_ShowCongratulation23F THEN
   ShowPage(p_Congratulation23F);
   sbb_Continue();
  ELSIF trgStatus = status_ShowCongratulationNY THEN
   ShowPage(p_CongratulationNY);
   sbb_Continue();
  ELSIF trgStatus = status_ShowErrorMessage THEN
   dlg.Controls.Item(id_ErrorMessage).Text:=L_GUI.ConvText(ErrorMessage);
   SETEMPTY(ErrorMessage);
   ShowPage(p_Error);
   sbb_Continue();
  ELSIF trgStatus = status_ShowInformMessage THEN
   dlg.Controls.Item(id_InformMessage).Text:=L_GUI.ConvText(ErrorMessage);
   SETEMPTY(ErrorMessage);
   ShowPage(p_Inform);
   sbb_Continue();
  ELSIF trgStatus = status_ViewReport THEN
   ShowPage(p_Report);
   sbb_Return();
  ELSIF trgStatus = status_ViewHtml THEN
   ShowPage(p_Html);
   sbb_Return();
  ELSIF trgStatus = status_ViewRepBut THEN
   ShowPage(p_RepButtons);
   sbb_Return();
   SetupSpecificGroupButton();
   SetupReportButtons();
  ELSE
   L_General.CallUs(0);
  END;
  dlg.Redraw();
  DTS_TimeOut:=SYSTIMESTAMP();
 END {DrawPage};

 PRIVATE PROCEDURE SetCurObject(trgStatus: tStatus);
 BEGIN
  IF    (trgStatus = status_InputTSN) | (trgStatus = status_ViewStaffGroupBut) | (trgStatus = status_ChooseStaffFromList) THEN
   curObject:=o_Staff;
  ELSIF (trgStatus = status_InputBoxNbr) | (trgStatus = status_ViewCarGroupBut) | (trgStatus = status_ChooseCarFromList) THEN
   curObject:=o_Car;
  ELSIF (trgStatus = status_InputPIN) THEN
   curObject:=o_PINCode;
  ELSIF (trgStatus = status_ViewRepBut) THEN
   IF    curPage = L_Kiosk.p_Staff THEN
    curObject:=o_Staff;
   ELSIF curPage = L_Kiosk.p_Car THEN
    curObject:=o_Car;
   ELSE
    L_General.CallUs(0);
   END;
  ELSIF (trgStatus = status_Enter) THEN
   SETEMPTY(curObject);
  END;
 END {SetCurObject};

 PRIVATE PROCEDURE simpleSetCurStatus(trgStatus: tStatus);
 BEGIN
  IF    trgStatus = status_ShowErrorMessage THEN
   IF History[curNestingLevel] # status_ShowErrorMessage THEN
(*
    PutStack("Kiosk.INC1." + L_Str.IntStr(curNestingLevel) + ".Stack");
*)
    INC(curNestingLevel);
   END;
  ELSIF ~IsInputDigitsStatus(History[curNestingLevel]) THEN
(*
   PutStack("Kiosk.INC2." + L_Str.IntStr(curNestingLevel) + ".Stack");
*)
   INC(curNestingLevel);
  END;
  History[curNestingLevel]:=trgStatus;
 END {simpleSetCurStatus};

 PRIVATE PROCEDURE extSetCurStatus(trgStatus: tStatus; wDrawPage: SCAL[2]);
  VAR
   i: NUMERIC[0];
 BEGIN
  SetCurObject(trgStatus);
  IF IsInputDigitsStatus(trgStatus) THEN
   dlg.Controls.Item(id_ObjectTitle).Text:=L_Str.PoolItem(" |ࠦ |-", curObject);
  END;
  IF (trgStatus = status_ViewStaffGroupBut) |
     (trgStatus = status_ViewCarGroupBut)   |
     (trgStatus = status_ViewRepBut) THEN
   i:=0;
   WHILE (i <= curNestingLevel) & (History[i] # trgStatus) DO
    INC(i);
   END; (* WHILE i ...*)
   IF i <= curNestingLevel THEN
    curNestingLevel:=i;
   ELSE
    simpleSetCurStatus(trgStatus);
   END;
  ELSE
   simpleSetCurStatus(trgStatus);
  END;
  IF wDrawPage THEN
   DrawPage();
  END;
 END {extSetCurStatus};

 PRIVATE PROCEDURE SetCurStatus(trgStatus: tStatus);
 BEGIN
  extSetCurStatus(trgStatus, 1);
 END {SetCurStatus};

PRIVATE PROCEDURE DebugCrashkiosk(Error, ErrorDescription: STRING[]);
 VAR
  i           : NUMERIC[0];
  HistoryAsStr: STRING[];
BEGIN
 SETEMPTY(HistoryAsStr);
 i:=0;
 WHILE i <= HIGH(History) DO
  IF ~!History[i] THEN
   HistoryAsStr:=L_Str.AddStrDlm(HistoryAsStr, ",") + L_Str.IntStr(i) + ":" + History[i];
  END;
  INC(i);
 END;
 L_SysLog.ELN_Put("Kiosk.Error", "ﭨ ᪠: curNestingLevel=" + L_Str.IntStr(curNestingLevel) + "; History="+HistoryAsStr);
 PutStack("Kiosk." + Error + ".Stack");
 IF ~!ErrorDescription THEN
  L_SysLog.ELN_Put("Kiosk.Error", "訡: " + ErrorDescription);
 END;
 klf_SimpleMarkError(Error);
 intReStartKiosk();
END {DebugCrashkiosk};

 PRIVATE PROCEDURE SetPreviousStatus();
 BEGIN
(*
  PutStack("Kiosk.DEC1." + L_Str.IntStr(curNestingLevel) + ".Stack");
*)

  DEC(curNestingLevel);
TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
 IF (History[curNestingLevel] = status_InputTSN) & E_UseProximityCard() |
    (History[curNestingLevel] = status_ChooseCarFromList) THEN
(*
  PutStack("Kiosk.DEC2." + L_Str.IntStr(curNestingLevel) + ".Stack");
*)
  DEC(curNestingLevel);
 END;
EXCEPT
ON Exc: Exc_Root DO
 DebugCrashkiosk("OutOfIndex", Exc.Description);
END; (* TRY *)
  SetCurObject(History[curNestingLevel]);
 END {SetPreviousStatus};

 PRIVATE PROCEDURE GoToPreviousStatus();
 BEGIN
  SetPreviousStatus();
  DrawPage();
 END {GoToPreviousStatus};

 PRIVATE PROCEDURE PushModeStr(): STRING[];
 BEGIN
  IF wTouchScreen THEN
   RETURN " 楬 ࠦ";
  ELSE
   RETURN "饫     ࠦ";
  END;
 END {PushModeStr};

 PRIVATE PROCEDURE ScrollModeStr(): STRING[];
 BEGIN
  IF wTouchScreen THEN
   RETURN "஢ 楬 /  ࠭.";
  ELSE
   RETURN "㤥ন ⮩   , ६  /.";
  END;
 END {ScrollModeStr};

 PRIVATE PROCEDURE GetErrorMsg(RealMsg: STRING[]): STRING[];
 BEGIN
  RETURN "     믮  騩 . ஡   " +
         L_Str.CRLF +
         L_Str.CRLF +
         L_Str.CRLF +
         "ଠ  :" +
         L_Str.CRLF +
         L_Str.ExclQM(RealMsg);
 END {GetErrorMsg};

 PRIVATE PROCEDURE UpdateObjectName(Id        : STRING[];
                                    Result    : tObjectAccessResult;
                                    ObjectCode: ANYTYPE;
                                    ObjectName: STRING[];
                                    PictName  : STRING[]);
  VAR
   tc: STATIC_TEXT;
   pc: STATIC_PICTURE;
 BEGIN
  tc:=dlg.Controls.Item(Id);
  pc:=dlg.Controls.Item(Id+"Picture");
  IF Result = oar_Done THEN
   tc.Text   :=ObjectCode + " " + ObjectName;
   pc.Picture:=L_GUI.SoftLoadPicture(fpn_Get(PictName));
  ELSE
   SETEMPTY(tc.Text, pc.Picture);
  END;
  tc.Redraw();
  pc.Redraw();
 END {UpdateObjectName};

 PRIVATE PROCEDURE ViewAcceptableStaffInDemoMode(trgMan: LIKE(Man.Man); trgTSN: LIKE(Staff.TSN)): SCAL[2];
 BEGIN
  RETURN KioskDemoMode & ((trgMan = P_Man.Try_curUSER2Man())   |
                           L_APtm.KioskUser_WO_Authorization() |
                           CurUserIsBoss(trgTSN));
 END {ViewAcceptableStaffInDemoMode};

 PRIVATE PROCEDURE AccessStaff(trgTSN: LIKE(Staff.TSN)): tObjectAccessResult;
  VAR
   Result: tObjectAccessResult;
 BEGIN
  TRY
   IF ~!trgTSN & L_Env.RealTSN(trgTSN) & SEARCH(Staff, TSN, trgTSN) THEN
    CONFORM(Staff, Man);
    IF L_Man.GetRealEndDate(SYSDATE()) <= (SYSDATE() - 180) THEN
     Result      :=oar_NotAcceptable;
     ErrorMessage:=Man.Name  + "|(⠡  "+trgTSN+")| 㢮"+L_Str.PoolItem("| ", Man.Sex);
    ELSE
     IF KioskDemoMode THEN
      IF ViewAcceptableStaffInDemoMode(Man.Man, trgTSN) THEN
       Result:=oar_Done;
      ELSE
       Result      :=oar_NotAcceptable;
       ErrorMessage:=Man.Name  + "|(⠡  "+trgTSN+")| 室  襬 稭";
      END;
     ELSE
      Result:=oar_Done;
     END;
    END;
   ELSE
    Result:=oar_NotAcceptable;
    IF ~!trgTSN THEN
     ErrorMessage:=" ⠡  " + trgTSN;
    END;
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   Result      :=oar_NotAvailable;
   ErrorMessage:=GetErrorMsg(Exc.Description);
  END; (* TRY *)
  RETURN Result;
 END {AccessStaff};

 PRIVATE PROCEDURE AccessCar(trgBoxNbr: LIKE(Car.BoxNbr)): tObjectAccessResult;
  VAR
   Result: tObjectAccessResult;
 BEGIN
  TRY
   IF ~!trgBoxNbr &
      L_Env.RealBoxNbr(trgBoxNbr) &
      SEARCH(Car, BoxNbr, trgBoxNbr) THEN
    Result:=oar_Done;
   ELSE
    Result:=oar_NotAcceptable;
    IF ~!trgBoxNbr THEN
     ErrorMessage:=" ࠦ  " + trgBoxNbr;
    END;
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   Result      :=oar_NotAvailable;
   ErrorMessage:=GetErrorMsg(Exc.Description);
  END; (* TRY *)
  RETURN Result;
 END {AccessCar};

 PRIVATE PROCEDURE GetCurCarName(): STRING[];
 BEGIN
  CONFORM(Car, Mark);
  RETURN "(" + L_Str.ExclQM(Car.StateNbr) + ") " + L_Str.ExclQM(Mark.Name);
 END {GetCurCarName};

 PRIVATE PROCEDURE E_GetWeatherForecastURL(): STRING[];
  VAR
   Local      : PROC;
   URL,
   TmpFileName: STRING[];
 BEGIN
  URL:="";
  IF P_OwnData.UseDedicatedLine(SYSDATE()) THEN
   Local:=PROCREF(E_UI.GetWeatherForecastURL);
   IF ~!Local THEN
    URL:=Local();
   ELSE
    URL:="http://informer.gismeteo.ru/new/4368-31.GIF";
   END;
  END;
  RETURN URL;
 END {E_GetWeatherForecastURL};

 PRIVATE PROCEDURE LoadWeatherForecast();
 BEGIN
  IF SecondsLeft(DTS_Weather) > refreshCycle_Weather THEN
   DTS_Weather:=SYSTIMESTAMP();
   L_GUI.ShowPictInActiveX(dlg, id_Weather, E_GetWeatherForecastURL());
  END;
 END {LoadWeatherForecast};

 PRIVATE PROCEDURE PrepareCarListByTSN();
 BEGIN
  SELECT(CarLs, BoxNbr);
  REMSEL(CarLs);

  SETSEL(RWayS, TSN, curTSN);
  SRCINSEL(RWayS, LE, , SYSDATE() - 30);
  WHILE OCCURE(RWayS) DO
   IF ~ADD(CarLs, BoxNbr, RWayS.BoxNbr,
           CarLs.Amount,  1) THEN
    IF AccessCar(RWayS.BoxNbr) = oar_Done THEN
     CarLs.Name:=RWayS.BoxNbr + " " + GetCurCarName();
     REPLACE(CarLs);
    ELSE
     REMOVE(CarLs);
    END;
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {PrepareCarListByTSN};

 PRIVATE PROCEDURE IsSpecificGroupButton(trgId: STRING[]): SCAL[2];
 BEGIN
  RETURN (trgId = L_Kiosk.gsrbid_Docs) | (trgId = L_Kiosk.gsrbid_Service) | (trgId = L_Kiosk.gcrbid_Service);
 END {IsSpecificGroupButton};

 PRIVATE PROCEDURE UpdateGroupButtonsAttr(trgPage: STRING[]);
  VAR
   gb                  : PUSH_BUTTON;
   trgName             : STRING[];
   ReportAmount,
   repEnableAmnt,
   repAuthReqAmnt      : NUMERIC[0];
   ForceSetGroupButName: SCAL[2];
 BEGIN
  SELECT(kskRepBut, Id, , trgPage, L_Kiosk.bt_Group);
  WHILE OCCURE(kskRepBut) DO
   trgName             :=kskRepBut.Name;
   ReportAmount        :=GetReportAmountByGroup(kskRepBut.Page, kskRepBut.Id);
   ForceSetGroupButName:=IsSpecificGroupButton(kskRepBut.Id);
   SAVE(kskRepBut);
   SETZERO(repAuthReqAmnt, repEnableAmnt);
   SELECT(kskRepBut, kskRepBut, , kskRepBut.Page, L_Kiosk.bt_Report, kskRepBut.Id);
   IF (ReportAmount = 1) & ForceSetGroupButName THEN
    trgName:=kskRepBut.Name;
   END;
   WHILE OCCURE(kskRepBut) DO
    INC(repAuthReqAmnt, kskRepBut.AuthReq);
    INC(repEnableAmnt,  kskRepBut.Enable);
    NEXT(kskRepBut);
   END; (* WHILE OCCURE(kskRepBut) ... *)
   RESTORE(kskRepBut);

   kskRepBut.Name   :=L_GUI.ConvText(trgName);
   IF ReportAmount = repAuthReqAmnt THEN
    kskRepBut.AuthReq:=1;
   END;
   kskRepBut.Enable :=(repEnableAmnt # 0) & L_Kiosk.E_AllowedButton(kskRepBut.Page, kskRepBut.Id, 1);
   REPLACE(kskRepBut);

   gb       :=dlg.Controls.Item(kskRepBut.Id);
   gb.Text  :=kskRepBut.Name;
   gb.Enable:=kskRepBut.Enable;

   NEXT(kskRepBut);
  END; (* WHILE OCCURE(kskRepBut) ... *)
 END {UpdateGroupButtonsAttr};

 PRIVATE PROCEDURE GoToViewStaffReportButtons();
  VAR
   ShowCongratulationRequired_BD,
   ShowCongratulationRequired_8M,
   ShowCongratulationRequired_23F,
   ShowCongratulationRequired_NY  : SCAL[2];
 BEGIN
  klf_SimpleMark("LogIn");
  ShowCongratulationRequired_BD:=L_DatTim.HasBirthdayInPer(curManBirthDate, SYSDATE() - 2, SYSDATE());
  ShowCongratulationRequired_NY:=L_DatTim.HasBirthdayInPer(01\01\1900, SYSDATE(), SYSDATE() + 1);
  SAVE(Man);
  L_General.CallUs(SEARCH(Man, Man, curMan));
  ShowCongratulationRequired_8M :=(Man.Sex = L_Man.sex_Female) & L_DatTim.HasBirthdayInPer(08\03\1990, SYSDATE(), SYSDATE() + 1);
  ShowCongratulationRequired_23F:=(Man.Sex = L_Man.sex_Male)   & L_DatTim.HasBirthdayInPer(23\02\1990, SYSDATE(), SYSDATE() + 1);
  RESTORE(Man);
  extSetCurStatus(status_ViewStaffGroupBut, ~(ShowCongratulationRequired_BD  |
                                              ShowCongratulationRequired_8M  |
                                              ShowCongratulationRequired_23F |
                                              ShowCongratulationRequired_NY   ));

  IF    ShowCongratulationRequired_8M  THEN
   extSetCurStatus(status_ShowCongratulation8M,  ~ShowCongratulationRequired_BD);
  ELSIF ShowCongratulationRequired_23F THEN
   extSetCurStatus(status_ShowCongratulation23F, ~ShowCongratulationRequired_BD);
  ELSIF ShowCongratulationRequired_NY THEN
   extSetCurStatus(status_ShowCongratulationNY,  ~ShowCongratulationRequired_BD);
  END;

  IF ShowCongratulationRequired_BD THEN
   SetCurStatus(status_ShowCongratulationBD);
  END;

  PrepareCarListByTSN();
 END {GoToViewStaffReportButtons};

 PRIVATE PROCEDURE GoToViewCarReportButtons();
 BEGIN
  SetCurStatus(status_ViewCarGroupBut);
 END {GoToViewCarReportButtons};

 PRIVATE PROCEDURE SetkskRepButEnable(trgId: STRING[]; trgEnable: SCAL[2]);
 BEGIN
  SELECT(kskRepBut, Id, , L_Kiosk.p_Staff, L_Kiosk.bt_Report, trgId);
  WHILE OCCURE(kskRepBut) DO
   IF (kskRepBut.RepType = L_Kiosk.rt_REP) & (kskRepBut.Enable # trgEnable) THEN
    kskRepBut.Enable:=trgEnable;
    REPLACE(kskRepBut);
   END;
   NEXT(kskRepBut);
  END; (* WHILE OCCURE(kskRepBut) ... *)
 END {SetkskRepButEnable};

 PRIVATE PROCEDURE AccessObject(Object: STRING[]): tObjectAccessResult;
  VAR
   Result      : tObjectAccessResult;
   tmpTSN      : LIKE(Staff.TSN);
   tmpBoxNbr,
   prvBoxNbr   : LIKE(Car.BoxNbr);
   Surname,
   FirstName,
   Patronymic,
   pict_Staff,
   prvCarName,
   ManPhotoPath: STRING[];
 BEGIN
  IF    curObject = o_Staff THEN
   SETEMPTY(curManName, curStaffPost, curStaffPostName, curManBirthDate, pict_Staff);
   tmpTSN:=STRTOFLD(Object, SCAL);
   Result:=AccessStaff(tmpTSN);
   IF Result = oar_Done THEN
    curTSN          :=tmpTSN;
    curMan          :=Man.Man;
    HISTCONF(Math.Max(Staff.BegDate, SYSDATE()), Staff, StaffLog, Officer, Post);
    curStaffIsGuard :=L_Env.IsGuard();
    curManName      :=Man.Name;
    curManBirthDate :=Man.Birth;
    curStaffPost    :=Post.Post;
    curStaffPostName:=Post.Name;
    pict_Staff      :=L_Str.PoolItem(otp_Staff, Man.Sex);

    L_Man.curMan_SplitName(Surname, FirstName, Patronymic);
    dlg.Controls.Item(id_TextCongratBD ).Text:="  ஦, "            + FirstName + " " + Patronymic + "!";
    dlg.Controls.Item(id_TextCongrat8M ).Text:=" ࠧ 8 , "       + FirstName + " " + Patronymic + "!";
    dlg.Controls.Item(id_TextCongrat23F).Text:="  ⭨ ⢠, " + FirstName + " " + Patronymic + "!";
    dlg.Controls.Item(id_TextCongratNY ).Text:="  , "              + FirstName + " " + Patronymic + "!";

    SETEMPTY(dlg.Controls.Item(id_ManPhoto).Picture, ManPhotoPath);
    ManPhotoPath    :=P_Man.GetFullPhotoFileName(P_Man.GetManProSoft(Man.Man, SYSDATE(), P_Man.P_ManPhoto));
    IF ~!ManPhotoPath THEN
     TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
      dlg.Controls.Item(id_ManPhoto).Picture:=LOADPICTURE(ManPhotoPath);
     EXCEPT
     ELSE
     END; (* TRY *)
    END;
    SetkskRepButEnable(L_Kiosk.srid_BQl02, L_SCAD.E_RWayCPLevel(SYSDATE()) & L_Env.IsDriver());
    SetkskRepButEnable(L_Kiosk.srid_StfFl, L_Env.IsDriver());
   END;
   UpdateObjectName(id_StaffName, Result, curTSN, curManName, pict_Staff);
   UpdateGroupButtonsAttr(L_Kiosk.p_Staff);
  ELSIF curObject = o_Car THEN
   prvBoxNbr :=curBoxNbr;
   prvCarName:=curCarName;
   SETEMPTY(curCarName);
   tmpBoxNbr :=STRTOFLD(Object, SCAL);
   Result    :=AccessCar(tmpBoxNbr);
   IF Result = oar_Done THEN
    klf_SimpleMark("ChooseCar");
    curBoxNbr :=tmpBoxNbr;
    curCarName:=GetCurCarName();
    UpdateObjectName(id_CarName, Result, curBoxNbr, curCarName, otp_Car);
   ELSE
    curBoxNbr :=prvBoxNbr;
    curCarName:=prvCarName;
   END;
   UpdateGroupButtonsAttr(L_Kiosk.p_Car);
  END; (* IF curObject = ...*)
  RETURN Result;
 END {AccessObject};

 PRIVATE PROCEDURE UpdateSingleStatusFile(StatusFileName: STRING[]);
 BEGIN
  IF ~!StatusFileName THEN
   FIO.Open(St, StatusFileName, , Create);
   FIO.WrStr(St, L_DatTim.DateStr(SYSDATE()) +  " " + L_DatTim.LongSystimeStr());
   FIO.Close(St);
  END;
 END {UpdateSingleStatusFile};

 PUBLIC PROCEDURE UpdateStatusFile();
  CONST
   StatusFileName  = "Activity.txt";
  VAR
   sfn_Local,
   sfn_Network,
   sfn_LocalPath: STRING[];
 BEGIN
  IF L_General.IsEndUser() THEN
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    sfn_LocalPath :="C:\AP_KIOSK";
    IF FIO.DirExists(sfn_LocalPath) THEN
     sfn_Local:=FIO.FullPath(FIO.BuildPath(StatusFileName, , sfn_LocalPath));
    ELSE
     sfn_Local:="";
    END;
    sfn_Network:=FIO.FullPath(FIO.BuildPath(COMPUTERNAME(COMPUTER_NAME_NetBIOS), "txt", "TMP"));
 
    UpdateSingleStatusFile(sfn_Local);
    UpdateSingleStatusFile(sfn_Network);
   EXCEPT
   ELSE
   END; (* TRY *)
  END;
 END {UpdateStatusFile};

 PRIVATE PROCEDURE RenewStatusFile(force: SCAL[2]);
 BEGIN
  IF L_General.IsEndUser() | ~KioskDemoMode THEN
   IF force | (SecondsLeft(DTS_StatusFile) >= refreshCycle_StatusFile) THEN
    UpdateStatusFile();
    DTS_StatusFile:=SYSTIMESTAMP();
   END;
  END;
 END {RenewStatusFile};

 PRIVATE PROCEDURE UpdateInstr();
  VAR
   Visible: SCAL[2];
   pc1, pc2: STATIC_PICTURE;
 BEGIN
  IF SecondsLeft(DTS_Instr) >= refreshCycle_Instr THEN
   pc1:=dlg.Controls.Item(id_Instr1);
   pc2:=dlg.Controls.Item(id_Instr2);
   Visible:=pc2.Visible;
   IF Visible THEN
    pc1.Visible:=Visible;
    pc1.Redraw();
    pc2.Visible:=~Visible;
    pc2.Redraw();
   ELSE
    pc2.Visible:=~Visible;
    pc2.Redraw();
    pc1.Visible:=Visible;
    pc1.Redraw();
   END;
   DTS_Instr:=SYSTIMESTAMP();
  END;
 END {UpdateInstr};

 PRIVATE PROCEDURE ShowMessage_woBackwardBut(trgMessage: STRING[];
                                             trgStatus : tStatus);
  VAR
   b: PUSH_BUTTON;
 BEGIN
  ErrorMessage:=trgMessage;
  SetCurStatus(trgStatus);
  b:=dlg.Controls.Item(id_Backward);
  b.Visible:=0;
  b.Redraw();
 END {ShowMessage_woBackwardBut};

 PRIVATE PROCEDURE intReStartKiosk();
  VAR
   Point: CALL_STACK_CELL;
 BEGIN
  klf_SimpleMark("ReStartKiosk");
  IF KioskDemoMode THEN
   Point:=RTI.Get().Stack(1);
   LIKEMENU(CALL, Point.Proc.Module.Name + ".Kiosk()");
  ELSE
   LIKEMENU(CALL, "AutoExec.Start()");
  END;
 END {intReStartKiosk};

 PRIVATE PROCEDURE ReStartKiosk();
 BEGIN
  ShowMessage_woBackwardBut(" 孨᪨ 稭 ॡ १㧪 ᪠.|||" +
                            "  ଠ樮 ᪥ 㤥  १ ᪮쪮 ᥪ㭤",
                            status_ShowInformMessage);
  SLEEP(4.0);
  intReStartKiosk();
 END {ReStartKiosk};

 PRIVATE PROCEDURE CheckReStartKioskRequired(force: SCAL[2]);
 BEGIN
  IF force |
     ((History[curNestingLevel] = status_Enter) & (SecondsLeft(DTS_Renewal) >= refreshCycle_Renewal)) THEN
   DTS_Renewal:=SYSTIMESTAMP();
   IF L_General.TheProjectModulesWereUpdated() THEN
    ReStartKiosk();
   END;
  END;
 END {CheckReStartKioskRequired};

 PRIVATE PROCEDURE UpdateClock();
 BEGIN
  dlg.Controls.Item(id_Clock).Text:=L_DatTim.CompleteSystimeStr();
  dlg.Controls.Item(id_Clock).Redraw();
 END {UpdateClock};

 PRIVATE PROCEDURE ClosePeriod();
 BEGIN
  prd.Visible:=0;
  prd.Redraw();
 END {ClosePeriod};

 PRIVATE PROCEDURE CloseCalendar();
 BEGIN
  SETEMPTY(CalendarRepId, clnd_CurPer, clnd_ChosenDate);
  HideCalendar();
 END {CloseCalendar};

 PRIVATE PROCEDURE ClearObjectsNameOnExit();
 BEGIN
  SETEMPTY(curTSN, curBoxNbr);
  UpdateObjectName(id_StaffName, oar_NotAcceptable, curTSN, "", "");
  UpdateObjectName(id_CarName,   oar_NotAcceptable, curBoxNbr, "", "");
 END {ClearObjectsNameOnExit};

 PRIVATE PROCEDURE ClearObjectCodeOnExit();
 BEGIN
  SETEMPTY(ObjectCode, dlg.Controls.Item(id_ObjectCode).Text);
  dlg.Controls.Item(id_ObjectCode).Redraw();
 END {ClearObjectCodeOnExit};

 PRIVATE PROCEDURE idleProc();
 BEGIN
  IF SecondsLeft(DTS_Renew) >= refreshCycle_Renew THEN
   RenewStatusFile(0);
   LoadWeatherForecast();
   CheckReStartKioskRequired(0);
   UpdateClock();
   SetupBackwardButtonText(1);
   IF History[curNestingLevel] = status_Enter THEN
    UpdateInstr();
   END;

   IF History[curNestingLevel] # status_Enter THEN
    IF SecondsLeft(DTS_TimeOut) >= refreshCycle_TimeOut  THEN
     ClosePeriod();
     CloseCalendar();
     klf_SimpleMark("AutoLogOut");
     ClearObjectsNameOnExit();
     ClearObjectCodeOnExit();
     ResetHistory();
     DrawPage();
    END;
   END;
   DTS_Renew:=SYSTIMESTAMP();
  END;
 END {idleProc};

 PRIVATE PROCEDURE SetCurMonth();
 BEGIN
  Memo.UIP_SetIntvl(L_DatTim.Per(SYSDATE()), SYSDATE());
 END {SetCurMonth};

 PRIVATE PROCEDURE SetMemoPeriod();
  VAR
   trgFrom,
   trgUpTo,
   CurDate: DATE;
 BEGIN
  IF prd_CurMonthBeg # L_DatTim.MonthBeg(SYSDATE()) THEN
   trgFrom:=prd_CurMonthBeg;
   trgUpTo:=L_DatTim.MonthEnd(prd_CurMonthBeg);
   CurDate:=prd_CurMonthBeg;
  ELSE
   trgFrom:=prd_CurMonthBeg;
   trgUpTo:=SYSDATE();
   CurDate:=SYSDATE();
  END;
  Memo.UIP_SetIntvl(trgFrom, trgUpTo);
  Memo.UIP_SetCurDate(CurDate);
 END {SetMemoPeriod};

 PRIVATE PROCEDURE PrvMonthReportRequired(): SCAL[2];
  CONST
   defDeadline = 15;
 BEGIN
  RETURN (prd_CurMonthBeg = L_DatTim.MonthBeg(SYSDATE())) &
         (L_DatTim.DAY(SYSDATE()) < defDeadline);
 END {PrvMonthReportRequired};

 PRIVATE PROCEDURE oldMake_wPrvMonthReport(Module: STRING[]; Mode: NUMERIC[0]);
 BEGIN
  CALL(^Module, Mode);
  IF PrvMonthReportRequired() THEN
   RenewStatusFile(1);
   Memo.UIP_SetIntvl(L_DatTim.IncMonth(L_DatTim.Per(SYSDATE()), -1), L_DatTim.Per(SYSDATE())-1);
   CALL(^Module, Mode);
   SetMemoPeriod();
  END;
 END {oldMake_wPrvMonthReport};

 PRIVATE PROCEDURE Make_wPrvMonthReport(ProcName: STRING[]);
 BEGIN
  L_Kiosk.OpenRep();
  CALL(^(ProcName + "()"));
  IF PrvMonthReportRequired() THEN
   RenewStatusFile(1);
   Memo.UIP_SetIntvl(L_DatTim.IncMonth(L_DatTim.Per(SYSDATE()), -1), L_DatTim.Per(SYSDATE())-1);
   CALL(^(ProcName + "()"));
   SetMemoPeriod();
  END;
  L_Kiosk.CloseRep();
 END {Make_wPrvMonthReport};

 PRIVATE PROCEDURE Run_Fuel_Obj_ByStaff();
 BEGIN
  Make_wPrvMonthReport("Fuel_Obj.FuelD_EU");
 END {Run_Fuel_Obj_ByStaff};

 PRIVATE PROCEDURE Run_Fuel_Obj_ByCar();
 BEGIN
  Make_wPrvMonthReport("Fuel_Obj.FuelC_EU");
 END {Run_Fuel_Obj_ByCar};

 PRIVATE PROCEDURE RunReport_wAnyDate(RepId   : STRING[];
                                      ProcName: STRING[]);
  VAR
   D,
   prvD: DATE;
 BEGIN
  GetReportDate(RepId, D);
  prvD:=Memo.ud_cd();
  Memo.UIP_SetCurDate(D);
  TRY
   CALL(^(ProcName + "()"));
  EXCEPT
  ON Exc: Exc_Root DO
   RAISE();
  FINALLY
   Memo.UIP_SetCurDate(prvD);
  END; (* TRY *)
 END {RunReport_wAnyDate};

 PRIVATE PROCEDURE Run_MsStf();
 BEGIN
  RunReport_wAnyDate(L_Kiosk.srid_MSStf, "MS_Staff.MSStf");
 END {Run_MsStf};

 PRIVATE PROCEDURE Run_DrGuS();
 BEGIN
  RunReport_wAnyDate(L_Kiosk.srid_DrGuS, "ManNow.DrGuS_EU");
 END {Run_DrGuS};

 PRIVATE PROCEDURE Run_Tck20();
 BEGIN
  Make_wPrvMonthReport("Tck20.DifTs");
 END {Run_Tck20};

 PRIVATE PROCEDURE intRunReport_wAnyIntvl(BPer, EPer: DATE; ProcName: STRING[]);
 BEGIN
  Memo.UIP_SetIntvl(BPer, EPer);
  TRY
   CALL(^(ProcName + "()"));
  EXCEPT
  ON Exc: Exc_Root DO
   RAISE();
  FINALLY
   SetMemoPeriod();
  END; (* TRY *)
 END {intRunReport_wAnyIntvl};

 PRIVATE PROCEDURE RunReport_wAnyIntvl(RepId   : STRING[];
                                       ProcName: STRING[]);
  VAR
   BPer, EPer: DATE;
 BEGIN
  GetReportSpecificIntvl(RepId, BPer, EPer);
  intRunReport_wAnyIntvl(BPer, EPer, ProcName);
 END {RunReport_wAnyIntvl};

 PRIVATE PROCEDURE Run_BQl02();
 BEGIN
  CALL(Bad_CP.MakeRep_EU());
 END {Run_BQl02};

 PRIVATE PROCEDURE Run_RwsInc();
  VAR
   ProcName: STRING[];
 BEGIN
  IF curStaffIsGuard THEN ProcName:="GuInc";
  ELSE                    ProcName:="DrInc";
  END;
  Make_wPrvMonthReport("TSN_Inc."+ProcName);
 END {Run_RwsInc};

 PRIVATE PROCEDURE Run_Shit04();
  VAR
   ProcName: STRING[];
 BEGIN
  IF curStaffIsGuard THEN ProcName:="Shit04_GrdSingleKsk";
  ELSE                    ProcName:="Shit04_DrvSingleKsk";
  END;
  Make_wPrvMonthReport("Shit04."+ProcName);
 END {Run_Shit04};

 PRIVATE PROCEDURE Run_BegStnOn();
 BEGIN
  L_Kiosk.OpenRep();
  CALL(BegStnOn.Staff_Per());
  L_Kiosk.CloseRep();
 END {Run_BegStnOn};

 PRIVATE PROCEDURE Run_Money();
  VAR
   P: DATE;
 BEGIN
  P:=GetReportSpecificMonth(0);
  Memo.gl_SetCurDate(P);
  L_Kiosk.OpenRep();
  CONFORM(Staff, Man);
  L_Staff.PosToStaffLog(Staff.TSN, Memo.gl_me(), 1);
  CALL(SMPrint.SMPrint_EU());
  L_Kiosk.CloseRep();
 END {Run_Money};

 PRIVATE PROCEDURE Run_KtmSh();
  VAR
   P: DATE;
 BEGIN
  TRY
   P:=GetReportSpecificMonth(1);
   L_Kiosk.OpenRep();
   Memo.gl_SetCurDate(P);
   CALL(CalcDed.CountUp_wKTM());
   IF P = L_DatTim.Per(SYSDATE()) THEN
    Memo.gl_SetCurDate(L_DatTim.IncMonth(P, -1));
    CALL(CalcDed.CountUp_wKTM());
   END;
   L_Kiosk.CloseRep();
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
 END {Run_KtmSh};

 PRIVATE PROCEDURE Run_AvePayPrt();
 BEGIN
  L_Kiosk.OpenRep();
  CALL(AvePay.MakeProtocol_EU());
  L_Kiosk.CloseRep();
 END {Run_AvePayPrt};

 PRIVATE PROCEDURE Run_UIP3();
 BEGIN
  L_Kiosk.OpenRep();
  oldMake_wPrvMonthReport("UIP3", 100);
  L_Kiosk.CloseRep();
 END {Run_UIP3};

 PRIVATE PROCEDURE Run_Rpr06();
 BEGIN
  RunReport_wAnyIntvl(L_Kiosk.crid_RprHs, "Rpr06.RHs00");
 END {Run_Rpr06};

 PRIVATE PROCEDURE Run_RUNBN();
 BEGIN
  RunReport_wAnyIntvl(L_Kiosk.crid_RUNBN, "CarRun.RUNBN");
 END {Run_RUNBN};

 PRIVATE PROCEDURE Run_EDO10();
 BEGIN
  RunReport_wAnyIntvl(L_Kiosk.srid_EDO10, "EDOTSN.EDO10");
 END {Run_EDO10};

 PRIVATE PROCEDURE Run_MhTSN();
 BEGIN
  RunReport_wAnyIntvl(L_Kiosk.srid_MhTSN, "MS_CarR1.MhTSN");
 END {Run_MhTSN};

 PRIVATE PROCEDURE Run_MTBNB();
 BEGIN
  RunReport_wAnyIntvl(L_Kiosk.crid_MTBNB, "MS_CarR1.MTBNB");
 END {Run_MTBNB};

 PRIVATE PROCEDURE Run_MhBNB();
 BEGIN
  RunReport_wAnyIntvl(L_Kiosk.crid_MhBNB, "MS_CarR1.MhBNB");
 END {Run_MhBNB};

 PRIVATE PROCEDURE E_Run_Local(RepId: STRING[]);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_UI.MakeReport);
  IF ~!Local THEN
   Local(RepId);
  ELSE
   L_General.CallUs(0);
  END;
 END {E_Run_Local};

 PRIVATE PROCEDURE SliceSpecialSymbol(S: STRING[]): STRING[];
  CONST
   BegPrintAttr = "";
   EndPrintAttr = "";
 BEGIN
  WHILE Str.Match(S, BegPrintAttr + "*") DO
   S:=Str.Delete(S, 0, Str.Pos(S, EndPrintAttr, 2) + 1);
  END;
  RETURN S;
 END {SliceSpecialSymbol};

 PRIVATE PROCEDURE MakeReport(RepId: STRING[]; Manual: SCAL[2]): STRING[];
  VAR
   BegDTS    : TIMESTAMP;
   pL_Prompt,
   pT_Prompt,
   sH_Prompt,
   sW_Prompt : FLOAT;
   dlgPrompt : DIALOG;
 BEGIN
  IF ~Manual & ThroughCalendar(RepId) THEN
   RETURN "";
  END;
  RenewStatusFile(1);
  klf_Start("MakeRep", kskRepBut.RepName);
  SETEMPTY(ErrorMessage);
  BegDTS:=SYSTIMESTAMP();
  TRY
   pL_Prompt:= 20 * dlg.ScaleX;
   pT_Prompt:= 10 * dlg.ScaleY;
   sW_Prompt:=dlg.StandardClientWidth * 7 / 8;
   sH_Prompt:=100 * dlg.ScaleY;

   dlgPrompt                          :=DIALOG.Create(dlg);
   dlgPrompt.WindowSizeStatus         :=DIALOG.WindowSizeStatus_Restored;
   dlgPrompt.BackgroundPicture        :=L_GUI.SoftLoadPicture(fpn_Get("BackGrnd.jpg"));
   dlgPrompt.BackgroundPicturePosition:=DIALOG.BackgroundPicturePosition_Tile;
   dlgPrompt.WindowStyle              :=DIALOG.WindowStyle_Popup;
   dlgPrompt.StandardClientWidth      :=sW_Prompt;
   dlgPrompt.StandardClientHeight     :=sH_Prompt;

   L_GUI.add_StaticText(dlgPrompt,
                        id_Prompt,
                        "",
                        pL_Prompt, pT_Prompt, sW_Prompt - 2 * pL_Prompt, sH_Prompt - 2 * pT_Prompt,
                        27 * dlg.ScaleX, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);

   dlgPrompt.Prompt        :=dlgPrompt.Controls.Item(0);
   dlgPrompt.Prompt.Visible:=1;
   dlgPrompt.Visible       :=1;
   dlgPrompt.Redraw();

   sorbd_ById(RepId);
   IF    curObject = o_Staff THEN
    SEARCH(Staff, TSN, , curTSN);
   ELSIF curObject = o_Car THEN
    SEARCH(Car, BoxNbr, , curBoxNbr);
   ELSE
    L_General.CallUs(0);
   END;
   APP.Get().NewPrompt('"' + Str.Replace(kskRepBut.Name, "|", " ") + '"');
   dlgPrompt.Prompt.Redraw();
   IF    curPage = L_Kiosk.p_Staff THEN
    IF    RepId = L_Kiosk.srid_StNon        THEN Run_BegStnOn();
    ELSIF RepId = L_Kiosk.srid_Sht04        THEN Run_Shit04();
    ELSIF RepId = L_Kiosk.srid_TBTSN        THEN Run_UIP3();
    ELSIF RepId = L_Kiosk.srid_AnyInc       THEN Run_RwsInc();
    ELSIF RepId = L_Kiosk.srid_DifTs        THEN Run_Tck20();
    ELSIF RepId = L_Kiosk.srid_DrGuS        THEN Run_DrGuS();
    ELSIF RepId = L_Kiosk.srid_EDO10        THEN Run_EDO10();
    ELSIF RepId = L_Kiosk.srid_EDO12        THEN CALL(EDOTSN.EDO12());
    ELSIF RepId = L_Kiosk.srid_StfFl        THEN Run_Fuel_Obj_ByStaff();
    ELSIF RepId = L_Kiosk.srid_MSStf        THEN Run_MsStf();
    ELSIF RepId = L_Kiosk.srid_MhTSN        THEN Run_MhTSN();
    ELSIF RepId = L_Kiosk.srid_MSSMT        THEN CALL(MS_SMOld, 202);
    ELSIF RepId = L_Kiosk.srid_Money        THEN Run_Money();
    ELSIF RepId = L_Kiosk.srid_KtmSh        THEN Run_KtmSh();
    ELSIF RepId = L_Kiosk.srid_AvePayPrt    THEN Run_AvePayPrt();
    ELSIF RepId = L_Kiosk.srid_RWSMP        THEN RunReport_wAnyIntvl(RepId, "RWPrtExp.RWPrtExp");
    ELSIF RepId = L_Kiosk.srid_BQl02        THEN Run_BQl02();
    ELSE                                         E_Run_Local(RepId);
    END;
   ELSIF curPage = L_Kiosk.p_Car THEN
    IF    RepId = L_Kiosk.crid_RUNBN        THEN Run_RUNBN();
    ELSIF RepId = L_Kiosk.crid_CStat        THEN CALL(CarTStat.CStat(2));
    ELSIF RepId = L_Kiosk.crid_RprHs        THEN Run_Rpr06();
    ELSIF RepId = L_Kiosk.crid_Rpr31        THEN RunReport_wAnyIntvl(RepId, "Rpr30.Rpr31");
    ELSIF RepId = L_Kiosk.crid_RprPr        THEN RunReport_wAnyIntvl(RepId, "RprS.MakeProtocol_ByCurrentCar");
    ELSIF RepId = L_Kiosk.crid_CarFl        THEN Run_Fuel_Obj_ByCar();
    ELSIF RepId = L_Kiosk.crid_MTBNB        THEN Run_MTBNB();
    ELSIF RepId = L_Kiosk.crid_MhBNB        THEN Run_MhBNB();
    ELSE                                         E_Run_Local(RepId);
    END;
   ELSE
    L_General.CallUs(0);
   END;
   klf_Stop("MakeRep", kskRepBut.RepName, SecondsLeft(BegDTS), 1);
   dlgPrompt.Visible:=0;
   RETURN L_General.NameConnection(kskRepBut.RepName);
  EXCEPT
  ON Exc: Exc_Root DO
   klf_Stop("MakeRep", kskRepBut.RepName, SecondsLeft(BegDTS), 0);
   L_Kiosk.CloseRep();
   dlgPrompt.Visible:=0;
   IF Manual THEN
    ErrorMessage:=GetErrorMsg(Exc.Description);
   ELSE
    ErrorMessage:=Exc.MsgOriginalText;
   END;
   RETURN "";
  END; (* TRY *)
 END {MakeReport};

 PRIVATE PROCEDURE ShowReport(trgNbr: NUMERIC[0]);
  VAR
   c               : OBJECT;
   Dummy           : SCAL[2];
   LineLength      : NUMERIC[0];
   S, Text,
   FullReportName  : STRING[];
 BEGIN
  sorbd_ByNbr(trgNbr);
  FullReportName:=MakeReport(kskRepBut.Id, 1);
  IF ~!FullReportName THEN
   PROMPT("ᬮ ");
   L_General.CallUs(FIO.Exists(FullReportName));
   c:=dlg.Controls.Item(id_ReportText);
   LineLength:=0;
   FIO.Open(Src, FullReportName, , Input);
   (*ய᪠  ப  㦥 ଠ樥 REP*)
   Dummy:=FIO.RdStr(Src, S);
   WHILE FIO.RdStr(Src, S) DO
    LineLength:=Math.Max(LineLength, Str.Length(S));
   END;
   FIO.Close(Src);

   IF    LineLength <= 78 THEN
    LineLength:=78;
   ELSIF LineLength <= 100 THEN
    LineLength:=100;
   END;
   c.MaxCharactersInRow :=LineLength;
   c.VerticalAlignment  :=CONTROL.VerticalAlignment_Top;
   c.HorizontalAlignment:=CONTROL.HorizontalAlignment_Center;
   c.VerticalScroll     :=1;
   c.Style.Font.Face    :=L_GUI.fn_LucidaConsole;

   Text:=L_Str.CRLF;
   FIO.Open(Src, FullReportName, , Input);
   WHILE FIO.RdStr(Src, S) DO
    Text:=Text + SliceSpecialSymbol(S) + L_Str.CRLF;
   END;
   FIO.Close(Src);
   c.Text:=Text;
   SetCurStatus(status_ViewReport);
  END;
 END {ShowReport};

 PRIVATE PROCEDURE MakeHTML(trgId: STRING[]): STRING[];
  VAR
   HTMLName,
   FullHTMLPath: STRING[];
 BEGIN
  sorbd_ById(trgId);
  HTMLName    :=kskRepBut.RepName;
  FullHTMLPath:=L_FIO.tf_GetFullPath(kskRepBut.RepName + L_Str.FixedIntStr(APP.Get().MyConnection.ConnectionNo, 4), "HTM");
  L_FIO.FileCopy(L_FIO.rf_GetFullFileName(FIO.BuildPath(HTMLName, "HTM")), FullHTMLPath);
  klf_Mark("ShowHTML", HTMLName, 0, r_Normal);
  RETURN FullHTMLPath;
 END {MakeHTML};

 PRIVATE PROCEDURE ShowHTML(trgNbr: NUMERIC[0]);
  VAR
   c: OBJECT;
 BEGIN
  sorbd_ByNbr(trgNbr);
  c    :=dlg.Controls.Item(id_ReportAsHtml);
  c.Url:=MakeHTML(kskRepBut.Id);
  c.Redraw();
  SetCurStatus(status_ViewHtml);
 END {ShowHTML};

 PRIVATE PROCEDURE srp_AttachMakedRep(FullReportName: STRING[]; VAR Attachments: STRING[]);
  VAR
   S,
   ReportName,
   PreparedReportName: STRING[];
 BEGIN
  ReportName        :=L_FIO.effp_FileName_woExt(FullReportName);
  PreparedReportName:=L_FIO.tf_GetFullPath(ReportName, "TXT");
  FIO.Open(Prpd, PreparedReportName, , Create);
  FIO.SetCP(Prpd, FIO.CP_WindowsRussian);
  FIO.Open(Src, FullReportName, , Input);
  WHILE FIO.RdStr(Src, S) DO
   FIO.WrStr(Prpd, SliceSpecialSymbol(S));
   FIO.WrLn(Prpd);
  END; (* WHILE FIO.RdStr(Src, S)...*)
  FIO.Close(Src);
  FIO.Close(Prpd);
  Attachments:=Attachments + PreparedReportName + "|";
 END {srp_AttachMakedRep};

 PRIVATE PROCEDURE MarkReportPacketSend();
 BEGIN
  ADD(spLog, TSN, , curTSN, curBoxNbr);
  spLog.Date:=SYSDATE();
  REPLACE(spLog);
 END {MarkReportPacketSend};

 PRIVATE PROCEDURE SendReportPacket();
  VAR
   BegDTS         : TIMESTAMP;
   trgStatus      : tStatus;
   MaxLength      : NUMERIC[0];
   Message,
   Subject,
   Attachments,
   CurManEMail,
   FullReportName,
   SingleRepResult: STRING[];
   DeliveryContact: L_EMail.tContact;
 BEGIN
  IF ~SEARCH(spLog, TSN, curTSN, curBoxNbr) | (spLog.Date # SYSDATE()) THEN
   TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    TRY
     DeliveryContact:=E_GetDeliveryContact(0);
     CurManEMail    :=P_Man.GetHomeContactInf(curMan, SYSDATE(), P_Man.ci_EMail);
     IF !CurManEMail THEN
      CurManEMail:=P_Man.GetWorkContactInf(curMan, SYSDATE(), P_Man.ci_EMail);
     END;
    EXCEPT
    ON Exc: Exc_Root DO
     SETEMPTY(CurManEMail);
    END; (* TRY *)

    IF ~!CurManEMail THEN
     BegDTS:=SYSTIMESTAMP();
     klf_SimpleMark("BegSendPck");
     IF    curPage = L_Kiosk.p_Staff THEN
      Subject:=" ⮢ ";
     ELSIF curPage = L_Kiosk.p_Car THEN
      SEARCH(Car, BoxNbr, , curBoxNbr);
      Subject:=" ⮢  ࠭ᯮ⭮ । " + curBoxNbr;
     ELSE
      L_General.CallUs(0);
     END;
     MaxLength:=0;
     SELECT(kskRepBut, Id, , curPage, L_Kiosk.bt_Report);
     WHILE OCCURE(kskRepBut) DO
      IF (kskRepBut.RepType = L_Kiosk.rt_REP) & kskRepBut.Enable THEN
       MaxLength:=Math.Max(Str.Length(Str.Replace(kskRepBut.RepName + " " + kskRepBut.Name, "|", " ")), MaxLength);
      END;
      NEXT(kskRepBut);
     END; (* WHILE OCCURE(kskRepBut) ... *)

     SETEMPTY(Attachments, Message);
     SELECT(kskRepBut, Id, , curPage, L_Kiosk.bt_Report);
     WHILE OCCURE(kskRepBut) DO
      IF (kskRepBut.RepType = L_Kiosk.rt_REP) & kskRepBut.Enable THEN
       SAVE(kskRepBut);
       FullReportName:=MakeReport(kskRepBut.Id, 0);
       RESTORE(kskRepBut);
       SingleRepResult:=kskRepBut.RepName + " " + kskRepBut.Name;
       IF ~!FullReportName THEN
        srp_AttachMakedRep(FullReportName, Attachments);
       ELSE
        SingleRepResult:=Str.Align(SingleRepResult, MaxLength, LEFT) + "訡: " + ErrorMessage;
       END;
       SingleRepResult:=SingleRepResult + L_Str.CRLF;
       Message:=Message + Str.Replace(Str.Replace(SingleRepResult, "|", " "), L_Str.CRLF, " ") + L_Str.CRLF;
      END;
      NEXT(kskRepBut);
     END; (* WHILE OCCURE(kskRepBut) ... *)

     L_APEMl.EasySend(L_EMail.AssembleContact(L_Str.ShortName(curManName), CurManEMail),
                      DeliveryContact,
                      Subject,
                      Attachments,
                      Message);

     klf_Mark("EndSendPck", "", SecondsLeft(BegDTS), r_Normal);
     IF    curPage = L_Kiosk.p_Staff THEN
      klf_SimpleMark("LogOut");
      trgStatus   :=status_Enter;
      ErrorMessage:="";
     ELSIF curPage = L_Kiosk.p_Car THEN
      trgStatus   :=status_ShowInformMessage;
      ErrorMessage:=Subject + " ନ஢  ࠢ   EMail";
     ELSE
      L_General.CallUs(0);
     END;
     MarkReportPacketSend();
    ELSE
     klf_SimpleMarkError("NoEmailForSendPck");
     trgStatus   :=status_ShowErrorMessage;
     ErrorMessage:="   ।  㪠  襣 ⮢ 騪. " +
                   "|" +
                   "᫨   ᯮ짮  ନ஢  ࠢ " +
                   " ⮢  ᢮ e-mail,  室   ᮮ⢥騩 ⤥ " +
                   " ᥭ    । ஭  襣 ⮢ 騪";
    END;
   EXCEPT
   ON Exc: Exc_Root DO
    klf_SimpleMarkError("SendPck");
    trgStatus   :=status_ShowErrorMessage;
    ErrorMessage:=GetErrorMsg(Exc.Description);
   END; (* TRY *)
  ELSE
   trgStatus   :=status_ShowErrorMessage;
   ErrorMessage:="ࠢ  ⮢     ࠧ  ." +
                 L_Str.CRLF +
                 L_Str.CRLF +
                 "  㦥  ";
  END;
  SetCurStatus(trgStatus);
 END {SendReportPacket};

 PRIVATE PROCEDURE DoAction(trgNbr: NUMERIC[0]);
 BEGIN
  sorbd_ByNbr(trgNbr);
  IF (kskRepBut.Id = L_Kiosk.srid_SendRepPck) | (kskRepBut.Id = L_Kiosk.crid_SendRepPck) THEN
   SendReportPacket();
  ELSE
   L_General.CallUs(0);
  END;
 END {DoAction};

 PRIVATE PROCEDURE PrepareInputPINCode(trgNbr: NUMERIC[0]; Operation: STRING[]);
  VAR
   ReportName: STRING[];
 BEGIN
  EncryptPIN:=P_Man.GetManProSoft(curMan, SYSDATE(), P_Man.P_PINCode);
  IF !EncryptPIN THEN
   ErrorMessage:="   ।|" +
                 " 㪠 |" +
                 "ᮭ 䨪樮  (-),|" +
                 "室  ᬮ 䨤樠쭮 ଠ樨.|";
   IF E_CheckPINCode_WhenInputTSN() THEN
    ErrorMessage:=ErrorMessage +
                 " ᯮ짮 ଠ樮 ᪠|" +
                 " 室   ᮮ⢥騩 ⤥|" +
                 " ᥭ    । 襣 -";
   ELSE
    ErrorMessage:=ErrorMessage +
                 "᫨   ᯮ짮  ᬮ ⮩ ଠ樨,|" +
                 " 室   ᮮ⢥騩 ⤥|" +
                 " ᥭ    । 襣 -";
   END;
   IF ~!curGroupButId THEN
    IF !trgNbr &
       (GetReportAmountByGroup(curPage, curGroupButId) = 1) &
       IsSpecificGroupButton(curGroupButId) THEN
     trgNbr:=0;
    END;
    IF ~!trgNbr THEN
     sorbd_ByNbr(trgNbr);
     ReportName:=kskRepBut.RepName;
    ELSE
     ReportName:=curGroupButId;
    END;
   ELSE
    SETEMPTY(ReportName);
   END;

   klf_Mark(Operation, ReportName, 0, r_NoPIN);
   SetCurStatus(status_ShowErrorMessage);
  ELSE
   aa_Nbr:=trgNbr;
   SetCurStatus(status_InputPIN);
  END;
 END {PrepareInputPINCode};

 PRIVATE PROCEDURE IsPushGroupButton(trgNbr: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN !trgNbr;
 END {IsPushGroupButton};

 PRIVATE PROCEDURE GetReportAmountByGroup(trgPage, trgGroupId: STRING[]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  SAVE(kskRepBut);
  SETZERO(Result);
  SELECT(kskRepBut, kskRepBut, , trgPage, L_Kiosk.bt_Report, trgGroupId);
  WHILE OCCURE(kskRepBut) DO
   INC(Result);
   NEXT(kskRepBut);
  END; (* WHILE OCCURE(kskRepBut) ... *)
  RESTORE(kskRepBut);
  RETURN Result;
 END {GetReportAmountByGroup};

 PRIVATE PROCEDURE AccessGranted(trgNbr: NUMERIC[0]): SCAL[2];
 BEGIN
  IF AuthorizationRequired(curPage, trgNbr, curGroupButId) THEN
   PrepareInputPINCode(trgNbr, "MakeRep");
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {AccessGranted};

 PRIVATE PROCEDURE ProceedButtonClick(trgNbr: NUMERIC[0]; HasAccess: SCAL[2]);
 BEGIN
  IF HasAccess | AccessGranted(trgNbr) THEN
   IF IsPushGroupButton(trgNbr) THEN
    IF (GetReportAmountByGroup(curPage, curGroupButId) = 1) & IsSpecificGroupButton(curGroupButId) THEN
     trgNbr:=0;
    ELSE
     SetCurStatus(status_ViewRepBut);
    END;
   END;
   IF ~!trgNbr THEN
    sorbd_ByNbr(trgNbr);
    TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
     IF    kskRepBut.RepType = L_Kiosk.rt_REP THEN
      ShowReport(trgNbr);
     ELSIF kskRepBut.RepType = L_Kiosk.rt_HTML THEN
      ShowHTML(trgNbr);
     ELSIF kskRepBut.RepType = L_Kiosk.rt_Act THEN
      DoAction(trgNbr);
     ELSE
      L_General.CallUs(0);
     END;
    EXCEPT
    ON Exc: Exc_Root DO
     ErrorMessage:=GetErrorMsg(Exc.Description);
    END; (* TRY *)
  
    IF ~!ErrorMessage THEN
     SetCurStatus(status_ShowErrorMessage);
    END;
   END;
  END;
 END {ProceedButtonClick};

 PRIVATE PROCEDURE GatherStaff_ByMan(trgMan: LIKE(Man.Man));
 BEGIN
  SELECT(StfLs, Contract);
  REMSEL(StfLs);

  SELECT(Staff, Man, , trgMan);
  WHILE OCCURE(Staff) DO
   SAVE(Staff);
   IF AccessStaff(Staff.TSN) = oar_Done THEN
    HISTCONF(Math.Max(Staff.BegDate, SYSDATE()), Staff, StaffLog, Officer, Post);
    StfLs.Contract:=Staff.Contract;
    StfLs.TSN     :=Staff.TSN;
    StfLs.Name    :=StfLs.TSN + " " + Post.Name;
    INSERT(StfLs);
   END;
   RESTORE(Staff);
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {GatherStaff_ByMan};

 PRIVATE PROCEDURE PrepareStaffListByProximityCard(VAR gccOn: SCAL[2];
                                                   gcc_Prepare, gcc_CardCodeIdle, gcc_Finish: PROC): SCAL[2];
  VAR
   i,
   Result,
   CardCode : NUMERIC[0];
 BEGIN
  IF ~gccOn THEN
   gcc_Prepare(L_ACS.ct_Wiegand26);
   gccOn:=1;
  END;

  i:=0;
  SETEMPTY(CardCode);
  LOOP
   Result:=0;
   TRY
    Result:=gcc_CardCodeIdle();
   EXCEPT
   ON Exc: Exc_Root DO
    IF L_General.IsOurEngineeringCopy() &
       L_StdFrm.Alternative(Exc.MsgOriginalText + "||     ?") THEN
     CardCode:=P_Man.ManualGetCardCode("", "INFORM");
     Result:=1;
    ELSE
     RAISE();
    END;
   END; (* TRY *)

   IF    (Result = 1) THEN  (*⠫ *)
 (*SHUR: 뢠 뢠⥫ ᫥     .    *)
 (* 뢠⥫ PERCo  ନ쭮  ASB 㤥    䨪 *)
    CardCode:=P_Man.gcc_Readout();
    gcc_Finish();
    gccOn:=0;
    EXIT;
   ELSIF (i >= 100) THEN
    EXIT;
   END;
   INC(i);
   RenewStatusFile(0);
   UpdateClock();
   SLEEP(0.1);
  END; (* LOOP *)

  IF ~!CardCode THEN
   TRY
    RENEWDATALAYER();
    SELECT(StfLs, Contract);
    REMSEL(StfLs);
    IF SEARCH(Man, Man, P_Man.GetSpeedSearchResults(SYSDATE(), P_Man.P_Pass, L_Str.IntStr(CardCode))) THEN
     GatherStaff_ByMan(Man.Man);
    END;
   EXCEPT
   END; (* TRY *)
   curObject:=o_Staff;
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {PrepareStaffListByProximityCard};

 PRIVATE PROCEDURE sgb_Set(trgName, trgPictName: STRING[]; trgAuthReq: SCAL[2]);
 BEGIN
  L_Kiosk.SetAnyKioskButton(L_Kiosk.p_Staff, L_Kiosk.bt_Group, curGroupButId, "", trgName, "", "", trgPictName + ".gif", EMPTYOF(L_Kiosk.tRepType), trgAuthReq, 1);
 END {sgb_Set};

 PRIVATE PROCEDURE ext_srb_Set(trgName, trgRepName: STRING[]; trgAuthReq, trgEnable: SCAL[2]; trgRepHandl, trgId: STRING[]; trgRepType: L_Kiosk.tRepType);
 BEGIN
  L_Kiosk.SetAnyKioskButton(L_Kiosk.p_Staff, L_Kiosk.bt_Report, trgId, curGroupButId, trgName, trgRepName, trgRepHandl, "", trgRepType, trgAuthReq, trgEnable);
 END {ext_srb_Set};

 PRIVATE PROCEDURE srb_Set(trgName, trgRepName: STRING[]; trgAuthReq, trgEnable: SCAL[2]; trgRepHandl, trgId: STRING[]);
 BEGIN
  ext_srb_Set(trgName, trgRepName, trgAuthReq, trgEnable, trgRepHandl, trgId, L_Kiosk.rt_REP);
 END {srb_Set};

 PRIVATE PROCEDURE cgb_Set(trgName, trgPictName: STRING[]; trgAuthReq: SCAL[2]);
 BEGIN
  L_Kiosk.SetAnyKioskButton(L_Kiosk.p_Car, L_Kiosk.bt_Group, curGroupButId, "", trgName, "", "", trgPictName + ".gif", EMPTYOF(L_Kiosk.tRepType), trgAuthReq, 1);
 END {cgb_Set};

 PRIVATE PROCEDURE ext_crb_Set(trgName, trgRepName: STRING[]; trgAuthReq, trgEnable: SCAL[2]; trgRepHandl, trgId: STRING[]; trgRepType: L_Kiosk.tRepType);
 BEGIN
  L_Kiosk.SetAnyKioskButton(L_Kiosk.p_Car, L_Kiosk.bt_Report, trgId, curGroupButId, trgName, trgRepName, trgRepHandl, "", trgRepType, trgAuthReq, trgEnable);
 END {ext_crb_Set};

 PRIVATE PROCEDURE crb_Set(trgName, trgRepName: STRING[]; trgAuthReq, trgEnable: SCAL[2]; trgRepHandl, trgId: STRING[]);
 BEGIN
  ext_crb_Set(trgName, trgRepName, trgAuthReq, trgEnable, trgRepHandl, trgId, L_Kiosk.rt_REP);
 END {crb_Set};

 PRIVATE PROCEDURE Get_pT_AnyRepBut(ButtonNbr: NUMERIC[0]): NUMERIC[0];
 BEGIN
  RETURN pT_RepBut + (sH_RepBut + sH_CommonShift) * ButtonNbr;
 END {Get_pT_AnyRepBut};

 PRIVATE PROCEDURE Get_pL_AnyRepBut(ColumnNbr: NUMERIC[0]): NUMERIC[0];
 BEGIN
  RETURN pL_RepBut + (sW_RepBut + sW_CommonShift) * ColumnNbr
 END {Get_pL_AnyRepBut};

 PRIVATE PROCEDURE cd_PutGroupButtonsSeries(Page: STRING[]);
  VAR
   ColumnNbr, ButtonNbr: NUMERIC[0];
 BEGIN
  SETZERO(ColumnNbr, ButtonNbr);
  SELECT(kskRepBut, kskRepBut, , Page, L_Kiosk.bt_Group);
  WHILE OCCURE(kskRepBut) DO
   IF ColumnNbr < rb_Column_Amnt THEN
    IF ButtonNbr < rb_ButtonsInColumn_Amnt THEN
     put_GroupButton(Page, Get_pL_AnyRepBut(ColumnNbr), Get_pT_AnyRepBut(ButtonNbr));
     INC(ButtonNbr);
     NEXT(kskRepBut);
    ELSE
     INC(ColumnNbr);
     SETZERO(ButtonNbr);
    END;
   ELSE
    L_General.CallUs(L_General.IsOurSite());
    LAST(kskRepBut);
    NEXT(kskRepBut);
   END;
  END; (* WHILE OCCURE(kskRepBut) ... *)
 END {cd_PutGroupButtonsSeries};

 PRIVATE PROCEDURE cd_PutRepButtonsSeries();
  VAR
   ButtonNbr: NUMERIC[0];
 BEGIN
  L_GUI.put_Button(dlg, p_RepButtons, id_GroupBut, "",
                   Get_pL_AnyRepBut(0), Get_pT_AnyRepBut(0), sW_RepBut, sH_RepBut,
                   L_GUI.fs_StandartButton, L_GUI.fn_Default,
                   EMPTYOF(PROC));
  dlg.Controls.Item(id_GroupBut).Enable:=0;

  ButtonNbr:=0;
  WHILE ButtonNbr < rb_TotalAmnt DO
   L_GUI.put_Button(dlg, p_RepButtons, "pb_Report_" + L_Str.IntStr(ButtonNbr), "",
                    Get_pL_AnyRepBut(ButtonNbr DIV rb_ButtonsInColumn_Amnt + 1),
                    Get_pT_AnyRepBut(ButtonNbr MOD rb_ButtonsInColumn_Amnt),
                    sW_RepBut,
                    sH_RepBut,
                    L_GUI.fs_StandartButton, L_GUI.fn_Default,
                    PROCREF(onClick_Report));
   INC(ButtonNbr);
  END;
 END {cd_PutRepButtonsSeries};

 PRIVATE PROCEDURE cd_PutInputDialogButton(Id, Text: STRING[]; Left, Top, Width, Height: FLOAT; FontSize: NUMERIC[0]);
 BEGIN
  L_GUI.put_Button(dlg, p_Input, Id, Text,
                   Left, Top, Width, Height,
                   FontSize, L_GUI.fn_Default,
                   PROCREF(OnClick_InputDigit));
  dlg.Controls.Item(Id).Style.Font.Face:=L_GUI.fn_Tahoma;
 END {cd_PutInputDialogButton};

 PUBLIC PROCEDURE DefineReportButtons();
  VAR
   Local            : PROC;
   StockExists,
   SendRepPckAllowed: SCAL[2];
 BEGIN
  StockExists      :=L_Env.MathAcntLev(SYSDATE()) >= L_MathR.mal_Recount_ActiveSMMove;
  SendRepPckAllowed:=P_OwnData.UseDedicatedLine(SYSDATE()) & ~!E_GetDeliveryContact(1);

  curGroupButId:=L_Kiosk.gsrbid_RWayS;
  sgb_Set("⥢ ",                                 "SHT04",   0);
  srb_Set("浪",                                    "STNON",   0, L_Way.E_BegRWSLev(SYSDATE()) = L_Way.brwsl_Active, "R", L_Kiosk.srid_StNon);
  srb_Set("'' ࠡ⪨",                            "SHT04",   0, 1, "R", L_Kiosk.srid_Sht04);
  srb_Set("⮪ ࠡ⪨",                           "RWAYA",   0, 1, "R", L_Kiosk.srid_RWSMP);
  srb_Set("襭|ॣ୮",                        "BQL02",   0, 1, "R", L_Kiosk.srid_BQl02);

  curGroupButId:=L_Kiosk.gsrbid_Income;
  sgb_Set("ࠡ⪠, 窠",                            "DRINC",   0);
  srb_Set("ࠡ⪠",                                     "TBTSN",   0, 1, "R", L_Kiosk.srid_TBTSN);
  srb_Set("窠 (஡)",                            "DRINC",   0, 1, "R", L_Kiosk.srid_AnyInc);
  srb_Set("窠  ",                                "DIFTS",   0, L_Way.E_TckRcLevel(SYSDATE()) # L_TRS.il_None, "R", L_Kiosk.srid_DifTs);

  curGroupButId:=L_Kiosk.gsrbid_Money;
  sgb_Set("௫",                                      "MONEY",   1);
  srb_Set(" ",                                "MONEY",   0, 1, "Mon",   L_Kiosk.srid_Money);
  srb_Set("⮪   ⠡",                    "KtmSh",   0, 1, "ktm_R", L_Kiosk.srid_KtmSh);
  srb_Set("᪠, 쭨  .",                     "AvPay",   0, 1, "R", L_Kiosk.srid_AvePayPrt);

  curGroupButId:=L_Kiosk.gsrbid_Fuel;
  sgb_Set("-ᬠ|ਠ",                    "FLOBJ",   0);
  srb_Set("室|",                                    "FLOBJ",   0, 1, "T", L_Kiosk.srid_StfFl);

  curGroupButId:=L_Kiosk.gsrbid_Math;
  sgb_Set("ਠ|業",                         "MHTSN",   0);
  srb_Set("७ 業",                            "MSStf",   0, StockExists, "R", L_Kiosk.srid_MSStf);
  srb_Set("",                                      "MHTSN",   0, StockExists, "R", L_Kiosk.srid_MhTSN);
  srb_Set("  ப 㦡",                          "MSSMT",   0, StockExists, "R", L_Kiosk.srid_MSSMT);

  curGroupButId:=L_Kiosk.gsrbid_EDOrder;
  sgb_Set("ਪ  ᢥ",                            "EDOTN",   0);
  srb_Set("ਪ  襭|樯",               "EDO10",   0, 1, "R", L_Kiosk.srid_EDO10);
  srb_Set(" ਪ| ७",                      "EDO12",   1, 1, "R", L_Kiosk.srid_EDO12);
  srb_Set("  ࠡ⭨",                          "DRGUS",   0, 1, "R", L_Kiosk.srid_DrGuS);

  curGroupButId:=L_Kiosk.gsrbid_Docs;
  sgb_Set("㬥",                                     "SPINF",   0);
  ext_srb_Set(" ",                            "CNSTN",   0, 1, "", L_Kiosk.srid_Constitution, L_Kiosk.rt_HTML);

  curGroupButId:=L_Kiosk.gsrbid_Service;
  sgb_Set("ࢨ",                                        "SENDPCK", 0);
  ext_srb_Set("ࠢ  |஭ |" +
              "   ᪠",                         "SENDPCK", 0, SendRepPckAllowed, "", L_Kiosk.srid_SendRepPck, L_Kiosk.rt_Act);


  curGroupButId:=L_Kiosk.gcrbid_Fuel;
  cgb_Set("-ᬠ|ਠ",                    "FLOBJ",   0);
  crb_Set("室|",                                    "FLOBJ",   0, 1, "T", L_Kiosk.crid_CarFl);

  curGroupButId:=L_Kiosk.gcrbid_Math;
  cgb_Set("ਠ|業",                         "MHBNB",   0);
  crb_Set("",                                      "MHBNB",   0, StockExists, "R", L_Kiosk.crid_MhBNB);
  crb_Set(" ॣ⮢",                            "MTBNB",   0, StockExists, "R", L_Kiosk.crid_MTBNB);

  curGroupButId:=L_Kiosk.gcrbid_Run;
  cgb_Set("஡",                                        "RUNBN",   0);
  crb_Set("஡",                                        "RUNBN",   0, 1, "R", L_Kiosk.crid_RUNBN);

  curGroupButId:=L_Kiosk.gcrbid_Stat;
  cgb_Set("孨᪮|ﭨ",                         "CSTAT",   0);
  crb_Set("ࠢ",                                       "CSTAT",   0, 1, "R", L_Kiosk.crid_CStat);
  crb_Set(" ६⮢",                              "RHS00",   0, L_Rpr.RprLev(SYSDATE()) # L_Rpr.rprl_None, "R", L_Kiosk.crid_RprHs);
  crb_Set("室 |  ",                            "Rpr31",   0, L_General.GetAPSiteNumber() = 84,          "R", L_Kiosk.crid_Rpr31);
  crb_Set("⮪ ࠡ⪨ ",                       "RprPr",   0, 1, "R", L_Kiosk.crid_RprPr);

  curGroupButId:=L_Kiosk.gcrbid_Service;
  cgb_Set("ࢨ",                                        "SENDPCK", 0);
  ext_crb_Set("ࠢ  |஭ ",     "SENDPCK", 0, SendRepPckAllowed, "", L_Kiosk.crid_SendRepPck, L_Kiosk.rt_Act);
  SETEMPTY(curGroupButId);

  Local:=PROCREF(E_UI.DefineAdditionalReportButtons);
  IF ~!Local THEN
   Local();
  END;
  cd_PutGroupButtonsSeries(L_Kiosk.p_Staff);
  cd_PutGroupButtonsSeries(L_Kiosk.p_Car);
  cd_PutRepButtonsSeries();
 END {DefineReportButtons};

 PRIVATE PROCEDURE HasWLM(D: DATE): SCAL[2];
 BEGIN
  SELECT(WayLMen, TSN, , curTSN, D);
  WHILE OCCURE(WayLMen) DO
   CONFORM(WayLMen, RWayS);
   IF RWayS.Status = L_Way.rwsStat_Rated THEN
    RETURN 1;
   END;
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
  RETURN 0;
 END {HasWLM};

 PRIVATE PROCEDURE clnd_GetDateButtonEnableState(D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  sorbd_ByNbr(GetNbrFromButtonId(CalendarRepId));
  IF kskRepBut.Id = L_Kiosk.srid_RWSMP THEN
   Result:=SELECT(RWayS, sTSN, L_Way.rwsStat_Rated, curTSN, D) | HasWLM(D);
  ELSIF kskRepBut.Id = L_Kiosk.crid_RprPr THEN
   SEARCH(Car, BoxNbr, , curBoxNbr);
   SELECT(RprS, CUCopy, , Car.CUCopy, D);
   LOOP
    IF ~OCCURE(RprS) THEN
     Result:=0;
     EXIT;
    ELSIF RprS.Status = L_Rpr.ms_Done THEN
     Result:=1;
     EXIT;
    END;
    NEXT(RprS);
   END;
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {clnd_GetDateButtonEnableState};

 PRIVATE PROCEDURE ChangeReportButtonsText();
  VAR
   ButtonNbr: NUMERIC[0];
   rb       : PUSH_BUTTON;
 BEGIN
  ButtonNbr:=0;
  WHILE ButtonNbr < rb_TotalAmnt DO
   rb:=dlg.Controls.Item("pb_Report_" + L_Str.IntStr(ButtonNbr));
   IF rb.Visible THEN
    sorbd_ByNbr(ButtonNbr);
    IF OCCURE(kskRepBut) THEN
     rb.Text:=GetFullReportButtonText(kskRepBut.Name);
     rb.Redraw();
    END;
   END;
   INC(ButtonNbr);
  END;
 END {ChangeReportButtonsText};

 PRIVATE PROCEDURE clnd_UpdateControls();
  VAR
   Title     : STATIC_TEXT;
   btnDate   : PUSH_BUTTON;
   D, sysD   : DATE;
   bc_CurMonth,
   bc_OthrMonth: RGBCOLOR;
   i         : SCAL[clnd_btnAmount];
 BEGIN
  bc_CurMonth :=RGBCOLOR.Create(128, 256, 64);
  bc_OthrMonth:=RGBCOLOR.Create(0, 0, 0);
  Title       :=clnd.Controls.Item(id_clndCurMonthName);
  Title.Text  :=MonthAndYearStr(clnd_CurPer, 0);

  clnd.Controls.Item(id_clndNxtMonth).Enable:=clnd_CurPer < L_DatTim.Per(SYSDATE());

  D:=L_DatTim.MonthBeg(clnd_CurPer) - (clnd_btnAmount - L_DatTim.MonthLen(clnd_CurPer)) DIV 2;
  INC(D, L_DatTim.wd_Sun - L_DatTim.WEEKDAY(D) + 1);
  IF D >= clnd_CurPer THEN
   DEC(D, L_DatTim.wd_DaysAmount);
  END;
  clnd_From:=D;
  sysD     :=SYSDATE();
  FOR_EACH i DO
   btnDate:=clnd.Controls.Item(clnd_DatePrefix + i);
   IF D = clnd_ChosenDate THEN
    btnDate.Text:="{" + FLDTOSTR(D, "D") + "}";
   ELSE
    btnDate.Text:=FLDTOSTR(D, "D");
   END;
   IF L_DatTim.MONTH(D) = L_DatTim.MONTH(clnd_CurPer) THEN
    L_GUI.SetControlFgColor(btnDate, bc_CurMonth);
    btnDate.Enable         :=clnd_GetDateButtonEnableState(D);
    btnDate.Style.Font.Size:=fs_ClndDayBtn * dlg.ScaleY;
   ELSE
    L_GUI.SetControlFgColor(btnDate, bc_OthrMonth);
    btnDate.Enable         :=D <= L_DatTim.MonthEnd(sysD);
    btnDate.Style.Font.Size:=fs_ClndDayBtn * 0.70 * dlg.ScaleY;
   END;
   INC(D);
  END;
  clnd.Redraw();
  DTS_TimeOut:=SYSTIMESTAMP();

  ChangeReportButtonsText();
 END {clnd_UpdateControls};

 PRIVATE PROCEDURE ShowCalendar(FirstPass: SCAL[2]);
 BEGIN
  IF FirstPass THEN
   SETEMPTY(clnd_ChosenDate);
   clnd_CurPer:=prd_CurMonthBeg;
   clnd_UpdateControls();
  END;
  clnd.Visible:=1;
  clnd.Redraw();

  WHILE clnd.Visible DO
   idleProc();
   clnd.Wait(0.1);
  END;
 END {ShowCalendar};

 PRIVATE PROCEDURE HideCalendar();
 BEGIN
  clnd.Visible:=0;
  clnd.Redraw();
 END {HideCalendar};

 PRIVATE PROCEDURE OnClick_CalendarDate(SLF: OBJECT);
  VAR
   curChosenDate: DATE;
 BEGIN
  curChosenDate:=clnd_From + STRTOFLD(Str.Delete(SLF.Id, 0, Str.Length(clnd_DatePrefix)), NUMERIC, "N0");
  IF L_DatTim.MONTH(clnd_CurPer) = L_DatTim.MONTH(curChosenDate) THEN
   clnd_ChosenDate:=curChosenDate;
   HideCalendar();
   Memo.UIP_SetCurDate(clnd_ChosenDate);
   ProceedButtonClick(GetNbrFromButtonId(CalendarRepId), 0);
  END;
  clnd_CurPer:=L_DatTim.Per(curChosenDate);
  clnd_UpdateControls();
 END {OnClick_CalendarDate};

 PRIVATE PROCEDURE OnCalendarClose(SLF: OBJECT);
 BEGIN
  CloseCalendar();
 END {OnCalendarClose};

 PRIVATE PROCEDURE OnClick_CalendarClose(SLF: OBJECT);
 BEGIN
  CloseCalendar();
 END {OnClick_CalendarClose};

 PRIVATE PROCEDURE clnd_ChangeMonth(Direction: NUMERIC[0]);
 BEGIN
  clnd_CurPer:=L_DatTim.IncMonth(clnd_CurPer, Direction);
  clnd_UpdateControls();
 END {clnd_ChangeMonth};

 PRIVATE PROCEDURE OnClick_PrvMonth(SLF: OBJECT);
 BEGIN
  clnd_ChangeMonth(-1);
 END {OnClick_PrvMonth};

 PRIVATE PROCEDURE OnClick_NxtMonth(SLF: OBJECT);
 BEGIN
  clnd_ChangeMonth(+1);
 END {OnClick_NxtMonth};

 PRIVATE PROCEDURE OnClick_clndToday(SLF: OBJECT);
 BEGIN
  clnd_CurPer:=L_DatTim.Per(SYSDATE());
  HideCalendar();
 END {OnClick_clndToday};

 PRIVATE PROCEDURE CreateCalendar();
  CONST
   sH_Title           = 50;
   sH_WeekDay         = 30;
   HorizontalPadding  = 3;
   VerticalPadding    = 3;
   sW_DayBtn          = 90;
   sH_DayBtn          = 80;
   sW_SpaceBtwButtons = 2;

   sW_TodayBtn = sW_DayBtn * 3;
   sH_TodayBtn = sH_DayBtn * 3/4;

   clnd_WDPrefix   = "wd_";

   fs_ClndTitle   = 36;
   fs_ClndWeekDay = 24;
   fs_Today       = 30;
  VAR
   i              : SCAL[clnd_btnAmount];
   Col            : SCAL[clnd_btnColumn];
   Item           : CONTROL;
   bkgnd          : STATIC_TEXT;
   sH_Clnd,
   sW_Clnd,
   pL_WeekDay,
   pT_WeekDay,
   pL_DayBtn,
   pT_DayBtn,
   sW_CurMonthName,
   pL_CurMonthName,
   pT_CurMonthName: NUMERIC[0];
 BEGIN
  pL_CurMonthName:=HorizontalPadding + (sW_DayBtn + sW_SpaceBtwButtons) * 2;
  pT_CurMonthName:=Math.Max(sH_DlgClsBtn-sH_Title, HorizontalPadding);

  sW_Clnd:=HorizontalPadding + (sW_DayBtn * clnd_btnColumn + sW_SpaceBtwButtons * (clnd_btnColumn-1)) + HorizontalPadding;
(*
  sH_Clnd:=pT_CurMonthName + sH_Title + sH_WeekDay + (sH_DayBtn * clnd_btnRow + sW_SpaceBtwButtons * (clnd_btnRow-1)) + sW_SpaceBtwButtons + sH_TodayBtn + VerticalPadding;
*)
  sH_Clnd:=pT_CurMonthName + sH_Title + sH_WeekDay + (sH_DayBtn * clnd_btnRow + sW_SpaceBtwButtons * (clnd_btnRow-1)) + VerticalPadding;

  clnd                     :=DIALOG.Create(dlg);
  clnd.WindowSizeStatus    :=DIALOG.WindowSizeStatus_Restored;
  clnd.WindowStyle         :=DIALOG.WindowStyle_Popup;
  clnd.StandardClientWidth :=sW_Clnd;
  clnd.StandardClientHeight:=sH_Clnd;
  clnd.Redraw();
  SetClndDialogSize();
  clnd.OnClose             :=PROCREF(OnCalendarClose);

  L_GUI.add_StaticText(clnd, "st_clndBkGnd", "", 0, 0, sW_Clnd,   sH_Clnd,
                       fs_ClndTitle, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
  Item:=clnd.Controls.Item("st_clndBkGnd");
  L_GUI.SetControlBkColor(Item, RGBCOLOR.Create(212, 212, 212));

  L_GUI.add_Button(clnd, "pb_ClndClose", "X", "", sW_Clnd-sW_DlgClsBtn+3, 0-3, sW_DlgClsBtn, sH_DlgClsBtn, fs_DlgClsBtn, L_GUI.fn_LucidaConsole, PROCREF(OnClick_CalendarClose));

  sW_CurMonthName:=(sW_DayBtn * 3) + (sW_SpaceBtwButtons * 2);

  L_GUI.add_Button(clnd, "pb_prvMonth", "<<", "", pL_CurMonthName - (sW_DayBtn+sW_SpaceBtwButtons), pT_CurMonthName, sW_DayBtn, sH_Title,
                   fs_ClndTitle, L_GUI.fn_LucidaConsole, PROCREF(OnClick_PrvMonth));
  L_GUI.add_StaticText(clnd, id_clndCurMonthName, "Test", pL_CurMonthName, pT_CurMonthName, sW_CurMonthName, sH_Title,
                       fs_ClndTitle, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
  L_GUI.add_Button(clnd, id_clndNxtMonth, ">>", "", pL_CurMonthName + sW_CurMonthName+sW_SpaceBtwButtons, pT_CurMonthName, sW_DayBtn, sH_Title,
                   fs_ClndTitle, L_GUI.fn_LucidaConsole, PROCREF(OnClick_NxtMonth));

  pL_WeekDay:=HorizontalPadding;
  pT_WeekDay:=pT_CurMonthName + sH_Title;
  FOR_EACH Col DO
   L_GUI.add_StaticText(clnd, clnd_WDPrefix + L_Str.IntStr(Col), L_DatTim.WeekDayShortStr(Col),
                        pL_WeekDay, pT_WeekDay, sW_DayBtn, sH_WeekDay, fs_ClndWeekDay,
                        CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
   INC(pL_WeekDay, sW_DayBtn + sW_SpaceBtwButtons);
  END;

  pL_DayBtn:=HorizontalPadding;
  pT_DayBtn:=pT_WeekDay + sH_WeekDay;
  FOR_EACH i DO
   IF (i # 0) & (i MOD clnd_btnColumn = 0) THEN
    pL_DayBtn:=HorizontalPadding;
    INC(pT_DayBtn, sH_DayBtn + sW_SpaceBtwButtons);
   END;
   L_GUI.add_Button(clnd, clnd_DatePrefix + i, "", "", pL_DayBtn, pT_DayBtn, sW_DayBtn, sH_DayBtn, fs_ClndDayBtn, L_GUI.fn_LucidaConsole, PROCREF(OnClick_CalendarDate));
   INC(pL_DayBtn, sW_DayBtn + sW_SpaceBtwButtons);
  END;
  FOR_EACH Item IN clnd.Controls DO
   Item.Visible:=1;
  END;
 END {CreateCalendar};

 PRIVATE PROCEDURE OnClick_prdCurMonth(SLF: OBJECT);
 BEGIN
  prd_ChosenMonthBeg:=prd_CurMonthBeg;
  ShowPeriod();
  WHILE prd.Visible DO
   idleProc();
   prd.Wait(0.1);
  END;
 END {OnClick_prdCurMonth};

 PRIVATE PROCEDURE SetPeriodBtn();
  VAR
   prvMon,
   curMon,
   nxtMon: CONTROL;
 BEGIN
  curMon:=dlg.Controls.Item(id_prdCurMonth);
  prvMon:=dlg.Controls.Item(id_prdPrvMonth);
  nxtMon:=dlg.Controls.Item(id_prdNxtMonth);

  curMon.Text:=MonthAndYearStr(prd_CurMonthBeg, 1);
  IF L_DatTim.MonthBeg(prd_CurMonthBeg) # L_DatTim.MonthBeg(SYSDATE()) THEN
   L_GUI.SetControlFgColor(curMon, RGBCOLOR.Create(255, 0, 0));
  ELSE
   L_GUI.SetControlFgColor(curMon, RGBCOLOR.Create(0, 0, 0));
  END;
  prvMon.Enable:=PeriodIsAvailable(L_DatTim.IncMonth(prd_CurMonthBeg, -1));
  nxtMon.Enable:=L_DatTim.MonthBeg(prd_CurMonthBeg) # L_DatTim.MonthBeg(SYSDATE());
  SetMemoPeriod();

  curMon.Redraw();
  prvMon.Redraw();
  nxtMon.Redraw();

  DTS_TimeOut:=SYSTIMESTAMP();
  ChangeReportButtonsText();
 END {SetPeriodBtn};

 PRIVATE PROCEDURE prd_ChangeMonth(Direction: NUMERIC[0]);
 BEGIN
  prd_CurMonthBeg:=L_DatTim.IncMonth(prd_CurMonthBeg, Direction);
  SetPeriodBtn();
 END {prd_ChangeMonth};

 PRIVATE PROCEDURE OnClick_prdPrvMonth(SLF: OBJECT);
 BEGIN
  prd_ChangeMonth(-1);
 END {OnClick_prdPrvMonth};

 PRIVATE PROCEDURE OnClick_prdNxtMonth(SLF: OBJECT);
 BEGIN
  prd_ChangeMonth(+1);
 END {OnClick_prdNxtMonth};

 PRIVATE PROCEDURE OnClick_prdToday(SLF: OBJECT);
 BEGIN
  prd_CurMonthBeg:=L_DatTim.MonthBeg(SYSDATE());
  SetPeriodBtn();
  ClosePeriod();
 END {OnClick_prdToday};

 PRIVATE PROCEDURE OnClick_prdMonthBtn(SLF: OBJECT);
 BEGIN
  ClosePeriod();
  prd_CurMonthBeg:=L_DatTim.IncMonth(prd_ChosenMonthBeg,
                                     STRTOFLD(Str.Delete(SLF.Id, 0, Str.Length(prd_MonthPrefix)), NUMERIC, "N0") - L_DatTim.MONTH(prd_ChosenMonthBeg));
  SetPeriodBtn();
 END {OnClick_prdMonthBtn};

 PRIVATE PROCEDURE OnClick_prdPrvYear(SLF: OBJECT);
 BEGIN
  prd_ChosenMonthBeg:=L_DatTim.IncYear(prd_ChosenMonthBeg, -1);
  ShowPeriod();
 END {OnClick_prdPrvYear};

 PRIVATE PROCEDURE OnClick_prdNxtYear(SLF: OBJECT);
 BEGIN
  prd_ChosenMonthBeg:=Math.Min(L_DatTim.IncYear(prd_ChosenMonthBeg, +1), L_DatTim.MonthBeg(SYSDATE()));
  ShowPeriod();
 END {OnClick_prdNxtYear};

 PRIVATE PROCEDURE PeriodIsAvailable(Per: DATE): SCAL[2];
 BEGIN
  RETURN SELECT(Month, Period, Per);
 END {PeriodIsAvailable};

 PRIVATE PROCEDURE ShowPeriod();
  VAR
   Btn   : SCAL[12];
   Left,
   Top   : NUMERIC[0];
   c     : CONTROL;
   sysD,
   Per   : DATE;
   sysClr,
   othClr: RGBCOLOR;
 BEGIN
  othClr:=RGBCOLOR.Create(128, 256, 64);
  sysClr:=RGBCOLOR.Create(0, 0, 0);

  sysD:=SYSDATE();
  Per :=L_DatTim.YearBeg(prd_ChosenMonthBeg);
  FOR_EACH Btn DO
   c:=prd.Controls.Item(prd_MonthPrefix + L_Str.IntStr(Btn));
   c.Enable:=(Per <= L_DatTim.MonthBeg(sysD)) & PeriodIsAvailable(Per);
   IF Per = L_DatTim.MonthBeg(sysD) THEN
    L_GUI.SetControlFgColor(c, sysClr);
   ELSE
    L_GUI.SetControlFgColor(c, othClr);
   END;
   Per:=L_DatTim.NextPer(Per);
  END;

  c:=prd.Controls.Item(id_prdPrvYear);
  c.Enable:=PeriodIsAvailable(L_DatTim.IncYear(prd_ChosenMonthBeg, -1));

  c:=prd.Controls.Item(id_prdCurYear);
  c.Text:=L_Str.IntStr(L_DatTim.YEAR(prd_ChosenMonthBeg));
  IF L_DatTim.YEAR(prd_ChosenMonthBeg) = L_DatTim.YEAR(sysD) THEN
   L_GUI.SetControlFgColor(c, sysClr);
  ELSE
   L_GUI.SetControlFgColor(c, othClr);
  END;

  c:=prd.Controls.Item(id_prdNxtYear);
  c.Enable:=L_DatTim.YEAR(prd_ChosenMonthBeg) < L_DatTim.YEAR(sysD);

  prd.Visible:=1;
  prd.Redraw();
  DTS_TimeOut:=SYSTIMESTAMP();
 END {ShowPeriod};

 PRIVATE PROCEDURE OnPeriodClose(SLF: OBJECT);
 BEGIN
  ClosePeriod();
 END {OnPeriodClose};

 PRIVATE PROCEDURE OnClick_PeriodClose(SLF: OBJECT);
 BEGIN
  ClosePeriod();
 END {OnClick_PeriodClose};

 PRIVATE PROCEDURE CreatePeriod();
  CONST
   prd_btnColumn = 4;
   prd_btnRow    = 3;

   HorizontalPadding   = 3;
   VerticalPadding     = 3;
   sW_SpaceBtwButtons  = 2;

   sW_MonthBtn = 180;
   sH_MonthBtn = 80;

   sH_Title        = 50;
   sH_Today        = sH_MonthBtn * 3/4;

   fs_PrdTitle      = 36;
   fs_MonthBtn      = 34;
   fs_Today         = 30;
  VAR
   Btn         : SCAL[prd_btnColumn * prd_btnRow];
   Item        : CONTROL;
   sW_Prd,
   sH_Prd,
   pL_MonthBtn,
   pT_MonthBtn : NUMERIC[0];
 BEGIN
  sW_Prd:=HorizontalPadding + (sW_MonthBtn * prd_btnColumn + sW_SpaceBtwButtons * (prd_btnColumn-1)) + HorizontalPadding;
  sH_Prd:=VerticalPadding + sH_Title + sW_SpaceBtwButtons + (sH_MonthBtn * prd_btnRow + sW_SpaceBtwButtons * (prd_btnRow-1)) + sW_SpaceBtwButtons + sH_Today + VerticalPadding;

  prd:=DIALOG.Create(dlg);
  prd.WindowSizeStatus    :=DIALOG.WindowSizeStatus_Restored;
  prd.WindowStyle         :=DIALOG.WindowStyle_Popup;
  prd.StandardClientWidth :=sW_Prd;
  prd.StandardClientHeight:=sH_Prd;
  SetPrdDialogSize();
  prd.Redraw();
  prd.OnClose             :=PROCREF(OnPeriodClose);

  L_GUI.add_StaticText(prd, "st_prdBkGnd", "", 0, 0, sW_Prd, sH_Prd,
                       fs_PrdTitle, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
  Item:=prd.Controls.Item("st_prdBkGnd");
  L_GUI.SetControlBkColor(Item, RGBCOLOR.Create(212, 212, 212));

  L_GUI.add_Button(prd, "pb_prdClose", "X", "", sW_Prd-sW_DlgClsBtn+3, 0-3, sW_DlgClsBtn, sH_DlgClsBtn,
                   fs_DlgClsBtn, L_GUI.fn_LucidaConsole, PROCREF(OnClick_PeriodClose));

  L_GUI.add_StaticText(prd, id_prdCurYear, L_Str.IntStr(L_DatTim.YEAR(SYSDATE())),
                       HorizontalPadding, VerticalPadding, sW_Prd - 2*HorizontalPadding, sH_Title,
                       fs_PrdTitle+10, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
  L_GUI.add_Button(prd, id_prdPrvYear, "<<", "",
                   HorizontalPadding + sW_MonthBtn + sW_SpaceBtwButtons, VerticalPadding, sW_MonthBtn*1/2, sH_Title,
                   fs_PrdTitle, L_GUI.fn_LucidaConsole, PROCREF(OnClick_prdPrvYear));
  L_GUI.add_Button(prd, id_prdNxtYear, ">>", "",
                   HorizontalPadding + (sW_MonthBtn + sW_SpaceBtwButtons)*2+sW_MonthBtn*1/2, VerticalPadding,
                   sW_MonthBtn*1/2, sH_Title,
                   fs_PrdTitle, L_GUI.fn_LucidaConsole, PROCREF(OnClick_prdNxtYear));

  pL_MonthBtn:=HorizontalPadding;
  pT_MonthBtn:=VerticalPadding + sH_Title + sW_SpaceBtwButtons;
  FOR_EACH Btn DO
   IF (Btn # 0) & (Btn MOD prd_btnColumn = 0) THEN
    pL_MonthBtn:=HorizontalPadding;
    INC(pT_MonthBtn, sH_MonthBtn + sW_SpaceBtwButtons);
   END;
   L_GUI.add_Button(prd, prd_MonthPrefix + L_Str.IntStr(Btn), L_Str.PoolItem(L_DatTim._Month_0, Btn), "",
                    pL_MonthBtn, pT_MonthBtn, sW_MonthBtn, sH_MonthBtn,
                    fs_MonthBtn, L_GUI.fn_LucidaConsole, PROCREF(OnClick_prdMonthBtn));
   INC(pL_MonthBtn, sW_MonthBtn + sW_SpaceBtwButtons);
  END;

  L_GUI.add_Button(prd, "pb_prdToday", MonthAndYearStr(SYSDATE(), 0), "",
                   (sW_Prd-sW_MonthBtn*2)/2, pT_MonthBtn+sH_MonthBtn+sW_SpaceBtwButtons,
                   sW_MonthBtn*2, sH_Today,
                   fs_Today, L_GUI.fn_LucidaConsole, PROCREF(OnClick_prdToday));

  FOR_EACH Item IN prd.Controls DO
   Item.Visible:=1;
  END;
  prd.Redraw();
 END {CreatePeriod};

 PRIVATE PROCEDURE cd_PutObjectNameControls(Id: STRING[]; Top, Width: NUMERIC[0]);
  CONST
   fs_ObjectName = 29;

   sW_IntShift   = 4;
   sH_IntShift   = 4;
   sH_Picture    = sH_Object - sH_IntShift*2;
   sW_Picture    = sH_Picture;
   pL_Text       = pL_Most + sW_IntShift*2 + sW_Picture;
 BEGIN
  L_GUI.put_Border(dlg, p_Common2, Id + "Border",
                   pL_Most, Top, Width, sH_Object);

  L_GUI.put_StaticText(dlg, p_Common2, Id, "",
                       pL_Text, Top + sH_IntShift, Width - pL_Text, sH_Picture,
                       fs_ObjectName, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_None);

  L_GUI.put_Picture(dlg, p_Common2, Id+"Picture", "",
                    pL_Most + sW_IntShift, Top + sH_IntShift, sW_Picture, sH_Picture);
 END {cd_PutObjectNameControls};

 PRIVATE PROCEDURE ReplicatePeriodButtons(Page: STRING[]);
 BEGIN
  L_GUI.pc_AddId(id_prdPrvMonth, Page);
  L_GUI.pc_AddId(id_prdCurMonth, Page);
  L_GUI.pc_AddId(id_prdNxtMonth, Page);
 END {ReplicatePeriodButtons};

 PRIVATE PROCEDURE cd_PutWelcomePage();
  CONST
   fs_EnterBut    = 96;
   fs_Copyright   = 19;
   fs_Title       = 20;
   fs_Clock       = 19;
   fs_Instruction = 23;

   sW_Title       = L_GUI.normalWidth-300;
   pL_Clock       = pL_Most + sW_Title + sW_CommonShift;

   sW_InstrPict   = sW_Most * 0.6;
   sH_Instr       = sW_InstrPict / 1.29;
   sW_InstrText   = sW_Most - sW_InstrPict - 3 * sW_CommonShift;
   pL_InstrText   = pL_Most + sW_CommonShift + sW_InstrPict + sW_CommonShift;

   pT_Enter       = pT_Instr + sH_Instr + 3 * sH_CommonShift;
   sH_Enter       = pB_Most - pT_Enter;

   sH_EnterButton = sH_Enter * 2/3;
   sW_EnterButton = sW_InstrPict;
   pL_EnterButton = pL_Most + sW_Most / 2 - sW_EnterButton / 2;
   pT_EnterButton = pT_Enter + (sH_Enter - sH_EnterButton) / 2;

   pT_ProxPict    = pT_EnterButton;
   sW_ProxPict    = sW_EnterButton;
   sH_ProxPict    = sH_EnterButton;

   sH_Weather     = 100;
   sW_Weather     = sH_Weather;
   pL_Weather     = (pL_EnterButton + sW_EnterButton) + (sW_Most - (pL_EnterButton + sW_EnterButton)) / 2 - sW_Weather/2;
   pT_Weather     = pT_Enter + (sH_Enter-sH_Weather) / 2;

   sW_Copyright   = sW_Most - sW_EnterButton - pL_EnterButton - 2 * sW_CommonShift;
   sH_Copyright   = 20;

   fs_Period      = 24;
   fs_PeriodChg   = 48;
  VAR
   sW_prdMonth,
   sW_prdCurMonth: NUMERIC[0];
 BEGIN
  L_GUI.put_StaticText(dlg, p_Common, "Title", "ଠ樮 . " + P_Firm.FP_FirmShortName(P_Firm.OWN_FIRM, SYSDATE()),
                       pL_Most, pT_Most, sW_Title, sH_Title,
                       fs_Title, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_ThinRidge);

  L_GUI.put_StaticText(dlg, p_Common, id_Clock, "",
                       pL_Clock, pT_Most, pR_Most-pL_Clock, sH_Title,
                       fs_Clock, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_ThinRidge);

  cd_PutObjectNameControls(id_StaffName, pT_O_Staff, sW_Title);
  cd_PutObjectNameControls(id_CarName,   pT_O_Car, sW_Title);

  sW_prdCurMonth:=(pR_Most-pL_Clock-8)/2;
  sW_prdMonth   :=sW_prdCurMonth / 2;
  L_GUI.put_Border(dlg, p_Common2, "st_prdBorder",
                   pL_Clock, pT_O_Staff, pR_Most-pL_Clock, sH_Object*2+4);

  L_GUI.put_Button(dlg, L_Kiosk.p_Staff, id_prdPrvMonth, "<<",
                   pL_Clock+4, pT_O_Staff+4, sW_prdMonth, sH_Object*2-4,
                   fs_PeriodChg, L_GUI.fn_Default,
                   PROCREF(OnClick_prdPrvMonth));
  L_GUI.put_Button(dlg, L_Kiosk.p_Staff, id_prdCurMonth, "",
                   pL_Clock+4+sW_prdMonth, pT_O_Staff+4, sW_prdCurMonth, sH_Object*2-4,
                   fs_Period, L_GUI.fn_Default,
                   PROCREF(OnClick_prdCurMonth));
  L_GUI.put_Button(dlg, L_Kiosk.p_Staff, id_prdNxtMonth, ">>",
                   pL_Clock+4+sW_prdMonth * 3 , pT_O_Staff+4, sW_prdMonth, sH_Object*2-4,
                   fs_PeriodChg, L_GUI.fn_Default,
                   PROCREF(OnClick_prdNxtMonth));
  ReplicatePeriodButtons(L_Kiosk.p_Car);
  ReplicatePeriodButtons(p_RepButtons);

  L_GUI.put_Border(dlg, p_Common2, "st_RepButBorder",
                   pL_Most, pT_RepButBorder, sW_RepButBorder, sH_RepButBorder);

  L_GUI.put_Border(dlg, p_Common2, "st_ControlButBorder",
                   pL_Most, pT_ControlButBorder, sW_Most, sH_ControlButBorder);
  L_GUI.pc_AddId("st_ControlButBorder", p_Report);
  L_GUI.pc_AddId("st_ControlButBorder", p_Html);

  L_GUI.put_Picture(dlg, p_Welcome, id_Instr2, fpn_Get("instr2.jpg"),
                    pL_Most + sW_CommonShift, pT_Instr + sH_CommonShift, sW_InstrPict, sH_Instr);
  L_GUI.put_Picture(dlg, p_Welcome, id_Instr1, fpn_Get("instr1.jpg"),
                    pL_Most + sW_CommonShift, pT_Instr + sH_CommonShift, sW_InstrPict, sH_Instr);

  L_GUI.put_StaticText(dlg, p_Welcome, "InstrText",
                       " " +
                       L_Str.CRLF +
                       " ଠ樮 !" +
                       L_Str.CRLF +
                       L_Str.CRLF +
                       " 祭 ॡ㥬 ଠ樨 室 " + PushModeStr() + " ᮮ⢥饩 ." +
                       L_Str.CRLF +
                       L_Str.CRLF +
                       "஫뢠 ⮢ - " + ScrollModeStr() +
                       L_Str.CRLF +
                       L_Str.CRLF +
                       "᫥ 砭 ࠡ  ᪥   믮 室  ᪠  ᪫祭  㯠  襩 ᮭ쭮 ଠ樨." +
                       L_Str.CRLF +
                       "⮬᪨ 室  ᪠ ந  砥   ࠡ  " + L_Str.IntStr(refreshCycle_TimeOut/60) + " ",
                       pL_InstrText, pT_Instr + sH_CommonShift, sW_InstrText, sH_Instr,
                       fs_Instruction, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);

  L_GUI.put_Border(dlg, p_Welcome, "InstrBorder",
                   pL_Most, pT_Instr, sW_Most, sH_Instr + 2 * sH_CommonShift);

  L_GUI.put_Border(dlg, p_Welcome, "EnterBorder",
                   pL_Most, pT_Enter, sW_Most, sH_Enter);

  IF ~E_UseProximityCard() | KioskDemoMode THEN
   L_GUI.put_Button(dlg, p_Welcome, id_Enter, "室  ",
                    pL_EnterButton, pT_EnterButton, sW_EnterButton, sH_EnterButton,
                    fs_EnterBut, L_GUI.fn_Default,
                    PROCREF(OnClick_Enter));
  ELSE
   L_GUI.put_Picture(dlg, p_Welcome, "ProxPict", fpn_Get("begin.jpg"),
                     pL_EnterButton, pT_ProxPict, sW_ProxPict, sH_ProxPict);

   L_GUI.put_StaticText(dlg, p_Welcome, "ProxText",
                       " 砫 ࠡ   -ய  뢠⥫",
                        pL_Most + sW_CommonShift, pT_Enter,
                        sW_Most, pT_EnterButton - pT_Enter,
                        fs_Instruction, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
  END;
  L_GUI.put_ActiveX(dlg, p_Welcome, id_Weather, "",
                    pL_Weather, pT_Weather, sW_Weather, sH_Weather, L_GUI.br_st_None);

  L_GUI.put_StaticText(dlg, p_Common, "PolakCopyright", "(c) Polak 2003 - " + L_Str.IntStr(L_DatTim.YEAR(SYSDATE())),
                       pR_Most-sW_Copyright-sW_CommonShift, pB_Most - sH_Copyright - sH_CommonShift, sW_Copyright, sH_Copyright,
                       fs_Copyright, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
 END {cd_PutWelcomePage};

 PRIVATE PROCEDURE SetupMessageFontColor(trgId: STRING[]);
  VAR
   m          : STATIC_TEXT;
 BEGIN
  m:=dlg.Controls.Item(trgId);
  m.Style.Font.Weight:=FONT.Weight_Bold;
  L_GUI.SetControlFgColor(m, RGBCOLOR.Create(255, 255, 255));
  IF trgId = id_ErrorMessage THEN
   L_GUI.SetControlBkColor(m, RGBCOLOR.Create(128, 0,   0));
  ELSE
   L_GUI.SetControlBkColor(m, RGBCOLOR.Create(0,   0, 128));
  END;
 END {SetupMessageFontColor};

 PRIVATE PROCEDURE SetClndDialogSize();
 BEGIN
  clnd.Rect.Right :=clnd.Rect.Left + clnd.StandardClientWidth  * dlg.ScaleX;
  clnd.Rect.Bottom:=clnd.Rect.Top  + clnd.StandardClientHeight * dlg.ScaleY;
(*
  clnd.ClientRect.Right :=clnd.ClientRect.Left + clnd.StandardClientWidth  * dlg.ScaleX;
  clnd.ClientRect.Bottom:=clnd.ClientRect.Top  + clnd.StandardClientHeight * dlg.ScaleY;
*)
  clnd.AutoPos:=1;
  clnd.Redraw();
 END {SetClndDialogSize};

 PRIVATE PROCEDURE SetPrdDialogSize();
 BEGIN
  prd.Rect.Right  :=prd.Rect.Left  + prd.StandardClientWidth   * dlg.ScaleX;
  prd.Rect.Bottom :=prd.Rect.Top   + prd.StandardClientHeight  * dlg.ScaleY;
(*
  prd.ClientRect.Right  :=prd.ClientRect.Left  + prd.StandardClientWidth   * dlg.ScaleX;
  prd.ClientRect.Bottom :=prd.ClientRect.Top   + prd.StandardClientHeight  * dlg.ScaleY;
*)
  prd.AutoPos:=1;
  prd.Redraw();
 END {SetPrdDialogSize};

 PRIVATE PROCEDURE OnDialogResize(d: DIALOG);
 BEGIN
  L_GUI.ShowPictInActiveX(dlg, id_Weather, E_GetWeatherForecastURL());
  SetClndDialogSize();
  SetPrdDialogSize();
 END {OnDialogResize};

 PRIVATE PROCEDURE OnDialogClose(d: DIALOG);
 BEGIN
  L_GUI.SetTaskBarVisible(1);
  d.Visible:=0;
 END {OnDialogClose};

 PRIVATE PROCEDURE CreateCongratPage(PageId, PictureId, TextId, FileName: STRING[]; pL, pT, sW, sH: FLOAT);
  CONST
   fS_Text = 30;
   sH_Text = 40;
 BEGIN
  L_GUI.put_StaticText(dlg, PageId, TextId, "", pL, pT, sW, sH_Text,
                       fS_Text, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);
  L_GUI.put_Picture(dlg, PageId, PictureId, fpn_Get(FileName), pL, pT+sH_Text, sW, sH-sH_Text);
 END {CreateCongratPage};

 PRIVATE PROCEDURE CreateDialog();
  CONST
   fs_InputDialogObjectTitle   = 24;
   fs_InputDialogObjectCode    = 61;
   fs_Message                  = 28;
   fs_ObjectList               = 37;
   fs_InputDialogButton        = 73;

   sW_ManPhoto  = 215;

   pT_ControlBut = pT_ControlButBorder + (sH_ControlButBorder - sH_ControlBut) / 2;

   pT_Report = pT_Instr;
   sH_Report = pT_ControlButBorder - sH_CommonShift - pT_O_Staff;
   sH_Prompt = 30;

   sW_InputBorder = 550;
   sH_InputBorder = 500;

   pL_InputBorder = pL_Most + (sW_RepButBorder / 2  - sW_InputBorder / 2);
   pT_InputBorder = pT_RepButBorder + (sH_RepButBorder / 2 - sH_InputBorder / 2);

   sW_Shift = 10;
   sH_Shift = 10;

   sW_ObjectTitle = 200;
   sH_ObjectTitle = 70; (*40*)
   pL_ObjectTitle = pL_InputBorder + 30;
   pT_ObjectTitle = pT_InputBorder + 15;

   sW_ObjectCode  = 280;
   sH_ObjectCode  = sH_ObjectTitle;

   sW_DigitBut = 90;
   sH_DigitBut = 90;
   pT_FirstDigitBut = pT_ObjectTitle + sH_ObjectTitle + sH_Shift;

   sW_3DigitBut = 3 * sW_DigitBut + 2 * sW_Shift;
   sW_2DigitBut = 2 * sW_DigitBut + sW_Shift;

   ChooseObjectButAmount = 5;

   sH_ChooseObjectShift = (sH_RepButBorder - sH_ChooseObject * ChooseObjectButAmount) / (ChooseObjectButAmount + 1);
   pL_ChooseObject      = pL_Most + (sW_RepButBorder / 2) - sW_ChooseObject / 2;
   pT_ChooseObject      = pT_RepButBorder + sH_ChooseObjectShift;

  VAR
   pL_DigitBut,
   pT_DigitBut,
   Row,
   BtnNbr,
   sH_ManPhoto,
   ButtonsInRow: NUMERIC[0];
 BEGIN
  PROMPT("⮢ 㠫 ꥪ⮢");
  dlg:=L_GUI.CreateDialog(~KioskDemoMode);

  dlg.CaptionText    :=L_General.GetAPSiteID() + ' - "⮏" ଠ樮 ';
  dlg.ShowMouseCursor:=~wTouchScreen;
  dlg.OnSize         :=PROCREF(OnDialogResize);
  dlg.OnClose        :=PROCREF(OnDialogClose);

  cd_PutWelcomePage();

  L_GUI.put_ImgButton(dlg,
                      p_Backward, id_Backward, "", "",
                      Get_pL_AnyRepBut(0), pT_ControlBut, sW_ControlBut, sH_ControlBut,
                      PROCREF(OnClick_Backward));

  L_GUI.put_ImgButton(dlg,
                      L_Kiosk.p_Staff, id_ChooseCar, "࠭ᯮ⭮|।⢮", fpn_Get("Car.gif"),
                      Get_pL_AnyRepBut(1), pT_ControlBut, sW_ControlBut, sH_ControlBut,
                      PROCREF(OnClick_ChooseCar));
  L_GUI.pc_AddId(id_ChooseCar, L_Kiosk.p_Car);

  sH_ManPhoto:=sW_ManPhoto * 45 / 35;
  IF ~KioskDemoMode THEN
   sH_ManPhoto:=sH_ManPhoto / (dlg.ScaleY / dlg.ScaleX);
  END;

  L_GUI.put_Picture(dlg, L_Kiosk.p_Staff, id_ManPhoto, "",
                    Get_pL_AnyRepBut(rb_Column_Amnt-1) + sW_RepBut/2-sW_ManPhoto/2, pT_RepBut, sW_ManPhoto, sH_ManPhoto);

  L_GUI.pc_AddId(id_ManPhoto, L_Kiosk.p_Car);
  L_GUI.pc_AddId(id_ManPhoto, p_RepButtons);

  L_GUI.put_StaticText(dlg, p_Report, id_ReportText, "",
                       pL_Most, pT_Report, sW_Most, sH_Report,
                       0, CONTROL.HorizontalAlignment_Left, L_GUI.br_st_ThinRidge);

  L_GUI.put_WebBrowser(dlg, p_Html, id_ReportAsHtml, "",
                       pL_Most, pT_Report, sW_Most, sH_Report,
                       L_GUI.br_st_ThinRidge);

  DefineReportButtons();

  L_GUI.put_Border(dlg, p_Input, id_Input,
                   pL_InputBorder, pT_InputBorder,
                   sW_InputBorder, sH_InputBorder);

  L_GUI.put_StaticText(dlg, p_Input, id_ObjectTitle, "",
                       pL_ObjectTitle, pT_ObjectTitle,
                       sW_ObjectTitle, sH_ObjectTitle,
                       fs_InputDialogObjectTitle, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_None);

  L_GUI.put_StaticText(dlg, p_Input, id_ObjectCode, "",
                       pL_ObjectTitle + sW_ObjectTitle + sW_Shift, pT_ObjectTitle, sW_ObjectCode, sH_ObjectCode,
                       fs_InputDialogObjectCode, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_ThinRidge);
  dlg.Controls.Item(id_ObjectCode).Style.Font.Face  :=L_GUI.fn_Tahoma;
  dlg.Controls.Item(id_ObjectCode).Style.Font.Weight:=FONT.Weight_Bold;

  Row         :=1;
  BtnNbr      :=1;
  ButtonsInRow:=1;
  LOOP
   IF ButtonsInRow > 3 THEN
    INC(Row);
    ButtonsInRow:=1;
   END;

   IF Row > 3 THEN
    EXIT;
   END;

   pL_DigitBut:=pL_ObjectTitle + (sW_DigitBut + sW_Shift) * (ButtonsInRow-1);
   pT_DigitBut:=pT_FirstDigitBut + (sH_DigitBut + sH_Shift) * (Row-1);

   cd_PutInputDialogButton("Nbr_" + L_Str.IntStr(BtnNbr), L_Str.IntStr(BtnNbr),
                           pL_DigitBut, pT_DigitBut,
                           sW_DigitBut, sH_DigitBut, fs_InputDialogButton);
   INC(ButtonsInRow);
   INC(BtnNbr);
  END;

  pT_DigitBut:=pT_FirstDigitBut + (sH_DigitBut + sH_Shift) * 3;
  cd_PutInputDialogButton("Nbr_0", "0",
                          pL_ObjectTitle, pT_DigitBut,
                          sW_3DigitBut, sH_DigitBut, fs_InputDialogButton);

  pL_DigitBut:=pL_ObjectTitle + (sW_DigitBut + sW_Shift) * 3;
  cd_PutInputDialogButton("Nbr_Del", "<<<",
                          pL_DigitBut, pT_FirstDigitBut,
                          sW_2DigitBut, sH_DigitBut, fs_InputDialogButton);

  L_GUI.put_Button(dlg, p_Input, id_EnterCode, "",
                   pL_DigitBut, pT_FirstDigitBut + sH_DigitBut + sH_Shift, sW_2DigitBut, sH_DigitBut * 3 + sW_Shift * 2,
                   fs_InputDialogButton, L_GUI.fn_Default,
                   PROCREF(OnClick_EnterCode));

  CreateCongratPage(p_CongratulationBD,  id_CongratulationBD,  id_TextCongratBD, L_APMsg.getCongratulationPictureFileName(L_APMsg.cw_BirthDay),
                    pL_InputBorder, pT_InputBorder, sW_InputBorder, sH_InputBorder);
  CreateCongratPage(p_Congratulation8M,  id_Congratulation8M,  id_TextCongrat8M,  L_APMsg.getCongratulationPictureFileName(L_APMsg.cw_8March),
                    pL_InputBorder, pT_InputBorder, sW_InputBorder, sH_InputBorder);
  CreateCongratPage(p_Congratulation23F, id_Congratulation23F, id_TextCongrat23F, L_APMsg.getCongratulationPictureFileName(L_APMsg.cw_23February),
                    pL_InputBorder, pT_InputBorder, sW_InputBorder, sH_InputBorder);
  CreateCongratPage(p_CongratulationNY,  id_CongratulationNY,  id_TextCongratNY,  L_APMsg.getCongratulationPictureFileName(L_APMsg.cw_NewYear),
                    pL_InputBorder, pT_InputBorder, sW_InputBorder, sH_InputBorder);

  L_GUI.put_StaticText(dlg, p_Error, id_ErrorMessage, "",
                       pL_InputBorder, pT_InputBorder,
                       sW_InputBorder, sH_InputBorder,
                       fs_Message, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_ThinRidge);
  SetupMessageFontColor(id_ErrorMessage);

  L_GUI.put_StaticText(dlg, p_Inform, id_InformMessage, "",
                       pL_InputBorder, pT_InputBorder,
                       sW_InputBorder, sH_InputBorder,
                       fs_Message, CONTROL.HorizontalAlignment_Center, L_GUI.br_st_ThinRidge);
  SetupMessageFontColor(id_InformMessage);

  BtnNbr:=0;
  WHILE (BtnNbr < 5) DO
   L_GUI.put_Button(dlg, p_ObjectsList, id_olItem + L_Str.IntStr(BtnNbr), "",
                    pL_ChooseObject, pT_ChooseObject + (sH_ChooseObject + sH_ChooseObjectShift) * BtnNbr,
                    sW_ChooseObject, sH_ChooseObject,
                    fs_ObjectList, L_GUI.fn_Default,
                    PROCREF(OnClick_ChooseObject));
   INC(BtnNbr);
  END;

  CreatePeriod();
  CreateCalendar();

  dlg.Redraw();
 END {CreateDialog};

 PRIVATE PROCEDURE SetupModeOnOurSite();
  VAR
   Timer,
   Result      : NUMERIC[0];
   btnTS,
   btnTest,
   btnTS_wMouse: STRING[];
 BEGIN
  Timer:=8;
  IF L_General.IsProgrammer() THEN
   btnTest     :="%<  ⫠   %T >DB";
   btnTS       :="%< 稩 ० >B";
   btnTS_wMouse:="%< 稩 ०   >B";
  ELSE
   btnTest     :="%<    ⫠     >B";
   btnTS       :="%< 稩 ० %T >DB";
   btnTS_wMouse:="%< 稩 ०   >B";
  END;
  Result:=STDFORM(" ᪠ ଠ樮 ᪠|"+
                  btnTest + " " + btnTS + " " + btnTS_wMouse + " %<   ⬥   >X",
                  "",
                  INFORM,
                  1,
                  Timer);
  IF    Result = 1 THEN
   KioskDemoMode:=1;
   wTouchScreen :=0;
  ELSIF Result = 3 THEN
   KioskDemoMode:=0;
   wTouchScreen :=0;
  END;
 END {SetupModeOnOurSite};

 PRIVATE PROCEDURE SetKioskSettings();
 BEGIN
  bbc_HasInform:=RGBCOLOR.Create(135, 206, 250);
  bbc_JustColor:=RGBCOLOR.Create(123, 156, 181);
  bbc_Default  :=RGBCOLOR.Create(100, 100, 100);

  KioskDemoMode:=~L_General.IsEndUser();
  wTouchScreen :=~KioskDemoMode;
  IF MONITORS.Create().Count = 1 THEN
   IF L_General.IsOurSite() & wTouchScreen THEN
    SetupModeOnOurSite();
   END;
  END;
 END {SetKioskSettings};

 PRIVATE PROCEDURE CreateTemporaryFiles();
 BEGIN
  L_AFM.MakeMultipleIndex("CarLs", "BoxNbr: LIKE(Car.BoxNbr);"+
                                   "Name  : STRING[64];"+
                                   "Amount: NUMERIC[0]",
                          "BoxNbr: BoxNbr; Amount: Amount");

  L_AFM.MakeMultipleIndex("StfLs", "Contract: LIKE(Staff.Contract);"+
                                   "TSN     : LIKE(Staff.TSN);"+
                                   "Name    : STRING[64]",
                          "Contract: Contract, TSN");

  L_AFM.MakeMultipleIndex("spLog", "Date  : DATE;"+
                                   "TSN   : LIKE(Staff.TSN);"+
                                   "BoxNbr: LIKE(Car.BoxNbr)",
                          "TSN: TSN, BoxNbr");
  L_AFM.MakeMultipleIndex("kskRepBut", "Page    : STRING[32];"+
                                       "ButType : SCAL[2];"+
                                       "GroupId : STRING[32];"+
                                       "Id      : STRING[32];"+
                                       "Nbr     : NUMERIC[0];"+
                                       "RepType : SCAL[3];"+
                                       "Picture : STRING[64];"+
                                       "Name    : STRING[64];"+
                                       "RepName : STRING[64];"+
                                       "RepHandl: STRING[64];"+
                                       "AuthReq : SCAL[2];"+
                                       "Enable  : SCAL[2]",
                          "kskRepBut:Page, ButType, GroupId, Nbr;Id:Page, ButType, Id");
 END {CreateTemporaryFiles};

 PRIVATE PROCEDURE MonthAndYearStr(D: DATE; Wrap: SCAL[2]): STRING[];
  CONST
   Delimiter = [" ", "|"];
 BEGIN
  RETURN L_GUI.ConvText(Str.Cap(L_DatTim.MonthStr(D, 0), 0, 1) + Delimiter[Wrap] + L_Str.IntStr(L_DatTim.YEAR(D)));
 END {MonthAndYearStr};

 PRIVATE PROCEDURE CurUserIsBoss(trgTSN: LIKE(Staff.TSN)): SCAL[2];
  VAR
   Result    : SCAL[2];
   cusMan    : LIKE(Man.Man);
   trgSort   : LIKE(Officer.Sort);
   trgOfficer: LIKE(Officer.Officer);
   D         : DATE;
 BEGIN
  Result:=0;
  TRY
   IF ~!TABLE.Get("Officer").Fields("BossSrt") THEN
    SETEMPTY(trgSort, trgOfficer);
    IF ~!trgTSN THEN
     SEARCH(Staff, TSN, , trgTSN);
     HISTCONF(Math.Max(Staff.BegDate, SYSDATE()), Staff, StaffLog);
     trgSort   :=StaffLog.Sort;
     trgOfficer:=StaffLog.Officer;
    END;
    cusMan:=P_Man.Try_curUSER2Man();
    IF ~!cusMan THEN
     SELECT(Staff, Man, , cusMan);
     WHILE OCCURE(Staff) & ~Result DO
      D:=Math.Max(Staff.BegDate, SYSDATE());
      IF L_Staff.rInState(D) THEN
       HISTCONF(D, Staff, StaffLog, Officer);
       IF !trgSort THEN
        Result:=SELECT(Officer, Boss, Officer.Sort, Officer.Officer);
       ELSE
        Result:=L_Staff.IsBossOfficer(Officer.Sort, Officer.Officer, trgSort, trgOfficer);
       END;
      END;
      NEXT(Staff);
     END; (* WHILE OCCURE(Staff) ... *)
    END; (* IF ~!cusMan *)
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  RETURN Result;
 END {CurUserIsBoss};

 PRIVATE PROCEDURE OnClick_Enter(SLF: OBJECT);
  VAR
   curMan: LIKE(Man.Man);
 BEGIN
  IF History[curNestingLevel] = status_Enter THEN
   IF KioskDemoMode & ~L_APtm.KioskUser_WO_Authorization() & ~CurUserIsBoss(EMPTYOF(Staff.TSN)) THEN
    curMan:=P_Man.Try_curUSER2Man();
    IF ~!curMan THEN
     curObject:=o_Staff;
     GatherStaff_ByMan(curMan);
     IF SELECT(StfLs, Contract) THEN
      ProceedStaffList();
     ELSE
      ErrorMessage:="    ࠪ ⥪饣 짮⥫.|  ᪥ ";
      SetCurStatus(status_ShowErrorMessage);
     END;
    ELSE
     ErrorMessage:="騩 짮⥫  ᮯ⠢  .|  ᪥ ";
     SetCurStatus(status_ShowErrorMessage);
    END;
   ELSE
(*
    CheckReStartKioskRequired(1);
*)
    SetCurStatus(status_InputTSN);
   END;
  ELSE
DebugCrashkiosk("OnClick_Enter", "");
   L_General.CallUs(0);
  END;
 END {OnClick_Enter};

 PRIVATE PROCEDURE OnClick_InputDigit(SLF: OBJECT);
  VAR
   c: OBJECT;
 BEGIN
  IF    L_Str.TestStrAlowChar(L_Str.Char(SLF.Id, 4), "09") THEN
   IF Str.Length(ObjectCode) < getObjectCodeMaxLength(curObject) THEN
    INC(ObjectCode, L_Str.Char(SLF.Id, 4));
   END;
  ELSIF SLF.Id = "Nbr_Del" THEN
   IF Str.Length(ObjectCode) > 0 THEN
    ObjectCode:=Str.Slice(ObjectCode, 0, Str.Length(ObjectCode)-1);
   ELSE
    SETEMPTY(ObjectCode);
   END;
  ELSE
   L_General.CallUs(0);
  END;
  c:=dlg.Controls.Item(id_ObjectCode);
  IF History[curNestingLevel] = status_InputPIN THEN
   c.Text:=L_Str.Repeat("*", Str.Length(ObjectCode));
  ELSE
   c.Text:=ObjectCode;
  END;
  c.Redraw();
 END {OnClick_InputDigit};

 PRIVATE PROCEDURE OnAfterAuthorization();
 BEGIN
  IF E_CheckPINCode_WhenInputTSN() THEN
   GoToViewStaffReportButtons();
  ELSE
   IF ~IsPushGroupButton(aa_Nbr) | (GetReportAmountByGroup(curPage, curGroupButId) = 1) THEN
    GoToPreviousStatus();
   ELSE
    SetPreviousStatus();
   END;
   ProceedButtonClick(aa_Nbr, 1);
  END;
 END {OnAfterAuthorization};

 PRIVATE PROCEDURE OnClick_EnterCode(SLF: OBJECT);
  VAR
   MaxLength: NUMERIC[0];
 BEGIN
  IF ~!ObjectCode THEN
   prd_CurMonthBeg:=L_DatTim.MonthBeg(SYSDATE());
   SetPeriodBtn();
   IF curObject = o_PINCode THEN
    IF P_Man.CheckPINCode(EncryptPIN, ObjectCode, curMan, SYSDATE(), 0) = P_Man.ar_Granted THEN
     klf_SimpleMark("GoodPIN");
     OnAfterAuthorization();
    ELSE
     klf_SimpleMarkError("BadPIN");
     ErrorMessage:=" ࠢ -";
     SetCurStatus(status_ShowErrorMessage);
    END;
   ELSE
    IF    curObject = o_Staff THEN
     MaxLength:=Str.Length(FLDTOSTR(MAXOF(Staff.TSN), "", 0));
    ELSIF curObject = o_Car THEN
     MaxLength:=Str.Length(FLDTOSTR(MAXOF(Car.BoxNbr), "", 0));
    END;
    ObjectCode:=L_Str.Repeat("0", MaxLength - Str.Length(ObjectCode)) + ObjectCode;

    IF AccessObject(ObjectCode) = oar_Done THEN
     IF    curObject = o_Staff THEN
      IF    ViewAcceptableStaffInDemoMode(curMan, curTSN) THEN
       GoToViewStaffReportButtons();
      ELSIF E_PINCodeRequired() & E_CheckPINCode_WhenInputTSN() THEN
       PrepareInputPINCode(EMPTYOF(NUMERIC[0]), "Login");
      ELSE
       GoToViewStaffReportButtons();
      END;
     ELSIF curObject = o_Car THEN
      GoToViewCarReportButtons();
     END;
    ELSE
     klf_SimpleMarkError("BadObject_"+L_Str.PoolItem(o_Pool, curObject)+"_"+ObjectCode);
     SetCurStatus(status_ShowErrorMessage);
    END;
   END;
   SETEMPTY(ObjectCode, dlg.Controls.Item(id_ObjectCode).Text);
   dlg.Controls.Item(id_ObjectCode).Redraw();
  END;
 END {OnClick_EnterCode};

 PRIVATE PROCEDURE GetNbrFromButtonId(trgId: STRING[]): NUMERIC[0];
 BEGIN
  RETURN STRTOFLD(Str.Item(trgId, "_", 2), NUMERIC);
 END {GetNbrFromButtonId};

 PRIVATE PROCEDURE CalendarRequired(trgId: STRING[]): SCAL[2];
 BEGIN
  IF ~!trgId THEN
   sorbd_ByNbr(GetNbrFromButtonId(trgId));
   RETURN ThroughCalendar(kskRepBut.Id);
  ELSE
   RETURN 0;
  END;
 END {CalendarRequired};

 PRIVATE PROCEDURE OnClick_Backward(SLF: OBJECT);
  VAR
   PrvStatus: tStatus;
 BEGIN
  IF IsInputDigitsStatus(History[curNestingLevel]) THEN
   ClearObjectCodeOnExit();
  END;
  IF (History[curNestingLevel] = status_ShowErrorMessage) & (History[curNestingLevel-1] = status_InputTSN) THEN
   ClearObjectsNameOnExit();
  END;

  PrvStatus:=History[curNestingLevel];
  SetPreviousStatus();
  IF    History[curNestingLevel] = status_Enter THEN
   IF (PrvStatus = status_ViewStaffGroupBut) | (PrvStatus = status_ChooseStaffFromList) THEN
    klf_SimpleMark("LogOut");
   END;
   ClearObjectsNameOnExit();
  ELSIF History[curNestingLevel] = status_ViewStaffGroupBut THEN
   SETEMPTY(curBoxNbr);
   UpdateObjectName(id_CarName,   oar_NotAcceptable, curBoxNbr, "", "");
  END;
  DrawPage();

  IF VAR_IMPL.Get(CalendarRepId).Initialized & CalendarRequired(CalendarRepId) THEN
   ShowCalendar(0);
  END;
 END {OnClick_Backward};

 PRIVATE PROCEDURE GetCarLsAmount(): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  SETZERO(Result);
  SELECT(CarLs, BoxNbr);
  WHILE OCCURE(CarLs) DO
   INC(Result);
   NEXT(CarLs);
  END; (* WHILE OCCURE(CarLs) ... *)
  RETURN Result;
 END {GetCarLsAmount};

 PRIVATE PROCEDURE OnClick_ChooseCar(SLF: OBJECT);
  VAR
   CarLsAmount: NUMERIC[0];
 BEGIN
  CarLsAmount:=GetCarLsAmount();
  IF    CarLsAmount = 0 THEN
   SetCurStatus(status_InputBoxNbr);
  ELSIF CarLsAmount = 1 THEN
   SELECT(CarLs, BoxNbr);
   curObject:=o_Car;
   IF (History[curNestingLevel] # status_ViewCarGroupBut) & (AccessObject(CarLs.BoxNbr) = oar_Done) THEN
    GoToViewCarReportButtons();
   ELSE
    SetCurStatus(status_InputBoxNbr);
   END;
  ELSE
   SetCurStatus(status_ChooseCarFromList);
  END;
 END {OnClick_ChooseCar};

 PRIVATE PROCEDURE OnClick_ChooseObject(SLF: OBJECT);
 BEGIN
  IF    curObject = o_Staff THEN
   IF AccessObject(Str.Item(SLF.Text, " ", 0)) = oar_Done THEN
    prd_CurMonthBeg:=L_DatTim.MonthBeg(SYSDATE());
    SetPeriodBtn();
    GoToViewStaffReportButtons();
   ELSE
    SetCurStatus(status_ShowErrorMessage);
   END;
  ELSIF curObject = o_Car THEN
   IF SLF.Id = id_olItem + "4" THEN
    SetCurStatus(status_InputBoxNbr);
   ELSE
    IF AccessObject(Str.Item(SLF.Text, " ", 0)) = oar_Done THEN
     GoToViewCarReportButtons();
    ELSE
     SetCurStatus(status_ShowErrorMessage);
    END;
   END;
  END;
 END {OnClick_ChooseObject};

 PRIVATE PROCEDURE onClick_GroupBut(SLF: OBJECT);
 BEGIN
  curGroupButId:=SLF.Id;
  curPage      :=L_GUI.pc_GetPageById(curGroupButId);
  ProceedButtonClick(EMPTYOF(NUMERIC[0]), 0);
 END {onClick_GroupBut};

 PRIVATE PROCEDURE onClick_Report(SLF: OBJECT);
 BEGIN
  IF CalendarRequired(SLF.Id) THEN
   CalendarRepId:=SLF.Id;
   ShowCalendar(1);
  ELSE
   ProceedButtonClick(GetNbrFromButtonId(SLF.Id), 0);
  END;
 END {onClick_Report};

 PRIVATE PROCEDURE ProceedStaffList();
 BEGIN
  IF IsSingleTSN() THEN
   ObjectCode:=StfLs.TSN;
   OnClick_EnterCode(dlg.Controls.Item(id_EnterCode));
  ELSE
   SETEMPTY(ObjectCode);
   SetCurStatus(status_ChooseStaffFromList);
  END;
 END {ProceedStaffList};

 PRIVATE PROCEDURE PlayDialog();
  VAR
   gccOn           : SCAL[2];
   gcc_Finish,
   gcc_Prepare,
   gcc_CardCodeIdle: PROC;
 BEGIN
  klf_SimpleMark("StartKiosk");

  DTS_TimeOut    :=SYSTIMESTAMP();
  History[0]     := status_Enter;
  curNestingLevel:=0;

  gccOn:=0;
  IF E_UseProximityCard() & ~KioskDemoMode THEN
   P_Man.gcc_Init(gcc_Prepare, gcc_CardCodeIdle, gcc_Finish);
  END;
  ShowPage(p_Common);
  dlg.Visible:=1;
  DrawPage();

  WHILE dlg.Visible DO
   PROMPT("");
   idleProc();
   IF (History[curNestingLevel] = status_Enter) & E_UseProximityCard() & ~KioskDemoMode THEN
    SETEMPTY(curObject);
    IF PrepareStaffListByProximityCard(gccOn, gcc_Prepare, gcc_CardCodeIdle, gcc_Finish) THEN
     IF SELECT(StfLs, Contract) THEN
(*
      CheckReStartKioskRequired(1);
*)
      ProceedStaffList();
     ELSE
      ErrorMessage:="  ⨢஢";
      SetCurStatus(status_ShowErrorMessage);
     END;
    END;
   END;
   RENEWDATALAYER();
   dlg.Wait(0.1);
  END; (* WHILE dlg.Visible *)

  IF gccOn THEN
   gcc_Finish();
   gccOn:=0;
  END;
  klf_SimpleMark("ManualClose");
 END {PlayDialog};

 PUBLIC PROCEDURE Kiosk();
  VAR
  sav_cd,
  sav_fr,
  sav_ut : DATE;
 BEGIN
  SetKioskSettings();
  sav_cd:=Memo.ud_cd();
  sav_fr:=Memo.ud_fr();
  sav_ut:=Memo.ud_ut();
  SETEMPTY(History, curObject,
           ErrorMessage,
           curTSN, curMan, curManName, curStaffPost, curStaffPostName,
           curBoxNbr, curCarName,
           DTS_Renew, DTS_Renewal, DTS_StatusFile, DTS_Weather, DTS_Instr, ObjectCode);
  curNestingLevel:=0;

  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   APP.Get().NewPrompt("ଠ樮 ");
   L_General.KioskExecution_Begin();
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   GRANT_ALL_RIGHTS();
   CreateTemporaryFiles();
   CreateDialog();
   PlayDialog();
   L_General.KioskExecution_End();
  EXCEPT
  ON Exc: Exc_TermByUser DO
   klf_SimpleMark("ManualClose_ByEsc");
  ON Exc: Exc_Root DO
   klf_SimpleMarkError("CriticalError");
   L_StdFrm.TimedINFORM_AsSTOP("᪠ 訡  ࠡ ଠ樮 ᪠.|" +
                               "㤥 믮 १ ᪠.||" +
                               "ଠ  :||" +
                               Exc.MsgOriginalText, 10);
   DebugCrashkiosk("CriticalError", Exc.MsgOriginalText);
  FINALLY
   L_GUI.SetTaskBarVisible(1);
   Memo.UIP_SetCurDate(sav_cd);
   Memo.UIP_SetIntvl(sav_fr, sav_ut);
  END; (* TRY *)
 END {Kiosk};

END.
