(*
%Copyright   (c) Polak Computer System
%Author      18.12.2000 13:24:38 RSN
%Purpose     ⥪   蠡
%Type        report
%Specific    SYS
%Modified    15.04.2013 18:01:34 POLAK\Gina
%Environment
*)

 MODULE Lookstr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_StdFrm, L_Str, L_DBD, L_PCS, L_AFM, DBD, Str, L_lsStore;

 CONST
  Total_Idx    = 20;
  RepName      = "ScrXX";
  LengRep      = 142;
  LenFileAbbr  = 4;
  LenFieldAbbr = 4;

 VAR
  Pattern: STRING[];
  Idx    : SCAL[2][Total_Idx];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
'"'+Pattern+'"', L, ""
@
############################################################  ########## #####
=#####============================================================================================================================================================================
| ⥪⭮ ᪠ ଠ樨  蠡 ###########################################################################################################################|
|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|祭 ⭮襭  :                                                                                                                                                     |
}
*)

(*
$P{ Cond:
? , L, ""
@
| ###############################################################################################################################################################################|
}
*)

(*
$P{ SubTop:
?, L, ""
@
|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|ꥪ  ⭮襭 #####################|. |祭                                                                                  |                   |
|-----------------------------------------------|---------|----------------------------------------------------------------------------------------------|-----------------------|
}
*)


(*
$P{ Line:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|###############################################|#### ####|##############################################################################################|#######################|
}
*)

(*
$P{ Bot:
@
=(c) Polak========================================================================================================================================================================
}
*)

 PRIVATE PROCEDURE GetAbbreviation(_Str: STRING[]; Num: NUMERIC[0]): STRING[];
  CONST
   Sep = " -:()/\.,";
  VAR
   i,
   NumWords: NUMERIC[0];
   Words   : STRING[][100];
   Result  : STRING[];
 BEGIN
  SETEMPTY(Words);
  NumWords:=Num;
  i:=0;
  WHILE i < Num DO
   Words[i]:=Str.Item(_Str, Sep, i);
   IF !Words[i] THEN
    NumWords:=i;
    i:=Num;
   END;
   INC(i);
  END;
  Result:=Str.Slice(Words[0], 0, Num-NumWords+1);
  i:=1;
  WHILE ~!Words[i] DO
   Result:=Result+Str.Cap(Words[i][0]);
   INC(i);
  END;
  RETURN Result;
 END {GetAbbreviation};

 PRIVATE PROCEDURE GetShortFileName(File: STRING[]): STRING[];
 BEGIN
  RETURN FLDTOSTR(GetAbbreviation(DBD.FileDescription(^File), LenFileAbbr), "", LenFileAbbr);
 END {GetShortFileName};

 PRIVATE PROCEDURE GetShortFieldName(File, Field: STRING[]): STRING[];
 BEGIN
  RETURN FLDTOSTR(GetAbbreviation(DBD.FieldDescription(^File, ^Field), LenFieldAbbr), "", LenFileAbbr);
 END {GetShortFieldName};

 PRIVATE PROCEDURE LookForStr(_Str, PFileAndIndex: STRING[]);
  CONST
   StrLen = 94;
   StrArrHigh = 1024;
  TYPE
   tStr = STRING[StrLen];
  VAR
   AmntFd,
   IndexFieldNum,
   IndexFieldNumBase,
   Counter,
   i, j, n, k, A     : NUMERIC[0];
   l                 : SCAL[StrArrHigh];
   str,
   File,
   FileBase,
   FieldBase,
   Field,
   KeyBase,
   Stack,
   StackBase,
   IndexFieldName,
   IndexBase,
   FatherIndex,
   StrBase           : STRING[];
   S,
   strArr            : STRING[][StrArrHigh];
   is_lsStoreLink    : SCAL[2][StrArrHigh];
   gsv_CallProc      : PROC[StrArrHigh];
   RecordID          : NUMERIC[0];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  L_AFM.MakeMultipleIndex("_LStr", "Num: NUMERIC[0];"+   (*뢮 १  浪*)
                                   "StackBase: STRING[38];"+
                                   "StrBase: STRING[42];"+
                                   "File: STRING[16];"+
                                   "Field: STRING[16];"+
                                   "Stack: STRING[32];"+
                                   "RecordID: NUMERIC[0]",
                          "RecordID: RecordID;"+
                          "_LStr: StackBase, StrBase, Num, Stack, Field;"+
                          "File: Num, Field");

  L_AFM.MakeMultipleIndex("_LStS", "RecordID: NUMERIC[0];" +
                                   "i: NUMERIC[0];"+
                                   "Str: "+GET_TYPE_SPEC(tStr).Name,
                                   "RecordID: RecordID, i");

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top);
  RecordID:=0;
  i:=0;
  FileBase :=PushFromPool(PFileAndIndex, 0, 0);
  IndexBase:=PushFromPool(PFileAndIndex, 0, 1);
  WHILE ~!Idx[i] DO
   IF Idx[i] THEN
    File       :=PushFromPool(PFileAndIndex, i, 0);
    FatherIndex:=PushFromPool(PFileAndIndex, i, 1);
    AmntFd:=DBD.FieldAmount(^File);
    SETEMPTY(gsv_CallProc);
    SETZERO(is_lsStoreLink);
    j:=0; k:=0;
    WHILE j < AmntFd DO
     Field:=DBD.FieldName(^File, j);
     IF (TYPEOF(^File.^Field) = L_General.ft_SCAL) |
        (TYPEOF(^File.^Field) = L_General.ft_STRING) THEN
      n:=0;
      WHILE n < RANGEOF(^File.^Field) DO
       S[k]:=L_DBD.GetFullFieldName(File, Field, n);
       IF (TYPEOF(^File.^Field) = L_General.ft_SCAL) THEN
        is_lsStoreLink[k]:=L_PCS.IsLinkTo_lsStore(File, Field);
        IF ~is_lsStoreLink[k] THEN
         gsv_CallProc[k]:=L_PCS.gsv_GetCallProc(File, Field);
        END;
       END;
       INC(n);
       INC(k);
      END;
     END;
     INC(j);
    END;
    A:=k;
    SELECT(^File, ^FatherIndex);
    WHILE OCCURE(^File) DO
     Counter:=0;
     StackBase:="";
     IndexFieldNum:=DBD.IndexFieldAmount(^FileBase,^IndexBase);
     CONFORM(^File, ^FileBase);
     WHILE Counter < IndexFieldNum DO
      IndexFieldName:=FileBase + "." +
                      DBD.IndexFieldName(^FileBase, ^IndexBase, Counter);
      StackBase:=StackBase + " " + FLDTOSTR(^IndexFieldName);
      INC (Counter)
     END; (* WHILE Counter < ... *)
     PROMPT(" - 䠩 "+ File + ": " + " " + StackBase);
     k:=0;
     WHILE k < A DO
      IF is_lsStoreLink[k] THEN
       str:=L_lsStore.Get(^(S[k]));
      ELSIF ~!gsv_CallProc[k] THEN
       IF !^(S[k]) THEN
        str:="";
       ELSE
        str:=gsv_CallProc[k]();
       END;
      ELSE
       str:=^(S[k]);
      END;
      IF Str.Match(str, _Str) THEN
       KeyBase:=File + "." + DBD.IndexFieldName(^File, ^FatherIndex, 0);
       CONFORM(^File, ^FileBase);
       IF    DBD.FieldExist(^FileBase, "Name") THEN
        FieldBase:="Name";
        StrBase  :=FLDTOSTR(^FileBase.Name)
       ELSIF DBD.FieldExist(^FileBase, "Subject") THEN
        StrBase  :=FLDTOSTR(^FileBase.Subject)
       ELSE
        StrBase  :="";
       END;
       IndexFieldNum    :=DBD.IndexFieldAmount(^File, ^FatherIndex);
       IndexFieldNumBase:=DBD.IndexFieldAmount(^FileBase, ^IndexBase);
       Counter  :=0;
       Stack    :="";
       StackBase:="";
       WHILE (Counter<IndexFieldNum) DO
        IF (Counter < IndexFieldNumBase) THEN
         IndexFieldName:=FileBase + "." +
                         DBD.IndexFieldName(^FileBase, ^IndexBase, Counter);

         StackBase:=StackBase + FLDTOSTR(^IndexFieldName) + " ";
        ELSE
         IndexFieldName:=File + "." +
                         DBD.IndexFieldName(^File, ^FatherIndex, Counter);
         Stack:=Stack + FLDTOSTR(^IndexFieldName)+ " ";
        END;
        INC(Counter);
       END; (* WHILE (COUNTER<IndexFieldNum) *)
       DEFAULT(_LStr);
       _LStr.Num      :=i;
       _LStr.StackBase:=StackBase;
       _LStr.StrBase  :=StrBase;
       _LStr.File     :=File;
       _LStr.Field    :=L_DBD.ffn_GetField(S[k]);
       _LStr.Stack    :=Stack;
       _LStr.RecordID :=RecordID;
       INSERT(_LStr);

       Str.Format(strArr, str, StrLen, LEFT);
       l:=0;
       FOR_EACH l DO
        IF ~!strArr[l] THEN
         DEFAULT(_LStS);
         _LStS.RecordID:=_LStr.RecordID;
         _LStS.i:=l;
         _LStS.Str:=strArr[l];
         INSERT(_LStS);
        END;
       END;

       INC(RecordID);
      END;
      INC(k);
     END;
     NEXT(^File);
    END;
   END; (* IF Idx[i]... *)
   INC(i);
  END;

  IF SELECT(_LStr, File) THEN
   IF _LStr.File # FileBase THEN
    MAKEPART(R, Cond, GetShortFileName(FileBase)+": "+DBD.FileDescription(^FileBase));
   END;
   WHILE OCCURE(_LStr) DO
    MAKEPART(R, Cond, GetShortFileName(_LStr.File)+": "+DBD.FileDescription(^(_LStr.File)));
    NARROWSEL(_LStr, Num);
    WHILE OCCURE(_LStr) DO
     NARROWSEL(_LStr, Field);
     MAKEPART(R, Cond, " "+GetShortFieldName(_LStr.File, _LStr.Field)+": "+DBD.FieldDescription(^(_LStr.File), ^(_LStr.Field)));
     NEXTINEXTENDEDSEL(_LStr, Field);
    END; (* WHILE OCCURE(_LStr) ... *)
    NEXTINEXTENDEDSEL(_LStr, Num);
   END; (* WHILE OCCURE(_LStr) ... *)

   MAKEPART(R, SubTop, "("+GetShortFileName(FileBase)+")");
   SELECT(_LStr, _LStr);
   WHILE OCCURE(_LStr) DO
    NARROWSEL(_LStr, StackBase, StrBase);
    StackBase:=_LStr.StackBase;
    StrBase :=_LStr.StrBase;
    WHILE OCCURE(_LStr) DO
     IF SELECT(_LStS, RecordID, _LStr.RecordID) THEN
      MAKEPART(R, Line, StackBase + StrBase,
                        GetShortFileName(_LStr.File), GetShortFieldName(_LStr.File, _LStr.Field),
                        _LStS.Str, _LStr.Stack);
      WHILE NEXT(_LStS) DO
       MAKEPART(R, Line, , , , _LStS.Str, );
      END;
     END;
     SETEMPTY(StackBase, StrBase);
     NEXT(_LStr);
    END; (* WHILE OCCURE(_LStr) ... *)
    NEXTINEXTENDEDSEL(_LStr, StackBase, StrBase);
   END; (* WHILE OCCURE(_LStr) ... *)
  END;
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("_LStr");
 END {LookForStr};

 PRIVATE PROCEDURE DoCond(PFileAndIndex: STRING[]):STRING[];
 VAR
  i       : NUMERIC[0];
  FileCond: STRING[];
 BEGIN
  i:=0;
  FileCond:="";
  WHILE ~!Idx[i] DO
   IF Idx[i] THEN
    IF ~!FileCond THEN
     FileCond:=FileCond + ", ";
    END;
    FileCond:=FileCond + DBD.FileDescription(
                            ^(PushFromPool(PFileAndIndex, i, 0)));
   END;
   INC(i);
  END; (* WHILE ~!Idx[i] *)
  RETURN FileCond;
 END {DoCond};

 PRIVATE PROCEDURE PutInPool(VAR PFileAndIndex: STRING[];
                                 File,
                                 Index        : STRING[];
                                 In           : SCAL[2];
                             VAR Id           : NUMERIC[0]);
 BEGIN
  PFileAndIndex:=PFileAndIndex + File  + "," + Index + "|";
  Idx[Id]:=In;
  INC(Id);
 END {PutInPool};

 PRIVATE PROCEDURE PushFromPool(PFileAndIndex: STRING[];
                                Pos,
                                Typ          : NUMERIC[0]): STRING[];
 BEGIN
  RETURN Str.Item(L_Str.PoolItem(PFileAndIndex, Pos), ",", Typ);
 END {PushFromPool};

 PRIVATE PROCEDURE MakePool(FileName: STRING[]): STRING[];
  VAR
   i,
   MaxIdx,
   LinkKind,
   LinkCounter,
   LinkNum       : NUMERIC[0];
   PFileAndIndex,
   LinkName      : STRING[];
 BEGIN
  SETEMPTY(Idx);
  MaxIdx:=0;
  i     :=0;
  PFileAndIndex:="";
  PutInPool(PFileAndIndex, FileName, DBD.IndexName(^FileName, 0), 1, MaxIdx);
  REPEAT
   LinkCounter:=0;
   FileName   :=PushFromPool(PFileAndIndex, i, 0);
   LinkNum    :=DBD.LinkAmount(^FileName);
   WHILE (LinkCounter < LinkNum) DO
    LinkName:=DBD.LinkName(^FileName, LinkCounter);
    LinkKind:=DBD.LinkKind(^FileName, ^LinkName);
    IF ((LinkKind = L_General.lk_LEND) | (LinkKind = L_General.lk_REVERSE_HISTORY)) THEN
     PutInPool(PFileAndIndex,
               DBD.LinkCooFileName(^FileName, ^LinkName),
               DBD.LinkIndexName  (^FileName, ^LinkName),
               0, MaxIdx);
     L_General.CallUs(MaxIdx < Total_Idx);
    END;
    INC(LinkCounter);
   END; (* WHILE (LinkCounter < NLinkNum) *)
   INC(i)
  UNTIL !L_Str.PoolItem(PFileAndIndex, i);
  RETURN PFileAndIndex
 END {MakePool};
 
 PRIVATE PROCEDURE DoDialogAndSetPattern(PFileAndIndex:STRING[]);
  CONST
   FieldWith = 50;
  VAR
   PIdx,
   MsgAdd,
   File,
   Msg,
   FileDesc        : STRING[];
   i,
   ChooseFileAmount: NUMERIC[0];
 BEGIN
  i      :=0;
  PIdx   :="";
  Pattern:="";
  MsgAdd :="";
  WHILE ~!Idx[i] DO
   File    :=PushFromPool(PFileAndIndex, i, 0);
   FileDesc:=Str.Align(DBD.FileDescription(^File), FieldWith, LEFT);
   MsgAdd  := MsgAdd + "|" + "%<" + FileDesc + ">E";
   IF ~!PIdx THEN
    PIdx:=PIdx + ", ";
   END;
   PIdx:=PIdx + "Idx[" + L_Str.IntStr(i) + "]";
   INC(i);
  END; (* WHILE *)
  Msg:="| ப  ᪠"+
       "||%"+L_Str.IntStr(FieldWith+4) + "I"+
       "|"+
       "|  ᪠"+
       MsgAdd+
       "||"+
       L_StdFrm.DrawButton("᪠", 12, "DB") + "  " +
       L_StdFrm.DrawButton("⬥", 12, "X");
  LOOP
   STDFORM(Msg, "  ଠ樨 ", , 1, Pattern, ^PIdx);

   SETZERO(ChooseFileAmount, i);
   WHILE ~!Idx[i] DO
    IF Idx[i] = 1 THEN
     INC(ChooseFileAmount);
    END;
    INC(i);
   END; (* WHILE *)
   IF ChooseFileAmount = 0 THEN
    L_StdFrm.RedInform(" ࠭    ᪠");
   ELSE
    EXIT;
   END;
  END; (* LOOP *)
 END {DoDialogAndSetPattern};

 PRIVATE PROCEDURE cf_AcceptableFile(File: STRING[]): SCAL[2];
 BEGIN
  RETURN (File = GE_CURFILE()) | (AMOUNT(^File) < 10000);
 END {cf_AcceptableFile};

 PUBLIC PROCEDURE ScrXX();
  VAR
   FileName,
   PFileAndIndex: STRING[];
 BEGIN
  FileName:=GE_CURFILE();
  IF !FileName THEN
   FileName:=L_DBD._ChooseFileName(" ଠ樨  ⥪", PROCREF(cf_AcceptableFile), 1);
  END;
  IF ~!FileName THEN
   PFileAndIndex:=MakePool(FileName);
   DoDialogAndSetPattern(PFileAndIndex);
   LookForStr("*"+Pattern+"*", PFileAndIndex);
  END;
 END {ScrXX};
 
END.
