(*
%Copyright   (c) Polak Computer System
%Author      21.07.2004 14:14:56 POLAK\San
%Purpose     প AcCut
%Type        library
%Specific    SYS
%Modified    24.09.2014 16:09:51 LDA
%Environment
*)

 MODULE L_AcCut [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  erkn_Fictive                = 010459800;
  erkn_OnlineBalance          = 010459801;
  erkn_BoughtKeyAssVAT        = 010459803;
  erkn_BoughtInventoryVAT     = 010459804;
  erkn_BoughtGoodsVAT         = 010459805;
  erkn_BoughtVATInCost        = 010459806;
  erkn_BoughtVATTransit       = 010459807;
  erkn_VATAccumulation        = 010459808;
  erkn_AccountableMan         = 010459809;
  erkn_FuelInTanks            = 010459810;
  erkn_Salary                 = 010459811;
  erkn_TokenCoins             = 010459812;
  erkn_CashShortage           = 010459814;
  erkn_SalaryDeposit          = 010459815;
  erkn_VATPrepay              = 010459816;
  erkn_VATUnderpay            = 010459818;
  erkn_SocialInsurance        = 010459819;
  erkn_Salary_CA              = 010459820;
  erkn_VacationProvision      = 010459821;
  erkn_LeavedManDebts         = 010459822;
  erkn_OperationalCashOffices = 010459823;
  erkn_CentralCashOffice      = 010459824;
  erkn_SettlementAccounts     = 010459825;
  erkn_Profit_Losses          = 010487900;

  sldt_wAmount       = 0;
  sldt_DebitCredit   = 1;
  sldt_OnlyDebit     = 2;
  sldt_OnlyCredit    = 3;
  sldt_wAmountCredit = 4;
  sldt_Pool = " ⢮ (⮢)|⮢  ।⮢|쪮 ⮢|쪮 ।⮢| ⢮ (।⮢)";
  sldt_PoolShort = "||||";

 IMPORT L_General, L_DatTim, L_APtm, L_XObj, Str, L_StdFrm, L_Pmnt, L_Acnt, L_XDoc, L_AFM;

(*!*) PUBLIC PROCEDURE erkn_GetSoft(D: DATE; _Notion: L_APtm.tNotion): LIKE(AcCut.AcCut);
 BEGIN
  RETURN L_kn.GetSoft(D, _Notion);
 END {erkn_GetSoft};

(*!*) PUBLIC PROCEDURE erkn_Get(D: DATE; _Notion: L_APtm.tNotion): LIKE(AcCut.AcCut);
 BEGIN
  RETURN L_kn.Get(D, _Notion);
 END {erkn_Get};

 PUBLIC PROCEDURE Fictive(): LIKE(AcCut.AcCut);
 BEGIN
  RETURN 000; (*L_kn.Get(SYSDATE(), erkn_Fictive);*)
 END {Fictive};

(*!*) PUBLIC PROCEDURE PositionOnAcCut(_AcCut: LIKE(AcCut.AcCut));
 BEGIN
  L_General.CallUs(SEARCH(AcCut, AcCut, _AcCut));
 END {PositionOnAcCut};

 PRIVATE PROCEDURE cacgh_XDocApr_SingleSide(leftSide: SCAL[2]);
 BEGIN
  LOOP
   L_XObj.SelectXDocAprByXApport(leftSide);
   IF ~OCCURE(XDocApr) THEN
    EXIT;
   END;
   IF leftSide THEN
    SETEMPTY(XDocApr.XObject, XDocApr.Apport);
   ELSE
    SETEMPTY(XDocApr.XObject2, XDocApr.Apport2);
   END;
   REPLACE(XDocApr);
   IF !XDocApr.XObject & !XDocApr.XObject2 THEN
    REMOVE(XDocApr);
   END;
  END; (* LOOP *)
 END {cacgh_XDocApr_SingleSide};

 PRIVATE PROCEDURE cacgh_SingleXObjectAcCut(P: DATE);
  VAR
   _XDat: LIKE(XCalc.XDat);
 BEGIN
  LAST(XCalc);
  WHILE OCCURE(XCalc) DO
   SELECT(XApport, XObject, , XCalc.XObject, XCalc.AcCut, XCalc.XDat);
   WHILE OCCURE(XApport) DO
    IF (XApport.WFDate < P) & (~L_Acnt.IsEntranceApport(XApport.Apport) | (XApport.WFDate < L_DatTim.IncMonth(P, -1))) THEN
     L_XObj.AddXA2XC(-1);
     cacgh_XDocApr_SingleSide(0);
     cacgh_XDocApr_SingleSide(1);
     REMOVE(XApport);
    ELSE
     NEXT(XApport);
    END;
   END; (* WHILE OCCURE(XApport) ... *)
   IF XCalc.XDat >= P THEN
    REPLACE(XCalc);
    PREV(XCalc);
   ELSE
    IF ~FIRST(XApport) &
       ~SELECT(XApport, WFD, XCalc.XObject, XCalc.AcCut, XCalc.XDat) THEN
     _XDat:=XCalc.XDat;
     REMOVE(XCalc);
     SRCINSEL(XCalc, LT, , _XDat);
    ELSE
     REPLACE(XCalc);
     PREV(XCalc);
    END;
   END;
  END; (* WHILE OCCURE(XCalc) *)
  IF FIRST(XCalc) THEN
   SETZERO(XCalc.SldSum, XCalc.SldQnt, XCalc.RSlSum, XCalc.RSlQnt);
   REPLACE(XCalc);
   CONFORM(XCalc, XObject);
   L_XObj.extBalXCalc(1);
  END;
 END {cacgh_SingleXObjectAcCut};

 PUBLIC PROCEDURE ClearAcCutGarbageHistory(trgAcCut: LIKE(AcCut.AcCut); Silent: SCAL[2]);
  VAR
   P        : DATE;
   ClearCntr: SCAL[2];
 BEGIN
  L_General.SilentPrgsOnly();
  SAVE(AcCut);
  SEARCH(AcCut, AcCut, , trgAcCut);
  P:=L_XObj.GetBeginOfAccountingOnAcCut(AcCut.AcCut);

  IF ~!P THEN
   IF ~Silent THEN
    L_StdFrm.Choice("  ࠧ१ " + trgAcCut + "  㤠  " + L_DatTim.PeriodStr(P) + "!");
   END;
  ELSE
   L_StdFrm.Choice(" ࠧ१ " + trgAcCut + "  ।  砫 |  㤠   !");
   P:=L_DatTim.Per(MAXOF(DATE)); (*    -  L_DatTim.IncMonth(P, -1)   ⥪*)
  END;
  IF L_Pmnt.ItCntrBalAcCut(AcCut.AcCut, P) THEN
   ClearCntr:=1;
  ELSE
   ClearCntr:=0;
  END;
  SELECT(XCalc, AcCut, , AcCut.AcCut);
  WHILE OCCURE(XCalc) DO
   PROMPT(XCalc.XObject);
   NARROWSEL(XCalc, XObject);
   L_XObj.AccessXObject(XCalc.XObject);
   cacgh_SingleXObjectAcCut(P);
   IF ClearCntr & (XObject.Origin = L_XObj.o_Contract) THEN
    L_XObj.AccessOrigin();
    IF SEARCH(ACSetL, ACSet, Contract.ACSet, L_Acnt.acp_Contract_Netto) &
       (ACSetL.AcCut = trgAcCut) THEN

     IF SELECT(XODone, XObject, XObject.XObject) & (XODone.Period < P) THEN
      L_XObj.XODone_SetSingleIntermediate(XODone.Period, L_XObj.xoid_Contract_SpecVATMDocNeed, 0, 0);
     END;

     SAVE(XCalc);
     SELECT(XCalc, XObject, , XObject.XObject);
     WHILE OCCURE(XCalc) DO
      NARROWSEL(XCalc, AcCut);
      cacgh_SingleXObjectAcCut(P);
      NEXTINEXTENDEDSEL(XCalc, AcCut);
     END; (* WHILE OCCURE(XCalc) ... *)
     L_Pmnt.PrepareContractBalanceHistory(Contract.Contract, L_DatTim.IncMonth(P, -1), P-1);
     SELECT(CnBHs, CnBHs, , XObject.XObject);
     WHILE OCCURE(CnBHs) DO
      L_General.CallUs(L_XDoc.StandOnXDoc(CnBHs.XDocId));
      IF L_XDoc.ExtractXDocType(CnBHs.XDocId) = L_XDoc.xdt_PDoc THEN
       L_General.Error("㤠 稬  㬥? " + PDoc.PDocKind + " " + PDoc.PDoc);
      ELSE
       L_Pmnt.SupportOnlineBalance(L_XDoc.xdt_MDoc, +1);
      END;
      NEXT(CnBHs);
     END; (* WHILE OCCURE(CnBHs) ... *)
     L_AFM.AF_PurgeTemp("CnBHs");
     RESTORE(XCalc);
    END;
   END;
   NEXTINEXTENDEDSEL(XCalc, XObject);
  END; (* WHILE OCCURE(XCalc) ... *)
  RESTORE(AcCut);
 END {ClearAcCutGarbageHistory};

END.
