(*
%Copyright   (c) Polak IT
%Author      19.02.2007 12:43:11 POLAK\GAV
%Purpose
%Type        library
%Specific    SYS
%Modified    12.08.2011 14:07:55 ROBOT by POLAK\San
%Environment
*)

 MODULE L_AcMth [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Math, L_General, L_DatTim, L_XDoc, L_MDoc, L_PDoc, L_AFM;

 TYPE
  DocType = SCAL[Math.Max(MAXOF(PDoc.PDoc), MAXOF(MDoc.MDoc))+1];

 PRIVATE PROCEDURE ltbam_Create();
 BEGIN
  CreateFILE(ltbam, "", "", "");

  CreateFIELD(ltbam, DocType, L_XDoc.tXDocType,     "", "", "", " 㬥", "");
  CreateFIELD(ltbam, DocKind, LIKE(MDoc.MDocKind),  "", "", "", " 㬥", "");
  CreateFIELD(ltbam, Doc,     DocType,              "", "", "", " 㬥", "");
  CreateFIELD(ltbam, Date,    LIKE(MDoc.Date),      "", "", "", " 㬥", "");
  CreateFIELD(ltbam, Math,    LIKE(MDocList.Math),  "", "", "", "", "");
  CreateFIELD(ltbam, MMode:   LIKE(MDocList.MMode), "", "", "", "", "");
  CreateFIELD(ltbam, Sum,     NUMERIC[2],           "", "", "", "㬬", "");
  CreateFIELD(ltbam, Num,     NUMERIC[2],           "", "", "", "⢮", "");

  CreateINDEXandLINK(ltbam, Math,     UNIQUE, Math, Math, USER, "", "", Math, DocType, DocKind, Date, Doc, MMode);
  CreateINDEX       (ltbam, DocDate,  UNIQUE,                   "", "", DocType, DocKind, Date, Doc, Math, MMode);
  CreateINDEX       (ltbam, MathKAGL, PLURAL,                   "", "", DocType, Math, Date);

  SetVersionOfFILE(ltbam, 0);
  L_AFM.CreateTemp("ltbam");
 END {ltbam_Create};

 PUBLIC PROCEDURE ltbam_Purge();
 BEGIN
  L_AFM.AF_PurgeTemp("ltbam");
 END {ltbam_Purge};

 PRIVATE PROCEDURE ltmbam_Prepare(_From,
                                  _UpTo          : DATE;
                                  _Dest          : LIKE(Dest.Dest);
                                  _MDocKindCond,
                                  _MDocCond,
                                  _MDocListCond  : PROC;
                                  VAR ltbam_Count: NUMERIC[0];
                                  MakeIndex      : SCAL[2]);
  VAR
   _Math: LIKE(Math.Math);
 BEGIN
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF _MDocKindCond() THEN
    SELECT(MDoc, MDKDest, , MDocKind.MDocKind, _Dest);
    SRCINSEL(MDoc, LE, , _UpTo);
    WHILE OCCURE(MDoc) & (MDoc.Date >= _From) DO
     PROMPT(" " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
     IF _MDocCond() THEN
      SELECT(MDocList, MDLMath, , MDoc.MDocKind, MDoc.MDoc);
      WHILE OCCURE(MDocList) DO
       L_MDoc.soByMDL_Math();
       IF _MDocListCond() THEN
        INC(ltbam_Count);
        IF MakeIndex  THEN
         IF L_MDoc.IsMDoc_woMath(MDoc.MDocKind) THEN
          SETEMPTY(_Math);
         ELSE
          _Math:=Math.Math;
         END;
         ADD(ltbam, Math, , _Math, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.Date, MDoc.MDoc, MDocList.MMode,
             ltbam.Sum, MDocList.Sum,
             ltbam.Num, MDocList.Qnt);
        ELSE
         RETURN;
        END;
       END;
       NEXT(MDocList);
      END; (* WHILE OCCURE(MDocList) ... *)
     END;
     PREV(MDoc);
    END; (* WHILE OCCURE(MDoc) ... *)
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
 END {ltmbam_Prepare};

 PRIVATE PROCEDURE ltpbam_Prepare(_From,
                                  _UpTo          : DATE;
                                  _Dest          : LIKE(Dest.Dest);
                                  _PDocKindCond,
                                  _PDocCond      : PROC;
                                  VAR ltbam_Count: NUMERIC[0];
                                  MakeIndex      : SCAL[2]);
 BEGIN
  SELECT(PDocKind, PDocKind);
  WHILE OCCURE(PDocKind) DO
   IF _PDocKindCond() THEN
    SELECT(PDoc, PDKDest, , PDocKind.PDocKind, _Dest);
    SRCINSEL(PDoc, LE, , _UpTo);
    WHILE OCCURE(PDoc) & (PDoc.Date >= _From) DO
     PROMPT(" " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
     IF _PDocCond() THEN
      INC(ltbam_Count);
      IF MakeIndex  THEN
       ADD(ltbam, DocDate, , L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.Date, PDoc.PDoc, "", "");
      ELSE
       RETURN;
      END;
     END;
     PREV(PDoc);
    END; (* WHILE OCCURE(PDoc) ... *)

    SELECT(PDocMDoc, PDKDest, , PDocKind.PDocKind, _Dest);
    SRCINSEL(PDocMDoc, LE, , _UpTo);
    WHILE OCCURE(PDocMDoc) & (PDocMDoc.PDocDate >= _From) DO
     CONFORM(PDocMDoc, PDoc);
     PROMPT(" " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
     IF _PDocCond() THEN
      INC(ltbam_Count);
      IF MakeIndex  THEN
       ADD(ltbam, DocDate, , L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.Date, PDoc.PDoc, "", "");
      ELSE
       RETURN;
      END;
     END;
     PREV(PDocMDoc);
    END; (* WHILE OCCURE(PDocMDoc) ... *)
   END;
   NEXT(PDocKind);
  END; (* WHILE OCCURE(PDocKind) ... *)
 END {ltpbam_Prepare};

 PUBLIC PROCEDURE ltbam_Has(_From,
                            _UpTo         : DATE;
                            _Dest         : LIKE(Dest.Dest);
                            _MDocKindCond,
                            _MDocCond,
                            _MDocListCond,
                            _PDocKindCond,
                            _PDocCond     : PROC): SCAL[2];
  VAR
   ltbam_Count: NUMERIC[0];
 BEGIN
  ltbam_Count:=0;
  ltmbam_Prepare(_From, _UpTo, _Dest, _MDocKindCond, _MDocCond, _MDocListCond, ltbam_Count, 0);
  IF ltbam_Count = 0 THEN
   ltpbam_Prepare(_From, _UpTo, _Dest, _PDocKindCond, _PDocCond, ltbam_Count, 0);
  END;
  RETURN ltbam_Count > 0;
 END {ltbam_Has};

 PUBLIC PROCEDURE ltbam_MakeIndex(_From,
                                  _UpTo         : DATE;
                                  _Dest         : LIKE(Dest.Dest);
                                  _MDocKindCond,
                                  _MDocCond,
                                  _MDocListCond,
                                  _PDocKindCond,
                                  _PDocCond     : PROC);
  VAR
   ltbam_Count: NUMERIC[0];
   oPrompt: PROMPTLINE;
 BEGIN
  oPrompt:=PROMPTLINE.Create("");
  ltbam_Count:=0;
  ltbam_Create();
  ltmbam_Prepare(_From, _UpTo, _Dest, _MDocKindCond, _MDocCond, _MDocListCond, ltbam_Count, 1);
  ltpbam_Prepare(_From, _UpTo, _Dest, _PDocKindCond, _PDocCond, ltbam_Count, 1);
 END {ltbam_MakeIndex};

 PUBLIC PROCEDURE CheckDupCurAcMthA(_DGroup  : LIKE(AcMthA.DGroup);
                                    _Dest    : LIKE(AcMthA.Dest);
                                    _MathType: LIKE(AcMthA.MathType);
                                    _MMode   : LIKE(AcMthA.MMode));
  VAR
   _AcMth : LIKE(AcMth.AcMth);
   _Begin,
   _Till  : DATE;
 BEGIN
  _AcMth:=AcMthA.AcMth;
  _Begin:=AcMthA.Begin;
  _Till :=AcMthA.Till;
  SAVE(AcMthA);
  SELECT(AcMthA, DGroup, , _DGroup, _Dest, _MathType, _MMode);
  WHILE OCCURE(AcMthA) DO
   IF AcMthA.AcMth # _AcMth THEN
    L_General.Assert(~L_DatTim.IsActiveInIntvl(_Begin, _Till, AcMthA.Begin, AcMthA.Till),
                     "祭 奬 "+ _AcMth +"  奬 " + AcMthA.AcMth);
   END;
   NEXT(AcMthA);
  END;
  RESTORE(AcMthA);
 END {CheckDupCurAcMthA};

 PUBLIC PROCEDURE CheckDupCurAcMth(_DGroup: LIKE(AcMth.DGroup);
                                   _Dest  : LIKE(AcMth.Dest));
  VAR
   _AcMth : LIKE(AcMth.AcMth);
   _Begin,
   _Till  : DATE;
 BEGIN
  IF SELECT(AcMthA, AcMth, AcMth.AcMth) THEN
   WHILE OCCURE(AcMthA) DO
    CheckDupCurAcMthA(_DGroup, _Dest, AcMthA.MathType, AcMthA.MMode);
    NEXT(AcMthA);
   END; (* WHILE OCCURE(AcMthA) ... *)
  ELSE
   _AcMth:=AcMth.AcMth;
   _Begin:=AcMth.Begin;
   _Till :=AcMth.Till;
   SAVE(AcMth);
   SELECT(AcMth, DGroup, , _DGroup, _Dest);
   WHILE OCCURE(AcMth) DO
    IF AcMth.AcMth # _AcMth THEN
     L_General.Assert(~L_DatTim.IsActiveInIntvl(_Begin, _Till, AcMth.Begin, AcMth.Till),
                      "祭 奬 "+ _AcMth +"  奬 " + AcMth.AcMth);
    END;
    NEXT(AcMth);
   END;
   RESTORE(AcMth);
  END;
 END {CheckDupCurAcMth};

END.
