(*
Copyright   (c) Polak Computer System
%Author      09.08.2001 17:18:29 SAN
%Purpose     壠᪨ 
%Type        library
%Specific    SYS
%Modified    17.09.2014 16:59:33 POLAK\San
%Environment
*)

 MODULE L_Acnt [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tAcntVectorPart   = SCAL[4];
  tAcntVector       = NUMERIC[2][MAXOF(tAcntVectorPart)+1];

  tUnfoldedAcntVectorPart     = SCAL[6];
  tUnfoldedAcntVector         = NUMERIC[2][MAXOF(tUnfoldedAcntVectorPart)+1];
  tUnfoldedAcntQuantityVector = NUMERIC[2][MAXOF(tUnfoldedAcntVectorPart)+1];

  tCirSource = SCAL[16];

  tCirComponent = SCAL[5];
  tCirComponentCalculationManner = SCAL[3];

  tAccountingKind   = SCAL[3];
  tAccountingMethod = SCAL[2];

  tMathTypeCategory = SCAL[7];
  tAcMthOrigin      = SCAL[32];
  tAcCutPurpose     = SCAL[16];
  tACSetKind        = SCAL[8];

 PUBLIC CONST
  avp_InSaldo  = 0;
  avp_Debit    = 1;
  avp_Credit   = 2;
  avp_OutSaldo = 3;

  uavp_ISlDbt = 0;
  uavp_ISlCrd = 1;
  uavp_CirDbt = 2;
  uavp_CirCrd = 3;
  uavp_OSlDbt = 4;
  uavp_OSlCrd = 5;

  uavp_Pool = "呫|呫।||।|呫|呫।";

  ck_MoneyOnly      = 0;
  ck_ExplicitCir    = 1;
  ck_EstimatedCir   = 2;
  ck_SpecialCir     = 3;

  ck_Pool           = "쪮 죨| |㬬 ⭠|樠 ";
  ck_Pool_SH        = "|||";
  ck_Pool_ConstName = "ck_MoneyOnly|ck_ExplicitCir|ck_EstimatedCir|ck_SpecialCir";

  ct_Credit = 0;
  ct_Debit  = 1;
  ct_Pool   = "।|";

  dt_Credit    = 0;
  dt_Debit     = 1;
  dt_Undefined = 2;

  dt_Pool = "室|室|  㬥";

  cs_MDoc           = 0;
  cs_PDoc           = 1;
  cs_PDocMDoc       = 2;
  cs_PDocList       = 3;
  cs_XCalc          = 4;
  cs_Dfrls          = 5;

  cs_Pool           = "ப ⮢୮ 㬥|"+
                      "㬬 ⥦ 㬥|"+
                      "㬬 뫪    |"+
                      "㬬 뫪    |"+
                      " 楢 |"+
                      "ࠢ ᯨᠭ |";
  cs_Pool_SH        = "|||||";
  cs_Pool_ConstName = "cs_MDoc|cs_PDoc|cs_PDocMDoc|cs_PDocList|cs_XCalc|cs_Dfrls";

  cc_Netto   = 0;
  cc_VAT     = 1;
  cc_SaleTax = 2;
  cc_Amount  = 3;
  cc_Kg      = 4;

  cccm_Not    = 0;
  cccm_AsIs   = 1;
  cccm_Storno = 2;

  cccm_Pool    = "0|+|-";
  cccm_Pool_SH = " |+|-";

  cvat_Not            = 0;
  cvat_Allow          = 1;
  cvat_NotAllow       = 2;
  cvat_VATOnlyAllow   = 3;

  cvat_Pool           = "⨬ ਬ 'ᮡ  '|"+
                        "    ᮮ⢥⢨  'Cᮡ  '|"+
                        "⭮⥫쭮 'Cᮡ  '|"+
                        "쪮   ᮮ⢥⢨  'Cᮡ  '";
  cvat_Pool_SH        = "|+||!";
  cvat_Pool_ConstName = "cvat_Not|cvat_Allow|cvat_NotAllow|cvat_VATOnlyAllow";

  ak_Acn = 0; (*tAccountingKind*)
  ak_Tax = 1;
  ak_Bth = 2;

  am_Cash    = 0;
  am_Accrual = 1;

  mtyp_Money    = 99; (* ? *)

  mtc_None         = 0;
  mtc_Inventories  = 1;
  mtc_Expenses     = 2;
  mtc_Gains        = 3;
  mtc_StrangeGains = 4;

  mtc_Pool = "||室 ᪫㥬|室|室/室 '㦨'";

  fictAcCut     = 000;

  fictACSet = 0000;

  amo_Global           = 00;
  amo_Man              = 01;
  amo_Contract         = 02;
  amo_Math             = 03;
  amo_MathInAH         = 04;
  amo_CostItem         = 05;
  amo_MathByStr        = 06;
  amo_MathByStr2       = 07;
  amo_MathByCntr       = 08;
  amo_MathByCar        = 09;
  amo_MathByTO         = 10;
  amo_Recast           = 11;
  amo_MathOfComplexCUC = 12;
  amo_CostItemByMDL    = 13;
  amo_OprDsk           = 14;

  amo_Pool             = "/  |"+
                         "|"+
                         "|"+
                         "  |"+
                         " (/)|"+
                         "|"+
                         " |"+
                         " 2|"+
                         " |"+
                         " |"+
                         " |"+
                         "⢥|"+
                         " |"+
                         "  ᯨ᪠|"+
                         "";

  amo_Pool_SH          = "|||||||2|||||||";
  amo_Pool_ConstName   = "amo_Global|amo_Man|amo_Contract|amo_Math|amo_MathInAH|amo_CostItem|amo_MathByStr|amo_MathByStr2|amo_MathByCntr|amo_MathByCar|amo_MathByTO|amo_Recast|amo_MathOfComplexCUC|amo_CostItemByMDL|amo_OprDsk";

  acp_Nothing          = 00;
  acp_CostItem_Default = 01;
  acp_Contract_Netto   = 02;
  acp_CostItemDfrls    = 03;
  acp_Math_Netto       = 04;
  acp_Math_VAT         = 05;
  acp_MathSale_Netto   = 06;
  acp_MathSale_VAT     = 07;
  acp_MathInAdvHld     = 08;
  acp_MathInKeeping    = 09;
  acp_MathOffSite      = 10;
  acp_RecExpSaldo      = 11;
  acp_CostItemSale     = 12;
  acp_CostPrice        = 13;

  acp_Pool = "|"+
             "室  |"+
             "  |"+
             "  |"+
             " ()|"+
             " ()|"+
             "த ()|"+
             "த ()|"+
             "  |"+
             "  ⢥⢥ ࠭|"+
             "  ஭ ࠡ⪥|"+
             "줮 室  室 ()|"+
             "室  |"+
             "⮨";

  acp_Pool_SH = " |"+
                "_|"+
                "_|"+
                "_࡯|"+
                "_|"+
                "_|"+
                "_|"+
                "_|"+
                "/|"+
                "|"+
                "|"+
                "_|"+
                "_|"+
                "_";

  acp_Pool_ConstName = "acp_Nothing|acp_CostItem_Default|acp_Contract_Netto|acp_CostItemDfrls|acp_Math_Netto|acp_Math_VAT|acp_MathSale_Netto|acp_MathSale_VAT|acp_MathInAdvHld|acp_MathInKeeping|acp_MathOffSite|acp_RecExpSaldo|acp_CostItemSale|acp_CostPrice";

  acsk_Math     = 0;
  acsk_CostItem = 1;
  acsk_Contract = 2;

  acsk_Pool = " || ⮢";

  catyp_Balance = 0;
  catyp_Tax     = 1;
  catyp_Online  = 2;

  catyp_Pool    = "ᮢ | |⨢ ";

 IMPORT L_General, L_EC, L_Money, L_DatTim, L_OwnData, L_MathR, L_PDoc, L_XDR,
        L_XObj, L_MDoc, L_Pmnt, Math, Str, E_Stock, P_Math, P_OwnData, L_Stock, P_Firm, L_XDoc,
        L_Str, L_JDoc, L_StdFrm;

 IMPORT Memo;

 PRIVATE VAR
  CurAcMthMyFirm: P_Firm.tMyFirm;

 PUBLIC PROCEDURE E_Apport_MoneyCredit(D: DATE): LIKE(Apport.Apport);
 BEGIN
  RETURN 001;
 END {E_Apport_MoneyCredit};

 PUBLIC PROCEDURE E_Apport_MoneyDebit(D: DATE): LIKE(Apport.Apport);
 BEGIN
  RETURN 002;
 END {E_Apport_MoneyDebit};

 PUBLIC PROCEDURE E_Apport_FuelWriteOff(D: DATE): LIKE(Apport.Apport);
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D,
                                 PROCREF(E_Stock.Apport_DepreciationCharge),
                                 020);
 END {E_Apport_FuelWriteOff};

 PUBLIC PROCEDURE E_Apport_RemainderOfRound(D: DATE): LIKE(Apport.Apport);
 BEGIN
  RETURN 997;
 END {E_Apport_RemainderOfRound};

 PUBLIC PROCEDURE E_Apport_AdjustmentOfPrices(D: DATE): LIKE(Apport.Apport);
 BEGIN
  RETURN 999;
 END {E_Apport_AdjustmentOfPrices};

 PUBLIC PROCEDURE E_AcCut_AdjustmentOfPrices(D: DATE): LIKE(AcCut.AcCut);
 BEGIN
  RETURN 999;
 END {E_AcCut_AdjustmentOfPrices};

 PUBLIC PROCEDURE E_FictDest(): LIKE(Dest.Dest);
  CONST
   FictDest = 0000;
 BEGIN
  SAVE(Dest);
  IF ~SEARCH(Dest, Dest, FictDest) THEN
   TRY [TRANSACTION(TRANSACTION_SLAVE)]
    DEFAULT(Dest);
    Dest.Dest :=FictDest;
    Dest.Name :="⨢";
    Dest.Type :=dt_Undefined;
    Dest.Begin:=01\01\1991;
    INSERT(Dest);
   EXCEPT
   END; (* TRY *)
  END;
  RESTORE(Dest);
  RETURN FictDest;
 END {E_FictDest};

 PUBLIC PROCEDURE E_RealDest(_Dest: LIKE(Dest.Dest)): SCAL[2];
 BEGIN
  RETURN _Dest # E_FictDest();
 END {E_RealDest};

 PUBLIC PROCEDURE GetInclTaxByPrc(OnDate: DATE; _Total: L_XObj.tSum; Prc: FLOAT): L_XObj.tSum;
 BEGIN
  RETURN L_Money.RoundMoney(L_DatTim.Per(OnDate), Prc*_Total/(100+Prc));
 END {GetInclTaxByPrc};

 PUBLIC PROCEDURE GetExclTaxByPrc(OnDate: DATE; _Sum: L_XObj.tSum; Prc: FLOAT): L_XObj.tSum;
 BEGIN
  RETURN L_Money.RoundMoney(L_DatTim.Per(OnDate), Prc*_Sum/100);
 END {GetExclTaxByPrc};

 PUBLIC PROCEDURE GetInclVAT(OnDate: DATE; Sum_wVAT: L_XObj.tSum): L_XObj.tSum;
 BEGIN
  RETURN GetInclTaxByPrc(OnDate, Sum_wVAT, L_Pmnt.VATValue(L_Pmnt.GetStandartVATRate(OnDate)));
 END {GetInclVAT};

 PUBLIC PROCEDURE GetExclVAT(OnDate: DATE; Sum_woVAT: L_XObj.tSum): L_XObj.tSum;
 BEGIN
  RETURN GetExclTaxByPrc(OnDate, Sum_woVAT, L_Pmnt.VATValue(L_Pmnt.GetStandartVATRate(OnDate)));
 END {GetExclVAT};

 PRIVATE PROCEDURE GetMathVATValue(_Math: LIKE(Math.Math); D: DATE): NUMERIC[0];
  VAR
   satVAT: P_Math.tSpecialAttitudeToVAT;
 BEGIN
  satVAT:=P_Math.GetSpecialAttitudeToVAT(_Math, D);
  IF    satVAT = P_Math.satVAT_woFeatures THEN
   RETURN L_Pmnt.VATValue(L_Pmnt.GetStandartVATRate(D));
  ELSIF satVAT = P_Math.satVAT_TaxFree THEN
   RETURN 0;
  ELSIF satVAT = P_Math.satVAT_IncentiveRate THEN
   RETURN L_Pmnt.VATValue(L_Pmnt.GetPreferentialVATRate(D));
  ELSE
   L_General.CallUs(0);
  END;
 END {GetMathVATValue};

 PUBLIC PROCEDURE GetInclMathVAT(_Math: LIKE(Math.Math); OnDate: DATE; Sum_wVAT: L_XObj.tSum): L_XObj.tSum;
 BEGIN
  RETURN GetInclTaxByPrc(OnDate, Sum_wVAT, GetMathVATValue(_Math, OnDate));
 END {GetInclMathVAT};

 PUBLIC PROCEDURE GetExclMathVAT(_Math: LIKE(Math.Math); OnDate: DATE; Sum_woVAT: L_XObj.tSum): L_XObj.tSum;
 BEGIN
  RETURN GetExclTaxByPrc(OnDate, Sum_woVAT, GetMathVATValue(_Math, OnDate));
 END {GetExclMathVAT};

 PUBLIC PROCEDURE AccessACLog(D: DATE; _AcCut: LIKE(AcCut.AcCut));
 BEGIN
  SETSEL(ACLog, AcCut, _AcCut);
  IF ~SRCINSEL(ACLog, LE, D) THEN
   L_StdFrm.WrongDB("⭮ ࠧ१ "+_AcCut + "  ᮯ⠢   " + L_DatTim.DateStr(D));
  END;
 END {AccessACLog};

 PUBLIC PROCEDURE StandOnCAcnt(D: DATE; _AcCut: LIKE(AcCut.AcCut));
 BEGIN
  AccessACLog(D, _AcCut);
  CONFORM(ACLog, CAcnt);
 END {StandOnCAcnt};

 PUBLIC PROCEDURE GetCAcntSign(D: DATE; _AcCut: LIKE(AcCut.AcCut)): LIKE(CAcnt.Sign);
 BEGIN
  StandOnCAcnt(D, _AcCut);
  RETURN CAcnt.Sign;
 END {GetCAcntSign};

 PUBLIC PROCEDURE GetAcCutSign(D: DATE; _AcCut: LIKE(AcCut.AcCut)): LIKE(AcCut.Sign);
 BEGIN
  AccessACLog(D, _AcCut);
  RETURN ACLog.Sign;
 END {GetAcCutSign};

 PUBLIC PROCEDURE E_SetMathPriceOnline(P: DATE): SCAL[2];
 BEGIN
  RETURN L_General.IsPolakSpecific() & (P >= 01\01\2006);
 END {E_SetMathPriceOnline};

 PUBLIC PROCEDURE E_DoXDocAprOfSpecifiedSource(P: DATE; _Source: L_XObj.tSource): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF    _Source = L_XObj.src_Salary THEN
   Result:=P >= L_PRoll.E_DoSecondSide();
  ELSIF _Source = L_XObj.src_ACalc THEN
   Result:=1;
  ELSIF P >= 01\07\2009 THEN
   Result:=(_Source = L_XObj.src_MDoc) | (_Source = L_XObj.src_JDoc) | (_Source = L_XObj.src_PDoc);
  ELSIF L_General.IsPolakSpecific() THEN
   Result:=(_Source = L_XObj.src_MDoc) | (_Source = L_XObj.src_JDoc);
  END;
  RETURN Result;
 END {E_DoXDocAprOfSpecifiedSource};

 PUBLIC PROCEDURE E_DoXDocApr(P: DATE; trgSource: L_XObj.tSource; curXDocId: L_XDoc.tXDocId): SCAL[2];
 BEGIN
  IF E_DoXDocAprOfSpecifiedSource(P, trgSource) THEN
   IF ~!curXDocId THEN
    RETURN 1;
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   RETURN 0;
  END;
 END {E_DoXDocApr};

 PUBLIC PROCEDURE AcMthStrForMessage(_DGroup  : LIKE(DGroup.DGroup);
                                     _Dest    : LIKE(Dest.Dest);
                                     _MathType: LIKE(MathType.MathType);
                                     _MMode   : LIKE(MMode.MMode)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=L_StdFrm.HR() + "㯯 権 " + _DGroup + ",  樨 " + _Dest;
  IF ~!_MathType THEN
   INC(Result, "| ꥪ "   + _MathType);
  END;
  IF ~!_MMode THEN
   INC(Result, ", ० " + L_MathR.MModeStr(_MMode));
  END;
  IF ~!L_XDR.XDocId THEN
   INC(Result, L_StdFrm.HR() + "஡ 㬥 - " + L_XDoc.XDocStr(L_XDR.XDocId));
  END;
  RETURN Result;
 END {AcMthStrForMessage};

 PUBLIC PROCEDURE AcMthIdForMessage(_AcMth: LIKE(AcMth.AcMth)): STRING[];
 BEGIN
  RETURN "| | 奬 樨: " + _AcMth;
 END {AcMthIdForMessage};

 PUBLIC PROCEDURE SelectOperatingAcMthL(P        : DATE;
                                        _DGroup  : LIKE(DGroup.DGroup);
                                        _Dest    : LIKE(Dest.Dest);
                                        _MathType: LIKE(MathType.MathType);
                                        _MMode   : LIKE(MMode.MMode);
                                        Optional : SCAL[2]);
  VAR
   _AcMth: LIKE(AcMth.AcMth);
 BEGIN
  TRY
   SETEMPTY(_AcMth);
   IF !_MathType & !_MMode THEN
    SETSEL(AcMth, DGroup, _DGroup, _Dest);
    FOR_EACH AcMth DO
     IF L_DatTim.IsActive(P, AcMth.Begin, AcMth.Till) THEN
      IF !_AcMth THEN
       _AcMth:=AcMth.AcMth;
      ELSE
       L_General.Error(" 騥 奬 権 - " + _AcMth + "  " + AcMth.AcMth +
                       AcMthStrForMessage(_DGroup, _Dest, _MathType, _MMode));
      END;
     END;
    END; (* FOR_EACH AcMth *)
   ELSE
    IF !_MathType THEN
     SETSEL(AcMthA, MMode,  _MMode, _Dest, _DGroup);
    ELSE
     SETSEL(AcMthA, DGroup, _DGroup, _Dest, _MathType, _MMode);
    END;
    FOR_EACH AcMthA DO
     IF L_DatTim.IsActive(P, AcMthA.Begin, AcMthA.Till) THEN
      IF !_AcMth THEN
       _AcMth:=AcMthA.AcMth;
      ELSE
       L_General.Error(" 騥 奬 権 - " + _AcMth + "  " + AcMthA.AcMth +
                       AcMthStrForMessage(_DGroup, _Dest, _MathType, _MMode));
      END;
     END;
    END; (* FOR_EACH AcMthA *)
   END;
   L_General.Assert(~!_AcMth,
                    " 饩 奬 樨" + AcMthStrForMessage(_DGroup, _Dest, _MathType, _MMode));
   SEARCH(AcMth, AcMth, , _AcMth);
   HISTCONF(P, AcMth, AcMthH, AcMthL);
  EXCEPT
  ON Exc:Exc_Raise DO
   IF Exc.ErrorCode = -1 THEN
    L_General.Assert(Optional, Exc.MsgOriginalText);
    SETSEL(AcMthL, AcMth, EMPTYOF(AcMth.AcMth));
   ELSE
    RAISE();
   END;
  END;
 END {SelectOperatingAcMthL};

 PUBLIC PROCEDURE ProceedDoc_Begin();
 BEGIN
  SETEMPTY(CurAcMthMyFirm);
 END {ProceedDoc_Begin};

 PUBLIC PROCEDURE ProceedDoc_End();
 BEGIN
  SETEMPTY(CurAcMthMyFirm);
 END {ProceedDoc_End};

 PUBLIC PROCEDURE ExecAcMth(P            : DATE;
                            _DGroup      : LIKE(DGroup.DGroup);
                            _Dest        : LIKE(Dest.Dest);
                            _MathType    : LIKE(MathType.MathType);
                            _MMode       : LIKE(MMode.MMode);
                            Optional     : SCAL[2];
                            ProceedSingle: PROC;
                            Prepare      : PROC);
  VAR
   Id,
   S: STRING[];
 BEGIN
  ProceedDoc_Begin();
  SelectOperatingAcMthL(P, _DGroup, _Dest, _MathType, _MMode, Optional);
  IF L_XDR.XDocRepDo() & L_XDR.AcMthSLDo & OCCURE(AcMth) THEN
   Id:=AcMth.AcMth;
   CONFORM(AcMth, DGroup);
   CONFORM(AcMth, Dest);
   S:=DGroup.DGroup   + " " + FLDTOSTR(DGroup.Name,   "", 15) + "  " +
      Dest.Dest       + " " + FLDTOSTR(Dest.Name,     "", 15) + "  " ;
   IF ~!_MathType THEN
    SEARCH(MathType, MathType, , _MathType);
    S:=S + MathType.MathType + " " + FLDTOSTR(MathType.Name, "", 15) + "  " +
           L_MathR.MModeStr(_MMode);
    Id:=Id + "," + _MathType + "," + _MMode;
   END;
   L_XDR.sl_AddItem(Id, S);
  END;
  IF !Prepare | Prepare() THEN
   FOR_EACH AcMthL DO
    ProceedSingle();
   END; (* FOR_EACH AcMthL *)
  END;
  ProceedDoc_End();
 END {ExecAcMth};

 PUBLIC PROCEDURE av_Add(VAR Dst: tAcntVector;
                         Src: tAcntVector);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i < RANGEOF(tAcntVector) DO
   INC(Dst[i], Src[i]);
   INC(i);
  END;
 END {av_Add};

 PUBLIC PROCEDURE av_ConvToExternal(VAR Dst: tAcntVector);
 BEGIN
  Dst[avp_InSaldo] :=(-1) * Dst[avp_InSaldo];
  Dst[avp_OutSaldo]:=(-1) * Dst[avp_OutSaldo];
 END {av_ConvToExternal};

 PUBLIC PROCEDURE ConvEtZ(v: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF !v THEN
   RETURN 0;
  ELSE
   RETURN v;
  END;
 END {ConvEtZ};

 PUBLIC PROCEDURE IsEntranceApport(_Apport: LIKE(Apport.Apport)): SCAL[2];
 BEGIN
  RETURN (_Apport = 901) | (_Apport = 902) | (_Apport = 903);
 END {IsEntranceApport};

 PRIVATE PROCEDURE GetSalesVolumesRatio(D: DATE): FLOAT;
  VAR
   Taxable,
   NonTaxable,
   monTaxable,
   monNonTaxable: L_XObj.tSum;
   P            : DATE;
 BEGIN
  IF E_IsMonthlyKeyAssVATDistr(D) THEN
   SAVE(Math);
   CONFORM(MDocList, Math);
   IF (Math.MathKind = L_MathR.mathk_KeyAs) & (D < L_DatTim.Per(L_Pmnt.GetVATClcPerLastDay(L_DatTim.Per(D)))) THEN
    P_OwnData.GetSalesVolumes(L_DatTim.Per(D), Taxable, NonTaxable);
   ELSE
    SETZERO(Taxable, NonTaxable);
    P:=L_Pmnt.ConvPer2VATClcPer(L_DatTim.Per(D));
    WHILE P <= L_Pmnt.GetVATClcPerLastDay(L_DatTim.Per(D)) DO
     P_OwnData.GetSalesVolumes(P, monTaxable, monNonTaxable);
     IF (OwnDPro.Date = P) | (P = L_Pmnt.ConvPer2VATClcPer(L_DatTim.Per(D))) THEN
      INC(Taxable,    monTaxable);
      INC(NonTaxable, monNonTaxable);
     END;
     P:=L_DatTim.NextPer(P);
    END;
   END;
   RESTORE(Math);
  ELSE
   P_OwnData.GetSalesVolumes(L_Pmnt.ConvPer2VATClcPer(L_DatTim.Per(D)), Taxable, NonTaxable);
  END;
  L_General.Assert((Taxable + NonTaxable) # 0, " 窨  ॠ樨");
  RETURN NonTaxable / (Taxable + NonTaxable);
 END {GetSalesVolumesRatio};

 PRIVATE PROCEDURE intVATPartInCost(trg_cVAT  : LIKE(AcMthL.cVAT);
                                    trgVAT    : LIKE(MDocList.VAT);
                                    trgVATMode: LIKE(MDocList.VATMode)): L_XObj.tSum;
 BEGIN
  IF    trg_cVAT = cvat_Not THEN
   L_General.Assert(!trgVATMode, "⨬ ᯮ짮 'ᮡ  '");
   RETURN 0;
  ELSIF (trg_cVAT = cvat_Allow) | (trg_cVAT = cvat_VATOnlyAllow) THEN
   IF !trgVATMode THEN
    IF trgVAT = 0 THEN
     RETURN 0;
    END;
    L_General.Error(" । ᯮᮡ  | ୮ ᠭ 奬 権");
   ELSIF trgVATMode = L_MDoc.vatm_Deduction    THEN
    RETURN 0;
   ELSIF trgVATMode = L_MDoc.vatm_Distribution THEN
    RETURN trgVAT * GetSalesVolumesRatio(MDoc.Date);
   ELSIF trgVATMode = L_MDoc.vatm_AddToCost THEN
    RETURN trgVAT;
   ELSE
    L_General.CallUs(0);
   END;
  ELSIF  trg_cVAT = cvat_NotAllow THEN
   RETURN 0;
  ELSE
   L_General.CallUs(0);
  END;
 END {intVATPartInCost};

 PUBLIC PROCEDURE MDLVATPartInCost(trg_cVAT: LIKE(AcMthL.cVAT)): L_XObj.tSum;
  VAR
   curVAT: LIKE(MDocList.VAT);
 BEGIN
  curVAT:=E_convVAT2Something(MDoc.Date, trg_cVAT, MDocList.VAT, MDocList.VATMode);
  RETURN intVATPartInCost(trg_cVAT, curVAT, MDocList.VATMode);
 END {MDLVATPartInCost};

(*!*) PUBLIC PROCEDURE VATPartInCost(trg_cVAT  : LIKE(AcMthL.cVAT);
                                     trgVAT    : LIKE(MDocList.VAT);
                                     trgVATMode: LIKE(MDocList.VATMode)): L_XObj.tSum;
 BEGIN
  L_General.CallUs(trgVAT     = MDocList.VAT);
  L_General.CallUs(trgVATMode = MDocList.VATMode);
  RETURN MDLVATPartInCost(trg_cVAT);
 END {VATPartInCost};

 PUBLIC PROCEDURE E_IsAlternateVATDistr(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Stock.IsAlternateVATDistr), (D>=01\04\2014) & L_APtm.IsMTA());
 END {E_IsAlternateVATDistr};

 PUBLIC PROCEDURE E_IsMonthlyKeyAssVATDistr(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Stock.IsMonthlyKeyAssVATDistr), (D>=01\04\2014) & L_APtm.IsMTA());
 END {E_IsMonthlyKeyAssVATDistr};

 PRIVATE PROCEDURE E_convVAT2Something(D         : DATE;
                                       trg_cVAT  : LIKE(AcMthL.cVAT);
                                       trgVAT    : LIKE(MDocList.VAT);
                                       trgVATMode: LIKE(MDocList.VATMode)): L_XObj.tSum;
  VAR
   Result: L_XObj.tSum;
 BEGIN
  Result:=trgVAT;
  IF Result # 0 THEN
   IF ~L_General.IsPolakSpecific() THEN
    IF D >= 01\04\2008 THEN
     IF (trgVATMode = L_MDoc.vatm_Distribution) & ((trg_cVAT = cvat_Allow) | (trg_cVAT = cvat_VATOnlyAllow)) THEN
      IF ~P_OwnData.HasActualOwnDPro(D, P_OwnData.P_SalesVolumes) THEN
       Result:=0;
      ELSE
       IF E_IsAlternateVATDistr(D) THEN
        IF OwnDPro.Date < L_Pmnt.ConvPer2VATClcPer(D) THEN
         Result:=0;
        ELSIF E_IsMonthlyKeyAssVATDistr(D) THEN
         SAVE(Math);
         CONFORM(MDocList, Math);
         IF    Math.MathKind = L_MathR.mathk_KeyAs THEN
          IF OwnDPro.Date < L_DatTim.Per(D) THEN
           Result:=0;
          END;
         ELSIF Math.MathKind = L_MathR.mathk_Math THEN
          SAVE(OwnDPro);
          IF ~P_OwnData.HasActualOwnDPro(L_Pmnt.GetVATClcPerLastDay(D), P_OwnData.P_SalesVolumes) |
             (OwnDPro.Date < L_DatTim.Per(L_Pmnt.GetVATClcPerLastDay(D))) THEN
           Result:=0;
          END;
          RESTORE(OwnDPro);
         ELSE
          L_General.CallUs(0);
         END;
         RESTORE(Math);
        ELSE
         L_General.Assert(SYSDATE() > L_Pmnt.GetVATClcPerLastDay(D),
                          " ன "+L_Str.FixedIntStr(P_OwnData.P_SalesVolumes, 4)+"|   ⭠  祭  ਮ ( "+L_DatTim.DateStr(L_DatTim.GetVATClcPerLastDay(D)+1)+")");
        END;
       END;
       IF ~E_IsMonthlyKeyAssVATDistr(D) &
          (OwnDPro.Date > L_Pmnt.ConvPer2VATClcPer(L_DatTim.Per(D))) THEN (* ᫨ '=',    浪, ᫨ '<',    㣠 *)
        L_General.Error(" ன "+L_Str.FixedIntStr(P_OwnData.P_SalesVolumes, 4)+"|  । ⮫쪮     ਮ ("+L_DatTim.DateStr(L_Pmnt.ConvPer2VATClcPer(L_DatTim.Per(D)))+")");
       END;
      END; (* IF ~P_OwnData.HasActualOwnDPro ... *)
     END;
    END; (* IF IF D >= 01\04\2008 ... *)
   END;
  END; (* IF Result # 0 *)
  RETURN Result;
 END {E_convVAT2Something};

 PRIVATE PROCEDURE GetMDLNetto(trg_cVAT: LIKE(AcMthL.cVAT)): L_XObj.tSum;
  VAR
   curVAT: LIKE(MDocList.VAT);
 BEGIN
  curVAT:=E_convVAT2Something(MDoc.Date, trg_cVAT, MDocList.VAT, MDocList.VATMode);
  IF trg_cVAT = cvat_VATOnlyAllow THEN
   RETURN intVATPartInCost(trg_cVAT, curVAT, MDocList.VATMode);
  ELSE
   RETURN intVATPartInCost(trg_cVAT, curVAT, MDocList.VATMode) + MDocList.Sum;
  END;
 END {GetMDLNetto};

 PRIVATE PROCEDURE GetMDLVAT(trg_cVAT: LIKE(AcMthL.cVAT)): L_XObj.tSum;
  VAR
   curVAT: LIKE(MDocList.VAT);
 BEGIN
  curVAT:=E_convVAT2Something(MDoc.Date, trg_cVAT, MDocList.VAT, MDocList.VATMode);
  RETURN curVAT - intVATPartInCost(trg_cVAT, curVAT, MDocList.VATMode);
 END {GetMDLVAT};

 PRIVATE VAR
  pdl_Netto,
  pdl_VAT    : L_XObj.tSum[2048];
  pdl_Count  : NUMERIC[0];

 PUBLIC PROCEDURE mpdl_First();
  VAR
   rst_Netto,
   rst_VAT    : L_XObj.tSum;
   VATRatio   : FLOAT;
 BEGIN
  SETEMPTY(pdl_Netto, pdl_VAT);
  SAVE(PDocList);
  SAVE(PDocMDoc);
  IF L_PDoc.IsPDocwMDoc() THEN
   SELECT(PDocMDoc, PDoc, , PDoc.PDocKind, PDoc.PDoc);
   rst_VAT  :=ConvEtZ(PDocMDoc.NDS);
   rst_Netto:=PDocMDoc.Total-rst_VAT;
  ELSE
   rst_VAT  :=0;
   rst_Netto:=PDoc.Total;
  END;
  IF (rst_Netto + rst_VAT) # 0 THEN
   VATRatio:=rst_VAT/(rst_Netto + rst_VAT);
  ELSE
   L_General.CallUs(rst_VAT = 0);
   VATRatio:=0;
  END;
  pdl_Count:=0;
  IF SELECT(PDocList, PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
   WHILE OCCURE(PDocList) DO
    pdl_VAT  [pdl_Count]:=PDocList.Sum * VATRatio;
    pdl_Netto[pdl_Count]:=PDocList.Sum - pdl_VAT[pdl_Count];
    DEC(rst_VAT,   pdl_VAT  [pdl_Count]);
    DEC(rst_Netto, pdl_Netto[pdl_Count]);
    INC(pdl_Count);
    NEXT(PDocList);
   END; (* WHILE OCCURE(PDocList) ... *)
   INC(pdl_VAT  [pdl_Count-1], rst_VAT  );
   INC(pdl_Netto[pdl_Count-1], rst_Netto);
  END;
  RESTORE(PDocMDoc);
  RESTORE(PDocList);
  pdl_Count:=0;
 END {mpdl_First};

 PUBLIC PROCEDURE mpdl_Next();
 BEGIN
  INC(pdl_Count);
 END {mpdl_Next};

 PRIVATE PROCEDURE getCirComponentValue(Src: tCirSource;
                                        Cmp: tCirComponent): L_XObj.tSum;
 BEGIN
  IF Src = cs_MDoc THEN
   IF    Cmp = cc_Netto   THEN RETURN GetMDLNetto(AcMthL.cVAT);
   ELSIF Cmp = cc_VAT     THEN RETURN GetMDLVAT  (AcMthL.cVAT);
   ELSIF Cmp = cc_SaleTax THEN RETURN MDocList.SaleTax;
   END;
  ELSIF Src = cs_PDoc THEN
   IF    Cmp = cc_Netto   THEN RETURN PDoc.Total-ConvEtZ(PDoc.NDS)-ConvEtZ(PDoc.SaleTax);
   ELSIF Cmp = cc_VAT     THEN RETURN ConvEtZ(PDoc.NDS);
   ELSIF Cmp = cc_SaleTax THEN RETURN ConvEtZ(PDoc.SaleTax);
   END;
  ELSIF Src = cs_PDocMDoc THEN
   IF    Cmp = cc_Netto   THEN RETURN PDocMDoc.Total-ConvEtZ(PDocMDoc.NDS)-ConvEtZ(PDocMDoc.SaleTax);
   ELSIF Cmp = cc_VAT     THEN RETURN ConvEtZ(PDocMDoc.NDS);
   ELSIF Cmp = cc_SaleTax THEN RETURN ConvEtZ(PDocMDoc.SaleTax);
   END;
  ELSIF Src = cs_PDocList THEN
   L_General.Assert(~!pdl_Count & ~!pdl_Netto[pdl_Count],
                    "। 稥  㬥 ᯨ᪠ ࠡ⭨|"+
                    " ୮ ᠭ ");
   IF    Cmp = cc_Netto   THEN RETURN pdl_Netto[pdl_Count];
   ELSIF Cmp = cc_VAT     THEN RETURN pdl_VAT  [pdl_Count];
   ELSIF Cmp = cc_SaleTax THEN RETURN 0;
   END;
  END;
  L_General.CallUs(0)
 END {getCirComponentValue};

 PRIVATE PROCEDURE sc_incStandartCir(VAR Value : VARIANT(*0081918*);
                                     VAR Storno: NUMERIC[0];
                                     CirCmp: tCirComponent;
                                     CCCM  : tCirComponentCalculationManner
                                     );
  VAR
   _Storno: NUMERIC[0];
 BEGIN
  IF CCCM # cccm_Not THEN
   IF CCCM = cccm_Storno THEN
    _Storno:=-1;
   ELSE
    _Storno:=+1;
   END;
   L_General.Assert((Storno = 0) | (Storno = _Storno),
                    "ᮣᮢ   ஢ ਧ '୮'");
   Storno:=_Storno;
   IF (AcMthL.CirSrc = cs_MDoc) & (CirCmp = cc_Amount) THEN
    INC(Value, Storno * L_MDoc.GetMDocListCir2());
   ELSE
    INC(Value, Storno * getCirComponentValue(AcMthL.CirSrc, CirCmp));
   END;
  END;
 END {sc_incStandartCir};

 PRIVATE PROCEDURE sc_PrepareStandartCir(VAR resSum: L_XObj.tSum;
                                         VAR resQnt: L_XObj.tQnt);
  VAR
   Storno: NUMERIC[0];
 BEGIN
  SETZERO(resSum, resQnt, Storno);
  sc_incStandartCir(resSum, Storno, cc_Netto,   AcMthL.aNetto);
  sc_incStandartCir(resSum, Storno, cc_VAT,     AcMthL.aVAT);
  sc_incStandartCir(resSum, Storno, cc_SaleTax, AcMthL.aSaleTax);
  sc_incStandartCir(resQnt, Storno, cc_Amount,  AcMthL.aAmount);
 END {sc_PrepareStandartCir};

 PRIVATE PROCEDURE sc_Assert(Cond: SCAL[2]; Msg: STRING[]);
 BEGIN
  L_General.Assert(Cond,
                   " ᭮ ᠭ 奬 樨 ( " + AcMthL.AcMth + ") ஢ 㬥" +
                   "|। " +  Msg);
 END {sc_Assert};

 PRIVATE PROCEDURE sc_StandOnOrigin(_amo: tAcMthOrigin;
                                    _Src: tCirSource);
  VAR
   trgMath    : LIKE(Math.Math);
   trgFirmAcnt: LIKE(FirmAcnt.FirmAcnt);
   trgMan: LIKE(Man.Man);
 BEGIN
  IF    _amo = amo_Global THEN
   L_PDoc.AccessmfBnkAcn(PDoc.MyFirm, L_PDoc.GetPDocOwnFirmAcnt());
  ELSIF _amo = amo_OprDsk THEN
   IF    L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_OprDskCash THEN
    trgFirmAcnt:=PDoc.OwnAcnt;
   ELSIF L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Cash THEN
    sc_Assert(P_Firm.GetMyFirmOfFirm(PDoc.Firm) = PDoc.MyFirm,
              "㯮 'ࠣ' " + P_Firm.fomf(PDoc.MyFirm));
    sc_Assert(~!PDoc.FirmAcnt, "㪠  樮 "+L_StdFrm.THR(" 稭")+"⠢  믮  १ ᮮ⢥騩 㭪 ");
    trgFirmAcnt:=PDoc.FirmAcnt;
   ELSE
    sc_Assert(0, "ਬ  ᮢ 㬥⠬");
   END;
   L_PDoc.AccessmfBnkAcn(PDoc.MyFirm, trgFirmAcnt);
  ELSIF _amo = amo_Contract THEN
   IF ~OCCURE(MDoc) | !MDoc.Contract THEN
    IF    (_Src = cs_PDocList) | (_Src = cs_PDocMDoc) THEN
     sc_Assert(0, "稥 뫪  ⮢ 㬥  ");
    ELSE
     sc_Assert(0, "㯭 ⮢୮ 㬥  ");
    END;
   END;
   CONFORM(MDoc, Contract);
  ELSIF _amo = amo_Man THEN
   IF    (_Src = cs_PDocList) | (_Src = cs_PDocMDoc) THEN
    IF OCCURE(PDocList) THEN
     CONFORM(PDocList, Staff);
     SEARCH(mfMan, XObject, , L_XObj.ObtainManXObject(Staff.Man, PDoc.MyFirm));
    ELSIF (_Src = cs_PDocMDoc) THEN
     trgMan:=P_Firm.GetManOfFirm(PDoc.Date, PDoc.Firm);
     sc_Assert(~!trgMan, "稥  㬥 ᯨ᪠ ࠡ⭨| ⠪ '㪮⥫'  ࠣ "+PDoc.Firm);
     SEARCH(mfMan, Man, , trgMan, PDoc.MyFirm);
    ELSE
     sc_Assert(0, "稥  㬥 ᯨ᪠ ࠡ⭨");
    END;
   ELSIF _Src = cs_MDoc THEN
    CONFORM(MDoc, Staff);
    SEARCH(mfMan, Man, , Staff.Man, Staff.MyFirm);
   ELSE
    sc_Assert(0, "஢  ꥪ '"+L_Str.PoolItem(amo_Pool, _amo)+"'| 筨 ⮢ '"+L_Str.PoolItem(cs_Pool, _Src)+"'||஢ ᠭ 奬 権");
   END;
  ELSIF _amo = amo_Recast THEN
   IF _Src = cs_MDoc THEN
    L_PDoc.AccessmfBnkAcn(MDoc.MyFirm, P_Firm.fa_CashOffice);
   ELSE
    L_PDoc.AccessmfBnkAcn(PDoc.MyFirm, P_Firm.fa_CashOffice);
   END;
  ELSIF _amo = amo_CostItem THEN
   IF _Src = cs_Dfrls THEN
    sc_Assert(OCCURE(Dfrls), "㯭 'ࠢ ᯨᠭ '");
    CONFORM(Dfrls, CostItem);
   ELSE
    sc_Assert(~!MDoc.CostItem, "㪠    ");
    CONFORM(MDoc, CostItem);
   END;
  ELSIF _amo = amo_CostItemByMDL THEN
   IF _Src = cs_Dfrls THEN
    sc_Assert(OCCURE(DfrlsL), "㯭 ப 'ࠢ ᯨᠭ '");
    CONFORM(DfrlsL, CostItem);
   ELSE
    sc_Assert(~!MDocList.CostItem, "㪠   ப ");
    CONFORM(MDocList, CostItem);
   END;
  ELSIF _amo = amo_Math THEN
   L_Stock.Obtain_mItem(Math.Math, L_Stock.Obtain_MyFirmStorage(MDoc.MyFirm, MDoc.Date));
  ELSIF _amo = amo_MathInAH THEN
   L_Stock.Obtain_mItem(Math.Math, L_Stock.Obtain_AdvHolderStorage(MDoc.TSN, MDoc.Date));
  ELSIF _amo = amo_MathByStr THEN
   sc_Assert(~!MDoc.Storage & ~L_Stock.IsMyFirmStorage(MDoc.Storage),
             "㪠 ॠ쭮  ࠭");
   L_Stock.Obtain_mItem(Math.Math, MDoc.Storage);
  ELSIF _amo = amo_MathByStr2 THEN
   sc_Assert(~!MDoc.Storage2 & ~L_Stock.IsMyFirmStorage(MDoc.Storage2),
             "㪠 ॠ쭮 ᯮ饣  ࠭");
   L_Stock.Obtain_mItem(Math.Math, MDoc.Storage2);
  ELSIF _amo = amo_MathByCntr THEN
   sc_Assert(~!MDoc.Contract, "㪠 ");
   L_Stock.Obtain_mItem(Math.Math, L_Stock.Obtain_ContractStorage(MDoc.Contract, MDoc.Date));
  ELSIF _amo = amo_MathByCar THEN
   L_Stock.Obtain_mItem(Math.Math, L_Stock.GetFuelTanksStorage(MDoc.MyFirm));
  ELSIF _amo = amo_MathByTO THEN
   SETEMPTY(trgMath);
   SAVE(MDocList);
   SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
   WHILE OCCURE(MDocList) DO
    IF MDocList.MMode = L_MathR.mm_TransactionObject THEN
     L_General.Assert(!trgMath, "    ꥪ 宧⢥ 樨");
     trgMath:=MDocList.Math;
    END;
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
   RESTORE(MDocList);
   L_General.Assert(~!trgMath, "     ꥪ 宧⢥ 樨");
   sc_Assert(~!MDoc.Storage & ~L_Stock.IsMyFirmStorage(MDoc.Storage),
             "㪠 ॠ쭮  ࠭");
   L_Stock.Obtain_mItem(trgMath, MDoc.Storage);
  ELSIF _amo = amo_MathOfComplexCUC THEN
   L_General.Assert(~!MDoc.CUCopy, "   㪠  ");
   CONFORM(MDoc, CUCopy);
   sc_Assert(~!MDoc.Storage & ~L_Stock.IsMyFirmStorage(MDoc.Storage),
             "㪠 ॠ쭮  ࠭");
   L_Stock.Obtain_mItem(CUCopy.Math, MDoc.Storage);
  ELSE
   L_General.CallUs(0);
  END;
 END {sc_StandOnOrigin};

 PRIVATE PROCEDURE convAcMthOrigin2Origin(_amo: tAcMthOrigin): L_XObj.tOrigin;
 BEGIN
  IF    _amo = amo_Global     THEN RETURN L_XObj.o_Global;
  ELSIF _amo = amo_OprDsk     THEN RETURN L_XObj.o_Global;
  ELSIF _amo = amo_Recast     THEN RETURN L_XObj.o_Global;
  ELSIF _amo = amo_Contract   THEN RETURN L_XObj.o_Contract;
  ELSIF _amo = amo_Man        THEN RETURN L_XObj.o_Man;
  ELSIF (_amo = amo_CostItem    ) |
        (_amo = amo_CostItemByMDL) THEN
   RETURN L_XObj.o_CostItem;
  ELSIF (_amo = amo_Math            ) |
        (_amo = amo_MathInAH        ) |
        (_amo = amo_MathByStr       ) |
        (_amo = amo_MathByStr2      ) |
        (_amo = amo_MathByCntr      ) |
        (_amo = amo_MathByCar       ) |
        (_amo = amo_MathByTO        ) |
        (_amo = amo_MathOfComplexCUC) THEN
   RETURN L_XObj.o_Math;
  ELSE
   L_General.CallUs(0);
  END;
 END {convAcMthOrigin2Origin};

 PUBLIC PROCEDURE sc_PrepareXObject(_amo: tAcMthOrigin; _Src: tCirSource);
 BEGIN
  sc_StandOnOrigin(_amo, _Src);
  L_XObj.AccessXObjectByOrigin(convAcMthOrigin2Origin(_amo));
 END {sc_PrepareXObject};

 PUBLIC PROCEDURE isMathFamilyOrigin(amo: tAcMthOrigin): SCAL[2];
 BEGIN
  RETURN convAcMthOrigin2Origin(amo) = L_XObj.o_Math;
 END {isMathFamilyOrigin};

 PRIVATE PROCEDURE PositionOnMTMM(D: DATE; trgMathType: LIKE(MTMM.MathType); trgMMode: LIKE(MTMM.MMode));
  VAR
   trgMTMM: LIKE(MTMM.MTMM);
 BEGIN
  SETEMPTY(trgMTMM);
  SELECT(MTMM, MathType, , trgMathType, trgMMode);
  WHILE OCCURE(MTMM) DO
   IF L_DatTim.IsActive(D, MTMM.Begin, MTMM.Till) THEN
    IF ~!trgMTMM THEN
     L_General.Error("᪮쪮 奬    " + L_DatTim.DateStr(D) +
                     "||"+
                     "  " + trgMathType + ", ०  " + trgMMode);
    END;
    trgMTMM:=MTMM.MTMM;
   END;
   NEXT(MTMM);
  END; (* WHILE OCCURE(MTMM) ... *)
  IF !trgMTMM THEN
   L_General.Error(" । 奬    " + L_DatTim.DateStr(D) +
                   "||"+
                   "  " + trgMathType + ", ०  " + trgMMode);
  END;
  SEARCH(MTMM, MTMM, , trgMTMM);
 END {PositionOnMTMM};

 PRIVATE PROCEDURE intGetSpecificAcCutFromACSet(trgACSet: LIKE(ACSet.ACSet); trgACPrp: tAcCutPurpose; ErrorPoint: STRING[]): LIKE(AcCut.AcCut);
 BEGIN
  IF SEARCH(ACSetL, ACSet, trgACSet, trgACPrp) THEN
   RETURN ACSetL.AcCut;
  ELSE
   L_StdFrm.WrongDB(ErrorPoint +
                    "|   ࠧ१ " + trgACSet +
                    "| । ࠧ१  祭 '" + L_Str.PoolItem(acp_Pool, trgACPrp) + "'");
  END;
 END {intGetSpecificAcCutFromACSet};

 PUBLIC PROCEDURE GetSpecificAcCutForContract(trgContract: LIKE(Contract.Contract); trgACPrp: tAcCutPurpose): LIKE(AcCut.AcCut);
  VAR
   Result: LIKE(AcCut.AcCut);
 BEGIN
  SAVE(Contract);
  SEARCH(Contract, Contract, , trgContract);
  Result:=intGetSpecificAcCutFromACSet(Contract.ACSet, trgACPrp, " "+Contract.Contract);
  RESTORE(Contract);
  RETURN Result;
 END {GetSpecificAcCutForContract};

 PUBLIC PROCEDURE GetSpecificAcCutForCostItem(trgCostItem: LIKE(CostItem.CostItem); trgACPrp: tAcCutPurpose): LIKE(AcCut.AcCut);
  VAR
   Result: LIKE(AcCut.AcCut);
 BEGIN
  SAVE(CostItem);
  SEARCH(CostItem, CostItem, , trgCostItem);
  Result:=intGetSpecificAcCutFromACSet(CostItem.ACSet, trgACPrp, " "+CostItem.CostItem);
  RESTORE(CostItem);
  RETURN Result;
 END {GetSpecificAcCutForCostItem};

 PUBLIC PROCEDURE GetSoftSpecificAcCutForCostItem(trgCostItem: LIKE(CostItem.CostItem); trgACPrp: tAcCutPurpose): LIKE(AcCut.AcCut);
  VAR
   Result: LIKE(AcCut.AcCut);
 BEGIN
  SAVE(CostItem);
  SEARCH(CostItem, CostItem, , trgCostItem);
  TRY
   Result:=intGetSpecificAcCutFromACSet(CostItem.ACSet, trgACPrp, " "+CostItem.CostItem);
  EXCEPT
  ON Exc:Exc_Raise DO
   SETEMPTY(Result);
  END;
  RESTORE(CostItem);
  RETURN Result;
 END {GetSoftSpecificAcCutForCostItem};

 PUBLIC PROCEDURE GetSpecificAcCutForMTMM(D: DATE; trgMathType: LIKE(MTMM.MathType); trgMMode: LIKE(MTMM.MMode); trgACPrp: tAcCutPurpose): LIKE(AcCut.AcCut);
 BEGIN
  PositionOnMTMM(D, trgMathType, trgMMode);
  RETURN intGetSpecificAcCutFromACSet(MTMM.ACSet, trgACPrp, "奬   "+MTMM.MTMM);
 END {GetSpecificAcCutForMTMM};

 PRIVATE PROCEDURE intGetAcMthL_AcCut(D       : DATE;
                                      trg_amo : tAcMthOrigin;
                                      trgACPrp: tAcCutPurpose;
                                      trgAcCut: LIKE(AcCut.AcCut)): LIKE(AcCut.AcCut);
 BEGIN
  IF ~!trgAcCut | !D THEN
   RETURN trgAcCut;
  ELSE
   IF    (trgACPrp = acp_CostItem_Default) | (trgACPrp = acp_CostItemSale) THEN
    IF !trg_amo THEN
     sc_StandOnOrigin(amo_CostItem (* 0070150 *), AcMthL.CirSrc);
    ELSE
     sc_StandOnOrigin(trg_amo      (* 0070120 *), AcMthL.CirSrc);
    END;
    L_General.Assert(~!CostItem.ACSet, "  " + CostItem.CostItem + "  㪠   ࠧ१");
    RETURN GetSpecificAcCutForCostItem(CostItem.CostItem, trgACPrp);
   ELSIF trgACPrp = acp_Contract_Netto THEN
    sc_StandOnOrigin(amo_Contract, AcMthL.CirSrc);
    RETURN GetSpecificAcCutForContract(Contract.Contract, trgACPrp);
   ELSIF (trgACPrp = acp_Math_Netto    ) | (trgACPrp = acp_Math_VAT     ) |
         (trgACPrp = acp_MathSale_Netto) | (trgACPrp = acp_MathSale_VAT ) |
         (trgACPrp = acp_MathInAdvHld  ) | (trgACPrp = acp_MathInKeeping) | (trgACPrp = acp_MathOffSite) THEN
(* 㦥 ⮨  Math -    ? . 0061923 - 04.01.2008 17:45:18 POLAK\San
    sc_StandOnOrigin(amo_Math, AcMthL.CirSrc);
*)
    RETURN GetSpecificAcCutForMTMM(D, Math.MathType, MDocList.MMode, trgACPrp);
   ELSE
    L_General.Error("⨬ ਬ 뫪  ࠧ१  祭 '" + L_Str.PoolItem(acp_Pool, trgACPrp) + "'");
   END;
  END;
 END {intGetAcMthL_AcCut};

 PUBLIC PROCEDURE getAcMthL_AcCut(D: DATE): LIKE(AcCut.AcCut);
 BEGIN
  RETURN intGetAcMthL_AcCut(D, AcMthL.Origin1, AcMthL.ACPrp, AcMthL.AcCut);
 END {getAcMthL_AcCut};

 PUBLIC PROCEDURE getAcMthL_AcCut2(D: DATE): LIKE(AcCut.AcCut);
 BEGIN
  RETURN intGetAcMthL_AcCut(D, AcMthL.Origin2, AcMthL.ACPrp2, AcMthL.AcCut2);
 END {getAcMthL_AcCut2};

 PRIVATE PROCEDURE GetAvlForSMP(trgAcCut: LIKE(AcCut.AcCut);
                                P       : DATE;
                                VAR AvlSum: L_XObj.tSum;
                                VAR AvlQnt: L_XObj.tQnt);
  VAR
   curMath : LIKE(Math.Math);
   trgP    : DATE;
   Dummy   : SCAL[2];
 BEGIN
  SETSEL(XCalc, XObject, XObject.XObject, trgAcCut);
  IF SRCINSEL(XCalc, LT, P) THEN
   SAVE(mItem);
   SEARCH(mItem, XObject, , XObject.XObject);
   curMath:=mItem.Math;
   RESTORE(mItem);
   trgP:=XCalc.XDat;
   Dummy:=L_MathR.extCountUpMath(curMath, trgP, 1, TRANSACTION_CURRENT);
  END;
  SETSEL(XCalc, XObject, XObject.XObject, trgAcCut);
  IF SRCINSEL(XCalc, LE, P) THEN
   AvlSum:=XCalc.RSlSum;
   AvlQnt:=XCalc.RSlQnt;
   SETSEL(XApport, WFD, XCalc.XObject, XCalc.AcCut, XCalc.XDat);
   FOR_EACH XApport DO
    IF ((XApport.Source # L_XObj.src_Math)&(XApport.Source # L_XObj.src_MathRevision)) | (XCalc.XDat < P) THEN
     XApport.Sum:=L_General.UnDenominate(XApport.XDat, XApport.WFDate, XApport.Sum);
     L_XObj.AddXA2Saldo(AvlSum, AvlQnt, +1);
    END;
   END; (* FOR_EACH XApport ... *)
  ELSE
   SETZERO(AvlSum, AvlQnt);
  END;
 END {GetAvlForSMP};

 PRIVATE PROCEDURE CheckXObjectMyFirm();
 BEGIN
  IF ~!CurAcMthMyFirm THEN
   L_General.Assert(XObject.MyFirm = CurAcMthMyFirm, "஢  樨   ⭮  ࠧ ࣠|"+CurAcMthMyFirm+"  "+XObject.MyFirm);
  ELSE
   CurAcMthMyFirm:=XObject.MyFirm;
  END;
 END {CheckXObjectMyFirm};

 PUBLIC PROCEDURE sc_MakeCir(_Dir    : NUMERIC[0];
                             _XDat   : DATE;
                             _Src    : tCirSource;
                             _amo    : tAcMthOrigin;
                             _AcCut  : LIKE(AcCut.AcCut);
                             _Apport : LIKE(Apport.Apport);
                             _amo2   : tAcMthOrigin;
                             _AcCut2 : LIKE(AcCut2.AcCut2);
                             _Apport2: LIKE(Apport.Apport);
                             curSum  : L_XObj.tSum;
                             curQnt  : L_XObj.tQnt;
                             _Source : L_XObj.tSource);
  VAR
   _XObject,
   _XObject2: LIKE(XObject.XObject);
   wAmount,
   wAmount2 : SCAL[2];
   SetMP    : SCAL[2];
   Dir      : SCAL[2];
   pXObject : LIKE(XObject.XObject);
   pAcCut   : LIKE(AcCut.AcCut);
   AvlSum   : L_XObj.tSum;
   AvlQnt   : L_XObj.tQnt;
 BEGIN
  IF (_Dir > 0) | ~E_DoXDocApr(_XDat, _Source, L_XDR.XDocId) THEN
   SetMP:=0;
   IF (_Src = cs_MDoc) & E_SetMathPriceOnline(_XDat) THEN
    IF    ~!_Apport & SEARCH(Apport, Apport, _Apport) &
       (Apport.CirKind = ck_EstimatedCir) & (Apport.CirType = ct_Credit) THEN
     SetMP:=1;
     Dir:=0;
     IF !_Apport2 THEN
      IF _Apport = 005 THEN
       _Apport2:=002;
      ELSE
       L_General.CallUs(0);
      END;
      _amo2:=amo_CostItem;
     END;
    ELSIF ~!_Apport2 & SEARCH(Apport, Apport, _Apport2) &
       (Apport.CirKind = ck_EstimatedCir) & (Apport.CirType = ct_Credit) THEN
     SetMP:=1;
     Dir:=1;
     IF !_Apport THEN
      IF _Apport2 = 005 THEN
       _Apport:=002;
      ELSE
       L_General.CallUs(0);
      END;
      _amo2:=amo_CostItem;
     END;
    END;
   END;
   IF ~!_amo THEN
    sc_PrepareXObject(_amo, _Src);
    CheckXObjectMyFirm();
    _XObject:=XObject.XObject;
    wAmount:=isMathFamilyOrigin(_amo) & (((_amo # amo_MathByTO) & (_amo # amo_MathOfComplexCUC)) | !_amo2);
   ELSE
    SETEMPTY(_XObject);
    wAmount:=1;
   END;
   IF ~!_amo2 THEN
    sc_PrepareXObject(_amo2, _Src);
    CheckXObjectMyFirm();
    _XObject2:=XObject.XObject;
    wAmount2:=isMathFamilyOrigin(_amo2) & (((_amo2 # amo_MathByTO) & (_amo2 # amo_MathOfComplexCUC)) | !_amo);
   ELSE
    SETEMPTY(_XObject2);
    wAmount2:=1;
   END;
   IF SetMP THEN
    IF Dir = 0 THEN
     pXObject:=_XObject;
     pAcCut  :=_AcCut;
    ELSE
     pXObject:=_XObject2;
     pAcCut  :=_AcCut2;
    END;
    L_XObj.AccessXObject(pXObject);
    GetAvlForSMP(pAcCut, _XDat, AvlSum, AvlQnt);
    IF AvlQnt = curQnt THEN
     curSum:=AvlSum;
    ELSE
     IF AvlQnt = 0 THEN
      curSum:=0;
     ELSE
      curSum:=curQnt*(AvlSum/AvlQnt);
     END;
    END;
   END;
   L_XObj.MakeCompleteCir(_Dir, _XDat, _XObject,  _AcCut,  _Apport,  wAmount,
                                       _XObject2, _AcCut2, _Apport2, wAmount2, curSum, curQnt, _Source);
  END;
 END {sc_MakeCir};

 PRIVATE PROCEDURE CheckCS(trgCS: tCirSource);
  CONST
   Len = 47;
  VAR
   curXDocId: L_XDoc.tXDocId;
 BEGIN
  IF trgCS # AcMthL.CirSrc THEN
   IF trgCS = cs_MDoc THEN
    curXDocId:=MDoc.XDocId;
   ELSIF (trgCS = cs_PDoc)     |
         (trgCS = cs_PDocMDoc) |
         (trgCS = cs_PDocList) THEN
    curXDocId:=PDoc.XDocId;
   ELSE
    L_General.CallUs(0);
   END;
   L_General.Error(" 筨 ⮢  ஢|"+
                   " '"+L_Str.PoolItem(cs_Pool, trgCS)+"'"+
                   L_StdFrm.THR(" 稭")+
                   Str.Align("1 ࠢ쭮 ଫ 㬥 "+L_XDoc.XDocStr(curXDocId), Len, LEFT)+"|"+
                   Str.Align("2 ࠢ쭮 ଫ 奬 権 "+AcMthL.AcMth, Len, LEFT));
  END;
 END {CheckCS};

 PRIVATE PROCEDURE int_sc_MakeCir(curDir: NUMERIC[0];
                                  curSum: L_XObj.tSum;
                                  curQnt: L_XObj.tQnt);
  VAR
   curSource: L_XObj.tSource;
   D        : DATE;
 BEGIN
  IF    AcMthL.CirSrc = cs_MDoc THEN
   D      :=MDoc.Date;
   curSource:=L_MDoc.GetMDocSource(MDoc.MDocKind);
  ELSIF (AcMthL.CirSrc = cs_PDoc)     |
        (AcMthL.CirSrc = cs_PDocMDoc) |
        (AcMthL.CirSrc = cs_PDocList) THEN
   D      :=PDoc.Date;
   curSource:=L_XObj.src_PDoc;
  ELSE
   L_General.Error("⨬ 筨 ⮢  ஢"+L_StdFrm.HR()+
                   "ࠢ쭮 ᠭ 奬 権 "+AcMthL.AcMth);
  END;
  sc_MakeCir(curDir, L_DatTim.Per(D), AcMthL.CirSrc,
             AcMthL.Origin1, getAcMthL_AcCut(D),  AcMthL.Apport,
             AcMthL.Origin2, getAcMthL_AcCut2(D), AcMthL.Apport2,
             curSum, curQnt, curSource);
 END {int_sc_MakeCir};

 PUBLIC PROCEDURE MakeCir(curDir    : NUMERIC[0];
                          requiredCS: tCirSource;
                          curSum    : L_XObj.tSum;
                          curQnt    : L_XObj.tQnt);
 BEGIN
  CheckCS(requiredCS);
  int_sc_MakeCir(curDir, curSum, curQnt);
 END {MakeCir};

 PUBLIC PROCEDURE MakeStandartCir(curDir    : NUMERIC[0];
                                  requiredCS: tCirSource);
  VAR
   curSum: L_XObj.tSum;
   curQnt: L_XObj.tQnt;
 BEGIN
  CheckCS(requiredCS);
  sc_PrepareStandartCir(curSum, curQnt);
  int_sc_MakeCir(curDir, curSum, curQnt);
 END {MakeStandartCir};

 PUBLIC PROCEDURE GetXApportSpecificValues(xdt: L_XDoc.tXDocType;
                                           VAR
                                            _Source: L_XObj.tSource;
                                           VAR
                                            P      : DATE);
 BEGIN
  IF    xdt = L_XDoc.xdt_MDoc THEN
   P      :=L_DatTim.Per(MDoc.Date);
   _Source:=L_MDoc.GetMDocSource(MDoc.MDocKind);
  ELSIF xdt = L_XDoc.xdt_PDoc THEN
   P      :=L_DatTim.Per(PDoc.Date);
   _Source:=L_XObj.src_PDoc;
  ELSIF xdt = L_XDoc.xdt_JDoc THEN
   P      :=L_DatTim.Per(JDoc.Date);
   _Source:=L_XObj.src_JDoc;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetXApportSpecificValues};

 PUBLIC PROCEDURE RollbackXDoc(curXDocId: L_XDoc.tXDocId);
  VAR
   dmXDocId: L_XDoc.tXDocId;
   i       : NUMERIC[0];
   P       : DATE;
 BEGIN
  APP.Get().NewPrompt("⪠ " + L_XDoc.XDocStr(curXDocId));
  dmXDocId:=L_XDoc.XDocId(L_XDoc.xdt_DUMMY, L_XDoc.EmptyXDocKind, APP.Get().MyConnection.Number);
  SETSEL(XDocApr, XDocApr, dmXDocId);
  REMSEL(XDocApr);
  i:=0;
  SETSEL(XDocApr, XDocApr, curXDocId);
  FOR_EACH XDocApr DO
   XDocApr.XDocId:=dmXDocId;
   INSERT(XDocApr);
   INC(i);
  END; (* FOR_EACH XDocApr *)
  P:=L_DatTim.Per(L_XDoc.GetXDocDate(curXDocId));
  L_General.CallUs(P = Memo.gl_mb());
  SETSEL(XDocApr, XDocApr, dmXDocId);
  FOR_EACH XDocApr DO
   PROMPT(L_Str.IntStr(i));
   IF XDocApr.Source # L_XObj.src_MathRevision THEN
    L_XObj.extMakeCompleteCir(1, curXDocId, -1, P,
                              XDocApr.XObject,  XDocApr.AcCut,  XDocApr.Apport,  XDocApr.wQnt MOD 2,
                              XDocApr.XObject2, XDocApr.AcCut2, XDocApr.Apport2, XDocApr.wQnt DIV 2,
                              XDocApr.Sum, XDocApr.Qnt, XDocApr.Source);
   END;
   DEC(i);
  END; (* FOR_EACH XDocApr *)
  SETSEL(XDocApr, XDocApr, dmXDocId);
  REMSEL(XDocApr);
  L_JDoc.XDoc_ForceUndoneAnnexJDoc(curXDocId);
 END {RollbackXDoc};

 PUBLIC PROCEDURE RenXDocApr(curXDocId: L_XDoc.tXDocId);
 BEGIN
  SELECT(XDocApr, XDocApr, , curXDocId);
  WHILE OCCURE(XDocApr) DO
   IF (XDocApr.Sum = 0) & (XDocApr.Qnt = 0) THEN
    REMOVE(XDocApr);
   ELSE
    NEXT(XDocApr);
   END;
  END; (* WHILE OCCURE(XDocApr) ... *)
 END {RenXDocApr};

BEGIN
 SETEMPTY(pdl_Count); (*!*)
END.
