(*
%Copyright   (c) Polak IT
%Author      11.02.2009 08:17:11 POLAK\LDA
%Purpose     ⥪  ࠡ  窠 㯠
%Type        library
%Specific    AP
%Modified    25.07.2014 11:44:49 POLAK\LDA
%Environment
*)

 MODULE L_AcsPnt [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, L_Str, L_General, L_StdFrm, L_AR, Math, L_PCS;

 PUBLIC TYPE
  tMessageKind = SCAL[4];

 PUBLIC CONST
  apra_Allowed   = 0;
  apra_Denied    = 1;
  apra_4Manager  = 2;

  aprm_None          = 0; (* 26.01.2011 17:08:26 POLAK\San  ⠭  tMessageKind. ,  ⠪ *)
  aprm_Inform        = 1;
  aprm_Choice        = 2;
  aprm_CrucialChoice = 3;

  apr_AccessPool  = "।⠢|⬥|쪮 ";
  apr_MessagePool = " 뢮||롮| 롮";

  aprsrc_Amount   = 2;

  aprsrc_Operator = 0;
  aprsrc_System   = 1;

  MinUserDefinedAcsPnt = 100000;

 PRIVATE PERMANENT VAR
  PassedAcsPnt: OBJECT;

 PRIVATE PROCEDURE SetSingleParentByName(_Name: STRING[]): LIKE(AcsPnt.AcsPnt);
  VAR
   Pos       : NUMERIC[0];
   _Parent   : LIKE(AcsPnt.AcsPnt);
   ParentName: STRING[];
 BEGIN
  Pos:=Str.Length(_Name);
  SETEMPTY(_Parent);
  LOOP
   Pos:=Str.Pos(_Name, ".", Pos, BACKWARD);
   IF (Pos = Str.Length(_Name)) | ~!_Parent THEN
    EXIT;
   END;
   ParentName:=Str.Slice(_Name, 0, Pos);
   SAVE(AcsPnt);
   IF SELECT(AcsPnt, Name, Str.Slice(_Name, 0, Pos)) THEN
    _Parent:=AcsPnt.AcsPnt;
   END;
   RESTORE(AcsPnt);
   DEC(Pos);
  END; (* LOOP *)
  RETURN _Parent;
 END {SetSingleParentByName};

 PUBLIC PROCEDURE SetParents();
 BEGIN
  SELECT(AcsPnt, AcsPnt);
  WHILE OCCURE(AcsPnt) & (AcsPnt.AcsPnt < MinUserDefinedAcsPnt) DO
   PROMPT(AcsPnt.AcsPnt);
   AcsPnt.Parent:=SetSingleParentByName(AcsPnt.Name);
   REPLACE(AcsPnt);
   NEXT(AcsPnt);
  END; (* WHILE OCCURE(AcsPnt) ... *)
 END {SetParents};

 PUBLIC PROCEDURE SetAllAccessPoints();
 BEGIN
  L_PCS.SetAllAccessPoints();
  SetParents();
 END {SetAllAccessPoints};

 PUBLIC PROCEDURE IsUserDefined(_AcsPnt: LIKE(AcsPnt.AcsPnt)): SCAL[2];
 BEGIN
  RETURN _AcsPnt >= MinUserDefinedAcsPnt;
 END {IsUserDefined};

 PUBLIC PROCEDURE NewUserDefinedAcsPnt(): LIKE(AcsPnt.AcsPnt);
  VAR
   result: LIKE(AcsPnt.AcsPnt);
 BEGIN
  SAVE(AcsPnt);
  SELECT(AcsPnt, AcsPnt);
  IF LAST(AcsPnt) & IsUserDefined(AcsPnt.AcsPnt) THEN
   result:=AcsPnt.AcsPnt + 1;
  ELSE
   result:=MinUserDefinedAcsPnt;
  END;
  RESTORE(AcsPnt);
  RETURN result;
 END {NewUserDefinedAcsPnt};

 PRIVATE PROCEDURE GetSingleAcsObjAccess(    _AcsObj : LIKE(AcsObj.AcsObj);
                                         VAR _Message: LIKE(AcsPntR.Message)): LIKE(AcsPntR.Access);
  VAR
   _Access: LIKE(AcsPntR.Access);
 BEGIN
  SETEMPTY(_Access, _Message);
  SAVE(AcsPntR);
  IF SEARCH(AcsPntR, AcsPnt, AcsPnt.AcsPnt, _AcsObj, aprsrc_Operator) |
     SEARCH(AcsPntR, AcsPnt, AcsPnt.AcsPnt, _AcsObj, aprsrc_System  ) THEN
   _Message:=AcsPntR.Message;
   _Access :=AcsPntR.Access;
  END;
  RESTORE(AcsPntR);
  RETURN _Access;
 END {GetSingleAcsObjAccess};

 PRIVATE PROCEDURE intShowMessage(Msg      : STRING[];
                                  Kind     : tMessageKind;
                                  GroupN   : STRING[]);
 BEGIN
  IF    Kind = aprm_Inform        THEN L_StdFrm.Question(Msg);
  ELSIF Kind = aprm_Choice        THEN L_StdFrm.Choice(Msg);
  ELSIF Kind = aprm_CrucialChoice THEN L_StdFrm.CrucialChoice(Msg, GroupN);
  END;
 END {intShowMessage};

 PUBLIC PROCEDURE ShowMessage(Msg: STRING[]; Kind: tMessageKind);
 BEGIN
  L_General.CallUs(Kind # aprm_CrucialChoice);
  intShowMessage(Msg, Kind, "");
 END {ShowMessage};

 PRIVATE PROCEDURE intPassAccessPoint(trgAcsPnt      : LIKE(AcsPnt.AcsPnt);
                                      trgExplanation,
                                      trgAdvice      : STRING[];
                                      wGrantRights   : SCAL[2]): SCAL[2];
  VAR
   Msg,
   AddText  : STRING[];
   rsAccess : LIKE(AcsPntR.Access);
   cgAccess : LIKE(AcsPntR.Access);
   rsMessage: LIKE(AcsPntR.Message);
   cgMessage: LIKE(AcsPntR.Message);
   CrChcGrpN: STRING[];
 BEGIN
  IF ~!APP.Get().MyConnection.Job | PassedAcsPnt.Exists(trgAcsPnt) THEN
   IF wGrantRights THEN
    GRANTALLRIGHTS();
   END;
   RETURN 1;
  ELSE
   TRY [ABORT_AFTER(AA_ON)]
    IF ~SEARCH(AcsPnt, AcsPnt, trgAcsPnt) THEN
     TRY [TRANSACTION(TRANSACTION_SLAVE)]
      L_AR.GrantRightsUnconditionally();
      SetAllAccessPoints();
     EXCEPT
     ELSE
     END;
     L_General.CallUs(SEARCH(AcsPnt, AcsPnt, trgAcsPnt));
    END; (* IF ~SEARCH(AcsPnt, AcsPnt, trgAcsPnt) *)

    rsMessage:=aprm_None;
    rsAccess :=GetSingleAcsObjAccess(L_General.curUSER, rsMessage);
    CrChcGrpN:=L_General.AdminGroupName();
    IF !rsAccess THEN
     SELECT(AcsPntR, AcsPnt, , AcsPnt.AcsPnt);
     WHILE OCCURE(AcsPntR) DO
      NARROWSEL(AcsPntR, AcsObj);
      SEARCH(AcsObj, AcsObj, , AcsPntR.AcsObj);
      IF (AcsObj.Type = L_AR.aot_Group) & L_General.IsMemberOf(AcsObj.Name) THEN
       cgAccess:=GetSingleAcsObjAccess(AcsPntR.AcsObj, cgMessage);
       IF cgAccess = apra_4Manager THEN
        IF L_AR.UserIsManagerOfGroup(AcsPntR.AcsObj, L_General.curUSER) THEN
         cgAccess:=apra_Allowed;
        ELSE
         cgAccess:=apra_Denied;
        END;
       END;
       IF ~!cgAccess THEN
        IF    !rsAccess  | (cgAccess < rsAccess) THEN
         rsAccess :=cgAccess;
         rsMessage:=cgMessage;
        ELSIF !rsMessage | (cgMessage < rsMessage) THEN
         rsMessage:=cgMessage;
        END;
       END;
       IF (cgAccess = apra_Allowed) & (cgMessage = aprm_CrucialChoice) THEN
        CrChcGrpN:=AcsObj.Name;
       END;
      END;
      NEXTINEXTENDEDSEL(AcsPntR, AcsObj);
     END; (* WHILE OCCURE(AcsPntR) *)
    END; (* IF !rsAccess *)
  
    Msg:=AcsPnt.Descr;

    AddText:="";
    IF ~!trgExplanation THEN
     INC(AddText, "(" + trgExplanation + ")|");
    END;

    IF ~!AcsPnt.AddText THEN
     INC(AddText, L_StdFrm.THR(" :") + AcsPnt.AddText + "|");
    END;

    IF ~!trgAdvice THEN
     INC(AddText, L_StdFrm.HR() + trgAdvice + "|");
    END;
    IF ~IsUserDefined(trgAcsPnt) THEN
     INC(AddText, L_StdFrm.HR() + "(ன  ࠢ筨 '窨 㯠', " + trgAcsPnt + ")|");
    END;
   EXCEPT
   END; (* TRY *)
  
   IF wGrantRights THEN
    IF rsAccess = apra_Allowed THEN
     intShowMessage(Msg + AddText, rsMessage, CrChcGrpN);
     GRANTALLRIGHTS();
    ELSE
     L_General.Assert_wReferToAdmin(0, Msg + L_StdFrm.HR() +
                                       "|   稩  宦 ⮩ 窨 㯠" +
                                       "||" + AddText);
     GRANTALLRIGHTS();
     RETURN 1;
    END;
   END;
   IF (rsAccess = apra_Allowed) & (rsMessage = aprm_None) THEN
    PassedAcsPnt.Add(trgAcsPnt, "");
   END;
   RETURN rsAccess = apra_Allowed;
  END;
 END {intPassAccessPoint};

 PUBLIC PROCEDURE MayPassAccessPoint(_AcsPnt: LIKE(AcsPnt.AcsPnt)): SCAL[2];
 BEGIN
  RETURN intPassAccessPoint(_AcsPnt, "", "", 0);
 END {MayPassAccessPoint};

 PUBLIC PROCEDURE PassAccessPoint(_AcsPnt: LIKE(AcsPnt.AcsPnt));
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=intPassAccessPoint(_AcsPnt, "", "", 1);
 END {PassAccessPoint};

 PUBLIC PROCEDURE PassAccessPointIfAllowed(_AcsPnt: LIKE(AcsPnt.AcsPnt));
 BEGIN
  IF MayPassAccessPoint(_AcsPnt) THEN
   PassAccessPoint(_AcsPnt);
  END;
 END {PassAccessPointIfAllowed};

 PUBLIC PROCEDURE PassAccessPoint_wExplanation(_AcsPnt: LIKE(AcsPnt.AcsPnt); Explanation: STRING[]);
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=intPassAccessPoint(_AcsPnt, Explanation, "", 1);
 END {PassAccessPoint_wExplanation};

 PUBLIC PROCEDURE fullPassAccessPoint(trgAcsPnt: LIKE(AcsPnt.AcsPnt); trgExplanation, trgAdvice: STRING[]);
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=intPassAccessPoint(trgAcsPnt, trgExplanation, trgAdvice, 1);
 END {fullPassAccessPoint};

 PUBLIC PROCEDURE Init();
 BEGIN
  SETEMPTY(PassedAcsPnt);
  PassedAcsPnt:=L_General.CreateDictionary();
 END {Init};

 PUBLIC PROCEDURE InsertSingleAcsPntR(GroupName : STRING[];
                                      trgMessage: LIKE(AcsPntR.Message);
                                      trgAccess : LIKE(AcsPntR.Access));
 BEGIN
  IF L_AR.StandOnGroup(GroupName) THEN
   L_General.CallUs(~SEARCH(AcsPntR, AcsPnt, AcsPnt.AcsPnt, AcsObj.AcsObj, aprsrc_System));
 
   DEFAULT(AcsPntR);
   AcsPntR.AcsPnt :=AcsPnt.AcsPnt;
   AcsPntR.AcsObj :=AcsObj.AcsObj;
   AcsPntR.Access :=trgAccess;
   AcsPntR.Message:=trgMessage;
   AcsPntR.Source :=aprsrc_System;
   INSERT(AcsPntR);
  END;
 END {InsertSingleAcsPntR};

 PUBLIC PROCEDURE InitAcsPnt(trgAcsPnt    : LIKE(AcsPnt.AcsPnt);
                             trgName,
                             trgDescr     : STRING[];
                             trgMessage   : LIKE(AcsPntR.Message));
  VAR
   IsNewAcsPnt: SCAL[2];
 BEGIN
  PROMPT(" 窨 㯠 " + trgAcsPnt);
  IsNewAcsPnt:=~SEARCH(AcsPnt, AcsPnt, trgAcsPnt);
  IF IsNewAcsPnt THEN
   AcsPnt.AcsPnt:=trgAcsPnt;
   SETEMPTY(AcsPnt.AddText, AcsPnt.Parent);
   AcsPnt.Leaf  :=0;
  END;

  AcsPnt.Name  :=trgName;
  AcsPnt.Descr :=trgDescr;

  IF IsNewAcsPnt THEN
   INSERT(AcsPnt);
  ELSE
   REPLACE(AcsPnt);
  END;

  IF SELECT(AcsPntR, Source, AcsPnt.AcsPnt, aprsrc_System) THEN
   REMSEL(AcsPntR);
  END;

  InsertSingleAcsPntR(L_General.AdminGroupName(), trgMessage, apra_Allowed);
 END {InitAcsPnt};

 PUBLIC PROCEDURE SetAcsPnt(trgAcsPnt : LIKE(AcsPnt.AcsPnt);
                            trgName,
                            trgDescr  : STRING[];
                            trgGroup  : STRING[];
                            trgMessage: LIKE(AcsPntR.Message));
 BEGIN
  InitAcsPnt(trgAcsPnt, trgName, trgDescr, trgMessage);
  IF ~!trgGroup THEN
   InsertSingleAcsPntR(trgGroup, trgMessage, apra_Allowed);
  END;
 END {SetAcsPnt};

END.
