(*
%Copyright   (c) Polak Computer System
%Author      22.05.1999 17:01:43 SAN
%Purpose     ?
%Type        library
%Specific    SYS
%Modified    17.09.2013 16:04:11 POLAK\Gina
%Environment
*)

 MODULE L_Adding [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  vt_Sum = 0; (*AddKind.ValType*)
  vt_Prc = 1;
  vt_Pool = "㡫|業";

 IMPORT L_General, L_DatTim, Math, L_PRoll;

 VAR
  IsSaved  : SCAL[2];
  _pAddKind: LIKE(Adding.AddKind);
  _pFrom   : LIKE(Adding.From);
  _pValue  : LIKE(Adding.Value);
  _pUpTo   : LIKE(Adding.UpTo);

 PUBLIC PROCEDURE Adding_SaveEmptyPrv();
 BEGIN
  L_General.CallUs(~IsSaved);
  SETEMPTY(_pAddKind, _pFrom, _pValue, _pUpTo);
  IsSaved:=1;
 END {Adding_SaveEmptyPrv};

 PUBLIC PROCEDURE Adding_SavePrvAsPValues();
 BEGIN
  L_General.CallUs(~IsSaved);
  _pAddKind:=GE_PVALUE(Adding.AddKind);
  _pFrom   :=GE_PVALUE(Adding.From);
  _pValue  :=GE_PVALUE(Adding.Value);
  _pUpTo   :=GE_PVALUE(Adding.UpTo);
  IsSaved  :=1;
 END {Adding_SavePrvAsPValues};

 PUBLIC PROCEDURE Adding_SavePrvAsAdding();
 BEGIN
  L_General.CallUs(~IsSaved);
  _pAddKind:=Adding.AddKind;
  _pFrom   :=Adding.From;
  _pValue  :=Adding.Value;
  _pUpTo   :=Adding.UpTo;
  IsSaved  :=1;
 END {Adding_SavePrvAsAdding};

 PUBLIC PROCEDURE Adding_EditMode(): SCAL[2];
 BEGIN
  RETURN ~IsSaved;
 END {Adding_EditMode};

 PUBLIC PROCEDURE Adding_GetActualPer(): DATE;
  VAR
   _minUpTo: DATE;
 BEGIN
  L_General.CallUs(IsSaved);
  IsSaved:=0;
  IF !_pFrom THEN
   RETURN L_DatTim.Per(Adding.From);
  ELSE
   IF (Adding.From    # _pFrom   ) |
      (Adding.Value   # _pValue  ) |
      (Adding.AddKind # _pAddKind) THEN
    RETURN L_DatTim.Per(Math.Min(Adding.From, _pFrom));
   ELSE
    _minUpTo:=Math.Min(Adding.UpTo, _pUpTo);
    IF !_minUpTo THEN
     RETURN L_PRoll.Salary_ClcPer();
    ELSE
     RETURN L_DatTim.Per(_minUpTo + 1);
    END;
   END;
  END;
 END {Adding_GetActualPer};

BEGIN
 IsSaved:=0;
END.
