(*
%Copyright   (c) Polak IT
%Author      17.09.2008 10:39:09 POLAK\San
%Purpose
%Type        library
%Specific    SYS
%Modified    15.09.2014 09:48:35 lda
%Environment
*)

 MODULE L_APAR [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_APtm, L_AR, P_Firm, Str, L_Rpr, L_Env, L_Str, L_AcsPnt, L_StdFrm, L_Staff, L_DatTim;

 PRIVATE PROCEDURE GrantRightsForAroundTheClock();
 BEGIN
  IF    L_APtm.IsAccountant() THEN
   GRANTALLRIGHTS("RWDst", "*");
   GRANTALLRIGHTS("Car05", "*");
  END;
  IF L_General.IsMemberOf(L_APtm.g_Disp) THEN
   GRANTALLRIGHTS("Beg002", "*");
   GRANTALLRIGHTS("BegRWP", "*");
   GRANTALLRIGHTS("BegRWS", "*");
   GRANTALLRIGHTS("BRWSTst", "*");
  END;
  IF L_APtm.IsOutPost() THEN
   GRANTALLRIGHTS("BegRWS", "*");
  END;
  IF L_APtm.IsTicketCashier() THEN
   GRANTALLRIGHTS("TckRcS", "*");
   GRANTALLRIGHTS("XDoc", "*");
   GRANTALLRIGHTS("BegTRS", "*");
   GRANTALLRIGHTS("Tck02", "*");
   GRANTALLRIGHTS("Tck04", "*");
   GRANTALLRIGHTS("Tck05", "*");
   GRANTALLRIGHTS("Tck10", "*");
   GRANTALLRIGHTS("Tck20", "*");
   GRANTALLRIGHTS("Tck30", "*");
   GRANTALLRIGHTS("TckRcD", "*");
   GRANTALLRIGHTS("TckRcC", "*");
   GRANTALLRIGHTS("Storage", "*");
  END;
  IF L_APtm.IsRepairZone() THEN
   GRANTALLRIGHTS("Rpr06", "*");
   GRANTALLRIGHTS("RprS", "*");
   GRANTALLRIGHTS("RprShow", "*");
   GRANTALLRIGHTS("RprTPrn", "*");
   GRANTALLRIGHTS("StatusMap", "*");
  END;
  IF L_APtm.IsMechanic() THEN
   GRANTALLRIGHTS("BegRWS", "*");
  END;
  IF L_General.IsMemberOf(L_APtm.g_twoOp) THEN
   GRANTALLRIGHTS("TWO", "*");
   GRANTALLRIGHTS("Shit04", "*");
  END;
  IF L_APtm.KioskUser_WO_Authorization() THEN
   GRANTALLRIGHTS("Kiosk", "*");
  END;
 END {GrantRightsForAroundTheClock};

 PRIVATE PROCEDURE cmf_SingleFile(trgTable: TABLE; MyFirms: P_Firm.tMyFirm[]; Exclusions: STRING[]);
  VAR
   curMyFirm: P_Firm.tMyFirm;
   Filter   : STRING[];
 BEGIN
  IF !L_Str.PositionInPool(Exclusions, trgTable.Name) THEN
   Filter:="";
   FOR_EACH curMyFirm IN MyFirms DO
    IF ~!Filter THEN
     Filter:=Filter + "&";
    END;
    Filter:=Filter + "(" + trgTable.Fields("MyFirm").ObtainName() + "#" + curMyFirm + ")";
   END;
   trgTable.Filter:=Filter;
  END;
 END {cmf_SingleFile};

 PRIVATE PROCEDURE ConcealMyFirm(MyFirms: P_Firm.tMyFirm[]; Exclusions: STRING[]);
  VAR
   mfTable: TABLE;
   curLink: LINK;
   Link,
   excFile: STRING[];
   i      : NUMERIC[0];
 BEGIN
  mfTable:=TABLE.Get("MyFirm");
  cmf_SingleFile(mfTable, MyFirms, Exclusions);
  FOR_EACH curLink IN mfTable.Links DO
   IF curLink.Kind = LINK.Kind_Owner THEN
    cmf_SingleFile(curLink.CooIndex.Table, MyFirms, Exclusions);
   END;
  END;
  i:=0;
  LOOP
   excFile:=L_Str.PoolItem(Exclusions, i);
   IF !excFile THEN
    EXIT;
   END;
   TABLE.Get(excFile).TransitiveFiltersAreActive:=0;
   INC(i);
  END; (* LOOP *)
 END {ConcealMyFirm};

 PRIVATE PROCEDURE ConcealSomeMyFirm();
  VAR
   MyFirmsToConceal: P_Firm.tMyFirm[64];
   i               : NUMERIC[0];
   DoIt            : SCAL[2];
 BEGIN
  DoIt:=0;
  IF L_General.GetAPSiteID() = "KL" THEN
   IF L_General.IsMemberOf("1792ONLY") THEN
    DoIt:=1;
    SETEMPTY(MyFirmsToConceal);
    i:=0;
    SELECT(MyFirm, MyFirm);
    WHILE OCCURE(MyFirm) DO
     IF (MyFirm.MyFirm # P_Firm.mf_Fict) & (MyFirm.MyFirm # L_Env.mf_AK) THEN
      MyFirmsToConceal[i]:=MyFirm.MyFirm;
      INC(i);
     END;
     NEXT(MyFirm);
    END; (* WHILE OCCURE(MyFirm) ... *)
    ConcealMyFirm(MyFirmsToConceal, "MyFirm|MFPro|Column|MDoc|MDocList|MDocLCU|Storage|StrgLog|Storage2|Math|CostItem|Contract");
   END;
  END;
  IF DoIt THEN
   L_AR.ConcealPartOfDatabase();
  END;
 END {ConcealSomeMyFirm};

 PUBLIC PROCEDURE AddUnconditionallyRelatedFiles();
 BEGIN
  APP.Get().NewPrompt(" 易 䠩");
(*
  L_AR.ft_SetRelated("Adding",   "Staff");
  L_AR.ft_SetRelated("Calendar", "Month");
  L_AR.ft_SetRelated("Deduct",   "Staff");
  L_AR.ft_SetRelated("ECSort",   "ExitClss");
  L_AR.ft_SetRelated("ExitIP",   "StExit");
  L_AR.ft_SetRelated("MPG_WP",   "MarkG");
  L_AR.ft_SetRelated("ManMlt",   "Man");
  L_AR.ft_SetRelated("Money",    "Staff");
  L_AR.ft_SetRelated("Monthly",  "Staff");
  L_AR.ft_SetRelated("OwnDPro",  "Property");
  L_AR.ft_SetRelated("PCalc",    "Staff");
  L_AR.ft_SetRelated("RouteIP",  "Route");
  L_AR.ft_SetRelated("Sheet",    "Staff");
  L_AR.ft_SetRelated("SrMnthly", "Sort");
  L_AR.ft_SetRelated("TaxInq",   "Man");
  L_AR.ft_SetRelated("WagePayL", "WagePay");
*)

  L_AR.ft_SetRelated("aofrl",    "aofr");
  L_AR.ft_SetRelated("AC2Log",   "AcCut2");
  L_AR.ft_SetRelated("ACLog",    "AcCut");
  L_AR.ft_SetRelated("ACSetL",   "ACSet");
  L_AR.ft_SetRelated("AcsPntR",  "AcsPnt");
  L_AR.ft_SetRelated("ATERAttr", "ATER");
  L_AR.ft_SetRelated("AcCut2",   "AcCut");
  L_AR.ft_SetRelated("AcMthA",   "AcMth");
  L_AR.ft_SetRelated("AcMthH",   "AcMth");
  L_AR.ft_SetRelated("AcMthL",   "AcMthH");
  L_AR.ft_SetRelated("AcsObj2",  "AcsObj");
  L_AR.ft_SetRelated("AlTypeL",  "AlType");
  L_AR.ft_SetRelated("Apport2",  "Apport");
  L_AR.ft_SetRelated("ArticleL", "Article");
  L_AR.ft_SetRelated("AvePPro",  "AvePay");
  L_AR.ft_SetRelated("AvePayP",  "AvePay");
  L_AR.ft_SetRelated("AveTypeP", "AveType");
  L_AR.ft_SetRelated("bpPL",     "bpP");
  L_AR.ft_SetRelated("BankBrn",  "Bank");
  L_AR.ft_SetRelated("BankBrnL", "BankBrn");
  L_AR.ft_SetRelated("BankLog",  "Bank");
  L_AR.ft_SetRelated("CIPro",    "CostItem");
  L_AR.ft_SetRelated("ClmnPro",  "Column");
  L_AR.ft_SetRelated("DfrlsL",   "Dfrls");
  L_AR.ft_SetRelated("DfrlsLD",  "DfrlsL");
  L_AR.ft_SetRelated("DWHP",     "DWH");
  L_AR.ft_SetRelated("DWHPL",    "DWH");
  L_AR.ft_SetRelated("dwhSPSet", "dwhS");
  L_AR.ft_SetRelated("dwhSP",    "dwhS");
  L_AR.ft_SetRelated("dwhSPG",   "dwhS");
  L_AR.ft_SetRelated("dwhI",     "dwhS");
  L_AR.ft_SetRelated("CUCPro",   "CUCopy");
  L_AR.ft_SetRelated("CarEvn",   "Car");
  L_AR.ft_SetRelated("CarLog",   "Car");
  L_AR.ft_SetRelated("CarPro",   "Car");
  L_AR.ft_SetRelated("CarRun",   "Car");
  L_AR.ft_SetRelated("CntrPro",  "Contract");
  L_AR.ft_SetRelated("CntrT",    "Contract");
  L_AR.ft_SetRelated("CtcVal",   "Contact");
  L_AR.ft_SetRelated("CtcAdr",   "Contact");
  L_AR.ft_SetRelated("dbRDtl",   "dbRights");
  L_AR.ft_SetRelated("DedAcnt",  "Deduct");
  L_AR.ft_SetRelated("DsptPck",  "Dspt");
  L_AR.ft_SetRelated("DsptDoc",  "Dspt");
  L_AR.ft_SetRelated("DsptFirm", "Dspt");
  L_AR.ft_SetRelated("DsptMPro", "DsptMode");
  L_AR.ft_SetRelated("DsptStf",  "Dspt");
  L_AR.ft_SetRelated("DsptTime", "Dspt");
  L_AR.ft_SetRelated("Dtwo",     "Mtwo");
  L_AR.ft_SetRelated("EDOKPro",  "EDOKind");
  L_AR.ft_SetRelated("EDOLC",    "EDOrderL");
  L_AR.ft_SetRelated("EDOLPro",  "EDOrderL");
  L_AR.ft_SetRelated("EDOrderL", "EDOrder");
  L_AR.ft_SetRelated("EnvlParm", "EnvlLttr");
  L_AR.ft_SetRelated("ExitClss", "StExit");
  L_AR.ft_SetRelated("ExitIPL",  "ExitIP");
  L_AR.ft_SetRelated("ExitPro",  "StExit");
  L_AR.ft_SetRelated("FOrderL",  "FOrder");
  L_AR.ft_SetRelated("FirmAcnt", "Firm");
  L_AR.ft_SetRelated("FirmCtc",  "Firm");
  L_AR.ft_SetRelated("FirmPro",  "Firm");
  L_AR.ft_SetRelated("FlRecL",   "FlRec");
  L_AR.ft_SetRelated("IRecL",    "IRec");
  L_AR.ft_SetRelated("JRgPayT",  "JRegime");
  L_AR.ft_SetRelated("KAGLog",   "KAGroup");
  L_AR.ft_SetRelated("MCPro",    "MCList");
  L_AR.ft_SetRelated("MDocLCU",  "MDocList");
  L_AR.ft_SetRelated("MDocList", "MDoc");
  L_AR.ft_SetRelated("MDocPro",  "MDoc");
  L_AR.ft_SetRelated("MDocBD",   "MDoc");
  L_AR.ft_SetRelated("IsSData",  "MDoc");
  L_AR.ft_SetRelated("JDocList", "JDoc");
  L_AR.ft_SetRelated("MFPro",    "MyFirm");
  L_AR.ft_SetRelated("MSPro",    "MySite");
  L_AR.ft_SetRelated("MPPro",    "MyPlace");
  L_AR.ft_SetRelated("MMthLog",  "MoneyMth");
  L_AR.ft_SetRelated("ManExpr",  "Man");
  L_AR.ft_SetRelated("ManPro",   "Man");
  L_AR.ft_SetRelated("ManTA",    "TaxInq");
  L_AR.ft_SetRelated("MarkFuel", "Mark");
  L_AR.ft_SetRelated("MarkGM",   "Mark");
  L_AR.ft_SetRelated("MarkGPro", "MarkG");
  L_AR.ft_SetRelated("MarkPro",  "Mark");
  L_AR.ft_SetRelated("MarkREN",  "Mark");
  L_AR.ft_SetRelated("MathEAN",  "Math");
  L_AR.ft_SetRelated("MathKAGL", "Math");
  L_AR.ft_SetRelated("MathMrkG", "Math");
  L_AR.ft_SetRelated("MathMty",  "Math");
  L_AR.ft_SetRelated("MathRun",  "Math");
  L_AR.ft_SetRelated("MathPro",  "Math");
  L_AR.ft_SetRelated("MathUnit", "Math");
  L_AR.ft_SetRelated("MeterLog", "Meter");
  L_AR.ft_SetRelated("Methods",  "PayKind");
  L_AR.ft_SetRelated("mItem",    "XObject");
  L_AR.ft_SetRelated("MoneyDst", "Money");
  L_AR.ft_SetRelated("MoneyRul", "MMthLog");
  L_AR.ft_SetRelated("MonthRt",  "Monthly");
  L_AR.ft_SetRelated("MRFlNorm", "Mark");
  L_AR.ft_SetRelated("MtrRg",    "MtrRdout");
  L_AR.ft_SetRelated("ODocPro",  "ODoc");
  L_AR.ft_SetRelated("ODocStf",  "ODoc");
  L_AR.ft_SetRelated("OfcDst",   "Officer");
  L_AR.ft_SetRelated("OfcPro",   "Officer");
  L_AR.ft_SetRelated("OfcShift", "Officer");
  L_AR.ft_SetRelated("Officer",  "Sort");
  L_AR.ft_SetRelated("OKOFAttr", "OKOF");
  L_AR.ft_SetRelated("OKOFGrp",  "OKOFAttr");
  L_AR.ft_SetRelated("PDocList", "PDoc");
  L_AR.ft_SetRelated("PDocMDoc", "PDoc");
  L_AR.ft_SetRelated("PDocPro",  "PDoc");
  L_AR.ft_SetRelated("PckATER",  "Packet");
  L_AR.ft_SetRelated("PckAttr",  "Packet");
  L_AR.ft_SetRelated("PckBody",  "Packet");
  L_AR.ft_SetRelated("PoolVal",  "Pool");
  L_AR.ft_SetRelated("PostPro",  "Post");
  L_AR.ft_SetRelated("REMGPrm",  "REPrm");
  L_AR.ft_SetRelated("ROpMarkT", "ROp");
  L_AR.ft_SetRelated("RWayCP",   "RWayJ");
  L_AR.ft_SetRelated("RWayJ",    "RWayS");
  L_AR.ft_SetRelated("RWayF",    "RWayS");
  L_AR.ft_SetRelated("RWayJP",   "RWayJ");
  L_AR.ft_SetRelated("RWayTxt",  "RWayS");
  L_AR.ft_SetRelated("recMsg",   "Message");
  L_AR.ft_SetRelated("RegHead",  "RegMain");
  L_AR.ft_SetRelated("RegList",  "RegHead");
  L_AR.ft_SetRelated("RoutMod",  "Route");
  L_AR.ft_SetRelated("RouteIPL", "RouteIP");
  L_AR.ft_SetRelated("RouteLog", "Route");
  L_AR.ft_SetRelated("RoutePro", "Route");
  L_AR.ft_SetRelated("RprDA",    "RprS");
  L_AR.ft_SetRelated("RprPro",   "RprS");
  L_AR.ft_SetRelated("RprJ",     "RprT");
  L_AR.ft_SetRelated("RprJMG",   "RprJob");
  L_AR.ft_SetRelated("RprJobDt", "RprJob");
  L_AR.ft_SetRelated("RprP",     "RprJ");
  L_AR.ft_SetRelated("RprT",     "RprS");
  L_AR.ft_SetRelated("RtMStop",  "RoutMod");
  L_AR.ft_SetRelated("SalDSetL", "SalDSet");
  L_AR.ft_SetRelated("SEJMStop", "SEJobs");
  L_AR.ft_SetRelated("SEJobs",   "StExit");
  L_AR.ft_SetRelated("SYSLOGA",  "SYSLOGD");
  L_AR.ft_SetRelated("SYSLOGD",  "SYSLOG_");
  L_AR.ft_SetRelated("StaffMon", "Sheet");
  L_AR.ft_SetRelated("SortPro",  "Sort");
  L_AR.ft_SetRelated("SprtCrsA", "SprtCrsp");
  L_AR.ft_SetRelated("StaffPro", "Staff");
  L_AR.ft_SetRelated("StaffLog", "Staff");
  L_AR.ft_SetRelated("StopCP",   "Stop");
  L_AR.ft_SetRelated("Storage2", "Storage");
  L_AR.ft_SetRelated("Strg2Log", "Storage2");
  L_AR.ft_SetRelated("StrgLog",  "Storage");
  L_AR.ft_SetRelated("StrgPro",  "Storage");
  L_AR.ft_SetRelated("TKindPro", "TKind");
  L_AR.ft_SetRelated("TckRcDL",  "TckRcD");
  L_AR.ft_SetRelated("TckRcDLL", "TckRcDL");
  L_AR.ft_SetRelated("TckRcJ",   "TckRcS");
  L_AR.ft_SetRelated("TckRcJR",  "TckRcJ");
  L_AR.ft_SetRelated("TckRcT",   "TckRcS");
  L_AR.ft_SetRelated("UnionPro", "Union");
  L_AR.ft_SetRelated("VndAlias", "Vendor");
  L_AR.ft_SetRelated("WJMethod", "WJMode");
  L_AR.ft_SetRelated("WJMty",    "WJMethod");
  L_AR.ft_SetRelated("WayLCar",  "RWayS");
  L_AR.ft_SetRelated("WayLMen",  "RWayS");
  L_AR.ft_SetRelated("XApport",  "XCalc");
  L_AR.ft_SetRelated("ccTBS1",   "ccTBSH");
  L_AR.ft_SetRelated("ccTBS2",   "ccTBSH");
  L_AR.ft_SetRelated("eMoney",   "Money");
  L_AR.ft_SetRelated("mfBnkAcn", "MyFirm");
  L_AR.ft_SetRelated("xRfTn",    "xRfTnH");
 END {AddUnconditionallyRelatedFiles};

 PRIVATE PROCEDURE x_Man(Rights: L_AR.tFileRights);
 BEGIN
  L_AR.ft_Add("Man",      Rights);
  L_AR.ft_Add("ManAdr",   Rights);
  L_AR.ft_Add("ManFml",   Rights);
  L_AR.ft_Add("ManActv",  Rights);
  L_AR.ft_Add("ManMlt",   Rights);
  L_AR.ft_Add("Contact",  Rights);
  L_AR.ft_Add("Expr",     Rights);
 END {x_Man};

 PRIVATE PROCEDURE s_ManView();
 BEGIN
  x_Man(L_AR.fr_Read);
  L_AR.ft_Add("Staff",    L_AR.fr_Read);
 END {s_ManView};

 PRIVATE PROCEDURE x_Acnt(Rights: L_AR.tFileRights);
 BEGIN
  L_AR.ft_Add("AcCut",    Rights);
  L_AR.ft_Add("ACSet",    Rights);
  L_AR.ft_Add("AcMth",    Rights);
  L_AR.ft_Add("Alower",   Rights);
  L_AR.ft_Add("Apport",   Rights);
  L_AR.ft_Add("ATER",     Rights);
  L_AR.ft_Add("BIC",      Rights);
  L_AR.ft_Add("CAcnt",    Rights);
  L_AR.ft_Add("CIKind",   Rights);
  L_AR.ft_Add("CostItem", Rights);
  L_AR.ft_Add("Dfrls",    Rights);
  L_AR.ft_Add("Dest",     Rights);
  L_AR.ft_Add("DGroup",   Rights);
  L_AR.ft_Add("MCList",   Rights);
  L_AR.ft_Add("MTMM",     Rights);
  L_AR.ft_Add("MDMth",    Rights);
  L_AR.ft_Add("PayP",     Rights);
  L_AR.ft_Add("ccTBSH",   L_AR.fr_Modify);
 END {x_Acnt};

 PRIVATE PROCEDURE x_Officer(Rights: L_AR.tFileRights);
 BEGIN
  L_AR.ft_Add("Officer",  Rights);
  L_AR.ft_Add("Post",     Rights);
  L_AR.ft_Add("SalDSet",  Rights);
  L_AR.ft_Add("Shift",    Rights);
  L_AR.ft_Add("Sort",     Rights);
  L_AR.ft_Add("Union",    Rights);
  L_AR.ft_Add("WagePay",  Rights);
 END {x_Officer};

 PRIVATE PROCEDURE x_Mark(Rights: L_AR.tFileRights);
 BEGIN
  L_AR.ft_Add("VehType",     Rights);
  L_AR.ft_Add("Mark",        Rights);
  L_AR.ft_Add("EnginTyp",    L_AR.fr_Read);
  L_AR.ft_Add("MarkG",       L_AR.fr_Read);
  L_AR.ft_Add("MarkGT",      L_AR.fr_Read);
 END {x_Mark};

 PRIVATE PROCEDURE CarEvnTracking();
 BEGIN
  L_AR.ft_Add("CarEvn",     L_AR.fr_Modify);
  L_AR.ft_Add("REFrCast",   L_AR.fr_Modify);
  L_AR.ft_Add("RepEvent",   L_AR.fr_Modify);
  L_AR.ft_Add("MarkREN",    L_AR.fr_Modify);
  L_AR.ft_Add("REPrm",      L_AR.fr_Read);
 END {CarEvnTracking};

 PRIVATE PROCEDURE x_Car(Rights: L_AR.tFileRights);
 BEGIN
  L_AR.ft_Add("Car",         Rights);
  L_AR.ft_Add("VehType",     Rights);
  L_AR.ft_Add("VehPasp",     Rights);
  L_AR.ft_Add("Column",      L_AR.fr_Read);
  x_Mark(L_AR.fr_Read);
 END {x_Car};

 PRIVATE PROCEDURE s_StockView();
 BEGIN
  x_Acnt(L_AR.fr_Read);
  x_Car(L_AR.fr_Read);
  L_AR.ft_Add("JDoc",      L_AR.fr_Read);
  L_AR.ft_Add("KAGroup",   L_AR.fr_Read);
  L_AR.ft_Add("Math",      L_AR.fr_Read);
  L_AR.ft_Add("MDoc",      L_AR.fr_Read);
  L_AR.ft_Add("OKOF",      L_AR.fr_Read);
  L_AR.ft_Add("RWayS",     L_AR.fr_Read);
  L_AR.ft_Add("Storage",   L_AR.fr_Read);

  (* 䨣 *)
  L_AR.ft_Add("OfcPro",    L_AR.fr_Read); (* OnReposition *)
 END {s_StockView};

 PRIVATE PROCEDURE s_CarView();
 BEGIN
  L_AR.ft_Add("Car",       L_AR.fr_Read);
  L_AR.ft_Add("MCFix",     L_AR.fr_Read);
  L_AR.ft_Add("RWayS",     L_AR.fr_Read);
 END {s_CarView};

 PRIVATE PROCEDURE m_Stock();
 BEGIN
  s_StockView();
  L_AR.ft_Add("CUCopy",    L_AR.fr_Modify);
  L_AR.ft_Add("FlRec",     L_AR.fr_Modify);
  L_AR.ft_Add("MDoc",      L_AR.fr_Modify);
  L_AR.ft_Add("JDoc",      L_AR.fr_Modify);
  L_AR.ft_Add("XObject",   L_AR.fr_Modify);
  L_AR.ft_Add("XCalc",     L_AR.fr_Modify);
(*    樨 07.11.2008 18:44:25 San *)
(*       MDoc.asl 19.11.2008 12:03:05 POLAK\San *)
  L_AR.ft_Add("PDocMDoc",  L_AR.fr_Read);
  L_AR.ft_Add("TckKind",   L_AR.fr_Read);
  L_AR.ft_Add("CstDclr",   L_AR.fr_Modify);
  L_AR.ft_Add("KAGroup",   L_AR.fr_Modify);
 END {m_Stock};

 PRIVATE PROCEDURE m_MainStock();
 BEGIN
  L_AR.ft_Add("CarUnit",   L_AR.fr_Modify);
  L_AR.ft_Add("Math",      L_AR.fr_Modify);
  L_AR.ft_Add("KAGroup",   L_AR.fr_Modify);
  L_AR.ft_Add("Vendor",    L_AR.fr_Modify);
 END {m_MainStock};

 PRIVATE PROCEDURE m_Car();
 BEGIN
  x_Car (L_AR.fr_Modify);
  x_Mark(L_AR.fr_Modify);
  CarEvnTracking();
 END {m_Car};

 PRIVATE PROCEDURE x_IPlan(Rights: L_AR.tFileRights);
 BEGIN
  L_AR.ft_Add("ExitIP",      Rights);
  L_AR.ft_Add("RouteIP",     Rights);
 END {x_IPlan};

 PRIVATE PROCEDURE x_RWOP(Rights: L_AR.tFileRights);
 BEGIN
  x_IPlan(L_AR.fr_Read);
  x_Car(L_AR.fr_Read);
  L_AR.ft_Add("CWOrder",     Rights);
  L_AR.ft_Add("CarRun",      Rights);
  L_AR.ft_Add("ECSort",      L_AR.fr_Read);
  L_AR.ft_Add("ElTck",       L_AR.fr_Read);
  L_AR.ft_Add("IRec",        Rights);
  L_AR.ft_Add("JRegime",     L_AR.fr_Read);
  L_AR.ft_Add("JRgPayT",     Rights);
  L_AR.ft_Add("MCFix",       L_AR.fr_Read);
  L_AR.ft_Add("MCGroup",     L_AR.fr_Read);
  L_AR.ft_Add("MCList",      L_AR.fr_Read);
  L_AR.ft_Add("MPG_WP",      Rights);
  L_AR.ft_Add("MathMty",     Rights);
  L_AR.ft_Add("MathRun",     Rights);
  L_AR.ft_Add("MoneyMth",    L_AR.fr_Read);
  L_AR.ft_Add("Monthly",     Rights);
  L_AR.ft_Add("MthType",     L_AR.fr_Read);
  L_AR.ft_Add("MtyIdx",      Rights);
  L_AR.ft_Add("Ticket",      Rights);
  L_AR.ft_Add("Quality",     L_AR.fr_Read);
  L_AR.ft_Add("RWJPro",      Rights);
  L_AR.ft_Add("RWPay",       Rights);
  L_AR.ft_Add("RWayS",       Rights);
  L_AR.ft_Add("Rule",        L_AR.fr_Read);
  L_AR.ft_Add("Sheet",       L_AR.fr_Read);
  L_AR.ft_Add("StopCP",      Rights);
  L_AR.ft_Add("Storage",     L_AR.fr_Read);
  L_AR.ft_Add("TKind",       L_AR.fr_Read);
  L_AR.ft_Add("TckKind",     Rights);
  L_AR.ft_Add("TckRcC",      L_AR.fr_Read);
  L_AR.ft_Add("TckRcD",      L_AR.fr_Read);
  L_AR.ft_Add("TckRcDLL",    Rights); (* 㦭  ⠪஢ Bulk *)
  L_AR.ft_Add("TckRcS",      Rights);
 END {x_RWOP};

 PRIVATE PROCEDURE x_RprS(Rights: L_AR.tFileRights);
 BEGIN
  L_AR.ft_Add("CarBlock", L_AR.fr_Read);
  L_AR.ft_Add("RprDfApr", L_AR.fr_Read);
  L_AR.ft_Add("RprJob",   L_AR.fr_Read);
  L_AR.ft_Add("OutCar",   L_AR.fr_Read);
  L_AR.ft_Add("OutCBlc",  L_AR.fr_Read);
  L_AR.ft_Add("RprS",     Rights);
 END {x_RprS};

 PRIVATE PROCEDURE ft_db_SingleRigths();
 BEGIN
  CONFORM(dbRights, dbFile);
  L_AR.ft_AddByAdmin(dbFile.Name, dbRights.Rights, dbRights.Manager);
 END {ft_db_SingleRigths};

 PRIVATE PROCEDURE ft_db_SingleAcsObj();
 BEGIN
  SELECT(dbRights, AcsObj, , AcsObj.AcsObj);
  WHILE OCCURE(dbRights) DO
   ft_db_SingleRigths();
   NEXT(dbRights);
  END; (* WHILE OCCURE(dbRights) ... *)
 END {ft_db_SingleAcsObj};

 PRIVATE VAR
  SpecifiedAcsObj: LIKE(AcsObj.AcsObj);

 PRIVATE PROCEDURE ft_db_PutAll(byTokenGroups: SCAL[2]);
  VAR
   e: ENUMERATOR;
 BEGIN
  L_General.CallUs(SEARCH(AcsObj, AcsObj, SpecifiedAcsObj));
  ft_db_SingleAcsObj();
  IF byTokenGroups THEN
   e:=CreateENUMERATOR(APP.Get().MyConnection.TokenGroups);
   WHILE ~e.AtEnd() DO
    IF SEARCH(AcsObj, TNAME, L_AR.aot_Group, Str.Cap(e.Item().Name)) THEN
     ft_db_SingleAcsObj();
    END;
    e.MoveNext();
   END;
  ELSE
   SELECT(AOMem, AcsObj2, , SpecifiedAcsObj);
   WHILE OCCURE(AOMem) DO
    CONFORM(AOMem, AcsObj);
    ft_db_SingleAcsObj();
    NEXT(AOMem);
   END; (* WHILE OCCURE(AOMem) ... *)
  END;
 END {ft_db_PutAll};

 PRIVATE PROCEDURE HasRightsAsMemberOfGroup(Login: STRING[]; Manager: LIKE(AOMem.Manager)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  L_AR.frt_SetIsManager(Manager);
  IF ~L_AR.StandOnGroup(Login) | ~L_General.IsMemberOf(Login) THEN
   RETURN 0;
  END;
  RETURN ~Manager | L_AR.ft_UserIsManagerOfGroup(AcsObj.AcsObj, SpecifiedAcsObj);
 END {HasRightsAsMemberOfGroup};

 PRIVATE PROCEDURE SpecifiedAcsObjIsInGroup(Login: STRING[]; Manager: LIKE(AOMem.Manager)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  L_AR.frt_SetIsManager(Manager);
  Result:=0;
  IF L_AR.StandOnGroup(Login) THEN
   SAVE(AOMem);
   Result:=SEARCH(AOMem, AcsObj, AcsObj.AcsObj, SpecifiedAcsObj) & (~Manager | AOMem.Manager);
   RESTORE(AOMem);
  END;
  RETURN Result;
 END {SpecifiedAcsObjIsInGroup};

 PRIVATE PROCEDURE GroupIsSpecifiedAcsObj(Login: STRING[]; Manager: LIKE(AOMem.Manager)): SCAL[2];
 BEGIN
  L_AR.frt_SetIsManager(Manager);
  RETURN L_AR.StandOnGroup(Login) & (AcsObj.AcsObj = SpecifiedAcsObj);
 END {GroupIsSpecifiedAcsObj};

 PRIVATE PROCEDURE GroupExists(Login: STRING[]; Manager: LIKE(AOMem.Manager)): SCAL[2];
 BEGIN
  L_AR.frt_SetIsManager(Manager);
  RETURN L_AR.StandOnGroup(Login);
 END {GroupExists};

 PRIVATE PROCEDURE ft_FillFor(HRP: PROC);
 BEGIN
  AddUnconditionallyRelatedFiles();
  L_AR.ft_Add("aofr",     L_AR.fr_Modify);
  L_AR.ft_Add("AcsObj",   L_AR.fr_Modify);
  L_AR.ft_Add("AcsPnt",   L_AR.fr_Read);
  L_AR.ft_Add("ACalc",    L_AR.fr_Modify);
  L_AR.ft_Add("AOMem",    L_AR.fr_Modify);
  L_AR.ft_Add("aoProLst", L_AR.fr_Modify);
  L_AR.ft_Add("bp",       L_AR.fr_Modify);
  L_AR.ft_Add("bpRT",     L_AR.fr_Modify);
  L_AR.ft_Add("bpP" ,     L_AR.fr_Read);
  L_AR.ft_Add("ccCnct",   L_AR.fr_Modify);
  L_AR.ft_Add("ccJDL",    L_AR.fr_Modify);
  L_AR.ft_Add("ccLD",     L_AR.fr_Modify);
  L_AR.ft_Add("ccKAXDoc", L_AR.fr_Modify);
  L_AR.ft_Add("dbFile",   L_AR.fr_Read);
  L_AR.ft_Add("dbRights", L_AR.fr_Read);
  L_AR.ft_Add("DoneEF",   L_AR.fr_Modify);
  L_AR.ft_Add("iga",      L_AR.fr_Read);
  L_AR.ft_Add("Group",    L_AR.fr_Read);
  L_AR.ft_Add("GroupE",   L_AR.fr_Read);
  L_AR.ft_Add("GroupT",   L_AR.fr_Read);
  L_AR.ft_Add("lsStore",  L_AR.fr_Modify);
  L_AR.ft_Add("Message",  L_AR.fr_Modify);
  L_AR.ft_Add("mfMan",    L_AR.fr_Modify);
  L_AR.ft_Add("MyFirm",   L_AR.fr_Read);
  L_AR.ft_Add("MyPlace",  L_AR.fr_Read);
  L_AR.ft_Add("MySite",   L_AR.fr_Read);
  L_AR.ft_Add("Pool",     L_AR.fr_Modify);
  L_AR.ft_Add("qs",       L_AR.fr_Modify);
  L_AR.ft_Add("r2r",      L_AR.fr_Modify);
  L_AR.ft_Add("rtCar",    L_AR.fr_Modify);
  L_AR.ft_Add("rtExit",   L_AR.fr_Modify);
  L_AR.ft_Add("SES",      L_AR.fr_Modify);
  L_AR.ft_Add("SYSLOG",   L_AR.fr_Read);
  L_AR.ft_Add("SYSLOG_",  L_AR.fr_Modify);
  L_AR.ft_Add("StrgKind", L_AR.fr_Read);
  L_AR.ft_Add("XDocApr",  L_AR.fr_Modify);
  L_AR.ft_Add("XDFCase",  L_AR.fr_Modify);
  L_AR.ft_Add("XDocFile", L_AR.fr_Modify);
  L_AR.ft_Add("XDocFlow", L_AR.fr_Modify);
  L_AR.ft_Add("XDocJrn",  L_AR.fr_Modify);
  L_AR.ft_Add("XDocRef",  L_AR.fr_Modify);
  L_AR.ft_Add("XODone",   L_AR.fr_Modify);

  L_AR.ft_Add("Country",  L_AR.fr_Read);
  L_AR.ft_Add("CUCopy",   L_AR.fr_Read);
  L_AR.ft_Add("Firm",     L_AR.fr_Read);
  L_AR.ft_Add("Bank",     L_AR.fr_Read);
  L_AR.ft_Add("KlAdr",    L_AR.fr_Read);
  L_AR.ft_Add("Month",    L_AR.fr_Read);
  L_AR.ft_Add("Officer",  L_AR.fr_Read);
  L_AR.ft_Add("OwnDPro",  L_AR.fr_Modify);
  L_AR.ft_Add("Property", L_AR.fr_Read);
  L_AR.ft_Add("Region",   L_AR.fr_Read);
  L_AR.ft_Add("RegMain",  L_AR.fr_Read);
  L_AR.ft_Add("Route",    L_AR.fr_Read);
  L_AR.ft_Add("StExit",   L_AR.fr_Read);
  L_AR.ft_Add("WJMode",   L_AR.fr_Read);
  L_AR.ft_Add("ERKN",     L_AR.fr_Read);
  L_AR.ft_Add("erkns",    L_AR.fr_Modify);
  L_AR.ft_Add("ECSort",   L_AR.fr_Read);

  L_AR.ft_Set("RWayS",    L_AR.fr_Nothing);
  L_AR.ft_Set("Staff",    L_AR.fr_Nothing);
  L_AR.ft_Set("Man",      L_AR.fr_Nothing);
  L_AR.ft_Set("Contact",  L_AR.fr_Nothing);

  IF HRP("Leaders", 0) THEN
   L_AR.ft_Set2All(L_AR.fr_Read);
  END;

  IF HRP("Econ", 0) THEN
   L_AR.ft_Set2All(L_AR.fr_Read);
   x_IPlan  (L_AR.fr_Modify);
   x_Officer(L_AR.fr_Modify);
   L_AR.ft_Add("SrMnthly",    L_AR.fr_Modify);
   L_AR.ft_Add("WagePayL",    L_AR.fr_Modify);
   L_AR.ft_Add("DWH",         L_AR.fr_Modify);
  END;

  IF HRP(L_APtm.g_Acnt, 0) THEN
   m_Stock();
   L_AR.ft_Add("ODoc",     L_AR.fr_Modify);
   L_AR.ft_Add("Packet",   L_AR.fr_Modify);
   L_AR.ft_Add("PDoc",     L_AR.fr_Modify);
   L_AR.ft_Add("CWOrder",  L_AR.fr_Modify);
   L_AR.ft_Add("Contact",  L_AR.fr_Modify);
   L_AR.ft_Add("Contract", L_AR.fr_Modify);
   L_AR.ft_Add("Firm",     L_AR.fr_Modify);
   L_AR.ft_Add("Bank",     L_AR.fr_Modify);
   L_AR.ft_Add("Storage",  L_AR.fr_Modify);
   L_AR.ft_Add("XCalc",    L_AR.fr_Modify);
   L_AR.ft_Add("XCalcDtl", L_AR.fr_Modify);
  END;
  IF HRP(L_APtm.g_Acnt, 1) THEN
   x_Acnt(L_AR.fr_Modify);
  END;

  IF HRP(L_APtm.g_TckCashier, 0) THEN
   L_AR.ft_Add("TckRcC",  L_AR.fr_Modify);
   L_AR.ft_Add("TckRcD",  L_AR.fr_Modify);
   L_AR.ft_Add("TckRcS",  L_AR.fr_Modify);
   L_AR.ft_Add("Storage", L_AR.fr_Read);
   L_AR.ft_Add("RWayS",   L_AR.fr_Read);
  END;

  IF HRP(L_APtm.g_Mechanic, 0) THEN
   s_CarView();
   s_StockView();
  END;

  IF HRP("MedInsp", 0) THEN
   L_AR.ft_Add("ODoc",    L_AR.fr_Modify);
   L_AR.ft_Add("RWayS",   L_AR.fr_Read);
   L_AR.ft_Add("EDOrder", L_AR.fr_Read);
   L_AR.ft_Add("Sheet",   L_AR.fr_Read);
  END;

  IF HRP("Stock", 0) THEN
   m_Stock();
   IF HRP("Stock", 1) THEN
    m_MainStock();
   END;
  END;

  IF HRP("SupplyAgent", 0) THEN
   m_Stock();
  END;

  IF HRP(L_APtm.g_FuelStock, 0) THEN
   m_Stock();
  END;

  IF HRP("Tech", 0) THEN
   m_Car();

   s_StockView();
   L_AR.ft_Add("CUCopy",    L_AR.fr_Modify);
   L_AR.ft_Add("FlRec",     L_AR.fr_Modify);
   L_AR.ft_Add("MCFix",     L_AR.fr_Read);
   L_AR.ft_Add("MDoc",      L_AR.fr_Modify);
   L_AR.ft_Add("JDoc",      L_AR.fr_Modify);
   L_AR.ft_Add("XObject",   L_AR.fr_Modify);
   L_AR.ft_Add("XCalc",     L_AR.fr_Modify);

   L_AR.ft_Add("PDocMDoc",  L_AR.fr_Read);
   L_AR.ft_Add("TckKind",   L_AR.fr_Read);
   L_AR.ft_Add("MathPro" ,  L_AR.fr_Modify);
   L_AR.ft_Add("RprS",      L_AR.fr_Read);
  END;

  IF HRP(L_APtm.g_twoOp, 0) THEN
   x_Officer(L_AR.fr_Read);
   L_AR.ft_Add("AvePay",   L_AR.fr_Modify);
   L_AR.ft_Add("CWOrder",  L_AR.fr_Modify); (*! 0067441 *)
   L_AR.ft_Add("ECSort",   L_AR.fr_Modify);
   L_AR.ft_Add("MCFix",    L_AR.fr_Modify);
   L_AR.ft_Add("Mtwo",     L_AR.fr_Modify);
   L_AR.ft_Add("RWayS",    L_AR.fr_Modify);
   L_AR.ft_Add("Sheet",    L_AR.fr_Read);
   L_AR.ft_Add("StaffPro", L_AR.fr_Modify);
   L_AR.ft_Add("StaffSMS", L_AR.fr_Modify);
(* 0067580 - ४஢ ࠧ浪 *)
   L_AR.ft_Add("TckRcJ",   L_AR.fr_Read);
   L_AR.ft_Add("VehType",  L_AR.fr_Read);
   L_AR.ft_Add("Mark",     L_AR.fr_Read);
  END;

  IF HRP("RPRS_0", 0) | HRP("RPRS_1", 0) |
     HRP("RPRS_2", 0) | HRP("RPRS_3", 0) |
     HRP("RPRS_4", 0) | HRP("RPRS_5", 0) |
     HRP("RPRS_6", 0) | HRP("RPRS_7", 0) THEN
   L_AR.ft_Add("RWayS",    L_AR.fr_Read);
   x_RprS(L_AR.fr_Modify);
   IF HRP("RPRS_0", 1) | HRP("RPRS_1", 1) |
      HRP("RPRS_2", 1) | HRP("RPRS_3", 1) |
      HRP("RPRS_4", 1) | HRP("RPRS_5", 1) |
      HRP("RPRS_6", 1) THEN
    L_AR.ft_Add("CarBlock",     L_AR.fr_Modify);
    L_AR.ft_Add("RprDfApr",     L_AR.fr_Modify);
    L_AR.ft_Add("RprJob",       L_AR.fr_Modify);
    L_AR.ft_Add("OutCar",       L_AR.fr_Modify);
    L_AR.ft_Add("OutCBlc",      L_AR.fr_Modify);
    L_AR.ft_Add("Sort",         L_AR.fr_Modify);
   END;
  END;

  IF HRP("RPRS_4", 0) THEN
   L_AR.ft_Add("Mark",     L_AR.fr_Modify);
   L_AR.ft_Add("FirmCtc",  L_AR.fr_Modify);
   L_AR.ft_Add("Contact",  L_AR.fr_Modify);
  END;

  IF HRP("RprSCarView", 0) | HRP("RprSOutCarView", 0) THEN
   x_RprS(L_AR.fr_Read);
  END;

  IF HRP("CarView", 0) THEN
   s_CarView();
  END;
  IF HRP("ManView", 0) THEN
   s_ManView();
  END;
  IF HRP("StockView", 0) THEN
   s_StockView();
  END;

  IF HRP(L_APtm.g_Staff, 0) THEN
   x_Man    (L_AR.fr_Modify);
   x_Officer(L_AR.fr_Read);
   x_Car    (L_AR.fr_Read);
   L_AR.ft_Add("AlType",      L_AR.fr_Modify);
   L_AR.ft_Add("AvePay",      L_AR.fr_Modify);
   L_AR.ft_Add("AveType",     L_AR.fr_Modify);
   L_AR.ft_Add("Deduct",      L_AR.fr_Modify);
   L_AR.ft_Add("DirtyTyp",    L_AR.fr_Modify);
   L_AR.ft_Add("FOrder",      L_AR.fr_Modify);
   L_AR.ft_Add("EDOrder",     L_AR.fr_Modify);
   L_AR.ft_Add("MCFix",       L_AR.fr_Modify);
   L_AR.ft_Add("MltDep",      L_AR.fr_Modify);
   L_AR.ft_Add("Packet",      L_AR.fr_Modify);
   L_AR.ft_Add("PnsAttr",     L_AR.fr_Modify);
   L_AR.ft_Add("Sheet",       L_AR.fr_Modify);
   L_AR.ft_Add("Staff",       L_AR.fr_Modify);

   L_AR.ft_Add("ACSEvent",    L_AR.fr_Read);
   L_AR.ft_Add("Adding",      L_AR.fr_Read);
   L_AR.ft_Add("Cash",        L_AR.fr_Read);
   L_AR.ft_Add("EDOKind",     L_AR.fr_Read);
   L_AR.ft_Add("MPG_WP",      L_AR.fr_Read);
   L_AR.ft_Add("WagePayL",    L_AR.fr_Read);
  END;

  IF HRP(L_APtm.g_PayRoll, 0) THEN
   L_AR.ft_Add("Adding",      L_AR.fr_Modify);
   L_AR.ft_Add("AvePay",      L_AR.fr_Modify);
   L_AR.ft_Add("Cash",        L_AR.fr_Modify);
   L_AR.ft_Add("Deduct",      L_AR.fr_Modify);
   L_AR.ft_Add("Disease",     L_AR.fr_Modify);
   L_AR.ft_Add("EDOrder",     L_AR.fr_Modify);
   L_AR.ft_Add("FOrder",      L_AR.fr_Modify);
   L_AR.ft_Add("ManSFee",     L_AR.fr_Modify);
   L_AR.ft_Add("Money",       L_AR.fr_Modify);
   L_AR.ft_Add("PCalc",       L_AR.fr_Modify);
   L_AR.ft_Add("PDoc",        L_AR.fr_Modify);
   L_AR.ft_Add("RegMain",     L_AR.fr_Modify);
   L_AR.ft_Add("Sheet",       L_AR.fr_Modify);
   L_AR.ft_Add("Staff",       L_AR.fr_Read);
   L_AR.ft_Add("StaffPro",    L_AR.fr_Modify);
   L_AR.ft_Add("TaxInq",      L_AR.fr_Modify);
   L_AR.ft_Add("TimeKeep",    L_AR.fr_Modify);
   L_AR.ft_Add("WagePay",     L_AR.fr_Modify);
   L_AR.ft_Add("WagePayL",    L_AR.fr_Modify);
   L_AR.ft_Add("XObject",     L_AR.fr_Modify);
   L_AR.ft_Add("XCalc",       L_AR.fr_Modify);
   L_AR.ft_Add("OfcPro",      L_AR.fr_Modify);
   x_Acnt   (L_AR.fr_Read);
   x_Officer(L_AR.fr_Read);
(* x_Car    (L_AR.fr_Modify); *)
   x_RWOP   (L_AR.fr_Read);
   L_AR.ft_Add("ManAdr",      L_AR.fr_Read);
   L_AR.ft_Add("ManActv",     L_AR.fr_Read);
   L_AR.ft_Add("ODoc",        L_AR.fr_Read);
   L_AR.ft_Add("Methods",     L_AR.fr_Read);
(*६, 0072078*)
   L_AR.ft_Add("IsSData",     L_AR.fr_Read);
   IF HRP(L_APtm.g_PayRoll, 1) THEN
    L_AR.ft_Add("MCList", L_AR.fr_Modify);
    L_AR.ft_Add("CAcnt",  L_AR.fr_Modify);
   END;
  END;

  IF HRP(L_APtm.g_RWOp, 0) THEN
   x_RWOP   (L_AR.fr_Modify);
   L_AR.ft_Add("MDoc",        L_AR.fr_Modify);
   x_Officer(L_AR.fr_Read);
   L_AR.ft_Add("EDOSrc",      L_AR.fr_Read);
  END;

  IF HRP(L_APtm.g_Disp, 0) THEN
   L_AR.ft_Add("CWOrder",    L_AR.fr_Modify);
   L_AR.ft_Add("Contact",    L_AR.fr_Modify);
   L_AR.ft_Add("Mtwo",       L_AR.fr_Modify);
   L_AR.ft_Add("RWayS",      L_AR.fr_Modify);
   L_AR.ft_Add("StaffSMS",   L_AR.fr_Modify);

   x_Officer(L_AR.fr_Read);
   x_Car    (L_AR.fr_Read);
   x_IPlan  (L_AR.fr_Read);
   L_AR.ft_Add("AvePay",     L_AR.fr_Read);
   L_AR.ft_Add("ECSort",     L_AR.fr_Read);
   L_AR.ft_Add("ElTck",      L_AR.fr_Read);
   L_AR.ft_Add("MCFix",      L_AR.fr_Read);
   L_AR.ft_Add("Sheet",      L_AR.fr_Read);
   L_AR.ft_Add("TckRcS",     L_AR.fr_Read);
  END;

  IF HRP(L_APtm.g_DispLine, 0) THEN
   L_AR.ft_Add("RWayS",      L_AR.fr_Read);
   x_Officer(L_AR.fr_Read);
   x_Car    (L_AR.fr_Read);
  END;

  IF HRP("CWOp", 0) THEN
   L_AR.ft_Add("CWOrder",    L_AR.fr_Modify);
  END;

  IF HRP("Sheet", 0) THEN
   L_AR.ft_Add("Sheet",      L_AR.fr_Modify);
   L_AR.ft_Add("RegMain",    L_AR.fr_Read);
   L_AR.ft_Add("AvePay",     L_AR.fr_Modify);
   L_AR.ft_Add("AveType",    L_AR.fr_Modify);
   x_Officer(L_AR.fr_Read);
  END;

  IF HRP("Expl", 0) THEN
   L_AR.ft_Add("MCFix",    L_AR.fr_Modify);
   L_AR.ft_Add("Mtwo",     L_AR.fr_Read);
   L_AR.ft_Add("StExit",   L_AR.fr_Modify);
   L_AR.ft_Add("Stop",     L_AR.fr_Modify);
   L_AR.ft_Add("ECSort",   L_AR.fr_Modify);
   L_AR.ft_Add("Route",    L_AR.fr_Modify);
   L_AR.ft_Add("TKind",    L_AR.fr_Modify);
   L_AR.ft_Add("Car",      L_AR.fr_Modify);
   L_AR.ft_Add("MathPro",  L_AR.fr_Modify);
   L_AR.ft_Add("SortPro",  L_AR.fr_Modify);
   x_RWOP(L_AR.fr_Read);
  END;

  IF HRP("RoadSafety", 0) THEN
   L_AR.ft_Add("AvePay",   L_AR.fr_Read);
   L_AR.ft_Add("Mtwo",     L_AR.fr_Read);
   L_AR.ft_Add("EDOrder",  L_AR.fr_Read);
   L_AR.ft_Add("Man",      L_AR.fr_Read);
   L_AR.ft_Add("Staff",    L_AR.fr_Read);
   L_AR.ft_Add("MCFix",    L_AR.fr_Read);
   L_AR.ft_Add("ODoc",     L_AR.fr_Modify);
   L_AR.ft_Add("RAccid",   L_AR.fr_Modify);
   L_AR.ft_Add("RAMemb",   L_AR.fr_Modify);
   x_Officer(L_AR.fr_Read);
   x_Car(L_AR.fr_Read);
  END;

  IF HRP("CarEvnTracking", 0) THEN
   CarEvnTracking();
   x_Car(L_AR.fr_Read);
  END;

  IF HRP(L_APtm.g_Secretary, 0) THEN
   L_AR.ft_Add("EDOrder",  L_AR.fr_Modify);
   L_AR.ft_Add("ODoc",     L_AR.fr_Modify);
   L_AR.ft_Add("Dspt",     L_AR.fr_Modify);
  END;

  IF HRP("Physician", 0) THEN
   L_AR.ft_Add("AvePay",   L_AR.fr_Modify);
   L_AR.ft_Add("ManPro",   L_AR.fr_Modify);
   L_AR.ft_Add("ODoc",     L_AR.fr_Read);
   L_AR.ft_Add("RWayS",    L_AR.fr_Read);
   L_AR.ft_Add("EDOrder",  L_AR.fr_Read);
   L_AR.ft_Add("Sheet",    L_AR.fr_Read);
  END;

  IF HRP("SprtCrspSend", 0) THEN
   L_AR.ft_Add("SprtCrsp", L_AR.fr_Modify);
  END;
 END {ft_FillFor};

 PRIVATE PROCEDURE ft_FullRights();
 BEGIN
  L_AR.ft_Set2All(L_AR.fr_Modify);
  L_AR.ft_Set("iga", L_AR.fr_Read);
 END {ft_FullRights};

 PRIVATE PROCEDURE pfrt_GrantsRights(srm: L_AR.tSetRightsMode; HRP: PROC);
  VAR
   Group           : STRING[];
   Groups          : STRING[][10];
   GrantsFullRights: SCAL[2];
 BEGIN
  SETEMPTY(Groups);
  Groups[0]:=L_General.AdminGroupName();
  Groups[1]:="Eng";
  IF L_General.IsPolakSpecific() THEN
   Groups[2]:=L_APtm.g_APSupport;
  END;
  GrantsFullRights:=0;
  FOR_EACH Group IN Groups DO
   IF ~!Group THEN
    IF HRP(Group, 0) THEN
     IF ~GrantsFullRights | (srm = L_AR.srm_ShowSpecifiedAcsObj) | (srm = L_AR.srm_ShowSpecifiedFile) THEN
      ft_FullRights();
      GrantsFullRights:=1;
     END;
    END;
   END;
  END; (* FOR_EACH *)
  IF ~GrantsFullRights | (srm = L_AR.srm_ShowSpecifiedAcsObj) | (srm = L_AR.srm_ShowSpecifiedFile) THEN
   ft_FillFor(HRP);
   L_AR.ft_Apply_System(srm);
  END;
  L_AR.ft_Apply_Admin(srm);
 END {pfrt_GrantsRights};

 PUBLIC PROCEDURE PrepareFilesRightsTable(srm: L_AR.tSetRightsMode);
  VAR
   HRP    : PROC;
   oPrompt: PROMPTLINE;
 BEGIN
  APP.Get().NewPrompt("⮢ ⠡ ࠢ  䠩 ");
  L_AR.ft_Init();
  IF    srm = L_AR.srm_ShowSpecifiedAcsObj THEN
   L_General.CallUs(OCCURE(AcsObj));
   SpecifiedAcsObj:=AcsObj.AcsObj;
   IF AcsObj.Type = L_AR.aot_User THEN
    HRP:=PROCREF(SpecifiedAcsObjIsInGroup);
    ft_db_PutAll(0);
   ELSE
    HRP:=PROCREF(GroupIsSpecifiedAcsObj);
    ft_db_SingleAcsObj();
   END;
  ELSIF srm = L_AR.srm_ShowSpecifiedFile THEN
   SETEMPTY(SpecifiedAcsObj);
   HRP            :=PROCREF(GroupExists);
   L_General.CallUs(OCCURE(dbFile));
   SELECT(dbRights, dbFile, , dbFile.dbFile);
   WHILE OCCURE(dbRights) DO
    CONFORM(dbRights, AcsObj);
    ft_db_SingleRigths();
    NEXT(dbRights);
   END; (* WHILE OCCURE(dbRights) ... *)
  ELSE
   SpecifiedAcsObj:=L_General.curUSER;
   HRP            :=PROCREF(HasRightsAsMemberOfGroup);
   ft_db_PutAll(~L_General.IsLocalMode());
  END; (* IF srm ... *)
  pfrt_GrantsRights(srm, HRP);
 END {PrepareFilesRightsTable};

 PRIVATE PROCEDURE sff_db_SingleRigths();
  TYPE
   tFilterType = SCAL[3];
  CONST
   ft_None = 0;
   ft_Incl = 1;
   ft_Excl = 2;
  VAR
   curTable: TABLE;
   Filter,
   eqlSign,
   logSign : STRING[];
 BEGIN
  IF dbRights.wDtl # ft_None THEN
   IF SELECT(dbRDtl, dbRights, dbRights.dbRights) THEN
    CONFORM(dbRights, dbFile);
    curTable:=TABLE.Get(dbFile.Name);
    Filter:="";
    IF dbRights.wDtl = ft_Incl THEN
     logSign:="|";
     eqlSign:="=";
    ELSE
     logSign:="&";
     eqlSign:="#";
    END;
    WHILE OCCURE(dbRDtl) DO
     SELECT(GroupE, Group, , dbRDtl.Group);
     WHILE OCCURE(GroupE) DO
      IF ~!Filter THEN
       INC(Filter, logSign);
      END;
      INC(Filter, "(" + curTable.Fields("RECORDID").ObtainName() + eqlSign + GroupE.riOwner + ")");
      NEXT(GroupE);
     END; (* WHILE OCCURE(GroupE) ... *)
     NEXT(dbRDtl);
    END; (* WHILE OCCURE(dbRDtl) ... *)
    IF ~!Filter THEN
     IF ~!curTable.Filter THEN
      curTable.Filter:="(" + curTable.Filter + ")|(" + Filter + ")";
     ELSE
      curTable.Filter:=Filter;
     END;
    END;
   END; (* IF SELECT(dbRDtl ... *)
  ELSIF AcsObj.Type = L_AR.aot_User THEN
   CONFORM(dbRights, dbFile);
   IF ~!DATABASE.Get().Tables(dbFile.Name) THEN
    curTable:=TABLE.Get(dbFile.Name);
    curTable.Filter:="";
   END;
  END; (* IF dbRights.wDtl ... *)
 END {sff_db_SingleRigths};

 PRIVATE PROCEDURE sff_db_SingleAcsObj();
 BEGIN
  SELECT(dbRights, AcsObj, , AcsObj.AcsObj);
  WHILE OCCURE(dbRights) DO
   sff_db_SingleRigths();
   NEXT(dbRights);
  END; (* WHILE OCCURE(dbRights) ... *)
 END {sff_db_SingleAcsObj};

 PRIVATE PROCEDURE SetFileFilters();
  VAR
   e: ENUMERATOR;
 BEGIN
  IF ~L_General.IsLocalMode() THEN
   e:=CreateENUMERATOR(APPLICATION.Get().MyConnection.TokenGroups);
   WHILE ~e.AtEnd() DO
    IF SEARCH(AcsObj, TNAME, L_AR.aot_Group, Str.Cap(e.Item().Name)) THEN
     sff_db_SingleAcsObj();
    END;
    e.MoveNext();
   END;
  ELSE
   SELECT(AOMem, AcsObj2, , L_General.curUSER);
   WHILE OCCURE(AOMem) DO
    SEARCH(AcsObj, TAcsObj, , L_AR.aot_Group, AOMem.AcsObj);
    sff_db_SingleAcsObj();
    NEXT(AOMem);
   END; (* WHILE OCCURE(AOMem) ... *)
  END;

  SEARCH(AcsObj, AcsObj, , L_General.curUSER);
  sff_db_SingleAcsObj();
 END {SetFileFilters};

 PRIVATE PROCEDURE ClearFileFilters();
  VAR
   curTable: TABLE;
 BEGIN
  FOR_EACH curTable IN DATABASE.Get().Tables DO
   IF ~!curTable.Filter THEN
    curTable.Filter:="";
   END;
  END;
 END {ClearFileFilters};

 PRIVATE PROCEDURE CrearRights();
 BEGIN
  APP.Get().NewPrompt("⪠ ⥪ ࠢ");
  L_AR.fr_Set2All(L_AR.fr_Nothing);
 END {CrearRights};

 PUBLIC PROCEDURE GrantRights(srm: L_AR.tSetRightsMode);
 BEGIN
  APP.Get().NewPrompt("祭 ࠢ 㯠  ");
  TRY [TERMBYUSERMODE(TERMBYUSERMODE_IGNORE)]
   IF L_General.SessionIsUnderExclusiveRemoteControl() THEN
    L_General.Error(" 稩  ० 쭮 ࠢ ");
   END;
   L_AcsPnt.Init();
   GRANTALLRIGHTS();
   IF srm = L_AR.srm_Renovate THEN
    CrearRights();
   END;
   ClearFileFilters();
   ConcealSomeMyFirm();
   GrantRightsForAroundTheClock();
   PrepareFilesRightsTable(srm);
   L_AR.fr_SetByTable();
   L_AR.ft_DeInit();
   SetFileFilters();
  EXCEPT
  END;
 END {GrantRights};

 PUBLIC PROCEDURE User2TSN(D: DATE; trgAcsObj: LIKE(AcsObj.AcsObj)): LIKE(Staff.TSN);
  VAR
   Result: LIKE(Staff.TSN);
 BEGIN
  SAVE(AcsObj);
  SEARCH(AcsObj, AcsObj, , trgAcsObj);
  L_General.Assert(AcsObj.Type = L_AR.aot_User,
                   "  ⥪    ᯮ짮 㯯. 쪮 짮⥫");
  Result:=L_Staff.Man2TSN(D, AcsObj.Man, EMPTYOF(P_Firm.tMyFirm), 0, 1);
  IF !Result THEN
   L_General.Error("짮⥫ " + AcsObj.Name + "   騬  " + L_DatTim.DateStr(D) + " ࠡ⭨");
  END;
  RESTORE(AcsObj);
  RETURN Result;
 END {User2TSN};

 PUBLIC PROCEDURE TSN2User(D: DATE; trgTSN: LIKE(Staff.TSN)): LIKE(AcsObj.AcsObj);
  VAR
   Result: LIKE(AcsObj.AcsObj);
 BEGIN
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   SETEMPTY(Result);
   SEARCH(Staff, TSN, , trgTSN);
   SELECT(AcsObj, Man, , Staff.Man);
   WHILE OCCURE(AcsObj) DO
    IF L_DatTim.IsActive(D, AcsObj.Begin, AcsObj.Till) THEN
     L_General.Assert(!Result, "⭨ " + trgTSN + " ᮯ⠢  ( ) 짮⥫");
     Result:=AcsObj.AcsObj;
    END;
    NEXT(AcsObj);
   END;
   IF !Result THEN
    L_General.Error("⭨ " + trgTSN + "  ᮯ⠢ 짮⥫");
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  RETURN Result;
 END {TSN2User};

END.
