(*
%Copyright   (c) Polak IT
%Author      29.05.2003 13:16:22 POLAK\SAN
%Purpose     ᮡ ᯮ짮 ஭   ⮏થ
%Type        library
%Specific    SYS
%Modified    18.11.2013 18:48:37 POLAK\Bor
%Environment
*)

 MODULE L_APEMl [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tReplyToType = SCAL[3];

 PUBLIC CONST
(*
  aps_Addr      = "support@autopark.ru";
*)
  aps_Addr      = "support@polak.ru";
  aps_Name      = "㦡 প ⮏";
  OurSiteSMTP   = "mail.polak.dom";
  OurSiteDomain = "polak.ru";

  sesvi_SMTP_Login    = "SMTP_Login";
  sesvi_SMTP_Password = "SMTP_Password";
  sesvi_EMail            = "EMail";
  sesvi_EMailReplyToType = "EMailReplyToType";

  rttFrom   = 0; (*ReplyToType*)
  rttSender = 1;
  rttBoth   = 2;

 IMPORT L_General, L_EMail, L_StdFrm, P_OwnData, P_Firm, Str, DBD, L_FIO,
        L_Str, P_Man, FIO, L_ctc, L_SES, L_XDoc, L_Pmnt, L_AR, L_Guard, L_ACL;


 PUBLIC PROCEDURE MyFirmContact(_MyFirm: P_Firm.tMyFirm): L_EMail.tContact;
 BEGIN
  RETURN L_EMail.AssembleContact(P_Firm.FP_FirmShortName(P_Firm.fomf(_MyFirm), SYSDATE()),
                                 P_Firm.gfcv_cc_Common(1, P_Firm.fomf(_MyFirm), SYSDATE(), L_ctc.cvt_Email));
 END {MyFirmContact};

 PRIVATE PROCEDURE GetCurUserContactParts(Strong: SCAL[2]; VAR name, eml: STRING[]);
  VAR
   curMan: LIKE(Man.Man);
 BEGIN
  IF L_General.IsEndUser() THEN
   IF ~L_SES.GetValue(L_SES.sit_WindowsProfile, sesvi_EMail, eml) THEN
    eml:="";
   END;
   L_General.Assert(~Strong | ~!eml, " 㪠 EMail  ᪠");
   L_General.CallUs(SEARCH(AcsObj, AcsObj, L_General.curUSER));
   name:=AcsObj.FullName;
  ELSIF L_General.curUSER = L_Guard.AcsObjOfGuard() THEN
   IF ~L_SES.GetValue(L_SES.sit_WindowsProfile, sesvi_EMail, eml) THEN
    eml:="";
   END;
   L_General.Assert(~Strong | ~!eml, " 㪠 EMail '⥫ ⮏'");
   L_General.CallUs(SEARCH(AcsObj, AcsObj, L_General.curUSER));
   name:=AcsObj.FullName;
  ELSE
   IF Strong THEN
    curMan:=P_Man.curUSER2Man();
   ELSE
    curMan:=P_Man.Try_curUSER2Man();
   END;
   IF ~!curMan THEN
    SEARCH(Man, Man, , curMan);
    eml:=P_Man.GetManWorkTelefon(Man.Man, SYSDATE(), P_Man.ci_EMail);
    L_General.Assert(~Strong | ~!eml, " ⠪  㪠  ࠡ稩 EMail");
    name:=L_Str.ShortName(Man.Name);
   ELSE
    SETEMPTY(name, eml);
   END;
  END;
 END {GetCurUserContactParts};

 PUBLIC PROCEDURE CurUserContact(Strong: SCAL[2]): L_EMail.tContact;
  VAR
   name,
   eml  : STRING[];
 BEGIN
  TRY
   L_AR.GrantRightsUnconditionally();
   GetCurUserContactParts(Strong, name, eml);
   IF !eml THEN
    L_General.CallUs(~Strong);
    RETURN L_EMail.EmptyContact();
   ELSE
    RETURN L_EMail.AssembleContact(name, eml);
   END;
  EXCEPT
  END; (* TRY *)
 END {CurUserContact};

 PUBLIC PROCEDURE CurrentSenderContact(): L_EMail.tContact;
 BEGIN
  RETURN CurUserContact(1);
 END {CurrentSenderContact};

 PUBLIC PROCEDURE CurUserEMail(Strong: SCAL[2]): STRING[];
  VAR
   Dummy,
   OwnEMail: STRING[];
 BEGIN
  GetCurUserContactParts(Strong, Dummy, OwnEMail);
  RETURN OwnEMail;
 END {CurUserEMail};

 PUBLIC PROCEDURE ToSupportOwnFirmContact(): L_EMail.tContact;
 BEGIN
  TRY
   L_AR.GrantRightsUnconditionally();
   RETURN Str.Cap(DBD.BaseName()) + " " + MyFirmContact(P_Firm.mf_Own);
  EXCEPT
  END; (* TRY *)
 END {ToSupportOwnFirmContact};

 PUBLIC PROCEDURE APSupportContact(): L_EMail.tContact;
 BEGIN
  RETURN L_EMail.AssembleContact(aps_Name, aps_Addr);
 END {APSupportContact};

 PRIVATE PROCEDURE GetOwnSMTPServer(): STRING[];
 BEGIN
  IF L_General.IsOurEngineeringCopy() THEN
   RETURN OurSiteSMTP;
  ELSE
   RETURN P_OwnData.ODSMTPServer(SYSDATE());
  END;
 END {GetOwnSMTPServer};

 PRIVATE PROCEDURE GetOwnEMailDomain(): STRING[];
 BEGIN
  IF L_General.IsOurSite() THEN
   RETURN OurSiteDomain;
  ELSE
   RETURN P_OwnData.EMailDomain(SYSDATE());
  END;
 END {GetOwnEMailDomain};

 PRIVATE PROCEDURE OwnSMTPServerNeedAuthentication(): SCAL[2];
 BEGIN
  IF L_General.IsOurEngineeringCopy() THEN
   RETURN 0;
  ELSE
   RETURN P_OwnData.SMTPWithAuthentication(SYSDATE());
  END;
 END {OwnSMTPServerNeedAuthentication};

 PRIVATE PROCEDURE OwnSMTPUseProtectedChnl(): SCAL[2];
 BEGIN
  IF L_General.IsOurEngineeringCopy() THEN
   RETURN 1;
  ELSE
   RETURN P_OwnData.SMTPUseProtectedChnl(SYSDATE());
  END;
 END {OwnSMTPUseProtectedChnl};

 PRIVATE PROCEDURE OwnSMTPUseDedicatedLine(): SCAL[2];
 BEGIN
  IF L_General.IsOurEngineeringCopy() THEN
   RETURN 1;
  ELSE
   RETURN P_OwnData.UseDedicatedLine(SYSDATE());
  END;
 END {OwnSMTPUseDedicatedLine};

 PUBLIC PROCEDURE AssembleOwnContact(Name, AddrInDomain: STRING[]): L_EMail.tContact;
 BEGIN
  RETURN L_EMail.AssembleContactFromParts(Name, AddrInDomain, GetOwnEMailDomain());
 END {AssembleOwnContact};

 PUBLIC PROCEDURE CurUserSMTPLogin(): STRING[];
 BEGIN
  (*L_SES.GetValue(L_SES.sit_WindowsProfile, sesvi_SMTP_Login, login) &*)
  RETURN CurUserEMail(1);
 END {CurUserSMTPLogin};

 PUBLIC PROCEDURE ReplyToType(): tReplyToType;
  VAR
   Result: tReplyToType;
 BEGIN
  Result:=rttFrom;
  IF ~L_SES.GetValue(L_SES.sit_User, sesvi_EMailReplyToType, Result) THEN
   Result:=rttFrom;
  END;
  RETURN Result;
 END {ReplyToType};

 PUBLIC PROCEDURE Send(ToContact   : L_EMail.tContact[];
                       FrContact,
                       SnContact,
                       CcContact,
                       BCcContact  : L_EMail.tContact;
                       Subject,
                       Attachments,
                       Message     : STRING[]);
  VAR
   login,
   pw                              : STRING[];
   Dummy                           : SCAL[2];
   Server                          : STRING[];
   ReplyToContact                  : L_EMail.tContact[2];
   UseDedicatedLine,
   UseProtectedChnl,
   NeedAuthentication,
   SetSMTPAuthenticationDataRequred: SCAL[2];
 BEGIN
  SETEMPTY(ReplyToContact);
  IF    L_EMail.IsEmptyContact(SnContact) | (ReplyToType() = rttFrom) THEN
   ReplyToContact[0]:=FrContact;
  ELSIF ReplyToType() = rttSender THEN
   ReplyToContact[0]:=SnContact;
  ELSE
   ReplyToContact[0]:=FrContact;
   ReplyToContact[1]:=SnContact;
  END;
  Server            :=GetOwnSMTPServer();
  UseDedicatedLine  :=OwnSMTPUseDedicatedLine();
  NeedAuthentication:=OwnSMTPServerNeedAuthentication();
  UseProtectedChnl  :=OwnSMTPUseProtectedChnl();

  SETEMPTY(login, pw);
  SetSMTPAuthenticationDataRequred:=0;
  LOOP
   IF OwnSMTPServerNeedAuthentication() THEN
    login:=CurUserSMTPLogin();
    Dummy:=L_SES.GetValue(L_SES.sit_WindowsProfile, sesvi_SMTP_Password, pw);
    IF !pw | SetSMTPAuthenticationDataRequred THEN
     CALL(SYS_ENV.SetSMTPAuthenticationData());
     Dummy:=L_SES.GetValue(L_SES.sit_WindowsProfile, sesvi_SMTP_Password, pw);
    END;
   END;
   TRY
    L_EMail.Send(ToContact, FrContact, SnContact, CcContact, BCcContact, ReplyToContact,
                 Subject, Attachments, Message, Server, login, pw,
                 UseDedicatedLine, NeedAuthentication, UseProtectedChnl);
    EXIT;
   EXCEPT
   ON Exc: Exc_Raise DO
    IF Exc.MsgOriginalText = L_EMail.ed_AuthenticationCredentialsInvalid THEN
     L_StdFrm.RedInform("訡 ⥭䨪樨  SMTP-ࢥ" +
                        "|஢  짮⥫  ஫");
     SetSMTPAuthenticationDataRequred:=1;
    ELSE
     RAISE();
    END;
   END; (* TRY *)
  END; (* LOOP *)
 END {Send};

 PUBLIC PROCEDURE EasySend(ToContact   : L_EMail.tContact[];
                           FrContact   : L_EMail.tContact;
                           Subject,
                           Attachments,
                           Message     : STRING[]);
 BEGIN
  Send(ToContact, FrContact, L_EMail.EmptyContact(), L_EMail.EmptyContact(), L_EMail.EmptyContact(),
       Subject, Attachments, Message);
 END {EasySend};

 PRIVATE PROCEDURE MessageBody(DocName, _About: STRING[]): STRING[];
 BEGIN
  RETURN "ࠢ塞 㬥:"+             L_Str.CRLF+
         DocName+                            L_Str.CRLF+
                                             L_Str.CRLF+
(*
         "ਨ:"+                     L_Str.CRLF+
         _About+                             L_Str.CRLF+
                                             L_Str.CRLF+
*)
         "ᯮ⥫: "+FULLNAME()+         L_Str.CRLF+
                                             L_Str.CRLF+
                                             L_Str.CRLF+
                                             L_Str.CRLF;
 END {MessageBody};

 PRIVATE PROCEDURE HasPDFFiles(AttFile: STRING[]): SCAL[2];
  VAR
   Ext,
   FileName: STRING[];
   i       : NUMERIC[0];
 BEGIN
  i:=0;
  LOOP
   FileName:=L_Str.PoolItem(AttFile, i);
   IF !FileName THEN
    EXIT;
   END;
   FIO.SplitPath(FileName, FileName, Ext);
   IF L_Str.IsEqStrI(Ext, "PDF") THEN
    RETURN 1;
   END;
   INC(i);
  END; (* LOOP *)
  RETURN 0;
 END {HasPDFFiles};

 PUBLIC PROCEDURE SendDocument(trg_iri  : L_General.tInternalRecordId;
                               DocName  : STRING[];
                               ToContact: L_EMail.tContact);
  CONST
   AdobeReadURL = "http://get.adobe.com/reader/otherversions";
  VAR
   AttFile,
   Text     : STRING[];
   trgMyFirm: LIKE(MyFirm.MyFirm);
 BEGIN
  AttFile:=L_XDoc.CopyLastXDocFileToTempDirForSendEMail(trg_iri);
  trgMyFirm:=L_XDoc.GetMyFirmBy_iri(trg_iri);

  IF HasPDFFiles(AttFile) THEN
   Text:=" ᬮ 㬥⮢ PDF 㦥 Adobe Reader: " + AdobeReadURL + L_Str.CRLF;
  ELSE
   SETEMPTY(Text);
  END;
  Send(ToContact,
       MyFirmContact(trgMyFirm),
       CurrentSenderContact(),
       "",
       L_Pmnt.E_GetBlindCarbonCopyEMail(trg_iri, trgMyFirm),
       DocName,
       AttFile,
       MessageBody(DocName, "") + Text);
 END {SendDocument};

 PRIVATE PROCEDURE intRejectSend(Text: STRING[]): SCAL[2];
 BEGIN
  Text:="|"  + Str.StdFormEscape(Text) +
        "|" +
        "|।०:                                               " +
        "| 砥 ⪠  ࠢ  C㦡 প           " +
        "| 㤭  ᯮ 易⥫  .   " +
        "|室 ᪮஢  䠩   , ⮡    " +
        "| 뫮  ᯮ짮  砥 室.         " +
        "|" +
        "|" + L_StdFrm.DrawButton("",          15, "X") + "   " +
              L_StdFrm.DrawButton(" ࠢ", 15, "DB") + "   " +
              L_StdFrm.DrawButton("ࠢ",     15, "B");
  RETURN STDFORM(Text, , CHOICE, -1) = 1;
 END {intRejectSend};

 PRIVATE PROCEDURE RejectSend(FullFileName: STRING[]): SCAL[2];
 BEGIN
  IF Str.Cap(DBD.BaseName()) = "T4" THEN
   RETURN intRejectSend(" ⮢  ࠢ 䠩|" + FullFileName);
  END;
  RETURN 0;
 END {RejectSend};

 PUBLIC PROCEDURE SendFileToSupport(Subject, FullFileName, Message: STRING[]);
  VAR
   msg: STRING[];
 BEGIN
  IF ~L_General.IsOurEngineeringCopy() & ~RejectSend(FullFileName) THEN
   LOOP
    TRY
     EasySend(APSupportContact(), ToSupportOwnFirmContact(), Subject, FullFileName, Message);
     EXIT;
    EXCEPT
    ON Exc: Exc_Root DO
     IF ~!FullFileName THEN
      msg:=" 㤠 ࠢ ࠧࠡ稪 䠩|" + FullFileName;
     ELSE
      msg:=" 㤠 ࠢ ᮮ饭 ࠧࠡ稪.";
     END;
     IF intRejectSend(msg +
                      "|" +
                      "|訡:                                                       " +
                      Exc.MsgOriginalText +
                      "|" +
                      "|室  ࠭ ஡   ࠢ.") THEN
      EXIT;
     END;
    END (* TRY *);
   END (* LOOP *);
  END; (* IF ~RejectSend(FullFileName)...*)
 END {SendFileToSupport};

 PUBLIC PROCEDURE SendACLResultToSupport(srcFullFileName: STRING[]; IsEmptyResult: SCAL[2]);
  VAR
   Message,
   Subject,
   RepName,
   dstFullFileName: STRING[];
 BEGIN
  IF ~!srcFullFileName THEN
   RepName        :=L_FIO.effp_FileName(srcFullFileName);
   dstFullFileName:=L_FIO.tf_GetFullPath(L_General.GetAPSiteID() + "_" + L_FIO.effp_FileName_woExt(RepName), L_FIO.effp_FileExt(RepName));
   L_General.Assert(FIO.Exists(srcFullFileName), "  䠩 " + srcFullFileName);
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    FIO.Open(chkF, srcFullFileName, , Output);
    FIO.Close(chkF);
   EXCEPT
   ON Exc: Exc_Root DO
    RAISE();
   END; (* TRY *)
   IF ~IsEmptyResult THEN
    FIO.Erase(dstFullFileName);
    L_FIO.ExactFileCopy(srcFullFileName, dstFullFileName);
   END;
  ELSE
   SETEMPTY(dstFullFileName, RepName);
  END;

  Subject:=Str.Cap(RTI.Get().Stack(1).Proc.Module.Name);
  Message:=L_General.GetAPSiteID();
  IF IsEmptyResult THEN
   Subject:=Subject + " (Empty)";
   Message:=Message + " (Empty)";
  ELSE
   Message:=Message + " " + RepName;
  END;

  SendFileToSupport(L_ACL.SubjectForMassInquiry(Subject), dstFullFileName, Message);
 END {SendACLResultToSupport};

END.
