(*
%Copyright   (c) Polak IT
%Author      17.09.2013 12:18:11 POLAK\MLB
%Purpose     ⥪  ࠡ  묨 ᮮ饭ﬨ
%Type        library
%Specific    AP
%Modified    31.12.2013 10:32:43 POLAK\GAV
%Environment
*)

 MODULE L_APMsg [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tCongratulationWith = SCAL[4];

 PRIVATE CONST
  cmdt_Congratulation = "ࠢ";
  cmdt_Pool = "ࠢ|"; (* tCmdType *)

  cw_Pool       = "  ஦| ࠧ 8 |  ⭨ ⢠|  |"; (* tCongratulationWith *)
  cw_FNPrefPool = "BD|8M|23F|NY";

 PUBLIC CONST
  cw_BirthDay   = 0;
  cw_8March     = 1;
  cw_23February = 2;
  cw_NewYear    = 3;

 IMPORT L_Msg, L_General, L_DatTim, L_Math, Str, L_Str, FIO, L_FIO,
        L_GUI, L_AR, L_Man, P_Man;

 PUBLIC PROCEDURE getCongratulationPictureFileName(cw: tCongratulationWith): STRING[];
  VAR
   r: NUMERIC[0];
 BEGIN
  r:=L_Math.Random(6)+1;
  L_General.CallUs((r >= 1) & (r <= 6));
  RETURN FIO.MakePath(L_Str.PoolItem(cw_FNPrefPool, cw) + L_Str.IntStr(r), "jpg");
 END {getCongratulationPictureFileName};

 PRIVATE PROCEDURE StretchButtonPicture(btn: PUSH_BUTTON; sH_Text, BorderWidth: FLOAT);
 BEGIN
  btn.TextRect.Left  :=BorderWidth;
  btn.TextRect.Top   :=BorderWidth;
  btn.TextRect.Right :=btn.Rect.Right   - BorderWidth;
  btn.TextRect.Bottom:=btn.TextRect.Top + sH_Text;

  btn.PictureRect.Left  :=BorderWidth;
  btn.PictureRect.Top   :=btn.TextRect.Bottom;
  btn.PictureRect.Right :=btn.Rect.Right  - BorderWidth;
  btn.PictureRect.Bottom:=btn.Rect.Bottom - BorderWidth;
 END {StretchButtonPicture};

 PRIVATE PROCEDURE OnClickDflt(SLF: PUSH_BUTTON);
 BEGIN
  Message.ViewDTS:=SYSTIMESTAMP();
  REPLACE(Message);
 END {OnClickDflt};

 PRIVATE PROCEDURE ShowSingleCongratulation(With: STRING[]);
  CONST
   Timeout           = 300;

   sW_Picture        = 800;
   sH_Picture        = 600;
   sW_Congratulation = sW_Picture;
   sH_Congratulation = 60;

   BorderWidth       = 5;
   pL_Button         = 0;
   pT_Button         = 0;
   sW_Button         = sW_Picture + 2*BorderWidth;
   sH_Button         = sH_Picture + sH_Congratulation + 2*BorderWidth;

   dlgWidth          = sW_Button;
   dlgHeight         = sH_Button;

   fS_Congratulation = 30;

  VAR
   dlg        : DIALOG;
   ElapsedTime: FLOAT;
   PictName,
   Surname,
   FirstName,
   Patronymic : STRING[];
   cw         : tCongratulationWith;
 BEGIN
  cw:=L_Str.PositionInPool(cw_Pool, With);
  PictName:=getCongratulationPictureFileName(cw);
  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   L_AR.GrantRightsUnconditionally();
   dlg                     :=L_GUI.extCreateDialog(0);
   dlg.ReplaceMainWindow   :=0;
   dlg.WindowStyle         :=DIALOG.WindowStyle_FixedSize;
   dlg.StandardClientWidth :=dlgWidth;
   dlg.StandardClientHeight:=dlgHeight;
   dlg.ClientRect.Right    :=dlg.ClientRect.Left + dlgWidth;
   dlg.ClientRect.Bottom   :=dlg.ClientRect.Top  + dlgHeight;
   dlg.CaptionText         :="ࠢ";

   L_Str.SplitManName(P_Man.GetFullNameOfCurrentUser(SYSDATE()), Surname, FirstName, Patronymic);
   L_GUI.add_Button(dlg, DIALOG.bi_Default,
                    With + ", " + FirstName + " " + Patronymic + "!",
                    FIO.BuildPath(PictName, , "mk:@MSITStore:" + L_FIO.rf_GetCHMFullName("ksk") + "::/"),
                    pL_Button, pT_Button, sW_Button, sH_Button,
                    fS_Congratulation, L_GUI.fn_Default, PROCREF(OnClickDflt));
   StretchButtonPicture(dlg.Controls.Item(DIALOG.bi_Default), sH_Congratulation, BorderWidth);
   dlg.Controls.Item(DIALOG.bi_Default).OldStyleDrawing:=1;
   L_GUI.SetControlBkColor(dlg.Controls.Item(DIALOG.bi_Default), RGBCOLOR.Create(255, 255, 255));
   dlg.Controls.Item(DIALOG.bi_Default).Visible:=1;
    
   ElapsedTime:=Timeout;
   dlg.Visible:=1;
   dlg.Redraw();
   WHILE dlg.Visible & (ElapsedTime > 0) DO
    dlg.Wait(0.5);
    DEC(ElapsedTime, 0.5);
   END; (* WHILE dlg.Visible *)
   IF ElapsedTime = 0 THEN
    dlg.Visible:=0;
    dlg.Redraw();
    TRY [TRANSACTION(TRANSACTION_SLAVE)]
     L_Msg.ToggleMessageStatus();
    EXCEPT
    END;
   END;
  EXCEPT
  ON Exc: Exc_TermByUser DO
   IF VAR_IMPL.Get(dlg).Initialized THEN
    dlg.Visible:=0;
    dlg.Redraw();
   END;
   Message.ViewDTS:=SYSTIMESTAMP();
   REPLACE(Message);
  END; (* TRY *)
 END {ShowSingleCongratulation};

 PRIVATE PROCEDURE NeedCongratulateOnThisDay(cw: tCongratulationWith): SCAL[2];
  VAR
   Result: SCAL[2];
   D     : DATE;
 BEGIN
  IF    cw = cw_BirthDay THEN
   Result:=L_DatTim.HasBirthdayInPer(Man.Birth, SYSDATE() - 2, SYSDATE());
  ELSE
   IF    cw = cw_8March     THEN
    D:=08\03\1990;
   ELSIF cw = cw_23February THEN
    D:=23\02\1990;
   ELSIF cw = cw_NewYear    THEN
    D:=01\01\1990;
   ELSE
    L_General.CallUs();
   END;
   Result:=L_DatTim.HasBirthdayInPer(D, SYSDATE(), SYSDATE() + 1);
  END;
  RETURN Result;
 END {NeedCongratulateOnThisDay};

 PRIVATE PROCEDURE MakeCongratulationMessage(cw                : tCongratulationWith;
                                             CmdMsgList        : STRING[];
                                             LaunchFromAutoExec: SCAL[2]);
  VAR
   With: STRING[];
 BEGIN
  IF NeedCongratulateOnThisDay(cw) THEN
   With:=L_Str.PoolItem(cw_Pool, cw);
   L_Msg.MakeCommandMessage(cmdt_Congratulation, With, CmdMsgList,
                            L_Msg.CombineCmdMsgText(cmdt_Congratulation, With, "ࠢ塞 " + With),
                            LaunchFromAutoExec);
  END;
 END {MakeCongratulationMessage};

 PUBLIC PROCEDURE MakeCongratulationMessages(LaunchFromAutoExec: SCAL[2]; trgAcsObj: LIKE(AcsObj.AcsObj));
  VAR
   CmdMsgList: STRING[];
 BEGIN
  TRY
   L_AR.GrantRightsUnconditionally();
   SEARCH(AcsObj, AcsObj, , trgAcsObj);
   IF ~!AcsObj.Man THEN
    CmdMsgList:=L_Msg.GetCommandList(AcsObj.AcsObj, 1);
    SEARCH(Man, Man, , AcsObj.Man);
    MakeCongratulationMessage(cw_BirthDay, CmdMsgList, LaunchFromAutoExec);
    IF Man.Sex = L_Man.sex_Female THEN
     MakeCongratulationMessage(cw_8March, CmdMsgList, LaunchFromAutoExec);
    ELSE
     MakeCongratulationMessage(cw_23February, CmdMsgList, LaunchFromAutoExec);
    END;
    MakeCongratulationMessage(cw_NewYear, CmdMsgList, LaunchFromAutoExec);
   END;
  EXCEPT
  END; (* TRY *)
 END {MakeCongratulationMessages};

 PUBLIC PROCEDURE DoCommand(Type, Command: STRING[]);
 BEGIN
  L_General.CallUs(Type = cmdt_Congratulation);
  ShowSingleCongratulation(Command);
 END {DoCommand};

END.