(*
%Copyright   (c) Polak Computer System
%Author      19.10.2001 19:43:28 SAN
%Purpose     L_General  ⮏
%Type        library
%Specific    SYS
%Modified    25.08.2014 11:33:02 POLAK\San
%Environment
*)

 MODULE L_APtm [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tSystems     = SCAL[6];
  tWeekdayKind = SCAL[3];
  (*!*) tNotion      = LIKE(ERKN.Notion);

 PUBLIC CONST
  system_Salary   = 0;
  system_Math     = 1;
  system_PDoc     = 2;
  system_KeyAss   = 3;
  system_Payments = 4;
  system_VAT      = 5;

  wdk_inGeneral = 0;
  wdk_toWay     = 1;
  wdk_toInc     = 2;

  adna_Salary = 12; (*ActiveDataNormalAge*)
  adna_RWayS  =  3;
  adna_MDoc   = 36;

  g_Disp       = "Disp";
  g_DispLine   = "DispLine";
  g_Staff      = "Staff";
  g_TckCashier = "TckCashier";
  g_Mechanic   = "Mechanic";
  g_APSupport  = "AP_Support";
  g_RWOp       = "RWOp";
  g_CWOp       = "CWOp";
  g_twoOp      = "twoOp";
  g_FuelStock  = "FuelStock";
  g_Secretary  = "Secretary";
  g_Acnt       = "Acnt";
  g_PayRoll    = "PayRoll";
  g_MedInsp    = "MedInsp";
  g_Stock      = "Stock";
  g_Sheet      = "Sheet";
  g_Expl       = "Expl";
  g_EndUser    = "End_User";
  g_Tech       = "Tech";

 PUBLIC PERMANENT VAR
  CurrentEntityId: NUMERIC[0];
  ClcPer         : DATE   [MAXOF(tSystems)+1];
  NoTouch        : SCAL[2][MAXOF(tSystems)+1];

 IMPORT Memo, L_General, L_DatTim, L_Basis, L_MathR, L_Pmnt, L_Events, L_SysLog, L_Str, Str, DBD,
        L_Russia, L_Env, L_XDoc, L_Way, L_TRS, L_StdFrm, L_APDBD, L_kn;

 PUBLIC PROCEDURE IsAccountant(): SCAL[2];
 BEGIN
  RETURN L_General.IsMemberOf("Acnt");
 END {IsAccountant};

 PUBLIC PROCEDURE IsTicketCashier(): SCAL[2];
 BEGIN
  RETURN L_General.IsMemberOf(g_TckCashier);
 END {IsTicketCashier};

 PUBLIC PROCEDURE IsRWayOperator(): SCAL[2];
 BEGIN
  RETURN L_General.IsMemberOf(g_RWOp);
 END {IsRWayOperator};

 PUBLIC PROCEDURE IsDispatcher(): SCAL[2];
 BEGIN
  RETURN L_General.IsMemberOf(g_Disp);
 END {IsDispatcher};

 PUBLIC PROCEDURE IsRepairZone(): SCAL[2];
 BEGIN
  RETURN L_General.IsMemberOf("RPRS_0") | L_General.IsMemberOf("RPRS_1") | L_General.IsMemberOf("RPRS_2") |
         L_General.IsMemberOf("RPRS_3") | L_General.IsMemberOf("RPRS_4") | L_General.IsMemberOf("RPRS_5") ;
 END {IsRepairZone};

 PUBLIC PROCEDURE IsViewRprS(): SCAL[2];
 BEGIN
  RETURN L_General.IsMemberOf("RprSCarView") | L_General.IsMemberOf("RprSOutCarView");
 END {IsViewRprS};

 PUBLIC PROCEDURE IsOutPost(): SCAL[2];
 BEGIN
  RETURN L_General.IsMemberOf("OutPost");
 END {IsOutPost};

 PUBLIC PROCEDURE IsMechanic(): SCAL[2];
 BEGIN
  RETURN L_General.IsMemberOf(g_Mechanic);
 END {IsMechanic};

 PUBLIC PROCEDURE IsLeaders(): SCAL[2];
 BEGIN
  RETURN L_General.IsMemberOf("Leaders");
 END {IsLeaders};

 PUBLIC PROCEDURE KioskUser_WO_Authorization(): SCAL[2];
 BEGIN
  RETURN IsLeaders() | L_General.IsAdmin();
 END {KioskUser_WO_Authorization};

 PUBLIC PROCEDURE IsTramDepo(): SCAL[2];
 BEGIN
  RETURN (Str.Cap(DBD.BaseName()) = "D2") | (Str.Cap(DBD.BaseName()) = "D3");
 END {IsTramDepo};

 PUBLIC PROCEDURE IsTrolPark(): SCAL[2];
 BEGIN
  RETURN (Str.Cap(DBD.BaseName()) = "T1") | (Str.Cap(DBD.BaseName()) = "T4");
 END {IsTrolPark};

 PUBLIC PROCEDURE IsMGT(): SCAL[2];
 BEGIN
  RETURN (L_Env.Region = L_Russia.reg_77) & ~L_General.IsPolakSpecific();
 END {IsMGT};

 PUBLIC PROCEDURE IsMTA(): SCAL[2];
  VAR
   APSiteNumber: SCAL[1E4];
 BEGIN
  APSiteNumber:=L_General.GetAPSiteNumber();
  RETURN ((APSiteNumber >= 21) & (APSiteNumber <= 29)) |
         ((APSiteNumber >= 50) & (APSiteNumber <= 80)) |
         (APSiteNumber = 90) | (APSiteNumber = 92) | (APSiteNumber = 93);
 END {IsMTA};

PUBLIC PROCEDURE IsOG(): SCAL[2];
BEGIN
 RETURN L_General.GetAPSiteNumber() = 79;
END {IsOG};

PUBLIC PROCEDURE IsOG_Fuel(D: DATE): SCAL[2];
BEGIN
 RETURN IsOG() & (D >= 01\05\2014);
END {IsOG_Fuel};

 PUBLIC PROCEDURE GetTheDocCause(D: DATE; Default: STRING[]): STRING[];
 BEGIN
  IF IsMTA() & (D>=01\01\2014) THEN
   RETURN "⢥ত ਪ     31.12.2013  843";
  ELSE
   RETURN Default;
  END;
 END {GetTheDocCause};

 PUBLIC PROCEDURE GetTheDocDraftsman(D: DATE; Default: STRING[]): STRING[];
 BEGIN
  IF IsMTA() & (D>=01\01\2014) THEN
   RETURN '㬥 ⠢ 㤠⢥ 㭨 ।⨥ ᠦ᪮ ⮬쭮 ࠭ᯮ ᪮᪮  ""';
  ELSE
   RETURN Default;
  END;
 END {GetTheDocDraftsman};

 PUBLIC PROCEDURE wordSetTheDocCauseAndDraftsman(D: DATE; defCause, defDraftsman: STRING[]);
 BEGIN
  L_MSO.wordSetVar("TheDoc.Cause",     GetTheDocCause    (D, defCause));
  L_MSO.wordSetVar("TheDoc.Draftsman", GetTheDocDraftsman(D, defDraftsman));
 END {wordSetTheDocCauseAndDraftsman};

 PUBLIC PROCEDURE SystemName(trgSystem: tSystems): STRING[32];
 BEGIN
  IF    trgSystem = system_Salary   THEN RETURN "ࠡ⭠ ";
  ELSIF trgSystem = system_Math     THEN RETURN " ";
  ELSIF trgSystem = system_PDoc     THEN RETURN "⥦";
  ELSIF trgSystem = system_KeyAss   THEN RETURN " ";
  ELSIF trgSystem = system_Payments THEN RETURN " ⮢";
  ELSIF trgSystem = system_VAT      THEN RETURN " ";
  ELSE
   L_General.CallUs(0);
  END;
 END {SystemName};

 PUBLIC PROCEDURE CheckIfBeforeSystemStart(P: DATE; trgSystem: tSystems);
  VAR
   StartP: DATE;
 BEGIN
  IF trgSystem = system_Salary THEN
   StartP:=L_Env.aptm_Start;
  ELSE
   StartP:=L_DatTim.PrevPer(L_Env.aptm_Start); (* 㬥 砫쭮 ᠫ줮 楬 ࠭*)
  END;
  L_General.Assert(P >= StartP, "⨬   ᪠ ⮏");
 END {CheckIfBeforeSystemStart};

 PUBLIC PROCEDURE MonthAccess(P: DATE);
 BEGIN
  L_General.Assert(SEARCH(Month, Period, P),
                   "   ᠭ "+L_DatTim.PeriodStr(P));
 END {MonthAccess};

 PUBLIC PROCEDURE MonthIsClosed(D: DATE; _System: tSystems): SCAL[2];
 BEGIN
  MonthAccess(L_DatTim.Per(D));
  IF L_DatTim.Per(D) = Memo.gl_mb() THEN
   IF NoTouch[_System] # Month.NoTouch[_System] THEN
    L_General.Error(" 㣮 ⠭樨  " +
                    Str.Item("|", "|", Month.NoTouch[_System]) +
                    "  (" + L_DatTim.PeriodStr(D) + ")" +
                    "| |室 ⠭ 㦭    ''");
   END;
  END;
  RETURN Month.NoTouch[_System];
 END {MonthIsClosed};

 PUBLIC PROCEDURE ANYSystem_CheckNoTouch(D: DATE; _System: tSystems);
 BEGIN
  L_General.Assert(~MonthIsClosed(D, _System),
                   L_DatTim.PeriodStr(D) + " -  ("+SystemName(_System)+")");
 END {ANYSystem_CheckNoTouch};

 PUBLIC PROCEDURE ANYSystem_ClcPer(_System: tSystems): DATE;
 BEGIN
  RETURN ClcPer[_System];
 END {ANYSystem_ClcPer};

 PUBLIC PROCEDURE ANYSystem_Clc_CntIsEqual(_System: tSystems): SCAL[2];
  VAR
   _Equal: SCAL[2];
 BEGIN
  _Equal:=Memo.gl_mb() = ANYSystem_ClcPer(_System);
  L_General.CallUs(_Equal # MonthIsClosed(Memo.gl_mb(), _System));
  RETURN _Equal;
 END {ANYSystem_Clc_CntIsEqual};

 PUBLIC PROCEDURE ANYSystem_CheckClcPer(trgSystem: tSystems);
 BEGIN
  IF ~L_General.KioskExecution_IsRunning() THEN
   IF ~ANYSystem_Clc_CntIsEqual(trgSystem) THEN
    CheckIfBeforeSystemStart(Memo.gl_mb(), trgSystem);
    L_StdFrm.Choice("⥬ '" + SystemName(trgSystem) + "' - ࠡ  ⮬ ਮ:" +
                    "|"+
                    "|⥪騩   ਮ - "+L_DatTim.PeriodStr(Memo.gl_mb())+
                    "| ਮ - "+L_DatTim.PeriodStr(ANYSystem_ClcPer(trgSystem)));
   END;
  END;
 END {ANYSystem_CheckClcPer};

 PUBLIC PROCEDURE ANYDoc_CheckDate(D: DATE);
 BEGIN
  L_General.Assert(L_DatTim.Per(D) = Memo.gl_mb(),
                   "㬥 ( " + L_DatTim.PeriodStr(D) + ")   ⥪騩 (" +
                   L_DatTim.PeriodStr(Memo.gl_mb())+") ਮ");
 END {ANYDoc_CheckDate};

 PUBLIC PROCEDURE ANYDoc_CheckPer(D: DATE; _System: tSystems);
 BEGIN
  ANYDoc_CheckDate(D);
  ANYSystem_CheckClcPer(_System);
 END {ANYDoc_CheckPer};

 PUBLIC PROCEDURE ANYDoc_StrongCheckPer(D: DATE; _System: tSystems);
 BEGIN
  ANYDoc_CheckDate(D);
  ANYSystem_CheckNoTouch(D, _System);
 END {ANYDoc_StrongCheckPer};

 PUBLIC PROCEDURE ChangeGlobalCurDate(D: DATE);
  VAR
   _System : tSystems;
   tryNextM: SCAL[2];
 BEGIN
  SAVE(Month);
  TRY [ABORT_AFTER(AA_ON)]
   MonthAccess(L_DatTim.Per(D));
   _System:=MINOF(tSystems);
   FOR_EACH _System DO
    NoTouch[_System]:=Month.NoTouch[_System];
   END;
   SETEMPTY(ClcPer);
   CHANGESEL(Month, Period);
   REPEAT
    tryNextM:=0;
    _System:=MINOF(tSystems);
    FOR_EACH _System DO
     IF !ClcPer[_System] THEN
      IF ~Month.NoTouch[_System] THEN
       ClcPer[_System]:=Month.Period;
      ELSE
       tryNextM:=1;
      END;
     END;
    END;
   UNTIL ~tryNextM | ~NEXT(Month);
   L_General.Assert(OCCURE(Month),
                    "   ");
  EXCEPT
  END;
  RESTORE(Month);
 END {ChangeGlobalCurDate};

 (*!*) PUBLIC PROCEDURE ChangeMemoDate(D: DATE);
 BEGIN
  Memo.gl_SetCurDate(D);
 END {ChangeMemoDate};

 (*!*) PUBLIC PROCEDURE SetUserDefinedCurDate(D: DATE);
 BEGIN
  Memo.gl_SetCurDate(D);
  Memo.ud_SetCurDate(D);
 END {SetUserDefinedCurDate};

 PUBLIC PROCEDURE TemporaryChangeMemoDate(D: DATE; P: PROC);
  VAR
   saveDate: DATE;
 BEGIN
  saveDate:=Memo.gl_cd();
  TRY
   Memo.gl_SetCurDate(D);
   P();
   Memo.gl_SetCurDate(saveDate);
  EXCEPT
  ELSE
   Memo.gl_SetCurDate(saveDate);
   RAISE();
  END;
 END {TemporaryChangeMemoDate};

 (*!*) PUBLIC PROCEDURE TemporarySetMemoDate(D: DATE; P: PROC);
 BEGIN
  TemporaryChangeMemoDate(D, P);
 END {TemporarySetMemoDate};

(*-------------BEGIN OF NORMAL ENVIRONMENT--------------------------*)

 PUBLIC PROCEDURE ForNight_CheckDates(Msg: STRING[]);
  VAR
   TimeDelayedTo: TIME;
   DateDelayedTo: DATE;
 BEGIN
  Memo.gl_SetCurDate(Memo.ud_cd()); (*???*)
  TimeDelayedTo:=SYSTIME();
  DateDelayedTo:=SYSDATE();
  STDFORM(L_StdFrm.sf_Choice("|" + Msg +
                             "|" +
                             "|: " + L_DatTim.DateStr(Memo.ud_cd()) +
                              ", ਮ :  " + L_DatTim.DateStr(Memo.ud_fr()) +
                              "  " +          L_DatTim.DateStr(Memo.ud_ut()) +
                             "|" +
                             "|  %#####% %##########%",
                             "%<H:M>I %<D.N.y>I"),
          " 믮 ⭮ 楤 ", CHOICE, 1,
          TimeDelayedTo, DateDelayedTo);
  WHILE (TimeDelayedTo > SYSTIME()) | (DateDelayedTo > SYSDATE()) DO
   PROMPT(Msg + ": १ " + L_Str.IntStr((TimeDelayedTo-SYSTIME())*60) +
          " . ( " + L_DatTim.TimeStr(TimeDelayedTo) + " " +
          L_DatTim.DateStr(DateDelayedTo)+")");
   SLEEP(60);
  END;
 END {ForNight_CheckDates};

 PUBLIC PROCEDURE Make(Type: SCAL[2]; Name: STRING[30]; _MODE, RunMode: SCAL[250];
                       SurveyNeed: SCAL[2]);
 BEGIN
  IF Type = L_Basis.ModuleType_ASL THEN
   IF SurveyNeed THEN
    LIKEMENU(RunProg, Name + " " + FLDTOSTR(_MODE, "0", 3),
             Survey,  "",
             RunProg, "ForNight " + FLDTOSTR(RunMode+1, "0", 3));
   ELSE
    LIKEMENU(RunProg, Name + " " + FLDTOSTR(_MODE, "0", 3),
             RunProg, "ForNight " + FLDTOSTR(RunMode+1, "0", 3));
   END;
  ELSE
   LIKEMENU(Report,  Name + " " + FLDTOSTR(_MODE, "0", 3),
            Survey,  "",
            RunProg, "ForNight " + FLDTOSTR(RunMode+1, "0", 3));
  END;
 END {Make};

 PRIVATE PROCEDURE mis_IsAcceptableProcess(Zone: FORM_ZONE; File: STRING[]): SCAL[2];
 BEGIN
  IF (Zone.MasterTable.Name = File) & ~!Zone.Processes(0) &
     ((Zone.Processes(0).Kind = FORM_PROCESS.Kind_Edit) |
      (Zone.Processes(0).Kind = FORM_PROCESS.Kind_Delete)) THEN
   RETURN 1;
  ELSE
   IF    ~!Zone.ParentZone THEN
    RETURN mis_IsAcceptableProcess(Zone.ParentZone, File);
   ELSIF ~!Zone.Window.ParentZone THEN
    RETURN mis_IsAcceptableProcess(Zone.Window.ParentZone, File);
   ELSE
    RETURN 0;
   END;
  END;
 END {mis_IsAcceptableProcess};

 PRIVATE PROCEDURE mis_IsForbiddenFile(File: STRING[]): SCAL[2];
 BEGIN
  RETURN 0;
(*
  RETURN "Mtwo";
*)
 END {mis_IsForbiddenFile};

 PRIVATE PROCEDURE mis_IsAcceptable(chkFile,
                                    mdfFile    : STRING[];
                                    trgXDocType: L_XDoc.tXDocType): SCAL[2];
  VAR
   Result   : SCAL[2];
   chkStatus: SCAL[1E2];
 BEGIN
  SAVE(^chkFile);
  IF ~OCCURE(^chkFile) THEN
   CONFORM(^mdfFile, ^chkFile);
  END;
  L_General.CallUs(DBD.FieldExist(^chkFile, Status));

  IF    trgXDocType = L_XDoc.xdt_RWayS THEN
   Result:=RWayS.Status # L_Way.rwsStat_Given;
  ELSIF trgXDocType = L_XDoc.xdt_TckRcS THEN
   Result:=TckRcS.Status = L_TRS.trsStat_Rated;
  ELSE
   L_General.CallUs(0);
  END; (* IF (trgXDocType = L_XDoc.xdt_RWayS) THEN *)

  RESTORE(^chkFile);

  RETURN Result;
 END {mis_IsAcceptable};

 PRIVATE PROCEDURE ConditionalMarkInSysLog(chkFile, mdfFile: STRING[]; knd: L_SysLog.tKind): SCAL[2];
  VAR
   Result     : SCAL[2];
   trgXDocType: L_XDoc.tXDocType;
 BEGIN
  Result:=~mis_IsForbiddenFile(chkFile);
  IF Result & ~!knd THEN
   trgXDocType:=L_XDoc.GetFileXDT(chkFile);
   IF ~!trgXDocType & L_XDoc.XDocTypeHasXDocJrn(trgXDocType) THEN
    Result:=mis_IsAcceptableProcess(RTI.Get().CurZone, chkFile);
    IF Result THEN
     IF (trgXDocType = L_XDoc.xdt_RWayS) | (trgXDocType = L_XDoc.xdt_TckRcS) THEN
      Result:=mis_IsAcceptable(chkFile, mdfFile, trgXDocType);
     END;
    END; (* IF Result...*)
   END; (* IF ~!trgXDocType & L_XDoc.XDocTypeHasXDocJrn(trgXDocType)...*)
  END; (* IF ~!knd...*)
  RETURN Result;
 END {ConditionalMarkInSysLog};

 PRIVATE PROCEDURE MarkInSysLogAcceptable(chkFile, mdfFile: STRING[]; knd: L_SysLog.tKind): SCAL[2];
  VAR
   LName   : STRING[];
   Result  : SCAL[2];
   dummyRI : LIKE(SYSLOG_.riLend);
   curTable: TABLE;
 BEGIN
  Result  :=0;
  curTable:=TABLE.Get(chkFile);
  IF    ~!curTable.Fields("RECORDID") THEN
   Result:=ConditionalMarkInSysLog(chkFile, mdfFile, knd);
  ELSE
   L_SysLog.GetPseudoLendWithRECORDID(chkFile, LName, dummyRI);
   Result:=~!LName;
   IF ~Result & ~!curTable.LendLink THEN
    Result:=MarkInSysLogAcceptable(curTable.LendLink.CooIndex.Table.Name, mdfFile, knd);
   END;
  END;
  RETURN Result;
 END {MarkInSysLogAcceptable};

 PRIVATE PROCEDURE E_MarkInSysLog(File: STRING[]; knd: L_SysLog.tKind): SCAL[2];
  VAR
   Local  : PROC;
   default: SCAL[2];
 BEGIN
  IF ~!File THEN
   default:=MarkInSysLogAcceptable(File, File, knd);
 
   Local:=PROCREF(L_Env.MarkInSysLog);
   IF ~!Local THEN
    RETURN Local(default, File, knd);
   ELSE
    RETURN default;
   END;
  ELSE
   RETURN 0;
  END;
 END {E_MarkInSysLog};

 PUBLIC PROCEDURE SysLogHandler(File: STRING[]; Kind: L_SysLog.tKind);
 BEGIN
  IF ~!Kind & ~!File THEN
   IF E_MarkInSysLog(File, Kind) THEN
    L_SysLog.SingleMark_Interactive(File, Kind, 0);
   ELSE
    L_SysLog.SingleMark_Interactive(File, Kind, 1);
   END;
  END;
 END {SysLogHandler};

 PRIVATE PROCEDURE HasLendWithRECORDID(FName: STRING[]): SCAL[2];
  VAR
   nextLendName: STRING[];
 BEGIN
  nextLendName:=DBD.LendFile(^FName);
  IF ~!nextLendName THEN
   IF DBD.FieldExist(^nextLendName, RECORDID) THEN
    RETURN 1;
   ELSE
    RETURN HasLendWithRECORDID(nextLendName);
   END;
  END;
  RETURN 0;
 END {HasLendWithRECORDID};

 PRIVATE PROCEDURE _TakedInSysLog(File: STRING[]): SCAL[2];
 BEGIN
  IF E_MarkInSysLog(File, L_General.EMPTY_NUMBER()) THEN
   RETURN 1;
  ELSE
   IF ~DBD.FieldExist(^File, RECORDID) THEN
    IF ~HasLendWithRECORDID(File) THEN
     RETURN 0;
    END;
   END;
   SELECT(SYSLOG_, Own, , TABLE.Get(File).Id);
   WHILE OCCURE(SYSLOG_) DO
    IF SYSLOG_.tmpRcCnt = 0 THEN
     RETURN 1;
    END;
    NEXT(SYSLOG_);
   END; (* WHILE OCCURE(SYSLOG_) ... *)
  END;
  RETURN 0;
 END {_TakedInSysLog};

 PUBLIC PROCEDURE TakedInSysLog(File: STRING[]): SCAL[2];
  VAR
   i     : NUMERIC[0];
   LName : STRING[];
   LK    : NUMERIC[0];
   Result: SCAL[2];
 BEGIN
  SETZERO(i);
  Result:=_TakedInSysLog(File);

  WHILE ~Result & (i < DBD.LinkAmount(^File)) DO
   LName:=DBD.LinkName(^File, i);
   LK:=DBD.LinkKind(^File, ^LName);
   IF (LK = -2) | (LK = -3) THEN
    Result:=_TakedInSysLog(DBD.LinkCooFileName(^File, ^LName));
   END;
   INC(i);
  END;
  RETURN Result;
 END {TakedInSysLog};

 (*!*) PUBLIC PROCEDURE AccessERKN(EntityName: STRING[]; trgNotion: tNotion);
 BEGIN
  L_kn.AccessERKN(EntityName, trgNotion);
 END {AccessERKN};

 (*!*) PUBLIC PROCEDURE IsTrgNotion(trgERKN: LIKE(ERKN.ERKN); trgNotion: tNotion): SCAL[2];
 BEGIN
  RETURN L_kn.IsTrgNotion(trgERKN, trgNotion);
 END {IsTrgNotion};

 (*!*) PUBLIC PROCEDURE SearchByERKNError(Msg: STRING[]);
 BEGIN
  L_kn.SearchByERKNError(Msg);
 END {SearchByERKNError};

END.
