(*
%Copyright   (c) Polak IT
%Author      14.04.2006 20:25:48 POLAK\San
%Purpose     ࠭祭 ࠢ 㯠
%Type        library
%Specific    SYS
%Modified    09.06.2014 11:53:37 ?
%Environment
*)

 MODULE L_AR [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tFileRights     = SCAL[3];
  tAcsObjType     = SCAL[2];
  tRightsSource   = SCAL[3];
  tRightsOrigin   = SCAL[3];
  tSetRightsMode  = SCAL[8];

 PUBLIC CONST
  fr_Nothing = 0;
  fr_Read    = 1;
  fr_Modify  = 2;
  fr_Pool = " 㯠|⥭|䨪";

  tr_Nothing = "        ";
  tr_Read    = "SV    AW";
  tr_Modify  = "SVIRD AW";

  d_Add = 0;
  d_Set = 1;

  aot_User  = 0;
  aot_Group = 1;

  aot_Pool       = "짮⥫|㯯";
  aot_Pool_Short = "|";

  rs_System = 0;
  rs_Admin  = 1;
  rs_Pool = "⥬|";

  ro_Prime   = 0;
  ro_Related = 1;
  ro_AsOwner = 2;
  ro_Pool = "|易|ࠢ筨";

  srm_Autoexec            = 0;
  srm_Renovate            = 1;
  srm_ShowCurrent         = 2;
  srm_ShowSpecifiedAcsObj = 3;
  srm_ShowSpecifiedFile   = 4;

  aomat_Staff          = 0; (* AcsObj.ManAssT *)
  aomat_NotMan         = 1;
  aomat_ManButNotStaff = 2;
  aomat_Robot          = 3;

 IMPORT L_General, L_StdFrm, L_Str, DBD, L_Prop, Str, L_AFM, L_DatTim,
        L_NetWrk, L_Env, L_MSWStp, FIO, Math, L_PCS;

 PRIVATE TYPE
  tDirection      = SCAL[2];
  tFileName       = STRING[16];

 PRIVATE CONST
  ec_rt_BadRightsFormat = 940;
  ft_TablesAmount       = 4096;

  vba_False =  0;
  vba_True  = -1;

 PRIVATE PERMANENT VAR
  HasConcealedPartOfDatabase: SCAL[2];

 PRIVATE VAR
  frt_Manager: LIKE(AOMem.Manager);

 PUBLIC PROCEDURE frt_SetIsManager(Manager: SCAL[2]);
 BEGIN
  frt_Manager:=Manager;
 END {frt_SetIsManager};

 PUBLIC PROCEDURE ConcealPartOfDatabase();
 BEGIN
  HasConcealedPartOfDatabase:=1;
 END {ConcealPartOfDatabase};

 PUBLIC PROCEDURE DatabaseIsTransparent(): SCAL[2];
 BEGIN
  RETURN ~HasConcealedPartOfDatabase;
 END {DatabaseIsTransparent};

 PUBLIC PROCEDURE CheckDatabaseTransparency();
 BEGIN
  L_General.Assert(DatabaseIsTransparent(),
                   " ࠡ⠥  ᫮ ࠭祭 㯠    ."+
                   "||"+
                   "  ");
 END {CheckDatabaseTransparency};

 PUBLIC PROCEDURE CheckIntegrityViolationBecausePartOfDataBaseConcealing();
 BEGIN
  IF DatabaseIsTransparent() THEN
   L_General.CallUs(0);
  END;
 END {CheckIntegrityViolationBecausePartOfDataBaseConcealing};

 PUBLIC PROCEDURE GrantRightsForInteractiveModification();
 BEGIN
  GRANTALLRIGHTS();
 END {GrantRightsForInteractiveModification};

 PUBLIC PROCEDURE GrantRightsUnconditionally();
 BEGIN
  GRANTALLRIGHTS();
 END {GrantRightsUnconditionally};

 PRIVATE VAR
  ft_DB_Tables: DATABASETABLES;

 PUBLIC PROCEDURE ft_Init();
  VAR
   cooFile: tFileName;
   t      : TABLE;
   l      : LINK;
 BEGIN
  L_AFM.MakeMultipleIndex("L_AR_frt", "File   :" + TYPENAMEOF(tFileName)     +";"+
                                      "Source :" + TYPENAMEOF(tRightsSource) +";"+
                                      "Origin :" + TYPENAMEOF(tRightsOrigin) +";"+
                                      "Dir    :" + TYPENAMEOF(tDirection)    +";"+
                                      "AcsObj :" + TYPENAMEOF(AcsObj.AcsObj) +";"+
                                      "AOType :" + TYPENAMEOF(AcsObj.Type)   +";"+
                                      "Manager:" + TYPENAMEOF(AOMem.Manager) +";"+
                                      "Rights :" + TYPENAMEOF(tFileRights)   +";"+
                                      "Master :" + TYPENAMEOF(tFileName)     +";"+
                                      "RltnLvl: NUMERIC[0];",
                             "File  : File, AOType, AcsObj, Dir, Manager, Rights, Origin, Source, Master, RltnLvl;"+
                             (*"toSet : AOType, AcsObj, File, Dir;"+*)
                             "toSetF: File, AOType, AcsObj, Rights;"+
                             "Source: Source, File;"+
                             "toShow: File, AOType, AcsObj, Source, Dir, Master;");

  L_AFM.MakeMultipleIndex("L_AR_rlf", "File  : " + TYPENAMEOF(tFileName)+";"+
                                      "Master: " + TYPENAMEOF(tFileName)+";",
                             "Master: Master, File;"+
                             "File  : File");

  L_AFM.MakeMultipleIndex("L_AR_ownr", "File : " + TYPENAMEOF(tFileName)+";"+
                                       "Owner: " + TYPENAMEOF(tFileName)+";",
                             "File  : File, Owner");

  L_AFM.MakeMultipleIndex("L_AR_mng", "User   :" + TYPENAMEOF(AcsObj.AcsObj) +";"+
                                      "Group  :" + TYPENAMEOF(AcsObj.AcsObj) +";"+
                                      "Manager:" + TYPENAMEOF(AOMem.Manager),
                             "Group: Group, User");

  APP.Get().NewPrompt(" ⠡ ᨬ⥩ 䠩");
  ft_DB_Tables:=DATABASE.Get().Tables;
  FOR_EACH t IN ft_DB_Tables DO
   IF t.Regular THEN
    FOR_EACH l IN t.Links DO
     IF l.Kind = L_General.lk_USER THEN
      cooFile:=l.CooIndex.Table.Name;
      IF cooFile # t.Name THEN
       ADD(L_AR_ownr, File, , t.Name, cooFile);
      END;
     END; (* IF l.Kind = L_General.lk_USER *)
    END; (* FOR_EACH l *)
   END; (* IF t.Regular *)
  END; (* FOR_EACH t *)
 END {ft_Init};

 PUBLIC PROCEDURE ft_SetRelated(rlf_File, rlf_Master: tFileName);
 BEGIN
  PROMPT(rlf_File);
  IF ~!ft_DB_Tables(rlf_File) & ~!ft_DB_Tables(rlf_Master) THEN
   L_AR_rlf.File  :=rlf_File;
   L_AR_rlf.Master:=rlf_Master;
   INSERT(L_AR_rlf);
  END;
 END {ft_SetRelated};

 PUBLIC PROCEDURE ft_Add(File: tFileName; Rights: tFileRights);
 BEGIN
  IF ~!ft_DB_Tables(File) THEN
   PROMPT(File);
   ADD(L_AR_frt, File, , File, AcsObj.Type, AcsObj.AcsObj, d_Add, frt_Manager, Rights, ro_Prime, rs_System, "", 0);
  END;
 END {ft_Add};

 PUBLIC PROCEDURE ft_Set(File: tFileName; Rights: tFileRights);
 BEGIN
  IF ~!ft_DB_Tables(File) THEN
   PROMPT(File);
   ADD(L_AR_frt, File, , File, AcsObj.Type, AcsObj.AcsObj, d_Set, frt_Manager, Rights, ro_Prime, rs_System, "", 0);
  END;
 END {ft_Set};

 PUBLIC PROCEDURE ft_AddByAdmin(File: tFileName; Rights: tFileRights; Manager: LIKE(AOMem.Manager));
 BEGIN
  IF ~!ft_DB_Tables(File) THEN
   PROMPT(File);
   ADD(L_AR_frt, File, , File, AcsObj.Type, AcsObj.AcsObj, d_Set, Manager, Rights, ro_Prime, rs_Admin, "", 0);
  END;
 END {ft_AddByAdmin};

 PUBLIC PROCEDURE ft_Set2All(Rights: tFileRights);
  VAR
   t: TABLE;
 BEGIN
  FOR_EACH t IN ft_DB_Tables DO
   IF t.Regular THEN
    ft_Add(t.Name, Rights);
   END;
  END;
 END {ft_Set2All};

 PRIVATE PROCEDURE tr2fr(tr: STRING[]): tFileRights;
 BEGIN
  IF    tr = tr_Modify THEN RETURN fr_Modify;
  ELSIF tr = tr_Read   THEN RETURN fr_Read;
  ELSE
   RETURN fr_Nothing;
  END;
 END {tr2fr};

 PRIVATE PROCEDURE intSetRights(t: TABLE; fr: tFileRights);
 BEGIN
  IF    fr = fr_Nothing THEN
   t.Rights:=tr_Nothing;
  ELSIF fr = fr_Read    THEN
   t.Rights:=tr_Read;
  ELSIF fr = fr_Modify  THEN
   t.Rights:=tr_Modify;
  ELSE
   L_General.CallUs(0);
  END;
 END {intSetRights};

 PRIVATE PROCEDURE SetRights(FileName: STRING[]; fr: tFileRights);
 BEGIN
  intSetRights(TABLE.Get(FileName), fr);
 END {SetRights};

 PRIVATE PROCEDURE AddRights(FileName: STRING[]; Rights: tFileRights);
 BEGIN
  SetRights(FileName, Math.Max(tr2fr(TABLE.Get(FileName).Rights), Rights));
 END {AddRights};

 PRIVATE PROCEDURE ft_ApplySingle(srm: tSetRightsMode; relatedOnly: SCAL[2]);
  VAR
   _File      : tFileName;
   _Dir       : tDirection;
   _Rights    : tFileRights;
   _Source    : tRightsSource;
   _AcsObj    : LIKE(AcsObj.AcsObj);
   _AOType    : LIKE(AcsObj.Type);
   _Manager   : LIKE(AOMem.Manager);
   RelationLvl: NUMERIC[0];
 BEGIN
  SAVE(L_AR_frt);
  SAVE(L_AR_rlf);
  _File      :=L_AR_frt.File;
  _Dir       :=L_AR_frt.Dir;
  _Manager   :=L_AR_frt.Manager;
  _Rights    :=L_AR_frt.Rights;
  _Source    :=L_AR_frt.Source;
  _AcsObj    :=L_AR_frt.AcsObj;
  _AOType    :=L_AR_frt.AOType;
  RelationLvl:=L_AR_frt.RltnLvl;
  IF ~relatedOnly & (_Rights >= fr_Read) THEN
   SAVE(L_AR_ownr);
   SELECT(L_AR_ownr, File, , _File);
   WHILE OCCURE(L_AR_ownr) DO
    IF (srm > srm_Renovate) | ~SELECT(L_AR_frt, toSetF, L_AR_ownr.Owner, _AOType, _AcsObj, fr_Read) THEN
     IF ~ADD(L_AR_frt, File, L_AR_ownr.Owner, _AOType, _AcsObj, d_Add, _Manager, fr_Read, ro_AsOwner, _Source, _File, 0) THEN
      ft_ApplySingle(srm, relatedOnly);
     END;
    END;
    NEXT(L_AR_ownr);
   END; (* WHILE OCCURE(L_AR_ownr) ... *)
   RESTORE(L_AR_ownr);
  END; (* IF ~relatedOnly & (_Rights >= fr_Read) *)

  IF SELECT(L_AR_rlf, Master, _File) THEN
   WHILE OCCURE(L_AR_rlf) DO
    IF (srm > srm_Renovate) | ~SELECT(L_AR_frt, toSetF, L_AR_rlf.File, _AOType, _AcsObj, _Rights) THEN
                               (*᫨ 楫 ⮫쪮  ࠢ,     筨*)
     IF ~ADD(L_AR_frt, File, L_AR_rlf.File, _AOType, _AcsObj, _Dir, _Manager, _Rights, ro_Related, _Source, _File, RelationLvl+1) THEN
      ft_ApplySingle(srm, relatedOnly);
     END;
    END;
    NEXT(L_AR_rlf);
   END; (* WHILE OCCURE(L_AR_rlf) ... *)
  END;
  RESTORE(L_AR_rlf);
  RESTORE(L_AR_frt);
 END {ft_ApplySingle};

 PRIVATE PROCEDURE ft_ApplyBySingleSource(srm: tSetRightsMode; rs: tRightsSource; relatedOnly: SCAL[2]);
 BEGIN
  SELECT(L_AR_frt, Source, , rs);
  WHILE OCCURE(L_AR_frt) DO
   PROMPT(" " + L_AR_frt.File);
   ft_ApplySingle(srm, relatedOnly);
   NEXT(L_AR_frt);
  END; (* WHILE OCCURE(L_AR_frt) ... *)
 END {ft_ApplyBySingleSource};

 PUBLIC PROCEDURE ft_Apply_System(srm: tSetRightsMode);
 BEGIN
  ft_ApplyBySingleSource(srm, rs_System, 0);
 END {ft_Apply_System};

 PUBLIC PROCEDURE ft_Apply_Admin(srm: tSetRightsMode);
 BEGIN
  ft_ApplyBySingleSource(srm, rs_Admin, 1);
 END {ft_Apply_Admin};

 PUBLIC PROCEDURE ft_Apply(srm: tSetRightsMode);
 BEGIN
  ft_Apply_System(srm);
  ft_Apply_Admin(srm);
 END {ft_Apply};

 PUBLIC PROCEDURE FileRightsLevel(): NUMERIC[0];
 BEGIN
  IF L_AR_frt.Dir = d_Set THEN
   RETURN 1000 + 100 * L_AR_frt.Source - L_AR_frt.RltnLvl;
  ELSE
   RETURN 0;
  END;
 END {FileRightsLevel};

 PRIVATE PROCEDURE ft_GetSingleFileRightsBySingleGroup(trgManager: LIKE(AOMem.Manager)): tFileRights;
  VAR
   Result   : tFileRights;
   curLevel,
   maxLevel : NUMERIC[0];
 BEGIN
  Result:=fr_Nothing;
  SETZERO(curLevel, maxLevel);
  LOOP
   IF ~OCCURE(L_AR_frt) THEN
    EXIT;
   END;
   IF L_AR_frt.Manager <= trgManager THEN
    curLevel :=FileRightsLevel();
    IF    curLevel > maxLevel THEN
     Result  :=L_AR_frt.Rights;
     maxLevel:=curLevel;
    ELSIF curLevel = maxLevel THEN
     Result  :=Math.Max(Result, L_AR_frt.Rights);
    END;
   END;
   NEXT(L_AR_frt);
  END; (* LOOP *)
  RETURN Result;
 END {ft_GetSingleFileRightsBySingleGroup};

 PUBLIC PROCEDURE ft_GetSingleFileRights4Group(trgFile   : tFileName;
                                               trgAcsObj : LIKE(AcsObj.AcsObj);
                                               trgManager: LIKE(AOMem.Manager)): tFileRights;
  VAR
   Result: tFileRights;
 BEGIN
  SAVE(L_AR_frt);
  Result:=fr_Nothing;
  IF SELECT(L_AR_frt, toSetF, trgFile, aot_Group, trgAcsObj) THEN
   Result:=ft_GetSingleFileRightsBySingleGroup(trgManager);
  END;
  RESTORE(L_AR_frt);
  RETURN Result;
 END {ft_GetSingleFileRights4Group};

 PUBLIC PROCEDURE ft_UserIsManagerOfGroup(g, u: LIKE(AcsObj.AcsObj)): SCAL[2];
 BEGIN
  IF ~SEARCH(L_AR_mng, Group, g, u) THEN
   ADD(L_AR_mng, Group, , g, u,
             L_AR_mng.Manager, UserIsManagerOfGroup(g, u));
  END;
  RETURN L_AR_mng.Manager;
 END {ft_UserIsManagerOfGroup};

 PUBLIC PROCEDURE ft_IsManagerOfGroup(g: LIKE(AcsObj.AcsObj)): SCAL[2];
 BEGIN
  RETURN ft_UserIsManagerOfGroup(g, L_General.curUSER);
 END {ft_IsManagerOfGroup};

 PUBLIC PROCEDURE ft_GetSingleFileRights(trgFile: tFileName; trgAcsObj: LIKE(AcsObj.AcsObj)): tFileRights;
  VAR
   Result: tFileRights;
 BEGIN
  SAVE(L_AR_frt);
  IF SELECT(L_AR_frt, toSetF, trgFile, aot_User) THEN
   Result:=L_AR_frt.Rights;
  ELSE
   Result:=fr_Nothing;
   SELECT(L_AR_frt, toSetF, , trgFile, aot_Group);
   WHILE OCCURE(L_AR_frt) DO
    NARROWSEL(L_AR_frt, AcsObj);
    Result:=Math.Max(Result, ft_GetSingleFileRightsBySingleGroup(ft_UserIsManagerOfGroup(L_AR_frt.AcsObj,
                                                                                         trgAcsObj)));
    NEXTINEXTENDEDSEL(L_AR_frt, AcsObj);
   END; (* WHILE OCCURE(L_AR_frt) ... *)
  END;
  RESTORE(L_AR_frt);
  RETURN Result;
 END {ft_GetSingleFileRights};

 PUBLIC PROCEDURE fr_SetByTable();
  VAR
   Rights: tFileRights;
   File  : tFileName;
 BEGIN
  SELECT(L_AR_frt, File);
  WHILE OCCURE(L_AR_frt) DO
   File:=L_AR_frt.File;
   PROMPT(File);
   NARROWSEL(L_AR_frt, File);
   IF L_AR_frt.AOType = aot_User THEN
    SetRights(File, L_AR_frt.Rights);
   ELSE
    Rights:=fr_Nothing;
    WHILE OCCURE(L_AR_frt) DO
     NARROWSEL(L_AR_frt, AOType, AcsObj);
     Rights:=Math.Max(Rights, ft_GetSingleFileRightsBySingleGroup(ft_IsManagerOfGroup(L_AR_frt.AcsObj)));
     NEXTINEXTENDEDSEL(L_AR_frt, AOType, AcsObj);
    END; (* WHILE OCCURE(L_AR_frt) ... *)
    AddRights(File, Rights);
   END;
   NEXTINEXTENDEDSEL(L_AR_frt, File);
  END; (* WHILE OCCURE(L_AR_frt) ... *)
 END {fr_SetByTable};

 PUBLIC PROCEDURE ft_DeInit();
 BEGIN
  L_AFM.AF_PurgeTemp("L_AR_frt");
  L_AFM.AF_PurgeTemp("L_AR_rlf");
  L_AFM.AF_PurgeTemp("L_AR_ownr");
  L_AFM.AF_PurgeTemp("L_AR_mng");
 END {ft_DeInit};

 PUBLIC PROCEDURE fr_Set2All(Rights: tFileRights);
  VAR
   t: TABLE;
 BEGIN
  FOR_EACH t IN DATABASE.Get().Tables DO
   IF t.Regular THEN
    intSetRights(t, Rights);
   END;
  END;
 END {fr_Set2All};

 PUBLIC PROCEDURE AccessAcsObj2(_AcsObj: LIKE(AcsObj.AcsObj));
 BEGIN
  L_General.CallUs(SEARCH(AcsObj2, AcsObj2, _AcsObj));
 END {AccessAcsObj2};

 PUBLIC PROCEDURE CopyRecordToAcsObj2(Interactive, New: SCAL[2]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i < DBD.FieldAmount(AcsObj) DO
   ^(DBD.FieldFullName(AcsObj2, i)):=^(DBD.FieldFullName(AcsObj, i));
   INC(i);
  END;
  TRY
   SE_INTEGRITY(1);
   IF New THEN
    INSERT(AcsObj2);
   ELSE
    REPLACE(AcsObj2);
   END;
  EXCEPT
  END;
 END {CopyRecordToAcsObj2};

 PUBLIC PROCEDURE ReplaceAcsObj();
 BEGIN
  REPLACE(AcsObj);
  CALL(AcsObj.AcsObj_OnAfterNoninteractiveEdit());
 END {ReplaceAcsObj};

 PUBLIC PROCEDURE InsertAcsObj();
 BEGIN
  INSERT(AcsObj);
  CALL(AcsObj.AcsObj_OnAfterNoninteractiveInsert());
 END {InsertAcsObj};

 PUBLIC PROCEDURE StandOnUser(Login: STRING[]): SCAL[2];
 BEGIN
  RETURN SEARCH(AcsObj, TNAME, aot_User, Str.Cap(Login));
 END {StandOnUser};

 PUBLIC PROCEDURE StandOnGroup(Login: STRING[]): SCAL[2];
 BEGIN
  RETURN SEARCH(AcsObj, TNAME, aot_Group, Str.Cap(Login));
 END {StandOnGroup};

 PUBLIC PROCEDURE UserIsManagerOfGroup(aoGroup, aoUser: LIKE(AcsObj.AcsObj)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(AOMem);
  Result:=SEARCH(AOMem, AcsObj, aoGroup, aoUser) & ~!AOMem.Manager & AOMem.Manager;
  RESTORE(AOMem);
  RETURN Result;
 END {UserIsManagerOfGroup};

 PUBLIC PROCEDURE IsManagerOfGroup(Group: LIKE(AcsObj.AcsObj)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(AcsObj);
  Result:=SEARCH(AcsObj, AcsObj, Group) & L_General.IsMemberOf(AcsObj.Name) &
          UserIsManagerOfGroup(AcsObj.AcsObj, L_General.curUSER);
  RESTORE(AcsObj);
  RETURN Result;
 END {IsManagerOfGroup};

 PUBLIC PROCEDURE IsManagerOfGroupN(GroupN: STRING[]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=L_General.IsMemberOf(GroupN);
  IF Result THEN
   SAVE(AcsObj);
   Result:=StandOnGroup(GroupN) & UserIsManagerOfGroup(AcsObj.AcsObj, L_General.curUSER);
   RESTORE(AcsObj);
  END; (* IF Result *)
  RETURN Result;
 END {IsManagerOfGroupN};

 PRIVATE PROCEDURE addByte(val, byte: NUMERIC[0]): NUMERIC[0];
 BEGIN
  RETURN val * 256 + byte;
 END {addByte};

 PRIVATE PROCEDURE sidArrayToSID(sidArray: NUMERIC[0][]): STRING[];
  VAR
   Revision         : NUMERIC[0];
   SubAuthorityCount: NUMERIC[0];
   Authority        : NUMERIC[0];
   SubAuthority     : NUMERIC[0];
   i                : NUMERIC[0];
   sidString        : STRING[184];
 BEGIN
  Revision:=sidArray[0];
  SubAuthorityCount:=sidArray[1];
  Authority:=                   sidArray[2];
  Authority:=addByte(Authority, sidArray[3]);
  Authority:=addByte(Authority, sidArray[4]);
  Authority:=addByte(Authority, sidArray[5]);
  Authority:=addByte(Authority, sidArray[6]);
  Authority:=addByte(Authority, sidArray[7]);
  sidString:="S-" + FLDTOSTR(Revision, "", 0) + "-"  + FLDTOSTR(Authority, "", 0);
  i:=0;
  WHILE i < SubAuthorityCount DO
   SubAuthority:=                      sidArray[8 + 4 * i + 3];
   SubAuthority:=addByte(SubAuthority, sidArray[8 + 4 * i + 2]);
   SubAuthority:=addByte(SubAuthority, sidArray[8 + 4 * i + 1]);
   SubAuthority:=addByte(SubAuthority, sidArray[8 + 4 * i    ]);
   sidString:=sidString + "-" + FLDTOSTR(SubAuthority, "", 0);
   INC(i);
  END;
  RETURN sidString;
 END {sidArrayToSID};

 PRIVATE PROCEDURE GetUserFromAD(Login: STRING[]): OBJECT;
 BEGIN
  RETURN GetOBJECT("WinNT://" + APPLICATION.Get().ServerDomain + "/" + Login + ",user");
 END {GetUserFromAD};

 PRIVATE VAR
  iu_UserWasInserted: SCAL[2];

 PRIVATE PROCEDURE InsertUser(Login: STRING[]): LIKE(AcsObj.AcsObj);
  CONST
   SID_MAX_SUB_AUTHORITIES = 15;
  VAR
   oUser   : OBJECT;
   c       : ASBCONNECTION;
   DoIns   : SCAL[2];
   sidArray: NUMERIC[0][1+1+6+4*SID_MAX_SUB_AUTHORITIES];
   UserSID : STRING[];
 BEGIN
  DoIns:=1;
  c:=L_NetWrk.GetAnyASBConnection(Login);
  IF ~!c THEN
   AcsObj.Name    :=c.LoginName;
   AcsObj.FullName:=c.FullName;
   AcsObj.ID      :=c.UserSID;
  ELSE
   oUser:=GetUserFromAD(Login);
   sidArray:=oUser.objectSid;
   UserSID:=sidArrayToSID(sidArray);
   IF SELECT(AcsObj, ID, UserSID) THEN
    AcsObj.Name    :=oUser.Name;
    AcsObj.FullName:=oUser.FullName;
    AcsObj.NAME    :=Str.Cap(AcsObj.Name);
    SETEMPTY(AcsObj.Till);
    ReplaceAcsObj();
    DoIns:=0;
   ELSE
    AcsObj.ID      :=UserSID;
    AcsObj.Name    :=oUser.Name;
    AcsObj.FullName:=oUser.FullName;
   END;
  END;
  IF DoIns THEN
   SETEMPTY(AcsObj.AcsObj, AcsObj.Till, AcsObj.Man, AcsObj.MCTotal, AcsObj.MCSngSt);
   AcsObj.Type   :=aot_User;
   AcsObj.Begin  :=SYSDATE();
   AcsObj.ManAssT:=aomat_Staff;
   AcsObj.NAME   :=Str.Cap(AcsObj.Name);
   AcsObj.inXDF  :=0;
   InsertAcsObj();
   iu_UserWasInserted:=1;
  END;
  RETURN AcsObj.AcsObj;
 END {InsertUser};

 PRIVATE PROCEDURE GetAcsObjBeginTill(trgAcsObj: LIKE(AcsObj.AcsObj); VAR trgBegin, trgTill: DATE);
 BEGIN
  SAVE(AcsObj);
  SEARCH(AcsObj, AcsObj, , trgAcsObj);
  trgBegin:=AcsObj.Begin;
  trgTill :=AcsObj.Till;
  RESTORE(AcsObj);
 END {GetAcsObjBeginTill};

 PUBLIC PROCEDURE UpdateUserAOMem();
 BEGIN
  SAVE(AOMem);
  SELECT(AOMem, AcsObj2, , AcsObj.AcsObj); (* 㯯 짮⥫ *)
  WHILE OCCURE(AOMem) DO
   AOMem.Begin:=AcsObj.Begin;
   AOMem.Till :=AcsObj.Till;
   REPLACE(AOMem);
   NEXT(AOMem);
  END; (* WHILE OCCURE(AOMem) ... *)
  RESTORE(AOMem);
 END {UpdateUserAOMem};

 PRIVATE PROCEDURE DefineUser(c: ASBCONNECTION; Silent: SCAL[2]): LIKE(AcsObj.AcsObj);
  VAR
   tg       : TOKENGROUP;
   Result   : LIKE(AcsObj.AcsObj);
   Msg,
   AOMPool,
   UserName,
   GroupName: STRING[];
   UserFN   : LIKE(AOMem.aoFN);
 BEGIN
  IF ~L_General.IsLocalMode() THEN
   SETEMPTY(Result);
   IF SELECT(AcsObj, ID, c.UserSID) THEN
    IF (AcsObj.Name # c.LoginName) | (AcsObj.FullName # c.FullName) THEN
     AcsObj.Name    :=c.LoginName;
     AcsObj.NAME    :=Str.Cap(AcsObj.Name);
     AcsObj.FullName:=c.FullName;
     SETEMPTY(AcsObj.Till);
     ReplaceAcsObj();
    END;
    Result:=AcsObj.AcsObj;
   ELSIF StandOnUser(c.LoginName) THEN
    IF ~!AcsObj.ID THEN
     Msg:="室  ⮏ 짮⥫ '" + c.LoginName + "'," +
          "| 㦥 ࠭  ॣ஢  ࠢ筨 '짮⥫'." +
          "|" +
          "|, 짮⥫ २  Active Directory,  ⥣᪨ ⨬" +
          "|( ᪠ ଠ樨  । ⢨ 짮⥫  ⮏)!";
 
     IF L_General.IsAdmin() THEN
      Msg:=Msg + L_StdFrm.HR() +
           "室    짮⥫  㣮, ," +
           "|᫨ ᮮ⢥⢨ ந諮 - ⢨⥫쭮   AD," +
           "|믮 楤 樨 ࠢ筨 '짮⥫'";
      L_StdFrm.CrucialChoice_FileExplicit("AcsObj", Msg, L_General.AdminGroupName());
     ELSE
      L_General.Error(Msg + L_StdFrm.HR() + "  ");
     END;
    END;
    IF AMOUNT(AcsObj2) > 0 THEN
     AcsObj.ID      :=c.UserSID;
     AcsObj.FullName:=c.FullName;
     ReplaceAcsObj();
    END;
    Result:=AcsObj.AcsObj;
   ELSE
    Result:=InsertUser(c.LoginName);
   END;
   TRY
    UserName:=AcsObj.Name;
    UserFN  :=AcsObj.FullName;
    AOMPool:="";
    FOR_EACH tg IN c.TokenGroups DO
     IF tg.Assigned THEN
      L_General.RaiseLockReleaseException();
     END;
     GroupName:=tg.Name;
     IF SEARCH(AcsObj, TNAME, aot_Group, Str.Cap(GroupName)) THEN
      IF ~SEARCH(AOMem, AcsObj, AcsObj.AcsObj, Result) THEN
       SETEMPTY(AOMem.AOMem);
       AOMem.AcsObj :=AcsObj.AcsObj;
       AOMem.AcsObj2:=Result;
       AOMem.aoName :=AcsObj.Name;
       AOMem.aoName2:=UserName;
       AOMem.aoFN   :=AcsObj.FullName;
       AOMem.aoFN2  :=UserFN;
       GetAcsObjBeginTill(Result, AOMem.Begin, AOMem.Till);
       AOMem.Manager:=0;
       INSERT(AOMem);
      ELSE
       IF (AOMem.aoName2 # UserName) | (AOMem.aoFN2 # UserFN) THEN
        AOMem.aoName2:=UserName;
        AOMem.aoFN2  :=UserFN;
        REPLACE(AOMem);
       END;
      END;
      AOMPool:=AOMPool + AOMem.AOMem + "|";
     ELSIF ~Silent THEN
      L_StdFrm.ShowINFORM_AsSTOP("㯯 " + GroupName + "  ᠭ  ⮏." +
                                 "||" +
                                 " 室 믮 '  ᭮  Active Directory'");
     END;
    END; (* FOR_EACH tg IN c.TokenGroups...*)
    SELECT(AOMem, AcsObj2, , Result);
    WHILE OCCURE(AOMem) DO
     IF !L_Str.PositionInPool(AOMPool, AOMem.AOMem) THEN
      REMOVE(AOMem);
     ELSE
      NEXT(AOMem);
     END;
    END; (* WHILE OCCURE(AOMem) ... *)
   EXCEPT
   ON Exc: Exc_AccessDeny DO
    IF (Exc.ErrorCode # L_General.ec_ad_IsLockedByOtherConnection) &
       (Exc.ErrorCode # L_General.ec_rt_HiddenUniquenessViolation) THEN
     RAISE();
    END;
   ON Exc: Exc_Root DO
    L_General.CheckIsLockReleaseException(Exc);
   END;
   RETURN Result;
  ELSE
   RETURN 0001;
  END;
 END {DefineUser};

 PRIVATE PROCEDURE intGetUser(Login: STRING[]; Silent: SCAL[2]): LIKE(AcsObj.AcsObj);
  VAR
   c     : ASBCONNECTION;
   Result: LIKE(AcsObj.AcsObj);
 BEGIN
  TRY
   GRANTALLRIGHTS();
   c:=L_NetWrk.GetAnyASBConnection(Login);
   IF    ~!c THEN
    Result:=DefineUser(c, Silent);
   ELSIF ~StandOnUser(Login) THEN
    Result:=InsertUser(Login);
   ELSE
    Result:=AcsObj.AcsObj;
   END;
   RETURN Result;
  EXCEPT
  END;
 END {intGetUser};

 PUBLIC PROCEDURE GetUser(Login: STRING[]): LIKE(AcsObj.AcsObj);
 BEGIN
  TRY [TRANSACTION(TRANSACTION_SLAVE), MSG_SUPPRESSION(MSG_SUPPRESSION_NONE)]
   RETURN intGetUser(Login, 0);
  EXCEPT
  END;
 END {GetUser};

(*
$P{ rubad_Top:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
=#####=======================================================================================########## #####=
|                ⮪  짮⥫  㯯  ᭮  Active Directory                 |
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ rubad_Line:
?, L, ""
?, L, ""
?, L, ""
@
|##### ##########################|###########################################################################|
}
*)

(*
$P{ rubad_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE VAR
  rubad_lastAO: LIKE(AcsObj.AcsObj);

 PRIVATE PROCEDURE rubad_ExtMakePart(curAcsObj: LIKE(AcsObj.AcsObj); Name, s: STRING[]);
 BEGIN
  IF curAcsObj # rubad_lastAO THEN
   MAKEPART(R, rubad_Line, curAcsObj, Name, s);
  ELSE
   MAKEPART(R, rubad_Line,          ,     , s);
  END;
  rubad_lastAO:=curAcsObj;
 END {rubad_ExtMakePart};

 PRIVATE PROCEDURE rubad_MakePart(s: STRING[]);
 BEGIN
  rubad_ExtMakePart(AcsObj.AcsObj, AcsObj.Name, s);
 END {rubad_MakePart};

 PRIVATE PROCEDURE rubad_IsMember(oUserGroups: OBJECT; gn: STRING[]): SCAL[2];
  VAR
   oGroup: OBJECT;
 BEGIN
  FOR_EACH oGroup IN oUserGroups DO
   IF Str.Cap(oGroup.Name) = Str.Cap(gn) THEN
    RETURN 1;
   END;
  END; (* FOR_EACH oGroup IN oUserGroups...*)
  RETURN 0;
 END {rubad_IsMember};

 PRIVATE PROCEDURE rubad_SetAOManAssT(trgManAssT: LIKE(AcsObj.ManAssT));
 BEGIN
  IF AcsObj.ManAssT # trgManAssT THEN
   AcsObj.ManAssT:=trgManAssT;
   ReplaceAcsObj();
  END;
 END {rubad_SetAOManAssT};

 PRIVATE PROCEDURE rubad_AddGroup(oGroup: OBJECT);
 BEGIN
  IF    ~StandOnGroup(oGroup.Name) THEN
   DEFAULT(AcsObj);
   AcsObj.Type    :=aot_Group;
   AcsObj.Name    :=oGroup.Name;
   AcsObj.NAME    :=Str.Cap(AcsObj.Name);
   AcsObj.FullName:=oGroup.Description;
   AcsObj.Begin   :=L_Env.aptm_Start;
   AcsObj.inXDF   :=0;
   InsertAcsObj();
   rubad_MakePart("㯯 ⠢");
  ELSIF ~!AcsObj.Till THEN
   AcsObj.Name    :=oGroup.Name;
   AcsObj.FullName:=oGroup.Description;
   SETEMPTY(AcsObj.Till);
   ReplaceAcsObj();
   rubad_MakePart("࠭  砭 ਮ ਬ 㯯");
  ELSIF AcsObj.FullName # oGroup.Description THEN
   AcsObj.FullName:=oGroup.Description;
   ReplaceAcsObj();
  END;
 END {rubad_AddGroup};

 PUBLIC PROCEDURE extRenovateUsersByAD(Silent: SCAL[2]): STRING[];
  CONST
   gt_Global = 2;
   RepName   = "RUBAD";
  VAR
   asl,
   aoDict,
   oAD,
   oUser,
   oGroup,
   oUserGroups: OBJECT;
   AOMPool,
   UserName,
   FullRepName: STRING[];
   UserAcsObj : LIKE(AcsObj.AcsObj);
   UserFN     : LIKE(AOMem.aoFN);
 BEGIN
  L_General.Assert(~L_General.IsLocalMode(), "   ᭮ Active Directory|" +
                                             " ਠ  ⠫樨  ");

  IF L_MSWStp.NeedElevation() THEN
   TRY
    asl := L_MSWStp.GetElevatedASL("AcsObj", L_MSWStp.aslDBModification_On);
    PROMPT("  ᭮  Active Directory");
    FullRepName:=asl.Func("L_AR.RenovateUsersByAD");
   EXCEPT
   ON Exc: Exc_Object DO
    L_MSWStp.AsbApplicationErrorHandler(Exc);
   END;
  ELSE
   GRANTALLRIGHTS();
   FullRepName:=L_General.NameConnection(RepName);
   OPENREP(R, FullRepName, Create);
   MAKEPART(R, rubad_Top, RepName);
   SETEMPTY(rubad_lastAO);
   aoDict:=L_General.CreateDictionary();
   L_General.Assert(ISLOCALADMIN(), "室  쭮  ");
   L_General.Assert(~!COMPUTERNAME(COMPUTER_NAME_DnsDomain), "   ᮥ  ");
   oAD:=GetOBJECT("WinNT://" + USERDOMAIN());
   FOR_EACH oGroup IN oAD DO
    PROMPT(oGroup.Name);
    IF (Str.Cap(oGroup.Class) = "GROUP") & (oGroup.GroupType = gt_Global) THEN
     aoDict.Add(Str.Cap(oGroup.Name), "");
     rubad_AddGroup(oGroup);
    END;
   END;

   FOR_EACH oUser IN oAD DO
    PROMPT(oUser.Name);
    IF (Str.Cap(oUser.Class) = "USER") THEN
     oUserGroups:=oUser.Groups();
     IF rubad_IsMember(oUserGroups, L_General.UsersGroupName()) THEN
      UserName          :=oUser.Name;
      UserFN            :=oUser.FullName;
      iu_UserWasInserted:=0;
      aoDict.Add(Str.Cap(UserName), "");
      UserAcsObj:=intGetUser(UserName, Silent);
      SEARCH(AcsObj, AcsObj, , UserAcsObj);
      IF AcsObj.FullName # oUser.FullName THEN
       AcsObj.FullName:=oUser.FullName;
       ReplaceAcsObj();
      END;

      IF    iu_UserWasInserted THEN
       rubad_MakePart("짮⥫ ⠢");
      END;

      IF DBD.FileExist(Man) THEN
       IF (AcsObj.ManAssT # aomat_NotMan) & (AcsObj.ManAssT # aomat_Robot) &
          !AcsObj.Man & SELECT(Man, Name, AcsObj.FullName) & ~NEXT(Man) THEN
        SELECT(Man, Name, , AcsObj.FullName);
        AcsObj.Man    :=Man.Man;
        IF Man.rStaff THEN
         AcsObj.ManAssT:=aomat_Staff;
        ELSE
         AcsObj.ManAssT:=aomat_ManButNotStaff;
        END;
        ReplaceAcsObj();
        rubad_MakePart("짮⥫ ᮯ⠢ ");
       END;
      END;

      IF    ~L_General.IsOurSite() & rubad_IsMember(oUserGroups, "AP_SUPPORT") THEN
       rubad_SetAOManAssT(aomat_NotMan);
      ELSIF rubad_IsMember(oUserGroups, "END_USER") | (AcsObj.Name = L_PCS.GuardLoginName()) THEN
       rubad_SetAOManAssT(aomat_Robot);
      END;

      IF AcsObj.ManAssT = aomat_Staff THEN
       IF oUser.AccountDisabled = vba_False THEN
        IF    !AcsObj.Man THEN
         rubad_MakePart("஡:  ᮯ⠢   짮⥫-ࠡ⭨");
        ELSIF ~L_PCS.UserAssociatedPersonIsActive(SYSDATE()) THEN
         rubad_MakePart("஡:  ⭠   ࠡ⭨,  室饣  ");
        ELSIF ~!AcsObj.Till THEN
         SETEMPTY(AcsObj.Till);
         ReplaceAcsObj();
         UpdateUserAOMem();
         rubad_MakePart("࠭  砭 ਮ ਬ");
        END;
       ELSE
        IF L_PCS.UserAssociatedPersonIsActive(SYSDATE()) THEN
         rubad_MakePart("஡: ⪫祭 ⭠   ࠡ⭨, 室饣  ");
        ELSIF !AcsObj.Till THEN
         AcsObj.Till:=SYSDATE();
         ReplaceAcsObj();
         UpdateUserAOMem();
         rubad_MakePart("⠭  砭 ਮ ਬ");
        END;
       END; (* IF oUser.AccountDisabled = vba_False *)
      ELSE
       IF oUser.AccountDisabled = vba_True THEN
        IF !AcsObj.Till THEN
         AcsObj.Till:=SYSDATE();
         ReplaceAcsObj();
         UpdateUserAOMem();
         rubad_MakePart("⠭  砭 ਮ ਬ");
        END;
       ELSE
        IF ~!AcsObj.Till THEN
         SETEMPTY(AcsObj.Till);
         ReplaceAcsObj();
         UpdateUserAOMem();
         rubad_MakePart("࠭  砭 ਮ ਬ");
        END;
       END; (* IF oUser.AccountDisabled = vba_True *)
      END; (* IF AcsObj.ManAssT = aomat_Staff *)

      AOMPool:="";
      FOR_EACH oGroup IN oUserGroups DO
       PROMPT(oUser.Name + ": " + oGroup.Name);
       IF oGroup.GroupType = gt_Global THEN
        rubad_AddGroup(oGroup);
        IF ~SEARCH(AOMem, AcsObj, AcsObj.AcsObj, UserAcsObj) THEN
         SETEMPTY(AOMem.AOMem);
         AOMem.AcsObj :=AcsObj.AcsObj;
         AOMem.AcsObj2:=UserAcsObj;
         AOMem.aoName :=AcsObj.Name;
         AOMem.aoName2:=UserName;
         AOMem.aoFN   :=AcsObj.FullName;
         AOMem.aoFN2  :=UserFN;
         GetAcsObjBeginTill(UserAcsObj, AOMem.Begin, AOMem.Till);
         AOMem.Manager:=0;
         INSERT(AOMem);
        END;
        AOMPool:=AOMPool + AOMem.AOMem + "|";
       END;
      END; (* FOR_EACH oGroup IN oUserGroups...*)
      SELECT(AOMem, AcsObj2, , UserAcsObj);
      WHILE OCCURE(AOMem) DO
       IF !L_Str.PositionInPool(AOMPool, AOMem.AOMem) THEN
        REMOVE(AOMem);
       ELSE
        NEXT(AOMem);
       END;
      END; (* WHILE OCCURE(AOMem) ... *)
     END; (* IF rubad_IsMember *)
    END; (* Str.Cap(oUser.Class) = "USER" *)
   END; (* FOR_EACH oUser IN oAD...*)

   SELECT(AcsObj, AcsObj);
   WHILE OCCURE(AcsObj) DO
    PROMPT(AcsObj.AcsObj);
    IF L_DatTim.IsActive(SYSDATE(), AcsObj.Begin, AcsObj.Till) & ~aoDict.Exists(AcsObj.NAME) THEN
     IF AcsObj.Type = aot_User THEN
      SETSEL(AOMem, AcsObj2, AcsObj.AcsObj);
     ELSE
      SETSEL(AOMem, AcsObj,  AcsObj.AcsObj);
     END;
     REMSEL(AOMem);
     TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), INTEGRITY(INTEGRITY_ON)]
      SEARCH(AcsObj2, AcsObj2, , AcsObj.AcsObj);
      REMOVE(AcsObj);
      rubad_ExtMakePart(AcsObj2.AcsObj2, AcsObj2.Name,
                        L_Str.PoolItem("짮⥫ 㤠|㯯 㤠", AcsObj2.Type));
      REMOVE(AcsObj2);
     EXCEPT
     ON Exc: Exc_Root DO
      IF Exc.ErrorCode = L_General.ec_rt_NoDeleteUser THEN
       AcsObj.Till:=SYSDATE();
       ReplaceAcsObj();
       rubad_MakePart("⠭  砭 ਮ ਬ");
       NEXT(AcsObj);
      ELSE
       RAISE();
      END;
     END;
    ELSE
     NEXT(AcsObj);
    END; (* IF ~aoDict.Exists(AcsObj.NAME) *)
   END; (* WHILE OCCURE(AcsObj) ... *)

   MAKEPART(R, rubad_Bot);
  END; (* IF L_MSWStp.NeedElevation() ... *)
  RETURN FullRepName;
 END {extRenovateUsersByAD};

 PUBLIC PROCEDURE RenovateUsersByAD(): STRING[];
 BEGIN
  RETURN extRenovateUsersByAD(1);
 END {RenovateUsersByAD};

 PUBLIC PROCEDURE extSwitchAccountDisabledFlagInAD(_AcsObj: LIKE(AcsObj.AcsObj); DisableAccount: SCAL[2]);
  VAR
   oUser: OBJECT;
 BEGIN
  SEARCH(AcsObj, AcsObj, , _AcsObj);
  TRY
   oUser:=GetUserFromAD(AcsObj.Name);
   IF DisableAccount THEN
    oUser.AccountDisabled:=vba_True;
   ELSE
    oUser.AccountDisabled:=vba_False;
   END;
   oUser.SetInfo();
   IF DisableAccount & !AcsObj.Till THEN
    AcsObj.Till:=SYSDATE();
    ReplaceAcsObj();
    UpdateUserAOMem();
   ELSIF ~DisableAccount & ~!AcsObj.Till THEN
    SETEMPTY(AcsObj.Till);
    ReplaceAcsObj();
    UpdateUserAOMem();
   END;
  EXCEPT
  ON Exc: Exc_Object DO
   L_MSWStp.AsbApplicationErrorHandler(Exc);
  END (* TRY *);
 END {extSwitchAccountDisabledFlagInAD};

 PUBLIC PROCEDURE SetAccountDisabledFlagInAD(Login: STRING[]; DisableAccount: SCAL[2]);
  VAR
   asl: OBJECT;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  IF StandOnUser(Login) THEN
   L_General.Assert(AcsObj.Type = aot_User, "  ⮫쪮  짮⥫");
   IF L_MSWStp.NeedElevation() THEN
    TRY
     asl:=L_MSWStp.GetElevatedASL("AcsObj", L_MSWStp.aslDBModification_On);
     asl.Proc("L_AR.extSwitchAccountDisabledFlagInAD", AcsObj.AcsObj, DisableAccount);
    EXCEPT
    ON Exc: Exc_Object DO
     L_MSWStp.AsbApplicationErrorHandler(Exc);
    END (* TRY *);
   ELSE
    extSwitchAccountDisabledFlagInAD(AcsObj.AcsObj, DisableAccount);
   END; (* IF L_MSWStp.NeedElevation()...*)
  END; (* IF StandOnUser(Login)...*)
 END {SetAccountDisabledFlagInAD};

 PRIVATE PROCEDURE CheckPolakTemporaryUserInAD();
  VAR
   oUser: OBJECT;
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   oUser:=GetOBJECT("WinNT://" + APPLICATION.Get().ServerDomain + "/Polak,user");
   L_General.CallUs(0);
  EXCEPT
  ON Exc: Exc_Object DO

  ELSE
   RAISE();
  END (* TRY *);
 END {CheckPolakTemporaryUserInAD};

 PUBLIC PROCEDURE DisablePolakUserInForeignAD(Login: STRING[]);
 BEGIN
  IF ~L_General.IsOurEngineeringCopy() THEN
   L_General.DomainAdminOnly();
   SetAccountDisabledFlagInAD(Login, 1);
   CheckPolakTemporaryUserInAD();
  END;
 END {DisablePolakUserInForeignAD};

 PUBLIC PROCEDURE SessionHasAssignedGroup(): SCAL[2];
  VAR
   tg: TOKENGROUP;
 BEGIN
  IF ~L_General.IsLocalMode() THEN
   FOR_EACH tg IN APP.Get().MyConnection.TokenGroups DO
    IF tg.Assigned THEN
     RETURN 1;
    END;
   END; (* FOR_EACH tg IN APP.Get().MyConnection.TokenGroups...*)
  END;
  RETURN 0;
 END {SessionHasAssignedGroup};

 PUBLIC PROCEDURE GetAcsObjManName(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  L_General.CallUs(OCCURE(AcsObj));
  IF ~!AcsObj.Man THEN
   SAVE(Man);
   CONFORM(AcsObj, Man);
   Result:=Man.Name;
   RESTORE(Man);
  ELSE
   Result:=AcsObj.FullName;
  END;
  RETURN Result;
 END {GetAcsObjManName};

BEGIN
 IF ~VAR_IMPL.Get(HasConcealedPartOfDatabase).Initialized THEN
  HasConcealedPartOfDatabase:=0;
 END;
END.
