(*
%Copyright   (c) Polak IT
%Author      25.03.2004 10:36:52 POLAK\LDA
%Purpose
%Type        library
%Specific    SYS
%Modified    08.08.2014 18:50:59 POLAK\LDA
%Environment
*)

 MODULE L_ATER [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, L_Str, L_Prop, L_General, L_Packet, P_Firm, L_Man, L_DatTim, P_Man, P_MyFirm, L_Russia,
        L_AFM, L_ctc, D_Slr, L_Staff, Math, L_StdFrm, P_MyPlc, L_SFee;

 PUBLIC CONST
  ZeroTable = 00000;
  ZeroRow2  = 00000;

  aak_Data          =  0;
  aak_Calculated    =  1;
  aak_NotRequired   =  2;
  aak_ManualInput   =  3;
  aak_Const         =  4;
  aak_Function      =  5;
  aak_EndOfBlock    =  6;
  aak_EndOfFragment =  7;
  aak_EndOfFile     =  8;
  aak_System        =  9;

  xet_xmlAttribute = 0;
  xet_SimpleElm    = 1;
  xet_ComplexElm   = 2;
  xet_NotUpLoad    = 3;

 PUBLIC VAR
  TestUpload,
  UploadInWord: SCAL[2];
  tblNodes    : OBJECT;

 PRIVATE TYPE
  tWho = SCAL[5];

 PRIVATE CONST
  s_Responsible = 0;
  s_Leader      = 1;
  s_Signatory   = 2;
  s_Sender      = 3;
  s_Acnt        = 4;

 PUBLIC PROCEDURE Key(_Table, _Table2: LIKE(PckATER.Table)): STRING[];
 BEGIN
  RETURN ""+_Table+_Table2;
 END {Key};

 PRIVATE PROCEDURE int(wEmptyFirstPacket: SCAL[2]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=STRTOFLD(Packet.ExtNbr, NUMERIC);
  IF (Result = 1) & wEmptyFirstPacket THEN
   SETEMPTY(Result);
  ELSE
   DEC(Result);
  END;
  RETURN Result;
 END {int};

 PRIVATE PROCEDURE _(): SCAL[1E3];
 BEGIN
  RETURN int(0);
 END {_};

 PRIVATE PROCEDURE NumCorr(): SCAL[1E3];
 BEGIN
  RETURN _();
 END {NumCorr};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  IF ATER.ATER >= 27 THEN
   RETURN L_Str.IntStr(int(0));
  ELSE
   RETURN L_Str.IntStr(int(1));
  END;
 END {};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN ();
 END {};

 PRIVATE PROCEDURE intGetAnyManName(Who: tWho): STRING[];
 BEGIN
  IF    Who = s_Responsible THEN
   (* 23.04.2007 16:19:10 POLAK\San - , , ⢥⢥?!    *)
   RETURN P_Firm.FP_AcntName(L_Packet.GetPacketOwnFirm(), SYSDATE());
  ELSIF Who = s_Leader THEN
   RETURN P_Firm.FP_LeadName(L_Packet.GetPacketOwnFirm(), SYSDATE());
  ELSIF Who = s_Acnt THEN
   RETURN P_Firm.FP_AcntName(L_Packet.GetPacketOwnFirm(), SYSDATE());
  ELSIF Who = s_Sender THEN
   L_General.CallUs(SEARCH(Man, Man, P_Man.curUSER2Man()));
   RETURN Man.Name;
  ELSIF Who = s_Signatory THEN
   IF L_Packet.TaxAgentRequired() THEN
    RETURN P_Firm.FP_LeadName(P_Firm.fomf(L_Packet.GetTaxAgentMyFirm()), SYSDATE());
   ELSIF (Packet.Kind = L_Packet.knd_TT_Decl) & (L_DatTim.YEAR(Packet.PerB) >= 2012) THEN
    RETURN P_Firm.FP_LeadName(L_Packet.GetPacketOwnFirm(), SYSDATE());
   ELSE
    IF (Packet.Kind = L_Packet.knd_TT_AdvRep) |
       (Packet.Kind = L_Packet.knd_TT_Decl)   |
       (Packet.Kind = L_Packet.knd_AvgCnt) THEN
     RETURN "";
    ELSE
     RETURN P_Firm.FP_LeadName(L_Packet.GetPacketOwnFirm(), SYSDATE());
    END;
   END;
  END;
  L_General.CallUs(0);
 END {intGetAnyManName};

 PRIVATE PROCEDURE IsSignatory(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SAVE(ATERAttr);
  IF    (ATERAttr.ATERAttr = "栏⢥ত饣") |
        (ATERAttr.ATERAttr = "।")                         |
        (ATERAttr.ATERAttr = "।") THEN
   Result:=1;
  ELSIF ATERAttr.ATERAttr = "" THEN
   SELECT(ATERAttr, ATER, , ATERAttr.ATER, ATERAttr.xmlPrnTb, 00);
   Result:=ATERAttr.ATERAttr = "ᠭ";
  END;
  RESTORE(ATERAttr);
  RETURN Result;
 END {IsSignatory};

 PRIVATE PROCEDURE GetAnyManName(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  SAVE(ATERAttr);
  SELECT(ATERAttr, ATER, , ATERAttr.ATER, ATERAttr.xmlPrnTb, 00);
  IF    ATERAttr.ATERAttr = "" THEN
   Result:=intGetAnyManName(s_Responsible);
  ELSIF ATERAttr.ATERAttr = "㪎" THEN
   IF ~L_Packet.TaxAgentRequired() THEN
    Result:=intGetAnyManName(s_Leader);
   END;
  ELSIF IsSignatory() THEN
   Result:=intGetAnyManName(s_Signatory);
  ELSE
   L_General.CallUs(0);
  END;
  RESTORE(ATERAttr);
  RETURN Result;
 END {GetAnyManName};

 PRIVATE PROCEDURE ext(Name: STRING[]; UpperCase: SCAL[2]): STRING[];
  VAR
   Result,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  L_Str.SplitManName(Name, Result, FirstName, Patronymic);
  IF UpperCase THEN
   Result:=Str.Cap(Result);
  END;
  RETURN Result;
 END {ext};

 PRIVATE PROCEDURE ext(Name: STRING[]; UpperCase: SCAL[2]): STRING[];
  VAR
   Result,
   Surname,
   Patronymic: STRING[];
 BEGIN
  L_Str.SplitManName(Name, Surname, Result, Patronymic);
  IF UpperCase THEN
   Result:=Str.Cap(Result);
  END;
  RETURN Result;
 END {ext};

 PRIVATE PROCEDURE ext⢮(Name: STRING[]; UpperCase: SCAL[2]): STRING[];
  VAR
   Result,
   Surname,
   FirstName: STRING[];
 BEGIN
  L_Str.SplitManName(Name, Surname, FirstName, Result);
  IF UpperCase THEN
   Result:=Str.Cap(Result);
  END;
  RETURN Result;
 END {ext⢮};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN ext(GetAnyManName(), 0);
 END {};

 PRIVATE PROCEDURE 㪮⥫_(): STRING[];
 BEGIN
  RETURN ();
 END {㪮⥫_};

 PRIVATE PROCEDURE ।⠢⥫_(): STRING[];
 BEGIN
  RETURN ();
 END {।⠢⥫_};

 PRIVATE PROCEDURE ᠭ_(): STRING[];
 BEGIN
  RETURN ();
 END {ᠭ_};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN ext(GetAnyManName(), 0);
 END {};

 PRIVATE PROCEDURE 㪮⥫_(): STRING[];
 BEGIN
  RETURN ();
 END {㪮⥫_};

 PRIVATE PROCEDURE ।⠢⥫_(): STRING[];
 BEGIN
  RETURN ();
 END {।⠢⥫_};

 PRIVATE PROCEDURE ᠭ_(): STRING[];
 BEGIN
  RETURN ();
 END {ᠭ_};

 PRIVATE PROCEDURE ⢮(): STRING[];
 BEGIN
  RETURN ext⢮(GetAnyManName(), 0);
 END {⢮};

 PRIVATE PROCEDURE 㪮⥫_⢮(): STRING[];
 BEGIN
  RETURN ⢮();
 END {㪮⥫_⢮};

 PRIVATE PROCEDURE ।⠢⥫_⢮(): STRING[];
 BEGIN
  RETURN ⢮();
 END {।⠢⥫_⢮};

 PRIVATE PROCEDURE ᠭ_⢮(): STRING[];
 BEGIN
  RETURN ⢮();
 END {ᠭ_⢮};

 PRIVATE PROCEDURE _(): STRING[];
 BEGIN
  RETURN ext(GetAnyManName(), 1);
 END {_};

 PRIVATE PROCEDURE _(): STRING[];
 BEGIN
  RETURN ext(GetAnyManName(), 1);
 END {_};

 PRIVATE PROCEDURE ⢮_(): STRING[];
 BEGIN
  RETURN ext⢮(GetAnyManName(), 1);
 END {⢮_};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN L_Man.ConvName(intGetAnyManName(s_Leader));
 END {};

 PRIVATE PROCEDURE (): STRING[];
  VAR
   _Name: STRING[];
 BEGIN
  _Name:=intGetAnyManName(s_Acnt);
  IF ~!_Name THEN
   RETURN L_Man.ConvName(_Name);
  ELSE
   IF UploadInWord THEN
    RETURN P_Firm.Acnt_MagicText_v2;
   ELSE
    RETURN ",,";
   END;
  END;
 END {};

 PUBLIC PROCEDURE (): SCAL[3];
 BEGIN
  IF L_Packet.TaxAgentRequired() THEN
   RETURN 2;
  ELSE
   RETURN 1;
  END;
 END {};

 PRIVATE PROCEDURE ।(): STRING[];
 BEGIN
  IF L_Packet.TaxAgentRequired() THEN
   RETURN "७";
  ELSE
   RETURN "";
  END;
 END {।};

 PUBLIC PROCEDURE ᪨넮।(): STRING[];
 BEGIN
  IF L_Packet.TaxAgentRequired() THEN
   RETURN "-";
  ELSE
   RETURN "";
  END;
 END {᪨넮।};

 PUBLIC PROCEDURE ᪨㪢넮।(): STRING[];
 BEGIN
  IF L_Packet.TaxAgentRequired() THEN
   RETURN "-";
  ELSE
   RETURN "";
  END;
 END {᪨㪢넮।};

 PUBLIC PROCEDURE ⮢饣।(): STRING[];
 BEGIN
  IF L_Packet.TaxAgentRequired() THEN
   RETURN "0";
  ELSE
   RETURN "";
  END;
 END {⮢饣।};

 PUBLIC PROCEDURE ⠂뤠稄।(): STRING[];
 BEGIN
  IF L_Packet.TaxAgentRequired() THEN
   RETURN "-";
  ELSE
   RETURN "";
  END;
 END {⠂뤠稄।};

 PUBLIC PROCEDURE 뤠।(): STRING[];
 BEGIN
  IF L_Packet.TaxAgentRequired() THEN
   RETURN "-";
  ELSE
   RETURN "";
  END;
 END {뤠।};

 PRIVATE PROCEDURE ext(trgMyFirm: P_Firm.tMyFirm): STRING[];
 BEGIN
  RETURN P_Firm.FP_ContractorBriefName(P_Firm.fomf(trgMyFirm), L_DatTim.MonthEnd(Packet.PerE));
 END {ext};

 PUBLIC PROCEDURE ࣏।(): STRING[];
 BEGIN
  IF L_Packet.TaxAgentRequired() THEN
   RETURN ext(L_Packet.GetTaxAgentMyFirm());
  ELSE
   RETURN "";
  END;
 END {࣏।};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN ATER.KND;
 END {};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN L_Str.IntStr(STRTOFLD(Packet.ExtNbr, NUMERIC)-1);
 END {};

 PRIVATE PROCEDURE ਧ(): STRING[];
 BEGIN
  IF STRTOFLD(Packet.ExtNbr, NUMERIC) > 1 THEN
   RETURN "3";
  ELSE
   RETURN "1";
  END;
 END {ਧ};

 PRIVATE PROCEDURE ਮ(): STRING[];
 BEGIN
  IF ATER.Kind = L_Packet.knd_TT_AdvRep THEN
   IF UploadInWord THEN
    RETURN L_Str.IntStr((L_DatTim.MONTH(Packet.PerE)+1));
   ELSE
    RETURN L_Str.IntStr((L_DatTim.QUARTAL(Packet.PerE)+1) + 20);
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {ਮ};

 PRIVATE PROCEDURE ਮ(): STRING[];
  VAR
   _Q: SCAL[5];
 BEGIN
  _Q:=L_DatTim.QUARTAL(Packet.PerE)+1;
  IF ATER.Kind = L_Packet.knd_VAT THEN
   RETURN "2" + _Q;
  ELSE
   IF    _Q = 1 THEN RETURN "21";
   ELSIF _Q = 2 THEN RETURN "31";
   ELSIF _Q = 3 THEN RETURN "33";
   ELSE              RETURN "34";
   END;
  END;
 END {ਮ};

 PRIVATE PROCEDURE _멏ਮ(): SCAL[1E2];
  VAR
   _Q: NUMERIC[0];
 BEGIN
  _Q:=L_DatTim.QUARTAL(Packet.PerE)+1;
  IF    _Q = 1 THEN
   RETURN 03;
  ELSIF _Q = 2 THEN
   RETURN 06;
  ELSIF _Q = 3 THEN
   RETURN 09;
  ELSE
   RETURN 12;
  END;
 END {_멏ਮ};

 PRIVATE PROCEDURE 2014_멏ਮ(): STRING[];
  VAR
   _Q: NUMERIC[0];
 BEGIN
  _Q:=L_DatTim.QUARTAL(Packet.PerE)+1;
  IF    _Q = 1 THEN
   RETURN "3";
  ELSIF _Q = 2 THEN
   RETURN "6";
  ELSIF _Q = 3 THEN
   RETURN "9";
  ELSE
   RETURN "0";
  END;
 END {2014_멏ਮ};

 PRIVATE PROCEDURE ਮ(): STRING[];
 BEGIN
  RETURN L_Str.IntStr(L_DatTim.YEAR(Packet.PerE));
 END {ਮ};

 PRIVATE PROCEDURE ⃮(): STRING[];
 BEGIN
  RETURN L_Str.IntStr(L_DatTim.YEAR(Packet.PerE));
 END {⃮};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN P_Firm.FP_TaxDepCode(L_Packet.GetPacketOwnFirm(), SYSDATE());
 END {};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN ();
 END {};

 PRIVATE PROCEDURE ⠄(): STRING[];
 BEGIN
  RETURN L_DatTim.DateStr(Packet.PrpDate);
 END {⠄};

 PRIVATE PROCEDURE ⠄(): STRING[];
 BEGIN
  RETURN FLDTOSTR(Packet.PrpDate, "y-N-D", 10);
 END {⠄};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN ext(Packet.MyFirm);
 END {};

 PRIVATE PROCEDURE _(): STRING[];
 BEGIN
  RETURN Str.Cap(());
 END {_};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN P_Firm.FP_INN(L_Packet.GetPacketOwnFirm(), L_DatTim.MonthEnd(Packet.PerE));
 END {};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN P_Firm.FP_KPP(L_Packet.GetPacketOwnFirm(), L_DatTim.MonthEnd(Packet.PerE));
 END {};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN P_Firm.FP_OGRN(L_Packet.GetPacketOwnFirm(), L_DatTim.MonthEnd(Packet.PerE));
 END {};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN P_Firm.FP_OKPO(L_Packet.GetPacketOwnFirm(), L_DatTim.MonthEnd(Packet.PerE));
 END {};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN P_Firm.FP_OKOPF_Code(L_Packet.GetPacketOwnFirm(), L_DatTim.MonthEnd(Packet.PerE));
 END {};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN P_Firm.FP_OKFS_Code(L_Packet.GetPacketOwnFirm(), L_DatTim.MonthEnd(Packet.PerE));
 END {};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN P_MyFirm.OKVED_Code(L_Packet.GetPacketMyFirm(), L_DatTim.MonthEnd(Packet.PerE));
 END {};

 PRIVATE PROCEDURE (): STRING[];
  VAR
   trgMyFirm: P_Firm.tMyFirm;
   trgD: DATE;
 BEGIN
  trgMyFirm:=L_Packet.GetPacketMyFirm();
  trgD     :=L_DatTim.MonthEnd(Packet.PerE);
  IF L_SFee.IsUSNOLowSFee(trgMyFirm, trgD) THEN
   RETURN P_MyFirm.OKVED_Code(trgMyFirm, trgD);
  ELSE
   RETURN "";
  END;
 END {};

 PRIVATE PROCEDURE 稭(): STRING[]; (*, 騩   , 㪠뢠騩  ਠ ࣠ ,  ஬ ॣ஢*)
 BEGIN
  RETURN P_MyFirm.FSSSubordinationCode(L_Packet.GetPacketMyFirm(), L_DatTim.MonthEnd(Packet.PerE));
 END {稭};

 PRIVATE PROCEDURE ࣠(): STRING[];
 BEGIN
  RETURN L_Str.Left(P_MyFirm.FSSRegistrationCode(L_Packet.GetPacketMyFirm(), L_DatTim.MonthEnd(Packet.PerE)), 4);
 END {࣠};

 PRIVATE PROCEDURE ⥫멊(): STRING[];
 BEGIN
  RETURN P_MyFirm.FSSSupplementaryCode(L_Packet.GetPacketMyFirm(), L_DatTim.MonthEnd(Packet.PerE));
 END {⥫멊};

 PRIVATE PROCEDURE ConvPhoneNumber(PhoneNumber: STRING[]): STRING[];
  VAR
   i     : NUMERIC[0];
   Char,
   Result: STRING[];
 BEGIN
  IF Str.Slice(PhoneNumber, 0, 2) = "+7" THEN
   PhoneNumber:=Str.Delete(PhoneNumber, 0, 2);
  END;
  IF UploadInWord THEN
   Result:=PhoneNumber;
  ELSE
   SETEMPTY(Result);
   i:=0;
   LOOP
    Char:=L_Str.Char(PhoneNumber, i);
    IF !Char THEN
     EXIT;
    END;
 
    IF L_Prop.IsNumericValue(Char, "") THEN
     Result:=Result+Char;
    END;
    INC(i);
   END; (* LOOP *)
  END;
  RETURN Result;
 END {ConvPhoneNumber};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN ConvPhoneNumber(P_Firm.FP_Phone(L_Packet.GetPacketOwnFirm(), SYSDATE()));
 END {};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN P_MyPlc.GetP_OKTMO(Packet.MyFirm, Packet.MyPlace, L_DatTim.MonthEnd(Packet.PerE));
 END {};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN P_MyPlc.GetP_OKTMO(Packet.MyFirm, Packet.MyPlace, L_DatTim.MonthEnd(Packet.PerE));
 END {};

 PRIVATE PROCEDURE _(): STRING[];
 BEGIN
  RETURN "18210604011021000110";
 END {_};

 PRIVATE PROCEDURE Check_(Kind_AsStr: STRING[]);
 BEGIN
  L_General.Error(Kind_AsStr + ": 室 筨   " + L_Str.IntStr(L_DatTim.YEAR(Packet.PerB)) + " ");
 END {Check_};

 PRIVATE PROCEDURE IsSince2011(): SCAL[2];
  VAR
   Year: NUMERIC[0];
 BEGIN
  Year:=L_DatTim.YEAR(Packet.PerB);
  RETURN (Year = 2011) | (Year = 2012) | (Year = 2013);
 END {IsSince2011};

 PUBLIC PROCEDURE __室(): STRING[];
 BEGIN
  IF    IsSince2011()                     THEN RETURN "18210501011011000110";
  ELSIF L_DatTim.YEAR(Packet.PerB) = 2010 THEN RETURN "18210501012011000110";
  ELSIF L_DatTim.YEAR(Packet.PerB) = 2009 THEN RETURN "18210501010011000110";
  ELSE  Check_("_室");
  END;
 END {__室};

 PUBLIC PROCEDURE __室(): STRING[];
 BEGIN
  IF    IsSince2011()                     THEN RETURN "18210501021011000110";
  ELSIF L_DatTim.YEAR(Packet.PerB) = 2010 THEN RETURN "18210501022011000110";
  ELSIF L_DatTim.YEAR(Packet.PerB) = 2009 THEN RETURN "18210501020011000110";
  ELSE  Check_("_室");
  END;
 END {__室};

 PUBLIC PROCEDURE __(): STRING[];
 BEGIN
  IF ~!Get("", 0000, 0000) THEN
   IF    IsSince2011()                     THEN RETURN "18210501050011000110";
   ELSIF L_DatTim.YEAR(Packet.PerB) = 2010 THEN RETURN "18210501030011000110";
   ELSIF L_DatTim.YEAR(Packet.PerB) = 2009 THEN RETURN "18210501030011000110";
   ELSE  Check_("_");
   END;
  ELSE
   RETURN "";
  END;
 END {__};

 PUBLIC PROCEDURE _(): STRING[];
 BEGIN
  RETURN "18210301000011000110";
 END {_};

 PUBLIC PROCEDURE __(): STRING[];
 BEGIN
  RETURN _();
 END {__};

 PRIVATE PROCEDURE IsNormalUpload(): SCAL[2];
 BEGIN
  RETURN ~VAR_IMPL.Get(TestUpload).Initialized | ~TestUpload;
 END {IsNormalUpload};

 PUBLIC PROCEDURE ER_㬬(_Attr: STRING[]): NUMERIC[2];
  VAR
   _Total: NUMERIC[2];
 BEGIN
  IF IsNormalUpload() THEN
   IF CalcByPublicName() THEN
    SAVE(ATERAttr);
    SELECT(ATERAttr, PublicNm, , Packet.ATER, _Attr);
    SELECT(PckATER, PckATER, , Packet.Packet, ATERAttr.Table, 00000, ATERAttr.ATERAttr);
    L_General.Assert(~NEXT(ATERAttr), "筮 । ਡ " + _Attr);
    RESTORE(ATERAttr);
   ELSE
    SELECT(PckATER, Packet, , Packet.Packet, _Attr);
   END;
   IF OCCURE(PckATER) THEN
    _Total:=0;
    WHILE OCCURE(PckATER) DO
     PROMPT(" " + _Attr);
     IF ~!PckATER.Value THEN
      INC(_Total, STRTOFLD(PckATER.Value, NUMERIC));
     END;
     NEXT(PckATER);
    END; (* WHILE OCCURE(PckATER)... *)
    RETURN _Total;
   ELSE
    RETURN EMPTYOF(NUMERIC[2]);
   END;
  ELSE
   RETURN 1;
  END;
 END {ER_㬬};

 PUBLIC PROCEDURE ER_㬬Z(_Attr: STRING[]): NUMERIC[2];
  VAR
   Result: NUMERIC[2];
 BEGIN
  Result:=ER_㬬(_Attr);
  IF !Result THEN
   Result:=0;
  END;
  RETURN Result;
 END {ER_㬬Z};

 PRIVATE PROCEDURE _(): STRING[];
  VAR
   ToPay,
   AdvSum,
   ToDec: NUMERIC[0];
 BEGIN
  IF Packet.Kind = L_Packet.knd_CPT_AdvRep THEN
   ToPay:=ER_㬬Z("㬀");
   ToDec:=ER_㬬Z("㬋");
   RETURN L_Str.IntStr(ToPay-ToDec);
  ELSE
   ToPay :=ER_㬬Z("㬍");
   AdvSum:=ER_㬬Z("㬀");
   ToDec :=ER_㬬Z("㬋");
   RETURN L_Str.IntStr(ToPay-AdvSum-ToDec);
  END;
 END {_};

 PRIVATE PROCEDURE ᯮ(): STRING[];
 BEGIN
  L_General.CallUs(SEARCH(Man, Man, P_Man.curUSER2Man()));
  RETURN Man.Name;
 END {ᯮ};

 PRIVATE PROCEDURE 㦈ᯮ(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=P_Man.GetManWorkTelefon(P_Man.curUSER2Man(), SYSDATE(), P_Man.ci_ExtTelefon);
  IF !Result THEN
   Result:=P_Firm.FP_AcntPhone(L_Packet.GetPacketOwnFirm(), SYSDATE());
  END;
  RETURN ConvPhoneNumber(Result);
 END {㦈ᯮ};

 PUBLIC PROCEDURE ᯮ⥫(): STRING[];
 BEGIN
  L_General.CallUs(SEARCH(Staff, TSN, L_Staff.Man2TSN(SYSDATE(), P_Man.curUSER2Man(),
                                                      L_Packet.GetPacketMyFirm(), 0, 0)));
  L_Staff.PosToStaffLog(Staff.TSN, SYSDATE(), 1);
  CONFORM(StaffLog, Officer);
  CONFORM(Officer, Post);
  RETURN Str.Cap(Post.Name);
 END {ᯮ⥫};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN P_MyFirm.NumInPFR(L_Packet.GetPacketMyFirm(), L_DatTim.MonthEnd(Packet.PerE));
 END {};

 PRIVATE PROCEDURE CC(): STRING[];
 BEGIN
  RETURN P_MyFirm.FSSRegistrationCode(L_Packet.GetPacketMyFirm(), L_DatTim.MonthEnd(Packet.PerE));
 END {CC};

 PRIVATE PROCEDURE (): STRING[];
 BEGIN
  RETURN P_MyFirm.NumInMSTF(L_Packet.GetPacketMyFirm(), L_DatTim.MonthEnd(Packet.PerE));
 END {};

 PRIVATE PROCEDURE ਧਮ(): STRING[];
 BEGIN
  RETURN L_Packet.GetPerSign();
 END {ਧਮ};

 PRIVATE PROCEDURE StandToFirmAddr();
  VAR
   dummy: SCAL[2];
 BEGIN
  dummy:=L_ctc.StandOnAdr_Fct(L_DatTim.MonthEnd(Packet.PerE), L_Packet.GetPacketOwnFirm(), 1);
 END {StandToFirmAddr};

 PRIVATE PROCEDURE _(): STRING[];
 BEGIN
  StandToFirmAddr();
  RETURN CtcAdr.Zip;
 END {_};

 PRIVATE PROCEDURE _(): STRING[];
 BEGIN
  StandToFirmAddr();
  RETURN L_Russia.RegionN_InPFRFormat(CtcAdr.Region);
 END {_};

 PRIVATE PROCEDURE __祭(): STRING[];
 BEGIN
  StandToFirmAddr();
  RETURN L_Russia.RegionT_InPFRFormat(CtcAdr.Region);
 END {__祭};

 PRIVATE PROCEDURE _(): STRING[];
 BEGIN
  StandToFirmAddr();
  RETURN Str.Cap(CtcAdr.Distr);
 END {_};

 PRIVATE PROCEDURE __祭(): STRING[];
 BEGIN
  IF ~!_() THEN
   RETURN "-";
  ELSE
   RETURN "";
  END;
 END {__祭};

 PRIVATE PROCEDURE _த(): STRING[];
 BEGIN
  StandToFirmAddr();
  RETURN Str.Cap(CtcAdr.Town);
 END {_த};

 PRIVATE PROCEDURE _த_祭(): STRING[];
 BEGIN
  IF ~!_த() THEN
   RETURN L_Russia.TownT_InMNSFormat(CtcAdr.TownT);
  ELSE
   RETURN "";
  END;
 END {_த_祭};

 PRIVATE PROCEDURE _㭪(): STRING[];
 BEGIN
  StandToFirmAddr();
  RETURN Str.Cap(CtcAdr.Village);
 END {_㭪};

 PRIVATE PROCEDURE _㭪_祭(): STRING[];
 BEGIN
  IF ~!_㭪() THEN
   RETURN L_Russia.VillageT_InMNSFormat(CtcAdr.VillageT);
  ELSE
   RETURN "";
  END;
 END {_㭪_祭};

 PRIVATE PROCEDURE _(): STRING[];
 BEGIN
  StandToFirmAddr();
  RETURN Str.Cap(CtcAdr.Street);
 END {_};

 PRIVATE PROCEDURE __祭(): STRING[];
 BEGIN
  IF ~!_() THEN
   RETURN L_Russia.StreetT_InMNSFormat(CtcAdr.StreetT);
  ELSE
   RETURN "";
  END;
 END {__祭};

 PRIVATE PROCEDURE _(): STRING[];
 BEGIN
  StandToFirmAddr();
  RETURN Str.Cap(CtcAdr.House);
 END {_};

 PRIVATE PROCEDURE __祭(): STRING[];
 BEGIN
  IF ~!_() THEN
   RETURN "";
  ELSE
   RETURN "";
  END;
 END {__祭};

 PRIVATE PROCEDURE _(): STRING[];
  VAR
   Block: STRING[];
 BEGIN
  StandToFirmAddr();
  Block:=CtcAdr.Block;
  IF ~!Block THEN
   Block:=Block + "/";
  END;
  RETURN Str.Cap(Block + CtcAdr.Build);
 END {_};

 PRIVATE PROCEDURE __祭(): STRING[];
 BEGIN
  IF ~!_() THEN
   RETURN "";
  ELSE
   RETURN "";
  END;
 END {__祭};

 PRIVATE PROCEDURE _(): STRING[];
 BEGIN
  StandToFirmAddr();
  RETURN Str.Cap(CtcAdr.Flat);
 END {_};

 PRIVATE PROCEDURE __祭(): STRING[];
 BEGIN
  IF ~!_() THEN
   RETURN "";
  ELSE
   RETURN "";
  END;
 END {__祭};

 PRIVATE PROCEDURE ⠭(): STRING[];
  VAR
   _⠭: STRING[];
 BEGIN
  L_General.Assert(SELECT(PckATER, PckATER, Packet.Packet, 00035, 00000, ""),
                   "  ਡ ''");
  _⠭:=PckATER.Value;
  IF NEXT(PckATER) THEN
   _⠭:="00";
  END;
  RETURN _⠭;
 END {⠭};

 PRIVATE PROCEDURE 1⠫(): STRING[];
 BEGIN
  RETURN L_DatTim.MonthStr(L_DatTim.IncMonth(Packet.PerE, -2), 0);
 END {1⠫};

 PRIVATE PROCEDURE 2⠫(): STRING[];
 BEGIN
  RETURN L_DatTim.MonthStr(L_DatTim.IncMonth(Packet.PerE, -1), 0);
 END {2⠫};

 PRIVATE PROCEDURE 3⠫(): STRING[];
 BEGIN
  RETURN L_DatTim.MonthStr(L_DatTim.IncMonth(Packet.PerE,  0), 0);
 END {3⠫};

 PUBLIC PROCEDURE (): STRING[];
 BEGIN
  IF IsNormalUpload() THEN
   IF OCCURE(PckATER) THEN
    RETURN FLDTOSTR(PckATER.Table2+1, "0");
   ELSE
    RETURN "";
   END;
  ELSE
   RETURN "1";
  END;
 END {};

 PUBLIC PROCEDURE CalcByPublicName(): SCAL[2];
 BEGIN
  RETURN (ATER.ATER >= 0032) & (ATER.Kind # L_Packet.knd_FSS_Sheet);
 END {CalcByPublicName};

 PRIVATE PROCEDURE Get(_Attr  : STRING[];
                       _Table2: LIKE(ATERAttr.Table);
                       _Row2  : LIKE(ATERAttr.Row)): STRING[];
  VAR
   _Value: STRING[];
 BEGIN
  SAVE(ATERAttr);
  IF CalcByPublicName() THEN
   SELECT(ATERAttr, PublicNm, , Packet.ATER, _Attr);
  ELSE
   SELECT(ATERAttr, ATERAttr, , Packet.ATER, _Attr);
  END;

  L_General.Assert(OCCURE(ATERAttr), " ଠ    ਡ '" + _Attr + "'");
  _Value:=Str.Condense(GetSingleAttr(_Table2, _Row2));
  RESTORE(ATERAttr);
  RETURN _Value;
 END {Get};

 PRIVATE PROCEDURE IsSpecSym(Char: STRING[]): SCAL[2];
 BEGIN
  RETURN (Char = "+") |
         (Char = "-") |
         (Char = "/") |
         (Char = "*") |
         (Char = "(") |
         (Char = ")");
 END {IsSpecSym};

 PRIVATE PROCEDURE SplitCondition(    Formula    : STRING[];
                                  VAR Sign       : STRING[];
                                  VAR LExpression: STRING[];
                                  VAR RExpression: STRING[]);
  VAR
   Signs : STRING[][5];
   i,
   Pos,
   Length: NUMERIC[0];
   LChar,
   RChar : STRING[];
 BEGIN
  Signs[0]:="<";
  Signs[1]:=">";
  Signs[2]:="#";
  Signs[3]:="=";
  Signs[4]:="~!";
  Length:=Str.Length(Formula);

  SETEMPTY(Sign);
  i:=0;
  LOOP
   IF i > HIGH(Signs) THEN
    EXIT;
   END;
   Pos:=Str.Pos(Formula, Signs[i]);
   IF Pos # Length THEN
    Sign:=Signs[i];
    EXIT;
   END;
   INC(i);
  END;
  L_General.CallUs(~!Sign);
  LChar:=L_Str.Char(Formula, Pos-1);
  RChar:=L_Str.Char(Formula, Pos+Str.Length(Sign));
  IF LChar = " " THEN
   SETEMPTY(LChar);
  END;
  IF RChar = " " THEN
   SETEMPTY(RChar);
  END;

  IF ~!LChar & ~!RChar THEN
   L_General.CallUs(0);
  END;
  IF    ~!LChar THEN
   Sign:=LChar+Result;
   DEC(Pos);
  ELSIF ~!RChar THEN
   Sign:=Sign+RChar;
  END;
  LExpression:=Str.Condense(Str.Slice(Formula, 0, Pos));
  RExpression:=Str.Condense(Str.Slice(Formula, Pos + Str.Length(Sign), Length - (Pos + Str.Length(Sign)) - 1));
 END {SplitCondition};

 PUBLIC PROCEDURE ER_᫮E(Val, LExpression, RExpression: NUMERIC[2]; Sign: STRING[]): NUMERIC[2];
  VAR
   Cond: SCAL[2];
 BEGIN
  IF    Sign = "<"  THEN
   Cond:=LExpression < RExpression;
  ELSIF Sign = ">"  THEN
   Cond:=LExpression > RExpression;
  ELSIF Sign = "#"  THEN
   Cond:=LExpression # RExpression;
  ELSIF Sign = "="  THEN
   Cond:=LExpression = RExpression;
  ELSIF Sign = "<=" THEN
   Cond:=LExpression <= RExpression;
  ELSIF Sign = ">=" THEN
   Cond:=LExpression >= RExpression;
  ELSIF Sign = "~!" THEN
   Cond:=~!RExpression;
  ELSE
   L_General.CallUs(0);
  END;

  IF Cond THEN
   RETURN Val;
  ELSE
   RETURN EMPTYOF(NUMERIC[2]);
  END;
 END {ER_᫮E};

 PUBLIC PROCEDURE Func_뢥⨅᫨(Val: STRING[]; Cond: SCAL[2]): STRING[];
 BEGIN
  IF Cond THEN
   IF L_Str.Left(Val, 1) = '"' THEN
    Val:=Str.Delete(Val, 0, 1);
   END;
   IF L_Str.Right(Val, 1) = '"' THEN
    Val:=Str.Delete(Val, Str.Length(Val)-1, 1);
   END;
   RETURN Val;
  ELSE
   RETURN "";
  END;
 END {Func_뢥⨅᫨};

 PRIVATE PROCEDURE GetParam(trgFormula: STRING[]; Nbr: NUMERIC[0]): STRING[];
  VAR
   begPos,
   endPos: NUMERIC[0];
   Result: STRING[];
 BEGIN
  IF    Nbr = 1 THEN
   begPos:=Str.Pos(trgFormula, "(")+1;
   endPos:=Str.Pos(trgFormula, ",");
   IF endPos = Str.Length(trgFormula) THEN
    DEC(endPos);
   END;
  ELSIF Nbr = 2 THEN
   begPos:=Str.Pos(trgFormula, ",")+1;
   endPos:=Str.Length(trgFormula)-1;
  ELSE
   L_General.CallUs(0);
  END;
  Result:=Str.Condense(Str.Slice(trgFormula, begPos, endPos-begPos));
  RETURN Result;
 END {GetParam};

 PRIVATE CONST
  f_ER_㬬              = "ER_㬬";
  f_ER_襍         = "ER_襍(";
  f_ER_襍E        = "ER_襍E(";
  f_ER_᫮E           = "ER_᫮E(";
  f_ER_            = "ER_(";
  f_ER_ᨬ           = "ER_ᨬ(";

  f_Func_뢥⨅᫨ = "Func_뢥⨅᫨(";

 PRIVATE PROCEDURE Calc(_Formula: STRING[];
                        _Table2 : LIKE(ATERAttr.Table);
                        _Row2   : LIKE(ATERAttr.Row)): NUMERIC[2];
  VAR
   Pos           : NUMERIC[0];
   Sign,
   Attr,
   Char,
   Result,
   AttrValue,
   tmpFormula,
   LExpression,
   RExpression   : STRING[];
   ForceEmptyAttr: SCAL[2];
 BEGIN
  IF    Str.Match(_Formula, f_ER_㬬 + "*") THEN
   Result:=_Formula;
  ELSIF Str.Match(_Formula, f_ER_襍 + "*") THEN
   RETURN ER_襍(Calc(GetParam(_Formula, 1), _Table2, _Row2));
  ELSIF Str.Match(_Formula, f_ER_襍E + "*") THEN
   RETURN ER_襍E(Calc(GetParam(_Formula, 1), _Table2, _Row2));
  ELSIF Str.Match(_Formula, f_ER_᫮E + "*") THEN
   Pos       :=Str.Pos(_Formula, ",");
   tmpFormula:=Str.Slice(_Formula, Str.Length(f_ER_᫮E), Pos-Str.Length(f_ER_᫮E));
   SplitCondition(Str.Slice(_Formula, Pos+1, Str.Length(_Formula)), Sign, LExpression, RExpression);
   RETURN ER_᫮E(Calc(tmpFormula, _Table2, _Row2), Calc(LExpression, _Table2, _Row2), Calc(RExpression, _Table2, _Row2), Sign);
  ELSIF Str.Match(_Formula, f_Func_뢥⨅᫨ + "*") THEN
 (* ⨯ ਡ -    塞,  㭪*)
   L_General.CallUs(0);
  ELSIF Str.Match(_Formula, f_ER_ + "*") THEN
   RETURN ER_(Calc(GetParam(_Formula, 1), _Table2, _Row2), Calc(GetParam(_Formula, 2), _Table2, _Row2));
  ELSIF Str.Match(_Formula, f_ER_ᨬ + "*") THEN
   RETURN ER_ᨬ(Calc(GetParam(_Formula, 1), _Table2, _Row2), Calc(GetParam(_Formula, 2), _Table2, _Row2));
  ELSE
   SETEMPTY(Result, Attr);
   Pos           :=0;
   ForceEmptyAttr:=1;

   LOOP
    Char:=L_Str.Char(_Formula, Pos);
    IF ~!Char & ~IsSpecSym(Char) THEN
     Attr:=Attr+Char;
    ELSE
     Attr:=Str.Condense(Attr);
     IF ~!Attr THEN
      IF ~L_Prop.IsNumericValue(Attr, "") THEN
       AttrValue:=Get(Attr, _Table2, _Row2);
       IF !AttrValue THEN
        IF ~ATERAttr.NotEmpty & (ATER.Kind # L_Packet.knd_FSS_Sheet) THEN
         Result:="";
         EXIT;
        END;
        AttrValue:="0";
       ELSE
        ForceEmptyAttr:=0;
       END;
       Result:=Result + "(" + AttrValue + ")";
      ELSE
       Result        :=Result + Attr;
       ForceEmptyAttr:=0;
      END;
      Attr:="";
     END;
     IF !Char THEN
      EXIT;
     ELSE
      Result:=Result+Char;
     END;
    END;
    INC(Pos);
   END; (* LOOP *)
   IF ForceEmptyAttr THEN
    Result:="";
   END;
  END; (* IF Str.Match(_Formula, "ER_㬬*")...*)
 
  IF !Result THEN
   RETURN EMPTYOF(NUMERIC[2]);
  END;

  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   RETURN ^(Result);
  EXCEPT
  ON Exc: Exc_Syntax DO
   L_General.Error("訡  ᫥ ਡ " + ATERAttr.ATERAttr + " '" + ATERAttr.Name + "'");
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = 40 THEN
    RETURN 0;
   ELSE
    RAISE();
   END;
  ELSE
   RAISE();
  END;
 END {Calc};

 PUBLIC PROCEDURE ER_襍E(Val: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF Val >= 0 THEN
   RETURN Val;
  ELSE
   RETURN EMPTYOF(Val);
  END;
 END {ER_襍E};

 PUBLIC PROCEDURE ER_襍(Val: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF    (ATER.Kind = L_Packet.knd_FSS_Sheet) & (!Val | (Val=0) | (Val<0)) THEN
   RETURN EMPTYOF(Val);
  ELSIF Val >= 0 THEN
   RETURN Val;
  ELSE
   RETURN 0;
  END;
 END {ER_襍};

 PRIVATE PROCEDURE ER_(Val1, Val2: NUMERIC[2]): NUMERIC[2];
 BEGIN
  RETURN Math.Min(Val1, Val2);
 END {ER_};

 PRIVATE PROCEDURE ER_ᨬ(Val1, Val2: NUMERIC[2]): NUMERIC[2];
 BEGIN
  RETURN Math.Max(Val1, Val2);
 END {ER_ᨬ};

 PUBLIC PROCEDURE IsEmptyValueForFSS_Sheet(_Value: STRING[]): SCAL[2];
 BEGIN
  RETURN 0 (* !!! *);
 END {IsEmptyValueForFSS_Sheet};

 PUBLIC PROCEDURE GetSingleAttr(_Table2 : LIKE(ATERAttr.Table);
                                _Row2   : LIKE(ATERAttr.Row)): STRING[];
  VAR
   Proc    : PROC;
   _Value,
   ProcName: STRING[];
 BEGIN
  IF    (ATERAttr.Kind = aak_Data) | (ATERAttr.Kind = aak_ManualInput) THEN
   IF IsNormalUpload() THEN
    IF SEARCH(PckATER, Table, Packet.Packet, ATERAttr.Table, _Table2, _Row2, ATERAttr.Row, ATERAttr.ATERAttr) THEN
     IF ATERAttr.NotEmpty THEN
      L_General.Assert(~!PckATER.Value, " '" + L_Str.PoolItem(L_Packet.knd_Pool, Packet.Kind) + "' (" + Packet.Packet + "):||" +
                                        "ਡ " + ATERAttr.ATERAttr + " '" + ATERAttr.Name+ "' (" + _Table2 + ", " + _Row2 + ")|" +
                                        "  ");
     END;
     _Value:=PckATER.Value;
    ELSE
     L_General.Assert(ATERAttr.NotEmpty = 0,
                      " '" + L_Str.PoolItem(L_Packet.knd_Pool, Packet.Kind) + "' (" + Packet.Packet + "):||" +
                      "ਡ " + ATERAttr.ATERAttr + " '" + ATERAttr.Name + "' (" + _Table2 + ", " + _Row2 + ")|" +
                      "  ");
     _Value:="";
    END;
   ELSE
    IF    ATERAttr.Type = L_General.ft_NUMERIC THEN
     _Value:="1";
    ELSIF ATERAttr.Type = L_General.ft_STRING THEN
     _Value:="XXX";
    ELSIF ATERAttr.Type = L_General.ft_DATE THEN
     _Value:=L_DatTim.DateStr(SYSDATE());
    ELSE
     L_General.CallUs(0);
    END;
   END;

   IF !_Value | IsEmptyValueForFSS_Sheet(_Value) THEN
    RETURN _Value;
   ELSE
    RETURN L_Packet.ConvATERAttrValue(_Value);
   END;
  ELSIF ATERAttr.Kind = aak_Function THEN
   IF ~!ATERAttr.Formula THEN
    IF Str.Match(ATERAttr.Formula, f_Func_뢥⨅᫨ + "*") THEN
     RETURN Func_뢥⨅᫨(GetParam(ATERAttr.Formula, 1), ~!Calc(GetParam(ATERAttr.Formula, 2), _Table2, _Row2));
    ELSE
     ProcName:=Str.Delete(ATERAttr.Formula, Str.Length(ATERAttr.Formula)-2, 2);
    END;
   ELSE
    ProcName:=ATERAttr.PublicNm;
   END;
   Proc:=PROCREF((ProcName));
   RETURN Proc();
  ELSIF ATERAttr.Kind = aak_Calculated THEN
   L_General.CallUs(~!ATERAttr.Formula);
   RETURN FLDTOSTR(Calc(ATERAttr.Formula, _Table2, _Row2), L_Packet.GetATERAttrFormat(), 0);
  ELSIF ATERAttr.Kind = aak_NotRequired THEN
   RETURN "";
  ELSIF ATERAttr.Kind = aak_Const THEN
   RETURN L_Packet.ConvATERAttrValue(ATERAttr.Formula);
  ELSE
   L_General.Error(" ਡ " + ATERAttr.ATERAttr + " '" + ATERAttr.Name + "'");
  END;
 END {GetSingleAttr};

 PUBLIC PROCEDURE GetPckATERValue_Str(_Packet: LIKE(Packet.Packet);
                                      _pn    : LIKE(ATERAttr.PublicNm);
                                      _Table2: LIKE(PckATER.Table2)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF ~!_Packet THEN
   SAVE(ATERAttr);
   SAVE(Packet);
   SAVE(PckATER);
   L_General.CallUs(SEARCH(Packet, Packet, _Packet));
   L_General.Assert(L_Packet.AccessATERAttrByPublicName(_pn), "  ਡ " + _pn+"|ଠ  "+Packet.ATER);
   Result:=Str.Condense(GetSingleAttr(_Table2, 0000));
   RESTORE(PckATER);
   RESTORE(Packet);
   RESTORE(ATERAttr);
  END;
  RETURN Result;
 END {GetPckATERValue_Str};

 PUBLIC PROCEDURE extGetNumericValueFromPacket(_Packet   : LIKE(Packet.Packet);
                                               _pn       : LIKE(ATERAttr.PublicNm);
                                               _Table2   : LIKE(PckATER.Table2);
                                               forceEmpty: SCAL[2]): FLOAT;
  VAR
   Result: FLOAT;
 BEGIN
  Result:=STRTOFLD(GetPckATERValue_Str(_Packet, _pn, _Table2), NUMERIC);
  IF ~forceEmpty  & !Result THEN
   SETZERO(Result);
  END;
  RETURN Result;
 END {extGetNumericValueFromPacket};

 PUBLIC PROCEDURE GetNumericValueFromPacket(_Packet: LIKE(Packet.Packet);
                                            _pn    : LIKE(ATERAttr.PublicNm)): FLOAT;
 BEGIN
  RETURN extGetNumericValueFromPacket(_Packet, _pn, 00000, 0);
 END {GetNumericValueFromPacket};

 PRIVATE PROCEDURE intIsAcceptablePacket(curPacket   : LIKE(Packet.Packet);
                                         curMyFirm   : P_Firm.tMyFirm;
                                         curATERKind : LIKE(ATER.Kind);
                                         curPerB,
                                         curPerE     : DATE;
                                         wCheckStatus: SCAL[2]): SCAL[2];
 BEGIN
  RETURN (Packet.Packet # curPacket) &
         (Packet.Kind = curATERKind) &
         (Packet.PerB = curPerB) &
         (Packet.PerE = curPerE) &
         (Packet.DataType = L_Packet.dt_None) &
         SELECT(PckATER, Packet, Packet.Packet) &
         (~wCheckStatus | L_Packet.IsAcceptablePacket());
 END {intIsAcceptablePacket};

 PRIVATE PROCEDURE GetPacketList(    curPacket    : LIKE(Packet.Packet);
                                     curMyFirm    : P_Firm.tMyFirm;
                                     curATERKind  : LIKE(ATER.Kind);
                                     curPerB,
                                     curPerE      : DATE;
                                 VAR PacketList   : STRING[];
                                 VAR extPacketList: STRING[];
                                 VAR Amount       : NUMERIC[0]);
 BEGIN
  APP.Get().NewPrompt(" ⮢");
  SETZERO(Amount);
  SETEMPTY(PacketList, extPacketList);

  TRY [RESTORE_CURSORS(RC_ON)]
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   IF !DATABASE.Get().Tables("_PckLst") THEN
    L_AFM.MakeIndex("_PckLst", "ExtNbr: LIKE(Packet.ExtNbr);" +
                               "Packet: LIKE(Packet.Packet)");
   ELSE
    SETSEL(_PckLst, _PckLst);
    REMSEL(_PckLst);
   END;

   SELECT(Packet, MyFirm, , curMyFirm);
   WHILE OCCURE(Packet) DO
    PROMPT(Packet.Packet);
    IF intIsAcceptablePacket(curPacket, curMyFirm, curATERKind, curPerB, curPerE, 0) THEN
     _PckLst.ExtNbr:=Packet.ExtNbr;
     _PckLst.Packet:=Packet.Packet;
     INSERT(_PckLst);
    END;
    NEXT(Packet);
   END; (* WHILE OCCURE(Packet) ... *)
 
   SETSEL(_PckLst, _PckLst);
   LAST(_PckLst);
   WHILE OCCURE(_PckLst) DO
    SEARCH(Packet, Packet, , _PckLst.Packet);
    extPacketList:=extPacketList + Packet.ExtNbr + "  (" + Packet.Packet + ") ନ஢ " + L_Packet.PacketDTStampStr() + " (" + L_Str.PoolItem(L_Packet.st_Pool, Packet.Status) + ")|";
    PacketList   :=PacketList + Packet.Packet + "|";
    INC(Amount);
    PREV(_PckLst);
   END; (* WHILE OCCURE(_PckLst) ... *)
  EXCEPT
  END; (* TRY *)
 END {GetPacketList};

 PUBLIC PROCEDURE GetPacket(curPacket  : LIKE(Packet.Packet);
                            curMyFirm  : P_Firm.tMyFirm;
                            curATERKind: LIKE(ATER.Kind);
                            curPerB,
                            curPerE    : DATE): LIKE(Packet.Packet);
  VAR
   Msg          : STRING[];
   Result       : LIKE(Packet.Packet);
   i,
   Amount       : NUMERIC[0];
   PacketList,
   extPacketList: STRING[];
 BEGIN
  GetPacketList(curPacket, curMyFirm, curATERKind, curPerB, curPerE, PacketList,  extPacketList, Amount);
  SETEMPTY(Result, Msg);
  IF ~!extPacketList THEN
   extPacketList:=extPacketList + " ᯮ짮   ।騩 ਮ";
   i:=L_StdFrm.ShowListAsMenu(extPacketList, "롮  '" + L_Str.PoolItem(L_Packet.knd_Pool, curATERKind) + "'  ਮ  " + L_DatTim.PeriodStr(curPerB) + "  " + L_DatTim.PeriodStr(curPerE));
   IF i # Amount THEN
    Result:=L_Str.PoolItem(PacketList, i);
   ELSE
    Msg:=" ⮢ ⭮ 㤥 믮  |" +
         " ।騩  ਮ  " + L_DatTim.PeriodStr(curPerB) + "  " + L_DatTim.PeriodStr(curPerE);
   END;
  ELSE
   Msg:=" ⮢ ⭮     |" +
        " ।騩  ਮ  " + L_DatTim.PeriodStr(curPerB) + "  " + L_DatTim.PeriodStr(curPerE) + "|" +
        "   ਮ  묨";
  END;
  IF ~!Msg THEN
   L_StdFrm.Choice(Msg);
  END;
  RETURN Result;
 END {GetPacket};

 PUBLIC PROCEDURE GetAverageCount(BPer, EPer: DATE; trgMyFirm: P_Firm.tMyFirm): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  SETZERO(Result);
  D_Slr.CalcAverageCount(BPer, EPer, trgMyFirm);
  SELECT(AvgCnt, AvgCnt);
  WHILE OCCURE(AvgCnt) DO
   IF (AvgCnt.Type = D_Slr.act_Total) |
      (AvgCnt.Type = D_Slr.act_SpecTax) THEN
    INC(Result, AvgCnt.Count[L_Man.sex_Female] + AvgCnt.Count[L_Man.sex_Male]);
   END;
   NEXT(AvgCnt);
  END; (* WHILE OCCURE(AvgCnt) ... *)
  RETURN Result;
 END {GetAverageCount};

 PUBLIC PROCEDURE IsAcceptableFormatATER(trgATER: LIKE(ATER.ATER)): SCAL[2];
 BEGIN
  RETURN trgATER >= 0027;
 END {IsAcceptableFormatATER};

 PUBLIC PROCEDURE CheckAcceptablePrvPacket(prvPacket           : LIKE(Packet.Packet);
                                           prvBPer             : DATE;
                                           prvEPer             : DATE;
                                           IsFirstQuartalPacket: SCAL[2];
                                           curPacket           : LIKE(Packet.Packet);
                                           curMyFirm           : P_Firm.tMyFirm;
                                           curKind             : LIKE(ATER.Kind));
 BEGIN
  IF ~!prvPacket THEN
   SAVE(Packet);
   L_General.Assert(SEARCH(Packet, Packet, prvPacket), "   " + prvPacket + "  ।騩  ਮ");
   L_General.Assert(intIsAcceptablePacket(curPacket, curMyFirm, curKind, prvBPer, prvEPer, 1) & ~IsFirstQuartalPacket,
                    " " + prvPacket + "  ।騩  ਮ|" +
                    "  室騬   ⥪饣 ");
   RESTORE(Packet);
  END;
 END {CheckAcceptablePrvPacket};

 PUBLIC PROCEDURE GetPrvQuartalPacket(curPacket, prvPacket: LIKE(Packet.Packet)): LIKE(Packet.Packet);
  VAR
   Result                  : LIKE(Packet.Packet);
   prvPerB,
   prvPerE                 : DATE;
   curPacket_ByFirstQuartal: SCAL[2];
 BEGIN
  SAVE(Packet);
  L_Packet.PositionOnPacket(curPacket);
  L_General.Assert(L_DatTim.MONTH(Packet.PerB) = 0, " " + curPacket + ":⭮ ନ ⮫쪮  砫 ");
  curPacket_ByFirstQuartal:=(L_DatTim.QUARTAL(Packet.PerB) = 0) & (L_DatTim.QUARTAL(Packet.PerE) = 0);
  IF    curPacket_ByFirstQuartal THEN
   SETEMPTY(Result, prvPerB, prvPerE);
  ELSE
   prvPerB:=Packet.PerB;
   prvPerE:=L_DatTim.IncMonth(L_DatTim.GetLastDateOfQuartal(Packet.PerE), -3);

   IF !prvPacket THEN
    Result:=GetPacket(Packet.Packet, Packet.MyFirm, Packet.Kind, prvPerB, prvPerE);
   ELSE
    Result:=prvPacket;
   END;
  END;
  CheckAcceptablePrvPacket(Result,
                           prvPerB,
                           prvPerE,
                           curPacket_ByFirstQuartal,
                           Packet.Packet,
                           Packet.MyFirm,
                           Packet.Kind);
  RESTORE(Packet);

  RETURN Result;
 END {GetPrvQuartalPacket};

 PUBLIC PROCEDURE GetPrvYearPacket(curPacket: LIKE(Packet.Packet)): LIKE(Packet.Packet);
  VAR
   Result  : LIKE(Packet.Packet);
   prvYearB,
   prvYearE: DATE;
 BEGIN
  SAVE(Packet);
  L_Packet.PositionOnPacket(curPacket);
  L_General.Assert(L_DatTim.MONTH(Packet.PerB) = 0, " " + curPacket + ":⭮ ନ ⮫쪮  砫 ");

  prvYearB:=PackDATE(01, 00, L_DatTim.YEAR(Packet.PerB)-1);
  prvYearE:=PackDATE(01, 11, L_DatTim.YEAR(Packet.PerB)-1);

  Result:=GetPacket(Packet.Packet, Packet.MyFirm, Packet.Kind, prvYearB, prvYearE);

  CheckAcceptablePrvPacket(Result,
                           prvYearB,
                           prvYearE,
                           0,
                           Packet.Packet,
                           Packet.MyFirm,
                           Packet.Kind);
  RESTORE(Packet);

  RETURN Result;
 END {GetPrvYearPacket};

 PUBLIC PROCEDURE IsRSV_1_Since2014(trgATER: LIKE(ATER.ATER)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF ~!trgATER THEN
   SAVE(ATER);
   SEARCH(ATER, ATER, , trgATER);
   Result:=(ATER.Kind = L_Packet.knd_RSV_1) & (ATER.ATER >= 0047);
   RESTORE(ATER);
  END;
  RETURN Result;
 END {IsRSV_1_Since2014};

END.
