(*
%Copyright   (c) Polak Computer System
%Author      30.06.2000 22:11:02 SAN
%Purpose     ⥪ ࠡ  AvePay
%Type        control
%Specific    SYS
%Modified    07.07.2014 11:45:54 POLAK\GAV
%Environment
*)

 MODULE L_AvePay [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tDaysArr = FLOAT[MAXOF(AveTypeP.DrtnIdx)+1];

 PUBLIC CONST
  st_Prepared  = 0;
  st_Estimated = 1;
  st_Canceled  = 2;

  nn_6Days   = 0; (*AveType.NetNo*)
  nn_Regime  = 1;
  nn_AllDays = 2;
  nn_7Days   = 3;
  nn_Define  = 4;
  nn_Pool = "⨤|䨪| ||।।";

  aveno_Hldy = 0; (*AveType.AveNo*)
  aveno_Sick = 1;
  aveno_Avrg = 2;
  aveno_None = 3;
  aveno_Pool = "|쭨|।|";

  avepass_byDocs  = 0; (*AveType.Pass*)
  avepass_bySheet = 1;

  avelim_None   = 0; (* AveType.LimType *)
  avelim_Hldy   = 1;
  avelim_EdHldy = 2;

  att_Other                = 0; (* AveType.Type *)
  att_Sick                 = 1;
  att_Vacation             = 2;
  att_VacationCompensation = 3;
  att_ParentalLeave        = 4;

  att_Pool = "祥|㤮ᯮᮡ| |  |  室";

  vt_Main     = 0; (*AveTypeP.DrtnIdx*)
  vt_Harm     = 1;
  vt_Stage    = 2;
  vt_LongWD   = 3;
  vt_Other    = 4;
  vt_OverNorm = 7;
  vt_Pool = "᭮|" +
            "⥫ - । ᫮ 㤠|" +
            "⥫ - 뢭 ⠦ ࠡ|" +
            "⥫ - ନ஢ ࠡ稩 |" +
            "⥫ -  稬 ᭮|" +
            " |" +
            " |" +
            "⥫ -  ଠ⨢";

 IMPORT L_Hld, L_EC, L_Str, E_PRoll, L_Sheet, L_DatTim, L_General, DBD,
        L_AFM, L_Man, L_Env, L_Staff, Math, P_Man, L_PRoll, Str, P_AveP;

 PRIVATE VAR
  IsStornoAvePayP: SCAL[2];

 PUBLIC PROCEDURE IsRealAvePay(): SCAL[2];
 BEGIN
  RETURN AvePay.Status # st_Canceled;
 END {IsRealAvePay};

 PUBLIC PROCEDURE SpecialSick(): SCAL[2];
 BEGIN
  RETURN (AvePay.StartD >= 01\01\2007) & (AveType.AveNo = aveno_Sick);
 END {SpecialSick};

 PUBLIC PROCEDURE GetRealNetNo(): LIKE(AveType.NetNo);
 BEGIN
  IF SpecialSick() THEN
   RETURN nn_AllDays;
  ELSIF (AveType.AveNo = aveno_Sick) & (AveType.NetNo = nn_Define) THEN
   RETURN nn_Regime;
  ELSE
   L_General.Assert(AveType.NetNo#nn_Define,
                    "⪠ '।।' ᪠ ⮫쪮  쭨 ⮢." +
                    "| 㬥  ⢨/ -। "+AveType.AveType);
   RETURN AveType.NetNo;
  END;
 END {GetRealNetNo};

 PUBLIC PROCEDURE RegListIsInNet(): SCAL[2];
 BEGIN
  IF    GetRealNetNo() = nn_7Days THEN
   RETURN ~L_Hld.DayIsHoliday(RegList.Period+RegList.Day-1);
  ELSIF GetRealNetNo() = nn_AllDays THEN
   RETURN 1;
  ELSE
   RETURN RegList.Net[GetRealNetNo()];
  END;
 END {RegListIsInNet};

 PUBLIC PROCEDURE GetAvePayStatus_asStr(): STRING[];
 BEGIN
  IF ~!AvePay.Status THEN
   RETURN L_Str.PoolItem("⮢|⠪஢|⬥", AvePay.Status);
  ELSE
   RETURN "";
  END;
 END {GetAvePayStatus_asStr};

 PUBLIC PROCEDURE GetAveTypeNetNo_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(nn_Pool, GetRealNetNo());
 END {GetAveTypeNetNo_asStr};

 PUBLIC PROCEDURE E_IsAcceptableMoneyAsPayFor(): SCAL[2];
 BEGIN
  IF L_EC.ExecE_Func_Scal2(Money.Period,
                           PROCREF(E_PRoll.IsAcceptableMoneyAsPayFor),
                           0) THEN
   RETURN Money.WFPeriod <= Money.Period;
  ELSE
   RETURN 1;
  END;
 END {E_IsAcceptableMoneyAsPayFor};

 PUBLIC PROCEDURE AvePayHasJMode(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(AveTypeP);
  Result:=0;
  SELECT(AveTypeP, AveType, , AvePay.AveType);
  WHILE OCCURE(AveTypeP) & ~Result DO
   IF ~!AveTypeP.JMode THEN
    Result:=1;
   END;
   NEXT(AveTypeP);
  END; (* WHILE OCCURE(AveTypeP) *)
  RESTORE(AveTypeP);
  RETURN Result;
 END {AvePayHasJMode};

 PUBLIC PROCEDURE DaysFormat(): STRING[];
  CONST
   dfFrac = "3.";
   dfInt  = "0";
 BEGIN
  IF ~AvePayHasJMode() & P_AveP.HasActualPro(AvePay.AvePay, P_AveP.P_DaysAmount) THEN
   RETURN dfFrac;
  ELSE
   RETURN dfInt;
  END;
 END {DaysFormat};

 PUBLIC PROCEDURE GetNativeSheetJModeAndAvePay(_TSN: LIKE(Staff.TSN); D: DATE;
                                               VAR trgJMode : LIKE(JMode.JMode);
                                               VAR trgAvePay: LIKE(AvePay.AvePay);
                                                   NeedAvePay: SCAL[2]);
 BEGIN
  IF ~SEARCH(Sheet, TSN, _TSN, L_DatTim.Per(D), L_DatTim.DAY(D)) | L_Sheet.REPCurrentSheetCond() THEN
   SETEMPTY(trgJMode, trgAvePay);
  ELSE
   trgJMode:=Sheet.JMode;
   SETEMPTY(trgAvePay);
   IF Sheet.Source = L_Sheet.src_AvePay THEN
    IF (Sheet.JMode = L_Sheet.jm_HldAvp(D)) | (Sheet.JMode = L_Sheet.jm_Hld(D)) | NeedAvePay THEN
     TRY [RESTORE_CURSORS(RC_ON)]
      SETSEL(AvePay, EBDTSN, Sheet.TSN);
      SRCINSEL(AvePay, GE, , D);
      WHILE OCCURE(AvePay) & ~(IsRealAvePay() & AvePayHasJMode()) DO
       NEXT(AvePay);
      END;
      L_General.Assert(OCCURE(AvePay) & L_DatTim.IsActive_Inc(D, AvePay.StartD, AvePay.StopD),
                       "室   㬥⠬");
      CONFORM(AvePay, AvePayP);
      WHILE ~L_DatTim.IsActive_Inc(D, AvePayP.StartD, AvePayP.StopD) DO
       NEXT(AvePayP);
      END;
      CONFORM(AvePayP, AveTypeP);
      trgJMode :=AveTypeP.JMode;
      trgAvePay:=AvePayP.AvePay;
     EXCEPT
     END; (* TRY *)
    END;
   END;
  END; (* IF ~SEARCH(Sheet... *)
 END {GetNativeSheetJModeAndAvePay};

 PUBLIC PROCEDURE GetNativeSheetJMode(_TSN: LIKE(Staff.TSN); D: DATE): LIKE(JMode.JMode);
  VAR
   Result: LIKE(JMode.JMode);
   Dummy : LIKE(AvePay.AvePay);
 BEGIN
  GetNativeSheetJModeAndAvePay(_TSN, D, Result, Dummy, 0);
  RETURN Result;
 END {GetNativeSheetJMode};

 PUBLIC PROCEDURE GetAvePayStopD(): DATE;
 BEGIN
  IF ~!AvePay.StopD THEN
   RETURN AvePay.StopD;
  ELSE
   RETURN AvePay.StartD+AvePay.Amount-1;
  END;
 END {GetAvePayStopD};

 PUBLIC PROCEDURE SickAvePaySequenceStart(): DATE;
  VAR
   Result: DATE;
 BEGIN
  SAVE(AvePay);
  SAVE(AveType);
  Result:=AvePay.StartD;
  CHANGESEL(AvePay, TSN, , AvePay.TSN);
  WHILE PREV(AvePay) & ((Result - 1 = GetAvePayStopD()) | ~IsRealAvePay()) DO
   CONFORM(AvePay, AveType);
   IF IsRealAvePay() & (AveType.AveNo = aveno_Sick) THEN
    Result:=AvePay.StartD;
   END;
  END;
  RESTORE(AveType);
  RESTORE(AvePay);
  RETURN Result;
 END {SickAvePaySequenceStart};

 PUBLIC PROCEDURE SickAvePayIsSequel(): SCAL[2];
 BEGIN
  RETURN AvePay.StartD > SickAvePaySequenceStart();
 END {SickAvePayIsSequel};

 PRIVATE PROCEDURE Create_StfVD();
 BEGIN
  IF ~DBD.FileExist(StfVD) THEN
   CREATE_TABLE(StfVD);
   CREATE_FIELD(StfVD, Year,     NUMERIC[0]);
   CREATE_FIELD(StfVD, AvePay,   LIKE(AvePay.AvePay));
   CREATE_FIELD(StfVD, AveTypeP, LIKE(AvePayP.AveTypeP));
   CREATE_FIELD(StfVD, AlType,   LIKE(AlType.AlType));
   CREATE_FIELD(StfVD, Plan,     tDaysArr, , "0");
   CREATE_FIELD(StfVD, PlanOnD,  tDaysArr, , "0");
   CREATE_FIELD(StfVD, Fact,     tDaysArr, , "0");
   CREATE_FIELD(StfVD, FactOnD,  tDaysArr, , "0");
   CREATE_FIELD(StfVD, Saldo,    tDaysArr, , "0");
   CREATE_INDEX(StfVD, Year, UNIQUE, , , Year, AvePay, AveTypeP, AlType);
   SET_VERSION_OF_TABLE(StfVD, 0);
   L_AFM.CreateTemp("StfVD");
  ELSE
   SETSEL(StfVD, Year);
   REMSEL(StfVD);
  END;

  IF ~DBD.FileExist(doiiy) THEN
   CREATE_TABLE(doiiy);
   CREATE_FIELD(doiiy, TSN,      LIKE(Staff.TSN));
   CREATE_FIELD(doiiy, year,     NUMERIC[0]);
   CREATE_FIELD(doiiy, fr,       DATE);
   CREATE_FIELD(doiiy, ut,       DATE);
   CREATE_FIELD(doiiy, Days,     NUMERIC[0], , "0");
   CREATE_INDEX(doiiy, TSN, UNIQUE, , , TSN, year, fr, ut);
   SET_VERSION_OF_TABLE(doiiy, 0);
   L_AFM.CreateTemp("doiiy");
  ELSE
   SETSEL(doiiy, TSN);
   REMSEL(doiiy);
  END;
 END {Create_StfVD};

 PRIVATE PROCEDURE JModeNotInStage4Vacation(D: DATE; trgJMode: LIKE(JMode.JMode)): SCAL[2];
 BEGIN
  RETURN (trgJMode = L_Sheet.jm_ParentalLeave) |
         (trgJMode = L_Sheet.jm_ParentalLeaveUntil3Y) |
         (trgJMode = L_Sheet.jm_ContractBreak(D)) |
         (trgJMode = L_Sheet.jm_Truancy);
 END {JModeNotInStage4Vacation};

 PRIVATE PROCEDURE DaysOfIntvlInYear(Beg: DATE; y: NUMERIC[0]; B, T: DATE): NUMERIC[0];
  VAR
   d,
   e,
   yb,
   ye  : DATE;
   days: NUMERIC[0];
 BEGIN
  IF ~SEARCH(doiiy, TSN, Staff.TSN, y, B, T) THEN
   yb:=L_DatTim.IncCalendarMonth(Beg, 12 * y);
   ye:=L_DatTim.IncCalendarMonth(Beg, 12 * (y + 1)) - 1;
   d:=Math.Max(yb, B);
   e:=Math.Min(ye, T);
   SETEMPTY(days);
   IF (yb >= B) & (ye <= T) THEN
    SELECT(doiiy, TSN, , Staff.TSN, y);
    WHILE !days & OCCURE(doiiy) & (doiiy.fr <= d) DO
     NARROWSEL(doiiy, fr);
     IF SRCINSEL(doiiy, GE, e) THEN
      days:=doiiy.Days;
     END; (* IF SRCINSEL(doiiy, GE, e) *)
     NEXTINEXTENDEDSEL(doiiy, fr);
    END; (* WHILE OCCURE(doiiy) *)
   END; (* IF (yb >= B) & (ye <= T) *)
   IF !days THEN
    days:=0;
    WHILE d <= e DO
     IF ~SEARCH(Sheet, TSN, Staff.TSN, L_DatTim.Per(d), L_DatTim.DAY(d)) |
         ~JModeNotInStage4Vacation(d, Sheet.JMode) THEN
      INC(days);
     END;
     INC(d);
    END; (* WHILE d <= e *)
   END; (* IF !days *)
   ADD(doiiy, TSN, , Staff.TSN, y, B, T, doiiy.Days, days);
  END;
  RETURN doiiy.Days;
 END {DaysOfIntvlInYear};

 PRIVATE PROCEDURE intPlan4Intvl(Beg: DATE; y, type: NUMERIC[0]; fr, ut: DATE): FLOAT;
  VAR
   YearDuration: NUMERIC[0];
   Result      : FLOAT;
 BEGIN
  YearDuration:=L_DatTim.IncCalendarMonth(Beg, 12 * (y+1)) - L_DatTim.IncCalendarMonth(Beg, 12 * y);
  Result:=DaysOfIntvlInYear(Beg, y, fr, ut) * AlTypeL.Duration[type] / YearDuration;
  IF type = L_Staff.ati_Main THEN
   SELECT(ManPro, Man, , Staff.Man, P_Man.P_Invalid);
   WHILE OCCURE(ManPro) DO
    INC(Result, DaysOfIntvlInYear(Beg, y, Math.Max(fr, ManPro.Date), Math.Min(ut, ManPro.EndDate)) * 2 / YearDuration);
    NEXT(ManPro);
   END; (* WHILE OCCURE(ManPro) ... *)
  END;
  RETURN Result;
 END {intPlan4Intvl};

 PRIVATE PROCEDURE Plan4Intvl(Beg: DATE; y, type: NUMERIC[0]; fr, ut: DATE): FLOAT;
  VAR
   yBeg  : DATE;
   Result: FLOAT;
 BEGIN
  Result:=0;
  fr:=Math.Max(fr, L_DatTim.IncCalendarMonth(Beg, 12 * y));
  SETSEL(AlTypeL, AlType, AlType.AlType);
  L_General.Assert(SRCINSEL(AlTypeL, LE, fr),
                   "ᮡ ।⠢ ᪮ " + AlType.AlType +
                   "    " + L_DatTim.PeriodStr(fr));
  WHILE OCCURE(AlTypeL) & (AlTypeL.Begin <= ut) DO
   INC(Result, intPlan4Intvl(Beg, y, type,
                             Math.Max(fr, AlTypeL.Begin),
                             Math.Min(ut, L_DatTim.till2ED(AlTypeL.Till))));
   NEXT(AlTypeL);
  END; (* WHILE OCCURE(AlTypeL) ... *)
  RETURN Result;
 END {Plan4Intvl};

 PRIVATE PROCEDURE StaffLogRegimeIsWOVacation(): SCAL[2];
  VAR
   D: DATE;
 BEGIN
  D:=Math.Max(StaffLog.Date, L_Env.aptm_Start);
  RETURN SEARCH(RegList, HumReg, StaffLog.Regime, L_DatTim.Per(D), L_DatTim.DAY(D)) &
         ((RegList.JMode = L_Sheet.jm_ParentalLeave) |
          (RegList.JMode = L_Sheet.jm_ParentalLeaveUntil3Y) |
          (RegList.JMode = L_Sheet.jm_ContractBreak(D)));
 END {StaffLogRegimeIsWOVacation};

 PRIVATE PROCEDURE IsStornRule();
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=Str.Match(MoneyRul.Rule, "*");
  L_General.CallUs(!IsStornoAvePayP | (IsStornoAvePayP = Result));
  IsStornoAvePayP:=Result;
 END {IsStornRule};

 PRIVATE PROCEDURE GetSignAvePayP(): NUMERIC[0];
 BEGIN
  SETEMPTY(IsStornoAvePayP);
  L_PRoll.ExecMethod(AvePay.Period,
                     L_PRoll.GetMethod(AvePay.Period, AveTypeP.MthType),
                     PROCREF(IsStornRule), EMPTYOF(PROC));
  IF ~!IsStornoAvePayP & IsStornoAvePayP THEN
   RETURN -1;
  ELSE
   RETURN +1;
  END;
 END {GetSignAvePayP};

 CONST
  likeZero = 0.0005;

 PRIVATE PROCEDURE AsAvePayPAmount(OnDate: DATE): NUMERIC[0];
 BEGIN
  IF OnDate >= AvePay.StartD THEN
   RETURN AvePayP.Amount;
  ELSE
   RETURN 0;
  END; (* IF OnDate ... *)
 END {AsAvePayPAmount};

 PUBLIC PROCEDURE extFillStaffVacationData(    StartD,
                                               OnDate       : DATE;
                                               Full,
                                               wFullAvPList,
                                               wFutAvP      : SCAL[2];
                                           VAR BaseYear     : NUMERIC[0]): DATE;
  CONST
   IdxAmount = 100;
 VAR
   SLBeg,
   Beg,
   RealBeg         : DATE;
   AvPDays         : FLOAT[IdxAmount+1];
   i,
   AmountOnD,
   Days,
   Rest,
   DaysOnD,
   RestOnD         : NUMERIC[0];
   HasVacation,
   HasPFOutOfRepPer: SCAL[2];
   MaxAmount       : NUMERIC[0];
   totAvPDays      : FLOAT;
   j               : SCAL[L_Staff.ati_Amount];
   oPrompt         : PROMPTLINE;
   totPlan,
   totSaldo        : FLOAT;
   ySaldo          : tDaysArr;
   Sign            : NUMERIC[0];
 BEGIN
  oPrompt:=PROMPTLINE.Create(" ᠫ줮  ᪠");
  StartD:=Math.Max(StartD, L_DatTim.IncYear(L_DatTim.YearBeg(L_Env.aptm_Start), -1));
  IF ~wFullAvPList THEN
   StartD:=Math.Max(StartD, L_DatTim.IncYear(L_DatTim.YearBeg(OnDate), -7));
  END;
  Create_StfVD();
  HasVacation:=0;
  RealBeg    :=L_Man.GetTakeOnDate(OnDate);
  Beg        :=L_DatTim.IncCalendarMonth(RealBeg, 12 * (L_DatTim.YEAR(StartD) - L_DatTim.YEAR(RealBeg)));
  MaxAmount  :=L_DatTim.YEAR(OnDate) - L_DatTim.YEAR(Beg) + 2;
  SLBeg      :=L_Env.aptm_Start;
  SETSEL(AvePay, EBDTSN, Staff.TSN);
  SRCINSEL(AvePay, GE, , Math.Max(StartD, RealBeg));
  WHILE OCCURE(AvePay) DO
   PROMPT(" " + AvePay.AvePay);
   CONFORM(AvePay, AveType);
   IF (AveType.LimType = avelim_Hldy) & IsRealAvePay() & (AvePay.StartD >= RealBeg) THEN
    HasVacation:=1;
    L_Staff.PosToStaffLog(Staff.TSN, AvePay.StartD, 1);
    CONFORM(StaffLog, Officer);
    SETZERO(AvPDays, HasPFOutOfRepPer, totAvPDays);
    IF ~!AvePay.PFTill & ~!AvePay.PFFrom THEN
     SLBeg:=Math.Min(SLBeg, AvePay.PFFrom);
     totAvPDays:=AvePay.PFTill - AvePay.PFFrom;
     IF AvePay.PFFrom < Beg THEN
      HasPFOutOfRepPer:=1;
     END;
     i:=0;
     WHILE i < MaxAmount DO
      AvPDays[i]:=L_DatTim.DATEINT(L_DatTim.IncCalendarMonth(Beg, 12 * i),
                                   L_DatTim.IncCalendarMonth(Beg, 12 * (i+1)) - 1,
                                   AvePay.PFFrom,
                                   AvePay.PFTill - 1);
      INC(i);
     END;
     IF AvePay.PFTill > L_DatTim.IncCalendarMonth(Beg, 12 * i) THEN
      HasPFOutOfRepPer:=1;
     END;
    END;

    SELECT(AvePayP, AvePay, , AvePay.AvePay);
    WHILE OCCURE(AvePayP) DO
     CONFORM(AvePayP, AveTypeP);
     Sign:=GetSignAvePayP();
     L_General.Assert(~!AveTypeP.DrtnIdx,
                      " 㬥  ⢨/ -।: "+AveTypeP.AveType+
                      "|                                           : "+AveTypeP.AveTypeP+
                      "|           ' ᪠'        ");
     AmountOnD:=AsAvePayPAmount(OnDate);
     IF totAvPDays = 0 THEN
      ADD(StfVD, Year, , EMPTYOF(NUMERIC[0]), AvePay.AvePay, AvePayP.AveTypeP, Officer.AlType,
              StfVD.Fact[AveTypeP.DrtnIdx],    Sign * AvePayP.Amount,
              StfVD.FactOnD[AveTypeP.DrtnIdx], Sign * AmountOnD);
     ELSE
      Rest   :=AvePayP.Amount;
      RestOnD:=AmountOnD;
      i:=0;
      WHILE i < MaxAmount DO
       IF AvPDays[i] > 0 THEN
        IF ~HasPFOutOfRepPer & (AvPDays[i+1] = 0) THEN
         Days   :=Rest;
         DaysOnD:=RestOnD;
        ELSE
         Days   :=AvePayP.Amount * AvPDays[i] / totAvPDays;
         DaysOnD:=AmountOnD      * AvPDays[i] / totAvPDays;
        END;
        DEC(Rest,    Days);
        DEC(RestOnD, DaysOnD);
        ADD(StfVD, Year, , L_DatTim.YEAR(StartD) + i, AvePay.AvePay, AvePayP.AveTypeP, Officer.AlType,
                StfVD.Fact[AveTypeP.DrtnIdx],    Sign * Days,
                StfVD.FactOnD[AveTypeP.DrtnIdx], Sign * DaysOnD);
       END; (* IF AvPDays[i] > 0 *)
       INC(i);
      END; (* WHILE i < MaxAmount *)
     END; (* IF totAvPDays = 0 *)
     NEXT(AvePayP);
    END; (* WHILE OCCURE(AvePayP) ... *)
   END; (* IF (AveType.LimType = avelim_Hldy *)
   NEXT(AvePay);
  END; (* WHILE OCCURE(AvePay) ... *)

  SLBeg:=Math.Max(SLBeg, Math.Max(Beg, RealBeg));
  i:=MaxAmount - 1;
  WHILE i >= 0 DO
   SETSEL(StaffLog, TSN, Staff.TSN);
   SRCINSEL(StaffLog, LE, , SLBeg);
   WHILE OCCURE(StaffLog) DO
    PROMPT(L_Str.IntStr(L_DatTim.YEAR(StartD) + i) + ".  " + L_DatTim.DateStr(StaffLog.Date));
    IF ~L_Staff.IsDischargeStaffLog() &
       (DaysOfIntvlInYear(Beg, i, StaffLog.Date, StaffLog.DateE) > 0) &
       ~StaffLogRegimeIsWOVacation() THEN
     CONFORM(StaffLog, Officer);
     CONFORM(Officer, AlType);
     FOR_EACH j DO
      ADD(StfVD, Year, , L_DatTim.YEAR(StartD) + i, EMPTYOF(AvePay.AvePay), EMPTYOF(AvePayP.AveTypeP), Officer.AlType,
              StfVD.Plan[j],    Plan4Intvl(Beg, i, j, StaffLog.Date, StaffLog.DateE),
              StfVD.PlanOnD[j], Plan4Intvl(Beg, i, j, StaffLog.Date, Math.Min(StaffLog.DateE, OnDate-1)));
     END;
    END;
    NEXT(StaffLog);
   END; (* WHILE OCCURE(StaffLog) ... *)

   SETEMPTY(BaseYear);
   SETZERO(ySaldo, totSaldo, totPlan);
   IF SELECT(StfVD, Year, L_DatTim.YEAR(StartD) + i) THEN
    WHILE OCCURE(StfVD) DO
     FOR_EACH j DO
      INC(totPlan,   StfVD.PlanOnD[j]);
      INC(totSaldo,  StfVD.PlanOnD[j]);
      INC(ySaldo[j], StfVD.PlanOnD[j]);
      IF wFutAvP THEN
       DEC(totSaldo,  StfVD.FactOnD[j]);
       DEC(ySaldo[j], StfVD.FactOnD[j]);
      ELSIF ~!StfVD.AvePay & SEARCH(AvePay, AvePay, StfVD.AvePay) & (AvePay.Period < OnDate) THEN
       DEC(totSaldo,  StfVD.Fact[j]);
       DEC(ySaldo[j], StfVD.Fact[j]);
      END;
     END;
     NEXT(StfVD);
    END; (* WHILE OCCURE(StfVD) ... *)
    LAST(StfVD);
    StfVD.Saldo:=ySaldo;
    REPLACE(StfVD);
   END;
   IF (Math.Abs(totSaldo) < likeZero) & (totPlan > 0) THEN
    IF !BaseYear THEN
     BaseYear:=StfVD.Year;
    END;
    IF ~Full THEN
     i:=0;
    END;
   END;
   DEC(i);
  END;
  IF !BaseYear THEN
   BaseYear:=L_DatTim.YEAR(StartD);
  END;
  RETURN SLBeg;
 END {extFillStaffVacationData};

 PUBLIC PROCEDURE FillStaffVacationData(StartD, OnDate: DATE): DATE;
  VAR
   Dummy: NUMERIC[0];
 BEGIN
  RETURN extFillStaffVacationData(StartD, OnDate, 0, 0, 1, Dummy);
 END {FillStaffVacationData};

 PRIVATE PROCEDURE intGetVacationDaysSaldo(    trgTSN  : LIKE(Staff.TSN);
                                               OnDate  : DATE;
                                               wFutAvP : SCAL[2];
                                           VAR BaseYear: NUMERIC[0]): FLOAT;
  VAR
   SLBeg : DATE;
   Saldo,
   yDays : FLOAT;
   i     : SCAL[L_Staff.ati_Amount];
 BEGIN
  L_General.CallUs(OCCURE(Staff) & (Staff.TSN = trgTSN));
  SETZERO(Saldo);
  SLBeg:=extFillStaffVacationData(L_Man.GetTakeOnDate(L_DatTim.MonthEnd(OnDate)), OnDate, 0, 0, wFutAvP, BaseYear);
  SETSEL(StfVD, Year);
  IF SRCINSEL(StfVD, GE, BaseYear) THEN
   WHILE OCCURE(StfVD) DO
    FOR_EACH i DO
     INC(Saldo, StfVD.PlanOnD[i]);
     IF ~!StfVD.AvePay THEN
      L_General.CallUs(SEARCH(AvePay, AvePay, StfVD.AvePay));
      IF wFutAvP THEN
       DEC(Saldo, StfVD.FactOnD[i]);
      ELSIF AvePay.Period < OnDate  THEN
       DEC(Saldo, StfVD.Fact[i]);
      END;
     END;
    END; (* FOR_EACH i *)
    NEXT(StfVD);
   END; (* WHILE OCCURE(File) *)
  END; (* IF SELECT(StfVD, Year) *)
  RETURN Saldo;
 END {intGetVacationDaysSaldo};

 PUBLIC PROCEDURE GetVacationDaysSaldo(trgTSN: LIKE(Staff.TSN); OnDate: DATE): FLOAT;
  VAR
   BaseYear: NUMERIC[0];
 BEGIN
  RETURN intGetVacationDaysSaldo(trgTSN, OnDate, 1, BaseYear);
 END {GetVacationDaysSaldo};

 PUBLIC PROCEDURE extGetVacationDaysAcntSaldo(trgTSN: LIKE(Staff.TSN); P: DATE; VAR BaseYear: NUMERIC[0]): FLOAT;
 BEGIN
  RETURN intGetVacationDaysSaldo(trgTSN, L_DatTim.Per(P), 0, BaseYear);
 END {extGetVacationDaysAcntSaldo};

 PUBLIC PROCEDURE GetVacationDaysAcntSaldo(trgTSN: LIKE(Staff.TSN); P: DATE): FLOAT;
  VAR
   BaseYear: NUMERIC[0];
 BEGIN
  RETURN extGetVacationDaysAcntSaldo(trgTSN, P, BaseYear);
 END {GetVacationDaysAcntSaldo};

 PUBLIC PROCEDURE GetVacationDaysInYearSaldo(trgTSN: LIKE(Staff.TSN); trgYear: NUMERIC[0]): FLOAT;
  VAR
   Beg,
   SLBeg: DATE;
   Saldo: FLOAT;
   i    : SCAL[L_Staff.ati_Amount];
 BEGIN
  L_General.CallUs(OCCURE(Staff) & (Staff.TSN = trgTSN));
  SETZERO(Saldo);
  Beg  :=L_Man.GetTakeOnDate(PackDATE(31, 11, trgYear));
  Beg  :=L_DatTim.IncCalendarMonth(Beg, 12 * (trgYear - L_DatTim.YEAR(Beg)));
  SLBeg:=FillStaffVacationData(Beg, L_DatTim.IncCalendarMonth(Beg, 12));
  SELECT(StfVD, Year, , trgYear);
  WHILE OCCURE(StfVD) DO
   FOR_EACH i DO
    INC(Saldo, StfVD.Plan[i] - StfVD.Fact[i]);
   END;
   NEXT(StfVD);
  END; (* WHILE *)
  RETURN Saldo;
 END {GetVacationDaysInYearSaldo};

 PUBLIC PROCEDURE GetStage4VacationInMonth(trgTSN: LIKE(Staff.TSN); P: DATE): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
   From,
   UpTo,
   PE    : DATE;
 BEGIN
  Result:=0;
  SELECT(StaffLog, TSN, , trgTSN);
  PE:=L_DatTim.MonthEnd(P);
  IF ~SRCINSEL(StaffLog, LE, P) THEN
   FIRST(StaffLog);
  END;
  WHILE OCCURE(StaffLog) & (StaffLog.Date <= PE) DO
   IF ~StaffLogRegimeIsWOVacation() THEN
    From:=Math.Max(P,  StaffLog.Date);
    UpTo:=Math.Min(PE, StaffLog.DateE);
    INC(Result, UpTo - From + 1);
    SETSEL(AvePay, EBDTSN, trgTSN);
    SRCINSEL(AvePay, GE, , From);
    WHILE OCCURE(AvePay) & (AvePay.StartD <= PE) DO
     IF IsRealAvePay() THEN
      CONFORM(AvePay, AvePayP);
      WHILE OCCURE(AvePayP) DO
       CONFORM(AvePayP, AveTypeP);
       IF JModeNotInStage4Vacation(AvePayP.StartD, AveTypeP.JMode) THEN
        DEC(Result, L_DatTim.DATEINT(P, PE, AvePayP.StartD, AvePayP.StopD));
       END;
       NEXT(AvePayP);
      END; (* WHILE OCCURE(AvePayP) ... *)
     END; (* IsRealAvePay()... *)
     NEXT(AvePay);
    END; (* WHILE OCCURE(AvePay) ... *)
   END;
   NEXT(StaffLog);
  END; (* WHILE OCCURE(StaffLog) ... *)
  RETURN Result;
 END {GetStage4VacationInMonth};

END.
