(*
%Copyright   (c) Polak IT
%Author      29.07.2010 12:50:29 POLAK\San
%Purpose       㫨஢ 묨 묨 楤ࠬ
%Type        library
%Specific    SYS
%Modified    16.04.2014 12:52:40 POLAK\San
%Environment
*)

 MODULE L_bp [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tId           = STRING[5];
  tType         = SCAL[7];
  tBP           = SCAL[1E4];
  tRepeat       = SCAL[32];
  tTimeTuning   = SCAL[32];
  tPriorityType = SCAL[5];

 PUBLIC CONST
  t_Process  = 0;
  t_Basis    = 1;
  t_Report   = 2;
  t_RTBasis  = 3;
  t_Prc_wF3  = 4;
  t_Prc_wRp  = 5;
  t_PassOnly = 6;
  t_Pool_Short = "[P]|[E]|[R]|[E]|[R]|[R]|[?]";

  r_None       = 0;
  r_Everyday   = 1;
  r_OnWeekdays = 2;
  r_OnceAWeek  = 3;
  r_Always     = 4;
  r_Pool = "| | ࠡ稩 | ࠧ  |ﭭ";

  tt_None      = 0;
  tt_Yesterday = 1;
  tt_CurMonth  = 2;
  tt_PrevMonth = 3;
  tt_Today     = 4;
  tt_Tomorrow  = 5;

  tt_Pool = "|''|騩 | |''|''";

  s_InQueue        = 0;
  s_Running        = 1;
  s_Done           = 2;
  s_Done_wWarnings = 3;
  s_Fail           = 4;
  s_Pool_Short = " |*| |?|!";

  en_Never  = 0; (* bpRT.EndNtf *)
  en_Error  = 1;
  en_Always = 2;
  en_Pool = "|쪮  訡筮 襭|ᥣ";

  i_BckpS = "BckpS";

  pt_StrictlyInTime = 0; (*priority type*)
  pt_MassCountUp    = 1;
  pt_Usual          = 2;
  pt_Low            = 3;


 IMPORT L_General, Str, L_Basis, L_AcsPnt, L_DatTim, Memo, L_XDoc, Math, L_Str, L_DBD, L_Guard, L_PCS,
        L_StdFrm;

 PRIVATE CONST
   maxSimultaneousReports = 3;

 PRIVATE PERMANENT VAR
  curIdByMenu: tId;

 PRIVATE VAR
  curId    : tId;
  curRI    : LIKE(bpRT.RECORDID);
  curPrompt: PROMPT_LINE;

 PUBLIC PROCEDURE pt_Pool(): STRING[];
 BEGIN
  RETURN "樠 (᫮  㪠 ६)" + "|" +
         "  (믮  ⢥)" + "|" +
         "ଠ ( "+L_Str.IntStr(maxSimultaneousReports)+"  ६)" + "|" +
         " ( । )";
 END {pt_Pool};

 PUBLIC PROCEDURE convTimes(tc: L_General.tTimeCond; VAR cur_cd, cur_fr, cur_ut: DATE);
 BEGIN
  IF    tc = L_General.tc_Entire THEN
   SETEMPTY(cur_cd, cur_fr, cur_ut);
  ELSIF tc = L_General.tc_inIntvl THEN
   SETEMPTY(cur_cd);
  ELSE
   SETEMPTY(cur_fr, cur_ut);
   IF    tc = L_General.tc_onDate     THEN (* nothing *)
   ELSIF tc = L_General.tc_inMonth    THEN cur_cd:=L_DatTim.MonthBeg(cur_cd);
   ELSIF tc = L_General.tc_onMonthBeg THEN cur_cd:=L_DatTim.MonthBeg(cur_cd);
   ELSIF tc = L_General.tc_onMonthEnd THEN cur_cd:=L_DatTim.MonthEnd(cur_cd);
   ELSIF tc = L_General.tc_onYearBeg  THEN cur_cd:=L_DatTim.YearBeg(cur_cd);
   ELSIF tc = L_General.tc_onYearEnd  THEN cur_cd:=L_DatTim.YearEnd(cur_cd);
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {convTimes};

 PUBLIC PROCEDURE convTimeCond2Str(tc: L_General.tTimeCond; cd, fr, ut: DATE): STRING[];
 BEGIN
  convTimes(tc, cd, fr, ut);
  IF !cd&!fr&!ut THEN
   RETURN "  ६";
  ELSE
   IF    tc = L_General.tc_onDate  THEN RETURN L_DatTim.DateStr(cd);
   ELSIF tc = L_General.tc_inMonth THEN RETURN " " + L_DatTim.PeriodStr(cd);
   ELSIF tc = L_General.tc_inIntvl THEN RETURN "c " + L_DatTim.DateStr(fr) + "  " + L_DatTim.DateStr(ut);
   ELSIF tc = L_General.tc_Entire  THEN RETURN "  ६";
   ELSE
    RETURN " " + L_DatTim.DateStr(cd);
   END;
  END;
 END {convTimeCond2Str};

 PRIVATE PROCEDURE Register(curId  : tId;
                            curName: STRING[];
                            t      : tType;
                            tc     : L_General.tTimeCond;
                            pt     : tPriorityType);
 BEGIN
  TRY [TRANSACTION(TRANSACTION_SLAVE)]
   bp.Id       :=curId;
   bp.Name     :=curName;
   bp.Type     :=t;
   bp.TimeCond :=tc;
   bp.Begin    :=SYSDATE();
   bp.ProcName :=RTI.Get().Stack(RTI.Get().Stack.Count-3).Proc.FullName;
   bp.PriorityT:=pt;
   SETEMPTY(bp.bp, bp.Till, bp.AcsPnt);
   INSERT(bp);
  EXCEPT
  END; (* TRY *)
 END {Register};

 PUBLIC PROCEDURE Check_aoAth(cur_aoAth: LIKE(bpRT.aoAth));
 BEGIN
  TRY
   IF cur_aoAth = L_Guard.AcsObjOfGuard() THEN
    L_General.Error("饭 ᯮ짮 짮⥫ " + L_PCS.GuardLoginName() + "  ⢥ 樠 믮 ");
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
 END {Check_aoAth};
 
 PRIVATE PROCEDURE intPutRT(curBegTime : LIKE(bpRT.BegTime);
                            cur_aoExc  : LIKE(bpRT.aoExc);
                            cur_aoAth  : LIKE(bpRT.aoAth);
                            cur_cd,
                            cur_fr,
                            cur_ut     : DATE;
                            curRepeat  : tRepeat;
                            curTimeTune: tTimeTuning;
                            curState   : LIKE(bpRT.State);
                            curEndNtf  : LIKE(bpRT.EndNtf));
 BEGIN
  L_General.CallUs(bp.Type#t_PassOnly);
  Check_aoAth(cur_aoAth);
  convTimes(bp.TimeCond, cur_cd, cur_fr, cur_ut);
  bpRT.bp      :=bp.bp;
  bpRT.BegTime :=curBegTime;
  bpRT.aoExc   :=cur_aoExc;
  bpRT.cd      :=cur_cd;
  bpRT.fr      :=cur_fr;
  bpRT.ut      :=cur_ut;
  bpRT.aoAth   :=cur_aoAth;
  bpRT.Repeat  :=curRepeat;
  bpRT.TimeTune:=curTimeTune;
  bpRT.State   :=curState;
  bpRT.EndNtf  :=curEndNtf;
  SETEMPTY(bpRT.EndTime);
  INSERT(bpRT);
  L_DBD.CheckOwnersValidity("bpRT");
 END {intPutRT};

 PUBLIC PROCEDURE PutRT(cur_cd, cur_fr, cur_ut: DATE; curEndNtf: LIKE(bpRT.EndNtf));
 BEGIN
  intPutRT(SYSTIMESTAMP(), L_General.curUSER, L_General.curUSER, cur_cd, cur_fr, cur_ut, r_None, tt_None, s_Running, curEndNtf);
 END {PutRT};

 PUBLIC PROCEDURE PutQueue(curBegTime: TIMESTAMP; cur_cd, cur_fr, cur_ut: DATE;
                           curRepeat: tRepeat; curTimeTune: tTimeTuning; cur_aoAth: LIKE(bpRT.aoAth);
                           curEndNtf: LIKE(bpRT.EndNtf));
 BEGIN
  intPutRT(curBegTime, EMPTYOF(bpRT.aoExc), cur_aoAth, cur_cd, cur_fr, cur_ut, curRepeat, curTimeTune, s_InQueue, curEndNtf);
 END {PutQueue};

 PUBLIC PROCEDURE bp_AccessByMenu(): SCAL[2];
 BEGIN
  IF VAR_IMPL.Get(curIdByMenu).Initialized & ~!curIdByMenu THEN
   L_General.CallUs(SEARCH(bp, Id, curIdByMenu));
   SETEMPTY(curIdByMenu);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {bp_AccessByMenu};

 TYPE
  tAction        = SCAL[6];

 CONST
  a_Pool         = "10 ᠬ ᢥ ⮢|" +
                   "ୠ 믮      |" +
                   "  ।     |" +
                   "믮              |" +
                   "             |" +
                   "室            |";
  a_bpr_View_bp  = 0;
  a_ShowRT       = 1;
  a_Queue_AddCur = 2;
  a_ExecCurrent  = 3;
  a_ShowAcsPnt   = 4;
  a_EditSource   = 5;

 PRIVATE PROCEDURE AddActionToList(     Action : tAction;
                                    VAR List   : STRING[];
                                    VAR Actions: tAction[];
                                    VAR Cnt    : NUMERIC[0]);
 BEGIN
  INC(List, L_Str.PoolItem(a_Pool, Action) + "|");
  Actions[Cnt]:=Action;
  INC(Cnt);
 END {AddActionToList};

 PRIVATE PROCEDURE Setup();
  VAR
   Actions: tAction[MAXOF(tAction)+1];
   List   : STRING[];
   Cnt,
   Choice : NUMERIC[0];
 BEGIN
  SETEMPTY(List, Actions);
  Cnt:=0;
  IF bp.Type # t_PassOnly THEN
   IF (bp.Type # t_Process) THEN
    AddActionToList(a_bpr_View_bp, List, Actions, Cnt);
   END;
   AddActionToList(a_ShowRT,       List, Actions, Cnt);
   AddActionToList(a_Queue_AddCur, List, Actions, Cnt);
  END;
  AddActionToList(a_ExecCurrent,   List, Actions, Cnt);
  IF L_General.IsAdmin() | L_General.IsProgrammer() THEN
   AddActionToList(a_ShowAcsPnt,   List, Actions, Cnt);
  END;
  IF L_General.IsProgrammer() THEN
   AddActionToList(a_EditSource,   List, Actions, Cnt);
  END;
  Choice:=L_StdFrm.ShowListAsMenu(List, " ⥫쭮   " + bp.Id + " ('" + L_Str.CutLongStr(bp.Name, 32) + "')");
  curIdByMenu:=bp.Id;
  IF    Actions[Choice] = a_bpr_View_bp  THEN LIKEMENU("CALL", "bp.bpr_View_bp()");
  ELSIF Actions[Choice] = a_ShowRT       THEN LIKEMENU("CALL", "bp.ShowRT()");
  ELSIF Actions[Choice] = a_Queue_AddCur THEN LIKEMENU("CALL", "bp.Queue_AddCurrent()");
  ELSIF Actions[Choice] = a_ExecCurrent  THEN LIKEMENU("CALL", "bp.ExecCurrent()");
  ELSIF Actions[Choice] = a_ShowAcsPnt   THEN LIKEMENU("CALL", "bp.ShowAcsPnt()");
  ELSIF Actions[Choice] = a_EditSource   THEN LIKEMENU("CALL", "bp.EditSource()");
  ELSE
   L_General.CallUs(0);
  END;
 END {Setup};

 PUBLIC PROCEDURE MustBeActive(trgD: DATE);
 BEGIN
  L_General.Assert(L_DatTim.IsActive(trgD, bp.Begin, bp.Till), "饭     ਮ ਬ");
 END {MustBeActive};

 PUBLIC PROCEDURE extBegin(Id: tId; Name: STRING[]; t: tType; tc: L_General.tTimeCond; pt: tPriorityType);
 BEGIN
  L_General.CallUs(Str.Length(Id) = Str.MaxLength(Id));

  IF !pt THEN
   IF (t = t_Process) | (t = t_Prc_wF3) | (t = t_Prc_wRp) THEN
    pt:=pt_MassCountUp;
   ELSE
    pt:=pt_Usual;
   END;
  END;

  IF t # t_PassOnly THEN
   L_General.CallUs(!curId);
  END;

  IF ~SEARCH(bp, Id, Id) THEN
   Register(Id, Name, t, tc, pt);
   IF ~SEARCH(bp, Id, Id) THEN
    L_General.CallUs(0);
   END;
  ELSE
   (* 0098789 *)
   IF bp.ProcName = "L_bp.Begin" THEN
    bp.ProcName:=RTI.Get().Stack(RTI.Get().Stack.Count-3).Proc.FullName;
    REPLACE(bp);
   END;
  END;
  MustBeActive(SYSDATE());

  IF RTI.Get().CallBP_wShift THEN
   Setup();
  END;

  IF t # t_PassOnly THEN
   curId:=bp.Id;
   curPrompt:=PROMPT_LINE.Create("(" + bp.Id + ") " + Name);
   SETEMPTY(L_StdFrm.Warnings);
  END;
  IF    bp.Type = t_Basis THEN
   L_Basis.TryExisting(bp.Id, bp.Name, bp.TimeCond);
  ELSIF bp.Type = t_Prc_wF3 THEN
   L_XDoc.sl_Init(bp.Name);
  END;

  IF ~!bp.AcsPnt THEN
   L_AcsPnt.fullPassAccessPoint(bp.AcsPnt, "", "(ன 稩 -  ᯥ樠쭮 ० 믮 㭪 )");
  END;

  IF ~L_General.BatchExecution_IsRunning() & (bp.Type # t_PassOnly) THEN
   PutRT(Memo.ud_cd(), Memo.ud_fr(), Memo.ud_ut(), en_Never);
   RTI.Get().TryBlock.CurTransaction.Description:=Get_bpRT_JobName();
   curRI:=bpRT.RECORDID;
  END;
 END {extBegin};

 PUBLIC PROCEDURE Begin(Id: tId; Name: STRING[]; t: tType; tc: L_General.tTimeCond);
 BEGIN
  extBegin(Id, Name, t, tc, EMPTYOF(tPriorityType));
 END {Begin};

 PUBLIC PROCEDURE oncretizeBPName(Text2Add: STRING[]);
 BEGIN
  L_General.CallUs(VAR_IMPL.Get(curPrompt).Initialized);
  L_General.CallUs(~!curPrompt);
  INC(curPrompt.Title, Text2Add);
 END {oncretizeBPName};

 PUBLIC PROCEDURE Pass(Id: tId; Name: STRING[]);
 BEGIN
  extBegin(Id, Name, t_PassOnly, EMPTYOF(L_General.tTimeCond), pt_Usual);
 END {Pass};

(*६!*)
 PUBLIC PROCEDURE End_wMiltipleRep(ReportList: STRING[]);
 BEGIN
  L_General.CallUs(~!curId);
  L_General.CallUs(SEARCH(bp, Id, curId));
  SETEMPTY(curId);
  IF ~L_General.BatchExecution_IsRunning() THEN
   L_General.CallUs(~!curRI);
   L_General.CallUs(SEARCH(bpRT, RECORDID, curRI));
   L_General.CallUs((bpRT.State = s_Running) & !bpRT.EndTime);
   L_General.CallUs(bpRT.bp = bp.bp);
   bpRT.EndTime:=SYSTIMESTAMP();
   bpRT.State  :=s_Done;
   REPLACE(bpRT);
   SETEMPTY(curRI);

   L_General.CallUs(bp.Type = t_Prc_wRp);
   IF ~!ReportList THEN
    LIKEMENU(^ReportList);
   END;
  END;
 END {End_wMiltipleRep};

 PUBLIC PROCEDURE End();
 BEGIN
  L_General.CallUs(~!curId);
  L_General.CallUs(SEARCH(bp, Id, curId));
  L_General.CallUs(bp.Type # t_PassOnly);
  SETEMPTY(curId);
  IF ~L_General.BatchExecution_IsRunning() THEN
   L_General.CallUs(~!curRI);
   L_General.CallUs(SEARCH(bpRT, RECORDID, curRI));
   L_General.CallUs((bpRT.State = s_Running) & !bpRT.EndTime);
   L_General.CallUs(bpRT.bp = bp.bp);
   bpRT.EndTime:=SYSTIMESTAMP();
   bpRT.State  :=s_Done;
   REPLACE(bpRT);
   SETEMPTY(curRI);
   IF    bp.Type = t_Basis   THEN
    L_Basis.PlayBasis();
   ELSIF bp.Type = t_RTBasis THEN
    L_Basis.ExtPlayMakedRunTimeRep(bp.Id, L_DatTim.SysDateTimeStamp(), bp.TimeCond, bp.Name, 0);
   ELSIF bp.Type = t_Report  THEN
    LIKEMENU(Survey, "");
   ELSIF bp.Type = t_Prc_wF3 THEN
    L_XDoc.sl_Done();
   ELSIF bp.Type = t_Prc_wRp THEN
    LIKEMENU(Survey, ""); 
   END;
  ELSE
   IF    bp.Type = t_Basis   THEN
    L_Basis.PlayBasis();
   END;
  END;
 END {End};

 PUBLIC PROCEDURE getCurId(): tId;
 BEGIN
  RETURN curId;
 END {getCurId};

 PUBLIC PROCEDURE TypeIsAnyProcess(t: tType): SCAL[2];
 BEGIN
  RETURN (t # t_Basis) & (t # t_Report);
 END {TypeIsAnyProcess};

 PUBLIC PROCEDURE mn_CheckNecessity(): STRING[];
 BEGIN
  RETURN bp.ProcName + "_CheckNecessity";
 END {mn_CheckNecessity};

 PUBLIC PROCEDURE mn_ResultPathMask(): STRING[];
 BEGIN
  RETURN bp.ProcName + "_ResultPathMask";
 END {mn_ResultPathMask};

 PRIVATE PROCEDURE RecalculateTimes(    execTime: TIMESTAMP;
                                        tc      : L_General.tTimeCond;
                                        rep     : tRepeat;
                                        tt      : tTimeTuning;
                                    VAR cd,
                                        fr,
                                        ut      : DATE;
                                        wAssert : SCAL[2]);
  VAR
   D: DATE;
 BEGIN
  IF (tt = tt_Yesterday) & (tc # L_General.tc_onDate) & (tc # L_General.tc_inIntvl) THEN
   IF wAssert THEN
    L_General.Error("  楤  믮  ''");
   ELSE
    L_General.CallUs(0);
   END;
  END;

  SETEMPTY(cd, fr, ut);
  IF (tc # L_General.tc_Entire) & (rep # r_Always) THEN
   IF    tt = tt_Yesterday THEN
    D:=L_DatTim.GetDateOfTIMESTAMP(execTime) - 1;
   ELSIF tt = tt_CurMonth THEN
    D:=L_DatTim.MonthBeg(L_DatTim.GetDateOfTIMESTAMP(execTime));
   ELSIF tt = tt_PrevMonth THEN
    D:=L_DatTim.IncMonth(L_DatTim.MonthBeg(L_DatTim.GetDateOfTIMESTAMP(execTime)), -1);
   ELSIF tt = tt_Today THEN
    D:=L_DatTim.GetDateOfTIMESTAMP(execTime);
   ELSIF tt = tt_Tomorrow THEN
    D:=L_DatTim.GetDateOfTIMESTAMP(execTime) + 1;
   ELSE
    L_General.CallUs(0);
   END;
   IF tc # L_General.tc_inIntvl THEN
    cd:=D;
   ELSE
    fr:=D;
    ut:=Math.Min(L_DatTim.MonthEnd(D), L_DatTim.GetDateOfTIMESTAMP(execTime) - 1);
    IF ut < fr THEN
     ut:=fr;
    END;
   END;
  END;
 END {RecalculateTimes};

 PUBLIC PROCEDURE spe_CheckRepeatingCompliance(cd,
                                               fr,
                                               ut      : DATE;
                                               execTime: TIMESTAMP;
                                               rep     : tRepeat;
                                               tt      : tTimeTuning);
  VAR
   new_cd,
   new_fr,
   new_ut     : DATE;
   toCheckOnly: STRING[];
 BEGIN
  IF rep # r_None THEN
   IF rep = r_Always THEN
    TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
     CALL(^(mn_CheckNecessity())(toCheckOnly));
    EXCEPT
    ON Exc:Exc_Root DO
     IF Exc.ErrorCode # 26 (* ᫨誮  ࠬ஢. ..   *)THEN
      L_General.Error("     ᯮ짮  ७ '" + L_Str.PoolItem(r_Pool, r_Always)+"'");
     END;
    END; (* TRY *)
   ELSE
    IF bp.TimeCond # L_General.tc_Entire THEN
     RecalculateTimes(execTime, bp.TimeCond, rep, tt, new_cd, new_fr, new_ut, 1);
     IF ~!cd THEN
      IF cd # new_cd THEN
       L_General.Error(" 㪠  믮 " + L_DatTim.DateStr(L_DatTim.GetDateOfTIMESTAMP(execTime)) +
                       "| ' ' " + L_DatTim.DateStr(new_cd));
      END;
     ELSIF (fr # new_fr) | (ut # new_ut) THEN
      L_General.Error(" 㪠  믮 " + L_DatTim.DateStr(L_DatTim.GetDateOfTIMESTAMP(execTime)) +
                      "| 'ਮ'  " + L_DatTim.DateStr(new_fr) + "  " + L_DatTim.DateStr(new_ut));
     END;
    END; (* IF bp.TimeCond # L_General.tc_Entire *)
   END; (* IF rep = r_Always *)
  END; (* IF rep # r_None *)
 END {spe_CheckRepeatingCompliance};

 PRIVATE PROCEDURE AddRepeatingRT(nextRun: TIMESTAMP);
  VAR
   new_cd,
   new_fr,
   new_ut: DATE;
   D     : DATE;
   T     : TIME;
 BEGIN
  IF (bpRT.Repeat # r_None) THEN
   IF bpRT.Repeat # r_Always THEN
    IF    bpRT.Repeat = r_Everyday   THEN
     nextRun:=bpRT.BegTime + 1;
    ELSIF bpRT.Repeat = r_OnWeekdays THEN
     UnPkTIMESTAMP(bpRT.BegTime, D, T);
     nextRun:=L_DatTim.GetTIMESTAMP(L_DatTim.IncWorkDay(D, +1), T);
    ELSIF bpRT.Repeat = r_OnceAWeek THEN
     nextRun:=bpRT.BegTime + 7;
    ELSE
     L_General.CallUs(0);
    END;
   END;
   RecalculateTimes(nextRun, bp.TimeCond, bpRT.Repeat, bpRT.TimeTune, new_cd, new_fr, new_ut, 0);
   SAVE(bpRT);
   PutQueue(nextRun, new_cd, new_fr, new_ut, bpRT.Repeat, bpRT.TimeTune, bpRT.aoAth, bpRT.EndNtf);
   RESTORE(bpRT);
  END;
 END {AddRepeatingRT};

 PUBLIC PROCEDURE bpRT_IsMyJob(curJob: ASBJOB): SCAL[2];
 BEGIN
  RETURN L_Str.IsStrInStr(curJob.Name, "[" + bpRT.RECORDID + "]");
 END {bpRT_IsMyJob};

 PRIVATE PROCEDURE bpRT_IsAliveRunning(): SCAL[2];
  VAR
   Result: SCAL[2];
   curJob: ASBJOB;
 BEGIN
  Result:=0;
  FOR_EACH curJob IN ASBJOBS.Get() DO
   IF bpRT_IsMyJob(curJob) THEN
    Result:=1;
    EXIT;
   END;
  END; (* FOR_EACH *)
  RETURN Result;
 END {bpRT_IsAliveRunning};

 PRIVATE PROCEDURE DefaultPriority(): tPriorityType;
 BEGIN
  IF (bp.Type = t_Process) | (bp.Type = t_Prc_wF3) | (bp.Type = t_Prc_wRp) THEN
   RETURN pt_MassCountUp;
  ELSE
   RETURN pt_Usual;
  END;
 END {DefaultPriority};

 PRIVATE PROCEDURE bpPriority(): tPriorityType;
 BEGIN
  IF ~!bp.PriorityT THEN
   RETURN bp.PriorityT;
  ELSE
   RETURN DefaultPriority();
  END;
 END {bpPriority};

 PRIVATE PROCEDURE MayRunNow(pt: tPriorityType; runCnt, waitCnt, QueueCnt: NUMERIC[0][]): SCAL[2];
  VAR
   totCnt: NUMERIC[0];
 BEGIN
  totCnt:=runCnt[pt_MassCountUp] + runCnt[pt_Usual] + runCnt[pt_Low];
  IF    pt = pt_StrictlyInTime THEN
   RETURN 1;
  ELSIF pt = pt_MassCountUp THEN
   RETURN totCnt = 0;
  ELSIF pt = pt_Usual THEN
   RETURN (waitCnt[pt_MassCountUp] + runCnt[pt_MassCountUp] = 0) & (totCnt < maxSimultaneousReports);
  ELSIF pt = pt_Low THEN
   RETURN (QueueCnt[pt_MassCountUp] + QueueCnt[pt_Usual] = 0) & (totCnt = 0);
  END;
 END {MayRunNow};

 PRIVATE VAR
  badRunTry_RI   : LIKE(bpRT.RECORDID);
  badRunTry_Count: NUMERIC[0];

 PUBLIC PROCEDURE Get_bpRT_JobName(): STRING[];
 BEGIN
  CONFORM(bpRT, bp);
  RETURN        bp.Id
        + " " + "(" + convTimeCond2Str(bp.TimeCond, bpRT.cd, bpRT.fr, bpRT.ut) + ")"
        + " " + bp.Name
        + " " + "[" + bpRT.RECORDID + "]";
 END {Get_bpRT_JobName};

 PUBLIC PROCEDURE RunQueue();
  CONST
   StdPatienceTimeout = 20*60*60;
  VAR
   runNow         : SCAL[2];
   sysDTS,
   nextRun        : TIMESTAMP;
   RunningSIT,
   newJobName,
   newOnStart     : STRING[];
   cur_bpRT_RI    : LIKE(bpRT.RECORDID);
   zeroCnt,
   runCnt,
   waitCnt,
   QueueCnt       : NUMERIC[0][MAXOF(tPriorityType)+1];
   pt             : tPriorityType;
   round          : SCAL[2];
   PatienceTimeout: FLOAT;
 BEGIN
  PROMPT("ᬮ ।");
  TRY
   sysDTS:=SYSTIMESTAMP();
   SETEMPTY(newJobName, cur_bpRT_RI, RunningSIT);
   SETZERO(zeroCnt, runCnt, waitCnt, QueueCnt);
   TRY [ABORT_AFTER(AA_ON), RESTORE_CURSORS(RC_ON)]
    RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
    SELECT(bpRT, State, , s_Running);
    WHILE OCCURE(bpRT) DO
     IF (bpRT.BegTime >= (sysDTS - 2/24)) | bpRT_IsAliveRunning() THEN
      CONFORM(bpRT, bp);
      INC(runCnt[bpPriority()]);
      IF bpPriority() = pt_StrictlyInTime THEN
       INC(RunningSIT, bp.Id + "|");
      END;
     END;
     NEXT(bpRT);
    END; (* LOOP ... *)
   EXCEPT
   END; (* TRY *)
   FOR_EACH round DO
    TRY [ABORT_AFTER(AA_ON)]
     SELECT(bpRT, State, , s_InQueue);
     WHILE OCCURE(bpRT) DO
      runNow:=0;
      TRY [ABORT_AFTER(AA_ON)]
       CONFORM(bpRT, bp);
       pt:=bpPriority();
       IF bpRT.BegTime <= sysDTS THEN
        IF round = 0 THEN
         INC(QueueCnt[pt], MayRunNow(pt, runCnt, waitCnt, zeroCnt));
        ELSE
         cur_bpRT_RI:=bpRT.RECORDID;
         runNow:=MayRunNow(pt, runCnt, waitCnt, QueueCnt);
         IF runNow THEN
          PatienceTimeout:=StdPatienceTimeout;
          IF    (pt = pt_StrictlyInTime) & ~!L_Str.PositionInPool(RunningSIT, bp.Id) THEN
           runNow:=0;
           CALL(bp.ClearDeads());
          ELSIF bpRT.Repeat = r_Always THEN
           CALL(^(mn_CheckNecessity())(runNow, nextRun));
           IF runNow THEN
            PatienceTimeout:=(nextRun - SYSTIMESTAMP())*24*60*60;
           ELSE
            TRY [TRANSACTION(TRANSACTION_SLAVE)]
             bpRT.BegTime:=nextRun;
             REPLACE(bpRT);
            EXCEPT
            END;
           END; (* IF ~runNow *)
          ELSE
           nextRun:=MINOF(TIMESTAMP);
          END; (* IF bpRT.Repeat = r_Always *)
         ELSE
          INC(waitCnt[pt]);
         END;
         IF runNow THEN
          INC(runCnt[pt]);
          newJobName:=Get_bpRT_JobName();
          newOnStart:="bp.ExecGivenRT(" + bpRT.RECORDID + ")";
          TRY [TRANSACTION(TRANSACTION_SLAVE)]
           AddRepeatingRT(nextRun);
           bpRT.State  :=s_Running;
           bpRT.BegTime:=SYSTIMESTAMP();
           REPLACE(bpRT);
          EXCEPT
          END;
         END;
        END; (* IF round...*)
       END; (* IF IF bpRT.BegTime <= sysDTS  ... *)
      EXCEPT
      END; (* TRY *)
      IF runNow THEN
       SETSEL(bpRT, State, s_InQueue);
      ELSE
       NEXT(bpRT);
      END;
     END; (* WHILE OCCURE(bpRT) ... *)
    EXCEPT
    END; (* TRY *)
   END; (* FOR_EACH round *)
   IF ~!newJobName THEN
    L_Guard.SetNewJob(newJobName, newOnStart, PatienceTimeout, 1);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   IF ~!cur_bpRT_RI THEN
    IF (cur_bpRT_RI # badRunTry_RI) THEN
     badRunTry_RI   :=cur_bpRT_RI;
     badRunTry_Count:=0;
    END;
    INC(badRunTry_Count);
    IF badRunTry_Count >= 3 THEN
     TRY [TRANSACTION(TRANSACTION_SLAVE)]
      SEARCH(bpRT, RECORDID, , badRunTry_RI);
      bpRT.BegTime:=SYSTIMESTAMP() + 1/24;
      REPLACE(bpRT);
      badRunTry_RI:=0;
     EXCEPT
     END;
    END;
   END;
   RAISE();
  END; (* TRY *)
 END {RunQueue};

 PUBLIC PROCEDURE IAmInQueue(): SCAL[2];
 BEGIN
  IF ~!APP.Get().MyConnection.Job THEN
   L_General.CallUs(ACCESS(bpRT));
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {IAmInQueue};

 PUBLIC PROCEDURE GetLastSelfExecutionTime(): TIMESTAMP;
  VAR
   Result: TIMESTAMP;
 BEGIN
  Result:=MINOF(TIMESTAMP);
  TRY [ABORT_AFTER(AA_ON)]
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   L_General.CallUs(ACCESS(bpRT));
   IF CHANGESEL(bpRT, bp, bpRT.bp) & LAST(bpRT) THEN
    LOOP
     IF ~OCCURE(bpRT) THEN
      EXIT;
     ELSIF ~!bpRT.EndTime THEN
      Result:=bpRT.BegTime;
      EXIT;
     END;
     PREV(bpRT);
    END; (* LOOP *)
   END; (* IF CHANGESEL ... *)
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetLastSelfExecutionTime};

BEGIN
 SETEMPTY(curId);
 badRunTry_RI:=0;
END.
