(*
%Copyright   (c) Polak IT
%Author      27.01.2003 13:31:33 POLAK\LDA
%Purpose     ⥪ ࠡ  - (ଠ 1, ⮁ )
%Type        library
%Specific    SYS
%Modified    01.09.2014 17:13:50 POLAK\GAV
%Environment
*)

 MODULE L_CB [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT FIO, L_General, L_DatTim, P_Firm, E_PDoc, L_Str, Str, L_PDoc, L_Acnt,
        L_ExtAb, L_AFM, L_StdFrm, L_Prop, L_Pmnt, P_PDoc, L_Events, L_Dest,
        L_OwnData, L_XDoc, L_DFS, L_PCS, L_FIO, L_MDoc, L_Money, Math, L_XObj,
        L_AcsPnt;

 PUBLIC CONST
  cua_No      = 0;
  cua_Yes     = 1;
  cua_Unknown = 2;

  d_Upload   = 0;
  d_Download = 1;

 PRIVATE CONST
  Payer     = 0;
  Recipient = 1;

  dlr_Pool = "P|I";

  dlr_Proceed = 0;
  dlr_Insert  = 1;

  dlsi_FileName       = 0;
  dlsi_DownloadResult = 1;
  dlsi_PrvPDocDate    = 2;
  dlsi_TimeStamp      = 3;
  dlsi_Login          = 4;
  dlsi_Firm           = 5;
  dlsi_Version        = 6;

  f_Upload            = 0;
  f_FailedImportInCB  = 1;
  f_SuccessImportInCB = 2;

  dsv_1           = "1.0";
  TIMESTAMPFormat = ".7yNDHMS";

  MaxErrorLineLength = 108;

 PRIVATE VAR
  uf_Name     : STRING[];
  uf_TimeStamp: TIMESTAMP;

 PRIVATE PROCEDURE E_GetReceiverName(D: DATE; _CB: NUMERIC[0]): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PDoc.GetReceiverName);
  IF ~!Local THEN
   RETURN Local(D, _CB);
  ELSE
   RETURN "";
  END;
 END {E_GetReceiverName};

 PRIVATE PROCEDURE E_UploadSinglePDocInSingleFile(_CB: NUMERIC[0]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PDoc.UploadSinglePDocInSingleFile);
  IF ~!Local THEN
   RETURN Local(_CB);
  ELSE
   RETURN 1;
  END;
 END {E_UploadSinglePDocInSingleFile};

 PUBLIC PROCEDURE CB_GetTEDParamsForViewDownloadFile(_CB: NUMERIC[0]): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PDoc.GetTEDParamsForViewDownloadFile);
  IF ~!Local THEN
   RETURN Local(_CB);
  ELSE
   RETURN "";
  END;
 END {CB_GetTEDParamsForViewDownloadFile};

 PRIVATE PROCEDURE E_CB_ConvertINN(trgCB: NUMERIC[0]; trgINN: STRING[]; trgDir: NUMERIC[0]): STRING[];
  VAR
   Local: PROC;
 BEGIN
  IF (trgDir = d_Download) & L_Str.TestStrAlowChar(trgINN, "00") THEN
   trgINN:="";
  END;
  Local:=PROCREF(E_PDoc.CB_ConvertINN);
  IF ~!Local THEN
   RETURN Local(trgCB, trgINN, trgDir);
  ELSE
   RETURN trgINN;
  END;
 END {E_CB_ConvertINN};

 PRIVATE PROCEDURE E_CB_UploadArchiveFullFileName(_CB: NUMERIC[0]; FileName: STRING[]): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PDoc.ClientBankUploadArchivePath);
  IF ~!Local THEN
   RETURN L_FIO.GetUniqueFileNameInFolder(FileName, FIO.FullPath(Local(_CB)));
  ELSE
   RETURN "";
  END;
 END {E_CB_UploadArchiveFullFileName};

 PRIVATE PROCEDURE E_CB_FailedImportInCBPath(_CB: NUMERIC[0]): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PDoc.ClientBankFailedImportInCBPath);
  IF ~!Local THEN
   RETURN Local(_CB);
  ELSE
   RETURN "";
  END;
 END {E_CB_FailedImportInCBPath};

 PRIVATE PROCEDURE E_CB_SuccessImportInCBPath(_CB: NUMERIC[0]): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PDoc.ClientBankSuccessImportInCBPath);
  IF ~!Local THEN
   RETURN Local(_CB);
  ELSE
   RETURN "";
  END;
 END {E_CB_SuccessImportInCBPath};

 PRIVATE PROCEDURE E_CB_DownloadPath(_CB: NUMERIC[0]): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PDoc.ClientBankDownloadPath);
  IF ~!Local THEN
   RETURN Local(_CB);
  ELSE
   RETURN "";
  END;
 END {E_CB_DownloadPath};

 PRIVATE PROCEDURE E_CB_DownloadArchivePath(_CB: NUMERIC[0]): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PDoc.ClientBankDownloadArchivePath);
  IF ~!Local THEN
   RETURN Local(_CB);
  ELSE
   RETURN "";
  END;
 END {E_CB_DownloadArchivePath};

 PRIVATE PROCEDURE GetDownloadArchiveFullFileName(_CB: NUMERIC[0]; FileName: STRING[]): STRING[];
  VAR
   DownloadArchiveFolder,
   DownloadArchiveFullFileName: STRING[];
 BEGIN
  DownloadArchiveFolder:=E_CB_DownloadArchivePath(_CB);
  L_General.Assert(~!DownloadArchiveFolder, " । ⠫  娢 믨᮪");
  DownloadArchiveFullFileName :=FIO.FullPath(FIO.BuildPath(FileName, , DownloadArchiveFolder));
  L_General.Assert(FIO.Exists(DownloadArchiveFullFileName), "  䠩 믨᪨|" + DownloadArchiveFullFileName);
  RETURN DownloadArchiveFullFileName
 END {GetDownloadArchiveFullFileName};

 PUBLIC PROCEDURE CB_ViewDownloadSrcFile(_CB: NUMERIC[0]; FileNameItemInStamp: NUMERIC[0]): STRING[];
  VAR
   dl_Stamp,
   dl_SrcFile,
   dl_SrcFileFolder,
   dl_SrcFullFileName: STRING[];
 BEGIN
  dl_Stamp:=P_PDoc.GetPDocProStrong(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_CBDlStamp);
  L_General.Assert(~!dl_Stamp, "  믮  㬥⮢, ਭ  '-'");

  dl_SrcFile:=Str.Item(dl_Stamp, ";", FileNameItemInStamp);
  L_General.Assert(~!dl_SrcFile, " ⠬ 㧪 믨᪨    䠩 믨᪨");
  dl_SrcFileFolder:=E_CB_DownloadArchivePath(_CB);
  IF ~!dl_SrcFileFolder THEN
   dl_SrcFullFileName:=GetDownloadArchiveFullFileName(_CB, dl_SrcFile);
  ELSE
   dl_SrcFileFolder:=E_CB_DownloadPath(_CB);
   L_General.CallUs(~!dl_SrcFileFolder);
   dl_SrcFullFileName:=FIO.FullPath(FIO.BuildPath(dl_SrcFile, , dl_SrcFileFolder));
  END;
  L_General.Assert(FIO.Exists(dl_SrcFullFileName), "  䠩 믨᪨|" + dl_SrcFullFileName);
  RETURN dl_SrcFullFileName;
 END {CB_ViewDownloadSrcFile};

 PRIVATE PROCEDURE E_NormalFirmAcntWork(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PDoc.NormalFirmAcntWork);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 0;
  END;
 END {E_NormalFirmAcntWork};

 PRIVATE PROCEDURE _PutField(Attr: STRING[]);
 BEGIN
  FIO.WrStr(CDoc, Attr);
  FIO.WrLn(CDoc);
 END {PutField};

 PRIVATE PROCEDURE PutField(Name, Value: STRING[]);
 BEGIN
  _PutField(Name + "=" + Value);
 END {PutField};

 PRIVATE PROCEDURE f1c_ConvertIllegalChars(Text: STRING[]): STRING[];
 BEGIN
  Text := Str.Replace(Text, '', '');
  Text := Str.Replace(Text, '', '');
  Text := Str.Replace(Text, '', 'N');
  RETURN Text;
 END {f1c_ConvertIllegalChars};

 PRIVATE PROCEDURE f1c_ExpFirmData(_CB: NUMERIC[0]; Who: SCAL[2]);
  CONST
   MaxFirmNameLength = 300;
  VAR
   _Acnt  : STRING[][2];
   _BIC,
   _INN,
   _KPP,
   _Name,
   _Bank : STRING[];
 BEGIN
  IF Who = Payer THEN
   P_Firm.AccessOwnFirm(PDoc.MyFirm);
   P_Firm.CheckFirmAcnt(PDoc.Date, Firm.Firm, PDoc.OwnAcnt);
  ELSE
   CONFORM(PDoc, Firm);
   P_Firm.CheckFirmAcnt(PDoc.Date, Firm.Firm, PDoc.FirmAcnt);
  END;
  P_Firm.GetFirmData(PDoc.Date, _Name, _Bank, _Acnt, _BIC, _INN, 0);
  _Name:=f1c_ConvertIllegalChars(Str.Slice(_Name, 0, MaxFirmNameLength));
  PutField(L_Str.PoolItem("⥫騪|⥫", Who), _Acnt[P_Firm.fa_AcntInAcnt]);
  IF !_INN THEN
   IF P_Firm.FP_PrtnrTyp(Firm.Firm, PDoc.Date) = P_Firm.pt_Man THEN
    _INN:=E_CB_ConvertINN(_CB, _INN, d_Upload);
   ELSE
    L_General.Error(" 㪠  ࠣ " + Firm.Firm);
   END;
  END;
  PutField(L_Str.PoolItem("⥫騪|⥫숍",   Who), _INN);
  SETEMPTY(_KPP);
  IF (Who = Payer) | L_PDoc.PDocMustHaveKPP() THEN
   IF Who = Payer THEN
    _KPP:=L_PDoc.GetPDocOwnFirmKPP();
   ELSE
    _KPP:=P_Firm.FP_KPP(Firm.Firm, PDoc.Date);
   END;
   PutField(L_Str.PoolItem("⥫騪|⥫슏",   Who), _KPP);
  END;
  PutField(L_Str.PoolItem("⥫騪|⥫",   Who),               _Name);
  PutField(L_Str.PoolItem("⥫騪1|⥫1", Who),               _Name);
  PutField(L_Str.PoolItem("⥫騪|⥫쐠", Who), _Acnt[P_Firm.fa_AcntInAcnt]);
  PutField(L_Str.PoolItem("⥫騪1|⥫쁠1", Who),       _Bank);
  PutField(L_Str.PoolItem("⥫騪2|⥫쁠2", Who),       "");
  PutField(L_Str.PoolItem("⥫騪|⥫쁈", Who),           _BIC);
  PutField(L_Str.PoolItem("⥫騪|⥫슮", Who),   _Acnt[P_Firm.fa_AcntInBankAcnt]);
 END {f1c_ExpFirmData};

 PRIVATE PROCEDURE GetTemporaryUploadFullFileName(_CB: NUMERIC[0]): STRING[];
 BEGIN
  RETURN FIO.FullPath(FIO.BuildPath(uf_Name, , "TMP"));
 END {GetTemporaryUploadFullFileName};

 PRIVATE PROCEDURE SetFileTime(FullFileName: STRING[]);
 BEGIN
  FIO.Open(CDoc, FullFileName, , Output);
  FIO.SetFileTime(CDoc, , , uf_TimeStamp);
  FIO.Close(CDoc);
 END {SetFileTime};

 PRIVATE PROCEDURE f1c_BeginUpload(_CB: NUMERIC[0]);
  VAR
   UploadPath,
   tmpFullFileName: STRING[];
 BEGIN
  UploadPath:=E_PDoc.ClientBankUploadPath(_CB);
  L_General.Assert(~!UploadPath, " । ⠫ । 㬥⮢  -");
  L_General.Assert(FIO.DirExists(UploadPath), "⠫ । 㬥⮢  -||" +
                                               UploadPath + "||" +
                                               " ");
  IF E_UploadSinglePDocInSingleFile(_CB) THEN
   uf_Name        :=L_XDoc.XDocId(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc) + ".txt";
  ELSE
   uf_Name        :=L_DatTim.SysDateTimeStamp() + ".txt";
  END;
  tmpFullFileName:=GetTemporaryUploadFullFileName(_CB);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   FIO.Close(CDoc);
  EXCEPT
  ELSE
  END; (* TRY *)
  FIO.Open(CDoc, tmpFullFileName, "", Create);
  FIO.SetCP(CDoc, FIO.CP_WindowsRussian);

  IF L_General.IsAcceptableProcessorVersion(014124010) THEN
   uf_TimeStamp   :=SYSTIMESTAMP(1);
  ELSE
   uf_TimeStamp   :=L_FIO.GetFileLastModifiedDTS(tmpFullFileName);
  END;

  _PutField("1CClientBankExchange");
  PutField("ଠ",  "1.02");
  PutField("஢",      "Windows");
  PutField("ࠢ⥫",    " ⮏");
  PutField("⥫",     E_GetReceiverName(SYSDATE(), _CB));
  PutField("⠑",   L_DatTim.DateStr(SYSDATE()));
  PutField("६",  L_DatTim.FullSystimeStr());
 END {f1c_BeginUpload};

 PRIVATE PROCEDURE f1c_EndUpload(_CB: NUMERIC[0]);
  VAR
   dstFullFileName,
   tmpFullFileName,
   ArchiveUploadFullFileName: STRING[];
 BEGIN
  _PutField("攠");
  FIO.Close(CDoc);

  tmpFullFileName          :=GetTemporaryUploadFullFileName(_CB);
  ArchiveUploadFullFileName:=E_CB_UploadArchiveFullFileName(_CB, uf_Name);
  IF ~!ArchiveUploadFullFileName THEN
   L_FIO.ExactFileCopy(tmpFullFileName, ArchiveUploadFullFileName);
   SetFileTime(ArchiveUploadFullFileName);
  END;
  dstFullFileName:=FIO.BuildPath(uf_Name, , E_PDoc.ClientBankUploadPath(_CB));
  FIO.RenMov(tmpFullFileName, , dstFullFileName);
  SetFileTime(dstFullFileName);
 END {f1c_EndUpload};

 PUBLIC PROCEDURE f1c_OpenPacket(_CB: NUMERIC[0]): STRING[];
 BEGIN
  IF ~E_UploadSinglePDocInSingleFile(_CB) THEN
   f1c_BeginUpload(_CB);
  END;
  RETURN "";
 END {f1c_OpenPacket};

 PUBLIC PROCEDURE f1c_ClosePacket(_CB: NUMERIC[0]): STRING[];
 BEGIN
  IF ~E_UploadSinglePDocInSingleFile(_CB) THEN
   f1c_EndUpload(_CB);
  END;
  RETURN "";
 END {f1c_ClosePacket};

 PUBLIC PROCEDURE f1c_UploadPDoc(_CB: NUMERIC[0]): STRING[];
  VAR
   i       : NUMERIC[0];
   Rest,
   curCode,
   _KBK,
   _Type,
   _About,
   _OKTMO,
   _Former,
   _Reason,
   _Period,
   _DocNbr,
   _DocDate: STRING[];
   ArrAbout: STRING[][4];
 BEGIN
  L_General.Assert(ACCESS(PDoc), " ⠭ ⥪騩 ⥦ 㬥");

  IF E_UploadSinglePDocInSingleFile(_CB) THEN
   f1c_BeginUpload(_CB);
  END;

  PutField("⠍砫",     L_DatTim.DateStr(PDoc.PrpDate));
  PutField("⠊",      L_DatTim.DateStr(PDoc.PrpDate));
  SEARCH(FirmAcnt, Firm, ,   L_PDoc.GetPDocOwnFirm(), PDoc.OwnAcnt);
  PutField("",       FirmAcnt.AcntA);
  PutField("㬥",       "⥦ 祭");
  PutField("㬥", "⥦ 祭");
  PutField("",          PDoc.SrcNbr);
  PutField("",           L_DatTim.DateStr(PDoc.PrpDate));
  PutField("㬬",          FLDTOSTR(PDoc.Total, "2."));
  f1c_ExpFirmData(_CB, Payer);
  f1c_ExpFirmData(_CB, Recipient);
  PutField("⥦", L_Str.PoolItem("⮩|䮬|஭| ", PDoc.PmntKind));
  PutField("",  "01");
  L_ExtAb.SliceExtAbout(PDoc.ExtAbout, _Former, _KBK, _OKTMO, _Reason, _Period, _DocNbr, _DocDate, _Type, curCode);
  PutField("",                  curCode);
  PutField("ᑮ⠢⥫",   _Former);
  PutField("⥫슁",       _KBK);
  PutField("",               _OKTMO);
  PutField("⥫᭮", _Reason);
  PutField("⥫쏥ਮ",   _Period);
  PutField("⥫썮",    _DocNbr);
  PutField("⥫선",      _DocDate);
  PutField("⥫쒨",      _Type);
  IF PDoc.Date # PDoc.PrpDate THEN
   PutField("ப⥦",        L_DatTim.DateStr(PDoc.Date));
  END;
  PutField("।",         PDoc.Queue);
  _About:=f1c_ConvertIllegalChars(L_PDoc.GetFullPDocAbout());
  PutField("祭⥦", _About);
  Str.Format(ArrAbout,
             _About,
             Str.Length(_About) DIV HIGH(ArrAbout),
             LEFT,
             Rest);
  ArrAbout[3]:=Str.Condense(ArrAbout[3] + " " + Rest);
  i:=0;
  WHILE i <= HIGH(ArrAbout) DO
   PutField("祭⥦" + L_Str.IntStr(i+1), ArrAbout[i]);
   INC(i);
  END; (* WHILE i <= HIGH(ArrAbout)...*)
  _PutField("愮㬥");

  IF E_UploadSinglePDocInSingleFile(_CB) THEN
   f1c_EndUpload(_CB);
  END;

  L_PDoc.CB_PutStamp(PDoc.PDocKind, PDoc.PDoc,
                     uf_Name                                 + ";" +
                     FLDTOSTR(uf_TimeStamp, TIMESTAMPFormat) + ";" +
                     LOGINNAME());
  RETURN "";
 END {f1c_UploadPDoc};

 PRIVATE PROCEDURE intCheckCancelUploadAllowed(cua: SCAL[3]; Text: STRING[]);
 BEGIN
  IF    cua = cua_Yes THEN
   (* 祣   *)
  ELSIF (cua = cua_No) | (cua = cua_Unknown) THEN
   IF !Text THEN
    Text:="⬥ । 㦥  - ⥦ 㬥 饭";
   END;
   L_AcsPnt.PassAccessPoint_wExplanation(0000045, Text);
  END;
 END {intCheckCancelUploadAllowed};

 PUBLIC PROCEDURE CheckCancelUploadAllowed(cua: SCAL[3]);
 BEGIN
  intCheckCancelUploadAllowed(cua, "");
 END {CheckCancelUploadAllowed};

 PRIVATE PROCEDURE GetCancelUploadParams(_CB, FolderId: NUMERIC[0];
                                         VAR cua: NUMERIC[0];
                                         VAR OutFileFolder: STRING[]);
 BEGIN
  SETEMPTY(OutFileFolder);
  IF    FolderId = f_SuccessImportInCB THEN
   cua          :=cua_No;
   OutFileFolder:=E_CB_SuccessImportInCBPath(_CB);
  ELSIF FolderId = f_FailedImportInCB THEN
   cua          :=cua_Yes;
   OutFileFolder:=E_CB_FailedImportInCBPath(_CB);
  ELSIF FolderId = f_Upload THEN
   cua          :=cua_Yes;
   OutFileFolder:=E_PDoc.ClientBankUploadPath(_CB);
  END;
 END {GetCancelUploadParams};

 PRIVATE PROCEDURE TryCancelUpload(_CB,
                                   FolderId               : NUMERIC[0];
                                   OutFileName            : STRING[];
                                   LastModifiedDTS        : STRING[];
                                   VAR AlreadyCancelUpload: SCAL[2]);
  VAR
   cua                : NUMERIC[0];
   Text,
   OutFileFolder,
   OutFileFullName    : STRING[];
   MayCancelUpload    : SCAL[2];
   IsEqualStamp       : SCAL[2];
   UTCUploadStamp,
   UTCFileLastModified: TIMESTAMP;
 BEGIN
  GetCancelUploadParams(_CB, FolderId, cua, OutFileFolder);
  IF ~!OutFileFolder THEN
   OutFileFullName:=FIO.FullPath(FIO.BuildPath(OutFileName, , OutFileFolder));
   MayCancelUpload:=0;
   SETEMPTY(Text);
   IF FIO.Exists(OutFileFullName) THEN
    IF FolderId = f_SuccessImportInCB THEN
     cua:=cua_No;
     IF Str.Length(LastModifiedDTS) = 14 THEN
      IsEqualStamp:=FLDTOSTR(L_FIO.GetFileLastModifiedDTS(OutFileFullName), "YMDHMS") = LastModifiedDTS;
     ELSE
      UTCUploadStamp     :=LOCALTOUNIVERSALTIMESTAMP(STRTOFLD(LastModifiedDTS, TIMESTAMP, TIMESTAMPFormat), 1);
      UTCFileLastModified:=L_FIO.GetUTCFileLastModifiedDTS(OutFileFullName);
      IsEqualStamp:=Math.Abs(UTCFileLastModified - UTCUploadStamp) < 1/24/60/60;
     END;
     IF ~IsEqualStamp THEN
      Text:=" ᮢ ⠬  ।  -  ਭ⮬ - 䠩";
     END;
    END;
    MayCancelUpload:=1;
   ELSE
    IF (FolderId = f_Upload) & ~AlreadyCancelUpload THEN
     IF FIO.Exists(OutFileFullName) THEN
      cua:=cua_Yes;
     ELSE
      cua:=cua_No;
     END;
     MayCancelUpload:=1;
    END;
   END;
   IF MayCancelUpload & ~AlreadyCancelUpload THEN
    intCheckCancelUploadAllowed(cua, Text);
    L_PDoc.CB_ClearStamp(PDoc.PDocKind, PDoc.PDoc);
    AlreadyCancelUpload:=1;
    FIO.Erase(OutFileFullName);
   END;
  END;
 END {TryCancelUpload};

 PUBLIC PROCEDURE CancelUpload_SinglePDoc(_CB: NUMERIC[0]): STRING[];
  VAR
   _Stamp,
   OutFile,
   OutFileDTS         : STRING[];
   AlreadyCancelUpload: SCAL[2];
 BEGIN
  L_General.Assert(E_UploadSinglePDocInSingleFile(_CB), "⬥ । 㬥  ⠭ ० ।| -     䠩 ");
  L_General.Assert(ACCESS(PDoc), " ⠭ ⥪騩 ⥦ 㬥");
  _Stamp:=L_PDoc.CB_GetStamp(PDoc.PDocKind, PDoc.PDoc);
  L_StdFrm.Question("⬥ ।  - : " + L_PDoc.CB_GetClientBankName(_CB) +
                    "| |" + "⠬ ।: " + _Stamp);
  OutFile            :=Str.Item(_Stamp, ";", 0);
  OutFileDTS         :=Str.Item(_Stamp, ";", 1);
  AlreadyCancelUpload:=0;
  TryCancelUpload(_CB, f_SuccessImportInCB, OutFile, OutFileDTS, AlreadyCancelUpload);
  TryCancelUpload(_CB, f_FailedImportInCB,  OutFile, OutFileDTS, AlreadyCancelUpload);
  TryCancelUpload(_CB, f_Upload,            OutFile, OutFileDTS, AlreadyCancelUpload);

  RETURN "";
 END {CancelUpload_SinglePDoc};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                             ⮪ 㧪 믨᮪  ᪨ ⮢                                  |
}
*)

(*
$P{ Top1:
@
|------------------------------------------------------------------------------------------------------------|
|       |       |      |       . ᠫ줮|           |          ।|      . ᠫ줮|
|--------------------|--------|--------|-----------------|----------------|----------------|-----------------|
}
*)

(*
$P{ LineAcntA:
HeadData.AcntA, L, ""
HeadData.BDate, L, "D.N.Y"
HeadData.EDate, L, "D.N.Y"
HeadData.Correct, L, "!!!|   "
HeadData.Vector[L_Acnt.avp_InSaldo], R, "2-"
HeadData.Vector[L_Acnt.avp_Debit], R, "2-"
HeadData.Vector[L_Acnt.avp_Credit], R, "2-"
HeadData.Vector[L_Acnt.avp_OutSaldo], R, "2-"
@
|####################|########|########|### #############|################|################|#################|
}
*)

(*
$P{ Top2:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|#####################################################################                                       |
|------------------------------------------------------------------------------------------------------------|
|㬥   |.|    |      㬬|/稭          |ࠣ                           |
|-----------|---------|--------|-----------|---------------------------|-------------------------------------|
}
*)

(*
$P{ Line2:
?, L, ""
?, L, ""
?, L, "D.N.Y"
?, R, "2-"
?, L, ""
?, L, ""
@
|###########|#########|########|###########|###########################|#####################################|
}
*)

(*
$P{ ErrLine:
?, L, ""
@
|############################################################################################################|
}
*)

(*
$P{ AddLine:
?, L, ""
@
|           |         |        |           |###########################|                                     |
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE CreateTmpFiles();
 BEGIN
  IF !DATABASE.Get().Tables("HeadData") THEN
   CREATE_TABLE(HeadData, , "६ 䠩");
 
   CREATE_FIELD(HeadData, dlf_Name, STRING[45],         ,  , , "࠭ᯮ 䠩");
   CREATE_FIELD(HeadData, AcntA,    STRING[20],         ,  , , " ");
   CREATE_FIELD(HeadData, BDate,    DATE,               ,  , , "");
   CREATE_FIELD(HeadData, EDate,    DATE,               ,  , , "");
   CREATE_FIELD(HeadData, Vector,   L_Acnt.tAcntVector, ,  , , "㬬");
   CREATE_FIELD(HeadData, Correct,  SCAL[2],            , "1", , "줮 ⮢୮");

   CREATE_INDEX(HeadData, dlf_Name,  PLURAL, "", "", dlf_Name, AcntA, BDate);
 
   SET_VERSION_OF_TABLE(HeadData, 0);
  END;
  L_AFM.CreateTemp("HeadData");

  IF !DATABASE.Get().Tables("DLData") THEN
   CREATE_TABLE(DLData, , "६ 䠩");
 
   CREATE_FIELD(DLData, dlf_Name, STRING[45],  , , , "࠭ᯮ 䠩");
   CREATE_FIELD(DLData, Number,   SCAL[1E4],   , , , "  浪");
   CREATE_FIELD(DLData, Pattern,  STRING[48],  , , , "ਡ");
   CREATE_FIELD(DLData, Value,    STRING[512], , , , "祭");

   CREATE_INDEX(DLData, Pattern,  UNIQUE, , , dlf_Name, Number, Pattern);
 
   SET_VERSION_OF_TABLE(DLData, 0);
  END;
  L_AFM.CreateTemp("DLData");

  IF !DATABASE.Get().Tables("asPDoc") THEN
   CREATE_TABLE(asPDoc, , "६ 䠩");
 
   CREATE_FIELD(asPDoc, dlf_Name,          STRING[48],              , , , " 䠩 믨᪨");
   CREATE_FIELD(asPDoc, CurAcntA,          STRING[20],              , , , "騩  ");
   CREATE_FIELD(asPDoc, Number,            SCAL[1E4],               , , , "  浪");
   CREATE_FIELD(asPDoc, PDocKind,          LIKE(PDocKind.PDocKind), , , , " 㬥");
   CREATE_FIELD(asPDoc, PayKind,           SCAL[100],               , , , " ");
   CREATE_FIELD(asPDoc, Date,              DATE,                    , , , " ⥦");
   CREATE_FIELD(asPDoc, PrpDate,           DATE,                    , , , " ⮢");
   CREATE_FIELD(asPDoc, SrcNbr,            STRING[20],              , , , "७  㬥");
   CREATE_FIELD(asPDoc, Total,             NUMERIC[2],              , , , "㬬");
   CREATE_FIELD(asPDoc, Payer,             LIKE(Firm.Firm),         , , , "⥫騪");
   CREATE_FIELD(asPDoc, PayerFirmName,     STRING[64],              , , , "⥫騪 ()");
   CREATE_FIELD(asPDoc, PayerMyFirm,       P_Firm.tMyFirm,          , , , "'' ࣠");
   CREATE_FIELD(asPDoc, PayerAcnt,         LIKE(FirmAcnt.FirmAcnt), , , , " ⥫騪");
   CREATE_FIELD(asPDoc, PayerINN,          STRING[20],              , , , " ⥫騪");
   CREATE_FIELD(asPDoc, PayerAcntA,        STRING[21],              , , , "/ ⥫騪");
   CREATE_FIELD(asPDoc, PayerBIC,          STRING[20],              , , , "  ⥫騪");
   CREATE_FIELD(asPDoc, Recipient,         LIKE(Firm.Firm),         , , , "⥫");
   CREATE_FIELD(asPDoc, RecipientFirmName, STRING[64],              , , , "⥫ ()");
   CREATE_FIELD(asPDoc, RecipientMyFirm,   P_Firm.tMyFirm,          , , , "'' ࣠");
   CREATE_FIELD(asPDoc, RecipientAcnt,     LIKE(FirmAcnt.FirmAcnt), , , , " ⥫");
   CREATE_FIELD(asPDoc, RecipientINN,      STRING[20],              , , , " ⥫");
   CREATE_FIELD(asPDoc, RecipientAcntA,    STRING[21],              , , , "/ ⥫");
   CREATE_FIELD(asPDoc, RecipientBIC,      STRING[20],              , , , "  ⥫");
   CREATE_FIELD(asPDoc, About,             STRING[256],             , , , "祭 ⥦");
   CREATE_FIELD(asPDoc, ExtAbout,          STRING[256],             , , , " ଠ");
   CREATE_FIELD(asPDoc, Queue,             LIKE(PDoc.Queue),        , , , "। ⥦");

   CREATE_INDEX(asPDoc, Number,  AUTOINCR, , , dlf_Name, CurAcntA, Number);
   CREATE_INDEX(asPDoc, PrpDate, PLURAL,   , , PrpDate);
 
   SET_VERSION_OF_TABLE(asPDoc, 0);
  END;
  L_AFM.CreateTemp("asPDoc");
 END {CreateTmpFiles};

 PRIVATE PROCEDURE PurgeTmpFiles();
 BEGIN
  IF ~!DATABASE.Get().Tables("HeadData") THEN
   L_AFM.AF_PurgeTemp("HeadData");
  END;
  IF ~!DATABASE.Get().Tables("DLData") THEN
   L_AFM.AF_PurgeTemp("DLData");
  END;
  IF ~!DATABASE.Get().Tables("asPDoc") THEN
   L_AFM.AF_PurgeTemp("asPDoc");
  END;
 END {PurgeTmpFiles};

 PUBLIC PROCEDURE IdentifyFirm(    OnDate   : DATE;
                                   _INN,
                                   _Acnt,
                                   _BIC     : STRING[];
                               VAR _firm    : LIKE(Firm.Firm);
                               VAR _firmacnt: LIKE(FirmAcnt.FirmAcnt);
                               VAR _MyFirm  : P_Firm.tMyFirm);
  VAR
   HasMyFirm    : SCAL[2];
   S            : STRING[];
   FirmAcntCount: NUMERIC[0];
 BEGIN
  SETEMPTY(_firm, _firmacnt, _MyFirm);
  IF SELECT(FirmAcnt, AcntA, _Acnt) THEN
   FirmAcntCount:=0;
   HasMyFirm    :=0;
   S            :="";
   WHILE OCCURE(FirmAcnt) DO
    IF L_DatTim.IsActive(OnDate, FirmAcnt.Begin, FirmAcnt.Till) &
       (!_INN | (_INN = P_Firm.FP_INN(FirmAcnt.Firm, OnDate)))  &
       (_BIC = P_Firm.FirmAcntBIC(OnDate))                      THEN
     _firm    :=FirmAcnt.Firm;
     _firmacnt:=FirmAcnt.FirmAcnt;
     IF ~!S THEN
      S:=S + ", ";
     END;
     S:=S + _firm + ": " + _firmacnt;
     HasMyFirm:=HasMyFirm | ~!P_Firm.GetMyFirmOfFirm(FirmAcnt.Firm);
     INC(FirmAcntCount);
    END;
    NEXT(FirmAcnt);
   END; (* WHILE OCCURE(FirmAcnt) ... *)
   IF   FirmAcntCount = 1 THEN
    _MyFirm:=P_Firm.GetMyFirmOfFirm(_firm);
   ELSIF FirmAcntCount > 1 THEN
    IF HasMyFirm THEN
     L_General.Error("᪮쪮 ࠣ⮢   ⮬ (" + _Acnt + "): " +
                     "||" +
                     S +
                     "||" +
                     "| ।   ' ࣠' !?!?!||");
    ELSE
     SETEMPTY(_firm, _firmacnt, _MyFirm);
    END;
   END;
  ELSIF ~!_INN THEN
   SELECT(FirmPro, Property, , P_Firm.P_INN, _INN);
   WHILE OCCURE(FirmPro) DO
    IF L_DatTim.IsActive(OnDate, FirmPro.Date, FirmPro.EndDate) & (OnDate < FirmPro.DocExpD) THEN
     IF !_firm THEN
      _firm  :=FirmPro.Firm;
      _MyFirm:=P_Firm.GetMyFirmOfFirm(_firm);
     ELSE
      SETEMPTY(_firm, _firmacnt, _MyFirm);
      LAST(FirmPro);
     END;
    END;
    NEXT(FirmPro);
   END; (* WHILE OCCURE(FirmPro) ... *)
  END;
 END {IdentifyFirm};

 PRIVATE PROCEDURE extPrompt(Operation, FileName, PDocSrcNbr: STRING[]);
 BEGIN
  PROMPT(Str.Align(Operation, 18, LEFT) + ": 䠩 " + FileName + ", 㬥 " + PDocSrcNbr);
 END {extPrompt};

 PRIVATE PROCEDURE Prompt(Operation: STRING[]);
 BEGIN
  extPrompt(Operation, asPDoc.dlf_Name, asPDoc.SrcNbr);
 END {Prompt};

 PRIVATE PROCEDURE Fill_asPDoc();
  VAR
   ItsMyPayment: SCAL[2];
 BEGIN
  SELECT(asPDoc, PrpDate);
  WHILE OCCURE(asPDoc) DO
   NARROWSEL(asPDoc, PrpDate);
   WHILE OCCURE(asPDoc) DO
    Prompt("樠 ");
    IdentifyFirm(asPDoc.Date,
                 asPDoc.PayerINN,
                 asPDoc.PayerAcntA,
                 asPDoc.PayerBIC,
                 asPDoc.Payer,
                 asPDoc.PayerAcnt,
                 asPDoc.PayerMyFirm);
    IdentifyFirm(asPDoc.Date,
                 asPDoc.RecipientINN,
                 asPDoc.RecipientAcntA,
                 asPDoc.RecipientBIC,
                 asPDoc.Recipient,
                 asPDoc.RecipientAcnt,
                 asPDoc.RecipientMyFirm);
    REPLACE(asPDoc);
    IF ~!asPDoc.CurAcntA THEN
     ItsMyPayment:=~!asPDoc.PayerMyFirm & (asPDoc.PayerAcntA = asPDoc.CurAcntA);
     IF    (Str.Slice(asPDoc.RecipientAcntA, 0, 3) = "421") &
           (asPDoc.Payer = asPDoc.Recipient)                &
           (asPDoc.PayerBIC = asPDoc.RecipientBIC)          &
           (asPDoc.PayKind = 01) THEN
      asPDoc.PDocKind:=L_PDoc.pd_IMO;
     ELSIF Str.Slice(asPDoc.RecipientAcntA, 0, 3) = "202" THEN
      asPDoc.PDocKind:=L_PDoc.pd_CND;
     ELSIF Str.Slice(asPDoc.PayerAcntA,     0, 3) = "202" THEN
      asPDoc.PDocKind:=L_PDoc.pd_OVN;
     ELSIF asPDoc.PayKind = 01 (* ⥦ 祭 *) THEN
      IF ItsMyPayment THEN
       asPDoc.PDocKind:=L_PDoc.pd_IPP;
      ELSE
       asPDoc.PDocKind:=L_PDoc.pd_VPP;
      END;
     ELSIF asPDoc.PayKind = 02 (* 室饥 ⥦ ॡ, 室  뢠 *) THEN
      IF ItsMyPayment THEN
       asPDoc.PDocKind:=L_PDoc.pd_ITP;
      END;
     ELSIF asPDoc.PayKind = 06 (* 室饥 ᮢ 祭, ஥  ᠬ  , 室  뢠 *) THEN
      IF ItsMyPayment THEN
       asPDoc.PDocKind:=L_PDoc.pd_ITP;
      END;
     ELSIF (asPDoc.PayKind = 09) | (asPDoc.PayKind = 16) | (asPDoc.PayKind = 17) (* ਠ, ᪨  ᮢ थ *) THEN
      IF ItsMyPayment THEN
       asPDoc.PDocKind:=L_PDoc.pd_IMO;
      ELSE
       asPDoc.PDocKind:=L_PDoc.pd_VMO;
      END;
     ELSE
      (* 祣   asPDoc.PDocKind ⮩,    ⮪ 訡 *)
     END;
     IF !asPDoc.Queue & ~L_PDoc.IsOutPDoc(asPDoc.PDocKind) THEN
      asPDoc.Queue:=6;
     END;
     REPLACE(asPDoc);
    END; (* IF ~!asPDoc.CurAcntA...*)
    NEXT(asPDoc);
   END; (* WHILE OCCURE(asPDoc) ... *)
   NEXTINEXTENDEDSEL(asPDoc, PrpDate);
  END; (* WHILE OCCURE(asPDoc) ... *)
 END {Fill_asPDoc};

 VAR
  LineNbr: NUMERIC[0];

 PRIVATE PROCEDURE ReadLine(FullFileName: STRING[]): STRING[];
  VAR
   Msg,
   S: STRING[];
   i,
   MaxLength: NUMERIC[0];
   MsgArr   : STRING[][10];
 BEGIN
  INC(LineNbr);
  IF ~FIO.RdStr(F, S) THEN
   Msg:=Str.Align("ப " + L_Str.IntStr(LineNbr), 11, LEFT)  + ": " + " 䠩  ";
   SETEMPTY(MsgArr);
   SETZERO(i);
   LOOP
    MsgArr[i]:=L_Str.PoolItem(Msg, i);
    IF !MsgArr[i] THEN
     EXIT;
    END;
    INC(i);
   END; (* LOOP *)

   SETZERO(i, MaxLength);
   WHILE ~!MsgArr[i] DO
    MaxLength:=Math.Max(MaxLength, Str.Length(MsgArr[i]));
    INC(i);
   END;
   SETEMPTY(Msg);
   SETZERO(i);
   WHILE ~!MsgArr[i] DO
    Msg:=Msg + Str.Align(MsgArr[i], MaxLength, LEFT) + "|";
    INC(i);
   END;
   L_General.Error(" " + FullFileName + "| |" + Msg);
  END;
  RETURN S;
 END {ReadLine};

 PRIVATE PROCEDURE gvfa_Str(Pattern: STRING[]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  SAVE(DLData);
  IF SEARCH(DLData, Pattern, DLData.dlf_Name, DLData.Number, Pattern) THEN
   Result:=DLData.Value;
  END;
  RESTORE(DLData);
  RETURN Result;
 END {gvfa_Str};

 PRIVATE PROCEDURE gvfa_INN(Pattern: STRING[]; _CB: NUMERIC[0]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=E_CB_ConvertINN(_CB, gvfa_Str(Pattern), d_Download);
  IF (L_Str.Char(Result, 0) = "0") & (L_Str.Char(Result, 1) = "0") THEN
   Result:=Str.Delete(Result, 0, 2);
  END;
  RETURN Result;
 END {gvfa_INN};

 PRIVATE PROCEDURE gvfa_BIC(Pattern: STRING[]): STRING[];
  VAR
   Result  : STRING[];
   pd_Index: NUMERIC[0];
 BEGIN
  Result:=gvfa_Str(Pattern);
  IF ~!Result & (Str.Length(Result) = 8) THEN
   Result:="0" + Result;
  END;
  RETURN Result;
 END {gvfa_BIC};

 PRIVATE PROCEDURE StrToDate(Value: STRING[]): DATE;
 BEGIN
  RETURN L_Prop.GetDateFromStr(Value, 0);
 END {StrToDate};

 PRIVATE PROCEDURE gvfa_Date(Pattern: STRING[]): DATE;
 BEGIN
  RETURN StrToDate(gvfa_Str(Pattern));
 END {gvfa_Date};

 PRIVATE PROCEDURE gvfa_Total(Pattern: STRING[]): NUMERIC[2];
  VAR
   trgTotal: LIKE(PDoc.Total);
 BEGIN
  trgTotal:=L_Str.StrToNum(gvfa_Str(Pattern), "2.", 1);
  IF ~!trgTotal THEN
   trgTotal:=Math.Abs(trgTotal);
  END;
  RETURN trgTotal;
 END {gvfa_Total};

 PRIVATE PROCEDURE f1c_GetDownloadExtAbout(): STRING[];
  VAR
   _Former,
   _KBK,
   _OKTMO,
   _Reason,
   _Period,
   _DocNbr,
   _DocDate,
   _Type    : STRING[];
 BEGIN
  _Former :=gvfa_Str("ᑮ⠢⥫");
  _KBK    :=gvfa_Str("⥫슁");
  _OKTMO  :=gvfa_Str("");
  _Reason :=gvfa_Str("⥫᭮");
  _Period :=gvfa_Str("⥫쏥ਮ");
  _DocNbr :=gvfa_Str("⥫썮");
  _DocDate:=gvfa_Str("⥫선");
  _Type   :=gvfa_Str("⥫쒨");
  IF ~!_Former | ~!_KBK    | ~!_OKTMO   | ~!_Reason |
     ~!_Period | ~!_DocNbr | ~!_DocDate | ~!_Type THEN
   RETURN _Former + ";" + _KBK + ";" + _OKTMO + ";" + _Reason + ";" +
          _Period + ";" + _DocNbr + ";" + _DocDate + ";" + _Type;
  ELSE
   RETURN "";
  END;
 END {f1c_GetDownloadExtAbout};

 PRIVATE PROCEDURE f1c_GetPDocDate(): DATE;
  VAR
   trgDate: DATE;
 BEGIN
  trgDate:=gvfa_Date("⠏㯨");
  IF !trgDate THEN
   trgDate:=gvfa_Date("⠑ᠭ");
  END;
  IF !trgDate THEN
   trgDate:=asPDoc.PrpDate;
  END;
  RETURN trgDate;
 END {f1c_GetPDocDate};

 PRIVATE PROCEDURE GetAcntA(trgAcntA: STRING[]): STRING[];
 BEGIN
  IF SELECT(HeadData, dlf_Name, asPDoc.dlf_Name, trgAcntA) THEN
   RETURN trgAcntA;
  ELSE
   RETURN "";
  END;
 END {GetAcntA};

 PRIVATE PROCEDURE f1c_GetCurAcntA(): STRING[];
  VAR
   pResult, rResult: STRING[];
 BEGIN
  pResult:=GetAcntA(asPDoc.PayerAcntA);
  rResult:=GetAcntA(asPDoc.RecipientAcntA);
  IF    ~!pResult & ~!rResult THEN
   RETURN "";
  ELSIF ~!pResult THEN
   RETURN pResult
  ELSIF ~!rResult THEN
   RETURN rResult;
  ELSE
   RETURN "";
  END;
 END {f1c_GetCurAcntA};

 PRIVATE PROCEDURE f1c_ProceedDownloadData(_CB: NUMERIC[0]);
  VAR
   i        : NUMERIC[0];
   S,
   trgSrcNbr: STRING[];
 BEGIN
  SELECT(DLData, Pattern);
  WHILE OCCURE(DLData) DO
   NARROWSEL(DLData, dlf_Name, Number);

   trgSrcNbr               :=gvfa_Str("");
   extPrompt(" 믨᪨", DLData.dlf_Name, trgSrcNbr);

   DEFAULT(asPDoc);
   asPDoc.SrcNbr           :=trgSrcNbr;
   asPDoc.dlf_Name         :=DLData.dlf_Name;
   asPDoc.Number           :=DLData.Number;
   asPDoc.Total            :=gvfa_Total("㬬");
   asPDoc.PayKind          :=gvfa_Str("");
   asPDoc.PrpDate          :=gvfa_Date("");
   asPDoc.Date             :=f1c_GetPDocDate();
   asPDoc.PayerFirmName    :=gvfa_Str("⥫騪1");
   asPDoc.PayerINN         :=gvfa_INN("⥫騪", _CB);
   asPDoc.PayerAcntA       :=gvfa_Str("⥫騪");
   asPDoc.PayerBIC         :=gvfa_BIC("⥫騪");
   asPDoc.RecipientFirmName:=gvfa_Str("⥫1");
   asPDoc.RecipientINN     :=gvfa_INN("⥫숍", _CB);
   asPDoc.RecipientAcntA   :=gvfa_Str("⥫");
   asPDoc.RecipientBIC     :=gvfa_BIC("⥫쁈");
   asPDoc.Queue            :=gvfa_Str("।");
   asPDoc.About            :=gvfa_Str("祭⥦");
   asPDoc.ExtAbout         :=f1c_GetDownloadExtAbout();
   asPDoc.CurAcntA         :=f1c_GetCurAcntA();
   INSERT(asPDoc);
   NEXT(DLData);

   NEXTINEXTENDEDSEL(DLData, dlf_Name, Number);
  END; (* WHILE OCCURE(DLData) ... *)
 END {f1c_ProceedDownloadData};

 PRIVATE PROCEDURE IsLoadedDoc(): SCAL[2];
 BEGIN
  L_General.CallUs(OCCURE(PDoc));
  RETURN P_PDoc.HasPDocPro(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_CBDlStamp);
 END {IsLoadedDoc};

 PRIVATE PROCEDURE IsAcceptablePDocForImport(Errors: SCAL[2][]): SCAL[2];
  VAR
   i     : NUMERIC[0];
   Result: SCAL[2];
 BEGIN
  Result:=1;
  i     :=0;
  LOOP
   IF (i > HIGH(Errors)) | ~Result THEN
    EXIT;
   END;
   Result:=Errors[i] = 0;
   INC(i);
  END; (* LOOP *)
  RETURN Result;
 END {IsAcceptablePDocForImport};

 PRIVATE PROCEDURE AcceptablePDoc(wCheckFirm    : SCAL[2];
                                  _Firm         : LIKE(Firm.Firm);
                                  _OwnAcnt      : LIKE(FirmAcnt.FirmAcnt);
                                  _Total        : LIKE(PDoc.Total);
                                  AdditionalCond: SCAL[2]): SCAL[2];
  VAR
   PDFirm    : LIKE(Firm.Firm);
   _Value    : STRING[];
   ds_Version: STRING[];
 BEGIN
  PDFirm:=PDoc.Firm;
  IF wCheckFirm THEN
   _Value:=P_PDoc.GetPDocProSoft(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_CBDlStamp);
   IF ~!_Value THEN
    ds_Version:=Str.Item(_Value, ";", dlsi_Version);
    IF ds_Version = dsv_1 THEN
     PDFirm:=Str.Condense(Str.Item(_Value, ";", dlsi_Firm, , 1));
    END;
   END;
  END;

  RETURN AdditionalCond                                      &
         (~wCheckFirm | !PDFirm | !_Firm | (PDFirm = _Firm)) &
         (PDoc.OwnAcnt = _OwnAcnt)                           &
         (PDoc.Total   = _Total);
 END {AcceptablePDoc};

 PRIVATE PROCEDURE IsSpecificIngoingPDoc(): SCAL[2];
 BEGIN
  RETURN (asPDoc.PDocKind = L_PDoc.pd_IMO) | (asPDoc.PDocKind = L_PDoc.pd_ITP);
 END {IsSpecificIngoingPDoc};

 PRIVATE PROCEDURE StandOnPDoc(): SCAL[2];
  VAR
   _Firm   : LIKE(Firm.Firm);
   _OwnAcnt: LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  IF L_PDoc.IsOurselvesPDoc(asPDoc.PDocKind) THEN
   IF (asPDoc.PDocKind = L_PDoc.pd_OVN) | (asPDoc.PDocKind = L_PDoc.pd_CND) THEN
    SETSEL(PDoc, PDKDate, asPDoc.PDocKind);
    SRCINSEL(PDoc, LE, , asPDoc.Date);
    WHILE OCCURE(PDoc) & (PDoc.Date >= (asPDoc.Date - 10)) DO
     IF (PDoc.Total = asPDoc.Total) & ((PDoc.SrcNbr = asPDoc.SrcNbr) | ~IsLoadedDoc()) THEN
      RETURN 1;
     END; (* WHILE OCCURE(PDoc)...*)
     PREV(PDoc);
    END;
   ELSE
    SETSEL(PDoc, PDocKind, asPDoc.PDocKind, asPDoc.SrcNbr);
    SRCINSEL(PDoc, GE, , asPDoc.PrpDate);
    WHILE OCCURE(PDoc) DO
     IF AcceptablePDoc(0, EMPTYOF(Firm.Firm), asPDoc.PayerAcnt, asPDoc.Total, PDoc.PrpDate = asPDoc.PrpDate) THEN
      RETURN 1;
     END;
     NEXT(PDoc);
    END; (* WHILE OCCURE(PDoc) ... *)
   END;
  ELSE
   IF IsSpecificIngoingPDoc() THEN
    _Firm   :=asPDoc.Recipient;
    _OwnAcnt:=asPDoc.PayerAcnt;
   ELSE
    _Firm   :=asPDoc.Payer;
    _OwnAcnt:=asPDoc.RecipientAcnt;
   END;
   SELECT(PDoc, PDKDate, , asPDoc.PDocKind, asPDoc.Date);
   WHILE OCCURE(PDoc) DO
    IF AcceptablePDoc(1, _Firm, _OwnAcnt, asPDoc.Total, PDoc.SrcNbr = asPDoc.SrcNbr) THEN
     RETURN 1;
    END; (* WHILE OCCURE(PDoc)...*)
    NEXT(PDoc);
   END;
  END;
  RETURN 0;
 END {StandOnPDoc};

 PRIVATE PROCEDURE TryProceedPDoc(    trgDone: SCAL[2];
                                  VAR Msg    : STRING[]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  TRY
   IF trgDone THEN
    CALL(PDoc.StreamMakeDone());
   ELSE
    CALL(PDoc.StreamMakeUnDone());
   END;
   SETEMPTY(Msg);
   Result:=1;
  EXCEPT
  ON Exc: Exc_Root DO
   Msg   :=L_General.ExcDescription(Exc);
   Result:=0;
  END; (* TRY *)
  RETURN Result;
 END {TryProceedPDoc};

 PRIVATE PROCEDURE StandOnPPk_InCurrentMonth(trgDate       : DATE;
                                             trgMyFirm     : P_Firm.tMyFirm;
                                             trgOwnFirmAcnt: LIKE(FirmAcnt.FirmAcnt);
                                             trgFirm       : LIKE(Firm.Firm)): SCAL[2];
  VAR
   trgMDoc: LIKE(MDoc.MDoc);
 BEGIN
  L_General.CallUs(SEARCH(mfBnkAcn, MyFirm, trgMyFirm, trgOwnFirmAcnt));
  SETEMPTY(trgMDoc);
  IF ~!mfBnkAcn.Contract THEN
   CONFORM(mfBnkAcn, Contract);
   IF Contract.Firm = trgFirm THEN
    SETSEL(MDoc, Contract, Contract.Contract, L_MDoc.md_PPk);
    IF SRCINSEL(MDoc, GE, L_DatTim.MonthBeg(trgDate))           &
       (L_DatTim.YEAR(MDoc.Date)  = L_DatTim.YEAR(trgDate))     &
       (L_DatTim.MONTH(MDoc.Date) = L_DatTim.MONTH(trgDate)) THEN
     WHILE OCCURE(MDoc) & (L_DatTim.MONTH(MDoc.Date) = L_DatTim.MONTH(trgDate)) DO
      IF (MDoc.Status # L_MDoc.st_Canceled) & (MDoc.Firm = trgFirm) THEN
       L_General.Assert(!trgMDoc,
                        L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc) + ":" +
                        "   " + Contract.Contract + "    " + L_MDoc.MDocKindNick(L_MDoc.md_PPk, 1) +
                        "  " + L_DatTim.PeriodStr(trgDate));
       trgMDoc:=MDoc.MDoc;
      END;
      NEXT(MDoc);
     END; (* WHILE OCCURE(MDoc) & ...*)
    END;
    L_General.Assert(~!trgMDoc, L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc) + ":" +
                     "   " + L_MDoc.MDocKindNick(L_MDoc.md_PPk, 1) + "   " + Contract.Contract +
                     "  " + L_DatTim.PeriodStr(trgDate));
    SEARCH(MDoc, MDoc, , L_MDoc.md_PPk, trgMDoc);
   END;
  END;
  RETURN ~!trgMDoc;
 END {StandOnPPk_InCurrentMonth};

 PRIVATE PROCEDURE PutDownloadStamp(DownloadResult: SCAL[2]; SysDateTimeStamp: TIMESTAMP; trgDate: DATE);
  VAR
   trgFirm_AsStr: STRING[];
 BEGIN
  IF ~!PDoc.Firm THEN
   trgFirm_AsStr:=PDoc.Firm;
  ELSE
   SETEMPTY(trgFirm_AsStr);
  END;
  P_PDoc.SetPDocPro(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_CBDlStamp,
                    asPDoc.dlf_Name                             + ";" +
                    L_Str.PoolItem(dlr_Pool, DownloadResult)    + ";" +
                    L_DatTim.DateStr(trgDate)                   + ";" +
                    FLDTOSTR(SysDateTimeStamp, TIMESTAMPFormat) + ";" +
                    LOGINNAME()                                 + ";" +
                    trgFirm_AsStr                               + ";" +
                    dsv_1);
 END {PutDownloadStamp};

 PRIVATE PROCEDURE IsNewPDocFromBank(): SCAL[2];
 BEGIN
  RETURN (asPDoc.PDocKind = L_PDoc.pd_VPP) | (asPDoc.PDocKind = L_PDoc.pd_VMO) |
         IsSpecificIngoingPDoc();
 END {IsNewPDocFromBank};

 PRIVATE PROCEDURE GetFirmAttrFrom_asPDoc(VAR trgFirm: LIKE(Firm.Firm); VAR trgFirmName: STRING[]);
 BEGIN
  IF L_PDoc.IsOutPDoc(asPDoc.PDocKind) THEN
   trgFirm    :=asPDoc.Recipient;
   trgFirmName:="     " + asPDoc.RecipientFirmName;
  ELSE
   trgFirm    :=asPDoc.Payer;
   trgFirmName:="     " + asPDoc.PayerFirmName;
  END;
 END {GetFirmAttrFrom_asPDoc};

 PRIVATE PROCEDURE MakeProtocolLine(Condition    : SCAL[2];
                                    Text         : STRING[];
                                    ByCurrentPDoc: SCAL[2]);
  VAR
   i         : NUMERIC[0];
   StrArray  : STRING[][10];
   _PDocStr,
   _FirmName : STRING[];
   _Firm     : LIKE(Firm.Firm);
   _PDocKind : LIKE(PDocKind.PDocKind);
   _PDoc     : LIKE(PDoc.PDoc);
   _SrcNbr   : STRING[];
   _Date     : DATE;
   _Total    : NUMERIC[2];
 BEGIN
  IF Condition THEN
   SETEMPTY(_FirmName);
   IF ByCurrentPDoc THEN
    _PDocKind:=PDoc.PDocKind;
    _PDoc    :=PDoc.PDoc;
    _SrcNbr  :=PDoc.SrcNbr;
    _Date    :=PDoc.Date;
    _Total   :=PDoc.Total;
    _Firm    :=PDoc.Firm;
    IF !PDoc.Firm THEN
     GetFirmAttrFrom_asPDoc(_Firm, _FirmName);
    END;
   ELSE
    _PDocKind:=asPDoc.PDocKind;
    SETEMPTY(_PDoc);
    _SrcNbr  :=asPDoc.SrcNbr;
    _Date    :=asPDoc.Date;
    _Total   :=asPDoc.Total;
    GetFirmAttrFrom_asPDoc(_Firm, _FirmName);
   END;

   IF ~!_Firm THEN
    SAVE(Firm);
    SEARCH(Firm, Firm, , _Firm);
    _FirmName:=Firm.Firm + " " + Firm.Name;
    RESTORE(Firm);
   END;
   IF ~!_PDocKind THEN
    IF ~!_PDoc THEN
     _PDocStr:=L_PDoc.PDocStr(_PDocKind, _PDoc);
    ELSE
     _PDocStr:=L_PDoc.PDocKindNick(_PDocKind, 1);
    END;
   ELSE
    _PDocStr:="???";
   END;

   Str.Format(StrArray, Text, 27, LEFT);
   MAKEPART(R, Line2, _PDocStr, _SrcNbr, _Date, _Total, StrArray[0], _FirmName);
   i:=1;
   WHILE (i <= HIGH(StrArray)) & ~!StrArray[i] DO
    MAKEPART(R, AddLine, StrArray[i]);
    INC(i);
   END; (* WHILE (i <= HIGH(StrArray)) &...*)
  END;
 END {MakeProtocolLine};

 PRIVATE PROCEDURE CheckIsPDocReadyForProceed(    Cond               : SCAL[2];
                                                  Text               : STRING[];
                                              VAR PDocReadyForProceed: SCAL[2]);
 BEGIN
  IF ~Cond THEN
   PDocReadyForProceed:=0;
   MakeProtocolLine(1, Text, 1);
  END;
 END {CheckIsPDocReadyForProceed};

 PRIVATE PROCEDURE CheckIsCriticalProblem(    Cond         : SCAL[2];
                                              Text         : STRING[];
                                              ByCurrentPDoc: SCAL[2];
                                          VAR Error        : NUMERIC[0]);
 BEGIN
  IF ~Cond THEN
   Error:=1;
   MakeProtocolLine(1, Text, ByCurrentPDoc);
  END;
 END {CheckIsCriticalProblem};

 PRIVATE PROCEDURE PDoc_OnAnyModification(Dir: NUMERIC[0]);
 BEGIN
  TRY
   L_PDoc.PDoc_OnAnyModification(Dir, L_PDoc.np_No, 1);
  EXCEPT
  ON Exc: Exc_Root DO
   IF (Dir = +1) & (PDoc.Status = L_PDoc.st_Passed) THEN
    PDoc.Status:=L_PDoc.st_Prepared;
    REPLACE(PDoc);
   END;
   L_PDoc.PDoc_OnAnyModification(Dir, L_PDoc.np_No, 1);
  END; (* TRY *)
 END {PDoc_OnAnyModification};

 PRIVATE PROCEDURE StandOnHeadAcntAByOwnAcntA(): SCAL[2];
 BEGIN
  L_PDoc.AccessPDocOwnFirmAcnt();
  RETURN SELECT(HeadData, dlf_Name, asPDoc.dlf_Name, FirmAcnt.AcntA);
 END {StandOnHeadAcntAByOwnAcntA};

 PRIVATE PROCEDURE IsPDocDateInDownloadPeriod(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF StandOnHeadAcntAByOwnAcntA() THEN
   WHILE OCCURE(HeadData) & ~Result DO
    Result:=L_DatTim.IsActive_Inc(asPDoc.Date, HeadData.BDate, HeadData.EDate);
    NEXT(HeadData);
   END; (* WHILE OCCURE(HeadData) ... *)
  ELSE
   Result:=1; (*ਢ,  ᫨    䠩 믨᪨,  "   ਮ 䠩 믨᪨" ᮮ 㯮 *)
  END;
  RETURN Result;
 END {IsPDocDateInDownloadPeriod};

 PRIVATE PROCEDURE ChangePDocStatus(trgDate: DATE; trgStatus: LIKE(PDoc.Status));
  VAR
   NeedModification: SCAL[2];
 BEGIN
(*
᢮ PDoc.Date:=trgDate -  ᠬ , ⮫쪮  叄,
 叄  ᢮ ⮦
*)
  NeedModification:=(L_DatTim.Per(PDoc.Date) # L_DatTim.Per(trgDate));
  IF NeedModification THEN
   PDoc_OnAnyModification(-1);
  END;
  PDoc.Date  :=trgDate;
  PDoc.Status:=trgStatus;
  REPLACE(PDoc);
  IF NeedModification THEN
   PDoc_OnAnyModification(+1);
  END;
 END {ChangePDocStatus};

 PRIVATE PROCEDURE f1c_Proceed();
  CONST
   ErrorsAmount = 10;

   e_FailIdentifyFirm = 0;
   e_UnknownPDocKind  = 1;
   e_NotFoundPDoc     = 2;
   e_AlreadyDownload  = 3;
   e_NotOwnFirmPDoc   = 4;
   e_NotUploaded      = 5;
   e_IncorrectStatus  = 6;
   e_NotEqualTotals   = 7;
   e_FailUnDone       = 8;
   e_AlreadyExists    = 9;
  VAR
   SysDTS             : TIMESTAMP;
   ErrMsg             : STRING[];
   Errors             : SCAL[2][ErrorsAmount];
   prvPDocDate        : DATE;
   NeedModification,
   PDocReadyForProceed: SCAL[2];
 BEGIN
  Fill_asPDoc();

  SELECT(asPDoc, Number);
  WHILE OCCURE(asPDoc) DO
   NARROWSEL(asPDoc, dlf_Name);
   SysDTS:=L_DatTim.GetSysTIMESTAMP();
   WHILE OCCURE(asPDoc) DO
    NARROWSEL(asPDoc, CurAcntA);
    Prompt("ࠡ⪠ 믨᪨");
    IF ~!asPDoc.CurAcntA THEN
     MAKEPART(R, Top2, asPDoc.CurAcntA);
    ELSE
     MAKEPART(R, Top2, "騩     ।");
    END;
    WHILE OCCURE(asPDoc) DO
     SETZERO(Errors);
     PDocReadyForProceed:=1;
     CheckIsCriticalProblem(~!asPDoc.PayerMyFirm | ~!asPDoc.RecipientMyFirm,
                            " 㤠 ஢  ⥫騪,  ⥫", 0, Errors[e_FailIdentifyFirm]);

     CheckIsCriticalProblem(~!asPDoc.PDocKind, "  ", 0, Errors[e_UnknownPDocKind]);

     IF IsAcceptablePDocForImport(Errors) THEN
      IF StandOnPDoc() THEN
       CheckIsCriticalProblem(~IsLoadedDoc(), " 㦥", 1, Errors[e_AlreadyDownload]);
       IF ~Errors[e_AlreadyDownload] THEN
        CheckIsCriticalProblem(~IsNewPDocFromBank(), "㬥 㦥 ", 1, Errors[e_AlreadyExists]);
       END;
       CheckIsCriticalProblem((asPDoc.Payer = L_PDoc.GetPDocOwnFirm()) | (asPDoc.Recipient = L_PDoc.GetPDocOwnFirm()),
                              "   ࠣ " + L_PDoc.GetPDocOwnFirm(), 1, Errors[e_NotOwnFirmPDoc]);
      ELSE
       CheckIsCriticalProblem(~L_PDoc.IsOurselvesPDoc(asPDoc.PDocKind), "  ", 0, Errors[e_NotFoundPDoc]);
      END;
      IF IsAcceptablePDocForImport(Errors) THEN
       SETEMPTY(ErrMsg);
       IF    L_PDoc.IsOurselvesPDoc(asPDoc.PDocKind) THEN
        IF (PDoc.PDocKind = L_PDoc.pd_OVN) | (PDoc.PDocKind = L_PDoc.pd_CND) THEN
         IF !PDoc.SrcNbr THEN
          PDoc.SrcNbr:=asPDoc.SrcNbr;
          REPLACE(PDoc);
         END;
         IF (PDoc.PDocKind = L_PDoc.pd_OVN) & !PDoc.OwnAcnt THEN
          PDoc.OwnAcnt:=asPDoc.RecipientAcnt;
          REPLACE(PDoc);
         END;
        ELSE
         CheckIsCriticalProblem(L_PDoc.CB_IsUploadedPDoc(PDoc.PDocKind, PDoc.PDoc), " ।  -", 1, Errors[e_NotUploaded]);
        END;
        CheckIsCriticalProblem(PDoc.Status = L_PDoc.st_Prepared, " -  '⮢'", 1, Errors[e_IncorrectStatus]);
        CheckIsCriticalProblem(PDoc.Total = asPDoc.Total, " 㬬", 1, Errors[e_NotEqualTotals]);
        IF IsAcceptablePDocForImport(Errors) & ~TryProceedPDoc(0, ErrMsg) THEN
         CheckIsCriticalProblem(0, "訡  ⪠: " + ErrMsg, 1, Errors[e_FailUnDone]);
        END;
       ELSIF IsNewPDocFromBank() THEN
        DEFAULT(PDoc);
        PDoc.PDocKind:=asPDoc.PDocKind;
        PDoc.Date    :=asPDoc.Date;
        PDoc.PrpDate :=asPDoc.PrpDate;
        PDoc.SrcNbr  :=asPDoc.SrcNbr;
        PDoc.SaleTax :=0;
        PDoc.Total   :=asPDoc.Total;
        IF IsSpecificIngoingPDoc() THEN
         PDoc.Firm    :=asPDoc.Recipient;
         PDoc.FirmAcnt:=asPDoc.RecipientAcnt;
         PDoc.MyFirm  :=asPDoc.PayerMyFirm;
         PDoc.OwnAcnt :=asPDoc.PayerAcnt;
        ELSE
         PDoc.Firm    :=asPDoc.Payer;
         PDoc.FirmAcnt:=asPDoc.PayerAcnt;
         PDoc.MyFirm  :=asPDoc.RecipientMyFirm;
         PDoc.OwnAcnt :=asPDoc.RecipientAcnt;
        END;
        L_PDoc.SetPDocComment(asPDoc.About);
        PDoc.ExtAbout:=asPDoc.ExtAbout;
        PDoc.Source  :=L_PDoc.src_Auto;
        PDoc.Queue   :=asPDoc.Queue;
        PDoc.PmntKind:=2(*஭*);
        PDoc.Status  :=L_PDoc.st_Prepared;
        L_PDoc.Insert_PDoc();
        PutDownloadStamp(dlr_Insert, SysDTS, PDoc.Date);
        IF (PDoc.PDocKind=L_PDoc.pd_IMO) & StandOnPPk_InCurrentMonth(PDoc.Date, PDoc.MyFirm, PDoc.OwnAcnt, PDoc.Firm) THEN
         L_Pmnt.InsPDocMDoc(MDoc.MDocKind, MDoc.MDoc, PDoc.Total, PDoc.NDS, PDoc.SaleTax);
         PDoc.Dest:=L_Dest.PDocwMDocDest();
         REPLACE(PDoc);
        END;
        IF ~!PDoc.Firm & !PDoc.Dest THEN
         L_Pmnt.TryDistributePayment(ErrMsg);
        END;
        IF !PDoc.Dest THEN
         PDoc.Dest:=L_Acnt.E_FictDest();
         REPLACE(PDoc);
        END;
        PDoc_OnAnyModification(+1);
       ELSE
        L_General.Error(" 㬥 "+asPDoc.PDocKind+" ঠ");
       END; (* IF *)

       IF PDoc.Dest = L_Acnt.E_FictDest() THEN
        PDoc.Status:=L_PDoc.st_Prepared;
        REPLACE(PDoc);
        PDocReadyForProceed:=0;
       END; (* IF PDoc.Dest # L_Acnt.E_FictDest()...*)

       CheckIsPDocReadyForProceed((PDoc.PDocKind = L_PDoc.pd_OVN) | ~!asPDoc.Payer, " । ⥫騪", PDocReadyForProceed);
       CheckIsPDocReadyForProceed(L_PDoc.IsOurselvesPDoc(PDoc.PDocKind) | ~!asPDoc.Recipient, " । ⥫", PDocReadyForProceed);

       IF ~!PDoc.MyFirm THEN
        CheckIsPDocReadyForProceed(~!PDoc.OwnAcnt,                                  " । ᮡ⢥ ", PDocReadyForProceed);
       END;
       IF ~!PDoc.Firm & (PDoc.PDocKind # L_PDoc.pd_OVN) & (PDoc.PDocKind # L_PDoc.pd_CND) THEN
        CheckIsPDocReadyForProceed(~!PDoc.FirmAcnt,                                 " ।  ࠣ", PDocReadyForProceed);
       END;

       CheckIsPDocReadyForProceed(~!PDoc.SrcNbr,                                    " 㪠  室  㬥", PDocReadyForProceed);
       CheckIsPDocReadyForProceed(~!asPDoc.PrpDate,                                 " 㪠  ⮢ 㬥", PDocReadyForProceed);
       CheckIsPDocReadyForProceed(~!asPDoc.Date,                                    " 㪠  ஢ 㬥", PDocReadyForProceed);
       IF ~!asPDoc.PrpDate & ~!asPDoc.Date THEN
        CheckIsPDocReadyForProceed(asPDoc.PrpDate <= asPDoc.Date,                   " ஢    ⮢", PDocReadyForProceed);
       END;
       IF ~!asPDoc.Date THEN
        CheckIsPDocReadyForProceed(IsPDocDateInDownloadPeriod(),                    " ஢   ਮ 믨᪨", PDocReadyForProceed);
       END;
       CheckIsPDocReadyForProceed(StandOnHeadAcntAByOwnAcntA(),                     "⢥       䠩 믨᪨", PDocReadyForProceed);
       CheckIsPDocReadyForProceed(~!PDoc.Total,                                     " 㪠 㬬", PDocReadyForProceed);
       CheckIsPDocReadyForProceed(~!PDoc.Comment,                                   " 㪠 祭 ⥦", PDocReadyForProceed);
       CheckIsPDocReadyForProceed(!ErrMsg,                                          ErrMsg, PDocReadyForProceed);

       IF IsAcceptablePDocForImport(Errors) THEN
        prvPDocDate:=PDoc.Date;
        IF PDocReadyForProceed THEN
         ChangePDocStatus(asPDoc.Date, L_PDoc.st_Passed);
         IF ~TryProceedPDoc(1, ErrMsg) THEN
          ChangePDocStatus(prvPDocDate, L_PDoc.st_Prepared);
          MakeProtocolLine(1, "訡  ࠡ⪥: " + ErrMsg, 1);
         END;
        END; (* IF PDocReadyForProceed...*)

        IF L_PDoc.IsOurselvesPDoc(PDoc.PDocKind) THEN
         PutDownloadStamp(dlr_Proceed, SysDTS, prvPDocDate);
        END;
        MakeProtocolLine(1, L_Str.PoolItem("!!!    !!!|ᯥ譮 㦥", PDocReadyForProceed), 1);
       END; (* IF IsAcceptablePDocForImport...*)
      END; (* IF IsAcceptablePDocForImport...*)
     END; (* IF IsAcceptablePDocForImport...*)
     NEXT(asPDoc);
    END; (* WHILE OCCURE(asPDoc) ... *)
    NEXTINEXTENDEDSEL(asPDoc, CurAcntA);
   END; (* WHILE OCCURE(asPDoc) ... *)
   NEXTINEXTENDEDSEL(asPDoc, dlf_Name);
  END; (* WHILE OCCURE(asPDoc) ... *)
 END {f1c_Proceed};

 PUBLIC PROCEDURE drr_GetName(): STRING[];
 BEGIN
  RETURN "CBA";
 END {drr_GetName};

 PRIVATE PROCEDURE E_CBDwn_GetFileName(_CB: NUMERIC[0]): STRING[];
  VAR
   Local  : PROC;
   Result,
   default: STRING[];
 BEGIN
  default:="*.txt";
  Local:=PROCREF(E_PDoc.CBDwn_GetFileName);
  IF ~!Local THEN
   Result:=Local(_CB, default);
  ELSE
   Result:=default;
  END;
  RETURN Str.Cap(Result);
 END {E_CBDwn_GetFileName};

 PRIVATE PROCEDURE GetNewFilesToDownload(_CB: NUMERIC[0]; DownloadFolder: STRING[]): STRING[];
  VAR
   Folder: FOLDERENTRY;
   Files : ENUMERATOR;
   Result: STRING[];
 BEGIN
  Result:="";
  L_General.Assert(FIO.DirExists(DownloadFolder), "⠫ 㧪 믨᮪  -||" +
                                                  DownloadFolder + "||"+
                                                  " ");
  APP.Get().NewPrompt("");
  Folder:=FOLDERENTRY.Create(DownloadFolder);
  Files :=CreateENUMERATOR(Folder.FolderContent);
  WHILE ~Files.AtEnd() DO
   PROMPT(" " + Files.Item().Path);
   IF ~Files.Item().Attributes.Directory &
      Str.Match(L_FIO.effp_FileName(Str.Cap(Files.Item().Path)), E_CBDwn_GetFileName(_CB)) &
      ~L_DFS.IsDone(Files.Item().Path, L_PCS.deft_CB) THEN
    Result:=Result + Files.Item().Path + "|";
   END;
   Files.MoveNext();
  END;
  RETURN Result;
 END {GetNewFilesToDownload};

 PRIVATE PROCEDURE FillXCalcDtl();
  VAR
   trgFirm    : LIKE(Firm.Firm);
   trgFirmAcnt: LIKE(FirmAcnt.FirmAcnt);
   trgXObject : LIKE(XObject.XObject);
 BEGIN
  SETEMPTY(trgFirm, trgFirmAcnt);
  SELECT(FirmAcnt, AcntA, , HeadData.AcntA);
  WHILE OCCURE(FirmAcnt) DO
   IF L_DatTim.IsActive(HeadData.BDate, FirmAcnt.Begin, FirmAcnt.Till) THEN
    IF ~!trgFirmAcnt THEN
     L_General.Error(" " + HeadData.AcntA + "    " + L_DatTim.DateStr(HeadData.BDate) + "|" +
                     "६  ࠣ " + trgFirm + "  " + FirmAcnt.Firm);
    END;
    trgFirm    :=FirmAcnt.Firm;
    trgFirmAcnt:=FirmAcnt.FirmAcnt;
   END;
   NEXT(FirmAcnt);
  END; (* WHILE OCCURE(FirmAcnt) ... *)

  trgXObject:=L_PDoc.GetGlobalXObject(P_Firm.GetMyFirmOfFirm(trgFirm), trgFirmAcnt);
  IF SEARCH(XCalcDtl, XObject, trgXObject, HeadData.BDate, L_kn.Get(HeadData.BDate, L_AcCut.erkn_SettlementAccounts)) THEN
   L_XObj.AccessXObject(trgXObject);
   IF XCalcDtl.RSlSum # HeadData.Vector[L_Acnt.avp_InSaldo] THEN
    L_StdFrm.Warning(L_XObj.GetXObjectOriginName() + "||" +
                     " 室 ᠫ줮  " + L_DatTim.DateStr(HeadData.BDate) + "|" +
                     "  : " + L_Money.MoneyToStr(HeadData.BDate, "", XCalcDtl.RSlSum) + "|" +
                     " 믨᪥   : " + L_Money.MoneyToStr(HeadData.BDate, "", HeadData.Vector[L_Acnt.avp_InSaldo]));

    XCalcDtl.Correct:=0;
    REPLACE(XCalcDtl);
 
    HeadData.Correct:=0;
    REPLACE(HeadData);
   END;
  ELSE
   XCalcDtl.XObject:=trgXObject;
   XCalcDtl.AcCut  :=L_kn.Get(HeadData.BDate, L_AcCut.erkn_SettlementAccounts);
   XCalcDtl.Date   :=HeadData.BDate;
   XCalcDtl.RSlSum :=HeadData.Vector[L_Acnt.avp_InSaldo];
   XCalcDtl.Correct:=1;
   INSERT(XCalcDtl);
  END;
 END {FillXCalcDtl};

 PRIVATE PROCEDURE f1c_allDownloadPDoc(_CB: NUMERIC[0]): STRING[];
  TYPE
   tSection = SCAL[3];

  CONST
   s_Nothing = 0;
   s_Acnt    = 1;
   s_PDoc    = 2;

  VAR
   S,
   FilesPool,
   dlf_FullPath,
   DownloadFolder,
   DownloadResultRep: STRING[];
   StrArray         : STRING[][10];
   avp              : L_Acnt.tAcntVectorPart;
   Section          : tSection;
   i, trgNumber     : NUMERIC[0];
   Entry            : FOLDERENTRY;
 BEGIN
  SETEMPTY(DownloadResultRep);
  i             :=0;
  DownloadFolder:=E_CB_DownloadPath(_CB);
  IF ~!DownloadFolder THEN
   TRY
    FilesPool:=GetNewFilesToDownload(_CB, DownloadFolder);
    CreateTmpFiles();
    LOOP
     dlf_FullPath:=L_Str.PoolItem(FilesPool, i);
     IF   !dlf_FullPath THEN
      EXIT;
     END;
     PROMPT("㧪 " + dlf_FullPath);
     IF i = 0 THEN
      DownloadResultRep:=L_General.rfn_byConnection(drr_GetName() + L_Str.FixedIntStr(_CB, 2));
      OPENREP(R, DownloadResultRep, Create);
      MAKEPART(R, Top, L_FIO.effp_FileName_woExt(DownloadResultRep));
      MAKEPART(R, Top1);
     END;

     Entry:=FOLDERENTRY.Create(dlf_FullPath);
     FIO.Open(F, dlf_FullPath, , Input);
     FIO.SetCP(F, FIO.CP_WindowsRussian);
  
   (* ⥭  -  ஢ન *)
     SETZERO(LineNbr, trgNumber);
     Section:=s_Nothing;
     LOOP
      S :=ReadLine(dlf_FullPath);
      IF    Str.Match(S, "**") THEN
       EXIT;
      ELSIF S = "" THEN
       Section:=s_Acnt;
       DEFAULT(HeadData);
       HeadData.dlf_Name:=L_FIO.effp_FileName(Entry.Path);
      ELSIF S = "搠" THEN
       INSERT(HeadData);

       L_General.CallUs(Section = s_Acnt);
       IF E_NormalFirmAcntWork() THEN
        FillXCalcDtl();
       END;
       Section:=s_Nothing;
      ELSIF Str.Match(S, "㬥*") THEN
       L_General.CallUs(Section = s_Nothing);
       Section:=s_PDoc;
       LOOP
        S:=ReadLine(dlf_FullPath);
        IF S = "愮㬥" THEN
         EXIT;
        END;
        DLData.dlf_Name:=L_FIO.effp_FileName(Entry.Path);
        DLData.Number  :=trgNumber;
        DLData.Pattern :=Str.Item(S, "=", 0);
        DLData.Value   :=Str.Condense(Str.Slice(S, Str.Pos(S, "=") + 1, Str.Length(S)));
        INSERT(DLData);
       END; (* LOOP *)
       INC(trgNumber);
       Section:=s_Nothing;
      ELSE
       IF    Section = s_Acnt THEN
        IF Str.Match(S, "*") THEN
         HeadData.AcntA:=Str.Item(S, "=", 1);
        ELSIF Str.Match(S, "⠍砫*") THEN
         HeadData.BDate:=StrToDate(Str.Condense(Str.Item(S, "=", 1)));
        ELSIF Str.Match(S, "⠊*") THEN
         HeadData.EDate:=StrToDate(Str.Condense(Str.Item(S, "=", 1)));
        ELSE
         IF    Str.Match(S, "砫멎⮪*") THEN avp:=L_Acnt.avp_InSaldo;
         ELSIF Str.Match(S, "ᥣ㯨*")   THEN avp:=L_Acnt.avp_Debit;
         ELSIF Str.Match(S, "ᥣᠭ*")     THEN avp:=L_Acnt.avp_Credit;
         ELSIF Str.Match(S, "멎⮪*")  THEN avp:=L_Acnt.avp_OutSaldo;
         ELSE
          SETEMPTY(avp);
         END;
         IF ~!avp THEN
          HeadData.Vector[avp]:=STRTOFLD(Str.Condense(Str.Item(S, "=", 1)), NUMERIC, "2.");
         END;
        END;
       ELSE
        (*Section = s_Nothing ? *)
       END;
      END;
     END; (* LOOP*)
     L_DFS.Do(dlf_FullPath, L_PCS.deft_CB);
     FIO.Close(F);
     INC(i);
    END; (* LOOP *)

    SELECT(HeadData, dlf_Name);
    WHILE OCCURE(HeadData) DO
     MAKEPART(R, LineAcntA);
     NEXT(HeadData);
    END; (* WHILE OCCURE(HeadData) ... *)

    IF i > 0 THEN
     f1c_ProceedDownloadData(_CB);
     f1c_Proceed();
     MAKEPART(R, Bot);
     CLOSEREP(R);
    ELSE
     SETEMPTY(DownloadResultRep);
    END;
   EXCEPT
   ON Exc: Exc_Root DO
    TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     FIO.Close(F);
    EXCEPT
    ELSE
    END; (* TRY *)

    IF ~!DownloadResultRep THEN
     TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
      MAKEPART(R, ErrLine);
      Str.Format(StrArray, Exc.Description, MaxErrorLineLength, LEFT);
      FOR_EACH S IN StrArray DO
       MAKEPART(R, ErrLine, S);
      END;
      MAKEPART(R, Bot);
      CLOSEREP(R);
     EXCEPT
     ELSE
     END; (* TRY *)
    END;
    RAISE();
   FINALLY
    PurgeTmpFiles();
   END; (* TRY *)
  ELSE
   DownloadResultRep:=L_PDoc.cb_DownloadPDocNotRealized;
  END; (* IF ~!DownloadFolder *)
  RETURN DownloadResultRep;
 END {f1c_allDownloadPDoc};

 PUBLIC PROCEDURE CheckNew2DownloadPDoc(_CB: NUMERIC[0]): STRING[];
  VAR
   DownloadFolder: STRING[];
 BEGIN
  DownloadFolder:=E_CB_DownloadPath(_CB);
  IF ~!DownloadFolder THEN
   RETURN GetNewFilesToDownload(_CB, DownloadFolder);
  ELSE
   RETURN L_PDoc.cb_DownloadPDocNotRealized;
  END;
 END {CheckNew2DownloadPDoc};

 PUBLIC PROCEDURE f1c_DownloadPDoc(_CB: NUMERIC[0]): STRING[];
 BEGIN
  RETURN f1c_allDownloadPDoc(_CB);
 END {f1c_DownloadPDoc};

 PUBLIC PROCEDURE f1c_ViewDownloadSrcFile(_CB: NUMERIC[0]): STRING[];
 BEGIN
  RETURN CB_ViewDownloadSrcFile(_CB, dlsi_FileName);
 END {f1c_ViewDownloadSrcFile};

 PUBLIC PROCEDURE f1c_CancelDownloadPDoc(_CB: NUMERIC[0]): STRING[];
  VAR
   curDate       : DATE;
   curStamp,
   FileName,
   CBDlStamp     : STRING[];
   prvPDocDate   : DATE;
   DownloadResult: SCAL[2];
 BEGIN
  FileName:=Str.Item(P_PDoc.GetPDocProSoft(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_CBDlStamp), ";", dlsi_FileName);
  L_General.Assert(~!FileName, " 㤠 ।  䠩 믨᪨|" +
                               "( ⠬ 㧪 )  ⬥ 㧪");

  curStamp:=Str.Item(P_PDoc.GetPDocProSoft(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_CBDlStamp), ";", dlsi_TimeStamp);
  curDate :=PDoc.Date;
  L_AFM.MakeIndex("CnclP", "PDocKind: LIKE(PDocKind.PDocKind);" +
                           "PDoc    : LIKE(PDoc.PDoc)");

  L_StdFrm.Choice("⬥ 㧪 믨᪨  ᪮ |" +
                  " 䠩 믨᪨ "+FileName+"|"+
                  "-: "+L_PDoc.CB_GetClientBankName(_CB));
  SETSEL(PDoc, Date);
  SRCINSEL(PDoc, GE, , curDate-30);
  WHILE OCCURE(PDoc) DO
   PROMPT("⮢ ᯨ᪠   ⬥ 㧪: " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   CBDlStamp:=P_PDoc.GetPDocProSoft(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_CBDlStamp);
   IF L_PDoc.IsBankPDoc(PDoc.PDocKind) &
      (L_PDoc.CB_GetPDocClientBank(PDoc.PDocKind, PDoc.PDoc) = _CB) &
      ~!CBDlStamp THEN

    IF (FileName = Str.Item(CBDlStamp, ";", dlsi_FileName))  &
       (curStamp = Str.Item(CBDlStamp, ";", dlsi_TimeStamp)) &
       L_Prop.IsDateValue(Str.Item(CBDlStamp, ";", dlsi_PrvPDocDate), "D.N.y") THEN
     CnclP.PDocKind:=PDoc.PDocKind;
     CnclP.PDoc    :=PDoc.PDoc;
     INSERT(CnclP);
    END;
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc) ... *)

  IF SELECT(CnclP, CnclP) THEN
   WHILE OCCURE(CnclP) DO
    SEARCH(PDoc, PDoc, , CnclP.PDocKind, CnclP.PDoc);
    PROMPT("⬥ 㧪: " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
    CBDlStamp     :=P_PDoc.GetPDocProStrong(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_CBDlStamp);
    prvPDocDate   :=STRTOFLD(Str.Item(CBDlStamp, ";", dlsi_PrvPDocDate), DATE);
    DownloadResult:=L_Str.PositionInPool(dlr_Pool, Str.Item(CBDlStamp, ";", dlsi_DownloadResult));
 
    P_PDoc.RemovePDocPro(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_CBDlStamp);
 
    IF DownloadResult = dlr_Insert THEN
     L_General.Assert(L_XDoc.XDoc_wo_Handicraft(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc),
                      "㬥   ᫥ 㧪");
     TRY [TRANSACTION(TRANSACTION_SLAVE)]
      CALL(PDoc.StreamMakeUnDone());
     EXCEPT
     END; (* TRY *)
     L_General.Assert(~PDoc.Done,  L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc) + ":   믮 ⮫쪮   ࠡ⠭ 㬥⮢");
     L_PDoc.Remove_PDoc(1);
    ELSE
     TRY [TRANSACTION(TRANSACTION_SLAVE)]
      CALL(PDoc.StreamMakeUnDone());
     EXCEPT
     END; (* TRY *)
     L_General.Assert(~PDoc.Done, L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc) + ":  ࠡ⠭ 㬥");
     PDoc_OnAnyModification(-1);
 
     PDoc.Date  :=prvPDocDate;
     PDoc.Status:=L_PDoc.st_Prepared;
     REPLACE(PDoc);
     PDoc_OnAnyModification(+1);
    END;
 
    NEXT(CnclP);
   END; (* WHILE OCCURE(CnclP) ... *)
 
   L_DFS.Remove(GetDownloadArchiveFullFileName(_CB, FileName), L_PCS.deft_CB);
  ELSE
   L_StdFrm.Inform("      ⬥ 㧪|" +
                   "-: "+L_PDoc.CB_GetClientBankName(_CB));
  END;
  RETURN "";
 END {f1c_CancelDownloadPDoc};

END.
