(*
%Copyright   (c) Polak IT
%Author      10.07.2009 12:51:25 POLAK\San
%Purpose     ⥪  ,   ..
%Type        library
%Specific    SYS
%Modified    24.09.2014 16:14:13 LDA
%Environment
*)

 MODULE L_CI [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  erkn_Salary               = 010488100;
  erkn_Fuel                 = 010488101;
  erkn_Incomes              = 010488102;
  erkn_VATAccountsBalancing = 010488103;
  erkn_KeyAssWear           = 010488104;
  erkn_ReminderOfRound      = 010494500;

 PUBLIC TYPE
  tCIKType = SCAL[64];

 PUBLIC CONST
  dfst_Prepared = 0;
  dfst_Passed   = 1;
  dfst_Canceled = 2;

  cikt_IsGroup  = 0;
  cikt_Activity = 1;
  cikt_Indirect = 2;
  cikt_KeyAss   = 3;
  cikt_Car      = 4;
  cikt_Element  = 5;

  cikt_Pool = "㯯 | ⥫쭮|ᢥ 室|᭮ ।⢠|࠭ᯮ ।⢠| ";
  cikt_Pool_Short = "|||||";

 IMPORT L_General, L_XObj, L_Str, L_DatTim, L_APtm, L_MathR, L_StdFrm, L_r2r, P_Firm, E_Pmnt;

 PUBLIC PROCEDURE PositionOnCostItem(trgCostItem: LIKE(CostItem.CostItem));
 BEGIN
  L_General.CallUs(SEARCH(CostItem, CostItem, trgCostItem));
 END {PositionOnCostItem};

 PUBLIC PROCEDURE CheckRequiredCostItem(trgCostItem: LIKE(CostItem.CostItem);
                                        reqLeaf    : LIKE(CostItem.Leaf);
                                        reqType    : tCIKType);
 BEGIN
  SAVE(CostItem);
  SAVE(CIKind);
  SEARCH(CostItem, CostItem, , trgCostItem);
  IF ~!reqLeaf & (CostItem.Leaf # reqLeaf) THEN
   IF reqLeaf THEN
    L_General.Error(" ᯮ짮  㯯 ");
   ELSE
    L_General.Error(" ᯮ짮 㯯 ");
   END;
  END;
  CONFORM(CostItem, CIKind);
  IF ~!reqType & (~OCCURE(CIKind) | (CIKind.Type # reqType)) THEN
   L_General.Error(" ᯮ짮   ⨯ '" + L_Str.PoolItem(cikt_Pool, reqType) + "'")
  END;
  RESTORE(CostItem);
  RESTORE(CIKind);
 END {CheckRequiredCostItem};

 PUBLIC PROCEDURE CheckActivityCostItem(trgCostItem: LIKE(CostItem.CostItem));
 BEGIN
  CheckRequiredCostItem(trgCostItem, 0, cikt_Activity);
 END {CheckActivityCostItem};

 PRIVATE PROCEDURE intGetActivityCostItem(ParentCI: LIKE(CostItem.CostItem);
                                          D       : DATE;
                                          _MyFirm : LIKE(MyFirm.MyFirm);
                                          byCar   : SCAL[2];
                                          Msg     : STRING[]): LIKE(CostItem.CostItem);
  VAR
   Result,
   _CostItem: LIKE(CostItem.CostItem);
   Local : PROC;
 BEGIN
  SAVE(CostItem);
  Local:=PROCREF(E_Pmnt.IsActivityCostItem);
  SEARCH(CostItem, CostItem, , ParentCI);
  IF CostItem.MyFirm = _MyFirm THEN
   Result:=ParentCI;
  ELSE
   SETEMPTY(Result);
  END;
  SELECT(CostItem, Parent, , ParentCI);
  WHILE OCCURE(CostItem) DO
   IF ~CostItem.Leaf & ~!CostItem.CIKind & L_DatTim.IsActive(D, CostItem.Begin, CostItem.Till) THEN
    CONFORM(CostItem, CIKind);
    IF CIKind.Type = cikt_Activity THEN
     IF Result = ParentCI THEN
      SETEMPTY(Result);
     END;
     IF ((CostItem.MyFirm = P_Firm.mf_Fict) | (CostItem.MyFirm = _MyFirm)) &
        (!Local | Local(D, byCar)) THEN
      _CostItem:=intGetActivityCostItem(CostItem.CostItem, D, _MyFirm, byCar, Msg);
      IF ~!_CostItem THEN
       L_General.Assert(!Result, "᪮쪮 "+Msg);
       Result:=_CostItem;
      END;
     END;
    END;
   END;
   NEXT(CostItem);
  END; (* WHILE OCCURE(CostItem) ... *)
  RESTORE(CostItem);
  RETURN Result;
 END {intGetActivityCostItem};

 PUBLIC PROCEDURE E_GetActivityCostItem(srcCostItem: LIKE(CostItem.CostItem);
                                        D          : DATE;
                                        trgMyFirm  : LIKE(MyFirm.MyFirm);
                                        byCar      : SCAL[2]): LIKE(CostItem.CostItem);
  VAR
   Result : LIKE(CostItem.CostItem);
   Msg    : STRING[];
 BEGIN
  CheckActivityCostItem(srcCostItem);
  Msg:="  ⨯ '" + L_Str.PoolItem(cikt_Pool, cikt_Activity) + "'   " + srcCostItem;
  Result:=intGetActivityCostItem(srcCostItem, D, trgMyFirm, byCar, Msg);
  L_General.Assert(~!Result, " । " + Msg);
  RETURN Result;
 END {E_GetActivityCostItem};

 PRIVATE PROCEDURE intGetElementCostItem(srcCostItem: LIKE(CostItem.CostItem);
                                         D          : DATE;
                                         trgMyFirm  : LIKE(MyFirm.MyFirm);
                                         trgNotion  : L_APtm.tNotion;
                                         Msg        : STRING[]): LIKE(CostItem.CostItem);
  VAR
   Result: LIKE(CostItem.CostItem);
 BEGIN
  SAVE(CostItem);
  SETEMPTY(Result);
  SETSEL(CostItem, Parent, srcCostItem);
  FOR_EACH CostItem DO
   IF CostItem.Leaf & (CostItem.MyFirm = trgMyFirm) & ~!CostItem.CIKind &
      L_DatTim.IsActive(D, CostItem.Begin, CostItem.Till) THEN
    CONFORM(CostItem, CIKind);
    IF L_kn.Is(D, trgNotion) THEN
     IF ~!Result THEN
      L_kn.AccessERKN("CIKind", trgNotion);
      L_StdFrm.WrongDB(Msg +': ᪮쪮   祭|"' + ERKN.Name + '"   ' + trgMyFirm);
     END;
     Result:=CostItem.CostItem;
    END;
   END;
  END; (* FOR_EACH CostItem *)
  IF !Result THEN
   L_kn.AccessERKN("CIKind", trgNotion);
   L_StdFrm.WrongDB(Msg +':  ।   祭|"' + ERKN.Name + '"   ' + trgMyFirm);
  END;
  RESTORE(CostItem);
  RETURN Result;
 END {intGetElementCostItem};

 PUBLIC PROCEDURE GetElementCostItem(srcCostItem: LIKE(CostItem.CostItem);
                                     D          : DATE;
                                     trgMyFirm  : LIKE(MyFirm.MyFirm);
                                     trgNotion  : L_APtm.tNotion): LIKE(CostItem.CostItem);
 BEGIN
  RETURN intGetElementCostItem(srcCostItem, D, trgMyFirm, trgNotion, "㯯  " + srcCostItem);
 END {GetElementCostItem};

 PUBLIC PROCEDURE GetElementOfActivityCostItem(srcCostItem: LIKE(CostItem.CostItem);
                                               D          : DATE;
                                               trgMyFirm  : LIKE(MyFirm.MyFirm);
                                               trgNotion  : L_APtm.tNotion;
                                               byCar      : SCAL[2]): LIKE(CostItem.CostItem);
  VAR
   ParentCI: LIKE(CostItem.CostItem);
   Msg     : STRING[];
 BEGIN
  ParentCI:=E_GetActivityCostItem(srcCostItem, D, trgMyFirm, byCar);
  Msg:="㯯  " + srcCostItem;
  IF ParentCI # srcCostItem THEN
   Msg:=Msg + " (" + ParentCI + ")";
  END;
  RETURN intGetElementCostItem(ParentCI, D, trgMyFirm, trgNotion, Msg);
 END {GetElementOfActivityCostItem};

 PUBLIC PROCEDURE GetMathByCostItem(trgCostItem: LIKE(CostItem.CostItem); D: DATE): LIKE(Math.Math);
  VAR
   curCostItem: LIKE(CostItem.CostItem);
   maxDate    : DATE; (*      CostItem   *)
   maxMath,
   Result     : LIKE(Math.Math);
 BEGIN
  SETEMPTY(Result);
  SAVE(CostItem);
  SAVE(Math);
  curCostItem:=trgCostItem;
  LOOP
   IF SELECT(MathKAGL, CostItem, curCostItem) THEN
    maxDate:=MINOF(DATE);
    maxMath:=EMPTYOF(Math.Math);
    WHILE OCCURE(MathKAGL) DO
     IF (MathKAGL.Date <= D) & (MathKAGL.Date > maxDate) THEN
      maxDate:=MathKAGL.Date;
      maxMath:=MathKAGL.Math;
      IF MathKAGL.DateE >= D THEN
       IF ~!Result THEN
        L_General.Error(" "+curCostItem+"  "+L_DatTim.DateStr(D)+" ६ 㪠  ᪮쪨 || "+Result+"  "+MathKAGL.Math);
       END;
       Result:=MathKAGL.Math;
      END;
     END;
     NEXT(MathKAGL);
    END;
    IF !Result THEN
     Result:=maxMath;
    END;
    EXIT;
   ELSE
    SEARCH(CostItem, CostItem, , curCostItem);
    IF ~!CostItem.Parent THEN
     curCostItem:=CostItem.Parent;
    ELSE
     EXIT;
    END;
   END; (* IF SELECT(MathKAGL, ... *)
  END; (* LOOP *)
  RESTORE(Math);
  RESTORE(CostItem);
  RETURN Result;
 END {GetMathByCostItem};

 PUBLIC PROCEDURE GetCarByCostItem(trgCostItem: LIKE(CostItem.CostItem); D: DATE): LIKE(Car.BoxNbr);
  VAR
   _Math : LIKE(Math.Math);
   Result: LIKE(Car.BoxNbr);
 BEGIN
  SETEMPTY(Result);
  SAVE(CarLog);
  _Math:=GetMathByCostItem(trgCostItem, D);
  IF ~!_Math & L_MathR.PosToLastCarLog(_Math, D) THEN
   Result:=CarLog.BoxNbr;
  END;
  RESTORE(CarLog);
  RETURN Result;
 END {GetCarByCostItem};

 PRIVATE PROCEDURE _CheckCIPro(_CostItem1, _CostItem2: LIKE(CostItem.CostItem)): SCAL[2];
  VAR
   _EndDate:  LIKE(CIPro.EndDate);
   _Value:    LIKE(CIPro.Value);
   _DocNum:   LIKE(CIPro.DocNum);
   _DocGiveS: LIKE(CIPro.DocGiveS);
   _DocGiveD: LIKE(CIPro.DocGiveD);
   _DocExpD:  LIKE(CIPro.DocExpD);
 BEGIN
  SELECT(CIPro, CostItem, , _CostItem1);
  WHILE OCCURE(CIPro) DO
   SAVE(CIPro);
   _EndDate :=CIPro.EndDate;
   _Value   :=CIPro.Value;
   _DocNum  :=CIPro.DocNum;
   _DocGiveS:=CIPro.DocGiveS;
   _DocGiveD:=CIPro.DocGiveD;
   _DocExpD :=CIPro.DocExpD;
   IF ~SEARCH(CIPro, CostItem, _CostItem2, CIPro.Property, CIPro.Date) |
      (_EndDate  # CIPro.EndDate)  |
      (_Value    # CIPro.Value)    |
      (_DocNum   # CIPro.DocNum)   |
      (_DocGiveS # CIPro.DocGiveS) |
      (_DocGiveD # CIPro.DocGiveD) |
      (_DocExpD  # CIPro.DocExpD) THEN
    RESTORE(CIPro);
    RETURN 0;
   END;
   RESTORE(CIPro);
   NEXT(CIPro);
  END; (* WHILE OCCURE(CIPro) ... *)
  RETURN 1;
 END {_CheckCIPro};

 PRIVATE PROCEDURE CheckCIPro(_CostItemSrc, _CostItemDst: LIKE(CostItem.CostItem));
 BEGIN
  IF ~_CheckCIPro(_CostItemSrc, _CostItemDst) |
     ~_CheckCIPro(_CostItemDst, _CostItemSrc) THEN
   STDMSG(" ᮢ ᢮⢠ | 㢥७,   ꥤ  ꥪ?", CHOICE);
  END;
 END {CheckCIPro};

 PUBLIC PROCEDURE MergeCostItem(_CostItemSrc, _CostItemDst: LIKE(CostItem.CostItem));
  VAR
   SrcName,
   DstName   : STRING[42];
   SrcMyFirm : LIKE(CostItem.MyFirm);
   SrcCIKind : LIKE(CostItem.CIKind);
   SrcLeaf   : LIKE(CostItem.Leaf);
   SrcParent : LIKE(CostItem.Parent);
   SrcACSet  : LIKE(CostItem.ACSet);
   SrcXObject: LIKE(CostItem.XObject);
 BEGIN
  APP.Get().NewPrompt(_CostItemSrc + " -> " + _CostItemDst);
  SEARCH(CostItem, CostItem, , _CostItemSrc);
  L_r2r.Owner_OnBeforeDelete("CostItem");

  SrcName   :=CostItem.Name;
  SrcMyFirm :=CostItem.MyFirm;
  SrcCIKind :=CostItem.CIKind;
  SrcLeaf   :=CostItem.Leaf;
  SrcParent :=CostItem.Parent;
  SrcACSet  :=CostItem.ACSet;
  SrcXObject:=CostItem.XObject;
  SEARCH(CostItem, CostItem, , _CostItemDst);
  DstName   :=CostItem.Name;

  L_StdFrm.Choice(" ᯮ짮 |" +
                  "|" +
                  _CostItemSrc + " " + SrcName + "|" +
                  "|" +
                  _CostItemDst + " " + DstName);

  L_General.Assert(SrcLeaf  =CostItem.Leaf,   " ᪫ 㯯  !");
  L_General.Assert(SrcMyFirm=CostItem.MyFirm, " ᮢ ' ࣠樨'!");
  L_General.Assert(SrcParent=CostItem.Parent, " ᮢ 㯯!");
  L_General.Assert(SrcCIKind=CostItem.CIKind, " ᮢ !");
  L_General.Assert(SrcACSet =CostItem.ACSet,  " ᮢ  ࠧ१!");

  CheckCIPro(_CostItemSrc, _CostItemDst);

  L_XObj.MergeXObject(SrcXObject, CostItem.XObject);

  SETSEL(CIPro, CostItem, _CostItemSrc);
  REMSEL(CIPro);

  TRY [INTEGRITY(INTEGRITY_OFF)]
   SEARCH(CostItem, CostItem, , _CostItemSrc);
   CONFORM(CostItem, XObject);
   REMOVE(CostItem);
 
   SEARCH(CostItem, CostItem, , _CostItemDst);
   CostItem.CostItem:=_CostItemSrc;
   REPLACE(CostItem);
  EXCEPT
  END;

  TRY [INTEGRITY(INTEGRITY_ON)]
   REMOVE(XObject);
   CostItem.CostItem:=_CostItemDst;
   REPLACE(CostItem);
  EXCEPT
  END;
 END {MergeCostItem};

END.