(*
%Copyright   (c) Polak IT
%Author      20.08.2004 09:14:07 POLAK\LDA
%Purpose     ⥪  ࠡ  ࠬ
%Type        library
%Specific    SYS
%Modified    14.07.2014 17:48:25 POLAK\GAV
%Environment
*)

 MODULE L_Cntr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  ct_Prch = 0;
  ct_Sell = 1;
  ct_Pool = "㯪|த";

  iit_Contract         = 0;
  iit_ContractTemplate = 1;
  iit_CntrTGroup       = 2;
  iit_FirmGroup        = 3;
  iit_Pool = "| |㯯஢筠 |㯯஢筠 ";

  erkn_Fictive       = 010265200;
  erkn_TckRcSale     = 010265201;
  erkn_TAF_PFIn      = 010265202;
  erkn_TAF_PFAc      = 010265203;
  erkn_TAF_xFSS      = 010265204;
  erkn_TAF_MSFF      = 010265205;
  erkn_TAF_MSTF      = 010265206;
  erkn_TAF_TrOb      = 010265207;
  erkn_TAF_PFA2      = 010265208;
  erkn_TAF_PFA1      = 010265209;
  erkn_TAF_NDFL      = 010438300;

 IMPORT L_General, L_DatTim, L_Str, L_XDoc, L_Pmnt, L_XObj, L_MSO, L_APtm, L_r2r, L_Staff,
        P_Firm, P_Cntr, Str, E_Prop, L_Acnt, L_StdFrm, P_MDoc, L_kn;

 PUBLIC PROCEDURE erkn_GetSoft(D: DATE; trgNotion: L_APtm.tNotion; trgMyFirm: P_Firm.tMyFirm): LIKE(Contract.Contract);
 BEGIN
  RETURN L_kn.GetSoft_wMF(D, trgNotion, trgMyFirm);
 END {erkn_GetSoft};

 PUBLIC PROCEDURE erkn_Get(D: DATE; trgNotion: L_APtm.tNotion; trgMyFirm: P_Firm.tMyFirm): LIKE(Contract.Contract);
 BEGIN
  RETURN L_kn.Get_wMF(D, trgNotion, trgMyFirm);
 END {erkn_Get};

 PUBLIC PROCEDURE PositionOnContract(_Contract: LIKE(Contract.Contract));
 BEGIN
  L_General.CallUs(SEARCH(Contract, Contract, _Contract));
 END {PositionOnContract};

 PUBLIC PROCEDURE IsFictiveContract(_Contract: LIKE(Contract.Contract)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF ~!_Contract THEN
   SAVE(Contract);
   SEARCH(Contract, Contract, , _Contract);
   Result:=L_kn.Is(SYSDATE(), erkn_Fictive);
   RESTORE(Contract);
  END;
  RETURN Result;
 END {IsFictiveContract};

 PUBLIC PROCEDURE GetContractiiType_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(iit_Pool, Contract.iiType);
 END {GetContractiiType_asStr};

 PUBLIC PROCEDURE GetContractLeaf_asStr(): STRING[];
 BEGIN
  IF    Contract.Leaf = 1 THEN
   RETURN "";
  ELSIF Contract.iiType = iit_ContractTemplate THEN
   RETURN " ";
  ELSE
   RETURN "㯯஢筠 ";
  END;
 END {GetContractLeaf_asStr};

 PUBLIC PROCEDURE GetContractType_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(ct_Pool, Contract.Type);
 END {GetContractType_asStr};

 PRIVATE PROCEDURE DecodeContractId(_ContractId  : STRING[];
                                    VAR _Contract: LIKE(Contract.Contract));
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
 BEGIN
  L_XDoc.DecodeXDocId(_ContractId, _XDocType, _XDocKind, _Contract);
  L_General.Assert(_XDocType = L_XDoc.xdt_Contract,
                   "L_Cntr.DecodeContractId.Error 1");
 END {DecodeContractId};

 PUBLIC PROCEDURE ContractNbr(): STRING[];
 BEGIN
  IF ~!Contract.SrcNbr THEN
   RETURN Contract.SrcNbr+" ("+Contract.Contract+")";
  ELSE
   RETURN "/ "+" ("+Contract.Contract+")";
  END;
 END {ContractNbr};

 PRIVATE PROCEDURE SetCntrProperty(_Contract: LIKE(Contract.Contract); d: DATE; Strong: SCAL[2]; PropName, _subplist: STRING[]);
  VAR
   _Property: LIKE(Property.Property);
   _name, t: STRING[];
 BEGIN
  TRY
   _Property:=^("E_Prop.P_"+PropName);
  EXCEPT
  ON Ex: Exc_Raise DO
   IF Ex.ErrorCode=4 THEN
    _Property:=^("P_Cntr.P_"+PropName);
   ELSE
    RAISE();
   END;
  END;
  IF Strong THEN
   t:=P_Cntr.GetCntrProStrong(_Contract, d, _Property);
  ELSE
   t:=P_Cntr.GetCntrProSoft(_Contract, d, _Property);
  END;
  _name:="Contract."+PropName;
  L_MSO.SetValueDerivatives(_name, t, _subplist);
  IF Strong THEN
   L_MSO.wordSetDateVar(_name+".Date",    P_Cntr.GetCntrProDate   (_Contract, d, _Property));
   L_MSO.wordSetDateVar(_name+".EndDate", P_Cntr.GetCntrProEndDate(_Contract, d, _Property));
  END;
 END {SetCntrProperty};

 PUBLIC PROCEDURE SetConsignees(OnDate: DATE);
  VAR
   Idx  : NUMERIC[0];
   Firms: LIKE(Firm.Firm)[P_Cntr.FirmsAmount];
 BEGIN
  Idx:=0;
  IF P_Cntr.HasActualPro(Contract.Contract, OnDate, P_Cntr.P_Consignees) THEN
   P_Cntr.Decode_PaymentAgents(CntrPro.Value, Firms);
   WHILE ~!Firms[Idx] DO
    P_Firm.SetFirmData_wAlias("Contract.Consignee" + L_MSO.IndexStr(Idx), Firms[Idx], OnDate, "", "");
    INC(Idx);
   END;
  END;
  L_MSO.extSetWordTable("Consignees", Idx, L_MSO.tt_Soft);
 END {SetConsignees};

 PRIVATE PROCEDURE wordSetAgentVars(trgProperty: LIKE(Property.Property);
                                    trgMDocKind: LIKE(MDocKind.MDocKind);
                                    trgMDoc    : LIKE(MDoc.MDoc);
                                    trgContract: LIKE(Contract.Contract);
                                    trgFirm    : LIKE(Firm.Firm);
                                    D          : DATE;
                                    r          : STRING[]);
  VAR
   trgTSN   : LIKE(Staff.TSN);
   DocExpD,
   DocGiveD : DATE;
   CntrSum  : NUMERIC[2];
   Dummy,
   Name,
   PostName,
   PropVal,
   DocKind,
   DocSer,
   DocNum,
   DocGiveS,
   SignatureDecoding,
   SignatureDecoding_wPostName,
   SignatureDecoding_woPostName,
   NameInTheAct,
   ContractorName,
   Full,
   LeaderName,
   LeaderPostName : STRING[];
   FirmPrtnrTyp   : P_Firm.tPartnerType;
   ContractSideName : STRING[][6];
 BEGIN
  SETEMPTY(PropVal, Name, PostName, DocKind, DocSer, DocNum, DocGiveS, DocGiveD, DocExpD, CntrSum,
           ContractSideName, ContractorName);
  IF    trgProperty = P_Cntr.P_OwnAgent THEN
   SETEMPTY(trgTSN);
   IF ~!trgContract THEN
    PropVal:=P_Cntr.GetCntrProSoft(trgContract, D, P_Cntr.P_OwnAgent);
    P_Cntr.Get_FullOwnAgentInfo(trgContract, D, trgTSN, DocKind, DocSer, DocNum, DocGiveS, DocGiveD, DocExpD, CntrSum);
    IF ~!trgTSN THEN
     Name    :=P_Firm.GetManAttrByTSN(trgTSN, D, P_Firm.mpt_ManName);
     PostName:=P_Firm.GetManAttrByTSN(trgTSN, D, P_Firm.mpt_ManPostName);
    END;
   END;
   IF ~!trgContract THEN
    P_Cntr.GetContractorsName(trgContract, D, ContractorName, Dummy);
   END;
  ELSIF trgProperty = P_Cntr.P_PartnerAgent THEN
   IF ~!trgMDocKind & ~!trgMDoc THEN
    PropVal:=P_MDoc.GetMDocProSoft(trgMDocKind, trgMDoc, P_MDoc.P_PartnerAgent);
    IF ~!PropVal THEN
     P_MDoc.Decode_PartnerAgent(PropVal,
                                Name,
                                PostName,
                                DocKind,
                                DocSer,
                                DocNum,
                                DocGiveS,
                                DocGiveD,
                                DocExpD);
    END;
   END;
   IF ~!trgContract THEN
    P_Cntr.GetContractorsName(trgContract, D, Dummy, ContractorName);
   END;
   IF !PropVal & ~!trgContract THEN
    PropVal:=P_Cntr.GetCntrProSoft(trgContract, D, P_Cntr.P_PartnerAgent);
    P_Cntr.Get_FullPartnerAgentInfo(trgContract, D, Name, PostName, DocKind, DocSer, DocNum, DocGiveS, DocGiveD, DocExpD);
   END;
  ELSE
   L_General.CallUs(0);
  END;

  L_MSO.wordSetVar(r, PropVal);
  r:=r + ".";

  IF ~!trgFirm  THEN
   FirmPrtnrTyp:=P_Firm.FP_PrtnrTyp(trgFirm, D);
   IF ~!ContractorName THEN
    IF (FirmPrtnrTyp = P_Firm.pt_Firm) | (FirmPrtnrTyp = P_Firm.pt_Branch) THEN
     ContractSideName[0]:=', 㥬  쭥襬 "' + ContractorName + '"';
    ELSE
     ContractSideName[0]:=', 㥬(-)  쭥襬 "' + ContractorName + '"';
    END;
   END;
  END;

  IF ~!PropVal THEN
   Full:=DocKind;
   IF ~!DocSer   THEN Full:=Full + "  " + DocSer; END;
   IF ~!DocNum   THEN Full:=Full + " " + DocNum; END;
   IF ~!DocGiveD THEN Full:=Full + ", 뤠 " + L_DatTim.DateStr(DocGiveD); END;
   SignatureDecoding_woPostName:=L_Str.ShortName(Str.Cap(Name, 0, 1));
   ContractSideName[2]:=Str.Cap(PostName, 0, 1) + " " + SignatureDecoding_woPostName;
   IF ~!Full THEN
    SignatureDecoding_woPostName:=SignatureDecoding_woPostName + " ( ⢥ত 㬥: " + Full + ")";
    ContractSideName[3]:=" ( ⢥ত 㬥: ";
    ContractSideName[4]:=Full;
    ContractSideName[5]:=")";
   END;
   SignatureDecoding_wPostName :=Str.Cap(PostName, 0, 1) + " " + SignatureDecoding_woPostName;
   SignatureDecoding           :=SignatureDecoding_wPostName;
   NameInTheAct                :=SignatureDecoding_wPostName;
  ELSE
   SETEMPTY(Full, SignatureDecoding, SignatureDecoding_wPostName, SignatureDecoding_woPostName, NameInTheAct);
   IF ~!trgFirm THEN
    LeaderPostName:=Str.Cap(P_Firm.extFP_LeadPostName1(0, trgFirm, D), 0, 1);
    LeaderName    :=Str.Cap(P_Firm.extFP_LeadName     (0, trgFirm, D), 0, 1);
    SignatureDecoding_wPostName:=LeaderPostName;
    IF ~!LeaderName THEN
     SignatureDecoding_woPostName:=L_Str.ShortName(LeaderName);
     SignatureDecoding           :=SignatureDecoding_woPostName;
     SignatureDecoding_wPostName :=L_Str.AddStrDlm(SignatureDecoding_wPostName, " ") + SignatureDecoding;
    END;
    IF (FirmPrtnrTyp = P_Firm.pt_Firm) | (FirmPrtnrTyp = P_Firm.pt_Branch) THEN
     ContractSideName[2]:=SignatureDecoding_wPostName;
    END;
    NameInTheAct:=SignatureDecoding_wPostName;
    IF P_Firm.HasActualFirmPro(trgFirm, D, P_Firm.P_BasisOfLeaderActivity) THEN
     ContractSideName[3]:=",   ᭮ ";
     ContractSideName[4]:=P_Firm.FP_BasisOfLeaderActivity(trgFirm, D);
     NameInTheAct:=NameInTheAct + ContractSideName[3] + ContractSideName[4];
    END;
   END;
  END;
  IF (~!PropVal |
      (~!trgFirm & ((FirmPrtnrTyp = P_Firm.pt_Firm) | (FirmPrtnrTyp = P_Firm.pt_Branch)))) &
     ~!ContractSideName[2] THEN
   ContractSideName[1]:=", 祩 ।⠢⥫ - ";
  END;
  L_MSO.wordSetVar    (r+"Name",                         Name);
  L_MSO.wordSetVar    (r+"Name.Short",                   L_Str.ShortName(Name));
  L_MSO.wordSetVar    (r+"Post.Name",                    PostName);
  L_MSO.wordSetVar    (r+"Document.Full",                Full);
  L_MSO.wordSetVar    (r+"Document.Kind",                DocKind);
  L_MSO.wordSetVar    (r+"Document.Ser",                 DocSer);
  L_MSO.wordSetVar    (r+"Document.Nbr",                 DocNum);
  L_MSO.wordSetVar    (r+"Document.GiveS",               DocGiveS);
  L_MSO.wordSetDateVar(r+"Document.GiveD",               DocGiveD);
  L_MSO.wordSetDateVar(r+"Document.ExpD",                DocExpD);
  L_MSO.wordSetVar    (r+"NameInTheAct",                 NameInTheAct);
  L_MSO.wordSetVar    (r+"ContractSideName.p0",          ContractSideName[0]);
  L_MSO.wordSetVar    (r+"ContractSideName.p1",          ContractSideName[1]);
  L_MSO.wordSetVar    (r+"ContractSideName.p2",          ContractSideName[2]);
  L_MSO.wordSetVar    (r+"ContractSideName.p3",          ContractSideName[3]);
  L_MSO.wordSetVar    (r+"ContractSideName.p4",          ContractSideName[4]);
  L_MSO.wordSetVar    (r+"ContractSideName.p5",          ContractSideName[5]);
  L_MSO.wordSetVar    (r+"SignatureDecoding",            SignatureDecoding);
  L_MSO.wordSetVar    (r+"SignatureDecoding.wPostName",  SignatureDecoding_wPostName);
  L_MSO.wordSetVar    (r+"SignatureDecoding.woPostName", SignatureDecoding_woPostName);
  IF    L_Str.IsStrInStr(r, "OwnAgent")     THEN
   r:=Str.Replace(r, "OwnAgent",     "OwnAsLeader");
  ELSIF L_Str.IsStrInStr(r, "PartnerAgent") THEN
   r:=Str.Replace(r, "PartnerAgent", "PartnerAsLeader");
  ELSE
   L_General.CallUs(0);
  END;
  IF !PropVal & ~!trgFirm THEN
   Name    :=LeaderName;
   PostName:=LeaderPostName;
  END;
  L_MSO.wordSetVar     (r+"Name",                         Name);
  L_MSO.wordSetVar     (r+"Name.Short",                   L_Str.ShortName(Name));
  L_MSO.wordSetVar     (r+"Post.Name",                    PostName);
  L_MSO.wordSetVar     (r+"NameInTheAct",                 NameInTheAct);
  L_MSO.wordSetVar     (r+"SignatureDecoding",            SignatureDecoding);
  L_MSO.wordSetVar     (r+"SignatureDecoding.wPostName",  SignatureDecoding_wPostName);
  L_MSO.wordSetVar     (r+"SignatureDecoding.woPostName", SignatureDecoding_woPostName);
  L_MSO.wordSetMoneyVar(r+"CntrSum", D,                   CntrSum);
 END {wordSetAgentVars};

 PUBLIC PROCEDURE wordSetMainAcntVars(trgContract: LIKE(Contract.Contract);
                                      D          : DATE;
                                      r          : STRING[]);
  VAR
   trgTSN: LIKE(Staff.TSN);
   Dummy : SCAL[2];
 BEGIN
  trgTSN:=P_Cntr.GetCntrProSoft(trgContract, D, P_Cntr.P_MainAcntSigner);
  IF ~!trgTSN THEN
   L_Staff.SetSignerVarsByStaff(r, D, trgTSN);
  END;
 END {wordSetMainAcntVars};

 PUBLIC PROCEDURE wordSetPartnerAgentVars(trgMDocKind: LIKE(MDocKind.MDocKind);
                                          trgMDoc    : LIKE(MDoc.MDoc);
                                          trgContract: LIKE(Contract.Contract);
                                          trgFirm    : LIKE(Firm.Firm);
                                          D          : DATE;
                                          r          : STRING[]);
 BEGIN
  wordSetAgentVars(P_Cntr.P_PartnerAgent, trgMDocKind, trgMDoc, trgContract, trgFirm, D, r);
 END {wordSetPartnerAgentVars};

 PUBLIC PROCEDURE wordSetOwnAgentVars(trgContract: LIKE(Contract.Contract);
                                      trgFirm    : LIKE(Firm.Firm);
                                      D          : DATE;
                                      r          : STRING[]);
 BEGIN
  wordSetAgentVars(P_Cntr.P_OwnAgent, EMPTYOF(MDoc.MDocKind), EMPTYOF(MDoc.MDoc), trgContract, trgFirm, D, r);
 END {wordSetOwnAgentVars};

 PRIVATE PROCEDURE _CheckCntrPro(_Contract1, _Contract2: LIKE(Contract.Contract)): SCAL[2];
  VAR
   _EndDate:  LIKE(CntrPro.EndDate);
   _Value:    LIKE(CntrPro.Value);
   _DocNum:   LIKE(CntrPro.DocNum);
   _DocGiveS: LIKE(CntrPro.DocGiveS);
   _DocGiveD: LIKE(CntrPro.DocGiveD);
   _DocExpD:  LIKE(CntrPro.DocExpD);
 BEGIN
  SELECT(CntrPro, Contract, , _Contract1);
  WHILE OCCURE(CntrPro) DO
   SAVE(CntrPro);
   _EndDate :=CntrPro.EndDate;
   _Value   :=CntrPro.Value;
   _DocNum  :=CntrPro.DocNum;
   _DocGiveS:=CntrPro.DocGiveS;
   _DocGiveD:=CntrPro.DocGiveD;
   _DocExpD :=CntrPro.DocExpD;
   IF ~SEARCH(CntrPro, Contract, _Contract2, CntrPro.Property, CntrPro.Date) |
      (_EndDate  # CntrPro.EndDate)  |
      (_Value    # CntrPro.Value)    |
      (_DocNum   # CntrPro.DocNum)   |
      (_DocGiveS # CntrPro.DocGiveS) |
      (_DocGiveD # CntrPro.DocGiveD) |
      (_DocExpD  # CntrPro.DocExpD) THEN
    RESTORE(CntrPro);
    RETURN 0;
   END;
   RESTORE(CntrPro);
   NEXT(CntrPro);
  END; (* WHILE OCCURE(CntrPro) ... *)
  RETURN 1;
 END {_CheckCntrPro};

 PRIVATE PROCEDURE CheckCntrPro(_ContractSrc, _ContractDst: LIKE(Contract.Contract));
 BEGIN
  IF ~_CheckCntrPro(_ContractSrc, _ContractDst) |
     ~_CheckCntrPro(_ContractDst, _ContractSrc) THEN
   L_StdFrm.Choice(" ᮢ ᢮⢠ ஢| 㢥७,   ꥤ  ꥪ?");
  END;
 END {CheckCntrPro};

 PUBLIC PROCEDURE IsBudgetContract(trgContract: LIKE(Contract.Contract); D: DATE): SCAL[2];
  VAR
   curSign : LIKE(AcCut.Sign);
 BEGIN
  curSign:=L_Acnt.GetAcCutSign(D, L_Acnt.GetSpecificAcCutForContract(trgContract, L_Acnt.acp_Contract_Netto));
  RETURN Str.Match(curSign, "68*") | Str.Match(curSign, "69*");
 END {IsBudgetContract};

 PUBLIC PROCEDURE MergeContract(_ContractSrc, _ContractDst: LIKE(Contract.Contract));
  VAR
   SrcName,
   DstName   : STRING[42];
   SrcMyFirm : LIKE(Contract.MyFirm);
   SrcType   : LIKE(Contract.Type);
   SrcFirm   : LIKE(Contract.Firm);
   SrcLeaf   : LIKE(Contract.Leaf);
   SrcParent : LIKE(Contract.Parent);
   SrcACSet  : LIKE(Contract.ACSet);
   SrcXObject: LIKE(Contract.XObject);
 BEGIN
  APP.Get().NewPrompt(_ContractSrc + " -> " + _ContractDst);
  SEARCH(Contract, Contract, , _ContractSrc);
  L_r2r.Owner_OnBeforeDelete("Contract");

  SrcName   :=Contract.Name;
  SrcMyFirm :=Contract.MyFirm;
  SrcType   :=Contract.Type;
  SrcFirm   :=Contract.Firm;
  SrcLeaf   :=Contract.Leaf;
  SrcParent :=Contract.Parent;
  SrcACSet  :=Contract.ACSet;
  SrcXObject:=Contract.XObject;
  SEARCH(Contract, Contract, , _ContractDst);
  DstName:=Contract.Name;

  L_StdFrm.Choice(" ᯮ짮 " +
                  "| |" +
                  _ContractSrc + " " + SrcName +
                  "|" +
                  "" +
                  "|" +
                  _ContractDst + " " + DstName);

  L_General.Assert(SrcLeaf  =Contract.Leaf,   " ᪫ 蠡  !");
  L_General.Assert(SrcMyFirm=Contract.MyFirm, " ᮢ ' ࣠樨'!");
  L_General.Assert(SrcParent=Contract.Parent, " ᮢ 蠡!");
  L_General.Assert(SrcType  =Contract.Type,   " ᮢ  ஢!");
  L_General.Assert(SrcFirm  =Contract.Firm,   " ᮢ ࠣ!");
  L_General.Assert(SrcACSet =Contract.ACSet,  " ᮢ  ࠧ१!");

  CheckCntrPro(_ContractSrc, _ContractDst);

  L_XObj.MergeXObject(SrcXObject, Contract.XObject);

  SELECT(CntrPro, Contract, , _ContractSrc);
  WHILE OCCURE(CntrPro) DO
   L_Prop.RemoveCurrentPro("CntrPro");
  END; (* WHILE OCCURE(CntrPro) ... *)

  TRY [INTEGRITY(INTEGRITY_OFF)]
   SEARCH(Contract, Contract, , _ContractSrc);
   CONFORM(Contract, XObject);
   REMOVE(Contract);
 
   SEARCH(Contract, Contract, , _ContractDst);
   Contract.Contract:=_ContractSrc;
   REPLACE(Contract);
  EXCEPT
  END;

  TRY [INTEGRITY(INTEGRITY_ON)]
   REMOVE(XObject);
   Contract.Contract:=_ContractDst;
   REPLACE(Contract);
  EXCEPT
  END;
 END {MergeContract};

 PUBLIC PROCEDURE ReplicationFirmNameToContract();
 BEGIN
  IF ~!Contract.Firm THEN
   CONFORM(Contract, Firm);
   PROMPT("  ࠣ " + Contract.Contract);
   IF Contract.iiType = iit_FirmGroup THEN
    Contract.Name:=Firm.Name;
   END;
   IF Contract.Leaf = 1 THEN
    Contract.AddInf:=Str.Align(Str.Slice(Firm.Name, 0, Str.MaxLength(Contract.AddInf) - Str.Length(Contract.SrcNbr)-1), Str.MaxLength(Contract.AddInf) - Str.Length(Contract.SrcNbr) - 1, LEFT) + " " + Contract.SrcNbr;
   END;
   REPLACE(Contract);
  END;
 END {ReplicationFirmNameToContract};

 PUBLIC PROCEDURE ReplicationCntrTNameToContract();
 BEGIN
  CONFORM(Contract, CntrT);
  PROMPT("    " + Contract.Contract);
  IF    Contract.iiType = iit_CntrTGroup THEN
   Contract.Name:=CntrT.Name;
  ELSIF Contract.Leaf = 0 THEN
   Contract.AddInf:=Str.Slice(Contract.CntrT +  " " + CntrT.Name, 0, Str.MaxLength(Contract.AddInf));
  END;
  REPLACE(Contract);
 END {ReplicationCntrTNameToContract};

 PUBLIC PROCEDURE CheckIsContract();
 BEGIN
  L_General.Assert(Contract.Leaf = 1, " 믮 ⮩ 樨 ॡ  ");
 END {CheckIsContract};

 PUBLIC PROCEDURE intGetGroupParent(trg_iiType       : LIKE(Contract.iiType);
                                    Object           : SCAL[1E4];
                                    AfterModification: SCAL[2];
                                    Silent           : SCAL[2];
                                    curContract      : LIKE(Contract.Contract)): LIKE(Contract.Contract);
  VAR
   Result : LIKE(Contract.Contract);
   prnBegin,
   prnTill: DATE;
   leafCnt: NUMERIC[0];
 BEGIN
  SETEMPTY(Result);
  IF ~!Object THEN
   SETEMPTY(prnBegin);
   prnTill:=L_DatTim.MINDATE();
   IF    trg_iiType = iit_FirmGroup THEN
    SELECT(Contract, Firm, , Object);
   ELSIF trg_iiType = iit_CntrTGroup THEN
    SELECT(Contract, CntrT, , Object);
   ELSE
    L_General.CallUs(0);
   END;
   leafCnt:=0;
   WHILE OCCURE(Contract) DO
    IF     (Contract.iiType = iit_Contract) & (AfterModification | (Contract.Contract # curContract)) THEN
     prnBegin:=L_DatTim.MinDATE(Contract.Begin, prnBegin);
     prnTill :=L_DatTim.MaxDATE(Contract.Till,  prnTill);
     INC(leafCnt);
    ELSIF Contract.iiType = trg_iiType THEN
     Result:=Contract.Contract;
    END;
    NEXT(Contract);
   END; (* WHILE OCCURE(Contract) ... *)
 
   IF    ~SEARCH(Contract, Contract, Result) THEN
    IF ~Silent THEN
     L_General.CallUs(AfterModification);
     DEFAULT(Contract);
     Contract.Leaf  :=0;
     Contract.MyFirm:=P_Firm.mf_Fict;
     Contract.iiType:=trg_iiType;
  
     IF    trg_iiType = iit_CntrTGroup THEN
      SEARCH(CntrT, CntrT, , Object);
      Contract.Name  :=CntrT.Name;
      Contract.CntrT :=CntrT.CntrT;
      Contract.Begin :=SYSDATE();
     ELSIF trg_iiType = iit_FirmGroup THEN
      SEARCH(Firm, Firm, , Object);
      Contract.Name  :=Firm.Name;
      Contract.Firm  :=Firm.Firm;
      Contract.Begin :=Firm.Begin;
      Contract.Till  :=Firm.Till;
     ELSE
      L_General.CallUs(0);
     END;
     INSERT(Contract);
     Result:=Contract.Contract;
    END;
   ELSE
    IF ~AfterModification & ~!curContract (*  ᪫ ࣠権 *) & (leafCnt = 0) THEN
     SAVE(Contract);
     L_General.CallUs(SEARCH(Contract, Contract, curContract));
     IF    trg_iiType = iit_CntrTGroup THEN
      SETEMPTY(Contract.prnCntrT);
      REPLACE(Contract);
     ELSIF trg_iiType = iit_FirmGroup THEN
      SETEMPTY(Contract.prnFirm);
     END;
     REPLACE(Contract);
     RESTORE(Contract);
     TRY [INTEGRITY(INTEGRITY_ON)]
      REMOVE(Contract);
      SETEMPTY(Result);
     EXCEPT
     END;
    ELSE
     IF !prnBegin THEN
      prnBegin:=SYSDATE();
      prnTill :=SYSDATE();
     END;
     Contract.Begin:=prnBegin;
     Contract.Till :=prnTill;
     REPLACE(Contract);
    END;
   END;
  END; (* IF ~!Object *)
  RETURN Result;
 END {intGetGroupParent};

 PRIVATE PROCEDURE GetGroupParent(_iiType          : LIKE(Contract.iiType);
                                  Object           : SCAL[1E4];
                                  AfterModification: SCAL[2]): LIKE(Contract.Contract);
  VAR
   _Parent,
   _Contract: LIKE(Contract.Contract);
 BEGIN
  _Contract:=Contract.Contract;
  SAVE(Contract);
  _Parent:=intGetGroupParent(_iiType, Object, AfterModification, 0, _Contract);
  RESTORE(Contract);
  RETURN _Parent;
 END {GetGroupParent};

 PUBLIC PROCEDURE UpdateGroupParent(_iiType: LIKE(Contract.iiType); Object: SCAL[1E4]; AfterModification: SCAL[2]);
  VAR
   _Parent: LIKE(Contract.Contract);
 BEGIN
  _Parent  :=GetGroupParent(_iiType, Object, AfterModification);

  IF    _iiType = iit_FirmGroup THEN
   Contract.prnFirm:=_Parent;
  ELSIF _iiType = iit_CntrTGroup THEN
   Contract.prnCntrT:=_Parent;
  END;
  REPLACE(Contract);
 END {UpdateGroupParent};

 PUBLIC PROCEDURE SetupXObjectByErknedContract(P             : DATE;
                                               trgNotion     : L_APtm.tNotion;
                                               trgMyFirm     : P_Firm.tMyFirm;
                                               VAR trgXObject: LIKE(XObject.XObject);
                                               VAR trgAcCut  : LIKE(AcCut.AcCut));
 BEGIN
  SEARCH(Contract, Contract, , erkn_Get(P, trgNotion, trgMyFirm));
  trgXObject:=Contract.XObject;
  trgAcCut  :=L_Acnt.GetSpecificAcCutForContract(Contract.Contract, L_Acnt.acp_Contract_Netto);
 END {SetupXObjectByErknedContract};

END.
