(*
%Copyright   (c) Polak IT
%Author      05.12.2006 09:15:19 POLAK\San
%Purpose     প ࠡ  ⠪⠬
%Type        library
%Specific    SYS
%Modified    07.04.2014 15:54:45 POLAK\GAV
%Environment
*)

 MODULE L_ctc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tOrigin     = SCAL[3];
  tCoverage   = SCAL[3];
  tValType    = SCAL[16];
  tCKType     = SCAL[16];
  tValInherit = SCAL[3];
  tCallMth    = SCAL[2];
  tMap        = SCAL[2];

 PUBLIC CONST
  m_Google = 0; (* tMap *)
  m_Yandex = 1;

  DualPhone_SESValId  = "DualPhone";
  cm_Pool     = "ᯮ URL 'SIP:'|Asterisk:call-file";
  cm_URLSIP   = 0; (*tCallMth*)
  cm_CallFile = 1;

  o_Man       = 00;
  o_Officer   = 01;
  o_FirmCtc   = 02;

  cvi_NotInherit   = 0;(*CtcVal.Inherit*)
  cvi_Inherit      = 1;
  cvi_wApplExt     = 2;

  cvc_Work  = 0;   (*CtcVal.Coverage*)
  cvc_Home  = 1;
  cvc_Other = 2;
  cvc_Pool = "稩||稩";
  cvc_PoolShort = "||";

  ckt_OtherPerson  = 0; (*CtcKind.Type*)
  ckt_OtherGroup   = 1;
  ckt_Common       = 2;
  ckt_Leader       = 3;
  ckt_MainAcnt     = 4;
  ckt_AcntDep      = 5;
  ckt_DftCtcPerson = 6;
  ckt_Pool = "稩 ᮭ|稩 㯯|騩|㪮⥫| 壠|騩 壠ਨ|⠪⭮ ";

  cvt_PhonePST  =  0; (*CtcVal.Type*)
  cvt_PhoneClr  =  1;
  cvt_PhoneLoc  =  2;
  cvt_Fax       =  3;
  cvt_SIP       =  4;
  cvt_Email     =  5;
  cvt_SMSEml    =  6;
  cvt_WWW       =  7;
  cvt_FTP       =  8;
  cvt_IM        =  9;
  cvt_Skype     = 10;
  cvt_Extension = 11;

  cvt_Pool       = "䮭|䮭 ⮢|䮭 ||SIP|e-mail|e-mail  SMS|WWW|FTP|IM|Skype| ";
  cvt_PoolShort  = "||||SIP||SMS|WWW|FTP|IM |Skp";

  cat_Reg        = 0; (* CtcAdr.Type *)
  cat_Fct        = 1;
  cat_Pst        = 2;
  cat_Pool       = "樨|᪨| ९᪨";
  cat_PoolShort  = "||";

  o_Pool = "|祥 |⠪ ࠣ";

  erkn_DispatcherOffice  = 010311700;

 IMPORT Str, L_Str, L_General, L_DatTim, L_Env, Math, L_Prop, E_Utils, L_SES, FIO, L_FIO, L_Russia, L_SES,
        P_Firm, L_AFM, L_APtm, L_SysLog, L_EMail, L_StdFrm;

 TYPE
  tCtcListSource = SCAL[2];
  tLstSource     = SCAL[4];

 PUBLIC CONST
  cls_CtcVal = 0; (*tCtcListSource*)
  cls_CtcAdr = 1;

  ls_Firm           = 0; (*tLstSource*)
  ls_FirmCtc        = 1;
  ls_Contact        = 2;
  ls_FirmForJournal = 3;

  cl_w_Value    = 60;
  cl_w_Comment  = 20;

 PRIVATE CONST
  o_Files = "Man|Officer|FirmCtc";

 PUBLIC PROCEDURE cl_w_Total(): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  GE_APPWIN_SIZE(Result);
  RETURN Result - 14;
 END {cl_w_Total};

 PUBLIC PROCEDURE GetCallMth(VAR CallMth: tCallMth;
                             VAR Number : STRING[]);
  VAR
   _Value: STRING[];
 BEGIN
  CallMth:=cm_URLSIP;
  SETEMPTY(_Value, Number);
  IF L_SES.GetValue(L_SES.sit_StationAcsObj, DualPhone_SESValId, _Value) THEN
   CallMth:=STRTOFLD(L_Str.AnyItem(_Value, ";", 0), SCAL);
   Number :=L_Str.AnyItem(_Value, ";", 1);
  END;
 END {GetCallMth};

 PUBLIC PROCEDURE GetCtcValType_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(cvt_Pool, CtcVal.Type);
 END {GetCtcValType_AsStr};

 PUBLIC PROCEDURE GetCtcKindType_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(ckt_Pool, CtcKind.Type);
 END {GetCtcKindType_AsStr};

 PUBLIC PROCEDURE GetCtcValCoverage_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(cvc_Pool, CtcVal.Coverage);
 END {GetCtcValCoverage_AsStr};

 PUBLIC PROCEDURE cvt_IswApplExtPhone(cvt: tValType): SCAL[2];
 BEGIN
  RETURN (cvt = cvt_PhonePST) | (cvt = cvt_PhoneClr);
 END {CtcValIswApplExtPhone};

 PUBLIC PROCEDURE CtcValIswApplExtPhone(): SCAL[2];
 BEGIN
  RETURN cvt_IswApplExtPhone(CtcVal.Type);
 END {CtcValIswApplExtPhone};

 PUBLIC PROCEDURE CtcValIsPhone(): SCAL[2];
 BEGIN
  RETURN (CtcVal.Type = cvt_PhonePST) | (CtcVal.Type = cvt_PhoneClr) | (CtcVal.Type = cvt_SIP) | (CtcVal.Type = cvt_Skype);
 END {CtcValIsPhone};

 PUBLIC PROCEDURE CtcTypeIsPerson(_Type: LIKE(CtcKind.Type)): SCAL[2];
 BEGIN
  RETURN (_Type # ckt_OtherGroup) & (_Type # ckt_Common) & (_Type # ckt_AcntDep);
 END {CtcTypeIsPerson};

 PUBLIC PROCEDURE CtcTypeMustBeUnique(_Type: LIKE(CtcKind.Type)): SCAL[2];
 BEGIN
  RETURN (_Type = ckt_Common) | (_Type = ckt_Leader) | (_Type = ckt_MainAcnt) |
         (_Type = ckt_AcntDep) | (_Type = ckt_DftCtcPerson);
 END {CtcTypeMustBeUnique};

 PUBLIC PROCEDURE IsDependentContact(): SCAL[2];
 BEGIN
  RETURN (Contact.Origin = o_Man);
 END {IsDependentContact};

 PUBLIC PROCEDURE GetNewContact(_Origin: tOrigin): LIKE(Contact.Contact);
 BEGIN
  DEFAULT(Contact);
  Contact.Origin:=_Origin;
  Contact.Begin :=SYSDATE();
  INSERT(Contact);
  L_APtm.SysLogHandler("Contact", L_SysLog.knd_Insert);
  RETURN Contact.Contact;
 END {GetNewContact};

 PUBLIC PROCEDURE BeforeOriginInsert(_Origin: tOrigin);
 BEGIN
  ^(L_Str.PoolItem(o_Files, _Origin)).Contact:=GetNewContact(_Origin);
  REPLACE(^(L_Str.PoolItem(o_Files, _Origin)));
 END {BeforeOriginInsert};

 PUBLIC PROCEDURE AccessContact(_Contact: LIKE(Contact.Contact));
 BEGIN
  IF ~SEARCH(Contact, Contact, _Contact) THEN
   L_General.CallUs(0);
  END;
 END {AccessContact};

 PUBLIC PROCEDURE AccessContactByOrigin(_Origin: tOrigin);
 BEGIN
  AccessContact(^(L_Str.PoolItem(o_Files, _Origin)).Contact);
 END {AccessContactByOrigin};

 PUBLIC PROCEDURE BeforeOriginDelete(_Origin: tOrigin);
  VAR
   hasCtcVal: SCAL[2]; 
 BEGIN
  IF ~!^(L_Str.PoolItem(o_Files, _Origin)).Contact THEN
   AccessContactByOrigin(_Origin);
   SETEMPTY(^(L_Str.PoolItem(o_Files, _Origin)).Contact);
   REPLACE(^(L_Str.PoolItem(o_Files, _Origin)));
   IF ((_Origin = o_Man) | (_Origin = o_Officer)) THEN
    hasCtcVal:=SELECT(CtcVal, Contact, Contact.Contact);
    TRY
     SE_INTEGRITY(1);
     REMOVE(Contact);
     IF hasCtcVal THEN
      STDMSG("'⠪', ⭮騩  㤠 ,  㤠, ⮬  ᮤন ଠ", INFORM);
      L_General.RaiseLockReleaseException();
     END;
    EXCEPT
    ON Exc: Exc_RunTime DO
     IF Exc.ErrorCode # L_General.ec_rt_NoDeleteUser THEN
      RAISE();
     END;
    ON Exc: Exc_Root DO
     L_General.CheckIsLockReleaseException(Exc);
    END;
   END;
  END;
 END {BeforeOriginDelete};

 PUBLIC PROCEDURE SetupContactNames(FromOrigin: SCAL[2]);
 BEGIN
  IF FromOrigin THEN
   IF    Contact.Origin = o_Man THEN
    Contact.Name:=Man.Name;
    Contact.IsPerson:=1;
    SETEMPTY(Contact.FirmName);
   ELSIF Contact.Origin = o_Officer THEN
    Contact.IsPerson:=0;
    SETEMPTY(Contact.FirmName);
   ELSIF Contact.Origin = o_FirmCtc THEN
    Contact.Name    :=FirmCtc.Name;
    CONFORM(FirmCtc, CtcKind);
    Contact.IsPerson:=CtcTypeIsPerson(CtcKind.Type);
    SAVE(Firm);
    CONFORM(FirmCtc, Firm);
    Contact.FirmName:=Firm.Name;
    RESTORE(Firm);
   END;
  END;
  IF Contact.IsPerson THEN
   Contact.srcName:=Str.Slice(Contact.Name, Str.ItemPos(Contact.Name, " ", 1), Str.Length(Contact.Name));
  ELSE
   Contact.srcName:=Contact.FirmName;
  END;
  REPLACE(Contact);

  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   SAVE(FirmCtc);
   IF SELECT(FirmCtc, Contact, Contact.Contact) THEN
    WHILE OCCURE(FirmCtc) DO
     IF FirmCtc.Name # Contact.Name THEN
      FirmCtc.Name   :=Contact.Name;
      REPLACE(FirmCtc);
     END;
     NEXT(FirmCtc);
    END;
   END;
   RESTORE(FirmCtc);
  EXCEPT
  END; (* TRY *)
 END {SetupContactNames};

 PUBLIC PROCEDURE ObtainClearPhoneNumber(S: STRING[]): STRING[];
  VAR
   i,
   l     : NUMERIC[0];
   c     : STRING[1];
   Result: STRING[];
 BEGIN
  Result:="";
  i:=0;
  l:=Str.Length(S);
  WHILE i < l DO
   c:=L_Str.Char(S, i);
   IF (c >= "0") & (c <= "9") | (c = "p") THEN
    Result:=Result + c;
   ELSIF (c # "+") & (c # "*") & (c # "#") & (c # "-") & (c # "(") & (c # ")") & (c # " ") THEN
    L_General.Error("⨬ ᨬ '" + c + "'   ⥫䮭 (" + S + ")");
   END;
   INC(i);
  END;
  RETURN Result;
 END {ObtainClearPhoneNumber};

 PUBLIC PROCEDURE GetInvValue(_Value: STRING[]): STRING[];
  VAR
   l     : NUMERIC[0];
   Result: STRING[];
 BEGIN
  Result:="";
  _Value:=ObtainClearPhoneNumber(_Value);
  l:=Str.Length(_Value);
  WHILE l > 0 DO
   DEC(l);
   Result:=Result + L_Str.Char(_Value, l);
  END;
  RETURN Result;
 END {GetInvValue};

 PUBLIC PROCEDURE SetCtcValInvValue();
 BEGIN
  SETEMPTY(CtcVal.InvValue);
  IF CtcValIsPhone() & (CtcVal.Type # cvt_SIP) & (CtcVal.Type # cvt_Skype) | (CtcVal.Type = cvt_Fax) THEN
   CtcVal.InvValue:=GetInvValue(CtcVal.Value);
  END;
  REPLACE(CtcVal);
 END {SetCtcValInvValue};

 PUBLIC PROCEDURE PosToCtcVal(_Contact: LIKE(Contact.Contact);
                              D       : DATE;
                              cc      : tCoverage;
                              cvt     : tValType): SCAL[2];
 BEGIN
  IF SELECT(CtcVal, Type, _Contact, cc, cvt) & SRCINSEL(CtcVal, LE, D) THEN
   WHILE OCCURE(CtcVal) & (CtcVal.Till <= D) DO
    PREV(CtcVal);
   END;
  END;
  RETURN OCCURE(CtcVal);
 END {PosToCtcVal};

 PUBLIC PROCEDURE PosToInheritCtcVal(trgContact: LIKE(Contact.Contact);
                                     D         : DATE;
                                     cc        : tCoverage;
                                     cvt       : tValType;
                                     trgInherit: LIKE(CtcVal.Inherit)): SCAL[2];
 BEGIN
  SETSEL(CtcVal, Type, trgContact, cc, cvt);
  SRCINSEL(CtcVal, LE, , D);
  LOOP
   IF ~OCCURE(CtcVal) |
      (L_DatTim.IsActive(D, CtcVal.Begin, CtcVal.Till) & (CtcVal.Inherit = trgInherit)) THEN
    EXIT;
   END;
   PREV(CtcVal);
  END; (* LOOP ... *)
  RETURN OCCURE(CtcVal);
 END {PosToInheritCtcVal};

 PUBLIC PROCEDURE GetCtcVal(Strong  : SCAL[2];
                            _Contact: LIKE(Contact.Contact);
                            D       : DATE;
                            cc      : tCoverage;
                            cvt     : tValType): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF PosToCtcVal(_Contact, D, cc, cvt) THEN
   RETURN CtcVal.Value;
  ELSE
   L_General.Assert(~Strong,
                    " ४⮢  '" + L_Str.PoolItem(cvt_Pool, cvt) +
                    "' (" + L_Str.PoolItem(cvc_Pool, cc) + ") " +
                    " '⠪' " + _Contact + "  " + L_DatTim.DateStr(D));
   RETURN "";
  END;
 END {GetCtcVal};

 PUBLIC PROCEDURE Call(Number, Name: STRING[]);
  CONST
   Asterisk_Outgoing_prepare = "\\pbx\hard\var\spool\asterisk\outgoing_prepare\";
   Asterisk_Outgoing         = "\\pbx\hard\var\spool\asterisk\outgoing\";
  VAR
   DualPhone: STRING[];
   FullFN   : STRING[];
   CallMth  : tCallMth;
   Dummy    : NUMERIC[0];
 BEGIN
  GetCallMth(CallMth, DualPhone);
  IF CallMth = cm_CallFile THEN
   L_General.Assert(L_General.IsPolakSpecific(), " 襩 ࣠樨  ।⢮ ⮢ call-䠩  ஥.|" +
                                                 "᫨  室  㭪樮쭮,   ࠧࠡ稪");
   L_General.Assert(FIO.DirExists(Asterisk_Outgoing_prepare), "⠫ '" + Asterisk_Outgoing_prepare + "'  ");
   L_General.Assert(FIO.DirExists(Asterisk_Outgoing), "⠫ '" + Asterisk_Outgoing + "'  ");
   FullFN:=Asterisk_Outgoing_prepare + L_General.curUSER + FLDTOSTR(SYSTIMESTAMP(), "yND_HMST") + ".call";
   FIO.Open(f, FullFN, , Create);
   FIO.WrStr(f, "Channel: SIP/" + DualPhone);
   FIO.WrLn(f);
   Name:=L_Russia.intRussianToTransliteration(Name, 1);
   FIO.WrStr(f, "Callerid: " + Name + " <" + Number + ">");
   FIO.WrLn(f);
   FIO.WrStr(f, "Context: numberplan-any");
   FIO.WrLn(f);
   FIO.WrStr(f, "Extension: " + Number);
   FIO.WrLn(f);
   FIO.WrStr(f, "Priority: 1");
   FIO.WrLn(f);
   FIO.WrStr(f, "Setvar: CallerPeer=" + DualPhone);
   FIO.WrLn(f);
   FIO.WrStr(f, "Archive: yes");
   FIO.Close(f);
   L_General.Assert(FIO.Exists(FullFN), "  call-䠩 '" + FullFN + "'|" +
                                        "    ࠢ    ⠫ '" + Asterisk_Outgoing_prepare + "'");
   FIO.RenMov(FullFN, , Asterisk_Outgoing + L_FIO.effp_FileName(FullFN), );
  ELSE
   Dummy:=L_General.LaunchEP(L_General.ept_Special,
                             "sip:" + Number,
                             "",
                             L_General.ws_Maximized,
                             0);
  END;
 END {Call};

 PUBLIC PROCEDURE E_GetPrefixes(    _Firm   : LIKE(Firm.Firm);
                                VAR Prefixes: STRING[];
                                VAR DfltIdx : NUMERIC[0]);
  VAR
   InDifferentMyFirm: SCAL[3];
 BEGIN
  Prefixes:="|";
  DfltIdx:=0;
  IF L_General.IsPolakSpecific() THEN
   Prefixes:=Prefixes + "051; ,  (499)999-8331|"
                      + "052; ,    (499)717-XXXX|"
                      + "053; Betamax, (495)989-7001|"
                      + "054;                |"
                      + "055; ,  (495)989-7001|"
                      + "056; ,  (499)999-1498|"
                      + "057; ,  (495)545-0145|";
   InDifferentMyFirm:=0;
   IF ~!_Firm THEN
    SELECT(Contract, Firm, , _Firm, 1);
    WHILE OCCURE(Contract) DO
     IF (Contract.Till > SYSDATE()) THEN
      IF (Contract.MyFirm = L_Env.mf_SMT) | (Contract.MyFirm = L_Env.mf_LSS) THEN
       InDifferentMyFirm:=Math.Max(InDifferentMyFirm, 1);
      ELSE
       InDifferentMyFirm:=2;
      END;
     END;
     NEXT(Contract);
    END; (* WHILE OCCURE(Contact) ... *)
   END;
   IF InDifferentMyFirm = 1 THEN
    DfltIdx:=1;
   END;
  END;
 END {E_GetPrefixes};

 PRIVATE PROCEDURE CheckEMailPart(PartName, Part, ValidChars: STRING[]);
  VAR
   i         : NUMERIC[0];
   SingleChar: STRING[];
   IsRus,
   IsEng,
   HasRus,
   HasEng    : SCAL[2];
 BEGIN
  SETZERO(i, HasRus, HasEng);
  WHILE i < Str.Length(Part) DO
   SingleChar:=L_Str.Char(Part, i);
   IF (SingleChar = ".") & (i<(Str.Length(Part)-1)) THEN
    L_General.Assert(L_Str.Char(Part, i+1) # ".",
                     PartName + "  (" + Part + ") e-mail  ᮤন 2   ᨬ '.' ");
   END;
   IsEng:=L_Str.TestStrAlowChar(SingleChar, "AZ") | L_Str.TestStrAlowChar(SingleChar, "az");
   IsRus:=L_Str.TestStrAlowChar(SingleChar, "") | L_Str.TestStrAlowChar(SingleChar, "");
   HasRus:=HasRus | IsRus;
   HasEng:=HasEng | IsEng;
   IF ~IsEng &
      ~IsRus &
      ~L_Str.TestStrAlowChar(SingleChar, "09") &
      (Str.Pos(ValidChars, SingleChar) = Str.Length(ValidChars)) THEN
    L_General.Error(PartName + "  (" + Part + ") e-mail  ᮤন ⨬ ᨬ '" + SingleChar + "'");
   END;
   INC(i);
  END;
  IF HasRus & HasEng THEN
   L_StdFrm.ConditionalCHOICE(PartName + "  (" + Part + ") e-mail  ᮤন ᬥ ᪨  ⨭᪨ ᨬ", 1);
  END;
 END {CheckEMailPart};

 PUBLIC PROCEDURE CheckEMailFormat(EMailVal: STRING[]);
  CONST
   Mask                = "?*@?*.??*";
   ValidCharsLocalPart = "!#$%&'*+-/=?^_`{|}~.";
   ValidCharsDomenPart = "-.";
  VAR
   LocalPart,
   DomenPart : STRING[];
 BEGIN
  L_General.Assert(Str.Match(EMailVal, Mask), "E-Mail   ᮮ⢥ ᪥ '" + Mask + "'");
  LocalPart:=Str.Item(EMailVal, "@", 0);
  DomenPart:=Str.Item(EMailVal, "@", 1);

  CheckEMailPart("쭠", LocalPart, ValidCharsLocalPart);
  CheckEMailPart("",  DomenPart, ValidCharsDomenPart);
 END {CheckEMailFormat};

 PUBLIC PROCEDURE CheckPhoneFormat(PhoneNbr: STRING[]);
  CONST
   PhoneTemplate1 = "+7(???)???-????";
   PhoneTemplate2 = "+7(????)??-????";
   PhoneTemplate3 = "+7(?????)?-????";
  VAR
   i         : NUMERIC[0];
   Local     : PROC;
   SingleChar: STRING[];
 BEGIN
  Local:=PROCREF(E_Utils.CheckPhoneFormat);
  IF ~!Local THEN
   Local(PhoneNbr);
  END;

  L_General.Assert(Str.Pos(PhoneNbr, " ") = Str.Length(PhoneNbr), "䮭    ᮤঠ ஡");
  i:=0;
  WHILE i < Str.Length(PhoneNbr) DO
   SingleChar:=L_Str.Char(PhoneNbr, i);
   IF (SingleChar # "+") &
      (SingleChar # "(") &
      (SingleChar # ")") &
      (SingleChar # "-") THEN
    L_General.Assert(L_Str.TestStrAlowChar(SingleChar, "09"), "䮭  ᮤন ⨬ ᨬ '" + SingleChar + "'");
   END;
   INC(i);
  END;
  IF    Str.Slice(PhoneNbr, 0, 2) = "+7" THEN
   IF ~Str.Match(PhoneNbr, PhoneTemplate1) &
      ~Str.Match(PhoneNbr, PhoneTemplate2) &
      ~Str.Match(PhoneNbr, PhoneTemplate3) THEN
    L_General.Error("४ ଠ  ⥫䮭 ||" +
                    "⨬ ଠ:||" +
                    PhoneTemplate1 + "|" +
                    PhoneTemplate2 + "|" +
                    PhoneTemplate3 + "|");
   END;
  ELSIF Str.Slice(PhoneNbr, 0, 1) = "+" THEN
   L_StdFrm.Question("  ⥫䮭   ᨨ?");
  END;
 END {CheckPhoneFormat};

 PUBLIC PROCEDURE FirmCtcHasChild():SCAL[2];
  VAR
   Result : SCAL[2];
 BEGIN
  SAVE(FirmCtc);
  Result := SELECT(FirmCtc, Parent, FirmCtc.Firm, FirmCtc.Id);
  RESTORE(FirmCtc);
  RETURN Result;
 END {FirmCtcHasChild};

 PRIVATE PROCEDURE E_IsCommonDepersonalizedFirmCtc(): SCAL[2];
  VAR
   Local  : PROC;
   default: SCAL[2];
 BEGIN
  Local  :=PROCREF(E_Utils.IsCommonDepersonalizedFirmCtc);
  default:=FirmCtc.CKType = ckt_Common;
  IF ~!Local THEN
   RETURN Local(default);
  ELSE
   RETURN default;
  END;
 END {E_IsCommonDepersonalizedFirmCtc};

 PUBLIC PROCEDURE GetCallerId(trgContact    : LIKE(Contact.Contact);
                              trgFirm       : LIKE(Firm.Firm);
                              trgFCtcId     : LIKE(FirmCtc.Id);
                              ForExternalUse: SCAL[2]): STRING[];
  VAR
   CallerId: STRING[];
 BEGIN
  SAVE(Contact);
  SAVE(Firm);
  SAVE(FirmCtc);
  L_General.Assert(SEARCH(Contact, Contact, trgContact), "  ⠪ " + trgContact);
  IF ~!trgFirm THEN
   P_Firm.AccessFirm(trgFirm);
   L_General.Assert(SEARCH(FirmCtc, Id, trgFirm, trgFCtcId),
                    "  ⠪ " + trgFCtcId + " ࠣ " + trgFirm);
   IF E_IsCommonDepersonalizedFirmCtc() | (P_Firm.FP_PrtnrTyp(trgFirm, SYSDATE()) = P_Firm.pt_Man)  THEN
    CallerId:=Firm.Name;
   ELSE
    IF CtcTypeIsPerson(FirmCtc.CKType) THEN
     CallerId:=FirmCtc.Name + " (" + Firm.Name + ")";
    ELSE
     CallerId:=Firm.Name + " (" + FirmCtc.Name + ")";
    END;
    IF L_General.IsPolakSpecific() & ~ForExternalUse THEN
     IF (trgFirm > 0000) & (trgFirm < 0100) THEN
      CallerId:=L_Str.Right(trgFirm, 2) + " " + FirmCtc.Name;
     END;
    END;
   END;
  ELSE
   CallerId:=Contact.Name;
  END;
  RESTORE(FirmCtc);
  RESTORE(Firm);
  RESTORE(Contact);
  RETURN CallerId
 END {GetCallerId};

 PUBLIC PROCEDURE ObtainDialNumber(cvt: tValType; Value: STRING[]): STRING[];
  VAR
   Result              : STRING[];
   l                   : NUMERIC[0];
   NumberInCommonFormat: SCAL[2];
 BEGIN
  IF    (cvt = cvt_SIP) THEN
   Result:=Value;
  ELSIF (cvt = cvt_Skype) THEN
   Result:="skype:" + Value + "?call";
   IF L_General.IsPolakSpecific() THEN
    Result:=Value + "@skype.com";
   END;
  ELSE
   NumberInCommonFormat:=L_Str.Char(Value, 0) = "+";
   Result              :=ObtainClearPhoneNumber(Value);
   IF ~NumberInCommonFormat THEN
    l:=Str.Length(Result);
    IF    l < 10 THEN
(*
     L_General.Error("⪨  ⥫䮭: " + Value)
*)
    ELSIF l = 10 THEN
     Result:="7" + Result;
    END;
   END;
  END;
  RETURN Result;
 END {ObtainDialNumber};

 PUBLIC PROCEDURE curCtcAdr_Set_glb_AdrVar();
 BEGIN
  L_Russia.Set_glb_AdrVar(CtcAdr.Country, CtcAdr.Zip, CtcAdr.Region, CtcAdr.RegionN, CtcAdr.Distr, CtcAdr.Town,
                          CtcAdr.Village, CtcAdr.Street, CtcAdr.TownT, CtcAdr.VillageT, CtcAdr.StreetT,
                          CtcAdr.House, CtcAdr.Block, CtcAdr.Build, CtcAdr.Flat, CtcAdr.PostBox, CtcAdr.PostKind, CtcAdr.Begin);
 END {curCtcAdr_Set_glb_AdrVar};

 PRIVATE PROCEDURE CurFirmCtc_StandOnAdr(D          : DATE;
                                         trgType    : LIKE(CtcAdr.Type);
                                         trgPostKind: LIKE(CtcAdr.PostKind);
                                         Strong     : SCAL[2]): SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(FirmCtc), " ⠭ ⥪  '⠪⮢ ࠣ'");
  CONFORM(FirmCtc, Contact);
  SELECT(CtcAdr, Type, , Contact.Contact, trgType, trgPostKind);
  SRCINSEL(CtcAdr, LE, , D);
  WHILE OCCURE(CtcAdr) DO
   IF L_DatTim.IsActive(D, CtcAdr.Begin, CtcAdr.Till) THEN
    RETURN 1;
   END;
   PREV(CtcAdr);
  END; (* WHILE OCCURE(CtcAdr) ... *)
  IF Strong THEN
   CONFORM(FirmCtc, Firm);
   L_General.Error("   '" + L_Str.PoolItem(cat_Pool, trgType) + "',|" +
                   "騩   " + L_DatTim.DateStr(D) + "|" +
                   " ⠪   = " + FirmCtc.Id + "|" +
                   "ࠣ " + Firm.Firm + " " + Firm.Name);
  ELSE
   RETURN 0;
  END;
 END {CurFirmCtc_StandOnAdr};

 PUBLIC PROCEDURE CurFirmCtc_StandOnAdr_Reg(D: DATE; Strong: SCAL[2]): SCAL[2];
 BEGIN
  RETURN CurFirmCtc_StandOnAdr(D, cat_Reg, L_Russia.capk_Stndr, Strong);
 END {CurFirmCtc_StandOnAdr_Reg};

 PUBLIC PROCEDURE CurFirmCtc_StandOnAdr_Fct(D: DATE; Strong: SCAL[2]): SCAL[2];
 BEGIN
  RETURN CurFirmCtc_StandOnAdr(D, cat_Fct, L_Russia.capk_Stndr, 0) |
         CurFirmCtc_StandOnAdr_Reg(D, Strong);
 END {CurFirmCtc_StandOnAdr_Fct};

 PUBLIC PROCEDURE CurFirmCtc_StandOnAdr_Pst(D: DATE; Strong: SCAL[2]): SCAL[2];
 BEGIN
  RETURN CurFirmCtc_StandOnAdr(D, cat_Pst, L_Russia.capk_Stndr, 0)    |
         CurFirmCtc_StandOnAdr(D, cat_Pst, L_Russia.capk_PostBox, 0)  |
         CurFirmCtc_StandOnAdr(D, cat_Pst, L_Russia.capk_PostRest, 0) |
         CurFirmCtc_StandOnAdr_Fct(D, Strong);
 END {CurFirmCtc_StandOnAdr_Pst};

 PRIVATE PROCEDURE StanOnMainFirmCtc(D: DATE; trgFirm: LIKE(Firm.Firm); Strong: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(FirmPro);
  Result:=0;
  IF   P_Firm.FP_PrtnrTyp(trgFirm, D) = P_Firm.pt_Man THEN
   Result:=P_Firm.StandOnFirmCtcByKindType(Strong, trgFirm, D, ckt_Leader);
  ELSE
   Result:=P_Firm.StandOnFirmCtcByKindType(Strong, trgFirm, D, ckt_Common);
   IF ~Result & (P_Firm.FP_PrtnrTyp(trgFirm, D) = P_Firm.pt_Owner) THEN
    Result:=P_Firm.StandOnFirmCtcByKindType(Strong, trgFirm, D, ckt_Leader);
   END;
  END;
  RESTORE(FirmPro);
  RETURN Result;
 END {StanOnMainFirmCtc};

 PUBLIC PROCEDURE StandOnAnyFCtc_wAdrFct(D: DATE; trgFirm: LIKE(Firm.Firm)): NUMERIC[0];
  VAR
   CntFCwAdr: NUMERIC[0];
   trgId    : LIKE(FirmCtc.Id);
 BEGIN
  CntFCwAdr:=0;
  SETEMPTY(trgId);
  SAVE(CtcAdr);
  SELECT(FirmCtc, Firm, , trgFirm);
  WHILE OCCURE(FirmCtc) DO
   IF L_DatTim.IsActive(D, FirmCtc.Begin, FirmCtc.Till) & CurFirmCtc_StandOnAdr_Fct(D, 0) THEN
    IF !trgId THEN
     trgId:=FirmCtc.Id;
    END;
    INC(CntFCwAdr);
   END;
   NEXT(FirmCtc);
  END; (* WHILE OCCURE(FirmCtc) ... *)
  IF ~(StanOnMainFirmCtc(D, trgFirm, 0) &  CurFirmCtc_StandOnAdr_Fct(D, 0)) & ~!trgId THEN
   L_General.CallUs(SEARCH(FirmCtc, Id, trgFirm, trgId));
  END;
  RESTORE(CtcAdr);
  RETURN CntFCwAdr;
 END {StandOnAnyFCtc_wAdrFct};

 PRIVATE PROCEDURE extStandOnAdr(D          : DATE;
                                 trgFirm    : LIKE(Firm.Firm);
                                 trgId      : LIKE(FirmCtc.Id);
                                 trgType    : LIKE(CtcAdr.Type);
                                 trgPostKind: LIKE(CtcAdr.PostKind);
                                 Strong     : SCAL[2]): SCAL[2];
  VAR
   IsStand: SCAL[2];
   Result : SCAL[2];
 BEGIN
  IF ~!trgId THEN
   Result:=SEARCH(FirmCtc, Id, trgFirm, trgId);
  ELSE
   Result:=StanOnMainFirmCtc(D, trgFirm, Strong);
  END;
  RETURN Result & CurFirmCtc_StandOnAdr(D, trgType, trgPostKind, Strong);
 END {extStandOnAdr};

 PUBLIC PROCEDURE extStandOnAdr_Reg(D: DATE; trgFirm: LIKE(Firm.Firm); trgId: LIKE(FirmCtc.Id); Strong: SCAL[2]): SCAL[2];
 BEGIN
  RETURN extStandOnAdr(D, trgFirm, trgId, cat_Reg, L_Russia.capk_Stndr, Strong);
 END {extStandOnAdr_Reg};

 PUBLIC PROCEDURE StandOnAdr_Reg(D: DATE; trgFirm: LIKE(Firm.Firm); Strong: SCAL[2]): SCAL[2];
 BEGIN
  RETURN extStandOnAdr_Reg(D, trgFirm, EMPTYOF(FirmCtc.Id), Strong);
 END {StandOnAdr_Reg};

 PUBLIC PROCEDURE extStandOnAdr_Fct(D: DATE; trgFirm: LIKE(Firm.Firm); trgId: LIKE(FirmCtc.Id); Strong: SCAL[2]): SCAL[2];
 BEGIN
  RETURN extStandOnAdr(D, trgFirm, trgId, cat_Fct, L_Russia.capk_Stndr, 0) |
         extStandOnAdr_Reg(D, trgFirm, trgId, Strong);
 END {extStandOnAdr_Fct};

 PUBLIC PROCEDURE StandOnAdr_Fct(D: DATE; trgFirm: LIKE(Firm.Firm); Strong: SCAL[2]): SCAL[2];
 BEGIN
  RETURN extStandOnAdr_Fct(D, trgFirm, EMPTYOF(FirmCtc.Id), Strong);
 END {StandOnAdr_Fct};

 PUBLIC PROCEDURE extStandOnAdr_Pst(D: DATE; trgFirm: LIKE(Firm.Firm); trgId: LIKE(FirmCtc.Id); Strong: SCAL[2]): SCAL[2];
 BEGIN
  IF L_General.IsPolakSpecific() THEN
   RETURN extStandOnAdr(D, trgFirm, trgId, cat_Pst, L_Russia.capk_Stndr, 0)    |
          extStandOnAdr(D, trgFirm, trgId, cat_Pst, L_Russia.capk_PostRest, 0) |
          extStandOnAdr(D, trgFirm, trgId, cat_Pst, L_Russia.capk_PostBox, 0)  |
          extStandOnAdr_Reg(D, trgFirm, trgId, Strong);
  ELSE
   RETURN extStandOnAdr(D, trgFirm, trgId, cat_Pst, L_Russia.capk_Stndr, 0) |
          extStandOnAdr(D, trgFirm, trgId, cat_Pst, L_Russia.capk_PostRest, 0) |
          extStandOnAdr(D, trgFirm, trgId, cat_Pst, L_Russia.capk_PostBox, 0)  |
          extStandOnAdr_Fct(D, trgFirm, trgId, Strong);
  END;
 END {extStandOnAdr_Pst};

 PUBLIC PROCEDURE StandOnAdr_Pst(D: DATE; trgFirm: LIKE(Firm.Firm); Strong: SCAL[2]): SCAL[2];
 BEGIN
  RETURN extStandOnAdr_Pst(D, trgFirm, EMPTYOF(FirmCtc.Id), Strong);
 END {StandOnAdr_Pst};

 PUBLIC PROCEDURE curCtcAdr_asStr(Format: L_Russia.tAddressFormat): STRING[];
 BEGIN
  curCtcAdr_Set_glb_AdrVar();
  RETURN L_Russia.Adr_asStr(Format);
 END {curCtcAdr_asStr};

 PUBLIC PROCEDURE GetAdr_Reg(D: DATE; trgFirm: LIKE(Firm.Firm)): STRING[];
 BEGIN
  IF StandOnAdr_Reg(D, trgFirm, 0) THEN
   RETURN curCtcAdr_asStr(L_Russia.af_Short);
  ELSE
   RETURN "";
  END;
 END {GetAdr_Reg};

 PUBLIC PROCEDURE GetAdr_Fct(D: DATE; trgFirm: LIKE(Firm.Firm)): STRING[];
 BEGIN
  IF StandOnAdr_Fct(D, trgFirm, 0) THEN
   RETURN curCtcAdr_asStr(L_Russia.af_Short);
  ELSE
   RETURN "";
  END;
 END {GetAdr_Fct};

 PUBLIC PROCEDURE GetAdr_Pst(D: DATE; trgFirm: LIKE(Firm.Firm)): STRING[];
 BEGIN
  IF StandOnAdr_Pst(D, trgFirm, 0) THEN
   RETURN curCtcAdr_asStr(L_Russia.af_Short);
  ELSE
   RETURN "";
  END;
 END {GetAdr_Pst};

 PUBLIC PROCEDURE GetCtcAdrType_asStr(IsShort: SCAL[2]): STRING[];
 BEGIN
  IF IsShort THEN
   RETURN L_Str.PoolItem(cat_PoolShort, CtcAdr.Type);
  ELSE
   RETURN L_Str.PoolItem(cat_Pool, CtcAdr.Type);
  END;
 END {GetCtcAdrType_asStr};

 PUBLIC PROCEDURE GetCtcAdrPostKind_asStr(IsShort: SCAL[2]): STRING[];
 BEGIN
  IF IsShort THEN
   RETURN L_Str.PoolItem(L_Russia.capk_PoolShort, CtcAdr.PostKind);
  ELSE
   RETURN L_Str.PoolItem(L_Russia.capk_Pool, CtcAdr.PostKind);
  END;
 END {GetCtcAdrPostKind_asStr};

 VAR
  NumFCtcLst: NUMERIC[0][MAXOF(tCtcListSource) + 1];

 PUBLIC PROCEDURE cl_GetCallerId(trgFirm       : LIKE(Firm.Firm);
                                 trgFCtcId     : LIKE(FirmCtc.Id);
                                 ForExternalUse: SCAL[2]): STRING[];
 BEGIN
  IF ~!trgFirm THEN
   RETURN GetCallerId(Contact.Contact, trgFirm,                  trgFCtcId,             ForExternalUse);
  ELSE
   RETURN GetCallerId(Contact.Contact, L_General.EMPTY_NUMBER(), L_General.EMPTY_NUMBER(), ForExternalUse);
  END;
 END {cl_GetCallerId};

 PRIVATE PROCEDURE cl_GetFirmCtcLeaf(trgFirm  : LIKE(Firm.Firm);
                                     trgFCtcId: LIKE(FirmCtc.Id)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SETEMPTY(Result);
  SAVE(FirmCtc);
  IF ~!trgFirm THEN
   P_Firm.AccessFirm(trgFirm);
   L_General.Assert(SEARCH(FirmCtc, Id, trgFirm, trgFCtcId), "  ⠪ " + trgFCtcId + " ࠣ " + trgFirm);
   Result:=FirmCtc.Leaf;
  END;
  RESTORE(FirmCtc);
  RETURN Result;
 END {cl_GetFirmCtcLeaf};

 PRIVATE PROCEDURE cl_PutItemToList(trgSource        : tCtcListSource;
                                    trgFirm          : LIKE(Firm.Firm);
                                    trgFCtcId        : LIKE(FirmCtc.Id);
                                    trgExt,
                                    trgAdr           : STRING[];
                                    trgRelationDegree: NUMERIC[0]);
 BEGIN
  DEFAULT(FCtcLst);
  INC(NumFCtcLst[trgSource]);
  FCtcLst.Num           :=NumFCtcLst[trgSource];
  FCtcLst.Source        :=trgSource;
  FCtcLst.FCtcId        :=trgFCtcId;
  FCtcLst.Leaf          :=cl_GetFirmCtcLeaf(trgFirm, trgFCtcId);
  FCtcLst.Adr           :=trgAdr;
  FCtcLst.Contact       :=Contact.Contact;
  FCtcLst.CallerId      :=cl_GetCallerId(trgFirm,
                                         trgFCtcId,
                                         (trgSource = cls_CtcVal) & ~!FCtcLst.Adr &
                                         ((CtcVal.Type = cvt_Email) | (CtcVal.Type = cvt_SMSEml)) );
  FCtcLst.RelationDegree:=trgRelationDegree;
  IF ~!FCtcLst.Adr THEN
   IF trgSource = cls_CtcVal THEN
    IF    (CtcVal.Type = cvt_SIP) THEN
     FCtcLst.MthConnect:=1;
    ELSIF (CtcVal.Type = cvt_Skype) THEN
     IF Str.Pos(trgAdr, "@") < Str.Length(trgAdr) THEN
      FCtcLst.MthConnect:=1;
     ELSE
      FCtcLst.MthConnect:=2;
     END
    ELSIF (CtcVal.Type = cvt_Email ) |
          (CtcVal.Type = cvt_SMSEml) |
          (CtcVal.Type = cvt_WWW   ) THEN
     FCtcLst.MthConnect:=2;
    ELSE
     FCtcLst.MthConnect:=0;
    END;
    FCtcLst.Ext  :=trgExt;
    FCtcLst.Value:=CtcVal.Value;
    IF ~!trgExt THEN
     FCtcLst.Value:=FCtcLst.Value + ' .' + trgExt;
    END;
    FCtcLst.Coverage:=CtcVal.Coverage;
    FCtcLst.Type    :=CtcVal.Type;
    FCtcLst.Comment :=CtcVal.Comment;
   ELSE
    FCtcLst.Value     :=curCtcAdr_asStr(L_Russia.af_Browser);
    FCtcLst.Coverage  :=CtcAdr.Type;
    FCtcLst.Type      :=CtcAdr.PostKind;
    FCtcLst.Comment   :=CtcAdr.Comment;
    FCtcLst.MthConnect:=3;
   END;
  END;
  FCtcLst.MayCall:=(FCtcLst.MthConnect = 0) | (FCtcLst.MthConnect = 1);
  INSERT(FCtcLst);
 END {cl_PutItemToList};

 PUBLIC PROCEDURE CurCtcAdrForViewInBrowser(MapType: tMap): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  L_General.CallUs(ACCESS(CtcAdr));
  IF ~!CtcAdr.Latitude & ~!CtcAdr.Longitude THEN
   IF MapType = m_Google THEN
    Result:=L_Str.NumericStr(CtcAdr.Latitude,  6) + "," + L_Str.NumericStr(CtcAdr.Longitude, 6);
   ELSIF MapType = m_Yandex THEN
    Result:=L_Str.NumericStr(CtcAdr.Longitude, 6) + "," + L_Str.NumericStr(CtcAdr.Latitude,  6);
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   Result:=Str.Condense(L_Str.Replace(curCtcAdr_asStr(L_Russia.af_Browser), ",", ""));
  END;
  IF MapType = m_Google THEN
   CONFORM(CtcAdr, Contact);
   Result:=Result + "(" + L_Str.PoolItem(Contact.srcName + "|" + Contact.Name, ~!Contact.srcName) +
                    ": " + curCtcAdr_asStr(L_Russia.af_Browser) + ")";
  END;
  RETURN Result;
 END {CurCtcAdrForViewInBrowser};

 PRIVATE PROCEDURE cl_PutCtcValToList(trgFirm          : LIKE(Firm.Firm);
                                      trgFCtcId        : LIKE(FirmCtc.Id);
                                      trgExt,
                                      trgAdr           : STRING[];
                                      trgRelationDegree: NUMERIC[0]);
 BEGIN
  cl_PutItemToList(cls_CtcVal, trgFirm, trgFCtcId, trgExt, trgAdr, trgRelationDegree);
 END {cl_PutCtcValToList};

 PRIVATE PROCEDURE cl_PutCtcAdrToList(trgFirm          : LIKE(Firm.Firm);
                                      trgFCtcId        : LIKE(FirmCtc.Id);
                                      trgRelationDegree: NUMERIC[0]);
 BEGIN
  cl_PutItemToList(cls_CtcAdr, trgFirm, trgFCtcId, "",
                               "http://maps.google.ru/maps?q=" + CurCtcAdrForViewInBrowser(m_Google) + "&iwloc=A&hl=ru" +
                               "|" +
                               "http://maps.yandex.ru/?text="  + CurCtcAdrForViewInBrowser(m_Yandex),
                               trgRelationDegree);
 END {cl_PutCtcAdrToList};

 PRIVATE PROCEDURE cl_ApplyCurExtPhone(trgFirm          : LIKE(Firm.Firm);
                                       D                : DATE;
                                       trgFCtcId        : LIKE(FirmCtc.Id);
                                       trgExt           : STRING[];
                                       trgContact       : LIKE(Contact.Contact);
                                       trgRelationDegree: NUMERIC[0]);
 BEGIN
  LOOP
   SELECT(CtcVal, Contact, , trgContact);
   WHILE OCCURE(CtcVal) DO
    IF CtcValIsPhone()                 &
       (CtcVal.Inherit = cvi_wApplExt) &
       L_DatTim.IsActive(D, CtcVal.Begin, CtcVal.Till) THEN
     cl_PutCtcValToList(trgFirm,
                        trgFCtcId,
                        trgExt,
                        ObtainDialNumber(CtcVal.Type, CtcVal.Value) + 'p' + trgExt,
                        trgRelationDegree);
    END;
    NEXT(CtcVal);
   END; (* WHILE OCCURE(CtcVal) ... *)

   IF ~OCCURE(FirmCtc) | !FirmCtc.Parent THEN
    EXIT;
   END;
   SELECT(FirmCtc, Id, , FirmCtc.Firm, FirmCtc.Parent);
   trgContact:=FirmCtc.Contact;
  END; (* LOOP ... *)
 END {cl_ApplyCurExtPhone};

 PRIVATE PROCEDURE SelectActionByCtcVal(LstSource        : tLstSource;
                                        D                : DATE;
                                        trgFirm          : LIKE(Firm.Firm);
                                        trgFCtcId        : LIKE(FirmCtc.Id);
                                        trgRelationDegree: NUMERIC[0]);
  VAR
   WWWAdr: STRING[];
 BEGIN
  IF (LstSource = ls_Contact) | (CtcVal.Inherit # cvi_NotInherit) | (FirmCtc.Id = trgFCtcId) THEN
   IF    CtcVal.Type = cvt_Extension THEN
    SAVE(FirmCtc);
    SAVE(CtcVal);
    cl_ApplyCurExtPhone(trgFirm, D, trgFCtcId, ObtainClearPhoneNumber(CtcVal.Value), Contact.Contact, trgRelationDegree);
    RESTORE(CtcVal);
    RESTORE(FirmCtc);
   ELSIF CtcValIsPhone() THEN
    cl_PutCtcValToList(trgFirm, trgFCtcId, "", ObtainDialNumber(CtcVal.Type, CtcVal.Value), trgRelationDegree);
   ELSIF LstSource # ls_FirmForJournal THEN
    IF    (CtcVal.Type = cvt_Email) | (CtcVal.Type = cvt_SMSEml) THEN
     cl_PutCtcValToList(trgFirm, trgFCtcId, "",
                        "mailto:" + L_EMail.AssembleContact(L_EMail.EncodeStrForMailToURL(cl_GetCallerId(trgFirm, trgFCtcId, 1) + CHR(255)), CtcVal.Value),
                        trgRelationDegree);
    ELSIF (CtcVal.Type = cvt_WWW) THEN
     WWWAdr:=CtcVal.Value;
     IF ~(Str.Match(WWWAdr, "?*://?*") | (Str.Cap(Str.Slice(WWWAdr, 0, 4)) = "WWW.")) THEN
      WWWAdr:="http://" + CtcVal.Value;
     END;
     cl_PutCtcValToList(trgFirm, trgFCtcId, "", WWWAdr, trgRelationDegree);
    END;
   END;
  END;
 END {SelectActionByCtcVal};

 PRIVATE PROCEDURE cl_ApplyToCurent(LstSource        : tLstSource;
                                    D                : DATE;
                                    trgFirm          : LIKE(Firm.Firm);
                                    trgFCtcId        : LIKE(FirmCtc.Id);
                                    trgRelationDegree: NUMERIC[0]);
 BEGIN
  SAVE(CtcVal);
  CONFORM(Contact, CtcVal);
  WHILE OCCURE(CtcVal) DO
   IF L_DatTim.IsActive(D, CtcVal.Begin, CtcVal.Till) THEN
    SelectActionByCtcVal(LstSource, D, trgFirm, trgFCtcId, trgRelationDegree);
   END;(*IF L_DatTim.IsActive(D, CtcVal.Begin, CtcVal.Till)...*)
   NEXT(CtcVal);
  END; (* WHILE OCCURE(CtcVal) ... *)
  RESTORE(CtcVal);

  IF LstSource # ls_FirmForJournal THEN
   SAVE(CtcAdr);
   CONFORM(Contact, CtcAdr);
   WHILE OCCURE(CtcAdr) DO
    IF L_DatTim.IsActive(D, CtcAdr.Begin, CtcAdr.Till) THEN
     cl_PutCtcAdrToList(trgFirm, trgFCtcId, trgRelationDegree);
    END;(*IF L_DatTim.IsActive(D, CtcAdr.Begin, CtcAdr.Till)...*)
    NEXT(CtcAdr);
   END; (* WHILE OCCURE(CtcAdr) ... *)
   RESTORE(CtcAdr);
  END;
 END {cl_ApplyToCurent};

 PUBLIC PROCEDURE cl_CntParents():NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=0;
  IF OCCURE(FirmCtc) THEN
   SAVE(FirmCtc);
   WHILE ~!FirmCtc.Parent & SELECT(FirmCtc, Id, FirmCtc.Firm, FirmCtc.Parent) DO
    INC(Result);
   END;
   RESTORE(FirmCtc);
  END;
  RETURN Result;
 END {cl_CntParents};

 PRIVATE PROCEDURE cl_ApplyToParent(LstSource: tLstSource;
                                    D        : DATE;
                                    trgFirm  : LIKE(Firm.Firm);
                                    trgFCtcId: LIKE(FirmCtc.Id));
 BEGIN
  SAVE(FirmCtc);
  SAVE(Contact);
  WHILE ~!FirmCtc.Parent DO
   SELECT(FirmCtc, Id, , trgFirm, FirmCtc.Parent);
   CONFORM(FirmCtc, Contact);
   cl_ApplyToCurent(LstSource, D, trgFirm, trgFCtcId, cl_CntParents());
  END; (* WHILE ~!FirmCtc.Parent *)
  RESTORE(Contact);
  RESTORE(FirmCtc);
 END {cl_ApplyToParent};

 PRIVATE PROCEDURE IsFirmLstSource(LstSource: tLstSource): SCAL[2];
 BEGIN
  RETURN (LstSource = ls_Firm) | (LstSource = ls_FirmForJournal);
 END {IsFirmLstSource};

 PRIVATE PROCEDURE cl_GetFirmCtcList(LstSource: tLstSource;
                                     D        : DATE;
                                     trgId    : LIKE(FirmCtc.Id));
  VAR
   trgNumFCtcLst: NUMERIC[0][MAXOF(tCtcListSource) + 1];
   cls          : SCAL[MAXOF(tCtcListSource) + 1];
 BEGIN
  SAVE(FirmCtc);
  IF IsFirmLstSource(LstSource) THEN
   SELECT(FirmCtc, Parent, , Firm.Firm, trgId);
  END;
  WHILE OCCURE(FirmCtc) DO
   PROMPT(FirmCtc.Firm + " " + FirmCtc.Id);
   IF L_DatTim.IsActive(D, FirmCtc.Begin, FirmCtc.Till) THEN
    trgNumFCtcLst[cls_CtcVal]:=NumFCtcLst[cls_CtcVal];
    trgNumFCtcLst[cls_CtcAdr]:=NumFCtcLst[cls_CtcAdr];
    CONFORM(FirmCtc, Contact);
    cl_ApplyToCurent(LstSource, D, Firm.Firm, FirmCtc.Id, cl_CntParents());
    cl_ApplyToParent(LstSource, D, Firm.Firm, FirmCtc.Id);
    FOR_EACH cls DO
     IF trgNumFCtcLst[cls] = NumFCtcLst[cls] THEN
      cl_PutItemToList(cls, Firm.Firm, FirmCtc.Id, "", "", cl_CntParents());
     END;
    END;
    IF IsFirmLstSource(LstSource) THEN
     cl_GetFirmCtcList(LstSource, D, FirmCtc.Id);
    END;
   END;
   NEXT(FirmCtc);
  END;
  RESTORE(FirmCtc);
 END {cl_GetFirmCtcList};

 PUBLIC PROCEDURE MakeFCtcLst(LstSource: tLstSource; D:DATE);
 BEGIN
  L_AFM.MakeMultipleIndex("FCtcLst", "FCtcId    : LIKE(FirmCtc.Id);"     +
                                     "Contact   : LIKE(Contact.Contact);"+
                                     "Source    : SCAL[2];"              +
                                     "Coverage  : LIKE(CtcVal.Coverage);"+
                                     "Type      : LIKE(CtcVal.Type);"    +
                                     "Ext       : LIKE(CtcVal.Value);"   +
                                     "CallerId  : STRING[256];"          +
                                     "Adr       : STRING[256];"          +
                                     "MthConnect: SCAL[4];"              +
                                     "MayCall   : SCAL[2];"              +
                                     "Value     : STRING[" + FLDTOSTR(cl_w_Value)+ "];"   +
                                     "Comment   : STRING[" + FLDTOSTR(cl_w_Comment)+ "];" +
                                     "Num       : NUMERIC[0];"                            +
                                     "Leaf      : SCAL[2];"                               +
                                     "RelationDegree: NUMERIC[0]",
                          "Source  : Source, Num;" +
                          "toShow  : FCtcId, RelationDegree, MayCall, MthConnect, Source, Coverage, Type");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  SETZERO(NumFCtcLst);

  IF LstSource = ls_Contact THEN
   L_General.CallUs(OCCURE(Contact));
   cl_ApplyToCurent(LstSource, D, "", "", 0);
  ELSE
   IF LstSource = ls_FirmCtc THEN
    L_General.CallUs(OCCURE(FirmCtc));
    CONFORM(FirmCtc, Firm);
   ELSIF IsFirmLstSource(LstSource) THEN
    L_General.CallUs(OCCURE(Firm));
   END;
   cl_GetFirmCtcList(LstSource, D, "");
  END;
 END {MakeFCtcLst};

END.
