(*
%Copyright   (c) Polak IT
%Author      21.10.2004 11:32:54 POLAK\San
%Purpose     ⥪  ࠡ  CUCopy
%Type        library
%Specific    SYS
%Modified    09.07.2014 10:57:39 POLAK\Gina
%Environment
*)

 MODULE L_CUC [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tOpKind      = SCAL[32];
  tCondition   = SCAL[6];
  tLocation    = SCAL[5];
  tCarUnitType = SCAL[3];

 PUBLIC CONST
  ok_Setting         =  0;
  ok_Dismant         =  1;
  ok_toCR1           =  2;
  ok_frCR1           =  3;
  ok_Accpt           =  4;
  ok_Retire          =  5;
  ok_toRsrv          =  6;
  ok_Fixup           =  7;
  ok_toCR2           =  8;
  ok_frCR2           =  9;
  ok_toIR            = 10;
  ok_frIR            = 11;
  ok_Sale            = 12;
  ok_Relocation      = 13;
  ok_Mentioning      = 14;
  ok_Complexing      = 15;
  ok_Cannibalisation = 16;

  ok_Pool = "|" +
            "|" +
            "  1|" +
            " 1|" +
            "ਥ|" +
            "ᠭ|" +
            " |" +
            "|" +
            "  2|" +
            " 2|" +
            "  |" +
            " |" +
            "த|" +
            "६-|" +
            "|" +
            "-|" +
            "㪮-";

  cnd_New              = 0;
  cnd_Restored         = 1;
  cnd_Used             = 2;
  cnd_InBadRepair      = 3;
  cnd_Nonserviceable   = 4;
  cnd_ToBeReclamaition = 5;

  cnd_Pool = "||/|||ફ";

  l_atStock     = 0;
  l_inExpl      = 1;
  l_inRsrv      = 2;
  l_Others      = 3;
  l_WrittenOff  = 4;

  l_Pool = " ᪫| ᯫ樨| १ࢥ|祥|ᠭ";

  cut_CarImplements    = 0;
  cut_Other            = 1;
  cut_TicketProduction = 2;

  cut_Pool = "ਭ ࠭ᯮ⭮ ।⢠|祥|⭠ த";

  o_Other   = 0;
  o_KeyAss  = 1;
  o_Car     = 2;
  o_OutCar  = 3;
  o_OutCBlc = 4;
  o_Math    = 5;

  o_Pool = "|᭮ ।⢮|࠭ᯮ⭮ ।⢮|஭ |஭ ॣ|";

  chr_Pool_Short = "|⮢| ६";
  chr_Pool       = "| ஢ ()| ६ (ਭ  )";

 PRIVATE CONST
  o_Files = "Math|Math|Car|OutCar|OutCBlc|Math| | | | | | | | | | | | | | | | | | | | | | | | | |";

 IMPORT L_General, L_DatTim, L_Str, Math, L_Env, L_MathR, L_MDoc, L_Car, L_XDoc, L_Stock, L_XObj,
        L_TRS, E_Stock, L_Acnt, L_StdFrm, P_Firm, L_AcCut, L_EC, Str, L_AR, L_OwnData, Memo, L_Print;

 PUBLIC PROCEDURE GetOriginFileName(_Origin: LIKE(CUCopy.Origin)): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(o_Files, _Origin);
 END {GetOriginFileName};

 PUBLIC PROCEDURE SoftAccessOrigin(): SCAL[2];
  VAR
   File: STRING[];
 BEGIN
  File:=GetOriginFileName(CUCopy.Origin);
  IF File = "Math" THEN
   RETURN SEARCH(Math, Math, CUCopy.Math);
  ELSE
   RETURN SEARCH(^File, CUCopy, CUCopy.CUCopy);
  END;
 END {SoftAccessOrigin};

 PUBLIC PROCEDURE AccessOrigin();
 BEGIN
  L_General.CallUs(SoftAccessOrigin());
 END {AccessOrigin};

 PUBLIC PROCEDURE DefineCULocation(_OpKind : tOpKind): tLocation;
 BEGIN
  IF    (_OpKind = ok_Setting) |
        (_OpKind = ok_Fixup  ) THEN
   RETURN l_inExpl;
  ELSIF (_OpKind = ok_toRsrv ) THEN
   RETURN l_inRsrv;
  ELSIF (_OpKind = ok_Retire ) |
        (_OpKind = ok_Sale   ) THEN
   RETURN l_WrittenOff;
  ELSIF ~!_OpKind &
        ~((_OpKind = ok_toCR1  ) |
          (_OpKind = ok_toCR2  ) |
          (_OpKind = ok_toIR   )) THEN
   RETURN l_atStock;
  ELSE
   RETURN l_Others;
  END;
 END {DefineCULocation};

 PUBLIC PROCEDURE IsCUAtStock(_OpKind : tOpKind): SCAL[2];
 BEGIN
  RETURN DefineCULocation(_OpKind) = l_atStock;
 END {IsCUAtStock};

 PUBLIC PROCEDURE IsCUAtCar(_OpKind : tOpKind): SCAL[2];
 BEGIN
  RETURN (DefineCULocation(_OpKind) = l_inExpl) | (DefineCULocation(_OpKind) = l_inRsrv);
 END {IsCUAtCar};

 PUBLIC PROCEDURE IsInitialSetting(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF (MDocLCU.OpKind = ok_Setting)    |
     (MDocLCU.OpKind = ok_Accpt)      |
     (MDocLCU.OpKind = ok_Dismant)    |
     (MDocLCU.OpKind = ok_toRsrv)     |
     (MDocLCU.OpKind = ok_Retire)     |
     (MDocLCU.OpKind = ok_Relocation) |
     (MDocLCU.OpKind = ok_frCR1)      |
     (MDocLCU.OpKind = ok_toCR1) THEN
   SAVE(Math);
   SAVE(CarUnit);
   SAVE(MDocList);
   CONFORM(MDocLCU, MDocList, Math);
   CONFORM(Math, CarUnit);
   IF MDocLCU.Date < CarUnit.SNDate THEN
    IF MDocLCU.Status = L_MDoc.st_Passed THEN
     SAVE(MDocLCU);
     CHANGESEL(MDocLCU, CUCopy, , MDocLCU.CUCopy, MDocLCU.Status);
     Result:=~PREV(MDocLCU);
      (* ᫥   ஢,  㬥 㯨⥫  .. *)
     RESTORE(MDocLCU);
    ELSE
     Result:=1;
    END;
   END;
   RESTORE(MDocList);
   RESTORE(CarUnit);
   RESTORE(Math);
  END;
  RETURN Result;
 END {IsInitialSetting};

 PUBLIC PROCEDURE GetCUCopyCarUnitType(_CUCopy: LIKE(CUCopy.CUCopy)): tCarUnitType;
  VAR
   Result: tCarUnitType;
 BEGIN
  SAVE(CUCopy);
  SAVE(Math);
  SAVE(CarUnit);
  L_General.CallUs(SEARCH(CUCopy, CUCopy, _CUCopy) &
                   SEARCH(Math, Math, CUCopy.Math) &
                   SEARCH(CarUnit, CarUnit, Math.CarUnit));
  Result:=CarUnit.Type;
  RESTORE(CarUnit);
  RESTORE(Math);
  RESTORE(CUCopy);
  RETURN Result;
 END {GetCUCopyCarUnitType};

 PRIVATE PROCEDURE CUCopyIsInventories(_CUCopy: LIKE(CUCPro.CUCopy)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(CUCopy);
  SAVE(Math);
  SAVE(MathType);
  SEARCH(CUCopy, CUCopy, , _CUCopy);
  CONFORM(CUCopy, Math);
  CONFORM(Math, MathType);
  Result:=MathType.Category = L_Acnt.mtc_Inventories;
  RESTORE(MathType);
  RESTORE(Math);
  RESTORE(CUCopy);
  RETURN Result;
 END {CUCopyIsInventories};

 PUBLIC PROCEDURE MMode2Condition(trgMMode: LIKE(MMode.MMode)): tCondition;
 BEGIN
  IF    trgMMode = L_MathR.mm_New              THEN RETURN cnd_New;
  ELSIF trgMMode = L_MathR.mm_Used             THEN RETURN cnd_Used;
  ELSIF trgMMode = L_MathR.mm_InBadRepair      THEN RETURN cnd_InBadRepair;
  ELSIF trgMMode = L_MathR.mm_Nonserviceable   THEN RETURN cnd_Nonserviceable;
  ELSIF trgMMode = L_MathR.mm_ToBeReclamaition THEN RETURN cnd_ToBeReclamaition;
  ELSIF trgMMode = L_MathR.mm_Restored         THEN RETURN cnd_Restored;
  ELSIF trgMMode = 210                         THEN RETURN cnd_Restored;
  ELSE
   RETURN EMPTYOF(tCondition);
  END;
 END {MMode2Condition};

 PRIVATE PROCEDURE LaxMMode2Condition(trgMMode: LIKE(MDocList.MMode)): tCondition;
  VAR
   Result: tCondition;
 BEGIN
  Result:=MMode2Condition(trgMMode);
  IF !Result THEN
   Result:=cnd_New;
  END;
  RETURN Result;
 END {LaxMMode2Condition};

 PUBLIC PROCEDURE GetMDocListStorageForCUC(Dst: SCAL[2]; _OpKind: tOpKind): LIKE(Storage.Storage);
  VAR
   cnt_mft,
   mft   : L_MDoc.tMathFlowType;
   Result: LIKE(Storage.Storage);
 BEGIN
  SAVE(MDoc);
  CONFORM(MDocList, MDoc);
  SETEMPTY(Result);
  mft:=L_MDoc.getMDocListStorageRelatedMathFlowType();
  IF    mft = L_MDoc.mft_Debit  THEN
   IF Dst THEN Result:=MDoc.Storage;
   ELSE        Result:=MDoc.Storage2;
   END;
  ELSIF mft = L_MDoc.mft_Credit THEN
   IF Dst THEN Result:=MDoc.Storage2;
   ELSE        Result:=MDoc.Storage;
   END;
  ELSE
   IF (_OpKind = ok_Complexing) |
      (_OpKind = ok_Cannibalisation) THEN
    Result:=MDoc.Storage;
   END;
  END;
  IF !Result THEN
   IF ~!MDoc.Contract THEN
    IF    L_MathR.IsContractStorageFlow(L_MDoc.InvertMathFlowType(mft)) THEN
     cnt_mft:=L_MDoc.InvertMathFlowType(mft);
    ELSIF L_MathR.IsContractStorageFlow(mft) THEN
     cnt_mft:=mft;
    ELSE
     SETEMPTY(cnt_mft);
    END;
    IF ((cnt_mft = L_MDoc.mft_Credit) & ~Dst) |
       ((cnt_mft = L_MDoc.mft_Debit)  &  Dst) THEN
     Result:=L_Stock.Obtain_ContractStorage(MDoc.Contract, MDoc.Date);
    END;
   ELSIF (_OpKind = ok_Retire) THEN
    IF ~Dst & L_MathR.IsAdvHolderFlow(mft) THEN
     Result:=L_Stock.Obtain_AdvHolderStorage(MDoc.TSN, MDoc.Date);
    END;
   ELSIF (_OpKind = ok_Relocation) THEN
    IF L_MathR.IsAdvHolderFlow(L_MDoc.InvertMathFlowType(mft)) THEN
     Result:=L_Stock.Obtain_AdvHolderStorage(MDoc.TSN, MDoc.Date);
    ELSE
     IF MDocList.Date > 01\01\2006 THEN
      cmdlcus_Bark(" " + L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc) +
                   "||" +
                   ". " + MDocList.MDLNbr + " -  樨 "+L_Str.PoolItem(ok_Pool, _OpKind)+",   । ");
     END;
    END;
   END;
  END;
  RESTORE(MDoc);
  RETURN Result;
 END {GetMDocListStorageForCUC};

 PRIVATE PROCEDURE intGetMDocLCUStorage(Dst: SCAL[2]): LIKE(Storage.Storage);
  VAR
   Result: LIKE(Storage.Storage);
 BEGIN
  SAVE(MDocList);
  CONFORM(MDocLCU, MDocList);
  Result:=GetMDocListStorageForCUC(Dst, MDocLCU.OpKind);
  RESTORE(MDocList);
  RETURN Result;
 END {intGetMDocLCUStorage};

 PRIVATE PROCEDURE cmdlcus_Bark(Msg: STRING[]);
 BEGIN
  INC(Msg, L_StdFrm.THR(" 稭"));
  INC(Msg,         "1 ୮ ଫ 㬥 (  㣮)   ;"
           + "|" + "2 ୮ ଫ   奬 権;                 "
           + "|" + "3 ୮ ଫ  樨;                                    "
           + "|" + "4 ୮ ଫ ࠢ筨 ᯥ樠 権  ;    "
           + "|" + "5 ୮ ଫ   奬                   ");
  L_General.Error(Msg);
 END {cmdlcus_Bark};

 PRIVATE PROCEDURE CheckMDocLCUStorage(prvStorage  : LIKE(Storage.Storage);
                                       prvCondition: tCondition);
  VAR
   mft         : L_MDoc.tMathFlowType;
   srcStorage,
   dstStorage  : LIKE(Storage.Storage);
 BEGIN
  srcStorage:=intGetMDocLCUStorage(0);
  IF ~!prvStorage THEN
   IF ~!srcStorage THEN
    IF srcStorage # prvStorage THEN
     cmdlcus_Bark(" " + MDocLCU.CUCopy + ":    " + prvStorage +
                  ",  ६頥   " + srcStorage);
    END;
    SAVE(MDocList);
    CONFORM(MDocLCU, MDocList);
    IF LaxMMode2Condition(MDocList.MMode) # prvCondition THEN
     IF L_Stock.GetStorageType(srcStorage) # L_Stock.st_Contract THEN
      cmdlcus_Bark(" " + MDocLCU.CUCopy + " (" + L_DatTim.DateStr(MDocLCU.Date) +
                   "): ᫨  ᪫  ﭨ '" + L_Str.PoolItem(cnd_Pool, prvCondition) + "'");
     END;
    END;
    RESTORE(MDocList);
   ELSIF ~L_MDoc.KeyAssetsMDoc(MDocLCU.MDocKind) THEN
    cmdlcus_Bark(" " + MDocLCU.CUCopy + ":    " + prvStorage + ",  ६頥  㤠");
   END;
  ELSE
   IF ~L_MDoc.KeyAssetsMDoc(MDocLCU.MDocKind) THEN
    IF ~!srcStorage THEN
     cmdlcus_Bark(" " + MDocLCU.CUCopy + ":   ,  ६頥   " + srcStorage);
    END;
   END;
  END;
  dstStorage:=intGetMDocLCUStorage(1);
 END {CheckMDocLCUStorage};

 PUBLIC PROCEDURE GetCurMDocLCUStorage(): LIKE(Storage.Storage);
 BEGIN
  RETURN intGetMDocLCUStorage(1);
 END {GetCurMDocLCUStorage};

 PUBLIC PROCEDURE SearchTckRcDL(trgCUCopy: LIKE(CUCopy.CUCopy); D: DATE; trgPassDTS: TIMESTAMP; After: SCAL[2]): SCAL[2];
 BEGIN
  SETSEL(TckRcDL, CUCopy, trgCUCopy, L_TRS.trcStat_Passed);
  IF After THEN RETURN SRCINSEL(TckRcDL, GT, D, trgPassDTS);
  ELSE          RETURN SRCINSEL(TckRcDL, LT, D, trgPassDTS);
  END;
 END {SearchTckRcDL};

 PUBLIC PROCEDURE SearchTckRcDLL(trgCUCopy: LIKE(CUCopy.CUCopy); D: DATE; trgPassDTS: TIMESTAMP; After: SCAL[2]): SCAL[2];
 BEGIN
  SETSEL(TckRcDLL, CUCopy, trgCUCopy, L_TRS.trcStat_Passed);
  IF (( After & SRCINSEL(TckRcDLL, GT, D, trgPassDTS)) |
      (~After & SRCINSEL(TckRcDLL, LT, D, trgPassDTS))) THEN
   CONFORM(TckRcDLL, TckRcDL);
   RETURN 1;
  END;
  RETURN 0;
 END {SearchTckRcDLL};

 PRIVATE PROCEDURE IsAfterPassed(srcD: DATE; srcPassDTS: TIMESTAMP; dstD: DATE; dstPassDTS: TIMESTAMP): SCAL[2];
 BEGIN
  RETURN (srcD > dstD) | ((srcD = dstD) & (srcPassDTS > dstPassDTS));
 END {IsAfterPassed};

 PRIVATE PROCEDURE SearchMDocLCU(trgCUCopy : LIKE(CUCopy.CUCopy); D: DATE; trgPassDTS: TIMESTAMP; After: SCAL[2]): SCAL[2];
 BEGIN
  SETSEL(MDocLCU, CUCopy, trgCUCopy, L_MDoc.st_Passed);
  IF   After THEN RETURN SRCINSEL(MDocLCU, GT, D, trgPassDTS);
  ELSE            RETURN SRCINSEL(MDocLCU, LT, D, trgPassDTS);
  END;
 END {SearchMDocLCU};

 PRIVATE PROCEDURE CheckAdjacentMovement(_CUCopy : LIKE(CUCopy.CUCopy);
                                         _CurOK,
                                         _PrvOK  : tOpKind;
                                         _CurBN,
                                         _PrvBN  : LIKE(Car.BoxNbr));
  VAR
   Ok: SCAL[2];
 BEGIN
  IF    _CurOK = ok_Dismant    THEN Ok:=(_PrvBN = _CurBN) & IsCUAtCar(_PrvOK);
  ELSIF _CurOK = ok_Setting    THEN Ok:=IsCUAtStock(_PrvOK) |
                                        IsCUAtCar(_PrvOK) & (_PrvOK # ok_Setting) & (_PrvBN = _CurBN);
  ELSIF _CurOK = ok_Accpt      THEN Ok:=!_PrvOK |
                                        (_PrvOK = ok_Sale);
  ELSIF _CurOK = ok_toCR1      THEN Ok:=!_PrvOK |
                                        IsCUAtStock(_PrvOK);
  ELSIF _CurOK = ok_toCR2      THEN Ok:=!_PrvOK |
                                        IsCUAtStock(_PrvOK);
  ELSIF _CurOK = ok_toIR       THEN Ok:=IsCUAtStock(_PrvOK);
  ELSIF _CurOK = ok_frCR1      THEN Ok:=(_PrvOK = ok_toCR1);
  ELSIF _CurOK = ok_frCR2      THEN Ok:=(_PrvOK = ok_toCR2);
  ELSIF _CurOK = ok_frIR       THEN Ok:=(_PrvOK = ok_toIR);
  ELSIF _CurOK = ok_Retire     THEN Ok:=IsCUAtStock(_PrvOK) | (_PrvOK = ok_toCR1) | (_PrvOK = ok_toCR2);
  ELSIF _CurOK = ok_Sale       THEN Ok:=IsCUAtStock(_PrvOK);
  ELSIF _CurOK = ok_Fixup      THEN Ok:=!_PrvOK;
  ELSIF _CurOK = ok_toRsrv     THEN Ok:=IsCUAtStock(_PrvOK) |
                                        IsCUAtCar(_PrvOK) & (_PrvOK # ok_toRsrv) & (_PrvBN = _CurBN);
  ELSIF _CurOK = ok_Complexing      THEN Ok:=IsCUAtStock(_PrvOK) & (_PrvOK # ok_Complexing);
  ELSIF _CurOK = ok_Cannibalisation THEN Ok:=(_PrvOK = ok_Complexing);
  ELSIF _CurOK = ok_Relocation THEN Ok:=IsCUAtStock(_PrvOK);
  ELSIF _CurOK = ok_Mentioning THEN Ok:=1;
  END;
  L_General.Assert(Ok, "ୠ ᫥⥫쭮   " + _CUCopy);
 END {CheckAdjacentMovement};

 PUBLIC PROCEDURE cucRole_IsCar(): SCAL[2];
 BEGIN
  RETURN CUCopy.Origin = o_Car;
 END {cucRole_IsCar};

 PUBLIC PROCEDURE cucRole_IsOutCar(): SCAL[2];
 BEGIN
  RETURN CUCopy.Origin = o_OutCar;
 END {cucRole_IsOutCar};

 PUBLIC PROCEDURE cucRole_IsTckBag(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF ~!CUCopy.Storage THEN
   SAVE(Storage);
   CONFORM(CUCopy, Storage);
   Result:=Storage.Type = L_Stock.st_TckBag;
   RESTORE(Storage);
  END;
  RETURN Result;
 END {cucRole_IsTckBag};

 PUBLIC PROCEDURE cucRole_IsTck(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  TRY
   L_AR.GrantRightsUnconditionally();
   SAVE(TckKind);
   Result:=SELECT(TckKind, Math, CUCopy.Math) & ((TckKind.Type = L_TRS.tkt_Ticket) | L_TRS.IsBulk_wCUC());
   RESTORE(TckKind);
  EXCEPT
  END;
  RETURN Result;
 END {cucRole_IsTck};

 PUBLIC PROCEDURE cucRole_IsBulkOfTck(wCUC: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  TRY
   L_AR.GrantRightsUnconditionally();
   SAVE(TckRcDL);
   IF SELECT(TckRcDL, CUCopy, CUCopy.CUCopy) THEN
    SAVE(TckKind);
    Result:=SELECT(TckKind, Math, CUCopy.Math) & (wCUC & L_TRS.IsBulk_wCUC() | ~wCUC & L_TRS.IsBulk());
    RESTORE(TckKind);
   END;
   RESTORE(TckRcDL);
  EXCEPT
  END;
  RETURN Result;
 END {cucRole_IsBulkOfTck};

 PUBLIC PROCEDURE cucRole_IsKeyAss(): SCAL[2];
 BEGIN
  RETURN CUCopy.Origin = o_KeyAss;
 END {cucRole_IsKeyAss};

 PUBLIC PROCEDURE cucRole_IsEngine(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(SYSDATE(), PROCREF(E_Stock.cucRole_IsEngine), 0);
 END {cucRole_IsEngine};

 PUBLIC PROCEDURE EngineAcntLev(): SCAL[2];
 BEGIN
  RETURN ~!PROCREF(E_Stock.cucRole_IsEngine);
 END {EngineAcntLev};

 PRIVATE PROCEDURE MDocLCU_IsTck(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(CUCopy);
  CONFORM(MDocLCU, CUCopy);
  Result:=cucRole_IsTck();
  RESTORE(CUCopy);
  RETURN Result;
 END {MDocLCU_IsTck};

 PRIVATE PROCEDURE intCheckLastMovement(RealMode: SCAL[2]);
  VAR
   prvBoxNbr   : LIKE(Car.BoxNbr);
   prvOpKind   : tOpKind;
   prvDate     : DATE;
   prvPassDTS  : TIMESTAMP;
   prvStorage  : LIKE(Storage.Storage);
   prvCondition: tCondition;
   Msg         : STRING[];
 BEGIN
  L_General.CallUs(ACCESS(MDocLCU));
  IF (GetCUCopyCarUnitType(MDocLCU.CUCopy) = cut_CarImplements) &
     (!MDocLCU.BoxNbr | ~L_Env.RealBoxNbr(MDocLCU.BoxNbr)) THEN
   Msg:="  (ਭ ) " + MDocLCU.CUCopy + ":" +
        "|| '" + L_Str.PoolItem(ok_Pool, MDocLCU.OpKind) + "'  ᯮ짮" +
        "||⮫쪮  ⠭  ॠ ";
   IF    (MDocLCU.OpKind = ok_Setting) | (MDocLCU.OpKind = ok_Dismant) THEN
    L_StdFrm.CrucialChoice(Msg, L_APtm.g_Stock);
   ELSIF (MDocLCU.OpKind = ok_toRsrv ) | (MDocLCU.OpKind = ok_Fixup) THEN
    L_General.Error(Msg);
   END;
  END;
  IF MDocLCU.OpKind # ok_Mentioning THEN
   IF RealMode THEN
    SAVE(MDocLCU);
    CHANGESEL(MDocLCU, CUCopy, , MDocLCU.CUCopy, MDocLCU.Status);
    L_General.CallUs(~NEXT(MDocLCU));
    RESTORE(MDocLCU);
   END; (* IF RealMode *)
   SAVE(MDocLCU);
   CHANGESEL(MDocLCU, CUCopy, , MDocLCU.CUCopy, MDocLCU.Status);
   WHILE PREV(MDocLCU) & (MDocLCU.OpKind = ok_Mentioning) DO
   END;
   IF OCCURE(MDocLCU) THEN
    prvBoxNbr :=MDocLCU.BoxNbr;
    prvOpKind :=MDocLCU.OpKind;
    prvDate   :=MDocLCU.Date;
    prvPassDTS:=MDocLCU.PassDTS;
    SETEMPTY(prvStorage, prvCondition);
    IF CUCopyIsInventories(MDocLCU.CUCopy) THEN
     prvStorage:=GetCurMDocLCUStorage();
     IF ~!prvStorage THEN
      prvCondition:=LaxMMode2Condition(GetMModeOfMDocLCU());
     END;
     RESTORE(MDocLCU);
     IF MDocLCU.OpKind # ok_Mentioning THEN
      CheckMDocLCUStorage(prvStorage, prvCondition);
     END;
    ELSE
     RESTORE(MDocLCU);
    END; (* IF CUCopyIsInventories(MDocLCU.CUCopy) *)
    IF MDocLCU_IsTck() THEN
     IF SearchTckRcDL(MDocLCU.CUCopy, MDocLCU.Date, MDocLCU.PassDTS, 0) |
        SearchTckRcDLL(MDocLCU.CUCopy, MDocLCU.Date, MDocLCU.PassDTS, 0) THEN
      CONFORM(TckRcDL, TckRcD);
      IF (TckRcD.Type # L_TRS.trdt_Sale) &
         IsAfterPassed(TckRcDL.Date, TckRcDL.PassDTS, prvDate, prvPassDTS) THEN
       L_General.Assert(MDocLCU.OpKind = ok_Dismant,
                        " " + MDocLCU.CUCopy + " 㦥 '뢠'  ⭮ ." +
                        "| ⮫쪮 ''");
       L_General.Assert(TckRcD.Type = L_TRS.trdt_Return,
                        " " + MDocLCU.CUCopy + " -  ᤠ   ");
      END;
     END;
    END; (* IF MDocLCU_IsTck() *)
    CheckAdjacentMovement(MDocLCU.CUCopy, MDocLCU.OpKind, prvOpKind, MDocLCU.BoxNbr, prvBoxNbr);
   ELSE
    SETEMPTY(prvBoxNbr, prvOpKind);
    RESTORE(MDocLCU);
    IF MDocLCU_IsTck() THEN
     IF SearchTckRcDL(MDocLCU.CUCopy, MDocLCU.Date, MDocLCU.PassDTS, 0) |
        SearchTckRcDLL(MDocLCU.CUCopy, MDocLCU.Date, MDocLCU.PassDTS, 0) THEN
      CONFORM(TckRcDL, TckRcD);
      L_General.Assert(TckRcD.Type = L_TRS.trdt_Return,
                       " " + MDocLCU.CUCopy + " 室  ⭮ 㬪");
      prvOpKind:=ok_Setting;
     END;
    END; (* IF MDocLCU_IsTck() *)
    IF ~IsInitialSetting() THEN
     CheckAdjacentMovement(MDocLCU.CUCopy, MDocLCU.OpKind, prvOpKind, MDocLCU.BoxNbr, prvBoxNbr);
    END;
   END; (* IF OCCURE(MDocLCU) *)
  END; (* IF MDocLCU.OpKind # ok_Mentioning *)
 END {intCheckLastMovement};

(*
$P{ TCUCM_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Memo.ud_cd(), L , "D.N.y"
Math.Math, L , ""
Math.Name, L , ""
@
############################################################################################################################################################################################################ ########## #####
=============================================================================================================================================================================================================================
|஢ઠ    ########## ஢  ##### #########################################################################################################################################################|
|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|㬥          |஡                                                                                                                                                                                            |
|----------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ TCUCM_Line:
L_MDoc.MDocStr(MDocLCU.MDocKind, MDocLCU.MDoc), L , ""
MDocLCU.Date, L , "D.N.y"
?, L, ""
@
|########### ##########|####################################################################################################################################################################################################|
}
*)

(*
$P{ TCUCM_Bot:
@
=(c) Polak===================================================================================================================================================================================================================
}
*)

 PUBLIC PROCEDURE TestMathCUCopyMovement();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(Math);
  OPENREP(R, L_General.NameConnection("TCUCM_" + Math.Math), Create);
  MAKEPART(R, TCUCM_Top);
  SETSEL(CUCopy, Math, Math.Math);
  SRCINSEL(CUCopy, GE, , Memo.ud_cd());
  WHILE OCCURE(CUCopy) DO
   PROMPT(CUCopy.CUCopy);
   SETSEL(MDocLCU, CUCopy, CUCopy.CUCopy, L_MDoc.st_Passed);
   LAST(MDocLCU);
   WHILE OCCURE(MDocLCU) DO
    TRY
     intCheckLastMovement(0);
    EXCEPT
    ON Exc: Exc_Raise DO
     MAKEPART(R, TCUCM_Line, Exc.Description);
    END;
    PREV(MDocLCU);
   END; (* WHILE OCCURE(MDocLCU) ... *)
   NEXT(CUCopy);
  END; (* WHILE OCCURE(CUCopy) ... *)
  MAKEPART(R, TCUCM_Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {TestMathCUCopyMovement};

 PUBLIC PROCEDURE AccessMDocLCU(_CUCopy: LIKE(CUCopy.CUCopy); D: DATE): SCAL[2];
 BEGIN
  SETSEL(MDocLCU, CUCopy, _CUCopy, L_MDoc.st_Passed);
  SRCINSEL(MDocLCU, LE, , D);
  WHILE OCCURE(MDocLCU) & (MDocLCU.OpKind = ok_Mentioning) DO
   PREV(MDocLCU);
  END;
  RETURN OCCURE(MDocLCU);
 END {AccessMDocLCU};

 PUBLIC PROCEDURE AccessLastMDocLCU(_CUCopy: LIKE(CUCopy.CUCopy)): SCAL[2];
 BEGIN
  RETURN AccessMDocLCU(_CUCopy, MAXOF(DATE));
 END {AccessLastMDocLCU};

 PRIVATE PROCEDURE GetMModeOfMDocLCU(): LIKE(MDocList.MMode);
  VAR
   Result: LIKE(MDocList.MMode);
 BEGIN
  SAVE(MDocList);
  CONFORM(MDocLCU, MDocList);
  Result:=MDocList.MMode;
  RESTORE(MDocList);
  RETURN Result;
 END {GetMModeOfMDocLCU};

 PUBLIC PROCEDURE GetInitCUCondition(_CUCopy: LIKE(CUCopy.CUCopy)): tCondition;
  VAR
   Result : tCondition;
 BEGIN
  SAVE(MDocLCU);
  IF ~SELECT(MDocLCU, CUCopy, _CUCopy, L_MDoc.st_Passed) THEN
   L_General.CallUs(0);
  END;
  WHILE OCCURE(MDocLCU) & (MDocLCU.OpKind = ok_Mentioning) DO
   NEXT(MDocLCU);
  END;
  IF OCCURE(MDocLCU) THEN
   Result:=LaxMMode2Condition(GetMModeOfMDocLCU());
  ELSE
   Result:=cnd_New;
  END;
  IF (Result = cnd_New) & ~!CUCopy.InitRun & (CUCopy.InitRun > 0) THEN
   Result:=cnd_Used;
  END;
  RESTORE(MDocLCU);
  RETURN Result;
 END {GetInitCUCondition};

 PUBLIC PROCEDURE GetCUCondition(_CUCopy: LIKE(CUCopy.CUCopy); D: DATE): tCondition;
  VAR
   Result: tCondition;
 BEGIN
  SETEMPTY(Result);
  SAVE(MDocLCU);
  IF AccessMDocLCU(_CUCopy, D) THEN
   WHILE OCCURE(MDocLCU) & !Result DO
    IF ~!MDocLCU.Storage & ~!MMode2Condition(GetMModeOfMDocLCU()) THEN
     Result:=MMode2Condition(GetMModeOfMDocLCU());
    END;
    PREV(MDocLCU);
   END; (* WHILE OCCURE(MDocLCU) *)
  END; (* IF AccessMDocLCU *)
  RESTORE(MDocLCU);
  IF !Result THEN
   Result:=GetInitCUCondition(_CUCopy);
  END;
  RETURN Result;
 END {GetCUCondition};

 PUBLIC PROCEDURE GetLastCUCondition(_CUCopy: LIKE(CUCopy.CUCopy)): tCondition;
 BEGIN
  RETURN GetCUCondition(_CUCopy, MAXOF(DATE));
 END {GetLastCUCondition};

 PUBLIC PROCEDURE MustBeLastCUCopyMDocLCU();
  VAR
 BEGIN
  IF (MDocLCU.Status = L_MDoc.st_Passed) & (MDocLCU.OpKind # ok_Mentioning) THEN
   SAVE(MDocLCU);
   CHANGESEL(MDocLCU, CUCopy, , MDocLCU.CUCopy, MDocLCU.Status);
   IF NEXT(MDocLCU) THEN
    LAST(MDocLCU);
    L_General.Error("᫥⥫쭠 䨪     " +
                    MDocLCU.CUCopy+"| |"+
                    "(. " + L_MDoc.MDocStr(MDocLCU.MDocKind, MDocLCU.MDoc) +
                    "  " + L_DatTim.DateStr(MDocLCU.Date) + ")");
   END;
   RESTORE(MDocLCU);
   IF MDocLCU_IsTck() &
      (SearchTckRcDL (MDocLCU.CUCopy, MDocLCU.Date, MDocLCU.PassDTS, 1) |
       SearchTckRcDLL(MDocLCU.CUCopy, MDocLCU.Date, MDocLCU.PassDTS, 1)) &
      ~IsInitialSetting() THEN
    L_General.Error("᫥⥫쭠 䨪     " +
                    MDocLCU.CUCopy + "| |"+
                    "(.  " + TckRcDL.TckRcD + "  " + L_DatTim.DateStr(TckRcDL.Date) + ")");
   END;
  END;
 END {MustBeLastCUCopyMDocLCU};

 PUBLIC PROCEDURE SetCUCValidity(trgCUCopy: LIKE(CUCopy.CUCopy));
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   L_General.CallUs(SEARCH(CUCopy, CUCopy, trgCUCopy));
   SETEMPTY(CUCopy.Begin, CUCopy.Till);
   IF SELECT(MDocLCU, CUCopy, trgCUCopy, L_MDoc.st_Passed) THEN
    CUCopy.Begin:=MDocLCU.Date;
   END;
   IF AccessLastMDocLCU(trgCUCopy) THEN
    IF (MDocLCU.OpKind = ok_Retire) | (MDocLCU.OpKind = ok_Sale) THEN
     CUCopy.Till:=MDocLCU.Date + 1;
    ELSIF (MDocLCU.OpKind = ok_Setting) & cucRole_IsTck() THEN
     SETSEL(TckRcDL, CUCopy, trgCUCopy, L_TRS.trcStat_Passed);
     IF LAST(TckRcDL) & (TckRcDL.Status # L_TRS.trdStat_Canceled) & !TckRcDL.RestNbr THEN
      CUCopy.Till:=TckRcDL.Date + 1;
     END;
     SETSEL(TckRcDLL, CUCopy, trgCUCopy, L_TRS.trcStat_Passed);
     IF LAST(TckRcDLL) & (TckRcDLL.Status # L_TRS.trdStat_Canceled) & ~!TckRcDLL.Sum THEN
      CUCopy.Till:=TckRcDLL.Date + 1;
     END;
    END;
   END;
   IF IS_ALTERED(CUCopy) THEN
    REPLACE(CUCopy);
   END;
  EXCEPT
  END;
 END {SetCUCValidity};

 PUBLIC PROCEDURE CompleteMDocLCU(ModifingDateOnly: SCAL[2]);
  CONST
   cucTryRelocate = "  ਢ    " +
                    "| ᫥⥫쭮  .  ";
  VAR
   newDate: DATE;
   newPassDTS: LIKE(MDocLCU.PassDTS);
 BEGIN
  newDate:=MDoc.Date;
  IF MDoc.Status = L_MDoc.st_Passed THEN
   IF !MDocLCU.PassDTS THEN
    newPassDTS:=SYSTIMESTAMP();
   ELSE
    newPassDTS:=MDocLCU.PassDTS;
   END;
  ELSE
   SETEMPTY(newPassDTS);
  END;
  IF MDocLCU.Status = L_MDoc.st_Passed THEN
   IF ~ModifingDateOnly THEN
    MustBeLastCUCopyMDocLCU();
   ELSE
    SAVE(MDocLCU);
    CHANGESEL(MDocLCU, CUCopy, , MDocLCU.CUCopy, MDocLCU.Status);
    IF NEXT(MDocLCU) &
       ((MDocLCU.Date < newDate) | ((MDocLCU.Date = newDate) & (MDocLCU.PassDTS <= newPassDTS))) THEN
     L_General.Error(cucTryRelocate + MDocLCU.CUCopy);
    END;
    RESTORE(MDocLCU);
    SAVE(MDocLCU);
    CHANGESEL(MDocLCU, CUCopy, , MDocLCU.CUCopy, MDocLCU.Status);
    IF PREV(MDocLCU) &
       ((MDocLCU.Date > newDate) | ((MDocLCU.Date = newDate) & (MDocLCU.PassDTS >= newPassDTS))) THEN
     L_General.Error(cucTryRelocate + MDocLCU.CUCopy);
    END;
    RESTORE(MDocLCU);
   END;
  END;
  MDocLCU.BoxNbr  :=MDoc.BoxNbr;
  MDocLCU.Date    :=newDate;
  MDocLCU.Status  :=MDoc.Status;
  MDocLCU.PassDTS :=newPassDTS;
  REPLACE(MDocLCU);
  MDocLCU.Storage:=GetCurMDocLCUStorage();
  REPLACE(MDocLCU);
  IF MDocLCU.Status = L_MDoc.st_Passed THEN
   IF ~ModifingDateOnly THEN
    MustBeLastCUCopyMDocLCU();
    intCheckLastMovement(1);
   END;
  END;
  SetCUCValidity(MDocLCU.CUCopy);
 END {CompleteMDocLCU};

 PUBLIC PROCEDURE InsMDocLCU(_CUCopy: LIKE(CUCopy.CUCopy);
                             _MDLNbr: LIKE(MDocList.MDLNbr);
                             _OpKind: LIKE(MDocLCU.OpKind));
 BEGIN
  DEFAULT(MDocLCU);
  MDocLCU.MDocKind:=MDoc.MDocKind;
  MDocLCU.MDoc    :=MDoc.MDoc;
  MDocLCU.MDLNbr  :=_MDLNbr;
  MDocLCU.CUCopy  :=_CUCopy;
  MDocLCU.OpKind  :=_OpKind;
  INSERT(MDocLCU);
  CompleteMDocLCU(0);
 END {InsMDocLCU};

 PUBLIC PROCEDURE GetDefaultSerial(_CUCopy: LIKE(CUCopy.CUCopy)): STRING[];
 BEGIN
  RETURN "#"+_CUCopy;
 END {GetDefaultSerial};

 PRIVATE PROCEDURE GetCUCopyUsersCollection(_CUCopy: LIKE(CUCopy.CUCopy);
                                            VAR ucBoxNbr: LIKE(Car.BoxNbr)[];
                                            VAR ucFrom,
                                                ucTill  : DATE[]);
  VAR
   i: NUMERIC[0];
   prvLocation,
   curLocation : tLocation;
 BEGIN
  SAVE(MDocLCU);
  SETEMPTY(ucBoxNbr, ucFrom, ucTill);
  SELECT(MDocLCU, CUCopy, , _CUCopy, L_MDoc.st_Passed);
  prvLocation:=l_Others;
  i:=0;
  WHILE OCCURE(MDocLCU) DO
   IF MDocLCU.OpKind # ok_Mentioning THEN
    curLocation:=DefineCULocation(MDocLCU.OpKind);
    IF curLocation = l_inExpl THEN
     IF prvLocation # l_inExpl THEN
      L_General.CallUs(!ucBoxNbr[i]);
      ucBoxNbr[i]:=MDocLCU.BoxNbr;
      ucFrom  [i]:=MDocLCU.Date;
     ELSE
      L_General.CallUs(MDocLCU.BoxNbr = ucBoxNbr[i]);
     END;
    ELSIF prvLocation = l_inExpl THEN
     L_General.CallUs(MDocLCU.BoxNbr = ucBoxNbr[i]);
     ucTill[i]:=MDocLCU.Date;
     INC(i);
    END;
    prvLocation:=curLocation;
   END;
   NEXT(MDocLCU);
  END; (* WHILE OCCURE(MDocLCU) ... *)
  RESTORE(MDocLCU);
 END {GetCUCopyUsersCollection};

 PRIVATE PROCEDURE DateOfSpecifiedOpKind(_CUCopy  : LIKE(CUCopy.CUCopy);
                                         spcOpKind: tOpKind;
                                         Till     : DATE): DATE;
  VAR
   Result: DATE;
 BEGIN
  SETEMPTY(Result);
  SAVE(MDocLCU);
  IF AccessMDocLCU(_CUCopy, Till) THEN
   WHILE (MDocLCU.OpKind # spcOpKind) & PREV(MDocLCU) DO
   END;
   IF OCCURE(MDocLCU) THEN
    Result:=MDocLCU.Date;
   END;
  END;
  RESTORE(MDocLCU);
  RETURN Result;
 END {DateOfSpecifiedOpKind};

 PRIVATE PROCEDURE intGetCUCopyOutput(_CUCopy   : LIKE(CUCopy.CUCopy);
                                      _From,
                                      _Till     : DATE;
                                      wInitValue: SCAL[2];
                                      wAccuracy : SCAL[2];
                                      VAR
                                       totRun: NUMERIC[3];
                                      VAR
                                       totTim: NUMERIC[0]);
  CONST
   ucAmount = 128;
  VAR
  ucBoxNbr: LIKE(Car.BoxNbr)[ucAmount];
  ucFrom,
  ucTill  : DATE            [ucAmount];
  curFrom,
  curTill : DATE;
  i       : NUMERIC[0];
 BEGIN
  GetCUCopyUsersCollection(_CUCopy, ucBoxNbr, ucFrom, ucTill);
  SETZERO(totRun, totTim);
  IF wInitValue THEN
   SAVE(CUCopy);
   SEARCH(CUCopy, CUCopy, , _CUCopy);
   IF ~!CUCopy.InitRun THEN
    INC(totRun, CUCopy.InitRun);
   END;
   RESTORE(CUCopy);
  END;
  i:=0;
  WHILE ~!ucBoxNbr[i] DO
   curFrom:=Math.Max(_From, ucFrom[i]);
   curTill:=Math.Min(_Till, ucTill[i]);
   IF curFrom < curTill THEN
    IF wAccuracy THEN
     INC(totRun, L_Car.GetAccurateRunInPer(ucBoxNbr[i], curFrom, curTill));
    ELSE
     INC(totRun, L_Car.GetGlobalRun(ucBoxNbr[i], curTill)-
                 L_Car.GetGlobalRun(ucBoxNbr[i], curFrom));
    END;
    INC(totTim, curTill-curFrom);
   END;
   INC(i);
  END;
 END {intGetCUCopyOutput};

 PUBLIC PROCEDURE GetCUCopyTotalRun(trgCUCopy: LIKE(CUCopy.CUCopy);
                                    D        : DATE;
                                    wAccuracy: SCAL[2]): NUMERIC[3];
  VAR
   totRun: NUMERIC[3];
   dmyTim: NUMERIC[0];
 BEGIN
  intGetCUCopyOutput(trgCUCopy, MINOF(DATE), D, 1, wAccuracy, totRun, dmyTim);
  RETURN totRun;
 END {GetCUCopyTotalRun};

 PUBLIC PROCEDURE GetCUCopyCRDate(trgCUCopy: LIKE(CUCopy.CUCopy); D: DATE): DATE;
  VAR
   Result: DATE;
 BEGIN
  SETEMPTY(Result);
  TRY [RESTORE_CURSORS(RC_ON)]
   SELECT(MDocLCU, CUCopy, , trgCUCopy, L_MDoc.st_Passed);
   WHILE OCCURE(MDocLCU) & (MDocLCU.OpKind = ok_Mentioning) DO
    NEXT(MDocLCU);
   END;
   IF OCCURE(MDocLCU) &
      (LaxMMode2Condition(GetMModeOfMDocLCU()) = cnd_Restored) THEN
    Result:=MDocLCU.Date;
   END;
   IF !Result THEN
    Result:=DateOfSpecifiedOpKind(trgCUCopy, ok_frCR1, D);
   END;
  EXCEPT
  END;
  RETURN Result;
 END {GetCUCopyCRDate};

 PUBLIC PROCEDURE GetCUCopyPerRun(trgCUCopy: LIKE(CUCopy.CUCopy);
                                  From,
                                  Till     : DATE;
                                  wAccuracy: SCAL[2]): NUMERIC[3];
  VAR
   totRun: NUMERIC[3];
   dmyTim: NUMERIC[0];
 BEGIN
  intGetCUCopyOutput(trgCUCopy, From, Till, 0, wAccuracy, totRun, dmyTim);
  RETURN totRun;
 END {GetCUCopyPerRun};

 PUBLIC PROCEDURE GetCUCopyLastBoxNbrRun(_CUCopy   : LIKE(CUCopy.CUCopy);
                                         D         : DATE;
                                         wAccuracy : SCAL[2]): NUMERIC[3];
  VAR
   _From : DATE;
   totRun: NUMERIC[3];
   totTim: NUMERIC[0];
 BEGIN
  _From:=Math.Min(DateOfSpecifiedOpKind(_CUCopy, ok_Setting, D),
                  DateOfSpecifiedOpKind(_CUCopy, ok_Fixup,   D));
  IF ~!_From THEN
   intGetCUCopyOutput(_CUCopy, _From, D, 0, wAccuracy, totRun, totTim);
   RETURN totRun;
  ELSE
   RETURN 0;
  END;
 END {GetCUCopyLastBoxNbrRun};

 PUBLIC PROCEDURE GetCUCopyTotalTim(_CUCopy   : LIKE(CUCopy.CUCopy);
                                    D         : DATE;
                                    wAccuracy : SCAL[2]): NUMERIC[0];
  VAR
   totRun: NUMERIC[3];
   totTim: NUMERIC[0];
 BEGIN
  intGetCUCopyOutput(_CUCopy, MINOF(DATE), D, 1, wAccuracy, totRun, totTim);
  RETURN totTim;
 END {GetCUCopyTotalTim};

 PUBLIC PROCEDURE GetCUCopyLastBoxNbrTim(_CUCopy   : LIKE(CUCopy.CUCopy);
                                         D         : DATE;
                                         wAccuracy : SCAL[2]): NUMERIC[0];
  VAR
   _From : DATE;
   totRun: NUMERIC[3];
   totTim: NUMERIC[0];
 BEGIN
  _From:=Math.Min(DateOfSpecifiedOpKind(_CUCopy, ok_Setting, D),
                  DateOfSpecifiedOpKind(_CUCopy, ok_Fixup,   D));
  IF ~!_From THEN
   intGetCUCopyOutput(_CUCopy, _From, D, 0, wAccuracy, totRun, totTim);
   RETURN totTim;
  ELSE
   RETURN 0;
  END;
 END {GetCUCopyLastBoxNbrTim};

 PUBLIC PROCEDURE ShowCUCopyRun(trgCUCopy: LIKE(CUCopy.CUCopy); D: DATE);
  VAR
   totRun,
   cr1Run : NUMERIC[3];
   totTim,
   dmyTim : NUMERIC[0];
   cr1Date: DATE;
 BEGIN
  totRun:=GetCUCopyTotalRun(trgCUCopy, D, 1);
  cr1Date:=GetCUCopyCRDate(trgCUCopy, D);
  IF ~!cr1Date THEN
   cr1Run:=GetCUCopyPerRun(trgCUCopy, cr1Date, D, 1);
  ELSE
   SETZERO(cr1Run);
  END;
  L_StdFrm.Inform(" " + L_DatTim.DateStr(D) + "               " +
                  "|" +
                  "| ஡ ॣ  - "+FLDTOSTR(totRun, ",0", 9, "R")+" "+
                  "|஡ ᫥ ६ - "+FLDTOSTR(cr1Run, ",0", 9, "R")+" ");
 END {ShowCUCopyRun};

 PUBLIC PROCEDURE GetMDocLCUOpKind_asStr(): STRING[];
 BEGIN
  IF OCCURE(MDocLCU) & ~!MDocLCU.OpKind THEN
   RETURN L_Str.PoolItem(ok_Pool, MDocLCU.OpKind);
  ELSE
   RETURN "";
  END;
 END {GetMDocLCUOpKind_asStr};

(*
 PRIVATE PROCEDURE cucBegin(_CUCopy: LIKE(CUCopy.CUCopy)): DATE;
 BEGIN
  IF SELECT(MDocLCU, CUCopy, _CUCopy, L_MDoc.st_Passed) THEN
   RETURN MDocLCU.Date;
  END;
  RETURN EMPTYOF(DATE);
 END {cucBegin};

 PRIVATE PROCEDURE cucTill(_CUCopy: LIKE(CUCopy.CUCopy)): DATE;
 BEGIN
  IF AccessLastMDocLCU(_CUCopy) &
     ((MDocLCU.OpKind = ok_Retire) | (MDocLCU.OpKind = ok_Sale)) THEN
   RETURN MDocLCU.Date;
  END;
  RETURN EMPTYOF(DATE);
 END {cucTill};
*)

 PUBLIC PROCEDURE AmountInSingleCopy(): L_XObj.tQnt;
  VAR
   Result: L_XObj.tQnt;
 BEGIN
  Result:=1;
(*
  IF cucRole_IsTck() THEN
   SAVE(TckKind);
   L_General.CallUs(L_TRS.AccessTckKindByMath(CUCopy.Math, MDocLCU.Date));
   Result:=TckKind.PckVol;
   RESTORE(TckKind);
  END;
*)
  RETURN Result;
 END {AmountInSingleCopy};

 PRIVATE PROCEDURE ctm_ExecPackProc(PackProc   : PROC;
                                    atTckRcDL  : SCAL[2];
                                    avp        : L_Acnt.tAcntVectorPart;
                                    curRestNbr : NUMERIC[0];
                                    D          : DATE;
                                    Invariable : SCAL[2]);
 BEGIN
  IF Invariable THEN
   PackProc(atTckRcDL, avp, curRestNbr);
  ELSE
   SAVE(TckKind);
   IF L_TRS.AccessTckKindByMath(TckKind.Math, D) THEN
    PackProc(atTckRcDL, avp, curRestNbr);
   ELSE
    L_General.CallUs(0);
   END;
   RESTORE(TckKind);
  END;
 END {ctm_ExecPackProc};

 PRIVATE PROCEDURE ctm_PutByMDocLCU(avp: L_Acnt.tAcntVectorPart; PackProc: PROC; Invariable : SCAL[2]);
 BEGIN
  IF    SearchTckRcDL(MDocLCU.CUCopy, MDocLCU.Date, MDocLCU.PassDTS, 0) THEN
   ctm_ExecPackProc(PackProc, 0, avp, TckRcDL.RestNbr, TckRcDL.Date, Invariable);
  ELSIF SearchTckRcDLL(MDocLCU.CUCopy, MDocLCU.Date, MDocLCU.PassDTS, 0) THEN
   ctm_ExecPackProc(PackProc, 0, avp, 1, TckRcDLL.Date, Invariable);
  ELSE
   ctm_ExecPackProc(PackProc, 0, avp, EMPTYOF(TckRcDL.RestNbr), MDocLCU.Date, Invariable);
  END;
 END {ctm_PutByMDocLCU};

 PRIVATE PROCEDURE CheckTckKindInvariability(trgMath: LIKE(Math.Math); fr, ut: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
   tmpTckKind: LIKE(TckKind.TckKind);
 BEGIN
  Result:=1;
  SAVE(TckKind);
  IF L_TRS.AccessTckKindByMath(Math.Math, ut) THEN
   tmpTckKind:=TckKind.TckKind;
   IF L_TRS.AccessTckKindByMath(Math.Math, fr) THEN
    Result:=TckKind.TckKind = tmpTckKind;
   END;
  END;
  RESTORE(TckKind);
  RETURN Result;
 END {CheckTckKindInvariability};

 PUBLIC PROCEDURE extCollectTckMovement(_Storage       : LIKE(Storage.Storage);
                                        begTime,
                                        endTime        : TIMESTAMP;
                                        PackProc       : PROC;
                                        IsBuildFirstViP: SCAL[2]);
  VAR
   asTckKind           : LIKE(TckKind.TckKind);
   SaldoPer,
   tkD,
   begD,
   endD                : DATE;
   _MyFirm             : P_Firm.tMyFirm;
   mft                 : L_MDoc.tMathFlowType;
   dmySum              : L_XObj.tSum;
   curQnt              : L_XObj.tQnt;
   IsMyStorage,
   PackNotEnded,
   TckRcDLFound        : SCAL[2];
   TckKindInvariability: SCAL[2];
 BEGIN
  begD:=L_DatTim.GetDateOfTIMESTAMP(begTime);
  endD:=L_DatTim.GetDateOfTIMESTAMP(endTime);

  SAVE(Storage);
  SEARCH(Storage, Storage, , _Storage);
  _MyFirm:=Storage.MyFirm;
  RESTORE(Storage);

  IsMyStorage:=_Storage = L_TRS.TckOfficeStorage(begD, _MyFirm);
  SELECT(CarUnit, Type, , cut_TicketProduction);
  WHILE OCCURE(CarUnit) DO
   SELECT(Math, CarUnit, , CarUnit.CarUnit);
   WHILE OCCURE(Math) DO
    PROMPT(" 室饣 ᠫ줮: " + Math.Math);
    IF Math.Leaf & SELECT(TckKind, Math, L_TRS.TckMath(Math.Math, endD)) THEN
     IF ~L_TRS.AccessTckKindByMath(Math.Math, endD) THEN
      SELECT(TckKind, Math, , L_TRS.TckMath(Math.Math, endD));
      tkD:=MINOF(DATE);
      SETEMPTY(asTckKind);
      WHILE OCCURE(TckKind) DO
       IF (TckKind.Till <= endD) & (TckKind.Till > tkD) THEN
        tkD:=TckKind.Till;
        asTckKind:=TckKind.TckKind;
       END;
       NEXT(TckKind);
      END; (* WHILE OCCURE(TckKind) ... *)

      IF !asTckKind THEN
       FIRST(TckKind);
       tkD:=TckKind.Begin;
       WHILE OCCURE(TckKind) DO
        IF TckKind.Begin <= tkD THEN
         tkD:=TckKind.Begin;
         asTckKind:=TckKind.TckKind;
        END;
        NEXT(TckKind);
       END; (* WHILE OCCURE(TckKind) ... *)
      END;

      SEARCH(TckKind, TckKind, , asTckKind);
     END;
     TckKindInvariability:=CheckTckKindInvariability(Math.Math, begD, endD);
     IF TckKind.Type = L_TRS.tkt_PieceTck THEN
      IF SEARCH(mItem, Math, Math.Math, _Storage) THEN
       CONFORM(mItem, XObject);
       SETEMPTY(SaldoPer);
       SELECT(XCalc, XObject, , XObject.XObject);
       WHILE OCCURE(XCalc) DO
        CONFORM(XCalc, AcCut);
        NARROWSEL(XCalc, AcCut);
        IF AcCut.SldType = L_AcCut.sldt_wAmount THEN
         SRCINSEL(XCalc, LT, , L_DatTim.Per(begD));
         LOOP
          IF ~OCCURE(XCalc) THEN
           FIRST(XCalc);
           SaldoPer:=Math.Min(SaldoPer, XCalc.XDat - 1);
           EXIT;
          ELSIF L_MathR.IsMathDone_AP(Math.Math, XCalc.XDat) THEN
           SaldoPer:=Math.Min(SaldoPer, XCalc.XDat);
           EXIT;
          ELSE
           PREV(XCalc);
          END;
         END;
        END;
        NEXTINEXTENDEDSEL(XCalc, AcCut);
       END; (* WHILE OCCURE(XCalc) ... *)
       IF ~!SaldoPer THEN
        SELECT(XCalc, XObject, , XObject.XObject);
        WHILE OCCURE(XCalc) DO
         NARROWSEL(XCalc, AcCut);
         CONFORM(XCalc, AcCut);
         IF AcCut.SldType = L_AcCut.sldt_wAmount THEN
          SAVE(XCalc);
          CONFORM(XObject, MyFirm);
          L_XObj.GetOutRSaldo(XCalc.AcCut, SaldoPer, dmySum, curQnt);
          ctm_ExecPackProc(PackProc, 0, L_Acnt.avp_InSaldo, curQnt, begD, TckKindInvariability);
          RESTORE(XCalc);
         END;
         NEXTINEXTENDEDSEL(XCalc, AcCut);
        END; (* WHILE OCCURE(XCalc) ... *)
       END;
 
       SETSEL(MDocList, Math, Math.Math);
       SRCINSEL(MDocList, GT, , L_DatTim.MonthEnd(SaldoPer));
       WHILE OCCURE(MDocList) & (MDocList.Date < endD) DO
        CONFORM(MDocList, MDoc);
        CONFORM(MDoc, MyFirm);
        IF (MDoc.Status = L_MDoc.st_Passed) THEN
         mft:=L_MDoc.getMDocListStorageRelatedMathFlowType();
         IF mft # L_MDoc.mft_None THEN
          IF MDoc.Storage2 = _Storage THEN
           mft:=L_MDoc.InvertMathFlowType(mft);
          ELSIF MDoc.Storage # _Storage THEN
           mft:=L_MDoc.mft_None;
          END;
         END; (*IF mft # L_MDoc.mft_None*)
         IF (MDocList.Date >= begD) THEN
          IF !L_XDoc.GetRefToXDC(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_TckRcD) THEN
           IF mft = L_MDoc.mft_Debit THEN
            ctm_ExecPackProc(PackProc, 0, L_Acnt.avp_Debit, MDocList.Qnt,
                             MDoc.Date, TckKindInvariability);
           ELSIF mft = L_MDoc.mft_Credit THEN
            ctm_ExecPackProc(PackProc, 0, L_Acnt.avp_Credit, MDocList.Qnt,
                             MDoc.Date, TckKindInvariability);
           END;
          END;
         ELSE
          IF mft = L_MDoc.mft_Debit THEN
           ctm_ExecPackProc(PackProc, 0, L_Acnt.avp_InSaldo,  MDocList.Qnt,
                            MDoc.Date, TckKindInvariability);
          ELSIF mft = L_MDoc.mft_Credit THEN
           ctm_ExecPackProc(PackProc, 0, L_Acnt.avp_InSaldo, -MDocList.Qnt,
                            MDoc.Date, TckKindInvariability);
          END;
         END; (*IF (MDocList.Date >= begD)*)
        END; (*IF (MDoc.Status = L_MDoc.st_Passed)*)
        NEXT(MDocList);
       END; (*WHILE OCCURE(MDocList) & (MDocList.Date < endD)*)
      END; (*IF SEARCH(mItem, Math, Math.Math, _Storage)*)
     ELSE
      SETSEL(CUCopy, Math, Math.Math);
      SRCINSEL(CUCopy, GT, , begD);
      WHILE OCCURE(CUCopy) DO
       PROMPT(" 室饣 ᠫ줮: " + Math.Math + ", " + CUCopy.CUCopy);
       IF L_TRS.IsBulk_wCUC() THEN
        PackNotEnded:=~SearchTckRcDLL(CUCopy.CUCopy, begD, begTime, 0) | !TckRcDLL.Sum;
       ELSE
        PackNotEnded:=~SearchTckRcDL(CUCopy.CUCopy, begD, begTime, 0) | ~!TckRcDL.RestNbr;
       END; (*IF L_TRS.IsBulk_wCUC() *)
       IF PackNotEnded THEN
        IF SearchMDocLCU(CUCopy.CUCopy, endD, endTime, 0) THEN
         WHILE OCCURE(MDocLCU) & IsAfterPassed(MDocLCU.Date, MDocLCU.PassDTS, begD, begTime) DO
          CONFORM(MDocLCU, MDocList);
          CONFORM(MDocList, MDoc);
          CONFORM(MDoc, MyFirm);
          IF !L_XDoc.GetRefToXDC(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_TckRcD) THEN
           mft:=L_MDoc.getMDocListStorageRelatedMathFlowType();
           IF mft # L_MDoc.mft_None THEN
            IF MDoc.Storage2 = _Storage THEN
             mft:=L_MDoc.InvertMathFlowType(mft);
            ELSIF MDoc.Storage # _Storage THEN
             mft:=L_MDoc.mft_None;
            END;
           END;
           IF mft = L_MDoc.mft_Debit THEN
            ctm_PutByMDocLCU(L_Acnt.avp_Debit, PackProc, TckKindInvariability);
           ELSIF mft = L_MDoc.mft_Credit THEN
            ctm_PutByMDocLCU(L_Acnt.avp_Credit, PackProc, TckKindInvariability);
           END;
          END;
          PREV(MDocLCU);
         END; (* WHILE OCCURE(MDocLCU) ...*)
         IF OCCURE(MDocLCU) & (GetCurMDocLCUStorage() = _Storage) THEN
          IF L_TRS.IsBulk_wCUC() & ~SearchTckRcDLL(CUCopy.CUCopy, begD, begTime, 1) |
             ~L_TRS.IsBulk_wCUC() & ~SearchTckRcDL(CUCopy.CUCopy, begD, begTime, 1) |
             IsAfterPassed(TckRcDL.Date, TckRcDL.PassDTS, begD, begTime) THEN
           ctm_PutByMDocLCU(L_Acnt.avp_InSaldo, PackProc, TckKindInvariability);
          END;
         END;
        ELSIF IsBuildFirstViP THEN
         IF IsMyStorage THEN
          IF L_TRS.IsBulk_wCUC() THEN
           IF SearchTckRcDLL(CUCopy.CUCopy, begD, begTime, 0) THEN
            IF !TckRcDLL.Sum & ~SearchMDocLCU(CUCopy.CUCopy, TckRcDLL.Date, TckRcDLL.PassDTS, 1) THEN
             CONFORM(TckRcDLL, TckRcDL);
             CONFORM(TckRcDL, TckRcD);
             IF (TckRcD.Type = L_TRS.trdt_Return) & (L_TRS.GetTckRcDMyFirm() = _MyFirm) THEN
              ctm_ExecPackProc(PackProc, 1, L_Acnt.avp_InSaldo, 1,
                               TckRcD.Date, TckKindInvariability);
             END;
            END;
           END;
          ELSE
           IF SearchTckRcDL(CUCopy.CUCopy, begD, begTime, 0) THEN
            IF ~!TckRcDL.RestNbr & ~SearchMDocLCU(CUCopy.CUCopy, TckRcDL.Date, TckRcDL.PassDTS, 1) THEN
             CONFORM(TckRcDL, TckRcD);
             IF (TckRcD.Type = L_TRS.trdt_Return) & (L_TRS.GetTckRcDMyFirm() = _MyFirm) THEN
              ctm_ExecPackProc(PackProc, 1, L_Acnt.avp_InSaldo, TckRcDL.RestNbr,
                               TckRcD.Date, TckKindInvariability);
             END;
            END;
           END;
          END; (* IF L_TRS.IsBulk_wCUC() *)
         END; (* IF IsMyStorage *)
        END; (* IF SearchMDocLCU ... *)
       END; (* IF PackNotEnded *)
       NEXT(CUCopy);
      END; (* WHILE OCCURE(CUCopy) ... *)
     END; (* IF (TckKind.Type = L_TRS.tkt_PieceTck) *)
    END; (* IF L_TRS.AccessTckKindByMath(Math.Math, endD) *)
    NEXT(Math);
   END; (* WHILE OCCURE(Math) ... *)
   NEXT(CarUnit);
  END; (* WHILE OCCURE(CarUnit) ... *)
 END {extCollectTckMovement};

 PUBLIC PROCEDURE CollectTckMovement(_Storage: LIKE(Storage.Storage); begTime, endTime: TIMESTAMP; PackProc: PROC);
 BEGIN
  extCollectTckMovement(_Storage, begTime, endTime, PackProc, 0);
 END {extCollectTckMovement};

 PUBLIC PROCEDURE E_NeedPrintLabel(_CUCopy: LIKE(CUCopy.CUCopy); OpKind: tOpKind): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  L_General.CallUs(SEARCH(CUCopy, CUCopy, _CUCopy));
  IF cucRole_IsTck() THEN
   RETURN 0;
  ELSE
   Local:=PROCREF(E_Stock.NeedPrintLabelForOpKind);
   IF ~!Local THEN
    RETURN Local(OpKind);
   ELSE
    RETURN (OpKind = ok_Setting) | (OpKind = ok_Fixup);
   END;
  END;
 END {E_NeedPrintLabel};

 PRIVATE PROCEDURE iis_Slice(Serial: STRING[]; VAR ser, num: STRING[]);
 BEGIN
  num:=Str.Slice(Serial, Str.Pos(Serial, " ", , BACKWARD), Str.Length(Serial));
  IF !num & (Str.Slice(Serial, 0, 1) = "#") THEN
   ser:="#";
   num:=Str.Slice(Serial, 1, Str.Length(Serial));
  ELSE
   ser:=Str.Slice(Serial, 0, Str.Length(Serial) - Str.Length(num));
  END;
 END {iis_Slice};

 PRIVATE PROCEDURE iis_PackStep(D: DATE): NUMERIC[0];
 BEGIN
  SELECT(TckKind, Math, , CUCopy.Math);
  WHILE OCCURE(TckKind) DO
   IF L_DatTim.IsActive(D, TckKind.Begin, TckKind.Till) & (TckKind.Type = L_TRS.tkt_Ticket) THEN
    RETURN TckKind.PckVol;
   END;
   NEXT(TckKind);
  END; (* WHILE OCCURE(TckKind) ... *)
  RETURN 1;
 END {iis_PackStep};

 PUBLIC PROCEDURE IsSuccessionSerials(s1, s2: STRING[]; step: NUMERIC[0]): SCAL[2];
  VAR
   n1,
   n2   : NUMERIC[0];
   num1,
   num2,
   ser1,
   ser2 : STRING[];
 BEGIN
  iis_Slice(s1, ser1, num1);
  iis_Slice(s2, ser2, num2);
  IF ser1 # ser2 THEN
   RETURN 0;
  END;
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   n1:=STRTOFLD(num1, NUMERIC);
   n2:=STRTOFLD(num2, NUMERIC);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_FailedSTRTOFLD THEN
    RETURN 0;
   ELSE
    RAISE();
   END;
  END; (* TRY *)
  RETURN n2 - n1 = step;
 END {IsSuccessionSerials};

 PUBLIC PROCEDURE IsInSuccession(D: DATE; cuc1, cuc2: LIKE(CUCopy.CUCopy)): SCAL[2];
  VAR
   step : NUMERIC[0];
   s1,
   s2 : STRING[];
 BEGIN
  (* ஢,        - ⠢塞  ᮢ 맢襣 *)
  SEARCH(CUCopy, CUCopy, , cuc1);
  s1:=CUCopy.Serial;
  SEARCH(CUCopy, CUCopy, , cuc2);
  s2:=CUCopy.Serial;
  RETURN IsSuccessionSerials(s1, s2, iis_PackStep(D));
 END {IsInSuccession};

 PUBLIC PROCEDURE ps_CreateJob(VAR PaperForm: STRING[]): PRINTJOB;
  VAR
   PrinterName: STRING[];
 BEGIN
  L_Print.GetPA_Stick(PrinterName, PaperForm);
  RETURN L_Print.CreatePrintJob(L_Print.pt_Stick, " ",
                                L_Print.Stick_NamePaperForm(), L_Print.o_Portrait);
 END {ps_CreateJob};

 PRIVATE PROCEDURE ps_PutSubjectName(PJ       : PRINTJOB;
                                     PaperForm: STRING[];
                                     trgMath  : LIKE(Math.Math);
                                     trgCUCopy: LIKE(CUCopy.CUCopy));
  CONST
   LnStr  = 25;
   RowCnt = 3;
  VAR
   ts         : TEXTSTYLE;
   SubjectName: STRING[];
   ArrStr     : STRING[][RowCnt];
   Idx        : NUMERIC[0];
   dummy      : SCAL[2];
   x, y0, dy  : NUMERIC[1];
   ts_size    : FLOAT;
 BEGIN
  L_General.CallUs(SEARCH(Math, Math, trgMath));
  SubjectName:=Math.Math + " " + Math.Name;
  IF ~!trgCUCopy THEN
   L_General.CallUs(SEARCH(CUCopy, CUCopy, trgCUCopy));
   INC(SubjectName, " (" + CUCopy.CUCopy + ")");
   IF CUCopy.Serial # GetDefaultSerial(CUCopy.CUCopy) THEN
    INC(SubjectName, L_Str.CRLF + "  " + CUCopy.Serial);
   END;
  END;
  dummy:=L_Str.SplitStrToStrArray(ArrStr, SubjectName, LnStr, RowCnt);
  IF    PaperForm = L_Print.pf_Stick_6040 THEN
   ts_size:=10; x:=11; y0:=10; dy:=4.5;
  ELSIF PaperForm = L_Print.pf_Stick_4525 THEN
   ts_size:=8; x:=5; y0:=5; dy:=3.5;
  ELSE
   L_General.CallUs(0);
  END;
  ts:=L_Print.ts_Create(ts_size, "Times New Roman");
  Idx:=0;
  WHILE (Idx < RowCnt) & ~!ArrStr[Idx]  DO
   L_Print.extTypeS(PJ, x, y0+Idx*dy, ArrStr[Idx], ts, L_Print.cp_OEM_Russian);
   INC(Idx);
  END; (* WHILE Idx < ... *)
 END {ps_PutSubjectName};

 PRIVATE PROCEDURE ps_PutBarCode(PJ       : PRINTJOB;
                                 PaperForm: STRING[];
                                 xdt      : L_XDoc.tXDocType;
                                 xd       : L_XDoc.tXDoc);
  VAR
   tsBarCode: TEXTSTYLE;
   x, y     : NUMERIC[1];
   tsbc_size: FLOAT;
 BEGIN
  IF    PaperForm = L_Print.pf_Stick_6040 THEN
   tsbc_size:=30; x:=11; y:=33;
  ELSIF PaperForm = L_Print.pf_Stick_4525 THEN
   tsbc_size:=22; x:=5; y:=21;
  ELSE
   L_General.CallUs(0);
  END;
  tsBarCode          :=TEXTSTYLE.Create();
  tsBarCode.Font.Face:="BC Code 128";
  tsBarCode.Font.Size:=tsbc_size;
  L_Print.extTypeS(PJ, x, y, L_XDoc.BarCode(L_XDoc.bck_IdIn17, xdt, L_XDoc.EmptyXDocKind, xd, 0), tsBarCode, L_Print.cp_ISO_8859_1_Latin_I);
 END {ps_PutBarCode};

 PUBLIC PROCEDURE PrintStick(PJ       : PRINTJOB;
                             PaperForm: STRING[];
                             trgMath  : LIKE(Math.Math);
                             trgCUCopy: LIKE(CUCopy.CUCopy));
 BEGIN
  PJ.StartPage();
  ps_PutSubjectName(PJ, PaperForm, trgMath, trgCUCopy);
  IF !trgCUCopy THEN
   ps_PutBarCode(PJ, PaperForm, L_XDoc.xdt_Math, trgMath);
  ELSE
   ps_PutBarCode(PJ, PaperForm, L_XDoc.xdt_CUCopy, trgCUCopy);
  END;
  PJ.EndPage();
 END {PrintStick};

 PUBLIC PROCEDURE PrintSticksByMath(PJ       : PRINTJOB;
                                    PaperForm: STRING[];
                                    trgMath  : LIKE(Math.Math);
                                    trgQnt   : NUMERIC[0]);
 BEGIN
  WHILE trgQnt > 0 DO
   PROMPT(trgMath + " " + L_Str.IntStr(trgQnt));
   PrintStick(PJ, PaperForm, trgMath, EMPTYOF(CUCopy.CUCopy));
   DEC(trgQnt);
  END;
 END {PrintSticksByMath};

END.
