(*
%Copyright   (c) Polak IT
%Author      01.03.2005 19:22:28 POLAK\San
%Purpose     প Dest
%Type        library
%Specific    SYS
%Modified    04.09.2014 20:15:32 POLAK\Bor
%Environment
*)

 MODULE L_Dest [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_APtm, L_StdFrm, L_AcMth, L_r2r, Str, L_ACL, L_SysLog, L_kn;

 PUBLIC CONST
  erkn_DebtAmortization    = 010298801;
  erkn_CashMovement        = 010298802;
  erkn_SumPaidOutOnAccount = 010298803;
  erkn_vmdbm_Prepayment    = 010298804;
  erkn_vmdbm_OnPrpShpmt    = 010298805;
  erkn_vmdbm_Underpay      = 010298806;
  erkn_vmdbm_Pstpayment    = 010298807;
  erkn_vmdbm_PrchUndpay    = 010298808;
  erkn_vmdbm_PrchPstpay    = 010298809;
  erkn_vmdbm_PrpReturn     = 010298810;
  erkn_CredAmortization    = 010298811;
  erkn_TckProceeds         = 010298812;
  erkn_TckMovement         = 010298813;
  erkn_FuelStationMovement = 010298814;
  erkn_ReleaseToProduction = 010298815;
  erkn_Salary              = 010298816;
  erkn_PDocwMDoc           = 010298817;

 PUBLIC PROCEDURE erkn_GetSoft(D: DATE; trgNotion: L_APtm.tNotion): LIKE(Dest.Dest);
 BEGIN
  RETURN L_kn.GetSoft(D, trgNotion);
 END {erkn_GetSoft};

 PUBLIC PROCEDURE erkn_Get(D: DATE; trgNotion: L_APtm.tNotion): LIKE(Dest.Dest);
 BEGIN
  RETURN L_kn.Get(D, trgNotion);
 END {erkn_Get};

 PUBLIC PROCEDURE PDocwMDocDest(): LIKE(Dest.Dest);
 BEGIN
  RETURN L_kn.Get(SYSDATE(), erkn_PDocwMDoc);
 END {PDocwMDocDest};

 PUBLIC PROCEDURE SalaryDest(): LIKE(Dest.Dest);
 BEGIN
  RETURN L_kn.Get(SYSDATE(), erkn_Salary);
 END {SalaryDest};

 PUBLIC PROCEDURE AccessDest(_Dest: LIKE(Dest.Dest));
 BEGIN
  L_General.CallUs(SEARCH(Dest, Dest, _Dest));
 END {AccessDest};

 PRIVATE PROCEDURE CheckDestERKN();
 BEGIN
  L_General.Assert(~SELECT(erkns, fi, TABLE.Get("Dest").Id, Dest.RECORDID),
                   "  権 "+Dest.Dest+"  '祭'|"+
                   "ꥤ  㣨  樨 ⨬");
 END {CheckDestERKN};

 PUBLIC PROCEDURE MergeDest(DestSrc, DestDst: LIKE(Dest.Dest); Silent: SCAL[2]);
  VAR
   ErrMsg : STRING[];
   DstName: LIKE(Dest.Name);
 BEGIN
  APP.Get().NewPrompt(" ᯮ짮  権 " + DestSrc + "  " + DestDst);
  ErrMsg:="訡  ꥤ  権 "+DestSrc+"  "+DestDst+"| |";
  SEARCH(Dest, Dest, , DestDst);
  CheckDestERKN();
  DstName:=Dest.Name;
  SEARCH(Dest, Dest, , DestSrc);
  CheckDestERKN();
  L_r2r.Owner_OnBeforeDelete("Dest");
  L_SysLog.SingleMark_BeforeDelete("Dest");
  IF ~Silent THEN
   L_StdFrm.JustQuestion(" ᯮ짮  樨" +
                         "| |" +
                         Str.Align(Dest.Dest + " " + Dest.Name, 36, LEFT) +
                         "|" +
                         "" +
                         "|" +
                         Str.Align(DestDst + " " + DstName, 36, LEFT));
  END;

  TRY
   SELECT(AcMth, Dest, , DestSrc);
   WHILE OCCURE(AcMth) DO
    L_AcMth.CheckDupCurAcMth(AcMth.DGroup, DestDst);
    NEXT(AcMth);
   END; (* WHILE OCCURE(AcMth) ... *)
  EXCEPT
  ON Exc: Exc_Raise DO
    L_General.Error(ErrMsg +
                    Exc.MsgOriginalText + L_StdFrm.HR() +
                    " ࠧ襭 ஡ 室  樨|" +
                    " ꥤ塞  権, ᮢ騥  㯯|"+
                    "権,  ꥪ⮢ ਠ쭮   ०.|" +
                    "⥬ 室    権 ( 訬|" +
                    "⢮ 㬥⮢) ⪠  㬥,|" +
                    "  樨  ࠡ 㬥, ᫥ 祣|"+
                    "㤠    ꥤ 権.");
  END;

  TRY [INTEGRITY(INTEGRITY_OFF)]
   REMOVE(Dest);
   SEARCH(Dest, Dest, , DestDst);
   Dest.Dest:=DestSrc;
   REPLACE(Dest);
  EXCEPT
  END;

  TRY [INTEGRITY(INTEGRITY_ON)]
   Dest.Dest:=DestDst;
   REPLACE(Dest);
  EXCEPT
  END;
 END {MergeDest};

END.
