(*
%Copyright   (c) Polak IT
%Author      08.01.2007 12:48:16 POLAK\GAV
%Purpose
%Type        library
%Specific    SYS
%Modified    16.04.2010 14:53:15 POLAK\GAV
%Environment
*)

 MODULE L_DFS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT FIO, L_DatTim, Math, Str, L_General;

 PUBLIC TYPE
  tTask = SCAL[16];

 PRIVATE PROCEDURE GetName(FullName: STRING[]): STRING[];
  VAR
   Name,
   Dummy: STRING[];
 BEGIN
  FIO.SplitPath(FullName, Name, , Dummy);
  RETURN Str.Cap(Name);
 END {GetName};

 PUBLIC PROCEDURE Do(FullName: STRING[]; Task: tTask);
  VAR
   Dummy: STRING[];
   d    : DATE;
   t    : TIME;
   s    : FLOAT;
   file : FOLDERENTRY;
 BEGIN
  file:=FOLDERENTRY.Create(FullName);
  SETEMPTY(DoneEF.DoneEF, DoneEF.RemDTS);
  DoneEF.Name   :=GetName(FullName);
  DoneEF.Task   :=Task;
  IF L_General.IsAcceptableProcessorVersion(014122180) THEN
   DoneEF.FileDTS:=file.UTCLastModified;
  ELSE
   DoneEF.FileDTS:=LOCALTOUNIVERSALTIMESTAMP(file.TimeLastModified);
  END;
  DoneEF.DoneDTS:=L_DatTim.GetSysTIMESTAMP();
  INSERT(DoneEF);
 END {Do};

 PUBLIC PROCEDURE IsDone(FullName: STRING[]; Task: tTask): SCAL[2];
  VAR
   file: FOLDERENTRY;
   dts : TIMESTAMP;
 BEGIN
  file:=FOLDERENTRY.Create(FullName);
  IF L_General.IsAcceptableProcessorVersion(014122180) THEN
   dts:=file.UTCLastModified;
  ELSE
   dts:=LOCALTOUNIVERSALTIMESTAMP(file.TimeLastModified);
  END;
  SELECT(DoneEF, Name, , Task, GetName(FullName));
  WHILE OCCURE(DoneEF) DO
   IF Math.Abs(DoneEF.FileDTS - dts) < 1/24/60/60 THEN
    RETURN 1;
   END;
   NEXT(DoneEF);
  END; (* WHILE OCCURE(DoneEF) ... *)
  RETURN 0;
 END {IsDone};

 PUBLIC PROCEDURE Remove(FullName: STRING[]; Task: tTask);
 BEGIN
  L_General.Assert(IsDone(FullName, Task), "    ࠡ⪥ 䠩 " + FullName);
  REMOVE(DoneEF);
 END {Remove};

END.
