(*
%Copyright   (c) Polak Computer System
%Author      03.06.2010 09:43:14 POLAK\MLB
%Purpose      ࠡ  Data Warehouse
%Type        library
%Specific    SYS
%Modified    10.08.2011 16:32:38 POLAK\MLB
%Environment
*)

 MODULE L_dwh [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, Str, L_General, L_Way, L_DBD, L_Str, DBD, L_DatTim, L_APtm;

 PUBLIC TYPE
  tOperation  = SCAL[3];
  tItemValue  = NUMERIC[3];

 PUBLIC CONST
  st_Prepared = 0; (* DWH.Status *)
  st_Passed   = 1;
  st_Canceled = 2;
  st_Pool     = "⮢|஢|㫨஢";

  ste_Prepared  = 0; (* DWHP.State *)
  ste_FilledSys = 1;
  ste_Calculate = 2;
  ste_Pool      = "⮢||⠭";

  dwhiType_Pool  = " " +
                   "|  " +
                   "| " +
                   "| ";

  MC_Pool   = "㬬|।"; (* dwhI.MthCalc *)
  MC_Sum    = 0;
  MC_Average= 1;

  MA_Pool   = "㬬|᫥"; (* dwhI.MthAdd *)
  MA_Sum    = 0;
  MA_Last   = 1;

  dwhCalc_Pool  = "-|";

  dwhiorig_Pool = "⥬|";
  dwhiorig_Sys = 0;
  dwhiorig_Opr = 1;

  dwhiSC_Pool="| ⥫쭮";
  dwhiSC_No          = 0;
  dwhiSC_NotNegative = 1;

  mstPln_NotRequired = 0; (* DWHI.MustPlan *)
  mstPln_Required    = 1;
  mstPln_NoPlan      = 2;

  mstFct_NotRequired = 0; (* DWHI.MustFact *)
  mstFct_Required    = 1;

  pool_period        = "|⠫|㣮|";
  pool_CntMonthInPer = "1|3|6|12";
  period_Amount = 4;
  perMonth      = 0;
  perQuarter    = 1;
  perHalfYear   = 2;
  perYear       = 3;

  pool_dwhSIWDOFormat = "1 234|1 234,5|1 234-56|1 234,56|1 234,567|%";
  pool_dwhSIXLSFormat = "# ##0|# ##0,0|# ##0-00|# ##0,00|# ##0,000|0,00";
  pool_StepRound      = "1    |0.1    |0.01    |0.01    |0.001    |0.01";
  dwhsIFrm_NumPrec0 = 0;
  dwhsIFrm_NumPrec1 = 1;
  dwhsIFrm_Currency = 2;
  dwhsIFrm_NumPrec2 = 3;
  dwhsIFrm_NumPrec3 = 4;
  dwhsIFrm_Percent  = 5;

  PUBLIC PROCEDURE CheckdwhIIsNotSys();
  BEGIN
   L_General.CallUs(ACCESS(dwhI));
   L_General.Assert(dwhI.Origin # dwhiorig_Sys, " ⥬ ⥫");
  END {CheckdwhIIsNotSys};

  PUBLIC PROCEDURE InsertdwhI(trgIdentif : LIKE(dwhI.Identif);
                              trgType    : LIKE(dwhI.Type);
                              trgMthCalc : LIKE(dwhI.MthCalc);
                              trgMthAdd  : LIKE(dwhI.MthAdd);
                              trgName    : LIKE(dwhI.Name);
                              trgShortN  : LIKE(dwhI.ShortN);
                              trgDiv1000 : LIKE(dwhI.Div1000);
                              trgUnit    : LIKE(dwhI.Unit);
                              trgFormula : LIKE(dwhI.Formula);
                              trgCalc    : LIKE(dwhI.Calc);
                              trgNumCycle: LIKE(dwhI.NumCycle);
                              trgOrigin  : LIKE(dwhI.Origin));
  BEGIN
   PROMPT("⠢    '" + trgIdentif + "'");
   SETEMPTY(dwhI.dwhI);
   dwhI.Name    :=trgName;
   dwhI.ShortN  :=trgShortN;
   dwhI.Identif :=trgIdentif;
   dwhI.Type    :=trgType;
   dwhI.MthCalc :=trgMthCalc;
   dwhI.MthAdd  :=trgMthAdd;
   dwhI.Div1000 :=trgDiv1000;
   dwhI.Unit    :=trgUnit;
   dwhI.Calc    :=trgCalc;
   IF dwhI.Calc THEN
    SETEMPTY(dwhI.MustPlan, dwhI.MustFact);
   ELSE
    dwhI.MustPlan:=mstPln_NotRequired;
    dwhI.MustFact:=mstFct_NotRequired;
   END;
   dwhI.Formula :=trgFormula;
   dwhI.NumCycle:=trgNumCycle;
   dwhI.Origin  :=trgOrigin;
   dwhI.SpecCond:=dwhiSC_No;
   INSERT(dwhI);
  END {InsertdwhI};

 PUBLIC PROCEDURE InsertAllSystemdwhI();
  VAR
   EmptyMC: LIKE(dwhI.MthCalc);
   EmptyMA: LIKE(dwhI.MthAdd);
 BEGIN
  SETEMPTY(EmptyMC, EmptyMA);
  InsertdwhI("5",  0, MC_Sum,     MA_Sum, "-   ࠢ ", "₈",   0, "",        "",       0, 0, dwhiorig_Sys);
  InsertdwhI("49", 3, MC_Average, MA_Sum, "-  ",           "",             0, "",        "",       0, 0, dwhiorig_Sys);
  InsertdwhI("33", 3, MC_Sum,     MA_Sum, "室",                                          "室",           1, "",      "",  0, 0, dwhiorig_Opr);
  InsertdwhI("52", 0, MC_Sum,     MA_Last,".   ᯫ樨   ⭮ ਮ","ᯫ",       0, "",       "",  0, 0, dwhiorig_Sys);
  InsertdwhI("3",  0, MC_Sum,     MA_Sum, "-  宧⢥",                             "",          0, "",       "",  0, 0, dwhiorig_Sys);
  InsertdwhI("4",  0, MC_Sum,     MA_Sum, "-  ࠡ",                                "",          0, "",       "",  0, 0, dwhiorig_Sys);
  InsertdwhI("53", 0, MC_Sum,     MA_Sum, "-  ६",                               "", 0, "",       "",  0, 0, dwhiorig_Sys);
  InsertdwhI("7",  0, MC_Sum,     MA_Sum, "--  宧-",                          "ℭ",       1, "",       "",  0, 0, dwhiorig_Sys);
  InsertdwhI("54", 0, MC_Sum,     MA_Sum, "--  ࠡ ",                         "ℭ",       1, "",       "",  0, 0, dwhiorig_Sys);
  InsertdwhI("55", 0, MC_Sum,     MA_Sum, "--  宧-  ।쭮 ⨬","।ℭ",  1, "",       "",  0, 0, dwhiorig_Sys);
  InsertdwhI("22", 2, MC_Sum,     MA_Sum, "-  ",                             "",          1, "",      "",  0, 0, dwhiorig_Sys);
  InsertdwhI("56", 2, MC_Sum,     MA_Sum, "-  ⮥",                              "⮥",   1, "",      "",  0, 0, dwhiorig_Sys);
  InsertdwhI("57", 2, MC_Sum,     MA_Sum, "-  ६  ",                     "",      1, "",      "",  0, 0, dwhiorig_Sys);
  InsertdwhI("23", 2, MC_Sum,     MA_Sum, "騩 ஡",                                     "஡",           1, "",       "",  0, 0, dwhiorig_Sys);
  InsertdwhI("24", 2, MC_Sum,     MA_Sum, "஡  ᠦࠬ",                             "஡ᠦ",       1, "",       "",  0, 0, dwhiorig_Sys);
  InsertdwhI("68", 2, MC_Sum,     MA_Sum, "ᠦ댎",                                      "ᠦ댎",       1, "",     "",  0, 0, dwhiorig_Sys);
  InsertdwhI("69", 2, MC_Sum,     MA_Sum, "ᠦ",                                       "ᠦ",        1, "",     "",  0, 0, dwhiorig_Sys);
  InsertdwhI("70", 2, MC_Sum,     MA_Sum, "ᠦ",                                      "ᠦ",       1, "",     "",  0, 0, dwhiorig_Sys);
  InsertdwhI("71", 2, MC_Sum,     MA_Sum, "ᠦ돫",                                    "ᠦ돫",     1, "",     "",  0, 0, dwhiorig_Sys);
  InsertdwhI("26", 2, MC_Sum,     MA_Sum, "ᠦம",                                  "Ꭱ",         1, " ",  "",  0, 0, dwhiorig_Sys);
  InsertdwhI("58", 2, MC_Sum,     MA_Sum, " - 믮 ३ᮢ",               "믐Ꮻ",    0, "",       "",  0, 0, dwhiorig_Sys);
  InsertdwhI("59", 2, MC_Sum,     MA_Sum, "- 믮 ३ᮢ  ",          "믁",    0, "",       "",  0, 0, dwhiorig_Sys);
  InsertdwhI("60", 2, MC_Sum,     MA_Sum, "- 믮 ३ᮢ  ﬨ",          "믑",      0, "",       "",  0, 0, dwhiorig_Sys);
  InsertdwhI("61", 2, MC_Sum,     MA_Sum, "- 믮 ᢥ  ३ᮢ",            "믑叫",   0, "",       "",  0, 0, dwhiorig_Opr);
  InsertdwhI("32", 3, MC_Sum,     MA_Sum, "室",                                           "室",            1, "",      "",  0, 0, dwhiorig_Opr);
  InsertdwhI("65", 3, MC_Sum,     MA_Sum, "室 ᮡ⢥",                               "室둮",       1, "",      "",  0, 0, dwhiorig_Opr);
  InsertdwhI("66", 3, MC_Sum,     MA_Sum, "室 믠騥",                                "室믠騥",  1, "",      "",  0, 0, dwhiorig_Opr);
  InsertdwhI("28", 2, MC_Sum,     MA_Sum, "- 믮 ३ᮢ",             "믐",                 0, "",        "59+60",         1, 1, dwhiorig_Opr);
  InsertdwhI("63", 3, MC_Sum,     MA_Sum, "室 ",                     "室댠",           1, "",       "65+66",         1, 1, dwhiorig_Opr);
  InsertdwhI("21", 2, EmptyMC,    EmptyMA, "-  拉",                   "",                    1, "",       "22+56+57",     1, 1, dwhiorig_Opr);
  InsertdwhI("25", 2, EmptyMC,    EmptyMA, "ᠦ",                            "ᠦ",                  0, "",      "68+69+70+71", 1, 1, dwhiorig_Opr);
  InsertdwhI("62", 2, EmptyMC,    EmptyMA, "- 믮   ३ᮢ", "믐⏫",         0, "",        "58-28",         1, 1, dwhiorig_Opr);
  InsertdwhI("1",  0, EmptyMC,    EmptyMA, "।ᯨ筮 -",               "।ኮ",                0, "",        "3/49",          1, 1, dwhiorig_Opr);
  InsertdwhI("2",  0, EmptyMC,    EmptyMA, " ",                    "",              0, "",        "4/49",          1, 1, dwhiorig_Opr);
  InsertdwhI("6",  0, EmptyMC,    EmptyMA, "। ⨬ 1 ",            "।1",             0, "",      "7/3",           1, 1, dwhiorig_Opr);
  InsertdwhI("8",  0, EmptyMC,    EmptyMA, " ⨬",                    "邬",                   0, "",      "6*1",           1, 2, dwhiorig_Opr);
  InsertdwhI("9",  1, EmptyMC,    EmptyMA, ".孨.⮢",           "",                        0, "-",    "(5+4)/3",      1, 1, dwhiorig_Opr);
  InsertdwhI("10", 1, EmptyMC,    EmptyMA, ".ᯮ짮 ઠ",            "",                        0, "-",    "4/3",           1, 1, dwhiorig_Opr);
  InsertdwhI("11", 1, EmptyMC,    EmptyMA, "६ ࠡ  拉",                "६",               0, "",       "21/4",          1, 1, dwhiorig_Opr);
  InsertdwhI("12", 1, EmptyMC,    EmptyMA, "६ ࠡ  ",              "६",              0, "",       "22/4",          1, 1, dwhiorig_Opr);
  InsertdwhI("13", 1, EmptyMC,    EmptyMA, "। ஡",                "।஡",                0, "",        "23/4",          1, 1, dwhiorig_Opr);
  InsertdwhI("14", 1, EmptyMC,    EmptyMA, "- ᯮ짮 ஡",         "ᯏ஡",                0, "-",    "24/23",         1, 1, dwhiorig_Opr);
  InsertdwhI("15", 1, EmptyMC,    EmptyMA, "। ﭨ ",           "।⏮",           0, "",        "26/25",         1, 2, dwhiorig_Opr);
  InsertdwhI("27", 2, EmptyMC,    EmptyMA, " ᠦம",            "Ꭱ",             1, " ",   "6*24",          1, 2, dwhiorig_Opr);
  InsertdwhI("16", 1, EmptyMC,    EmptyMA, "- ᯮ짮 ⨬",     "ᯂ",               0, "-",    "26/27",         1, 3, dwhiorig_Opr);
  InsertdwhI("17", 1, EmptyMC,    EmptyMA, "ࠡ⪠  1 .. ",      "ࠡ1⮌⮏",   0, "",      "25/(7/49)",    1, 1, dwhiorig_Opr);
  InsertdwhI("18", 1, EmptyMC,    EmptyMA, "ࠡ⪠  1 .. ()",  "ࠡ1⮌⮏Ꭱ", 0, " ",   "26/(7/49)",    1, 1, dwhiorig_Opr);
  InsertdwhI("19", 1, EmptyMC,    EmptyMA, "ᯫ樮 ᪮",            "ᯫ",              0, "/ ",   "23/21",         1, 1, dwhiorig_Opr);
  InsertdwhI("20", 1, EmptyMC,    EmptyMA, "㬠 - ᪠  ०",     "㬊믈",             0, "-",    "21/3",          1, 1, dwhiorig_Opr);
  InsertdwhI("29", 2, EmptyMC,    EmptyMA, "% 믮 ३ᮢ",                 "믐ᮢ",              0, "%",         "28/(28+62)",   1, 2, dwhiorig_Opr);
  InsertdwhI("31", 2, EmptyMC,    EmptyMA, "  ࢠ ३ᮢ",           "਎⑮࢐ᮢ",         1, "",       "(63/28)*62",   1, 2, dwhiorig_Opr);
 END {InsertAllSystemdwhI};

 PUBLIC PROCEDURE CheckLegalOwnerCurGroup();
  CONST
   pool_LegalOwnerName = "TKind|Mark|Route";
  VAR
   i      : NUMERIC[0];
   IsLegal: SCAL[2];
 BEGIN
  i:=0;
  IsLegal:=0;
  WHILE ~!L_Str.PoolItem(pool_LegalOwnerName, i) & ~IsLegal DO
   IF Group.Owner = DBD.FileNameToId(L_Str.PoolItem(pool_LegalOwnerName, i)) THEN
    IsLegal:=1;
   END;
   INC(i);
  END;
  L_General.Assert(IsLegal, " ᯮ짮 㯯 ᥩ , ஥  ⭮襭 |'" +
                            DBD.FileDescription((DBD.FileIdToName(Group.Owner))) + "'");
 END {CheckLegalOwnerCurGroup};

 PUBLIC PROCEDURE Check_dwhSPIsActive(Strong: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(dwhSP);
  CONFORM(DWHP, dwhSP);
  Result:=L_DatTim.IsActiveInIntvl(DWHP.PerB, DWHP.PerE, dwhSP.Begin, dwhSP.Till);
  IF ~Result & Strong THEN
   L_General.Error("䨪 ࠭ " + dwhSP.dwhSP + " '" + dwhSP.Name + "'|   " +
                    L_DatTim.PeriodStr(DWHP.PerB) + "  " + L_DatTim.PeriodStr(DWHP.PerE) );
  END;
  RESTORE(dwhSP);
  RETURN Result;
 END {Check_dwhSPIsActive};

END.