(*
%Copyright   (c) Polak Computer System
%Author      07.12.1998 13:02:12 SAN
%Purpose     ⥪  ࠡ  ਪ  ᮭ
%Type        library
%Specific    SYS
%Modified    01.08.2014 17:49:57 POLAK\GAV
%Environment
*)

 MODULE L_EDO [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tGroup = SCAL[1E2];

 PUBLIC CONST
  grp_Combining              = 01;
  grp_Adding                 = 02;
  grp_SingleRegimeAlteration = 03;
  grp_RegimeAlteration       = 04;
  grp_Violation              = 10;
  grp_Reward                 = 12;
  grp_ChangePersonalInfo     = 20;
  grp_Probation              = 30;
  grp_Permit                 = 31;
  grp_CancelPermit           = 32;
  grp_MCFix                  = 40;
  grp_BusinessTrip           = 50;
  grp_Deduct                 = 60;
  grp_BonusFee               = 61;

  st_Passed    = 0; (* EDOrderL.Status *)
  st_Canceled  = 1;
  st_Pool      = "|⬥";

  type_Initial = 0; (* EDOrderL.Type *)
  type_Correct = 1;
  type_Cancel  = 2;
  type_Pool    = "室|४騩|⬥騩";

  fipc_Nothing = 0;

  st_ordPrepared = 0;
  st_ordPrinted  = 1;
  st_ordModified = 2;
  st_ordSigned   = 3;

  edoct_Initial     = 0; (*EDOCause.Type*)
  edoct_Declaratory = 1;
  edoct_Enclosure   = 2;
  edoct_Decision    = 3;
  edoctPool = "㬥-᭮|᭥|㬥-ਫ|";

  ot_FO  = 0;
  ot_EDO = 1;

  fost_Prepared  = 0; (*FOrder.Status*)
  fost_Passed    = 1;
  fost_Canceled  = 2;

  tn_NoTemplate = "NoTemplate";
  tn_Standart   = "EDO";
  tn_T11a       = "t11a";
  tn_T11x       = "t11x";
  tn_T9_10      = "t9+t10";
  tn_Combining  = "EDO_Combining";
  tn_CPI        = "EDO_20_01";

 IMPORT L_General, L_DatTim, L_Str, DBD, L_EC, E_Staff, P_EDOKnd, L_XDoc, L_AcsPnt, L_MSO, L_Events,
        L_StdFrm, L_PRoll, P_EDOL, L_Staff, Math, L_Man, L_APtm;

 PUBLIC PERMANENT VAR
  curEDOrder: SCAL[1E7]; (* LIKE(EDOrderL.EDOrder);*)
  curRow    : SCAL[1E4]; (* LIKE(EDOrderL.Row);    *)
  curEDOGrp : SCAL[1E2]; (* LIKE(EDOKind.EDOGrp);  *)

 PUBLIC PROCEDURE AcceptableEDOrderL(): SCAL[2];
 BEGIN
  RETURN (EDOrderL.Status = st_Passed) & (EDOrderL.Type # type_Cancel);
 END {AcceptableEDOrderL};

 PRIVATE PROCEDURE MayPassAccessPoint(trgAcsPnt: LIKE(AcsPnt.AcsPnt)): SCAL[2];
 BEGIN
  IF !trgAcsPnt THEN
   RETURN L_General.IsAdmin();
  ELSE
   RETURN L_AcsPnt.MayPassAccessPoint(trgAcsPnt);
  END;
 END {MayPassAccessPoint};

 PUBLIC PROCEDURE AccessibleSrc(OrderType: SCAL[2]; VAR EDOSources: SCAL[2][]);
 BEGIN
  SETZERO(EDOSources);
  SAVE(EDOSrc);
  SELECT(EDOSrc, EDOSrc);
  WHILE OCCURE(EDOSrc) DO
   IF    OrderType = ot_EDO THEN
    EDOSources[EDOSrc.EDOSrc]:=MayPassAccessPoint(EDOSrc.apMEDO) |
                               MayPassAccessPoint(EDOSrc.apVEDO);
   ELSIF OrderType = ot_FO THEN
    EDOSources[EDOSrc.EDOSrc]:=MayPassAccessPoint(EDOSrc.apMFO) |
                               MayPassAccessPoint(EDOSrc.apVFO);
   END;
   NEXT(EDOSrc);
  END;
  RESTORE(EDOSrc);
 END {AccessibleSrc};

 PRIVATE PROCEDURE intGetEDOSrcPermanentFilter(OrderType: SCAL[2]; File: STRING[]; VAR Filter: STRING[]; VAR SrcCnt: NUMERIC[0]);
  VAR
   EDOSources: SCAL[2][MAXOF(EDOSrc.EDOSrc)+1];
 BEGIN
  SrcCnt:=0;
  AccessibleSrc(OrderType, EDOSources);
  Filter:="";
  SAVE(EDOSrc);
  SELECT(EDOSrc, EDOSrc);
  WHILE OCCURE(EDOSrc) DO
   IF EDOSources[EDOSrc.EDOSrc] THEN
    IF ~!Filter THEN
     Filter:=Filter + "|";
    END;
    Filter:=Filter + "(" + File + ".EDOSrc=" + EDOSrc.EDOSrc+")";
    INC(SrcCnt);
   END;
   NEXT(EDOSrc);
  END; (* WHILE OCCURE(EDOSrc)... *)
  RESTORE(EDOSrc);
 END {intGetEDOSrcPermanentFilter};

 PUBLIC PROCEDURE GetEDOSrcPermanentFilter(OrderType: SCAL[2]; VAR Filter: STRING[]; VAR SrcCnt: NUMERIC[0]);
 BEGIN
  intGetEDOSrcPermanentFilter(OrderType, "EDOSrc", Filter, SrcCnt);
 END {GetEDOSrcPermanentFilter};

 PUBLIC PROCEDURE GetOrderLSrcPermanentFilter(OrderType: SCAL[2]): STRING[];
  VAR
   Result: STRING[];
   SrcCnt: NUMERIC[0];
 BEGIN
  IF OrderType = ot_EDO THEN
   intGetEDOSrcPermanentFilter(ot_EDO, "EDOrderL", Result, SrcCnt);
  ELSE
   intGetEDOSrcPermanentFilter(ot_FO,  "FOrderL",  Result, SrcCnt);
  END;
  RETURN Result;
 END {GetOrderLSrcPermanentFilter};

 PUBLIC PROCEDURE FOrderName(): STRING[];
 BEGIN
  IF DBD.FieldExist(FOrder, EDOSrc) THEN
   CONFORM(FOrder, EDOSrc);
   RETURN FOrder.Name + "  " + L_DatTim.DateStr(FOrder.Date) + " (" + EDOSrc.Name + ")";
  ELSE
   RETURN FOrder.Name + "  " + L_DatTim.DateStr(FOrder.Date);
  END;
 END {FOrderName};

 PUBLIC PROCEDURE EDOrderName(): STRING[80];
  VAR
   _Date: DATE;
   Prf  : STRING[];
 BEGIN
  CONFORM(EDOrder, EDOSrc);
  IF ~!EDOrder.Date THEN
   _Date:=EDOrder.Date;
  ELSE
   _Date:=EDOrder.PrpDate;
  END;
  IF !EDOrder.SrcNum THEN
   Prf:=" " + EDOrder.EDOrder;
  ELSE
   Prf:="N " + EDOrder.SrcNum;
  END;
  RETURN Prf + "  " + L_DatTim.DateStr(_Date) + " (" + EDOSrc.Name + ")";
 END {EDOrderName};

 PUBLIC PROCEDURE EDorderMustBeSigned(trgDate: DATE);
  VAR
   Msg: STRING[];
 BEGIN
  IF EDOrder.State # st_ordSigned THEN
   IF    L_Staff.IsLeave(L_DatTim.Per(SYSDATE())) THEN
    Msg:="⭨ 㢮.  ᠭ ਪ  ᮭ:|" + EDOrderName();
    L_StdFrm.CrucialChoice_FileExplicit("Staff", Msg, L_APtm.g_PayRoll);
   ELSIF SYSDATE() >= L_PRoll.GetFinalCalcDate(trgDate) THEN
    L_StdFrm.Choice(" ᠭ ਪ  ᮭ:|" + EDOrderName());
   END;
  END;
 END {EDorderMustBeSigned};

 PRIVATE PROCEDURE IsInFrame(_Property: LIKE(Property.Property); Val: NUMERIC[3]): SCAL[2];
  VAR
   Min, Max: NUMERIC[3];
 BEGIN
  P_EDOKnd.Get_AnyInterval(EDOKind.EDOKind, EDOrder.PrpDate, _Property, Min, Max);
  IF ~!Min & ~!Max THEN
   RETURN (Val >= Min) & (Val <= Max);
  ELSE
   RETURN Val = 0;
  END;
 END {IsInFrame};

 PRIVATE PROCEDURE SetByFrame(_Property: LIKE(Property.Property); Txt: STRING[32]; VAR Val: NUMERIC[3]);
  VAR
   Min, Max: NUMERIC[3];
 BEGIN
  Val:=0;
  P_EDOKnd.Get_AnyInterval(EDOKind.EDOKind, EDOrder.PrpDate, _Property, Min, Max);
  IF ~!Min & ~!Max THEN
   IF Min = Max THEN
    IF Min # 0 THEN
     L_StdFrm.Inform("稭 " + Txt + " - " + FLDTOSTR(Min, "2.", 0));
    END;
    Val:=Min;
   ELSE
    L_StdFrm.Inform(" " + Txt + " -  " + FLDTOSTR(Min, "2.", 0) + "  " + FLDTOSTR(Max, "2.", 0));
   END;
  END;
 END {SetByFrame};

 PUBLIC PROCEDURE SetSum_Prc();
 BEGIN
  SetByFrame(P_EDOKnd.P_SumInterval,  "㬬",    EDOrderL.BySum);
  SetByFrame(P_EDOKnd.P_ProcInterval, "業", EDOrderL.ByPrc);
 END {SetSum_Prc};

 PUBLIC PROCEDURE CheckBounds();
 BEGIN
  IF ~IsInFrame(P_EDOKnd.P_SumInterval, EDOrderL.BySum) THEN
   L_StdFrm.Choice(" 㬬 室  ⨬ ।");
  END;
  IF ~IsInFrame(P_EDOKnd.P_ProcInterval, EDOrderL.ByPrc) THEN
   L_StdFrm.Choice("稭 業 室  ⨬ ।");
  END;
 END {CheckBounds};

 PUBLIC PROCEDURE EDO_MayModify(WithContent: SCAL[2]);
 BEGIN
  L_General.Assert(ACCESS(EDOrder),
                   " ⠭ ⥪騩 ਪ  ᮭ");
  L_General.Assert(EDOrder.State # st_ordSigned, "ਪ 㦥 ᠭ");
  IF WithContent THEN
   IF (E_EDO_Level(EDOrder.PrpDate) # 0) &
      (EDOrder.State = st_ordPrinted) THEN
    L_StdFrm.Choice(" ਪ  ⯥⠭  .| 饭  ࠡ?");
    EDOrder.State:=st_ordModified;
    REPLACE(EDOrder);
   END;
  END;
 END {EDO_MayModify};

 PUBLIC PROCEDURE StandOnEDOrder(_EDOrder: LIKE(EDOrder.EDOrder);
                                 _Row    : LIKE(EDOrderL.Row));
 BEGIN
  L_General.CallUs(SEARCH(EDOrderL, EDOrder, _EDOrder, _Row));
  SEARCH(EDOrder, EDOrder, , _EDOrder);
 END {StandOnEDOrder};

 PUBLIC PROCEDURE GetFixInPCPool(_EDOGrp : LIKE(EDOGrp.EDOGrp)): STRING[];
 BEGIN
  IF    _EDOGrp = grp_Violation THEN
   RETURN E_EDG10FixInPool();
  ELSIF _EDOGrp = grp_Reward THEN
   RETURN " |୮|⭠ ࠬ| ப";
  ELSE
   RETURN "";
  END;
 END {GetFixInPCPool};

 PUBLIC PROCEDURE GetFixInPC_byStr(_EDOGrp : LIKE(EDOGrp.EDOGrp);
                                   _FixInPC: LIKE(EDOrderL.FixInPC)): STRING[30];
 BEGIN
  RETURN L_Str.PoolItem(GetFixInPCPool(_EDOGrp), _FixInPC);
 END {GetFixInPC_byStr};

 PUBLIC PROCEDURE GetEDOLPropValue(    trgProperty: LIKE(EDOLPro.Property);
                                   VAR trgValue   : STRING[]);
  VAR
   curValue: STRING[];
 BEGIN
  SETEMPTY(trgValue);
  SELECT(EDOLPro, EDOrder, , EDOrderL.EDOrder, EDOrderL.Row, trgProperty);
  WHILE OCCURE(EDOLPro) DO
   IF ~!P_EDOL.IsSimpleUserOf(trgProperty) THEN
    curValue:=P_EDOL.Decode_CurEDOLPro();
   ELSE
    curValue:=EDOLPro.Value;
   END;
   trgValue:=L_Str.AddStrDlm(trgValue, ";") + curValue;
   NEXT(EDOLPro);
  END; (* WHILE OCCURE(EDOLPro)... *)
 END {GetEDOLPropValue};

 PUBLIC PROCEDURE GetEDOLPropVal2Show(    trgProperty: LIKE(EDOLPro.Property);
                                      VAR trgValue   : STRING[]);
 BEGIN
  SETEMPTY(trgValue);
  SELECT(EDOLPro, EDOrder, , EDOrderL.EDOrder, EDOrderL.Row, trgProperty);
  WHILE OCCURE(EDOLPro) DO
   IF ~!EDOLPro.Val2Show THEN
    trgValue:=L_Str.AddStrDlm(trgValue, ";") + EDOLPro.Val2Show;
   END;
   NEXT(EDOLPro);
  END; (* WHILE OCCURE(EDOLPro)... *)
 END {GetEDOLPropVal2Show};

 PUBLIC PROCEDURE AccessAddKind(_Kind: LIKE(EDOrderL.EDOKind); _Date: DATE);
 BEGIN
  SEARCH(AddKind, AddKind, , P_EDOKnd.GetEDOKProStrong(_Kind, _Date, P_EDOKnd.P_AddKind));
 END {AccessAddKind};

 PUBLIC PROCEDURE SetCurrentEDOGrpByEDOrderL();
 BEGIN
  L_General.Assert(ACCESS(EDOrderL), " ⠭ ⥪ ப ਪ");
  SEARCH(EDOGrp, EDOGrp, , EDOrderL.EDOGrp);
  curEDOGrp:=EDOGrp.EDOGrp;
 END {SetCurrentEDOGrpByEDOrderL};

 PUBLIC PROCEDURE IsEDOrderOfGroup(trgEDOGrp: LIKE(EDOKind.EDOGrp)): SCAL[2];
 BEGIN
  IF !EDOrder.EDOGrp THEN
   IF ~SELECT(EDOrderL, EDOrder, EDOrder.EDOrder) THEN
    RETURN 0;
   END;
   CONFORM(EDOrderL, EDOKind);
   RETURN EDOKind.EDOGrp = trgEDOGrp;
  ELSE
   RETURN EDOrder.EDOGrp = trgEDOGrp;
  END;
 END {IsEDOrderOfGroup};

 PUBLIC PROCEDURE CanPrintAsTForm(trgEDOGrp: LIKE(EDOKind.EDOGrp); CanPrint: PROC): SCAL[2];
 BEGIN
  L_General.Assert(SELECT(EDOrderL, EDOrder, EDOrder.EDOrder), "祬  ⮩ ਪ");
  RETURN IsEDOrderOfGroup(trgEDOGrp) & CanPrint();
 END {CanPrintAsTForm};

 PRIVATE PROCEDURE cp_AsT9(): SCAL[2];
 BEGIN
  L_General.Assert(~NEXT(EDOrderL), "ਪ  ஢  ᮤঠ  ");
  RETURN 1;
 END {cp_AsT9};

 PUBLIC PROCEDURE EDOCauseCodes(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="";
  SELECT(EDOLC, edcType, , EDOrderL.EDOrder, EDOrderL.Row);
  WHILE OCCURE(EDOLC) DO
   IF ~!Result THEN
    Result:=Result + ";";
   END;
   Result:=Result + EDOLC.EDOCause;
   NEXT(EDOLC);
  END; (* WHILE OCCURE(EDOLC) ... *)
  RETURN Result;
 END {EDOCauseCodes};

 PUBLIC PROCEDURE cp_AsT11a(): SCAL[2];
  VAR
   _EDOKind  : LIKE(EDOrderL.EDOKind);
   _EDOCauses: STRING[];
   _FixInPC  : LIKE(EDOrderL.FixInPC);
   HasSums   : SCAL[2];
 BEGIN
  _EDOKind  :=EDOrderL.EDOKind;
  _FixInPC  :=EDOrderL.FixInPC;
  _EDOCauses:=EDOCauseCodes();
  HasSums   :=EDOrderL.BySum # 0;
  WHILE OCCURE(EDOrderL) DO
   IF (EDOrderL.EDOKind     # _EDOKind  ) |
      (EDOrderL.FixInPC     # _FixInPC  ) |
      ((EDOrderL.BySum # 0) # HasSums   ) |
      (EDOCauseCodes()      # _EDOCauses) THEN
    RETURN 0;
   END;
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
  RETURN 1;
 END {cp_AsT11a};

 PUBLIC PROCEDURE CanPrintAsT9(): SCAL[2];
 BEGIN
  RETURN CanPrintAsTForm(grp_BusinessTrip, PROCREF(cp_AsT9));
 END {CanPrintAsT9};

 PUBLIC PROCEDURE CanPrintAsT11a(): SCAL[2];
 BEGIN
  RETURN CanPrintAsTForm(grp_Reward,   PROCREF(cp_AsT11a)) |
         CanPrintAsTForm(grp_BonusFee, PROCREF(cp_AsT11a));
 END {CanPrintAsT11a};

 PRIVATE CONST
  sra_EntryAmount = 100;

 PRIVATE VAR
  sra_TSN: LIKE(Staff.TSN);
  sra_Per: DATE;
  sra_Dat: DATE             [sra_EntryAmount];
  sra_JMd: LIKE(JMode.JMode)[sra_EntryAmount];
  sra_Typ: SCAL[2]          [sra_EntryAmount];

 PRIVATE PROCEDURE sra_Src(D: DATE): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=0;
  WHILE ~!sra_Dat[Result] & (D # sra_Dat[Result]) DO
   INC(Result);
  END;
  RETURN Result;
 END {sra_Src};

 PRIVATE PROCEDURE sra_Put(workDay: SCAL[2]; wCheckSignedEDO: SCAL[2]);
  VAR
   D: DATE;
   i: NUMERIC[0];
 BEGIN
  IF workDay THEN
   D:=EDOrderL.OcrDate;
  ELSE
   D:=EDOrderL.EndDate;
  END;
  IF ~!D & (L_DatTim.Per(D) = sra_Per) THEN
   IF    EDOrder.State = st_ordSigned THEN
    i:=sra_Src(D);
    L_General.Assert(!sra_Dat[i],
                     "ਪ " + EDOrderName() +
                     "|४뢠 㦥 騩 ਪ  ᮭ");
    sra_Dat[i]:=D;
    sra_Typ[i]:=workDay;
    P_EDOKnd.Get_sraDescription(EDOrderL.EDOKind, EDOrder.Date, workDay, sra_JMd[i]);
   ELSIF wCheckSignedEDO THEN
    EDorderMustBeSigned(D);
   END;
  END;
 END {sra_Put};

 PRIVATE PROCEDURE sra_Init(trgTSN: LIKE(Staff.TSN); P: DATE; wCheckSignedEDO: SCAL[2]);
 BEGIN
  SAVE(Staff);
  L_General.CallUs(SEARCH(Staff, TSN, trgTSN));
  IF (sra_TSN # trgTSN) | (sra_Per # P) THEN
   sra_TSN:=trgTSN;
   sra_Per:=P;
   SETEMPTY(sra_Dat);
   SETSEL(EDOrderL, TSNGrCl, trgTSN, grp_SingleRegimeAlteration);
   IF SRCINSEL(EDOrderL, GE, L_DatTim.IncMonth(sra_Per, -2)) THEN
    WHILE OCCURE(EDOrderL) & (EDOrderL.Closed <= L_DatTim.IncMonth(sra_Per, +2)) DO
     IF AcceptableEDOrderL() THEN
      CONFORM(EDOrderL, EDOrder);
      sra_Put(0, wCheckSignedEDO);
      sra_Put(1, wCheckSignedEDO);
     END;
     NEXT(EDOrderL);
    END; (* WHILE OCCURE(EDOrderL) *)
   END;
  END;
  RESTORE(Staff);
 END {sra_Init};

 PUBLIC PROCEDURE sra_GetSpecifiedJMode_Int(trgTSN: LIKE(Staff.TSN); D: DATE; wCheckSignedEDO: SCAL[2]): LIKE(JMode.JMode);
 BEGIN
  sra_Init(trgTSN, L_DatTim.Per(D), wCheckSignedEDO);
  IF ~!sra_Dat[sra_Src(D)] THEN
   RETURN sra_JMd[sra_Src(D)];
  ELSE
   RETURN EMPTYOF(JMode.JMode);
  END;
 END {sra_GetSpecifiedJMode_Int};

 PUBLIC PROCEDURE sra_GetSpecifiedJMode(trgTSN: LIKE(Staff.TSN); D: DATE): LIKE(JMode.JMode);
 BEGIN
  RETURN sra_GetSpecifiedJMode_Int(trgTSN, D, 1);
 END {sra_GetSpecifiedJMode};

 PUBLIC PROCEDURE IsAutoNumeratedEDOrder(): SCAL[2];
 BEGIN
  IF ~ACCESS(EDOrder) | !EDOrder.PrpDate THEN
   RETURN 0;
  ELSE
   CONFORM(EDOrder, EDOSrc);
   RETURN (EDOSrc.AutoNumD<=EDOrder.PrpDate);
  END;
 END {IsAutoNumeratedEDOrder};

 PRIVATE PROCEDURE edocxdt_GetPool(Type    : LIKE(EDOCause.Type);
                                   GetNames: SCAL[2]): STRING[];
  VAR
   Result: STRING[];
   xdt   : L_XDoc.tXDocType;
 BEGIN
  Result:="";
  FOR_EACH xdt DO
   IF ((Type = edoct_Enclosure) & (xdt = L_XDoc.xdt_RWayS)   |
       (Type = edoct_Enclosure) & (xdt = L_XDoc.xdt_TckRcS)  |
       (Type = edoct_Enclosure) & (xdt = L_XDoc.xdt_RprS)    |
       (Type = edoct_Enclosure) & (xdt = L_XDoc.xdt_EDOrder) |
       (xdt = L_XDoc.xdt_ODoc)) THEN
    IF GetNames THEN
     Result:=Result + L_XDoc.Ref_FullName(xdt) + "|";
    ELSE
     Result:=Result + xdt + "|";
    END;
   END;
  END;
  RETURN Result;
 END {edocxdt_GetPool};

 PUBLIC PROCEDURE edocxdt_FullNames(Type: LIKE(EDOCause.Type)): STRING[];
 BEGIN
  RETURN edocxdt_GetPool(Type, 1);
 END {edocxdt_FullNames};

 PUBLIC PROCEDURE edocxdt_XDocTypes(Type: LIKE(EDOCause.Type)): STRING[];
 BEGIN
  RETURN edocxdt_GetPool(Type, 0);
 END {edocxdt_XDocTypes};

 PUBLIC PROCEDURE InsertEDOGrp(_EDOGrp: LIKE(EDOGrp.EDOGrp); Strong: SCAL[2]);
 BEGIN
  IF SEARCH(EDOGrp, EDOGrp, _EDOGrp) THEN
   L_General.CallUs(~Strong);
  ELSE
   EDOGrp.EDOGrp:=_EDOGrp;
   EDOGrp.EWin  :="EDO_" + _EDOGrp;
   EDOGrp.KWin  :="";
   EDOGrp.Descr :="";
   IF    _EDOGrp = grp_Combining              THEN EDOGrp.Name:="饭";
   ELSIF _EDOGrp = grp_Adding                 THEN EDOGrp.Name:="稥 ";
   ELSIF _EDOGrp = grp_SingleRegimeAlteration THEN EDOGrp.Name:="  䨪 ࠡ (⭮)";
   ELSIF _EDOGrp = grp_RegimeAlteration       THEN EDOGrp.Name:=" ० ࠡ";
   ELSIF _EDOGrp = grp_Violation              THEN EDOGrp.Name:="襭 樯";
   ELSIF _EDOGrp = grp_Reward                 THEN EDOGrp.Name:="㤮 ⨦";
   ELSIF _EDOGrp = grp_ChangePersonalInfo     THEN EDOGrp.Name:=" ᮭ ";
   ELSIF _EDOGrp = grp_Probation              THEN EDOGrp.Name:="⠦஢";
   ELSIF _EDOGrp = grp_Permit                 THEN EDOGrp.Name:="";
   ELSIF _EDOGrp = grp_CancelPermit           THEN EDOGrp.Name:="⬥ ᪠";
   ELSIF _EDOGrp = grp_MCFix                  THEN EDOGrp.Name:="९";
   ELSIF _EDOGrp = grp_BusinessTrip           THEN EDOGrp.Name:="஢";
   ELSIF _EDOGrp = grp_Deduct                 THEN EDOGrp.Name:="ঠ";
   ELSIF _EDOGrp = grp_BonusFee               THEN EDOGrp.Name:="᫥ ६";
   ELSE
    L_General.CallUs(~Strong);
   END;
   INSERT(EDOGrp);
  END;
 END {InsertEDOGrp};

 PUBLIC PROCEDURE IsGroup_wPay(_EDOGrp: LIKE(EDOGrp.EDOGrp)): SCAL[2];
 BEGIN
  RETURN (_EDOGrp = grp_Violation) |
         (_EDOGrp = grp_Reward) |
         (_EDOGrp = grp_Deduct) |
         (_EDOGrp = grp_BonusFee);
 END {IsGroup_wPay};

 PUBLIC PROCEDURE IsGroup_wAllODate(trgEDOGrp: LIKE(EDOGrp.EDOGrp)): SCAL[2];
 BEGIN
  RETURN (trgEDOGrp = grp_Violation) | (trgEDOGrp = grp_Deduct) | (trgEDOGrp = grp_BonusFee);
 END {IsGroup_wAllODate};

 PUBLIC PROCEDURE HasAffectOnPayRoll(): SCAL[2];
 BEGIN
  IF (E_EDO_Level(EDOrderL.Closed) > 0) &
     (~IsGroup_wPay(EDOrderL.EDOGrp) | L_PRoll.E_ReflectEDOrder(EDOrderL.Closed)) THEN
   CONFORM(EDOrderL, EDOKind);
   RETURN (EDOKind.Rule # "稥") &
          (EDOKind.Rule # "९") &
          (EDOKind.Rule # "ᄠ");
  END;
  RETURN 0;
 END {HasAffectOnPayRoll};

 PUBLIC PROCEDURE IsRealFOrder(): SCAL[2];
 BEGIN
  RETURN FOrder.Status # fost_Canceled;
 END {IsRealFOrder};

 PUBLIC PROCEDURE InitPrepareFOrder();
 BEGIN
  L_General.Assert(ACCESS(FOrder), " ⠭ ਪ");
  L_General.Assert(~FOrder.Done, "ਪ    ࠡ⠭");
  L_General.Assert(IsRealFOrder(), "  믮  㫨஢ ਪ");
  IF SELECT(FOrderL, FOrder, FOrder.FOrder) THEN
   L_StdFrm.Choice("ਪ  . ?");
   REMSEL(FOrderL);
   FOrder.Sum:=0;
   REPLACE(FOrder);
  END;
 END {InitPrepareFOrder};

 PUBLIC PROCEDURE gbo_SetCurrentEDOrder(): SCAL[2];
  VAR
   srcFile: STRING[];
 BEGIN
  srcFile:=RTI.Get().CurZone.MasterTable.Name;
  GE_WZD_CURSOR(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number, ^srcFile);
  IF ACCESS(^srcFile) THEN
   curEDOrder:=^srcFile._EDOrder;
   curRow    :=^srcFile._Row;
   IF ~!curEDOrder THEN
    StandOnEDOrder(curEDOrder, curRow);
    SetCurrentEDOGrpByEDOrderL();
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {gbo_SetCurrentEDOrder};

 PUBLIC PROCEDURE gbo_SetSubwindow(defaultName: STRING[]);
 BEGIN
  IF L_Events.IsSubWinEvents(RTI.Get().StartMode) THEN
   IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_ShowWin THEN
    IF gbo_SetCurrentEDOrder() THEN
     defaultName:=EDOGrp.EWin;
    END;
   END;
   RTI.Get().CurZone.SubwindowOriginalName:=defaultName;
  ELSE
   L_General.CallUs(0);
  END;
 END {gbo_SetSubwindow};
 
 PUBLIC PROCEDURE StandOnEDOLCauseODoc();
 BEGIN
  L_General.Assert(SELECT(EDOLC, edcType, EDOrderL.EDOrder, EDOrderL.Row, edoct_Initial) & ~!EDOLC.XDocId,
                   " ᭮ ப " + EDOrderL.Row + " ਪ " + EDOrderL.EDOrder +
                   "| 뫪  稩 㬥");
  SEARCH(ODoc, ODoc, , EDOLC.XDocKind, EDOLC.XDoc);
 END {StandOnEDOLCauseODoc};

 PUBLIC PROCEDURE PassAccessPoint(trgAcsPnt: LIKE(AcsPnt.AcsPnt));
 BEGIN
  L_AcsPnt.fullPassAccessPoint(trgAcsPnt, "", "(ன 稩  ࠢ筨 '筨 ਪ', " + EDOSrc.EDOSrc + ")");
 END {PassAccessPoint};

 PUBLIC PROCEDURE CheckMthType(curEDOKind: LIKE(EDOKind.EDOKind); curMthType: LIKE(MoneyMth.MthType));
 BEGIN
  SAVE(EDOKind);
  IF SEARCH(EDOKind, EDOKind, curEDOKind) THEN
   IF IsGroup_wPay(EDOKind.EDOGrp) THEN
    L_General.Assert((curMthType = L_PRoll.mthtyp_SheetCalc) | (curMthType = L_PRoll.mthtyp_BonusCalc) |
                     (curMthType = L_PRoll.mthtyp_EDOrder)   | (curMthType = L_PRoll.mthtyp_EmptyCalc),
                     "  ਪ 㪠 ⮤  ⨬ ன ਬ "+FLDTOSTR(curMthType)+"."+
                     "|⨬  ਬ:|' ⠡', ' ६', 'ࠦ ਪ  ᮭ'."+
                     "| ਪ  ᮭ "+FLDTOSTR(curEDOKind));
   END;
  END;
  RESTORE(EDOKind);
 END {CheckMthType};

 PUBLIC PROCEDURE ShtDoneFromEDOrderLClosed();
  VAR
   IsMEDO     : SCAL[2];
   curAffectTo: LIKE(EDOrderL.AffectTo);
 BEGIN
  IF L_PRoll.E_ReflectEDOrder(EDOrderL.Closed) THEN
   L_General.SetConcurrentMode();
   curAffectTo:=EDOrderL.AffectTo;
   IsMEDO:=~!EDOrder.MEDOrder;
   IF IsMEDO THEN
    SAVE(EDOrderL);
    L_General.CallUs(SEARCH(EDOrderL, EDOrder, EDOrder.MEDOrder, EDOrderL.Row));
    CONFORM(EDOrderL, Staff);
   END;

   L_PRoll.ShtDone_AP(Math.Min(Math.Max(EDOrderL.Closed, L_DatTim.Per(Staff.BegDate)), curAffectTo), 0);

   IF IsMEDO THEN
    RESTORE(EDOrderL);
   END;
  END;
 END {ShtDoneFromEDOrderLClosed};

 PRIVATE PROCEDURE HasManyLabourContractInMonth(P: DATE): SCAL[2];
  VAR
   LastBegDateInPeriod,
   LastEndDateInPeriod: DATE;
   Result             : SCAL[2];
 BEGIN
  SAVE(StaffLog);
  LastBegDateInPeriod:=L_Man.GetTakeOnDate(L_DatTim.MonthEnd(P));
  IF L_DatTim.Per(LastBegDateInPeriod) < P THEN
   Result:=0;
  ELSE
   LastEndDateInPeriod:=L_Man.GetRealEndDate(LastBegDateInPeriod-1);
   Result:=~!LastEndDateInPeriod & (L_DatTim.Per(LastEndDateInPeriod) = P) & (LastEndDateInPeriod < LastBegDateInPeriod);
  END;
  RESTORE(StaffLog);
  RETURN Result;
 END {HasManyLabourContractInMonth};

 PUBLIC PROCEDURE AllODateAllowed(): SCAL[2];
 BEGIN
  CONFORM(FOrderL, FOrder);
  IF FOrder.Type # L_PRoll.fot_ByPrc THEN
   RETURN 0;
  ELSIF ~!FOrderL.TSN THEN
   CONFORM(FOrderL, Staff);
   RETURN ~HasManyLabourContractInMonth(FOrderL._Closed);
  ELSE
   RETURN 1;
  END;
 END {AllODateAllowed};

 PUBLIC PROCEDURE CheckAllODate();
 BEGIN
  L_General.Assert(~FOrderL.AllODate | (FOrder.Type = L_PRoll.fot_ByPrc),
                   " ਪ  / ' /'  ⠭ ⮫쪮  ਪ 業⮬.|ਪ "+FOrderName());
  L_General.Assert(~FOrderL.AllODate | ~HasManyLabourContractInMonth(FOrderL._Closed),
                   " ਪ  / ' /'  ⠭ ⮫쪮  ᫮"+
                   "|⢥ 㤮    ਪ.|ਪ "+FOrderName());
 END {CheckAllODate};

 PUBLIC PROCEDURE EDO_AllODateAllowed(): SCAL[2];
 BEGIN
  IF IsGroup_wAllODate(EDOrderL.EDOGrp) THEN
   IF ~!EDOrderL.TSN THEN
    CONFORM(EDOrderL, Staff);
    RETURN (EDOrderL.BySum = 0) & ~HasManyLabourContractInMonth(EDOrderL.Closed);
   ELSE
    RETURN (EDOrderL.BySum = 0);
   END;
  ELSE
   RETURN 0;
  END;
 END {EDO_AllODateAllowed};

 PUBLIC PROCEDURE EDO_CheckAllODate();
 BEGIN
  L_General.Assert(~EDOrderL.AllODate | (EDOrderL.BySum = 0),
                   " ਪ  ᮭ ' /'  ⠭ ⮫쪮  ਪ 業⮬.|ਪ "+EDOrderName());
  L_General.Assert(~EDOrderL.AllODate | ~HasManyLabourContractInMonth(EDOrderL.Closed),
                   " ਪ  ᮭ ' /'  ⠭ ⮫쪮  ᫮"+
                   "|⢥ 㤮    ਪ.|ਪ "+EDOrderName());
 END {EDO_CheckAllODate};

 PUBLIC PROCEDURE AppendFOrderL(trgTim: NUMERIC[3]; trgValue: NUMERIC[2]);
 BEGIN
  FOrderL.FOrder :=FOrder.FOrder;
  FOrderL.TSN    :=StaffLog.TSN;
  FOrderL.Tim    :=trgTim;
  FOrderL.Value  :=trgValue;
  FOrderL.ODate  :=StaffLog.Date;
  FOrderL.AllODate:=0;
  FOrderL._Closed:=FOrder.Closed;
  FOrderL.EDOSrc :=FOrder.EDOSrc;
  INSERT(FOrderL);
  IF FOrder.Type = L_PRoll.fot_BySum THEN
   INC(FOrder.Sum, FOrderL.Value);
   REPLACE(FOrder);
  END;
 END {AppendFOrderL};

(*-------------BEGIN OF NORMAL ENVIRONMENT--------------------------*)

 PRIVATE PROCEDURE E_EDG10FixInPool(): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(SYSDATE(), PROCREF(E_Staff.EDG10FixInPool),
                                "|砭|룮|ண 룮");
 END {E_EDG10FixInPool};

 PUBLIC PROCEDURE E_UseDefaultEDOrderTemplate(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Staff.UseDefaultEDOrderTemplate), 1);
 END {E_UseDefaultEDOrderTemplate};

 PUBLIC PROCEDURE E_EDO_Level(D: DATE): SCAL[5];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Staff.EDO_Level), 0); (* ⮢ ਪ*)
 END {E_EDO_Level};

BEGIN
 SETEMPTY(sra_TSN, sra_Per);
END.
