(*
%Copyright   (c) Polak Computer System
%Author      12.11.2001 13:32:20 MOG
%Purpose     ⥪ 뫪 㬥⮢  e-mail
%Type        library
%Specific    SYS
%Modified    05.02.2014 18:00:54 POLAK\LDA
%Environment
*)

 MODULE L_EMail [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tContact = STRING[];

 IMPORT FIO, L_General, L_StdFrm, L_Str, Str, Math;

 PRIVATE PROCEDURE CheckForIllegalChars(    CheckedStr : STRING[];
                                            IllegalChar: NUMERIC[0][];
                                        VAR Clm        : NUMERIC[0];
                                        VAR Char       : STRING[]): SCAL[2];
  VAR
   i, Length: NUMERIC[0];
 BEGIN
  IF ~!CheckedStr THEN
   Length:=Str.Length(CheckedStr);
   i:=0;
   WHILE (i <= HIGH(IllegalChar)) & ~!IllegalChar[i] DO
    Char:=CHR(IllegalChar[i]);
    Clm :=Str.Pos(CheckedStr, Char);
    IF Clm # Length THEN
     RETURN 1;
    END;
    INC(i);
   END; (* WHILE ~!IllegalSymbol[i]...*)
  END;
  SETEMPTY(Char);
  RETURN 0;
 END {CheckForIllegalChars};

 PRIVATE PROCEDURE InitIllegalChars(VAR IllegalChar: NUMERIC[0][]);
 BEGIN
  IllegalChar[0] :=15;  (* ' ' *)
  IllegalChar[1] :=20;  (* ' ' *)
  IllegalChar[2] :=21;  (* ' ' *)
  IllegalChar[3] :=176; (* '' *)
  IllegalChar[4] :=177; (* '' *)
  IllegalChar[5] :=178; (* '' *)
  IllegalChar[6] :=179; (* '' *)
  IllegalChar[7] :=180; (* '' *)
  IllegalChar[8] :=181; (* '' *)
  IllegalChar[9] :=182; (* '' *)
  IllegalChar[10]:=183; (* '' *)
  IllegalChar[11]:=184; (* '' *)
  IllegalChar[12]:=185; (* '' *)
  IllegalChar[13]:=186; (* '' *)
  IllegalChar[14]:=187; (* '' *)
  IllegalChar[15]:=188; (* '' *)
  IllegalChar[16]:=189; (* '' *)
  IllegalChar[17]:=190; (* '' *)
  IllegalChar[18]:=191; (* '' *)
  IllegalChar[19]:=192; (* '' *)
  IllegalChar[20]:=193; (* '' *)
  IllegalChar[21]:=194; (* '' *)
  IllegalChar[22]:=195; (* '' *)
  IllegalChar[23]:=196; (* '' *)
  IllegalChar[24]:=197; (* '' *)
  IllegalChar[25]:=198; (* '' *)
  IllegalChar[26]:=199; (* '' *)
  IllegalChar[27]:=200; (* '' *)
  IllegalChar[28]:=201; (* '' *)
  IllegalChar[29]:=202; (* '' *)
  IllegalChar[30]:=203; (* '' *)
  IllegalChar[31]:=204; (* '' *)
  IllegalChar[32]:=205; (* '' *)
  IllegalChar[33]:=206; (* '' *)
  IllegalChar[34]:=207; (* '' *)
  IllegalChar[35]:=208; (* '' *)
  IllegalChar[36]:=209; (* '' *)
  IllegalChar[37]:=210; (* '' *)
  IllegalChar[38]:=211; (* '' *)
  IllegalChar[39]:=212; (* '' *)
  IllegalChar[40]:=213; (* '' *)
  IllegalChar[41]:=214; (* '' *)
  IllegalChar[42]:=215; (* '' *)
  IllegalChar[43]:=216; (* '' *)
  IllegalChar[44]:=217; (* '' *)
  IllegalChar[45]:=218; (* '' *)
  IllegalChar[46]:=219; (* '' *)
  IllegalChar[47]:=220; (* '' *)
  IllegalChar[48]:=221; (* '' *)
  IllegalChar[49]:=222; (* '' *)
  IllegalChar[50]:=223; (* '' *)
  IllegalChar[51]:=242; (* '' *)
  IllegalChar[52]:=243; (* '' *)
  IllegalChar[53]:=244; (* '' *)
  IllegalChar[54]:=245; (* '' *)
  IllegalChar[55]:=246; (* '' *)
  IllegalChar[56]:=247; (* '' *)
  IllegalChar[57]:=249; (* '' *)
  IllegalChar[58]:=251; (* '' *)
  IllegalChar[59]:=252; (* '' *)
  IllegalChar[60]:=253; (* '' *)
  IllegalChar[61]:=254; (* '' *)
 END {InitIllegalChars};

 PRIVATE PROCEDURE extIllegalCharsExist(    CheckedStr     : STRING[];
                                            AddIllegalChars: STRING[];
                                        VAR Clm            : NUMERIC[0];
                                        VAR Char           : STRING[]): SCAL[2];
  VAR
   i, j        : NUMERIC[0];
   IllegalChars: NUMERIC[0][100];
 BEGIN
  SETEMPTY(IllegalChars, Char);
  InitIllegalChars(IllegalChars);
  i:=0;
  WHILE ~!IllegalChars[i] DO
   INC(i);
  END; (* WHILE ~!IllegalChars[i] ...*)

  j:=0;
  LOOP
   IF !L_Str.Char(AddIllegalChars, j) THEN
    EXIT;
   END;
   IllegalChars[i]:=ORD(L_Str.Char(AddIllegalChars, j));
   INC(i);
   INC(j);
  END;

  RETURN CheckForIllegalChars(CheckedStr, IllegalChars, Clm, Char);
 END {extIllegalCharsExist};

 PRIVATE PROCEDURE ReplaceToOctetStr(VAR s: STRING[]; c: STRING[]);
  VAR
   p: STRING[];
 BEGIN
  p:="%"+FLDTOSTR(ORD(c), "H00", 2);
  s:=Str.Replace(s, c, p);
 END {ReplaceToOctetStr};

 PUBLIC PROCEDURE EncodeStrForMailToURL(s: STRING[]): STRING[];
 BEGIN
  ReplaceToOctetStr(s, "%");
  ReplaceToOctetStr(s, "/");
  ReplaceToOctetStr(s, "?");
  ReplaceToOctetStr(s, ":");
  ReplaceToOctetStr(s, "@");
  ReplaceToOctetStr(s, "=");
  ReplaceToOctetStr(s, "&");
  RETURN s;
 END {EncodeStrForMailToURL};

 PUBLIC PROCEDURE AssembleContact(Name, Addr: STRING[]): tContact;
  VAR
   Char   : STRING[];
   Dummy  : NUMERIC[0];
   Contact: tContact;
 BEGIN
  IF ~!Name & !Addr THEN
   L_General.Error(" ஭  .  ⠪:" + "||" + '"' + Name + '"');
  END;
  Contact:=L_Str.ExclQM(Name) + " <" + Addr + ">";

  IF extIllegalCharsExist(Contact, ",;", Dummy, Char) THEN
   L_General.Error(" e-mail  '" + Contact + "'|" +
                   "㦥 饭 ᨬ '" + Char + "'");
  END;
  RETURN Contact;
 END {AssembleContact};

 PUBLIC PROCEDURE EmptyContact(): tContact;
 BEGIN
  RETURN AssembleContact("", "");
 END {EmptyContact};

 PUBLIC PROCEDURE AssembleContactFromParts(Name, AddrInDomain, Domain: STRING[]): tContact;
 BEGIN
  RETURN AssembleContact(Name, AddrInDomain + "@" + Domain);
 END {AssembleContactFromParts};

 PUBLIC PROCEDURE cp_Name(Contact: tContact): STRING[];
 BEGIN
  RETURN Str.Condense(Str.Item(Contact, "<>", 0));
 END {cp_Name};

 PUBLIC PROCEDURE cp_EmailAdr(Contact: tContact): STRING[];
 BEGIN
  RETURN Str.Condense(Str.Item(Contact, "<>", 1));
 END {cp_EmailAdr};

 PUBLIC PROCEDURE IsEmptyContact(Contact: tContact): SCAL[2];
 BEGIN
  RETURN !Contact | (!cp_Name(Contact) & !cp_EmailAdr(Contact));
 END {IsEmptyContact};

 PUBLIC PROCEDURE GetEmail(Contact: tContact): STRING[];
  VAR
   AdrValue: STRING[];
 BEGIN
  IF ~IsEmptyContact(Contact) THEN
   AdrValue:=cp_EmailAdr(Contact);
   L_General.Assert(~!AdrValue,
                    " 㪠  ஭ ."+
                    "|"+
                    "⠪ " + Contact);
   RETURN cp_Name(Contact) + " <" + AdrValue + ">";
  ELSE
   RETURN "";
  END;
 END {GetEmail};

 PUBLIC PROCEDURE LaunchWGet(Params: STRING[]; AllowError: SCAL[2]): NUMERIC[0];
  VAR
   AllowedRCs: NUMERIC[0][2];
   ReturnCode: NUMERIC[0];
 BEGIN
  AllowedRCs[0]:=L_General.eprc_Normal;
  AllowedRCs[1]:=1 (* 㤠筮 襭 *);
  ReturnCode:=L_General.LaunchEP(L_General.ept_Standart,
                                 "WGet.exe",
                                 Params,
                                 L_General.ws_Minimized,
                                 AllowedRCs);
  L_General.Assert(AllowError | (ReturnCode = L_General.eprc_Normal),
                   " 㤠    ୥." +
                   "||:  ," +
                   "|᫨ 訡  ॣ୮,   ");
  RETURN ReturnCode;
 END {LaunchWGet};

 PUBLIC PROCEDURE AddAttachments(VAR EMailMessage: EMAIL_MESSAGE; FileList: STRING[]);
  VAR
   FileName : STRING[];
   i        : NUMERIC[0];
 BEGIN
  FileName:=L_Str.PoolItem(FileList, 0);
  i:=0;
  WHILE ~!FileName DO
   L_General.CallUs(FIO.Exists(FileName));
   EMailMessage.Parts.AddAttachment(FileName);
   INC(i);
   FileName:=L_Str.PoolItem(FileList, i);
  END;
 END {AddAttachments};

 PRIVATE PROCEDURE AddHeaders(VAR EMailMessage: EMAIL_MESSAGE; header: STRING[]; Contact: tContact[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE (i <= HIGH(Contact)) & ~IsEmptyContact(Contact[i]) DO
   EMailMessage.Headers.Add(header, GetEmail(Contact[i]));
   INC(i);
  END;
 END {AddHeaders};

 PRIVATE PROCEDURE SetContactHeader(VAR EMailMessage: EMAIL_MESSAGE; header: STRING[]; Contact: tContact);
 BEGIN
  IF ~IsEmptyContact(Contact) THEN
   EMailMessage.Headers.Set(header, GetEmail(Contact));
  END;
 END {SetContactHeader};

 PRIVATE PROCEDURE ShowLastErrorLog(Title: STRING[]; SmtpClient: SMTP_CLIENT);
  VAR
   i,
   j,
   cnt,
   Width,
   Depth,
   LineLength,
   LineAmount: NUMERIC[0];
   Err       : STRING[];
   Log       : SMTP_COMMAND_LOG;
 BEGIN
  GE_APPWIN_SIZE(Width, Depth);
  LineLength:=Width - 9;
  LineAmount:=Depth - 6 - 1;

  Log:=SmtpClient.LastCommandLog;
  IF Log.ErrorCategory = SMTP_COMMAND_LOG.ErrorCategory_Other THEN
   Err:="";
   i:=Math.Max(0, Log.Count - 2);
   cnt:=0;
   WHILE (i < Log.Count) & (cnt < LineAmount) DO
    Err:=L_Str.AddStrDlm(Err, "|") + ">> " + Str.Align(Log(i).CommandInfo, LineLength, LEFT);
    INC(cnt);
    j:=0;
    WHILE (j < Log(i).Reply.Count) & (cnt < LineAmount) DO
     Err:=L_Str.AddStrDlm(Err, "|") + "<< " + Str.Align(L_Str.FixedIntStr(Log(i).Reply(j).Code, 3) + " " + Log(i).Reply(j).Info, LineLength, LEFT);
     INC(cnt);
     INC(j);
    END;
    INC(i);
   END;

   IF cnt = Depth THEN
    Title:=Title + " ( " + L_Str.IntStr(LineAmount) + " ப() ୠ 訡)";
   END;
   L_General.Error(Title + "|" + Err +
                   L_StdFrm.HR() +
                   "室 㡥  ࠡᯮᮡ|" +
                   "⮢ ࢥ " + SmtpClient.RemoteHostAndPort + ".||" +
                   "᫨ 訡 㤥 ,   ");
  ELSE
   L_General.CallUs(0);
  END;
 END {ShowLastErrorLog};

 PUBLIC CONST
  ed_AuthenticationCredentialsInvalid = "஡ ⥭䨪樨: ୮  짮⥫ / ஫";

 PUBLIC PROCEDURE sc_Connect(SMTPServer          : STRING[];
                             SMTPSchannelProtocol: NUMERIC[0];
                             SMTPLogin,
                             SMTPEncryptedPass   : STRING[];
                             wAuthentication     : SCAL[2]): SMTP_CLIENT;
  VAR
   SmtpClient: SMTP_CLIENT;
 BEGIN
  SmtpClient:=SMTP_CLIENT.Create();

  IF wAuthentication THEN
   SmtpClient.UserName          :=SMTPLogin;
   SmtpClient.PasswordEncryption:=CSECR_PKCU;
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    SmtpClient.Password         :=SMTPEncryptedPass;
   EXCEPT
   ON Exc: Exc_Root DO
    IF (Exc.ErrorCode = L_General.ec_rt_IncorrectlyEncodedString) |
       (Exc.ErrorCode = L_General.ec_rt_CantDecodeString) THEN
     L_General.Error(" 㤠 ஢ ࠭  ⮏ ஫." +
                     "|" + L_StdFrm.THR(" 稭") +
                     "    믮 ன ⭮  ஭ ");
    ELSE
     RAISE();
    END;
   END; (* TRY *)
   SmtpClient.SchannelProtocol  :=SMTPSchannelProtocol;
  END;
  SmtpClient.RemoteHostAndPort:=SMTPServer;
  SmtpClient.ConnectAndAuthenticate();

  IF    SmtpClient.LastCommandLog.ErrorCategory = SMTP_COMMAND_LOG.ErrorCategory_AuthenticationCredentialsInvalid THEN
   L_General.Error(ed_AuthenticationCredentialsInvalid);
  ELSIF SmtpClient.LastCommandLog.ErrorCategory = SMTP_COMMAND_LOG.ErrorCategory_Other THEN
   ShowLastErrorLog("㤠筮 祭  SMTP-ࢥ", SmtpClient));
  END;
  RETURN SmtpClient;
 END {sc_Connect};

 PUBLIC PROCEDURE sc_Send(SmtpClient    : SMTP_CLIENT;
                          ToContact,
                          FrContact,
                          SnContact,
                          CcContact,
                          BCcContact,
                          ReplyToContact: tContact[];
                          Subject,
                          Attachments,
                          Message       : STRING[]);
  VAR
   Dummy       : SCAL[2];
   EMailMessage: EMAIL_MESSAGE;
 BEGIN
  L_General.CallUs(~!SmtpClient & SmtpClient.Connected);

  EMailMessage:=EMAIL_MESSAGE.Create();

  IF L_General.TestExecution_IsRunning() THEN
   AddHeaders      (EMailMessage, EMAIL_HEADERS.Header_To,      AssembleContact("㤠", "null@polak.ru"));
   SetContactHeader(EMailMessage, EMAIL_HEADERS.Header_From,    AssembleContact("㤠", "null@polak.ru"));
  ELSE
   AddHeaders      (EMailMessage, EMAIL_HEADERS.Header_To,      ToContact);
   SetContactHeader(EMailMessage, EMAIL_HEADERS.Header_From,    FrContact);
   SetContactHeader(EMailMessage, EMAIL_HEADERS.Header_XSender, SnContact);
   SetContactHeader(EMailMessage, EMAIL_HEADERS.Header_Cc,      CcContact);
   SetContactHeader(EMailMessage, EMAIL_HEADERS.Header_Bcc,     BCcContact);
   AddHeaders      (EMailMessage, EMAIL_HEADERS.Header_ReplyTo, ReplyToContact);
  END;
  EMailMessage.Headers.Set(EMAIL_HEADERS.Header_Subject, Subject);
  AddAttachments(EMailMessage, Attachments);
  EMailMessage.Parts.Text:=Message;

  Dummy:=SmtpClient.Send(EMailMessage);

  IF SmtpClient.LastCommandLog.ErrorCategory # SMTP_COMMAND_LOG.ErrorCategory_NoError THEN
   ShowLastErrorLog("㤠 ࠢ  ஭ ", SmtpClient);
  END;
 END {sc_Send};

 PUBLIC PROCEDURE sc_Quit(SmtpClient: SMTP_CLIENT);
 BEGIN
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   SmtpClient.Quit();
  EXCEPT
  ON Exc: Exc_Root DO
  END;
 END {sc_Quit};

 PUBLIC PROCEDURE Send(ToContact        : tContact[];
                       FrContact,
                       SnContact,
                       CcContact,
                       BCcContact       : tContact;
                       ReplyToContact   : tContact[];
                       Subject,
                       Attachments,
                       Message,
                       SMTPServer,
                       SMTPLogin,
                       SMTPEncryptedPass: STRING[];
                       IsDedicatedLine,
                       wAuthentication,
                       UseProtectedChnl : SCAL[2]);
  VAR
   oPrompt   : PROMPTLINE;
   SmtpClient: SMTP_CLIENT;
 BEGIN
  oPrompt:=PROMPTLINE.Create("ࠢ  ஭ ");

  SmtpClient:=sc_Connect(SMTPServer, SMTP_CLIENT.SchannelProtocol_Auto, SMTPLogin, SMTPEncryptedPass, wAuthentication);

  sc_Send(SmtpClient, ToContact,
                      FrContact,
                      SnContact,
                      CcContact,
                      BCcContact,
                      ReplyToContact,
                      Subject,
                      Attachments,
                      Message);

  sc_Quit(SmtpClient);
 END {Send};

END.
