(*
%Copyright   (c) Polak IT
%Author      17.12.2002 11:36:19 POLAK\SAN
%Purpose     ᯮ 
%Type        library
%Specific    SYS
%Modified    04.07.2014 14:58:48 POLAK\LDA
%Environment
*)

 MODULE L_Exp [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tExistanceCheckType = SCAL[3];

 PUBLIC CONST
  ect_StrongInsert           = 0;
  ect_ReplaceExistent        = 1;
  ect_ReplaceOnlyEqualRecord = 2;

 IMPORT DBD, FIO, Str, L_General, L_Str, L_DatTim, L_PCS, L_StdFrm, L_DBD;

 PRIVATE PERMANENT VAR
  StreamMode: SCAL[2];
  RecordNbr : NUMERIC[0];
  FileName  : STRING[];

(*
$P {Stamp:
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
LOGINNAME(), L, ""
SYSDATE(), L, "D.N.y"
L_DatTim.FullSystimeStr(), L, ""
USERDOMAIN() + "\" + LOGINNAME(), L, ""
?, L, ""
@
(*
%Copyright   (c) Polak IT
%Author      ########## ##### ##############################################
%Purpose     ᯮ ᥩ 䠩
%Type        operation
%Specific    TOOLS
%Modified    ########## ######## ##############################################
%Environment
*)

 PRIVATE VAR
  Exists: SCAL[2];
  ErrMsg : STRING[];

BEGIN
 ##################################
}
*)

 PRIVATE PROCEDURE WrStr(S: STRING[]);
 BEGIN
  FIO.WrStr(R, S);
 END {WrStr};

 PRIVATE PROCEDURE Wr(S: STRING[]);
 BEGIN
  WrStr(S);
  FIO.WrLn(R);
 END {Wr};

 PRIVATE PROCEDURE WrLn();
 BEGIN
  FIO.WrLn(R);
 END {WrLn};

 PRIVATE PROCEDURE GetTmpFileName(): STRING[];
 BEGIN
  RETURN L_FIO.tf_GetFullPath(FileName, "");
 END {GetTmpFileName};

 PUBLIC PROCEDURE OpenToAppend();
  VAR
   tmpFileName: STRING[];
 BEGIN
  L_General.Assert(~!FileName, " 믮 楤 ᮧ  ASL");
  tmpFileName:=GetTmpFileName();
  L_General.Assert(FIO.Exists(tmpFileName), " " + tmpFileName + "  ᮧ");
  FIO.Open(R, tmpFileName, , Append);
 END {OpenToAppend};

 PUBLIC PROCEDURE CreateNew(trgFileName, Text: STRING[]; trgStreamMode: SCAL[2]);
 BEGIN
  FileName  :=trgFileName;
  StreamMode:=trgStreamMode;
  SETZERO(RecordNbr);

  OPENREP(R, GetTmpFileName(), Create, NoTune);
  MAKEPART(R, Stamp, Text);
  CLOSEREP(R);
  IF StreamMode THEN
   OpenToAppend();
  END;
 END {CreateNew};

 PUBLIC PROCEDURE acl_CreateNew();
  VAR
   Task    : SCAL[1E7];
   acl_Name: STRING[];
 BEGIN
  SETEMPTY(Task);
  IF STDFORM(L_StdFrm.sf_Choice("ACL_%#######%", "%I"), "   ", , , Task) THEN
   acl_Name:="ACL_"+Task +".ASL";
   IF FIO.Exists(acl_Name) THEN
    L_StdFrm.Choice("'"+acl_Name+"' 㦥 !!!|| ࠢ ᮧ ?");
   ELSE
    L_StdFrm.Question(" '"+acl_Name+"' ?");
   END;
   CreateNew(acl_Name, 'L_ACL.Inform(" ", "");', 0);
  END;
 END {acl_CreateNew};

 PRIVATE PROCEDURE GetAcsObjName(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(AcsObj);
  SEARCH(AcsObj, AcsObj, , L_General.curUSER);
  IF L_Str.IsStrInStr(AcsObj.Name, ".") THEN
   Result:=Str.Slice(AcsObj.Name, 0, Str.Pos(AcsObj.Name, "."));
  ELSE
   Result:=AcsObj.Name;
  END;
  RESTORE(AcsObj);
  RETURN Result;
 END {GetAcsObjName};

 PUBLIC PROCEDURE tool_CreateNew();
  VAR
   tmpFileName: STRING[];
 BEGIN
  tmpFileName:="_" + GetAcsObjName() + "_" + L_DatTim.SysDateTimeStamp() + ".asl";
  L_StdFrm.Question("  '"+tmpFileName + "' ?");
  CreateNew(tmpFileName, "", 0);
 END {tool_CreateNew};

 PUBLIC PROCEDURE Close();
 BEGIN
  FIO.Close(R);
  HALT(1);
 END {Close};

 PUBLIC PROCEDURE Term();
  VAR
   tmpFileName: STRING[];
 BEGIN
  L_General.Assert(L_General.VariableIsInitialized(FileName) & ~!FileName, " ࠭  ஢");
  tmpFileName:=GetTmpFileName();
  L_General.Assert(FIO.Exists(tmpFileName), " " + tmpFileName + "  ᮧ");
  IF ~StreamMode THEN
   L_StdFrm.Question(" '" + FileName + "'?");
   FIO.Open(R, tmpFileName, "", Append);
  END;
  Wr('');
  Wr('END.');
  FIO.Close(R);

  FIO.RenMov(tmpFileName, , FIO.FirstPath(L_FIO.effp_FileName(tmpFileName)));
  SETEMPTY(FileName);
 END {Term};

 PRIVATE PROCEDURE WrData(File, Field: STRING[]; _Idx: STRING[]): STRING[];
  VAR
   FulField: STRING[];
   _quot,
   _S,
   _Str    : STRING[];
   i       : NUMERIC[0];
 BEGIN
  FulField:=File+"."+Field+_Idx;
  IF    TYPEOF(^File.^Field) = L_General.ft_STRING THEN
   _Str:=FLDTOSTR(^FulField, "", 0);
   IF    Str.Pos(_Str, "'") = Str.Length(_Str) THEN
    _quot:="'";
   ELSIF Str.Pos(_Str, '"') = Str.Length(_Str) THEN
    _quot:='"';
   ELSE
    L_General.Error(FulField+" -  ᨬ '  "+'"'+"|஢  ࠢ '"+FileName+"'");
   END;
   IF Str.Pos(_Str, L_Str.CRLF) # Str.Length(_Str) THEN
    i:=0; _S:=_Str; SETEMPTY(_Str);
    WHILE ~!Str.Item(_S, L_Str.CRLF, i) DO
     IF ~!_Str THEN
      _Str:=_Str+_quot+"+L_Str.CRLF"+"+"+_quot;
     END;
     _Str:=_Str+Str.Item(_S, L_Str.CRLF, i);
     INC(i);
    END;
   END;
   RETURN _quot+_Str+_quot;
  ELSIF TYPEOF(^File.^Field) = L_General.ft_DATE THEN
   RETURN FLDTOSTR(^FulField, "D\N\y");
  ELSE
   RETURN Str.Condense(FLDTOSTR(^FulField));
  END;
 END {WrData};

 PRIVATE PROCEDURE AddKeyValue(File, _Key: STRING[]; VAR S: STRING[]);
  CONST
   Dlm = ", ";
  VAR
   n      : NUMERIC[0];
   Field : STRING[];
 BEGIN
  n:=0;
  S:="";
  REPEAT
   Field:=DBD.IndexFieldName(^File, ^_Key, n);
   S:=S + Dlm + WrData(File, Field, " ");
   INC(n);
  UNTIL n = DBD.IndexFieldAmount(^File, ^_Key);
 END {AddKeyValue};

 PRIVATE PROCEDURE GetUniqueKey(File: STRING[]): STRING[];
  VAR
   i, a: NUMERIC[0];
   Key : STRING[];
 BEGIN
  a:=DBD.IndexAmount(^File);
  i:=0;
  WHILE i<a DO
   Key:=DBD.IndexName(^File, i);
   IF DBD.IndexUnique(^File, ^Key) THEN
    RETURN DBD.IndexName(^File, i);
   END;
   INC(i);
  END;
  RETURN "";
 END {GetUniqueKey};

 PRIVATE PROCEDURE GetFullFileName(File: STRING[]): STRING[];
 BEGIN
  RETURN "'" + File + " " + DBD.FileDescription(^File) + "'";
 END {GetFullFileName};

 PRIVATE PROCEDURE IsIdentityCheckRequired(File: STRING[]): SCAL[2];
  VAR
   n             : NUMERIC[0];
   Field,
   FulField      : STRING[];
   wIdentityCheck: SCAL[2];
 BEGIN
  wIdentityCheck:=1;
  n             :=0;
  LOOP
   Field:=DBD.FieldName(^File, n);
   IF !Field THEN
    EXIT;
   END;
   FulField:=File+"."+Field;
   IF Field = "Firm" THEN
    wIdentityCheck:=^(FulField) # 0000;
   END;
   INC(n);
  END; (* LOOP *)
  RETURN wIdentityCheck;
 END {IsIdentityCheckRequired};

 PUBLIC PROCEDURE PutOneRecord(File             : STRING[];
                               Silent            : SCAL[2];
                               ExistanceCheckType: tExistanceCheckType);
  VAR
   FulField,
   KeyValue,
   S        : STRING[];
   k, n     : NUMERIC[0];
   _Rng     : NUMERIC[0];
   Idx,
   Line     : STRING[];
   _Key,
   Field   : STRING[];
 BEGIN
  IF ~Silent THEN
   L_StdFrm.Question("ᯮ஢  "+File+"|  '"+FileName + "' ?");
  END;
  WrLn();
  _Key:=GetUniqueKey(File);
  IF !_Key THEN
   _Key:=DBD.IndexName(^File, 0);
   L_General.Assert((ExistanceCheckType = ect_StrongInsert) |
                    (ExistanceCheckType = ect_ReplaceOnlyEqualRecord),
                    "ᯮ ᥩ 䠩  㭨쭮  ⮫쪮  ० ⠢");
   AddKeyValue(File, _Key, KeyValue);
   Wr(' Exists:=0;');
  ELSE
   AddKeyValue(File, _Key, KeyValue);
   Wr(' Exists:=SEARCH('+File+', '+_Key+KeyValue+');');
  END;

  IF (ExistanceCheckType = ect_ReplaceOnlyEqualRecord) & ~IsIdentityCheckRequired(File) THEN
(*
   Wr(' IF ~Exists THEN');
   Wr('  STDMSG(" 䠩 '+GetFullFileName(File)+
                '|  ᯮ㥬  (஢ઠ ᮢ ⪫祭)'+
                '|祭  '+KeyValue+'", STOP);');
   Wr(' END;');
*)
  ELSE
   Wr(' SETEMPTY(ErrMsg);');
   Wr(' PROMPT("ࠡ⪠ ' + L_Str.IntStr(RecordNbr) + '");');

   n:=0;
   Field:=DBD.FieldName(^File, n);
   WHILE ~!Field DO
    IF Field # "RECORDID" THEN
     PROMPT("ᯮ  䠩 " + File + " " + FLDTOSTR(n, "", 0));
     FulField:=File+"."+Field;
     _Rng:=RANGEOF(^File.^Field);
     k:=0;
     WHILE k < _Rng DO
      IF _Rng > 1 THEN
       Idx:="["+FLDTOSTR(k, "", 0)+"]";
       S:=FulField+Idx;
      ELSE
       Idx:=" ";
       S:=FulField;
      END;
      IF ExistanceCheckType = ect_ReplaceOnlyEqualRecord THEN
       WrStr(' IF Exists & ');
       IF !^S THEN
        WrStr('(~!' + S + ')');
       ELSE
        WrStr('(' + S + ' # ' + WrData(File, Field, Idx) + ')');
       END;
       WrStr(' THEN');
       WrLn();
       Wr('  ErrMsg:=ErrMsg + "' + S + ': 祭   ' +
          L_Str.ExclQM(WrData(File, Field, Idx)) + '|饥 祭: "+FLDTOSTR(' + S + ')+"|";');
       Wr(' END;');
      END;
  
      IF !^S THEN
       Wr(' SETEMPTY('+S+');');
      ELSE
       Wr(' '+S+':='+WrData(File, Field, Idx)+';');
      END;
      INC(k);
     END;
    END; (* IF Field # RECORDID ... *)
    INC(n);
    Field:= DBD.FieldName(^File, n);
   END; (* WHILE ~!Field... *)
   Wr(' IF Exists THEN ');
   IF    ExistanceCheckType = ect_StrongInsert THEN
    Wr('  STDMSG("    䠩 '+GetFullFileName(File)+
                 '|祭  '+KeyValue+'", STOP);');
   ELSIF (ExistanceCheckType = ect_ReplaceExistent) |
         (ExistanceCheckType = ect_ReplaceOnlyEqualRecord) THEN
    IF ExistanceCheckType = ect_ReplaceOnlyEqualRecord THEN
     Wr('  IF ~!ErrMsg THEN');
     Wr('   STDMSG("    䠩 '+GetFullFileName(File)+
                   ',|   ⫨  ᯮ㥬|" + ErrMsg + '+
 
                   '"|祭  '+KeyValue+'", STOP);');
     Wr('  END;');
    END;
    Wr('  REPLACE('+File+');');
   END;
   Wr(' ELSE');
   Wr('  INSERT('+File+');');
   Wr(' END;');
  END;
  INC(RecordNbr);
 END {PutOneRecord};

 PRIVATE PROCEDURE AcceptableFileForExport(File: STRING[]): SCAL[2];
 BEGIN
  RETURN ~L_Str.IsEqStrI(File, "XCalc")    &
         ~L_Str.IsEqStrI(File, "XApport")  &
         ~L_Str.IsEqStrI(File, "Sheet")    &
         ~L_Str.IsEqStrI(File, "PCalc")    &
         ~L_Str.IsEqStrI(File, "Money")    &
         ~L_Str.IsEqStrI(File, "DedAcnt")  &
         ~L_Str.IsEqStrI(File, "MathMty")  &
         ~L_Str.IsEqStrI(File, "Monthly")  &
         ~L_Str.IsEqStrI(File, "TaxInq");
 END {AcceptableFileForExport};

 PRIVATE PROCEDURE intPutFamily(wGuide            : SCAL[2];
                                File              : STRING[];
                                Silent            : SCAL[2];
                                ExistanceCheckType: tExistanceCheckType);
  VAR
   i,
   a,
   LinkKind   : NUMERIC[0];
   Coo,
   LinkName,
   MirrorName,
   KeyValue   : STRING[];
 BEGIN
  IF ~Silent THEN
   L_StdFrm.Question("ᯮ஢  "+File+"|  " + L_Str.PoolItem("|  ", wGuide) + "  '"+FileName+ "' ?");
  END;

  IF ~L_DBD.lr_Label(File) & AcceptableFileForExport(File) THEN
   L_DBD.lr_Remember(File);
   PutOneRecord(File, 1, ExistanceCheckType);

   IF ~!PROCREF(L_PCS.GetMirrorEntity) THEN
    MirrorName:=L_PCS.GetMirrorEntity(File);
   ELSE
    SETEMPTY(MirrorName);
   END;
   IF ~!MirrorName THEN
     AddKeyValue(File, GetUniqueKey(File), KeyValue);
     SEARCH(^(MirrorName + " , " + GetUniqueKey(MirrorName) +  " , " + KeyValue));
     intPutFamily(wGuide, MirrorName, 1, ExistanceCheckType);
   END;

   i:=0;
   a:=DBD.LinkAmount(^File);
   WHILE i < a DO
    LinkName:=DBD.LinkName(^File, i);
    LinkKind:=DBD.LinkKind(^File, ^LinkName);

    IF ((LinkKind = L_General.lk_USER) & wGuide) |
       ((LinkKind = L_General.lk_LEND) | (LinkKind = L_General.lk_REVERSE_HISTORY)) THEN
     Coo:=DBD.LinkCooFileName(^File, ^LinkName);
     IF LinkKind = L_General.lk_REVERSE_HISTORY THEN
      HISTCONF(L_DatTim.MINDATE(), ^File, ^Coo);
     ELSE
      TRY
       CONFORM(^File, ^Coo);
      EXCEPT
      ON Exc: Exc_Root DO
       L_General.Error(Exc.MsgOriginalText + L_StdFrm.HR() + ".  0102118");
      END;
     END;
     IF LinkKind = L_General.lk_USER THEN
      IF OCCURE(^Coo) THEN
       intPutFamily(wGuide, Coo, 1, ect_ReplaceOnlyEqualRecord);
      END;
     ELSE
      FIRST(^Coo);
      (* FIRST 㦥  ᪨ 䠩 -  樮  ⥪  *)
      WHILE OCCURE(^Coo) DO
       intPutFamily(wGuide, Coo, 1, ExistanceCheckType);
       NEXT(^Coo);
      END;
     END;
    END;
    INC(i);
   END;
  END; (* IF ~L_DBD.lr_Label(File) ...*)
 END {intPutFamily};

 PUBLIC PROCEDURE PutFamily(File              : STRING[];
                            Silent            : SCAL[2];
                            ExistanceCheckType: tExistanceCheckType);
 BEGIN
  intPutFamily(0, File, Silent, ExistanceCheckType);
 END {PutFamily};

 PUBLIC PROCEDURE PutFamily_wGuides(File              : STRING[];
                                    Silent            : SCAL[2];
                                    ExistanceCheckType: tExistanceCheckType);
 BEGIN
  intPutFamily(1, File, Silent, ExistanceCheckType);
 END {PutFamily_wGuides};

END.
