(*
%Copyright   (c) Polak IT
%Author      21.05.2003 17:20:15 POLAK\LDA
%Purpose      ࠡ  PDoc.ExtAbout
%Type        library
%Specific    SYS
%Modified    26.03.2014 11:45:20 POLAK\Gina
%Environment
*)

 MODULE L_ExtAb [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Str, Str, L_Prop;

 PUBLIC CONST
  Former_Pool_Short = "01|02|14|08|";
  Former_Pool       = "01 ⥫騪 - ਤ᪮ |"+
                      "02  |"+
                      "14 ⥫騪, ந騩 믫  (.1.1 .235 )|"+
                      "08 ⥫騪 - ૨, ⢫饥 㯫    ⥦   ⥬ |";
  Former_PayPTemplate = "\MDoc.Contract.7322.pmnt_Former";

  Reason_Pool_Short = "0||||||||||||";
  Reason_Pool       = "⭮ ᭮ ⥦|"+
                      " ⥦ ⥪饣 |"+
                      " ஢쭮 襭 |"+
                      " 騥 ⥦ , 㯫稢  ᢮ ᪮ |"+
                      " 襭   ॡ|"+
                      " 襭 祭 |"+
                      " 襭 祭 |"+
                      " 襭 㥬 |"+
                      " 襭   裡   譥 ࠢ|"+
                      " 襭 , ਮ⠭  ᪠|"+
                      " 襭    ஢ન|"+
                      " 襭   ᯮ⥫쭮 㬥|"+
                      " 襭 樮  ।";

  PeriodFormat_Pool = " |" +
                      "00.00.0000|" +
                      "00.0000|" +
                      "00.0000|" +
                      "00.0000|" +
                      "00.0000|" +
                      "00.0000|" +
                      "00.0000|" +
                      "00.0000|";

  Period_Type_Pool_Short = " | |1|2|3||||";
  Period_Type_Pool       = " ਮ ⥦|"+
                           "⥦  |"+
                           "1 ⥦    |"+
                           "2 ⥦    |"+
                           "3 ⥦    |"+
                           "  ⥦|"+
                           " ⠫ ⥦|"+
                           " 㣮 ⥦|"+
                           "  ⥦";

  PaymentType_Pool_Short = "0||||||||||";
  PaymentType_Pool       = "0  ⨯ ⥦|"+
                           "    ᡮ|"+
                           "  ⥦|"+
                           "  諨|"+
                           "  |"+
                           "    ।|"+
                           "  |"+
                           "  業⮢|"+
                           "  ᠭ樨, ⠭  |"+
                           " ⨢ |"+
                           "  ";

 PRIVATE PROCEDURE intAssert(Cond: SCAL[2]);
 BEGIN
  L_General.Assert(Cond, "४⭮ 祭 ਮ ⥦");
 END {intAssert};

 PRIVATE PROCEDURE intCheckSpecialDateValue(Period_Type: SCAL[100]; Value: STRING[]; Strong: SCAL[2]);
  VAR
   IntervalNumber: NUMERIC[0];
 BEGIN
  IF Strong THEN
   IF    Period_Type = 0 THEN
    intAssert(Value = "0");
   ELSIF Period_Type = 1 THEN
    intAssert(L_Prop.IsDateValue(Value, "D.N.y"));
   ELSE
    Value:=Str.Delete(Value, 0, 3);
    intAssert(L_Prop.IsNumericValue(Str.Item(Value, ".", 0), ""));
    intAssert(L_Prop.IsNumericValue(Str.Item(Value, ".", 1), ""));
    IF    Period_Type = 8 THEN
     IntervalNumber:=STRTOFLD(Str.Item(Value, ".", 0), NUMERIC);
     intAssert(IntervalNumber = 00);
     intAssert(L_Prop.IsDateValue("01.01." + Str.Item(Value, ".", 1), "D.N.y"));
    ELSE
     IF    Period_Type = 6 THEN
      IntervalNumber:=STRTOFLD(Str.Item(Value, ".", 0), NUMERIC);
      intAssert((IntervalNumber >= 01) & (IntervalNumber <= 04));
     ELSIF Period_Type = 7 THEN
      IntervalNumber:=STRTOFLD(Str.Item(Value, ".", 0), NUMERIC);
      intAssert ((IntervalNumber >= 01) & (IntervalNumber <= 02));
     END;
     intAssert(L_Prop.IsDateValue("01."+Value, "D.N.y"));
    END;
   END;
  END;
 END {intCheckSpecialDateValue};

 PUBLIC PROCEDURE CheckSpecialDateValue(Period_Type: SCAL[100]; Value: STRING[]);
 BEGIN
  intCheckSpecialDateValue(Period_Type, Value, 1);
 END {CheckSpecialDateValue};

 PUBLIC PROCEDURE SliceExtAbout(    trgExtAbout: STRING[];
                                VAR Former,
                                    KBK,
                                    OKTMO,
                                    Reason,
                                    Period,
                                    DocNbr,
                                    DocDate,
                                    PaymentType,
                                    Code       : STRING[]);
 BEGIN
  SETEMPTY(Former, KBK, OKTMO, Reason, Period, DocNbr, DocDate, PaymentType, Code);
  IF ~!trgExtAbout THEN
   Former     :=L_Str.AnyItem(trgExtAbout, ";", 0);
   KBK        :=L_Str.AnyItem(trgExtAbout, ";", 1);
   OKTMO      :=L_Str.AnyItem(trgExtAbout, ";", 2);
   Reason     :=L_Str.AnyItem(trgExtAbout, ";", 3);
   Period     :=L_Str.AnyItem(trgExtAbout, ";", 4);
   DocNbr     :=L_Str.AnyItem(trgExtAbout, ";", 5);
   DocDate    :=L_Str.AnyItem(trgExtAbout, ";", 6);
   PaymentType:=L_Str.AnyItem(trgExtAbout, ";", 7);
   Code       :=L_Str.AnyItem(trgExtAbout, ";", 8);
  END;
 END {SliceExtAbout};

 PRIVATE PROCEDURE DecodeAnyExtAbout(    trgExtAbout : STRING[];
                                     VAR Former      : STRING[];
                                     VAR KBK         : STRING[];
                                     VAR OKTMO       : STRING[];
                                     VAR Reason      : SCAL[100];
                                     VAR Period_Type : SCAL[100];
                                     VAR Period      : STRING[];
                                     VAR DocNbr      : STRING[];
                                     VAR DocDate     : DATE;
                                     VAR DocDateAsStr: STRING[];
                                     VAR PaymentType : SCAL[100];
                                     VAR Code        : STRING[];
                                         Strong      : SCAL[2];
                                         forPDoc     : SCAL[2]);
  VAR
   FormerIdx : NUMERIC[0];
   tmpFormer,
   tmpReason,
   tmpPeriod,
   tmpDocDate,
   tmpPaymentType: STRING[];
 BEGIN
  SETEMPTY(Code);
  IF ~!trgExtAbout THEN
   SETEMPTY(FormerIdx, Former, KBK, OKTMO, Reason, Period_Type, Period, DocNbr, DocDate, DocDateAsStr, PaymentType);
   SliceExtAbout(trgExtAbout, tmpFormer, KBK, OKTMO, tmpReason, tmpPeriod, DocNbr, tmpDocDate, tmpPaymentType, Code);

   IF ~!tmpFormer THEN
    FormerIdx:=L_Str.PositionInPool(Former_Pool_Short+Former_PayPTemplate, tmpFormer);
    IF ~!FormerIdx THEN
     Former:=L_Str.PoolItem(Former_Pool+Former_PayPTemplate, FormerIdx);
    END;
   END;

   Reason:=L_Str.PositionInPool(Reason_Pool_Short, tmpReason);

   IF L_Prop.IsNumericValue(tmpPeriod, "") THEN
    Period_Type:=0;
    Period     :=tmpPeriod;
   ELSE
    Period_Type:=L_Str.PositionInPool(Period_Type_Pool_Short, Str.Item(tmpPeriod, ".", 0));
    IF ~!Period_Type THEN
     IF forPDoc THEN
      Period:=Str.Item(tmpPeriod, ".", 1)+Str.Item(tmpPeriod, ".", 2);
     ELSE
      Period:=Str.Slice(tmpPeriod, Str.Length(Str.Item(tmpPeriod, ".", 0))+1, 999);
     END;
    ELSE
     Period_Type:=1;
     IF    L_Prop.IsDateValue(tmpPeriod, "D.N.y") THEN
      Period:=Str.Item(tmpPeriod, ".", 0)+Str.Item(tmpPeriod, ".", 1)+Str.Item(tmpPeriod, ".", 2);
     ELSIF ~forPDoc THEN
      Period:=tmpPeriod;
     END;
    END;
    IF forPDoc THEN
     intCheckSpecialDateValue(Period_Type, tmpPeriod, Strong);
    END;
   END;

   IF tmpDocDate # "0" THEN
    IF forPDoc THEN
     DocDate:=L_Prop.GetDateValueFromStr(tmpDocDate, "", Strong);
    ELSE
     DocDateAsStr:=tmpDocDate;
    END;
   END;

   PaymentType:=L_Str.PositionInPool(PaymentType_Pool_Short, tmpPaymentType);

   IF Strong THEN
    L_General.Assert(~!tmpFormer, " 㪠 ନ⥫");
    L_General.Assert(~!FormerIdx & ~!Former, "४ ନ⥫");
    L_General.Assert(~!KBK, " 㪠 ");
    L_General.Assert(~!OKTMO, " 㪠 ");
    L_General.Assert(~!tmpReason, " 㪠 ᭮ ⥦");
    L_General.Assert(~!Reason, "୮ 祭 ᭮ ⥦");
    L_General.Assert(~!tmpPeriod, " 㪠 ਮ ⥦");
    L_General.Assert(~!Period, "୮ 祭 ਮ ⥦");
    L_General.Assert(~!tmpPaymentType, " 㪠 ⨯ ⥦");
    L_General.Assert(~!PaymentType, "୮ 祭 ⨯ ⥦");
    IF forPDoc THEN
     L_General.Assert(tmpPeriod = "0", "୮ 祭 ਮ ⥦");
    END;
   END;
  END;
 END {DecodeAnyExtAbout};

 PUBLIC PROCEDURE DecodePayPLSExt(    trgExtAbout : STRING[];
                                  VAR Former      : STRING[];
                                  VAR KBK         : STRING[];
                                  VAR OKTMO       : STRING[];
                                  VAR Reason      : SCAL[100];
                                  VAR Period_Type : SCAL[100];
                                  VAR Period      : STRING[];
                                  VAR DocNbr      : STRING[];
                                  VAR DocDateAsStr: STRING[];
                                  VAR PaymentType : SCAL[100]);
  VAR
   DummyDate: DATE;
   DummyCode: STRING[];
 BEGIN
  DecodeAnyExtAbout(trgExtAbout, Former, KBK, OKTMO, Reason, Period_Type, Period, DocNbr, DummyDate, DocDateAsStr, PaymentType, DummyCode, 0, 0);
 END {DecodePayPLSExt};

 PUBLIC PROCEDURE DecodePDocExtAbout(    trgExtAbout: STRING[];
                                     VAR Former     : STRING[];
                                     VAR KBK        : STRING[];
                                     VAR OKTMO      : STRING[];
                                     VAR Reason     : SCAL[100];
                                     VAR Period_Type: SCAL[100];
                                     VAR Period     : STRING[];
                                     VAR DocNbr     : STRING[];
                                     VAR DocDate    : DATE;
                                     VAR PaymentType: SCAL[100];
                                     VAR Code       : STRING[]);
  VAR
   Dummy: STRING[];
 BEGIN
  DecodeAnyExtAbout(trgExtAbout, Former, KBK, OKTMO, Reason, Period_Type, Period, DocNbr, DocDate, Dummy, PaymentType, Code, 0, 1);
 END {DecodePDocExtAbout};

 PRIVATE PROCEDURE CheckAnyExtAbout(trgExtAbout: STRING[]; forPDoc: SCAL[2]);
  VAR
   Former      : STRING[];
   KBK         : STRING[];
   OKTMO       : STRING[];
   Reason      : SCAL[100];
   Period_Type : SCAL[100];
   Period      : STRING[];
   DocNbr      : STRING[];
   DocDate     : DATE;
   DocDateAsStr: STRING[];
   PaymentType : SCAL[100];
   Code        : STRING[];
 BEGIN
  DecodeAnyExtAbout(trgExtAbout, Former, KBK, OKTMO, Reason, Period_Type, Period, DocNbr, DocDate, DocDateAsStr, PaymentType, Code, 1, forPDoc);
 END {CheckAnyExtAbout};

 PUBLIC PROCEDURE CheckPayPPayLSExt();
 BEGIN
  CheckAnyExtAbout(PayP.PayLSExt, 0);
 END {CheckPayPPayLSExt};

 PUBLIC PROCEDURE CheckPDocExtAbout();
 BEGIN
  CheckAnyExtAbout(PDoc.ExtAbout, 1);
 END {CheckPDocExtAbout};

END.
