(*
%Copyright   (c) Polak Computer System
%Author      21.10.2001 19:17:45 SAN
%Purpose       譨 筨 
%Type        library
%Specific    SYS
%Modified    11.06.2014 13:29:44 POLAK\San
%Environment
*)

 MODULE L_ExtDB [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, DBD, L_AFM, DBF, Str, L_DatTim, FIO, L_Str, L_Basis, L_FIO, L_MSWStp;

 PUBLIC CONST
  m_Create = 0;
  m_Append = 1;

 PUBLIC VAR
  DEBUG: SCAL[2];

(*
$P{ StrTop:
?, L, ""
@
==============================================================================
| 䠩 ###################                                         |
|----------------------------------------------------------------------------|
| |                                                                |
|--------|-------------------------------------------------------------------|
}
*)

(*
$P{ StrLine:
?, L, ""
?, L, ""
@
|########|##################                                                 |
}
*)

(*
$P{ StrBot:
@
==============================================================================
}
*)

 PRIVATE PROCEDURE PrintMirrorStructure(File: STRING[]);
  VAR
   curField: FIELD;
 BEGIN
  OPENREP(R, L_General.NameConnection(File), Create, NoTune);
  MAKEPART(R, StrTop, File);
  FOR_EACH curField IN TABLE.Get(File).Fields DO
   MAKEPART(R, StrLine, curField.Name, curField.Type.Name);
  END; (* FOR_EACH curField ... *)
  MAKEPART(R, StrBot);
  CLOSEREP(R);
 END {PrintMirrorStructure};

 PUBLIC PROCEDURE PurgeDBFMirror(File: STRING[]);
 BEGIN
  L_AFM.AF_PurgeTemp(File);
 END {PurgeDBFMirror};

 PUBLIC PROCEDURE DBF_FieldExist(DBFFileName, DBFFieldName: STRING[]): SCAL[2];
  VAR
   Result   : SCAL[2];
   dbfIDENT,
   FieldName: STRING[];
 BEGIN
  dbfIDENT:="dbf" + L_DatTim.SysDateTimeStamp();
  DBF.Open(^dbfIDENT, DBFFileName, Input);
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   IF ~!DBF.GetField(^dbfIDENT, DBFFieldName) THEN
   END;
   Result:=1;
  EXCEPT
  ON Exc: Exc_Root DO
   Result:=0;
  END; (* TRY *)
  DBF.Close(^dbfIDENT);
  RETURN Result;
 END {DBF_FieldExist};

 PUBLIC PROCEDURE _MakeDBFMirror(File, FileDBF, NewFieldList, Keys: STRING[]; Mode: SCAL[3]; Cond: STRING[]; Lines: NUMERIC[0]);
  VAR
   ShortFileDBF,
   DBFFile,
   KeyStr,
   DBFField,
   _Field,
   _Type,
   AssignStr,
   SingleFieldDescr : STRING[];
   i, curLine       : NUMERIC[0];
   type             : STRING[1];
   length,
   decimal          : SCAL[255];
   AllowedDBFRecord,
   NeedCreateTmpFile: SCAL[2];
 BEGIN
  TRY
   ShortFileDBF:=L_FIO.effp_FileName_woExt(FileDBF);
   APP.Get().NewPrompt("㧪 DBF-䠩 "+ShortFileDBF);

   DBFFile:=File + "_"+ L_DatTim.LongSystimeStr();
   DBF.Open(^DBFFile, FileDBF);
   AssignStr        :="";
   IF    Mode = m_Create THEN
    IF ~!DATABASE.Get().Tables(File) THEN
     SETSEL(^File, RecNum);
     REMSEL(^File);
     NeedCreateTmpFile:=0;
    ELSE
     NeedCreateTmpFile:=1;
    END;
   ELSIF Mode = m_Append THEN
    NeedCreateTmpFile:=!DATABASE.Get().Tables(File);
   ELSE
    L_General.CallUs(0);
   END;
 
   IF NeedCreateTmpFile THEN
    CreateFILE(^File, "", " DBF-䠩 "+FileDBF, "");
    CreateFIELD(^File, "RecNum",  SCAL[1E14], "", "", "", "浪  ", "⥬ ଠ");
    CreateFIELD(^File, "DBFFile", STRING[32], "", "", "", " DBF-䠩 筨", "⥬ ଠ");
  
    i:=0;
    WHILE i < DBF.FieldAmount(^DBFFile) DO
     DBF.GetFD(^DBFFile, i, DBFField, type, length, decimal);
     _Field:=Str.Small(DBFField);
     _Type :=DBF.ConvTYPENAME(type, length, decimal);
     CreateFIELD(^File, ^_Field, ^_Type, "", "", "", "", "");
     INC(i);
    END; (* WHILE i < DBF.FieldAmount(^File) *)
 
    i:=0;
    LOOP
     SingleFieldDescr:=Str.Item(NewFieldList, ";", i);
     _Field          :=Str.Item(SingleFieldDescr, ":", 0);
     _Type           :=Str.Item(SingleFieldDescr, ":", 1);
     IF !SingleFieldDescr THEN
      EXIT;
     END;
     IF !TABLE.Get(File).Fields(_Field) THEN
      CreateFIELD(^File, ^_Field, ^_Type, "", "", "",  "", "");
     END;
     INC(i);
    END;
  
    CreateINDEX(^File, RecNum, AUTOINCR, " 浪", "⥬", RecNum);
    SETEMPTY(KeyStr); i:=0;
    LOOP
     KeyStr:=Str.Item(Keys,   ";", i);
     _Field:=Str.Item(KeyStr, ",", 0);
     IF ~!KeyStr THEN
      CreateINDEX(^File, ^_Field, PLURAL, "", "", ^KeyStr);
     ELSE
      EXIT;
     END;
     INC(i);
    END; (* LOOP *)
  
    SetVersionOfFILE(^File, 0000);
    L_AFM.AF_CreateTemp(File, File);
   END;
 
   i:=0;
   WHILE i < DBF.FieldAmount(^DBFFile) DO
    DBF.GetFD(^DBFFile, i, DBFField, type, length, decimal);
    _Field:=Str.Small(DBFField);
    IF ~!TABLE.Get(File).Fields(_Field) THEN
     AssignStr:=AssignStr+File+"."+_Field+":=DBF.GetField("+DBFFile+",'"+DBFField+"');";
    END;
    INC(i);
   END; (* WHILE i < DBF.FieldAmount(^File) *)
 
   i:=0;
   WHILE i < DBD.FieldAmount(^File) DO
    _Field:=DBD.FieldName(^File, i);
    IF (_Field # "RecNum") & (_Field # "DBFFile") THEN
     IF ~DBF_FieldExist(FileDBF, _Field) THEN
      AssignStr:=AssignStr+"SETEMPTY("+File+"."+_Field+");";
     END;
    END;
    INC(i);
   END; (* WHILE i < DBF.FieldAmount(^File) *)
 
   IF L_General.VariableIsInitialized(DEBUG) & (DEBUG = 1) THEN
    PrintMirrorStructure(File);
   ELSE
    curLine:=0;
    LOOP
     IF (~!Lines & (curLine > Lines)) | ~DBF.Seek(^DBFFile, curLine) THEN
      EXIT;
     END;
     PROMPT("ப "+L_Str.IntStr(curLine) + " " + L_Str.PoolItem(" |<DELETED>", DBF.Deleted(^DBFFile)));
     IF ~DBF.Deleted(^DBFFile) THEN
      IF !Cond THEN
       AllowedDBFRecord:=1;
      ELSE
       AllowedDBFRecord:=^Cond;
      END;
      IF AllowedDBFRecord THEN
       SETEMPTY(^File.RecNum);
       ^File.DBFFile:=ShortFileDBF;
       ^AssignStr;
       INSERT(^File);
      END;
     END;
 
     INC(curLine);
    END; (* LOOP *)
   END;
  EXCEPT
  FINALLY
   TRY
    DBF.Close(^DBFFile);
   EXCEPT
   ON Exc: Exc_Root DO
   END; (* TRY *)
  END;
 END {_MakeDBFMirror};

 PUBLIC PROCEDURE intMakeDBFMirror(File, FileDBF, NewFieldList, Keys: STRING[]; Mode: SCAL[3]);
 BEGIN
  _MakeDBFMirror(File, FileDBF, NewFieldList, Keys, Mode, "", EMPTYOF(NUMERIC[0]));
 END {intMakeDBFMirror};

 PUBLIC PROCEDURE MakeDBFMirror_wLimit(File, FileDBF, Keys: STRING[]; Lines: NUMERIC[0]);
 BEGIN
  _MakeDBFMirror(File, FileDBF, "", Keys, m_Create, "", Lines);
 END {MakeDBFMirror_wLimit};

 PUBLIC PROCEDURE MakeDBFMirror(File, FileDBF, Keys: STRING[]);
 BEGIN
  intMakeDBFMirror(File, FileDBF, "", Keys, m_Create);
 END {MakeDBFMirror};

 PUBLIC PROCEDURE ImportFromExpFile(File, FullExpFileName: STRING[]);
  VAR
   i, n,
   f, j, r,
   FieldAmount: NUMERIC[0];
   S,
   fName,
   rName,
   tName      : STRING[];
 BEGIN
  FieldAmount:=DBD.FieldAmount(^File);
  n          :=0;
  FIO.Open(R, FullExpFileName, , Input);
  WHILE FIO.RdStr(R, S) DO
   INC(n);
   PROMPT(L_Str.IntStr(n));
   f:=0; i:=0;
   WHILE f < FieldAmount DO
    fName:=DBD.FieldFullName(^File, f);
    tName:=L_Str.PoolItem("NUMERIC|FLOAT|SCAL|STRING|DATE|TIME|TIMESTAMP", TYPEOF(^fName));
    r:=RANGEOF(^fName);
    IF r > 1 THEN
     j:=0;
     WHILE j < r DO
      rName:=fName + "[" + L_Str.IntStr(j) + "]";
      ^rName:=STRTOFLD(L_Str.PoolItem(S, i), ^tName);
      INC(j);
      INC(i);
     END;
    ELSE
     ^fName:=STRTOFLD(L_Str.PoolItem(S, i), ^tName);
     INC(i);
    END;
    INC(f);
   END;
   INSERT(^File);
  END; (* WHILE FIO.RdStr ... *)
  FIO.Close(R);
 END {ImportFromExpFile};

 PRIVATE PROCEDURE PrintDBFStructure(RepName: STRING[]);
  VAR
   i       : NUMERIC[0];
   fName,
   type,
   DBFField: STRING[];
   length,
   decimal : NUMERIC[0];
 BEGIN
  FIO.Open(F, RepName, , Create);
  fName:=FIO.ChooseFile("*.dbf");
  DBF.Open(CDoc, fName, Output);
  i:=0;
  WHILE i < DBF.FieldAmount(CDoc) DO
   DBF.GetFD(CDoc, i, DBFField, type, length, decimal);
   L_Basis.wb_WrStr("F", DBFField);
   IF decimal=0 THEN
    L_Basis.wb_WrStr("F", type+"-"+L_Str.IntStr(length));
   ELSE
    L_Basis.wb_WrStr("F", type+"-"+L_Str.IntStr(length)+"."+L_Str.IntStr(decimal));
   END;
   L_Basis.wb_WrStr("F", DBF.ConvTYPENAME(type, length, decimal));
   L_Basis.wb_TermLine("F");
   INC(i);
  END; (* WHILE i < DBF.FieldAmount(^File) *)
  DBF.Close(CDoc);
  FIO.Close(F);
 END {PrintDBFStructure};

 PUBLIC PROCEDURE AddRecord(File: STRING[]);
  VAR
   n: NUMERIC[0];
 BEGIN
  n:=DBF.Amount(^File)+1;
  DBF.SetAmount(^File, n);
  DBF.Seek(^File, n-1);
 END {AddRecord};

 PUBLIC PROCEDURE RepRecord(File: STRING[]);
 BEGIN
  DBF.SetDeleted(^File, 0);
  DBF.Update(^File);
 END {RepRecord};

 PUBLIC PROCEDURE ado_MSSQLConnect(ServerList,
                                   Database,
                                   User,
                                   Pass      : STRING[]): OBJECT;
  VAR
   i             : NUMERIC[0];
   Result        : OBJECT;
   Server,
   tmpPass,
   SecurityString: STRING[];
   oPrompt       : PROMPT_LINE;
 BEGIN
  IF !User THEN
   SecurityString:="Integrated Security=SSPI;Persist Security Info=False;"
  ELSE
   tmpPass:=Pass;
   Pass   :=DECRYPTSTR(Pass, "24.06.2008 17:40:38 POLAK\San", CALG_RC2, , , CSP_NAME_MS_BASE);
   SecurityString:="uid="      + User     + ";" +
                   "pwd="      + Pass     + ";" ; 
  END;

  oPrompt:=PROMPT_LINE.Create("祭  ࢥ");
  i:=0;
  LOOP
   Server:=L_Str.PoolItem(ServerList, i);
   IF !Server THEN
    EXIT;
   END;
   PROMPT(Server);
   Result:=CreateOBJECT("ADODB.Connection");
   Result.ConnectionString :="Provider=" + "SQLOLEDB.1" + ";" +
                             "Server="   + Server       + ";" +
                             "database=" + Database     + ";" +
                             SecurityString;
   Result.ConnectionTimeout:=60;
   TRY
    Result.Open();
    EXIT;
   EXCEPT
   ON Exc: Exc_Object DO
    IF (L_MSWStp.ScodeCode(Exc.ErrorCode) = 16389) THEN
     L_General.Error(" 㤠   SQL ࢥ '" + Server + "'.|" +
                     " ࠢ,  ६ 㤭|" +
                     "(᫨ ஡ ﭭ, , , 祭 饭 ஬ )");
    ELSIF !L_Str.PoolItem(ServerList, i + 1) THEN
     RAISE();
    END;
   ELSE
    RAISE();
   END (* TRY *);
   INC(i);
  END; (* LOOP *)
  RETURN Result;
 END {ado_MSSQLConnect};

 PUBLIC PROCEDURE ado_MSSQLSelect(Connection: OBJECT; Select: STRING[]): OBJECT;
  VAR
   Result: OBJECT;
 BEGIN
  Result:=CreateOBJECT("ADODB.RecordSet");
  Result.Open(Select, Connection, 2(*adOpenDynamic*), 3(*adLockOptimistic*), 1(*adCmdText*));
  Result.CacheSize:=10000000;
  RETURN Result;
 END {ado_MSSQLSelect};

 PUBLIC PROCEDURE ado_intMSSQLCommand(Connection: OBJECT; Command: STRING[]; Silent: SCAL[2]);
  VAR Dummy : OBJECT;
 BEGIN
  TRY
   Dummy:=ado_MSSQLSelect(Connection, Command);
  EXCEPT
  ON Exc:Exc_Root DO
   IF ~Silent THEN
    RAISE();
   END;
  END;
 END {ado_intMSSQLCommand};

 PUBLIC PROCEDURE ado_MSSQLCommand(Connection: OBJECT; Command: STRING[]);
  VAR
   Dummy: OBJECT;
 BEGIN
  ado_intMSSQLCommand(Connection, Command, 0);
 END {ado_MSSQLCommand};

END.
