(*
%Copyright   (c) Polak IT
%Author      18.04.2011 09:35:59 POLAK\MLB
%Purpose
%Type        library
%Specific    SYS
%Modified    30.05.2011 17:17:23 POLAK\Bor
%Environment
*)

 MODULE L_FSS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Str, L_XDoc, L_APtm;

 PUBLIC TYPE
  tsie      = SCAL[32];
  tTaxGroup = SCAL[3];

 PUBLIC CONST
  sie_SickOrdinary   = 00; (**)               (*SocialInsuranceExpences*)
  sie_SickPregnancy  = 01; (**)
  sie_BabyMinding1   = 02; (*室1_5, 1*)
  sie_BabyBirth      = 03; (**)
  sie_Interment      = 04; (*ॡ*)
  sie_HldBabyInvld   = 05; (*吥*)
  sie_EarlyPregnancy = 06; (*⁥ ࠭ ப*)
  sie_Adoption       = 07; (*뭮*)
  sie_BabyMinding2   = 08; (*室1_5*)
  sie_IndustrialInj  = 09; (*ந⢥ ࠢ⨧*)
  sie_Pool           = "||室1_5||ॡ|吥|⁥|뭮|室1_5|쭏நࠢ";

  TaxGroupOrdinary = 0;
  TaxGroupSpec     = 1;
  TaxGroupAll      = 2;

 PUBLIC PROCEDURE GetAveTypeList(Per: DATE; _MCode: LIKE(MCList.MCode)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  SELECT(MoneyRul, MCode, , _MCode);
  WHILE OCCURE(MoneyRul) DO
   CONFORM(MoneyRul, MMthLog);
   CONFORM(MMthLog, MoneyMth);
   IF (MMthLog.Date <= Per) & L_DatTim.IsActive(Per, MoneyMth.Begin, MoneyMth.Till) &
      SELECT(AveTypeP, MthType, MoneyMth.MthType) THEN
    WHILE OCCURE(AveTypeP) DO
     IF !L_Str.PositionInPool(Result, AveTypeP.AveType) THEN
      Result:=L_Str.AddStrDlm(Result, "|")+AveTypeP.AveType;
     END;
     NEXT(AveTypeP);
    END; (* WHILE OCCURE(AveTypeP) ... *)
   END;
   NEXT(MoneyRul);
  END; (* WHILE OCCURE(MoneyRul) ... *)
  RETURN Result;
 END {GetAveTypeList};

 PRIVATE PROCEDURE PeriodClosed(Per: DATE): FLOAT;
  VAR
   LimDate : DATE;
   LimTime : TIME;
   PerClosed: FLOAT;
 BEGIN
  L_APtm.MonthAccess(Per);
  IF Month.NoTouch[L_APtm.system_Salary] THEN
   LimDate:=Month.NoTouchD[L_APtm.system_Salary];
   LimTime:=Month.NoTouchT[L_APtm.system_Salary];
  ELSE
   LimDate:=SYSDATE();
   LimTime:=SYSTIME();
  END;
  PackVARIANTDATE(PerClosed, LimDate, LimTime);
  RETURN PerClosed;
 END {PeriodClosed};

 PUBLIC PROCEDURE IsInPer(): SCAL[2];
  VAR
   Result  : SCAL[2];
   XDocType: L_XDoc.tXDocType;
   XDocKind: L_XDoc.tXDocKind;
   XDoc    : L_XDoc.tXDoc;
   AvePayClosed: FLOAT;
 BEGIN
  IF !AvePay.StopD THEN
   Result:=L_DatTim.Per(AvePay.StartD) = Tmp01._Period;
  ELSE
   Result:=(L_DatTim.Per(AvePay.StartD) <= Tmp01._Period) &
           (Tmp01._Period <= L_DatTim.Per(AvePay.StopD));
  END;
  IF Result THEN
   XDocType:=L_XDoc.GetFileXDT("AvePay");
   IF ~!XDocType & L_XDoc.XDocTypeHasXDocJrn(XDocType) THEN
    L_XDoc.DecodeXDocId(L_XDoc.curXDocId(XDocType), XDocType, XDocKind, XDoc);
    L_General.CallUs(SELECT(XDocJrn, XDocJrn, XDocType, XDocKind, XDoc) & LAST(XDocJrn));
    PackVARIANTDATE(AvePayClosed, XDocJrn.Date, XDocJrn.EndTime);
    IF    Tmp01._Closed > Tmp01._Period THEN
     Result:=(AvePayClosed > PeriodClosed(Tmp01._Period)) & (AvePayClosed < PeriodClosed(Tmp01._Closed));
    ELSIF Tmp01._Closed < Tmp01._Period THEN
     Result:=(AvePay.Period<=Tmp01._Closed) & (AvePayClosed > PeriodClosed(L_DatTim.IncMonth(Tmp01._Closed, -1))) & (AvePayClosed < PeriodClosed(Tmp01._Closed));
    ELSE
     Result:=AvePayClosed < PeriodClosed(Tmp01._Period);
    END;
   END;
  END;
  RETURN Result;
 END {IsInPer};

END.