(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     ⥪  㭪権
%Type        library
%Specific    SYS
%Modified    25.08.2014 14:15:17 POLAK\San
%Environment
*)

 MODULE L_General [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PRIVATE CONST
  FieldIdLen  =  7; (* Str.Length(MAXOF(tFileId)) *)
  RecordIdLen = 10; (* Str.Length(MAXOF(tRecordId)) *)

 PUBLIC TYPE
  tTimeCond           = SCAL[8];
  ft_DataType         = SCAL[99];
  tOSPlatform         = SCAL[4];
  tExecutablePrgType  = SCAL[4];
  tExecutablePrgPath  = STRING[][4];
  tModuleType         = SCAL[5];
  tProjectId          = STRING[];
  tRidgeExecuteMode   = SCAL[3];
  tFileId             = SCAL[1E7];
  tRecordId           = SCAL[4294967295];
  tInternalRecordId   = STRING[FieldIdLen+RecordIdLen];
  tLongTime           = FLOAT;

 PUBLIC PERMANENT VAR
  curUSER : SCAL[65535](*LIKE(AcsObj.AcsObj) 0084503 *);

 PUBLIC CONST
  lk_HISTORY         = +3; (* ᪨ borrow-䠩  *)
  lk_BORROW          = +2; (* Borrow-䠩               *)
  lk_USER            = +1; (* 짮⥫ ࠢ筨  *)
  lk_OWNER           = -1; (* ࠢ筨                *)
  lk_LEND            = -2; (* Lend-䠩                 *)
  lk_REVERSE_HISTORY = -3; (* Lend  ᪮ 裡 *)

  tc_onDate     = 0;
  tc_inIntvl    = 1;
  tc_inMonth    = 2;
  tc_onMonthBeg = 3;
  tc_onMonthEnd = 4;
  tc_onYearBeg  = 5;
  tc_onYearEnd  = 6;
  tc_Entire     = 7;

  tc_Pool = " ᥣ| ਮ| | 砫 |  | 砫 |  | 楫";

  (*  ⠭ ५ *)
  timeCond_OnDate     = tc_onDate;
  timeCond_InIntvl    = tc_inIntvl;
  timeCond_InMonth    = tc_inMonth;
  timeCond_OnMonthBeg = tc_onMonthBeg;
  timeCond_OnMonthEnd = tc_onMonthEnd;
  timeCond_OnYearBeg  = tc_onYearBeg;
  timeCond_OnYearEnd  = tc_onYearEnd;
  timeCond_Entire     = tc_Entire;

  ft_NUMERIC    = 0;
  ft_FLOAT      = 1; 
  ft_SCAL       = 2;
  ft_STRING     = 3;
  ft_DATE       = 4; 
  ft_TIME       = 5; 
  ft_TIMESTAMP  = 6;
  ft_OBJECT     = 7;
  ft_ENUMERATOR = 8;
  ft_VARIANT    = 9;
  ft_PROC       = 10;

  osp_32RTM  = 0;
  osp_Win32s = 1;
  osp_Win9x  = 2;
  osp_WinNT  = 3;

  ws_Normal    = 1;
  ws_Maximized = 3;
  ws_Minimized = 7;

  ept_Internal       = 0;
  ept_Standart       = 1;
  ept_Special        = 2;
  ept_ForInternalUse = 3;

  eprc_Normal  = 0;

  mt_ASL = 0;
  mt_FRM = 1;
  mt_WDO = 2;
  mt_MNU = 3;
  mt_DBS = 4;

  APSupportFolderName = "AP_SUPPORT";
  AP_Admin_GroupName = "AP_ADMIN";

  ec_rt_UnknownIdentifier         =   4;
  ec_rt_InvalidDate               =   9;
  ec_sn_TooFewParametrs           =  26;
  ec_rt_Overfilling               =  48;
  ec_rt_NoSuchZoneInWindow        =  64;
  ec_rt_NoWinFieldName            =  66;
  ec_rt_VarIsNotInitialized       =  77;
  ec_rt_FailedSTRTOFLD            = 131;
  ec_rt_ZoneIsNotPlane            = 132;
  ec_rt_TooBigCanvasSize          = 134;
  ec_rt_ClassNotRegistered        = 140;
  ec_rt_DynamicTypeIncompat       = 143;
  ec_rt_CantLoadModule            = 201;
  ec_rt_CantCreateRep             = 212;
  ec_rt_NoDeleteUser              = 223;
  ec_rt_UniquenessViolation       = 229;
  ec_rt_PosOutOfZoneSystemSelect  = 234;
  ec_rt_PosOutOfZoneUserSelect    = 367;
  ec_rt_PosOutOfZoneFilter        = 368;
  ec_ad_IsLockedByOtherConnection = 374;
  ec_rt_NoRecordAfterRESTORE      = 377;
  ec_rt_LockedByMainASL           = 380;
  ec_rt_UnableToOpenThePrinter    = 471;
  ec_rt_IncorrectlyEncodedString  = 481;
  ec_rt_CantDecodeString          = 482;
  ec_rt_FIOCantOpenFile           = 601;
  ec_rt_CantLoadWindow            = 883;
  ec_rt_HiddenUniquenessViolation = 952;
  ec_rt_InsAttemptInAddOnly       = 958;
  ec_rt_RecAccessDeniedByOwnTRN   = 960;
  ec_rt_NoZoneSelect              = 974;
  ec_rt_RecordIsInEdIns           = 988;

 IMPORT SysLog;

 PUBLIC CONST
  sle_RunACLItem     = SysLog.UserEvent + 1;
  sle_RunProgAtStart = sle_RunACLItem + 1;
  sle_Pool = "Insert|Edit|Delete|RunProg|Report|Debug|wo_Prog|ImActions|RunACLItem|RunAtStart|"+
             "10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|"+
             "ExcRmtCtrl|TimeShift";

  rem_Isolated = 0; (*tRidgeExecuteMode*)
  rem_SameTRN  = 1;
  rem_Discard  = 2;

 PRIVATE VAR
  tpm_UpdatingTime: TIMESTAMP;

 IMPORT Memo, L_DatTim, DBD, Reg, L_Math, L_StdFrm, L_Str, FIO, Shell, L_MSWStp, Math, L_FIO, Str;

 PRIVATE PERMANENT VAR
  Exc_Raise_Collection: OBJECT;

 PRIVATE VAR
  IsInBatchExecution: SCAL[2];
  IsInKioskExecution: SCAL[2];
  IsInTestExecution : SCAL[2];
  be_AuthorAscObj   : LIKE(AcsObj.AcsObj);

 PUBLIC PROCEDURE IsOurSite(): SCAL[2];
 BEGIN
  RETURN ISOURSITE();
 END {IsOurSite};

 PUBLIC PROCEDURE IsOurEngineeringCopy(): SCAL[2];
 BEGIN
  RETURN IsOurSite() & !FIO.AsbSpecialFolders("IsProductiveCopy");
 END {IsOurEngineeringCopy};

 PRIVATE PROCEDURE Is16x9PrimaryMonitor(): SCAL[2];
  VAR
   m: MONITOR;
 BEGIN
  IF IsAcceptableProcessorVersion(14216030) & L_StdFrm.wGUI() & IsOurSite() THEN
   FOR_EACH m IN MONITORS.Create() DO
    IF m.Primary THEN
     IF (m.Screen.Right-m.Screen.Left) / (m.Screen.Bottom-m.Screen.Top) >= 1.6 THEN
      RETURN 1;
     END;
    END;
   END;
  END;
  RETURN 0;
 END {Is16x9PrimaryMonitor};

 PUBLIC PROCEDURE MainWindowStandartWidth(): NUMERIC[0];
 BEGIN
  IF Is16x9PrimaryMonitor() THEN RETURN 150;
  ELSE                           RETURN 112;
  END;
 END {MainWindowStandartWidth};

 PUBLIC PROCEDURE MainWindowStandartHeight(): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  IF Is16x9PrimaryMonitor() THEN RETURN 47;
  ELSE                           RETURN 50;
  END;
 END {MainWindowStandartHeight};

 PUBLIC PROCEDURE BatchExecution_Begin(AuthorAscObj: LIKE(AcsObj.AcsObj));
 BEGIN
  IsInBatchExecution:=1;
  be_AuthorAscObj   :=AuthorAscObj;
 END {BatchExecution_Begin};

 PUBLIC PROCEDURE BatchExecution_AuthorAscObj(): LIKE(AcsObj.AcsObj);
 BEGIN
  CallUs(BatchExecution_IsRunning());
  RETURN be_AuthorAscObj;
 END {BatchExecution_AuthorAscObj};

 PUBLIC PROCEDURE BatchExecution_End();
 BEGIN
  IsInBatchExecution:=0;
 END {BatchExecution_End};

 PUBLIC PROCEDURE BatchExecution_IsRunning(): SCAL[2];
 BEGIN
  RETURN VAR_IMPL.Get(IsInBatchExecution).Initialized & IsInBatchExecution;
 END {BatchExecution_IsRunning};

 PUBLIC PROCEDURE TestExecution_Begin();
 BEGIN
  IsInTestExecution:=1;
 END {TestExecution_Begin};

 PUBLIC PROCEDURE TestExecution_IsRunning(): SCAL[2];
 BEGIN
  RETURN VAR_IMPL.Get(IsInTestExecution).Initialized & IsInTestExecution;
 END {TestExecution_IsRunning};

 PUBLIC PROCEDURE KioskExecution_Begin();
 BEGIN
  IsInKioskExecution:=1;
 END {KioskExecution_Begin};

 PUBLIC PROCEDURE KioskExecution_End();
 BEGIN
  IsInKioskExecution:=0;
 END {KioskExecution_End};

 PUBLIC PROCEDURE KioskExecution_IsRunning(): SCAL[2];
 BEGIN
  RETURN VAR_IMPL.Get(IsInKioskExecution).Initialized & IsInKioskExecution;
 END {KioskExecution_IsRunning};

 PRIVATE PROCEDURE GetProjectId(): tProjectId;
  VAR
   Id, Dummy: STRING[];
 BEGIN
  FIO.SplitPath(FIO.AsbSpecialFolders("ProjectId"), Id, Dummy, Dummy);
  RETURN Id;
 END {GetProjectId};

 PUBLIC PROCEDURE GetAPSiteID(): STRING[];
 BEGIN
  IF Str.Cap(DATABASE.Get().Name) = "OD" THEN (*  ⠪ *)
   RETURN GetProjectId();
  ELSE
   RETURN Str.Cap(DATABASE.Get().Name);
  END;
 END {GetAPSiteID};

 PUBLIC PROCEDURE GetAPSiteNumber(): SCAL[1E4];
  VAR
   APSiteID: STRING[];
   Result  : SCAL[1E4];
 BEGIN
  APSiteID:=GetAPSiteID();
  IF    APSiteID = "KL" THEN
   Result:=21;
  ELSIF APSiteID = "VD" THEN
   Result:=22;
  ELSIF APSiteID = "ML" THEN
   Result:=23;
  ELSIF APSiteID = "SN" THEN
   Result:=24;
  ELSIF APSiteID = "OD" THEN
   Result:=25;
  ELSIF APSiteID = "HM" THEN
   Result:=26;
  ELSIF APSiteID = "DD" THEN
   Result:=27;
  ELSIF APSiteID = "ES" THEN
   Result:=28;
  ELSIF APSiteID = "NF" THEN
   Result:=29;
  ELSIF APSiteID = "SP" THEN
   Result:=50;
  ELSIF APSiteID = "IV" THEN
   Result:=51;
  ELSIF APSiteID = "ZV" THEN
   Result:=90;
  ELSIF APSiteID = "X1" THEN
   Result:=91;
  ELSIF APSiteID = "X2" THEN
   Result:=92;
  ELSIF APSiteID = "X3" THEN
   Result:=93;
  ELSIF APSiteID = "POLAK" THEN
   Result:=96;
  ELSIF APSiteID = "JOURNAL" THEN
   Result:=00;
  ELSE
   Result:=APSiteID;
  END;
  RETURN Result;
 END {GetAPSiteNumber};

 PUBLIC PROCEDURE IsSetRecordPositionInZoneError(ErrorCode: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN (ErrorCode = ec_rt_PosOutOfZoneSystemSelect) |
         (ErrorCode = ec_rt_PosOutOfZoneUserSelect)   |
         (ErrorCode = ec_rt_PosOutOfZoneFilter)       |
         (ErrorCode = ec_rt_NoZoneSelect);
 END {IsSetRecordPositionInZoneError};

 PUBLIC PROCEDURE extCallUs(Msg: STRING[]);
 BEGIN
  STDMSG(Msg, STOP_AND_CALL_AUTHOR);
 END {extCallUs};

 PRIVATE PROCEDURE intCallUs();
  VAR
   Point: CALL_STACK_CELL;
   Id   : STRING[];
   Done : SCAL[2];
 BEGIN
  Point:=RTI.Get().Stack(2);
  Id   :=Point.Proc.FullName + "." + L_Str.IntStr(Point.Row);

  CreatePermanentDictionary(Exc_Raise_Collection);
  IF ~Exc_Raise_Collection.Exists(Id) THEN
   Exc_Raise_Collection.Add(Id, "");
   LOGMSG("饭 ࠧࠡ稪 " + Id);
  END;

  STDMSG(Id, STOP_AND_CALL_AUTHOR);
 END {intCallUs};

 PUBLIC PROCEDURE CallUs(Cond: SCAL[2]);
 BEGIN
  IF ~Cond THEN
   intCallUs();
  END;
 END {CallUs};

 PRIVATE PROCEDURE GetLastASLRenewalDTS(): TIMESTAMP;
  VAR
   Result: TIMESTAMP;
   File  : FOLDERENTRY;
 BEGIN
  SETEMPTY(Result);
  FOR_EACH File IN FOLDERENTRY.CreateRedirector(FIO.BuildPath(GetAPSiteID() + "_?????", "UPD", FIO.BuildPath("DEF", , FIO.AsbSpecialFolders("ClientProjectRoot")))).FolderContent DO
   IF ~File.Attributes.Directory THEN
    CallUs(!Result);
    Result:=File.UTCLastModified;
   END;
  END; (* FOR_EACH File IN FOLDERENTRY...*)
  RETURN Result;
 END {GetLastASLRenewalDTS};

 PUBLIC PROCEDURE TheProjectModulesWereUpdated(): SCAL[2];
  VAR
   lm    : TIMESTAMP;
   Result: SCAL[2];
 BEGIN
  Result:=0;
  lm:=APP.Get().ProjectModulesLastModified;
  IF ~VAR_IMPL.Get(tpm_UpdatingTime).Initialized THEN
   tpm_UpdatingTime:=lm;
  ELSIF tpm_UpdatingTime # lm THEN
   Result          :=1;
   tpm_UpdatingTime:=lm;
  END;
  RETURN Result;
 END {TheProjectModulesWereUpdated};

(*!! *) PUBLIC PROCEDURE ResourceFolder(): STRING[];
  VAR s: STRING[];
 BEGIN
  s:=FIO.AsbSpecialFolders("PrototypeRoot");
  IF ~!s THEN
   RETURN FIO.BuildPath("TXT\RES", , s);
  ELSE
   RETURN "TXT\RES";
  END;
 END {ResourceFolder};

 PUBLIC PROCEDURE Error(Text: STRING[]);
 BEGIN
  STDMSG(Text, STOP);
 END {Error};

 PUBLIC PROCEDURE Assert(Cond: SCAL[2]; Text: STRING[]);
 BEGIN
  IF ~Cond THEN Error(Text); END;
 END {Assert};

 PUBLIC PROCEDURE ErrorInteractive_NonExistentOwner(Cond: SCAL[2]);
  VAR
   React: NUMERIC[0];
 BEGIN
  Assert(Cond, "祭 ⮣     ந !||" +
               " ⨬ 祭 ᫥  ᮮ⢥饬 ࠢ筨.");
(*
  IF ~Cond THEN
   React:=STDFORM(L_StdFrm.PartForm("%<   ஢   >B" +
                                    "%<  ஥ 祭 >B"+
                                    "%<  㦭 祭 >B"+
                                    "@" +
                                    "|" +
                                    "|祭 ⮣     ந !" +
                                    "|" +
                                    "| ⨬ 祭 ᫥  ᮮ⢥饬 ࠢ筨." +
                                    "|" +
                                    "|  %#########################%   %#########################%   %#########################%"),
                                    "  ",
                                    STOP,
                                    1);
   IF    React = 1 THEN
    HALT(1);
   ELSIF React = 2 THEN
   ELSIF React = 3 THEN
    LIKEMENU(Ask, "");
   END;
  END;
*)
 END {ErrorInteractive_NonExistentOwner};

 PUBLIC CONST
  ec_Raise_RoughAssert = 153849;

 PUBLIC PROCEDURE RoughAssert(Cond: SCAL[2]; Text: STRING[]);
 BEGIN
  IF ~Cond THEN
   RAISE(ec_Raise_RoughAssert, Text);
  END;
 END {Assert};

 PRIVATE PROCEDURE IsRoughAssert(Exc: Exc_Root): SCAL[2];
 BEGIN
  RETURN (Exc.Class = "Exc_Raise") & (Exc.ErrorCode = ec_Raise_RoughAssert);
 END {IsRoughAssert};

 PUBLIC PROCEDURE CheckIsRoughRaiseException(Exc: Exc_Root);
 BEGIN
  IF IsRoughAssert(Exc) THEN
   RAISE();
  END;
 END {CheckIsRoughRaise};

 (* rfn: report full name *)

 PRIVATE PROCEDURE rfn_GetSessionTail(): STRING[];
 BEGIN
  RETURN L_Str.FixedIntStr(curUSER, 5) + "_" + L_Str.FixedIntStr(APP.Get().MyConnection.ConnectionNo, 4);
 END {rfn_GetSessionTail};

 PRIVATE PROCEDURE rfn_GetFullTail(): STRING[];
 BEGIN
  RETURN FLDTOSTR(SYSTIMESTAMP(), "yNDHMS") + "_" + rfn_GetSessionTail();
 END {rfn_GetFullTail};

 PUBLIC PROCEDURE rfn_byMonth(Name: STRING[]; P: DATE): STRING[];
  VAR
   oldStyleName,
   newStyleName: STRING[];
 BEGIN
  oldStyleName:=Name + "_" + FLDTOSTR(P, "YN");
  newStyleName:=oldStyleName + "_" + rfn_GetFullTail();
  RETURN FIO.BuildPath(newStyleName, "REP", L_FIO.effp_Folder(FIO.FirstPath(oldStyleName, "REP")));
 END {rfn_byMonth};

 (*!*) PUBLIC PROCEDURE NameAnyMonth(N: STRING[]; P: DATE): STRING[];
 BEGIN
  RETURN rfn_byMonth(N, P);
(*
  RETURN N + FLDTOSTR(P, "_YN");
*)
 END {NameAnyMonth};

 (*!*) PUBLIC PROCEDURE NameMonth(N: STRING[]): STRING[];
 BEGIN
  RETURN NameAnyMonth(N, Memo.tmp_mb());
 END {NameMonth};

 PRIVATE PROCEDURE rfn_byConnection_ext(Name: STRING[]; wTimeStamp: SCAL[2]): STRING[];
  VAR
   oldStyleName,
   newStyleName: STRING[];
 BEGIN
  oldStyleName:=Name + "_01";
  IF wTimeStamp THEN
   newStyleName:=Name + "_" + rfn_GetFullTail();
  ELSE
   newStyleName:=Name + "_" + rfn_GetSessionTail();
  END;
  IF KioskExecution_IsRunning() THEN
   RETURN FIO.BuildPath(newStyleName, "REP", FIO.AsbSpecialFolders("ASBTemp"));
  ELSE
   RETURN FIO.BuildPath(newStyleName, "REP", L_FIO.effp_Folder(FIO.FirstPath(oldStyleName, "REP")));
  END;
 END {rfn_byConnection_ext};

 PUBLIC PROCEDURE rfn_byConnection(Name: STRING[]): STRING[];
 BEGIN
  RETURN rfn_byConnection_ext(Name, 1);
 END {rfn_byConnection};

 PUBLIC PROCEDURE NameConnection(Name: STRING[]): STRING[];
 BEGIN
  RETURN rfn_byConnection_ext(Name, 0);
 END {NameConnection};

 PUBLIC PROCEDURE NameConnection_ForSend(Name: STRING[]): STRING[];
 BEGIN
  RETURN rfn_byConnection_ext(Name + "_" + GetAPSiteNumber(), 0);
 END {NameConnection_ForSend};

 PUBLIC PROCEDURE IsAPSupportFolder(FolderName: STRING[]): SCAL[2];
 BEGIN
  RETURN Str.Match(Str.Cap(FolderName), "*" + Str.Cap(APSupportFolderName) + "*");
 END {IsAPSupportFolder};

 PUBLIC PROCEDURE IsLocalMode(): SCAL[2];
 BEGIN
  RETURN !APP.Get().ServerDomainSID;
 END {IsLocalMode};

 PUBLIC PROCEDURE IsProgrammer(): SCAL[2];
 BEGIN
  RETURN ISPROGRAMMER() & (IsOurEngineeringCopy() | APP.Get().SupportMode);
 END {IsProgrammer};

 PUBLIC PROCEDURE extPrgsOnly_wMes(Mes: STRING[]);
 BEGIN
  Assert(IsProgrammer(), Mes);
 END {extPrgsOnly_wMes};

 PUBLIC PROCEDURE SilentPrgsOnly();
 BEGIN
  extPrgsOnly_wMes("   稩 (PROGRAMMERS)  믮 ⮩ 樨");
 END {SilentPrgsOnly};

 CONST
  PrgsOnlyMsg = "You may do it because You're Programmer!";

 PUBLIC PROCEDURE PrgsOnly();
 BEGIN
  SilentPrgsOnly();
  L_StdFrm.Choice(PrgsOnlyMsg);
 END {PrgsOnly};

 PUBLIC PROCEDURE PrgsOnly_wMes(Mes: STRING[]);
 BEGIN
  extPrgsOnly_wMes(Mes);
  L_StdFrm.Choice(PrgsOnlyMsg);
 END {PrgsOnly};

 PUBLIC PROCEDURE PermitIllegalDataModifying();
 BEGIN
  IF ISPROGRAMMER() THEN
   L_StdFrm.Choice(" 믮 쭮  !");
  ELSE
   HALT();
  END;
 END {PermitIllegalDataModifying};

 PUBLIC PROCEDURE IsPolakSpecific(): SCAL[2];
 BEGIN
  RETURN (Str.Cap(DATABASE.Get().Name) = "POLAK") | ((Str.Cap(DATABASE.Get().Name) = "X1"));
 END {IsPolakSpecific};

 PUBLIC PROCEDURE SessionIsUnderExclusiveRemoteControl(): SCAL[2];
  VAR
   exclusive: SCAL[2];
 BEGIN
  RETURN UNDERREMOTECONTROL( , , exclusive) & exclusive;
 END {SessionIsUnderExclusiveRemoteControl};

 PUBLIC PROCEDURE AdminGroupName(): STRING[];
 BEGIN
  IF IsPolakSpecific() & ~IsOurEngineeringCopy() THEN
   RETURN "POLAK_ADMIN";
  ELSE
   RETURN AP_Admin_GroupName;
  END;
 END {AdminGroupName};

 PUBLIC PROCEDURE UsersGroupName(): STRING[];
 BEGIN
  IF IsPolakSpecific() THEN
   RETURN "POLAK_USERS";
  ELSE
   RETURN "AP_USERS";
  END;
 END {UsersGroupName};

 PUBLIC PROCEDURE IsMemberOf(GroupName: STRING[]): SCAL[2];
 BEGIN
  IF ~IsLocalMode() THEN
   RETURN MEMBEROF(Str.Cap(GroupName)) | MEMBEROF(Str.Cap(GroupName), 1);
  ELSE
   RETURN ~L_Str.IsEqStrI(GroupName, L_APtm.g_APSupport) & ~L_Str.IsEqStrI(GroupName, L_APtm.g_EndUser);
  END;
 END {IsMemberOf};

 PUBLIC PROCEDURE IsAdmin(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=1;
  IF ~IsLocalMode() THEN
   Result:=ISADMIN() & IsMemberOf(AdminGroupName());
   IF ~Result & SessionIsUnderExclusiveRemoteControl() THEN
    L_StdFrm.CustomQuestion(" 室  ० 쭮 ࠢ 祭,"+
                            "||⮬  ﬨ ."+
                            "|| ");
    Result:=1;
   END;
  END;
  RETURN Result;
 END {IsAdmin};

 PUBLIC PROCEDURE ForbAction(NeedGroup: STRING[30]);
 BEGIN
  Assert(IsMemberOf(NeedGroup) | IsAdmin(),
         "   稩 (" + NeedGroup + ")  믮 ⮩ 樨");
 END {ForbAction};

 PUBLIC PROCEDURE SilentAdminOnly();
 BEGIN
  Assert(IsAdmin(), " 믮 ⮩ 樨 室  ");
 END {SilentAdminOnly};

 PRIVATE CONST
  YouMayDoItAsAdmin = "  믮 , ⮬   !";

 PUBLIC PROCEDURE AdminOnly();
 BEGIN
  SilentAdminOnly();
  L_StdFrm.Choice(YouMayDoItAsAdmin);
 END {AdminOnly};

 PUBLIC PROCEDURE DomainAdminOnly();
 BEGIN
  Assert(IsMemberOf("Domain Admins") | IsMemberOf(" "), "   稩 ( )  믮 ⮩ 樨");
 END {DomainAdminOnly};

 PUBLIC PROCEDURE Assert_wReferToAdmin(Cond: SCAL[2]; Text: STRING[]);
 BEGIN
  IF ~Cond THEN
   IF IsAdmin() THEN
    L_StdFrm.Choice(Text + L_StdFrm.HR() + YouMayDoItAsAdmin);
   ELSE
    STDMSG(Text + L_StdFrm.HR()+ "   稩  믮 ⮩ 樨" +
                                "|᫨  㢥७  ࠢ쭮 ᢮ ⢨," +
                                "|,   ", STOP_AND_CALL_ADMIN);
   END;
  END;
 END {Assert_wReferToAdmin};

 PUBLIC PROCEDURE AssertInSupportMode(Cond: SCAL[2]; Text: STRING[]);
 BEGIN
  IF ~Cond THEN
   IF APP.Get().SupportMode THEN
    L_StdFrm.Choice(Text + "||   믮, ⮬ | 饭  ० ࠧࠡ稪");
   ELSE
    Error(Text);
   END;
  END;
 END {AssertInSupportMode};

 PUBLIC PROCEDURE TestIsMemberOfSpecificGroup(IsMember: SCAL[2]; WhoStr: STRING[]);
 BEGIN
  IF ~IsAdmin() & ~IsMember THEN
   L_StdFrm.RedInform(", " + WhoStr + ",  祭 |" +
                      " ᯥ  ⮩ ࠡ 㯯 짮⥫." +
                      "||  த ࠡ,  ⥫쭮 ४㥬" +
                      "|  , ⮡  ந ࠢ.");
  END;
 END {TestIsMemberOfSpecificGroup};

 PRIVATE PROCEDURE extCreateDictionary(FirstPass: SCAL[2]): OBJECT;
  CONST
   vbTextCompare = 1;
  VAR
   Dictionary: OBJECT;
 BEGIN
  TRY
   Dictionary:=CreateOBJECT("Scripting.Dictionary", , 0);
   Dictionary.CompareMode:=vbTextCompare;
  EXCEPT
  ON Exc:Exc_Root DO
   IF Exc.ErrorCode = ec_rt_ClassNotRegistered THEN
    Assert(FirstPass, Exc.MsgOriginalText);
    L_MSWStp.InstallScriptingDictionary();
    Dictionary:=extCreateDictionary(0);
   ELSE
    RAISE();
   END;
  END; (* TRY *)
  RETURN Dictionary;
 END {extCreateDictionary};

 PUBLIC PROCEDURE CreateDictionary(): OBJECT;
 BEGIN
  RETURN extCreateDictionary(1);
 END {CreateDictionary};

 PUBLIC PROCEDURE CreatePermanentDictionary(VAR Dct: OBJECT);
 BEGIN
  IF ~OBJECTIsInitialized(Dct) THEN
   Dct:=CreateDictionary();
  END;
 END {CreatePermanentDictionary};

 PUBLIC PROCEDURE InformUs(Text: STRING[]);
  VAR
   Msg: STRING[];
 BEGIN
  Msg:=" 믮  樨 ॡ ன ணࠬ" + L_StdFrm.HR() +
       "᫨  㢥७  ࠢ쭮 ᢮ ⢨";
  IF ~IsAdmin() THEN
   Msg:=Msg+",|    ଫ ,";
  ELSE
   Msg:=Msg+", ନ ,";
  END;
  Msg:=Msg+"| ஬ ᮮ ᫥饥:||";
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   STDMSG(Msg+Text, STOP_AND_CALL_AUTHOR);
  EXCEPT
  END; (* TRY *)
 END {InformUs};

 (*!*) PUBLIC PROCEDURE ConsultToUs(Condition: SCAL[2]; Msg: STRING[]);
 BEGIN
  IF ~Condition THEN
   intCallUs();
  END;
 END {ConsultToUs};

 PUBLIC PROCEDURE BadMode(MODE: SCAL[1E3]);
 BEGIN
  IF MODE # 999 THEN
   CallUs(0);
  ELSE
   IF IsOurEngineeringCopy() THEN
    L_StdFrm.Choice(" L_General.BadMode '諮' 999");
   END;
  END;
 END {BadMode};

 PUBLIC PROCEDURE _SilentCheckRightsByMEMBEROF(Default,
                                               Rights    : STRING[];
                                               ForceCheck: SCAL[2]): SCAL[2];
  VAR
   i     : NUMERIC[0];
   _Group: STRING[];
 BEGIN
  IF ~IsAdmin() THEN
   IF ForceCheck | ~(!Default & !Rights) THEN
    Rights:=Default+";"+Rights;
    i:=0;
    LOOP
     _Group:=Str.Item(Rights, "; ", i);
     IF    !_Group THEN
      RETURN 0;
     ELSIF IsMemberOf(_Group) THEN
      EXIT;
     END;
     INC(i);
    END; (* LOOP *)
   END;
  END;
  RETURN 1;
 END {_SilentCheckRightsByMEMBEROF};

 PUBLIC PROCEDURE SilentCheckRightsByMEMBEROF(Default, Rights: STRING[]): SCAL[2];
 BEGIN
  RETURN _SilentCheckRightsByMEMBEROF(Default, Rights, 0);
 END {SilentCheckRightsByMEMBEROF};

 PUBLIC PROCEDURE CheckRightsByMEMBEROF(Default, Rights: STRING[]);
 BEGIN
  Assert(SilentCheckRightsByMEMBEROF(Default, Rights),
         "   ᮮ⢥ 稩");
 END {CheckRightsByMEMBEROF};

 PUBLIC PROCEDURE DenominationDate(): DATE;
 BEGIN
  RETURN 01\01\1998;
 END {DenominationDate};

 PUBLIC PROCEDURE UnDenominate(DS, DD: DATE; S: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF (DS >= DenominationDate()) & (DD < DenominationDate()) THEN
   RETURN S * 1000;
  ELSE
   RETURN S;
  END;
 END {UnDenominate};

 PUBLIC PROCEDURE Denominate(DS, DD: DATE; S: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF (DS < DenominationDate()) & (DD >= DenominationDate()) THEN
   IF S < 0 THEN
    RETURN S/1000;
   ELSE
    RETURN S/1000;
   END;
  ELSE
   RETURN S;
  END;
 END {Denominate};

 PUBLIC PROCEDURE DenominateNM(D: DATE; S: NUMERIC[2]): NUMERIC[2];
 BEGIN
  RETURN Denominate(D, L_DatTim.IncMonth(D, +1), S);
 END {DenominateNM};

 PUBLIC PROCEDURE IsLegalRecordModification(File: STRING[]; AllowedFields: STRING[]): SCAL[2];
  VAR
   i       : NUMERIC[0];
   Changed : SCAL[2];
   s       : STRING[];
   curField: FIELD;
 BEGIN
  FOR_EACH curField IN TABLE.Get(File).Fields DO
   i:=0; Changed:=0;
   WHILE (i < curField.Type.Range) & ~Changed DO
    Changed:=^(curField.ObtainName(i)) # GE_PVALUE(^(curField.ObtainName(i)));
    INC(i);
   END;
   IF Changed THEN
    i:=0;
    LOOP
     s:=L_Str.PoolItem(AllowedFields, i);
     IF !s THEN
      RETURN 0;
     ELSIF Str.Match(curField.Name, s) THEN
      EXIT;
     END;
     INC(i);
    END; (* LOOP *)
   END; (* IF Changed *)
  END; (* FOR_EACH curField IN ... *)
  RETURN 1;
 END {IsLegalRecordModification};

 PUBLIC PROCEDURE IsWindowsXP(): SCAL[2];
  VAR
   platform: tOSPlatform;
   major,
   minor,
   prType  : NUMERIC[0];
 BEGIN
  OSVERSION(platform, major, minor, , , prType);
  RETURN (platform = osp_WinNT       ) &
         (major    = 5               ) &
         ((minor  = 1) | (minor  = 2)) &
         ((prType = 0) | (prType = 1));
 END {IsWindowsXP};

 PUBLIC PROCEDURE IsWindowsVista(): SCAL[2];
  VAR
   platform: tOSPlatform;
   major,
   minor,
   prType  : NUMERIC[0];
 BEGIN
  OSVERSION(platform, major, minor, , , prType);
  RETURN (platform = osp_WinNT) &
         (major    = 6        ) &
         (minor    = 0        ) &
         (prType   = 1        );
 END {IsWindowsVista};

 PUBLIC PROCEDURE IsWindows2008(): SCAL[2];
  VAR
   platform: tOSPlatform;
   major,
   minor,
   prType  : NUMERIC[0];
 BEGIN
  OSVERSION(platform, major, minor, , , prType);
  RETURN (platform = osp_WinNT       ) &
         (major    = 6               ) &
         ((minor  = 0) | (minor  = 1)) &
         ((prType = 2) | (prType = 3));
 END {IsWindows2008};

 PUBLIC PROCEDURE IsWindows7(): SCAL[2];
  VAR
   platform: tOSPlatform;
   major,
   minor,
   prType  : NUMERIC[0];
 BEGIN
  OSVERSION(platform, major, minor, , , prType);
  RETURN (platform = osp_WinNT) &
         (major    = 6        ) &
         (minor    = 1        ) &
         (prType   = 1        );
 END {IsWindows7};

 PUBLIC PROCEDURE GetOSPlatform(): tOSPlatform;
  VAR
   platform: tOSPlatform;
 BEGIN
  OSVERSION(platform);
  RETURN platform;
 END {GetOSPlatform};

 PUBLIC PROCEDURE GetOSName(): STRING[];
  VAR
   platform: SCAL[4];
   csdver  : STRING[];
 BEGIN
  OSVERSION(platform, , , , csdver);
  IF platform = osp_WinNT THEN
   RETURN OSNAME() + " " + csdver;
  ELSE
   RETURN OSNAME();
  END;
 END {GetOSName};

 PUBLIC PROCEDURE Reg_Str_Setup(Path, WantedValue: STRING[]; CaseSensitive: SCAL[2]);
  VAR
   Value: STRING[];
 BEGIN
  IF (GetOSPlatform() >= osp_Win9x) &
     (~Reg.Read(Path, Value) |
     (~CaseSensitive & ~L_Str.IsEqStrI(Value, WantedValue)) |
     ( CaseSensitive & (Value # WantedValue))) THEN
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    Reg.Write(Path, WantedValue, "REG_SZ");
   EXCEPT
   ON Exc:Exc_RunTime DO
    IF (Exc.ErrorCode = 653) |
       (Exc.ErrorCode = 654) THEN
     Error("쪮  ⮣ | ࠢ  䨪樨 ॥ Windows");
    ELSE
     RAISE();
    END;
   ELSE
    RAISE();
   END; (* TRY *)
  END; (* IF *)
 END {Reg_Str_Setup};

 PUBLIC PROCEDURE Reg_DWord_Setup(Path, WantedValue: STRING[]);
  VAR
   Value,
   WantedValueNum: NUMERIC[0];
 BEGIN
  WantedValueNum:=L_Math.HexToDec(WantedValue);
  IF (GetOSPlatform() >= osp_Win9x) &
     (~Reg.Read(Path, Value) | (Value # WantedValueNum)) THEN
   TRY
    Reg.Write(Path, WantedValueNum, "REG_DWORD");
   EXCEPT
   ON Exc:Exc_RunTime DO
    IF (Exc.ErrorCode = 653) |
       (Exc.ErrorCode = 654) THEN
     Error("쪮  ⮣ | ࠢ  䨪樨 ॥ Windows");
    ELSE
     RAISE();
    END;
   ELSE
    RAISE();
   END; (* TRY *)
  END; (* IF *)
 END {Reg_DWord_Setup};

 (*!*) PUBLIC PROCEDURE SetIntvlByIntvl(VAR IntvlB, IntvlE: DATE);
 BEGIN
  IntvlB:=Memo.ud_fr();
  IntvlE:=Memo.ud_ut();
 END {SetIntvlByIntvl};

 (*!*) PUBLIC PROCEDURE SetIntvlByMonth(VAR IntvlB, IntvlE: DATE);
 BEGIN
  IntvlB:=Memo.tmp_mb();
  IntvlE:=Memo.tmp_me();
 END {SetIntvlByMonth};

 PUBLIC PROCEDURE Debug(Condition: SCAL[2]): SCAL[2];
 BEGIN
  IF ~IsOurEngineeringCopy() & ~APP.Get().SupportMode THEN
   intCallUs();
  END;
  RETURN Condition;
 END {Debug};

 PUBLIC PROCEDURE IsEndUser(): SCAL[2];
 BEGIN
  RETURN IsMemberOf(L_APtm.g_EndUser);
 END {IsEndUser};

 (*!*) PUBLIC PROCEDURE EMPTY_NUMBER(): FLOAT;
  VAR V: FLOAT;
 BEGIN SETEMPTY(V); RETURN V;
 END {EMPTY_NUMBER};

 (*!*) PUBLIC PROCEDURE EMPTY_DATE(): DATE;
  VAR V: DATE;
 BEGIN SETEMPTY(V); RETURN V;
 END {EMPTY_DATE};

 (*!*) PUBLIC PROCEDURE EMPTY_TIME(): TIME;
  VAR V: TIME;
 BEGIN SETEMPTY(V); RETURN V;
 END {EMPTY_DATE};

 (*!*) PUBLIC PROCEDURE EMPTY_PROC(): PROC;
  VAR V: PROC;
 BEGIN SETEMPTY(V); RETURN V;
 END {EMPTY_PROC};

 PRIVATE PROCEDURE GetREDISTRPath(): STRING[];
  VAR
   MaxLength,
   Result             : NUMERIC[0];
   Paths,
   REDISTRPath,
   ClientASBRoot,
   ASBProcessorRunFrom: STRING[];
 BEGIN
(*   ࠧ - /⢨   "\", BuildPath  "\"   *)
  ASBProcessorRunFrom:=FIO.BuildPath("", , FIO.AsbSpecialFolders("ASBProcessorRunFrom"));
  ClientASBRoot      :=FIO.BuildPath("", , FIO.AsbSpecialFolders("ClientASBRoot"));
  IF (RTI.Get().TryBlock.MSG_SUPPRESSION = MSG_SUPPRESSION_NONE) &
     ~!ClientASBRoot &
     ~L_Str.IsEqStrI(ClientASBRoot, ASBProcessorRunFrom) &
     IsProgrammer() THEN
   MaxLength:=Math.Max(Str.Length(ASBProcessorRunFrom), Str.Length(ClientASBRoot));
   Paths    :="ASBProcessorRunFrom " + Str.Align(ASBProcessorRunFrom, MaxLength, LEFT) + "|" +
              "ClientASBRoot       " + Str.Align(ClientASBRoot,       MaxLength, LEFT);
   Result:=0;
   STDFORM("| ⠫ ASBProcessorRunFrom  ClientASBRoot|" +
           "|%,2<" + Paths + ">O|||"+
           L_StdFrm.DrawButton("⬥",  10, "X") + "  " +
           L_StdFrm.DrawButton("믮", 13, "DB"),
           " 롮 ⠫  ࠡ ",
           ,
           1,
           Result);
   IF Result = 0 THEN
    REDISTRPath:=ASBProcessorRunFrom;
   ELSE
    REDISTRPath:=ClientASBRoot;
   END;
  ELSE
   REDISTRPath:=ASBProcessorRunFrom;
  END;
  RETURN FIO.BuildPath("REDISTR", , REDISTRPath);
 END {GetREDISTRPath};

 PUBLIC PROCEDURE GetREDISTRFullPath(FileName: STRING[]): STRING[];
 BEGIN
  RETURN FIO.BuildPath(FileName, , GetREDISTRPath());
 END {GetREDISTRFullPath};

 PRIVATE PROCEDURE GetExecPrgPath(VAR ExecPrgPath: tExecutablePrgPath);
 BEGIN
  ExecPrgPath[ept_Internal]      :=FIO.AsbSpecialFolders("ASBProcessorRunFrom");
  ExecPrgPath[ept_Standart]      :=GetREDISTRPath();
  ExecPrgPath[ept_Special]       :="";
  ExecPrgPath[ept_ForInternalUse]:="G:\BAT_UTIL";
 END {GetExecPrgPath};

 PRIVATE PROCEDURE RunEP(wUseShell          : SCAL[2];
                         ep_Type            : tExecutablePrgType;
                         ep_Name,
                         ep_Params,
                         ep_WorkingDirectory: STRING[];
                         WindowStyle        : NUMERIC[0];
                         Wait               : NUMERIC[0];
                         AllowedRCs         : NUMERIC[0][];
                         wUseCmd            : SCAL[2]): NUMERIC[0];
  CONST
   ws_Pool = "|Restored||Maximized||||Minimized";
  VAR
   WShell          : OBJECT;
   ReturnCode      : NUMERIC[0];
   CmdName,
   Command,
   ErrorDescription: STRING[];
   i               : NUMERIC[0];
   ExecPrgPath     : tExecutablePrgPath;
 BEGIN
  GetExecPrgPath(ExecPrgPath);
  Command         :=FIO.BuildPath(ep_Name, , ExecPrgPath[ep_Type]);
  IF wUseCmd THEN
   IF GetOSPlatform() = osp_WinNT THEN
    CmdName:="cmd";
   ELSE
    CmdName:="command";
   END;
   ep_Params:=" /c" + " " + Command + " " + ep_Params;
   Command  :=CmdName;
  END;
  ErrorDescription:="";
  IF wUseShell THEN
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    ReturnCode:=Shell.Execute(, Command, ep_Params, ep_WorkingDirectory, L_Str.AnyItem(ws_Pool, "|", WindowStyle), Wait);
   EXCEPT
   ON Exc: Exc_RunTime DO
    ReturnCode      :=-1;
    ErrorDescription:=Exc.MsgOriginalText;
   END; (* TRY *)
  ELSE
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    WShell    :=CreateOBJECT("WScript.Shell");
    ReturnCode:=WShell.Run(Command + " " + ep_Params, WindowStyle, -1);
   EXCEPT
   ON Exc: Exc_Object DO
    ReturnCode      :=-1;
    ErrorDescription:=Exc.MsgOriginalText;
   END; (* TRY *)
  END;
  i:=0;
  WHILE i <= HIGH(AllowedRCs) DO
   IF ReturnCode = AllowedRCs[i] THEN
    RETURN ReturnCode;
   END;
   INC(i);
  END;
  L_StdFrm.RedInform("㤠筮 믮 譥 ணࠬ|" +
                     Command + "| " +
                     "訡: " + L_Str.IntStr(ReturnCode) + " " + ErrorDescription);
  RETURN ReturnCode;
 END {RunEP};

 PUBLIC PROCEDURE extExecEP(ep_Type            : tExecutablePrgType;
                            ep_Name,
                            ep_Params,
                            ep_WorkingDirectory: STRING[];
                            WindowStyle        : NUMERIC[0];
                            Wait               : NUMERIC[0];
                            AllowedRCs         : NUMERIC[0][];
                            wUseCmd            : SCAL[2]): NUMERIC[0];
 BEGIN
  RETURN RunEP(1, ep_Type, ep_Name, ep_Params, ep_WorkingDirectory, WindowStyle, Wait, AllowedRCs, wUseCmd);
 END {extExecEP};

 PUBLIC PROCEDURE ExecEP(ep_Type            : tExecutablePrgType;
                         ep_Name,
                         ep_Params,
                         ep_WorkingDirectory: STRING[];
                         WindowStyle        : NUMERIC[0];
                         Wait               : NUMERIC[0];
                         AllowedRCs         : NUMERIC[0][]): NUMERIC[0];
 BEGIN
  RETURN extExecEP(ep_Type, ep_Name, ep_Params, ep_WorkingDirectory, WindowStyle, Wait, AllowedRCs, 0);
 END {ExecEP};

 PUBLIC PROCEDURE extLaunchEP(ep_Type    : tExecutablePrgType;
                              ep_Name,
                              ep_Params  : STRING[];
                              WindowStyle: NUMERIC[0];
                              AllowedRCs : NUMERIC[0][];
                              wUseCmd    : SCAL[2]): NUMERIC[0];
 BEGIN
  RETURN RunEP(1, ep_Type, ep_Name, ep_Params, "",                  WindowStyle, 1,    AllowedRCs, wUseCmd);
 END {extLaunchEP};

 PUBLIC PROCEDURE LaunchEP(ep_Type    : tExecutablePrgType;
                           ep_Name,
                           ep_Params  : STRING[];
                           WindowStyle: NUMERIC[0];
                           AllowedRCs : NUMERIC[0][]): NUMERIC[0];
 BEGIN
  RETURN extLaunchEP(ep_Type, ep_Name, ep_Params, WindowStyle, AllowedRCs, 0);
 END {LaunchEP};

 PRIVATE PROCEDURE CondUpdateArchiver(ArchiverFileName: STRING[]): STRING[];
  VAR
   dst_ArchiverFolder,
   dst_ArchiverFullFileName,
   src_ArchiverFullFileName: STRING[];
 BEGIN
  src_ArchiverFullFileName:=GetREDISTRFullPath(ArchiverFileName);

  dst_ArchiverFolder:=FIO.BuildPath("ASBClient\REDISTR", , Shell.SpecialFolders("AppData"));
  L_FIO.MakeSubDirs(dst_ArchiverFolder);
  dst_ArchiverFullFileName:=FIO.BuildPath(ArchiverFileName, , dst_ArchiverFolder);

  IF ~L_FIO.ext_IsEqualFiles(dst_ArchiverFullFileName, src_ArchiverFullFileName) THEN
   FIO.Erase(dst_ArchiverFullFileName);
   L_FIO.ExactFileCopy(src_ArchiverFullFileName, dst_ArchiverFullFileName);
  END;

  RETURN dst_ArchiverFullFileName;
 END {CondUpdateArchiver};

 PUBLIC PROCEDURE Launch_PKZIP(ep_Params, SrcFileName, ArchFileName: STRING[]): NUMERIC[0];
  CONST
   PkZipFileName = "pkzipc.exe";
  VAR
   PkZipFullFileName: STRING[];
 BEGIN
  PkZipFullFileName:=CondUpdateArchiver(PkZipFileName);
  RETURN LaunchEP(ept_Special,
                  PkZipFullFileName,
                  ep_Params + ' -Temp=' + FIO.AsbSpecialFolders("ASBTemp") +
                  ' "' + ArchFileName + '" "' + SrcFileName + '"',
                  ws_Minimized,
                  eprc_Normal);
 END {Launch_PKZIP};

 PUBLIC PROCEDURE Launch_PKUNZIP(ep_Params, ArchFileName, dstFolder: STRING[]): NUMERIC[0];
 BEGIN
  RETURN Launch_PKZIP('-ext -times=modify ' + ep_Params, dstFolder, ArchFileName);
 END {Launch_PKUNZIP};

 PUBLIC PROCEDURE Extract_7z(ep_Params, ArchFileName, dstFolder: STRING[]): NUMERIC[0];
  CONST
   z7FileName = "7za.exe";
  VAR
   z7FullFileName: STRING[];
 BEGIN
  APP.Get().NewPrompt("ᯠ " + ArchFileName);
  z7FullFileName:=CondUpdateArchiver(z7FileName);
  RETURN LaunchEP(ept_Special,
                  z7FullFileName,
                  "e " + ArchFileName + " -o" + dstFolder + " " + ep_Params,
                  ws_Minimized,
                  eprc_Normal);
 END {Extract_7z};

 PUBLIC PROCEDURE SetupRequired();
  VAR
   Point: CALL_STACK_CELL;
 BEGIN
  Point:= RTI.Get().Stack(1);
  InformUs("楤 " + Point.Proc.FullName + "  ஥");
 END {SetupRequired};

 PUBLIC PROCEDURE IsAcceptableProcessorVersion(ProcessorVersion: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN DBD.ProcessorVersion() >= ProcessorVersion;
 END {IsAcceptableProcessorVersion};

 PUBLIC PROCEDURE SetSoftAccessDataModeForInteractiveModification();
 BEGIN
  IF (IsOurEngineeringCopy() | IsPolakSpecific()) THEN
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  END;
 END {SetSoftAccessDataModeForInteractiveModification};

 PUBLIC PROCEDURE SetConcurrentMode();
 BEGIN
  TABLE.Get("MathMty" ).AccessDataMode:=adm_CONCURRENT;
  TABLE.Get("MathRun" ).AccessDataMode:=adm_CONCURRENT;
  TABLE.Get("Money"   ).AccessDataMode:=adm_CONCURRENT;
  TABLE.Get("MoneyDst").AccessDataMode:=adm_CONCURRENT;
  TABLE.Get("Monthly" ).AccessDataMode:=adm_CONCURRENT;
  TABLE.Get("MonthRt" ).AccessDataMode:=adm_CONCURRENT;
  TABLE.Get("PCalc"   ).AccessDataMode:=adm_CONCURRENT;
  TABLE.Get("XODone"  ).AccessDataMode:=adm_CONCURRENT;
  TABLE.Get("XCalc"   ).AccessDataMode:=adm_CONCURRENT;
  TABLE.Get("XApport" ).AccessDataMode:=adm_CONCURRENT;
  TABLE.Get("XDocApr" ).AccessDataMode:=adm_RIDGE;
 END {SetConcurrentMode};

 PUBLIC PROCEDURE SetCacheables(a: STRING[][]);
  VAR
   f: STRING[];
   t: TABLE;
 BEGIN
IF IsAcceptableProcessorVersion(14260140) THEN
  FOR_EACH f IN a DO
   IF !f THEN
    EXIT;
   END;
   TABLE.Get(f).Cacheable:=TABLE.Cacheable_TRY;
  END; (* FOR_EACH f *)
  IF RTI.Get().TryBlock.AccessDataMode # adm_SOFT THEN
   RTI.Get().TryBlock.Set_adm_SOFT_4_Cacheables();
  END; (* IF RTI.Get().TryBlock.AccessDataMode # adm_SOFT *)
END;
 END {SetCacheables};

 PUBLIC PROCEDURE DoConcurrentModification(): SCAL[2];
 BEGIN
  RETURN TABLE.Get("XApport" ).AccessDataMode = adm_CONCURRENT;
 END {DoConcurrentModification};

 PUBLIC PROCEDURE NeedExecuteArchaicCode(D, BoundDate: DATE): SCAL[2];
 BEGIN
  RETURN D < BoundDate;
 END {NeedExecuteArchaicCode};

 PUBLIC PROCEDURE GetModuleType_asStr(MD: tModuleType): STRING[];
  CONST
   ModuleTypePool = "ASL|FRM|WDO|MNU|DBS";
 BEGIN
  RETURN L_Str.PoolItem(ModuleTypePool, MD);
 END {GetModuleType_asStr};

 PUBLIC PROCEDURE ChooseModule(ModuleType: tModuleType): STRING[];
  VAR
   _FName,
   ModuleType_AsStr: STRING[];
 BEGIN
  ModuleType_AsStr:=GetModuleType_asStr(ModuleType);
  IF ISPROGRAMMER() | SessionIsUnderExclusiveRemoteControl() THEN
   _FName:=FIO.ChooseFile("*." + ModuleType_AsStr);
  ELSE
   _FName:=FIO.ChooseFile(ModuleType_AsStr + "\BY_USER\" + "*." + ModuleType_AsStr);
  END;
  IF !_FName THEN
   HALT();
  END;
  RETURN _FName;
 END {ChooseModule};

 PUBLIC PROCEDURE EditModule(ModuleName: STRING[]; ModuleType: tModuleType);
  VAR
   Dummy,
   FullPath,
   FolderName,
   EditorRunKeys: STRING[];
 BEGIN
  IF !ModuleName THEN
   ModuleName:=ChooseModule(ModuleType);
  ELSE
   Assert(FIO.Exists(ModuleName, GetModuleType_asStr(ModuleType), ModuleName), " " + ModuleName + "  ");
  END;

  IF ~IsOurEngineeringCopy() THEN
   FullPath:=L_FIO.effp_Folder(ModuleName);
   IF L_Str.Right(FullPath, 1) = "\" THEN
    FullPath:=L_Str.Left(FullPath, Str.Length(FullPath) - 1);
   END;
   FIO.SplitPath(FullPath, FolderName, Dummy, Dummy);

   IF    (Str.Cap(FolderName) = "BY_USER") THEN
    EditorRunKeys:="";
   ELSIF APP.Get().SupportMode & IsAPSupportFolder(FullPath) THEN
    EditorRunKeys:="";
   ELSIF (Str.Cap(FolderName) = "TOOLS") & ISPROGRAMMER() THEN
    EditorRunKeys:="";
   ELSE
    EditorRunKeys:=" -V";
   END;
  ELSE
   EditorRunKeys:="";
  END;

  IF ModuleType = mt_WDO THEN
   LIKEMENU(ExecAsb, "WED.EXE " + ModuleName + " /B:" + DATABASE.Get().Name + EditorRunKeys);
  ELSE
   LIKEMENU(EditText, ModuleName + EditorRunKeys);
  END;
 END {EditModule};

 PUBLIC PROCEDURE IsAcceptableProjectId(ProjectId: tProjectId): SCAL[2];
 BEGIN
  RETURN Str.Cap(GetProjectId()) = Str.Cap(ProjectId);
 END {IsAcceptableProjectId};

 PUBLIC PROCEDURE DisableDebuggerExceptionBreak();
 BEGIN
  SE_EXCEPTIONHANDLING(0);
 END {DisableDebuggerExceptionBreak};

(*! ࠢ  ࠬ⭮ VariableIsInitialized*)
 PUBLIC PROCEDURE VariableIsInitializing(VAR Variable: VARIANT): SCAL[2];
 BEGIN
  RETURN VariableIsInitialized(Variable);
 END {VariableIsInitializing};

 (*!*) PUBLIC PROCEDURE VariableIsInitialized(VAR Variable: VARIANT): SCAL[2];
 BEGIN
  RETURN VAR_IMPL.Get(Variable).Initialized;
 END {VariableIsInitialized};

 PUBLIC PROCEDURE OBJECTIsInitialized(VAR Obj: OBJECT): SCAL[2];
 BEGIN
  RETURN VAR_IMPL.Get(Obj).Initialized;
 END {OBJECTIsInitialized};

 PUBLIC PROCEDURE InitArray(VAR Result: ANYTYPE[]; Value: ANYTYPE);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(Result) DO
   Result[i]:=Value;
   INC(i);
  END;
 END {InitArray};

 PRIVATE CONST
  LockReleaseRaiseErrorCode   = -100;
  LockReleaseRaiseDescription = ", ᮮ ࠡ稪 ᫥饥" +
                                  L_Str.CRLF +
                                  L_Str.CRLF +
                                 "'ࠡ⠭ ᪫祭   ஢'";

 (*old*)PUBLIC PROCEDURE RaiseLockReleaseException();
 BEGIN
  RAISE(LockReleaseRaiseErrorCode, LockReleaseRaiseDescription);
 END {RaiseLockReleaseException};

 (*old*)PUBLIC PROCEDURE IsLockReleaseException(Exc: Exc_Root): SCAL[2];
 BEGIN
  RETURN (Exc.Class = "Exc_Raise") &
         (Exc.ErrorCode = LockReleaseRaiseErrorCode) &
         (Exc.MsgOriginalText = LockReleaseRaiseDescription);
 END {IsLockReleaseException};

 (*old*)PUBLIC PROCEDURE CheckIsLockReleaseException(Exc: Exc_Root);
 BEGIN
  IF ~IsLockReleaseException(Exc) THEN
   RAISE();
  END;
 END {CheckIsLockReleaseException};

 PUBLIC PROCEDURE IsUniquenessViolationException(Exc: Exc_Root): SCAL[2];
 BEGIN
  RETURN (Exc.ErrorCode = ec_rt_UniquenessViolation) |
         (Exc.ErrorCode = ec_rt_HiddenUniquenessViolation);
 END {IsUniquenessViolationException};

 PUBLIC PROCEDURE ExcDescription(Exc: Exc_Root): STRING[];
 BEGIN
  RETURN Exc.Class+" "+L_Str.IntStr(Exc.ErrorCode)+" "+Exc.MsgOriginalText+
         " ["+Exc.ProgramFile+" "+L_Str.IntStr(Exc.Row)+" "+L_Str.IntStr(Exc.Column)+"]";
 END {ExcDescription};

 PUBLIC PROCEDURE CLEAR(trgFile: STRING[]);
 BEGIN
  SETSEL(^trgFile, ^(TABLE.Get(trgFile).Indexes(0).Name));
 END {CLEAR};

 PUBLIC PROCEDURE GetProcessEnvVar(VarName: STRING[]): STRING[];
  VAR
   oShell : OBJECT;
   oSysEnv: OBJECT;
 BEGIN
  oShell :=CreateOBJECT("WScript.Shell");
  oSysEnv:=oShell.Environment("PROCESS");
  RETURN oSysEnv.Item(VarName);
 END {GetProcessEnvVar};

 PUBLIC PROCEDURE IsTSSession(): SCAL[2];
  VAR
   oAppl: APPLICATION;
 BEGIN
  oAppl:=APPLICATION.Get();
  RETURN oAppl.MyConnection.WTSRemoteSession;
 END {IsTSSession};

 PUBLIC PROCEDURE RidgeExecute(CurrentFile: STRING[]; Proc: PROC; Mode: tRidgeExecuteMode);
  VAR
   re_Transaction,
   re_MsgSuppression,
   re_AbortAfter      : NUMERIC[0];
 BEGIN
  IF    Mode = rem_Isolated THEN
   re_Transaction   :=TRANSACTION_SLAVE;
   re_MsgSuppression:=MSGSUPPRESS_ALL;
   re_AbortAfter    :=AA_OFF;
  ELSIF Mode = rem_SameTRN  THEN
   re_Transaction   :=TRANSACTION_CURRENT;
   re_MsgSuppression:=MSGSUPPRESS_ALL;
   re_AbortAfter    :=AA_OFF;
  ELSIF Mode = rem_Discard  THEN
   re_Transaction   :=TRANSACTION_CURRENT;
   re_MsgSuppression:=MSGSUPPRESS_NONE;
   re_AbortAfter    :=AA_ON;
  END;
  TRY [TRANSACTION(re_Transaction), MSG_SUPPRESSION(re_MsgSuppression), RESTORE_CURSORS(RC_ON), ABORT_AFTER(re_AbortAfter)]
   GETLASTVERSION(^CurrentFile);
   RTI.Get().TryBlock.AccessDataMode:=adm_RIDGE;
   SetCacheables("");
   Proc();
  EXCEPT
  END; (* TRY *)
 END {RidgeExecute};

 PUBLIC PROCEDURE TellThisReportIsToRemoveCandidate(Till: DATE);
 BEGIN
  Assert(SYSDATE() < Till, "  ५");
  L_StdFrm.Question("  ५  㤥 ࠡ  " + L_DatTim.DateStr(Till) +
                    ".||᫨    㦥,|᫥ ஡  ," +
                    "|   祣  ᯮ  .");
 END {TellThisReportIsToRemoveCandidate};

 PUBLIC PROCEDURE TellTemporaryInform(Msg: STRING[]; Till: DATE);
 BEGIN
  IF SYSDATE() < Till THEN
   L_StdFrm.TimedINFORM(Msg, 10);
  END;
 END {TellTemporaryInform};

 PRIVATE PROCEDURE Halt(Exc: Exc_Root);
 BEGIN
  IF ~!Exc THEN
   IF IsProgrammer() & (GET_TYPE_SPEC_OF_INSTANCE(Exc).IsDerivedFrom(GET_TYPE_SPEC(Exc_Syntax )) |
                        GET_TYPE_SPEC_OF_INSTANCE(Exc).IsDerivedFrom(GET_TYPE_SPEC(Exc_RunTime))) THEN
    RAISE();
   ELSE
    IF Exc.HasDeferredMsg THEN
     L_StdFrm.RedInform(Exc.MsgOriginalText);
    END;
    HALT();
   END;
  ELSE
   HALT();
  END;
 END {Halt};

 PUBLIC PROCEDURE SurveyLastReport();
 BEGIN
  IF ~BatchExecution_IsRunning() & ~KioskExecution_IsRunning() THEN
   LIKEMENU(Survey, "");
  END;
 END {SurveyLastReport};

 PUBLIC PROCEDURE HaltAndSurveyLastReport(Exc: Exc_Root);
 BEGIN
  CALL(CallStub.c_SurveyLastReport());
  Halt(Exc);
 END {HaltAndSurveyLastReport};

 PUBLIC PROCEDURE BrowseLastReport();
 BEGIN
  CALL(CallStub.c_sl_Done());
 END {BrowseLastReport};

 PUBLIC PROCEDURE HaltAndBrowseLastReport(Exc: Exc_Root);
 BEGIN
  BrowseLastReport();
  Halt(Exc);
 END {HaltAndBrowseLastReport};

 PUBLIC PROCEDURE GetCurWinMasterTable(): STRING[];
  VAR
   CurZone: FORM_ZONE;
 BEGIN
  CurZone:=RTI.Get().CurZone;
  Assert(~!CurZone & ~!CurZone.MasterTable, "  ⥪ 믮 樨 ");
  RETURN CurZone.MasterTable.Name;
 END {GetCurWinMasterTable};

 PUBLIC PROCEDURE SetProportionalFontFace(trgProportionalFontFace: STRING[]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   APP.Get().ProportionalFontFace:=trgProportionalFontFace;
   Result:=1;
  EXCEPT
  ON Exc: Exc_Root DO
   IF Exc.ErrorCode = 747 THEN
    Result:=0;
   ELSE
    RAISE();
   END;
  END; (* TRY *)
  RETURN Result;
 END {SetProportionalFontFace};

 PUBLIC PROCEDURE iri_Pack(fi: tFileId; ri: tRecordId): tInternalRecordId;
 BEGIN
  RETURN ""+fi+ri;
 END {iri_Pack};

 PUBLIC PROCEDURE iri_GetCurrent(File: STRING[]): tInternalRecordId;
 BEGIN
  RETURN iri_Pack(TABLE.Get(File).Id, ^(File).RECORDID);
 END {iri_GetCurrent};

 PUBLIC PROCEDURE iri_fi(iri: tInternalRecordId): tFileId;
 BEGIN
  RETURN Str.Slice(iri, 0, FieldIdLen);
 END {iri_fi};

 PUBLIC PROCEDURE iri_ri(iri: tInternalRecordId): tRecordId;
 BEGIN
  RETURN Str.Slice(iri, FieldIdLen+1, RecordIdLen);
 END {iri_ri};

END.
