(*
%Copyright   (c) Polak Computer System
%Author      03.06.2010 09:43:14 POLAK\MLB
%Purpose      ࠡ  Group
%Type        library
%Specific    SYS
%Modified    27.05.2013 16:46:12 POLAK\MLB
%Environment
*)

 IMPORT Memo, Str, L_General, L_Way, L_DBD, L_Str, DBD, L_DatTim, L_APtm, L_SysLog, E_Way,
        L_Prop, P_Route;

 PUBLIC CONST
  pool_erknName = "  ॢ" +
                  "| 䨭஢  ॢ" +
                  "| 㯯 =    ⭮襭" +
                  "| 㯯 ப " +
                  "|㯯 ப    " +
                  "|㯯 ப    室 " +
                  "|㯯 ப     " +
                  "|㯯 ப     ⮯" +
                  "|㯯 ப   䠬   ॢ" +
                  "|㯯 ப   ஢ ய⨩" +
                  "|㯯 ப   ᢥન  " +
                  "|㯯 ப   ६ " +
                  "|㯯 ப   ᮢ⨬   ப " +
                  "|㯯 ப    ᪠  ࠢ" +
                  "|㯯 ப     " +
                  "|㯯 ப   楫  ᥡ⮨" +
                  "|㯯 ⮢ (᢮⢮ 5023)";

  erkn_Amount   = 17;

  erkn_TKind_Rgn              = 0; (* ERKN.Notion *)
  erkn_TKind_FnMode           = 1;
  erkn_1Group_1OwnRec         = 2;

  erkn_Mark_WagePay           = 3;
  erkn_Mark_TEP               = 4;
  erkn_Mark_Math              = 5;
  erkn_Mark_Loss              = 6;
  erkn_Mark_Fuel              = 7;
  erkn_Mark_OrderIncome       = 8;
  erkn_Mark_REPlan            = 9;
  erkn_Mark_Revise_wRDO       = 10;
  erkn_Mark_RprJobBaseTime    = 11;
  erkn_Mark_MathCompatibility = 12;
  erkn_Mark_AccessDriving     = 13;
  erkn_Mark_KIPandKTG         = 14;
  erkn_Mark_CostAccounting    = 15;

  erkn_Route_P_Group          = 16;

 PRIVATE CONST
  dummyBegin    = 01\01\1900;

 PRIVATE PROCEDURE int_erkn_Get(D        : DATE;
                                Owner    : STRING[];
                                trgNotion: L_APtm.tNotion;
                                Strong   : SCAL[2]): LIKE(GroupT.GroupT);
  VAR
   Msg   : STRING[];
   Result: LIKE(GroupT.GroupT);
 BEGIN
  SAVE(GroupT);
  SETEMPTY(Result);
  L_APtm.AccessERKN("GroupT", trgNotion);
  IF trgNotion = erkn_1Group_1OwnRec THEN
   L_General.CallUs(~!Owner);
   SELECT(GroupT, Owner, , TABLE.Get(Owner).Id, ERKN.ERKN);
   Msg:="| 䠩 " + TABLE.Get(Owner).Name + ' "' + TABLE.Get(Owner).Description + '"';
  ELSE
   SELECT(GroupT, ERKN, , ERKN.ERKN);
   SETEMPTY(Msg);
  END;
  WHILE OCCURE(GroupT) DO
   IF L_DatTim.IsActive(D, GroupT.Begin, GroupT.Till) THEN
    IF ~!Result THEN
     L_APtm.SearchByERKNError("   (" + Result + ", " + GroupT.GroupT + ") ⨯ 㯯  祭" +
                              '|"' + ERKN.Name + '"' + Msg);
    END;
    Result:=GroupT.GroupT;
   END;
   NEXT(GroupT);
  END; (* OCCURE(GroupT) ... *)
  IF Strong & !Result THEN
   L_APtm.SearchByERKNError('   ⨯ 㯯  祭|"' + ERKN.Name + '"' + Msg);
  END;
  RESTORE(GroupT);
  RETURN Result;
 END {int_erkn_Get};

 PUBLIC PROCEDURE erkn_GetSoft(D: DATE; Owner: STRING[]; trgNotion: L_APtm.tNotion): LIKE(GroupT.GroupT);
 BEGIN
  RETURN int_erkn_Get(D, Owner, trgNotion, 0)
 END {erkn_GetSoft};

 PUBLIC PROCEDURE erkn_Get(D: DATE; Owner: STRING[]; trgNotion: L_APtm.tNotion): LIKE(GroupT.GroupT);
 BEGIN
  RETURN int_erkn_Get(D, Owner, trgNotion, 1)
 END {erkn_Get};

 PUBLIC PROCEDURE GetCurrentGroupTNotion(): LIKE(ERKN.Notion);
  VAR
   Result: LIKE(ERKN.Notion);
 BEGIN
  IF ~!GroupT.ERKN THEN
   CONFORM(GroupT, ERKN);
   Result:=ERKN.Notion;
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetCurrentGroupTNotion};

 PUBLIC PROCEDURE IsNotionBasedOnScalVal(trgNotion: LIKE(ERKN.Notion)): SCAL[2];
 BEGIN
  RETURN (trgNotion = erkn_TKind_Rgn) | (trgNotion = erkn_TKind_FnMode);
 END {IsNotionBasedOnScalVal};

 PUBLIC PROCEDURE IsAutoBuildGroupT(): SCAL[2];
  VAR
   trgNotion: LIKE(ERKN.Notion);
 BEGIN
  trgNotion:=GetCurrentGroupTNotion();
  RETURN IsNotionBasedOnScalVal(trgNotion) |
         (trgNotion = erkn_1Group_1OwnRec) |
         ~!GetPropFileNameByNotion(trgNotion);
 END {IsAutoBuildGroupT};

 PUBLIC PROCEDURE IsProgrammerBuildGroupT(): SCAL[2];
  VAR
   Local  : PROC;
   Result : SCAL[2];
 BEGIN
  Result:=~!GroupT.ERKN;

  IF ~Result THEN
   Local:=PROCREF(E_Way.MarkGT2GroupT);
   IF ~!Local THEN
    SELECT(MarkGT, MarkGT);
    WHILE OCCURE(MarkGT) & ~Result DO
     Result:=(Local() = GroupT.GroupT);
     NEXT(MarkGT);
    END; (* WHILE OCCURE(MarkGT) ... *)
   END;
  END;

  RETURN Result;
 END {IsProgrammerBuildGroupT};

 PUBLIC PROCEDURE GetFatedNotionInfo(Notion        : LIKE(ERKN.Notion);
                                     VAR FileName  : STRING[];
                                     VAR FieldName : STRING[];
                                     VAR Pool      : STRING[]);
 BEGIN
  IF    Notion = erkn_TKind_Rgn THEN
   FileName := "TKind";
   FieldName:= "Rgn";
   Pool     := L_Way.tkrgn_Pool;
  ELSIF Notion = erkn_TKind_FnMode THEN
   FileName := "TKind";
   FieldName:= "FnMode";
   Pool     := L_Way.tkfnm_Pool;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetFatedNotionInfo};

 PUBLIC PROCEDURE GroupTCanBeCreatedFromThisFile(FileId: LIKE(dbFile.dbFile)): SCAL[2];
  VAR
   FileName: STRING[];
   Result  : SCAL[2];
 BEGIN
  FileName:=DBD.FileIdToName(FileId);
  Result:=0;
  IF (FileName = "ODocKind") | (FileName = "PDocKind") | (FileName = "TKind") |
     (FileName = "Mark")     | (FileName = "Route")                           THEN
   Result:=1;
  END;
  RETURN Result;
 END {GroupTCanBeCreatedFromThisFile};

 PUBLIC PROCEDURE GetPropFileNameByNotion(trgNotion: LIKE(ERKN.Notion)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF trgNotion = erkn_Route_P_Group THEN
   Result:="RoutePro";
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetPropFileNameByNotion};

 PRIVATE PROCEDURE GetNotionOfSupportedProperty(VAR FileName: STRING[]): LIKE(ERKN.Notion);
  VAR
   Result: LIKE(ERKN.Notion);
 BEGIN
  IF (FileName = "RoutePro") & (^(FileName + ".Property") = P_Route.P_Group) THEN
   CONFORM(RoutePro, Route);
   FileName:="Route";
   Result:=erkn_Route_P_Group;
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetNotionOfSupportedProperty};

 PUBLIC PROCEDURE InsertGroupT(trgName : LIKE(GroupT.Name);
                               trgOwner: LIKE(GroupT.Owner);
                               trgERKN : LIKE(ERKN.ERKN));
 BEGIN
  SETEMPTY(GroupT.GroupT, GroupT.Till);
  GroupT.Name :=trgName;
  GroupT.Owner:=trgOwner;
  GroupT.ERKN :=trgERKN;
  GroupT.Begin:=dummyBegin;
  INSERT(GroupT);
 END {InsertGroupT};

 PRIVATE PROCEDURE InsertGroup(trgScalVal: LIKE(Group.ScalVal);
                               trgGroupN : LIKE(Group.Name));
 BEGIN
  DEFAULT(Group);
  Group.Begin  :=dummyBegin;
  Group.ScalVal:=trgScalVal;
  Group.Name   :=trgGroupN;
  Group.Owner  :=GroupT.Owner;
  Group.GroupT :=GroupT.GroupT;
  INSERT(Group);
 END {InsertGroup};

 PRIVATE PROCEDURE RenovateCurrentGroupE();
  VAR
   BegField,
   TillField,
   OwnerName,
   PropFile : STRING[];
 BEGIN
  OwnerName:=DBD.FileIdToName(GroupE.Owner);
  GroupE.CodeOwn:=L_Str.Right(^(L_DBD.GetFieldName(OwnerName, OwnerName)),  Str.MaxLength(GroupE.CodeOwn));
  GroupE.NameOwn:=^(L_DBD.GetFieldName(OwnerName, "Name"));
  PropFile:=GetPropFileNameByNotion(GetCurrentGroupTNotion());
  IF ~!PropFile THEN
   OwnerName:=PropFile;
  END;
  L_DBD.CollateValidityFieldNames(OwnerName, BegField, TillField);
  IF ~!BegField & ~!TillField THEN
   GroupE.Begin:=^(L_DBD.GetFieldName(OwnerName, BegField));
   GroupE.Till :=^(L_DBD.GetFieldName(OwnerName, TillField));
  ELSE
   SETEMPTY(GroupE.Begin, GroupE.Till)
  END;
  IF !GroupE.Begin THEN
   GroupE.Begin:=dummyBegin;
  END;
  REPLACE(GroupE);
  SAVE(GroupT);
  SAVE(Group);
  CONFORM(GroupE, Group, GroupT);
  IF GetCurrentGroupTNotion() = erkn_1Group_1OwnRec THEN
   Group.Name:=GroupE.NameOwn;
   REPLACE(Group);
  END;
  RESTORE(Group);
  RESTORE(GroupT);
 END {RenovateCurrentGroupE};

 PUBLIC PROCEDURE StandOnGroup(trgGroup: LIKE(Group.Group));
 BEGIN
  L_General.CallUs(~!trgGroup);
  L_General.CallUs(SEARCH(Group, Group, trgGroup));
 END {StandOnGroup};

 PRIVATE PROCEDURE DeleteGroupE(trg_riOwner: LIKE(GroupE.riOwner);
                                trgBegDate: DATE);
  VAR
   GroupIsRemoved: SCAL[2];
 BEGIN
  SELECT(Group, GroupT, , GroupT.GroupT);
  WHILE OCCURE(Group) DO
   GroupIsRemoved:=0;
   IF SELECT(GroupE, GriO, Group.Group, trg_riOwner) &
      (!trgBegDate | SRCINSEL(GroupE, EQ, trgBegDate)) THEN
    TRY
     SE_INTEGRITY(1);
     REMOVE(GroupE);
     IF IsAutoBuildGroupT() THEN
      IF ~SELECT(GroupE, Group, Group.Group) THEN
       REMOVE(Group);
       GroupIsRemoved:=1;
      END;
     END; (* IF IsAutoBuildGroupT() *)
    EXCEPT
    END; (* TRY *)
   END; (* IF SELECT ... *)
   IF ~GroupIsRemoved THEN
    NEXT(Group);
   END;
  END; (* WHILE OCCURE(Group) ... *)
 END {DeleteGroupE};

 PRIVATE PROCEDURE InsertGroupE(trg_riOwner: LIKE(GroupE.riOwner);
                                trgScalVal : LIKE(Group.ScalVal);
                                trgGroupN  : LIKE(Group.Name));
  VAR
   GroupExists: SCAL[2];
 BEGIN
  IF IsNotionBasedOnScalVal(GetCurrentGroupTNotion()) THEN
   GroupExists:=SELECT(Group, GrTScalV, GroupT.GroupT, trgScalVal);
  ELSIF GetCurrentGroupTNotion() = erkn_1Group_1OwnRec THEN
   GroupExists:=0;
  ELSE
   GroupExists:=SELECT(Group, GrTName, GroupT.GroupT, trgGroupN);
  END;
  IF ~GroupExists THEN
   InsertGroup(trgScalVal, trgGroupN);
  END;
  DEFAULT(GroupE);
  GroupE.Group  :=Group.Group;
  GroupE.Owner  :=Group.Owner;
  GroupE.riOwner:=trg_riOwner;
  INSERT(GroupE);
  RenovateCurrentGroupE();
 END {InsertGroupE};

 PRIVATE PROCEDURE RenovateGroupE(trg_riOwner: LIKE(GroupE.riOwner);
                                  trgBegDate: DATE);
 BEGIN
  SELECT(Group, GroupT, , GroupT.GroupT);
  WHILE OCCURE(Group) DO
   IF SELECT(GroupE, GriO, Group.Group, trg_riOwner) &
      (!trgBegDate | SRCINSEL(GroupE, EQ, trgBegDate)) THEN
    RenovateCurrentGroupE();
   END;
   NEXT(Group);
  END; (* WHILE OCCURE(Group) ... *)
 END {RenovateGroupE};

 PRIVATE PROCEDURE GetCurProGroupName(PropFile: STRING[]; CurVal: SCAL[2]): STRING[];
  VAR
   PropModule: STRING[];
   p         : PROC;
 BEGIN
  L_General.CallUs(ACCESS(^(PropFile)));
  CONFORM(^(PropFile), Property);
  PropModule:=L_Prop.GetModuleName(Property.Object);
  p:=PROCREF(^(PropModule + ".GetCurProGroupName"));
  L_General.CallUs(~!p);
  RETURN p(CurVal);
 END {GetCurProGroupName};

 PRIVATE PROCEDURE simo_SingleGroupT(Operation: L_SysLog.tKind; CurFileIsProp: SCAL[2]);
  VAR
   BegField,
   TillField,
   OwnerName,
   FileName,
   FieldName,
   PropFile,
   GroupN,
   _Pool      : STRING[];
   trgScalVal : LIKE(Group.ScalVal);
   trg_riOwner: LIKE(GroupE.riOwner);
   BegDate    : DATE;
   trgNotion  : LIKE(ERKN.Notion);
 BEGIN
  OwnerName :=DBD.FileIdToName(GroupT.Owner);
  trg_riOwner:=^(L_DBD.GetFieldName(OwnerName, "RECORDID"));
  trgNotion :=GetCurrentGroupTNotion();
  PropFile  :=GetPropFileNameByNotion(trgNotion);
  IF ~!PropFile THEN
   L_DBD.CollateValidityFieldNames(PropFile, BegField, TillField);
   IF (Operation =  L_SysLog.knd_Edit) & CurFileIsProp THEN
    BegDate:=GE_PVALUE(^(L_DBD.GetFieldName(PropFile, BegField)));
   ELSE
    BegDate:=^(L_DBD.GetFieldName(PropFile, BegField));
   END;
  ELSE
   SETEMPTY(BegDate);
  END;
  IF    Operation = L_SysLog.knd_Delete THEN
   DeleteGroupE(trg_riOwner, BegDate);
  ELSIF Operation = L_SysLog.knd_AutoEdit THEN
   RenovateGroupE(trg_riOwner, BegDate);
  ELSIF (Operation =  L_SysLog.knd_Edit) & ~IsAutoBuildGroupT() THEN
   RenovateGroupE(trg_riOwner, BegDate);
  ELSIF IsAutoBuildGroupT() THEN
   SETEMPTY(trgScalVal, GroupN);
   IF IsNotionBasedOnScalVal(trgNotion) THEN
    GetFatedNotionInfo(trgNotion, FileName, FieldName, _Pool);
    FieldName :=L_DBD.GetFieldName(FileName, FieldName);
    trgScalVal:=^(FieldName);
    GroupN    :=L_Str.PoolItem(_Pool, trgScalVal);
   ELSIF trgNotion = erkn_1Group_1OwnRec THEN
    GroupN:=^(L_DBD.GetFieldName(OwnerName, "Name"));
   ELSIF ~!PropFile THEN
    GroupN:=GetCurProGroupName(PropFile, 1);
   ELSE
    L_General.CallUs(0);
   END;

   IF    Operation = L_SysLog.knd_Insert THEN
    InsertGroupE(trg_riOwner, trgScalVal, GroupN);
   ELSIF Operation = L_SysLog.knd_Edit THEN
    IF (~!trgScalVal & (GE_PVALUE(^(FieldName)) # trgScalVal)) |
       (~!PropFile & CurFileIsProp & (GroupN # GetCurProGroupName(PropFile, 0))) THEN
     DeleteGroupE(trg_riOwner, BegDate);
     InsertGroupE(trg_riOwner, trgScalVal, GroupN);
    ELSE
     RenovateGroupE(trg_riOwner, BegDate);
    END;
   END;
  END; (* IF Operation = ... *)
 END {simo_SingleGroupT};

 PUBLIC PROCEDURE SupportInteractiveModificationOwner(OwnerFile: STRING[];
                                                      Operation: L_SysLog.tKind);
  VAR
   CurGroupTNotion,
   PropFileNotion: LIKE(ERKN.Notion);
   FileName,
   tmpFileName,
   PropFileName  : STRING[];
   CurFileIsProp : SCAL[2];
 BEGIN
  IF ~!OwnerFile THEN
   TRY
    GRANTALLRIGHTS();
    FileName:=OwnerFile;
    PropFileNotion:=GetNotionOfSupportedProperty(OwnerFile);
    IF ~!PropFileNotion | GroupTCanBeCreatedFromThisFile(DBD.FileNameToId(OwnerFile)) THEN
     SELECT(GroupT, Owner, , DBD.FileNameToId(OwnerFile));
     WHILE OCCURE(GroupT) DO
      CurGroupTNotion:=GetCurrentGroupTNotion();
      IF !PropFileNotion | (PropFileNotion = CurGroupTNotion) THEN
       PropFileName:=GetPropFileNameByNotion(CurGroupTNotion);
       IF ~!PropFileNotion | !PropFileName THEN
        simo_SingleGroupT(Operation, 1);
       ELSE
        CONFORM(^OwnerFile, ^PropFileName);
        WHILE OCCURE(^PropFileName) DO
         tmpFileName:=PropFileName;
         IF ~!GetNotionOfSupportedProperty(tmpFileName) THEN
          simo_SingleGroupT(Operation, 0);
         END;
         NEXT(^PropFileName);
        END; (* WHILE OCCURE(^PropFileName) ... *)
       END;
      END; (* IF !PropFileNotion ... *)
      NEXT(GroupT);
     END; (* WHILE OCCURE(GroupT) ... *)
    END; (* IF ~!PropFileNotion | ... *)
   EXCEPT
   END;
  END;
 END {SupportInteractiveModificationOwner};

 PUBLIC PROCEDURE InitializeCurrentGroupT();
  VAR
   OwnerFile,
   FileName  : STRING[];
   trgNotion : LIKE(ERKN.Notion);
 BEGIN
  L_General.Assert(ACCESS(GroupT), " । ⥪  ' 㯯'");
  L_General.CallUs(GroupTCanBeCreatedFromThisFile(GroupT.Owner));
  trgNotion:=GetCurrentGroupTNotion();
  IF ~!trgNotion THEN
   IF ~!GetPropFileNameByNotion(trgNotion) THEN
    FileName:=GetPropFileNameByNotion(trgNotion);
   ELSE
    FileName:=DBD.FileIdToName(GroupT.Owner);
   END;
   SELECT(^FileName, ^(L_DBD.GetPrimaryIndex(FileName)));
   WHILE OCCURE(^FileName) DO
    OwnerFile:=FileName;
    IF ~!GetNotionOfSupportedProperty(OwnerFile) | (FileName=DBD.FileIdToName(GroupT.Owner)) THEN
     simo_SingleGroupT(L_SysLog.knd_Insert, 1);
    END;
    NEXT(^FileName);
   END; (* WHILE OCCURE(^FileName) ... *)
  END; (* IF ~!trgNotion ... *)
 END {InitializeCurrentGroupT};

END.