(*
%Copyright   (c) Polak IT
%Author      11.05.2007 09:40:37 POLAK\San
%Purpose     প http
%Type        library
%Specific    CORE
%Modified    03.10.2013 17:54:00 POLAK\LDA
%Environment
*)

 MODULE L_HTTP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_MSWStp, L_Str, Math, FIO, Str, Shell, L_StdFrm;

 PRIVATE CONST
  icString    = 0; (* Default. Retrieves data as string *)
  icByteArray = 1; (* Retrieves data as a byte array *)

  (*Valid settings for MSINet.Protocol*)
  icUnknown   = 0;(* Unknown. *)
  icDefault   = 1;(* Default protocol.  *)
  icFTP       = 2;(* FTP. File Transfer Protocol. *)
  icReserved  = 3;(* Reserved for future use. *)
  icHTTP      = 4;(* HTTP. HyperText Transfer Protocol. *)
  icHTTPS     = 5;(* Secure HTTP. *)

 PRIVATE PROCEDURE ici_Create(RequestTimeout: NUMERIC[0]): OBJECT;
  CONST
   Obj           = "InetCtls.Inet";
   Lic           = "GecYPvjz5g/cX+qdLCPgYFRmJPWeELCL7/9pI72tAaVDy9VHnNOjPQ==";
   ComponentName = "MSINet";
   ComponentExt  = "ocx";
  VAR
   Cnt              : NUMERIC[0];
   oINet            : OBJECT;
   ComponentCabPath : STRING[];
   ReInstallRequired: SCAL[2];
 BEGIN
  ComponentCabPath :=L_General.GetREDISTRFullPath("MSINet.cab");
  ReInstallRequired:=L_MSWStp.IsReInstallComponentRequired(ComponentName, ComponentExt, ComponentCabPath);
  Cnt              :=0;
  REPEAT
   oINet:=L_MSWStp.extInstallDVBCAndCreateObject2(Obj,
                                                  DECRYPTSTR(Lic, Obj, CALG_DES),
                                                  ComponentName,
                                                  ComponentExt,
                                                  ComponentCabPath,
                                                  ReInstallRequired);
   ReInstallRequired:=0;
   SLEEP(0.3);
   INC(Cnt);
  UNTIL ~oINet.StillExecuting | (Cnt > 10);

  L_General.Assert(~oINet.StillExecuting, " 㤠 ᮧ ꥪ MSInet");
  oINet.RequestTimeout:=RequestTimeout;
  RETURN oINet;
 END {ici_Create};
 
 PRIVATE PROCEDURE ici_Wait(oINet: OBJECT);
 BEGIN
  WHILE oINet.StillExecuting DO
   SLEEP(0.1);
  END;
 END {ici_Wait};

 PRIVATE PROCEDURE ici_Quit(VAR oINet: OBJECT);
 BEGIN
  IF VAR_IMPL.Get(oINet).Initialized THEN
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    IF oINet.StillExecuting THEN
     oINet.Cancel();
    END;
   EXCEPT
   ON Exc: Exc_Root DO
   END; (* TRY *)
  END;
 END {ici_Quit};

 PRIVATE PROCEDURE ici_GetHeader(oINet: OBJECT; Section: STRING[]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="";
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=oINet.GetHeader(Section);
  EXCEPT
  ON Exc: Exc_Object DO
  END; (* TRY *)
  RETURN Result;
 END {ici_GetHeader};

 PRIVATE PROCEDURE httpTimeStamp2DT(    Stamp: STRING[];
                                    VAR D    : DATE;
                                    VAR T    : TIME;
                                    VAR S    : NUMERIC[0]);
  VAR
   s : STRING[];
   l,
   r : NUMERIC[0];
   vd: FLOAT;
 BEGIN
  r:=Str.ItemPos(Stamp, " ", 1);
 
  l:=r; r:=Str.ItemPos(Stamp, " ", 3, l); s:=Str.Slice(Stamp, l, r-l-1);
  D:=STRTOFLD(s, DATE, "D M y");
 
  l:=r; r:=Str.ItemPos(Stamp, ":", 2, l); s:=Str.Slice(Stamp, l, r-l-1);
  T:=STRTOFLD(s, TIME, "H:M");
 
  l:=r; r:=Str.ItemPos(Stamp, " ", 1, l); s:=Str.Slice(Stamp, l, r-l-1);
  S:=STRTOFLD(s, FLOAT, "0");
 
  l:=r; r:=Str.Length(Stamp); s:=Str.Slice(Stamp, l, r-l);
  L_General.CallUs(s="GMT");

  UNIVERSALTOLOCALVARIANTTIME(vd, L_DatTim.GetVARIANTDATE(D, T, S));
  UnPkVARIANTDATE(vd, D, T, S);
 END {httpTimeStamp2DT};

 PRIVATE PROCEDURE httpTimeStamp2Variant(Stamp: STRING[]): FLOAT;
  VAR
   D: DATE;
   T: TIME;
   S: NUMERIC[0];
 BEGIN
  httpTimeStamp2DT(Stamp, D, T, S);
  RETURN L_DatTim.GetVARIANTDATE(D, T, S);
 END {httpTimeStamp2Variant};

 PRIVATE PROCEDURE httpSetFileTimeStamp(fileHandle: STRING[]; ts: TIMESTAMP);
 BEGIN
  FIO.SetFileTime(^fileHandle, , , ts);
 END {httpSetFileTimeStamp};

 PRIVATE PROCEDURE Str2Int(S: STRING[]): NUMERIC[0];
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   RETURN STRTOFLD(S, NUMERIC, "0");
  EXCEPT
  ELSE
  END; (* TRY *)
  RETURN L_General.EMPTY_NUMBER();
 END {Str2Int};

 PRIVATE PROCEDURE intGetFileLastModifiedDTS(oINet: OBJECT): TIMESTAMP;
  VAR
   tsStr: STRING[];
   D    : DATE;
   T    : TIME;
   S    : NUMERIC[0];
 BEGIN
  tsStr:=ici_GetHeader(oINet, "Last-modified");
  IF !tsStr THEN
   tsStr:=ici_GetHeader(oINet, "Date");
  END;
  httpTimeStamp2DT(tsStr, D, T, S);
  RETURN PackTIMESTAMP(D, T, S);
 END {intGetFileLastModifiedDTS};

 PRIVATE PROCEDURE AcceptableResponse(oINet: OBJECT): SCAL[2];
  VAR
   Header      : STRING[];
   httpResponse: NUMERIC[0];
 BEGIN
  Header      :=ici_GetHeader(oINet, "");
  httpResponse:=Str2Int(Str.Item(Header, " " + CHR(13) + CHR(10), 1));
  RETURN (httpResponse >= 200) & (httpResponse <= 299);
 END {AcceptableResponse};

 PUBLIC PROCEDURE GetFileLastModifiedDTS(URL: STRING[]): TIMESTAMP;
  VAR
   oINet : OBJECT;
   Result: TIMESTAMP;
 BEGIN
  APP.Get().NewPrompt("祭 ६ ⠬ 䠩 " + URL);
  SETEMPTY(Result);
  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   oINet:=ici_Create(20);
   oINet.Execute(URL, "GET", "", "");
   ici_Wait(oINet);
   IF AcceptableResponse(oINet) THEN
    Result:=intGetFileLastModifiedDTS(oINet);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   IF Exc.Class # "Exc_Object" THEN
    RAISE();
   END;
  FINALLY
   ici_Quit(oINet);
  END; (* TRY *)
  RETURN Result;
 END {GetFileLastModifiedDTS};

 PRIVATE PROCEDURE intGetFileSize(oINet: OBJECT): NUMERIC[0];
 BEGIN
  RETURN Str2Int(ici_GetHeader(oINet, "Content-Length"));
 END {intGetFileSize};

 PUBLIC PROCEDURE GetFileSize(URL: STRING[]): NUMERIC[0];
  VAR
   oINet : OBJECT;
   Result: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("祭 ࠧ 䠩 " + URL);
  SETEMPTY(Result);
  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   oINet:=ici_Create(20);
   oINet.Execute(URL, "GET", "", "");
   ici_Wait(oINet);
   IF AcceptableResponse(oINet) THEN
    Result:=intGetFileSize(oINet);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   IF Exc.Class # "Exc_Object" THEN
    RAISE();
   END;
  FINALLY
   ici_Quit(oINet);
  END; (* TRY *)
  RETURN Result;
 END {GetFileSize};

 PRIVATE PROCEDURE int_httpGet(URL, dstFile: STRING[]; FileMode: SCAL[2]): SCAL[2];
  CONST
   BufferSize = 16*1024;
  VAR
   oINet         : OBJECT;
   Rest,
   BytesToRead   : NUMERIC[0];
   TimeStampAsStr: STRING[];
   Result        : SCAL[2];
 BEGIN
  APP.Get().NewPrompt("㧪 䠩  " + URL);
  Result:=0;
  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   oINet:=ici_Create(20);
   oINet.Execute(URL, "GET", "", "");
   ici_Wait(oINet);
   IF AcceptableResponse(oINet) THEN
    Rest:=intGetFileSize(oINet);
    FIO.Open(f, dstFile, , Create);
    IF ~!Rest THEN
     WHILE Rest > 0 DO
      BytesToRead:=Math.Min(Rest, BufferSize);
      FIO.WrByteSA(f, oINet.GetChunk(BytesToRead, icByteArray));
      DEC(Rest, BytesToRead);
      PROMPT("⠫ " + FLDTOSTR(Rest, "N,0", 0) + " .");
     END;
    ELSE
     (* ࠧ ⥭, ⮬ .. *)
     FIO.WrByteSA(f, oINet.OpenUrl(URL, icByteArray));
    END;
    IF FileMode THEN
     httpSetFileTimeStamp("f", intGetFileLastModifiedDTS(oINet));
    END;
    Result:=1;
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   IF Exc.Class # "Exc_Object" THEN
    RAISE();
   END;
  FINALLY
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    FIO.Close(f);
   EXCEPT
   ELSE
   END; (* TRY *)
   ici_Quit(oINet);
  END; (* TRY *)
  RETURN Result;
 END {int_httpGet};

 PUBLIC PROCEDURE httpGetFile(URL, dstFile: STRING[]): SCAL[2];
 BEGIN
  RETURN int_httpGet(URL, dstFile, 1);
 END {httpGetFile};

 PUBLIC PROCEDURE httpGet(URL, dstFile: STRING[]): SCAL[2];
 BEGIN
  RETURN int_httpGet(URL, dstFile, 0);
 END {httpGet};

 PRIVATE PROCEDURE WaitFinishExecute(oINet: OBJECT);
  VAR
   S: STRING[];
   i: NUMERIC[0];
 BEGIN
  SETZERO(i);
  S:="\";
  WHILE oINet.StillExecuting DO
   SLEEP(0.1);
   INC(i);
   IF Math.Mod(i, 3) = 0 THEN
    IF S = "\" THEN
     S:="|";
    ELSIF S = "|" THEN
     S:= "/";
    ELSIF S = "/" THEN
     S:="-";
    ELSIF S = "-" THEN
     S:="\";
    END;
    PROMPT(S);
   END;
  END;
 END {WaitFinishExecute};

 PRIVATE PROCEDURE ftpExecute(oINet: OBJECT; cmd, Descr: STRING[]; NoCheck: SCAL[2]);
 BEGIN
  APP.Get().NewPrompt("FTP " + oINet.RemoteHost + ": " + Descr);
  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   oINet.Execute("", cmd);
   WaitFinishExecute(oINet);
  EXCEPT
  ON Exc: Exc_Object DO
   IF oINet.ResponseCode = 0 THEN
    L_General.Error("FTP: " + Exc.MsgOriginalText);
   END;
  ON Exc: Exc_TermByUser DO
   IF oINet.StillExecuting THEN
    oINet.Cancel();
   END;
   RAISE();
  END; (* TRY *)
  L_General.Assert(NoCheck | (oINet.ResponseCode = 0),
                   "FTP:" + L_Str.IntStr(oINet.ResponseCode) + "||" + oINet.ResponseInfo);
 END {ftpExecute};

 PRIVATE PROCEDURE ftpFileExists(oINet: OBJECT; FName: STRING[]): SCAL[2];
  VAR
   S,
   CF: STRING[];
   i : NUMERIC[0];
 BEGIN
  ftpExecute(oINet, "DIR", "஢ઠ ⢮ 䠩/ " + FName, 1);
  S:=oINet.GetChunk(10000, icString);
  SETZERO(i);
  WHILE ~!Str.Item(S, "/" + L_Str.CRLF, i) DO
   CF:=Str.Item(S, "/" + L_Str.CRLF, i);
   IF L_Str.IsEqStrI(CF, FName) THEN
    RETURN 1
   END;
   INC(i);
  END;
  RETURN 0;
 END {ftpFileExists};

 PRIVATE PROCEDURE ftpForcePath(oINet: OBJECT; ftpPath: STRING[]);
  VAR
   i,
   j : NUMERIC[0];
   CF: STRING[];
 BEGIN
  SETZERO(i);
  WHILE ~!Str.Item(ftpPath, "\", i) DO
   CF:=Str.Item(ftpPath, "\", i);
   IF ~ftpFileExists(oINet, CF) THEN
    ftpExecute(oINet, "MKDIR " + CF, "  " + CF, 0);
   END;
   ftpExecute(oINet, "CD " + CF, " ⥪饩 ", 0);
   INC(i);
  END;
 END {ftpForcePath};

 PRIVATE PROCEDURE ConnectToFTP(URL, user, pass: STRING[]): OBJECT;
  VAR
   oINet: OBJECT;
 BEGIN
  APP.Get().NewPrompt("祭  FTP " + URL);
  oINet:=ici_Create(20);
  oINet.Protocol      :=icFTP;
  oINet.URL           :=URL;
  oINet.UserName      :=user;
  oINet.Password      :=DECRYPTSTR(pass, "05.02.2009 08:38:18 POLAK\LDA", CALG_RC2, , , CSP_NAME_MS_BASE);

  IF L_Str.IsEqStrI(URL, "polak.ru") THEN
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    oINet.Execute("", "DIR");
    WaitFinishExecute(oINet);
   EXCEPT
   ON Exc: Exc_Object DO
    oINet:=ConnectToFTP("stc.polak.ru", user, pass);
   ELSE
    RAISE();
   END; (* TRY *)
  END;
  RETURN oINet;
 END {ConnectToFTP};

 PRIVATE PROCEDURE CopyFileToFTP(oINet: OBJECT; srcFile, ftpPath: STRING[]; Safe: SCAL[2]);
  VAR
   FName,
   tmpFName,
   srcPath: STRING[];
 BEGIN
  ftpForcePath(oINet, ftpPath);
  FIO.SplitPath(srcFile, FName, , srcPath);
  IF Safe THEN
   tmpFName:=FName + ".tmp";
   IF ftpFileExists(oINet, tmpFName) THEN
    L_StdFrm.Confirm("FTP:  " + tmpFName + " 㦥    " + ftpPath);
   END;
   ftpExecute(oINet, "PUT " + srcFile + " " + tmpFName,  "஢ 䠩 " + tmpFName, 0);
   IF ftpFileExists(oINet, FName) THEN
    L_StdFrm.Confirm("FTP:  " + FName + " 㦥    " + ftpPath);
    ftpExecute(oINet, "DELETE " + FName, " 䠩 " + FName, 0);
   END;
   ftpExecute(oINet, "RENAME " + tmpFName + " " + FName, "஢ 䠩 " + FName, 0);
  ELSE
   IF ftpFileExists(oINet, FName) THEN
    L_StdFrm.Confirm("FTP:  " + FName + " 㦥    " + ftpPath);
   END;
   ftpExecute(oINet, "PUT " + srcFile + " " + FName, "஢ 䠩 " + FName, 0);
  END;
 END {CopyFileToFTP};

 PRIVATE PROCEDURE CopyFileFromFTP(oINet: OBJECT; srcFile, ftpPath, dstPath: STRING[]);
  VAR
   FName: STRING[];
 BEGIN
  FName:=FIO.BuildPath(srcFile, , dstPath);
  IF FIO.Exists(FName) THEN
   L_StdFrm.Confirm(" " + srcFile + " 㦥    " + dstPath);
   FIO.Erase(FName);
  END;
  ftpForcePath(oINet, ftpPath);
(*
  ftpExecute(oINet, "lcd " + dstPath, " 쭮   " + dstPath, 0);
*)
  ftpExecute(oINet, "GET " + srcFile + " " + FName, "஢ 䠩 " + srcFile, 0);
 END {CopyFileFromFTP};

 PRIVATE PROCEDURE intftpPutFile(URL, user, pass, srcFile, ftpPath: STRING[]; Safe: SCAL[2]);
  VAR
   i    : NUMERIC[0];
   oINet: OBJECT;
 BEGIN
  APP.Get().NewPrompt("ࠢ 䠩 " + srcFile + "  ftp ࢥ " + URL);
  TRY
   oINet:=ConnectToFTP(URL, user, pass);
   SETZERO(i);
   WHILE ~!L_Str.PoolItem(srcFile, i) DO
    CopyFileToFTP(oINet, L_Str.PoolItem(srcFile, i), ftpPath, Safe);
    INC(i);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   IF Exc.Class # "Exc_Object" THEN
    RAISE();
   END;
  FINALLY
   ici_Quit(oINet);
  END; (* TRY *)
 END {ftpPutFile};

 PUBLIC PROCEDURE ftpPutFile(URL, user, pass, srcFile, ftpPath: STRING[]);
 BEGIN
  intftpPutFile(URL, user, pass, srcFile, ftpPath, 0);
 END {ftpPutFile};

 PUBLIC PROCEDURE ftpPutFileSafe(URL, user, pass, srcFile, ftpPath: STRING[]);
 BEGIN
  intftpPutFile(URL, user, pass, srcFile, ftpPath, 1);
 END {ftpPutFileSafe};

 PUBLIC PROCEDURE ftpGetFile(URL, user, pass, srcFile, ftpPath, dstPath: STRING[]);
  VAR
   i    : NUMERIC[0];
   oINet: OBJECT;
 BEGIN
  APP.Get().NewPrompt("㧪 䠩 " + srcFile + "  ftp ࢥ " + URL);
  TRY
   oINet:=ConnectToFTP(URL, user, pass);
   SETZERO(i);
   WHILE ~!L_Str.PoolItem(srcFile, i) DO
    CopyFileFromFTP(oINet, L_Str.PoolItem(srcFile, i), ftpPath, dstPath);
    INC(i);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   IF Exc.Class # "Exc_Object" THEN
    RAISE();
   END;
  FINALLY
   ici_Quit(oINet);
  END; (* TRY *)
 END {ftpGetFile};

 PUBLIC PROCEDURE ftpMoveFilesFromDir(URL, user, pass, mask, ftpPath, dstPath: STRING[]);
  VAR
   i      : NUMERIC[0];
   oINet  : OBJECT;
   S,
   FName,
   srcFile: STRING[];
 BEGIN
  APP.Get().NewPrompt("㧪 䠩   " + ftpPath + " ftp ࢥ " + URL);
  TRY
   oINet:=ConnectToFTP(URL, user, pass);
   ftpForcePath(oINet, ftpPath);
   ftpExecute(oINet, "DIR " + mask, "஢ઠ ᮤন  " + ftpPath, 1);
   S:=oINet.GetChunk(10000, icString);
   SETZERO(i);
   LOOP
    srcFile:=Str.Item(S, "/" + L_Str.CRLF, i);
    IF !srcFile THEN
     EXIT;
    END;
    FName:=FIO.BuildPath(srcFile, , dstPath);
    IF FIO.Exists(FName) THEN
     L_StdFrm.Confirm(" " + srcFile + " 㦥    " + dstPath);
     FIO.Erase(FName);
    END;
    ftpExecute(oINet, "GET " + srcFile + " " + FName, L_Str.IntStr(i) + " ஢ 䠩 " + srcFile, 0);
    ftpExecute(oINet, "DELETE " + srcFile, L_Str.IntStr(i) + "  䠩 " + srcFile, 0);
    INC(i);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   IF Exc.Class # "Exc_Object" THEN
    RAISE();
   END;
  FINALLY
   ici_Quit(oINet);
  END; (* TRY *)
 END {ftpMoveFilesFromDir};

END.
