(*
%Copyright   (c) Polak IT
%Author      15.03.2010 12:51:24 POLAK\San
%Purpose     প ॣ樨   ᮡ⨩
%Type        library
%Specific    SYS
%Modified    10.02.2012 17:33:08 POLAK\San
%Environment
*)

 MODULE L_iga [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General;

 PUBLIC TYPE
  tAction = SCAL[128];

 PUBLIC CONST
  a_CloseMonth_Salary  = 0;
  a_CloseMonth_Payment = 1;
  a_CalculateSFee      = 2;
  a_RedistributeVAT    = 3;
  a_VacationProvision  = 4;

  a_Pool =         "⨥ . ௫"
           + "|" + "⨥ . "
           + "|" + " 客 ᮢ"
           + "|" + "९஢   '।'"
           + "|" + "᫥ १ࢠ  ᪮";

  r_Pool = " |⬥!";

 PRIVATE PROCEDURE intPut(_Action: tAction; _Repeal: SCAL[2]; _Period: DATE; _Comment: STRING[]);
 BEGIN
  SETEMPTY(iga.iga);
  iga.AcsObj :=L_General.curUSER;
  iga.Action :=_Action;
  iga.Repeal :=_Repeal;
  iga.Period :=_Period;
  iga.DTS    :=SYSTIMESTAMP();
  iga.Comment:=_Comment;
  L_General.CallUs(iga.Comment = _Comment);
  TRY
   GRANTALLRIGHTS();
   INSERT(iga);
  EXCEPT
  END; (* TRY *)
 END {intPut};

 PUBLIC PROCEDURE Put(_Action: tAction; _Period: DATE; _Comment: STRING[]);
 BEGIN
  intPut(_Action, 0, _Period, _Comment);
 END {Put};

 PUBLIC PROCEDURE Repeal(_Action: tAction; _Period: DATE; _Comment: STRING[]);
 BEGIN
  intPut(_Action, 1, _Period, _Comment);
 END {Repeal};

 PRIVATE PROCEDURE StandOnLast(trgAction: tAction; P: DATE): SCAL[2];
 BEGIN
  RETURN SELECT(iga, Action, trgAction, P) & LAST(iga);
 END {StandOnLast};

 PUBLIC PROCEDURE HasAction(trgAction: tAction; P: DATE): SCAL[2];
 BEGIN
  RETURN StandOnLast(trgAction, P) & ~iga.Repeal;
 END {HasAction};

 PUBLIC PROCEDURE GetActionLastDTS(trgAction: tAction; P: DATE): TIMESTAMP;
  VAR
   Result: TIMESTAMP;
 BEGIN
  SETEMPTY(Result);
  IF HasAction(trgAction, P) THEN
   Result:=iga.DTS;
  END;
  RETURN Result;
 END {GetActionLastDTS};

 PUBLIC PROCEDURE ActionHasProperPredecessor(trgAction, prdAction: tAction; P: DATE): SCAL[2];
 BEGIN
  RETURN HasAction(trgAction, P) & (GetActionLastDTS(trgAction, P) > GetActionLastDTS(prdAction, P));
 END {ActionHasProperPredecessor};

END.