(*
%Copyright   (c) Polak IT
%Author      05.02.2005 20:31:18 POLAK\San
%Purpose     প ଠ樮   ஭ ணࠬ ᯥ祭
%Type        library
%Specific    SYS
%Modified    10.05.2012 10:29:10 POLAK\San
%Environment
*)

 MODULE L_iSwap [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tiSwap         = SCAL[1E9];
  tSwapParty     = SCAL[1E2];
  tSwapKind      = SCAL[1E2];
  tSendingResult = SCAL[3];
  tStatus        = SCAL[5];

 PUBLIC CONST
  sp_Own      = 00;
  sp_TN       = 01; (*?*)

  sp_Pool = "⮏| ()";

  sk_ChangeBegRWS = 00; (*?*)

  sk_Pool = " 鸞|";

  sr_Sent       = 0;
  sr_Postpone   = 1;
  sr_Wait       = 2;
  sr_Impossible = 3;


  st_Prepared  = 0;
  st_Sent      = 1;
  st_Declined  = 2;
  st_Canceled  = 3;

  st_Pool = "⮢|।|⢥࣭|㫨஢";

 IMPORT L_General, L_lsStore, L_DatTim, L_Str, L_XML;

 PUBLIC PROCEDURE FormatLogEntry(_Entry: STRING[]): STRING[];
 BEGIN
  RETURN L_DatTim.CompleteSystimeStr() + " - " + _Entry;
 END {FormatLogEntry};

 PUBLIC PROCEDURE Send(_Receiver: LIKE(iSwap.Receiver);
                       _Sender  : LIKE(iSwap.Sender);
                       _Kind    : LIKE(iSwap.Kind);
                       _XDocId  : LIKE(iSwap.XDocId);
                       _Body    : STRING[]);
 BEGIN
  DEFAULT(iSwap);
  iSwap.Kind    :=_Kind;
  iSwap.Sender  :=_Sender;
  iSwap.Receiver:=_Receiver;
  iSwap.BldDate :=SYSDATE();
  iSwap.BldTime :=SYSTIME();
  iSwap.SrvDTS  :=L_DatTim.GetSysVARIANTDATE();
  iSwap.Status  :=st_Prepared;
  iSwap.SndDTS  :=L_DatTim.GetSysVARIANTDATE();
  iSwap.AcsObj  :=L_General.curUSER;
  iSwap.XDocId  :=_XDocId;
  iSwap.Body    :=L_lsStore.Insert(_Body);
  SETEMPTY(iSwap.Log);
  INSERT(iSwap);
 END {Send};

 PRIVATE PROCEDURE GetNew(_Receiver: LIKE(iSwap.Receiver);
                          _Sender  : LIKE(iSwap.Sender);
                          _Kind    : LIKE(iSwap.Kind);
                          VAR
                           _iSwap: tiSwap[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  TRY [MSGSUPPRESSIONMODE(MSGSUPPRESS_ALL)];
   i:=0;
   SETEMPTY(_iSwap);
   SELECT(iSwap, Polling, , _Receiver, _Sender, _Kind, st_Prepared);
   WHILE OCCURE(iSwap) & (i <= HIGH(_iSwap)) DO
    IF iSwap.SndDTS <= L_DatTim.GetSysVARIANTDATE() THEN
     _iSwap[i]:=iSwap.iSwap;
     INC(i);
    END;
    NEXT(iSwap);
   END; (* WHILE OCCURE(iSwap) ... *)
  EXCEPT
  ON Exc: Exc_AccessDeny DO
   IF Exc.ErrorCode # 374 THEN
    RAISE();
   END;
  END;
 END {GetNew};

 PRIVATE PROCEDURE Access_iSwap(_iSwap: tiSwap);
 BEGIN
  L_General.ConsultToUs(SEARCH(iSwap, iSwap, _iSwap), "Access_iSwap.Error 1");
 END {Access_iSwap};

 PUBLIC PROCEDURE GetBody(_iSwap: tiSwap): STRING[];
 BEGIN
  Access_iSwap(_iSwap);
  RETURN L_lsStore.Get(iSwap.Body);
 END {GetBody};

 PUBLIC PROCEDURE GetLog(_iSwap: tiSwap): STRING[];
 BEGIN
  Access_iSwap(_iSwap);
  RETURN L_lsStore.Get(iSwap.Log);
 END {GetLog};

 PUBLIC PROCEDURE ChangeStatus(_iSwap: tiSwap; _Status: tStatus);
 BEGIN
  Access_iSwap(_iSwap);
  IF iSwap.Status # _Status THEN
   iSwap.SrvDTS:=L_DatTim.GetSysVARIANTDATE();
   iSwap.Status:=_Status;
   REPLACE(iSwap);
  END;
 END {ChangeStatus};

 PUBLIC PROCEDURE AppendLog(_iSwap: tiSwap; _Log: STRING[]);
 BEGIN
  Access_iSwap(_iSwap);
  iSwap.Log:=L_lsStore.Replace(iSwap.Log, _Log + L_Str.CRLF + L_lsStore.Get(iSwap.Log));
  REPLACE(iSwap);
 END {AppendLog};

 PUBLIC PROCEDURE Postpone(_iSwap: tiSwap; Value: FLOAT);
 BEGIN
  Access_iSwap(_iSwap);
  INC(iSwap.SndDTS, Value);
  REPLACE(iSwap);
 END {Postpone};

 PUBLIC (*PRIVATE*) PERMANENT VAR
  iSwapToManipulate : tiSwap;
  iSwapStatus       : tStatus;
  iSwapLogToAppend  : STRING[];
  iSwapPostponeValue: FLOAT;

 PUBLIC PROCEDURE Agent_Prompt(Msg: STRING[]);
 BEGIN
  PROMPT(" iSwap (" + L_DatTim.CompleteSystimeStr() + "): " + Msg);
 END {Agent_Prompt};

 PRIVATE PROCEDURE Agent_Sleep(Sec: NUMERIC[0]; Msg: STRING[]);
 BEGIN
  WHILE Sec > 0 DO
   Agent_Prompt(Msg + " (" + FLDTOSTR(Sec, "0", 0) + ")");
   SLEEP(1.0);
   DEC(Sec);
  END;
 END {Agent_Sleep};

 PRIVATE PROCEDURE Agent_ChangeStatus(_iSwap: tiSwap; _Status: tStatus);
 BEGIN
  iSwapToManipulate:=_iSwap;
  iSwapStatus      :=_Status;
  PROCESS(iSwap, 135);
 END {Agent_ChangeStatus};

 PRIVATE PROCEDURE Agent_AppendLog(_iSwap: tiSwap; Msg, nativeResult: STRING[]);
 BEGIN
  iSwapToManipulate:=_iSwap;
  iSwapLogToAppend :=FormatLogEntry(Msg + " (" + nativeResult + ")");
  PROCESS(iSwap, 136);
 END {Agent_AppendLog};

 PRIVATE PROCEDURE Agent_Postpone(_iSwap: tiSwap; Value: FLOAT);
 BEGIN
  iSwapToManipulate :=_iSwap;
  iSwapPostponeValue:=Value;
  PROCESS(iSwap, 137);
 END {Agent_Postpone};

 PUBLIC PROCEDURE Agent_Run(_Receiver: LIKE(iSwap.Receiver);
                            _Sender  : LIKE(iSwap.Sender);
                            _Kind    : LIKE(iSwap.Kind);
                            _SendProc: PROC);
  CONST
   oneTimePacketSize = 1024;
   UnlockAll = "17.03.2005 17:53:52 POLAK\San -   ஢";

  VAR
   _iSwap        : tiSwap[oneTimePacketSize];
   sendingResult : tSendingResult;
   nativeResult  : STRING[];
   delayTime     : FLOAT;
   i             : NUMERIC[0];
 BEGIN
  LOOP
   LOOP
    TRY
     Agent_Prompt("祭  ᮮ饭");
     GetNew(_Receiver, _Sender, _Kind, _iSwap);
     i:=0;
     WHILE (i < oneTimePacketSize) & ~!_iSwap[i] DO
      Access_iSwap(_iSwap[i]);
      _SendProc(L_XML.LoadXML(GetBody(_iSwap[i])),
                iSwap.SrvDTS,
                sendingResult, nativeResult, delayTime);
      IF    sendingResult = sr_Impossible THEN
       Agent_AppendLog(_iSwap[i], "⢥࣭", nativeResult);
       Agent_ChangeStatus(_iSwap[i], st_Declined);
       INC(i);
      ELSIF sendingResult = sr_Sent THEN
       Agent_AppendLog(_iSwap[i], "।", nativeResult);
       Agent_ChangeStatus(_iSwap[i], st_Sent);
       INC(i);
      ELSIF sendingResult = sr_Postpone THEN
       Agent_AppendLog(_iSwap[i], "⫮", nativeResult);
       Agent_Postpone(_iSwap[i], delayTime);
       INC(i);
      ELSIF sendingResult = sr_Wait THEN
       Agent_AppendLog(_iSwap[i], "", nativeResult);;
       IF ISOURSITE() THEN
        delayTime:=10;
       ELSE
        delayTime:=delayTime*60*60*24;
       END;
       Agent_Sleep(delayTime, " ⮢");
      ELSE
       Agent_Prompt("訡 1.   ࠡ稪");
      END;
     END; (* WHILE i ... *)
     RAISE(, UnlockAll);
    EXCEPT
    ELSE
    END;
    Agent_Sleep(10, "४ ;)");
   END; (* LOOP single GetNew *)
   Agent_Sleep(10, "   ⤮ ;)");
  END; (* LOOP main *)
 END {Agent_Run};

END.