(*
%Copyright   (c) Polak IT
%Author      08.05.2009 15:25:05 POLAK\LDA
%Purpose     ⥪ ࠡ  ୠ묨 㬥⠬
%Type        library
%Specific    AP
%Modified    14.06.2013 14:22:30 POLAK\Bor
%Environment
*)

 MODULE L_JDoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  st_Prepared  = 0; (* ⮢ *)
  st_Passed    = 1; (* ஢    *)
  st_Canceled  = 2; (* ⬥     *)

  jdkf_Manual         = 0;
  jdkf_Annex          = 1;
  jdkf_Technological  = 2;

  jd_Manual = 01;
  jd_MDoc   = 02;
  jd_PDoc   = 03;
  jd_Dfrls  = 04;
  jd_RWayS  = 05;
  jd_Distr  = 06;

 IMPORT L_General, L_DatTim, L_XDoc, L_Events, L_StdFrm, L_Pmnt, L_XObj, L_Acnt, L_XDR,
        DBD, L_Way;

 PUBLIC PROCEDURE JDocKindNick(_JDocKind: LIKE(JDoc.JDocKind)): STRING[3];
  VAR
   _Sign: LIKE(JDocKind.Sign);
 BEGIN
  SAVE(JDocKind);
  SEARCH(JDocKind, JDocKind, , _JDocKind);
  L_General.Assert(OCCURE(JDocKind), "  ୠ쭮 㬥 "+_JDocKind);
  _Sign:=JDocKind.Sign;
  RESTORE(JDocKind);
  RETURN _Sign;
 END {JDocKindNick};

 PUBLIC PROCEDURE JDocStr(_JDocKind: LIKE(JDoc.JDocKind); _JDoc: LIKE(JDoc.JDoc)): STRING[];
 BEGIN
  RETURN JDocKindNick(_JDocKind)+" "+_JDoc;
 END {JDocStr};

 PUBLIC PROCEDURE GetJDocStrNbr(): STRING[];
 BEGIN
  RETURN JDocStr(JDoc.JDocKind, JDoc.JDoc) + "  " + L_DatTim.DateStr(JDoc.Date);
 END {GetJDocStrNbr};

 PRIVATE PROCEDURE CheckXObjectMyFirm(_XObject: LIKE(XObject.XObject));
 BEGIN
  IF ~!_XObject THEN
   L_XObj.AccessXObject(_XObject);
   IF XObject.MyFirm # JDoc.MyFirm THEN
    L_General.Error(" ࣠樨  㬥  ꥪ "+L_XObj.GetXObjectOriginName());
   END;
  END;
 END {CheckXObjectMyFirm};

 PUBLIC PROCEDURE ReplicateAnnexJDoc(mainXDocId: L_XDoc.tXDocId);
  VAR
   AnnexJDocId: L_XDoc.tXDocId;
 BEGIN
  AnnexJDocId:=L_XDoc.GetAnnexXDocId(mainXDocId);
  IF ~!AnnexJDocId THEN
   IF L_XDoc.ExtractXDocType(AnnexJDocId) = L_XDoc.xdt_JDoc THEN
    L_XDoc.PositionOnXDoc(AnnexJDocId);
    IF    L_XDoc.ExtractXDocType(mainXDocId) = L_XDoc.xdt_MDoc THEN
     JDoc.MyFirm  :=MDoc.MyFirm;
     JDoc.Date    :=MDoc.Date;
     JDoc.SrcNbr  :=MDoc.MDocKind + " " + MDoc.MDoc;
     JDoc.SrcDate :=MDoc.SrcDate;
     JDoc.Status  :=MDoc.Status;
     REPLACE(JDoc);
    ELSIF L_XDoc.ExtractXDocType(mainXDocId) = L_XDoc.xdt_PDoc THEN
     JDoc.MyFirm  :=PDoc.MyFirm;
     JDoc.Date    :=PDoc.Date;
     JDoc.SrcNbr  :=PDoc.PDocKind + " " + PDoc.PDoc;
     JDoc.SrcDate :=PDoc.PrpDate;
     JDoc.Status  :=PDoc.Status;
     REPLACE(JDoc);
    ELSE
     L_General.CallUs(0);
    END;
    CONFORM(JDoc, JDocList);
    WHILE OCCURE(JDocList) DO
     CheckXObjectMyFirm(JDocList.XObject);
     CheckXObjectMyFirm(JDocList.XObject2);
     JDocList.Date:=JDoc.Date;
     JDocList.DoneDTS:=JDoc.DoneDTS;
     REPLACE(JDocList);
     NEXT(JDocList);
    END; (* WHILE OCCURE(JDocList) ... *)
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {ReplicateAnnexJDoc};

 PUBLIC PROCEDURE AccessJDoc();
 BEGIN
  L_General.Assert(ACCESS(JDoc), " ⠭ ⥪   'ୠ 㬥'");
 END {AccessJDoc};

 PRIVATE PROCEDURE GetXDocTypeOfMaiXDoc(_JDocKind: LIKE(JDocKind.JDocKind)): L_XDoc.tXDocType;
 BEGIN
  IF    JDoc.JDocKind = jd_MDoc THEN RETURN L_XDoc.xdt_MDoc;
  ELSIF JDoc.JDocKind = jd_PDoc THEN RETURN L_XDoc.xdt_PDoc;
  ELSE                               RETURN L_General.EMPTY_NUMBER();
  END;
 END {GetXDocTypeOfMaiXDoc};

 PUBLIC PROCEDURE GetJDocOnBehalfOfXDocId(): LIKE(JDoc.XDocId);
 BEGIN
  L_General.CallUs(ACCESS(JDoc));
  IF ~!GetXDocTypeOfMaiXDoc(JDoc.JDocKind) THEN
   RETURN L_XDoc.GetMainXDocIdPfAnnexXDoc(JDoc.XDocId);
  ELSE
   RETURN JDoc.XDocId;
  END;
 END {GetJDocOnBehalfOfXDocId};

 PUBLIC PROCEDURE PositionOnMainXDoc();
 BEGIN
  L_General.CallUs(ACCESS(JDoc));
  L_XDoc.PositionOnXDoc(GetJDocOnBehalfOfXDocId());
 END {PositionOnMainXDoc};

 PUBLIC PROCEDURE JDoc_OnAnyModification(Dir: NUMERIC[0]; NeedProceed: SCAL[2]; Stream: SCAL[2]);
 BEGIN
  CONFORM(JDoc, JDocKind);
  IF JDocKind.Features # jdkf_Technological THEN
   L_XDoc.xdmb_CheckABan(L_XDoc.xdcls_AllPmnt, JDoc.Date);
  END;
  IF Dir = +1 THEN
   IF NeedProceed THEN
    SAVE(JDoc);
    TRY
     IF Stream THEN
      CALL(JDoc.StreamMakeDone());
     ELSE
      CALL(JDoc.SingleMakeDone());
     END;
    EXCEPT
    ON Exc: Exc_Raise DO
     IF ~Stream THEN
      L_XDoc.OnAnyXDocModificationProceedError(Exc);
     END; (* IF ~Stream ... *)
    END; (* TRY *)
    RESTORE(JDoc);
   END;
  ELSIF Dir = -1 THEN
   IF NeedProceed THEN
    IF JDoc.Done THEN
     SAVE(JDoc);
     IF Stream THEN
      CALL(JDoc.StreamMakeUnDone());
     ELSE
      CALL(JDoc.SingleMakeUnDone());
     END;
     RESTORE(JDoc);
    END;
   ELSE
    L_General.CallUs(~JDoc.Done);
   END;
  END;
  L_Pmnt.SupportOnlineBalance(L_XDoc.xdt_JDoc, Dir);
 END {JDoc_OnAnyModification};

 PUBLIC PROCEDURE JDoc_Proceed(Sign: NUMERIC[0]);
  VAR
   _XDocId          : LIKE(JDoc.XDocId);
   P                : DATE;
   _Source          : L_XObj.tSource;
   save_L_XDR_XDocId: L_XDoc.tXDocId;
 BEGIN
  AccessJDoc();
  IF ((Sign = +1) & JDoc.Done) | ((Sign = -1) & ~JDoc.Done) THEN
   L_General.CallUs(0);
  END;
  IF JDoc.Status = st_Passed THEN
   APP.Get().NewPrompt("ࠡ⪠ " + L_XDoc.XDocStr(JDoc.XDocId));
   _XDocId:=GetJDocOnBehalfOfXDocId();
   IF JDoc.XDocId # _XDocId THEN
    L_XDoc.PositionOnXDoc(_XDocId);
   END;
   TRY
    save_L_XDR_XDocId:=L_XDR.XDocId;
    L_XDR.XDocId:=_XDocId;
    L_Acnt.GetXApportSpecificValues(L_XDoc.ExtractXDocType(_XDocId), _Source, P);
    CONFORM(JDoc, JDocList);
    WHILE OCCURE(JDocList) DO
     IF ~!JDocList.XObject  & (!JDocList.AcCut  | !JDocList.Apport  | !JDocList.AcCut2) |
        ~!JDocList.XObject2 & (!JDocList.AcCut2 | !JDocList.Apport2 | !JDocList.AcCut ) THEN
      L_General.Error("஢  ஬ " + JDocList.JDLNbr + " ᠭ  ");
     END;
     PROMPT(JDocList.JDLNbr);
     L_XObj.MakeCompleteCir(Sign, P, JDocList.XObject,  JDocList.AcCut,  JDocList.Apport,  JDocList.wQnt,
                                     JDocList.XObject2, JDocList.AcCut2, JDocList.Apport2, JDocList.wQnt2,
                            JDocList.Sum, JDocList.Qnt, _Source);
  
     NEXT(JDocList);
    END; (* WHILE OCCURE(JDocList) ... *)
   EXCEPT
   FINALLY
    L_XDR.XDocId:=save_L_XDR_XDocId;
   END; (* TRY *)
  ELSIF !JDoc.Status THEN
   L_General.CallUs(0);
  END;
 END {JDoc_Proceed};

 PUBLIC PROCEDURE XDoc_ProceedAnnexJDoc(Sign: NUMERIC[0]; xdt: L_XDoc.tXDocType);
  VAR
   AnnexJDocId: L_XDoc.tXDocId;
 BEGIN
  AnnexJDocId:=L_XDoc.GetAnnexXDocId(L_XDoc.curXDocId(xdt));
  IF ~!AnnexJDocId THEN
   L_XDoc.PositionOnXDoc(AnnexJDocId);
   JDoc_Proceed(Sign);
   IF Sign = +1 THEN
    JDoc.Done:=1;
    IF (JDoc.DoneDTS = L_XDoc.max_DoneDTS) | !JDoc.DoneDTS(*0053330*) THEN
     JDoc.DoneDTS:=L_XDoc.GetSysDTS();
    END;
   ELSIF Sign = -1 THEN
    JDoc.Done:=0;
   END;
   REPLACE(JDoc);
  END;
 END {XDoc_ProceedAnnexJDoc};

 PUBLIC PROCEDURE XDoc_ForceUndoneAnnexJDoc(curXDocId: L_XDoc.tXDocId);
  VAR
   AnnexJDocId: L_XDoc.tXDocId;
 BEGIN
  AnnexJDocId:=L_XDoc.GetAnnexXDocId(curXDocId);
  IF ~!AnnexJDocId THEN
   L_XDoc.PositionOnXDoc(AnnexJDocId);
   L_General.CallUs(JDoc.Done);
   JDoc.Done:=0;
   REPLACE(JDoc);
  END;
 END {XDoc_ForceUndoneAnnexJDoc};

 PUBLIC PROCEDURE GetJDocDoneDTS(): L_XDoc.tDoneDTS;
  VAR
   curXDocId: LIKE(JDoc.XDocId);
   Result   : L_XDoc.tDoneDTS;
 BEGIN
  curXDocId:=GetJDocOnBehalfOfXDocId();
  IF JDoc.XDocId # curXDocId THEN
   TRY
    L_XDoc.PositionOnXDoc(curXDocId);
    IF    L_XDoc.ExtractXDocType(curXDocId) = L_XDoc.xdt_MDoc THEN
     Result:=MDoc.DoneDTS;
    ELSIF L_XDoc.ExtractXDocType(curXDocId) = L_XDoc.xdt_PDoc THEN
     Result:=PDoc.DoneDTS;
    ELSE
     L_General.CallUs(0);
    END;
    L_General.RaiseLockReleaseException(); (*⠭ 樨  䠩*)
   EXCEPT
   ON Exc: Exc_Root DO
    L_General.CheckIsLockReleaseException(Exc);
   END; (* TRY *)
  ELSE
   Result:=JDoc.DoneDTS;
  END;
  RETURN Result;
 END {GetJDocDoneDTS};

 PUBLIC PROCEDURE CheckPassed();
 BEGIN
  L_General.Assert(JDoc.Status=st_Passed,
                   "ୠ 㬥 " + JDocStr(JDoc.JDocKind, JDoc.JDoc) +
                   "|   ﭨ '஢'");
 END {CheckPassed};

 PUBLIC PROCEDURE CheckDone();
 BEGIN
  L_General.Assert(JDoc.Done,
                   "ୠ 㬥 " + JDocStr(JDoc.JDocKind, JDoc.JDoc) +
                   "|  ࠡ⠭");
 END {CheckDone};

 PRIVATE PROCEDURE ResetJDoc(_fiPrn    : LIKE(JDoc.fiPrn);
                             _riPrn    : LIKE(JDoc.riPrn);
                             _MyFirm   : LIKE(JDoc.MyFirm);
                             _JDocKind : LIKE(JDoc.JDocKind);
                             D         : DATE;
                             NewDocProc: PROC);
 BEGIN
  TRY
   TABLE.Get("JDoc").AccessDataMode:=adm_CONCURRENT;
   CONCURRENTRESET(JDoc, Prn,
                    _fiPrn, _riPrn, _MyFirm, _JDocKind, D,
                   Ready);
   IF !JDoc.XDocId THEN
    GETLASTVERSION(JDoc);
    JDoc.XDocId :=L_XDoc.curXDocId(L_XDoc.xdt_JDoc);
    JDoc.SrcDate:=D;
    JDoc.DoneDTS:=L_XDoc.GetSysDTS();
    JDoc.Status :=st_Passed;
    REPLACE(JDoc);
    L_XDoc.XDocJrn_Mark(L_XDoc.xdt_JDoc, JDoc.JDocKind, JDoc.JDoc, L_XDoc.action_AutoBuild);
    NewDocProc();
   END;
  EXCEPT
  END; (* TRY *)
 END {ResetJDoc};

 PRIVATE PROCEDURE ndp_CarOfRWayS();
 BEGIN
  JDoc.SrcNbr:=Car.BoxNbr;
  REPLACE(JDoc);
 END {ndp_CarOfRWayS};

 PUBLIC PROCEDURE ResetJDocByRWayS();
 BEGIN
  ResetJDoc(DBD.FileNameToId("Car"), Car.RECORDID, L_Way.GetRWaySMyFirm(),
            jd_RWayS, L_DatTim.MonthEnd(RWayS.Date), PROCREF(ndp_CarOfRWayS));
 END {ResetJDocByRWayS};

 PUBLIC PROCEDURE Insert_JDoc();
 BEGIN
  JDoc.Ready:=1;
  JDoc.DoneDTS:=L_XDoc.GetSysDTS();
  INSERT(JDoc);
  JDoc.XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_JDoc);
  REPLACE(JDoc);
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_JDoc, JDoc.JDocKind, JDoc.JDoc, L_XDoc.action_AutoBuild);
 END {Insert_JDoc};

END.
