(*
%Copyright   (c) Polak IT
%Author      26.02.2014 13:45:24 POLAK\San
%Purpose     ⥪  ࠡ  "묨 ﬨ" (祭ﬨ) - ERKN, erkns
%Type        library
%Specific    SYS
%Modified    05.09.2014 12:22:52 POLAK\Bor
%Environment
*)

 MODULE L_kn [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_StdFrm, Str, L_DBD, P_Firm, L_Str;

 PUBLIC TYPE
  tNotion = LIKE(ERKN.Notion);

 PUBLIC PROCEDURE OnBeforeDelete(trgFile: STRING[]);
  VAR
   trgTable: TABLE;
 BEGIN
  IF trgFile # "erkns" THEN
   trgTable:=TABLE.Get(trgFile);
   IF ~!trgTable.Fields("RECORDID") THEN
    IF SELECT(erkns, fi, trgTable.Id, ^(trgTable.Fields("RECORDID").ObtainName())) THEN
     REMSEL(erkns);
    END;
   END;
  END;
 END {OnBeforeDelete};

 PRIVATE PROCEDURE intUpdateERKN(InsOnly    : SCAL[2];
                                 curNotion  : tNotion;
                                 curFile    : STRING[];
                                 curName    : STRING[];
                                 curBegin   : DATE;
                                 curMultiple: LIKE(ERKN.Multiple);
                                 curwHistory: LIKE(ERKN.wHistory));
  VAR
   doIns: SCAL[2];
 BEGIN
  IF SELECT(ERKN, NotionId, curNotion) THEN
   L_General.CallUs(~InsOnly);
   doIns:=0;
  ELSE
   doIns:=1;
  END;
  ERKN.Notion  :=curNotion;
  ERKN.EntityId:=TABLE.Get(curFile).Id;
  ERKN.Name    :=curName;
  ERKN.Begin   :=curBegin;
  ERKN.Multiple:=curMultiple;
  ERKN.wHistory:=curwHistory;
  TRY
   GRANT_ALL_RIGHTS();
   IF doIns THEN
    SETEMPTY(ERKN.ERKN, ERKN.Till);
    INSERT(ERKN);
   ELSE
    REPLACE(ERKN);
    L_General.CallUs(~NEXT(ERKN));
   END;
  EXCEPT
  END; (* TRY *)
 END {intUpdateERKN};

 PUBLIC PROCEDURE InsertERKN(curNotion  : tNotion;
                             curFile    : STRING[];
                             curName    : STRING[];
                             curBegin   : DATE;
                             curMultiple: LIKE(ERKN.Multiple);
                             curwHistory: LIKE(ERKN.wHistory));
 BEGIN
  intUpdateERKN(1, curNotion, curFile, curName, curBegin, curMultiple, curwHistory);
 END {InsertERKN};

 PUBLIC PROCEDURE UpdateERKN(curNotion  : tNotion;
                             curFile    : STRING[];
                             curName    : STRING[];
                             curBegin   : DATE;
                             curMultiple: LIKE(ERKN.Multiple);
                             curwHistory: LIKE(ERKN.wHistory));
 BEGIN
  intUpdateERKN(0, curNotion, curFile, curName, curBegin, curMultiple, curwHistory);
 END {UpdateERKN};

 PUBLIC PROCEDURE AccessERKN(File: STRING[]; trgNotion: tNotion);
 BEGIN
  SEARCH(ERKN, Notion, , TABLE.Get(File).Id, trgNotion);
 END {AccessERKN};

 PUBLIC PROCEDURE StandOnERKN(trgNotion: tNotion);
 BEGIN
  IF SELECT(ERKN, NotionId, trgNotion) THEN
   L_General.CallUs(~NEXT(ERKN));
   FIRST(ERKN);
  END;
 END {StandOnERKN};

 PUBLIC PROCEDURE IsTrgNotion(trgERKN: LIKE(ERKN.ERKN); trgNotion: tNotion): SCAL[2];
 BEGIN
  RETURN ~!trgERKN & SEARCH(ERKN, ERKN, trgERKN) & (ERKN.Notion = trgNotion);
 END {IsTrgNotion};

 PUBLIC PROCEDURE SearchByERKNError(Msg: STRING[]);
 BEGIN
  L_StdFrm.WrongDB(Msg);
 END {SearchByERKNError};

 PRIVATE PROCEDURE intGet(D: DATE; trgNotion: tNotion; Strong: SCAL[2]; trgMyFirm: P_Firm.tMyFirm): STRING[];
  VAR
   trgFile: STRING[];
   aboutMF: STRING[];
   Result : STRING[];
 BEGIN
  IF ~!trgMyFirm & P_Firm.E_wMultipleMyFirm(D) THEN
   aboutMF:=" ( " + trgMyFirm + ")";
  ELSE
   aboutMF:="";
  END;
  StandOnERKN(trgNotion);
  trgFile:=DATABASE.Get().TableById(ERKN.EntityId).Name;
  SAVE((trgFile));
  SETEMPTY(Result);
  SETSEL(erkns, ERKN, ERKN.ERKN);
  FOR_EACH erkns DO
   IF ~ERKN.wHistory | L_DatTim.IsActive(D, erkns.Begin, erkns.Till) THEN
    SEARCH((trgFile), RECORDID, , erkns.ri);
    IF L_DBD.RecordIsActive(D, trgFile) & (!trgMyFirm | (^(TABLE.Get(trgFile).Fields("MyFirm").ObtainName()) = trgMyFirm)) THEN
     IF ~!Result & ~ERKN.Multiple THEN
      L_StdFrm.WrongDB( "㦥  ( )  䠩  祭" +
                       "|" +
                       "|'" + ERKN.Name + "'" + aboutMF +
                       L_StdFrm.THR("ᠭ 䠩") +
                        "'" + TABLE.Get(trgFile).Description + "' (" + trgFile + ")" +
                       L_StdFrm.THR(" ஡ ᥩ") +
                        Result + "  " + L_DBD.GetPrimaryIndexValue(trgFile));
     END;
     Result:=L_DBD.GetPrimaryIndexValue(trgFile);
    END;
   END;
  END; (* FOR_EACH erkns *)
  RESTORE((trgFile));
  IF Strong & !Result THEN
   L_StdFrm.WrongDB( "    䠩  祭" +
                    "|" +
                    "|'" + ERKN.Name + "'" + aboutMF +
                    L_StdFrm.THR("ᠭ 䠩") +
                     "'" + TABLE.Get(trgFile).Description + "' (" + trgFile + ")");
  END;
  RETURN Result;
 END {intGet};

 PUBLIC PROCEDURE GetSoft(D: DATE; trgNotion: tNotion): SCAL[1E9];
 BEGIN
  RETURN intGet(D, trgNotion, 0, EMPTYOF(P_Firm.tMyFirm));
 END {GetSoft};

 PUBLIC PROCEDURE Get(D: DATE; trgNotion: tNotion): SCAL[1E9];
 BEGIN
  RETURN intGet(D, trgNotion, 1, EMPTYOF(P_Firm.tMyFirm));
 END {Get};

 PUBLIC PROCEDURE GetSoft_wMF(D: DATE; trgNotion: tNotion; trgMyFirm: P_Firm.tMyFirm): SCAL[1E9];
 BEGIN
  RETURN intGet(D, trgNotion, 0, trgMyFirm);
 END {GetSoft_wMF};

 PUBLIC PROCEDURE Get_wMF(D: DATE; trgNotion: tNotion; trgMyFirm: P_Firm.tMyFirm): SCAL[1E9];
 BEGIN
  RETURN intGet(D, trgNotion, 1, trgMyFirm);
 END {Get_wMF};

 PUBLIC PROCEDURE Is(D: DATE; trgNotion: tNotion): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=SELECT(ERKN, NotionId, trgNotion) &
          SEARCH(erkns, ERKN, ERKN.ERKN, ^(DATABASE.Get().TableById(ERKN.EntityId).Fields("RECORDID").ObtainName())) &
          (~ERKN.wHistory | L_DatTim.IsActive(D, erkns.Begin, erkns.Till));
  IF NEXT(ERKN) THEN
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {Is};

 PRIVATE PROCEDURE intStand(D: DATE; trgNotion: tNotion; Strong: SCAL[2]): SCAL[2];
  VAR
   File,
   PrmIdxVal: STRING[];
 BEGIN
  PrmIdxVal:=intGet(D, trgNotion, Strong, EMPTYOF(P_Firm.tMyFirm));
  IF ~!PrmIdxVal THEN
   File:=DATABASE.Get().TableById(ERKN.EntityId).Name;
   L_General.CallUs(L_DBD.SelectByIndexValue(File, L_DBD.GetPrimaryIndex(File), PrmIdxVal));
  END;
  RETURN ~!PrmIdxVal;
 END {intStand};

 PUBLIC PROCEDURE Stand(D: DATE; trgNotion: tNotion);
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=intStand(D, trgNotion, 1);
 END {Stand};

 PUBLIC PROCEDURE StandSoft(D: DATE; trgNotion: tNotion): SCAL[2];
 BEGIN
  RETURN intStand(D, trgNotion, 0);
 END {StandSoft};

END.