(*
%Copyright   (c) Polak IT
%Author      17.02.2005 12:06:51 POLAK\San
%Purpose     প ࠭  ப
%Type        library
%Specific    SYS
%Modified    16.07.2010 18:23:03 POLAK\Gina
%Environment
*)

 MODULE L_lsStore [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tlsStore = SCAL[1E12];

 PUBLIC PERMANENT VAR
  v_empty_lsStore: tlsStore;

 PUBLIC CONST
  hasNext_Pool = " |v v v";

 IMPORT L_General, Str, L_Str;

 PRIVATE CONST
  lsStoreValueLength = Str.MaxLength(lsStore.Value);

 PUBLIC PROCEDURE Insert(S: STRING[]): tlsStore;
  VAR
   _Value: LIKE(lsStore.Value);
   p, l  : NUMERIC[0];
   Result: tlsStore;
 BEGIN
  SETEMPTY(Result);
  IF ~!S THEN
   p:=Str.Length(S);
   l:=p MOD lsStoreValueLength;
   IF l = 0 THEN
    l:=lsStoreValueLength;
   END;
   REPEAT
    DEC(p, l);
    _Value:=Str.Slice(S, p, l);
    SETEMPTY(lsStore.lsStore, lsStore.Dummy);
    lsStore.Value:=_Value;
    lsStore.Next :=Result;
    INSERT(lsStore);
    Result:=lsStore.lsStore;
    l:=lsStoreValueLength;
   UNTIL p = 0;
  END;
  RETURN Result;
 END {Insert};

 PRIVATE PROCEDURE Access(_lsStore: tlsStore);
 BEGIN
  L_General.ConsultToUs(SEARCH(lsStore, lsStore, _lsStore), "Access.Error 1");
 END {Access};

 PRIVATE PROCEDURE PutNext(_lsStore, _Next: tlsStore);
 BEGIN
  Access(_lsStore);
  lsStore.Next:=_Next;
  REPLACE(lsStore);
 END {PutNext};

 PRIVATE PROCEDURE Remove(_lsStore: tlsStore);
 BEGIN
  WHILE ~!_lsStore DO
   Access(_lsStore);
   _lsStore:=lsStore.Next;
   CHANGESEL(lsStore, lsStore, , lsStore.lsStore); (*0069121 ⮡ ᫥ REMOVE  ⠫   ᫥ *)
   REMOVE(lsStore);
  END;
 END {Remove};

 PUBLIC PROCEDURE Replace(_lsStore: tlsStore; S: STRING[]): tlsStore;
  VAR
   _Value   : LIKE(lsStore.Value);
   p        : NUMERIC[0];
   prvStore,
   Result   : tlsStore;
 BEGIN
  IF !S THEN
   SETEMPTY(Result);
   Remove(_lsStore);
  ELSIF !_lsStore THEN
   Result:=Insert(S);
  ELSE
   Result:=_lsStore;
   SETEMPTY(prvStore);
   p:=0;
   LOOP
    _Value:=Str.Slice(S, p, lsStoreValueLength);
    IF !_Value THEN
     Remove(_lsStore);
     PutNext(prvStore, L_General.EMPTY_NUMBER());
     EXIT;
    END;
    Access(_lsStore);
    lsStore.Value:=_Value;
    REPLACE(lsStore);
    INC(p, lsStoreValueLength);
    prvStore:=lsStore.lsStore;
    IF !lsStore.Next THEN
     _lsStore:=Insert(Str.Slice(S, p, 99999999999999));
     PutNext(prvStore, _lsStore);
     EXIT;
    ELSE
     _lsStore:=lsStore.Next;
    END;
   END; (* LOOP *)
  END;
  RETURN Result;
 END {Replace};

 PUBLIC PROCEDURE Get(_lsStore: tlsStore): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="";
  WHILE ~!_lsStore DO
   Access(_lsStore);
   Result:=Result + lsStore.Value;
   _lsStore:=lsStore.Next;
  END;
  RETURN Result;
 END {Get};

 PUBLIC PROCEDURE GetAsSingleLine(_lsStore: tlsStore): STRING[];
 BEGIN
  RETURN L_Str.ExclIllegalChars(Get(_lsStore), L_Str.CRLF, " ");
 END {GetAsSingleLine};

BEGIN
 SETEMPTY(v_empty_lsStore);
END.
