(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose     ⥪ 㭪権  ࠡ  ᫮묨 ⨯
%Type        library
%Specific    SYS
%Modified    01.08.2011 14:37:10 ROBOT by POLAK\LDA
%Environment

Exports:

 * ROUND(Value, Step: FLOAT): FLOAT;
     㣫  筮 Step

 * TRUNC(Value, Step: FLOAT): FLOAT;

 * MIN(Val1, Val2: FLOAT): FLOAT;
     頥 쭮 祭

 * MAX(Val1, Val2: FLOAT): FLOAT;
     頥 ᨬ쭮 祭

 * ABS(Val: FLOAT): FLOAT;
     頥 ᮫ 稭

 * Div(Numer, Denom: FLOAT): NUMERIC[0];    ⥫묨 ᫠
 * Mod(Numer, Denom: FLOAT): FLOAT;         .

     Example:  -3 DIV 10 =  0;  Div(-3, 10) = 1;
               -3 MOD 10 = -3;  Mod(-3, 10) = 7;
*)

 MODULE L_Math [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Math, Str, L_Str, L_General;

 PUBLIC PROCEDURE ROUND(Value, Step: FLOAT): FLOAT;
 BEGIN
  IF Value > 0 THEN
   RETURN (Value + Step/2) DIV Step * Step;
  ELSIF Value < 0 THEN
   RETURN (Value - Step/2) DIV Step * Step;
  ELSE
   RETURN 0;
  END;
 END {ROUND};

 PUBLIC PROCEDURE TRUNC(Value, Step: FLOAT): FLOAT;
 BEGIN
  RETURN Value DIV Step * Step;
 END {TRUNC};

 PUBLIC PROCEDURE MIN(Val1, Val2: FLOAT): FLOAT;
 BEGIN
  IF Val1 < Val2 THEN
   RETURN Val1;
  ELSE
   RETURN Val2;
  END;
 END {MIN};

 PUBLIC PROCEDURE MAX(Val1, Val2: FLOAT): FLOAT;
 BEGIN
  IF Val1 > Val2 THEN
   RETURN Val1;
  ELSE
   RETURN Val2;
  END;
 END {MAX};

 PUBLIC PROCEDURE ABS(Val: FLOAT): FLOAT;
 BEGIN
  IF Val < 0 THEN
   RETURN -Val;
  ELSE
   RETURN Val;
  END;
 END {ABS};

 PUBLIC PROCEDURE Div(Numer, Denom: FLOAT): NUMERIC[0];
 BEGIN
  IF (Numer < 0) & (Numer MOD Denom # 0) THEN
   RETURN (Numer DIV Denom) - 1;
  ELSE
   RETURN Numer DIV Denom;
  END;
 END {Div};

 PUBLIC PROCEDURE  Mod(Numer, Denom: FLOAT): FLOAT;
 BEGIN
  RETURN Numer - Denom*Div(Numer, Denom);
 END {Mod};

 PUBLIC PROCEDURE Math__BisectionSearch(    StrArr: STRING[][];
                                            ArrVol: NUMERIC[0];
                                            PatStr: STRING[];
                                        VAR Idx  : NUMERIC[0]): SCAL[2];
  VAR
   r, i : NUMERIC[0];
 BEGIN
  Idx:=0; r:=ArrVol;
  WHILE Idx < r DO
   i:=(Idx + r) DIV 2;
   IF StrArr[i] < PatStr THEN
    Idx:=i + 1;
   ELSE
    r:=i;
   END;
  END;
  RETURN (Idx < ArrVol) & (StrArr[Idx] = PatStr);
 END {Math__BisectionSearch};

 PRIVATE PROCEDURE Math_BisectionSearch(StrArr: STRING[][];
                                        ArrVol: NUMERIC[0];
                                        PatStr: STRING[]): SCAL[2];
  VAR
   Idx: NUMERIC[0];
 BEGIN
  RETURN Math__BisectionSearch(StrArr, ArrVol, PatStr, Idx);
 END {Math_BisectionSearch};

 PUBLIC PROCEDURE Math__InsInOrderedArray(VAR StrArr: STRING[][];
                                          VAR ArrVol: NUMERIC[0];
                                          PatStr: STRING[]): NUMERIC[0];
  VAR
   Idx,
   i    : NUMERIC[0];
 BEGIN
  IF ~Math__BisectionSearch(StrArr, ArrVol, PatStr, Idx) THEN
   i:=ArrVol;
   WHILE i >= Idx DO
    StrArr[i+1]:=StrArr[i];
    DEC(i);
   END;
   StrArr[Idx]:=PatStr;
   INC(ArrVol);
  END;
  RETURN Idx;
 END {Math__InsInOrderedArray};

 PUBLIC PROCEDURE Math_InsInOrderedArray(VAR StrArr: STRING[][];
                                         VAR ArrVol: NUMERIC[0];
                                         PatStr: STRING[]);
  VAR
   Idx: NUMERIC[0];
 BEGIN
  Idx:=Math__InsInOrderedArray(StrArr, ArrVol, PatStr);
 END {Math_InsInOrderedArray};

 PUBLIC PROCEDURE Math_GetArraySum(Arr: NUMERIC[2][]; ArrVol: NUMERIC[0]): NUMERIC[2];
  VAR
   i: NUMERIC[0];
   S: NUMERIC[2];
 BEGIN
  SETZERO(S, i);
  WHILE i < ArrVol DO
   INC(S, Arr[i]);
   INC(i);
  END;
  RETURN S;
 END {Math_GetArraySum};

 PRIVATE PROCEDURE _HexToDec(OneValue: STRING[]): NUMERIC[0];
  CONST
   HexCodes ="0123456789ABCDEF";
  VAR
   Dec: NUMERIC[0];
 BEGIN
  Dec:=-1;
  Dec:=Str.Pos(HexCodes, Str.Cap(OneValue));
  L_General.Assert(Dec>=0, OneValue+"   ⭠ ᫮!");
  RETURN Dec;
 END {_HexToDec};

 PUBLIC PROCEDURE HexToDec(Value: STRING[]): NUMERIC[0];
  CONST
   Hex = 16;
  VAR
   i, Res, L: NUMERIC[0];
 BEGIN
  i:=0;
  Res:=0;
  L:=Str.Length(Value)-1;
  WHILE i<=L DO
   Res:=Res+_HexToDec(L_Str.Char(Value, L-i))*Math.Pow(Hex, i);
   INC(i);
  END; (* WHILE i<=L...*)
  RETURN Res;
 END {HexToDec};

 PUBLIC PROCEDURE DecToHex(OneValue: NUMERIC[0]): STRING[];
  CONST
   HexCodes ="0|1|2|3|4|5|6|7|8|9|A|B|C|D|E|F";
  VAR
   Hex: STRING[];
   Dec: NUMERIC[0];
 BEGIN
  IF OneValue < 0 THEN
   OneValue:=4294967296 + OneValue;
  END;
  Hex:="";
  REPEAT
   Dec:=OneValue MOD 16;
   Hex:=Str.Item(HexCodes, "|", Dec)+Hex;
   OneValue:=OneValue DIV 16;
  UNTIL OneValue = 0;
  RETURN Hex;
 END {DecToHex};

 PUBLIC PROCEDURE Random(Amount: NUMERIC[0]): NUMERIC[0];
 BEGIN
  RETURN HIGH_RESOLUTION_TIMER() MOD 1 * 1000000 DIV 1 MOD Amount;
 END {Random};

END.
