(*
%Copyright   (c) Polak IT
%Author      06.12.2007 12:35:13 POLAK\GAV
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    03.07.2014 11:08:33 POLAK\GAV
%Environment
*)
 MODULE L_Meter  [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, Str, L_Str, L_Prop, Math,
        L_WMEnergomera, L_WME6823, L_WME301;

 PUBLIC CONST
  mt_Electric = 0;
  mt_Water    = 1;
  mt_Heat     = 2;

  mm_Electric_Usual = 0;
  mm_Electric_6823  = 1;
  mm_Electric_301   = 2;
  mm_Electric_Pool = "6822|6823|301";

  mt_Pool = "||";

  mrk_WattageHalfhourMax = 01;     (*MtrRgKnd.MtrRgKnd*)
  mrk_Energy1            = 02;
  mrk_Energy2            = 03;
  mrk_Energy3            = 04;
  mrk_Energy4            = 05;
  mrk_CurrentWattage     = 06;

 PRIVATE PROCEDURE _IncMonth(Date: DATE; i: NUMERIC[0]): DATE;
  VAR
   Result: DATE;
   D, M, Y: NUMERIC[0];
 BEGIN
  Result:=L_DatTim.IncMonth(L_DatTim.Per(Date), i);
  UnPkDATE(Result, D, M, Y);
  Result:=PackDATE(Math.Min(L_DatTim.DAY(L_DatTim.MonthEnd(Result)), L_DatTim.DAY(Date)), M, Y);
  RETURN Result;
 END {_IncMonth};

 PUBLIC PROCEDURE PosToMeterLog(trgMeter: LIKE(Meter.Meter); D: DATE);
 BEGIN
  SETSEL(MeterLog, Meter, trgMeter);
  L_General.Assert(SRCINSEL(MeterLog, LE, D) & L_DatTim.IsActive(D, MeterLog.Date, MeterLog.DateE),
                   " ᪮ ଠ樨  稪 " + trgMeter + "  " + L_DatTim.DateStr(D));
 END {PosToMeterLog};

 PUBLIC PROCEDURE StartMtrRdout(trgMeter: LIKE(Meter.Meter); VAR PortIsOpen: SCAL[2]): LIKE(MtrRdout.MtrRdout);
  VAR
   COMPort,
   WMAddr  : NUMERIC[0];
   mDT,
   sysDT   : TIMESTAMP;
   AbNbr   : STRING[];
 BEGIN
  PortIsOpen:=0;
  L_General.CallUs(SEARCH(Meter, Meter, trgMeter));
  PosToMeterLog(trgMeter, SYSDATE());
  IF Meter.MtrType = mt_Electric THEN
   COMPort:=L_Prop.GetNumericValueFromStr(L_Str.AnyItem(MeterLog.InitPrm, ";", 0));
   WMAddr :=L_Prop.GetNumericValueFromStr(L_Str.AnyItem(MeterLog.InitPrm, ";", 1));
   PROMPT("祭. 稪 " + trgMeter);
   IF    Meter.MtrModel = mm_Electric_Usual THEN
    L_General.Assert(~!COMPort & ~!WMAddr & !L_Str.AnyItem(MeterLog.InitPrm, ";", 2),
                     " ଠ ஥ ࠬ஢: " + MeterLog.InitPrm +
                     "|᫥ १ ';' 㪠  Com-   稪");
    PortIsOpen:=1;
    L_WMEnergomera.Open(COMPort, WMAddr);
    PROMPT("஢ઠ 祭. 稪 " + trgMeter);
    AbNbr:=L_WMEnergomera.᪨();
    TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     L_General.Assert(STRTOFLD(AbNbr, SCAL) = Meter.Meter, " ᮢ ᪨ ");
    EXCEPT
    ON Exc: Exc_RunTime DO
     IF Exc.ErrorCode = L_General.ec_rt_FailedSTRTOFLD THEN
      L_General.Error('  ᪮  稪 ⢥⨫ "'+AbNbr+'"');
     ELSE
      RAISE();
     END;
    END; (* TRY *)

    L_General.Assert(L_WMEnergomera.᪮() = Meter.Serial, " ᮢ ᪮ ");
    mDT:=L_WMEnergomera.⠂६(); sysDT:=SYSTIMESTAMP(); (*易⥫쭮 ६*)
   ELSIF Meter.MtrModel = mm_Electric_6823  THEN
    L_General.Assert(~!COMPort & !L_Str.AnyItem(MeterLog.InitPrm, ";", 1),
                     " ଠ ஥ ࠬ஢: " + MeterLog.InitPrm +
                     "|᫥ 㪠  Com-");
    PortIsOpen:=1;
    L_WME6823.Open(COMPort);
    PROMPT("஢ઠ 祭. 稪 " + trgMeter);
    L_General.Assert(STRTOFLD(L_WME6823.᪨(), SCAL) = Meter.Meter, " ᮢ ᪨ ");
    L_General.Assert(L_WME6823.᪮() = Meter.Serial, " ᮢ ᪮ ");
    mDT:=L_WME6823.⠂६(); sysDT:=SYSTIMESTAMP(); (*易⥫쭮 ६*)
   ELSIF Meter.MtrModel = mm_Electric_301  THEN
    L_General.Assert(~!COMPort & !L_Str.AnyItem(MeterLog.InitPrm, ";", 1 & ~!L_Str.AnyItem(MeterLog.InitPrm, ";", 2)),
                     " ଠ ஥ ࠬ஢: " + MeterLog.InitPrm +
                     "|ॡ㥬 ଠ: < Com->;;<砫쭠 ᪮ >");
    PortIsOpen:=1;
    L_WME301.Open(COMPort);
    PROMPT("஢ઠ 祭. 稪 " + trgMeter);
    L_General.Assert(STRTOFLD(L_WME301.᪨(), SCAL) = Meter.Meter, " ᮢ ᪨ ");
    L_General.Assert(L_WME301.᪮() = Meter.Serial, " ᮢ ᪮ ");
    mDT:=L_WME301.⠂६(); sysDT:=SYSTIMESTAMP(); (*易⥫쭮 ६*)
   END;
   SETEMPTY(MtrRdout.MtrRdout);
   MtrRdout.Meter   :=Meter.Meter;
   MtrRdout.TimDelta:=mDT - sysDT;
   MtrRdout.PassDTS :=sysDT;
  ELSE
   L_General.CallUs(0);
  END;
  INSERT(MtrRdout);
  RETURN MtrRdout.MtrRdout;
 END {StartMtrRdout};

 PRIVATE PROCEDURE prompt_Read(_DTS: TIMESTAMP; _MtrRgKnd: LIKE(MtrRg.MtrRgKnd));
 BEGIN
  L_General.CallUs(SEARCH(MtrRgKnd, MtrRgKnd, _MtrRgKnd));
  PROMPT("뢠. 稪 " + MtrRdout.Meter + " " + MtrRgKnd.Sign + " " + L_DatTim.TimestampStr(_DTS));
 END {prompt_Read};

 PRIVATE PROCEDURE InsMtrRg(_DTS: TIMESTAMP; _MtrRgKnd: LIKE(MtrRg.MtrRgKnd); _Value: LIKE(MtrRg.Value));
 BEGIN
  IF ~!_Value THEN
   MtrRg.MtrRdout:=MtrRdout.MtrRdout;
   MtrRg.Meter   :=MtrRdout.Meter;
   SETEMPTY(MtrRg.MtrRg);
   MtrRg.DTS     :=_DTS;
   MtrRg.MtrRgKnd:=_MtrRgKnd;
   MtrRg.Value   :=_Value;
   INSERT(MtrRg);
  END;
 END {InsMtrRg};

 PRIVATE PROCEDURE CheckTimeDelta(dts: TIMESTAMP; m: NUMERIC[0]): SCAL[2];
  VAR
   sec: FLOAT;
 BEGIN
  IF (dts - SYSTIMESTAMP()) > MtrRdout.TimDelta THEN
   RETURN 0;
  END;
  IF (dts - PackTIMESTAMP(_IncMonth(SYSDATE(), -m), SYSTIME(sec), sec) < MtrRdout.TimDelta) THEN
   RETURN 0;
  END;
  RETURN 1;
 END {CheckTimeDelta};

 PUBLIC PROCEDURE IsEnergy(trgMtrRgKnd: LIKE(MtrRg.MtrRgKnd)): SCAL[2];
 BEGIN
  RETURN (trgMtrRgKnd = mrk_Energy1) | (trgMtrRgKnd = mrk_Energy2) | (trgMtrRgKnd = mrk_Energy3) | (trgMtrRgKnd = mrk_Energy4);
 END {IsEnergy};

 PRIVATE PROCEDURE ToEnergyNum(trgMtrRgKnd: LIKE(MtrRg.MtrRgKnd)): NUMERIC[0];
 BEGIN
  IF    (trgMtrRgKnd = mrk_Energy1) THEN RETURN 1;
  ELSIF (trgMtrRgKnd = mrk_Energy2) THEN RETURN 2;
  ELSIF (trgMtrRgKnd = mrk_Energy3) THEN RETURN 3;
  ELSIF (trgMtrRgKnd = mrk_Energy4) THEN RETURN 4;
  ELSE
   L_General.CallUs(0);
  END;
 END {ToEnergyNum};

 PRIVATE PROCEDURE InsEnergyOnDayBeg(_MtrRgKnd: LIKE(MtrRg.MtrRgKnd); d: DATE);
  VAR
   sd    : DATE;
   _Value: LIKE(MtrRg.Value);
 BEGIN
  sd:=L_DatTim.GetDateOfVARIANTDATE(L_DatTim.GetSysVARIANTDATE() + MtrRdout.TimDelta);
  IF Meter.MtrModel = mm_Electric_Usual THEN
   IF d # sd THEN
    RETURN;
   END;
  ELSIF Meter.MtrModel = mm_Electric_6823  THEN
   IF (d < sd - 3) | (d > sd) THEN
    RETURN;
   END;
  ELSIF Meter.MtrModel = mm_Electric_301  THEN
   IF (d < sd - 44) | (d > sd) THEN
    RETURN;
   END;
  END;
  IF ~SELECT(MtrRg, Meter, MtrRdout.Meter, _MtrRgKnd, d) THEN
   prompt_Read(PackTIMESTAMP(d, 00:00), _MtrRgKnd);
   IF    Meter.MtrModel = mm_Electric_Usual THEN
    _Value:=L_WMEnergomera.ࣨ砫⮪(ToEnergyNum(MtrRgKnd.MtrRgKnd));
   ELSIF Meter.MtrModel = mm_Electric_6823  THEN
    _Value:=L_WME6823.ࣨ砫⮪(ToEnergyNum(MtrRgKnd.MtrRgKnd), d, sd);
   ELSIF Meter.MtrModel = mm_Electric_301  THEN
    _Value:=L_WME301.ࣨ砫⮪(ToEnergyNum(MtrRgKnd.MtrRgKnd), d, sd);
   END;
   InsMtrRg(PackTIMESTAMP(d, 00:00), _MtrRgKnd, _Value);
  END;
 END {InsEnergyOnDayBeg};

 PRIVATE PROCEDURE InsEnergyOnMonthBeg(mb: DATE; _MtrRgKnd: LIKE(MtrRg.MtrRgKnd));
  VAR
   _Value: LIKE(MtrRg.Value);
   SM    : DATE;
 BEGIN
  IF ~SELECT(MtrRg, Meter, MtrRdout.Meter, _MtrRgKnd, mb) THEN
   prompt_Read(PackTIMESTAMP(mb, 00:00), _MtrRgKnd);
   IF    Meter.MtrModel = mm_Electric_Usual THEN
    _Value:=L_WMEnergomera.ࣨ挥(ToEnergyNum(MtrRgKnd.MtrRgKnd),
                                                L_DatTim.MONTH(L_DatTim.IncMonth(mb, -1)) + 1);
   ELSIF Meter.MtrModel = mm_Electric_6823  THEN
    SM    :=L_DatTim.MonthBeg(L_DatTim.GetDateOfVARIANTDATE(L_DatTim.GetSysVARIANTDATE() + MtrRdout.TimDelta));
    _Value:=L_WME6823.ࣨ挥(ToEnergyNum(MtrRgKnd.MtrRgKnd), mb, SM);
   ELSIF Meter.MtrModel = mm_Electric_301  THEN
    SM    :=L_DatTim.MonthBeg(L_DatTim.GetDateOfVARIANTDATE(L_DatTim.GetSysVARIANTDATE() + MtrRdout.TimDelta));
    _Value:=L_WME301.ࣨ砫(ToEnergyNum(MtrRgKnd.MtrRgKnd), mb, SM);
   END;
   InsMtrRg(PackTIMESTAMP(mb, 00:00), _MtrRgKnd, _Value);
  END;
 END {InsEnergyOnMonthBeg};

 PRIVATE PROCEDURE InsWattageHalfhourMax(dts: TIMESTAMP);
  VAR
   _Value: LIKE(MtrRg.Value);
 BEGIN
  IF ~SELECT(MtrRg, Meter, MtrRdout.Meter, MtrRgKnd.MtrRgKnd, dts) THEN
   IF CheckTimeDelta(dts + 0.5/24, 2) THEN
    prompt_Read(dts, MtrRgKnd.MtrRgKnd);
    IF    Meter.MtrModel = mm_Electric_Usual THEN
     _Value:=L_WMEnergomera.魮쏮ᮢ(L_DatTim.GetDateOfTIMESTAMP(dts), L_DatTim.GetTimeOfTIMESTAMP(dts));
    ELSIF Meter.MtrModel = mm_Electric_6823  THEN
     _Value:=L_WME6823.魮쏮ᮢ     (L_DatTim.GetDateOfTIMESTAMP(dts), L_DatTim.GetTimeOfTIMESTAMP(dts));
    ELSIF Meter.MtrModel = mm_Electric_301  THEN
     _Value:=L_WME301.魮쏮ᮢ      (L_DatTim.GetDateOfTIMESTAMP(dts), L_DatTim.GetTimeOfTIMESTAMP(dts));
    END;
    InsMtrRg(dts, MtrRgKnd.MtrRgKnd, _Value);
   END;
  END;
 END {InsWattageHalfhourMax};

 PRIVATE PROCEDURE TurnOnDate(trgMeter: LIKE(Meter.Meter); OnDate: DATE): DATE;
  VAR
   d: DATE;
 BEGIN
  SETEMPTY(d);
  SAVE(MeterLog);
  SETSEL(MeterLog, Meter, trgMeter);
  SRCINSEL(MeterLog, LE, , OnDate);
  WHILE OCCURE(MeterLog) & MeterLog.TurnedOn DO
   d:=MeterLog.Date;
   PREV(MeterLog);
  END; (* WHILE OCCURE(MeterLog) ... *)
  RESTORE(MeterLog);
  RETURN d;
 END {TurnOnDate};

 PUBLIC PROCEDURE FillMtrRdout();
   VAR
    mb,
    d,
    UpToD  : DATE;
    dts    : TIMESTAMP;
    t,
    UpToT  : TIME;
    _Value : LIKE(MtrRg.Value);
 BEGIN
  UnPkTIMESTAMP(MtrRdout.PassDTS, UpToD, UpToT);

  IF    Meter.MtrModel = mm_Electric_Usual THEN
   L_General.CallUs(L_WMEnergomera.IsOpen());
  ELSIF Meter.MtrModel = mm_Electric_6823  THEN
   L_General.CallUs(L_WME6823.IsOpen());
  ELSIF Meter.MtrModel = mm_Electric_301  THEN
   L_General.CallUs(L_WME301.IsOpen());
  END;

  SELECT(MtrRgKnd, MtrRgKnd);
  WHILE OCCURE(MtrRgKnd) DO
   IF    (MtrRgKnd.MtrRgKnd = mrk_CurrentWattage) THEN
    prompt_Read(SYSTIMESTAMP(), mrk_CurrentWattage);
    IF    Meter.MtrModel = mm_Electric_Usual THEN
     _Value:=L_WMEnergomera.魮();
    ELSIF Meter.MtrModel = mm_Electric_6823  THEN
     _Value:=L_WME6823.魮();
    ELSIF Meter.MtrModel = mm_Electric_301  THEN
     _Value:=L_WME301.魮();
    END;
    InsMtrRg(SYSTIMESTAMP(), mrk_CurrentWattage, _Value);
   ELSIF IsEnergy(MtrRgKnd.MtrRgKnd) THEN
    SETEMPTY(mb);
    d:=Math.Max(Math.Min(TurnOnDate(Meter.Meter, UpToD), UpToD+1), _IncMonth(UpToD, -2));
    IF SELECT(MtrRg, Meter, Meter.Meter, MtrRgKnd.MtrRgKnd) & LAST(MtrRg) &
       (L_DatTim.GetDateOfTIMESTAMP(MtrRg.DTS) > d) THEN
     d:=L_DatTim.GetDateOfTIMESTAMP(MtrRg.DTS) + 1;
    END;
    WHILE d <= UpToD DO
     InsEnergyOnDayBeg(MtrRgKnd.MtrRgKnd, d);
     IF mb # L_DatTim.MonthBeg(d) THEN
      mb:=L_DatTim.MonthBeg(d);
      IF CheckTimeDelta(PackTIMESTAMP(mb, 00:00), 12) THEN
       InsEnergyOnMonthBeg(mb, MtrRgKnd.MtrRgKnd);
      END;
     END;
     INC(d);
    END;
   ELSIF (MtrRgKnd.MtrRgKnd = mrk_WattageHalfhourMax) THEN
    dts:=Math.Max(PackTIMESTAMP(Math.Min(TurnOnDate(Meter.Meter, UpToD), UpToD+1), 00:00),
                  PackTIMESTAMP(_IncMonth(UpToD, -2),                              00:00 + (UpToT - 00:00) * 2 DIV 1 / 2));
    IF SELECT(MtrRg, Meter, Meter.Meter, MtrRgKnd.MtrRgKnd) & LAST(MtrRg) & (MtrRg.DTS >= dts) THEN
     dts:=MtrRg.DTS + 0.5/24;
    END;
    WHILE dts <= MtrRdout.PassDTS DO
     InsWattageHalfhourMax(dts);
     dts:=dts + 0.5/24;
    END;
   END;
   NEXT(MtrRgKnd);
  END; (* WHILE OCCURE(MtrRgKnd) ... *)
 END {FillMtrRdout};

 PUBLIC PROCEDURE FinishMtrRdout();
 BEGIN
  PROMPT("⨥ 祭. 稪 " + MtrRdout.Meter);
  IF    Meter.MtrModel = mm_Electric_Usual THEN
   L_WMEnergomera.Close();
  ELSIF Meter.MtrModel = mm_Electric_6823  THEN
   L_WME6823.Close();
  ELSIF Meter.MtrModel = mm_Electric_301  THEN
   L_WME301.Close();
  END;
 END {FinishMtrRdout};

 PUBLIC PROCEDURE AbortMtrRdout();
 BEGIN
  IF    Meter.MtrModel = mm_Electric_Usual THEN
   L_WMEnergomera.Abort();
  ELSIF Meter.MtrModel = mm_Electric_6823  THEN
   L_WME6823.Abort();
  ELSIF Meter.MtrModel = mm_Electric_301  THEN
   L_WME301.Abort();
  END;
 END {AbortMtrRdout};

 PUBLIC PROCEDURE FillMeterSerial();
  VAR
   COMPort,
   WMAddr   : NUMERIC[0];
 BEGIN
  L_General.CallUs(OCCURE(Meter));
  L_General.Assert(!Meter.Serial, "᪮  㦥 ");
  L_General.Assert(~SELECT(MtrRdout, Meter, Meter.Meter), "⨬  ᪮   稨  ");
  PosToMeterLog(Meter.Meter, SYSDATE());
  IF Meter.MtrType = mt_Electric THEN
   COMPort:=L_Prop.GetNumericValueFromStr(L_Str.AnyItem(MeterLog.InitPrm, ";", 0));
   WMAddr :=L_Prop.GetNumericValueFromStr(L_Str.AnyItem(MeterLog.InitPrm, ";", 1));
   PROMPT("祭. 稪 " + Meter.Meter);
   IF    Meter.MtrModel = mm_Electric_Usual THEN
    L_WMEnergomera.Open(COMPort, WMAddr);
    PROMPT("஢ઠ 祭. 稪 " + Meter.Meter);
    L_General.Assert(STRTOFLD(L_WMEnergomera.᪨(), SCAL) = Meter.Meter,
                     " ᮢ ᪨ ");
    PROMPT("뢠 ᪮ . 稪 " + Meter.Meter);
    Meter.Serial:=L_WMEnergomera.᪮();
    REPLACE(Meter);
    L_WMEnergomera.Close();
   ELSIF Meter.MtrModel = mm_Electric_6823  THEN
    L_WME6823.Open(COMPort);
    PROMPT("஢ઠ 祭. 稪 " + Meter.Meter);
    L_General.Assert(STRTOFLD(L_WME6823.᪨(), SCAL) = Meter.Meter,
                     " ᮢ ᪨ ");
    PROMPT("뢠 ᪮ . 稪 " + Meter.Meter);
    Meter.Serial:=L_WME6823.᪮();
    REPLACE(Meter);
    L_WME6823.Close();
   ELSIF Meter.MtrModel = mm_Electric_301  THEN
    L_WME301.Open(COMPort);
    PROMPT("஢ઠ 祭. 稪 " + Meter.Meter);
    L_General.Assert(STRTOFLD(L_WME301.᪨(), SCAL) = Meter.Meter,
                     " ᮢ ᪨ ");
    PROMPT("뢠 ᪮ . 稪 " + Meter.Meter);
    Meter.Serial:=L_WME301.᪮();
    REPLACE(Meter);
    L_WME301.Close();
   END;
  ELSE
   L_General.Error("祣     稪 ⠪ ⨯");
  END;
 END {FillMeterSerial};

 PUBLIC PROCEDURE InitialBaudRate(trgMeter: LIKE(Meter.Meter)): NUMERIC[0];
 BEGIN
  PosToMeterLog(trgMeter, SYSDATE());
  RETURN L_Prop.GetNumericValueFromStr(L_Str.AnyItem(MeterLog.InitPrm, ";", 2));
 END {InitialBaudRate};

END.