(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     ⥪ 権  ࠡ  죠
%Type        library
%Specific    SYS
%Modified    19.07.2010 08:48:45 POLAK\MLB
%Environment
*)
 MODULE L_Money  [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Math, Str, L_General;

 PUBLIC PROCEDURE GetBusinessAccountingPrecision(_Date: DATE): NUMERIC[2];
 BEGIN
  IF    _Date >= L_General.DenominationDate() THEN
   RETURN 0.01;
  ELSIF _Date >= 01\02\1994 THEN
   RETURN 1;
  ELSE
   RETURN 0.01;
  END;
 END {GetBusinessAccountingPrecision};

 (* 㣫 㬬  筮 .  *)
 PUBLIC PROCEDURE RoundMoney(P: DATE; S: NUMERIC[2]): NUMERIC[2];
 BEGIN
  RETURN Math.Round(S, GetBusinessAccountingPrecision(P));
 END {RoundMoney};

 (* ஢ઠ 㬬  ᮮ⢥⢨ 筮 .  *)
 PUBLIC PROCEDURE CheckAcAccuracy(P: DATE; S: NUMERIC[2]; Text: STRING[]);
 BEGIN
  L_General.Assert(RoundMoney(P, S) = S, "㬬  ᮣ᭮ 筮 壠᪮ |"+Text);
 END {CheckAcAccuracy};

 (* ८ࠧ 㬬  ப *)
 PUBLIC PROCEDURE MoneyToStr(P: DATE; d: STRING[]; x: NUMERIC[2]): STRING[];
  VAR p: STRING[];
 BEGIN
  IF GetBusinessAccountingPrecision(P) < 1 THEN
   p:=d+"2-";
  ELSE
   p:=d+"0";
  END;
  RETURN FLDTOSTR(x, p, 0);
 END {MoneyToStr};

 (* 祭 㬬  㡫 ய *)
 PUBLIC PROCEDURE ByWord(S: NUMERIC[2]): STRING[];
  VAR
   Cop: SCAL[100];
   prf: STRING[];
 BEGIN
  IF S < 0 THEN
   prf:=" ";
   S:=(-1)*S;
  ELSE
   prf:="";
  END;
  Cop:=(S MOD 1)*100;
  RETURN Str.Cap(prf+Str.NumByWord(S DIV 1, MASCULINE, "㡫|㡫|㡫"), 0, 1)+" "+FLDTOSTR(Cop)+" "+Str.EnumObject(Cop, "||");
 END {ByWord};

 (* ८ࠧ 㬬  ப  0 . 00 . *)
 PUBLIC PROCEDURE MoneyToSpecStr(P: DATE; d: STRING[]; x: NUMERIC[2]): STRING[];
  VAR
   p  : STRING[];
   Rub: NUMERIC[0];
   Kop: SCAL[100];
 BEGIN
  Rub:=x DIV 1;
  Kop:=(x-Rub)*100;
  RETURN FLDTOSTR(Rub, d+"0")+" . "+FLDTOSTR(Kop, "")+" .";
 END {MoneyToSpecStr};

END.
