(*
%Copyright   (c) Polak IT
%Author      19.02.2008 12:42:35 POLAK\GAV
%Purpose
%Type        library
%Specific    SYS
%Modified    19.07.2010 08:54:21 POLAK\MLB
%Environment
*)
 MODULE L_MSComm [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_MSWStp, L_General, L_Str, Str;

 PUBLIC CONST
   h_None       = 0;
   h_XOnXOff    = 1;
   h_RTS        = 2;
   h_RTSXOnXOff = 3;

 PUBLIC PROCEDURE CreateMSComm(): OBJECT;
  CONST
   MSComm32Obj = "MSCOMMLib.MSComm";
   MSComm32Lic = "Zp5Gh1f+IhxAk+kW0md23TLdiBZ+JyQL";
 BEGIN
  RETURN L_MSWStp.InstallDVBCAndCreateObject2(MSComm32Obj,
                                              DECRYPTSTR(MSComm32Lic, MSComm32Obj, CALG_DES),
                                              "MSComm32",
                                              "OCX",
                                              L_General.GetREDISTRFullPath("mscomm32.cab"));
 END {CreateMSComm};

 PUBLIC PROCEDURE SetDefaultCommState(MSComm: OBJECT; Settings: STRING[]);
 BEGIN
  MSComm.InputMode  :=1;  (* binary *)
  MSComm.Settings   :=Settings;
  MSComm.DTREnable  :=0;
  MSComm.RTSEnable  :=0;
  MSComm.Handshaking:=h_None;
  MSComm.EOFEnable  :=0;
  MSComm.NullDiscard:=0;
 END {SetDefaultCommState};

 PUBLIC PROCEDURE SetBaudRate(MSComm: OBJECT; BaudRate: NUMERIC[0]);
  VAR s: STRING[];
 BEGIN
  s:=MSComm.Settings;
  MSComm.Settings:=L_Str.IntStr(BaudRate)+","
                  +Str.Item(s, ",", 1)+","
                  +Str.Item(s, ",", 2)+","
                  +Str.Item(s, ",", 3);
 END {SetBaudRate};

 PRIVATE PROCEDURE GetBaudRate(MSComm: OBJECT): NUMERIC[0];
  VAR s: STRING[];
 BEGIN
  s:=MSComm.Settings;
  RETURN STRTOFLD(Str.Item(s, ",", 0), NUMERIC);
 END {SetBaudRate};


BEGIN
END.