(*
%Copyright   (c) Polak IT
%Author      19.03.2012 12:12:48 POLAK\GAV
%Purpose       Message
%Type        library
%Specific    SYS
%Modified    25.06.2014 17:52:11 POLAK\LDA
%Environment
*)

 MODULE L_Msg [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tMessageStatus     = SCAL[3];
  tMessageImportance = SCAL[3];
  tMessageType       = SCAL[10];

 PUBLIC CONST
  mt_Org           = 0;    (* Message.Type *)
  mt_Dup           = 1;
  mt_SystemNote    = 2; (*!*)
  mt_Pool_Short    = "|";
  mt_Pool          = "室饥|室饥";

  mk_Usual         = 0;    (* Message.Kind *)
  mk_Note          = 1;
  mk_SystemNote    = 2;
  mk_ShownTrouble  = 3;
  mk_CrucialChoice = 4;
  mk_FromRobot     = 5;
  mk_bpResult      = 6;
  mk_WatchInvite   = 7;
  mk_Cmd           = 8;
  mk_Pool          = "筮|" +
                     "⪠|" +
                     "⥬|" +
                     " ஡ ࠡ⪨|" +
                     "  롮|" +
                     " ஡|" +
                     " १ 믮 |" +
                     "ਣ襭|" +
                     "|";
  mk_Pool_Short    = "筮|⪠|⥬|஡| 롮| ஡| |ਣ襭|";
  ShowDTSTitle_Pool= "ப |ப |ப |ப |ப |ப |ப |ப ⢨ ਣ襭|ப 믮 ";

  ms_Unread      = 0; (* Message.Status *)
  ms_Read        = 1;
  ms_PartialRead = 2;
  ms_Pool        = " ⠭|⠭|⠭  ⮢";

  mi_Low    = 0; (* Message.Imp *)
  mi_Normal = 1;
  mi_High   = 2;
  mi_Pool = "|ଠ쭠|᮪";

  cntrl_Pool = "|ࠢ";

 PRIVATE CONST
  ec_NoGroupMessageRsp = -0098569;
  AP_SupportGroupN = "AP_SUPPORT";

  SpcCharPref = "{";
  SpcCharSuf  = "}";

  DontShowSeenMsgPeriod = 60;

 IMPORT L_General, DBD, Str, L_Str, L_StdFrm, L_DBD, L_DatTim,  L_SysLog,
        L_Prop, L_lsStore, L_AR, L_NTF, L_WDO, L_NetWrk, L_Guard, L_ACL, L_PCS;

 PRIVATE PROCEDURE UserOffline(trgAcsObj: LIKE(AcsObj.AcsObj)): SCAL[2];
 BEGIN
  SEARCH(AcsObj, AcsObj, , trgAcsObj);
  RETURN !L_NetWrk.GetAnyASBConnection(AcsObj.Name);
 END {UserOffline};

 PRIVATE PROCEDURE MakeCheckMessageNTF(trgAcsObj: LIKE(AcsObj.AcsObj); Importance: tMessageImportance);
  VAR
   ntfName: STRING[];
 BEGIN
  IF ~UserOffline(trgAcsObj) THEN
   ntfName:="nr_" + trgAcsObj + "_" + L_General.curUSER;
   L_NTF.PutNTF(ntfName,
                'IMPORT L_NTF;' + L_Str.CRLF +
                'BEGIN' + L_Str.CRLF +
                ' IF !APP.Get().SesEnv.Item("RunProgAtStart") THEN' + L_Str.CRLF +
                '  L_NTF.CheckMessages(' + trgAcsObj + ', ' + FLDTOSTR(Importance) +');' + L_Str.CRLF +
                ' END;' + L_Str.CRLF +
                'END.' + L_Str.CRLF);
  END;
 END {MakeCheckMessageNTF};

 PUBLIC PROCEDURE LinkRecordDescription(): STRING[];
  VAR
   FileName: STRING[];
 BEGIN
  IF OCCURE(Message) & ~!Message.FileId THEN
   TRY
    L_AR.GrantRightsUnconditionally();
    FileName:=DBD.FileIdToName(Message.FileId);
    IF SELECT(^FileName, RECORDID, Message.RecordId) THEN
     RETURN L_SysLog.GetObjectDescription(FileName) + ": " +
            Str.Replace(L_DBD.GetPrimaryIndexValue(FileName), "|", ",");
    ELSE
     RETURN '[뫪  , ன 㦥 ]';
    END;
   EXCEPT
   END; (* TRY *)
  ELSE
   RETURN "";
  END;
 END {LinkRecordDescription};

 PRIVATE PROCEDURE MakeWatchMeNTF(trgAcsObj: LIKE(AcsObj.AcsObj));
  VAR
   ntfName: STRING[];
 BEGIN
  ntfName:="Watch" + "_" + trgAcsObj;
  L_NTF.PutNTF(ntfName,
               'IMPORT L_NTF;' + L_Str.CRLF +
               'BEGIN' + L_Str.CRLF +
               'L_NTF.Watch(' + trgAcsObj + ');' + L_Str.CRLF +
               'END.' + L_Str.CRLF);
 END {MakeWatchMeNTF};

 PUBLIC PROCEDURE NotifyCurMessage(Silent: SCAL[2]);
 BEGIN
  IF    Message.Kind = mk_WatchInvite THEN
   IF UserOffline(Message.Rsp) THEN
    IF ~Silent THEN
     L_StdFrm.Inform("   짮⥫ '" + AcsObj.Name + "'  ࠡ⠥  ⮏. ");
    END;
   ELSE
    IF Message.Status = ms_Unread THEN
     MakeWatchMeNTF(Message.Rsp);
    END;
   END;
  ELSIF Message.Type = mt_Org THEN
   IF ~Message.IsGroup & UserOffline(Message.Rsp) THEN
    IF ~Silent THEN
     L_StdFrm.Inform("   짮⥫ '" + AcsObj.Name + "'  ࠡ⠥  ⮏. " +
                     "|( ᬮ  ᮮ饭 )");
    END;
   ELSE
    SELECT(Message, Org, , Message.Message);
    WHILE OCCURE(Message) DO
     IF Message.Status = ms_Unread THEN
      SETEMPTY(Message.ViewDTS);
      REPLACE(Message);
      MakeCheckMessageNTF(Message.Blng, Message.Imp);
     END;
     NEXT(Message);
    END; (* WHILE OCCURE(Message) ... *)
   END;
  ELSE
   L_General.CallUs((Message.Type = mt_Dup) & !Message.Org & Silent); (* ᮮ饭  "" *)
   MakeCheckMessageNTF(Message.Blng, Message.Imp);
  END;
 END {NotifyCurMessage};

 PRIVATE PROCEDURE intMakeMessageDuplicate(VAR Cnt: NUMERIC[0]);
 BEGIN
  SAVE(Message);
  L_General.CallUs((Message.Type = mt_Org) & !Message.Org);
  Message.Type:=mt_Dup;
  Message.Org :=Message.Message;
  SETEMPTY(Message.Message);
  Message.Rsp :=Message.Blng;
  Message.Blng:=AcsObj.AcsObj;
  IF Message.Rsp = Message.Blng THEN
   Message.Status:=ms_Read;
  END;
  INSERT(Message);
  RESTORE(Message);
  INC(Cnt);
 END {intMakeMessageDuplicate};

 PUBLIC PROCEDURE AcsObjIsRobot(trgAcsObj: LIKE(AcsObj.AcsObj)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(AcsObj);
  SAVE(AOMem);
  Result:=SEARCH(AcsObj, AcsObj, trgAcsObj) &
          ((AcsObj.ManAssT = L_AR.aomat_Robot) | (AcsObj.AcsObj = L_Guard.AcsObjOfGuard()));
  RESTORE(AOMem);
  RESTORE(AcsObj);
  RETURN Result;
 END {AcsObjIsRobot};

 PUBLIC PROCEDURE MakeMessageDuplicate(forManagers: SCAL[2]);
  VAR
   Cnt      : NUMERIC[0];
   D        : DATE;
   MakeMsg  : SCAL[2];
   trgGroup,
   apsGroup : LIKE(AcsObj.AcsObj);
 BEGIN
  Cnt:=0;
  SEARCH(AcsObj, AcsObj, , Message.Rsp);
  IF AcsObj.Type = L_AR.aot_User THEN
   intMakeMessageDuplicate(Cnt);
  ELSE
   trgGroup:=AcsObj.AcsObj;
   SAVE(AcsObj);
   L_General.CallUs(L_AR.StandOnGroup(AP_SupportGroupN));
   apsGroup:=AcsObj.AcsObj;
   RESTORE(AcsObj);
   Message.IsGroup:=1;
   REPLACE(Message);
   D  :=L_DatTim.GetDateOfTIMESTAMP(Message.DTS);
   SELECT(AOMem, AcsObj, , AcsObj.AcsObj);
   WHILE OCCURE(AOMem) DO
    IF ~forManagers | AOMem.Manager THEN
     SEARCH(AcsObj, AcsObj, , AOMem.AcsObj2);
     SAVE(AOMem);
     MakeMsg:=~AcsObjIsRobot(AcsObj.AcsObj) &
              L_DatTim.IsActive(SYSDATE(), AcsObj.Begin, AcsObj.Till) &
              (forManagers | (trgGroup = apsGroup) | ~SEARCH(AOMem, AcsObj, apsGroup, AcsObj.AcsObj));
     RESTORE(AOMem);
     IF MakeMsg THEN
      intMakeMessageDuplicate(Cnt);
     END; (* IF L_DatTim.IsActive(D ... *)
    END; (* IF ~forManagers | AOMem.Manager... *)
    NEXT(AOMem);
   END; (* WHILE OCCURE(AOMem) ... *)
   IF Cnt = 0 THEN
    RAISE(ec_NoGroupMessageRsp, " 㯯 " + Message.Rsp + "   짮⥫");
   END;
  END;
 END {MakeMessageDuplicate};

 PUBLIC PROCEDURE GetCurRecId(    FileName: STRING[];
                              VAR FileId  : LIKE(Message.FileId);
                              VAR RecordId: LIKE(Message.RecordId)): SCAL[2];
  VAR
   i   : NUMERIC[0];
   Link,
   cooFile: STRING[];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   FileName:=L_PCS.GetPrototype(FileName);
   IF DBD.FieldExist(^FileName, RECORDID) THEN
    FileId  :=DBD.FileNameToId(FileName);
    RecordId:=^FileName.RECORDID;
    RETURN 1;
   END;
   i:=DBD.LinkAmount(^FileName);
   WHILE i > 0 DO
    DEC(i);
    Link:=DBD.LinkName(^FileName, i);
    IF (DBD.LinkKind(^FileName, ^Link) = L_General.lk_BORROW) |
       (DBD.LinkKind(^FileName, ^Link) = L_General.lk_HISTORY) THEN
     cooFile:=DBD.LinkCooFileName(^FileName, ^Link);
     CONFORM(^FileName, ^cooFile);
     IF GetCurRecId(cooFile, FileId, RecordId) THEN
      RETURN 1;
     END;
    END;
   END; (* WHILE i > 0 *)
  EXCEPT
  END;
  RETURN 0;
 END {GetCurRecId};

 PUBLIC PROCEDURE TruncDTS(DTS: TIMESTAMP): TIMESTAMP;
  VAR
   D: DATE;
   T: TIME;
   s: NUMERIC[0];
 BEGIN
  UnPkTIMESTAMP(DTS, D, T, s);
  RETURN PackTIMESTAMP(D, T);
 END {TruncDTS};

 PRIVATE PROCEDURE intMakeAnyRecordMsg(Kind       : LIKE(Message.Kind);
                                       Type       : LIKE(Message.Type);
                                       Blng,
                                       Rsp        : LIKE(AcsObj.AcsObj);
                                       Imp        : LIKE(Message.Imp);
                                       Text       : STRING[];
                                       ShowDTS    : TIMESTAMP;
                                       FileId     : LIKE(Message.FileId);
                                       RecordId   : LIKE(Message.RecordId);
                                       forManagers: SCAL[2]);
  VAR
   Cnt: NUMERIC[0];
 BEGIN
  L_General.CallUs(~!Blng);
  SETEMPTY(Message.Message);
  Message.Kind    :=Kind;
  Message.Type    :=Type;
  Message.Blng    :=Blng;
  Message.Rsp     :=Rsp;
  Message.Imp     :=Imp;
  Message.Text    :=L_lsStore.Insert(Text);
  Message.DTS     :=SYSTIMESTAMP();
  Message.ShowDTS :=ShowDTS;
  Message.IsGroup :=0;
  IF Blng = Rsp THEN
   Message.Status :=ms_Read;
  ELSE
   Message.Status :=ms_Unread;
  END;
  Message.FileId  :=FileId;
  Message.RecordId:=RecordId;
  SETEMPTY(Message.Parent, Message.Org, Message.ViewDTS);
  INSERT(Message);
  IF (Type = mt_Org) & ~!Rsp & (Rsp # Blng) THEN
   MakeMessageDuplicate(forManagers);
  END;
 END {intMakeAnyRecordMsg};

 PUBLIC PROCEDURE MakeAnyRecordMsg(Type    : LIKE(Message.Type);
                                   Blng,
                                   Rsp     : LIKE(AcsObj.AcsObj);
                                   Imp     : LIKE(Message.Imp);
                                   Text    : STRING[];
                                   ShowDTS : TIMESTAMP;
                                   FileId  : LIKE(Message.FileId);
                                   RecordId: LIKE(Message.RecordId));
 BEGIN
  L_General.CallUs((Type = mt_Org) | (Type = mt_Dup));
  intMakeAnyRecordMsg(mk_Usual, Type, Blng, Rsp, Imp, Text, ShowDTS, FileId, RecordId, 0);
 END {MakeAnyRecordMsg};

 PRIVATE PROCEDURE MakeCurRecordMsg(Kind    : LIKE(Message.Kind);
                                    Type    : LIKE(Message.Type);
                                    Blng,
                                    Rsp     : LIKE(AcsObj.AcsObj);
                                    Imp     : LIKE(Message.Imp);
                                    curFileN: STRING[];
                                    Text    : STRING[];
                                    ShowDTS : TIMESTAMP);
  VAR
   curFile: TABLE;
 BEGIN
  IF ~!curFileN THEN
   curFile :=TABLE.Get(curFileN);
   intMakeAnyRecordMsg(Kind, Type, Blng, Rsp, Imp, Text, ShowDTS, curFile.Id, ^(curFile.Fields("RECORDID").ObtainName()), 0);
  ELSE
   intMakeAnyRecordMsg(Kind, Type, Blng, Rsp, Imp, Text, ShowDTS, "", "", 0);
  END;
 END {MakeCurRecordMsg};

 PUBLIC PROCEDURE MakeCurRecordNote(curFile: STRING[]; Text: STRING[]);
 BEGIN
  MakeCurRecordMsg(mk_Note, mt_Org, L_General.curUSER, L_General.curUSER, mi_Normal, curFile, Text, SYSTIMESTAMP());
 END {MakeCurRecordNote};

 PUBLIC PROCEDURE PutCurRecordShownTrouble(curFile: TABLE; Text: STRING[]): SCAL[2];
 BEGIN
  SELECT(Message, RecordId, , curFile.Id, ^(curFile.Fields("RECORDID").ObtainName()));
  WHILE OCCURE(Message) DO
   IF (Message.Status = ms_Unread) & (L_lsStore.Get(Message.Text) = Text) THEN
    RETURN 0;
   END;
   NEXT(Message);
  END; (* WHILE OCCURE(Message) ... *)
  MakeCurRecordMsg(mk_ShownTrouble, mt_Org, L_General.curUSER, "", mi_Normal, curFile.Name, Text, SYSTIMESTAMP());
  RETURN 1;
 END {PutCurRecordShownTrouble};

 PRIVATE PROCEDURE intPutCurRecordCrucialChoice(curFileN, Text, GroupN: STRING[]; forManagers: SCAL[2]);
  VAR
   Cnt     : NUMERIC[0];
   FileId  : LIKE(Message.FileId);
   RecordId: LIKE(Message.RecordId);
   MakeMsg : SCAL[2];
 BEGIN
  Cnt:=0;
  TRY
   IF L_AR.StandOnGroup(GroupN) THEN
    IF ~!curFileN & GetCurRecId(curFileN, FileId, RecordId) THEN
     intMakeAnyRecordMsg(mk_CrucialChoice, mt_Org, L_General.curUSER, AcsObj.AcsObj, mi_Normal, Text,
                         SYSTIMESTAMP(), FileId, RecordId, forManagers);
    ELSE
     intMakeAnyRecordMsg(mk_CrucialChoice, mt_Org, L_General.curUSER, AcsObj.AcsObj, mi_Normal, Text,
                         SYSTIMESTAMP(), "", "", forManagers);
    END;
    INC(Cnt);
   END; (*IF L_AR.StandOnGroup(GroupN)*)
  EXCEPT
  ON Exc: Exc_Raise DO
   IF Exc.ErrorCode # ec_NoGroupMessageRsp THEN
    RAISE();
   END;
  END;
  IF Cnt = 0 THEN
   IF (GroupN = L_General.AdminGroupName()) & ~forManagers THEN
    Text:=Text + L_Str.CRLF + "========================" + L_Str.CRLF +
          "饭 ࠢ 㯯 " + AP_SupportGroupN + ", ..  㯯 " + GroupN +
          "    짮⥫,  室饣  㯯 " + AP_SupportGroupN;
    intPutCurRecordCrucialChoice(curFileN, Text, AP_SupportGroupN, 0);
   ELSIF L_General.IsOurEngineeringCopy() | (Str.Cap(GroupN) # AP_SupportGroupN) THEN
    Text:=Text + L_Str.CRLF + "========================" + L_Str.CRLF +
          "饭 ࠢ , ..  㯯 " + GroupN +
          "    饣 .";
    intPutCurRecordCrucialChoice(curFileN, Text, L_General.AdminGroupName(), 0);
   ELSE
    Text:=Text + L_Str.CRLF + "========================" + L_Str.CRLF +
          "饭 ࠢ ᥩ 㯯 " + AP_SupportGroupN + ", ..   " +
          "    饣 .";
    intPutCurRecordCrucialChoice(curFileN, Text, AP_SupportGroupN, 0);
   END;
  ELSE
   Message.Status :=GetGroupMessageStatus(Message.Message);
   Message.IsGroup:=1;
   REPLACE(Message);
  END;
 END {intPutCurRecordCrucialChoice};

 PUBLIC PROCEDURE PutCurRecordCrucialChoice(curFileN, Text, GroupN: STRING[]);
 BEGIN
  intPutCurRecordCrucialChoice(curFileN, Text, GroupN, 1);
 END {PutCurRecordCrucialChoice};

 PUBLIC PROCEDURE CurRecordShownTroubles_MakeRead(curFile: TABLE);
 BEGIN
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   SELECT(Message, RecordId, , curFile.Id, ^(curFile.Fields("RECORDID").ObtainName()));
   WHILE OCCURE(Message) DO
    IF (Message.Kind = mk_ShownTrouble) & (Message.Status = ms_Unread) THEN
     Message.Status:=ms_Read;
     REPLACE(Message);
    END;
    NEXT(Message);
   END; (* WHILE OCCURE(Message) ... *)
  EXCEPT
  END; (* TRY *)
 END {CurRecordShownTroubles_MakeRead};

 PUBLIC PROCEDURE MakeCurRecordSystemNote(Blng: LIKE(AcsObj.AcsObj); curFileN: STRING[]; Text: STRING[]);
  VAR
   curFile: TABLE;
 BEGIN
  curFile :=TABLE.Get(curFileN);
  intMakeAnyRecordMsg(mk_SystemNote, mt_Org, Blng, "", mi_Normal, Text, SYSTIMESTAMP(),
                      curFile.Id, ^(curFile.Fields("RECORDID").ObtainName()), 0);
  Message.Status:=ms_Read;
  REPLACE(Message);
 END {MakeCurRecordSystemNote};

 PUBLIC PROCEDURE MakeAnyRecordMsgFromNowhere(Kind    : LIKE(Message.Kind);
                                              Blng    : LIKE(AcsObj.AcsObj);
                                              Imp     : LIKE(Message.Imp);
                                              FileId  : LIKE(Message.FileId);
                                              RecordId: LIKE(Message.RecordId);
                                              Text    : STRING[];
                                              ShowDTS : TIMESTAMP);
  VAR
   Rsp: LIKE(AcsObj.AcsObj);
 BEGIN
  SEARCH(AcsObj, AcsObj, , Blng);
  IF AcsObj.Type = L_AR.aot_User THEN
   IF AcsObjIsRobot(L_General.curUSER) THEN
    Rsp:=L_General.curUSER;
   ELSE
    SETEMPTY(Rsp);
   END;
   intMakeAnyRecordMsg(Kind, mt_Dup, Blng, Rsp, Imp, Text, ShowDTS, FileId, RecordId, 0);
  ELSE
   intMakeAnyRecordMsg(Kind, mt_Org, L_General.curUSER, Blng, Imp, Text, ShowDTS, FileId, RecordId, 0);
  END;
 END {MakeAnyRecordMsgFromNowhere};

 PUBLIC PROCEDURE MakeCurRecordMsgFromNowhere(Kind    : LIKE(Message.Kind);
                                              Blng    : LIKE(AcsObj.AcsObj);
                                              Imp     : LIKE(Message.Imp);
                                              curFileN: STRING[];
                                              Text    : STRING[];
                                              ShowDTS : TIMESTAMP);
  VAR
   Rsp: LIKE(AcsObj.AcsObj);
 BEGIN
  SEARCH(AcsObj, AcsObj, , Blng);
  IF AcsObj.Type = L_AR.aot_User THEN
   IF AcsObjIsRobot(L_General.curUSER) THEN
    Rsp:=L_General.curUSER;
   ELSE
    SETEMPTY(Rsp);
   END;
   MakeCurRecordMsg(Kind, mt_Dup, Blng,              Rsp,  Imp, curFileN, Text, ShowDTS);
  ELSE
   MakeCurRecordMsg(Kind, mt_Org, L_General.curUSER, Blng, Imp, curFileN, Text, ShowDTS);
  END;
 END {MakeCurRecordMsgFromNowhere};

 PUBLIC PROCEDURE MakeCurRecordMsgFromRobot(Blng: LIKE(AcsObj.AcsObj); curFileN, Text: STRING[]);
 BEGIN
  MakeCurRecordMsgFromNowhere(mk_FromRobot, Blng, mi_Normal, curFileN, Text, SYSTIMESTAMP());
 END {MakeCurRecordMsgFromRobot};

 PUBLIC PROCEDURE MakeCurRecordMsg_bpResult(Blng: LIKE(AcsObj.AcsObj); curFileN, Text: STRING[]);
 BEGIN
  MakeCurRecordMsgFromNowhere(mk_bpResult,  Blng, mi_Normal, curFileN, Text, SYSTIMESTAMP());
 END {MakeCurRecordMsg_bpResult};

 PUBLIC PROCEDURE MakeMsg(Rsp: LIKE(AcsObj.AcsObj); Imp: LIKE(Message.Imp); Text: STRING[]);
 BEGIN
  MakeCurRecordMsg(mk_Usual, mt_Org, L_General.curUSER, Rsp, Imp, "", Text, SYSTIMESTAMP());
 END {MakeMsg};

 PUBLIC PROCEDURE MakeAutoBroadcastMessage(Groups: STRING[][]; Text: STRING[]);
  VAR
   Msg   : STRING[];
   Group : STRING[];
   grpCnt: NUMERIC[0];
   grpLst: STRING[];
 BEGIN
  grpCnt:=0;
  grpLst:="";
  FOR_EACH Group IN Groups DO
   IF ~!grpLst THEN
    INC(grpLst, ", ");
   END;
   INC(grpLst, Group);
   INC(grpCnt);
  END;
  L_General.CallUs(grpCnt > 0);
  IF   grpCnt = 1 THEN
   Msg:="ଫ ᮮ饭 짮⥫ 㯯 " + grpLst;
  ELSE
   Msg:="ଫ ᮮ饭 짮⥫ 㯯:" + "|" + grpLst;
  END;
  INC(Msg, "|" + "( ਢ ⥪ ᮮ饭)" + "|" + L_Str.Repeat("", 64) + "|" + Text);
  L_ACL.Inform(Msg, "");
  SAVE(AcsObj);
  FOR_EACH Group IN Groups DO
   L_General.CallUs(L_AR.StandOnGroup(Group));
   MakeMsg(AcsObj.AcsObj, mi_Low, Text);
  END;
  RESTORE(AcsObj);
 END {MakeAutoBroadcastMessage};

 PUBLIC PROCEDURE GetGroupMessageStatus(OriginalMessage: LIKE(Message.Message)): LIKE(Message.Status);
  VAR
   Result: LIKE(Message.Status);
 BEGIN
  SETEMPTY(Result);
  TRY [RESTORE_CURSORS(RC_ON), ABORT_AFTER(AA_ON)]
   RTI.Get().TryBlock.AccessDataMode:=adm_HOTTEST;
   SELECT(Message, Org, , OriginalMessage);
   Result:=Message.Status;
   WHILE NEXT(Message) DO
    IF Message.Status # Result THEN
     Result:=ms_PartialRead;
     LAST(Message);
    END;
   END; (* WHILE OCCURE(Message) ... *)
  EXCEPT
  END;
  RETURN Result;
 END {GetGroupMessageStatus};

 PUBLIC PROCEDURE ToggleMessageStatus();
  VAR
   GroupMessageStatus: LIKE(Message.Status);
 BEGIN
  IF    Message.Type = mt_Org THEN
   L_General.Assert(Message.Rsp = Message.Blng, " 室饥 ᮮ饭.  ﭨ 饭");
  END;
  IF Message.Status = ms_Unread THEN
   Message.Status:=ms_Read;
  ELSE
   Message.Status:=ms_Unread;
   SETEMPTY(Message.ViewDTS);
  END;
  REPLACE(Message);
  IF    (Message.Type # mt_Org) & ~!Message.Org THEN
   SAVE(Message);
   SEARCH(Message, Message, , Message.Org);
   GroupMessageStatus:=GetGroupMessageStatus(Message.Message);
   IF Message.Status # GroupMessageStatus THEN
    Message.Status:=GroupMessageStatus;
    REPLACE(Message);
   END;
   RESTORE(Message);
  END;
 END {ToggleMessageStatus};

 PRIVATE PROCEDURE NotSeenMsg(): SCAL[2];
 BEGIN
  RETURN !Message.ViewDTS | (Message.ViewDTS <= SYSTIMESTAMP() - DontShowSeenMsgPeriod/60/24);
 END {NotSeenMsg};

 PRIVATE PROCEDURE GoodImportance(Importance: tMessageImportance): SCAL[2];
 BEGIN
  RETURN (DBD.BaseName() = "JOURNAL") & (Message.Imp >= Importance);
 END {GoodImportance};

 PRIVATE PROCEDURE intGetUnreadMessage(    Rsp         : LIKE(AcsObj.AcsObj);
                                           Importance  : tMessageImportance;
                                           SignAsViewed: SCAL[2];
                                       VAR List        : STRING[];
                                       VAR MaxImprtnc  : tMessageImportance);
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
   SETEMPTY(List);
   MaxImprtnc:=mi_Low;
   SELECT(Message, Blng, , Rsp, ms_Unread);
   WHILE OCCURE(Message) DO
    IF ((Message.Kind = mk_Note)                                    |
        (Message.Kind = mk_Usual)         & (Message.Type = mt_Dup) |
        (Message.Kind = mk_CrucialChoice) & (Message.Type = mt_Dup) |
        (Message.Kind = mk_FromRobot)     & (Message.Type = mt_Dup) |
        (Message.Kind = mk_bpResult)      & (Message.Type = mt_Dup)  ) &
       NotSeenMsg() &
       (GoodImportance(Importance) | (Message.ShowDTS <= SYSTIMESTAMP())) THEN
     IF SignAsViewed THEN
      Message.ViewDTS:=SYSTIMESTAMP();
      REPLACE(Message);
     END;
     List:=List + Message.Message + "|";
     IF Message.Imp >= MaxImprtnc THEN
      MaxImprtnc:=Message.Imp;
     END;
    END;
    NEXT(Message);
   END; (* WHILE OCCURE(Message) ... *)
  EXCEPT
  ON Exc: Exc_AccessDeny DO
   IF SignAsViewed THEN
    RAISE();
   ELSE
    SETEMPTY(List);
   END;
  END;
 END {intGetUnreadMessage};

 PUBLIC PROCEDURE NotifyNewMessages(trgAcsObj: LIKE(AcsObj.AcsObj); trgImportance: tMessageImportance);
  VAR
   msgMaxImportance: tMessageImportance;
   msgList         : STRING[];
 BEGIN
  TRY
   TABLE.Get("Message").AccessDataMode:=adm_HOTTEST;
   intGetUnreadMessage(trgAcsObj, trgImportance, 0, msgList, msgMaxImportance);
   IF ~!msgList THEN
    MakeCheckMessageNTF(trgAcsObj, msgMaxImportance);
   END;
  EXCEPT
  END;
 END {NotifyNewMessages};

 PRIVATE PROCEDURE GetDepth(S: STRING[]; Width: NUMERIC[0]; VAR Depth: NUMERIC[0]; VAR ActiveChar: STRING[1]);
  CONST
   FormDepthWOMessageText = 13;
  VAR
   R      : STRING[][100];
   Rest   : STRING[];
   i,
   awDepth: NUMERIC[0];
 BEGIN
  GE_APPWIN_SIZE( , awDepth);
  Str.Format(R, S, Width, LEFT, Rest);
  i:=HIGH(R);
  WHILE !R[i] DO
   DEC(i);
  END;
  IF    i < (awDepth DIV 3) THEN
   Depth:=awDepth DIV 3 + 1;
   ActiveChar:="N";
  ELSIF i > (awDepth - FormDepthWOMessageText) THEN
   Depth:=awDepth - FormDepthWOMessageText;
   ActiveChar:="";
  ELSE
   Depth:=awDepth - FormDepthWOMessageText;
   ActiveChar:="N";
  END;
 END {GetDepth};

 PUBLIC PROCEDURE CheckIncomingMessage(Importance: tMessageImportance);
  CONST
   Width = 74;
   ShowMessageDelay = 300;
  VAR
   s,
   FileName,
   List,
   Current,
   FormStr,
   lrDescr,
   Vars,
   Texts      : STRING[];
   ActiveChar : STRING[1];
   i,
   MsgCount,
   refCount,
   Choice,
   Depth,
   Delay      : NUMERIC[0];
   MaxImprtnc : tMessageImportance;
 BEGIN
  SETZERO(MsgCount, refCount);
  TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)]
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   TRY
    IF VAR_IMPL.Get(L_General.curUSER).Initialized THEN
     intGetUnreadMessage(L_General.curUSER, Importance, 1, List, MaxImprtnc);
    ELSE
     SETEMPTY(List);
    END;
   EXCEPT
   ON Exc: Exc_Root DO
    SETEMPTY(List);
   END;
   IF ~!List THEN
    SETEMPTY(Texts);
    LOOP
     Current:=L_Str.PoolItem(List, MsgCount);
     IF !Current THEN
      EXIT;
     END;
     SEARCH(Message, Message, , Current);

     IF SEARCH(AcsObj, AcsObj, Message.Rsp) THEN
      s:=AcsObj.Name + " " + AcsObj.FullName;
     ELSE
      s:="";
     END;
     s:=s + L_Str.Repeat("", Width);
     Texts:=Texts +
            "" + L_Str.Left(s, Width - 18) + "" + L_DatTim.TimestampStr(Message.DTS) + "" + L_Str.CRLF +
            L_lsStore.Get(Message.Text);
     lrDescr:=LinkRecordDescription();
     IF ~!lrDescr THEN
      INC(Texts, L_Str.CRLF + "[" + lrDescr + "]");
      INC(refCount);
     END;
     INC(Texts, L_Str.CRLF + L_Str.CRLF);
     INC(MsgCount);
    END;
    GetDepth(Texts, Width, Depth, ActiveChar);
    FormStr:=Str.Align(L_DatTim.DateTimeStr(SYSDATE(), SYSTIME()), Width + 2, RIGHT)+
             "|%" + L_Str.IntStr(Width) + "," + L_Str.IntStr(Depth) + ActiveChar + "I" +
             L_Str.Repeat("|", Depth);
    Vars:="Texts, ";
    FormStr:=FormStr + "|" + L_StdFrm.DrawButton(" ३  '{} ᮮ饭' ", Width - 10, "FB") + "|";
    Vars:=Vars + "Delay";
    IF MsgCount = 1 THEN
     IF    refCount = 0 THEN
      FormStr:=FormStr + L_StdFrm.DrawButton(" ⬥  {}⥭ ", Width - 10, "DB") + "|";
     ELSIF refCount = 1 THEN
      FormStr:=FormStr + L_StdFrm.DrawButton(" ⬥  {}⥭  ३   ", Width - 10, "DB") + "|";
     END;
    END;
    FormStr:=FormStr + L_StdFrm.DrawButton(" {}⬥ (%T) ", Width - 11, "X");
    IF MAINTHREADTRNCOUNT() = 0 THEN
     Delay :=(DontShowSeenMsgPeriod + L_Guard.MessagesCheckPeriod + 10) * 60;
    ELSE
     Delay :=ShowMessageDelay;
    END;
    Choice :=STDFORM(FormStr,
                    L_Str.PoolItem("  ᮮ饭 |  ᮮ饭 ", MsgCount > 1),
                    INFORM_NEUTRAL, , ^Vars);
    IF    Choice = 1 THEN
     SETLIKEMENUPROMPT("室  ᮮ饭 ந ᫥ 砭 ।஢");
     LIKEMENU(View, "Msg_My 1");
    ELSIF Choice = 2 THEN
     SEARCH(Message, Message, , L_Str.PoolItem(List, 0));
     ToggleMessageStatus();
     IF refCount = 1 THEN
      FileName:=DBD.FileIdToName(Message.FileId);
      L_General.Assert(SEARCH(^FileName, RECORDID, Message.RecordId),
                       "   " + Message.RecordId + '  䠩' +
                       '|"' + DBD.FileDescription(^FileName) + '"');
      L_DBD.extPosToCurRecordOfTable(DATABASE.Get().Tables(FileName));
     END;
    ELSE
     IF Delay > 0 THEN
      Delay:=5;
      STDFORM("|" + L_Str.PoolItem(" C饭  ⠭ | 饭  ⠭ ", MsgCount > 1) +
              "||"+L_StdFrm.DrawButton("  (%T) ", 0, "X"), , INFORM, , Delay);
     ELSE
      (* 10   ॠ樨.   ᮮ饭 묨 *)
      L_General.RaiseLockReleaseException();
     END;
    END;
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
 END {CheckIncomingMessage};

 PUBLIC PROCEDURE GetWatchInvite(Rsp: LIKE(AcsObj.AcsObj)): STRING[];
  VAR
   List: STRING[];
 BEGIN
  List:="";
  SELECT(Message, Blng_Knd, , Rsp, mk_WatchInvite, ms_Unread);
  WHILE OCCURE(Message) DO
   IF Message.Type = mt_Dup THEN
    IF Message.ShowDTS > SYSTIMESTAMP() THEN
     List:=List + Message.Message + "|";
     NEXT(Message);
    ELSE
     IF NEXT(Message) THEN
      SAVE(Message);
      PREV(Message);
     ELSE
      SAVE(Message);
      LAST(Message);
     END;
     TRY [TRANSACTION(TRANSACTION_SLAVE)]
      ToggleMessageStatus();
     EXCEPT
     END;
     RESTORE(Message);
    END;
   ELSE
    NEXT(Message);
   END;
  END; (* WHILE OCCURE(Message) ... *)
  RETURN List;
 END {GetWatchInvite};

 PUBLIC PROCEDURE SliceWatchInviteMsgText(VAR ConnNo : LIKE(ccCnct.CnctNo);
                                          VAR Control: SCAL[2];
                                          VAR Text   : STRING[]);
  VAR
   pos: NUMERIC[0];
   s  : STRING[];
 BEGIN
  s      :=L_lsStore.Get(Message.Text);
  pos    :=Str.Pos(s, L_Str.CRLF, , BACKWARD);
  Text   :=Str.Slice(s, 0, pos);

  s      :=Str.Slice(s, pos + Str.Length(L_Str.CRLF), Str.Length(s));
  ConnNo :=STRTOFLD(Str.Item(s, " ", 1), SCAL);

  s      :=Str.Item(s, "()", 1);
  Control:=L_Str.PositionInPool(cntrl_Pool, s);
 END {SliceWatchInviteMsgText};

 PUBLIC PROCEDURE CombineWatchInviteMsgText(ConnNo : LIKE(ccCnct.CnctNo);
                                            Control: SCAL[2];
                                            Text   : STRING[]): STRING[];
 BEGIN
  RETURN Text + L_Str.CRLF + "祭: " + ConnNo + " (" +
         L_Str.PoolItem(cntrl_Pool, Control) + ")";
 END {CombineWatchInviteMsgText};

 PUBLIC PROCEDURE CheckWatchInvite();
  CONST
   Width = 74;
   ShowMessageDelay = 300;
  VAR
   trgConnNo : LIKE(ccCnct.CnctNo);
   List,
   s,
   Current,
   FormStr,
   Text      : STRING[];
   ActiveChar: STRING[1];
   MsgCount,
   Choice,
   Depth,
   Delay     : NUMERIC[0];
   Control   : SCAL[2];
 BEGIN
  TRY
   IF VAR_IMPL.Get(L_General.curUSER).Initialized THEN
    List:=GetWatchInvite(L_General.curUSER);
   ELSE
    SETEMPTY(List);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   SETEMPTY(List);
  END;
  IF ~!List THEN
   MsgCount:=0;
   LOOP
    Current:=L_Str.PoolItem(List, MsgCount);
    IF !Current THEN
     EXIT;
    END;
    INC(MsgCount);
    SEARCH(Message, Message, , Current);
    SEARCH(AcsObj, AcsObj, , Message.Rsp);
    s:=AcsObj.Name + "--" + AcsObj.FullName + L_Str.Repeat("-", Width);
    Text:="--" + L_Str.Left(s, Width - 23) + "--" + L_DatTim.TimestampStr(Message.DTS) + "--" + L_Str.CRLF;
    SliceWatchInviteMsgText(trgConnNo, Control, s);
    Text:=Text + s;
    GetDepth(Text, Width, Depth, ActiveChar);
    FormStr:=Str.Align(L_DatTim.TimestampStr(SYSTIMESTAMP()), Width + 2, RIGHT) +
             "|%" + L_Str.IntStr(Width) + "," + L_Str.IntStr(Depth) + ActiveChar + "I" +
             L_Str.Repeat("|", Depth) +
             "|" + L_StdFrm.DrawButton(" {} ",    20, "FDB") +
             " " + L_StdFrm.DrawButton(" {}  ", 20, "FB") +
             " " + L_StdFrm.DrawButton(" {}⬥ (%T) ",     20, "X");

    Delay :=ShowMessageDelay;
    Choice:=STDFORM(FormStr,
                    " ਣ襭 " + L_Str.PoolItem(" |ࠢ", Control) + " 祭 ",
                    QUESTION, , Text, Delay);

    TRY [TRANSACTION(TRANSACTION_SLAVE)]
     ToggleMessageStatus();
    EXCEPT
    END;
    IF Choice = 1 THEN
     CALL(ccCnct.WatchByInvite(Control, trgConnNo, Message.Rsp));
    END;
   END; (* LOOP *)
  END; (* IF ~!List *)
 END {CheckWatchInvite};

 PRIVATE PROCEDURE AddSpecialChars(s: STRING[]): STRING[];
 BEGIN
  RETURN SpcCharPref + L_Str.CheckIllegalChars(s, SpcCharPref+SpcCharSuf) + SpcCharSuf;
 END {AddSpecialChars};

 PUBLIC PROCEDURE CombineCmdMsgText(TypeStr, Command, Text: STRING[]): STRING[];
  VAR
   Result,
   PictName: STRING[];
 BEGIN
  SETEMPTY(Result);
  L_Prop.putRES(Result, TypeStr);
  L_Prop.putRES(Result, Command);
  Result:=Text + AddSpecialChars(Result);
  RETURN Result;
 END {CombineCmdMsgText};

 PUBLIC PROCEDURE SliceCmdMsgText(VAR Type, Command, Text: STRING[]);
  VAR
   s      : STRING[];
   PosPref,
   PosSuf : NUMERIC[0];
 BEGIN
  s      :=L_lsStore.Get(Message.Text);
  PosPref:=Str.Pos(s, SpcCharPref);
  PosSuf :=Str.Pos(s, SpcCharSuf);
  Text   :=Str.Slice(s, 0, PosPref);
  s      :=Str.Slice(s, PosPref+1, PosSuf - PosPref - 1);
  Type   :=L_Prop.getRES(s, 0);
  Command:=L_Prop.getRES(s, 1);
 END {SliceCmdMsgText};

 PUBLIC PROCEDURE GetCommandList(Rsp: LIKE(AcsObj.AcsObj); All: SCAL[2]): STRING[];
  VAR
   List: STRING[];
 BEGIN
  List:="";
  IF All THEN
   TRY
    RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
    SELECT(Message, BlngTKnd, , Rsp, mt_Dup, mk_Cmd);
    SRCINSEL(Message, GE, , L_DatTim.GetTIMESTAMPOfDate(SYSDATE()-2));
    WHILE OCCURE(Message) DO
     IF Message.ShowDTS > SYSTIMESTAMP() THEN
      List:=List + Message.Message + "|";
     END;
     NEXT(Message);
    END; (* WHILE OCCURE(Message) ... *)
   EXCEPT
   END;
  ELSE
   SELECT(Message, Blng_Knd, , Rsp, mk_Cmd, ms_Unread);
   WHILE OCCURE(Message) DO
    IF Message.Type = mt_Dup THEN
     IF Message.ShowDTS > SYSTIMESTAMP() THEN
      List:=List + Message.Message + "|";
     ELSE
      TRY [TRANSACTION(TRANSACTION_SLAVE)]
       ToggleMessageStatus();
      EXCEPT
      END;
     END;
    END;
    NEXT(Message);
   END; (* WHILE OCCURE(Message) ... *)
  END;
  RETURN List;
 END {GetCommandList};

 PRIVATE PROCEDURE IsStdCommandType(Type: STRING[]): SCAL[2];
 BEGIN
  RETURN 0;
 END {IsStdCommandType};

 PRIVATE PROCEDURE DoStdCommand(Type, Command: STRING[]);
 BEGIN
  (*  ⠪*)
  L_General.CallUs(0);
 END {DoStdCommand};

 PUBLIC PROCEDURE DoCommandMessage(trgMessage: LIKE(Message.Message));
  VAR
   Type,
   Command,
   Text    : STRING[];
 BEGIN
  SEARCH(Message, Message, , trgMessage);
  SEARCH(AcsObj, AcsObj, , Message.Blng);
  SliceCmdMsgText(Type, Command, Text);
  TRY [TRANSACTION(TRANSACTION_SLAVE)]
   ToggleMessageStatus();
  EXCEPT
  END;
  IF IsStdCommandType(Type) THEN
   DoStdCommand(Type, Command);
  ELSE
   L_PCS.DoCommand(Type, Command);
  END;
 END {DoCommandMessage};

 PUBLIC PROCEDURE CheckCommands(fromNTF: SCAL[2]);
  VAR
   List,
   Current : STRING[];
   MsgCount: NUMERIC[0];
 BEGIN
  TRY
   IF VAR_IMPL.Get(L_General.curUSER).Initialized THEN
    List:=GetCommandList(L_General.curUSER, 0);
   ELSE
    SETEMPTY(List);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   SETEMPTY(List);
  END;
  IF ~!List THEN
   IF fromNTF THEN
    SETLIKEMENUPROMPT("");
   END;
   MsgCount:=0;
   LOOP
    Current:=L_Str.PoolItem(List, MsgCount);
    IF !Current THEN
     EXIT;
    END;
    INC(MsgCount);
    IF fromNTF THEN
     CALL(CallStub.AppendMacro('CALL, "Message.DoCommandMessage(' + Current + ')"'));
     RETURN; (* ࠢ   NTF  *)
    ELSE
     DoCommandMessage(Current);
    END;
   END; (* LOOP *)
  END; (* IF ~!List ... *)
 END {CheckCommands};

 PRIVATE PROCEDURE HasCmdMsg(Rsp: LIKE(AcsObj.AcsObj); CmdMsgList, Type, Command: STRING[]): SCAL[2];
  VAR
   Result  : SCAL[2];
   curType,
   curCmd,
   dummy,
   Current : STRING[];
   MsgCount: NUMERIC[0];
 BEGIN
  Result:=0;
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   IF ~!CmdMsgList THEN
    MsgCount:=0;
    LOOP
     Current:=L_Str.PoolItem(CmdMsgList, MsgCount);
     IF !Current | Result THEN
      EXIT;
     END;
     INC(MsgCount);
     SEARCH(Message, Message, , Current);
     SliceCmdMsgText(curType, curCmd, dummy);
     Result:=(curType = Type) & (curCmd = Command);
    END; (* LOOP *)
   END; (* IF ~!CmdMsgList ... *)
  EXCEPT
  END;
  RETURN Result;
 END {HasCmdMsg};

 PUBLIC PROCEDURE MakeCommandMessage(Type,
                                     Command,
                                     CmdMsgList,
                                     MsgText           : STRING[];
                                     LaunchFromAutoExec: SCAL[2]);
  VAR
   ShowDTS: TIMESTAMP;
   trgMessage: LIKE(Message.Message);
 BEGIN
  IF ~HasCmdMsg(AcsObj.AcsObj, CmdMsgList, Type, Command) THEN
   ShowDTS:=L_DatTim.GetTIMESTAMP(L_DatTim.GetDateOfTIMESTAMP(SYSTIMESTAMP()), 23:59);
   TRY [TRANSACTION(TRANSACTION_SLAVE)]
    MakeCurRecordMsgFromNowhere(mk_Cmd, AcsObj.AcsObj, mi_Normal, EMPTYOF(STRING[]), MsgText, ShowDTS);
    trgMessage:=Message.Message;
   EXCEPT
   END;
   IF LaunchFromAutoExec THEN
    DoCommandMessage(trgMessage);
   ELSE
    SEARCH(Message, Message, , trgMessage);
    NotifyCurMessage(1);
   END;
  END;
 END {MakeCommandMessage};

END.
