(*
%Copyright   (c) Polak Computer System
%Author      20.03.2001 13:16:17 SAN
%Purpose     ⥪  ࠡ  MS Office
%Type        library
%Specific    SYS
%Modified    18.09.2014 16:21:07 POLAK\LDA
%Environment
*)

 MODULE L_MSO [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  PrpModeType   = SCAL[7];
  PrpResultType = SCAL[5];
  tTableType    = SCAL[2];

 PUBLIC CONST
  PrpMode_Print     = 0;
  PrpMode_ToDoc     = 1;
  PrpMode_ToPDF     = 2;
  PrpMode_ToHTM     = 3;
  PrpMode_ToTmpDot  = 4;
  PrpMode_ToImage   = 5;
  PrpMode_ToDocFile = 6;

  PrpResult_Original = 0;
  PrpResult_Preview  = 1;
  PrpResult_Copy     = 2;
  PrpResult_Email    = 3;
  PrpResult_html     = 4;

  us_Using       = 0;
  us_Development = 1;
  us_Publication = 2;

  Put_Values = 0;
  Put_Fields = 1;

  fps_Soft_asStr = "fps_Soft_asStr";
  fps_Soft       = 1;

  tt_Normal = 0;
  tt_Soft   = 1;

  DefaultDocumentExtension = "doc";
  DefaultTemplateExtension = "dot";

  PeculiaritiesPrefix = "PCLRT.";

  ipb_None        = 0;
  ipb_BeforePaste = 1;
  ipb_AfterPaste  = 2;

  ipb_BeforePaste_AsStr = "ipb_BeforePaste";

  RootFolder    = "DOT";
  BY_USERFolder = RootFolder+"\BY_USER";
  TMP_LIBFolder = RootFolder+"\TMP_LIB";

  dl_Title    = 0;
  dl_Template = 1;
  dl_PrepProc = 2;
  dl_PrepDate = 3;

  dl_MaxSize  = 128;

  NoValuePrefix = "~|!+@_#)$)%(^*&";

 PUBLIC TYPE
  tDocList    = STRING[][dl_MaxSize];

 PUBLIC PERMANENT VAR
  UsingStage: SCAL[3];

 IMPORT Str, Math, L_General, L_Money, L_DatTim, L_Str, L_FIO, FIO, L_StdFrm, L_PCS,
        L_Print, L_Excel, L_XDoc, L_ACL, L_AFM;

 PRIVATE CONST
  wordCRLF = CHR(13)+CHR(10);
  wordNL   = CHR(11);
  VarsNum  = 102400;
  BkmsNum  = 128;
  PicsNum  = 128;
  PageBreakForDuplexVarName = "TheDoc.PageBreakForDuplex";

  wdFalse       = 0;
  wdTrue        = -1;
  wdFormatHTML  = 8;
  wdLine        = 5;

  wdFieldDocVariable = 64;

  wdStory        = 6;
  wdPageBreak    = 7;
  wdGoToBookmark = -1;

  PointsInMillimeter = 2.835;

  dl_MainGroup = 00;

 PUBLIC VAR
  UseTmpDot    : SCAL[2];
  PutInTables  : SCAL[2];
  PutInFields  : SCAL[2];
  IsDuplexDoc  : SCAL[2];
  UseManualFeed: SCAL[2];

 PRIVATE VAR
  wordVars          : OBJECT;

  wordBkmsNam,
  wordBkmsVal       : STRING[]  [BkmsNum];

  wordPicsBkmkNam   : STRING[]  [PicsNum];
  wordPicsFileNam   : STRING[]  [PicsNum];
  wordPicsW,
  wordPicsH         : FLOAT     [PicsNum];

  wordTablesBkmksNam: STRING[]  [BkmsNum];
  wordTablesLineCnt : NUMERIC[0][BkmsNum];
  wordTablesType    : tTableType[BkmsNum];

  wordPicsCnt,
  wordVarsCnt,
  wordBkmsCnt,
  wordTablesCnt     : NUMERIC[0];

 PRIVATE PERMANENT VAR
  dl_PrepareMode: PrpModeType;

 PUBLIC PROCEDURE wordSetVar(Nam, Val: STRING[]);
 BEGIN
  IF !Val THEN
   Val:=" ";
  ELSE
   Val:=Str.Replace(Val, L_Str.LF, "");
  END;
  IF wordVars.Exists(Nam) THEN
   wordVars.Remove(Nam);
  END;
  wordVars.Add(Nam, Val);
 END {wordSetVar};

 PUBLIC PROCEDURE wordGetVar(Nam: STRING[]): STRING[];
 BEGIN
  IF wordVars.Exists(Nam) THEN
   RETURN wordVars(Nam);
  ELSE
   RETURN " ";
  END;
 END {wordGetVar};

 PUBLIC PROCEDURE wordSetUnicodeStringVar(Nam, Val: STRING[]; CodePage: NUMERIC[0]);
 BEGIN
  IF !Val THEN
   Val:=" ";
  ELSE
   Val:=Str.Replace(Val, L_Str.LF, "");
  END;
  IF wordVars.Exists(Nam) THEN
   wordVars.Remove(Nam);
  END;
  wordVars.Add(Nam, CreateVARIANT(String, Val, CodePage));
 END {wordSetUnicodeStringVar};

 PUBLIC PROCEDURE wordSetVar_wIndex(Nam, Val: STRING[]; i: NUMERIC[0]);
 BEGIN
  wordSetVar(Nam + IndexStr(i), Val);
 END {wordSetVar_wIndex};

 PUBLIC PROCEDURE wordSetMoneyVar(_var: STRING[]; d: DATE; s: NUMERIC[2]);
 BEGIN
  IF ~!s THEN
   wordSetVar(_var, L_Money.MoneyToStr(d, "", s));
   IF s >= 0 THEN
    wordSetVar(_var + ".ByWord",         L_Money.ByWord(s));
    wordSetVar(_var + ".Numeric.ByWord", L_Str.NumericByWord(s, 2));
   ELSE
    wordSetVar(_var + ".ByWord",         "");
    wordSetVar(_var + ".Numeric.ByWord", "");
   END;
   wordSetVar(_var + ".Numeric",         L_Str.NumericStr(s, 2));
   wordSetVar(_var + ".IntegerPart" ,    L_Str.NumericStr(Math.Div(s), 0));
   wordSetVar(_var + ".Fraction" ,       L_Str.FixedIntStr(Math.Mod(s)*100, 2));
  ELSE
   wordSetVar(_var,                     "");
   wordSetVar(_var + ".ByWord",         "");
   wordSetVar(_var + ".Numeric",        "");
   wordSetVar(_var + ".Numeric.ByWord", "");
   wordSetVar(_var + ".IntegerPart" ,   "");
   wordSetVar(_var + ".Fraction",       "");
  END;
 END {wordSetMoneyVar};

 PUBLIC PROCEDURE wordSetDateVar(_var: STRING[]; d: DATE);
 BEGIN
  IF ~!d THEN
   wordSetVar(_var,                L_DatTim.DateStr(d));
   wordSetVar(_var + ".Full",      L_DatTim.FullDateStr(d));
   wordSetVar(_var + ".Year",      L_Str.FixedIntStr(L_DatTim.YEAR(d),    4));
   wordSetVar(_var + ".Month",     L_Str.FixedIntStr(L_DatTim.MONTH(d)+1, 2));
   wordSetVar(_var + ".MonthName", L_DatTim.MonthStr(d, 1));
   wordSetVar(_var + ".Day",       L_Str.FixedIntStr(L_DatTim.DAY(d),     2));
   wordSetVar(_var + ".WeekDay",   L_DatTim.WeekDayStr(L_DatTim.WEEKDAY(d), 0));
  ELSE
   wordSetVar(_var,                "");
   wordSetVar(_var + ".Full",      "");
   wordSetVar(_var + ".Year",      "");
   wordSetVar(_var + ".Month",     "");
   wordSetVar(_var + ".MonthName", "");
   wordSetVar(_var + ".Day",       "");
   wordSetVar(_var + ".WeekDay",   "");
  END;
 END {wordSetDateVar};

 PUBLIC PROCEDURE wordSetStrArray_wSuffix(_var, Suffix: STRING[]; s: STRING[][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(s) DO
   wordSetVar(_var + IndexStr(i) + Suffix, s[i]);
   INC(i);
  END;
 END {wordSetStrArray_wSuffix};

 PUBLIC PROCEDURE wordSetStrArray(_var: STRING[]; s: STRING[][]);
 BEGIN
  wordSetStrArray_wSuffix(_var, "", s);
 END {wordSetStrArray};

 PUBLIC PROCEDURE wordSetBkm(Nam, Val: STRING[]);
 BEGIN
  wordBkmsNam[wordBkmsCnt]:=Nam;
  wordBkmsVal[wordBkmsCnt]:=Val;
  INC(wordBkmsCnt);
 END {wordSetBkm};

 PUBLIC PROCEDURE _AddToStr(VAR s: STRING[]; ToAdd: STRING[]);
 BEGIN
  IF !s THEN
   s:=ToAdd;
  ELSE
   s:=s + wordNL + ToAdd;
  END;
 END {_AddToStr};

 PUBLIC PROCEDURE IndexStr(Idx: SCAL[1E10]): STRING[];
 BEGIN
  IF !Idx THEN
   RETURN "";
  ELSE
   RETURN "["+L_Str.IntStr(Idx)+"]";
  END;
 END {IndexStr};

 PRIVATE PROCEDURE SetFieldVar(Alias, File, Field: STRING[]; Idx: SCAL[1E10]);
  CONST
   vt_NUMERIC = 0;
   vt_SCAL    = 2;
   vt_DATE    = 4;
  VAR
   _var,
   _val,
   Sic   : STRING[];
 BEGIN
  _var:=Alias + "." + Field + IndexStr(Idx);
  Sic :=File  + "." + Field + IndexStr(Idx);
  IF    (TYPEOF(^Sic) = vt_DATE) THEN
   wordSetDateVar(_var, ^Sic);
  ELSIF (TYPEOF(^Sic) = vt_NUMERIC) & (PRECISIONOF(^Sic) = 2) THEN
   wordSetMoneyVar(_var, SYSDATE(), ^Sic);
  ELSE
   IF TYPEOF(^Sic) = vt_SCAL THEN
    _val:=L_PCS.GetScalValueInterpretation(File, Field, Idx);
    wordSetVar(_var+".Value", L_Str.IntStr(^Sic));
   ELSIF TYPEOF(^Sic) = vt_NUMERIC THEN
    _val:=L_Str.NumericStr(^Sic, PRECISIONOF(^Sic));
   ELSE
    _val:=FLDTOSTR(^Sic);
   END;
   wordSetVar(_var, _val);
  END;
 END {SetFieldVar};

 PRIVATE PROCEDURE GetDotFullName(DotName: STRING[]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  L_General.Assert(FIO.Exists(DotName, DefaultTemplateExtension, Result),
                   "  蠡 㬥 " + DotName + "." +
                   "|,   뢠  㬥, ⮬,"+
                   "|,   ࠡ稪");
  RETURN Result;
 END {GetDotFullName};

 PRIVATE PROCEDURE IsAcceptableTemplateLocation(DotName, Folder: STRING[]): SCAL[2];
 BEGIN
  RETURN Str.Match(GetDotFullName(DotName), "*"+Folder+"*");
 END {IsAcceptableTemplateLocation};

 PUBLIC PROCEDURE IsBY_USERTemplate(DotName: STRING[]): SCAL[2];
 BEGIN
  RETURN IsAcceptableTemplateLocation(DotName, BY_USERFolder);
 END {IsBY_USERTemplate};

 PRIVATE PROCEDURE IsTMP_LIBTemplate(DotName: STRING[]): SCAL[2];
 BEGIN
  RETURN IsAcceptableTemplateLocation(DotName, TMP_LIBFolder);
 END {IsTMP_LIBTemplate};

 PRIVATE PROCEDURE GetTemplateDescr(DotName: STRING[]): STRING[];
 BEGIN
  RETURN L_Str.PoolItem("|짮⥫᪨ 蠡", IsBY_USERTemplate(DotName)) + " " + L_FIO.effp_FileName_woExt(DotName);
 END {GetTemplateDescr};

 PRIVATE CONST
  MaxTemplateErrorDialogLength = 80;

 PRIVATE PROCEDURE GetErrorLine(Text: STRING[]): STRING[];
 BEGIN
  RETURN Str.Align(Text, MaxTemplateErrorDialogLength, LEFT);
 END {GetErrorLine};

 PRIVATE PROCEDURE GetTemplateErrorMsg(DotName, Text: STRING[]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=GetTemplateDescr(DotName) + ": " + Text;
  IF IsBY_USERTemplate(DotName) THEN
   Result:=Result +
           L_StdFrm.THR(" 稭") +
           GetErrorLine("1 짮⥫᪨ 蠡 ᮧ 訡筮  ५   ᫥ 㤠.") + "|" +
           GetErrorLine("2 訡  ᠬ⥫쭮 ୨樨 蠡.")                             + "|" +
           GetErrorLine("3  믮  樨  裡   ।⠢")        + "|" +
           GetErrorLine("     㦤 ⠢ 蠡.")                                 + "|" +
           GetErrorLine("4  樨  祭.");
  END;
  RETURN Result;
 END {GetTemplateErrorMsg};

 PRIVATE PROCEDURE ShowTemplateError(DotName, Msg: STRING[]);
 BEGIN
  IF UsingStage = us_Development THEN
   L_StdFrm.Choice(Msg);
  ELSE
   IF IsBY_USERTemplate(DotName) THEN
    L_General.Error(Msg);
   ELSE
    L_General.extCallUs(Msg);
   END;
  END;
 END {ShowTemplateError};

 PRIVATE PROCEDURE wordUpdateFields(DotName: STRING[]; FieldCollection, VarDict: OBJECT);
  VAR
   Amount,
   FieldIdx    : NUMERIC[0];
   BadFieldList: STRING[];
 BEGIN
  APP.Get().NewPrompt(" ");
  IF FieldCollection.Update() > 0 THEN
   SETZERO(Amount);
   SETEMPTY(BadFieldList);
   FieldIdx:=FieldCollection.Count;
   WHILE FieldIdx > 0 DO
    PROMPT(L_Str.IntStr(FieldIdx));
    IF FieldCollection(FieldIdx).Update() # wdTrue THEN
     BadFieldList:=BadFieldList + Str.Align(Str.Condense(FieldCollection(FieldIdx).Code.Text), MaxTemplateErrorDialogLength, LEFT) + "|";
     INC(Amount);
    END;
    DEC(FieldIdx);
   END; (* WHILE FieldIdx < FieldCollection.Count... *)
   ShowTemplateError(DotName, GetTemplateErrorMsg(DotName, "訡   (  " + L_Str.IntStr(Amount) + ")") + "|" +
                              L_StdFrm.THR("᮪ ") + BadFieldList);
  END;
 END {wordUpdateFields};

 PRIVATE PROCEDURE convValToBlank(V: STRING[]): STRING[];
  VAR
   p,
   l: NUMERIC[0];
   R,
   c: STRING[];
 BEGIN
  IF !V | (V = " ") THEN
   R:=" "; (*"XxXxX"*)
  ELSE
   R:="";
   p:=0;
   l:=Str.Length(V);
   WHILE p < l DO
    c:=L_Str.Char(V, p);
    IF    L_Str.TestStrAlowChar(c, "09") THEN c:="0";
    ELSIF L_Str.TestStrAlowChar(c, "AZ") THEN c:="X";
    ELSIF L_Str.TestStrAlowChar(c, "az") THEN c:="x";
    ELSIF L_Str.TestStrAlowChar(c, "") THEN c:="";
    ELSIF L_Str.TestStrAlowChar(c, "") THEN c:="";
    END;
    R:=R+c;
    INC(p);
   END; (* WHILE p < l ... *)
  END;
  RETURN R;
 END {convValToBlank};

 PRIVATE PROCEDURE CheckVarNoValue(Name: STRING[]);
 BEGIN
  IF Str.Pos(wordVars(Name), NoValuePrefix) = 0 THEN
   L_General.Error(Str.Delete(wordVars(Name), 0, Str.Length(NoValuePrefix)));
  END;
 END {CheckVarNoValue};

 PRIVATE PROCEDURE SetAllVariables(Variables, ActualVariables: OBJECT);
  VAR
   i   : NUMERIC[0];
   Keys: STRING[][VarsNum];
 BEGIN
  APP.Get().NewPrompt("");
  i:=Variables.Count;
  WHILE i > 0 DO
   PROMPT(" ६. ⠫: " + L_Str.IntStr(i));
   Variables(i).Delete();
   DEC(i);
  END; (* WHILE i < 0...*)

  IF UsingStage = us_Development THEN
   Keys:=wordVars.Keys();
   i   :=wordVars.Count;
   IF i > 25000 THEN
    L_StdFrm.Choice(" ࠧࠡ뢠 蠡 㦠|" +
                   "᫨誮 讥 ⢮ ६ (" + L_Str.IntStr(i) + ").||" +
                   " ⮬ 砥 ࠡᯮᮡ|MS Word  ࠭"+
                   L_StdFrm.HR() +
                   "롥 㣮 㬥  訬 ⢮ ");
   END;
   WHILE i > 0 DO
    DEC(i);
    PROMPT("㧪 ६. ⠫: " + L_Str.IntStr(i));
    Variables(Keys[i]).Value:=wordVars(Keys[i]);
   END; (* WHILE i <= Count...*)
  ELSE
   Keys:=ActualVariables.Keys();
   i   :=ActualVariables.Count;
   WHILE i > 0 DO
    DEC(i);
    PROMPT("㧪 ६. ⠫: " + L_Str.IntStr(i));
    IF wordVars.Exists(Keys[i]) THEN
     IF UsingStage = us_Publication THEN
      Variables(Keys[i]).Value:=convValToBlank(wordVars(Keys[i]));
     ELSE
      CheckVarNoValue(Keys[i]);
      Variables(Keys[i]).Value:=wordVars(Keys[i]);
     END;
    END;
   END; (* WHILE i <= Count...*)
  END;
 END {SetAllVariables};

 PRIVATE PROCEDURE GetAllVariables(Variables: OBJECT);
  VAR
   i: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("㧪 ६");
  i:=Variables.Count;
  WHILE i > 0 DO
   PROMPT("⠫: " + L_Str.IntStr(i));
   wordSetVar(Variables(i).Name, Variables(i).Value);
   DEC(i);
  END; (* WHILE i <= Count...*)
 END {GetAllVariables};

 PRIVATE PROCEDURE SetAllBookmarks(Document: OBJECT);
  VAR
   Range : OBJECT;
   j,
   i     : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" ");
  i:=0;
  WHILE i < wordBkmsCnt DO
   PROMPT("ࠡ⪠: " + L_Str.IntStr(i) + "  " + L_Str.IntStr(wordBkmsCnt));
   IF    Document.Bookmarks.Exists(wordBkmsNam[i]) THEN
    Range:=Document.Bookmarks(wordBkmsNam[i]).Range;
    IF ~!wordBkmsVal[i] THEN
     Range.Text:=wordBkmsVal[i];
    ELSE
     Range.Text:=" ";
    END;
    j:=Range.Paragraphs.Count;
    IF j > 0 THEN
     Range.Paragraphs(j).KeepWithNext:=wdTrue;
     DEC(j);
    END;
    WHILE j > 0 DO
     Range.Paragraphs(j).KeepWithNext:=wdFalse;
     DEC(j);
    END;
    Document.Bookmarks.Add(wordBkmsNam[i], Range);
   ELSIF UsingStage # us_Using THEN
    L_StdFrm.Choice(' 蠡   "' + wordBkmsNam[i] + '"');
   END;
   INC(i);
  END;
 END {SetAllBookmarks};

 PRIVATE PROCEDURE SetPic(Document: OBJECT; BkmkName, PicFileName: STRING[]; PicW, PicH: FLOAT);
  VAR
   h, w       : FLOAT;
   InlineShape: OBJECT;
 BEGIN
  IF Document.Bookmarks.Exists(BkmkName) THEN
   IF ~!PicFileName THEN
    InlineShape:=Document.Bookmarks(BkmkName).Range.InlineShapes.AddPicture(PicFileName, wdTrue);
    IF PicW > 0 THEN (* ਭ *)
     w:=PicW * PointsInMillimeter;
     h:=InlineShape.Height * w / InlineShape.Width;
    ELSE
     h:=PicH * PointsInMillimeter;
     w:=InlineShape.Width * h / InlineShape.Height;
    END;
    InlineShape.Height:=h;
    InlineShape.Width :=w;
   END; (* (IF ~!PicFileName |...*)
  END; (* IF Document.Bookmarks.Exists(BkmkName)...*)
 END {SetPic};

 PRIVATE PROCEDURE IsPictureInCell(Range: OBJECT): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=~!Range.Cells;
  EXCEPT
  ON Exc: Exc_Root DO
  END; (* TRY *)
  RETURN Result;
 END {IsPictureInCell};

 PRIVATE PROCEDURE CheckSingleSpecificPic(Document   : OBJECT;
                                          DotName    : STRING[];
                                          BkmkName,
                                          PicFileName: STRING[];
                                          PicW, PicH : FLOAT);
  VAR
   Msg         : STRING[];
   w, CellWidth: FLOAT;
 BEGIN
  IF Document.Bookmarks.Exists(BkmkName) THEN
   IF (Str.Match(BkmkName, "Sign_*") | (BkmkName = "Stamp")) &
      IsPictureInCell(Document.Bookmarks(BkmkName).Range) THEN
    IF PicW > 0 THEN (* ਭ *)
     w:=PicW;
    ELSE
     w:=0;
    END;
    CellWidth:=Document.Bookmarks(BkmkName).Range.Cells(1).Width / PointsInMillimeter;
    IF (w - CellWidth) > 2 (* 2 *) THEN
     IF ~!PicFileName | L_General.IsProgrammer() THEN
      Msg:=GetTemplateDescr(DotName) + ":|" +
           "㤠筠 ⠢ ࠦ ( " + BkmkName + ").||" +
           "ਭ ࠦ (" + FLDTOSTR(w / 10, "2.") + " ), " +
           "ਭ 祩 (" + FLDTOSTR(CellWidth / 10, "2.") + " ).||" +
           L_StdFrm.HR() +
           " 㢥 ਭ 祩.";
      IF    IsBY_USERTemplate(DotName) | APP.Get().SupportMode | (UsingStage = us_Development) THEN
       L_StdFrm.Choice(Msg);
      ELSIF ~APP.Get().ProductiveCopy THEN
       L_General.Error(Msg);
      ELSE
       L_General.CallUs(0);
      END;
     END;
    END;
   END;
  END; (* IF Document.Bookmarks.Exists(BkmkName)...*)
 END {CheckSingleSpecificPic};

 PRIVATE PROCEDURE CheckSpecificPics(Document: OBJECT; DotName: STRING[]);
  VAR
   i, j: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" ࠦ");
  i:=0;
  WHILE i < wordPicsCnt DO
   PROMPT("ࠡ⪠: " + L_Str.IntStr(i) + "  " + L_Str.IntStr(wordPicsCnt));
   CheckSingleSpecificPic(Document, DotName, wordPicsBkmkNam[i], wordPicsFileNam[i], wordPicsW[i], wordPicsH[i]);
   j:=1;
   WHILE j < 10 DO
    PROMPT(" " + L_Str.IntStr(j));
    CheckSingleSpecificPic(Document, DotName, wordPicsBkmkNam[i] + L_Str.IntStr(j), wordPicsFileNam[i], wordPicsW[i], wordPicsH[i]);
    INC(j);
   END;
   INC(i);
  END;
 END {CheckSpecificPics};

 PRIVATE PROCEDURE SetAllPics(Document: OBJECT);
  VAR
   i, j: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("㧪 ࠦ");
  i:=0;
  WHILE i < wordPicsCnt DO
   PROMPT("ࠡ⪠: " + L_Str.IntStr(i) + "  " + L_Str.IntStr(wordPicsCnt));
   SetPic(Document, wordPicsBkmkNam[i], wordPicsFileNam[i], wordPicsW[i], wordPicsH[i]);
   j:=1;
   WHILE j < 10 DO
    PROMPT(" " + L_Str.IntStr(j));
    SetPic(Document, wordPicsBkmkNam[i] + L_Str.IntStr(j), wordPicsFileNam[i], wordPicsW[i], wordPicsH[i]);
    INC(j);
   END;
   INC(i);
  END;
 END {SetAllPics};

 PRIVATE PROCEDURE SetStandartVariables(PrepareMode: PrpModeType);
  VAR
   exName,
   exPost : STRING[];
   Local  : PROC;
 BEGIN
  APP.Get().NewPrompt("㧪 ६ 㦥");
  IF PrepareMode = PrpMode_ToDoc THEN
   wordSetVar("TheDoc.PrepareMode", " (஥)");
  ELSE
   wordSetVar("TheDoc.PrepareMode", "");
  END;
  exName:=L_PCS.GetFullNameOfCurrentUser(SYSDATE());
  wordSetVar    ("TheDoc.ExecutorName",       exName);
  wordSetVar    ("TheDoc.ExecutorName.Short", L_Str.ShortName(exName));
  Local:=PROCREF(L_PCS.GetPostNameOfCurrentUser);
  IF ~!Local THEN
   exPost:=Local(SYSDATE());
  ELSE
   exPost:="";
  END;
  wordSetVar    ("TheDoc.Executor.Name",       exName);
  wordSetVar    ("TheDoc.Executor.Name.Short", L_Str.ShortName(exName));
  wordSetVar    ("TheDoc.Executor.Post.Name",  exPost);
  wordSetDateVar("TheDoc.Creation.Date",       SYSDATE());
  wordSetVar    ("TheDoc.Creation.Time",       FLDTOSTR(SYSTIME(), "H:M", 0));
 END {SetStandartVariables};

 PRIVATE PROCEDURE GetTmpDocumentFullName(PatternPathName: STRING[]): STRING[];
  VAR
   TmpName: STRING[];
 BEGIN
  IF ~!PatternPathName THEN
   TmpName:=L_FIO.effp_FileName_woExt(PatternPathName);
  ELSE
   SETEMPTY(TmpName);
  END;
  RETURN FIO.BuildPath(TmpName + FLDTOSTR(SYSTIMESTAMP(), "yNDHMST") + "_" + APP.Get().MyConnection.Number,
                       DefaultDocumentExtension,
                       FIO.AsbSpecialFolders("ASBTemp"));
 END {GetTmpDocumentFullName};

 (* PUBLICs *)

 PUBLIC PROCEDURE L_MSO_wordCRLF(): STRING[2];
 BEGIN
  RETURN wordCRLF;
 END {L_MSO_wordCRLF};

 PUBLIC PROCEDURE L_MSO_wordNL(): STRING[1];
 BEGIN
  RETURN wordNL;
 END {L_MSO_wordNL};

 PUBLIC PROCEDURE _SetVarsByFile(File, Alias: STRING[]; ForceEmpty: SCAL[2]);
  VAR
   Field: FIELD;
   j    : NUMERIC[0];
 BEGIN
  SAVE((File));
  FOR_EACH Field IN TABLE.Get(File).Fields DO
   IF ForceEmpty THEN
    SETEMPTY(^(Field.ObtainName()));
   END;

   IF Field.Type.Range > 1 THEN
    j:=0;
    WHILE j < Field.Type.Range DO
     SetFieldVar(Alias, File, Field.Name, j);
     INC(j);
    END;
   ELSE
    SetFieldVar(Alias, File, Field.Name, EMPTYOF(j));
   END;
  END;
  RESTORE((File));
 END {_SetVarsByFile};

 PUBLIC PROCEDURE wordSetVarsByFile_wAlias(File, Alias: STRING[]);
 BEGIN
  _SetVarsByFile(File, Alias, 0);
 END {wordSetVarsByFile_wAlias};

 PUBLIC PROCEDURE wordSetVarsByFile(File: STRING[]);
 BEGIN
  _SetVarsByFile(File, File, 0);
 END {wordSetVarsByFile};

 PUBLIC PROCEDURE wordSetVarsByFile_wAliasAndIndexE(       File: STRING[];
                                                          Alias: STRING[];
                                                              i: NUMERIC[0];
                                                     ForceEmpty: SCAL[2]);
 BEGIN
  _SetVarsByFile(File, Alias + IndexStr(i), ForceEmpty);
 END {wordSetVarsByFile_wAliasAndIndex};

 PUBLIC PROCEDURE wordSetVarsByFile_wIndexedPrefixE(       File: STRING[];
                                                         Prefix: STRING[];
                                                              i: NUMERIC[0];
                                                     ForceEmpty: SCAL[2]);
 BEGIN
  _SetVarsByFile(File, Prefix + IndexStr(i) + "." + File, ForceEmpty);
 END {wordSetVarsByFile_wIndexedPrefixE};

 PUBLIC PROCEDURE wordSetVarsByFile_wPrefix(File, Prefix: STRING[]);
 BEGIN
  _SetVarsByFile(File, Prefix + File, 0);
 END {wordSetVarsByFile_wPrefix};

 PUBLIC PROCEDURE wordSetVarsByFile_wIndex(File: STRING[]; i: NUMERIC[0]; ForceEmpty: SCAL[2]);
 BEGIN
  _SetVarsByFile(File, File + IndexStr(i), ForceEmpty);
 END {wordSetVarsByFile_wIndex};

 PUBLIC PROCEDURE wordSetVarsByFile_wAliasE(File, Alias: STRING[]; ForceEmpty: SCAL[2]);
 BEGIN
  _SetVarsByFile(File, Alias, ForceEmpty);
 END {wordSetVarsByFile_wAlias};

 PUBLIC PROCEDURE wordSetVarsByFile_wPrefixE(File, Prefix: STRING[]; ForceEmpty: SCAL[2]);
 BEGIN
  _SetVarsByFile(File, Prefix + File, ForceEmpty);
 END {wordSetVarsByFile_wIndex};

 PUBLIC PROCEDURE SetValueDerivativesOnDate(_var, _val, _subplist: STRING[]; D: DATE);
  VAR
   i,
   n: NUMERIC[0];
   t: STRING[];
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  wordSetVar(_var, _val);
  i:=0;
  n:=Str.WordAmount(_subplist);
  WHILE i<n DO
   t:=Str.Item(_subplist, " ", i);
   IF t = "Short" THEN
    wordSetVar(_var + "." + t, L_Str.ShortName(_val));
   ELSIF t = "SetManNameVar" THEN
    L_Str.SplitManName(_val, Surname, FirstName, Patronymic);
    wordSetVar(_var + ".Alpha",      Str.Slice(_val, 0, 1));       
    wordSetVar(_var + ".Short",      L_Str.ShortName(_val));
    wordSetVar(_var + ".Last",       Surname);
    wordSetVar(_var + ".First",      FirstName);
    wordSetVar(_var + ".Patronymic", Patronymic);
   ELSIF t = "SetMoneyVar" THEN
    TRY
     wordSetMoneyVar(_var, D, STRTOFLD(_val, NUMERIC));
    EXCEPT
    ON Exc: Exc_RunTime DO
     IF Exc.ErrorCode = L_General.ec_rt_FailedSTRTOFLD THEN
      L_General.Error("६ MS Word " + _var + "||" + " 믮 ८ࠧ  ᫮");
     ELSE
      RAISE();
     END;
    END; (* TRY *)
   END;
   INC(i);
  END;
 END {SetValueDerivativesOnDate};

 PUBLIC PROCEDURE SetValueDerivatives(_var, _val, _subplist: STRING[]);
 BEGIN
  SetValueDerivativesOnDate(_var, _val, _subplist, SYSDATE());
 END {SetValueDerivatives};

 PUBLIC PROCEDURE wordSetPic(Bookmark, FileName: STRING[]; w, h: FLOAT);
  VAR
   PicFullName: STRING[];
 BEGIN
  IF (w<=0) = (h<=0) THEN
   L_General.Error(" ⠢  㬥 ࠦ   ਭ,  |" + FileName);
  END;
  IF ~!FileName THEN
   L_General.Assert(FIO.Exists(FileName, "", PicFullName), "  䠩 ࠦ "+FileName);
  ELSE
   SETEMPTY(PicFullName);
  END;

  wordPicsBkmkNam[wordPicsCnt]:=Bookmark;
  wordPicsFileNam[wordPicsCnt]:=PicFullName;
  wordPicsW      [wordPicsCnt]:=w;
  wordPicsH      [wordPicsCnt]:=h;
  INC(wordPicsCnt);
 END {wordSetPic};

 PUBLIC PROCEDURE InitializeUsingStage();
 BEGIN
  IF L_General.VariableIsInitializing(UsingStage) THEN
   L_General.Assert(UsingStage # us_Publication, "⨬ ० ⮢");
  ELSE
   UsingStage:=us_Using;
  END;
 END {InitializeUsingStage};

 PUBLIC PROCEDURE wordInitDocument(D: DATE);
  VAR
   Msg  : STRING[];
   Local: PROC;
 BEGIN
  InitializeUsingStage();
  IF    UsingStage = us_Using THEN
   Msg:="⮢ 㬥 MS Word";
  ELSIF UsingStage = us_Development THEN
   Msg:="⮢ 蠡 MS Word";
  ELSIF UsingStage = us_Publication THEN
   Msg:="㡫 蠡 MS Word";
  ELSE
   L_General.CallUs(0);
  END;
  APP.Get().NewPrompt(Msg);

  wordVarsCnt  :=0;
  wordBkmsCnt  :=0;
  wordTablesCnt:=0;
  wordPicsCnt  :=0;
  wordVars     :=L_General.CreateDictionary();
  PutInTables  :=Put_Fields;
  PutInFields  :=Put_Fields;
  UseTmpDot    :=0;
  SETEMPTY(IsDuplexDoc, UseManualFeed);
 END {wordInitDocument};

 PRIVATE PROCEDURE PutInDict(DotName: STRING[]; FieldCollection, VarDict: OBJECT);
  VAR
   s,
   _Code: STRING[];
   i, j : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" 樨 ");
  j:=FieldCollection.Count;
  WHILE j>0 DO
   PROMPT("⠫: " + L_Str.IntStr(j));
   IF FieldCollection(j).Type = wdFieldDocVariable THEN
    _Code:=FieldCollection(j).Code.Text;
    i:=0;
    s:=Str.Item(_Code, ' \"', i);
    WHILE s # "" DO
     IF ~VarDict.Exists(s) THEN
      VarDict.Add(s, "");
     END;
     INC(i);
     s:=Str.Item(_Code, ' \"', i);
    END;
   END;
   DEC(j);
  END;
 END {PutInDict};

 PRIVATE PROCEDURE extStrReplace(SrcStr, SearchValue, ReplaceValue: STRING[]): STRING[];
  VAR
   Pos: NUMERIC[0];
 BEGIN
  Pos:=Str.Pos(Str.Cap(SrcStr), Str.Cap(SearchValue));
  IF Pos # Str.Length(SrcStr) THEN
   SrcStr:=Str.Delete(SrcStr, Pos, Str.Length(SearchValue));
   SrcStr:=Str.Insert(SrcStr, ReplaceValue, Pos);
  END;
  RETURN SrcStr;
 END {extStrReplace};

 PRIVATE PROCEDURE ConvertDOCVARIABLE2QUOTE(Value: STRING[]): STRING[];
 BEGIN
  Value:=Str.Replace(Value, '\', '\\');
  Value:=Str.Replace(Value, '"', '\"');
  Value:=Str.Replace(Value, '', '\');
  RETURN Value;
 END {ConvertDOCVARIABLE2QUOTE};

 PRIVATE PROCEDURE ReplaceFieldsToValues(Document, VarDict: OBJECT);
  CONST
   kw_Docvariable = "DOCVARIABLE";
  VAR
   j,
   i,
   Pos    : NUMERIC[0];
   _Code,
   varName: STRING[];
 BEGIN
  APP.Get().NewPrompt(" 祭 ");
  j:=Document.Fields.Count;
  WHILE j > 0 DO
   PROMPT("⠫: " + L_Str.IntStr(j));
   IF Document.Fields(j).Type = wdFieldDocVariable THEN
    Document.Fields(j).Select();
    _Code  :=Document.Fields(j).Code.Text;
    i      :=0;
    varName:=Str.Item(_Code, " ", i);
    WHILE ~!varName & ~wordVars.Exists(varName) DO
     INC(i);
     varName:=Str.Item(_Code, " ", i);
    END;
    _Code:=extStrReplace(_Code, kw_Docvariable, "quote");
    CheckVarNoValue(varName);
    _Code:=extStrReplace(_Code, varName,        '"' + ConvertDOCVARIABLE2QUOTE(wordVars(varName)) + '"');
    Document.Fields(j).Code.Text:=_Code;
   END;
   DEC(j);
  END;
 END {ReplaceFieldsToValues};

 PRIVATE PROCEDURE ParseSingleShapeFields(DotName: STRING[]; Shape, VarDict: OBJECT; p: PROC);
 BEGIN
  IF Shape.TextFrame.HasText THEN
   p(DotName, Shape.TextFrame.TextRange.Fields, VarDict);
  END;
 END {ParseSingleShapeFields};

 PRIVATE PROCEDURE ParseFields(DotName: STRING[]; Document, VarDict: OBJECT; p: PROC);
  VAR
   i, j: NUMERIC[0];
 BEGIN
  p(DotName, Document.Fields, VarDict);
  APP.Get().NewPrompt("");
  i:=Document.Shapes.Count;
  WHILE i > 0 DO
   PROMPT("ࠡ⪠ . ⠫ " + L_Str.IntStr(i));
   ParseSingleShapeFields(DotName, Document.Shapes(i), VarDict, p);
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    j:=Document.Shapes(i).GroupItems.Count;
   EXCEPT
   ON Exc: Exc_Object DO
    j:=0;
   END; (* TRY *)
   WHILE j > 0 DO
    ParseSingleShapeFields(DotName, Document.Shapes(i).GroupItems(j), VarDict, p);
    DEC(j);
   END;
   DEC(i);
  END;
  i:=Document.Sections.Count;
  WHILE i > 0 DO
   j:=Document.Sections(i).Headers.Count;
   WHILE j > 0 DO
    PROMPT("ࠡ⪠: ᥪ " + L_Str.IntStr(i) + ", 孨  " + L_Str.IntStr(j));
    p(DotName, Document.Sections(i).Headers(j).Range.Fields, VarDict);
    DEC(j);
   END;

   j:=Document.Sections(i).Footers.Count;
   WHILE j > 0 DO
    PROMPT("ࠡ⪠: ᥪ " + L_Str.IntStr(i) + ",   " + L_Str.IntStr(j));
    p(DotName, Document.Sections(i).Footers(j).Range.Fields, VarDict);
    DEC(j);
   END;
   DEC(i);
  END;
 END {ParseFields};

 PUBLIC PROCEDURE dl_Put(    Doc    : STRING[];
                         VAR DocList: tDocList;
                         VAR Idx    : NUMERIC[0]);
 BEGIN
  DocList[Idx]:=Doc;
  INC(Idx);
 END {dl_Put};

 PRIVATE PROCEDURE dl_GetCurGroup(): NUMERIC[0];
 BEGIN
  L_General.CallUs(OCCURE(MSODL));
  IF ~MSODL.IsDoc THEN
   RETURN MSODL.Nbr;
  ELSE
   RETURN MSODL.Group;
  END;
 END {dl_GetCurGroup};

 PRIVATE PROCEDURE dl_GetGroupByName(GroupName: STRING[]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  SAVE(MSODL);
  L_General.CallUs(SELECT(MSODL, Name, GroupName));
  L_General.CallUs(~MSODL.IsDoc);
  Result:=MSODL.Nbr;
  RESTORE(MSODL);
  RETURN Result;
 END {dl_GetGroupByName};

 PRIVATE PROCEDURE dl_Insert(trgGroup   : NUMERIC[0];
                             trgName    : STRING[];
                             trgTemplate: STRING[];
                             trgProc    : STRING[];
                             trgDateDef : STRING[];
                             trgIsDoc   : SCAL[2];
                             trgIsLocal : SCAL[2]);
  VAR
   trgNbr: NUMERIC[0];
 BEGIN
  IF !DATABASE.Get().Tables("MSODL") THEN
   L_AFM.MakeMultipleIndex("MSODL", "Group   : NUMERIC[0];" +
                                    "Nbr     : NUMERIC[0];" +
                                    "Name    : STRING[128];" +
                                    "Template: STRING[64];" +
                                    "Proc    : STRING[32];" +
                                    "DateDef : STRING[32];" +
                                    "IsDoc   : SCAL[2];" +
                                    "IsLocal : SCAL[2]",
                           "Group:Group,IsDoc,Nbr;Nbr:Nbr;Name:Name");
  END;
  IF SELECT(MSODL, Nbr) & LAST(MSODL) THEN
   trgNbr:=MSODL.Nbr+1;
  ELSE
   trgNbr:=1;
  END;
  MSODL.Group   :=trgGroup;
  MSODL.Nbr     :=trgNbr;
  MSODL.Name    :=trgName;
  MSODL.Template:=trgTemplate;
  MSODL.Proc    :=trgProc;
  MSODL.DateDef :=trgDateDef;
  MSODL.IsDoc   :=trgIsDoc;
  MSODL.IsLocal :=trgIsLocal;
  INSERT(MSODL);
 END {dl_Insert};

 PUBLIC PROCEDURE dl_AddGroup(GroupName: STRING[]);
 BEGIN
  dl_Insert(dl_MainGroup, GroupName, "", "", "", 0, 0);
 END {dl_AddGroup};

 PUBLIC PROCEDURE dl_AddDocInCurGroup(trgDocName, trgTemplate, trgProc, trgDateDef: STRING[]);
 BEGIN
  dl_Insert(dl_GetCurGroup(), trgDocName, trgTemplate, trgProc, trgDateDef, 1, 0);
 END {dl_AddDocInCurGroup};

 PUBLIC PROCEDURE dl_AddDoc(trgDocName, trgTemplate, trgProc, trgDateDef: STRING[]);
 BEGIN
  dl_Insert(dl_MainGroup, trgDocName, trgTemplate, trgProc, trgDateDef, 1, 0);
 END {dl_AddDoc};

 PUBLIC PROCEDURE dl_AddLocDoc(trgDocName, trgTemplate, trgProc, trgDateDef: STRING[]);
 BEGIN
  dl_Insert(dl_MainGroup, trgDocName, trgTemplate, trgProc, trgDateDef, 1, 1);
 END {dl_AddLocDoc};

 PUBLIC PROCEDURE dl_AddLocDocInGroup(GroupName, trgDocName, trgTemplate, trgProc, trgDateDef: STRING[]);
 BEGIN
  dl_Insert(dl_GetGroupByName(GroupName), trgDocName, trgTemplate, trgProc, trgDateDef, 1, 1);
 END {dl_AddLocDocInGroup};

 PRIVATE PROCEDURE AcceptableMSODL(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=1;
  IF ~MSODL.IsDoc THEN
   SAVE(MSODL);
   Result:=SELECT(MSODL, Group, MSODL.Nbr);
   RESTORE(MSODL);
  END;
  RETURN Result;
 END {AcceptableMSODL};

 PUBLIC PROCEDURE dl_SelectDoc(VAR Prepare: PrpModeType);
  VAR
   MaxL,
   MaxDotL,
   aws_Height,
   ListSize,
   Height,
   Result   : NUMERIC[0];
   DocList,
   PoolIns,
   Blank,
   VarList,
   DocNbrList,
   Title,
   subTitle,
   StdFormTitle: STRING[];
   prvRow,
   prvGroup,
   curGroup    : NUMERIC[0];
   HasGroupInList: SCAL[2];
 BEGIN
  L_General.Assert(~!DATABASE.Get().Tables("MSODL"), " 㬥⮢  ");

  IF VAR_IMPL.Get(dl_PrepareMode).Initialized THEN
   Prepare:=dl_PrepareMode;
  END;

  InitializeUsingStage();
  GE_APPWIN_SIZE(, aws_Height);

  Result  :=0;
  curGroup:=dl_MainGroup;
  LOOP
   SETEMPTY(DocList, DocNbrList);
   SETZERO(MaxL, MaxDotL, Height, ListSize, HasGroupInList);

   SELECT(MSODL, Group, , curGroup);
   WHILE OCCURE(MSODL) DO
    IF AcceptableMSODL() THEN
     MaxL:=Math.Max(MaxL, Str.Length(MSODL.Name));
     IF UsingStage = us_Development THEN
      MaxDotL:=Math.Max(MaxDotL, Str.Length(MSODL.Template));
     END;
     INC(ListSize);
    END;
    NEXT(MSODL);
   END; (* WHILE OCCURE(MSODL) ... *)

   SELECT(MSODL, Group, , curGroup);
   WHILE OCCURE(MSODL) DO
    IF AcceptableMSODL() THEN
     DocList   :=DocList + Str.Align(MSODL.Name, MaxL, LEFT);
     IF UsingStage = us_Development THEN
      DocList:=DocList + " " + Str.Align(MSODL.Template, MaxDotL, LEFT);
     END;
     IF ~MSODL.IsDoc THEN
      HasGroupInList:=1;
      DocList       :=DocList + " >";
     END;
     DocList:=DocList + "|";
     DocNbrList:=DocNbrList + L_Str.IntStr(MSODL.Nbr) + "|";
    END;
    NEXT(MSODL);
   END; (* WHILE OCCURE(MSODL) ... *)

   StdFormTitle:="롮 㬥";
   IF UsingStage = us_Development THEN
    INC(MaxL, MaxDotL + 1);
    StdFormTitle:=StdFormTitle + " (⮢ 蠡)";
   END;
   IF HasGroupInList THEN
    INC(MaxL, 2);
   END;

   Height:=Math.Min(Math.Max(ListSize, 2), aws_Height * 2 DIV 3);
   SETEMPTY(subTitle);
   IF curGroup # dl_MainGroup THEN
    SELECT(MSODL, Nbr, , curGroup);
    subTitle:=": " + MSODL.Name;
   END;
   StdFormTitle:=StdFormTitle + subTitle;
   TRY
    MaxL   :=Math.Max(MaxL, Str.Length(StdFormTitle));
    PoolIns:="%" + L_Str.Repeat("#", MaxL) + "%" + L_Str.Repeat("|", Height-1);
    Blank  :="%" + "," + L_Str.IntStr(Height) + "AI";
    VarList:="Result";
    IF UsingStage = us_Using THEN
     PoolIns:=PoolIns + "|" +
              L_StdFrm.HR() +
              "%" + L_Str.Repeat("#", MaxL) + "%";
     Blank  :=Blank + "%<஥>E";
     VarList:=VarList + ", Prepare";
    END;
    STDFORM(L_StdFrm.sf_Choice(PoolIns, Blank),
            " " + StdFormTitle + " ",
            ^(L_StdFrm.SFMenuStyle()),
            ,
            DocList,
            ^VarList);

    prvRow:=Result;
    Result:=STRTOFLD(L_Str.PoolItem(DocNbrList, Result), NUMERIC);

    SELECT(MSODL, Nbr, , Result);
    IF ~MSODL.IsDoc THEN
     prvGroup:=curGroup;
     curGroup:=MSODL.Nbr;
     Result  :=0;
    ELSE
     EXIT;
    END;
   EXCEPT
   ON Exc: Exc_Halt DO
    IF curGroup = dl_MainGroup THEN
     RAISE();
    ELSE
     Result  :=prvRow;
     curGroup:=prvGroup;
    END;
   END; (* TRY *)
  END; (* LOOP *)
  dl_PrepareMode:=Prepare;
 END {dl_SelectDoc};

 PUBLIC PROCEDURE dl_GetPrepareProc(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=MSODL.Proc;
  IF !Result THEN
   Result:=MSODL.Template;
  END;
  RETURN Result;
 END {dl_GetPrepareProc};

(*!!!*) PUBLIC PROCEDURE SelectDoc(DocList, DotList: STRING[]; VAR Prepare: PrpModeType): NUMERIC[0];
  VAR
   s,
   DotName,
   StdFormTitle,
   CompList,
   PoolIns,
   Blank,
   VarList   : STRING[];
   i,
   j,
   MaxL,
   MaxDotL,
   Result,
   aws_Height: NUMERIC[0];
 BEGIN
  IF VAR_IMPL.Get(dl_PrepareMode).Initialized THEN
   Prepare:=dl_PrepareMode;
  END;
  InitializeUsingStage();
  j      :=0;
  MaxL   :=0;
  s      :=L_Str.PoolItem(DocList, j);
  WHILE ~!s DO
   MaxL   :=Math.Max(MaxL,    Str.Length(s));
   INC(j);
   s:=L_Str.PoolItem(DocList, j);
  END;

  StdFormTitle:="롮 㬥";
  IF (UsingStage = us_Development) THEN
   i      :=0;
   MaxDotL:=0;
   SETEMPTY(CompList);
   WHILE i < j DO
    s       :=L_Str.PoolItem(DocList,    i);
    DotName :=L_Str.PoolItem(DotList, i);
    MaxDotL :=Math.Max(MaxDotL, Str.Length(DotName));
    CompList:=CompList + s + L_Str.Repeat(" ", MaxL - Str.Length(s) + 1) +
              DotName + "|";
    INC(i);
   END;
   INC(MaxL, 1 + MaxDotL);
   DocList     :=CompList;
   StdFormTitle:=StdFormTitle + " (⮢ 蠡)";
  END;
  GE_APPWIN_SIZE(, aws_Height);
  j:=Math.Min(Math.Max(j, 2), aws_Height * 2 DIV 3);

  PoolIns:="%" + L_Str.Repeat("#", MaxL) + "%" + L_Str.Repeat("|", j-1);
  Blank  :="%" + "," + L_Str.IntStr(j) + "AI";
  VarList:="Result";
  IF UsingStage = us_Using THEN
   PoolIns:=PoolIns +
            "|" + L_StdFrm.HR() +
            "%" + L_Str.Repeat("#", MaxL) + "%";
   Blank  :=Blank + "%<஥>E";
   VarList:=VarList + ", Prepare";
  END;
  Result:=0;
  STDFORM(L_StdFrm.sf_Choice(PoolIns, Blank),
          " " + StdFormTitle + " ",
          ^(L_StdFrm.SFMenuStyle()),
          ,
          DocList,
          ^VarList);
  dl_PrepareMode:=Prepare;
  RETURN Result + 1;
 END {SelectDoc};

 PUBLIC PROCEDURE extSetWordTable(BkmkName: STRING[]; LineCount: NUMERIC[0]; Type: tTableType);
 BEGIN
  wordTablesBkmksNam[wordTablesCnt]:=BkmkName;
  wordTablesLineCnt [wordTablesCnt]:=LineCount;
  wordTablesType    [wordTablesCnt]:=Type;
  INC(wordTablesCnt);
 END {extSetWordTable};

 PUBLIC PROCEDURE SetWordTable(BkmkName: STRING[]; LineCount: NUMERIC[0]);
 BEGIN
  extSetWordTable(BkmkName, LineCount, tt_Normal);
 END {SetWordTable};

 PRIVATE PROCEDURE ChangeIndex(S: STRING[]; Index: NUMERIC[0]): STRING[];
  VAR Position: NUMERIC[0];
 BEGIN
  Position:=Str.Pos(S, IndexStr(0));
  IF (Position < Str.Length(S)) THEN
   RETURN Str.Insert(Str.Delete(S, Position, Str.Length(IndexStr(0))),
                     IndexStr(Index),
                     Position);
  ELSE
   RETURN S;
  END;
 END {ChangeIndex};

 PRIVATE PROCEDURE GetFieldsList(    Selection: OBJECT;
                                 VAR FldCnt   : NUMERIC[0];
                                 VAR Items    : STRING[][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  FldCnt:=Selection.Fields.Count;
  SETEMPTY(Items);
  i:=1;
  WHILE i <= FldCnt DO
   IF Selection.Fields.Item(i).Type = wdFieldDocVariable THEN
    Items[i]:=Selection.Fields.Item(i).Code.Text;
   END;
   INC(i);
  END;
 END {GetFieldsList};

 PRIVATE PROCEDURE UserWordError();
 BEGIN
  L_General.Error(" ⮢ 㬥 ࢠ ᪮ 㣮  MS Word.||" +
                  "( ६ 㧪 㬥  ঠ|" +
                  " ࠡ  㣨 㬥⠬ MS Word)");
 END {UserWordError};

 PRIVATE PROCEDURE CheckWordIsAutomationServer(Document: OBJECT);
 BEGIN
  IF Document.Application.UserControl # 0 THEN
   UserWordError();
  END;
 END {CheckWordIsAutomationServer};

 PRIVATE PROCEDURE Selection_Proceed(Document: OBJECT; Operation: STRING[]);
 BEGIN
  IF Document.Application.UserControl # 0 THEN
   UserWordError();
  END;
  ^("Document.Application.Selection." + Operation);
  IF Document.Application.UserControl # 0 THEN
   UserWordError();
  END;
 END {Selection_Proceed};

 PRIVATE PROCEDURE ProceedRowFields(Document,
                                    Range    : OBJECT;
                                    Row,
                                    FldCnt   : NUMERIC[0];
                                    Items    : STRING[][]);
  VAR
   i, j,
   FldIdx: NUMERIC[0];
   Code,
   Dummy,
   varName,
   varAsText: STRING[];
 BEGIN
  i:=1;
  FldIdx:=1;
  WHILE i <= FldCnt DO
   IF ~!Items[i] THEN
    IF    PutInTables = Put_Values THEN
     j:=0;
     varAsText:="";
     Code:=ChangeIndex(Items[i], Row);
     LOOP
      varName:=Str.Item(Code, " ", j);
      IF !varName THEN
       EXIT;
      END;
      IF wordVars.Exists(varName) THEN
       Dummy:=wordVars(varName);
       IF Dummy # " " THEN
        CheckVarNoValue(varName);
        varAsText:=varAsText + Dummy;
       END;
      END;
      INC(j);
     END; (* LOOP *)
     IF !varAsText THEN
      varAsText:=" ";
     END;
     Range.Fields(FldIdx).Select();
     CheckWordIsAutomationServer(Document);
     Document.Application.selection.Text:=varAsText;
     CheckWordIsAutomationServer(Document);
    ELSIF PutInTables = Put_Fields THEN
     Range.Fields.Item(i).Code.Text:=ChangeIndex(Items[i], Row);
    END; (*IF PutInTables*)
   ELSE
    INC(FldIdx);
   END;
   INC(i);
  END; (* WHILE i <= FldCnt...*)
 END {ProceedRowFields};

 PRIVATE PROCEDURE SetEmptyRowFields(FldCnt: NUMERIC[0];
                                     Items : STRING[][]);
  VAR
   i, j   : NUMERIC[0];
   varName: STRING[];
 BEGIN
  i:=1;
  WHILE i <= FldCnt DO
   j:=0;
   LOOP
    varName:=Str.Item(Items[i], ' \"', j);
    IF varName = "" THEN
     EXIT;
    END;
    IF ~wordVars.Exists(varName) THEN
     wordSetVar(varName, "");
    END;
    INC(j);
   END;
   INC(i);
  END; (* WHILE i <= FldCnt...*)
 END {SetEmptyRowFields};

 PRIVATE PROCEDURE SetTable_UseFormattedText(DotName: STRING[]; Document: OBJECT; BkmkNam: STRING[]; LineCnt: NUMERIC[0]; Type: tTableType);
  CONST
   tmpBookMark = "TmpLabel_26082011150048";
  VAR
   Row,
   FldCnt,
   BegCell,
   EndCell,
   StartDelete,
   EndDelete,
   CellsAmount : NUMERIC[0];
   Items       : STRING[][512];
   newRow,
   Range       : OBJECT;
 BEGIN
  IF ~Document.Bookmarks.Exists(BkmkNam) THEN
   IF Type # tt_Soft THEN
    ShowTemplateError(DotName, GetTemplateErrorMsg(DotName, " ⠡   " + BkmkNam));
   END;
  ELSE
   Row:=LineCnt - 1;
   LOOP
    Range      :=Document.Bookmarks(BkmkNam).Range;
    Range.Select();
    Selection_Proceed(Document, "ParagraphFormat.KeepWithNext:=wdFalse");
    IF    (LineCnt = 0) & ((Type = tt_Soft) | (UsingStage = us_Development)) THEN
     CheckWordIsAutomationServer(Document);
     GetFieldsList(Range, FldCnt, Items);
     CheckWordIsAutomationServer(Document);
     SetEmptyRowFields(FldCnt, Items);
     EXIT;
    ELSIF (LineCnt = 0) & (UsingStage = us_Using) THEN
     Selection_Proceed(Document, "Rows.Delete()");
     EXIT;
    ELSIF (Row = 0) | (UsingStage = us_Development) THEN
     EXIT;
    ELSIF UsingStage = us_Using THEN
     PROMPT("⠫ ப: " + L_Str.IntStr(Row));
     CellsAmount:=Range.Cells.Count;
     BegCell:=CellsAmount + 1;
     EndCell:=BegCell + CellsAmount - 1;
     IF BegCell # EndCell THEN
      Document.Bookmarks(BkmkNam).Delete();
      Selection_Proceed(Document, "InsertRowsBelow()");
      CheckWordIsAutomationServer(Document);
      Document.Bookmarks.Add(tmpBookMark, Document.Application.Selection.Range);
      CheckWordIsAutomationServer(Document);
      Document.Application.Selection.Range.FormattedText:=Range.FormattedText;
      CheckWordIsAutomationServer(Document);
      Document.Bookmarks.Add(BkmkNam, Range);

      Range   :=Document.Bookmarks(tmpBookMark).Range;
      Range.SetRange(Range.Cells(BegCell).Range.Start, Range.Cells(EndCell).Range.End);
      Range.Rows.Delete();

      Range   :=Document.Bookmarks(tmpBookMark).Range;
      Range.Select();

      GetFieldsList(Range, FldCnt, Items);
      ProceedRowFields(Document, Range, Row, FldCnt, Items);

      Document.Bookmarks(tmpBookMark).Delete();
      Document.UndoClear();
     END;
    ELSE
     L_General.CallUs(0);
    END; (* IF IF (UsingStage = us_Using) & (LineCnt = 0)... *)
    DEC(Row);
   END; (* LOOP *)
  END; (* IF ~Document.Bookmarks.Exists ... *)
 END {SetTable_UseFormattedText};

 PRIVATE PROCEDURE sat_UseFormattedText(DotName: STRING[]; Document: OBJECT);
  VAR
   Idx    : NUMERIC[0];
   oPrompt: PROMPT_LINE;
   Title  : STRING[];
 BEGIN
  oPrompt:=PROMPT_LINE.Create("ࠡ⪠ ⠡");
  Idx    :=0;
  WHILE Idx < wordTablesCnt DO
   Title:="ࠡ⪠ ⠡. " + L_Str.IntStr(Idx+1) + "/" + L_Str.IntStr(wordTablesCnt);
   oPrompt.Title:=Title;
   SetTable_UseFormattedText(DotName, Document, wordTablesBkmksNam[Idx],        wordTablesLineCnt[Idx], wordTablesType[Idx]);
   oPrompt.Title:=Title + " ( 1)";
   SetTable_UseFormattedText(DotName, Document, wordTablesBkmksNam[Idx] + "_1", wordTablesLineCnt[Idx], tt_Soft);
   oPrompt.Title:=Title + " ( 2)";
   SetTable_UseFormattedText(DotName, Document, wordTablesBkmksNam[Idx] + "_2", wordTablesLineCnt[Idx], tt_Soft);
   INC(Idx);
  END; (* WHILE Idx... *)
 END {sat_UseFormattedText};

 PRIVATE PROCEDURE CheckClipboardOwner(Obj: OBJECT);
 BEGIN
  L_General.Assert(ISTHEOBJECTSERVERTHECLIPBOARDOWNER(Obj) = 1,
                   " ⮢ 㬥 ࢠ ⥫⢮    Windows.|" +
                   " 믮 ⮢ ୮");
 END {CheckClipboardOwner};

 PRIVATE PROCEDURE SetTable_UseClipboard(DotName: STRING[]; Document: OBJECT; BkmkNam: STRING[]; LineCnt: NUMERIC[0]; Type: tTableType);
  VAR
   Row,
   FldCnt,
   RangeLength: NUMERIC[0];
   Items      : STRING[][512];
   Range      : OBJECT;
 BEGIN
  IF ~Document.Bookmarks.Exists(BkmkNam) THEN
   IF Type # tt_Soft THEN
    ShowTemplateError(DotName, GetTemplateErrorMsg(DotName, " ⠡   " + BkmkNam));
   END;
  ELSE
   Range:=Document.Bookmarks(BkmkNam).Range;
   RangeLength:=Range.End - Range.Start;
   Document.Bookmarks(BkmkNam).Delete();
   Range.Paragraphs(1).KeepWithNext:=wdFalse;
   Range.Copy();
   Range.Paragraphs(1).KeepWithNext:=wdTrue;
   GetFieldsList(Range, FldCnt, Items);
   IF    (LineCnt = 0) & ((Type = tt_Soft) | (UsingStage = us_Development)) THEN
    SetEmptyRowFields(FldCnt, Items);
   ELSIF UsingStage = us_Using THEN
    IF LineCnt = 0 THEN
     Range.Cut();
    ELSE
     Row:=LineCnt - 1;
     WHILE Row >= 0 DO
      PROMPT("⠫ ப: " + L_Str.IntStr(Row));
      ProceedRowFields(Document, Range, Row, FldCnt, Items);
      IF Row # 0 THEN
       Range.Paste();
       CheckClipboardOwner(Document);
       Range.End:=Range.Start + RangeLength;
       Document.UndoClear();
      END;
      DEC(Row);
     END; (* WHILE ... *)
    END;
   END; (* IF (LineCnt = 0) ... *)
   Document.Bookmarks.Add(BkmkNam, Range);
  END; (* IF ~Document.Bookmarks.Exists ... *)
 END {SetTable_UseClipboard};

 PRIVATE PROCEDURE sat_UseClipboard(DotName: STRING[]; Document: OBJECT);
  VAR
   Idx    : NUMERIC[0];
   oPrompt: PROMPT_LINE;
   Title  : STRING[];
 BEGIN
  oPrompt:=PROMPT_LINE.Create("ࠡ⪠ ⠡");
  Idx    :=0;
  WHILE (Idx < wordTablesCnt) DO
   Title:="ࠡ⪠ ⠡. " + L_Str.IntStr(Idx+1) + "/" + L_Str.IntStr(wordTablesCnt);
   oPrompt.Title:=Title;
   SetTable_UseClipboard(DotName, Document, wordTablesBkmksNam[Idx],        wordTablesLineCnt[Idx], wordTablesType[Idx]);
   oPrompt.Title:=Title + " ( 1)";
   SetTable_UseClipboard(DotName, Document, wordTablesBkmksNam[Idx] + "_1", wordTablesLineCnt[Idx], tt_Soft);
   oPrompt.Title:=Title + " ( 2)";
   SetTable_UseClipboard(DotName, Document, wordTablesBkmksNam[Idx] + "_2", wordTablesLineCnt[Idx], tt_Soft);
   INC(Idx);
  END; (* WHILE Idx... *)
 END {sat_UseClipboard};

 PRIVATE PROCEDURE SetTables_wClipboard(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=1;
  IF    L_General.IsPolakSpecific() THEN
   Result:=0;
  ELSIF APP.Get().SupportMode THEN
   IF (L_General.GetAPSiteNumber() = 26) | (L_General.GetAPSiteNumber() = 29) THEN
    Result:=0;
   END;
  END;
  RETURN Result;
 END {SetTables_wClipboard};

 PRIVATE PROCEDURE SetAllTables(DotName: STRING[]; Document: OBJECT);
 BEGIN
  IF SetTables_wClipboard() THEN
   sat_UseClipboard(DotName, Document);
  ELSE
   sat_UseFormattedText(DotName, Document);
  END;
 END {SetAllTables};

 PUBLIC PROCEDURE BuildTemplateName(Template, Version: STRING[]): STRING[];
  CONST
   VerSign  = "##";
   VerSignL = Str.Length(VerSign);
  VAR
   _VerN,
   _VerP : NUMERIC[0];
 BEGIN
  _VerP:=Str.Pos(Template, VerSign);
  IF _VerP < Str.Length(Template) THEN
   IF !Version THEN _VerN:=1;
   ELSE             _VerN:=STRTOFLD(Version, NUMERIC);
   END;
   RETURN Str.Insert(Str.Delete(Template, _VerP, VerSignL), L_Str.FixedIntStr(_VerN, VerSignL), _VerP);
  ELSE
   RETURN Template;
  END;
 END {BuildTemplateName};

 PUBLIC PROCEDURE GetStandartPrepareMode(PrpResult: PrpResultType): PrpModeType;
 BEGIN
  IF    (PrpResult = PrpResult_Preview)  THEN
   RETURN PrpMode_ToDoc;
  ELSIF (PrpResult = PrpResult_Copy) |
        (PrpResult = PrpResult_Original) THEN
   RETURN PrpMode_Print;
  ELSIF (PrpResult = PrpResult_Email)    THEN
   RETURN PrpMode_ToPDF;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetStandartPrepareMode};

 PRIVATE PROCEDURE GetTmpDotFullName(DotName: STRING[]): STRING[];
 BEGIN
  RETURN FIO.BuildPath(DotName, DefaultTemplateExtension, FIO.AsbSpecialFolders("ASBTemp"));
 END {GetTmpDotFullName};

 PUBLIC PROCEDURE CreateTmpDot(DotName: STRING[]);
  VAR
   TmpDotFullName: STRING[];
 BEGIN
  TmpDotFullName:=GetTmpDotFullName(DotName);
  FIO.Erase(TmpDotFullName);
  L_FIO.ExactFileCopy(GetDotFullName(DotName), TmpDotFullName);
  FIO.SetAttr(TmpDotFullName, , 0, 0);
 END {CreateTmpDot};

 PUBLIC PROCEDURE SetEmptyRootVars(Root: STRING[]);
  VAR
   i   : NUMERIC[0];
   Keys: STRING[][VarsNum];
 BEGIN
  APP.Get().NewPrompt(" ");
  Keys:=wordVars.Keys();
  i   :=wordVars.Count;
  WHILE i > 0 DO
   DEC(i);
   PROMPT("⠫: " + L_Str.IntStr(i));
   IF Str.Match(Keys[i], Root + ".*") THEN
    wordSetVar(Keys[i], "");
   END;
  END;
 END {SetEmptyRootVars};

 PRIVATE PROCEDURE PrepareVariableList(word: OBJECT);
  VAR
   i, Pos, WSU: NUMERIC[0];
   Keys       : STRING[][VarsNum];
   doc        : OBJECT;
 BEGIN
  APP.Get().NewPrompt("⮢ ᯨ᪠ ६");
  word.Options.CheckGrammarAsYouType :=wdFalse;
  word.Options.CheckSpellingAsYouType:=wdFalse;
  WSU :=word.ScreenUpdating;
  word.ScreenUpdating:=wdFalse;
  doc :=word.Documents.Add();
  Keys:=wordVars.Keys();
  i   :=wordVars.Count;
  WHILE i > 0 DO
   DEC(i);
   PROMPT("⠫: " + L_Str.IntStr(i));
   SETZERO(Pos);
   Pos:=Str.Pos(Keys[i], "[", Pos);
   IF (Pos = Str.Length(Keys[i])) |
      (L_Str.Char(Keys[i], Pos+1) = "0") THEN
    doc.Range().InsertAfter("docvariable " + Keys[i] + ":   " + wordVars(Keys[i]));
    doc.Range().InsertParagraphAfter();
   END;
  END;
  word.ScreenUpdating:=WSU;
 END {PrepareVariableList};

 PRIVATE PROCEDURE SetupPage(VAR WordDocument: OBJECT; PrinterName: STRING[]);
  VAR
   PJ: OBJECT;
   HasDuplex: SCAL[2];
 BEGIN
  IF (UseManualFeed = 1) | ~!IsDuplexDoc THEN
   PJ:=PRINTJOB.Create(PrinterName);
   HasDuplex:=PJ.Printer.OSDefaultDocumentProperties.Duplex;
   IF UseManualFeed=1 THEN
    WordDocument.PageSetup.FirstPageTray :=PJ.Printer.ASBPrintSettings.ManualPaperTray;
    WordDocument.PageSetup.OtherPagesTray:=PJ.Printer.ASBPrintSettings.ManualPaperTray;
   ELSIF IsDuplexDoc=1 THEN
    IF HasDuplex THEN
     WordDocument.PageSetup.FirstPageTray :=PJ.Printer.DefaultDocumentProperties.PaperTray;
     WordDocument.PageSetup.OtherPagesTray:=PJ.Printer.DefaultDocumentProperties.PaperTray;
    ELSE
     WordDocument.PageSetup.FirstPageTray :=PJ.Printer.DefaultDocumentProperties.PaperTray;
     WordDocument.PageSetup.OtherPagesTray:=PJ.Printer.ASBPrintSettings.ManualPaperTray;
    END;
   ELSIF IsDuplexDoc=0 THEN
    IF HasDuplex THEN
     wordSetVar(PageBreakForDuplexVarName, CHR(12));
    END;
   END;
  END;
 END {SetupPage};

 PRIVATE PROCEDURE CreateWordApplication(Msg: STRING[]): OBJECT;
  CONST
   AcceptableVersion       = 9;
   AcceptableVersion_AsStr = "MS Word 2000";
  VAR
   trgWord: OBJECT;
 BEGIN
  APP.Get().NewPrompt(" MS Word Application: " + Msg);
  TRY
   trgWord:=CreateOBJECT("Word.Application");
   IF STRTOFLD(trgWord.Version, NUMERIC) < AcceptableVersion THEN
    L_General.Error(" Word     " +
                    L_Str.IntStr(AcceptableVersion) + " (" + AcceptableVersion_AsStr + ")");
   END;
   RETURN trgWord;
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.Assert(L_General.OBJECTIsInitialized(trgWord), "    ⠭ MS Word");
   trgWord.Quit();
   IF Exc.ErrorCode # L_General.ec_rt_FailedSTRTOFLD THEN
    RAISE();
   END;
   L_General.Error(" Word     9 (Word 2000)");
  END; (* TRY *)
 END {CreateWordApplication};

 PRIVATE PROCEDURE CloseWordApplication(word: OBJECT; wCheckDocAmount: SCAL[2]);
 BEGIN
  TRY
   IF ~!word THEN
    APP.Get().NewPrompt("襭 MS Word Application");
    IF ~wCheckDocAmount | (word.Documents.Count = 0) THEN
     word.DisplayAlerts:=wdFalse;
     word.Quit(wdFalse);
    END;
    SETEMPTY(word);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
  END; (* TRY *)
 END {CloseWordApplication};

 PRIVATE PROCEDURE SaveDocument(Document: OBJECT; DotName: STRING[]): STRING[];
  VAR
   DocumentFileName: STRING[];
 BEGIN
  DocumentFileName:=GetTmpDocumentFullName(DotName);
  Document.SaveAs(DocumentFileName);
  Document.Close(wdFalse);
  RETURN DocumentFileName;
 END {SaveDocument};

 PRIVATE PROCEDURE AddByUserSignInFooter(Range: OBJECT);
  CONST
   TextToSearch   = "⮢ ";
   TextToReplace  = TextToSearch + "*";
   wdFindContinue = 1;
   wdReplaceAll   = 2;
 BEGIN
  Range.Find.ClearFormatting(); 
  Range.Find.Replacement.ClearFormatting();
  Range.Find.Forward          :=wdTrue;
  Range.Find.Wrap             :=wdFindContinue;
  Range.Find.Format           :=wdFalse; 
  Range.Find.MatchCase        :=wdFalse; 
  Range.Find.MatchWholeWord   :=wdFalse; 
  Range.Find.MatchWildcards   :=wdFalse; 
  Range.Find.MatchSoundsLike  :=wdFalse; 
  Range.Find.MatchAllWordForms:=wdFalse;

  Range.Find.Text             :=TextToReplace;
  IF ~Range.Find.Execute() THEN
   Range.Find.Text            :=TextToSearch;
   Range.Find.Replacement.Text:=TextToReplace;
   Range.Find.Execute(,,,,,,,,,, wdReplaceAll);
  END;
 END {AddByUserSignInFooter};

 PRIVATE PROCEDURE AddByUserSign(Document: OBJECT);
  VAR
   i, j: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" ਧ 짮⥫᪮ 蠡");
  i:=Document.Sections.Count;
  WHILE i > 0 DO
   j:=Document.Sections(i).Footers.Count;
   WHILE j > 0 DO
    PROMPT(" " + L_Str.IntStr(i) + ",   " + L_Str.IntStr(j));
    AddByUserSignInFooter(Document.Sections(i).Footers(j).Range);
    DEC(j);
   END;
   DEC(i);
  END;
 END {AddByUserSign};

 PRIVATE PROCEDURE SystemTemplateExist(DotName: STRING[]): SCAL[2];
  VAR
   T: STRING[];
 BEGIN
  T:=FIO.FullPath(FIO.BuildPath(DotName, DefaultTemplateExtension, RootFolder));
  RETURN FIO.Exists(FIO.FullPath(FIO.BuildPath(DotName, DefaultTemplateExtension, RootFolder)));
 END {SystemTemplateExist};

 PRIVATE PROCEDURE OpenWord(    First      : SCAL[2];
                                DotName    : STRING[];
                                PrepareMode: PrpModeType;
                            VAR tempWord1               : OBJECT;
                            VAR tempWord2               : OBJECT;
                            VAR mainWord                : OBJECT;
                            VAR Document                : OBJECT;
                            VAR ActivePrinter           : STRING[];
                            VAR CheckGrammarAsYouType   : NUMERIC[0];
                            VAR CheckSpellingAsYouType  : NUMERIC[0];
                            VAR CheckGrammarWithSpelling: NUMERIC[0];
                            VAR DotFullName             : STRING[]);
 BEGIN
  SETEMPTY(ActivePrinter, CheckGrammarAsYouType, CheckSpellingAsYouType, CheckGrammarWithSpelling,
           tempWord1, tempWord2, mainWord, Document);
  TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)]
   IF (~SetTables_wClipboard()) | (PutInTables = Put_Values) | (PrepareMode = PrpMode_ToTmpDot) THEN
    tempWord1:=CreateWordApplication("guard 1");
    tempWord2:=CreateWordApplication("guard 2");
   END;
   mainWord :=CreateWordApplication("main");
   mainWord.Visible        :=wdFalse;
   mainWord.DisplayAlerts  :=wdFalse;
   CheckGrammarAsYouType   :=mainWord.Options.CheckGrammarAsYouType;
   CheckSpellingAsYouType  :=mainWord.Options.CheckSpellingAsYouType;
   CheckGrammarWithSpelling:=mainWord.Options.CheckGrammarWithSpelling;
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)] (* 0057205 04.04.2007 11:36:21 San *)
    ActivePrinter:=mainWord.ActivePrinter;
   EXCEPT
    SETEMPTY(ActivePrinter);
   ON Exc: Exc_Root DO
   END; (* TRY *)
   DotFullName:=GetDotFullName(DotName);
   mainWord.Options.CheckGrammarAsYouType   :=wdFalse;
   mainWord.Options.CheckSpellingAsYouType  :=wdFalse;
   mainWord.Options.CheckGrammarWithSpelling:=wdFalse;
  EXCEPT
  END; (* TRY *)
  IF    (UsingStage = us_Development) | (UsingStage = us_Publication) THEN
   PROMPT("࠭  蠡");
   FIO.SetAttr(DotFullName, , 0, 0);
   L_FIO.ExactFileCopy(DotFullName,
                           Str.Delete(DotFullName, Str.Length(DotFullName) - 1, 1) + "~");
   IF    UsingStage = us_Development THEN
    PROMPT("⨥ 蠡  ० ࠧࠡ⪨");
   ELSIF UsingStage = us_Publication THEN
    PROMPT("⨥ 蠡  ० 㡫樨");
   END;
   Document:=mainWord.Documents.Open(DotFullName, wdFalse);
  ELSIF UsingStage = us_Using THEN
   IF UseTmpDot THEN
    DotFullName:=GetTmpDotFullName(DotName);
   END;
   Document:=mainWord.Documents.Add(DotFullName);
  END;
  IF First THEN
   IF (UsingStage = us_Using) | (UsingStage = us_Development) THEN
    SetStandartVariables(PrepareMode);
   END;
  END;
 END {OpenWord};

 PRIVATE PROCEDURE CloseWord(    Intermediate: SCAL[2];
                             VAR tempWord1               : OBJECT;
                             VAR tempWord2               : OBJECT;
                             VAR mainWord                : OBJECT;
                                 CloseMainWordRequired   : SCAL[2];
                                 ActivePrinter           : STRING[];
                                 CheckGrammarAsYouType,
                                 CheckSpellingAsYouType,
                                 CheckGrammarWithSpelling: NUMERIC[0]);
 BEGIN
  APP.Get().NewPrompt(L_Str.PoolItem(" 䥪⮢ MS Word|襭 ࠡ", Intermediate));
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   CloseWordApplication(tempWord1, 1);
   CloseWordApplication(tempWord2, 1);
   IF CloseMainWordRequired THEN
    IF ~!mainWord THEN
     mainWord.Options.CheckGrammarAsYouType   :=CheckGrammarAsYouType;
     mainWord.Options.CheckSpellingAsYouType  :=CheckSpellingAsYouType;
     mainWord.Options.CheckGrammarWithSpelling:=CheckGrammarWithSpelling;
     mainWord.ActivePrinter                   :=ActivePrinter;
     CloseWordApplication(mainWord, 0);
    END;
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   (* nothing *)
  END; (* TRY *)
 END {CloseWord};

 PRIVATE PROCEDURE Put2XDocFile(trg_iri    : L_General.tInternalRecordId;
                                trgXDFKind : L_XDoc.tXDFKind;
                                srcFileName: STRING[];
                                trgFileOper: L_XDoc.tFileOper;
                                trgStatus  : LIKE(XDocFile.Status);
                                VAR dstFileName: STRING[]);
  VAR
   trgXDocId : L_XDoc.tXDocId;
   trgName   : STRING[];
 BEGIN
  TRY [TRANSACTION(TRANSACTION_SLAVE)]
   IF ~!L_XDoc.GetFileXDT(DATABASE.Get().TableById(L_General.iri_fi(trg_iri)).Name) THEN
    trgXDocId:=L_XDoc.iri2XDocId(trg_iri);
    trgName:=trgXDocId + FLDTOSTR(L_XDoc.GetXDocCopyCnt(trgXDocId), "L");
   ELSE
    trgName:=trg_iri;
   END;
   INC(trgName, "." + L_FIO.effp_FileExt(srcFileName));
   L_XDoc.AttachFile2iri(trg_iri,
                         trgXDFKind,
                         srcFileName,
                         trgName,
                         trgFileOper,
                         trgStatus,
                         "");
   dstFileName:=L_XDoc.xdf_GetFullFileName();
  EXCEPT
  ON Exc: Exc_Root DO
   RAISE();
  END; (* TRY *)
 END {Put2XDocFile};

 PRIVATE PROCEDURE CheckBY_USERTemplateIsPublished(DotName: STRING[]);
  CONST
   Till = 14\04\2014;
  VAR
   Msg: STRING[];
 BEGIN
  IF IsBY_USERTemplate(DotName) & ~FOLDER_ENTRY.Create(GetDotFullName(DotName)).Attributes.ReadOnly THEN
   SETEMPTY(Msg);
   IF ~L_General.IsAdmin() THEN
    Msg:=",   ,  ᮮ  ᫥饥:||";
   END;
   Msg:=Msg +
        "ࠡ⪠ 짮⥫᪮ 蠡 '" + DotName + "'  襭,|" +
        "室 믮 楤 㡫樨 蠡";

   IF SYSDATE() >= Till THEN
    L_General.Error(Msg);
   ELSE
    L_StdFrm.Choice(Msg + "||" +
                    "  㡫묨 짮⥫᪨ 蠡|"+
                    "⠭  ᫥ " + L_DatTim.DateStr(Till));
   END;
  END;
 END {CheckBY_USERTemplateIsPublished};

 PRIVATE PROCEDURE intMakeDocument(DotName    : STRING[];
                                   Copies     : NUMERIC[0];
                                   PrepareMode: PrpModeType;
                                   TextParam  : STRING[];
                                   trg_iri    : L_General.tInternalRecordId;
                                   PrepareProc: PROC): STRING[];
  VAR
   PJ,
   tempWord1,
   tempWord2,
   mainWord,
   Document,
   TmpDocument,
   ActualVariables       : OBJECT;

   Result,
   DotFullName,
   DotFileName,
   TempFileName,
   ActivePrinter,
   pa_Name,
   pa_FilePath,
   pa_FileName,
   pa_FileExt,
   dst_Path,
   srcFileName,
   dstFileName,
   PrinterName    : STRING[];

   AddButton,
   AddButtonPlace : STRING[];
   React,
   TryCnt,
   CheckGrammarAsYouType,
   CheckSpellingAsYouType,
   PrintZoomPaperWidth,
   PrintZoomPaperHeight,
   CheckGrammarWithSpelling: NUMERIC[0];
   wPrepareVariableList,
   InsertPageBreak         : SCAL[3];
   LabelName, Dummy        : STRING[];
   ProceedAllowed,
   CloseMainWordRequired   : SCAL[2];
   Sleep                   : NUMERIC[3];
 BEGIN
  IF ~!PrepareProc THEN
   wordInitDocument(SYSDATE());
   IF UsingStage = us_Development THEN
    SETEMPTY(Document);
    PrepareProc(Document);
    SETEMPTY(PrepareProc);
   END;
  END;
  ProceedAllowed:=1;
  IF UsingStage = us_Development THEN
   IF    ~L_General.IsOurEngineeringCopy() THEN
    IF    APP.Get().SupportMode & IsAcceptableTemplateLocation(DotName, "AP_SUPPORT") THEN
     L_StdFrm.Question("ࠡ⪠ 蠡  AP_SUPPORT");
    ELSIF ~IsBY_USERTemplate(DotName) THEN
     L_StdFrm.CrucialChoice_FileExplicit("",
                                         "㤥 ᮧ 짮⥫᪨ 蠡 " + DotName +
                                         "| ᭮ 蠡, ।⠢塞 ࠡ稪",
                                         L_General.AdminGroupName());
     IF ~FIO.DirExists(BY_USERFolder) THEN
      FIO.MkDir(BY_USERFolder);
     END;
     FIO.SplitPath(DotName, DotFileName, Dummy, Dummy);
     L_FIO.ExactFileCopy(GetDotFullName(DotName),
                         FIO.BuildPath(DotFileName, DefaultTemplateExtension, BY_USERFolder));
     L_General.Assert(IsBY_USERTemplate(DotName),
                      "짮⥫᪨ 蠡 ᮧ   BY_USER, " +
                      "| RED-䠩 ஥  ஥  ᯮ짮 짮⥫᪨ 蠡. "+
                      "|| " + BY_USERFolder + "|  㪠 ࢮ  䠩  ७ DOT.");
    END;
   ELSE
    IF ~IsTMP_LIBTemplate(DotName) THEN
     L_General.Error("ࠡ⪠ 蠡    믮  " + TMP_LIBFolder);
    END;
    IF ((L_General.GetAPSiteNumber() = 91) |
        (L_General.GetAPSiteNumber() = 92) |
        (L_General.GetAPSiteNumber() = 93)) &
       ~Str.Match(GetDotFullName(DotName), "*\" + L_General.GetAPSiteID() + "\*") THEN
     L_StdFrm.Choice(' "' + DotName + '" 室   ஥ ' + L_General.GetAPSiteID() + "!");
    END;
   END; (* IF L_General.IsOurEngineeringCopy() *)
   IF PrepareMode = PrpMode_ToTmpDot THEN
    AddButton           :="%< ய >B";
    AddButtonPlace      :="%############% ";
   ELSE
    SETEMPTY(AddButton, AddButtonPlace);
   END;
   UseTmpDot           :=0;
   wPrepareVariableList:=0;
   React:=STDFORM(L_StdFrm.PartForm("%< 믮 >DB" +
                                    AddButton +
                                    "%< ⮯! >X" +
                                    "%<  㧪  {}६ >B" +
                                    "@" +
                                    "|" + GetTemplateDescr(DotName) + ": ० ⮢" +
                                    "|%###########% " + AddButtonPlace + "%#######% %#############################%"),
                                    " ⮢ 蠡 ",
                                    QUESTION,
                                    1,
                                    );
   IF !AddButton THEN
    ProceedAllowed      :=1;
    wPrepareVariableList:=React = 2;
   ELSE
    ProceedAllowed      :=React # 2;
    wPrepareVariableList:=React = 3;
   END;
  END; (* IF UsingStage = us_Development...*)

  SETEMPTY(Result);
  IF ProceedAllowed THEN
   TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
    CloseMainWordRequired:=1;
    OpenWord(1, DotName, PrepareMode,
             tempWord1, tempWord2, mainWord, Document,
             ActivePrinter,
             CheckGrammarAsYouType, CheckSpellingAsYouType, CheckGrammarWithSpelling,
             DotFullName);
    IF    UsingStage = us_Publication THEN
     GetAllVariables(Document.Variables);
    ELSIF UsingStage = us_Development THEN
     SETEMPTY(wordBkmsVal);
     SetAllBookmarks(Document);
     SetAllTables(DotName, Document);
    ELSIF UsingStage = us_Using THEN
     IF ~!PrepareProc THEN
      PrepareProc(Document);
      IF L_General.IsWindows2008() THEN
       CloseWord(0,
                 tempWord1, tempWord2, mainWord,
                 1,
                 ActivePrinter,
                 CheckGrammarAsYouType, CheckSpellingAsYouType, CheckGrammarWithSpelling);
       OpenWord(0, DotName, PrepareMode,
                tempWord1, tempWord2, mainWord, Document,
                ActivePrinter,
                CheckGrammarAsYouType, CheckSpellingAsYouType, CheckGrammarWithSpelling,
                DotFullName);
      END;
     END;
     SetAllBookmarks(Document);
     SetAllTables(DotName, Document);
     CheckSpecificPics(Document, DotName);
     SetAllPics(Document);
    END;
 
    wordSetVar(PageBreakForDuplexVarName, "");
    IF (UsingStage = us_Using) & (PrepareMode = PrpMode_Print) THEN
     PrinterName:=TextParam;
     IF !PrinterName THEN
      PrinterName:=GETDEFAULTPRINTER();
      L_General.Assert(~!PrinterName, " ஥ ਭ  㬮砭");
     END;
     SetupPage(Document, PrinterName);
    END;
 
    ActualVariables:=L_General.CreateDictionary();
    ParseFields(DotName, Document, ActualVariables, PROCREF(PutInDict));
    SetAllVariables(Document.Variables, ActualVariables);
    IF (UsingStage = us_Using) & (PutInFields = Put_Values) THEN
     ReplaceFieldsToValues(Document, ActualVariables);
    ELSE
     ParseFields(DotName, Document, ActualVariables, PROCREF(wordUpdateFields));
    END;
    Sleep:=Math.Max(0.7, Document.Fields.Count / 1200);
    SLEEP(Sleep);
    Document.Fields.Update();
    IF    UsingStage = us_Publication THEN
     Document.Save();
     IF ~IsTMP_LIBTemplate(DotName) THEN
      FIO.SetAttr(DotFullName, , 1, 0);
     END;
    ELSIF UsingStage = us_Development THEN
     Document.Save();
     IF wPrepareVariableList THEN
      PrepareVariableList(mainWord);
     END;
     mainWord.Visible     :=wdTrue;
     mainWord.Activate();
     CloseMainWordRequired:=0;
    ELSIF UsingStage = us_Using THEN
     IF IsBY_USERTemplate(DotName) & SystemTemplateExist(DotName) THEN
      AddByUserSign(Document);
     END;
     CheckBY_USERTemplateIsPublished(DotName);
     IF    PrepareMode = PrpMode_Print THEN
      PROMPT("");
      mainWord.ActivePrinter:=PrinterName;
      PJ:=PRINTJOB.Create(PrinterName);
      IF (Document.PageSetup.PaperSize = 6) & (PJ.DocumentProperties.PaperForm = "A4") THEN
       PrintZoomPaperWidth :=11907;
       PrintZoomPaperHeight:=16839;
      ELSE
       SETZERO(PrintZoomPaperWidth, PrintZoomPaperHeight);
      END;
      Document.PrintOut(wdFalse(* 䮭 *),,,,,,, Copies, ,,,,,,,, PrintZoomPaperWidth, PrintZoomPaperHeight);
      mainWord.ActivePrinter:=ActivePrinter;
      Document.Close(wdFalse);
     ELSIF (PrepareMode = PrpMode_ToDoc) | (PrepareMode = PrpMode_ToDocFile) THEN
      PROMPT("࠭ 㬥");
      IF IsBY_USERTemplate(DotName) & SystemTemplateExist(DotName) THEN
       TempFileName:=SaveDocument(Document, DotName + "_ByU_");
      ELSE
       TempFileName:=SaveDocument(Document, DotName);
      END;
      IF ~!trg_iri THEN
       PROMPT("ਪ९ 㬥");
       L_XDoc.xdf_CancelActualBy_iri(trg_iri, L_XDoc.xdfk_DocOrig);
       Put2XDocFile(trg_iri, L_XDoc.xdfk_DocOrig, TempFileName, L_XDoc.FO_Move, L_XDoc.xdfSt_Prepared, Result);
       IF L_General.BatchExecution_IsRunning() THEN
        CloseMainWordRequired:=1;
       ELSE
        IF L_XDoc.xdf_StandOnActualBy_iri(trg_iri, L_XDoc.xdfk_DocOrig) THEN
         CALL(XDocFile.OpenFile());
        ELSE
         L_General.CallUs(0);
        END;
        CloseMainWordRequired:=0;
       END;
      ELSE
       IF PrepareMode = PrpMode_ToDoc THEN
        PROMPT("⨥ 㬥");
        mainWord.Documents.Open(TempFileName, wdFalse, wdTrue);
        TryCnt:=0;
        LOOP
         (* 0103226 *)
         TRY
          mainWord.Visible:=wdTrue;
          EXIT;
         EXCEPT
         ON Exc:Exc_Object DO
          IF TryCnt = 10 THEN
           RAISE();
          END;
          INC(TryCnt);
          SLEEP(0.1);
         END;
        END; (* LOOP *)
        mainWord.Activate();
       END;
       CloseMainWordRequired:=(PrepareMode = PrpMode_ToDocFile);
       Result:=TempFileName;
      END;
     ELSIF (PrepareMode = PrpMode_ToPDF) | (PrepareMode = PrpMode_ToImage) THEN
      PROMPT(" 㬥");
      IF    PrepareMode = PrpMode_ToPDF THEN
       L_Print.GetPA_Virtual(L_Print.pt_PDF, pa_Name, pa_FilePath, pa_FileName);
      ELSIF PrepareMode = PrpMode_ToImage THEN
       L_Print.GetPA_Virtual(L_Print.pt_Image, pa_Name, pa_FilePath, pa_FileName);
      END;
      mainWord.ActivePrinter:=pa_Name;
      L_General.Assert(Str.Pos(mainWord.ActivePrinter, pa_Name) = 0,
                       " 㤠  ਭ " + pa_Name);
 
      FIO.SplitPath(pa_FileName, pa_FileName, pa_FileExt);
      IF pa_FileName = "*" THEN
       TempFileName:=GetTmpDocumentFullName("");
       FIO.SplitPath(TempFileName, srcFileName, Dummy, Dummy);
      ELSE
       TempFileName:=GetTmpDocumentFullName(pa_FileName);
       srcFileName:=pa_FileName;
      END;
      srcFileName:=FIO.BuildPath(srcFileName, pa_FileExt, pa_FilePath);

      Document.SaveAs(TempFileName);
      Document.PrintOut(wdFalse(* 䮭 *));
      mainWord.ActivePrinter:=ActivePrinter;
      Document.Close(wdFalse);
 
      IF ~L_General.TestExecution_IsRunning() THEN
       IF !trg_iri THEN
        FIO.SplitPath(TextParam, TextParam, Dummy, dst_Path);
        dstFileName:=FIO.BuildPath(TextParam, pa_FileExt, dst_Path);
        L_FIO.MakeSubDirs(L_FIO.effp_Folder(dstFileName));
        TryCnt:=0;
        LOOP
         PROMPT("७ 䠩 (" + L_Str.IntStr(TryCnt) + ")");
         TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
          FIO.RenMov(srcFileName, , dstFileName, );
          EXIT;
         EXCEPT
         ON Exc: Exc_Root DO
          INC(TryCnt);
          L_General.Assert(TryCnt < 10, Exc.MsgOriginalText);
         END; (* TRY *)
         SLEEP(1.0);
        END; (* LOOP *)
       ELSE
        Put2XDocFile(trg_iri, L_XDoc.xdfk_DocCopy, srcFileName, L_XDoc.FO_Move, L_XDoc.xdfSt_Passed,
                     dstFileName);
       END;
       Result:=dstFileName;
      ELSE
       Result:=srcFileName;
      END; (* IF ~L_General.TestExecution_IsRunning() *)
     ELSIF PrepareMode = PrpMode_ToHTM THEN
      PROMPT(" web-࠭");
      Document.SaveAs(TextParam, wdFormatHTML);
      Document.Close(wdFalse);
      IF Copies > 0 THEN
       PROMPT("⨥ 㬥");
       mainWord.Documents.Open(TextParam, wdFalse, wdTrue);
       mainWord.Visible     :=wdTrue;
       mainWord.Activate();
       CloseMainWordRequired:=0;
      END;
      Result:=TextParam;
     ELSIF PrepareMode = PrpMode_ToTmpDot THEN
      PROMPT("⨥ 蠡");
      TempFileName:=GetTmpDotFullName(L_Str.AnyItem(TextParam, ";", 0));
      PROMPT("⨥ ६ 㬥");
      TmpDocument :=mainWord.Documents.Open(TempFileName, wdFalse);
 
      IF    !L_Str.AnyItem(TextParam, ";", 1) THEN
       InsertPageBreak:=ipb_None;
      ELSIF L_Str.AnyItem(TextParam, ";", 1) = ipb_BeforePaste_AsStr THEN
       InsertPageBreak:=ipb_BeforePaste;
      ELSE
       InsertPageBreak:=ipb_AfterPaste;
      END;
      LabelName:=L_Str.AnyItem(TextParam, ";", 2);
      IF    ~!LabelName THEN
       Selection_Proceed(TmpDocument, 'GoTo(wdGoToBookmark, , , "' + LabelName + '")');
       Selection_Proceed(TmpDocument, "MoveUp(wdLine, 1)");
      ELSIF InsertPageBreak # ipb_None THEN
       Selection_Proceed(TmpDocument, "EndKey(wdStory)");
      END;
 
      IF InsertPageBreak = ipb_BeforePaste THEN
       Selection_Proceed(TmpDocument, "InsertBreak(wdPageBreak)");
      END;
 
      srcFileName:=SaveDocument(Document, DotName);
      Selection_Proceed(TmpDocument, 'InsertFile("' + srcFileName + '")');
      IF InsertPageBreak = ipb_AfterPaste THEN
       Selection_Proceed(TmpDocument, "InsertBreak(wdPageBreak)");
      END;
 
      TryCnt:=0;
      LOOP
       PROMPT("࠭ 蠡 (" + L_Str.IntStr(TryCnt) + ")");
       TRY
        FIO.Erase(srcFileName);
        TmpDocument.SaveAs(TempFileName);
        EXIT;
       EXCEPT
       ON Exc: Exc_Root DO
        INC(TryCnt);
        L_General.Assert(TryCnt < 3, " 㤠 ࠭ 蠡 " + TempFileName);
       END; (* TRY *)
      END; (* LOOP *)
 
      TmpDocument.Close(wdFalse);
      Result:=TempFileName;
     END;
    END;
   EXCEPT
   ON Exc: Exc_Root DO
    RAISE();
   FINALLY
    CloseWord(1,
              tempWord1, tempWord2, mainWord,
              CloseMainWordRequired,
              ActivePrinter,
              CheckGrammarAsYouType, CheckSpellingAsYouType, CheckGrammarWithSpelling);
   END; (* TRY *)
  END; (* IF ProceedAllowed...*)
  RETURN Result;
 END {intMakeDocument};

 PUBLIC PROCEDURE MakeWordDocument(DotName    : STRING[];
                                   Copies     : NUMERIC[0];
                                   PrepareMode: PrpModeType;
                                   TextParam  : STRING[]);
  VAR
   Dummy: STRING[];
 BEGIN
  Dummy:=intMakeDocument(DotName, Copies, PrepareMode, TextParam, EMPTYOF(L_General.tInternalRecordId), EMPTYOF(PROC));
 END {MakeWordDocument};

 PUBLIC PROCEDURE BuildWordDocument(DotName    : STRING[];
                                    Copies     : NUMERIC[0];
                                    PrepareMode: PrpModeType;
                                    TextParam  : STRING[];
                                    PrepareProc: PROC);
  VAR
   Dummy: STRING[];
 BEGIN
  Dummy:=intMakeDocument(DotName, Copies, PrepareMode, TextParam, EMPTYOF(L_General.tInternalRecordId), PrepareProc);
 END {MakeWordDocument};

 PUBLIC PROCEDURE MakeXDFWordDocument(trg_iri    : L_General.tInternalRecordId;
                                       DotName    : STRING[];
                                       Copies     : NUMERIC[0];
                                       PrepareMode: PrpModeType);
  VAR
   Dummy: STRING[];
 BEGIN
  Dummy:=intMakeDocument(DotName, Copies, PrepareMode, "", trg_iri, EMPTYOF(PROC));
 END {MakeXDFWordDocument};

 PUBLIC PROCEDURE BuildXDFWordDocument(trg_iri    : L_General.tInternalRecordId;
                                       DotName    : STRING[];
                                       Copies     : NUMERIC[0];
                                       PrepareMode: PrpModeType;
                                       PrepareProc: PROC);
  VAR
   Dummy: STRING[];
 BEGIN
  Dummy:=intMakeDocument(DotName, Copies, PrepareMode, "", trg_iri, PrepareProc);
 END {MakeXDFWordDocument};

 PUBLIC PROCEDURE E_PrintXDocMethod(): SCAL[2];
 BEGIN
  RETURN L_General.IsPolakSpecific();
 END {E_PrintXDocMethod};

 PUBLIC PROCEDURE MakeWordDocument2File(DotName, FileName: STRING[]; PrepareMode: PrpModeType): STRING[];
  VAR
   TextParam: STRING[];
 BEGIN
  TextParam:=L_FIO.tf_GetFullPath(FileName, "");
  RETURN intMakeDocument(DotName, 1, PrepareMode, TextParam, EMPTYOF(L_General.tInternalRecordId), EMPTYOF(PROC));
 END {MakeWordDocument2File};

 PUBLIC PROCEDURE PrintWordDocument(pj: PRINTJOB; srcFileName: STRING[]);
  VAR
   mainWord            : OBJECT;
   Document            : OBJECT;
   ActivePrinter       : STRING[];
   PrintZoomPaperWidth,
   PrintZoomPaperHeight: NUMERIC[0];
 BEGIN
  SETEMPTY(ActivePrinter);
  TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)]
   mainWord :=CreateWordApplication("main");
   mainWord.Visible        :=wdFalse;
   mainWord.DisplayAlerts  :=wdFalse;
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)] (* 0057205 04.04.2007 11:36:21 San *)
    ActivePrinter:=mainWord.ActivePrinter;
   EXCEPT
    SETEMPTY(ActivePrinter);
   END; (* TRY *)
  EXCEPT
  END; (* TRY *)
  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   IF !pj THEN
    pj:=PRINTJOB.Create(GET_DEFAULT_PRINTER());
   END;
   mainWord.ActivePrinter:=pj.Printer.Name;
   Document:=mainWord.Documents.Open(srcFileName, wdFalse, wdTrue);
   IF (Document.PageSetup.PaperSize = 6) & (PJ.DocumentProperties.PaperForm = "A4") THEN
    PrintZoomPaperWidth :=11907;
    PrintZoomPaperHeight:=16839;
   ELSE
    SETZERO(PrintZoomPaperWidth, PrintZoomPaperHeight);
   END;
   Document.PrintOut(wdFalse(* 䮭 *),,,,,,, 1, ,,,,,,,, PrintZoomPaperWidth, PrintZoomPaperHeight);
   mainWord.ActivePrinter:=ActivePrinter;
   Document.Close(wdFalse);
  EXCEPT
  FINALLY
   mainWord.ActivePrinter:=ActivePrinter;
   CloseWordApplication(mainWord, 0);
  END; (* TRY *)
 END {PrintWordDocument};

 PUBLIC CONST
  m_SearchOnlyFromBegDocvariable = 0;
  m_SearchInWholeDocvariable     = 1;

 PRIVATE PROCEDURE GetWordDocVariableName(Code: STRING[]): STRING[];
  VAR
   i     : NUMERIC[0];
   Found : SCAL[2];
   Result: STRING[];
 BEGIN
  SETZERO(i, Found);
  LOOP
   Result:=Str.Item(Code, " ", i);
   IF !Result THEN
    EXIT;
   END;
   IF Str.Pos(Result, ".") # Str.Length(Result) THEN
    Found:=1;
    EXIT;
   END;
   INC(i);
  END; (* LOOP *)
  IF ~Found THEN
   SETEMPTY(Result);
  END;
  RETURN Str.Condense(Result);
 END {GetWordDocVariableName};

 PRIVATE PROCEDURE RenameWordDocVariablesInSingleDocumentPart(FieldCollection: OBJECT;
                                                              Variables      : OBJECT;
                                                              Msg            : STRING[];
                                                              oldText        : STRING[];
                                                              newText        : STRING[];
                                                              Mode           : SCAL[2]);
  CONST
   wdFieldDocVariable = 64;
  VAR
   Field                    : OBJECT;
   i, Pos                   : NUMERIC[0];
   trgValue,
   oldSingleText,
   newSingleText,
   oldDocVariable,
   newDocVariable,
   newDocVariableCode       : STRING[];
   RequiredInsertNewVariable: SCAL[2];
 BEGIN
  FOR_EACH Field IN FieldCollection DO
   IF    Field.Type = wdFieldDocVariable THEN
    oldDocVariable:=GetWordDocVariableName(Field.Code.Text);
    PROMPT(Msg + ": " + oldDocVariable);
    IF ~!oldDocVariable THEN
     i:=0;
     LOOP
      oldSingleText:=L_Str.PoolItem(oldText, i);
      newSingleText:=L_Str.PoolItem(newText, i);
      IF !oldSingleText THEN
       EXIT;
      END;
      IF ((Mode = m_SearchInWholeDocvariable)     & Str.Match(oldDocVariable, "*" + oldSingleText + "*")) |
         ((Mode = m_SearchOnlyFromBegDocvariable) & Str.Match(oldDocVariable, oldSingleText + "*")) THEN
       (* ஢ઠ,  宦 oldSingleText  oldDocVariable - ⢥ *)
       Pos:=Str.Pos(oldDocVariable, oldSingleText);
       IF Str.Pos(oldDocVariable, oldSingleText, Pos+1) # Str.Length(oldDocVariable) THEN
         L_General.CallUs(0);
       END;
       newDocVariable:=Str.Replace(oldDocVariable, oldSingleText, newSingleText);
      ELSE
       SETEMPTY(newDocVariable);
      END;
      IF ~!newDocVariable THEN
       TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
        trgValue      :=Variables(oldDocVariable).Value;
        Variables(oldDocVariable).Delete();
        RequiredInsertNewVariable:=1;
 
       EXCEPT
       ON Exc:Exc_Object DO
        RequiredInsertNewVariable:=0;
       ELSE
        RAISE();
       END; (* TRY *)
 
       Pos               :=Str.Pos(Field.Code.Text, oldDocVariable);
       newDocVariableCode:=Str.Delete(Field.Code.Text, Pos, Str.Length(oldDocVariable));
       newDocVariableCode:=Str.Condense(Str.Insert(newDocVariableCode, newDocVariable, Pos));
 
       Field.Code.Text   :=newDocVariableCode;
 
       IF RequiredInsertNewVariable THEN
        Variables(newDocVariable).Value:=trgValue;
       END;
 
       Field.Update();
      END;
      INC(i);
     END; (* LOOP *)
    END;
   END;
  END; (* FOR_EACH *)
 END {RenameWordDocVariablesInSingleDocumentPart};

 PRIVATE PROCEDURE RenameWordDocVariablesInSingleDotFile(Document: OBJECT;
                                                         oldText : STRING[];
                                                         newText : STRING[];
                                                         Mode    : SCAL[2]);
  VAR
   i, j: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("");
  RenameWordDocVariablesInSingleDocumentPart(Document.Fields, Document.Variables, "᭮ ", oldText, newText, Mode);
  i:=1;
  WHILE i <= Document.Sections.Count DO
   j:=1;
   WHILE j <= Document.Sections(i).Headers.Count DO
    IF Document.Sections(i).Headers(j).LinkToPrevious = wdFalse THEN
     RenameWordDocVariablesInSingleDocumentPart(Document.Sections(i).Headers(j).Range.Fields, Document.Variables, "孨 ", oldText, newText, Mode);
    END;
    INC(j);
   END;
   j:=1;
   WHILE j <= Document.Sections(i).Footers.Count DO
    IF Document.Sections(i).Footers(j).LinkToPrevious = wdFalse THEN
     RenameWordDocVariablesInSingleDocumentPart(Document.Sections(i).Footers(j).Range.Fields, Document.Variables, " ", oldText, newText, Mode);
    END;
    INC(j);
   END;
   INC(i);
  END;
  Document.Close(wdTrue);
 END {RenameWordDocVariablesInSingleDotFile};

 PUBLIC PROCEDURE RenameWordDocVariables(DotFileList: STRING[];
                                         oldText    : STRING[];
                                         newText    : STRING[];
                                         Mode       : SCAL[2]);
  VAR
   i            : NUMERIC[0];
   word         : OBJECT;
   File         : FOLDER_ENTRY;
   trgReadOnly  : SCAL[2];
   DotFolderName,
   SingleDotFile: STRING[];
 BEGIN
  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   word        :=CreateOBJECT("Word.Application");
   word.Visible:=wdFalse;
   L_General.CallUs(~!DotFileList);
   i:=0;
   LOOP
    SingleDotFile:=L_Str.PoolItem(DotFileList, i);
    IF !SingleDotFile THEN
     EXIT;
    END;
    DotFolderName:=FIO.FullPath("DOT\BY_USER");
    IF FIO.DirExists(DotFolderName) THEN
     FOR_EACH File IN FOLDER_ENTRY.CreateRedirector(FIO.BuildPath(SingleDotFile, "DOT", DotFolderName)).FolderContent DO
      PROMPT(File.Path);
      trgReadOnly:=File.Attributes.ReadOnly;
 
      IF trgReadOnly THEN
       FIO.SetAttr(File.Path, , 0);
      END;
 
      RenameWordDocVariablesInSingleDotFile(word.Documents.Open(File.Path, wdFalse), oldText, newText, Mode);
 
      IF trgReadOnly THEN
       FIO.SetAttr(File.Path, , 1);
      END;
     END; (* FOR_EACH File IN FOLDERENTRY...*)
    END;
    INC(i);
   END; (* LOOP *)
  EXCEPT
  ON Exc: Exc_Root DO
   RAISE();
  FINALLY
   IF VAR_IMPL.Get(word).Initialized & ~!word THEN
    word.Quit();
   END;
  END; (* TRY *)
 END {RenameWordDocVariables};

END.
