(*
%Copyright   (c) Polak IT
%Author      28.06.2004 15:22:28 POLAK\GAV
%Purpose       ASBCONNECTIONS
%Type        library
%Specific    SYS
%Modified    05.10.2011 20:53:20 Bor
%Environment
*)

 MODULE L_NetWrk [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tConnectionNo = SCAL[1E4];

 IMPORT Str, FIO, L_General;

 PUBLIC PROCEDURE GetMyConnectionNo(): tConnectionNo;
 BEGIN
  RETURN APP.Get().MyConnection.Number;
 END {GetMyConnectionNo};

 PUBLIC PROCEDURE IsAutomationServer(): SCAL[2];
 BEGIN
  RETURN APP.Get().MyConnection.ConnectionType = ASBCONNECTION.ConnectionType_AutomationServer;
 END {IsAutomationServer};

 PUBLIC PROCEDURE GetAnyASBConnection(Login: STRING[]): ASBCONNECTION;
  VAR
   c: ASBCONNECTION;
 BEGIN
  FOR_EACH c IN ASBCONNECTIONS.Create() DO
   IF (Str.Cap(c.LoginName) = Str.Cap(Login)) &
       ((c.Type = ASBCONNECTION.Type_Client) | (c.Type = ASBCONNECTION.Type_TerminalAgent)) THEN
    RETURN c;
   END;
  END;
  RETURN EMPTYOF(c);
 END {GetAnyASBConnection};

 PRIVATE PROCEDURE IsEqualLoginName(UserDomain1, LoginName1, UserDomain2, LoginName2: STRING[]): SCAL[2];
 BEGIN
  RETURN (Str.Cap(UserDomain1) = Str.Cap(UserDomain2)) & (Str.Cap(LoginName1) = Str.Cap(LoginName2))
 END {IsEqualLoginName};
 
 PUBLIC PROCEDURE GetTotalMyConnectionsAmount(): NUMERIC[0];
  VAR
   Connections: ASBCONNECTIONS;
   MyConn     : ASBCONNECTION;
   i,
   Amount     : NUMERIC[0];
 BEGIN
  MyConn:=APP.Get().MyConnection;
  Amount:=0;
  i:=0;
  Connections:=ASBCONNECTIONS.Create();
  WHILE i < Connections.Count DO
   IF IsEqualLoginName(Connections.Item(i).UserDomain, Connections.Item(i).LoginName,
                       MyConn.UserDomain,              MyConn.LoginName) THEN
    INC(Amount);
   END;
   INC(i);
  END(*WHILE*);
  RETURN Amount;
 END {GetTotalMyConnectionsAmount};
 
 PUBLIC PROCEDURE GetTheStationMyConnectionsAmount(): NUMERIC[0];
  VAR
   Connections: ASBCONNECTIONS;
   Conn,
   MyConn     : ASBCONNECTION;
   i,
   Amount     : NUMERIC[0];
 BEGIN
  MyConn:=APP.Get().MyConnection;
  Amount:=0;
  i:=0;
  Connections:=ASBCONNECTIONS.Create();
  WHILE i < Connections.Count DO
(*Conn  - 訡  ࠧ஬ ᪮祪  IF*)
   Conn:=Connections.Item(i);
   IF (Conn.IPAddress = MyConn.IPAddress) &
      IsEqualLoginName(Conn.UserDomain,   Conn.LoginName, MyConn.UserDomain, MyConn.LoginName) THEN
    INC(Amount);
   END;
   INC(i);
  END(*WHILE*);
  RETURN Amount;
 END {GetTheStationMyConnectionsAmount};

 PUBLIC PROCEDURE ConnectionIsRunningOnServer(c: ASBCONNECTION): SCAL[2];
 BEGIN
  RETURN Str.Match(FIO.AsbSpecialFolders("ServerProjectRoot"), "\\" + c.ClientName + "*");
 END {ConnectionIsRunningOnServer};

END.
