(*
%Copyright   (c) Polak IT
%Author      14.07.2005 11:41:05 POLAK\GAV
%Purpose     ⥫ ⠭ NTF.
%Type        library
%Specific    SYS
%Modified    23.06.2014 17:58:14 POLAK\GAV
%Environment
*)

 MODULE L_NTF [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT DBD, Str, FIO, L_General, L_Msg, L_AR, L_NetWrk, L_Guard, L_StdFrm, L_SysLog;

 PRIVATE CONST
  StartUI = 9999999;

 PRIVATE PROCEDURE DeleteNTF();
  VAR
   tryCnt : NUMERIC[0];
 BEGIN
  SETZERO(tryCnt);
  LOOP
   IF tryCnt = 3 THEN
    EXIT;
   END;
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    FIO.Erase(RTI.Get().Stack(RTI.Get().Stack.Count-1).Proc.Module.Path);
    EXIT;
   EXCEPT
   ON Exc: Exc_Root DO
    INC(tryCnt);
    SLEEP(0.3);
   END; (* TRY *)
  END; (* LOOP *)
 END {DeleteNTF};

 PRIVATE PROCEDURE Abort(wRestart, OnlyOne: SCAL[2]);
 BEGIN
  IF ~!APP.Get().MyConnection.Job THEN
   L_SysLog.ELN_Put("Job.AbortedByNtf", APP.Get().MyConnection.Job.Name)
  END;
  IF wRestart THEN
   ABORTASBPROCESSOR(RESTART);
  ELSE
   TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)]
    IF OnlyOne THEN
     DeleteNTF();
    END;
    ABORTASBPROCESSOR();
   EXCEPT
   END;
  END;
 END {Abort};

 PRIVATE PROCEDURE AbortIfAutomationServer(OnlyOne: SCAL[2]);
 BEGIN
  IF L_NetWrk.IsAutomationServer() THEN
   Abort(0, OnlyOne);
  END;
 END {AbortIfAutomationServer};

 PUBLIC PROCEDURE intGetFullNTFName(ntfName, Ext: STRING[]): STRING[];
  VAR
   Path,
   Dummy: STRING[];
 BEGIN
  FIO.SplitPath(FIO.FirstPath("Dummy", Ext), Dummy, , Path);
  RETURN FIO.BuildPath(ntfName, Ext, Path);
 END {intGetFullNTFName};

 PUBLIC PROCEDURE GetFullNTFName(ntfName: STRING[]): STRING[];
 BEGIN
  RETURN intGetFullNTFName(ntfName, "ntf");
 END {GetFullNTFName};

 PUBLIC PROCEDURE GetOut(Level   : NUMERIC[0];
                         ConnNo  : L_NetWrk.tConnectionNo;
                         OnlyOne,
                         wRestart: SCAL[2]);
  VAR
   Delay         : NUMERIC[0];
   MyConnectionNo: L_NetWrk.tConnectionNo;
 BEGIN
  IF    USERIDLE() = StartUI THEN
   IF    ~OnlyOne THEN
    IF ISADMIN() THEN
     Delay:=20;
     IF STDFORM("|, , ࠡ⠥  ०,    ⮏"+
                "|ᥬ ⠫ 짮⥫ " +
                "||%< த >X       %<    %T  >FDB", , CHOICE, , Delay) THEN
      Abort(1, OnlyOne);
     END;
    ELSE
     Abort(1, OnlyOne);
    END;
   ELSIF L_NetWrk.GetMyConnectionNo() = ConnNo THEN
    DeleteNTF();
   END;
  ELSIF Level > 0 THEN
   MyConnectionNo:=L_NetWrk.GetMyConnectionNo();
   IF (OnlyOne  & (MyConnectionNo = ConnNo)) |
      (~OnlyOne & (MyConnectionNo # ConnNo)) THEN
    AbortIfAutomationServer(OnlyOne);
    IF    L_General.IsEndUser() THEN
     CALL(Ksk.klf_SimpleMark("GetOutByNTF"));
     Abort(1, OnlyOne);
    ELSIF L_Guard.IsGuardConnection(APP.Get().MyConnection) THEN
     Abort(0, OnlyOne);
    END;
    TRY
     IF    Level = 1 THEN
      IF MAINTHREADTRNCOUNT() = 0 THEN
       Delay:=10;
       IF ISADMIN() THEN
        STDFORM("|     ⮏" +
                "||%<   ࠡ >Z    %<  %T >DB", , CHOICE, -1, Delay);
       ELSE
        STDFORM("|     ⮏" +
                "||%<  %T >X", , STOP, , Delay);
       END;
       Abort(wRestart, OnlyOne);
      ELSE
       Delay:=60;
       STDFORM("|     ⮏." +
               "||᫨      ࠡ," +
               "|  ஬, ⥬   %< த %T >X",
               , INFORM_RED, , Delay);
      END;
     ELSIF Level = 2 THEN
      Delay:=5;
      IF ISADMIN() THEN
       STDFORM("|     ⮏." +
               "||%<   ࠡ >Z" +
               "||%<  ࠡ  ⮏  १ %T ᥪ㭤 >FDB", , CHOICE, -1, Delay);
      ELSE
       STDFORM("|     ⮏." +
               "||%<  ࠡ  ⮏  १ %T ᥪ㭤 >X", , STOP, , Delay);
      END;
      Abort(wRestart, OnlyOne);
     END;
    EXCEPT
    ON Exc: Exc_Halt DO
     IF OnlyOne THEN
      DeleteNTF();
     END;
     RAISE();
    END;
   END;
  END;
 END {GetOut};

 PRIVATE PROCEDURE GetCurUser(): LIKE(AcsObj.AcsObj);
 BEGIN
  TRY
   SE_ACCESSDATAMODE(AccessDataMode_SOFT);
   L_AR.GrantRightsUnconditionally();
   IF L_AR.StandOnUser(APP.Get().MyConnection.LoginName) THEN
    RETURN AcsObj.AcsObj;
   ELSE
    RETURN EMPTYOF(AcsObj.AcsObj);
   END;
  EXCEPT
  END; (* TRY *)
 END {GetCurUser};

 PUBLIC PROCEDURE NeedRb(AuthorLogin: STRING[]);
 VAR
  Msg    : STRING[];
  R,
  TimeOut: NUMERIC[0];
 BEGIN
  IF USERIDLE() = StartUI THEN
   IF Str.Cap(APP.Get().MyConnection.LoginName) # Str.Cap(AuthorLogin) THEN
    Abort(1, 0);
   ELSE
    TimeOut:=20;
    IF STDFORM("| ⠭  室  믮 Rb"+
               "||%< த >X    %<    %T  >FDB", , QUESTION, , TimeOut) THEN
     Abort(1, 0);
    ELSE
     RETURN;
    END;
   END;
  END;
  AbortIfAutomationServer(0);
  IF L_Guard.IsGuardConnection(APP.Get().MyConnection) THEN
   Abort(0, 0);
  END;
  Msg:='|,   ࠡ  ஥ ' + DBD.BaseName() +
       '|室 ६ ࢠ  믮 Rebuild';
  IF MAINTHREADTRNCOUNT() = 0 THEN
   TimeOut:=10;
   R      :=STDFORM(Msg +
                    '||%< ⮯! >X  %< 室 %T >DB  %<     室! >B',
                    , CHOICE, 1, TimeOut);
   Abort(R = 1, 0);
  ELSE
   L_StdFrm.TimedINFORM_AsSTOP(Msg +
                               '||   襭  ।஢.' +
                               '||ࠩ ॥  ᢮ ࠡ' +
                               '|   ⮏', 60);
  END;
 END {NeedRb};

 PUBLIC PROCEDURE intPutNTF(FullNTFName, Text: STRING[]);
  VAR
   tmpFullNTFName: STRING[];
 BEGIN
  SAVE(AcsObj);
  SEARCH(AcsObj, AcsObj, , L_General.curUSER);
  Text:="(*" + L_Str.CRLF +
        "%Author: " + AcsObj.Name + " " + AcsObj.FullName + ", " + L_DatTim.CompleteSystimeStr() + L_Str.CRLF +
        "*)" + L_Str.CRLF + L_Str.CRLF +
        Text;
  RESTORE(AcsObj);

  tmpFullNTFName:=FIO.BuildPath(FullNTFName, "tmp");
  FIO.Open(F, tmpFullNTFName, , Create);
  FIO.WrStr(F, Text);
  FIO.Close(F);
  FIO.Rename(tmpFullNTFName, , FullNTFName);
 END {intPutNTF};

 PUBLIC PROCEDURE PutNTF(ntfName, Text: STRING[]);
 BEGIN
  intPutNTF(GetFullNTFName(ntfName), Text);
 END {PutNTF};

 PUBLIC PROCEDURE CheckMessages(toUSER    : LIKE(AcsObj.AcsObj);
                                Importance: L_Msg.tMessageImportance);
 BEGIN
  TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)]
   IF GetCurUser() = toUSER THEN
    TRY [TERM_BY_USER(TERM_BY_USER_IGNORE), TRANSACTION(TRANSACTION_SLAVE2)]
     L_AR.GrantRightsUnconditionally();
     L_Msg.CheckIncomingMessage(Importance);
     L_Msg.CheckCommands(1);
    EXCEPT
    FINALLY
     DeleteNTF();
    END; (* TRY *)
   END;
  EXCEPT
  END; (* TRY *)
 END {CheckMessages};

 PUBLIC PROCEDURE GetOutFromJournal(toUSER: LIKE(AcsObj.AcsObj));
  VAR
   Delay: NUMERIC[0];
 BEGIN
  IF GetCurUser() = toUSER THEN
   Delay:=20;
   IF STDFORM("| ⢨   ᫥   Journal" +
              "||%< {}⬥ >X    %< {} %T >DB", , CHOICE, , Delay) = 1 THEN
    CALL(Guard.GotOutFromJournal());
    DeleteNTF();
    Abort(0, 0);
   ELSE
    DeleteNTF();
   END;
  END;
 END {GetOutFromJournal};

 PUBLIC PROCEDURE Bark(toUSER: LIKE(AcsObj.AcsObj); Text: STRING[]);
  VAR
   Delay: NUMERIC[0];
 BEGIN
  IF GetCurUser() = toUSER THEN
   DeleteNTF();
   Delay:=600;
   STDFORM("|" + Text + "||%< {} %T >X", , INFORM_RED, , Delay);
  END;
 END {Bark};

 PUBLIC PROCEDURE Watch(toUSER: LIKE(AcsObj.AcsObj));
 BEGIN
  IF GetCurUser() = toUSER THEN
   L_Msg.CheckWatchInvite();
   DeleteNTF();
  END;
 END {Watch};

END.
