(*
%Copyright   (c) Polak IT
%Author      17.05.2004 18:04:37 POLAK\ATS
%Purpose     ⥪  ࠡ  稬 㬥⠬
%Type        library
%Specific    SYS
%Modified    18.04.2014 19:13:12 POLAK\San
%Environment
*)

 MODULE L_ODoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tAMOType = SCAL[5];

  tDamage  = NUMERIC[2];
  tConseq  = SCAL[3];
  tWho     = SCAL[3];
  tType    = SCAL[2];

 PUBLIC CONST
  erkn_StaffExplanatoryNote  = 010270100;
  erkn_MedicalExaminationAct = 010270101;
  erkn_ContractAddIns        = 010270102;
  erkn_ContractMessage       = 010270103;
  erkn_FirmMessage           = 010270104;
  erkn_RAccid                = 010270105;
  erkn_IngoingContractChange = 010270107;
  erkn_PowerOfAttorney       = 010270108;
  erkn_ForeignManMedExamAct  = 010270109;
  erkn_ViolationAct          = 010270110;

  odks_Internal = 0; (* ODocKind.Scope *)
  odks_External = 1;

  odkd_Ingoing  = 0;
  odkd_Outgoing = 1;

  odsw_Staff = 0; (* ODocStf.Who *)
  odswPool = "⭨|";

  ods_Prepared = 0;(* ODoc.Status *)
  ods_Passed   = 1;
  ods_Canceled = 2;

  odsnm_No  = 0;
  odsnm_Yes = 1;

  odsnk_Manual        = 0;
  odsnk_Through       = 1;
  odsnk_MyFirmThrough = 2;
  odsnk_Special       = 3;

  pool_ContractAdInsSense   = 0000975;
  pool_ContractMessageSense = 0000976;

  fms_BadPaidInvoices        = 00; (* FirmMessage ODoc.Sense *)
  fms_PaymentReviseAct       = 01;
  fms_PaymentReviseAct_InPer = 02;
  fms_Pool = "  ᮮ⢥饩 ⮩|" +
             " ᢥન ⮢|" +
             " ᢥન ⮢  ਮ";

  odkcn_No          = 0; (*ODocKind.CanNamed*)
  odkcn_Yes         = 1;
  odkcn_Necessarily = 2;

  amok_Granted  = 0;
  amok_Alcohol  = 1;
  amok_Drugs    = 2;
  amok_Sickness = 3;

  amo_KindPool = "饭|"+
                 "   堥 |"+
                 "મ᪮ ﭥ|"+
                 " 饭  ";

  amo_atrPool  = "⥫쭠|⥫쭠";

  amot_Undefined  = 0;
  amot_First      = 1;
  amot_InterJob   = 2;
  amot_Final      = 3;
  amot_ForeignMan = 4;

  amo_TypePool = " ।|।३ᮢ|३ᮢ|᫥३ᮢ|஭ ";

  fld_None     = "None";

  t_Car = 0;
  t_Man = 1;

  w_Pool = "⥫|ᠦ|室";
  w_Driver     = 0;
  w_Passenger  = 1;
  w_Pedestrian = 2;

  dm_Pool = "|()|()";
  dc_Pool = "||";
  d_NoInjuries  = 0;
  d_YesInjuries = 1;
  d_Death       = 2;

  i_pool = "ﭨ ﭥ  ⠭|⠭ ﭨ ﭥ";
  k_pool = "  |⮫|ப뢠|  饥 ࠭ᯮ⭮ ।⢮|  ९⢨|  室|  ᨯ|  㦥 ࠭ᯮ| ᠦ";

  p_pool = 0001000; (* RAccid.Place *)
  v_pool = 0001003; (* RAccid.Violat *)

  CntViolat = 5;

  tsnr_Staff     = 0;
  tsnr_Initiator = 1;

  tsnr_Pool = "⭨|樠";

 IMPORT L_XDoc, L_General, L_DatTim, L_Str, E_ODoc, P_Firm, Str, L_lsStore,
        P_Cntr, L_Pool, L_BarCode, L_EC, L_Prop, L_BegRWS, DBD, L_StdFrm,
        L_Man, L_Way, L_kn;

 PUBLIC PROCEDURE Decode_Violat(    curViolat: LIKE(RAccid.Violat);
                                VAR Violat   : STRING[][CntViolat]);
  VAR
   Idx: SCAL[CntViolat];
 BEGIN
  SETEMPTY(Violat);
  FOR_EACH Idx DO
   Violat[Idx]:=L_Prop.getRecordElement(curViolat, Idx);
  END;
 END {Decode_Violat};

 PUBLIC PROCEDURE Encode_Violat(VAR curViolat: LIKE(RAccid.Violat);
                                    Violat   : STRING[][CntViolat]);
  VAR
   Idx: SCAL[CntViolat];
 BEGIN
  SETEMPTY(curViolat);
  FOR_EACH Idx DO
   IF ~!Violat[Idx] THEN
    L_Prop.putRecordElement(curViolat, Violat[Idx]);
   END;
  END;
 END {Encode_Violat};

 PUBLIC PROCEDURE ram_StandOnDriver(): SCAL[2];
  CONST
   lnSex  = 3;
   lnName = 32;
   lnCrtD = 13;
  VAR
   CarName: LIKE(RAMemb.Name);
   Result : SCAL[2];
   DrvStr : STRING[];
 BEGIN
  Result :=0;
  SETEMPTY(DrvStr);
  CarName:=RAMemb.Name;
  SELECT(RAMemb, RAccid, , RAMemb.RAccid, t_Man, w_Driver);
  WHILE OCCURE(RAMemb) DO
   IF RAMemb.CarName = CarName THEN
    INC(DrvStr, Str.Align(L_Str.PoolItem(L_Man.GetManSexPool(), RAMemb.Sex), lnSex,  LEFT) + "" +
                Str.Align(RAMemb.Name,                                       lnName, LEFT) + "" +
                Str.Align(L_DatTim.DateStr(RAMemb.CrtD),                     lnCrtD, LEFT) + "|");
    L_General.Assert(~Result, "  ⥫   '" + CarName + "':||" +
                              Str.Align("",           lnSex,  LEFT) + "" +
                              Str.Align("",           lnName, LEFT) + "" +
                              Str.Align(" ஦", lnCrtD, LEFT) + "|" +
                              L_Str.Repeat("", lnSex)  + "" +
                              L_Str.Repeat("", lnName) + "" +
                              L_Str.Repeat("", lnCrtD) + "|" +
                              DrvStr);
    Result:=1;
    SAVE(RAMemb);
   END;
   NEXT(RAMemb);
  END; (* WHILE OCCURE(RAMemb) ... *)
  IF Result THEN
   RESTORE(RAMemb);
  END;
  RETURN Result;
 END {ram_StandOnDriver};

 PUBLIC PROCEDURE StandOnRWayJByCurRAccid(Soft: SCAL[2]);
  TYPE
   tSearchType = SCAL[2];
  CONST
   st_Prev = 0;
   st_Next = 1;
  VAR
   RAFullTime     : NUMERIC[3];
   SearchType     : tSearchType;
 BEGIN
  L_General.CallUs(OCCURE(ODoc));
  L_General.CallUs(SEARCH(RAccid, XDocId, ODoc.XDocId));
  L_General.CallUs(SEARCH(RWayS,  RWayS,  RAccid.RWayS));
  L_General.Assert(ODoc.Date >= RWayS.Date, "    砫 ");
  L_General.Assert((ODoc.Date - RWayS.Date + 1) <= MAXOF(RWayJ.Day), "  - " + L_DatTim.DateStr(ODoc.Date) + ",  砫  - " +  L_DatTim.DateStr(RWayS.Date));
  RAFullTime:=L_Way.FullBegTime(ODoc.Date - RWayS.Date + 1, RAccid.Time);
  SearchType:=st_Prev;
  LOOP
   SELECT(RWayJ, RWayS, , RWayS.RWayS);
   IF SearchType = st_Prev THEN
    LAST(RWayJ);
    WHILE OCCURE(RWayJ) & (L_Way.FullBegTime(RWayJ.Day, RWayJ.StartT) > RAFullTime) DO
     PREV(RWayJ);
    END;
   ELSE
    WHILE OCCURE(RWayJ) & (L_Way.FullEndTime(RWayJ.Day, RWayJ.StartT, RWayJ.StopT) < RAFullTime) DO
     NEXT(RWayJ);
    END;
   END;
   WHILE OCCURE(RWayJ) DO
    CONFORM(RWayJ, Quality);
    CONFORM(RWayJ, SEJobs, WJMode);
    IF (Quality.Type # L_Way.QualType_Annul) & (WJMode.WJCode = "10") THEN
     RETURN;
    END;
    IF SearchType = st_Prev THEN
     PREV(RWayJ);
    ELSE
     NEXT(RWayJ);
    END;
   END; (* WHILE OCCURE(RWayJ) ... *)
   IF SearchType = st_Next THEN
    L_StdFrm.ConditionalCHOICE(" ६    ३", Soft);
    EXIT;
   END;
   SearchType:=st_Next;
  END; (* LOOP *)
 END {StandOnRWayJByCurRAccid};

 PUBLIC PROCEDURE AccessODoc();
 BEGIN
  L_General.Assert(ACCESS(ODoc), " ⠭ 稩 㬥");
 END {AccessODoc};

 PUBLIC PROCEDURE curRefToXDoc_GetId(): L_XDoc.tXDocId;
 BEGIN
  RETURN L_XDoc.GetSingleRefToXDocId(L_XDoc.curXDocId(L_XDoc.xdt_ODoc));
 END {curRefToXDoc_GetId};

 PUBLIC PROCEDURE curRefToXDoc_PositionOn(reqXDT: L_XDoc.tXDocType);
  VAR
   reqToXDocId: L_XDoc.tXDocId;
 BEGIN
  reqToXDocId:=curRefToXDoc_GetId();
  L_General.CallUs(L_XDoc.ExtractXDocType(reqToXDocId) = reqXDT);
  L_XDoc.PositionOnXDoc(reqToXDocId);
 END {curRefToXDoc_PositionOn};

 PUBLIC PROCEDURE StatusPool(Short: SCAL[2]): STRING[];
 BEGIN
  IF Short THEN
   RETURN "||";
  ELSE
   RETURN "⮢|஢|㫨஢";
  END;
 END {StatusPool};

 PUBLIC PROCEDURE amo_Time(): TIME;
 BEGIN
  RETURN STRTOFLD(L_Prop.getRecordElement(ODoc.Descript, 0), TIME);
 END {amo_Time};

 PUBLIC PROCEDURE amo_Temperature(): NUMERIC[4,1];
 BEGIN
  RETURN STRTOFLD(L_Prop.getRecordElement(ODoc.Descript, 5), NUMERIC);
 END {amo_Temperature};

 PUBLIC PROCEDURE amo_Pulse(): NUMERIC[4,0];
 BEGIN
  RETURN STRTOFLD(L_Prop.getRecordElement(ODoc.Descript, 6), NUMERIC);
 END {amo_Pulse};

 PUBLIC PROCEDURE amo_AD(VAR trgPressureHigh, trgPressureLow  : NUMERIC[4,0]);
 BEGIN
  trgPressureHigh:=STRTOFLD(L_Prop.getRecordElement(ODoc.Descript, 7), NUMERIC);
  trgPressureLow :=STRTOFLD(L_Prop.getRecordElement(ODoc.Descript, 8), NUMERIC);
 END {amo_AD};

 PUBLIC PROCEDURE amo_AlcoholTestResult(): SCAL[2];
 BEGIN
  RETURN STRTOFLD(L_Prop.getRecordElement(ODoc.Descript, 3), SCAL);
 END {amo_AlcoholTestResult};

 PUBLIC PROCEDURE amo_Complaints(): STRING[];
 BEGIN
  RETURN  L_Prop.getRecordElement(ODoc.Descript, 4);
 END {amo_Complaints};

 PUBLIC PROCEDURE amo_Kind(): SCAL[4];
 BEGIN
  RETURN L_Str.PositionInPool(amo_KindPool, L_Prop.getRecordElement(ODoc.Descript, 1));
 END {amo_Kind};

 PUBLIC PROCEDURE amo_DecodeDescription(VAR _Time              : TIME;
                                        VAR _Kind,
                                            _Descript          : STRING[];
                                        VAR _AlcoholTestResult : SCAL[2];
                                        VAR _ATR1              : NUMERIC[2];
                                        VAR _ATR2              : SCAL[2];
                                        VAR _ATR3              : NUMERIC[2];
                                        VAR _Complaints        : STRING[];
                                        VAR _Temperature       : NUMERIC[4,1];
                                        VAR _Pulse,
                                            _PressureHigh,
                                            _PressureLow       : NUMERIC[4,0]);
 BEGIN
  TRY
   _Time             :=amo_Time();
   _Kind             :=L_Prop.getRecordElement(ODoc.Descript, 1);
   _Descript         :=L_Prop.getRecordElement(ODoc.Descript, 2);
   _AlcoholTestResult:=amo_AlcoholTestResult();
   _Complaints       :=amo_Complaints();
   _Temperature      :=amo_Temperature();
   _Pulse            :=amo_Pulse();
   _ATR1             :=STRTOFLD(L_Prop.getRecordElement(ODoc.Descript, 9), NUMERIC);
   _ATR2             :=STRTOFLD(L_Prop.getRecordElement(ODoc.Descript, 10), SCAL);
   _ATR3             :=STRTOFLD(L_Prop.getRecordElement(ODoc.Descript, 11), NUMERIC);
   amo_AD(_PressureHigh, _PressureLow);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_FailedSTRTOFLD THEN
    _ATR1:=0;
    SETEMPTY(_Time, _Kind, _AlcoholTestResult, _Complaints, _Temperature, _Pulse,
             _PressureHigh, _PressureLow, _ATR2, _ATR3);
    _Descript:=ODoc.Descript;
   ELSE
    RAISE();
   END;
  END;
 END {amo_DecodeDescription};

 PUBLIC PROCEDURE E_GetSensePool(_ODocKind: LIKE(ODocKind.ODocKind)): STRING[];
  VAR
   Local : PROC;
   Result: STRING[];
 BEGIN
  SEARCH(ODocKind, ODocKind, , _ODocKind);
  IF    L_kn.Is(SYSDATE(), erkn_ContractAddIns) THEN
   Result:=L_Pool.Get(pool_ContractAdInsSense);
  ELSIF L_kn.Is(SYSDATE(), erkn_ContractMessage) THEN
   Result:=L_Pool.Get(pool_ContractMessageSense);
  ELSIF L_kn.Is(SYSDATE(), erkn_FirmMessage) THEN
   Result:=fms_Pool;
  ELSE
   SETEMPTY(Result);
   Local:=PROCREF(E_ODoc.GetSensePool);
   IF ~!Local THEN
    Result:=Local(_ODocKind, Result);
   END;
  END;
  RETURN Result;
 END {E_GetSensePool};

 PRIVATE PROCEDURE DecodeODocId(    trgODocId  : STRING[];
                                VAR trgODocKind: LIKE(ODocKind.ODocKind);
                                VAR trgODoc    : LIKE(ODoc.ODoc));
  VAR
   trgXDocType: L_XDoc.tXDocType;
 BEGIN
  L_XDoc.DecodeXDocId(trgODocId, trgXDocType, trgODocKind, trgODoc);
  L_General.CallUs(trgXDocType = L_XDoc.xdt_ODoc);
 END {DecodeODocId};

 PUBLIC PROCEDURE amo_Type(): tAMOType;
  VAR
   reqToXDocId: L_XDoc.tXDocId;
   D          : DATE;
   T          : TIME;
 BEGIN
  IF ODoc.Status # ods_Passed THEN
   RETURN amot_Undefined;
  END;
  T          :=amo_Time();
  D          :=ODoc.SrcDate;
  reqToXDocId:=curRefToXDoc_GetId();
  IF ~!reqToXDocId & (L_XDoc.ExtractXDocType(reqToXDocId) = L_XDoc.xdt_RWayS) THEN
   L_XDoc.PositionOnXDoc(reqToXDocId);
   SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
   IF L_BegRWS.E_UsingBarCodeScannerLevel(L_BegRWS.ubcr_Outpost) &
      L_BegRWS.E_UsingBarCodeScannerLevel(L_BegRWS.ubcr_Mechanic) THEN
    IF SRCINSEL(XDocJrn, GE, D, T) THEN
     LOOP
      IF (XDocJrn.Date > D) | (XDocJrn.BegTime > T) |
         (XDocJrn.Action = L_XDoc.action_MedicalExamination) |
         (XDocJrn.Action = L_XDoc.action_NotAllowedByMedic) THEN
       PREV(XDocJrn);
       EXIT;
      END;
      IF ~NEXT(XDocJrn) THEN
       LAST(XDocJrn);
       EXIT;
      END;
     END;
    ELSE
     LAST(XDocJrn);
    END;
    WHILE OCCURE(XDocJrn) DO
     IF    (XDocJrn.Action = L_XDoc.action_AcceptCarReturn) THEN
      RETURN amot_Final;
     ELSIF (XDocJrn.Action = L_XDoc.action_CarDeparture)    THEN
      RETURN amot_InterJob;
     END;
     PREV(XDocJrn);
    END;
    RETURN amot_First;
   ELSE
    WHILE OCCURE(XDocJrn) & ((XDocJrn.Date < D) | (XDocJrn.Date = D) & (XDocJrn.BegTime < T)) DO
     IF (XDocJrn.Action = L_XDoc.action_MedicalExamination) |
        (XDocJrn.Action = L_XDoc.action_NotAllowedByMedic) THEN
      RETURN amot_Final;
     END;
     NEXT(XDocJrn);
    END;
    RETURN amot_First;
   END;
  ELSIF ~!reqToXDocId & (L_XDoc.ExtractXDocType(reqToXDocId) = L_XDoc.xdt_Man) THEN
   RETURN amot_ForeignMan;
  END;
  RETURN amot_Undefined;
 END {amo_Type};

 PUBLIC PROCEDURE E_DefaultODocSrcNbr(D: DATE): STRING[];
  VAR
   Local : PROC;
   Result: STRING[];
 BEGIN
  Result:="";
  IF ODoc.MyFirm # P_Firm.mf_Fict THEN
   IF    ODocKind.sn_Kind = odsnk_Manual THEN
    (*祣  *)
   ELSIF ODocKind.sn_Kind = odsnk_Through THEN
    Result:=ODoc.ODoc;
   ELSIF ODocKind.sn_Kind = odsnk_MyFirmThrough THEN
    Result:=ODoc.mfNbr;
   ELSIF ODocKind.sn_Kind = odsnk_Special THEN
    Local:=PROCREF(E_ODoc.DefaultODocSrcNbr);
    L_General.Assert(~!Local, "ࠢ 室 㬥樨  㬥⮢  ᠭ");
    Result:=Local(D, Result);
   ELSE
    L_General.CallUs(0);
   END;
  END;
  RETURN Result;
 END {E_DefaultODocSrcNbr};

 PUBLIC PROCEDURE E_BCScannerLevel(D: DATE): L_BarCode.tBCScannerLevel;
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_ODoc.BCScannerLevel), L_BarCode.bcsl_None);
 END {E_BCScannerLevel};

 PRIVATE PROCEDURE Field(FileName, Fld: STRING[]): STRING[];
 BEGIN
  RETURN (FileName + "." + Fld);
 END {Field};

 PRIVATE PROCEDURE FieldExist(trgXDocType: L_XDoc.tXDocType;
                              trgField   : STRING[]): SCAL[2];
 BEGIN
  RETURN DBD.FieldExist(^(L_XDoc.Ref_FileName(trgXDocType)), ^(trgField));
 END {FieldExist};

 PUBLIC PROCEDURE GetXDocField(trgXDocType: L_XDoc.tXDocType;
                               trgField   : STRING[]): STRING[];
  VAR
   Type  : NUMERIC[0];
   FieldName,
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF FieldExist(trgXDocType, trgField) THEN
   FieldName:=Field(L_XDoc.Ref_FileName(trgXDocType), trgField);
   IF ~!(^FieldName) THEN
    Type:=TYPEOF(^FieldName);
    IF    (Type = L_General.ft_STRING) | (Type = L_General.ft_SCAL) THEN
     Result:=^FieldName;
    ELSIF Type = L_General.ft_DATE THEN
     Result:=L_DatTim.DateStr(^FieldName);
    ELSE
     L_General.CallUs(0)
    END;
   END;
  END;
  RETURN Result;
 END {GetXDocField};

 PUBLIC PROCEDURE GetXDocSign(trgXDocId: L_XDoc.tXDocId): STRING[];
  VAR
   trgXDocType: L_XDoc.tXDocType;
 BEGIN
  trgXDocType:=L_XDoc.ExtractXDocType(trgXDocId);
  IF L_XDoc.Ref_KindName(trgXDocType) = fld_None THEN
   RETURN L_XDoc.Ref_ShortName(trgXDocType);
  ELSE
   RETURN GetXDocField(trgXDocType, "Sign");
  END;
 END {GetXDocSign};

 PUBLIC PROCEDURE GetXDocSrcNbr(trgXDocId: L_XDoc.tXDocId): STRING[];
  VAR
   trgXDocType: L_XDoc.tXDocType;
   trgXDocKind: L_XDoc.tXDocKind;
   trgXDoc    : L_XDoc.tXDoc;
   Result     : STRING[];
 BEGIN
  L_XDoc.DecodeXDocId(trgXDocId, trgXDocType, trgXDocKind, trgXDoc);
  Result:=GetXDocField(trgXDocType, "SrcNbr");
  IF !Result THEN
   Result:=trgXDoc;
  END;
  RETURN Result;
 END {GetXDocSrcNbr};

 PRIVATE PROCEDURE GetAnyXDocDate(trgXDocId: L_XDoc.tXDocId; Field: STRING[]): DATE;
 BEGIN
  RETURN STRTOFLD(GetXDocField(L_XDoc.ExtractXDocType(trgXDocId), Field), DATE);
 END {GetAnyXDocDate};

 PUBLIC PROCEDURE GetXDocDate(trgXDocId: L_XDoc.tXDocId): DATE;
 BEGIN
  IF FieldExist(L_XDoc.ExtractXDocType(trgXDocId), "Date") THEN
   RETURN GetAnyXDocDate(trgXDocId, "Date");
  ELSE
   RETURN L_General.EMPTY_DATE();
  END;
 END {GetXDocDate};

 PUBLIC PROCEDURE GetXDocSrcDate(trgXDocId: L_XDoc.tXDocId): DATE;
  VAR
   trgXDocType: L_XDoc.tXDocType;
 BEGIN
  trgXDocType:=L_XDoc.ExtractXDocType(trgXDocId);
  IF    trgXDocType = L_XDoc.xdt_PDoc THEN
   RETURN GetAnyXDocDate(trgXDocId, "PrpDate");
  ELSIF FieldExist(trgXDocType, "SrcDate") THEN
   RETURN GetAnyXDocDate(trgXDocId, "SrcDate");
  ELSE
   RETURN GetXDocDate(trgXDocId);
  END;
 END {GetXDocSrcDate};

 PUBLIC PROCEDURE GetCurODocSpcName(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:="";
  IF ACCESS(ODoc) & ~!ODoc.ODSpcNam THEN
   SAVE(ODSpcNam);
   CONFORM(ODoc, ODSpcNam);
   Result:=ODSpcNam.RegName;
   RESTORE(ODSpcNam);
  END;
  RETURN Result;
 END {GetCurODocSpcName};

 PRIVATE PROCEDURE intGetXDocKindName(trgXDocId: L_XDoc.tXDocId; wKind: SCAL[2]): STRING[];
  VAR
   trgXDocType: L_XDoc.tXDocType;
   Result     : STRING[];
 BEGIN
  trgXDocType:=L_XDoc.ExtractXDocType(trgXDocId);
  IF    trgXDocType = L_XDoc.xdt_ODoc THEN
   L_XDoc.PositionOnXDoc(trgXDocId);
   CONFORM(ODoc, ODocKind);
   Result:=GetCurODocSpcName();
   IF !Result THEN
    Result:=L_Str.PoolItem(E_GetSensePool(ODocKind.ODocKind), ODoc.Sense);
    IF !Result & wKind THEN
     Result:=ODocKind.SName;
    END;
   END;
  ELSIF L_XDoc.XDocTypeHasXDocKind(trgXDocType) THEN
   Result:=L_XDoc.GetDocKindDescription(trgXDocType, L_XDoc.xdast_External);
  ELSE
   Result:=L_XDoc.Ref_FullName(trgXDocType);
  END;
  RETURN Result;
 END {intGetXDocKindName};

 PUBLIC PROCEDURE GetXDocKindName(trgXDocId: L_XDoc.tXDocId): STRING[];
 BEGIN
  RETURN intGetXDocKindName(trgXDocId, 1);
 END {GetXDocKindName};

 PUBLIC PROCEDURE GetXDocDescription(trgXDocId: L_XDoc.tXDocId; wKind: SCAL[2]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=intGetXDocKindName(trgXDocId, wKind);
  IF L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_ODoc THEN
   IF ~!Result THEN
    INC(Result, " ");
   END;
   INC(Result, ODoc.Descript);
  END;
  RETURN Result;
 END {GetXDocDescription};

 PUBLIC PROCEDURE GetXDocName_Short(trgXDocId: L_XDoc.tXDocId): STRING[];
  VAR
   trgXDocType: L_XDoc.tXDocType;
   trgXDocKind: L_XDoc.tXDocKind;
   trgXDoc    : L_XDoc.tXDoc;
 BEGIN
  L_XDoc.DecodeXDocId(trgXDocId, trgXDocType, trgXDocKind, trgXDoc);
  RETURN Str.Condense(L_XDoc.Ref_ShortName(trgXDocType)) + "/" + trgXDocKind + "/" + FLDTOSTR(trgXDoc, "", 7);
 END {GetXDocName_Short};

 PUBLIC PROCEDURE GetXDocName(trgXDocId: L_XDoc.tXDocId): STRING[];
 BEGIN
  RETURN Str.Condense(GetXDocDescription(trgXDocId, 1) + "  " + GetXDocSrcNbr(trgXDocId) + "  " + L_DatTim.DateStr(GetXDocSrcDate(trgXDocId)));
 END {GetXDocName};

 PUBLIC PROCEDURE GetXDocName_Full(trgXDocId: L_XDoc.tXDocId): STRING[];
 BEGIN
  RETURN GetXDocName(trgXDocId) + " " + "(" + GetXDocName_Short(trgXDocId) + ")";
 END {GetXDocName_Full};

 PUBLIC PROCEDURE E_ODocCopiesCount(): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=1;
  IF L_General.IsPolakSpecific() THEN
   IF ODoc.ODocKind = 83 THEN
    IF (ODoc.Sense = fms_PaymentReviseAct) | (ODoc.Sense = fms_PaymentReviseAct_InPer) THEN
     Result:=2;
    END;
   END;
  END;
  RETURN Result;
 END {E_ODocCopiesCount};

END.
