(*
%Copyright   (c) Polak Computer System
%Author      06.12.1993 19:18:15 SAN
%Purpose     ⥪ ࠡ  䠩 OwnData
%Type        library
%Specific    SYS
%Modified    17.12.2013 22:11:12 POLAK\MLB
%Environment
*)

 MODULE L_OwnData [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, P_Firm, Str, L_EC, L_Env, L_ctc;

 PUBLIC PERMANENT VAR
  CurBrnch: STRING[];

 PRIVATE PROCEDURE OwnFirmPro(Proc: STRING[]; _Date: DATE): STRING[];
  VAR
   _Value: STRING[];
 BEGIN
  SAVE(Firm);
  _Value:=^Proc(P_Firm.OWN_FIRM, _Date);
  RESTORE(Firm);
  RETURN _Value;
 END {OwnFirmPro};

 PUBLIC PROCEDURE ODFirmName(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_FirmName", _Date);
 END;

 PUBLIC PROCEDURE ODFirmShortName(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_FirmShortName", _Date);
 END;

 PUBLIC PROCEDURE ODFirmAddr(_Date: DATE): STRING[];
 BEGIN
  RETURN L_ctc.GetAdr_Fct(_Date, P_Firm.OWN_FIRM);
 END;

 PUBLIC PROCEDURE ODAcntPhone(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_AcntPhone", _Date);
 END;

 PUBLIC PROCEDURE ODStaffDepPhone(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_StaffDepPhone", _Date);
 END;

 PUBLIC PROCEDURE ODLeadName(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_LeadName", _Date);
 END;

 PUBLIC PROCEDURE ODLeadPostName(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_LeadPostName1", _Date);
 END;

 PUBLIC PROCEDURE ODAcntName(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_AcntName", _Date);
 END;

 PUBLIC PROCEDURE ODTaxCardResp(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_TaxCardResp", _Date);
 END {ODTaxCardResp};

 PUBLIC PROCEDURE ODTaxCardCont(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_TaxCardCont", _Date);
 END {ODTaxCardCont};

 PUBLIC PROCEDURE ODTaxDep(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_TaxDep", _Date);
 END;

 PUBLIC PROCEDURE ODTaxDepCode(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_TaxDepCode", _Date);
 END {ODTaxDepCode};

 PUBLIC PROCEDURE ODINN(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_INN", _Date);
 END {ODINN};

 PUBLIC PROCEDURE ODOKPO(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_OKPO", _Date);
 END {ODOKPO};

 PUBLIC PROCEDURE ODBankReq(_Date: DATE): STRING[];
 BEGIN
  RETURN OwnFirmPro("P_Firm.FP_BankReq", _Date);
 END {ODBankReq};

 PUBLIC PROCEDURE ODMinimum(_Date: DATE): NUMERIC[2];
 BEGIN
  IF    _Date >= 01\01\2001 THEN  RETURN 100.00;
  ELSIF _Date >= 01\01\1998 THEN  RETURN  83.49;
  ELSIF _Date >= 01\01\1997 THEN  RETURN  83490;
  ELSIF _Date >= 01\04\1996 THEN  RETURN  75900;
  ELSIF _Date >= 01\01\1996 THEN  RETURN  63250;
  ELSIF _Date >= 01\12\1995 THEN  RETURN  60500;
  ELSIF _Date >= 01\11\1995 THEN  RETURN  57750;
  ELSIF _Date >= 01\08\1995 THEN  RETURN  55000;
  ELSIF _Date >= 01\05\1995 THEN  RETURN  43700;
  ELSIF _Date >= 01\04\1995 THEN  RETURN  34400;
  ELSIF _Date >= 01\07\1994 THEN  RETURN  20500;
  ELSIF _Date >= 01\12\1993 THEN  RETURN  14620;
  ELSIF _Date >= 01\07\1993 THEN  RETURN   7740;
  ELSIF _Date >= 01\04\1993 THEN  RETURN   4275;
  ELSIF _Date >= 01\01\1993 THEN  RETURN   2250;
  END;
 END {ODMinimum};

 PUBLIC PROCEDURE ODMROT(_Date: DATE): NUMERIC[2];
 BEGIN
  IF    _Date >= 01\01\2014 THEN  RETURN 5554.00;
  ELSIF _Date >= 01\01\2013 THEN  RETURN 5205.00;
  ELSIF _Date >= 01\06\2011 THEN  RETURN 4611.00;
  ELSIF _Date >= 01\01\2009 THEN  RETURN 4330.00;
  ELSIF _Date >= 01\09\2007 THEN  RETURN 2300.00;
  ELSIF _Date >= 01\05\2006 THEN  RETURN 1100.00;
  ELSIF _Date >= 01\09\2005 THEN  RETURN  800.00;
  ELSIF _Date >= 01\01\2005 THEN  RETURN  720.00;
  ELSIF _Date >= 01\10\2003 THEN  RETURN  600.00;
  ELSIF _Date >= 01\05\2002 THEN  RETURN  450.00;
  ELSIF _Date >= 01\07\2001 THEN  RETURN  300.00;
  ELSIF _Date >= 01\01\2001 THEN  RETURN  200.00;
  ELSIF _Date >= 01\07\2000 THEN  RETURN  132.00;
  ELSIF _Date >= 01\01\1998 THEN  RETURN   83.49;
  ELSIF _Date >= 01\01\1997 THEN  RETURN   83490;
  ELSIF _Date >= 01\04\1996 THEN  RETURN   75900;
  ELSIF _Date >= 01\01\1996 THEN  RETURN   63250;
  ELSIF _Date >= 01\12\1995 THEN  RETURN   60500;
  ELSIF _Date >= 01\11\1995 THEN  RETURN   57750;
  ELSIF _Date >= 01\08\1995 THEN  RETURN   55000;
  ELSIF _Date >= 01\05\1995 THEN  RETURN   43700;
  ELSIF _Date >= 01\04\1995 THEN  RETURN   34400;
  ELSIF _Date >= 01\07\1994 THEN  RETURN   20500;
  ELSIF _Date >= 01\12\1993 THEN  RETURN   14620;
  ELSIF _Date >= 01\07\1993 THEN  RETURN    7740;
  ELSIF _Date >= 01\04\1993 THEN  RETURN    4275;
  ELSIF _Date >= 01\01\1993 THEN  RETURN    2250;
  END;
 END {ODMROT};

 PUBLIC PROCEDURE RefinancingRate(_Date: DATE): NUMERIC[2];
 BEGIN
  IF    _Date >= 14\09\2012 THEN RETURN  08.25;
  ELSIF _Date >= 26\12\2011 THEN RETURN  08.00;
  ELSIF _Date >= 03\05\2011 THEN RETURN  08.25;
  ELSIF _Date >= 28\02\2011 THEN RETURN  08.00;
  ELSIF _Date >= 01\06\2010 THEN RETURN  07.75;
  ELSIF _Date >= 30\04\2010 THEN RETURN  08.00;
  ELSIF _Date >= 29\03\2010 THEN RETURN  08.25;
  ELSIF _Date >= 24\02\2010 THEN RETURN  08.50;
  ELSIF _Date >= 28\12\2009 THEN RETURN  08.75;
  ELSIF _Date >= 25\11\2009 THEN RETURN  09.00;
  ELSIF _Date >= 30\10\2009 THEN RETURN  09.50;
  ELSIF _Date >= 30\09\2009 THEN RETURN  10.00;
  ELSIF _Date >= 15\09\2009 THEN RETURN  10.50;
  ELSIF _Date >= 10\08\2009 THEN RETURN  10.75;
  ELSIF _Date >= 13\07\2009 THEN RETURN  11.00;
  ELSIF _Date >= 05\06\2009 THEN RETURN  11.50;
  ELSIF _Date >= 14\05\2009 THEN RETURN  12.00;
  ELSIF _Date >= 24\04\2009 THEN RETURN  12.50;
  ELSIF _Date >= 01\12\2008 THEN RETURN  13.00;
  ELSIF _Date >= 12\11\2008 THEN RETURN  12.00;
  ELSIF _Date >= 14\07\2008 THEN RETURN  11.00;
  ELSIF _Date >= 10\06\2008 THEN RETURN  10.75;
  ELSIF _Date >= 29\04\2008 THEN RETURN  10.50;
  ELSIF _Date >= 04\02\2008 THEN RETURN  10.25;
  ELSIF _Date >= 19\06\2007 THEN RETURN  10.0;
  ELSIF _Date >= 29\01\2007 THEN RETURN  10.5;
  ELSIF _Date >= 23\10\2006 THEN RETURN  11.0;
  ELSIF _Date >= 26\06\2006 THEN RETURN  11.5;
  ELSIF _Date >= 26\12\2005 THEN RETURN  12.0;
  ELSIF _Date >= 15\06\2004 THEN RETURN  13.0;
  ELSIF _Date >= 15\01\2004 THEN RETURN  14.0;
  ELSIF _Date >= 21\06\2003 THEN RETURN  16.0;
  ELSIF _Date >= 17\02\2003 THEN RETURN  18.0;
  ELSIF _Date >= 07\08\2002 THEN RETURN  21.0;
  ELSIF _Date >= 09\04\2002 THEN RETURN  23.0;
  ELSIF _Date >= 04\11\2000 THEN RETURN  25.0;
  ELSIF _Date >= 10\07\2000 THEN RETURN  28.0;
  ELSIF _Date >= 21\03\2000 THEN RETURN  33.0;
  ELSIF _Date >= 07\04\2000 THEN RETURN  38.0;
  ELSIF _Date >= 24\01\2000 THEN RETURN  45.0;
  ELSIF _Date >= 10\06\1999 THEN RETURN  55.0;
  ELSIF _Date >= 24\07\1998 THEN RETURN  60.0;
  ELSIF _Date >= 29\06\1998 THEN RETURN  80.0;
  ELSIF _Date >= 05\06\1998 THEN RETURN  60.0;
  ELSIF _Date >= 27\05\1998 THEN RETURN 150.0;
  ELSIF _Date >= 19\05\1998 THEN RETURN  50.0;
  ELSIF _Date >= 16\03\1998 THEN RETURN  30.0;
  ELSIF _Date >= 02\03\1998 THEN RETURN  36.0;
  ELSIF _Date >= 17\02\1998 THEN RETURN  39.0;
  ELSIF _Date >= 02\02\1998 THEN RETURN  42.0;
  ELSIF _Date >= 11\11\1997 THEN RETURN  28.0;
  ELSIF _Date >= 06\10\1997 THEN RETURN  21.0;
  ELSIF _Date >= 16\06\1997 THEN RETURN  24.0;
  ELSIF _Date >= 28\04\1997 THEN RETURN  36.0;
  ELSIF _Date >= 10\02\1997 THEN RETURN  42.0;
  ELSIF _Date >= 02\12\1996 THEN RETURN  48.0;
  ELSIF _Date >= 21\10\1996 THEN RETURN  60.0;
  ELSIF _Date >= 19\08\1996 THEN RETURN  80.0;
  ELSIF _Date >= 24\07\1996 THEN RETURN 110.0;
  ELSIF _Date >= 10\02\1996 THEN RETURN 120.0;
  ELSIF _Date >= 01\12\1995 THEN RETURN 160.0;
  ELSIF _Date >= 24\10\1995 THEN RETURN 170.0;
  ELSIF _Date >= 19\06\1995 THEN RETURN 180.0;
  ELSIF _Date >= 16\05\1995 THEN RETURN 195.0;
  ELSIF _Date >= 06\01\1995 THEN RETURN 200.0;
  ELSIF _Date >= 17\11\1994 THEN RETURN 180.0;
  ELSIF _Date >= 12\10\1994 THEN RETURN 170.0;
  ELSIF _Date >= 23\08\1994 THEN RETURN 130.0;
  ELSIF _Date >= 01\08\1994 THEN RETURN 150.0;
  ELSIF _Date >= 30\06\1994 THEN RETURN 155.0;
  ELSIF _Date >= 22\06\1994 THEN RETURN 170.0;
  ELSIF _Date >= 02\06\1994 THEN RETURN 185.0;
  ELSIF _Date >= 17\05\1994 THEN RETURN 200.0;
  ELSIF _Date >= 29\04\1994 THEN RETURN 205.0;
  ELSIF _Date >= 15\10\1993 THEN RETURN 210.0;
  ELSIF _Date >= 23\09\1993 THEN RETURN 180.0;
  ELSIF _Date >= 15\07\1993 THEN RETURN 170.0;
  ELSIF _Date >= 29\06\1993 THEN RETURN 140.0;
  ELSIF _Date >= 22\06\1993 THEN RETURN 120.0;
  ELSIF _Date >= 02\06\1993 THEN RETURN 110.0;
  ELSIF _Date >= 30\03\1993 THEN RETURN 100.0;
  ELSIF _Date >= 23\05\1992 THEN RETURN  80.0;
  ELSIF _Date >= 10\04\1992 THEN RETURN  50.0;
  ELSIF _Date >= 01\01\1992 THEN RETURN  20.0;
  END;
 END {RefinancingRate};

 PUBLIC PROCEDURE ODPayBabyMind15(_Date: DATE): NUMERIC[2];
 BEGIN
  IF    _Date >= 01\01\2006 THEN  RETURN 700.00;
  ELSIF _Date >= 01\01\2002 THEN  RETURN 500.00;
  ELSE                            RETURN ODMinimum(_Date)*2;
  END;
 END {ODPayBabyMind15};

 PUBLIC PROCEDURE ODBranchName(_Date: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(_Date, PROCREF(L_Env.BranchName), "");
 END {ODBranchName};

 PUBLIC PROCEDURE E_BranchesAmount(D: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(L_Env.BranchesAmount), 0);
 END {E_BranchesAmount};

 PUBLIC PROCEDURE BranchNumber(D: DATE; Name: STRING[]): SCAL[100];
  VAR
   i: SCAL[1000];
   S: STRING[];
 BEGIN
  IF E_BranchesAmount(D) > 0 THEN
   i:=0;
   LOOP
    S:=Str.Item(L_Env.BranchesNamesPool(), "|", i);
    L_General.Assert(~!S, "⭮  䨫: " + Name);
    IF S = Name THEN
     RETURN i;
    END;
    INC(i);
   END;
  ELSE
   RETURN 0;
  END;
 END {BranchNumber};

 PUBLIC PROCEDURE branchName_Consolidating(): STRING[];
 BEGIN
  RETURN "᮫";
 END {branchName_Consolidating};

 PUBLIC PROCEDURE branchName_OwnBranch(D: DATE): STRING[];
 BEGIN
  RETURN ODBranchName(D);
 END {branchName_OwnBranch};

 PUBLIC PROCEDURE OwnBranchNumber(D: DATE): SCAL[100];
 BEGIN
  IF E_BranchesAmount(D) > 0 THEN
   RETURN BranchNumber(D, branchName_OwnBranch(D));
  ELSE
   RETURN 0;
  END;
 END {OwnBranchNumber};

END.
