(*
%Copyright   (c) Polak IT
%Author      02.09.2003 20:05:42 POLAK\Bor
%Purpose       ⠬ ᢥ     
%Type        library
%Specific    SYS
%Modified    19.09.2014 19:14:41 POLAK\Bor
%Environment
*)

 MODULE L_Packet [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tBuildMode   = SCAL[4];
  tPacketGroup = SCAL[100];
  tPFExtNbr    = SCAL[1e5];
  tMInsType    = STRING[40]; (* ManIns.E_SpecStageForPens() *)
  tCntrType    = SCAL[2];

 PUBLIC CONST
  dt_None     = 0;
  dt_Basic    = 1;
  dt_ForPens  = 2;
  dt_Pool = " ||";

  ct_None     = 0;
  ct_Corr     = 1;
  ct_Cancel   = 2;
  ct_Pool = " ||";

  fg_9998 = "99998";
  fg_9999 = "99999";

  cntrt_Basic  = 0;
  cntrt_CA     = 1;
  cntrt_Pool = "|-";

  st_Prepared   = 0;
  st_InProcess  = 1;
  st_Done       = 2;
  st_Rejected   = 3;
  st_Canceled   = 4;
  st_Pool       = "⮢| ࠡ||⢥࣭|㫨஢";
  st_ShortPool  = "||||";
  st_SamplePool = "⮢| | ନ஢| | ";

  VER_2_50    = "02.50";
  VER_3_00    = "03.00";
  VER_4_00    = "04.00";
  VER_7_00    = "07.00";
  OwnVER      = " ";

  rcv_PensFund = 0;
  rcv_TaxDep   = 1;
  rcv_e_TaxDep = 2;
  rcv_Pool = "||-";

  src_System   = 0;
  src_Operator = 1;

  knd_PF_ADV1     =  1;
  knd_PF_ADV2     =  2;
  knd_PF_ADV3     =  3;
  knd_PF_SZV1     =  4;
  knd_PF_SZV3     =  5;
  knd_PF_SZV4     =  6;
  knd_PF_SZV6     =  7;
  knd_PF_SZVK     =  8;
  knd_PF_ADV10    =  9;
  knd_PF_ADV11    = 10;
  knd_PF_ADV6_2   = 11;
  knd_PF_DSV1     = 12;
  knd_PF_DSV3     = 13;
  knd_PF_SPV1     = 14;
  knd_PF_SZV6_3   = 15;
  knd_PF_SZV6_4   = 16;
  knd_PF_RSV1_6   = 17;
  knd_PF_SPV2     = 18;

  knd_TD_IncTax   = 30;

  knd_ESN_AdvRep  = 50;
  knd_ESN_Decl    = 51;
  knd_VPS_AdvRep  = 52;
  knd_VPS_Decl    = 53;
  knd_TT_AdvRep   = 54;
  knd_TT_Decl     = 55;
  knd_FSS_Sheet   = 56;
  knd_CPT_AdvRep  = 57; (*Corporate property tax -   ⢮ ࣠権*)
  knd_CPT_Decl    = 58;
  knd_USNO_Decl   = 59;
  knd_RSV_1       = 60;
  knd_AvgCnt      = 61;
  knd_VAT         = 62;

  knd_Pool = " " +
             "|-1" +
             "|-2" +
             "|-3" +
             "|-1" +
             "|-3" +
             "|-4" +
             "|-6-1(2)" +
             "|-" +
             "|-10" +
             "|-11"+
             "|-6-2"+
             "|-1" +
             "|-3" +
             "|-1" +
             "|-6-3" +
             "|-6-4" +
             "|-1 .6"+
             "|-2"+
             "| | | | | | | | | | | "+
             "|" +
             "| | | | | | | | | | | | | | | | | | | " +
             "|ᮢ   " +
             "|  " +
             "|ᮢ   " +
             "|  " +
             "|ᮢ   " +
             "|  " +
             "|⭠  " +
             "|ᮢ   " +
             "|  " +
             "|  " +
             "|    " +
             "|।ᯨ筠 ᫥" +
             "|  ";

  part_Ank    = 0;
  part_Manins = 1;

  bm_bySingle = 0;
  bm_byPacket = 1;
  bm_byAll    = 2;
  bm_byStaff  = 3;

  SampleDTStamp = 0;

  path_PFR      = "REP\ANK";
  path_TaxDep   = "REP\T3";
  path_e_TaxDep = "REP\IMNS";

 PUBLIC TYPE
  tNeedCorr    = SCAL[3]; (* ManIns.E_ManIns_NeedMakeKORR() *)
 PUBLIC CONST
  minc_No       = 0; (* ManIns.E_ManIns_NeedMakeKORR *)
  minc_ForPens  = 1;
  minc_Basic    = 2;

 PUBLIC TYPE
  tMInsAddType = SCAL[2];   (* E_Staff.SpecStage2ForPens() *)
 PUBLIC CONST
  miat_Disability  = 0;
  miat_UnpaidLeave = 1;

  OrdinaryPnsAttr = 00;

  adr_OnlyReg  = 0; (*E_ManIns_NeedDwMA()*)
  adr_UseDwell = 1;
  adr_None     = 2;

  patt_GUID     = "GUID";
  patt_FileName = "";

 PUBLIC TYPE
  tFilesToProcess = SCAL[3];

 PUBLIC CONST
  fp_All = 0; (*ProcessPacketFiles*)
  fp_Prn = 1;
  fp_Trn = 2;

 PRIVATE TYPE
  tPart = SCAL[2];

 IMPORT L_General, L_DatTim, L_Russia, L_Str, L_EC, L_Man, L_Prop, L_StdFrm, L_XML, L_FIO, L_SES, L_WDO,
        L_XDoc, P_MyFirm, P_Man, P_Firm, P_Staff, Str, FIO, Math, Shell, DBD, E_PRoll, L_Env, L_ATER,
        L_Sheet, E_Staff;

 PUBLIC VAR
  OwnFirmFullName,
  OwnFirmName,
  OwnNumInPFR,
  OwnINN,
  OwnKPP,
  OwnOKPO,
  OwnOGRN,
  OwnOKOPFName,
  ActingLeadName,
  ActingLeadPostName,
  OwnAcntName,
  OwnLeadName,
  OwnLeadPostName : STRING[];
  PrepareDate,
  ActualDate: DATE;
  PckMyFirm : P_Firm.tMyFirm;
  DTStamp   : LIKE(Packet.DTStamp);
  BuildMode : tBuildMode;

 PRIVATE CONST
  patt_Sum = "Sum";

 PRIVATE VAR
  FirstFieldInLine: SCAL[2];

(*
$P{ ADV61_4_00_Top:
Packet.ExtNbr, R, "", "U"
1, R, "", "U"
OwnOKPO, L, "", "U"
OwnNumInPFR, L, "", "U"
OwnINN, L, "", "U"
OwnKPP, L, "", "U"
OwnFirmName, L, "", "U"
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, L, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
Packet.ExtNbr, L, "", "U"
?, L, ""
?, L, ""
?, L, " |X| "
?, L, " | |X"
?, L, " |X| "
?, L, " | |X"
?, R, "0"
?, R, "0"
?, L, ""
?, R, ""
?, R, ""
?, L, "", "U"
?, L, "", "U"
@
                                             N 窨 #####   N  窥 ###
ଠ -6-1     ________                  ############

             㬥⮢, । ࠡ⮤⥫  

 ࠡ⮤⥫, ।饣 㬥:
樮   ################################################
 ##########         #########
 ࣠樨  ################################################
(⪮)
ਬ砭: ______________________________________________________________
--------------------------------------------------------------------------
|                                                     |⢮ 㬥|
|            室饣 㬥          |⮢  -|
|                                                     |  窥   |
|-----------------------------------------------------|------------------|
| 客  (-1)                  |##################|
|-----------------------------------------------------|------------------|
|   客 ᢨ⥫⢠ (-2) |##################|
|-----------------------------------------------------|------------------|
|  뤠 㡫 客 ᢨ⥫⢠|##################|
|-----------------------------------------------------|------------------|
|  㤮 ⠦ 客      |                  |
|ਮ  ॣ樨  ⥬ 易⥫쭮        |                  |
|ᨮ 客 (-)                      |##################|
|-----------------------------------------------------|------------------|
| 室騥 㬥                              |                  |
|#####################################################|##################|
|------------------------------------------------------------------------|
|              㠫 ᢥ  2002                    |
|------------------------------------------------------------------------|
|㠫 ᢥ  㤮 ⠦, ࠡ⪥  |                  |
|(ࠦ), 室  ᫥    |                  |
|(-1  -3)                                    |##################|
|-----------------------------------------------------|------------------|
|   㬥⮢ -3, ।|                  |
|ࠡ⮤⥫   (-10)                         |##################|
|------------------------------------------------------------------------|
|          㠫 ᢥ, 稭  2002                |
|------------------------------------------------------------------------|
|                                              | ⢮ |   ᫮    |
|        室饣 㬥       | 㬥⮢ |客.|
|                                              |   窥   |  窥 |
|----------------------------------------------|------------|------------|
|㠫 ᢥ  客 ⠦    |            |            |
|᫥ 客   易⥫쭮 |            |            |
|ᨮ 客 客    |############|############|
--------------------------------------------------------------------------
  窨 㬥⮢, ᮯ஢ 設 ⥫
ଠ樨 (᪥⮩):
 窨 㬥⮢, ᢮ ࠡ⮤⥫ ######
 ॣ樨 窨  ਠ쭮 ࣠  __________ / ____

  窨 㬥⮢, ᮤঠ饩 "㠫 ᢥ 
客 ⠦  ᫥ 客   易⥫쭮 ᨮ
客 客 " (-4-1  -4-2):
-------------------------------------------------------------------------|
| ਮ   ####            |             ᢥ         |
| ⥣ਨ 客   ##|[#]室  [#]祭 ᨨ|
|--------------------------------------|---------------------------------|
| ⥫쭮             |           ४஢      |
|ਠ ᫮               |[#]४騥   [#]⬥騥|
|------------------------------------------------------------------------|
|  㬬 ᫥ .  (⮣  窥 㬥⮢)|
|------------------------------------------------------------------------|
|   客    |  ⥫  |   ⥫쭮   |
|    㤮 ᨨ    |     㤮 ᨨ    |                 |
|-----------------------|------------------------|-----------------------|
|#######################|########################|                       |
--------------------------------------------------------------------------
  窨 㬥⮢, ᮤঠ饩  "㠫
ᢥ" -1  -3:
--------------------------------------------------------------------------
| ਮ: #######################################################|
|------------------------------------------------------------------------|
|  ࠡ⪥ (ࠦ)  室   ਮ,      |
|뢠  祭 ᨨ (⮣  窥 㬥⮢)           |
|------------------------------------------------------------------------|
|                     ᥣ ᫥|    ⮬ ᫥ ᮡ  ६|
|                                    |     㤮ᯮᮡ  ⨯|
|------------------------------------|-----------------------------------|
|####################################|###################################|
--------------------------------------------------------------------------
ᯮ⥫                             ஢ 
#################################              ###########################
}
*)

(*
$P{ ADV61_4_00_Certify:
@

        ,  ᮤঠ  㬥⮢, 室  ,
               襯ਢ ᫠ , ୮.
}
*)

(*
$P{ ADV61_4_00_Bot:
ActingLeadPostName, L, "", "U"
L_Str.ShortName(ActingLeadName), L, "", "U"
L_DatTim.FullDateStr(PrepareDate), L, "", "U"
@

  㪮⥫     ஢ 
###################################            ###########################

 ##############################            ..}
*)

(*
$P{ ProjectPrt:
@
                       !!!    !!!

}
*)

 PUBLIC PROCEDURE FSS_SheetwXML(_ATER: LIKE(ATER.ATER)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(ATER);
  SEARCH(ATER, ATER, , _ATER);
  Result:=(ATER.Kind = knd_FSS_Sheet) & (ATER.Version # "0");
  RESTORE(ATER);
  RETURN Result;
 END {FSS_SheetwXML};

 PUBLIC PROCEDURE Kind_wMyPlace(D: DATE; trgKind: LIKE(Packet.Kind)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF (trgKind = knd_CPT_AdvRep) | (trgKind = knd_CPT_Decl) THEN
   IF D >= 01\09\2012 THEN
    Result:=1;
   END;
  END;
  RETURN Result;
 END {Kind_wMyPlace};

 PRIVATE PROCEDURE BuildAnyPacketFullName(_Receiver: LIKE(Packet.Receiver);
                                          Prefix   : STRING[1];
                                          _Packet  : LIKE(Packet.Packet);
                                          Ext      : STRING[]): STRING[];
  VAR
   Path: STRING[];
 BEGIN
  IF    _Receiver = rcv_PensFund THEN
   Path:=FIO.BuildPath(path_PFR,      , FIO.AsbSpecialFolders("ClientProjectRoot"));
  ELSIF _Receiver = rcv_e_TaxDep THEN
   Path:=FIO.BuildPath(path_e_TaxDep, , FIO.AsbSpecialFolders("ClientProjectRoot"));
  END;
  IF ~FIO.DirExists(Path) THEN
   FIO.MkDir(Path);
  END;
  RETURN FIO.BuildPath(Prefix + _Packet, Ext, Path);
 END {BuildAnyPacketFullName};

 PRIVATE PROCEDURE PacketRepFullName(): STRING[];
 BEGIN
  RETURN BuildAnyPacketFullName(rcv_PensFund, "R", Packet.Packet, "REP");
 END {PacketRepFullName};

 PUBLIC PROCEDURE PacketTrnFullName(_Receiver: LIKE(Packet.Receiver)): STRING[];
  VAR
   Extension: STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF ~!Packet.ATER THEN
   CONFORM(Packet, ATER);
  END;
  IF (_Receiver = rcv_PensFund) |
     FSS_SheetwXML(Packet.ATER) |
     (~!Packet.ATER & (~!ATER.xmlSchm | (Packet.ATER >= 0032))) THEN
   Extension:="XML";
  ELSE
   Extension:="TXT";
  END;
  RETURN BuildAnyPacketFullName(_Receiver, "T", Packet.Packet, Extension);
 END {PacketTrnFullName};

 PRIVATE PROCEDURE OldPfrPacketTrnFullName(): STRING[];
 BEGIN
  RETURN BuildAnyPacketFullName(rcv_PensFund, "T", Packet.Packet, "TXT");
 END {OldPfrPacketTrnFullName};

 PUBLIC PROCEDURE Packet999FullName(): STRING[];
 BEGIN
  RETURN BuildAnyPacketFullName(rcv_PensFund, "X", Packet.Packet, "REP");
 END {Packet999FullName};

 PUBLIC PROCEDURE PacketZapFullName(): STRING[];
 BEGIN
  RETURN BuildAnyPacketFullName(rcv_PensFund, "Z", Packet.Packet, "REP");
 END {PacketZapFullName};

 PUBLIC PROCEDURE PacketPrtFullName(): STRING[];
 BEGIN
  RETURN BuildAnyPacketFullName(rcv_PensFund, "P", Packet.Packet, "REP");
 END {PacketPrtFullName};

 PRIVATE PROCEDURE Packet2NDFLAnyFileName(S, Ext: STRING[]): STRING[];
  VAR
   Path: STRING[];
 BEGIN
  Path:=FIO.BuildPath(path_TaxDep, , FIO.AsbSpecialFolders("ClientProjectRoot"));
  Path:=FIO.BuildPath(L_Str.IntStr(L_DatTim.YEAR(Packet.PerB)), , Path);
  IF ~FIO.DirExists(Path) THEN
   FIO.MkDir(Path);
  END;
  RETURN FIO.BuildPath(S + Packet.Packet, Ext, Path);
 END {Packet2NDFLAnyFileName};

 PUBLIC PROCEDURE Packet2NDFLRepFileName(S: STRING[]): STRING[];
 BEGIN
  RETURN Packet2NDFLAnyFileName(S, "REP");
 END {Packet2NDFLRepFileName};

 PUBLIC PROCEDURE Packet2NDFLTrnFileName(): STRING[];
 BEGIN
  RETURN Packet2NDFLAnyFileName("T", "XML");
 END {Packet2NDFLTrnFileName};

 PRIVATE PROCEDURE PacketT3ShortName(S: STRING[1]; PackNum: SCAL[50]; Ext: STRING[]): STRING[];
  VAR
   _INN: STRING[];
 BEGIN
  _INN:=P_Firm.FP_INN(P_Firm.fomf(PckMyFirm), Packet.PerB);
  RETURN S + Str.Slice(_INN, 4, 5) + FLDTOSTR(PackNum)+"."+Ext;
 END {PacketT3ShortName};

 PRIVATE PROCEDURE PacketT3FullName(S: STRING[1]; PackNum: SCAL[50]; Ext: STRING[]): STRING[];
  VAR
   Path: STRING[];
 BEGIN
  Path:=FIO.BuildPath(path_TaxDep, , FIO.AsbSpecialFolders("ClientProjectRoot"));
  Path:=FIO.BuildPath(L_Str.IntStr(L_DatTim.YEAR(Packet.PerB)), , Path);
  RETURN FIO.BuildPath(PacketT3ShortName(S, PackNum, Ext), , Path);
 END {PacketT3FullName};

 PUBLIC PROCEDURE Sender(Get: PROC; VAR PostN, ManN: STRING[]);
  VAR
   Val: STRING[];
 BEGIN
  Val  :=Get(PckMyFirm, PrepareDate);
  PostN:=L_Prop.getRecordElement(Val, 0);
  ManN :=L_Str.ShortName(L_Prop.getRecordElement(Val, 1));
 END {Sender};

 PUBLIC PROCEDURE MakeADV61forADV1_2_3(Num1, Num2, Num3: NUMERIC[0]);
  VAR
   SenderPostN,
   SenderName  : STRING[];
 BEGIN
  InitPrintAttr(R, LinesPerPage, DEPTH(ADV61_4_00_Top)+
                                 DEPTH(ADV61_4_00_Bot)+1,
                   Duplex, Off);
  Sender(PROCREF(P_MyFirm.AnkSender), SenderPostN, SenderName);
  MAKEPART(R, ADV61_4_00_Top, Num1, Num2, Num3, , , , , , , , , , , , , , , , , , ,
                              SenderPostN, SenderName);
  MAKEPART(R, ADV61_4_00_Bot);
 END {MakeADV61forADV1_2_3};

 PUBLIC PROCEDURE MakeADV61forOther(DocName: STRING[]; Num: NUMERIC[0]);
  VAR
   SenderPostN,
   SenderName  : STRING[];
 BEGIN
  InitPrintAttr(R, LinesPerPage, DEPTH(ADV61_4_00_Top)+
                                 DEPTH(ADV61_4_00_Bot)+1,
                   Duplex, Off);
  Sender(PROCREF(P_MyFirm.PFRInsSender), SenderPostN, SenderName);
  MAKEPART(R, ADV61_4_00_Top, , , , , DocName, Num, , , , , , , , , , , , , , , ,
                              SenderPostN, SenderName);
  MAKEPART(R, ADV61_4_00_Bot);
 END {MakeADV61forOther};

 PUBLIC PROCEDURE MakeADV61forSZV3(Num: NUMERIC[0]; PerByWord: STRING[]; TotSum, SickPay: NUMERIC[2]);
  VAR
   SenderPostN,
   SenderName: STRING[];
 BEGIN
  InitPrintAttr(R, LinesPerPage, DEPTH(ADV61_4_00_Top)+
                                 DEPTH(ADV61_4_00_Certify)+
                                 DEPTH(ADV61_4_00_Bot)+1,
                   Duplex, Off);
  Sender(PROCREF(P_MyFirm.PFRInsSender), SenderPostN, SenderName);
  MAKEPART(R, ADV61_4_00_Top, , , , , , , Num, , , , , , , , , , , , PerByWord,
                              MoneyToTxt(TotSum), MoneyToTxt(SickPay),
                              SenderPostN, SenderName);
  MAKEPART(R, ADV61_4_00_Certify);
  MAKEPART(R, ADV61_4_00_Bot);
 END {MakeADV61forSZV3};

 PRIVATE VAR
  SenderPostNSZV4,
  SenderNameSZV4: STRING[][32];

 PUBLIC PROCEDURE MakeADV61forSZV4x(DocsInPck, MansInPck, Year: NUMERIC[0];
                                    GroupNick: STRING[]; PFInSum, PFAcSum: NUMERIC[2]);
  VAR
   SenderPostN,
   SenderName: STRING[];
 BEGIN
  InitPrintAttr(R, LinesPerPage, DEPTH(ADV61_4_00_Top)+
                                 DEPTH(ADV61_4_00_Certify)+
                                 DEPTH(ADV61_4_00_Bot)+1,
                   Duplex, Off);
  Sender(PROCREF(P_MyFirm.PFRInsSender), SenderPostN, SenderName);
  SenderPostNSZV4[PckMyFirm]:=SenderPostN;
  SenderNameSZV4 [PckMyFirm]:=SenderName;
  MAKEPART(R, ADV61_4_00_Top, , , , , , , , , DocsInPck, MansInPck,  Year, GroupNick,
                              Packet.DataType, Packet.DataType,
                              Packet.CorrType, Packet.CorrType,
                              PFInSum, PFAcSum, , , ,
                              SenderPostN, SenderName);
  MAKEPART(R, ADV61_4_00_Certify);
  MAKEPART(R, ADV61_4_00_Bot);
 END {MakeADV61forSZV4x};

 PUBLIC PROCEDURE MakeADV61forADV10(Num: NUMERIC[0]);
  VAR
   SenderPostN,
   SenderName: STRING[];
 BEGIN
  InitPrintAttr(R, LinesPerPage, DEPTH(ADV61_4_00_Top)+
                                 DEPTH(ADV61_4_00_Bot)+1,
                   Duplex, Off);
  Sender(PROCREF(P_MyFirm.PFRInsSender), SenderPostN, SenderName);
  MAKEPART(R, ADV61_4_00_Top, , , , , , , , Num, , , , , , , , , , , , , ,
                              SenderPostN, SenderName);
  MAKEPART(R, ADV61_4_00_Bot);
 END {MakeADV61forADV10};

 PUBLIC PROCEDURE MakeADV61forADV11();
  VAR
   SenderPostN,
   SenderName: STRING[];
 BEGIN
  InitPrintAttr(R, LinesPerPage, DEPTH(ADV61_4_00_Top)+
                                 DEPTH(ADV61_4_00_Bot)+1,
                   Duplex, Off);
  IF ~VAR_IMPL.Get(SenderNameSZV4).Initialized[PckMyFirm] THEN
   Sender(PROCREF(P_MyFirm.PFRInsSender), SenderPostN, SenderName);
   SenderPostNSZV4[PckMyFirm]:=SenderPostN;
   SenderNameSZV4 [PckMyFirm]:=SenderName;
  ELSE
   SenderPostN:=SenderPostNSZV4[PckMyFirm];
   SenderName :=SenderNameSZV4 [PckMyFirm];
  END;
  MAKEPART(R, ADV61_4_00_Top, , , , , , , , , , , , , , , , , , , , , ,
                              SenderPostN, SenderName);
  MAKEPART(R, ADV61_4_00_Bot);
 END {MakeADV61forADV11};

 PUBLIC PROCEDURE MakeADV61forSZVK(Num: NUMERIC[0]);
  VAR
   SenderPostN,
   SenderName: STRING[];
 BEGIN
  InitPrintAttr(R, LinesPerPage, DEPTH(ADV61_4_00_Top)+
                                 DEPTH(ADV61_4_00_Certify)+
                                 DEPTH(ADV61_4_00_Bot)+1,
                   Duplex, Off);
  Sender(PROCREF(P_MyFirm.AnkSender), SenderPostN, SenderName);
  MAKEPART(R, ADV61_4_00_Top, , , , Num, , , , , , , , , , , , , , , , , ,
                              SenderPostN, SenderName);
  MAKEPART(R, ADV61_4_00_Certify);
  MAKEPART(R, ADV61_4_00_Bot);
 END {MakeADV61forSZVK};

 PUBLIC PROCEDURE MakeProjectPrt();
 BEGIN
  MAKEPART(R, ProjectPrt);
 END {MakeProjectPrt};

 PUBLIC PROCEDURE CheckPacketType();
  VAR
   Ok: SCAL[2];
 BEGIN
  IF    Packet.PerB >= 01\01\2010 THEN
   Ok:=Packet.DataType # dt_ForPens;
  ELSIF Packet.PerB >= 01\01\2004 THEN
   Ok:=Packet.DataType # dt_None;
  ELSE
   Ok:=(Packet.DataType # dt_None) | (Packet.CorrType # ct_None);
  END;
  L_General.Assert(Ok, "⨬ ⠭ ⨯ ᢥ  ४஢ '"+L_Str.PoolItem(dt_Pool, Packet.DataType)+"' '"+L_Str.PoolItem(ct_Pool, Packet.CorrType)+"'");
 END {CheckPacketType};

 PUBLIC PROCEDURE FormType(_DataType: LIKE(Packet.DataType);
                           _CorrType: LIKE(Packet.CorrType)): STRING[];
 BEGIN
  IF    (_DataType = dt_Basic)   & (_CorrType = ct_None)   THEN RETURN "";
  ELSIF (_DataType = dt_None)    & (_CorrType = ct_Corr)   THEN RETURN "";
  ELSIF (_DataType = dt_None)    & (_CorrType = ct_Cancel) THEN RETURN "";
  ELSIF (_DataType = dt_ForPens) & (_CorrType = ct_None)   THEN RETURN "";
  ELSE
   L_General.Error("⨬  '"+L_Str.PoolItem(dt_Pool, _DataType)+"' '"+L_Str.PoolItem(ct_Pool, _CorrType)+"'");
  END;
 END {FormType};

 PUBLIC PROCEDURE SetDTStamp();
 BEGIN
  DTStamp:=STRTOFLD(L_DatTim.SysDateTimeStamp(), NUMERIC);
 END {SetDTStamp};

 PUBLIC PROCEDURE FinishATER(trgStatus: LIKE(Packet.Status));
 BEGIN
  PutManualInputATERAttr();
  SetDTStamp();
  Packet.PrpDate :=SYSDATE();
  Packet.DTStamp :=DTStamp;
  Packet.DataType:=dt_None;
  Packet.CorrType:=ct_None;
  IF ~!trgStatus THEN
   Packet.Status  :=trgStatus;
  END;
  REPLACE(Packet);
 END {FinishATER};

 PUBLIC PROCEDURE GetDTStampTIMESTAMP(trgDTStamp: LIKE(Packet.DTStamp)): TIMESTAMP;
  VAR
   D: DATE;
   T: TIME;
   S,
   tmp : NUMERIC[0];
 BEGIN
  IF trgDTStamp = 0 THEN
   RETURN SYSTIMESTAMP();
  ELSE
   tmp:=trgDTStamp DIV 1000000;
   D:=PackDATE(tmp MOD 100, tmp DIV 100 MOD 100 - 1, tmp DIV 10000);
   tmp:=trgDTStamp MOD 1000000;
   T:=00:00 + (tmp DIV 10000 + tmp DIV 100 MOD 100 / 60);
   S:=trgDTStamp MOD 100;
   RETURN PackTIMESTAMP(D, T, S);
  END;
 END {GetDTStampTIMESTAMP};

 PRIVATE PROCEDURE GetDateFromDTStamp(trgDTStamp: LIKE(Packet.DTStamp)): DATE;
 BEGIN
  RETURN L_DatTim.GetDateOfTIMESTAMP(GetDTStampTIMESTAMP(trgDTStamp));
 END {GetDateTimeFromStamp};

 PUBLIC PROCEDURE SetTimeStampByTheStamp(Handle: STRING[]);
 BEGIN
  FIO.SetFileTime(^Handle, , , GetDTStampTIMESTAMP(DTStamp));
 END {SetTimeStampByTheStamp};

 PUBLIC PROCEDURE SINumberToAnyOut(_SINumber: LIKE(Man.SINumber)): STRING[];
 BEGIN
  IF ~!_SINumber THEN
   RETURN FLDTOSTR(_SINumber, L_Russia.sf_ManSINumber, 0);
  ELSE
   RETURN L_Russia.sf_ManSINumber;
  END;
 END {SINumberToAnyOut};

 PRIVATE PROCEDURE ExclBadChr(S: STRING[]): STRING[];
  VAR
   n, i, j:NUMERIC[0];
 BEGIN
  S:=Str.Replace(S, "", "");
  S:=Str.Replace(S, "", "");
  RETURN S;
 END {ExclBadChr};

 PUBLIC PROCEDURE trn_PutNode(nParent: L_XML.tNode; NodeName:STRING[]): L_XML.tNode;
 BEGIN
  RETURN L_XML.bd_PutNode(nParent, NodeName, "");
 END {trn_PutNode};

 PUBLIC PROCEDURE trn_PutString(nParent: L_XML.tNode; NodeName:STRING[]; s: STRING[]);
 BEGIN
  L_XML.bd_PutLeafNode(nParent, NodeName, L_Str.ExclQM(Str.Condense(Str.Cap(s))));
 END {trn_PutString};

 PUBLIC PROCEDURE MoneyToTxt(x: NUMERIC[2]): STRING[];
 BEGIN
  IF !x THEN
   RETURN "";
  END;
  IF ActualDate < L_General.DenominationDate() THEN
   RETURN FLDTOSTR(x, "0", 0);
  ELSE
   RETURN FLDTOSTR(x, "2.", 0);
  END;
 END {MoneyToTxt};

 PUBLIC PROCEDURE MoneyToIntTxt(x: NUMERIC[2]): STRING[];
 BEGIN
  IF !x THEN
   RETURN "";
  END;
  RETURN FLDTOSTR(x, "0", 0);
 END {MoneyToIntTxt};

 PRIVATE PROCEDURE MoneyToTrn(x: NUMERIC[2]): STRING[];
 BEGIN
  RETURN MoneyToTxt(x);
 END {MoneyToTrn};

 PUBLIC PROCEDURE trn_PutMoney(nParent: L_XML.tNode; NodeName:STRING[]; m: NUMERIC[2]);
 BEGIN
  trn_PutString(nParent, NodeName, MoneyToTrn(m));
 END {trn_PutMoney};

 PUBLIC PROCEDURE trn_PutInt(nParent: L_XML.tNode; NodeName:STRING[]; i: NUMERIC[0]);
 BEGIN
  L_XML.bd_PutLeafNode(nParent, NodeName, L_Str.IntStr(i));
 END {trn_PutInt};

 PUBLIC PROCEDURE trn_PutNumeric(nParent: L_XML.tNode; NodeName:STRING[]; f: FLOAT; n: SCAL[10]);
 BEGIN
  L_XML.bd_PutLeafNode(nParent, NodeName, FLDTOSTR(f, n+"."));
 END {trn_PutNumeric};

 PUBLIC PROCEDURE trn_PutDate(nParent: L_XML.tNode; NodeName:STRING[]; D: DATE);
  VAR
   _DateStr: STRING[];
 BEGIN
  IF ~!D THEN
   _DateStr:=L_DatTim.DateStr(D);
  ELSE
   _DateStr:="";
  END;
  L_XML.bd_PutLeafNode(nParent, NodeName, _DateStr);
 END {trn_PutDate};

 PRIVATE PROCEDURE E_ActingLeadName(D: DATE; _Part: tPart): STRING[];
 BEGIN
  IF _Part = part_Ank THEN
   RETURN L_EC.ExecE_Func_String(D, PROCREF(E_PRoll.Ank_ActingLeadName), OwnLeadName);
  ELSE
   RETURN L_EC.ExecE_Func_String(D, PROCREF(E_PRoll.ManIns_ActingLeadName), OwnLeadName);
  END;
 END {E_ActingLeadName};

 PRIVATE PROCEDURE E_ActingLeadPostName(D: DATE; _Part: tPart): STRING[];
 BEGIN
  IF _Part = part_Ank THEN
   RETURN L_EC.ExecE_Func_String(D, PROCREF(E_PRoll.Ank_ActingLeadPostName), OwnLeadPostName);
  ELSE
   RETURN L_EC.ExecE_Func_String(D, PROCREF(E_PRoll.ManIns_ActingLeadPostName), OwnLeadPostName);
  END;
 END {E_ActingLeadPostName};

 PUBLIC PROCEDURE E_ManIns_NeedDwMA(): SCAL[3];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(PrepareDate, PROCREF(E_PRoll.ManIns_NeedDwMA), adr_UseDwell);
 END {E_ManIns_NeedDwMA};

 PUBLIC PROCEDURE E_ManIns_NeedSeparateMan(DB, DE: DATE; _Group: tPacketGroup): SCAL[100];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PRoll.ManIns_NeedSeparateMan);
  IF ~!Local THEN
   RETURN Local(DB, DE, _Group);
  ELSE
   RETURN 0;
  END;
 END {E_ManIns_NeedSeparateMan};

 PUBLIC PROCEDURE IsFictExtNbr(_ExtNbr: LIKE(Packet.ExtNbr)): SCAL[2];
 BEGIN
  RETURN (_ExtNbr=fg_9998) | (_ExtNbr=fg_9999);
 END {IsFictExtNbr};

 PUBLIC PROCEDURE IsAcceptablePacket(): SCAL[2];
 BEGIN
  RETURN (Packet.Status # st_Rejected) & (Packet.Status # st_Canceled);
 END {IsAcceptablePacket};

 PUBLIC PROCEDURE HasDonePacketInYear(trgMan     : LIKE(Man.Man);
                                      trgKind    : LIKE(Packet.Kind);
                                      trgDataType: LIKE(Packet.DataType);
                                      trgMyFirm  : LIKE(Packet.MyFirm);
                                      trgP       : DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SAVE(Packet);
  SAVE(PckBody);
  SELECT(PckBody, Man, , trgMan);
  WHILE OCCURE(PckBody) & ~Result DO
   CONFORM(PckBody, Packet);
   IF (Packet.Receiver = rcv_PensFund) & (Packet.Kind = trgKind) & (!trgMyFirm | (Packet.MyFirm = trgMyFirm)) &
      IsAcceptablePacket() & ~IsSamplePacket() & ~IsFictExtNbr(Packet.ExtNbr) &
      (!trgDataType | (Packet.DataType = trgDataType)) & (Packet.CorrType # ct_Cancel) &
      (!trgP | (L_DatTim.YEAR(Packet.PerB) = L_DatTim.YEAR(trgP))) THEN
    Result:=1;
   ELSE
    NEXT(PckBody);
   END;
  END; (* WHILE OCCURE(PckBody) ... *)
  RESTORE(PckBody);
  RESTORE(Packet);
  RETURN Result;
 END {HasDonePacketInYear};

 PUBLIC PROCEDURE HasDonePacket(trgMan: LIKE(Man.Man); trgKind: LIKE(Packet.Kind)): SCAL[2];
 BEGIN
  RETURN HasDonePacketInYear(trgMan, trgKind, EMPTYOF(Packet.DataType), PckMyFirm, EMPTYOF(DATE));
 END {HasDonePacket};

 PUBLIC PROCEDURE DefinePckMyFirm(trgBuildMode: tBuildMode);
 BEGIN
  IF    trgBuildMode = bm_bySingle THEN
   PckMyFirm:=P_Firm.DefineManMyFirm(Man.Man, SYSDATE());
  ELSIF trgBuildMode = bm_byPacket THEN
   PckMyFirm:=Packet.MyFirm;
  ELSIF trgBuildMode = bm_byAll    THEN
   PckMyFirm:=P_Firm.DefineMyFirm();
  ELSIF trgBuildMode = bm_byStaff  THEN
   PckMyFirm:=Staff.MyFirm;
  ELSE
   L_General.CallUs(0);
  END;
 END {DefinePckMyFirm};

 PRIVATE PROCEDURE GetPacketNumb(_ExtNbr: LIKE(Packet.ExtNbr); Strong: SCAL[2]): tPFExtNbr;
  VAR
   Numb: NUMERIC[0];
 BEGIN
  IF ~L_Str.TestStrAlowChar(_ExtNbr, "09") THEN
   L_General.Assert(~Strong, "    ᫮: "+_ExtNbr);
   Numb:=0;
  ELSE
   Numb:=STRTOFLD(_ExtNbr, SCAL);
   L_General.Assert(Numb <= MAXOF(tPFExtNbr), "      "+MAXOF(tPFExtNbr)+": "+FLDTOSTR(Numb,""));
  END;
  RETURN Numb;
 END {GetPacketNumb};

 PUBLIC PROCEDURE E_SZVK_OwnEntrysDate(): DATE;
 BEGIN
  RETURN L_EC.ExecE_Func_Date(SYSDATE(), PROCREF(E_PRoll.SZVK_OwnEntrysDate), SYSDATE());
 END {E_SZVK_OwnEntrysDate};

 PRIVATE PROCEDURE IsPacket_wSZVK(): SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(Packet), " । ⥪騩 ");
  RETURN (Packet.Receiver = rcv_PensFund) &
         (Packet.PerB = 01\01\1900) &
         (Packet.PerE = 31\12\2001);
 END {IsPacket_wSZVK};

 PUBLIC PROCEDURE ext_trnFileName(orgPerE: DATE): STRING[];
  VAR
   trgExtNbr: LIKE(Packet.ExtNbr);
   ActualDate: DATE;
 BEGIN
  IF IsPacket_wSZVK() THEN
   ActualDate:=E_SZVK_OwnEntrysDate();
  ELSE
   ActualDate:=orgPerE;
  END;
  IF L_ATER.IsRSV_1_Since2014(Packet.ATER) THEN
   trgExtNbr:=GetPacketNumb("99999", 1);
  ELSE
   trgExtNbr:=GetPacketNumb(Packet.ExtNbr, 1);
  END;
  RETURN "PFR-700-Y-"+L_Str.IntStr(L_DatTim.YEAR(orgPerE))+"-ORG-"+
         P_MyFirm.NumInPFR(PckMyFirm, ActualDate) +
         "-DCK-"+trgExtNbr+"-DPT-000000-DCK-00000.XML";
 END {ext_trnFileName};

 PUBLIC PROCEDURE trnFileName(): STRING[];
 BEGIN
  RETURN ext_trnFileName(Packet.PerE);
 END {trnFileName};

 PRIVATE PROCEDURE NextPacketNbr(D: DATE): tPFExtNbr;
  VAR
   allPFExtNbr,
   yearPFExtNbr,
   Result : tPFExtNbr;
   oPrompt: PROMPT_LINE;
 BEGIN
  oPrompt:=PROMPT_LINE.Create(" । ");
  allPFExtNbr:=0;
  yearPFExtNbr:=0;
  SAVE(Packet);
  SELECT(Packet, PacketDS, , rcv_PensFund);
  WHILE OCCURE(Packet) DO
   PROMPT(Packet.ExtNbr);
   IF ~IsFictExtNbr(Packet.ExtNbr) & (Packet.MyFirm = PckMyFirm) &
      IsAcceptablePacket() & ~IsSamplePacket() THEN
    allPFExtNbr:=Math.Max(allPFExtNbr, GetPacketNumb(Packet.ExtNbr, 0));
    IF L_DatTim.YEAR(D) = L_DatTim.YEAR(Packet.PerB) THEN
     yearPFExtNbr:=Math.Max(yearPFExtNbr, GetPacketNumb(Packet.ExtNbr, 0));
    END;
   END;
   NEXT(Packet);
  END; (* WHILE OCCURE(Packet) ... *)
  RESTORE(Packet);
  IF yearPFExtNbr # 0 THEN
   Result:=yearPFExtNbr;
  ELSE
   Result:=allPFExtNbr;
  END;
  INC(Result);
  RETURN Result;
 END {NextPacketNbr};

 PRIVATE PROCEDURE GetPacketNbrAndPrpDate(D: DATE; trgKind: LIKE(Packet.Kind)): tPFExtNbr;
  VAR
   Result: tPFExtNbr;
 BEGIN
  Result:=NextPacketNbr(D);
  PrepareDate:=SYSDATE();
  P_Firm.PositionOnMyFirm(PckMyFirm);
  STDFORM(L_StdFrm.sf_Choice("| ।  %#####%"+
                             "|"+
                             "| ⮢    %##########%",
                             "%I"+
                             "%<D.N.y>I"),
          "   "+L_Str.PoolItem(knd_Pool, trgKind) + " " +MyFirm.vzSign+" ",
          , -1,
          Result, PrepareDate);
  RETURN Result;
 END {GetPacketNbrAndPrpDate};

 PUBLIC PROCEDURE trn_Init(D: DATE;
                           trgBuildMode: tBuildMode;
                           trgPart: tPart;
                           trgKind: LIKE(Packet.Kind)): tPFExtNbr;
  VAR
   curFirm    : LIKE(Firm.Firm);
   CurPacket: tPFExtNbr;
 BEGIN
  SetDTStamp();
  BuildMode:=trgBuildMode;

  DefinePckMyFirm(BuildMode);
  IF BuildMode # bm_bySingle THEN
   CurPacket:=GetPacketNbrAndPrpDate(D, trgKind);
  ELSE
   CurPacket:="00000";
   PrepareDate:=SYSDATE();
  END;
  ActualDate:=Math.Min(D, PrepareDate);

  curFirm        :=P_Firm.fomf(PckMyFirm);
  OwnNumInPFR    :=P_MyFirm.NumInPFR(PckMyFirm, D);
  L_Str.CheckStrWMask("  ", OwnNumInPFR, "999-999-999999");
  OwnFirmFullName:=ExclBadChr(P_Firm.FP_ContractorBriefName(curFirm, D));
  OwnFirmName    :=ExclBadChr(P_Firm.FP_FirmNameFP(curFirm, D));
  L_General.Assert(Str.Pos(OwnFirmName, '"', 0) = Str.Length(OwnFirmName),
                   "  襩 ࣠樨   ⨬  窨||" +
                   "(᢮⢮ " + FLDTOSTR(P_Firm.P_FirmNameFP, "L", 4) + " ࠣ " + curFirm + ")");
  OwnOKPO        :=P_Firm.FP_OKPO(curFirm, D);
  OwnINN         :=P_Firm.FP_INN(curFirm, D);
  OwnKPP         :=P_Firm.FP_KPP(curFirm, D);
  OwnOGRN        :=P_Firm.FP_OGRN(curFirm, D);
  OwnOKOPFName   :=P_Firm.FP_OKOPF_Name(curFirm, D);
  OwnAcntName    :=P_Firm.FP_AcntName(curFirm, PrepareDate);
  OwnLeadName    :=P_Firm.FP_LeadName(curFirm, PrepareDate);
  OwnLeadPostName:=P_Firm.FP_LeadPostName1(curFirm, PrepareDate);

  ActingLeadName    :=E_ActingLeadName(PrepareDate, trgPart);
  ActingLeadPostName:=E_ActingLeadPostName(PrepareDate, trgPart);
  IF (L_General.GetAPSiteID() = "ZV") & (curFirm=P_Firm.OWN_FIRM) THEN
   OwnFirmFullName:='  "࠭ᠢ" 䨫 殢᪮ ᠦ᪮ ࠭ᯮ⭮ ।⨥ .殢';
   OwnFirmName    :='殢᪮ ';
   OwnKPP         :='503202001';
  END;
  RETURN CurPacket;
 END {trn_Init};

 PUBLIC PROCEDURE trn_DeInit();
 BEGIN
 END {trn_DeInit};

 PUBLIC PROCEDURE trn_OpenFiles();
 BEGIN
  FirstFieldInLine:=1;
  OPENREP(R, PacketRepFullName(), Create,
          Duplex, Off,
          FontProperty, "/U /B /I");
 END {trn_OpenFiles};

 PUBLIC PROCEDURE trn_CloseFiles(_Node: L_XML.tNode);
  VAR
   trnFullName: STRING[];
 BEGIN
  SetTimeStampByTheStamp("R"); CLOSEREP(R);

  trnFullName:=PacketTrnFullName(rcv_PensFund);
  L_XML.bd_Save(L_XML.bd_GetDocument(_Node), trnFullName);
  FIO.Open(T, trnFullName, , Append);
  SetTimeStampByTheStamp("T");
  FIO.Close(T);
 END {trn_CloseFiles};

 PUBLIC PROCEDURE ext_trn_PutHead(FileName: STRING[]): L_XML.tNode;
  VAR
   nRoot,
   nHead,
   nProg,
   nPack: L_XML.tNode;
 BEGIN
  nRoot:=L_XML.bd_Create("");
  L_XML.NeedConvertStringVal:=0;

  trn_PutString(nRoot, "", FileName);
  PutPacketAttr(Packet.Packet, patt_FileName, FileName);

  nHead:=trn_PutNode(nRoot, "");
   trn_PutString(nHead, "ଠ", VER_7_00);
   trn_PutString(nHead, "", "");
   nProg:=trn_PutNode(nHead, "ணࠬ⮢");
    trn_PutString(nProg, "ணࠬ", OwnVER);
    trn_PutString(nProg, "", L_Str.IntStr(DBD.ProcessorVersion()));
   trn_PutString(nHead, "筨", "");
  nPack:=trn_PutNode(nRoot, "窠室儮㬥⮢");
   L_XML.bd_SetAttribute(nPack, "㦥", " ⠢ 䠩");
   L_XML.bd_SetAttribute(nPack, "⠤", " ࠡ⪨");
  RETURN nPack;
 END {ext_trn_PutHead};

 PUBLIC PROCEDURE trn_PutHead(): L_XML.tNode;
 BEGIN
  RETURN ext_trn_PutHead(trnFileName());
 END {trn_PutHead};

 PUBLIC PROCEDURE trn_PutAbstractDoc(nParent: L_XML.tNode; NodeName: STRING[]; Numb: NUMERIC[0]): L_XML.tNode;
  VAR
   nSysNbr,
   nAbsDoc: L_XML.tNode;
 BEGIN
  nAbsDoc:=trn_PutNode(nParent, NodeName);
   trn_PutInt(nAbsDoc, "窥", Numb);
(* ???
   trn_PutString(nAbsDoc, "७㬥", "");
   nSysNbr:=trn_PutNode(nAbsDoc, "㬥᭮");
    trn_PutInt(nSysNbr, "ࠧ", "");
    trn_PutInt(nSysNbr, "室騩", "");
    trn_PutInt(nSysNbr, "窥", "");
    trn_PutInt(nSysNbr, "", "");
*)
  RETURN nAbsDoc;
 END {trn_PutAbstractDoc};

 PUBLIC PROCEDURE trn_PutOwnFirmTaxNum(nParent: L_XML.tNode; NodeName: STRING[]);
  VAR
   nTaxNbr: L_XML.tNode;
 BEGIN
  nTaxNbr:=trn_PutNode(nParent, NodeName);
   trn_PutString(nTaxNbr, "", OwnINN); (*Int*)
   trn_PutString(nTaxNbr, "", OwnKPP); (*Int*)
 END {trn_PutOwnFirmTaxNum};

 PUBLIC PROCEDURE trn_PutOwnFirm(nParent: L_XML.tNode; NodeName: STRING[]);
  VAR
   nFirm,
   nTaxNbr: L_XML.tNode;
   kndBD,
   kndBE  : DATE;
 BEGIN
  nFirm:=trn_PutNode(nParent, NodeName);
   trn_PutOwnFirmTaxNum(nFirm, "멍");
   GetPacketKindActualPer(Packet.Kind, kndBD, kndBE);
   IF kndBD < 01\01\2014 THEN
    trn_PutString(nFirm, "", "");
    trn_PutString(nFirm, "", OwnOGRN); (*Int*)
    trn_PutString(nFirm, "ଠ", Str.Slice(OwnOKOPFName, 0, 40)); (*࣠樮-ࠢ*)
   END;
   trn_PutString(nFirm, "࣠樨", OwnFirmFullName);
   trn_PutString(nFirm, "⪮", OwnFirmName);
   trn_PutString(nFirm, "樮멍", OwnNumInPFR);
(*
   nSubdiv:=trn_PutNode(nFirm, "ࠧ");
    trn_PutString(nSubdiv, "ࠧ", "");
    trn_PutString(nSubdiv, "ࠧ", "0");
   trn_PutString(nFirm, "業", );
   trn_PutDate(nFirm, "⠂뤠程業", );
*)
 END {trn_PutOwnFirm};

 PUBLIC PROCEDURE trn_PutInventoryHead(nParent: L_XML.tNode; NodeName, _DocType: STRING[]; PacketVolume: NUMERIC[0]): L_XML.tNode;
  VAR
   nInven,
   nSubdiv,
   nPckNbr,
   nDocAcc,
   nDocForm: L_XML.tNode;
 BEGIN
  nInven:=trn_PutAbstractDoc(nParent, NodeName, 1);
(* 4.1.2. "室 "  ७  "室騩 㬥" *)
   trn_PutString(nInven, "室饩", " ");
   trn_PutOwnFirm(nInven, "⠢⥫쏠窨");
   nPckNbr:=trn_PutNode(nInven, "窨");
    trn_PutString(nPckNbr, "᭮", Packet.ExtNbr); (*Int*)
(*
    trn_PutString(nPckNbr, "ࠧ", ""); (*Int*)
*)
   nDocAcc:=trn_PutNode(nInven, "⠢㬥⮢");
    L_XML.bd_PutLeafNode(nDocAcc, "⢮", "1");
    nDocForm:=trn_PutNode(nDocAcc, "稥㬥⮢");
     trn_PutString(nDocForm, "㬥", _DocType);
     trn_PutInt(nDocForm, "⢮", PacketVolume);
   trn_PutDate(nInven, "⠑⠢", PrepareDate);
   RETURN nInven;
 END {trn_PutInventoryHead};

 PUBLIC PROCEDURE trn_PutFIO(nParent: L_XML.tNode; NodeName: STRING[]; ManName: STRING[]);
  VAR
   nName     : L_XML.tNode;
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  nName:=trn_PutNode(nParent, NodeName);
  L_Str.SplitManName(ManName, Surname, FirstName, Patronymic);
  trn_PutString(nName, "",  Surname);
  trn_PutString(nName, "",      FirstName);
  trn_PutString(nName, "⢮", Patronymic);
 END {trn_PutFIO};

 PRIVATE PROCEDURE trn_PutGeography(nParent: L_XML.tNode; NodeName:STRING[]; FullName, ShortName: STRING[]);
  VAR
   nGeogr: L_XML.tNode;
 BEGIN
  IF ~!FullName THEN
   nGeogr:=trn_PutNode(nParent, NodeName);
    trn_PutString(nGeogr, "᪮", FullName);
    trn_PutString(nGeogr, "饭", ShortName);
  END;
 END {trn_PutGeography};

 PRIVATE PROCEDURE trn_PutNumeration(nParent: L_XML.tNode; NodeName:STRING[]; Numer, ShortName: STRING[]);
  VAR
   nNumer: L_XML.tNode;
 BEGIN
  IF ~!Numer THEN
   nNumer:=trn_PutNode(nParent, NodeName);
    trn_PutString(nNumer, "饭", ShortName);
    trn_PutString(nNumer, "", Numer);
  END;
 END {trn_PutNumeration};

 PUBLIC PROCEDURE GetAdrForPFR(): STRING[];
 BEGIN
  L_General.CallUs(ACCESS(ManAdr));
  L_Man.curManAdr_Set_glb_AdrVar();
  RETURN L_Russia.PFRAdr_asStr();
 END {GetAdrForPFR};

 PUBLIC PROCEDURE trn_PutAdr(nParent: L_XML.tNode; NodeName: STRING[]);
  VAR
   nFullAdr,
   nAdr: L_XML.tNode;
 BEGIN
  nFullAdr:=trn_PutNode(nParent, NodeName);
  IF ManAdr.Country = L_Russia.c_Russia THEN
   trn_PutString(nFullAdr, "", "");
   IF ~!ManAdr.Zip THEN
    trn_PutString(nFullAdr, "", ManAdr.Zip); (*Int*)
   END;
   nAdr:=trn_PutNode(nFullAdr, "ᨩ᪨");
    trn_PutString(nAdr, "ﭨ", "");
    trn_PutGeography(nAdr, "", L_Russia.RegionN_InPFRFormat(ManAdr.Region), L_Russia.RegionT_InPFRFormat(ManAdr.Region));
    trn_PutGeography(nAdr, "", ManAdr.Distr, "-");
    trn_PutGeography(nAdr, "த", ManAdr.Town, L_Russia.TownT_InMNSFormat(ManAdr.TownT));
    trn_PutGeography(nAdr, "ᥫ멏㭪", ManAdr.Village, L_Russia.VillageT_InMNSFormat(ManAdr.VillageT));
    trn_PutGeography(nAdr, "", ManAdr.Street, L_Russia.StreetT_InMNSFormat(ManAdr.StreetT));
    trn_PutNumeration(nAdr, "", ManAdr.House, "");
    trn_PutNumeration(nAdr, "", ManAdr.Block, "");
    trn_PutNumeration(nAdr, "", ManAdr.Flat, "");
  ELSE
   CONFORM(ManAdr, Country);
   trn_PutString(nFullAdr, "", "");
   IF ~!ManAdr.Zip THEN
    trn_PutString(nFullAdr, "", ManAdr.Zip); (*Int*)
   END;
   nAdr:=trn_PutNode(nFullAdr, "࠭멀");
    trn_PutInt(nAdr, "࠭", Country.Country);
    trn_PutString(nAdr, "࠭", Country.FullName);
    trn_PutString(nAdr, "", GetAdrForPFR());
  END;
(* ஢ 
  trn_PutString(nFullAdr, "", "");
  trn_PutString(nFullAdr, "", ""); (*Int*)
  nAdr:=trn_PutNode(nFullAdr, "஢멀");
   trn_PutString(nAdr, "", "");
*)
 END {trn_PutAdr};

 PUBLIC PROCEDURE trn_PutTerrCond(nParent: L_XML.tNode; NodeName: STRING[]; Reason: STRING[]; Coeff: NUMERIC[2]);
  VAR
   nTerr: L_XML.tNode;
 BEGIN
  nTerr:=trn_PutNode(nParent, NodeName);
   trn_PutString(nTerr, "᭮", Reason);
   trn_PutNumeric(nTerr, "樥", Coeff, 2);
 END {trn_PutTerrCond};

 PUBLIC PROCEDURE trn_PutEarnHours(nParent: L_XML.tNode; NodeName: STRING[]; Hours, Mins: NUMERIC[0]);
  VAR
   nEarnHours: L_XML.tNode;
 BEGIN
IF (Hours # 0) | (Mins # 0) THEN
  nEarnHours:=trn_PutNode(nParent, NodeName);
   trn_PutInt(nEarnHours, "", Hours);
   trn_PutInt(nEarnHours, "", Mins);
END;
 END {trn_PutEarnHours};

 PUBLIC PROCEDURE trn_PutEarnDays(nParent: L_XML.tNode; NodeName: STRING[]; Years, Months, Days: NUMERIC[0]);
  VAR
   nEarnDays: L_XML.tNode;
 BEGIN
IF (Years # 0) | (Months # 0) | (Days # 0) THEN
  nEarnDays:=trn_PutNode(nParent, NodeName);
   trn_PutInt(nEarnDays, "᥃",   Years);  (*>=0*)
   trn_PutInt(nEarnDays, "᥌", Months); (* 0  12*)
   trn_PutInt(nEarnDays, "᥄",    Days);   (* 0  29*)
END;
 END {trn_PutEarnDays};

 PUBLIC PROCEDURE PutPckBodyAttr(_Packet: LIKE(PckBody.Packet);
                                 _SeqNbr: LIKE(PckBody.SeqNbr);
                                 _Attr  : LIKE(PckAttr.Attr);
                                 _Value : STRING[]);
 BEGIN
  IF ~SEARCH(PckAttr, PckBody, _Packet, _SeqNbr, _Attr) THEN
   PckAttr.Packet:=_Packet;
   PckAttr.SeqNbr:=_SeqNbr;
   PckAttr.Attr  :=_Attr;
   PckAttr.Value :=_Value;
   INSERT(PckAttr);
  ELSE
   PckAttr.Value :=_Value;
   REPLACE(PckAttr);
  END;
  L_General.CallUs(PckAttr.Value = _Value); (*஢塞,    *)
 END {PutPckBodyAttr};

 PUBLIC PROCEDURE GetPckBodyAttr(_Packet: LIKE(PckBody.Packet);
                                 _SeqNbr: LIKE(PckBody.SeqNbr);
                                 _Attr  : LIKE(PckAttr.Attr)): LIKE(PckAttr.Value);
 BEGIN
  IF SEARCH(PckAttr, PckBody, _Packet, _SeqNbr, _Attr) THEN
   RETURN PckAttr.Value;
  ELSE
   RETURN "";
  END;
 END {GetPckBodyAttr};

 PUBLIC PROCEDURE GetPckBodySum(trgPacket: LIKE(PckBody.Packet);
                                trgSeqNbr: LIKE(PckBody.SeqNbr)): NUMERIC[2];
  VAR
   trgValue: LIKE(PckAttr.Value);
 BEGIN
  trgValue:=GetPckBodyAttr(trgPacket, trgSeqNbr, patt_Sum);
  L_General.Assert(~!trgValue, "  " + trgPacket + "  㪠 㬬   " + PckBody.Man);
  RETURN STRTOFLD(trgValue, NUMERIC);
 END {GetPckBodySum};

 PUBLIC PROCEDURE PutPckBodySum(trgPacket: LIKE(PckBody.Packet);
                                trgSeqNbr: LIKE(PckBody.SeqNbr);
                                trgSum   : LIKE(PDocList.Sum));
 BEGIN
  PutPckBodyAttr(trgPacket, trgSeqNbr, patt_Sum, L_Str.NumericStr(trgSum, 2));
 END {PutPckBodySum};

 PUBLIC PROCEDURE PutPacketAttr(_Packet: LIKE(PckBody.Packet);
                                _Attr  : LIKE(PckAttr.Attr);
                                _Value : STRING[]);
 BEGIN
  PutPckBodyAttr(_Packet, EMPTYOF(PckBody.SeqNbr), _Attr, _Value);
 END {PutPacketAttr};

 PUBLIC PROCEDURE GetPacketAttr(_Packet: LIKE(PckBody.Packet);
                                _Attr  : LIKE(PckAttr.Attr)): LIKE(PckAttr.Value);
 BEGIN
  RETURN GetPckBodyAttr(_Packet, EMPTYOF(PckBody.SeqNbr), _Attr);
 END {GetPacketAttr};

 PUBLIC PROCEDURE GetManInPFRFName(D: DATE): STRING[];
  VAR
   N: STRING[];
 BEGIN
  N:=P_Man.GetManProSoft(Man.Man, D, P_Man.P_ManName_inPFRF);
  IF !N THEN
   RETURN Man.Name;
  ELSE
   RETURN N;
  END;
 END {GetManInPFRFName};

 PRIVATE CONST
  AveDaysInMonth = 30;

 PUBLIC PROCEDURE NormalizeDM(VAR D, M: NUMERIC[0]);
 BEGIN
  INC(M, D DIV AveDaysInMonth);
  D:=D MOD AveDaysInMonth;
 END {NormalizeDM};

 PUBLIC PROCEDURE NormalizeDMY(VAR D, M, Y: NUMERIC[0]);
 BEGIN
  NormalizeDM(D, M);
  INC(Y, M DIV 12);
  M:=M MOD 12;
 END {NormalizeDMY};

 PUBLIC PROCEDURE UnNormalizeDMY(D, M, Y: NUMERIC[0]): NUMERIC[0];
 BEGIN
  IF ~!Y THEN
   L_General.Assert(~!M, " ⢮ ,   楢!");
   INC(M, Y*12);
  END;
  IF ~!M THEN
   L_General.Assert(~!D, " ⢮ 楢,   !");
   INC(D, M*AveDaysInMonth);
  END;
  IF ~!D THEN
   RETURN D;
  ELSE
   RETURN 0;
  END;
 END {UnNormalizeDMY};

 PUBLIC PROCEDURE DaysInIntvl(B, E: DATE): NUMERIC[0];
  VAR
   DB, DE,
   MB, ME,
   YB, YE,
   Days  : NUMERIC[0];
 BEGIN
  UnPkDATE(B, DB, MB, YB);
  UnPkDATE(E, DE, ME, YE);
  DEC(YE, YB);
  DEC(ME, MB);
  DEC(DE, DB);
  IF DE < 0 THEN
   INC(DE, AveDaysInMonth);
   DEC(ME);
  END;
  IF ME < 0 THEN
   INC(ME, 12);
   DEC(YE);
  END;
  RETURN UnNormalizeDMY(DE, ME, YE) + 1;
 END {DaysInIntvl};

 PUBLIC PROCEDURE FirstToEmptyPool(Pool: STRING[]; Item: NUMERIC[0]): STRING[];
 BEGIN
  IF Item = 0 THEN
   RETURN "";
  ELSE
   RETURN L_Str.PoolItem(Pool, Item);
  END;
 END {FirstToEmptyPool};

 PRIVATE VAR
  spf_FileList : STRING[];
  spf_FileDescr: STRING[];

 PRIVATE PROCEDURE AddFileInShow(FileName, FileDescr: STRING[]);
 BEGIN
  spf_FileList :=spf_FileList  + "|" + FileName;
  spf_FileDescr:=spf_FileDescr + "|" + FileDescr;
 END {AddFileInShow};

 PRIVATE PROCEDURE EraseFile(FileName, FileDescr: STRING[]);
 BEGIN
  FIO.Erase(FileName);
 END {EraseFile};

 PRIVATE PROCEDURE GetFileDescr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(knd_Pool, Packet.Kind) + " (" + Packet.ExtNbr + ")";
 END {GetFileDescr};

 PRIVATE PROCEDURE ProcessPacketFile(FileName: STRING[]; Proc: PROC);
 BEGIN
  IF FIO.Exists(FileName) THEN
   Proc(FileName, GetFileDescr());
  END;
 END {ProcessPacketFile};

 PRIVATE PROCEDURE ProcessPFRPackets(trgDTStamp: LIKE(Packet.DTStamp); Proc: PROC);
 BEGIN
  IF ~!trgDTStamp THEN
   DTStamp:=trgDTStamp;
   SAVE(Packet);
   SELECT(Packet, PckDTSPk, , rcv_PensFund, DTStamp);
   WHILE OCCURE(Packet) DO
    ProcessPacketFile(PacketTrnFullName(rcv_PensFund), Proc);
    NEXT(Packet);
   END; (* WHILE OCCURE(Packet) ... *)
   RESTORE(Packet);
  END;
 END {ProcessPFRPackets};

 PUBLIC PROCEDURE GetPFRDTStampFromRSV(): LIKE(Packet.DTStamp);
  VAR
   Result: NUMERIC[0];
 BEGIN
  SETEMPTY(Result);
  IF L_ATER.IsRSV_1_Since2014(Packet.ATER) THEN
   SAVE(PckATER);
   Result:=L_ATER.extGetNumericValueFromPacket(Packet.Packet, "⠬⠏", L_ATER.ZeroTable, 1);
   RESTORE(PckATER);
  END;
  RETURN Result;
 END {GetPFRDTStampFromRSV};

 PRIVATE PROCEDURE ProcessPacketFileList(Proc: PROC; EraseFiles: SCAL[2]; FilesToProcess: tFilesToProcess);
  VAR
   NeedPrn,
   NeedTrn: SCAL[2];
 BEGIN
  NeedPrn:=(FilesToProcess = fp_All) | (FilesToProcess = fp_Prn);
  NeedTrn:=(FilesToProcess = fp_All) | (FilesToProcess = fp_Trn);

  IF    Packet.Receiver = rcv_PensFund THEN
   IF NeedTrn THEN
    ProcessPacketFile(PacketTrnFullName(rcv_PensFund), Proc);
    ProcessPacketFile(OldPfrPacketTrnFullName(), Proc);
   END;
   IF NeedPrn THEN
    ProcessPacketFile(Packet999FullName(), Proc);
    ProcessPacketFile(PacketPrtFullName(), Proc);
    ProcessPacketFile(PacketZapFullName(), Proc);
    ProcessPacketFile(PacketRepFullName(), Proc);
   END;
  ELSIF Packet.Receiver = rcv_TaxDep THEN
   IF Packet.PerB >= 01\01\2005 THEN
    IF NeedTrn THEN
     ProcessPacketFile(Packet2NDFLTrnFileName(), Proc);
    END;
    IF NeedPrn THEN
     ProcessPacketFile(Packet2NDFLRepFileName("R"), Proc);
     ProcessPacketFile(Packet2NDFLRepFileName("E"), Proc);
    END;
   ELSE
    IF NeedTrn THEN
     ProcessPacketFile(PacketT3FullName("S", Packet.ExtNbr, "TXT"), Proc);
    END;
    IF NeedPrn THEN
     ProcessPacketFile(PacketT3FullName("T", Packet.ExtNbr, "REP"), Proc);
     ProcessPacketFile(PacketT3FullName("E", Packet.ExtNbr, "REP"), Proc);
     ProcessPacketFile(PacketT3FullName("R", Packet.ExtNbr, "REP"), Proc);
    END;
   END;
  ELSIF Packet.Receiver = rcv_e_TaxDep THEN
   IF NeedTrn THEN
    ProcessPacketFile(PacketTrnFullName(Packet.Receiver), Proc);
    IF ~EraseFiles THEN
     ProcessPFRPackets(GetPFRDTStampFromRSV(), Proc);
    END;
   END;
  END;
 END {ProcessPacketFileList};

 PUBLIC PROCEDURE ShowPacketFiles(FilesToProcess: tFilesToProcess);
  VAR
   i                : NUMERIC[0];
   FileName,
   FilesToSurvey    : STRING[];
   SingleFileForShow: SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭  ⭮");
  DefinePckMyFirm(bm_byPacket);
  SETEMPTY(spf_FileList, spf_FileDescr);
  ProcessPacketFileList(PROCREF(AddFileInShow), 0, FilesToProcess);
  L_General.Assert(~!spf_FileList, "    䠩   " + Packet.Packet);
  SingleFileForShow:=L_Str.CntItemsInPool(spf_FileList) = 1;
  LOOP
   IF SingleFileForShow THEN
    i:=0;
   ELSE
    i:=L_StdFrm.ShowListAsMenu(spf_FileDescr, "롮 䠩  ᬮ");
   END;
   FileName:=L_Str.PoolItem(spf_FileList, i);
   IF Str.Cap(L_FIO.effp_FileExt(FileName)) = "XML" THEN
    Shell.Execute("open", FileName);
    IF SingleFileForShow THEN
     EXIT;
    END;
   ELSE
    LIKEMENU(Survey, FileName);
    EXIT;
   END;
  END; (* LOOP *)
 END {ShowPacketFiles};

 PUBLIC PROCEDURE ErasePacketFiles();
 BEGIN
  ProcessPacketFileList(PROCREF(EraseFile), 1, fp_All);
 END {ErasePacketFiles};

 PUBLIC PROCEDURE CheckExistTrnFiles();
 BEGIN
  ErasePacketFiles();
 END {CheckExistTrnFiles};

 PRIVATE PROCEDURE intHasExistingPackets(trgMan     : LIKE(Man.Man);
                                         trgKind    : LIKE(Packet.Kind);
                                         trgPerB,
                                         trgPerE    : DATE;
                                         trgDataType: LIKE(Packet.DataType);
                                         trgCorrType: LIKE(Packet.CorrType);
                                         UnDoneOnly : SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  TRY [RESTORE_CURSORS(RC_ON)]
   SELECT(Packet, PacketKn, , rcv_PensFund, trgKind, trgPerB);
   WHILE OCCURE(Packet) DO
    IF IsAcceptablePacket() & ~IsSamplePacket() &
       (Packet.PerE = trgPerE) & (Packet.DataType = trgDataType) & (Packet.CorrType = trgCorrType) &
       (Packet.MyFirm = PckMyFirm) &
       (~UnDoneOnly | (Packet.Status # st_Done)) &
       (!trgMan | SEARCH(PckBody, PckMan, Packet.Packet, trgMan)) THEN
     LAST(Packet);
     Result:=1;
    END;
    NEXT(Packet);
   END; (* WHILE OCCURE(Packet) ... *)
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {intHasExistingPackets};

 PUBLIC PROCEDURE HasExistingPackets(trgKind: LIKE(Packet.Kind);
                                     trgPerB, trgPerE: DATE;
                                     trgDataType: LIKE(Packet.DataType);
                                     trgCorrType: LIKE(Packet.CorrType)): SCAL[2];
 BEGIN
  RETURN intHasExistingPackets(EMPTYOF(Man.Man), trgKind, trgPerB, trgPerE, trgDataType, trgCorrType, 0);
 END {HasExistingPackets};

 PRIVATE PROCEDURE intCheckExistingPackets(Strong     : SCAL[2];
                                           trgMan     : LIKE(Man.Man);
                                           trgKind    : LIKE(Packet.Kind);
                                           trgPerB,
                                           trgPerE    : DATE;
                                           trgDataType: LIKE(Packet.DataType);
                                           trgCorrType: LIKE(Packet.CorrType));
  VAR
   Msg: STRING[];
 BEGIN
  IF intHasExistingPackets(trgMan, trgKind, trgPerB, trgPerE, trgDataType, trgCorrType, 0) THEN
   IF ~!trgMan THEN
    SEARCH(Man, Man, , trgMan);
    Msg:=" "+L_Man.Man_ManAsStr()+" "+Man.Name+":|";
   ELSE
    Msg:="";
   END;
   Msg:=Msg+"    ଥ "+L_Str.PoolItem(knd_Pool, trgKind)+"  ਮ  "+L_DatTim.PeriodStr(trgPerB)+"  "+L_DatTim.PeriodStr(trgPerE)+
        "|"+
        "|,  뫨 㪠 ﭨ '"+L_Str.PoolItem(st_Pool, st_Rejected)+"'|"+
        " ࠭ ନ஢   㫨஢ ";
   L_StdFrm.ConditionalCHOICE(Msg, ~Strong);
  END;
 END {intCheckExistingPackets};

 PUBLIC PROCEDURE CheckExistingPackets(trgKind: LIKE(Packet.Kind);
                                       trgPerB, trgPerE: DATE;
                                       trgDataType: LIKE(Packet.DataType);
                                       trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  intCheckExistingPackets(0, EMPTYOF(Man.Man), trgKind, trgPerB, trgPerE, trgDataType, trgCorrType);
 END {CheckExistingPackets};

 PUBLIC PROCEDURE CheckExistingPacketsStrong(trgKind: LIKE(Packet.Kind);
                                             trgPerB, trgPerE: DATE;
                                             trgDataType: LIKE(Packet.DataType);
                                             trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  intCheckExistingPackets(1, EMPTYOF(Man.Man), trgKind, trgPerB, trgPerE, trgDataType, trgCorrType);
 END {CheckExistingPacketsStrong};

 PUBLIC PROCEDURE CheckManExistingPackets(trgMan : LIKE(Man.Man);
                                          trgKind: LIKE(Packet.Kind);
                                          trgPerB, trgPerE: DATE;
                                          trgDataType: LIKE(Packet.DataType);
                                          trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  intCheckExistingPackets(0, trgMan, trgKind, trgPerB, trgPerE, trgDataType, trgCorrType);
 END {CheckManExistingPackets};

 PRIVATE PROCEDURE intCheckUnDonePackets(Strong: SCAL[2];
                                         trgKind: LIKE(Packet.Kind);
                                         trgPerB, trgPerE: DATE;
                                         trgDataType: LIKE(Packet.DataType);
                                         trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  IF intHasExistingPackets(EMPTYOF(Man.Man), trgKind, trgPerB, trgPerE, trgDataType, trgCorrType, 1) THEN
   L_StdFrm.ConditionalCHOICE("   ﭨ '"+L_Str.PoolItem(st_Pool, st_Prepared)+"'  '"+L_Str.PoolItem(st_Pool, st_InProcess)+"'|"+
                              " ଥ "+L_Str.PoolItem(knd_Pool, trgKind)+"  ਮ  "+L_DatTim.PeriodStr(trgPerB)+"  "+L_DatTim.PeriodStr(trgPerE)+
                              "|"+
                              "|,  뫨 㪠   ﭨ '"+L_Str.PoolItem(st_Pool, st_Done)+"'",
                               ~Strong);
  END;
 END {intCheckUnDonePackets};

 PUBLIC PROCEDURE CheckUnDonePackets(trgKind: LIKE(Packet.Kind);
                                     trgPerB, trgPerE: DATE;
                                     trgDataType: LIKE(Packet.DataType);
                                     trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  intCheckUnDonePackets(0, trgKind, trgPerB, trgPerE, trgDataType, trgCorrType)
 END {CheckUnDonePackets};

 PUBLIC PROCEDURE CheckUnDonePacketsStrong(trgKind: LIKE(Packet.Kind);
                                           trgPerB, trgPerE: DATE;
                                           trgDataType: LIKE(Packet.DataType);
                                           trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  intCheckUnDonePackets(1, trgKind, trgPerB, trgPerE, trgDataType, trgCorrType)
 END {CheckUnDonePacketsStrong};

 PUBLIC PROCEDURE E_ManIns_ExcludedTSN(D: DATE): SCAL[2];
 BEGIN
  IF Staff.EndDate < D THEN
   RETURN 0;
  ELSIF P_Staff.HasActualStaffPro(Staff.TSN, D, P_Staff.P_ExcludedTSNForPF) THEN
   RETURN 1;
  ELSE
   RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.ManIns_ExcludedTSN), 0);
  END;
 END {E_ManIns_ExcludedTSN};

 PRIVATE PROCEDURE GetFileSize(FullFileName: STRING[]): NUMERIC[0];
  VAR
   Size: NUMERIC[0];
 BEGIN
  FIO.Open(F, FullFileName, , Input);
  Size:=FIO.Size(F);
  FIO.Close(F);
  RETURN Size;
 END {GetFileSize};

 PRIVATE PROCEDURE CondZipTransportFile(TransportFile, DestFile: STRING[]; AvailableSpace: NUMERIC[0]): STRING[];
  VAR
   Name,
   Ext,
   Dummy,
   tmpDestFile,
   ZipFile,
   DestPath,
   Result: STRING[];
 BEGIN
  IF GetFileSize(TransportFile) >= AvailableSpace THEN
   L_StdFrm.Question(" ࠭ᯮ⭮ 䠩 ॢ蠥 ࠧ ᢮ ࠭⢠ (" + FLDTOSTR(AvailableSpace / 1024 / 1024, "2.") + " )|" +
                     "믮 娢 䠩?");
   FIO.SplitPath(DestFile, Name, Ext, DestPath);
   tmpDestFile:=FIO.BuildPath(Name, Ext, FIO.AsbSpecialFolders("ASBTemp"));
   L_FIO.ExactFileCopy(TransportFile, tmpDestFile);
   ZipFile:=FIO.BuildPath(Name, "ZIP", FIO.AsbSpecialFolders("ASBTemp"));
   L_General.Assert(L_General.Launch_PKZIP("-add", tmpDestFile, ZipFile) = L_General.eprc_Normal,
                    "訡  娢樨");

   L_General.Assert(GetFileSize(ZipFile) <= AvailableSpace,
                    "筮   ᬥ ⥫.|" +
                    "᢮     롥 㣮 ᬥ ⥫");
   FIO.SplitPath(ZipFile, Name, Ext, Dummy);
   DestFile:=FIO.BuildPath(Name, Ext, DestPath);
   L_FIO.ExactFileCopy(ZipFile, DestFile);
   FIO.Erase(ZipFile);
   FIO.Erase(tmpDestFile);
  ELSE
   L_FIO.ExactFileCopy(TransportFile, DestFile);
  END;
  RETURN DestFile;
 END {CondZipTransportFile};

 PUBLIC PROCEDURE GetPerSign(): STRING[];
  VAR
   PerLength: NUMERIC[0];
 BEGIN
  CONFORM(Packet, ATER);
  IF (Packet.PerB >= 01\01\2011) & (ATER.Kind = knd_FSS_Sheet) THEN
   RETURN L_Str.PoolItem("03|06|09|12", L_DatTim.QUARTAL(Packet.PerE))
  ELSE
 (* 1- |3 - ⠫|6 - 㣮|9 - 9 楢|0 - |2 -  *)
   PerLength:=L_DatTim.MonthsInIntvl(Packet.PerB, Packet.PerE) + 1;
   IF    PerLength = 1 THEN
    RETURN "1";
   ELSIF PerLength = 3 THEN
    IF ATER.Kind = knd_TT_AdvRep THEN
     RETURN L_Str.IntStr((L_DatTim.QUARTAL(Packet.PerE)+1)*3);
    END;
    RETURN "3";
   ELSIF PerLength = 6 THEN
    RETURN "6";
   ELSIF PerLength = 9 THEN
    RETURN "9";
   ELSIF PerLength = 12 THEN
    RETURN "0";
   ELSE
    RETURN "2";
   END;
  END;
 END {GetPerSign};

 PUBLIC PROCEDURE GetPacketOwnFirm(): LIKE(Firm.Firm);
 BEGIN
  RETURN P_Firm.fomf(Packet.MyFirm);
 END {GetPacketOwnFirm};

 PUBLIC PROCEDURE GetPacketMyFirm(): P_Firm.tMyFirm;
 BEGIN
  RETURN Packet.MyFirm;
 END {GetPacketMyFirm};

 PUBLIC PROCEDURE GetTaxAgentMyFirm(): P_Firm.tMyFirm;
  VAR
   Result: P_Firm.tMyFirm;
 BEGIN
  Result:=Packet.MyFirm;
  IF L_General.IsPolakSpecific() & (Packet.MyFirm # L_Env.mf_PIS) &
     (L_DatTim.YEAR(Packet.PerB) >= 2010) & (Packet.Kind # knd_RSV_1) THEN
   Result:=L_Env.mf_PIS;
  END;
  RETURN Result;
 END {GetTaxAgentMyFirm};

 PUBLIC PROCEDURE TaxAgentRequired(): SCAL[2];
 BEGIN
  RETURN GetTaxAgentMyFirm() # Packet.MyFirm;
 END {TaxAgentRequired};

 PRIVATE PROCEDURE GetIdFilewUUID(R_T: STRING[]; trgMyFirm: P_Firm.tMyFirm; PrepareDate: DATE; UUID: STRING[]): STRING[];
 BEGIN
  RETURN R_T +
          "_" + P_MyFirm.IntermedTaxDepCode(trgMyFirm, PrepareDate) +
          "_" + P_MyFirm.TaxDepCode(trgMyFirm, PrepareDate) +
          "_" + P_Firm.FP_INN(P_Firm.fomf(trgMyFirm), Packet.PerE) + P_Firm.FP_KPP(P_Firm.fomf(trgMyFirm), Packet.PerE) +
          "_" + FLDTOSTR(PrepareDate, "yND") +
          "_" + UUID;
 END {GetIdFilewUUID};

 PUBLIC PROCEDURE GetIdFile(R_T: STRING[]): STRING[];
 BEGIN
  RETURN GetIdFilewUUID(R_T, GetTaxAgentMyFirm(), SYSDATE(), Str.Cap(CreateUUID(1)));
 END {GetIdFile};

 PRIVATE PROCEDURE GetOldIdFilewUUID(R_T: STRING[]; PrepareDate: DATE; UUID: STRING[]): STRING[];
 BEGIN
  RETURN R_T +
          "_" + P_MyFirm.IntermedTaxDepCode(Packet.MyFirm, PrepareDate) +
          "_" + P_Firm.FP_INN(GetPacketOwnFirm(), Packet.PerE) + P_Firm.FP_KPP(GetPacketOwnFirm(), Packet.PerE) +
          "_" + FLDTOSTR(PrepareDate, "yND") +
          "_" + UUID;
 END {GetOldIdFilewUUID};

 PUBLIC PROCEDURE Get2NDFLFileName(GUID: STRING[]): STRING[];
  VAR
   D: DATE;
 BEGIN
  D:=GetDateFromDTStamp(DTStamp);
  IF Packet.PerB >= 01\01\2010 THEN
   RETURN GetIdFilewUUID("NO_NDFL2", GetTaxAgentMyFirm(), D, GUID);
  ELSE
   RETURN GetOldIdFilewUUID("_2", D, GUID);
  END;
 END {Get2NDFLFileName};

 PUBLIC PROCEDURE Get2NDFLXMLFileName(GUID: STRING[]): STRING[];
 BEGIN
  RETURN FIO.BuildPath(Get2NDFLFileName(GUID), "xml");
 END {Get2NDFLXMLFileName};

 PRIVATE PROCEDURE GetTrnFileNameFromPacket(_ATERAttr: LIKE(ATERAttr.ATERAttr)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(ATERAttr);
  L_General.CallUs(SELECT(ATERAttr, ATERAttr, Packet.ATER, _ATERAttr) &
                   SEARCH(PckATER, Table, Packet.Packet, ATERAttr.Table, 0000, 0000, ATERAttr.Row, ATERAttr.ATERAttr));
  Result:=PckATER.Value;
  RESTORE(ATERAttr);
  IF !L_FIO.effp_FileExt(Result) THEN
   Result:=FIO.BuildPath(Result, "xml");
  END;
  RETURN Result;
 END {GetTrnFileNameFromPacket};

 PRIVATE PROCEDURE GetTrnFileNameForv4(): STRING[];
 BEGIN
  RETURN GetTrnFileNameFromPacket("");
 END {GetTrnFileNameForv4};

 PRIVATE PROCEDURE GetTrnFileNameForv3(): STRING[];
  VAR
   D: DATE;
 BEGIN
  D:=GetDateFromDTStamp(DTStamp);
  RETURN "O" + P_Firm.FP_INN(GetPacketOwnFirm(), Packet.PerE)         + "_" +
               P_Firm.FP_KPP(GetPacketOwnFirm(), Packet.PerE)         + "_" +
               P_MyFirm.IntermedTaxDepCode(Packet.MyFirm, D)          +
               P_MyFirm.TaxDepCode(Packet.MyFirm, D)                  + "_" +
               FLDTOSTR(Packet.PerB, "Y")                             + "_" +
               L_Str.FixedIntStr(STRTOFLD(Packet.ExtNbr, NUMERIC), 8)       + ".txt";
 END {GetTrnFileNameForv3};

 PUBLIC PROCEDURE GetTransportFileName(): STRING[];
  VAR
   GUID,
   Result: STRING[];
 BEGIN
  IF    Packet.Receiver = rcv_PensFund THEN
   Result:=GetPacketAttr(Packet.Packet, patt_FileName);
   IF !Result THEN
    Result:=trnFileName();
   END;
   RETURN Result;
  ELSIF Packet.Receiver = rcv_TaxDep THEN
   IF Packet.PerB >= 01\01\2005 THEN
    GUID:=GetPacketAttr(Packet.Packet, patt_GUID);
    L_General.Assert(~!GUID, " ᪮஢ 䠩. 室 ନ஢ .|"+
                             "᫨ 訡 㤥 ,   ࠡ稪");
    RETURN Get2NDFLXMLFileName(GUID);
   ELSE
    RETURN PacketT3ShortName("S", Packet.ExtNbr, "TXT");
   END;
  ELSIF Packet.Receiver = rcv_e_TaxDep THEN
   CONFORM(Packet, ATER);
   IF    ATER.Kind = knd_FSS_Sheet THEN
    RETURN P_MyFirm.FSSRegistrationCode(Packet.MyFirm, Packet.PerE) + "_" +
           L_Str.IntStr(L_DatTim.YEAR(Packet.PerE)) + "_" +
           GetPerSign() + ".xml";
   ELSIF ATER.Kind = knd_RSV_1 THEN
    RETURN GetTrnFileNameFromPacket("");
   ELSIF ATER.Kind = knd_AvgCnt THEN
    RETURN GetTrnFileNameFromPacket("");
   ELSIF ATER.Version >= "4.00000" THEN
    RETURN GetTrnFileNameForv4();
   ELSE
    RETURN GetTrnFileNameForv3();
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetTransportFileName};

 PUBLIC PROCEDURE GetPacketTrnFileName(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF    Packet.Receiver = rcv_PensFund THEN
   Result:=PacketTrnFullName(Packet.Receiver);
  ELSIF Packet.Receiver = rcv_TaxDep THEN
   IF Packet.PerB >= 01\01\2005 THEN
    Result:=Packet2NDFLTrnFileName();
   ELSE
    Result:=PacketT3FullName("S", Packet.ExtNbr, "TXT");
   END;
  ELSIF Packet.Receiver = rcv_e_TaxDep THEN
   Result:=PacketTrnFullName(Packet.Receiver);
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {GetPacketTrnFileName};

 PRIVATE PROCEDURE CheckIsAcceptableToCopyPacket(SrcFullFileName, DstFullFileName: STRING[]);
  VAR
   Msg: STRING[];
 BEGIN
  SETEMPTY(Msg);
  IF    ~!Packet.ATER & ~L_ATER.IsAcceptableFormatATER(Packet.ATER) THEN
   Msg:="騩 ଠ .";
  ELSIF Packet.Status = st_Done THEN
   IF    FIO.Exists(SrcFullFileName) THEN
    Msg:=" 㦥 ᤠ, ᮧ ࠭ᯮ⭮ 䠩 .";
   ELSIF FIO.Exists(DstFullFileName) THEN
    Msg:=" 㦥 ᤠ, ࠭ᯮ 䠩|" + DstFullFileName + "|㦥 .";
   END;
  END;
  L_General.Assert(!Msg, Msg + "||" +
                         "᫨  ⢨⥫쭮 室 믮  ,|" +
                         "  ");
 END {CheckIsAcceptableToCopyPacket};

 PRIVATE PROCEDURE CreateSingleTransportFile(ExtPrgPath: STRING[]; VAR tf_List: STRING[]; OnlyCheck: SCAL[2]);
  VAR
   DestFile,
   FullDestFile,
   FullTrnFile : STRING[];
 BEGIN
  FullTrnFile :=GetPacketTrnFileName();
  DestFile    :=GetTransportFileName();
  FullDestFile:=FIO.BuildPath(DestFile, "", ExtPrgPath);
  CheckIsAcceptableToCopyPacket(FullTrnFile, FullDestFile);

  IF ~OnlyCheck THEN
   IF Packet.Receiver = rcv_e_TaxDep THEN
    CALL(ATER_Lnc.CreateTransportFile());
   END;
 
   L_FIO.ExactFileCopy(FullTrnFile, FullDestFile);
   tf_List:=tf_List + DestFile + "|";
  END;
  END {CreateSingleTransportFile};

 PRIVATE PROCEDURE CreateTransportFiles(ExtPrgPath: STRING[]; VAR tf_List: STRING[]; OnlyCheck: SCAL[2]);
 BEGIN
  SETEMPTY(DTStamp, tf_List);
  IF Packet.Receiver = rcv_e_TaxDep THEN
   CreateSingleTransportFile(ExtPrgPath, tf_List, OnlyCheck);
   DTStamp:=GetPFRDTStampFromRSV();
  ELSE
   DTStamp:=Packet.DTStamp;
  END;
  IF ~!DTStamp THEN
   SAVE(Packet);
   SELECT(Packet, PckDTSPk, , rcv_PensFund, DTStamp);
   WHILE OCCURE(Packet) DO
    CreateSingleTransportFile(ExtPrgPath, tf_List, OnlyCheck);
    NEXT(Packet);
   END; (* WHILE OCCURE(Packet) ... *)
   RESTORE(Packet);
  END;
 END {CreateTransportFiles};

 PUBLIC PROCEDURE CopyPacketTrn();
  CONST
   ExtPrgId = "ExtPacketTransferPrgPath";
  VAR
   i, rd_Idx         : NUMERIC[0];
   fso, Drive        : OBJECT;
   Drives            : ENUMERATOR;
   tmpPath,
   DestFile,
   tf_List,
   rd_Pool,
   b_Place,
   b_Caption,
   ExtPrgPath,
   trgNameMask,
   rd_ShareName,
   be_RemovableDevice: STRING[];
   rd_Name           : STRING[][200];
   rd_FreeSpace      : NUMERIC[2][100];
   ChooseDir         : CHOOSEFILEDIALOG;
   tf_Amount,
   ChooseButton      : NUMERIC[0];
   PFRPacketsDTStamp : TIMESTAMP;
 BEGIN
  DefinePckMyFirm(bm_byPacket);
  IF Packet.Receiver = rcv_e_TaxDep THEN
   b_Caption:="";
   b_Place  :="%#######%";
  ELSE
   L_General.Assert(FIO.Exists(GetPacketTrnFileName()), "  ࠭ᯮ 䠩   " + Packet.Packet);
   b_Caption:= "   祪  ⠪ ⠬";
   b_Place  :="%######################################%";
  END;

  SETEMPTY(rd_Name, rd_FreeSpace, rd_Pool);
  fso   :=CreateOBJECT("Scripting.FileSystemObject");
  Drives:=CreateENUMERATOR(fso.Drives);
  i     :=0;
  WHILE ~Drives.AtEnd() DO
   Drive:=Drives.Item();
   IF (Drive.DriveType = 1(*ᬥ*) ) & Drive.IsReady THEN
    TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
     rd_ShareName:=Drive.ShareName;
    EXCEPT
    ON Exc: Exc_Root DO
     SETEMPTY(rd_ShareName);
    END;
    rd_Name[i]     :=Drive.DriveLetter + ":\";
    rd_FreeSpace[i]:=Drive.AvailableSpace;
    rd_Pool        :=rd_Pool + Drive.DriveLetter + ": " + rd_ShareName + "|";
    INC(i);
   END;
   Drives.MoveNext();
  END; (* WHILE ~Drives.AtEnd()...*)
  IF !rd_Pool THEN
   be_RemovableDevice:="N";
   rd_Pool           :=" 㯭 ᬥ ᪮|";
  ELSE
   be_RemovableDevice:="";
   rd_Pool           :="|" + rd_Pool;
  END;

  IF ~L_SES.GetValue(L_SES.sit_Station, ExtPrgId, ExtPrgPath) THEN
   ExtPrgPath:="";
  END;

  ChooseDir:=CHOOSEFILEDIALOG.Create("");
  ChooseDir.FilesAreAcceptable  :=0;
  ChooseDir.FoldersAreAcceptable:=1;

  rd_Idx:=0;
  LOOP
   ChooseButton:=STDFORM(L_StdFrm.PartForm("%LYI %<...>B"+
                                           "%L<" + rd_Pool + ">" + be_RemovableDevice + "I" +
                                           "%<" + b_Caption +  ">DB" +
                                           "%<ᬮ 䠩>B"+
                                           "%<⬥>X"+
                                           "@"+
                                           "| ࠭ ࠭ᯮ⭮ 䠩                          "+
                                           "|%################################################% %###%    "+
                                           "|஢  ᬥ                                  "+
                                           "|%################################################%          "+
                                           "|"+
                                           "|" + b_Place + "   %###############%   %########%"),
                         " ࠭ᯮ⭮ 䠩",
                         ,
                         -1,
                         ExtPrgPath, rd_Idx);
   IF    ChooseButton = 1 THEN
    IF    !ExtPrgPath THEN
     trgNameMask:=CHOOSEFILEDIALOG.NameMask_Drives;
    ELSIF ~FIO.DirExists(ExtPrgPath) THEN
     L_StdFrm.RedInform(" " + ExtPrgPath + "  .||" +
                        ",  뫠 㤠  २");
     trgNameMask:=CHOOSEFILEDIALOG.NameMask_Drives;
    ELSE
     trgNameMask:=FIO.BuildPath("", "", ExtPrgPath);
    END;
    ChooseDir.NameMask:=trgNameMask;
    tmpPath:=ChooseDir.Deal();
    IF ~!tmpPath THEN
     ExtPrgPath:=tmpPath;
    END;
   ELSIF ChooseButton = 2 THEN
    IF !ExtPrgPath & (!rd_Idx | (rd_Idx = 0)) THEN
     L_StdFrm.RedInform(" 㪠  ࠭ ࠭ᯮ⭮ 䠩");
    ELSE
     IF Packet.Kind = knd_PF_RSV1_6 THEN
      L_General.Error('࠭ᯮ 䠩 ࠧ 6  -1  ᮧ ⮬᪨|' +
                      ' ନ஢ ࠭ᯮ⭮ 䠩   -1|' +
                      '("F10 - 壠 - ⮣ -   壠᪠ ⭮")');
     END;
     IF ~FIO.DirExists(ExtPrgPath) THEN
      L_StdFrm.Question(" " + ExtPrgPath + "  .||?");
      L_FIO.MakeSubDirs(ExtPrgPath);
     END;

     L_SES.PutValueAtSlaveTrn(L_SES.sit_Station, ExtPrgId, ExtPrgPath);

     CreateTransportFiles(ExtPrgPath, tf_List, 1);
     CreateTransportFiles(ExtPrgPath, tf_List, 0);

     IF ~!tf_List THEN
      IF rd_Idx # 0 THEN
       LOOP
        DestFile:=L_Str.PoolItem(tf_List, i);
        IF !DestFile THEN
         EXIT;
        END;
        CondZipTransportFile(TrnFile, FIO.BuildPath(DestFile, "", rd_Name[rd_Idx-1]), rd_FreeSpace[rd_Idx-1]);
        INC(i);
       END; (* LOOP *)
      END;
      L_StdFrm.Inform(L_Str.PoolItem(" ࠭ᯮ 䠩:| ࠭ᯮ 䠩:", L_Str.CntItemsInPool(tf_List) > 1) + "||" +
                      tf_List);
     END;

     EXIT;
    END;
   ELSIF ChooseButton = 3 THEN
    ShowPacketFiles(fp_Trn);
    EXIT;
   END;
  END; (*LOOP *)
 END {CopyPacketTrn};

 PUBLIC PROCEDURE GetATERAttrFormat(): STRING[];
 BEGIN
  IF    ATERAttr.Type = L_General.ft_NUMERIC THEN
   IF (ATERAttr.Format = 0) THEN
    RETURN L_Str.IntStr(ATERAttr.Format);
   ELSE
    RETURN L_Str.IntStr(ATERAttr.Format) + ".";
   END;
  ELSIF ATERAttr.Type = L_General.ft_DATE THEN
   RETURN "D.N.y";
  ELSE
   RETURN "";
  END;
 END {GetATERAttrFormat};

 PUBLIC PROCEDURE ConvATERAttrValue(_Value: STRING[]): STRING[];
  VAR
   _Format: STRING[];
 BEGIN
  IF ~!_Value THEN
   _Format:=GetATERAttrFormat();
   IF    ATERAttr.Type = L_General.ft_NUMERIC THEN
(* ࠭ 譮  㣫 -  ८ࠧ*)
    L_Prop.CheckNumericValue(_Value, _Format);
    RETURN _Value;
   ELSIF ATERAttr.Type = L_General.ft_DATE THEN
    L_Prop.CheckDateValue(_Value, _Format);
    IF FSS_SheetwXML(ATERAttr.ATER) THEN
     RETURN FLDTOSTR(STRTOFLD(_Value, DATE), "y-N-D");
    ELSE
     RETURN FLDTOSTR(STRTOFLD(_Value, DATE), _Format);
    END;
   END;
  END;
  RETURN _Value;
 END {ConvATERAttrValue};

 PUBLIC PROCEDURE GetATERDescr(VAR MainTemplate       : STRING[];
                               VAR MultiTables        : LIKE(ATERAttr.Table)[];
                               VAR Templates          : STRING[][];
                               VAR NeedInsertPageBreak: STRING[][];
                               VAR wUseTmpDot         : SCAL[2]);
  VAR
   i     : NUMERIC[0];
   tmpVal: STRING[];
 BEGIN
  SETEMPTY(MultiTables, Templates, NeedInsertPageBreak);
  MainTemplate:=L_Str.AnyItem(ATER.Descr, ";", 0);
  i:=0;
  LOOP
   tmpVal:=L_Str.AnyItem(ATER.Descr, ";", i+1);
   IF !tmpVal THEN
    EXIT;
   END;
   MultiTables[i]        :=L_Str.AnyItem(tmpVal, ",", 0);
   Templates[i]          :=L_Str.AnyItem(tmpVal, ",", 1);
   NeedInsertPageBreak[i]:=L_Str.AnyItem(tmpVal, ",", 2);
   L_General.CallUs(!MultiTables[i] | (i < HIGH(MultiTables)));
   INC(i);
  END; (* LOOP *)
  wUseTmpDot:=~L_Prop.IsEmptyStrArray(Templates);
 END {GetATERDescr};

 PUBLIC PROCEDURE ClearATER(TotalClear: SCAL[2]);
  VAR
   Msg: STRING[];
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭  ⭮");
  L_General.Assert(Packet.Status = st_InProcess, " ( "+Packet.Packet+")  ﭨ '" + L_Str.PoolItem(st_Pool, Packet.Status) + "'");
  CONFORM(Packet, ATER);
  IF    SELECT(PckATER, PckATER, Packet.Packet) THEN
   Msg:="⪠    ⭮ '" + L_Str.PoolItem(knd_Pool, ATER.Kind) + "'" +
        "||" +
        " ਮ  " + L_DatTim.PeriodStr(Packet.PerB) + "  " + L_DatTim.PeriodStr(Packet.PerE);
   IF TotalClear THEN
    L_StdFrm.Choice(Msg + L_StdFrm.HR() + "  (  )   㤠!");
   ELSE
    L_StdFrm.Question(Msg + L_StdFrm.HR() + "    㤠");
   END;
   WHILE OCCURE(PckATER) DO
    PROMPT(" "  + PckATER.Table2 + " " + PckATER.Row2 + " " + PckATER.ATERAttr);
    IF TotalClear | (PckATER.Source = src_System) THEN
     REMOVE(PckATER);
    ELSE
     NEXT(PckATER);
    END;
   END; (* WHILE OCCURE(PckATER)...*)
   PROMPT("");
  ELSIF TotalClear THEN
   L_StdFrm.Inform(" ");
  END;
 END {ClearATER};

 PUBLIC PROCEDURE PutSingleValueInPacket(_Table2: LIKE(ATERAttr.Table);
                                         _Row2  : LIKE(ATERAttr.Row);
                                         _Value : STRING[];
                                         _Source: LIKE(PckATER.Source));
 BEGIN
  IF ~SEARCH(PckATER, Table, Packet.Packet, ATERAttr.Table, _Table2, _Row2, ATERAttr.Row, ATERAttr.ATERAttr) THEN
   DEFAULT(PckATER);
   PckATER.Packet  :=Packet.Packet;
   PckATER.ATER    :=Packet.ATER;
   PckATER.Table   :=ATERAttr.Table;
   PckATER.Table2  :=_Table2;
   PckATER.Row     :=ATERAttr.Row;
   PckATER.Row2    :=_Row2;
   PckATER.Column  :=ATERAttr.Column;
   PckATER.ATERAttr:=ATERAttr.ATERAttr;
   PckATER.Source  :=_Source;
   PckATER.Value   :=_Value;
   INSERT(PckATER);
  ELSE
   L_General.CallUs(PckATER.Source = src_Operator);
  END;
 END {PutSingleValueInPacket};

 PUBLIC PROCEDURE PutManualInputATERAttr();
 BEGIN
  SELECT(ATERAttr, ATER, , Packet.ATER);
  WHILE OCCURE(ATERAttr) DO
   IF ATERAttr.Kind = L_ATER.aak_ManualInput THEN
    PutSingleValueInPacket(00000, 00000, "", src_Operator);
   END;
   NEXT(ATERAttr);
  END; (* WHILE OCCURE(ATERAttr) ... *)
 END {PutManualInputATERAttr};

 PUBLIC PROCEDURE AccessATERAttrByPublicName(pn: STRING[]): SCAL[2];
 BEGIN
  RETURN SELECT(ATERAttr, PublicNm, Packet.ATER, pn);
 END {AccessATERAttrByPublicName};

 PUBLIC PROCEDURE StandOnATERAttrByPublicName(pn: STRING[]);
 BEGIN
  PROMPT(" " + pn);
  L_General.CallUs(AccessATERAttrByPublicName(pn));
 END {StandOnATERAttrByPublicName};

 PRIVATE PROCEDURE psf(    pn     : STRING[];
                       VAR Value  : VARIANT;
                           _Table2: LIKE(ATERAttr.Table);
                           _Row2  : LIKE(ATERAttr.Row);
                           _Source: LIKE(PckATER.Source));
 BEGIN
  StandOnATERAttrByPublicName(pn);
  PROMPT("㧪 " + ATERAttr.Table + " " + pn);
  PutSingleValueInPacket(_Table2, _Row2, FLDTOSTR(Value, GetATERAttrFormat()), _Source);
 END {psf};

 PUBLIC PROCEDURE psf_Str(pn, Value: STRING[]; _Table2: LIKE(ATERAttr.Table); _Row2: LIKE(ATERAttr.Row));
 BEGIN
  psf(pn, Value, _Table2, _Row2, src_System);
 END {psf_Str};

 PUBLIC PROCEDURE ext_psf_Str(pn, Value: STRING[]; _Table2: LIKE(ATERAttr.Table); _Row2: LIKE(ATERAttr.Row));
 BEGIN
  psf(pn, Value, _Table2, _Row2, src_Operator);
 END {ext_psf_Str};

 PUBLIC PROCEDURE ext_psf_Num(pn     : STRING[];
                              Value  : FLOAT;
                              _Table2: LIKE(ATERAttr.Table);
                              _Row2  : LIKE(ATERAttr.Row);
                              _Source: LIKE(PckATER.Source));
 BEGIN
  psf(pn, Value, _Table2, _Row2, _Source);
 END {ext_psf_Num};

 PUBLIC PROCEDURE psf_Num(pn     : STRING[];
                          Value  : FLOAT;
                          _Table2: LIKE(ATERAttr.Table);
                          _Row2  : LIKE(ATERAttr.Row));
 BEGIN
  psf(pn, Value, _Table2, _Row2, src_System);
 END {psf_Num};

 PUBLIC PROCEDURE psf_Dat(pn     : STRING[];
                          Value  : DATE;
                          _Table2: LIKE(ATERAttr.Table);
                          _Row2  : LIKE(ATERAttr.Row));
 BEGIN
  psf(pn, Value, _Table2, _Row2, src_System);
 END {psf_Dat};

 PUBLIC PROCEDURE CheckActualPacketInPer();
 BEGIN
  IF Packet.Status # st_Canceled THEN
   CONFORM(Packet, ATER);
   L_General.Assert(~!Packet.PerB, "   砫 ⭮ ਮ ");
   L_General.Assert(~!Packet.PerE, "    ⭮ ਮ ");
   IF    ATER.Till < Packet.PerB THEN
    L_General.Error(" ଠ  ⭮ " + ATER.Version + "|   ⭮ ਮ.|" +
                    ",     ");
   ELSIF L_DatTim.IsActive_Inc(ATER.Till, Packet.PerB, Packet.PerE) THEN
    L_General.Error(" ଠ  ⭮ " + ATER.Version + "|" +
                    "  ⭮ ਮ.|" +
                    ",     ");
   ELSIF ~L_DatTim.IsActiveInIntvl_Inc(ATER.Begin, ATER.Till, Packet.PerB, Packet.PerE) THEN
    L_General.Error(" ଠ  ⭮ " + ATER.Version + "|" +
                    "    ⭮ ਮ.|" +
                    ",   ࠭  ");
   END;
  END; (* IF Packet.Status... *)
 END {CheckActualPacketInPer};

 PRIVATE PROCEDURE GetPacketKindActualPer(trgKind: LIKE(Packet.Kind); VAR KindB, KindE: DATE);
 BEGIN
  IF    (trgKind = knd_PF_ADV1) |
        (trgKind = knd_PF_ADV2) |
        (trgKind = knd_PF_ADV3) THEN
   KindB:=01\01\1996;
   KindE:=MAXOF(DATE);
  ELSIF (trgKind = knd_PF_SZV1) THEN
   KindB:=01\01\1996;
   KindE:=31\12\2000;
  ELSIF (trgKind = knd_PF_SZV3) THEN
   KindB:=01\01\2001;
   KindE:=31\12\2001;
  ELSIF (trgKind = knd_PF_SZV4) THEN
   KindB:=01\01\2002;
   KindE:=31\12\2009;
  ELSIF (trgKind = knd_PF_SZV6) THEN
   KindB:=01\01\2010;
   KindE:=31\12\2012;
  ELSIF (trgKind = knd_PF_SZVK) THEN
   KindB:=01\01\1900;
   KindE:=31\12\2001;
  ELSIF (trgKind = knd_PF_ADV10) THEN
   KindB:=01\01\1996;
   KindE:=31\12\2001;
  ELSIF (trgKind = knd_PF_ADV11) THEN
   KindB:=01\01\2002;
   KindE:=31\12\2009;
  ELSIF (trgKind = knd_PF_ADV6_2) THEN
   KindB:=01\01\2010;
   KindE:=MAXOF(DATE);
  ELSIF (trgKind = knd_PF_DSV1) THEN
   KindB:=01\01\2008;
   KindE:=MAXOF(DATE);
  ELSIF (trgKind = knd_PF_DSV3) THEN
   KindB:=01\01\2009;
   KindE:=MAXOF(DATE);
  ELSIF (trgKind = knd_PF_SPV1) THEN
   KindB:=01\01\2010;
   KindE:=31\12\2013;
  ELSIF (trgKind = knd_PF_SZV6_3) THEN
   KindB:=01\01\2011;
   KindE:=31\12\2012;
  ELSIF (trgKind = knd_PF_SZV6_4) THEN
   KindB:=01\01\2013;
   KindE:=31\12\2013;
  ELSIF (trgKind = knd_PF_RSV1_6) THEN
   KindB:=01\01\2014;
   KindE:=EMPTYOF(DATE);
  ELSIF (trgKind = knd_PF_SPV2) THEN
   KindB:=01\01\2014;
   KindE:=EMPTYOF(DATE);
  ELSE
   L_General.CallUs(0);
  END;
 END {GetPacketKindActualPer};

 PUBLIC PROCEDURE CheckActual_PF_PacketInPer();
  VAR
   KindB,
   KindE: DATE;
   PerStr: STRING[];
 BEGIN
  GetPacketKindActualPer(Packet.Kind, KindB, KindE);
  IF ~L_DatTim.InPatIntvl(KindB, KindE, Packet.PerB, Packet.PerE) THEN
   PerStr:="ਮ ⢨  "+L_DatTim.DateStr(KindB);
   IF ~!KindE THEN
    PerStr:=PerStr+"  "+L_DatTim.DateStr(KindE);
   END;
   L_General.Error("ଠ ⭮ "+L_Str.PoolItem(knd_Pool, Packet.Kind)+" ("+PerStr+")|"+
                   " ਬ  ਮ  c "+L_DatTim.DateStr(Packet.PerB)+"  "+L_DatTim.DateStr(Packet.PerE));
  END;
 END {CheckActual_PF_PacketInPer};

 PUBLIC PROCEDURE Get_PF_PacketKind(trgPerB, trgPerE: DATE; trgDataType: LIKE(Packet.DataType); trgCorrType: LIKE(Packet.CorrType)): LIKE(Packet.Kind);
 BEGIN
  IF (trgPerB = 01\01\1900) & (trgPerE = 31\12\2001) THEN
   RETURN knd_PF_SZVK;
  ELSIF (trgDataType = dt_None) & (trgCorrType = ct_None) THEN
   IF    trgPerB >= 01\01\2014 THEN
    RETURN EMPTYOF(Packet.Kind);
   ELSIF trgPerB >= 01\01\2010 THEN
    IF (trgPerB = 01\01\2010) & (trgPerE = 31\12\2010) THEN
     RETURN knd_PF_ADV11;
    ELSE
     RETURN knd_PF_ADV6_2;
    END;
   ELSIF trgPerB >= 01\01\2002 THEN
    RETURN knd_PF_ADV11;
   ELSE
    RETURN knd_PF_ADV10;
   END;
  ELSE
   IF    trgPerB >= 01\01\2014 THEN
    RETURN knd_PF_RSV1_6;
   ELSIF trgPerB >= 01\01\2013 THEN
    RETURN knd_PF_SZV6_4;
   ELSIF trgPerB >= 01\01\2010 THEN
    RETURN knd_PF_SZV6;
   ELSIF trgPerB >= 01\01\2002 THEN
    RETURN knd_PF_SZV4;
   ELSIF trgPerB >= 01\01\2001 THEN
    RETURN knd_PF_SZV3;
   ELSE
    RETURN knd_PF_SZV1;
   END;
  END;
 END {Get_PF_PacketKind};

 PUBLIC PROCEDURE MustBeOnlyOneDonePacketStamp(): SCAL[2];
 BEGIN
  IF Packet.Receiver = rcv_PensFund THEN
   RETURN (Packet.DataType = dt_Basic) & (Packet.CorrType = ct_None) &
          (Packet.Kind = Get_PF_PacketKind(Packet.PerB, Packet.PerE, Packet.DataType, Packet.CorrType));
  ELSE
   RETURN 0;
  END;
 END {MustBeOnlyOneDonePacketStamp};

 PUBLIC PROCEDURE IsSamplePacket(): SCAL[2];
 BEGIN
  RETURN (Packet.Receiver = rcv_PensFund) & (Packet.DTStamp = SampleDTStamp);
 END {IsSamplePacket};

 PUBLIC PROCEDURE SetSamplePacketDone();
 BEGIN
  L_General.CallUs(IsSamplePacket());
  Packet.Status:=st_Done;
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_Packet, L_XDoc.EmptyXDocKind, Packet.Packet, L_XDoc.action_AutoEdit);
  REPLACE(Packet);
 END {SetSamplePacketDone};

 PUBLIC PROCEDURE PositionOnPacket(_Packet: LIKE(Packet.Packet));
 BEGIN
  L_General.CallUs(SEARCH(Packet, Packet, _Packet));
 END {PositionOnPacket};

 PRIVATE PROCEDURE intInsPacket(trgPacket  : LIKE(Packet.Packet);
                                trgKind    : LIKE(Packet.Kind);
                                trgATER    : LIKE(Packet.ATER);
                                trgReceiver: LIKE(Packet.Receiver);
                                trgMyFirm  : LIKE(Packet.MyFirm);
                                trgMyPlace : LIKE(Packet.MyPlace);
                                trgExtNbr  : LIKE(Packet.ExtNbr);
                                trgPrpDate : LIKE(Packet.PrpDate);
                                trgDTStamp : LIKE(Packet.DTStamp);
                                trgPerB    : LIKE(Packet.PerB);
                                trgPerE    : LIKE(Packet.PerE);
                                trgDataType: LIKE(Packet.DataType);
                                trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  DEFAULT(Packet);
  Packet.Packet  :=trgPacket;
  Packet.Kind    :=trgKind;
  Packet.ATER    :=trgATER;
  Packet.Receiver:=trgReceiver;
  Packet.MyFirm  :=trgMyFirm;
  Packet.MyPlace :=trgMyPlace;
  Packet.ExtNbr  :=trgExtNbr;
  Packet.PrpDate :=trgPrpDate;
  Packet.DTStamp :=trgDTStamp;
  Packet.PerB    :=trgPerB;
  Packet.PerE    :=trgPerE;
  Packet.DataType:=trgDataType;
  Packet.CorrType:=trgCorrType;

  Packet.Status  :=st_Prepared;
  SETZERO(Packet.Sums);
  INSERT(Packet);
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_Packet, L_XDoc.EmptyXDocKind, Packet.Packet, L_XDoc.action_AutoBuild);
 END {intInsPacket};

 PRIVATE PROCEDURE intInsPFPacket(trgPacket  : LIKE(Packet.Packet);
                                  trgKind    : LIKE(Packet.Kind);
                                  trgExtNbr  : LIKE(Packet.ExtNbr);
                                  trgPrpDate : LIKE(Packet.PrpDate);
                                  trgDTStamp : LIKE(Packet.DTStamp);
                                  trgPerB    : LIKE(Packet.PerB);
                                  trgPerE    : LIKE(Packet.PerE);
                                  trgDataType: LIKE(Packet.DataType);
                                  trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  intInsPacket(trgPacket, trgKind, EMPTYOF(Packet.ATER), rcv_PensFund, PckMyFirm, EMPTYOF(Packet.MyPlace),
               trgExtNbr, trgPrpDate, trgDTStamp, trgPerB, trgPerE, trgDataType, trgCorrType);
  CheckActual_PF_PacketInPer();
 END {intInsPFPacket};

 PUBLIC PROCEDURE InsSamplePFPacket(trgKind    : LIKE(Packet.Kind);
                                    trgPerB    : LIKE(Packet.PerB);
                                    trgPerE    : LIKE(Packet.PerE);
                                    trgDataType: LIKE(Packet.DataType);
                                    trgCorrType: LIKE(Packet.CorrType));
 BEGIN
  intInsPFPacket(EMPTYOF(Packet.Packet), trgKind, EMPTYOF(Packet.ExtNbr), EMPTYOF(Packet.PrpDate), SampleDTStamp,
                 trgPerB, trgPerE, trgDataType, trgCorrType);
 END {InsSamplePFPacket};

 PUBLIC PROCEDURE InsPFPacket(trgKind    : LIKE(Packet.Kind);
                              trgExtNbr  : LIKE(Packet.ExtNbr);
                              trgPerB    : LIKE(Packet.PerB);
                              trgPerE    : LIKE(Packet.PerE);
                              trgDataType: LIKE(Packet.DataType);
                              trgCorrType: LIKE(Packet.CorrType));
  VAR
   trgPacket: LIKE(Packet.Packet);
 BEGIN
  IF BuildMode = bm_bySingle THEN
   trgPacket:=0000000;
  ELSE
   trgPacket:=EMPTYOF(Packet.Packet);
  END;
  intInsPFPacket(trgPacket, trgKind, trgExtNbr, PrepareDate, DTStamp, trgPerB, trgPerE, trgDataType, trgCorrType);
 END {InsPFPacket};

 PUBLIC PROCEDURE InsIncTaxPacket(trgExtNbr: LIKE(Packet.ExtNbr); trgMyPlace: LIKE(Packet.MyPlace); trgPerB, trgPerE: DATE);
 BEGIN
  intInsPacket(EMPTYOF(Packet.Packet), knd_TD_IncTax, EMPTYOF(Packet.ATER), rcv_TaxDep, PckMyFirm, trgMyPlace,
               trgExtNbr, EMPTYOF(Packet.PrpDate), EMPTYOF(Packet.DTStamp), trgPerB, trgPerE, dt_None, ct_None);
 END {InsIncTaxPacket};

 PUBLIC PROCEDURE DTStampStr(trgDTStamp: LIKE(Packet.DTStamp)): STRING[];
 BEGIN
  RETURN FLDTOSTR(trgDTStamp, "0000.00.00 00:00:00");
 END {DTStampStr};

 PUBLIC PROCEDURE PacketDTStampStr(): STRING[];
 BEGIN
  IF IsSamplePacket() THEN
   RETURN "      ࠧ      ";
  ELSE
   RETURN DTStampStr(Packet.DTStamp);
  END;
 END {PacketDTStampStr};

 PUBLIC PROCEDURE ChoosePacket(trgKind: LIKE(Packet.Kind);
                               PerB, PerE: DATE;
                               trgDataType: LIKE(Packet.DataType);
                               trgCorrType: LIKE(Packet.CorrType)): SCAL[2];
  VAR
   S            : STRING[];
   Choice,
   i            : NUMERIC[0];
   AlreadyPacket: LIKE(Packet.Packet);
   Packets      : LIKE(Packet.Packet)[100];
 BEGIN
  SETEMPTY(AlreadyPacket, Packets);
  S:="";
  i:=0;
  SELECT(Packet, PacketKn, , rcv_PensFund, trgKind);
  WHILE OCCURE(Packet) DO
   IF IsAcceptablePacket() &
      (!PerB | ((Packet.PerB = PerB) & (Packet.PerE = PerE))) &
      (Packet.DataType = trgDataType) & (Packet.CorrType = trgCorrType) &
      (Packet.MyFirm = PckMyFirm) &
      (~IsSamplePacket() | (Packet.Status = st_Prepared)) THEN
    IF SEARCH(PckBody, Man, Man.Man, Packet.Packet) THEN
     IF ~!AlreadyPacket THEN
      L_StdFrm.RedInform(" 室  ᪮쪮 ⮢  ।   "+
                         "|室  冷");
      RETURN 0;
     ELSE
      AlreadyPacket:=Packet.Packet;
     END;
    END;
    IF IsSamplePacket() THEN
     Packets[i]:=Packet.Packet;
     CONFORM(Packet, MyFirm);
     S:=S+"  騩 -ࠧ ( "+Packet.Packet+")|";
     INC(i);
    END;
   END;
   NEXT(Packet);
  END; (* WHILE OCCURE(Packet) ... *)
  IF ~!AlreadyPacket THEN
   SEARCH(PckBody, Man, , Man.Man, AlreadyPacket);
   CONFORM(PckBody, Packet);
   L_StdFrm.Inform(" 㦥 祭  "+L_Str.PoolItem(" |-ࠧ ", IsSamplePacket())+"|"+Packet.ExtNbr+" ( "+Packet.Packet+")");
   RETURN 1;
  END;

  P_Firm.PositionOnMyFirm(PckMyFirm);

  Choice:=0;
  STDFORM(L_StdFrm.sf_Choice("%###############################################%"+L_Str.Repeat("|", i+1),
                              "%,"+FLDTOSTR(i+2, "")+"<쪮 ᬮ|" +
                              S +
                             "  -ࠧ>O"),
          " "+L_Str.PoolItem(knd_Pool, trgKind) + " " +MyFirm.vzSign+" ",
          , -1,
          Choice);

  IF Choice = 0 THEN
   RETURN 0;
  ELSE
   IF Choice <= i THEN
    PositionOnPacket(Packets[Choice-1]);
   ELSE
    IF !PerB THEN
     PerB:=SYSDATE();
    END;
    IF !PerE THEN
     PerE:=SYSDATE();
    END;
    InsSamplePFPacket(trgKind, PerB, PerE, trgDataType, ct_None);
   END;
   L_General.CLEAR("PckBody");
   PckBody.Packet  :=Packet.Packet;
   PckBody.SeqNbr  :="";
   PckBody.Man     :=Man.Man;
   INSERT(PckBody);
   L_StdFrm.Inform(" "+Man.Man+" "+Man.Name+"|㤥   -ࠧ "+L_Str.PoolItem(knd_Pool, trgKind)+" ( "+Packet.Packet+")");
  END;
  RETURN 1;
 END {ChoosePacket};

 PUBLIC PROCEDURE CheckMyFirmForMan(_Man: LIKE(Man.Man));
 BEGIN
  L_General.Assert(SEARCH(mfMan, Man, _Man, PckMyFirm), " "+_Man+"   ⭮襭  ' ࣠樨' "+PckMyFirm);
 END {CheckMyFirmForMan};

 PUBLIC PROCEDURE ShowMakedPackets();
  VAR
   TotalPacketAmount: NUMERIC[0];
 BEGIN
  TotalPacketAmount:=0;
  SELECT(Packet, PacketDS, , rcv_PensFund, DTStamp);
  WHILE OCCURE(Packet) DO
   INC(TotalPacketAmount);
   NEXT(Packet);
  END; (* WHILE OCCURE(Packet) ... *)
  IF TotalPacketAmount = 0 THEN
   L_StdFrm.Inform(" 室  ନ஢ ⮢");
  ELSE
   L_StdFrm.Inform(" ନ஢. ⢮ ⮢ - " + L_Str.IntStr(TotalPacketAmount) + "." +
                   "|"+
                   "४ " + FIO.FullPath(path_PFR) +
                   "|"+
                   " ᬮ /  -    'F9-  '");
   LIKEMENU(View, "Packet0 1", CALL, "Packet.PosToMakedPackets("+DTStamp+")");
  END;
 END {ShowMakedPackets};

 PUBLIC PROCEDURE IsAddMInsType(trgType: tMInsType): SCAL[2];
 BEGIN
  RETURN ~!Str.Condense(Str.Item(trgType, ";", 2));
 END {IsAddMInsType};

 PUBLIC PROCEDURE IsPAttMInsType(trgType: tMInsType): SCAL[2];
 BEGIN
  RETURN ~!Str.Condense(Str.Item(trgType, ";", 0));
 END {IsPAttMInsType};

 PUBLIC PROCEDURE IsOrdinaryType(trgType: tMInsType): SCAL[2];
 BEGIN
  RETURN ~IsAddMInsType(trgType) & ~IsPAttMInsType(trgType);
 END {IsOrdinaryType};

 PRIVATE PROCEDURE AddToTypePool(srcMInsType: tMInsType; thirdItem: STRING[]): tMInsType;
  VAR
   i: SCAL[2];
   tmpItem,
   Result: STRING[];
 BEGIN
  IF IsOrdinaryType(srcMInsType) THEN
   Result:=" ; ;"+thirdItem;
  ELSE
   Result:="";
   FOR_EACH i DO
    tmpItem:=Str.Item(srcMInsType, ";", i);
    IF !tmpItem THEN
     tmpItem:=" ";
    END;
    Result:=Result+tmpItem+";";
   END;
   Result:=Result+thirdItem;
  END;
  RETURN Result;
 END {AddToTypePool};

 PRIVATE PROCEDURE IsNotHarmCondition(D: DATE): SCAL[2];
  VAR
   curDirtyTyp         : LIKE(DirtyTyp.DirtyTyp);
   curSpecialEvaluation: P_Officer.tSpecialEvaluation;
 BEGIN
  SETSEL(StaffLog, TSN, StfLg.TSN);
  SRCINSEL(StaffLog, LE, , D);
  P_Officer.GetP_LabourConditions(StaffLog.Sort, StaffLog.Officer, L_DatTim.MonthEnd(D), curDirtyTyp, curSpecialEvaluation);
  IF curSpecialEvaluation THEN
   SEARCH(DirtyTyp, DirtyTyp, , curDirtyTyp);
   RETURN (DirtyTyp.Power = L_Staff.dtpwr_Optimal) | (DirtyTyp.Power = L_Staff.dtpwr_Acceptable);
  ELSE
   RETURN 0; (* ஢ ᯥ業 -     ।*)
  END;
 END {IsNotHarmCondition};

 PUBLIC PROCEDURE ext_E_SpecStageForPens(D: DATE; curJMode: LIKE(Sheet.JMode); pckKind: LIKE(Packet.Kind)): tMInsType;
  CONST
   ssfp_Ordinary = " ; ; ";
  VAR
   Result    : tMInsType;
   curPnsAttr: LIKE(PnsAttr.PnsAttr);
   curAddType: tMInsAddType;
   Local     : PROC;
 BEGIN
  Result:=ssfp_Ordinary;
  IF    curJMode = L_Sheet.jm_MaternityLeave       THEN Result:=" ; ;";
  ELSIF curJMode = L_Sheet.jm_ParentalLeave        THEN Result:=" ; ;";
  ELSIF curJMode = L_Sheet.jm_ParentalLeaveUntil3Y THEN
   IF D>=01\01\2010 THEN                                Result:=" ; ;";
   ELSE                                                 Result:=" ; ;";
   END;
  ELSIF curJMode = L_Sheet.jm_ChernobylLeave       THEN
   IF D>=01\01\2010 THEN                                Result:=" ; ;";
   END;
  ELSIF curJMode = L_Sheet.jm_ContractBreak(D)     THEN
                                                        Result:=EMPTYOF(tMInsType);
  END;
  IF Result = ssfp_Ordinary THEN
   curPnsAttr:=P_Staff.GetP_SpecificForPF(StfLg.TSN, D);
   IF !curPnsAttr THEN
    curPnsAttr:=StfLg.PnsAttr;
   END;
   IF curPnsAttr # OrdinaryPnsAttr THEN
    SAVE(PnsAttr);
    SEARCH(PnsAttr, PnsAttr, , curPnsAttr);
    IF D>=01\01\2002 THEN
     Result:=PnsAttr.Str2002;
    ELSE
     Result:=PnsAttr.Str;
    END;
    Result:=AddToTypePool(Result, " "); (*  饣   3 Item*)
    IF ~IsOrdinaryType(Result) THEN
     IF (D >= 01\01\2014) & IsNotHarmCondition(D) THEN
      Result:=ssfp_Ordinary;
     ELSE
      Local:=PROCREF(E_Staff.BreakPensSpecStage);
      IF ~!Local & Local(D, curJMode) THEN
       Result:=ssfp_Ordinary;
      END;
     END;
    END;
    RESTORE(PnsAttr);
   END;
  END;

  IF (D>=01\01\2002) & ~!Result THEN
   IF (curJMode = L_Sheet.jm_AnnualLeave) |
      (curJMode = L_Sheet.jm_AdditionalLeave) THEN
    IF (D>=01\01\2013) & (pckKind # knd_PF_SPV1) THEN (*13.05.2013 18:45:52 POLAK\Bor 0097363*)
     Result:=AddToTypePool(Result, "");
    END;
   ELSIF D>=01\01\2010 THEN
    curAddType:=E_Staff.SpecStage2ForPens(D, curJMode);
    IF ~!curAddType THEN
     IF    curAddType = miat_Disability THEN
      Result:=AddToTypePool(Result, "");
     ELSIF curAddType = miat_UnpaidLeave THEN
      Result:=" ; ;"; (*뢠 죮 ⠦*)
     ELSE
      L_General.CallUs(0);
     END;
    END;
    IF ~IsAddMInsType(Result) & ~!curJMode THEN
     SAVE(JMode);
     SEARCH(JMode, JMode, , curJMode);
     IF JMode.Type = L_Sheet.jmType_NonPAbsent THEN
      Result:=" ; ;";
     END;
     RESTORE(JMode);
    END; (* IF ~IsAddMInsType(Result) ... *)
   END; (* ELSIF D>=01\01\2010 ... *)
  END; (* IF (D>=01\01\2002) & ~!Result ... *)
  RETURN Result;
 END {ext_E_SpecStageForPens};

 PUBLIC PROCEDURE E_SpecStageForPens(D: DATE; curJMode: LIKE(Sheet.JMode)): tMInsType;
 BEGIN
  RETURN ext_E_SpecStageForPens(D, curJMode, EMPTYOF(Packet.Kind));
 END {E_SpecStageForPens};

 PUBLIC PROCEDURE CheckQuartalATER(    ManualMake          : SCAL[2];
                                   VAR IsFirstQuartalPacket: SCAL[2];
                                   VAR BPer                : DATE;
                                   VAR EPer                : DATE);
  VAR
   Msg           : STRING[];
   StandartPeriod: SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭ ");
  L_General.Assert(Packet.DataType = dt_None, "ନ஢    ");
  IsFirstQuartalPacket:=(L_DatTim.QUARTAL(Packet.PerB) = 0) & (L_DatTim.QUARTAL(Packet.PerE) = 0);
  BPer                :=Packet.PerB;
  EPer                :=L_DatTim.MonthEnd(Packet.PerE);
  CONFORM(Packet, ATER);
  CheckActualPacketInPer();

  IF ManualMake THEN
   IF ATER.Kind = knd_VAT THEN
    StandartPeriod:=(BPer = L_DatTim.GetFirstDateOfQuartal(BPer)) & L_DatTim.IsLastMonthOfQuartal(EPer);
    IF StandartPeriod THEN
     Msg:=" " +
          L_Str.PoolItem("I ⠫ " + L_Str.IntStr(L_DatTim.YEAR(EPer)) + " |" +
                         "II ⠫ " + L_Str.IntStr(L_DatTim.YEAR(EPer)) + " |" +
                         "III ⠫ " + L_Str.IntStr(L_DatTim.YEAR(EPer)) + " |" +
                         "IV ⠫ " + L_Str.IntStr(L_DatTim.YEAR(EPer)) + " ", L_DatTim.QUARTAL(EPer));
    ELSE
     Msg:=" ਮ c " +
          Str.Cap(L_DatTim.FullDateStr(BPer)) + "  " + Str.Cap(L_DatTim.FullDateStr(EPer));
    END;
   ELSE
    L_General.Assert(L_DatTim.MONTH(BPer) = 0, "⭮ ନ ⮫쪮  砫 ");
    StandartPeriod      :=L_DatTim.IsLastMonthOfQuartal(EPer) & (BPer = L_DatTim.YearBeg(EPer));
    IF StandartPeriod THEN
     Msg:=" " +
          L_Str.PoolItem("I ⠫ " + L_Str.IntStr(L_DatTim.YEAR(EPer)) + " |" +
                         "㣮 " + L_Str.IntStr(L_DatTim.YEAR(EPer)) + " |" +
                         "9 楢 " + L_Str.IntStr(L_DatTim.YEAR(EPer)) + " |" +
                         L_Str.IntStr(L_DatTim.YEAR(EPer)) + " ", L_DatTim.QUARTAL(EPer));
    ELSE
     Msg:=" ਮ c " +
          Str.Cap(L_DatTim.FullDateStr(BPer)) + "  " + Str.Cap(L_DatTim.FullDateStr(EPer));
    END;
   END; (* IF ATER.Kind ... *)
   L_StdFrm.Question("⮢ ⭮  ଥ|" + L_Str.PoolItem(knd_Pool, ATER.Kind) + "|" +  Msg);
   IF ~StandartPeriod THEN
    L_StdFrm.Choice(" ਮ|" + "c " + Str.Cap(L_DatTim.FullDateStr(BPer)) +
                    "  " + Str.Cap(L_DatTim.FullDateStr(EPer)) + "|  ⠭! த?");
   END;
  END;
 END {CheckQuartalATER};

 PUBLIC PROCEDURE IsValidPacket(): SCAL[2];
 BEGIN
  RETURN IsAcceptablePacket() &
        (Packet.MyFirm = PckMyFirm) &
        ~IsFictExtNbr(Packet.ExtNbr) &
        ~IsSamplePacket();
 END {IsValidPacket};

 PUBLIC PROCEDURE IsPersPacket(): SCAL[2];
 BEGIN
  RETURN (Packet.Receiver= rcv_PensFund) &
         ((Packet.Kind = Get_PF_PacketKind(Packet.PerB, Packet.PerE, dt_None,  ct_None)) |
          (Packet.Kind = Get_PF_PacketKind(Packet.PerB, Packet.PerE, dt_Basic, ct_None)));
 END {IsPersPacket};

 PUBLIC PROCEDURE Get_PF_StdPerB(D: DATE): DATE;
 BEGIN
  IF    D >= 01\01\2014 THEN
   RETURN L_DatTim.YearBeg(D);
  ELSIF D >= 01\01\2011 THEN
   RETURN L_DatTim.GetFirstDateOfQuartal(D);
  ELSIF D >= 01\07\2010 THEN
   RETURN 01\07\2010;
  ELSE
   RETURN L_DatTim.YearBeg(D);
  END;
 END {Get_PF_StdPerB};

 PUBLIC PROCEDURE Get_PF_StdPerE(D: DATE): DATE;
 BEGIN
  IF    D >= 01\01\2011 THEN
   RETURN L_DatTim.GetLastDateOfQuartal(D);
  ELSIF D >= 01\07\2010 THEN
   RETURN 31\12\2010;
  ELSIF D >= 01\01\2010 THEN
   RETURN 30\06\2010;
  ELSE
   RETURN L_DatTim.YearEnd(D);
  END;
 END {Get_PF_StdPerE};

 PUBLIC PROCEDURE Get_PF_PrvPer(VAR trgPerB, trgPerE: DATE);
 BEGIN
  L_General.CallUs(trgPerB = Get_PF_StdPerB(trgPerE));
  IF trgPerB >= 01\01\2014 THEN
   trgPerE:=L_DatTim.GetFirstDateOfQuartal(trgPerE)-1;
  ELSE
   trgPerE:=trgPerB-1;
  END;
  trgPerB:=Get_PF_StdPerB(trgPerE);
 END {Get_PF_PrvPer};

 PRIVATE PROCEDURE intGetDonePacketDTS(    tilPer: DATE;
                                      VAR Msg   : STRING[];
                                      VAR DTS   : TIMESTAMP);
  VAR
   trgPerB,
   trgPerE       : DATE;
   trgKind       : LIKE(Packet.Kind);
   PacketDTS     : LIKE(Packet.DTStamp);
   Recommendation: STRING[];
 BEGIN
  trgPerE:=tilPer-1;
  trgPerB:=Get_PF_StdPerB(trgPerE);

  Recommendation:=" 㪠 ࠢ쭮 ﭨ   ᢥ| ਮ  "+L_DatTim.PeriodStr(trgPerB)+"  "+L_DatTim.PeriodStr(trgPerE);

  SETEMPTY(PacketDTS, DTS, Msg);
  TRY [RESTORE_CURSORS(RC_ON)]
   trgKind:=Get_PF_PacketKind(trgPerB, trgPerE, dt_Basic, ct_None);
   SETSEL(Packet, PacketKn, rcv_PensFund, trgKind, trgPerB, trgPerE);
   FOR_EACH Packet DO
    IF IsValidPacket() & (Packet.Status = st_Done) & MustBeOnlyOneDonePacketStamp() THEN
     L_General.Assert(!PacketDTS | (PacketDTS = Packet.DTStamp),
                      " ਮ  "+L_DatTim.PeriodStr(trgPerB)+"  "+L_DatTim.PeriodStr(trgPerE)+
                      "  ᪮쪮 ⮢  ଥ "+L_Str.PoolItem(knd_Pool, trgKind)+
                      "  ﭨ '"+L_Str.PoolItem(st_Pool, Packet.Status)+"'"+
                      "| |⠬ "+PacketDTStampStr()+"  "+DTStampStr(PacketDTS)+
                      L_StdFrm.HR()+Recommendation);
     PacketDTS:=Packet.DTStamp;
    END; (* IF IsValidPacket() ... *)
   END; (* FOR_EACH Packet ... *)
  EXCEPT
  END; (* TRY *)

  IF ~!PacketDTS THEN
   DTS:=GetDTStampTIMESTAMP(PacketDTS);
  ELSE
   Msg:="  ᤠ ⮢  ଥ "+L_Str.PoolItem(knd_Pool, trgKind)+
        "  ਮ  "+L_DatTim.PeriodStr(trgPerB)+"  "+L_DatTim.PeriodStr(trgPerE)+L_StdFrm.HR()+Recommendation;
  END;
 END {intGetDonePacketDTS};

 PUBLIC PROCEDURE GetDonePacketDTS(tilPer: DATE): TIMESTAMP;
  VAR
   Msg   : STRING[];
   Result: TIMESTAMP;
 BEGIN
  intGetDonePacketDTS(tilPer, Msg, Result);
  IF ~!Msg THEN
   L_General.Error(Msg);
  END;
  RETURN Result;
 END {GetDonePacketDTS};

 PUBLIC PROCEDURE Get_PF_ProgressiveTotalPersAcc_Start(): DATE;
  CONST
   trgKind = knd_PF_ADV6_2;
  VAR
   Result : DATE;
 BEGIN
  SETEMPTY(Result);
  TRY [RESTORE_CURSORS(RC_ON)]
   SELECT(Packet, PacketKn, , rcv_PensFund, trgKind);
   WHILE OCCURE(Packet) & !Result DO
    IF IsValidPacket() THEN
     Result:=Packet.PerB;
    END;
    NEXT(Packet);
   END; (* WHILE OCCURE(Packet) ... *)
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {Get_PF_ProgressiveTotalPersAcc_Start};

END.
