(*
%Copyright   (c) Polak Computer System
%Author      06.12.1995 19:30:32 SAN
%Purpose     ࠭筠 
%Type        library
%Specific    SYS
%Modified    19.07.2010 11:27:43 POLAK\MLB
%Environment
*)

 MODULE L_PagePr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT FIO, Str;

 PUBLIC CONST
  m_Depth = 0;
  m_Print = 1;
  m_RDoneTop = 2; (* Top- ᫥  ᫥ ࠭*)
  m_HowBot = 2;   (*/  । Bot-⮩*)

  pbot_None  = 0; (* ,  *)
  pbot_Print = 1; (*,  *)
  pbot_Fill  = 2; (*  *)

  st_Init  = 0;
  st_Activ = 1;
  st_Begun = 2; (*㦥 뢥   ப ⠡*)
  st_Done  = 3;

 VAR
  PagePr_Status,
  PagePr_Result  : NUMERIC[0];

  PagePr_PageLen : NUMERIC[0];
  PagePr_Report  : STRING[32];
  PagePr_RprtTop,
  PagePr_PageTop,
  PagePr_PageBot,
  PagePr_RprtBot,
  PagePr_Filling : PROC;
  PagePr_FlLen,
  PagePr_PBLen,
  PagePr_RBLen   : NUMERIC[0];

 PUBLIC PROCEDURE PagePr_BadCallMode(C: SCAL[2]);
 BEGIN
  IF ~C THEN
   STDMSG("맮  L_PagePr  ୮ ", STOP);
  END;
 END {PagePr_BadCallMode};

 PRIVATE PROCEDURE BadPagePr(C: SCAL[2]);
 BEGIN
  IF ~C THEN
   STDMSG("୮ ਬ L_PagePr", STOP);
  END;
 END {BadPagePr};

 PRIVATE PROCEDURE ExecuteExternalProc(Proc: PROC; Mode: SCAL[20]);
 BEGIN
  SETEMPTY(PagePr_Result);
  IF ~!Proc THEN
   Proc(Mode);
  END;
 END {ExecuteExternalProc};

 PUBLIC PROCEDURE PagePr_SetResult(R: NUMERIC[0]);
 BEGIN
  PagePr_Result:=R;
 END {PagePr_SetResult};

 PRIVATE PROCEDURE PagePr_GetResult(): NUMERIC[0];
 BEGIN
  BadPagePr(~!PagePr_Result);
  RETURN PagePr_Result;
 END {PagePr_GetResult};

 PUBLIC PROCEDURE PagePr_xInit(
                               _ppReport : STRING[32];
                               _ppPageLen: NUMERIC[0];
                               _ppRprtTop,
                               _ppPageTop,
                               _ppPageBot,
                               _ppRprtBot,
                               _ppFilling : PROC);
  VAR
   Dummy: NUMERIC[0];
 BEGIN
  PagePr_Status:=st_Init;
  PagePr_Report :=_ppReport;
  PagePr_RprtTop:=_ppRprtTop;
  PagePr_PageTop:=_ppPageTop;
  PagePr_PageBot:=_ppPageBot;
  PagePr_RprtBot:=_ppRprtBot;
  PagePr_Filling:=_ppFilling;
  PagePr_PageLen:=_ppPageLen;
  ExecuteExternalProc(PagePr_PageBot, m_Depth); PagePr_PBLen:=PagePr_GetResult();
  ExecuteExternalProc(PagePr_RprtBot, m_Depth); PagePr_RBLen:=PagePr_GetResult();
  ExecuteExternalProc(PagePr_Filling, m_Depth); PagePr_FlLen:=PagePr_GetResult();
 END {PagePr_xInit};

 PRIVATE PROCEDURE PagePr_AtEveryBeginning();
 BEGIN
  IF PagePr_Status = st_Init THEN
   PagePr_Status:=st_Activ;
   ExecuteExternalProc(PagePr_RprtTop, m_Print);
   ExecuteExternalProc(PagePr_PageTop, m_Print);
  END;
 END {PagePr_AtEveryBeginning};

 PUBLIC PROCEDURE PagePr_Init(
                              _ppReport : STRING[32];
                              _ppPageLen: NUMERIC[0];
                              _ppRprtTop,
                              _ppPageTop,
                              _ppPageBot,
                              _ppRprtBot,
                              _ppFilling : PROC);
 BEGIN
  PagePr_xInit(_ppReport, _ppPageLen, _ppRprtTop, _ppPageTop,
               _ppPageBot, _ppRprtBot, _ppFilling);
  IF PagePr_CurrentPage() = 1 THEN
   SetPrintAttr(^_ppReport, LinesPerPage, _ppPageLen);
  END;
  PagePr_AtEveryBeginning();
 END {PagePr_Init};

 PUBLIC PROCEDURE PagePr_CurrentPage(): NUMERIC[0];
 BEGIN
  RETURN PAGENUM(^PagePr_Report);
 END {PagePr_CurrentPage};

 PUBLIC PROCEDURE PagePr_GetPageRest(): NUMERIC[0];
  VAR Rest: NUMERIC[0];
 BEGIN
  Rest:=PagePr_PageLen - LINENUM(^PagePr_Report);
  BadPagePr(Rest >= 0);
  RETURN Rest;
 END {PagePr_GetPageRest};

 PUBLIC PROCEDURE PagePr_BeforePrintLineAtLast(IsLastLine: SCAL[2]; NeedToPrint: NUMERIC[0]);
  VAR
   Rest,
   Need : NUMERIC[0];
 BEGIN
  PagePr_AtEveryBeginning();
  PagePr_Status:=st_Begun;
  Rest:=PagePr_GetPageRest();
  IF IsLastLine THEN
   Need:=PagePr_RBLen+NeedToPrint;
  ELSE
   Need:=PagePr_PBLen+NeedToPrint;
  END;
  IF Rest <= Need THEN
   ExecuteExternalProc(PagePr_PageBot, m_Print);
   FORMFEED(^PagePr_Report);
   ExecuteExternalProc(PagePr_PageTop, m_Print);
  END;
 END {PagePr_BeforePrintLineAtLast};

 PUBLIC PROCEDURE PagePr_BeforePrintLine(NeedToPrint: NUMERIC[0]);
 BEGIN
  PagePr_BeforePrintLineAtLast(0, NeedToPrint);
 END {PagePr_BeforePrintLine};

 PUBLIC PROCEDURE PagePr_SetNewPage();
  VAR
   PageBRes: NUMERIC[0];
 BEGIN
  ExecuteExternalProc(PagePr_PageBot, m_HowBot); PageBRes:=PagePr_GetResult();
  IF PagePr_Status=st_Begun THEN
   PagePr_Fill(PagePr_PBLen);
   ExecuteExternalProc(PagePr_PageBot, m_Print);
   FORMFEED(^PagePr_Report);
   ExecuteExternalProc(PagePr_PageTop, m_Print);
  END;
 END {PagePr_SetNewPage};

 PRIVATE PROCEDURE PagePr_Fill(Reserve: NUMERIC[0]);
 BEGIN
  IF PagePr_FlLen > 0 THEN
   LOOP
    IF PagePr_PageLen <= (Reserve+LINENUM(^PagePr_Report)+PagePr_FlLen) THEN
     EXIT;
    END;
    ExecuteExternalProc(PagePr_Filling, m_Print);
   END;
  END;
 END {PagePr_Fill};

 PUBLIC PROCEDURE PagePr_Done();
  VAR
   PageBRes,
   RprtBRes,
   Rest     : NUMERIC[0];
 BEGIN
  PagePr_AtEveryBeginning();
  ExecuteExternalProc(PagePr_PageBot, m_HowBot); PageBRes:=PagePr_GetResult();
  IF PageBRes # pbot_None THEN
   IF PageBRes = pbot_Fill THEN
    PagePr_Fill(PagePr_PBLen);
   ELSE
    BadPagePr(PageBRes = pbot_Print);
   END;
   ExecuteExternalProc(PagePr_PageBot, m_Print);
   FORMFEED(^PagePr_Report);
   ExecuteExternalProc(PagePr_PageTop, m_RDoneTop);
  END; (* IFPageBRes # pbot_None ... *)
  ExecuteExternalProc(PagePr_RprtBot, m_HowBot); RprtBRes:=PagePr_GetResult();
  IF RprtBRes # pbot_None THEN
   Rest:=PagePr_GetPageRest();
   IF Rest < PagePr_RBLen THEN
    IF PageBRes = pbot_Fill THEN
     PagePr_Fill(PagePr_PBLen);
    END;
    ExecuteExternalProc(PagePr_PageBot, m_Print);
    FORMFEED(^PagePr_Report);
    ExecuteExternalProc(PagePr_PageTop, m_RDoneTop);
   END;
   IF    RprtBRes = pbot_Print THEN
    ExecuteExternalProc(PagePr_RprtBot, m_Print);
   ELSIF RprtBRes = pbot_Fill THEN
    PagePr_Fill(PagePr_RBLen);
    ExecuteExternalProc(PagePr_RprtBot, m_Print);
   ELSE
    BadPagePr(0);
   END;
  END; (* IF RprtBRes > 0 ... *)
  IF LINENUM(^PagePr_Report) > 0  THEN
   FORMFEED(^PagePr_Report);
  END;
  PagePr_Status:=st_Done;
 END {PagePr_Done};

 PUBLIC PROCEDURE CutRedundantFormfeed(F: STRING[]; PageLen: NUMERIC[0]);
  VAR
   S            : STRING[];
   Cnt,
   prvPageCnt,
   p,
   strPos,
   prvFFPos,
   savePos      : NUMERIC[0];
 BEGIN
  FIO.Open(R, F, "", Output);
  SETZERO(prvPageCnt, Cnt);
  SETEMPTY(prvFFPos);
  LOOP
   strPos:=FIO.Tell(R);
   IF FIO.RdStr(R, S) THEN
    INC(Cnt);
    INC(prvPageCnt);
    p:=Str.Pos(S, CHR(12));
    IF p < Str.Length(S) THEN
     IF Cnt < PageLen THEN
      IF ~!prvFFPos THEN
       savePos:=FIO.Tell(R);
       FIO.Seek(R, prvFFPos);
       FIO.WrByte(R, ORD(" "));
       FIO.Seek(R, savePos);
      END;
     ELSE
      Cnt:=prvPageCnt;
     END;
     prvFFPos:=strPos + p;
     prvPageCnt:=0;
    END;
   ELSE
    EXIT;
   END;
  END;
  FIO.Close(R);
 END {CutRedundantFormfeed};

END.
