(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose       PayP  蠡
%Type        library
%Specific    SYS
%Modified    08.11.2013 20:03:03 POLAK\MLB
%Environment
*)

 MODULE L_PayP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Str, Str, L_General, L_PDoc, L_DatTim, L_PayPRl, Memo, L_StdFrm;

 PUBLIC TYPE
  tSelector = SCAL[250];

 PUBLIC CONST
  MaxLength   = 150;  (* ᨬ쭠 ਭ           *)
  MaxAttrAmnt =   3;  (* ᨬ쭮 ᫮ ਡ⮢  *)
  MaxSumAmnt  =   3;  (* ᨬ쭮 ᫮ 㬬       *)
  SumObj      = 100;
  LineNbrObj  = 101;

  ppType_Simple = 0; (* PayP.Type *)
  ppType_wSheet = 1;

  ot_Numeric = 0;
  ot_String  = 3;

  a_Name      = 000;
  a_Account   = 001;
  a_Address   = 002;
  a_ShortName = 003;
  a_Empty     = 004;  (* ⮩ ਡ  *)
  a_Document  = 005;

  (*PayP Templates*)

  ppt_MDocPayment       = "MDoc.#:MDoc.SrcNbr:室  ⮢୮ 㬥|"+
                          "MDoc.@:MDoc.SrcDate:室  ⮢୮ 㬥|"+
                          "MDoc.Date^mm.yyyy:MDoc.Date^mm.yyyy:   ⮢୮ 㬥|"+
                          "MDoc.Date^mm:MDoc.Date^mm: ⮢୮ 㬥|"+
                          "MDoc.Date^qq.yyyy:MDoc.Date^qq.yyyy:⠫   ⮢୮ 㬥|"+
                          "MDoc.Date^yyyy:MDoc.Date^yyyy: ⮢୮ 㬥|"+
                          "MDoc.Date^yy:MDoc.Date^yy: ⮢୮ 㬥  ࠬ|"+
                          "MDoc.Contract.#:Contract.SrcNbr:室  |"+
                          "MDoc.Contract.@:Contract.SrcDate:室  |"+
                          "PDoc.Firm.RegName:Firm.RegName:ࠣ|"+
                          "MDoc.PayDate:MDoc.PayDate:ப 㯫  ⮢୮ 㬥|"+
                          "MDoc.Note:MDoc.Note:ਬ砭  ⮢୮ 㬥|"+
                          "PDocMDoc.Netto:PDocMDoc.Total.Netto:㬬 ⥦ 㬥 |"+
                          "PDocMDoc.VAT.byWord:PDocMDoc.Total.VAT.byWord:㬬  ⥦ 㬥 ᫮|"+
                          "PDocMDoc.VAT:PDocMDoc.Total.VAT:㬬  ⥦ 㬥|"+
                          "PDocMDoc.Total:PDocMDoc.Total:㬬 ⥦ 㬥|"+
                          "MDoc.Contract.7322.GoodsDescr:Contract.7322.GoodsDescr: ⮢஢ ( - 7322 )|"+
                          "MDoc.Contract.7322.KBK:Contract.7322.KBK: ( - 7322 )|"+
                          "MDoc.Contract.7322.OKATO:Contract.7322.OKATO: ( - 7322 )|"+
                          "MDoc.Contract.7322.pmnt_Former:Contract.7322.pmnt_Former:ନ⥫ ( - 7322 )";

  ppt_SinglePersPayment = "M:Memo.tmp_mb():砫 ⥪饣 |"+
                          "E:_EventName: ᮡ|"+
                          "T:Staff.TSN:  ⥫騪|"+
                          "S:Man.Name:  ⢮ ⥫騪|"+
                          "s:Man.Name.Short: 樠 ⥫騪|"+
                          "L:LbCNbr: 㤮  ⥫騪|"+
                          "D:LbCDate: 㤮  ⥫騪|"+
                          "P:Deduct.Person:  ⢮ ⥫|"+
                          "p:Deduct.Person.Short:  樠 ⥫|"+
                          "A:Deduct.PAddr[0]:⮢  ⥫|"+
                          "C:Deduct.PCode:楢  ⥫|"+
                          ppt_MDocPayment;

  ppt_MultyPersPayment  = "M:Memo.tmp_mb():砫 ⥪饣 |"+
                          "N:PDoc.PDoc: ⥦ 㬥|"+
                          "E:_EventName: ᮡ|"+
                          ppt_MDocPayment;

  ppt_ListTitle         = "M:Memo.tmp_mb():砫 ⥪饣 |"+
                          "N:PDoc.PDoc: ⥦ 㬥|"+
                          "F:Firm.RegName:ࠣ|";

(*--------------------------------------------------------------------------*)

 PRIVATE PROCEDURE PayPProgCheck(Selector: tSelector);
 BEGIN
  L_General.Assert(~!Selector, " 㪠 ਡ .|室 ஢ 祭 ⥦");
  L_General.ConsultToUs(0, " ꥪ"+Selector+".|室 ஢ ணࠬ ᮧ ⥩");
 END {PayPProgCheck};

 PUBLIC PROCEDURE IsEmptyAttr(Index: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN PayP.LstAttr[Index] = a_Empty;
 END;

 PUBLIC PROCEDURE IsEmptyPaylSngl(): SCAL[2];
 BEGIN
  RETURN (!PayP.PayLSngl[0]) & (!PayP.PayLSngl[1]) & (!PayP.PayLSngl[2]);
 END {IsEmptyPaylSngl};

 PUBLIC PROCEDURE GetObjName(Selector: tSelector; Index: NUMERIC[0]): STRING[250];
 BEGIN
  IF    Selector = a_Name      THEN
   RETURN "Deduct.Person";
  ELSIF Selector = a_Account   THEN
   RETURN "Deduct.PCode";
  ELSIF Selector = a_Address   THEN
   IF Index = 0 THEN                    (*  ⢥ ਡ    *)
    RETURN "Str.Condense(Deduct.PAddr[0]+' '+Deduct.PAddr[1])";
   ELSE
    RETURN "Deduct.PAddr[0]";           (*  ⢥ ࠬ 樨 *)
   END;
  ELSIF Selector = a_ShortName THEN
   IF Index = 0 THEN                    (*  ⢥ ਡ    *)
    RETURN "L_Str.ShortName(Deduct.Person)";
   ELSE
    RETURN "Deduct.Person";             (*  ⢥ ࠬ 樨 *)
   END;
  ELSIF Selector = a_Document  THEN
   RETURN "Man.PspSer+'  '+Man.PspNbr";
  ELSIF Selector = a_Empty     THEN
   RETURN "BlanksLine";                  (* ⠭  FirmPay.asl       *)
  ELSIF Selector = SumObj      THEN
   RETURN "Sum[" + FLDTOSTR(Index, "", 1) + "]";
  ELSIF Selector = LineNbrObj  THEN
   RETURN "LineNbr";
  ELSE
   PayPProgCheck(Selector);
  END;
 END {GetObjName};

 PUBLIC PROCEDURE GetObjTitle(Selector: tSelector; Index: NUMERIC[0]): STRING[250];
 BEGIN
  IF    Selector = a_Name      THEN RETURN "  ⢮";
  ELSIF Selector = a_Account   THEN RETURN "楢 ";
  ELSIF Selector = a_Address   THEN RETURN "";
  ELSIF Selector = a_ShortName THEN RETURN ", 樠";
  ELSIF Selector = a_Document  THEN RETURN "㬥";
  ELSIF Selector = a_Empty     THEN RETURN "⮩ ਡ";
  ELSIF Selector = SumObj      THEN RETURN PayP.LstSum[Index];
  ELSIF Selector = LineNbrObj  THEN RETURN "";
  ELSE
   PayPProgCheck(Selector);
  END;
 END {GetObjTitle};

 PUBLIC PROCEDURE GetDefaultObjLen(Selector: tSelector): NUMERIC[0];
 BEGIN
  IF    Selector = a_Name      THEN RETURN 48;
  ELSIF Selector = a_Account   THEN RETURN 20;
  ELSIF Selector = a_Address   THEN RETURN 72;
  ELSIF Selector = a_ShortName THEN RETURN 34;
  ELSIF Selector = a_Document  THEN RETURN 18;
  ELSIF Selector = a_Empty     THEN RETURN 20;
  ELSIF Selector = SumObj      THEN RETURN 12;
  ELSE
   PayPProgCheck(Selector);
  END;
 END {GetDefaultObjLen};

 PUBLIC PROCEDURE GetObjLen(Selector: tSelector; Index: NUMERIC[0]): NUMERIC[0];
 BEGIN
  IF    (Selector >= a_Name) &
        (Selector <= a_Document) THEN
   L_General.Assert(Selector = PayP.LstAttr[Index],
                    "訡  ணࠬ ࠡ⪨ 祭 ⥦");
   RETURN PayP.AttrLen[Index];
  ELSIF Selector = SumObj        THEN
   RETURN GetDefaultObjLen(SumObj);
  ELSE
   PayPProgCheck(Selector);
  END;
 END {GetObjLen};

 PUBLIC PROCEDURE GetObjAlign(Selector: tSelector): STRING[5];
 BEGIN
  IF    Selector = a_Name      THEN RETURN "L";
  ELSIF Selector = a_Account   THEN RETURN "L";
  ELSIF Selector = a_Address   THEN RETURN "L";
  ELSIF Selector = a_ShortName THEN RETURN "L";
  ELSIF Selector = a_Document  THEN RETURN "L";
  ELSIF Selector = a_Empty     THEN RETURN "L";
  ELSIF Selector = SumObj      THEN RETURN "R";
  ELSIF Selector = LineNbrObj  THEN RETURN "R";
  ELSE
   PayPProgCheck(Selector);
  END;
 END {GetObjAlign};

 PUBLIC PROCEDURE GetObjType(Selector: tSelector): NUMERIC[0];
 BEGIN
  IF    Selector = a_Name      THEN RETURN ot_String;
  ELSIF Selector = a_Account   THEN RETURN ot_Numeric;
  ELSIF Selector = a_Address   THEN RETURN ot_String;
  ELSIF Selector = a_ShortName THEN RETURN ot_String;
  ELSIF Selector = a_Document  THEN RETURN ot_String;
  ELSIF Selector = a_Empty     THEN RETURN ot_String;
  ELSIF Selector = SumObj      THEN RETURN ot_Numeric;
  ELSIF Selector = LineNbrObj  THEN RETURN ot_Numeric;
  ELSE
   PayPProgCheck(Selector);
  END;
 END {GetObjType};

(*--- ᯮ 蠡 -----------------------------------------------*)

 PRIVATE PROCEDURE UnknownPat(s: STRING[]; Posit: NUMERIC[0]);
  VAR
   Pat: STRING[];
 BEGIN
  Pat:=Str.Item(Str.Slice(s, Posit, Str.Length(s)), "\ ", 0);
  L_General.Error(" 蠡 " + "'" + Pat + "'" + "  樨 " + L_Str.IntStr(Posit) +
                  "||室 ப: " + s);
 END {UnknownPat};

 PRIVATE PROCEDURE IdentifyTemplateName(s, _Template: STRING[]; VAR j: NUMERIC[0]; VAR Field, Description: STRING[]);
  VAR
   i: NUMERIC[0];
   t,
   _name: STRING[];
 BEGIN
  i:=0; t:=L_Str.PoolItem(_Template, i);
  WHILE t#"" DO
   _name:=Str.Item(t, ":", 0);
   IF Str.Slice(s, j, Str.Length(_name))=_name THEN
    INC(j, Str.Length(_name));
    Field      :=Str.Item(t, ":", 1);
    Description:=Str.Item(t, ":", 2);
    RETURN;
   END;
   INC(i); t:=L_Str.PoolItem(_Template, i);
  END;
  UnknownPat(s, j);
  INC(j);
  SETEMPTY(Field, Description);
  RETURN;
 END {IdentifyTemplateName};

 PUBLIC PROCEDURE _MorphString(s, Template: STRING[]; Proc: PROC): STRING[];
  CONST
   Prefix = "\";
  VAR
   i,
   pos,
   Len     : NUMERIC[0];
   PayPStr,
   R,
   t,
   _field,
   _descr  : STRING[];
 BEGIN
  IF OCCURE(PayP) THEN
   PayPStr:="|| 祭 ⥦ " + PayP.PayP;
  ELSE
   PayPStr:="";
  END;

  i  :=0;
  Len:=Str.Length(s);
  R  :="";
  WHILE i < Len DO
   t:=Str.Slice(s, i, 1);
   INC(i);
   IF t = Prefix THEN
    t:=Str.Slice(s, i, 1);
    IF t = Prefix THEN
     INC(i);
    ELSE
     pos:=i;
     IdentifyTemplateName(s, Template, i, _field, _descr);
     t:="OK";
     IF ~!Proc THEN
      t:=Proc(_field);
      L_General.Assert(~!t, "| 樨 " + L_Str.IntStr(pos) + " ⮩ १  " +
                            "|" + _descr + "." +
                            "||室 ப: " + s +
                            PayPStr +
                            "||ଠ  㯭 蠡 ᫥ ᬮ" +
                            "| ᠭ 祭 ⥦");
     END;
    END;
   END;
   R:=R+t;
  END; (* WHILE i < Len *)
  RETURN R;
 END {_MorphString};

 PUBLIC PROCEDURE MorphString(s,
                              Template: STRING[];
                              Proc    : PROC;
                              LenLimit: NUMERIC[0]): STRING[];
  VAR
   PayPStr,
   R : STRING[];
 BEGIN
  IF OCCURE(PayP) THEN
   PayPStr:="|| 祭 ⥦ " + PayP.PayP;
  ELSE
   PayPStr:="";
  END;

  R:=_MorphString(s, Template, Proc);
  L_General.Assert((LenLimit < 0) | (Str.Length(R) <= LenLimit),
                   "誮  ப. :| |" + s + PayPStr +
                   "| |室 ப  " + L_Str.IntStr(Str.Length(R)) + " ᨬ:" +
                   R + "||" +
                   "ᨬ쭠  " + L_Str.IntStr(LenLimit) + " ᨬ, " +
                   " 㬥頥 " + L_Str.IntStr(Str.Length(R) - LenLimit) + " ᨬ");
  RETURN R;
 END {MorphString};

 PUBLIC PROCEDURE GetPayPLstProc(): PROC;
  VAR
   p: PROC;
 BEGIN
  L_General.Assert(~!PayP.LstProc, " 祭 ⥦ " + PayP.PayP +
                                   "| 㪠 ࠢ ࠡ⪨ 㬬");
  p:=PROCREF(^("L_PayPRl." + PayP.LstProc));
  L_General.Assert(~!p, " 祭 ⥦ " + PayP.PayP +
                        '|㪠 ⭮ ࠢ ࠡ⪨ 㬬 "' + PayP.LstProc + '"');
  RETURN p;
 END {GetPayPLstProc};

 PUBLIC PROCEDURE GetDedAcntDebts(VAR Debt, Collect: NUMERIC[2][]);
  VAR
   X: LIKE(DedAcnt.TotDebt);
   p: PROC;
 BEGIN
  p:=GetPayPLstProc();
  CONFORM(DedAcnt, Deduct, PayP);
  IF Memo.tmp_mb() >= 01\01\2002 THEN
   p(0, DedAcnt.NetDebt, Debt, Collect[0]);
   X:=Debt + Collect[0];   (*᫥  ࠢ*)
   L_General.Assert((DedAcnt.TotDebt >= X) & (DedAcnt.TotDebt < (X + 1)),
                    "襭 ⮢, ⠡. " + Deduct.TSN +
                    "|ঠ " + Deduct.DedNbr +
                    " ਮ " + L_DatTim.PeriodStr(DedAcnt.Period));
  ELSE
   Debt:=L_General.Denominate(DedAcnt.Period,
                              L_DatTim.Per(SYSDATE()),
                              DedAcnt.NetDebt);
   p(0, Debt, Debt, Collect[0]);
   L_General.Assert(DedAcnt.TotDebt = DedAcnt.NetDebt,
                    "襭 ⮢, ⠡. " + Deduct.TSN +
                    "|ঠ " + Deduct.DedNbr +
                    " ਮ " + L_DatTim.PeriodStr(DedAcnt.Period));
  END;
 END {GetDedAcntDebts};

END.
