(*
%Copyright   (c) Polak Computer System
%Author      23.06.1997 18:29:19 GINA
%Purpose      ࠢ ࠡ⪨ 㬬 㤥ঠ
%Type        library
%Specific    SYS
%Modified    16.10.2013 18:31:16 POLAK\Gina
%Environment
*)

 MODULE L_PayPRl [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_PRoll, Memo, L_DatTim, L_APtm, L_Env, L_Money,
        Str, DBD, L_Russia;

 PRIVATE TYPE
  tInterUnionPostalRates = SCAL[3];

 PRIVATE CONST
  iupr_Ukraine    = 0; (* tInterUnionPostalRates*)
  iupr_Azerbaijan = 1;
  iupr_Kyrgyzstan = 2;

(*--- ࠢ 祭 㬬 -----------------------------------------------*)

 PRIVATE PROCEDURE (OpT: SCAL[2]; P: NUMERIC[2]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]);
 BEGIN
  IF Memo.gl_mb() >= 01\01\2002 THEN
   Res:=S;
   Delta:=(S+0.999) DIV 1 * P;
  ELSE
   IF    OpT = 0 THEN                        (*뤥  ᡮ  㬬*)
    IF SYSDATE() < L_General.DenominationDate() THEN
     Delta:=(S / (1+P) + 999) DIV 1000 * 1000 * P;
    ELSE
     Delta:=(S / (1+P) + 0.999) DIV 1 * 1 * P;
    END;
    Res:=S-Delta;
   ELSIF OpT = 1 THEN                        (*  ᡮ  㬬*)
    IF Memo.gl_mb() < L_General.DenominationDate() THEN
     Delta:=(S+999) DIV 1000 * 1000 * P;
    ELSE
     Delta:=(S+0.999) DIV 1 * 1 * P;
    END;
    Res:=S+Delta;
   END;
  END;
 END {};

 PUBLIC PROCEDURE ᯮ(s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]);
 BEGIN
  Res:=S; Delta:=0;
  IF    Memo.gl_mb() >= 01\04\2013 THEN
   IF    S > 500000 THEN
    L_General.Error("ᨬ쭠 㬬 ⮢ ॢ 500 000 .|㬬 "+L_Money.MoneyToStr(S));
   ELSIF S > 20000 THEN
    Delta:=S * 0.015 + 250;
   ELSIF S > 5000 THEN
    Delta:=S * 0.02  + 150;
   ELSIF S > 1000 THEN
    Delta:=S * 0.04  +  50; (* . 0094851 -  㬠 ⠪ 㫠  S * 0.055 + 35 *)
   ELSIF S > 0 THEN
    Delta:=S * 0.05  +  40;
   END;
  ELSIF Memo.gl_mb() >= 01\11\2012 THEN
   IF    S > 500000 THEN
    L_General.Error("ᨬ쭠 㬬 ⮢ ॢ 500 000 .|㬬 "+L_Money.MoneyToStr(S));
   ELSIF S > 20000 THEN
    Delta:=S * 0.01 + 335;
   ELSIF S > 5000 THEN
    Delta:=S * 0.02 + 135;
   ELSIF S > 1000 THEN
    Delta:=S * 0.04 +  35;
   ELSIF S > 0 THEN
    Delta:=S * 0.05 +  25;
   END;
  ELSIF Memo.gl_mb() >= 01\04\2010 THEN
   IF    S > 500000 THEN
    L_General.Error("ᨬ쭠 㬬 ⮢ ॢ 500 000 .|㬬 "+L_Money.MoneyToStr(S));
   ELSIF S > 20000 THEN
    Delta:=(S - 20000) * 0.01 + 535;
   ELSIF S > 5000 THEN
    Delta:=(S -  5000) * 0.02 + 235;
   ELSIF S > 1000 THEN
    Delta:=(S -  1000) * 0.04 +  75;
   ELSIF S > 0 THEN
    Delta:=S *           0.05 +  25;
   END;
  ELSE
   IF    S > 100000 THEN
    L_General.Error(" । ⮢ ᡮ  㬬, ॢ 100000-00|㬬 "+L_Money.MoneyToStr(S));
   ELSIF S > 20000 THEN
    Delta:=(S - 20000) * 0.01 + 517;
   ELSIF S > 5000 THEN
    Delta:=(S -  5000) * 0.02 + 217;
   ELSIF S > 1000 THEN
    Delta:=(S -  1000) * 0.04 +  57;
   ELSIF S > 0 THEN
    Delta:=S *           0.05 +   7;
   END;
  END;
 END {ᯮ};

 PUBLIC PROCEDURE Ꭱ(s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]);
 BEGIN
  Res:=S; Delta:=0;
  IF    Memo.gl_mb() >= 01\04\2013 THEN
   IF    S > 500000 THEN
    L_General.Error("ᨬ쭠 㬬 ⮢ ॢ 500 000 .|㬬 "+L_Money.MoneyToStr(S));
   ELSIF S > 20000 THEN
    Delta:=S * 0.015 + 250;
   ELSIF S > 5000 THEN
    Delta:=S * 0.02  + 150;
   ELSIF S > 1000 THEN
    Delta:=S * 0.04  +  50; (* . 0094851 -  㬠 ⠪ 㫠  S * 0.055 + 35 *)
   ELSIF S > 0 THEN
    Delta:=S * 0.05  +  40;
   END;
  ELSIF Memo.gl_mb() >= 01\11\2012 THEN
   IF    S > 500000 THEN
    L_General.Error("ᨬ쭠 㬬 ⮢ ॢ 500 000 .|㬬 "+L_Money.MoneyToStr(S));
   ELSIF S > 20000 THEN
    Delta:=S * 0.01  + 410;
   ELSIF S > 5000 THEN
    Delta:=S * 0.02  + 210;
   ELSIF S > 1000 THEN
    Delta:=(S -  1000) * 0.015 + (50 + S * 0.04); (* . 0094851 -  㬠 ⠪ 㫠  S * 0.055 + 35 *)
   ELSIF S > 0 THEN
    Delta:=S * 0.065 +  25;
   END;
  ELSIF Memo.gl_mb() >= 01\04\2010 THEN
   IF    S > 500000 THEN
    L_General.Error("ᨬ쭠 㬬 ⮢ ॢ 500 000 .|㬬 "+L_Money.MoneyToStr(S));
   ELSIF S > 20000 THEN
    Delta:=(S - 20000) * 0.01 + 675;
   ELSIF S > 5000 THEN
    Delta:=(S -  5000) * 0.02 + 375;
   ELSIF S > 0 THEN
    Delta:=S *           0.07 +  25;
   END;
  ELSE
   IF    S > 100000 THEN
    L_General.Error(" । ⮢ ᡮ  㬬, ॢ 100000-00|㬬 "+L_Money.MoneyToStr(S));
   ELSIF S > 20000 THEN
    Delta:=(S - 20000) * 0.01 + 657;
   ELSIF S > 5000 THEN
    Delta:=(S -  5000) * 0.02 + 357;
   ELSIF S > 0 THEN
    Delta:=S *           0.07 +   7;
   END;
  END;
 END {Ꭱ};

 PRIVATE PROCEDURE 㭠த2012(iupr: tInterUnionPostalRates; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]);
 BEGIN
  Res:=S; Delta:=0;
  IF Memo.gl_mb() >= 01\12\2012 THEN
   IF    iupr = iupr_Ukraine THEN
    IF    S > 150000 THEN
     L_General.Error("ᨬ쭠 㬬 ⮢ ॢ 150000 .|㬬 "+L_Money.MoneyToStr(S));
    ELSIF S > 20000 THEN
     Delta:=S * 0.015 + 260;
    ELSIF S > 5000 THEN
     Delta:=S * 0.022 + 120;
    ELSIF S > 1000 THEN
     Delta:=S * 0.035 +  55;
    ELSIF S > 0 THEN
     Delta:=S * 0.050 +  40;
    END;
   ELSIF iupr = iupr_Azerbaijan THEN
    IF    S > 150000 THEN
     L_General.Error("ᨬ쭠 㬬 ⮢ ॢ 150000 .|㬬 "+L_Money.MoneyToStr(S));
    ELSIF S > 20000 THEN
     Delta:=S * 0.015 + 105;
    ELSIF S > 5000 THEN
     Delta:=S * 0.017 +  65;
    ELSIF S > 1000 THEN
     Delta:=S * 0.020 +  50;
    ELSIF S > 0 THEN
     Delta:=S * 0.030 +  40;
    END;
   ELSIF iupr = iupr_Kyrgyzstan THEN
    IF    S > 500000 THEN
     L_General.Error("ᨬ쭠 㬬 ⮢ ॢ 500000 .|㬬 "+L_Money.MoneyToStr(S));
    ELSIF S > 20000 THEN
     Delta:=S * 0.010 + 475;
    ELSIF S > 5000 THEN
     Delta:=S * 0.020 + 275;
    ELSIF S > 1000 THEN
     Delta:=S * 0.040 + ((S-1000)*0.030) + 55;
    ELSIF S > 0 THEN
     Delta:=S * 0.070 +  25;
    END;
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {㭠த2012};

 PRIVATE PROCEDURE 㭠த(s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]);
 BEGIN
  L_General.CallUs(Memo.gl_mb() < 01\12\2012);
  Res:=S; Delta:=0;
  IF Memo.gl_mb() >= 01\11\2012 THEN
   IF L_Env.Region = L_Russia.reg_50 THEN
    IF    S > 500000 THEN
     L_General.Error("ᨬ쭠 㬬 ⮢ ॢ 500 000 .|㬬 "+L_Money.MoneyToStr(S));
    ELSIF S > 20000 THEN
     Delta:=(S - 20000) * 0.010 + 675;
    ELSIF S > 5000 THEN
     Delta:=(S -  5000) * 0.020 + 375;
    ELSIF S > 1000 THEN
     Delta:=(S -  1000) * 0.070 +  95;
    ELSIF S > 0 THEN
     Delta:=S *           0.070 +  25;
    END;
   ELSE
    L_General.Error("  㭠த ⮢  ॢ  ஥");
   END;
  ELSE
   IF    S > 500000 THEN
    L_General.Error("ᨬ쭠 㬬 ⮢ ॢ 500 000 .|㬬 "+L_Money.MoneyToStr(S));
   ELSIF S > 20000 THEN
    Delta:=(S - 20000) * 0.015 + 602;
   ELSIF S > 5000 THEN
    Delta:=(S -  5000) * 0.025 + 227;
   ELSIF S > 1000 THEN
    Delta:=(S -  1000) * 0.035 +  87;
   ELSIF S > 0 THEN
    Delta:=S *           0.080 +   7;
   END;
  END;
 END {㭠த};

 PUBLIC PROCEDURE 72(s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]);
 BEGIN
  Res:=S; Delta:=0;
  IF    Memo.gl_mb() >= 01\04\2013 THEN
   IF    S > 500000 THEN
    L_General.Error("ᨬ쭠 㬬 ⮢ ॢ 500 000 .|㬬 "+L_Money.MoneyToStr(S));
   ELSIF S > 20000 THEN
    Delta:=(S * 0.015 + 250) + ((S - 20000) * 0.02 + 400);
   ELSIF S > 5000 THEN
    Delta:=(S * 0.02  + 150) + ((S -  5000) * 0.02 + 100);
   ELSIF S > 1000 THEN
    Delta:=(S * 0.04  +  50) + ((S -  1000) * 0.02 +  20);
   ELSIF S > 0 THEN
    Delta:=(S * 0.05  +  40) + (S *           0.02);
   END;
  ELSIF Memo.gl_mb() >= 01\04\2010 THEN
   IF    S > 500000 THEN
    L_General.Error("ᨬ쭠 㬬 ⮢ ॢ 500 000 .|㬬 "+L_Money.MoneyToStr(S));
   ELSIF S > 20000 THEN
    Delta:=(S - 20000) * 0.03 + 935;
   ELSIF S > 5000 THEN
    Delta:=(S -  5000) * 0.04 + 335;
   ELSIF S > 1000 THEN
    Delta:=(S -  1000) * 0.06 +  95;
   ELSIF S > 0 THEN
    Delta:=S *           0.07 +  25;
   END;
  ELSE
   IF    S > 20000 THEN
    L_General.Error(" । ⮢ ᡮ  㬬, ॢ 20000-00|㬬 "+L_Money.MoneyToStr(S));
   ELSIF S > 5000 THEN
    Delta:=(S - 5000) * 0.04 + 317;
   ELSIF S > 1000 THEN
    Delta:=(S - 1000) * 0.06 +  77;
   ELSIF S > 0 THEN
    Delta:=S *          0.07 +   7;
   END;
  END;
 END {72};

 PUBLIC PROCEDURE 㬬(s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]);
 BEGIN
  Delta:=0;
  Res:=S;
 END {㬬};

 PUBLIC PROCEDURE ②(s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]);
 BEGIN
  IF L_Env.Region = L_Russia.reg_50 THEN
   IF (Memo.gl_mb() >= 01\01\2004) | (Memo.gl_mb() = 01\12\2003) & (Str.Cap(DBD.BaseName()) = "KL") THEN
    Ꭱ(s, S, Res, Delta);
   ELSE
    (s, L_PRoll.E_PostTaxValue(SYSDATE()), S, Res, Delta);
   END;
  ELSIF L_Env.Region = L_Russia.reg_72 THEN
   72(s, S, Res, Delta);
  ELSE
   IF (Memo.gl_mb() >= 01\12\2003) | (Memo.gl_mb() = 01\11\2003) & (Str.Cap(DBD.BaseName()) # "T4") THEN
    ᯮ(s, S, Res, Delta);
   ELSE
    (s, L_PRoll.E_PostTaxValue(SYSDATE()), S, Res, Delta);
   END;
  END;
 END {②};

 PUBLIC PROCEDURE ②1(s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]); (*㭠த*)
 BEGIN
  IF    Memo.gl_mb() >= 01\12\2012 THEN
   㭠த2012(iupr_Kyrgyzstan, S, Res, Delta);
  ELSIF Memo.gl_mb() >= 01\10\2005 THEN
   㭠த(s, S, Res, Delta);
  ELSIF Memo.gl_mb() >= 01\05\2000 THEN
   (s, 0.09, S, Res, Delta);
  ELSE
   (s, 0.11, S, Res, Delta);
  END;
 END {②1};

 PUBLIC PROCEDURE ②2(s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]); (*㭠த*)
 BEGIN
(*
  01.12.2012 , , ଥ, ࠨ, 㧨, ⢠, ⮭, ࠭, ⠩
  ⮣ ଥ, ࠨ, ⠭, 㧨, ⢨, ⢠, ⮭
*)
  IF    Memo.gl_mb() >= 01\12\2012 THEN
   㭠த2012(iupr_Ukraine, S, Res, Delta);
  ELSIF Memo.gl_mb() >= 01\10\2005 THEN
   㭠த(s, S, Res, Delta);
  ELSIF Memo.gl_mb() >= 01\03\2001 THEN
   (s, 0.12, S, Res, Delta);
  ELSIF Memo.gl_mb() >= 01\05\2000 THEN
   (s, 0.15, S, Res, Delta);
  ELSE
   L_General.Error("L_PAYPRL.②2.  । ⮢ ᡮ  "+
                   L_DatTim.DateStr(Memo.gl_mb()));
  END;
 END {②2};

 PUBLIC PROCEDURE ②3(s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]); (*㭠த*)
 BEGIN
(*
  01.12.2012 ࡠ, ⠭, બ⠭, ⠭, ⠭
  ⮣ , ࣨ, ⠭, બ, ⠭
*)
  IF    Memo.gl_mb() >= 01\12\2012 THEN
   㭠த2012(iupr_Azerbaijan, S, Res, Delta);
  ELSIF Memo.gl_mb() >= 01\10\2005 THEN
   㭠த(s, S, Res, Delta);
  ELSIF Memo.gl_mb() >= 01\03\2001 THEN
   (s, 0.09, S, Res, Delta);
  ELSE
   ②2(s, S, Res, Delta);
  END;
 END {②3};

 PUBLIC PROCEDURE ②4(s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]); (* *)
 BEGIN
  IF Memo.gl_mb() >= 01\11\2003 THEN
   ᯮ(s, S, Res, Delta);
  ELSE
   Res:=S;
   IF    S >= 1000 THEN
    Delta:=(S - 1000) * 0.02 + 60;
   ELSIF S >= 500 THEN
    Delta:=(S - 500) * 0.04 + 40;
   ELSE
    Delta:=S * 0.08;
   END;
  END;
 END {②4};

 PUBLIC PROCEDURE ②5(s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]); (* ⠫*)
 BEGIN
  (s, L_PRoll.E_PostTaxValue(SYSDATE()), S, Res, Delta);
 END {②5};

 PUBLIC PROCEDURE ②16(s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]);
  VAR Delta2: NUMERIC[2];
 BEGIN
  IF Memo.gl_mb() < 01\08\1999 THEN
   IF    s = 0 THEN                        (*뤥  ᡮ  㬬*)
    IF SYSDATE() < L_General.DenominationDate() THEN
     Delta :=(S / 1.16 +   999) DIV 1000 * 1000 * 0.10;
     Delta2:=(S / 1.16 +   999) DIV 1000 * 1000 * 0.06;
    ELSE
     Delta :=(S / 1.16 + 0.999) DIV    1 *    1 * 0.10;
     Delta2:=(S / 1.16 + 0.999) DIV    1 *    1 * 0.06;
    END;
    Res:=S-Delta-Delta2;
   ELSE
    (s, 0.16, S, Res, Delta);
   END;
  ELSE
   ②(s, S, Res, Delta);
  END;
 END {②16};

 PUBLIC PROCEDURE 業(s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]);
 BEGIN
  Delta:=S*0.001;
  IF s = 0 THEN
   Res:=S;
  ELSE
   Res:=S-Delta;
  END;
 END {業};

 PUBLIC PROCEDURE (s: NUMERIC[0]; S: NUMERIC[2]; VAR Res, Delta: NUMERIC[2]); (*  ࡠ  1%  ⨥ 묨*)
 BEGIN
  IF Memo.gl_mb() >= 01\12\2007 THEN
   Delta:=S*0.01; (*   㬬*)
   Res:=S;
  ELSE
   Delta:=0;
   Res:=S;
  END;
 END {};

END.
