(*
%Copyright   (c) Polak IT
%Author      15.09.2004 11:50:24 POLAK\LDA
%Purpose     Project Class Settings
%Type        library
%Specific     ᨬ  ⨯ ஥
%Modified    29.08.2014 13:28:21 POLAK\Gina
%Environment
*)

 MODULE L_PCS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_MSO, L_Russia, L_APtm, P_OwnData, P_Firm, L_Stock, FIO, L_Prop,
        L_SES, L_Str, L_OwnData, L_Man, L_Staff, L_Dspt, L_CUC, L_APEMl, Str,
        L_EMail, L_DatTim, Memo, P_Man, L_StdFrm, L_MDoc, L_Way, L_ctc, L_lsStore, L_Cntr,
        L_WDO, L_APAR, L_AR, L_SprtCrsp, L_SysLog, L_PDoc, L_Group, L_XDoc,
        L_PRoll, L_r2r, L_qs, L_XDF, L_AcsPnt, L_APMsg;

 PUBLIC PERMANENT VAR
  CurrentProcess: STRING[];

 PUBLIC CONST
  deft_CB   = 01;
  deft_IRec = 02;
  deft_AZS  = 10;

  Files_UploadToExcel_wAdminOnlyRights_Pool = "EDOrder|FOrder";

 PUBLIC PROCEDURE GuardLoginName(): STRING[];
 BEGIN
  IF APP.Get().ProductiveCopy THEN
   RETURN "AP_Guard";
  ELSE
   RETURN "Eng_AP_Guard";
  END;
 END {GuardLoginName};

 PUBLIC PROCEDURE GetBackupAdditionalRootPath(): STRING[];
 BEGIN
  RETURN P_OwnData.BackupAdditionalRootPath(SYSDATE());
 END {GetBackupAdditionalRootPath};

 PUBLIC PROCEDURE ODFirmName(D: DATE): STRING[];
 BEGIN
  RETURN L_OwnData.ODFirmName(D);
 END {ODFirmName};

 PUBLIC PROCEDURE ChangeGlobalCurDate(D: DATE);
 BEGIN
  L_APtm.ChangeGlobalCurDate(D);
 END {ChangeGlobalCurDate};

 PUBLIC PROCEDURE DefineSesValues();
 BEGIN
  IF ~L_SES.GetValue(L_SES.sit_User, "L_Stock.dsAssigned", L_Stock.dsAssigned) THEN
   L_Stock.dsAssigned:=0;
  END;
  IF ~L_SES.GetValue(L_SES.sit_User, "L_Stock.defaultStorage", L_Stock.defaultStorage) THEN
   SETEMPTY(L_Stock.defaultStorage);
  END;

  IF ~L_SES.GetValue(L_SES.sit_User, "L_PDoc.dodAssigned", L_PDoc.dodAssigned) THEN
   L_PDoc.dodAssigned:=0;
  END;
  IF ~L_SES.GetValue(L_SES.sit_User, "L_PDoc.dodMyFirm", L_PDoc.dodMyFirm) THEN
   L_PDoc.dodMyFirm:=P_Firm.mf_Own;
  END;
  IF ~L_SES.GetValue(L_SES.sit_User, "L_PDoc.dodFirmAcnt", L_PDoc.dodFirmAcnt) THEN
   SETEMPTY(L_PDoc.dodFirmAcnt);
  END;

  IF ~L_SES.GetValue(L_SES.sit_User, "dfmAssigned", P_Firm.dfmAssigned) THEN
   P_Firm.dfmAssigned:=0;
  END;
  IF ~L_SES.GetValue(L_SES.sit_User, "defaultMyFirm", P_Firm.defaultMyFirm) THEN
   SETEMPTY(P_Firm.defaultMyFirm);
  END;

  IF ~L_SES.GetValue(L_SES.sit_User, "dfpAssigned", P_Firm.dfpAssigned) THEN
   P_Firm.dfpAssigned:=0;
  END;
  IF ~L_SES.GetValue(L_SES.sit_User, "defaultMyPlace", P_Firm.defaultMyPlace) THEN
   SETEMPTY(P_Firm.defaultMyPlace);
  END;

  IF ~L_SES.GetValue(L_SES.sit_User, "L_APtm.CurBrnch", L_OwnData.CurBrnch) THEN
   SETEMPTY(L_OwnData.CurBrnch);
  END;

  P_Firm.SetMyPlaceForFilter();
  P_Firm.SetMyFirmForFilter();
 END {DefineSesValues};

 PUBLIC PROCEDURE GetMirrorEntity(File: STRING[]): STRING[];
 BEGIN
  IF    File = "AcCut"   THEN RETURN "AcCut2";
  ELSIF File = "AcLog"   THEN RETURN "Ac2Log";
  ELSIF File = "AcsObj"  THEN RETURN "AcsObj2";
  ELSIF File = "Apport"  THEN RETURN "Apport2";
  ELSIF File = "Storage" THEN RETURN "Storage2";
  ELSIF File = "StrLog"  THEN RETURN "Str2Log";
  ELSE
   RETURN "";
  END;
 END {GetMirrorEntity};

 PUBLIC PROCEDURE StandOnMirrorRecord(File: STRING[]);
  VAR
   Ok: SCAL[2];
 BEGIN
  IF    File = "AcCut"   THEN Ok:=SEARCH(AcCut2, AcCut2, AcCut.AcCut);
  ELSIF File = "AcLog"   THEN CONFORM(AcCut2, AC2Log); Ok:=OCCURE(AC2Log);
  ELSIF File = "AcsObj"  THEN Ok:=SEARCH(AcsObj2, AcsObj2, AcsObj.AcsObj);
  ELSIF File = "Apport"  THEN Ok:=SEARCH(Apport2, Apport2, Apport.Apport);
  ELSIF File = "Storage" THEN Ok:=SEARCH(Storage2, Storage2, Storage.Storage);
  ELSIF File = "StrLog"  THEN CONFORM(Storage2, Str2Log); Ok:=OCCURE(Str2Log);
  ELSE
   L_General.CallUs(0);
  END;
  L_General.CallUs(Ok);
 END {StandOnMirrorRecord};

 PUBLIC PROCEDURE GetPrototypeEntity(mirrFile: STRING[]): STRING[];
 BEGIN
  IF    mirrFile = "AcCut2"   THEN RETURN "AcCut";
  ELSIF mirrFile = "Ac2Log"   THEN RETURN "AcLog";
  ELSIF mirrFile = "AcsObj2"  THEN RETURN "AcsObj";
  ELSIF mirrFile = "Apport2"  THEN RETURN "Apport";
  ELSIF mirrFile = "Storage2" THEN RETURN "Storage";
  ELSIF mirrFile = "Str2Log"  THEN RETURN "StrLog";
  ELSE
   RETURN "";
  END;
 END {GetPrototypeEntity};

 PRIVATE PROCEDURE StandOnPrototypeRecord(mirrFile: STRING[]);
  VAR
   Ok: SCAL[2];
 BEGIN
  IF    mirrFile = "AcCut2"   THEN Ok:=SEARCH(AcCut, AcCut, AcCut2.AcCut2);
  ELSIF mirrFile = "Ac2Log"   THEN Ok:=SEARCH(AcLog, AcCut, AC2Log.AcCut2, AC2Log.Date);
  ELSIF mirrFile = "AcsObj2"  THEN Ok:=SEARCH(AcsObj, AcsObj, AcsObj2.AcsObj2);
  ELSIF mirrFile = "Apport2"  THEN Ok:=SEARCH(Apport, Apport, Apport2.Apport2);
  ELSIF mirrFile = "Storage2" THEN Ok:=SEARCH(Storage, Storage, Storage2.Storage2);
  ELSIF mirrFile = "Str2Log"  THEN Ok:=SEARCH(StrLog, Storage, Strg2Log.Storage2, Strg2Log.Date);
  ELSE
   L_General.CallUs(0);
  END;
  L_General.CallUs(Ok);
 END {StandOnPrototypeRecord};

 PUBLIC PROCEDURE GetPrototype(trgFile: STRING[]): STRING[];
  VAR
   protFile: STRING[];
 BEGIN
  protFile:=GetPrototypeEntity(trgFile);
  IF ~!protFile THEN
   StandOnPrototypeRecord(trgFile);
   RETURN protFile;
  ELSE
   RETURN trgFile;
  END;
 END {GetPrototype};

 PUBLIC PROCEDURE IsLinkTo_lsStore(File, Field: STRING[]): SCAL[2];
  VAR
   l: LINK;
 BEGIN
  FOR_EACH l IN TABLE.Get(File).Links DO
   IF (l.Index.Fields(0).Name = Field) & (l.CooIndex.Table.Name = "lsStore") THEN
    RETURN 1;
   END;
  END; (* FOR_EACH *)
  RETURN 0;
 END {IsLinkTo_lsStore};

 PUBLIC PROCEDURE gsv_GetCallProc(File, Field: STRING[]): PROC;
  VAR
   Module: STRING[];
 BEGIN
  IF    (File = "Man") |
        (File = "ManExpr") |
        (File = "ManFml") THEN
   Module:="L_Man";
  ELSIF (File = "Staff"   ) |
        (File = "StaffLog") |
        (File = "Officer" ) |
        (File = "SLKind"  ) |
        (File = "DirtyTyp"  ) |
        (File = "WagePayL") THEN
   Module:="L_Staff";
  ELSIF (File = "Dspt"   )  |
        (File = "DsptMode") |
        (File = "DsptDoc")  |
        (File = "DsptStf")  |
        (File = "DsptTime") |
        (File = "DsptPck")  |
        (File = "ODoc")     |
        (File = "ODocKind") THEN
   Module:="L_Dspt";
  ELSIF (File = "MDocLCU")  THEN
   Module:="L_CUC";
  ELSIF (File = "ManAdr")   THEN
   Module:="L_Russia";
  ELSIF (File = "CtcVal")   |
        (File = "CtcKind")  THEN
   Module:="L_ctc";
  ELSIF (File = "Contract") THEN
   Module:="L_Cntr";
  ELSE
   SETEMPTY(Module);
  END;
  IF ~!Module THEN
   RETURN PROCREF((Module + ".Get" + File + Field + "_asStr"));
  ELSE
   RETURN EMPTYOF(PROC);
  END;
 END {gsv_GetCallProc};

 PUBLIC PROCEDURE GetScalValueInterpretation(File, Field: STRING[]; Idx: SCAL[1E10]): STRING[];
  VAR
   CallProc  : PROC;
   FieldValue: STRING[];
 BEGIN
  FieldValue:=^(TABLE.Get(File).Fields(Field).ObtainName(Idx));
  IF ~!FieldValue THEN
   IF IsLinkTo_lsStore(File, Field) THEN
    RETURN L_lsStore.Get(FieldValue);
   ELSE
    CallProc:=gsv_GetCallProc(File, Field);
    IF ~!CallProc THEN
     RETURN CallProc();
    END;
   END;
  END;
  RETURN FieldValue;
 END {GetScalValueInterpretation};

 PUBLIC PROCEDURE SetApplicationTitle();
  VAR
   ApplicationConsoleTitle: STRING[];
 BEGIN
  SETEMPTY(ApplicationConsoleTitle);
  TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
IF L_General.IsAcceptableProcessorVersion(014225010) THEN
   IF APP.Get().ProductiveCopy THEN
    SE_APPWIN_ICON(FIO.BuildPath("v32.exe", , FIO.AsbSpecialFolders("ASBProcessorRunFrom")), 0);
   END;
END;
   IF APP.Get().SupportMode THEN
    ApplicationConsoleTitle:=L_Str.FixedIntStr(L_General.GetAPSiteNumber(), 2) + " " + L_General.APSupportFolderName;
   ELSE
    ApplicationConsoleTitle:='"⮏"';
   END;
   IF    Str.Match(Str.Cap(FIO.AsbSpecialFolders("ASBProcessorRunFrom")), "*ASBCLIENT.TEST*") THEN
    ApplicationConsoleTitle:=ApplicationConsoleTitle + " ( ⮢ V32)";
   ELSIF Str.Match(Str.Cap(FIO.AsbSpecialFolders("ASBProcessorRunFrom")), "*ASBCLIENT.TMP*") THEN
    ApplicationConsoleTitle:=ApplicationConsoleTitle + " (⮢ V32)";
   END;
   IF L_AR.SessionHasAssignedGroup() THEN
    ApplicationConsoleTitle:="/G " + ApplicationConsoleTitle;
   END;
   IF VAR_IMPL.Get(CurrentProcess).Initialized & ~!CurrentProcess THEN
    ApplicationConsoleTitle:=ApplicationConsoleTitle + " (" + CurrentProcess + ")";
   END;
   ApplicationConsoleTitle:=ApplicationConsoleTitle + " " + L_DatTim.DateStr(Memo.ud_cd()) +
                            " [" + L_DatTim.DateStr(Memo.ud_fr()) + "-" + L_DatTim.DateStr(Memo.ud_ut()) + "]";
   IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
    IF VAR_IMPL.Get(P_Firm.dfmAssigned).Initialized & P_Firm.dfmAssigned THEN
     SEARCH(MyFirm, MyFirm, , P_Firm.defaultMyFirm);
     ApplicationConsoleTitle:=ApplicationConsoleTitle + " !";
    ELSE
     SEARCH(MyFirm, MyFirm, , P_Firm.mf_Own);
    END;
    ApplicationConsoleTitle:=ApplicationConsoleTitle + " " + MyFirm.Name;
   ELSE
    ApplicationConsoleTitle:=ApplicationConsoleTitle + " " + L_OwnData.ODFirmShortName(SYSDATE());
   END;
   IF VAR_IMPL.Get(P_Firm.dfpAssigned).Initialized & P_Firm.dfpAssigned THEN
    SEARCH(MyPlace, MyPlace, , P_Firm.defaultMyPlace);
    ApplicationConsoleTitle:=ApplicationConsoleTitle + " (" + MyPlace.Name + ")";
   END;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ELSE
  END; (* TRY *)
  SE_APPWIN_TITLE(ApplicationConsoleTitle);
 END {SetApplicationTitle};

 PUBLIC PROCEDURE GetFullNameOfCurrentUser(D: DATE): STRING[];
 BEGIN
  RETURN P_Man.GetFullNameOfCurrentUser(D);
 END {GetFullNameOfCurrentUser};

 PUBLIC PROCEDURE GetPostNameOfCurrentUser(D: DATE): STRING[];
  VAR
   Result: STRING[];
   curMan: LIKE(Man.Man);
   curTSN: LIKE(Staff.TSN);
 BEGIN
  Result:="";
  SAVE(Staff);
  curMan:=P_Man.Try_curUSER2Man();
  IF ~!curMan THEN
   curTSN:=L_Staff.Man2TSN(D, curMan, "", 0, 0);
   IF ~!curTSN THEN
    Result:=P_Firm.GetManAttrByTSN(curTSN, D, P_Firm.mpt_ManPostName);
   END;
  END;
  RESTORE(Staff);
  RETURN Result;
 END {GetPostNameOfCurrentUser};

 PUBLIC PROCEDURE GetNameFieldName(File: STRING[]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF File = "AcsObj" THEN
   Result:="FullName";
  ELSE
   Result:="Name";
  END;
  RETURN Result;
 END {GetNameFieldName};

 PUBLIC PROCEDURE GrantRights(srm: L_AR.tSetRightsMode);
 BEGIN
  L_APAR.GrantRights(srm);
 END {GrantRights};

 PUBLIC PROCEDURE SysLogHandler(Mode: NUMERIC[0]);
 BEGIN
  IF !RTI.Get().CurProcess.Env.Item(L_WDO.MWM) THEN
   L_APtm.SysLogHandler(GE_CURFILE(), L_SysLog.ConvModeToSysLogKind(Mode));
   L_Group.SupportInteractiveModificationOwner(GE_CURFILE(), L_SysLog.ConvModeToSysLogKind(Mode));
   IF    L_SysLog.ConvModeToSysLogKind(Mode) = L_SysLog.knd_Delete THEN
    L_r2r.OnBeforeInteractiveDelete(GE_CURFILE());
   ELSIF L_SysLog.ConvModeToSysLogKind(Mode) = L_SysLog.knd_Edit THEN
    L_XDF.UpdateXDFCase(GE_CURFILE());
   END;
  END;
 END {SysLogHandler};

 PUBLIC PROCEDURE UserAssociatedPersonIsActive(D: DATE): SCAL[2];
 BEGIN
  RETURN ~!AcsObj.Man & L_Staff.IsStandOnAnyMainContract(AcsObj.Man, D) & L_Staff.rInState(D);
 END {UserAssociatedPersonIsActive};

 PUBLIC PROCEDURE IsSpecialValidityTable(trgTable: TABLE): SCAL[2];
 BEGIN
  RETURN (trgTable.Name = "Staff") | (trgTable.Name = "Man") | (trgTable.Name = "Car") |
         (trgTable.Name = "CUCopy") | (trgTable.Name = "RprPro") |
         ((trgTable.Name = "OfcDst") & L_PRoll.UseSalDSet());
 END {IsSpecialValidityTable};

 PUBLIC PROCEDURE IsSpecialValidityRecord(trgTable: TABLE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF    trgTable.Name = "OfcDst" THEN
   Result:=(OfcDst.DstMode # L_PRoll.dm_MainSalary);
  ELSIF trgTable.Name = "StaffLog" THEN
   SAVE(SLKind);
   Result:=L_Staff.IsDischargeStaffLog();
   RESTORE(SLKind);
  ELSIF trgTable.Name = "CarLog" THEN
   Result:=(CarLog.Status = L_Car.carst_Retired);
  END;
  RETURN Result;
 END {IsSpecialValidityRecord};

 PRIVATE PROCEDURE intIsSpecialValidityLink(trgLink: LINK; trgFileName, trgCooFileName, trgLinkName: STRING[]): SCAL[2];
 BEGIN
  RETURN ((trgLink.Index.Table.Name = trgFileName) & (trgLink.CooIndex.Table.Name = trgCooFileName) & (trgLink.Name = trgLinkName)) |
         ((trgLink.Index.Table.Name = trgCooFileName) & (trgLink.CooIndex.Table.Name = trgFileName) & (trgLink.Name = trgFileName+"@"+trgLinkName));
 END {intIsSpecialValidityLink};

 PUBLIC PROCEDURE IsSpecialValidityLink(trgLink: LINK): SCAL[2];
 BEGIN
  RETURN intIsSpecialValidityLink(trgLink, "Officer", "Officer", "Boss") |
         intIsSpecialValidityLink(trgLink, "Officer", "Sort",    "BossSort") |
         (L_PRoll.UseSalDSet() & (intIsSpecialValidityLink(trgLink, "MCList", "AcCut", "AcCut") |
                                  intIsSpecialValidityLink(trgLink, "MCList", "DstMode", "DstMode")
                                 )
         );
 END {IsSpecialValidityLink};

 PUBLIC PROCEDURE GetSpecialRecordValidity(trgTable: TABLE;
                                           VAR valFRVT: L_DBD.tFileRecordsValidityType;
                                           VAR valBD, valED: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=1;
  IF    trgTable.Name = "bpRT" THEN
   valFRVT:=L_DBD.frvt_None;
   valBD:=L_DatTim.GetDateOfTIMESTAMP(bpRT.BegTime);
   valED:=EMPTYOF(DATE);
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {GetSpecialRecordValidity};

 PUBLIC PROCEDURE IsAnyProTable(curTable: TABLE): SCAL[2];
  VAR
   Idx: L_Prop.tProObject;
 BEGIN
  FOR_EACH Idx DO
   IF L_Prop.ObjectFileProName(Idx) = curTable.Name THEN
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {IsAnyProTable};

 PUBLIC PROCEDURE AccountDateFieldName(trgTable: TABLE): STRING[];
 BEGIN
  RETURN L_XDoc.DateFieldName(trgTable.Name);
 END {AccountDateFieldName};

 PUBLIC PROCEDURE IsAccumBorrow(trgTable: TABLE): SCAL[2];
 BEGIN
  RETURN (trgTable.Name = "StaffMon") |
         (trgTable.Name = "PCalc")    |
         (trgTable.Name = "XCalc")    |
         (trgTable.Name = "SrMnthly") |
         (trgTable.Name = "Monthly")  |
         (trgTable.Name = "Money")    |
         (trgTable.Name = "ManSFee")  |
         (trgTable.Name = "MathMty")  |
         (trgTable.Name = "MathRun")  |
         (trgTable.Name = "CarRun")   |
         (trgTable.Name = "XODone");
 END {IsAccumBorrow};

 PUBLIC PROCEDURE DateIndexName(TableName: STRING[]): STRING[];
  VAR
   dfn: STRING[];
 BEGIN
  dfn:=L_XDoc.DateFieldName(TableName);
  IF ~!dfn & ~!TABLE.Get(TableName).Indexes(dfn) THEN
   RETURN dfn;
  ELSIF TableName = "EDOrderL" THEN
   RETURN "Closed";
  END;
  RETURN "";
 END {DateIndexName};

 PUBLIC PROCEDURE SetAllAccessPoints();
 BEGIN
  L_AcsPnt.InitAcsPnt(0000001, ".䨪.४஢ 楯窨", "४஢ 楯窨 ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_RWOp, L_AcsPnt.aprm_None, L_AcsPnt.apra_4Manager);

  L_AcsPnt.InitAcsPnt(0000002, "⭨.䨪.  ᫮", "   ᫮", L_AcsPnt.aprm_Inform);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Staff, L_AcsPnt.aprm_Inform, L_AcsPnt.apra_4Manager);

  L_AcsPnt.InitAcsPnt(0000003, "⭨.䨪", " ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Staff, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000004, ".७..䨪", "䨪 ७  ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_FuelStock, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000005, ".७.䨪", "䨪 ७ ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Stock, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000006, ".譨.䨪. ", "   ", L_AcsPnt.aprm_Choice);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Acnt, L_AcsPnt.aprm_Choice, L_AcsPnt.apra_4Manager);

  L_AcsPnt.InitAcsPnt(0000007, "⭨..", " ௫", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_General.UsersGroupName(), L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000008, ".䨪", "䨪 ᠭ ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_General.UsersGroupName(), L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000009, ".㧪 室", "㧪 室 .", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_General.UsersGroupName(), L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000010, "⭨.䨪. ⨯ 㤮 ", " ⨯ 㤮 ", L_AcsPnt.aprm_Choice);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Staff, L_AcsPnt.aprm_Choice, L_AcsPnt.apra_4Manager);
  L_AcsPnt.InsertSingleAcsPntR("Eng", L_AcsPnt.aprm_Choice, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000011, "⭨.䨪. ", "   ࠪ", L_AcsPnt.aprm_Choice);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Staff, L_AcsPnt.aprm_Choice, L_AcsPnt.apra_4Manager);
  L_AcsPnt.InsertSingleAcsPntR("Eng", L_AcsPnt.aprm_Choice, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000012, ".ᬮ ⪮", "ᬮ ⪮  ᪫", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Acnt, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Stock, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_FuelStock, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR("SupplyAgent", L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR("StockView", L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR("Tech", L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000013, "..⪠", "⪠ ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Acnt, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Stock, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_FuelStock, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR("SupplyAgent", L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000014, "..ࠡ⪠", "ࠡ⪠ ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_General.UsersGroupName(), L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000015, "..", " 楢  ꥪ ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_General.UsersGroupName(), L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000016, ".易 㬥.ନ஢ / 㤠", "ନ஢, 㤠 易 㬥⮢", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Acnt, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Stock, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000017, ".ࠡ⪠", "ࠡ⪠ ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_General.UsersGroupName(), L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000018, ".䨪", "䨪 㬥⮢  ⢨/ -।", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Staff, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Sheet, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_twoOp, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000019, ".⪠", "⪠ ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_RWOp, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000020, "..", " ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Acnt, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Stock, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_FuelStock, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR("SupplyAgent", L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000021, ".  뫪    ࠡ.䨪.  ᫮", "䨪 ७    ᫮", L_AcsPnt.aprm_Choice);

  L_AcsPnt.InitAcsPnt(0000022, ".஢", "஢ ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_RWOp, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000023, ".䨪", "ଫ ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_General.UsersGroupName(), L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000024, "..䨪", "ଫ 蠡 ", L_AcsPnt.aprm_None);

  L_AcsPnt.InitAcsPnt(0000025, "⨥ ਮ.௫.믮", "⨥   ௫", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_PayRoll, L_AcsPnt.aprm_None, L_AcsPnt.apra_4Manager);

  L_AcsPnt.InitAcsPnt(0000026, "⨥ ਮ.௫.⬥", "⨥   ௫. ਢ   ⮢,  ᫥⥫쭮,  室 ᤥ     ", L_AcsPnt.aprm_CrucialChoice);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_PayRoll, L_AcsPnt.aprm_CrucialChoice, L_AcsPnt.apra_4Manager);

  L_AcsPnt.InitAcsPnt(0000027, "⨥ ਮ. ⮢.믮", "⨥   ⠬", L_AcsPnt.aprm_None);

  L_AcsPnt.InitAcsPnt(0000028, "⨥ ਮ. ⮢.⬥", "⨥   ⠬. ਢ   ⮢,  ᫥⥫쭮,  室 ᤥ     ", L_AcsPnt.aprm_CrucialChoice);

  L_AcsPnt.InitAcsPnt(0000029, ".ᬮ ", "ᬮ    ᠭ ", L_AcsPnt.aprm_Choice);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Acnt, L_AcsPnt.aprm_Choice, L_AcsPnt.apra_4Manager);

  L_AcsPnt.InitAcsPnt(0000030, ".", " ", L_AcsPnt.aprm_None);

  L_AcsPnt.InitAcsPnt(0000032, ".ਥ.⥫ 室 ⮯", "ਥ   ⥫ 室 ⮯", L_AcsPnt.aprm_CrucialChoice);

  L_AcsPnt.InitAcsPnt(0000033, ".஢.஫ ᮮ⢥⢨ ᯨᠭ", "஢  c ⪫  ᯨᠭ", L_AcsPnt.aprm_Choice);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_RWOp, L_AcsPnt.aprm_Choice, L_AcsPnt.apra_4Manager);

  L_AcsPnt.InitAcsPnt(0000034, "ࢨ 㬥 (  ).८  䨪樨", "८, ⠭, ⨥  䨪樨 ࢨ 㬥⮢", L_AcsPnt.aprm_Choice);

  L_AcsPnt.InitAcsPnt(0000035, "⭨.᢮ -", "᢮ -", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Staff, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000036, "..  ॠ쭮 ६.䨪. 㬥⮢, ଫ 㣨 짮⥫", " ⮢ 㬥⮢    ॠ쭮 ६, ଫ 㣨 짮⥫", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Stock, L_AcsPnt.aprm_None, L_AcsPnt.apra_4Manager);
  L_AcsPnt.InsertSingleAcsPntR("Eng", L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000037, "..ࠡ⪠  ⮬ ", "ࠡ⪠   ⮬ ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Stock, L_AcsPnt.aprm_None, L_AcsPnt.apra_4Manager);
  L_AcsPnt.InsertSingleAcsPntR("Eng", L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000038, "..", " 楢 ⮢ ꥪ⮢ ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Acnt, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000039, "..䨪", "䨪 ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Acnt, L_AcsPnt.aprm_None, L_AcsPnt.apra_4Manager);

  L_AcsPnt.InitAcsPnt(0000040, "㣨 祭.ࠢ", "ࠢ 㣨 祭ﬨ", L_AcsPnt.aprm_None);

  L_AcsPnt.InitAcsPnt(0000041, "㣨 祭.", "  㣨 祭ﬨ", L_AcsPnt.aprm_None);

  L_AcsPnt.InitAcsPnt(0000042, ".  ᥬ 㬥⠬", ".  ᥬ 㬥⠬", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Acnt, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_PayRoll, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000043, ".譨.䨪", "䨪 譨 ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Acnt, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Stock, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR("SupplyAgent", L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000044, "..ᬮ", "ᬮ 楢 ⮢ ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Acnt, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_PayRoll, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000045, ".⬥ ।  -", "⬥ ।   -", L_AcsPnt.aprm_Choice);

  L_AcsPnt.InitAcsPnt(0000046, ".㯯஢筠 .䨪", "ଫ 㯯஢筮  ", L_AcsPnt.aprm_None);

  L_AcsPnt.InitAcsPnt(0000047, ".  ।", "  楤  ।  믮", L_AcsPnt.aprm_None);

  L_AcsPnt.InitAcsPnt(0000048, ".䨪 ।", "䨪 (㤠 㦨 ᥩ,  浪 믮) । ", L_AcsPnt.aprm_None);

  L_AcsPnt.InitAcsPnt(0000049, ".  '⠭'", "⠭  '⠭', ⬥ 襭 ⮢ ⯥⠭ 鸞", L_AcsPnt.aprm_CrucialChoice);

  L_AcsPnt.InitAcsPnt(0000050, ".  'ᠭ'", "⠭  'ᠭ', ⬥ 襭 ⮢ ᠭ 鸞", L_AcsPnt.aprm_CrucialChoice);

  L_AcsPnt.InitAcsPnt(0000051, "⭨..䨪 ⥫쭮 ଠ樨", " 䨪 '⥫쭮 ଠ樨'  ப ", L_AcsPnt.aprm_None);

  L_AcsPnt.InitAcsPnt(0000052, " ࠡ⭨.䨪.  ⮬ ", "䨪 ⠡ ࠡ⭨  ⮬ ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_PayRoll, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000053, "⥢ 㬥.८  䨪樨", "८, ⠭, ⨥  䨪樨 ⥢ 㬥⮢", L_AcsPnt.aprm_Choice);

  L_AcsPnt.InitAcsPnt(0000054, ".७.  .䨪", "䨪 ", L_AcsPnt.aprm_None);

  L_AcsPnt.InitAcsPnt(0000055, "SMS.ᮢ 뫪", "ᮢ 뫪 SMS", L_AcsPnt.aprm_None);

  L_AcsPnt.InitAcsPnt(0000056, ".७.  .  ⠭묨 ࠢ.䨪", "䨪     ⠭묨 ࠢ", L_AcsPnt.aprm_None);

  L_AcsPnt.InitAcsPnt(0000057, ".䨪. ", "   ", L_AcsPnt.aprm_Choice);

  L_AcsPnt.InitAcsPnt(0000058, "⭨..  ᫮", " ௫  ᫮ ( 3 楢  ᫥ ⮣ )", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_PayRoll, L_AcsPnt.aprm_None, L_AcsPnt.apra_4Manager);
  L_AcsPnt.InsertSingleAcsPntR("Eng", L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000059, "ࢨ 㬥 (  ).ॢ襭 ࠭祭 㬬   ७", "ଫ ࢨ筮 㬥 ᢥ ࠭祭 㬬   ७", L_AcsPnt.aprm_Choice);

  L_AcsPnt.InitAcsPnt(0000060, ".஢. , ଫ  ", "  ⠪஢  , ଫ  ⭮ ", L_AcsPnt.aprm_None);

  L_AcsPnt.InitAcsPnt(0000061, ".ଫ  㢮 ࠡ⭨", "ଫ   㢮 ࠡ⭨", L_AcsPnt.aprm_Choice);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_TckCashier, L_AcsPnt.aprm_Choice, L_AcsPnt.apra_4Manager);

  L_AcsPnt.InitAcsPnt(0000062, ".䨪. ॣ  娨", " ॣ  娨 ", L_AcsPnt.aprm_Choice);

  L_AcsPnt.InitAcsPnt(0000063, ".७.䨪.䨪 , 易  㣨 㬥⠬,  ᪠ ", "䨪 , 易  㣨 㬥⠬,  ᪠ ", L_AcsPnt.aprm_Choice);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Stock, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000064, "SMS.饭 ⥫  ࠬ  ० ࠡ  ", "饭 ⥫  ࠬ  ० ࠡ  ", L_AcsPnt.aprm_None);
  L_AcsPnt.InsertSingleAcsPntR(L_APtm.g_Disp, L_AcsPnt.aprm_None, L_AcsPnt.apra_Allowed);

  L_AcsPnt.InitAcsPnt(0000065, ".ଫ ⥫ ' ࠢ'", " ⥫  ⪫    ࠢ", L_AcsPnt.aprm_Choice);

  L_AcsPnt.InitAcsPnt(0000066, ".ଫ  ' ࠢ'", "   ⪫    ࠢ", L_AcsPnt.aprm_Choice);
 END {SetAllAccessPoints};

 PUBLIC PROCEDURE DoCommand(Type, Command: STRING[]);
 BEGIN
  L_APMsg.DoCommand(Type, Command);
 END {DoCommand};

END.
