(*
%Copyright   (c) Polak IT
%Author      29.09.2006 12:19:01 POLAK\GAV
%Purpose     know-how     ᨬ   ஥
%Type        library
%Specific    SYS
%Modified    18.03.2014 10:09:20 POLAK\San
%Environment
*)

 MODULE L_PDBS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Staff, L_Man, L_MathR, L_Car, L_MDoc, Str, L_Str, L_Prop, L_OLE,
        P_Man, P_Staff, P_Car, P_Mark, P_Route, P_EDOKnd, L_Russia,
        P_Math, P_Firm, P_Union, P_Sort, P_Cntr, P_Post, P_Officer,
        L_BegRWS, L_ctc, L_AR, L_ODoc, L_kn;

 PUBLIC PROCEDURE FileOfPseudonim(Pseudonim: STRING[]): STRING[];
 BEGIN
  IF    Pseudonim = "APrMDoc"  THEN RETURN "MDoc";
  ELSIF Pseudonim = "ASpMDoc"  THEN RETURN "MDoc";
  ELSIF Pseudonim = "BgStfLog" THEN RETURN "StaffLog";
  ELSIF Pseudonim = "ManBtAdr" THEN RETURN "ManAdr"; (* Bt  Bth ⮡   8 ᨬ *)
  ELSIF Pseudonim = "ManRgAdr" THEN RETURN "ManAdr";
  ELSIF Pseudonim = "ManDwAdr" THEN RETURN "ManAdr";
  ELSIF Pseudonim = "WrkPhone" THEN RETURN "CtcVal";
  ELSIF Pseudonim = "HomPhone" THEN RETURN "CtcVal";
  ELSIF Pseudonim = "OthPhone" THEN RETURN "CtcVal";
  ELSIF Pseudonim = "WrkClPhn" THEN RETURN "CtcVal";
  ELSIF Pseudonim = "HomClPhn" THEN RETURN "CtcVal";
  ELSIF Pseudonim = "OthClPhn" THEN RETURN "CtcVal";
  ELSIF Pseudonim = "WrkEMail" THEN RETURN "CtcVal";
  ELSIF Pseudonim = "HomEMail" THEN RETURN "CtcVal";
  ELSIF Pseudonim = "OthEMail" THEN RETURN "CtcVal";
  ELSE
   RETURN Pseudonim;
  END;
 END {FileOfPseudonim};

 PUBLIC PROCEDURE PseudoFiles(srcFile: STRING[]): STRING[];
 BEGIN
  IF    srcFile = "Math" THEN
   RETURN "APrMDoc|ASpMDoc";
  ELSIF srcFile = "Man" THEN
   RETURN "Staff|ManBtAdr|ManRgAdr|ManDwAdr";
  ELSIF srcFile = "Staff" THEN
   RETURN "BgStfLog";
  ELSIF srcFile = "Contact" THEN
   RETURN "WrkPhone|HomPhone|OthPhone|WrkClPhn|HomClPhn|OthClPhn|WrkEMail|HomEMail|OthEMail";
  ELSE
   RETURN "";
  END;
 END {PseudoFiles};

 PUBLIC PROCEDURE PseudoFileDescription(fileName: STRING[]): STRING[];
 BEGIN
  IF    fileName = "APrMDoc"  THEN RETURN "   ᯫ ()";
  ELSIF fileName = "ASpMDoc"  THEN RETURN " ᯨᠭ ()";
  ELSIF fileName = "BgStfLog" THEN RETURN "ਪ  ਥ";
  ELSIF fileName = "ManBtAdr" THEN RETURN " " + L_Man.GetManAdrType_asStr(L_Russia.at_BthMA);
  ELSIF fileName = "ManRgAdr" THEN RETURN " " + L_Man.GetManAdrType_asStr(L_Russia.at_RgMA);
  ELSIF fileName = "ManDwAdr" THEN RETURN " " + L_Man.GetManAdrType_asStr(L_Russia.at_DwMA);
  ELSIF fileName = "WrkPhone" THEN RETURN "稩 ⥫䮭";
  ELSIF fileName = "HomPhone" THEN RETURN "譨 ⥫䮭";
  ELSIF fileName = "OthPhone" THEN RETURN "稩 ⥫䮭";
  ELSIF fileName = "WrkClPhn" THEN RETURN "稩 ⮢ ⥫䮭";
  ELSIF fileName = "HomClPhn" THEN RETURN "譨 ⮢ ⥫䮭";
  ELSIF fileName = "OthClPhn" THEN RETURN "稩 ⮢ ⥫䮭";
  ELSIF fileName = "WrkEMail" THEN RETURN "稩 E-Mail";
  ELSIF fileName = "HomEMail" THEN RETURN "譨 E-Mail";
  ELSIF fileName = "OthEMail" THEN RETURN "稩 E-Mail";
  ELSE
   RETURN "";
  END;
 END {PseudoFileDescription};

 PUBLIC PROCEDURE ConformToPseudoFile(    From,
                                          To             : STRING[];
                                          D              : DATE;
                                      VAR NeedReturnValue: SCAL[2];
                                      VAR ReturnValue    : STRING[]): SCAL[2];
 BEGIN
  NeedReturnValue:=0;
  IF    (From = "Man") & (To = "Staff") THEN
   L_Staff.StandOnAnyMainContract(Man.Man, D);
  ELSIF (From = "Man") & Str.Match(To, "Man??Adr") THEN
   IF ~L_Man.AccessManAdr(Man.Man, D, L_Str.PositionInPool("ManBtAdr|ManRgAdr|ManDwAdr", To)) THEN
    NeedReturnValue:=1;
    ReturnValue    :="-";
   END;
  ELSIF (From = "Math") & (To = "APrMDoc") THEN
   IF ~L_MathR.AccessMDoc_asAPr(Math.Math) THEN
    NeedReturnValue:=1;
    ReturnValue    :="-";
   END;
  ELSIF (From = "Math") & (To = "ASpMDoc") THEN
   IF ~L_MathR.AccessMDoc_asASp(Math.Math) THEN
    NeedReturnValue:=1;
    ReturnValue    :="-";
   END;
  ELSIF (From = "Staff") & (To = "BgStfLog") THEN
   L_Man.StandOnLastBegan(Staff.TSN, D);
  ELSIF (From = "Contact") & (FileOfPseudonim(To) = "CtcVal") THEN
   IF ~L_ctc.PosToCtcVal(Contact.Contact, D, L_Str.PositionInPool("Wrk|Hom|Oth", Str.Slice(To, 0, 3)),
                         L_Str.PositionInPool("Phone|ClPhn| | | |EMail| | |", Str.Slice(To, 3, 5))) THEN
    NeedReturnValue:=1;
    ReturnValue    :="-";
   END;
  ELSE
   RETURN 0;
  END;
  RETURN 1;
 END {ConformToPseudoFile};

 PUBLIC PROCEDURE PseudoFields(srcFile: STRING[]): STRING[];
 BEGIN
  IF srcFile = "Man" THEN
   RETURN "RgManAdr|DwManAdr|BthManAdr|Citizen|Name_Sh";
  ELSIF srcFile = "Car" THEN
   RETURN "Run";
  ELSIF srcFile = "Staff" THEN
   RETURN "Acs2Rout|Acs2Mark|Name_Lat";
  ELSE
   RETURN "";
  END;
 END {PseudoFields};

 PUBLIC PROCEDURE PseudoFieldDescription(srcFile, fieldName: STRING[]): STRING[];
 BEGIN
  IF    srcFile = "Man" THEN
   IF    fieldName = "RgManAdr" THEN  RETURN " " + L_Man.GetManAdrType_asStr(L_Russia.at_RgMA);
   ELSIF fieldName = "DwManAdr" THEN  RETURN " " + L_Man.GetManAdrType_asStr(L_Russia.at_DwMA);
   ELSIF fieldName = "BthManAdr" THEN RETURN " " + L_Man.GetManAdrType_asStr(L_Russia.at_BthMA);
   ELSIF fieldName = "Citizen"  THEN  RETURN " ⥫⢠";
   ELSIF fieldName = "Name_Sh"  THEN  RETURN " . .";
   END;
  ELSIF srcFile = "Car" THEN
   IF    fieldName = "Run" THEN       RETURN "஡  ";
   END;
  ELSIF srcFile = "Staff" THEN
   IF    fieldName = "Acs2Rout" THEN RETURN "  ";
   ELSIF fieldName = "Acs2Mark" THEN RETURN "  ન";
   ELSIF fieldName = "Name_Lat" THEN RETURN "  ⨭᪮ ࠭ਯ樨";
   END;
  END;
  RETURN "";
 END {PseudoFieldDescription};

 PUBLIC PROCEDURE GetPseudoFieldValue(    File,
                                          Field      : STRING[];
                                          D          : DATE;
                                      VAR ReturnValue: STRING[]): SCAL[2];
  VAR
   Dummy: SCAL[2];
 BEGIN
  IF    (File = "Man") & (Field = "DwManAdr") THEN
   IF L_Man.AccessManAdr(Man.Man, D, L_Russia.at_DwMA) THEN
    ReturnValue:=L_Man.GetPostAdr_asStr(1);
   ELSE
    ReturnValue:="-";
   END;
  ELSIF (File = "Man") & (Field = "RgManAdr") THEN
   ReturnValue:=L_Man.GetAdr_asStr(Man.Man, D, L_Russia.at_RgMA);
  ELSIF (File = "Man") & (Field = "BthManAdr") THEN
   ReturnValue:=L_Man.GetAdr_asStr(Man.Man, D, L_Russia.at_BthMA);
  ELSIF (File = "Man") & (Field = "Citizen") THEN
   ReturnValue:=L_Man.CitizenAsStr(Man.Man, D);
  ELSIF (File = "Man") & (Field = "Name_Sh") THEN
   ReturnValue:=L_Str.ShortName(Man.Name);
  ELSIF (File = "Car") & (Field = "Run") THEN
   ReturnValue:=Str.Condense(FLDTOSTR(L_Car.GetGlobalRun(Car.BoxNbr, D)));
  ELSIF (File = "Staff") & (Field = "Acs2Rout") THEN
   ReturnValue:=L_BegRWS.GetPermitToRouteList(D, Staff.TSN, Dummy);
  ELSIF (File = "Staff") & (Field = "Acs2Mark") THEN
   ReturnValue:=L_BegRWS.GetPermitToMarkGList(D, Staff.TSN);
  ELSIF (File = "Staff") & (Field = "Name_Lat") THEN
   ReturnValue:=L_Staff.GetStaffLatinName(D);
  ELSE
   RETURN 0;
  END;
  RETURN 1;
 END {GetPseudoFieldValue};

 PUBLIC PROCEDURE HasActualPro(PrevPart,
                               Part,
                               NextPart: STRING[];
                               D       : DATE): SCAL[2];
  VAR
   ModuleName,
   ObjectKey  : STRING[];
   HasActual  : PROC;
 BEGIN
  ModuleName:=L_Prop.GetModuleName(L_Prop.GetObjNum(Part));
  HasActual :=PROCREF(^(ModuleName + ".HasActual" + Part));
  IF !HasActual THEN
   HasActual:=PROCREF(^(ModuleName + ".HasActualPro_Normal"));
  END;
  IF !HasActual THEN
   HasActual:=PROCREF(^(ModuleName + ".HasActualPro"));
  END;
  L_OLE._Assert(-5, ~!HasActual, "L_OLE.HasActualPro Error 1");

  IF    ModuleName = "P_Officer" THEN ObjectKey:="Officer.Sort, Officer.Officer";
  ELSIF PrevPart = "Staff"       THEN ObjectKey:="Staff.TSN";
  ELSIF PrevPart = "Car"         THEN ObjectKey:="Car.BoxNbr";
  ELSE                                ObjectKey:=PrevPart+"."+PrevPart;
  END;
  RETURN HasActual(^ObjectKey, D, NextPart);
 END {HasActualPro};

 PUBLIC PROCEDURE GetF1SpecialPage(CurFile: STRING[]; VAR Page, humPagePat: STRING[]);
  VAR
   TopWindow: WINDOW;
 BEGIN
  SETEMPTY(Page);
  TopWindow:=APP.Get().TopWindow;
  IF    (CurFile = "Packet") & ACCESS(Packet) & (Packet.Receiver = 2) THEN
   Page:="壠᪠   ⭮  ஭ ";
  ELSIF (CurFile = "AcsObj") & ACCESS(AcsObj) THEN
   IF AcsObj.Type = L_AR.aot_User THEN
    Page:="짮⥫";
   ELSE
    Page:="㯯 짮⥫";
   END;
  ELSIF (CurFile = "Math") & ACCESS(Math) THEN
   IF    Math.MathKind = L_MathR.mathk_Math THEN
    Page:="ꥪ ਠ쭮 ";
   ELSIF Math.MathKind = L_MathR.mathk_KeyAs THEN
    Page:="᭮ ।⢠";
   ELSE
    L_General.CallUs(0);
   END;
  ELSIF (CurFile = "MDoc") & ACCESS(MDoc) THEN
   IF    L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) THEN
    Page:="㬥   ";
   ELSE
    Page:=" 㬥";
   END;
  ELSIF CurFile = "bpRT" THEN
   IF TopWindow.OriginalName = "bpSh" THEN
    Page:="।  믮  楤";
   END;
  ELSIF CurFile = "OwnDPro" THEN
   Page:=TABLE.Get("OwnDPro").Description;
  ELSIF CurFile = "ODoc" THEN
   Page:=TABLE.Get("ODoc").Description;
   IF ACCESS(ODocKind) THEN
    IF    L_kn.Is(SYSDATE(), L_ODoc.erkn_RAccid) THEN
     Page:="  ";
    ELSIF L_kn.Is(SYSDATE(), L_ODoc.erkn_MedicalExaminationAct) THEN
     Page:=" ( 짮⥫)";
    END;
   END;
  ELSIF ~!TopWindow THEN
   IF TopWindow.Type = WINDOW.Type_Loadable THEN
    IF    TopWindow.OriginalName = "SpcPrntr" THEN
     Page:="ன ਭ஢";
    ELSIF TopWindow.OriginalName = "StfSMSPrp" THEN
     Page:="SMS-饭";
    ELSIF TopWindow.OriginalName = "GasStan" THEN
     Page:=" ( 짮⥫)";
    ELSIF TopWindow.OriginalName = "bpQPrep" THEN
     Page:="।  믮  楤";
    ELSIF TopWindow.OriginalName = "OwnDProA" THEN
     Page:=TABLE.Get("OwnDPro").Description;
    ELSIF (TopWindow.OriginalName = "TckRcD3") |
          (TopWindow.OriginalName = "TckRcD3E") THEN
     Page:="㬥  த ⭮ த樨";
    ELSIF TopWindow.OriginalName = "OutPost" THEN
     Page:="ਭ  /";
    ELSIF TopWindow.OriginalName = "REFrCast" THEN
     Page:="஢ ய⨩ ( 짮⥫)";
    ELSIF TopWindow.OriginalName = "TRSWrOut" THEN
     Page:="⭠  ( 짮⥫)";
    END;
   END;
  END;
  humPagePat:=Page;
 END {GetF1SpecialPage};

END.