(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose     ⥪  ࠡ  PDoc
%Type        library
%Specific    SYS
%Modified    03.09.2014 16:59:00 POLAK\Bor
%Environment
*)

 MODULE L_PDoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tMoneyKind           = SCAL[4];
  tPDocTotalFillMethod = SCAL[3];
  tEvent               = SCAL[10];
  tTurn                = NUMERIC[0];

 PUBLIC CONST
  mk_Nothing    = 0; (*tMoneyKind*)
  mk_Cash       = 1;
  mk_Bank       = 2;
  mk_OprDskCash = 3;

  cb_NoCB_Nick  = "NoCLB";

  st_Prepared  = 0; (* ⮢ *)
  st_Passed    = 1; (* ஢    *)
  st_Canceled  = 2; (* ⬥     *)
  st_Pool      = "⮢|஢|㫨஢";

  src_Manual     = 0; (*  *)
  src_Auto       = 1; (* ⮬᪨ *)
  src_InProgress = 2; (* "" *)

  typ_Once  = 0;
  typ_Mass  = 1;
  typ_Other = 2;
  typSalPDoc_pool = "|ᮢ|稩|";

  pd_RKO = 01;
  pd_PKO = 02;
  pd_IPP = 03;
  pd_VPP = 04;
  pd_IMO = 05;
  pd_VMO = 06;
  pd_ITP = 07;
  pd_VTP = 08;
  pd_OVN = 09;
  pd_CND = 10;
  pd_AVO = 11;
  pd_VPK = 12;
  pd_IPK = 13;
  pd_VhP = 14;
  pd_IsP = 15;
  pd_VPG = 16;
  pd_IPG = 17;
  pd_AIN = 18;
  pd_ROO = 19;
  pd_POO = 20;
  pd_AII = 21;

  ev_DeductTransfer        = 0;
  ev_MainPay               = 1;
  ev_AdvnPay               = 2;
  ev_CurWholeSal           = 3;
  ev_PrvWholeSal           = 4;
  ev_McodPay               = 5;
  ev_FordPay               = 6;
  ev_FutSal                = 7; (*??*)
  ev_EdordPay              = 8;
  ev_OnePayPDeductTransfer = 9;

  pdl_st_Paid      = 0; (*믫祭*)
  pdl_st_NotPaid   = 1; (* 믫祭*)
  pdl_st_Deposited = 2; (*஢*)

  fa_CashOffice = 00; (*   -  *)

  pd_DefaultTemplateVersion = "01";

  pdtfm_Manual     = 0;
  pdtfm_byPDocList = 1;
  pdtfm_byPDocMDoc = 2;

  fpdsn_No                 = 0; (*FillPDocSrcNbr*)
  fpdsn_Yes                = 1;
  fpdsn_YesAndNotAllowEdit = 2;

  cb_DownloadPDocNotRealized = "㧪 믨᪨  ॠ";

  spl_KO = 0;
  spl_PP = 1;

  EOR_PAYP    = 10;   (* 祭 ⥦  室 थ஢ *)
  SPC_DEDTYPE = 00;   (* DedType  䨪⨢ 㤥ঠ  \ *)

  np_No  = 0; (*PDoc_OnAnyModification.NeedProceed*)
  np_Yes = 1;
  np_Try = 2;

  MaxPDocCommentLength = 210;

 PUBLIC PERMANENT VAR
  (* default operational desk *)
  dodAssigned: SCAL[2];
  dodMyFirm  : LIKE(MyFirm.MyFirm);
  dodFirmAcnt: LIKE(FirmAcnt.FirmAcnt);

 PUBLIC VAR
  ForceUnClosedPay: SCAL[2]; (* ⥫ ௫  ( ६ ஬ *)

 PUBLIC TYPE
  tRequiredPDocKind = SCAL[3];
 PUBLIC CONST
  pdkrq_Disabled   = 0;
  pdkrq_Required   = 1;
  pdkrq_Unrequired = 2;

 IMPORT Memo, L_StdFrm, L_DatTim, E_PDoc, Str, P_Firm, L_Acnt, L_XObj, L_WDO, L_PRoll,
        L_General, L_PayP, L_Str, L_XDoc, L_AFM, L_EC, L_MDoc, L_JDoc, L_Cntr,
        L_Money, P_PDoc, L_Staff, L_OwnData, L_APtm, L_EDO, E_PRoll,
        L_Hld, L_Pmnt, L_Dest, P_Cntr, P_MDoc, FIO, L_FIO, P_MySite, L_Prop;

 PRIVATE CONST
  RepName = "PDcL1";

 PRIVATE VAR
  _Event             : tEvent;            (* ⨥ *)
  EventName          : STRING[];
  _Type              : LIKE(PDoc.Type);
  SalPayLev,                              (*  ௫  楢  (  믫稢 १ ) *)
  ForceEOPay         : SCAL[2];           (* ਭ㤨⥫쭮 믫稢 १  *)
  WithTurn           : SCAL[2];           (*  믫   祬  ਥ *)
  _DeductTransferTurn: NUMERIC[0];        (*  뤥 ⥫騪  ⮢ *)
  _CurTurn           : NUMERIC[0];        (*  ࠧ   祭 ⨯ "쪮 祭" *)

(*
$P { Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|                        ᮪ ᮧ 㬥⮢                         |
}
*)

(*
$P{ PDK_Top:
@
|----------------------------------------------------------------------------|
| 㬥|    |     |      ||                㬬||
|-------------|---------|-------|----------|----|---------------------|------|
}
*)

(*
$P { Line:
PDocKind.PDocKind, L, ""
PDocKind.Sign, L, ""
PDoc.PDoc, L, ""
PDoc.SrcNbr, L, ""
L_DatTim.DateStr(PDoc.Date), L, ""
PDoc.Firm, L, ""
PDoc.Total, R, ",2-"
?, L, "-|+"
@
|## ##########|#########|#######|##########|####|#####################|   #  |
}
*)

(*
$P { PDK_Bot:
PDocKind.Sign, L, ""
?, R, ",2-"
@
|-----------------------------------------------|---------------------|------|
|⮣  ###                                   |#####################|      |
}
*)

(*
$P { Bottom:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE PDocPrgCheck(C: SCAL[2]; Src: STRING[]);
 BEGIN
  L_General.Assert(C, "訡  ணࠬ ନ஢ ⥦ 㬥⮢| ᫥ "+Src);
 END {PDocPrgCheck};

 PRIVATE PROCEDURE IsDeductEvent(): SCAL[2];
 BEGIN
  RETURN (_Event = ev_DeductTransfer) | (_Event = ev_OnePayPDeductTransfer);
 END {IsDeductEvent};

 PRIVATE PROCEDURE IsSalaryEvent(): SCAL[2];
 BEGIN
  RETURN (_Event >= ev_MainPay) & (_Event <= ev_EdordPay);
 END {IsSalaryEvent};

 PUBLIC PROCEDURE IsMassDocEvent(): SCAL[2];
 BEGIN
  RETURN (_Event = ev_MainPay) | (_Event = ev_AdvnPay) | (_Event = ev_McodPay) |
         (_Event = ev_FordPay) | (_Event = ev_FutSal) | (_Event = ev_EdordPay);
 END {IsMassDocEvent};

 PUBLIC PROCEDURE ForceEOrdPay();
 BEGIN
  ForceEOPay:=1;
 END {ForceEOPay};

 PUBLIC PROCEDURE ForceUnClosedSalPDoc();
 BEGIN
  ForceUnClosedPay:=1;
 END {ForceUnClosedSalPDoc};

 PUBLIC PROCEDURE PDocKindHasStructuredComment(trgPDocKind: LIKE(PDocKind.PDocKind)): SCAL[2];
 BEGIN
  RETURN (trgPDocKind = pd_RKO) |
         (trgPDocKind = pd_PKO) |
         (trgPDocKind = pd_OVN) |
         (trgPDocKind = pd_CND) |
         (trgPDocKind = pd_AVO) |
         (trgPDocKind = pd_AIN) |
         (trgPDocKind = pd_AII) |
         (trgPDocKind = pd_ROO) |
         (trgPDocKind = pd_POO);
 END {PDocKindHasStructuredComment};

 PUBLIC PROCEDURE IsDeductPayP(_PayP: LIKE(PayP.PayP)): SCAL[2];
 BEGIN
  RETURN _PayP=50(*믫 १  3- 栬*);
 END {IsDeductPayP};

 PUBLIC PROCEDURE IsActiveSpecDeduct(D: DATE): SCAL[2];
 BEGIN
  RETURN (Deduct.DedType = SPC_DEDTYPE) & (Deduct.BegDate <= D) & (!Deduct.EndDate | (Deduct.EndDate >= D));
 END {IsActiveSpecDeduct};

 PUBLIC PROCEDURE _AssertByDeduct(Cond: SCAL[2]; ErrText: STRING[]);
 BEGIN
  IF ~Cond THEN
   L_StdFrm.WrongDB(ErrText+":|ࠡ⭨ "+Staff.TSN+", 㤥ঠ  "+Deduct.DedNbr);
  END;
 END {_AssertByDeduct};

 PRIVATE PROCEDURE NeedFirmAcnt(_Firm    : LIKE(FirmAcnt.Firm);
                                _FirmAcnt: LIKE(FirmAcnt.FirmAcnt)): SCAL[2];
 BEGIN
  IF ~!Deduct.FirmAcnt THEN
   RETURN Deduct.FirmAcnt = _FirmAcnt;
  ELSE
   RETURN 1;
  END;
 END {NeedFirmAcnt};

 PUBLIC PROCEDURE IsNeedDeduct(_PayP    : LIKE(Deduct.PayP);
                               _Firm    : LIKE(Deduct.Firm);
                               _FirmAcnt: LIKE(Deduct.FirmAcnt)): SCAL[2];
 BEGIN
  IF (Deduct.PayP = _PayP) & (Deduct.Firm = _Firm) & NeedFirmAcnt(_Firm, _FirmAcnt) THEN
   CONFORM(Deduct, DedAcnt);
   SRCINSEL(DedAcnt, EQ, , Memo.gl_mb());
   IF OCCURE(DedAcnt) & (DedAcnt.NetDebt > 0) THEN
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {IsNeedDeduct};

 PUBLIC PROCEDURE StandOnSpecDeduct(_TSN: LIKE(Staff.TSN));
 BEGIN
  SELECT(Deduct, TSN, , _TSN);
  WHILE OCCURE(Deduct) & ~IsActiveSpecDeduct(PDoc.Date) DO
   NEXT(Deduct);
  END; (* WHILE OCCURE(Deduct ... *)
 END {StandOnSpecDeduct};

 PUBLIC PROCEDURE IsSalaryDest(trgDest: LIKE(Dest.Dest)): SCAL[2];
 BEGIN
  RETURN trgDest = L_Dest.SalaryDest();
 END {IsSalaryDest};

 PUBLIC PROCEDURE IsOutPDoc(_PDocKind: LIKE(PDoc.PDocKind)): SCAL[2];
 BEGIN
  RETURN (_PDocKind = pd_RKO) | (_PDocKind = pd_IPP) |
         (_PDocKind = pd_IMO) | (_PDocKind = pd_ITP) |
         (_PDocKind = pd_CND) | (_PDocKind = pd_AVO) |
         (_PDocKind = pd_IPK) | (_PDocKind = pd_IsP) |
         (_PDocKind = pd_IPG) | (_PDocKind = pd_AIN) |
         (_PDocKind = pd_ROO) ;
 END {IsOutPDoc};

 PUBLIC PROCEDURE IsOurselvesPDoc(_PDocKind: LIKE(PDoc.PDocKind)): SCAL[2];
 BEGIN
  RETURN (_PDocKind = pd_IPP) | (_PDocKind = pd_OVN) | (_PDocKind = pd_CND);
 END {IsOurselvesPDoc};

 PRIVATE PROCEDURE IsBudgetPDoc(): SCAL[2];
  VAR
   prvContract: LIKE(Contract.Contract);
   Result     : SCAL[2];
 BEGIN
  IF IsPDocwMDoc() THEN
   Result:=0;
   SAVE(PDocMDoc);
   IF SELECT(PDocMDoc, PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
    prvContract:=PDocMDoc.Contract;
    WHILE OCCURE(PDocMDoc) DO
     IF L_Cntr.IsBudgetContract(PDocMDoc.Contract, PDoc.Date) THEN
      Result:=1;
     END;
     IF PDocMDoc.Contract # prvContract THEN
      L_General.Assert(~Result, "    뫪   ⮫쪮   ");
     END;
     NEXT(PDocMDoc);
    END; (* WHILE OCCURE(PDocMDoc) ... *)
   END;
   RESTORE(PDocMDoc);
   IF Result & IsOutPDoc(PDoc.PDocKind) & (PDoc.PDocKind # pd_IPK) THEN
    L_General.Assert(~!PDoc.ExtAbout, " 祭 ⥦ ⭮    |⥫쭠 () ଠ");
   END;
  ELSE
   Result:=~!PDoc.ExtAbout;
  END;
  RETURN Result;
 END {IsBudgetPDoc};

 PUBLIC PROCEDURE CheckBudgetPDoc();
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=IsBudgetPDoc();
 END {CheckBudgetPDoc};

 PUBLIC PROCEDURE IsSalPDoc(): SCAL[2];
 BEGIN
  RETURN IsSalaryDest(PDoc.Dest);
 END {IsSalPDoc};

 PUBLIC PROCEDURE IsPDocwMDoc(): SCAL[2];
  VAR
   IsPwM: SCAL[2];
 BEGIN
  SAVE(PDocMDoc);
  IsPwM:=SELECT(PDocMDoc, PDoc, PDoc.PDocKind, PDoc.PDoc);
  RESTORE(PDocMDoc);
  IF IsPwM THEN
   L_General.Assert(PDoc.Dest = L_Dest.PDocwMDocDest(), "   뫪    樨   "+L_Dest.PDocwMDocDest());
  END;
  RETURN IsPwM;
 END {IsPDocwMDoc};

 PUBLIC PROCEDURE MoneyKind(_PDocKind: LIKE(PDoc.PDocKind)): tMoneyKind;
 BEGIN
  IF (_PDocKind = pd_RKO) | (_PDocKind = pd_PKO) |
     (_PDocKind = pd_AIN) | (_PDocKind = pd_AII) THEN
   RETURN mk_Cash;
  ELSIF (_PDocKind = pd_POO) | (_PDocKind = pd_ROO) THEN
   RETURN mk_OprDskCash;
  ELSIF (_PDocKind = pd_IPP) | (_PDocKind = pd_VPP) |
        (_PDocKind = pd_IMO) | (_PDocKind = pd_VMO) |
        (_PDocKind = pd_ITP) | (_PDocKind = pd_VTP) |
        (_PDocKind = pd_OVN) | (_PDocKind = pd_CND) THEN
   RETURN mk_Bank;
  ELSIF (_PDocKind = pd_AVO) |
        (_PDocKind = pd_VPK) |
        (_PDocKind = pd_IPK) |
        (_PDocKind = pd_VhP) |
        (_PDocKind = pd_IsP) |
        (_PDocKind = pd_VPG) |
        (_PDocKind = pd_IPG) THEN
   RETURN mk_Nothing;
  ELSE
   L_General.CallUs(0);
  END;
 END {MoneyKind};

 (*!*) PUBLIC PROCEDURE IsCashOfficePDoc(_PDocKind: LIKE(PDoc.PDocKind)): SCAL[2];
 BEGIN
  RETURN MoneyKind(_PDocKind) = mk_Cash;
 END {IsCashOfficePDoc};

 (*!*) PUBLIC PROCEDURE IsBankPDoc(_PDocKind: LIKE(PDoc.PDocKind)): SCAL[2];
 BEGIN
  RETURN MoneyKind(_PDocKind) = mk_Bank;
 END {IsBankPDoc};

 PUBLIC PROCEDURE IsSingleTSN_PDoc(): SCAL[2];
  VAR
   SecondPDocList: SCAL[2];
 BEGIN
  CONFORM(PDoc, PDocList);
  IF ~OCCURE(PDocList) THEN
   RETURN 0;
  END;
  SAVE   (PDocList);
  SecondPDocList:=NEXT(PDocList);
  RESTORE(PDocList);
  RETURN ~SecondPDocList;
 END {IsSingleTSN_PDoc};

 PUBLIC PROCEDURE PDocStr(_PDocKind: LIKE(PDoc.PDocKind); _PDoc: LIKE(PDoc.PDoc)): STRING[];
 BEGIN
  RETURN PDocKindNick(_PDocKind, 1) + " " + FLDTOSTR(_PDoc, "", 7);
 END {PDocStr};

 PRIVATE PROCEDURE DecodePDocId(_PDocId: STRING[];
                                VAR _PDocKind: LIKE(PDocKind.PDocKind);
                                VAR _PDoc    : LIKE(PDoc.PDoc));
  VAR
   _XDocType: L_XDoc.tXDocType;
 BEGIN
  L_XDoc.DecodeXDocId(_PDocId, _XDocType, _PDocKind, _PDoc);
  L_General.CallUs(_XDocType = L_XDoc.xdt_PDoc);
 END {DecodePDocId};

 PUBLIC PROCEDURE SearchPDoc(_PDocKind: LIKE(PDoc.PDocKind); _PDoc: LIKE(PDoc.PDoc));
 BEGIN
  L_General.Assert(SEARCH(PDoc, PDoc, _PDocKind, _PDoc),
                   "⥦ 㬥 "+PDocStr(_PDocKind, _PDoc)+"  ");
 END {SearchPDoc};

 PUBLIC PROCEDURE BarCode(): STRING[];
 BEGIN
  RETURN L_XDoc.BarCode(L_XDoc.bck_IdIn17, L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, PDoc.CopyCnt);
 END {BarCode};

 PUBLIC PROCEDURE GetPDocCommentPart(Idx: NUMERIC[0]): STRING[];
  VAR
   PosB,
   PosE : NUMERIC[0];
 BEGIN
  PosB:=0;
  WHILE Idx > 0 DO
   PosB:=Str.Pos(PDoc.Comment, L_Str.CRLF, PosB);
   IF PosB < Str.Length(PDoc.Comment) THEN
    INC(PosB, Str.Length(L_Str.CRLF));
   END;
   DEC(Idx);
  END;
  PosE:=Str.Pos(PDoc.Comment, L_Str.CRLF, PosB);
  RETURN Str.Slice(PDoc.Comment, PosB, PosE - PosB);
 END {GetPDocCommentPart};

 PUBLIC PROCEDURE GetPDocComment(): STRING[];
 BEGIN
  RETURN Str.Replace(PDoc.Comment, L_Str.CRLF, " ");
 END {GetPDocComment};

 PRIVATE PROCEDURE spdcp_Part(i, Idx: NUMERIC[0]; s: STRING[]): STRING[];
 BEGIN
  IF i = Idx THEN
   RETURN s;
  ELSE
   RETURN GetPDocCommentPart(i);
  END;
 END {spdcp_Part};

 PUBLIC PROCEDURE SetPDocCommentPart(Idx: NUMERIC[0]; s: STRING[]);
 BEGIN
  L_General.CallUs(PDocKindHasStructuredComment(PDoc.PDocKind));
  PDoc.Comment:=spdcp_Part(0, Idx, s) + L_Str.CRLF + spdcp_Part(1, Idx, s) + L_Str.CRLF + spdcp_Part(2, Idx, s);
 END {SetPDocCommentPart};

 PRIVATE PROCEDURE intSetPDocComment(s: STRING[]): SCAL[2];
  VAR
   Rest : STRING[];
   Dummy: STRING[][3];
 BEGIN
  s:=Str.Condense(s);
  PDoc.Comment:=L_Str.Left(s, 210);
  Str.Format(Dummy, s, Str.MaxLength(PDoc.Comment), NONE, Rest);
  RETURN (Str.Length(PDoc.Comment) = Str.Length(s)) & !Rest;
 END {intSetPDocComment};

 PUBLIC PROCEDURE SetPDocComment(s: STRING[]);
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=intSetPDocComment(s);
 END {SetPDocComment};

 PUBLIC PROCEDURE SetStructuredPDocComment(s0, s1, s2: STRING[]);
 BEGIN
  L_General.CallUs(PDocKindHasStructuredComment(PDoc.PDocKind));
  PDoc.Comment:=s0 + L_Str.CRLF + s1 + L_Str.CRLF + s2;
 END {SetStructuredPDocComment};

 PUBLIC PROCEDURE PDocAbout(_PDocKind: LIKE(PDoc.PDocKind); _PDoc: LIKE(PDoc.PDoc)): STRING[];
  VAR
   _About: STRING[];
 BEGIN
  SAVE(PDoc);
  SearchPDoc(_PDocKind, _PDoc);
  IF (_PDocKind = pd_RKO) | (_PDocKind = pd_PKO) |
     (_PDocKind = pd_ROO) | (_PDocKind = pd_POO) THEN
   _About :=GetPDocCommentPart(1);
  ELSE
   _About :=GetPDocComment();
  END;
  RESTORE(PDoc);
  RETURN _About;
 END {PDocAbout};

 PUBLIC PROCEDURE GetPDocPurpose(): STRING[];
  VAR
   Indx: NUMERIC[0];
 BEGIN
  IF (PDoc.PDocKind = pd_RKO) | (PDoc.PDocKind = pd_ROO) THEN
   Indx:=1;
  ELSE
   Indx:=0;
  END;
  RETURN GetPDocCommentPart(Indx);
 END {GetPDocPurpose};

 PRIVATE PROCEDURE GetLbCAttr(D: DATE; _Field: STRING[]): STRING[];
  VAR
   _LbCNbr : STRING[];
   _LbCDate: DATE;
   _KindOfWork: STRING[];
 BEGIN
  SAVE(StaffLog);
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  L_Staff.GetLabourContractAttr(D, _LbCNbr, _LbCDate, _KindOfWork);
  RESTORE(StaffLog);
  IF    _Field="LbCNbr" THEN
   RETURN _LbCNbr;
  ELSIF _Field="LbCDate" THEN
   RETURN L_DatTim.DateStr(_LbCDate);
  ELSE
   L_General.CallUs(0);
  END;
 END {GetLbCAttr};

 PRIVATE PROCEDURE GetNotEmptyValue(Value: STRING[]; Msg: STRING[]): STRING[];
 BEGIN
  L_General.Assert(~!Value, Msg + " ");
  RETURN Value;
 END {GetNotEmptyValue};

 PUBLIC PROCEDURE PRollFields(_Field: STRING[]): STRING[];
 BEGIN
  IF    _Field="Memo.tmp_mb()"                 THEN RETURN L_DatTim.PeriodStr(Memo.gl_mb());
  ELSIF _Field="Staff.TSN"                     THEN RETURN Staff.TSN;
  ELSIF _Field="Man.Name"                      THEN RETURN Man.Name;
  ELSIF _Field="Man.Name.Short"                THEN RETURN L_Str.ShortName(Man.Name);
  ELSIF _Field="Deduct.Person"                 THEN RETURN Deduct.Person;
  ELSIF _Field="Deduct.Person.Short"           THEN RETURN L_Str.ShortName(Deduct.Person);
  ELSIF _Field="Deduct.PAddr[0]"               THEN RETURN Deduct.PAddr[0];
  ELSIF _Field="Deduct.PCode"                  THEN RETURN GetNotEmptyValue(Deduct.PCode, "'楢 ' 㤥ঠ " + Deduct.DedNbr + " 㤭 " + Deduct.TSN);
  ELSIF _Field="_EventName"                    THEN
   L_General.Assert(~!EventName, " । ⥪饥 ᮡ⨥,  ண|  뢥  ᮮ⢥⢨  蠡  祭 ⥦"+
                                 L_StdFrm.HR()+" 祭 ⥦ ");  RETURN EventName;
  ELSIF _Field="PDoc.PDoc"                     THEN RETURN GetNotEmptyValue(PDoc.SrcNbr, "'室 '  " + PDoc.PDocKind + " " + PDoc.PDoc);
  ELSIF _Field="Firm.RegName"                  THEN RETURN P_Firm.FP_PersonFullName_wBranchName(PDoc.Firm, PDoc.Date);
  ELSIF (_Field="LbCNbr") | (_Field="LbCDate") THEN RETURN GetLbCAttr(PDoc.Date, _Field);
  ELSE                                              RETURN "訡!"
  END;
 END {PRollFields};

 PRIVATE PROCEDURE GetAnyPDocSum(vtb_Kind: NUMERIC[0]): NUMERIC[2];
  VAR
   _vtb: L_Pmnt.tValuesToBalance;
 BEGIN
  _vtb:=L_Pmnt.vtbGetByPDocMDoc();
  RETURN _vtb[vtb_Kind];
 END {GetAnyPDocSum};

 PRIVATE PROCEDURE PDocwMDocFields(_Field: STRING[]): STRING[];
 BEGIN
  IF    _Field="MDoc.SrcNbr"               THEN RETURN GetNotEmptyValue(MDoc.SrcNbr, "'室騩 '  " + MDoc.MDocKind + " " + MDoc.MDoc);
  ELSIF _Field="MDoc.SrcDate"              THEN RETURN L_DatTim.DateStr(MDoc.SrcDate);
  ELSIF _Field="MDoc.PayDate"              THEN RETURN L_DatTim.DateStr(MDoc.PayDate);
  ELSIF _Field="MDoc.Date^mm"              THEN RETURN FLDTOSTR(MDoc.Date, "N", 0);
  ELSIF _Field="MDoc.Date^mm.yyyy"         THEN RETURN L_DatTim.PeriodStr(MDoc.Date);
  ELSIF _Field="MDoc.Date^qq.yyyy"         THEN RETURN L_Str.FixedIntStr(L_DatTim.QUARTAL(MDoc.Date)+1, 2)+"."+L_Str.FixedIntStr(L_DatTim.YEAR(MDoc.Date), 4);
  ELSIF _Field="MDoc.Date^yyyy"            THEN RETURN L_Str.FixedIntStr(L_DatTim.YEAR(MDoc.Date), 4);
  ELSIF _Field="MDoc.Date^yy"              THEN RETURN FLDTOSTR(MDoc.Date, "Y", 0);
  ELSIF _Field="MDoc.Note"                 THEN RETURN P_MDoc.GetMDocProStrong(MDoc.MDocKind,MDoc.MDoc, P_MDoc.P_Note);
  ELSIF _Field="PDoc.PDoc"                 THEN RETURN GetNotEmptyValue(PDoc.SrcNbr, "'室 '  " + PDoc.PDocKind + " " + PDoc.PDoc);
  ELSIF _Field="Firm.RegName"              THEN RETURN P_Firm.FP_PersonFullName_wBranchName(PDoc.Firm, PDoc.Date);
  ELSIF _Field="PDocMDoc.Total"            THEN RETURN L_Money.MoneyToStr(PDoc.Date, "", GetAnyPDocSum(L_Pmnt.vtb_Total));
  ELSIF _Field="PDocMDoc.Total.Netto"      THEN RETURN L_Money.MoneyToStr(PDoc.Date, "", GetAnyPDocSum(L_Pmnt.vtb_Netto));
  ELSIF _Field="PDocMDoc.Total.VAT"        THEN RETURN L_Money.MoneyToStr(PDoc.Date, "", GetAnyPDocSum(L_Pmnt.vtb_VAT));
  ELSIF _Field="PDocMDoc.Total.VAT.byWord" THEN RETURN VatSumToStr(PDoc.Date, GetAnyPDocSum(L_Pmnt.vtb_VAT));
  ELSIF _Field="Contract.SrcNbr"           THEN RETURN GetNotEmptyValue(Contract.SrcNbr, "'室 '  " + Contract.Contract);
  ELSIF _Field="Contract.SrcDate"          THEN RETURN L_DatTim.DateStr(Contract.SrcDate);
  ELSIF _Field="Contract.7322.GoodsDescr"  THEN RETURN P_Cntr.ppi_DescriptionOfGoods_Ext(Contract.Contract, PDoc.Date, L_Prop.pc_Strong);
  ELSIF _Field="Contract.7322.KBK"         THEN RETURN P_Cntr.ppi_KBK(Contract.Contract, PDoc.Date);
  ELSIF _Field="Contract.7322.OKATO"       THEN RETURN P_Cntr.ppi_OKATO(Contract.Contract, PDoc.Date);
  ELSIF _Field="Contract.7322.pmnt_Former" THEN RETURN P_Cntr.ppi_pmnt_Former(Contract.Contract, PDoc.Date);
  ELSE                                          RETURN "訡!";
  END;
 END {PDocwMDocFields};

 PRIVATE PROCEDURE VatSumToStr(D: DATE; _VAT: NUMERIC[2]): STRING[];
 BEGIN
  IF !_VAT | (_VAT = 0) THEN
   RETURN "  ()";
  ELSE
   RETURN ": " + L_Money.MoneyToStr(D, "", _VAT);
  END;
 END {VatSumToStr};

 PUBLIC PROCEDURE VatStr(): STRING[];
 BEGIN
  IF !PDoc.NDS | (PDoc.NDS = 0) THEN
   IF    IsBudgetPDoc() THEN
    RETURN "";
   ELSIF !PDoc.NDS THEN
    IF IsSalPDoc() THEN
     RETURN "";
    END;
   END;
  END;
  RETURN VatSumToStr(PDoc.Date, PDoc.NDS);
 END {VatStr};

 PUBLIC PROCEDURE GetFullPDocAbout(): STRING[];
  VAR
   Result,
   _VatStr,
   OurCode: STRING[];
 BEGIN
  Result:=GetPDocComment();
  IF IsOurselvesPDoc(PDoc.PDocKind) THEN
   _VatStr:=VatStr();
   IF ~!_VatStr THEN
    Result:=Result + ", " + _VatStr;
   END;
   IF PDoc.PDocKind = pd_IPP THEN
    OurCode:=P_Firm.GetOurCode(PDoc.Firm, PDoc.Date);
    IF ~!OurCode THEN
     Result:=Result + ". : " + OurCode;
    END;
   END;
  END;
  RETURN Str.Condense(Result);
 END {GetFullPDocAbout};

 PUBLIC PROCEDURE FillPDocAbout();
  VAR
   plsIdx     : SCAL[RANGEOF(PayP.PayLSngl)];
   plmIdx     : SCAL[RANGEOF(PayP.PayLMult)];
   Count      : NUMERIC[0];
   WholeString,
   Rest,
   Template,
   Dummy,
   singleAbout,
   _About     : STRING[];
   SrcField   : LIKE(PayP.PayLMult);
   curPayLSExt: LIKE(PayP.PayLSExt);
 BEGIN
  APP.Get().NewPrompt(PDocStr(PDoc.PDocKind, PDoc.PDoc));
  IF ~!PDoc.payp THEN
   SEARCH(PayP, PayP, , PDoc.payp);
   IF ~L_PayP.IsEmptyPaylSngl() & IsSingleTSN_PDoc() THEN
    IF IsDeductEvent() THEN
     Count:=0;
     CONFORM(PDoc, PDocList);
     PROMPT(PDocList.TSN);
     SELECT(Deduct, TSN, , PDocList.TSN);
     WHILE OCCURE(Deduct) DO
      IF IsNeedDeduct(PDoc.payp, PDoc.Firm, PDoc.FirmAcnt) THEN
       INC(Count);
      END;
      NEXT(Deduct);
     END; (* WHILE OCCURE(Deduct)... *)
     PDocPrgCheck(Count # 0, "㤥ঠ");
     IF Count = 1 THEN
      SELECT(Deduct, TSN, , PDocList.TSN);
      WHILE OCCURE(Deduct) & ~IsNeedDeduct(PDoc.payp, PDoc.Firm, PDoc.FirmAcnt) DO
       NEXT(Deduct);
      END;
      CONFORM(PDocList, Staff, Man);           (*?!?!?!?!?!?!*)
      SrcField:=PayP.PayLSngl;
      Template:=L_PayP.ppt_SinglePersPayment;
     ELSE
      L_General.Assert(PayP.Type # L_PayP.ppType_Simple,
                       "祭 ⥦ " + PDoc.payp + "  ।ᬠਢ ." +
                       "||⭨ " + PDocList.TSN + "    饣 㤥ঠ" +
                       "| 祭 ⥦ " + PDoc.payp +
                       "   " + PDoc.FirmAcnt + " ࠣ " + PDoc.Firm);
      SrcField:=PayP.PayLMult;
      Template:=L_PayP.ppt_MultyPersPayment;
     END; (* IF Count = 1 ... *)
    ELSE
     StandOnSpecDeduct(PDocList.TSN);
     CONFORM(PDocList, Staff, Man);
     SrcField:=PayP.PayLSngl;
     Template:=L_PayP.ppt_SinglePersPayment;
    END; (* IF IsDeductEvent() ... *)
   ELSE
    SrcField:=PayP.PayLMult;
    Template:=L_PayP.ppt_MultyPersPayment;
   END; (* IF ~IsEmptyPaylSngl() & ... *)
 
   WholeString:="";
   IF PDocKindHasStructuredComment(PDoc.PDocKind) THEN
    FOR_EACH plmIdx DO
     SetPDocCommentPart(plmIdx, L_PayP._MorphString(SrcField[plmIdx], Template, PROCREF(PRollFields)));
    END; (* FOR_EACH plmIdx ... *)
   ELSE
    FOR_EACH plmIdx DO
     WholeString:=L_Str.AddStrDlm(WholeString, " ") +
                  L_PayP.MorphString(SrcField[plmIdx], Template, PROCREF(PRollFields), -1);
    END; (* FOR_EACH plmIdx ... *)
    L_General.Assert(intSetPDocComment(WholeString) &
                     (Str.Length(GetFullPDocAbout()) <= MaxPDocCommentLength),
                     "誮  祭 ⥦:|" + PayP.PayP + " " + PayP.Name + "." +
                     "||樨: ࠢ 蠡:|" + SrcField[0] + "|" + SrcField[1] + "|" + SrcField[2]);
   END;
   REPLACE(PDoc);
  ELSIF IsPDocwMDoc() THEN
   CONFORM(PDoc, PDocMDoc);
   IF SELECT(PDocMDoc, PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
    _About:="";
    WHILE OCCURE(PDocMDoc) DO
     CONFORM(PDocMDoc, MDoc);
     CONFORM(MDoc, Contract);
     AccessPayP(P_Cntr.GetCntrProStrong(Contract.Contract, MDoc.Date, P_Cntr.P_PayP));
     IF !PDoc.Queue THEN
      PDoc.Queue:=PayP.Queue;
     ELSE
      L_General.Assert(PDoc.Queue = PayP.Queue,
                       " ᮢ 祭 । ⥦");
     END;
     singleAbout:="";
     FOR_EACH plsIdx DO
      Dummy:=Str.Condense(L_PayP.MorphString(PayP.PayLSngl[plsIdx], L_PayP.ppt_MDocPayment, PROCREF(PDocwMDocFields), -1));
      IF ~!Dummy THEN
       singleAbout:=L_Str.AddStrDlm(singleAbout, " ") + Dummy;
      END;
     END; (* FOR_EACH plsIdx ... *)
     L_General.Assert(~!singleAbout, "⮥ 祭 ⥦   " +
                                     L_MDoc.MDocStr(PDocMDoc.MDocKind, PDocMDoc.MDoc));
     IF Str.Pos(_About, singleAbout) = Str.Length(_About) THEN
      _About:=L_Str.AddStrDlm(_About, "; ") + singleAbout;
     END;
     NEXT(PDocMDoc);
    END; (* WHILE OCCURE(PDocMDoc) ... *)

    curPayLSExt:=PayP.PayLSExt;
    IF ~!PayP.PayLSExt & (PDoc.Date>=31\03\2014) THEN
     curPayLSExt:=curPayLSExt+";0"; (* 0*)
    END;
    PDoc.ExtAbout:=Str.Condense(L_PayP.MorphString(curPayLSExt,
                                                   L_PayP.ppt_MDocPayment,
                                                   PROCREF(PDocwMDocFields),
                                                   Str.MaxLength(PDoc.ExtAbout)));

    IF PDocKindHasStructuredComment(PDoc.PDocKind) THEN
     SetStructuredPDocComment("", _About, "");
    ELSE
     L_General.Assert(intSetPDocComment(_About) &
                      (Str.Length(GetFullPDocAbout()) <= MaxPDocCommentLength),
                      "祭 ⥦   ॢ蠥 ⨬ ࠧ."+
                      "||஡ ନ஢   ᭮ 襣 ⢠ .");
    END;
    REPLACE(PDoc);
   END;
  END;
 END {FillPDocAbout};

 PRIVATE PROCEDURE FillPDocPmntKind();
 BEGIN
  IF (PDoc.PDocKind = pd_IPP) & !PDoc.PmntKind THEN
   PDoc.PmntKind:=E_DefaultPDocPmntKind(PDoc.Date);
   REPLACE(PDoc);
  END;
 END {FillPDocPmntKind};

 PRIVATE PROCEDURE AccessPayP(_PayP: LIKE(PayP.PayP));
 BEGIN
  IF ~SEARCH(PayP, PayP, _PayP) THEN
   IF _PayP = EOR_PAYP THEN
    L_General.Error('室   ࠢ筨 "祭 ⥦"|'+FLDTOSTR(EOR_PAYP, "L", 2)+" - ௫ १ ");
   ELSE
    L_General.Error("室   ࠢ筨 祭 ⥦ "+_PayP);
   END;
  END;
 END {AccessPayP};

 PUBLIC PROCEDURE GetPDocOwnFirm(): LIKE(Firm.Firm);
 BEGIN
  L_General.CallUs(~!PDoc.MyFirm);
  RETURN P_Firm.GetFirmOfMyFirm(PDoc.MyFirm);
 END {GetPDocOwnFirm};

 PUBLIC PROCEDURE GetPDocOwnFirmAcnt(): LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  IF (MoneyKind(PDoc.PDocKind) = mk_Cash) |
     (PDoc.PDocKind = pd_VPK) | (PDoc.PDocKind = pd_IPK) |
     (PDoc.PDocKind = pd_VhP) | (PDoc.PDocKind = pd_IsP) THEN
   RETURN P_Firm.fa_CashOffice;
  ELSE
   RETURN PDoc.OwnAcnt;
  END;
 END {GetPDocOwnFirmAcnt};

 PUBLIC PROCEDURE AccessPDocOwnFirmAcnt();
 BEGIN
  L_General.Assert(SEARCH(FirmAcnt, FirmAcnt, GetPDocOwnFirm(), GetPDocOwnFirmAcnt()),
                   " ⥦ 㬥 㪠   '襩 ࣠樨'");
 END {AccessPDocOwnFirmAcnt};

 PUBLIC PROCEDURE GetFirmAcnt(D        : DATE;
                              _Firm    : LIKE(PDoc.Firm);
                              _FirmAcnt: LIKE(FirmAcnt.FirmAcnt)): LIKE(Deduct.FirmAcnt);
 BEGIN
  IF ~!_FirmAcnt THEN
   P_Firm.CheckFirmAcnt(D, _Firm, _FirmAcnt);
   RETURN _FirmAcnt;
  ELSE
   P_Firm.AccessSilentFirmAcnt(_Firm, D);
   RETURN FirmAcnt.FirmAcnt;
  END;
 END {GetFirmAcnt};

 PUBLIC PROCEDURE GetFilterValueForOnlyBankFirmAcnt(): STRING[];
 BEGIN
  RETURN "(FirmAcnt.Type#" + L_Str.IntStr(P_Firm.fat_CashOffice) + ")" +
         "&" +
         "(FirmAcnt.Type#" + L_Str.IntStr(P_Firm.fat_OprCashDsk) + ")" ;
 END {GetFilterValueForOnlyBankFirmAcnt};

 PRIVATE PROCEDURE GetDataForPDoc(    D        : DATE;
                                  VAR _PayP    : LIKE(Deduct.PayP);
                                  VAR _Firm    : LIKE(PDoc.Firm);
                                  VAR _FirmAcnt: LIKE(PDoc.FirmAcnt));
  VAR
   Found: SCAL[2];
 BEGIN
  Found:=0;
  IF    IsDeductEvent() THEN   (* ᫥ 㤥ঠ *)
   PDocPrgCheck(OCCURE(Deduct), "㤥ঠ");
   Found:=1;
  ELSIF SalPayLev = spl_PP THEN
   CONFORM(Staff, Deduct);
   WHILE OCCURE(Deduct) DO
    IF IsActiveSpecDeduct(D) THEN
     L_General.Assert(~Found, "    㤥ঠ  楢   "+L_DatTim.DateStr(D)+"| "+Staff.TSN);
     SAVE(Deduct);
     Found:=1;
    END;
    NEXT(Deduct);
   END; (* WHILE OCCURE(Deduct) ... *)
   IF Found THEN
    RESTORE(Deduct);
   END;
  END; (* IF IsDeductEvent() ... *)
  IF Found THEN
   _PayP    :=Deduct.PayP;
   _Firm    :=Deduct.Firm;
   _FirmAcnt:=GetFirmAcnt(D, Deduct.Firm, Deduct.FirmAcnt);
  END;
  IF IsSalaryEvent() THEN
   SAVE(PayP);
   AccessPayP(_PayP);
   IF Found THEN
    _AssertByDeduct(IsSalaryDest(PayP.Dest), " 樨  祭 ⥦ "+PayP.PayP+"| ᮮ⢥ ᫥ ௫");
   ELSE
    L_General.Assert(IsSalaryDest(PayP.Dest), "⭨ "+Staff.TSN+"| 樨  祭 ⥦ "+PayP.PayP+"| ᮮ⢥ ᫥ ௫");
   END;
   RESTORE(PayP);
  END;
 END {GetDataForPDoc};

 PUBLIC PROCEDURE UnClosedSalPDoc_MinNum(): LIKE(PDoc.mfNbr);
 BEGIN
  RETURN 198000000;
 END {UnClosedSalPDoc_MinNum};

 PRIVATE PROCEDURE UnClosedSalPDoc_MaxNum(): LIKE(PDoc.mfNbr);
 BEGIN
  RETURN 198099999;
 END {UnClosedSalPDoc_MaxNum};

 PUBLIC PROCEDURE IsUnClosedSalPDoc(_mfNbr: LIKE(PDoc.mfNbr)): SCAL[2];
 BEGIN
  RETURN (_mfNbr >= UnClosedSalPDoc_MinNum()) & (_mfNbr <= UnClosedSalPDoc_MaxNum());
 END {IsUnClosedSalPDoc};

 PUBLIC PROCEDURE GoodYearPDoc(trgDate: DATE): SCAL[2];
 BEGIN
  RETURN IsUnClosedSalPDoc(PDoc.mfNbr) |
         (L_DatTim.YEAR(trgDate) = (PDoc.mfNbr DIV 1E5));
 END {GoodYearPDoc};

 PRIVATE PROCEDURE AccessUnClosedSalPDoc(_MyFirm: LIKE(PDoc.MyFirm); _PDocKind: LIKE(PDoc.PDocKind); Per: DATE): SCAL[2];
 BEGIN
  SETSEL(PDoc, mfNbr, _PDocKind, _MyFirm);
  SRCINSEL(PDoc, LE, , UnClosedSalPDoc_MaxNum());
  WHILE OCCURE(PDoc) & (PDoc.mfNbr >= UnClosedSalPDoc_MinNum()) &
        ((L_DatTim.Per(PDoc.Date)#Per) | (PDoc.Status = st_Canceled)) DO
   PREV(PDoc);
  END;
  RETURN OCCURE(PDoc) & IsUnClosedSalPDoc(PDoc.mfNbr);
 END {AccessUnClosedSalPDoc};

 PUBLIC PROCEDURE Temporary_mfNbr(_MyFirm: LIKE(PDoc.MyFirm); _PDocKind: LIKE(PDoc.PDocKind); _Date: DATE; Temporary: SCAL[2]): LIKE(PDoc.mfNbr);
  VAR
   _mfNbr: LIKE(PDoc.mfNbr);
 BEGIN
  SETEMPTY(_mfNbr);
  IF (_PDocKind = pd_RKO) | ((_PDocKind = pd_IPP) & ForceUnClosedPay) THEN
   SAVE(PDoc);
   SETSEL(PDoc, mfNbr, _PDocKind, _MyFirm);
   SRCINSEL(PDoc, LE, , UnClosedSalPDoc_MaxNum());
   IF ~OCCURE(PDoc) | (PDoc.mfNbr < UnClosedSalPDoc_MinNum()) THEN
    _mfNbr:=UnClosedSalPDoc_MinNum();
   ELSE
    _mfNbr:=PDoc.mfNbr+1;
    L_General.Assert(_mfNbr < UnClosedSalPDoc_MaxNum(), " ᢮ ६ ஢  ");
   END;
   RESTORE(PDoc);
  END;
  RETURN _mfNbr;
 END {Temporary_mfNbr};

 PUBLIC PROCEDURE E_FillPDocSrcNbr(): SCAL[3];
  VAR
   Default: SCAL[3];
   Local  : PROC;
 BEGIN
  IF (PDoc.PDocKind = pd_RKO) | (PDoc.PDocKind = pd_PKO) |
     (PDoc.PDocKind = pd_IPP) | (PDoc.PDocKind = pd_AVO) |
     (PDoc.PDocKind = pd_ROO) | (PDoc.PDocKind = pd_POO) |
     (PDoc.PDocKind = pd_AIN) | (PDoc.PDocKind = pd_AII) THEN
   Default:=fpdsn_YesAndNotAllowEdit;
  ELSE
   Default:=fpdsn_No;
  END;
  Local:=PROCREF(E_PDoc.FillPDocSrcNbr);
  IF ~!Local THEN
   RETURN Local(Default);
  ELSE
   RETURN Default;
  END;
 END {E_FillPDocSrcNbr};

 PUBLIC PROCEDURE E_DefaultPDocSrcNbr(D: DATE): STRING[];
  VAR
   Local : PROC;
   Result: STRING[];
 BEGIN
  Result:="";
  IF E_FillPDocSrcNbr() # fpdsn_No THEN
   IF PDoc.MyFirm # P_Firm.mf_Fict THEN
    IF ~IsUnClosedSalPDoc(PDoc.mfNbr) THEN
     Result:=FLDTOSTR(PDoc.mfNbr MOD 100000, "", 0);
    END;
    Local:=PROCREF(E_PDoc.DefaultPDocSrcNbr);
    IF ~!Local THEN
     Result:=Local(D, Result);
    END;
   END;
  END;
  RETURN Result;
 END {E_DefaultPDocSrcNbr};

 PUBLIC PROCEDURE SetNew_mfNbr_Required(): SCAL[2];
 BEGIN
  RETURN ~IsUnClosedSalPDoc(PDoc.mfNbr) & ~!PDoc.Date & ~GoodYearPDoc(PDoc.Date);
 END {SetNew_mfNbr_Required};

 PUBLIC PROCEDURE SetDefaultPDocSrcNbr();
 BEGIN
  IF E_FillPDocSrcNbr() # fpdsn_No THEN
   PDoc.SrcNbr:=E_DefaultPDocSrcNbr(PDoc.Date);
   REPLACE(PDoc);
  END;
 END {SetDefaultPDocSrcNbr};

 PUBLIC PROCEDURE CheckNCorrect_PDocNbrs();
  VAR
   Title    : STRING[];
   curPDoc  : LIKE(PDoc.PDoc);
   curDate  : DATE;
   trg_mfNbr: LIKE(PDoc.mfNbr);
 BEGIN
  IF SetNew_mfNbr_Required() THEN
   curPDoc:=PDoc.PDoc;
   curDate:=PDoc.Date;
   SAVE(PDoc);
   CHANGESEL(PDoc, mfNbr, , PDoc.PDocKind, PDoc.MyFirm);
   IF SRCINSEL(PDoc, LT, (L_DatTim.YEAR(curDate)+1)*1E5) &
      (PDoc.mfNbr DIV 1E5 = L_DatTim.YEAR(curDate)) THEN
    trg_mfNbr:=PDoc.mfNbr + 1;
   ELSE
    trg_mfNbr:=L_DatTim.YEAR(curDate)*1E5 + 1;
   END;
   RESTORE(PDoc);
   SAVE(PDocKind);
   CONFORM(PDoc, PDocKind);
   Title:="ଫ  '" + PDocKind.SName + "'";
   RESTORE(PDocKind);
   SAVE(PDoc);
   LOOP
    STDFORM(L_StdFrm.sf_Choice("| ⥦ 㬥 %##########%|",
                               "%R<0000\00000>I"),
            Title, , -1, trg_mfNbr);
    IF SEARCH(PDoc, mfNbr, PDoc.PDocKind, PDoc.MyFirm, trg_mfNbr) & (PDoc.PDoc # curPDoc) THEN
     L_StdFrm.RedInform("  " + PDocKindNick(PDoc.PDocKind, 1) +
                        "  ஬ " + FLDTOSTR(trg_mfNbr, "0000\00000"));
    ELSE
     EXIT;
    END;
   END; (* LOOP *)
   RESTORE(PDoc);
   PDoc.mfNbr:=trg_mfNbr;
   REPLACE(PDoc);
  END;

  IF E_FillPDocSrcNbr() # fpdsn_No THEN
   IF PDoc.PDocKind = pd_IPP (*ॡ  :⭠  ࠭ 姭 ,.  ⫨  000*) THEN
    IF    L_General.IsPolakSpecific() & ((PDoc.PDoc MOD 1000) = 0) THEN
     INC(PDoc.PDoc);
     INTEGRITY(NoAsk);
     REPLACE(PDoc);
    END;
    IF ((PDoc.mfNbr MOD 1000) = 0) & ~IsUnClosedSalPDoc(PDoc.mfNbr) THEN
     INC(PDoc.mfNbr);
     REPLACE(PDoc);
    END;
   END;
   SetDefaultPDocSrcNbr();
  END;
 END {CheckNCorrect_PDocNbrs};

 PUBLIC PROCEDURE Insert_PDoc();
 BEGIN
  L_General.Assert(~!PDoc.Date, "Insert_PDoc:  ।  㬥");
  L_General.CallUs(PDoc.MyFirm # P_Firm.mf_Fict);
  PDoc.DoneDTS :=L_XDoc.max_DoneDTS;
  INSERT(PDoc);
  CheckNCorrect_PDocNbrs();
  PDoc.XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_PDoc);
  REPLACE(PDoc);
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, L_XDoc.action_AutoBuild);
 END {Insert_PDoc};

 PUBLIC PROCEDURE IsPDoc_wJDocOnly(): SCAL[2];
  VAR
   JDocId: L_XDoc.tXDocId;
   Result: SCAL[2];
 BEGIN
  Result:=0;
  JDocId:=L_XDoc.GetAnnexXDocId(PDoc.XDocId);
  IF ~!JDocId & (L_XDoc.ExtractXDocType(JDocId) = L_XDoc.xdt_JDoc) THEN
   L_XDoc.PositionOnXDoc(JDocId);
   Result:=JDoc.SubstAM;
  END;
  RETURN Result;
 END {IsPDoc_wJDocOnly};

 PRIVATE PROCEDURE CheckOwnAgentCntrSumLimit();
 BEGIN
  IF PDoc.Status # st_Canceled THEN
   IF SELECT(PDocMDoc, PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
    L_AFM.MakeIndex("_Cntr", "Contract: LIKE(PDocMDoc.Contract)");
    WHILE OCCURE(PDocMDoc) DO
     ADD(_Cntr, _Cntr, , PDocMDoc.Contract);
     NEXT(PDocMDoc);
    END; (* WHILE OCCURE(PDocMDoc) ... *)
    SELECT(_Cntr, _Cntr);
    WHILE OCCURE(_Cntr) DO
     L_Pmnt.CheckOwnAgentCntrSumLimit(_Cntr.Contract, PDoc.Date);
     NEXT(_Cntr);
    END; (* WHILE OCCURE(_Cntr) ... *)
    L_AFM.AF_PurgeTemp("_Cntr");
   END; (* IF SELECT(PDocMDoc, ... *)
  END;
 END {CheckOwnAgentCntrSumLimit};

 PUBLIC PROCEDURE PDoc_OnAnyModification(Dir: NUMERIC[0]; NeedProceed: SCAL[3]; Stream :SCAL[2]);
 BEGIN
  IF Dir = +1 THEN
   L_JDoc.ReplicateAnnexJDoc(PDoc.XDocId);
  ELSIF Dir = -1 THEN
   IF NeedProceed # np_No THEN
    IF PDoc.Done THEN
     IF Stream THEN CALL(PDoc.StreamMakeUnDone());
     ELSE           CALL(PDoc.SingleMakeUnDone());
     END;
    END;
   ELSE
    L_General.CallUs(~PDoc.Done);
   END;
  END;
  IF IsPDocwMDoc() THEN
   L_XDoc.xdmb_CheckABan(L_XDoc.xdcls_VATRelated, PDoc.Date);
   L_Pmnt.SupportOnlineBalance(L_XDoc.xdt_PDoc, Dir);
   SAVE(PDocMDoc);
   SAVE(MDoc);
   CONFORM(PDoc, PDocMDoc);
   WHILE OCCURE(PDocMDoc) DO
    CONFORM(PDocMDoc, MDoc);
    L_Pmnt.ResetMDocClosed();
    NEXT(PDocMDoc);
   END;
   RESTORE(MDoc);
   RESTORE(PDocMDoc);
  END;
  IF Dir = +1 THEN
   IF ~Stream THEN
    L_Pmnt.CheckPDocHasUnalteredBalanceButVATChange();
    CheckOwnAgentCntrSumLimit();
   END;
   IF    NeedProceed = np_Try THEN
    TRY
     IF Stream THEN  CALL(PDoc.StreamMakeDone());
     ELSE            CALL(PDoc.SingleMakeDone());
     END;
    EXCEPT
    ON Exc: Exc_Raise DO
     IF ~Stream THEN
      L_XDoc.OnAnyXDocModificationProceedError(Exc);
     END; (* IF ~Stream ... *)
    END;
   ELSIF NeedProceed = np_Yes THEN
    IF Stream THEN CALL(PDoc.StreamMakeDone());
    ELSE           CALL(PDoc.SingleMakeDone());
    END;
   END;
  END; (* IF Dir = +1 ... *)
 END {PDoc_OnAnyModification};

 PUBLIC PROCEDURE Remove_PDoc(wRemove: SCAL[2]);
 BEGIN
  L_General.CallUs(~PDoc.Done);
  PDoc_OnAnyModification(-1, np_No, 1);
  L_XDoc.XDoc_OnBeforeDelete(L_XDoc.curXDocId(L_XDoc.xdt_PDoc));
  IF wRemove THEN
   INTEGRITY(NoAsk);
   REMOVE(PDoc);
   INTEGRITY(Off);
  END;
 END {Remove_PDoc};

 PRIVATE PROCEDURE Create_PD001();
 BEGIN
  CreateFILE(PD001, "", "⥦ 㬥", "");

  CreateFIELD(PD001, MyFirm,   P_Firm.tMyFirm,     "", "", "", "'' ࣠", "");
  CreateFIELD(PD001, PayP,     SCAL[100],          "", "", "", "祭 ⥦", "");
  CreateFIELD(PD001, Firm,     SCAL[10000],        "", "", "", "ࠣ", "");
  CreateFIELD(PD001, FirmAcnt, SCAL[100],          "", "", "", " ", "");
  CreateFIELD(PD001, Turn,     tTurn,              "", "", "", " ।", "");
  CreateFIELD(PD001, PDoc,     SCAL[1E9],          "", "", "", " 㬥", "");
  CreateFIELD(PD001, PDocKind, SCAL[100],          "", "", "", " 㬥", "");
  CreateFIELD(PD001, Create,   SCAL[2],            "", "", "", " 㬥", ", ");
  CreateFIELD(PD001, PrpDate,  LIKE(PDoc.PrpDate), "", "", "", " ⮢", "");
  CreateFIELD(PD001, Date,     LIKE(PDoc.Date),    "", "", "", "", "");
  CreateFIELD(PD001, AllDoc,   SCAL[2],            "", "", "", "  㬥⮢", "");
  CreateFIELD(PD001, OwnAcnt,  LIKE(PDoc.OwnAcnt), "", "", "", "", "");

  CreateINDEXandLINK(PD001, PayP,   UNIQUE, PayP,   PayP,   USER, "", "", PayP, MyFirm, Firm, FirmAcnt, Turn);
  CreateINDEXandLINK(PD001, Firm,   PLURAL, Firm,   Firm,   USER, "", "", Firm);
  CreateINDEXandLINK(PD001, PDoc,   UNIQUE, PDoc,   PDoc,   USER, "", "", PDocKind, PDoc);
  CreateINDEXandLINK(PD001, MyFirm, PLURAL, MyFirm, MyFirm, USER, "", "", MyFirm, PDocKind, PDoc);

  SetVersionOfFILE(PD001, 0);
 END {Create_PD001};

 PUBLIC PROCEDURE PDocListRepName(): STRING[];
 BEGIN
  RETURN L_General.NameConnection(RepName);
 END {PDocListRepName};

 PUBLIC PROCEDURE InitPDocGroup(Event: tEvent);
  VAR
   _Turn : LIKE(Cash.Turn);
   Local : PROC;
 BEGIN
  _Event    :=Event;

  (* 砨,   室  ௫    *)
  (*  楢  (  믫稢  १ )     *)
  Local:=PROCREF(E_PRoll.SalaryPayLev);
  IF ~!Local THEN
   SalPayLev:=Local(Event);
  ELSIF (Event = ev_DeductTransfer) | (Event = ev_OnePayPDeductTransfer) THEN  (* ᫥ 㤥ঠ *)
   SalPayLev:=spl_KO; (* ௫⭮ ᮡ⨥. ᥣ  ⥦ 祭 *)
  ELSE                (*ᮢ; ;  ௫ ࠡ⭨;  ਪ*)
   SalPayLev:=spl_PP; (*/ ࠡ⭨   ;   \*)
  END;
  SalPayLev :=SalPayLev & ~ForceEOPay;

  WithTurn:=0;
  _CurTurn:=1;
  IF    Event = ev_DeductTransfer  THEN
   _Type:=typ_Other; EventName:="ঠ  ௫  "+L_DatTim.PeriodStr(Memo.gl_mb());
   _DeductTransferTurn:=1;
  ELSIF Event = ev_OnePayPDeductTransfer  THEN
   _Type:=typ_Other; EventName:="ঠ  ௫  "+L_DatTim.PeriodStr(Memo.gl_mb()) +
                                 ". 祭 ⥦ " + PayP.PayP;
   _DeductTransferTurn:=1;
  ELSIF Event = ev_MainPay  THEN
   _Type:=typ_Mass;  EventName:="௫ ᮭ  "+L_DatTim.PeriodStr(Memo.gl_mb());
   WithTurn:=1;
  ELSIF Event = ev_AdvnPay  THEN
   L_General.CallUs(Memo.ud_mb() = L_DatTim.Per(SYSDATE()));
   _Type:=typ_Other; EventName:=" ᮭ  "+L_DatTim.PeriodStr(Memo.gl_mb());
   WithTurn:=1;
  ELSIF Event = ev_CurWholeSal  THEN
   _Type:=typ_Once;  EventName:="௫ ࠡ⭨ " + Staff.TSN + "  "+L_DatTim.PeriodStr(Memo.gl_mb());
  ELSIF Event = ev_PrvWholeSal  THEN
   _Type:=typ_Once;  EventName:="௫ ࠡ⭨ " + Staff.TSN + "    (" +
                                 L_DatTim.PeriodStr(L_DatTim.IncMonth(Memo.gl_mb(), -1)) + ")";
  ELSIF Event = ev_McodPay  THEN
   _Type:=typ_Other; EventName:="᫥   "+MCList.MCode+"  "+L_DatTim.PeriodStr(Memo.gl_mb());
   WithTurn:=1;
  ELSIF Event = ev_FordPay  THEN
   CONFORM(FOrder, MCList);
   _Type:=typ_Other; EventName:=" ਪ "+L_EDO.FOrderName()+". "+MCList.Name;
   WithTurn:=1;
  ELSIF Event = ev_FutSal  THEN
   _Type:=typ_Once;  EventName:="௫ ᮭ  ⮬ 㬬    "+L_DatTim.PeriodStr(Memo.gl_mb());
  ELSIF Event = ev_EdordPay  THEN
   _Type:=typ_Other; EventName:=" ਪ "+L_EDO.EDOrderName();
   WithTurn:=1;
  END;
  IF WithTurn THEN
   SAVE(Cash);
   SELECT(Cash, Cash);
   _Turn:=Cash.Turn;
   WHILE OCCURE(Cash) & (_Turn=Cash.Turn) DO
    NEXT(Cash);
   END; (* WHILE OCCURE(Cash) ... *)
   IF OCCURE(Cash) & (_Turn#Cash.Turn) THEN
    STDFORM(L_StdFrm.sf_Choice("|"+L_StdFrm.DrawLineInBox("%#################################%"),
                               "%<  ⮬ । >E"),
            " ନ஢ ⥦ 㬥⮢ ", , , WithTurn);
   END;
   RESTORE(Cash);
  END;
  OPENREP(List, PDocListRepName(), Create);
  MAKEPART(List, Top, EventName);
  Create_PD001(); L_AFM.AF_CreateTemp("PD001", "PD001");
 END {InitPDocGroup};

 PRIVATE PROCEDURE GetDates();
  VAR
   _PDocKindNick,
   tmpS,
   s1, s2, s3, s4: STRING[];
   tmpD: DATE;
   _EventNameArr: STRING[40][2];
   React        : NUMERIC[0];
   _PrpDate,
   _Date        : DATE;
   _OwnAcnt     : LIKE(PDoc.OwnAcnt);
   _AllDoc,
   _Create      : SCAL[2];
 BEGIN
  REPLACE(PD001);
  SAVE(PD001);
  CHANGESEL(PD001, MyFirm, , PD001.MyFirm, PD001.PDocKind);
  IF PREV(PD001) & PD001.AllDoc THEN
   _PrpDate:=PD001.PrpDate;
   _Date   :=PD001.Date;
   _AllDoc :=PD001.AllDoc;
   _OwnAcnt:=PD001.OwnAcnt;
   _Create :=PD001.Create;
   RESTORE(PD001);
   PD001.PrpDate:=_PrpDate;
   PD001.Date:=_Date;
   PD001.AllDoc:=_AllDoc;
   PD001.OwnAcnt:=_OwnAcnt;
   PD001.Create:=_Create;
   REPLACE(PD001);
   RETURN;
  END;
  RESTORE(PD001);

  IF    PDoc.PDocKind = pd_RKO THEN
   PD001.PrpDate:=GetActualPDocDate(1);
   PD001.Date:=IncWorkDay(PD001.PrpDate, +2);
   s1:=" 砫 뤠      ";
   s2:=" 砭 뤠   ";
   SETEMPTY(s3, s4);
  ELSIF PDoc.PDocKind = pd_IPP THEN
   PD001.PrpDate:=GetActualPDocDate(1);
   PD001.Date:=PD001.PrpDate;
   s1:=" ⮢         ";
   s2:="ப ⥦            ";
   s3:="                   %##%        ";
   s4:="%<0>I";
  ELSE
   L_General.CallUs(0);
  END;
  CONFORM(PDoc, Firm);
  CONFORM(PDoc, MyFirm);
  Str.Format(_EventNameArr, EventName, 40, CENTRE);
  tmpD:=PD001.PrpDate; _PDocKindNick:=PDocKindNick(PDoc.PDocKind, 1);
  tmpS:=L_StdFrm.sf_Choice("|"+_EventNameArr[0]+
                           "|"+_EventNameArr[1]+
                           "|"+" "+_PDocKindNick+":"+
                           "|"+Str.Align("। "+L_Str.IntStr(PD001.Turn) + " "+MyFirm.vzSign, 42, LEFT)+
                           "|"+Str.Align("ࠣ "+Str.Slice(Firm.Name, 0, 25), 42, LEFT)+
                           "|"+s3+
                           "|"+s1+"%##########%"+
                           "|"+s2+"%##########%"+
                           "|"+L_StdFrm.DrawLineInBox("%#################################%")+
                           "|"+L_StdFrm.DrawLineInBox("%#################################%"),
                           s4+
                           "%<D.N.y>I"+
                           "%<D.N.y>I"+
                           "%C<ନ஢ ᮡ⢥ "+_PDocKindNick+">E"+
                           "%C<ਬ  ᥬ "+_PDocKindNick+">E");
  LOOP
   IF    PDoc.PDocKind = pd_RKO THEN
    React:=STDFORM(tmpS, "ନ஢ ⥦ 㬥⮢", , ,
                   PD001.PrpDate, PD001.Date, PD001.Create, PD001.AllDoc);
   ELSIF PDoc.PDocKind = pd_IPP THEN
    React:=STDFORM(tmpS, "ନ஢ ⥦ 㬥⮢", , , PD001.OwnAcnt,
                   PD001.PrpDate, PD001.Date, PD001.Create, PD001.AllDoc);
   ELSE
    L_General.CallUs(0);
   END;

   IF ~React THEN
    STDFORM("|⢨⥫쭮 ࢠ ନ஢ 㬥⮢?|("+EventName+")"+
            "||"+L_StdFrm.DrawButton("ࢠ", 14, "Z")+"  "+L_StdFrm.DrawButton("த", 14, "FB"),
            , CHOICE);
   ELSE
    IF ~PD001.Create THEN
     STDFORM("|⢨⥫쭮  ନ஢ 㬥?|("+EventName+")"+
             "||"+L_StdFrm.DrawButton("⬥", 14, "Z")+"  "+L_StdFrm.DrawButton("த", 14, "FB"),
             , CHOICE);
     EXIT;
    ELSE
     IF (PDoc.PDocKind = pd_IPP) & ~SEARCH(FirmAcnt, Firm, GetPDocOwnFirm(), PD001.OwnAcnt) THEN
       L_StdFrm.RedInform(" ࠣ "+L_Str.FixedIntStr(GetPDocOwnFirm(), 4)+"     ஬ "+PD001.OwnAcnt);
     ELSIF (PDoc.PDocKind = pd_IPP) & ~L_DatTim.IsActive(PD001.Date, FirmAcnt.Begin, FirmAcnt.Till) THEN
      L_StdFrm.RedInform(" "+PD001.OwnAcnt+"    "+L_DatTim.DateStr(PD001.Date));
     ELSIF (PDoc.PDocKind = pd_RKO) & (PD001.Date > (PD001.PrpDate+10)) THEN
      L_StdFrm.RedInform("ப ⥦   ⮢  祬  10 ");
     ELSIF (PDoc.PDocKind = pd_IPP) & (PD001.Date > IncWorkDay(PD001.PrpDate, +2)) THEN
      L_StdFrm.RedInform("। ப 뤠   ॢ  ");
     ELSIF PD001.Date < PD001.PrpDate THEN
      L_StdFrm.RedInform(Str.Condense(s1)+"  祬 "+Str.Condense(s2));
     ELSIF PD001.Date < SYSDATE() THEN
      L_StdFrm.RedInform(Str.Condense(s2)+"  ⥬ ");
     ELSIF (PD001.PrpDate>=tmpD) |
           L_StdFrm.RedAlternative("थ "+L_DatTim.DateStr(PD001.PrpDate)+" 㦥 祭|"+
                                   " 㢥७,    ࠢ쭮?") THEN
      EXIT;
     END;
    END;
   END;
  END; (* LOOP *)
  REPLACE(PD001);
 END {GetDates};

 PRIVATE PROCEDURE E_IsolateDeductTransfer(D: DATE; _PayP: LIKE(PayP.PayP); S: NUMERIC[2]): SCAL[2];
  VAR
   Default: SCAL[2];
   Local  : PROC;
 BEGIN
  SAVE(PayP);
  L_General.CallUs(SEARCH(PayP, PayP, _PayP));
  Default:=(PayP.Type = L_PayP.ppType_Simple);
  Local:=PROCREF(E_PDoc.IsolateDeductTransfer);
  IF ~!Local THEN
   Local(D, _PayP, S, Default);
  END;
  RESTORE(PayP);
  RETURN Default;
 END {E_IsolateDeductTransfer};

 PRIVATE PROCEDURE E_AppendStaff(D: DATE): SCAL[2];
  VAR
   Default: SCAL[2];
   Local  : PROC;
 BEGIN
  Default:=1;
  Local:=PROCREF(E_PDoc.AppendStaff);
  IF ~!Local THEN
   RETURN Local(D, _Event, Default);
  END;
  RETURN Default;
 END {E_AppendStaff};

 PUBLIC PROCEDURE AppendStaff(_Sum: NUMERIC[2]; WithIns: SCAL[2]): SCAL[2];
 BEGIN
  IF ~E_AppendStaff(PDoc.Date) THEN
   PROMPT(Staff.TSN+" :  ᥭ  㬥 "+PDocStr(PDoc.PDocKind, PDoc.PDoc));
   RETURN 0;
  END;
  IF WithIns THEN
   PROMPT(Staff.TSN+" : ᥭ  㬥 "+PDocStr(PDoc.PDocKind, PDoc.PDoc));
   SEARCH(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc, Staff.TSN);
   IF OCCURE(PDocList) THEN
    PDocPrgCheck(IsDeductEvent(), "௫");
    INC(PDocList.Sum, _Sum);
    REPLACE(PDocList);
   ELSE
    DEFAULT(PDocList);
    PDocList.PDocKind:=PDoc.PDocKind;
    PDocList.PDoc    :=PDoc.PDoc;
    PDocList.TSN     :=Staff.TSN;
    PDocList.Sum     :=_Sum;
    PDocList.PDocDate:=PDoc.Date;
    PDocList.State   :=pdl_st_Paid;
    INSERT(PDocList);
   END;
   IF PDocList.State = pdl_st_Paid THEN
    INC(PDoc.Total, _Sum);
   END;
   REPLACE(PDoc);
  END;
  RETURN 1;
 END {AppendStaff};

 PRIVATE PROCEDURE StandOnStaffTimeKeep(_TSN: LIKE(Staff.TSN); D: DATE);
 BEGIN
  SAVE(Staff);
  L_General.CallUs(SEARCH(Staff, TSN, _TSN));
  IF (Staff.Contract=L_Staff.cnt_InternalCombine) & E_AccumulateContractsPayment(D) THEN
   SAVE(Staff);
   L_Staff.StandOnMainContractByStaff(D);
   L_Staff.PosToStaffLog(Staff.TSN, D, 1);
   CONFORM(StaffLog, Officer, TimeKeep);
   RESTORE(Staff);
   L_Staff.PosToStaffLog(Staff.TSN, D, 1); (* !!! *)
   CONFORM(StaffLog, Officer);
  ELSE
   L_Staff.PosToStaffLog(Staff.TSN, D, 1);
   CONFORM(StaffLog, Officer, TimeKeep);
  END;
  RESTORE(Staff);
 END {StandOnStaffTimeKeep};

 PUBLIC PROCEDURE GetStaffMainTSN(_TSN: LIKE(Staff.TSN); D: DATE): LIKE(Staff.TSN);
  VAR
   Result: LIKE(Staff.TSN);
 BEGIN
  SAVE(Staff);
  L_General.CallUs(SEARCH(Staff, TSN, _TSN));
  IF (Staff.Contract=L_Staff.cnt_InternalCombine) & E_AccumulateContractsPayment(D) THEN
   L_Staff.StandOnMainContractByStaff(D);
   Result:=Staff.TSN;
  ELSE
   Result:=_TSN;
  END;
  RESTORE(Staff);
  RETURN Result;
 END {GetStaffMainTSN};

 PUBLIC PROCEDURE AppendPDoc(S: NUMERIC[2]);
  VAR
   _MyFirm   : LIKE(PDoc.MyFirm);
   _PayP     : LIKE(PayP.PayP);
   _Firm     : LIKE(PDoc.Firm);
   _FirmAcnt : LIKE(PDoc.FirmAcnt);
   _Date     : LIKE(PDoc.Date);
   _Queue    : LIKE(PayP.Queue);
   _PDocKind : LIKE(PDoc.PDocKind);
   _mfNbr    : LIKE(PDoc.mfNbr);
   _Status   : LIKE(PDoc.Status);
   _Turn     : tTurn;
   Dummy     : SCAL[2];
 BEGIN
  IF S > 0 THEN
   _Date    :=SYSDATE();
   _MyFirm  :=Staff.MyFirm;
   _PayP    :=EOR_PAYP;
   _Firm    :=P_Firm.GetFirmOfMyFirm(_MyFirm);
   _FirmAcnt:=EMPTYOF(PDoc.FirmAcnt);
   GetDataForPDoc(_Date, _PayP, _Firm, _FirmAcnt);
   _Turn:=1;
   IF _Firm # P_Firm.GetFirmOfMyFirm(_MyFirm) THEN
    _PDocKind:=pd_IPP;
   ELSE
    _PDocKind:=pd_RKO;
   END;
   IF IsSalaryEvent() THEN
    L_General.CallUs(SEARCH(PayP, PayP, _PayP));
    IF WithTurn THEN
     StandOnStaffTimeKeep(Staff.TSN, SYSDATE());
     CONFORM(TimeKeep, Cash);
     _Turn:=Cash.Turn*MAXOF(Staff.TSN);
     _Turn:=E_TurnForPDoc(_Date, _Turn, _PDocKind);
    END;
    IF    PayP.Type = L_PayP.ppType_Simple THEN
     INC(_CurTurn);
     _Turn:=_Turn+_CurTurn;
    END;
   ELSIF E_IsolateDeductTransfer(_Date, _PayP, S) THEN
    INC(_DeductTransferTurn);
    _Turn:=_DeductTransferTurn;
   END;
   IF ~SEARCH(PD001, PayP, _PayP, _MyFirm, _Firm, _FirmAcnt, _Turn) THEN
    SETEMPTY(_mfNbr);
    IF (_PDocKind = pd_IPP) & ~ForceUnClosedPay THEN
     _Status:=st_Prepared;
    ELSE
     IF IsMassDocEvent() | IsDeductEvent() | ForceUnClosedPay THEN
      _mfNbr:=Temporary_mfNbr(_MyFirm, _PDocKind, _Date, 1);
      _Status:=st_Prepared;
     ELSE
      _Status:=st_Passed;
     END;
    END;
    IF ForceUnClosedPay & AccessUnClosedSalPDoc(_MyFirm, _PDocKind, L_DatTim.Per(_Date)) THEN
     PDoc.Status:=_Status;
     REPLACE(PDoc);
     IF PDoc.Done THEN
      SAVE(Staff);
      CALL(PDoc.SingleMakeUnDone());
      RESTORE(Staff);
     END;
    ELSE
     DEFAULT(PDoc);
     PDoc.PDocKind:=_PDocKind;
     PDoc.MyFirm  :=_MyFirm;
     PDoc.mfNbr   :=_mfNbr;
     SAVE(PayP);
     AccessPayP(_PayP);
     PDoc.Date    :=_Date;
     PDoc.PrpDate :=_Date;
     PDoc.Dest    :=PayP.Dest;
     PDoc.Queue   :=PayP.Queue;
     PDoc.payp    :=_PayP;
     PDoc.Firm    :=_Firm;
     PDoc.FirmAcnt:=_FirmAcnt;
     PDoc.Type    :=_Type;
     P_Firm.AccessSilentFirmAcnt(P_Firm.GetFirmOfMyFirm(_MyFirm), SYSDATE());
     PDoc.OwnAcnt :=FirmAcnt.FirmAcnt;
     SETZERO(PDoc.Total);
     PDoc.Source  :=src_InProgress;
     PDoc.ServDate:=Memo.gl_cd();
     SETEMPTY(PDoc.PmntKind, PDoc.ExtAbout);
     PDoc.Status  :=_Status;
     RESTORE(PayP);
     SetPDocComment("");
     Insert_PDoc();
    END;

    DEFAULT(PD001);
    PD001.PayP    :=PDoc.payp;
    PD001.MyFirm  :=PDoc.MyFirm;
    PD001.Firm    :=PDoc.Firm;
    PD001.FirmAcnt:=PDoc.FirmAcnt;
    PD001.Turn    :=_Turn;
    PD001.PDocKind:=PDoc.PDocKind;
    PD001.PDoc    :=PDoc.PDoc;
    PD001.Create  :=1;
    PD001.OwnAcnt :=PDoc.OwnAcnt;
    INSERT(PD001);
    IF IsMassDocEvent() | IsDeductEvent() THEN
     IF    PDoc.PDocKind = pd_RKO THEN
      GetDates();
      PDoc.PrpDate:=PD001.PrpDate;
      PDoc.Date   :=PD001.Date;
     ELSIF PDoc.PDocKind = pd_IPP THEN
      GetDates();
      PDoc.PrpDate:=PD001.PrpDate;
      PDoc.Date   :=PD001.Date;
      PDoc.OwnAcnt:=PD001.OwnAcnt;
     END;
     REPLACE(PDoc);
    END;
   END; (* IF ~SEARCH(PD001, PayP, _PayP, _Firm, _FirmAcnt, _Turn) ... *)
   CONFORM(PD001, PDoc);
   Dummy:=AppendStaff(S, 1);
  END; (* IF S > 0 *)
 END {AppendPDoc};

 PUBLIC PROCEDURE AccessmfBnkAcn(_MyFirm: P_Firm.tMyFirm; _FirmAcnt: LIKE(FirmAcnt.FirmAcnt));
 BEGIN
  L_General.CallUs(SEARCH(mfBnkAcn, MyFirm, _MyFirm, _FirmAcnt));
 END {AccessmfBnkAcn};

 PUBLIC PROCEDURE IncWorkDay(_Date: DATE; i: NUMERIC[0]): DATE;
  VAR
   j,
   s: NUMERIC[0];
 BEGIN
  IF i<0 THEN
   s:=-1;
  ELSE
   s:=+1;
  END;
  j:=0;
  INC(_Date, s);
  WHILE j#i DO
   L_General.Assert(SEARCH(Calendar, Date, _Date), "   ᠭ "+L_DatTim.DateStr(_Date));
   IF Calendar.WeekDay < 5 THEN
    INC(j, s);
   END;
   INC(_Date, s);
  END;
  RETURN Calendar.Date;
 END {IncWorkDay};

 PUBLIC PROCEDURE GetActualPDocDate(Silent: SCAL[2]): DATE;
  VAR
   D     : DATE;
   T,
   ctrlT : TIME;
   Choice: NUMERIC[0];
 BEGIN
  L_General.CallUs(PDoc.MyFirm # P_Firm.mf_Fict);
  D:=SYSDATE();
  T:=SYSTIME();
  AccessmfBnkAcn(PDoc.MyFirm, GetPDocOwnFirmAcnt());
  IF L_Hld.DayIsBeforeHoliday(D) THEN
   ctrlT:=mfBnkAcn.EndTime[1];
  ELSE
   ctrlT:=mfBnkAcn.EndTime[0];
  END;
  IF T > ctrlT THEN
   IF ~Silent THEN
    Choice:=STDFORM(L_StdFrm.PartForm(
                     "%< 騩 ࠡ稩 >DB"+
                     "%<    譨    >B"+
                     "%<     ⬥      >Z"+
                     "@"+
                     "|樮  祭.  ।   ⥦:"+
                     "|                                   "+
                     "|%###################% %###################% %###################%"),
                     " 롮  ⥦ ", STOP);
   ELSE
    Choice:=1;
   END;
   IF Choice = 1 THEN
    D:=IncWorkDay(D, 1);
   END;
  END;
  RETURN D;
 END {GetActualPDocDate};

 PRIVATE PROCEDURE PDocSingleMakeDone();
 BEGIN
  CALL(PDoc.SingleMakeDone());
 END {PDocSingleMakeDone};

 PUBLIC PROCEDURE ExtDonePDocGroup(ByCassa: SCAL[2]; Closed: SCAL[2]);
  VAR
   Tot: NUMERIC[2];
 BEGIN
  SELECT(PD001, PayP);
  WHILE OCCURE(PD001) DO
   CONFORM(PD001, PDoc);
   PROMPT(PDocStr(PDoc.PDocKind, PDoc.PDoc));
   FillPDocAbout();
   FillPDocPmntKind();
   IF PD001.Create & SELECT(PDocList, PDoc, PD001.PDocKind, PD001.PDoc) THEN
    IF ~IsUnClosedSalPDoc(PDoc.mfNbr) THEN
     CALL(PDocP.Print_InOpenRep());                (*  㬥            *)
    END;
    IF Closed THEN
     IF ByCassa THEN
      CALL(PDocP.PrintPaySheetByCash_InOpenRep()); (*  ᯨ᪠  ᠬ     *)
     ELSE
      CALL(PDocP.PrintPaySheet_InOpenRep());       (*  ᯨ᪠   ᠬ  *)
     END;
     CALL(Add_Doc, 062);         (*  . 㬥⮢ *)
    END;
    PDoc.Source:=src_Auto;
    REPLACE(PDoc);

    L_APtm.TemporarySetMemoDate(PDoc.Date, PROCREF(PDocSingleMakeDone));
   END;
   IF PD001.Create THEN
    PD001.Create:=SELECT(PDocList, PDoc, PD001.PDocKind, PD001.PDoc);
    REPLACE(PD001);
   END;
   NEXT(PD001);
  END; (* WHILE OCCURE(PD001) ... *)

  SELECT(PD001, PDoc);
  WHILE OCCURE(PD001) DO
   NARROWSEL(PD001, PDocKind);
   SEARCH(PDocKind, PDocKind, , PD001.PDocKind);
   MAKEPART(List, PDK_Top);
   Tot:=0;
   WHILE OCCURE(PD001) DO
    CONFORM(PD001, PDoc);
    PROMPT(PDocStr(PDoc.PDocKind, PDoc.PDoc));
    MAKEPART(List, Line, PD001.Create);
    INC(Tot, PDoc.Total);
    IF ~PD001.Create THEN
     REMOVE(PD001);
     Remove_PDoc(1);
    ELSE
     NEXT(PD001);
    END;
   END; (* WHILE OCCURE(File) *)
   MAKEPART(List, PDK_Bot, Tot);
   NEXTINEXTENDEDSEL(PD001, PDocKind);
  END; (* WHILE OCCURE(PD001) *)
  MAKEPART(List, Bottom);
  CLOSEREP(List);
  L_AFM.AF_PurgeTemp("PD001");
 END {ExtDonePDocGroup};

 PUBLIC PROCEDURE DonePDocGroup(ByCassa: SCAL[2]);
 BEGIN
  ExtDonePDocGroup(ByCassa, 1);
 END {DonePDocGroup};

 PUBLIC PROCEDURE AccessFirstAcMthL();
  VAR
   _Dest: LIKE(Dest.Dest);
 BEGIN
  IF IsPDocwMDoc() THEN
   _Dest:=MDoc.Dest;
  ELSE
   _Dest:=PDoc.Dest;
  END;
  L_Acnt.SelectOperatingAcMthL(L_DatTim.Per(PDoc.Date), PDocDGroup(PDoc.PDocKind),
                               _Dest, EMPTYOF(MathType.MathType), EMPTYOF(MMode.MMode), 0);
 END {AccessFirstAcMthL};

 PUBLIC PROCEDURE AccessFirstPDocMDoc();
 BEGIN
  CONFORM(PDoc, PDocMDoc);
  L_General.Assert(OCCURE(PDocMDoc), " ⮬ 񦭮 㬥|  㪠 뫪  ⮢ 㬥");
 END {AccessFirstPDocMDoc};

 PRIVATE PROCEDURE _AcCutCond(): SCAL[2];
 BEGIN
  RETURN (AcMthL.AcCut = AcCut.AcCut) | (AcMthL.AcCut2 = AcCut.AcCut);
 END {_AcCutCond};

 PRIVATE PROCEDURE _ApportCond(): SCAL[2];
 BEGIN
  RETURN (AcMthL.Apport = Apport.Apport) | (AcMthL.Apport2 = Apport.Apport);
 END {_ApportCond};

 PRIVATE PROCEDURE _HasInCurPDoc(Cond: PROC): SCAL[2];
 BEGIN
  IF IsPDocwMDoc() THEN
   AccessFirstPDocMDoc();
   CONFORM(PDocMDoc, MDoc);
  END;
  LOOP
   AccessFirstAcMthL();
   WHILE OCCURE(AcMthL) DO
    IF Cond() THEN
     RETURN 1;
    END;
    NEXT(AcMthL);
   END; (* WHILE OCCURE(AcMthL) ... *)
   IF ~IsPDocwMDoc() | ~NEXT(PDocMDoc) THEN
    EXIT;
   ELSE
    CONFORM(PDocMDoc, MDoc);
   END;
  END;
  RETURN 0;
 END {_HasInCurPDoc};

 PRIVATE PROCEDURE HasAcCut(): SCAL[2];
 BEGIN
  RETURN _HasInCurPDoc(PROCREF(_AcCutCond));
 END {HasAcCut};

 PRIVATE PROCEDURE HasApport(): SCAL[2];
 BEGIN
  RETURN _HasInCurPDoc(PROCREF(_ApportCond));
 END {HasApport};

 PUBLIC PROCEDURE GetGlobalAcCutForSalPDoc(D: DATE): LIKE(AcCut.AcCut);
 BEGIN
  IF    MoneyKind(PDoc.PDocKind) = mk_Cash THEN RETURN L_kn.Get(D, L_AcCut.erkn_CentralCashOffice);
  ELSIF MoneyKind(PDoc.PDocKind) = mk_Bank THEN RETURN L_kn.Get(D, L_AcCut.erkn_SettlementAccounts);
  ELSE
   L_General.Error(L_XDoc.XDocStr(PDoc.XDocId+": ᯮ짮 '௫⭮'  (" + PDoc.Dest + ") ⨬");
  END;
 END {GetGlobalAcCutForSalPDoc};

 PRIVATE PROCEDURE intGetAcnt(trgPDocKind: LIKE(PDoc.PDocKind);
                              trgPDoc    : LIKE(PDoc.PDoc);
                              NeedCorAcnt: SCAL[2]): LIKE(AcCut.Sign);
  VAR
   OnDate  : DATE;
   NotInv  : SCAL[2];
   trgAcCut: LIKE(AcCut.AcCut);
 BEGIN
  SAVE(PDoc);
  SEARCH(PDoc, PDoc, , trgPDocKind, trgPDoc);
  OnDate:=PDoc.Date;
  IF IsSalPDoc() THEN
   IF NeedCorAcnt THEN
    SAVE(Staff);
    CONFORM(PDoc, PDocList);
    CONFORM(PDocList, Staff);
    trgAcCut:=L_PRoll.GetSalaryAcCut(PDoc.Date);
    RESTORE(Staff);
   ELSE
    trgAcCut:=GetGlobalAcCutForSalPDoc(OnDate);
   END;
  ELSE
   SAVE(MDoc);
   SAVE(PDocMDoc);
   IF IsPDocwMDoc() THEN
    AccessFirstPDocMDoc();
    CONFORM(PDocMDoc, MDoc);
   END;
   AccessFirstAcMthL();
   L_General.Assert(OCCURE(AcMthL), " ᠭ :" +
                    L_Acnt.AcMthStrForMessage(AcMth.DGroup,
                                              AcMth.Dest,
                                              EMPTYOF(MathType.MathType),
                                              EMPTYOF(MMode.MMode)));
   IF ~!AcMthL.Apport THEN
    SEARCH(Apport, Apport, , AcMthL.Apport);
    NotInv:=(Apport.CirType = L_Acnt.ct_Debit);
   ELSE
    SEARCH(Apport, Apport, , AcMthL.Apport2);
    NotInv:=(Apport.CirType = L_Acnt.ct_Credit);
   END;
   IF (~IsOutPDoc(trgPDocKind) = NeedCorAcnt) = NotInv THEN
    trgAcCut:=L_Acnt.getAcMthL_AcCut2(OnDate);
   ELSE
    trgAcCut:=L_Acnt.getAcMthL_AcCut(OnDate);
   END;
   RESTORE(PDocMDoc);
   RESTORE(MDoc);
  END;
  RESTORE(PDoc);
  RETURN L_Acnt.GetAcCutSign(PDoc.Date, trgAcCut);
 END {intGetAcnt};

 PUBLIC PROCEDURE GetCorAcnt(_PDocKind: LIKE(PDoc.PDocKind); _PDoc: LIKE(PDoc.PDoc)): LIKE(AcCut.Sign);
 BEGIN
  RETURN intGetAcnt(_PDocKind, _PDoc, 1);
 END {GetCorAcnt};

 PUBLIC PROCEDURE GetOwnAcnt(_PDocKind: LIKE(PDoc.PDocKind); _PDoc: LIKE(PDoc.PDoc)): LIKE(CAcnt.Sign);
 BEGIN
  RETURN intGetAcnt(_PDocKind, _PDoc, 0);
 END {GetOwnAcnt};

 PUBLIC PROCEDURE GetGlobalXObject(_MyFirm: P_Firm.tMyFirm; _FirmAcnt: LIKE(FirmAcnt.FirmAcnt)): LIKE(XObject.XObject);
 BEGIN
  AccessmfBnkAcn(_MyFirm, _FirmAcnt);
  RETURN mfBnkAcn.XObject;
 END {GetGlobalXObject};

 PUBLIC PROCEDURE AccessGlobalXObject();
 BEGIN
  L_XObj.AccessXObject(GetGlobalXObject(PDoc.MyFirm, GetPDocOwnFirmAcnt()));
 END {AccessGlobalXObject};

 PUBLIC PROCEDURE PDoc_ClcPer(): DATE;
 BEGIN
  RETURN L_APtm.ANYSystem_ClcPer(L_APtm.system_PDoc);
 END {PDoc_ClcPer};

 PUBLIC PROCEDURE PDoc_CheckNoTouch(D: DATE);
 BEGIN
  L_APtm.ANYSystem_CheckNoTouch(D, L_APtm.system_PDoc);
 END {PDoc_CheckNoTouch};

 PUBLIC PROCEDURE PDocDGroup(_PDocKind: LIKE(PDoc.PDocKind)): LIKE(AcMth.DGroup);
  VAR
   _DGroup: LIKE(PDocKind.DGroup);
 BEGIN
  SAVE(PDocKind);
  L_General.CallUs(SEARCH(PDocKind, PDocKind, _PDocKind));
  _DGroup:=PDocKind.DGroup;
  RESTORE(PDocKind);
  RETURN _DGroup;
 END {PDocDGroup};

 PUBLIC PROCEDURE PDocKindNick(_PDocKind: LIKE(PDoc.PDocKind); NoLatin: SCAL[2]): STRING[3];
 BEGIN
  IF    _PDocKind = pd_RKO THEN RETURN Str.Item("RKO|", "|", NoLatin);
  ELSIF _PDocKind = pd_PKO THEN RETURN Str.Item("PKO|", "|", NoLatin);
  ELSIF _PDocKind = pd_IPP THEN RETURN Str.Item("IPP|", "|", NoLatin);
  ELSIF _PDocKind = pd_VPP THEN RETURN Str.Item("VPP|", "|", NoLatin);
  ELSIF _PDocKind = pd_IMO THEN RETURN Str.Item("IMO|", "|", NoLatin);
  ELSIF _PDocKind = pd_VMO THEN RETURN Str.Item("VMO|", "|", NoLatin);
  ELSIF _PDocKind = pd_ITP THEN RETURN Str.Item("ITP|", "|", NoLatin);
  ELSIF _PDocKind = pd_VTP THEN RETURN Str.Item("VTP|", "|", NoLatin);
  ELSIF _PDocKind = pd_OVN THEN RETURN Str.Item("OVN|", "|", NoLatin);
  ELSIF _PDocKind = pd_CND THEN RETURN Str.Item("CND|", "|", NoLatin);
  ELSIF _PDocKind = pd_AVO THEN RETURN Str.Item("AVO|", "|", NoLatin);
  ELSIF _PDocKind = pd_VPK THEN RETURN Str.Item("VPK|", "|", NoLatin);
  ELSIF _PDocKind = pd_IPK THEN RETURN Str.Item("IPK|", "|", NoLatin);
  ELSIF _PDocKind = pd_VhP THEN RETURN Str.Item("VhP|", "|", NoLatin);
  ELSIF _PDocKind = pd_IsP THEN RETURN Str.Item("IsP|", "|", NoLatin);
  ELSIF _PDocKind = pd_VPG THEN RETURN Str.Item("VPG|", "|", NoLatin);
  ELSIF _PDocKind = pd_IPG THEN RETURN Str.Item("IPG|", "|", NoLatin);
  ELSIF _PDocKind = pd_AIN THEN RETURN Str.Item("AIN|", "|", NoLatin);
  ELSIF _PDocKind = pd_AII THEN RETURN Str.Item("AII|", "|", NoLatin);
  ELSIF _PDocKind = pd_ROO THEN RETURN Str.Item("ROO|", "|", NoLatin);
  ELSIF _PDocKind = pd_POO THEN RETURN Str.Item("POO|", "|", NoLatin);
  ELSE  L_General.CallUs(0);
  END;
 END {PDocKindNick};

 PRIVATE PROCEDURE _AssertFitforPDoc(Cond: SCAL[2]; ObjectName, ObjectValueInPD, ObjectValueInDe: STRING[]);
 BEGIN
  _AssertByDeduct(Cond, " ᮢ "+ObjectName+"     㤥ঠ ࠡ⭨,"+
                        "|祭   - "+ObjectValueInPD+", 祭  㤥ঠ  - "+ObjectValueInDe);
 END {_AssertFitforPDoc};

 PUBLIC PROCEDURE CheckDeductFitforPDoc();
 BEGIN
  _AssertFitforPDoc(Deduct.PayP = PDoc.payp, "祭 ⥦", PDoc.payp, Deduct.PayP);
  _AssertFitforPDoc(Deduct.Firm = PDoc.Firm, "ࠣ", PDoc.Firm, Deduct.Firm);
  IF ~!Deduct.FirmAcnt THEN
   _AssertFitforPDoc(Deduct.FirmAcnt = PDoc.FirmAcnt, "  ⥫", PDoc.FirmAcnt, Deduct.FirmAcnt);
  END;
 END {CheckDeductFitforPDoc};

 PUBLIC PROCEDURE ScanDeductTSN(_TSN: LIKE(Deduct.TSN); PP: PROC);
  VAR
   _IsSalPDoc: SCAL[2];
   IndexBy   : STRING[250];
   AmntForTSN: NUMERIC[0];
 BEGIN
  SEARCH(PayP, PayP, , PDoc.payp);
  _IsSalPDoc:=IsSalPDoc();
  AmntForTSN:=0;
  SELECT(Deduct, TSN, , _TSN);
  WHILE OCCURE(Deduct) DO
   IF  _IsSalPDoc & IsActiveSpecDeduct(PDoc.Date) |
      ~_IsSalPDoc & IsNeedDeduct(PDoc.payp, PDoc.Firm, PDoc.FirmAcnt) THEN
    IF IsActiveSpecDeduct(PDoc.Date) THEN
     L_General.Assert(AmntForTSN=0, "    㤥ঠ  楢   "+L_DatTim.DateStr(PDoc.Date)+"| "+Staff.TSN);
    END;
    IF PayP.Type # L_PayP.ppType_Simple THEN
     IndexBy:=L_PayP.GetObjName(PayP.LstAttr[0], 1);
     _AssertByDeduct(~!IndexBy, " 㪠 祭 ४ ஢");
    END;
    CheckDeductFitforPDoc();
    PP();
    INC(AmntForTSN);
   END;
   NEXT(Deduct);
  END; (* WHILE OCCURE(Deduct) ... *)
  L_General.Assert(AmntForTSN > 0, Staff.TSN+" "+Man.Name+"|  ⨢ 室 㤥ঠ");
 END {ScanDeductTSN};

 PUBLIC PROCEDURE AccessPDoc();
 BEGIN
  L_General.Assert(ACCESS(PDoc), " ⠭ ⥦ 㬥");
 END {AccessPDoc};

 PUBLIC PROCEDURE CheckTaxed();
 BEGIN
  L_General.Assert(PDoc.Status#st_Prepared,
                   "⥦ 㬥 " + PDocStr(PDoc.PDocKind, PDoc.PDoc) +
                   "|    ﭨ '⮢'");
 END {CheckTaxed};

 PUBLIC PROCEDURE CheckPassed();
 BEGIN
  L_General.Assert(PDoc.Status=st_Passed,
                   "⥦ 㬥 " + PDocStr(PDoc.PDocKind, PDoc.PDoc) +
                   "|   ﭨ '஢'");
 END {CheckPassed};

 PUBLIC PROCEDURE CheckDone();
 BEGIN
  L_General.Assert(PDoc.Done,
                   "⥦ 㬥 " + PDocStr(PDoc.PDocKind, PDoc.PDoc) +
                   "|  ࠡ⠭");
 END {CheckDone};

 PUBLIC PROCEDURE PDocTotalFillMethod(): tPDocTotalFillMethod;
 BEGIN
  IF IsSalPDoc() THEN
   RETURN pdtfm_byPDocList;
  ELSIF (PDoc.PDocKind = pd_VPK) |
        (PDoc.PDocKind = pd_IPK) |
        (PDoc.PDocKind = pd_AVO) THEN
   RETURN pdtfm_byPDocMDoc;
  ELSE
   RETURN pdtfm_Manual;
  END;
 END {PDocTotalFillMethod};

 PUBLIC PROCEDURE InPassingNoteSetting(): SCAL[2];
 BEGIN
  RETURN ~!L_WDO.AccessEnvVar("InPassingNoteSetting");
 END {InPassingNoteSetting};

 PUBLIC PROCEDURE IsOneHeadFirmBranch(trgMyFirm: P_Firm.tMyFirm; trgFirm: LIKE(Firm.Firm); trgDate: DATE): SCAL[2];
  VAR
   HeadFirm: LIKE(Firm.Firm);
 BEGIN
  HeadFirm:=P_Firm.FP_HeadFirm(P_Firm.fomf(trgMyFirm), trgDate);
  RETURN ~!HeadFirm &
         ((HeadFirm = trgFirm) | (HeadFirm = P_Firm.FP_HeadFirm(trgFirm, trgDate)));
 END {IsOneHeadFirmBranches};

 PUBLIC PROCEDURE PDocMustHaveKPP(): SCAL[2];
 BEGIN
  IF ~!PDoc.ExtAbout THEN
   RETURN 1;
  ELSE
   RETURN IsOneHeadFirmBranch(PDoc.MyFirm, PDoc.Firm, PDoc.Date);
  END;
 END {PDocMustHaveKPP};

 PUBLIC PROCEDURE GetPDocOwnFirmKPP(): STRING[];
 BEGIN
  L_General.CallUs(~!PDoc.MyFirm);
  RETURN P_MySite.GetP_KPP(PDoc.MyFirm,
                           P_PDoc.GetPDocProSoft(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_MyPlace),
                           PDoc.Date);
 END {GetPDocOwnFirmKPP};

 PUBLIC PROCEDURE GetStaffMPacket(trgDate: DATE): LIKE(TimeKeep.MPacket);
  VAR
   Result: LIKE(TimeKeep.MPacket);
 BEGIN
  TRY
   StandOnStaffTimeKeep(Staff.TSN, L_DatTim.MonthEnd(trgDate));
   Result:=TimeKeep.MPacket;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  RETURN Result;
 END {GetStaffMPacket};

 PUBLIC PROCEDURE GetStaffCash(trgDate: DATE): LIKE(TimeKeep.Cash);
  VAR
   Result: LIKE(TimeKeep.Cash);
 BEGIN
  TRY
   StandOnStaffTimeKeep(Staff.TSN, L_DatTim.MonthEnd(trgDate));
   Result:=TimeKeep.Cash;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  RETURN Result;
 END {GetStaffCash};

(*------------- ClientBank---------------------*)

 PUBLIC PROCEDURE IsPDocToUpload(): SCAL[2];
 BEGIN
  RETURN (PDoc.PDocKind=pd_IPP) &
         (PDoc.Status=st_Prepared) &
         (~IsUnClosedSalPDoc(PDoc.mfNbr)) &
         ~CB_IsUploadedPDoc(PDoc.PDocKind, PDoc.PDoc);
 END {IsPDocToUpload};

 PUBLIC PROCEDURE CB_IsUploadedPDoc(_PDocKind: LIKE(PDoc.PDocKind); _PDoc: LIKE(PDoc.PDoc)): SCAL[2];
 BEGIN
  RETURN P_PDoc.HasPDocPro(_PDocKind, _PDoc, P_PDoc.P_CBStamp);
 END {CB_IsUploadedPDoc};

 PUBLIC PROCEDURE CB_GetClientBankName(_CB: NUMERIC[0]): STRING[];
  VAR
   s: STRING[];
 BEGIN
  s:="("+FLDTOSTR(_CB, "0", 0)+") ";
  IF _CB = 0 THEN
   RETURN s+" -";
  ELSE
   RETURN s+E_PDoc.ClientBankOperation(_CB, "ClientBankName");
  END;
 END {CB_GetClientBankName};

 PUBLIC PROCEDURE CB_GetClientBank(_Date: DATE; _MyFirm: P_Firm.tMyFirm): NUMERIC[0];
  VAR
   _CB  : NUMERIC[0];
   _Name,
   _Bank,
   _BIC_,
   _INN_: STRING[];
   _Acnt: STRING[][2];
   Local: PROC;
 BEGIN
  _CB:=0;
  Local:=PROCREF(E_PDoc.ClientBank);
  IF ~!Local THEN
   _CB:=Local(_Date);
  ELSE
   Local:=PROCREF(E_PDoc.ClientBankByBIC);
   IF ~!Local THEN
    SAVE(Firm);
    SAVE(Bank);
    SAVE(BankLog);
    SAVE(BankBrn);
    SAVE(BankBrnL);
    P_Firm.AccessOwnFirm(_MyFirm);
    P_Firm.GetFirmData(_Date, _Name, _Bank, _Acnt, _BIC_, _INN_, 0);
    _CB:=Local(_Date, _BIC_);
    RESTORE(BankBrnL);
    RESTORE(BankBrn);
    RESTORE(BankLog);
    RESTORE(Bank);
    RESTORE(Firm);
   END;
  END;
  RETURN _CB;
 END {CB_GetClientBank};

 PUBLIC PROCEDURE CB_GetPDocClientBank(_PDocKind: LIKE(PDoc.PDocKind); _PDoc: LIKE(PDoc.PDoc)): NUMERIC[0];
  VAR
   _CB: NUMERIC[0];
 BEGIN
  SAVE(PDoc);
  SearchPDoc(_PDocKind, _PDoc);
  SAVE(FirmAcnt);
  AccessPDocOwnFirmAcnt();
  CONFORM(PDoc, MyFirm);
  _CB:=CB_GetClientBank(PDoc.Date, PDoc.MyFirm);
  RESTORE(FirmAcnt);
  RESTORE(PDoc);
  RETURN _CB;
 END {CB_GetPDocClientBank};

 PUBLIC PROCEDURE CB_PutStamp(_PDocKind: LIKE(PDoc.PDocKind); _PDoc: LIKE(PDoc.PDoc); _Value: STRING[]);
 BEGIN
  P_PDoc.SetPDocPro(_PDocKind, _PDoc, P_PDoc.P_CBStamp, _Value);
 END {CB_PutStamp};

 PUBLIC PROCEDURE CB_GetStamp(_PDocKind: LIKE(PDoc.PDocKind); _PDoc: LIKE(PDoc.PDoc)): STRING[];
 BEGIN
  RETURN P_PDoc.GetPDocProSoft(_PDocKind, _PDoc, P_PDoc.P_CBStamp);
 END {CB_GetStamp};

 PUBLIC PROCEDURE CB_ClearStamp(_PDocKind: LIKE(PDoc.PDocKind); _PDoc: LIKE(PDoc.PDoc));
 BEGIN
  P_PDoc.RemovePDocPro(_PDocKind, _PDoc, P_PDoc.P_CBStamp);
 END {CB_ClearStamp};

 PUBLIC PROCEDURE E_AllowAnyStaffMyFirmInAnyPDocList(): SCAL[2];
 BEGIN
  RETURN L_General.IsPolakSpecific();
 END {E_AllowAnyStaffMyFirmInAnyPDocList};

 PUBLIC PROCEDURE E_AllowAnyStaffMyFirmInPDocList(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF ~IsSalPDoc() & E_AllowAnyStaffMyFirmInAnyPDocList() THEN
   Result:=1;
  END;
  RETURN Result;
 END {E_AllowAnyStaffMyFirmInPDocList};

(*-------------BEGIN OF NORMAL ENVIRONMENT--------------------------*)

 PUBLIC PROCEDURE E_NeedPasspInPDoc(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_PDoc.NeedPasspInPDoc), 1);
 END {E_NeedPasspInPDoc};

 PUBLIC PROCEDURE E_DefaultPDocPmntKind(P: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(P, PROCREF(E_PDoc.DefaultPDocPmntKind), 2);
 END {E_DefaultPDocPmntKind};

 PUBLIC PROCEDURE E_DefaultPayLAmnt(P: DATE): NUMERIC[0];
 BEGIN
  IF    PDoc.PDocKind = pd_IPP THEN
   IF PDoc.PmntKind = 2(*஭*) THEN
    RETURN L_EC.ExecE_Func_Numeric(P, PROCREF(E_PDoc.DefaultPayLAmnt), 2);
   ELSE
    RETURN L_EC.ExecE_Func_Numeric(P, PROCREF(E_PDoc.DefaultPayLAmnt), 4);
   END;
  ELSIF (PDoc.PDocKind = pd_VPP) | (PDoc.PDocKind = pd_AVO) |
        (PDoc.PDocKind = pd_AIN) | (PDoc.PDocKind = pd_AII) THEN
   RETURN 1;
  ELSE
   L_General.CallUs(0);
  END;
 END {E_DefaultPayLAmnt};

 PUBLIC PROCEDURE E_ClientBankNick(_CB: NUMERIC[0]): STRING[];
  VAR
   p: PROC;
   s: STRING[];
 BEGIN
  p:=PROCREF(E_PDoc.ClientBankNick);
  IF ~!p THEN
   s:=E_PDoc.ClientBankNick(_CB);
   IF ~!s THEN
    RETURN s;
   END;
  END;
  RETURN cb_NoCB_Nick;
 END {E_ClientBankNick};

 PUBLIC PROCEDURE E_NeedSignInKO(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PDoc.NeedSignInKO), 1);
 END {E_NeedSignInKO};

 PRIVATE PROCEDURE E_AccumulateContractsPayment(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PDoc.AccumulateContractsPayment), 0);
 END {E_AccumulateContractsPayment};

 PUBLIC PROCEDURE E_NeedCorrectPCalc(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_PDoc.NeedCorrectPCalc), 1);
 END {E_NeedCorrectPCalc};

 PUBLIC PROCEDURE E_O_PDocP_GetTemplateVersion(): STRING[2];
  VAR
   Local     : PROC;
   DefaultVer: STRING[];
 BEGIN
  IF PDoc.PDocKind = pd_AVO THEN
   DefaultVer:=pd_DefaultTemplateVersion;
  ELSE
   DefaultVer:="";
  END;
  Local:=PROCREF(E_PDoc.O_PDocP_GetTemplateVersion);
  IF ~!Local THEN
   RETURN Local(DefaultVer);
  END;
  RETURN DefaultVer;
 END {E_O_PDocP_GetTemplateVersion};

 PUBLIC PROCEDURE E_PDocP_SpecialPrint(VAR Output: NUMERIC[0]): SCAL[2];
  VAR
   Result: SCAL[2];
   Local : PROC;
 BEGIN
  Result:=(PDoc.PDocKind = pd_AVO) |
          (PDoc.PDocKind = pd_AIN) | (PDoc.PDocKind = pd_AII) |
          IsPDocKind_wPmntMsgAsMainForm(PDoc.PDocKind, PDoc.Date);
  Local:=PROCREF(E_PDoc.O_PDocP_SpecialPrint);
  IF    ~!Local THEN
   Local(Result, Output);
  END;
  RETURN Result;
 END {E_PDocP_SpecialPrint};

 PUBLIC PROCEDURE E_cb_Amount(D: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_PDoc.cb_Amount), 5);
 END {E_cb_Amount};

 PRIVATE PROCEDURE E_TurnForPDoc(_D: DATE; _Turn: tTurn; _PDocKind: LIKE(PDoc.PDocKind)): tTurn;
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PDoc.TurnForPDoc);
  IF ~!Local THEN
   _Turn:=Local(_D, _Turn, _PDocKind);
  END;
  RETURN _Turn;
 END {E_TurnForPDoc};

 PUBLIC PROCEDURE E_FileNameForAdd_Doc(D: DATE; curCB: NUMERIC[0]; DefaultName: STRING[]): STRING[];
  VAR
   Local : PROC;
   Result: STRING[];
   tPath,
   tFileName: STRING[];
 BEGIN
  Local:=PROCREF(E_PDoc.FileNameForAdd_Doc);
  IF ~!Local THEN
   Result:=Local(PDoc.Date, curCB, DefaultName);
  ELSE
   Result:=DefaultName;
  END;
  FIO.SplitPath(Result, tFileName, , tPath);
  tPath:=L_FIO.MakeDir(tPath);
  RETURN Result;
 END {E_FileNameForAdd_Doc};

 PUBLIC PROCEDURE IsRequiredPDocKind(trgPDocKind: LIKE(PDocKind.PDocKind); D: DATE): tRequiredPDocKind;
 BEGIN
  IF    (trgPDocKind = pd_RKO) |
        (trgPDocKind = pd_PKO) |
        (trgPDocKind = pd_IPP) |
        (trgPDocKind = pd_VPP) |
        (trgPDocKind = pd_IMO) |
        (trgPDocKind = pd_VMO) |
        (trgPDocKind = pd_ITP) |
        (trgPDocKind = pd_OVN) |
        (trgPDocKind = pd_CND) |
        (trgPDocKind = pd_AVO) |
        (trgPDocKind = pd_VPK) |
        (trgPDocKind = pd_IPK) |
        (trgPDocKind = pd_VhP) |
        (trgPDocKind = pd_IsP) |
        (trgPDocKind = pd_AIN) |
        (trgPDocKind = pd_AII)  THEN RETURN pdkrq_Required;
  ELSIF (trgPDocKind = pd_VTP) |
        (trgPDocKind = pd_ROO) |
        (trgPDocKind = pd_POO)  THEN RETURN pdkrq_Unrequired;
  ELSIF (trgPDocKind = pd_VPG) |
        (trgPDocKind = pd_IPG)  THEN RETURN pdkrq_Disabled;
  ELSE
   L_General.CallUs(0);
  END;
 END {IsRequiredMDocKind};

 PUBLIC PROCEDURE IsPDocKind_wPmntMsgAsMainForm(trgPDocKind: LIKE(PDocKind.PDocKind); D: DATE): SCAL[2];
 BEGIN
  IF L_General.IsPolakSpecific() THEN
   RETURN (trgPDocKind = pd_VPP) | (trgPDocKind = pd_VPK) | (trgPDocKind = pd_IPK) |
          (trgPDocKind = pd_VMO) | (trgPDocKind = pd_ITP) | (trgPDocKind = pd_VTP) ;
  ELSE
   RETURN 0;
  END;
 END {IsPDocKind_wPmntMsgAsMainForm};

BEGIN
 ForceEOPay:=0;
 ForceUnClosedPay:=0;
 EventName:="";
END.
