(*
%Copyright   (c) Polak IT
%Author      20.01.2006 08:53:23 POLAK\Shur
%Purpose     ⥭  ᪮⠪  㯠   PERCo-CR-12001
%Type        library
%Specific    SYS
%Modified    21.01.2014 19:35:08 POLAK\LDA
%Environment
*)

 MODULE L_Perco [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_StdFrm, L_MSWStp, L_Str, L_Man,
        P_OwnData, P_Man, FIO, Math, Str, L_ACS, E_Utils, L_Staff;

 PRIVATE TYPE
  tPercoBroadcastCmd = NUMERIC[0];

 PUBLIC CONST
  ridi_PhoneClr = 0;
  ridi_MarkName = 1;
  ridi_StateNbr = 2;

 PRIVATE CONST
  MainGroupName = "㯯1";

  pbcForbid = 1;
  pbcPermit = 2;
  pbcStpLst = 3;

 PUBLIC PROCEDURE Open(Connection: OBJECT; Table, Condition: STRING[]): OBJECT;
  VAR
   Result: OBJECT;
   sqlStr: STRING[];
 BEGIN
  Result:=CreateOBJECT("ADODB.RecordSet");
  sqlStr:="SELECT * FROM " + Table;
  IF ~!Condition THEN
   sqlStr:=sqlStr + " WHERE " + Condition;
  END;
  sqlStr:=sqlStr + " FOR UPDATE";
  Result.Open(sqlStr, Connection, 2(*adOpenDynamic*), 3(*adLockOptimistic*), 1(*adCmdText*));
  Result.CacheSize:=10000000;
  RETURN Result;
 END {Open};

 VAR
  perco_SystemServer: OBJECT;

 PRIVATE PROCEDURE intCreateSSERVER15K(): OBJECT;
  VAR
   Result     : OBJECT;
   Server     : STRING[];
   SrvType    : P_OwnData.t_acsp_SystemType;
   GoodVersion: SCAL[2];
 BEGIN
  P_OwnData.GetACSSystemServer(SYSDATE(), SrvType, Server);
  L_General.CallUs(SrvType = P_OwnData.c_acsp_SrvType_Perco);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=PERCO_SSERVER15K.Create("{2C86CF20-2CEC-41EC-8272-446B663CB3E9}", Server);
   GoodVersion:=(Result.MajorVersion = 3) & ((Result.MinorVersion = 4) | (Result.MinorVersion = 5)) |
                (Result.MajorVersion = 5) & ((Result.MinorVersion = 4) | (Result.MinorVersion = 6)) ;
   L_General.CallUs(GoodVersion);
  EXCEPT
  ON Exc:Exc_Root DO
   RAISE();
  END; (* TRY *)
  RETURN Result;
 END {intCreateSSERVER15K};

 PUBLIC PROCEDURE CreateSSERVER15K(): SCAL[2];
 BEGIN
  perco_SystemServer:=intCreateSSERVER15K();
  RETURN ~!perco_SystemServer;
 END {CreateSSERVER15K};

 PUBLIC PROCEDURE CheckError(ErrorCode: NUMERIC[0]);
 BEGIN
  IF ErrorCode # 0 THEN
   L_General.Error(perco_SystemServer.GetErrorDescription(ErrorCode));
  END;
  IF perco_SystemServer.LastCmdStatus # 0 THEN
   L_General.Error(perco_SystemServer.LastCmdStatusDescription);
  END;
 END {CheckError};

 PUBLIC PROCEDURE ComminAndPACL(act: NUMERIC[0]);
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   CheckError(perco_SystemServer.PostAccessCardList(act));
  EXCEPT
  ON Exc: Exc_Root DO
   L_StdFrm.RedInform(" 㤠 믮 .   ." + "|" + Exc.MsgOriginalText);
  END; (* TRY *)
 END {ComminAndPACL};

 PRIVATE PROCEDURE PostParams(OnlyChanged: SCAL[2]);
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   CheckError(perco_SystemServer.ApplyUnCommitSystemConfig());
   CheckError(perco_SystemServer.PostParams(OnlyChanged));
  EXCEPT
  ON Exc: Exc_Root DO
   L_StdFrm.RedInform(" 㤠 믮 .   ." + "|" + Exc.MsgOriginalText);
  END; (* TRY *)
 END {PostParams};

 PRIVATE PROCEDURE PostBroadcastCmd(pbc        : tPercoBroadcastCmd;
                                    CardsArray : NUMERIC[0][];
                                    CardsAmount: NUMERIC[0]): SCAL[2];
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   CheckError(perco_SystemServer.PostBroadcastCmd(pbc, CardsArray, CardsAmount));
   RETURN 1;
  EXCEPT
  ON Exc: Exc_Root DO
   L_StdFrm.RedInform(" 㤠 믮 .   ." + "|" + Exc.MsgOriginalText);
  END; (* TRY *)
  RETURN 0;
 END {PostBroadcastCmd};

 PUBLIC PROCEDURE ManHasOperatingCard(Connection: OBJECT): SCAL[2];
  VAR
   R     : OBJECT;
   Result: SCAL[2];
 BEGIN
  Result:=0;
  R:=Open(Connection, "STAFF_CARDS", "(STAFF_ID=" + L_Str.IntStr(Man.Man) + ")" +
                                     " AND " +
                                     "(ACTIVE_RECORD=1)");
  Result:=~R.EOF();
  R.Close();
  RETURN Result;
 END {ManHasOperatingCard};

 PUBLIC PROCEDURE percoAcsGroup_Main(Connection: OBJECT; GroupName: STRING[]): STRING[];
  VAR
   Result   : OBJECT;
   InnerName: STRING[];
 BEGIN
  Result   :=Open(Connection, "ACCESS_GROUP", "(DISPLAY_NAME='" + GroupName + "')");
  L_General.Assert(Result.EOF() = 0, "  Perco  㦥 㯯 㯠 " + GroupName);
  InnerName:=Result.Fields("INNER_NAME").Value;
  Result.MoveNext();
  L_General.Assert(Result.EOF() # 0, "  Perco 㦥   㯯 㯠 " + GroupName);
  RETURN InnerName;
 END {percoAcsGroup_Main};

 PUBLIC PROCEDURE percoAcsGroup_StopList(): STRING[];
 BEGIN
  RETURN "4DE6466BD8098B38466205EE84E03C8B"
 END {percoAcsGroup_StopList};

 PUBLIC PROCEDURE percoAcsGroup_Forbidden(): STRING[];
 BEGIN
  RETURN "320B89A4DFB54D4DB2E7401267EE95AE";
 END {percoAcsGroup_Forbidden};

 PUBLIC PROCEDURE Connect(): OBJECT;
  VAR
   Result: OBJECT;
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=CreateOBJECT("ADODB.Connection");
   Result.ConnectionString:="driver=Firebird/InterBase(r) driver;" +
                            "CHARSET=WIN1251;"+
                            "DBName=Perco:c:\PercoDB\SCD15.FDB;" +
                            "uid=SYSDBA;" +
                            "pwd=masterkey"; 
   Result.Open();
   RETURN Result;
  EXCEPT
  ON Exc: Exc_Object DO
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    Result:=CreateOBJECT("ADODB.Connection");
    Result.ConnectionString:="DSN=Perco;" +
                             "User ID=SYSDBA;" +
                             "Password=masterkey";
    Result.Open();
    RETURN Result;
   EXCEPT
   ON Exc: Exc_Object DO
    L_General.Error(" 㤠 ⠭ ᮥ  ᯮ짮 ODBC." +
                    "|室 ஢ ன DSN=Perco");
   END; (* TRY *)
  END; (* TRY *)
 END {Connect};

 PUBLIC PROCEDURE PutBinaryFieldFromFile(ADODBField: OBJECT; ImgFileName: STRING[]);
  CONST
   XXX = 8192;
  VAR
   Len: NUMERIC[0];
   n  : NUMERIC[0];
 BEGIN
  FIO.Open(ImgFile, ImgFileName, , Input);
  Len:=FIO.Size(ImgFile);
  WHILE Len > 0 DO
   n:=Math.Min(Len, XXX);
   ADODBField.AppendChunk(FIO.RdByteSA(ImgFile, n));
   DEC(Len, n);
  END;
  FIO.Close(ImgFile);
 END {PutBinaryFieldFromFile};

 PRIVATE PROCEDURE OpenTheCard(Connection: OBJECT; CardCode: NUMERIC[0]): OBJECT;
 BEGIN
  RETURN Open(Connection, "STAFF_CARDS", "(FCARD=" + L_Str.IntStr(L_ACS.Wiegand26CardFamily(CardCode)) + ")" +
                                         " AND " +
                                         "(NCARD=" + L_Str.IntStr(L_ACS.Wiegand26CardNumber(CardCode)) + ")" +
                                         " AND " +
                                         "(ACTIVE_RECORD=1)");
 END {OpenTheCard};

 PRIVATE PROCEDURE GetCardOwner(Connection: OBJECT; CardCode: NUMERIC[0]): LIKE(Man.Man);
  VAR
   R      : OBJECT;
   StaffId: NUMERIC[0];
   Result : LIKE(Man.Man);
 BEGIN
  R:=OpenTheCard(Connection, CardCode);
  IF ~R.EOF() THEN
   StaffId:=R.Fields("STAFF_ID").Value;
   L_General.Assert(StaffId # -1, "㦥 ஡  㭪樮஢ ࢥ Perco." +
                                  "|| 믮 १㧪  ( 㤮) Perco.");
   Result :=StaffId;
  ELSE
   SETEMPTY(Result);
  END;
  R.Close();
  RETURN Result;
 END {GetCardOwner};

 PRIVATE PROCEDURE CheckCardCodeRange(Connection: OBJECT; CardCode: NUMERIC[0]);
  VAR
   R         : OBJECT;
   Result    : SCAL[2];
   i,
   fCard,
   nCard     : NUMERIC[0];
   CardFamily,
   CardBegNum,
   CardEndNum: NUMERIC[0][32];
 BEGIN
  fCard :=L_ACS.Wiegand26CardFamily(CardCode);
  nCard :=L_ACS.Wiegand26CardNumber(CardCode);
  Result:=0;
  SETEMPTY(CardFamily, CardBegNum, CardEndNum);
  R:=Open(Connection, "CARD_SEG_COMMIT", "IN_USE=1");
  i:=0;
  WHILE ~R.EOF() DO
   CardFamily[i]:=R.Fields("FCARD").Value;
   CardBegNum[i]:=R.Fields("MIN_NUM").Value;
   CardEndNum[i]:=R.Fields("MAX_NUM").Value;
   INC(i);
   R.MoveNext();
  END;

  i:=0;
  WHILE (i <= HIGH(CardFamily)) & ~!CardFamily[i] & ~Result DO
   Result:=(fCard = CardFamily[i]) & (nCard >= CardBegNum[i]) & (nCard <= CardEndNum[i]);
   INC(i);
  END; (* WHILE (i <= HIGH(CardFamily)) & ~!CardFamily[i]...*)
  L_General.Assert(Result, "!   " + L_ACS.CardCodeAsStr(CardCode) + "|"+
                           "  室饣    ࠢ筨 '  㯠'||"+
                           "室 ନ ( ᮫ Perco)  ");
 END {CheckCardCodeRange};

 PRIVATE PROCEDURE E_GetRefIds(VAR RefIds: NUMERIC[0][]);
  VAR
   Local: PROC;
 BEGIN
  SETEMPTY(RefIds);
  Local:=PROCREF(E_Utils.perco_GetRefIds);
  IF ~!Local THEN
   Local(RefIds);
  END;
 END {E_GetRefIds};

 PRIVATE PROCEDURE AddRefId(RefId: NUMERIC[0]; VAR Info: STRING[][]; Connection: OBJECT);
  VAR
   R       : OBJECT;
   i       : NUMERIC[0];
   InfoData: STRING[];
 BEGIN
  IF ~!RefId THEN
   i:=0;
   SETEMPTY(InfoData);
   WHILE i <= HIGH(Info) DO
    IF ~!Info[i] THEN
     InfoData:=L_Str.AddStrDlm(InfoData, " / ") + Info[i];
    END;
    INC(i);
   END; (* WHILE i ...*)

   R:=Open(Connection, "STAFF_INFO", "(STAFF_ID=" + L_Str.IntStr(Man.Man) + ") AND " +
                                     "(REF_ID = " + L_Str.IntStr(RefId) + ")");
   IF ~!InfoData | ~R.EOF THEN
    IF R.EOF THEN
     R.AddNew();
    END;
    R.Fields("STAFF_ID").Value :=Man.Man;
    R.Fields("REF_ID").Value   :=RefId;
    R.Fields("INFO_DATA").Value:=InfoData;
    R.Update();
    R.Close();
   END;
  END;
 END {AddRefId};

 PRIVATE PROCEDURE UpdateStaffInfo(Connection: OBJECT);
  VAR
   RefIds      : NUMERIC[0][3];
   PhoneClr,
   StateNbrs,
   CarMarkNames: STRING[][2];
 BEGIN
  P_Man.GetAccessOutsiderCar(Man.Man, SYSDATE(), CarMarkNames, StateNbrs);
  P_Man.GetAllClrPhones(Man.Man, SYSDATE(), PhoneClr);

  E_GetRefIds(RefIds);
  AddRefId(RefIds[ridi_PhoneClr], PhoneClr,     Connection);
  AddRefId(RefIds[ridi_MarkName], CarMarkNames, Connection);
  AddRefId(RefIds[ridi_StateNbr], StateNbrs,    Connection);
 END {UpdateStaffInfo};

 PRIVATE PROCEDURE CM_PutMan(Connection        : OBJECT;
                             CardCode          : NUMERIC[0];
                             ItsNewCard,
                             UpdateSystemServer: SCAL[2]);
  VAR
   R            : OBJECT;
   fCard, nCard : NUMERIC[0];
   CardOwner    : LIKE(Man.Man);
   GroupName,
   PhotoFileName: STRING[];
   SelectedCard : NUMERIC[0][2];
   Surname,
   FirstName,
   Patronymic   : STRING[];
 BEGIN
  TRY
   Connection.BeginTrans();
   fCard:=L_ACS.Wiegand26CardFamily(CardCode);
   nCard:=L_ACS.Wiegand26CardNumber(CardCode);
   IF L_General.GetAPSiteNumber() # 60 THEN
    CheckCardCodeRange(Connection, CardCode);
   END;
   IF ItsNewCard THEN
    L_General.Assert(~ManHasOperatingCard(Connection),
                     "     " + L_Str.IntStr(Man.Man) + " 㦥   ");
   END;
   R:=Open(Connection, "STAFF", "ID_STAFF=" + L_Str.IntStr(Man.Man));
   IF R.EOF THEN
    R.AddNew();
   END;
   L_Man.curMan_SplitName(Surname, FirstName, Patronymic);

   R.Fields("ID_STAFF"    ).Value:=Man.Man;
   R.Fields("LAST_NAME"   ).Value:=Surname;
   R.Fields("FIRST_NAME"  ).Value:=FirstName;
   R.Fields("MIDDLE_NAME" ).Value:=Patronymic;
   R.Fields("VALID"       ).Value:=1;
   IF OCCURE(Staff) THEN
    R.Fields("TABEL_ID"    ).Value:=FLDTOSTR(Staff.TSN);
    R.Fields("DATE_BEGIN"  ).Value:=Staff.BegDate;
    R.Fields("DATE_DISMISS").Value:=Staff.EndDate;
   ELSE
    R.Fields("TABEL_ID"    ).Value:="/";
    R.Fields("DATE_BEGIN"  ).Value:=SYSDATE();
    R.Fields("DATE_DISMISS").Value:=L_General.EMPTY_DATE();
   END;
   PhotoFileName:=P_Man.GetFullPhotoFileName(P_Man.GetManProSoft(Man.Man, SYSDATE(), P_Man.P_ManPhoto));
   IF ~!PhotoFileName & FIO.Exists(PhotoFileName) THEN
    PutBinaryFieldFromFile(R.Fields("PORTRET"), PhotoFileName);
   END;
   R.Update();
   R.Close();
   R:=Open(Connection, "STAFF_REF", "STAFF_ID=" + L_Str.IntStr(Man.Man));
   WHILE ~R.EOF() DO
    R.Fields("VISIBLE").Value:=0;
    R.MoveNext();
   END;
   R.UpdateBatch();
   R.AddNew();
   R.Fields("STAFF_ID"   ).Value:=Man.Man;
   R.Fields("VISIBLE"    ).Value:=1;
   R.Fields("DATE_ACTION").Value:=L_DatTim.GetSysVARIANTDATE();
   R.Fields("GROUP_WT_ID").Value:=1;
   R.Update();
   R.Close();

   UpdateStaffInfo(Connection);

   CardOwner:=GetCardOwner(Connection, CardCode);
   GroupName:=P_Man.GetAcsGroup(Man.Man, SYSDATE());
   IF !GroupName THEN
    GroupName:=MainGroupName;
   END;
   R:=Open(Connection, "STAFF_CARDS", "STAFF_ID=" + L_Str.IntStr(Man.Man));
   IF ItsNewCard THEN
    L_General.Assert(!CardOwner,
                     "  ஬ " + L_ACS.CardCodeAsStr(CardCode) + " 㦥  饭   ." +
                     "||" +
                     ". 䨧 " + L_Str.IntStr(CardOwner));
    R.AddNew();
    R.Fields("STAFF_ID" ).Value           :=Man.Man;
    R.Fields("FCARD"    ).Value           :=fCard;
    R.Fields("NCARD"    ).Value           :=nCard;
    R.Fields("GROUP_ACC_INNER_NAME").Value:=percoAcsGroup_Main(Connection, GroupName);
    R.Fields("DATE_BEGIN").Value          :=SYSDATE()-1;
    R.Fields("DATE_END").Value            :=L_DatTim.MAXDATE();
    R.Fields("VALID").Value               :=0;
    R.Fields("VALID_TRANSFER").Value      :=1;
    R.Fields("ACTIVE_RECORD").Value       :=1;
    R.Fields("TEMPORARY").Value           :=0;
    R.Fields("HISTORY_DATE").Value        :=L_DatTim.GetSysVARIANTDATE();
    R.Fields("PROHIBIT").Value            :=0;
   ELSE
    L_General.Assert(~!CardOwner,         "    ");
    L_General.Assert(CardOwner = Man.Man, "    ਭ 㣮 :" + CardOwner);
    R:=OpenTheCard(Connection, CardCode);
    R.Fields("GROUP_ACC_INNER_NAME").Value:=percoAcsGroup_Main(Connection, GroupName);
   END;
   R.UpdateBatch();
   R.Close();
   Connection.CommitTrans();
  EXCEPT
  ON Exc:Exc_Root DO
   Connection.RollbackTrans();
   RAISE();
  END;
  IF UpdateSystemServer THEN
   IF ItsNewCard THEN
    ComminAndPACL(PERCO_SSERVER15K.AccessCardType_Changed);
   ELSE
    SelectedCard[0]:=fCard;
    SelectedCard[1]:=nCard;
    CheckError(perco_SystemServer.PostAccessCardList(PERCO_SSERVER15K.AccessCardType_Selected, SelectedCard));
   END;
  END; (* TRY *)
 END {CM_PutMan};

 PUBLIC PROCEDURE CM_PutStaff(CardCode: NUMERIC[0]);
 BEGIN
  IF CreateSSERVER15K() THEN
   CM_PutMan(Connect(), CardCode, 1, 1);
  END;
 END {CM_PutStaff};

 PUBLIC PROCEDURE CM_Renovate(CardCode: NUMERIC[0]);
 BEGIN
  IF CreateSSERVER15K() THEN
   CM_PutMan(Connect(), CardCode, 0, 1);
  END;
 END {CM_Renovate};

 PUBLIC PROCEDURE PBC_SingleCard(pbc     : tPercoBroadcastCmd;
                                 CardCode: NUMERIC[0]): SCAL[2];
  VAR
   CA: NUMERIC[0][2];
 BEGIN
  CA[0]:=L_ACS.Wiegand26CardFamily(CardCode);
  CA[1]:=L_ACS.Wiegand26CardNumber(CardCode);
  RETURN PostBroadcastCmd(pbc, CA, 1);
 END {PBC_SingleCard};

 PRIVATE PROCEDURE ToStopListInDataBase(Connection: OBJECT; CardCode: NUMERIC[0]; wRollbackTrans: SCAL[2]);
  VAR
   R, r  : OBJECT;
   Cnt   : NUMERIC[0];
   sysDTS: FLOAT;
 BEGIN
  TRY
   Connection.BeginTrans();
   Cnt:=0;
   r:=Open(Connection, "STAFF_CARDS", "");
   R:=OpenTheCard(Connection, CardCode);
   WHILE ~R.EOF DO
    r.AddNew();
    sysDTS:=L_DatTim.GetSysVARIANTDATE();
    r.Fields("STAFF_ID"            ).Value:=0;
    r.Fields("FCARD"               ).Value:=R.Fields("FCARD").Value;
    r.Fields("NCARD"               ).Value:=R.Fields("NCARD").Value;
    r.Fields("GROUP_ACC_INNER_NAME").Value:=percoAcsGroup_StopList();
    r.Fields("DATE_BEGIN"          ).Value:=sysDTS;
    r.Fields("DATE_END"            ).Value:=sysDTS;
    r.Fields("VALID"               ).Value:=1; (* ⨯ 㦥 யᠭ *)
    r.Fields("VALID_TRANSFER"      ).Value:=R.Fields("VALID_TRANSFER").Value;
    r.Fields("ACTIVE_RECORD"       ).Value:=1;
    r.Fields("TEMPORARY"           ).Value:=R.Fields("TEMPORARY").Value;
    r.Fields("HISTORY_DATE"        ).Value:=sysDTS;
    r.Fields("PROHIBIT"            ).Value:=1;

    R.Fields("ACTIVE_RECORD").Value:=0;
    R.Fields("DATE_END").Value:=sysDTS;
    INC(Cnt);
    R.MoveNext();
   END;
   L_General.Assert(Cnt=1,
                    "   " + L_Str.IntStr(Cnt) + " ⨢   ஬ " + L_ACS.CardCodeAsStr(CardCode));
   r.UpdateBatch();
   r.Close();
   R.UpdateBatch();
   R.Close();
   R:=OpenTheCard(Connection, CardCode);
   L_General.Assert(~R.EOF(), "     " + L_ACS.CardCodeAsStr(CardCode));
   r:=Open(Connection, "STOP_CARDS_DISCRIPTION", "");
   r.AddNew();
   r.Fields("CARD_ID"        ).Value:=R.Fields("ID_CARD").Value;
   r.Fields("DISCRIPTION"    ).Value:="ᯮ⥫ " + FULLNAME() + " (" + L_DatTim.CompleteSystimeStr() + ")";
   r.Fields("POSSIBLE_RECALL").Value:=1;
   r.UpdateBatch();
   r.Close();
   IF wRollbackTrans THEN
    Connection.RollbackTrans();
   ELSE
    Connection.CommitTrans();
   END;
  EXCEPT
  ON Exc:Exc_Root DO
   Connection.RollbackTrans();
   RAISE();
  END; (* TRY *)
 END {ToStopListInDataBase};

 PUBLIC PROCEDURE ToStopList(Connection: OBJECT; CardCode: NUMERIC[0]);
 BEGIN
  ToStopListInDataBase(Connection, CardCode, 1);
  IF PBC_SingleCard(pbcStpLst, CardCode) THEN
   ToStopListInDataBase(Connection, CardCode, 0);
  END;
 END {ToStopList};

 PUBLIC PROCEDURE CM_ToStopList(CardCode: NUMERIC[0]);
 BEGIN
  IF CreateSSERVER15K() THEN
   ToStopList(Connect(), CardCode);
  END;
 END {CM_ToStopList};

 PUBLIC PROCEDURE PrepareSTAFF_CARDS_ToClearFromEquipment(R: OBJECT);
 BEGIN
  R.Fields("STAFF_ID").Value            :=-1;
  R.Fields("GROUP_ACC_INNER_NAME").Value:=percoAcsGroup_Forbidden();
  R.Fields("VALID").Value               :=0;
  R.Fields("PROHIBIT").Value            :=1;
 END {PrepareSTAFF_CARDS_ToClearFromEquipment};

 PRIVATE PROCEDURE SelectCardInStopList(Connection: OBJECT; CardCode: NUMERIC[0]): OBJECT;
 BEGIN
  RETURN Open(Connection, "STAFF_CARDS", "(STAFF_ID=0)" +
                                         " AND (FCARD=" + L_Str.IntStr(L_ACS.Wiegand26CardFamily(CardCode)) + ")" +
                                         " AND (NCARD=" + L_Str.IntStr(L_ACS.Wiegand26CardNumber(CardCode)) + ")" +
                                         " AND (VALID=1)");
 END {SelectCardInStopList};

 PRIVATE PROCEDURE IsInStopList(Connection: OBJECT; CardCode: NUMERIC[0]): SCAL[2];
  VAR
   R     : OBJECT;
   Result: SCAL[2];
 BEGIN
  R     :=SelectCardInStopList(Connection, CardCode);
  Result:=~R.EOF;
  R.Close();
  RETURN Result;
 END {IsInStopList};

 PUBLIC PROCEDURE ThrowFromStopList(Connection: OBJECT; CardCode: NUMERIC[0]);
  VAR
   R: OBJECT;
 BEGIN
  L_General.Assert(IsInStopList(Connection, CardCode), "  ᥭ  ⮯-   ");
  TRY
   Connection.BeginTrans();
   R:=SelectCardInStopList(Connection, CardCode);
   IF ~R.EOF THEN
    PrepareSTAFF_CARDS_ToClearFromEquipment(R);
    R.UpdateBatch();
    Connection.CommitTrans();
    ComminAndPACL(PERCO_SSERVER15K.AccessCardType_Changed);
   ELSE
    Connection.CommitTrans();
   END;
  EXCEPT
  ON Exc:Exc_Root DO
   Connection.RollbackTrans();
   RAISE();
  END; (* TRY *)
 END {ThrowFromStopList};

 PUBLIC PROCEDURE CM_ThrowFromStopList(CardCode: NUMERIC[0]);
  VAR
   Connection: OBJECT;
 BEGIN
  IF CreateSSERVER15K() THEN
   Connection:=Connect();
   ThrowFromStopList(Connection, CardCode);
  END;
 END {CM_ThrowFromStopList};

 PUBLIC PROCEDURE CM_Withdraw(CardCode: NUMERIC[0]);
  VAR
   Connection: OBJECT;
 BEGIN
  IF CreateSSERVER15K() THEN
   Connection:=Connect();
   ToStopList(Connection, CardCode);
   ThrowFromStopList(Connection, CardCode);
  END;
 END {CM_Withdraw};

 PRIVATE CONST
  FakeEvent = 7;

 PRIVATE PROCEDURE GetPercoEvent(Event: NUMERIC[0]): SCAL[8];
 BEGIN
  IF    Event = 27 THEN
   RETURN 2;
  ELSIF Event = 28  THEN
   RETURN 3;
  ELSIF Event = 25 THEN
   RETURN 4;
  ELSE
   RETURN FakeEvent;
  END;
 END {GetPercoEvent};

 PRIVATE PROCEDURE AddCond(Cond, Add: STRING[]): STRING[];
 BEGIN
  IF !Cond THEN
   RETURN Add;
  ELSE
   RETURN Cond + " AND " + Add;
  END;
 END {AddCond};

 PUBLIC PROCEDURE Fill_ACSEvent(From, UpTo : DATE; _Man: LIKE(Man.Man); _CardCode: NUMERIC[0]);
  VAR
   R           : OBJECT;
   Cond        : STRING[];
   _DTS        : FLOAT;
   sqlEvent    : LIKE(ACSEvent.Event);
   D           : DATE;
   T           : TIME;
   S           : NUMERIC[0];
 BEGIN
  P_OwnData.GetACSSystemOutposts(SYSDATE());
  SETEMPTY(Cond);
  IF (~!From) THEN
   Cond:=AddCond(Cond, "(DATE_EV >= '" + FLDTOSTR(From, "D.N.y") + "')");
  END;
  IF (~!UpTo) THEN
   Cond:=AddCond(Cond, "(DATE_EV <= '" + FLDTOSTR(UpTo, "D.N.y") + "')");
  END;

  IF (~!_CardCode) THEN
   Cond:=AddCond(Cond, "(FAC_CARD=" + L_Str.IntStr(L_ACS.Wiegand26CardFamily(_CardCode)) + ")");
   Cond:=AddCond(Cond, "(COD_CARD=" + L_Str.IntStr(L_ACS.Wiegand26CardNumber(_CardCode)) + ")");
   Cond:=AddCond(Cond, "(STAFF_ID<>" + L_Str.IntStr(_Man) + ")");
  ELSIF (~!_Man) THEN
   Cond:=AddCond(Cond, "(STAFF_ID=" + L_Str.IntStr(_Man) + ")");
  END;

  PROMPT(" 襭 믮    Perco");
  R:=Open(Connect(), "REG_EVENTS", Cond + " order by DATE_EV, TIME_EV");
  WHILE ~R.EOF DO
   sqlEvent:=GetPercoEvent(R.Fields("NUM_EV").Value);
   IF sqlEvent # FakeEvent THEN
    UnPkVARIANTDATE(R.Fields("TIME_EV").Value, D, T, S);
    D:=R.Fields("DATE_EV").Value;
    PackVARIANTDATE(_DTS, D, T, S);
    L_ACS.AddACSEvent(_DTS,
                      R.Fields("FAC_CARD").Value * 65536 + R.Fields("COD_CARD").Value,
                      R.Fields("ID_AREAS").Value,
                      Str.Condense(R.Fields("STAFF_ID").Value),
                      sqlEvent);
   END;
   R.MoveNext();
  END(*~R.EOF() *);
  R.Close();
  P_OwnData.Purge_Outposts();
 END {Fill_ACSEvent};

(*
$P{ Top:
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
                                                                                              ########## #####
=######=======================================================================================================
|                                      ⮪ 㧪   PERCO                                        |
|------------------------------------------------------------------------------------------------------------|
|                        |                                                                        |
|--------------------------|---------------------------------------------------------------------------------|
}
*)

(*
$P{ Line:
Man.Man, L, ""
L_Str.ShortName(Man.Name), L, ""
?, L, ""
@
|##### ####################|#################################################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE ClearTable(Connection: OBJECT; Table: STRING[]);
  VAR
   R: OBJECT;
 BEGIN
  PROMPT("⪠ " + Table);
  R:=Open(Connection, Table, "");
  WHILE ~R.EOF() DO
   R.Delete();
   R.MoveNext();
  END;
  R.UpdateBatch();
  R.Close();
 END {ClearTable};

 PRIVATE PROCEDURE ClearAll();
  VAR
   R         : OBJECT;
   Connection: OBJECT;
 BEGIN
  Connection:=Connect();
  TRY
   Connection.BeginTrans();
   R:=Open(Connection, "STAFF_CARDS", "ACTIVE_RECORD=1");
   WHILE ~R.EOF DO
    PrepareSTAFF_CARDS_ToClearFromEquipment(R);
    R.MoveNext();
   END;
   R.UpdateBatch();
   R.Close();
   Connection.CommitTrans();
   PROMPT("।   ...");
   ComminAndPACL(PERCO_SSERVER15K.AccessCardType_All);
  EXCEPT
  ON Exc:Exc_Root DO
   Connection.RollbackTrans();
   L_General.Error("訡  ⮢ ᯨ᪠   ⪨.||" + Exc.MsgOriginalText);
  END; (* TRY *)

  TRY
   Connection.BeginTrans();
   ClearTable(Connection, "STAFF");
   ClearTable(Connection, "STAFF_INFO");
   ClearTable(Connection, "STAFF_REF");
   ClearTable(Connection, "STAFF_CARDS");
   ClearTable(Connection, "STOP_CARDS_DISCRIPTION");
   Connection.CommitTrans();
  EXCEPT
  ON Exc:Exc_Root DO
   Connection.RollbackTrans();
   L_General.Error(" 㤠   Perco.||" + Exc.MsgOriginalText);
  END; (* TRY *)
 END {ClearAll};

 PUBLIC PROCEDURE PutAllMan();
  CONST
   RepName = "UplPrt";
  VAR
   CardType  : L_ACS.tCardType;
   CardCode  : NUMERIC[0];
   Connection: OBJECT;
 BEGIN
  L_General.SilentAdminOnly();
  L_StdFrm.Choice("ᮢ 㧪   Perco.|" +
                  "। 믮 㤥 믮 ⪠  ");
  L_General.Assert(CreateSSERVER15K(), " 㤠 ᮧ ࢥ ⮬⨧樨 Perco");

  ClearAll();

  Connection:=Connect();
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   PROMPT("㧪 " + Man.Man);
   P_Man.GetPassAttributes(Man.Man, SYSDATE(), CardType, CardCode);
   IF ~!CardCode THEN
    TRY
     IF Man.rStaff THEN
      L_Staff.StandOnAnyMainContract(Man.Man, SYSDATE());
     ELSE
      L_General.CLEAR("Staff");
     END;
     CM_PutMan(Connection, CardCode, 1, 0);
     MAKEPART(R, Line, "");
    EXCEPT
    ON Exc:Exc_Root DO
     MAKEPART(R, Line, Exc.Description);
    END; (* TRY *)
   END;
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);

  PROMPT("।   ...");
  ComminAndPACL(PERCO_SSERVER15K.AccessCardType_All);
 END {PutAllMan};

END.
