(*
%Copyright   (c) Polak IT
%Author      20.01.2006 08:53:23 POLAK\Shur
%Purpose     ⥭  ᪮⠪  㯠   PERCo-CR-12001
%Type        library
%Specific    SYS
%Modified    29.07.2014 11:25:08 POLAK\LDA
%Environment
*)

 MODULE L_Perco_S20 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_StdFrm, L_Str, L_Man, P_OwnData, P_Man, FIO, Math, Str,
        L_ACS, L_Staff, L_XML, L_FIO, P_Firm;

 PRIVATE CONST
  fictSTAFF_ID = 0;

  a_PutMan            = 0;
  a_RenovateMan       = 1;
  a_Withdraw          = 2;
  a_ThrowFromStopList = 3;
  a_SendSingleCard    = 4;
  a_SendAllCard       = 5;
  a_ChangeAccessGroup = 6;
  a_InsertSubDiv      = 7;

 PRIVATE VAR
  Stream            : SCAL[2];
  perco_SystemServer: OBJECT;

 PRIVATE PROCEDURE IsSpecificProject(): SCAL[2];
 BEGIN
  RETURN (L_General.GetAPSiteNumber() = 25) | (L_General.GetAPSiteNumber() = 90);
 END {IsSpecificProject};

 PRIVATE PROCEDURE ConvMan2PercoId(trgMan: LIKE(Man.Man)): STRING[];
  VAR
   APSiteAsStr: STRING[];
 BEGIN
  SETEMPTY(APSiteAsStr);
  IF IsSpecificProject() THEN
   APSiteAsStr:=L_General.GetAPSiteNumber() + "_";
  END;
  RETURN APSiteAsStr + FLDTOSTR(trgMan, "", 5);
 END {ConvMan2PercoId};

 PRIVATE PROCEDURE ConvPercoId2Man(PercoId: STRING[]): LIKE(Man.Man);
  VAR
   Result: LIKE(Man.Man);
 BEGIN
  IF IsSpecificProject() THEN
   Result:=Str.Delete(PercoId, 0, Str.Pos(PercoId, "_")+1);
  ELSE
   Result:=PercoId;
  END;
  RETURN Result;
 END {ConvPercoId2Man};

 PRIVATE PROCEDURE GetStaffIdByMan(Connection: OBJECT; trgMan: LIKE(Man.Man)): NUMERIC[0];
  VAR
   R     : OBJECT;
   Result: NUMERIC[0];
 BEGIN
  SETEMPTY(Result);
  R:=Open(Connection, "STAFF", "ID_FROM_1C='" + ConvMan2PercoId(trgMan) + "'");
  IF ~R.EOF() THEN
   Result:=R.Fields("ID_STAFF").Value;
  END;
  R.Close();
  RETURN Result;
 END {GetStaffIdByMan};

 PRIVATE PROCEDURE GetManByStaffId(Connection: OBJECT; StaffId: NUMERIC[0]): LIKE(Man.Man);
  VAR
   R     : OBJECT;
   Result: LIKE(Man.Man);
 BEGIN
  SETEMPTY(Result);
  IF ~!StaffId THEN
   R:=Open(Connection, "STAFF", "ID_STAFF='" + L_Str.IntStr(StaffId) + "'");
   IF ~R.EOF() THEN
    Result:=ConvPercoId2Man(R.Fields("ID_FROM_1C").Value);
   END;
   R.Close();
  END;
  RETURN Result;
 END {GetManByStaffId};

 PRIVATE PROCEDURE Connect(): OBJECT;
  VAR
   Result : OBJECT;
   Server : STRING[];
   SrvType: P_OwnData.t_acsp_SystemType;
 BEGIN
  P_OwnData.GetACSSystemServer(SYSDATE(), SrvType, Server);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=CreateOBJECT("ADODB.Connection");
   Result.ConnectionString:="driver=Firebird/InterBase(r) driver;" +
                            "CHARSET=WIN1251;"+
                            "DBName="+ Server +":c:\PercoDB\SCD17K.FDB;" +
                            "uid=SYSDBA;" +
                            "pwd=masterkey"; 
   Result.Open();
   RETURN Result;
  EXCEPT
  ON Exc: Exc_Object DO
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    Result:=CreateOBJECT("ADODB.Connection");
    Result.ConnectionString:="DSN=Perco;" +
                             "User ID=SYSDBA;" +
                             "Password=masterkey";
    Result.Open();
    RETURN Result;
   EXCEPT
   ON Exc: Exc_Object DO
    L_General.Error(" 㤠 ⠭ ᮥ  ᯮ짮 ODBC." +
                    "|室 ஢ ன DSN=Perco");
   END; (* TRY *)
  END; (* TRY *)
 END {Connect};

 PRIVATE PROCEDURE Open(Connection: OBJECT; Table, Condition: STRING[]): OBJECT;
  VAR
   Result: OBJECT;
   sqlStr: STRING[];
 BEGIN
  Result:=CreateOBJECT("ADODB.RecordSet");
  sqlStr:="SELECT * FROM " + Table;
  IF ~!Condition THEN
   sqlStr:=sqlStr + " WHERE " + Condition;
  END;
  Result.Open(sqlStr, Connection, 2(*adOpenDynamic*), 3(*adLockOptimistic*), 1(*adCmdText*));
  Result.CacheSize:=10000000;
  RETURN Result;
 END {Open};

 PRIVATE PROCEDURE ManHasOperatingCard(Connection: OBJECT): SCAL[2];
  VAR
   R      : OBJECT;
   Result : SCAL[2];
   StaffId: NUMERIC[0];
 BEGIN
  StaffId:=GetStaffIdByMan(Connection, Man.Man);
  Result :=0;
  IF ~!StaffId THEN
   R:=Open(Connection, "STAFF_CARDS", "(STAFF_ID='" + L_Str.IntStr(StaffId) + "')" +
                                      " AND " +
                                      "(VALID=1)");
   Result:=~R.EOF();
   R.Close();
  END;
  RETURN Result;
 END {ManHasOperatingCard};

 PRIVATE PROCEDURE OpenCard(Connection: OBJECT; CardCode: NUMERIC[0]): OBJECT;
 BEGIN
  RETURN Open(Connection, "STAFF_CARDS", "(IDENTIFIER=" + L_Str.IntStr(CardCode) + ")" +
                                         " AND " +
                                         "(VALID=1)");
 END {OpenCard};

 PRIVATE PROCEDURE GetCardOwner(Connection: OBJECT; CardCode: NUMERIC[0]): LIKE(Man.Man);
  VAR
   R      : OBJECT;
   StaffId: NUMERIC[0];
 BEGIN
  R:=OpenCard(Connection, CardCode);
  IF ~R.EOF() THEN
   StaffId:=R.Fields("STAFF_ID").Value;
  ELSE
   SETEMPTY(StaffId);
  END;
  R.Close();
  L_General.Assert(StaffId # fictSTAFF_ID, "ய " + L_ACS.CardCodeAsStr(CardCode) + " 室  -.||" +
                                           "室 믮 楤 㤠 ய᪠  -");
  RETURN GetManByStaffId(Connection, StaffId);
 END {GetCardOwner};

 PRIVATE PROCEDURE intCheckError(ErrorCode: NUMERIC[0]; Server: OBJECT; Strong: SCAL[2]);
  CONST
   Success = 0;
  VAR
   i,
   ErrorAmount   : NUMERIC[0];
   XML,
   XMLFile       : OBJECT;
   Msg,
   Root,
   Node,
   tmpXMLFileName: STRING[];
 BEGIN
  IF ErrorCode # Success THEN
   SETEMPTY(Msg);
   XML:=L_XML.CreateXMLOBJECT();
   Server.GetErrorDescription(XML);
   tmpXMLFileName:=L_FIO.tf_GetFullPath(L_DatTim.SysDateTimeStamp(), "xml");
   XML.Save(tmpXMLFileName);
   XMLFile    :=L_XML.Load(tmpXMLFileName);
   Root       :=L_XML.ICN("", "documentrequest");
   ErrorAmount:=L_XML.dct_getNum(XMLFile, L_XML.ICN(Root, "error.Amount"));
   i          :=0;
   WHILE i < ErrorAmount DO
    PROMPT(L_Str.IntStr(i));
    Node:=L_XML.ICN(Root, L_XML.AssembleIdexedIN("error", i));
    Msg :=Msg + L_XML.dct_getStr(XMLFile, L_XML.ICN(Node, "Error")) + "|";
    INC(i);
   END; (* WHILE i < ErrorAmount...*)
   IF Strong THEN
    L_General.Error(Msg);
   ELSE
    L_StdFrm.RedInform(Msg);
   END;
  END;
 END {intCheckError};

 PRIVATE PROCEDURE CheckError(ErrorCode: NUMERIC[0]; Server: OBJECT);
 BEGIN
  intCheckError(ErrorCode, Server, 1)
 END {CheckError};

 PRIVATE PROCEDURE intCreateSSERVER_S20(): OBJECT;
  VAR
   Result    : OBJECT;
   SrvType   : P_OwnData.t_acsp_SystemType;
   Server    : STRING[];
   ServerPort: NUMERIC[0];
   Login,
   Password  : STRING[];
   ver_SoftWare,
   ver_SDK   : STRING[];
 BEGIN
  P_OwnData.GetACSSystemServer(SYSDATE(), SrvType, Server);
  ServerPort:=211;
  Login     :="Admin";
  Password  :="";
  L_General.CallUs(SrvType = P_OwnData.c_acsp_SrvType_Perco_S20);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=CreateOBJECT("PERCo_S20_SDK.ExchangeMain");
   CheckError(Result.SetConnect(Server, ServerPort, Login, Password), Result);
   SETEMPTY(ver_SoftWare, ver_SDK);
   intCheckError(Result.CheckVersion(ver_SoftWare, ver_SDK), Result, 1);
  EXCEPT
  ON Exc: Exc_Root DO
   IF VAR_IMPL.Get(Result).Initialized THEN
    Result.Disconnect();
   END;
   RAISE();
  END; (* TRY *)
  RETURN Result;
 END {intCreateSSERVER_S20};

 PRIVATE PROCEDURE CreateSSERVER_S20(): SCAL[2];
 BEGIN
  perco_SystemServer:=intCreateSSERVER_S20();
  RETURN ~!perco_SystemServer;
 END {CreateSSERVER_S20};

 PRIVATE PROCEDURE Disconnect();
 BEGIN
  IF VAR_IMPL.Get(perco_SystemServer).Initialized THEN
   perco_SystemServer.Disconnect();
  END;
 END {Disconnect};

 PRIVATE PROCEDURE PutNode_wAttr(rootNode: L_XML.tNode; Name, AttrName, AttrValue: STRING[]): L_XML.tNode;
  VAR
   Node: L_XML.tNode;
 BEGIN
  Node:=L_XML.bd_PutNode(rootNode, Name, "");
  L_XML.bd_SetAttribute(Node, AttrName, AttrValue);
  RETURN Node;
 END {PutNode_wAttr};

 PRIVATE PROCEDURE PutCard(rootNode: L_XML.tNode; ShablonId, CardCode: NUMERIC[0]; trgDate_Begin, trgDate_End: DATE);
 BEGIN
  rootNode:=L_XML.bd_PutNode(rootNode, "identifiers", "");
  rootNode:=PutNode_wAttr(rootNode, "identifier", "type_identifier", "family_number");
  L_XML.bd_SetAttribute(rootNode, "identifier", L_Str.IntStr(CardCode));
  L_XML.bd_SetAttribute(rootNode, "date_begin_action", L_DatTim.DateStr(trgDate_Begin));
  IF !trgDate_End THEN
   trgDate_End:=L_DatTim.MAXDATE();
  END;
  L_XML.bd_SetAttribute(rootNode, "date_end_action", L_DatTim.DateStr(trgDate_End));
  L_XML.bd_SetAttribute(rootNode, "prohibit", "false");
  L_XML.bd_SetAttribute(rootNode, "shablon_id_external", "");
  L_XML.bd_SetAttribute(rootNode, "shablon_id_internal", L_Str.IntStr(ShablonId));
 END {PutCard};

 PRIVATE PROCEDURE GetShablonId(Connection: OBJECT): NUMERIC[0];
  CONST
   MainGroupName = " 㬮砭";
  VAR
   R        : OBJECT;
   Result   : NUMERIC[0];
   GroupName: STRING[];
 BEGIN
  GroupName:=P_Man.GetAcsGroup(Man.Man, SYSDATE());
  IF !GroupName THEN
   GroupName:=MainGroupName;
  END;
  R:=Open(Connection, "SHABLON_MAIN", "DISPLAY_NAME='" + GroupName + "'");
  L_General.Assert(R.EOF()=0, " 蠡 㯠 '" + GroupName + "'");
  Result:=R.Fields("ID_SHABLON_MAIN").Value;
  R.MoveNext();
  L_General.Assert(R.EOF() # 0, "  PERCo 㦥   蠡 㯠 " + GroupName);
  R.Close();
  RETURN Result;
 END {GetShablonId};

 PRIVATE PROCEDURE GetFirmByMan(): LIKE(Firm.Firm);
  VAR
   Result             : LIKE(Firm.Firm);
   dummyAim           : STRING[];
   dummyResponsibleTSN: LIKE(Staff.TSN);
 BEGIN
  P_Man.GetAccessOutsiderInf(Man.Man, SYSDATE(), Result, dummyAim, dummyResponsibleTSN);
  IF !Result & OCCURE(Staff) THEN
   Result:=L_Staff.GetFirmOfStaff();
  END;
  RETURN Result;
 END {GetFirmByMan};

 PRIVATE PROCEDURE intGetSubDivId(Connection: OBJECT): NUMERIC[0];
  VAR
   R        : OBJECT;
   Result   : NUMERIC[0];
   trgFirm  : LIKE(Firm.Firm);
   trgSubDiv: STRING[];
 BEGIN
  SETEMPTY(Result);
  trgFirm:=GetFirmByMan();
  IF ~!trgFirm THEN
   P_Firm.AccessFirm(trgFirm);
   trgSubDiv:=Firm.Name;
   R:=Open(Connection, "SUBDIV_REF", "DISPLAY_NAME='" + trgSubDiv + "'");
   IF R.EOF() = 0 THEN
    Result:=R.Fields("ID_REF").Value;
   END;
   R.Close();
  ELSE
   Result:=1; (* ࠧ - " ।"*)
  END;
  RETURN Result;
 END {intGetSubDivId};

 PRIVATE PROCEDURE GetSubDivId(Connection: OBJECT): NUMERIC[0];
  VAR
   R        : OBJECT;
   Result   : NUMERIC[0];
   trgFirm  : LIKE(Firm.Firm);
   trgSubDiv: STRING[];
 BEGIN
  Result:=intGetSubDivId(Connection);
  IF !Result THEN
   intExecRequest(a_InsertSubDiv, Connection, EMPTYOF(NUMERIC[0]), 0);
   Result:=intGetSubDivId(Connection);
  END;
  L_General.CallUs(~!Result);
  RETURN Result;
 END {GetSubDivId};

 PRIVATE PROCEDURE intPutMan(Connection: OBJECT;
                             rootNode  : L_XML.tNode;
                             CardCode  : NUMERIC[0];
                             ItsNewCard: SCAL[2]);
  VAR
   R            : OBJECT;
   trgTSN       : STRING[];
   CardOwner    : LIKE(Man.Man);
   trgMode,
   Surname,
   FirstName,
   Patronymic,
   PhotoFileName: STRING[];
   trgDate_End,
   trgDate_Begin: DATE;
 BEGIN
  IF ItsNewCard THEN
   L_General.Assert(~ManHasOperatingCard(Connection),
                    "  PERCo   " + FLDTOSTR(Man.Man, "L", 5) + " 㦥   ");
  END;
  CardOwner:=GetCardOwner(Connection, CardCode);
  IF ItsNewCard THEN
   L_General.Assert(!CardOwner,
                    "  ஬ " + L_ACS.CardCodeAsStr(CardCode) + " 㦥  饭   PERCo." +
                    "||" +
                    ".  " + FLDTOSTR(CardOwner, "L", 5));
  ELSE
   L_General.Assert(~!CardOwner,         "    PERCo");
   L_General.Assert(CardOwner = Man.Man, "  PERCo  ਭ 㣮 :" + CardOwner);
  END;

  IF OCCURE(Staff) THEN
   trgTSN       :=Staff.TSN;
   trgDate_Begin:=Staff.BegDate;
   trgDate_End  :=Staff.EndDate;
  ELSE
   trgTSN       :="/";
   trgDate_Begin:=SYSDATE();
   SETEMPTY(trgDate_End);
  END;

  R:=Open(Connection, "STAFF", "ID_FROM_1C='" + ConvMan2PercoId(Man.Man) + "'");
  IF ~R.EOF() THEN
   trgMode:="update";
  ELSE
   trgMode:="append";
  END;
  R.Close();

  rootNode:=PutNode_wAttr(rootNode, "workmode", "mode", trgMode);
  rootNode:=PutNode_wAttr(rootNode, "staff", "id_external", ConvMan2PercoId(Man.Man));
  L_Man.curMan_SplitName(Surname, FirstName, Patronymic);
  L_XML.bd_SetAttribute(rootNode, "last_name",           Surname);
  L_XML.bd_SetAttribute(rootNode, "first_name",          FirstName);
  L_XML.bd_SetAttribute(rootNode, "middle_name",         Patronymic);
  L_XML.bd_SetAttribute(rootNode, "tabel_id",            trgTSN);
  L_XML.bd_SetAttribute(rootNode, "subdiv_id_external",  "");
  L_XML.bd_SetAttribute(rootNode, "appoint_id_external", "");
  L_XML.bd_SetAttribute(rootNode, "graph_id_external",   "");
  L_XML.bd_SetAttribute(rootNode, "subdiv_id_internal",  L_Str.IntStr(GetSubDivId(Connection)));
  L_XML.bd_SetAttribute(rootNode, "appoint_id_internal", "1");
  L_XML.bd_SetAttribute(rootNode, "graph_id_internal",   "0");

  L_XML.bd_SetAttribute(rootNode, "date_begin",          L_DatTim.DateStr(trgDate_Begin));

  PhotoFileName:=P_Man.GetFullPhotoFileName(P_Man.GetManProSoft(Man.Man, SYSDATE(), P_Man.P_ManPhoto));
  IF ~!PhotoFileName & ~FIO.Exists(PhotoFileName) THEN
   SETEMPTY(PhotoFileName);
  END;
  L_XML.bd_SetAttribute(rootNode, "photo", PhotoFileName);

  PutCard(rootNode, GetShablonId(Connection), CardCode, trgDate_Begin, trgDate_End);

  IF ~ItsNewCard THEN
   intExecRequest(a_ChangeAccessGroup, Connection, CardCode, 1);
  END;
 END {intPutMan};

 PRIVATE PROCEDURE PutMan(Connection: OBJECT; rootNode: L_XML.tNode; CardCode: NUMERIC[0]);
 BEGIN
  intPutMan(Connection, rootNode, CardCode, 1);
 END {PutMan};

 PRIVATE PROCEDURE RenovateMan(Connection: OBJECT; rootNode: L_XML.tNode; CardCode: NUMERIC[0]);
 BEGIN
  intPutMan(Connection, rootNode, CardCode, 0);
 END {RenovateMan};

 PRIVATE PROCEDURE Withdraw(Connection: OBJECT; rootNode: L_XML.tNode; CardCode: NUMERIC[0]);
  VAR
   R: OBJECT;
 BEGIN
  R:=OpenCard(Connection, CardCode);
  L_General.Assert(~R.EOF(), "    PERCo");
  rootNode:=PutNode_wAttr(rootNode, "employ", "id_external", ConvMan2PercoId(Man.Man));
  L_XML.bd_SetAttribute(rootNode, "reason", LOGINNAME() + ": 饭  - " + L_DatTim.FullSystimeStr());
  rootNode:=L_XML.bd_PutNode(rootNode, "identifiers", "");
  rootNode:=PutNode_wAttr(rootNode, "identifier", "type_identifier", "family_number");
  L_XML.bd_SetAttribute(rootNode, "identifier", L_Str.IntStr(CardCode));
 END {Withdraw};

 PRIVATE PROCEDURE GetInternalCardId_AsStr(Connection: OBJECT; CardCode: NUMERIC[0]): STRING[];
  VAR
   R     : OBJECT;
   CardId: NUMERIC[0];
 BEGIN
  R:=OpenCard(Connection, CardCode);
  CardId:=R.Fields("ID_CARD").Value;
  R.Close();
  RETURN L_Str.IntStr(CardId);
 END {GetInternalCardId_AsStr};

 PRIVATE PROCEDURE ThrowFromStopList(Connection: OBJECT; rootNode: L_XML.tNode; CardCode: NUMERIC[0]);
 BEGIN
  rootNode:=L_XML.bd_PutNode(rootNode, "cards_stopList", "");
  rootNode:=PutNode_wAttr(rootNode, "card", "identifier", L_Str.IntStr(CardCode));
  L_XML.bd_SetAttribute(rootNode, "id_card", GetInternalCardId_AsStr(Connection, CardCode));
 END {ThrowFromStopList};

 PRIVATE PROCEDURE SendSingleCard(Connection: OBJECT; rootNode: L_XML.tNode; CardCode: NUMERIC[0]);
 BEGIN
  rootNode:=L_XML.bd_PutNode(rootNode, "employs", "");
  rootNode:=PutNode_wAttr(rootNode, "employ", "id_external", ConvMan2PercoId(Man.Man));
  L_XML.bd_SetAttribute(rootNode, "id_internal", "");
 END {SendSingleCard};

 PRIVATE PROCEDURE SendAllCard(Connection: OBJECT; rootNode: L_XML.tNode; CardCode: NUMERIC[0]);
 BEGIN
  (*  *)
 END {SendAllCard};

 PRIVATE PROCEDURE GetAreaName(Connection: OBJECT; AreaId: NUMERIC[0]): STRING[];
  VAR
   R     : OBJECT;
   Result: STRING[];
 BEGIN
  R:=Open(Connection, "AREAS_TREE", "ID_AREAS_TREE=" + FLDTOSTR(AreaId));
  Result:=Str.Align(R.Fields("DISPLAY_NAME").Value, 32, LEFT);
  R.Close();
  RETURN Result;
 END {GetAreaName};

 PRIVATE PROCEDURE GetCardInternalShablonId(Connection: OBJECT; CardCode: NUMERIC[0]): NUMERIC[0];
  VAR
   R, r       : OBJECT;
   Found      : SCAL[2];
   AreasIds   : NUMERIC[0][20];
   AreasNames : STRING[];
   i,
   Amount,
   Result,
   FoundAmount: NUMERIC[0];
 BEGIN
  SETEMPTY(AreasIds, AreasNames);
  i:=0;
  R:=Open(Connection, "STAFF_CARDS_AREAS", "STAFF_CARDS_ID=" + GetInternalCardId_AsStr(Connection, CardCode));
  WHILE ~R.EOF DO
   AreasIds[i]:=R.Fields("AREAS_TREE_ID").Value;
   AreasNames :=AreasNames + GetAreaName(Connection, R.Fields("AREAS_TREE_ID").Value) + "|";
   INC(i);
   R.MoveNext();
  END; (* WHILE ~R.EOF... *)
  Amount:=i;
  R.Close();

  SETEMPTY(Result);
  IF ~!AreasIds[0] THEN
   R:=Open(Connection, "SHABLON_MAIN", "");
   WHILE ~R.EOF & !Result DO
    SETZERO(FoundAmount);
    r:=Open(Connection, "SHABLON_AREAS", "SHABLON_MAIN_ID="+L_Str.IntStr(R.Fields("ID_SHABLON_MAIN").Value));
    WHILE ~r.EOF DO
     SETZERO(i, Found);
     WHILE (i <= HIGH(AreasIds)) & ~!AreasIds[i] & ~Found DO
      IF AreasIds[i] = r.Fields("AREAS_TREE_ID").Value THEN
       INC(FoundAmount);
       Found:=1;
      END;
      INC(i);
     END; (* WHILE (i <= HIGN(AreasIds)) &...*)
     r.MoveNext();
    END; (* WHILE ~r.EOF... *)
    IF FoundAmount = Amount THEN
     Result:=R.Fields("ID_SHABLON_MAIN").Value;
    END;
    R.MoveNext();
   END; (* WHILE ~R.EOF... *)
  END; (* IF ~!AreasIds[0]...*)

  IF !Result THEN
   L_StdFrm.WrongDB("  PERCo   蠡 㯠  筥 饭:||" + AreasNames + "||" +
                    "ᮡ ଫ 蠡 㯠 .  㬥樨");
  END;
  RETURN Result;
 END {GetCardInternalShablonId};

 PRIVATE PROCEDURE CreateCardAccessXMLFile(Connection: OBJECT;
                                           rootNode  : L_XML.tNode;
                                           CardCode,
                                           ShablonId : NUMERIC[0]);
  VAR
   StaffId: NUMERIC[0];
 BEGIN
  rootNode:=L_XML.bd_PutNode(rootNode, "employs", "");
  rootNode:=PutNode_wAttr(rootNode, "employ", "id_external", ConvMan2PercoId(Man.Man));
  StaffId:=GetStaffIdByMan(Connection, Man.Man);
  L_XML.bd_SetAttribute(rootNode, "id_internal", L_Str.IntStr(StaffId));
  rootNode:=PutNode_wAttr(rootNode, "card_access", "id_card", GetInternalCardId_AsStr(Connection, CardCode));
  L_XML.bd_SetAttribute(rootNode, "shablon_id_external", "");
  L_XML.bd_SetAttribute(rootNode, "shablon_id_internal", L_Str.IntStr(ShablonId));
 END {CreateCardAccessXMLFile};

 PRIVATE PROCEDURE ClearAccessGroup(Connection: OBJECT; rootNode: L_XML.tNode; CardCode: NUMERIC[0]);
 BEGIN
  CreateCardAccessXMLFile(Connection, rootNode, CardCode, GetCardInternalShablonId(Connection, CardCode));
 END {ClearAccessGroup};

 PRIVATE PROCEDURE SetAccessGroup(Connection: OBJECT; rootNode: L_XML.tNode; CardCode: NUMERIC[0]);
 BEGIN
  CreateCardAccessXMLFile(Connection, rootNode, CardCode, GetShablonId(Connection));
 END {SetAccessGroup};

 PRIVATE PROCEDURE InsertSubDiv(Connection: OBJECT; rootNode: L_XML.tNode; CardCode: NUMERIC[0]);
  VAR
   trgFirm: LIKE(Firm.Firm);
 BEGIN
  trgFirm:=GetFirmByMan();
  L_General.CallUs(~!trgFirm);
  P_Firm.AccessFirm(trgFirm);
  rootNode:=PutNode_wAttr(rootNode, "workmode", "mode", "append");
  rootNode:=L_XML.bd_PutNode(rootNode, "subdiv", "");
  L_XML.bd_SetAttribute(rootNode, "id_external",       "");
  L_XML.bd_SetAttribute(rootNode, "id_external",       "");
  L_XML.bd_SetAttribute(rootNode, "displayname",       Firm.Name);
  L_XML.bd_SetAttribute(rootNode, "parentid_external", "-1");
  L_XML.bd_SetAttribute(rootNode, "parentid_internal", "-1");
  L_XML.bd_SetAttribute(rootNode, "description",       "");
 END {InsertSubDiv};

 PRIVATE PROCEDURE intCreateXMLRequest(trgType,
                                       trgMode   : STRING[];
                                       wLogin    : SCAL[2];
                                       Connection: OBJECT;
                                       CardCode  : NUMERIC[0];
                                       FillProc  : PROC): OBJECT;
  VAR
   Result     : OBJECT;
   rootNode   : L_XML.tNode;
   XMLFileName: STRING[];
 BEGIN
  rootNode:=L_XML.bd_Create_Ext("documentrequest", "version='1.0' encoding='UTF-8' standalone='yes'", "", "");

  L_XML.bd_SetAttribute(rootNode, "type", trgType);
  IF ~!trgMode THEN
   L_XML.bd_SetAttribute(rootNode, "mode", trgMode);
  END;
  IF wLogin THEN
   rootNode:=PutNode_wAttr(rootNode, "login", "loginname", LOGINNAME());
  END;

  FillProc(Connection, rootNode, CardCode);

  XMLFileName:=L_FIO.tf_GetFullPath(trgType, "xml");
  FIO.Erase(XMLFileName);
  L_XML.bd_Save(L_XML.bd_GetDocument(rootNode), XMLFileName);

  Result:=L_XML.CreateXMLOBJECT();
  Result.Load(XMLFileName);
  RETURN Result;
 END {intCreateXMLRequest};

 PRIVATE PROCEDURE CreateXMLRequest(trgType, trgMode: STRING[]; Connection: OBJECT; CardCode: NUMERIC[0]; FillProc: PROC): OBJECT;
 BEGIN
  RETURN intCreateXMLRequest(trgType, trgMode, 1, Connection, CardCode, FillProc);
 END {CreateXMLRequest};

 PRIVATE PROCEDURE intExecRequest(act: NUMERIC[0]; Connection: OBJECT; CardCode: NUMERIC[0]; UpdateSystemServer: SCAL[2]);
  VAR
   XMLFile: OBJECT;
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   IF    act = a_PutMan THEN
    XMLFile:=CreateXMLRequest("staff", "", Connection, CardCode, PROCREF(PutMan));
    CheckError(perco_SystemServer.SendData(XMLFile), perco_SystemServer);
    IF UpdateSystemServer THEN
     intExecRequest(a_SendSingleCard, Connection, CardCode, 1);
    END;
   ELSIF act = a_RenovateMan THEN
    XMLFile:=CreateXMLRequest("staff", "", Connection, CardCode, PROCREF(RenovateMan));
    CheckError(perco_SystemServer.SendData(XMLFile), perco_SystemServer);
    IF UpdateSystemServer THEN
     intExecRequest(a_SendSingleCard, Connection, CardCode, 1);
    END;
   ELSIF act = a_Withdraw THEN
    XMLFile:=CreateXMLRequest("sendcards", "withdraw_one_card_selected_employ", Connection, CardCode, PROCREF(Withdraw));
    CheckError(perco_SystemServer.ExecuteAccessCardsAction(XMLFile), perco_SystemServer);
   ELSIF act = a_ThrowFromStopList THEN
    XMLFile:=CreateXMLRequest("sendcards", "withdraw_cards_stop_list", Connection, CardCode, PROCREF(ThrowFromStopList));
    CheckError(perco_SystemServer.ExecuteAccessCardsAction(XMLFile), perco_SystemServer);
   ELSIF act = a_SendSingleCard THEN
    XMLFile:=CreateXMLRequest("sendcards", "selected_employs", Connection, CardCode, PROCREF(SendSingleCard));
    CheckError(perco_SystemServer.ExecuteAccessCardsAction(XMLFile), perco_SystemServer);
   ELSIF act = a_SendAllCard THEN
    XMLFile:=CreateXMLRequest("sendcards", "all_system", Connection, CardCode, PROCREF(SendAllCard));
    CheckError(perco_SystemServer.ExecuteAccessCardsAction(XMLFile), perco_SystemServer);
   ELSIF act = a_ChangeAccessGroup THEN
    XMLFile:=CreateXMLRequest("sendcards", "withdraw_and_insert_access_staff", Connection, CardCode, PROCREF(ClearAccessGroup));
    CheckError(perco_SystemServer.Withdraw_Access(XMLFile), perco_SystemServer);

    XMLFile:=CreateXMLRequest("sendcards", "withdraw_and_insert_access_staff", Connection, CardCode, PROCREF(SetAccessGroup));
    CheckError(perco_SystemServer.Append_Access(XMLFile), perco_SystemServer);
   ELSIF act = a_InsertSubDiv THEN
    XMLFile:=CreateXMLRequest("subdiv", "", Connection, EMPTYOF(NUMERIC[0]), PROCREF(InsertSubDiv));
    CheckError(perco_SystemServer.SendData(XMLFile), perco_SystemServer);
   ELSE
    L_General.CallUs(0);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.Error(Exc.MsgOriginalText);
  END; (* TRY *)
 END {intExecRequest};

 PRIVATE PROCEDURE ExecRequest(act: NUMERIC[0]; CardCode: NUMERIC[0]; UpdateSystemServer: SCAL[2]);
 BEGIN
  TRY
   IF CreateSSERVER_S20() THEN
    intExecRequest(act, Connect(), CardCode, UpdateSystemServer);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   RAISE();
  FINALLY
   Disconnect();
  END; (* TRY *)
 END {ExecRequest};

 PUBLIC PROCEDURE CM_PutStaff(CardCode: NUMERIC[0]);
 BEGIN
  ExecRequest(a_PutMan, CardCode, 1);
 END {CM_PutStaff};

 PUBLIC PROCEDURE CM_Renovate(CardCode: NUMERIC[0]);
 BEGIN
  ExecRequest(a_RenovateMan, CardCode, 1);
 END {CM_Renovate};

 PUBLIC PROCEDURE CM_ToStopList(CardCode: NUMERIC[0]);
 BEGIN
  ExecRequest(a_Withdraw, CardCode, 1);
 END {CM_ToStopList};

 PRIVATE PROCEDURE IsInStopList(Connection: OBJECT; CardCode: NUMERIC[0]): SCAL[2];
  VAR
   R     : OBJECT;
   Result: SCAL[2];
 BEGIN
  Result:=0;
  R     :=OpenCard(Connection, CardCode);
  IF ~R.EOF() THEN
   Result:=R.Fields("STAFF_ID").Value = fictSTAFF_ID;
  END;
  R.Close();
  RETURN Result;
 END {IsInStopList};

 PUBLIC PROCEDURE CM_ThrowFromStopList(CardCode: NUMERIC[0]);
 BEGIN
  L_General.Assert(IsInStopList(Connect(), CardCode), "  ᥭ  ⮯-   PERCo");
  ExecRequest(a_ThrowFromStopList, CardCode, 1);
 END {CM_ThrowFromStopList};

 PUBLIC PROCEDURE CM_Withdraw(CardCode: NUMERIC[0]);
 BEGIN
  CM_ToStopList(CardCode);
  CM_ThrowFromStopList(CardCode);
 END {CM_Withdraw};

 PRIVATE PROCEDURE GetFullEventName(trgEvent: NUMERIC[0]): STRING[];
  VAR
   R,
   Connection: OBJECT;
   EventName : STRING[];
 BEGIN
  Connection:=Connect();
  R:=Open(Connection, "MODEL_EVENTS", "INNER_NUMBER="+L_Str.IntStr(trgEvent));
  IF R.EOF() THEN
   EventName:=" ⠡ MODEL_EVENTS ᮡ⨥  ";
  ELSE
   EventName:=R.Fields("DISPLAY_NAME").Value;
  END;
  R.Close();
  RETURN L_Str.IntStr(trgEvent) + " '" + EventName + "'";
 END {GetFullEventName};

 PRIVATE PROCEDURE ConvPercoEvent(Event: NUMERIC[0]; Areas: NUMERIC[0]; trgDTS: LIKE(ACSEvent.DTS); percoMan: LIKE(Man.Man)): NUMERIC[0];
  VAR
   Msg   : STRING[];
   Result: NUMERIC[0];
 BEGIN
(*
 17  - 室
 27  - 室, ⢥ত  
529  - 室, 襭 
2065 - 室, 襭 
*)
  Msg:="室  " + FLDTOSTR(percoMan, "L0", 5) + "  " + L_DatTim.DTStampStr(trgDTS) + ":|";
  SETEMPTY(Result);
  IF (Event = 17) | (Event = 27) | (Event = 529) | (Event = 2065) THEN
   IF    SEARCH(Outpost, o_Enter, Areas) THEN
    Result:=2;
   ELSIF SEARCH(Outpost, o_Exit, Areas) THEN
    Result:=3;
   ELSE
    L_StdFrm.WrongDB(Msg +
                     "  PERCo ⬥⪠  室 १ ⭮ ன⢮   " + L_Str.IntStr(Areas) + ".||" +
                     ", ᫥ 믮 ன ᮯ殮  PERCo.|"+
                     "।⥫쭮 室 ᭨,  䨪 ன⢮: 室  室");
   END;
  ELSE
   L_General.InformUs(Msg +
                     "  PERCo    室 㯮 ⭮ ᮡ⨥|" + GetFullEventName(Event));
  END;
  RETURN Result;
 END {ConvPercoEvent};

 PRIVATE PROCEDURE AddCond(Cond, Add: STRING[]): STRING[];
 BEGIN
  IF !Cond THEN
   RETURN Add;
  ELSE
   RETURN Cond + " AND " + Add;
  END;
 END {AddCond};

 PRIVATE PROCEDURE IsAcceptableMan(    Connection: OBJECT;
                                       StaffId   : NUMERIC[0];
                                   VAR trgMan    : LIKE(Man.Man)): SCAL[2];
  VAR
   R           : OBJECT;
   Result      : SCAL[2];
   APSiteNumber: SCAL[1E4];
 BEGIN
  Result:=1;
  R     :=Open(Connection, "STAFF", "ID_STAFF='" + L_Str.IntStr(StaffId) + "'");
  IF ~R.EOF() THEN
   trgMan:=ConvPercoId2Man(R.Fields("ID_FROM_1C").Value);
  ELSE
   SETEMPTY(trgMan);
  END;
  IF ~!trgMan & IsSpecificProject() THEN
   APSiteNumber:=Str.Slice(R.Fields("ID_FROM_1C").Value, 0, Str.Pos(R.Fields("ID_FROM_1C").Value, "_"));
   Result:=APSiteNumber = L_General.GetAPSiteNumber();
  END;
  R.Close();
  RETURN Result;
 END {IsAcceptableMan};

 PUBLIC PROCEDURE Fill_ACSEvent(trgFrom, trgUpTo : DATE; trgMan: LIKE(Man.Man); CardCode: NUMERIC[0]);
  VAR
   R         : OBJECT;
   D         : DATE;
   T         : TIME;
   S         : NUMERIC[0];
   trgStaffId: NUMERIC[0];
   trgDTS    : FLOAT;
   Cond      : STRING[];
   percoMan  : LIKE(Man.Man);
   sqlEvent  : LIKE(ACSEvent.Event);
   Connection: OBJECT;
 BEGIN
  P_OwnData.GetACSSystemOutposts(SYSDATE());
  PROMPT(" 襭 믮    PERCo");
  Connection:=Connect();
  SETEMPTY(Cond);
  Cond:=AddCond(Cond, "(TYPE_PASS = 1)");
  IF ~!trgFrom THEN
   Cond:=AddCond(Cond, "(DATE_EV >= '" + FLDTOSTR(trgFrom, "D.N.y") + "')");
  END;
  IF ~!trgUpTo THEN
   Cond:=AddCond(Cond, "(DATE_EV <= '" + FLDTOSTR(trgUpTo, "D.N.y") + "')");
  END;

  IF ~!trgMan THEN
   trgStaffId:=GetStaffIdByMan(Connection, trgMan);
   L_General.Assert(~!trgStaffId, "  PERCo    " + trgMan);
  END;
  IF    ~!CardCode THEN
   Cond:=AddCond(Cond, "(IDENTIFIER=" + L_Str.IntStr(CardCode) + ")");
   Cond:=AddCond(Cond, "(STAFF_ID<>" + L_Str.IntStr(trgStaffId) + ")");
  ELSIF ~!trgMan THEN
   Cond:=AddCond(Cond, "(STAFF_ID=" + L_Str.IntStr(trgStaffId) + ")");
  END;

  R:=Open(Connection, "REG_EVENTS", Cond + " order by DATE_EV, TIME_EV");
  WHILE ~R.EOF DO
   IF ~!R.Fields("STAFF_ID").Value & (R.Fields("STAFF_ID").Value # fictSTAFF_ID) &
      IsAcceptableMan(Connection, R.Fields("STAFF_ID").Value, percoMan) THEN
    UnPkVARIANTDATE(R.Fields("TIME_EV").Value, D, T, S);
    D:=R.Fields("DATE_EV").Value;
    PackVARIANTDATE(trgDTS, D, T, S);
    PROMPT("祭    PERCo:  " + FLDTOSTR(percoMan, "L0", 5) + ", " + FLDTOSTR(R.Fields("IDENTIFIER").Value) + ", " + L_DatTim.DTStampStr(trgDTS));
    sqlEvent:=ConvPercoEvent(R.Fields("INNER_NUMBER_EV").Value, R.Fields("CONFIGS_TREE_ID_RESOURCE").Value, trgDTS, percoMan);
    L_ACS.AddACSEvent(trgDTS,
                      R.Fields("IDENTIFIER").Value,
                      R.Fields("CONFIGS_TREE_ID_RESOURCE").Value,
                      percoMan,
                      sqlEvent);
   END;
   R.MoveNext();
  END; (* WHILE ~R.EOF... *)
  R.Close();
  P_OwnData.Purge_Outposts();
 END {Fill_ACSEvent};

(*
$P{ Top:
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
                                                                                              ########## #####
=######=======================================================================================================
|                                      ⮪ 㧪   PERCo                                        |
|------------------------------------------------------------------------------------------------------------|
|                        |                                                                        |
|--------------------------|---------------------------------------------------------------------------------|
}
*)

(*
$P{ Line:
Man.Man, L, ""
L_Str.ShortName(Man.Name), L, ""
?, L, ""
@
|##### ####################|#################################################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PUBLIC PROCEDURE PutAllMan();
  CONST
   RepName = "UplPrt";
  VAR
   R,
   Connection   : OBJECT;
   CardType     : L_ACS.tCardType;
   CardCode     : NUMERIC[0];
 BEGIN
  L_General.SilentAdminOnly();
  L_StdFrm.Choice("ᮢ 㧪    PERCo.|" +
                  "। 믮 室 믮   PERCo   ࠢ");

  Connection:=Connect();
  R:=Open(Connection, "STAFF", "");
  IF ~R.EOF() THEN
   L_General.Error(" 믮 ⪠  PERCo   ࠢ");
  END;
  R.Close();
  R:=Open(Connection, "STOP_CARDS_DESCRIPTION", "");
  IF ~R.EOF() THEN
   L_General.Error("   -.||" +
                  "室 믮 㤠   -  ᮫ ࠢ");
  END;
  R.Close();
  R:=Open(Connection, "STAFF_CARDS", "");
  IF ~R.EOF() THEN
   L_General.Error(" 㤠 ");
  END;
  R.Close();

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  TRY
   IF CreateSSERVER_S20() THEN
    SELECT(Man, Man);
    WHILE OCCURE(Man) DO
     PROMPT("㧪 " + Man.Man);
     P_Man.GetPassAttributes(Man.Man, SYSDATE(), CardType, CardCode);
     IF ~!CardCode THEN
      TRY
       IF Man.rStaff THEN
        L_Staff.StandOnAnyMainContract(Man.Man, SYSDATE());
        IF ~L_Staff.rInState(SYSDATE()) THEN
         L_General.CLEAR("Staff");
        END;
       ELSE
        L_General.CLEAR("Staff");
       END;
       intExecRequest(a_PutMan, Connection, CardCode, 0);
       MAKEPART(R, Line, "");
      EXCEPT
      ON Exc:Exc_Root DO
       MAKEPART(R, Line, Exc.Description);
      END; (* TRY *)
     END;
     NEXT(Man);
    END; (* WHILE OCCURE(Man) ... *)
   END;

   MAKEPART(R, Bot);
   CLOSEREP(R);
 
   PROMPT("।   ...");
   intExecRequest(a_SendAllCard, Connection, CardCode, 1);
  EXCEPT
  ON Exc: Exc_Root DO
   RAISE();
  FINALLY
   Disconnect();
  END; (* TRY *)
 END {PutAllMan};

END.
