(*
%Copyright   (c) Polak IT
%Author      22.05.2007 12:31:04 POLAK\GAV
%Purpose
%Type        library
%Specific    SYS
%Modified    05.12.2011 13:22:11 POLAK\GAV
%Environment
*)

 MODULE L_Pool [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, L_Str, L_StdFrm, L_DatTim, L_General;

 PRIVATE PROCEDURE GetOnDate(D: DATE; _Pool: LIKE(Pool.Pool)): STRING[];
  VAR
   S: STRING[];
 BEGIN
  S:="";
  L_General.CallUs(SEARCH(Pool, Pool, _Pool));
  L_General.Assert(L_DatTim.IsActive(D, Pool.Begin, Pool.Till),
                   "᮪ ப 祭 " + _Pool + "   " + L_DatTim.DateStr(D));
  CONFORM(Pool, PoolVal);
  WHILE OCCURE(PoolVal) DO
   IF L_DatTim.IsActive(D, PoolVal.Begin, PoolVal.Till) THEN
    IF ~!S THEN
     S:=S + "|";
    END;
    S:=S + PoolVal.Value;
   END;
   NEXT(PoolVal);
  END; (* WHILE OCCURE(PoolVal) ... *)
  IF !S THEN
   S:="|";
  END;
  RETURN S;
 END {GetOnDate};

 PUBLIC PROCEDURE Get(_Pool: LIKE(Pool.Pool)): STRING[];
 BEGIN
  RETURN GetOnDate(SYSDATE(), _Pool);
 END {Get};

 PUBLIC PROCEDURE SetShortVal();
 BEGIN
  IF Str.Length(PoolVal.Value) > Str.MaxLength(PoolVal.ShortVal) THEN
   PoolVal.ShortVal:=Str.Slice(PoolVal.Value, 0, Str.MaxLength(PoolVal.ShortVal) - 2) + "";
  ELSE
   PoolVal.ShortVal:=PoolVal.Value;
  END;
 END {SetShortVal};

 PRIVATE PROCEDURE PutOnDate(trgDate         : DATE;
                             trgPool         : LIKE(Pool.Pool);
                             trgValue        : STRING[];
                             TemplateIsStrict: SCAL[2]);
  CONST
   InsertAfterLast = "<⠢   ᯨ᪠>";
  VAR
   Result        : NUMERIC[0];
   trgNbr        : LIKE(PoolVal.Nbr);
   S, BeforeValue: STRING[];
 BEGIN
  L_General.CallUs(SEARCH(Pool, Pool, trgPool));
  IF ~!trgValue & ~Pool.Single THEN
   S:=GetOnDate(trgDate, trgPool);
   IF !L_Str.PositionInPool(S, trgValue) THEN
    Result:=STDFORM("| ᯨ᪥ ப 祭 " +
                    "|" + Pool.Pool + " '" + Pool.Name + "'" +
                    "|   祭" +
                    "|'" + trgValue + "'" +
                    "||" + L_StdFrm.DrawButton("{}⬥",                                                  61, "X")  +
                    "|" + L_StdFrm.DrawButton("{}ᯮ짮  祭,     ᯨ᮪", 61, "DB") +
                    "|" + L_StdFrm.DrawButton("{}  祭  ᯨ᮪",                      61, "B"),
                    , INFORM, -1);
    IF    Result = 1 THEN
     L_General.Assert(TemplateIsStrict = 0, "饭 ᯮ짮 祭, 騥  ᯨ᪥");
    ELSIF Result = 2 THEN
     L_General.CheckRightsByMEMBEROF("", Pool.Rights);
     S:=S+"|"+InsertAfterLast;
     BeforeValue:=L_Str.PoolItem(S, L_StdFrm.ShowListAsMenu_wCaption(S, Pool.Name,
                                                                    "  祭 ।:|"));
     CONFORM(Pool, PoolVal);
     IF LAST(PoolVal) THEN
      IF BeforeValue = InsertAfterLast THEN
       trgNbr:=PoolVal.Nbr + 1;
      ELSE
       WHILE OCCURE(PoolVal) &
             ((PoolVal.Value # BeforeValue) | ~L_DatTim.IsActive(trgDate, PoolVal.Begin, PoolVal.Till)) DO
        INC(PoolVal.Nbr);
        REPLACE(PoolVal);
        PREV(PoolVal);
       END; (* WHILE OCCURE(PoolVal) ... *)
       L_General.CallUs(PoolVal.Value = BeforeValue);
       trgNbr:=PoolVal.Nbr;
       INC(PoolVal.Nbr);
       REPLACE(PoolVal);
      END;
     ELSE
      trgNbr:=0;
     END;
     PoolVal.Pool    :=Pool.Pool;
     PoolVal.Nbr     :=trgNbr;
     PoolVal.Value   :=trgValue;
     SetShortVal();
     PoolVal.Begin   :=trgDate;
     SETEMPTY(PoolVal.Till);
     INSERT(PoolVal);
    END;
   END; (* IF !L_Str.PositionInPool(S, trgValue)...*)
  END; (* IF ~!trgValue & ~Pool.Single...*)
 END {PutOnDate};

 PUBLIC PROCEDURE extPut(trgPool: LIKE(Pool.Pool); trgValue: STRING[]; TemplateIsStrict: SCAL[2]);
 BEGIN
  PutOnDate(SYSDATE(), trgPool, trgValue, TemplateIsStrict);
 END {extPut};

 PUBLIC PROCEDURE Put(trgPool: LIKE(Pool.Pool); trgValue: STRING[]);
 BEGIN
  extPut(trgPool, trgValue, 0);
 END {Put};

 PUBLIC PROCEDURE Insert(_Pool: LIKE(Pool.Pool); Name, DComment, Value: STRING[]; Single: SCAL[2]; D: DATE);
  VAR
   Idx: NUMERIC[0];
 BEGIN
  Pool.Pool    :=_Pool;
  Pool.Name    :=Name;
  Pool.DComment:=DComment;
  Pool.Single  :=Single;
  Pool.Begin   :=D;
  SETEMPTY(Pool.UComment, Pool.Rights, Pool.Till);
  INSERT(Pool);
  Idx:=0;
  WHILE ~!L_Str.PoolItem(Value, Idx) DO
   PoolVal.Pool :=_Pool;
   PoolVal.Nbr  :=Idx;
   PoolVal.Value:=L_Str.PoolItem(Value, Idx);
   PoolVal.Begin:=D;
   SETEMPTY(PoolVal.Till);
   SetShortVal();
   INSERT(PoolVal);
   INC(Idx);
  END;
 END {Insert};

END.
