(*
%Copyright   (c) Polak IT
%Author      14.05.2009 09:10:32 POLAK\GAV
%Purpose     ⥪ ᠭ  ᮡ⥩ ஥.
%Type        library
%Specific    SYS
%Modified    03.09.2014 11:07:02 POLAK\LDA
%Environment !!! 楤 L_PWDO  뢠   L_WDO !!!
*)

 MODULE L_PWDO [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_ODoc, L_Str, L_MathR, L_General, Memo, L_DBD, L_Stock, L_TRS, L_bp, L_Prop, L_PCS, L_EDO, L_Way,
        P_Firm, L_StdFrm, L_Packet, L_CUC, L_WDO, L_Man;

 PRIVATE PROCEDURE pcr_SetDefaultWindowAndZone_ByMDocKind(VAR Window: STRING[]; VAR Zone: NUMERIC[0]);
  VAR
   CurWindow: STRING[];
 BEGIN
  IF    MDocKind.imOC = 2 THEN
   Window:="MDoc_OC";
  ELSIF MDocKind.imDO = 2 THEN
   Window:="MDoc_DO";
  ELSIF MDocKind.imTD = 2 THEN
   Window:="MDocEI";
  ELSE
   L_General.Error("  㬥 " + MDocKind.MDocKind + " '" + MDocKind.SName + "'  㪠 '᭮'  ᬮ");
  END;

  IF ~!RTI.Get().CurWindow THEN
   CurWindow:=RTI.Get().CurWindow.OriginalName;
   IF ((CurWindow = "MDoc_OC") & (MDocKind.imOC # 0)) |
      ((CurWindow = "MDoc_DO") & (MDocKind.imDO # 0)) |
      ((CurWindow = "MDoc_EI") & (MDocKind.imEI # 0)) THEN
    Window:=CurWindow;
   END;
  END;
 END {pcr_SetDefaultWindowAndZone_ByMDocKind};

 PUBLIC PROCEDURE pcr_PosOnMasterFile(curFile, mstFile: STRING[]);
 BEGIN
  IF curFile = "ACalc" THEN
   SEARCH((mstFile), RECORDID, , ACalc.riOwn);
  ELSE
   CONFORM((curFile), (mstFile));
  END;
 END {pcr_PosOnMasterFile};

 PUBLIC PROCEDURE prc_GetPseudoMasterFile(File: STRING[]): STRING[];
 BEGIN
  IF File = "ACalc" THEN
   RETURN DATABASE.Get().TableById(ACalc.fiOwn).Name;
  ELSE
   RETURN "";
  END;
 END {prc_GetPseudoMasterFile};

 PRIVATE PROCEDURE pcr_SetDefaultWindowAndZone_ByODocKind(VAR Window: STRING[]; VAR Zone: NUMERIC[0]);
 BEGIN
  IF ODocKind.Scope = L_ODoc.odks_Internal THEN
   Window:="ODocInt";
  END;
 END {pcr_SetDefaultWindowAndZone_ByODocKind};

 PUBLIC PROCEDURE pcr_SetDefaultWindowAndZone(    File              : STRING[];
                                              VAR Window            : STRING[];
                                              VAR Zone              : NUMERIC[0];
                                              VAR wExternalChangesel: SCAL[2]);
  VAR
   ownFile,
   Filter: STRING[];
   Dummy : NUMERIC[0];
 BEGIN
  Window            :=File;
  Zone              :=1;
  wExternalChangesel:=0;
  IF   File = "EDOrder" THEN
   Window:="EDOrder1";
  ELSIF File = "Staff" THEN
   Window:="Staff_A";
  ELSIF File = "Money" THEN
   Window:="Money0";
  ELSIF File = "RouteLog" THEN
   Window:="RoutMod";
   Zone  :=2;
  ELSIF File = "RprPro" THEN
   IF OCCURE(RprPro) & !RprPro.RprJ & !RprPro.RprT THEN (* ᢮ RprT  RprJ 樮஢  㬥*)
    CONFORM(RprPro, RprS);
    CHANGESEL(RprPro, RprS, , RprPro.RprS, RprPro.RprT, RprPro.RprJ);
    Window            :="RprSE";
    Zone              :=4;
    wExternalChangesel:=1;
   END;
  ELSIF L_PCS.IsAnyProTable(TABLE.Get(File)) THEN
   Window:=L_Prop.GetPropListWindowName(File);
  ELSIF OCCURE((File)) THEN
   IF    File = "PDoc" THEN
    CONFORM(PDoc, PDocKind);
    CHANGESEL(PDoc, PDoc, , PDoc.PDocKind);
    wExternalChangesel:=1;
   ELSIF File = "MDoc" THEN
    CONFORM(MDoc, MDocKind);
    CHANGESEL(MDoc, MDoc, , MDoc.MDocKind);
    pcr_SetDefaultWindowAndZone_ByMDocKind(Window, Zone);
    wExternalChangesel:=1;
   ELSIF File = "ODoc" THEN
    CONFORM(ODoc, ODocKind);
    CHANGESEL(ODoc, ODoc, , ODoc.ODocKind);
    pcr_SetDefaultWindowAndZone_ByODocKind(Window, Zone);
    wExternalChangesel:=1;
   ELSIF File = "AMO" THEN
    CHANGESEL(AMO, AMO, , AMO.Kind);
    Window            :="AMO" + AMO.Kind;
    wExternalChangesel:=1;
   ELSIF File = "XDFCase" THEN
    CHANGESEL(XDFCase, ToDo, , XDFCase.Owner, XDFCase.Closed);
    Window            :="MyXDFC";
    wExternalChangesel:=1;
    CALL(XDFCase.SetupVarsForRequiredPosition());
   ELSIF File = "JDoc" THEN
    CONFORM(JDoc, JDocKind);
    CHANGESEL(JDoc, JDoc, , JDoc.JDocKind);
    wExternalChangesel:=1;
   ELSIF File = "PLDoc" THEN
    CONFORM(PLDoc, PLDKind);
    CHANGESEL(PLDoc, PLDoc, , PLDoc.PLDKind);
    wExternalChangesel:=1;
   ELSIF File = "FOrder" THEN
    IF Memo.ud_mb() # FOrder.Closed THEN
     Memo.ud_SetCurDate(FOrder.Closed);
    END;
    CONFORM(FOrder, EDOSrc);
    L_EDO.GetEDOSrcPermanentFilter(L_EDO.ot_FO, Filter, Dummy);
    L_General.Assert(~!Filter & ^Filter, "   ࠢ  ਪ  ᫥  㤥ঠ" +
                                          "| 筨 " + EDOSrc.EDOSrc + " " + EDOSrc.Name);
    CHANGESEL(FOrder, EDOSrc, , FOrder.EDOSrc, FOrder.Closed);
    wExternalChangesel:=1;
   ELSIF File = "Property" THEN
    IF (Property.Object = L_Prop.OwnDProObj) & Property.IsUsed THEN
     CHANGESEL(Property, PropObj, , Property.Object);
     Window            :="OwnDProA";
     wExternalChangesel:=1;
    END;
   ELSIF File = "Officer" THEN
    CONFORM(Officer, Sort);
    CHANGESEL(Sort, Parent);
    CHANGESEL(Officer, Officer, , Officer.Sort);
    Window            :="Sort";
    Zone              :=2;
    wExternalChangesel:=1;
   ELSIF File = "RWayS" THEN
    IF (RWayS.Status = L_Way.rwsStat_Ordered) | (RWayS.Status = L_Way.rwsStat_Given) THEN
     CHANGESEL(RWayS, sRWayS, , RWayS.Status);
     Window            :="Beg"+RWayS.Status;
     wExternalChangesel:=1;
    END;
   ELSIF File = "TckRcS" THEN
    IF (TckRcS.Status = L_TRS.trsStat_Ordered) | (TckRcS.Status = L_TRS.trsStat_Given) THEN
     CHANGESEL(TckRcS, sTckRcS, , TckRcS.Status);
     Window            :="TRS"+TckRcS.Status;
     wExternalChangesel:=1;
    END;
   ELSIF File = "TckRcD" THEN
    IF L_TRS.IsSaleTckRcD(TckRcD.Type) THEN
     CHANGESEL(TckRcD, Type, , TckRcD.Type);
     Window            :="TckRcD3";
     wExternalChangesel:=1;
    END;
   ELSIF File = "AvePay" THEN
    IF Memo.ud_mb() # AvePay.Period THEN
     Memo.ud_SetCurDate(AvePay.Period);
    END;
    CHANGESEL(AvePay, Period, , AvePay.Period);
    Window            :="AvpAll";
    wExternalChangesel:=1;
   ELSIF File = "Dspt" THEN
    CHANGESEL(Dspt, Dspt, , Dspt.Type);
    Window            :=L_Str.PoolItem("DsptI|DsptO", Dspt.Type);
    wExternalChangesel:=1;
   ELSIF File = "DsptDoc" THEN
    Window:=L_Str.PoolItem("DsptIE|DsptOE", DsptDoc.Type);
   ELSIF File = "Math" THEN
    CHANGESEL(Math, MathKind, , Math.MathKind);
    IF Math.MathKind = L_MathR.mathk_KeyAs THEN
     Window:="Math01";
    ELSE
     Window:="Math00";
    END;
    wExternalChangesel:=1;
   ELSIF File = "CUCopy" THEN
    IF    ~!CUCopy.Storage & SEARCH(Storage, Storage, CUCopy.Storage) & (Storage.StrgKind = L_Stock.sk_TckBag) THEN
     Window:="Strg2";
    ELSIF CUCopy.Origin = L_CUC.o_OutCBlc THEN
     Window:="OutCBlc";
    ELSE
     Window:="CUCopyA";
    END;
   ELSIF File = "Storage" THEN
    CHANGESEL(Storage, StrgKind, , Storage.StrgKind);
    CONFORM(Storage, StrgKind);
    IF  StrgKind.StrgKind = L_Stock.sk_TckBag THEN
     Window:="Strg2";
    END;
    wExternalChangesel:=1;
   ELSIF File = "Packet" THEN
    Window:="Packet" + Packet.Receiver;
    IF L_Packet.IsSamplePacket() THEN
     CHANGESEL(Packet, PacketDS, , Packet.Receiver, Packet.DTStamp);
     Zone              :=2;
     wExternalChangesel:=1;
    ELSE
     CHANGESEL(Packet, PPacket, , Packet.Receiver);
     wExternalChangesel:=1;
    END;
   ELSIF File = "bpRT" THEN
    IF    bpRT.State = L_bp.s_InQueue THEN
     CHANGESEL(bpRT, State, , bpRT.State);
     Window            :="bpSh";
     wExternalChangesel:=1;
    ELSIF bpRT.State = L_bp.s_Running THEN
     CHANGESEL(bpRT, State, , bpRT.State);
     Window            :="bpSh";
     Zone              :=2;
     wExternalChangesel:=1;
    ELSE
     Window            :="bpJrn";
    END;
   ELSIF File = "Mtwo" THEN
    IF Memo.ud_mb() # Mtwo.Per THEN
     Memo.ud_SetCurDate(Mtwo.Per);
    END;
    CHANGESEL(Mtwo, Who, , Mtwo.Per);
    wExternalChangesel:=1;
   ELSIF File = "ManActv" THEN
    IF    ManActv.ActvKind = L_Man.actvk_Education THEN
     Window:="MActv";
     Zone  :=1;
    ELSIF ManActv.ActvKind = L_Man.actvk_Work THEN
     Window:="MActv";
     Zone  :=2;
    ELSE
     Window:="MActvEu";
    END;
   ELSIF File = "StaffMon" THEN
    Window:="Sheet2";
    CONFORM(StaffMon, Staff);
    IF Memo.ud_mb() # StaffMon.Period THEN
     Memo.ud_SetCurDate(StaffMon.Period);
    END;
   ELSIF File = "RprT" THEN
    CHANGESEL(RprT, RprS, , RprT.RprS);
    CONFORM(RprT, RprS);
    Window            :="RprSE";
    Zone              :=2;
    wExternalChangesel:=1;
   END;
  END;
 END {pcr_SetDefaultWindowAndZone};

 PUBLIC PROCEDURE pcr_Check_SE_WZD_Error(trgZone: FORM_ZONE);
 BEGIN
  IF ~!trgZone.MasterTable.Fields("MyPlace") |~!trgZone.MasterTable.Fields("MyFirm") THEN
   IF ~(^(L_Way.extCurPlaceFilter(trgZone.MasterTable.Name, ""))) THEN
    L_General.Error(",   㦭 ३,  ᮮ⢥ ⠭  㬮砭  / ");
   END;
  END;
 END {pcr_Check_SE_WZD_Error};

 PUBLIC PROCEDURE StandOnDefaultPosition(File: STRING[]);
  VAR
   kN: STRING[];
 BEGIN
  IF    L_DBD.FileHasXDocKind(File) THEN
   kN:=File + "Kind";
   SETSEL((File), (File), ^(L_DBD.GetFieldName(kN, kN)));
   LAST((File));
  ELSIF File = "RWayS" THEN
   SETSEL(RWayS, RWayS);
   LAST(RWayS);
  ELSE
   SELECT((File), ^(L_DBD.GetPrimaryIndex(File)));
  END;
 END {StandOnDefaultPosition};

END.
