(*
%Copyright   (c) Polak IT
%Author      08.12.2010 11:35:24 POLAK\San
%Purpose     প ண ᪠ ਡ⮢ 䠩
%Type        library
%Specific    SYS
%Modified    20.12.2013 10:53:54 POLAK\GAV
%Environment
*)

 IMPORT L_General, L_DBD, L_DatTim, L_Prop;

 PUBLIC TYPE
  tSrcMode       = SCAL[2];
  tQSearchResult = SCAL[3];

 PUBLIC CONST
  sm_EQ = 0;
  sm_LE = 1;

  qsr_None    = 0;
  qsr_Unique  = 1;
  qsr_Several = 2;

 PUBLIC PROCEDURE StringBelong2Value(trgString: STRING[]): SCAL[2];
  VAR
   asValue: LIKE(qs.Value);
 BEGIN
  asValue:=trgString;
  RETURN asValue = trgString;
 END {StringBelong2Value};

 PRIVATE PROCEDURE byPro_GetValidityValues(proTable: TABLE; VAR trgBegin, trgTill: DATE);
 BEGIN
  trgBegin:=^(proTable.Fields("Date").ObtainName());
  trgTill :=^(proTable.Fields("EndDate").ObtainName());
  IF ~!trgTill THEN
   INC(trgTill);
  END;
 END {byPro_GetValidityValues};

 PUBLIC PROCEDURE byPro_Add(proFile : STRING[];
                            trgAttr : LIKE(qs.Attr);
                            trgValue: STRING[]);
  VAR
   srcTable,
   mstTable  : TABLE;
 BEGIN
  srcTable:=TABLE.Get(proFile);
  qs.fiSrc:=srcTable.Id;
  qs.riSrc:=^(srcTable.Fields("RECORDID").ObtainName());
  mstTable:=srcTable.LendLink.CooIndex.Table;
  qs.fi:=mstTable.Id;
  SAVE(^(mstTable.Name));
  CONFORM(^(srcTable.Name), ^(mstTable.Name));
  qs.ri:=^(mstTable.Fields("RECORDID").ObtainName());
  RESTORE(^(mstTable.Name));
  qs.Attr :=trgAttr;
  qs.Value:=trgValue;
  L_General.CallUs(StringBelong2Value(trgValue));
  byPro_GetValidityValues(srcTable, qs.Begin, qs.Till);
  INSERT(qs);
 END {byPro_Add};

 PUBLIC PROCEDURE byPro_RenovateValidyty(proFile: STRING[]);
  VAR
   proTable: TABLE;
   proRI   : NUMERIC[0];
 BEGIN
  proTable:=TABLE.Get(proFile);
  proRI   :=^(TABLE.Get(proFile).Fields("RECORDID").ObtainName());
  SELECT(qs, Src, , proTable.Id, proRI);
  WHILE OCCURE(qs) DO
   byPro_GetValidityValues(proTable, qs.Begin, qs.Till);
   REPLACE(qs);
   NEXT(qs);
  END; (* WHILE OCCURE(qs) *)
 END {byPro_RenovateValidyty};

 PUBLIC PROCEDURE OnBeforeDelete(trgFile: STRING[]);
  VAR
   curId,
   curRI   : NUMERIC[0];
   ownTable: TABLE;
 BEGIN
  ownTable:=TABLE.Get(trgFile);
  IF ~!ownTable.Fields("RECORDID") THEN
   curId:=ownTable.Id;
   curRI:=^(ownTable.Fields("RECORDID").ObtainName());
   WHILE SELECT(qs, qs, curId, curRI) | SELECT(qs, Src, curId, curRI) DO
    REMOVE(qs);
   END; (* WHILE SELECT ... *)
  END;
 END {OnBeforeDelete};

 PUBLIC PROCEDURE MakeCopy(trgFile: STRING[]; srcRI, dstRI: LIKE(qs.ri));
  VAR
   curId   : NUMERIC[0];
   curTable: TABLE;
 BEGIN
  curTable:=TABLE.Get(trgFile);
  curId   :=curTable.Id;

  SELECT(qs, Src, , curId, srcRI);
  WHILE OCCURE(qs) DO
   SAVE(qs);
   qs.riSrc:=dstRI;
   byPro_GetValidityValues(curTable, qs.Begin, qs.Till);
   INSERT(qs);
   RESTORE(qs);
   NEXT(qs);
  END; (* WHILE OCCURE(qs) ... *)
 END {MakeCopy};

 PUBLIC PROCEDURE byPro_MakeCopy(trgFI, mstFI: LIKE(qs.fi); srcRI, dstRI, mstSrcRI, mstDstRI: LIKE(qs.ri));
  VAR
   curTable: TABLE;
 BEGIN
  curTable:=DATABASE.Get().TableById(trgFI);
  SELECT(qs, Src, , trgFI, srcRI);
  WHILE OCCURE(qs) DO
   SAVE(qs);
   IF (qs.fi = mstFI) & (qs.ri = mstSrcRI) THEN
    qs.ri  :=mstDstRI;
   END;
   qs.riSrc:=dstRI;
   byPro_GetValidityValues(curTable, qs.Begin, qs.Till);
   INSERT(qs);
   RESTORE(qs);
   NEXT(qs);
  END; (* WHILE OCCURE(qs) ... *)
 END {byPro_MakeCopy};

 PRIVATE PROCEDURE StandOnRecord(trgFile : STRING[];
                                 trgAttr : LIKE(qs.Attr);
                                 trgValue: LIKE(qs.Value);
                                 trgDate : DATE;
                                 srcMode : tSrcMode;
                                 trmQSR  : tQSearchResult;
                                 CondProc: PROC): tQSearchResult;
  VAR
   Result: tQSearchResult;
   rsltRI: LIKE(qs.ri);
 BEGIN
  Result:=qsr_None;
  IF    srcMode = sm_EQ THEN
   SELECT(qs, qsQS, , TABLE.Get(trgFile).Id, trgAttr, trgValue);
   LAST(qs);
  ELSIF srcMode = sm_LE THEN
   SELECT(qs, qsQS, , TABLE.Get(trgFile).Id, trgAttr);
   SRCINSEL(qs, LE, , trgValue);
  ELSE
   L_General.CallUs(0);
  END;
  WHILE OCCURE(qs) & (Result # trmQSR) DO
   IF L_DatTim.IsActive(trgDate, qs.Begin, qs.Till) &
      SEARCH(^trgFile, RECORDID, qs.ri) &
      ((qs.fiSrc = qs.fi) | L_DBD.RecordIsActive(trgDate, trgFile)) &
      (!CondProc | CondProc(trgDate)) THEN
    IF Result = qsr_None THEN
     Result:=qsr_Unique;
     rsltRI:=qs.ri;
    ELSIF Result = qsr_Unique THEN
     Result:=qsr_Several;
    END;
   END;
   PREV(qs);
  END; (* WHILE OCCURE(qs) ... *)
  IF Result # qsr_None THEN
   SEARCH(^trgFile, RECORDID, , rsltRI);
  END;
  RETURN Result;
 END {StandOnRecord};

 PUBLIC PROCEDURE complexStandOnFirst(trgFile : STRING[];
                                      trgAttr : LIKE(qs.Attr);
                                      trgValue: LIKE(qs.Value);
                                      trgDate : DATE;
                                      srcMode : tSrcMode;
                                      CondProc: PROC): SCAL[2];
 BEGIN
  RETURN StandOnRecord(trgFile, trgAttr, trgValue, trgDate, srcMode, qsr_Unique, CondProc) # qsr_None;
 END {complexStandOnFirst};

 PUBLIC PROCEDURE StandOnFirst(trgFile : STRING[];
                               trgAttr : LIKE(qs.Attr);
                               trgValue: LIKE(qs.Value);
                               trgDate : DATE): SCAL[2];
 BEGIN
  RETURN complexStandOnFirst(trgFile, trgAttr, trgValue, trgDate, sm_EQ, L_General.EMPTY_PROC()) # qsr_None;
 END {StandOnFirst};

 PUBLIC PROCEDURE complexStandOnUnique(trgFile : STRING[];
                                       trgAttr : LIKE(qs.Attr);
                                       trgValue: LIKE(qs.Value);
                                       trgDate : DATE;
                                       srcMode : tSrcMode;
                                       CondProc: PROC): tQSearchResult;
 BEGIN
  RETURN StandOnRecord(trgFile, trgAttr, trgValue, trgDate, srcMode, qsr_Several, CondProc);
 END {complexStandOnUnique};

 PUBLIC PROCEDURE StandOnUnique(trgFile : STRING[];
                                trgAttr : LIKE(qs.Attr);
                                trgValue: LIKE(qs.Value);
                                trgDate : DATE): tQSearchResult;
 BEGIN
  RETURN complexStandOnUnique(trgFile, trgAttr, trgValue, trgDate, sm_EQ, L_General.EMPTY_PROC());
 END {StandOnUnique};

END.