(*
%Copyright   (c) Polak Computer System
%Author      27.11.2002 15:39:51 POLAK\SAN
%Purpose     প SES
%Type        library
%Specific    SYS
%Modified    05.10.2012 11:55:18 POLAK\GAV
%Environment
*)

 MODULE L_SES [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tSbjIdType = LIKE(SES.SbjIdTyp);
  tSbjId     = LIKE(SES.SbjId);
  tValId     = LIKE(SES.ValId);

 PUBLIC CONST
  sit_Station        = 0;
  sit_User           = 1;
  sit_Special        = 2;
  sit_Global         = 3;
  sit_WindowsProfile = 4;
  sit_StationAcsObj  = 5;

  IdGlobal = "GLOBAL";
  ctId_AppValues = "AppValues";

 IMPORT L_General, L_StdFrm, L_ACL;

 PRIVATE PROCEDURE intPutValue(trgSbjIdType: tSbjIdType;
                               trgSbjId    : tSbjId;
                               trgValId    : tValId;
                               Value       : STRING[];
                               Transaction : NUMERIC[0]);
 BEGIN
  IF ~!trgSbjId THEN
   TRY [TRANSACTION(Transaction), MSGSUPPRESSIONMODE(MSGSUPPRESS_ALL), EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
    IF SEARCH(SES, SES, trgSbjIdType, trgSbjId, ctId_AppValues, trgValId) THEN
     SES.Value  :=Value;
     SES.UpdTime:=SYSTIMESTAMP();
     REPLACE(SES);
    ELSE
     SES.SbjIdTyp:=trgSbjIdType;
     SES.SbjId   :=trgSbjId;
     SES.CntxtId :=ctId_AppValues;
     SES.ValId   :=trgValId;
     SES.Value   :=Value;
     SES.UpdTime :=SYSTIMESTAMP();
     INSERT(SES);
    END;
   EXCEPT
   ON Exc: Exc_AccessDeny DO
    L_StdFrm.TimedINFORM(" 㤠 ࠭ 祭 塞  ࠬ."+
                         "||,  ॣ஢  ᢮   㣮 ⠭樨", 5);
   END;
  END;
 END {intPutValue};

 PRIVATE PROCEDURE GetId_Special(): tSbjId;
 BEGIN
  RETURN APP.Get().MyConnection.Number + "_" + LOGINNAME() + "_" + PSTATION();
 END {GetId_Special};

 PRIVATE PROCEDURE StationId(): STRING[];
 BEGIN
  IF L_General.IsTSSession() THEN
   RETURN APP.Get().MyConnection.WTSClientName;
  ELSE
   RETURN PSTATION();
  END;
 END {StationId};

 PRIVATE PROCEDURE CurSbjId(trgSbjIdType: tSbjIdType): tSbjId;
 BEGIN
  IF    trgSbjIdType = sit_Station THEN
   RETURN StationId();
  ELSIF trgSbjIdType = sit_User THEN
   RETURN LOGINNAME();
  ELSIF trgSbjIdType = sit_Special THEN
   RETURN GetId_Special();
  ELSIF trgSbjIdType = sit_Global THEN
   RETURN IdGlobal;
  ELSIF trgSbjIdType = sit_WindowsProfile THEN
   RETURN L_General.curUSER + "_" + PSTATION() + "_" + COMPUTERNAME(COMPUTER_NAME_PhysicalNetBIOS);
  ELSIF trgSbjIdType = sit_StationAcsObj THEN
   RETURN L_General.curUSER + "_" + StationId();
  ELSE
   L_General.CallUs(0);
  END;
 END {CurSbjId};

 PUBLIC PROCEDURE PutValueAtSlaveTrn(trgSbjIdType: tSbjIdType;
                                     trgValId    : tValId;
                                     trgValue    : STRING[]);
 BEGIN
  intPutValue(trgSbjIdType, CurSbjId(trgSbjIdType), trgValId, trgValue, TRANSACTION_SLAVE);
 END {PutValueAtSlaveTrn};

 PUBLIC PROCEDURE PutValueAtCurTrn(trgSbjIdType: tSbjIdType;
                                   trgValId    : tValId;
                                   trgValue    : STRING[]);
 BEGIN
  intPutValue(trgSbjIdType, CurSbjId(trgSbjIdType), trgValId, trgValue, TRANSACTION_CURRENT);
 END {PutValueAtCurTrn};

 PUBLIC PROCEDURE PosToSES(trgSbjIdType: tSbjIdType; trgValId: tValId): SCAL[2];
 BEGIN
  RETURN SEARCH(SES, SES, trgSbjIdType, CurSbjId(trgSbjIdType), ctId_AppValues, trgValId);
 END {PosToSES};

 PUBLIC PROCEDURE GetValue(trgSbjIdType: tSbjIdType; trgValId: tValId; VAR Value: STRING[]): SCAL[2];
 BEGIN
  TRY
   IF PosToSES(trgSbjIdType, trgValId) THEN
    Value:=SES.Value;
    RETURN 1;
   END;
  EXCEPT
  ELSE
  END;
  RETURN 0;
 END {GetValue};

 PUBLIC PROCEDURE GetFieldValue_asDATE(trgSbjIdType: tSbjIdType; Field: STRING[]; Default: DATE): DATE;
  VAR
   Value: STRING[];
 BEGIN
  IF GetValue(trgSbjIdType, Field, Value) THEN
   RETURN STRTOFLD(Value, DATE);
  ELSE
   RETURN Default;
  END;
 END {GetFieldValue_asDATE};

 PUBLIC PROCEDURE GetFieldValue_asNUMERIC(trgSbjIdType: tSbjIdType;
                                          Field       : STRING[];
                                          Default     : NUMERIC[5]): NUMERIC[5];
  VAR
   Value: STRING[];
 BEGIN
  IF GetValue(trgSbjIdType, Field, Value) THEN
   RETURN STRTOFLD(Value, NUMERIC);
  ELSE
   RETURN Default;
  END;
 END {GetFieldValue_asNUMERIC};

END.
