(*
%Copyright   (c) Polak IT
%Author      31.12.2009 14:43:04 POLAK\San
%Purpose      客 ᮢ
%Type        library
%Specific    SYS
%Modified    24.09.2014 16:11:20 LDA
%Environment
*)

 MODULE L_SFee [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_EC, L_DatTim, P_Firm, P_Man, L_Man, L_PRoll, E_PRoll, L_APtm, L_ACL,
        L_Staff, Math, L_AFM, P_MCList, L_Russia, L_iga, L_StdFrm, L_Cntr, L_Env,
        L_Packet, L_Str, P_Staff, P_Officer;

 PUBLIC TYPE
  tPart          = SCAL[8+5];
  tBase          = SCAL[5+5];
  tType          = SCAL[8];
  tManAgeGroup   = SCAL[2];
  tSource        = SCAL[3];
  tPFAReasonCode = SCAL[3];

 PUBLIC CONST
  TheStartingPoint=01\01\2010;

  p_Amount = MAXOF(tPart)+1;
  p_PFIn = 0;
  p_PFAc = 1;
  p_xFSS = 2;
  p_MSFF = 3;
  p_MSTF = 4;
  p_PFOv = 5;
  p_PFA1 = 6; (*.   ।묨 ᫮ﬨ 㤠,  ᮡ ᫮ 㤠 27-1*)
  p_PFA2 = 7; (*.   殮묨 ᫮ﬨ 㤠,  ᮡ ᫮ 㤠 27-2  稥*)
  p_PFA3_1 = 08; (*.    27-1  27-2,  3.1*)
  p_PFA3_2 = 09; (*.    27-1  27-2,  3.2*)
  p_PFA3_3 = 10; (*.    27-1  27-2,  3.3*)
  p_PFA3_4 = 11; (*.    27-1  27-2,  3.4*)
  p_PFA4_0 = 12; (*.    27-1  27-2,  4*)
  p_Pool = "||||||1|2|3_1|3_2|3_3|3_4|4";

  b_Amount = MAXOF(tBase)+1;
  b_PFR = 0;
  b_FSS = 1;
  b_MSF = 2;
  b_PA1 = 3;
  b_PA2 = 4;
  b_PA3_1 = 5;
  b_PA3_2 = 6;
  b_PA3_3 = 7;
  b_PA3_4 = 8;
  b_PA4_0 = 9;
  b_Pool = "|||1|2|3_1|3_2|3_3|3_4|4";

  t_Normal     = 0; (*tType*)
  t_Invalid    = 1;
  t_ENVD       = 2;
  t_USNO       = 3;
  t_woCtzn     = 4;
  t_woCtzn_Commorancy   = 5;
  t_woCtzn_TmpResidence = 6;
  t_Pool    = " ०|||| ࠦ⢠ |࠭ |࠭ ";

  mag_Old = 0; (*tManAgeGroup*)
  mag_Ave = 1;
  mag_Pool = "1966|1967";

  s_Money  = 0; (*tSource*)
  s_Plus   = 1;
  s_Minus  = 2;
  s_Pool = " | (४஢)| (४஢)";

  pfarc_None = 0; (* ᯨ᪮*) (*tPFAReasonCode*)
  pfarc_1    = 1; (*᮪ 죮 1*)
  pfarc_2    = 2; (*᮪ 죮 2*)

 PUBLIC TYPE
  tValues     = NUMERIC[2][p_Amount];

 PRIVATE TYPE
  tInBaseArr  = SCAL[2][b_Amount];
  tGatherMode = SCAL[2];
  tRate       = SCAL[4];
  tPFAGroup   = SCAL[8];

 PRIVATE CONST
  gm_Calculate = 0;
  gm_Spread    = 1;

  r_Normal    = 0; (*tRate*)
  r_Reduced   = 1;
  r_USNO_2011 = 2;
  r_woCtzn_wPF =3;

  pfagr_None     = 0; (*tPFAGroup*)
  pfagr_PnsAttr  = 1;
  pfagr_DirtyNon = 2;
  pfagr_Dirty3_1 = 3;
  pfagr_Dirty3_2 = 4;
  pfagr_Dirty3_3 = 5;
  pfagr_Dirty3_4 = 6;
  pfagr_Dirty4   = 7;
  pfagr_Pool     = " |᪨ 죮| 1  2| 3_1| 3_2| 3_3| 3_4| 4";

 PRIVATE VAR
  rd_Period: DATE;
  rd_MyFirm: P_Firm.tMyFirm;
  rd_A2SF  : P_MCList.tAttitude2SFee[1000];

 PUBLIC PROCEDURE p2b(p: tPart): tBase;
 BEGIN
  IF    p = p_PFAc THEN RETURN b_PFR;
  ELSIF p = p_PFIn THEN RETURN b_PFR;
  ELSIF p = p_xFSS THEN RETURN b_FSS;
  ELSIF p = p_MSFF THEN RETURN b_MSF;
  ELSIF p = p_MSTF THEN RETURN b_MSF;
  ELSIF p = p_PFOv THEN RETURN b_PFR;
  ELSIF p = p_PFA1 THEN RETURN b_PA1;
  ELSIF p = p_PFA2 THEN RETURN b_PA2;
  ELSIF p = p_PFA3_1 THEN RETURN b_PA3_1;
  ELSIF p = p_PFA3_2 THEN RETURN b_PA3_2;
  ELSIF p = p_PFA3_3 THEN RETURN b_PA3_3;
  ELSIF p = p_PFA3_4 THEN RETURN b_PA3_4;
  ELSIF p = p_PFA4_0 THEN RETURN b_PA4_0;
  END;
 END {p2b};

 PUBLIC PROCEDURE IsPFAddPart(trg_p: tPart): SCAL[2];
 BEGIN
  RETURN (trg_p >= p_PFA1) & (trg_p <= p_PFA4_0);
 END {IsPFAddPart};

 PUBLIC PROCEDURE IsPartwNotion(P: DATE; trg_p: tPart): SCAL[2];
 BEGIN
  RETURN (trg_p >= p_PFIn) & (trg_p <= p_PFA2);
 END {IsPartwNotion};

 PUBLIC PROCEDURE IsAcceptablePart(P: DATE; trg_p: tPart): SCAL[2];
 BEGIN
  IF P >= 01\01\2014 THEN
   RETURN (trg_p >= p_PFIn) & (trg_p <= p_PFA4_0);
  ELSE
   RETURN (trg_p >= p_PFIn) & (trg_p <= p_PFA2);
  END;
 END {IsAcceptablePart};

 PUBLIC PROCEDURE IsForeignCitizen(_Man: LIKE(Man.Man); P: DATE): SCAL[2];
  VAR
   D: DATE;
 BEGIN
  D:=L_DatTim.MonthEnd(P);
  RETURN (L_Man.Man_Citizen(_Man, D) >= L_Man.ct_CIS) &
         (~L_Man.AccessManAdr(_Man, D, L_Russia.at_CtMA) | (ManAdr.Country # L_Russia.c_Russia));
 END {IsForeignCitizen};

 PUBLIC PROCEDURE ManCitizenship(_Man: LIKE(Man.Man); P: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
   fls   : P_Man.tForeignerLegalStatus;
 BEGIN
  Result:=1;
  IF IsForeignCitizen(_Man, P) THEN
   fls:=P_Man.GetForeignerLegalStatus(_Man, L_DatTim.MonthEnd(P));
   Result:=(fls # P_Man.fls_Commorancy) & (fls # P_Man.fls_Commorancy_wSIN);
  END;
  RETURN Result;
 END {ManCitizenship};

 PRIVATE PROCEDURE woCtznWithPF(_Man: LIKE(Man.Man); P: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
   D,
   BegD,
   EndD: DATE;
 BEGIN
  D:=L_DatTim.MonthEnd(P);
  SAVE(Staff);
  L_Staff.StandOnMainContract(_Man, Staff.MyFirm, D);
  IF Staff.Contract = L_Staff.cnt_ContractorsAgreement THEN
   Result:=0;
  ELSE
   IF D >= 01\01\2013 THEN
    BegD:=L_Man.GetTakeOnDate(D);
   ELSE
    BegD:=L_Man.GetRealBegDate(D);
   END;
   EndD:=L_Man.GetTimedContractEndDate(D);
   Result:=!EndD | (L_DatTim.CompleteMonthsInIntvl(BegD, EndD) >= 6);
  END;
  RESTORE(Staff);
  RETURN Result;
 END {woCtznWithPF};

 PUBLIC PROCEDURE ManHasSINumber(): SCAL[2];
 BEGIN
  RETURN ~!Man.SINumber;
 END {ManHasSINumber};

 PUBLIC PROCEDURE ManHasADV1(): SCAL[2];
 BEGIN
  RETURN L_Packet.HasDonePacketInYear(Man.Man, L_Packet.knd_PF_ADV1, EMPTYOF(Packet.DataType), EMPTYOF(Packet.MyFirm), EMPTYOF(DATE));
 END {ManHasADV1};

 PUBLIC PROCEDURE ManIsInsuredInPF(trgMan: LIKE(Man.Man); P: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=ManCitizenship(trgMan, P);
  IF (P >= 01\01\2012) & ~Result THEN
   IF ManHasSINumber() | ManHasADV1() THEN
    IF P_Man.HasActualManPro(trgMan, L_DatTim.MonthEnd(P), P_Man.P_ForeignerLegalStatus) THEN
     Result:=P_Man.GetForeignerLegalStatus(trgMan, L_DatTim.MonthEnd(P)) # P_Man.fls_Commorancy;
    ELSE
     Result:=1;
    END;
   END;
  END;
  RETURN Result;
 END {ManIsInsuredInPF};

 PUBLIC PROCEDURE ManNeedInsureInPF(_Man: LIKE(Man.Man); P: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=ManCitizenship(_Man, P);
  IF (P >= 01\01\2012) & ~Result THEN
   Result:=IsForeignCitizen(_Man, P) & woCtznWithPF(_Man, P);
  END;
  RETURN Result;
 END {ManNeedInsureInPF};

 PUBLIC PROCEDURE E_ApplySFeeBenefitToInvalid(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_PRoll.ApplySTxBenefitToInvalid), 1);
 END {E_ApplySFeeBenefitToInvalid};

 PUBLIC PROCEDURE ManIsInvalid(_Man: LIKE(Man.Man); P: DATE): SCAL[2];
 BEGIN
  RETURN E_ApplySFeeBenefitToInvalid(P) &
         P_Man.HasActualManPro(_Man, L_DatTim.MonthEnd(P), P_Man.P_Invalid);
 END {ManIsInvalid};

 PUBLIC PROCEDURE IsUSNOLowSFee(trgMyFirm: P_Firm.tMyFirm; P: DATE): SCAL[2];
 BEGIN
  RETURN P_Firm.FirmHasSimplifiedTaxation(P_Firm.GetFirmOfMyFirm(trgMyFirm), P) &
         L_General.IsPolakSpecific() & (trgMyFirm = L_Env.mf_PIS);
 END {IsUSNOLowSFee};

 PUBLIC PROCEDURE DefineType(_MyFirm: P_Firm.tMyFirm; _Man: LIKE(Man.Man); P: DATE): tType;
  VAR
   Result: tType;
   fls   : P_Man.tForeignerLegalStatus;
 BEGIN
  IF    P >= 01\01\2012 THEN
   IF IsForeignCitizen(_Man, P) THEN
    fls:=P_Man.GetForeignerLegalStatus(_Man, L_DatTim.MonthEnd(P));
    IF    fls = P_Man.fls_ResidencePermit THEN
     Result:=t_Normal;
    ELSIF ManIsInsuredInPF(_Man, P) THEN
     IF fls = P_Man.fls_TempResidence THEN
      Result:=t_woCtzn_TmpResidence;
     ELSIF (fls = P_Man.fls_Commorancy) | (fls = P_Man.fls_Commorancy_wSIN) THEN
      Result:=t_woCtzn_Commorancy;
     END;
    ELSE
     Result:=t_woCtzn;
    END;
   ELSIF IsUSNOLowSFee(_MyFirm, P) THEN
    Result:=t_USNO;
   ELSIF ManIsInvalid(_Man, P) THEN
    Result:=t_Invalid;
   ELSE
    Result:=t_Normal;
   END;
   IF Result # t_Invalid THEN
    L_General.Assert(~ManIsInvalid(_Man, P), "  ঠ    ० "+L_Str.PoolItem(t_Pool, Result)+
                                             ":| "+FLDTOSTR(_Man, "", 5));
   END;
   RETURN Result;
  ELSIF P >= 01\01\2011 THEN
   IF ~ManCitizenship(_Man, P) THEN
    RETURN t_woCtzn;
   ELSIF IsUSNOLowSFee(_MyFirm, P) THEN
    RETURN t_USNO;
   ELSIF ManIsInvalid(_Man, P) THEN
    RETURN t_Invalid;
   ELSE
    RETURN t_Normal;
   END;
  ELSE
   IF ~ManCitizenship(_Man, P) THEN
    RETURN t_woCtzn;
   ELSIF P_Firm.FirmHasSimplifiedTaxation(P_Firm.GetFirmOfMyFirm(_MyFirm), P) THEN
    RETURN t_USNO;
   ELSIF ManIsInvalid(_Man, P) THEN
    RETURN t_Invalid;
   ELSE
    RETURN t_Normal;
   END;
  END; (* IF P >= ... *)
 END {DefineType};

 PRIVATE PROCEDURE t2r(t: tType; P: DATE): tRate;
 BEGIN
  IF (P >= 01\01\2012) &
     ((t = t_woCtzn_Commorancy) | (t = t_woCtzn_TmpResidence)) THEN
   RETURN r_woCtzn_wPF;
  ELSIF P >= 01\01\2011 THEN
   IF    (t = t_Normal) | (t = t_woCtzn) THEN
    RETURN r_Normal;
   ELSIF (t = t_USNO) THEN
    RETURN r_USNO_2011;
   ELSIF (t = t_ENVD) | (t = t_Invalid) THEN
    RETURN r_Reduced;
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   IF (t = t_Normal) | (t = t_woCtzn) THEN
    RETURN r_Normal;
   ELSE
    RETURN r_Reduced;
   END;
  END;
 END {t2r};

 PRIVATE PROCEDURE PutPartOfSingle(P          : DATE;
                                   Source     : tSource;
                                   _InSign    : P_MCList.tAttitude2SFee;
                                   trgXObject : LIKE(XObject.XObject);
                                   trgAcCut   : LIKE(AcCut.AcCut);
                                   trgCostItem: LIKE(CostItem.CostItem);
                                   ofcAcCut   : LIKE(AcCut.AcCut);
                                   _Base,
                                   _Sum       : L_PRoll.tSum;
                                   _ExcBaseArr: tInBaseArr;
                                   ofcMyPlace : LIKE(MyPlace.MyPlace));
  VAR
   totSum,
   totAsS,
   totPA1,
   totPA2: NUMERIC[0];
 BEGIN
  ADD(L_SFee_M, MyFirm, , Staff.MyFirm, Staff.Man, P, _InSign, Money.MCode, trgAcCut, trgXObject, Money.Closed, ofcAcCut, trgCostItem, Source, ofcMyPlace, Staff.TSN, Money.ODate,
       L_SFee_M.Sum,         _Sum,
       L_SFee_M.asSum,       _Base,
       L_SFee_M.Base[b_PFR], _Base * (1-_ExcBaseArr[b_PFR]),
       L_SFee_M.Base[b_FSS], _Base * (1-_ExcBaseArr[b_FSS]),
       L_SFee_M.Base[b_MSF], _Base * (1-_ExcBaseArr[b_MSF]),
       L_SFee_M.Base[b_PA1], _Base * (1-_ExcBaseArr[b_PA1]),
       L_SFee_M.Base[b_PA2], _Base * (1-_ExcBaseArr[b_PA2]),
       L_SFee_M.Base[b_PA3_1], _Base * (1-_ExcBaseArr[b_PA3_1]),
       L_SFee_M.Base[b_PA3_2], _Base * (1-_ExcBaseArr[b_PA3_2]),
       L_SFee_M.Base[b_PA3_3], _Base * (1-_ExcBaseArr[b_PA3_3]),
       L_SFee_M.Base[b_PA3_4], _Base * (1-_ExcBaseArr[b_PA3_4]),
       L_SFee_M.Base[b_PA4_0], _Base * (1-_ExcBaseArr[b_PA4_0]));
  IF (L_SFee_M.Sum = 0) & (L_SFee_M.asSum = 0) THEN
   IF (L_SFee_M.Base[b_PA1] # 0) | (L_SFee_M.Base[b_PA2] # 0) THEN
    TRY [RESTORE_CURSORS(RC_ON)]
     IF ~(SEARCH(eMoney, ori, Money.RECORDID, L_PRoll.et_ManSFee) & (eMoney.ClcPer = Money.WFPeriod)) THEN
      NARROWSEL(L_SFee_M, MyFirm, Man, Period, InSign, MCode, AcCut, XObject, Closed, ofcAcCut, ofcCostItem);
      FIRST(L_SFee_M);
      SETZERO(totSum, totAsS, totPA1, totPA2);
      WHILE OCCURE(L_SFee_M) DO
       INC(totSum, L_SFee_M.Sum);
       INC(totAsS, L_SFee_M.asSum);
       INC(totPA1, L_SFee_M.Base[b_PA1]);
       INC(totPA2, L_SFee_M.Base[b_PA2]);
       NEXT(L_SFee_M);
      END;
      IF (totSum = 0) & (totAsS = 0) THEN
       IF (totPA1 # 0) | (totPA2 # 0) THEN
        L_General.Error("㫥   ᮢ  ⥫쭮   㫥 "+
                        L_StdFrm.HR() +
                        "ᠭ ஡ .  㬥樨  ᠭ  Dst10");
       END;
      END;
     END;
    EXCEPT
    END; (* TRY *)
    RETURN;
   END;
   REMOVE(L_SFee_M);
  END;
 END {PutPartOfSingle};

 PRIVATE PROCEDURE ps_GetCostItemXObject(trgCostItem: LIKE(CostItem.CostItem)): LIKE(XObject.XObject);
  VAR
   Result: LIKE(XObject.XObject);
 BEGIN
  IF ~!trgCostItem THEN
   SAVE(CostItem);
   SEARCH(CostItem, CostItem, , trgCostItem);
   Result:=CostItem.XObject;
   RESTORE(CostItem);
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {ps_GetCostItemXObject};

 PRIVATE PROCEDURE PutSingle(P          : DATE;
                             Source     : tSource;
                             _InSign    : P_MCList.tAttitude2SFee;
                             trgXObject : LIKE(XObject.XObject);
                             trgAcCut   : LIKE(AcCut.AcCut);
                             _Base      : L_PRoll.tSum;
                             _ExcBaseArr: tInBaseArr);
  VAR
   ofcAcCut,
   monAcCut,
   feeAcCut   : LIKE(AcCut.AcCut);
   monCostItem,
   feeCostItem,
   ofcCostItem: LIKE(CostItem.CostItem);
   ofcMyPlace : LIKE(MyPlace.MyPlace);
 BEGIN
  IF _Base # 0 THEN
   L_PRoll.DefineMoneyCorrespondence(monAcCut, feeAcCut, ofcAcCut, monCostItem, feeCostItem, ofcCostItem, ofcMyPlace);
   IF !trgAcCut THEN
    trgAcCut:=monAcCut;
   END;
   IF !trgXObject THEN
    trgXObject:=ps_GetCostItemXObject(monCostItem);
   END;
   IF (monAcCut = feeAcCut) & (monCostItem = feeCostItem) THEN
    PutPartOfSingle(P, Source, _InSign, trgXObject, monAcCut, ofcCostItem, ofcAcCut, _Base, _Base, _ExcBaseArr, ofcMyPlace);
   ELSE
    PutPartOfSingle(P, Source, _InSign, trgXObject, monAcCut, ofcCostItem, ofcAcCut,     0, _Base, _ExcBaseArr, ofcMyPlace);
    PutPartOfSingle(P, Source, _InSign, ps_GetCostItemXObject(feeCostItem),
                                                    feeAcCut, ofcCostItem, ofcAcCut, _Base,     0, _ExcBaseArr, ofcMyPlace);
   END;
  END;
 END {PutSingle};

 PUBLIC PROCEDURE ManAgeGroup(P: DATE): tManAgeGroup;
 BEGIN
  IF L_DatTim.YEAR(Man.Birth) <= 1966 THEN
   RETURN mag_Old;
  ELSE
   RETURN mag_Ave;
  END;
 END {ManAgeGroup};

 PUBLIC PROCEDURE GetOvrQuota(P: DATE): NUMERIC[2];
 BEGIN
  IF    P >= 01\01\2014 THEN
   RETURN 624000;
  ELSIF P >= 01\01\2013 THEN
   RETURN 568000;
  ELSIF P >= 01\01\2012 THEN
   RETURN 512000;
  ELSIF P >= 01\01\2011 THEN
   RETURN 463000;
  ELSIF P >= TheStartingPoint THEN
   RETURN 415000;
  END;
 END {GetOvrQuota};

 PRIVATE PROCEDURE TaxSinglePart(P       : DATE;
                                 Part    : tPart;
                                 Rate    : tRate;
                                 Base,
                                 Fee,
                                 OvrPrt  : NUMERIC[2];
                                 curType : LIKE(ManSFee.Type)): NUMERIC[2];

  VAR
   forProperRound,
   ToTax          : NUMERIC[2];
   Prc            : NUMERIC[1];
 BEGIN
  IF (P >= TheStartingPoint) THEN
   ToTax:=Base;
   IF IsPFAddPart(Part) THEN
    IF    P >= 01\01\2015 THEN
     IF    Part = p_PFA1   THEN Prc:=9;
     ELSIF Part = p_PFA2   THEN Prc:=6;
     ELSIF Part = p_PFA3_1 THEN Prc:=2;
     ELSIF Part = p_PFA3_2 THEN Prc:=4;
     ELSIF Part = p_PFA3_3 THEN Prc:=6;
     ELSIF Part = p_PFA3_4 THEN Prc:=7;
     ELSIF Part = p_PFA4_0 THEN Prc:=8;
     ELSE
      L_General.CallUs(0);
     END;
    ELSIF P >= 01\01\2014 THEN
     IF    Part = p_PFA1   THEN Prc:=6;
     ELSIF Part = p_PFA2   THEN Prc:=4;
     ELSIF Part = p_PFA3_1 THEN Prc:=2;
     ELSIF Part = p_PFA3_2 THEN Prc:=4;
     ELSIF Part = p_PFA3_3 THEN Prc:=6;
     ELSIF Part = p_PFA3_4 THEN Prc:=7;
     ELSIF Part = p_PFA4_0 THEN Prc:=8;
     ELSE
      L_General.CallUs(0);
     END;
    ELSIF P >= 01\01\2013 THEN
     IF    Part = p_PFA1 THEN Prc:=4.0;
     ELSIF Part = p_PFA2 THEN Prc:=2.0;
     ELSE
      RETURN 0.0;
     END;
    ELSE
     RETURN 0.0;
    END;
   ELSE
    IF Rate = r_Normal THEN
     IF    P >= 01\01\2017 THEN
      L_General.Error(" ঠ  , 騥  2017 ");
     ELSIF P >= 01\01\2014 THEN
      IF    Part = p_PFIn THEN Prc:=22.0;
      ELSIF Part = p_PFAc THEN Prc:= 0.0;
      ELSIF Part = p_xFSS THEN Prc:= 2.9;
      ELSIF Part = p_MSFF THEN Prc:= 5.1;
      ELSIF Part = p_MSTF THEN Prc:= 0.0;
      ELSIF Part = p_PFOv THEN Prc:=10.0; ToTax:=OvrPrt;
      END;
     ELSIF P >= 01\01\2012 THEN
      IF    Part = p_PFIn THEN
       IF    ManAgeGroup(P) = mag_Old THEN Prc:=22.0;
       ELSE                                Prc:=16.0;
       END;
      ELSIF Part = p_PFAc THEN
       IF    ManAgeGroup(P) = mag_Old THEN Prc:=0.0;
       ELSE                                Prc:=6.0;
       END;
      ELSIF Part = p_xFSS THEN Prc:= 2.9;
      ELSIF Part = p_MSFF THEN Prc:= 5.1;
      ELSIF Part = p_MSTF THEN Prc:= 0.0;
      ELSIF Part = p_PFOv THEN Prc:=10.0; ToTax:=OvrPrt;
      END;
     ELSIF P >= 01\01\2011 THEN
      IF    Part = p_PFIn THEN
       IF ManAgeGroup(P) = mag_Old THEN Prc:=26.0;
       ELSE                             Prc:=20.0;
       END;
      ELSIF Part = p_PFAc THEN
       IF ManAgeGroup(P) = mag_Old THEN Prc:= 0.0;
       ELSE                             Prc:= 6.0;
       END;
      ELSIF Part = p_xFSS THEN Prc:=2.9;
      ELSIF Part = p_MSFF THEN Prc:=3.1;
      ELSIF Part = p_MSTF THEN Prc:=2.0;
      ELSIF Part = p_PFOv THEN Prc:=0.0;
      END;
     ELSE
      IF    Part = p_PFIn THEN
       IF ManAgeGroup(P) = mag_Old THEN Prc:=20.0;
       ELSE                             Prc:=14.0;
       END;
      ELSIF Part = p_PFAc THEN
       IF ManAgeGroup(P) = mag_Old THEN Prc:= 0.0;
       ELSE                             Prc:= 6.0;
       END;
      ELSIF Part = p_xFSS THEN Prc:=2.9;
      ELSIF Part = p_MSFF THEN Prc:=1.1;
      ELSIF Part = p_MSTF THEN Prc:=2.0;
      ELSIF Part = p_PFOv THEN Prc:=0.0;
      END;
     END;
    ELSIF Rate = r_USNO_2011 THEN
     L_General.CallUs(P >= 01\01\2011);
     IF    P >= 01\01\2019 THEN
      L_General.Error(" ঠ  , 騥  2019 ");
     ELSIF P >= 01\01\2014 THEN
      IF    Part = p_PFIn THEN Prc:=20.0;
      ELSIF Part = p_PFAc THEN Prc:= 0.0;
      ELSIF Part = p_xFSS THEN Prc:= 0.0;
      ELSIF Part = p_MSFF THEN Prc:= 0.0;
      ELSIF Part = p_MSTF THEN Prc:= 0.0;
      ELSIF Part = p_PFOv THEN Prc:= 0.0;
      END;
     ELSIF P >= 01\01\2012 THEN
      IF    Part = p_PFIn THEN
       IF ManAgeGroup(P) = mag_Old THEN Prc:=20.0;
       ELSE                             Prc:=14.0;
       END;
      ELSIF Part = p_PFAc THEN
       IF ManAgeGroup(P) = mag_Old THEN Prc:= 0.0;
       ELSE                             Prc:= 6.0;
       END;
      ELSIF Part = p_xFSS THEN Prc:=0.0;
      ELSIF Part = p_MSFF THEN Prc:=0.0;
      ELSIF Part = p_MSTF THEN Prc:=0.0;
      ELSIF Part = p_PFOv THEN Prc:=0.0;
      END;
     ELSE
      IF    Part = p_PFIn THEN
       IF ManAgeGroup(P) = mag_Old THEN Prc:=18.0;
       ELSE                             Prc:=12.0;
       END;
      ELSIF Part = p_PFAc THEN
       IF ManAgeGroup(P) = mag_Old THEN Prc:= 0.0;
       ELSE                             Prc:= 6.0;
       END;
      ELSIF Part = p_xFSS THEN Prc:=2.9;
      ELSIF Part = p_MSFF THEN Prc:=3.1;
      ELSIF Part = p_MSTF THEN Prc:=2.0;
      ELSIF Part = p_PFOv THEN Prc:=0.0;
      END;
     END;
    ELSIF Rate = r_woCtzn_wPF THEN
     L_General.CallUs(P >= 01\01\2012);
     IF    P >= 01\01\2017 THEN
      L_General.Error(" ঠ  , 騥  2017 ");
     ELSIF P >= 01\01\2012 THEN
      IF    Part = p_PFIn THEN Prc:=22.0;
      ELSIF Part = p_PFAc THEN Prc:= 0.0;
      ELSIF Part = p_xFSS THEN Prc:= 2.9;
      ELSIF Part = p_MSFF THEN Prc:= 5.1;
      ELSIF Part = p_MSTF THEN Prc:= 0.0;
      ELSIF Part = p_PFOv THEN Prc:=10.0; ToTax:=OvrPrt;
      END;
     END;
    ELSE
     IF    P >= 01\01\2015 THEN
      L_General.Error(" ঠ  , 騥  2015 ");
     ELSIF P >= 01\01\2014 THEN
      IF    Part = p_PFIn THEN Prc:=21.0;
      ELSIF Part = p_PFAc THEN Prc:= 0.0;
      ELSIF Part = p_xFSS THEN Prc:= 2.4;
      ELSIF Part = p_MSFF THEN Prc:= 3.7;
      ELSIF Part = p_MSTF THEN Prc:= 0.0;
      ELSIF Part = p_PFOv THEN Prc:= 0.0;
      END;
     ELSIF P >= 01\01\2011 THEN
      IF    Part = p_PFIn THEN
       IF P >= 01\01\2013 THEN
        IF ManAgeGroup(P) = mag_Old THEN Prc:=21.0;
        ELSE                             Prc:=15.0;
        END;
       ELSE
        IF ManAgeGroup(P) = mag_Old THEN Prc:=16.0;
        ELSE                             Prc:=10.0;
        END;
       END;
      ELSIF Part = p_PFAc THEN
       IF P >= 01\01\2013 THEN
        IF ManAgeGroup(P) = mag_Old THEN Prc:= 0.0;
        ELSE                             Prc:= 6.0;
        END;
       ELSE
        IF ManAgeGroup(P) = mag_Old THEN Prc:= 0.0;
        ELSE                             Prc:= 6.0;
        END;
       END;
      ELSIF Part = p_xFSS THEN
       IF    P >= 01\01\2013 THEN Prc:=2.4;
       ELSE                       Prc:=1.9;
       END;
      ELSIF Part = p_MSFF THEN
       IF    P >= 01\01\2013 THEN Prc:=3.7;
       ELSIF P >= 01\01\2012 THEN Prc:=2.3;
       ELSE                       Prc:=1.1;
       END;
      ELSIF Part = p_MSTF THEN
       IF    P >= 01\01\2012 THEN Prc:=0.0;
       ELSE                       Prc:=1.2;
       END;
      ELSIF Part = p_PFOv THEN
       Prc:=0.0;
      END;
     ELSE
      IF    Part = p_PFIn THEN
       IF ManAgeGroup(P) = mag_Old THEN Prc:=14.0;
       ELSE                             Prc:= 8.0;
       END;
      ELSIF Part = p_PFAc THEN
       IF ManAgeGroup(P) = mag_Old THEN Prc:= 0.0;
       ELSE                             Prc:= 6.0;
       END;
      ELSIF Part = p_xFSS THEN Prc:=0.0;
      ELSIF Part = p_MSFF THEN Prc:=0.0;
      ELSIF Part = p_MSTF THEN Prc:=0.0;
      ELSIF Part = p_PFOv THEN Prc:=0.0;
      END;
     END;
    END; (* IF Rate ... *)
   END;
  ELSE
   L_General.Error("᫥ 客 ᮢ ந  " + L_DatTim.PeriodStr(TheStartingPoint));
  END; (* IF P ... *)
  forProperRound:=ToTax * Prc / 100;
  RETURN forProperRound - Fee;
 END {TaxSinglePart};

 PUBLIC PROCEDURE GetCurrentSinglePartBase(p: tPart): NUMERIC[2];
 BEGIN
  RETURN ManSFee.Object-ManSFee.ExcCmn-ManSFee.ExcPrt[p2b(p)]-ManSFee.OvrPrt[p2b(p)];
 END {GetCurrentSinglePartBase};

 PRIVATE PROCEDURE TaxIt(P: DATE; trgMyFirm: P_Firm.tMyFirm; Rate: tRate; curType: LIKE(ManSFee.Type));
  VAR
   totOvrPrt,
   totBase,
   totFee,
   curFee  : tValues;
   putCur  : SCAL[2];
   i       : NUMERIC[0];
 BEGIN
  SETZERO(totBase, totFee, totOvrPrt);
  SELECT(ManSFee, MyFirm, , trgMyFirm, Man.Man, 1);
  SRCINSEL(ManSFee, GE, , L_DatTim.YearBeg(P));
  WHILE OCCURE(ManSFee) & (ManSFee.Period <= P) DO
   IF t2r(ManSFee.Type, ManSFee.Period) = Rate THEN
    i:=0;
    WHILE i < p_Amount DO
     INC(totBase[i],   GetCurrentSinglePartBase(i));
     INC(totFee[i],    ManSFee.Fee[i]);
     INC(totOvrPrt[i], ManSFee.OvrPrt[p2b(i)]);
     INC(i);
    END;
   END;
   NEXT(ManSFee);
  END; (* WHILE OCCURE(ManSFee) ... *)
  putCur:=0;
  i:=0;
  WHILE i < p_Amount DO
   curFee[i]:=TaxSinglePart(P, i, Rate, totBase[i], totFee[i], totOvrPrt[i], curType);
   putCur:=putCur | (curFee[i] # 0);
   INC(i);
  END;
  IF putCur THEN
   SELECT(ManSFee, MyFirm, , trgMyFirm, Man.Man, 1, P);
   L_General.CallUs(t2r(ManSFee.Type, ManSFee.Period) = Rate);
   ManSFee.Fee:=curFee;
   REPLACE(ManSFee);
  END;
 END {TaxIt};

 PRIVATE PROCEDURE PrepareReferenceData(P: DATE; trgMyFirm: P_Firm.tMyFirm);
 BEGIN
  APP.Get().NewPrompt("⮢");
  IF (P # rd_Period) | (trgMyFirm # rd_MyFirm) THEN
   SETEMPTY(rd_A2SF);
   SELECT(MCList, MCode);
   WHILE OCCURE(MCList) DO
    PROMPT("  " + MCList.MCode);
    IF (P >= MCList.Begin) & (MCList.Till > TheStartingPoint) THEN
     rd_A2SF[MCList.MCode]:=P_MCList.a2sf_Attitude(MCList.MCode, P);
     IF MCList.MCTyp = L_PRoll.mct_Debit THEN
      L_General.Assert(rd_A2SF[MCList.MCode]=P_MCList.a2sf_NotObject, "ঠ   室    ᫥ 客 ᮢ");
     END;
     IF rd_A2SF[MCList.MCode] = P_MCList.a2sf_LimitedTaxable THEN
      rd_A2SF[MCList.MCode]:=P_MCList.a2sf_Taxable;
     END;
    END;
    NEXT(MCList);
   END; (* WHILE OCCURE(MCList) ... *)
   IF !DATABASE.Get().Tables("L_SFee_M") THEN
    L_AFM.MakeMultipleIndex("L_SFee_M", "MyFirm     : "+TYPENAMEOF(P_Firm.tMyFirm)   +";"+
                                        "Man        : "+TYPENAMEOF(Man.Man)          +";"+
                                        "TSN        : "+TYPENAMEOF(Staff.TSN)        +";"+
                                        "ODate      : "+TYPENAMEOF(StaffLog.Date)    +";"+
                                        "Period     : "+TYPENAMEOF(DATE)             +";"+
                                        "InSign     : "+TYPENAMEOF(P_MCList.tAttitude2SFee)+";"+
                                        "MCode      : "+TYPENAMEOF(MCList.MCode)     +";"+
                                        "AcCut      : "+TYPENAMEOF(AcCut.AcCut)      +";"+
                                        "XObject    : "+TYPENAMEOF(XObject.XObject)  +";"+
                                        "Closed     : "+TYPENAMEOF(DATE)             +";"+
                                        "Source     : "+TYPENAMEOF(tSource)          +";"+
                                        "ofcCostItem: "+TYPENAMEOF(CostItem.CostItem)+";"+
                                        "ofcAcCut   : "+TYPENAMEOF(AcCut.AcCut)      +";"+
                                        "Sum        : "+TYPENAMEOF(L_PRoll.tSum)     +";"+
                                        "asSum      : "+TYPENAMEOF(L_PRoll.tSum)     +";"+
                                        "Base       : "+TYPENAMEOF(ManSFee.Fee)      +";"+
                                        "Fee        : "+TYPENAMEOF(ManSFee.Fee)      +";"+
                                        "MyPlace    : "+TYPENAMEOF(MyPlace.MyPlace)  +";",
                              "MyFirm: MyFirm, Man, Period, InSign, MCode, AcCut, XObject, Closed, ofcAcCut, ofcCostItem, Source, MyPlace, TSN, ODate;"+
                              "toSort: MyFirm, Man, Period, InSign, Sum");
   END;
   rd_Period:=P;
   rd_MyFirm:=trgMyFirm;
  END;
 END {PrepareReferenceData};

 PUBLIC PROCEDURE SFeeIsCalculatedInProperConsecution(P: DATE): SCAL[2];
 BEGIN
  RETURN L_iga.ActionHasProperPredecessor(L_iga.a_CalculateSFee, L_iga.a_CloseMonth_Salary, P);
 END {SFeeIsCalculatedInProperConsecution};

 PRIVATE PROCEDURE SpreadSingle(P: DATE; trgMyFirm: P_Firm.tMyFirm);
  VAR
   curBase,
   curRst,
   curFee  : tValues;
   tstSum  : NUMERIC[2];
   i       : NUMERIC[0];
 BEGIN
  IF SELECT(L_SFee_M, MyFirm, trgMyFirm, Man.Man, P, P_MCList.a2sf_Taxable) THEN
   IF SELECT(ManSFee, MyFirm, trgMyFirm, Man.Man, 1, P) THEN
    i:=0;
    WHILE i < p_Amount DO
     curBase[i]:=GetCurrentSinglePartBase(i) + ManSFee.OvrPrt[p2b(i)];
     curFee[i] :=ManSFee.Fee[i];
     INC(i);
    END;
   ELSE
    SETZERO(curBase, curFee);
    tstSum:=0;
    WHILE OCCURE(L_SFee_M) DO
     INC(tstSum, L_SFee_M.Sum);
     NEXT(L_SFee_M);
    END;
    IF tstSum # 0 THEN
     IF ~SFeeIsCalculatedInProperConsecution(P) THEN
      L_General.Error(" 믮    " + L_DatTim.PeriodStr(P));
     ELSE
      L_General.CallUs(0);
     END;
    END;
   END;
   curRst:=curFee;
   WHILE OCCURE(L_SFee_M) DO
    i:=0;
    WHILE i < p_Amount DO
     IF curBase[i] # 0 THEN
      L_SFee_M.Fee[i]:=L_SFee_M.Base[p2b(i)]/curBase[i] * curFee[i];
      DEC(curRst[i], L_SFee_M.Fee[i]);
     ELSE
      L_General.CallUs(curFee[i] = 0);
      L_SFee_M.Fee[i]:=0;
     END;
     INC(i);
    END; (* WHILE i < ... *)
    REPLACE(L_SFee_M);
    NEXT(L_SFee_M);
   END; (* WHILE OCCURE(L_SFee_M) *)
   i:=0;
   WHILE i < p_Amount DO
    IF curRst[i] # 0 THEN
     SELECT(L_SFee_M, toSort, , trgMyFirm, Man.Man, P, P_MCList.a2sf_Taxable);
     LAST(L_SFee_M);
     LOOP
      IF ~OCCURE(L_SFee_M) THEN
       L_General.Error(", ॡ    " + L_DatTim.PeriodStr(P) + ",  " + Man.Man);
      ELSIF L_SFee_M.Base[p2b(i)] # 0 THEN
       INC(L_SFee_M.Fee[i], curRst[i]);
       REPLACE(L_SFee_M);
       EXIT;
      END;
      PREV(L_SFee_M);
     END; (* LOOP *)
    END; (* IF curRst[i] # 0 *)
    INC(i);
   END; (* WHILE i < ... *)
  END; (* IF SELECT(L_SFee_M ... *)
 END {SpreadSingle};

 PRIVATE PROCEDURE getCurBase_woOvrQuota(p: tPart): NUMERIC[2];
 BEGIN
  RETURN ManSFee.Object-ManSFee.ExcCmn-ManSFee.ExcPrt[p2b(p)];
 END {getCurBase_woOvrQuota};

 PUBLIC PROCEDURE E_IsRealContractorsAgreement(P: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=1;
  IF (L_General.GetAPSiteID() = "SP") & (P >= 01\07\2010) THEN
   Result:=0;
  END;
  RETURN Result;
 END {E_IsRealContractorsAgreement};

 PRIVATE PROCEDURE GetPFAGr(curP: DATE): tPFAGroup;
  VAR
   curDirtyTyp         : LIKE(DirtyTyp.DirtyTyp);
   curSpecialEvaluation: P_Officer.tSpecialEvaluation;
 BEGIN
  IF curP >= 01\01\2014 THEN
   P_Officer.GetP_LabourConditions(Officer.Sort, Officer.Officer, L_DatTim.MonthEnd(curP), curDirtyTyp, curSpecialEvaluation);
   IF !curDirtyTyp THEN
    RETURN pfagr_PnsAttr;
   ELSE
    IF ~curSpecialEvaluation & (curP > 31\12\2018) THEN
     RETURN pfagr_PnsAttr;
    ELSE
     L_General.CallUs(SEARCH(DirtyTyp, DirtyTyp, curDirtyTyp));
     IF    (DirtyTyp.Power = L_Staff.dtpwr_Optimal) | (DirtyTyp.Power = L_Staff.dtpwr_Acceptable) THEN
      IF curSpecialEvaluation THEN
       RETURN pfagr_DirtyNon;
      ELSE
       RETURN pfagr_PnsAttr;
      END;
     ELSIF DirtyTyp.Power = L_Staff.dtpwr_Harmful1 THEN
      RETURN pfagr_Dirty3_1;
     ELSIF DirtyTyp.Power = L_Staff.dtpwr_Harmful2 THEN
      RETURN pfagr_Dirty3_2;
     ELSIF DirtyTyp.Power = L_Staff.dtpwr_Harmful3 THEN
      RETURN pfagr_Dirty3_3;
     ELSIF DirtyTyp.Power = L_Staff.dtpwr_Harmful4 THEN
      RETURN pfagr_Dirty3_4;
     ELSIF DirtyTyp.Power = L_Staff.dtpwr_Dangerous THEN
      RETURN pfagr_Dirty4;
     ELSE
      L_General.CallUs(0);
     END;
    END;
   END;
  ELSE
   RETURN pfagr_PnsAttr;
  END;
 END {GetPFAGr};

 PUBLIC PROCEDURE GetPnsAttrOnDate(D: DATE): LIKE(PnsAttr.PnsAttr);
  VAR
   Result: LIKE(PnsAttr.PnsAttr);
 BEGIN
  Result:=P_Staff.GetP_SpecificForPF(Staff.TSN, D);
  IF !Result THEN
   Result:=Officer.PnsAttr;
  END;
  RETURN Result;
 END {GetPnsAttrOnDate};

 PRIVATE PROCEDURE GetbPFAbyPnsAttr(curP: DATE): tBase;
  VAR
   curPnsAttr: LIKE(PnsAttr.PnsAttr);
 BEGIN
  CONFORM(StaffLog, Officer);
  curPnsAttr:=GetPnsAttrOnDate(Math.Min(StaffLog.DateE, L_DatTim.MonthEnd(curP)));
  IF curPnsAttr # L_Packet.OrdinaryPnsAttr THEN
   SEARCH(PnsAttr, PnsAttr, , curPnsAttr);
   IF L_Str.AnyItem(PnsAttr.Str2002, ";", 0) = "27-1" THEN
    RETURN b_PA1;
   ELSE
    RETURN b_PA2;
   END;
  ELSE
   RETURN EMPTYOF(tBase);
  END;
 END {GetbPFAbyPnsAttr};

 PUBLIC PROCEDURE GetPFA_ReasonCode(): tPFAReasonCode;
  VAR
   Result  : tPFAReasonCode;
   curBase : tBase;
   curP    : DATE;
 BEGIN
  curP:=ManSFee.Period;
  IF    ManSFee.Fee[p_PFA1] # 0 THEN
   RETURN pfarc_1;
  ELSIF ManSFee.Fee[p_PFA2] # 0 THEN
   RETURN pfarc_2;
  ELSE
   Result:=pfarc_None;
   IF (ManSFee.Fee[p_PFA3_1] # 0) | (ManSFee.Fee[p_PFA3_2] # 0) | (ManSFee.Fee[p_PFA3_3] # 0) | (ManSFee.Fee[p_PFA3_4] # 0) | (ManSFee.Fee[p_PFA4_0] # 0)  THEN
    TRY [RESTORE_CURSORS(RC_ON)]
     SELECT(Staff, Man, , ManSFee.Man);
     WHILE OCCURE(Staff) DO
      SETSEL(StaffLog, TSN, Staff.TSN);
      SRCINSEL(StaffLog, LE, , L_DatTim.MonthEnd(curP));
      WHILE (Result=pfarc_None) & OCCURE(StaffLog) DO
       IF ~L_Staff.IsDischargeStaffLog() THEN
        curBase:=GetbPFAbyPnsAttr(curP);
        IF    curBase = b_PA1 THEN Result:=pfarc_1;
        ELSIF curBase = b_PA2 THEN Result:=pfarc_2;
        END;
       END;
       PREV(StaffLog);
      END;
      NEXT(Staff);
     END; (* WHILE OCCURE(Staff) ... *)
    EXCEPT
    END; (* TRY *)
    L_General.Assert(Result # pfarc_None, " "+ManSFee.Man+":  "+L_DatTim.PeriodStr(curP)+":  ,      '।'");
   END;
  END;
  RETURN Result;
 END {GetPFA_ReasonCode};

 PRIVATE PROCEDURE GetbPFA(curP, curODate: DATE): tBase;
  VAR
   curPFAGr  : tPFAGroup;
   Result    : tBase;
 BEGIN
  L_Staff.PosToStaffLog(Staff.TSN, curODate, 1);
  Result:=GetbPFAbyPnsAttr(curP);
  IF (curP >= 01\01\2014) & ((Result = b_PA1) | (Result = b_PA2)) THEN
   curPFAGr:=GetPFAGr(curP);
   IF    curPFAGr = pfagr_DirtyNon THEN
    Result:=EMPTYOF(tBase);
   ELSIF curPFAGr = pfagr_Dirty3_1 THEN
    Result:=b_PA3_1;
   ELSIF curPFAGr = pfagr_Dirty3_2 THEN
    Result:=b_PA3_2;
   ELSIF curPFAGr = pfagr_Dirty3_3 THEN
    Result:=b_PA3_3;
   ELSIF curPFAGr = pfagr_Dirty3_4 THEN
    Result:=b_PA3_4;
   ELSIF curPFAGr = pfagr_Dirty4 THEN
    Result:=b_PA4_0;
   END;
  END;
  RETURN Result;
 END {GetbPFA};

 PRIVATE PROCEDURE ProceedSum(    P        : DATE;
                                  gm       : tGatherMode;
                                  Source   : tSource;
                                  curType  : tType;
                                  a2sf     : P_MCList.tAttitude2SFee;
                                  Sum      : NUMERIC[2];
                                  curODate : DATE;
                              VAR curObject: LIKE(ManSFee.Object);
                              VAR curExcCmn: LIKE(ManSFee.ExcCmn);
                              VAR curExcPrt: LIKE(ManSFee.ExcPrt));
  VAR
   ExcBaseArr: tInBaseArr;
   Sign      : NUMERIC[0];
   urbPFA   : tBase;
 BEGIN
  SETZERO(ExcBaseArr);
  IF Source = s_Minus THEN Sign:=-1;
  ELSE                     Sign:=+1;
  END;
  IF a2sf > P_MCList.a2sf_NotObject THEN
   INC(curObject, Sign*Sum);
   IF (a2sf = P_MCList.a2sf_NotTaxable) | (curType = t_woCtzn) THEN
    INC(curExcCmn, Sign*Sum);
   ELSE
    IF    curType = t_woCtzn_Commorancy THEN
     INC(curExcPrt[b_FSS], Sign*Sum);
     ExcBaseArr[b_FSS]:=1;
     INC(curExcPrt[b_MSF], Sign*Sum);
     ExcBaseArr[b_MSF]:=1;
    ELSIF (Staff.Contract = L_Staff.cnt_ContractorsAgreement) & E_IsRealContractorsAgreement(P) THEN
     INC(curExcPrt[b_FSS], Sign*Sum);
     ExcBaseArr[b_FSS]:=1;
    END; (* IF    curType ... *)
    IF P >= 01\01\2013 THEN
     urbPFA:=GetbPFA(P, curODate);
     IF urbPFA # b_PA1 THEN
      INC(curExcPrt[b_PA1], Sign*Sum);
      ExcBaseArr[b_PA1]:=1;
     END;
     IF urbPFA # b_PA2 THEN
      INC(curExcPrt[b_PA2], Sign*Sum);
      ExcBaseArr[b_PA2]:=1;
     END;
     IF urbPFA # b_PA3_1 THEN
      INC(curExcPrt[b_PA3_1], Sign*Sum);
      ExcBaseArr[b_PA3_1]:=1;
     END;
     IF urbPFA # b_PA3_2 THEN
      INC(curExcPrt[b_PA3_2], Sign*Sum);
      ExcBaseArr[b_PA3_2]:=1;
     END;
     IF urbPFA # b_PA3_3 THEN
      INC(curExcPrt[b_PA3_3], Sign*Sum);
      ExcBaseArr[b_PA3_3]:=1;
     END;
     IF urbPFA # b_PA3_4 THEN
      INC(curExcPrt[b_PA3_4], Sign*Sum);
      ExcBaseArr[b_PA3_4]:=1;
     END;
     IF urbPFA # b_PA4_0 THEN
      INC(curExcPrt[b_PA4_0], Sign*Sum);
      ExcBaseArr[b_PA4_0]:=1;
     END;
    END;
   END; (*IF a2sf = P_MCList.a2sf_NotTaxable*)
  END; (* IF a2sf > P_MCList.a2sf_NotObject *)
  IF gm = gm_Spread THEN
   CONFORM(Money, MCList);
   IF Money.WFPeriod >= L_PRoll.E_DoSecondSide() THEN
    SETSEL(MoneyDst, MoneyDst, Money.RECORDID);
    FOR_EACH MoneyDst DO
     PutSingle(P, Source, a2sf, MoneyDst.XObject, MoneyDst.AcCut, Sign*MoneyDst.Sum, ExcBaseArr);
    END; (* FOR_EACH MoneyDst *)
   ELSE
    PutSingle(P, Source, a2sf, "", "", Sign*Sum, ExcBaseArr);
   END;
  END; (* IF gm = gm_Spread *)
 END {ProceedSum};

 PRIVATE PROCEDURE ProceedSingleMoney(    P        : DATE;
                                          gm       : tGatherMode;
                                          Source   : tSource;
                                          curType  : tType;
                                      VAR curObject: LIKE(ManSFee.Object);
                                      VAR curExcCmn: LIKE(ManSFee.ExcCmn);
                                      VAR curExcPrt: LIKE(ManSFee.ExcPrt));
 BEGIN
  L_General.Assert(~!rd_A2SF[Money.MCode], "⭨ " + Money.TSN + ": ᫥   (" + Money.MCode + "),     " + L_DatTim.PeriodStr(Money.Closed));
  ProceedSum(P, gm, Source, curType, rd_A2SF[Money.MCode], Money.Sum, Money.ODate, curObject, curExcCmn, curExcPrt);
 END {ProceedSingleMoney};

 PRIVATE PROCEDURE GetManFeatures(P: DATE; trgMyFirm: P_Firm.tMyFirm; VAR curType: tType; VAR curRate: tRate);
 BEGIN
  curType:=DefineType(trgMyFirm, Man.Man, P);
  curRate:=t2r(curType, P);
 END {GetManFeatures};

 PUBLIC PROCEDURE GetTableRecordAsStr(t: TABLE; Exclusions: STRING[]): STRING[];
  VAR
   f     : FIELD;
   i, r  : NUMERIC[0];
   Result: STRING[];
 BEGIN
  Result:="";
  FOR_EACH f IN t.Fields DO
   IF !L_Str.PositionInPool(Exclusions, f.Name) THEN
    r:=GET_TYPE_SPEC(^(f.ObtainName())).Range;
    i:=0;
    WHILE i < r DO
     INC(Result, FLDTOSTR(^(f.ObtainName(i))) + "|");
     INC(i);
    END; (* WHILE i < r...*)
   END;
  END;
  RETURN Result;
 END {GetTableRecordAsStr};

 PUBLIC PROCEDURE GetChangingReason(trgMan: LIKE(Man.Man); trgMyFirm: P_Firm.tMyFirm; P: DATE): LIKE(eMoney.SubType);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SELECT(Staff, MyFirm, , trgMyFirm, trgMan);
   WHILE OCCURE(Staff) DO
    SELECT(Money, TSN, , Staff.TSN, P);
    WHILE OCCURE(Money) DO
     IF SEARCH(eMoney, ori, Money.RECORDID, L_PRoll.et_ManSFee) & (eMoney.SubType = L_PRoll.est_byAudit) THEN
      RETURN L_PRoll.est_byAudit;
     END;
     NEXT(Money);
    END; (* WHILE OCCURE(Money) ... *)
    SELECT(eMoney, TSN, , Staff.TSN, L_PRoll.et_ManSFee, P);
    WHILE OCCURE(eMoney) DO
     IF eMoney.SubType = L_PRoll.est_byAudit THEN
      RETURN L_PRoll.est_byAudit;
     END;
     NEXT(eMoney);
    END; (* WHILE OCCURE(eMoney) ... *)
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
  EXCEPT
  END; (* TRY *)
  RETURN L_PRoll.est_byMyself;
 END {GetChangingReason};

(*
$P{ Line:
Man.Man, L, ""
?, L, "N.y"
?, L, ""
?, L, ""
?, L, ""
@
|######|#######|##########|################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################
                          |################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################################

}
*)

 PRIVATE PROCEDURE PrepareSingleMan(P: DATE; trgMyFirm: P_Firm.tMyFirm; gm: tGatherMode; trg_ri_iga: LIKE(iga.RECORDID));
  CONST
   NoChanges = "᪫祭  ⪠ ⠢ ManSFee  ⢨   ";
  VAR
   curType     : tType;
   curRate     : tRate;
   curObject   : LIKE(ManSFee.Object);
   curExcCmn   : LIKE(ManSFee.ExcCmn);
   curExcPrt   : LIKE(ManSFee.ExcPrt);

   prvBase,
   prvOvr      : tValues;
   tmpValue    : NUMERIC[2];
   i           : NUMERIC[0];
   hasExtension: SCAL[2];
   prv_ri_iga  : LIKE(ManSFee.ri_iga);
   curTRS,
   prvTRS      : STRING[];
 BEGIN
  APP.Get().NewPrompt(": " + FLDTOSTR(Man.Man, "", 5));
  IF SELECT(Staff, MyFirm, trgMyFirm, Man.Man) THEN
   SETZERO(curObject, curExcCmn, curExcPrt);
   SETEMPTY(curType, curRate);
   WHILE OCCURE(Staff) DO
    hasExtension:=SELECT(eMoney, TSN, Staff.TSN);
    SETSEL(Money, TSN, Staff.TSN, P);
    FOR_EACH Money DO
     IF !curType & L_Staff.IsBegan(P) THEN
      GetManFeatures(P, trgMyFirm, curType, curRate);
     END;
     ProceedSingleMoney(P, gm, s_Money, curType, curObject, curExcCmn, curExcPrt);
     IF hasExtension & SEARCH(eMoney, ori, Money.RECORDID, L_PRoll.et_ManSFee) & (eMoney.ClcPer # Money.Closed) THEN
      ProceedSingleMoney(P, gm, s_Minus, curType, curObject, curExcCmn, curExcPrt);
     END;
    END; (* FOR_EACH Money *)
    IF hasExtension & SELECT(eMoney, TSN, Staff.TSN, L_PRoll.et_ManSFee, P) THEN
     WHILE OCCURE(eMoney) DO
      IF !curType & L_Staff.IsBegan(P) THEN
       GetManFeatures(P, trgMyFirm, curType, curRate);
      END;
      SEARCH(Money, RECORDID, , eMoney.ori);
      IF eMoney.ClcPer # Money.Closed THEN
       ProceedSingleMoney(P, gm, s_Plus, curType, curObject, curExcCmn, curExcPrt);
      END;
      NEXT(eMoney);
     END; (* WHILE OCCURE(eMoney) ... *)
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) *)
   IF gm = gm_Calculate THEN
    TRY
     SETEMPTY(prvTRS);
     IF SELECT(ManSFee, MyFirm, trgMyFirm, Man.Man, 1, P) THEN
      IF ~!ManSFee.ri_iga THEN
       IF ~!trg_ri_iga THEN
        prv_ri_iga:=ManSFee.ri_iga;
        ManSFee.Actual:=0;
        REPLACE(ManSFee);
        prvTRS:=GetTableRecordAsStr(TABLE.Get("ManSFee"), "Actual|ri_iga");
       ELSE
        L_General.Error("   " + L_DatTim.PeriodStr(P) + " ⥯  ⮫쪮  ࠬ 饩 楤");
       END;
      ELSE
       REMOVE(ManSFee);
      END;
     END;
     L_General.CallUs(~SELECT(ManSFee, MyFirm, trgMyFirm, Man.Man, 1, P));
 
     IF (curObject # 0) | (curExcCmn # 0) THEN
      SETZERO(prvBase, prvOvr);
      SELECT(ManSFee, MyFirm, , trgMyFirm, Man.Man, 1);
      SRCINSEL(ManSFee, GE, , L_DatTim.YearBeg(P));
      WHILE OCCURE(ManSFee) & (ManSFee.Period < P) DO
       i:=0;
       WHILE i < p_Amount DO
        INC(prvBase[i], getCurBase_woOvrQuota(i));
        INC(prvOvr[i],  ManSFee.OvrPrt[p2b(i)]);
        INC(i);
       END;
       NEXT(ManSFee);
      END; (* WHILE OCCURE(ManSFee) ... *)
      ManSFee.Man   :=Man.Man;
      ManSFee.MyFirm:=trgMyFirm;
      ManSFee.Period:=P;
      ManSFee.Actual:=1;
      ManSFee.ri_iga:=trg_ri_iga;
      ManSFee.Type  :=curType;
      ManSFee.Object:=curObject;
      ManSFee.ExcCmn:=curExcCmn;
      ManSFee.ExcPrt:=curExcPrt;
      i:=0;
      WHILE i < p_Amount DO
       IF IsPFAddPart(i) THEN
        ManSFee.OvrPrt[p2b(i)]:=0;
       ELSE
        tmpValue:=prvBase[i]+getCurBase_woOvrQuota(i)-GetOvrQuota(P)-prvOvr[i];
        IF prvOvr[i] = 0 THEN
         ManSFee.OvrPrt[p2b(i)]:=Math.Max(0, tmpValue);
        ELSE
         ManSFee.OvrPrt[p2b(i)]:=tmpValue;
        END;
       END;
       INC(i);
      END;
      SETZERO(ManSFee.Fee);
      INSERT(ManSFee);
     END;
     IF ~!curRate THEN
      TaxIt(P, trgMyFirm, curRate, curType);
     END;
     IF ~!prvTRS & SEARCH(ManSFee, MyFirm, trgMyFirm, Man.Man, 1, P, trg_ri_iga) THEN
      curTRS:=GetTableRecordAsStr(TABLE.Get("ManSFee"), "Actual|ri_iga");
      IF curTRS = prvTRS THEN
       RAISE(, NoChanges);
      END; (* IF curTRS = prvTRS *)
     END; (* IF ~!prvTRS ... *)
    EXCEPT
    ON Exc: Exc_Raise DO
     IF Exc.MsgOriginalText # NoChanges THEN
      RAISE();
     END;
    END; (* TRY *)
   ELSE
    SpreadSingle(P, trgMyFirm);
   END;
  END;
 END {PrepareSingleMan};

 PUBLIC PROCEDURE RepealSFee(P: DATE; trgComment: STRING[]);
 BEGIN
  WHILE L_iga.HasAction(L_iga.a_CalculateSFee, P) DO
   L_iga.Repeal(L_iga.a_CalculateSFee, P, trgComment);
   P:=L_DatTim.NextPer(P);
  END; (* WHILE *)
 END {RepealSFee};

 PRIVATE PROCEDURE ChoiceAboutNotFinalResults(Msg: STRING[]);
 BEGIN
  IF OCCURE(bpRT) THEN
   L_StdFrm.CrucialChoice_FileExplicit("bpRT", Msg, L_APtm.g_Acnt);
  ELSE
   L_StdFrm.CrucialChoice(Msg, L_APtm.g_Acnt);
  END;
 END {ChoiceAboutNotFinalResults};

 PUBLIC PROCEDURE PrepareMonthData(P: DATE);
  VAR
   trg_ri_iga : LIKE(iga.RECORDID);
   AlreadyDone: SCAL[2];
 BEGIN
  APP.Get().NewPrompt("   " + L_DatTim.PeriodStr(P));
  IF (P > Math.Max(TheStartingPoint, L_Env.aptm_Start)) & ~L_iga.HasAction(L_iga.a_CalculateSFee, L_DatTim.PrevPer(P)) THEN
   L_General.Error(" 客 ᮢ ᫥ 믮 ᫥⥫쭮.|| 믮   ।騩 ");
  END;
  AlreadyDone:=SFeeIsCalculatedInProperConsecution(P);
  IF L_APtm.MonthIsClosed(P, L_APtm.system_Salary) THEN
   L_iga.Put(L_iga.a_CalculateSFee, P, "");
   trg_ri_iga:=iga.RECORDID;
   IF AlreadyDone THEN (* 㦭 ࠢ쭠   iga.  ஢ 䠪   ⮫쪮    䨪樨*)
    L_StdFrm.CrucialChoice_FileExplicit("iga",
                                        " 客 ᮢ  " + L_DatTim.PeriodStr(P) + " 㦥 믮." +
                                        "||" +
                                        " ࠢ     ⥫⢠, ॡ騥 ?",
                                        L_APtm.g_Acnt);
   END;
   RepealSFee(L_DatTim.NextPer(P), "  " + L_DatTim.PeriodStr(P));
  ELSE
   L_iga.Put(L_iga.a_CalculateSFee, P, "");
   SETEMPTY(trg_ri_iga);
   ChoiceAboutNotFinalResults("   , १    ⥫"+
                              "|  ᯮ짮 ⮫쪮  祭 ।⥫쭮 業."+
                              "|⮏ 㤥 த   ⮬,    ⠭");
  END;
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF MyFirm.MyFirm # P_Firm.mf_Fict THEN
    PrepareReferenceData(P, MyFirm.MyFirm);
    SETSEL(Man, Man);
    FOR_EACH Man DO
     PrepareSingleMan(P, MyFirm.MyFirm, gm_Calculate, trg_ri_iga);
    END; (* FOR_EACH Man *)
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
 END {PrepareMonthData};

 PUBLIC PROCEDURE extPrepareForDistribution(BPer, EPer: DATE; Silent: SCAL[2]; trgMyFirm: LIKE(MyFirm.MyFirm));
  VAR
   P: DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt("⮢   ");
  IF ~Silent THEN
   IF ~SFeeIsCalculatedInProperConsecution(EPer) THEN
    L_General.Assert(L_iga.HasAction(L_iga.a_CalculateSFee, EPer),
                     "ॡ  客 ᮢ  " + L_DatTim.PeriodStr(EPer));
    ChoiceAboutNotFinalResults("     ⥫  " + L_DatTim.PeriodStr(EPer));
   END;
  END; (* IF ~Silent *)

  SETSEL(MyFirm, MyFirm);
  FOR_EACH MyFirm DO
   IF (MyFirm.MyFirm # P_Firm.mf_Fict) & (!trgMyFirm | (MyFirm.MyFirm = trgMyFirm)) THEN
    P:=BPer;
    WHILE P <= EPer DO
     PROMPT(L_DatTim.PeriodStr(P));
     PrepareReferenceData(P, MyFirm.MyFirm);
     SETSEL(Man, Man);
     FOR_EACH Man DO
      PrepareSingleMan(P, MyFirm.MyFirm, gm_Spread, EMPTYOF(iga.RECORDID));
     END; (* FOR_EACH Man *)
     P:=L_DatTim.IncMonth(P, +1);
    END;
   END;
  END; (* FOR_EACH MyFirm *)
 END {extPrepareForDistribution};

 PUBLIC PROCEDURE PrepareForDistribution(BPer, EPer: DATE);
 BEGIN
  extPrepareForDistribution(BPer, EPer, 0, EMPTYOF(MyFirm.MyFirm));
 END {PrepareForDistribution};

 PUBLIC PROCEDURE sfp2Notion(p: tPart): L_APtm.tNotion;
 BEGIN
  IF    p = p_PFIn THEN RETURN L_Cntr.erkn_TAF_PFIn;
  ELSIF p = p_PFAc THEN RETURN L_Cntr.erkn_TAF_PFAc;
  ELSIF p = p_xFSS THEN RETURN L_Cntr.erkn_TAF_xFSS;
  ELSIF p = p_MSFF THEN RETURN L_Cntr.erkn_TAF_MSFF;
  ELSIF p = p_MSTF THEN RETURN L_Cntr.erkn_TAF_MSTF;
  ELSIF p = p_PFOv THEN RETURN L_Cntr.erkn_TAF_PFIn;
  ELSIF p = p_PFA1 THEN RETURN L_Cntr.erkn_TAF_PFA1;
  ELSIF p = p_PFA2 THEN RETURN L_Cntr.erkn_TAF_PFA2;
  END;
 END {sfp2Notion};

 PUBLIC PROCEDURE CalculateSingleMan(P: DATE);
 BEGIN
  L_General.CallUs(ACCESS(Man));
  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF MyFirm.MyFirm # P_Firm.mf_Fict THEN
    PrepareReferenceData(P, MyFirm.MyFirm);
    PrepareSingleMan(P, MyFirm.MyFirm, gm_Calculate, EMPTYOF(iga.RECORDID));
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
 END {CalculateSingleMan};

 PUBLIC PROCEDURE TaxAllPart(P     : DATE;
                             curSum: NUMERIC[2]): NUMERIC[2];
  VAR
   Result   : NUMERIC[2];
   curType  : LIKE(ManSFee.Type);
   curRate  : tRate;
   curObject: LIKE(ManSFee.Object);
   curExcCmn: LIKE(ManSFee.ExcCmn);
   curExcPrt: LIKE(ManSFee.ExcPrt);
   Part     : tPart;
 BEGIN
  CONFORM(Staff, Man);
  Result:=0;
  IF SELECT(ManSFee, MyFirm, Staff.MyFirm, Staff.Man, 1, P) THEN
   curType:=ManSFee.Type;
  ELSE
   curType:=DefineType(Staff.MyFirm, Staff.Man, P);
  END;
  curRate:=t2r(curType, P);
  SETZERO(curObject, curExcCmn, curExcPrt);
  ProceedSum(P, gm_Calculate, s_Plus, curType, P_MCList.a2sf_Taxable, curSum, L_DatTim.MonthEnd(P),
             curObject, curExcCmn, curExcPrt);
  FOR_EACH Part DO
   INC(Result, TaxSinglePart(P, Part, curRate, curObject-curExcCmn-curExcPrt[p2b(Part)], 0, 0, curType));
  END; (* FOR_EACH *)
  RETURN Result;
 END {TaxAllPart};

 PRIVATE PROCEDURE AcceptableForPrepareChanges(ctlEnd: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=1;
  IF ~!ctlEnd THEN
   IF L_General.GetAPSiteNumber() = 26 THEN
    Result:=ctlEnd > 31\03\2013;
   ELSE
    Result:=ctlEnd > 30\06\2013;
   END;
  END;
  RETURN Result;
 END {AcceptableForPrepareChanges};

 PRIVATE PROCEDURE Get_RI_iga(PerB, tilPer: DATE): LIKE(iga.RECORDID);
  VAR
   ctlDTS: TIMESTAMP;
   Result: LIKE(iga.RECORDID);
 BEGIN
  SETEMPTY(Result);
  IF ~!tilPer THEN
   ctlDTS:=L_Packet.GetDonePacketDTS(tilPer);
   SELECT(iga, Action, , L_iga.a_CalculateSFee);
   WHILE OCCURE(iga) & (iga.Period < PerB) & !Result DO
    NARROWSEL(iga, Period);
    SRCINSEL(iga, GE, , ctlDTS);
    WHILE OCCURE(iga) & !Result DO
     IF ~iga.Repeal THEN
      Result:=iga.RECORDID; (* "⨥" ᥣ ᫥⥫쭮 *)
     END;
     NEXT(iga);
    END; (* WHILE OCCURE(iga) *)
    NEXTINEXTENDEDSEL(iga, Period);
   END; (* WHILE OCCURE(iga) *)
  END;
  IF !Result THEN
   Result:=MAXOF(Result);
  END;
  RETURN Result;
 END {Get_RI_iga};

 PRIVATE PROCEDURE IsSingleMansFeeInPeriod(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(ManSFee);
  Result:=~NEXT(ManSFee);
  RESTORE(ManSFee);
  RETURN Result;
 END {IsSingleMansFeeInPeriod};

 PUBLIC PROCEDURE PrepareChanges(trgMyFirm: P_Firm.tMyFirm;
                                 PerB,
                                 Till,
                                 ctlEnd   : DATE);
  VAR
   est       : L_PRoll.tExtensionSubType;
   prvFee    : LIKE(ManSFee.Fee);
   ctlPer    : DATE;
   prv_ri_iga,
   beg_ri_iga,
   til_ri_iga: LIKE(iga.RECORDID);
   ctlDTS    : TIMESTAMP;
 BEGIN
  APP.Get().NewPrompt(" ᢥ     ");
  L_General.CallUs(trgMyFirm = L_Packet.PckMyFirm);

  L_AFM.MakeMultipleIndex("MSFCh", "MyFirm : LIKE(ManSFee.MyFirm);"+
                                   "Period : LIKE(ManSFee.Period);"+
                                   "est    : SCAL[2];"+
                                   "ReasonC: SCAL[9];"+
                                   "Man    : LIKE(ManSFee.Man);"+
                                   "Fee    : LIKE(ManSFee.Fee)",
                          "Man:Man,MyFirm,Period;" +
                          "Period:MyFirm,Period,est,ReasonC,Man");

  IF AcceptableForPrepareChanges(ctlEnd) & (L_Packet.Get_PF_ProgressiveTotalPersAcc_Start() < PerB) THEN

   beg_ri_iga:=Get_RI_iga(PerB, PerB);
   til_ri_iga:=Get_RI_iga(PerB, Till);
 
   IF beg_ri_iga # til_ri_iga THEN
    SEARCH(iga, RECORDID, , beg_ri_iga);

    SELECT(ManSFee, Actual, , 0, trgMyFirm);
    WHILE OCCURE(ManSFee) DO
     NARROWSEL(ManSFee, Man);
     PROMPT(" " + ManSFee.Man);
     IF SRCINSEL(ManSFee, GE, iga.Period) THEN
      WHILE OCCURE(ManSFee) & (ManSFee.Period < PerB) DO
       NARROWSEL(ManSFee, Period);
       est:=GetChangingReason(ManSFee.Man, ManSFee.MyFirm, ManSFee.Period);
       TRY [RESTORE_CURSORS(RC_ON)]
        CHANGESEL(ManSFee, MyFirm, , ManSFee.MyFirm, ManSFee.Man, ManSFee.Actual, ManSFee.Period);
        IF SRCINSEL(ManSFee, LT, beg_ri_iga) THEN
         prvFee    :=ManSFee.Fee;
         prv_ri_iga:=ManSFee.ri_iga;
         CHANGESEL(ManSFee, Man, , ManSFee.Man, ManSFee.MyFirm, ManSFee.Period);
         LAST(ManSFee);
         IF ManSFee.Actual THEN
          WHILE OCCURE(ManSFee) & (ManSFee.ri_iga >= til_ri_iga) DO
           PREV(ManSFee);
          END; (* WHILE OCCURE(ManSFee) ... *)
          IF (ManSFee.ri_iga >= beg_ri_iga) THEN
           ADD(MSFCh, Man, , ManSFee.Man, ManSFee.MyFirm, ManSFee.Period,
               MSFCh.Fee[p_PFIn], ManSFee.Fee[p_PFIn]-prvFee[p_PFIn],
               MSFCh.Fee[p_PFAc], ManSFee.Fee[p_PFAc]-prvFee[p_PFAc],
               MSFCh.Fee[p_xFSS], ManSFee.Fee[p_xFSS]-prvFee[p_xFSS],
               MSFCh.Fee[p_MSFF], ManSFee.Fee[p_MSFF]-prvFee[p_MSFF],
               MSFCh.Fee[p_MSTF], ManSFee.Fee[p_MSTF]-prvFee[p_MSTF],
               MSFCh.Fee[p_PFOv], ManSFee.Fee[p_PFOv]-prvFee[p_PFOv],
               MSFCh.Fee[p_PFA1], ManSFee.Fee[p_PFA1]-prvFee[p_PFA1],
               MSFCh.Fee[p_PFA2], ManSFee.Fee[p_PFA2]-prvFee[p_PFA2],
               MSFCh.Fee[p_PFA3_1], ManSFee.Fee[p_PFA3_1]-prvFee[p_PFA3_1],
               MSFCh.Fee[p_PFA3_2], ManSFee.Fee[p_PFA3_2]-prvFee[p_PFA3_2],
               MSFCh.Fee[p_PFA3_3], ManSFee.Fee[p_PFA3_3]-prvFee[p_PFA3_3],
               MSFCh.Fee[p_PFA3_4], ManSFee.Fee[p_PFA3_4]-prvFee[p_PFA3_4],
               MSFCh.Fee[p_PFA4_0], ManSFee.Fee[p_PFA4_0]-prvFee[p_PFA4_0]);
           MSFCh.est    :=est;
           MSFCh.ReasonC:=GetPFA_ReasonCode();
           REPLACE(MSFCh);
          END; (* IF ManSFee.ri_iga # prv_ri_iga ... *)
         ELSE
          L_General.CallUs(IsSingleMansFeeInPeriod());
         END;
        END;
       EXCEPT
       END; (* TRY *)
       NEXTINEXTENDEDSEL(ManSFee, Period);
      END; (* WHILE OCCURE(ManSFee) *)
     END;
     NEXTINEXTENDEDSEL(ManSFee, Man);
    END; (* WHILE OCCURE(ManSFee) ... *)
   END;
  END;
 END {PrepareChanges};

BEGIN
 SETEMPTY(rd_Period, rd_MyFirm);
END.
