(*
%Copyright   (c) Polak Computer System
%Author      05.04.1994 09:32:57 SAN
%Purpose     ⥪  ࠡ  Sheet
%Type        library
%Specific    SYS
%Modified    26.06.2014 13:35:41 POLAK\Gina
%Environment
*)

 MODULE L_Sheet [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Staff, L_DatTim, L_PRoll, L_Hld, Math, L_EDO, E_Staff, L_Str, L_StdFrm;

 PUBLIC CONST
  src_Operator = 0;
  src_Regime   = 2;
  src_StaffLog = 3;
  src_RWayS    = 4;
  src_AvePay   = 5;
  src_EDOrder  = 6;

  src_Pool = "|1|䨪|ਪ  |⥢|㬥|ਪ | ⥢";

  jmType_NonPAbsent = 0;
  jmType_PaidAbsent = 1;
  jmType_TimDone    = 2;
  jmType_HolTime    = 3;
  jmType_Pool       = ". ⢨|. ⢨|ந⢥|室";

  spk_None     = 0;
  spk_Night    = 1;
  spk_Evening  = 2;
  spk_Juvenile = 3;

  jm_Sick                 = 03; (*쭨 , ⮪ 㤮ᯮᮡ*)
  jm_MaternityLeave       = 04; (* *)
  jm_ParentalLeave        = 06; (*.  室  ॡ  1.5 *)
  jm_AnnualLeave          = 07; (* 稢 *)
  jm_Truancy              = 15; (*ண*)
  jm_AdditionalLeave      = 21; (* ⥫ 稢 *)
  jm_ParentalLeaveUntil3Y = 47; (*  室  ॡ  1.5  3 *)
  jm_ChernobylLeave       = 48; (* ୮栬*)

 PUBLIC PROCEDURE RegListDate(): DATE;
 BEGIN
  RETURN RegList.Period + (RegList.Day - 1);
 END {RegListDate};

 PRIVATE PROCEDURE smf_WrongDB(Msg: STRING[]);
 BEGIN
  L_StdFrm.WrongDB(Msg + ".|䨪 ⠡ ");
 END {smf_WrongDB};

 PRIVATE PROCEDURE SheetModFail(D: DATE; BadSource: SCAL[2]);
 BEGIN
  IF Sheet.Source = src_Operator THEN
   smf_WrongDB(" ࠡ⭨ " + Staff.TSN + "  " + L_DatTim.DateStr(D) + "  ஬");
  ELSIF BadSource THEN
   smf_WrongDB(" ⠡ ࠡ⭨ " + Staff.TSN + "  " + L_DatTim.DateStr(D) +
               '|㦥  ⬥⪠  筨 "' + L_Str.PoolItem(src_Pool, Sheet.Source) + '"');
  ELSE
   CONFORM(Sheet, JMode);
   smf_WrongDB(" ⠡ ࠡ⭨ " + Staff.TSN + "  " + L_DatTim.DateStr(D) +
               ":|㦥 㪠  ࠡ " + Sheet.JMode + ' "' + JMode.Name + '"' +
               '| 筨 "' + L_Str.PoolItem(src_Pool, Sheet.Source) + '"');
  END;
 END {SheetModFail};

 PUBLIC PROCEDURE PosToSheet(D: DATE);
 BEGIN
  SAVE(StaffLog);
  IF ~L_Staff.rInState(D) THEN
   CONFORM(Staff, Man);
   L_StdFrm.WrongDB(Staff.TSN + " " + Man.Name + "|" + L_DatTim.DateStr(D) + "  ⮨  ");
  END;
  RESTORE(StaffLog);
  SEARCH(Sheet, TSN, , Staff.TSN, L_DatTim.Per(D), L_DatTim.DAY(D));
 END {PosToSheet};

 PUBLIC PROCEDURE REPCurrentSheetCond(): SCAL[2];
 BEGIN
  RETURN ~OCCURE(Sheet) | (Sheet.Source = src_Regime) | (Sheet.Source = src_EDOrder);
 END {REPCurrentSheetCond};

 PUBLIC PROCEDURE REPSheetCondition(D: DATE): SCAL[2];
 BEGIN
  PosToSheet(D);
  RETURN REPCurrentSheetCond();
 END {REPSheetCondition};

 PUBLIC PROCEDURE MayREPCurSheet();
 BEGIN
  IF ~REPCurrentSheetCond() THEN
   SheetModFail(Sheet.Period + Sheet.Day - 1, 1);
  END;
 END {MayREPSheet};

 PUBLIC PROCEDURE MayREPSheet(D: DATE);
 BEGIN
  PosToSheet(D);
  MayREPCurSheet();
 END {MayREPSheet};

 PUBLIC PROCEDURE MaySUBSheet(D: DATE; trgJMode: LIKE(JMode.JMode); trgSource: LIKE(Sheet.Source));
 BEGIN
  PosToSheet(D);
  IF ~OCCURE(Sheet) | (Sheet.Source # trgSource) | (Sheet.JMode # trgJMode) THEN
   SheetModFail(D, 1);
  END;
 END {MaySUBSheet};

 PUBLIC PROCEDURE MayADDSheet(D: DATE; trgJMode: LIKE(JMode.JMode); trgSource: LIKE(Sheet.Source));
 BEGIN
  PosToSheet(D);
  IF OCCURE(Sheet) THEN
   IF    (Sheet.Source # src_Regime) & (Sheet.Source # src_EDOrder) & (Sheet.Source # trgSource) THEN
    SheetModFail(D, 1);
   ELSIF (Sheet.Source = trgSource) & (Sheet.JMode # trgJMode) THEN
    SheetModFail(D, 0);
   END;
  END;
 END {MayADDSheet};

 PUBLIC PROCEDURE jm_ContractBreak(D: DATE): LIKE(JMode.JMode);
 BEGIN
  RETURN 08;
 END {jm_ContractBreak};

 PUBLIC PROCEDURE jm_RatherEarly(D: DATE): LIKE(JMode.JMode);
 BEGIN
  RETURN 20;
 END {jm_RatherEarly};

 PUBLIC PROCEDURE jm_Line(D: DATE): LIKE(JMode.JMode);
 BEGIN
  RETURN 02;
 END {jm_Line};

 PUBLIC PROCEDURE jm_LineHld(D: DATE): LIKE(JMode.JMode);
 BEGIN
  RETURN 32;
 END {jm_LineHld};

 PUBLIC PROCEDURE jm_Hld(D: DATE): LIKE(JMode.JMode);
 BEGIN
  RETURN 01;
 END {jm_Hld};

 PUBLIC PROCEDURE jm_HldAvp(D: DATE): LIKE(JMode.JMode);
 BEGIN
  RETURN 40;
 END {jm_HldAvp};

 PUBLIC PROCEDURE E_IsUnknownAbsence(trgJMode: LIKE(JMode.JMode)): SCAL[2];
  VAR
   local: PROC;
 BEGIN
  local:=PROCREF(E_Staff.IsUnknownAbsence);
  RETURN ~!local & local(trgJMode);
 END {E_IsUnknownAbsence};

 PUBLIC PROCEDURE HolTimeByDate(D: DATE; _Tim: LIKE(Sheet.Tim); _DayTime: LIKE(Sheet.DayTime)): L_PRoll.tTime;
  VAR
   Result: L_PRoll.tTime;
 BEGIN
  SETZERO(Result);
  IF L_Hld.DayIsHoliday(D) THEN
   IF ~!_DayTime & (_DayTime > 0) & (_Tim # _DayTime) THEN
    INC(Result, Math.Min(_Tim, _DayTime));
   ELSE
    INC(Result, _Tim);
   END;
  END;
  IF (~!_DayTime) & (_DayTime > 0) &
     (_Tim > _DayTime) &
     L_Hld.DayIsHoliday(D+1) THEN
   INC(Result, _Tim-_DayTime);
  END;
  RETURN Result;
 END {HolTimeByDate};

 PUBLIC PROCEDURE ReplaceableSheet(): SCAL[2];
 BEGIN
  RETURN (Sheet.Source = src_Regime) | (Sheet.Source = src_StaffLog);
 END {ReplaceableSheet};

 PUBLIC PROCEDURE GetRealSheet(VAR IsHole   : SCAL[2];
                               VAR _Tim     : LIKE(Sheet.Tim);
                               VAR _ShtSign : LIKE(JMode.ShtSign);
                               VAR fromSheet: SCAL[2]);
  VAR
   byEDOJMode: LIKE(JMode.JMode);
 BEGIN
  L_General.CallUs(OCCURE(StaffLog) & OCCURE(RegList));
  fromSheet:=SEARCH(Sheet, TSN, Staff.TSN, RegList.Period, RegList.Day) & ~ReplaceableSheet();
  IF fromSheet THEN
   CONFORM(Sheet, JMode);
   _Tim  :=Sheet.Tim;
   IsHole:=(JMode.Type = jmType_HolTime) | ((JMode.Type = jmType_NonPAbsent) & ~JMode.DecrBal);
  ELSE
   byEDOJMode:=L_EDO.sra_GetSpecifiedJMode_Int(Staff.TSN, RegListDate(), 0);
   IF ~!byEDOJMode THEN
    L_General.Assert(SEARCH(JMode, JMode, byEDOJMode), "   ࠡ  ⠡ " + byEDOJMode);
    _Tim  :=RegList.Durat;
    IsHole:=1;
   ELSE
    CONFORM(RegList, JMode);
    _Tim  :=RegList.GrTime;
    IsHole:=(JMode.Type = jmType_HolTime) | ((JMode.Type = jmType_NonPAbsent) & ~JMode.DecrBal);
   END;
  END; (* IF SEARCH(Sheet, TSN...*)
  _ShtSign:=JMode.ShtSign;
 END {GetRealSheet};

 PUBLIC PROCEDURE UpdateSheet(curDate   : DATE;
                              curJMode  : LIKE(Sheet.JMode);
                              curTim    : LIKE(Sheet.Tim);
                              curSpKind : LIKE(Sheet.SpKind);
                              curSpTime : LIKE(Sheet.SpTime);
                              curDayTime: LIKE(Sheet.DayTime);
                              curSource : LIKE(Sheet.Source));
 BEGIN
  IF OCCURE(Sheet) THEN
   IF (Sheet.TSN # Staff.TSN) | (Sheet.Period # L_DatTim.MonthBeg(curDate)) |
      (Sheet.Day # L_DatTim.DAY(curDate)) THEN
    L_General.CallUs(0);
   END;
   IF (Sheet.JMode   # curJMode ) |
      (Sheet.Tim     # curTim   ) |
      (Sheet.SpKind  # curSpKind) |
      (Sheet.SpTime  # curSpTime) |
      (Sheet.DayTime # curDayTime) |
      (Sheet.Source  # curSource) THEN
    Sheet.JMode  :=curJMode;
    Sheet.Tim    :=curTim;
    Sheet.SpKind :=curSpKind;
    Sheet.SpTime :=curSpTime;
    Sheet.DayTime:=curDayTime;
    Sheet.Source :=curSource;
    REPLACE(Sheet);
   END;
  ELSE
   Sheet.TSN    :=Staff.TSN;
   Sheet.Period :=L_DatTim.MonthBeg(curDate);
   Sheet.Day    :=L_DatTim.DAY(curDate);
   Sheet.JMode  :=curJMode;
   Sheet.Tim    :=curTim;
   Sheet.SpKind :=curSpKind;
   Sheet.SpTime :=curSpTime;
   Sheet.DayTime:=curDayTime;
   Sheet.Source :=curSource;
   IF ~SEARCH(StaffMon, TSN, Sheet.TSN, Sheet.Period) THEN
    StaffMon.TSN   :=Sheet.TSN;
    StaffMon.Period:=Sheet.Period;
    SETEMPTY(StaffMon.RECORDID);
    INSERT(StaffMon);
   END;
   INSERT (Sheet);
  END;
 END {UpdateSheet};

 PUBLIC PROCEDURE GetBalInf(    BegD, EndD: DATE;
                                NeedPosToStaffLog: SCAL[2];
                            VAR TimDone, HBal, CorBal, NightTime, HolTime: L_PRoll.tTime);
  VAR
   curD     : DATE;
   curTim,
   curDayTime,
   curNight : L_PRoll.tTime;
   curSource: LIKE(Sheet.Source);
 BEGIN
  SETZERO(TimDone, HBal, CorBal, NightTime, HolTime);
  curD:=BegD;
  WHILE curD <= EndD DO
   IF NeedPosToStaffLog THEN
    HISTCONF(curD, Staff, StaffLog);
   END;
   L_General.Assert(SEARCH(RegList, HumReg, StaffLog.Regime, L_DatTim.Per(curD), L_DatTim.DAY(curD)),
                    " ⠭ ० ࠡ "+StaffLog.Regime+"  "+L_DatTim.DateStr(curD));
   SETZERO(curNight);
   IF SEARCH(Sheet, TSN, Staff.TSN, L_DatTim.Per(curD), L_DatTim.DAY(curD)) &
      (Sheet.JMode # jm_RatherEarly(curD)) THEN
    CONFORM(Sheet, JMode);
    curTim:=Sheet.Tim;
    IF Sheet.SpKind = spk_Night THEN
     curNight:=Sheet.SpTime;
    END;
    curDayTime:=Sheet.DayTime;
    curSource :=Sheet.Source;
   ELSE
    CONFORM(RegList, JMode);
    curTim:=RegList.GrTime;
    IF RegList.SpKind = spk_Night THEN
     curNight:=RegList.SpTime;
    END;
    curDayTime:=RegList.DayTime;
    curSource :=src_Regime;
   END;
   IF JMode.InFirm THEN
    IF (JMode.Type = jmType_TimDone) & (curD<=SYSDATE()) THEN
     INC(TimDone,   curTim);
     INC(NightTime, curNight);
    ELSIF JMode.DecrBal THEN
     IF (curD >= 01\11\2012) & (StaffLog.DutyDgr < 1) & (curSource = src_AvePay) THEN
      DEC(CorBal, RegList.Durat*StaffLog.DutyDgr);
     ELSE
      DEC(CorBal, curTim);
     END;
    END;
    INC(HBal,   RegList.Durat*StaffLog.DutyDgr);
    INC(CorBal, RegList.Durat*StaffLog.DutyDgr);
    IF JMode.PayHldy THEN
     INC(HolTime, HolTimeByDate(curD, curTim, curDayTime));
    END;
   END; (* IF JMode.InFirm... *)
   INC(curD);
  END; (* WHILE curD <= EndD... *)
 END {GetBalInf};

END.
