(*
%Copyright   (c) Polak IT
%Author      04.01.2005 14:57:11 POLAK\LDA
%Purpose
%Type        library
%Specific    AP
%Modified    20.12.2013 09:09:24 POLAK\GAV
%Environment
*)

 MODULE L_SprtCrsp [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  dl_Immediately        = 0;
  dl_Today              = 1;
  dl_ByTomorrow         = 2;
  dl_WithinWeek         = 3;
  dl_WithinMonth        = 4;
  dl_BySpecifiedDate    = 5;
  dl_InFuture           = 6;

  dl_Pool = "| 祭 | 譥 | 祭 | 祭 | 㪠 | 饬";

  rt_Amount =  5;

  rt_ErrorCorrection = 0;
  rt_TaskSolution    = 1;
  rt_Alarm           = 2;
  rt_Addition        = 3;
  rt_AutoBuild       = 4;

  rt_Pool = "ࠢ 訡|襭 |ॡ 筠 !|  |ࠢ 訡 (⮢ ⮬᪨)";
  rt_Pool_Short = "||!!!||";

  h_Action  = " 믮  ⢨:";
  h_Object  = "  ꥪ:";
  h_Prompt  = " ᠭ  ࠭:";
  h_Purpose = "  訡:";


  dt_DoneAsIs    = 0;
  dt_DoneWAddIns = 1;
  dt_Refused     = 2;
  dt_Rejected    = 3;
  dt_Delayed     = 4;
  dt_Canceled    = 5;

  dt_Pool        = "믮  ࢮ砫쭮 |믮  ⮬ ||⢥࣭|⫮|㫨஢";
  dt_ShortPool   = "|||-||";

  st_Prepared = 0;
  st_Canceled = 1;
  st_Sent     = 2;
  st_Done     = 3;

  st_Pool        = "⮢|㫨஢|ࠢ|믮";
  st_ShortPool   = "|||";

  xmln_SprtCrsp          = "SprtCrsp";
  xmln_Date              = "Date";
  xmln_Time              = "Time";
  xmln_PrpDate           = "PrpDate";
  xmln_PrpTime           = "PrpTime";
  xmln_Author            = "Author";
  xmln_Customer          = "Customer";
  xmln_Sender            = "Sender";
  xmln_SenderEMail       = "SenderEMail";
  xmln_ReplyToType       = "ReplyToType";
  xmln_RequestT          = "RequestType";
  xmln_Subject           = "Subject";
  xmln_DeadLine          = "DeadLine";
  xmln_dlDate            = "dlDate";
  xmln_dlTime            = "dlTime";
  xmln_Action            = "Action";
  xmln_Object            = "Object";
  xmln_Prompt            = "Prompt";
  xmln_Purpose           = "Purpose";
  xmln_Text              = "Text";
  xmln_NormativeDocument = "NormativeDocument";
  xmln_Attachments       = "Attachments";
  xmln_Parent            = "Parent";
  xmln_Version           = "Version";
  xmln_Client            = "Client";

  aps_BegWork   = 10:00;
  aps_EndWork   = 20:00;
  aps_psBegWork = 10:00;
  aps_psEndWork = 18:30;

  ZIPExtForGoogleMail = "ZEA";

 IMPORT L_XDoc, L_General, L_DatTim, L_Str, L_PCS;

 PUBLIC PROCEDURE aps_GetLocalDatTime(D: DATE; T: TIME): FLOAT;
  VAR
   F: FLOAT;
   _D: DATE;
   _T: TIME;
 BEGIN
  _D:=D;
  _T:=T;
  L_DatTim.inGMT_Moscow(_D, _T);
  UNIVERSALTOLOCALVARIANTTIME(F, L_DatTim.GetVARIANTDATE(_D, _T, 0));
  RETURN F;
 END {aps_GetLocalDatTime};

 PUBLIC PROCEDURE aps_GetLocalTime(T: TIME): TIME;
 BEGIN
  RETURN L_DatTim.GetTimeOfVARIANTDATE(aps_GetLocalDatTime(SYSDATE(), T));
 END {aps_GetLocalTime};

 PRIVATE PROCEDURE IsPolakWorkingDay(Date: DATE): SCAL[2];
 BEGIN
  RETURN (Date = 03\01\2014) | (Date = 04\01\2014) | (Date = 06\01\2014) | (Date = 08\01\2014) |
         (Date = 04\01\2013) | (Date = 05\01\2013) | (Date = 06\01\2013) | (Date = 08\01\2013) |
         (Date = 04\01\2012) | (Date = 05\01\2012) | (Date = 06\01\2012) | (Date = 09\01\2012) |
         (Date = 04\01\2011) | (Date = 05\01\2011) | (Date = 06\01\2011) | (Date = 08\01\2011) |
         (Date = 04\01\2010) | (Date = 05\01\2010) | (Date = 06\01\2010) | (Date = 08\01\2010) |
         (Date = 04\01\2009) | (Date = 05\01\2009) | (Date = 06\01\2009) | (Date = 08\01\2009) |
         ((Date >= 03\01\2006) & (Date <= 09\01\2006));
 END {IsPolakWorkingDay};

 PUBLIC PROCEDURE GetWorkTimeIntvl(D: DATE; VAR BT, ET: FLOAT);
 BEGIN
  IF    L_DatTim.IsWorkDay(D) THEN
   BT:=aps_GetLocalDatTime(D, aps_BegWork);
   ET:=aps_GetLocalDatTime(D, aps_EndWork);
  ELSIF IsPolakWorkingDay(D) THEN
   BT:=aps_GetLocalDatTime(D, aps_psBegWork);
   ET:=aps_GetLocalDatTime(D, aps_psEndWork);
  ELSE
   SETEMPTY(BT, ET);
  END;
 END {GetWorkTimeIntvl};

 PUBLIC PROCEDURE IsAcceptableTimeForAlarm(): SCAL[2];
  VAR
   begTime,
   endTime: FLOAT;
 BEGIN
  GetWorkTimeIntvl(SYSDATE(), begTime, endTime);
  RETURN !begTime | (L_DatTim.GetSysVARIANTDATE() < begTime) | (L_DatTim.GetSysVARIANTDATE() >= endTime);
 END {IsAcceptableTimeForAlarm};

 PUBLIC PROCEDURE FirstWorkingDT(D: DATE): FLOAT;
 BEGIN
  LOOP
   IF    L_DatTim.IsWorkDay(D) THEN
    RETURN aps_GetLocalDatTime(D, aps_BegWork);
   ELSIF IsPolakWorkingDay(D) THEN
    RETURN aps_GetLocalDatTime(D, aps_psBegWork);
   END;
   INC(D);
  END;
 END {FirstWorkingDT};

 PUBLIC PROCEDURE MinDeadline(): FLOAT;
  VAR
   BT,
   ET        : FLOAT;
   CurDayRest: FLOAT;
 BEGIN
  GetWorkTimeIntvl(SYSDATE(), BT, ET);
  IF ~!BT & (L_DatTim.GetSysVARIANTDATE() < BT) THEN
   RETURN BT + 0.5 / 24;
  ELSIF ~!BT & ((L_DatTim.GetSysVARIANTDATE() + 0.5 / 24) < ET) THEN
   RETURN L_DatTim.GetSysVARIANTDATE() + 0.5 / 24;
  ELSE
   IF ~!BT & (L_DatTim.GetSysVARIANTDATE() < ET) THEN
    RETURN FirstWorkingDT(SYSDATE() + 1) + 0.5 / 24 - (ET - L_DatTim.GetSysVARIANTDATE());
   ELSE
    RETURN FirstWorkingDT(SYSDATE() + 1) + 0.5 / 24;
   END;
  END;
 END {MinDeadline};

 PUBLIC PROCEDURE IsAddition(): SCAL[2];
 BEGIN
  RETURN SprtCrsp.RequestT = rt_Addition;
 END {IsAddition};

 PRIVATE PROCEDURE DecodeSprtCrspId(    _SprtCrspId: STRING[];
                                    VAR _SprtCrsp  : LIKE(SprtCrsp.SprtCrsp));
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
 BEGIN
  L_XDoc.DecodeXDocId(_SprtCrspId, _XDocType, _XDocKind, _SprtCrsp);
  L_General.Assert(_XDocType = L_XDoc.xdt_SprtCrsp,
                   "L_SprtCrsp.DecodeSprtCrspId.Error 1");
 END {DecodeSprtCrspId};

 PUBLIC PROCEDURE GetAuthorName(): STRING[];
 BEGIN
  RETURN L_Str.ShortName(L_PCS.GetFullNameOfCurrentUser(SYSDATE()));
 END {GetAuthorName};

END.
