(*
%Copyright   (c) Polak IT
%Author      16.04.2009 11:58:07 POLAK\LDA
%Purpose     ⥪  ࠡ  MS SQK Server
%Type        library
%Specific    SYS
%Modified    11.10.2010 22:00:55 POLAK\MLB
%Environment
*)

 MODULE L_SQL [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_ExtDB, L_MSWStp, P_Firm;

 PUBLIC CONST
  adr_MTASQLServer         = "83.166.226.245,11436";
  adr_PolakSQLServerLocal  = "srv2\sqlexpress";
  adr_PolakSQLServerRemote = "polak.ru\sqlexpress,1433|stc.polak.ru\sqlexpress,1433";

 PUBLIC VAR
  slqRecordSet: OBJECT;

 PUBLIC PROCEDURE Connect(Server, Database, User, Pass: STRING[]): OBJECT;
 BEGIN
  RETURN L_ExtDB.ado_MSSQLConnect(Server, Database, User, Pass);
 END {Connect};

 PUBLIC PROCEDURE ConnectToMTASQLServer(): OBJECT;
 BEGIN
  RETURN Connect(adr_MTASQLServer, "mta01", "client", "Wqmcfg7Byec=");
 END {ConnectToMTASQLServer};

 PUBLIC PROCEDURE ConnectToPolakSQLServer(): OBJECT;
  VAR
   Server: STRING[];
 BEGIN
  IF L_General.IsOurSite() THEN
   Server:=adr_PolakSQLServerLocal;
  ELSE
   Server:=adr_PolakSQLServerRemote;
  END;
  RETURN Connect(Server, "mta01", "client", "Wqmcfg7Byec=");
 END {ConnectToPolakSQLServer};

 PUBLIC PROCEDURE OpenRecordSet(sqlConnection: OBJECT; sqlStr: STRING[]);
 BEGIN
  slqRecordSet:=L_ExtDB.ado_MSSQLSelect(sqlConnection, sqlStr);
 END {OpenRecordSet};

 PRIVATE PROCEDURE WrVal(Field: STRING[]; VAR _Value: VARIANT);
 BEGIN
  slqRecordSet.Fields(Field).Value:=_Value;
 END {WrVal};

 PUBLIC PROCEDURE WrInt(Field: STRING[]; _Value: NUMERIC[0]);
 BEGIN
  WrVal(Field, _Value);
 END {WrInt};

 PUBLIC PROCEDURE WrStr(Field: STRING[]; _Value: STRING[]);
 BEGIN
  WrVal(Field, _Value);
 END {WrStr};

 PUBLIC PROCEDURE WrDat(Field: STRING[]; _Value: DATE);
 BEGIN
  WrVal(Field, _Value);
 END {WrDat};

 PUBLIC PROCEDURE WrDTS(Field: STRING[]; _Value: FLOAT);
 BEGIN
  WrVal(Field, _Value);
 END {WrDTS};

 PUBLIC PROCEDURE WrNum(Field: STRING[]; _Value: FLOAT);
 BEGIN
  WrVal(Field, _Value);
 END {WrNum};

 PUBLIC PROCEDURE UpdateRecordSet(wClose: SCAL[2]);
 BEGIN
  slqRecordSet.Update();
  IF wClose THEN
   CloseRecordSet();
  END;
 END {UpdateRecordSet};

 PUBLIC PROCEDURE CloseRecordSet();
 BEGIN
  slqRecordSet.Close();
 END {CloseRecordSet};

 PUBLIC PROCEDURE GetFieldValue(VAR _Value: VARIANT; Field: STRING[]);
 BEGIN
  _Value:=slqRecordSet.Fields(Field).Value;
 END {GetFieldValue};

 PUBLIC PROCEDURE Occure(): SCAL[2];
 BEGIN
  RETURN ~slqRecordSet.EOF;
 END {Occure};

 PUBLIC PROCEDURE Insert();
 BEGIN
  slqRecordSet.AddNew();
 END {Insert};

 PUBLIC PROCEDURE GetFirmFromSQLServer(    sqlConnection: OBJECT;
                                       VAR trgAPId      : SCAL[1E4]);
 VAR
  sqlStr  : STRING[];
  _mtaName: STRING[64];
  _mtaCode: NUMERIC[0];
  HeadFirm: LIKE(Firm.Firm);
 BEGIN
  trgAPId:=L_General.GetAPSiteNumber();
  TRY
   sqlConnection.BeginTrans();
   sqlStr:="SELECT * FROM Firm WHERE APId=" + trgAPId + " FOR UPDATE";
   OpenRecordSet(sqlConnection, sqlStr);
   IF ~Occure() THEN
    L_General.Assert(~L_General.IsOurEngineeringCopy(), "஥ " + trgAPId + ": ࣠   ॥ ࣠権  ࢥ");

    _mtaName:=P_Firm.FP_BranchName(P_Firm.OWN_FIRM, SYSDATE());
    L_General.Assert(~!_mtaName, " ࠣ 0000 ୮  ᢮⢮ '' -  㪠  䨫");
   
    HeadFirm:=P_Firm.FP_HeadFirm(P_Firm.OWN_FIRM, SYSDATE());
    L_General.Assert(~!HeadFirm, " ࠣ 0000  㪠  ࣠");
   
    _mtaCode:=STRTOFLD(P_Firm.GetFirmProSoft(HeadFirm, SYSDATE(), P_Firm.P_OurCode), NUMERIC);;
   
    L_General.Assert(~!_mtaCode, "室  ᢮⢮ 0025  ࠣ " + HeadFirm +
                                 "||" +
                                 "  襣 ।  ");

    Insert();
    WrVal("APId", trgAPId);
    WrStr("Name", P_Firm.FP_FirmShortName(P_Firm.OWN_FIRM, SYSDATE()));
    WrVal("mtaCode", _mtaCode);
    WrVal("mtaName", _mtaName);
   END;
   UpdateRecordSet(1);
   sqlConnection.CommitTrans();
  EXCEPT
  ON Exc:Exc_Root DO
   sqlConnection.RollbackTrans();
   RAISE();
  END;
 END {GetFirmFromSQLServer};

 PRIVATE PROCEDURE CheckSQLServerConnection(sqlConnection: OBJECT);
 BEGIN
  STDMSG("  ࢥ஬ ᡮ  " + sqlConnection.Properties.Item("Data Source Name").Value + " ࠡᯮᮡ", INFORM);
 END {CheckSQLServerConnection};

 PUBLIC PROCEDURE CheckMTASQLServerConnection();
 BEGIN
  CheckSQLServerConnection(ConnectToMTASQLServer());
 END {CheckMTASQLServerConnection};

 PUBLIC PROCEDURE CheckPolakSQLServerConnection();
 BEGIN
  CheckSQLServerConnection(ConnectToPolakSQLServer());
 END {CheckPolakSQLServerConnection};

END.
