(*
%Copyright   (c) Polak Computer System
%Author      Unknown
%Purpose       Staff
%Type        library
%Specific    SYS
%Modified    19.09.2014 18:43:23 POLAK\Gina
%Environment
*)

 MODULE L_Staff [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tProximityCardStatus = SCAL[4];
  tOStaffPrintMethod   = SCAL[2];
  tT2Form              = SCAL[4];

 PUBLIC CONST
  cnt_Basic                = 0;
  cnt_ExternalCombine      = 1;
  cnt_InternalCombine      = 2;
  cnt_ContractorsAgreement = 3;
  cnt_OutStaff             = 4;
  cnt_Pool = "||||";
  cnt_Pool_Full = "᭮ ࠡ|譥 ᮢ⥫⢮|७ ᮢ⥫⢮| 鸞| ७";

  cdt_Permanent = 0;
  cdt_FixedDate = 1;
  cdt_Pool_Full = " । ப|";

  slkt_TakeOn              = 0;
  slkt_Move                = 1;
  slkt_Discharge           = 2;
  slkt_Prolongation        = 3;
  slkt_TakeOnWithDischarge = 4;
  slkt_Pool = "ਥ|ॢ|쭥|த|쭥  ਥ";

  pcn_NoClasses = 0;
  pcn_Pool_Full = " | ࠧ|⥣|";

  rspma_None             = 0;
  rspma_Accountability   = 1;
  rspma_AccountabilityKA = 2; (*Officer.RspMAsst*)
  rspma_pool = "|뤠 |⢥⢥  ";

  sarr_Begun   = 1;
  sarr_EDOrder = 2;

  ati_Main       = 0;
  ati_HarmPwr    = 1;
  ati_Continuity = 2;
  ati_UnNorm     = 3;
  ati_Other      = 4;
  ati_OverNorm   = 7;

  ati_Amount = 5;

  dtpwr_Optimal    = 0; (*DirtyTyp.Power*)
  dtpwr_Acceptable = 1;
  dtpwr_Harmful1   = 2;
  dtpwr_Harmful2   = 3;
  dtpwr_Harmful3   = 4;
  dtpwr_Harmful4   = 5;
  dtpwr_Dangerous  = 6;
  dtpwr_pool = "1  ⨬|2  ⨬|3.1  ।|3.2  ।|3.3  ।|3.4  ।|4  ";

  dtinj_Optimal    = 0; (*DirtyTyp.InjPower*)
  dtinj_Acceptable = 1;
  dtinj_Dangerous  = 2;
  dtinj_pool = "1  ⨬|2  ⨬|3  ";

  dtmep_Never      = 0; (* DirtyTyp.MedExPer *)
  dtmep_EveryYear  = 1;
  dtmep_Every2Year = 2;
  dtmep_Pool = " ॡ|1 ࠧ  |1 ࠧ  2 ";

  tkso_ByTSN          = 0; (* TimeKeep.SrtOrder *)
  tkso_BySortTSN      = 1;
  tkso_ByOfcrTSN      = 2;
  tkso_ByOfcrShiftTSN = 3;
  tkso_pool = "|, ⠡|, ⠡|, ᬥ, ⠡";

  sdpm_ActualInf = 0;
  sdpm_TakeOnInf = 1;

  t2f_Default         = 0;
  t2f_wT2_2_BeganInf  = 1;
  t2f_wT2_2_ActualInf = 2;
  t2f_Default_A4      = 3;

  osgn_Tx_Forms        = "ਪ  ࠡ⭨ ( )";
  osgn_StaffContracts  = "  ࠡ⭨";
  osgn_T2              = "筠 窠 ࠡ⭨ (-2)";
  osgn_References      = "ࠢ";
  osgn_Foreigners      = "쪮  ࠭ ࠦ";

 IMPORT Str, L_DatTim, L_General, L_EC, L_Prop, L_Str, L_MSO, L_PRoll, L_EDO,
        P_Staff, P_Officer, P_Union, P_Man, Memo, E_Staff, L_Env, L_BarCode, L_PDoc,
        L_XDoc, FIO, P_Firm, L_Man, L_Russia, L_StdFrm, P_Sort, L_ctc, L_Print, L_DBD;

 PUBLIC PROCEDURE InStateInPer(BegD, EndD: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  L_General.CallUs(EndD>=BegD);
  IF (Staff.BegDate > EndD) | (Staff.EndDate < BegD) THEN
   RETURN 0;
  END;
  SAVE(StaffLog);
  HISTCONF(EndD, Staff, StaffLog);
  CHANGESEL(StaffLog, TSN, , StaffLog.TSN);
  WHILE OCCURE(StaffLog) & (~OrderInIntvl(BegD, EndD) | IsDischargeStaffLog()) DO
   PREV(StaffLog);
  END;
  Result:=OCCURE(StaffLog);
  RESTORE(StaffLog);
  RETURN Result;
 END {InStateInPer};

 PUBLIC PROCEDURE IsBegan(P: DATE): SCAL[2];   (* ਭ   P  ࠭ *)
  VAR
   D: DATE;
 BEGIN
  D:=L_DatTim.MonthEnd(P);
  RETURN L_Man.GetTakeOnDate(D) <= D;
 END {IsBegan};

 PUBLIC PROCEDURE IsWorking(P: DATE): SCAL[2]; (* ⠥   P *)
 BEGIN
  RETURN InStateInPer(L_DatTim.MonthBeg(P), L_DatTim.MonthEnd(P));
 END {IsWorking};

 PUBLIC PROCEDURE IsLeave(P: DATE): SCAL[2];   (*    P  ࠭ *)
  VAR
   D: DATE;
 BEGIN
  D:=L_DatTim.MonthEnd(P);
  RETURN L_Man.GetRealEndDate(D) <= D;
 END {IsLeave};

 PUBLIC PROCEDURE IsLeaveFinally(P: DATE): SCAL[2];   (* ⥫쭮 㢮   P  ࠭ *)
 BEGIN
  RETURN ~!Staff.EndDate & (L_DatTim.Per(Staff.EndDate) <= P);
 END {IsLeaveFinally};

 PUBLIC PROCEDURE rInState(D: DATE): SCAL[2];
 BEGIN
  IF ~L_Env.RealTSN(Staff.TSN) | (Staff.BegDate > D) THEN
   RETURN 0;
  END;
  HISTCONF(D, Staff, StaffLog);
  RETURN InOrder(D) & ~IsDischargeStaffLog();
 END {rInState};

 PUBLIC PROCEDURE InOrder(D: DATE): SCAL[2];
 BEGIN
  RETURN L_DatTim.IsActive_Inc(D, StaffLog.Date, StaffLog.DateE);
 END {InOrder};

 PUBLIC PROCEDURE IsDischargeStaffLog(): SCAL[2];
 BEGIN
  RETURN GetStaffLogType() = slkt_Discharge;
 END {IsDischargeStaffLog};

 PUBLIC PROCEDURE ItsNotLastDischargeStaffLog(): SCAL[2];
 BEGIN
  RETURN StaffLog.Date <= StaffLog.DateE;
 END {ItsNotLastDischargeStaffLog};

 PUBLIC PROCEDURE OrderInIntvl(IntvlB, IntvlE: DATE): SCAL[2];
 BEGIN
  RETURN ItsNotLastDischargeStaffLog() &
         L_DatTim.IsActiveInIntvl_Inc(IntvlB, IntvlE,
                                      StaffLog.Date, StaffLog.DateE);
 END {OrderInIntvl};

 PUBLIC PROCEDURE OrderInMonth(P: DATE): SCAL[2];
 BEGIN
  RETURN OrderInIntvl(P, L_DatTim.MonthEnd(P));
 END {OrderInMonth};

 PUBLIC PROCEDURE GetStaffMyFirm(): P_Firm.tMyFirm;
 BEGIN
  RETURN Staff.MyFirm;
 END {GetStaffMyFirm};

 PUBLIC PROCEDURE GetFirmOfStaff(): LIKE(Firm.Firm);
 BEGIN
  L_General.CallUs(ACCESS(Staff) & ~!Staff.MyFirm);
  RETURN P_Firm.GetFirmOfMyFirm(Staff.MyFirm);
 END {GetFirmOfStaff};

 PRIVATE PROCEDURE intIsMainContract(trgOnDate: DATE): SCAL[2];
 BEGIN
  RETURN (Staff.Contract = cnt_Basic) & (Staff.BegDate <= trgOnDate) & (trgOnDate <= Staff.EndDate);
 END {intIsMainContract};

 PRIVATE PROCEDURE _StandOnMain(_Man       : LIKE(Man.Man);
                                _MyFirm    : P_Firm.tMyFirm;
                                _Contract  : LIKE(Staff.Contract);
                                VAR _TSN   : LIKE(Staff.TSN);
                                VAR LDate  : DATE;
                                OnDate     : DATE): SCAL[2];
 BEGIN
  SELECT(Staff, MyFirm, , _MyFirm, _Man, _Contract);
  WHILE OCCURE(Staff) & (Staff.BegDate <= OnDate) DO
   IF !Staff.EndDate | intIsMainContract(OnDate) THEN
    _TSN:=Staff.TSN;
    RETURN 1;
   ELSIF Staff.EndDate > LDate THEN
    LDate:=Staff.EndDate;
    _TSN:=Staff.TSN;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RETURN 0;
 END {_StandOnMain};

 PUBLIC PROCEDURE IsMainForTax(OnDate: DATE): SCAL[2];
  VAR
   _Man   : LIKE(Man.Man);
   _MyFirm: P_Firm.tMyFirm;
   Dummy  : SCAL[2];
   LDate  : DATE;
   _TSN   : LIKE(Staff.TSN);
 BEGIN
  IF    Staff.Contract = cnt_InternalCombine THEN
   RETURN 0;
  ELSIF Staff.BegDate > OnDate THEN
   RETURN 0;
  ELSIF intIsMainContract(OnDate) THEN
   RETURN 1;
  ELSE
   SAVE(Staff);
   LDate:=MINOF(DATE);
   _Man   :=Staff.Man;
   _MyFirm:=Staff.MyFirm;
   Dummy:=_StandOnMain(_Man, _MyFirm, cnt_Basic,                _TSN, LDate, OnDate) |
          _StandOnMain(_Man, _MyFirm, cnt_ExternalCombine,      _TSN, LDate, OnDate) |
          _StandOnMain(_Man, _MyFirm, cnt_ContractorsAgreement, _TSN, LDate, OnDate) |
          _StandOnMain(_Man, _MyFirm, cnt_OutStaff,             _TSN, LDate, OnDate) ;
   RESTORE(Staff);
   L_General.CallUs(~!_TSN);
   RETURN Staff.TSN = _TSN;
  END;
 END {IsMainForTax};

 PUBLIC PROCEDURE CheckCurrentAsMainForTax(OnDate: DATE);
 BEGIN
  L_General.Assert(IsMainForTax(OnDate), "   ࠪ");
 END {CheckCurrentAsMainForTax};

 PUBLIC PROCEDURE IsStandOnMainContract(_Man: LIKE(Man.Man); _MyFirm: P_Firm.tMyFirm; D: DATE): SCAL[2];
 BEGIN
  SELECT(Staff, MyFirm, , _MyFirm, _Man);
  WHILE OCCURE(Staff) DO
   IF IsMainForTax(D) THEN
    RETURN 1;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RETURN 0;
 END {IsStandOnMainContract};

 PUBLIC PROCEDURE StandOnMainContract(_Man: LIKE(Man.Man); _MyFirm: P_Firm.tMyFirm; D: DATE);
  VAR
   Msg: STRING[];
 BEGIN
  IF ~IsStandOnMainContract(_Man, _MyFirm, D) THEN
   Msg:="   ࠪ  " + _Man + "  " + L_DatTim.DateStr(D);
   IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
    Msg:=Msg + "|" + "('' ࣠ " + _MyFirm + ")";
   END;
   L_General.Error(Msg);
  END;
 END {StandOnMainContract};

 PUBLIC PROCEDURE StandOnMainContractByStaff(D: DATE);
 BEGIN
  StandOnMainContract(Staff.Man, Staff.MyFirm, D);
 END {StandOnMainContractByStaff};

 PUBLIC PROCEDURE IsStandOnAnyMainContract(trgMan: LIKE(Man.Man); D: DATE): SCAL[2];
  VAR
   trgTSN    : LIKE(Staff.TSN);
   maxEndDate: DATE;
 BEGIN
  SETEMPTY(trgTSN);
  maxEndDate:=MINOF(DATE);
  IF SELECT(Staff, Man, trgMan, cnt_Basic) THEN
   WHILE OCCURE(Staff) DO
    IF IsMainForTax(D) & (Staff.EndDate > maxEndDate) THEN
     trgTSN    :=Staff.TSN;
     maxEndDate:=Staff.EndDate;
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
  END;
  IF !trgTSN & SELECT(Staff, Man, trgMan) THEN
   WHILE OCCURE(Staff) DO
    IF IsMainForTax(D) & (Staff.EndDate > maxEndDate) THEN
     trgTSN    :=Staff.TSN;
     maxEndDate:=Staff.EndDate;
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
  END;
  IF ~!trgTSN THEN
   SEARCH(Staff, TSN, , trgTSN);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {IsStandOnAnyMainContract};

 PUBLIC PROCEDURE StandOnAnyMainContract(_Man: LIKE(Man.Man); D: DATE);
 BEGIN
  L_General.Assert(IsStandOnAnyMainContract(_Man, D),
                   "   ࠪ  " + _Man + "  " + L_DatTim.DateStr(D));
 END {StandOnAnyMainContract};

 PUBLIC PROCEDURE Man2TSN(D        : DATE;
                          trgMan   : LIKE(Man.Man);
                          trgMyFirm: P_Firm.tMyFirm;
                          mfOnly,
                          inState  : SCAL[2]): LIKE(Staff.TSN);
  VAR
   Result: LIKE(Staff.TSN);
   Dummy : SCAL[2];
 BEGIN
  SAVE(Staff);
  SAVE(StaffLog);
  IF    !trgMyFirm THEN
   Dummy:=IsStandOnAnyMainContract(trgMan, D);
  ELSIF mfOnly THEN
   Dummy:=IsStandOnMainContract(trgMan, trgMyFirm, D);
  ELSIF ~IsStandOnMainContract(trgMan, trgMyFirm, D) | (Staff.Contract # cnt_Basic) THEN
   Dummy:=IsStandOnAnyMainContract(trgMan, D);
  END;
  IF OCCURE(Staff) & (~inState | rInState(D)) THEN
   Result:=Staff.TSN;
  ELSE
   IF ~mfOnly & ~!trgMyFirm THEN
    Result:=Man2TSN(D, trgMan, EMPTYOF(trgMyFirm), 0, inState);
   ELSE
    SETEMPTY(Result);
   END;
  END;
  RESTORE(StaffLog);
  RESTORE(Staff);
  RETURN Result;
 END {Man2TSN};

 PUBLIC PROCEDURE FirstLogInMonth(): SCAL[2];
 BEGIN
  IF IsDischargeStaffLog() |
     ~L_DatTim.IsActiveInIntvl_Inc(StaffLog.Date, StaffLog.DateE,
                                   Memo.gl_mb(), Memo.gl_me()) THEN
   RETURN 0;
  END;

  SAVE(StaffLog);
  CHANGESEL(StaffLog, TSN, , StaffLog.TSN);
  WHILE PREV(StaffLog) & (StaffLog.DateE >= Memo.gl_mb()) DO
   IF ~IsDischargeStaffLog() THEN
    RESTORE(StaffLog);
    RETURN 0;
   END;
  END; (* WHILE OCCURE(StaffLog) ... *)
  RESTORE(StaffLog);
  RETURN 1;
 END {FirstLogInMonth};

 PUBLIC PROCEDURE LastLogInAnyMonth(mb, me: DATE): SCAL[2];
 BEGIN
  IF IsDischargeStaffLog() |
     ~L_DatTim.IsActiveInIntvl_Inc(StaffLog.Date, StaffLog.DateE, mb, me) THEN
   RETURN 0;
  END;

  SAVE(StaffLog);
  CHANGESEL(StaffLog, TSN, , StaffLog.TSN);
  WHILE NEXT(StaffLog) & (StaffLog.Date <= me) DO
   IF ~IsDischargeStaffLog() THEN
    RESTORE(StaffLog);
    RETURN 0;
   END;
  END; (* WHILE OCCURE(StaffLog) ... *)
  RESTORE(StaffLog);
  RETURN 1;
 END {LastLogInAnyMonth};

 PUBLIC PROCEDURE LastLogInMonth(): SCAL[2];
 BEGIN
  RETURN LastLogInAnyMonth(Memo.gl_mb(), Memo.gl_me());
 END {LastLogInMonth};

 PUBLIC PROCEDURE CheckManyStaffLogInMonth(_ODate: LIKE(StaffLog.Date); P: DATE);
  VAR
   Found: SCAL[2];
 BEGIN
  L_General.Assert(OCCURE(StaffLog) & (_ODate=StaffLog.Date), " ਪ  ");
  L_General.Assert(~IsDischargeStaffLog(), "⨬ ਬ ਪ  㢮쭥");
  IF (~!Staff.EndDate) & (Staff.EndDate <= L_DatTim.MonthEnd(P)) THEN
   L_StdFrm.Choice("㤭 㢮 "+L_DatTim.DateStr(Staff.EndDate));
  END;
  IF (StaffLog.DateE < P) & (Staff.EndDate # StaffLog.DateE) THEN
   L_StdFrm.Choice(" ਪ  /  ⭮  " + L_DatTim.PeriodStr(P));
  END;
  L_General.Assert(StaffLog.Date <= L_DatTim.MonthEnd(P), "  㯨  ࠡ");
  Found:=0;
  SAVE(StaffLog);
  SAVE(SLKind);
  HISTCONF(L_DatTim.MonthEnd(P), Staff, StaffLog);
  WHILE OCCURE(StaffLog) & (StaffLog.Date > P) & ~Found DO
   CONFORM(StaffLog, SLKind);
   IF SLKind.Type = slkt_Move THEN
    L_StdFrm.Choice("⭨  ॢ  祭 !");
    Found:=1;
   END;
   PREV(StaffLog);
  END; (* WHILE OCCURE(StaffLog) ... *)
  RESTORE(StaffLog);
  RESTORE(SLKind);
 END {CheckManyStaffLogInMonth};

 PUBLIC PROCEDURE CheckManyStaffLog(_ODate: LIKE(StaffLog.Date));
 BEGIN
  CheckManyStaffLogInMonth(_ODate, Memo.ud_mb());
 END {CheckManyStaffLog};

 PUBLIC PROCEDURE PosToStaffLog(_TSN: LIKE(Staff.TSN); D: DATE; InState: SCAL[2]);
 BEGIN
  L_General.CallUs(OCCURE(Staff) & (Staff.TSN = _TSN));
  HISTCONF(D, Staff, StaffLog);
  IF InState THEN
   WHILE OCCURE(StaffLog) & IsDischargeStaffLog() DO
    PREV(StaffLog);
   END;
  END;
  L_General.Assert(OCCURE(StaffLog), "⭨ "+_TSN+"  "+L_DatTim.DateStr(D)+"   㯨  ࠡ");
 END {PosToStaffLog};

 PUBLIC PROCEDURE E_GetBegInFirm(D: DATE): DATE;
  VAR
   DefBiF: DATE;
 BEGIN
  IF P_Staff.HasActualStaffPro(Staff.TSN, D, P_Staff.P_BegInFirm) THEN
   DefBiF:=L_Prop.GetDateFromStr(StaffPro.Value, 1);
  ELSE
   IF D >= 01\09\2008 THEN (* 0065919 *)
    DefBiF:=L_Man.GetTotTakeOnDate(D, 0);
   ELSE
    DefBiF:=L_Man.GetRealBegDate(D);
   END;
   IF DefBiF # L_DatTim.Per(DefBiF) THEN
    DefBiF:=L_DatTim.NextPer(DefBiF);
   END;
  END;
  RETURN L_EC.ExecE_Func_Date(D, PROCREF(E_Staff.GetBegInFirm), DefBiF);
 END {E_GetBegInFirm};

 PUBLIC PROCEDURE GetOfficerBonus(P: DATE): NUMERIC[3];
 BEGIN
  RETURN P_Officer.GetOfcBonus(0, P);
 END {GetOfficerBonus};

 PUBLIC PROCEDURE GetOfficerHarm(P: DATE; N: SCAL[2]): NUMERIC[1];
  VAR
   _Value: LIKE(OfcPro.Value);
 BEGIN
  IF N = 0 THEN
   _Value:=P_Officer.GetProValueSoft(Officer.Sort, Officer.Officer, L_DatTim.MonthEnd(P), P_Officer.P_OfcHarm);
  ELSE
   _Value:=P_Officer.GetProValueSoft(Officer.Sort, Officer.Officer, L_DatTim.MonthEnd(P), P_Officer.P_OfcIntens);
  END;
  IF !_Value THEN
   RETURN 0;
  ELSE
   RETURN STRTOFLD(_Value, NUMERIC);
  END;
 END {GetOfficerHarm};

 PUBLIC PROCEDURE GetStaffContract_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(cnt_Pool_Full, Staff.Contract);
 END {GetStaffContract_asStr};

 PUBLIC PROCEDURE GetStaffLogContDTyp_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(cdt_Pool_Full, StaffLog.ContDTyp);
 END {GetStaffLogContDTyp_asStr};

 PRIVATE PROCEDURE Password(D: DATE; Index: NUMERIC[0]): STRING[];
  VAR
   Found: SCAL[2];
 BEGIN
  Found:=0;
  CONFORM(Staff, Deduct);
  WHILE OCCURE(Deduct) DO
   IF L_PDoc.IsActiveSpecDeduct(D) THEN
    L_General.Assert(~Found, "    楢   "+L_DatTim.DateStr(D)+"|⭨ "+Staff.TSN);
    SAVE(Deduct);
    Found:=1;
   END;
   NEXT(Deduct);
  END; (* WHILE OCCURE(Deduct) ... *)
  IF Found THEN
   RESTORE(Deduct);
  END;
  IF Found THEN
   RETURN Deduct.PAddr[Index];
  ELSE
   RETURN "";
  END;
 END {Password};

 PRIVATE PROCEDURE GetTranslitName(d: DATE): STRING[];
  VAR
   s: STRING[];
 BEGIN
  s:=Password(d, 1);
  IF s="" THEN
   CONFORM(Staff, Man);
   s:=L_Russia.RussianToTransliteration(Man.Name);
  END;
  RETURN s;
 END {GetTranslitName};

 PUBLIC PROCEDURE GetStaffLatinName(D: DATE): STRING[];
  VAR
   s: STRING[];
 BEGIN
  s:=GetTranslitName(D);
  RETURN Str.Item(s, " ", 1) + " " + Str.Item(s, " ", 0);
 END {GetStaffLatinName};

 PUBLIC PROCEDURE GetDirtyTypPower_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(dtpwr_pool, DirtyTyp.Power);
 END {GetDirtyTypPower_asStr};

 PUBLIC PROCEDURE GetDirtyTypInjPower_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(dtinj_pool, DirtyTyp.InjPower);
 END {GetDirtyTypInjPower_asStr};

 PUBLIC PROCEDURE OfficerHarmPwr(D: DATE): LIKE(DirtyTyp.Power);
 BEGIN
  SEARCH(DirtyTyp, DirtyTyp, , P_Officer.GetP_LCDirtyTyp(Officer.Sort, Officer.Officer, D));
  RETURN DirtyTyp.Power;
 END {OfficerHarmPwr};

 PUBLIC PROCEDURE ClassName(_Post: LIKE(Post.Post); _Class: LIKE(StaffLog.Class)): STRING[];
 BEGIN
  L_General.CallUs(SEARCH(Post, Post, _Post));
  IF Post.ClsName = pcn_NoClasses THEN
   RETURN "";
  ELSE
   RETURN _Class + " " + L_Str.PoolItem(pcn_Pool_Full, Post.ClsName);
  END;
 END {ClassName};

 PUBLIC PROCEDURE GetStaffLogClass_asStr(): STRING[];
 BEGIN
  CONFORM(StaffLog, Officer);
  RETURN ClassName(Officer.Post, StaffLog.Class);
 END {GetStaffLogClass_asStr};

 PUBLIC PROCEDURE GetWagePayLType_AsStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(" | ", WagePayL.Type);
 END {GetWagePayLType_AsStr};

 PUBLIC PROCEDURE GetStaffLogType(): LIKE(SLKind.Type);
 BEGIN
  CONFORM(StaffLog, SLKind);
  RETURN SLKind.Type;
 END {GetStaffLogType};

 PUBLIC PROCEDURE GetAvans(_TSN      : LIKE(Staff.TSN);
                           _Date     : DATE;
                           VAR
                           AvansbySum: SCAL[2];
                           VAR
                           Avans     : NUMERIC[2]);
 BEGIN
  IF P_Staff.HasActualStaffPro(_TSN, _Date, P_Staff.P_Advance) THEN
   AvansbySum:=1;
   Avans     :=STRTOFLD(StaffPro.Value, FLOAT);
  ELSE
   SETSEL(StaffLog, TSN, _TSN);
   L_General.CallUs(SRCINSEL(StaffLog, LE, L_DatTim.MonthEnd(_Date)));
   CONFORM(StaffLog, Officer);
   P_Union.GetAvans(Officer.Union, _Date, L_Prop.pc_Strong, AvansbySum, Avans);
  END;
 END {GetAvans};

 PUBLIC PROCEDURE GetSLKindIsTemp_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem("ﭭ|६", SLKind.IsTemp);
 END {GetSLKindIsTemp_asStr};

 PUBLIC PROCEDURE GetSLKindReason(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF ~!SLKind.LCA_No THEN
   Result:= " " + SLKind.LCA_No;
   IF ~!SLKind.LCA_Part THEN
    Result:=L_Str.AddStrDlm(Result, ", ") + " "    + SLKind.LCA_Part;
   END;
   IF ~!SLKind.LCA_Prg THEN
    Result:=L_Str.AddStrDlm(Result, ", ") + "㭪 "    + SLKind.LCA_Prg;
   END;
   IF ~!SLKind.LCA_SPrg THEN
    Result:=L_Str.AddStrDlm(Result, ", ") + "㭪 " + SLKind.LCA_SPrg;
   END;
   Result:=Result + " 㤮  ᨩ᪮ 樨.";
  ELSE
   Result:=SLKind.NormAct;
  END;
  RETURN Result;
 END {GetSLKindReason};

 PUBLIC PROCEDURE StandOnShiftByShiftNum(_Sort    : LIKE(Sort.Sort);
                                         _Officer : LIKE(Officer.Officer);
                                         _Number  : LIKE(Shift.Number));
  VAR
   _Shift: LIKE(Shift.Shift);
 BEGIN
  IF _Number = 0 THEN
   _Shift:=00;
  ELSE
   SETEMPTY(_Shift);
   SELECT(OfcShift, Officer, , _Sort, _Officer);
   WHILE OCCURE(OfcShift) DO
    CONFORM(OfcShift, Shift);
    IF Shift.Number = _Number THEN
     L_General.Assert(!_Shift | (_Shift = Shift.Shift),
                     " ࠡ祬  " + _Sort + " " + _Officer +
                     " ⨬ 祭 ᬥ");
     _Shift:=Shift.Shift;
    END;
    NEXT(OfcShift);
   END; (* WHILE OCCURE(OfcShift) ... *)
  END;
  L_General.Assert(~!_Shift,
                   " 筥 ᬥ    㪠  ᬥ  ஬ " + _Number);
  L_General.Assert(SEARCH(Shift, Shift, _Shift),
                   " ࠢ筨 ᬥ  ᬥ   " + _Shift);
 END {StandOnShiftByShiftNum};

 PUBLIC PROCEDURE CheckStringAsTSN(D: DATE; Value: STRING[]; SpecialCheck: PROC);
 BEGIN
  L_General.Assert(SEARCH(Staff, TSN, Value), "  ࠡ⭨ " + Value);
  HISTCONF(D, Staff, StaffLog);
  L_General.Assert(OCCURE(StaffLog) & InOrder(D) & ~IsDischargeStaffLog(),
                   "⭨ " + Value + "  ⮨    " +
                   L_DatTim.DateStr(D));
  IF ~!SpecialCheck THEN
   SpecialCheck();
  END;
 END {CheckStringAsTSN};

 PUBLIC PROCEDURE wordSetWagePayVar(D: DATE; Root: STRING[]; forceEmpty: SCAL[2]);
  VAR
   p                : STRING[];
   trgPay           : NUMERIC[2];
   trgType,
   trgByHour,
   trgPayAsStr      : STRING[];
   trgLastChangeDate: DATE;
 BEGIN
  SETEMPTY(trgPay, trgType, trgByHour, trgLastChangeDate, trgPayAsStr);
  IF ~forceEmpty THEN
   IF    L_PRoll.E_UsePersMPay(D) & (L_PRoll.GetPersAddValue(D) # 0) THEN
    trgPay           :=Adding.Value;
    trgByHour        :="";
    trgType          :=" ";
    trgLastChangeDate:=Adding.From;
   ELSIF OCCURE(WagePayL) THEN
    trgPay           :=WagePayL.Pay[StaffLog.Class];
    IF (PRECISIONOF(trgPay) = 3) & ((trgPay*1000 MOD 10) # 0) THEN
     p:="3-";
    ELSE
     p:="2-";
    END;
    trgPayAsStr      :=FLDTOSTR(trgPay, p, 0);
    trgByHour        :=L_Str.PoolItem("|", WagePayL.Type);
    trgType          :=GetWagePayLType_AsStr();
    trgLastChangeDate:=WagePayL.Period;
   END;
  END;

  L_MSO.wordSetMoneyVar(Root+".Pay",            D, trgPay);
  IF ~!trgPayAsStr THEN
   L_MSO.wordSetVar(Root+".Pay", trgPayAsStr);
  END;
  L_MSO.wordSetVar     (Root+".ByHour",         trgByHour);
  L_MSO.wordSetVar     (Root+".Type",           trgType);
  L_MSO.wordSetDateVar (Root+".LastChangeDate", trgLastChangeDate);
 END {wordSetWagePayVar};

 PRIVATE PROCEDURE _wordSetVarsByFile_wAliasE(File, r, Root: STRING[]; ForceEmpty: SCAL[2]);
 BEGIN
  L_MSO.wordSetVarsByFile_wAliasE(File, Root, ForceEmpty);
  L_MSO.wordSetVarsByFile_wAliasE(File, r,    ForceEmpty);
 END {_wordSetVarsByFile_wAliasE};

 PUBLIC PROCEDURE Sort_ParentsName(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF ~!Sort.Parent THEN
   Result:=Str.Condense(L_DBD.BuildHierarchyString("Sort", 200, 1));
  ELSE
   Result:="--";
  END;
  RETURN Result;
 END {Sort_ParentsName};

 PUBLIC PROCEDURE StaffFileFamily(D, SLDate: DATE; Alias: STRING[]);
  VAR
   r,
   Root: STRING[];
   i   : NUMERIC[0];
 BEGIN
  HISTCONF(SLDate, Staff, StaffLog);
  CONFORM(StaffLog, RegMain);
  CONFORM(StaffLog, SLKind);
  CONFORM(StaffLog, Officer);
  CONFORM(Officer,  Sort);
  CONFORM(Officer,  Post);
  CONFORM(Officer,  Union);
  CONFORM(Officer,  PayKind);
  CONFORM(Officer,  WagePay);
  HISTCONF(D, WagePay, WagePayL);
  CONFORM(Officer,  AlType);
  HISTCONF(D, AlType, AlTypeL);
  L_MSO.wordSetVarsByFile_wAliasE("Staff", Alias, 0);
  IF    Alias = "oStaff" THEN
   r:="o";
  ELSIF Alias = "Staff"  THEN
   r:="";
  ELSE
   r:=Alias;
  END;
  Root:=Alias;
  L_MSO.wordSetDateVar(Root+".RealBegDate", L_Man.GetTakeOnDate(D));
  _wordSetVarsByFile_wAliasE("StaffLog", r + "StaffLog", Root + ".StaffLog", ~OCCURE(StaffLog));
  Root:=Root + ".StaffLog";
  _wordSetVarsByFile_wAliasE("SLKind",   r + "SLKind",   Root + ".SLKind",   ~OCCURE(SLKind));
  L_MSO.wordSetVar(r    + ".SLKind.Reason", GetSLKindReason());
  L_MSO.wordSetVar(Root + ".SLKind.Reason", GetSLKindReason());
  _wordSetVarsByFile_wAliasE("RegMain",  r + "RegMain",  Root + ".RegMain",  ~OCCURE(RegMain));
  _wordSetVarsByFile_wAliasE("Officer",  r + "Officer",  Root + ".Officer",  ~OCCURE(Officer));
  Root:=Root + ".Officer";
  IF OfficerHarmPwr(D) <= dtpwr_Acceptable THEN
   IF OCCURE(AlType) & (AlTypeL.Duration[ati_HarmPwr] > 0) THEN
    L_MSO.wordSetVar(Root + ".HarmPwr", "।");
   END;
  END;
  _wordSetVarsByFile_wAliasE("AlType",   r + "AlType",   Root + ".AlType",   ~OCCURE(AlType));
  IF OCCURE(AlTypeL) THEN
   i:=0;
   WHILE i <= HIGH(AlTypeL.Duration) DO
    L_MSO.wordSetVar(r +     "AlType.Duration" + L_MSO.IndexStr(i), L_Str.IntStr(AlTypeL.Duration[i]));
    L_MSO.wordSetVar(Root + ".AlType.Duration" + L_MSO.IndexStr(i), L_Str.IntStr(AlTypeL.Duration[i]));
    INC(i);
   END;
  END;
  _wordSetVarsByFile_wAliasE("DirtyTyp", r + "DirtyTyp", Root + ".DirtyTyp", ~OCCURE(DirtyTyp));
  _wordSetVarsByFile_wAliasE("Sort",     r + "Sort",     Root + ".Sort",     ~OCCURE(Sort));
  _wordSetVarsByFile_wAliasE("Post",     r + "Post",     Root + ".Post",     ~OCCURE(Post));
  _wordSetVarsByFile_wAliasE("Union",    r + "Union",    Root + ".Union",    ~OCCURE(Union));
  _wordSetVarsByFile_wAliasE("PayKind",  r + "PayKind",  Root + ".PayKind",  ~OCCURE(PayKind));
  _wordSetVarsByFile_wAliasE("WagePay",  r + "WagePay",  Root + ".WagePay",  ~OCCURE(WagePay));
  wordSetWagePayVar(D, Root + ".WagePay", 0);
  wordSetWagePayVar(D, r + "WagePay", 0);
  Root:=Root + ".Sort";
  L_MSO.wordSetVar(Root + ".ParentsName", Sort_ParentsName());
  Root:=Root + ".Depart";
  L_MSO.wordSetVar(Root + ".Depart", getDepart());
  L_MSO.wordSetVar(Root + ".Name",   getDepartName());
  Root:=Root + ".Service";
  L_MSO.wordSetVar(Root + ".Service", getService());
  L_MSO.wordSetVar(Root + ".Name",    getServiceName());
  L_MSO.wordSetVar("CodexName", Str.Item(" | ", "|", (D < 01\02\2002)));
 END {StaffFileFamily};

 PUBLIC PROCEDURE extPutScalablePhoto(D: DATE; Width: NUMERIC[0]; StrongExistence: SCAL[2]);
  VAR
   _filename: STRING[];
 BEGIN
  _filename:=P_Man.GetFullPhotoFileName(P_Man.GetManProSoft(Man.Man, D, P_Man.P_ManPhoto));
  IF FIO.Exists(_filename) THEN
   L_MSO.wordSetBkm("Face", "");
   L_MSO.wordSetPic("Face",  _filename, Width, -1);
  ELSE
   L_General.Assert(~StrongExistence, "  " + L_Str.FixedIntStr(Man.Man, 6) + "  ⮣䨨");
   L_MSO.wordSetBkm("Face", "  ");
  END;
 END {extPutScalablePhoto};

 PUBLIC PROCEDURE PutScalablePhoto(D: DATE; Width: NUMERIC[0]);
 BEGIN
  extPutScalablePhoto(D, Width, 0);
 END {PutScalablePhoto};

 PUBLIC PROCEDURE PutPhoto(D: DATE);
 BEGIN
  PutScalablePhoto(D, 30);
 END {PutPhoto};

 PUBLIC PROCEDURE WordSetManName(Root: STRING[]);
 BEGIN
  L_MSO.SetValueDerivativesOnDate(Root + "Man.Name", Man.Name, "SetManNameVar", SYSDATE());
 END {WordSetManName};

 PUBLIC PROCEDURE SetSignerVarsByStaff(Alias: STRING[]; D: DATE; SignerTSN: LIKE(Staff.TSN));
 BEGIN
  SAVE(Staff);
  SEARCH(Staff, TSN, , SignerTSN);
  CONFORM(Staff, Man);
  L_MSO.SetValueDerivatives(Alias+".Name", Man.Name, "SetManNameVar");
  L_MSO.wordSetVar(Alias+".Post.Name", P_Firm.GetManAttrByTSN(SignerTSN, D, P_Firm.mpt_ManPostName));
  L_MSO.wordSetVar(Alias+".ExtWrkTel", P_Firm.GetManAttrByTSN(SignerTSN, D, P_Firm.mpt_ManExtWrkTel));
  RESTORE(Staff);
 END {SetSignerVarsByStaff};

 PUBLIC PROCEDURE E_asLeader(D: DATE; Rights: NUMERIC[0]): LIKE(SgnAuthR.SgnAuthR);
  VAR
   local: PROC;
 BEGIN
  local:=PROCREF(E_Staff.asLeader);
  IF ~!local THEN
   RETURN local(D, Rights);
  ELSE
   RETURN "";
  END;
 END {E_asLeader};

 PUBLIC PROCEDURE SetSignerVarsBySgnAuthR(Alias: STRING[]; D: DATE; asLeader: LIKE(SgnAuthR.SgnAuthR));
  VAR
   ser,
   num : STRING[];
 BEGIN
  L_General.Assert(P_Staff.AccessBySpdSrchV(P_Staff.P_SgnAuthR, asLeader, D),
                   "  ࠡ⭨, 騩 ࠢ  " + asLeader + "  " + L_DatTim.DateStr(D));
  SetSignerVarsByStaff(Alias, D, StaffPro.TSN);
  L_Prop.GetDocSerAndNum(StaffPro.DocNum, ser, num);
  L_MSO.wordSetVar(Alias+".LetterOfAttorney",
                   L_Prop.CombineDocDescription(L_Prop.getRecordElement(StaffPro.Value, 1), ser, num,
                                                StaffPro.DocGiveS, StaffPro.DocExpD, StaffPro.DocGiveD));
 END {SetSignerVarsBySgnAuthR};

 PUBLIC PROCEDURE SetTheDocSignerVars(D: DATE; DefaultTSN: LIKE(Staff.TSN); local: PROC);
 BEGIN
  IF ~!local THEN
   DefaultTSN:=local(D, DefaultTSN);
  END;
  SetSignerVarsByStaff("TheDoc.Signer", D, DefaultTSN);
 END {SetTheDocSignerVars};

 PUBLIC PROCEDURE extSet_AsLeaderVars(D: DATE; trgFirm: LIKE(Firm.Firm); asLeader: LIKE(SgnAuthR.SgnAuthR));
  VAR
   Dummy: SCAL[2];
 BEGIN
  IF ~!asLeader THEN
   SetSignerVarsBySgnAuthR("OwnFirm.asLeader", D, asLeader);
  ELSE
   Dummy:=P_Firm.StandOnFirmCtcByKindType(1, trgFirm, D, L_ctc.ckt_Leader);
   L_MSO.SetValueDerivatives("OwnFirm.asLeader.Name", FirmCtc.Name, "SetManNameVar");
   L_MSO.wordSetVar("OwnFirm.asLeader.INN", P_Firm.GetManINNByFirmCtc());
   L_MSO.wordSetVar("OwnFirm.asLeader.Post.Name", FirmCtc.ECKName);
   L_MSO.wordSetVar("OwnFirm.asLeader.ExtWrkTel", L_ctc.GetCtcVal(0, FirmCtc.Contact, D, L_ctc.cvc_Work, L_ctc.cvt_PhonePST));
   L_MSO.wordSetVar("OwnFirm.asLeader.LetterOfAttorney", P_Firm.FP_BasisOfLeaderActivity(trgFirm, D));
  END;
 END {extSet_AsLeaderVars};

 PUBLIC PROCEDURE Set_AsLeaderVars(D: DATE; asLeader: LIKE(SgnAuthR.SgnAuthR));
 BEGIN
  extSet_AsLeaderVars(D, GetFirmOfStaff(), asLeader);
 END {Set_AsLeaderVars};

 PUBLIC PROCEDURE GetLabourContractAttr(    D            : DATE;
                                        VAR trgLbCNbr    : STRING[];
                                        VAR trgLbCDate   : DATE;
                                        VAR trgKindOfWork: STRING[]);
 BEGIN
  L_General.Assert(OCCURE(StaffLog), " । ਪ  /  " + L_DatTim.DateStr(D));
  SETEMPTY(trgLbCNbr, trgLbCDate, trgKindOfWork);
  SAVE(StaffLog);
  L_Man.StandOnLastBegan(Staff.TSN, D);
  trgLbCNbr :=StaffLog.LbCNbr;
  trgLbCDate:=StaffLog.LbCDate;
  RESTORE(StaffLog);
  trgKindOfWork:=P_Officer.GetOfcProSoft(StaffLog.Sort, StaffLog.Officer, D, P_Officer.P_KindOfWork);
 END {GetLabourContractAttr};

 PRIVATE PROCEDURE E_IsGrossViolationEDOrderL(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Staff.IsGrossViolationEDOrderL), 1);
 END {E_IsGrossViolationEDOrderL};

 PRIVATE PROCEDURE CheckGrossViolationCorrEDOrder(D: DATE): SCAL[2];
  VAR
   curTSN: LIKE(Staff.TSN);
   curRow: LIKE(EDOrderL.Row);
   Result: SCAL[2];
 BEGIN
  SETEMPTY(Result);
  curTSN:=EDOrderL.TSN;
  curRow:=EDOrderL.Row;
  SAVE(EDOrderL);
  SAVE(EDOrder);
  SELECT(EDOrder, MEDOrder, , EDOrderL.EDOrder);
  LOOP
   IF ~OCCURE(EDOrder) THEN
    EXIT;
   END;
   IF SEARCH(EDOrderL, EDOrder, EDOrder.EDOrder, curRow) THEN
    L_General.CallUs(EDOrderL.TSN = curTSN);
    IF EDOrderL.Status = L_EDO.st_Passed THEN
     IF    EDOrderL.Type = L_EDO.type_Correct THEN
      Result:=E_IsGrossViolationEDOrderL(D);
     ELSIF EDOrderL.Type = L_EDO.type_Cancel THEN
      Result:=0;
     ELSE
      L_General.CallUs(0);
     END;
    ELSIF EDOrderL.Status = L_EDO.st_Canceled THEN
     Result:=CheckGrossViolationCorrEDOrder(D);
    ELSE
     L_General.CallUs(0);
    END;
    EXIT;
   END;
   NEXT(EDOrder);
  END; (* LOOP ... *)
  RESTORE(EDOrder);
  RESTORE(EDOrderL);
  L_General.CallUs(~!Result);
  RETURN Result;
 END {CheckGrossViolationCorrEDOrder};

 PUBLIC PROCEDURE HasGrossViolationEDOrder(_TSN: LIKE(Staff.TSN); From, UpTo: DATE): SCAL[2];
 BEGIN
  SETSEL(EDOrderL, TSN, _TSN);
  SRCINSEL(EDOrderL, GE, , From);
  WHILE OCCURE(EDOrderL) & (EDOrderL.Closed <= UpTo) DO
   CONFORM(EDOrderL, EDOrder);
   IF (EDOrderL.Type   = L_EDO.type_Initial) &
      (EDOrderL.EDOGrp = L_EDO.grp_Violation) THEN
    IF EDOrderL.Status = L_EDO.st_Passed THEN
     IF E_IsGrossViolationEDOrderL(EDOrder.Date) THEN
      RETURN 1;
     END;
    ELSE
     IF CheckGrossViolationCorrEDOrder(EDOrder.Date) THEN
      RETURN 1;
     END;
    END;
   END; (* IF EDOrderL.Type ... *)
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
  RETURN 0;
 END {HasGrossViolationEDOrder};

 PUBLIC PROCEDURE GetStaffMyPlace(D: DATE): LIKE(MyPlace.MyPlace);
 BEGIN
  PosToStaffLog(Staff.TSN, D, 0);
  RETURN P_Sort.GetMyPlace(StaffLog.Sort, D);
 END {GetStaffMyPlace};

 PUBLIC PROCEDURE IsBossOfficer(curSort   : LIKE(Officer.Sort);
                                curOfficer: LIKE(Officer.Officer);
                                trgSort   : LIKE(Officer.Sort);
                                trgOfficer: LIKE(Officer.Officer)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SAVE(Officer);
  SELECT(Officer, Boss, , curSort, curOfficer);
  WHILE OCCURE(Officer) & ~Result DO
   IF (Officer.Sort = trgSort) & (Officer.Officer = trgOfficer) THEN
    Result:=1;
   ELSE
    Result:=IsBossOfficer(Officer.Sort, Officer.Officer, trgSort, trgOfficer);
   END;
   NEXT(Officer);
  END;
  RESTORE(Officer);
  RETURN Result;
 END {IsBossOfficer};

 PUBLIC PROCEDURE GetDepartBossOfficer(    curSort   : LIKE(Officer.Sort);
                                           curOfficer: LIKE(Officer.Officer);
                                       VAR resSort   : LIKE(Officer.Sort);
                                       VAR resOfficer: LIKE(Officer.Officer));
  VAR
   curDepart: LIKE(Sort.Sort);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH(Officer, Officer, , curSort, curOfficer);
   curDepart:=getDepart();
   LOOP
    resSort   :=Officer.Sort;
    resOfficer:=Officer.Officer;
    IF ~!Officer.BossSrt & SEARCH(Officer, Officer, Officer.BossSrt, Officer.BossOfc) THEN
     IF curDepart # getDepart() THEN
      EXIT; (* get it *)
     END;
    ELSE
     EXIT; (* capo di capi *)
    END; (* IF ~!Officer.BossSrt *)
   END; (* LOOP *)
  EXCEPT
  END; (* TRY *)
 END {GetDepartBossOfficer};

 PUBLIC PROCEDURE CheckVeritableSort(Reason: STRING[]);
 BEGIN
  IF ~!TABLE.Get("Sort").Fields("Leaf") THEN
   IF ~Sort.Leaf THEN
    IF ~!Reason THEN
     Reason:=L_StdFrm.HR() + "(" + Reason + ")";
    END;
    L_General.Error(" ࠧ (" + Sort.Sort + ")   ᥪ஬" + Reason);
   END;
  END;
 END {CheckVeritableSort};

(*-------------BEGIN OF NORMAL ENVIRONMENT--------------------------*)

 PUBLIC PROCEDURE E_StaffNormalLeeway(P: DATE): NUMERIC[0];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(P, PROCREF(E_Staff.StaffNormalLeeway), 5);
 END {E_StaffNormalLeeway};

 PUBLIC PROCEDURE E_NeedCheckOfficerExcess(P: DATE): SCAL[3];
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(P, PROCREF(E_Staff.NeedCheckOfficerExcess), 0);
 END {E_NeedCheckOfficerExcess};

 PUBLIC PROCEDURE E_NeedCheckActualAdding(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_Staff.NeedCheckActualAdding), 1);
 END {E_NeedCheckActualAdding};

 PUBLIC PROCEDURE E_DefaultLabourContractNumeration(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_Staff.DefaultLabourContractNumeration), 0);
 END {E_DefaultLabourContractNumeration};

 PUBLIC PROCEDURE E_IsOutsider(D: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Staff.IsOutsider);
  IF ~!Local THEN
   RETURN Local(D);
  ELSE
   RETURN ~L_Man.intInteractiveAccessStaffByMan(0, 1);
  END;
 END {E_IsOutsider};

 PUBLIC PROCEDURE E_GetPassTemplateName(Outsider: SCAL[2]): STRING[];
  VAR
   Local : PROC;
   Result: STRING[];
 BEGIN
  Local:=PROCREF(E_Staff.GetPassTemplateName);
  IF !Local THEN
   IF Outsider THEN
    Result:="PassOut_01";
   ELSE
    Result:="PassInt_01";
   END;
  ELSE
   Result:=Local(SYSDATE());
  END;
  RETURN Result;
 END {E_GetPassTemplateName};

 PUBLIC PROCEDURE PassIntPrepare(D: DATE; PhotoSize: NUMERIC[1]);
 BEGIN
  L_MSO.wordSetUnicodeStringVar("Staff.BarCode", GetBarCode_bck_IdIn20(), L_Print.cp_ISO_8859_1_Latin_I);
  L_MSO.wordSetDateVar("Staff.Man.Pass.DocGiveD", SYSDATE());
  PutScalablePhoto(D, PhotoSize);
 END {PassIntPrepare};

 PUBLIC PROCEDURE PassOutPrepare(D: DATE; PhotoSize: NUMERIC[1]);
  VAR
   Outsider_Firm          : LIKE(Firm.Firm);
   Outsider_Aim           : STRING[];
   Outsider_ResponsibleTSN: LIKE(Staff.TSN);
 BEGIN
  L_MSO.wordSetVarsByFile("Man");
  WordSetManName("");
  L_MSO.wordSetUnicodeStringVar("Man.BarCode", L_Man.GetBarCode_bck_IdIn20(), L_Print.cp_ISO_8859_1_Latin_I);
  L_MSO.wordSetDateVar("Man.Pass.DocGiveD", SYSDATE());
  PutScalablePhoto(D, PhotoSize);
  P_Man.GetAccessOutsiderInf(Man.Man, D, Outsider_Firm, Outsider_Aim, Outsider_ResponsibleTSN);
  L_MSO.wordSetVarsByFile_wPrefixE("Firm" ,"Man.", ~SEARCH(Firm, Firm, Outsider_Firm));
 END {PassOutPrepare};

 PUBLIC PROCEDURE GetBarCode_bck_IdIn20(): STRING[];
 BEGIN
  RETURN L_BarCode.toFont_IntP36DlTt(L_XDoc.BarCode(L_XDoc.bck_IdIn20,
                                     L_XDoc.xdt_Staff,
                                     L_XDoc.EmptyXDocKind,
                                     Staff.TSN,
                                     0));
 END {GetBarCode_bck_IdIn20};

 PUBLIC PROCEDURE StreamPrintDoc_BySort(DocNameForStreamPrint: STRING[]);
 BEGIN
  L_General.Assert(ACCESS(Sort), " ⠭ ᥪ");
  L_StdFrm.Question("⮪  㬥 '" + DocNameForStreamPrint + "'|" +
                    "ᥬ ࠡ⭨ ᥪ " + Sort.Sort + " " + Sort.Name);
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF rInState(SYSDATE()) & rInState(Memo.ud_cd()) & (StaffLog.Sort = Sort.Sort) THEN
    CALL(O_Staff.StreamPrintDoc(DocNameForStreamPrint));
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {StreamPrintDoc_BySort};

 PUBLIC PROCEDURE StreamPrintDoc_ByUnion(DocNameForStreamPrint: STRING[]);
 BEGIN
  L_General.Assert(ACCESS(Union), " ⠭ ⥣");
  L_StdFrm.Question("⮪  㬥 '" + DocNameForStreamPrint + "'|" +
                    "ᥬ ࠡ⭨ ⥣ਨ " + Union.Union + " " + Union.Name);
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF rInState(SYSDATE()) & rInState(Memo.ud_cd()) THEN
    CONFORM(StaffLog, Officer);
    IF Officer.Union = Union.Union THEN
     CALL(O_Staff.StreamPrintDoc(DocNameForStreamPrint));
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {StreamPrintDoc_ByUnion};

 PUBLIC PROCEDURE getSortDprt(trgSort: LIKE(Sort.Sort)): LIKE(Sort.Sort);
  VAR
   Result: LIKE(Sort.Sort);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH(Sort, Sort, , trgSort);
   WHILE ~Sort.isDprt & ~!Sort.Parent DO
    SEARCH(Sort, Sort, , Sort.Parent);
   END;
   Result:=Sort.Sort;
  EXCEPT
  END;
  RETURN Result;
 END {getSortDprt};

 PUBLIC PROCEDURE getDepart(): LIKE(Sort.Sort);
 BEGIN
  RETURN getSortDprt(Officer.Sort);
 END {getDepart};

 PUBLIC PROCEDURE getService(): LIKE(Sort.Sort);
  VAR
   Result: LIKE(Sort.Sort);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   CONFORM(Officer, Sort);
   WHILE ~!Sort.Parent DO
    SEARCH(Sort, Sort, , Sort.Parent);
   END;
   Result:=Sort.Sort;
  EXCEPT
  END;
  RETURN Result;
 END {getService};

 PRIVATE PROCEDURE getSortName(trgSort: LIKE(Sort.Sort)): STRING[];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH(Sort, Sort, , trgSort);
   RETURN Sort.Name;
  EXCEPT
  END;
 END {getSortName};

 PUBLIC PROCEDURE getSortDprtName(trgSort: LIKE(Sort.Sort)): STRING[];
 BEGIN
  RETURN getSortName(getSortDprt(trgSort));
 END {getSortDprtName};

 PUBLIC PROCEDURE getDepartName(): STRING[];
 BEGIN
  RETURN getSortDprtName(Officer.Sort);
 END {getDepartName};

 PUBLIC PROCEDURE getServiceName(): STRING[];
 BEGIN
  RETURN getSortName(getService());
 END {getServiceName};

 PUBLIC PROCEDURE IsLabourContract(trgContract: LIKE(Staff.Contract)): SCAL[2];
 BEGIN
  RETURN (trgContract = cnt_Basic) | (trgContract = cnt_ExternalCombine) | (trgContract = cnt_InternalCombine);
 END {IsLabourContract};

END.
