(*
%Copyright   (c) Polak IT
%Author      20.02.2005 13:59:58 POLAK\San
%Purpose     ⥪  প "⥩"
%Type        library
%Specific    SYS
%Modified    25.12.2013 11:16:56 POLAK\LDA
%Environment
*)

 MODULE L_Stock [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tStorageKind   = SCAL[100];
  tStorageType   = SCAL[9];
  tStoringType   = SCAL[8];
  tFixedStorages = LIKE(Storage.Storage)[12];

 PUBLIC PERMANENT VAR
  defaultStorage: LIKE(Storage.Storage);
  dsAssigned    : SCAL[2];

 PUBLIC CONST
  zeroStorage = 0000000;

  st_Stock       = 0;
  st_Distributor = 1;
  st_TckBag      = 4;
  st_AdvHolder   = 5;
  st_Contract    = 6;
  st_Car         = 7;
  st_MyFirm      = 8;

  st_Pool    = "|稪 | | |⭠ 㬪|⭮ ||࠭ᯮ⭮ ।⢮|  楫";
  st_Pool_PL = "|稪 | | | 㬪| ||࠭ᯮ ।⢠|  楫";
  st_Pool_SH = "|| | |||||";

  st_Pool_Selectable = "|稪 ";

  storingType_Usual     = 0;
  storingType_Fuel      = 1;
  storingType_FuelTanks = 2;
  storingType_TckOffice = 3;
  storingType_Tickets   = 4;
  storingType_Repair    = 5;
  storingType_Oil       = 6;
  storingType_OutFuel   = 7;

(*
  storingType_Pool = "筮|| |樮 ⭠ |࠭ ⭮ த樨||᫮ࠢ|஭ ";
*)
  storingType_Pool = "筮|| |樮 ⭠ |࠭ ⭮ த樨|";

  sk_MyFirm    = 95;
  sk_TckBag    = 96;
  sk_Car       = 97;
  sk_Contract  = 98;
  sk_AdvHolder = 99;

  acspnt_InternalMDocModification = 0000005;
  acspnt_ExternalMDocModification = 0000043;

 IMPORT L_General, L_DatTim, L_Str, L_MSO, L_BarCode, L_XDoc, L_XObj,
        L_MathR, L_Acnt, Str, P_Officer, P_Man, L_Staff, P_Storage,
        P_Firm, Memo, L_StdFrm, L_AcsPnt, L_qs, L_SysLog;

 PUBLIC PROCEDURE PositionOnStorage(trgStorage: LIKE(Storage.Storage));
 BEGIN
  L_General.CallUs(SEARCH(Storage, Storage, trgStorage));
 END {PositionOnStorage};

 PUBLIC PROCEDURE GetStorageFixedStaff(trgStorage: LIKE(Storage.Storage); D: DATE): LIKE(Staff.TSN);
  VAR
   Result: LIKE(Staff.TSN);
 BEGIN
  SAVE(StrgLog);
  SETSEL(StrgLog, Storage, trgStorage);
  IF SRCINSEL(StrgLog, LE, D) & (StrgLog.Till > D) THEN
   Result:=StrgLog.TSN;
  ELSE
   SETEMPTY(Result);
  END;
  RESTORE(StrgLog);
  RETURN Result;
 END {GetStorageFixedStaff};

 PRIVATE PROCEDURE E_AmountOfStaffFixedTckBags(D: DATE): NUMERIC[0];
 BEGIN
  IF L_General.GetAPSiteID() = "84" THEN
   RETURN 2;
  ELSE
   RETURN 1;
  END;
 END {E_AmountOfStaffFixedTckBags};

 PRIVATE PROCEDURE gsfs_Pass(trgTSN    : LIKE(Staff.TSN);
                             trgType   : tStorageType;
                             D         : DATE;
                             trgStorage: LIKE(Storage.Storage);
                             _Date,
                             _Till     : DATE): tFixedStorages;
  VAR
   curIdx : NUMERIC[0];
   Msg    : STRING[];
   Dummy,
   Result : tFixedStorages;
 BEGIN
  SAVE(Storage);
  SAVE(StrgLog);
  curIdx:=0;
  SETEMPTY(Result);
  SELECT(StrgLog, TSN, , trgTSN);
  WHILE OCCURE(StrgLog) DO
   CONFORM(StrgLog, Storage);
   IF Storage.Type = trgType THEN
    IF !trgStorage THEN
     Dummy:=gsfs_Pass(trgTSN, trgType, D, Storage.Storage, StrgLog.Date, StrgLog.Till);
     IF L_DatTim.IsActive(D, StrgLog.Date, StrgLog.Till) THEN
      Result[curIdx]:=Storage.Storage;
      INC(curIdx);
     END;
    ELSIF Storage.Storage # trgStorage THEN
     IF L_DatTim.IsActiveInIntvl(_Date, _Till, StrgLog.Date, StrgLog.Till) THEN
      Result[curIdx]:=Storage.Storage;
      INC(curIdx);
     END;
    END;
   END;
   NEXT(StrgLog);
  END; (* WHILE OCCURE(StrgLog) ... *)
  RESTORE(StrgLog);
  RESTORE(Storage);
  IF ~!trgStorage & ((curIdx+1) > E_AmountOfStaffFixedTckBags(D)) THEN
   Result[curIdx]:=trgStorage;
   Msg:="誮  , ९  ࠡ⭨ " + trgTSN + ":||";
   WHILE curIdx >= 0 DO
    INC(Msg, Result[curIdx]);
    IF curIdx > 0 THEN
     INC(Msg, ", ");
    END;
    DEC(curIdx);
   END;
   L_General.Error(Msg);
  END; (* IF !trgStorage & (curIdx > 0) *)
  RETURN Result;
 END {gsfs_Pass};

 PUBLIC PROCEDURE GetStaffFixedStorage(trgTSN : LIKE(Staff.TSN);
                                       D      : DATE;
                                       trgType: tStorageType): LIKE(Storage.Storage);
  VAR
   i       : NUMERIC[0];
   List    : STRING[];
   Storages: tFixedStorages;
 BEGIN
  Storages:=gsfs_Pass(trgTSN, trgType, D, EMPTYOF(Storage.Storage), EMPTYOF(DATE), EMPTYOF(DATE));
  i:=0;
  IF ~!Storages[1] THEN
   SAVE(Storage);
   List:="";
   WHILE ~!Storages[i] DO
    SEARCH(Storage, Storage, , Storages[i]);
    INC(List, Storage.Storage + " " + Storage.Name + "|");
    INC(i);
   END;
   i:=L_StdFrm.ShowListAsMenu(List, " 롮 㬪 ");
   RESTORE(Storage);
  END;
  RETURN Storages[i];
 END {GetStaffFixedStorage};

 PUBLIC PROCEDURE GetStaffFixedStorages(trgTSN: LIKE(Staff.TSN); D: DATE; trgType: tStorageType): tFixedStorages;
 BEGIN
  RETURN gsfs_Pass(trgTSN, trgType, D, EMPTYOF(Storage.Storage), EMPTYOF(DATE), EMPTYOF(DATE));
 END {GetStaffFixedStorages};

 PRIVATE PROCEDURE Insert_Storage(trgType: tStorageType; trgMyFirm: P_Firm.tMyFirm; Begin: DATE);
 BEGIN
  SETEMPTY(Storage.Storage, Storage.Till, Storage.Name, Storage.Sign);
  Storage.Begin :=Begin;
  Storage.Type  :=trgType;
  Storage.MyFirm:=trgMyFirm;
  IF    Storage.Type = st_AdvHolder THEN
   Storage.StrgKind:=sk_AdvHolder;
  ELSIF Storage.Type = st_Contract THEN
   Storage.StrgKind:=sk_Contract;
  ELSIF Storage.Type = st_MyFirm THEN
   Storage.StrgKind:=sk_MyFirm;
  ELSE
   L_General.CallUs(0);
  END;
Storage.Apparent:=1;
  INSERT(Storage);
  CALL(Storage.Storage_OnAfterNoninteractiveInsert());
 END {Insert_Storage};

 PUBLIC PROCEDURE Replace_Storage();
 BEGIN
  REPLACE(Storage);
  CALL(Storage.Storage_OnAfterNoninteractiveEdit());
 END {Replace_Storage};

 PRIVATE PROCEDURE intSetName_AdvHolderStorage();
 BEGIN
  CONFORM(Staff, Man);
  Storage.Sign :=Staff.TSN;
  Storage.Name :=Str.Align(Man.Name, Str.MaxLength(Storage.Name)-Str.MaxLength(Storage.Sign), LEFT) + Storage.Sign;
  Storage.Begin:=Staff.BegDate;
  (*Storage.Till   DEDF.CheckInUse() . 0094784*)
  IF !Staff.EndDate THEN
   SETEMPTY(Storage.Till);
  END;
  Replace_Storage();
 END {intSetName_AdvHolderStorage};

 PUBLIC PROCEDURE SetName_AdvHolderStorage();
 BEGIN
  IF ~!Staff.Storage THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    CONFORM(Staff, Storage);
    L_SysLog.SingleMark_Init("Storage");
    intSetName_AdvHolderStorage();
    L_SysLog.SingleMark_Done("Storage");
   EXCEPT
   END; (* TRY *)
  END;
 END {SetName_AdvHolderStorage};

 PUBLIC PROCEDURE Obtain_AdvHolderStorage(trgTSN: LIKE(Staff.TSN); D: DATE): LIKE(Storage.Storage);
  VAR
   Result: LIKE(Storage.Storage);
 BEGIN
  SAVE(Staff);
  SEARCH(Staff, TSN, , trgTSN);
  IF ~!Staff.Storage THEN
   Result:=Staff.Storage;
  ELSE
   TRY [RESTORE_CURSORS(RC_ON)]
    L_AcsPnt.PassAccessPointIfAllowed(acspnt_InternalMDocModification);
    Insert_Storage(st_AdvHolder, Staff.MyFirm, D);
    Staff.Storage:=Storage.Storage;
    REPLACE(Staff);
    intSetName_AdvHolderStorage();
    L_SysLog.SingleMark_AutoBuild("Storage");
    Result:=Storage.Storage;
   EXCEPT
   END; (* TRY *)
  END;
  RESTORE(Staff);
  RETURN Result;
 END {Obtain_AdvHolderStorage};

 PRIVATE PROCEDURE intSetName_ContractStorage();
 BEGIN
  CONFORM(Contract, Firm);
  Storage.Sign :=Firm.Firm;
  Storage.Name :=Contract.Contract + " " + Str.Align(Contract.Name, 24, LEFT) + " " + Firm.Name;
  Storage.Begin:=Contract.Begin;
  Storage.Till :=Contract.Till;
  Replace_Storage();
 END {intSetName_ContractStorage};

 PUBLIC PROCEDURE SetName_ContractStorage();
 BEGIN
  IF ~!Contract.Storage THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    CONFORM(Contract, Storage);
    L_SysLog.SingleMark_Init("Storage");
    intSetName_ContractStorage();
    L_SysLog.SingleMark_Done("Storage");
   EXCEPT
   END; (* TRY *)
  END;
 END {SetName_ContractStorage};

 PUBLIC PROCEDURE Obtain_ContractStorage(trgContract: LIKE(Contract.Contract); D: DATE): LIKE(Storage.Storage);
  VAR
   Result: LIKE(Storage.Storage);
 BEGIN
  SAVE(Contract);
  SEARCH(Contract, Contract, , trgContract);
  IF ~!Contract.Storage THEN
   Result:=Contract.Storage;
  ELSE
   TRY [RESTORE_CURSORS(RC_ON)]
    L_AcsPnt.PassAccessPointIfAllowed(acspnt_ExternalMDocModification);
    Insert_Storage(st_Contract, Contract.MyFirm, D);
    Contract.Storage:=Storage.Storage;
    REPLACE(Contract);
    intSetName_ContractStorage();
    L_SysLog.SingleMark_AutoBuild("Storage");
    Result:=Storage.Storage;
   EXCEPT
   END; (* TRY *)
  END;
  RESTORE(Contract);
  RETURN Result;
 END {Obtain_ContractStorage};

 PRIVATE PROCEDURE intSetName_MyFirmStorage();
 BEGIN
  Storage.Sign :=MyFirm.MyFirm;
  Storage.Name :="  楫 " + MyFirm.vzSign;
  Storage.Begin:=MyFirm.Begin;
  Storage.Till :=MyFirm.Till;
  Replace_Storage();
 END {intSetName_MyFirmStorage};

 PUBLIC PROCEDURE SetName_MyFirmStorage();
 BEGIN
  L_General.CallUs(~!MyFirm.Storage);
  SAVE(Storage);
  SEARCH(Storage, Storage, , MyFirm.Storage);
  L_SysLog.SingleMark_Init("Storage");
  intSetName_MyFirmStorage();
  L_SysLog.SingleMark_Done("Storage");
  RESTORE(Storage);
 END {SetName_MyFirmStorage};

 PUBLIC PROCEDURE Obtain_MyFirmStorage(trgMyFirm: P_Firm.tMyFirm; D: DATE): LIKE(Storage.Storage);
  VAR
   Result: LIKE(Storage.Storage);
 BEGIN
  SAVE(MyFirm);
  L_General.CallUs(trgMyFirm # P_Firm.mf_Fict);
  SEARCH(MyFirm, MyFirm, , trgMyFirm);
  IF ~!MyFirm.Storage THEN
   Result:=MyFirm.Storage;
  ELSE
   SAVE(Storage);
   Insert_Storage(st_MyFirm, trgMyFirm, D);
   MyFirm.Storage:=Storage.Storage;
   REPLACE(MyFirm);
   intSetName_MyFirmStorage();
   L_SysLog.SingleMark_AutoBuild("Storage");
   Result:=Storage.Storage;
   RESTORE(Storage);
  END;
  RESTORE(MyFirm);
  RETURN Result;
 END {Obtain_MyFirmStorage};

 PUBLIC PROCEDURE PositionOn_mItem(trgMath: LIKE(Math.Math); trgStorage: LIKE(Storage.Storage)): SCAL[2];
 BEGIN
  RETURN SEARCH(mItem, Math, trgMath, trgStorage);
 END {PositionOn_mItem};

 PUBLIC PROCEDURE Obtain_mItem(trgMath: LIKE(Math.Math); trgStorage: LIKE(Storage.Storage));
  VAR
   _Origin: L_XObj.tOrigin;
 BEGIN
  IF ~PositionOn_mItem(trgMath, trgStorage) THEN
   mItem.Math   :=trgMath;
   mItem.Storage:=trgStorage;
   SAVE(Math);
   SEARCH(Math, Math, , trgMath);
   IF    Math.MathKind = L_MathR.mathk_Math THEN
    _Origin:=L_XObj.o_Math;
   ELSIF Math.MathKind = L_MathR.mathk_KeyAs THEN
    _Origin:=L_XObj.o_KeyAss;
   ELSE
    L_General.CallUs(0);
   END;
   RESTORE(Math);
   SAVE(Storage);
   SEARCH(Storage, Storage, , trgStorage);
   mItem.XObject:=L_XObj.GetNewXObject(_Origin, Storage.MyFirm);
   mItem.MyFirm:=Storage.MyFirm;
   INSERT(mItem);
   RESTORE(Storage);
  END;
 END {Obtain_mItem};

 PUBLIC PROCEDURE mItem_CheckAllIsZero(trgMath   : LIKE(Math.Math);
                                       trgStorage: LIKE(Storage.Storage);
                                       wRemove   : SCAL[2]);
 BEGIN
  INTEGRITY(NoAsk);
  IF    ~!trgMath THEN
   L_General.CallUs(!trgStorage);
   SELECT(mItem, Math, , trgMath);
  ELSIF ~!trgStorage THEN
   L_General.CallUs(!trgMath);
   SELECT(mItem, Storage, , trgStorage);
  ELSE
   L_General.CallUs(0);
  END;
  WHILE OCCURE(mItem) DO
   PROMPT("஢ઠ : ꥪ " + mItem.XObject);
   IF wRemove THEN
    L_XObj.BeforeOriginDelete(L_XObj.o_Math);
    REMOVE(mItem);
   ELSE
    L_XObj.CheckXCalcIsZero(mItem.XObject);
    NEXT(mItem);
   END;
  END; (* WHILE OCCURE(mItem) ... *)
  INTEGRITY(Off);
 END {mItem_CheckAllIsZero};

 PUBLIC PROCEDURE GetAuthorizedStoragesOfCurrentUser(VAR AuthorizedStorages              : P_Officer.tStorages;
                                                     VAR WriteOffFromAdvanceHolderAllowed: SCAL[2]);
  VAR
   curMan: LIKE(Man.Man);
   curTSN: LIKE(Staff.TSN);
 BEGIN
  SETEMPTY(AuthorizedStorages);
  WriteOffFromAdvanceHolderAllowed:=1;
  curMan:=P_Man.Try_curUSER2Man();
  IF ~!curMan THEN
   curTSN:=L_Staff.Man2TSN(SYSDATE(), curMan, EMPTYOF(P_Firm.tMyFirm), 0, 1);
   IF ~!curTSN THEN
    SEARCH(Staff, TSN, , curTSN);
    L_Staff.PosToStaffLog(Staff.TSN, SYSDATE(), 1);
    P_Officer.GetP_AuthorizedStorages(StaffLog.Sort, StaffLog.Officer, SYSDATE(),
                                      AuthorizedStorages, WriteOffFromAdvanceHolderAllowed);
   END;
  END;
 END {GetAuthorizedStoragesOfCurrentUser};

 PRIVATE PROCEDURE IsAuthorizedStorage(trgStorage: LIKE(Storage.Storage)): SCAL[2];
  VAR
   AuthorizedStorages              : P_Officer.tStorages;
   WriteOffFromAdvanceHolderAllowed: SCAL[2];
   Idx                             : NUMERIC[0];
 BEGIN
  GetAuthorizedStoragesOfCurrentUser(AuthorizedStorages, WriteOffFromAdvanceHolderAllowed);
  IF !AuthorizedStorages[0] THEN
   RETURN 1;
  ELSE
   Idx:=0;
   WHILE ~!AuthorizedStorages[Idx] DO
    IF AuthorizedStorages[Idx] = trgStorage THEN
     RETURN 1;
    END;
    INC(Idx);
   END;
   RETURN 0;
  END;
 END {IsAuthorizedStorage};

 PUBLIC PROCEDURE CheckIsSelectableStorage(trgStorage: LIKE(Storage.Storage));
 BEGIN
  SEARCH(Storage, Storage, , trgStorage);
  IF (Storage.Type = st_TckBag) | (Storage.Type = st_Contract) |
     (Storage.Type = st_Car)    | (Storage.Type = st_MyFirm) THEN
   L_General.Error(" ࠭ " + trgStorage + "    ࠭");
  END;
 END {CheckIsSelectableStorage};

 PUBLIC PROCEDURE CheckIsAuthorizedStorage(trgStorage: LIKE(Storage.Storage));
 BEGIN
  CheckIsSelectableStorage(trgStorage);
  L_General.Assert(IsAuthorizedStorage(trgStorage), "   㯠   ࠭ " + trgStorage);
 END {CheckIsAuthorizedStorage};

 PUBLIC PROCEDURE GetSingleAuthorizedStorage(): LIKE(Storage.Storage);
  VAR
   AuthorizedStorages              : P_Officer.tStorages;
   WriteOffFromAdvanceHolderAllowed: SCAL[2];
 BEGIN
  GetAuthorizedStoragesOfCurrentUser(AuthorizedStorages, WriteOffFromAdvanceHolderAllowed);
  IF WriteOffFromAdvanceHolderAllowed THEN
   RETURN EMPTYOF(Storage.Storage);
  ELSIF ~!AuthorizedStorages[0] & !AuthorizedStorages[1] THEN
   RETURN AuthorizedStorages[0];
  ELSE
   RETURN EMPTYOF(Storage.Storage);
  END;
 END {GetSingleAuthorizedStorage};

 PUBLIC PROCEDURE GetStorageType(trgStorage: LIKE(Storage.Storage)): LIKE(Storage.Type);
  VAR
   Result: LIKE(Storage.Type);
 BEGIN
  SAVE(Storage);
  SEARCH(Storage, Storage, , trgStorage);
  Result:=Storage.Type;
  RESTORE(Storage);
  RETURN Result;
 END {GetStorageType};

 PUBLIC PROCEDURE IsMyFirmStorage(trgStorage: LIKE(Storage.Storage)): SCAL[2];
 BEGIN
  RETURN GetStorageType(trgStorage) = st_MyFirm;
 END {IsMyFirmStorage};

 PUBLIC PROCEDURE DefaultStorage(): LIKE(Storage.Storage);
  VAR
   SingleAuthorizedStorage: LIKE(Storage.Storage);
 BEGIN
  SingleAuthorizedStorage:=GetSingleAuthorizedStorage();
  IF    ~!SingleAuthorizedStorage THEN                                RETURN SingleAuthorizedStorage;
  ELSIF L_General.VariableIsInitialized(dsAssigned) & dsAssigned THEN RETURN defaultStorage;
  ELSE                                                                RETURN EMPTYOF(Storage.Storage);
  END;
 END {DefaultStorage};

 PUBLIC PROCEDURE MDocStorage(): LIKE(Storage.Storage);
 BEGIN
  IF OCCURE(MDoc) & ~!MDoc.Storage THEN
   RETURN MDoc.Storage;
  ELSE
   RETURN DefaultStorage();
  END;
 END {MDocStorage};

 PUBLIC PROCEDURE IsFuelStationMDoc(): SCAL[2];
 BEGIN
  RETURN P_Storage.IsFuelStation(MDocStorage());
 END {IsFuelStationMDoc};

 PUBLIC PROCEDURE IsAnyFuelStationMDoc(): SCAL[2];
 BEGIN
  RETURN P_Storage.IsAnyFuelStation(MDocStorage());
 END {IsAnyFuelStationMDoc};

 PUBLIC PROCEDURE IsAnyFuelOrOilStationMDoc(): SCAL[2];
 BEGIN
  RETURN P_Storage.IsAnyFuelOrOilStation(MDocStorage());
 END {IsAnyFuelOrOilStationMDoc};

 PUBLIC PROCEDURE GetAnyStoringTypeStorage_Ext(    D          : DATE;
                                                   trgMyFirm  : P_Firm.tMyFirm;
                                                   StoringType: tStoringType;
                                               VAR trgStorage : LIKE(Storage.Storage);
                                               VAR qsResult   : L_qs.tQSearchResult;
                                               VAR Msg        : STRING[]);
 BEGIN
  SETEMPTY(Msg, trgStorage);
  SAVE(Storage);
  qsResult:=L_qs.StandOnUnique("Storage", P_Storage.qsa_StoringType,
                               P_Storage.qsa_SetStoringType_Set(trgMyFirm, StoringType), D);
  IF    qsResult = L_qs.qsr_None THEN
   Msg:=" ।  ࠭ '" + L_Str.PoolItem(storingType_Pool, StoringType) +
        "'  " + L_DatTim.DateStr(D);
  ELSIF qsResult = L_qs.qsr_Several THEN
   Msg:="   ࠭ '" + L_Str.PoolItem(storingType_Pool, StoringType) +
        "'  " + L_DatTim.DateStr(D);
  ELSIF qsResult = L_qs.qsr_Unique THEN
   trgStorage:=Storage.Storage;
  END;
  RESTORE(Storage);
 END {GetAnyStoringTypeStorage_Ext};

 PUBLIC PROCEDURE GetAnyStoringTypeStorage(D          : DATE;
                                           trgMyFirm  : P_Firm.tMyFirm;
                                           StoringType: tStoringType): LIKE(Storage.Storage);
  VAR
   Msg     : STRING[];
   Result  : LIKE(Storage.Storage);
   qsResult: L_qs.tQSearchResult;
 BEGIN
  GetAnyStoringTypeStorage_Ext(D, trgMyFirm, StoringType, Result, qsResult, Msg);
  IF qsResult # L_qs.qsr_Unique THEN
   L_General.Error(Msg);
  END;
  RETURN Result;
 END {GetAnyStoringTypeStorage};

 PUBLIC PROCEDURE GetFuelStorage(trgMyFirm: P_Firm.tMyFirm): LIKE(Storage.Storage);
 BEGIN
  RETURN GetAnyStoringTypeStorage(SYSDATE(), trgMyFirm, storingType_Fuel);
 END {GetFuelStorage};

 PUBLIC PROCEDURE GetFuelTanksStorage(trgMyFirm: P_Firm.tMyFirm): LIKE(Storage.Storage);
 BEGIN
  RETURN GetAnyStoringTypeStorage(SYSDATE(), trgMyFirm, storingType_FuelTanks);
 END {GetFuelTanksStorage};

 PUBLIC PROCEDURE Stick_MakeDoc(Template   : STRING[];
                                CUCopies   : LIKE(CUCopy.CUCopy)[];
                                PrepareMode: L_MSO.PrpModeType;
                                Copies     : NUMERIC[0]);
  VAR
   Idx    : NUMERIC[0];
   trgMyFirm: LIKE(MyFirm.MyFirm);
 BEGIN
  L_MSO.wordInitDocument(SYSDATE());
  PROMPT("⮢ ... ");
  Idx:=0;
  WHILE (Idx <= HIGH(CUCopies)) & ~!CUCopies[Idx] DO
   PROMPT(CUCopies[Idx]);
   L_General.Assert(SEARCH(CUCopy, CUCopy, CUCopies[Idx]), "   " + CUCopies[Idx]);
   IF ~!CUCopy.Storage THEN
    CONFORM(CUCopy, Storage);
    trgMyFirm:=Storage.MyFirm;
   ELSE
    CONFORM(CUCopy, Math);
    L_General.Assert((Math.MathKind = L_MathR.mathk_Math) | (Math.MyFirm # P_Firm.mf_Fict),
                     " । '' ࣠  " + CUCopy.CUCopy);
    trgMyFirm:=Math.MyFirm;
   END;
   IF trgMyFirm = P_Firm.mf_Fict THEN
    trgMyFirm:=P_Firm.mf_Own;
   END;
   SEARCH(MyFirm, MyFirm, , trgMyFirm);
   IF Idx # 0 THEN
    L_General.Assert(MyFirm.Firm = Firm.Firm, " ࠧ ࣠権");
   END;
   CONFORM(MyFirm, Firm);
   CONFORM(CUCopy, Storage);
   L_MSO.wordSetVar("CUCopy" + L_MSO.IndexStr(Idx) + ".BarCode",
                    "!" + L_XDoc.BarCode(L_XDoc.bck_IdIn17,
                                         L_XDoc.xdt_CUCopy,
                                         L_XDoc.EmptyXDocKind,
                                         CUCopy.CUCopy,
                                         0) + "!");
   L_MSO.wordSetVarsByFile_wIndex         (           "CUCopy", Idx, 0);
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("Math",    "CUCopy", Idx, ~OCCURE(Math));
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("Storage", "CUCopy", Idx, ~OCCURE(Storage));
   INC(Idx);
  END;

  P_Firm.AccessSilentFirmAcnt(Firm.Firm, Memo.ud_cd());
  P_Firm.SetFirmData("Own", Firm.Firm, Memo.ud_cd(), FirmAcnt.FirmAcnt, L_MSO.fps_Soft_asStr);
  L_MSO.SetWordTable("Stickers", Idx);
  L_MSO.MakeWordDocument(Template, Copies, PrepareMode, "");
 END {Stick_MakeDoc};

END.
