(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     ⥪ ப 権
%Type        library
%Specific    None
%Modified    08.09.2014 14:36:22 POLAK\Gina
%Environment
*)

 MODULE L_Str [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  CR   = CHR(13);
  LF   = CHR(10);
  CRLF = CR + LF;

 IMPORT L_General, L_DatTim, Str, Math, L_Roman;

 PUBLIC PROCEDURE PositionInPool(_Pool, _Value: STRING[]): SCAL[1E6];
  VAR
   _Item: STRING[];
   i    : NUMERIC[0];
 BEGIN
  IF ~!_Value THEN
   i:=0;
   LOOP
    _Item:=PoolItem(_Pool, i);
    IF !_Item THEN
     EXIT;
    ELSIF (_Item = _Value) THEN
     RETURN i;
    END;
    INC(i);
   END;
  END;
  RETURN "";
 END {PositionInPool};

 PUBLIC PROCEDURE CntItemsInPool(Pool: STRING[]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=0;
  WHILE ~!PoolItem(Pool, Result) DO
   INC(Result);
  END;
  RETURN Result;
 END {CntItemsInPool};

 PUBLIC PROCEDURE GetPosOfNextDelimiter(_Str, _Delimiters: STRING[]; _Pos: NUMERIC[0]): NUMERIC[0];
  VAR
   p,
   Idx:  NUMERIC[0];
 BEGIN
  p:=Str.Length(_Str);
  Idx:=0;
  WHILE Idx < Str.Length(_Delimiters) DO
   p:=Math.Min(p, Str.Pos(_Str, Str.Slice(_Delimiters, Idx, 1), _Pos));
   INC(Idx);
  END;
  RETURN p;
 END {GetPosOfNextDelimiter};

 PUBLIC PROCEDURE AnyItem(_Str, _Delimiters: STRING[]; Num: NUMERIC[0]):STRING[];
  (* ⫨稥  Str.Item ⠥   ப*)
 BEGIN
  RETURN Str.Item(_Str, _Delimiters, Num, , 1);
 END {AnyItem};

 PUBLIC PROCEDURE SplitStrToStrArray(VAR R: STRING[][]; S: STRING[]; Width, Depth: NUMERIC[0]): SCAL[2];
  VAR
   Rest: STRING[];
 BEGIN
  Str.Format(R, S, Width, LEFT, Rest);
  RETURN ((Depth < HIGH(R)) & !R[Depth]) | !Rest;
 END {SplitStrToStrArray};

 PUBLIC PROCEDURE SplitStr(VAR R: STRING[][]; S: STRING[]; Width, Depth: NUMERIC[0]);
 BEGIN
  L_General.Assert(SplitStrToStrArray(R, S, Width, Depth), "誮  ப|"+R[0]);
 END {SplitStr};

 PUBLIC PROCEDURE FormatStrToStrArray(VAR R: STRING[][]; S: STRING[]; Width: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN SplitStrToStrArray(R, S, Width, HIGH(R)+1);
 END {FormatStrToStrArray};

(*!*) PUBLIC PROCEDURE FormatStr(VAR R: STRING[][]; S: STRING[]; Width: NUMERIC[0]);
 BEGIN
  SplitStr(R, S, Width, HIGH(R)+1);
 END {FormatStr};

 PUBLIC PROCEDURE SplitManName(    ManName   : STRING[];
                               VAR Surname   : STRING[];
                               VAR FirstName : STRING[];
                               VAR Patronymic: STRING[]);
  CONST
   dlm = " .";
  VAR
   tmp            : STRING[];
   Length,
   begposFirstName,
   endposFirstName: NUMERIC[0];
 BEGIN
  tmp            :=Str.Item(ManName, dlm, 1);
  Length         :=Str.Length(ManName);
  begposFirstName:=Str.ItemPos(ManName, dlm, 2);

  IF IsEqStrI(tmp, "") | IsEqStrI(tmp, "") THEN
   endposFirstName:=Str.ItemPos(ManName, dlm, 3);
   Surname        :=Str.Slice(ManName, 0, begposFirstName - 1);
   FirstName      :=Str.Slice(ManName, begposFirstName, endposFirstName - begposFirstName - 1 * (endposFirstName < Length));
   Patronymic     :=Str.Slice(ManName, endposFirstName, Length);
  ELSE
   Surname        :=Str.Item(ManName, dlm, 0);
   FirstName      :=Str.Item(ManName, dlm, 1);
   Patronymic     :=Str.Slice(ManName, begposFirstName, Length);
  END;
 END {SplitManName};

 PUBLIC PROCEDURE ShortName(ManName: STRING[]): STRING[];
  VAR
   Result,
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF ~!ManName THEN
   SplitManName(ManName, Surname, FirstName, Patronymic);
   Result:=Surname + " " + Str.Slice(FirstName, 0, 1) + ".";
   IF ~!Patronymic THEN
    Result:=Result + " " + Str.Slice(Patronymic, 0, 1) + ".";
   END;
  END;
  RETURN Result;
 END {ShortName};

 PUBLIC PROCEDURE TestStrAlowChar(s, AlowChar: STRING[]): NUMERIC[0];
  VAR
   L,
   i: NUMERIC[0];
   low,
   hig: STRING[];
 BEGIN
  low:=Str.Slice(AlowChar, 0, 1);
  hig:=Str.Slice(AlowChar, 1, 1);
  L:=Str.Length(s);
  i:=0;
  WHILE i < L DO
   IF (Str.Slice(s, i, 1)<low) | (Str.Slice(s, i, 1)>hig) THEN
    RETURN 0;
   END;
   INC(i);
  END;
  RETURN 1;
 END {TestStrAlowChar};

 PRIVATE PROCEDURE _Legend(Mask:STRING[]): STRING[];
  CONST
   Size = 7;
  VAR
   L     : STRING[][Size];
   i,
   j,
   n     : NUMERIC[0];
   RetStr: STRING[];
 BEGIN
  L[0]:="'R' - ਬ᪠                                                ";
  L[1]:="'9' -  筠  (易⥫쭠)                       ";
  L[2]:="'0' -  筠  (易⥫쭠,  ⢮)";
  L[3]:="'' -  ᪠  㪢                               ";
  L[4]:="'S' -  ᨬ (易⥫,  ⢮)          ";
  L[5]:="' ' - ஡                                                      ";
  L[6]:="'-' -  ()                                                ";
  RetStr:="|";
  n:=Str.Length(Mask);
  i:=0;
  WHILE i < Size DO
   j:=0;
   WHILE j<n DO
    IF Mask[j] = L[i][1] THEN
     RetStr:=RetStr+"|"+L[i];
     j:=n; (*室  横*)
    ELSE
     INC(j);
    END;
   END;
   INC(i);
  END;
  RETURN RetStr;
 END {_Legend};

 PUBLIC PROCEDURE ShowLegend();
 BEGIN
  STDMSG("祭, ᯮ㥬  蠡:" + _Legend("R90S -"), INFORM);
 END {ShowLegend};

 PUBLIC PROCEDURE TestStrWMask(ObjectOfTestDescr, StrToTest, Mask, RealMask: STRING[]): STRING[];
  VAR
   i, j, k, n, m: NUMERIC[0];
   s,
   RetStr,
   TmpStr : STRING[];
 BEGIN
  RetStr:=ObjectOfTestDescr + "  ᮮ⢥ 蠡|" + RealMask;
  SETZERO(i, j, k);
  n:=Str.Length(Mask);
  IF ~!StrToTest THEN
   m:=Str.Length(StrToTest);
  ELSE
   m:=0;
  END;
  WHILE i < n DO
   IF    Mask[i] = '' THEN
    IF !StrToTest[j] | ~TestStrAlowChar(StrToTest[j], "") THEN
     RETURN RetStr + _Legend(RealMask);
    ELSE
     INC(j);
    END;
   ELSIF Mask[i] = '9' THEN
    IF !StrToTest[j] | ~TestStrAlowChar(StrToTest[j], "09") THEN
     RETURN RetStr + _Legend(RealMask);
    ELSE
     INC(j);
    END;
   ELSIF (Mask[i] = '-') | (Mask[i] = ' ') THEN
    IF StrToTest[j] # Mask[i] THEN
     RETURN RetStr + _Legend(RealMask);
    ELSE
     INC(j);
    END;
   ELSIF Mask[i] = 'R' THEN
    k:=0;
    WHILE (StrToTest[j+k]='I') |
          (StrToTest[j+k]='V') |
          (StrToTest[j+k]='X') |
          (StrToTest[j+k]='L') |
          (StrToTest[j+k]='C') |
          (StrToTest[j+k]='M') DO
     INC(k);
    END;
    IF L_Roman.RomanToArabic(Str.Slice(StrToTest, j, k)) <= 0 THEN
     RETURN ObjectOfTestDescr + ":  ଠ ਬ᪮ ᫠";
    END;
    INC(j, k);
   ELSIF Mask[i] = '0' THEN
    TmpStr:=TestStrWMask(ObjectOfTestDescr,
                         Str.Slice(StrToTest, i, m-i),
                         Str.Slice(Mask, j+1, n-j-1),
                         RealMask);
    IF !TmpStr THEN
     RETURN "";
    ELSE
     RETURN TestStrWMask(ObjectOfTestDescr,
                         Str.Slice(StrToTest, i, m-i),
                         '9'+Str.Slice(Mask, j+1, n-j-1),
                         RealMask);
    END;
   ELSIF Mask[i] = 'S' THEN
    TmpStr:=TestStrWMask(ObjectOfTestDescr,
                         Str.Slice(StrToTest, i, m-i),
                         Str.Slice(Mask, j+1, n-j-1),
                         RealMask);
    IF !TmpStr THEN
     RETURN "";
    ELSE
     RETURN TestStrWMask(ObjectOfTestDescr,
                         Str.Slice(StrToTest, i+1, m-i-1),
                         Str.Slice(Mask, j+1, n-j-1),
                         RealMask);
    END;
   ELSE
    L_General.Error(" ᨬ 蠡: '" + Mask[i] + "'" + '|("' + RealMask + '")');
   END;
   INC(i);
  END;
  IF ~!StrToTest[j] THEN
   RETURN RetStr + _Legend(RealMask);
  ELSE
   RETURN "";
  END;
 END {TestStrWMask};

 PUBLIC PROCEDURE CheckStrWMask(ObjectOfTestDescr, StrToTest, Mask: STRING[]);
  VAR
   Err: STRING[];
 BEGIN
  Err:=TestStrWMask(ObjectOfTestDescr, StrToTest, Mask, Mask);
  IF ~!Err THEN
   L_General.Error(Err);
  END;
 END {CheckStrWMask};

 PUBLIC PROCEDURE StrFormat(VAR r: STRING[][]): STRING[];
  VAR
   i: NUMERIC[0];
   s: STRING[];
 BEGIN
  i:=1; s:=r[0];
  WHILE i<=HIGH(r) DO
   s:=s+" "+r[i]; INC(i);
  END;
  RETURN Str.Condense(s);
 END {StrFormat};

 PUBLIC PROCEDURE Repeat(s: STRING[]; n: NUMERIC[0]): STRING[];
  VAR
   r: STRING[];
   i: NUMERIC[0];
 BEGIN
  r:=""; i:=0;
  WHILE i<n DO
   r:=r+s; INC(i);
  END;
  RETURN r;
 END {Repeat};

 PUBLIC PROCEDURE Left(s: STRING[]; n: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Str.Slice(s, 0, n)
 END {Left};

 PUBLIC PROCEDURE Right(s: STRING[]; n: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Str.Slice(s, Math.Max(0, Str.Length(s)-n), n)
 END {Right};

 PUBLIC PROCEDURE RightFrom(s: STRING[]; p: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Str.Slice(s, p, Str.Length(s)-p);
 END {RightFrom};

 PUBLIC PROCEDURE IntStr(i: NUMERIC[0]): STRING[];
 BEGIN
  RETURN FLDTOSTR(i, "N0", 0);
 END {IntStr};

 PUBLIC PROCEDURE NumericStr(v: FLOAT; Fraction: NUMERIC[0]): STRING[];
 BEGIN
  IF Fraction > 0 THEN
   RETURN FLDTOSTR(v, IntStr(Fraction)+".", 0);
  ELSE
   RETURN FLDTOSTR(v, "0", 0);
  END;
 END {NumericStr};

 PUBLIC PROCEDURE Char(S: STRING[]; i: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Str.Slice(S, i, 1);
 END {Char};

 PUBLIC PROCEDURE FixedIntStr(n, Digits: NUMERIC[0]): STRING[];
 BEGIN
  RETURN FLDTOSTR(n, "L", Digits);
 END {FixedIntStr};

 PUBLIC PROCEDURE PoolItem(Pool: STRING[]; Item: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Str.Item(Pool, "|", Item);
 END {PoolItem};

 PRIVATE PROCEDURE FormsPattern(p: STRING[]): STRING[];
  VAR
   p1: STRING[];
 BEGIN
  p1:=Str.Slice(p, 0, Str.Length(p)-2)+"";
  RETURN p+"|"+p1+"|"+p1;
 END {FormsPattern};

 PUBLIC PROCEDURE NumericByWord(v: FLOAT; FrSize: NUMERIC[0]): STRING[];
  CONST
   Prefix = "|";
   FrStr0 = "|";
   FrStr  = "筠||भ";
   FctStr = "1000000000000";
  VAR
   Fraction: NUMERIC[0];
   r, p, p1: STRING[];
 BEGIN
  r:="";
  IF v<0 THEN
   r:=" ";
   v:=Math.Abs(v);
  END;
  IF FrSize>0 THEN
   r:=Str.Cap(r+Str.NumByWord(v DIV 1, FEMININE), 0, 1);
   IF FrSize<3 THEN
    p:=PoolItem(FrStr0, FrSize - 1);
   ELSE
    L_General.Assert(FrSize<12, "L_Str.NumericByWord: 誮 ᮪ 筮");
    p:=PoolItem(FrStr, FrSize DIV 3 - 1);
    IF FrSize MOD 3 > 0 THEN
     p:=PoolItem(Prefix, FrSize MOD 3 - 1)+p;
    END;
   END;
   Fraction:=(v MOD 1)*STRTOFLD(Str.Slice(FctStr, 0, FrSize+1), NUMERIC);
   r:=r+" "+Str.EnumObject(v DIV 1, FormsPattern("楫"))+
        " "+FixedIntStr(Fraction, FrSize)+
        " "+Str.EnumObject(Fraction, FormsPattern(p));
  ELSE
   r:=Str.Cap(r+Str.NumByWord(v DIV 1), 0, 1);
  END;
  RETURN r;
 END {NumericByWord};

 PUBLIC PROCEDURE StrToScal(_Value: STRING[]): SCAL[1E9];
 BEGIN
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   RETURN STRTOFLD(_Value, SCAL);
  EXCEPT
   ON Exc: Exc_RunTime DO
    IF Exc.ErrorCode = L_General.ec_rt_FailedSTRTOFLD THEN
     L_General.Error(" ८ࠧ "+_Value+"  ᪠");
    ELSE
     RAISE();
    END;
  END;
 END {StrToScal};

 PUBLIC PROCEDURE Str2Num(S, Format: STRING[]): FLOAT;
 BEGIN
  IF ~!Format THEN
   RETURN STRTOFLD(S, NUMERIC, Format);
  ELSE
   RETURN STRTOFLD(S, NUMERIC);
  END;
 END {Str2Num};

 PUBLIC PROCEDURE StrToNum(S, Format: STRING[]; Silent: SCAL[2]): FLOAT;
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   RETURN Str2Num(S, Format);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_FailedSTRTOFLD THEN
    L_General.Assert(Silent, "४⭮ 祭 ᫠ '" + S + "'");
    RETURN EMPTYOF(FLOAT);
   ELSE
    RAISE();
   END;
  END; (* TRY *)
 END {StrToNum};

 PRIVATE PROCEDURE _StrToScalArr(_Value, Dlm, DlmPer: STRING[];
                                 VAR Arr: SCAL[1E9][]);
  VAR
   i,
   idx,
   pos  : NUMERIC[0];
   BValue,
   EValue  : SCAL[1E9];
   tmpValue: STRING[][2];
 BEGIN
  SETEMPTY(Arr);
  i:=0;
  idx:=0;
  tmpValue[0]:=Str.Item(_Value, Dlm, i);
  TRY
   WHILE ~!tmpValue[0] DO
    pos:=Str.Pos(tmpValue[0], DlmPer);
    tmpValue[1]:=Str.Slice(tmpValue[0], pos+Str.Length(DlmPer), Str.Length(tmpValue[0]));
    IF !tmpValue[1] THEN
     Arr[idx]:=StrToScal(tmpValue[0]);
     INC(idx);
    ELSE
     BValue:=StrToScal(Str.Slice(tmpValue[0], 0, pos));
     EValue:=StrToScal(tmpValue[1]);
     WHILE BValue<=EValue DO
      Arr[idx]:=BValue;
      INC(BValue);
      INC(idx);
     END;
    END;
    INC(i);
    tmpValue[0]:=Str.Item(_Value, Dlm, i);
   END; (* WHILE ~!tmpValue[0]...*)
  EXCEPT
   ON Exc: Exc_RunTime DO
    IF Exc.ErrorCode=12 THEN
     L_General.Error(" ࠧ ᨢ  ᮮ⢥"+
                      "| ⮢  ८ࠧ㥬 ப");
    ELSE
     RAISE();
    END;
  END;
 END {_StrToScalArr};

 PRIVATE PROCEDURE _StrToArr(_Value, Dlm, DlmPer: STRING[]; VAR Arr: STRING[][]);
  VAR
   i,
   idx,
   pos     : NUMERIC[0];
   tmpValue: STRING[][2];
 BEGIN
  SETEMPTY(Arr);
  i:=0;
  idx:=0;
  tmpValue[0]:=Str.Item(_Value, Dlm, i);
  TRY
   WHILE ~!tmpValue[0] DO
    pos:=Str.Pos(tmpValue[0], DlmPer);
    tmpValue[1]:=Str.Slice(tmpValue[0], pos+Str.Length(DlmPer), Str.Length(tmpValue[0]));
    L_General.Assert(!tmpValue[1], " ப ⨬ 㪠뢠 ");
    Arr[idx]:=tmpValue[0];
    INC(idx);
    INC(i);
    tmpValue[0]:=Str.Item(_Value, Dlm, i);
   END; (* WHILE ~!tmpValue[0]...*)
  EXCEPT
   ON Exc: Exc_RunTime DO
    IF Exc.ErrorCode=12 THEN
     L_General.Error(" ࠧ ᨢ  ᮮ⢥"+
                      "| ⮢  ८ࠧ㥬 ப");
    ELSE
     RAISE();
    END;
  END;
 END {_StrToArr};

 PUBLIC PROCEDURE StrToScalArr(_Value: STRING[]; VAR Arr: SCAL[1E9][]);
 BEGIN
  _StrToScalArr(_Value, ",", "..", Arr);
 END {StrToScalArr};

 PUBLIC PROCEDURE StrToArr(_Value : STRING[]; VAR Arr: STRING[][]);
 BEGIN
  _StrToArr(_Value, ",", "..", Arr);
 END {StrToScalArr};

 PUBLIC PROCEDURE CutLongStr(TmpStr: STRING[]; MaxWidth: NUMERIC[0]): STRING[];
  CONST
   EndOfLine = "~>";
 BEGIN
  IF Str.Length(TmpStr) > MaxWidth THEN
   RETURN Str.Slice(TmpStr, 0, MaxWidth - Str.Length(EndOfLine)) + EndOfLine;
  ELSE
   RETURN TmpStr;
  END;
 END {CutLongStr};

(*! ॢ,   Str.Replace !*)
 PUBLIC PROCEDURE Replace(S, Fr, To: STRING[]): STRING[];
 BEGIN
  RETURN Str.Replace(S, Fr, To);
 END {Replace};

 PUBLIC PROCEDURE ExclQM(S: STRING[]): STRING[];
 BEGIN
  RETURN Str.Replace(S, '"', "'");
 END {ExclQM};

 PUBLIC PROCEDURE ExclIllegalChars(S, IllegalChars, NormalChar: STRING[]): STRING[];
  VAR
   IllegalChar: STRING[];
   i          : NUMERIC[0];
 BEGIN
  i:=0;
  LOOP
   IllegalChar:=Char(IllegalChars, i);
   IF !IllegalChar THEN
    EXIT;
   END;
   S:=Str.Replace(S, IllegalChar, NormalChar);
   INC(i);
  END; (* LOOP *)
  RETURN S;
 END {ExclIllegalChars};

 PUBLIC PROCEDURE CheckIllegalChars(S: STRING[]; IC: STRING[]): STRING[];
  VAR
   c: STRING[1];
   i,
   l: NUMERIC[0];
 BEGIN
  l:=Str.Length(S);
  i:=0;
  LOOP
   c:=Str.Slice(IC, i, 1);
   IF !c THEN
    EXIT;
   ELSIF Str.Pos(S, c) < l THEN
    L_General.Error("ப '" + S + "'|ᮤন 饭 ᨬ  鸞 '" + IC + "'");
   END;
   INC(i);
  END;
  RETURN S;
 END {CheckIllegalChars};

 PUBLIC PROCEDURE IsStrInStr(S, Pat: STRING[]): SCAL[2];
 BEGIN
  RETURN Str.Pos(S, Pat) < Str.Length(S);
 END {IsStrInStr};

 PUBLIC PROCEDURE CheckPresenceSemicolon(S: STRING[]): STRING[];
 BEGIN
  L_General.Assert(~IsStrInStr(S, ";"),
                   "ப '" + S + "'|  ᮤঠ 饭 ᨬ ';'");
  RETURN S;
 END {CheckPresenceSemicolon};

 PUBLIC PROCEDURE CheckPresenceComma(S: STRING[]): STRING[];
 BEGIN
  L_General.Assert(~IsStrInStr(S, ","),
                   "ப '" + S + "'|  ᮤঠ 饭 ᨬ ','");
  RETURN S;
 END {CheckPresenceComma};

 PUBLIC PROCEDURE IsEqStrI(Str1, Str2: STRING[]): SCAL[2];
 BEGIN
  RETURN Str.Cap(Str1) = Str.Cap(Str2);
 END {IsEqStrI};

 PUBLIC PROCEDURE Var_wIdx(VarName: STRING[]; Idx: NUMERIC[0]): STRING[];
 BEGIN
  RETURN VarName + "[" + IntStr(Idx) + "]";
 END {Var_wIdx};

 PUBLIC PROCEDURE AddStrDlm(srcStr, Delimiter: STRING[]): STRING[];
 BEGIN
  IF ~!srcStr THEN
   RETURN srcStr + Delimiter;
  ELSE
   RETURN srcStr;
  END;
 END {AddStrDlm};

 PUBLIC PROCEDURE NumToStr_woNZ(Value: FLOAT): STRING[];
  VAR
   LastSym,
   tmpValue: STRING[];
 BEGIN
  tmpValue:=FLDTOSTR(Value, "20.");
  LOOP
   LastSym:=Char(tmpValue, Str.Length(tmpValue)-1);
   IF (LastSym = "0") | (LastSym = ".") THEN
    tmpValue:=Str.Delete(tmpValue, Str.Length(tmpValue) - 1, 1);
   END;

   IF (LastSym # "0") | (LastSym = ".") THEN
    EXIT;
   END;
  END; (* LOOP *)
  RETURN Str.Condense(tmpValue);
 END {NumToStr_woNZ};

 PUBLIC PROCEDURE DTSStr(_DTS: FLOAT): STRING[];
  VAR
   D: DATE;
   T: TIME;
   S: SCAL[60];
   SF: FLOAT;
 BEGIN
  UnPkVARIANTDATE(_DTS, D, T, S, SF);
  RETURN L_DatTim.DateStr(D)+" "+L_DatTim.TimeStr(T)+":"+S+"."+FLDTOSTR(SF DIV 0.001, "L000", 3);
 END {DTSStr};

 PUBLIC PROCEDURE ExcludeCRinCRLF(s: STRING[]):STRING[];
 BEGIN
  RETURN Str.Replace(s, CRLF, LF);
 END {ExcludeCRinCRLF};

 PUBLIC PROCEDURE Days_asStr(i: NUMERIC[0]): STRING[];
 BEGIN
  RETURN IntStr(i)+" "+Str.EnumObject(i, "||");
 END {Days_asStr};

 PUBLIC PROCEDURE Months_asStr(i: NUMERIC[0]): STRING[];
 BEGIN
  RETURN IntStr(i)+" "+Str.EnumObject(i, "||楢");
 END {Months_asStr};

 PUBLIC PROCEDURE Years_asStr(i: NUMERIC[0]): STRING[];
 BEGIN
  RETURN IntStr(i)+" "+Str.EnumObject(i, "||");
 END {Years_asStr};

 PUBLIC PROCEDURE DMY_asStr(D, M, Y: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Days_asStr(D)+" "+Months_asStr(M)+" "+Years_asStr(Y);
 END {DMY_asStr};

END.
