(*
%Copyright   (c) Polak Computer System
%Author      29.01.2001 12:41:10 SAN
%Purpose      樠쭮 
%Type        library
%Specific    SYS
%Modified    24.09.2014 16:14:17 LDA
%Environment
*)

 MODULE L_STx [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Acnt, L_DatTim, L_Man, E_PRoll, L_EC, P_Man,
        L_Staff, L_XObj, Math, L_PRoll, L_Tax, L_Str, DBD, L_Russia,
        P_Officer, L_AFM, Str, Memo, P_Firm, L_AcCut, P_MCList;

 PUBLIC TYPE
  tSTxPart      = SCAL[6];
  tManAgeGroup  = SCAL[3];
  twoTaxManKind = SCAL[3];
  tSpecificSTx  = SCAL[3];

 PUBLIC CONST
  stxp_PFRF = 0;
  stxp_SSRF = 1;
  stxp_MSFF = 2;
  stxp_MSTF = 3;
  stxp_PFIn = 4;
  stxp_PFAc = 5;

  STx_TotAcCut = 102;
  STx_ExlAcCut = 103;
  Spc_BasAcCut = 104;

  stxp_Pool = "|||||";

  mag_Old = 0;
  mag_Ave = 1;
  mag_Jun = 2;

  wotmk_Obvious   = 0;
  wotmk_Invalid   = 1;
  wotmk_Foreigner = 2;

  SpcSTx_None = 0;
  SpcSTx_ENVD = 1;
  SpcSTx_USNO = 2;
  SpcSTx_pool = "-||";

  STx2001_LastPeriod  = 01\12\2009;

 PRIVATE TYPE
  tSTx_TaxPartsType = SCAL[6];
  tSTx_BasValues    = LIKE(Money.Sum);
  tSTx_SBsValues    = NUMERIC[2]; (* stored bases *)
  tSTx_TaxValues    = NUMERIC[2];

 PRIVATE CONST
  SizeOfAcCut = 1000;
  STx2001_FirstPeriod = 01\01\2001;
  STx2001_ScaleSize = 5; (* always +1 *)
  STx2001_AcCNum = 32;

  dlbInvVer       = 2;

 PRIVATE VAR
  ProceedPeriod : DATE;

  x97_Count     : NUMERIC[0];
  x97_MCode     : LIKE(MCList.MCode)[16];

 PRIVATE PROCEDURE STx_MaxOf_TaxPartsType(P: DATE): tSTx_TaxPartsType;
 BEGIN
  IF    P >= 01\01\2002 THEN
   RETURN 6-1;
  ELSIF P >= 01\01\2001 THEN
   RETURN 4-1;
  ELSE
   L_General.CallUs(0); (* 뫮   01\01\2001*)
  END;
 END {STx_MaxOf_TaxPartsType};

 PUBLIC PROCEDURE STx_GetTotAcCut(): LIKE(AcCut.AcCut);
 BEGIN RETURN STx_TotAcCut;
 END {STx_GetTotAcCut};

 PUBLIC PROCEDURE STx_GetExlAcCut(): LIKE(AcCut.AcCut);
 BEGIN RETURN STx_ExlAcCut;
 END {STx_GetExlAcCut};

 PUBLIC PROCEDURE STx_PFRF(): tSTx_TaxPartsType;
 BEGIN
  RETURN stxp_PFRF;
 END {STx_PFRF};

 PUBLIC PROCEDURE STx_SSRF(): tSTx_TaxPartsType;
 BEGIN
  RETURN stxp_SSRF;
 END {STx_SSRF};

 PUBLIC PROCEDURE STx_MSFF(): tSTx_TaxPartsType;
 BEGIN
  RETURN stxp_MSFF;
 END {STx_MSFF};

 PUBLIC PROCEDURE STx_MSTF(): tSTx_TaxPartsType;
 BEGIN
  RETURN stxp_MSTF;
 END {STx_MSTF};

 PRIVATE PROCEDURE STx_IsSpecialPFRParts(_Part: tSTx_TaxPartsType): SCAL[2];
 BEGIN
  RETURN (_Part = stxp_PFIn) | (_Part = stxp_PFAc);
 END {STx_IsSpecialPFRParts};

 PUBLIC PROCEDURE STx_GetPoBAcCut(_Part: tSTx_TaxPartsType): LIKE(AcCut.AcCut);
 BEGIN
  IF STx_IsSpecialPFRParts(_Part) THEN
   _Part:=stxp_PFIn;
  END;
  RETURN 105 + _Part;
 END {STx_GetPoBAcCut};

 PUBLIC PROCEDURE STx_GetBnfAcCut(_Part: tSTx_TaxPartsType): LIKE(AcCut.AcCut);
 BEGIN
  IF STx_IsSpecialPFRParts(_Part) THEN
   _Part:=stxp_PFIn;
  END;
  RETURN 110 + _Part;
 END {STx_GetBnfAcCut};

 PUBLIC PROCEDURE STx_GetTaxAcCut(_Part: tSTx_TaxPartsType): LIKE(AcCut.AcCut);
 BEGIN
  RETURN 115 + _Part;
 END {STx_GetTaxAcCut};

 PUBLIC PROCEDURE STx_IsAcCutToDetail(_AcCut: LIKE(AcCut.AcCut)): SCAL[2];
 BEGIN
  RETURN (_AcCut >= STx_ExlAcCut) & (_AcCut < 115);
 END {STx_IsAcCutToDetail};

 PUBLIC PROCEDURE STx_IsTaxAcCut(_AcCut: LIKE(AcCut.AcCut)): SCAL[2];
 BEGIN
  RETURN (_AcCut >= 115) & (_AcCut <= 120);
 END {STx_GetTaxAcCut};

 PUBLIC PROCEDURE STx_IsSpecialPFRAcCut(_AcCut: LIKE(AcCut.AcCut)): SCAL[2];
 BEGIN
  RETURN (_AcCut >= 119) & (_AcCut <= 120);
 END {STx_IsSpecialPFRAcCut};

 PRIVATE PROCEDURE Setup_x97(P: DATE);
  VAR
   FirstP: DATE;
 BEGIN
  FirstP:=01\08\2002;
  IF (Str.Cap(DBD.BaseName()) = "SN") | (Str.Cap(DBD.BaseName()) = "ML") THEN
   FirstP:=01\09\2002;
  END;
  x97_Count:=0;
  IF ~!PROCREF(E_PRoll.FutMCode) & (P >= FirstP) THEN
   SELECT(MCList, MCode);
   WHILE OCCURE(MCList) DO
    IF P_MCList.GetForFuture(MCList.MCode, P) = P_MCList.mcfp_ChangeMCode THEN
     x97_MCode[x97_Count]:=MCList.MCode;
     INC(x97_Count);
     x97_MCode[x97_Count]:=E_PRoll.FutMCode(MCList.MCode);
     INC(x97_Count);
    END;
    NEXT(MCList);
   END; (* WHILE OCCURE(MCList) ... *)
  END;
 END {Setup_x97};

 PUBLIC PROCEDURE STx_StaffProceedInit(P: DATE);
 BEGIN
  IF P <= STx2001_LastPeriod THEN
   L_AFM.MakeMultipleIndex("ScTxB", "AcCut : LIKE(AcCut.AcCut);"+
                                    "P     : DATE;"+
                                    "ObjVal: NUMERIC[2];"+
                                    "ExlVal: NUMERIC[2];"+
                                    "SpcVal: NUMERIC[2]",
                              "AcCut: AcCut, P");
   Setup_x97(P);
  END;
  ProceedPeriod:=P;
 END {STx_StaffProceedInit};

 PRIVATE PROCEDURE AccessAcCut(_AcCut: LIKE(AcCut.AcCut));
 BEGIN
  L_General.Assert(SEARCH(AcCut, AcCut, _AcCut), " ࠢ筨   ࠧ१ "+_AcCut);
 END {AccessAcCut};

 PRIVATE PROCEDURE STx_PutSingleBase(Dir    : NUMERIC[0];
                                     _AcCut : LIKE(AcCut.AcCut);
                                     _XDat  : DATE;
                                     _AcCut2: LIKE(AcCut2.AcCut2);
                                     _Value : tSTx_SBsValues);
 BEGIN
  IF _Value # 0 THEN
   AccessAcCut(_AcCut);
   AccessAcCut(_AcCut2);
  END;
  L_XObj.extMakeCir(+1, _AcCut, _XDat, ProceedPeriod,
                    L_Acnt.E_Apport_MoneyCredit(ProceedPeriod),
                    _AcCut2, Dir*_Value, 0, L_XObj.src_Salary);
 END {STx_PutSingleBase};

 PUBLIC PROCEDURE STx_CitizenshipForSTx(_Man: LIKE(Man.Man); D: DATE): SCAL[2];
 BEGIN
  IF L_Man.Man_Citizen(_Man, D) > 1 THEN
   RETURN L_Man.AccessManAdr(_Man, D, L_Russia.at_CtMA) &
          (ManAdr.Country = 643);
  ELSE
   RETURN 1;
  END;
 END {STx_CitizenshipForSTx};

 PUBLIC PROCEDURE STx_Man_IsInvalid(P: DATE; _Man: LIKE(Man.Man)): SCAL[2];
 BEGIN
  RETURN E_ApplySTxBenefitToInvalid(P) &
        P_Man.HasActualManPro(_Man, L_DatTim.MonthEnd(P), P_Man.P_Invalid) &
        STx_CitizenshipForSTx(_Man, L_DatTim.MonthEnd(P));
 END {STx_Man_IsInvalid};

 PUBLIC PROCEDURE Get_woTaxManKind(P: DATE; _Man: LIKE(Man.Man)): twoTaxManKind;
 BEGIN
  IF    STx_Man_IsInvalid(P, _Man) THEN
   RETURN wotmk_Invalid;
  ELSIF ~STx_CitizenshipForSTx(_Man, L_DatTim.MonthEnd(P)) THEN
   IF P >= 01\01\2005 THEN
    IF P_Man.GetForeignerLegalStatus(_Man, P) = P_Man.fls_Commorancy THEN
     RETURN wotmk_Foreigner;
    ELSE
     RETURN wotmk_Obvious;
    END;
   ELSE
    RETURN wotmk_Foreigner;
   END;
  ELSE
   RETURN wotmk_Obvious;
  END;
 END {Get_woTaxManKind};

 PRIVATE PROCEDURE ApplyBenefitToPart(P     : DATE;
                                      _wotmk: twoTaxManKind;
                                      _Part : tSTx_TaxPartsType): SCAL[2];
 BEGIN
  IF    _wotmk = wotmk_Invalid THEN
   RETURN ~STx_IsSpecialPFRParts(_Part);
  ELSIF _wotmk = wotmk_Foreigner THEN
   IF P >= 01\01\2003 THEN
    RETURN (_Part = stxp_PFIn);
   ELSE
    RETURN (_Part = stxp_PFRF) | (_Part = stxp_PFIn);
   END;
  ELSE
   RETURN 0;
  END;
 END {ApplyBenefitToPart};

 PUBLIC PROCEDURE DlbInvlSum(P: DATE): NUMERIC[2];
 BEGIN
  RETURN 100000;
 END {DlbInvlSum};

 PUBLIC PROCEDURE DlbInvlPurePF(P: DATE): NUMERIC[2]; (*-  㫥 誠*)
 BEGIN
  IF P >= 01\01\2005 THEN
   RETURN  6.0;
  ELSE
   RETURN 14.0;
  END;
 END {DlbInvlPurePF};

 PUBLIC PROCEDURE TotalSpecialPF(P: DATE): NUMERIC[2]; (* ᥣ  㫥 誠*)
 BEGIN
  RETURN 14.0;
 END {TotalSpecialPF};

 PRIVATE PROCEDURE wos_SingleAcCut(P: DATE; _AcCut, _AcCut2: LIKE(AcCut.AcCut));
  VAR
   toWriteOff: L_XObj.tSum;
 BEGIN
  toWriteOff:=L_XObj.mo_GetOutSaldo(_AcCut, P);
  IF toWriteOff # 0 THEN
   L_XObj.mo_MakeCir(+1, _AcCut, P, L_Acnt.E_Apport_MoneyDebit(P), _AcCut2,
                     -toWriteOff, L_XObj.src_Salary);
  END;
 END {wos_SingleAcCut};

 PUBLIC PROCEDURE GetManXObject(trgMan: LIKE(Man.Man); trgMyFirm: P_Firm.tMyFirm): LIKE(XObject.XObject);
 BEGIN
  SEARCH(mfMan, Man, , trgMan, trgMyFirm);
  RETURN mfMan.XO_ESN;
 END {GetManXObject};

 PUBLIC PROCEDURE AccessManXObject(trgMan: LIKE(Man.Man); trgMyFirm: P_Firm.tMyFirm);
 BEGIN
  L_XObj.AccessXObject(GetManXObject(trgMan, trgMyFirm));
 END {AccessManXObject};

 PRIVATE PROCEDURE WriteOffSaldo(P: DATE);
  VAR
   AcCut_69: LIKE(AcCut.AcCut);
   _Part   : tSTx_TaxPartsType;
 BEGIN
  IF L_General.IsPolakSpecific() THEN
   AcCut_69:=680;
  ELSIF P >= 01\12\2008 THEN
   AcCut_69:=L_AcCut.erkn_Get(P, L_AcCut.erkn_SocialInsurance);
  ELSE
   SETEMPTY(AcCut_69);
  END;
  IF ~!AcCut_69 THEN
   AccessManXObject(Staff.Man, Staff.MyFirm);
   wos_SingleAcCut(P, STx_TotAcCut, L_AcCut.Fictive());
   wos_SingleAcCut(P, STx_ExlAcCut, L_AcCut.Fictive());
   wos_SingleAcCut(P, Spc_BasAcCut, L_AcCut.Fictive());
   FOR_EACH _Part DO
    IF _Part > STx_MaxOf_TaxPartsType(P) THEN
     EXIT;
    END;
    wos_SingleAcCut(P, STx_GetTaxAcCut(_Part), AcCut_69);
    wos_SingleAcCut(P, STx_GetPoBAcCut(_Part), L_AcCut.Fictive());
    wos_SingleAcCut(P, STx_GetBnfAcCut(_Part), L_AcCut.Fictive());
   END; (* FOR_EACH _Part ... *)
  END;
 END {WriteOffSaldo};

 PUBLIC PROCEDURE STx_StaffProceedDone();
  VAR
   _Part  : tSTx_TaxPartsType;
   _ObjVal,
   _ExlVal,
   _SpcVal,
   _BasVal: tSTx_SBsValues;
   wotmk  : twoTaxManKind;
   TotBnf : tSTx_SBsValues;
   ToWrOff,
   WORest,
   WOPart : NUMERIC[2];
 BEGIN
  IF ProceedPeriod <= STx2001_LastPeriod THEN
   AccessManXObject(Staff.Man, Staff.MyFirm);
   IF SELECT(ScTxB, AcCut) THEN
    wotmk:=Get_woTaxManKind(ProceedPeriod, Man.Man);
    WHILE OCCURE(ScTxB) DO
     IF E_STxRoundBase(ProceedPeriod) THEN
      _ObjVal:=Math.Round(ScTxB.ObjVal, 1);
      _ExlVal:=Math.Round(ScTxB.ExlVal, 1);
      _SpcVal:=Math.Round(ScTxB.SpcVal, 1);
     ELSE
      _ObjVal:=ScTxB.ObjVal;
      _ExlVal:=ScTxB.ExlVal;
      _SpcVal:=ScTxB.SpcVal;
     END;
     _BasVal:=_ObjVal-_ExlVal;
     STx_PutSingleBase(+1, STx_TotAcCut, ScTxB.P, ScTxB.AcCut, _ObjVal);
     STx_PutSingleBase(-1, STx_ExlAcCut, ScTxB.P, ScTxB.AcCut, _ExlVal);
     STx_PutSingleBase(+1, Spc_BasAcCut, ScTxB.P, ScTxB.AcCut, _SpcVal);
     IF Staff.Contract = L_Staff.cnt_ContractorsAgreement THEN
      STx_PutSingleBase(-1, STx_GetPoBAcCut(stxp_SSRF), ScTxB.P, ScTxB.AcCut, _BasVal);
     END;
     IF wotmk # wotmk_Obvious THEN
      FOR_EACH _Part DO
       IF _Part > STx_MaxOf_TaxPartsType(ProceedPeriod) THEN
        EXIT;
       END;
       IF ApplyBenefitToPart(ProceedPeriod, wotmk, _Part) THEN
        STx_PutSingleBase(-1, STx_GetBnfAcCut(_Part), ScTxB.P, ScTxB.AcCut, _BasVal);
       END;
      END; (* FOR_EACH _Part <= ... *)
     END; (* IF wotmk # ... *)
     NEXT(ScTxB);
    END; (* WHILE OCCURE(ScTxB) ... *)
    IF wotmk = wotmk_Invalid THEN
     L_XObj.RenovateXCalc(STx_GetBnfAcCut(stxp_PFRF), ProceedPeriod);
     IF OCCURE(XCalc) THEN
      TotBnf:=0;
      CHANGESEL(XCalc, XObject, , XCalc.XObject, XCalc.AcCut);
      REPEAT
       INC(TotBnf, -XCalc.CrdSum);
      UNTIL ~PREV(XCalc) | (XCalc.XDat < L_DatTim.YearBeg(ProceedPeriod));
      ToWrOff:=TotBnf-DlbInvlSum(ProceedPeriod);
      IF ToWrOff > 0 THEN
       FOR_EACH _Part DO
        IF _Part > STx_MaxOf_TaxPartsType(ProceedPeriod) THEN
         EXIT;
        END;
        IF ApplyBenefitToPart(ProceedPeriod, wotmk_Invalid, _Part) THEN
         WORest:=ToWrOff;
         L_XObj.RenovateXCalc(STx_GetBnfAcCut(_Part), ProceedPeriod);
         L_General.Assert(OCCURE(XCalc),
                          "   ࠧ१  죮⠬ - " + STx_GetBnfAcCut(_Part));
         CONFORM(XCalc, XApport);
         WHILE OCCURE(XApport) DO
          WOPart:=-XApport.Sum * (ToWrOff/(-XCalc.CrdSum));
          DEC(WORest, WOPart);
          INC(XApport.Sum, WOPart);
          REPLACE(XApport);
          NEXT(XApport);
         END; (* WHILE OCCURE(XApport) ... *)
         IF WORest # 0 THEN
          LAST(XApport);
          INC(XApport.Sum, WOPart);
          REPLACE(XApport);
         END;
        END;
       END; (* FOR_EACH _Part ... *)
      END; (* IF ToWrOff > 0 ... *)
     END; (* IF OCCURE(XCalc) ... *)
    END; (* IF wotmk = wotmk_Invalid ... *)
   END;
   L_AFM.AF_PurgeTemp("ScTxB");
   SETEMPTY(ProceedPeriod);
  END;
 END {STx_StaffProceedDone};

 PUBLIC PROCEDURE STx_GetAcCutForMoney(): LIKE(AcCut.AcCut);
(* CURRENTS - Money, Staff, MCList *)
 BEGIN
  L_General.Assert(SEARCH(StaffLog, TSN, Staff.TSN, Money.ODate),
                   "࠭   ⭮ : " +
                   "|. " + Money.TSN + ", " + L_DatTim.PeriodStr(Money.Closed) + ",   " + Money.MCode);
  RETURN L_PRoll.GetMCListAcCut(MCList.MCode, Money.Closed);
 END {STx_GetAcCutForMoney};

 PUBLIC PROCEDURE SpecificSTx(_Sort   : LIKE(Officer.Sort);
                              _Officer: LIKE(Officer.Officer);
                              _Date   : DATE;
                              _MyFirm : LIKE(MyFirm.MyFirm)): tSpecificSTx;
 BEGIN
  IF    P_Officer.HasActualOfcPro(_Sort, _Officer, _Date, P_Officer.P_SpecialSTx) THEN
   RETURN SpcSTx_ENVD;
  ELSIF P_Firm.FirmHasSimplifiedTaxation(P_Firm.GetFirmOfMyFirm(_MyFirm), _Date) THEN
   RETURN SpcSTx_USNO;
  ELSE
   RETURN SpcSTx_None;
  END;
 END {SpecificSTx};

 PUBLIC PROCEDURE IsSpecSTxOfficer(D: DATE): SCAL[2]; (*ᯥ ० /, ਬ *)
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(StaffLog);
  SAVE(Staff);
  L_General.Assert(SEARCH(StaffLog, TSN, Money.TSN, Money.ODate), "࠭   ⭮ ");
  CONFORM(StaffLog, Staff);
  Result:=SpecificSTx(StaffLog.Sort, StaffLog.Officer, D, Staff.MyFirm) > SpcSTx_None;
  RESTORE(Staff);
  RESTORE(StaffLog);
  RETURN Result;
 END {IsSpecSTxOfficer};

 PRIVATE PROCEDURE IsIn_x97MCode(_MCode: LIKE(MCList.MCode)): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  LOOP
   IF i = x97_Count THEN
    RETURN 0;
   ELSIF _MCode = x97_MCode[i] THEN
    RETURN 1;
   END;
   INC(i);
  END; (* LOOP *)
 END {IsIn_x97MCode};

 PRIVATE PROCEDURE NeedFtSysIn97(): SCAL[2];
 BEGIN
  IF Str.Cap(DBD.BaseName()) = "18" THEN
   RETURN Money.WFPeriod>=01\11\2005;
  ELSE
   RETURN 1;
  END;
 END {NeedFtSysIn97};

 PUBLIC PROCEDURE STx_KeepForSTax(_Sum: LIKE(Money.Sum));
  TYPE
   tKind = SCAL[3];
  CONST
   k_Normal   = 0;
   k_InFuture = 1;
   k_Ignore   = 2;
  VAR
   Kind   : tKind;
   _AcCut : LIKE(AcCut.AcCut);
   _ObjVal,
   _ExlVal,
   _SpcVal: tSTx_SBsValues;
   _Apport: LIKE(Apport.Apport);
 BEGIN
  IF (Memo.gl_mb() <= STx2001_LastPeriod) & (Memo.gl_mb() >= STx2001_FirstPeriod) THEN
   SETZERO(_ObjVal, _ExlVal, _SpcVal);
   Kind:=k_Ignore;
   IF MCList.MCTyp = L_PRoll.mct_Credit THEN
    CONFORM(MCList, TaxAdv);
    IF TaxAdv.OwnCode # L_Tax.Tax2001__oc_NoInc THEN
     Kind:=k_Normal;
     IF IsIn_x97MCode(Money.MCode) THEN
      IF (Money.Source = L_PRoll.src_System) & (Money.Period > Money.Closed) THEN
       Kind:=k_InFuture;
      ELSIF (Money.Source = L_PRoll.src_FtSys) & NeedFtSysIn97() THEN
       Kind:=k_Ignore;
      END;
     END;
     _AcCut:=STx_GetAcCutForMoney();
     IF IsSpecSTxOfficer(Memo.gl_mb()) THEN
      IF MCList.InSign[1] THEN
       _SpcVal:=_Sum;
      END;
     ELSE
      _ObjVal:=_Sum;
      IF ~MCList.InSign[1] THEN
       _ExlVal:=_Sum;
      END;
     END;
    END;
   ELSIF MCList.InSign[1] THEN
    L_General.Assert(MCList.MCode = L_Tax.Tax_GetLoanProfitMCode(Money.Closed),
           "⭮    㤥ঠ, 뢠饬   - 룮  %");
    Kind  :=k_Normal;
    _AcCut:=L_PRoll.E_GetLoanProfitAcCut(Money.Closed);
    _ObjVal:=-_Sum;
   END; (* IF MCList.MCTyp = ... *)
   IF Kind # k_Ignore THEN
    ADD(ScTxB, AcCut, , _AcCut, ProceedPeriod,
        ScTxB.ObjVal, _ObjVal,
        ScTxB.ExlVal, _ExlVal,
        ScTxB.SpcVal, _SpcVal);
    IF Kind = k_InFuture THEN
     ADD(ScTxB, AcCut, , _AcCut, Money.Period,
         ScTxB.ObjVal, -_ObjVal,
         ScTxB.ExlVal, -_ExlVal,
         ScTxB.SpcVal, -_SpcVal);
    END;
   END;
  END; (* IF (Memo.gl_mb() ... *)
 END {STx_KeepForSTax};

 PUBLIC PROCEDURE STx_ClearForSTax(P: DATE);
  VAR
   _Part: tSTx_TaxPartsType;
 BEGIN
  IF P <= STx2001_LastPeriod THEN
   AccessManXObject(Staff.Man, Staff.MyFirm);
   L_XObj.ClearXApport(L_XObj.s_Salary, L_XObj.src_Salary);
   L_XObj.RenovateXCalc(           STx_TotAcCut, P);
   L_XObj.RenovateXCalc(           STx_ExlAcCut, P);
   FOR_EACH _Part DO
    IF _Part > STx_MaxOf_TaxPartsType(P) THEN
     EXIT;
    END;
    L_XObj.RenovateXCalc(STx_GetTaxAcCut(_Part), P);
    L_XObj.RenovateXCalc(STx_GetPoBAcCut(_Part), P);
    L_XObj.RenovateXCalc(STx_GetBnfAcCut(_Part), P);
   END; (* FOR_EACH _Part ... *)
  END;
 END {STx_ClearForSTax};

 PUBLIC PROCEDURE GetManAgeGroup(P: DATE): tManAgeGroup;
  VAR
   birthYear: NUMERIC[0];
 BEGIN
  birthYear:=L_DatTim.YEAR(Man.Birth);
  IF P >= 01\01\2005 THEN
   IF (birthYear <= 1966) THEN
    RETURN mag_Old;
   ELSE
    RETURN mag_Ave;
   END;
  ELSE
   IF    ((Man.Sex = L_Man.sex_Male  ) & (birthYear <= 1952)) |
         ((Man.Sex = L_Man.sex_Female) & (birthYear <= 1956)) THEN
    RETURN mag_Old;
   ELSIF (birthYear <= 1966) THEN
    RETURN mag_Ave;
   ELSE
    L_General.Assert(L_DatTim.YEAR(P) <= 2004, "L_STx: 室 ⠢ |। ⮫쪮  2004 ");
    RETURN mag_Jun;
   END;
  END;
 END {GetManAgeGroup};

 PUBLIC PROCEDURE STx2001_GetScale(P           : DATE;
                                   _Part       : tSTx_TaxPartsType;
                                   _ManAgeGroup: tManAgeGroup;
                                   VAR
                                    _Bas,
                                    _Sum,
                                    _Prc       : NUMERIC[2][]);
 BEGIN
  SETEMPTY(_Bas, _Prc, _Sum);
  _Bas[0]:=0;
  IF E_ApplyRegressiveScale(P) THEN
   IF P >= 01\01\2005 THEN
    _Bas[1]:=280000;
    _Bas[2]:=600000;
   ELSE
    _Bas[1]:=100000;
    _Bas[2]:=300000;
    _Bas[3]:=600000;
   END;
  ELSE
   _Bas[1]:=1000000000;
   _Bas[2]:=3000000000;
   _Bas[3]:=6000000000;
  END;
  IF    _Part = stxp_PFRF THEN
   IF P >= 01\01\2005 THEN
    _Prc[0]:=20.0; _Sum[0]:=    0;
    _Prc[1]:= 7.9; _Sum[1]:=56000;
    _Prc[2]:= 2.0; _Sum[2]:=81280;
   ELSE
    _Prc[0]:=28.0; _Sum[0]:=    0;
    _Prc[1]:=15.8; _Sum[1]:=28000;
    _Prc[2]:= 7.9; _Sum[2]:=59600;
    _Prc[3]:= 2.0; _Sum[3]:=83300;
   END;
  ELSIF _Part = stxp_SSRF THEN
   IF    P >= 01\01\2006 THEN
    _Prc[0]:= 2.9; _Sum[0]:=    0;
    _Prc[1]:= 1.0; _Sum[1]:= 8120;
    _Prc[2]:= 0.0; _Sum[2]:=11320;
   ELSIF P >= 01\01\2005 THEN
    _Prc[0]:= 3.2; _Sum[0]:=    0;
    _Prc[1]:= 1.1; _Sum[1]:= 8960;
    _Prc[2]:= 0.0; _Sum[2]:=12480;
   ELSE
    _Prc[0]:= 4.0; _Sum[0]:=    0;
    _Prc[1]:= 2.2; _Sum[1]:= 4000;
    _Prc[2]:= 1.1; _Sum[2]:= 8400;
    _Prc[3]:= 0.0; _Sum[3]:=11700;
   END;
  ELSIF _Part = stxp_MSFF THEN
   IF    P >= 01\01\2006 THEN
    _Prc[0]:= 1.1; _Sum[0]:=     0;
    _Prc[1]:= 0.6; _Sum[1]:=  3080;
    _Prc[2]:= 0.0; _Sum[2]:=  5000;
   ELSIF P >= 01\01\2005 THEN
    _Prc[0]:= 0.8; _Sum[0]:=     0;
    _Prc[1]:= 0.5; _Sum[1]:=  2240;
    _Prc[2]:= 0.0; _Sum[2]:=  3840;
   ELSE
    _Prc[0]:= 0.2; _Sum[0]:=    0;
    _Prc[1]:= 0.1; _Sum[1]:=  200;
    _Prc[2]:= 0.1; _Sum[2]:=  400;
    _Prc[3]:= 0.0; _Sum[3]:=  700;
   END;
  ELSIF _Part = stxp_MSTF THEN
   IF P >= 01\01\2005 THEN
    _Prc[0]:= 2.0; _Sum[0]:=    0;
    _Prc[1]:= 0.5; _Sum[1]:= 5600;
    _Prc[2]:= 0.0; _Sum[2]:= 7200;
   ELSE
    _Prc[0]:= 3.4; _Sum[0]:=    0;
    _Prc[1]:= 1.9; _Sum[1]:= 3400;
    _Prc[2]:= 0.9; _Sum[2]:= 7200;
    _Prc[3]:= 0.0; _Sum[3]:= 9900;
   END;
  ELSIF (_Part = stxp_PFIn) | (_Part = stxp_PFAc) THEN
   IF    _ManAgeGroup = mag_Old THEN
    IF    _Part = stxp_PFIn THEN
     IF P >= 01\01\2005 THEN
      _Prc[0]:=14.00; _Sum[0]:=    0;
      _Prc[1]:= 5.50; _Sum[1]:=39200;
      _Prc[2]:= 0.00; _Sum[2]:=56800;
     ELSE
      _Prc[0]:=14.00; _Sum[0]:=    0;
      _Prc[1]:= 7.90; _Sum[1]:=14000;
      _Prc[2]:= 3.95; _Sum[2]:=29800;
      _Prc[3]:= 0.00; _Sum[3]:=41650;
     END;
    ELSE
     _Prc[0]:= 0.0; _Sum[0]:=0;
     _Prc[1]:= 0.0; _Sum[1]:=0;
     _Prc[2]:= 0.0; _Sum[2]:=0;
     _Prc[3]:= 0.0; _Sum[3]:=0;
    END;
   ELSIF _ManAgeGroup = mag_Ave THEN
    IF P >= 01\01\2008 THEN
     IF    _Part = stxp_PFIn THEN
      _Prc[0]:=8.00; _Sum[0]:=    0;
      _Prc[1]:=3.10; _Sum[1]:=22400;
      _Prc[2]:=0.00; _Sum[2]:=32320;
     ELSE
      _Prc[0]:=6.00; _Sum[0]:=    0;
      _Prc[1]:=2.40; _Sum[1]:=16800;
      _Prc[2]:=0.00; _Sum[2]:=24480;
     END;
    ELSIF P >= 01\01\2005 THEN
     IF    _Part = stxp_PFIn THEN
      _Prc[0]:=10.00; _Sum[0]:=    0;
      _Prc[1]:= 3.90; _Sum[1]:=28000;
      _Prc[2]:= 0.00; _Sum[2]:=40480;
     ELSE
      _Prc[0]:= 4.00; _Sum[0]:=    0;
      _Prc[1]:= 1.60; _Sum[1]:=11200;
      _Prc[2]:= 0.00; _Sum[2]:=16320;
     END;
    ELSE
     IF    _Part = stxp_PFIn THEN
      _Prc[0]:=12.00; _Sum[0]:=    0;
      _Prc[1]:= 6.80; _Sum[1]:=12000;
      _Prc[2]:= 3.39; _Sum[2]:=25600;
      _Prc[3]:= 0.00; _Sum[3]:=35770;
     ELSE
      _Prc[0]:= 2.00; _Sum[0]:=    0;
      _Prc[1]:= 1.10; _Sum[1]:= 2000;
      _Prc[2]:= 0.56; _Sum[2]:= 4200;
      _Prc[3]:= 0.00; _Sum[3]:= 5880;
     END;
    END; (* IF P >= 01\01\2005... *)
   ELSIF _ManAgeGroup = mag_Jun THEN
    L_General.Assert(P < 01\01\2005, "L_STx:  2005  ⭠ 㯯 "+_ManAgeGroup+"  ।");
    IF P >= 01\01\2004 THEN
     IF    _Part = stxp_PFIn THEN
      _Prc[0]:=10.00; _Sum[0]:=    0;
      _Prc[1]:= 5.64; _Sum[1]:=10000;
      _Prc[2]:= 2.82; _Sum[2]:=21280;
      _Prc[3]:= 0.00; _Sum[3]:=29740;
     ELSE
      _Prc[0]:= 4.00; _Sum[0]:=    0;
      _Prc[1]:= 2.26; _Sum[1]:= 4000;
      _Prc[2]:= 1.13; _Sum[2]:= 8520;
      _Prc[3]:= 0.00; _Sum[3]:=11910;
     END;
    ELSE
     IF    _Part = stxp_PFIn THEN
      _Prc[0]:=11.00; _Sum[0]:=    0;
      _Prc[1]:= 6.21; _Sum[1]:=11000;
      _Prc[2]:= 3.10; _Sum[2]:=23420;
      _Prc[3]:= 0.00; _Sum[3]:=32720;
     ELSE
      _Prc[0]:= 3.00; _Sum[0]:=    0;
      _Prc[1]:= 1.69; _Sum[1]:= 3000;
      _Prc[2]:= 0.85; _Sum[2]:= 6380;
      _Prc[3]:= 0.00; _Sum[3]:= 8930;
     END;
    END; (* IF P >=... *)
   ELSE
    L_General.Error("STx2001_GetScale:Error 2");
   END;
  ELSE
   L_General.Error("STx2001_GetScale:Error 1");
  END;
 END {STx2001_GetScale};

 PUBLIC PROCEDURE STx2001_TaxScale(P     : DATE;
                                   _Part : tSTx_TaxPartsType;
                                   _ToTax: tSTx_SBsValues): SCAL[STx2001_ScaleSize+1];
  VAR
   _Bas,
   _Prc,
   _Sum         : NUMERIC[2][STx2001_ScaleSize];
   PosInScale   : SCAL[STx2001_ScaleSize+1];
 BEGIN
  STx2001_GetScale(P, _Part, GetManAgeGroup(P), _Bas, _Sum, _Prc);

  PosInScale:=1; (* ! 㫥 誠 易  _Bas = 0 *)
  WHILE ~!_Bas[PosInScale] & (_Bas[PosInScale] < _ToTax) DO
   INC(PosInScale);
  END;
  DEC(PosInScale);

  RETURN PosInScale;
 END {STx2001_TaxScale};

 PRIVATE PROCEDURE STx2001_TaxIt(P     : DATE;
                                 _Part : tSTx_TaxPartsType;
                                 _ToTax,
                                 _ToTaxTotal: tSTx_SBsValues;
                                 PosInScale: SCAL[STx2001_ScaleSize+1]): tSTx_TaxValues;
  VAR
   _Bas,
   _Prc,
   _Sum: NUMERIC[2][STx2001_ScaleSize];
 BEGIN
  STx2001_GetScale(P, _Part, GetManAgeGroup(P), _Bas, _Sum, _Prc);
  IF (P>=01\01\2008) & (_ToTaxTotal < 0) THEN
   RETURN 0;
  ELSIF _ToTaxTotal # 0 THEN
   RETURN _Sum[PosInScale]*_ToTax/_ToTaxTotal+_Prc[PosInScale]/100*(_ToTax-_Bas[PosInScale]*_ToTax/_ToTaxTotal);
  ELSE
   RETURN _Sum[PosInScale]+_Prc[PosInScale]/100*(_ToTax-_Bas[PosInScale]);
  END;
 END {STx2001_TaxIt};

 PRIVATE TYPE
  tValuesKind = SCAL[6];
  tSpc        = SCAL[2];

 PRIVATE CONST
  vk_CommonBase = 0;
  vk_byPartBase = 1;
  vk_PaidTax    = 2;
  vk_TaxToPay   = 3;
  vk_MFB        = 4;
  vk_MFBToPay   = 5;

  s_Nrm = 0;
  s_Spc = 1;

 PRIVATE PROCEDURE pt_CheckXApport(_Kind: tValuesKind;
                                   _Spc : tSpc): SCAL[2];
 BEGIN
  IF    _Kind = vk_PaidTax THEN
   IF XApport.Apport # E_Apport_PseudoTax(XApport.XDat) THEN
    IF STx_IsSpecialPFRAcCut(XApport.AcCut) THEN
     RETURN  (_Spc = s_Nrm) = STx_IsTaxAcCut(XApport.AcCut2);
    ELSE
     L_General.ConsultToUs(_Spc = s_Nrm, "pt_ca_OnBase.Error 1");
     RETURN ~STx_IsTaxAcCut(XApport.AcCut2);
    END;
   ELSE
    RETURN 0;
   END;
  ELSE
   RETURN 1;
  END;
 END {pt_CheckXApport};

 PRIVATE PROCEDURE pt_IsAcceptableXApport(P: DATE): SCAL[2];
 BEGIN
  IF (P >= 01\01\2005) | (Str.Cap(DBD.BaseName()) = "ES") THEN
   RETURN (XApport.WFDate = P) |
          ((XApport.XDat <= P) & (XApport.WFDate >= L_DatTim.YearBeg(P)));
  ELSE
   RETURN ((XApport.WFDate = XApport.XDat) & (XApport.XDat <= P)) | (XApport.WFDate = P);
  END;
 END {pt_IsAcceptableXApport};

 PRIVATE PROCEDURE pt_AddBySingleAcCut(P     : DATE;
                                       _AcCut: LIKE(AcCut.AcCut);
                                       _Kind : tValuesKind;
                                       _Spc  : tSpc;
                                       _Part : tSTxPart);
 BEGIN
  L_XObj.RenovateXCalc(_AcCut, P); (* ??? *)
  IF SELECT(XCalc, XObject, XObject.XObject, _AcCut) &
     SRCINSEL(XCalc, GE, L_DatTim.YearBeg(P))        THEN
   WHILE OCCURE(XCalc) DO
    CONFORM(XCalc, XApport);
    WHILE OCCURE(XApport) DO
     IF pt_IsAcceptableXApport(P) THEN
      CONFORM(XApport, Apport);
      IF (Apport.CirType = L_Acnt.ct_Credit) & pt_CheckXApport(_Kind, _Spc) THEN
       ADD(SclTx, Kind, , _Kind, _Spc, _Part, XApport.AcCut2, Math.Max(P, XCalc.XDat),
           SclTx.Value,   XApport.Sum,
           SclTx.InMonth, XApport.Sum*(XCalc.XDat >= P));
      END;
     END;
     NEXT(XApport);
    END; (* WHILE OCCURE(XApport) ... *)
    NEXT(XCalc);
   END; (* WHILE OCCURE(XCalc) ... *)
  END;
 END {pt_AddBySingleAcCut};

 PRIVATE PROCEDURE pt_GetBySingleAcCut(P     : DATE;
                                       _AcCut: LIKE(AcCut.AcCut);
                                       _Kind : tValuesKind;
                                       _Spc  : tSpc;
                                       _Part : tSTxPart): NUMERIC[2];
  VAR
   _Value: NUMERIC[2];
 BEGIN
  L_XObj.RenovateXCalc(_AcCut, P); (* ??? *)
  _Value:=0;
  IF SELECT(XCalc, XObject, XObject.XObject, _AcCut) &
     SRCINSEL(XCalc, GE, L_DatTim.YearBeg(P))        THEN
   WHILE OCCURE(XCalc) DO
    CONFORM(XCalc, XApport);
    WHILE OCCURE(XApport) DO
     IF pt_IsAcceptableXApport(P) THEN
      CONFORM(XApport, Apport);
      IF (Apport.CirType = L_Acnt.ct_Credit) & pt_CheckXApport(_Kind, _Spc) THEN
       INC(_Value, XApport.Sum);
      END;
     END;
     NEXT(XApport);
    END; (* WHILE OCCURE(XApport) ... *)
    NEXT(XCalc);
   END; (* WHILE OCCURE(XCalc) ... *)
  END;
  RETURN _Value;
 END {pt_GetBySingleAcCut};

 PRIVATE PROCEDURE pt_AddSomeBase(P     : DATE;
                                  _AcCut: LIKE(AcCut.AcCut);
                                  _Kind : tValuesKind;
                                  _Spc  : tSpc;
                                  _Part : tSTxPart);
 BEGIN
  L_XObj.RenovateXCalc(_AcCut, P); (* ??? *)
  pt_AddBySingleAcCut(P, _AcCut, _Kind, _Spc, _Part);
 END {pt_AddSomeBase};

 PRIVATE PROCEDURE pt_AddSomeTax(P     : DATE;
                                 _Spc  : tSpc;
                                 _Part : tSTxPart);
 BEGIN
  pt_AddBySingleAcCut(P, STx_GetTaxAcCut(_Part), vk_PaidTax, _Spc, _Part);
 END {pt_AddSomeTax};

 PRIVATE PROCEDURE GetPseudoTax(P: DATE): NUMERIC[2];
  VAR
   Result : NUMERIC[2];
 BEGIN
  Result:=0;
  IF SELECT(XCalc, XObject, XObject.XObject, STx_GetTaxAcCut(stxp_PFRF)) &
     SRCINSEL(XCalc, GE, L_DatTim.YearBeg(P)) THEN
   WHILE OCCURE(XCalc) DO
    CONFORM(XCalc, XApport);
    WHILE OCCURE(XApport) DO
     IF pt_IsAcceptableXApport(P) & (XApport.Apport = E_Apport_PseudoTax(XApport.XDat)) THEN
      INC(Result, XApport.Sum);
     END;
     NEXT(XApport);
    END; (* WHILE OCCURE(XApport) ... *)
    NEXT(XCalc);
   END; (* WHILE OCCURE(XCalc) ... *)
  END;
  RETURN Result;
 END {GetPseudoTax};

 PRIVATE PROCEDURE PutSingleTax(P      : DATE;
                                _Kind  : tValuesKind;
                                _Spc   : tSpc;
                                _Part  : tSTx_TaxPartsType;
                                _Apport: LIKE(Apport.Apport));
 BEGIN
  SELECT(SclTx, Kind, , _Kind, _Spc, _Part);
  WHILE OCCURE(SclTx) DO
   L_XObj.extMakeCir(+1, STx_GetTaxAcCut(_Part), SclTx.XDat, P,
                     _Apport, SclTx.AcCut,
                     SclTx.InMonth, 0, L_XObj.src_Salary);
   NEXT(SclTx);
  END; (* WHILE OCCURE(SclTx) ... *)
 END {PutSingleTax};

 PRIVATE PROCEDURE PutMutualSingleTax(P      : DATE;
                                      _Part  : tSTx_TaxPartsType;
                                      _AcCut : LIKE(AcCut.AcCut);
                                      _Value : tSTx_TaxValues);
 BEGIN
  L_XObj.mo_MakeCir(+1,
                    STx_GetTaxAcCut(_Part),
                    P, L_Acnt.E_Apport_MoneyCredit(P),
                    _AcCut,
                    _Value, L_XObj.src_Salary);
  L_XObj.mo_MakeCir(+1, _AcCut,
                    P, L_Acnt.E_Apport_MoneyDebit(P),
                    STx_GetTaxAcCut(_Part),
                    _Value, L_XObj.src_Salary);
 END {PutMutualSingleTax};

 PRIVATE PROCEDURE PlaceRestToMaxValue(P    : DATE;
                                       _Kind: tValuesKind;
                                       _Spc : tSpc;
                                       _Part: tSTxPart;
                                       Rest : NUMERIC[2]);
  VAR
   _AcCut: LIKE(AcCut.AcCut);
   _XDat : DATE;
   m     : NUMERIC[2];
 BEGIN
  L_General.Assert(Math.Abs(Rest) < 0.1, "PlaceRestToMaxValue: ⭮");
  SETEMPTY(_AcCut);
  m:=0;
  SELECT(SclTx, Kind, , _Kind, _Spc, _Part);
  WHILE OCCURE(SclTx) DO
   IF (Math.Abs(SclTx.InMonth) >= m) & (SclTx.XDat=P) THEN
    _AcCut:=SclTx.AcCut;
    m:=Math.Abs(SclTx.InMonth);
   END;
   NEXT(SclTx);
  END; (* WHILE OCCURE(SclTx) ... *)
  L_General.Assert(~!_AcCut, "PlaceRestToMaxValue:  । "+FLDTOSTR(Rest, "2.", 0));
  SRCINSEL(SclTx, EQ, , _AcCut, P);
  INC(SclTx.InMonth, Rest);
  REPLACE(SclTx);
 END {PlaceRestToMaxValue};

 PRIVATE PROCEDURE Merge(_Spc    : tSpc;
                         _Part   : tSTxPart;
                         dstKind,
                         srcKind : tValuesKind);
  VAR
   _AcCut: LIKE(AcCut.AcCut);
   _XDat : DATE;
 BEGIN
  SELECT(SclTx, Kind, , srcKind, _Spc, _Part);
  WHILE OCCURE(SclTx) DO
   _AcCut:=SclTx.AcCut;
   _XDat :=SclTx.XDat;
   SAVE(SclTx);
   IF ~SELECT(SclTx, Kind, dstKind, _Spc, _Part, _AcCut, _XDat) THEN
    DEFAULT(SclTx);
    SclTx.Kind :=dstKind;
    SclTx.Spc  :=_Spc;
    SclTx.Part :=_Part;
    SclTx.AcCut:=_AcCut;
    SclTx.XDat :=_XDat;
    INSERT(SclTx);
   END;
   RESTORE(SclTx);
   NEXT(SclTx);
  END; (* WHILE OCCURE(SclTx) ... *)
 END {Merge};

 PRIVATE PROCEDURE st_GetSingleValue(_Kind : tValuesKind;
                                     _Spc  : tSpc;
                                     _Part : tSTxPart;
                                     _AcCut: LIKE(AcCut.AcCut);
                                     _XDat : DATE;
                                     v     : SCAL[2]): NUMERIC[2];
  VAR
   Result: NUMERIC[2];
 BEGIN
  SAVE(SclTx);
  IF SEARCH(SclTx, Kind, _Kind, _Spc, _Part, _AcCut, _XDat) THEN
   IF v THEN
    Result:=SclTx.Value;
   ELSE
    Result:=SclTx.InMonth;
   END;
  ELSE
   Result:=0;
  END;
  RESTORE(SclTx);
  RETURN Result;
 END {st_GetSingleValue};

 PRIVATE PROCEDURE st_GetTotal(_Kind: tValuesKind;
                               _Spc : SCAL[2];
                               _Part: tSTxPart;
                               v    : SCAL[2]): NUMERIC[2];
  VAR
   Result: NUMERIC[2];
 BEGIN
  Result:=0;
  SELECT(SclTx, Kind, , _Kind, _Spc, _Part);
  WHILE OCCURE(SclTx) DO
   IF v THEN
    INC(Result, SclTx.Value);
   ELSE
    INC(Result, SclTx.InMonth);
   END;
   NEXT(SclTx);
  END; (* WHILE OCCURE(SclTx) ... *)
  RETURN Result;
 END {st_GetTotal};

 PRIVATE PROCEDURE Put(P        : DATE;
                       _Spc     : SCAL[2];
                       _Part    : tSTx_TaxPartsType;
                       pBasTotal,
                       pTaxTotal,
                       pTaxToPay: NUMERIC[2]);
  VAR
   SinglePart  : tSTx_TaxValues;
   dlbInv      : SCAL[2];
   pTaxRest    : tSTx_TaxValues;
   mfb_TaxTotal,
   mfb_TaxToPay,
   mfb_Rest    : tSTx_TaxValues;
   mfb_Coef    : FLOAT;
 BEGIN
  Merge(_Spc, _Part, vk_PaidTax, vk_byPartBase);
  dlbInv:=(_Part = stxp_PFRF) & STx_Man_IsInvalid(P, Man.Man);
  IF dlbInv THEN
   Merge(_Spc, _Part, vk_PaidTax, vk_MFB);
  END;
  IF SELECT(SclTx, Kind, vk_PaidTax, _Spc, _Part) THEN
   pTaxRest:=pTaxToPay;
   WHILE OCCURE(SclTx) DO
    SAVE(SclTx);
    IF pBasTotal = 0 THEN
     L_General.Assert(pTaxTotal = 0, "㤠   㫥 ?");
     SinglePart:=0;
    ELSE
     SinglePart:=pTaxTotal*(st_GetSingleValue(vk_byPartBase,
                                              _Spc, SclTx.Part,
                                              SclTx.AcCut,
                                              SclTx.XDat,
                                              ~STx_IsSpecialPFRParts(_Part) | _Spc)/pBasTotal);
    END;
    IF ~STx_IsSpecialPFRParts(_Part) | _Spc THEN
     SclTx.InMonth:=SinglePart - SclTx.Value;
    ELSE
     SclTx.InMonth:=SinglePart - SclTx.InMonth;
    END;
    SclTx.Kind   :=vk_TaxToPay;
    SETEMPTY(SclTx.Value);
    INSERT(SclTx);
    DEC(pTaxRest, SclTx.InMonth);
    RESTORE(SclTx);
    NEXT(SclTx);
   END; (* WHILE OCCURE(SclTx) ... *)
   IF pTaxRest # 0 THEN
    PlaceRestToMaxValue(P, vk_TaxToPay, _Spc, _Part, pTaxRest);
   END;
   IF STx_IsSpecialPFRParts(_Part) THEN
    IF _Spc THEN
     PutSingleTax(P, vk_TaxToPay, _Spc, _Part, L_Acnt.E_Apport_MoneyCredit(P));
    ELSE
     PutMutualSingleTax(P, _Part, STx_GetTaxAcCut(stxp_PFRF), pTaxToPay);
     L_XObj.RenovateXCalc(STx_GetTaxAcCut(stxp_PFRF), P);
     SELECT(SclTx, Kind, , vk_TaxToPay, _Spc, _Part);
     WHILE OCCURE(SclTx) DO
      SAVE(SclTx);
      ADD(SclTx, Kind, , vk_MFB, _Spc, stxp_PFRF, SclTx.AcCut, SclTx.XDat,
          SclTx.InMonth, SclTx.InMonth);
      RESTORE(SclTx);
      NEXT(SclTx);
     END; (* WHILE OCCURE(SclTx) ... *)
    END;
   ELSE
    PutSingleTax(P, vk_TaxToPay, _Spc, _Part, L_Acnt.E_Apport_MoneyCredit(P));
    IF dlbInv THEN
     mfb_TaxToPay:=st_GetTotal(vk_MFB, s_Nrm, _Part, 0);
     IF dlbInvVer = 1 THEN
      mfb_Rest:=mfb_TaxToPay-pTaxToPay;
     ELSE
      mfb_TaxTotal:=GetPseudoTax(P) + mfb_TaxToPay;
      mfb_Rest:=mfb_TaxToPay-Math.Min(Math.Max(mfb_TaxTotal-0.14*DlbInvlSum(P), 0),
                                      Math.Max(mfb_TaxToPay, 0));
      IF mfb_TaxToPay # 0 THEN
       mfb_Coef:=mfb_Rest/mfb_TaxToPay;
      ELSE
       L_General.CallUs(mfb_Rest=0);
       mfb_Coef:=0;
      END;
     END;
     SELECT(SclTx, Kind, , vk_TaxToPay, _Spc, _Part);
     WHILE OCCURE(SclTx) DO
      SAVE(SclTx);
      SinglePart:=st_GetSingleValue(vk_MFB, SclTx.Spc, SclTx.Part,
                                    SclTx.AcCut, SclTx.XDat, 0);
      SclTx.Kind:=vk_MFBToPay;
      IF dlbInvVer = 1 THEN
       SclTx.InMonth:=SinglePart - SclTx.InMonth;
      ELSE
       SclTx.InMonth:=SinglePart*mfb_Coef;
      END;
      INSERT(SclTx);
      DEC(mfb_Rest, SclTx.InMonth);
      RESTORE(SclTx);
      NEXT(SclTx);
     END; (* WHILE OCCURE(SclTx) ... *)
     IF mfb_Rest # 0 THEN
      PlaceRestToMaxValue(P, vk_MFBToPay, _Spc, _Part, mfb_Rest);
     END;
     PutSingleTax(P, vk_MFBToPay, _Spc, _Part, E_Apport_PseudoTax(P));
    END; (* IF dlbInv ... *)
   END; (* IF STx_IsSpecialPFRParts(_Part) ... *)
   L_XObj.RenovateXCalc(STx_GetTaxAcCut(_Part), P);
  END;
 END {Put};

 PRIVATE PROCEDURE pt_PrepareTmp();
 BEGIN
  IF ~DBD.FileExist(SclTx) THEN
   CreateFILE(SclTx, "", "᫥ ", "");
 
   CreateFIELD(SclTx, Kind,    tValuesKind, "", "", "", " 稭", "");
   CreateFIELD(SclTx, Spc,     tSpc, "", "", "", "樠 ०", "1-");
   CreateFIELD(SclTx, Part,    tSTxPart, "", "", "", " ", "");
   CreateFIELD(SclTx, AcCut,   LIKE(AcCut.AcCut), "", "", "", "ᯮ騩 ࠧ१", "");
   CreateFIELD(SclTx, XDat,    DATE, "", "", "", "ਮ ", "");
   CreateFIELD(SclTx, Value,   NUMERIC[2], "", "0", "", "稭  砫 ", "");
   CreateFIELD(SclTx, InMonth, NUMERIC[2], "", "0", "", "稭  ", "");

   CreateINDEX(SclTx, Kind, UNIQUE, "", "",  Kind, Spc, Part, AcCut, XDat);

   SetVersionOfFILE(SclTx, 0000);
  END;
  AttachFILE(SclTx, Temporary, L_General.NameConnection("SclTx") + ".did");
 END {pt_PrepareTmp};

 PRIVATE PROCEDURE pt_CloneCommonBase(_Spc : tSpc;
                                      _Part: tSTxPart);
 BEGIN
  SELECT(SclTx, Kind, , vk_CommonBase, _Spc);
  WHILE OCCURE(SclTx) DO
   SAVE(SclTx);
   SclTx.Kind:=vk_byPartBase;
   SclTx.Spc :=_Spc;
   SclTx.Part:=_Part;
   INSERT(SclTx);
   RESTORE(SclTx);
   NEXT(SclTx);
  END; (* WHILE OCCURE(SclTx) ... *)
 END {pt_CloneCommonBase};

 PRIVATE PROCEDURE pt_PrepareSclTxByPart(P: DATE; _Part: tSTxPart);
 BEGIN
  pt_CloneCommonBase(s_Nrm, _Part);
  pt_AddSomeBase(P, STx_GetPoBAcCut(_Part), vk_byPartBase, s_Nrm, _Part);
  pt_AddSomeBase(P, STx_GetBnfAcCut(_Part), vk_byPartBase, s_Nrm, _Part);
  pt_AddSomeTax(P, s_Nrm, _Part);
  IF STx_IsSpecialPFRParts(_Part) THEN
   pt_CloneCommonBase(s_Spc, _Part);
   pt_AddSomeTax(P, s_Spc, _Part);
  END;
 END {pt_PrepareSclTxByPart};

 PUBLIC PROCEDURE STx_PutTaxes(P: DATE);
  VAR
  _Part         : tSTx_TaxPartsType;
  pBnfGrandTotal,
  pBasGrandTotal: tSTx_SBsValues;
  pBasBnf,
  pBasTotal     : tSTx_SBsValues[MAXOF(tSpc)+1];
  pTaxTotal,
  pTaxToPay     : tSTx_TaxValues[MAXOF(tSpc)+1];
  PosInScale    : SCAL[STx2001_ScaleSize+1];
 BEGIN
  IF P <= STx2001_LastPeriod THEN
   IF L_Staff.IsMainForTax(L_DatTim.MonthEnd(P)) THEN
    pt_PrepareTmp();
    AccessManXObject(Staff.Man, Staff.MyFirm);
    pt_AddSomeBase(P, STx_TotAcCut, vk_CommonBase, s_Nrm, L_General.EMPTY_NUMBER());
    pt_AddSomeBase(P, STx_ExlAcCut, vk_CommonBase, s_Nrm, L_General.EMPTY_NUMBER());
    pt_AddSomeBase(P, Spc_BasAcCut, vk_CommonBase, s_Spc, L_General.EMPTY_NUMBER());
    _Part:=STx_MaxOf_TaxPartsType(P);
    LOOP
     PROMPT("᫥ :  " + FLDTOSTR(Man.Man, "", 5) + " " + L_DatTim.PeriodStr(P) + " " + L_Str.PoolItem(stxp_Pool, _Part));
     pt_PrepareSclTxByPart(P, _Part);
 
     pBasTotal[s_Nrm]:=st_GetTotal(vk_byPartBase, s_Nrm, _Part, 1);
     pBasTotal[s_Spc]:=st_GetTotal(vk_byPartBase, s_Spc, _Part, 1);
 
     pBasGrandTotal:=pBasTotal[s_Nrm]+pBasTotal[s_Spc];
     SETZERO(pBasBnf, pBnfGrandTotal);
     IF (P>=01\01\2005) & (pBasGrandTotal # 0) & ~STx_IsSpecialPFRParts(_Part) THEN
      pBnfGrandTotal:=-1*pt_GetBySingleAcCut(P, STx_GetBnfAcCut(_Part), vk_byPartBase, s_Nrm, _Part);
      IF pBnfGrandTotal # 0 THEN
       pBasBnf[s_Nrm]:=pBasTotal[s_Nrm] * pBnfGrandTotal / pBasGrandTotal;
       pBasBnf[s_Spc]:=pBasTotal[s_Spc] * pBnfGrandTotal / pBasGrandTotal;
      END;
     END;
 
     pBasGrandTotal:=pBasGrandTotal+pBnfGrandTotal;
     PosInScale    :=STx2001_TaxScale(P, _Part, pBasGrandTotal);
 
     pTaxTotal[s_Nrm]:=STx2001_TaxIt(P, _Part, pBasTotal[s_Nrm]+pBasBnf[s_Nrm], pBasGrandTotal, PosInScale);
     pTaxTotal[s_Spc]:=STx2001_TaxIt(P, _Part, pBasTotal[s_Spc]+pBasBnf[s_Spc], pBasGrandTotal, PosInScale);
 
     IF ~STx_IsSpecialPFRParts(_Part) THEN
      DEC(pTaxTotal[s_Nrm], STx2001_TaxIt(P, _Part, pBasBnf[s_Nrm], pBnfGrandTotal, 0)); (*誠 0!!!*)
      DEC(pTaxTotal[s_Spc], STx2001_TaxIt(P, _Part, pBasBnf[s_Spc], pBnfGrandTotal, 0)); (*誠 0!!!*)
     END;
 
     pTaxToPay[s_Nrm]:=pTaxTotal[s_Nrm]-st_GetTotal(vk_PaidTax, s_Nrm, _Part, 1);
     pTaxToPay[s_Spc]:=pTaxTotal[s_Spc]-st_GetTotal(vk_PaidTax, s_Spc, _Part, 1);
 
     IF STx_IsSpecialPFRParts(_Part) THEN
      pBasTotal[s_Nrm]:=st_GetTotal(vk_byPartBase, s_Nrm, _Part, 0);
      pTaxTotal[s_Nrm]:=pTaxToPay[s_Nrm];
 (* 14.10.2005 18:01:51 POLAK\Gina. 蠥 ஡ "㤠   㫥 "  ॢ 饣 ॣ   *)
      IF (pBasTotal[s_Nrm] = 0) & (pTaxToPay[s_Nrm] # 0) THEN (* ⥪饬   s_Nrm, ࠭ .  ண s_Nrm*)
       INC(pTaxTotal[s_Spc], pTaxTotal[s_Nrm]);
       pTaxTotal[s_Nrm]:=0;
       INC(pTaxToPay[s_Spc], pTaxToPay[s_Nrm]);
       pTaxToPay[s_Nrm]:=0;
       L_General.Assert((pTaxToPay[s_Spc] # 0) = (st_GetTotal(vk_byPartBase, s_Spc, _Part, 0) # 0), " ,   㫥");
      END;
     END;
 
     Put(P, s_Nrm, _Part, pBasTotal[s_Nrm], pTaxTotal[s_Nrm], pTaxToPay[s_Nrm]);
 
     IF STx_IsSpecialPFRParts(_Part) & (pTaxToPay[s_Spc] # 0) &
        (Get_woTaxManKind(P, Man.Man)#wotmk_Foreigner) THEN
      Put(P, s_Spc, _Part, pBasTotal[s_Spc], pTaxTotal[s_Spc], pTaxToPay[s_Spc]);
     END;
     IF _Part = MINOF(_Part) THEN
      EXIT;
     ELSE
      DEC(_Part);
     END;
    END; (* LOOP ... *)
    DetachFILE(SclTx, Purge);
    WriteOffSaldo(P);
   END; (* IF L_Staff.IsMainForTax ... *)
  END; (* IF P <= STx2001_LastPeriod *)
 END {STx_PutTaxes};

 PRIVATE PROCEDURE RecalculateCurrentMan(PerB, PerE: DATE);
  VAR
   _TSNCnt : NUMERIC[0];
   _MainTSN: LIKE(Staff.TSN);
   _CurDate,
   _Period : DATE;
 BEGIN
  L_General.Assert(ACCESS(Man), " । ⥪   ᯨ᪥ 䨧");

  _CurDate:=Memo.gl_cd();
  SELECT(mfMan, Man, , Man.Man);
  WHILE OCCURE(mfMan) DO
   L_XObj.AccessXObject(mfMan.XObject);
   _Period:=PerE;
   WHILE _Period >= PerB DO
    PROMPT("⪠  : " + FLDTOSTR(Man.Man, "", 5) + " " + L_DatTim.PeriodStr(_Period));
    Memo.gl_SetCurDate(_Period);
    L_XObj.ClearXApport(L_XObj.s_Salary, L_XObj.src_Salary);
    _Period:=L_DatTim.IncMonth(_Period, -1);
   END; (* WHILE _Period >= ... *)
   NEXT(mfMan);
  END; (* WHILE OCCURE(mfMan) ... *)

  SELECT(Staff, Man, , Man.Man);
  WHILE OCCURE(Staff) DO
   L_XObj.AccessXObjectByOrigin(L_XObj.o_Staff);
   _Period:=PerE;
   WHILE _Period >= PerB DO
    PROMPT("⪠  ࠡ⭨: " + FLDTOSTR(Man.Man, "", 5) + " " + L_DatTim.PeriodStr(_Period));
    Memo.gl_SetCurDate(_Period);
    L_XObj.ClearXApport(L_XObj.s_Salary, L_XObj.src_Salary);
    _Period:=L_DatTim.IncMonth(_Period, -1);
   END; (* WHILE _Period >= ... *)
   NEXT(Staff);
  END;

  _Period:=PerB;
  WHILE _Period <= PerE DO
   Memo.gl_SetCurDate(_Period);
   SELECT(mfMan, Man, , Man.Man);
   WHILE OCCURE(mfMan) DO
    SAVE(mfMan);
    SETEMPTY(_MainTSN); _TSNCnt:=0;
    SELECT(Staff, MyFirm, , mfMan.MyFirm, mfMan.Man);
    WHILE OCCURE(Staff) DO
     IF L_Staff.IsBegan(_Period) THEN
      INC(_TSNCnt);
      STx_StaffProceedInit(_Period);
      IF L_Staff.IsMainForTax(L_DatTim.MonthEnd(_Period)) THEN
       L_General.Assert(!_MainTSN, " "+Man.Man+":   ࠪ  "+L_DatTim.DateStr(L_DatTim.MonthEnd(_Period)));
       _MainTSN:=Staff.TSN;
      END;
      SELECT(Money, TSN, , Staff.TSN, _Period);
      WHILE OCCURE(Money) DO
       CONFORM(Money, MCList);
       STx_KeepForSTax(Money.Sum);
       NEXT(Money);
      END; (* WHILE OCCURE(Money) ... *)
      STx_StaffProceedDone();
     END;
     NEXT(Staff);
    END; (* WHILE OCCURE(Staff) ... *)
    IF _TSNCnt > 0 THEN
     L_General.Assert(~!_MainTSN, " "+mfMan.Man+":    ࠪ  "+L_DatTim.DateStr(L_DatTim.MonthEnd(_Period)));
     SEARCH(Staff, TSN, , _MainTSN);
     STx_PutTaxes(_Period);
    END;
    RESTORE(mfMan);
    NEXT(mfMan);
   END; (* WHILE OCCURE(mfMan) ... *)
   _Period:=L_DatTim.IncMonth(_Period, +1);
  END;
  Memo.gl_SetCurDate(_CurDate);
 END {RecalculateCurrentMan};

 PUBLIC PROCEDURE CheckLastPeriod(P: DATE);
 BEGIN
  L_General.Assert(L_DatTim.Per(P)<=STx2001_LastPeriod, "   "+L_DatTim.PeriodStr(STx2001_LastPeriod));
 END {CheckLastPeriod};

 PUBLIC PROCEDURE RecalculateCurrentStaff(PerB, PerE: DATE);
 BEGIN
  L_General.Assert(ACCESS(Staff), " । ⥪   ᯨ᪥ ࠡ⭨");
  CONFORM(Staff, Man);
  STDMSG("   ਮ " +
         L_DatTim.PeriodStr(PerB)+" - "+L_DatTim.PeriodStr(PerE) +
         "| " + Man.Name, CHOICE);
  CheckLastPeriod(PerE);
  RecalculateCurrentMan(PerB, PerE);
 END {RecalculateCurrentStaff};

 PUBLIC PROCEDURE RecalculateAll(PerB, PerE: DATE);
 BEGIN
  STDMSG("   ਮ " +
         L_DatTim.PeriodStr(PerB)+" - "+L_DatTim.PeriodStr(PerE) +
         "| ᥬ ࠡ⭨", CHOICE);
  CheckLastPeriod(PerE);
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   PROMPT(" :  " + FLDTOSTR(Man.Man, "", 5));
   RecalculateCurrentMan(PerB, PerE);
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
 END {RecalculateAll};

(*--------- begin of normal environment ----------------*)

 PRIVATE PROCEDURE E_STxRoundBase(P: DATE): SCAL[2];
 BEGIN
  IF P >= 01\01\2002 THEN
   RETURN 0;
  ELSE
   RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_PRoll.STx_RoundBase), 1);
  END;
 END {E_STxRoundBase};

 PUBLIC PROCEDURE E_ApplySTxBenefitToInvalid(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_PRoll.ApplySTxBenefitToInvalid), 1);
 END {E_ApplySTxBenefitToInvalid};

 PUBLIC PROCEDURE E_ApplyRegressiveScale(P: DATE): SCAL[2];
 BEGIN
  IF P >= 01\01\2002 THEN
   RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_PRoll.ApplyRegressiveScale), 1);
  ELSE
   RETURN 0;
  END;
 END {E_ApplyRegressiveScale};

 PRIVATE PROCEDURE E_Apport_PseudoTax(P: DATE): LIKE(Apport.Apport);
 BEGIN
  RETURN 900;
 END {E_Apport_PseudoTax};

BEGIN
 SETEMPTY(ProceedPeriod);
END.
