(*
%Copyright   (c) Polak Computer System
%Author      18.07.2002 18:56:13 SAN
%Purpose
%Type        library
%Specific    SYS
%Modified    20.03.2013 17:14:58 POLAK\San
%Environment
*)

 MODULE L_SysLog [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tHandle            = SCAL[1E16];
  tKind              = SCAL[1E2];

 PUBLIC CONST
  knd_Insert     = 000;
  knd_Edit       = 001;
  knd_Delete     = 002;
  knd_RunProg    = 003;
  knd_AutoBuild  = 004;
  knd_AutoEdit   = 005;

  knd_Field      = 009;
  knd_CurRecord  = 010;

  knd_Pool = "⠢|||ணࠬ|. ⮢|. ।-| | | ||";

  fvDelimiter    = CHR(26); (*  *)

 IMPORT L_General, Str, L_Str, L_DBD, FIO, L_DatTim, Math, L_lsStore, L_AR, L_NTF, L_NetWrk, L_Guard, L_ACL;

 PRIVATE VAR
  FieldsDic: OBJECT;

 PUBLIC PROCEDURE IsTerminatingKind(_Kind: tKind): SCAL[2];
 BEGIN
  RETURN (_Kind = knd_Insert) | (_Kind = knd_Edit) | (_Kind = knd_Delete) | (_Kind = knd_AutoBuild) | (_Kind = knd_AutoEdit);
 END {IsTerminatingKind};

 PUBLIC PROCEDURE GetPseudoLendWithRECORDID(    FName: STRING[];
                                            VAR LName: STRING[];
                                            VAR LRI  : LIKE(SYSLOG_.riLend));
 BEGIN
  SETEMPTY(LName, LRI);
  IF (FName = "RprJ") | (FName = "RprP") | (FName = "RprPro") THEN
   LName:="RprS";
   CONFORM((FName), (LName));
   LRI  :=^(TABLE.Get(LName).Fields("RECORDID").ObtainName());
  END;
 END {GetPseudoLendWithRECORDID};

 PUBLIC PROCEDURE GetLendWithRECORDID(    FName: STRING[];
                                      VAR LName: STRING[];
                                      VAR LRI  : LIKE(SYSLOG_.riLend));
  VAR
   nextLendName: STRING[];
 BEGIN
  GetPseudoLendWithRECORDID(FName, LName, LRI);
  IF !LName & ~!TABLE.Get(FName).LendLink THEN
   nextLendName:=TABLE.Get(FName).LendLink.CooIndex.Table.Name;
   SAVE(^nextLendName);
   CONFORM(^FName, ^nextLendName);
   IF ~!TABLE.Get(nextLendName).Fields("RECORDID") THEN
    LName:=nextLendName;
    LRI  :=^(TABLE.Get(nextLendName).Fields("RECORDID").ObtainName());
   ELSE
    GetLendWithRECORDID(nextLendName, LName, LRI);
   END;
   RESTORE(^nextLendName);
  END;
 END {GetLendWithRECORDID};

 PRIVATE PROCEDURE FillSysLog_OwnLend(_fiOwn: LIKE(SYSLOG_.fiOwn));
  VAR
   FName,
   LName : STRING[];
   LRI   : LIKE(SYSLOG_.riLend);
   FTable: TABLE;
 BEGIN
  SYSLOG_.fiOwn:=_fiOwn;
  SETEMPTY(SYSLOG_.riOwn, SYSLOG_.fiLend, SYSLOG_.riLend);
  FTable:=DATABASE.Get().TableById(_fiOwn);
  FName:=FTable.Name;
  IF ~!FTable.Fields("RECORDID") THEN
   SYSLOG_.riOwn:=^(FTable.Fields("RECORDID").ObtainName());
  END;
  GetLendWithRECORDID(FName, LName, LRI);
  IF ~!LRI THEN
   SYSLOG_.fiLend:=TABLE.Get(LName).Id;
   SYSLOG_.riLend:=LRI;
  END;
 END {FillSysLog_OwnLend};

 PRIVATE PROCEDURE intOpenHandle(trgObject: LIKE(SYSLOG_.Object); trgFileId: NUMERIC[0]; IsTmpRc: SCAL[2]): tHandle;
  VAR
   i           : NUMERIC[0];
   cur_tmpRcCnt: LIKE(SYSLOG_.tmpRcCnt);
   curSYSLOG_  : LIKE(SYSLOG_.SYSLOG_);
S: FLOAT;
 BEGIN
  SETEMPTY(curSYSLOG_);
  IF IsTmpRc THEN
   TRY
    TABLE.Get("SYSLOG_").AccessDataMode:=adm_SOFT;
    SETSEL(SYSLOG_, AcsObj, L_General.curUSER);
    LAST(SYSLOG_);
    i:=0;
    LOOP
     IF    ~OCCURE(SYSLOG_) | (i = 100) THEN
      cur_tmpRcCnt:=1;
      EXIT;
     ELSIF SYSLOG_.tmpRcCnt # 0 THEN
      IF SYSLOG_.tmpRcCnt = MAXOF(SYSLOG_.tmpRcCnt) THEN
       cur_tmpRcCnt:=1;
      ELSE
       cur_tmpRcCnt:=SYSLOG_.tmpRcCnt + 1;
      END;
      EXIT;
     END;
     PREV(SYSLOG_);
     INC(i);
    END; (* LOOP *)
   EXCEPT
   ON Exc: Exc_Root DO
    RAISE();
   END; (* TRY *)
   IF SELECT(SYSLOG_, tmpRcCnt, L_General.curUSER, cur_tmpRcCnt) & LAST(SYSLOG_) THEN
    curSYSLOG_:=SYSLOG_.SYSLOG_;
   END;
  ELSE
   cur_tmpRcCnt:=0;
  END;

SETEMPTY(SYSLOG_.ETime, SYSLOG_.ESec);
  SYSLOG_.SYSLOG_ :=curSYSLOG_;
  SYSLOG_.AcsObj  :=L_General.curUSER;
  SYSLOG_.Object  :=trgObject;
  IF ~!trgFileId THEN
   FillSysLog_OwnLend(trgFileId);
  ELSE
   SETEMPTY(SYSLOG_.fiOwn, SYSLOG_.riOwn, SYSLOG_.fiLend, SYSLOG_.riLend);
  END;
SYSLOG_.BTime   :=SYSTIME(S);
SYSLOG_.BSec    :=S DIV 1;
  SYSLOG_.BegDTS  :=SYSTIMESTAMP();
  SYSLOG_.Date    :=L_DatTim.GetDateOfTIMESTAMP(SYSLOG_.BegDTS);
  SETEMPTY(SYSLOG_.EndDTS);
  SYSLOG_.tmpRcCnt:=cur_tmpRcCnt;
  IF ~!SYSLOG_.fiOwn & !SYSLOG_.riOwn & !SYSLOG_.riLend THEN
   L_General.CallUs(SYSLOG_.tmpRcCnt > 0);
  END;
  IF !SYSLOG_.SYSLOG_ THEN
   INSERT(SYSLOG_);
  ELSE
   REPLACE(SYSLOG_);
   IF SELECT(SYSLOGD, SYSLOG_, SYSLOG_.SYSLOG_) THEN
    TRY
     SE_INTEGRITY(1);
     REMSEL(SYSLOGD);
    EXCEPT
    END; (* TRY *)
   END;
  END;
  RETURN SYSLOG_.SYSLOG_;
 END {intOpenHandle};

 PRIVATE PROCEDURE OpenHandleByFile(File: STRING[]; IsTmpRc: SCAL[2]): tHandle;
 BEGIN
  IF ~!DATABASE.Get().Tables(File) THEN
   RETURN intOpenHandle(File, TABLE.Get(File).Id, IsTmpRc);
  ELSE
   L_General.CallUs(0);
  END;
 END {OpenHandleByFile};

 PRIVATE PROCEDURE CloseHandle(VAR Handle: tHandle);
VAR
 S: FLOAT;
 BEGIN
  L_General.CallUs(SEARCH(SYSLOG_, SYSLOG_, Handle));
  L_General.CallUs(!SYSLOG_.EndDTS);
  SYSLOG_.EndDTS:=SYSTIMESTAMP();
SYSLOG_.ETime :=SYSTIME(S);
SYSLOG_.ESec  :=S DIV 1;
  REPLACE(SYSLOG_);
 END {CloseHandle};

 PRIVATE PROCEDURE PutItem(Handle    : tHandle;
                           _Kind     : tKind;
                           _FileId   : LIKE(SYSLOGD.FileId);
                           _FieldId  : LIKE(SYSLOGD.FieldId);
                           _FieldIdx : LIKE(SYSLOGD.FieldIdx);
                           _Descr    : STRING[]);
  VAR
   pos,
   LeftPos,
   RightPos,
   MaxLength,
   LeftLength,
   RightLength: NUMERIC[0];
   Rest,
   Left,
   Right      : STRING[];
 BEGIN
  L_General.CallUs(~!Handle);
  MaxLength:=Str.MaxLength(SYSLOGD.Descr) + Str.MaxLength(SYSLOGA.Descr) * MAXOF(SYSLOGA.SYSLOGA);
  IF Str.Length(_Descr) > MaxLength THEN
   IF Str.Pos(_Descr, fvDelimiter) = Str.Length(_Descr) THEN
    _Descr     :=Str.Slice(_Descr, 0, MaxLength);
   ELSE
    MaxLength  :=MaxLength - 1;
    Left       :=L_Str.AnyItem(_Descr, fvDelimiter, 0);
    Right      :=L_Str.AnyItem(_Descr, fvDelimiter, 1);
    LeftLength :=Str.Length(Left);
    RightLength:=Str.Length(Right);
 
    LeftPos    :=Math.Min(LeftLength, MaxLength - Math.Min(RightLength, MaxLength/2));
    RightPos   :=MaxLength - LeftPos;
    _Descr     :=Str.Slice(Left, 0, LeftPos) +
                 fvDelimiter +
                 Str.Slice(Right, 0, RightPos);
   END;
  END;
  DEFAULT(SYSLOGD);
  SYSLOGD.SYSLOG_ :=Handle;
  SYSLOGD.Kind    :=_Kind;
  SYSLOGD.FileId  :=_FileId;
  SYSLOGD.FieldId :=_FieldId;
  SYSLOGD.FieldIdx:=_FieldIdx;
  SYSLOGD.Descr   :=_Descr;
  INSERT(SYSLOGD);
  pos:=Str.MaxLength(SYSLOGD.Descr);
  LOOP
   Rest:=Str.Slice(_Descr, pos, Str.MaxLength(SYSLOGA.Descr));
   IF !Rest THEN
    EXIT;
   ELSE
    DEFAULT(SYSLOGA);
    SYSLOGA.SYSLOG_:=SYSLOGD.SYSLOG_;
    SYSLOGA.SYSLOGD:=SYSLOGD.SYSLOGD;
    SYSLOGA.Descr  :=Rest;
    INSERT(SYSLOGA);
   END;
   INC(pos, Str.MaxLength(SYSLOGA.Descr));
  END; (* LOOP *)
 END {PutItem};

 PRIVATE PROCEDURE PutField_Unconditional(Handle   : tHandle;
                                          File     : STRING[];
                                          Field    : STRING[];
                                          Idx      : NUMERIC[0];
                                          fullField: STRING[];
                                          after    : SCAL[2]);
  VAR
   _Descr: STRING[];
 BEGIN
  IF after THEN
   _Descr:=fvDelimiter;
  ELSE
   _Descr:="";
  END;
  PutItem(Handle, knd_Field,
          TABLE.Get(File).Id,
          TABLE.Get(File).Fields(Field).Id,
          Idx,
          _Descr + L_DBD.FieldToStr(fullField, TYPEOF(^fullField)));
 END {PutField_Unconditional};

 PRIVATE PROCEDURE PutField_Before(Handle   : tHandle;
                                   File     : STRING[];
                                   Field    : STRING[];
                                   Idx      : NUMERIC[0];
                                   fullField: STRING[]);
 BEGIN
  PutField_Unconditional(Handle, File, Field, Idx, fullField, 0);
 END {PutField_Before};

 PRIVATE PROCEDURE PutField_After(Handle   : tHandle;
                                  File     : STRING[];
                                  Field    : STRING[];
                                  Idx      : NUMERIC[0];
                                  fullField: STRING[]);
 BEGIN
  PutField_Unconditional(Handle, File, Field, Idx, fullField, 1);
 END {PutField_After};

 PRIVATE PROCEDURE PutField_wChangedPValue(Handle   : tHandle;
                                           File     : STRING[];
                                           Field    : STRING[];
                                           Idx      : NUMERIC[0];
                                           fullField: STRING[]);
 BEGIN
  IF ^fullField # GE_PVALUE(^fullField) THEN
   PutItem(Handle, knd_Field,
           TABLE.Get(File).Id,
           TABLE.Get(File).Fields(Field).Id,
           Idx,
           L_DBD.FieldToStr("GE_PVALUE("+fullField+")", TYPEOF(^fullField)) +
           fvDelimiter +
           L_DBD.FieldToStr(fullField, TYPEOF(^fullField)));
  END;
 END {PutField_wChangedPValue};

 PRIVATE PROCEDURE PutPrimaryKey(Handle: tHandle; File: STRING[]; Kind: tKind);
  VAR
   Index,
   Value : STRING[];
 BEGIN
  L_DBD.GetPrimaryIndexAndValue(File, Index, Value);
  PutItem(Handle, Kind,
          TABLE.Get(File).Id,
          TABLE.Get(File).Indexes(Index).Fields(0).Id,
          0,
          Value);
 END {PutPrimaryKey};

 PRIVATE PROCEDURE StoreFieldBeforeModification(Handle   : tHandle;
                                                File     : STRING[];
                                                Field    : STRING[];
                                                Idx      : NUMERIC[0];
                                                fullField: STRING[]);
 BEGIN
  SingleMark_InitField(fullField);
 END {StoreFieldBeforeModification};

 PRIVATE PROCEDURE PutField_wChangedStoredValue(Handle   : tHandle;
                                                File     : STRING[];
                                                Field    : STRING[];
                                                Idx      : NUMERIC[0];
                                                fullField: STRING[]);
  VAR
   PrvValue,
   CurValue: STRING[];
 BEGIN
  CurValue:=L_DBD.FieldToStr(fullField, TYPEOF(^fullField));
  L_General.CallUs(FieldsDic.Exists(fullField) # 0);
  PrvValue:=FieldsDic.Item(fullField);
  FieldsDic.Remove(fullField);
  IF CurValue # PrvValue THEN
   PutItem(Handle, knd_Field,
           TABLE.Get(File).Id,
           TABLE.Get(File).Fields(Field).Id,
           Idx,
           PrvValue + fvDelimiter + CurValue);
  END;
 END {PutField_wChangedStoredValue};

 PRIVATE PROCEDURE WalkRoundFields(Handle: tHandle; File: STRING[]; Proc: PROC);
  VAR
   i, r : NUMERIC[0];
   Type : TYPESPEC;
   Field: FIELD;
 BEGIN
  FOR_EACH Field IN TABLE.Get(File).Fields DO
   r:=GET_TYPE_SPEC(^(Field.ObtainName())).Range;
   i:=0;
   WHILE i < r DO
    Proc(Handle, File, Field.Name, i,
        L_DBD.GetFullFieldName(File, Field.Name, i));
    INC(i);
   END; (* WHILE i < r...*)
  END; (* FOR_EACH *)
 END {WalkRoundFields};

 PRIVATE PROCEDURE SingleMark_PutRecord(File: STRING[]; Kind: tKind; IsTmpRc: SCAL[2]);
  VAR
   Handle: tHandle;
   P     : PROC;
 BEGIN
  IF    Kind = knd_Edit                              THEN P:=PROCREF(PutField_wChangedPValue);
  ELSIF Kind = knd_Delete                            THEN P:=PROCREF(PutField_Before);
  ELSIF (Kind = knd_Insert) | (Kind = knd_AutoBuild) THEN SETEMPTY(P);
  ELSE
   L_General.CallUs(0);
  END;
  TRY
   Handle:=OpenHandleByFile(File, IsTmpRc);
   IF ~!P THEN
    WalkRoundFields(Handle, File, P);
    IF ~SELECT(SYSLOGD, SYSLOG_, Handle) THEN
     L_General.RaiseLockReleaseException();
    END;
   END;
   PutPrimaryKey(Handle, File, Kind);
   CloseHandle(Handle);
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
 END {SingleMark_PutRecord};

 PUBLIC PROCEDURE SingleMark_Init(File: STRING[]);
 BEGIN
  FieldsDic:=L_General.CreateDictionary();
  WalkRoundFields("", File, PROCREF(StoreFieldBeforeModification));
 END {SingleMark_Init};

 PUBLIC PROCEDURE SingleMark_InitField(fullField: STRING[]);
 BEGIN
  L_General.CreatePermanentDictionary(FieldsDic);
  L_General.CallUs(FieldsDic.Exists(fullField) = 0);
  FieldsDic.Add(fullField, L_DBD.FieldToStr(fullField, TYPEOF(^fullField)));
 END {SingleMark_InitField};

 PUBLIC PROCEDURE SingleMark_Done(File: STRING[]);
  VAR
   Handle   : tHandle;
   i,
   n,
   Idx,
   ChgCnt   : NUMERIC[0];
   CurValue,
   PrvValue,
   Field,
   fullField: STRING[];
   Keys     : STRING[][1000];
 BEGIN
  TRY
   Handle:=OpenHandleByFile(File, 0);
   Keys  :=FieldsDic.Keys();
   i     :=FieldsDic.Count;
   ChgCnt:=0;
   WHILE i > 0 DO
    DEC(i);
    fullField:=Keys[i];
    IF File = L_DBD.ffn_GetFile(fullField) THEN
     CurValue:=L_DBD.FieldToStr(fullField, TYPEOF(^fullField));
     PrvValue:=FieldsDic.Item(fullField);
     FieldsDic.Remove(fullField);
     IF CurValue # PrvValue THEN
      Field:=L_DBD.ffn_GetField(fullField);
      Idx  :=L_DBD.ffn_GetIndex(fullField);
      PutItem(Handle, knd_Field,
              TABLE.Get(File).Id,
              TABLE.Get(File).Fields(Field).Id,
              Idx,
              PrvValue + fvDelimiter + CurValue);
      INC(ChgCnt);
     END; (* IF CurValue # PrvValue ...*)
    END; (* IF File = L_DBD.ffn_GetFile(fullField) ... *)
   END; (* WHILE i... *)
   IF ChgCnt = 0 THEN
    L_General.RaiseLockReleaseException();
   END;
   PutPrimaryKey(Handle, File, knd_AutoEdit);
   CloseHandle(Handle);
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
 END {SingleMark_Done};

 PUBLIC PROCEDURE SingleMark_AfterEdit(File: STRING[]);
 BEGIN
  SingleMark_PutRecord(File, knd_Edit, 0);
 END {SingleMark_AfterEdit};

 PUBLIC PROCEDURE SingleMark_AfterInsert(File: STRING[]);
 BEGIN
  SingleMark_PutRecord(File, knd_Insert, 0);
 END {SingleMark_AfterInsert};

 PUBLIC PROCEDURE SingleMark_AutoBuild(File: STRING[]);
 BEGIN
  SingleMark_PutRecord(File, knd_AutoBuild, 0);
 END {SingleMark_AutoBuild};

 PUBLIC PROCEDURE SingleMark_BeforeDelete(File: STRING[]);
 BEGIN
  SingleMark_PutRecord(File, knd_Delete, 0);
 END {SingleMark_BeforeDelete};

 PUBLIC PROCEDURE SingleMark_Interactive(File: STRING[]; Kind: tKind; IsTmpRc: SCAL[2]);
 BEGIN
  SingleMark_PutRecord(File, Kind, IsTmpRc);
 END {SingleMark_Interactive};

 PUBLIC PROCEDURE SingleMark_RunProg(File, Prog, Descr: STRING[]);
  VAR
   Handle: tHandle;
 BEGIN
  Handle:=intOpenHandle(Prog, L_General.EMPTY_NUMBER(), 0);
  PutPrimaryKey(Handle, File, knd_CurRecord);
  PutItem(Handle, knd_RunProg, L_General.EMPTY_NUMBER(),
          L_General.EMPTY_NUMBER(), 0, Descr);
  CloseHandle(Handle);
 END {SingleMark_RunProg};

 PUBLIC PROCEDURE GetObjectDescription(_Object: STRING[]): STRING[];
  VAR
   Description: STRING[];
 BEGIN
  IF ~!DATABASE.Get().Tables(_Object) THEN
   Description:=TABLE.Get(_Object).Description;
   IF ~!Description THEN
    RETURN Description;
   ELSE
    RETURN "  ࠡ稪.  " + _Object;
   END;
  ELSE
   RETURN _Object;
  END;
 END {GetObjectDescription};

 PUBLIC PROCEDURE GetFullDescr(_SYSLOG_: LIKE(SYSLOG_.SYSLOG_);
                               _SYSLOGD: LIKE(SYSLOGD.SYSLOGD)): STRING[];
  VAR
  _Descr: STRING[];
 BEGIN
  SAVE(SYSLOGD);
  SAVE(SYSLOGA);
  L_General.CallUs(SEARCH(SYSLOGD, SYSLOG_, _SYSLOG_, _SYSLOGD));
  _Descr:=SYSLOGD.Descr;
  IF SELECT(SYSLOGA, SYSLOG_, _SYSLOG_, SYSLOGD.SYSLOGD) THEN
   WHILE OCCURE(SYSLOGA) DO
    _Descr:=_Descr + SYSLOGA.Descr;
    NEXT(SYSLOGA);
   END; (* WHILE OCCURE(SYSLOGA)...*)
  END; (* IF *)
  RESTORE(SYSLOGD);
  RESTORE(SYSLOGA);
  RETURN _Descr;
 END {GetFullDescr};

 PUBLIC PROCEDURE GetFieldValue_BeforeModification(_SYSLOG_: LIKE(SYSLOG_.SYSLOG_);
                                                   _SYSLOGD: LIKE(SYSLOGD.SYSLOGD)): STRING[];
 BEGIN
  RETURN L_Str.AnyItem(GetFullDescr(_SYSLOG_, _SYSLOGD), fvDelimiter, 0);
 END {GetFieldValue_BeforeModification};

 PUBLIC PROCEDURE GetFieldValue_AfterModification(_SYSLOG_: LIKE(SYSLOG_.SYSLOG_);
                                                  _SYSLOGD: LIKE(SYSLOGD.SYSLOGD)): STRING[];
 BEGIN
  RETURN L_Str.AnyItem(GetFullDescr(_SYSLOG_, _SYSLOGD), fvDelimiter, 1);
 END {GetFieldValue_AfterModification};

 PUBLIC PROCEDURE ConvModeToSysLogKind(Mode: NUMERIC[0]): tKind;
 BEGIN
  IF    Mode = 001 THEN RETURN knd_Edit;
  ELSIF Mode = 003 THEN RETURN knd_Insert;
  ELSIF Mode = 004 THEN RETURN knd_Delete;
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {ConvModeToSysLogKind};

 PRIVATE CONST
  fileIdent = "lfn";

 PRIVATE PROCEDURE ELN_Close();
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
   FIO.Close(^fileIdent);
  EXCEPT
  ELSE
  END; (* TRY *)
 END {ELN_Close};

 PRIVATE PROCEDURE intELN_Open(FirstPass: SCAL[2]);
  VAR
   LogFileName,
   FullLogFileName: STRING[];
 BEGIN
  LogFileName:=L_General.GetAPSiteID();
  IF ~FirstPass THEN
   LogFileName:=LogFileName+"_"+FLDTOSTR(SYSTIMESTAMP(), "yNDHMS")+"_"+APP.Get().MyConnection.Number;
  END;
  FullLogFileName:=FIO.FullPath(FIO.BuildPath(LogFileName, "ELN", "TJR"));
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
   IF ~FIO.Exists(FullLogFileName) THEN
    FIO.Open(^fileIdent, FullLogFileName, , Create);
   ELSE
    FIO.Open(^fileIdent, FullLogFileName, , Append);
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   IF FirstPass THEN
    ELN_Close();
    intELN_Open(0);
   ELSE
    L_General.CallUs(0);
   END;
  END; (* TRY *)
 END {intELN_Open};

 PRIVATE PROCEDURE ELN_Open();
 BEGIN
  intELN_Open(1);
 END {ELN_Open};

 PUBLIC PROCEDURE ELN_Put(Ident, Msg: STRING[]);
  VAR
   S: STRING[];
 BEGIN
  ELN_Open();
  FIO.Seek(^fileIdent, Math.Max(0, FIO.Size(^fileIdent)-2));
  IF FIO.RdByte(^fileIdent, S, 2) THEN
   IF S # L_Str.CRLF THEN
    FIO.WrLn(^fileIdent);
   END;
  END;

  Msg:=Str.Replace(Msg, L_Str.CRLF, " ");
  Msg:=Str.Replace(Msg, "|", " ");

  FIO.WrStr(^fileIdent, FLDTOSTR(SYSTIMESTAMP(), "D.N.Y H:M:S"));
  FIO.WrStr(^fileIdent, ";");
  FIO.WrStr(^fileIdent, LOGINNAME());
  FIO.WrStr(^fileIdent, ";");
  FIO.WrStr(^fileIdent, Ident);
  FIO.WrStr(^fileIdent, ";");
  FIO.WrStr(^fileIdent, Str.Condense(Msg));
  FIO.WrLn(^fileIdent);

  ELN_Close();
 END {ELN_Put};

END.
