(*
%Copyright   (c) Polak Computer System
%Author      05.01.2001 17:11:50 SAN
%Purpose      室 
%Type        library
%Specific    SYS
%Modified    08.09.2014 11:48:10 POLAK\Bor
%Environment
*)

 MODULE L_Tax [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_AFM, L_EC, L_Man, L_Staff, L_PRoll, L_Tx2000, L_Russia,
        L_Math, L_Str, Str, Math, DBD, E_PRoll, L_Env, Memo, P_Man, L_StdFrm, L_kn;

 PUBLIC TYPE
  tTax2001_ScalesType = SCAL[10];
  tTax2001_MdfType    = SCAL[32];
  tVCode              = STRING[4];
  tOwnCode            = SCAL[32];

 CONST
  Tax2001_FirstPeriod = 01\01\2001;

  Tax2001_ScaleSize = 2; (* always +1 *)
  Tax2001_CodeLength = 6;
  Tax2001_CodesNum = 256;

 PUBLIC VAR
  ReCalcInClosedYear,
  InConverterInClosedYear: SCAL[2];

 PUBLIC CONST

  Tax2001_MainScale = 0;
  Tax2001_ScndScale = 1;
  Tax2001_ThrdScale = 2;
  Tax2001_FrthScale = 3;
  Tax2001_EvryScale = 9;

  Tax2001__oc_IsMNS = 00;
  Tax2001__oc_NoTxd = 01;
  Tax2001__oc_NoInc = 02;
  Tax2001__oc_NYInc = 03;
  Tax2001__oc_PYTax = 04;
  Tax2001__oc_RtOvr = 05;
  Tax2001__oc_OYRec = 06;
  Tax2001__oc_CYTax = 07;
  Tax2001__oc_EFTax = 08;
  Tax2001__oc_OvrLm = 09;
  Tax2001__oc_XXXXX = 31;
  Tax2001__oc_Pool = "  |"+
                     "室,   |"+
                     ",  騥 室|"+
                     "室 ᫥饣 |"+
                     "९ 諮 |"+
                     "  |"+
                     "   |"+
                     "믫祭  ⥪饣 |"+
                     "।  ᪠|"+
                     "㬬 㤥ঠ ᢥ ࠭祭|"+
                     " | | | | | | | | | | | | | | | | | | | | |"+
                     "⠭ 室 ⭮ ";

  Tax2001_mt_Inc = 00;
  Tax2001_mt_StD = 01;
  Tax2001_mt_Exp = 02;
  Tax2001_mt_EFT = 08;
  Tax2001_mt_Tax = 09;
  Tax2001_mt_Spc = 10;
  Tax2001_mt_NTx = 11;
  Tax2001_mt_NIn = 12;

  Tax2001_PureIncomVCode="2000";

  rap_None     = 1;
  rap_InYear   = 2;
  rap_InMonth  = 3;
  rap_InYearwCntAgreem = 4;

  inqt_Other  = 0; (*TaxInq.InqType*)
  inqt_Own    = 1;
  inqt_Corr   = 2;
  inqt_InAPFY = 5;
  inqt_Auto   = 6;
  inqt_Fict   = 7;
  inqt_Pool   = "C ।饣  ࠡ|"+
                "⢥ 䨪樨|"+
                "४஢|"+
                " | |"+
                "  ᪠ ⥬|"+
                "⮬᪨ ᫥|"+
                "⨢";

  VAR
   Tax_ManIsWorkingInYear : SCAL[2][12];

   Tax2001_ScaleToGather: tTax2001_ScalesType;

   Tax2001_FutTimes     : NUMERIC[3][12];
   Tax2001_NextYearInc  : NUMERIC[2];

   InitCodesPeriod      : DATE;

   Tax2001_Man_TotInc   : NUMERIC[2][12];

   Tax2001_ArrVol       : NUMERIC[0];
   Tax2001_CodArr       : STRING[Tax2001_CodeLength][Tax2001_CodesNum];
   Tax2001_NamArr       : STRING[]                  [Tax2001_CodesNum];
   Tax2001_TypArr       : tTax2001_MdfType          [Tax2001_CodesNum];
   Tax2001_SclArr       : tTax2001_ScalesType       [Tax2001_CodesNum];
   Tax2001_LmCArr       : tVCode                    [Tax2001_CodesNum];
   Tax2001_ValArr       : NUMERIC[2]                [Tax2001_CodesNum];
   Tax2001_LmVArr       : NUMERIC[2]                [Tax2001_CodesNum];

 PUBLIC PROCEDURE SetTax2001_ScaleToGather(_ScaleToGather: tTax2001_ScalesType);
 BEGIN
  Tax2001_ScaleToGather:=_ScaleToGather;
 END {SetTax2001_ScaleToGather};

 PRIVATE PROCEDURE MakeInternalCode(_OwnCode: tOwnCode;
                                    _VCode  : tVCode): STRING[Tax2001_CodeLength];
 BEGIN
  IF _OwnCode = Tax2001__oc_IsMNS THEN
   RETURN "00"+_VCode;
  ELSE
   RETURN _OwnCode+"0000";
  END;
 END {MakeInternalCode};

 PRIVATE PROCEDURE GetIdx(_OwnCode: tOwnCode; _VCode: tVCode): NUMERIC[0];
  VAR
   _Code   : STRING[Tax2001_CodeLength];
   l, r, i : NUMERIC[0];
 BEGIN
  _Code:=MakeInternalCode(_OwnCode, _VCode);
  l:=0; r:=Tax2001_ArrVol;
  WHILE l < r DO
   i:=(l + r) DIV 2;
   IF Tax2001_CodArr[i] < _Code THEN
    l:=i + 1;
   ELSE
    r:=i;
   END;
  END;
  IF (l >= Tax2001_ArrVol) | (Tax2001_CodArr[l] # _Code) THEN
   IF _OwnCode = Tax2001__oc_IsMNS THEN
    L_General.Error("   " + _VCode);
   ELSE
    L_General.Error("  䨪樨  " + _OwnCode);
   END;
  END;
  RETURN l;
 END {GetIdx};

 PUBLIC PROCEDURE Tax2001_taGetIdx(): NUMERIC[0];
 BEGIN
  RETURN GetIdx(TaxAdv.OwnCode, TaxAdv.VCode);
 END {Tax2001_taGetIdx};

 PUBLIC PROCEDURE Tax2001_taGetLCode(): LIKE(TaxAdv.VCode);
 BEGIN
  RETURN Tax2001_LmCArr[GetIdx(TaxAdv.OwnCode, TaxAdv.VCode)];
 END {Tax2001_taGetLCode};

 PUBLIC PROCEDURE Get_mc_NDFL(P: DATE; Strong: SCAL[2]): LIKE(MCList.MCode);
 BEGIN
  IF Strong THEN
   RETURN L_kn.Get(P, L_PRoll.erkn_MCList_NDLF);
  ELSE
   RETURN L_kn.GetSoft(P, L_PRoll.erkn_MCList_NDLF);
  END;
 END {Get_mc_NDFL};

 PUBLIC PROCEDURE Tax_Get_mc_Tax(P: DATE; Idx: NUMERIC[0]): LIKE(MCList.MCode);
 BEGIN
  IF    Idx = 0 THEN
   RETURN Get_mc_NDFL(P, 1);
  ELSIF Idx = 1 THEN
   RETURN 099;
  ELSE
   L_General.CallUs(0);
  END;
 END {Tax_Get_mc_Tax};

 PUBLIC PROCEDURE Tax_TaxAdv_NeedBeInClcPer(): SCAL[2];
 BEGIN
  RETURN (TaxAdv.OwnCode = Tax2001__oc_RtOvr) | (TaxAdv.OwnCode = Tax2001__oc_OvrLm);
 END {Tax_TaxAdv_NeedBeInClcPer};

 PUBLIC PROCEDURE Tax_TaxAdv_Type(): LIKE(ManTA.Value);
 BEGIN
  IF TaxAdv.Till <= Tax2001_FirstPeriod THEN
   RETURN TaxAdv.Reason;
  ELSE
   RETURN Tax2001_TypArr[Tax2001_taGetIdx()];
  END;
 END {Tax_TaxAdv_Type};

 PRIVATE PROCEDURE Tax_TaxAdv_Scale(): tTax2001_ScalesType;
 BEGIN
  IF TaxAdv.Till <= Tax2001_FirstPeriod THEN
   RETURN 0;
  ELSE
   RETURN Tax2001_SclArr[Tax2001_taGetIdx()];
  END;
 END {Tax_TaxAdv_Scale};

 PUBLIC PROCEDURE Tax_TaxAdv_MayBeOpn(): SCAL[2];
 BEGIN
  IF TaxAdv.Till <= Tax2001_FirstPeriod THEN
   RETURN TaxAdv.MayBeOpn;
  ELSE
   RETURN Tax2001_TypArr[Tax2001_taGetIdx()] = Tax2001_mt_StD;
  END;
 END {Tax_TaxAdv_MayBeOpn};

 PUBLIC PROCEDURE Tax_TaxAdv_DefValue(): LIKE(ManTA.Value);
 BEGIN
  IF TaxAdv.Till <= Tax2001_FirstPeriod THEN
   RETURN TaxAdv.DefValue;
  ELSE
   IF TaxAdv.OwnCode = Tax2001__oc_RtOvr THEN
    RETURN 1;
   ELSE
    RETURN Tax2001_ValArr[Tax2001_taGetIdx()];
   END;
  END;
 END {Tax_TaxAdv_DefValue};

 PRIVATE PROCEDURE Tax_TaxAdv_TakenOft(): SCAL[3];
 BEGIN
  IF TaxAdv.Till <= Tax2001_FirstPeriod THEN
   RETURN TaxAdv.TakenOft;
  ELSE
   IF Tax_TaxAdv_Type() = Tax2001_mt_StD THEN
    RETURN 2;
   ELSE
    RETURN 0;
   END;
  END;
 END {Tax_TaxAdv_TakenOft};

 PRIVATE PROCEDURE Tax_TaxAdv_LimOft(): SCAL[2];
 BEGIN
  IF TaxAdv.Till <= Tax2001_FirstPeriod THEN
   RETURN TaxAdv.LimOft;
  ELSE
   RETURN 0;
  END;
 END {Tax_TaxAdv_LimOft};

 PUBLIC PROCEDURE Tax_InterpretValueAsSum(_InqType: LIKE(TaxInq.InqType)): SCAL[2];
 BEGIN
  RETURN (_InqType=inqt_Other ) |
         (_InqType=inqt_Fict  ) |
         (_InqType=inqt_InAPFY) |
         (_InqType=inqt_Corr);
 END {Tax_InterpretValueAsSum};

 PUBLIC PROCEDURE Tax_CheckYear(P: DATE);
 BEGIN
  L_General.Assert(L_DatTim.YEAR(P) = L_DatTim.YEAR(Memo.gl_mb()),
                   " 믮  । ⥪饣 ");
 END {Tax_CheckYear};

 PUBLIC PROCEDURE Tax_FillManIsWorking(P: DATE);
  VAR
   p: DATE;
 BEGIN
  SAVE(Staff);
  SAVE(StaffLog);
  SETZERO(Tax_ManIsWorkingInYear);
  SETSEL(Staff, MyFirm, Staff.MyFirm, Staff.Man);
  FOR_EACH Staff DO
   p:=L_DatTim.YearBeg(P);
   WHILE p <= P DO
    IF L_Staff.InStateInPer(p, L_DatTim.MonthEnd(p)) THEN
     Tax_ManIsWorkingInYear[L_DatTim.MONTH(p)]:=1;
    END;
    p:=L_DatTim.NextPer(p);
   END;
  END; (* FOR_EACH Staff *)
  RESTORE(Staff);
  RESTORE(StaffLog);
 END {Tax_FillManIsWorking};

 PRIVATE PROCEDURE TooOldPeriod();
 BEGIN
  L_General.Assert(0, "L_Tax: ⨬ ਬ  " + L_DatTim.PeriodStr(Tax2001_FirstPeriod));
 END {TooOldPeriod};

 PUBLIC PROCEDURE Tax_AccessManTA_by_MnTA();
  VAR
   _Number : NUMERIC[0];
 BEGIN
  SELECT(ManTA, TaxInq, , _MnTA._TaxInq, _MnTA._TaxAdv, _MnTA._StartD);
  _Number:=_MnTA.Number;
  WHILE OCCURE(ManTA) & (_Number > 1) DO
   DEC(_Number);
   NEXT(ManTA);
  END;
  L_General.CallUs(OCCURE(ManTA));
 END {Tax_AccessManTA_by_MnTA};

 PUBLIC PROCEDURE Tax2001__InitValues(P: DATE; fictOnly: SCAL[2]);
  VAR
   _TaxAdv: LIKE(ManTA.TaxAdv);
   _StartD: LIKE(ManTA.StartD);
   _Number: NUMERIC[0];
 BEGIN
  Tax_CheckYear(P);

  Tax2001_InitCodes(P);
  SETEMPTY(Tax2001_ScaleToGather);



  IF !DATABASE.Get().Tables("_MnTA") THEN
   L_AFM.MakeIndex("_MnTA", "_Man    : LIKE(Man.Man)       ;"+
                            "_MdfType: SCAL[32]            ;"+
                            "_TaxAdv : LIKE(TaxAdv.TaxAdv) ;"+
                            "_Source : SCAL[2]             ;"+
                            "_TaxInq : LIKE(ManTA.TaxInq)  ;"+
                            "_StartD : DATE                ;"+
                            "Number  : NUMERIC[0]           ");
  END;

  L_General.CallUs(~SELECT(_MnTA, _MnTA, Man.Man));

  SETZERO(Tax2001_FutTimes, Tax2001_NextYearInc);

  SETEMPTY(Tax2001_Man_TotInc);
  SETSEL(TaxInq, MyFirm, Staff.MyFirm, Staff.Man);
  FOR_EACH TaxInq DO
   IF fictOnly = (TaxInq.InqType = inqt_Fict) THEN
    SETEMPTY(_TaxAdv, _StartD);
    SETSEL(ManTA, TaxInq, TaxInq.TaxInq);
    FOR_EACH ManTA DO
     IF (ManTA.TaxAdv # _TaxAdv) | (ManTA.StartD # _StartD) THEN
      _TaxAdv:=ManTA.TaxAdv;
      _StartD:=ManTA.StartD;
      _Number:=1;
     ELSE
      INC(_Number);
     END;
     IF (ManTA.StartD <= L_DatTim.MonthEnd(P)) &
        (ManTA.StopD  >= L_DatTim.YearBeg(P)) THEN
      CONFORM(ManTA, TaxAdv);
      L_General.Assert(L_DatTim.InPatIntvl(TaxAdv.Begin, TaxAdv.Till, ManTA.StartD, ManTA.StopD),
                       "䨪  " + TaxAdv.TaxAdv + "    ਮ| " +
                       L_DatTim.DateStr(ManTA.StartD)+"  "+L_DatTim.DateStr(ManTA.StopD));
      _MnTA._Man    :=Staff.Man;
      _MnTA._MdfType:=Tax_TaxAdv_Type();
      _MnTA._TaxAdv :=ManTA.TaxAdv;
      _MnTA._Source :=TaxInq.InqType = inqt_Other;
      _MnTA._TaxInq :=ManTA.TaxInq;
      _MnTA._StartD :=ManTA.StartD;
      _MnTA.Number  :=_Number;
      INSERT(_MnTA);
     END;
    END; (* FOR_EACH ManTA *)
   END;
  END; (* FOR_EACH TaxInq *)
  Tax_FillManIsWorking(P);

  IF ~Tax_IsResident(P) THEN
   IF StandOnSpecifiedTaxAdv(P, Tax2001__oc_IsMNS, "2610") > 0 THEN
    Tax_StandOnSingleSpecifiedTaxAdv(P, Tax2001__oc_IsMNS, "2610");
    L_General.Assert(~Tax_StandOnManTAByTaxAdv(P, P, TaxAdv.TaxAdv), " ਠ쭮 룮  짮 묨 ।⢠| ।  १⮢| ଫ   ࠢ   室");
   END;
  END;
 END {Tax2001__InitValues};

 PUBLIC PROCEDURE Tax_InitValues(P: DATE);
 BEGIN
  IF P >= Tax2001_FirstPeriod THEN
   Tax2001__InitValues(P, 0);
  ELSE
   L_Tx2000.NTax_InitValues(P);
  END;
 END {Tax_InitValues};

 PUBLIC PROCEDURE Tax_FreeValues(P: DATE);
 BEGIN
  IF P >= Tax2001_FirstPeriod THEN
   IF DBD.FileExist(_MnTA) THEN
    L_AFM.AF_PurgeTemp("_MnTA");
   END;
  ELSE
   L_Tx2000.NTax_FreeValues();
  END;
 END {Tax_FreeValues};

 PRIVATE PROCEDURE AddManTA(P: DATE; _TaxAdv: LIKE(TaxAdv.TaxAdv); s: LIKE(ManTA.Value));
 BEGIN
  IF s # 0 THEN
   IF ~InConverterInClosedYear & ~ReCalcInClosedYear THEN
    L_General.CallUs(L_PRoll.Salary_Clc_CntIsEqual());
   END;
   L_General.Assert(SEARCH(TaxAdv, TaxAdv, _TaxAdv), "L_Tax.AddManTA - 䨪 |  ࠢ筨.  "+FLDTOSTR(_TaxAdv));
   IF ~SELECT(TaxInq, MyFirm, Staff.MyFirm, Staff.Man, inqt_Auto, Memo.gl_mb()) THEN
    DEFAULT(TaxInq);
    TaxInq.InqType:=inqt_Auto;
    TaxInq.Man    :=Staff.Man;
    TaxInq.MyFirm :=Staff.MyFirm;
    TaxInq.SrcNum :=" ⥬";
    TaxInq.Date   :=Memo.gl_mb();
    INSERT(TaxInq);
   END;
   IF SELECT(ManTA, TaxInq, TaxInq.TaxInq, _TaxAdv, P) THEN
    ManTA.StopD:=L_DatTim.MonthEnd(P);
    INC(ManTA.Value, s);
    REPLACE(ManTA);
   ELSE
    ManTA.TaxInq:=TaxInq.TaxInq;
    ManTA.TaxAdv:=_TaxAdv;
    ManTA.StartD:=P;
    ManTA.StopD :=L_DatTim.MonthEnd(P);
    ManTA.Value :=s;
    INSERT(ManTA);
   END;
  END; (* IF s # 0 ... *)
 END {AddManTA};

 PUBLIC PROCEDURE Tax_FormTaxAdvByMoney(_Sum: LIKE(Money.Sum));
 BEGIN
  CONFORM(MCList, TaxAdv);
  IF Memo.gl_mb() >= Tax2001_FirstPeriod THEN
   IF _Sum # 0 THEN
    IF (Money.Period >= Memo.gl_mb()) &
       (L_DatTim.YEAR(Money.Period)=L_DatTim.YEAR(Memo.gl_mb())) &
       (MCList.TimeType > 0) &
       ((TaxAdv.OwnCode = Tax2001__oc_XXXXX) |
        (Tax_TaxAdv_Type() = Tax2001_mt_Inc)) THEN
     INC(Tax2001_FutTimes[L_DatTim.MONTH(Money.Period)-L_DatTim.MONTH(Memo.gl_mb())], Money.Tim);
    END;
    IF Money.MCode # Get_mc_NDFL(Money.Closed, 1) THEN
     IF Money.Source # L_PRoll.src_FtSys THEN
      IF TaxAdv.OwnCode = Tax2001__oc_XXXXX THEN
       L_General.Assert(MCList.MCTyp = L_PRoll.mct_Credit, "   㤥ঠ 室.  " + MCList.MCode);
       INC(PCalc.PurToTax, _Sum);                   (* storno ? *)
       IF L_DatTim.YEAR(Money.Period) > L_DatTim.YEAR(Memo.gl_mb()) THEN
        INC(Tax2001_NextYearInc, _Sum);             (* storno ? *)
       END;
      ELSIF Tax_TaxAdv_Type() # Tax2001_mt_NIn THEN
       IF (MCList.MCTyp=L_PRoll.mct_Debit) & (Tax_TaxAdv_Type() = Tax2001_mt_Inc) THEN
        AddManTA(Memo.gl_mb(), TaxAdv.TaxAdv, -_Sum);
       ELSE
        L_General.Assert((Tax_TaxAdv_Type()=Tax2001_mt_Inc) | (Tax_TaxAdv_Type()=Tax2001_mt_NTx), "ࠢ쭠   .  " + MCList.MCode);
        AddManTA(Memo.gl_mb(), TaxAdv.TaxAdv,  _Sum);
       END;
      END;
     END;
    END; (* IF Money.MCode # ... *)
   END; (* IF _Sum # 0 ... *)
  ELSE
   L_Tx2000.FormTaxAdvByMoney(Tax2001_NextYearInc);
  END;
 END {Tax_FormTaxAdvByMoney};

 PUBLIC PROCEDURE Tax_ClearFormedTaxAdv();
 BEGIN
  L_General.CallUs(L_PRoll.Salary_Clc_CntIsEqual());
  SETSEL(TaxInq, MyFirm, Staff.MyFirm, Staff.Man, inqt_Auto);
  SRCINSEL(TaxInq, GE, , Memo.gl_mb());
  WHILE OCCURE(TaxInq) DO
   CONFORM(TaxInq, ManTA);
   WHILE OCCURE(ManTA) DO
    REMOVE(ManTA);
   END; (* WHILE OCCURE(ManTA) ... *)
   REMOVE(TaxInq);
  END; (* WHILE OCCURE(TaxInq) ... *)
 END {Tax_ClearFormedTaxAdv};

 PRIVATE PROCEDURE TaxAdv_NeedEstimate(): SCAL[2];
 BEGIN
  RETURN (Tax_TaxAdv_Type() = Tax2001_mt_StD) &
         ((TaxAdv.VCode = "0101") | (TaxAdv.VCode = "0102") | (TaxAdv.VCode = "0103") |
          (TaxAdv.VCode = "0106") | (TaxAdv.VCode = "0107") |
          (TaxAdv.VCode = "0108") | (TaxAdv.VCode = "0110") | (TaxAdv.VCode = "0109") | (TaxAdv.VCode = "0112") |
          (TaxAdv.VCode = "0111") | (TaxAdv.VCode = "0113") |
          (TaxAdv.VCode = "0114") | (TaxAdv.VCode = "0115") | (TaxAdv.VCode = "0116") |
          (TaxAdv.VCode = "0117") |
          (TaxAdv.VCode = "0118") | (TaxAdv.VCode = "0119") | (TaxAdv.VCode = "0120") |
          (TaxAdv.VCode = "0121") |
          (TaxAdv.VCode = "0122") | (TaxAdv.VCode = "0123") | (TaxAdv.VCode = "0124") |
          (TaxAdv.VCode ="0125")
         );
 END {TaxAdv_NeedEstimate};

 PRIVATE PROCEDURE Estimate(P: DATE; VAR _Value: LIKE(ManTA.Value));
  VAR
   Idx: SCAL[12];
   EstValue: NUMERIC[2];
 BEGIN
  Idx:=L_DatTim.MONTH(P);
  L_General.CallUs(~!Tax2001_Man_TotInc[Idx]);
  IF (P >= 01\01\2005) & (TaxAdv.VCode # "0103"(* -*)) THEN
   IF P >= 01\01\2009 THEN
    EstValue:=280000;
   ELSE
    EstValue:=40000;
   END;
  ELSE
   IF P >= 01\01\2009 THEN
    EstValue:=40000;
   ELSE
    EstValue:=20000;
   END;
  END;
  IF P >= Tax2001_FirstPeriod THEN
   IF (Tax2001_Man_TotInc[Idx] > EstValue) &
(* 죮 (+1, -1)  饬   모 (-1), ᫨ ⠬ 室
ॢᨫ EstValue*)
      ~((TaxInq.InqType=inqt_Auto) & (ManTA.StartD > TaxInq.Date) &
        (Tax2001_Man_TotInc[Idx-1] <= EstValue)) THEN
    _Value:=0;
   END;
  ELSE
   TooOldPeriod();
  END;
 END {Estimate};

 PUBLIC PROCEDURE GetPrcByScale(P: DATE; _Scale: tTax2001_ScalesType): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  IF P >= Tax2001_FirstPeriod THEN
   IF    _Scale = Tax2001_MainScale THEN Result:=13;
   ELSIF _Scale = Tax2001_ScndScale THEN Result:=30;
   ELSIF _Scale = Tax2001_ThrdScale THEN Result:=35;
   ELSIF _Scale = Tax2001_FrthScale THEN
    IF Tax_IsResident(P) THEN
     Result:=09;
    ELSE
     Result:=15;
    END;
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   TooOldPeriod();
  END;
  RETURN Result;
 END {GetPrcByScale};

 PRIVATE PROCEDURE GetScale(P: DATE; _Scale: tTax2001_ScalesType;
                            VAR _Sum, _Prc, _Bas: NUMERIC[2][Tax2001_ScaleSize]);
 BEGIN
  SETEMPTY(_Sum, _Prc, _Bas);
  _Sum[0]:=0;
  _Prc[0]:=GetPrcByScale(P, _Scale);
  _Bas[0]:=0;
 END {GetScale};

 PUBLIC PROCEDURE GetTAValue(P: DATE; WithEstimate: SCAL[2]): LIKE(ManTA.Value);
  VAR _Value: LIKE(ManTA.Value);
 BEGIN
  IF ~!ManTA.Value THEN
   L_General.Assert(!Tax_TaxAdv_DefValue() |
                    ((TaxInq.InqType=inqt_Auto)|
                     Tax_InterpretValueAsSum(TaxInq.InqType)),
                    "᪮  "+TaxInq.Man+
                    " 䨪  "+ManTA.TaxAdv+"|    㪠 稭 䨪樨");
   _Value:=ManTA.Value;
  ELSE
   _Value:=Tax_TaxAdv_DefValue();
   L_General.Assert(~!_Value, "᪮  "+TaxInq.Man+" 䨪  "+ManTA.TaxAdv+"|   㪠 稭 䨪樨");
  END;
  IF WithEstimate & TaxAdv_NeedEstimate() THEN
   Estimate(P, _Value);
  END;
  RETURN _Value;
 END {GetTAValue};

 PRIVATE PROCEDURE SingleTime(P: DATE): NUMERIC[2];
  VAR Sum: NUMERIC[2];
 BEGIN
  IF (Tax2001_TypArr[Tax2001_taGetIdx()] # Tax2001_mt_Inc) |
     (Tax2001_SclArr[Tax2001_taGetIdx()] = Tax2001_ScaleToGather) THEN
   IF ~Tax_InterpretValueAsSum(TaxInq.InqType) THEN
    Sum:=GetTAValue(P, 1);
    IF (Tax_TaxAdv_TakenOft() > 0(**)) & ~Tax_ManIsWorkingInYear[L_DatTim.MONTH(P)] THEN
     RETURN 0;
    ELSE
     RETURN Sum;
    END;
   ELSE
    RETURN GetTAValue(P, 0);
   END;
  ELSE
   L_General.CallUs(~!Tax2001_ScaleToGather);
   RETURN 0;
  END;
 END {SingleTime};

 PRIVATE PROCEDURE taGetLimit(): NUMERIC[2];
 BEGIN
  RETURN Tax2001_LmVArr[Tax2001_taGetIdx()];
 END {taGetLimit};

 PRIVATE PROCEDURE Limit(Sum: NUMERIC[2]): NUMERIC[2];
  VAR
   LimSum : NUMERIC[2];
 BEGIN
  LimSum:=taGetLimit();
  IF ~!LimSum & (LimSum < Sum) THEN
   RETURN LimSum;
  ELSIF !LimSum & (Tax_TaxAdv_Type() = Tax2001_mt_Inc) THEN
   RETURN 0;
  ELSE
   RETURN Sum;
  END;
 END {Limit};

 PRIVATE PROCEDURE GetGate(P, F: DATE; VAR P1, P2: DATE);
  VAR
   MinD: DATE;
 BEGIN
  IF (Tax_TaxAdv_TakenOft() = 0(**)) | Tax_InterpretValueAsSum(TaxInq.InqType) THEN
   MinD:=L_DatTim.YearBeg(L_Env.aptm_Start);
   IF ManTA.StartD < L_DatTim.YearBeg(Memo.gl_mb()) THEN
    P1:=L_DatTim.YearBeg(Memo.gl_mb());
   ELSE
    P1:=L_DatTim.Per(ManTA.StartD);
   END;
   IF P >= P1 THEN
    P2:=P1;
   ELSE
    P2:=P1-1;
   END;
  ELSE
   MinD:=L_Env.aptm_Start;
   IF Tax_TaxAdv_TakenOft() = 2(*/  ⮬ 믫 *) THEN
    P:=F;
   END;
   IF ManTA.StartD < L_DatTim.YearBeg(Memo.gl_mb()) THEN
    P1:=L_DatTim.YearBeg(Memo.gl_mb());
   ELSE
    P1:=L_DatTim.Per(ManTA.StartD);
   END;
   IF !ManTA.StopD | (L_DatTim.Per(ManTA.StopD) > P) THEN
    P2:=P;
   ELSE
    P2:=L_DatTim.Per(ManTA.StopD);
   END;
  END; (* IF Tax_TaxAdv_TakenOft = 0 ... *)
  P1:=Math.Max(P1, MinD);
 END {GetGate};

 PRIVATE PROCEDURE Tax_IncArrayCell(VAR Array: NUMERIC[2][]; Value: NUMERIC[2]; i: NUMERIC[0]);
 BEGIN
  INC(Array[Math.Min(i, HIGH(Array))], Value);
 END {Tax_IncArrayCell};

 PRIVATE PROCEDURE Tax_PutInArray(VAR Array: NUMERIC[2][]; P: DATE; S: NUMERIC[2]);
 BEGIN
  IF HIGH(Array) = 0 THEN
   INC(Array[0], S);
  ELSE
   INC(Array[L_DatTim.MONTH(P)], S);
  END;
 END {Tax_PutInArray};

 PUBLIC PROCEDURE Tax2001__GetOneTaxAdv(P, F: DATE;
                                        _MdfType: tTax2001_MdfType;
                                        _TaxAdv: LIKE(TaxAdv.TaxAdv);
                                        VAR S: NUMERIC[2][];
                                        VAR L: NUMERIC[2];
                                        _Source: SCAL[3]): SCAL[2];
  VAR
   Sum,
   Itog   : NUMERIC[2];
   P1, P2 : DATE;
 BEGIN
  L_General.CallUs(_Source<2);
  IF SELECT(_MnTA, _MnTA, Man.Man, _MdfType, _TaxAdv, _Source) THEN
   SEARCH(TaxAdv, TaxAdv, , _MnTA._TaxAdv);
   SETZERO(Itog, L);
   REPEAT
    Tax_AccessManTA_by_MnTA();
    SEARCH(TaxInq, TaxInq, , ManTA.TaxInq);
    GetGate(P, F, P1, P2);
    WHILE P1 <= P2 DO
     Sum:=SingleTime(P1);
     Tax_PutInArray(S, P1, Sum);
     IF Tax_TaxAdv_LimOft() = 0(**) THEN
      INC(Itog, Sum);
     ELSE
      INC(L, Limit(Sum));
     END;
     P1:=L_DatTim.IncMonth(P1, +1);
    END; (* WHILE P1 <= P2 ... *)
   UNTIL ~NEXT(_MnTA);
   IF Tax_TaxAdv_LimOft() = 0(**) THEN
    L:=Limit(Itog);
   END;
   RETURN 1;
  ELSE
   RETURN 0;
  END; (* IF SELECT(ManTA ... *)
 END {Tax2001__GetOneTaxAdv};

 PUBLIC PROCEDURE GetOneTaxAdv(P, F: DATE;
                               _MdfType: tTax2001_MdfType;
                               _TaxAdv: LIKE(TaxAdv.TaxAdv);
                               VAR S: NUMERIC[2][];
                               VAR L: NUMERIC[2]): SCAL[2];
 BEGIN
  RETURN Tax2001__GetOneTaxAdv(P, F, _MdfType, _TaxAdv, S, L, 0);
 END {GetOneTaxAdv};

 PRIVATE PROCEDURE Tax_GetStartToTax(): DATE;
 BEGIN
  RETURN Math.Max(L_Env.aptm_Start, L_DatTim.YearBeg(Memo.gl_mb()));
 END {Tax_GetStartToTax};

 PUBLIC PROCEDURE Tax2001_GetPureIncome(P: DATE; VAR Inc: NUMERIC[2][]);
 BEGIN
  Tax_CheckYear(P);
  SAVE(Staff);
  SAVE(PCalc);
  SELECT(Staff, MyFirm, , Staff.MyFirm, Staff.Man);
  WHILE OCCURE(Staff) DO
   SETSEL(PCalc, TSN, Staff.TSN);
   SRCINSEL(PCalc, GE, , Tax_GetStartToTax());
   WHILE OCCURE(PCalc) & (PCalc.Period <=  P) DO
    Tax_PutInArray(Inc, PCalc.Period, PCalc.PurToTax);
    NEXT(PCalc);
   END; (* WHILE OCCURE(PCalc) ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RESTORE(PCalc);
  RESTORE(Staff);
 END {Tax2001_GetPureIncome};

 PRIVATE PROCEDURE _GetTax(From, UpTo: DATE; VAR _TaxArr: NUMERIC[2][]);
  VAR
   P: DATE;
 BEGIN
  Tax_CheckYear(UpTo);
  SAVE(Staff);
  SETSEL(Staff, MyFirm, Staff.MyFirm, Staff.Man);
  FOR_EACH Staff DO
   L_General.CallUs(From = L_DatTim.Per(From));
   P:=From;
   WHILE P <= UpTo DO
    SETSEL(Money, MCode, Get_mc_NDFL(P, 1), P, Staff.TSN);
    FOR_EACH Money DO
     Tax_PutInArray(_TaxArr, Money.Closed, Money.Sum);
    END; (* FOR_EACH Money *)
    P:=L_DatTim.NextPer(P);
   END; (* WHILE P <= UpTo *)
  END; (* FOR_EACH Staff *)
  RESTORE(Staff);
 END {_GetTax};

 PUBLIC PROCEDURE Tax2001_GetTax(P: DATE; VAR _TaxArr: NUMERIC[2][]);
 BEGIN
  _GetTax(Tax_GetStartToTax(), P, _TaxArr);
 END {Tax2001_GetTax};

 PUBLIC PROCEDURE Tax2001_GetArrSum(S: NUMERIC[2][]): NUMERIC[2];
  VAR
   curSum,
   Result: NUMERIC[2];
 BEGIN
  SETZERO(Result);
  FOR_EACH curSum IN S DO
   INC(Result, curSum);
  END;
  RETURN Result;
 END {Tax2001_GetArrSum};

 PRIVATE PROCEDURE _Wo_Lim(_MdfType: tTax2001_MdfType; Tmp: NUMERIC[2][]; Lim: NUMERIC[2]; VAR Result: NUMERIC[2][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  L_General.CallUs(HIGH(Result)<=HIGH(Tmp));
  i:=0;
  WHILE i <= HIGH(Tmp) DO
   Tax_IncArrayCell(Result, Tmp[i], i);
   INC(i);
  END;
 END {_Wo_Lim};

 PUBLIC PROCEDURE Tax2001__W_Lim(_MdfType: tTax2001_MdfType; Tmp: NUMERIC[2][]; Lim: NUMERIC[2]; VAR Result: NUMERIC[2][]);
  VAR
   i: NUMERIC[0];
   T: NUMERIC[2];
 BEGIN
  L_General.CallUs(HIGH(Result)<=HIGH(Tmp));
  IF (Lim = 0) & (_MdfType = Tax2001_mt_Inc) THEN
   _Wo_Lim(_MdfType, Tmp, Lim, Result);
  ELSIF (_MdfType = Tax2001_mt_Inc) THEN
   T:=0; i:=0;
   WHILE i <= HIGH(Tmp) DO
    INC(T, Tmp[i]);
    IF Lim <= T THEN
     Tax_IncArrayCell(Result, Math.Min(T-Lim, Tmp[i]), i);
    END;
    INC(i);
   END; (* WHILE i ... *)
  ELSIF Lim >= Tax2001_GetArrSum(Tmp) THEN
   _Wo_Lim(_MdfType, Tmp, Lim, Result);
  ELSE
   i:=0;
   WHILE i <= HIGH(Tmp) DO
    T:=Math.Min(Lim, Tmp[i]);
    Tax_IncArrayCell(Result, T, i);
    DEC(Lim,  T);
    INC(i);
   END; (* WHILE i ... *)
  END; (* IF Lim = 0 ... *)
 END {Tax2001__W_Lim};

 PUBLIC PROCEDURE Tax2001__GetOneType(Proc: PROC;
                                      P, F: DATE;
                                      _MdfType: tTax2001_MdfType;
                                      VAR S: NUMERIC[2][];
                                      _Source: SCAL[3]);
  VAR
   Tmp    : NUMERIC[2][12];
   Lim    : NUMERIC[2];
 BEGIN
  SELECT(_MnTA, _MnTA, , Man.Man, _MdfType);
  WHILE OCCURE(_MnTA) DO
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
   SAVE(_MnTA);
   SETZERO(Tmp, Lim);
   IF Tax2001__GetOneTaxAdv(P, F, _MdfType, _MnTA._TaxAdv, Tmp, Lim, _Source) THEN
    Proc(_MdfType, Tmp, Lim, S);
   END; (* IF Get ... *)
   RESTORE(_MnTA);
   LAST(_MnTA);
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType);
   NEXT(_MnTA);
  END; (* WHILE OCCURE(_MnTA) ... *)
 END {Tax2001__GetOneType};

 PUBLIC PROCEDURE Tax2001_GetOneType(P, F: DATE; _MdfType: tTax2001_MdfType; VAR S: NUMERIC[2][]);
 BEGIN
  Tax2001__GetOneType(PROCREF(Tax2001__W_Lim), P, F, _MdfType, S, 0);
 END {Tax2001_GetOneType};

 PUBLIC PROCEDURE Tax2001_GetOneOwnCode(P, F: DATE; _OwnCode: LIKE(TaxAdv.OwnCode); VAR S: NUMERIC[2][]);
  VAR
   _MdfType: tTax2001_MdfType;
   Tmp     : NUMERIC[2][12];
   Lim     : NUMERIC[2];
 BEGIN
  Tax_StandOnSingleSpecifiedTaxAdv(P, _OwnCode, "");
  _MdfType:=Tax_TaxAdv_Type();
  SETZERO(Tmp, Lim);
  IF Tax2001__GetOneTaxAdv(P, F, _MdfType, TaxAdv.TaxAdv, Tmp, Lim, 0) THEN
   Tax2001__W_Lim(_MdfType, Tmp, Lim, S);
  END; (* IF Get ... *)
 END {Tax2001_GetOneOwnCode};

 PRIVATE PROCEDURE SetManTotInc(Inc0, Inc1, Inc2: NUMERIC[2][]);
  VAR
   k: NUMERIC[0];
   T,
   I: NUMERIC[2];
 BEGIN
  T:=0; k:=0;
  WHILE k < 12 DO
   I:=Inc0[k] + Inc1[k] + Inc2[k];
   Tax2001_Man_TotInc[k]:=I + T;
   INC(T, I);
   INC(k);
  END;
 END {SetManTotInc};

 PRIVATE PROCEDURE ConvertTaxType(Tax: FLOAT): NUMERIC[2];
 BEGIN
  RETURN L_Math.ROUND(Tax, 1);
 END {ConvertTaxType};

 PRIVATE PROCEDURE TaxIt(P: DATE; _Scale: tTax2001_ScalesType; _ToTax: NUMERIC[2]): NUMERIC[2];
  VAR
   _Sum,
   _Prc,
   _Bas      : NUMERIC[2][Tax2001_ScaleSize];
   PosInScale: SCAL[Tax2001_ScaleSize+1];
 BEGIN
  GetScale(P, _Scale, _Sum, _Prc, _Bas);
  PosInScale:=1; (* ! 㫥 誠 易  _Bas = 0 *)
  WHILE ~!_Bas[PosInScale] & (_Bas[PosInScale] < _ToTax) DO
   INC(PosInScale);
  END;
  DEC(PosInScale);
  RETURN ConvertTaxType(_Sum[PosInScale]+_Prc[PosInScale]/100*(_ToTax-_Bas[PosInScale]));
 END {TaxIt};

 PRIVATE PROCEDURE Tax_CitizenshipForTax(_Man: LIKE(Man.Man); D: DATE): SCAL[2];
 BEGIN
  L_General.CallUs(OCCURE(Man) & (Man.Man = _Man));
  IF L_Man.AccessManAdr(_Man, D, L_Russia.at_RgMA) |
     L_Man.AccessManAdr(_Man, D, L_Russia.at_CtMA) THEN
   IF ManAdr.Country = L_Russia.c_Russia THEN
    RETURN 1;
   ELSE
    CONFORM(ManAdr, Country);
    RETURN L_PRoll.E_StatesForTaxSameAs643(D);
   END;
  ELSIF Man.DocType=L_Man.dt_PaspRussia THEN
   RETURN 1;
  ELSIF Man.DocType=L_Man.dt_PaspForeign THEN
   RETURN 0;
  ELSE
   L_General.Error(" । ࠦ⢮  " + L_DatTim.DateStr(D) +
                   "|(   ﭭ  ⥫⢠,  ࠦ⢠)" +
                   "|᪮  "+ _Man);
  END;
 END {Tax_CitizenshipForTax};

 PUBLIC PROCEDURE Tax_IsResident(P: DATE): SCAL[2];
  VAR
   RAP       : NUMERIC[0];
   curFrom,
   curUpto   : DATE;
   wCA       : SCAL[2];
   Result    : SCAL[2];
   mp_MinD   : DATE;
   mp_Status : P_Man.tNDFLStatus;
   mp_Days   : P_Man.tNDFLDaysInRussia;
 BEGIN
  Result:=1;
  RAP:=E_ResidentApproachLevel(P);
  IF P_Man.HasActualManPro(Man.Man, L_DatTim.MonthEnd(P), P_Man.P_SpecificNDFL) THEN
   P_Man.GetNDFLInf(mp_Status, mp_Days);
   mp_MinD:=ManPro.Date;
   IF    mp_Status = P_Man.ndfls_Auto THEN
    P_Man.CheckNDFL(0, P);
   ELSIF mp_Status = P_Man.ndfls_Nonresident THEN
    Result:=0;
   ELSIF mp_Status # P_Man.ndfls_Resident THEN
    L_General.CallUs(0);
   END;
  ELSE
   mp_Status:=P_Man.ndfls_Auto;
   mp_Days  :=0;
   mp_MinD  :=MINOF(DATE);
  END;
  IF (mp_Status = P_Man.ndfls_Auto) & ~Tax_CitizenshipForTax(Man.Man, L_DatTim.MonthEnd(P)) THEN
   IF RAP = rap_None THEN
    Result:=0;
   ELSIF (RAP = rap_InYear) | (RAP = rap_InYearwCntAgreem(* ࠬ 鸞*)) THEN
    wCA:=RAP=rap_InYearwCntAgreem;
    curFrom:=Math.Max(mp_MinD, L_DatTim.YearBeg(P));
    Result:=(mp_Days + L_Man.extGetContractsLengthOfMan(Man.Man, curFrom, L_DatTim.YearEnd(P), P, wCA, 1)) >= 183;
    IF (P >= 01\01\2007) & ~Result THEN
     curUpto:=L_Man.GetTheLastContractEndOfMan(Man.Man, L_DatTim.MonthEnd(P), wCA);
     IF curUpto >= L_DatTim.YearBeg(P) THEN
      curUpto:=Math.Min(L_DatTim.YearEnd(P), curUpto);
      curFrom:=Math.Max(mp_MinD, L_DatTim.IncMonth(L_DatTim.Per(curUpto), -11));
      Result:=(mp_Days + L_Man.extGetContractsLengthOfMan(Man.Man, curFrom, curUpto, P, wCA, 1)) >= 183;
     END;
    END;
   ELSIF RAP = rap_InMonth THEN
    IF P >= 01\01\2007 THEN
     curFrom:=Math.Max(mp_MinD, L_DatTim.IncMonth(L_DatTim.Per(P), -11));
     Result:=(mp_Days + L_Man.extGetContractsLengthOfMan(Man.Man, curFrom, L_DatTim.MonthEnd(P), P, 0, 0)) >= 183;
     IF ~Result THEN
      curUpto:=L_Man.GetTheLastContractEndOfMan(Man.Man, L_DatTim.MonthEnd(P), 0);
      IF (curUpto >= L_DatTim.YearBeg(P)) & (curUpto < P) THEN
       curFrom:=Math.Max(mp_MinD, L_DatTim.IncMonth(L_DatTim.Per(curUpto), -11));
       Result:=(mp_Days + L_Man.extGetContractsLengthOfMan(Man.Man, curFrom, L_DatTim.MonthEnd(curUpto), P, 0, 0)) >= 183;
      END;
     END;
    ELSE
     curFrom:=Math.Max(mp_MinD, L_DatTim.YearBeg(P));
     Result:=L_Man.extGetContractsLengthOfMan(Man.Man, curFrom, L_DatTim.MonthEnd(P), P, 0, 0) >= 183;
    END;
   ELSE
    L_General.CallUs(0);
   END;
  END;
  RETURN Result;
 END {Tax_IsResident};

 PRIVATE PROCEDURE ManWasNonresident(P: DATE): DATE;
  VAR
   Y: DATE;
 BEGIN
  Y:=Math.Max(L_DatTim.Per(L_Man.GetTotTakeOnDate(L_DatTim.MonthEnd(P), 1)), L_DatTim.YearBeg(P));
  IF (P > Y) & ~Tax_IsResident(Y) & Tax_IsResident(P) THEN
   REPEAT
    P:=L_DatTim.IncMonth(P, -1);
   UNTIL ~Tax_IsResident(P);
   RETURN P;
  ELSE
   RETURN EMPTYOF(DATE);
  END;
 END {ManWasNonresident};

 PUBLIC PROCEDURE Tax_GetScaleForMainScale(P: DATE): tTax2001_ScalesType;
 BEGIN
  IF Tax_IsResident(P) THEN
   RETURN Tax2001_MainScale;
  ELSE
   RETURN Tax2001_ScndScale;
  END;
 END {Tax_GetScaleForMainScale};

 PUBLIC PROCEDURE IsMainScale(_Scale: tTax2001_ScalesType): SCAL[2];
 BEGIN
  RETURN (_Scale#Tax2001_ThrdScale) & (_Scale#Tax2001_FrthScale);
 END {IsMainScale};

 PRIVATE PROCEDURE GetExpenseRealtyVCode(P: DATE): LIKE(TaxAdv.VCode);
 BEGIN
  RETURN "0311";
 END {GetExpenseRealtyVCode};

 PUBLIC PROCEDURE extGetClcTax(P: DATE; fictOnly: SCAL[2]; curScale, mainScale: tTax2001_ScalesType): NUMERIC[2];
  VAR
   msOthInc,
   msInc,
   ssInc,
   tsInc,
   fsInc   : NUMERIC[2][12];
   Inc,
   Dec,
   ToTax   : NUMERIC[2];
 BEGIN
  Tax_CheckYear(P);

  SETZERO(msInc, ssInc, tsInc, fsInc, msOthInc, Inc, Dec);

  IF IsMainScale(curScale) THEN
   IF ~fictOnly THEN
    Tax2001_GetPureIncome(P, msInc);
   END;
  END;

  IF (curScale=Tax2001_EvryScale) | (curScale=Tax2001_MainScale) THEN
   Tax2001_ScaleToGather:=Tax2001_MainScale;
   Tax2001_GetOneType(P, P, Tax2001_mt_Inc, msInc);
   Tax2001__GetOneType(PROCREF(Tax2001__W_Lim), P, P, Tax2001_mt_Inc, msOthInc, 1); (*室  ।  ࠡ  ࠭祭 ⮢*)
  END;
  IF (curScale=Tax2001_EvryScale) | (curScale=Tax2001_ScndScale) THEN
   Tax2001_ScaleToGather:=Tax2001_ScndScale;
   Tax2001_GetOneType(P, P, Tax2001_mt_Inc, ssInc);
  END;
  IF (curScale=Tax2001_EvryScale) | (curScale=Tax2001_ThrdScale) THEN
   Tax2001_ScaleToGather:=Tax2001_ThrdScale;
   Tax2001_GetOneType(P, P, Tax2001_mt_Inc, tsInc);
  END;
  IF (curScale=Tax2001_EvryScale) | (curScale=Tax2001_FrthScale) THEN
   Tax2001_ScaleToGather:=Tax2001_FrthScale;
   Tax2001_GetOneType(P, P, Tax2001_mt_Inc, fsInc);
  END;
  SETEMPTY(Tax2001_ScaleToGather);

  SetManTotInc(msInc, ssInc, msOthInc);(*: Estimate - ⮫쪮  室 13%*)

  Inc:=Tax2001_GetArrSum(msInc);

  IF IsMainScale(curScale) THEN
   IF Tax_IsResident(P) THEN
    Tax2001_GetOneType(P, P, Tax2001_mt_StD, Dec);
   END;
   Tax2001_GetOneType(P, P, Tax2001_mt_Exp, Dec);
  END;

  ToTax:=Inc-Dec;

  IF ToTax < 0 THEN
   ToTax:=0;
  END;

  IF !mainScale THEN
   mainScale:=Tax_GetScaleForMainScale(P);
  END;
  RETURN TaxIt(P,         mainScale,                    ToTax) +
         TaxIt(P, Tax2001_ScndScale, Tax2001_GetArrSum(ssInc)) +
         TaxIt(P, Tax2001_ThrdScale, Tax2001_GetArrSum(tsInc)) +
         TaxIt(P, Tax2001_FrthScale, Tax2001_GetArrSum(fsInc));
 END {extGetClcTax};

 PUBLIC PROCEDURE _Tax2001_GetClcTax(P, F: DATE; fictOnly: SCAL[2]; _Scale: NUMERIC[0]): NUMERIC[2];
 BEGIN
  RETURN extGetClcTax(P, fictOnly, _Scale, EMPTYOF(tTax2001_ScalesType));
 END {_Tax2001_GetClcTax};

 PUBLIC PROCEDURE _Tax2001_GetPaidTax(P, F: DATE; fictOnly: SCAL[2]; _Scale: NUMERIC[0]): NUMERIC[2];
  VAR
   Tax: NUMERIC[2];
 BEGIN
  Tax   :=0;
  IF IsMainScale(_Scale) THEN
   Tax2001_GetOneType(P, F, Tax2001_mt_Tax, Tax);
   IF (_Scale=Tax2001_EvryScale) THEN
    Tax2001_GetOneType(P, F, Tax2001_mt_EFT, Tax);
   END;
   IF ~fictOnly THEN
    Tax2001_GetTax(P, Tax);
   END;
  END;
  RETURN ConvertTaxType(Tax);
 END {_Tax2001_GetPaidTax};

 PUBLIC PROCEDURE _Tax2001_GetOverTax(P, F: DATE; fictOnly: SCAL[2]; _Scale: NUMERIC[0]): NUMERIC[2];
 BEGIN
  RETURN ConvertTaxType(_Tax2001_GetClcTax (P, F, fictOnly, _Scale)-
                        _Tax2001_GetPaidTax(P, F, fictOnly, _Scale));
 END {_Tax2001_GetOverTax};

 PUBLIC PROCEDURE Tax2001_GetOverTax(P, F: DATE; fictOnly: SCAL[2]): NUMERIC[2];
 BEGIN
  RETURN _Tax2001_GetOverTax(P, F, fictOnly, Tax2001_EvryScale);
 END {Tax2001_GetOverTax};

 PUBLIC PROCEDURE StandOnSpecifiedTaxAdv(D       : DATE;
                                         _OwnCode: LIKE(TaxAdv.OwnCode);
                                         _VCode  : LIKE(TaxAdv.VCode)): NUMERIC[0];
  VAR
   Cnt: NUMERIC[0];
 BEGIN
  Cnt:=0;
  SELECT(TaxAdv, FullCode, , _OwnCode, _VCode);
  WHILE OCCURE(TaxAdv) DO
   IF L_DatTim.IsActive(D, TaxAdv.Begin, TaxAdv.Till) THEN
    IF Cnt = 0 THEN
     SAVE(TaxAdv);
    END;
    INC(Cnt);
   END;
   NEXT(TaxAdv);
  END; (* WHILE OCCURE(TaxAdv) ... *)
  IF Cnt > 0 THEN
   RESTORE(TaxAdv);
  END;
  RETURN Cnt;
 END {StandOnSpecifiedTaxAdv};

 PUBLIC PROCEDURE Tax_StandOnSingleSpecifiedTaxAdv(D       : DATE;
                                                   _OwnCode: LIKE(TaxAdv.OwnCode);
                                                   _VCode  : LIKE(TaxAdv.VCode));
 BEGIN
  L_General.Assert(StandOnSpecifiedTaxAdv(D, _OwnCode, _VCode) = 1,
                   "室  ஢  䨪"+
                   "|"+
                   "'" + Tax2001_NamArr[GetIdx(_OwnCode, _VCode)] + "'");
 END {Tax_StandOnSingleSpecifiedTaxAdv};

 PUBLIC PROCEDURE Tax_StandOnManTAByTaxAdv(P, F: DATE; _TaxAdv: LIKE(TaxAdv.TaxAdv)): SCAL[2];
 BEGIN
  SELECT(_MnTA, _MnTA, , Man.Man, Tax_TaxAdv_Type(), _TaxAdv);
  WHILE OCCURE(_MnTA) DO
   IF L_DatTim.Per(_MnTA._StartD) <= F THEN
    Tax_AccessManTA_by_MnTA();
    IF ManTA.StopD>=P THEN
     RETURN 1;
    END;
   END;
   NEXT(_MnTA);
  END; (* WHILE OCCURE(_MnTA) ... *)
  RETURN 0;
 END {Tax_StandOnManTAByTaxAdv};

 PRIVATE PROCEDURE IsLastMonthOfYear(P: DATE): SCAL[2];
 BEGIN
  RETURN L_DatTim.MONTH(P) = 11;
 END {IsLastMonthOfYear};

 PRIVATE PROCEDURE PlaceOverTax(P                  : DATE;
                                PaidByOtherContract: NUMERIC[2];
                                VAR ClcTax         : NUMERIC[2]);
  VAR
   TaxToReturn: NUMERIC[2];
 BEGIN
  IF ClcTax < 0 THEN
   TaxToReturn:=ClcTax + PaidByOtherContract;
   IF TaxToReturn < 0 THEN
    Tax_StandOnSingleSpecifiedTaxAdv(P, Tax2001__oc_RtOvr, "");
    IF ~Tax_StandOnManTAByTaxAdv(P, P, TaxAdv.TaxAdv) THEN
     IF IsLastMonthOfYear(P) THEN
      Tax_StandOnSingleSpecifiedTaxAdv(P, Tax2001__oc_PYTax, "");
      AddManTA(L_DatTim.IncMonth(P, +1), TaxAdv.TaxAdv, -TaxToReturn);
      L_StdFrm.Choice("   ⮬ (९ )  ࠧ " + FLDTOSTR(-TaxToReturn, "2-", 0)+
                      "|७ᥭ  ᫥騩 ");
     ELSIF L_Staff.IsLeaveFinally(P) & (L_DatTim.IncMonth(L_DatTim.Per(Staff.EndDate), +1)>(SYSDATE()-20)) THEN
      L_StdFrm.Choice("    ⮬ (९ )  ࠧ " +
                      FLDTOSTR(-TaxToReturn, "2-", 0));
     END;
     INC(ClcTax, -TaxToReturn);
    END; (* IF ~OCCURE(ManTA) ... *)
   END; (* IF TaxToReturn < 0 ... *)
  END; (* IF ClcTax < 0 ... *)
 END {PlaceOverTax};

 PRIVATE PROCEDURE PlaceToEnforcement(P: DATE; IsLeaved: SCAL[2]; VAR ToEnforcementTax: NUMERIC[2]);
  VAR
   Msg: STRING[];
 BEGIN
  IF ToEnforcementTax > 0 THEN
   Tax_StandOnSingleSpecifiedTaxAdv(P, Tax2001__oc_OvrLm, "");
   IF Tax_StandOnManTAByTaxAdv(P, P, TaxAdv.TaxAdv) THEN
    L_General.Assert((ManTA.Value MOD 1) = 0, "㬬 㤥ঠ  ᢥ ࠭祭 㪠  ");
    DEC(ToEnforcementTax, Math.Min(ToEnforcementTax, ManTA.Value));
    IF ToEnforcementTax > 0 THEN
     L_StdFrm.Choice(" ᫥   ࠧ " + FLDTOSTR(ToEnforcementTax, "2-", 0) +
                     "| 㤥 㤥ঠ");
    END; (* IF ToEnforcementTax > 0 ... *)
   END;
   IF ToEnforcementTax > 0 THEN
    IF IsLeaved THEN
     Tax_StandOnSingleSpecifiedTaxAdv(P, Tax2001__oc_EFTax, "");
     AddManTA(P, TaxAdv.TaxAdv, ToEnforcementTax);
     Msg:="।  ᪠   ᯥ";
    ELSIF IsLastMonthOfYear(P) THEN
     Tax_StandOnSingleSpecifiedTaxAdv(P, Tax2001__oc_PYTax, "");
     AddManTA(L_DatTim.IncMonth(P, +1), TaxAdv.TaxAdv, -ToEnforcementTax);
     Msg:="७ᥭ  ᫥騩 ";
    ELSE
     Msg:="";
    END;
    IF ~!Msg & ~InConverterInClosedYear THEN
     L_StdFrm.Choice(" ᫥   ࠧ " + FLDTOSTR(ToEnforcementTax, "2-", 0) +
                     "|" + Msg);
    END;
   END; (* IF IsLeaved() | ... *)
  END; (* IF ToEnforcementTax ... *)
 END {PlaceToEnforcement};

 PRIVATE PROCEDURE MoveEM_wf(P, F: DATE);
  VAR
   _Value : LIKE(ManTA.Value);
 BEGIN
  SELECT(TaxInq, MyFirm, , Staff.MyFirm, Staff.Man);
  WHILE OCCURE(TaxInq) DO
   IF (TaxInq.InqType # inqt_Auto) &
      (TaxInq.InqType # inqt_Fict) THEN
    SELECT(ManTA, TaxInq, , TaxInq.TaxInq);
    WHILE OCCURE(ManTA) DO
     IF L_DatTim.IsActiveInIntvl_Inc(F, L_DatTim.MonthEnd(F), ManTA.StartD, ManTA.StopD) THEN
      CONFORM(ManTA, TaxAdv);
      IF Tax_TaxAdv_TakenOft() = 2(*/  ⮬ 믫 *) THEN
       SAVE(TaxInq);
       SAVE(ManTA);
       _Value:=GetTAValue(P, 0);
       AddManTA(F, TaxAdv.TaxAdv, -_Value);
       AddManTA(P, TaxAdv.TaxAdv,  _Value);
       RESTORE(ManTA);
       RESTORE(TaxInq);
      END; (* IF Tax_TaxAdv_TakenOft ... *)
     END; (* IF L_DatTim.IsActiveInIntvl_Inc ... *)
     NEXT(ManTA);
    END; (* WHILE OCCURE(ManTA) ... *)
   END; (* IF TaxInq.InqType ... *)
   NEXT(TaxInq);
  END; (* WHILE OCCURE(TaxInq) ... *)
 END {MoveEM_wf};

 PRIVATE PROCEDURE AddInCodesArray(_OwnCode: tOwnCode;
                                   _VCode  : tVCode;
                                   _Name   : STRING[]);
 BEGIN
  Tax2001_CodArr[Tax2001_ArrVol]:=MakeInternalCode(_OwnCode, _VCode);
  Tax2001_NamArr[Tax2001_ArrVol]:=_Name;
  INC(Tax2001_ArrVol);
 END {AddInCodesArray};

 PRIVATE PROCEDURE AddIncome(_VCode   : tVCode;
                             _Scale   : tTax2001_ScalesType;
                             _LimCode : tVCode;
                             _LimValue: NUMERIC[2];
                             _Name    : STRING[]);
 BEGIN
  Tax2001_TypArr[Tax2001_ArrVol]:=Tax2001_mt_Inc;
  Tax2001_SclArr[Tax2001_ArrVol]:=_Scale;
  IF ~!_LimCode THEN
   Tax2001_LmCArr[Tax2001_ArrVol]:=_LimCode;
   Tax2001_LmVArr[Tax2001_ArrVol]:=_LimValue;
  END;
  AddInCodesArray(Tax2001__oc_IsMNS, _VCode, _Name);
 END {AddIncome};

 PRIVATE PROCEDURE AddStandartDeduction(_VCode: tVCode;
                                        _Value: NUMERIC[2];
                                        _Name : STRING[]);
 BEGIN
  Tax2001_TypArr[Tax2001_ArrVol]:=Tax2001_mt_StD;
  Tax2001_ValArr[Tax2001_ArrVol]:=_Value;
  AddInCodesArray(Tax2001__oc_IsMNS, _VCode, _Name);
 END {AddStandartDeduction};

 PRIVATE PROCEDURE AddExpenses(_VCode   : tVCode;
                               _LimValue: NUMERIC[2];
                               _Name    : STRING[]);
 BEGIN
  Tax2001_TypArr[Tax2001_ArrVol]:=Tax2001_mt_Exp;
  Tax2001_LmVArr[Tax2001_ArrVol]:=_LimValue;
  AddInCodesArray(Tax2001__oc_IsMNS, _VCode, _Name);
 END {AddExpenses};

 PRIVATE PROCEDURE AddOwnModification(_OwnCode : tOwnCode;
                                      _Type    : tTax2001_MdfType;
                                      _Name    : STRING[]);
 BEGIN
  Tax2001_TypArr[Tax2001_ArrVol]:=_Type;
  AddInCodesArray(_OwnCode, "0000", _Name);
 END {AddOwnModification};

 PUBLIC PROCEDURE Tax2001_InitCodes(P: DATE);
  VAR
   ForPresents,
   ForChild,
   ForChild2,
   ForChild3,
   ForChildInvalid,
   ForChildSingleParent: NUMERIC[2];
 BEGIN
  IF ~!InitCodesPeriod & (L_DatTim.YEAR(InitCodesPeriod) = L_DatTim.YEAR(P)) THEN
   RETURN;  (*१ ⠡, ᫨  *)
  END;
  InitCodesPeriod:=P;
  Tax2001_ArrVol:=0;
  SETEMPTY(Tax2001_CodArr,
           Tax2001_NamArr,
           Tax2001_TypArr,
           Tax2001_SclArr,
           Tax2001_LmCArr,
           Tax2001_LmVArr,
           Tax2001_ValArr);

  IF P < 01\01\2009 THEN
   IF P >= 01\01\2005 THEN
    ForChild:=600;
    ForChildSingleParent:=1200;
   ELSE
    ForChild:=300;
    ForChildSingleParent:=600;
   END;
   AddStandartDeduction("0101",  ForChild,             " ॡ "+L_Str.IntStr(ForChild)+" 㡫, .4 .1 .218 ");
   AddStandartDeduction("0102",  ForChildSingleParent, " ॡ  (),  த⥫, , ⥫ "+L_Str.IntStr(ForChildSingleParent)+" 㡫, .4 .1 .218 ");
  END;
  IF P < 01\01\2012 THEN
   AddStandartDeduction("0103",  400, " ⥫騪 400 㡫, .3 .1 .218 ");
  END;
  AddStandartDeduction("0104",  500, " ⥫騪 500 㡫, .2 .1 .218 ");
  AddStandartDeduction("0105", 3000, " ⥫騪 3000 㡫, .1 .1 .218 ");
  IF P >= 01\01\2011 THEN
   IF    P >= 01\01\2012 THEN
    ForChild :=1400;
    ForChild2:=1400;
    ForChild3:=3000;
    ForChildInvalid:=3000;
   ELSIF P >= 01\01\2011 THEN
    ForChild :=1000;
    ForChild2:=1000;
    ForChild3:=3000;
    ForChildInvalid:=3000;
   END;
   AddStandartDeduction("0114", ForChild,          " ࢮ ॡ "+L_Str.IntStr(ForChild)+" 㡫");
   AddStandartDeduction("0115", ForChild2,         " ண ॡ "+L_Str.IntStr(ForChild2)+" 㡫");
   AddStandartDeduction("0116", ForChild3,         " 쥣   ᫥饣 ॡ "+L_Str.IntStr(ForChild3)+" 㡫");
   AddStandartDeduction("0117", ForChildInvalid,   " ॡ- "+L_Str.IntStr(ForChildInvalid)+" 㡫");
   AddStandartDeduction("0118", ForChild*2,        " ࢮ ॡ ⢥ த⥫, , ⥫ "+L_Str.IntStr(ForChild*2)+" 㡫");
   AddStandartDeduction("0119", ForChild2*2,       " ண ॡ ⢥ த⥫, , ⥫ "+L_Str.IntStr(ForChild2*2)+" 㡫");
   AddStandartDeduction("0120", ForChild3*2,       " 쥣   ᫥饣 ॡ ⢥ த⥫, , ⥫ "+L_Str.IntStr(ForChild3*2)+" 㡫");
   AddStandartDeduction("0121", ForChildInvalid*2, " ॡ- ⢥ த⥫, , ⥫ "+L_Str.IntStr(ForChildInvalid*2)+" 㡫");
   AddStandartDeduction("0122", ForChild*2,        " ࢮ ॡ, ᫨ ன த⥫ ⪠   "+L_Str.IntStr(ForChild*2)+" 㡫");
   AddStandartDeduction("0123", ForChild2*2,       " ண ॡ, ᫨ ன த⥫ ⪠   "+L_Str.IntStr(ForChild2*2)+" 㡫");
   AddStandartDeduction("0124", ForChild3*2,       " 쥣   ᫥饣 ॡ, ᫨ ன த⥫ ⪠   "+L_Str.IntStr(ForChild3*2)+" 㡫");
   AddStandartDeduction("0125", ForChildInvalid*2, " ॡ-, ᫨ ன த⥫ ⪠   "+L_Str.IntStr(ForChildInvalid*2)+" 㡫");
  ELSIF P >= 01\01\2009 THEN
   ForChild       :=1000;
   ForChildInvalid:=2000;
   AddStandartDeduction("0108", ForChild,          " ॡ "+L_Str.IntStr(ForChild)+" 㡫, .4 .1 .218 ");
   AddStandartDeduction("0109", ForChildInvalid,   " ॡ- "+L_Str.IntStr(ForChildInvalid)+" 㡫, .4 .1 .218 ");
   AddStandartDeduction("0110", ForChild*2,        " ॡ  (),  த⥫, , ⥫ "+L_Str.IntStr(ForChild*2)+" 㡫, .4 .1 .218 ");
   AddStandartDeduction("0111", ForChild*2,        " ॡ "+L_Str.IntStr(ForChild*2)+" 㡫, ᫨ ன த⥫ ⪠  , .4 .1 .218 ");
   AddStandartDeduction("0112", ForChildInvalid*2, " ॡ- "+L_Str.IntStr(ForChildInvalid*2)+" 㡫  (),  த⥫, , ⥫, .4 .1 .218 ");
   AddStandartDeduction("0113", ForChildInvalid*2, " ॡ- "+L_Str.IntStr(ForChildInvalid*2)+" 㡫, ᫨ ன த⥫ ⪠  , .4 .1 .218 ");
  ELSE
   AddStandartDeduction("0106", ForChild*2,             " ॡ- "+L_Str.IntStr(ForChild*2)+" 㡫, .4 .1 .218 ");
   AddStandartDeduction("0107", ForChildSingleParent*2, " ॡ- "+L_Str.IntStr(ForChildSingleParent*2)+" 㡫  (),  த⥫, , ⥫, .4 .1 .218 ");
  END;

  AddExpenses("0203", 0, "室  祭 ⥩"); (* 25000, 뢠 ⮬*)
  IF    P >= 01\01\2010 THEN
   AddExpenses(GetExpenseRealtyVCode(P), 2000000, "室  ");
  ELSIF P >= 01\01\2005 THEN
   AddExpenses(GetExpenseRealtyVCode(P), 1000000, "室  ");
  ELSE
   AddExpenses(GetExpenseRealtyVCode(P),       0, "室  ");  (*600000, 뢠 ⮬*)
  END;
  IF P >= 01\01\2010 THEN
   AddExpenses("0312", 2000000, "।  ");
  END;
  IF (P < 01\01\2010) & (P >= 01\01\2009) THEN
   AddExpenses("0313", 2000000, "室  ");
  END;
  IF P >= 01\01\2010 THEN
   AddExpenses("0318", 2000000, "।   (४।⮢)");
  END;

  AddIncome("1010", Tax2001_FrthScale,     "",       0, "");
  AddIncome("1230", Tax2001_MainScale,     "",       0, "客   ࠡ⭨");
  AddIncome("1510", Tax2001_MainScale, "0301", 1000000, "த  ⢠");
  AddIncome("2000", Tax2001_MainScale,     "",       0, "ࠡ⭠ ");
  AddIncome("2010", Tax2001_MainScale,     "",       0, "믫  ࠬ ࠦ᪮-ࠢ ࠪ ( ᪫祭 ᪨ ࠦ)");
  IF P >= 01\01\2006 THEN
   AddIncome("2012", Tax2001_MainScale,    "",       0, "㬬 ᪭ 믫");
   AddIncome("2300", Tax2001_MainScale,    "",       0, "ᮡ  ६ 㤮ᯮᮡ");
  ELSE
   AddIncome("2300", Tax2001_MainScale,    "",       0, "ᨨ, ᮡ, ⨯  , ஬ .ᮡ");
  END;
  AddIncome("2510", Tax2001_MainScale,     "",       0, " ⮢஢   ࣠樥");
  AddIncome("2520", Tax2001_MainScale,     "",       0, "⮨ ⮢஢     ᭮");
  AddIncome("2610", Tax2001_ThrdScale,     "",       0, "룮 ( ।⢠)");
  IF P < 01\01\2010 THEN
   AddIncome("2620", Tax2001_MainScale,     "",       0, "룮 ( ।⢠  )");
  END;

  IF P >= 01\01\2006 THEN
   ForPresents:=4000;
  ELSE
   ForPresents:=2000;
  END;
  AddIncome("2720", Tax2001_MainScale, "0501", ForPresents, "ન");
  AddIncome("2760", Tax2001_MainScale, "0503", ForPresents, "ਠ쭠 ");
  AddIncome("2762", Tax2001_MainScale, "0508",       50000, "ਠ쭠   ஦");
  IF P >= 01\01\2006 THEN (* ,     2001  - -3-08/379,   饫, ⮬ ⠢  2006*)
   AddIncome("4800", Tax2001_MainScale,     "",           0, " 室");
  ELSE
   AddIncome("3100", Tax2001_MainScale,     "",           0, " 室");
  END;

  AddOwnModification(Tax2001__oc_NoTxd, Tax2001_mt_NTx, "  ");
  AddOwnModification(Tax2001__oc_NoInc, Tax2001_mt_NIn, "  室");
  AddOwnModification(Tax2001__oc_NYInc, Tax2001_mt_Inc, "室 ᫥饣 ");
  Tax2001_SclArr[GetIdx(Tax2001__oc_NYInc, "")]:=Tax2001_MainScale; (*!*)
  AddOwnModification(Tax2001__oc_PYTax, Tax2001_mt_Tax, "९ 諮 ");
  AddOwnModification(Tax2001__oc_RtOvr, Tax2001_mt_Spc, "  ");
  AddOwnModification(Tax2001__oc_OYRec, Tax2001_mt_Tax, "   ");
  AddOwnModification(Tax2001__oc_CYTax, Tax2001_mt_Tax, "믫祭 ");
  AddOwnModification(Tax2001__oc_EFTax, Tax2001_mt_EFT, "।  ᪠");
  AddOwnModification(Tax2001__oc_OvrLm, Tax2001_mt_Spc, "ঠ ᢥ ࠭祭");
  AddOwnModification(Tax2001__oc_XXXXX, Tax2001_mt_Inc, "⠭ 室 ");
  Tax2001_SclArr[GetIdx(Tax2001__oc_XXXXX, "")]:=Tax2001_MainScale; (*!*)
 END {Tax2001_InitCodes};

 PUBLIC PROCEDURE Tax_SaveLoanProfit(P: DATE; Profit: NUMERIC[2]);
 BEGIN
  L_General.CallUs(P < Tax2001_FirstPeriod);
  L_Tx2000.AddManTA(P, 40, Profit);
 END {Tax_SaveLoanProfit};

 PUBLIC PROCEDURE Tax_GetLoanProfitMCode(P: DATE): LIKE(MCList.MCode);
  VAR
   _MCode: LIKE(MCList.MCode);
 BEGIN
  L_General.CallUs(P >= Tax2001_FirstPeriod);
  SAVE(MCList);
  SAVE(TaxAdv);
  Tax_StandOnSingleSpecifiedTaxAdv(P, 00, "2610"); (* !!! *)
  L_General.Assert(SELECT(MCList, TaxAdv, TaxAdv.TaxAdv) & (MCList.MCTyp=L_PRoll.mct_Debit),
                   "室 ନ  㤥ঠ: 룮  %  㤥");
  WHILE OCCURE(MCList) & ~L_DatTim.IsActive(P, MCList.Begin, MCList.Till) DO
   NEXT(MCList);
  END; (* WHILE OCCURE(MCList) ... *)
  L_General.Assert(OCCURE(MCList),
                   "室 ନ  㤥ঠ: 룮  %  㤥");
  _MCode:=MCList.MCode;
  RESTORE(TaxAdv);
  RESTORE(MCList);
  RETURN _MCode;
 END {Tax_GetLoanProfitMCode};

 PUBLIC PROCEDURE Tax2001_GetFromTable(    Idx     : NUMERIC[0];
                                       VAR _OwnCode: LIKE(TaxAdv.OwnCode);
                                       VAR _VCode  : LIKE(TaxAdv.VCode);
                                       VAR _Name   : STRING[]): SCAL[2];
 BEGIN
  IF Idx < Tax2001_ArrVol THEN
   _OwnCode:=Str.Slice(Tax2001_CodArr[Idx], 0, 2);
   IF _OwnCode = Tax2001__oc_IsMNS THEN
    _VCode :=Str.Slice(Tax2001_CodArr[Idx], 2, 4);
   ELSE
    SETEMPTY(_VCode);
   END;
   _Name   :=Tax2001_NamArr[Idx];
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {Tax2001_GetFromTable};

 PRIVATE PROCEDURE ApproachFuture(P: DATE);
  VAR
   i: NUMERIC[0];
 BEGIN
  IF (P<01\01\2004) & ~L_Staff.IsLeaveFinally(P) THEN
   i:=1;
   WHILE (i <= HIGH(Tax2001_FutTimes)) & (Tax2001_FutTimes[i] > 0) DO
    MoveEM_wf(P, L_DatTim.IncMonth(P, i));
    INC(i);
   END; (* WHILE i < ... *)
  END;
 END {ApproachFuture};

 PRIVATE PROCEDURE Calc_Tax(P: DATE; Lmt: NUMERIC[2]; VAR ToPayThisYear: NUMERIC[2]);
  VAR
   ToEnforcement,
   PaidByOtherContract : NUMERIC[2];
   lastNonresidentMonth: DATE;
   NonresidentOverTax  : NUMERIC[0];
 BEGIN
  L_General.CallUs(Man.Man=Staff.Man);
  SETZERO(ToPayThisYear);
  IF L_Staff.IsMainForTax(L_DatTim.MonthEnd(P)) THEN
   ApproachFuture(P);
   Tax_InitValues(P);
   ToPayThisYear:=Tax2001_GetOverTax(P, P, 0);
   IF P >= 01\01\2011 THEN
    lastNonresidentMonth:=ManWasNonresident(P);
    IF ~!lastNonresidentMonth THEN
     NonresidentOverTax:=extGetClcTax(lastNonresidentMonth, 0, Tax2001_EvryScale, Tax2001_MainScale);
     DEC(NonresidentOverTax, _Tax2001_GetPaidTax(lastNonresidentMonth, lastNonresidentMonth, 0, Tax2001_EvryScale));
     NonresidentOverTax:=ConvertTaxType(NonresidentOverTax);
     IF NonresidentOverTax < 0 THEN
      INC(ToPayThisYear, (-1) * NonresidentOverTax);
     END;
    END;
   END; (* IF P >= 01\01\2011 *)
   PaidByOtherContract:=0; _GetTax(P, P, PaidByOtherContract);
   IF ~InConverterInClosedYear THEN
    L_General.Assert(PaidByOtherContract >= 0,
                     "㤠 ⥫ 㤥ঠ    Calc_Tax?");
   END;
   IF ToPayThisYear < 0 THEN
    PlaceOverTax(P, PaidByOtherContract, ToPayThisYear);
   ELSE
    DEC(Lmt, PaidByOtherContract);
    IF ~InConverterInClosedYear THEN
     L_General.Assert(Lmt >= 0, "祬 ࠭祭  ⮣ ?");
    END;
    IF ToPayThisYear > Lmt THEN
     ToEnforcement:=ConvertTaxType(ToPayThisYear-Lmt);
     PlaceToEnforcement(P, L_Staff.IsLeaveFinally(P), ToEnforcement);
     DEC(ToPayThisYear, ToEnforcement);
    END;
   END;
  ELSIF PCalc.PurToTax > 0 THEN
   Tax_InitValues(P);
   ToPayThisYear:=ConvertTaxType(Math.Min(Lmt,
                                          TaxIt(P, Tax_GetScaleForMainScale(P), PCalc.PurToTax)));
  END; (* IF L_Staff.IsMainForTax( ... *)
 END {Calc_Tax};

 PUBLIC PROCEDURE Tax_Calc_Tax(P: DATE; Base: NUMERIC[2]; VAR ToPayThisYear: NUMERIC[2][]);
 BEGIN
  IF P >= Tax2001_FirstPeriod THEN
   ToPayThisYear[1]:=0;
   Calc_Tax(P, Math.Max(Base/2, 0), ToPayThisYear[0]);
  ELSE
   L_Tx2000.Calc_Tax(P, ToPayThisYear[1], ToPayThisYear[0]);
  END;
  IF ~InConverterInClosedYear THEN
   Tax_FreeValues(P);
  END;
 END {Tax_Calc_Tax};

 PUBLIC PROCEDURE E_NeedDwAdrForForeignResident(D: DATE): SCAL[2];
 BEGIN
  IF D > 01\01\2001 THEN
   RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.NeedDwAdrForForeignResident), 0);
  ELSE
   RETURN 0;
  END;
 END {E_NeedDwAdrForForeignResident};

 PUBLIC PROCEDURE StandOnManAdrForTax(trgMan: LIKE(Man.Man); D: DATE);
  VAR
   Per   : DATE;
   Strong: SCAL[2];
 BEGIN
  Per:=L_DatTim.Per(D);
  L_Man.AccessRgManAdr(trgMan, D);
  IF ManAdr.Country # L_Russia.c_Russia THEN
   IF    D >= 01\01\2005 THEN
    Strong:=1;
   ELSE
    Strong:=E_NeedDwAdrForForeignResident(Per) & Tax_IsResident(Per);
   END;
   IF Strong THEN
    L_Man.StrongAccessManAdr(trgMan, D, L_Russia.at_DwMA);
   ELSIF ~L_Man.AccessManAdr(trgMan, D, L_Russia.at_DwMA) THEN
    L_Man.AccessRgManAdr(trgMan, D);
   END;
  END; (* IF ManAdr.Country # L_Russia.c_Russia *)
 END {StandOnManAdrForTax};

(*---------begin of normal environment ------------*)

 PUBLIC PROCEDURE E_NeedOtherFirmToT3(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PRoll.NeedOtherFirmToT3), 0);
 END {E_NeedOtherFirmToT3};

 PRIVATE PROCEDURE IsBelarusCitizen(_Man: LIKE(Man.Man); D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(ManAdr);
  IF L_Man.AccessManAdr(_Man, D, L_Russia.at_CtMA) |
     L_Man.AccessManAdr(_Man, D, L_Russia.at_RgMA) THEN
   Result:=(ManAdr.Country = 112(**));
  ELSE
   Result:=0;
  END;
  RESTORE(ManAdr);
  RETURN Result;
 END {IsBelarusCitizen};

 PRIVATE PROCEDURE E_ResidentApproachLevel(P: DATE): NUMERIC[0];
  VAR
   Local  : PROC;
   Default: NUMERIC[0];
 BEGIN
  IF P >= 01\01\2010 THEN
   IF IsBelarusCitizen(Man.Man, L_DatTim.MonthEnd(P)) THEN
    Default:=rap_InYear;
   ELSE
    Default:=rap_InMonth;
   END;
  ELSE
   Default:=rap_InYear;
  END;
  Local:=PROCREF(E_PRoll.ResidentApproachLevel);
  IF ~!Local THEN
   RETURN Local(P, Default);
  ELSE
   RETURN Default;
  END;
 END {E_ResidentApproachLevel};

BEGIN
 InConverterInClosedYear:=0; ReCalcInClosedYear:=0;
 SETZERO(Tax2001_FutTimes, Tax2001_NextYearInc);
 SETEMPTY(InitCodesPeriod);
END.
