(*
%Copyright   (c) Polak IT
%Author      01.12.2004 10:11:35 POLAK\San
%Purpose     ⢨  ⥬
%Type        library
%Specific    SYS
%Modified    12.09.2014 12:31:17 POLAK\GAV
%Environment
*)

 MODULE L_WDO [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC PERMANENT VAR
  v_dbConnection: SCAL[1E4];

 PUBLIC TYPE
  tFilters = STRING[];

 PUBLIC CONST
  e_OnAnyModification = "e_OnAnyModification";
  e_OnAfterMdf        = "e_OnAfterMdf";
  e_OnBeforeEdit      = "e_OnBeforeEdit";
  e_OnAfterEdit       = "e_OnAfterEdit";
  e_OnBeforeInsert    = "e_OnBeforeInsert";
  e_OnAfterInsert     = "e_OnAfterInsert";
  e_OnBeforeDelete    = "e_OnBeforeDelete";
  e_OnAfterDelete     = "e_OnAfterDelete";
  e_OnReposition      = "e_OnReposition";
  e_OnOpenZone        = "e_OnOpenZone";
  e_OnChangeIndex     = "e_OnChangeIndex";
  e_OnSetSubwindow    = "e_OnSetSubwindow";

  MWM = "MultiWindowsModification";

 PRIVATE TYPE
  tFilter = STRING[];

 PRIVATE CONST
  fn_CurDate_ExceptOld = "஬  ᥩ  ⥪ ";
  fn_MatchName         = "   ''";

 PRIVATE CONST
  MaxFiltersCnt = 100;
  ptcr_DirectAccess = "<DirectAccess>";

 IMPORT L_General, Str, L_Str, L_DBD, L_PWDO, L_PCS, L_Prop, L_StdFrm, L_SES, Math;

 PRIVATE PROCEDURE extBuildValidityBEFilter(File: STRING[]; OnSysDate: SCAL[2]; CheckEDFOnly: SCAL[2]): STRING[];
  VAR
   frvt       : L_DBD.tFileRecordsValidityType;
   BDF,
   EDF,
   DatePointer: STRING[];
   Result     : STRING[];
 BEGIN
  frvt:=L_DBD.FileHasValidityFields(File);
  IF frvt # L_DBD.frvt_None THEN
   L_DBD.CollateValidityFieldNames(File, BDF, EDF);
   IF OnSysDate THEN
    DatePointer:=FLDTOSTR(SYSDATE());
   ELSE
    DatePointer:="Memo.CurDate";
   END;
   IF CheckEDFOnly THEN
    Result:="(" + L_DBD.GetFieldName(File, EDF);
   ELSE
    Result:="(" + L_DBD.GetFieldName(File, BDF) + "<=" + DatePointer + ") & (" + L_DBD.GetFieldName(File, EDF);
   END;
   IF frvt = L_DBD.frvt_Normal THEN
    Result:=Result + ">"  + DatePointer + ")";
   ELSE
    Result:=Result + ">=" + DatePointer + ")";
   END;

  ELSE
   Result:="";
  END;
  RETURN Result;
 END {extBuildValidityBEFilter};

 PUBLIC PROCEDURE extBuildValidityFilter(File: STRING[]; OnSysDate: SCAL[2]): STRING[];
 BEGIN
  RETURN extBuildValidityBEFilter(File, OnSysDate, 0);
 END {extBuildValidityFilter};

 PUBLIC PROCEDURE BuildValidityFilter(File: STRING[]): STRING[];
 BEGIN
  RETURN extBuildValidityFilter(File, 0);
 END {BuildValidityFilter};

 PRIVATE PROCEDURE getForm(Name: STRING[]): FORM_WINDOW;
  VAR
   Result,
   W      : FORM_WINDOW;
 BEGIN
  Result:=APP.Get().Forms(Name);
  IF !Result THEN
   FOR_EACH W IN APP.Get().Forms DO
    IF W.AssignedName = Name THEN
     Result:=W;
     EXIT;
    END;
   END;
   IF !Result THEN
    FOR_EACH W IN APP.Get().Forms DO
     IF W.OriginalName = Name THEN
      Result:=W;
      EXIT;
     END;
    END;
   END;
  END;
  RETURN Result;
 END {getForm};

 PRIVATE PROCEDURE getZone(Window: STRING[]; Zone: NUMERIC[0]): FORM_ZONE;
 BEGIN
  RETURN getForm(Window).Zones(Zone);
 END {getZone};

 (*old*) PUBLIC PROCEDURE getActiveForm(): FORMWINDOW;
 BEGIN
  RETURN RTI.Get().CurWindow;
 END {getActiveForm};

 PUBLIC PROCEDURE getActiveZone(): FORM_ZONE;
 BEGIN
  RETURN getActiveForm().ActiveZone;
 END {getActiveZone};

 PRIVATE PROCEDURE ext_getField(Window: STRING[]; Zone: NUMERIC[0]; Name: STRING[]; MustPresent: SCAL[2]): FORMFIELD;
  VAR
   oField: FORMFIELD;
 BEGIN
  oField:=getZone(Window, Zone).Fields(Name);
  IF MustPresent & !oField THEN
   L_General.CallUs(0);
  END;
  RETURN oField;
 END {ext_getField};

 PRIVATE PROCEDURE getField(Window: STRING[]; Zone: NUMERIC[0]; Name: STRING[]): FORMFIELD;
 BEGIN
  RETURN ext_getField(Window, Zone, Name, 0);
 END {getField};

 PUBLIC PROCEDURE getFieldInActiveZone(Name: STRING[]): FORM_FIELD;
 BEGIN
  RETURN getField(getActiveForm().Name, getActiveZone().Number, Name);
 END {getFieldInActiveZone};

 PUBLIC PROCEDURE getActiveField(): FORM_FIELD;
 BEGIN
  RETURN getActiveZone().ActiveField;
 END {getActiveField};

 PUBLIC PROCEDURE wz_getFieldValue(Window: STRING[]; Zone: NUMERIC[0]; Name: STRING[]; VAR Value: ANYTYPE);
 BEGIN
  Value:=ext_getField(Window, Zone, Name, 1).Value;
 END {wz_getFieldValue};

 PUBLIC PROCEDURE getFieldValue(Name: STRING[]; VAR Value: ANYTYPE);
 BEGIN
  wz_getFieldValue(getActiveForm().Name, 0, Name, Value);
 END {getFieldValue};

 PUBLIC PROCEDURE wz_getFV_String(Window: STRING[]; Zone: NUMERIC[0]; Name: STRING[]): STRING[];
  VAR
   Value: STRING[];
 BEGIN
  wz_getFieldValue(Window, Zone, Name, Value);
  RETURN Value;
 END {wz_getFV_String};

 PUBLIC PROCEDURE wz_getFV_Number(Window: STRING[]; Zone: NUMERIC[0]; Name: STRING[]): FLOAT;
  VAR
   Value: FLOAT;
 BEGIN
  wz_getFieldValue(Window, Zone, Name, Value);
  RETURN Value;
 END {wz_getFV_Number};

 PUBLIC PROCEDURE getFV_String(Name: STRING[]): STRING[];
 BEGIN
  RETURN wz_getFV_String(getActiveForm().Name, 0, Name);
 END {getFV_String};

 PUBLIC PROCEDURE getFV_Number(Name: STRING[]): FLOAT;
 BEGIN
  RETURN wz_getFV_Number(getActiveForm().Name, 0, Name);
 END {getFV_Number};

 PUBLIC PROCEDURE wz_setFieldValue(Window: STRING[]; Zone: NUMERIC[0]; Name: STRING[]; Value: ANYTYPE);
 BEGIN
  ext_getField(Window, Zone, Name, 1).Value:=Value;;
 END {wz_setFieldValue};

 PUBLIC PROCEDURE z_setFieldValue(Zone: NUMERIC[0]; Name: STRING[]; Value: ANYTYPE);
 BEGIN
  RTI.Get().CurWindow.Zones(Zone).Fields(Name).Value:=Value;
 END {z_setFieldValue};

 PUBLIC PROCEDURE setFieldValue(Name: STRING[]; Value: ANYTYPE);
 BEGIN
  RTI.Get().CurWindow.Zones(0).Fields(Name).Value:=Value;
 END {setFieldValue};

 PUBLIC PROCEDURE InstallPermanentFilter(Value: STRING[]);
 BEGIN
  RTI.Get().CurWindow.ActiveZone.PermanentFilter:=Value;
 END {InstallPermanentFilter};

 PUBLIC PROCEDURE Fld_wIdx(FldName: STRING[]; Idx: NUMERIC[0]): STRING[];
 BEGIN
  RETURN FldName + "_" + L_Str.IntStr(Idx);
 END {Fld_wIdx};

 PUBLIC PROCEDURE getFldIdx(FldName: STRING[]): NUMERIC[0];
  VAR
   p: NUMERIC[0];
 BEGIN
  p:=Str.Pos(FldName, "_", Str.Length(FldName), BACKWARD);
  RETURN STRTOFLD(Str.Slice(FldName, p+1, Str.Length(FldName) - p), NUMERIC);
 END {getFldIdx};

 PUBLIC PROCEDURE getCurFldIdx(): NUMERIC[0];
 BEGIN
  RETURN getFldIdx(getActiveField().Name);
 END {getCurFldIdx};

 PUBLIC PROCEDURE TermProg_wRefresh();
 BEGIN
  LIKEMENU(IncBack, "");
 END {TermProg_wRefresh};

 PUBLIC PROCEDURE WindowExists(Window: STRING[]): SCAL[2];
  VAR
   Win: FORMWINDOW;
 BEGIN
  RETURN ~!APPLICATION.Get().Forms.Item(Window);
 END {WindowExists};

 PUBLIC PROCEDURE wz_FieldExists(Window: STRING[]; Zone: NUMERIC[0]; Name: STRING[]): SCAL[2];
 BEGIN
  RETURN ~!getField(Window, Zone, Name);
 END {wz_FieldExists};

 PUBLIC PROCEDURE FieldExists(Name: STRING[]): SCAL[2];
 BEGIN
  RETURN wz_FieldExists(getActiveForm().Name, getActiveZone().Number, Name);
 END {FieldExists};

 PUBLIC PROCEDURE wz_SetFieldFormat(Window: STRING[]; Zone: NUMERIC[0]; Name, Format: STRING[]);
 BEGIN
  L_General.CallUs(GE_CURWIN() = RTI.Get().CurWindow.Name);
  IF ~!RTI.Get().CurWindow.Zones(Zone).Fields(Name) THEN
   RTI.Get().CurWindow.Zones(Zone).Fields(Name).Format:=Format;
  END;
 END {wz_SetFieldFormat};

 PUBLIC PROCEDURE z_SetFieldFormat(Zone: NUMERIC[0]; Name, Format: STRING[]);
 BEGIN
  IF ~!RTI.Get().CurWindow.Zones(Zone).Fields(Name) THEN
   RTI.Get().CurWindow.Zones(Zone).Fields(Name).Format:=Format;
  END;
 END {z_SetFieldFormat};

 PUBLIC PROCEDURE SetFieldFormat(Name, Format: STRING[]);
 BEGIN
  IF ~!RTI.Get().CurZone.Fields(Name) THEN
   RTI.Get().CurZone.Fields(Name).Format:=Format;
  END;
 END {SetFieldFormat};

 PUBLIC PROCEDURE wz_FieldMustBeNonEmpty(Window: STRING[]; Zone: NUMERIC[0]; Name: STRING[]; MustBeNonEmpty: SCAL[2]);
  VAR
   oField: FORMFIELD;
 BEGIN
  oField:=getField(Window, Zone, Name);
  IF ~!oField THEN
   oField.MustBeNonempty:=MustBeNonEmpty;
  END;
 END {wz_FieldMustBeNonEmpty};

 PUBLIC PROCEDURE FieldMustBeNonEmpty(Name: STRING[]; MustBeNonEmpty: SCAL[2]);
 BEGIN
  wz_FieldMustBeNonEmpty(getActiveForm().Name, getActiveZone().Number, Name, MustBeNonEmpty);
 END {FieldMustBeNonEmpty};

 PRIVATE PROCEDURE insSetFieldTemplate(Name, Template: STRING[]; TemplateIsStrict: SCAL[2]);
  VAR
   oField: FORMFIELD;
 BEGIN
  oField                 :=getFieldInActiveZone(Name);
  oField.Template        :=Template;
  oField.TemplateIsStrict:=TemplateIsStrict;
 END {insSetFieldTemplate};

 PUBLIC PROCEDURE SetFieldStrongTemplate(Name, Template: STRING[]);
 BEGIN
  insSetFieldTemplate(Name, Template, 1);
 END {SetFieldStrongTemplate};

 PUBLIC PROCEDURE SetFieldTemplate(Name, Template: STRING[]);
 BEGIN
  insSetFieldTemplate(Name, Template, 0);
 END {SetFieldTemplate};

 PRIVATE PROCEDURE intSetFormFieldTemplate(Field: FORMFIELD; Template: STRING[]; TemplateIsStrict: SCAL[2]);
 BEGIN
  Field.Template        :=Template;
  Field.TemplateIsStrict:=1;
 END {intSetFormFieldTemplate};

 PUBLIC PROCEDURE SetFormFieldStrongTemplate(Field: FORMFIELD; Template: STRING[]);
 BEGIN
  intSetFormFieldTemplate(Field, Template, 1);
 END {SetFormFieldStrongTemplate};

 PUBLIC PROCEDURE SetFormFieldTemplate(Field: FORMFIELD; Template: STRING[]);
 BEGIN
  intSetFormFieldTemplate(Field, Template, 0);
 END {SetFormFieldTemplate};

 PUBLIC PROCEDURE wz_SetFieldVisible(Window: STRING[]; Zone: NUMERIC[0]; Name: STRING[]; Visible: SCAL[2]);
  VAR
   oField: FORMFIELD;
 BEGIN
  oField:=getField(Window, Zone, Name);
  IF ~!oField THEN
   oField.Visible:=Visible;
  END;
 END {wz_SetFieldVisible};

 PUBLIC PROCEDURE SetFieldVisible(Name: STRING[]; Visible: SCAL[2]);
 BEGIN
  wz_SetFieldVisible(getActiveForm().Name, getActiveZone().Number, Name, Visible);
 END {SetFieldVisible};

 PUBLIC PROCEDURE wz_SetFieldColor(Window: STRING[]; Zone: NUMERIC[0]; Name: STRING[]; Color: NUMERIC[0]);
  VAR
   oField: FORMFIELD;
 BEGIN
  oField:=getField(Window, Zone, Name);
  IF ~!oField THEN
   oField.Color:=Color;
  END;
 END {wz_SetFieldColor};

 PUBLIC PROCEDURE wz_SetFieldModifiable(Window: STRING[]; Zone: NUMERIC[0]; Name: STRING[]; Modifiable: SCAL[2]);
  VAR
   oField: FORMFIELD;
 BEGIN
  oField:=getField(Window, Zone, Name);
  IF ~!oField THEN
   oField.Modifiable:=Modifiable;
  END;
 END {wz_SetFieldModifiable};

 PUBLIC PROCEDURE z_SetFieldModifiable(Zone: NUMERIC[0]; Name: STRING[]; Modifiable: SCAL[2]);
 BEGIN
  wz_SetFieldModifiable(getActiveForm().Name, Zone, Name, Modifiable);
 END {z_SetFieldModifiable};

 PUBLIC PROCEDURE SetFieldModifiable(Name: STRING[]; Modifiable: SCAL[2]);
 BEGIN
  wz_SetFieldModifiable(getActiveForm().Name, getActiveZone().Number, Name, Modifiable);
 END {SetFieldModifiable};

 PUBLIC PROCEDURE SetFieldFirst(Name: STRING[]; First: SCAL[2]);
  VAR
   oField: FORMFIELD;
 BEGIN
  oField:=getField(getActiveForm().Name, getActiveZone().Number, Name);
  IF ~!oField THEN
   oField.First:=First;
  END;
 END {SetFieldFirst};

 PUBLIC PROCEDURE SetOwnerWindow(Name, OwnerWindow: STRING[]; OwnerZone: NUMERIC[0]);
  VAR
   oField: FORMFIELD;
 BEGIN
  oField                        :=getFieldInActiveZone(Name);
  oField.OwnerWindowOriginalName:=OwnerWindow;
  oField.OwnerZoneNumber        :=OwnerZone;
 END {SetOwnerWindow};

 PUBLIC PROCEDURE OriginalName(WorkName: STRING[]): STRING[];
 BEGIN
  IF ~!WorkName THEN
   RETURN APPLICATION.Get().VisibleWindows(WorkName).OriginalName;
  ELSE
   RETURN "";
  END;
 END {OriginalName};

 PRIVATE PROCEDURE GetFieldTitle(Zone: NUMERIC[0]; FieldName: STRING[]): STRING[];
 BEGIN
  RETURN FieldName + "_" + L_Str.IntStr(Zone) + "_Title";
 END {GetFieldTitle};

 PUBLIC PROCEDURE SetFieldExpression_wTitle(Zone: NUMERIC[0]; Name, Expression, Title: STRING[]);
 BEGIN
  setFieldValue(GetFieldTitle(Zone, Name), Title);
  RTI.Get().CurWindow.Zones(Zone).Fields(Name).Expression:=Expression;
 END {SetFieldExpression_wTitle};

 PUBLIC PROCEDURE IsLoadableAskClone(): SCAL[2];
  VAR
   oWindow: FORMWINDOW;
 BEGIN
  oWindow:=getActiveForm();
  RETURN (oWindow.Type = WINDOW.Type_Loadable) & ~!oWindow.AskSourceField;
 END {IsLoadableAskClone};

 PUBLIC PROCEDURE GetOwnerZone(curField: FORM_FIELD): FORM_ZONE;
 BEGIN
  RETURN RTI.Get().TrgZone;
 END {GetOwnerZone};

 PUBLIC PROCEDURE PositionInOwnerZoneOfActiveField(Master: STRING[]);
 BEGIN
  SE_WZD_POSITION(RTI.Get().TrgZone.Window.Name, RTI.Get().TrgZone.Number, ^(Master));
 END {PositionInOwnerZoneOfActiveField};

 PUBLIC PROCEDURE w_getParentZoneNumber(Window: FORMWINDOW): NUMERIC[0];
  VAR
   Result    : NUMERIC[0];
   ParentZone: FORM_ZONE;
 BEGIN
  SETEMPTY(Result);
  ParentZone:=Window.ParentZone;
  IF ~!ParentZone THEN
   Result:=ParentZone.Number;
  END;
  RETURN Result;
 END {w_getParentZoneNumber};

 PUBLIC PROCEDURE w_getParentWindow(Window: FORMWINDOW): FORMWINDOW;
  VAR
   Result    : FORMWINDOW;
   ParentZone: FORM_ZONE;
 BEGIN
  SETEMPTY(Result);
  ParentZone:=Window.ParentZone;
  IF ~!ParentZone THEN
   Result:=ParentZone.Window;
  END;
  RETURN Result;
 END {getParentWindow};

 PUBLIC PROCEDURE getParentWindow(): FORMWINDOW;
 BEGIN
  RETURN w_getParentWindow(getActiveForm());
 END {getParentWindow};

 PUBLIC PROCEDURE w_getParentWindowName(Window: FORMWINDOW): STRING[];
  VAR
   Result      : STRING[];
   ParentWindow: FORMWINDOW;
 BEGIN
  SETEMPTY(Result);
  ParentWindow:=w_getParentWindow(Window);
  IF ~!ParentWindow THEN
   Result:=ParentWindow.OriginalName;
  END;
  RETURN Result;
 END {w_getParentWindowName};

 PUBLIC PROCEDURE getParentWindowName(): STRING[];
 BEGIN
  RETURN w_getParentWindowName(getActiveForm());
 END {getParentWindowName};

 PUBLIC PROCEDURE getParentZoneNumber(): NUMERIC[0];
 BEGIN
  RETURN w_getParentZoneNumber(getActiveForm());
 END {getParentZoneNumber};

 PUBLIC PROCEDURE fz_AccessEnvVar(trgZone: FORM_ZONE; EnvVarName: STRING[]): ENVVAR;
  VAR
   Result: ENVVAR;
   p     : FORM_PROCESS;
 BEGIN
  SETEMPTY(Result);
  WHILE ~!trgZone & !Result DO
   FOR_EACH p IN trgZone.Processes DO
    Result:=p.Env.Item(EnvVarName);
    IF ~!Result THEN
     EXIT;
    END;
   END; (* FOR_EACH *)
   trgZone:=trgZone.ParentZone;
  END;
  RETURN Result;
 END {fz_AccessEnvVar};

 PUBLIC PROCEDURE AccessEnvVar(EnvVarName: STRING[]): ENVVAR;
  VAR
   Result: ENVVAR;
 BEGIN
  IF ~!RTI.Get().CurProcess THEN
   Result:=RTI.Get().CurProcess.Env.Item(EnvVarName);
  ELSE
   SETEMPTY(Result);
  END;
  IF !Result & ~!RTI.Get().CurWindow THEN
   Result:=fz_AccessEnvVar(RTI.Get().CurWindow.ActiveZone, EnvVarName);
  END;
  RETURN Result;
 END {AccessEnvVar};

 PUBLIC PROCEDURE GetEnvVarValue(EnvVarName: STRING[]): STRING[];
  VAR
   EnvVar: ENVVAR;
 BEGIN
  EnvVar:=AccessEnvVar(EnvVarName);
  IF ~!EnvVar THEN
   RETURN EnvVar.Value;
  ELSE
   RETURN "";
  END;
 END {GetEnvVarValue};

 PRIVATE PROCEDURE cfl_GetIndex(FileName: STRING[]): INDEX;
  VAR
   IndexName: STRING[];
   Index    : INDEX;
 BEGIN
  IF    FileName = "Staff" THEN
   IndexName:="TSN";
  ELSIF FileName = "Car"   THEN
   IndexName:="BoxNbr";
  ELSIF FileName = "FirmCtc"   THEN
   IndexName:="Id";
  ELSIF FileName = "RegMain"   THEN
   IndexName:="HumReg";
  ELSIF FileName = "MCList" THEN
   IndexName:="MCode";
  ELSE
   L_General.CallUs(~!DATABASE.Get().Tables(FileName));
   IndexName:=FileName;
  END;
  Index:=TABLE.Get(FileName).Indexes(IndexName);
  L_General.CallUs((Index.Unique = INDEX.Unique_Unique) | (Index.Unique = INDEX.Unique_AutoIncr));
  RETURN Index;
 END {cfl_GetIndex};

 PRIVATE PROCEDURE cfl_BuildNameFieldExpression(FileName, LinkName: STRING[]): STRING[];
 BEGIN
  IF    FileName = "Car"   THEN
   RETURN "SELF.Zone.LinkedFieldValue('" + LinkName + "->Mark.Name" + "')";
  ELSIF FileName = "AcsObj"   THEN
   RETURN "SELF.Zone.LinkedFieldValue('" + LinkName + ".FullName" + "')";
  ELSE
   RETURN "SELF.Zone.LinkedFieldValue('" + LinkName + ".Name" + "')";
  END;
 END {cfl_BuildNameFieldExpression};

 PRIVATE PROCEDURE intCreateFormLink(FileName,
                                     Prefix                 : STRING[];
                                     Idx                    : NUMERIC[0];
                                     SimpleFieldNamingManner: SCAL[2]);
  VAR
   Zone     : FORM_ZONE;
   Suffix,
   LinkName,
   FieldName: STRING[];
   Index    : INDEX;
   Link,
   trgLink  : FORM_LINK;
   Field1,
   Field2   : FORM_FIELD;
 BEGIN
  Index:=cfl_GetIndex(FileName);
  IF ~!Idx THEN
   Suffix:="_" + L_Str.IntStr(Idx);
  ELSE
   SETEMPTY(Suffix);
  END;
  Zone    :=RTI.Get().CurWindow.Zones(0);
  LinkName:=Prefix + FileName + Suffix;
  IF !Zone.Links(LinkName) THEN
   IF    Index.Fields.Count = 1 THEN
    IF SimpleFieldNamingManner THEN
     FieldName:=Prefix + Suffix;
    ELSE
     FieldName:=Prefix + Index.Fields(0).Name + Suffix;
    END;
    SETEMPTY(Field2);
    Field1 :=Zone.Fields(FieldName);
    trgLink:=FORM_LINK.Create(LinkName, Index, Field1);
   ELSIF Index.Fields.Count = 2 THEN
    L_General.CallUs(~SimpleFieldNamingManner);
    Field1 :=Zone.Fields(Prefix + Index.Fields(0).Name + Suffix);
    Field2 :=Zone.Fields(Prefix + Index.Fields(1).Name + Suffix);
    trgLink:=FORM_LINK.Create(LinkName, Index, Field1, Field2);
   ELSE
    L_General.CallUs(0);
   END;

   FOR_EACH Link IN Zone.Links DO
    IF ( !Field2 & (Field1 = Link.Fields(0))) |
       (~!Field2 & (Field2 = Link.Fields(1))) THEN
     Zone.Links.Remove(Link);
    END;
   END; (* FOR_EACH *)
   Zone.Links.Add(trgLink);
  END;
  IF SimpleFieldNamingManner THEN
   FieldName:=Prefix + "Name" + Suffix;
  ELSE
   FieldName:=Prefix + FileName + "_Name" + Suffix;
  END;
  Field1:=Zone.Fields(FieldName);
  IF ~!Field1 THEN
   Field1.Expression:=cfl_BuildNameFieldExpression(FileName, LinkName);
  END;
 END {intCreateFormLink};

 PUBLIC PROCEDURE extCreateFormLink(FileName, Prefix: STRING[]; Idx: NUMERIC[0]);
 BEGIN
  intCreateFormLink(FileName, Prefix, Idx, 0);
 END {extCreateFormLink};

 PUBLIC PROCEDURE CreateFormLink_Simple(FileName, Prefix: STRING[]);
 BEGIN
  intCreateFormLink(FileName, Prefix, EMPTYOF(NUMERIC[0]), 1);
 END {CreateFormLink_Simple};

 PUBLIC PROCEDURE CreateFormLink(FileName, Prefix: STRING[]);
 BEGIN
  extCreateFormLink(FileName, Prefix, EMPTYOF(NUMERIC[0]));
 END {CreateFormLink};

 PUBLIC PROCEDURE InHierarchyInsMode(): SCAL[2];
 BEGIN
  RETURN ~!RTI.Get().CurProcess.Env.Item("HierarchyInsMode");
 END {InHierarchyInsMode};

 PRIVATE PROCEDURE SetZonePosition(trgZone: FORM_ZONE);
 BEGIN
  IF OCCURE((trgZone.MasterTable.Name)) THEN
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    SE_WZD_CURSOR(trgZone.Window.Name, trgZone.Number, (trgZone.MasterTable.Name));
   EXCEPT
   ON Exc: Exc_RunTime DO
    IF L_General.IsSetRecordPositionInZoneError(Exc.ErrorCode) THEN
     IF Exc.ErrorCode = L_General.ec_rt_PosOutOfZoneSystemSelect THEN
      L_PWDO.pcr_Check_SE_WZD_Error(trgZone);
     END;
     SE_WZD_CURSOR(trgZone.Window.Name, trgZone.Number, (trgZone.MasterTable.Name));
    ELSE
     RAISE();
    END;
   END; (* TRY *)
  END;
 END {SetZonePosition};

 PRIVATE PROCEDURE SetAllPosition(trgWindow: FORM_WINDOW; trgZoneNbr: NUMERIC[0]);
  VAR
   curZone: FORM_ZONE;
 BEGIN
  IF ~!trgWindow.MasterCursor THEN
   SE_WWD_CURSOR(trgWindow.Name, (trgWindow.MasterCursor.TABLE.Name));
  END;

  FOR_EACH curZone IN trgWindow.Zones DO
   IF (curZone.Number # trgZoneNbr) & (curZone.MasterTable.Name # trgWindow.Zones(trgZoneNbr).MasterTable.Name) THEN
    SetZonePosition(curZone);
   END;
  END;
  SetZonePosition(trgWindow.Zones(trgZoneNbr));
 END {SetAllPosition};

 PRIVATE PROCEDURE IsPanelHasEditableFirstSymptom(Panel: FORM_ZONE): SCAL[2];
 BEGIN
  RETURN (Panel.ViewOnly = 0) &
         ~!Panel.RLevProg     &
         (Panel.OnBeforeEdit | Panel.OnAfterEdit | Panel.OnBeforeInsert | Panel.OnAfterInsert | Panel.OnBeforeDelete | Panel.OnAfterDelete) &
         ~!Panel.Fields;
 END {IsPanelHasEditableFirstSymptom};

 PRIVATE PROCEDURE IsWindowHasEditablePanel(File: STRING[]; FormWindow: FORM_WINDOW): SCAL[2];
  VAR
   Z                   : FORM_ZONE;
   Result              : SCAL[2];
   PanelMasterTableName: STRING[];
 BEGIN
  Result:=0;
  Z     :=FormWindow.Zones(0);
  IF ~!Z THEN
   IF IsPanelHasEditableFirstSymptom(Z) THEN
    Result              :=1;
    PanelMasterTableName:=Z.MasterTable.Name;
    FOR_EACH Z IN FormWindow.Zones DO
     IF ~Z.Plane THEN
      IF Z.MasterTable.Name = PanelMasterTableName THEN
       Result:=0;
       EXIT;
      END;
     END;
    END; (* FOR_EACH *)
   END; (* IF IsPanelHasEditableFirstSymptom...*)
  END;
  RETURN Result;
 END {IsWindowHasEditablePanel};

 PRIVATE PROCEDURE IsFileEditedInPanelOnly(File: STRING[]; FormWindow: FORM_WINDOW): SCAL[2];
  VAR
   Z     : FORM_ZONE;
   Result: SCAL[2];
 BEGIN
  Result:=0;
  Z     :=FormWindow.Zones(0);
  IF ~!Z THEN
   IF IsPanelHasEditableFirstSymptom(Z) & (Z.MasterTable.Name = File) THEN
    Result:=1;
    FOR_EACH Z IN FormWindow.Zones DO
     IF ~Z.Plane THEN
      IF Z.MasterTable.Name = File THEN
       Result:=0;
       EXIT;
      END;
     END;
    END; (* FOR_EACH *)
   END; (* IF IsPanelHasEditableFirstSymptom...*)
  END;
  RETURN Result;
 END {IsFileEditedInPanelOnly};

 PRIVATE PROCEDURE PreloadFormWindowForCurFile(curFile       : STRING[];
                                               WindowName    : STRING[];
                                               AddToFatedName: STRING[]): FORM_WINDOW;
  VAR
   Result: FORM_WINDOW;
 BEGIN
  SETEMPTY(Result);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=APP.Get().Forms(WindowName+AddToFatedName);
   IF ~!Result & ~!Result.ParentZone THEN
(* 㦥     稭, 㦭 㣮  뢠. ୮*)
    INC(AddToFatedName, ptcr_DirectAccess);
    Result:=APP.Get().Forms(WindowName+AddToFatedName);
   END;

   IF    !Result THEN
(*
   ࠧ  뢠. 㦭  (!) 㧨, ⮡  뫮 ஢ ਣ .
LoadBlank   -  믮 OnInitializeWindow, 䫠     ⠢,  
*)
    Result:=APP.Get().Forms.Load(WindowName, WindowName+AddToFatedName, EMPTYOF(FORM_ZONE));
   ELSIF ~!Result.ParentZone THEN
(*  㦥 . 㦭 , ⮡  뫮 䫨 ९稭 *)
    Result.Hide();
   END;
  EXCEPT
  ON Exc:Exc_Root DO
  END; (* TRY *)

  RETURN Result;
 END {PreloadFormWindowForCurFile};

 PRIVATE PROCEDURE GetFormWindowForCurFile(curFile       : STRING[];
                                           WindowName    : STRING[];
                                           AddToFatedName: STRING[]): FORM_WINDOW;
  VAR
   LendFile     : STRING[];
   Result,
   tmpFormWindow: FORM_WINDOW;
 BEGIN
  tmpFormWindow:=PreloadFormWindowForCurFile(curFile, WindowName, AddToFatedName);
  IF (WindowName = curFile)        &
     ~!TABLE.Get(curFile).LendLink &
     (!tmpFormWindow | IsFileEditedInPanelOnly(curFile, tmpFormWindow)) THEN
(* ࠫ ४⭮  -  ।஢ ᠬ curFile *)
   LendFile     :=TABLE.Get(curFile).LendLink.CooIndex.Table.Name;
   tmpFormWindow:=PreloadFormWindowForCurFile(LendFile, LendFile+"E", AddToFatedName);
  END;
  Result:=APP.Get().Forms.Load(tmpFormWindow.OriginalName, tmpFormWindow.AssignedName, EMPTYOF(FORM_ZONE));
  L_General.Assert(~!Result, " 㤠 ।   ⮡ࠦ 䠩 " + curFile);
  RETURN Result;
 END {GetFormWindowForCurFile};

 PRIVATE PROCEDURE ReloadCurFormWindow(curFormWindow : FORM_WINDOW; ParentZone: FORM_ZONE; Isolated: SCAL[2]): FORM_WINDOW;
  VAR
   Result: FORM_WINDOW;
 BEGIN
  Result         :=APP.Get().Forms.Load(curFormWindow.OriginalName, curFormWindow.AssignedName, ParentZone);
  Result.Isolated:=Isolated;
  RETURN Result;
 END {ReloadCurFormWindow};

 PRIVATE PROCEDURE DefineFormWindowsForPosToCurRecord(    curFile       : STRING[];
                                                          curWindowName : STRING[];
                                                          AddToFatedName: STRING[];
                                                          Isolated      : SCAL[2];
                                                      VAR curFormWindow : FORM_WINDOW;
                                                      VAR curZoneNumber : SCAL[99];
                                                      VAR mstFile       : STRING[];
                                                      VAR mstFormWindow : FORM_WINDOW;
                                                      VAR mstZoneNumber : SCAL[99]);
  VAR
   Dummy        : SCAL[2];
   tmpZone      : FORM_ZONE;
   mstWindowName: STRING[];
 BEGIN
  curFormWindow:=GetFormWindowForCurFile(curFile, curWindowName, AddToFatedName);

  IF curWindowName # curFormWindow.OriginalName THEN
(*﫨 㣮 , 祬 㪠  L_PWDO.pcr_SetDefaultWindowAndZone - 㦭 ।  *)
   SETEMPTY(curZoneNumber);
   FOR_EACH tmpZone IN curFormWindow.Zones DO
    IF ~tmpZone.Plane THEN
     IF tmpZone.MasterTable.Name = curFile THEN
      curZoneNumber:=tmpZone.Number;
      EXIT;
     END;
    END;
   END; (* FOR_EACH *)
   L_General.Assert(~!curZoneNumber, "  " + curFormWindow.Name + "    ⮡ࠦ 䠩 " + curFile);
  END;

  mstFile:=L_PWDO.prc_GetPseudoMasterFile(curFile);
  IF !mstFile THEN
   mstFile:=curFormWindow.MasterCursor.TABLE.Name;
  END;

  IF ViewInSingleWindow(curFile, mstFile, curFormWindow, curZoneNumber) THEN
   SETEMPTY(mstFile, mstFormWindow, mstZoneNumber);
   curFormWindow         :=ReloadCurFormWindow(curFormWindow, EMPTYOF(FORM_ZONE), Isolated);
  ELSE
   L_PWDO.pcr_PosOnMasterFile(curFile, mstFile);
   L_PWDO.pcr_SetDefaultWindowAndZone(mstFile, mstWindowName, mstZoneNumber, Dummy);
   mstFormWindow         :=APP.Get().Forms.Load(mstWindowName, mstWindowName+AddToFatedName, EMPTYOF(FORM_ZONE));
   mstFormWindow.Isolated:=Isolated;
   curFormWindow         :=ReloadCurFormWindow(curFormWindow, mstFormWindow.Zones(mstZoneNumber), 0);
  END;
 END {DefineFormWindowsForPosToCurRecord};

 PRIVATE PROCEDURE GetCurZoneParentZoneNumber(curZone: FORM_ZONE; File: STRING[]): NUMERIC[0];
  VAR
   Table : TABLE;
   Link  : LINK;
   Result: NUMERIC[0];
 BEGIN
  SETEMPTY(Result);
  IF ~!curZone.ParentZone & ~curZone.ParentZone.Plane THEN
   Table:=TABLE.Get(File);
   FOR_EACH Link IN Table.Links DO
    IF (Link.Kind = LINK.Kind_User) &
       (curZone.ParentZone.MasterTable.Name = Link.CooIndex.Table.Name) THEN
     Result:=curZone.ParentZone.Number;
     EXIT;
    END;
   END; (* FOR_EACH *)
  END;
  RETURN Result;
 END {GetCurZoneParentZoneNumber};

 PRIVATE PROCEDURE ViewInSingleWindow(curFile, mstFile: STRING[]; curFormWindow: FORM_WINDOW; curZoneNumber: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN (curFile = mstFile) | ~!GetCurZoneParentZoneNumber(curFormWindow.Zones(curZoneNumber), curFile);
 END {ViewInSingleWindow};

 PRIVATE PROCEDURE GetMstFile2CurFileLink(curFile, mstFile: STRING[]): LINK;
 BEGIN
  RETURN TABLE.Get(mstFile).Links(L_DBD.Get2FilesLinkName(mstFile, curFile));
 END {GetMstFile2CurFileLink};

 PRIVATE PROCEDURE ChangeselCurFile(curFile, mstFile: STRING[]; wExternalChangesel: SCAL[2]);
  VAR
   Link    : LINK;
   Index,
   cooIndex: INDEX;
   cooFile,
   Fields  : STRING[];
 BEGIN
  IF ~wExternalChangesel & ~!mstFile THEN
   Link:=GetMstFile2CurFileLink(curFile, mstFile);
   IF ~!Link THEN
    Index   :=Link.Index;
    cooIndex:=Link.CooIndex;
    Fields  :=L_DBD.GetPartialIndexFieldsName(cooIndex.Table.Name, cooIndex.Name, Math.Min(Index.Fields.Count, cooIndex.Fields.Count));
    CHANGESEL((cooIndex.Table.Name), (cooIndex.Name), , ^(Fields));
   END;
  END;
 END {ChangeselCurFile};

 PRIVATE PROCEDURE CreateViewLikeMenuOption(trgFormWindow: FORM_WINDOW; trgZoneNumber: SCAL[99]): STRING[];
  VAR
   Result       : STRING[];
   prnZoneNumber: SCAL[99];
 BEGIN
  Result:='View, "' + trgFormWindow.Name + ' ' + trgZoneNumber + '"';
  RETURN Result;
 END {CreateViewLikeMenuOption};

 PUBLIC PROCEDURE intPosToCurRecord(curFile, AddToFatedName, OptionAfter: STRING[]; Isolated: SCAL[2]);
  VAR
   prnZoneNumber,
   curZoneNumber,
   mstZoneNumber     : SCAL[99];
   mstFile,
   curWindowName,
   mstWindowName,
   LikeMenuOption    : STRING[];
   curFormWindow,
   mstFormWindow     : FORM_WINDOW;
   Dummy,
   wExternalChangesel: SCAL[2];
 BEGIN
  SETEMPTY(LikeMenuOption);
  IF ~!PROCREF(L_PCS.GetPrototype) THEN
   curFile:=L_PCS.GetPrototype(curFile);
  END;
  L_PWDO.pcr_SetDefaultWindowAndZone(curFile, curWindowName, curZoneNumber, wExternalChangesel);
  IF curWindowName = L_Prop.PropListWindowName THEN
   mstFile:=L_Prop.ObjectFileName(L_Prop.GetObjNum(curFile));
   CONFORM((curFile), (mstFile));
   TRY [TRANSACTION(TRANSACTION_SLAVE), ABORT_AFTER(AA_ON)]
    REPLACE((mstFile));
   EXCEPT
   ON Exc: Exc_Root DO
    IF Exc.ErrorCode = 36 THEN
     (*  ⠪,  쬨, ᯮᮡ, ⮡ ,    ।㥬 *)
     LikeMenuOption:='CALL, "ObjPro.ViewSpecific(' + "'" + mstFile + "'" + ')"';
    END;
   END;
   IF !LikeMenuOption THEN
    L_PWDO.pcr_SetDefaultWindowAndZone(mstFile, mstWindowName, mstZoneNumber, Dummy);
    mstFormWindow         :=APP.Get().Forms.Load(mstWindowName, mstWindowName + ptcr_DirectAccess, EMPTYOF(FORM_ZONE));
    mstFormWindow.Isolated:=Isolated;
    SetAllPosition(mstFormWindow, mstZoneNumber);
    LikeMenuOption:='View, "' + mstFormWindow.Name + ' ' + mstZoneNumber + '", ' +
                    'CALL, "ObjPro.extViewSpecific(' + "'" + mstFile + "'" + ', ' + ^(TABLE.Get(curFile).Fields("RECORDID").ObtainName())  + ')"';
   END;
  ELSE
   DefineFormWindowsForPosToCurRecord(curFile, curWindowName, AddToFatedName, Isolated,
                                      curFormWindow, curZoneNumber,
                                      mstFile,
                                      mstFormWindow, mstZoneNumber);

   IF !mstFormWindow THEN
    IF ~!GetCurZoneParentZoneNumber(curFormWindow.Zones(curZoneNumber), curFile) THEN
(*姮 *)
     ChangeselCurFile(curFile, mstFile, wExternalChangesel);
    END;
    SetAllPosition(curFormWindow, curZoneNumber);
    LikeMenuOption:=CreateViewLikeMenuOption(curFormWindow, curZoneNumber);
   ELSE
    SetAllPosition(mstFormWindow, mstZoneNumber);
    ChangeselCurFile(curFile, mstFile, wExternalChangesel);
    SetAllPosition(curFormWindow, curZoneNumber);

    LikeMenuOption:=CreateViewLikeMenuOption(mstFormWindow, mstZoneNumber);
    IF    IsWindowHasEditablePanel(curFile, curFormWindow) THEN
     LikeMenuOption:=LikeMenuOption + ',' +
                     'ShowWin, "' + curFormWindow.Name + ' 0",' +
                     'ShowWin, "' + '. '               + '#'+L_Str.IntStr(curZoneNumber)+'"';
    ELSIF !GetMstFile2CurFileLink(curFile, mstFile) THEN
     LikeMenuOption:=LikeMenuOption + ',' +
                     'View, "' + curFormWindow.Name + ' ' + curZoneNumber + ' ' + mstFormWindow.Name + ' ' + mstZoneNumber + '"';
    ELSE
     LikeMenuOption:=LikeMenuOption + ',' +
                     'View, "' + curFormWindow.Name + ' ' + curZoneNumber + '"';
    END;
   END;
  END;
  IF ~!OptionAfter THEN
   LikeMenuOption:=LikeMenuOption + ', ' + OptionAfter;
  END;
DEBUGBREAK();

  LIKEMENU(^LikeMenuOption);
 END {intPosToCurRecord};

 PUBLIC PROCEDURE PosToCurRecord(curFile, OptionAfter: STRING[]; Isolated: SCAL[2]);
 BEGIN
  intPosToCurRecord(curFile, "", OptionAfter, Isolated);
 END {PosToCurRecord};

 PUBLIC PROCEDURE StandOnDefaultPosition(curFile: STRING[]);
 BEGIN
  L_PWDO.StandOnDefaultPosition(curFile);
 END {StandOnDefaultPosition};

 PUBLIC PROCEDURE ViewFile(curFile, OptionAfter: STRING[]; Isolated: SCAL[2]);
 BEGIN
  IF ~OCCURE(^curFile) THEN
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   StandOnDefaultPosition(curFile);
  END;
  PosToCurRecord(curFile, OptionAfter, Isolated);
 END {ViewFile};

 PUBLIC PROCEDURE AddFilter(Filters: FORM_FILTERS; trgName, trgValue: STRING[]; trgStorable: SCAL[2]);
  VAR
   Filter: FORM_FILTER;
 BEGIN
  Filter:=Filters.Item(trgName);
  IF !Filter THEN
   Filter            :=FORM_FILTER.Create();
   Filter.Name       :=trgName;
   Filter.Value      :=trgValue;
   Filter.Description:=trgName;
   Filter.Storable   :=trgStorable;
   Filters.Add(Filter);
  ELSE
   Filter.Value      :=trgValue;
   Filter.Description:=trgName;
   Filter.Storable   :=trgStorable;
  END;
 END {AddFilter};

 PUBLIC PROCEDURE SoftRemoveFilter(Filters: FORM_FILTERS; trgName: STRING[]);
  VAR
   Filter: FORM_FILTER;
 BEGIN
  Filter:=Filters.Item(trgName);
  IF ~!Filter THEN
   Filters.Remove(Filter);
  END;
 END {AddFilter};

 PRIVATE PROCEDURE Encode_Filters(VAR Filters       : tFilters;
                                      trgName,
                                      trgValue      : STRING[];
                                      trgStorable   : SCAL[2]);
  VAR
   Filter: tFilter;
 BEGIN
  SETEMPTY(Filter);
  L_Prop.putRecordElement(Filter, trgName);
  L_Prop.putRecordElement(Filter, trgValue);
  L_Prop.putRecordElement(Filter, trgName);
  L_Prop.putRecordElement(Filter, trgStorable);
  L_Prop.putArrayItem(Filters, Filter);
 END {Encode_Filters};

 PUBLIC PROCEDURE PutNewFilter(VAR Filters       : tFilters;
                                   trgName,
                                   trgValue      : STRING[];
                                   trgStorable   : SCAL[2]);
 BEGIN
  Encode_Filters(Filters, trgName, trgValue, trgStorable);
 END {PutNewFilter};

 PRIVATE PROCEDURE GetNameField(File: STRING[]): FIELD;
 BEGIN
  RETURN TABLE.Get(File).Fields(L_PCS.GetNameFieldName(File));
 END {GetNameField};

 PUBLIC PROCEDURE CheckIsNonExistentProcException(Exc: Exc_Root);
 BEGIN
  IF    Exc.Class = "Exc_Syntax" THEN
   IF Exc.ErrorCode # L_General.ec_rt_UnknownIdentifier THEN
    RAISE();
   END;
  ELSIF Exc.Class = "Exc_RunTime" THEN
   IF Exc.ErrorCode # L_General.ec_rt_CantLoadModule THEN
    RAISE();
   END;
  ELSE
   RAISE();
  END;
 END {CheckIsNonExistentProcException};

 PUBLIC PROCEDURE CallProc_wParam(ProcName: STRING[]; VAR Param: VARIANT);
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   CALL(^ProcName(Param));
  EXCEPT
  ON Exc: Exc_Root DO
   CheckIsNonExistentProcException(Exc);
  END;
 END {CallProc_wParam};

 PUBLIC PROCEDURE CallProc_woParam(ProcName: STRING[]);
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   CALL(^ProcName());
  EXCEPT
  ON Exc: Exc_Root DO
   CheckIsNonExistentProcException(Exc);
  END;
 END {CallProc_woParam};

 PRIVATE PROCEDURE DefineZoneFilters(Zone: FORM_ZONE): STRING[];
  VAR
   Result: tFilters;
   File  : STRING[];
 BEGIN
  SETEMPTY(Result);
  File:=Zone.MasterTable.Name;
  IF ~!BuildValidityFilter(File) THEN
   PutNewFilter(Result, fn_CurDate_ExceptOld,                 extBuildValidityBEFilter(File, 0, 1), 1);
   PutNewFilter(Result, "騥   ⥪ ", BuildValidityFilter     (File),       1);
   PutNewFilter(Result, "騥   ᥣ",      extBuildValidityFilter  (File, 1),    1);
  END;
  IF ~!GetNameField(File) THEN
   PutNewFilter(Result, fn_MatchName,  "", 0);
  END;
  IF ~!Zone.ZLevProg THEN
   CallProc_wParam(Zone.ZLevProg + ".scs_GetFilters_" + Zone.Window.OriginalName + "_" + Zone.Number, Result);
  END;
  RETURN Result;
 END {DefineZoneFilters};

 PRIVATE PROCEDURE Decode_Filters(    Filters       : tFilters;
                                  VAR arrName,
                                      arrValue      : STRING[][];
                                  VAR arrStorable   : SCAL[2][]);
  VAR
   Filter         : tFilter;
   i              : NUMERIC[0];
   dmyDescription : STRING[];
 BEGIN
  SETEMPTY(arrName, arrValue, arrStorable);
  i:=0;
  WHILE (i < MaxFiltersCnt) & ~!L_Prop.getArrayItem(Filters, i) DO
   Filter          :=L_Prop.getArrayItem(Filters, i);
   arrName[i]      :=L_Prop.getRecordElement(Filter, 0);
   arrValue[i]     :=L_Prop.getRecordElement(Filter, 1);
   dmyDescription  :=L_Prop.getRecordElement(Filter, 2);
   arrStorable[i]  :=STRTOFLD(L_Prop.getRecordElement(Filter, 3), SCAL);
   INC(i);
  END;
 END {Decode_Filters};

 PUBLIC PROCEDURE OnInitializeZoneFilters();
  VAR
   Zone          : FORM_ZONE;
   arrName,
   arrValue      : STRING[][MaxFiltersCnt];
   arrStorable   : SCAL[2][MaxFiltersCnt];
   arrActive     : SCAL[2][MaxFiltersCnt];
   Filter        : FORM_FILTER;
   i             : NUMERIC[0];
   Find          : SCAL[2];
 BEGIN
  Zone:=RTI.Get().CurZone;
  Decode_Filters(DefineZoneFilters(Zone), arrName, arrValue, arrStorable);
  SETZERO(arrActive);
  FOR_EACH Filter IN Zone.Filters DO
   i:=0;
   LOOP
    IF (i = MaxFiltersCnt) | !arrName[i] THEN
     EXIT;
    ELSIF arrName[i] = Filter.Name THEN
     arrActive[i]:=1;
     EXIT;
    END;
    INC(i);
   END; (* LOOP *)
   Zone.Filters.Remove(Filter);
  END; (* FOR_EACH Filter ... *)
  i:=0;
  WHILE (i < MaxFiltersCnt) & ~!arrName[i] DO
   AddFilter(Zone.Filters, arrName[i], arrValue[i], arrStorable[i]);
   IF arrActive[i] THEN
    Zone.Filters.Item(arrName[i]).Active:=1;
   END;
   INC(i);
  END; (*WHILE i < ... *)
 END {OnInitializeZoneFilters};

 PRIVATE PROCEDURE scs_InitialAddingAllFilters(Zone: FORM_ZONE);
  VAR
   arrName,
   arrValue      : STRING[][MaxFiltersCnt];
   arrStorable   : SCAL[2][MaxFiltersCnt];
   i             : NUMERIC[0];
 BEGIN
  IF Zone.Filters.Count = 0 THEN
   Decode_Filters(DefineZoneFilters(Zone), arrName, arrValue, arrStorable);
   i:=0;
   WHILE (i < MaxFiltersCnt) & ~!arrName[i] DO
    AddFilter(Zone.Filters, arrName[i], arrValue[i], arrStorable[i]);
    INC(i);
   END; (*WHILE i ... *)
  END;
  IF ~!Zone.ZLevProg THEN
   CallProc_woParam(Zone.ZLevProg + ".scs_RenovateFilters_" + Zone.Window.OriginalName + "_" + Zone.Number);
  END;
 END {scs_InitialAddingAllFilters};

 PRIVATE PROCEDURE HasAnyActiveFilter(trgZone: FORM_ZONE): SCAL[2];
  VAR
   Filter: FORM_FILTER;
   Result: SCAL[2];
 BEGIN
  Result:=0;
  FOR_EACH Filter IN trgZone.Filters DO
   IF Filter.Active THEN
    Result:=1;
    EXIT;
   END;
  END; (* FOR_EACH Filter ... *)
  RETURN Result;
 END {HasAnyActiveFilter};

 PRIVATE PROCEDURE ConvertFilter(s: STRING[]): STRING[];
  VAR
   p: NUMERIC[0];
 BEGIN
  IF ~!s THEN
   s:=Str.Replace(s, "Memo.CurDate", "Memo.ud_cd()");
   IF L_Str.Char(s, 0) # "(" THEN
    s:="(" + s + ")";
   END;
   p:=Str.Pos(s, "=*");
   IF p < Str.Length(s) THEN
    s:="Str.Match(" + Str.Slice(s, 1, p - 1) + ", '" + Str.Slice(s, p + 2, Str.Length(s) - p - 3) + "')";
   END;
  END;
  RETURN s;
 END {ConvertFilter};

 PUBLIC PROCEDURE GetActiveFiltersCondtion(trgZone: FORM_ZONE): STRING[];
  VAR
   Result: STRING[];
   Filter: FORM_FILTER;
 BEGIN
  Result:=ConvertFilter(trgZone.PermanentFilter);
  IF trgZone.UserFilterIsActive THEN
   IF ~!Result THEN
    Result:=Result + "&";
   END;
   Result:=Result + ConvertFilter(trgZone.UserFilter);
  END;
  IF trgZone.Filters.Active THEN
   FOR_EACH Filter IN trgZone.Filters DO
    IF Filter.Active THEN
     IF ~!Result THEN
      Result:=Result + "&";
     END;
     Result:=Result + ConvertFilter(Filter.Value);
    END;
   END; (* FOR_EACH Filter *)
  END; (* IF trgZone.Filters.Active *)
  RETURN Result;
 END {GetActiveFiltersCondtion};

 PRIVATE PERMANENT VAR
  MatchFile,
  MatchSelectList  : STRING[];
  MatchSelectChoice: NUMERIC[0];

 PUBLIC PROCEDURE SetCustomSelectForm();
  CONST
   FiltersAmount   = 32;

   ln              = 60;

   r_OK            = 1;
   r_RemoveFilters = 2;
   r_ToggleFilters = 3;

  VAR
   FormStr,
   NarrowingProc,
   SelectList,
   File,
   NamePattern,
   ChoiceStr     : STRING[];
   MatchNameTitle: STRING[];
   SelectChoice,
   cnt,
   i, r          : NUMERIC[0];
   FilterNames   : STRING[][FiltersAmount];
   FilterActives : SCAL[2][FiltersAmount];
   Filter        : FORM_FILTER;
   Zone          : FORM_ZONE;
 BEGIN
  L_General.CallUs(~!RTI.Get().CurWindow);
  Zone:=RTI.Get().CurZone;
  File:=Zone.MasterTable.Name;
  scs_InitialAddingAllFilters(Zone);
  SETEMPTY(SelectList);
  IF ~!Zone.ZLevProg THEN
   CallProc_wParam(Zone.ZLevProg + ".scs_GetNarrowing_" + Zone.Window.OriginalName + "_" + Zone.Number, SelectList);
  END;
  IF ~!SelectList THEN
   SelectList:="|" + SelectList;
  END;
  IF VAR_IMPL.Get(MatchFile).Initialized       &
     VAR_IMPL.Get(MatchSelectList).Initialized &
     (MatchFile       = File)                  &
     (MatchSelectList = SelectList)            THEN
   SelectChoice:=MatchSelectChoice;
  ELSE
   SETZERO(SelectChoice);
  END;

  SETEMPTY(FilterNames, FilterActives, NamePattern);
  i:=0;
  FOR_EACH Filter IN Zone.Filters DO
   IF   Filter.Name = fn_MatchName THEN
    IF Filter.Active THEN
     NamePattern:=L_Str.RightFrom(Filter.Value, Str.Pos(Filter.Value, "=**")+3);
     NamePattern:=L_Str.Left(NamePattern, Str.Pos(NamePattern, "*"));
    END;
   ELSE
    FilterNames  [i]:=Filter.Name;
    FilterActives[i]:=Zone.Filters.Item(Filter.Name).Active;
    INC(i);
   END;
  END;

  SETEMPTY(ChoiceStr, FormStr);
  IF ~!SelectList THEN
   cnt:=L_Str.CntItemsInPool(SelectList);
   FormStr:=L_Str.AddStrDlm(FormStr, "|") + "%L" + L_Str.IntStr(ln) + "," + L_Str.IntStr(cnt) + "AO" +
            L_Str.Repeat("|", cnt);
   ChoiceStr:="SelectList, SelectChoice";
  END;

  i:=0;
  WHILE ~!FilterNames[i] DO
   FormStr:=L_Str.AddStrDlm(FormStr, "|") + "%" + L_Str.IntStr(ln) + "<" + FilterNames[i] + ">E";
   ChoiceStr:=L_Str.AddStrDlm(ChoiceStr, ",") + "FilterActives[" + L_Str.IntStr(i) + "]";
   INC(i);
  END; (* WHILE ~!FilterNames ... *)

  IF ~!Zone.Filters.Item(fn_MatchName) THEN
   IF Zone.Filters.Count > 1 THEN
    FormStr:=L_Str.AddStrDlm(FormStr, "|");
   END;
   MatchNameTitle:=" ⮫쪮  , 祭  '" + GetNameField(File).Description + "'  ᮤন:";
   FormStr:=L_Str.AddStrDlm(FormStr, "|") + "%L" + L_Str.IntStr(ln+6) + "AM";
   ChoiceStr:=L_Str.AddStrDlm(ChoiceStr, ",") + "MatchNameTitle";
   FormStr:=L_Str.AddStrDlm(FormStr, "|") + "%"  + L_Str.IntStr(ln+4) + "YI";
   ChoiceStr:=L_Str.AddStrDlm(ChoiceStr, ",") + "NamePattern";
  ELSIF !FilterNames[0] & ~!FormStr THEN
   FormStr:=Str.Slice(FormStr, 0, Str.Length(FormStr)-1);
  END;

  IF ~!FormStr THEN
   IF ~L_StdFrm.wGUI() THEN
    FormStr:="|" + FormStr + "|";
   END;
   FormStr:=FormStr + "|%C< 믮 >DB %C< ⮯! >Z";
   IF HasAnyActiveFilter(Zone) THEN
    IF Zone.Filters.Active THEN
     FormStr:=FormStr + " %< {} ⡮ >B %< {}몫 >B";
    ELSE
     FormStr:=FormStr + " %< {} ⡮ >B %< {} >B";
    END;
   ELSE
    FormStr:=FormStr + " %< {} ⡮ >B";
   END;
   LOOP
    r:=STDFORM(FormStr, " 롮 ᯥ樠쭮 ⡮ ", NONE, , ^(ChoiceStr));
    TRY
     NamePattern:=L_Str.CheckIllegalChars(NamePattern, ")*");
     EXIT;
    EXCEPT
    ON Exc: Exc_Raise DO
     L_StdFrm.RedInform(Exc.MsgOriginalText);
    END;
   END;
   IF    r = r_RemoveFilters THEN
    FOR_EACH Filter IN Zone.Filters DO
     Filter.Active:=0;
    END;
    SETZERO(SelectChoice);
   ELSIF r = r_ToggleFilters THEN
    Zone.Filters.Active:=~Zone.Filters.Active;
   ELSIF r = r_OK THEN
    i:=0;
    WHILE ~!FilterNames[i] DO
     Zone.Filters.Item(FilterNames[i]).Active:=FilterActives[i];
     INC(i);
    END; (* WHILE ... *)
    Filter:=Zone.Filters.Item(fn_MatchName);
    IF ~!Filter THEN
     Filter.Value :="(" + GetNameField(File).ObtainName() +  "=**" + NamePattern + "*)";
     Filter.Active:=~!NamePattern;
    END;
    Zone.Filters.Active:=1;
   END; (* IF r = r_RemoveFilters ... *)
  END;
  MatchFile        :=File;
  MatchSelectList  :=SelectList;
  MatchSelectChoice:=SelectChoice;

  IF ~!SelectList THEN
   CALL(^(Zone.ZLevProg + ".scs_SetNarrowing_" + Zone.Window.OriginalName + "_" + Zone.Number + "(SelectChoice)"));
   IF    SelectChoice = 0 THEN
    SE_WZD_CURSOR(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number);
   ELSIF OCCURE(^(File)) THEN
    Zone.Filters.Active:=0;
    SE_WZD_CURSOR(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number, ^File);
    Zone.Filters.Active:=1;
   ELSE
    L_StdFrm.Inform("祣 室饣!");
   END;
  ELSIF Zone.Filters.Count <= 0 THEN
   L_StdFrm.BlueHalt("  ।ᬮ७ ⠭ ᯥ樠쭮 ⡮." +
                     L_StdFrm.HR() +
                     ",   訬 ﬨ  ");
  END;
 END {SetCustomSelectForm};

 PUBLIC PROCEDURE ToggleFilter();
  VAR
   curZone: FORM_ZONE;
 BEGIN
  curZone:=RTI.Get().CurZone;
  IF HasAnyActiveFilter(curZone) THEN
   curZone.Filters.Active:=~curZone.Filters.Active;
  ELSE
   SetCustomSelectForm();
  END;
 END {ToggleFilter};

 PRIVATE PROCEDURE iInitAll(Z: FORM_ZONE);
  VAR
   F: FORM_FIELD;
 BEGIN
IF ~L_General.IsAcceptableProcessorVersion(14199091) THEN
  SETZERO(Z.OnBeforeEdit, Z.OnAfterEdit, Z.OnBeforeInsert, Z.OnAfterInsert, Z.OnBeforeDelete, Z.OnAfterDelete,
          Z.OnReposition, Z.OnOpenZone, Z.OnChangeIndex, Z.OnSetSubwindow,
          Z.ViewOnly);
(*
  SETEMPTY(Z.SubwindowOriginalName, Z.Narrowing, Z.PermanentFilter, Z.HierarchicLink);
*)
  SETEMPTY(Z.SubwindowOriginalName, Z.Narrowing, Z.PermanentFilter);
  FOR_EACH F IN Z.Fields DO
   F.OnSuccessfulChange:=0;
   F.MustBeNonempty    :=1;
   F.Modifiable        :=1;
   F.Last              :=0;
   F.First             :=0;
   F.First             :=0;
   F.LineBreakEnable   :=0;
   F.OnBeforeAsk       :=0;
   F.AskMode           :=0;
   F.ReverseSorting    :=0;
   F.Hierarchic        :=0;
   SETEMPTY(F.OwnerWindowOriginalName, F.OwnerZoneNumber);
  END;
END;
 END {iInitAll};

 PRIVATE PROCEDURE iSetupProg(Z: FORM_ZONE; VAR ProgName: STRING[]);
 BEGIN
  IF ~!Z.MasterTable THEN
   ProgName:=Z.MasterTable.Name;
  ELSE
   ProgName:="MustBeReplaced";
  END;
 END {iSetupProg};

 PUBLIC PROCEDURE iWindow(): FORM_WINDOW;
 BEGIN
  RETURN RTI.Get().CurWindow;
 END {iWindow};

 PUBLIC PROCEDURE iZone(ZoneNumber: NUMERIC[0]): FORM_ZONE;
 BEGIN
  RETURN RTI.Get().CurWindow.Zones(ZoneNumber);
 END {iZone};

 PUBLIC PROCEDURE iField(ZoneNumber: NUMERIC[0]; Name: STRING[]): FORM_FIELD;
 BEGIN
  RETURN RTI.Get().CurWindow.Zones(ZoneNumber).Fields(Name);
 END {iField};

 PUBLIC PROCEDURE iScsChange(ZoneNumber: NUMERIC[0]; FieldNames: STRING[][]);
  VAR
   Z: FORM_ZONE;
   F: STRING[];
 BEGIN
  Z:=RTI.Get().CurWindow.Zones(ZoneNumber);
  FOR_EACH F IN FieldNames DO
   Z.Fields(F).OnSuccessfulChange:=1;
  END;
  iSetupProg(Z, Z.FLevProg)
 END {iScsChange};

 PUBLIC PROCEDURE iUnmodifiable(ZoneNumber: NUMERIC[0]; FieldNames: STRING[][]);
  VAR
   Z: FORM_ZONE;
   N: STRING[];
 BEGIN
  Z:=RTI.Get().CurWindow.Zones(ZoneNumber);
  FOR_EACH N IN FieldNames DO
   Z.Fields(N).Modifiable:=0;
  END;
 END {iUnmodifiable};

 PUBLIC PROCEDURE iModifiable(ZoneNumber: NUMERIC[0]; FieldNames: STRING[][]);
  VAR
   Z: FORM_ZONE;
   F: FORM_FIELD;
   N: STRING[];
 BEGIN
  Z:=RTI.Get().CurWindow.Zones(ZoneNumber);
  FOR_EACH F IN Z.Fields DO
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
    F.Modifiable:=0;
   EXCEPT
   ON Exc: Exc_Root DO
    IF (Exc.ErrorCode # 144) & (Exc.ErrorCode # 978) THEN
     RAISE();
    END;
   END; (* TRY *)
  END;
  FOR_EACH N IN FieldNames DO
   Z.Fields(N).Modifiable:=1;
  END;
 END {iModifiable};

 PUBLIC PROCEDURE iMayBeEmpty(ZoneNumber: NUMERIC[0]; FieldNames: STRING[][]);
  VAR
   Z: FORM_ZONE;
   F: STRING[];
 BEGIN
  Z:=RTI.Get().CurWindow.Zones(ZoneNumber);
  FOR_EACH F IN FieldNames DO
   Z.Fields(F).MustBeNonempty:=0;
  END;
 END {iMayBeEmpty};

 PUBLIC PROCEDURE iEvents(ZoneNumber: NUMERIC[0]; EventNames: STRING[][]);
  VAR
   Z: FORM_ZONE;
   E: STRING[];
 BEGIN
  Z:=RTI.Get().CurWindow.Zones(ZoneNumber);
  iInitAll(Z);
  FOR_EACH E IN EventNames DO
   IF    E = e_OnAnyModification THEN
    Z.OnBeforeEdit  :=1;
    Z.OnAfterEdit   :=1;
    Z.OnBeforeInsert:=1;
    Z.OnAfterInsert :=1;
    Z.OnBeforeDelete:=1;
   ELSIF E = e_OnAfterMdf THEN
    Z.OnAfterEdit   :=1;
    Z.OnAfterInsert :=1;
    Z.OnBeforeDelete:=1;
   ELSIF E = e_OnBeforeEdit   THEN Z.OnBeforeEdit  :=1;
   ELSIF E = e_OnAfterEdit    THEN Z.OnAfterEdit   :=1;
   ELSIF E = e_OnBeforeInsert THEN Z.OnBeforeInsert:=1;
   ELSIF E = e_OnAfterInsert  THEN Z.OnAfterInsert :=1;
   ELSIF E = e_OnBeforeDelete THEN Z.OnBeforeDelete:=1;
   ELSIF E = e_OnAfterDelete  THEN Z.OnAfterDelete :=1;
   ELSIF E = e_OnReposition   THEN Z.OnReposition  :=1;
   ELSIF E = e_OnOpenZone     THEN Z.OnOpenZone    :=1;
   ELSIF E = e_OnChangeIndex  THEN Z.OnChangeIndex :=1;
   ELSIF E = e_OnSetSubwindow THEN Z.OnSetSubwindow:=1;
   ELSE
    L_General.CallUs(0);
   END;
  END;
  IF Z.OnBeforeEdit | Z.OnAfterEdit | Z.OnBeforeInsert | Z.OnAfterInsert | Z.OnBeforeDelete | Z.OnReposition THEN
   iSetupProg(Z, Z.RLevProg)
  END;
  IF Z.OnOpenZone | Z.OnChangeIndex | Z.OnSetSubwindow THEN
   iSetupProg(Z, Z.ZLevProg)
  END;
 END {iEvents};

 PUBLIC PROCEDURE iProgs(ZoneNumber: NUMERIC[0]; Name: STRING[]);
  VAR
   Z: FORM_ZONE;
 BEGIN
  Z:=RTI.Get().CurWindow.Zones(ZoneNumber);
  IF ~!Z.RLevProg THEN Z.RLevProg:=Name; END;
  IF ~!Z.ZLevProg THEN Z.ZLevProg:=Name; END;
  IF ~!Z.FLevProg THEN Z.FLevProg:=Name; END;
 END {iProgs};

 PUBLIC PROCEDURE iSubwindow(ZoneNumber: NUMERIC[0]; Name: STRING[]);
 BEGIN
  RTI.Get().CurWindow.Zones(ZoneNumber).SubwindowOriginalName:=Name;
 END {iSubwindow};

 PUBLIC PROCEDURE iFieldAskMode(ZoneNumber        : NUMERIC[0];
                                FieldName         : STRING[];
                                trgAskMode        : SCAL[2];
                                trgOwnerWindowName: STRING[];
                                trgOwnerZoneNumber: SCAL[10]);
  VAR
   F: FORM_FIELD;
 BEGIN
  F:=RTI.Get().CurWindow.Zones(ZoneNumber).Fields(FieldName);
  F.AskMode                :=trgAskMode;
  F.OwnerWindowOriginalName:=trgOwnerWindowName;
  F.OwnerZoneNumber        :=trgOwnerZoneNumber;
 END {iFieldAskMode};

 PUBLIC PROCEDURE cField(Name: STRING[]): FORM_FIELD;
 BEGIN
  RETURN RTI.Get().CurZone.Fields(Name);
 END {cField};

 PUBLIC PROCEDURE GetRelatedWindow(curW: FORM_WINDOW; trgOriginalName: STRING[]): FORM_WINDOW;
 BEGIN
  WHILE ~!curW & (curW.OriginalName # trgOriginalName) DO
   curW:=curW.ParentZone.Window;
  END;
  RETURN curW;
 END {GetRelatedWindow};

 PUBLIC PROCEDURE MultiWindowsModification(Window: STRING[]);
 BEGIN
  LIKEMENU(Edit, Window + " 0 " + MWM + "=");
 END {MultiWindowsModification};

 PRIVATE CONST
  InsertionSourceVarName = "InsertionSourceVarNameValue";
 
 PUBLIC PROCEDURE GetInsertionSource(): STRING[];
 BEGIN
  RETURN GetEnvVarValue(InsertionSourceVarName);
 END {GetInsertionSource};
 
 PUBLIC PROCEDURE LaunchInsertBySource(srcValue, addParams: STRING[]);
 BEGIN
  LIKEMENU(Ins, "@ " + InsertionSourceVarName + "=" + srcValue + addParams);
 END {LaunchInsertBySource};

 PUBLIC PROCEDURE IamInModification(): SCAL[2];
  VAR
   z: FORM_ZONE;
   p: FORM_PROCESS;
 BEGIN
  z:=RTI.Get().CurZone;
  WHILE ~!z DO
   FOR_EACH p IN z.Processes DO
    IF (p.Kind = FORM_PROCESS.Kind_Edit) | (p.Kind = FORM_PROCESS.Kind_Insert) THEN
     RETURN 1;
    END;
   END; (* FOR_EACH *)
   z:=z.ParentZone;
  END;
  RETURN 0;
 END {IamInModification};

END.
