(*
%Copyright   (c) Polak IT
%Author      14.02.2008 16:06:51 POLAK\GAV
%Purpose
%Type        Library
%Specific    SYS
%Modified    08.05.2013 16:32:35 POLAK\GAV
%Environment
*)

 MODULE L_WME301 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Math, L_StdFrm, FIO, Shell, Str, L_Str, Math, L_DatTim, L_MSComm, L_Meter;

 PRIVATE CONST
  DEBUG_PUT_IN_LOG = 0;

  SOH  = CHR(1);
  STX  = CHR(2);
  ETX  = CHR(3);
  ASK  = CHR(6);

  _Timeout = 0.3;
  Delay = 0.001;

  ms_Yes = -1;

 PRIVATE VAR
  com                       : OBJECT;
  _।筮᫮        : NUMERIC[0];
  _樥⓬     : NUMERIC[0];
  _魮쏮ᮢ_Date : DATE;
  _魮쏮ᮢ_Value: STRING[];

  badGetCount: NUMERIC[0];

 PRIVATE PROCEDURE SetCommState(com: OBJECT);
 BEGIN
  L_MSComm.SetDefaultCommState(com, L_Str.IntStr(L_Meter.InitialBaudRate(Meter.Meter)) + ",e,7,1");
  com.DTREnable:=ms_Yes;
 END {SetCommState};

 PRIVATE PROCEDURE _PutInLog(Msg: STRING[]);
  CONST
   Filename = "TXT\wme301.log";
  VAR
   NormalOpenFile: SCAL[2];
 BEGIN
  IF DEBUG_PUT_IN_LOG THEN
   TRY [MSGSUPPRESSIONMODE(MSGSUPPRESS_ALL)]
    NormalOpenFile:=0;
    IF ~FIO.Exists(Filename) THEN
     FIO.Open(L, Filename, , Create);
     NormalOpenFile:=1;
    ELSE
     FIO.Open(L, Filename, , Append);
     NormalOpenFile:=1;
    END;
 
    FIO.WrStr(L, "*** " + L_DatTim.CompleteSystimeStr() + " *** ");
    FIO.WrStr(L, Msg);
    FIO.WrLn(L);
   EXCEPT
   ELSE
   END; (* TRY *)
 
   IF NormalOpenFile THEN
    FIO.Close(L);
   END;
  END;
 END {_PutInLog};

 PRIVATE PROCEDURE _Assert(Cond: SCAL[2]; Msg: STRING[]);
 BEGIN
  IF ~Cond THEN
   _PutInLog(Msg);
   L_General.Error(Msg);
  END;
 END {_Assert};

 PRIVATE PROCEDURE GetData(MSComm: OBJECT; Prefix, Suffix: STRING[]): STRING[];
  VAR
   i,
   j,
   SuffixLen,
   PrefixLen,
   Byte,
   _BCC      : NUMERIC[0];
   Timeout   : FLOAT;
   Answer    : STRING[];
   _Answer   : NUMERIC[0][10000];
 BEGIN
  MSComm.RTSEnable:=0;
  MSComm.InputLen :=0;
  SuffixLen       :=Str.Length(Suffix);
  PrefixLen       :=Str.Length(Prefix);
  _BCC            :=0;
  Answer          :="";
  i               :=0;
  WHILE (i < SuffixLen) | ~Str.Match(Str.Slice(Answer, i - SuffixLen, SuffixLen), Suffix) DO
   Timeout:=_Timeout;
   WHILE (MSComm.InBufferCount = 0) & (Timeout > 0) DO
    SLEEP(Delay);
    DEC(Timeout, Delay);
   END;
   _Assert(MSComm.InBufferCount > 0, "饭  祭");
   j:=0;
   _Answer:=MSComm.Input;
   WHILE ~!_Answer[j] DO
    Byte  :=_Answer[j];
    IF Byte=0 THEN
     Byte:=128;
    END;
    INC(i);
    INC(j);
    Answer:=Answer + CHR(Byte);
    IF i > PrefixLen THEN
     INC(_BCC, Byte);
    END;
   END;
  END;
  _PutInLog(">" + Answer);
  _Assert(Str.Slice(Answer, 0, PrefixLen) = Prefix, "饭  ᨬ, ⫨  ᨬ 䨪"); (*STX ("+L_Str.IntStr(ORD(STX))+")" *)
  IF Suffix = ETX + "?" THEN
   Byte:=(ORD(Str.Slice(Answer, i - 1, 1))) MOD 128;
   _BCC:=(_BCC-Byte) MOD 128;
   _Assert(_BCC = Byte, "ᮢ ஢筮 ᨬ  (BCC): ᫥ - " + L_Str.IntStr(_BCC) +
                        ";   - " + L_Str.IntStr(Byte));
  END;
  RETURN Str.Slice(Answer, PrefixLen, i - SuffixLen - PrefixLen);
 END {GetData};

 PRIVATE PROCEDURE PutS(MSComm: OBJECT; s: STRING[]);
  VAR
   i: NUMERIC[0];
   Request: NUMERIC[0][1000];
   Timeout: FLOAT;
 BEGIN
  _PutInLog("<" + s);
  SETEMPTY(Request);
  i:=0;
  WHILE i < Str.Length(s) DO
   Request[i]:=ORD(Str.Slice(s, i, 1));
   INC(i);
  END;
  IF (i > 0) & (Request[i-1] = 128) THEN
   Request[i-1]:=0;
  END;
  MSComm.RTSEnable:=ms_Yes;
  SLEEP(0.014); (* প  ࠢ RTS  砫 ।  *)
  MSComm.Output:=CreateSAFEARRAY(Byte, Request, 1, i);
  Timeout:=Str.Length(s) * 8 / 300 + 0.03 + 0.005 * badGetCount;
  _PutInLog("Waiting CTS, timeout " + FLDTOSTR(Timeout));
  WHILE (MSComm.CTSHolding # ms_Yes) & (Timeout > 0) DO
   SLEEP(Delay);
   DEC(Timeout, Delay);
  END;
  _PutInLog("CTS Held, timeout " + FLDTOSTR(Timeout));
 END {PutS};

 PRIVATE PROCEDURE PutData(MSComm: OBJECT; s, Prefix, Suffix: STRING[]);
  VAR
   i,
   _BCC: NUMERIC[0];
   t   : STRING[];
 BEGIN
  _BCC:=0;
  t   :=s + Suffix;
  i   :=0;
  WHILE i < Str.Length(t) DO
   INC(_BCC, ORD(Str.Slice(t, i, 1)));
   INC(i);
  END;
  _BCC:=_BCC MOD 128;
  IF _BCC = 0 THEN
   _BCC:=128;
  END;
  PutS(MSComm, Prefix + t + CHR(_BCC));
 END {PutData};

 PRIVATE PROCEDURE GetLine(MSComm: OBJECT): STRING[];
 BEGIN
  RETURN GetData(MSComm, "/", L_Str.CRLF);
 END {GetLine};

 PRIVATE PROCEDURE GetMessage(MSComm: OBJECT; Prefix: STRING[]): STRING[];
 BEGIN
  RETURN GetData(MSComm, Prefix, ETX + "?");
 END {GetMessage};

 PRIVATE PROCEDURE PutMessage(MSComm: OBJECT; s: STRING[]);
 BEGIN
  PutData(MSComm, s, SOH, ETX);
(*  ASL !!!
  RETURN PutData(MSComm, SOH, ETX);
*)
 END {PutMessage};

 PRIVATE PROCEDURE BaudRateSignToValue(BaudRateSign: STRING[1]): NUMERIC[0];
 BEGIN
  IF    BaudRateSign = "0" THEN RETURN 300;
  ELSIF BaudRateSign = "1" THEN RETURN 600;
  ELSIF BaudRateSign = "2" THEN RETURN 1200;
  ELSIF BaudRateSign = "3" THEN RETURN 2400;
  ELSIF BaudRateSign = "4" THEN RETURN 4800;
  ELSIF BaudRateSign = "5" THEN RETURN 9600;
  ELSIF BaudRateSign = "6" THEN RETURN 19200;
  ELSIF BaudRateSign = "7" THEN RETURN 38400;
  ELSE
   L_General.Error("⭮ 祭 ࠬ ᪮  "+BaudRateSign);
  END;
 END {BaudRateSignToValue};

 PRIVATE PROCEDURE BaudRateValueToSign(BaudRate: NUMERIC[0]): STRING[];
 BEGIN
  IF    BaudRate = 300   THEN RETURN "0";
  ELSIF BaudRate = 600   THEN RETURN "1";
  ELSIF BaudRate = 1200  THEN RETURN "2";
  ELSIF BaudRate = 2400  THEN RETURN "3";
  ELSIF BaudRate = 4800  THEN RETURN "4";
  ELSIF BaudRate = 9600  THEN RETURN "5";
  ELSIF BaudRate = 19200 THEN RETURN "6";
  ELSIF BaudRate = 38400 THEN RETURN "7";
  ELSE
   L_General.Error("⭮ 祭 ᪮  "+L_Str.IntStr(BaudRate));
  END;
 END {BaudRateValueToSign};

 PUBLIC PROCEDURE IsOpen(): SCAL[2];
 BEGIN
  RETURN L_General.OBJECTIsInitialized(com) & ~!com;
 END {IsOpen};

 PUBLIC PROCEDURE Open(_COMPort: NUMERIC[0]);
  CONST
   _InBufferSize = 1024;
  VAR
   s        : STRING[];
   val,
   _BaudRate: NUMERIC[0];
 BEGIN
  badGetCount:=0;

  _PutInLog("*** OPEN ***");

  L_General.Assert(~IsOpen(), "뢠 稪  뢠 ।饣");
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   com:=L_MSComm.CreateMSComm();
   SetCommState(com);
   com.CommPort    :=_COMPort;
   com.InBufferSize:=_InBufferSize;
   com.PortOpen:=-1;
  EXCEPT
  ON Exc: Exc_Root DO
   IF Exc.Class = "Exc_Object" THEN
    L_General.Error(" 㤠  .||ଠ  訡:|" + Exc.MsgOriginalText);
   ELSE
    L_General.Error(" 㤠  .||ଠ  訡:|" +
                    L_Str.IntStr(Exc.ErrorCode) + " " + Exc.MsgOriginalText);
   END;
  END;
  PutS(com, "/?" + Meter.Meter + "!" + L_Str.CRLF);
  s:=GetLine(com);
  L_General.Assert(Str.Match(s, "EKT?CE301v?") | Str.Match(s, "EKT?CE301v??"),
                   "⢥ ன⢠  ᮮ⢥ 蠡 ("+s+")");
  _BaudRate:=BaudRateSignToValue(Str.Slice(s, 3, 1));
(* 砫 ࠡ, ⠭ max ᪮  *)
  PutS(com, ASK + "0" + BaudRateValueToSign(_BaudRate) + "1" + L_Str.CRLF);
  SLEEP(0.2);
  L_MSComm.SetBaudRate(com, _BaudRate);
(* ⢥ - 䨪 稪 *)
  s:=GetMessage(com, SOH);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   val:=STRTOFLD(Str.Item(s, "()", 1), NUMERIC);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_FailedSTRTOFLD THEN
    Close();
    L_General.Error("稪  ஢ ");
   ELSE
    RAISE();
   END;
  END;
  L_General.Assert(GetNumVal("TAVER", "") = 30, " 稪 ⠭ ࢠ ।  30 ");
  SETEMPTY(_樥⓬, _।筮᫮, _魮쏮ᮢ_Date);
 END {Open};

 PUBLIC PROCEDURE Close();
 BEGIN
  PutMessage(com, "B0");
  com.PortOpen:=0;
  SETEMPTY(com);
_PutInLog("*** CLOSE ***");
 END {Close};

 PUBLIC PROCEDURE Abort();
 BEGIN
  L_General.ConsultToUs(IsOpen(), "୮ ਬ L_WME301.Abort");
  IF com.PortOpen THEN
   PutMessage(com, "B0");
   com.PortOpen:=0;
  END;
  SETEMPTY(com);
_PutInLog("*** ABORT ***");
 END {Abort};

 PRIVATE PROCEDURE GetStr(Func, Param: STRING[]): STRING[];
  VAR
   s: STRING[];
 BEGIN
  badGetCount:=1;
  LOOP
   TRY
    PutMessage(com, "R1"+STX+Func+"("+Param+")");
    s:=GetMessage(com, STX);
    IF Str.Length(s)=0 THEN
     RETURN "";
    ELSE
     RETURN L_Str.RightFrom(s, Str.Length(Func));
    END;
   EXCEPT
   ELSE
   INC(badGetCount);
   IF badGetCount > 7 THEN
    RAISE();
   END;
   END;
  END;
 END {GetStr};

 PRIVATE PROCEDURE GetStrVal(Func, Param: STRING[]): STRING[];
 BEGIN
  RETURN Str.Item(GetStr(Func, Param), "()", 0);
 END {GetStrVal};

 PRIVATE PROCEDURE GetNumVal(Func, Param: STRING[]): FLOAT;
  VAR
   s     : STRING[];
   Result: FLOAT;
 BEGIN
  s:=GetStrVal(Func, Param);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=STRTOFLD(s, FLOAT);
  EXCEPT
  END;
  RETURN Result;
 END {GetNumVal};

 PUBLIC PROCEDURE 樥⓬(): NUMERIC[0];
 BEGIN
  IF !_樥⓬ THEN
   (* 樥 ࠭ଠ樨 ⮪ * 樥 ࠭ଠ樨 殮 *)
   _樥⓬:=GetNumVal("FCCUR", "") * GetNumVal("FCVOL", "");
  END;
  RETURN _樥⓬;
 END {樥⓬};

 PUBLIC PROCEDURE ᪨(): STRING[];
 BEGIN
  RETURN GetStrVal("IDPAS", "");
 END {᪨};

 PUBLIC PROCEDURE ᪮(): STRING[];
 BEGIN
  RETURN GetStrVal("SNUMB", "");
 END {᪮};

 PUBLIC PROCEDURE ⠂६(): TIMESTAMP;
  VAR
   DateStr,
   TimeStr : STRING[];
   Result  : TIMESTAMP;
 BEGIN
  DateStr:=Str.Slice(GetStrVal("DATE_", ""), 3, 8);
  TimeStr:=GetStrVal("TIME_", "");
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=PackTIMESTAMP(STRTOFLD(DateStr, DATE, "D.N.Y"),
                         STRTOFLD(Str.Slice(TimeStr, 0, 5), TIME, "H:M"),
                         STRTOFLD(Str.Slice(TimeStr, 6, 2), NUMERIC));
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {⠂६};

 PUBLIC PROCEDURE 魮(): NUMERIC[4];
 BEGIN
  RETURN GetNumVal("PAVEP", "");
 END {魮};

 PUBLIC PROCEDURE 魮쏮ᮢ(_Date: DATE; _Time: TIME): NUMERIC[4];
  VAR
   Result: NUMERIC[4];
 BEGIN
  IF _Date # _魮쏮ᮢ_Date THEN
   _魮쏮ᮢ_Value:=GetStr("GRAPE", FLDTOSTR(_Date, "D.N.Y"));
   _魮쏮ᮢ_Date :=_Date;
  END;
(*  祭!
  L_General.CallUs(⠂६() - L_DatTim.GetVARIANTDATE(_Date, _Time, 0) - 30/60/24 > 0);
*)
  (*, ..  饬 砥 MtrRdout  易 , 㬠,   Consult *)
  L_General.CallUs(L_DatTim.GetSysVARIANTDATE() + MtrRdout.TimDelta - L_DatTim.GetVARIANTDATE(_Date, _Time, 0) - 30/60/24 > 0);

  IF Str.Length(_魮쏮ᮢ_Value) = 0 THEN
   Result:=0;
  ELSE
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    Result:=STRTOFLD(Str.Item(_魮쏮ᮢ_Value, "()" + L_Str.CRLF, (_Time - 00:00) * 2), NUMERIC);
   EXCEPT
   END; (* TRY *)
  END;
  RETURN Result;
 END {魮쏮ᮢ};

 PRIVATE PROCEDURE EnergyOnDayEnd(TNmbr: NUMERIC[0]; d: DATE): NUMERIC[4];
 BEGIN
  RETURN GetNumVal("ENDPE", FLDTOSTR(d, "D.N.Y") + "." + L_Str.IntStr(TNmbr+1))
 END {EnergyOnDayEnd};

 PRIVATE PROCEDURE EnergyOnMonthEnd(TNmbr: NUMERIC[0]; Month: DATE): NUMERIC[4];
 BEGIN
  RETURN GetNumVal("ENMPE", FLDTOSTR(Month, "N.Y") + ".0." + L_Str.IntStr(TNmbr+1))
 END {EnergyOnMonthEnd};

 PUBLIC PROCEDURE ࣨ砫(TNmbr: NUMERIC[0]; MonthBeg, sysMonth: DATE): NUMERIC[4];
  VAR
   Month : DATE;
   Result: NUMERIC[4];
 BEGIN
  Month :=L_DatTim.IncMonth(MonthBeg, -1);
  Result:=EnergyOnMonthEnd(TNmbr, Month);
  WHILE !Result & (sysMonth - Month < 365*2) DO
   Month :=L_DatTim.IncMonth(Month, -1);
   PROMPT(L_DatTim.DateStr(Month));
   Result:=EnergyOnMonthEnd(TNmbr, Month);
  END;
  RETURN Result;
 END {ࣨ砫};

 PUBLIC PROCEDURE ࣨ砫⮪(TNmbr: NUMERIC[0]; d, sysdate: DATE): NUMERIC[4];
  VAR
   Result: NUMERIC[4];
 BEGIN
  Result:=EnergyOnDayEnd(TNmbr, d-1);
  IF !Result THEN
   APP.Get().NewPrompt("   " + L_DatTim.DateStr(d) + ".  । ");
   WHILE !Result & (sysdate - d < 365*2) DO
    PROMPT(L_DatTim.DateStr(d));
    IF d = L_DatTim.MonthBeg(d) THEN
     d     :=L_DatTim.IncMonth(d, -1);
     Result:=EnergyOnMonthEnd(TNmbr, d);
    ELSE
     DEC(d);
     Result:=EnergyOnDayEnd(TNmbr, d);
    END;
   END;
  END;
  RETURN Result;
 END {ࣨ砫⮪};

 PUBLIC PROCEDURE ࣨ(TNmbr: NUMERIC[0]): NUMERIC[4];
  VAR
   s     : STRING[];
   Result: NUMERIC[4];
 BEGIN
  s:=Str.Item(GetStr("ET0PE", ""), "()" + L_Str.CRLF, TNmbr);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=STRTOFLD(s, NUMERIC);
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {ࣨ};

END.