(*
%Copyright   (c) Polak IT
%Author      01.12.2007 11:21:44 POLAK\MOG
%Purpose
%Type        library
%Specific    SYS
%Modified    23.06.2014 15:31:43 POLAK\GAV
%Environment
*)

 MODULE L_WMEnergomera [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_MSComm, L_Math, L_StdFrm, FIO, Shell, Str, L_Str, L_DatTim;

 PRIVATE CONST
  DEBUG_PUT_IN_LOG = 1;

  T_6827M1 = 0;
  T_6822   = 16;
  T_6827M  = 32;

  _InBufferSize = 1024;

  _CRCTable = "/00/b5/df/6a/0b/be/d4/61/16/a3/c9/7c/1d/a8/c2/77/2c/99/f3/46/27/92/f8/4d/3a/8f/e5/50/31/84/ee/5b"+
              "/58/ed/87/32/53/e6/8c/39/4e/fb/91/24/45/f0/9a/2f/74/c1/ab/1e/7f/ca/a0/15/62/d7/bd/08/69/dc/b6/03"+
              "/b0/05/6f/da/bb/0e/64/d1/a6/13/79/cc/ad/18/72/c7/9c/29/43/f6/97/22/48/fd/8a/3f/55/e0/81/34/5e/eb"+
              "/e8/5d/37/82/e3/56/3c/89/fe/4b/21/94/f5/40/2a/9f/c4/71/1b/ae/cf/7a/10/a5/d2/67/0d/b8/d9/6c/06/b3"+
              "/d5/60/0a/bf/de/6b/01/b4/c3/76/1c/a9/c8/7d/17/a2/f9/4c/26/93/f2/47/2d/98/ef/5a/30/85/e4/51/3b/8e"+
              "/8d/38/52/e7/86/33/59/ec/9b/2e/44/f1/90/25/4f/fa/a1/14/7e/cb/aa/1f/75/c0/b7/02/68/dd/bc/09/63/d6"+
              "/65/d0/ba/0f/6e/db/b1/04/73/c6/ac/19/78/cd/a7/12/49/fc/96/23/42/f7/9d/28/5f/ea/80/35/54/e1/8b/3e"+
              "/3d/88/e2/57/36/83/e9/5c/2b/9e/f4/41/20/95/ff/4a/11/a4/ce/7b/1a/af/c5/70/07/b2/d8/6d/0c/b9/d3/66";

  M_6822 = "6822 1,0 220 5-50 3.4. 4 1 |"+
           "6822 2,0 220 5-50 3.4. 4 1 |"+
           "6822 1,0 220 10-100 3.4. 4 1 |"+
           "6822 2,0 220 10-100 3.4. 4 1 |"+
           "6822 1,0 220 5-7,5 3.4. 4 1 |"+
           "6822 2,0 220 5-7,5 3.4. 4 1 |"+
           "6822 1,0 127 5-50 3.4. 4 1 |"+
           "6822 2,0 127 5-50 3.4. 4 1 |"+
           "6822 1,0 127 10-100 3.4. 4 1 |"+
           "6822 2,0 127 10-100 3.4. 4 1 |"+
           "6822 1,0 127 5-7,5 3.4. 4 1 |"+
           "6822 2,0 127 5-7,5 3.4. 4 1 |"+
           "6822 1,0 57,7 1-1,5 3.4. 4 1 |"+
           "6822 2,0 57,7 1-1,5 3.4. 4 1 |"+
           "6822 1,0 57,7 5-7,5 3.4. 4 1 |"+
           "6822 2,0 57,7 5-7,5 3.4. 4 1 |"+
           "6822 1,0 100 1-1,5 3.3. 4 1 |"+
           "6822 2,0 100 1-1,5 3.3. 4 1 |"+
           "6822 1,0 100 5-7,5 3.3. 4 1 |"+
           "6822 2,0 100 5-7,5 3.3. 4 1 |";

  DT_Binary  = 0;
  DT_Decimal = 1;
  DT_HDStr   = 2;
  HDStrPool = "01234567890ND???";

 PRIVATE VAR
  _com                     : OBJECT;
  CRCTable                 : NUMERIC[0][256];

  Addr                     : NUMERIC[0];

  _᫮䮢            : NUMERIC[0];
  _⮯室⭥६: SCAL[2];
  _䨪      : SCAL[2];
  _ᮢ륇祭     : SCAL[2];
  _窨          : NUMERIC[0];
  _䨪室儭 : SCAL[2];
  _窨Format    : STRING[];

  _                     : NUMERIC[0];
  _                  : NUMERIC[0];
  _썠      : STRING[];
  _।筮᫮       : NUMERIC[0];

  _樥⓬    : NUMERIC[0];

 PRIVATE PROCEDURE _PutInLog(Msg: STRING[]);
  CONST
   Filename = "TXT\wme6822.log";
  VAR
   NormalOpenFile: SCAL[2];
 BEGIN
  IF DEBUG_PUT_IN_LOG THEN
   TRY [MSGSUPPRESSIONMODE(MSGSUPPRESS_ALL)]
    NormalOpenFile:=0;
    IF ~FIO.Exists(Filename) THEN
     FIO.Open(L, Filename, , Create);
     NormalOpenFile:=1;
    ELSE
     FIO.Open(L, Filename, , Append);
     NormalOpenFile:=1;
    END;
 
    FIO.WrStr(L, "*** " + L_DatTim.CompleteSystimeStr() + " *** ");
    FIO.WrStr(L, Msg);
    FIO.WrLn(L);
   EXCEPT
   ELSE
   END; (* TRY *)
 
   IF NormalOpenFile THEN
    FIO.Close(L);
   END;
  END;
 END {_PutInLog};

 PRIVATE PROCEDURE _Assert(Cond: SCAL[2]; Msg: STRING[]);
 BEGIN
  IF ~Cond THEN
   _PutInLog(Msg);
   L_General.Error(Msg);
  END;
 END {_Assert};

 PRIVATE PROCEDURE SetCommState(MSComm: OBJECT);
 BEGIN
  L_MSComm.SetDefaultCommState(MSComm, "2400,n,8,2");
  MSComm.Handshaking:=L_MSComm.h_RTS;
 END {SetCommState};

 PRIVATE PROCEDURE NumToHStr(v: NUMERIC[0]): STRING[];
 BEGIN
  RETURN "/"+FLDTOSTR(v, "H", 2);
 END {NumToHStr};

 PRIVATE PROCEDURE h(s: STRING[]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=STRTOFLD(s, NUMERIC, "H");
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {h};

 PRIVATE PROCEDURE HStrToBuf(VAR Buffer: NUMERIC[0][]; s: STRING[]);
  VAR
   i, j: NUMERIC[0];
 BEGIN
  SETEMPTY(Buffer); i:=1; j:=0;
  WHILE i<Str.Length(s) DO
   Buffer[j]:=h(Str.Slice(s, i, 2));
   INC(j); INC(i, 3);
  END;
 END {HStrToBuf};

 PRIVATE PROCEDURE Pack(s, Prefix, Suffix: STRING[]): STRING[];
  VAR
   i: NUMERIC[0];
   r, t: STRING[];
 BEGIN
  r:=Prefix; i:=0;
  WHILE i<Str.Length(s) DO
   t:=Str.Cap(Str.Slice(s, i, 3));
   IF    t="/C0" THEN
    r:=r+"/DB/DC";
   ELSIF t="/DB" THEN
    r:=r+"/DB/DD";
   ELSE
    r:=r+t;
   END;
   INC(i, 3);
  END;
  RETURN r+Suffix;
 END {Pack};

 PRIVATE PROCEDURE Unpack(s, Prefix, Suffix: STRING[]): STRING[];
  VAR
   i: NUMERIC[0];
   r, t: STRING[];
 BEGIN
  r:=""; i:=Str.Length(Prefix);
  WHILE i<Str.Length(s)-Str.Length(Suffix) DO
   t:=Str.Cap(Str.Slice(s, i, 3));
   IF    t="/DB" THEN INC(i, 3);
    t:=Str.Cap(Str.Slice(s, i, 3));
    IF    t="/DC" THEN
     r:=r+"/C0";
    ELSIF t="/DD" THEN
     r:=r+"/DB";
    END;
   ELSE
    r:=r+t;
   END;
   INC(i, 3);
  END;
  RETURN r;
 END {Unpack};

 PRIVATE PROCEDURE PutHStr(MSComm: OBJECT; Prefix, s, Suffix: STRING[]);
  VAR
   Buffer: NUMERIC[0][100];
   r: STRING[];
 BEGIN
  r:=Pack(s, Prefix, Suffix);
  HStrToBuf(Buffer, r);
  MSComm.RTSEnable:=-1;
  MSComm.Output:=CreateSAFEARRAY(Byte, Buffer, 1, Str.Length(r) DIV 3);
 END {PutHStr};

 PRIVATE PROCEDURE Get(MSComm: OBJECT; Binary: SCAL[2]; Prefix, Suffix: STRING[]): STRING[];
  CONST
   _Timeout = 1.000;
   Delay    = 0.005;
  VAR
   j,
   SuffixLen,
   PrefixLen: NUMERIC[0];
   Timeout: FLOAT;
   ByteStr,
   Answer: STRING[];
   _Answer: NUMERIC[0][_InBufferSize];
 BEGIN
  MSComm.RTSEnable:=0;
  MSComm.InputLen:=0;
  SuffixLen:=Str.Length(Suffix);
  PrefixLen:=Str.Length(Prefix);
  Answer:="";
  WHILE (Str.Length(Answer)<PrefixLen+SuffixLen) | ~Str.Match(Str.Slice(Answer, Str.Length(Answer)-SuffixLen, SuffixLen), Suffix) DO
   Timeout:=_Timeout;
   WHILE (MSComm.InBufferCount = 0) & (Timeout > 0) DO
    SLEEP(Delay);
    DEC(Timeout, Delay);
   END;
   IF MSComm.InBufferCount > 0 THEN
    j:=0;
    _Answer:=MSComm.Input;
    WHILE ~!_Answer[j] DO
     IF Binary THEN
      ByteStr:=NumToHStr(_Answer[j]);
     ELSE
      ByteStr:=CHR(_Answer[j]);
     END;
     Answer:=Answer+ByteStr;
     IF (Str.Length(Answer)=PrefixLen) & (Answer#Prefix) THEN
      _PutInLog("< " + Answer);
      _Assert(0, "饭  ᨬ, ⫨  ᨬ 䨪"); (*STX ("+L_Str.IntStr(ORD(STX))+")" *)
     END;
     INC(j);
    END;
   ELSE
    _Assert(0, "௠ ⠩  ⠭ ᮥ.  " + L_Str.IntStr(MSComm.CommPort));
   END;
  END;
  _PutInLog("< " + Answer);
  RETURN Unpack(Answer, Prefix, Suffix);
 END {Get};

 PRIVATE PROCEDURE XOR(x, y: SCAL[256]): NUMERIC[0];
  VAR
   _xor, i: NUMERIC[0];
 BEGIN
  i:=0; _xor:=0;
  WHILE i<8 DO
   _xor:=_xor DIV 2;
   IF INBITSET(x, i)#INBITSET(y, i) THEN
    INC(_xor, 128);
   END;
   INC(i);
  END;
  RETURN _xor;
 END {XOR};

 PRIVATE PROCEDURE CalcCRC(Buffer: NUMERIC[0][]): NUMERIC[0];
  VAR
   CRC, i: NUMERIC[0];
 BEGIN
  i:=0; CRC:=0;
  WHILE ~!Buffer[i] DO
   CRC:=CRCTable[XOR(CRC, Buffer[i])];
   INC(i);
  END;
  RETURN CRC;
 END {CalcCRC};

 PRIVATE PROCEDURE CalcCRCHStr(s: STRING[]): NUMERIC[0];
  VAR
   Buffer: NUMERIC[0][100];
 BEGIN
  HStrToBuf(Buffer, s);
  RETURN CalcCRC(Buffer);
 END {CalcCRC};

 PRIVATE PROCEDURE _Ask(MSComm: OBJECT; s: STRING[]);
 BEGIN
  PutHStr(MSComm, "/00/00/00/00/00/C0", s+NumToHStr(CalcCRCHStr(s)), "/C0");
 END {_Ask};

 PRIVATE PROCEDURE Ask(MSComm: OBJECT; NetAddr, MemAddr, Bytes: NUMERIC[0]);
  VAR
   r: STRING[];
   _MemAddr, _Bytes: NUMERIC[0];
 BEGIN
  _MemAddr:=MemAddr;
  _Bytes  :=Bytes;
  IF MemAddr > 65536 THEN
   IF Bytes MOD 2 = 1 THEN
    INC(Bytes);
   END;
   INC(Bytes, 32);
  END;
  r:="/28"+NumToHStr(NetAddr MOD 256)+NumToHStr(NetAddr DIV 256)+
     "/FF/FF/FF/FF"+NumToHStr(128+Bytes)+
     NumToHStr(MemAddr DIV 256 MOD 256)+NumToHStr(MemAddr MOD 256);
  _Ask(MSComm, r);
  _PutInLog("> " + r);
  _PutInLog("            {MemAdr="+L_Str.IntStr(_MemAddr) + " Bytes=" + L_Str.IntStr(_Bytes) + "}");
 END {Ask};

 PRIVATE PROCEDURE ExtractBinary(VAR Buffer: NUMERIC[0][]; Start, Len: NUMERIC[0]): NUMERIC[0];
  VAR
   i, v: NUMERIC[0];
 BEGIN
  v:=0; i:=Start;
  WHILE i<Start+Len DO
   v:=v*256;
   INC(v, Buffer[i]);
   INC(i);
  END;
  RETURN v;
 END {ExtractBinary};

 PRIVATE PROCEDURE ExtractStrValue(VAR Buffer: NUMERIC[0][]; Start, Len, Type: NUMERIC[0]): STRING[];
  VAR
   i,
   j,
   DecVal: NUMERIC[0];
   r: STRING[];

 BEGIN
  r:=""; i:=0; j:=Start+Len-1;
  DecVal:=0;
  WHILE i<Len DO
   IF    Type=DT_Decimal THEN
    DecVal:=100*DecVal+Buffer[j];
    r:=FLDTOSTR(DecVal, "L");
(*
    r:=r+FLDTOSTR(Buffer[j], "L", 2);
*)
   ELSIF Type=DT_HDStr THEN
    r:=r+Str.Slice(HDStrPool, Buffer[j] DIV 16, 1) + Str.Slice(HDStrPool, Buffer[j] MOD 16, 1);
   END;
   INC(i);
   DEC(j);
  END;
  RETURN r;
 END {ExtractStrValue};

 PRIVATE PROCEDURE Answer(MSComm: OBJECT; NetAddr, MemAddr, Bytes, Type: NUMERIC[0]): STRING[];
  VAR
   s: STRING[];
   Buffer: NUMERIC[0][100];
   _Prefix,
   _NetAddr,
   _Bytes,
   _MemAddr,
   _Value: NUMERIC[0];
 BEGIN
  s:=Get(MSComm, 1, "/C0", "/C0");
  HStrToBuf(Buffer, s);
  L_General.Assert(~!Buffer[5], "祭 ⢥  ᮮ⢥ ଠ");
  _Prefix :=ExtractBinary(Buffer, 0, 1);
  _NetAddr:=ExtractBinary(Buffer, 1, 2);
  _Bytes  :=ExtractBinary(Buffer, 3, 1);
  _MemAddr:=ExtractBinary(Buffer, 4, 2);

  IF _Bytes>32 THEN
   DEC(_Bytes, 32);
   INC(_MemAddr, 65536);
  END;
  _PutInLog("            {MemAdr="+L_Str.IntStr(_MemAddr) + " Bytes=" + L_Str.IntStr(_Bytes) + "}");
  L_General.Assert(Bytes<=_Bytes, "⠭ "+L_Str.IntStr(_Bytes)+"  - , 祬 ॡ ("+L_Str.IntStr(Bytes)+")");
  L_General.Assert(MemAddr+Bytes<=_MemAddr+_Bytes, "⠭   ᮮ⢥ ॡ㥬");
  L_General.Assert(_MemAddr<=MemAddr, "⠭   ᮮ⢥ ॡ㥬");

  IF    Type=DT_Binary THEN
   RETURN L_Str.IntStr(ExtractBinary(Buffer, 6+MemAddr-_MemAddr, Bytes));
  ELSIF (Type=DT_Decimal) | (Type=DT_HDStr) THEN
   RETURN ExtractStrValue(Buffer, 6+MemAddr-_MemAddr, Bytes, Type);
  END;
 END {Answer};

 PRIVATE PROCEDURE GetStrValue(MSComm : OBJECT;
                               NetAddr: NUMERIC[0];
                               MemAddr: NUMERIC[0];
                               Bytes  : NUMERIC[0];
                               Type   : NUMERIC[0]): STRING[];
  VAR
   Count: NUMERIC[0];
 BEGIN
  Count:=0;
  LOOP
   TRY
    Ask(MSComm, NetAddr, MemAddr, Bytes);
    RETURN Answer(MSComm, NetAddr, MemAddr, Bytes, Type);
   EXCEPT
   ELSE
    INC(Count);
    IF Count >= 3 THEN
     RAISE();
    END;
   END;
  END;
 END {GetStrValue};

 PRIVATE PROCEDURE GetValue(MSComm: OBJECT; NetAddr, MemAddr, Bytes, Type: NUMERIC[0]): NUMERIC[0];
  VAR
   s     : STRING[];
   Result: NUMERIC[0];
 BEGIN
  s:=GetStrValue(MSComm, NetAddr, MemAddr, Bytes, Type);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=STRTOFLD(s, NUMERIC, "0");
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetValue};

 PUBLIC PROCEDURE Open(_COMPort, WMAddr: NUMERIC[0]);
  VAR
   t,
   _Addr,
   CfgWord: NUMERIC[0];
 BEGIN
  IF ~L_General.VariableIsInitialized(Addr) THEN
   HStrToBuf(CRCTable, _CRCTable);
   _com:=L_MSComm.CreateMSComm();
   SETEMPTY(Addr);
  END;

  L_General.Assert(~IsOpen(), "뢠 稪  뢠 ।饣");
  Addr:=WMAddr;

  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   SetCommState(_com);
   _com.CommPort:=_COMPort;
   _com.InBufferSize:=_InBufferSize;
   _com.PortOpen:=-1;
  EXCEPT
  ON Exc: Exc_Root DO
   IF Exc.Class = "Exc_Object" THEN
    L_General.Error(" 㤠  .||ଠ  訡:|" + Exc.MsgOriginalText);
   ELSE
    L_General.Error(" 㤠  .||ଠ  訡:|" +
                    L_Str.IntStr(Exc.ErrorCode) + " " + Exc.MsgOriginalText);
   END;
  END;

  _Addr:=GetValue(_com, WMAddr, h("00028"), 1, DT_Binary);
  L_General.Assert(Addr = _Addr, " 稪  ᮬ " + L_Str.IntStr(WMAddr) +
                                 "(COM" + L_Str.IntStr(_com.CommPort) + ") ⠭  " + L_Str.IntStr(_Addr));
  CfgWord:=GetValue(_com, WMAddr, h("0000b"), 1, DT_Binary);
  _᫮䮢:=CfgWord DIV 64 MOD 4+1;                     (* 2 *)
  _⮯室⭥६:=1-CfgWord DIV 32 MOD 2;         (* 1 *)
  _䨪:=CfgWord DIV 16 MOD 2;                 (* 1 *)
  _ᮢ륇祭:=CfgWord DIV 8 MOD 2;                 (* 1 *)
  t:=CfgWord DIV 2 MOD 4;                                    (* 2 *)
  IF    t=1 THEN
   _窨:=1000; _窨Format:="3,";
  ELSIF t=2 THEN
   _窨:=100;  _窨Format:="2,";
  ELSIF t=3 THEN
   _窨:=10;   _窨Format:="1,";
  ELSE
   _窨:=1;    _窨Format:="0";
  END;
  _䨪室儭:=CfgWord DIV 1 MOD 2;             (* 1 *)

  SETEMPTY(_樥⓬, _, _, _썠, _।筮᫮);
 END {Open};

 PUBLIC PROCEDURE IsOpen(): SCAL[2];
 BEGIN
  RETURN L_General.VariableIsInitialized(Addr) & ~!Addr;
 END {IsOpen};

 PUBLIC PROCEDURE Close();
 BEGIN
  L_General.ConsultToUs(IsOpen(), "뢠 ⮣ 稪");
  _com.PortOpen:=0;
  SETEMPTY(Addr);
 END {Close};

 PUBLIC PROCEDURE Abort();
 BEGIN
  L_General.ConsultToUs(L_General.VariableIsInitialized(Addr) & ~!Addr,
                        "୮ ਬ L_WMEnergomera.Abort");
  IF _com.PortOpen THEN
   _com.PortOpen:=0;
  END;
  SETEMPTY(Addr);
 END {Abort};

 PRIVATE PROCEDURE WMType();
  VAR
   _WMType: NUMERIC[0];
 BEGIN
  _WMType:=GetValue(_com, Addr, h("1008c"), 2, DT_Binary);
  _:=_WMType DIV 256;
  _:=_WMType MOD 256;
  IF    _=T_6827M1 THEN
   _썠:=""; _।筮᫮:=0;
  ELSIF _=T_6822 THEN
   _썠:=L_Str.PoolItem(M_6822, _-1);
   IF _ <= 6 THEN
    _।筮᫮:=320/10*_窨;
   ELSE
    _।筮᫮:=0;
   END;
  ELSIF _=T_6827M THEN
   _썠:=""; _।筮᫮:=0;
  ELSE
   _썠:=" ⨯ 稪"; _।筮᫮:=0;
  END;
 END {WMType};

 PRIVATE PROCEDURE 窨Format(): STRING[];
 BEGIN
  RETURN _窨Format;
 END {窨Format};

 PRIVATE PROCEDURE ।筮᫮(): NUMERIC[0];
 BEGIN
  IF !_।筮᫮ THEN
   WMType();
  END;
  RETURN _।筮᫮;
 END {।筮᫮};

 PUBLIC PROCEDURE 樥⓬(): NUMERIC[0];
 BEGIN
  IF !_樥⓬ THEN
   _樥⓬:=GetValue(_com, Addr, h("0003a"), 1, DT_Decimal);
  END;
  RETURN _樥⓬;
 END {樥⓬};

 PUBLIC PROCEDURE ᪨(): STRING[];
 BEGIN
  RETURN GetStrValue(_com, Addr, h("100bc"), 4, DT_HDStr)
        +GetStrValue(_com, Addr, h("1005c"), 4, DT_HDStr);
 END {᪨};

 PUBLIC PROCEDURE ᪮(): STRING[];
 BEGIN
  RETURN GetStrValue(_com, Addr, h("1002c"), 4, DT_HDStr);
 END {᪮};

 PUBLIC PROCEDURE ⠂६(): TIMESTAMP;
  VAR
   DT,
   Date,
   Time : NUMERIC[0];
   sec  : FLOAT;
 BEGIN
  DT:=GetValue(_com, Addr, h("00020"), 6, DT_Binary);
  Date:=DT MOD (256*256*256);
  Time:=DT DIV (256*256*256);
  sec :=Time DIV 65536 MOD 128 + Time DIV (65536*128) MOD 2 / 2;
  L_General.ConsultToUs(sec < 60, "ࠢ쭠 ஢  ६");
  RETURN PackTIMESTAMP(PackDATE(Date DIV 65536 MOD 256, Date DIV 256 MOD 16 - 1, 2000 + Date DIV 1 MOD 256),
                       00:00 + Time DIV 1 MOD 256 / 2 + Time DIV 256 MOD 256 / 60,
                       sec);
 END {⠂६};

 PUBLIC PROCEDURE 魮(): NUMERIC[4];
 BEGIN
  RETURN GetValue(_com, Addr, h("00034"), 2, DT_Decimal)*60*樥⓬()/।筮᫮();
 END {魮};

 PUBLIC PROCEDURE 魮쏮ᮢ(_Date: DATE; _Time: TIME): NUMERIC[4];
  VAR
   _Addr,
   Day,
   Month,
   HalfHourNbr: NUMERIC[0];
 BEGIN
  UnPkDATE(_Date, Day, Month);
  HalfHourNbr:=(_Time-00:00)*2 DIV 1;
  _Addr:=h("10400")+(Month MOD 2)*(4096-1024)+(Day-1)*96+HalfHourNbr*2;
  RETURN GetValue(_com, Addr, _Addr, 2, DT_Decimal)*2/_窨;
 END {魮쏮ᮢ};

 PUBLIC PROCEDURE ᨬ㬌魮⨇騥⪨(): NUMERIC[4];
 BEGIN
  RETURN GetValue(_com, Addr, h("00030"), 2, DT_Decimal)*2/_窨;
 END {ᨬ㬌魮⨇騥⪨};

 PUBLIC PROCEDURE ᨬ㬌魮⨇騩(): NUMERIC[4];
 BEGIN
  RETURN GetValue(_com, Addr, h("00032"), 2, DT_Decimal)*2/_窨;
 END {ᨬ㬌魮⨇騩};

 PUBLIC PROCEDURE ᨬ㬌魮⨇(MonthNbr: NUMERIC[0]): NUMERIC[4];
 BEGIN
  RETURN GetValue(_com, Addr, h("103e0")+(MonthNbr-1)*2, 2, DT_Decimal)*2/_窨;
 END {ᨬ㬌魮⨇};

 PUBLIC PROCEDURE ࣨ砫⮪(TNmbr: NUMERIC[0]): NUMERIC[4];
 BEGIN
  RETURN GetValue(_com, Addr, h("103c0")+(TNmbr-1)*4, 4, DT_Decimal)/_窨;
 END {ࣨ砫⮪};

 PUBLIC PROCEDURE ࣨ(TNmbr: NUMERIC[0]): NUMERIC[4];
 BEGIN
  RETURN GetValue(_com, Addr, h("00040")+(TNmbr-1)*4, 4, DT_Decimal)/_窨;
 END {ࣨ};

 PUBLIC PROCEDURE ࣨ挥(TNmbr, MonthNbr: NUMERIC[0]): NUMERIC[4];
 BEGIN
  RETURN GetValue(_com, Addr, h("10300")+(MonthNbr-1)*16+(TNmbr-1)*4, 4, DT_Decimal)/_窨;
 END {ࣨ};

END.

