(*
%Copyright   (c) Polak IT
%Author      21.08.2008 12:47:14 POLAK\San
%Purpose     প 㬥⮮
%Type        control
%Specific    SYS
%Modified    18.09.2013 14:56:37 POLAK\LDA
%Environment
*)

 MODULE L_XDF [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tAction             = SCAL[32];
  tAuthenticationKind = SCAL[5];
  tCaseToDo           = SCAL[8];

 PUBLIC CONST
  a_Permission     = 0;
  a_Agreement      = 1;
  a_HandOriginal   = 2;
  a_HandCopy       = 3;
  a_Acquaint       = 4;
  a_Implementation = 5;
  a_HandElCopy     = 6;
  a_AcquaintElCopy = 7;
  a_SetAuthor      = 8;

  a_Pool_1 = "襭  ᯮ|ᮢ|। ਣ|। ||⬥⪠  ᯮ|। .|  .|⠭ ";
  a_Pool_2 = "襭  ᯮ|ᮢ|祭 ਣ|祭 ||⬥⪠  ᯮ|। .|  .|⠭ ";

  ak_Internal     = 0;
  ak_PIN          = 1;
  ak_PassCard     = 2;
  ak_BarCode      = 3;

  ak_Pool = "짮⥫|-|-ய|| ";

  pool_XDocFlowRslTxt = 00989;

  ctd_NeedAgreement  = 0;
  ctd_NeedPermission = 1;
  ctd_DoIt           = 2;
  ctd_Acquaint       = 3;
  ctd_OnControl      = 5;
  ctd_Done           = 6;
  ctd_Pool = "ᮢ|襭?|믮||।|஫| 娢";

 IMPORT L_General, L_XDoc, E_Utils, L_DatTim, L_Str, Str, L_ODoc, L_StdFrm;

 PUBLIC PROCEDURE UseXDF(): SCAL[2];
 BEGIN
  RETURN ~APP.Get().ProductiveCopy |
         (L_General.GetAPSiteNumber() = 29) | (L_General.GetAPSiteNumber() = 26);
 END {UseXDF};

 PUBLIC PROCEDURE IsUserSelfAction(Action: tAction): SCAL[2];
 BEGIN
  RETURN (Action = a_Permission) | (Action = a_Agreement) | (Action = a_Implementation) | (Action = a_HandElCopy) | (Action = a_AcquaintElCopy);
 END {IsUserSelfAction};

 PUBLIC PROCEDURE XDocFullDescription(trgXDocId: L_XDoc.tXDocId): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=L_XDoc.extXDocStr(trgXDocId, L_XDoc.xdast_wStatus);
  IF L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_ODoc THEN
   TRY
    RTI.Get().TryBlock.AccessDataMode:=adm_HOTTEST;
    L_XDoc.PositionOnXDoc(trgXDocId);
    IF ~!ODoc.Firm THEN
     CONFORM(ODoc, Firm);
     INC(Result, L_Str.CRLF + "ࠣ: " + Firm.Firm + " " + Firm.Name);
    ELSIF ~!ODoc.TSN THEN
     CONFORM(ODoc, Staff);
     INC(Result, L_Str.CRLF + "⭨: " + Staff.TSN + " " + Staff.Name);
    END;
    INC(Result, L_Str.CRLF);
    INC(Result, Str.Condense(L_ODoc.GetCurODocSpcName() + " " + ODoc.Descript));
    IF SELECT(XDocFlow, XDocFlow, trgXDocId) & LAST(XDocFlow) THEN
     LOOP
      IF ~OCCURE(XDocFlow) THEN
       EXIT;
      ELSIF ~!XDocFlow.RslTxt THEN
       INC(Result, L_Str.CRLF + ": " + XDocFlow.RslTxt);
       EXIT;
      END;
      PREV(XDocFlow);
     END; (* LOOP ... *)
    END; (* IF SELECT(XDocFlow ... *)
    L_General.RaiseLockReleaseException();
   EXCEPT
   ON Exc: Exc_Root DO
    L_General.CheckIsLockReleaseException(Exc);
   END;
  END;
  RETURN Result;
 END {XDocFullDescription};

 PUBLIC PROCEDURE E_XDF_AuthenticationKind(): tAuthenticationKind;
  VAR
   Local : PROC;
   Result: tAuthenticationKind;
 BEGIN
  Local:=PROCREF(E_Utils.XDF_AuthenticationKind);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   IF ~APP.Get().ProductiveCopy THEN
    TOOLTIP("ᮡ ਧ樨  ஥", 0);
    RETURN ak_BarCode;
   END;
   L_General.InformUs(" ஥ ᯮᮡ ਧ樨  㦤 㬥⮡");
  END;
 END {E_XDF_AuthenticationKind};

 PUBLIC PROCEDURE HasAcquaintElCopyByCurHandElCopy(curXDocId: L_XDoc.tXDocId; trgAcsObj: LIKE(AcsObj.AcsObj); VAR SignDTS: LIKE(XDocFlow.SignDTS)): SCAL[2];
  VAR
   Result    : SCAL[2];
   trgSignDTS: LIKE(XDocFlow.SignDTS);
 BEGIN
  trgSignDTS:=XDocFlow.SignDTS;
  SAVE(XDocFlow);
  SELECT(XDocFlow, XDocFlow, , curXDocId);
  LAST(XDocFlow);
  LOOP
   IF    ~OCCURE(XDocFlow) | (XDocFlow.SignDTS <= trgSignDTS ) THEN
    Result :=0;
    SignDTS:=MINOF(TIMESTAMP);
    EXIT;
   ELSIF (XDocFlow.Action = a_AcquaintElCopy) & (XDocFlow.Executor = trgAcsObj) THEN
    Result :=1;
    SignDTS:=XDocFlow.SignDTS;
    EXIT;
   END;
   PREV(XDocFlow);
  END; (* LOOP *)
  RESTORE(XDocFlow);
  RETURN Result;
 END {HasAcquaintElCopyByCurHandElCopy};

 PUBLIC PROCEDURE UpdateXDFCase(curFile: STRING[]);
  VAR
   curXDocId: L_XDoc.tXDocId;
   srcDate  : DATE;
   srcName  : LIKE(XDFCase.Name);
fckDateName: STRING[];
 BEGIN
  TRY
   curXDocId:=L_XDoc.curXDocIdSoft(L_XDoc.GetFileXDT(curFile));
   IF ~!curXDocId & SELECT(XDFCase, XDFCase, curXDocId) THEN
    fckDateName:=L_XDoc.DateFieldName(curFile);
    IF ~!fckDateName THEN
     srcDate:=^(TABLE.Get(curFile).Fields(fckDateName).ObtainName());
    ELSE
     SETEMPTY(srcDate);
    END;
    srcName:=L_XDoc.extXDocStr(curXDocId, L_XDoc.xdast_wSrcNbr);
    WHILE OCCURE(XDFCase) DO
     XDFCase.Name:=srcName;
     XDFCase.Date:=srcDate;
     REPLACE(XDFCase);
     NEXT(XDFCase);
    END;
   END;
  EXCEPT
  ON Exc: Exc_Raise DO
   RAISE();
  ON Exc: Exc_AccessDeny DO
   RAISE();
  ELSE
   (*   㤥 ⮒ *)
  END;
 END {UpdateXDFCase};

 PRIVATE PROCEDURE RenewCase(curXDocId : L_XDoc.tXDocId;
                             trgOwner  : LIKE(AcsObj.AcsObj);
                             trgToDo   : LIKE(XDFCase.ToDo);
                             trgTrgDate: DATE);
 BEGIN
  IF ~SEARCH(XDFCase, XDFCase, curXDocId, trgOwner) THEN
   DEFAULT(XDFCase);
   XDFCase.Owner :=trgOwner;
   XDFCase.XDocId:=curXDocId;
   INSERT(XDFCase);
  END;
  XDFCase.dlDate:=trgTrgDate;
  XDFCase.ToDo  :=trgToDo;
  XDFCase.Closed:=0;
  XDFCase.LastMdf:=SYSTIMESTAMP();
  REPLACE(XDFCase);
  L_XDoc.PositionOnXDoc(curXDocId);
  UpdateXDFCase(L_XDoc.Ref_FileName(L_XDoc.ExtractXDocType(curXDocId)));
 END {RenewCase};

 PRIVATE PROCEDURE RenewCaseByFlow(trgOwner: LIKE(AcsObj.AcsObj);
                                   trgToDo : LIKE(XDFCase.ToDo));
 BEGIN
  RenewCase(XDocFlow.XDocId, trgOwner, trgToDo, XDocFlow.TrgDate);
 END {RenewCaseByFlow};

 PUBLIC PROCEDURE PutFlowInCase();
 BEGIN
IF UseXDF() THEN
  IF    XDocFlow.Action = a_Permission THEN
   RenewCaseByFlow(XDocFlow.To,       ctd_DoIt);
   RenewCaseByFlow(XDocFlow.Executor, ctd_OnControl);
  ELSIF XDocFlow.Action = a_Agreement THEN
  ELSIF XDocFlow.Action = a_Implementation THEN
   SELECT(XDFCase, XDFCase, , XDocFlow.XDocId);
   WHILE OCCURE(XDFCase) DO
    XDFCase.ToDo:=ctd_Done;
    REPLACE(XDFCase);
    NEXT(XDFCase);
   END; (* WHILE OCCURE(XDFCase) ... *)
  ELSIF XDocFlow.Action = a_HandElCopy THEN
   RenewCaseByFlow(XDocFlow.To, ctd_Acquaint);
  ELSIF XDocFlow.Action = a_AcquaintElCopy THEN
   RenewCaseByFlow(XDocFlow.Executor, ctd_OnControl);
  ELSIF XDocFlow.Action = a_HandOriginal   THEN
  ELSIF XDocFlow.Action = a_HandCopy       THEN
  ELSIF XDocFlow.Action = a_Acquaint       THEN
  ELSIF XDocFlow.Action = a_SetAuthor      THEN
  ELSE
   L_General.CallUs(0);
  END;
END;
 END {PutFlowInCase};

 PUBLIC PROCEDURE XDoc_OnAfterInsert(curXDocId: L_XDoc.tXDocId);
  VAR
   R: NUMERIC[0];
 BEGIN
  IF UseXDF() THEN
   R:=L_StdFrm.ShowListAsMenu("ॡ ࠧ襭  ᯮ|ॡ ᮣᮢ|襭 | ࠦ  㬥⮮",
                              "롮 ਠ  㬥");
   IF    R = 0 THEN RenewCase(curXDocId, L_General.curUSER, ctd_NeedPermission, SYSDATE()+3);
   ELSIF R = 1 THEN RenewCase(curXDocId, L_General.curUSER, ctd_NeedAgreement,  SYSDATE()+3);
   ELSIF R = 2 THEN
    LIKEMENU(CALL, "XDocFlow.Mark_Permission()");
   ELSIF R # 3 THEN
    L_General.CallUs(0);
   END;
  END;
 END {XDoc_OnAfterInsert};

END.
