(*
%Copyright   (c) Polak Computer System
%Author      23.03.1998 11:57:40 SAN
%Purpose     প Xꥪ⮢
%Type        library
%Specific    SYS
%Modified    22.09.2014 18:43:34 POLAK\San
*)

 MODULE L_XObj [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tOrigin                 = SCAL[8];
  tOriginsMap             = SCAL[2][MAXOF(tOrigin)+1];
  tSection                = SCAL[32];
  tSum                    = NUMERIC[2];
  tQnt                    = NUMERIC[3];
  tSource                 = SCAL[1E2];
  tDoAcnt                 = SCAL[3];
  tXObjectAcCutCollection = LIKE(AcCut.AcCut)[32];

 PUBLIC CONST
  o_Global    = 00;
  o_Man       = 01;
  o_Contract  = 02;
  o_Math      = 03;
  o_KeyAss    = 04;
  o_CostItem  = 05;
  o_Staff     = 06;
  o_ESN       = 07;

  o_Pool    = "⢥, ||||||⭨| ()";
  o_Pool_SH = "E|||||||";

  s_Payments       = 00;
  s_Salary         = 01;
  s_Math           = 02;
  s_KeyAss         = 03;

  xo_CashOffice = 000000100;

  src_Operator     = 0;
  src_Converter    = 1;
  src_Online       = 2;
  src_Salary       = 3;
  src_Payments     = 4;
  src_JDoc         = 5;
  src_MDoc         = 6;
  src_PDoc         = 8;
  src_Amortisation = 9;
  src_KAMDoc       = 10;
  src_OnSalary     = 11;
  src_MathRevision = 18;
  src_Math         = 19;
  src_RWayS        = 20;
  src_ACalc        = 21;

  src_Pool = "|<>|Online|௫ (c)| (c)||| ||⨧| | ௫()| | | | | | |८業|  ()||";

  acda_No     = 0;
  acda_Ignore = 1;
  acda_Yes    = 2;

  xoid_Contract_SpecVATMDocNeed = 0;
  xoid_Man_SalarySection        = 0;

  xoid_ForFixXODone             = 3;

 IMPORT Memo, L_General, L_DatTim, L_Str, L_Acnt, L_Math, L_XDR, L_StdFrm, L_APtm, L_AR, L_AFM, L_r2r,
        L_EC, L_AcCut, L_MathR, L_Stock, L_XDoc, L_ACL, L_AcsPnt,
        Math, Str, P_Firm, P_Storage, E_Stock, L_MDoc;

 PRIVATE CONST
  o_Files = "mfBnkAcn|mfMan|Contract|mItem|mItem|CostItem|Staff|???";

 PUBLIC PROCEDURE PassManXCalcViewAcsPnt();
 BEGIN
  L_AcsPnt.PassAccessPoint(0000044);
 END {PassManXCalcViewAcsPnt};

 PUBLIC PROCEDURE SectionOfXObjectAcCut(trgAcCut: LIKE(AcCut.AcCut)): tSection;
  VAR
   Result  : tSection;
 BEGIN
  IF    XObject.Origin = o_Staff THEN
   Result:=s_Payments;
(*
   IF L_AcCut.IsAcCutwERKN(trgAcCut, L_AcCut.erkn_Salary)    |
      L_AcCut.IsAcCutwERKN(trgAcCut, L_AcCut.erkn_Salary_CA) THEN
    Result:=s_Salary;
   ELSE
    Result:=s_Payments;
   END;
*)
  ELSIF XObject.Origin = o_Man THEN
   Result:=s_Payments;
  ELSIF XObject.Origin = o_Math THEN
   Result:=s_Math;
  ELSIF XObject.Origin = o_KeyAss THEN
   Result:=s_KeyAss;
  ELSIF XObject.Origin = o_ESN THEN
   Result:=s_Salary;
  ELSE
   Result:=s_Payments;
  END;
  RETURN Result;
 END {SectionOfXObjectAcCut};

 PUBLIC PROCEDURE SystemOfSection(_Section: tSection): L_APtm.tSystems;
 BEGIN
  IF    _Section = s_Payments THEN
   RETURN L_APtm.system_Payments;
  ELSIF _Section = s_Math THEN
   RETURN L_APtm.system_Math;
  ELSIF _Section = s_KeyAss THEN
   RETURN L_APtm.system_KeyAss;
  ELSIF _Section = s_Salary THEN
   RETURN L_APtm.system_Salary;
  ELSE
   L_General.CallUs(0);
  END;
 END {SystemOfSection};

 PUBLIC PROCEDURE IsAppropriateSection(_AcCut: LIKE(AcCut.AcCut); trgSection: tSection): SCAL[2];
 BEGIN
  IF ~!trgSection THEN
   RETURN SectionOfXObjectAcCut(_AcCut) = trgSection;
  ELSE
   RETURN 1;
  END;
 END {IsAppropriateSection};

 PUBLIC PROCEDURE GetNewXObject(_Origin: tOrigin; _MyFirm: P_Firm.tMyFirm): LIKE(XObject.XObject);
 BEGIN
  DEFAULT(XObject);
  XObject.Origin:=_Origin;
  XObject.MyFirm:=_MyFirm;
  INSERT(XObject);
  RETURN XObject.XObject;
 END {GetNewXObject};

 PUBLIC PROCEDURE GetOriginFileName(_Origin: tOrigin): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(o_Files, _Origin);
 END {GetOriginFileName};

 PUBLIC PROCEDURE AfterOriginInsert(_Origin: tOrigin; _MyFirm: P_Firm.tMyFirm);
 BEGIN
  ^(GetOriginFileName(_Origin)).XObject:=GetNewXObject(_Origin, _MyFirm);
  REPLACE(^(GetOriginFileName(_Origin)));
 END {AfterOriginInsert};

 PUBLIC PROCEDURE SrcXObject(trgXObject: LIKE(XObject.XObject)): SCAL[2];
 BEGIN
  IF SEARCH(XObject, XObject, trgXObject) THEN
   RETURN 1;
  ELSE
   TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_OFF)]
    L_General.CallUs(SEARCH(XObject, XObject, trgXObject));
    RETURN 0;
   EXCEPT
   END; (* TRY *)
  END;
 END {SrcXObject};

 PUBLIC PROCEDURE AccessXObject(trgXObject: LIKE(XObject.XObject));
 BEGIN
  IF ~SEARCH(XObject, XObject, trgXObject) THEN
   TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_THROW)]
    L_General.CallUs(SEARCH(XObject, XObject, trgXObject));
   EXCEPT
   END; (* TRY *)
  END;
 END {AccessXObject};

 PUBLIC PROCEDURE GetXObjectOrigin(trgXObject: LIKE(XObject.XObject)): tOrigin;
 BEGIN
  TRY [ABORT_AFTER(AA_ON)]
   IF ~!trgXObject THEN
    AccessXObject(trgXObject);
    RETURN XObject.Origin;
   ELSE
    RETURN EMPTYOF(tOrigin);
   END;
  EXCEPT
  END; (* TRY *)
 END {GetXObjectOrigin};

 PUBLIC PROCEDURE AccessXObjectByOrigin(_Origin: tOrigin);
 BEGIN
  AccessXObject(^(GetOriginFileName(_Origin)).XObject);
 END {AccessXObjectByOrigin};

 PRIVATE PROCEDURE AssertNotZeroCir(trgXObject: LIKE(XObject.XObject); trgAcCut: LIKE(XApport.AcCut); BeforeDelete: SCAL[2]);
  VAR
   Msg: STRING[];
 BEGIN
  AccessXObject(trgXObject);
  SEARCH(AcCut, AcCut, , trgAcCut);
  Msg:=" ꥪ '"+GetXObjectOriginName() + "':" +
       "| 楢   㫥 , ਬ  ⭮ ࠧ१" +
       "|" + AcCut.AcCut + " " + AcCut.Name + "." +
       "| ࠧ  த   ⮢";
  IF BeforeDelete THEN
   Msg:=Msg+".|᫨ ஢  ,|  ꥪ 㤠 , ᫥  ''";
  END;
  L_StdFrm.WrongDB(Msg);
 END {AssertNotZeroCir};

 PRIVATE PROCEDURE intCheckXCalcIsZero(_XObject: LIKE(XObject.XObject); BeforeDelete: SCAL[2]);
 BEGIN
  L_AFM.MakeMultipleIndex("_XApp", "WFDate: LIKE(XApport.WFDate);"+
                                   "AcCut: LIKE(XApport.AcCut);"+
                                   "Apport: LIKE(XApport.Apport);"+
                                   "AcCut2: LIKE(XApport.AcCut2);"+
                                   "Source: LIKE(XApport.Source);"+
                                   "Sum   : LIKE(XApport.Sum);"+
                                   "Qnt   : LIKE(XApport.Qnt)",
                                   "XApp: AcCut, Apport, AcCut2, Source, WFDate");
  SELECT(XCalc, XObject, , _XObject);
  WHILE OCCURE(XCalc) DO
   CONFORM(XCalc, XApport);
   WHILE OCCURE(XApport) DO
    IF ~IsZeroCir() THEN
     IF BeforeDelete THEN
      AssertNotZeroCir(_XObject, XCalc.AcCut, BeforeDelete);
     ELSIF (XApport.Source # src_Payments) &
           (XCalc.AcCut # L_AcCut.erkn_GetSoft(XCalc.XDat, L_AcCut.erkn_OnlineBalance)) THEN
      ADD(_XApp, XApp, , XApport.AcCut, XApport.Apport, XApport.AcCut2, XApport.Source, XApport.WFDate,
                         _XApp.Sum, XApport.Sum,
                         _XApp.Qnt, XApport.Qnt);
     END;
    END;
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
   NEXT(XCalc);
  END; (* WHILE OCCURE(XCalc) *)

  SELECT(_XApp, XApp);
  WHILE OCCURE(_XApp) DO
   IF (_XApp.Sum # 0) | (_XApp.Qnt # 0) THEN
    AssertNotZeroCir(_XObject, _XApp.AcCut, BeforeDelete);
   END;
   NEXT(_XApp);
  END; (* WHILE OCCURE(_XApp) ... *)
  L_AFM.AF_PurgeTemp("_XApp");
 END {intCheckXCalcIsZero};

 PUBLIC PROCEDURE CheckXCalcIsZero(_XObject: LIKE(XObject.XObject));
 BEGIN
  intCheckXCalcIsZero(_XObject, 0);
 END {CheckXCalcIsZero};

 PRIVATE PROCEDURE BeforeOriginDelete_OneRecord(_Origin: tOrigin);
  VAR
   OriginFile: STRING[];
 BEGIN
  OriginFile:=GetOriginFileName(_Origin);
  AccessXObjectByOrigin(_Origin);
  intCheckXCalcIsZero(XObject.XObject, 1);
  IF SELECT(JDocList, XObject,  XObject.XObject) |
     SELECT(JDocList, XObject2, XObject.XObject) THEN
   CONFORM(JDocList, JDoc);
   L_General.Error(" 뫪  "+GetXObjectOriginName()+"| "+L_XDoc.XDocStr(JDoc.XDocId));
  END;
  SETEMPTY(^OriginFile.XObject);
  REPLACE(^OriginFile);
  TRY [INTEGRITY(INTEGRITY_ON)]
   REMOVE(XObject);
  EXCEPT
  END;
 END {BeforeOriginDelete_OneRecord};

 PUBLIC PROCEDURE BeforeOriginDelete(_Origin: tOrigin);
 BEGIN
  IF _Origin = o_Man THEN
   SELECT(mfMan, Man, , Man.Man);
   WHILE OCCURE(mfMan) DO
    BeforeOriginDelete_OneRecord(_Origin);
    NEXT(mfMan);
   END; (* WHILE OCCURE(mfMan) ... *)
  ELSE
   BeforeOriginDelete_OneRecord(_Origin);
  END;
 END {BeforeOriginDelete};

 PUBLIC PROCEDURE GetRecastXObject(_MyFirm: P_Firm.tMyFirm): LIKE(XObject.XObject);
  VAR
   Result: LIKE(XObject.XObject);
 BEGIN
  SAVE(mfBnkAcn);
  IF SEARCH(mfBnkAcn, MyFirm, _MyFirm, P_Firm.fa_CashOffice) THEN
   Result:=mfBnkAcn.XObject;
  ELSE
   L_General.CallUs(0);
  END;
  RESTORE(mfBnkAcn);
  RETURN Result;
 END {GetRecastXObject};

 PUBLIC PROCEDURE ObtainManXObject(trgMan: LIKE(Man.Man); trgMyFirm: P_Firm.tMyFirm): LIKE(XObject.XObject);
 BEGIN
  IF ~SEARCH(mfMan, Man, trgMan, trgMyFirm) THEN
   mfMan.Man    :=trgMan;
   mfMan.MyFirm :=trgMyFirm;
   SETEMPTY(mfMan.XObject, mfMan.XO_ESN);
   INSERT(mfMan);
   AfterOriginInsert(o_Man, mfMan.MyFirm);
  END;
  RETURN mfMan.XObject;
 END {ObtainManXObject};

 PUBLIC PROCEDURE GetManXObject(trgMan: LIKE(Man.Man); trgMyFirm: P_Firm.tMyFirm): LIKE(XObject.XObject);
 BEGIN
  SEARCH(mfMan, Man, , trgMan, trgMyFirm);
  RETURN mfMan.XObject;
 END {GetManXObject};

 PUBLIC PROCEDURE AccessManXObject(_Man: LIKE(Man.Man); _MyFirm: P_Firm.tMyFirm);
 BEGIN
  AccessXObject(GetManXObject(_Man, _MyFirm));
 END {AccessManXObject};

 PUBLIC PROCEDURE AccessManByXObject(_XObject: LIKE(XObject.XObject));
 BEGIN
  L_General.CallUs(SEARCH(mfMan, XObject, _XObject) & SEARCH(Man, Man, mfMan.Man));
 END {AccessManByXObject};

 PUBLIC PROCEDURE SoftAccessOrigin(): SCAL[2];
 BEGIN
  IF XObject.Origin = o_ESN THEN
   RETURN SEARCH(mfMan, XO_ESN, XObject.XObject);
  ELSE
   RETURN SEARCH((GetOriginFileName(XObject.Origin)), XObject, XObject.XObject);
  END;
 END {SoftAccessOrigin};

 PUBLIC PROCEDURE AccessOrigin();
 BEGIN
  L_General.CallUs(SoftAccessOrigin());
 END {AccessOrigin};

 PUBLIC PROCEDURE GetXObjectOriginName(): STRING[];
  VAR
   mfSign,
   Result : STRING[];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   IF SoftAccessOrigin() THEN
    IF    XObject.Origin = o_Global   THEN
     IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
      CONFORM(mfBnkAcn, MyFirm);
      mfSign:="(" + Str.Align(MyFirm.vzSign, Str.MaxLength(MyFirm.vzSign), CENTRE) + "), ";
     ELSE
      mfSign:="";
     END;
     CONFORM(mfBnkAcn, FirmAcnt);
     IF    FirmAcnt.Type = P_Firm.fat_CashOffice THEN
      Result:=mfSign + '"⢥ ꥪ"';
     ELSIF FirmAcnt.Type = P_Firm.fat_OprCashDsk THEN
      Result:=mfSign + FirmAcnt.Name;
     ELSE
      CONFORM(FirmAcnt, Bank);
      Result:=mfSign + FirmAcnt.AcntA + ", " + Bank.Name;
     END;
    ELSIF (XObject.Origin = o_Man) |
          (XObject.Origin = o_ESN) THEN
     CONFORM(mfMan, Man);
     Result:=FLDTOSTR(Man.Man, "", 5) + " " + Man.Name;
    ELSIF XObject.Origin = o_Staff THEN
     Result:=Staff.TSN + " " + Staff.Name;
    ELSIF  XObject.Origin = o_Contract THEN
     Result:=Contract.Contract + " " + Contract.Name;
    ELSIF  XObject.Origin = o_CostItem THEN
     Result:=CostItem.CostItem + " " + CostItem.Name;
    ELSIF (XObject.Origin = o_Math) |
          (XObject.Origin = o_KeyAss) THEN
     CONFORM(mItem, Math);
     Result:=mItem.Math + " ( " + mItem.Storage + ") " + Math.Name;
    END;
   ELSE
    Result:=" ᮯ⠢";
   END;
  EXCEPT
  END; (* TRY *)
  RETURN L_Str.PoolItem(o_Pool_SH, XObject.Origin) + ": " + Result;
 END {GetXObjectOriginName};

 PUBLIC PROCEDURE IsMaterialXObject(): SCAL[2];
 BEGIN
  RETURN (XObject.Origin = o_Math) | (XObject.Origin = o_KeyAss);
 END {IsMaterialXObject};

 PRIVATE PROCEDURE intErrorPoint(curAcCut: LIKE(AcCut.AcCut); curXDat: DATE; curXApport: LIKE(Apport.Apport)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(AcCut);
  L_AcCut.PositionOnAcCut(curAcCut);
  Result:=L_StdFrm.THR("  ஡ ப 楢 ")
                + Str.Align("ꥪ: " + GetXObjectOriginName(),                70, LEFT)
          + "|" + Str.Align("१: " + AcCut.AcCut + ' "' + AcCut.Name + '"', 70, LEFT)
          + "|" + Str.Align(" : " + L_DatTim.PeriodStr(curXDat),           70, LEFT);
  IF ~!curXApport THEN
   INC(Result,
            "|" + Str.Align("-: " + curXApport,                            70, LEFT));
  END;
  RESTORE(AcCut);
  RETURN Result;
 END {intErrorPoint};

 PUBLIC PROCEDURE ErrorPoint1(curAcCut: LIKE(AcCut.AcCut); curXDat: DATE): STRING[];
 BEGIN
  RETURN intErrorPoint(curAcCut, curXDat, EMPTYOF(Apport.Apport));
 END {ErrorPoint1};

 PUBLIC PROCEDURE ErrorPoint(): STRING[];
 BEGIN
  RETURN intErrorPoint(XApport.AcCut, XApport.XDat, XApport.Apport);
 END {ErrorPoint};

 PUBLIC PROCEDURE RoundXObject(S: NUMERIC[2]): tSum;
 BEGIN
  IF (Memo.gl_mb() < 01\09\1996) | (Memo.gl_mb() >= L_General.DenominationDate()) THEN
   RETURN L_Math.ROUND(S, 0.01);
  ELSE
   RETURN L_Math.ROUND(S, 1.00);
  END;
 END {RoundXObject};

 PRIVATE PROCEDURE ClcPer(Section: tSection): DATE;
 BEGIN
  IF Section = s_Salary THEN
   RETURN Memo.gl_mb(); (*!*)
  ELSE
   RETURN L_APtm.ClcPer[SystemOfSection(Section)];
  END;
 END {ClcPer};

 PRIVATE PROCEDURE Clc_CntIsEqual(Section: tSection): SCAL[2];
 BEGIN
  IF Section = s_Salary THEN
   RETURN 1; (*!*)
  ELSE
   RETURN L_APtm.ANYSystem_Clc_CntIsEqual(SystemOfSection(Section));
  END;
 END {Clc_CntIsEqual};

 PUBLIC PROCEDURE CheckClcPer(Section: tSection);
 BEGIN
  IF Section = s_Salary THEN
   (* ஢ઠ  ॡ *)
  ELSE
   L_APtm.ANYSystem_CheckClcPer(SystemOfSection(Section));
  END;
 END {CheckClcPer};

 PUBLIC PROCEDURE OutSaldo(VAR resSum: tSum; VAR resQnt: tQnt);
 BEGIN
  resSum:=XCalc.SldSum+XCalc.DbtSum-XCalc.CrdSum;
  resQnt:=XCalc.SldQnt+XCalc.DbtQnt-XCalc.CrdQnt;
 END {OutSaldo};

 PUBLIC PROCEDURE mo_OutSaldo(): tSum;
 BEGIN
  RETURN XCalc.SldSum+XCalc.DbtSum-XCalc.CrdSum;
 END {mo_OutSaldo};

 PUBLIC PROCEDURE qo_OutSaldo(): tQnt;
 BEGIN
  RETURN XCalc.SldQnt+XCalc.DbtQnt-XCalc.CrdQnt;
 END {qo_OutSaldo};

 PRIVATE PROCEDURE StandOnXCalc(_XObject: LIKE(XObject.XObject); _AcCut: LIKE(AcCut.AcCut); P: DATE): SCAL[2];
 BEGIN
  SETSEL(XCalc, XObject, _XObject, _AcCut);
  RETURN SRCINSEL(XCalc, LE, P);
 END {StandOnXCalc};

 PUBLIC PROCEDURE AddXA2Saldo(VAR trgSum: tSum;
                              VAR trgQnt: tQnt;
                              trgSign: NUMERIC[0]);
 BEGIN
  CONFORM(XApport, Apport);
  IF Apport.CirType = L_Acnt.ct_Credit THEN
   trgSign:=(-1)*trgSign;
  END;
  INC(trgSum, trgSign*XApport.Sum);
  INC(trgQnt, trgSign*XApport.Qnt);
 END {AddXA2Saldo};

 PRIVATE PROCEDURE intOutRSaldo(VAR resSum  : tSum;
                                VAR resQnt  : tQnt;
                                VAR NextXDat: DATE);
  VAR
   _XDat: DATE;
 BEGIN
  SETEMPTY(NextXDat);
  SAVE(XCalc);
  resSum:=XCalc.RSlSum;
  resQnt:=XCalc.RSlQnt;
  CHANGESEL(XCalc, XObject, , XCalc.XObject, XCalc.AcCut);
  _XDat:=XCalc.XDat;
  WHILE OCCURE(XCalc) DO
   SETSEL(XApport, XObject, XCalc.XObject, XCalc.AcCut, XCalc.XDat);
   FOR_EACH XApport DO
    IF    XApport.WFDate = _XDat THEN
     XApport.Sum:=L_General.UnDenominate(XApport.XDat, _XDat, XApport.Sum);
     AddXA2Saldo(resSum, resQnt, +1);
    END;
    IF (XApport.WFDate < XApport.XDat) & (XApport.WFDate >= _XDat) THEN
     NextXDat:=Math.Min(XApport.WFDate, NextXDat);
    END;
   END; (* FOR_EACH XApport *)
   NEXT(XCalc);
  END; (* WHILE OCCURE(XCalc) ... *)
  RESTORE(XCalc);
 END {intOutRSaldo};

 PUBLIC PROCEDURE OutRSaldo(VAR resSum: tSum; VAR resQnt: tQnt);
 BEGIN
  resSum:=XCalc.RSlSum;
  resQnt:=XCalc.RSlQnt;
  SETSEL(XApport, WFD, XCalc.XObject, XCalc.AcCut, XCalc.XDat);
  FOR_EACH XApport DO
   XApport.Sum:=L_General.UnDenominate(XApport.XDat, XApport.WFDate, XApport.Sum);
   AddXA2Saldo(resSum, resQnt, +1);
  END; (* FOR_EACH *)
 END {OutRSaldo};

 PUBLIC PROCEDURE mo_OutRSaldo(): tSum;
  VAR
   resSum: tSum;
   dmyQnt: tQnt;
 BEGIN
  OutRSaldo(resSum, dmyQnt);
  RETURN resSum;
 END {mo_OutRSaldo};

 PUBLIC PROCEDURE GetOutSaldo(trgAcCut: LIKE(XCalc.AcCut);
                              P       : DATE;
                              VAR resSum: tSum;
                              VAR resQnt: tQnt);
 BEGIN
  IF StandOnXCalc(XObject.XObject, trgAcCut, P) THEN
   OutSaldo(resSum, resQnt);
  ELSE
   SETZERO(resSum, resQnt);
  END;
 END {GetOutSaldo};

 PUBLIC PROCEDURE mo_GetOutSaldo(trgAcCut: LIKE(XCalc.AcCut); P: DATE): tSum;
 BEGIN
  IF StandOnXCalc(XObject.XObject, trgAcCut, P) THEN
   RETURN mo_OutSaldo();
  ELSE
   RETURN 0;
  END;
 END {mo_GetOutSaldo};

 PUBLIC PROCEDURE mo_GetOutRSaldo(trgAcCut: LIKE(XCalc.AcCut); P: DATE): tSum;
 BEGIN
  IF StandOnXCalc(XObject.XObject, trgAcCut, P) THEN
   RETURN mo_OutRSaldo();
  ELSE
   RETURN 0;
  END;
 END {mo_GetOutRSaldo};

 PUBLIC PROCEDURE mo_GetInSaldo(trgAcCut: LIKE(AcCut.AcCut); P: DATE): tSum;
 BEGIN
  RETURN mo_GetOutSaldo(trgAcCut, L_DatTim.Per(P)-1);
 END {mo_GetInSaldo};

 PUBLIC PROCEDURE mo_GetInRSaldo(trgAcCut: LIKE(AcCut.AcCut); P: DATE): tSum;
 BEGIN
  RETURN mo_GetOutRSaldo(trgAcCut, L_DatTim.Per(P)-1);
 END {mo_GetInRSaldo};

 PUBLIC PROCEDURE qo_GetInSaldo(trgAcCut: LIKE(AcCut.AcCut); P: DATE): tQnt;
  VAR
   dmySum: tSum;
   resQnt: tQnt;
 BEGIN
  GetOutSaldo(trgAcCut, L_DatTim.Per(P)-1, dmySum, resQnt);
  RETURN resQnt;
 END {qo_GetInSaldo};

 PRIVATE PROCEDURE GetConcurrentOutRQnt(trgAcCut: LIKE(AcCut.AcCut); P: DATE): tQnt;
  VAR
   Result: tQnt;
 BEGIN
  Result:=0;
  IF StandOnXCalc(XObject.XObject, trgAcCut, P) THEN
   Result:=CONCURRENTGET(XCalc, RSlQnt, CONCURRENTGET_MIN);
   SELECT(XApport, WFD, , XCalc.XObject, XCalc.AcCut, XCalc.XDat);
   WHILE OCCURE(XApport) DO
    CONFORM(XApport, Apport);
    IF Apport.CirType = L_Acnt.ct_Credit THEN
     DEC(Result, CONCURRENTGET(XApport, Qnt, CONCURRENTGET_MAX));
    ELSE
     INC(Result, CONCURRENTGET(XApport, Qnt, CONCURRENTGET_MAX));
    END;
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
  END;
  RETURN Result;
 END {GetConcurrentOutRQnt};

 PUBLIC PROCEDURE GetOutRSaldo(trgAcCut: LIKE(XCalc.AcCut);
                               P       : DATE;
                               VAR resSum: tSum;
                               VAR resQnt: tQnt);
 BEGIN
  IF StandOnXCalc(XObject.XObject, trgAcCut, P) THEN
   OutRSaldo(resSum, resQnt);
  ELSE
   SETZERO(resSum, resQnt);
  END;
 END {GetOutRSaldo};

 PUBLIC PROCEDURE extBalXCalc(Silent: SCAL[2]);
  VAR
   sldSum,
   rslSum,
   rsdSum  : tSum;
   sldQnt,
   rslQnt,
   rsdQnt  : tQnt;
   prvXD,
   nxtXD   : DATE;
   inCM    : SCAL[2];
 BEGIN
  IF ~L_XDR.XDocRepDo() THEN
   IF OCCURE(XCalc) THEN
    SAVE(XCalc);
    prvXD:=XCalc.XDat;
    OutSaldo(sldSum, sldQnt);
    intOutRSaldo(rslSum, rslQnt, nxtXD);
    NEXT(XCalc);
    WHILE OCCURE(XCalc) DO
     GETLASTVERSION(XCalc);
     sldSum:=L_General.Denominate(prvXD, XCalc.XDat, sldSum);
     inCM:=L_DatTim.Per(XCalc.XDat) < ClcPer(SectionOfXObjectAcCut(XCalc.AcCut));
     IF inCM & ((XCalc.SldSum # sldSum) | (XCalc.SldQnt # sldQnt)) THEN
      IF L_General.IsAdmin() THEN
       IF ~Silent THEN
        L_StdFrm.Choice(", , ந 樨," +
                        "|騥   ᠫ줮  ⮬  " +
                        L_DatTim.PeriodStr(XCalc.XDat) +
                        "| 祭 ᭮ !!!");
        L_StdFrm.Choice("⢨⥫쭮 த?");
        Silent:=1;
       END;
      ELSE
       L_General.Error(" ᠫ줮  " + L_DatTim.DateStr(XCalc.XDat));
      END;
     END;
     XCalc.SldSum:=sldSum;
     XCalc.SldQnt:=sldQnt;
     rslSum:=L_General.Denominate(prvXD, XCalc.XDat, rslSum);
     XCalc.RSlSum:=rslSum;
     XCalc.RSlQnt:=rslQnt;
     REPLACE(XCalc);
     IF XCalc.XDat < nxtXD THEN
      rsdSum:=rslSum;
      rsdQnt:=rslQnt;
      DEC(rsdSum, sldSum);
      DEC(rsdQnt, sldQnt);
     ELSE
      SETEMPTY(rsdSum, rsdQnt);
     END;
     prvXD:=XCalc.XDat;
     OutSaldo(sldSum, sldQnt);
     IF inCM THEN
      IF ~!rsdSum THEN
       rslSum:=sldSum;
       rslQnt:=sldQnt;
       INC(rslSum, rsdSum);
       INC(rslQnt, rsdQnt);
      ELSE
       intOutRSaldo(rslSum, rslQnt, nxtXD);
      END;
     ELSE
      rslSum:=sldSum;
      rslQnt:=sldQnt;
     END;
     NEXT(XCalc);
    END;
    RESTORE(XCalc);
   END; (* IF OCCURE(XCalc) ... *)
  END; (* IF ~L_XDR.XDocRepDo() ... *)
 END {extBalXCalc};

 PUBLIC PROCEDURE BalXCalc();
 BEGIN
  extBalXCalc(0);
 END {BalXCalc};

 PUBLIC PROCEDURE SrcXCalc(_AcCut: LIKE(AcCut.AcCut); P: DATE): SCAL[2];
 BEGIN
  SETSEL(XCalc, XObject, XObject.XObject, _AcCut);
  RETURN SRCINSEL(XCalc, EQ, P);
 END {SrcXCalc};

 PUBLIC PROCEDURE FixXCalc(_AcCut: LIKE(AcCut.AcCut); _XDat: DATE);
  VAR
   sldSum,
   rslSum  : tSum;
   sldQnt,
   rslQnt  : tQnt;
   _PrvXD  : DATE;
 BEGIN
  IF ~SrcXCalc(_AcCut, _XDat) THEN
   IF SRCINSEL(XCalc, LE, _XDat) THEN
    _PrvXD :=XCalc.XDat;
    OutSaldo (sldSum, sldQnt);
    OutRSaldo(rslSum, rslQnt);
   ELSE
    _PrvXD:=_XDat;
    SETZERO(sldSum, sldQnt, rslSum, rslQnt);
   END;
   DEFAULT(XCalc);
   XCalc.XObject :=XObject.XObject;
   XCalc.AcCut:=_AcCut;
   XCalc.XDat :=_XDat;
   sldSum:=L_General.Denominate(_PrvXD, XCalc.XDat, sldSum);
   XCalc.SldSum:=sldSum;
   XCalc.SldQnt:=sldQnt;
   rslSum:=L_General.Denominate(_PrvXD, XCalc.XDat, rslSum);
   XCalc.RSlSum:=rslSum;
   XCalc.RSlQnt:=rslQnt;
   INSERT(XCalc);
  ELSIF _XDat=L_General.DenominationDate() THEN
   SAVE(XCalc);
   IF PREV(XCalc) THEN
    _PrvXD:=XCalc.XDat;
    OutSaldo (sldSum, sldQnt);
    OutRSaldo(rslSum, rslQnt);
    RESTORE(XCalc);
    sldSum:=L_General.Denominate(_PrvXD, XCalc.XDat, sldSum);
    XCalc.SldSum:=sldSum;
    XCalc.SldQnt:=sldQnt;
    rslSum:=L_General.Denominate(_PrvXD, XCalc.XDat, rslSum);
    XCalc.RSlSum:=rslSum;
    XCalc.RSlQnt:=rslQnt;
    REPLACE(XCalc);
   ELSE
    RESTORE(XCalc);
   END;
  END;
  GETLASTVERSION(XCalc);
 END {FixXCalc};

 PRIVATE PROCEDURE TryConcurrentModifyXCalc(_AcCut: LIKE(AcCut.AcCut); clcXDat, curXDat: DATE): SCAL[2];
  VAR
   tstXDat,
   trgXDat: DATE;
   Result : SCAL[2];
 BEGIN
  Result:=0;
  TRY
   L_General.DisableDebuggerExceptionBreak();
   tstXDat:=Math.Min(curXDat, clcXDat);
   trgXDat:=Math.Max(curXDat, clcXDat);
   LOOP
    CONCURRENTADDONLY(XCalc, XObject,
                       XObject.XObject, _AcCut, tstXDat,
                      DbtSum, 0);
    CHANGESEL(XCalc, XObject, , XCalc.XObject, XCalc.AcCut);
    IF ~NEXT(XCalc) THEN
     IF tstXDat >= trgXDat THEN
      EXIT;
     ELSE
      L_General.RaiseLockReleaseException();
     END;
    ELSE
     tstXDat:=L_DatTim.IncMonth(tstXDat, +1);
     IF tstXDat # XCalc.XDat THEN
      L_General.RaiseLockReleaseException();
     END;
    END;
   END; (* LOOP *)
   Result:=1;
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF (Exc.ErrorCode # L_General.ec_rt_InsAttemptInAddOnly) &
      (Exc.ErrorCode # L_General.ec_rt_RecAccessDeniedByOwnTRN) THEN
    RAISE();
   END;
  ON Exc: Exc_AccessDeny DO
   (* 䫨 稬  筮 ७⭮ 䨪樨 *)
  ON Exc: Exc_Raise DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  RETURN Result;
 END {TryConcurrentModifyXCalc};

 PUBLIC PROCEDURE Add2XC(trgSign: NUMERIC[0]; curSum: LIKE(XApport.Sum); curQnt: LIKE(XApport.Qnt));
 BEGIN
  CONFORM(XApport, Apport);
  IF Apport.CirType = L_Acnt.ct_Debit THEN
   INC(XCalc.DbtSum, trgSign*curSum);
   INC(XCalc.DbtQnt, trgSign*curQnt);
  ELSE
   INC(XCalc.CrdSum, trgSign*curSum);
   INC(XCalc.CrdQnt, trgSign*curQnt);
  END;
 END {Add2XC};

 PUBLIC PROCEDURE AddXA2XC(trgSign: NUMERIC[0]);
 BEGIN
  Add2XC(trgSign, XApport.Sum, XApport.Qnt);
 END {AddXA2XC};

 PRIVATE PROCEDURE intCheckXCalcOutSaldoErrorMsg(curSum: tSum; curQnt: tQnt): STRING[];
  VAR
   wSum,
   wQnt      : SCAL[2];
   Result    : STRING[];
 BEGIN
  Result:="";
  IF (curSum # 0) | (curQnt # 0) THEN
   IF    AcCut.SldType = L_AcCut.sldt_wAmount       THEN wSum:=curSum < 0; wQnt:=curQnt < 0;
   ELSIF AcCut.SldType = L_AcCut.sldt_OnlyDebit     THEN wSum:=curSum < 0; wQnt:=0;
   ELSIF AcCut.SldType = L_AcCut.sldt_OnlyCredit    THEN wSum:=curSum > 0; wQnt:=0;
   ELSIF AcCut.SldType = L_AcCut.sldt_wAmountCredit THEN wSum:=curSum > 0; wQnt:=curQnt > 0;
   ELSE
    L_General.CallUs(0);
   END;
   IF wSum | wQnt THEN
    Result:="|⨬ 稭 ᠫ줮: ";
    IF wSum THEN
     INC(Result, FLDTOSTR(curSum, "2-", 0) + "(㬬)");
    END;
    IF wQnt THEN
     IF wSum THEN
      INC(Result, "  ");
     END;
     INC(Result, FLDTOSTR(curQnt, "3.", 0) + "(⢮)");
    END;
    INC(Result, "||");
    INC(Result, ErrorPoint1(XCalc.AcCut, L_DatTim.NextPer(XCalc.XDat)));
    INC(Result, L_StdFrm.THR(" 稭"));
    INC(Result,         "1 ⢨⥫쭮 '⮣ ⮫쪮 ';                          "
                + "|" + "2  㬥 (⮬  㣨) 訡筮 㪠 㣮 ꥪ;"
                + "|" + "3  ࠡ⠭ 㣨 㬥  ⮬ ꥪ;            "
                + "|" + "4 ୮ ᠭ 奬 樨;                             "
                + "|" + "5  ᠭ ࠧ१ ୮ 㪠 ' ⨬ ᠫ줮'  ");
   END;
  END;
  RETURN Result;
 END {intCheckXCalcOutSaldoErrorMsg};

 PRIVATE PROCEDURE CheckXCalcOutSaldo();
  VAR
   sldSum : tSum;
   sldQnt : tQnt;
   ErrMsg : STRING[];
 BEGIN
  SAVE(AcCut);
  L_AcCut.PositionOnAcCut(XCalc.AcCut);
  IF AcCut.SldType # L_AcCut.sldt_DebitCredit THEN
   OutRSaldo(sldSum, sldQnt);
   ErrMsg:=intCheckXCalcOutSaldoErrorMsg(sldSum, sldQnt);
   IF ~!ErrMsg THEN
    L_General.Error(ErrMsg);
   END;
  END;
  RESTORE(AcCut);
 END {CheckXCalcOutSaldo};

 PUBLIC PROCEDURE GetBeginOfAccountingOnAcCut(_AcCut: LIKE(AcCut.AcCut)): DATE;
  VAR
   Result: DATE;
 BEGIN
  SETEMPTY(Result);
  SAVE(ACLog);
  SELECT(ACLog, AcCut, , _AcCut);
  LOOP
   IF ~OCCURE(ACLog) THEN
    EXIT;
   ELSIF ACLog.DoAcnt = acda_Yes THEN
    Result:=ACLog.Date;
    EXIT;
   END;
   NEXT(ACLog);
  END;
  RESTORE(ACLog);
  RETURN Result;
 END {GetBeginOfAccountingOnAcCut};

 PUBLIC PROCEDURE GetAcCutDoAcnt(P: DATE; _XObject: LIKE(XObject.XObject); _AcCut: LIKE(AcCut.AcCut); _Apport: LIKE(Apport.Apport)): tDoAcnt;
  VAR
   Result: tDoAcnt;
 BEGIN
  IF L_Acnt.IsEntranceApport(_Apport) THEN
   P:=L_DatTim.IncMonth(P, +1);
  END;
  SAVE(XObject);
  SAVE(ACLog);
  AccessXObject(_XObject);
  IF    XObject.Origin = o_Contract THEN
   SAVE(Contract);
   L_General.CallUs(SELECT(Contract, XObject, _XObject));
   L_General.Assert(SEARCH(ACSetL, ACSet, Contract.ACSet, L_Acnt.acp_Contract_Netto), "   ࠧ१ "+Contract.ACSet+"  । 祭 '"+L_Str.PoolItem(L_Acnt.acp_Pool, L_Acnt.acp_Contract_Netto)+"'");
   _AcCut:=ACSetL.AcCut;
   RESTORE(Contract);
  END;
  L_Acnt.AccessACLog(P, _AcCut);
  Result:=ACLog.DoAcnt;
  RESTORE(ACLog);
  RESTORE(XObject);
  RETURN Result;
 END {GetAcCutDoAcnt};

 PRIVATE PROCEDURE uncondMakeApp(_Sign     : NUMERIC[0];
                                 Concurrent: SCAL[2];
                                 _AcCut    : LIKE(AcCut.AcCut);
                                 _XDat     : DATE;
                                 _WFDate   : DATE;
                                 _Apport   : LIKE(Apport.Apport);
                                 _XObject2 : LIKE(XObject.XObject);
                                 _AcCut2   : LIKE(AcCut2.AcCut2);
                                 _Apport2  : LIKE(Apport.Apport);
                                 curSum    : tSum;
                                 curQnt    : tQnt;
                                 _Source   : tSource);
 BEGIN
  IF _WFDate > _XDat THEN
   L_General.CallUs(0);
  END;
  IF Concurrent & L_General.DoConcurrentModification() THEN
   CONCURRENTADD(XApport, XObject,
                  XObject.XObject, _AcCut, _XDat, _Apport, _AcCut2, _WFDate, _Source,(* _Apport2, _XObject2,*)
                 Sum, _Sign*curSum,
                 Qnt, _Sign*curQnt);
  ELSE
   ADD(XApport, XObject, , XObject.XObject, _AcCut, _XDat, _Apport, _AcCut2, _WFDate, _Source,(* _Apport2, _XObject2,*)
       XApport.Sum, _Sign*curSum,
       XApport.Qnt, _Sign*curQnt);
  END;
 END {uncondMakeApp};

 PRIVATE PROCEDURE intMakeApp(uncond    : SCAL[2];
                              _Sign     : NUMERIC[0];
                              Concurrent: SCAL[2];
                              _AcCut    : LIKE(AcCut.AcCut);
                              _XDat     : DATE;
                              _WFDate   : DATE;
                              _Apport   : LIKE(Apport.Apport);
                              _XObject2 : LIKE(XObject.XObject);
                              _AcCut2   : LIKE(AcCut2.AcCut2);
                              _Apport2  : LIKE(Apport.Apport);
                              VAR curSum: tSum;
                              curQnt    : tQnt;
                              _Source   : tSource);
  VAR
   _DoAcnt: tDoAcnt;
 BEGIN
  _DoAcnt:=GetAcCutDoAcnt(_WFDate, XObject.XObject, _AcCut, _Apport);
  IF   uncond | (_DoAcnt = acda_Yes) | (_AcCut = L_AcCut.erkn_GetSoft(_XDat, L_AcCut.erkn_OnlineBalance)) THEN
   uncondMakeApp(_Sign, Concurrent, _AcCut, _XDat, _WFDate, _Apport, _XObject2, _AcCut2, _Apport2,
                 curSum, curQnt, _Source);
  ELSIF _DoAcnt = acda_No THEN
   L_General.Error("⪠ 믮 ⮢  ࠧ१ " + _AcCut + "  " + L_DatTim.PeriodStr(_WFDate));
  ELSIF _DoAcnt = acda_Ignore THEN
   SETEMPTY(curSum);
  ELSE
   L_General.CallUs(0);
  END;
 END {intMakeApp};

 PRIVATE PROCEDURE MakeApp(uncond    : SCAL[2];
                           _Sign     : NUMERIC[0];
                           Concurrent: SCAL[2];
                           _AcCut    : LIKE(AcCut.AcCut);
                           _XDat     : DATE;
                           _WFDate   : DATE;
                           _Apport   : LIKE(Apport.Apport);
                           _XObject2 : LIKE(XObject.XObject);
                           _AcCut2   : LIKE(AcCut2.AcCut2);
                           _Apport2  : LIKE(Apport.Apport);
                           VAR curSum: tSum;
                           curQnt    : tQnt;
                           _Source   : tSource);
 BEGIN
  curSum:=RoundXObject(L_General.Denominate(_WFDate, _XDat, curSum));
  IF (curSum # 0) | (curQnt # 0) THEN
   intMakeApp(uncond, _Sign, Concurrent, _AcCut, _XDat, _WFDate, _Apport, _XObject2, _AcCut2, _Apport2, curSum, curQnt, _Source);
  END;
 END {MakeApp};

 PRIVATE PROCEDURE XODone_Src(P: DATE): SCAL[2];
 BEGIN
  SETSEL(XODone, XObject, XObject.XObject);
  RETURN SRCINSEL(XODone, EQ, P);
 END {XODone_Src};

 PRIVATE PROCEDURE XODone_SrcLast(P: DATE): SCAL[2];
 BEGIN
  SETSEL(XODone, XObject, XObject.XObject);
  RETURN SRCINSEL(XODone, LE, P);
 END {XODone_SrcLast};

 PRIVATE PROCEDURE XODone_SrcFirst(P: DATE): SCAL[2];
 BEGIN
  SETSEL(XODone, XObject, XObject.XObject);
  RETURN SRCINSEL(XODone, GE, P);
 END {XODone_SrcFirst};

 PRIVATE PROCEDURE XODone_Fix(P: DATE);
 BEGIN
  IF ~XODone_Src(P) THEN
   XODone.XObject:=XObject.XObject;
   XODone.Period :=P;
   SETZERO(XODone.Done, XODone.intmDone);
   XODone.Origin :=XObject.Origin;
   INSERT(XODone);
  END;
 END {XODone_Fix};

 PRIVATE PROCEDURE XODone_ReplaceCurrent(wIntmDone: SCAL[2]);
 BEGIN
  REPLACE(XODone);
  WHILE NEXT(XODone) DO
   GETLASTVERSION(XODone);
   IF wIntmDone THEN
    SETZERO(XODone.intmDone);
   END;
   XODone.Done:=0;
   REPLACE(XODone);
  END;
 END {XODone_ReplaceCurrent};

 PRIVATE PROCEDURE XODone_ConcurrentReset(P: DATE; xoid: NUMERIC[0]);
  VAR
   fieldsList: STRING[];
 BEGIN
  fieldsList:="Done";
  IF ~!xoid THEN
   fieldsList:=fieldsList + ", intmDone[xoid]";
  END;
  CONCURRENTRESET(XODone, XObject,
                   XObject.XObject, P,
                  ^fieldsList);
  IF !XODone.Origin THEN
   GETLASTVERSION(XODone);
   XODone.Origin:=XObject.Origin;
   REPLACE(XODone);
  END;
  fieldsList:="Done";
  IF ~!xoid THEN
   fieldsList:=fieldsList + ", intmDone[0], intmDone[1], intmDone[2], intmDone[3]";
  END;
  CHANGESEL(XODone, XObject, , XODone.XObject);
  WHILE NEXT(XODone) DO
   CONCURRENTRESET(XODone, XObject,
                    XObject.XObject, XODone.Period,
                   ^fieldsList);
  END;
 END {XODone_ConcurrentReset};

 PUBLIC PROCEDURE XODone_SetSingleIntermediate(P: DATE; xoid: NUMERIC[0]; _intmSingleDone: SCAL[2]; forceFix: SCAL[2]);
 BEGIN
  IF (_intmSingleDone = 0) & L_General.DoConcurrentModification() THEN
   XODone_ConcurrentReset(P, xoid);
  ELSE
   IF forceFix THEN
    XODone_Fix(P);
   END;
   IF XODone_SrcFirst(P) THEN
    GETLASTVERSION(XODone);
    IF ((_intmSingleDone = 1) & (XODone.Period = P)) | (_intmSingleDone = 0) THEN
     XODone.intmDone[xoid]:=_intmSingleDone;
    END;
    XODone.Done          :=0;
    XODone_ReplaceCurrent(1);
   END;
  END;
 END {XODone_SetSingleIntermediate};

 PUBLIC PROCEDURE XODone_Set(P: DATE; _Done: SCAL[2]; forceFix: SCAL[2]);
 BEGIN
  IF (_Done = 0) & L_General.DoConcurrentModification() THEN
   XODone_ConcurrentReset(P, L_General.EMPTY_NUMBER());
  ELSE
   IF forceFix THEN
    XODone_Fix(P);
   END;
   IF XODone_SrcFirst(P) THEN
    GETLASTVERSION(XODone);
    IF ((_Done = 1) & (XODone.Period = P)) | (_Done = 0) THEN
     XODone.Done:=_Done;
    END;
    XODone_ReplaceCurrent(0);
   END;
  END;
 END {XODone_Set};

 PUBLIC PROCEDURE XODone_IsSingleIntermediateDone(P: DATE; xoid: NUMERIC[0]): SCAL[2];
 BEGIN
  IF XODone_SrcLast(P) THEN
   RETURN XODone.intmDone[xoid];
  ELSE
   RETURN 1;
  END;
 END {XODone_IsSingleIntermediateDone};

 PUBLIC PROCEDURE XODone_IsDone(P: DATE): SCAL[2];
 BEGIN
  IF XODone_SrcLast(P) THEN
   RETURN XODone.Done;
  ELSE
   RETURN 1;
  END;
 END {XODone_IsDone};

 PUBLIC PROCEDURE wrmdxo_ResetDone(P: DATE; forceFix: SCAL[2]): SCAL[2];
 BEGIN
  XODone_Set(P, 0, forceFix);
  RETURN 1;
 END {wrmdxo_ResetDone};

 PRIVATE PROCEDURE wrmdxo_IsDone(P: DATE; forceFix: SCAL[2]): SCAL[2];
 BEGIN
  RETURN XODone_IsDone(P);
 END {wrmdxo_IsDone};

 PRIVATE PROCEDURE wrmdxo_SetDone(P: DATE; forceFix: SCAL[2]): SCAL[2];
 BEGIN
  XODone_Set(P, 1, forceFix);
  RETURN 1;
 END {wrmdxo_SetDone};

 PRIVATE PROCEDURE WalkRoundMathDoneXObject(_Math: LIKE(Math.Math); _MyFirm: P_Firm.tMyFirm; Proc: PROC[]; P: DATE; forceFix: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   Result:=1;
   IF ~!_MyFirm THEN
    P_Firm.PositionOnMyFirm(_MyFirm);
    IF SEARCH(mItem, Math, _Math, MyFirm.Storage) | forceFix THEN
     IF ~OCCURE(mItem) THEN
      L_Stock.Obtain_mItem(_Math, MyFirm.Storage);
     END;
     CONFORM(mItem, XObject);
     Result:=Proc(P, forceFix);
    END;
   ELSE
    L_General.CallUs(forceFix = 0);
    SETSEL(MyFirm, Storage);
    FOR_EACH MyFirm DO
     IF SEARCH(mItem, Math, _Math, MyFirm.Storage) THEN
      CONFORM(mItem, XObject);
      Result:=Proc(P, forceFix) & Result;
     END;
    END; (* FOR_EACH MyFirm *)
   END;
   RETURN Result;
  EXCEPT
  END; (* TRY *)
 END {WalkRoundMathDoneXObject};

 PUBLIC PROCEDURE mfResetMathDone(_Math: LIKE(Math.Math); _MyFirm: P_Firm.tMyFirm; P: DATE; forceFix: SCAL[2]);
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=WalkRoundMathDoneXObject(_Math, _MyFirm, PROCREF(wrmdxo_ResetDone), P, forceFix);
 END {mfResetMathDone};

 PUBLIC PROCEDURE mfSetMathDone(_Math: LIKE(Math.Math); _MyFirm: P_Firm.tMyFirm; P: DATE);
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=WalkRoundMathDoneXObject(_Math, _MyFirm, PROCREF(wrmdxo_SetDone), P, 0);
 END {mfSetMathDone};

 PUBLIC PROCEDURE mfMathIsDone(_Math: LIKE(Math.Math); _MyFirm: P_Firm.tMyFirm; P: DATE): SCAL[2];
 BEGIN
  RETURN WalkRoundMathDoneXObject(_Math, _MyFirm, PROCREF(wrmdxo_IsDone), P, 0);
 END {mfMathIsDone};

 PRIVATE PROCEDURE ConcurrentUpdateXCalc(_AcCut : LIKE(AcCut.AcCut);
                                         _XDat ,
                                         _WFDate: DATE;
                                         _Sign  : NUMERIC[0];
                                         curSum : tSum;
                                         curQnt : tQnt);
 BEGIN
  CONFORM(XApport, Apport);
  IF Apport.CirType = L_Acnt.ct_Debit THEN
   CONCURRENTADDONLY(XCalc, XObject,
                      XObject.XObject, _AcCut, _XDat,
                     DbtSum, _Sign * curSum,
                     DbtQnt, _Sign * curQnt);
  ELSE
   CONCURRENTADDONLY(XCalc, XObject,
                      XObject.XObject, _AcCut, _XDat,
                     CrdSum, _Sign * curSum,
                     CrdQnt, _Sign * curQnt);
   _Sign:=(-1) * _Sign;
  END;
  SAVE(XCalc);
  CHANGESEL(XCalc, XObject, , XCalc.XObject, XCalc.AcCut);
  WHILE NEXT(XCalc) DO
   CONCURRENTADDONLY(XCalc, XObject,
                      XObject.XObject, XCalc.AcCut, XCalc.XDat,
                     SldSum, _Sign * curSum,
                     SldQnt, _Sign * curQnt,
                     RSlSum, _Sign * curSum,
                     RSlQnt, _Sign * curQnt);
  END; (* WHILE NEXT(XCalc) *)
  IF _WFDate < _XDat THEN
   L_General.CallUs(SRCINSEL(XCalc, GT, _WFDate));
   WHILE OCCURE(XCalc) & (XCalc.XDat <= _XDat) DO
    CONCURRENTADDONLY(XCalc, XObject,
                       XObject.XObject, XCalc.AcCut, XCalc.XDat,
                      RSlSum, _Sign * curSum,
                      RSlQnt, _Sign * curQnt);
    NEXT(XCalc);
   END; (* WHILE OCCURE(XCalc) & ... *)
  END;
  RESTORE(XCalc);
 END {ConcurrentUpdateXCalc};

 PRIVATE PROCEDURE intMakeCir(uncond   : SCAL[2];
                              _Sign    : NUMERIC[0];
                              _XDat    : DATE;
                              _WFDate  : DATE;
                              _AcCut   : LIKE(AcCut.AcCut);
                              _Apport  : LIKE(Apport.Apport);
                              _XObject2: LIKE(XObject.XObject);
                              _AcCut2  : LIKE(AcCut2.AcCut2);
                              _Apport2 : LIKE(Apport2.Apport2);
                              _Source  : tSource;
                              VAR RealXDat: DATE;
                              VAR curSum  : tSum;
                              VAR curQnt  : tQnt);
  VAR
   outRSum   : tSum;
   outRQnt   : tQnt;
   ConcurrentAtAll,
   ConcurrentXCalc: SCAL[2];
   ErrMsg         : STRING[];
 BEGIN
  IF (curSum # 0) | (curQnt # 0) THEN
   IF (L_XDR.XDocRepDo() = L_XDR.xdrd_No) | (L_XDR.XDocRepDo() = L_XDR.xdrd_KeyAss) THEN
    IF IsMaterialXObject() THEN
     SAVE(Math);
     SAVE(mItem);
     SEARCH(mItem, XObject, , XObject.XObject);
     SEARCH(Math, Math, , mItem.Math);
    END;
    IF Clc_CntIsEqual(SectionOfXObjectAcCut(_AcCut)) THEN
     RealXDat:=_XDat;
    ELSE
     IF IsMaterialXObject() & ~L_XDR.XDocRepDo() THEN
      L_AcsPnt.PassAccessPoint(0000037);
     END;
     RealXDat:=ClcPer(SectionOfXObjectAcCut(_AcCut));
    END;
    ConcurrentAtAll:=L_General.DoConcurrentModification();
    ConcurrentXCalc:=ConcurrentAtAll & TryConcurrentModifyXCalc(_AcCut, RealXDat, _XDat);
    IF ~ConcurrentXCalc THEN
     FixXCalc(_AcCut, RealXDat);
    END;
    MakeApp(uncond, _Sign, ConcurrentAtAll, _AcCut, RealXDat, _WFDate, _Apport, _XObject2, _AcCut2, _Apport2,
            curSum, curQnt, _Source);
    IF ~!curSum & ((curSum # 0) | (curQnt # 0)) THEN
     IF ~ConcurrentXCalc THEN
      Add2XC(_Sign, curSum, curQnt);
      REPLACE(XCalc);
     ELSE
      ConcurrentUpdateXCalc(_AcCut, RealXDat, _XDat, _Sign, curSum, curQnt);
     END;
     IF IsMaterialXObject() THEN
      L_General.Assert((!Math.sysTill) | (_AcCut = _AcCut2) |
                       (Apport.CirType = L_Acnt.ct_Credit),
                       "⨬ ⮢ ஢   " + Math.Math);
      IF E_NeedCheckXCalcRest(RealXDat) & (_Sign > 0) & (Apport.CirType = L_Acnt.ct_Credit) THEN
       IF ~ConcurrentXCalc THEN
        IF Clc_CntIsEqual(SectionOfXObjectAcCut(_AcCut)) THEN
         OutSaldo(outRSum, outRQnt);
        ELSE
         SAVE(XCalc);
         FixXCalc(_AcCut, _XDat);
         OutRSaldo(outRSum, outRQnt);
         RESTORE(XCalc);
        END;
       ELSE
        outRQnt:=GetConcurrentOutRQnt(_AcCut, _XDat);
       END;

       IF (outRQnt # 0) & L_MathR.AcCutOfRealStock(_AcCut) THEN
        SAVE(AcCut);
        L_AcCut.PositionOnAcCut(_AcCut);
        ErrMsg:=intCheckXCalcOutSaldoErrorMsg(0, outRQnt);
        IF ~!ErrMsg & ~P_Storage.DontCheckXCalcRest(mItem.Storage, _XDat) & (_AcCut # L_AcCut.erkn_GetSoft(_WFDate, L_AcCut.erkn_FuelInTanks)) THEN
         L_MDoc.RaiseCheckXCalcRestException(Math.Math, ErrMsg);
        END;
        RESTORE(AcCut);
       END; (* IF outRQnt < 0 ... *)
      END;
     END; (* IF IsMaterialXObject() *)
     IF ~ConcurrentXCalc THEN
      IF _XDat < RealXDat THEN
       FixXCalc(_AcCut, _XDat);
      END;
      REPLACE(XCalc);
      BalXCalc();
     END;
     ResetXObjectDone(_XDat, SectionOfXObjectAcCut(_AcCut), 1);
     IF _XDat < RealXDat THEN
      ResetXObjectDone(RealXDat, SectionOfXObjectAcCut(_AcCut), 1);
     END;
    END;
    IF IsMaterialXObject() THEN
     RESTORE(mItem);
     RESTORE(Math);
    END;
   END; (* IF (L_XDR.XDocRepDo() = L_XDR.xdrd_No) | (L_XDR.XDocRepDo() = L_XDR.xdrd_KeyAss) ... *)
  END; (* IF (curSum # 0) | (curQnt # 0) ... *)
 END {intMakeCir};

 PUBLIC PROCEDURE extMakeCompleteCir(uncond     : SCAL[2];
                                     trgXDocId  : L_XDoc.tXDocId;
                                     trgSign    : NUMERIC[0];
                                     trgXDat    : DATE;
                                     trgXObject : LIKE(XObject.XObject);
                                     trgAcCut   : LIKE(AcCut.AcCut);
                                     trgApport  : LIKE(Apport.Apport);
                                     wQnt       : SCAL[2];
                                     trgXObject2: LIKE(XObject.XObject);
                                     trgAcCut2  : LIKE(AcCut2.AcCut2);
                                     trgApport2 : LIKE(Apport2.Apport2);
                                     wQnt2      : SCAL[2];
                                     curSum     : tSum;
                                     curQnt     : tQnt;
                                     trgSource  : tSource);
  VAR
   curMyFirm: LIKE(XObject.MyFirm);
   rs1Sum,
   rs2Sum   : tSum;
   rs1Qnt,
   rs2Qnt   : tQnt;
   RealXDat,
   RealXDat2,
   trgWFDate: DATE;
 BEGIN
  trgWFDate:=Memo.gl_mb();
  SETEMPTY(curMyFirm, rs1Sum, rs1Qnt, rs2Sum, rs2Qnt, RealXDat, RealXDat2);
  SAVE(XObject);
  IF ~!trgXObject THEN
   AccessXObject(trgXObject);
   curMyFirm:=XObject.MyFirm;
   rs1Sum:=curSum;
   IF wQnt THEN
    rs1Qnt:=curQnt;
   ELSE
    rs1Qnt:=0;
   END;
   intMakeCir(uncond, trgSign, trgXDat, trgWFDate, trgAcCut, trgApport, trgXObject2, trgAcCut2, trgApport2, trgSource, RealXDat,
              rs1Sum, rs1Qnt);
   IF !rs1Sum THEN
    SETEMPTY(trgXObject, trgApport, RealXDat);
   END;
  END;
  IF ~!trgXObject2 THEN
   AccessXObject(trgXObject2);
   IF ~!curMyFirm & (XObject.MyFirm # curMyFirm) THEN
    L_General.Error("   ஢  ꥪ⠬   ࠧ ࣠権");
   END;
   rs2Sum:=curSum;
   IF wQnt2 THEN
    rs2Qnt:=curQnt;
   ELSE
    rs2Qnt:=0;
   END;
   intMakeCir(uncond, trgSign, trgXDat, trgWFDate, trgAcCut2, trgApport2, trgXObject, trgAcCut, trgApport, trgSource, RealXDat2,
              rs2Sum, rs2Qnt);
   IF !rs2Sum THEN
    SETEMPTY(trgXObject2, trgApport2, RealXDat2);
   END;
  END;
  IF    !rs1Sum THEN
   curSum:=rs2Sum;
  ELSIF !rs2Sum THEN
   curSum:=rs1Sum;
  ELSIF rs1Sum = rs2Sum THEN
   curSum:=rs1Sum;
  ELSE
   L_General.CallUs(0);
  END;
  IF    ~!RealXDat THEN
   L_General.Assert(!RealXDat2 | (RealXDat2 = RealXDat), " ஭  ஢  ࠧ  ਮ");
  ELSIF ~!RealXDat2 THEN
   RealXDat:=RealXDat2;
  END;
  IF ~!curSum & ((curSum # 0) | (curQnt # 0)) THEN
   IF ~!RealXDat & L_Acnt.E_DoXDocApr(trgWFDate, trgSource, trgXDocId) THEN
    L_General.CallUs((trgSign > 0) | uncond);
    ADD(XDocApr, XDocApr, , trgXDocId, RealXDat, trgWFDate,
                            trgXObject,  trgAcCut,  trgApport,
                            trgXObject2, trgAcCut2, trgApport2, (wQnt+wQnt2*2), trgSource,
        XDocApr.Sum, trgSign * curSum,
        XDocApr.Qnt, trgSign * curQnt);
   END;
   IF L_XDR.XDocRepDo() THEN
    L_XDR.AddToEntryList(trgXObject,  trgAcCut,  trgApport,  wQnt,
                         trgXObject2, trgAcCut2, trgApport2, wQnt2, curSum, curQnt);
   END;
  END;
  RESTORE(XObject);
 END {extMakeCompleteCir};

 PUBLIC PROCEDURE MakeCompleteCir(_Sign    : NUMERIC[0];
                                  _XDat    : DATE;
                                  _XObject : LIKE(XObject.XObject);
                                  _AcCut   : LIKE(AcCut.AcCut);
                                  _Apport  : LIKE(Apport.Apport);
                                  wAmount  : SCAL[2];
                                  _XObject2: LIKE(XObject.XObject);
                                  _AcCut2  : LIKE(AcCut2.AcCut2);
                                  _Apport2 : LIKE(Apport2.Apport2);
                                  wAmount2 : SCAL[2];
                                  curSum   : tSum;
                                  curQnt   : tQnt;
                                  _Source  : tSource);
 BEGIN
  extMakeCompleteCir(0, L_XDR.XDocId, _Sign, _XDat, _XObject,  _AcCut,  _Apport,  wAmount,
                                                    _XObject2, _AcCut2, _Apport2, wAmount2,
                                                    curSum, curQnt, _Source);
 END {MakeCompleteCir};

 PUBLIC PROCEDURE extMakeCir(trgSign  : NUMERIC[0];
                             trgAcCut : LIKE(AcCut.AcCut);
                             trgXDat  : DATE;
                             trgWFDate: DATE;
                             trgApport: LIKE(Apport.Apport);
                             trgAcCut2: LIKE(AcCut2.AcCut2);
                             curSum   : tSum;
                             curQnt   : tQnt;
                             trgSource: tSource);
 BEGIN
  SAVE(XObject);
  L_General.CallUs(trgWFDate = Memo.gl_mb());
  extMakeCompleteCir(0, L_XDR.XDocId, trgSign, trgXDat, XObject.XObject,      trgAcCut,  trgApport,                1,
                                                    EMPTYOF(XObject.XObject), trgAcCut2, EMPTYOF(Apport2.Apport2), 1,
                                                    curSum, curQnt, trgSource);
  RESTORE(XObject);
 END {extMakeCir};

 PUBLIC PROCEDURE MakeCir(_Sign  : NUMERIC[0];
                          _AcCut : LIKE(AcCut.AcCut);
                          _XDat  : DATE;
                          _Apport: LIKE(Apport.Apport);
                          _AcCut2: LIKE(AcCut2.AcCut2);
                          curSum : tSum;
                          curQnt : tQnt;
                          _Source: tSource);
 BEGIN
  extMakeCir(_Sign, _AcCut, _XDat, _XDat, _Apport, _AcCut2, curSum, curQnt, _Source);
 END {MakeCir};

 PUBLIC PROCEDURE mo_MakeCir(curSign  : NUMERIC[0];
                             curAcCut : LIKE(AcCut.AcCut);
                             curXDat  : DATE;
                             curApport: LIKE(Apport.Apport);
                             curAcCut2: LIKE(AcCut2.AcCut2);
                             curSum   : tSum;
                             curSource: tSource);
 BEGIN
  MakeCir(curSign, curAcCut, curXDat, curApport, curAcCut2, curSum, 0, curSource);
 END {mo_MakeCir};

 PRIVATE PROCEDURE IsZeroCir(): SCAL[2];
 BEGIN
  RETURN (XApport.Sum=0) & (XApport.Qnt=0);
 END {IsZeroCir};

 PUBLIC PROCEDURE SelectXDocAprByXApport(leftSide: SCAL[2]);
 BEGIN
  IF leftSide THEN
   SELECT(XDocApr, AcCut, , XApport.AcCut, XApport.XDat, XApport.XObject, XApport.Apport, XApport.AcCut2, XApport.WFDate, XApport.Source);
  ELSE
   SELECT(XDocApr, AcCut2, , XApport.AcCut, XApport.XDat, XApport.XObject, XApport.Apport, XApport.AcCut2, XApport.WFDate, XApport.Source);
  END;
 END {SelectXDocAprByXApport};

 PRIVATE PROCEDURE XApportHasXDocApr(): SCAL[2];
 BEGIN
  SelectXDocAprByXApport(0);
  IF ~OCCURE(XDocApr) THEN
   SelectXDocAprByXApport(1);
  END;
  RETURN OCCURE(XDocApr);
 END {XApportHasXDocApr};

 PUBLIC PROCEDURE CheckXCalcIncorrectMonthOpen();
  VAR
   curSection: tSection;
 BEGIN
  SAVE(XApport);
  IF SELECT(XApport, WFD, XCalc.XObject, XCalc.AcCut, Memo.gl_mb()) THEN
   SAVE(XObject);
   CONFORM(XCalc, XObject);
   curSection:=SectionOfXObjectAcCut(XCalc.AcCut);
   RESTORE(XObject);
   SRCINSEL(XApport, GT, , ClcPer(curSection));
   WHILE OCCURE(XApport) DO
    L_General.Assert(IsZeroCir() |
                     (curSection = s_Salary) |
                     (XApport.Source = src_Online), "᫥   ⠫ ஢   ਮ"+
                     "|室 믮  "+L_DatTim.PeriodStr(Memo.gl_mb())+"  筨 '"+L_Str.PoolItem(src_Pool, XApport.Source)+"'");
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
  END;
  RESTORE(XApport);
 END {CheckXCalcIncorrectMonthOpen};

 PUBLIC PROCEDURE intRenXCalc(wRemove: SCAL[2]);
  VAR
   _XDat,
   _ClcPer   : DATE;
   SldSum,
   curSum    : tSum;
   SldQnt,
   curQnt    : tSum;
   rorApport : LIKE(Apport.Apport);
   dbtXObject,
   crdXObject: LIKE(XObject.XObject);
   dbtAcCut,
   crdAcCut  : LIKE(AcCut.AcCut);
 BEGIN
  IF XCalc.AcCut = L_AcCut.Fictive() THEN
   CONFORM(XCalc, XApport);
   WHILE OCCURE(XApport) DO
    L_General.Assert(IsZeroCir(), "   ஢  ࠧ१ " + XCalc.AcCut + "?");
    REMOVE(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
   RETURN;
  END;
  _ClcPer:=ClcPer(SectionOfXObjectAcCut(XCalc.AcCut));
  L_General.CallUs(L_DatTim.Per(XCalc.XDat) <= _ClcPer);

  IF L_DatTim.Per(XCalc.XDat) = _ClcPer THEN
   SETZERO(XCalc.DbtSum, XCalc.DbtQnt, XCalc.CrdSum, XCalc.CrdQnt);
   CONFORM(XCalc, XApport);
   WHILE OCCURE(XApport) DO
    IF IsZeroCir() THEN
     IF wRemove &
        (XApport.Source # src_Operator) & (XApport.Source # src_Converter) &
        ~XApportHasXDocApr() (* 0085905 *) THEN
      REMOVE(XApport);
     ELSE
      NEXT(XApport);
     END;
    ELSE
     AddXA2XC(+1);
     NEXT(XApport);
    END; (* IF ... *)
   END; (* WHILE OCCURE(XApport) ... *)
   REPLACE(XCalc);
  END;

  IF (XObject.Origin = o_Math) & L_MathR.AcCutOfRealStock(XCalc.AcCut) THEN
   SETZERO(curSum, curQnt);
   OutRSaldo(SldSum, SldQnt);
   IF    (SldQnt = 0) & (SldSum # 0) THEN
    curSum:=SldSum;
   ELSE
    curSum:=SldSum - RoundXObject(SldSum);
   END;
   IF curSum # 0 THEN
    TRY [RESTORE_CURSORS(RC_ON)]
     IF E_DoSecondSide(XCalc.XDat) THEN
      SEARCH(CostItem, CostItem, , L_kn.Get_wMF(Memo.gl_mb(), L_CI.erkn_ReminderOfRound, XObject.MyFirm));
      IF curSum > 0 THEN
       dbtXObject:=CostItem.XObject;
       dbtAcCut  :=L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItem_Default);
       crdXObject:=XCalc.XObject;
       crdAcCut  :=XCalc.AcCut;
      ELSE
       dbtXObject:=XCalc.XObject;
       dbtAcCut  :=XCalc.AcCut;
       crdXObject:=CostItem.XObject;
       crdAcCut  :=L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItemSale);
      END;
      extMakeCompleteCir(0, L_XDoc.curXDocId(L_XDoc.xdt_ACalc),
                         +1, XCalc.XDat, dbtXObject, dbtAcCut, L_Acnt.E_Apport_MoneyDebit (Memo.gl_mb()), 0,
                                         crdXObject, crdAcCut, L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb()), 0,
                         curSum, 0, src_ACalc);
     ELSE
      rorApport:=L_Acnt.E_Apport_RemainderOfRound(XCalc.XDat);
      L_General.Assert(SEARCH(Apport, Apport, rorApport), " ᯮ樨 " + rorApport);
      L_General.Assert(Apport.CirType = L_Acnt.ct_Credit, " ⨯ ⮢  ᯮ樨 " + rorApport);
      _XDat:=XCalc.XDat;
      FixXCalc(XCalc.AcCut, _ClcPer);
      intMakeApp(0, +1, 0, XCalc.AcCut, _ClcPer, _XDat, rorApport,
                 L_General.EMPTY_NUMBER(), rorApport(*bullshit*), L_General.EMPTY_NUMBER(),
                 curSum, curQnt, src_Math);
      Add2XC(+1, curSum, curQnt);
      REPLACE(XCalc);
     END;
    EXCEPT
    END; (* TRY *)
    ResetXObjectDone(_ClcPer, SectionOfXObjectAcCut(XCalc.AcCut), 1);
   END;
  END;

  IF SELECT(XApport, WFD, XCalc.XObject, XCalc.AcCut, XCalc.XDat) THEN
   CheckXCalcIncorrectMonthOpen();
  ELSIF L_DatTim.Per(XCalc.XDat) = _ClcPer THEN
   IF ~SELECT(XApport, XObject, XCalc.XObject, XCalc.AcCut, XCalc.XDat) THEN
    IF XCalc.XDat # L_General.DenominationDate() THEN
     REMOVE(XCalc);
     IF OCCURE(XCalc) THEN
      IF ~PREV(XCalc) THEN
       FIRST(XCalc);
       SETZERO(XCalc.SldSum, XCalc.SldQnt, XCalc.RSlSum, XCalc.RSlQnt);
       REPLACE(XCalc);
      END;
      BalXCalc();
     END;
     RETURN;
    END;
   END; (* IF OCCURE(XApport) ... *)
  END; (* IF L_DatTim.Per( ... *)
  CheckXCalcOutSaldo();
  BalXCalc();
 END {intRenXCalc};

 PUBLIC PROCEDURE RenXCalc();
 BEGIN
  intRenXCalc(1);
 END {RenXCalc};

 PUBLIC PROCEDURE RenovateXCalc(_AcCut: LIKE(AcCut.AcCut); _XDat: DATE);
 BEGIN
  SETSEL(XCalc, XObject, XObject.XObject, _AcCut);
  IF SRCINSEL(XCalc, EQ, _XDat) THEN
   RenXCalc();
  END;
 END {RenovateXCalc};

 PUBLIC PROCEDURE AddOldXApport(curSum: tSum; curQnt: tQnt; curSource: tSource);
  VAR
   _XDat: DATE;
 BEGIN
  IF (curSum # 0) | (curQnt # 0) THEN
   _XDat:=ClcPer(SectionOfXObjectAcCut(XCalc.AcCut));
   SAVE(XCalc);
   SAVE(XApport);
   FixXCalc(XApport.AcCut, _XDat);
   RESTORE(XApport);
   SAVE(XApport);
   MakeApp(0, +1, 0, XApport.AcCut, _XDat, XApport.WFDate,
           XApport.Apport, L_General.EMPTY_NUMBER()(*XApport.XObject2*), XApport.AcCut2, L_General.EMPTY_NUMBER()(*XApport.Apport2*),
           curSum, curQnt, curSource);
   RESTORE(XApport);
   Add2XC(+1, curSum, curQnt);
   REPLACE(XCalc);
   RESTORE(XCalc);
   ResetXObjectDone(_XDat, SectionOfXObjectAcCut(XCalc.AcCut), 1);
  END;
 END {AddOldXApport};

 PUBLIC PROCEDURE ClearXDocApr(_XDocId: L_XDoc.tXDocId; P: DATE);
  VAR
   XDocClcPer,
   xaClcPer,
   xaClcPer2     : DATE;
 BEGIN
  SETEMPTY(XDocClcPer);
  SELECT(XDocApr, XDocApr, , _XDocId);
  WHILE OCCURE(XDocApr) DO
   SETEMPTY(xaClcPer);
   IF ~!XDocApr.XObject THEN
    AccessXObject(XDocApr.XObject);
    xaClcPer:=ClcPer(SectionOfXObjectAcCut(XDocApr.AcCut));
   END;
   IF ~!XDocApr.XObject2 THEN
    AccessXObject(XDocApr.XObject2);
    xaClcPer2:=ClcPer(SectionOfXObjectAcCut(XDocApr.AcCut));
    IF ~!xaClcPer & (xaClcPer # xaClcPer2) THEN
     L_General.Error(" ஭  ஢  ࠧ  ਮ");
    ELSE
     xaClcPer:=xaClcPer2;
    END;
   END;
   IF !XDocClcPer THEN
    XDocClcPer:=xaClcPer;
   ELSIF ~!xaClcPer & (XDocClcPer # xaClcPer) THEN
    L_General.Error("  ਮ  ࠧ ஢   㬥");
   END;
   IF (XDocApr.Source # src_MathRevision) &
      ((XDocApr.WFDate = P) | (XDocApr.WFDate >= XDocClcPer)) & (XDocApr.XDat >= XDocClcPer) THEN
    REMOVE(XDocApr);
   ELSE
    NEXT(XDocApr);
   END;
  END; (* WHILE OCCURE(XDocApr) ... *)
  FIRST(XDocApr);
  WHILE OCCURE(XDocApr) & (XDocApr.XDat < XDocClcPer) DO
   IF (XDocApr.Source # src_MathRevision) & (XDocApr.WFDate = P) THEN
    SAVE(XDocApr);
    ADD(XDocApr, XDocApr, , XDocApr.XDocId, XDocClcPer, P,
                            XDocApr.XObject,  XDocApr.AcCut,   XDocApr.Apport,
                            XDocApr.XObject2, XDocApr.AcCut2,  XDocApr.Apport2, XDocApr.wQnt, XDocApr.Source,
        XDocApr.Sum, (-1) * XDocApr.Sum,
        XDocApr.Qnt, (-1) * XDocApr.Qnt);
    RESTORE(XDocApr);
   END;
   NEXT(XDocApr);
  END; (* WHILE OCCURE(XDocApr) ... *)
 END {ClearXDocApr};

 PUBLIC PROCEDURE exa_SingleAddByXDocApr(leftSide: SCAL[2]; Sign: NUMERIC[0]);
 BEGIN
  IF leftSide THEN
   ADD(XApport, XObject, , XDocApr.XObject2, XDocApr.AcCut2, XDocApr.XDat, XDocApr.Apport2, XDocApr.AcCut, XDocApr.WFDate, XDocApr.Source,
       XApport.Sum, Sign * XDocApr.Sum);
  ELSE
   ADD(XApport, XObject, , XDocApr.XObject, XDocApr.AcCut, XDocApr.XDat, XDocApr.Apport, XDocApr.AcCut2, XDocApr.WFDate, XDocApr.Source,
       XApport.Sum, Sign * XDocApr.Sum);
  END;
  Add2XC(Sign, XDocApr.Sum, XDocApr.Qnt);
 END {exa_SingleAddByXDocApr};

 PUBLIC PROCEDURE exa_src_MathRevision_MirrorXDocAprSecondSide(leftSide: SCAL[2]; Sign: NUMERIC[0]);
  VAR
   _XObject: LIKE(XObject.XObject);
   _AcCut  : LIKE(AcCut.AcCut);
 BEGIN
  IF leftSide THEN
   _XObject:=XDocApr.XObject2; _AcCut:=XDocApr.AcCut2;
  ELSE
   _XObject:=XDocApr.XObject;  _AcCut:=XDocApr.AcCut;
  END;
  IF ~!_XObject THEN
   SAVE(XObject);
   SEARCH(XObject, XObject, , _XObject);
   IF XObject.Origin = o_CostItem THEN
    SAVE(XApport);
    SAVE(XCalc);
    FixXCalc(_AcCut, XDocApr.XDat);
    exa_SingleAddByXDocApr(leftSide, Sign);
    REPLACE(XCalc);
    XODone_Set(XCalc.XDat, 0, 1);
    RESTORE(XApport);
    RESTORE(XCalc);
   END;
   RESTORE(XObject);
  END;
 END {exa_src_MathRevision_MirrorXDocAprSecondSide};

 PRIVATE PROCEDURE cxda_SingleSide(leftSide: SCAL[2]; _ClcPer: DATE);
 BEGIN
  IF XObject.Origin = o_Math THEN
   SelectXDocAprByXApport(leftSide);
   WHILE OCCURE(XDocApr) DO
    IF XDocApr.XDat >= _ClcPer THEN
     exa_src_MathRevision_MirrorXDocAprSecondSide(leftSide, -1);
     REMOVE(XDocApr);
    ELSE
     L_General.CallUs(0(* 08.06.2011 20:53:42 POLAK\San *));
     SAVE(XDocApr);
     ADD(XDocApr, XDocApr, , XDocApr.XDocId, _ClcPer, XDocApr.WFDate,
                             XDocApr.XObject,  XDocApr.AcCut,   XDocApr.Apport,
                             XDocApr.XObject2, XDocApr.AcCut2,  XDocApr.Apport2, XDocApr.wQnt, XDocApr.Source,
         XDocApr.Sum, (-1) * XDocApr.Sum,
         XDocApr.Qnt, (-1) * XDocApr.Qnt);
     exa_src_MathRevision_MirrorXDocAprSecondSide(leftSide, +1);
     RESTORE(XDocApr);
     NEXT(XDocApr);
    END;
   END;
  END;
 END {cxda_SingleSide};

 PRIVATE PROCEDURE xMultipleClearXApport(trgSection: tSection;
                                         trgSources: SCAL[2][];
                                         Through   : SCAL[2]);
  VAR
   curClcPer,
   firstACXDat,
   firstXOXDat: DATE;
   doIt       : SCAL[2];
 BEGIN
  curClcPer:=ClcPer(trgSection);
  SETEMPTY(firstXOXDat);
  SELECT(XCalc, XObject, , XObject.XObject);
  WHILE OCCURE(XCalc) DO
   NARROWSEL(XCalc, AcCut);
   IF IsAppropriateSection(XCalc.AcCut, trgSection) THEN
    SETEMPTY(firstACXDat);
    LAST(XCalc);
    WHILE OCCURE(XCalc) & (XCalc.XDat >= Memo.gl_mb()) DO
     doIt:=0;
     SETSEL(XApport, XObject, XCalc.XObject, XCalc.AcCut, XCalc.XDat);
     FOR_EACH XApport DO
      IF trgSources[XApport.Source] & ((XApport.WFDate = Memo.gl_mb()) | (Through & (XApport.WFDate >= Memo.gl_mb()))) THEN
       doIt:=1;
       EXIT;
      END;
     END; (* FOR_EACH XApport *)
     IF doIt THEN
      firstACXDat:=XCalc.XDat;
      IF XCalc.XDat >= curClcPer THEN
       SETZERO(XCalc.DbtSum, XCalc.DbtQnt, XCalc.CrdSum, XCalc.CrdQnt);
       REPLACE(XCalc);
      END;
      FOR_EACH XApport DO
       IF trgSources[XApport.Source] & ((XApport.WFDate = Memo.gl_mb()) | (Through & (XApport.WFDate >= Memo.gl_mb()))) THEN
        IF XCalc.XDat >= curClcPer THEN
         IF XApport.Source = src_MathRevision THEN
          cxda_SingleSide(0, curClcPer);
          cxda_SingleSide(1, curClcPer);
         END;
         REMOVE(XApport);
        ELSE
         AddOldXApport(-XApport.Sum, -XApport.Qnt, XApport.Source);
        END;
       ELSE
        IF XCalc.XDat >= curClcPer THEN
         AddXA2XC(+1);
         REPLACE(XCalc);
        END;
       END; (* IF trgSources[XApport.Source] ... *)
      END; (* FOR_EACH XApport *)
     END; (* IF doIt *)
     PREV(XCalc);
    END; (* WHILE OCCURE(XCalc) ... *)
    IF ~!firstACXDat THEN
     SRCINSEL(XCalc, EQ, , firstACXDat);
     BalXCalc();
     firstXOXDat:=Math.Min(firstXOXDat, firstACXDat);
    END;
   END; (* IF IsAppropriateSection ... *)
   NEXTINEXTENDEDSEL(XCalc, AcCut);
  END; (* WHILE OCCURE(XCalc) ... *)
  IF ~!firstXOXDat THEN
   ResetXObjectDone(firstXOXDat, trgSection, 1);
  END;
 END {xMultipleClearXApport};

 PUBLIC PROCEDURE MultipleClearXApport(trgSection: tSection; trgSources: SCAL[2][]);
 BEGIN
  xMultipleClearXApport(trgSection, trgSources, 0);
 END {MultipleClearXApport};

 PUBLIC PROCEDURE ClearXApport(trgSection: tSection; trgSource: tSource);
  VAR
   trgSources: SCAL[2][100];
 BEGIN
  SETZERO(trgSources);
  trgSources[trgSource]:=1;
  MultipleClearXApport(trgSection, trgSources);
 END {ClearXApport};

 PUBLIC PROCEDURE xMultipleClearXApportOfObjectsType(_Origin : tOrigin;
                                                     _Section: tSection;
                                                     _Sources: SCAL[2][];
                                                     Through : SCAL[2]);
 BEGIN
  APP.Get().NewPrompt("⪠   (" + L_Str.PoolItem(o_Pool, _Origin) + ")");
  SETSEL(XObject, Origin, _Origin);
  FOR_EACH XObject DO
   PROMPT(XObject.XObject);
   xMultipleClearXApport(_Section, _Sources, Through);
  END; (* FOR_EACH XObject *)
 END {xMultipleClearXApportOfObjectsType};

 PUBLIC PROCEDURE MultipleClearXApportOfObjectsType(_Origin : tOrigin;
                                                    _Section: tSection;
                                                    _Sources: SCAL[2][]);
 BEGIN
  xMultipleClearXApportOfObjectsType(_Origin, _Section, _Sources, 0);
 END {MultipleClearXApportOfObjectsType};

 PUBLIC PROCEDURE _IsXObjectDone(P: DATE; _Section: tSection): SCAL[2];
 BEGIN
  IF _Section = s_Salary THEN
   RETURN XODone_IsSingleIntermediateDone(P, xoid_Man_SalarySection);
  ELSE
   RETURN XODone_IsDone(P);
  END;
 END {_IsXObjectDone};

 PRIVATE PROCEDURE IsPrvXObjectDone(_Section: tSection): SCAL[2];
 BEGIN
  RETURN _IsXObjectDone(L_DatTim.IncMonth(Memo.gl_mb(), -1), _Section);
 END {IsPrvXObjectDone};

 PUBLIC PROCEDURE ResetXObjectDone(P: DATE; _Section: tSection; forceFix: SCAL[2]);
 BEGIN
  IF _Section = s_Salary THEN
   XODone_SetSingleIntermediate(P, xoid_Man_SalarySection, 0, forceFix);
  ELSE
   IF IsMaterialXObject() THEN
    SAVE(mItem);
    AccessOrigin();
    mfResetMathDone(mItem.Math, XObject.MyFirm, P, forceFix);
    RESTORE(mItem);
   ELSE
    XODone_Set(P, 0, forceFix);
   END;
  END;
 END {ResetXObjectDone};

 PUBLIC PROCEDURE IsXObjectDone(_Section: tSection): SCAL[2];
 BEGIN
  RETURN _IsXObjectDone(Memo.gl_mb(), _Section) & IsPrvXObjectDone(_Section);
 END {IsXObjectDone};

 PUBLIC PROCEDURE CheckXObjectDone(D: DATE; trgSection: tSection);
 BEGIN
  IF ~L_APtm.MonthIsClosed(L_DatTim.Per(D), SystemOfSection(trgSection)) THEN
   IF ~_IsXObjectDone(L_DatTim.Per(D), trgSection) THEN
    L_General.Error(GetXObjectOriginName()+"|"+
                    " 믮  楢   " + L_DatTim.PeriodStr(D));
   END;
  END;
 END {CheckXObjectDone};

 PRIVATE PROCEDURE GatherAcntVectorPrompt(_XObject: LIKE(XObject.XObject); Msg: STRING[]);
 BEGIN
  PROMPT(" ⮢: ꥪ " + _XObject + Msg);
 END {GatherAcntVectorPrompt};

 PRIVATE PROCEDURE intGetVector(trgXObject   : LIKE(XObject.XObject);
                                trgAcCuts,
                                trgAcCuts2   : LIKE(AcCut.AcCut)[];
                                PerB,
                                PerE         : DATE;
                                AcntVectorReq: SCAL[2]): L_Acnt.tAcntVector;
  VAR
   Result   : L_Acnt.tAcntVector;
   curAcCut,
   curAcCut2: LIKE(AcCut.AcCut);
   DoIt     : SCAL[2];
 BEGIN
  SETZERO(Result);
  FOR_EACH curAcCut IN trgAcCuts DO
   SETSEL(XCalc, XObject, trgXObject, curAcCut);
   IF SRCINSEL(XCalc, LE, PerE) THEN
    GatherAcntVectorPrompt(trgXObject, ", ࠧ१ " + curAcCut);
    WHILE OCCURE(XCalc) & (XCalc.XDat >= PerB) DO
     IF AcntVectorReq THEN
      SELECT(XApport, XObject, , XCalc.XObject, XCalc.AcCut, XCalc.XDat);
     ELSE
      SELECT(XApport, WFD, ,     XCalc.XObject, XCalc.AcCut, XCalc.XDat);
     END;
     WHILE OCCURE(XApport) DO
      IF !trgAcCuts2[0] THEN
       DoIt:=1;
      ELSE
       DoIt:=0;
       FOR_EACH curAcCut2 IN trgAcCuts2 DO
        IF XApport.AcCut2 = curAcCut2 THEN
         DoIt:=1;
         EXIT;
        END;
       END; (* FOR_EACH curAcCut2 IN ... *)
      END;
      IF DoIt THEN
       CONFORM(XApport, Apport);
       IF Apport.CirType = L_Acnt.ct_Debit THEN
        INC(Result[L_Acnt.avp_Debit], XApport.Sum);
       ELSE
        INC(Result[L_Acnt.avp_Credit], XApport.Sum);
       END;
      END;
      NEXT(XApport);
     END; (* WHILE OCCURE(XApport) ... *)
     PREV(XCalc);
    END; (* WHILE OCCURE(XCalc) ... *)
    IF !trgAcCuts2[0] & OCCURE(XCalc) THEN
     IF AcntVectorReq THEN
      INC(Result[L_Acnt.avp_InSaldo], mo_OutSaldo());
     ELSE
      INC(Result[L_Acnt.avp_InSaldo], mo_OutRSaldo());
     END;
    END; (* IF !trgAcCuts2[0] & ... *)
   END; (* IF SRCINSEL(XCalc, LE, PerE) ... *)
  END; (* FOR_EACH curAcCut IN ... *)
  IF !trgAcCuts2[0] THEN
   Result[L_Acnt.avp_OutSaldo]:=Result[L_Acnt.avp_InSaldo]+Result[L_Acnt.avp_Debit]-Result[L_Acnt.avp_Credit];
  END;
  RETURN Result;
 END {intGetVector};

 PUBLIC PROCEDURE GetAcntVector(_XObject: LIKE(XObject.XObject);
                                _AcCut,
                                _AcCut2 : LIKE(AcCut.AcCut)[];
                                PerB,
                                PerE    : DATE): L_Acnt.tAcntVector;
 BEGIN
  RETURN intGetVector(_XObject, _AcCut, _AcCut2, PerB, PerE, 1);
 END {GetAcntVector};

 PUBLIC PROCEDURE GetAcntVector_Total(_MyFirm: P_Firm.tMyFirm;
                                      _AcCut,
                                      _AcCut2: LIKE(AcCut.AcCut)[];
                                      PerB,
                                      PerE   : DATE): L_Acnt.tAcntVector;
  VAR
   Result: L_Acnt.tAcntVector;
 BEGIN
  SETZERO(Result);
  SELECT(XObject, MyFirm, , _MyFirm);
  WHILE OCCURE(XObject) DO
   GatherAcntVectorPrompt(XObject.XObject, "");
   L_Acnt.av_Add(Result, intGetVector(XObject.XObject, _AcCut, _AcCut2, PerB, PerE, 1));
   NEXT(XObject);
  END; (* WHILE OCCURE(XObject) ... *)
  RETURN Result;
 END {GetAcntVector_Total};

 PUBLIC PROCEDURE GetTaxVector(_XObject: LIKE(XObject.XObject);
                               _AcCut,
                               _AcCut2 : LIKE(AcCut.AcCut)[];
                               PerB,
                               PerE    : DATE): L_Acnt.tAcntVector;
 BEGIN
  RETURN intGetVector(_XObject, _AcCut, _AcCut2, PerB, PerE, 0);
 END {GetTaxVector};

 PRIVATE PROCEDURE intGetTaxVector(_MyFirm         : P_Firm.tMyFirm;
                                   _AcCut,
                                   _AcCut2         : LIKE(AcCut.AcCut);
                                   PerB,
                                   PerE            : DATE;
                                   allowEmpty_AcCut: SCAL[2]): L_Acnt.tAcntVector;
  VAR
   Result: L_Acnt.tAcntVector;
 BEGIN
  SETEMPTY(Result);
  SETZERO(Result[L_Acnt.avp_Debit], Result[L_Acnt.avp_Credit]);
  SETSEL(XApport, AcCut2, _AcCut2);
  IF SRCINSEL(XApport, GE, PerB) THEN
   WHILE OCCURE(XApport) & (XApport.WFDate <= PerE) DO
    GatherAcntVectorPrompt(XApport.XObject, "");
    IF (XApport.AcCut = _AcCut) | (!_AcCut & allowEmpty_AcCut) THEN
     SEARCH(XObject, XObject, , XApport.XObject);
     IF XObject.MyFirm = _MyFirm THEN
      CONFORM(XApport, Apport);
      IF Apport.CirType = L_Acnt.ct_Debit THEN
       INC(Result[L_Acnt.avp_Debit], XApport.Sum);
      ELSE
       INC(Result[L_Acnt.avp_Credit], XApport.Sum);
      END;
     END;
    END;
    NEXT(XApport);
   END;
  END;
  RETURN Result;
 END {intGetTaxVector};

 PUBLIC PROCEDURE GetTaxVector_Total(_MyFirm: P_Firm.tMyFirm;
                                     _AcCut,
                                     _AcCut2: LIKE(AcCut.AcCut);
                                     PerB,
                                     PerE   : DATE): L_Acnt.tAcntVector;
 BEGIN
  RETURN intGetTaxVector(_MyFirm, _AcCut, _AcCut2, PerB, PerE, 0);
 END {GetTaxVector_Total};

 PUBLIC PROCEDURE GetTaxVector2AcCut2_Total(_MyFirm: P_Firm.tMyFirm;
                                            _AcCut2: LIKE(AcCut.AcCut);
                                            PerB,
                                            PerE   : DATE): L_Acnt.tAcntVector;
 BEGIN
  RETURN intGetTaxVector(_MyFirm, L_General.EMPTY_NUMBER(), _AcCut2, PerB, PerE, 1);
 END {GetTaxVector2AcCut2_Total};

 PUBLIC PROCEDURE SetupOrigins(    Selective: SCAL[2];
                               VAR trgOM    : tOriginsMap;
                               VAR trgMyFirm: P_Firm.tMyFirm);
  CONST
   mfpv_All = "|";
  VAR
   curOrigin: tOrigin;
   i        : NUMERIC[0];
   mfPool   : STRING[];
   mfArray  : P_Firm.tMyFirm[64];
   mfChoice : NUMERIC[0];
   R        : NUMERIC[0];
 BEGIN
  FOR_EACH curOrigin DO
   trgOM[curOrigin]:=1;
  END;
  trgOM[o_ESN]:=0;
  mfChoice:=0;
  IF Selective THEN
   mfPool:=mfpv_All;
   IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
    i:=0;
    SELECT(MyFirm, MyFirm);
    WHILE OCCURE(MyFirm) DO
     IF MyFirm.MyFirm # P_Firm.mf_Fict THEN
      mfPool:=mfPool+ MyFirm.MyFirm + " " + MyFirm.vzSign + "|" ;
      mfArray[i]:=MyFirm.MyFirm;
      INC(i);
     END;
     NEXT(MyFirm);
    END; (* WHILE OCCURE(MyFirm) ... *)
   END;
   LOOP
    R:=STDFORM(L_StdFrm.PartForm("%L<"+mfPool+">" + L_Str.PoolItem("NI|I", mfPool # mfpv_All) +
                                 "%<"+L_Str.PoolItem(o_Pool, o_Global  )+">E" +
                                 "%<"+L_Str.PoolItem(o_Pool, o_Man     )+">E" +
                                 "%<"+L_Str.PoolItem(o_Pool, o_Staff   )+">E" +
                                 "%<"+L_Str.PoolItem(o_Pool, o_Contract)+">E" +
                                 "%<"+L_Str.PoolItem(o_Pool, o_Math    )+">E" +
                                 "%<"+L_Str.PoolItem(o_Pool, o_KeyAss  )+">E" +
                                 "%<"+L_Str.PoolItem(o_Pool, o_CostItem)+">E" +
                                 "%< 믮 >DB" +
                                 "%< ⬥ >X"   +
                                 "%< {}  >B" +
                                 "%< {}  >B"   +
                                 "@" +
                                 "|  %############################% " +
                                 "|                                   " +
                                 "|%################################% " +
                                 "|%################################% " +
                                 "|%################################% " +
                                 "|%################################% " +
                                 "|%################################% " +
                                 "|%################################% " +
                                 "|%################################% " +
                                 "|                                   " +
                                 "| %#############%    %###########%  " +
                                 "| %#############%    %###########%  "),
                                 " 롮  ꥪ⮢ ",
                                 ,
                                 -1,
                                 mfChoice,
                                 trgOM[o_Global],
                                 trgOM[o_Man],
                                 trgOM[o_Staff],
                                 trgOM[o_Contract],
                                 trgOM[o_Math],
                                 trgOM[o_KeyAss],
                                 trgOM[o_CostItem]);
    IF    R = 1 THEN
     i:=0;
     FOR_EACH curOrigin DO
      INC(i, trgOM[curOrigin]);
     END;
     IF i = 0 THEN
      L_StdFrm.ShowINFORM_AsSTOP("   ࠩ   㭪");
     ELSE
      EXIT;
     END; (* IF *)
    ELSIF (R = 2) | (R = 3) THEN
     FOR_EACH curOrigin DO
      trgOM[curOrigin]:=(R=2);
     END;
    END; (* IF R ... *)
   END; (* LOOP *)
  END; (* IF Selective *)
  IF mfChoice = 0 THEN
   SETEMPTY(trgMyFirm);
  ELSE
   trgMyFirm:=mfArray[mfChoice-1];
  END;
 END {SetupOrigins};

 PUBLIC PROCEDURE extSetupOrigins(Title    : STRING[];
                                  Selective: SCAL[2];
                                  VAR trgOM    : tOriginsMap;
                                  VAR trgMyFirm: P_Firm.tMyFirm;
                                  VAR trgAK    : L_Acnt.tAccountingKind);
  CONST
   mfpv_All = "|";
  VAR
   curOrigin: tOrigin;
   i        : NUMERIC[0];
   mfPool   : STRING[];
   mfArray  : P_Firm.tMyFirm[64];
   mfChoice : NUMERIC[0];
   R        : NUMERIC[0];
 BEGIN
  FOR_EACH curOrigin DO
   trgOM[curOrigin]:=1;
  END;
  mfChoice:=0;
  trgAK:=L_Acnt.ak_Acn;
  IF Selective THEN
   mfPool:=mfpv_All;
   IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
    i:=1;
    SELECT(MyFirm, MyFirm);
    WHILE OCCURE(MyFirm) DO
     IF MyFirm.MyFirm # P_Firm.mf_Fict THEN
      mfPool:=mfPool+ MyFirm.MyFirm + " " + MyFirm.vzSign + "|" ;
      mfArray[i]:=MyFirm.MyFirm;
      IF MyFirm.MyFirm = trgMyFirm THEN
       mfChoice:=i;
      END;
      INC(i);
     END;
     NEXT(MyFirm);
    END; (* WHILE OCCURE(MyFirm) ... *)
   END;
   LOOP
    R:=STDFORM(L_StdFrm.PartForm("%L<"+mfPool+">" + L_Str.PoolItem("NI|I", (mfPool # mfpv_All) & !trgMyFirm) +
                                 "%<"+L_Str.PoolItem(o_Pool, o_Global  )+">E" +
                                 "%<"+L_Str.PoolItem(o_Pool, o_Man     )+">E" +
                                 "%<"+L_Str.PoolItem(o_Pool, o_Staff   )+">E" +
                                 "%<"+L_Str.PoolItem(o_Pool, o_Contract)+">E" +
                                 "%<"+L_Str.PoolItem(o_Pool, o_Math    )+">E" +
                                 "%<"+L_Str.PoolItem(o_Pool, o_KeyAss  )+">E" +
                                 "%<"+L_Str.PoolItem(o_Pool, o_CostItem)+">E" +
                                 "%<"+" ਮ| ਮ"            +">O" +
                                 "%< 믮 >DB" +
                                 "%< ⬥ >X"   +
                                 "%< {}  >B" +
                                 "%< {}  >B"   +
                                 "@" +
                                 "|  %#####################################% " +
                                 "|                                   " +
                                 "|%#########################################% " +
                                 "|%#########################################% " +
                                 "|%#########################################% " +
                                 "|%#########################################% " +
                                 "|%#########################################% " +
                                 "|%#########################################% " +
                                 "|%#########################################% " +
                                 "|                                   " +
                                 "|%#########################################% " +
                                 "|                                   " +
                                 "| %#############%             %###########%  " +
                                 "| %#############%             %###########%  "),
                                 Title,
                                 ,
                                 -1,
                                 mfChoice,
                                 trgOM[o_Global],
                                 trgOM[o_Man],
                                 trgOM[o_Staff],
                                 trgOM[o_Contract],
                                 trgOM[o_Math],
                                 trgOM[o_KeyAss],
                                 trgOM[o_CostItem],
                                 trgAK);
    IF    R = 1 THEN
     i:=0;
     FOR_EACH curOrigin DO
      INC(i, trgOM[curOrigin]);
     END;
     IF i = 0 THEN
      L_StdFrm.ShowINFORM_AsSTOP("   ࠩ   㭪");
     ELSE
      EXIT;
     END; (* IF *)
    ELSIF (R = 2) | (R = 3) THEN
     FOR_EACH curOrigin DO
      trgOM[curOrigin]:=(R=2);
     END;
    END; (* IF R ... *)
   END; (* LOOP *)
  END; (* IF Selective *)
  IF mfChoice = 0 THEN
   SETEMPTY(trgMyFirm);
  ELSE
   trgMyFirm:=mfArray[mfChoice];
  END;
 END {extSetupOrigins};

 PUBLIC PROCEDURE GetOriginsStr(trgOM: tOriginsMap; trgMyFirm: P_Firm.tMyFirm): STRING[];
  VAR
   curOrigin: tOrigin;
   i        : NUMERIC[0];
   Result   : STRING[];
 BEGIN
  SETEMPTY(Result);
  IF ~!trgMyFirm THEN
   SAVE(MyFirm);
   SEARCH(MyFirm, MyFirm, , trgMyFirm);
   INC(Result, "쪮  '" + MyFirm.vzSign + "'");
   RESTORE(MyFirm);
  END;
  i:=0;
  FOR_EACH curOrigin DO
   INC(i, trgOM[curOrigin])
  END;
  IF i <= MAXOF(tOrigin) THEN
   i:=0;
   IF ~!Result THEN
    INC(Result, ". ");
   END;
   INC(Result, " :");
   FOR_EACH curOrigin DO
    IF trgOM[curOrigin] THEN
     IF i = 0 THEN
      INC(Result, " ");
     ELSE
      INC(Result, ", ");
     END;
     INC(Result, L_Str.PoolItem(o_Pool_SH, curOrigin));
     INC(i);
    END;
   END;
   INC(Result, ".");
  END;
  IF !Result THEN
   Result:=" ᥬ ꥪ⠬ ";
  END;
  RETURN Result;
 END {GetOriginsStr};

 PRIVATE PROCEDURE E_NeedCheckXCalcRest(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_Stock.NeedCheckXCalcRest), 1);
 END {E_NeedCheckXCalcRest};

 PRIVATE PROCEDURE MergeXObjectJDocList(leftSide: SCAL[2]; SrcXObject, DstXObject: LIKE(XObject.XObject));
 BEGIN
  IF leftSide THEN
   WHILE SELECT(JDocList, XObject, SrcXObject) DO
    JDocList.XObject:=DstXObject;
    REPLACE(JDocList);
   END; (* WHILE SELECT(JDocList ... *)
  ELSE
   WHILE SELECT(JDocList, XObject2, SrcXObject) DO
    JDocList.XObject2:=DstXObject;
    REPLACE(JDocList);
   END; (* WHILE SELECT(JDocList ... *)
  END;
 END {MergeXObjectJDocList};

 PRIVATE PROCEDURE MergeXDocApr(leftSide: SCAL[2]; DstXObject: LIKE(XObject.XObject));
  VAR
   _XObject:  LIKE(XDocApr.XObject);
   _XObject2: LIKE(XDocApr.XObject2);
   _Sum: LIKE(XDocApr.Sum);
   _Qnt: LIKE(XDocApr.Qnt);
 BEGIN
  LOOP
   SelectXDocAprByXApport(leftSide);
   IF ~OCCURE(XDocApr) THEN
    EXIT;
   END;
   SAVE(XDocApr);
   IF leftSide THEN
    _XObject:=DstXObject;
    _XObject2:=XDocApr.XObject2;
   ELSE
    _XObject:=XDocApr.XObject;
    _XObject2:=DstXObject;
   END;
   _Sum:=XDocApr.Sum;
   _Qnt:=XDocApr.Qnt;
   ADD(XDocApr, XDocApr, , XDocApr.XDocId, XDocApr.XDat, XDocApr.WFDate,
                           _XObject, XDocApr.AcCut, XDocApr.Apport,
                           _XObject2, XDocApr.AcCut2, XDocApr.Apport2,
                           XDocApr.wQnt, XDocApr.Source,
                           XDocApr.Sum, _Sum,
                           XDocApr.Qnt, _Qnt);
   RESTORE(XDocApr);
   REMOVE(XDocApr);
  END; (* LOOP *)
 END {MergeXDocApr};

 PUBLIC PROCEDURE MergeXObject(SrcXObject, DstXObject: LIKE(XObject.XObject));
  (* 㤠 ᪫ XObject*)
  VAR
   curSldSum: LIKE(XCalc.SldSum);
   curSldQnt: LIKE(XCalc.SldQnt);
   curRSlSum: LIKE(XCalc.RSlSum);
   curRSlQnt: LIKE(XCalc.RSlQnt);
   curDbtSum: LIKE(XCalc.DbtSum);
   curDbtQnt: LIKE(XCalc.DbtQnt);
   curCrdSum: LIKE(XCalc.CrdSum);
   curCrdQnt: LIKE(XCalc.CrdQnt);
   curSum   : LIKE(XApport.Sum);
   curQnt   : LIKE(XApport.Qnt);

   curDone  : LIKE(XODone.Done);
   cur_intmD: LIKE(XODone.intmDone);
   curPeriod: LIKE(XODone.Period);

   FirstP   : DATE;
   i        : NUMERIC[0];
   curOrigin: LIKE(XObject.Origin);
 BEGIN
  APP.Get().NewPrompt(" ꥪ⮢ "+SrcXObject+" -> "+DstXObject);

  TRY [INTEGRITY(INTEGRITY_ON)]
   SETEMPTY(FirstP);
 
   AccessXObject(SrcXObject);
   L_r2r.Owner_OnBeforeDelete("XObject");

   curOrigin:=XObject.Origin;
   AccessXObject(DstXObject);
   L_General.CallUs(XObject.Origin = curOrigin);
 
   MergeXObjectJDocList(1, SrcXObject, DstXObject);
   MergeXObjectJDocList(0, SrcXObject, DstXObject);
 
   SELECT(XCalc, XObject, , SrcXObject);
   WHILE OCCURE(XCalc) DO
    curSldSum:=XCalc.SldSum;
    curSldQnt:=XCalc.SldQnt;
    curRSlSum:=XCalc.RSlSum;
    curRSlQnt:=XCalc.RSlQnt;
    curDbtSum:=XCalc.DbtSum;
    curDbtQnt:=XCalc.DbtQnt;
    curCrdSum:=XCalc.CrdSum;
    curCrdQnt:=XCalc.CrdQnt;
    IF FirstP > XCalc.XDat THEN
     FirstP:=XCalc.XDat;
    END;
    SAVE(XCalc);
    ADD(XCalc, XObject, , DstXObject, XCalc.AcCut, XCalc.XDat,
         XCalc.SldSum,  curSldSum,
         XCalc.SldQnt,  curSldQnt,
         XCalc.RSlSum,  curRSlSum,
         XCalc.RSlQnt,  curRSlQnt,
         XCalc.DbtSum,  curDbtSum,
         XCalc.DbtQnt,  curDbtQnt,
         XCalc.CrdSum,  curCrdSum,
         XCalc.CrdQnt,  curCrdQnt);
    RESTORE(XCalc);
 
    CONFORM(XCalc, XApport);
    WHILE OCCURE(XApport) DO
     SAVE(XApport);
     curSum:=XApport.Sum;
     curQnt:=XApport.Qnt;
     ADD(XApport, XObject, , DstXObject, XApport.AcCut, XApport.XDat, XApport.Apport,
                             XApport.AcCut2, XApport.WFDate, XApport.Source,
                             XApport.Sum, curSum,
                             XApport.Qnt, curQnt);
     RESTORE(XApport);
     MergeXDocApr(1, DstXObject);
     MergeXDocApr(0, DstXObject);
     REMOVE(XApport);
    END; (* WHILE OCCURE(XApport) ... *)
    REMOVE(XCalc);
   END; (* WHILE OCCURE(XCalc) ... *)
 
   IF ~!FirstP THEN
    SELECT(XCalc, XObject, , DstXObject);
    WHILE OCCURE(XCalc) DO
     NARROWSEL(XCalc, AcCut);
     IF ~SRCINSEL(XCalc, LT, FirstP) THEN
      FIRST(XCalc);
     END;
     BalXCalc();
     NEXTINEXTENDEDSEL(XCalc, AcCut);
    END; (* WHILE OCCURE(XCalc) ... *)
   END;
 
   AccessXObject(DstXObject);
   IF SELECT(XODone, XObject, DstXObject) THEN
    FirstP:=XODone.Period;
   ELSE
    SETEMPTY(FirstP);
   END;
   IF SELECT(XODone, XObject, SrcXObject) THEN
    FirstP:=Math.Max(FirstP, XODone.Period);
    WHILE OCCURE(XODone) DO
     SAVE(XODone);
     curPeriod:=XODone.Period;
     curDone  :=XODone.Done;
     cur_intmD:=XODone.intmDone;
 
     IF ~XODone_Src(curPeriod) THEN
      XODone.XObject:=XObject.XObject;
      XODone.Period :=curPeriod;
      XODone.Origin :=XObject.Origin;
      XODone.intmDone:=cur_intmD;
      XODone.Done    :=curDone;
      INSERT(XODone);
     ELSE
      XODone.Done:=Math.Min(XODone.Done, curDone);
      i:=0;
      WHILE i< RANGEOF(XODone.intmDone) DO
       XODone.intmDone[i]:=Math.Min(XODone.intmDone[i], cur_intmD[i]);
       INC(i);
      END;
      REPLACE(XODone);
     END;
     RESTORE(XODone);
     NEXT(XODone);
    END; (* WHILE OCCURE(XODone) ... *)
   END;
   IF ~!FirstP THEN
    L_General.CallUs(XODone_Src(FirstP));
    GETLASTVERSION(XODone);
    SETZERO(XODone.intmDone, XODone.Done);
    XODone_ReplaceCurrent(1);
   END;
  EXCEPT
  END;
 END {MergeXObject};

 PUBLIC PROCEDURE DefineConciseXOId(Section: tSection): LIKE(XObject.XObject);
 BEGIN
  RETURN 999999999-Section;
 END {DefineConciseXOId};

 PUBLIC PROCEDURE DecodeConciseXOId(XOId: LIKE(XObject.XObject)): tSection;
  VAR
   Result: tSection;
 BEGIN
  IF XOId >= DefineConciseXOId(MAXOF(tSection)) THEN
   Result:=DefineConciseXOId(MINOF(tSection))-XOId;
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {DecodeConciseXOId};

 PUBLIC PROCEDURE xoacc_Put(trgAcCut: LIKE(AcCut.AcCut); VAR xoacc: tXObjectAcCutCollection);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  LOOP
   IF !xoacc[i] THEN
    xoacc[i]:=trgAcCut;
    EXIT;
   ELSIF xoacc[i] = trgAcCut THEN
    EXIT;
   END;
   INC(i);
  END;
 END {xoacc_Put};

 PUBLIC PROCEDURE GetXObjectAcCutCollection(trgXObject: LIKE(XObject.XObject)): tXObjectAcCutCollection;
  VAR
   curAcCut: LIKE(AcCut.AcCut);
   Result  : tXObjectAcCutCollection;
 BEGIN
  SETEMPTY(Result);
  curAcCut:=MINOF(AcCut.AcCut);
  SETSEL(XCalc, XObject, trgXObject);
  WHILE SRCINSEL(XCalc, GE, curAcCut) DO
   xoacc_Put(XCalc.AcCut, Result);
   curAcCut:=XCalc.AcCut+1;
  END; (* WHILE OCCURE(XCalc) ... *)
  RETURN Result;
 END {GetXObjectAcCutCollection};

 PUBLIC PROCEDURE GetXObjectBy_fi_ri(fi: L_General.tFileId; ri: L_General.tRecordId): LIKE(XObject.XObject);
 BEGIN
  IF ~!fi THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    L_DBD.StandOnRecord(L_General.iri_Pack(fi, ri));
    RETURN ^(L_DBD.GetTable(fi).Fields("XObject").ObtainName());
   EXCEPT
   END; (* TRY *)
  ELSE
   RETURN EMPTYOF(XObject.XObject);
  END;
 END {GetXObjectBy_fi_ri};

 PUBLIC PROCEDURE E_DoSecondSide(P: DATE): SCAL[2];
 BEGIN
  IF L_General.IsPolakSpecific() THEN RETURN P >= 01\07\2014;
  ELSE                                RETURN 0;
  END;
 END {E_DoSecondSide};

END.
