(*
%Copyright   (c) Polak Computer System
%Author      22.10.1996 03:47:26 POLAK
%Purpose     ⠢ 㤥ঠ
%Type        operation
%Specific    SYS
%Modified    17.06.2014 22:34:47 POLAK\Gina
%Environment
*)

 MODULE Make_TU [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_PRoll, L_DatTim, L_Staff, P_Firm, E_Utils, L_Env, Math, L_StdFrm;

 PRIVATE PROCEDURE TradeUnion(    P       : DATE;
                              VAR _MCode  : LIKE(Deduct.MCode);
                              VAR _Firm   : LIKE(Deduct.Firm);
                              VAR _DedType: LIKE(Deduct.DedType);
                              VAR _PayP   : LIKE(Deduct.PayP);
                              VAR _Cred   : LIKE(DedAcnt.Cred);
                              VAR _ToPay  : LIKE(DedAcnt.ToPay));
 BEGIN
  _MCode  :=L_PRoll.E_GetTradeUnionMCode(P);
  _Firm   :=P_Firm.fomf(L_Staff.GetStaffMyFirm());
  _DedType:=050;
  _PayP   :=00;
  _Cred   :=0;
  _ToPay  :=1;
 END {TradeUnion};

 PRIVATE PROCEDURE CheckCreated(Exist, Active: SCAL[2]; Text: STRING[]; P: DATE);
 BEGIN
  L_General.Assert(Exist & Active, " ࠢ筨     "+L_DatTim.PeriodStr(P)+" "+Text+"|室   ࠢ筨| ᮮ ࠧࠡ稪   ");
 END {CheckCreated};

 PRIVATE PROCEDURE MakeDeduct(GetDeductParms: PROC; trgBegDate: LIKE(Deduct.BegDate));
  VAR
   trgDedNbr : LIKE(Deduct.DedNbr);
   trgMCode  : LIKE(Deduct.MCode);
   trgFirm   : LIKE(Deduct.Firm);
   trgDedType: LIKE(Deduct.DedType);
   trgPayP   : LIKE(Deduct.PayP);
   trgCred   : LIKE(DedAcnt.Cred);
   trgToPay  : LIKE(DedAcnt.ToPay);
 BEGIN
  L_General.Assert(~L_Staff.IsLeave(L_DatTim.IncMonth(trgBegDate, -1)), "⭨ 㦥 㢮");
  trgBegDate:=Math.Max(trgBegDate, L_DatTim.Per(Staff.BegDate));
  trgDedNbr:=01;
  WHILE SEARCH(Deduct, TSN, Staff.TSN, trgDedNbr) DO
   INC(trgDedNbr);
  END;
  L_General.Assert(~!GetDeductParms, "  ।");
  GetDeductParms(trgBegDate, trgMCode, trgFirm, trgDedType, trgPayP, trgCred, trgToPay);
  IF SELECT(Deduct, MCode, trgMCode, Staff.TSN) & L_DatTim.IsActive_Inc(trgBegDate, Deduct.BegDate, Deduct.EndDate) THEN
   L_StdFrm.Choice(" ࠡ⭨ 㦥  㤥ঠ  "+Deduct.DedNbr);
  END;
  CheckCreated(SEARCH(MCList, MCode, trgMCode),      L_DatTim.IsActive(trgBegDate, MCList.Begin, MCList.Till), "  " +trgMCode, trgBegDate);
  CheckCreated(SEARCH(Firm, Firm, trgFirm),          L_DatTim.IsActive(trgBegDate, Firm.Begin, Firm.Till),     "ࠣ " +trgFirm, trgBegDate);
  CheckCreated(SEARCH(DedType, DedType, trgDedType), 1,                                                        "⨯ 㤥ঠ " +trgDedType, trgBegDate);
  CheckCreated(SEARCH(PayP, PayP, trgPayP),          L_DatTim.IsActive(trgBegDate, PayP.Begin, PayP.Till),     "祭 ⥦ " +trgPayP, trgBegDate);
  DEFAULT(Deduct);
  Deduct.TSN     :=Staff.TSN;
  Deduct.DedNbr  :=trgDedNbr;
  Deduct.MCode   :=trgMCode;
  Deduct.BegDate :=trgBegDate;
  Deduct.Firm    :=trgFirm;
  SETEMPTY(Deduct.FirmAcnt);
  Deduct.DedType :=trgDedType;
  Deduct.PayP    :=trgPayP;
  CONFORM(Staff, Man);
  Deduct.Person  :=Man.Name;
  INSERT(Deduct);
  DEFAULT(DedAcnt);
  DedAcnt.TSN   :=Deduct.TSN;
  DedAcnt.DedNbr:=Deduct.DedNbr;
  DedAcnt.Period:=Deduct.BegDate;
  DedAcnt.Cred  :=trgCred;
  DedAcnt.ToPay :=trgToPay;
  INSERT(DedAcnt);
  L_PRoll.DedDone_AP(L_DatTim.Per(Deduct.BegDate), 0);
 END {MakeDeduct};

 PUBLIC PROCEDURE TUSingle();
 BEGIN
  L_General.Assert(ACCESS(Staff), " । ࠡ⭨");
  MakeDeduct(PROCREF(TradeUnion), Memo.ud_mb());
  SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), Deduct);
 END {TUSingle};

 PUBLIC PROCEDURE TUAll();
  VAR
   P       : DATE;
   trgMCode: LIKE(MCList.MCode);
 BEGIN
  P:=L_Env.aptm_Start;
  L_StdFrm.Choice("ନ 㤥ঠ  ᮢ  "+L_DatTim.PeriodStr(P)+" 騬  ");
  FLOCK(Staff,   Share);
  FLOCK(Man,     Share);
  FLOCK(Deduct,  Share);
  FLOCK(DedAcnt, Share);
  FLOCK(PCalc,   Share);
  trgMCode:=L_PRoll.E_GetTradeUnionMCode(P);
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF (Staff.Contract # L_Staff.cnt_OutStaff) & L_Env.RealTSN(Staff.TSN) &
      ~L_Staff.IsLeaveFinally(L_DatTim.IncMonth(P, -1)) &
      ~SELECT(Deduct, MCode, trgMCode, Staff.TSN) THEN
    MakeDeduct(PROCREF(TradeUnion), P);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff)... *)
 END {TUAll};

END.
