(*
%Copyright   (c) Polak Computer System
%Author      17.03.1998 17:22:27 GINA
%Purpose     ஫ 䨪樨 Man
%Type        operation
%Specific    SYS
%Modified    16.09.2014 14:08:14 POLAK\Gina
%Environment
*)

 MODULE Man [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_Russia, L_Events, L_DatTim, Str, L_Str, L_XObj, L_Man, Math, L_Env,
        FIO, Shell, P_Man, L_Stock, L_DBD, L_ctc, L_AR, L_Pool, L_StdFrm, L_WDO, L_APtm;

 PRIVATE CONST
  wn_Main    = "ManE";
  wn_2Pass   = "MnE2Pass";

  dt_Pool = "ᯮ ࠦ |⥫⢮  ஦|⮢७ 筮|ࠢ  ᢮|"+
            " |࠭ ᯮ|. ॣ樨 .|⮢७ |"+
            "ᯮ ࠦ |⮢७..|࠭ᯮ ࠦ.|࠭ᯮ ࠦ. |"+
            "  ⥫⢮|ᯮ 䫮|ᯮ 猪|. .|"+
            ".ᯮ .| 㬥 |. ஦.. .";

 PRIVATE PROCEDURE ManE_0_OnSetupFields();
  VAR
   Fields  : FORM_FIELDS;
   IswStaff: SCAL[2];
 BEGIN
  IswStaff:=Man.rStaff = L_Man.rs_wStaff;
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Man_rStaff").Value:=Man.rStaff-1;
  Fields("Firm_Title").Visible:=~IswStaff;
  Fields("Firm"      ).Visible:=~IswStaff;
  Fields("Firm_Name" ).Visible:=~IswStaff;
  Fields("Man.FmlState").MustBeNonempty:=IswStaff;
  Fields("Man.Birth"   ).MustBeNonempty:=IswStaff;
 END {ManE_0_OnSetupFields};

 PRIVATE PROCEDURE Man_Man_rStaff_OnSuccessfulChange();
 BEGIN
  Man.rStaff:=RTI.Get().CurZone.Fields("Man_rStaff").Value+1;
  REPLACE(Man);
  ManE_0_OnSetupFields();
 END {Man_Man_rStaff_OnSuccessfulChange};

 PRIVATE PROCEDURE Man_Birth_OnSuccessfulChange();
 BEGIN
  IF ~!GE_PVALUE() THEN
   SAVE(ManAdr);
   IF SELECT(ManAdr, Man, Man.Man, L_Russia.at_BthMA) THEN
    ManAdr.Date:=Man.Birth;
    REPLACE(ManAdr);
    L_General.CallUs(~NEXT(ManAdr));
   END;
   RESTORE(ManAdr);
  END;
 END {Man_Birth_OnSuccessfulChange};

 PRIVATE PROCEDURE Man_SINumber_OnSuccessfulChange();
 BEGIN
  IF !Man.SINumber THEN
   IF L_Man.ManIsInvolved(Man.Man) THEN
    L_StdFrm.CrucialChoice("⢨⥫쭮 㤠 ᢥ  ?", L_APtm.g_Staff);
   END;
  ELSE
   L_Russia.CheckSINumber(Man.SINumber, 0);
   SAVE(Man);
   L_General.Assert(SELECT(Man, SINumber, Man.SINumber) & ~NEXT(Man), "    ⠪ ");
   RESTORE(Man);
  END;
 END {Man_SINumber_OnSuccessfulChange};

 PRIVATE PROCEDURE Man_INN_OnSuccessfulChange();
 BEGIN
  IF !Man.INN THEN
   IF L_Man.ManIsInvolved(Man.Man) THEN
    L_StdFrm.CrucialChoice("⢨⥫쭮 㤠 ᢥ  ?", L_APtm.g_Staff);
   END;
  ELSE
   IF ~L_Russia.CheckINN(Man.INN) THEN
    L_General.Error("४ ");
   ELSE
    SAVE(Man);
    IF SELECT(Man, INN, Man.INN) & NEXT(Man) THEN
     L_General.Error("    ⠪ :  "+L_Man.Man_ManAsStr());
    END;
    RESTORE(Man);
   END;
  END;
 END {Man_INN_OnSuccessfulChange};

 PRIVATE PROCEDURE SetSexDependentPool();
 BEGIN
  L_WDO.SetFieldFormat("Man.FmlState", L_Man.GetFmlStatePool());
 END {SetSexDependentPool};

 PRIVATE PROCEDURE Man_Sex_OnSuccessfulChange();
 BEGIN
  SetSexDependentPool();
 END {Man_Sex_OnSuccessfulChange};

 PRIVATE PROCEDURE Man_Name_OnSuccessfulChange();
 BEGIN
  SAVE(Man);
  IF SELECT(Man, Name, Man.Name) & NEXT(Man) THEN
   L_StdFrm.Choice("    ⠪ | ࠢ ?");
  END; (* IF ... *)
  RESTORE(Man);
  IF ~!GE_PVALUE() &
     (RTI.Get().CurWindow.OriginalName = wn_Main) &
     (RTI.Get().CurZone.Processes(0).Kind = FORM_PROCESS.Kind_Edit) &
     L_Man.E_ManNameModificationThroughEDOrder() THEN
   L_General.Assert_wReferToAdmin(0, "  ଫ ਪ   ᮭ ");
  END;
 END {Man_Name_OnSuccessfulChange};

 PRIVATE PROCEDURE ManDoc_Citizen(_DocType: LIKE(Man.DocType)): L_Man.tCitizen;
 BEGIN
  IF (_DocType = 05(*࠭ ᯮ*)) |
     (_DocType = 06(*. ॣ樨 ࠭*)) |
     (_DocType = 07(*㤮⮢७ *)) |
     (_DocType = 12(*  ⥫⢮*)) |
     (_DocType = 17(* 㬥, 뤠 ࣠ *)) |
     (_DocType = 18(*⥫⢮  ஦,뤠 㯮祭 ࣠ ࠭ 㤠⢠*)) THEN
   RETURN L_Man.ct_Foreign;
  ELSE
   RETURN L_Man.ct_Russia;
  END;
 END {ManDoc_Citizen};

 PUBLIC PROCEDURE CheckAllData();
  VAR
   Err    : STRING[];
   Birth,
   onDate : DATE;
   Count  : NUMERIC[0];
   doctype: LIKE(Man.DocType);
   _rStaff: LIKE(Man.rStaff);
   ManDocCtz,
   ManAdrCtz: SCAL[2];
 BEGIN
  _rStaff:=Man.rStaff;
  Birth:=Man.Birth;
  Count:=0;
  SAVE(Man);
  SELECT(Man, Name, , Man.Name);
  WHILE OCCURE(Man) DO
   INC(Count, (Man.Birth = Birth) & (_rStaff = Man.rStaff));
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
  RESTORE(Man);
  L_General.Assert_wReferToAdmin(Count = 1, "    ⠪   ⮩ ஦");
  IF ~!Man.PspNbr | ~!Man.PspSer THEN
   SAVE(Man);
   doctype:=Man.DocType;
   Count:=0;
   SELECT(Man, Pasport, , Man.PspNbr, Man.PspSer);
   WHILE OCCURE(Man) DO
    INC(Count, (doctype = Man.DocType) & (_rStaff = Man.rStaff));
    NEXT(Man);
   END; (* WHILE OCCURE(Man) ... *)
   RESTORE(Man);
   IF Count > 1 THEN
    L_StdFrm.Choice("    ⠪ 㬥⮬");
   END;
  END;

  Err:=L_Man.CheckDocument();
  L_General.Assert(!Err, Err);

  IF Man.rStaff = L_Man.rs_wStaff THEN
   L_General.Assert(L_DatTim.CompleteYearsInIntvl(Man.Birth, SYSDATE()) >= 14,
                    " ࠡ⭨     14 ");
 
   onDate:=SYSDATE();
   IF SELECT(Staff, Man, Man.Man) THEN
    WHILE OCCURE(Staff) DO
     onDate:=Math.Min(onDate, Staff.BegDate);
     NEXT(Staff);
    END; (* WHILE OCCURE(Staff) ... *)
   END;
   onDate:=Math.Max(Math.Max(onDate, L_Env.aptm_Start), 01\01\1998);
   L_General.Assert(SELECT(ManAdr, Man, Man.Man, L_Russia.at_BthMA),
                    "室 㪠  " + L_Man.GetManAdrType_asStr(L_Russia.at_BthMA));
   L_General.Assert(SELECT(ManAdr, Man, Man.Man, L_Russia.at_RgMA),
                    "室 㪠  " + L_Man.GetManAdrType_asStr(L_Russia.at_RgMA));
   L_General.Assert(ManAdr.Date <= onDate,
                    "  "+ L_Man.GetManAdrType_asStr(L_Russia.at_RgMA) + "     " + L_DatTim.DateStr(onDate));
   ManDocCtz:=ManDoc_Citizen(Man.DocType) <= L_Man.ct_Russia;
   ManAdrCtz:=L_Man.Man_Citizen(Man.Man, MAXOF(DATE)) <= L_Man.ct_Russia;
   IF ManDocCtz # ManAdrCtz THEN
    Err:="ࠦ⢮  㬥, 㤮⮢饬 筮,"+
         "|   ﭭ  ⥫⢠   :"+
         "| 㬥  - "+Str.Align(L_Str.PoolItem("࠭ ࠦ|ࠦ ", ManDocCtz), 21, LEFT)+
         "|   - "+Str.Align(L_Str.PoolItem("࠭ ࠦ|ࠦ ", ManAdrCtz), 21, LEFT)+
         L_StdFrm.THR("")+
         "⭮,      "+L_DatTim.DateStr(Man.PspGiveD)+
         L_Str.PoolItem("   ᨨ|  ᨨ", ManDocCtz);
    IF (Man.DocType = 05(*࠭ ᯮ*)) | (Man.DocType = 08(*ᯮ ࠦ *)) THEN
     L_General.Error(Err);
    ELSE
     L_StdFrm.CrucialChoice(Err, L_APtm.g_Staff);
    END;
   END;
   IF Man.DocType = 12(*  ⥫⢮*) THEN
    L_StdFrm.CrucialChoice("  ⥫⢮   㬥⮬, 㤮⮢騬 筮"+
                           L_StdFrm.THR("")+
                           "室 㪠 ࠢ 㬥 (ᯮ  ..  稨),"+
                           "|   ⥫⢮ ନ  ᢮⢥  "+L_Str.IntStr(P_Man.P_ForeignerLegalStatus),
                           L_APtm.g_Staff);
   END;
  END; (* IF Man.rStaff...*)

  L_Man.CheckName(Man.Name);

  L_General.Assert((Man.rStaff # L_Man.rs_None) | P_Man.HasManPro(Man.Man, SYSDATE(), P_Man.P_AccessToTerritory),
                   "⭨  㤮 ஢|  ᢮⢮ '  ।⨥'");
  L_Man.CheckManActvForPrvWork(Man.Man);
 END {CheckAllData};

 PRIVATE PROCEDURE UpdateOutsiderInfo();
  VAR
   Fields: FORM_FIELDS;
   Dummy : STRING[];
 BEGIN
  IF (RTI.Get().CurWindow.OriginalName = wn_2Pass) THEN
   Fields:=RTI.Get().CurZone.Fields;
   P_Man.GetAccessOutsiderInf(Man.Man, SYSDATE(), Fields("Firm").Value, Fields("Aim").Value, Fields("ResponsibleTSN").Value);
   Fields("AcsGroup").Value:=P_Man.GetAcsGroup(Man.Man, SYSDATE());
  ELSIF (RTI.Get().CurWindow.OriginalName = wn_Main) THEN
   Fields:=RTI.Get().CurZone.Fields;
   P_Man.GetAccessOutsiderInf(Man.Man, SYSDATE(), Fields("Firm").Value, Dummy, Dummy);
  END;
 END {UpdateOutsiderInfo};

 PRIVATE PROCEDURE Man_OnBeforeEdit();
 BEGIN
  L_AR.GrantRightsForInteractiveModification();
 END {Man_OnBeforeEdit};

 PRIVATE PROCEDURE Man_OnBeforeInsert();
 BEGIN
  L_AR.GrantRightsForInteractiveModification();
  Man.DocType:=08(*ᯮ ࠦ *);
  IF RTI.Get().CurWindow.OriginalName = wn_2Pass THEN
   Man.rStaff:=L_Man.rs_None;
  END;
  REPLACE(Man);
  L_ctc.BeforeOriginInsert(L_ctc.o_Man);
 END {Man_OnBeforeInsert};

 PRIVATE PROCEDURE Man_OnBeforeDelete();
 BEGIN
  L_XObj.BeforeOriginDelete(L_XObj.o_Man);
  L_ctc.BeforeOriginDelete (L_ctc.o_Man);
  L_General.Assert(~SELECT(ACSEvent, Man, Man.Man), "   㦥   ଠ  室.|" +
                                                    " ⠪  ");
  IF L_DBD.TestUsers("Man", 1) THEN
   L_General.Assert(~SELECT(ManPro, Man, Man.Man), "। 㤠  ᫥ 㤠  ᢮⢠ ");
  END;
 END {Man_OnBeforeDelete};

 PRIVATE PROCEDURE Man_OnAfterEdIns();
  VAR
   Fields                 : FORM_FIELDS;
   Outsider_Firm          : LIKE(Firm.Firm);
   Outsider_Aim           : STRING[];
   Outsider_ResponsibleTSN: LIKE(Staff.TSN);
   GiveCP,
   Err,
   AcsGroup               : STRING[];
   Dummy                  : STRING[][2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF (Man.rStaff = L_Man.rs_None) |  (Man.rStaff = L_Man.rs_OutStaff) THEN
   IF Man.rStaff = L_Man.rs_None THEN
    Outsider_Firm          :=Fields("Firm").Value;
    Outsider_Aim           :=Fields("Aim").Value;
    Outsider_ResponsibleTSN:=Fields("ResponsibleTSN").Value;
    AcsGroup               :=Fields("AcsGroup").Value;
   ELSE
    Outsider_Firm          :=Fields("Firm").Value;
    SETEMPTY(Outsider_Aim, Outsider_ResponsibleTSN, AcsGroup);
   END;
   L_General.Assert(~!Outsider_Firm | ~!Outsider_Aim | ~!Outsider_ResponsibleTSN,
                    "  ࠬ 㯠  ।⨥");
   IF ~P_Man.HasActualManPro(Man.Man, SYSDATE(), P_Man.P_AccessToTerritory) THEN
    DEFAULT(ManPro);
    ManPro.Man     :=Man.Man;
    ManPro.Property:=P_Man.P_AccessToTerritory;
    ManPro.Date    :=SYSDATE();
    INSERT(ManPro);
   ELSE
    SETEMPTY(ManPro.Value);
    REPLACE(ManPro);
   END;
   SETEMPTY(Dummy);
   P_Man.Encode_AccessToTerritory(Outsider_Firm, Outsider_Aim, Outsider_ResponsibleTSN, AcsGroup, Dummy, Dummy);
   ManPro.Val2Show:=P_Man.GetVal2Show();
   REPLACE(ManPro);
  END;
  Man.PspGiveS:=Fields("PspGiveS").Value;
  GiveCP:=Fields("PspGiveCP").Value;
  IF ~!GiveCP THEN
   Err:=L_Str.TestStrWMask(" ࠧ", GiveCP, "999-999", "999-999");
   L_General.Assert(!Err, Err);
   INC(Man.PspGiveS, " " + Fields("PspGiveCP").Value);
  END;
  REPLACE(Man);
  CheckAllData();
  L_Man.CheckIfManIsIdentified(Man.Man, 0);
  CONFORM(Man, Contact);
  L_ctc.SetupContactNames(1);
 END {Man_OnAfterEdIns};

 PRIVATE PROCEDURE Man_OnAfterEdit();
 BEGIN
  Man_OnAfterEdIns();
  IF (Man.Name # GE_PVALUE(Man.Name)) | (Man.NameSfx # GE_PVALUE(Man.NameSfx)) THEN
   SAVE(Staff);
   IF SELECT(Staff, Man, Man.Man) THEN
    WHILE OCCURE(Staff) DO
     Staff.Name:=L_Man.GetStaffName();
     REPLACE(Staff);
     L_Stock.SetName_AdvHolderStorage();
     NEXT(Staff);
    END; (* WHILE OCCURE(Staff) ... *)
   END;
   RESTORE(Staff);
  END;
 END {Man_OnAfterEdit};

 PRIVATE PROCEDURE Man_OnAfterInsert();
 BEGIN
  Man_OnAfterEdIns();
 END {Man_OnAfterInsert};

 PRIVATE PROCEDURE Man_1_OnSetSubwindow();
  VAR
   SubWindow: STRING[];
 BEGIN
  IF ACCESS(Man) & ~Man.rStaff THEN
   SubWindow:=wn_2Pass;
  ELSE
   SubWindow:=wn_Main;
  END;
  RTI.Get().CurZone.HasVariousSubwindows :=1;
  RTI.Get().CurZone.SubwindowOriginalName:=SubWindow;
 END {Man_1_OnSetSubwindow};

 PRIVATE PROCEDURE ManE_0_OnReposition();
  VAR
   Modifiable: SCAL[2];
   Fields    : FORM_FIELDS;
 BEGIN
  SetSexDependentPool();
  Modifiable:=1;
  IF RTI.Get().CurProcess.Kind # FORM_PROCESS.Kind_Insert THEN
   Modifiable:=L_General.IsAdmin() | ~L_Man.E_ManNameModificationThroughEDOrder();
  END;
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Man.Name").Modifiable:=Modifiable;
  L_Man.SplitManDocGiveS(Man.PspGiveS, Fields("PspGiveS").Value, Fields("PspGiveCP").Value);
  UpdateOutsiderInfo();
  ManE_0_OnSetupFields();
  Fields("Photo").Value:=L_GUI.SoftLoadPicture(P_Man.GetFullPhotoFileName(P_Man.GetManProSoft(Man.Man, Memo.ud_cd(), P_Man.P_ManPhoto)));
 END {ManE_0_OnReposition};

 PRIVATE PROCEDURE MnE2Pass_0_OnReposition();
 BEGIN
  UpdateOutsiderInfo();
  L_Man.SplitManDocGiveS(Man.PspGiveS, RTI.Get().CurZone.Fields("PspGiveS").Value,
                                       RTI.Get().CurZone.Fields("PspGiveCP").Value);
 END {MnE2Pass_0_OnReposition};

 PRIVATE PROCEDURE Man_1_OnZoneOpen();
 BEGIN
  SELECT(ManAdr, Man);
 END {Man_1_OnZoneOpen};

 PRIVATE PROCEDURE ManE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["Man.SINumber", "Man.Birth", "Man.Name", "Man.Sex", "Man.INN", "Man_rStaff"]);
  L_WDO.iUnmodifiable(0, ["Man.Man", "Firm_Name", "Firm_Title"]);
  L_WDO.iMayBeEmpty  (0, ["Man.INN", "Man.SINumber", "Man.PspSer", "PspGiveCP", "Man.NameSfx"]);
  L_WDO.iField       (0, "Man.Sex").Format:=L_Man.GetManSexPool();
  L_WDO.iField       (0, "Man.Sex").First:=1;
  L_WDO.iField       (0, "Man.DocType").Format :=dt_Pool;
  L_WDO.iField       (0, "Man.SINumber").Format:=L_Russia.sf_ManSINumber;
  L_WDO.iField       (0, "Man_rStaff").Format:=L_Man.rs_Pool_woNone;
  L_WDO.CreateFormLink("Firm", "");
  L_WDO.iSubwindow   (1, "ManFmlE");
  L_WDO.iMayBeEmpty  (1, ["ManFml.Name", "ManFml.Member"]);
  L_WDO.iField       (1, "ManFml.Member").Format:=L_Man.FmlMemberPool;
  L_WDO.iEvents      (2, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iField       (2, "ManAdr.AdrType").Format:=" ஦|ﭭ|᪨|ࠦ⢠";
  L_WDO.iZone        (2).HasVariousSubwindows:=1;
 END {ManE_OnInitializeWindow};

 PRIVATE PROCEDURE StretchButtonPicture(btn: PUSH_BUTTON; BorderWidth: FLOAT);
 BEGIN
  btn.PictureRect.Left  :=BorderWidth;
  btn.PictureRect.Top   :=BorderWidth;
  btn.PictureRect.Right :=btn.Rect.Right  - BorderWidth;
  btn.PictureRect.Bottom:=btn.Rect.Bottom - BorderWidth;
 END {StretchButtonPicture};


 PUBLIC PROCEDURE ShowPhoto();
  CONST
   Timeout     = 300;

   BorderWidth = 5;
   pL_Button   = 0;
   pT_Button   = 0;

  VAR
   dlg          : DIALOG;
   oImgFile     : OBJECT;
   ElapsedTime  : FLOAT;
   PhotoFileName: STRING[];
   kx, ky, kmax,
   sW_Picture,
   sH_Picture,
   sW_Button,
   sH_Button,
   dlgWidth,
   dlgHeight    : FLOAT;
 BEGIN
  ACCESS(Man);
  PhotoFileName:=P_Man.GetFullPhotoFileName(P_Man.GetManProStrong(Man.Man, Memo.ud_cd(), P_Man.P_ManPhoto));
  L_General.Assert(FIO.Exists(PhotoFileName), " " + PhotoFileName + "  ");
  oImgFile  :=L_GUI.LoadPicture(PhotoFileName);
  HIMETRICTOPIXELS(sW_Picture, sH_Picture, oImgFile.Width, oImgFile.Height);
  IF (sW_Picture + BorderWidth > L_GUI.normalWidth) | (sH_Picture + BorderWidth > L_GUI.normalHeight) THEN
   kx  :=(sW_Picture + BorderWidth)/L_GUI.normalWidth;
   ky  :=(sH_Picture + BorderWidth)/L_GUI.normalHeight;
   kmax:=Math.Max(kx, ky);
   sW_Picture:=sW_Picture/kmax;
   sH_Picture:=sH_Picture/kmax;
  END;
  sW_Button :=sW_Picture + 2*BorderWidth;
  sH_Button :=sH_Picture + 2*BorderWidth;
  dlgWidth  :=sW_Button;
  dlgHeight :=sH_Button;
  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   L_AR.GrantRightsUnconditionally();
   dlg                     :=L_GUI.extCreateDialog(0);
   dlg.ReplaceMainWindow   :=0;
   dlg.WindowStyle         :=DIALOG.WindowStyle_FixedSize;
   dlg.StandardClientWidth :=dlgWidth;
   dlg.StandardClientHeight:=dlgHeight;
   dlg.ClientRect.Right    :=dlg.ClientRect.Left + dlgWidth;
   dlg.ClientRect.Bottom   :=dlg.ClientRect.Top  + dlgHeight;
   dlg.CaptionText         :=Man.Name + " (" + L_Str.FixedIntStr(Man.Man, 5) + ")";

   L_GUI.add_Button(dlg, DIALOG.bi_Default,
                    "",
                    PhotoFileName,
                    pL_Button, pT_Button, sW_Button, sH_Button,
                    L_GUI.fs_StandartButton, L_GUI.fn_Default, EMPTYOF(PROC));
   StretchButtonPicture(dlg.Controls.Item(DIALOG.bi_Default), BorderWidth);
   dlg.Controls.Item(DIALOG.bi_Default).Visible:=1;
    
   ElapsedTime:=Timeout;
   dlg.Visible:=1;
   dlg.Redraw();
   WHILE dlg.Visible & (ElapsedTime > 0) DO
    dlg.Wait(0.5);
    DEC(ElapsedTime, 0.5);
   END; (* WHILE dlg.Visible *)
   IF ElapsedTime = 0 THEN
    dlg.Visible:=0;
    dlg.Redraw();
   END;
  EXCEPT
  ON Exc: Exc_TermByUser DO
   IF VAR_IMPL.Get(dlg).Initialized THEN
    dlg.Visible:=0;
    dlg.Redraw();
   END;
  END; (* TRY *)
 END {ShowPhoto};

 PRIVATE PROCEDURE MnE2Pass_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition, L_WDO.e_OnOpenZone]);
  L_WDO.iScsChange   (0, ["Man.Name", "Man.Sex"]);
  L_WDO.iUnmodifiable(0, ["Firm_Name", "ResponsibleStaff_Name", "Man.Man"]);
  L_WDO.iMayBeEmpty  (0, ["AcsGroup", "Aim", "Man.PspSer", "ResponsibleTSN", "Firm", "PspGiveCP"]);
  L_WDO.iField       (0, "Man.DocType").Format:=dt_Pool;
  L_WDO.iField       (0, "Man.Sex").Format:=L_Man.GetManSexPool();
  L_WDO.CreateFormLink("Firm", "");
  L_WDO.CreateFormLink("Staff", "Responsible");
 END {MnE2Pass_OnInitializeWindow};

 PRIVATE PROCEDURE MnE2Pass_0_OnZoneOpen();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("AcsGroup").Template        :=L_Pool.Get(P_Man.pool_AcsGroup);
  Fields("AcsGroup").TemplateIsStrict:=1;
 END {MnE2Pass_0_OnZoneOpen};

BEGIN
 L_Events.ExecuteHandler();
END.
