(*
%Copyright   (c) Polak Computer System
%Author      13.11.2002 17:21:11 POLAK\GAV
%Purpose
%Type        report
%Specific    SYS
%Modified    04.09.2014 17:59:45 POLAK\Gina
%Environment
*)

 MODULE MAN01 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Staff, L_Man, L_Basis, L_Str, P_Man, FIO, Memo, P_Firm, L_Env, Str,
        L_Russia, L_bp, L_PRoll, L_APtm;

 PRIVATE PROCEDURE GetTotStage(OnDate: DATE): DATE;
  VAR
   Result: DATE;
 BEGIN
  TRY
   Result:=L_Man.GetStageDate(OnDate, L_Man.ins_Common);
  EXCEPT
  ON Exc: Exc_Raise DO
   SETEMPTY(Result);
  ELSE
   RAISE();
  END;
  RETURN Result;
 END {GetTotStage};

 PRIVATE PROCEDURE WithMF(): SCAL[2];
 BEGIN
  RETURN P_Firm.E_wMultipleMyFirm(SYSDATE());
 END {WithMF};

 PRIVATE PROCEDURE MAN01_MakeHeader(F: STRING[]);
 BEGIN
  IF WithMF() THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  IF L_APtm.IsOG() THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ਥ");
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ⥫⢠");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, " ஦");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "࠭");
  L_Basis.wb_WrInQM(F, "࠭");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "䮭");
  L_Basis.wb_WrInQM(F, "䮭 ࠡ");
  L_Basis.wb_WrInQM(F, "쭠  ਥ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ॣ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⠦  ");
  L_Basis.wb_WrInQM(F, "騩 ⠦");
  L_Basis.wb_WrInQM(F, "㬥");
  L_Basis.wb_WrInQM(F, "⥫");
  L_Basis.wb_WrInQM(F, "⠦ ࠡ ⥫");
  L_Basis.wb_WrInQM(F, "⥣ ⥫᪮ 㤮⮢७");
  L_Basis.wb_WrInQM(F, "⥫᪮ 㤮⮢७");
  L_Basis.wb_WrInQM(F, "ࠧ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_TermLine(F);
 END {MAN01_MakeHeader};

 PRIVATE PROCEDURE HasOutsiderInfFirm(curD: DATE): SCAL[2];
  VAR
   trgFirm : LIKE(Firm.Firm);
   DummyStr: STRING[];
   DummyTSN: LIKE(Staff.TSN);
 BEGIN
  P_Man.GetAccessOutsiderInf(Man.Man, curD, trgFirm, DummyStr, DummyTSN);
  IF !trgFirm THEN
   RETURN 0;
  ELSE
   SEARCH(Firm, Firm, , trgFirm);
   RETURN 1;
  END;
 END {HasOutsiderInfFirm};

 PRIVATE PROCEDURE GetRgManAdrInf(    curD          : DATE;
                                  VAR curCountry    : LIKE(Country.Country);
                                  VAR curCountryName: LIKE(Country.Name);
                                  VAR curRegion     : LIKE(ManAdr.Region);
                                  VAR curRegionN    : LIKE(ManAdr.RegionN);
                                  VAR curPostAdrStr : STRING[]);
 BEGIN
  IF L_Man.AccessManAdr(Man.Man, curD, L_Russia.at_RgMA) THEN
   CONFORM(ManAdr, Country);
   curCountry    :=Country.Country;
   curCountryName:=Country.Name;
   curRegion     :=ManAdr.Region;
   curRegionN    :=ManAdr.RegionN;
   curPostAdrStr :=L_Man.GetPostAdr_asStr(1);
  ELSE
   SETEMPTY(curCountry, curCountryName, curRegion, curRegionN, curPostAdrStr);
  END;
 END {GetRgManAdrInf};

 PRIVATE PROCEDURE MAN01_MakeLine(F: STRING[]; OnDate: DATE);
  VAR
   DaysDriver,
   MonthsDriver,
   YearsDriver,
   DaysDrInFirm,
   MonthsDrInFirm,
   YearsDrInFirm  : NUMERIC[0];
   StageDriver,
   StageDrInFirm  : NUMERIC[6];
   s              : STRING[];
   curCountry     : LIKE(Country.Country);
   curCountryName : LIKE(Country.Name);
   curRegion      : LIKE(ManAdr.Region);
   curRegionN     : LIKE(ManAdr.RegionN);
   curPostAdrStr  : STRING[];
 BEGIN
  CONFORM(StaffLog, Officer, Post, Union, Sort);
  CONFORM(Staff, Man);
  L_Man.FillStageDriver(OnDate,
                        DaysDriver,   MonthsDriver,   YearsDriver,
                        DaysDrInFirm, MonthsDrInFirm, YearsDrInFirm,
                        StageDriver, StageDrInFirm);
  GetRgManAdrInf(OnDate, curCountry, curCountryName, curRegion, curRegionN, curPostAdrStr);
  IF WithMF() THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  IF L_APtm.IsOG() THEN
   CONFORM(Man, am);
   L_Basis.wb_WrScl(F, am.am);
   L_Basis.wb_WrStr(F, am.Name);
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Staff.cnt_Pool, Staff.Contract));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", StaffLog.ContDTyp));
  L_Basis.wb_WrDat(F, Staff.BegDate);
  L_Basis.wb_WrScl(F, L_Staff.getService());
  L_Basis.wb_WrStr(F, L_Staff.getServiceName());
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrStr(F, L_Man.GetManSex_asStr());
  L_Basis.wb_WrStr(F, L_Man.CitizenAsStr(Man.Man, OnDate));
  L_Basis.wb_WrStr(F, L_Man.GetManSINumber_asStr());
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrDat(F, Man.Birth);
  L_Basis.wb_WrStr(F, FLDTOSTR(L_DatTim.CompleteYearsInIntvl(Man.Birth, OnDate-1), ""));
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrScl(F, curCountry);
  L_Basis.wb_WrStr(F, curCountryName);
  L_Basis.wb_WrScl(F, StaffLog.Class);
  L_Basis.wb_WrStr(F, L_Man.ManPhone(OnDate));
  L_Basis.wb_WrStr(F, P_Man.GetStaffWorkTelefon(OnDate, P_Man.ci_ExtTelefon));
  L_Basis.wb_WrDat(F, L_Man.GetTakeOnDate(OnDate));
  L_Basis.wb_WrStr(F, curPostAdrStr);
  L_Basis.wb_WrScl(F, curRegion);
  L_Basis.wb_WrStr(F, curRegionN);
  L_Basis.wb_WrDat(F, L_Staff.E_GetBegInFirm(OnDate));
  L_Basis.wb_WrDat(F, GetTotStage(OnDate));
  L_Basis.wb_WrStr(F, L_Man.GetManDocAttr_asStr());
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", L_Env.IsDriver()));
  L_Basis.wb_WrNum(F, StageDriver, 6);
  L_Basis.wb_WrStr(F, P_Man.GetDriveSertification_NewStyleCategory(Man.Man, OnDate));
  IF P_Man.HasActualManPro(Man.Man, OnDate, P_Man.P_DriveSertification) THEN
   L_Basis.wb_WrStr(F, ManPro.DocNum);
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrStr(F, L_Man.GetManEducationLevelAsStr());
  IF P_Man.HasActualManPro(Man.Man, OnDate, P_Man.P_MemberOMI) THEN
   s:=ManPro.DocNum;
   IF ~!ManPro.DocGiveS | ~!ManPro.DocGiveD THEN
    s:=s + ", 뤠";
    IF ~!ManPro.DocGiveD THEN
     s:=s + " " + L_DatTim.DateStr(ManPro.DocGiveD);
    END;
    IF ~!ManPro.DocGiveS THEN
     s:=s + " " + ManPro.DocGiveS;
    END;
   END;
   IF ~!ManPro.DocExpD THEN
    s:=s + ", .  " + L_DatTim.DateStr(ManPro.DocExpD);
   ELSE
    s:=s + ", ﭭ";
   END;
   L_Basis.wb_WrStr(F, s);
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
  IF HasOutsiderInfFirm(OnDate) THEN
   L_Basis.wb_WrScl(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_TermLine(F);
 END {MAN01_MakeLine};

 PUBLIC PROCEDURE MAN01();
  CONST
   bpId = "Man01";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.SetCacheables(["Man", "Officer", "SLKind", "Staff", "StaffLog"]);
  L_bp.Begin(bpId, " ᮭ N 01", L_bp.t_Basis, L_General.tc_onDate);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);

  MAN01_MakeHeader("R");

  SETSEL(Staff, TSN);
  FOR_EACH Staff DO
   PROMPT(Staff.TSN);
   IF L_Staff.rInState(Memo.ud_cd()) THEN
    MAN01_MakeLine("R", Memo.ud_cd());
   END;
  END; (* FOR_EACH Staff *)

  FIO.Close(R);
  L_bp.End();
 END {MAN01};

 PRIVATE PROCEDURE GetAgeGr(OnDate: DATE): STRING[];
  VAR
   _Age: NUMERIC[6];
 BEGIN
  IF ~!ManFml.Birth THEN
   _Age:=L_DatTim.YearsInIntvl(ManFml.Birth, OnDate);
   IF    _Age < 1.5 THEN RETURN " 1.5";
   ELSIF _Age < 3   THEN RETURN " 1.5  3";
   ELSIF _Age < 16  THEN RETURN " 3  16";
   ELSE                  RETURN " 16  ";
   END;
  ELSE
   RETURN "⭮";
  END;
 END {GetAgeGr};

 PRIVATE PROCEDURE _GetManFmlState_asStr(): STRING[];
 BEGIN
  IF !Man.FmlState THEN RETURN "";
  ELSE                  RETURN L_Man.GetManFmlState_asStr();
  END;
 END {_GetManFmlState_asStr};

 PRIVATE PROCEDURE FM003_MakeHeader(F: STRING[]);
 BEGIN
  IF WithMF() THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "_");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "䮭");
  L_Basis.wb_WrInQM(F, "⭮襭");
  L_Basis.wb_WrInQM(F, "_");
  L_Basis.wb_WrInQM(F, "_");
  L_Basis.wb_WrInQM(F, " ஦");
  L_Basis.wb_WrInQM(F, "⭠ 㯯");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ⥫⢠");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_TermLine(F);
 END {FM003_MakeHeader};

 PRIVATE PROCEDURE FM003_MakeLine(F          : STRING[];
                                  OnDate     : DATE;
                                  AdrStr,
                                  MemberStr,
                                  SexStr,
                                  NameStr    : STRING[];
                                  BirthDate  : DATE;
                                  AgeGrStr,
                                  CitizenStr,
                                  FmlStateStr: STRING[]);
 BEGIN
  IF WithMF() THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, L_Man.GetManSex_asStr());
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|", L_PRoll.HasTradeUnionDeduct(Staff.TSN, OnDate)));
  L_Basis.wb_WrStr(F, AdrStr);
  L_Basis.wb_WrStr(F, L_Man.ManPhone(OnDate));
  L_Basis.wb_WrStr(F, MemberStr);
  L_Basis.wb_WrStr(F, SexStr);
  L_Basis.wb_WrStr(F, NameStr);
  L_Basis.wb_WrDat(F, BirthDate);
  L_Basis.wb_WrStr(F, AgeGrStr);
  IF ~!BirthDate THEN
   L_Basis.wb_WrNum(F, L_DatTim.CompleteYearsInIntvl(BirthDate, OnDate), 0);
  ELSE
   L_Basis.wb_WrNum(F, EMPTYOF(NUMERIC[0]), 0);
  END;
  L_Basis.wb_WrStr(F, CitizenStr);
  L_Basis.wb_WrStr(F, FmlStateStr);
  L_Basis.wb_TermLine(F);
 END {FM003_MakeLine};

 PUBLIC PROCEDURE Fm003();
  CONST
   bpId = "Fm003";
  VAR
   OnDate    : DATE;
   AdrStr,
   CitizenStr: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " ࠡ⭨", L_bp.t_Basis, L_General.tc_onDate);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);

  FM003_MakeHeader("R");
  OnDate:=Memo.ud_cd();
  SETSEL(Staff, TSN);
  FOR_EACH Staff DO
   PROMPT(Staff.TSN);
   IF L_Staff.rInState(OnDate) &
      (Staff.Contract # L_Staff.cnt_InternalCombine) THEN
    L_Staff.PosToStaffLog(Staff.TSN, OnDate, 1);
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, Post);
    CONFORM(Officer, Sort);
    CONFORM(Staff, Man);
    CitizenStr:=L_Man.CitizenAsStr(Man.Man, OnDate);
    IF L_Man.AccessManAdr(Man.Man, OnDate, L_Russia.at_RgMA) THEN
     L_Man.curManAdr_Set_glb_AdrVar();
     AdrStr:=L_Russia.PFRAdr_asStr();
    ELSE
     SETEMPTY(AdrStr);
    END;
    FM003_MakeLine("R", OnDate, AdrStr, "⭨", L_Man.GetManSex_asStr(), Man.Name,
                   Man.Birth, "", CitizenStr, _GetManFmlState_asStr());
    SETSEL(ManFml, Man, Man.Man);
    FOR_EACH ManFml DO
     IF L_DatTim.IsActive_Inc(OnDate, ManFml.BegDate, ManFml.EndDate) THEN
      FM003_MakeLine("R", OnDate,
                      AdrStr,
                      L_Str.PoolItem(L_Man.FmlMemberPool, ManFml.Member),
                      L_Man.GetManFmlSex_asStr(),
                      ManFml.Name,
                      ManFml.Birth,
                      GetAgeGr(OnDate),
                      CitizenStr,
                      "");
     END;
    END; (* FOR_EACH ManFml *)
   END;
  END; (* FOR_EACH Staff *)
  FIO.Close(R);
  L_bp.End();
 END {FM003};

 PRIVATE PROCEDURE MAN02_MakeHeader(F: STRING[]);
 BEGIN
  IF WithMF() THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ਥ");
  L_Basis.wb_WrInQM(F, "쭠  ਥ");
  L_Basis.wb_WrInQM(F, "⠦  ");
  L_Basis.wb_WrInQM(F, "騩 ⠦");
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "஢ ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " 㬥");
  L_Basis.wb_WrInQM(F, " 㬥");
  L_Basis.wb_WrInQM(F, " 뤠");
  L_Basis.wb_WrInQM(F, "ਬ砭");
  L_Basis.wb_TermLine(F);
 END {MAN02_MakeHeader};

 PRIVATE PROCEDURE MAN02_MakeLine(F         : STRING[];
                                  RealBeg,
                                  TotStage,
                                  ExprDate  : DATE;
                                  ExprType,
                                  ExprLevel,
                                  ExprValue : STRING[]);
 BEGIN
  IF WithMF() THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, L_Man.GetManSex_asStr());
  L_Basis.wb_WrDat(F, Staff.BegDate);
  L_Basis.wb_WrDat(F, RealBeg);
  L_Basis.wb_WrDat(F, L_Staff.E_GetBegInFirm(Memo.ud_cd()));
  L_Basis.wb_WrDat(F, TotStage);
  L_Basis.wb_WrScl(F, L_Staff.getService());
  L_Basis.wb_WrStr(F, L_Staff.getServiceName());
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrDat(F, ExprDate);
  L_Basis.wb_WrStr(F, ExprType);
  L_Basis.wb_WrStr(F, ExprLevel);
  L_Basis.wb_WrStr(F, ExprValue);
  IF ~!ExprLevel THEN
   L_Basis.wb_WrStr(F, ManExpr.DocSer);
   L_Basis.wb_WrStr(F, ManExpr.DocNum);
   L_Basis.wb_WrStr(F, ManExpr.DocGiveS);
   L_Basis.wb_WrStr(F, ManExpr.Comment);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;
  L_Basis.wb_TermLine(F);
 END {MAN02_MakeLine};

 PRIVATE PROCEDURE MAN02_MakeNoExprLine(HasExpr : SCAL[2][16];
                                        F       : STRING[];
                                        RealBeg,
                                        TotStage: DATE;
                                        ExprType: SCAL[16]);
 BEGIN
  IF ~HasExpr[ExprType] THEN
   MAN02_MakeLine(F, RealBeg,
                     TotStage,
                     EMPTYOF(DATE),
                     L_Str.PoolItem(L_Man.et_Pool, ExprType),
                     "",
                     "");
  END;
 END {MAN02_MakeNoExprLine};

 PRIVATE PROCEDURE MAN02_MakeOneMan(F: STRING[]);
  VAR
   RealBeg,
   TotStage: DATE;
   HasExpr : SCAL[2][16];
 BEGIN
  CONFORM(StaffLog, Officer, Post, Sort, Union);
  CONFORM(Staff, Man);
  RealBeg :=L_Man.GetTakeOnDate(Memo.ud_cd());
  TotStage:=GetTotStage(Memo.ud_cd());
  SETZERO(HasExpr);
  SETSEL(ManExpr, Man, Man.Man);
  FOR_EACH ManExpr DO
   IF ~L_Man.ExprIsNativeLanguage(ManExpr.ExprType) THEN
    CONFORM(ManExpr, Expr);
    MAN02_MakeLine(F, RealBeg,
                      TotStage,
                      ManExpr.Date,
                      L_Str.PoolItem(L_Man.et_Pool, ManExpr.ExprType),
                      Expr.Level,
                      Expr.Name);
    HasExpr[ManExpr.ExprType]:=1;
   END;
  END; (* FOR_EACH ManExpr *)

  MAN02_MakeNoExprLine(HasExpr, F, RealBeg, TotStage, L_Man.et_Skill);
  MAN02_MakeNoExprLine(HasExpr, F, RealBeg, TotStage, L_Man.et_Stimulation);
  MAN02_MakeNoExprLine(HasExpr, F, RealBeg, TotStage, L_Man.et_Tribute);
 END {MAN02_MakeOneMan};

 PUBLIC PROCEDURE MAN02();
  CONST
   bpId = "Man02";
  VAR
   AdrStr,
   CitizenStr: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.SetCacheables(["Man", "Officer", "SLKind", "Staff", "StaffLog"]);
  L_bp.Begin(bpId, " ᮭ N 02", L_bp.t_Basis, L_General.tc_onDate);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);

  MAN02_MakeHeader("R");

  SETSEL(Staff, TSN);
  FOR_EACH Staff DO
   PROMPT(Staff.TSN);
   IF L_Staff.rInState(Memo.ud_cd()) & L_Staff.IsMainForTax(Memo.ud_cd()) THEN
    MAN02_MakeOneMan("R");
   END;
  END; (* FOR_EACH Staff *)

  FIO.Close(R);
  L_bp.End();
 END {MAN02};

END.
