(*
%Copyright   (c) Polak Computer System
%Author      13.10.1999 14:50:18 GINA
%Purpose     ஫ 䨪樨 ManActv
%Type        control
%Specific    SYS
%Modified    01.08.2014 17:42:05 POLAK\GAV
%Environment
*)

 MODULE ManActv [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, L_Man, L_Staff, Str, E_Man, L_Str, L_StdFrm, L_WDO;

 PRIVATE PERMANENT VAR
  ChoosenActvKind: LIKE(ManActv.ActvKind);

 PRIVATE PROCEDURE E_EuDepNameTemplate(): STRING[];
  VAR
   local: PROC;
 BEGIN
  local:=PROCREF(E_Man.EuDepNameTemplate);
  IF ~!local THEN
   RETURN local();
  ELSE
   RETURN "";
  END;
 END {E_EuDepNameTemplate};

 PRIVATE PROCEDURE E_EuEdTypeTemplate(): STRING[];
  VAR
   Local    : PROC;
   LocalPool: STRING[];
 BEGIN
  SETEMPTY(LocalPool);
  Local:=PROCREF(E_Man.EuEdTypeTemplate);
  IF ~!Local THEN
   LocalPool:="|" + Local();
  END;
  RETURN L_Man.traintype_Pool + LocalPool;
 END {E_EuEdTypeTemplate};

 PRIVATE PROCEDURE MActv_OnInitializeWindow();
 BEGIN
  SETEMPTY(ChoosenActvKind);
  L_WDO.iZone        (1).Narrowing:="(ManActv.ActvKind="+L_Str.IntStr(L_Man.actvk_Education)+")&(ManActv.Man=Man.Man)";
  L_WDO.iSubwindow   (1, "MActvEdE");
  L_WDO.iField       (1, "ManActv.EdType").Format:=L_Man.edtype_Pool;
  L_WDO.iZone        (2).Narrowing:="(ManActv.ActvKind="+L_Str.IntStr(L_Man.actvk_Work)+")&(ManActv.Man=Man.Man)";
  L_WDO.iSubwindow   (2, "MActvLbE");
 END {MActv_OnInitializeWindow};

 PRIVATE PROCEDURE MActvEu_OnInitializeWindow();
 BEGIN
  SETEMPTY(ChoosenActvKind);
  L_WDO.iEvents      (1, L_WDO.e_OnSetSubwindow);
  L_WDO.iSubwindow   (1, "MActvEuE");
  L_WDO.iZone        (1).PermanentFilter:="(ManActv.ActvKind#"+L_Str.IntStr(L_Man.actvk_Education)+")&" +
                                          "(ManActv.ActvKind#"+L_Str.IntStr(L_Man.actvk_Work)+")";
  L_WDO.iField       (1, "ManActv.ActvKind").Format:=L_Man.actvk_Pool;
 END {MActvEu_OnInitializeWindow};

 PRIVATE PROCEDURE MActvEuE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterInsert]);
  L_WDO.iMayBeEmpty  (0, ["ManActv.DocDate", "ManActv.DocNum", "ManActv.DocExpD", "ManActv.Result",
                          "ManActv.FndName", "ManActv.DepName"]);
  L_WDO.iField       (0, "ManActv.EdType").Format   :=E_EuEdTypeTemplate();
  L_WDO.iField       (0, "ManActv.EdForm").Format   :=L_Man.edform_Pool;
  L_WDO.iField       (0, "ManActv.DocType").Format  :=L_Man.eddoctype_Pool;
  L_WDO.iField       (0, "ManActv.DepName").Template:=E_EuDepNameTemplate();
 END {MActvEuE_OnInitializeWindow};

 PRIVATE PROCEDURE MActvEdE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterInsert]);
  L_WDO.iScsChange   (0, ["ManActv.EdForm"]);
  L_WDO.iUnmodifiable(0, ["v_Qualification", "v_Faculty"]);
  L_WDO.iMayBeEmpty  (0, ["ManActv.Result", "ManActv.DocNum", "ManActv.DocDate", "ManActv.DocType",
                         "ManActv.EndDate", "ManActv.BegDate", "ManActv.OKSO", "ManActv.OKPDTR",
                         "ManActv.DepName"]);
  L_WDO.iField       (0, "ManActv.EdType").Format :=L_Man.edtype_Pool;
  L_WDO.iField       (0, "ManActv.EdForm").Format :=L_Man.edform_Pool;
  L_WDO.iField       (0, "ManActv.DocType").Format:=L_Man.eddoctype_Pool;
  L_WDO.iField       (0, "v_Faculty").Format      :="⥫쭮|⥫쭮|⥫쭮|⥫쭮|⥫쭮|"+
                                                    "||";
  L_WDO.iField       (0, "v_Qualification").Format:="||||䨪|"+
                                                    "䨪|䨪|祭 ⥯";
 END {MActvEdE_OnInitializeWindow};

 PRIVATE PROCEDURE MActvLbE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Man";
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterInsert]);
  L_WDO.iMayBeEmpty  (0, ["ManActv.LongSrvN[2]", "ManActv.TerrCndC", "ManActv.LongSrvN[1]",
                         "ManActv.LongSrvN[0]", "ManActv.SenAddN[0]", "ManActv.SenAddN[1]",
                         "ManActv.SenAddN[2]"]);
  L_WDO.iField       (0, "ManActv.ActvCatg").Format:=L_Man.actvc_Pool;
  L_WDO.iField       (0, "ManActv.TerrCond").Format:=L_Man.terc_Pool;
  L_WDO.iField       (0, "ManActv.Seniorit").Format:=L_Man.senr_Pool;
  L_WDO.iField       (0, "ManActv.SenAddS").Format :=L_Man.senrs_Pool;
  L_WDO.iField       (0, "ManActv.LongServ").Format:=L_Man.longsrv_Pool;
 END {MActvLbE_OnInitializeWindow};

 PRIVATE PROCEDURE MActvEu_1_OnSetSubwindow();
  VAR
   Choose         : NUMERIC[0];
   trgActvKind    : LIKE(ManActv.ActvKind);
   ActvKindList,
   trgActvKindName: STRING[];
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert THEN
   SETEMPTY(ActvKindList);
   trgActvKind:=0;
   LOOP
    trgActvKindName:=L_Str.PoolItem(L_Man.actvk_Pool, trgActvKind);
    IF !trgActvKindName THEN
     EXIT;
    END;
    IF (trgActvKind # L_Man.actvk_Education) & (trgActvKind # L_Man.actvk_Work) THEN
     ActvKindList:=ActvKindList + trgActvKindName + "|";
    END;
    INC(trgActvKind);
   END; (* LOOP *)

   Choose:=L_StdFrm.ShowListAsMenu(ActvKindList, "襭 䨪樨");
   ChoosenActvKind:=L_Str.PositionInPool(L_Man.actvk_Pool, L_Str.PoolItem(ActvKindList, Choose));
  END;
 END {MActvEu_1_OnSetSubwindow};

 PRIVATE PROCEDURE ManActv_OnBeforeInsert();
 BEGIN
  IF ManActv.ActvKind = L_Man.actvk_Work THEN
   ManActv.InStage[L_Man.ins_LastProf]  :=1;
   ManActv.InStage[L_Man.ins_Continuous]:=1;
   ManActv.InStage[L_Man.ins_Common]    :=1;
   ManActv.InStage[L_Man.ins_Post]      :=1;
   ManActv.InStage[L_Man.ins_Branch]    :=0;
   REPLACE(ManActv);
  END;
  IF VAR_IMPL.Get(ChoosenActvKind).Initialized & ~!ChoosenActvKind THEN
   ManActv.ActvKind:=ChoosenActvKind;
   REPLACE(ManActv);
   RTI.Get().CurWindow.Title:=L_Str.PoolItem(L_Man.actvk_Pool, ManActv.ActvKind);
  END;
 END {ManActv_OnBeforeInsert};

 PRIVATE PROCEDURE _CheckManActvIntvl(Dir: STRING[]);
  VAR
   _BegDate: LIKE(ManActv.BegDate);
   _EndDate: LIKE(ManActv.EndDate);
 BEGIN
  _BegDate:=ManActv.BegDate;
  _EndDate:=ManActv.EndDate;
  SAVE(ManActv);
  CHANGESEL(ManActv, Man, , ManActv.Man, ManActv.ActvKind);
  ^Dir(ManActv);
  WHILE OCCURE(ManActv) DO
   IF L_DatTim.IsActiveInIntvl_Inc(_BegDate, _EndDate, ManActv.BegDate, ManActv.EndDate) THEN
    L_StdFrm.Choice(" ਮ ᥪ  ६" +
                    "| 㤮 ⥫쭮  " +
                    L_DatTim.DateStr(ManActv.BegDate) + "  " + L_DatTim.DateStr(ManActv.EndDate));
   END;
   ^Dir(ManActv);
  END; (* WHILE OCCURE(ManActv) ... *)
  RESTORE(ManActv);
 END {_CheckManActvIntvl};

 PRIVATE PROCEDURE CheckWorkPer();
  VAR
   D, RealBegD: DATE;
 BEGIN
  D:=SYSDATE();
  IF L_Staff.IsStandOnAnyMainContract(ManActv.Man, D) & !Staff.EndDate THEN
   RealBegD:=L_Man.GetTakeOnDate(D);
   IF L_DatTim.IsActiveInIntvl_Inc(RealBegD, D, ManActv.BegDate, ManActv.EndDate) THEN
    L_StdFrm.Choice(" ਮ ᥪ  ६" +
                    "| ࠡ⮩  襬 ।⨨  " + L_DatTim.DateStr(RealBegD));
   END;
  END;
 END {CheckWorkPer};

 PRIVATE PROCEDURE ManActv_OnAfterEditInsertEvents();
 BEGIN
  IF ManActv.ActvKind = L_Man.actvk_Education THEN
   L_General.Assert(!ManActv.OKSO | !ManActv.OKPDTR, "       ६");
   L_General.Assert(!ManActv.OKSO | (ManActv.EdType >= L_Man.edtype_SecondaryProf),
                    "      ࠧ '"+L_Str.PoolItem(L_Man.edtype_Pool, L_Man.edtype_SecondaryProf)+"'  ");
   L_General.Assert(!ManActv.OKPDTR | (ManActv.EdType <= L_Man.edtype_PrimaryProf),
                    "      ࠧ '"+L_Str.PoolItem(L_Man.edtype_Pool, L_Man.edtype_PrimaryProf)+"'  ");

   IF    (ManActv.EdType >= L_Man.edtype_PrimaryProf) | L_Man.InAnyStage() THEN
    IF !ManActv.BegDate THEN
     IF    (ManActv.EdType >= L_Man.edtype_HighProf) THEN
      L_General.Error("室 㪠  砫 祭");
     ELSIF L_Man.InAnyStage() THEN
      L_General.Error("室 㪠  砫 祭   㪠뢠 宦  ⠦");
     ELSE
      L_StdFrm.Question(" 㪠  砫 祭");
     END;
    END;
    IF !ManActv.EndDate THEN
     L_StdFrm.Question("祭  稫?");
    ELSE
     L_General.Assert((ManActv.DocType = L_Man.eddoctype_None) |
                      ~!ManActv.DocNum & ~!ManActv.DocDate,
                      "室  ଠ  㬥  砭");
    END;
   END;
   CheckWorkPer();
  ELSIF ManActv.ActvKind = L_Man.actvk_Work THEN
   IF Str.Item(L_Man.actvc_Pool, "|", ManActv.ActvCatg) = "" THEN
    L_StdFrm.Choice(" ⥫쭮 '' ᫥   ࠧ 'ࠧ'");
   END;
   L_General.Assert(ManActv.BegDate <= ManActv.EndDate, " 砫      砭");
   _CheckManActvIntvl("PREV");
   _CheckManActvIntvl("NEXT");
   CheckWorkPer();
  ELSIF ManActv.ActvKind = L_Man.actvk_FurtherTrain THEN
   L_General.Assert((ManActv.EdType = L_Man.traintype_SelfOrg) |
                    ~!ManActv.FndName,
                    "室 㪠  ࠧ⥫쭮 ०");
   L_General.Assert((ManActv.DocType = L_Man.eddoctype_None) |
                    ~!ManActv.DocNum & ~!ManActv.DocDate,
                    "室  ଠ  㬥  砭");
  END;
  IF ~!ManActv.EndDate THEN
   L_General.Assert(ManActv.EndDate <= SYSDATE(), " 砭   㯨?");
  END;
 END {ManActv_OnAfterEditInsertEvents};

 PRIVATE PROCEDURE ManActv_OnAfterInsert();
 BEGIN
  ManActv_OnAfterEditInsertEvents();
 END {ManActv_OnAfterInsert};

 PRIVATE PROCEDURE ManActv_OnAfterEdit();
 BEGIN
  ManActv_OnAfterEditInsertEvents();
 END {ManActv_OnAfterEdit};

 PRIVATE PROCEDURE ManActv_EdForm_OnSuccessfulChange();
 BEGIN
  IF ~!ManActv.EdType & (((ManActv.EdType <=4) & (ManActv.EdForm = 0)) |
                         ((ManActv.EdType > 4) & (ManActv.EdForm # 0))) THEN
   IF (ManActv.InStage[L_Man.ins_Common] # 0) THEN
    L_StdFrm.Inform(" ⨯ ࠧ,|室 ஢ ࠢ쭮   ⠦");
   END;
  END;
 END {ManActv_EdForm_OnSuccessfulChange};

 PUBLIC PROCEDURE BreakService();
 BEGIN
  L_StdFrm.Choice("ࢠ ⠦  ।饩 ⥫쭮?");
  SAVE(ManActv);
  CHANGESEL(ManActv, Man, , ManActv.Man, ManActv.ActvKind);
  WHILE PREV(ManActv) DO
   IF ManActv.InStage[L_Man.ins_Continuous] THEN
    ManActv.InStage[L_Man.ins_Continuous]:=0;
    REPLACE(ManActv);
   END;
  END; (* WHILE PREV(ManActv) ... *)
  RESTORE(ManActv);
 END {BreakService};

BEGIN
 L_Events.ExecuteHandler();
END.
