(*
%Copyright   (c) Polak Computer System
%Author      24.06.1999 12:09:44 GINA
%Purpose     ஢ઠ  
%Type        control
%Specific    SYS
%Modified    17.09.2014 14:26:51 POLAK\Bor
%Environment
*)

 MODULE ManAdr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, L_Russia, L_Man, L_Str, Str, L_WDO, L_StdFrm, L_APtm;

 PUBLIC PROCEDURE SetZipByKlAdr();
 BEGIN
  L_Man.curManAdr_Set_glb_AdrVar();
  ManAdr.Zip:=L_Russia.GetZipByKlAdr();
  REPLACE(ManAdr);
 END {SetZipByKlAdr};

 PUBLIC PROCEDURE SetAdrByZip();
  VAR
   dummy        : STRING[];
   dummyPostKind: L_Russia.tPostKind;
   dummyD       : DATE;
 BEGIN
  L_StdFrm.Question("    ");
  L_Man.curManAdr_Set_glb_AdrVar();
  L_Russia.SetAdrByZip(ManAdr.Zip);
  L_Russia.Get_glb_AdrVar(ManAdr.Country, ManAdr.Zip, ManAdr.Region, ManAdr.RegionN, ManAdr.Distr,
                          ManAdr.Town, ManAdr.Village, ManAdr.Street, ManAdr.TownT, ManAdr.VillageT,
                          ManAdr.StreetT, ManAdr.House, ManAdr.Block, ManAdr.Build, ManAdr.Flat, dummy, dummyPostKind, dummyD);
  REPLACE(ManAdr);
 END {SetAdrByZip};

 PRIVATE PROCEDURE ManAdr_Country_OnSuccessfulChange();
 BEGIN
  L_Russia.Check_MayChooseCountry("ManAdr", ManAdr.Country);
  IF (ManAdr.AdrType#L_Russia.at_BthMA) THEN
   L_Russia.CheckCountryIsActive(ManAdr.Country, SYSDATE());
  END;
 END {ManAdr_Country_OnSuccessfulChange};

 PRIVATE PROCEDURE ManAdr_Region_OnSuccessfulChange();
 BEGIN
  IF ~!ManAdr.Region THEN
   IF ManAdr.Region # 00 THEN
    CONFORM(ManAdr, Region);
    ManAdr.RegionN:=Region.Name;
    REPLACE(ManAdr);
   END;
  END;
 END {ManAdr_Region_OnSuccessfulChange};

 PRIVATE PROCEDURE ManAdr_RegionN_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!ManAdr.Country, "砫 㪠 ࠭");
  L_General.Assert((ManAdr.AdrType = L_Russia.at_BthMA) | (ManAdr.Country#L_Russia.c_Russia),
                   "⨬   ॣ ᨨ");
 END {ManAdr_RegionN_OnSuccessfulChange};

 PRIVATE PROCEDURE SupportEndDate(BeforeDelete: SCAL[2]);
  VAR
   _CurDate,
   _Date     : DATE;
 BEGIN
  SAVE(ManAdr);
  SETEMPTY(_Date);
  _CurDate:=ManAdr.Date;
  CHANGESEL(ManAdr, Man, , ManAdr.Man, ManAdr.AdrType);
  LAST(ManAdr);
  WHILE OCCURE(ManAdr) DO
   IF ManAdr.EndDate > _Date THEN
    IF ~!_Date THEN
     ManAdr.EndDate:=_Date-1;
     REPLACE(ManAdr);
    END;
   END;
   IF ~BeforeDelete | (ManAdr.Date # _CurDate) THEN
    _Date:=ManAdr.Date;
   END;
   PREV(ManAdr);
  END; (* WHILE OCCURE(ManAdr) ... *)
  RESTORE(ManAdr);
 END {SupportEndDate};

 PRIVATE PROCEDURE SetSubWindow(trgAdrType: LIKE(ManAdr.AdrType));
  VAR
   WinName: STRING[];
 BEGIN
  IF (RTI.Get().CurWindow.OriginalName="ManE") & (RTI.Get().CurZone.Number = 2) THEN
   IF    trgAdrType = L_Russia.at_BthMA THEN
    WinName:="ManAdrE0";
   ELSIF trgAdrType = L_Russia.at_CtMA THEN
    WinName:="ManAdrE3";
   ELSE
    WinName:="ManAdrE1";
   END;
   RTI.Get().CurZone.SubwindowOriginalName:=WinName;
  END;
 END {SetSubWindow};

 PRIVATE PROCEDURE EqCountryMsg(trgAdrType: LIKE(ManAdr.AdrType));
  VAR
   _Country: LIKE(ManAdr.Country);
 BEGIN
  SAVE(ManAdr);
  _Country :=ManAdr.Country;
  IF L_Man.AccessManAdr(ManAdr.Man, ManAdr.Date, trgAdrType) & (_Country = ManAdr.Country) THEN
   L_StdFrm.Choice(" ࠭ "+ _Country +" ᮢ   ࠭   " + L_Man.GetManAdrType_asStr(trgAdrType));
  END;
  RESTORE(ManAdr);
 END {EqCountryMsg};

 PRIVATE PROCEDURE ManAdr_OnBeforeInsert();
  VAR
   trgAdrType: LIKE(ManAdr.AdrType);
 BEGIN
  trgAdrType:=L_WDO.GetEnvVarValue("at");
  L_General.CallUs(~!trgAdrType);
  IF trgAdrType = L_Russia.at_BthMA THEN
   SAVE(ManAdr);
   L_General.Assert(~SELECT(ManAdr, Man, ManAdr.Man, trgAdrType), " ஦ 㦥 .  ᫥   .");
   RESTORE(ManAdr);
   CONFORM(ManAdr, Man);
   L_General.Assert(~!Man.Birth, "   ஦");
   ManAdr.Date:=Man.Birth;
  END;
  ManAdr.AdrType:=trgAdrType;
  REPLACE(ManAdr);
 END {ManAdr_OnBeforeInsert};

 PUBLIC PROCEDURE TestAdr();
 BEGIN
  L_Man.curManAdr_Set_glb_AdrVar();
  L_Russia.TestAdr(L_Russia.ao_ManAdr, ManAdr.AdrType, "");
 END {TestAdr};

 PRIVATE PROCEDURE CheckEndDate();
  VAR
   nxtDate,
   prvEndDate : DATE;
   ThereIsHole: SCAL[2];
 BEGIN
  L_General.Assert(ManAdr.EndDate >= ManAdr.Date, " 砭     砫");
  IF ManAdr.AdrType = L_Russia.at_RgMA THEN
   ThereIsHole:=0;
   IF ~!ManAdr.EndDate THEN
    SAVE(ManAdr);
    nxtDate:=ManAdr.EndDate+1;
    IF CHANGESEL(ManAdr, Man, ManAdr.Man, ManAdr.AdrType) & NEXT(ManAdr) THEN
     L_General.Assert(ManAdr.Date >= nxtDate,
                      "騩    " + L_DatTim.DateStr(ManAdr.Date) +
                      "| 砭   ࠭");
     ThereIsHole:=nxtDate # ManAdr.Date;
     RESTORE(ManAdr);
    ELSE
     RESTORE(ManAdr);
     L_StdFrm.CrucialChoice("ப ⢨    ⮫쪮  ⢨  " +
                            " 稨 ६ ॣ樨." +
                            "| ⮣  ⢨⥫쭮  ?", L_APtm.g_Staff);
    END;
   END;
   SAVE(ManAdr);
   prvEndDate:=ManAdr.Date-1;
   IF ~ThereIsHole & CHANGESEL(ManAdr, Man, ManAdr.Man, ManAdr.AdrType) & PREV(ManAdr) THEN
    ThereIsHole:=ThereIsHole | (prvEndDate # ManAdr.EndDate);
   END;
   RESTORE(ManAdr);
   IF ThereIsHole THEN
    L_StdFrm.CrucialChoice(" ''   .  ⢨⥫쭮  ᥣ  ?",
                           L_APtm.g_Staff);
   END;
  END; (* IF ManAdr.AdrType ... *)
 END {CheckEndDate};

 PRIVATE PROCEDURE intCheckManAdr(InformType, OnAfterEdIns: SCAL[2]);
 BEGIN
  TestAdr();
  IF (ManAdr.AdrType = L_Russia.at_RgMA) | (ManAdr.AdrType = L_Russia.at_DwMA) THEN
   IF L_Russia.intCheckKLADRState(OnAfterEdIns) THEN
    L_Russia.CheckAdrByKlAdr(InformType, ManAdr.NotKLADR, L_Russia.lv_All);
   END;
  END;
 END {intCheckManAdr};

 PUBLIC PROCEDURE ManAdr_AfterEdIns();
  VAR
   ErrStr,
   _Address: STRING[];
 BEGIN
  SupportEndDate(0);
  IF ((ManAdr.AdrType = L_Russia.at_RgMA) | (ManAdr.AdrType = L_Russia.at_DwMA)) & (ManAdr.Country = L_Russia.c_Russia) THEN
   L_General.Assert(~!ManAdr.Zip, "室 㪠 ");
  END;
  intCheckManAdr(L_Russia.tit_Error, 1);

  IF    ManAdr.AdrType = L_Russia.at_CtMA THEN
   EqCountryMsg(L_Russia.at_RgMA);
  ELSIF ManAdr.AdrType = L_Russia.at_RgMA THEN
   ErrStr:=L_Man.GetAdrForTax(_Address);
   IF ~!ErrStr THEN
    L_General.Error(ErrStr);
   END;
   EqCountryMsg(L_Russia.at_CtMA);
   CheckEndDate();
  ELSIF ManAdr.AdrType = L_Russia.at_DwMA THEN
   CheckEndDate();
  END;
 END {ManAdr_AfterEdIns};

 PRIVATE PROCEDURE ManAdr_OnAfterEdit();
 BEGIN
  ManAdr_AfterEdIns();
 END {ManAdr_OnAfterEdit};

 PRIVATE PROCEDURE ManAdr_OnAfterInsert();
 BEGIN
  ManAdr_AfterEdIns();
 END {ManAdr_OnAfterInsert};

 PRIVATE PROCEDURE ManAdr_OnBeforeDelete();
 BEGIN
  SupportEndDate(1);
 END {ManAdr_OnBeforeDelete};

 PRIVATE PROCEDURE ManAdr_Ask(Lev: LIKE(KlAdr.Level); VAR trgName: LIKE(KlAdr.Name); VAR trgType: LIKE(KlAdr.Type));
 BEGIN
  L_Russia.CheckKLADRState();
  L_Man.curManAdr_Set_glb_AdrVar();
  L_Russia.PosToFieldKlAdr(Lev);
  IF (KlAdr.Name # trgName) | (KlAdr.Type # trgType) THEN
   trgName:=KlAdr.Name;
   trgType:=KlAdr.Type;
   REPLACE(ManAdr);
  END;
 END {ManAdr_Ask};

 PRIVATE PROCEDURE ManAdr_Distr_OnBeforeAsk();
  VAR
   dmyType: LIKE(KlAdr.Type);
 BEGIN
  SETEMPTY(dmyType);
  ManAdr_Ask(L_Russia.lv_District, ManAdr.Distr, dmyType);
 END {ManAdr_Distr_OnBeforeAsk};

 PRIVATE PROCEDURE ManAdr_Town_OnBeforeAsk();
 BEGIN
  ManAdr_Ask(L_Russia.lv_City, ManAdr.Town, ManAdr.TownT);
 END {ManAdr_Town_OnBeforeAsk};

 PRIVATE PROCEDURE ManAdr_Village_OnBeforeAsk();
 BEGIN
  ManAdr_Ask(L_Russia.lv_Village, ManAdr.Village, ManAdr.VillageT);
 END {ManAdr_Village_OnBeforeAsk};

 PRIVATE PROCEDURE ManAdr_Street_OnBeforeAsk();
 BEGIN
  ManAdr_Ask(L_Russia.lv_Street, ManAdr.Street, ManAdr.StreetT);
 END {ManAdr_Street_OnBeforeAsk};

 PRIVATE PROCEDURE ANY_0_OnZoneOpen();
  VAR
   Fields: FORMFIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("ManAdr.TownT").Format   :=L_Russia.c_TownT;
  Fields("ManAdr.VillageT").Format:=L_Russia.c_VillageT;
  IF ~!Fields("ManAdr.StreetT") THEN
   Fields("ManAdr.StreetT").Format:=L_Russia.c_StreetT;
  END;
 END {ANY_0_OnZoneOpen};

 PRIVATE PROCEDURE ManAdrE1_0_OnZoneOpen();
 BEGIN
  ANY_0_OnZoneOpen();
 END {ManAdrE1_0_OnZoneOpen};

 PRIVATE PROCEDURE ManAdrE0_0_OnZoneOpen();
 BEGIN
  ANY_0_OnZoneOpen();
 END {ManAdrE0_0_OnZoneOpen};

 PUBLIC PROCEDURE CheckManAdr();
 BEGIN
  intCheckManAdr(L_Russia.tit_Choice, 0);
 END {CheckManAdr};

 PRIVATE PROCEDURE ManE_2_OnSetSubwindow();
 BEGIN
  IF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert) THEN
   L_General.CallUs(~!L_WDO.GetEnvVarValue("at"));
   SetSubWindow(L_WDO.GetEnvVarValue("at"));
  ELSE
   L_General.Assert(ACCESS(ManAdr), " ⠭ ⥪ ");
   L_General.CallUs(~!ManAdr.AdrType);
   SetSubWindow(ManAdr.AdrType);
  END;
 END {ManE_2_OnSetSubwindow};

BEGIN
 L_Events.ExecuteHandler();
END.
