(*
%Copyright   (c) Polak Computer System
%Author      01.09.1999 19:32:59 SAN
%Purpose     ஫ 䨪樨 ManExpr
%Type        control
%Specific    SYS
%Modified    02.09.2011 13:21:00 POLAK\San
%Environment
*)

 IMPORT L_General, L_Man, L_Events, L_Pool, L_EDO, L_PRoll, L_DatTim, L_Env, E_Man;

 PRIVATE PROCEDURE ManExpr_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("ManExpr.ExprType").Format:=L_Man.et_Pool;
 END {ManExpr_1_OnZoneOpen};

 PRIVATE PROCEDURE ManExprE_0_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("Expr.Source").Format:=L_Man.expsrc_Pool;
 END {ManExpr_0_OnZoneOpen};

 PUBLIC PROCEDURE _ShtDone();
  VAR
   D: DATE;
 BEGIN
  IF OCCURE(Staff) THEN
   D:=L_DatTim.Per(ManExpr.Date);
   IF D < L_PRoll.Salary_ClcPer() THEN
    STDMSG(" ਢ   ௫  " + L_DatTim.PeriodStr(D), CHOICE);
   END;
   L_PRoll.ShtDone_AP(L_DatTim.MaxDATE(L_Env.aptm_Start, D), 0);
  END;
 END {_ShtDone};

 PRIVATE PROCEDURE CheckEdInsAllowed();
  VAR
   Local: PROC;
 BEGIN
  L_General.Assert(!ManExpr._EDOrder,   " ⨦ ଫ ਪ  ᮭ");
  IF L_Man.ExprIsTribute(ManExpr.ExprType) | L_Man.ExprIsStimulation(ManExpr.ExprType) THEN
   Local:=PROCREF(E_Man.ManExprModificationThroughEDOrder);
   IF ~!Local THEN
    L_General.Assert(~Local(ManExpr.Date), "ࠤ  ७ ଫ ਪ  ᮭ");
   END;
  END;
 END {CheckEdInsAllowed};

 PRIVATE PROCEDURE CheckEdDelAllowed();
 BEGIN
  L_General.Assert(!ManExpr._EDOrder,   " ⨦ ଫ ਪ  ᮭ");
 END {CheckEdDelAllowed};

 PRIVATE PROCEDURE ManExpr_OnBeforeEdIns();
 BEGIN
  RTI.Get().CurZone.Fields("ManExpr.DocGiveS").Template:=L_Pool.Get(L_Man.pool_ManExprDocGiveS);
 END {ManExpr_OnBeforeEdIns};

 PRIVATE PROCEDURE ManExpr_OnBeforeEdit();
 BEGIN
  ManExpr_OnBeforeEdIns();
  CheckEdDelAllowed();
 END {ManExpr_OnBeforeEdit};

 PRIVATE PROCEDURE ManExpr_OnBeforeInsert();
 BEGIN
  ManExpr_OnBeforeEdIns();
 END {ManExpr_OnBeforeInsert};

 PRIVATE PROCEDURE ManExpr_OnAfterEdIns();
 BEGIN
  CheckEdInsAllowed();
  _ShtDone();
 END {ManExpr_OnAfterEdIns};

 PRIVATE PROCEDURE ManExpr_OnAfterEdit();
 BEGIN
  ManExpr_OnAfterEdIns();
 END {ManExpr_OnAfterEdit};

 PRIVATE PROCEDURE ManExpr_OnAfterInsert();
 BEGIN
  ManExpr_OnAfterEdIns();
 END {ManExpr_OnAfterInsert};

 PRIVATE PROCEDURE ManExpr_OnBeforeDelete();
 BEGIN
  CheckEdDelAllowed();
  _ShtDone();
 END {ManExpr_OnBeforeDelete};

 PRIVATE PROCEDURE ManExpr_DocGiveS_OnSuccessfulChange();
 BEGIN
  L_Pool.Put(L_Man.pool_ManExprDocGiveS, ManExpr.DocGiveS);
 END {ManExpr_DocGiveS_OnSuccessfulChange};

 PRIVATE PROCEDURE ManExpr_Expr_OnSuccessfulChange();
 BEGIN
  CONFORM(ManExpr, Expr);
  ManExpr.ExprType:=Expr.ExprType;
  CheckEdInsAllowed();
  REPLACE(ManExpr);
 END {ManExpr_Expr_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_OnAfterInsert();
 BEGIN
  ManExpr_OnAfterInsert();
 END {EDOrderL_OnAfterInsert};

 PRIVATE PROCEDURE EDOrderL_OnBeforeDelete();
 BEGIN
  ManExpr_OnBeforeDelete();
 END {EDOrderL_OnBeforeDelete};

 PRIVATE PROCEDURE ManExpr_OnSetSubwindow();
 BEGIN
  RTI.Get().CurZone.HasVariousSubwindows:=1;
  L_EDO.gbo_SetSubwindow("ManExprE");
 END {ManExpr_OnSetSubwindow};

BEGIN
 IF  L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSIF L_Events.IsSubWinEvents(MODE) THEN
  ManExpr_OnSetSubwindow();
 ELSE
  L_General.BadMode(MODE);
 END;
END.
