(*
%Copyright   (c) Polak IT
%Author      LDA
%Purpose     ஫ ࠡ  ᢥﬨ  
%Type        control
%Specific    SYS
%Modified    12.03.2013 12:25:02 POLAK\LDA
%Environment
*)

 MODULE ManMlt [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Man, L_Events, L_DatTim, L_Str, L_StdFrm, L_Env, DBD,
        L_ManMlt;

 PRIVATE PROCEDURE NeedSetProfil(_MltRank: LIKE(MltRank.MltRank)): SCAL[2];
 BEGIN
  RETURN ~!_MltRank &
         SEARCH(MltRank, MltRank, _MltRank) &
         (MltRank.Composit # 0) &
         (MltRank.Composit # 7) &
         (MltRank.Composit >= 4);
 END {NeedSetProfil};

 PRIVATE PROCEDURE PrepareProfilPool(): STRING[];
 BEGIN
  IF ACCESS(ManMlt) & NeedSetProfil(ManMlt.MltRank) THEN
   RETURN L_ManMlt.mmp_PoolPart1;
  ELSE
   RETURN L_ManMlt.mmp_FullPool;
  END;
 END {PrepareProfilPool};

 PRIVATE PROCEDURE SetPool(FieldName, Pool: STRING[]);
 BEGIN
  RTI.Get().CurZone.Fields(FieldName).Format:=Pool;
 END {SetPool};

 PRIVATE PROCEDURE SetManMltProfilPool();
 BEGIN
  SetPool("ManMlt.Profil", PrepareProfilPool());
  RTI.Get().CurZone.Fields("ManMlt.Profil").Modifiable:=ACCESS(ManMlt) & NeedSetProfil(ManMlt.MltRank);
 END {SetManMltProfilPool};

 PRIVATE PROCEDURE SetManMltDocTypePool(Pool: STRING[]);
 BEGIN
  SetPool("ManMlt.DocType", Pool);
 END {SetManMltDocTypePool};

 PRIVATE PROCEDURE SetManMltReadyPool();
 BEGIN
  SetPool("ManMlt.Ready", L_ManMlt.mm_ReadyPool);
 END {SetManMltReadyPool};

 PRIVATE PROCEDURE SetManMltEventPool();
 BEGIN
  SetPool("ManMlt.Event", L_ManMlt.mm_EventPool);
 END {SetManMltEventPool};

 PRIVATE PROCEDURE SetManMltGrpPool();
 BEGIN
  SetPool("ManMlt.Grp", L_ManMlt.mgrp_Pool);
 END {SetManMltGrpPool};

 PRIVATE PROCEDURE SetManMltSortPool();
 BEGIN
  SetPool("ManMlt.Sort", L_ManMlt.mms_Pool);
 END {SetManMltSortPool};

 PRIVATE PROCEDURE _Assert(Cond: SCAL[2];
                           Msg : STRING[]);
 BEGIN
  L_General.Assert(Cond, Msg);
 END {_Assert};

 PRIVATE PROCEDURE __Assert(_Event: LIKE(ManMlt.Event));
  CONST
   Message = "㦥 祭 ਮ  ᮡ⨥ ";
 BEGIN
  SAVE(ManMlt);
  _Assert(~L_ManMlt.SearchManMltEvent_wCurEvent(ManMlt.Man, _Event, 1),
          Message + "'" + L_ManMlt.GetManMltEvent_AsStr(_Event) + "'");
  RESTORE(ManMlt);
 END {__Assert};

 PRIVATE PROCEDURE CheckEventsIntersection();
 BEGIN
  SAVE(ManMlt);
  IF     ManMlt.Event = L_ManMlt.mme_Registration THEN
   __Assert(L_ManMlt.mme_Registration);
  ELSIF (ManMlt.Event = L_ManMlt.mme_MilitaryServ)      |
        (ManMlt.Event = L_ManMlt.mme_ContractServ)      |
        (ManMlt.Event = L_ManMlt.mme_AlternativeServ)   |
        (ManMlt.Event = L_ManMlt.mme_MilitaryGathering) |
        (ManMlt.Event = L_ManMlt.mme_Reserv)            |
        (ManMlt.Event = L_ManMlt.mme_OrderX) THEN
   __Assert(L_ManMlt.mme_MilitaryServ);
   __Assert(L_ManMlt.mme_ContractServ);
   __Assert(L_ManMlt.mme_AlternativeServ);
   __Assert(L_ManMlt.mme_MilitaryGathering);
   __Assert(L_ManMlt.mme_Reserv);
   __Assert(L_ManMlt.mme_OrderX);
  END;
  RESTORE(ManMlt);
 END {CheckEventsIntersection};

 PRIVATE PROCEDURE SupportEndDate(_Man  : LIKE(Man.Man);
                                  _Event: LIKE(ManMlt.Event));
  VAR
   _UpTo: DATE;
 BEGIN
  SETEMPTY(_UpTo);
  SAVE(ManMlt);
  SELECT(ManMlt, Event, , _Man, _Event);
  LAST(ManMlt);
  WHILE OCCURE(ManMlt) DO
   ManMlt.UpTo:=_UpTo;
   REPLACE(ManMlt);
   _UpTo:=ManMlt.From - 1;
   PREV(ManMlt);
  END; (* WHILE OCCURE(ManMlt)...*)
  RESTORE(ManMlt);
 END {SupportEndDate};

 PRIVATE PROCEDURE CheckFillDocAttr();
 BEGIN
  IF !ManMlt.DocSer   | !ManMlt.DocNbr |
     !ManMlt.DocGiveS | !ManMlt.DocGiveD THEN
   STDMSG(" 㬥   ", CHOICE);
  END;
 END {CheckFillDocAttr};

 PRIVATE PROCEDURE ManMlt_OnAfterEditInsert();
  VAR
   Str: STRING[];
 BEGIN
  _Assert(ManMlt.From < ManMlt.UpTo, "४ ਮ ய");
  CheckEventsIntersection();
  IF (ManMlt.DocType = L_ManMlt.mdt_00) |
     (ManMlt.DocType = L_ManMlt.mdt_01) |
     (ManMlt.DocType = L_ManMlt.mdt_03) |
     (ManMlt.DocType = L_ManMlt.mdt_Reserv) THEN
   CheckFillDocAttr();
   Str:=L_Man.CheckPsp(" 㬥", ManMlt.DocSer, "");
   _Assert(!Str, Str);
   Str:=L_Man.CheckPsp(" 㬥", ManMlt.DocNbr, "0999999");
   _Assert(!Str, Str);
  ELSIF ManMlt.DocType = L_ManMlt.mdt_02 THEN
   _Assert(!ManMlt.DocSer, " 㬥    ");
   Str:=L_Man.CheckPsp(" 㬥", ManMlt.DocNbr, "0000009");
   _Assert(!Str, Str);
  ELSIF ManMlt.DocType = L_ManMlt.mdt_Certificate THEN
   CheckFillDocAttr();
  END;
  IF ManMlt.Event = L_ManMlt.mme_ChangeAccount THEN
   SupportEndDate(ManMlt.Man, ManMlt.Event);
  END;
  IF ~!ManMlt.MltRank THEN
   CONFORM(ManMlt, MltRank);
   IF ((ManMlt.Grp = 02) & (MltRank.RankType # L_ManMlt.rt_Naval)) |
      ((ManMlt.Grp # 02) & (MltRank.RankType = L_ManMlt.rt_Naval)) THEN
    L_General.Error(" ࠭  (" +
                    L_Str.PoolItem("᪮|ࠡ", MltRank.RankType) +
                    ")| ᮮ⢥ 㯯 ");
   END;
    IF (MltRank.Composit # L_ManMlt.mrc_JuniorOfficer) &
       (MltRank.Composit # L_ManMlt.mrc_FirstOfficer)  &
       (MltRank.Composit # L_ManMlt.mrc_HigherOfficer) THEN
     L_General.Assert(~!ManMlt.Grp, " 㯯 ᪮ ");
     L_General.Assert(~!ManMlt.Sort, " ⥣ ᪮ ");
    END;
  END;
  IF (ManMlt.Event = L_ManMlt.mme_MilitaryServ) |
     (ManMlt.Event = L_ManMlt.mme_ContractServ) |
     (ManMlt.Event = L_ManMlt.mme_AlternativeServ) |
     (ManMlt.Event = L_ManMlt.mme_MilitaryGathering) THEN
   L_General.Assert(~!ManMlt.UpTo, "室 㪠  ''");
  END;
 END {ManMlt_OnAfterEditInsert};

 PRIVATE PROCEDURE ManMlt_OnAfterEdit();
 BEGIN
  ManMlt_OnAfterEditInsert();
 END {ManMlt_OnAfterEdit};

 PRIVATE PROCEDURE ManMlt_OnAfterInsert();
 BEGIN
  ManMlt_OnAfterEditInsert();
 END {ManMlt_OnAfterInsert};

 PRIVATE PROCEDURE ManMlt_1_OnZoneOpen();
 BEGIN
  ACCESS(Man);
  _Assert(L_Env.RealMan(Man.Man),
          " 䨪⨢     ᢥ  ᪮ ");
  SetManMltDocTypePool(L_ManMlt.mdt_FullPool);
  SetManMltEventPool();
 END {ManMlt_1_OnZoneOpen};

 PRIVATE PROCEDURE _PutSpec();
  VAR
   _Spec : LIKE(ManMlt.Spec);
   _SpecC: LIKE(ManMlt.SpecC);
 BEGIN
  IF ~!L_ManMlt.mmas_Spec | ~!L_ManMlt.mmas_SpecC THEN
   _Spec :=L_ManMlt.mmas_Spec;
   _SpecC:=L_ManMlt.mmas_SpecC;
  ELSE
   _Spec :="-";
   _SpecC:="-";
  END;
  ManMlt.Spec :=_Spec;
  ManMlt.SpecC:=_SpecC;
  REPLACE(ManMlt);
 END {_PutSpec};

 PRIVATE PROCEDURE _PutReady();
 BEGIN
  ManMlt.Ready:=L_ManMlt.mmas_Ready;
  REPLACE(ManMlt);
 END {_PutReady};

 PRIVATE PROCEDURE _PutMltDep();
 BEGIN
  ManMlt.MltDep:=L_ManMlt.mmas_MltDep;
  REPLACE(ManMlt);
 END {_PutMltDep};

 PRIVATE PROCEDURE _PutDocAttr();
 BEGIN
  ManMlt.DocType :=L_ManMlt.mmas_DocType;
  ManMlt.DocSer  :=L_ManMlt.mmas_DocSer;
  ManMlt.DocNbr  :=L_ManMlt.mmas_DocNbr;
  ManMlt.DocGiveS:=L_ManMlt.mmas_DocGiveS;
  ManMlt.DocGiveD:=L_ManMlt.mmas_DocGiveD;
  REPLACE(ManMlt);
 END {_PutDocAttr};

 PRIVATE PROCEDURE _PutMltAttr();
 BEGIN
  ManMlt.Grp     :=L_ManMlt.mmas_Grp;
  ManMlt.Sort    :=L_ManMlt.mmas_Sort;
  ManMlt.MltRank :=L_ManMlt.mmas_MltRank;
  ManMlt.Profil  :=L_ManMlt.mmas_Profil;
  REPLACE(ManMlt);
 END {_PutMltAttr};

 PRIVATE PROCEDURE PrepareEventInsert();
 BEGIN
  IF    ManMlt.Event = L_ManMlt.mme_OrderX THEN
   _PutSpec();
  ELSIF ManMlt.Event = L_ManMlt.mme_Registration THEN
   _PutReady();
   _PutSpec();
   _PutDocAttr();
   _PutMltAttr();
  END;
 END {PrepareEventInsert};

 PRIVATE PROCEDURE ManMlt_OnBeforeInsert();
 BEGIN
  L_ManMlt.GetManMltActualStatus(ManMlt.Man, SYSDATE());
  IF    L_ManMlt.v_mm_Event = L_ManMlt.mme_Reserv THEN
   ManMlt.DocType:=L_ManMlt.mdt_Reserv;
  ELSIF L_ManMlt.v_mm_Event = L_ManMlt.mme_OrderX THEN
   ManMlt.DocType:=L_ManMlt.mdt_OrderX;
  END;
  ManMlt.Event:=L_ManMlt.v_mm_Event;
  REPLACE(ManMlt);
  PrepareEventInsert();
 END {ManMlt_OnBeforeInsert};

 PRIVATE PROCEDURE ManMlt_UpTo_OnSuccessfulChange();
 BEGIN
  CheckEventsIntersection();
 END {ManMlt_UpTo_OnSuccessfulChange};

 PRIVATE PROCEDURE ManMlt_MltRank_OnSuccessfulChange();
 BEGIN
  SetManMltProfilPool();
  SEARCH(MltRank, MltRank, , ManMlt.MltRank);
  IF    ~OCCURE(MltRank) THEN
   SETEMPTY(ManMlt.Profil);
  ELSIF (MltRank.Composit = 0) | (MltRank.Composit = 7) THEN
   ManMlt.Profil:=L_ManMlt.mmp_Conscripts;
  ELSIF MltRank.Composit < 4 THEN
   ManMlt.Profil:=L_ManMlt.mmp_Soldiers;
  END;
  REPLACE(ManMlt);
 END {ManMlt_MltRank_OnSuccessfulChange};

 PRIVATE PROCEDURE ManMlt0E_0_OnZoneOpen();
 BEGIN
  SetManMltDocTypePool(L_ManMlt.mdt_PoolPart1);
  SetManMltReadyPool();
  SetManMltProfilPool();
  SetManMltGrpPool();
  SetManMltSortPool();
 END {ManMlt0E_0_OnZoneOpen};

 PRIVATE PROCEDURE ManMlt1E_0_OnZoneOpen();
 BEGIN
  SetManMltReadyPool();
 END {ManMlt0E_1_OnZoneOpen};

 PRIVATE PROCEDURE ManMlt2E_0_OnZoneOpen();
 BEGIN
  SetManMltDocTypePool(L_ManMlt.mdt_PoolPart1);
 END {ManMlt2E_0_OnZoneOpen};

 PRIVATE PROCEDURE ManMlt3E_0_OnZoneOpen();
 BEGIN
  SetManMltEventPool();
 END {ManMlt3E_0_OnZoneOpen};

 PRIVATE PROCEDURE ManMlt5E_0_OnZoneOpen();
 BEGIN
  SetManMltProfilPool();
  SetManMltGrpPool();
  SetManMltSortPool();
 END {ManMlt5E_0_OnZoneOpen};

 PRIVATE PROCEDURE ManMlt6E_0_OnZoneOpen();
 BEGIN
  SetManMltEventPool();
 END {ManMlt6E_0_OnZoneOpen};

 PRIVATE PROCEDURE ManMlt_1_OnSetSubwindow();
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert THEN
   L_ManMlt.v_mm_Event:=L_StdFrm.ShowListAsMenu(L_ManMlt.mm_EventPool, "᪮ ய⨥");
  ELSE
   L_General.Assert(ACCESS(ManMlt), "   ।");
   L_ManMlt.v_mm_Event:=ManMlt.Event;
  END;
  RTI.Get().CurZone.HasVariousSubwindows :=1;
  RTI.Get().CurZone.SubwindowOriginalName:=L_Str.PoolItem(L_ManMlt.mm_WindowNamePool, L_ManMlt.v_mm_Event);
 END {ManMlt_1_OnSetSubwindow};

BEGIN
 L_Events.ExecuteHandler();
END.
