(*
%Copyright   (c) Polak Computer System
%Author      16.11.1999 12:03:22 GINA
%Purpose     ⠦  稥   D
%Type        report
%Specific    SYS
%Modified    08.09.2014 18:03:24 POLAK\Gina
%Environment
*)

 MODULE ManNow [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_BegRWS, L_Str, P_Man, Str, L_General, L_DatTim, L_OwnData,
        L_Man, P_Staff, Memo, Math, L_Env, L_Way, L_Car, L_AvePay,
        L_two, L_ctc, L_Russia, L_bp, L_Staff;

 PRIVATE VAR
  D             : DATE;
  Stage_asStr   : STRING[][L_Man.ins_Size];
  CntStageDate  : DATE      [L_Man.ins_Size];
  Cnt           : NUMERIC[0];
  DayStr,
  SignStr       : STRING[];
  ByMtwo        : SCAL[2];

(*
$P{ MnNow:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
D, L, "D.N.y"
L_Man.Man_ManAsStr()+" "+Man.Name, L, ""
Man.INN, L, ""
L_Man.GetManSINumber_asStr(), L, ""
Stage_asStr[L_Man.ins_Continuous]+ ",  "+L_DatTim.DateStr(CntStageDate [L_Man.ins_Continuous]), L, ""
Stage_asStr[L_Man.ins_Common], L, ""
Stage_asStr[L_Man.ins_Post], L, ""
Stage_asStr[L_Man.ins_SocInsurance], L, ""
Stage_asStr[L_Man.ins_SocInsuranceNoIns], L, ""
Man.Birth, L, "D.N.y"
L_Man.Man_Citizen(Man.Man, D), L, "᪢,|||㣨 ࠭"
@
############################################################# ########## #####
=#####========================================================================
|                             ##########                           |
|----------------------------------------------------------------------------|
|᪮                                                              |
| ###########################################################################|
|----------------------------------------------------------------------------|
|: ############   : ##############                                   |
|----------------------------------------------------------------------------|
|⠦:                                                                       |
| 뢭         : #############################################        |
| 騩               : ##############################                       |
|  ᯥ樠쭮    : ##############################                       |
|  . 客: ##############################                       |
|   . . 客 ਮ: ##############################               |
|----------------------------------------------------------------------------|
| ஦: ##########   ஦: ############################         |
}
*)

(*
$P{ Delimiter:
@
|----------------------------------------------------------------------------|
}
*)

(*
$P{ MnPhone:
L_ctc.GetCtcValCoverage_asStr(), L, ""
L_ctc.GetCtcValType_asStr(), L, ""
CtcVal.Value, L, ""
@
|######## ############### ################################################   |
}
*)

(*
$P{ AddrLine:
?, L, ""
?, L, ""
?, L, ""
@
| ######################################################################|
| ###########################################################################|
| ###########################################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE GetSort(): STRING[];
  VAR
   Str,
   trgSort: STRING[];
 BEGIN
  trgSort:=P_Staff.GetP_SortForMkBegRWS(Staff.TSN, D);
  IF ~!trgSort THEN
   SAVE(Sort);
   L_General.Assert(SEARCH(Sort, Sort, trgSort), "९ ᥪ  ࠧ浪   ࠢ筨");
   Str:=Sort.Sort + " " + Sort.Name;
   RESTORE(Sort);
   RETURN Str;
  ELSE
   RETURN " 㪠";
  END;
 END {GetSort};

 PRIVATE PROCEDURE GetRegime(): STRING[];
  VAR
   trgRegime : LIKE(RegMain.Regime);
   dummyShift: NUMERIC[0];
 BEGIN
  P_Staff.GetP_RegimeForMkBegRWS(Staff.TSN, D, trgRegime, dummyShift);
  IF ~!trgRegime THEN
   L_General.Assert(SEARCH(RegMain, HumReg, trgRegime), "९ ० ࠡ   ࠢ筨");
   RETURN RegMain.Regime + " " + RegMain.Name;
  ELSE
   RETURN " 㪠";
  END;
 END {GetRegime};

 PRIVATE PROCEDURE GetWho(): L_two.tTWOWho;
 BEGIN
  IF ByMtwo THEN
   RETURN Mtwo.Who;
  ELSE
   IF L_Env.IsGuard() THEN
    RETURN L_two.who_Guard;
   ELSE
    RETURN L_two.who_Driver;
   END;
  END;
 END {GetWho};

 PRIVATE PROCEDURE GetWhoAsStr(): STRING[];
  VAR
   trgWho: L_two.tTWOWho;
 BEGIN
  SETEMPTY(trgWho);
  IF ByMtwo THEN
   trgWho:=Mtwo.Who;
  ELSE
   IF    L_Env.IsGuard() THEN
    trgWho:=L_two.who_Guard;
   ELSIF L_Env.IsDriver() THEN
    trgWho:=L_two.who_Driver;
   ELSE
    SETEMPTY(trgWho);
   END;
  END;
  IF ~!trgWho THEN
   RETURN L_Str.PoolItem("⥫|", trgWho);
  ELSE
   RETURN "ࠡ⭨";
  END;
 END {GetWhoAsStr};

 PRIVATE PROCEDURE GetGuard(): STRING[];
  VAR
   trgTSN: STRING[];  (* LIKE (Staff.TSN), P_Staff.GetP_FixedGuard()   ⠡;⠡*)
   Str   : STRING[];
   i     : NUMERIC[0];
 BEGIN
  IF GetWho()=L_two.who_Guard THEN
   trgTSN:=L_two.GetDrvTSN(Staff.TSN, L_two.who_Guard, D);
  ELSE
   trgTSN:=P_Staff.GetP_FixedGuard(Staff.TSN, D);
  END;
  Str:=" 㪠";
  IF ~!trgTSN THEN
   SAVE(Staff);
   SAVE(Man);
   i:=0; SETEMPTY(Str);
   WHILE ~!L_Str.AnyItem(trgTSN, ";", i) DO
    L_General.Assert(SEARCH(Staff, TSN, L_Str.AnyItem(trgTSN, ";", i)), "  ⠡ ९ ");
    CONFORM(Staff, Man);
    Str:=L_Str.AddStrDlm(Str, ";") + Staff.TSN + " " + Man.Name;
    INC(i);
   END;
   RESTORE(Man);
   RESTORE(Staff);
  END;
  RETURN Str;
 END {GetGuard};

 PRIVATE PROCEDURE GetMCFix(Proc: PROC): STRING[];
 BEGIN
  IF Proc(Staff.TSN, D) THEN
   L_Car.StandOnCarLog(MCFix.BoxNbr, D);
   CONFORM(CarLog, Mark);
   RETURN CarLog.BoxNbr+" "+Str.Align(Mark.Name, 24, LEFT)+"  .  "+Str.Align(CarLog.StateNbr, Str.MaxLength(CarLog.StateNbr), LEFT)+"   "+CarLog.Column;
  ELSIF Proc = PROCREF(L_Car.StandOnFirstMCFix) THEN
   RETURN " 㪠";
  ELSE
   RETURN "";
  END;
 END {GetMCFix};

 PRIVATE PROCEDURE GetExit(): STRING[];
  VAR
   trgExitClss: LIKE(ExitClss.ExitClss);
   ecfm       : L_BegRWS.tECFixMethod;
   Result     : STRING[];
 BEGIN
  IF L_BegRWS.IsWorkDayType(L_BegRWS.GetDayType(Staff.TSN, D)) THEN
   L_BegRWS.GetFixedEC(Staff.TSN, D, trgExitClss, ecfm);
   IF    ecfm = L_BegRWS.ecfm_Single THEN
    Result:=" : '९ 室'";
   ELSIF ecfm = L_BegRWS.ecfm_Decade THEN
    Result:=" : '横᪮ ९'";
   ELSE
    Result:=" 㪠";
   END;
   IF ~!trgExitClss THEN
    Result:=trgExitClss + Result;
   END;
  ELSE
   Result:="ࠡ稩 ";
  END;
  RETURN Result;
 END {GetExit};

 PRIVATE PROCEDURE PrintDriverInformation();
  CONST
   LineLength = 74;
  VAR
   PermitToMark,
   PermitToRoute : STRING[LineLength][32];
   Tmp,
   DrSertificStr,
   MedSertificStr: STRING[];
   AllRoute      : SCAL[2];
   i             : NUMERIC[0];
 BEGIN
  IF GetWho() # L_two.who_Guard THEN
   DrSertificStr:="";
   IF P_Man.HasActualManPro(Man.Man, D, P_Man.P_DriveSertification) THEN
    DrSertificStr:=ManPro.DocNum + " 뤠 " + L_DatTim.DateStr(ManPro.DocGiveD);
   END;
   IF P_Man.HasActualManPro(Man.Man, D, P_Man.P_MedicalSertification) THEN
    MedSertificStr:=ManPro.Value+" ( "+L_DatTim.DateStr(ManPro.DocGiveD)+"  "+L_DatTim.DateStr(ManPro.DocExpD) + ")";
   ELSE
    MedSertificStr:="";
   END;
   MAKEPART(R, DrGuS_Drv, DrSertificStr, P_Man.GetDriveSertification_Category(Man.Man, D), MedSertificStr);
 
   MAKEPART(R, DrGuS_Drv_Add_Auth_Top, "  ન");
   Tmp:=L_BegRWS.GetPermitToMarkGList(D, Staff.TSN);
   IF !Tmp THEN
    Tmp:=" 㪠";
   END;
   L_Str.SplitStr(PermitToMark, Tmp, LineLength, HIGH(PermitToMark)+1);
   i:=0;
   WHILE ~!PermitToMark[i] DO
    MAKEPART(R, DrGuS_Drv_Add_Auth_Line, PermitToMark[i]);
    INC(i);
   END;
 
   MAKEPART(R, DrGuS_Drv_Add_Auth_Top, "  ");
   Tmp:=L_BegRWS.GetPermitToRouteList(D, Staff.TSN, AllRoute);
   IF    !Tmp THEN
    Tmp:=" 㪠";
   ELSIF AllRoute THEN
    Tmp:=" ࠭祭";
   END;
   L_Str.SplitStr(PermitToRoute, Tmp, LineLength, HIGH(PermitToRoute)+1);
   i:=0;
   WHILE ~!PermitToRoute[i] DO
    MAKEPART(R, DrGuS_Drv_Add_Auth_Line, PermitToRoute[i]);
    INC(i);
   END;
  END;
 END {PrintDriverInformation};

 PRIVATE PROCEDURE MakeRepAvePay();
  VAR
   From,
   UpTo: DATE;
   Cnt : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" ");
  From:=L_DatTim.MonthBeg(Memo.ud_cd());
  UpTo:=L_DatTim.MonthEnd(Memo.ud_cd());
  Cnt :=0;
  SELECT(AvePay, TSN, , Staff.TSN);
  SRCINSEL(AvePay, LE, , UpTo);
  WHILE OCCURE(AvePay) DO
   IF L_AvePay.IsRealAvePay() &
      L_DatTim.IsActiveInIntvl_Inc(From, UpTo, AvePay.StartD, AvePay.StopD) THEN
    SELECT(AvePayP, AvePay, , AvePay.AvePay);
    WHILE OCCURE(AvePayP) DO
     CONFORM(AvePayP, AveTypeP);
     PROMPT(AveTypeP.Name);
     IF ~!AveTypeP.JMode THEN
      IF Cnt=0 THEN
       MAKEPART(R, DrGuS_AveTop, "");
       MAKEPART(R, DrGuS_AveTop1);
      END;
      MAKEPART(R, DrGuS_AveLine);
      INC(Cnt);
     END;
     NEXT(AvePayP);
    END; (* WHILE OCCURE(AvePayP) ... *)
   END;
   PREV(AvePay);
  END; (* WHILE OCCURE(AvePay) ... *)
  IF Cnt=0 THEN
   MAKEPART(R, DrGuS_AveTop, "");
  END;
 END {MakeRepAvePay};

 PRIVATE PROCEDURE InsertDelim(S: STRING[]): STRING[];
 BEGIN
  S:=Str.Insert(S, " |",  Str.ItemPos(S, "|", 10));
  S:=Str.Insert(S, " |",  Str.ItemPos(S, "|", 21));
  RETURN S;
 END {InsertDelim};

 PRIVATE PROCEDURE PrintRegime();
  VAR
   D: DATE;
 BEGIN
  APP.Get().NewPrompt(" 䨪");
  SETEMPTY(DayStr, SignStr);
  D:=L_DatTim.MonthBeg(Memo.ud_cd());
  WHILE D <= L_DatTim.MonthEnd(Memo.ud_cd()) DO
   PROMPT(L_DatTim.DateStr(D));
   DayStr :=DayStr + L_Str.IntStr(L_DatTim.DAY(D) MOD 10)+"|";
   SignStr:=SignStr+ L_Str.PoolItem(L_BegRWS.wh_Pool, L_BegRWS.GetDayType(Staff.TSN, D))+"|";
   INC(D);
  END;
  DayStr :=InsertDelim(DayStr);
  SignStr:=InsertDelim(SignStr);
 END {PrintRegime};

(*
$P{ DrGuS_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(),     L, "D.N.y"
SYSTIME(),     L, "H:M"
?,             L, ""
GetWhoAsStr(), C, ""
D,             L, "D.N.y"
Staff.TSN,     L, ""
Man.Name,      L, ""
@
############################################################# ########## #####
=#####========================================================================
|                      ##########  ##########                     |
|----------------------------------------------------------------------------|
|⭨                                                                    |
|##### ################################################                      |
}
*)

(*
$P{ DrGuS_Drv:
StaffLog.Class, L, ""
?,              L, ""
?,              L, ""
?,              L, ""
@
|----------------------------------------------------------------------------|
| ⥫᪮ 㤮⮢७        ⥣ਨ                   |
|  #   ################################ #####################################|
|樭᪮ ᢨ⥫⢮                                             |
|  ##########################################################################|
|----------------------------------------------------------------------------|
}
*)

(*
$P{ DrGuS_Drv_Add_Auth_Top:
?, L, ""
@
|############################################################################|
}
*)

(*
$P{ DrGuS_Drv_Add_Auth_Line:
?, L, ""
@
|  ##########################################################################|
}
*)

(*
$P{ DrGuS_OfcTop:
@
|============================================================================|
|祥                                                                |
|----------------------------------------------------------------------------|
|      ||⤥           |                |            |
|----------|---|----------------|----------------------|---------------------|
}
*)

(*
$P{ DrGuS_Ofc:
StaffLog.Date, L, "D.N.y"
SLKind.Sign,   L, ""
L_Staff.getDepartName(),   L, ""
Sort.Sort,     L, ""
Sort.Name,     L, ""
Post.Post,     L, ""
Post.Name,     L, ""
@
|##########|###|################|### ##################|### #################|
}
*)

(*
$P{ DrGuS_OfcDlm:
@
|----------|---|----------------|----------------------|---------------------|
}
*)


(*
$P{ DrGuS_BgAll:
GetSort(),                                                           L, ""
GetRegime(),                                                         L, ""
L_Str.PoolItem(L_BegRWS.wh_Pool, L_BegRWS.GetDayType(Staff.TSN, D)), L, ""
GetExit(),                                                           L, ""
GetWho(),                                                            L, "|⥫"
GetGuard(),                                                          L, ""
GetMCFix(PROCREF(L_Car.StandOnFirstMCFix)),                          L, ""
GetMCFix(PROCREF(L_Car.StandOnSecondaryMCFix)),                      L, ""
@
|============================================================================|
|⢠  ࠧ浪                                                     |
|      ################################################################|
|  䨪    #####################################################  # |
|  室     ################################################################|
|  ######### ################################################################|
|          ################################################################|
|            ################################################################|
}
*)

(*
$P { DrGuS_AveTop:
L_DatTim.Per(Memo.ud_cd()), L, "N.y"
?,                          L, ""
@
|============================================================================|
|㬥  ⢨/ -।  ####### ####################|
}
*)

(*
$P { DrGuS_AveTop1:
@
|----------------------------------------------------------------------------|
|ﭨ |砫    |砭 ||                                    |
|----------|----------|----------|---|---------------------------------------|
}
*)

(*
$P { DrGuS_AveLine:
AvePay.Status,    L, "⮢.|஢|⬥"
AvePayP.StartD,   L, "D.N.y"
AvePayP.StopD,    L, "D.N.y"
AvePayP.Amount,   L, ""
AvePayP.AveTypeP, L, ""
AveTypeP.Name,    L, ""
@
|##########|##########|##########|###|## ####################################|
}
*)

(*
$P{ DrGuS_Bot:
L_DatTim.Per(Memo.ud_cd()), L, "N.y"
DayStr,                     L, ""
SignStr,                    L, ""
@
|============================================================================|
|䨪  #######                                                           |
|----------------------------------------------------------------------------|
||#################################################################|     |
|----|-|-|-|-|-|-|-|-|-|-| |-|-|-|-|-|-|-|-|-|-| |-|-|-|-|-|-|-|-|-|-|-|     |
|    |#################################################################|     |
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE FillStages();
  VAR
   i             : NUMERIC[0];
   BegDate       : DATE;
   DaysOfStage,
   MonthsOfStage,
   YearsOfStage  : NUMERIC[0][L_Man.ins_Size];
 BEGIN
  L_Man.FillStages(D, DaysOfStage, MonthsOfStage, YearsOfStage, CntStageDate, BegDate);
  i:=0;
  WHILE i < L_Man.ins_Size DO
   IF (i # L_Man.ins_SocInsuranceNoIns) & (D > BegDate) THEN
    INC(DaysOfStage[i], D-BegDate);
    L_DatTim.NormalizeDMY(DaysOfStage[i], MonthsOfStage[i], YearsOfStage[i]);
   END;
   Stage_asStr[i]:=L_Str.DMY_asStr(DaysOfStage[i], MonthsOfStage[i], YearsOfStage[i]);
   INC(i);
  END;
 END {FillStages};

 PRIVATE PROCEDURE TypeAddress(trgAdrType: LIKE(ManAdr.AdrType));
  CONST
   SAdrLen = 75;
  VAR
   AddressStr: STRING[SAdrLen][2];
 BEGIN
  Str.Format(AddressStr, L_Man.GetAdr_asStr(Man.Man, D, trgAdrType), SAdrLen, LEFT);
  MAKEPART(R, AddrLine, L_Man.GetManAdrType_asStr(trgAdrType),
                        AddressStr[0], AddressStr[1]);
 END {TypeAddress};

 PRIVATE PROCEDURE TypeAddresses();
 BEGIN
  MAKEPART(R, Delimiter);
  TypeAddress(L_Russia.at_RgMA);
  IF L_Man.AccessManAdr(Man.Man, D, L_Russia.at_DwMA) THEN
   TypeAddress(L_Russia.at_DwMA);
  END;
 END {TypeAddresses};

 PRIVATE PROCEDURE TypePhones();
  VAR
   Count: NUMERIC[0];
 BEGIN
  Count:=0;
  SELECT(CtcVal, Type, , Man.Contact);
  WHILE OCCURE(CtcVal) DO
   IF L_ctc.CtcValIsPhone() & L_DatTim.IsActive(Memo.ud_cd(), CtcVal.Begin, CtcVal.Till) THEN
    IF Count = 0 THEN
     MAKEPART(R, Delimiter);
    END;
    MAKEPART(R, MnPhone);
    INC(Count);
   END;
   NEXT(CtcVal);
  END; (* WHILE OCCURE(CtcVal) ... *)
 END {TypePhones};

 PUBLIC PROCEDURE MnNow();
  CONST
   bpId = "MnNow";
 BEGIN
  ByMtwo :=0;
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
  D:=Math.Max(Staff.BegDate, Math.Min(Memo.ud_cd(), Staff.EndDate));
  CONFORM(Staff, Man);
  L_bp.Pass(bpId, "稥 ᢥ  ࠡ⭨");
  OPENREP(R, L_General.NameConnection(bpId), Create);
  FillStages();
  MAKEPART(R, MnNow, bpId);
  TypePhones();
  TypeAddresses();
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MnNow};

 PRIVATE PROCEDURE DoDrGu(EUMode: SCAL[2]);
  CONST
   bpId = "DrGuS";
  VAR
   IsDriverOrGuard: SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ByMtwo:=0;
  IF ~EUMode THEN
   ACCESS((RTI.Get().CurZone.MasterTable.Name));
   IF RTI.Get().CurZone.MasterTable.Name = "Mtwo" THEN
    ByMtwo:=1;
    CONFORM(Mtwo, Staff);
   END;
   L_bp.Pass(bpId, "  ⥫/");
  END;
  OPENREP(R, L_General.NameConnection(bpId), Create);
  D:=Math.Max(Staff.BegDate, Math.Min(Memo.ud_cd(), Staff.EndDate));
  CONFORM(Staff, Man);
  HISTCONF(D, Staff, StaffLog, Officer, Sort, Post);
  IsDriverOrGuard:=L_Env.IsDriver() | L_Env.IsGuard();
  IF ~EUMode THEN
   L_General.Assert(IsDriverOrGuard, "⭨    ⥫,  ஬");
  END;
  PrintRegime();
  MAKEPART(R, DrGuS_Top, bpId);
  TypePhones();
  TypeAddresses();
  PrintDriverInformation();
  MAKEPART(R, DrGuS_OfcTop);
  Cnt:=0;
  WHILE OCCURE(StaffLog) DO
   CONFORM(StaffLog, SLKind);
   IF (Cnt = 0) | SLKind.PutInT2 THEN
    IF Cnt = 1 THEN
     MAKEPART(R, DrGuS_OfcDlm);
    END;
    CONFORM(StaffLog, Officer, Sort, Post);
    MAKEPART(R, DrGuS_Ofc);
    INC(Cnt);
   END;
   PREV(StaffLog);
  END; (* WHILE OCCURE(StaffLog) ... *)
  IF IsDriverOrGuard THEN
   MAKEPART(R, DrGuS_BgAll);
  END;
  MakeRepAvePay();
  MAKEPART(R, DrGuS_Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {DoDrGu};

 PUBLIC PROCEDURE DrGuS();
 BEGIN
  DoDrGu(0)
 END {DrGuS};

 PUBLIC PROCEDURE DrGuS_EU();
 BEGIN
  DoDrGu(1);
 END {DrGuSFromKsk};

END.
