(*
%Copyright   (c) Polak IT
%Author      06.01.2010 19:54:32 POLAK\San
%Purpose     客 
%Type        operation
%Specific    SYS
%Modified    22.09.2014 18:52:18 POLAK\San
%Environment
*)

 MODULE ManSFee [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_SFee, P_Firm, L_Events, Memo, L_OTx, L_AFM, P_MCList, L_APtm, L_DatTim, L_Acnt,
        L_XObj, L_Cntr, L_MSO, L_Staff, P_MyFirm, L_Man, L_Str, L_PRoll, Math, L_StdFrm, L_AcCut,
        L_Sheet, E_Staff, L_Packet, L_WDO;

(*
$P{ Top:
P_Firm.MyFirmName(MyFirm.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
@
#################################################################################### ########## #####
=#####===============================================================================================
|                         ஢ઠ   ਮ  ##########  ##########                          |
|---------------------------------------------------------------------------------------------------|
|                        |  |਩                                                     |
|--------------------------|-------|----------------------------------------------------------------|
}
*)

(*
$P{ Line:
Man.Man, L, ""
L_Str.ShortName(Man.Name), L, ""
ManSFee.Period, L, "N.y"
?, L, ""
@
|##### ####################|#######|################################################################|
}
*)

(*
$P{ Bot:
@
=(c) Polak===========================================================================================
}
*)

 PRIVATE PROCEDURE ManSFee_OnInitializeWindow();
 BEGIN
  L_WDO.iZone        (1).Narrowing:="(ManSFee.Man=Staff.Man)&(ManSFee.MyFirm=Staff.MyFirm)";
  L_WDO.iSubwindow   (1, "ManSFeeE");
  L_WDO.iField       (1, "ManSFee.Type").Format:=L_SFee.t_Pool;
 END {ManSFee_OnInitializeWindow};

 PRIVATE PROCEDURE ManSFeeE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnReposition]);
  L_WDO.iZone        (0).ViewOnly:=1;
  L_WDO.iField       (0, "ManSFee.Type").Format:=L_SFee.t_Pool;
 END {ManSFeeE_OnInitializeWindow};

 PRIVATE PROCEDURE ManSFeeE_0_OnReposition();
 BEGIN
  IF ~!ManSFee.ri_iga THEN
   SEARCH(iga, RECORDID, , ManSFee.ri_iga);
   RTI.Get().CurZone.Fields("igaDTS").Value:=FLDTOSTR(iga.DTS, "D.N.y H:M");
  ELSE
   RTI.Get().CurZone.Fields("igaDTS").Value:="।⥫";
  END;
 END {ManSFeeE_0_OnReposition};

 PUBLIC PROCEDURE DoMonthlyCalculation();
 BEGIN
  L_StdFrm.Question("믮   " + L_DatTim.PeriodStr(Memo.ud_mb()));
  APP.Get().NewPrompt("   " + L_DatTim.PeriodStr(Memo.ud_mb()));
  L_SFee.PrepareMonthData(Memo.ud_mb());
  Proceed_o_Staff_XCalc(Memo.ud_mb());
 END {DoMonthlyCalculation};

 PUBLIC PROCEDURE DoYearlyCalculation();
  VAR
   P,
   E:  DATE;
 BEGIN
  P:=Memo.ud_mb();
  E:=L_DatTim.YearEnd(P);
  L_StdFrm.Question("믮    " + L_DatTim.PeriodStr(P) + "    ?");
  APP.Get().NewPrompt(" , 稭  " + L_DatTim.PeriodStr(P));
  REPEAT
   L_SFee.PrepareMonthData(P);
   Proceed_o_Staff_XCalc(P);
   P:=L_DatTim.IncMonth(P, +1);
  UNTIL (P > E) | ~L_APtm.MonthIsClosed(P, L_APtm.system_Salary);
 END {DoYearlyCalculation};

 PRIVATE PROCEDURE EmpyToZero(_Fee: LIKE(ManSFee.Fee[0])): LIKE(ManSFee.Fee[0]);
 BEGIN
  IF !_Fee THEN
   RETURN 0;
  ELSE
   RETURN _Fee;
  END;
 END {EmpyToZero};

 PRIVATE PROCEDURE PutSingleJDocListBySFBMJD(P: DATE; cntrNotion: L_APtm.tNotion; trgSum: LIKE(JDocList.Sum));
 BEGIN
  IF trgSum # 0 THEN
   JDocList.JDocKind:=JDoc.JDocKind;
   JDocList.JDoc    :=JDoc.JDoc;
   SETEMPTY(JDocList.JDLNbr);
   IF OCCURE(XObject) THEN
    JDocList.XObject :=XObject.XObject;
   ELSE
    SETEMPTY(JDocList.XObject);
   END;
   JDocList.AcCut   :=SFBMJD.AcCut;
   JDocList.Apport  :=L_Acnt.E_Apport_MoneyDebit(P);
   L_Cntr.SetupXObjectByErknedContract(P, cntrNotion, JDoc.MyFirm, JDocList.XObject2, JDocList.AcCut2);
   JDocList.Apport2 :=L_Acnt.E_Apport_MoneyCredit(P);
   JDocList.Sum:=trgSum;
   SETZERO(JDocList.Qnt, JDocList.wQnt, JDocList.wQnt2);
   SETEMPTY(JDocList.Date, JDocList.DoneDTS);
   INSERT(JDocList);
  END;
 END {PutSingleJDocListBySFBMJD};

 PUBLIC PROCEDURE BuildMonthlyJDoc();
  TYPE
   tTOBlin = NUMERIC[6];
  VAR
   P                      : DATE;
   trgMyFirm              : LIKE(MyFirm.MyFirm);
   curTravmObligTariff    : P_MyFirm.tTravmObligTariff;
   curPart                : L_SFee.tPart;
   _TOBlin                : tTOBlin;
   AcCut_VacationProvision: LIKE(AcCut.AcCut);
   trgXObject             : LIKE(XObject.XObject);
   curp_PFAbyReasonCode   : SCAL[L_SFee.p_Amount];
   asFee0                 : LIKE(ManSFee.Fee[0]);
 BEGIN
IF SELECT(JDocList, JDoc, JDoc.JDocKind, JDoc.JDoc) THEN
 L_StdFrm.Choice(" ");
 WHILE OCCURE(JDocList) DO
  REMOVE(JDocList);
 END; (* WHILE OCCURE(JDocList) ... *)
END;
P:=L_DatTim.Per(JDoc.Date);

  L_AFM.MakeMultipleIndex("SFBMJD", "MyFirm : "+TYPENAMEOF(P_Firm.tMyFirm) +";"+
                                    "MCode  : "+TYPENAMEOF(MCList.MCode)   +";"+
                                    "AcCut  : "+TYPENAMEOF(AcCut.AcCut)    +";"+
                                    "XObject: "+TYPENAMEOF(XObject.XObject)+";"+
                                    "Fee    : "+TYPENAMEOF(ManSFee.Fee)    +";"+
                                    "TOBlin : "+TYPENAMEOF(tTOBlin)        +";",
                            "MyFirm: MyFirm, AcCut, XObject");

  L_SFee.PrepareForDistribution(P, P);

trgMyFirm:=0001;
SEARCH(MyFirm, MyFirm, , trgMyFirm);
AcCut_VacationProvision:=L_AcCut.erkn_GetSoft(P, L_AcCut.erkn_VacationProvision);

  SELECT(L_SFee_M, MyFirm, , MyFirm.MyFirm);
  WHILE OCCURE(L_SFee_M) DO
   NARROWSEL(L_SFee_M, Man, Period);
   SEARCH(Man, Man, , L_SFee_M.Man);
   curTravmObligTariff:=L_OTx.TravmObligTariff_InvalidCoef(L_SFee_M.MyFirm, L_SFee_M.Period, L_SFee_M.Man);
   IF SELECT(ManSFee, MyFirm, L_SFee_M.MyFirm, L_SFee_M.Man, 1, L_SFee_M.Period) & (L_SFee.GetPFA_ReasonCode()=L_SFee.pfarc_1) THEN
    curp_PFAbyReasonCode:=L_SFee.p_PFA1;
   ELSE
    curp_PFAbyReasonCode:=L_SFee.p_PFA2;
   END;
   PROMPT(" " + L_SFee_M.Man);
   WHILE OCCURE(L_SFee_M) DO
    SEARCH(MCList, MCode, , L_SFee_M.MCode);
    IF L_OTx.TravmOblig_MCList_Attitude(L_SFee_M.Period) THEN
     _TOBlin:=L_SFee_M.Sum * curTravmObligTariff / 100;
    ELSE
     _TOBlin:=0;
    END;
IF L_SFee_M.AcCut = AcCut_VacationProvision THEN
 trgXObject:=L_XObj.GetRecastXObject(trgMyFirm);
ELSE
 trgXObject:=L_SFee_M.XObject;
END;

    asFee0:=EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA3_1])+
            EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA3_2])+
            EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA3_3])+
            EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA3_4])+
            EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA4_0]);

    ADD(SFBMJD, MyFirm, , L_SFee_M.MyFirm, L_SFee_M.AcCut, trgXObject,
        SFBMJD.Fee[L_SFee.p_PFIn],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFIn]),
        SFBMJD.Fee[L_SFee.p_PFAc],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFAc]),
        SFBMJD.Fee[L_SFee.p_xFSS],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_xFSS]),
        SFBMJD.Fee[L_SFee.p_MSFF],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_MSFF]),
        SFBMJD.Fee[L_SFee.p_MSTF],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_MSTF]),
        SFBMJD.Fee[L_SFee.p_PFOv],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFOv]),
        SFBMJD.Fee[L_SFee.p_PFA1],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA1]) + asFee0*(curp_PFAbyReasonCode=L_SFee.p_PFA1),
        SFBMJD.Fee[L_SFee.p_PFA2],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA2]) + asFee0*(curp_PFAbyReasonCode=L_SFee.p_PFA2),
        SFBMJD.TOBlin,               _TOBlin);
    NEXT(L_SFee_M);
   END; (* WHILE OCCURE(L_SFee_M) ... *)
   NEXTINEXTENDEDSEL(L_SFee_M, Man, Period);
  END; (* WHILE OCCURE(L_SFee_M) ... *)

  SELECT(SFBMJD, MyFirm, , MyFirm.MyFirm);
  WHILE OCCURE(SFBMJD) DO
   IF ~!SFBMJD.XObject THEN
    SEARCH(XObject, XObject, , SFBMJD.XObject);
   ELSE
    L_General.CLEAR("XObject");
   END;
   FOR_EACH curPart DO
    IF L_SFee.IsPartwNotion(P, curPart) THEN
     PutSingleJDocListBySFBMJD(P, L_SFee.sfp2Notion(curPart), SFBMJD.Fee[curPart]);
    END;
   END; (* FOR_EACH curPart... *)
   PutSingleJDocListBySFBMJD(P, L_Cntr.erkn_TAF_TrOb, SFBMJD.TOBlin);
   NEXT(SFBMJD);
  END; (* WHILE OCCURE(SFBMJD) ... *)
  CALL(JDoc.ccJDL_Renovate());
 END {BuildMonthlyJDoc};

 PRIVATE PROCEDURE MCCodeIsTaxable(trgMCode: LIKE(MCList.MCode); D: DATE): SCAL[2];
 BEGIN
  RETURN P_MCList.a2sf_Attitude(trgMCode, Math.Max(D, L_SFee.TheStartingPoint)) >= P_MCList.a2sf_Taxable;
 END {MCCodeIsTaxable};

 TYPE
  tExclKind = SCAL[4];
 CONST
  ek_None = 0; (*tExclKind*)
  ek_ML   = 1;
  ek_PL   = 2;
  ek_DL   = 3;
  ek_Pool = "-|  ६  த|  室  ॡ|६ 㤮ᯮᮡ";

  AddKNbr = 4;
  RuleForChildCare1 = "室_15_।1";
  RuleForChildCare2 = "室_15_।2";
  RuleForChildCare3 = "室_30";

 VAR
  AddKindChildCare: LIKE(Adding.AddKind)[AddKNbr];
 
 PRIVATE PROCEDURE GetAddKind(    PerB, PerE      : DATE;
                                  trgRule         : LIKE(Rule.Rule);
                              VAR AddKindChildCare: LIKE(Adding.AddKind)[];
                              VAR i               : NUMERIC[0]);
 BEGIN
  SELECT(MoneyRul, Rule, , trgRule);
  WHILE OCCURE(MoneyRul) DO
   CONFORM(MoneyRul, MMthLog);
   IF L_DatTim.IsActiveInIntvl(PerB, L_DatTim.Per(PerE), MMthLog.Date, MMthLog.Till) THEN
    SETSEL(AddKind, MoneyMth, MMthLog.Method);
    FOR_EACH AddKind DO
     IF L_DatTim.IsActiveInIntvl(PerB, L_DatTim.Per(PerE), AddKind.Begin, AddKind.Till) THEN
      AddKindChildCare[i]:=AddKind.AddKind;
      INC(i);
     END;
    END; (* FOR_EACH AddKind *)
   END;
   NEXT(MoneyRul);
  END; (* WHILE OCCURE(MoneyRul) ... *)
 END {GetAddKind};

 PRIVATE PROCEDURE HasParentalLeaveAdding(curDate: DATE): SCAL[2];
  VAR
   curAddKind: LIKE(AddKind.AddKind);
 BEGIN
  FOR_EACH curAddKind IN AddKindChildCare DO
   SETSEL(Adding, TSN, Staff.TSN, curAddKind);
   FOR_EACH Adding DO
    IF L_DatTim.IsActive_Inc(curDate, Adding.From, Adding.UpTo) THEN
     RETURN 1;
    END;
   END; (* FOR_EACH Adding *)
  END; (* FOR_EACH *)
  RETURN 0;
 END {HasParentalLeaveAdding};

 PRIVATE PROCEDURE GetExclDays(PerB, PerE: DATE): NUMERIC[0];
  VAR
   Result     : NUMERIC[0];
   BegDLeave,
   EndDLeave,
   curD       : DATE;
   prvExclKind,
   curExclKind: tExclKind;
   Idx        : NUMERIC[0];
 BEGIN
  Idx:=0; SETEMPTY(AddKindChildCare);
  GetAddKind(PerB, PerE, RuleForChildCare1, AddKindChildCare, Idx);
  GetAddKind(PerB, PerE, RuleForChildCare2, AddKindChildCare, Idx);
  GetAddKind(PerB, PerE, RuleForChildCare3, AddKindChildCare, Idx);

  Result:=0; SETEMPTY(BegDLeave, EndDLeave, prvExclKind);
  SELECT(Sheet, TSN, , Staff.TSN);
  SRCINSEL(Sheet, GE, , PerB);
  WHILE OCCURE(Sheet) & (Sheet.Period <= L_DatTim.Per(PerE)) DO
   curD:=Sheet.Period+Sheet.Day-1;
   PROMPT("ᬮ ⠡ "+L_DatTim.DateStr(curD));
   IF    (Sheet.JMode=L_Sheet.jm_MaternityLeave) THEN
    curExclKind:=ek_ML;
   ELSIF (Sheet.JMode=L_Sheet.jm_ParentalLeave) | (Sheet.JMode=L_Sheet.jm_ParentalLeaveUntil3Y) | HasParentalLeaveAdding(curD) THEN
    curExclKind:=ek_PL;
   ELSIF (E_Staff.SpecStage2ForPens(Sheet.Period, Sheet.JMode)=L_Packet.miat_Disability) THEN
    curExclKind:=ek_DL;
   ELSE
    curExclKind:=ek_None;
   END;
   IF ~!prvExclKind & (prvExclKind # ek_None) & (prvExclKind # curExclKind) & ~!BegDLeave THEN
    ADD(ExclD, ExclD, , PerB, prvExclKind, BegDLeave, EndDLeave);
    SETEMPTY(BegDLeave, EndDLeave);
   END;
   IF curExclKind # ek_None THEN
    IF !BegDLeave THEN
     BegDLeave:=curD;
    END;
    EndDLeave:=curD;
    INC(Result);
   END;
   prvExclKind:=curExclKind;
   NEXT(Sheet);
  END; (* WHILE OCCURE(Sheet) ... *)
  IF ~!BegDLeave THEN
   ADD(ExclD, ExclD, , PerB, prvExclKind, BegDLeave, EndDLeave);
  END;
  RETURN Result;
 END {GetExclDays};

 PRIVATE PROCEDURE WordSetSingleExclDays(Nam: STRING[]; curBegD, curEndD: DATE; curDays: NUMERIC[0]; ek: STRING[]);
 BEGIN
  L_MSO.wordSetDateVar(Nam + ".BegDate", curBegD);
  L_MSO.wordSetDateVar(Nam + ".EndDate", curEndD);
  L_MSO.wordSetVar(Nam + ".Days", L_Str.IntStr(curDays));
  L_MSO.wordSetVar(Nam + ".Kind", ek);
 END {WordSetSingleExclDays};

 PRIVATE PROCEDURE MakeYear(trgMyFirm: LIKE(MyFirm.MyFirm); P: DATE; VAR SumYear: NUMERIC[2]; VAR ExclDaysYear: NUMERIC[0]);
 BEGIN
  SumYear:=0; ExclDaysYear:=0;
  SELECT(Staff, MyFirm, , trgMyFirm, Man.Man);
  WHILE OCCURE(Staff) DO

   SELECT(Money, TSN, , Staff.TSN);
   SRCINSEL(Money, GE, , L_DatTim.YearBeg(P));
   WHILE OCCURE(Money) & (Money.Closed <= L_DatTim.YearEnd(P)) DO
    IF ((Staff.Contract # L_Staff.cnt_ContractorsAgreement) | ~L_SFee.E_IsRealContractorsAgreement(Money.Closed)) &
       (Staff.Contract # L_Staff.cnt_OutStaff) &
       MCCodeIsTaxable(Money.MCode, Money.Closed) THEN
     INC(SumYear, Money.Sum);
    END;
    NEXT(Money);
   END; (* WHILE OCCURE(Money) ... *)

   IF (Staff.Contract # L_Staff.cnt_InternalCombine) & (Staff.Contract # L_Staff.cnt_OutStaff) THEN
    INC(ExclDaysYear, GetExclDays(L_DatTim.YearBeg(P), L_DatTim.YearEnd(P)));
   END;

   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {MakeYear};

 PUBLIC PROCEDURE MakeSprMin();
  VAR
   P,
   D        : DATE;
   trgMyFirm: LIKE(MyFirm.MyFirm);
   SumYear  : NUMERIC[2];
   NumYear  : SCAL[3];
   i        : NUMERIC[0];
   _BegDate,
   _EndDate : DATE;
   ExclDaysYear: NUMERIC[0];
   BadYearAmnt: NUMERIC[0];
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  D:=Memo.ud_cd();

  L_StdFrm.Question("  ਮ  "+L_DatTim.DateStr(L_DatTim.IncYear(L_DatTim.YearBeg(D), -2))+"  "+L_DatTim.DateStr(L_DatTim.YearEnd(D)));
  IF L_DatTim.YearBeg(D) < L_DatTim.YearBeg(SYSDATE()) THEN
   L_StdFrm.Choice("⮢ ᢥ  ⠭ ਮ.||" +
                   "⠭  ਮ  " +L_DatTim.DateStr(L_DatTim.IncYear(L_DatTim.YearBeg(SYSDATE()), -2))+"  "+L_DatTim.DateStr(L_DatTim.YearEnd(SYSDATE())));
  END;
  L_PRoll.CheckSalDone(D);
  L_MSO.wordInitDocument(SYSDATE());
  CONFORM(Staff, Man);
  L_MSO.wordSetVarsByFile("Man");
  L_Man.wordSetAddresses("Man.", Man.Man, SYSDATE());
  trgMyFirm:=L_Staff.GetStaffMyFirm();
  P_Firm.SetFirmDefaultData("Own", L_Staff.GetFirmOfStaff(), SYSDATE(), "");
  L_MSO.wordSetVar("OwnFirm.FSSRegistrationCode",  P_MyFirm.FSSRegistrationCode(trgMyFirm, SYSDATE()));
  L_MSO.wordSetVar("OwnFirm.FSSSupplementaryCode", P_MyFirm.FSSSupplementaryCode(trgMyFirm, SYSDATE()));
  L_MSO.wordSetVar("OwnFirm.FSSName",              P_MyFirm.FSSName(trgMyFirm, SYSDATE()));
  L_MSO.wordSetVar("OwnFirm.KpsNum",               P_MyFirm.FSSSubordinationCode(trgMyFirm, SYSDATE()));

  i:=0;
  SELECT(Staff, MyFirm, , trgMyFirm, Man.Man);
  WHILE OCCURE(Staff) DO
   IF ((Staff.Contract # L_Staff.cnt_ContractorsAgreement) | ~L_SFee.E_IsRealContractorsAgreement(L_DatTim.MonthBeg(D))) &
      (Staff.Contract # L_Staff.cnt_InternalCombine) & (Staff.Contract # L_Staff.cnt_OutStaff) THEN
    SELECT(StaffLog, TSN, , Staff.TSN);
    WHILE OCCURE(StaffLog) DO
     _BegDate:=StaffLog.Date;
     SETEMPTY(_EndDate);
     NEXT(StaffLog);
     WHILE OCCURE(StaffLog) DO
      IF L_Staff.IsDischargeStaffLog() THEN
       _EndDate:=StaffLog.DateE;
      END;
      NEXT(StaffLog);
     END;
     L_MSO.wordSetDateVar(L_Str.Var_wIdx("Staff.StaffLog", i) + ".Date", _BegDate);
     L_MSO.wordSetDateVar(L_Str.Var_wIdx("Staff.StaffLog", i) + ".EndDate", Math.Min(_EndDate, SYSDATE()));
     INC(i);
     IF OCCURE(StaffLog) THEN
      NEXT(StaffLog);
     END;
    END; (* WHILE OCCURE(StaffLog) ... *)
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  L_MSO.SetWordTable("table10", i);

  L_AFM.MakeIndex("ExclD", "Year: DATE;"+
                           "ExclKind: SCAL[4];"+
                           "BedD: DATE;"+
                           "EndD: DATE");

  SETZERO(BadYearAmnt);
  P:=L_DatTim.IncYear(L_DatTim.MonthBeg(D), -1 * MAXOF(NumYear));
  FOR_EACH NumYear DO
   L_MSO.wordSetVar("Year" + L_Str.IntStr(NumYear), L_Str.IntStr(L_DatTim.YEAR(P)));
   MakeYear(trgMyFirm, P, SumYear, ExclDaysYear);
   SumYear:=Math.Min(SumYear, L_SFee.GetOvrQuota(Math.Max(L_DatTim.YearBeg(P), L_SFee.TheStartingPoint)));
   L_MSO.wordSetMoneyVar("SumYear" + L_Str.IntStr(NumYear), D, SumYear);

   L_MSO.wordSetVar("ExclDaysYear" + L_Str.IntStr(NumYear), L_Str.IntStr(ExclDaysYear));
   i:=0;
   WordSetSingleExclDays(L_Str.Var_wIdx("ExclDays" + L_Str.IntStr(NumYear), i),
                         EMPTYOF(DATE), EMPTYOF(DATE), EMPTYOF(NUMERIC[0]), "");
   SELECT(ExclD, ExclD, , L_DatTim.YearBeg(P));
   WHILE OCCURE(ExclD) DO
    WordSetSingleExclDays(L_Str.Var_wIdx("ExclDays" + L_Str.IntStr(NumYear), i),
                          ExclD.BedD, ExclD.EndD, ExclD.EndD-ExclD.BedD+1, L_Str.PoolItem(ek_Pool, ExclD.ExclKind));
    NEXT(ExclD);
    INC(i);
   END; (* WHILE OCCURE(ExclD) ... *)
   L_MSO.SetWordTable("table" + L_Str.IntStr(NumYear), i);
   INC(BadYearAmnt, SELECT(ExclD, ExclD, L_DatTim.YearBeg(P), ek_ML) |
                    SELECT(ExclD, ExclD, L_DatTim.YearBeg(P), ek_PL));
   P:=L_DatTim.IncYear(P, 1);
  END; (* FOR_EACH NumYear ... *)

  i:=0;
  L_MSO.wordSetMoneyVar(L_Str.Var_wIdx("SumYearAdd", i), P, EMPTYOF(SumYear));
  L_MSO.wordSetVar(L_Str.Var_wIdx("ExclDaysYearAdd", i), "");
  P:=L_DatTim.IncYear(L_DatTim.MonthBeg(D), -1 * MAXOF(NumYear));
  WHILE (BadYearAmnt > 0) & (i<=NumYear) & (P > L_DatTim.IncYear(L_DatTim.MonthBeg(D), -10)) DO
   P:=L_DatTim.IncYear(P, -1);
   MakeYear(trgMyFirm, P, SumYear, ExclDaysYear);
   SumYear:=Math.Min(SumYear, L_SFee.GetOvrQuota(Math.Max(L_DatTim.YearBeg(P), L_SFee.TheStartingPoint)));
   IF ~SELECT(ExclD, ExclD, L_DatTim.YearBeg(P), ek_ML) &
      ~SELECT(ExclD, ExclD, L_DatTim.YearBeg(P), ek_PL) &
      (SumYear > 0) THEN
    L_MSO.wordSetDateVar(L_Str.Var_wIdx("YearAdd", i), P);
    L_MSO.wordSetMoneyVar(L_Str.Var_wIdx("SumYearAdd", i), P, SumYear);
    L_MSO.wordSetVar(L_Str.Var_wIdx("ExclDaysYearAdd", i), L_Str.IntStr(ExclDaysYear));
    DEC(BadYearAmnt);
    INC(i);
   END;
  END;
  L_MSO.SetWordTable("table11", i);
  L_MSO.SetWordTable("table12", i);

  L_AFM.AF_PurgeTemp("ExclD");
  L_MSO.MakeWordDocument("SprMin", 1, L_MSO.PrpMode_ToDoc, "");
 END {MakeSprMin};

 PUBLIC PROCEDURE TestSFee();
  CONST
   RepName = "TstSF";
  VAR
   BPer,
   EPer   : DATE;
   ManNeedInsureInPF: SCAL[2];
   pIdx   : L_SFee.tPart;
 BEGIN
  APP.Get().NewPrompt("("+RepName+")");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  BPer:=Memo.ud_fr();
  EPer:=Memo.ud_ut();
  L_DatTim.CheckWMIntvl(BPer, EPer);
  L_General.Assert(L_SFee.SFeeIsCalculatedInProperConsecution(L_DatTim.Per(EPer)), " ⠭ 客   " + L_DatTim.PeriodStr(EPer));

  OPENREP(R, L_General.NameConnection(RepName), Create);

  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF (MyFirm.MyFirm # P_Firm.mf_Fict) & L_DatTim.IsActiveInIntvl_Inc(MyFirm.Begin, L_DatTim.till2ED(MyFirm.Till), BPer, EPer) THEN
    MAKEPART(R, Top, RepName, BPer, EPer);

    SELECT(ManSFee, Actual, , 1, MyFirm.MyFirm);
    WHILE OCCURE(ManSFee) DO
     NARROWSEL(ManSFee, Man);
     PROMPT(" "+ManSFee.Man);
     SRCINSEL(ManSFee, GE, , BPer);
     WHILE OCCURE(ManSFee) & (ManSFee.Period<=EPer) DO
      CONFORM(ManSFee, Man);
      L_Staff.StandOnMainContract(ManSFee.Man, ManSFee.MyFirm, L_DatTim.MonthEnd(ManSFee.Period));
      IF ManSFee.Type # L_SFee.DefineType(ManSFee.MyFirm, ManSFee.Man, ManSFee.Period) THEN
       MAKEPART(R, Line, " ");
      END;
      ManNeedInsureInPF:=L_SFee.ManNeedInsureInPF(Man.Man, ManSFee.Period);
      IF L_SFee.ManIsInsuredInPF(Man.Man, ManSFee.Period) # ManNeedInsureInPF THEN
       MAKEPART(R, Line, " "+L_Str.PoolItem(" |", ManNeedInsureInPF)+" 客  , "+
                         " "+L_Str.PoolItem("客| 客", ManNeedInsureInPF)+". "+
                         L_Str.PoolItem("-1 |-1 ", L_SFee.ManHasADV1()));
      END;
      IF ManSFee.ExcCmn < 0 THEN
       MAKEPART(R, Line, "⥫쭠 㬬 ᪫祭  ");
      ELSIF (ManSFee.Object-ManSFee.ExcCmn) < 0 THEN
       MAKEPART(R, Line, "⥫쭠    ᮢ");
      ELSE
       FOR_EACH pIdx DO
        IF ManSFee.Fee[pIdx]<0 THEN
         MAKEPART(R, Line, "⥫  '"+L_Str.PoolItem(L_SFee.p_Pool, pIdx)+"'");
        END;
       END;
      END;
      NEXT(ManSFee);
     END; (* WHILE OCCURE(ManSFee) ... *)
     NEXTINEXTENDEDSEL(ManSFee, Man);
    END; (* WHILE OCCURE(ManSFee) ... *)
    MAKEPART(R, Bot);
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)

  CLOSEREP(R);
 END {TestSFee};

 PUBLIC PROCEDURE CalcSingleMan();
 BEGIN
  L_General.Assert(ACCESS(Staff), " । ࠡ⭨");
  CONFORM(Staff, Man);
  L_StdFrm.Choice("।⥫    "+L_DatTim.PeriodStr(Memo.ud_mb())+"| "+Man.Name);
  L_General.Assert(~L_SFee.SFeeIsCalculatedInProperConsecution(Memo.ud_mb()),
                   " 믮 ⮫쪮  ,|   뫮 ᮢ  ");
  L_SFee.CalculateSingleMan(Memo.ud_mb());
 END {CalcSingleMan};

 PRIVATE PROCEDURE pmx_Single(P: DATE; cntrNotion: L_APtm.tNotion; trgSum: LIKE(JDocList.Sum));
  VAR
   crdXObject: LIKE(XObject.XObject);
   crdAcCut  : LIKE(AcCut.AcCut);
 BEGIN
  IF trgSum # 0 THEN
   L_Cntr.SetupXObjectByErknedContract(P, cntrNotion, MyFirm.MyFirm, crdXObject, crdAcCut);
   L_XObj.MakeCompleteCir(+1, P,
                          SFBMJD.XObject, SFBMJD.AcCut,  L_Acnt.E_Apport_MoneyDebit(P),  0,
                          crdXObject,     crdAcCut,      L_Acnt.E_Apport_MoneyCredit(P), 0,
                          trgSum, 0, L_XObj.src_Salary);
   SEARCH(XObject, XObject, , crdXObject);
   L_XObj.mo_MakeCir(+1, L_AcCut.erkn_Get(P, L_AcCut.erkn_OnlineBalance), P, L_Acnt.E_Apport_MoneyCredit(P),
                     L_AcCut.erkn_Get(P, L_AcCut.erkn_Fictive), trgSum, L_XObj.src_Salary);
  END;
 END {pmx_Single};

 PRIVATE PROCEDURE Proceed_ManSFee_XCalc(P: DATE);
  TYPE
   tTOBlin = NUMERIC[6];
  VAR
   curTravmObligTariff    : P_MyFirm.tTravmObligTariff;
   curPart                : L_SFee.tPart;
   curTOBlin,
   totTOBlin              : tTOBlin;
   AcCut_VacationProvision: LIKE(AcCut.AcCut);
   trgXObject             : LIKE(XObject.XObject);
   curp_PFAbyReasonCode   : SCAL[L_SFee.p_Amount];
   asFee0                 : LIKE(ManSFee.Fee[0]);
   maxTOBlin              : tTOBlin;
   maxTSN                 : LIKE(Staff.TSN);
   maxAcCut               : LIKE(AcCut.AcCut);
   maxXObject             : LIKE(XObject.XObject);
 BEGIN
  APP.Get().NewPrompt("ନ஢ ⮢  裡  ");
  L_AFM.MakeMultipleIndex("SFBMJD", "TSN    : "+TYPENAMEOF(Staff.TSN)      +";"+
                                    "AcCut  : "+TYPENAMEOF(AcCut.AcCut)    +";"+
                                    "XObject: "+TYPENAMEOF(XObject.XObject)+";"+
                                    "Fee    : "+TYPENAMEOF(ManSFee.Fee)    +";"+
                                    "TOBlin : "+TYPENAMEOF(L_XObj.tSum)    +";",
                            "TSN: TSN, AcCut, XObject");

  L_SFee.extPrepareForDistribution(P, P, 1, EMPTYOF(MyFirm.MyFirm));

  AcCut_VacationProvision:=L_AcCut.erkn_GetSoft(P, L_AcCut.erkn_VacationProvision);

  SELECT(L_SFee_M, MyFirm);
  WHILE OCCURE(L_SFee_M) DO
   NARROWSEL(L_SFee_M, MyFirm);
   SEARCH(MyFirm, MyFirm, , L_SFee_M.MyFirm);
   totTOBlin:=0;
   SETSEL(SFBMJD, TSN);
   REMSEL(SFBMJD);
   WHILE OCCURE(L_SFee_M) DO
    NARROWSEL(L_SFee_M, Man, Period);
    SEARCH(Man, Man, , L_SFee_M.Man);
    curTravmObligTariff:=L_OTx.TravmObligTariff_InvalidCoef(L_SFee_M.MyFirm, L_SFee_M.Period, L_SFee_M.Man);
    IF SELECT(ManSFee, MyFirm, L_SFee_M.MyFirm, L_SFee_M.Man, 1, L_SFee_M.Period) & (L_SFee.GetPFA_ReasonCode()=L_SFee.pfarc_1) THEN
     curp_PFAbyReasonCode:=L_SFee.p_PFA1;
    ELSE
     curp_PFAbyReasonCode:=L_SFee.p_PFA2;
    END;
    PROMPT(" " + L_SFee_M.Man);
    WHILE OCCURE(L_SFee_M) DO
     SEARCH(MCList, MCode, , L_SFee_M.MCode);
     IF L_OTx.TravmOblig_MCList_Attitude(L_SFee_M.Period) THEN
      curTOBlin:=L_SFee_M.Sum * curTravmObligTariff / 100;
      INC(totTOBlin, curTOBlin);
     ELSE
      curTOBlin:=0;
     END;
 
     IF L_SFee_M.AcCut = AcCut_VacationProvision THEN
      trgXObject:=L_XObj.GetRecastXObject(L_SFee_M.MyFirm);
     ELSE
      trgXObject:=L_SFee_M.XObject;
     END;
 
     asFee0:=EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA3_1])+
             EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA3_2])+
             EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA3_3])+
             EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA3_4])+
             EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA4_0]);
 
     ADD(SFBMJD, TSN, , L_SFee_M.TSN, L_SFee_M.AcCut, trgXObject,
         SFBMJD.Fee[L_SFee.p_PFIn],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFIn]),
         SFBMJD.Fee[L_SFee.p_PFAc],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFAc]),
         SFBMJD.Fee[L_SFee.p_xFSS],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_xFSS]),
         SFBMJD.Fee[L_SFee.p_MSFF],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_MSFF]),
         SFBMJD.Fee[L_SFee.p_MSTF],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_MSTF]),
         SFBMJD.Fee[L_SFee.p_PFOv],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFOv]),
         SFBMJD.Fee[L_SFee.p_PFA1],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA1]) + asFee0*(curp_PFAbyReasonCode=L_SFee.p_PFA1),
         SFBMJD.Fee[L_SFee.p_PFA2],   EmpyToZero(L_SFee_M.Fee[L_SFee.p_PFA2]) + asFee0*(curp_PFAbyReasonCode=L_SFee.p_PFA2),
         SFBMJD.TOBlin,               curTOBlin);
     NEXT(L_SFee_M);
    END; (* WHILE OCCURE(L_SFee_M) ... *)
    NEXTINEXTENDEDSEL(L_SFee_M, Man, Period);
   END; (* WHILE OCCURE(L_SFee_M) ... *)
   maxTOBlin:=MINOF(curTOBlin);
   SELECT(SFBMJD, TSN);
   WHILE OCCURE(SFBMJD) DO
    NARROWSEL(SFBMJD, TSN);
    IF SEARCH(PCalc, TSN, SFBMJD.TSN, P) THEN
     L_XDR.XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_PCalc);
    ELSE
     L_General.CallUs(0);
    END;
    WHILE OCCURE(SFBMJD) DO
     FOR_EACH curPart DO
      IF L_SFee.IsPartwNotion(P, curPart) THEN
       pmx_Single(P, L_SFee.sfp2Notion(curPart), SFBMJD.Fee[curPart]);
      END;
     END; (* FOR_EACH curPart... *)
     IF SFBMJD.TOBlin >= maxTOBlin THEN
      maxTOBlin :=SFBMJD.TOBlin;
      maxTSN    :=SFBMJD.TSN;
      maxAcCut  :=SFBMJD.AcCut;
      maxXObject:=SFBMJD.XObject;
     END;
     DEC(totTOBlin, SFBMJD.TOBlin);
     pmx_Single(P, L_Cntr.erkn_TAF_TrOb, SFBMJD.TOBlin);
     NEXT(SFBMJD);
    END;
    NEXTINEXTENDEDSEL(SFBMJD, TSN);
   END; (* WHILE OCCURE(SFBMJD) ... *)
   IF totTOBlin # 0 THEN
    SEARCH(SFBMJD, TSN, , maxTSN, maxAcCut, maxXObject);
    pmx_Single(P, L_Cntr.erkn_TAF_TrOb, totTOBlin);
   END;
   NEXTINEXTENDEDSEL(L_SFee_M, MyFirm);
  END; (* WHILE OCCURE(L_SFee_M) ... *)
 END {Proceed_ManSFee_XCalc};

 PRIVATE PROCEDURE Proceed_o_Staff_XCalc(P: DATE);
  VAR
   SourcesToClear: SCAL[2][100];
   savCD         : DATE;
 BEGIN
  IF P >= L_PRoll.E_DoSecondSide() THEN
   savCD:=Memo.gl_cd();
   TRY
    Memo.gl_SetCurDate(P);
    SETSEL(Staff, TSN);
    FOR_EACH Staff DO
     L_PRoll.Make70Cir(Staff.TSN);
    END; (* FOR_EACH Staff  *)
    Proceed_ManSFee_XCalc(P);
   EXCEPT
   FINALLY
    Memo.gl_SetCurDate(savCD);
   END;
  END;
 END {Proceed_o_Staff_XCalc};

BEGIN
 L_Events.ExecuteHandler();
END.
