(*
%Copyright   (c) Polak Computer System
%Author      19.07.1995 11:47:20 SAN
%Purpose     ஫   죮
%Type        control
%Specific    SYS
%Modified    10.04.2012 12:20:30 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_DatTim, L_Tax, L_PRoll, L_Events, L_APtm, Memo;

 VAR
  IsSaved : SCAL[2];
  _pTaxAdv: LIKE(ManTA.TaxAdv);
  _pStartD: LIKE(ManTA.StartD);
  _pStopD : LIKE(ManTA.StopD);
  _pValue : LIKE(ManTA.Value);

 PRIVATE PROCEDURE ManTA_SaveEmptyPrv();
 BEGIN
  L_General.ConsultToUs(~IsSaved, "ManTA.ManTA_SetEmptyPrv: Error 1");
  SETEMPTY(_pTaxAdv, _pStartD, _pStopD, _pValue);
  IsSaved:=1;
 END {ManTA_SaveEmptyPrv};

 PRIVATE PROCEDURE ManTA_SavePrvAsPValues();
 BEGIN
  L_General.ConsultToUs(~IsSaved, "ManTA.ManTA_SavePrvAsPValues: Error 1");
  _pTaxAdv:=GE_PVALUE(ManTA.TaxAdv);
  _pStartD:=GE_PVALUE(ManTA.StartD);
  _pStopD :=GE_PVALUE(ManTA.StopD);
  _pValue :=GE_PVALUE(ManTA.Value);
  IsSaved :=1;
 END {ManTA_SavePrvAsPValues};

 PRIVATE PROCEDURE GetNotClosedMonth(D: DATE): DATE;
 BEGIN
  D:=L_DatTim.Per(D);
  IF D > SYSDATE() THEN            (*᫨誮  ਮ  *)
   D:=L_DatTim.NextPer(SYSDATE()); (* ᠭ  *)
  END;
  WHILE L_APtm.MonthIsClosed(D, L_APtm.system_Salary) DO
   D:=L_DatTim.IncMonth(D, +1);
  END;
  RETURN D;
 END {GetNotClosedMonth};

 PRIVATE PROCEDURE ManTA_GetActualPer(): DATE;
  VAR
   _minStopD: DATE;
 BEGIN
  L_General.ConsultToUs(IsSaved, "ManTA.GetActualPer: Error 1");
  IsSaved:=0;
  IF !_pStartD THEN
   RETURN GetNotClosedMonth(ManTA.StartD);
  ELSE
   IF (ManTA.TaxAdv # _pTaxAdv) |
      (ManTA.StartD # _pStartD) |
      (ManTA.Value  # _pValue ) THEN
    RETURN GetNotClosedMonth(L_DatTim.MinDATE(ManTA.StartD, _pStartD));
   ELSE
    _minStopD:=L_DatTim.MinDATE(ManTA.StopD, _pStopD);
    IF !_minStopD THEN
     RETURN L_PRoll.Salary_ClcPer();
    ELSE
     RETURN GetNotClosedMonth(_minStopD + 1);
    END;
   END;
  END;
 END {ManTA_GetActualPer};

 PRIVATE PROCEDURE _ShtDone();
  VAR
   P: DATE;
 BEGIN
  P:=ManTA_GetActualPer();
  CONFORM(ManTA, TaxInq);
  L_General.Assert(SELECT(Staff, MyFirm, TaxInq.MyFirm, TaxInq.Man), "   ࠪ");
  WHILE OCCURE(Staff) DO
   L_PRoll.DedDone_AP(L_DatTim.MaxDATE(L_DatTim.Per(Staff.BegDate), P), 0);
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {_ShtDone};

 PRIVATE PROCEDURE ManTA_StartD_OnSuccessfulChange();
 BEGIN
  IF ~!ManTA.TaxAdv THEN
   CONFORM(ManTA, TaxAdv);
   IF ~L_Tax.Tax_TaxAdv_MayBeOpn() | L_Tax.Tax_InterpretValueAsSum(TaxInq.InqType) THEN
    IF !ManTA.StartD THEN
     SETEMPTY(ManTA.StopD);
    ELSE
     ManTA.StopD:=L_DatTim.MonthEnd(ManTA.StartD);
    END;
    REPLACE(ManTA);
   END;
  END;
 END {ManTA_StartD_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckClcPer(Action: STRING[]);
 BEGIN
  CONFORM(ManTA, TaxAdv);
  IF L_Tax.Tax_TaxAdv_NeedBeInClcPer() THEN
   L_General.Assert(~L_APtm.MonthIsClosed(ManTA.StartD, L_APtm.system_Salary),
                    "䨪  " + ManTA.TaxAdv +
                    "  " + Action + "|" + L_DatTim.PeriodStr(ManTA.StartD) +
                    " -  (" + L_APtm.SystemName(L_APtm.system_Salary) + ")");
  END;
 END {CheckClcPer};

 PRIVATE PROCEDURE ManTA_OnAfterEditInsert();
 BEGIN
  IF ~!ManTA.StopD THEN
   ManTA.StopD:=L_DatTim.MonthEnd(ManTA.StopD);
   REPLACE(ManTA);
  END;
  CONFORM(ManTA, TaxAdv);
  IF L_Tax.Tax_InterpretValueAsSum(TaxInq.InqType) THEN
   L_General.Assert(~!ManTA.Value, "室 㪠 㬬");
  ELSIF !L_Tax.Tax_TaxAdv_DefValue() THEN
   L_General.Assert(~!ManTA.Value, "室 㪠 稭");
  ELSE
   L_General.Assert(!ManTA.Value, "⨬ 㪠뢠 稭");
  END;
  IF ~L_Tax.Tax_TaxAdv_MayBeOpn() THEN
   L_General.Assert(~!ManTA.StopD, "⨬ ⠢ ⮩");
   L_General.Assert(L_DatTim.YEAR(ManTA.StartD) = L_DatTim.YEAR(ManTA.StopD),
                    "    祭 ");
  END;
  L_General.Assert(ManTA.StartD <= ManTA.StopD, "ୠ  砭");
  CheckClcPer("");
  L_General.Assert(L_DatTim.InPatIntvl(TaxAdv.Begin, TaxAdv.Till,
                                       ManTA.StartD, ManTA.StopD),
                                       "䨪  " + TaxAdv.TaxAdv + "    ਮ| " +
                                       L_DatTim.DateStr(ManTA.StartD)+"  "+L_DatTim.DateStr(ManTA.StopD));
 END {ManTA_OnAfterEditInsert};

 PRIVATE PROCEDURE ManTA_OnAfterEdit();
 BEGIN
  ManTA_SavePrvAsPValues();
  ManTA_OnAfterEditInsert();
  _ShtDone();
 END {ManTA_OnAfterEdit};

 PRIVATE PROCEDURE ManTA_OnAfterInsert();
 BEGIN
  ManTA_SaveEmptyPrv();
  ManTA_OnAfterEditInsert();
  _ShtDone();
 END {ManTA_OnAfterInsert};

 PRIVATE PROCEDURE ManTA_OnBeforeEdit();
 BEGIN
  CheckClcPer("");
 END {ManTA_OnBeforeEdit};

 PRIVATE PROCEDURE ManTA_OnBeforeDelete();
 BEGIN
  ManTA_SaveEmptyPrv();
  CheckClcPer("㤠");
  _ShtDone();
 END {ManTA_OnBeforeDelete};

 PRIVATE PROCEDURE ManTA_StreamDelete();
 BEGIN
  ManTA_OnBeforeDelete();
 END {ManTA_StreamDelete};

BEGIN
 IsSaved:=0;
 L_Tax.Tax2001_InitCodes(ManTA.StartD);
 IF L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSIF MODE = 060 THEN
  ManTA_StreamDelete();
 ELSE
  L_General.BadMode(MODE);
 END;
END.
