(*
%Copyright   (c) Polak Computer System
%Author      22.09.2000 15:49:02 BOR
%Purpose     ⥫  ꥪ 
%Type        control
%Specific    SYS
%Modified    10.04.2012 12:20:35 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_Events, L_MathR, L_APtm;

 CONST
  src_Operator = 0;

 PRIVATE PROCEDURE Check();
 BEGIN
  CONFORM(MathMty, Math);
  L_General.Assert(MathMty.Source=src_Operator, " ⮬᪨ ᫥ ⥫  ந");
  L_APtm.ANYDoc_CheckDate(MathMty.Period);
  L_MathR.ChMClcPer(Math.MathKind);
  L_MathR.ResetMathDone_AP(MathMty.Math, MathMty.Period);
 END {Check};

 PRIVATE PROCEDURE MathMty_OnBeforeInsert();
 BEGIN
  L_General.AdminOnly();
  MathMty.Source:=src_Operator;
  REPLACE(MathMty);
 END {MathMty_OnBeforeInsert};

 PRIVATE PROCEDURE MathMty_OnBeforeEdit();
 BEGIN
  Check();
 END {MathMty_OnBeforeEdit};

 PRIVATE PROCEDURE MathMty_OnBeforeDelete();
 BEGIN
  Check();
 END {MathMty_OnBeforeDelete};

 PRIVATE PROCEDURE MathMty_OnAfterEdit();
 BEGIN
  Check();
 END {MathMty_OnAfterEdit};

 PRIVATE PROCEDURE MathMty_OnAfterInsert();
 BEGIN
  Check();
 END {MathMty_OnAfterInsert};

BEGIN
 IF L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSE
  L_General.BadMode(MODE);
 END;
END.
