(*
%Copyright   (c) Polak IT
%Author      27.04.2010 20:27:04 POLAK\Bor
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    10.04.2012 12:20:40 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_Events, L_MathR, L_APtm, L_CI;

 CONST
  src_Operator = 0;

 PRIVATE PROCEDURE Check();
 BEGIN
  CONFORM(MathRun, Math);
  L_General.Assert(MathRun.Source=src_Operator, " ⮬᪨ ᫥ ⥫  ந");
  L_APtm.ANYDoc_CheckDate(MathRun.Period);
  L_MathR.ChMClcPer(Math.MathKind);
  L_MathR.ResetMathDone_AP(MathRun.Math, MathRun.Period);
  L_CI.CheckActivityCostItem(MathRun.CostItem);
 END {Check};

 PRIVATE PROCEDURE MathRun_OnBeforeInsert();
 BEGIN
  L_General.AdminOnly();
  MathRun.Source:=src_Operator;
  REPLACE(MathRun);
 END {MathRun_OnBeforeInsert};

 PRIVATE PROCEDURE MathRun_OnBeforeEdit();
 BEGIN
  Check();
 END {MathRun_OnBeforeEdit};

 PRIVATE PROCEDURE MathRun_OnBeforeDelete();
 BEGIN
  Check();
 END {MathRun_OnBeforeDelete};

 PRIVATE PROCEDURE MathRun_OnAfterEdit();
 BEGIN
  Check();
 END {MathRun_OnAfterEdit};

 PRIVATE PROCEDURE MathRun_OnAfterInsert();
 BEGIN
  Check();
 END {MathRun_OnAfterInsert};

BEGIN
 IF L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSE
  L_General.BadMode(MODE);
 END;
END.
