(*
%Copyright   (c) Polak Computer System
%Author      22.12.2000 19:55:13 BOR
%Purpose
%Type        operation
%Specific    SYS
%Modified    12.08.2014 22:02:58 POLAK\San
%Environment
*)

 MODULE MCList [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_Acnt, L_Events, L_PRoll, Memo,
        L_WDO, L_Str, P_MCList, L_Prop, L_DatTim, Math, L_StdFrm,
        L_DBD, L_SFee, L_APtm, L_r2r, L_qs;

 PRIVATE PROCEDURE Geta2sf_Attitude(): P_MCList.tAttitude2SFee;
 BEGIN
  IF Memo.ud_mb() >= L_SFee.TheStartingPoint THEN
   RETURN P_MCList.a2sf_Attitude(MCList.MCode, Memo.ud_mb());
  ELSE
   RETURN EMPTYOF(P_MCList.tAttitude2SFee);
  END;
 END {Geta2sf_Attitude};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_cd(), C, " ᫥  㤥ঠ  D.N.y"
@
#################################################################################################################                                                             ########## #####
-#####----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
|############################################################################################################################################################################################|
}
*)

(*
$P{ SubTop:
?, L, ""
@
|============================================================================================================================================================================================|
|##############################################################################|     |  |             㤥ঠ          |         ६        |          稥           |
|------------------------------------------------------------------------------|६|-----------|-----------------------------------|-----------------------|-------------------------------|
||                    | |㯯                             |     ||/|||| 1 |||| 5 | 6 | 7 | 1 | 2 | 3 | 4 | 5 | 6 |||||||| |
|---|--------------------------------|-----|-----------------------------------|-----|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|---|
}
*)

 PRIVATE CONST
  IndexPool = "-||";

(*
$P{ Line:
MCList.MCode, L, ""
MCList.Name, L, ""
L_Acnt.GetCAcntSign(Memo.ud_cd(), MCList.AcCut), L, ""
MCGroup.MCGroup, L, ""
MCGroup.Name, L, ""
L_Str.PoolItem(" ||ந", MCList.TimeType), L, ""
MCList.Index[0], L, IndexPool
MCList.Index[1], L, IndexPool
MCList.Index[2], L, IndexPool
MCList.TaxAdv, L, ""
MCList.ForDed[0], L, IndexPool
MCList.ForDed[1], L, IndexPool
MCList.ForDed[2], L, IndexPool
MCList.ForDed[3], L, IndexPool
MCList.ForDed[4], L, IndexPool
MCList.ForDed[5], L, IndexPool
MCList.ForDed[6], L, IndexPool
MCList.ForDed[7], L, IndexPool
P_MCList.inBonus(MCList.MCode, Memo.ud_mb(), 0), L, IndexPool
P_MCList.inBonus(MCList.MCode, Memo.ud_mb(), 1), L, IndexPool
P_MCList.inBonus(MCList.MCode, Memo.ud_mb(), 2), L, IndexPool
P_MCList.inBonus(MCList.MCode, Memo.ud_mb(), 3), L, IndexPool
P_MCList.inBonus(MCList.MCode, Memo.ud_mb(), 4), L, IndexPool
P_MCList.inBonus(MCList.MCode, Memo.ud_mb(), 5), L, IndexPool
MCList.InSign[00], L, IndexPool
MCList.InSign[01], L, IndexPool
MCList.InSign[02], L, IndexPool
MCList.InSign[05], L, IndexPool
MCList.InSign[09], L, IndexPool
MCList.InSign[10], L, IndexPool
P_MCList.a2ii_Attitude(MCList.MCode, Memo.ud_mb()), L, "|-|"
Geta2sf_Attitude(), L, "|-||"
@
|###|################################|#####|## ################################|#####| # | # | # |###| # | # | # | # | # | # | # | # | # | # | # | # | # | # | # | # | # | # | # | # | # | # |
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================================================================================================
}
*)

 PRIVATE PROCEDURE MakeMCTypPart(_MCTyp: LIKE(MCList.MCTyp));
 BEGIN
  SELECT(MCList, MCode);
  WHILE OCCURE(MCList) DO
   IF L_DatTim.IsActive(L_DatTim.Per(Memo.ud_cd()), MCList.Begin, MCList.Till) & (MCList.MCTyp = _MCTyp) THEN
    PROMPT(MCList.MCTyp + " " + MCList.MCode);
    CONFORM(MCList, MCGroup);
    MAKEPART(R, Line);
   END;
   NEXT(MCList);
  END; (* WHILE OCCURE(MCList) ... *)
 END {MakeMCTypPart};

 PUBLIC PROCEDURE MCLST();
  CONST
   RepName = "MCLST";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  MAKEPART(R, SubTop, " ᫥");
  MakeMCTypPart(L_PRoll.mct_Credit);
  MAKEPART(R, SubTop, " 㤥ঠ");
  MakeMCTypPart(L_PRoll.mct_Debit);
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {MCLST};

 PRIVATE PROCEDURE MCList_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "MCListE");
 END {MCList_OnInitializeWindow};

 PRIVATE PROCEDURE MCListE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit, L_WDO.e_OnAfterInsert, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, "MCList.Begin");
  L_WDO.iUnmodifiable(0, ["MCList.InSign[5]", "MCList.InSign[1]", "MCList.ForDed[2]", "MCList.Index[1]"]);
  L_WDO.iMayBeEmpty  (0, ["MCList.ProtIn[0]", "MCList.ProtIn[1]", "MCList.Till"]);
  L_WDO.iEvents      (1, L_WDO.e_OnSetSubwindow);
  L_WDO.iProgs       (1, "ObjPro");
 END {MCListE_OnInitializeWindow};

 PRIVATE PROCEDURE CheckRequiredProperty(VAR Msg: STRING[]);
  VAR
   _EndDate: DATE;
 BEGIN
  SELECT(Property, PropObj, , L_Prop.MCProObj);
  WHILE OCCURE(Property) DO
   IF IsRequiredProperty(Property.Property) & (Property.Begin < MCList.Till) THEN
    crp_CheckOne(Property.Property, Math.Max(MCList.Begin, Property.Begin), EMPTYOF(DATE), Msg);
   END;
   NEXT(Property);
  END; (* WHILE OCCURE(Property) ... *)
 END {CheckRequiredProperty};

 PRIVATE PROCEDURE ocStr(trgOwnCode: LIKE(TaxAdv.OwnCode)): STRING[];
 BEGIN
  RETURN Str.Align("'"+L_Str.PoolItem(L_Tax.Tax2001__oc_Pool, trgOwnCode)+"'", 40, LEFT);
 END {ocStr};

 PRIVATE PROCEDURE MCList_Check();
  VAR
   Msg      : STRING[];
   curA2SFee: P_MCList.tAttitude2SFee;
   OnDate   : DATE;
 BEGIN
  L_PRoll.CheckMCListDistr(1);
  SETEMPTY(Msg);
  CheckRequiredProperty(Msg);
  IF ~!Msg THEN
   L_General.Error(Msg);
  END;
  OnDate:=Math.Max(SYSDATE(), MCList.Begin);
  curA2SFee:=P_MCList.a2sf_Attitude(MCList.MCode, OnDate);
  IF curA2SFee = P_MCList.a2sf_LimitedTaxable THEN
   curA2SFee:=P_MCList.a2sf_Taxable;
  END;
  IF curA2SFee # P_MCList.a2ii_Attitude(MCList.MCode, OnDate) THEN
   L_StdFrm.CrucialChoice("⭮襭    ᠬ ' ࠢ⨧'" +
                          "    " + L_DatTim.DateStr(OnDate), L_APtm.g_PayRoll);
  END;
  L_Tax.Tax2001_InitCodes(OnDate);
  CONFORM(MCList, TaxAdv);
  IF MCList.MCTyp = L_PRoll.mct_Credit THEN
   IF ~((TaxAdv.OwnCode = L_Tax.Tax2001__oc_XXXXX) | (TaxAdv.OwnCode = L_Tax.Tax2001__oc_NoTxd) |
        (TaxAdv.OwnCode = L_Tax.Tax2001__oc_NoInc) | (L_Tax.Tax_TaxAdv_Type() = L_Tax.Tax2001_mt_Inc)) THEN
    L_StdFrm.WrongDB("  ᫥ ᪠ ⮫쪮  :"+
                     "|"+ocStr(L_Tax.Tax2001__oc_XXXXX)+", "+
                     "|"+ocStr(L_Tax.Tax2001__oc_NoTxd)+", "+
                     "|"+ocStr(L_Tax.Tax2001__oc_NoInc)+", "+
                     "|' 室 '");
   END;
   IF (TaxAdv.OwnCode = L_Tax.Tax2001__oc_IsMNS) & (TaxAdv.VCode = L_Tax.Tax2001_PureIncomVCode) THEN
    L_StdFrm.WrongDB(" 筮 ࠡ⭮  ᫥ ଫ  :"+
                     "|"+ocStr(L_Tax.Tax2001__oc_XXXXX));
   END;
  ELSE
   IF ~((TaxAdv.OwnCode = L_Tax.Tax2001__oc_NoInc) | (TaxAdv.OwnCode = L_Tax.Tax2001__oc_CYTax)) THEN
    L_StdFrm.WrongDB("  㤥ঠ ᪠ ⮫쪮  :"+
                     "|"+ocStr(L_Tax.Tax2001__oc_NoInc)+" "+
                     "|"+ocStr(L_Tax.Tax2001__oc_CYTax));
   END;
  END;
 END {MCList_Check};

 PRIVATE PROCEDURE MCList_OnAfterEdit();
 BEGIN
  MCList_Check();
  L_DBD.CheckValidity("MCList");
  IF SELECT(Money, MCode, MCList.MCode) THEN
   IF ~L_General.IsLegalRecordModification("MCList", "Till") | SRCINSEL(Money, GE, P_MCList.oldestModificated) THEN
    IF L_APtm.MonthIsClosed(Money.Closed, L_APtm.system_Salary) THEN
     L_StdFrm.CrucialChoice(" ᠭ  /  ᫮|"+
                            "  ⢥ ᫥⢨   ࠡ⭮ .|"+
                            ", 室 ନ   ", L_APtm.g_PayRoll);
    END;
   END;
  END;
 END {MCList_OnAfterEdit};

 PRIVATE PROCEDURE intMakeCopy(srcMCode: LIKE(MCList.MCode));
 BEGIN
  L_DBD.CopyFromSrcRecord("MCList", srcMCode);
  REPLACE(MCList);
 END {intMakeCopy};

 PRIVATE PROCEDURE MCList_OnBeforeInsert();
  VAR
   srcMCode: LIKE(MCList.MCode);
 BEGIN
  P_MCList.oldestModificated:=MAXOF(DATE);
  srcMCode:=L_WDO.GetInsertionSource();
  IF ~!srcMCode THEN
   intMakeCopy(srcMCode);
  END;
 END {MCList_OnBeforeInsert};

 PRIVATE PROCEDURE MCList_OnBeforeEdit();
 BEGIN
  P_MCList.oldestModificated:=MAXOF(DATE);
 END {MCList_OnBeforeEdit};

 PRIVATE PROCEDURE MCList_OnAfterInsert();
 BEGIN
  MCList_Check();
  L_DBD.CheckValidity("MCList");
 END {MCList_OnAfterInsert};

 PRIVATE PROCEDURE MCListE_0_OnReposition();
 BEGIN
  CALL(ObjPro.UpdateCurObjectVal2Show("MCList", "MCPro"));
  RTI.Get().CurZone.Fields("MCList.DstMode").Modifiable:=~L_PRoll.UseSalDSet();
  RTI.Get().CurZone.Fields("MCList.AcCut"  ).Modifiable:=~L_PRoll.UseSalDSet();
 END {MCListE_0_OnReposition};

 PUBLIC PROCEDURE MakeCopy();
 BEGIN
  ACCESS(MCList);
  L_WDO.LaunchInsertBySource(MCList.MCode, "");
 END {MakeCopy};

 PRIVATE PROCEDURE IsRequiredProperty(_Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN (_Property = P_MCList.P_Attitude2SFee) | (_Property = P_MCList.P_Attitude2IInj);
 END {IsRequiredProperty};

 PUBLIC PROCEDURE InsertRequiredProperty(Strong: SCAL[2]);
  VAR
   PropDate : DATE;
 BEGIN
  L_General.Assert(~!MCList.MCode, "   ");
  IF ~!MCList.Begin THEN
   SELECT(Property, PropObj, , L_Prop.MCProObj);
   WHILE OCCURE(Property) DO
    IF IsRequiredProperty(Property.Property) & ~SELECT(MCPro, MCode, MCList.MCode, Property.Property) THEN
     P_MCList.InsertProperty(1, MCList.MCode, Math.Max(MCList.Begin, Property.Begin), Property.Property, "",
                             "", "", EMPTYOF(DATE), EMPTYOF(DATE));
    END;
    NEXT(Property);
   END; (* WHILE OCCURE(Property) ... *)
  ELSE
   L_General.Assert(~Strong, "   砫 ਬ ");
  END;
 END {InsertRequiredProperty};

 PRIVATE PROCEDURE CheckMCProIsFirst(oldDate: DATE; Text: STRING[]);
  VAR
   _Property: LIKE(Property.Property);
 BEGIN
  _Property:=MCPro.Property;
  SAVE(MCPro);
  L_General.Assert(~PREV(MCPro), "  ᢮⢠ " + _Property + "  " + L_DatTim.DateStr(oldDate) +
                                 " :|" + Text);
  RESTORE(MCPro);
 END {CheckMCProIsFirst};

 PRIVATE PROCEDURE crp_CheckOne(    _Property: LIKE(MCPro.Property);
                                    _Date,
                                    _EndDate : DATE;
                                VAR Msg      : STRING[]);
  VAR
   EndDate: DATE;
 BEGIN
  SETSEL(MCPro, MCode, MCList.MCode, _Property);
  IF ~SRCINSEL(MCPro, LE, _Date) | !MCPro.Value THEN
   Msg:=L_Str.AddStrDlm(Msg, "|") +
        "  । ᢮⢮ " + _Property + "  " + L_DatTim.DateStr(_Date);
  END;
  WHILE OCCURE(MCPro) & (MCPro.EndDate < _EndDate) DO
   EndDate:=MCPro.EndDate;
   IF ~NEXT(MCPro) | !MCPro.Value | (MCPro.Date > (EndDate + 1)) THEN
    Msg:=L_Str.AddStrDlm(Msg, "|") +
         "  । ᢮⢮ " + _Property + "  " + L_DatTim.DateStr(EndDate + 1);
   END;
  END;
 END {crp_CheckOne};

 PRIVATE PROCEDURE MCList_Begin_OnSuccessfulChange();
  VAR
   srcMCode: LIKE(MCList.MCode);
   srcRI   : LIKE(MCList.RECORDID);
 BEGIN
  srcMCode:=L_WDO.GetInsertionSource();
  IF ~!srcMCode THEN
   IF ~!GE_PVALUE() THEN
    L_StdFrm.Choice(" ᢮⢠  㤠  ⠢ , 㠫  " + L_DatTim.DateStr(MCList.Begin));
    SELECT(MCPro, MCode, , MCList.MCode);
    WHILE OCCURE(MCPro) DO
     L_Prop.RemoveCurrentPro("MCPro");
    END; (* WHILE OCCURE(MCPro) ... *)
   END;
   SAVE(MCList);
   SEARCH(MCList, MCode, , srcMCode);
   srcRI:=MCList.RECORDID;
   RESTORE(MCList);
   L_Prop.CopyProRecords("MCList", srcRI, MCList.RECORDID);
  ELSE
   IF !GE_PVALUE() THEN
    InsertRequiredProperty(1);
   ELSE
    L_Prop.AnyProBeginChange("MCList", GE_PVALUE());
   END;
  END;
 END {MCList_Begin_OnSuccessfulChange};

BEGIN
 L_Events.ExecuteHandler();
END.
