(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose      楢  ꥪ 
%Type        operation
%Specific    SYS
%Modified    16.09.2014 18:46:41 POLAK\Bor
%Environment
*)

 MODULE MCM [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Acnt, L_MathR, L_MDoc, L_AFM, L_APtm, L_AcCut, L_StdFrm,
        Memo, Str, Math, E_Stock, L_Env, L_XObj, L_Stock, P_Firm, L_AcsPnt, L_Fuel;

 TYPE
  tTargetStorageType = SCAL[3];

 CONST
  tst_All    = 0;
  tst_AdvHld = 1;
  tst_exclAH = 2;

 VAR
  curMyFirm : P_Firm.tMyFirm;
  fit_AcCut : LIKE(AcCut.AcCut);
  fit_AvlSum: L_XObj.tSum;
  fit_AvlQnt: L_XObj.tQnt;

 PRIVATE PROCEDURE IsAfterDeadLine(): SCAL[2];
 BEGIN
  RETURN (Memo.gl_mb() >= 01\01\2002) | L_General.IsPolakSpecific();
 END {IsAfterDeadLine};

 PRIVATE PROCEDURE MoneyAmntCir(curSum: L_XObj.tSum; curQnt: L_XObj.tQnt);
 BEGIN
  IF L_XObj.E_DoSecondSide(Memo.gl_mb()) & ((curSum # 0) | (curQnt # 0)) THEN
   L_General.SetupRequired();
  END;
  L_XObj.MakeCir(+1, AcMthL.AcCut, Memo.gl_mb(), AcMthL.Apport, AcMthL.AcCut2, curSum, curQnt, L_XObj.src_Math);
 END {MoneyAmntCir};

 PROCEDURE ᑠ줮();
  VAR
   curSum: L_XObj.tSum;
   curQnt: L_XObj.tQnt;
 BEGIN
  L_XObj.GetOutRSaldo(AcMthL.AcCut, Memo.gl_mb(), curSum, curQnt);
  MoneyAmntCir(curSum, curQnt);
 END {ᑠ줮};

 PROCEDURE 呠줮();
  VAR
   curSum: L_XObj.tSum;
   curQnt: L_XObj.tQnt;
   Dummy : SCAL[2];
 BEGIN
  L_XObj.GetOutRSaldo(AcMthL.AcCut, L_DatTim.IncMonth(Memo.gl_mb(), -1), curSum, curQnt);
  CONFORM(AcMthL, Apport);
  IF Apport.CirType = L_Acnt.ct_Debit THEN
   curSum:=-curSum;
   curQnt:=-curQnt;
  END;
  L_XObj.MakeCompleteCir(+1, Memo.gl_mb(),
                         XObject.XObject, AcMthL.AcCut,  AcMthL.Apport,  1,
                         XObject.XObject, AcMthL.AcCut2, AcMthL.Apport2, 1,
                         curSum, curQnt, L_XObj.src_Math);
  L_XObj.GetOutRSaldo(AcMthL.AcCut, Memo.gl_mb(), curSum, curQnt);
  IF curSum # 0 THEN
   Dummy:=L_XObj.wrmdxo_ResetDone(Memo.gl_me()+1, 1);
  END;
 END {呠줮};

 PROCEDURE ᑠ줮(); (* ஢  ꥪ  ।⮢ 줮 *)
  VAR
   curSum: L_XObj.tSum;
   curQnt: L_XObj.tQnt;
 BEGIN
  L_XObj.GetOutRSaldo(AcMthL.AcCut, Memo.gl_mb(), curSum, curQnt);
  MoneyAmntCir(-curSum, -curQnt);
 END {ᑠ줮};

 PROCEDURE (); (* ६!  ⢮, ᫨ 㬬 ᠫ줮 = 0 *)
  VAR
   curSum: L_XObj.tSum;
   curQnt: L_XObj.tQnt;
 BEGIN
  L_XObj.GetOutRSaldo(AcMthL.AcCut, Memo.gl_mb(), curSum, curQnt);
  IF (curSum = 0) & (curQnt # 0) THEN
   MoneyAmntCir(0, curQnt);
  END;
 END {};

 PRIVATE PROCEDURE _GetCrdAndSaldo(_PriceGrp: LIKE(AcCut.PriceGrp); VAR _Sld, _Crd: L_XObj.tQnt);
  VAR
   macc    : L_MathR.tMathAcCutCollection;
   curAcCut: LIKE(AcCut.AcCut);
   dmySum  : L_XObj.tSum;
   cutQnt  : L_XObj.tQnt;
 BEGIN
  macc:=L_MathR.GetXObjectAcCutCollection(XObject.XObject);
  FOR_EACH curAcCut IN macc DO
   L_AcCut.PositionOnAcCut(curAcCut);
   IF AcCut.PriceGrp = _PriceGrp THEN
    SELECT(XApport, WFD, , XObject.XObject, curAcCut, Memo.gl_mb());
    WHILE OCCURE(XApport) DO
     IF XApport.AcCut2 # XApport.AcCut (* *) THEN
      CONFORM(XApport, Apport);
      IF (Apport.CirType = L_Acnt.ct_Credit) &
         ((Apport.CirKind = L_Acnt.ck_EstimatedCir) | (Apport.CirKind = L_Acnt.ck_SpecialCir)) THEN
       INC(_Crd, XApport.Qnt);
      END;
     END;
     NEXT(XApport);
    END; (* WHILE OCCURE(XApport) ... *)
    L_XObj.GetOutRSaldo(curAcCut, Memo.gl_mb())), dmySum, curQnt);
    INC(_Sld, curQnt);
   END;
  END; (* FOR_EACH curAcCut IN macc ... *)
 END {_GetCrdAndSaldo};

 PROCEDURE ⮨();
  VAR
   macc     : L_MathR.tMathAcCutCollection;
   curAcCut : LIKE(AcCut.AcCut);
   _PriceGrp: LIKE(AcCut.PriceGrp);
   sldSum   : L_XObj.tSum;
   sldQnt   : L_XObj.tQnt;
   _Sld,
   _Crd     : L_XObj.tQnt;
 BEGIN
  SAVE(mItem);
  SEARCH(mItem, XObject, , XObject.XObject);
  IF mItem.Storage = L_Stock.zeroStorage THEN
   macc:=L_MathR.GetXObjectAcCutCollection(XObject.XObject);
   FOR_EACH curAcCut IN macc DO
    _PriceGrp:=E_Stock.TaxAcCutsPriceGrp(Memo.gl_mb(), curAcCut);
    IF ~!_PriceGrp THEN
     L_XObj.GetOutRSaldo(curAcCut, Memo.gl_mb(), sldSum, sldQnt);
     IF sldSum # 0 THEN
      _Sld:=0;
      _Crd:=0;
      SAVE(XObject);
      SELECT(mItem, Math, , Math.Math);
      WHILE OCCURE(mItem) DO
       CONFORM(mItem, Storage);
       IF Storage.Type = L_Stock.st_Stock THEN
        CONFORM(mItem, XObject);
        _GetCrdAndSaldo(_PriceGrp, _Sld, _Crd);
       END;
       NEXT(mItem);
      END; (* WHILE OCCURE(mItem) ... *)
      RESTORE(XObject);
      IF _Sld # 0 THEN
       sldSum:=sldSum*_Crd/(_Sld+_Crd);
      END;
      L_XObj.MakeCir(+1, curAcCut, Memo.gl_mb(), AcMthL.Apport, AcMthL.AcCut2, sldSum, sldQnt, L_XObj.src_Math);
     END;
    END;
   END; (* FOR_EACH curAcCut IN macc ... *)
  END;
  RESTORE(mItem);
 END {⮨};

 PROCEDURE WalkRoundMath(_MyFirm: P_Firm.tMyFirm; Proc: PROC[]; tst: tTargetStorageType; everyXCalc: SCAL[2]);
  VAR
   _AcCut: LIKE(AcCut.AcCut);
 BEGIN
  IF ~!_MyFirm THEN
   SELECT(_mItm, _mItm, , _MyFirm);
  ELSE
   SELECT(_mItm, _mItm);
  END;
  WHILE OCCURE(_mItm) DO
   IF (tst = tst_All) |
      ((tst = tst_AdvHld) & (_mItm.StorageType = L_Stock.st_AdvHolder)) |
      ((tst = tst_exclAH) & (_mItm.StorageType # L_Stock.st_AdvHolder))  THEN
    SEARCH(XObject, XObject, , _mItm.XObject);
    IF everyXCalc THEN
     SELECT(XCalc, XObject, , XObject.XObject);
     WHILE OCCURE(XCalc) DO _AcCut:=XCalc.AcCut;
      IF L_XObj.SrcXCalc(_AcCut, Memo.gl_mb()) THEN
       Proc();
      END; (* IF OCCURE(XCalc) ... *)
      IF LAST(XCalc) THEN
       CHANGESEL(XCalc, XObject, , XCalc.XObject);
       NEXT(XCalc);
      ELSE
       SETSEL(XCalc, XObject, XObject.XObject);
       SRCINSEL(XCalc, GT, , _AcCut);
      END;
     END; (* WHILE OCCURE(XCalc) ... *)
    ELSE
     Proc();
    END;
   END;
   NEXT(_mItm);
  END; (* WHILE OCCURE(mItm) ... *)
 END {WalkRoundMath};

 PROCEDURE wrm_byXObject(Proc: PROC; tst: tTargetStorageType);
 BEGIN
  WalkRoundMath(curMyFirm, Proc, tst, 0);
 END {wrm_byXObject};

 PROCEDURE wrm_byXCalc(Proc: PROC; tst: tTargetStorageType);
 BEGIN
  WalkRoundMath(curMyFirm, Proc, tst, 1);
 END {wrm_byXCalc};

 PROCEDURE wrm_byAllMyFirmXCalc(Proc: PROC; tst: tTargetStorageType);
 BEGIN
  WalkRoundMath(L_General.EMPTY_NUMBER(), Proc, tst, 1);
 END {wrm_byAllMyFirmXCalc};

 PROCEDURE Prepare_mItm();
  VAR
   DoIt: SCAL[2];
 BEGIN
  SELECT(mItem, Math, , Math.Math);
  WHILE OCCURE(mItem) DO
   PROMPT("⮢  " + mItem.Storage);
   CONFORM(mItem, Storage);
   CONFORM(mItem, XObject);
   DoIt:=0;
   SELECT(XCalc, XObject, , XObject.XObject);
   WHILE OCCURE(XCalc) & ~DoIt DO
    DoIt:=DoIt | L_XObj.SrcXCalc(XCalc.AcCut, Memo.gl_mb());
    LAST(XCalc);
    CHANGESEL(XCalc, XObject, , XCalc.XObject);
    NEXT(XCalc);
   END; (* WHILE OCCURE(XCalc) ... *)
   IF DoIt THEN
    _mItm.MyFirm     :=Storage.MyFirm;
    _mItm.StorageType:=Storage.Type;
    _mItm.XObject    :=XObject.XObject;
    INSERT(_mItm);
   END;
   NEXT(mItem);
  END; (* WHILE OCCURE(mItem) ... *)
 END {Prepare_mItm};

 PROCEDURE GetAvl(inAH: SCAL[2];
                  VAR AvlSum: L_XObj.tSum;
                  VAR AvlQnt: L_XObj.tQnt;
                  VAR AvPSum: L_XObj.tSum;
                  VAR AvPQnt: L_XObj.tQnt);
 BEGIN
  AvlSum:=XCalc.RSlSum; AvPSum:=AvlSum;
  AvlQnt:=XCalc.RSlQnt; AvPQnt:=AvlQnt;
  SETSEL(XApport, XObject, XCalc.XObject, XCalc.AcCut);
  SRCINSEL(XApport, GE, , XCalc.XDat);
  WHILE OCCURE(XApport) DO
   IF L_DatTim.Per(XApport.WFDate) = Memo.gl_mb() THEN
    CONFORM(XApport, Apport);
    IF Apport.CirType = L_Acnt.ct_Debit THEN
     IF (Apport.CirKind = L_Acnt.ck_ExplicitCir) |
        (inAH & ((Apport.CirKind = L_Acnt.ck_SpecialCir) |
                 (Apport.Apport = ah_EDApport          ))) THEN
      IF ~!XApport.Sum THEN
       XApport.Sum:=L_General.UnDenominate(XApport.XDat, XApport.WFDate, XApport.Sum);
       INC(AvlSum, XApport.Sum);
       INC(AvlQnt, XApport.Qnt);
       IF XApport.Qnt > 0 THEN
        INC(AvPSum, XApport.Sum);
        INC(AvPQnt, XApport.Qnt);
       END;
      END;
     END;
    END;
   END;
   NEXT(XApport);
  END; (* WHILE OCCURE(XApport) ... *)
 END {GetAvl};

 PROCEDURE E_DoEstimateXDocApr(P: DATE; trgAcCut: LIKE(AcCut.AcCut)): SCAL[2];
 BEGIN
  IF    trgAcCut = fit_AcCut THEN
   RETURN L_Fuel.E_DoJDocByRWayS(P);
  ELSIF (P >= 01\07\2014) THEN
   RETURN ~L_Acnt.E_SetMathPriceOnline(P);
  ELSE
   IF ((L_General.GetAPSiteNumber() = 55) & (P >= 01\08\2009)) |
      ((L_General.GetAPSiteNumber() = 26) & (P >= 01\07\2010)) |
      ((L_General.GetAPSiteNumber() = 21) & (P >= 01\01\2011)) THEN
    RETURN 1;
   END;
  END;
  RETURN 0;
 END {E_DoEstimateXDocApr};

 PROCEDURE PutCirInCurrentXApport(curSum: L_XObj.tSum);
  VAR
   _Source: LIKE(XApport.Source);
 BEGIN
  IF (curSum # XApport.Sum) THEN
   IF L_DatTim.Per(XApport.XDat) >= L_MathR.MClcPer(Math.MathKind) THEN
    XApport.Sum:=curSum;
    REPLACE(XApport);
   ELSE
    DEC(curSum, XApport.Sum);
    IF E_DoEstimateXDocApr(XApport.XDat, XApport.AcCut) & L_Acnt.E_DoXDocAprOfSpecifiedSource(XApport.XDat, XApport.Source) THEN
     _Source:=L_XObj.src_MathRevision;
    ELSE
     _Source:=L_XObj.src_Math;
    END;
    L_XObj.AddOldXApport(curSum, 0, _Source);
   END;
  END;
 END {PutCirInCurrentXApport};

(*-------------⠪஢ -----------------------------*)

 VAR
  ah_NextRule : LIKE(Rule.Rule);
  ah_curCirSum,
  ah_curRstSum: L_XObj.tSum;
  ah_curCirQnt,
  ah_curRstQnt: L_XObj.tQnt;
  ah_curAcCut : LIKE(AcCut.AcCut);
  AdvHldMACC  : L_MathR.tMathAcCutCollection;
  ah_ECApport,
  ah_EDApport : LIKE(Apport.Apport);

 PROCEDURE EstimateCurrentXApport(PutIt: SCAL[2];
                                  VAR curSum: L_XObj.tSum;
                                  VAR curQnt: L_XObj.tQnt;
                                  VAR rstSum: L_XObj.tSum;
                                  VAR rstQnt: L_XObj.tQnt;
                                  totSum: L_XObj.tSum;
                                  totQnt: L_XObj.tQnt);
 BEGIN
  curSum:=XApport.Sum;
  curQnt:=XApport.Qnt;
  DEC(rstQnt, curQnt);
  IF rstQnt = 0 THEN
   curSum:=rstSum;
  ELSIF (rstQnt < 0) & (totQnt = 0) THEN
   curSum:=0; (* 室  "-" - Assert  *)
  ELSIF totQnt # 0 THEN
   curSum:=L_XObj.RoundXObject(curQnt * totSum / totQnt);
  ELSE
   L_General.Assert(~PutIt | (curQnt = 0), "襭 ");
   curSum:=0;
  END;
  DEC(rstSum, curSum);
  IF PutIt THEN
   PutCirInCurrentXApport(curSum);
  END;
 END {EstimateCurrentXApport};

 PROCEDURE ah_Gather();
 BEGIN
  SETSEL(XCalc, XObject, XObject.XObject, AcMthL.AcCut);
  IF SRCINSEL(XCalc, GE, Memo.gl_mb()) THEN
   WHILE OCCURE(XCalc) & (L_DatTim.Per(XCalc.XDat)<=L_MathR.MClcPer(Math.MathKind)) DO
    IF IsAfterDeadLine() & (AcMthL.AcCut2 = L_Acnt.fictAcCut) THEN
     SELECT(XApport, XObject, , XCalc.XObject, XCalc.AcCut, XCalc.XDat, AcMthL.Apport);
    ELSE
     SELECT(XApport, XObject, , XCalc.XObject, XCalc.AcCut, XCalc.XDat, AcMthL.Apport, AcMthL.AcCut2);
    END;
    WHILE OCCURE(XApport) DO
     IF L_DatTim.Per(XApport.WFDate) = Memo.gl_mb() THEN
      XApport.Sum:=L_General.UnDenominate(XCalc.XDat, Memo.gl_mb(), XApport.Sum);
      INC(ah_curCirSum, XApport.Sum);
      INC(ah_curCirQnt, XApport.Qnt);
     END;
     NEXT(XApport);
    END; (* WHILE OCCURE(XApport) *)
    NEXT(XCalc);
   END; (* WHILE OCCURE(XCalc) *)
  END;
 END {ah_Gather};

 PROCEDURE ah_Spread();
  VAR
   dmySum: L_XObj.tSum;
   dmyQnt: L_XObj.tQnt;
 BEGIN
  SETSEL(XCalc, XObject, XObject.XObject, AcMthL.AcCut);
  IF SRCINSEL(XCalc, GE, Memo.gl_mb()) THEN
   WHILE OCCURE(XCalc) & (L_DatTim.Per(XCalc.XDat)<=L_MathR.MClcPer(Math.MathKind)) DO
    SELECT(XApport, XObject, , XCalc.XObject, XCalc.AcCut, XCalc.XDat, AcMthL.Apport, AcMthL.AcCut2);
    WHILE OCCURE(XApport) DO
     IF (L_DatTim.Per(XApport.WFDate) = Memo.gl_mb()) &
        (XApport.Source # L_XObj.src_Math) & (XApport.Source # L_XObj.src_MathRevision) THEN
      EstimateCurrentXApport(1, dmySum, dmyQnt, ah_curRstSum, ah_curRstQnt, ah_curCirSum, ah_curCirQnt);
     END;
     NEXT(XApport);
    END; (* WHILE OCCURE(XApport) *)
    NEXT(XCalc);
   END; (* WHILE OCCURE(XCalc) *)
  END;
 END {ah_Spread};

 PROCEDURE int_ahCreditEstimate(trgApport: LIKE(Apport.Apport));
  VAR
   AvlSum,
   DmySum,
   RstSum,
   curSum             : L_XObj.tSum;
   AvlQnt,
   DmyQnt,
   RstQnt,
   curQnt             : L_XObj.tQnt;
   hasUnestimatedDebit: SCAL[2];
   hasTargetApport    : SCAL[2];
 BEGIN
  IF SELECT(XCalc, XObject, XObject.XObject) & L_XObj.SrcXCalc(AcMthL.AcCut, Memo.gl_mb()) THEN
   hasUnestimatedDebit:=0;
   hasTargetApport    :=0;
   GetAvl(1, AvlSum, AvlQnt, DmySum, DmyQnt);
   RstSum:=AvlSum;
   RstQnt:=AvlQnt;
   SETSEL(XApport, XObject, XCalc.XObject, XCalc.AcCut);
   SRCINSEL(XApport, GE, , XCalc.XDat);
   WHILE OCCURE(XApport) DO
    IF (L_DatTim.Per(XApport.WFDate) = Memo.gl_mb()) &
       (XApport.Source # L_XObj.src_Math) & (XApport.Source # L_XObj.src_MathRevision) &
       (XApport.Qnt # 0) THEN
     CONFORM(XApport, Apport);
     IF (Apport.CirType = L_Acnt.ct_Credit) & (Apport.CirKind = L_Acnt.ck_EstimatedCir) THEN

      EstimateCurrentXApport(!trgApport, curSum, curQnt, RstSum, RstQnt, AvlSum, AvlQnt);
      IF XApport.Apport = trgApport THEN
       hasTargetApport:=1;
       INC(ah_curCirSum, curSum);
       INC(ah_curCirQnt, curQnt);
      END;
     ELSIF (Apport.CirType = L_Acnt.ct_Debit) & !XApport.Sum THEN
      hasUnestimatedDebit:=1;
      IF !trgApport THEN
       L_General.Error(" 㤠 業 室  "+L_XObj.ErrorPoint()+L_StdFrm.HR()+
                       " 稭:|"+
                       "1. ୮ ᠭ 奬 権  ᪠  |"+
                       "2. ୮ ᠭ 奬 権 ⠪஢   ");
      END;
     END;
    END;
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
   L_General.Assert(~(hasUnestimatedDebit & hasTargetApport),
                    "⨬ ।  / ⮣,  祭 ।祩  /" +
                    L_XObj.ErrorPoint1(XCalc.AcCut, XCalc.XDat));
   IF !trgApport THEN
    L_General.Assert(RstQnt >= 0,
                     "ᠭ   (/) , 祬 뫮." +
                     "|, ᫥⢨ ୮ ।  /  /" +
                     L_XObj.ErrorPoint1(XCalc.AcCut, XCalc.XDat));
   END;
  END;
 END {int_ahCreditEstimate};

 PROCEDURE ah_CreditEstimate();
 BEGIN
  int_ahCreditEstimate(L_General.EMPTY_NUMBER());
 END {ah_CreditEstimate};

 PROCEDURE ah_PreliminaryExchangeCreditEstimate();
 BEGIN
  int_ahCreditEstimate(ah_ECApport);
 END {ah_PreliminaryExchangeCreditEstimate};

 PROCEDURE ah_TestRulesOrder(Cur, Nxt: LIKE(Rule.Rule); firstRule, wSameAcCut: SCAL[2]);
  CONST
   TaxingError = "襭  ᠭ ⠪஢ ";
 BEGIN
  L_General.Assert((firstRule & !ah_NextRule) | (ah_NextRule = Cur),
                    TaxingError + "| |冷 ᫥ ࠢ. 饥 ࠢ " + Cur);
  L_General.Assert((AcMthL.AcCut=ah_curAcCut) = wSameAcCut,
                   TaxingError + "| |  ࠧ१  ஢  ࠢ " + Cur);
  ah_NextRule:=Nxt;
 END {ah_TestRulesOrder};

 PROCEDURE _();
 BEGIN
  ah_TestRulesOrder("_", "", 1, 0);
  SETZERO(ah_curCirSum, ah_curCirQnt);
  wrm_byXObject(PROCREF(ah_Gather), tst_exclAH);
 END {_};

 PROCEDURE ();
 BEGIN
  ah_TestRulesOrder("", "", 0, 1);
  ah_curRstSum:=ah_curCirSum;
  ah_curRstQnt:=ah_curCirQnt;
  wrm_byXObject(PROCREF(ah_Spread), tst_AdvHld);
  L_General.Assert(ah_curRstQnt=0, "୮ ଫ 뤠  ");
 END {};

 PROCEDURE ();
 BEGIN
  ah_TestRulesOrder("", "", 1, 1);
  wrm_byXObject(PROCREF(ah_CreditEstimate), tst_AdvHld);
 END {};

 PROCEDURE _();
 BEGIN
  ah_TestRulesOrder("_", "_", 1, 1);
  ah_ECApport:=AcMthL.Apport;
  SETZERO(ah_curCirSum, ah_curCirQnt);
  wrm_byXObject(PROCREF(ah_PreliminaryExchangeCreditEstimate), tst_AdvHld);
 END {_};

 PROCEDURE _();
 BEGIN
  ah_TestRulesOrder("_", "", 0, 1);
  ah_EDApport:=AcMthL.Apport;
  ah_curRstSum:=ah_curCirSum;
  ah_curRstQnt:=ah_curCirQnt;
  wrm_byXObject(PROCREF(ah_Spread), tst_AdvHld);
  L_General.Assert(ah_curRstQnt=0, "୮ ଫ ।    ");
 END {_};

 PROCEDURE ah_Init();
  VAR
   WillBeAdded  : SCAL[2];
 BEGIN
  WillBeAdded:=0;
  SELECT(XApport, WFD, , XCalc.XObject, XCalc.AcCut, Memo.gl_mb());
  WHILE OCCURE(XApport) DO
   CONFORM(XApport, Apport);
   IF (Apport.CirKind = L_Acnt.ck_EstimatedCir) | (Apport.CirKind = L_Acnt.ck_SpecialCir) THEN
    IF XApport.Qnt # 0 THEN
     WillBeAdded:=1;
    END;
    IF (XApport.Source # L_XObj.src_Math) & (XApport.Source # L_XObj.src_MathRevision) &
       (L_DatTim.Per(XApport.XDat) = L_MathR.MClcPer(Math.MathKind)) THEN
     IF XApport.Qnt # 0 THEN
      SETEMPTY(XApport.Sum);
     ELSE
      SETZERO(XApport.Sum);
     END;
     REPLACE(XApport);
    END;
   END;
   NEXT(XApport);
  END; (* WHILE OCCURE(XApport) ... *)
  IF WillBeAdded THEN
   L_MathR.macc_Put(XCalc.AcCut, AdvHldMACC);
  END;
 END {ah_Init};

(*-------------砭 ⠪஢ -------------------*)

 PROCEDURE SimpleProceed();
 BEGIN
  ^AcMthL.Rule();
 END {SimpleProceed};

 PROCEDURE CalcAvePrice(WholePriceGroup: SCAL[2];
                        VAR _Price: FLOAT;
                        VAR RstSum: L_XObj.tSum;
                        VAR RstQnt: L_XObj.tQnt);
  VAR
   RpcSum: L_XObj.tSum;
   RpcQnt: L_XObj.tQnt;
 BEGIN
  SETZERO(RstSum, RstQnt, RpcSum, RpcQnt);
  IF WholePriceGroup THEN
   SELECT(_PrGr, _PrGr, , AcCut.PriceGrp);
  ELSE
   SELECT(_PrGr, _PrGr, , AcCut.PriceGrp, AcCut.AcCut, XCalc.XObject);
  END;
  WHILE OCCURE(_PrGr) DO
   INC(RstSum, _PrGr.AvlSum);
   INC(RstQnt, _PrGr.AvlQnt);
   INC(RpcSum, _PrGr.AvPSum);
   INC(RpcQnt, _PrGr.AvPQnt);
   NEXT(_PrGr);
  END; (* WHILE OCCURE(_PrGr) ... *)
  IF    RstQnt # 0 THEN
   _Price:=RstSum / RstQnt;
  ELSIF RpcQnt > 0 THEN
   _Price:=RpcSum / RpcQnt;
  ELSE
   SETEMPTY(_Price);
  END;
 END {CalcAvePrice};

 PROCEDURE PutAdjustmentOfPrice(_PriceGrp: LIKE(AcCut.PriceGrp);
                                _AcCut   : LIKE(AcCut.AcCut);
                                _XObject : LIKE(XObject.XObject);
                                _XDat    : DATE;
                                _Sum     : L_XObj.tSum);
 BEGIN
  IF _Sum # 0 THEN
   SAVE(XCalc);
   SAVE(XObject);
   SEARCH(XObject, XObject, , _XObject);
   L_XObj.mo_MakeCir(+1, _AcCut, _XDat,
                     L_Acnt.E_Apport_AdjustmentOfPrices(_XDat),
                     L_Acnt.E_AcCut_AdjustmentOfPrices(_XDat),
                     _Sum, L_XObj.src_Math);
   RESTORE(XObject);
   RESTORE(XCalc);
   SAVE(_PrGr);
   SEARCH(_PrGr, _PrGr, , _PriceGrp, _AcCut, _XObject);
   _PrGr.aopSum:=_Sum;
   REPLACE(_PrGr);
   RESTORE(_PrGr);
  END;
 END {PutAdjustmentOfPrice};

 VAR
  PricePG: FLOAT; (* 0085905 쭠  㦤 EstimateXDocApr *)

 PROCEDURE PutAvePrice();
  VAR
   PriceAC    : FLOAT;
   RstPGSum,
   RstACSum,
   AvlACSum,
   curSum     : L_XObj.tSum;
   RstPGQnt,
   RstACQnt,
   AvlACQnt,
   curQnt     : L_XObj.tQnt;
 BEGIN
  CalcAvePrice(1, PricePG, RstPGSum, RstPGQnt);
  CalcAvePrice(0, PriceAC, RstACSum, RstACQnt);
  IF !PriceAC THEN
   PriceAC:=PricePG;
  END;
  AvlACSum:=XCalc.RSlSum;
  AvlACQnt:=XCalc.RSlQnt;
  SAVE(XCalc);
  CHANGESEL(XCalc, XObject, , XCalc.XObject, XCalc.AcCut);
  SRCINSEL(XCalc, GE, , Memo.gl_mb());
  WHILE OCCURE(XCalc) & (L_DatTim.Per(XCalc.XDat) <= L_MathR.MClcPer(Math.MathKind)) DO
   CONFORM(XCalc, XApport);
   WHILE OCCURE(XApport) DO
    IF (L_DatTim.Per(XApport.WFDate) = Memo.gl_mb()) &
       (XApport.Source # L_XObj.src_Math) & (XApport.Source # L_XObj.src_MathRevision) THEN
     CONFORM(XApport, Apport);
     curSum:=XApport.Sum;
     curQnt:=XApport.Qnt;
     IF (Apport.CirKind = L_Acnt.ck_EstimatedCir) THEN
      IF !PricePG & (curQnt # 0) THEN
       IF (L_DatTim.Per(XCalc.XDat) < L_MathR.MClcPer(Math.MathKind)) & (curSum # 0) THEN
        PricePG:=curSum / curQnt;
        PriceAC:=PricePG;
       END;
      END;
      IF ~!PricePG THEN
       curSum:=L_XObj.RoundXObject(curQnt*PricePG);
      ELSE
       L_XObj.CheckXCalcIncorrectMonthOpen();
       L_General.Assert(RstPGSum=0, "稥 ⮨  ⢨ ⢠"+L_XObj.ErrorPoint());
       L_General.Assert(curQnt=0, " ᠫ줮  室   業  業 ⮢  । "+L_XObj.ErrorPoint());
       curSum:=0;
      END; (* IF ~!Price ... *)
      curSum:=L_General.Denominate(XApport.WFDate, XCalc.XDat, curSum);
     ELSIF Apport.CirType = L_Acnt.ct_Debit THEN
      INC(AvlACSum, XApport.Sum);
      INC(AvlACQnt, XApport.Qnt);
     END; (* IF Apport.CirKind ... *)
     PutCirInCurrentXApport(curSum);
    END;
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
   NEXT(XCalc);
  END; (* WHILE OCCURE(XCalc) *)
  RESTORE(XCalc);
  IF (AvlACQnt # 0) & (PricePG # PriceAC) THEN
   PutAdjustmentOfPrice(AcCut.PriceGrp, AcCut.AcCut, XCalc.XObject, XCalc.XDat,
                        -(AvlACQnt * (PricePG-PriceAC)));
  END;
 END {PutAvePrice};

 PROCEDURE CheckAdjustmentOfPrice();
  VAR
   pgTotal   : L_XObj.tSum;
   maxValue  : L_XObj.tSum;
   maxAcCut  : LIKE(AcCut.AcCut);
   maxXObject: LIKE(XObject.XObject);
 BEGIN
  SELECT(_PrGr, _PrGr);
  WHILE OCCURE(_PrGr) DO
   NARROWSEL(_PrGr, _PrGr);
   SETZERO(pgTotal, maxValue);
   WHILE OCCURE(_PrGr) DO
    IF Math.Abs(_PrGr.aopSum) > maxValue THEN
     maxAcCut  :=_PrGr._AcCut;
     maxXObject:=_PrGr._XObject;
     maxValue:=Math.Abs(_PrGr.aopSum);
    END;
    INC(pgTotal, _PrGr.aopSum);
    NEXT(_PrGr);
   END;
   LAST(_PrGr);
   IF pgTotal # 0 THEN
    PutAdjustmentOfPrice(_PrGr._PrGr, maxAcCut, maxXObject, Memo.gl_mb(), -pgTotal);
   END;
   NEXTINEXTENDEDSEL(_PrGr, _PrGr);
  END; (* WHILE OCCURE(_PrGr) ... *)
 END {CheckAdjustmentOfPrice};

 PROCEDURE GetAvePrice();
  VAR
   AvlSum,
   AvPSum: L_XObj.tSum;
   AvlQnt,
   AvPQnt: L_XObj.tQnt;
 BEGIN
  CONFORM(XCalc, AcCut);
  IF AcCut.PriceGrp # 00 THEN
   GetAvl(0, AvlSum, AvlQnt, AvPSum, AvPQnt);
   ADD(_PrGr, _PrGr, , AcCut.PriceGrp, XCalc.AcCut, XCalc.XObject,
       _PrGr.AvlSum, AvlSum,
       _PrGr.AvlQnt, AvlQnt,
       _PrGr.AvPSum, AvPSum,
       _PrGr.AvPQnt, AvPQnt);
  END;
 END {GetAvePrice};

 PROCEDURE SetAvePrice();
 BEGIN
  CONFORM(XCalc, AcCut);
  IF (AcCut.PriceGrp # 00) THEN
   PutAvePrice();
  END;
  L_XObj.intRenXCalc(0); (* 01.10.2002 17:12:47 POLAK\SAN . 21810 *)
 END {SetAvePrice};

 PROCEDURE GetFuelInTankPrice();
 BEGIN
  IF XCalc.AcCut = fit_AcCut THEN
   fit_AvlSum:=XCalc.RSlSum;
   fit_AvlQnt:=XCalc.RSlQnt;
   SETSEL(XApport, XObject, XCalc.XObject, XCalc.AcCut);
   SRCINSEL(XApport, GE, , XCalc.XDat);
   WHILE OCCURE(XApport) DO
    IF L_DatTim.Per(XApport.WFDate) = Memo.gl_mb() THEN
     IF (XApport.Source # L_XObj.src_RWayS) & (XApport.Source # L_XObj.src_JDoc) THEN
      L_XObj.AddXA2Saldo(fit_AvlSum, fit_AvlQnt, +1);
     END;
    END;
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
  END;
 END {GetFuelInTankPrice};

 PROCEDURE SetFuelInTankPrice();
  VAR
   curSum: L_XObj.tSum;
   curQnt: L_XObj.tQnt;
 BEGIN
  IF XCalc.AcCut = fit_AcCut THEN
   SAVE(XCalc);
   CHANGESEL(XCalc, XObject, , XCalc.XObject, XCalc.AcCut);
   SRCINSEL(XCalc, GE, , Memo.gl_mb());
   WHILE OCCURE(XCalc) & (L_DatTim.Per(XCalc.XDat) <= L_MathR.MClcPer(Math.MathKind)) DO
    CONFORM(XCalc, XApport);
    WHILE OCCURE(XApport) DO
     IF (L_DatTim.Per(XApport.WFDate) = Memo.gl_mb()) &
         ((XApport.Source = L_XObj.src_RWayS) | (XApport.Source = L_XObj.src_JDoc)) THEN
      IF XApport.Qnt # 0 THEN
       curSum:=XApport.Sum;
       curQnt:=XApport.Qnt;
       L_General.Assert(fit_AvlQnt#0, "  ᯫ樨 -  । । 業");
       curSum:=L_XObj.RoundXObject(curQnt*(fit_AvlSum/fit_AvlQnt));
       curSum:=L_General.Denominate(XApport.WFDate, XCalc.XDat, curSum);
       PutCirInCurrentXApport(curSum);
      END;
     END;
     NEXT(XApport);
    END; (* WHILE OCCURE(XApport) ... *)
    NEXT(XCalc);
   END; (* WHILE OCCURE(XCalc) *)
   RESTORE(XCalc);
   L_XObj.RenXCalc(); (* 01.10.2002 17:12:47 POLAK\SAN . 21810 *)
  END;
 END {SetFuelInTankPrice};

 PRIVATE PROCEDURE exa_XObjectNeed(P: DATE; trgXObject: LIKE(XObject.XObject)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF !trgXObject THEN
   Result:=(P >= 01\07\2014);
  ELSE
   SAVE(XObject);
   SEARCH(XObject, XObject, , trgXObject);
   Result:=(XObject.Origin = L_XObj.o_CostItem);
   RESTORE(XObject);
  END;
  RETURN Result;
 END {exa_XObjectNeed};

 PROCEDURE exa_OneSideOfApport(leftSide: SCAL[2];
                               Stage   : SCAL[2];
                               Price   : FLOAT;
                               VAR
                                tQnt: L_XObj.tQnt;
                               VAR
                                tSum: L_XObj.tSum);
  VAR
   curXObject: LIKE(XObject.XObject);
   curAcCut  : LIKE(AcCut.AcCut);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   L_XObj.SelectXDocAprByXApport(leftSide);
   WHILE OCCURE(XDocApr) DO
    PROMPT("業 ⮢  㬥⮬: " + XDocApr.XDocId);
    IF leftSide THEN
     curXObject:=XDocApr.XObject2; curAcCut:=XDocApr.AcCut2;
    ELSE
     curXObject:=XDocApr.XObject;  curAcCut:=XDocApr.AcCut;
    END;
    IF exa_XObjectNeed(XDocApr.WFDate, curXObject) THEN
     IF Stage = 0 THEN
      IF XDocApr.Qnt > 0 THEN
       INC(tQnt, XDocApr.Qnt);
       INC(tSum, XDocApr.Sum);
      END;
     ELSE
      IF ~!curXObject THEN
       SEARCH(XObject, XObject, , curXObject);
       L_XObj.FixXCalc(curAcCut, XDocApr.XDat);
       L_XObj.exa_SingleAddByXDocApr(leftSide, -1);
      END;
      IF (XDocApr.Qnt = tQnt) THEN
       XDocApr.Sum:=tSum;
      ELSE
       XDocApr.Sum:=XDocApr.Qnt * Price;
      END;
      REPLACE(XDocApr);
      IF ~!curXObject THEN
       L_XObj.exa_SingleAddByXDocApr(leftSide, +1);
       REPLACE(XCalc);
       L_XObj.XODone_Set(XCalc.XDat, 0, 1);
      END;
      DEC(tQnt, XDocApr.Qnt);
      DEC(tSum, XDocApr.Sum);
     END;
    END; (* IF exa_XObjectNeed( ... *)
    IF (XDocApr.Sum = 0) & (XDocApr.Qnt = 0) THEN
     REMOVE(XDocApr);
    ELSE
     NEXT(XDocApr);
    END;
   END; (* WHILE OCCURE(XDocApr) ... *)
  EXCEPT
  END; (* TRY *)
 END {exa_OneSideOfApport};

 PROCEDURE exaMR_OneSideOfApport(leftSide: SCAL[2];
                                 Stage   : SCAL[2];
                                 tSum    : L_XObj.tSum;
                                 VAR
                                  rSum: L_XObj.tSum;
                                 VAR
                                  tQnt,
                                  rQnt: L_XObj.tQnt;
                                 VAR
                                  tAmn: NUMERIC[0]);
  VAR
   curXDat   : DATE;
   curSum    : L_XObj.tSum;
   curXObject: LIKE(XObject.XObject);
 BEGIN
  curXDat:=XApport.WFDate;
  WHILE curXDat < XApport.XDat DO
   IF leftSide THEN
    SETSEL(XDocApr, AcCut, XApport.AcCut, curXDat, XApport.XObject, XApport.Apport, XApport.AcCut2, XApport.WFDate);
   ELSE
    SETSEL(XDocApr, AcCut2, XApport.AcCut, curXDat, XApport.XObject, XApport.Apport, XApport.AcCut2, XApport.WFDate);
   END;
   FOR_EACH XDocApr DO
    PROMPT("। ८業  㬥⠬: " + XDocApr.XDocId);
    IF leftSide THEN
     curXObject:=XDocApr.XObject2;
    ELSE
     curXObject:=XDocApr.XObject;
    END;
    IF exa_XObjectNeed(XDocApr.WFDate, curXObject) THEN
     IF XDocApr.Source # L_XObj.src_MathRevision THEN
      IF Stage = 0 THEN
       INC(tQnt, XDocApr.Qnt);
       INC(tAmn, 1);
      ELSE
       IF tAmn = 1 THEN
        curSum:=rSum;
       ELSE
        curSum:=tSum * (XDocApr.Qnt / tQnt);
       END;
       ADD(XDocApr, XDocApr, , XDocApr.XDocId, XApport.XDat, XApport.WFDate,
                               XDocApr.XObject,  XDocApr.AcCut,   XDocApr.Apport,
                               XDocApr.XObject2, XDocApr.AcCut2,  XDocApr.Apport2, 0, XApport.Source,
           XDocApr.Sum, curSum);
       L_XObj.exa_src_MathRevision_MirrorXDocAprSecondSide(leftSide, +1);
       DEC(rSum, curSum);
       DEC(rQnt, XDocApr.Qnt);
       DEC(tAmn);
      END; (* IF Stage = 0 *)
     END; (* IF XDocApr.Source... *)
    END; (* IF exa_XObjectNeed( ... *)
   END; (* FOR_EACH XDocApr ... *)
   curXDat:=L_DatTim.NextPer(curXDat);
  END; (* WHILE curXDat *)
 END {exaMR_OneSideOfApport};

 PROCEDURE EstimateXDocApr();
  VAR
   Price   : FLOAT;
   tQnt,
   rQnt,
   pQnt    : L_XObj.tQnt;
   tSum,
   rSum,
   pSum    : L_XObj.tSum;
   tAmn    : NUMERIC[0];
 BEGIN
  IF E_DoEstimateXDocApr(Memo.gl_mb(), XCalc.AcCut) THEN
   SETSEL(XApport, XObject, XCalc.XObject, XCalc.AcCut);
   SRCINSEL(XApport, GE, , XCalc.XDat);
   WHILE OCCURE(XApport) DO
    IF L_DatTim.Per(XApport.WFDate) = Memo.gl_mb() THEN
     IF L_DatTim.Per(XApport.XDat) >= L_MathR.MClcPer(Math.MathKind) THEN
      IF L_Acnt.E_DoXDocAprOfSpecifiedSource(XApport.WFDate, XApport.Source) THEN
       CONFORM(XApport, Apport);
       tQnt:=XApport.Qnt;
       IF (Apport.CirType = L_Acnt.ct_Credit) & (Apport.CirKind = L_Acnt.ck_EstimatedCir) THEN
        tSum:=XApport.Sum;
        IF  tQnt # 0 THEN
         Price:=tSum / tQnt;
        ELSE
         L_General.CallUs(tSum = 0);
         Price:=0;
         SETZERO(pSum, pQnt);
         exa_OneSideOfApport(0, 0, EMPTYOF(Price), pQnt, pSum);
         exa_OneSideOfApport(1, 0, EMPTYOF(Price), pQnt, pSum);
         IF pQnt # 0 THEN
          Price:=PricePG;
         ELSE
          L_General.CallUs(pSum = 0);
         END;
        END;
        exa_OneSideOfApport(0, 1, Price, tQnt, tSum);
        exa_OneSideOfApport(1, 1, Price, tQnt, tSum);
        IF (tQnt # XApport.Qnt) | (tSum # XApport.Sum) THEN
         L_General.CallUs(tQnt = 0);
         L_General.CallUs(tSum = 0);
        END;
       END;
      ELSIF XApport.Source = L_XObj.src_MathRevision THEN
       CONFORM(XApport, Apport);
       IF (Apport.CirType = L_Acnt.ct_Credit) & (Apport.CirKind = L_Acnt.ck_EstimatedCir) THEN
        L_General.CallUs(XApport.Qnt = 0);
        tSum:=XApport.Sum;
        IF tSum # 0 THEN
         SETZERO(rSum, tQnt, rQnt, tAmn);
         exaMR_OneSideOfApport(0, 0,    0, rSum, tQnt, rQnt, tAmn);
         exaMR_OneSideOfApport(1, 0,    0, rSum, tQnt, rQnt, tAmn);
         rSum:=tSum;
         rQnt:=tQnt;
         exaMR_OneSideOfApport(0, 1, tSum, rSum, tQnt, rQnt, tAmn);
         exaMR_OneSideOfApport(1, 1, tSum, rSum, tQnt, rQnt, tAmn);
         IF (rSum # 0)&(rSum # tSum) | (rQnt # 0) THEN
          L_General.CallUs(0);
         END;
        END;
       END;
      ELSE
       L_General.CallUs(XApport.Source = L_XObj.src_Math);
      END; (* IF XApport.Source ... *)
     END; (* IF L_DatTim.Per(XApport.XDat) ... *)
    END; (* IF L_DatTim.Per(XApport.WFDate) ... *)
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
  END; (* IF XCalc.AcCut # fit_AcCut *)
 END {EstimateXDocApr};

 PROCEDURE Create_TempFiles();
 BEGIN
  IF !DATABASE.Get().Tables("_PrGr") THEN
   CreateFILE(_PrGr, , "稥  業 㯯");
 
   CreateFIELD(_PrGr, _PrGr,    LIKE(AcCut.PriceGrp),  , ,    , " 㯯");
   CreateFIELD(_PrGr, _AcCut,   LIKE(AcCut.AcCut),     , ,    , "१");
   CreateFIELD(_PrGr, _XObject, LIKE(XObject.XObject), , ,    , "ꥪ, 䠪᪨ Storage");
   CreateFIELD(_PrGr, AvlSum,   L_XObj.tSum,           , "0", , " 稨, 㬬");
   CreateFIELD(_PrGr, AvlQnt,   L_XObj.tQnt,           , "0", , " 稨, ⢮");
   CreateFIELD(_PrGr, AvPSum,   L_XObj.tSum,           , "0", , " 稨  ᭮ ⮫쪮 室, 㬬");
   CreateFIELD(_PrGr, AvPQnt,   L_XObj.tQnt,           , "0", , " 稨  ᭮ ⮫쪮 室, ⢮");
   CreateFIELD(_PrGr, aopSum,   L_XObj.tSum,           , "0", , "  ࠭ 業");
 
   CreateINDEX(_PrGr, _PrGr, UNIQUE, , , _PrGr, _AcCut, _XObject);
 
   SetVersionOfFILE(_PrGr, 0000);
  END; (* IF !DATABASE.Get().Tables("_PrGr") ... *)
  L_AFM.CreateTemp("_PrGr");
  L_AFM.MakeIndex("_mItm", "MyFirm     : LIKE(Storage.MyFirm);"+
                           "StorageType: LIKE(Storage.Type);"+
                           "XObject    : LIKE(XObject.XObject)");
 END {Create_TempFiles};

 PRIVATE PROCEDURE Purge_TempFiles();
 BEGIN
  L_AFM.AF_PurgeTemp("_mItm");
  L_AFM.AF_PurgeTemp("_PrGr");
 END {Purge_TempFiles};

 PRIVATE PROCEDURE ProceedPrvMonth(ppmTransaction: NUMERIC[0]);
  VAR
   cur_gl_cd,
   P        : DATE;
 BEGIN
  cur_gl_cd:=Memo.gl_cd();
  P:=L_DatTim.IncMonth(L_DatTim.Per(cur_gl_cd), -1);
  WHILE ~L_MathR.IsMathD_OnDate(P) DO
   P:=L_DatTim.IncMonth(P, -1);
  END;
  TRY
   P:=L_DatTim.IncMonth(P, +1);
   WHILE P < L_DatTim.Per(cur_gl_cd) DO
    Memo.gl_SetCurDate(P);
    TRY [TRANSACTION(ppmTransaction), MSGSUPPRESSIONMODE(MSGSUPPRESS_NONE)]
     intCountMath();
    EXCEPT
    END;
    P:=L_DatTim.IncMonth(P, +1);
   END;
  EXCEPT
  FINALLY
   Memo.gl_SetCurDate(cur_gl_cd);
  END;
 END {ProceedPrvMonth};

 PRIVATE PROCEDURE ClearApport();
  VAR
   SourcesToClear: SCAL[2][MAXOF(L_XObj.tSource)+1];
 BEGIN
  SETZERO(SourcesToClear);
  SourcesToClear[L_XObj.src_Math]        :=1;
  SourcesToClear[L_XObj.src_MathRevision]:=1;
  L_XObj.MultipleClearXApport(L_XObj.SectionOfXObjectAcCut(L_General.EMPTY_NUMBER()), SourcesToClear);
 END {ClearApport};

 PRIVATE PROCEDURE AdditionalTaxing();
 BEGIN
  L_Acnt.ExecAcMth(Memo.gl_mb(), L_MDoc.DG_AdT, 000, Math.MathType, L_MathR.mm_New,
                   1, PROCREF(SimpleProceed), L_General.EMPTY_PROC());
 END {AdditionalTaxing};

 PRIVATE PROCEDURE E_GetMModeForAcCutInUse(_AcCut: LIKE(AcCut.AcCut)): LIKE(MMode.MMode);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Stock.GetMModeForAcCutInUse);
  IF ~!Local THEN
   RETURN Local(Memo.gl_mb(), _AcCut);
  ELSE
   RETURN L_MathR.mm_New;
  END;
 END {E_GetMModeForAcCutInUse};

 PRIVATE PROCEDURE ProceedAdvancedHolder();
  VAR
   curAcCut: LIKE(AcCut.AcCut);
 BEGIN
  SETEMPTY(AdvHldMACC);
  wrm_byXCalc(PROCREF(ah_Init), tst_AdvHld);
  FOR_EACH curAcCut IN AdvHldMACC DO
   IF L_MathR.AcCutOfRealStock(curAcCut) THEN
    ah_curAcCut:=curAcCut;
    SETEMPTY(ah_NextRule, ah_ECApport, ah_EDApport);
    L_Acnt.ExecAcMth(Memo.gl_mb(), L_MDoc.DG_TIU, 000, Math.MathType, E_GetMModeForAcCutInUse(ah_curAcCut),
                     0, PROCREF(SimpleProceed), L_General.EMPTY_PROC());
   END;
  END; (* FOR_EACH curAcCut IN AdvHldMACC ... *)
 END {ProceedAdvancedHolder};

 PRIVATE PROCEDURE intCountMath();
  VAR
   SourcesToClear: SCAL[2][MAXOF(L_XObj.tSource)+1];
 BEGIN
  APP.Get().NewPrompt("   " + Math.Math + "  " + L_DatTim.PeriodStr(Memo.gl_mb()));
  Create_TempFiles();
  Prepare_mItm();

  IF    Math.MathKind = L_MathR.mathk_KeyAs THEN
   L_XDoc.FixACalc("Math", Math.MyFirm, Memo.gl_mb());
   L_Acnt.RollbackXDoc(L_XDoc.curXDocId(L_XDoc.xdt_ACalc));

   L_MathR.AccessKeyAssXObject();
   SETZERO(SourcesToClear);
   SourcesToClear[L_XObj.src_Math]:=1;
   SourcesToClear[L_XObj.src_Amortisation]:=1;
   SourcesToClear[L_XObj.src_KAMDoc]:=1;
   L_MathR.MultipleClearMApport(SourcesToClear);

   curMyFirm:=Math.MyFirm;
   PROMPT(" ⨧樨");
   CALL(MDoc.MCMForKeyAssets());
   PROMPT("⥫쭠 ⠪஢");
   wrm_byXObject(PROCREF(AdditionalTaxing), tst_All);
   wrm_byAllMyFirmXCalc(PROCREF(L_XObj.RenXCalc), tst_All);
   L_XDoc.CompleteACalc();
  ELSIF Math.MathKind = L_MathR.mathk_Math THEN
   IF IsAfterDeadLine() THEN
    IF L_Fuel.TanksIsStock(Memo.gl_mb()) THEN
     fit_AcCut:=L_AcCut.erkn_Get(Memo.gl_mb(), L_AcCut.erkn_FuelInTanks);
    ELSE
     SETEMPTY(fit_AcCut);
    END;
    SELECT(_mItm, _mItm);
    WHILE OCCURE(_mItm) DO
     NARROWSEL(_mItm, MyFirm);
     curMyFirm:=_mItm.MyFirm;

     PROMPT("⪠");
     L_XDoc.FixACalc("Math", curMyFirm, Memo.gl_mb());
     L_Acnt.RollbackXDoc(L_XDoc.curXDocId(L_XDoc.xdt_ACalc));
     wrm_byXObject(PROCREF(ClearApport), tst_All);

     IF ~L_Acnt.E_SetMathPriceOnline(Memo.gl_mb()) THEN
      PROMPT(" । 業");
      SELECT(_PrGr, _PrGr);
      REMSEL(_PrGr);
      wrm_byXCalc(PROCREF(GetAvePrice), tst_exclAH);
      wrm_byXCalc(PROCREF(SetAvePrice), tst_exclAH);
      CheckAdjustmentOfPrice();
      PROMPT("業 ");
      ProceedAdvancedHolder();
     ELSE
      IF ~!fit_AcCut THEN
       wrm_byXCalc(PROCREF(GetFuelInTankPrice), tst_exclAH);
       wrm_byXCalc(PROCREF(SetFuelInTankPrice), tst_exclAH);
      END;
     END;
     wrm_byXCalc(PROCREF(EstimateXDocApr), tst_exclAH);
     PROMPT("⥫쭠 ⠪஢");
     wrm_byXObject(PROCREF(AdditionalTaxing), tst_All);
     wrm_byXCalc(PROCREF(L_XObj.RenXCalc), tst_All);
     L_XDoc.CompleteACalc();
     NEXTINEXTENDEDSEL(_mItm, MyFirm);
    END; (* WHILE OCCURE(_mItm) *)
   END;
  ELSE
   L_General.CallUs(0);
  END;
  L_XObj.mfSetMathDone(Math.Math, L_General.EMPTY_NUMBER(), Memo.gl_mb());
  Purge_TempFiles();
 END {intCountMath};

 PRIVATE PROCEDURE slfCountMath(ForceRecount: SCAL[2]; ppmTransaction: NUMERIC[0]);
 BEGIN
  IF ForceRecount | ~L_MathR.IsMathDone() THEN
   L_AcsPnt.PassAccessPoint(0000015);
   ProceedPrvMonth(ppmTransaction);
   intCountMath();
  END; (* IF _Mode ... *)
 END {slfCountMath};

 PRIVATE PROCEDURE CountMath(ForceRecount: SCAL[2]; ppmTransaction: NUMERIC[0]);
 BEGIN
  APP.Get().NewPrompt("   " + Math.Math + "  " + L_DatTim.PeriodStr(Memo.gl_mb()));
  IF L_General.DoConcurrentModification() THEN
   TRY
    GETLASTVERSION(Math);
    RTI.Get().TryBlock.AccessDataMode:=adm_RIDGE;
    slfCountMath(ForceRecount, ppmTransaction);
   EXCEPT
   END; (* TRY *)
  ELSE
   slfCountMath(ForceRecount, ppmTransaction);
  END;
 END {CountMath};

 PRIVATE PROCEDURE CountMath_mItem(ForceRecount: SCAL[2]);
 BEGIN
  ACCESS(mItem);
  CONFORM(mItem, Math);
  CountMath(ForceRecount, TRANSACTION_SLAVE);
 END {CountMath_mItem};

 PUBLIC PROCEDURE mItem_CountUp();
 BEGIN
  CountMath_mItem(0);
 END {mItem_CountUp};

 PUBLIC PROCEDURE mItem_Recount();
 BEGIN
  CountMath_mItem(1);
 END {mItem_Recount};

 PRIVATE PROCEDURE CountMath_XCalc(ForceRecount: SCAL[2]);
 BEGIN
  IF ~ACCESS(XODone) THEN
   L_General.Assert(ACCESS(XCalc), " ⠭   ப 楢  ");
   Memo.gl_SetCurDate(XCalc.XDat);
   SEARCH(mItem, XObject, , XCalc.XObject);
  ELSE
   Memo.gl_SetCurDate(XODone.Period);
   SEARCH(mItem, XObject, , XODone.XObject);
  END;
  L_General.Assert(ACCESS(mItem), " ⠭   쭮 ⭮ ꥪ ");
  CONFORM(mItem, Math);
  CountMath(ForceRecount, TRANSACTION_SLAVE);
 END {CountMath_XCalc};

 PUBLIC PROCEDURE XCalc_CountUp();
 BEGIN
  CountMath_XCalc(0);
 END {XCalc_CountUp};

 PUBLIC PROCEDURE XCalc_Recount();
 BEGIN
  CountMath_XCalc(1);
 END {XCalc_Recount};

 PRIVATE PROCEDURE CountMath_Math(ForceRecount: SCAL[2]; ppmTransaction: NUMERIC[0]);
 BEGIN
  ACCESS(Math);
  CountMath(ForceRecount, ppmTransaction);
 END {CountMath_Math};

 PUBLIC PROCEDURE SingleCountUp(ppmTransaction: NUMERIC[0]);
 BEGIN
  CountMath_Math(0, ppmTransaction);
 END {SingleCountUp};

 PUBLIC PROCEDURE Math_CountUp();
 BEGIN
  CountMath_Math(0, TRANSACTION_SLAVE);
 END {Math_CountUp};

 PUBLIC PROCEDURE Math_Recount();
 BEGIN
  CountMath_Math(1, TRANSACTION_SLAVE);
 END {Math_Recount};

END.
