(*
%Copyright   (c) Polak Computer System
%Author      01.09.2000 14:58:35 SAM
%Purpose      ﬨ ⮏
%Type        operation
%Specific    SYS
%Modified    05.02.2014 18:08:40 POLAK\LDA
%Environment
*)

 MODULE MdlMnp [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT FIO, Str, DBD, L_General, L_Str, L_StdFrm, L_FIO, L_Prop, L_DatTim;

 PRIVATE PERMANENT VAR
  AltPModeOrProc,
  AltPModule : STRING[];

 PRIVATE PROCEDURE CopyToTmpLib(ModuleType: L_General.tModuleType);
  VAR
   Dummy,
   InName,
   OutName,
   OutPath,
   MdlName,
   TmpName,
   MdTName : STRING[];
 BEGIN
  L_General.SilentPrgsOnly();
  L_General.Assert(APP.Get().ProductiveCopy, "஢ ꥪ⮢  TMP_LIB ⮫쪮  'ୠ'");
  L_General.Assert(APP.Get().SupportMode, "஢ ꥪ⮢  ⫠ ⮫쪮  ⫠筮 ᨨ ⮏");
  OutPath:=FIO.AsbSpecialFolders("ClientRedFileDir");
  MdTName:=L_General.GetModuleType_asStr(ModuleType);
  InName :=FIO.ChooseFile("*." + MdTName);
  IF ~!InName THEN
   FIO.SplitPath(InName, MdlName, MdTName, Dummy);
   OutName:=FIO.MakePath(MdlName, MdTName, OutPath);
   IF FIO.Exists(OutName) THEN
    L_StdFrm.Choice(" "+OutName+" 㦥 ");
   END;
   IF ~L_General.IsAPSupportFolder(FIO.FirstPath(MdlName, MdTName)) THEN
    L_StdFrm.Choice(" " + MdTName + " 䠩  RED 䠩  㪠   " + OutPath);
   END;
   TmpName:=FIO.MakePath(MdlName, "TMP", OutPath);
   L_FIO.FileCopy(InName, TmpName);
   FIO.Rename(TmpName, , OutName);
   L_General.EditModule(OutName, ModuleType);
  END;
 END {CopyToTmpLib};

 PUBLIC PROCEDURE CopyToTmpLib_ASL();
 BEGIN
  CopyToTmpLib(L_General.mt_ASL);
 END {CopyToTmpLib_ASL};

 PUBLIC PROCEDURE CopyToTmpLib_MNU();
 BEGIN
  CopyToTmpLib(L_General.mt_MNU);
 END {CopyToTmpLib_MNU};

 PUBLIC PROCEDURE CopyToTmpLib_WDO();
 BEGIN
  CopyToTmpLib(L_General.mt_WDO);
 END {CopyToTmpLib_WDO};

 PRIVATE PROCEDURE GetModuleName(FullFileName: STRING[]): STRING[];
  CONST
   o_Module = " MODULE ";
  VAR
   Pos   : NUMERIC[0];
   S,
   Result: STRING[];
 BEGIN
  Result:="";
  TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   FIO.Open(F, FullFileName, , Input);
   IF FIO.RdByte(F, S, FIO.Size(F)) THEN
    Pos:=Str.Pos(S, o_Module)+Str.Length(o_Module);
    IF Pos < Str.Length(S) THEN
     S:=Str.Slice(S, Pos, Str.Pos(S, L_Str.CRLF, Pos)-Pos);
     Result:=Str.Item(S, " ;[", 0);
    END;
   END;
   FIO.Close(F);
  EXCEPT
  ELSE
  END; (* TRY *)
  IF !Result THEN
   Result:=L_FIO.effp_FileName_woExt(FullFileName);
  END;
  RETURN Result;
 END {GetModuleName};

 PRIVATE PROCEDURE RunModule(ModuleType: L_General.tModuleType);
  VAR
   FullFileName,
   FileName,
   ModuleName: STRING[];
 BEGIN
  FullFileName:=L_General.ChooseModule(ModuleType);
  IF ~!FullFileName THEN
   IF APP.Get().ProductiveCopy & ~APP.Get().SupportMode THEN
    L_General.Assert(Str.Match(FullFileName, "*\TOOLS\*"),
                     " ࠡ祩   믮 ⮫쪮 㫨  TOOLS");
   END;

   FileName:=L_FIO.effp_FileName(FullFileName);
   ModuleName:=GetModuleName(FullFileName);
   IF ~L_General.VariableIsInitialized(AltPModule) | (FileName # AltPModule) THEN
    SETEMPTY(AltPModeOrProc);
    AltPModule:=FileName;
    STDFORM(L_StdFrm.sf_Choice("|믮 " + ModuleName + " %########################%|",
                               "%LYI"),
            ,
            ,
            ,
            AltPModeOrProc);
   END;
   IF ModuleType = L_General.mt_ASL THEN
    IF !AltPModeOrProc | L_Prop.IsNumericValue(AltPModeOrProc, "0") THEN
     LIKEMENU(RunProg, ModuleName + " " + FLDTOSTR(AltPModeOrProc));
    ELSE
     IF    ~L_Str.IsStrInStr(AltPModeOrProc, "(") & ~L_Str.IsStrInStr(AltPModeOrProc, ")") THEN
      INC(AltPModeOrProc, "()");
     ELSIF ~L_Str.IsStrInStr(AltPModeOrProc, ")") THEN
      INC(AltPModeOrProc, ")");
     ELSIF ~L_Str.IsStrInStr(AltPModeOrProc, "(") THEN
      AltPModeOrProc:=Str.Insert(AltPModeOrProc, "(", Str.Length(AltPModeOrProc) - 1 );
     END;
     LIKEMENU(CALL, ModuleName + "."  + AltPModeOrProc);
    END;
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {RunModule};

 PUBLIC PROCEDURE Run_ASL();
 BEGIN
  RunModule(L_General.mt_ASL);
 END {Run_ASL};

 PUBLIC PROCEDURE Edit_ASL();
 BEGIN
  L_General.EditModule("", L_General.mt_ASL);
 END {Edit_ASL};

 PUBLIC PROCEDURE Edit_MNU();
 BEGIN
  L_General.EditModule("", L_General.mt_MNU);
 END {Edit_MNU};

 PUBLIC PROCEDURE Edit_DBS();
 BEGIN
  L_General.EditModule("", L_General.mt_DBS);
 END {Edit_DBS};

 PUBLIC PROCEDURE Edit_WDO();
  VAR
   w: WINDOW;
 BEGIN
  w:=APP.Get().TopWindow;
  IF ~!w & (w.Type # WINDOW.Type_Survey) & (w.Type # WINDOW.Type_Browse) THEN
   L_General.EditModule(w.OriginalName, L_General.mt_WDO);
  ELSE
   L_General.EditModule("", L_General.mt_WDO);
  END;
 END {Edit_WDO};

 PUBLIC PROCEDURE Edit_AnyFile();
 BEGIN
  L_General.SilentPrgsOnly();
  LIKEMENU(EditText, "$*.*");
 END {Edit_AnyFile};

 PRIVATE PROCEDURE GetAcsObjName(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF L_Str.IsStrInStr(AcsObj.Name, ".") THEN
   Result:=Str.Slice(AcsObj.Name, 0, Str.Pos(AcsObj.Name, "."));
  ELSE
   Result:=AcsObj.Name;
  END;
  RETURN Result;
 END {GetAcsObjName};

 PUBLIC PROCEDURE CreateNewFile();
  VAR
   DefaultFileName,
   FileName,
   Dummy,
   FileExt : STRING[];
   Res     : NUMERIC[0];
 BEGIN
  L_General.SilentPrgsOnly();
  IF ~APP.Get().ProductiveCopy | APP.Get().SupportMode THEN
   SAVE(AcsObj);
   SEARCH(AcsObj, AcsObj, , L_General.curUSER);
   DefaultFileName:="_" + GetAcsObjName() + "_" + L_DatTim.SysDateTimeStamp();
   RESTORE(AcsObj);
   FileName:=DefaultFileName;
   LOOP
    Res:=STDFORM(L_StdFrm.sf_Choice_wAddBtns(" 䠩                                         " +
                                             "|%###############################################%",
                                             "%L<>YI",
                                             "%########################%",
                                             "%C<  䠩  㬮砭 >B"),
                 "  䠩 ", , , FileName);
    IF Res = 2 THEN
     FileName:=DefaultFileName;
    ELSE
     EXIT;
    END;
   END; (* LOOP ... *)
   IF ~!FileName THEN
    FIO.SplitPath(FileName, Dummy, FileExt);
    L_General.Assert((Str.Pos(FileName, "_") = 0) |
                     (~!FileExt & !L_Str.PositionInPool("ASL|MNU|DBS", Str.Cap(FileExt))),
                     "  ꥪ⮢  ᮧ ⮫쪮  Journal-");
    LIKEMENU(EditText, FileName);
   END;
  ELSE
   LIKEMENU(EditText, "");
  END;
 END {CreateNewFile};

END.
