(*
%Copyright   (c) Polak IT
%Author      09.08.2010 16:07:58 POLAK\Bor
%Purpose     樠 樨  
%Type        operation
%Specific    SYS
%Modified    24.01.2014 13:49:57 POLAK\MLB
%Environment
*)

 MODULE MDMth [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, L_MDoc, L_CUC, L_WDO;

 PRIVATE PROCEDURE SetFieldsFormat(trgZoneNbr: NUMERIC[0]; Short: SCAL[2]);
 BEGIN
  L_WDO.iField(trgZoneNbr, "MDMth.DefOpKnd").Format:=L_CUC.ok_Pool;
  IF Short THEN
   L_WDO.iField(trgZoneNbr, "MDMth.FlowType").Format:=L_MDoc.mft_Pool_1Char;
   L_WDO.iField(trgZoneNbr, "MDMth.CUCChar" ).Format:=L_CUC.chr_Pool_Short;
  ELSE
   L_WDO.iField(trgZoneNbr, "MDMth.FlowType").Format:=L_MDoc.mft_Pool;
   L_WDO.iField(trgZoneNbr, "MDMth.CUCChar" ).Format:=L_CUC.chr_Pool;
  END;
 END {SetFieldsFormat};

 PRIVATE PROCEDURE MDMth_OnInitializeWindow();
 BEGIN
  SetFieldsFormat(1, 1);
  L_WDO.iSubwindow   (1, "MDMthE");
 END {MDMth_OnInitializeWindow};

 PRIVATE PROCEDURE MDMthE_OnInitializeWindow();
 BEGIN
  SetFieldsFormat(0, 0);
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit, L_WDO.e_OnAfterInsert]);
  L_WDO.iMayBeEmpty  (0, ["MDMth.CUCChar", "MDMth.DefOpKnd", "MDMth.FlowType", "MDMth.Till", "MDMth.MMode", "MDMth.Dest", "MDMth.MDocKind"]);
 END {MDMthE_OnInitializeWindow};

 PRIVATE PROCEDURE CheckCover();
  VAR
   curMDMth   : LIKE(MDMth.MDMth);
   curMDocKind: LIKE(MDMth.MDocKind);
   curDest    : LIKE(MDMth.Dest);
   curMMode   : LIKE(MDMth.MMode);
   curBegin   : LIKE(MDMth.Begin);
   curTill    : LIKE(MDMth.Till);
   curFlowType: LIKE(MDMth.FlowType);
   curDefOpKnd: LIKE(MDMth.DefOpKnd);
   curCUCChar : LIKE(MDMth.CUCChar);
 BEGIN
  curMDMth   :=MDMth.MDMth;
  curMDocKind:=MDMth.MDocKind;
  curDest    :=MDMth.Dest;
  curMMode   :=MDMth.MMode;
  curBegin   :=MDMth.Begin;
  curTill    :=MDMth.Till;
  curFlowType:=MDMth.FlowType;
  curDefOpKnd:=MDMth.DefOpKnd;
  curCUCChar :=MDMth.CUCChar;
  SAVE(MDMth);
  SELECT(MDMth, MDMth);
  WHILE OCCURE(MDMth) DO
   IF (MDMth.MDMth # curMDMth) & L_DatTim.IsActiveInIntvl(MDMth.Begin, MDMth.Till, curBegin, curTill) &
      (MDMth.MDocKind = curMDocKind) &
      (MDMth.Dest     = curDest) &
      (MDMth.MMode    = curMMode) &
      ((~!MDMth.FlowType & ~!curFlowType) |
       (~!MDMth.DefOpKnd & ~!curDefOpKnd) |
       (~!MDMth.CUCChar  & ~!curCUCChar)) THEN
    L_General.Error("奬 "+curMDMth+" ᥪ  奬 "+MDMth.MDMth);
   END;
   NEXT(MDMth);
  END; (* WHILE OCCURE(MDMth) ... *)
  RESTORE(MDMth);
 END {CheckCover};

 PRIVATE PROCEDURE MDMth_OnAfterEdIns();
 BEGIN
  L_General.Assert(~!MDMth.MDocKind | ~!MDMth.Dest | ~!MDMth.MMode, "       ᠭ");
  L_General.Assert(~!MDMth.FlowType | ~!MDMth.DefOpKnd | ~!MDMth.CUCChar, "      ");
  IF ~!MDMth.FlowType THEN
   L_General.Assert(~!MDMth.MMode, " । ⨯     㪠 ०  ");
  END;
  IF ~!MDMth.DefOpKnd THEN
   L_General.Assert(~!MDMth.MDocKind, " । 樨   㪠  ");
  END;
  IF ~!MDMth.CUCChar THEN
   L_General.Assert(~!MDMth.MDocKind, " । ࠪ    㪠  ");
  END;

  MDMth.sFlowTyp:=~!MDMth.FlowType;
  MDMth.sDfOpKnd:=~!MDMth.DefOpKnd;
  MDMth.sCUCChar:=~!MDMth.CUCChar;
  REPLACE(MDMth);
  CheckCover();
 END {MDMth_OnAfterEdIns};

 PRIVATE PROCEDURE MDMth_OnAfterEdit();
 BEGIN
  MDMth_OnAfterEdIns();
 END {MDMth_OnAfterEdit};

 PRIVATE PROCEDURE MDMth_OnAfterInsert();
 BEGIN
  MDMth_OnAfterEdIns();
 END {MDMth_OnAfterInsert};

 PUBLIC PROCEDURE scs_GetFilters_MDMth_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "  ",      "(MDMth.sFlowTyp=1)", 1);
  L_WDO.PutNewFilter(Filters, "樨",           "(MDMth.sDfOpKnd=1)", 1);
  L_WDO.PutNewFilter(Filters, "ࠪ ஢", "(MDMth.sCUCChar=1)", 1);
 END {scs_GetFilters_MDMth_1};

BEGIN
 L_Events.ExecuteHandler();
END.