(*
%Copyright   (c) Polak Computer System
%Author      14.05.1998 13:17:14 SAN
%Purpose     ࠢ 䨪樥 ப ᪫᪮ 㬥
%Type        control
%Specific    SYS
%Modified    20.11.2013 13:42:47 POLAK\Bor
%Environment
*)

 MODULE MDocList [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Acnt, L_Fuel, L_Events, L_MDoc, L_Str, L_Car, L_WDO, L_XObj, L_CI,
        L_DatTim, L_Money, L_MathR, L_EC, L_StdFrm, P_OwnData, L_Pmnt, L_AFM, L_CUC, L_SES,
        P_MDoc, P_Car, P_Cntr, P_Math, E_Stock, E_Prop, Str, Math, Memo, L_Stock, L_Prop, L_Way,
        L_XDoc, L_Print, L_BarCode;

 PRIVATE TYPE
  tCalculateMth = SCAL[10];

 PRIVATE CONST
  cmth_byCir0  = 0;
  cmth_byTotal = 1;
  cmth_None    = 9;

  cmth_Pool    = " | ";
  ses_MDocList_CalculateMethod = "MDocList_CalculateMethod";

  v_MDocList_CMth        = "v_MDocList_CMth";
  v_MDocList_Total       = "v_MDocList_Total";
  v_MDocList_NettoPrice  = "v_MDocList_NettoPrice";
  v_MDocList_BruttoPrice = "v_MDocList_BruttoPrice";

 PRIVATE PERMANENT VAR
  DeletedMDLNbr   : LIKE(MDocList.MDLNbr);

 PRIVATE PROCEDURE MDocList_Make(_s: NUMERIC[0]);
 BEGIN
  INC(MDoc.Total, _s*(MDocList.Sum+MDocList.VAT+MDocList.SaleTax));
  REPLACE(MDoc);
 END {MDocList_Make};

 PRIVATE PROCEDURE SetMUNbrFormat();
  VAR
   s,
   pool     : STRING[];
   curNumber: LIKE(MathUnit.Number);
 BEGIN
  IF ~!RTI.Get().CurZone.Fields("MDocList.MUNbr") THEN
   IF ACCESS(MDocList) & ~!MDocList.Math THEN
    curNumber:=000;
    pool:="";
    SELECT(MathUnit, Math, , MDocList.Math);
    WHILE OCCURE(MathUnit) DO
     IF MathUnit.Number > curNumber THEN
      pool:=pool+L_Str.Repeat(" |", MathUnit.Number - curNumber);
     END;
     s:=MathUnit.Sign;
     IF MathUnit.Number # 000 THEN
      s:=Str.Align(s, Str.MaxLength(MathUnit.Sign), LEFT);
      s:=s + FLDTOSTR(MathUnit.Ratio, "4.", 10, "R");
     END;
     pool:=pool + s + "|";
     curNumber:=MathUnit.Number+1;
     NEXT(MathUnit);
    END; (* WHILE OCCURE(MathUnit) ... *)
   ELSE
    pool:="|";
   END;
   RTI.Get().CurZone.Fields("MDocList.MUNbr").Format:=pool;
  END;
 END {SetMUNbrFormat};

 PRIVATE PROCEDURE QuantityStrFormat(Precision: NUMERIC[0]): STRING[];
 BEGIN
  IF Precision = 0 THEN
   RETURN "0";
  ELSE
   RETURN L_Str.IntStr(Precision) + ".";
  END;
 END {QuantityStrFormat};

 PRIVATE PROCEDURE QuantityStr(Value: NUMERIC[4]; Precision, len: NUMERIC[0]): STRING[];
  VAR
   v: STRING[];
 BEGIN
  v:=FLDTOSTR(Value, QuantityStrFormat(Precision), len + (Precision # 0) + Precision);
  RETURN v + L_Str.Repeat(" ", len + 6 - Str.Length(v));
 END {QuantityStr};

 PRIVATE PROCEDURE GetMDocListQntForPrice(): L_XObj.tQnt;
 BEGIN
  IF MDocList.MUNbr # 000 THEN
   RETURN RTI.Get().CurZone.Fields("MDLMUQnt").Value;
  ELSE
   RETURN MDocList.Qnt;
  END;
 END {GetMDocListQntForPrice};

 PRIVATE PROCEDURE MDocList_OnCalculate();
  VAR
   cMth       : tCalculateMth;
   NettoPrice,
   BruttoPrice: L_XObj.tSum;
   MDLMUSign  : STRING[];
   Fields     : FORM_FIELDS;
 BEGIN
  cMth:=GetCalculateMth();
  IF cMth # cmth_None THEN
   Fields:=RTI.Get().CurZone.Fields;
   Fields(v_MDocList_Total).Value:=MDocList.Sum + MDocList.VAT + MDocList.SaleTax;

   IF !GetMDocListQntForPrice() | (GetMDocListQntForPrice() = 0) THEN
    NettoPrice :=0;
    BruttoPrice:=0;
   ELSE
    NettoPrice :=MDocList.Sum/GetMDocListQntForPrice();
    BruttoPrice:=(MDocList.Sum+MDocList.VAT)/GetMDocListQntForPrice();
   END;
   Fields(v_MDocList_NettoPrice ).Value:=NettoPrice;
   Fields(v_MDocList_BruttoPrice).Value:=BruttoPrice;
   IF    !MDocList.Math | !MDocList.MUNbr THEN
    MDLMUSign:="  ...";
   ELSE
    SEARCH(MathUnit, Math, , MDocList.Math, MDocList.MUNbr);
    MDLMUSign:="  "+L_MathR.MUnitSign(MathUnit.MUnit);
   END;
   Fields("MDLMUSign_Netto" ).Value:=MDLMUSign;
   Fields("MDLMUSign_Brutto").Value:= MDLMUSign;
  END;
 END {MDocList_OnCalculate};

 PRIVATE PROCEDURE intMDocList_Qnt_OnSuccessfulChange(IsAlternativeMUnit, wRatioCheck: SCAL[2]);
  VAR
   MDLMUQnt: LIKE(MDocList.Qnt);
   errMsg  : STRING[];
   len     : NUMERIC[0];
 BEGIN
  IF ~L_MDoc.IsMDoc_woMath(MDocList.MDocKind) THEN
   L_MDoc.soByMDL_Math();
   L_General.Assert(OCCURE(Math), " 㪠  ");
   CONFORM(Math, MathType);
   CONFORM(Math, MUnit);
   L_MathR.CheckFormat(MDocList.Qnt);
  END;
  IF MDocList.MUNbr # 000 THEN
   SEARCH(MathUnit, Math, , MDocList.Math, MDocList.MUNbr);
   CONFORM(MathUnit, MUnit);
   IF IsAlternativeMUnit THEN
    MDLMUQnt:=RTI.Get().CurZone.Fields("MDLMUQnt").Value;
   ELSE
    MDLMUQnt:=Math.Round(MDocList.Qnt / MathUnit.Ratio, Math.Pow(0.1, MUnit.Format));
   END;
   IF wRatioCheck & (MDLMUQnt * MathUnit.Ratio # MDocList.Qnt) THEN
    CONFORM(MDocList, Math);
    IF IsAlternativeMUnit THEN
     CONFORM(Math, MUnit);
     len:=Str.Length(L_Str.IntStr(MDocList.Qnt));
     errMsg:="⢮  ᭮  ७" +
             "| ࠭   筮." +
             "|"+
             "|筮 祭: " + QuantityStr(MDLMUQnt * MathUnit.Ratio, 4, len) + Str.Align(MUnit.Sign, 3, LEFT) +
             "|㤥 ࠭: " + QuantityStr(MDocList.Qnt, MUnit.Format, len) + Str.Align(MUnit.Sign, 3, LEFT);
    ELSE
     CONFORM(MathUnit, MUnit);
     len:=Str.Length(L_Str.IntStr(MDLMUQnt));
     errMsg:="⢮  ⥫  ७" +
             "| ࠭   筮." +
             "|"+
             "|筮 祭: " + QuantityStr(MDocList.Qnt / MathUnit.Ratio, 4, len) + Str.Align(MUnit.Sign, 3, LEFT) +
             "|㤥 ࠭: " + QuantityStr(MDLMUQnt, MUnit.Format, len) + Str.Align(MUnit.Sign, 3, LEFT);
     CONFORM(Math, MUnit);
    END;
    L_StdFrm.Choice(errMsg);
   END;
   RTI.Get().CurZone.Fields("MDLMUQnt").Value:=MDLMUQnt;
  END;
  MDocList_OnCalculate();
 END {intMDocList_Qnt_OnSuccessfulChange};

 PRIVATE PROCEDURE SetMDocListQntFormat();
 BEGIN
  IF ~!MDocList.Math                &
     (RTI.Get().CurZone.Number = 0) &
     ~!RTI.Get().CurZone.Fields("MDocList.Qnt") THEN
   CONFORM(MDocList, Math);
   CONFORM(Math, MUnit);
   RTI.Get().CurZone.Fields("MDocList.Qnt").Format:=QuantityStrFormat(MUnit.Format);
  END;
 END {SetMDocListQntFormat};

 PRIVATE PROCEDURE UpdateMUnitInfo(wRatioCheck: SCAL[2]);
  VAR
   IsAlternativeMUnit,
   HasAlternativeMUnit: SCAL[2];
 BEGIN
  IF ~!RTI.Get().CurZone.Fields("MDocList.MUNbr") THEN
   HasAlternativeMUnit:=ACCESS(MDocList) & SELECT(MathUnit, Math, MDocList.Math) & NEXT(MathUnit);
   IsAlternativeMUnit :=HasAlternativeMUnit & (MDocList.MUNbr # 0);
   IF    IsAlternativeMUnit & SEARCH(MathUnit, Math, MDocList.Math, MDocList.MUNbr) & ~!MDocList.Qnt THEN
    CONFORM(MathUnit, MUnit);
    RTI.Get().CurZone.Fields("MDLMUQnt").Format:=QuantityStrFormat(MUnit.Format);
    intMDocList_Qnt_OnSuccessfulChange(0, wRatioCheck);
   ELSE
    SETEMPTY(RTI.Get().CurZone.Fields("MDLMUQnt").Value);
   END;
   RTI.Get().CurZone.Fields("MDocList.MUNbr").Modifiable:=HasAlternativeMUnit;
   RTI.Get().CurZone.Fields("MDLMUQnt").Visible:=IsAlternativeMUnit;
   RTI.Get().CurZone.Fields("MUnit.Sign").Visible:=IsAlternativeMUnit;
  END;
  SetMDocListQntFormat();
 END {UpdateMUnitInfo};

 PRIVATE PROCEDURE IsVATPossible(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  CONFORM(MDocList, MDoc);
  Result:=(L_MDoc.CalculateVAT() # L_MDoc.cvat_Impossible);
  IF ~!MDocList.Math &
     Result &
     (P_Math.GetSpecialAttitudeToVAT(MDocList.Math, MDoc.Date) = P_Math.satVAT_TaxFree) THEN
   Result:=0;
  END;
  RETURN Result;
 END {IsVATPossible};

 PRIVATE PROCEDURE GetCalculateMth(): tCalculateMth;
  VAR
   Result: tCalculateMth;
 BEGIN
  IF !RTI.Get().CurZone.Fields(v_MDocList_Total) THEN
   Result:=cmth_None;
  ELSE
   IF ~IsVATPossible() THEN
    Result:=cmth_byCir0;
   ELSE
    TRY
     IF ~L_SES.GetValue(L_SES.sit_User, ses_MDocList_CalculateMethod, Result) |
        (Result # cmth_byTotal) THEN
      Result:=cmth_byCir0;
     END;
     L_General.RaiseLockReleaseException();
    EXCEPT
    ON Exc: Exc_Raise DO
     L_General.CheckIsLockReleaseException(Exc);
    END;
   END; (* IF ~IsVATPossible() ... *)
  END;
  RETURN Result;
 END {GetCalculateMth};

 PRIVATE PROCEDURE SetMDocListCstDclr(SetDefault: SCAL[2]);
  VAR
   defCstDclr: LIKE(MDocList.CstDclr);
   Field: FORM_FIELD;
   Modifiable,
   HasCstDclr: SCAL[2];
 BEGIN
  Field:=RTI.Get().CurZone.Fields("MDocList.CstDclr");
  CONFORM(MDocList, MDoc);
  HasCstDclr:=L_Pmnt.MDocKind_wCstDclr(MDoc.MDocKind, MDoc.Date);
  IF ~!Field THEN
   IF HasCstDclr & ~L_Pmnt.IsMDocKindWithJustCopyCstDclr(MDocList.MDocKind) THEN
    defCstDclr:=MDocList.CstDclr;
    IF ~!MDocList.Math & ~!MDocList.MMode THEN
     IF L_Pmnt.E_MDocListMustHasCstDclr() THEN
      IF P_Math.IsDomesticManufacture(MDocList.Math, MDocList.Date) THEN
       defCstDclr:=L_Pmnt.CstDclr_DomesticManufacture;
       Modifiable:=0;
      ELSE
       Modifiable:=1;
      END;
     ELSE
      SETEMPTY(defCstDclr);
      Modifiable:=0;
     END; (* IF L_Pmnt.E_MDocListMustHasCstDclr() ... *)
    ELSE
     Modifiable:=1;
    END; (* IF ~!MDocList.Math & ~!MDocList.MMode ... *)
    IF SetDefault & (MDocList.CstDclr # defCstDclr) THEN
     MDocList.CstDclr:=defCstDclr;
     REPLACE(MDocList);
    END;
   ELSE
    Modifiable:=0;
   END; (* IF L_Pmnt.IsMDocKindWithJustCopyCstDclr() ... *)
   Field.Modifiable:=Modifiable;
  END;
 END {SetMDocListCstDclr};

 PRIVATE PROCEDURE SetFieldsFlagEdit();
  VAR
   cMth       : tCalculateMth;
   Fields     : FORM_FIELDS;
   VATPossible: SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF ~!Fields("MDocList.VAT") THEN
   VATPossible:=IsVATPossible();
   Fields("MDocList.VAT"     ).Modifiable:=VATPossible;
   IF ~!Fields("MDocList.VATMode") THEN
    Fields("MDocList.VATMode").Modifiable:=VATPossible & L_MDoc.IsAvailableVATMode();
   END;
  ELSE
   VATPossible:=0;
  END;

  cMth:=GetCalculateMth();
  IF cMth # cmth_None THEN
   IF ~VATPossible THEN
    L_General.CallUs(cMth=cmth_byCir0); (*. GetCalculateMth() *)
   END;
   Fields(v_MDocList_CMth).Modifiable:=VATPossible;
   Fields(v_MDocList_CMth).Format    :=cmth_Pool;
   Fields(v_MDocList_CMth).Value     :=cMth;

   Fields(v_MDocList_BruttoPrice).Modifiable:=cMth = cmth_byTotal;
   Fields(v_MDocList_Total      ).Modifiable:=cMth = cmth_byTotal;
   Fields(v_MDocList_NettoPrice ).Modifiable:=cMth # cmth_byTotal;
   Fields("MDocList.Sum"        ).Modifiable:=cMth # cmth_byTotal;
  END;
  SetMDocListCstDclr(0);
 END {SetFieldsFlagEdit};

 PRIVATE PROCEDURE MDocList_Math_OnSuccessfulChange();
  VAR
   curTSN    : LIKE(MDoc.TSN);
   defVATMode: LIKE(MDocList.VATMode);
   prvMUnit  : LIKE(MUnit.MUnit);
 BEGIN
  CONFORM(MDocList, Math);
  L_General.Assert(Math.Leaf, "⨬ ᯮ짮 㯯஢ ᥩ ");
  CONFORM(MDocList, MDocLCU);
  IF OCCURE(MDocLCU) THEN
   L_General.Assert(L_CUC.GetCUCopyCarUnitType(MDocLCU.CUCopy) # L_CUC.cut_TicketProduction, "⨬    - ⭮ த樨  稨 ஢");
  END;
  IF L_MDoc.KeyAssetsMDoc(MDocList.MDocKind) THEN
   CONFORM(MDocList, MDoc);
   IF !MDoc.TSN THEN
    SAVE(MDocList);
    SAVE(MDoc);
     IF L_MDoc.PosToLastKeyAssChangeResponsibleMDoc(MDocList.Math, MDoc.Date-1) THEN
      curTSN:=MDoc.TSN;
     ELSE
      SETEMPTY(curTSN);
     END;
    RESTORE(MDocList);
    RESTORE(MDoc);
    IF ~!curTSN THEN
     MDoc.TSN:=curTSN;
     REPLACE(MDoc);
    END;
   END;
  END;

  IF ~IsVATPossible() & (MDocList.VAT # 0) THEN
   MDocList.VAT:=0;
   MDocList_OnCalculate();
  END;

  defVATMode:=L_MDoc.E_DefaultVATMode(MDoc.Date, MDocList.Math);
  IF ~!defVATMode THEN
   L_General.CallUs(~!RTI.Get().CurZone.Fields("MDocList.VATMode"));
   IF !MDocList.VATMode THEN
    MDocList.VATMode:=defVATMode;
   END;
  ELSE
   SETEMPTY(MDocList.VATMode);
  END;

  CONFORM(MDocList, Math);

  IF ~!GE_PVALUE(MDocList.Math) THEN
   SEARCH(Math, Math, , GE_PVALUE(MDocList.Math));
   prvMUnit:=Math.MUnit;
   SEARCH(Math, Math, , MDocList.Math);
   IF Math.MUnit # prvMUnit THEN
    L_StdFrm.Choice("  " + MDocList.Math + " 㣠  ७");
    SETEMPTY(MDocList.Qnt);
   END;
  END;
  MDocList.MUNbr:=000;

  REPLACE(MDocList);

  SetFieldsFlagEdit();
  SetMDocListCstDclr(1);
  SetMUNbrFormat();
  UpdateMUnitInfo(1);
  MDocList_OnCalculate();
 END {MDocList_Math_OnSuccessfulChange};

 PRIVATE PROCEDURE MDocList_MMode_OnSuccessfulChange();
 BEGIN
  SetMDocListCstDclr(1);
  IF SELECT(MDocLCU, MDoc, MDocList.MDocKind, MDocList.MDoc, MDocList.MDLNbr) THEN
   APP.Get().NewPrompt("ࠡ⪠ ஢");
   WHILE OCCURE(MDocLCU) DO
    PROMPT(MDocLCU.CUCopy);
    L_CUC.CompleteMDocLCU(0);
    NEXT(MDocLCU);
   END; (* WHILE OCCURE(MDocLCU) ... *)
  END;
 END {MDocList_MMode_OnSuccessfulChange};

 PRIVATE PROCEDURE MDocList_MUNbr_OnSuccessfulChange();
 BEGIN
  UpdateMUnitInfo(1);
  MDocList_OnCalculate();
 END {MDocList_MUNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE CUCopyBringToConformityWithMDocList();
  VAR
   Warned: SCAL[2];
 BEGIN
  Warned:=0;
  CONFORM(MDocList, MDocLCU);
  WHILE OCCURE(MDocLCU) DO
   CONFORM(MDocLCU, CUCopy);
   IF CUCopy.Math # MDocList.Math THEN
    L_General.Assert_wReferToAdmin(Warned, "㤥 ࠢ    ᮮ⢥ !");
    Warned:=1;
    SAVE(MDoc);
    SAVE(MDocList);
    SAVE(MDocLCU);
    SELECT(MDocLCU, CUCopy, , CUCopy.CUCopy);
    WHILE OCCURE(MDocLCU) DO
     CONFORM(MDocLCU, MDocList);
     CONFORM(MDocList, MDoc);
     L_General.Assert(MDoc.Status # L_MDoc.st_Passed, " ४ப  |   㬥⮢  ᮮ⢥騬 ࠬ| ﭨ '஢' (ਬ "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+")");
     NEXT(MDocLCU);
    END; (* WHILE OCCURE(MDocLCU) ... *)
    RESTORE(MDocLCU);
    RESTORE(MDocList);
    RESTORE(MDoc);

    TRY [INTEGRITY(INTEGRITY_ON)]
     CUCopy.Math:=MDocList.Math;
     REPLACE(CUCopy);
    EXCEPT
    END; (* TRY *)
   END;
   NEXT(MDocLCU);
  END; (* WHILE OCCURE(MDocLCU) ... *)
 END {CUCopyBringToConformityWithMDocList};

 PUBLIC PROCEDURE SetCalculateMth(NewCalcMth: tCalculateMth);
  VAR
   PrvCalcMth: tCalculateMth;
 BEGIN
  PrvCalcMth:=GetCalculateMth();
  IF PrvCalcMth = cmth_None THEN
   L_StdFrm.Inform(" 室   ᯮᮡ ");
  ELSE
   IF PrvCalcMth # NewCalcMth THEN
    L_SES.PutValueAtSlaveTrn(L_SES.sit_User, ses_MDocList_CalculateMethod, NewCalcMth);
    SetFieldsFlagEdit();
   END;
  END;
 END {SetCalculateMth};

 PRIVATE PROCEDURE CalcByTotal(_Total: NUMERIC[2]);
 BEGIN
  L_General.Assert(~!MDocList.Math, " 㪠 ");
  MDocList.Sum:=_Total;
  MDocList.SaleTax:=0;
  DEC(MDocList.Sum, MDocList.SaleTax);
  IF L_MDoc.MDocListVATPossible() THEN
   MDocList.VAT:=L_Acnt.GetInclMathVAT(MDocList.Math, MDoc.Date, MDocList.Sum);
  ELSE
   MDocList.VAT:=0;
  END;
  DEC(MDocList.Sum, MDocList.VAT);
  REPLACE(MDocList);
  MDocList_OnCalculate();
 END {CalcByTotal};

 PRIVATE PROCEDURE MDocList_CMth_OnSuccessfulChange();
  VAR
   cMth: tCalculateMth;
 BEGIN
  SetCalculateMth(RTI.Get().CurZone.Fields(v_MDocList_CMth).Value);
  cMth:=GetCalculateMth();
  IF cMth # RTI.Get().CurZone.Fields(v_MDocList_CMth).Value THEN
   RTI.Get().CurZone.Fields(v_MDocList_CMth).Value:=cMth;
  END;
  SetFieldsFlagEdit();
 END {MDocList_CMth_OnSuccessfulChange};

 PRIVATE PROCEDURE MDocList_Sum_OnSuccessfulChange(); (* ஢ ᫥ Rb 0081918 *)
 BEGIN
  L_General.Assert(~!MDocList.Math, " 㪠 ");
  IF L_MDoc.MDocListVATPossible() THEN
   MDocList.VAT:=L_Acnt.GetExclMathVAT(MDocList.Math, MDoc.Date, MDocList.Sum);
  ELSE
   MDocList.VAT:=0;
  END;
  REPLACE(MDocList);
  MDocList_OnCalculate();
 END {MDocList_Sum_OnSuccessfulChange};

 PRIVATE PROCEDURE MDocList_Qnt_OnSuccessfulChange(); (* ஢ ᫥ Rb 0081918 *)
 BEGIN
  intMDocList_Qnt_OnSuccessfulChange(0, 1);
 END {MDocList_Qnt_OnSuccessfulChange};

 PRIVATE PROCEDURE MDocList_MDLMUQnt_OnSuccessfulChange();
  VAR
   MDLMUQnt: LIKE(MDocList.Qnt);
 BEGIN
  MDLMUQnt:=RTI.Get().CurZone.ActiveField.Value;
  SEARCH(MathUnit, Math, , MDocList.Math, MDocList.MUNbr);
  CONFORM(MathUnit, MUnit);
  L_MathR.CheckFormat(MDLMUQnt);
  CONFORM(MDocList, Math);
  CONFORM(Math, MUnit);
  MDocList.Qnt:=Math.Round(MDLMUQnt * MathUnit.Ratio, Math.Pow(0.1, MUnit.Format));
  REPLACE(MDocList);
  intMDocList_Qnt_OnSuccessfulChange(1, 1);
 END {MDocList_MDLMUQnt_OnSuccessfulChange};

 PRIVATE PROCEDURE MDocList_v_MDocList_CMth_OnSuccessfulChange();
 BEGIN
  MDocList_CMth_OnSuccessfulChange()
 END {MDocList_v_MDocList_CMth_OnSuccessfulChange};

 PRIVATE PROCEDURE MDocList_v_MDocList_NettoPrice_OnSuccessfulChange();
  VAR
   tmpSum: FLOAT;
 BEGIN
  L_General.Assert(~!GetMDocListQntForPrice(), " 㪠 ⢮");
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   tmpSum      :=GetMDocListQntForPrice() * RTI.Get().CurZone.ActiveField.Value;
   MDocList.Sum:=tmpSum;
   REPLACE(MDocList);
  EXCEPT
  ON Exc: Exc_Root DO
   IF Exc.ErrorCode = L_General.ec_rt_Overfilling THEN
    L_General.Error("९ 祭   㬬  ப .||" +
                    "㬬 " + FLDTOSTR(tmpSum, "2-") + "||" +
                    "᫨  㢥७  ࠢ쭮 ᢮ ⢨,|" +
                    "  ");
   ELSE
    RAISE();
   END;
  END; (* TRY *)
  MDocList_Sum_OnSuccessfulChange();
 END {MDocList_v_MDocList_NettoPrice_OnSuccessfulChange};

 PRIVATE PROCEDURE MDocList_v_MDocList_BruttoPrice_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!GetMDocListQntForPrice(), " 㪠 ⢮");
  L_General.Assert(~!MDocList.Math, " 㪠 ");
  CalcByTotal(GetMDocListQntForPrice() * RTI.Get().CurZone.ActiveField.Value);
 END {MDocList_v_MDocList_BruttoPrice_OnSuccessfulChange};

 PRIVATE PROCEDURE MDocList_v_MDocList_Total_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!MDocList.Math, " 㪠 ");
  CalcByTotal(RTI.Get().CurZone.ActiveField.Value);
 END {MDocList_v_MDocList_Total_OnSuccessfulChange};

 PRIVATE PROCEDURE MDocList_VAT_OnSuccessfulChange();
 BEGIN
  IF GetCalculateMth() = cmth_byTotal THEN
   MDocList.Sum:=RTI.Get().CurZone.Fields(v_MDocList_Total).Value - MDocList.VAT - MDocList.SaleTax;
   REPLACE(MDocList);
  END;
  MDocList_OnCalculate();
 END {MDocList_VAT_OnSuccessfulChange};

 PRIVATE PROCEDURE MDocList_SaleTax_OnSuccessfulChange();
 BEGIN
  MDocList_OnCalculate();
 END {MDocList_SaleTax_OnSuccessfulChange};

 PRIVATE PROCEDURE MDocList_OnReposition();
 BEGIN
  IF ACCESS(MDocList) THEN
   SetFieldsFlagEdit();
   MDocList_OnCalculate();
   SetMUNbrFormat();
   UpdateMUnitInfo(0);
   IF ~L_MDoc.KeyAssetsMDoc(MDocList.MDocKind) THEN
    RTI.Get().CurZone.Fields("MDocList.Math").OwnerWindowOriginalName:="Math";
    RTI.Get().CurZone.Fields("MDocList.Math").OwnerZoneNumber:=1;
   END;
   IF ~!RTI.Get().CurZone.Fields("AddMDLName") THEN
    IF SEARCH(MDocPro, MDoc, MDocList.MDocKind, MDocList.MDoc, P_MDoc.P_AddMDLNames, MDocList.MDLNbr) THEN
     RTI.Get().CurZone.Fields("AddMDLName").Value:=MDocPro.Value;
    ELSE
     SETEMPTY(RTI.Get().CurZone.Fields("AddMDLName").Value);
    END;
   END;
  END;
 END {MDocList_OnReposition};

 PRIVATE PROCEDURE E_DefaultMMode(D: DATE): LIKE(MDocList.MMode);
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(D, PROCREF(E_Stock.DefaultMMode), L_MathR.mm_New);
 END {E_DefaultMMode};

 PRIVATE PROCEDURE MDocList_OnBeforeEdIns();
 BEGIN
  SetFieldsFlagEdit();
  SetMDocListQntFormat();
 END {MDocList_OnBeforeEdIns};

 PRIVATE PROCEDURE MDocList_OnBeforeEdit();
 BEGIN
  MDocList_Make(-1);
  MDocList_OnBeforeEdIns();
 END {MDocList_OnBeforeEdit};

 PRIVATE PROCEDURE MDocList_OnBeforeInsert();
  VAR
   newMDLNbr: LIKE(MDocList.MDLNbr);
 BEGIN
  newMDLNbr:=L_WDO.GetEnvVarValue("newMDLNbr");
  IF ~!newMDLNbr THEN
   ChangeMDocListMDLNbr(MAXOF(MDocList.MDLNbr));
   CHANGESEL(MDocList, MDoc, , MDocList.MDocKind, MDocList.MDoc);
   WHILE PREV(MDocList) & (MDocList.MDLNbr >= newMDLNbr) DO
    ChangeMDocListMDLNbr(MDocList.MDLNbr+1);
   END; (* WHILE PREV(MDocList) ... *)
   SRCINSEL(MDocList, EQ, , MAXOF(MDocList.MDLNbr));
   ChangeMDocListMDLNbr(newMDLNbr);
  END;

  IF L_Stock.IsFuelStationMDoc() |
     (MDocList.MDocKind=L_MDoc.md_NPr) |
     (MDocList.MDocKind=L_MDoc.md_TOV) |
     (MDocList.MDocKind=L_MDoc.md_NOV) |
     (MDocList.MDocKind=L_MDoc.md_MSP) |
     (MDocList.MDocKind=L_MDoc.md_DDA) |
     (MDocList.MDocKind=L_MDoc.md_ZMC) THEN
   MDocList.MMode:=E_DefaultMMode(MDoc.Date);
  END;
  IF L_MDoc.KeyAssetsMDoc(MDocList.MDocKind) THEN
   MDocList.MMode:=L_MathR.mm_New;
   MDocList.Qnt:=1;
   MDocList.Sum:=0;
  ELSIF (MDocList.MDocKind = L_MDoc.md_RNR) |
        (MDocList.MDocKind = L_MDoc.md_RPU) |
        (MDocList.MDocKind = L_MDoc.md_RPN) |
        (MDocList.MDocKind = L_MDoc.md_RSZ) THEN
   MDocList.MMode:=L_MathR.mm_New;
   MDocList.Qnt:=0;
  ELSIF (MDocList.MDocKind # L_MDoc.md_ViP) THEN
   MDocList.Sum:=0;
  END;
  MDocList.Date   :=MDoc.Date;
  MDocList.VAT    :=0;

  REPLACE(MDocList);
  CONFORM(MDocList, MDoc);
  IF ~!MDoc.Contract THEN
   MDocList.Math:=P_Cntr.GetCntrProSoft(MDoc.Contract, MDoc.Date, P_Cntr.P_SingleMath);
   IF ~!MDocList.Math THEN
   REPLACE(MDocList);
   MDocList_Math_OnSuccessfulChange();
   END;
  END;
  MDocList_OnBeforeEdIns();
  MDocList_OnCalculate();
 END {MDocList_OnBeforeInsert};

 PRIVATE PROCEDURE MDocList_OnAfterEdIns();
  VAR
   defVATMode: LIKE(MDocList.VATMode);
 BEGIN
  IF ~!MDocList.CostItem THEN
   L_CI.CheckRequiredCostItem(MDocList.CostItem, 1, EMPTYOF(CIKind.Type));
  END;
  IF (MDocList.Qnt = 0) & ~L_MDoc.KeyAssetsMDoc(MDocList.MDocKind) &
     (MDocList.MDocKind # L_MDoc.md_RNR) &
     (MDocList.MDocKind # L_MDoc.md_RPU) &
     (MDocList.MDocKind # L_MDoc.md_RPN) &
     (MDocList.MDocKind # L_MDoc.md_RSZ) THEN
   L_StdFrm.Choice(" 㫥 ⢮");
  END;

  IF ~!MDocList.Math THEN
   CONFORM(MDocList, Math);
   CONFORM(Math, MUnit);
   L_MathR.CheckFormat(MDocList.Qnt);
  END;
  IF MDocList.MDocKind = L_MDoc.md_NPr THEN
   L_Money.CheckAcAccuracy(L_DatTim.Per(MDoc.Date), MDocList.Sum, " ");
  END;
  IF L_Fuel.TanksIsStock(MDoc.Date) & (MDoc.MDocKind = L_MDoc.md_NOV) THEN
   IF L_Stock.IsFuelStationMDoc() THEN
    L_General.Assert(~!MDoc.BoxNbr, " 㪠 ࠦ  ");
    CONFORM(MDoc, Car);
    L_Car.AccessMark(Car.BoxNbr, MDoc.Date);
    IF L_Fuel.AcsMarkFuel(MDoc.Date, Mark.Mark, MDocList.Math) THEN
     IF ~L_Fuel.IsFuelInMixOnDate(MDoc.Date, MDocList.Math) THEN
      IF MDocList.Qnt > 10 THEN
       L_StdFrm.Choice(" " + L_Str.PoolItem("ਭ|뤠", L_MDoc.getMDocListMathFlowType()) +
                       "  10  ᬠ ਠ");
      END;
     ELSE
      L_Way.CheckBakVol(Car.BoxNbr, MDoc.Date, MDocList.Qnt, 1);
      IF (MarkFuel.InMix # L_Fuel.im_MainFuel) & (MarkFuel.InMix # L_Fuel.im_AddMainFuel) THEN
       L_StdFrm.Choice(" 뤠  ᭮  ⮯");
      END;
      IF MDocList.Qnt > 300 THEN
       L_StdFrm.Choice("⢮ ⮯  300 ");
      END;
     END;
     IF MDocList.Sum # 0 THEN
      L_Money.CheckAcAccuracy(L_DatTim.Per(MDoc.Date), MDocList.Sum, " ");
     END;
    END;
   ELSE
    L_General.Assert(MDocList.Sum=0, "㬬   㫥");
   END;
  END;
  IF ~!MDocList.VATMode THEN
   defVATMode:=L_MDoc.GetVATModeDefinedByPro(MDoc.Contract, MDoc.CostItem, MDocList.Math, MDoc.Date);
   IF ~!defVATMode & (MDocList.VATMode # defVATMode) THEN
    L_StdFrm.Choice(" ᯮᮡ   '"+L_Str.PoolItem(L_MDoc.Get_vatm_Pool(0), MDocList.VATMode)+
                    "' ⫨砥| ।  㬮砭 '"+
                    L_Str.PoolItem(L_MDoc.Get_vatm_Pool(0), defVATMode)+"'");
   END;
  END;
  MDocList_Make(+1);
  L_MDoc.SetMDocTotals(L_WDO.getParentWindowName());
  IF ~!RTI.Get().CurZone.Fields("AddMDLName") THEN
   P_MDoc.extSetMDocPro(MDocList.MDocKind, MDocList.MDoc, P_MDoc.P_AddMDLNames, MDocList.MDLNbr,
                        RTI.Get().CurZone.Fields("AddMDLName").Value);
  END;
 END {MDocList_OnAfterEdIns};

 PRIVATE PROCEDURE MDocList_OnAfterEdit();
 BEGIN
  CUCopyBringToConformityWithMDocList();
  MDocList_OnAfterEdIns();
 END {MDocList_OnAfterEdit};

 PRIVATE PROCEDURE MDocList_OnAfterInsert();
 BEGIN
  MDocList_OnAfterEdIns();
 END {MDocList_OnAfterInsert};

 PRIVATE PROCEDURE GetNewParent(delMDLNbr: LIKE(MDocList.MDLNbr);
                                trgParent: LIKE(IsSData.Parent)): LIKE(IsSData.Parent);
  VAR
   Result: LIKE(IsSData.Parent);
 BEGIN
  SETEMPTY(Result);
  IF ~!trgParent THEN
   SAVE(IsSData);
   SEARCH(IsSData, RECORDID, , trgParent);
   IF IsSData.MDLNbr = delMDLNbr THEN
    IF ~!IsSData.Parent THEN
     Result:=GetNewParent(delMDLNbr, IsSData.Parent);
    END;
   ELSE
    Result:=IsSData.RECORDID;
   END;
   RESTORE(IsSData);
  END;
  RETURN Result;
 END {GetNewParent};

 PRIVATE PROCEDURE MDocListBeforeDel();
  VAR
   trgMDLNbr: LIKE(MDocList.MDLNbr);
   trgParent: LIKE(IsSData.Parent);
 BEGIN
  CONFORM(MDocList, MDocLCU);
  L_General.Assert(~OCCURE(MDocLCU), "।⥫쭮 室  ᯨ᮪ '᪨ ஢'");
  MDocList_Make(-1);

  SELECT(MDocPro, MDoc, , MDocList.MDocKind, MDocList.MDoc);
  WHILE OCCURE(MDocPro) DO
   NARROWSEL(MDocPro, Property);
   IF P_MDoc.IsMDocListProperty(MDocPro.Property) THEN
    IF SRCINSEL(MDocPro, EQ, MDocList.MDLNbr) THEN
     REMOVE(MDocPro);
    END;
   END;
   NEXTINEXTENDEDSEL(MDocPro, Property);
  END; (* WHILE OCCURE(MDocPro) *)

  IF SELECT(IsSData, MDoc, MDoc.MDocKind, MDoc.MDoc, MDocList.MDLNbr) THEN
   trgMDLNbr:=MDocList.MDLNbr;
   SAVE(IsSData);
   WHILE OCCURE(IsSData) DO
    trgParent:=IsSData.RECORDID;
    SAVE(IsSData);
    WHILE SELECT(IsSData, Parent, MDoc.MDocKind, MDoc.MDoc, trgParent) DO
     IsSData.Parent:=GetNewParent(trgMDLNbr, trgParent);
     REPLACE(IsSData);
    END; (* WHILE SELECT(IsSData, Parent...*)
    RESTORE(IsSData);
    NEXT(IsSData);
   END; (* WHILE OCCURE(IsSData) ... *)
   RESTORE(IsSData);
   REMSEL(IsSData);
  END;
 END {MDocListBeforeDel};

 PRIVATE PROCEDURE MDocList_OnBeforeDelete();
 BEGIN
  MDocListBeforeDel();
  DeletedMDLNbr:=MDocList.MDLNbr;
 END {MDocList_OnBeforeDelete};

 PRIVATE PROCEDURE ChangeMDocListMDLNbr(newMDLNbr: LIKE(MDocList.MDLNbr));
 BEGIN
  TRY [INTEGRITY(INTEGRITY_ON)]
   SELECT(MDocPro, MDoc, , MDocList.MDocKind, MDocList.MDoc);
   WHILE OCCURE(MDocPro) DO
    NARROWSEL(MDocPro, Property);
    IF P_MDoc.IsMDocListProperty(MDocPro.Property) THEN
     IF SRCINSEL(MDocPro, EQ, MDocList.MDLNbr) THEN
      MDocPro.PropRow:=newMDLNbr;
      REPLACE(MDocPro);
     END;
    END;
    NEXTINEXTENDEDSEL(MDocPro, Property);
   END; (* WHILE OCCURE(MDocPro) *)
 
   WHILE SELECT(IsSData, MDoc, MDoc.MDocKind, MDoc.MDoc, MDocList.MDLNbr) DO
    IsSData.MDLNbr:=newMDLNbr;
    REPLACE(IsSData);
   END; (* WHILE SELECT(IsSData, MDoc, MDoc.MDocKind, MDoc.MDoc, MDocList.MDLNbr) ...*)
 
   MDocList.MDLNbr:=newMDLNbr;
   REPLACE(MDocList);
  EXCEPT
  END; (* TRY *)
 END {ChangeMDocListMDLNbr};

 PUBLIC PROCEDURE RenumerateMDocList();
  VAR
   curMDLNbr: LIKE(MDocList.MDLNbr);
 BEGIN
  L_MDoc.AccessMDoc();
  CONFORM(MDoc, MDocList);
  curMDLNbr:=0001;
  WHILE OCCURE(MDocList) DO
   PROMPT(curMDLNbr);
   IF MDocList.MDLNbr # curMDLNbr THEN
    ChangeMDocListMDLNbr(curMDLNbr);
   END;
   INC(curMDLNbr);
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ...*)
 END {RenumerateMDocList};

 PRIVATE PROCEDURE MDocList_OnAfterDelete();
 BEGIN
  L_MDoc.SetMDocTotals(L_WDO.getParentWindowName());
  RenumerateMDocList();
  IF GE_CURZONE() = 0 THEN
   SETSEL(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc);
   IF SRCINSEL(MDocList, EQ, DeletedMDLNbr) | LAST(MDocList) THEN
    SE_WZD_POSITION(L_WDO.getParentWindowName(), L_WDO.getParentZoneNumber(), MDocList);
   END;
  END;
 END {MDocList_OnAfterDelete};

 PRIVATE PROCEDURE MDocEIE_1_OnSetSubwindow();
  VAR
   CurZone: FORM_ZONE;
 BEGIN
  CurZone:=RTI.Get().CurZone;
  L_General.Assert(ACCESS(MDoc), " ⠭ ⥪騩 ");
  L_General.Assert(~!MDoc.Contract, " 㪠 ");
  IF    L_Pmnt.MDocKind_wCstDclr(MDoc.MDocKind, MDoc.Date) THEN
   CurZone.SubwindowOriginalName:="MD011ESF";
  ELSIF (MDoc.MDocKind = L_MDoc.md_RPr) |
        (MDoc.MDocKind = L_MDoc.md_OBK) THEN
   CurZone.SubwindowOriginalName:="MD011ERR";
  ELSIF (MDoc.MDocKind = L_MDoc.md_VTN) THEN
   CurZone.SubwindowOriginalName:="MD011EM";
  ELSE
   CurZone.SubwindowOriginalName:="MD011EM";
  END;
 END {MDocEIE_1_OnSetSubwindow};

 PRIVATE PROCEDURE MD02E_1_OnSetSubwindow();
 BEGIN
  IF L_General.IsPolakSpecific() THEN
   RTI.Get().CurZone.SubwindowOriginalName:="MDL02E";
  END;
 END {MD02E_1_OnSetSubwindow};

 PRIVATE PROCEDURE MD011E_1_OnSetSubwindow();
 BEGIN
  RTI.Get().CurZone.SubwindowOriginalName:="MD011EM";
 END {MD011E_1_OnSetSubwindow};

 PRIVATE PROCEDURE MD60E_1_OnSetSubwindow();
 BEGIN
  IF L_General.IsPolakSpecific() THEN
   RTI.Get().CurZone.SubwindowOriginalName:="MDL02E";
  END;
 END {MD60E_1_OnSetSubwindow};

 PRIVATE PROCEDURE MD61E_1_OnSetSubwindow();
  VAR
   SubWindowName: STRING[];
 BEGIN
  IF L_General.IsPolakSpecific() THEN
   SubWindowName:="MDL61E";
  ELSE
   SubWindowName:="MD61EE";
  END;
  RTI.Get().CurZone.SubwindowOriginalName:=SubWindowName;
 END {MD61E_1_OnSetSubwindow};

 PRIVATE PROCEDURE MD70E_1_OnSetSubwindow();
 BEGIN
  RTI.Get().CurZone.SubwindowOriginalName:="MD011EM";
 END {MD70E_1_OnSetSubwindow};

 PUBLIC PROCEDURE MoveMDocList(trgDir: NUMERIC[0]);
  CONST
   maxMDLNbr = MAXOF(MDocList.MDLNbr);
  VAR
   oldMDLNbr,
   newMDLNbr: LIKE(MDocList.MDLNbr);
   Local    : PROC;
 BEGIN
  L_General.Assert(ACCESS(MDocList), " ⠭ ⥪ ப ");
  oldMDLNbr:=MDocList.MDLNbr;
  CHANGESEL(MDocList, MDoc, , MDocList.MDocKind, MDocList.MDoc);
  SAVE(MDocList);
  IF    ((trgDir = +1) & NEXT(MDocList))|
        ((trgDir = -1) & PREV(MDocList)) THEN
   newMDLNbr      :=MDocList.MDLNbr;
   ChangeMDocListMDLNbr(maxMDLNbr);
  ELSE
   IF trgDir = -1 THEN
    L_StdFrm.BlueStop(" ࢠ ப ");
   ELSE
    L_StdFrm.BlueStop(" ᫥ ப ");
   END;
  END;
  RESTORE(MDocList);

  ChangeMDocListMDLNbr(newMDLNbr);
  SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), MDocList);
  SRCINSEL(MDocList, EQ, , maxMDLNbr);
  ChangeMDocListMDLNbr(oldMDLNbr);
 END {MoveMDocList};

 PUBLIC PROCEDURE CountCurrency();
  VAR
   Sum   : NUMERIC[2];
   CURate: FLOAT;
 BEGIN
  L_General.Assert(~!MDocList.Math, " 㪠 ");
  IF ~!MDocList.Sum THEN
   Sum:=MDocList.Sum + MDocList.VAT;
  ELSE
   Sum:=0;
  END;
  CURate:=P_MDoc.GetCURate(P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_BilCURate));
  L_General.Assert(~!CURate & (CURate # 0), "     㬥");
  Sum:=Sum / CURate;
  STDFORM(" |㬬         %R12<2->I"+
          "||           %R12<6.>NI"+
          "||    %<  㬬  㡫  >DB    %<   ⬥   >X  ",
          "  㬬   ", , -1, Sum, CURate);
  CalcByTotal(Sum * CURate);
  MDocList_OnCalculate();
 END {CountCurrency};

 PRIVATE PROCEDURE GetMathName(_Name: LIKE(Math.Name); _Len: NUMERIC[0]): STRING[];
 BEGIN
  RETURN Str.Slice(_Name, 0, Math.Min(_Len, Str.ItemPos(Math.Name, " ", 3)-1));
 END {GetMathName};

 PUBLIC PROCEDURE SplitKeyAss();
  VAR
   i: NUMERIC[0];
   OMVAT,
   OMSum,
   VAT,
   Sum: NUMERIC[2];
 BEGIN
  L_General.Assert(ACCESS(MDocList), " । ப 㬥");
  CONFORM(MDocList, Math);
  L_General.Assert(Math.MathKind = L_MathR.mathk_KeyAs, "ꥪ "+MDocList.Math+"   ꥪ⮬ ");
  Sum:=MDocList.Sum;
  OMSum:=MDocList.Sum/MDocList.Qnt;
  VAT:=MDocList.VAT;
  OMVAT:=MDocList.VAT   /MDocList.Qnt;
  L_StdFrm.Choice(" "+FLDTOSTR(MDocList.Qnt-1, "0")+"  ꥪ "+
                  MDocList.Math+" '"+GetMathName(Math.Name, 40)+
                  "'?|  ꥪ 㬬  :"+L_Money.MoneyToStr(MDoc.Date, "", OMSum)+
                  " :"+L_Money.MoneyToStr(MDoc.Date, "", OMVAT));
  L_StdFrm.Choice(" 㢥७  ᢮ ⢨?");
  i:=MDocList.Qnt-1;
  MDocList.Sum:=OMSum;
  MDocList.Qnt:=1;
  MDocList.VAT:=OMVAT;
  REPLACE(MDocList);
  CONFORM(MDocList, Math);
  WHILE i > 0 DO
   CALL(_Math.InsKeyAsCopy());
   MDocList.Math:=Math.Math;
   SETEMPTY(MDocList.MDLNbr);
   INSERT(MDocList);
   DEC(i);
   DEC(Sum, OMSum);
   DEC(VAT, OMVAT);
  END;
  MDocList.Sum:=Sum;
  MDocList.VAT:=VAT;
  REPLACE(MDocList);
 END {SplitKeyAss};

 PRIVATE PROCEDURE MDocList_Math_OnAskPhase1();
  VAR
   OwnerZone: FORM_ZONE;
 BEGIN
  OwnerZone:=L_WDO.GetOwnerZone(RTI.Get().CurZone.ActiveField);
  GE_WZD_CURSOR(OwnerZone.Window.Name, OwnerZone.Number, MathMrkG);
  IF OCCURE(MathMrkG) THEN
   CHANGESEL(MathMrkG, MarkG, , MathMrkG.MarkG);
   IF SRCINSEL(MathMrkG, EQ, MDocList.Math) THEN
    SE_WZD_POSITION(OwnerZone.Window.Name, OwnerZone.Number, MathMrkG);
   END;
  END;
 END {MDocList_Math_OnAskPhase1};

 PRIVATE PROCEDURE MDocList_Math_OnAskPhase2();
 BEGIN
  MDocList.Math:=MathMrkG.Math;
  REPLACE(MDocList);
 END {MDocList_Math_OnAskPhase2};

 PRIVATE PROCEDURE RemSingleMDocList(VAR Asked: SCAL[2]);
 BEGIN
  TRY [INTEGRITY(INTEGRITY_ON)]
   L_General.CallUs(ACCESS(MDocList));
   CALL(MDocLCU.extRemMDocListMDocLCUs(Asked));
   MDocListBeforeDel();
   REMOVE(MDocList);
  EXCEPT
  END; (* TRY *)
 END {RemSingleMDocList};

 PUBLIC PROCEDURE RemAllMDocList();
  VAR
   Asked: SCAL[2];
 BEGIN
  Asked:=0;
  CONFORM(MDoc, MDocList);
  IF OCCURE(MDocList) THEN
   L_StdFrm.Choice(" 㬥   |믮 ?");
   WHILE OCCURE(MDocList) DO
    RemSingleMDocList(Asked);
   END; (* WHILE OCCURE(MDocList) ... *)
  END;
  RenumerateMDocList();
  L_MDoc.SetMDocTotals(RTI.Get().CurWindow.Name);
 END {RemAllMDocList};

 PUBLIC PROCEDURE RemMarkedMDocList();
  VAR
   Asked: SCAL[2];
 BEGIN
  L_StdFrm.Choice("  㤠 ⬥祭 ப");
  Asked:=0;
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   IF WITHLAB(MDocList, 0) THEN
    RemSingleMDocList(Asked);
   ELSE
    NEXT(MDocList);
   END;
  END; (* WHILE OCCURE(MDocList) ... *)
  RenumerateMDocList();
  L_MDoc.SetMDocTotals(RTI.Get().CurWindow.Name);
 END {RemMarkedMDocList};

 PUBLIC PROCEDURE RemRestMDocList();
  VAR
   Asked: SCAL[2];
 BEGIN
  L_StdFrm.Choice("  㤠 ப  ");
  Asked:=0;
  WHILE ACCESS(MDocList) DO
   RemSingleMDocList(Asked);
  END; (* WHILE OCCURE(MDocList) ... *)
  RenumerateMDocList();
  L_MDoc.SetMDocTotals(RTI.Get().CurWindow.Name);
 END {RemRestMDocList};

 PUBLIC PROCEDURE PrintSticksBySubject();
  VAR
   Idx      : NUMERIC[0];
   PaperForm: STRING[];
   PJ       : PRINTJOB;
 BEGIN
  L_General.Assert(ACCESS(MDocList), " ⠭ ⥪ ப ");
  CONFORM(MDocList, Math);
  PJ:=L_CUC.ps_CreateJob(PaperForm);
  IF SELECT(MDocLCU, MDoc, MDocList.MDocKind, MDocList.MDoc, MDocList.MDLNbr) THEN
   Idx:=0;
   WHILE OCCURE(MDocLCU) DO
    PROMPT(MDocList.Math + " " + MDocLCU.CUCopy);
    L_CUC.PrintStick(PJ, PaperForm, MDocList.Math, MDocLCU.CUCopy);
    INC(Idx);
    NEXT(MDocLCU);
   END; (* WHILE OCCURE(MDocLCU) ... *)
  ELSE
   L_CUC.PrintSticksByMath(PJ, PaperForm, MDocList.Math, MDocList.Qnt);
  END;
  PJ.Close();
 END {PrintSticksBySubject};

 PUBLIC PROCEDURE PrintSticksByPack();
  VAR
   trgQnt   : NUMERIC[0];
   PaperForm: STRING[];
   PJ       : PRINTJOB;
 BEGIN
  L_General.Assert(ACCESS(MDocList), " ⠭ ⥪ ப ");
  PJ:=L_CUC.ps_CreateJob(PaperForm);
  trgQnt:=1;
  STDFORM(L_StdFrm.sf_Choice("|⢮  ஢ %##%", "%L<0>I"),
          "   ", INFORM, , trgQnt);
  L_CUC.PrintSticksByMath(PJ, PaperForm, MDocList.Math, trgQnt);
  PJ.Close();
 END {PrintSticksByPack};

 PUBLIC PROCEDURE FillMDocListCstDclr();
 BEGIN
  L_Pmnt.FindMDocListCstDclr();
 END {FillMDocListCstDclr};

 PUBLIC PROCEDURE InsMDocListInCurPos();
  VAR
   newMDLNbr: LIKE(MDocList.MDLNbr);
 BEGIN
  IF ACCESS(MDocList) THEN
   newMDLNbr:=MDocList.MDLNbr;
  ELSE
   newMDLNbr:=0001;
  END;
  LIKEMENU(Ins, "@ newMDLNbr="+newMDLNbr);
 END {InsMDocListInCurPos};

BEGIN
 L_Events.ExecuteHandler();
END.
