(*
%Copyright   (c) Polak Computer System
%Author      23.07.2001 21:57:21 MOG
%Purpose     뢮   Microsoft Office
%Type        operation
%Specific    SYS
%Modified    18.09.2014 16:30:07 POLAK\LDA
%Environment
*)

 MODULE MDocP_MO [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, FIO, L_General, L_DatTim, L_Money, L_Str, L_MSO, P_Firm, P_Cntr, L_MDoc, L_FIO,
        P_MDoc, L_XDoc, L_EMail, L_APEMl, L_PDoc, L_Pmnt, L_MathR, E_Stock, P_Math,
        L_AFM, L_Acnt, P_OwnData, L_Prop, L_XDR, L_XObj, L_APtm, L_CWOrder, L_Cntr, L_StdFrm,
        L_CarAD, L_Staff, (*㦭 L_MSO  뢮 ப  ᪠஢*) L_CUC, L_Man, L_Car,
        L_Rpr, Math;

 PRIVATE PROCEDURE wordSetMoneyVar(_var: STRING[]; d: DATE; s: NUMERIC[2]);
 BEGIN
  L_MSO.wordSetVar(_var, L_Money.MoneyToStr(d, "", s));
 END {wordSetMoneyVar};

 PRIVATE PROCEDURE IsSystemXDocID(_XDocId: L_XDoc.tXDocId): SCAL[2];
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
   _XDoc    : L_XDoc.tXDoc;
 BEGIN
  L_XDoc.DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
  RETURN (_XDocType = L_XDoc.xdt_MDoc) & (_XDocKind = L_MDoc.md_Amr);
 END {IsSystemXDocID};

 PRIVATE PROCEDURE SetAssetVars(D: DATE; Prefix: STRING[]; VAR TotalCost, Depreciation: L_XObj.tSum);
  VAR
   Str_Saldo01,
   Str_Saldo02,
   Str_AcntSign01,
   Str_AcntSign02,
   Str_AcCut01,
   Str_AcCut02,
   Str_Cir,
   Str_Cir_Depr,   
   Str_AcC_Cr,
   Str_AcC_Dt,
   Str_CAS_Cr,
   Str_CAS_Dt,
   Str_AcC_Cr_Depr,
   Str_AcC_Dt_Depr,
   Str_CAS_Cr_Depr,
   Str_CAS_Dt_Depr  : STRING[];
   Saldo01,
   Saldo02,
   Cir01,
   Cir02,
   DocCir,
   TotalCostBySaldo,
   TotalCostByXDE01 : L_XObj.tSum;
   _BAcCuts,
   _WAcCuts         : L_MathR.tMathAcCutCollection;
   P                : DATE;
   _AcntSign        : LIKE(CAcnt.Sign);
   _AcCut           : LIKE(AcCut.AcCut);
   i                : SCAL[RANGEOF(L_MathR.tMathAcCutCollection)];
   j                : SCAL[L_MathR.KA_NumWearAcnt];
   CurDocID         : L_XDoc.tXDocId;
   CurDocDate       : DATE;
 BEGIN
  TotalCost   :=0;
  Depreciation:=0;
  P:=L_DatTim.NextPer(D);

  CurDocID:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
  CurDocDate:=MDoc.Date;
  SAVE(MDoc);

  CALL(MCM.Math_Recount());
  L_MathR.AccessKeyAssXObject();
  SETEMPTY(Str_AcC_Cr, Str_AcC_Dt, Str_CAS_Cr, Str_CAS_Dt, Str_Cir,
           Str_Saldo01, Str_Saldo02, Str_AcntSign01, Str_AcntSign02, Str_AcCut01, Str_AcCut02,
           Str_AcC_Cr_Depr, Str_CAS_Cr_Depr, Str_AcC_Dt_Depr, Str_CAS_Dt_Depr, Str_Cir_Depr);
  SETZERO(Saldo01, Saldo02, Cir01, Cir02);
  FOR_EACH j DO
   IF j # L_MathR.KA_All THEN
    E_Stock.GetKeyAssBalCostAcCuts(D, _BAcCuts, L_MathR.KA_All, L_MathR.KA_All, j);
    FOR_EACH i DO
     IF !_BAcCuts[i] THEN
      EXIT;
     END;
     Saldo01:=L_MathR.RemaindersR(P, _BAcCuts[i], L_Acnt.ct_Credit);
 
     SETZERO(DocCir);
     SELECT(XDE01, AcCut, , _BAcCuts[i]);
     WHILE OCCURE(XDE01) DO
      IF (XDE01.Prt = L_XDR.xdr_XObject) & (XDE01.XObject = XObject.XObject) & (XDE01.Sum # 0) THEN
       CONFORM(XDE01, Apport);
       IF CurDocID = XDE01.XDocId THEN
        IF Apport.CirType = L_Acnt.ct_Debit THEN
         L_MSO._AddToStr(Str_AcC_Dt, XDE01.AcCut);
         L_MSO._AddToStr(Str_CAS_Dt, L_Acnt.GetCAcntSign(D, XDE01.AcCut));
         L_MSO._AddToStr(Str_AcC_Cr, XDE01.AcCut2);
         L_MSO._AddToStr(Str_CAS_Cr, L_Acnt.GetCAcntSign(D, XDE01.AcCut2));
         INC(DocCir, XDE01.Sum);
         DEC(Saldo01, XDE01.Sum);
        ELSE
         L_MSO._AddToStr(Str_AcC_Cr, XDE01.AcCut);
         L_MSO._AddToStr(Str_CAS_Cr, L_Acnt.GetCAcntSign(D, XDE01.AcCut));
         L_MSO._AddToStr(Str_AcC_Dt, XDE01.AcCut2);
         L_MSO._AddToStr(Str_CAS_Dt, L_Acnt.GetCAcntSign(D, XDE01.AcCut2));
         DEC(DocCir, XDE01.Sum);
         INC(Saldo01, XDE01.Sum);
        END;
       ELSIF ~IsSystemXDocID(XDE01.XDocId) THEN
        L_XDoc.PositionOnXDoc(XDE01.XDocId);
        IF MDoc.Date > CurDocDate THEN
         IF Apport.CirType = L_Acnt.ct_Debit THEN
          DEC(Saldo01, XDE01.Sum);
         ELSE
          INC(Saldo01, XDE01.Sum);
         END;
        END;
       END;
      END;
      NEXT(XDE01);
     END; (* WHILE OCCURE(XDE01) ... *)
     IF DocCir # 0 THEN
      L_MSO._AddToStr(Str_Cir, FLDTOSTR(DocCir, "2-"));
      INC(Cir01, DocCir);
     END;
 
     IF (Saldo01 > 0) THEN
      L_MSO._AddToStr(Str_AcCut01,    _BAcCuts[i]);
      L_MSO._AddToStr(Str_AcntSign01, L_Acnt.GetCAcntSign(D, _BAcCuts[i]));
      L_MSO._AddToStr(Str_Saldo01, FLDTOSTR(Saldo01, "2-"));
      INC(TotalCost, Saldo01);
     END;
    END; (* FOR_EACH i ... *)
 
    E_Stock.GetKeyAssWearAcCuts(D, _WAcCuts, L_MathR.KA_All, L_MathR.KA_All, j);
    IF ~!_WAcCuts[0] THEN
     L_General.CallUs(!_WAcCuts[1]); (*  ஢  ࠧ१  ⨧樨*)
     Saldo02:=L_MathR.RemaindersR(P, _WAcCuts[0], L_Acnt.ct_Debit);
 
     SETZERO(DocCir);
     SELECT(XDE01, AcCut, , _WAcCuts[0]);
     WHILE OCCURE(XDE01) DO
      IF (XDE01.Prt = L_XDR.xdr_XObject) & (XDE01.XObject = XObject.XObject) & (XDE01.Sum # 0) THEN
       CONFORM(XDE01, Apport);
       IF (CurDocID = XDE01.XDocId) THEN
        IF Apport.CirType = L_Acnt.ct_Debit THEN
         L_MSO._AddToStr(Str_AcC_Dt_Depr, XDE01.AcCut);
         L_MSO._AddToStr(Str_CAS_Dt_Depr, L_Acnt.GetCAcntSign(D, XDE01.AcCut));
         L_MSO._AddToStr(Str_AcC_Cr_Depr, XDE01.AcCut2);
         L_MSO._AddToStr(Str_CAS_Cr_Depr, L_Acnt.GetCAcntSign(D, XDE01.AcCut2));
         DEC(DocCir, XDE01.Sum);
         INC(Saldo02, XDE01.Sum);
        ELSE
         L_MSO._AddToStr(Str_AcC_Cr_Depr, XDE01.AcCut);
         L_MSO._AddToStr(Str_CAS_Cr_Depr, L_Acnt.GetCAcntSign(D, XDE01.AcCut));
         L_MSO._AddToStr(Str_AcC_Dt_Depr, XDE01.AcCut2);
         L_MSO._AddToStr(Str_CAS_Dt_Depr, L_Acnt.GetCAcntSign(D, XDE01.AcCut2));
         INC(DocCir, XDE01.Sum);
         DEC(Saldo02, XDE01.Sum);
        END;
       ELSIF ~IsSystemXDocID(XDE01.XDocId) THEN
        L_XDoc.PositionOnXDoc(XDE01.XDocId);
        IF MDoc.Date > CurDocDate THEN
         IF Apport.CirType = L_Acnt.ct_Debit THEN
          INC(Saldo02, XDE01.Sum);
         ELSE
          DEC(Saldo02, XDE01.Sum);
         END;
        END;
       END;
      END;
      NEXT(XDE01);
     END; (* WHILE OCCURE(XDE01) ... *)
     IF DocCir # 0 THEN
      L_MSO._AddToStr(Str_Cir_Depr, FLDTOSTR(DocCir, "2-"));
      INC(Cir02, DocCir);
     END;
 
     IF Saldo02 # 0 THEN
      L_MSO._AddToStr(Str_AcCut02,    _WAcCuts[0]);
      L_MSO._AddToStr(Str_AcntSign02, L_Acnt.GetCAcntSign(D, _WAcCuts[0]));
      L_MSO._AddToStr(Str_Saldo02,    FLDTOSTR(Saldo02, "2-"));
      INC(Depreciation, Saldo02);
     END;
    END; (* IF ~!_WAcCuts[0] ... *)
   END; (* IF j # L_MathR.KA_All ... *)
  END; (* FOR_EACH j ... *)

  RESTORE(MDoc);

  L_MSO.wordSetVar(Prefix + "AcCut_Dt",  Str_AcC_Dt);
  L_MSO.wordSetVar(Prefix + "AcCut_Cr",  Str_AcC_Cr);
  L_MSO.wordSetVar(Prefix + "AcSign_Dt", Str_CAS_Dt);
  L_MSO.wordSetVar(Prefix + "AcSign_Cr", Str_CAS_Cr);
  L_MSO.wordSetVar(Prefix + "Cir_Cost",  Str_Cir);

  L_MSO.wordSetVar(Prefix + "AcCut_Dt_Depr",  Str_AcC_Dt_Depr);
  L_MSO.wordSetVar(Prefix + "AcCut_Cr_Depr",  Str_AcC_Cr_Depr);
  L_MSO.wordSetVar(Prefix + "AcSign_Dt_Depr", Str_CAS_Dt_Depr);
  L_MSO.wordSetVar(Prefix + "AcSign_Cr_Depr", Str_CAS_Cr_Depr);
  L_MSO.wordSetVar(Prefix + "Cir_Depr",       Str_Cir_Depr);

  IF L_MDoc.md_asAPr(MDoc.MDocKind) THEN
   L_MSO.wordSetVar(Prefix + "BalCost",      Str_Cir);
   L_MSO.wordSetVar(Prefix + "Depreciation", Str_Cir_Depr);
   TotalCost   :=Cir01;
   Depreciation:=Cir02;
  ELSE
   L_MSO.wordSetVar(Prefix + "BalCost",      Str_Saldo01);
   L_MSO.wordSetVar(Prefix + "Depreciation", Str_Saldo02);
  END;
  L_MSO.wordSetMoneyVar(Prefix + "Cir",             D, Cir01);
  L_MSO.wordSetMoneyVar(Prefix + "TotCost",         D, TotalCost);
  L_MSO.wordSetMoneyVar(Prefix + "TotDepreciation", D, Depreciation);
  L_MSO.wordSetMoneyVar(Prefix + "DepreciatedCost", D, TotalCost-Depreciation);
  IF MDoc.MDocKind = L_MDoc.md_ADo THEN
   TotalCost:=Cir01;
  END;
  L_MSO.wordSetVar(Prefix + "CorrCAcnt.Sign",  Str_AcntSign02);
  L_MSO.wordSetVar(Prefix + "CorrAcCut.AcCut", Str_AcCut02);
 END {SetAssetVars};

 PRIVATE PROCEDURE PrepareKeyAssObjects(    trgIndex: NUMERIC[0];
                                            curDate : DATE;
                                        VAR TotCost,
                                            TotWear : L_XObj.tSum);
  VAR
   Alias,
   Prefix: STRING[];
 BEGIN
  L_General.Assert(Math.MathKind, Math.Math + "   ");
  IF ~!trgIndex THEN
   PROMPT("⮢ : " + L_Str.IntStr(trgIndex + 1));
   Alias:="Math" + L_MSO.IndexStr(trgIndex);
  ELSE
   Alias:="Math";
  END;
  Prefix:=Alias + ".";
  SAVE(MDocList); SAVE(MDoc);
  L_MathR.Math_setWordVars(curDate, Alias, 0);
  RESTORE(MDoc);  RESTORE(MDocList);

  L_MathR.KACar_setWordVars(curDate, Prefix, 0);
  SetAssetVars(curDate, Prefix, TotCost, TotWear);

  L_MathR.Precious_setWordVars(curDate, Prefix, 0);
  L_MSO.wordSetVarsByFile_wAliasE("MathPro", Prefix + "KARightReg", ~P_Math.HasActualMathPro(Math.Math, curDate, P_Math.P_KARightReg));
 END {PrepareKeyAssObjects};

 PRIVATE PROCEDURE PrepareKeyAssObjects_E(trgIndex: NUMERIC[0]);
  VAR
   Alias,
   Prefix: STRING[];
 BEGIN
  PROMPT("⮢ : " + L_Str.IntStr(trgIndex + 1));
  Alias :="Math" + L_MSO.IndexStr(trgIndex);
  Prefix:=Alias + ".";
  L_MathR.Math_setWordVars (EMPTYOF(DATE), Alias,  1);
  L_MathR.KACar_setWordVars(EMPTYOF(DATE), Prefix, 1);

  L_MSO.wordSetVar(Prefix + "AcCut_Dt",        "");
  L_MSO.wordSetVar(Prefix + "AcCut_Cr",        "");
  L_MSO.wordSetVar(Prefix + "AcSign_Dt",       "");
  L_MSO.wordSetVar(Prefix + "AcSign_Cr",       "");
  L_MSO.wordSetVar(Prefix + "BalCost",         "");
  L_MSO.wordSetVar(Prefix + "TotCost",         "");
  L_MSO.wordSetVar(Prefix + "CorrCAcnt.Sign",  "");
  L_MSO.wordSetVar(Prefix + "CorrAcCut.AcCut", "");
  L_MSO.wordSetVar(Prefix + "Depreciation",    "");
  L_MSO.wordSetVar(Prefix + "Life",            "");
 END {PrepareKeyAssObjects_E};

 PRIVATE PROCEDURE intGetNameAndPost(    curDate : DATE;
                                         curTSN  : LIKE(Staff.TSN);
                                     VAR ManName : LIKE(Man.Name);
                                     VAR PostName: LIKE(Post.Name));
 BEGIN
  IF ~!curTSN THEN
   L_Staff.CheckStringAsTSN(curDate, curTSN, EMPTYOF(PROC));
   ManName :=P_Firm.GetManAttrByTSN(curTSN, curDate, P_Firm.mpt_ManName);
   PostName:=P_Firm.GetManAttrByTSN(curTSN, curDate, P_Firm.mpt_ManPostName);
  ELSE
   SETEMPTY(ManName, PostName);
  END;
 END {intGetNameAndPost};

 PRIVATE PROCEDURE GetNameAndPost(    curTSN  : LIKE(Staff.TSN);
                                  VAR ManName : LIKE(Man.Name);
                                  VAR PostName: LIKE(Post.Name));
 BEGIN
  intGetNameAndPost(GetMDocSrcDate(), curTSN, ManName, PostName);
 END {GetNameAndPost};

 PRIVATE PROCEDURE GetMDocSrcDate(): DATE;
  VAR
   _SrcDate: DATE;
 BEGIN
  SAVE(MDocKind);
  CONFORM(MDoc, MDocKind);
  IF    L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) THEN
   _SrcDate:=MDoc.Date;
  ELSIF MDocKind.Scope = L_MDoc.mds_External THEN
   _SrcDate:=MDoc.SrcDate;
  ELSIF MDocKind.Scope = L_MDoc.mds_Internal THEN
   _SrcDate:=MDoc.Date;
  ELSE
   L_General.CallUs(0);
  END;
  RESTORE(MDocKind);
  RETURN _SrcDate;
 END {GetMDocSrcDate};

 PRIVATE PROCEDURE SetFirmData_wPrefix(_Firm    : LIKE(Firm.Firm);
                                       _FirmAcnt: LIKE(FirmAcnt.FirmAcnt);
                                       Prefix   : STRING[];
                                       D        : DATE);
 BEGIN
  SAVE(Firm);
  P_Firm.SetFirmData(Prefix, _Firm, D, _FirmAcnt, L_MSO.fps_Soft_asStr);
  RESTORE(Firm);
 END {SetFirmData_wPrefix};

 PRIVATE PROCEDURE SetFirmData_wPrefixE(_Firm    : LIKE(Firm.Firm);
                                        _FirmAcnt: LIKE(FirmAcnt.FirmAcnt);
                                        Prefix   : STRING[];
                                        D        : DATE;
                                        Empty    : SCAL[2]);
 BEGIN
  IF Empty THEN
   P_Firm.SetEmptyFirmData(Prefix, "");
  ELSE
   SetFirmData_wPrefix(_Firm, _FirmAcnt, Prefix, D);
  END;
 END {SetFirmData_wPrefixE};

 PRIVATE PROCEDURE SetMDocProp(Prefix: STRING[]; _Property: LIKE(MDocPro.Property); varName: STRING[]);
 BEGIN
  L_MSO.wordSetVar(Prefix + varName,
                   P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, _Property));
 END {SetMDocProp};

 PUBLIC PROCEDURE SetMDocPropStrong(Prefix: STRING[]; _Property: LIKE(MDocPro.Property); varName: STRING[]);
 BEGIN
  L_MSO.wordSetVar(Prefix + varName,
                   P_MDoc.GetMDocProStrong(MDoc.MDocKind, MDoc.MDoc, _Property));
 END {SetMDocPropStrong};

 PRIVATE PROCEDURE SetMDocPropArr(Prefix: STRING[]; _Property: LIKE(MDocPro.Property); varName: STRING[]);
  VAR
   PropArr: LIKE(MDocPro.Value)[2];
 BEGIN
  P_MDoc.GetMDocProArray(MDoc.MDocKind, MDoc.MDoc, _Property, PropArr);
  L_MSO.wordSetVar(Prefix + varName + "[0]", PropArr[0]);
  L_MSO.wordSetVar(Prefix + varName + "[1]", PropArr[1]);
 END {SetMDocPropArr};

 PRIVATE PROCEDURE SetGroundVars();
  VAR
   BO_Name,
   BO_DocNum: STRING[];
   BO_Date  : DATE;
 BEGIN
  P_MDoc.Decode_KeyAssBaseOrder(P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_KeyAssBaseOrder),
                                BO_Name, BO_DocNum, BO_Date);
  L_MSO.wordSetVar    ("MDoc.Ground",        BO_Name);
  L_MSO.wordSetVar    ("MDoc.Ground.DocNum", BO_DocNum);
  L_MSO.wordSetDateVar("MDoc.Ground.Date",   BO_Date);
 END {SetGroundVars};

 PRIVATE PROCEDURE GetFirmAcnt(_Firm: LIKE(Firm.Firm); D: DATE): LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  IF P_Firm.SoftAccessSilentFirmAcnt(_Firm, D) THEN
   RETURN FirmAcnt.FirmAcnt;
  ELSE
   RETURN EMPTYOF(FirmAcnt.FirmAcnt);
  END;
 END {GetFirmAcnt};

 PRIVATE PROCEDURE SetFirmDataForKeyAss(byOwn, byFirm: STRING[]; _Firm: LIKE(MDoc.Firm); D: DATE);
  VAR
   OwnFirm: LIKE(Firm.Firm);
 BEGIN
  OwnFirm:=P_Firm.fomf(MDoc.MyFirm);
  IF !_Firm | (_Firm = OwnFirm) THEN
   P_Firm.SetEmptyFirmData(byFirm, "");
  ELSE
   SetFirmData_wPrefix(_Firm, GetFirmAcnt(_Firm, D), byFirm, D);
  END;
  SetFirmData_wPrefix(OwnFirm, GetFirmAcnt(OwnFirm, D), byOwn, D);
 END {SetFirmDataForKeyAss};

 PRIVATE PROCEDURE SetMDocTSNAsSideOfAct(Prefix: STRING[]);
  VAR
   ManName,
   PostName: STRING[];
 BEGIN
  GetNameAndPost(MDoc.TSN, ManName, PostName);
  L_MSO.wordSetVar(Prefix + "TSN",  MDoc.TSN);
  L_MSO.wordSetVar(Prefix + "Name", ManName);
  L_MSO.wordSetVar(Prefix + "Post", PostName);
  CONFORM(StaffLog, Sort);
  L_MSO.wordSetVarsByFile_wPrefix("Sort", Prefix);
 END {SetMDocTSNAsSideOfAct};

 PRIVATE PROCEDURE SetKAResponsibleAsSideOfAct(Prefix: STRING[]);
  VAR
   _Date   : DATE;
   ManName,
   PostName: STRING[];
 BEGIN
  _Date:=GetMDocSrcDate();
  SAVE(MDoc);
  IF L_MDoc.PosToLastKeyAssChangeResponsibleMDoc(Math.Math, MDoc.Date - 1) THEN
   intGetNameAndPost(_Date, MDoc.TSN, ManName, PostName);
   CONFORM(StaffLog, Sort);
   L_MSO.wordSetVar(Prefix + "TSN",  MDoc.TSN);
   L_MSO.wordSetVar(Prefix + "Name", ManName);
   L_MSO.wordSetVar(Prefix + "Post", PostName);
   L_MSO.wordSetVarsByFile_wPrefix("Sort", Prefix);
  ELSE
   L_MSO.wordSetVar(Prefix + "TSN",  "");
   L_MSO.wordSetVar(Prefix + "Name", "");
   L_MSO.wordSetVar(Prefix + "Post", "");
   L_MSO.wordSetVarsByFile_wPrefixE("Sort", Prefix, 1);
  END;
  RESTORE(MDoc);
 END {SetKAResponsibleAsSideOfAct};

 PRIVATE PROCEDURE _GetCounterFirm(Nxt: SCAL[2]): LIKE(MDoc.Firm);
  VAR
   _Firm: LIKE(MDoc.Firm);
   HasCntMDK: SCAL[2];
 BEGIN
  SETEMPTY(_Firm);
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   SAVE(MDocList);
   CHANGESEL(MDocList, Math, , MDocList.Math, MDocList.Date);
   IF Nxt THEN
    FIRST(MDocList);
   ELSE
    LAST(MDocList);
   END;
   HasCntMDK:=0;
   CHANGESEL(MDocList, Math, , MDocList.Math);
   WHILE OCCURE(MDocList) DO
    IF L_Pmnt.IsAcptMDocKind(MDocList.MDocKind) THEN
     CONFORM(MDocList, MDoc);
     IF (MDoc.Status # L_MDoc.st_Canceled) &
        P_Cntr.GetInHouse(MDoc.Contract, MDoc.Date) THEN
      HasCntMDK:=1;
      IF !_Firm THEN
       _Firm:=MDoc.Firm;
      ELSIF _Firm # MDoc.Firm THEN
       RESTORE(MDocList);
       RETURN "";
      END;
     END;
    END; (* IF L_Pmnt.IsAcptMDocKind(MDocList.MDocKind) ...*)
    IF Nxt THEN
     NEXT(MDocList);
    ELSE
     PREV(MDocList);
    END;
   END; (* WHILE OCCURE(MDocList) ... *)
   RESTORE(MDocList);
   IF ~HasCntMDK THEN
    RETURN "";
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  RETURN _Firm;
 END {_GetCounterFirm};

 PRIVATE PROCEDURE GetCounterFirm(): LIKE(MDoc.Firm);
  VAR
   Nxt        : SCAL[2];
   _Firm      : LIKE(MDoc.Firm);
 BEGIN
  IF    (MDoc.MDocKind = L_MDoc.md_APr) THEN
   Nxt:=0;
  ELSIF (MDoc.MDocKind = L_MDoc.md_AVb) THEN
   Nxt:=1;
  ELSE
   RETURN MDoc.Firm;
  END;
  SAVE(MDoc);
  _Firm:=_GetCounterFirm(Nxt);
  RESTORE(MDoc);
  IF ~!_Firm THEN
   RETURN _Firm;
  ELSE
   RETURN MDoc.Firm;
  END;
 END {GetCounterFirm};

 PRIVATE PROCEDURE SetBaileeData();
  CONST
   Prefix = "MDoc.Bailee.";
  VAR
   D       : DATE;
   dvrMDoc : LIKE(MDoc.MDoc);
   ManName : LIKE(Man.Name);
   PostName: LIKE(Post.Name);
   HasDub  : SCAL[2];
 BEGIN
  D:=MDoc.Date;
  SETEMPTY(dvrMDoc);
  IF L_MDoc.md_asAPr(MDoc.MDocKind) THEN
   SAVE(MDoc);
   HasDub:=0;
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) & ~HasDub DO
    SAVE(MDocList);
    SETSEL(MDocList, Math, MDocList.Math);
    SRCINSEL(MDocList, LE, , D);
    WHILE OCCURE(MDocList) & ~HasDub DO
     IF MDocList.MDocKind = L_MDoc.md_Dvr THEN
      CONFORM(MDocList, MDoc);
      IF MDoc.Status = L_MDoc.st_Passed THEN
       IF    !dvrMDoc THEN
        dvrMDoc:=MDoc.MDoc;
       ELSIF dvrMDoc # MDoc.MDoc THEN
        L_StdFrm.Choice(" ᪮쪮 ७⥩  祭 , ਬ "+MDoc.MDoc+"  "+dvrMDoc+
                        "|⢥騩 ࠧ   㤥 ");
        SETEMPTY(dvrMDoc);
        HasDub:=1;
       END;
      END; (* IF MDoc.Status = ... *)
     END; (* IF MDocList.MDocKind = ... *)
     PREV(MDocList);
    END; (* WHILE OCCURE(MDocList) ... *)
    RESTORE(MDocList);
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
   RESTORE(MDoc);
  END;
  IF ~!dvrMDoc THEN
   SAVE(MDoc);
   SEARCH(MDoc, MDoc, , L_MDoc.md_Dvr,     dvrMDoc);
   L_MSO.wordSetVar    (Prefix+"MDoc",     MDoc.SrcNbr);
   L_MSO.wordSetDateVar(Prefix+"MDocDate", MDoc.SrcDate);
   L_MSO.wordSetVar    (Prefix+"TSN",      MDoc.TSN);
   GetNameAndPost(MDoc.TSN, ManName, PostName);
   L_MSO.wordSetVar    (Prefix+"Name",     ManName);
   L_MSO.wordSetVar    (Prefix+"Post",     PostName);
   RESTORE(MDoc);
  ELSE
   L_MSO.wordSetVar(Prefix+"MDoc",  "");
   L_MSO.wordSetDateVar(Prefix+"MDocDate", EMPTYOF(DATE));
   L_MSO.wordSetVar(Prefix+"TSN",   "");
   L_MSO.wordSetVar(Prefix+"Name",  "");
   L_MSO.wordSetVar(Prefix+"Post",  "");
  END;
 END {SetBaileeData};

 PRIVATE PROCEDURE pkamd_SetCommisMemberVars(Prefix: STRING[]; trgTSN: LIKE(Staff.TSN); Num: NUMERIC[0]);
  VAR
   ManName   : LIKE(Man.Name);
   PostName  : LIKE(Post.Name);
   CommissWho: STRING[];
 BEGIN
  GetNameAndPost(trgTSN, ManName, PostName);
  IF    Num = 0 THEN CommissWho:="।ᥤ⥫ ᨨ";
  ELSIF Num = 1 THEN CommissWho:=" ᨨ:";
  ELSE               CommissWho:="";
  END;
  L_MSO.wordSetVar_wIndex(Prefix+"CommWho",    CommissWho,  Num);
  L_MSO.wordSetVar_wIndex(Prefix+"Commission", ManName,     Num);
  L_MSO.wordSetVar_wIndex(Prefix+"CommPost",   PostName,    Num);
 END {pkamd_SetCommisMemberVars};

 PRIVATE PROCEDURE pkamd_SetCommissionVars(Prefix           : STRING[];
                                           Chairman         : LIKE(Staff.TSN);
                                           Members          : LIKE(Staff.TSN)[P_OwnData.CommissMembersAmnt];
                                           OrderOfCommission: STRING[];
                                           Amount           : NUMERIC[0]);
  VAR
   Idx,
   LineCnt: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("㧪 ᢥ  童 ᨨ");
  SETZERO(Idx, LineCnt);
  pkamd_SetCommisMemberVars(Prefix, Chairman, Idx);
  INC(Idx);
  INC(LineCnt);
  WHILE Idx <= Amount DO
   IF ~!Members[Idx-1] THEN
    PROMPT(" " + Members[Idx-1]);
    pkamd_SetCommisMemberVars(Prefix, Members[Idx-1], LineCnt);
    INC(LineCnt);
   END;
   INC(Idx);
  END;
  WHILE LineCnt <= 4 DO
   pkamd_SetCommisMemberVars(Prefix, EMPTYOF(Staff.TSN), LineCnt);
   INC(LineCnt);
  END; (* WHILE LineCnt <= 4...*)

  L_MSO.wordSetVar(Prefix+"CommAssign",  OrderOfCommission);
  L_MSO.extSetWordTable("tableCommission", LineCnt, L_MSO.tt_Soft);
 END {pkamd_SetCommissionVars};

 PRIVATE PROCEDURE PrepareKeyAssetsMDoc(D: DATE; Root: STRING[]);
  VAR
   Count            : NUMERIC[0];
   Cir_2            : L_XObj.tQnt;
   Cir_0,
   BalCost,
   BalWear,
   TotalCost,
   TotalWear        : L_XObj.tSum;
   _Sort,
   Life,
   Dummy            : STRING[];
   Chairman         : LIKE(Staff.TSN);
   Members          : LIKE(Staff.TSN)[P_OwnData.CommissMembersAmnt];
   OrderOfCommission: STRING[];
   Description      : STRING[];
   Prefix           : STRING[];
   _Firm            : LIKE(MDoc.Firm);
   aprvl_TSN        : LIKE(Staff.TSN);
   aprvl_Name,
   aprvl_PostName   : STRING[];
 BEGIN
  L_APtm.wordSetTheDocCauseAndDraftsman(D, "⢥ত ⠭ ᪮ ᨨ  21.01.2003  7", "");
  Prefix:="MDoc.";
  CONFORM(MDoc, Alower);
  L_MSO.wordSetVarsByFile_wAliasE("Alower", "Alower", ~OCCURE(Alower));

  CONFORM(MDoc, Firm);
  SetFirmData_wPrefixE(MDoc.Firm, GetFirmAcnt(MDoc.Firm, D), Prefix, D, ~OCCURE(Firm));

  IF L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) THEN
   L_XDR.PrepareEntryList(L_XDoc.xdt_MDoc, EMPTYOF(DATE), 0);
   IF    (MDoc.MDocKind = L_MDoc.md_APr) |
         (MDoc.MDocKind = L_MDoc.md_ADo) THEN
    SetFirmDataForKeyAss("Reciever", "Deliver", GetCounterFirm(), D);
   ELSIF (MDoc.MDocKind = L_MDoc.md_AVb) THEN
    SetFirmDataForKeyAss("Deliver", "Reciever", MDoc.Firm,        D);
   END;
   IF (MDoc.MDocKind = L_MDoc.md_APr) |
      (MDoc.MDocKind = L_MDoc.md_APP) |
      (MDoc.MDocKind = L_MDoc.md_AVb) |
      (MDoc.MDocKind = L_MDoc.md_ADo) |
      (MDoc.MDocKind = L_MDoc.md_APO) THEN
    CONFORM(MDoc, MDocList);
    IF OCCURE(MDocList) THEN
     L_MDoc.CheckMDocKAGroup();
     L_MathR.PosToKAG(MDocList.Math, MDoc.Date);
     L_MSO.wordSetVar(Prefix+"KAGroup.Name", KAGroup.Name);
    ELSE
     L_MSO.wordSetVar(Prefix+"KAGroup.Name", " ");
    END;
   END;

   Count:=0;
   TotalCost:=0;
   TotalWear:=0;
   SELECT(MDocList, MDLMath, , MDoc.MDocKind, MDoc.MDoc);
   WHILE OCCURE(MDocList) DO
    NARROWSEL(MDocList, Math);
    CONFORM(MDocList, Math);
    L_MSO.wordSetVarsByFile_wIndex("MDocList", Count, 0);
    SAVE(MDoc);
    SAVE(MDocList);
    PrepareKeyAssObjects(Count, MDoc.Date, BalCost, BalWear);
    INC(TotalCost, BalCost);
    INC(TotalWear, BalWear);
    L_MSO.wordSetVar_wIndex("Idx", L_Str.IntStr(Count + 1), Count);
    RESTORE(MDocList);
    RESTORE(MDoc);
    NEXTINEXTENDEDSEL(MDocList, Math);
    INC(Count);
   END; (* WHILE OCCURE(MDocList) ... *)
   L_MSO.wordSetMoneyVar(Prefix+"TotalCost",         MDoc.Date, TotalCost);
   L_MSO.wordSetMoneyVar(Prefix+"TotalDepreciation", MDoc.Date, TotalWear);

   IF (MDoc.MDocKind = L_MDoc.md_APr) |
      (MDoc.MDocKind = L_MDoc.md_APP) |
      (MDoc.MDocKind = L_MDoc.md_AVb) |
      (MDoc.MDocKind = L_MDoc.md_ASO) |
      (MDoc.MDocKind = L_MDoc.md_APc) |
      (MDoc.MDocKind = L_MDoc.md_APO) THEN
    IF ((MDoc.MDocKind = L_MDoc.md_APP) |
        (MDoc.MDocKind = L_MDoc.md_ASO)) & NeedNewForm() THEN
     WHILE Count < 24 DO
      PrepareKeyAssObjects_E(Count);
      L_MSO.wordSetVar_wIndex("Idx", "", Count);
      INC(Count);
     END;
     L_MSO.SetWordTable("table1", Count);
    ELSIF (MDoc.MDocKind = L_MDoc.md_ASO) THEN
     L_MSO.SetWordTable("table2", Count);
    ELSE
     L_MSO.extSetWordTable("table1", Count, L_MSO.tt_Soft);
     L_MSO.extSetWordTable("table2", Count, L_MSO.tt_Soft);
     L_MSO.extSetWordTable("table3", Count, L_MSO.tt_Soft);
    END;
   ELSIF ((MDoc.MDocKind = L_MDoc.md_ASp) |
          (MDoc.MDocKind = L_MDoc.md_ADo)) & NeedNewForm() THEN
    L_MSO.SetWordTable("table1", Count);
    L_MSO.SetWordTable("table2", Count);
   END;
  ELSIF (MDoc.MDocKind = L_MDoc.md_NPr) |
        (MDoc.MDocKind = L_MDoc.md_VTN) |
        (MDoc.MDocKind = L_MDoc.md_ViP) |
        (MDoc.MDocKind = L_MDoc.md_FPk) |
        (MDoc.MDocKind = L_MDoc.md_RPk) THEN
   Count:=0;
   CONFORM(MDoc, MDocList);
   IF ~OCCURE(MDocList) THEN
    L_MSO.wordSetVarsByFile_wIndex("MDocList", 0, 1);
   END;
   SETZERO(Cir_0, Cir_2);
   WHILE OCCURE(MDocList) DO
    CONFORM(MDocList, Math, MUnit, MathType);
    L_General.Assert(Math.MathKind, Math.Math + "   ");
    L_MathR.StandOnVendor();
    L_MSO.wordSetVarsByFile_wIndex("Math",     Count, 0);
    L_MSO.wordSetVar("Math" + L_MSO.IndexStr(Count) + ".Math", L_MathR.E_KeyAssInv(D));
    L_MSO.wordSetVarsByFile_wIndex("MathType", Count, 0);
    L_MSO.wordSetVarsByFile_wIndex("MUnit",    Count, 0);
    L_MSO.wordSetVarsByFile_wPrefixE("Vendor",
                                     "Math" + L_MSO.IndexStr(Count) + ".",
                                     Math.Vendor = 00);
    L_MSO.wordSetMoneyVar("MDocList" + L_MSO.IndexStr(Count) + ".Cir[0]",
                          MDoc.Date, MDocList.Sum + MDocList.VAT);
    L_MSO.wordSetVar("MDocList" + L_MSO.IndexStr(Count) + ".Cir[2]",
                     L_Str.IntStr(MDocList.Qnt));
    INC(Cir_0, MDocList.Sum + MDocList.VAT);
    INC(Cir_2, MDocList.Qnt);
    NEXT(MDocList);
    INC(Count);
   END; (* WHILE OCCURE(MDocList) ... *)
   L_MSO.wordSetMoneyVar(Prefix+"Cir[0]", MDoc.Date, Cir_0);
   L_MSO.wordSetVar(Prefix+"Cir[2]", L_Str.IntStr(Cir_2));
   L_MSO.SetWordTable("table1", Count);
   L_MSO.SetWordTable("table2", Count);
  ELSE
   L_General.Error(" 蠡 Word  ⠪ 㬥⮢");
  END;

  IF     MDoc.MDocKind = L_MDoc.md_AVb THEN
   Dummy:=P_MDoc.GetMDocProStrong(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Through);
   L_MSO.wordSetVar(Prefix+"TakeTSN",  "");
   L_MSO.wordSetVar(Prefix+"TakeName", Str.Item(Dummy, ";", 0));
   L_MSO.wordSetVar(Prefix+"TakePost", Str.Item(Dummy, ";", 1));
   L_MSO.wordSetVar(Prefix+"TakeSort.Sort", MDoc.Firm);
   L_MSO.wordSetVar(Prefix+"TakeSort.Name", P_Firm.FP_FirmName(MDoc.Firm, GetMDocSrcDate()));
  ELSIF MDoc.MDocKind = L_MDoc.md_ADo THEN
   SetKAResponsibleAsSideOfAct(Prefix+"Take");
  ELSE
   SetMDocTSNAsSideOfAct(Prefix+"Take");
  END;

  IF (MDoc.MDocKind = L_MDoc.md_AVb) | (MDoc.MDocKind = L_MDoc.md_ADo) | (MDoc.MDocKind = L_MDoc.md_APc) THEN
   SetMDocTSNAsSideOfAct(Prefix+"Deliver");
  ELSE
   SetKAResponsibleAsSideOfAct(Prefix+"Deliver");
  END;

  IF P_MDoc.HasActualMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Approval) THEN
   P_MDoc.Decode_Approval(MDocPro.Value, aprvl_TSN, aprvl_Name, aprvl_PostName);
  ELSE
   SETEMPTY(aprvl_Name, aprvl_PostName);
  END;
  L_MSO.wordSetVar(Prefix+"Approval",     aprvl_Name);
  L_MSO.wordSetVar(Prefix+"ApprovalPost", aprvl_PostName);

  SetMDocPropArr(Prefix, P_MDoc.P_Findings,   "Findings");
  SetMDocPropArr(Prefix, P_MDoc.P_ListOfDocs, "ListOfDocs");

  Description:="";
  CONFORM(MDoc, MDocList);
  IF OCCURE(MDocList) THEN
   Description:=P_Math.GetMathProSoft(MDocList.Math, GetMDocSrcDate(), P_Math.P_Description);
  END;
  L_MSO.wordSetVar(Prefix+"Description", Description);

  SetGroundVars();
  SetMDocProp(Prefix, P_MDoc.P_KeyAssAddress,       "Whereabouts");
  SetMDocProp(Prefix, P_MDoc.P_KeyAssMovReason,     "BaseOfMoving");
  SetMDocProp(Prefix, P_MDoc.P_KeyAssWhatNotProper, "WhatNotProper");
  SetMDocProp(Prefix, P_MDoc.P_KeyAssWhatNeed,      "WhatNeedToComplete");
  SetMDocProp(Prefix, P_MDoc.P_KeyAssTestResult,    "TestResult");
  SetMDocProp(Prefix, P_MDoc.P_Reason,              "Reason");
  SetMDocProp(Prefix, P_MDoc.P_Condition,           "Condition");
  SetMDocProp(Prefix, P_MDoc.P_AboutGIBDD,          "AboutGIBDD");
  SetMDocProp(Prefix, P_MDoc.P_Results,             "Results");

  IF P_MDoc.HasActualMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Commission) THEN
   P_MDoc.Decode_Commission(MDocPro.Value, Chairman, Members, OrderOfCommission);
   pkamd_SetCommissionVars(Prefix, Chairman, Members, OrderOfCommission, P_MDoc.CommissMembersAmnt);
  ELSE
   P_OwnData.Decode_Commiss(P_OwnData.GetOwnDProStrong(GetMDocSrcDate(), P_OwnData.P_RetirementCommiss),
                            Chairman, Members, OrderOfCommission);
   pkamd_SetCommissionVars(Prefix, Chairman, Members, OrderOfCommission, P_OwnData.CommissMembersAmnt);
  END;

  L_MSO.wordSetVar(Prefix+"Sort",   "");
  SetBaileeData()
 END {PrepareKeyAssetsMDoc};

 PRIVATE PROCEDURE wordPutVATText(r: STRING[]; D: DATE; _vat: NUMERIC[2]);
  VAR
   satVAT: P_Cntr.tSpecialAttitudeToVAT;
 BEGIN
  IF ~!MDoc.Contract THEN
   satVAT:=P_Cntr.GetSpecialAttitudeToVAT(MDoc.Contract, D);
  ELSE
   satVAT:=P_Cntr.satVAT_woFeatures;
  END;
  L_MSO.wordSetVar(r + "Contract.SpecialAttitudeToVAT", L_Str.IntStr(satVAT));
  IF    !_vat THEN
   L_MSO.wordSetVar(r + "VAT.Text", "");
  ELSIF satVAT = P_Cntr.satVAT_Seller_wENVD THEN
   L_MSO.wordSetVar(r + "VAT.Text", "  (ᮣ᭮ 㭪 4  346.26  , ࣠樨  " +
                                    "㠫 ।ਭ⥫, 騥 ⥫騪  " +
                                    ",  ਧ ⥫騪    ⮨)");
  ELSIF satVAT = P_Cntr.satVAT_Seller_wUSNO THEN
   L_MSO.wordSetVar(r + "VAT.Text", "  (ᮣ᭮ 㭪 2  346.11  , ࣠樨, " +
                                    "ਬ騥 饭 ⥬ ,  ਧ " +
                                    "⥫騪    ⮨)");
  ELSE
   L_MSO.wordSetVar(r + "VAT.Text", L_Money.MoneyToStr(MDoc.Date, "", _vat) + " (" + L_Money.ByWord(_vat) + ")");
  END;
 END {wordPutVATText};

 PRIVATE PROCEDURE setEmptyAltMUnit(r: STRING[]);
 BEGIN
  L_MSO.wordSetVar(r+"AltMUnit.Amount",      "");
  L_MSO.wordSetVar(r+"AltMUnit.Price",       "");
  L_MSO.wordSetVar(r+"AltMUnit.Price.Total", "");
  L_MSO.wordSetVarsByFile_wPrefixE("MathUnit", r+"Math.Alt", 1);
  L_MSO.wordSetVarsByFile_wPrefixE("MUnit",    r+"Math.AltMathUnit.", 1);
 END {setEmptyAltMUnit};

 PRIVATE PROCEDURE mdOnM11(_MDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind = L_MDoc.md_NOV) |
         (_MDocKind = L_MDoc.md_TOV) |
         (_MDocKind = L_MDoc.md_ViP) |
         (_MDocKind = L_MDoc.md_MSP) ;
 END {mdOnM11};

 PRIVATE PROCEDURE NeedPriceInM11(): SCAL[2];
 BEGIN
  IF L_General.GetAPSiteNumber() = 84 THEN
   RETURN 1;
  ELSIF L_APtm.IsMTA() THEN
   IF MDoc.Date >= 01\12\2012 THEN
    RETURN 1;
   ELSE
    RETURN (L_General.GetAPSiteNumber() = 50) | (L_General.GetAPSiteNumber() = 27);
   END;
  ELSE
   RETURN 0;
  END;
 END {NeedPriceInM11};

 PRIVATE PROCEDURE PutSingleMDocList(    Prefix  : STRING[];
                                         i       : NUMERIC[0];
                                     VAR t_Netto,
                                         t_VAT   : L_XObj.tSum;
                                     VAR j       : NUMERIC[0]);
  VAR
   r,
   SerialLst,
   _vatprc,
   trgMathFullName: STRING[];
   k,
   _pos         : NUMERIC[0];
   AltAmount,
   _amount      : L_XObj.tQnt;
   _netto,
   _vat,
   _total,
   _priceNetto,
   _priceTotal  : L_XObj.tSum;
   arrMath  : LIKE(Math.Math)[P_Math.cs_Amount];
   arrAmount: NUMERIC[0][P_Math.cs_Amount];
   arrType  : P_Math.tCompositionSetType[P_Math.cs_Amount];
 BEGIN
  PROMPT(" " + MDocList.Math);
  SETEMPTY(_pos, _amount, _priceNetto, _priceTotal, _netto, _vatprc, _vat, _total, trgMathFullName);
  CONFORM(MDocList, Math);
  CONFORM(Math, MUnit);
  CONFORM(Math, MathType);
  L_MathR.StandOnVendor();
  _amount:=MDocList.Qnt;
(*?*)
  IF    L_MDoc.E_MDocListIsPartOfComplex(MDoc.Date) THEN
   trgMathFullName:="    ";
  ELSE
   INC(j);
   _pos   :=j;

   IF mdOnM11(MDoc.MDocKind) & NeedPriceInM11() & (L_MDoc.getMDocListMathFlowType() = L_MDoc.mft_Credit) THEN
    _netto:=L_MathR.GetMDLMathPrice()* MDocList.Qnt;
   ELSE
    _netto :=MDocList.Sum;
   END;
   _vat   :=MDocList.VAT;
   IF L_MathR.E_IsComplexMath(MDoc.Date) THEN
    SAVE(MDocList);
    NEXT(MDocList);
(*?*)
    WHILE OCCURE(MDocList) & L_MDoc.E_MDocListIsPartOfComplex(MDoc.Date) DO
     INC(_netto, MDocList.Sum);
     INC(_vat,   MDocList.VAT);
     NEXT(MDocList);
    END;
    RESTORE(MDocList);
    L_General.Assert(((_netto=MDocList.Sum)|(MDocList.Sum=0))
                    &((_vat  =MDocList.VAT)   |(MDocList.VAT   =0)),
                     "    㬬  ,     ஢|ப "+MDocList.MDLNbr);
   END;
   _total :=_netto+_vat;
   _vatprc:=L_Str.PoolItem(L_Pmnt.vr_Pool, L_Pmnt.GetMDocListVATRate());
   IF _amount#0 THEN
    IF _netto#0 THEN
     _priceNetto:=_netto/_amount;
    END;
    IF _total#0 THEN
     _priceTotal:=_total/_amount;
    END;
   END;
   INC(t_Netto, _netto);
   INC(t_VAT,   _vat);
  END;
  INC(trgMathFullName, Math.Name);
  IF SEARCH(MDocPro, MDoc, MDocList.MDocKind, MDocList.MDoc, P_MDoc.P_AddMDLNames, MDocList.MDLNbr) THEN
   INC(trgMathFullName, " (" + MDocPro.Value + ")");
  END;
  IF ~!MDoc.Contract  THEN
   IF L_Pmnt.E_MathIsService() & (P_Cntr.GetMakeBillsPayMode(Contract.Contract, MDoc.Date) = P_Cntr.mbpm_Recurrent) THEN
    INC(trgMathFullName, "  "+L_DatTim.PeriodStr(MDoc.Date));
   END;
   IF ~!P_Cntr.GetCntrProSoft(Contract.Contract, GetMDocSrcDate(), P_Cntr.P_SingleMath) THEN
    INC(trgMathFullName, "   "+Contract.SrcNbr+"  "+L_DatTim.DateStr(Contract.SrcDate));
   END;
  END;
  IF (MDoc.MDocKind=L_MDoc.md_IsS) & P_Math.IsCompositeMath(MDocList.Math, MDoc.Date) THEN
   SAVE(MDocList);
   SAVE(Math);
   P_Math.Decode_CompositionSet(P_Math.GetMathProSoft(MDocList.Math, MDoc.Date, P_Math.P_CompositionSet), arrMath, arrAmount, arrType);
   k:=0;
   WHILE (k < P_Math.cs_Amount) & ~!arrMath[k] DO
    L_General.Assert(SEARCH(Math, Math, arrMath[k]), "    - " + arrMath[k]);
    IF P_Math.GetCompositionSetType(arrType[k]) = 1 THEN
     INC(trgMathFullName, CHR(11) + "        " + Math.Name);
     IF arrAmount[k] # 1 THEN
      INC(trgMathFullName, " (" + L_MathR.DefaultFormatCir(Math.Math, arrAmount[k]) + " " +
                           L_MathR.DefaultMUnitSign(Math.Math) + ")");
     END;
    END;
    INC(k);
   END;
   RESTORE(Math);
   RESTORE(MDocList);
  END;
  IF L_Pmnt.E_IsSellMDoc() & L_Pmnt.E_IsAcptMDoc() THEN
   SAVE(MDocLCU);
   CONFORM(MDocList, MDocLCU);
   SerialLst:="";
   WHILE OCCURE(MDocLCU) DO
    CONFORM(MDocLCU, CUCopy);
    IF ~!SerialLst THEN
     SerialLst:=SerialLst+", ";
    END;
    SerialLst:=SerialLst+CUCopy.Serial;
    NEXT(MDocLCU);
   END;
   IF ~!SerialLst THEN
    INC(trgMathFullName, "; .  "+SerialLst);
   END;
   RESTORE(MDocLCU);
  END;
  r:=Prefix+"MDocList"+L_MSO.IndexStr(i);
  L_MSO.wordSetVarsByFile_wAlias("MDocList", r);
  r:=r+".";
  IF ~!i THEN
   L_MSO.wordSetVar    (r+"Index",         L_Str.IntStr(i));
  END;
  L_MSO.wordSetVar     (r+"Pos",           L_Str.IntStr(_pos));
  IF MUnit.Real THEN
   L_MSO.wordSetVarsByFile_wPrefix("MUnit", r+"Math.");
   L_MSO.wordSetVar    (r+"Price",          L_Money.MoneyToStr(MDoc.Date, "", _priceNetto));
   L_MSO.wordSetVar    (r+"Price.Total",    L_Money.MoneyToStr(MDoc.Date, "", _priceTotal));
   L_MSO.wordSetVar    (r+"Amount",         L_MathR._FormatCir(_amount, Math.MUnit));
   L_MSO.wordSetVar    (r+"Amount.ByWord",  L_MathR._AmountByWord(_amount, Math.MUnit));
   IF MDocList.MUNbr # 000 THEN
    SEARCH(MathUnit, Math, , MDocList.Math, MDocList.MUNbr);
    CONFORM(MathUnit, MUnit);

    L_MSO.wordSetVarsByFile_wPrefix("MathUnit", r+"Math.Alt");
    L_MSO.wordSetVarsByFile_wPrefix("MUnit", r+"Math.AltMathUnit.");
    AltAmount:=Math.Round(MDocList.Qnt / MathUnit.Ratio, Math.Pow(0.1, MUnit.Format));
    IF AltAmount # 0 THEN
     IF _netto # 0 THEN
      L_MSO.wordSetVar  (r+"AltMUnit.Price",          L_Money.MoneyToStr(MDoc.Date, "", _netto/AltAmount));
      L_MSO.wordSetVar  (r+"AltMUnit.Price.Total",    L_Money.MoneyToStr(MDoc.Date, "", _total/AltAmount));
     ELSE
      L_MSO.wordSetVar    (r+"AltMUnit.Price",       "");
      L_MSO.wordSetVar    (r+"AltMUnit.Price.Total", "");
     END;
    ELSE
     L_MSO.wordSetVar  (r+"AltMUnit.Price",          "-");
     L_MSO.wordSetVar  (r+"AltMUnit.Price.Total",    "-");
    END;
    L_MSO.wordSetVar   (r+"AltMUnit.Amount", L_MathR._FormatCir(AltAmount, MUnit.MUnit));
   ELSE
    setEmptyAltMUnit(r);
   END;
  ELSE
   L_MSO.wordSetVar    (r+"Price",          "-");
   L_MSO.wordSetVar    (r+"Price.Total",    "-");
   L_MSO.wordSetVar    (r+"Amount",         "-");
   L_MSO.wordSetVar    (r+"Amount.ByWord",  "-");
   L_MSO.wordSetVar    (r+"Math.MUnit.Sign",    "-");
   L_MSO.wordSetVar    (r+"Math.MUnit.Code",    "-");
   L_MSO.wordSetVar    (r+"Math.MUnit.NatSimb", "-");
   setEmptyAltMUnit(r);
  END;
  L_MSO.wordSetVar     (r+"Netto",          L_Money.MoneyToStr(MDoc.Date, "", _netto));
  L_MSO.wordSetVar     (r+"VATPrc",         _vatprc);
  L_MSO.wordSetMoneyVar(r+"VAT", MDoc.Date, _vat);
  L_MSO.wordSetVar     (r+"Total",          L_Money.MoneyToStr(MDoc.Date, "", _total));

  CONFORM(MDocList, MMode);
  L_MSO.wordSetVarsByFile_wPrefixE("MMode",  r, 0);

  IF L_Pmnt.E_MDocListMustHasCstDclr() THEN
   L_General.Assert(~!MDocList.CstDclr, "  㪠 ⠬ |ப "+MDocList.MDLNbr);
  ELSE
   L_General.Assert(!MDocList.CstDclr, "   㪠 ⠬ |ப "+MDocList.MDLNbr);
  END;
  IF ~!MDocList.CstDclr THEN
   CONFORM(MDocList, CstDclr);
   CONFORM(CstDclr, Country);
  END;
  L_MSO.wordSetVarsByFile_wPrefixE("CstDclr",  r,            !MDocList.CstDclr);
  L_MSO.wordSetVarsByFile_wPrefixE("Country",  r+"CstDclr.", !MDocList.CstDclr);
  IF OCCURE(Country) & Country.NotCntry THEN
   L_MSO.wordSetVar(r+"CstDclr.Country.Country", "-");
  END;

  L_MSO.wordSetVarsByFile_wPrefix("Math",     r);
  L_MSO.wordSetVar     (r+"Math.Name.Full", trgMathFullName);
  L_MSO.wordSetVar     (r+"Math.Warranty",  P_Math.GetMathProSoft(Math.Math, GetMDocSrcDate(), P_Math.P_Warranty));

  r:=r+"Math.";
  L_MSO.wordSetVarsByFile_wPrefix("MathType", r);
  L_MSO.wordSetVarsByFile_wPrefix("Vendor", r);
 END {PutSingleMDocList};

 PRIVATE PROCEDURE PutEmptyMDocList(Prefix: STRING[]; i: NUMERIC[0]);
  VAR
   r: STRING[];
 BEGIN
  PROMPT("⮢ .");
  r:=Prefix+"MDocList"+L_MSO.IndexStr(i);
  L_MSO.wordSetVarsByFile_wAliasE("MDocList", r, 1);
  r:=r+".";
  L_MSO.wordSetVar     (r+"Index",         L_Str.IntStr(i));
  L_MSO.wordSetVar     (r+"Pos",           "");
  L_MSO.wordSetVar     (r+"Price",         "");
  L_MSO.wordSetVar     (r+"Price.Total",   "");
  L_MSO.wordSetVar     (r+"Netto",         "");
  L_MSO.wordSetVar     (r+"VATPrc",        "");
  L_MSO.wordSetMoneyVar(r+"VAT", MDoc.Date, EMPTYOF(MDocList.VAT));
  L_MSO.wordSetVar     (r+"Total",         "");
  L_MSO.wordSetVar     (r+"Amount",        "");
  L_MSO.wordSetVar     (r+"Amount.ByWord", "");
  L_MSO.wordSetVar     (r+"AltMUnit.Amount", "");
  L_MSO.wordSetVar     (r+"AltMUnit.Price",       "");
  L_MSO.wordSetVar     (r+"AltMUnit.Price.Total", "");

  L_MSO.wordSetVarsByFile_wPrefixE("CstDclr",  r,            1);
  L_MSO.wordSetVarsByFile_wPrefixE("Country",  r+"CstDclr.", 1);
  L_MSO.wordSetVarsByFile_wPrefixE("Math",     r,            1);
  L_MSO.wordSetVarsByFile_wPrefixE("MMode",    r,            1);
  L_MSO.wordSetVar     (r+"Math.Name.Full", "");

  r:=r+"Math.";
  L_MSO.wordSetVarsByFile_wPrefixE("MUnit",    r, 1);
  L_MSO.wordSetVarsByFile_wPrefixE("MUnit", r+"Alt", 1);
  L_MSO.wordSetVarsByFile_wPrefixE("MathType", r, 1);
  L_MSO.wordSetVarsByFile_wPrefixE("Vendor",   r, 1);
 END {PutEmptyMDocList};

 PRIVATE PROCEDURE PutSingleMDocLCU(Prefix: STRING[]; i: NUMERIC[0]; feCUCopy, feMath: SCAL[2]);
  VAR
   p, r: STRING[];
   j: NUMERIC[0];
   t_VAT,
   t_Netto: L_XObj.tSum;
 BEGIN
  IF ~feCUCopy THEN
   CONFORM(MDocLCU, CUCopy);
  ELSE
  END;
  r:=Prefix+"MDocLCU"+L_MSO.IndexStr(i);
  L_MSO.wordSetVarsByFile_wAliasE("MDocLCU", r, feCUCopy);
  r:=r+".";
  L_MSO.wordSetVar     (r+"Index",         L_Str.IntStr(i));
  L_MSO.wordSetVar     (r+"Pos",           L_Str.IntStr(i+1));
  L_MSO.wordSetVarsByFile_wPrefixE("CUCopy", r, feCUCopy);
  j:=0; t_Netto:=0; t_VAT:=0;
  IF ~feMath THEN
   PutSingleMDocList(r, EMPTYOF(NUMERIC[0]), t_Netto, t_VAT, j);
  ELSE
   PutEmptyMDocList(r, EMPTYOF(NUMERIC[0]));
  END;
 END {PutSingleMDocLCU};

 PRIVATE PROCEDURE HasSpecificVariableFamily(Variables: OBJECT; trgMask: STRING[]): SCAL[2];
  VAR
   i: NUMERIC[0];
   Item: OBJECT;
 BEGIN
  IF L_MSO.UsingStage # L_MSO.us_Using THEN
   RETURN 1;
  ELSE
   APP.Get().NewPrompt("஢ઠ ६");
   i:=Variables.Count;
   WHILE i > 0 DO
    PROMPT(L_Str.IntStr(i));
    IF    Str.Match(Variables(i).Name, trgMask) THEN
     RETURN 1;
    END;
    DEC(i);
   END; (* WHILE i <= Count...*)
   RETURN 0;
  END;
 END {HasSpecificVariableFamily};

 PRIVATE PROCEDURE PrepareMDocListByMModeCollections(VAR Document: OBJECT);
  VAR
   i, j, k: NUMERIC[0];
   Root   : STRING[];
   t_VAT,
   t_Netto: L_XObj.tSum;
 BEGIN
  IF !Document | HasSpecificVariableFamily(Document.Variables, "MDoc.MMode_*") THEN
   APP.Get().NewPrompt("   ࠧ१ ० ");
   L_AFM.MakeMultipleIndex("MDLCl", "_MMode : LIKE(MDocList.MMode);"+
                                       "_MDLNbr: LIKE(MDocList.MDLNbr)",
                               "MMode: _MMode, _MDLNbr");
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) DO
    MDLCl._MMode :=MDocList.MMode;
    MDLCl._MDLNbr:=MDocList.MDLNbr;
    INSERT(MDLCl);
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
   SELECT(MMode, MMode);
   WHILE OCCURE(MMode) DO
    Root:="MDoc.MMode_" + MMode.MMode + ".";
    SETZERO(i, j, k, t_VAT, t_Netto);
    SELECT(MDLCl, MMode, , MMode.MMode);
    WHILE OCCURE(MDLCl) DO
     SEARCH(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc, MDLCl._MDLNbr);
     PutSingleMDocList(Root, i, t_Netto, t_VAT, j);
     INC(i);
     CONFORM(MDocList, MDocLCU);
     IF OCCURE(MDocLCU) THEN
      WHILE OCCURE(MDocLCU) DO
       CONFORM(MDocLCU, CUCopy);
       PutSingleMDocLCU(Root, k, 0, 0);
       INC(k);
       NEXT(MDocLCU);
      END;
     ELSE
      PutSingleMDocLCU(Root, k, 1, 0);
      INC(k);
     END;
     NEXT(MDLCl);
    END; (* WHILE OCCURE(MDLCl) ... *)
    L_MSO.wordSetMoneyVar(Root+"Netto", MDoc.Date, t_Netto);
    L_MSO.wordSetMoneyVar(Root+"VAT",   MDoc.Date, t_VAT);
    L_MSO.extSetWordTable("MMode_"+MMode.MMode+"_MDocList", i, L_MSO.tt_Soft);
    L_MSO.extSetWordTable("MMode_"+MMode.MMode+"_MDocLCU",  k, L_MSO.tt_Soft);
    NEXT(MMode);
   END; (* WHILE OCCURE(MMode) ... *)
   L_AFM.AF_PurgeTemp("MDLCl");
  END;
 END {PrepareMDocListByMModeCollections};

 PRIVATE PROCEDURE PrepareMDocLCUCollection(VAR Document: OBJECT);
  VAR
   k   : NUMERIC[0];
   Root: STRING[];
 BEGIN
  IF !Document | HasSpecificVariableFamily(Document.Variables, "MDoc.MDocLCU*") THEN
   APP.Get().NewPrompt(" ஢");
   Root:="MDoc.";
   SETZERO(k);
   IF SELECT(MDocLCU, MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
     WHILE OCCURE(MDocLCU) DO
     CONFORM(MDocLCU, MDocList);
     CONFORM(MDocLCU, CUCopy);
     PROMPT(CUCopy.CUCopy);
     PutSingleMDocLCU(Root, k, 0, 0);
     INC(k);
     NEXT(MDocLCU);
    END; (* WHILE OCCURE(MDocLCU) *)
   ELSE
    PutSingleMDocLCU(Root, k, 1, 1);
    INC(k);
   END; (* IF SELECT(MDocLCU ... *)
   L_MSO.extSetWordTable("MDocLCU", k, L_MSO.tt_Soft);
  END;
 END {PrepareMDocLCUCollection};

 PRIVATE PROCEDURE PrepareStdMDoc(VAR Document: OBJECT; D: DATE; Root: STRING[]);
  CONST
   Dvr_LinesInBlank = 20;
  VAR
   i, j    : NUMERIC[0];
   t_VAT,
   t_Netto : L_XObj.tSum;
 BEGIN
  APP.Get().NewPrompt("㧪  ");
  L_APtm.wordSetTheDocCauseAndDraftsman(D, "⢥ত ⠭ ᪮ ᨨ  30.10.97  71", "");
  SETZERO(i, j, t_VAT, t_Netto);
  CONFORM(MDoc, MDocList);
  IF ~OCCURE(MDocList) THEN
   WHILE i < Dvr_LinesInBlank DO
    PutEmptyMDocList(Root, i);
    INC(i);
   END;
   L_MSO.wordSetMoneyVar(Root+"Netto",   D, EMPTYOF(t_Netto));
   L_MSO.wordSetMoneyVar(Root+"VAT",     D, EMPTYOF(t_VAT));
   L_MSO.wordSetVar     (Root+"Pos",        "");
   L_MSO.wordSetVar     (Root+"Pos.ByWord", "");
   wordPutVATText(Root, D, EMPTYOF(t_VAT));
  ELSE
   WHILE OCCURE(MDocList) DO
    PutSingleMDocList(Root, i, t_Netto, t_VAT, j);
    INC(i);
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
   L_MSO.wordSetMoneyVar(Root+"Netto",   D, t_Netto);
   L_MSO.wordSetMoneyVar(Root+"VAT",     D, t_VAT);
   L_MSO.wordSetVar     (Root+"Pos",        L_Str.IntStr(j));
   L_MSO.wordSetVar     (Root+"Pos.ByWord", Str.NumByWord(j));
   wordPutVATText(Root, D, t_VAT);
  END;
  L_MSO.extSetWordTable("Line", i, L_MSO.tt_Soft);
  PrepareMDocListByMModeCollections(Document);
  PrepareMDocLCUCollection(Document);
 END {PrepareStdMDoc};

 PRIVATE PROCEDURE GetXDocDate_AsStr(trgDate, trgSrcDate: DATE): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF ~!trgSrcDate THEN
   Result:=L_DatTim.DateStr(trgSrcDate);
  ELSE
   Result:=L_DatTim.DateStr(trgDate);
  END;
  RETURN "  " + Result;
 END {GetXDocDate_AsStr};

 PRIVATE PROCEDURE SetXDocVars(r, LinkName: STRING[]; trgDocId: L_XDoc.tXDocId);
  VAR
   trgXDocType             : L_XDoc.tXDocType;
   trgXDoc                 : SCAL[1E7];
   trgDate,
   trgSrcDate              : DATE;
   trgNote,
   trgSrcNbr,
   trgFileName,
   trgFullName,
   trgXDKSign,
   trgXDKSName,
   trgServiceNote,
   trgXDocDescr_Full,
   trgXDocDescr_wXDoc,
   trgXDocDescr_wSrcNbr: STRING[];
 BEGIN
  SETEMPTY(trgXDoc, trgDate, trgSrcDate, trgSrcNbr, trgFileName, trgFullName,
           trgXDKSign, trgXDKSName, trgNote, trgServiceNote,
           trgXDocDescr_wXDoc, trgXDocDescr_wSrcNbr, trgXDocDescr_Full);
  IF ~!trgDocId THEN
   trgXDocType:=L_XDoc.ExtractXDocType(trgDocId);
   trgFileName:=L_XDoc.Ref_FileName(trgXDocType);
   trgFullName:=L_XDoc.Ref_FullName(trgXDocType);
   SAVE(^trgFileName);
   L_XDoc.PositionOnXDoc(trgDocId);
   IF    trgXDocType=L_XDoc.xdt_MDoc THEN
    SAVE(MDocKind);
    CONFORM(MDoc, MDocKind);
    trgXDoc       :=MDoc.MDoc;
    trgDate       :=MDoc.Date;
    trgSrcDate    :=MDoc.SrcDate;
    trgSrcNbr     :=MDoc.SrcNbr;
    trgNote       :=P_MDoc.GetNote(MDoc.MDocKind, MDoc.MDoc);
    trgServiceNote:=P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_ServiceNote);
    trgXDKSign    :=L_MDoc.MDocKindNick(MDocKind.MDocKind, 1);
    trgXDKSName   :=MDocKind.ExtSName;
    RESTORE(MDocKind);
   ELSIF trgXDocType=L_XDoc.xdt_PDoc THEN
    SAVE(PDocKind);
    CONFORM(PDoc, PDocKind);
    trgXDoc       :=PDoc.PDoc;
    trgDate       :=PDoc.Date;
    trgSrcDate    :=PDoc.PrpDate;
    trgSrcNbr     :=PDoc.SrcNbr;
    trgXDKSign    :=L_PDoc.PDocKindNick(PDocKind.PDocKind, 1);
    trgXDKSName   :=PDocKind.SName;
    RESTORE(PDocKind);
   ELSIF (trgXDocType=L_XDoc.xdt_CWOrder) | (trgXDocType=L_XDoc.xdt_CarAD) THEN
    trgXDoc       :=CWOrder.CWOrder;
    trgDate       :=CWOrder.Date;
    trgXDKSign    :=L_XDoc.Ref_ShortName(trgXDocType);
    trgXDKSName   :=L_XDoc.Ref_FullName(trgXDocType);
   ELSIF trgXDocType=L_XDoc.xdt_RprS THEN
    trgXDoc       :=RprS.RprS;
    trgDate       :=RprS.OrdDate;
    trgXDKSign    :=L_XDoc.Ref_ShortName(trgXDocType);
    trgXDKSName   :=L_XDoc.Ref_FullName(trgXDocType);
   ELSE
    L_General.CallUs(0);
   END;
   RESTORE(^trgFileName);

   trgXDocDescr_wXDoc  :=Str.Small(trgXDKSName) + "  " + trgXDoc + GetXDocDate_AsStr(trgDate, trgSrcDate);
   trgXDocDescr_wSrcNbr:=Str.Small(trgXDKSName) + "  " + trgSrcNbr + GetXDocDate_AsStr(trgDate, trgSrcDate);
   trgXDocDescr_Full   :=Str.Small(trgXDKSName) + "  " + trgSrcNbr + "/" + trgXDoc + GetXDocDate_AsStr(trgDate, trgSrcDate);;
  END;

  L_MSO.wordSetVar(r+LinkName+"T.FileName",     trgFileName);
  L_MSO.wordSetVar(r+LinkName+"T.FullName",     trgFullName);
  r:=r + LinkName + ".";
  L_MSO.wordSetVar(r+"Descr.wXDoc",             trgXDocDescr_wXDoc);
  L_MSO.wordSetVar(r+"Descr.wSrcNbr",           trgXDocDescr_wSrcNbr);
  L_MSO.wordSetVar(r+"Descr.Full",              trgXDocDescr_Full);
  L_MSO.wordSetVar(r+"XDoc",                    trgXDoc);
  L_MSO.wordSetDateVar(r+"Date",                trgDate);
  L_MSO.wordSetVar(r+"SrcNbr",                  trgSrcNbr);
  L_MSO.wordSetDateVar(r+"SrcDate",             trgSrcDate);
  L_MSO.wordSetVar(r+"Note",                    trgNote);
  L_MSO.wordSetVar(r+"ServiceNote",             trgServiceNote);
  r:=r + "XDocKind.";
  L_MSO.wordSetVar(r+"Sign",                    trgXDKSign);
  L_MSO.wordSetVar(r+"SName",                   trgXDKSName);
 END {SetXDocVars};

 PRIVATE PROCEDURE SetRefDocVars(r: STRING[]);
  VAR
   RefToXDocId: L_XDoc.tXDocId;
 BEGIN
  RefToXDocId:=L_XDoc.GetSingleRefToXDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
(* 0102910, 0102917 *)
  IF !RefToXDocId THEN
   RefToXDocId:=L_XDoc.GetBaseOnXDocId(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
  END;
  SetXDocVars(r, "RefDoc", RefToXDocId);
 END {SetRefDocVars};

 PRIVATE PROCEDURE SetRootDocVars(r: STRING[]);
  VAR
   TmpXDocId,
   RootXDocId: L_XDoc.tXDocId;
 BEGIN
  SETEMPTY(RootXDocId);
  TmpXDocId:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
  LOOP
   TmpXDocId:=L_XDoc.GetBaseOnXDocId(TmpXDocId);
   IF !TmpXDocId THEN
    EXIT;
   END;
   RootXDocId:=TmpXDocId;
  END;
  SetXDocVars(r, "RootDoc", RootXDocId);
 END {SetRootDocVars};

 PRIVATE PROCEDURE E_MDocP_MO_IsKeyAssetsDoc(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  IF L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) THEN
   RETURN 1;
  END;
  Local:=PROCREF(E_Stock.MDocP_MO_IsKeyAssetsDoc);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 0;
  END;
 END {E_MDocP_MO_IsKeyAssetsDoc};

 PRIVATE PROCEDURE PrepareCWOrderMDoc(D: DATE; Root: STRING[]);
  VAR
   XDC         : L_XDoc.tXDocCollection;
   _XDocType   : L_XDoc.tXDocType;
   _XDocKind   : L_XDoc.tXDocKind;
   _XDoc       : L_XDoc.tXDoc;
   _XDocId     : L_XDoc.tXDocId;
   i           : NUMERIC[0];
   r           : STRING[];
   TotalTime,
   TotalNightTim,
   TotalHldTim : NUMERIC[3];
   TotalSum,
   TotalSum_wIP: NUMERIC[2];
   mTotalTime,
   mTotalNightTim,
   mTotalHldTim : NUMERIC[3];
   mTotalSum,
   mTotalSum_wIP: NUMERIC[2];
   mSum         : NUMERIC[2];
   mRun         : NUMERIC[0];
   mSpeed       : NUMERIC[0];
   mOverRun     : NUMERIC[0];
   mOverRunS    : NUMERIC[2];
   mWTim        : NUMERIC[3];
   mWTimSum     : NUMERIC[2];
   mPsgAm       : NUMERIC[0];
   mIPSum       : NUMERIC[2];
 BEGIN
  L_CWOrder.Create_TaxInfFile();
  L_AFM.MakeIndex("mdcwo", "Math: LIKE(CWOrder.Math); D: DATE; CWOrder: LIKE(CWOrder.CWOrder)");
  XDC:=L_XDoc.GetRefToXDC_Transitively(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_CWOrder);
  SETZERO(i);
  LOOP
   _XDocId:=L_XDoc.xdc_Item(XDC, i);
   IF !_XDocId THEN
    EXIT;
   END;
   L_XDoc.DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
   IF _XDocType = L_XDoc.xdt_CWOrder THEN
    L_XDoc.PositionOnXDoc(_XDocId);
    PROMPT("ઠ " + CWOrder.CWOrder);
    L_CWOrder.CalcSingleCWOrderSum(L_CWOrder.CWOrderIsTaxed(), 1);
    ADD(mdcwo, mdcwo, , CWOrder.Math, CWOrder.Date, CWOrder.CWOrder);
   END;
   INC(i);
  END; (* LOOP *)

  Root:="MDoc.CWOrder";

  SETZERO(TotalTime, TotalNightTim, TotalHldTim, TotalSum, TotalSum_wIP);
  i:=0;

  SELECT(mdcwo, mdcwo);
  WHILE OCCURE(mdcwo) DO
   NARROWSEL(mdcwo, Math);
   SEARCH(Math, Math, , mdcwo.Math);
   SETZERO(mTotalTime, mTotalNightTim, mTotalHldTim, mTotalSum, mTotalSum_wIP,
           mSum, mRun, mSpeed, mOverRun, mOverRunS, mWTim, mWTimSum, mPsgAm, mIPSum);
   WHILE OCCURE(mdcwo) DO
    PROMPT("㧪 " + Math.Math + " " + CWOrder.CWOrder);
    SEARCH(TxInf, CWOrder, , mdcwo.CWOrder);
    CONFORM(TxInf, CWOrder);
    CONFORM(CWOrder, RWayS);
    IF OCCURE(RWayS) THEN
     L_Car.StandOnCarLog(RWayS.BoxNbr, RWayS.Date);
     CONFORM(CarLog, Mark);
    END;
    r:=L_Str.Var_wIdx(Root, i);
    L_MSO.wordSetVarsByFile_wAlias("CWOrder", r);
    r:=r + ".";
    L_MSO.wordSetVar     (r + "Math.Name", Math.Name);
    L_MSO.wordSetVar     (r + "TotalsName", "");
    L_MSO.wordSetVarsByFile_wPrefixE("TxInf",   r, 0);
    L_MSO.wordSetMoneyVar(r + "TxInf.Total",     D, TxInf.TotalSum+TxInf.VAT);
    L_MSO.wordSetMoneyVar(r + "TxInf.Total_wIP", D, TxInf.TotalSum+TxInf.VAT+TxInf.IPSum);
    L_MSO.wordSetVarsByFile_wPrefixE("RWayS",   r, ~OCCURE(RWayS));
    L_MSO.wordSetVarsByFile_wPrefixE("CarLog",  r+"RWayS.Car.", ~OCCURE(RWayS));
    L_MSO.wordSetVarsByFile_wPrefixE("Mark",    r+"RWayS.Car.CarLog.", ~OCCURE(RWayS));
    INC(mTotalTime,     TxInf.Time);
    INC(mTotalNightTim, TxInf.NightTim);
    INC(mTotalHldTim,   TxInf.HldTim);
    INC(mTotalSum,      TxInf.TotalSum+TxInf.VAT);
    INC(mTotalSum_wIP,  TxInf.TotalSum+TxInf.VAT+TxInf.IPSum);
    INC(mSum,           TxInf.Sum);
    INC(mRun,           TxInf.Run);
    INC(mSpeed,         TxInf.Speed);
    INC(mOverRun,       TxInf.OverRun);
    INC(mOverRunS,      TxInf.OverRunS);
    INC(mWTim,          TxInf.WTim);
    INC(mWTimSum,       TxInf.WTimSum);
    INC(mPsgAm,         CWOrder.p_PsgAm);
    INC(mIPSum,         TxInf.IPSum);
    NEXT(TxInf);
    INC(i);
    NEXT(mdcwo);
   END; (* WHILE OCCURE(File) *)

   r:=L_Str.Var_wIdx(Root, i);
   L_MSO.wordSetVarsByFile_wAliasE("CWOrder", r,                     1);
   r:=r + ".";
   L_MSO.wordSetVar     (r + "Math.Name", "");
   L_MSO.wordSetVarsByFile_wPrefixE("TxInf",  r,                     1);
   L_MSO.wordSetVar     (r + "TotalsName", "⮣ " + Math.Name);
   L_MSO.wordSetVar     (r + "TxInf.Time",      L_Str.NumericStr(mTotalTime, 3));
   L_MSO.wordSetVar     (r + "TxInf.NightTim",  L_Str.NumericStr(mTotalNightTim, 3));
   L_MSO.wordSetVar     (r + "TxInf.HldTim",    L_Str.NumericStr(mTotalHldTim, 3));
   L_MSO.wordSetMoneyVar(r + "TxInf.Total",     D, mTotalSum);
   L_MSO.wordSetMoneyVar(r + "TxInf.Total_wIP", D, mTotalSum_wIP);
   L_MSO.wordSetMoneyVar(r + "TxInf.Sum",       D, mSum);
   L_MSO.wordSetVar     (r + "TxInf.Run",       L_Str.NumericStr(mRun, 0));
   L_MSO.wordSetVar     (r + "TxInf.Speed",     L_Str.NumericStr(mSpeed, 0));
   L_MSO.wordSetVar     (r + "TxInf.OverRun",   L_Str.NumericStr(mOverRun, 0));
   L_MSO.wordSetVar     (r + "TxInf.OverRunS",  L_Str.NumericStr(mOverRunS, 0));
   L_MSO.wordSetVar     (r + "TxInf.WTim",      L_Str.NumericStr(mWTim, 3));
   L_MSO.wordSetVar     (r + "TxInf.WTimSum",   L_Str.NumericStr(mWTimSum, 3));
   L_MSO.wordSetVar     (r + "p_PsgAm",         L_Str.NumericStr(mPsgAm, 0));
   L_MSO.wordSetMoneyVar(r + "TxInf.IPSum",     D, mIPSum);
   L_MSO.wordSetVarsByFile_wPrefixE("RWayS",  r,                     1);
   L_MSO.wordSetVarsByFile_wPrefixE("CarLog", r+"RWayS.Car.",        1);
   L_MSO.wordSetVarsByFile_wPrefixE("Mark",   r+"RWayS.Car.CarLog.", 1);
   INC(i);

   INC(TotalTime,     mTotalTime);
   INC(TotalNightTim, mTotalNightTim);
   INC(TotalHldTim,   mTotalHldTim);
   INC(TotalSum,      mTotalSum);
   INC(TotalSum_wIP,  mTotalSum_wIP);
   NEXTINEXTENDEDSEL(mdcwo, Math);
  END; (* WHILE OCCURE(mdcwo) *)
  L_MSO.extSetWordTable("CWOrdersList", i, L_MSO.tt_Soft);

  L_MSO.wordSetVar(Root + ".TotalTime",     FLDTOSTR(TotalTime, "3."));
  L_MSO.wordSetVar(Root + ".TotalNightTim", FLDTOSTR(TotalNightTim, "3."));
  L_MSO.wordSetVar(Root + ".TotalHldTim",   FLDTOSTR(TotalHldTim, "3."));

  L_MSO.wordSetMoneyVar(Root + ".TotalSum",     D, TotalSum);
  L_MSO.wordSetMoneyVar(Root + ".TotalSum_wIP", D, TotalSum_wIP);

  L_CWOrder.Purge_TaxInfFile();
 END {PrepareCWOrderMDoc};

 PRIVATE PROCEDURE CombineInFace(trgFirm     : LIKE(Firm.Firm); 
                                 D           : DATE; 
                                 trgName,
                                 trgPostName,
                                 trgDocKind,
                                 trgDocSer,
                                 trgDocNbr,
                                 trgDocGiveS : STRING[];
                                 trgDocExpD,
                                 trgDocGiveD : DATE): STRING[];
  VAR
   s,
   InFaceStr: STRING[];
 BEGIN
  InFaceStr:=", 祩 ।⠢⥫";
  IF ~!trgPostName THEN
   InFaceStr:=InFaceStr + " " + trgPostName;
  END;
  IF P_Firm.FP_PrtnrTyp(trgFirm, D) = P_Firm.pt_Branch THEN
   InFaceStr:=InFaceStr + " " + P_Firm.FP_FirmName(trgFirm, D);
  END;
  InFaceStr:=InFaceStr + " " + trgName;
  s:=L_Prop.CombineDocDescription(trgDocKind, trgDocSer, trgDocNbr, trgDocGiveS, trgDocExpD, trgDocGiveD);
  IF ~!s THEN
   InFaceStr:=InFaceStr + "   ᭮ " + s;
  END;
  RETURN InFaceStr;
 END {CombineInFace};

 PRIVATE PROCEDURE E_SetInFaceVar(Prefix: STRING[]; _Firm: LIKE(Firm.Firm); D: DATE; IsOwn: SCAL[2]);
  VAR
   local       : PROC;
   LeadName,
   LeadPostName,
   InFaceStr   : STRING[];
   TSN         : LIKE(Staff.TSN);
   Name,
   PostName,
   DocType,
   DocSer,
   DocNum,
   DocGiveS    : STRING[];
   DocExpD,
   DocGiveD    : DATE;
   CntrSum     : NUMERIC[2];
 BEGIN
  local:=PROCREF(E_Pmnt.CarADFirmInFaceStr);
  IF    IsOwn & P_Cntr.HasActualPro(MDoc.Contract, MDoc.Date, P_Cntr.P_OwnAgent) THEN
   P_Cntr.Get_FullOwnAgentInfo(MDoc.Contract, MDoc.Date, TSN,
                                                         DocType,
                                                         DocSer,
                                                         DocNum,
                                                         DocGiveS,
                                                         DocGiveD,
                                                         DocExpD,
                                                         CntrSum);
  ELSIF ~IsOwn & P_Cntr.HasActualPro(MDoc.Contract, MDoc.Date, P_Cntr.P_PartnerAgent) THEN
   P_Cntr.Get_FullPartnerAgentInfo(Contract.Contract, SrcDate, Name,
                                                               PostName,
                                                               DocType,
                                                               DocSer,
                                                               DocNum,
                                                               DocGiveS,
                                                               DocGiveD,
                                                               DocExpD);
  ELSE
   Name    :=P_Firm.FP_LeadName(_Firm, D);
   PostName:=P_Firm.FP_LeadPostName1(_Firm, D);
   DocType :=P_Firm.FP_BasisOfLeaderActivity(_Firm, D);
   L_Prop.GetDocSerAndNum(FirmPro.DocNum, DocSer, DocNum);
   DocGiveS:=FirmPro.DocGiveS;
   DocGiveD:=FirmPro.DocGiveD;
   DocExpD :=FirmPro.DocExpD;
  END;

  InFaceStr:=CombineInFace(_Firm,
                           D,
                           Name,
                           PostName,
                           DocType,
                           DocSer,
                           DocNum,
                           DocGiveS,
                           DocExpD,
                           DocGiveD);
  IF ~!local THEN
   InFaceStr:=local(_Firm, D, InFaceStr);
  END;
  L_MSO.wordSetVar(Prefix + "Firm.InFace", InFaceStr);
 END {E_SetInFaceVar};

 PRIVATE PROCEDURE PrepareCarADMDoc(D: DATE; Root: STRING[]);
  VAR
   XDC      : L_XDoc.tXDocCollection;
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
   _XDoc    : L_XDoc.tXDoc;
   _XDocId  : L_XDoc.tXDocId;
   i, j,
   Period,
   CarADAmnt    : NUMERIC[0];
   r,
   BoxNbrs,
   _Root        : STRING[];
   CarADLTotalSum,
   _Sum,
   _MD,
   _Mount,
   _Dismount,
   TotalSum,
   TotalTotal,
   TotalMount,
   TotalDismount: LIKE(CarADL.Sum);
   Mount_inclVAT,
   Dismount_inclVAT: NUMERIC[2];
 BEGIN
  E_SetInFaceVar("Own", P_Firm.fomf(MDoc.MyFirm), D, 1);
  r:="MDoc.CarAD";
  XDC:=L_XDoc.GetRefToXDC_Transitively(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_CarAD);
  SETZERO(i, CarADAmnt);
  LOOP
   _XDocId:=L_XDoc.xdc_Item(XDC, i);
   IF !_XDocId THEN
    EXIT;
   END;
   L_XDoc.DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
   IF _XDocType = L_XDoc.xdt_CarAD THEN
    L_General.CallUs(CarADAmnt < 2);
    L_XDoc.PositionOnXDoc(_XDocId);
    PROMPT("ઠ " + CarAD.CarAD);
    L_MSO.wordSetVarsByFile_wPrefix("CarAD", Root);
    Root :=Root + "CarAD.";
    _Root:=Root;
    Period:=L_DatTim.CompleteMonthsInIntvl(CarAD.BegDate, CarAD.EndDate);
    L_MSO.wordSetVar(Root + "Period",        L_Str.IntStr(Period));
    L_MSO.wordSetVar(Root + "Period.ByWord", L_Str.NumericByWord(Period, 0));
    CONFORM(CarAD, Contract);
    L_MSO.wordSetVarsByFile_wPrefix("Contract", Root);
    E_SetInFaceVar("MDoc.Contract.", Contract.Firm, D, 0);
  
    L_General.Assert(SELECT(CarADL, CarAD, CarAD.CarAD), " ४ ᤥ");
    IF    (MDoc.MDocKind = L_MDoc.md_IsS) THEN
     BoxNbrs:=CarADL.BoxNbr;
     WHILE NEXT(CarADL) DO
      BoxNbrs:=BoxNbrs + ", " + CarADL.BoxNbr;
     END; (* WHILE OCCURE(CarADL) ... *)
     L_MSO.wordSetVar(Root + "BoxNbrs", BoxNbrs);
    ELSIF (MDoc.MDocKind = L_MDoc.md_IAS) THEN
     SETZERO(TotalMount, TotalDismount, TotalTotal, TotalSum);
     Root:=Root + "CarADL";
     j:=0;
     WHILE OCCURE(CarADL) DO
      IF L_DatTim.IsActiveInIntvl_Inc(CarADL.BegDate, CarADL.EndDate,
                                      L_DatTim.MonthBeg(MDoc.Date), L_DatTim.MonthEnd(MDoc.Date)) THEN
       L_MSO.wordSetVarsByFile_wAliasAndIndexE("CarADL", Root, j, 0);
       _Sum[L_CarAD.psidx_Netto]:=L_CarAD.CalcCarADLPartSum(CarADL.Cost[L_CarAD.psidx_Netto], MDoc.Date, L_CarAD.IsLastMDocInPeriod(MDoc.Date));
       _Sum[L_CarAD.psidx_VAT]  :=L_CarAD.CalcCarADLPartSum(CarADL.Cost[L_CarAD.psidx_VAT],   MDoc.Date, L_CarAD.IsLastMDocInPeriod(MDoc.Date));
  
       CarADLTotalSum[L_CarAD.psidx_Netto]:=_Sum[L_CarAD.psidx_Netto];
       CarADLTotalSum[L_CarAD.psidx_VAT]  :=_Sum[L_CarAD.psidx_VAT];
  
       IF SELECT(MDocList, MDLMath, MDoc.MDocKind, MDoc.MDoc, L_CarAD.E_GetMountMath(CarAD.Date)) THEN
        _Mount[L_CarAD.psidx_Netto]:=CarADL.Mount[L_CarAD.psidx_Netto];
        _Mount[L_CarAD.psidx_VAT]  :=CarADL.Mount[L_CarAD.psidx_VAT];
  
        INC(CarADLTotalSum[L_CarAD.psidx_Netto], _Mount[L_CarAD.psidx_Netto]);
        INC(CarADLTotalSum[L_CarAD.psidx_VAT],   _Mount[L_CarAD.psidx_VAT]);
        Mount_inclVAT:=_Mount[L_CarAD.psidx_Netto] + _Mount[L_CarAD.psidx_VAT];
       ELSE
        SETZERO(Mount_inclVAT, _Mount);
       END;
  
       IF SELECT(MDocList, MDLMath, MDoc.MDocKind, MDoc.MDoc, L_CarAD.E_GetDismountMath(CarAD.Date)) THEN
        _Dismount[L_CarAD.psidx_Netto]:=CarADL.Dismount[L_CarAD.psidx_Netto];
        _Dismount[L_CarAD.psidx_VAT]  :=CarADL.Dismount[L_CarAD.psidx_VAT];
  
        INC(CarADLTotalSum[L_CarAD.psidx_Netto], _Dismount[L_CarAD.psidx_Netto]);
        INC(CarADLTotalSum[L_CarAD.psidx_VAT],   _Dismount[L_CarAD.psidx_VAT]);
        Dismount_inclVAT:=_Dismount[L_CarAD.psidx_Netto] + _Dismount[L_CarAD.psidx_VAT];
       ELSE
        SETZERO(Dismount_inclVAT, _Dismount);
       END;
  
       L_MSO.wordSetDateVar(L_Str.Var_wIdx(Root, j) + ".BegInMonth", L_DatTim.MaxDATE(L_DatTim.MonthBeg(MDoc.Date), CarADL.BegDate));
       L_MSO.wordSetDateVar(L_Str.Var_wIdx(Root, j) + ".EndInMonth", L_DatTim.MinDATE(L_DatTim.MonthEnd(MDoc.Date), CarADL.EndDate));
       L_MSO.wordSetVar    (L_Str.Var_wIdx(Root, j) + ".DaysToPay",  L_Str.IntStr(L_CarAD.GetDaysToPay(MDoc.Date)));
  
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".Mount[0]",    D, _Mount[L_CarAD.psidx_Netto]);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".Mount[1]",    D, _Mount[L_CarAD.psidx_VAT]);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".Mount[2]",    D, Mount_inclVAT);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".Dismount[0]", D, _Dismount[L_CarAD.psidx_Netto]);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".Dismount[1]", D, _Dismount[L_CarAD.psidx_VAT]);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".Dismount[2]", D, Dismount_inclVAT);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".MD[0]",       D, _Mount[L_CarAD.psidx_Netto] + _Dismount[L_CarAD.psidx_Netto]);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".MD[1]",       D, _Mount[L_CarAD.psidx_VAT] + _Dismount[L_CarAD.psidx_VAT]);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".MD[2]",       D, Mount_inclVAT + Dismount_inclVAT);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".Cost[2]",     D, CarADL.Cost[L_CarAD.psidx_Netto] + CarADL.Cost[L_CarAD.psidx_VAT]);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".Sum[0]",      D, _Sum[L_CarAD.psidx_Netto]);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".Sum[1]",      D, _Sum[L_CarAD.psidx_VAT]);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".Sum[2]",      D, _Sum[L_CarAD.psidx_Netto] + _Sum[L_CarAD.psidx_VAT]);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".Total[0]",    D, CarADLTotalSum[L_CarAD.psidx_Netto]);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".Total[1]",    D, CarADLTotalSum[L_CarAD.psidx_VAT]);
       L_MSO.wordSetMoneyVar(L_Str.Var_wIdx(Root, j) + ".Total[2]",    D, CarADLTotalSum[L_CarAD.psidx_Netto] + CarADLTotalSum[L_CarAD.psidx_VAT]);
  
       IF ~!_Mount[L_CarAD.psidx_Netto] THEN
        INC(TotalMount[L_CarAD.psidx_Netto],    _Mount[L_CarAD.psidx_Netto]);
        INC(TotalMount[L_CarAD.psidx_VAT],      _Mount[L_CarAD.psidx_VAT]);
       END;
       IF ~!_Dismount[L_CarAD.psidx_Netto] THEN
        INC(TotalDismount[L_CarAD.psidx_Netto], _Dismount[L_CarAD.psidx_Netto]);
        INC(TotalDismount[L_CarAD.psidx_VAT],   _Dismount[L_CarAD.psidx_VAT]);
       END;
       INC(TotalSum[L_CarAD.psidx_Netto],      _Sum[L_CarAD.psidx_Netto]);
       INC(TotalSum[L_CarAD.psidx_VAT],        _Sum[L_CarAD.psidx_VAT]);
       INC(TotalTotal[L_CarAD.psidx_Netto],    CarADLTotalSum[L_CarAD.psidx_Netto]);
       INC(TotalTotal[L_CarAD.psidx_VAT],      CarADLTotalSum[L_CarAD.psidx_VAT]);
       INC(j);
      END;
      NEXT(CarADL);
     END; (* WHILE OCCURE(CarADL) ... *)
 
     L_MSO.SetWordTable("CarADL", j);
   
     Root:=_Root;
     L_MSO.wordSetMoneyVar(Root + "TotalMount[0]",     D, TotalMount[L_CarAD.psidx_Netto]);
     L_MSO.wordSetMoneyVar(Root + "TotalMount[1]",     D, TotalMount[L_CarAD.psidx_VAT]);
     L_MSO.wordSetMoneyVar(Root + "TotalMount[2]",     D, TotalMount[L_CarAD.psidx_Netto] + TotalMount[L_CarAD.psidx_VAT]);
     L_MSO.wordSetMoneyVar(Root + "TotalDismount[0]",  D, TotalDismount[L_CarAD.psidx_Netto]);
     L_MSO.wordSetMoneyVar(Root + "TotalDismount[1]",  D, TotalDismount[L_CarAD.psidx_VAT]);
     L_MSO.wordSetMoneyVar(Root + "TotalDismount[2]",  D, TotalDismount[L_CarAD.psidx_Netto] + TotalDismount[L_CarAD.psidx_VAT]);
     L_MSO.wordSetMoneyVar(Root + "TotalMD[0]",        D, TotalMount[L_CarAD.psidx_Netto] + TotalDismount[L_CarAD.psidx_Netto]);
     L_MSO.wordSetMoneyVar(Root + "TotalMD[1]",        D, TotalMount[L_CarAD.psidx_VAT]   + TotalDismount[L_CarAD.psidx_VAT]);
     L_MSO.wordSetMoneyVar(Root + "TotalMD[2]",        D, TotalMount[L_CarAD.psidx_Netto] + TotalDismount[L_CarAD.psidx_Netto] + TotalMount[L_CarAD.psidx_VAT]   + TotalDismount[L_CarAD.psidx_VAT]);
     L_MSO.wordSetMoneyVar(Root + "TotalSum[0]",       D, TotalSum[L_CarAD.psidx_Netto]);
     L_MSO.wordSetMoneyVar(Root + "TotalSum[1]",       D, TotalSum[L_CarAD.psidx_VAT]);
     L_MSO.wordSetMoneyVar(Root + "TotalSum[2]",       D, TotalSum[L_CarAD.psidx_Netto] + TotalSum[L_CarAD.psidx_VAT]);
     L_MSO.wordSetMoneyVar(Root + "TotalTotal[0]",     D, TotalTotal[L_CarAD.psidx_Netto]);
     L_MSO.wordSetMoneyVar(Root + "TotalTotal[1]",     D, TotalTotal[L_CarAD.psidx_VAT]);
     L_MSO.wordSetMoneyVar(Root + "TotalTotal[2]",     D, TotalTotal[L_CarAD.psidx_Netto] + TotalTotal[L_CarAD.psidx_VAT]);
 
     L_MSO.wordSetDateVar("MDoc.Period.MonthBeg", L_DatTim.MonthBeg(MDoc.Date));
     L_MSO.wordSetDateVar("MDoc.Period.MonthEnd", L_DatTim.MonthEnd(MDoc.Date));
     IF (TotalTotal[L_CarAD.psidx_Netto] + TotalTotal[L_CarAD.psidx_VAT]) # MDoc.Total THEN
      L_StdFrm.Choice("㬬  㬥  ᮢ  ⭮:"+
                      "| 㬥 : " + Str.Align(L_Money.MoneyToStr(CarAD.Date, "", MDoc.Total), 10, LEFT)+
                      "|⭠   : " + Str.Align(L_Money.MoneyToStr(CarAD.Date, "", TotalTotal[L_CarAD.psidx_Netto] + TotalTotal[L_CarAD.psidx_VAT]), 10, LEFT));
     END;
    END;
    INC(CarADAmnt);
   END;
   INC(i);
  END; (* LOOP *)
 END {PrepareCarADMDoc};

 PRIVATE VAR
  AlreadyBarkOnRprSMDocSums: SCAL[2];

 PRIVATE PROCEDURE PositionOnTransitivelyRprS();
  VAR
   i          : NUMERIC[0];
   XDC        : L_XDoc.tXDocCollection;
   Result     : SCAL[2];
   trgXDocId  : L_XDoc.tXDocId;
 BEGIN
  Result:=0;
  XDC   :=L_XDoc.GetRefToXDC_Transitively(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_RprS);
  SETZERO(i);
  LOOP
   trgXDocId:=L_XDoc.xdc_Item(XDC, i);
   IF !trgXDocId THEN
    EXIT;
   END;
   IF L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_RprS THEN
    L_General.CallUs(~Result);
    L_XDoc.PositionOnXDoc(trgXDocId);
    Result:=1;
   END;
   INC(i);
  END; (* LOOP *)
  L_General.CallUs(Result);
 END {PositionOnTransitivelyRprS};

 PRIVATE PROCEDURE PrepareRprSMDoc(D: DATE; root: STRING[]);
  VAR
   j,
   PosAmount  : NUMERIC[0];
   Root,
   DocName    : STRING[];
   RprJSum,
   MDLRprJSum : NUMERIC[3];
   t_VAT,
   t_Netto    : L_XObj.tSum;
 BEGIN
  IF (MDoc.MDocKind = L_MDoc.md_IAS) | (MDoc.MDocKind = L_MDoc.md_RPr) THEN
   APP.Get().NewPrompt("㧪  ");
   PositionOnTransitivelyRprS();
   IF L_Rpr.IsRprS_w_OutCBlc() THEN
    IF L_APtm.IsMTA() THEN
     L_MSO.wordSetVar("TheDoc.Cause", "ਫ  4  ਪ  137  03.02.2010");
    ELSE
     L_MSO.wordSetVar("TheDoc.Cause", "");
    END;
   END;

   IF    MDoc.MDocKind = L_MDoc.md_IAS THEN
    DocName:=" 믮 ࠡ";
   ELSIF MDoc.MDocKind = L_MDoc.md_RPr THEN
    DocName:=" -鸞";
   ELSE
    SETEMPTY(DocName);
   END;
   L_MSO.wordSetVar(root + "RprS.DocName",  DocName);
   L_Rpr.E_GetServiceCenterContacts(MDoc.Date, "MDoc.Contract.");
   L_Rpr.RprSFileFamily(MDoc.Date, root, 0);
   L_Rpr.UploadRprJ(MDoc.Date, root);
   L_Rpr.UploadClientSpares(MDoc.Date, root);

   Root:="Narjad." + root;
   SETZERO(j, t_Netto, t_VAT, PosAmount);
   CONFORM(MDoc, MDocList);
   WHILE OCCURE(MDocList) DO
    IF L_MathR.IsInventories(MDocList.Math) THEN
     PutSingleMDocList(Root, j, t_Netto, t_VAT, PosAmount);
     INC(j);
    END;
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
   Root:=Root + "MDocList.";
   L_MSO.wordSetMoneyVar(Root+"Netto",   D, t_Netto);
   L_MSO.wordSetMoneyVar(Root+"VAT",     D, t_VAT);
   L_MSO.wordSetMoneyVar(Root+"Total",   D, t_Netto + t_VAT);
   L_MSO.wordSetVar     (Root+"Pos",        L_Str.IntStr(PosAmount));
   L_MSO.wordSetVar     (Root+"Pos.ByWord", Str.NumByWord(PosAmount));

   L_MSO.extSetWordTable("NarjadMDocList", j, L_MSO.tt_Soft);

   SETZERO(RprJSum);
   SELECT(RprJ, RprS, , RprS.RprS);
   WHILE OCCURE(RprJ) DO
    IF ~!RprJ.Sum THEN
     INC(RprJSum, RprJ.Sum);
    END;
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
 
   SETZERO(MDLRprJSum);
   SELECT(MDocList, MDLMath, , MDoc.MDocKind, MDoc.MDoc);
   WHILE OCCURE(MDocList) DO
    IF ~L_MathR.IsInventories(MDocList.Math) THEN
     INC(MDLRprJSum, MDocList.Sum + MDocList.VAT);
    END;
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
 
   IF (RprJSum # MDLRprJSum) & ~VAR_IMPL.Get(AlreadyBarkOnRprSMDocSums).Initialized THEN
    L_StdFrm.Choice(" ᮢ ⮨ ६ ࠡ    :||" +
                    "⮨  : " + Str.Align(L_Money.MoneyToStr(MDoc.Date, ",", RprJSum), 15, LEFT) + "|" +
                    "⮨   : " + Str.Align(L_Money.MoneyToStr(MDoc.Date, ",", MDLRprJSum), 15, LEFT));
    AlreadyBarkOnRprSMDocSums:=1;
   END;
  END;
 END {PrepareRprSMDoc};

 PRIVATE PROCEDURE IsNotInventoriesMDoc(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF ~L_General.IsPolakSpecific() THEN
   SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
   WHILE OCCURE(MDocList) DO
    CONFORM(MDocList, Math);
    CONFORM(Math, MathType);
    IF MathType.Category = L_Acnt.mtc_Inventories THEN
     RETURN 0;
    END;
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {IsNotInventoriesMDoc};

 PRIVATE PROCEDURE PrepareObjects(VAR Document: OBJECT; D: DATE; TemplateName: STRING[]; PrpResult: L_MSO.PrpResultType);
  VAR
   r,
   Root,
   srcOwnAgent,
   srcPartnerAgent  : STRING[];
   Local            : PROC;
   ownFirmAcnt      : LIKE(FirmAcnt.FirmAcnt);
   Firms            : LIKE(Firm.Firm)[P_Cntr.FirmsAmount];
 BEGIN
  Root:="MDoc.";
  r:=Root;
  L_MSO.wordSetVarsByFile("MDoc");
  L_MSO.wordSetVar(r+"Note", P_MDoc.GetNote(MDoc.MDocKind, MDoc.MDoc));
  SetMDocProp(r, P_MDoc.P_ServiceNote, "ServiceNote");
  L_MSO.wordSetVar(r + "BarCode",      L_MDoc.BarCode());
  L_MSO.wordSetVar(r + "Through",      P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Through));
  L_MSO.wordSetVar(r + "Author",       L_MDoc.GetMDocAuthor());
  SetRefDocVars(r);
  SetRootDocVars(r);
  IF ~!MDoc.Contract THEN
   CONFORM(MDoc, Contract);
   CALL(O_Cntr.MakeDocByMDoc());
  END;
(* 11.11.2004 21:36:32 POLAK\Mog *)
  L_Cntr.wordSetPartnerAgentVars(MDoc.MDocKind, MDoc.MDoc, MDoc.Contract, MDoc.Firm, MDoc.Date, r+"PartnerAgent");
  L_Cntr.wordSetOwnAgentVars(MDoc.Contract, P_Firm.fomf(MDoc.MyFirm), MDoc.Date, r+"Contract.OwnAgent");

  r:=Root;
(* 11.11.2004 21:36:32 POLAK\Mog *)

  CONFORM(MDoc, MDocKind);
  L_MSO.wordSetVarsByFile_wPrefix("MDocKind", r);

  CONFORM(MDoc, Dest);
  L_MSO.wordSetVarsByFile_wPrefixE("Dest", r, ~OCCURE(Dest));

  IF ~!MDoc.Contract THEN
   CONFORM(MDoc, Contract);
   L_MSO.wordSetVarsByFile_wPrefix("Contract", r);

   r:=r+"Contract.";
   L_MSO.wordSetVarsByFile_wPrefixE("Math", r, ~SEARCH(Math, Math, P_Cntr.GetCntrProSoft(Contract.Contract, D, P_Cntr.P_SingleMath)));
   IF L_General.IsPolakSpecific() THEN
    L_MSO.wordSetVar(r+"Ver", P_Cntr.GetCntrProSoft(Contract.Contract, D, P_Cntr.P_ContractVersion));
   END;

   CONFORM(Contract, CntrT);
   L_MSO.wordSetVarsByFile_wPrefix("CntrT", r);
   CONFORM(Contract, Firm);
   L_MSO.wordSetVar(r+"Firm."+"ContactPerson.Name",      P_Firm.FP_ContactPersonName(Firm.Firm, MDoc.SrcDate));
   L_MSO.wordSetVar(r+"Firm."+"ContactPerson.Post.Name", P_Firm.FP_ContactPersonPostName1(Firm.Firm, MDoc.SrcDate));
   L_Cntr.wordSetMainAcntVars(MDoc.Contract, MDoc.Date, r+"OwnFirm.AcntWLeader");
   SAVE(Firm);
   IF P_Cntr.HasActualPro(Contract.Contract, D, P_Cntr.P_Consignees) THEN
    P_Cntr.Decode_PaymentAgents(CntrPro.Value, Firms);
    IF ~!Firms[0] & !Firms[1] THEN
     L_General.Assert(SEARCH(Firm, Firm, Firms[0]),
                      " ᢮⢥ " + L_Str.IntStr(P_Cntr.P_Consignees ) + "  " + Contract.Contract +
                      "|㪠 騩 ࠣ " + Firms[0]);
    END;
   END;
   P_Firm.SetFirmData_wAlias(r + "Consignee", Firm.Firm, D, "", L_MSO.fps_Soft_asStr);
   RESTORE(Firm);
  ELSE
   P_Firm.AccessFirm(P_Firm.fomf(MDoc.MyFirm));
   P_Firm.AccessSilentFirmAcnt(P_Firm.fomf(MDoc.MyFirm), D);
   ownFirmAcnt:=FirmAcnt.FirmAcnt;
   SetFirmData_wPrefix(Firm.Firm, ownFirmAcnt, r+"Own",  MDoc.SrcDate);
   SetFirmData_wPrefix(Firm.Firm, ownFirmAcnt,   "Own",  MDoc.SrcDate);
   CONFORM(MDoc, Firm); (* ??? *)
  END;

  r:=Root;
  CONFORM(MDoc, Staff);
  L_MSO.wordSetVarsByFile_wPrefix("Staff", r);
  r:=r+"Staff.";

  CONFORM(Staff, Man);
  L_MSO.wordSetVarsByFile_wPrefix("Man", r);
  L_MSO.wordSetVar(r + "Man.Name.Short", L_Str.ShortName(Man.Name));

  HISTCONF(D, Staff, StaffLog);
  CONFORM(StaffLog, Officer, Post);
  L_MSO.wordSetVarsByFile_wPrefix("StaffLog", r);
  r:=r + "StaffLog.";
  L_MSO.wordSetVarsByFile_wPrefix("Officer", r);
  r:=r + "Officer.";
  L_MSO.wordSetVarsByFile_wPrefix("Post", r);

  r:=Root;
  CONFORM(MDoc, CostItem);
  L_MSO.wordSetVarsByFile_wPrefixE("CostItem", r, ~OCCURE(CostItem));
  IF OCCURE(CostItem) THEN
   CONFORM(CostItem, ACSet);
  ELSE
   L_General.CLEAR("ACSet");
  END;
  L_MSO.wordSetVarsByFile_wPrefixE("ACSet", r+"CostItem.", ~OCCURE(ACSet));

  CONFORM(MDoc, Alower);
  L_MSO.wordSetVarsByFile_wPrefixE("Alower", r, ~OCCURE(Alower));
  CONFORM(MDoc, Storage);
  L_MSO.wordSetVarsByFile_wPrefixE("Storage", r, ~OCCURE(Storage));
  CONFORM(MDoc, Storage2);
  L_MSO.wordSetVarsByFile_wPrefixE("Storage2", r, ~OCCURE(Storage2));

  L_MSO.wordSetVar(r+"3Direction", L_MDoc.MDoc3Direction());

  IF E_MDocP_MO_IsKeyAssetsDoc() THEN
   PrepareKeyAssetsMDoc(D, Root);
  ELSE
   PrepareStdMDoc(Document, D, Root);
   IF    ~!L_XDoc.GetRefToXDC_Transitively(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_CWOrder) THEN
    PrepareCWOrderMDoc(D, Root);
   ELSIF ~!L_XDoc.GetRefToXDC_Transitively(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_CarAD) THEN
    PrepareCarADMDoc(D, Root);
   ELSIF ~!L_XDoc.GetRefToXDC_Transitively(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_RprS) THEN
    PrepareRprSMDoc(D, Root);
   END;
  END;

  L_MSO.wordSetVar(r+"NotInventories", IsNotInventoriesMDoc());

  Local:=PROCREF(E_Stock.MDocP_MO_AdditionalPrepare);
  IF ~!Local THEN
   Local(D, Root, TemplateName, PrpResult);
  END;
 END {PrepareObjects};

 PRIVATE VAR
  curTemplateName: STRING[];
  curCtrlDate    : DATE;
  curPrpResult   : L_MSO.PrpResultType;

 PRIVATE PROCEDURE prepareDoc(VAR Document: OBJECT);
 BEGIN
  IF E_MDocP_MO_IsKeyAssetsDoc() THEN
   L_XDR.InitEntryList();
   L_MSO.IsDuplexDoc:=1;
  END;
  IF MDoc.MDocKind = L_MDoc.md_Spc THEN
   L_MSO.UseManualFeed:=1;
  END;
  PrepareObjects(Document, MDoc.Date, curTemplateName, curPrpResult);
 END {prepareDoc};

 PUBLIC PROCEDURE MakeDoc(TemplateList: STRING[];
                          PrpResult   : L_MSO.PrpResultType);
  VAR
   PrepareMode    : L_MSO.PrpModeType;
   MDocName,
   TemplateName,
   TmpTemplateName: STRING[];
   cur_iri        : L_General.tInternalRecordId;
 BEGIN
  TemplateName   :=L_Str.AnyItem(TemplateList, "|", 0);
  TmpTemplateName:=L_Str.AnyItem(TemplateList, "|", 1);
  L_General.Assert(~!TemplateName, "MDocP_MO.MakeDoc:  । ᭮ 蠡");

  L_MDoc.AccessMDoc();
  CONFORM(MDoc, MDocKind);

  curCtrlDate :=GetMDocSrcDate();
  curPrpResult:=PrpResult;
  PrepareMode:=L_MSO.GetStandartPrepareMode(curPrpResult);

  IF ~!TmpTemplateName THEN
   curTemplateName:=TmpTemplateName;
   L_MSO.BuildWordDocument(curTemplateName, 1, PrepareMode, "", PROCREF(prepareDoc));
  END;

  curTemplateName:=TemplateName;

  cur_iri:=L_General.iri_GetCurrent("MDoc");
  IF (PrepareMode = L_MSO.PrpMode_ToPDF) | (PrepareMode = L_MSO.PrpMode_ToImage) THEN
   L_MSO.BuildXDFWordDocument(cur_iri,
                              curTemplateName,
                              L_MDoc.E_MDocCopiesCount(curPrpResult),
                              PrepareMode, PROCREF(prepareDoc));
  ELSE
   L_MSO.BuildWordDocument(curTemplateName,
                           L_MDoc.E_MDocCopiesCount(curPrpResult),
                           PrepareMode, "", PROCREF(prepareDoc));
  END;

  IF PrpResult=L_MSO.PrpResult_Email THEN
   CONFORM(MDoc, MDocKind);
   CONFORM(MDoc, Contract, CntrT);
   MDocName:=MDocKind.ExtSName + " " + "(" + MDocKind.MDocKind + ")" + " " +
             MDoc.SrcNbr + "  " + L_DatTim.DateStr(MDoc.SrcDate) +
             "   " + Contract.SrcNbr +
             "  " + L_DatTim.DateStr(Contract.SrcDate) +
             ": " + CntrT.Name;

   L_APEMl.SendDocument(cur_iri,
                        MDocName,
                        L_EMail.AssembleContact(Firm.Name, P_Firm.FP_email(Firm.Firm, SYSDATE())));
  END;
  IF E_MDocP_MO_IsKeyAssetsDoc() THEN
   L_XDR.DeInitEntryList();
  END;
 END {MakeDoc};

 PRIVATE PROCEDURE MathIsConstruction(_Math: LIKE(Math.Math); D: DATE): SCAL[2];
 BEGIN
  L_MathR.PosToKAG(_Math, D);
  RETURN (KAGLog.DeprecT = 01) | (KAGLog.DeprecT = 02) |
         (~!KAGLog.OKOF & (KAGLog.OKOF < 130000000));
 END {MathIsConstruction};

 PRIVATE PROCEDURE NeedNewForm(): SCAL[2];
 BEGIN
  RETURN MDoc.Date >= 22\03\2003;
 END {NeedNewForm};

 PRIVATE PROCEDURE GetProducer(): STRING[];
 BEGIN
  L_MathR.StandOnVendor();
  RETURN Vendor.Name;
 END {GetProducer};

 PRIVATE PROCEDURE GetTemplateVersion(default: STRING[]): STRING[];
 BEGIN
  IF !default THEN
   IF    (MDoc.MDocKind = L_MDoc.md_ISF) | (MDoc.MDocKind = L_MDoc.md_DPr) THEN
    IF    MDoc.Date >= 24\01\2012 THEN default:="06";
    ELSIF MDoc.Date >= 25\11\2009 THEN default:="05";
    ELSIF MDoc.Date >= 30\05\2006 THEN default:="04";
    ELSIF MDoc.Date >= 01\03\2004 THEN default:="03";
    ELSIF MDoc.Date >= 01\08\2002 THEN default:="02";
    ELSE                               default:="01";
    END;
   ELSIF MDoc.MDocKind = L_MDoc.md_ITN THEN
    IF    MDoc.Date >= 29\04\2011 THEN default:="03";
    ELSIF MDoc.Date >= 16\03\2004 THEN default:="02";
    ELSE                               default:="01";
    END;
   ELSIF MDoc.MDocKind = L_MDoc.md_ISA THEN
    default:="02";
   ELSIF MDoc.MDocKind = L_MDoc.md_IsS THEN
    IF    MDoc.Date >= 01\01\2008 THEN default:="02";
    ELSE                               default:="01";
    END;
   END;
  END;
  RETURN default;
 END {GetTemplateVersion};

 PUBLIC PROCEDURE E_MDocP_MO_GetFullTemplateName(): STRING[];
  VAR
   Local    : PROC;
   Version,
   Template,
   Producer : STRING[];
   _HeadFirm: LIKE(Firm.Firm);
 BEGIN
  SETEMPTY(Template, Version);
  IF ~!MDoc.Contract THEN
   P_Cntr.GetTemplateNameAndVersion(MDoc.Contract, MDoc.Date, MDoc.MDocKind, Template, Version);
  END;
  Local:=PROCREF(E_Stock.MDocP_MO_GetTemplateName);
  IF ~!Local THEN
   Template:=Local(Template);
  END;
  Version:=GetTemplateVersion(Version);

  IF !Template THEN
   CONFORM(MDoc, MDocList);
   L_General.Assert(OCCURE(MDocList) | (MDoc.MDocKind = L_MDoc.md_Dvr), "⠥ ⮩ 㬥?");
   _HeadFirm:=P_Firm.FP_HeadFirm(P_Firm.fomf(MDoc.MyFirm), GetMDocSrcDate());
   IF    (MDoc.MDocKind = L_MDoc.md_AVb) & L_APtm.IsMGT() &
         ~!_HeadFirm & (_HeadFirm = P_Firm.FP_HeadFirm(MDoc.Firm, GetMDocSrcDate())) THEN
    Template:="OC-2x02";
   ELSIF (MDoc.MDocKind = L_MDoc.md_APr) |
         (MDoc.MDocKind = L_MDoc.md_AVb) THEN
    IF NeedNewForm() THEN
     CONFORM(MDocList, Math);
     Producer :=GetProducer();
     IF MathIsConstruction(MDocList.Math, MDoc.Date) THEN
      L_General.Assert(~NEXT(MDocList),
                       "   ᮮ㦥 ⨬ ଫ|"+
                       "᪮쪨 ꥪ⮢  ⮬");
      Template:="OC-1a02";
     ELSIF NEXT(MDocList) THEN
      WHILE OCCURE(MDocList) DO
       CONFORM(MDocList, Math);
       PROMPT("஢ઠ ᮤন . :" + Math.Math);
       L_General.Assert(Producer = GetProducer(),
                        " ꥪ⮢ ࠧ ⮢⥫.|"+
                        "ଫ  ⮬ ⨬.");
       L_General.Assert(~MathIsConstruction(MDocList.Math, MDoc.Date),
                        "   ᮮ㦥 ⨬ ଫ|"+
                        "᪮쪨 ꥪ⮢  ⮬");
       NEXT(MDocList);
      END; (* WHILE OCCURE(MDocList) ... *)
      Template:="OC-1b02";
     ELSE
      Template:="OC-1_02";
     END;
    ELSE
     Template:="OC-1";
    END;
   ELSIF MDoc.MDocKind = L_MDoc.md_APP THEN
    IF NeedNewForm() THEN
     Template:="OC-2_02";
    ELSE
     Template:="OC-1";
    END;
   ELSIF MDoc.MDocKind = L_MDoc.md_ASp THEN
    IF L_MathR.PosToCarLog(MDocList.Math, MDoc.Date) THEN
     IF NeedNewForm() THEN
      L_General.Assert(~NEXT(MDocList),
                       " ࠭ᯮ । ⨬ ଫ|"+
                       "᪮쪨 ꥪ⮢  ⮬");
      Template:="OC-4A02";
     ELSE
      Template:="OC-4A";
     END;
    ELSE
     IF NeedNewForm() THEN
      IF NEXT(MDocList) THEN
       WHILE OCCURE(MDocList) DO
        L_General.Assert(~L_MathR.PosToCarLog(MDocList.Math, MDoc.Date),
                         " ࠭ᯮ । ⨬ ଫ|"+
                         "᪮쪨 ꥪ⮢  ⮬");
        NEXT(MDocList);
       END; (* WHILE OCCURE(MDocList) ... *)
       Template:="OC-4B02";
      ELSE
       Template:="OC-4_02";
      END;
     ELSE
      Template:="OC-4";
     END;
    END;
   ELSIF MDoc.MDocKind = L_MDoc.md_ASO THEN
    IF NeedNewForm() THEN
     Template:="OC-2_02";
    ELSE
     Template:="OC-ASO";
    END;
   ELSIF MDoc.MDocKind = L_MDoc.md_ADo   THEN Template:="OC-3_02";
   ELSIF MDoc.MDocKind = L_MDoc.md_APO   THEN Template:="OC_APO";
   ELSIF MDoc.MDocKind = L_MDoc.md_APc   THEN Template:="OC_APc";
   ELSIF MDoc.MDocKind = L_MDoc.md_IsS   THEN Template:="MD_40_##";
   ELSIF (MDoc.MDocKind = L_MDoc.md_ITN) |
         (MDoc.MDocKind = L_MDoc.md_FPr) THEN Template:="MD_41_##";
   ELSIF (MDoc.MDocKind = L_MDoc.md_ISF) |
         (MDoc.MDocKind = L_MDoc.md_DPr) THEN Template:="MD_42_##";
   ELSIF MDoc.MDocKind = L_MDoc.md_IAS   THEN
    Template:="MD_43_##";
    IF ~!L_XDoc.GetRefToXDC_Transitively(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_RprS) THEN
     PositionOnTransitivelyRprS();
     IF    L_Rpr.IsRprS_w_Car() | L_Rpr.IsRprS_w_OutCar() THEN
      Template:="MD_43_SC_01";
     ELSIF L_Rpr.IsRprS_w_CarBlock() | L_Rpr.IsRprS_w_OutCBlc() THEN
      Template:="MD_43_WS_01";
     END;
    END;
   ELSIF MDoc.MDocKind = L_MDoc.md_ISA   THEN Template:="MD_64_##";
   ELSIF MDoc.MDocKind = L_MDoc.md_Dvr   THEN Template:="MDocAtrn";
   END;
  END;
  RETURN L_MSO.BuildTemplateName(Template, Version);
 END {E_MDocP_MO_GetFullTemplateName};

 PUBLIC PROCEDURE E_MDocP_MO_GetOtherFormFullTemplateName(): STRING[];
  VAR
   Local   : PROC;
   Version,
   Template: STRING[];
 BEGIN
  CONFORM(MDoc, Contract);
  SETEMPTY(Template, Version);
  IF ~!L_XDoc.GetRefToXDC_Transitively(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), L_XDoc.xdt_CWOrder) THEN
   Template:="MD_W_CWORDER_01.DOT";
  END;
  Local:=PROCREF(E_Stock.MDocP_MO_GetOtherFormTemplateName);
  IF ~!Local THEN
   Template:=Local(Template);
  END;
  L_General.Assert(~!Template, " ⥫쭮    㬥");
  Version:=GetTemplateVersion(Version);
  RETURN L_MSO.BuildTemplateName(Template, Version);
 END {E_MDocP_MO_GetOtherFormFullTemplateName};

END.
