(*
%Copyright   (c) Polak Computer System
%Author      22.05.2002 17:39:01 LDA
%Purpose     ⭨,  ॡ ன ᬮ
%Type        report
%Specific    SYS
%Modified    19.09.2014 16:19:08 POLAK\Gina
%Environment
*)

 MODULE MedExam [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, P_Officer, P_Man, L_bp, L_Staff, L_Man, FIO, L_Basis, L_Env;

 PRIVATE PROCEDURE CheckNeed_MedExamination(D: DATE): SCAL[2];
  VAR
   val: STRING[];
 BEGIN
  val:=P_Officer.GetProValueSoft(StaffLog.Sort, StaffLog.Officer, D, P_Officer.P_MedExamination);
  RETURN (val = "ਮ᪨") | (val = "ਮ᪨  ");
 END {CheckNeed_MedExamination};

 PRIVATE PROCEDURE CheckNeed_MedBook(D: DATE): SCAL[2];
 BEGIN
  RETURN P_Officer.HasActualOfcPro(StaffLog.Sort, StaffLog.Officer, D, P_Officer.P_MedBook);
 END {CheckNeed_MedBook};

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⠐");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⠦  ");
  L_Basis.wb_WrInQM(F, "騩 ⠦");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ᎌ");
  L_Basis.wb_WrInQM(F, "ᎌ客");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ॡࠢ");
  L_Basis.wb_WrInQM(F, "ࠢ砫ਮ");
  L_Basis.wb_WrInQM(F, "ࠢ揥ਮ");
  L_Basis.wb_WrInQM(F, "ࠢப");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "ࠢ⠑");
  L_Basis.wb_WrInQM(F, "ࠢ⠄");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "ॡ");
  L_Basis.wb_WrInQM(F, "砫ਮ");
  L_Basis.wb_WrInQM(F, "揥ਮ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⠑");
  L_Basis.wb_WrInQM(F, "⠄");
  L_Basis.wb_WrInQM(F, "⥍揥ਮ");
  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE GetStage(): NUMERIC[0];
  VAR
   StageDate: DATE;
 BEGIN
  TRY
   StageDate:=L_Man.GetStageDate(Memo.ud_fr(), L_Man.ins_Common);
  EXCEPT
  ON Exc: Exc_Raise DO
   SETEMPTY(StageDate);
  ELSE
   RAISE();
  END;
  RETURN L_DatTim.CompleteYearsInIntvl(StageDate, Memo.ud_fr());
 END {GetStage};

 PRIVATE PROCEDURE MakeLine(F: STRING[]);
  VAR
   DocSer,
   DocNum : STRING[];
 BEGIN
  CONFORM(Staff, Man);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrDat(F, Man.Birth);
  CONFORM(StaffLog, Officer);
  CONFORM(Officer, Post);
  CONFORM(Officer, Union);
  CONFORM(Officer, Sort);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);

  L_Basis.wb_WrNum(F, L_DatTim.CompleteYearsInIntvl(L_Staff.E_GetBegInFirm(Memo.ud_fr()), Memo.ud_fr()), 0);
  L_Basis.wb_WrNum(F, GetStage(), 0);
  IF L_Man.AccessManAdr(Man.Man, Memo.ud_ut(), L_Russia.at_RgMA) THEN
   L_Basis.wb_WrStr(F, L_Man.GetPostAdr_asStr(1));
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;

  IF P_Man.HasActualManPro(Staff.Man, Memo.ud_fr(), P_Man.P_MemberOMI) THEN
   L_Basis.wb_WrStr(F, ManPro.DocNum);
   L_Basis.wb_WrStr(F, ManPro.DocGiveS);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrStr(F, L_Man.GetManSINumber_asStr());
  L_Basis.wb_WrScl(F, CheckNeed_MedExamination(Memo.ud_ut()));
  L_Basis.wb_WrScl(F, P_Man.HasActualManPro(Staff.Man, Memo.ud_fr(), P_Man.P_MedicalSertification));
  L_Basis.wb_WrScl(F, P_Man.HasActualManPro(Staff.Man, Memo.ud_ut(), P_Man.P_MedicalSertification));
  IF P_Man.HasManPro(Staff.Man, Memo.ud_ut(), P_Man.P_MedicalSertification) THEN
   L_Basis.wb_WrNum(F, L_DatTim.YearsInIntvl(ManPro.DocGiveD, ManPro.DocExpD), 0);
   L_Basis.wb_WrStr(F, ManPro.DocNum);
   L_Basis.wb_WrDat(F, ManPro.DocGiveD);
   L_Basis.wb_WrDat(F, ManPro.DocExpD);
   L_Basis.wb_WrStr(F, ManPro.Value);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;

  L_Basis.wb_WrScl(F, CheckNeed_MedBook(Memo.ud_ut()));
  L_Basis.wb_WrScl(F, P_Man.HasActualManPro(Staff.Man, Memo.ud_fr(), P_Man.P_PersonalMedicalBook));
  L_Basis.wb_WrScl(F, P_Man.HasActualManPro(Staff.Man, Memo.ud_ut(), P_Man.P_PersonalMedicalBook));
  IF P_Man.HasManPro(Staff.Man, Memo.ud_ut(), P_Man.P_PersonalMedicalBook) THEN
   L_Basis.wb_WrStr(F, ManPro.DocNum);
   L_Basis.wb_WrDat(F, ManPro.DocGiveD);
   L_Basis.wb_WrDat(F, ManPro.DocExpD);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrScl(F, L_Staff.rInState(Memo.ud_ut()));
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PUBLIC PROCEDURE MedEx();
  CONST
   bpId = "MedEx";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.SetCacheables(["Man", "Staff", "StaffLog"]);
  L_bp.Begin(bpId, " ࠢ  ", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  MakeTop('F');
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(". " + Staff.TSN);
   IF L_Env.RealTSN(Staff.TSN) & L_Staff.InStateInPer(Memo.ud_fr(), Memo.ud_ut()) THEN
    L_Staff.PosToStaffLog(Staff.TSN, Memo.ud_ut(), 1);
    MakeLine('F');
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  FIO.Close(F);
  L_bp.End();
 END {MedEx};

END.
