(*
%Copyright   (c) Polak IT
%Author      14.02.2003 13:27:30 POLAK\SAN
%Purpose     প ⥪饩 /ਮ
%Type        library
%Specific    SYS
%Modified    08.08.2014 21:05:15 POLAK\San
%Environment
*)

 MODULE Memo [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_SES, L_PCS, L_StdFrm, DBD;

 PRIVATE PERMANENT VAR
  gl_CurDate,
  gl_MonthB,
  gl_MonthE  : DATE;
  ud_CurDate,
  ud_MonthB,
  ud_MonthE  : DATE;
  ud_From,
  ud_UpTo    : DATE;

 CurDate,
 MonthB,
 MonthE      : DATE; (*  ᮢ⨬  "" *)

 PUBLIC PROCEDURE gl_SetCurDate(D: DATE);
 BEGIN
  gl_CurDate:=D;
  gl_MonthB :=L_DatTim.MonthBeg(D);
  gl_MonthE :=L_DatTim.MonthEnd(D);
  L_PCS.ChangeGlobalCurDate(D);
 END {gl_SetCurDate};

 PUBLIC PROCEDURE gl_cd(): DATE;
 BEGIN
  RETURN gl_CurDate;
 END {gl_cd};

 PUBLIC PROCEDURE gl_mb(): DATE;
 BEGIN
  RETURN gl_MonthB;
 END {gl_mb};

 PUBLIC PROCEDURE gl_me(): DATE;
 BEGIN
  RETURN gl_MonthE;
 END {gl_me};

 PUBLIC PROCEDURE UIP_SetIntvl(_From, _UpTo: DATE);
 BEGIN
  ud_From  :=_From;
  ud_UpTo  :=_UpTo;
  L_PCS.SetApplicationTitle();
 END {UIP_SetIntvl};

 PUBLIC PROCEDURE SetIntvl(_From, _UpTo: DATE);
 BEGIN
  UIP_SetIntvl(_From, _UpTo);
  L_SES.PutValueAtCurTrn(L_SES.sit_User, "Memo.From", FLDTOSTR(ud_From));
  L_SES.PutValueAtCurTrn(L_SES.sit_User, "Memo.UpTo", FLDTOSTR(ud_UpTo));
 END {SetIntvl};

 PUBLIC PROCEDURE DefineApplicationProperties();
  VAR
   trgProportionalFontFace: STRING[];
 BEGIN
  IF L_StdFrm.wGUI() THEN
   APP.Get().Mousable                  :=1;
   APP.Get().MenuRespondToMouseMovement:=1;
   APP.Get().MenuArrangeStyle          :=L_SES.GetFieldValue_asNUMERIC(L_SES.sit_User, "APP.MenuArrangeStyle",           APP.Get().MenuArrangeStyle);
   SETEMPTY(trgProportionalFontFace);
   IF ~L_SES.GetValue(L_SES.sit_User, "APP.ProportionalFontFace", trgProportionalFontFace) |
      ~L_General.SetProportionalFontFace(trgProportionalFontFace) THEN
    SETEMPTY(APP.Get().ProportionalFontFace);
   END;
   APP.Get().UseAltForMainMenuAccess  :=L_SES.GetFieldValue_asNUMERIC(L_SES.sit_User, "APP.UseAltForMainMenuAccess",    APP.Get().UseAltForMainMenuAccess);
   IF L_General.IsAcceptableProcessorVersion(014234010) THEN
    APP.Get().LargeUISchema           :=L_SES.GetFieldValue_asNUMERIC(L_SES.sit_User, "APP.LargeUISchema",    APP.Get().LargeUISchema);
   END;
   IF L_General.IsAcceptableProcessorVersion(014237010) THEN
    APP.Get().ForceClearType          :=L_SES.GetFieldValue_asNUMERIC(L_SES.sit_User, "APP.ForceClearType",   APP.Get().ForceClearType);
   END;
  ELSE
   APP.Get().Mousable                  :=L_SES.GetFieldValue_asNUMERIC(L_SES.sit_User, "APP.Mousable",                   APP.Get().Mousable);
   APP.Get().MenuRespondToMouseMovement:=L_SES.GetFieldValue_asNUMERIC(L_SES.sit_User, "APP.MenuRespondToMouseMovement", APP.Get().MenuRespondToMouseMovement);
   APP.Get().MenuArrangeStyle          :=L_SES.GetFieldValue_asNUMERIC(L_SES.sit_User, "APP.MenuArrangeStyle",           APP.Get().MenuArrangeStyle);
  END;
 END {DefineApplicationProperties};

 PUBLIC PROCEDURE DefineSesValues();
 BEGIN
  ud_From    :=L_SES.GetFieldValue_asDATE(L_SES.sit_User, "Memo.From",     L_DatTim.MonthBeg(SYSDATE()));
  ud_UpTo    :=L_SES.GetFieldValue_asDATE(L_SES.sit_User, "Memo.UpTo",     L_DatTim.MonthEnd(SYSDATE()));

  DefineApplicationProperties();
  L_PCS.DefineSesValues();
  L_PCS.SetApplicationTitle();
 END {DefineSesValues};

 PUBLIC PROCEDURE UIP_SetCurDate(D: DATE);
 BEGIN
  gl_SetCurDate(D);
  ud_CurDate:=D;
  ud_MonthB :=L_DatTim.MonthBeg(D);
  ud_MonthE :=L_DatTim.MonthEnd(D);
  SE_DEFAULTGUIDE(ud_CurDate);
  L_PCS.SetApplicationTitle();
  CurDate:=ud_CurDate;
  MonthB :=ud_MonthB ;
  MonthE :=ud_MonthE ;
 END {UIP_SetCurDate};

 PUBLIC PROCEDURE ud_SetCurDate(D: DATE);
 BEGIN
  UIP_SetCurDate(D);
  L_SES.PutValueAtSlaveTrn(L_SES.sit_User, "Memo.LastDate", FLDTOSTR(D));
 END {ud_SetCurDate};

 PUBLIC PROCEDURE ud_cd(): DATE;
 BEGIN
  RETURN ud_CurDate;
 END {ud_cd};

 PUBLIC PROCEDURE ud_mb(): DATE;
 BEGIN
  RETURN ud_MonthB;
 END {ud_mb};

 PUBLIC PROCEDURE ud_me(): DATE;
 BEGIN
  RETURN ud_MonthE;
 END {ud_me};

 PUBLIC PROCEDURE ud_fr(): DATE;
 BEGIN
  RETURN ud_From;
 END {ud_fr};

 PUBLIC PROCEDURE ud_ut(): DATE;
 BEGIN
  RETURN ud_UpTo;
 END {ud_ut};

 (*!*) PUBLIC PROCEDURE From(): DATE;
 BEGIN
  RETURN ud_fr();
 END {From};

 (*!*) PUBLIC PROCEDURE UpTo(): DATE;
 BEGIN
  RETURN ud_ut();
 END {UpTo};

 PUBLIC PROCEDURE tmp_cd(): DATE;
 BEGIN
  RETURN gl_cd();
 END {tmp_cd};

 PUBLIC PROCEDURE tmp_mb(): DATE;
 BEGIN
  RETURN L_DatTim.MonthBeg(tmp_cd());
 END {tmp_mb};

 PUBLIC PROCEDURE tmp_me(): DATE;
 BEGIN
  RETURN L_DatTim.MonthEnd(tmp_cd());
 END {tmp_me};

 PUBLIC PROCEDURE YearB(): DATE;
 BEGIN
  RETURN L_DatTim.YearBeg(tmp_cd());
 END {YearB};

BEGIN
(* . 0089252 12.01.2012 19:54:45 POLAK\San *)
 IF VAR_IMPL.Get(ud_CurDate).Initialized THEN
  gl_SetCurDate(ud_CurDate);
 END;
END.
