(*
%Copyright   (c) Polak IT
%Author      19.05.1999 18:47:45 BOR
%Purpose     ꥪ,    쭮 ⪠  ᪫
%Type        report
%Specific    SYS
%Modified    16.06.2014 15:32:51 POLAK\MLB
%Environment
*)

 MODULE MLM01 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_MathR, P_Math, L_AFM, L_XObj, L_DatTim, L_Stock, P_Storage, L_Basis, FIO, L_bp,
        P_Firm, L_Str, L_Acnt, L_AcCut;

 PRIVATE CONST
  mmAmount = 3;

 PRIVATE VAR
  wMF     : SCAL[2];
  trgMMode: LIKE(MMode.MMode)[mmAmount];

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CREATE_TABLE(Tmp, , "६ 䠩 - 祭   ⪮  㬠");
  CREATE_FIELD(Tmp, Math,     LIKE(Math.Math),       , , , "");
  CREATE_FIELD(Tmp, MMode,    LIKE(MMode.MMode),     , , , "");
  CREATE_FIELD(Tmp, MyFirm,   LIKE(MyFirm.MyFirm),   , , , " ࣠");
  CREATE_FIELD(Tmp, Storage,  LIKE(Storage.Storage), , , , "");
  CREATE_FIELD(Tmp, Rmnds,    P_Math.tRemainders,    , , , "  ᨬ ⪨");
  CREATE_FIELD(Tmp, LowRest,  SCAL[2],               , , , "⮪  쭮");
  CREATE_FIELD(Tmp, Rest,     L_XObj.tQnt,           , , , "⮪");

  CREATE_INDEX_AND_LINK(Tmp, Math,    UNIQUE, Math,    Math,    USER, , , Math, MyFirm, MMode, Storage);
  CREATE_INDEX_AND_LINK(Tmp, Storage, PLURAL, Storage, Storage, USER, , , Storage);
  CREATE_INDEX_AND_LINK(Tmp, MyFirm,  PLURAL, MyFirm,  MyFirm,  USER, , , MyFirm);

  SET_VERSION_OF_TABLE(Tmp, 0001);
  L_AFM.CreateTemp("Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE InsTmp(trgMath   : LIKE(Math.Math);
                          trgMyFirm : LIKE(MyFirm.MyFirm);
                          trgMMode  : LIKE(MMode.MMode);
                          trgStorage: LIKE(Storage.Storage);
                          trgRmnds  : P_Math.tRemainders;
                          trgRest   : L_XObj.tQnt;
                          TotalRest : L_XObj.tQnt);
 BEGIN
  DEFAULT(Tmp);
  Tmp.Math    :=trgMath;
  Tmp.MyFirm  :=trgMyFirm;
  Tmp.MMode   :=trgMMode;
  Tmp.Storage :=trgStorage;
  Tmp.Rmnds   :=trgRmnds;
  Tmp.Rest    :=trgRest;
  Tmp.LowRest :=(TotalRest < trgRmnds[P_Math.rem_Min]);
  INSERT(Tmp)
 END {InsTmp};

 PRIVATE PROCEDURE GetAcCut(trgMathType: LIKE(MathType.MathType); trgMMode: LIKE(MMode.MMode)): LIKE(AcCut.AcCut);
  VAR
   Result: LIKE(AcCut.AcCut);
 BEGIN
  SETEMPTY(Result);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=L_Acnt.GetSpecificAcCutForMTMM(SYSDATE(), trgMathType, trgMMode, L_Acnt.acp_Math_Netto);
  EXCEPT
  ON Exc:Exc_Raise DO
  END; (* TRY *)
  RETURN Result;
 END {GetAcCut};

 PRIVATE PROCEDURE Calc();
  VAR
   dmySum     : L_XObj.tSum;
   curPer     : DATE;
   curRest,
   tmmRest    : L_XObj.tQnt[mmAmount];
   tstRest,
   totRest    : L_XObj.tQnt;
   Rmnds,
   totRmnds   : P_Math.tRemainders;
   trgStorages: LIKE(Storage.Storage)[P_Math.smr_Amount];
   trgMins    : L_XObj.tQnt[P_Math.smr_Amount];
   trgRmnds   : P_Math.tRemainders;
   i          : SCAL[mmAmount];
   j          : SCAL[P_Math.smr_Amount];
   trgAcCut   : LIKE(AcCut.AcCut)[mmAmount];
 BEGIN
  curPer:=L_DatTim.Per(SYSDATE());
  L_MathR.CountUpMath(Math.Math, curPer);

  SETEMPTY(trgAcCut);
  FOR_EACH i DO
   trgAcCut[i]:=GetAcCut(Math.MathType, trgMMode[i]);
  END; (* FOR_EACH *)

  totRmnds:=P_Math.GetRemainders(Math.Math, SYSDATE());
  P_Math.GetMinRemainders(Math.Math, SYSDATE(), trgStorages, trgMins);

  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF (MyFirm.MyFirm # P_Firm.mf_Fict) & L_DatTim.IsActive(SYSDATE(), MyFirm.Begin, MyFirm.Till) THEN
    SETZERO(totRest, tmmRest);
    SELECT(mItem, Math, , Math.Math);
    WHILE OCCURE(mItem) DO
     IF mItem.MyFirm = MyFirm.MyFirm THEN
      IF ~P_Storage.IsRepair(mItem.Storage, SYSDATE()) THEN
       CONFORM(mItem, Storage);
       CONFORM(mItem, XObject);
       IF Storage.Type # L_Stock.st_AdvHolder THEN
        SETZERO(tstRest, curRest);
        FOR_EACH i DO
         IF ~!trgAcCut[i] THEN
          L_XObj.GetOutSaldo(trgAcCut[i], curPer, dmySum, curRest[i]);
          INC(tmmRest[i], curRest[i]);
          INC(tstRest, curRest[i]);
         END;
        END; (* FOR_EACH *)
        INC(totRest, tstRest);
        Rmnds:=P_Math.GetStorageRemainders(Math.Math, SYSDATE(), Storage.Storage);
        IF tstRest < Rmnds[P_Math.rem_Min] THEN
         FOR_EACH i DO
          IF ~!trgAcCut[i] # 0 THEN
           InsTmp(Math.Math, MyFirm.MyFirm, trgMMode[i], Storage.Storage, Rmnds, curRest[i], tstRest);
          END;
         END; (* FOR_EACH *)
        END;
        FOR_EACH j DO
         IF trgStorages[j] = Storage.Storage THEN
          SETEMPTY(trgStorages[j]);
          EXIT;
         END;
        END; (* FOR_EACH j *)
       END;
      END; (* IF P_Storage.StoringType ... *)
     END; (* IF mItem.MyFirm = MyFirm.MyFirm ... *)
     NEXT(mItem);
    END; (* WHILE OCCURE(mItem) ... *)
  
    FOR_EACH j DO
     IF ~!trgStorages[j] THEN
      trgRmnds[P_Math.rem_Min]:=trgMins[j];
      trgRmnds[P_Math.rem_Max]:=MAXOF(L_XObj.tQnt);
      InsTmp(Math.Math, MyFirm.MyFirm, trgMMode[i], trgStorages[j], trgRmnds, 0, 0);
     END;
    END; (* FOR_EACH j *)
    FOR_EACH i DO
     IF SELECT(Tmp, Math, Math.Math, MyFirm.MyFirm, trgMMode[i]) | (totRest < totRmnds[P_Math.rem_Min]) THEN
      InsTmp(Math.Math, MyFirm.MyFirm, trgMMode[i], EMPTYOF(Storage.Storage), totRmnds, tmmRest[i], totRest);
     END;
    END; (* FOR_EACH *)
   END; (* IF (MyFirm.MyFirm ... *)

   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
 END {Calc};

 PRIVATE PROCEDURE MakeIndex();
 BEGIN
  APP.Get().NewPrompt("ઠ");
  trgMMode[0]:=L_MathR.mm_New;
  trgMMode[1]:=L_MathR.mm_Used;
  trgMMode[2]:=L_MathR.mm_Restored;
  Create_Tmp();
  SELECT(Math, LeafMK, , 1, L_MathR.mathk_Math);
  WHILE OCCURE(Math) DO
   PROMPT(" " + Math.Math);
   IF L_DatTim.IsActive(SYSDATE(), Math.Begin, Math.Till) &
      P_Math.HasActualMathPro(Math.Math, SYSDATE(), P_Math.P_Remainders) THEN
    Calc();
   END; (* IF L_DatTim.IsActive(SYSDATE(), Math.Begin, Math.Till)... *)
   NEXT(Math);
  END; (* WHILE OCCURE(Math)... *)
 END {MakeIndex};

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⮢⥫");
  L_Basis.wb_WrInQM(F, "⮢⥫");
  L_Basis.wb_WrInQM(F, "⠫");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "ॣ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㯯ப⨬⨊");
  L_Basis.wb_WrInQM(F, "㯯ப⨬");
  L_Basis.wb_WrInQM(F, "⮪");
  L_Basis.wb_WrInQM(F, "⮪");
  L_Basis.wb_WrInQM(F, "⮪");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "襌⪠");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]; trgMarkG: LIKE(MarkG.MarkG); Price: L_XObj.tSum);
 BEGIN
  IF wMF THEN
   CONFORM(Tmp, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrScl(F, MathType.MathType);
  L_Basis.wb_WrStr(F, MathType.Name);
  L_Basis.wb_WrScl(F, MUnit.MUnit);
  L_Basis.wb_WrStr(F, MUnit.Name);
  L_Basis.wb_WrScl(F, Vendor.Vendor);
  L_Basis.wb_WrStr(F, Vendor.Name);
  L_Basis.wb_WrStr(F, Math.UnitedC);
  L_Basis.wb_WrScl(F, CarUnit.CarUnit);
  L_Basis.wb_WrStr(F, CarUnit.Name);

  IF ~!Tmp.Storage THEN
   CONFORM(Tmp, Storage);
   L_Basis.wb_WrScl(F, Storage.Storage);
   L_Basis.wb_WrStr(F, Storage.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, " 楫  ।");
  END;
  L_Basis.wb_WrStr(F, L_MathR.MModeStr(Tmp.MMode));
  IF ~!trgMarkG THEN
   SEARCH(MarkG, MarkG, , trgMarkG);
   L_Basis.wb_WrScl(F, MarkG.MarkG);
   L_Basis.wb_WrStr(F, MarkG.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "-----");
  END;
  L_Basis.wb_WrNum(F, Tmp.Rmnds[P_Math.rem_Min], 3);
  L_Basis.wb_WrNum(F, Tmp.Rmnds[P_Math.rem_Max], 3);
  L_Basis.wb_WrNum(F, Tmp.Rest, 3);
  L_Basis.wb_WrNum(F, Price,    2);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", Tmp.LowRest));
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PUBLIC PROCEDURE MLM01();
  CONST
   bpId = "MLM01";
  VAR
   Price   : L_XObj.tSum;
   trgAcCut: LIKE(AcCut.AcCut);
 BEGIN
  L_bp.Begin(bpId, "ꥪ,    쭮 ⪠  ᪫", L_bp.t_RTBasis, L_General.timeCond_Entire);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());

  MakeIndex();

  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
  SELECT(Tmp, Math);
  WHILE OCCURE(Tmp) DO
   PROMPT(" " + Tmp.Math);
   NARROWSEL(Tmp, Math, MyFirm, MMode);
   WHILE OCCURE(Tmp) DO
    CONFORM(Tmp,  Math);
    CONFORM(Math, MathType);
    CONFORM(Math, MUnit);
    CONFORM(Math, Vendor);
    CONFORM(Math, CarUnit);

    trgAcCut:=GetAcCut(Math.MathType, Tmp.MMode);
    IF ~!trgAcCut THEN
     SEARCH(AcCut, AcCut, , trgAcCut);
     Price:=L_MathR.GetANYMathPrice(SYSDATE(), Tmp.Math, Tmp.MyFirm, AcCut.PriceGrp);
    ELSE
     SETEMPTY(Price);
    END;

    MakePart("R", EMPTYOF(MarkG.MarkG), Price);

    SELECT(MathMrkG, Math, , Tmp.Math);
    WHILE OCCURE(MathMrkG) DO
     MakePart("R", MathMrkG.MarkG, Price);
     NEXT(MathMrkG);
    END; (* WHILE OCCURE(MathMrkG) ... *)

    NEXT(Tmp);
   END; (* WHILE OCCURE(Tmp) ... *)
   NEXTINEXTENDEDSEL(Tmp, Math, MyFirm, MMode);
  END; (* WHILE OCCURE(Tmp) ... *)
  FIO.Close(R);
  L_bp.End();
 END {MLM01};

END.
