(*
%Copyright   (c) Polak Computer System
%Author      06.12.1999 17:46:19 BOR
%Purpose       ⮢
%Type        report
%Specific    LOC
%Modified    18.08.2014 13:53:26 POLAK\Gina
%Environment
*)

 MODULE MltCount [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, E_Utils, L_OwnData, L_General, L_Staff, L_DatTim, L_Man,
        L_Env, L_ManMlt, L_Str, L_AFM, P_Firm, L_ctc, L_EC, P_MyFirm, P_MyPlc, Str;

 PRIVATE CONST
  row_Officials         = 01;
  row_Personnel_Tot     = 02;
  row_Personnel_A       = 03;
  row_Personnel_C       = 04;
  row_Personnel_D       = 05;
  row_Personnel_E       = 06;
  row_Personnel_F       = 07;
  row_Personnel_I       = 08;
  row_Personnel_M       = 09;
  row_Personnel_N       = 10;
  row_OtherEcAct        = 11;
  row_OtherClrc         = 12;
  row_Workers_Tot       = 13;
  row_Workers_wClass    = 14;
  row_Workers_woClass   = 15;
  row_Workers_AC        = 16;
  row_Workers_Loco      = 17;
  row_Workers_Drv       = 18;
  row_Workers_tractor   = 19;
  row_Aviators          = 20;
  row_Mariners          = 21;
  row_Total1            = 22;
  row_NoReservation     = 23;
  row_Total2            = 24;

  NumRow   = 24;
  NumCol   = 11;
  MaxRow   = NumRow + 1;
  MaxCol   = NumCol + 1;
 
  r2_Officials       = 01;
  r2_Personnel       = 02;
  r2_OtherClrc       = 03;
  r2_Workers_Tot     = 04;
  r2_Workers_RoutDrv = 05;
  r2_Workers_SubsDrv = 06;
  r2_Workers_SrpsDrv = 07;
  r2_Workers_Repair  = 08;
  r2_Workers_Other   = 09;
  r2_Total           = 10;

  NumRow2   = 10;
  NumCol2   = 7;
  MaxRow2   = NumRow2 + 1;
  MaxCol2   = NumCol2 + 1;

 PRIVATE VAR
  Count_  : NUMERIC[0][MaxRow*MaxCol];
  Count__ : NUMERIC[0][MaxCol];
  Cnt_    : NUMERIC[0][MaxRow2*MaxCol2];
  Cnt__   : NUMERIC[0][MaxCol2];

(*
$P{ RepTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|----------------------------------------------------------------------------|
|       |  ⢮                   |         |        |
|--------------|---------------------------------------|----------|----------|
}
*)

(*
$P{ RepLine:
Man.Man, L, ""
Man.Name, L, ""
?, L, "D.N.y"
?, L, "D.N.y"
@
|##############|#######################################|##########|##########|
}
*)

(*
$P{ RepBot:
?, R, "0"
@
|----------------------------------------------------------------------------|
|⮣ ##### 祫                                                         |
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE CreateTmp();
 BEGIN
  CreateFILE(Tmp, "", "஢", "");
  CreateFIELD(Tmp, Man,  LIKE(Man.Man), "", "", "", "", "");
  CreateFIELD(Tmp, From, DATE         , "", "", "", "", "");
  CreateFIELD(Tmp, UpTo, DATE         , "", "", "", "", "");
  CreateINDEX(Tmp, Man, PLURAL, "", "", Man, From);
  SetVersionOfFILE(Tmp, 0000);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
 END {CreateTmp};

 PRIVATE PROCEDURE PrepareTmp(Cond: PROC);
 BEGIN
  FOR_EACH ManMlt DO
   PROMPT("C஢ - " + ManMlt.Man);
   IF Cond() THEN
    Tmp.Man :=ManMlt.Man;
    Tmp.From:=ManMlt.From;
    Tmp.UpTo:=ManMlt.UpTo;
    INSERT(Tmp);
   END;
  END; (* FOR_EACH ManMlt *)
 END {PrepareTmp};

 PRIVATE PROCEDURE MakeRep(RepName: STRING[]; Cond: PROC; RepTitle: STRING[]);
  VAR
   Count: NUMERIC[0];
 BEGIN
  CreateTmp();
  PrepareTmp(Cond);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  Count:=0;
  MAKEPART(R, RepTop, RepName, RepTitle);
  SETSEL(Tmp, Man);
  FOR_EACH Tmp DO
   PROMPT(Tmp.Man);
   SEARCH(Man, Man, , Tmp.Man);
   MAKEPART(R, RepLine, Tmp.From, Tmp.UpTo);
   INC(Count);
  END; (* FOR_EACH Tmp *)
  MAKEPART(R, RepBot, Count);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("Tmp");
 END {MakeRep};

 PRIVATE PROCEDURE CurDateCond(): SCAL[2];
 BEGIN
  RETURN L_DatTim.IsActive_Inc(Memo.ud_cd(), ManMlt.From, ManMlt.UpTo);
 END {CurDateCond};

 PRIVATE PROCEDURE AlltimeCond(): SCAL[2];
 BEGIN
  RETURN 1;
 END {AlltimeCond};

 PROCEDURE MltCount_Cond_IsTuned(): SCAL[2];
 BEGIN
  RETURN ~!PROCREF(E_Utils.MltCount_CondRowNew);
 END {MltCount_Cond_IsTuned};

(*
$P{ Top:
MltCount_Cond_IsTuned(), L, "!!!    !!!|", "B"
MltCount_Cond_IsTuned(), L, "!!!  ᫮ ࠧᥭ ࠡ⭨   ''  ନ ⮏ !!!|", "B"
L_OwnData.ODFirmName(SYSDATE()), C, "", "U"
Memo.ud_cd(), L, "y", "U"
@
#########################                                                                                                                                                 ଠ 6
#########################################################################################                                              ᥪ⭮  ࠭⥫쭠 ⬥⪠
                                                                                                                                 ( )*
                                                                                                                                                                    _____
                                           ᫥ ࠡ  ஭஢ ࠦ, ॡ뢠   ( - )                                   ---------------
                                                                                                                                                          |             |
                                  ######################################################################################################                           |-------------|
                                                                                                                                          ᫮ 饭  6 |             |
                                                                                ####                                                                          |-------------|
                                                                                                                                          ᫮ 饭      |             |
=================================================================================================================================================================================|
|                  |  |  ᥣ   |        ᫥ ᥣ ࠡ        | ᫥  ஭஢|᫥|᫥|         |ਬ砭 |
|     ⥣਩ ⥩     |-|ࠡ|-------------------------------------------------|--------------------------------| ஭-|    ,   |᫥|           |
| 㦠  ᨩ ࠡ |-|          |  ᥣ  |      ⮬ ᫥      |᫥ -|  ᥣ  |       ⮬ ᫥     |  ஢ |    |   ᥣ   |           |
|                              | |          |         |----------------------|騪, 笠-|         |----------------------|  ,   |-|ࠡ |           |
|                              |/|          |         |஢ |࠯騪,|, ঠ⮢, |         |஢ |࠯騪,|    |      |     -     |           |
|                              |   |          |         |         |  笠, |設,᮫ |         |         |  笠, |-|।ᠭ|  ࠦ, |           |
|                              |   |          |         |         | ঠ⮢, |ᮢ ,|         |         | ঠ⮢, |      |           | |           |
|                              |   |          |         |         |  設,  |  ࠭祭   |         |         |  設,  |।ᠭ|           |ਧ  |           |
|                              |   |          |         |         |  ᮫   |  |         |         |  ᮫   |           |           |    |           |
|                              |   |          |         |         |  ᮢ  |     㦡     |         |         |  ᮢ  |           |           |  㦡   |           |
|------------------------------|---|----------|---------|---------|------------|----------------|---------|---------|------------|-----------|-----------|-----------|-----------|
|                             |  |    1     |    2    |    3    |     4      |       5        |    6    |    7    |      8     |     9     |    10     |    11     |    12     |
}
*)

(*
$P{ Separator:
@
|------------------------------|---|----------|---------|---------|------------|----------------|---------|---------|------------|-----------|-----------|-----------|-----------|
}
*)

(*
$P{ Line:
?, L, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
@
|##############################|## |##########|#########|#########|############|################|#########|#########|############|###########|###########|###########|           |
}
*)

(*
$P{ Bot:
P_Firm.FP_LeadPostName1(P_Firm.OWN_FIRM, SYSDATE()), C, "", "U"
"", L, "", "U" (*⮡ ન 뫮 *)
P_Firm.FP_LeadName(P_Firm.OWN_FIRM, SYSDATE()), C, "", "U"
@
=(c) Polak========================================================================================================================================================================

                                                  ######################################################  #####################  #################################################

*   ࣠樥  ⢮ ஭஢  300  - " 㦥 짮"
}
*)

(*
$P{ Top1:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
####################################################################################                                      ########## ######
=#####=====================================================================================================================================
|                                 ⭨ (稭),  騥  ᪮  (ࠢ筮                                   |
|                                             ᫥  ஭஢ 易)                                             |
|-----------------------------------------------------------------------------------------------------------------------------------------|
|           |                                             |                              |                           |
|--------------|------------------------------------------------|------------------------------------|------------------------------------|
}
*)

(*
$P{ Line1:
Man.Man, L, ""
Man.Name, L, ""
Sort.Sort, L, ""
Sort.Name, L, ""
Post.Post, L , ""
Post.Name, L, ""
@
|##############|################################################|### ################################|### ################################|
}
*)

(*
$P{ Bot1:
?, L, "0"
@
|-----------------------------------------------------------------------------------------------------------------------------------------|
|ᥣ #### 祫                                                                                                                       |
=(c) Polak=================================================================================================================================
}
*)

(*
$P{ Top2:
L_OwnData.ODFirmName(SYSDATE()), C, ""
Memo.ud_cd(), L, "D.N.y"
@
                             㤮 ᮢ ( ॣ)
##############################################################################################
                                   ﭨ  ##########
==============================================================================================
|                  | N |ᥣ |᪢|᪮|㣨 |㣨|஬ ⮣ ᮢ.|
|     ⥣਩ ⥩     |-|ࠡ- |      | |ॣ|࠭|-------------------|
| 㦠  ᨩ ࠡ |-||      |        |     |   | 㣨|   |
|                              | |      |      |        |       |      |࣠|  ઠ  |
|------------------------------|---|------|------|--------|-------|------|---------|---------|
|                             |  |  1   |  2   |   3    |   4   |  5   |    6    |    7    |
|------------------------------|---|------|------|--------|-------|------|---------|---------|
}
*)

(*
$P{ Separator2:
@
|------------------------------|---|------|------|--------|-------|------|---------|---------|
}
*)

(*
$P{ Line2:
?, L, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
@
|##############################|## |######|######|########|#######|######|#########|#########|
}
*)

(*
$P{ Bot2:
@
=(c) Polak====================================================================================
}
*)

 PRIVATE PROCEDURE LeadPhone(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=P_Firm.GetFirmCtcVal(0, P_Firm.OWN_FIRM, Memo.ud_cd(), L_ctc.ckt_Leader, L_ctc.cvc_Work, L_ctc.cvt_PhonePST);
  IF !Result THEN
   Result:=P_Firm.FP_Phone(P_Firm.OWN_FIRM, Memo.ud_cd());
  END;
  RETURN Result;
 END {FP_AcntPhone};

 PRIVATE PROCEDURE FP_HeadFirmName(): STRING[];
  VAR
   HeadFirm: LIKE(Firm.Firm);
 BEGIN
  HeadFirm:=P_Firm.FP_HeadFirm(P_Firm.OWN_FIRM, Memo.ud_cd());
  IF ~!HeadFirm THEN
   RETURN P_Firm.FP_PersonFullName(HeadFirm, Memo.ud_cd());
  ELSE
   RETURN "";
  END;
 END {FP_HeadFirmName};

 PRIVATE PROCEDURE GetAdr_Reg(trgFirm: LIKE(Firm.Firm)): STRING[];
 BEGIN
  IF P_Firm.FP_PrtnrTyp(trgFirm, Memo.ud_cd()) = P_Firm.pt_Branch THEN
   trgFirm:=P_Firm.FP_HeadFirm(trgFirm, Memo.ud_cd());
  END;
  RETURN L_ctc.GetAdr_Reg(Memo.ud_cd(), trgFirm);
 END {GetAdr_Reg};

 PRIVATE PROCEDURE GetOGRNDocument(): STRING[];
 BEGIN
  RETURN Str.Condense(L_DatTim.DateStr(P_Firm.GetFirmProDocGiveD(P_Firm.OWN_FIRM, Memo.ud_cd(), P_Firm.P_OGRN))+" "+
                      P_Firm.GetFirmProDocGiveS(P_Firm.OWN_FIRM, Memo.ud_cd(), P_Firm.P_OGRN)+" "+
                      P_Firm.GetFirmProDocNum(P_Firm.OWN_FIRM, Memo.ud_cd(), P_Firm.P_OGRN));
 END {GetOGRNDocument};

 PRIVATE PROCEDURE GetFullName_wBranchName(Idx: SCAL[2]): STRING[];
  VAR
   Result: STRING[][2];
 BEGIN
  L_Str.SplitStr(Result, P_Firm.FP_PersonFullName_wBranchName(P_Firm.OWN_FIRM, Memo.ud_cd()), 83, 2);
  RETURN Result[Idx];
 END {GetFullName_wBranchName};

(*
$P{ Top3:
"", L, "", "U"
Memo.ud_cd(), L, "D.N.y", "U"
GetFullName_wBranchName(0), L, "", "U"
GetFullName_wBranchName(1), L, "", "U"
P_Firm.FP_LeadName(P_Firm.OWN_FIRM, Memo.ud_cd()) + ", " + LeadPhone(), L, "", "U"
"", L, "", "U"
GetOGRNDocument(), L, "", "U"
GetAdr_Reg(P_Firm.OWN_FIRM), L, "", "U"
"", L, "", "U"
L_ctc.GetAdr_Fct(Memo.ud_cd(), P_Firm.OWN_FIRM), L, "", "U"
"", L, "", "U"
L_ctc.GetAdr_Pst(Memo.ud_cd(), P_Firm.OWN_FIRM), L, "", "U"
"", L, "", "U"
FP_HeadFirmName(), L, "", "U"
P_Firm.FP_INN(P_Firm.OWN_FIRM, Memo.ud_cd()), C, "", ""
P_Firm.FP_OGRN(P_Firm.OWN_FIRM, Memo.ud_cd()), C, "", ""
P_MyPlc.GetP_OKTMO(P_Firm.mf_Own, EMPTYOF(MyPlace.MyPlace), Memo.ud_cd()), C, "", ""
P_Firm.FP_OKPO(P_Firm.OWN_FIRM, Memo.ud_cd()), C, "", ""
P_Firm.FP_OKOPF_Name(P_Firm.OWN_FIRM, Memo.ud_cd()), L, "", ""
P_Firm.FP_OKOPF_Code(P_Firm.OWN_FIRM, Memo.ud_cd()), C, "", ""
P_Firm.FP_OKFS_Name(P_Firm.OWN_FIRM, Memo.ud_cd()), L, "", ""
P_Firm.FP_OKFS_Code(P_Firm.OWN_FIRM, Memo.ud_cd()), C, "", ""
P_MyFirm.OKVED_Name(P_Firm.mf_Own, Memo.ud_cd()), L, "", ""
P_MyFirm.OKVED_Code(P_Firm.mf_Own, Memo.ud_cd()), C, "", ""
@
                                                                                    ଠ 18

                                     樮  ##################################
                                                           (ᢠ ࠩ ᨥ)
 ﭨ  ##########
                                            窠
                                         ࣠樨

1.   ࣠樨
#############################################################################################
#############################################################################################
2. ...   ⥫䮭 (䠪) 㪮⥫
#############################################################################################
3. ...   ⥫䮭 (䠪) ⢥⢥   ᪨   ஭஢
#############################################################################################
4.    ॣ樨 (ॣ樨)
#############################################################################################
5. ਤ᪨ 
#############################################################################################
#############################################################################################
6. ᪨ 
#############################################################################################
#############################################################################################
7. ⮢ 
#############################################################################################
#############################################################################################
8.  ࣠
#############################################################################################
9. ᭮  ࣠樨:                                               -----------------
                                                                            |   ஢    |
                                                                            |  祭  |
----------------------------------------------------------------------------|---------------|
|㠫  ⥫騪                               |  |###############|
|---------------------------------------------------------------------|-----|---------------|
|᭮ 㤠⢥ ॣ樮                        | |###############|
|---------------------------------------------------------------------|-----|---------------|
| ⨢-ਠ쭮                          ||###############|
|---------------------------------------------------------------------|-----|---------------|
|  ᨩ᪮ 䨪 ।⨩  ࣠権      | |###############|
|---------------------------------------------------------------------|-----|---------------|
|࣠樮-ࠢ ଠ|#######################################| |###############|
|-----------------------------|---------------------------------------|-----|---------------|
|ଠ ᮡ⢥          |#######################################| |###############|
|-----------------------------|---------------------------------------|-----|---------------|
|᭮             |#######################################||###############|
|-------------------------------------------------------------------------------------------|
|᭮   (஢ 祭)|                                              |
---------------------------------------------------------------------------------------------
}
*)

(*
$P{ Bot3:
_Count(row_Total1, 1), R, "0", "U"
_Count(row_Total1, 2), R, "0", "U"
_Count(row_Total1, 3), R, "0", "U"
_Count(row_Total1, 4), R, "0", "U"
_Count(row_Total1, 9), R, "0", "U"
_Count(row_Total1, 10), R, "0", "U"
_Count(row_Total1, 11), R, "0", "U"
_Count(row_Total1, 6), R, "0", "U"
"", L, "", "U" (*⮡ ન 뫮 *)
"", L, "", "U" (*⮡ ન 뫮 *)
"", L, "", "U" (*⮡ ન 뫮 *)
"", L, "", "U" (*⮡ ન 뫮 *)
"", L, "", "U" (*⮡ ન 뫮 *)
"", L, "", "U" (*⮡ ન 뫮 *)
"", L, "", "U" (*⮡ ન 뫮 *)
"", L, "", "U" (*⮡ ન 뫮 *)
P_Firm.FP_LeadPostName1(P_Firm.OWN_FIRM, Memo.ud_cd()), C, "", "U"
"", L, "", "U" (*⮡ ન 뫮 *)
P_Firm.FP_LeadName(P_Firm.OWN_FIRM, Memo.ud_cd()), C, "", "U"
"", L, "", "U" (*⮡ ન 뫮 *)
"", L, "", "U" (*⮡ ન 뫮 *)
@
(⭠ ஭)

10.   ࠡ (祫.):
ᥣ ࠡ                                                                         ####
         :
        10.1. ࠦ, ॡ뢠                                                ####
               :
              ) ஢  ࠫ                                                    ####
              ) ࠯騪, 笠, ঠ⮢  設, ᮫  ᮢ,
                  ⮬ ᫥ ࠭祭    㦡                         ####
        10.2.  ஭஢ ࠦ, ॡ뢠  ,
                樮 ।ᠭ                                     ####
        10.3.  ஭஢ ࠦ, ॡ뢠  ,
               樮 ।ᠭ                                        ####
        10.4. ࠦ,  ਧ   㦡                              ####
        10.5. ஭஢ ࠦ, ॡ뢠                                  ####
11.   ࣠ ஭஢ (, )                                          ####
12.   ࠧ  ⥩  ᨩ,   ஭ ࠦ,
    ॡ뢠騥   ####################################################################
13.    (ꥪ , )                                      ################
14. 室  ࣠ ࠢ 㤠⢥  (, )                           ####
15. ⥫쭠 ଠ:
        15.1. ᯮ짮  ࠡ  ᪮   ஭஢:
           ) । ᫨⥫쭮 孨 (⢮)                                ####
           ) ᯥ樠쭮 ணࠬ ᯥ祭 (⢮)                         ####
               ##################################################################
        15.2. 㣠 ଠ #############################################################



 ######################################### ############### ##################################



        ..



 "_____"__________________ 20___.

⬥⪠  ⨨   (樨) ࣠樨 ###########################################
#############################################################################################
                                (  ࠩ ᨨ)
}
*)

 PRIVATE PROCEDURE _Count(i: NUMERIC[0]; j: NUMERIC[0]): NUMERIC[0];
 BEGIN
  RETURN Count_[i*MaxCol+j];
 END {_Count};

 PRIVATE PROCEDURE _Cnt(i: NUMERIC[0]; j: NUMERIC[0]): NUMERIC[0];
 BEGIN
  RETURN Cnt_[i*MaxCol2+j];
 END {_Cnt};

 PRIVATE PROCEDURE PrintLine(ColA: STRING[]; Row: NUMERIC[0]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  MAKEPART(R, Separator);
  WHILE L_Str.PoolItem(ColA, i + 1) # "" DO
   MAKEPART(R, Line, L_Str.PoolItem(ColA, i));
   INC(i);
  END; (* WHILE L_Str.PoolItem(ColA, i + 1) # ""...*)
  MAKEPART(R, Line, L_Str.PoolItem(ColA, i),
                    Row,
                    _Count(Row, 01),
                    _Count(Row, 02),
                    _Count(Row, 03),
                    _Count(Row, 04),
                    _Count(Row, 05),
                    _Count(Row, 06),
                    _Count(Row, 07),
                    _Count(Row, 08),
                    _Count(Row, 09),
                    _Count(Row, 10),
                    _Count(Row, 11));
 END {PrintLine};

 PRIVATE PROCEDURE PrintLine2(ColA: STRING[]; Row: NUMERIC[0]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE L_Str.PoolItem(ColA, i + 1) # "" DO
   IF L_Str.PoolItem(ColA, i) # " " THEN
    MAKEPART(R, Line2, L_Str.PoolItem(ColA, i));
   ELSE
    MAKEPART(R, Separator2);
   END;
   INC(i);
  END; (* WHILE L_Str.PoolItem(ColA, i + 1) # ""...*)
  MAKEPART(R, Line2, L_Str.PoolItem(ColA, i),
                     Row,
                     _Cnt(Row, 01),
                     _Cnt(Row, 02),
                     _Cnt(Row, 03),
                     _Cnt(Row, 04),
                     _Cnt(Row, 05),
                     _Cnt(Row, 06),
                     _Cnt(Row, 07));
 END {PrintLine2};

 PRIVATE PROCEDURE _Composit(): SCAL[3];
 BEGIN
  IF    (MltRank.Composit = 4) |
        (MltRank.Composit = 5) |
        (MltRank.Composit = 6) THEN
   RETURN 0;
  ELSIF (MltRank.Composit = 2) |
        (MltRank.Composit = 3) THEN
   RETURN 1;
  ELSIF (MltRank.Composit = 1) THEN
   RETURN 2;
  ELSIF (MltRank.Composit = 0) |
        (MltRank.Composit = 7) |
        (MltRank.Composit = 8) THEN
   L_General.CallUs(0);
  ELSE
   L_General.Error(" ⠢ " + MltRank.Composit);
  END;
 END {_Composit};

 PRIVATE PROCEDURE E_MltCount_Cond(D: DATE; CheckAdr: SCAL[2]): SCAL[2];
  VAR
   P: PROC;
 BEGIN
  P:=PROCREF(E_Utils.MltCount_Cond);
  IF ~!P THEN
   RETURN P(D, CheckAdr);
  ELSE
   RETURN 0;
  END;
 END {E_MltCount_Cond};

 PRIVATE PROCEDURE E_MltCount_CondRow(Row: NUMERIC[0]): SCAL[2];
  VAR
   P: PROC;
 BEGIN
  P:=PROCREF(E_Utils.MltCount_CondRowNew);
  IF ~!P THEN
   RETURN P(Row);
  ELSE
   RETURN 0;
  END;
 END {E_MltCount_CondRow};

 PRIVATE PROCEDURE SetRow(Row: NUMERIC[0]);
  VAR
   Col: NUMERIC[0];
 BEGIN
  IF E_MltCount_CondRow(Row) THEN
   Col:=1;
   WHILE Col <= NumCol DO
    INC(Count_[Row*MaxCol+Col], Count__[Col]);
    INC(Col);
   END; (* WHILE Col <= NumCol...*)
  END;
 END {SetRow};

 PRIVATE PROCEDURE SetRow2(Row: NUMERIC[0]);
  VAR
   Col: NUMERIC[0];
 BEGIN
  Col:=1;
  WHILE Col <= NumCol2 DO
   INC(Cnt_[Row*MaxCol2+Col], Cnt__[Col]);
   INC(Col);
  END; (* WHILE Col <= NumCol2...*)
 END {SetRow2};

 PRIVATE PROCEDURE GetTitle(VAR Title : STRING[][];
                            VAR Title2: STRING[][]);
 BEGIN
  SETEMPTY(Title, Title2);
  Title[row_Officials]        :="㪮⥫";
  Title[row_Personnel_Tot]    :="樠 - ᥣ";
  Title[row_Personnel_A]      :="   ᭮ |" +
                                "᪮ ⥫쭮:|" +
                                "A ᪮ 宧⢮";
  Title[row_Personnel_C]      :="C   ᪮";
  Title[row_Personnel_D]      :="D ࠡ뢠騥 ந⢠";
  Title[row_Personnel_E]      :="E ந⢮  ।|" +
                                "  ࣨ,   ";
  Title[row_Personnel_F]      :="F ந⥫⢮";
  Title[row_Personnel_I]      :="I ࠭ᯮ  ";
  Title[row_Personnel_M]      :="M ࠧ";
  Title[row_Personnel_N]      :="N ࠢ࠭  ।⠢-|" +
                                "   樠 ";
  Title[row_OtherEcAct]       :="稥  ᪮|" +
                                "⥫쭮";
  Title[row_OtherClrc]        :="㣨 㦠騥";
  Title[row_Workers_Tot]      :="稥 - ᥣ" ;
  Title[row_Workers_wClass]   :=" ⮬ ᫥: |" +
                                "騥  ࠧ";
  Title[row_Workers_woClass]  :=" 騥  ࠧ冷";
  Title[row_Workers_AC]       :="ᥫ᪮宧⢥|" +
                                "ந⢠";
  Title[row_Workers_Loco]     :="⨢ ਣ";
  Title[row_Workers_Drv]      :="⥫";
  Title[row_Workers_tractor]  :="ࠪ";
  Title[row_Aviators]         :=" ᫥ 㪮⥫,|"+
                                "ᯥ樠⮢  ࠡ:|"+
                                "⭮-ꥬ ⠢";
  Title[row_Mariners]         :="騩 ⠢";
  Title[row_Total1]           :="|" +
                                "(㬬 ப 1+2+12+13)";
  Title[row_NoReservation]    :=" ஭㥬 ࣠";
  Title[row_Total2]           :="|" +
                                "(㬬 ப 22+23)";
 
  Title2[r2_Officials]      :="㪮⥫";
  Title2[r2_Personnel]      :=" |樠";
  Title2[r2_OtherClrc]      :=" |㣨 㦠騥";
  Title2[r2_Workers_Tot]    :=" |稥 - ᥣ" ;
  Title2[r2_Workers_RoutDrv]:=" | ⮬ ᫥:|-  ⥫";
  Title2[r2_Workers_SubsDrv]:="- ⥫ ᮡ ࠭ᯮ";
  Title2[r2_Workers_SrpsDrv]:="- ⥫-ॣ騪";
  Title2[r2_Workers_Repair] :="-  ६  ⠢";
  Title2[r2_Workers_Other]  :="- ⠫";
  Title2[r2_Total]          :=" |⮣";
 END {GetTitle};

 PRIVATE PROCEDURE E_NeedPrintRepPart(Idx: STRING[]; D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(^("E_Utils.MltCount_NeedPrintRepPart"+Idx)), 1);
 END {E_NeedPrintRepPart};

 PRIVATE PROCEDURE E_MakeAdditionalBot(Idx: STRING[]);
  VAR
   local: PROC;
 BEGIN
  local:=PROCREF(E_Utils.MltCount_MakeAdditionalBot);
  IF ~!local THEN
   local(Idx);
  END;
 END {E_MakeAdditionalBot};

 PRIVATE PROCEDURE PrintRep(ProcN  : STRING[];
                            Title  : STRING[][];
                            Idx    : STRING[];
                            RowAmnt: NUMERIC[0]);
  VAR
   i   : NUMERIC[0];
   Proc: PROC;
 BEGIN
  IF E_NeedPrintRepPart(Idx, Memo.ud_cd()) THEN
   FORMFEED(R);
   InitPrintAttr(R, FontProperty, "/U /B /I",
                    TopMargin,    10,
                    BottomMargin, 10,
                    LeftMargin,   10,
                    RightMargin,  10);

   Proc:=PROCREF(^ProcN);
   PROMPT("");
   MAKEPART(R, ^("Top" + Idx));
   i:=1;
   WHILE i <= RowAmnt DO
    Proc(Title[i], i);
    INC(i)
   END; (* WHILE i < RowAmnt...*)
   MAKEPART(R, ^("Bot" + Idx));
   E_MakeAdditionalBot(Idx);
  END;
 END {PrintRep};

 PRIVATE PROCEDURE E_IsSurpassDriver(): SCAL[2];
  VAR
   local: PROC;
 BEGIN
  local:=PROCREF(E_Utils.MltCount_IsSurpassDriver);
  RETURN ~!local & local();
 END {E_IsSurpassDriver};

 PRIVATE PROCEDURE intMltCt(RepName: STRING[]; curMltDep: LIKE(MltDep.MltDep));
  CONST
   RepName1 = "MltOu";
  VAR
   Title   : STRING[][MaxRow];
   Title2  : STRING[][MaxRow2];
  _Citizen : SCAL[4];
  i,
  j,
  Age,
  BadNum   : NUMERIC[0];
 BEGIN
  SETZERO(Count_, BadNum);
  SETZERO(Cnt_);

  OPENREP(R,  L_General.NameConnection(RepName),  Create, FontProperty, "/U /B /I");
  MAKEPART(R, Top1, RepName1);

  SETSEL(Man, Man);
  FOR_EACH Man DO
   PROMPT(Man.Man);
   SETSEL(Staff, Man, Man.Man);
   FOR_EACH Staff DO
    SETZERO(Count__, Cnt__);
    IF L_Staff.rInState(Memo.ud_cd()) THEN
     CONFORM(StaffLog, Officer);
     CONFORM(Officer, WagePay);
     HISTCONF(Memo.ud_cd(), WagePay, WagePayL);
     IF     Staff.Contract = L_Staff.cnt_Basic THEN
      IF E_MltCount_Cond(Memo.ud_cd(), 1) THEN
       L_ManMlt.GetManMltActualStatus(Man.Man, Memo.ud_cd());
       INC(Count__[01]); (*ᥣ ࠡ ()*)
       IF     ~!L_ManMlt.mmas_Ready & (L_ManMlt.mmas_Ready # 0) &
              ((curMltDep = L_ManMlt.mmas_MltDep) | !curMltDep) THEN
        Age:=L_DatTim.YEAR(Memo.ud_cd())-L_DatTim.YEAR(Man.Birth);
        L_General.Assert(~!L_ManMlt.mmas_MltRank,
                         Man.Man + " "+Man.Name + "|  ᪮ ");
        SEARCH(MltRank, MltRank, , L_ManMlt.mmas_MltRank);
        IF    L_ManMlt.MltRankComposCond(Age, 0(* ਧ뢭*)) THEN
         INC(Count__[02]); (*  - 易 () ᥣ*)
         IF _Composit() = 0 THEN
          INC(Count__[03]);
         ELSE
          INC(Count__[04]);
         END;
         IF _Composit() THEN
          IF (L_ManMlt.mmas_Ready = 1) | (L_ManMlt.mmas_Ready = 2) | (L_ManMlt.mmas_Ready = 3) THEN
           INC(Count__[05]);
          END;
         END;
         IF    L_ManMlt.HasActualManMltEvent(Man.Man, Memo.ud_cd(), L_ManMlt.mme_Reserv) THEN
          INC(Count__[06]); (*஭஢ ᥣ*)
          IF    _Composit() = 0 THEN
           INC(Count__[07]);(*஢  ࠫ*)
          ELSE
           INC(Count__[08]);
          END;
         ELSIF ~L_ManMlt.HasActualManMltEvent(Man.Man, Memo.ud_cd(), L_ManMlt.mme_OrderX) THEN
          INC(Count__[09]); (*஭஢,  騥 樮 ।ᠭ*)
         END;
         IF L_ManMlt.HasActualManMltEvent(Man.Man, Memo.ud_cd(), L_ManMlt.mme_OrderX) THEN
          INC(Count__[10]); (*騥 樮 ।ᠭ*)
         END;
        ELSIF MltRank.Composit = 7(*ਧ뢭*) THEN
         INC(Count__[11]);
        END;
       ELSIF !L_ManMlt.mmas_Ready & (Man.Sex = L_Man.sex_Male) THEN
        CONFORM(Officer, Sort);
        CONFORM(Officer, Post);
        INC(BadNum);
        MAKEPART(R, Line1);
       END;
       CONFORM(Officer, Post, Union);
       j:=1;
       WHILE j <= NumRow DO
        SetRow(j);
        INC(j);
       END;
      END;
      IF E_MltCount_Cond(Memo.ud_cd(), 0) THEN
       INC(Cnt__[01]); (*ᥣ ࠡ ()*)
       _Citizen:=L_Man.Man_Citizen(Man.Man, Memo.ud_cd());
       IF    _Citizen = L_Man.ct_Moscow THEN
        IF ManAdr.Region = 77 THEN
         INC(Cnt__[2]);
        ELSE
         INC(Cnt__[3]);
        END;
       ELSIF _Citizen = L_Man.ct_Russia THEN
        INC(Cnt__[4]);
       ELSIF _Citizen = L_Man.ct_CIS THEN
        INC(Cnt__[5]);
       END;
      END; (* IF E_MltCount_Cond(Memo.ud_cd()) ... *)
     ELSIF E_MltCount_Cond(Memo.ud_cd(), 0) THEN
      IF (Staff.Contract = L_Staff.cnt_ExternalCombine) THEN
       INC(Cnt__[6]);
      ELSIF (Staff.Contract = L_Staff.cnt_InternalCombine) THEN
       INC(Cnt__[7]);
      END;
     END;

     IF    E_MltCount_CondRow(row_Officials) THEN
      SetRow2(r2_Officials);
      SetRow2(r2_Total);
     ELSIF E_MltCount_CondRow(row_Personnel_Tot) THEN
      SetRow2(r2_Personnel);
      SetRow2(r2_Total);
     ELSIF E_MltCount_CondRow(row_OtherClrc) THEN
      SetRow2(r2_OtherClrc);
      SetRow2(r2_Total);
     ELSIF E_MltCount_CondRow(row_Workers_Tot) |
           E_MltCount_CondRow(row_NoReservation) THEN
      SetRow2(r2_Workers_Tot);
      SetRow2(r2_Total);
      IF    L_Env.IsRouteDriver() THEN
       SetRow2(r2_Workers_RoutDrv);
      ELSIF L_Env.IsSubsidiaryDriver() THEN
       SetRow2(r2_Workers_SubsDrv);
      ELSIF E_IsSurpassDriver() THEN
       SetRow2(r2_Workers_SrpsDrv);
      ELSIF ~!PROCREF(L_Env.IsRepairman) & L_Env.IsRepairman() THEN
       SetRow2(r2_Workers_Repair);
      ELSE
       SetRow2(r2_Workers_Other);
      END;
     END;
    END; (* IF L_Staff.InState(Memo.ud_cd()) ... *)
   END; (* FOR_EACH Staff *)
  END; (* FOR_EACH Man *)

  MAKEPART(R, Bot1, BadNum);

  GetTitle(Title, Title2);

  PrintRep("PrintLine",  Title,  "",  NumRow);
  PrintRep("PrintLine2", Title2, "2", NumRow2);
 
  PROMPT("ࠫ쭠 ஢ઠ");
  i:=1;
  WHILE i < MaxCol DO
   L_General.Assert(_Count(row_Officials,     i) + 
                    _Count(row_Personnel_Tot, i) + 
                    _Count(row_OtherClrc,     i) +
                    _Count(row_Workers_Tot,   i) = _Count(row_Total1, i),
                    " 室 " + Title[row_Total1] + "  ⮫ " + L_Str.IntStr(i));
   L_General.Assert(_Count(row_Total1, i) + _Count(row_NoReservation, i) = _Count(row_Total2, i),
                    " 室 " + Title[row_Total2] + "  ⮫ " + L_Str.IntStr(i));
   INC(i);
  END;

  FORMFEED(R);
  InitPrintAttr(R, PaperForm, A5, Orientation, Portrait, FontProperty, "/U");

  MAKEPART(R, Top3);
  FORMFEED(R);
  MAKEPART(R, Bot3);
  L_General.SurveyLastReport();
 END {intMltCt};

 PUBLIC PROCEDURE MltCt();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  intMltCt("MltCt", EMPTYOF(MltDep.MltDep));
 END {MltCt};

 PUBLIC PROCEDURE MltRn();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(MltRank), " ⠭ ᪮ ");
  SETSEL(ManMlt, MltRank, MltRank.MltRank);
  MakeRep("MltRn", PROCREF(AlltimeCond), "ᯮ짮  " + MltRank.MltRank + " " + MltRank.Name);
  L_General.SurveyLastReport();
 END {MltRn};

 PUBLIC PROCEDURE MltRD();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(MltRank), " ⠭ ᪮ ");
  SETSEL(ManMlt, MltRank, MltRank.MltRank);
  MakeRep("MltRD", PROCREF(CurDateCond), "ᯮ짮  " + MltRank.MltRank + " " + MltRank.Name + "  " + L_DatTim.DateStr(Memo.ud_cd()));
  L_General.SurveyLastReport();
 END {MltRD};

 PUBLIC PROCEDURE MltDp();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(MltDep), " ⠭ ");
  SETSEL(ManMlt, MltDep, MltDep.MltDep);
  MakeRep("MltDp", PROCREF(AlltimeCond), ", ਯᠭ   " + MltDep.MltDep +" "+ MltDep.Name);
  L_General.SurveyLastReport();
 END {MltDp};

 PUBLIC PROCEDURE MltDD();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(MltDep), " ⠭ ");
  SETSEL(ManMlt, MltDep, MltDep.MltDep);
  MakeRep("MltDD", PROCREF(CurDateCond), ", ਯᠭ   " + MltDep.MltDep +" "+ MltDep.Name + "  " + L_DatTim.DateStr(Memo.ud_cd()));
  L_General.SurveyLastReport();
 END {MltDD};

 PUBLIC PROCEDURE MlDCt();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(MltDep), " ⠭ ");
  intMltCt("MlDCt", MltDep.MltDep)
 END {MlDCt};

END.
