(*
%Copyright   (c) Polak IT
%Author      15.01.2007 14:27:31 POLAK\Gina
%Purpose
%Type        report
%Specific    LOC
%Modified    25.06.2014 22:16:39 POLAK\Gina
%Environment
*)

 MODULE MltList [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_Man, L_Staff, L_General, L_OwnData, Str, L_Str, L_DatTim,
        L_ManMlt, L_AFM, E_Prop, P_Firm, L_MSO, L_Russia, L_Env;

 PRIVATE CONST
  rk_Taked   = 0;
  rk_Leaved  = 1;
  rk_InState = 2;

  ActvPool  = " 砫쭮|"+
              "砫쭮 饥|"+
              "᭮ 饥|"+
              "। 饥|"+
              "砫쭮 ᨮ쭮|"+
              "। ᨮ쭮|"+
              "襥 ᨮ쭮|"+
              "᫥㧮᪮ ᨮ쭮";

  TypeRegPool = "騩|ᯥ樠";

 PRIVATE VAR
  OnDate : DATE;
  RepKind: SCAL[3];

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "६ 䠩", "");

  CreateFIELD(Tmp, Name, LIKE(Man.Name), "", "", "", "", "");
  CreateFIELD(Tmp, TSN, LIKE(Staff.TSN), "", "", "", ".", "");
  CreateFIELD(Tmp, BegDate, DATE, "", "", "", " ਥ", "");
  CreateFIELD(Tmp, Post, LIKE(Post.Post), "", "", "", "", "");

  CreateFIELD(Tmp, MltRank, LIKE(MltRank.MltRank), "", "", "", "", "");
  CreateFIELD(Tmp, MltSort, LIKE(ManMlt.Sort), "", "", "", "⥣", "");
  CreateFIELD(Tmp, Spec, LIKE(ManMlt.Spec), "", "", "", "", "");
  CreateFIELD(Tmp, SpecC, LIKE(ManMlt.SpecC), "", "", "", "", "");
  CreateFIELD(Tmp, Ready, LIKE(ManMlt.Ready), "", "", "", "", "");
  CreateFIELD(Tmp, TypeReg, SCAL[2], "", "", "", " ", "");

  CreateINDEXandLINK(Tmp, Post, PLURAL, Post, Post, USER, "", "", Post);
  CreateINDEXandLINK(Tmp, TSN, PLURAL, Staff, TSN, USER,"", "", TSN);
  CreateINDEXandLINK(Tmp, MltRank, PLURAL, MltRank, MltRank, USER,"", "", MltRank);

  CreateINDEX(Tmp, Name, PLURAL, "", "", Name);

  SetVersionOfFILE(Tmp, 0);
  L_AFM.CreateTemp("Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE GetManActv(): STRING[];
  VAR
   _ManActv: STRING[];
 BEGIN
  SETEMPTY(_ManActv);
  IF SELECT(ManActv, Man, Man.Man, L_Man.actvk_Education) THEN
   LAST(ManActv);
   IF ~!ManActv.OKPDTR THEN
    CONFORM(ManActv, OKPDTR);
    _ManActv:=OKPDTR.Name;
   ELSE
    _ManActv:=ManActv.Result;
   END;
   _ManActv:=_ManActv + " " + L_Str.PoolItem(ActvPool, ManActv.EdType) + " " +
             ManActv.FndName + " " + L_DatTim.DateStr(ManActv.EndDate);
  END;
  RETURN _ManActv;
 END {GetManActv};

 PRIVATE PROCEDURE IsGoodMan(Age: NUMERIC[2]): SCAL[2];
 BEGIN
  RETURN (L_Man.Man_Citizen(Man.Man, OnDate) <= L_Man.ct_Russia) &
         L_ManMlt.MltRankComposCond(Age, 1) & (L_ManMlt.mmas_DocType # L_ManMlt.mdt_01);
 END {IsGoodMan};

 PRIVATE PROCEDURE IsGoodTSN(): SCAL[2];
  VAR
   D: DATE;
 BEGIN
  IF (Staff.Contract = L_Staff.cnt_OutStaff) | ~L_Staff.IsMainForTax(OnDate) THEN
   RETURN 0;
  END;
  IF    RepKind = rk_Taked THEN
   D:=L_Man.GetTakeOnDate(OnDate);
   RETURN ~!D & L_DatTim.IsActive_Inc(D, Memo.ud_fr(), Memo.ud_ut());
  ELSIF RepKind = rk_Leaved THEN
   D:=L_Man.GetRealEndDate(OnDate);
   RETURN ~!D & L_DatTim.IsActive_Inc(D, Memo.ud_fr(), Memo.ud_ut());
  ELSIF RepKind = rk_InState THEN
   RETURN L_Staff.rInState(OnDate);
  END;
 END {IsGoodTSN};

 PRIVATE PROCEDURE MakeIndex();
 BEGIN
  SELECT(Staff, MyFirm, , P_Firm.curMyFirm);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.Man);
   IF IsGoodTSN() THEN
    CONFORM(Staff, Man);
    L_ManMlt.GetManMltActualStatus(Man.Man, OnDate);
    IF SEARCH(MltRank, MltRank, L_ManMlt.mmas_MltRank) &
       IsGoodMan(L_DatTim.YearsInIntvl(Man.Birth, OnDate)) &
       ((~!L_ManMlt.mmas_From) & (L_ManMlt.mmas_From <= Memo.ud_cd()) &
        ((~!L_ManMlt.mmas_UpTo) & (L_ManMlt.mmas_UpTo >= Memo.ud_cd())) | !L_ManMlt.mmas_UpTo) THEN
     L_Staff.PosToStaffLog(Staff.TSN, OnDate, 1);
     CONFORM(StaffLog, Officer);
     Tmp.Name   :=Man.Name;
     Tmp.TSN    :=Staff.TSN;
     Tmp.BegDate:=L_Man.GetTakeOnDate(OnDate);
     Tmp.Post   :=Officer.Post;
     Tmp.MltRank:=L_ManMlt.mmas_MltRank;
     Tmp.MltSort:=L_ManMlt.mmas_Sort;
     Tmp.Spec   :=L_ManMlt.mmas_Spec;
     Tmp.SpecC  :=L_ManMlt.mmas_SpecC;
     Tmp.Ready  :=L_ManMlt.mmas_Ready;
     Tmp.TypeReg:=L_ManMlt.HasActualManMltEvent(Man.Man, OnDate, L_ManMlt.mme_Reserv);
     INSERT(Tmp);
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {MakeIndex};

 PUBLIC PROCEDURE MakeDOC();
  CONST
   RepName = "MltLs";
  VAR
   Amount  : NUMERIC[0];
   root,
   Family,
   rk_Pool : STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  OnDate :=Memo.ud_cd();
  RepKind:=rk_InState;
  rk_Pool:="ਭ  ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut()) +
           "|  ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut()) +
           "|   " + L_DatTim.DateStr(Memo.ud_cd());
  STDFORM("|%AI||%< {}믮 >DB  %< {}⬥ >X", "᮪ ࠦ, ॡ뢠  ", , -1, rk_Pool, RepKind);
  IF RepKind # rk_InState THEN
   OnDate:=Memo.ud_ut();
  END;
  P_Firm.curMyFirm:=P_Firm.DefineMyFirm();
  Create_Tmp();
  MakeIndex();
  L_MSO.wordInitDocument(OnDate);

  L_MSO.wordSetVar("TheDoc.ReportType", L_Str.PoolItem(rk_Pool, RepKind));

  SELECT(Tmp, Name);
  Amount:=0;
  WHILE OCCURE(Tmp) DO
   PROMPT("⮢ " + Tmp.TSN);
   CONFORM(Tmp, Staff);
   root:="Staff" + L_MSO.IndexStr(Amount) + ".";
   L_MSO.wordSetVar(root + "Idx",     L_Str.IntStr(Amount+1));
   L_MSO.wordSetDateVar(root + "TakeOn",  Tmp.BegDate);
   L_MSO.wordSetDateVar(root + "RealEnd", L_Man.GetRealEndDate(OnDate));
   CONFORM(Staff, Man);
   CONFORM(Tmp, Post);
   L_MSO.wordSetVar(root + "Post.Name", Post.Name);
   L_MSO.wordSetVarsByFile_wPrefix("Man", root);
   root:=root + "Man.";
   L_Man.wordSetAddresses(root, Man.Man, OnDate);
   IF ~!Tmp.MltRank THEN
    CONFORM(Tmp, MltRank);
    L_MSO.wordSetVar(root + "MltRank.Name", MltRank.Name);
    L_MSO.wordSetVar(root + "MltRank.Composit", L_ManMlt.GetRealComposit_asStr(MltRank.Composit, MltRank.RankType));
   ELSE
    L_MSO.wordSetVar(root + "MltRank.Name", "");
    L_MSO.wordSetVar(root + "MltRank.Composit", "");
   END;

   Family:="";
   CONFORM(Man, ManFml);
   WHILE OCCURE(ManFml) DO
    L_MSO._AddToStr(Family, L_Man.GetFlmMember_asStr() + " - " +
                            ManFml.Name + " " + FLDTOSTR(ManFml.Birth, "y.."));
    NEXT(ManFml);
   END; (* WHILE OCCURE(ManFml) ... *)
   L_MSO.wordSetVar(root + "Family",     Family);
   L_MSO.wordSetVar(root + "Activity",   GetManActv());
   L_MSO.wordSetVar(root + "MltReady",   L_Str.PoolItem(L_ManMlt.mm_ReadyPool_Short, Tmp.Ready));
   IF ~!Tmp.MltSort THEN
    L_MSO.wordSetVar(root + "MltSort",    L_Str.PoolItem(L_ManMlt.mms_Pool, Tmp.MltSort));
   ELSE
    L_MSO.wordSetVar(root + "MltSort",    "");
   END;
   L_MSO.wordSetVar(root + "MltSpec",    Tmp.Spec);
   L_MSO.wordSetVar(root + "MltSpecC",   Tmp.SpecC);
   L_MSO.wordSetVar(root + "MltTypeReg", L_Str.PoolItem(TypeRegPool, Tmp.TypeReg));
   INC(Amount);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  IF Amount = 0 THEN
   root:="Staff" + L_MSO.IndexStr(Amount) + ".";
   L_MSO.wordSetVar(root + "Idx",         "");
   L_MSO.wordSetDateVar(root + "TakeOn",  EMPTYOF(DATE));
   L_MSO.wordSetDateVar(root + "RealEnd", EMPTYOF(DATE));
   L_MSO.wordSetVar(root + "Post.Name", "");
   L_MSO.wordSetVarsByFile_wPrefixE("Man", root, 1);
   root:=root + "Man.";
   L_Russia.Set_glb_AdrVar_ToEmpty();
   L_Russia.wordSetAddr_byPart(root+"BthAdr");
   L_Russia.wordSetAddr_byPart(root+"RgAdr");
   L_Russia.wordSetAddr_byPart(root+"DwAdr");
   L_MSO.wordSetVar(root + "MltRank.Name", "");
   L_MSO.wordSetVar(root + "MltRank.Composit", "");
   L_MSO.wordSetVar(root + "Family",     "");
   L_MSO.wordSetVar(root + "Activity",   "");
   L_MSO.wordSetVar(root + "MltReady",   "");
   L_MSO.wordSetVar(root + "MltSort",    "");
   L_MSO.wordSetVar(root + "MltSpec",    "");
   L_MSO.wordSetVar(root + "MltSpecC",   "");
   L_MSO.wordSetVar(root + "MltTypeReg", "");
  END;
  P_Firm.SetFirmData("Own", P_Firm.fomf(P_Firm.curMyFirm), OnDate, "", "");
  L_MSO.PutInTables:=L_MSO.Put_Values;
  L_MSO.SetWordTable("ManList", Amount);
  L_MSO.MakeWordDocument(RepName, 1, L_MSO.PrpMode_ToDoc, "");
 END {MakeDOC};

 PRIVATE CONST
  MAXHIGH = 80;

  MltSpecLen  = 12;
  MltRankNLen = 20;
  ManAdrLen   = 32;

 PRIVATE VAR
  ManN,
  MltSpec,
  MltRankN,
  ManBirth,
  ManAdrS: STRING[][MAXHIGH];
  j      : NUMERIC[0];
  D      : DATE;

(*$P { Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
MltDep.MltDep + " " + Str.Condense(MltDep.RegName[0]+" "+MltDep.RegName[1]), C, ""
"᮪ 易, ਯᠭ  "+L_DatTim.DateStr(D), C, ""
@
############################################################################## ########## #####
=#####=========================================================================================
|#############################################################################################|
|#############################################################################################|
|---------------------------------------------------------------------------------------------|
|,   |      |                           |         |               |
|⢮      |஦  |                                |            |⠢               |
|--------------|----------|--------------------------------|------------|---------------------|
|      1       |    2     |                3               |     4      |          5          |
|--------------|----------|--------------------------------|------------|---------------------|
}

$P { Line:
ManN[j], L, ""
ManBirth[j], C, ""
ManAdrS[j], L, ""
MltSpec[j], L, ""
MltRankN[j], L, ""
@
|##############|##########|################################|############|#####################|
}

$P { Bot:
@
=(c) Polak=====================================================================================
}
*)

 PRIVATE VAR
  MaxHigh: NUMERIC[0];

 PRIVATE PROCEDURE Split(VAR R: STRING[][]; S: STRING[]; Len: NUMERIC[0]);
  VAR
   i: NUMERIC[0];
 BEGIN
  Str.Format(R, S, Len, LEFT);
  i:=0;
  WHILE ~!R[i] & (i # HIGH(R)) DO
   INC(i);
  END;
  IF MaxHigh < i THEN
   MaxHigh:=i;
  END;
  WHILE i # HIGH(R) DO
   R[i]:=" ";
   INC(i);
  END;
 END {Split};

 PUBLIC PROCEDURE MltLs();
  CONST
   RepName = "MltLs";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  D:=Memo.ud_cd();
  L_General.Assert(ACCESS(MltDep), " ⠭ ⥪騩 ");
 
  L_AFM.MakeIndex("_MNam", "_Name: LIKE(Man.Name);"+
                           "_Man : LIKE(Man.Man)");
 
  SELECT(ManMlt, MltDep, , MltDep.MltDep);
  WHILE OCCURE(ManMlt) DO
   IF L_DatTim.IsActive(D, ManMlt.From, ManMlt.UpTo) THEN
    PROMPT(": " + ManMlt.Man);
    SAVE(ManMlt);
    CONFORM(ManMlt, Man);
    L_ManMlt.GetManMltActualStatus(Man.Man, D);
    IF L_ManMlt.mmas_Ready &
       ~!L_ManMlt.mmas_MltRank &
       SEARCH(MltRank, MltRank, L_ManMlt.mmas_MltRank) &
       L_ManMlt.MltRankComposCond(L_DatTim.YEAR(D)-L_DatTim.YEAR(Man.Birth), 1(* ਧ뢭*)) THEN
     _MNam._Name:=Man.Name;
     _MNam._Man :=Man.Man;
     INSERT(_MNam);
    END;
    RESTORE(ManMlt);
   END;
   NEXT(ManMlt);
  END; (* WHILE OCCURE(ManMlt) ... *)
 
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
 
  SELECT(_MNam, _MNam);
  WHILE OCCURE(_MNam) DO
   SEARCH(Man, Man, , _MNam._Man);
   PROMPT(Man.Man);
   SELECT(Staff, Man, , Man.Man, L_Staff.cnt_Basic);
   IF SRCINSEL(Staff, LE, D) & L_Env.RealTSN(Staff.TSN) & L_Staff.rInState(D) THEN
 
    L_Man.StrongAccessManAdr(Man.Man, D, L_Russia.at_RgMA);
    L_ManMlt.GetManMltActualStatus(Man.Man, D);
 
    MaxHigh:=3; (*,    ࠧ ப*)
    SETEMPTY(ManN, MltSpec, MltRankN, ManAdrS, ManBirth);
    L_Man.curMan_SplitName(ManN[0], ManN[1], ManN[2]);
 
    ManBirth[0]:=FLDTOSTR(Man.Birth, "D.N.y");
    SEARCH(MltRank, MltRank, , L_ManMlt.mmas_MltRank);
    Split(MltSpec, L_ManMlt.mmas_Spec + " " + L_ManMlt.mmas_SpecC, MltSpecLen);
    Split(MltRankN, MltRank.Name + " " + L_ManMlt.GetRealComposit_asStr(MltRank.Composit, MltRank.RankType), MltRankNLen);
    Split(ManAdrS,  L_Man.GetPostAdr_asStr(0),  ManAdrLen);
 
    j:=0;
    WHILE j < MaxHigh DO
     IF j = 0 THEN
      MAKEPART(R, Line, L_Str.PoolItem(L_ManMlt.mm_ReadyPool_Short, L_ManMlt.mmas_Ready));
     ELSE
      MAKEPART(R, Line);
     END;
     INC(j);
    END;
   END;
   NEXT(_MNam);
  END; (* WHILE OCCURE(_MNam) ... *)
  MAKEPART(R, Bot);
  L_General.SurveyLastReport();
 END {MltLs};

END.
