(*
%Copyright   (c) Polak IT
%Author      20.05.2008 18:52:10 POLAK\kns
%Purpose     ᯨ᮪   ⮬   
%Type        report
%Specific    LOC
%Modified    10.04.2012 12:22:05 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, L_General, L_OwnData, L_AcCut, L_XObj, L_DatTim, L_PDoc, L_Staff, L_PRoll, L_AFM, P_Firm;

 VAR
  CurDate: DATE;
  _TSN,
  _Name   : STRING[];
  _DepSum : NUMERIC[2];
  _EndDate: DATE;
  _Old    : SCAL[2];

(*
$P{ Top:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
CurDate+1, L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                         ⭨  ஢ ࠡ⭮ ⮩  ##########                         |
|------------------------------------------------------------------------------------------------------------|
|                                            |          |          |      |       ⥦ 㬥        |
|⭨                                    |     㬬|    |3 |----------------------------------|
|                                            |          |          |諮|       㬥    |     㬬|
}
*)

 PRIVATE PROCEDURE EndDate(): STRING[];
 BEGIN
  IF !_EndDate THEN
   RETURN "";
  ELSE
   RETURN L_DatTim.DateStr(_EndDate);
  END;
 END {EndDate};

(*
$P{ Dlm:
@
|--------------------------------------------|----------|----------|------|-----------------------|----------|
}
*)

(*
$P{ Line:
_TSN, L, ""
_Name, L, ""
_DepSum, R, "2-"
EndDate(), L, ""
_Old, L, "-|"
?, L, ""
?, R, ""
@
|##### ######################################|##########|##########|  #   |#######################|##########|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE MakeLine(FullSumm: SCAL[2]; PDocStr: STRING[]; Sum: NUMERIC[2]);
 BEGIN
  IF FullSumm THEN
   MAKEPART(R, Line, PDocStr, FLDTOSTR(Sum, "2-"));
  ELSE
   MAKEPART(R, Line, PDocStr, "?");   (*뢠  "?"  㬬 (, ᥣ ),    ᠫ줮  筮*)
  END;
  SETEMPTY(_TSN, _Name, _DepSum, _EndDate, _Old);
 END {MakeLine};

 PRIVATE PROCEDURE MnDep();
  CONST
   RepName = "MnDep";
  VAR
   _AcCut  : LIKE(XCalc.AcCut);
   _XObject: LIKE(XObject.XObject);
   _Saldo  : L_XObj.tSum;
   oPrompt : PROMPTLINE;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  TABLE.Get("XCalc"  ).AccessDataMode:=AccessDataMode_RIDGE;
  TABLE.Get("XApport").AccessDataMode:=AccessDataMode_RIDGE;
  TABLE.Get("XODone" ).AccessDataMode:=AccessDataMode_RIDGE;

  oPrompt:=PROMPTLINE.Create(RepName);
  CurDate:=Memo.ud_me();
  _AcCut:=L_AcCut.erkn_Get(CurDate, L_AcCut.erkn_SalaryDeposit);
  OPENREP(R, L_General.NameConnection(RepName), Create);

  L_AFM.MakeMultipleIndex("_Stf", "MyFirm : LIKE(Staff.MyFirm);"+
                                  "TSN    : LIKE(Staff.TSN);"+
                                  "XObject: LIKE(XObject.XObject);"+
                                  "Sum    : NUMERIC[2]",
                          "MyFirm: MyFirm, TSN, XObject");

  L_AFM.MakeIndex("tmpStaff",  "BegDate: DATE; TSN: LIKE(Staff.TSN)");

  SELECT(XCalc, AcCut, , _AcCut);
  WHILE OCCURE(XCalc) DO
   PROMPT(": "+XCalc.XObject);
   _XObject:=XCalc.XObject;
   NARROWSEL(XCalc, XObject);
   IF SRCINSEL(XCalc, LE, CurDate) THEN
    CONFORM(XCalc, XObject);
    IF XObject.Origin = L_XObj.o_Man THEN
     L_XObj.AccessOrigin();
     L_Staff.StandOnMainContract(mfMan.Man, mfMan.MyFirm, CurDate);
     L_PRoll.StaffCountUp(Staff.TSN, L_DatTim.Per(CurDate));
     _Saldo:=-L_XObj.mo_GetOutRSaldo(_AcCut, L_DatTim.Per(CurDate));
     IF _Saldo > 0 THEN
      ADD(_Stf, MyFirm, , Staff.MyFirm, Staff.TSN, XObject.XObject,
                          _Stf.Sum, _Saldo);
     END;
    END;
   END;
   SELECT(XCalc, AcCut, , _AcCut);
   SRCINSEL(XCalc, GT, , _XObject);
  END; (* WHILE OCCURE(XCalc) ... *)

  IF SELECT(_Stf, MyFirm) THEN
   WHILE OCCURE(_Stf) DO
    MAKEPART(R, Top, P_Firm.MyFirmName(_Stf.MyFirm, SYSDATE()), RepName);
    NARROWSEL(_Stf, MyFirm);
    WHILE OCCURE(_Stf) DO
     L_General.CallUs(SEARCH(Staff, TSN, _Stf.TSN));
     _Saldo:=_Stf.Sum;
     MAKEPART(R, Dlm);
     CONFORM(Staff, Man);
     _TSN    :=Staff.TSN;
     _Name   :=Man.Name;
     _DepSum :=_Saldo;
     _EndDate:=Staff.EndDate;
     _Old    :=(L_DatTim.IncYear(CurDate, -3) > Staff.EndDate);
 
     SELECT(tmpStaff, tmpStaff);
     REMSEL(tmpStaff);
     SELECT(Staff, MyFirm, , _Stf.MyFirm, Man.Man);
     WHILE OCCURE(Staff) DO
      tmpStaff.BegDate:=Staff.BegDate;
      tmpStaff.TSN    :=Staff.TSN;
      INSERT(tmpStaff);
      NEXT(Staff);
     END; (* WHILE OCCURE(Staff) ... *)

     SELECT(tmpStaff, tmpStaff);
     LAST(tmpStaff);
     WHILE OCCURE(tmpStaff) DO
      SELECT(PDocList, TSN, , tmpStaff.TSN);
      SRCINSEL(PDocList, LE, , CurDate);
      WHILE OCCURE(PDocList) & (_Saldo > 0) DO
       CONFORM(PDocList, PDoc);
       IF (PDoc.Status # L_PDoc.st_Canceled) & PDoc.Done &
          (PDocList.State = L_PDoc.pdl_st_Deposited) THEN
        MakeLine(_Saldo >= PDocList.Sum, L_DatTim.DateStr(PDocList.PDocDate)+" "+L_PDoc.PDocStr(PDocList.PDocKind, PDocList.PDoc),
                                         PDocList.Sum);
        DEC(_Saldo, PDocList.Sum);
       END;
       PREV(PDocList);
      END; (* WHILE OCCURE(PDocList) ... *)
      PREV(tmpStaff);
     END; (* WHILE OCCURE(Staff) ... *)
 
     IF (_Saldo > 0) THEN
      MakeLine(1, "砫쭮 ᠫ줮", _Saldo);
     END;
 
     NEXT(_Stf);
    END; (* WHILE OCCURE(_Stf) ... *)
    MAKEPART(R, Bot);
    NEXTINEXTENDEDSEL(_Stf, MyFirm);
   END; (* WHILE OCCURE(_Stf) ... *)
  ELSE
   MAKEPART(R, Top, P_Firm.MyFirmName(P_Firm.mf_Own, SYSDATE()), RepName);
   MAKEPART(R, Bot);
  END;
  CLOSEREP(R);
 END {MnDep};

END.