(*
%Copyright   (c) Polak Computer System
%Author      19.04.2001 20:40:07 BOR
%Purpose     ॢ      㣮
%Type        report
%Specific    SYS
%Modified    23.10.2012 18:36:52 POLAK\Bor
%Environment
*)

 MODULE ModKATyp [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_OwnData, L_MathR, L_AFM;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################################# ########## #####
=#####========================================================================================
|          ꥪ ᭮ ।, ॢ    ꥪ⮢  㣮           |
|                             ਮ  ##########  ##########                            |
|--------------------------------------------------------------------------------------------|
|N |ꥪ                   |           室            |           室            |
|    |                           |-----------------------------|-----------------------------|
|    |                           |. ⮨|         |. ⮨|         |
}
*)

(*
$P{ DeprTop:
DeprecT.DeprecT, L, ""
DeprecT.Name, L, ""
@
|============================================================================================|
|  ## ################################                                                  |
|--------------------------------------------------------------------------------------------|
}
*)

(*
$P{ Line:
?, R, "0"
Math.Math, L, ""
Math.Name, L, ""
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|####|##### #####################|##############|##############|##############|##############|
}
*)

(*
$P{ DeprBot:
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|--------------------------------|--------------|--------------|--------------|--------------|
|⮣                     |##############|##############|##############|##############|
}
*)

(*
$P{ Bot:
?, R, "2-"
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|================================|==============|==============|==============|==============|
|⮣  ।            |##############|##############|##############|##############|
=(c) Polak====================================================================================
}
*)


 PRIVATE PROCEDURE Create_DepL();
 BEGIN
  CREATE_TABLE(_DepL);

  CREATE_FIELD(_DepL, DeprecT, LIKE(DeprecT.DeprecT), , , , " ");
  CREATE_FIELD(_DepL, Math,    LIKE(Math.Math));
  CREATE_FIELD(_DepL, Date,    DATE);
  CREATE_FIELD(_DepL, Direct,  SCAL[2], , , , , "0-室, 1-室");

  CREATE_INDEX_AND_LINK(_DepL, DeprecT, PLURAL, DeprecT, DeprecT, USER, , , DeprecT, Math, Date);
  CREATE_INDEX_AND_LINK(_DepL, Math,    PLURAL, Math,    Math,    USER, , , Math);

  SET_VERSION_OF_TABLE(_DepL, 0);
 END {Create_DepL};

 PRIVATE PROCEDURE MathKAGL2KAGLog();
 BEGIN
  CONFORM(MathKAGL, KAGroup);
  HISTCONF(MathKAGL.Date, KAGroup, KAGLog);
 END {MathKAGL2KAGLog};

 PUBLIC PROCEDURE MKATp();
  CONST
   RepName    = "MKATp";
   dir_Credit = 0;
   dir_Debit  = 1;
  VAR
   _PrevDeprecT: LIKE(DeprecT.DeprecT);
   IncBalCost,
   DecBalCost,
   IncWear,
   DecWear,
   TotIncBalCost,
   TotDecBalCost,
   TotIncWear,
   TotDecWear,
   BalCost,
   Wear   : NUMERIC[2];
   i      : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(RepName);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
 
  Create_DepL(); L_AFM.CreateTemp("_DepL");
 
  SELECT(Math, LeafMK, , 1, L_MathR.mathk_KeyAs);
  WHILE OCCURE(Math) DO
   PROMPT(" "+Math.Math);
 
   IF SELECT(MathKAGL, Math, Math.Math) THEN
    IF ~SRCINSEL(MathKAGL, LT, Memo.ud_fr()) THEN
     FIRST(MathKAGL);
    END;
 
    CONFORM(MathKAGL, KAGroup);
    HISTCONF(L_DatTim.MaxDATE(MathKAGL.Date, Memo.ud_fr()-1), KAGroup, KAGLog);
    _PrevDeprecT:=KAGLog.DeprecT;
 
    WHILE OCCURE(MathKAGL) & (MathKAGL.Date<=Memo.ud_ut()) DO
     CONFORM(MathKAGL, KAGroup);
     HISTCONF(L_DatTim.MaxDATE(MathKAGL.Date, Memo.ud_fr()), KAGroup, KAGLog);
     WHILE OCCURE(KAGLog) & (KAGLog.Date<=L_DatTim.MaxDATE(MathKAGL.DateE, Memo.ud_ut())) DO
      IF _PrevDeprecT # KAGLog.DeprecT THEN
       DEFAULT(_DepL);
       _DepL.DeprecT:=_PrevDeprecT;
       _DepL.Math:=Math.Math;
       _DepL.Date:=L_DatTim.MaxDATE(MathKAGL.Date, KAGLog.Date);
       _DepL.Direct:=dir_Debit;
       INSERT(_DepL);
       DEFAULT(_DepL);
       _DepL.DeprecT:=KAGLog.DeprecT;
       _DepL.Math:=Math.Math;
       _DepL.Date:=L_DatTim.MaxDATE(MathKAGL.Date, KAGLog.Date);
       _DepL.Direct:=dir_Credit;
       INSERT(_DepL);
       _PrevDeprecT:=KAGLog.DeprecT;
      END;
      NEXT(KAGLog);
     END;
     NEXT(MathKAGL);
    END; (* WHILE OCCURE(MathKAGL) ... *)
   END;
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)
 
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
 
  SETZERO(TotIncBalCost, TotIncWear, TotDecBalCost, TotDecWear);
 
  SELECT(_DepL, DeprecT);
  WHILE OCCURE(_DepL) DO
   CONFORM(_DepL, DeprecT);
   MAKEPART(R, DeprTop);
   SETZERO(i, IncBalCost, IncWear, DecBalCost, DecWear);
   NARROWSEL(_DepL, DeprecT);
   WHILE OCCURE(_DepL) DO
    INC(i);
    CONFORM(_DepL, Math);
    PROMPT(DeprecT.DeprecT + " " + Math.Math);
    L_MathR.CountUpMath(Math.Math, Memo.ud_ut());
    BalCost:=L_MathR.GetKeyAssBalCost(L_DatTim.Per(_DepL.Date), L_MathR.KA_All);
    Wear   :=L_MathR.GetKeyAssWear   (L_DatTim.Per(_DepL.Date), L_MathR.KA_BalDepr);
    IF _DepL.Direct = dir_Credit THEN
     MAKEPART(R, Line, i, BalCost, Wear);
     INC(IncBalCost, BalCost);
     INC(IncWear, Wear);
    ELSE
     MAKEPART(R, Line, i, , , BalCost, Wear);
     INC(DecBalCost, BalCost);
     INC(DecWear, Wear);
    END;
    NEXT(_DepL);
   END; (* WHILE OCCURE(_DepL) ... *)
   MAKEPART(R, DeprBot, IncBalCost, IncWear, DecBalCost, DecWear);
   INC(TotIncBalCost, IncBalCost);
   INC(TotIncWear,    IncWear);
   INC(TotDecBalCost, DecBalCost);
   INC(TotDecWear,    DecWear);
   NEXTINEXTENDEDSEL(_DepL, DeprecT);
  END; (* WHILE OCCURE(_DepL) ... *)
 
  MAKEPART(R, Bot, TotIncBalCost, TotIncWear, TotDecBalCost, TotDecWear);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("_DepL");

  L_General.SurveyLastReport();
 END {MKATp};

END.
