(*
%Copyright   (c) Polak Computer System
%Author      10.07.2002 20:27:50 LDA
%Purpose     ᫥  
%Type        report
%Specific    SYS
%Modified    30.04.2014 19:53:25 POLAK\Gina
%Environment
*)

 MODULE MoneyLs [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_OwnData, L_StdFrm, L_Staff, L_AFM, L_PRoll,
        L_Man, L_Str, Str, FIO, L_Excel, P_Firm, L_AR, L_Russia;

 TYPE
  tSource = SCAL[1E4];

 CONST
  RepName = "MnyLs";

  RepTypePool     = " ⥪饬 |"+
                    " ⥪饣 |"+
                    " ⥪饬  㣨 |"+
                    " ⥪騩 |"+
                    " ⥪饬  㣨|"+
                    " 砫   ⥪騩 |"+
                    " 㪠 ਮ";

  MoneySourcePool = " ᫥|"+
                    " ᫥ (᪫ '⥬ ')|"+
                    "--------------------------------------|"+
                    L_PRoll.src_Pool;

  ArrSize                       = 5;

  ind_Period                    = 0;
  ind_Union                     = 1;
  ind_Sort                      = 2;
  ind_TSN                       = 3;
  ind_Firm                      = 4;

  src_All                       = 0;
  src_All_wo_src_FtSys          = 1;
  src_Delimiter                 = 2;

  Delta                         = src_Delimiter+1;

  rep_InCurMonth                = 0;
  rep_FromCurMonth              = 1;
  rep_InCurMonth_ForOtherMonth  = 2;
  rep_ForCurMonth               = 3;
  rep_InCurMonth_FromOtherMonth = 4;
  rep_FromYearBeg               = 5;
  rep_InCurPer                  = 6;

 VAR
  TotalTim    : NUMERIC[3][ArrSize];
  TotalSum    : NUMERIC[2][ArrSize];
  TotalAmn    : NUMERIC[0][ArrSize];

  _RepType    : NUMERIC[0];
  _MoneySource: tSource;
  _RepName    : STRING[];
  wMF         : SCAL[2];

(*
$P{ Top:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
" "+L_Str.PoolItem("᫥|㤥ঠ", MCList.MCTyp)+"   ("+L_Str.PoolItem(MoneySourcePool, _MoneySource)+")", C, ""
?, C, ""
MCList.MCode, L, ""
MCList.Name, L, ""
PrintPeriod(), R, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
| ### ############################################# ######################################################## |
}
*)

(*
$P{ LinePeriod:
Tmp.Period, L, "N.y"
@
|============================================================================================================|
| #######                                                                                               |
}
*)

(*
$P{ LineUnion:
Union.Union, L, ""
Union.Name, L, ""
@
|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|
|⥣p ## #####################################                                                          |
}
*)

(*
$P{ LineSort:
Sort.Sort, L, ""
Sort.Name, L, ""
PrintTitle(), L, ""
@
|------------------------------------------------------------------------------------------------------------|
| ### #################################################################                                |
|------------------------------------------------------------------------------------------------------------|
|. |              |                        |   |##   |筨    |      ६|        㬬|
|-----|-----------------|---------------------------------|-----|-----|------------|-----------|-------------|
}
*)

(*
$P{ Line:
?, L, ""
?, L, ""
?, L, ""
Tmp.WFPeriod, L, "N.Y"
Tmp.Period, L, "N.Y"
Tmp.Source, L, L_PRoll.src_Pool
Tmp.Tim, R, "3."
Tmp.Sum, R, ",2-"
@
|#####|#################|#################################|#####|#####|############|###########|#############|
}
*)

(*
$P{ LineTotalTSN:
TotalTim[ind_TSN], R, "3."
TotalSum[ind_TSN], R, ",2-"
@
|----------------------------------------------------------------------------------|-----------|-------------|
|⮣  ࠡ⭨                                                                |###########|#############|
}
*)

(*
$P{ LineTotalSort:
TotalAmn[ind_Sort], R, "0"
TotalTim[ind_Sort], R, "3."
TotalSum[ind_Sort], R, ",2-"
@
|----------------------------------------------------------------------------------|-----------|-------------|
|⮣  ᥪ                                                        ##### 祫.|###########|#############|
}
*)

(*
$P{ LineTotalUnion:
TotalAmn[ind_Union], R, "0"
TotalTim[ind_Union], R, "3."
TotalSum[ind_Union], R, ",2-"
@
|----------------------------------------------------------------------------------|-----------|-------------|
|⮣  ⥣p                                                      ##### 祫.|###########|#############|
}
*)

(*
$P{ LineTotalPeriod:
Tmp.Period, L, "N.y"
TotalAmn[ind_Period], R, "0"
TotalTim[ind_Period], R, "3."
TotalSum[ind_Period], R, ",2-"
@
|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|~~~~~~~~~~~|~~~~~~~~~~~~~|
|⮣  #######                                                        ##### 祫.|###########|#############|
}
*)

(*
$P{ Bot:
TotalAmn[ind_Firm], R, "0"
TotalTim[ind_Firm], R, "3."
TotalSum[ind_Firm], R, ",2-"
@
|~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~|
|⮣  ।                                                    ##### 祫.|###########|#############|
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE IsRealSource(): SCAL[2];
 BEGIN
  RETURN _MoneySource >= Delta;
 END {IsRealSource};

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "६ 䠩", "");

  CreateFIELD(Tmp, TSN, LIKE(Staff.TSN), "", "", "", ".", "");
  CreateFIELD(Tmp, MyFirm, P_Firm.tMyFirm, "", "", "", " ࣠", "");
  CreateFIELD(Tmp, Union, LIKE(Union.Union), "", "", "", "⥣", "");
  CreateFIELD(Tmp, Sort, LIKE(Sort.Sort), "", "", "", "", "");
  CreateFIELD(Tmp, Post, LIKE(Post.Post), "", "", "", "", "");
  CreateFIELD(Tmp, Source, LIKE(Money.Source), "", "", "", "筨", "");
  CreateFIELD(Tmp, WFPeriod, DATE, "", "", "", "", "");
  CreateFIELD(Tmp, Period, DATE, "", "", "", "", "");
  CreateFIELD(Tmp, Tim, NUMERIC[3], "", "0", "", "६", "");
  CreateFIELD(Tmp, Sum, NUMERIC[2], "", "0", "", "㬬", "");

  CreateINDEXandLINK(Tmp, Sort, PLURAL, Sort, Sort, USER, "", "", Sort);
  CreateINDEXandLINK(Tmp, Post, PLURAL, Post, Post, USER, "", "", Post);
  CreateINDEXandLINK(Tmp, Union, PLURAL, Union, Union, USER, "", "", Union);
  CreateINDEXandLINK(Tmp, TSN, PLURAL, Staff, TSN, USER,"", "", TSN);

  CreateINDEX(Tmp, Period, PLURAL, "", "", MyFirm, Period, Union, Sort, TSN, Post, WFPeriod);
  CreateINDEX(Tmp, List, PLURAL, "", "", MyFirm, Union, Sort, TSN, Post, WFPeriod, Period, Source);

  SetVersionOfFILE(Tmp, 0);
 END {Create_Tmp};

 PRIVATE PROCEDURE PrintPeriod(): STRING[];
 BEGIN
  IF    (_RepType = rep_InCurMonth) | (_RepType = rep_ForCurMonth) THEN
   RETURN " "+L_DatTim.PeriodStr(Memo.ud_mb());
  ELSIF _RepType = rep_FromCurMonth THEN
   RETURN " "+L_DatTim.PeriodStr(Memo.ud_mb())+"  "+L_DatTim.PeriodStr(Memo.ud_mb());
  ELSIF _RepType = rep_InCurMonth_ForOtherMonth THEN
   RETURN " "+L_DatTim.PeriodStr(Memo.ud_mb())+"  㣨";
  ELSIF _RepType = rep_InCurMonth_FromOtherMonth THEN
   RETURN " "+L_DatTim.PeriodStr(Memo.ud_mb())+"  㣨";
  ELSIF _RepType = rep_FromYearBeg THEN
   RETURN " "+L_DatTim.PeriodStr(L_DatTim.YearBeg(Memo.ud_mb()))+"  " + L_DatTim.PeriodStr(Memo.ud_mb());
  ELSIF _RepType = rep_InCurPer THEN
   RETURN " "+L_DatTim.PeriodStr(Memo.ud_fr())+"  " + L_DatTim.PeriodStr(Memo.ud_ut());
  END;
 END {PrintPeriod};

 PRIVATE PROCEDURE PrintTitle(): STRING[];
 BEGIN
  IF _RepType = rep_ForCurMonth THEN
   RETURN "";
  ELSE
   RETURN "";
  END;
 END {PrintTitle};

 PRIVATE PROCEDURE OutToExcel(Export: PROC);
  VAR
   objXL,
   objWB,
   objWS : OBJECT;
 BEGIN
  L_General.Assert(L_Excel.ExcelInstalled(), " ⠭ MS Excel");
  objXL:=CreateOBJECT("Excel.Application");
  TRY
   objWB:=objXL.Workbooks.Add();
   objWS:=objWB.Sheets(1);
   objXL.Visible       :=L_Excel.xlFalse;
   objXL.EnableEvents  :=L_Excel.xlFalse;
   objXL.ScreenUpdating:=L_Excel.xlFalse;
   Export(objWB, objWS);
   objWS.Name:=_RepName;
   objWS.Visible       :=L_Excel.xlTrue;
   objWB.SaveAs(FIO.MakePath(_RepName+FLDTOSTR(SYSDATE(), "_yND")+L_DatTim.LongSystimeStr(), "XLS",
                             FIO.AsbSpecialFolders("ASBTemp")));
   objXL.ScreenUpdating:=L_Excel.xlTrue;
   objXL.EnableEvents  :=L_Excel.xlTrue;
   objXL.Visible       :=L_Excel.xlTrue;
  EXCEPT
  ELSE
   L_Excel.CloseExcelAfterCrash(objXL, objWB);
   RAISE();
  END;
 END {OutToExcel};

 PRIVATE PROCEDURE MakeExcel(objWB, objWS: OBJECT);
 BEGIN
  L_Excel.ws_Init(objWS);
  L_Excel.ws_AddColumn(objWS, L_General.ft_SCAL,     5, "", "");
  L_Excel.ws_AddColumn(objWS, L_General.ft_STRING,   0, "", "");
  L_Excel.ws_AddColumn(objWS, L_General.ft_STRING,   0, "", "");
  L_Excel.ws_AddColumn(objWS, L_General.ft_STRING,   0, "", "");
  L_Excel.ws_AddColumn(objWS, L_General.ft_STRING,   0, "⥣", "");
  L_Excel.ws_AddColumn(objWS, L_General.ft_DATE,     0, "", "");
  L_Excel.ws_AddColumn(objWS, L_General.ft_DATE,     0, "", "");
  L_Excel.ws_AddColumn(objWS, L_General.ft_NUMERIC,  3, "६", "");
  L_Excel.ws_AddColumn(objWS, L_General.ft_NUMERIC,  2, "㬬", "");
  L_Excel.ws_AddColumn(objWS, L_General.ft_SCAL,    12, "", "");
  L_Excel.ws_AddColumn(objWS, L_General.ft_STRING,  12, "", "");
  L_Excel.ws_AddColumn(objWS, L_General.ft_STRING, 200, "ᯮ ", "");
  IF wMF THEN
   L_Excel.ws_AddColumn(objWS, L_General.ft_SCAL,     5, "", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_STRING,   0, "", "");
  END;
  L_Excel.ws_TermLine(objWS);

  SELECT(Tmp, TSN);
  WHILE OCCURE(Tmp) DO
   PROMPT(" " + Tmp.TSN);
   CONFORM(Tmp, Union);
   CONFORM(Tmp, Sort);
   CONFORM(Tmp, Staff);
   CONFORM(Staff, Man);
   CONFORM(Tmp, Post);
   L_Man.StrongAccessManAdr(Staff.Man, Memo.ud_me(), L_Russia.at_RgMA);
   L_Excel.ws_WrScl(objWS, Staff.TSN);
   L_Excel.ws_WrStr(objWS, Man.Name);
   L_Excel.ws_WrStr(objWS, Post.Name);
   L_Excel.ws_WrStr(objWS, Sort.Name);
   L_Excel.ws_WrStr(objWS, Union.Name);
   L_Excel.ws_WrDat(objWS, Tmp.WFPeriod);
   L_Excel.ws_WrDat(objWS, Tmp.Period);
   L_Excel.ws_WrNum(objWS, Tmp.Tim);
   L_Excel.ws_WrNum(objWS, Tmp.Sum);
   L_Excel.ws_WrScl(objWS, Man.INN);
   L_Excel.ws_WrStr(objWS, L_Man.GetPostAdr_asStr(1));
   L_Excel.ws_WrStr(objWS, L_Man.GetManDocAttr_asStr());
   IF wMF THEN
    CONFORM(Staff, MyFirm);
    L_Excel.ws_WrScl(objWS, MyFirm.MyFirm);
    L_Excel.ws_WrStr(objWS, MyFirm.vzSign);
   END;
   L_Excel.ws_TermLine(objWS);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  objWS.UsedRange.EntireColumn.AutoFit();
  L_Excel.ws_DeInit(objWS);
 END {MakeExcel};

 PRIVATE PROCEDURE PrintRep(ByPeriod: SCAL[2]);
  VAR
   _TSN   : LIKE(Staff.TSN);
   _Name,
   _Post  : STRING[];
 BEGIN
  OPENREP(R, L_General.NameConnection(_RepName), Create);
  IF ByPeriod THEN
   SELECT(Tmp, Period);
  ELSE
   SELECT(Tmp, List);
  END;

  IF ~OCCURE(Tmp) THEN
   IF ByPeriod THEN
    MAKEPART(R, Top, L_OwnData.ODFirmName(SYSDATE()), " ࠧ  ਮ");
   ELSE
    MAKEPART(R, Top, L_OwnData.ODFirmName(SYSDATE()), L_Str.PoolItem(RepTypePool, _RepType));
   END;
   SETZERO(TotalTim, TotalSum, TotalAmn);
   MAKEPART(R, Bot);
  END;

  WHILE OCCURE(Tmp) DO
   NARROWSEL(Tmp, MyFirm);
   IF ByPeriod THEN
    MAKEPART(R, Top, P_Firm.MyFirmName(Tmp.MyFirm, SYSDATE()), " ࠧ  ਮ");
   ELSE
    MAKEPART(R, Top, P_Firm.MyFirmName(Tmp.MyFirm, SYSDATE()), L_Str.PoolItem(RepTypePool, _RepType));
   END;
   SETZERO(TotalTim, TotalSum, TotalAmn);
   WHILE OCCURE(Tmp) DO
    IF ByPeriod THEN
     SETZERO(TotalTim[ind_Period], TotalSum[ind_Period], TotalAmn[ind_Period]);
     NARROWSEL(Tmp, Period);
     MAKEPART(R, LinePeriod);
    END;
    WHILE OCCURE(Tmp) DO
     NARROWSEL(Tmp, Union);
     CONFORM(Tmp, Union);
     SETZERO(TotalTim[ind_Union], TotalSum[ind_Union], TotalAmn[ind_Union]);
     MAKEPART(R, LineUnion);
     WHILE OCCURE(Tmp) DO
      NARROWSEL(Tmp, Sort);
      CONFORM(Tmp, Sort);
      SETZERO(TotalTim[ind_Sort], TotalSum[ind_Sort], TotalAmn[ind_Sort]);
      MAKEPART(R, LineSort);
      WHILE OCCURE(Tmp) DO
       PROMPT(" " + Tmp.TSN);
       NARROWSEL(Tmp, TSN);
       CONFORM(Tmp, Staff);
       CONFORM(Staff, Man);
       _TSN:=Tmp.TSN;
       _Name:=L_Str.ShortName(Man.Name);
       SETZERO(TotalTim[ind_TSN], TotalSum[ind_TSN], TotalAmn[ind_TSN]);
       WHILE OCCURE(Tmp) DO
        NARROWSEL(Tmp, Post);
        CONFORM(Tmp, Post);
        _Post:=Post.Name;
        WHILE OCCURE(Tmp) DO
         INC(TotalTim[ind_TSN], Tmp.Tim);
         INC(TotalSum[ind_TSN], Tmp.Sum);
         INC(TotalAmn[ind_TSN]);
         MAKEPART(R, Line, _TSN, _Name, _Post);
         SETEMPTY(_TSN, _Name, _Post);
         NEXT(Tmp);
        END; (* WHILE OCCURE(Tmp) ... *)
        NEXTINEXTENDEDSEL(Tmp, Post);
       END; (* WHILE OCCURE(Tmp) ... *)
(* 0076160
       IF TotalAmn[ind_TSN] > 1 THEN
        MAKEPART(R, LineTotalTSN);
       END;
*)
       INC(TotalTim[ind_Sort], TotalTim[ind_TSN]);
       INC(TotalSum[ind_Sort], TotalSum[ind_TSN]);
       INC(TotalAmn[ind_Sort]);
       NEXTINEXTENDEDSEL(Tmp, TSN);
      END; (* WHILE OCCURE(Tmp) ... *)
      INC(TotalTim[ind_Union], TotalTim[ind_Sort]);
      INC(TotalSum[ind_Union], TotalSum[ind_Sort]);
      INC(TotalAmn[ind_Union], TotalAmn[ind_Sort]);
      MAKEPART(R, LineTotalSort);
      NEXTINEXTENDEDSEL(Tmp, Sort);
     END; (* WHILE OCCURE(Tmp) ... *)
     INC(TotalTim[ind_Firm], TotalTim[ind_Union]);
     INC(TotalSum[ind_Firm], TotalSum[ind_Union]);
     INC(TotalAmn[ind_Firm], TotalAmn[ind_Union]);
     IF ByPeriod THEN
      INC(TotalTim[ind_Period], TotalTim[ind_Union]);
      INC(TotalSum[ind_Period], TotalSum[ind_Union]);
      INC(TotalAmn[ind_Period], TotalAmn[ind_Union]);
     END;
     MAKEPART(R, LineTotalUnion);
     NEXTINEXTENDEDSEL(Tmp, Union);
    END; (* WHILE OCCURE(Tmp) ... *)
    IF ByPeriod THEN
     LAST(Tmp);
     MAKEPART(R, LineTotalPeriod);
     NEXTINEXTENDEDSEL(Tmp, Period);
    END;
   END; (* WHILE OCCURE(Tmp) ... *)
   MAKEPART(R, Bot);
   IF NEXTINEXTENDEDSEL(Tmp, MyFirm) THEN
    FORMFEED(R);
   END;
  END; (* WHILE OCCURE(Tmp) ... *)
  CLOSEREP(R);
 END {PrintRep};

 PRIVATE PROCEDURE CheckPer(): SCAL[2];
 BEGIN
  IF    _RepType = rep_FromCurMonth THEN
   RETURN Memo.ud_mb() = Money.WFPeriod;
  ELSIF _RepType = rep_InCurMonth_ForOtherMonth THEN
   RETURN Money.Closed # Money.Period;
  ELSIF _RepType = rep_InCurMonth_FromOtherMonth THEN
   RETURN Money.Closed # Money.WFPeriod;
  ELSE
   RETURN 1;
  END;
 END {CheckPer};

 PRIVATE PROCEDURE CheckSource(): SCAL[2];
 BEGIN
  IF IsRealSource() THEN
   RETURN (Money.Source = (_MoneySource - Delta));
  ELSIF _MoneySource = src_All_wo_src_FtSys THEN
   RETURN (Money.Source # L_PRoll.src_FtSys);
  ELSE
   RETURN 1;
  END;
 END {CheckSource};

 PRIVATE PROCEDURE ConditionalInsIntoTmp();
 BEGIN
  IF CheckSource() & CheckPer() THEN
   CONFORM(Money, Staff);
   IF OCCURE(Staff) THEN
    IF (Money.Tim # 0) | (Money.Sum # 0) THEN
     L_Staff.PosToStaffLog(Money.TSN, Money.ODate, 0);
     CONFORM(StaffLog, Officer);
     Tmp.TSN     :=Money.TSN;
     Tmp.MyFirm  :=L_Staff.GetStaffMyFirm();
     Tmp.Union   :=Officer.Union;
     Tmp.Sort    :=Officer.Sort;
     Tmp.Post    :=Officer.Post;
     Tmp.Source  :=Money.Source;
     Tmp.WFPeriod:=Money.WFPeriod;
     Tmp.Period  :=Money.Period;
     Tmp.Tim     :=Money.Tim;
     Tmp.Sum     :=Money.Sum;
     INSERT(Tmp);
    END;
   ELSE
    L_General.CallUs(~L_AR.DatabaseIsTransparent());
   END;
  END; (* IF CheckSource ... *)
 END {ConditionalInsIntoTmp};

 PRIVATE PROCEDURE Make(DoExcel: SCAL[2]);
  VAR
   frP,
   utP: DATE;
 BEGIN
  IF DoExcel THEN
   L_General.Assert(L_Excel.ExcelInstalled(), "Excel  ⠭");
  END;
  IF _RepType = rep_ForCurMonth THEN
   SELECT(Money, PayFor);
   WHILE OCCURE(Money) DO
    NARROWSEL(Money, TSN);
    PROMPT("⮢ : " + Money.TSN);
    IF SRCINSEL(Money, EQ, Memo.ud_mb(), MCList.MCode) THEN
     SAVE(Money);
     CHANGESEL(Money, PayFor, , Money.TSN, Money.Period, Money.MCode);
     WHILE OCCURE(Money) DO
      ConditionalInsIntoTmp();
      NEXT(Money);
     END; (* WHILE OCCURE(Money) ... *)
     RESTORE(Money);
    END; (* IF *)
    NEXTINEXTENDEDSEL(Money, TSN);
   END; (* WHILE OCCURE(Money) ... *)
  ELSE
   IF    _RepType = rep_FromCurMonth THEN
    frP:=Memo.ud_mb();
    utP:=L_DatTim.Per(MAXOF(DATE));
   ELSIF _RepType = rep_FromYearBeg THEN
    frP:=L_DatTim.YearBeg(Memo.ud_mb());
    utP:=Memo.ud_mb();
   ELSIF _RepType = rep_InCurPer THEN
    frP:=L_DatTim.Per(Memo.ud_fr());
    utP:=L_DatTim.Per(Memo.ud_ut());
   ELSE
    frP:=Memo.ud_mb();
    utP:=Memo.ud_mb();
   END;
   SELECT(Money, MCode, , MCList.MCode);
   SRCINSEL(Money, GE, , frP);
   WHILE OCCURE(Money) & (Money.Closed <= utP) DO
    PROMPT("⮢ : " + Money.TSN);
    ConditionalInsIntoTmp();
    NEXT(Money);
   END; (* WHILE OCCURE(Money) ...*)
  END; (* IF *)

  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  IF DoExcel THEN
   OutToExcel(PROCREF(MakeExcel));
  ELSE
   PrintRep(_MoneySource = src_All_wo_src_FtSys);
  END;
 END {Make};

 PUBLIC PROCEDURE MoneyLs();
  VAR
   DoExcel: SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(MCList), " ࠭  ᫥/㤥ঠ");
  _RepName:=FLDTOSTR(MCList.MCode);
  DoExcel:=0;
  SETZERO(_MoneySource, _RepType);
  LOOP
   STDFORM(L_StdFrm.sf_Choice(      "%##############%%#####%                                 " +
                              "|" + "                                                        " +
                              "|" + "%##############%%######################################%" +
                              "|" + "                                                        " +
                              "|" + "%##############%%######################################%" +
                              "|" + "                                                        " +
                              "|" + "%##############%%####%%##########%                      ",
                              "%<ଠ         >M" + "%<|Excel>I" +
                              "%<      >M" + "%L<"+RepTypePool+">I" +
                              "%<筨       >M" + "%L<"+MoneySourcePool+">I" +
                              "%< >M" + "%<" + RepName + "_>T" +  "%LI"),
           " ᫥   ",
           ,
           1,
           DoExcel, _RepType, _MoneySource, _RepName);
   IF (_MoneySource = src_Delimiter) |
      (~IsRealSource() & (_MoneySource # src_All) & (_RepType # rep_InCurMonth)) THEN
    L_StdFrm.RedInform("  ⠪  | ⠪ 筨");
   ELSE
    EXIT;
   END;
  END; (* LOOP *)

  _RepName:=RepName + "_" + _RepName;
  Create_Tmp();
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
  Make(DoExcel);
  L_AFM.AF_PurgeTemp("Tmp");
  IF ~DoExcel THEN
   L_General.SurveyLastReport();
  END;
 END {MoneyLs};

END.
