(*
%Copyright   (c) Polak Computer System
%Author      14.04.1998 15:49:22 GINA
%Purpose      MoneyRul.Comment
%Type        operation
%Specific    SYS
%Modified    10.04.2012 12:22:35 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_Events, L_General, L_DatTim;

 PRIVATE PROCEDURE MoneyRul_Rule_OnSuccessfulChange();
 BEGIN
  IF ~!MoneyRul.Rule & (!GE_PVALUE() | (MoneyRul.Rule#GE_PVALUE())) THEN
   CONFORM(MoneyRul, Rule);
   IF ~!Rule.Name THEN
    MoneyRul.Comment:=Rule.Name;
   ELSE
    SETEMPTY(MoneyRul.Comment);
   END;
   REPLACE(MoneyRul);
  END;
 END {MoneyRul_Rule_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckLastMMthLog();
 BEGIN
  L_General.Assert(ACCESS(MMthLog), " ⠭ ⥪ 䨪");
  SAVE(MMthLog);
  IF NEXT(MMthLog) THEN
   STDMSG("   ᫥ 䨪", CHOICE);
  END;
  RESTORE(MMthLog);
 END {CheckLastMMthLog};

 PRIVATE PROCEDURE MoneyRul_OnBeforeInsert();
 BEGIN
  CheckLastMMthLog();
 END {MoneyRul_OnBeforeInsert};

 PRIVATE PROCEDURE MoneyRul_OnBeforeEdit();
 BEGIN
  CheckLastMMthLog();
 END {MoneyRul_OnBeforeEdit};

 PRIVATE PROCEDURE MoneyRul_OnBeforeDelete();
 BEGIN
  CheckLastMMthLog();
 END {MoneyRul_OnBeforeDelete};

BEGIN
 IF    L_Events.IsInternalEvents(MODE) THEN
  ^(L_Events.GetInternalEventHandlerName(MODE))();
 ELSE
  L_General.BadMode(MODE);
 END;
END.
