(*
%Copyright   (c) Polak Computer System
%Author      19.01.1994 15:35:09 SAN
%Purpose     ନ஢ ⥦ 㬥⮢  뤠 
%Type        operation
%Specific    SYS
%Modified    17.06.2014 22:50:09 POLAK\Gina
%Environment
*)

 MODULE MPD_Advn [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_DatTim, L_General, L_PDoc, L_PRoll, L_Staff, L_OwnData, Memo,
        L_AFM, L_EC, L_Env, Math, L_Sheet, L_Str, L_Man, L_Math, L_StdFrm, L_Hld;

 PRIVATE CONST
  ec_NoAvn = 27012003;
  cRNMon   = "Avn";
  cRNPrt   = "PrAvn";

 PRIVATE VAR
  _Sum,
  InitVal,
  CorrVal,
  _OutSaldo,
  Corr      : NUMERIC[2];
  _FullBal,
  _TimDone  : LIKE(Money.Tim);
  Today,
  PeriodE,
  _Period   : DATE;
  _Reason   : STRING[];
  JMArr     : LIKE(JMode.JMode)[31];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
cRNPrt, L, ""
_Period, L, "N.y"
Today, L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                        ⮪    ####### (⥪  ##########)                        |
}
*)

(*
$P{ DlmLine:
?, C, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
}
*)

(*
$P{ CashTop:
Cash.Cash, L, ""
Cash.Name, L, ""
@
|------------------------------------------------------------------------------------------------------------|
| ## ######################################################                                             |
|------------------------------------------------------------------------------------------------------------|
|                 |        |稭         ||| 室|४.| 뤠|
|-----------------------|-----------------|-------------------------------|---|---|--------|--------|--------|
}
*)

(*
$P{ Line:
_Temp._TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Post.Name, L, ""
_Temp._Reason, L, ""
_Temp._FullBal, R, "0"
_Temp._TimDone, R, "0"
_Temp._InitVal, R, "2-"
_Temp._CorrVal, R, "2-"
_Temp._Sum, R, "2-"
@
|##### #################|#################|###############################|###|###|########|########|########|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE NoAvn_Assert(Cond: SCAL[2]; Msg: STRING[]);
 BEGIN
  IF ~Cond THEN
   RAISE(ec_NoAvn, Msg);
  END;
 END {NoAvn_Assert};

 PRIVATE PROCEDURE GetHldDayTime(): L_PRoll.tTime;
  VAR
   Result: L_PRoll.tTime;
 BEGIN
  Result:=0;
  TRY [RESTORE_CURSORS(RC_ON)]
   CONFORM(StaffLog, RegMain);
   IF RegMain.SlipGr # L_PRoll.rgt_SlipGr THEN
    L_General.Assert(SEARCH(RegHead, HumReg, StaffLog.Regime, _Period),
                     " ० " + StaffLog.Regime + "    " + L_DatTim.PeriodStr(_Period));
    IF RegHead.GrTime > 0 THEN
     Result:=RegHead.GrTime/RegHead.GDay;
    ELSE
     Result:=8*StaffLog.DutyDgr;
    END;
   END;
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetHldDayTime};

 PRIVATE PROCEDURE SetBalTimes();
  VAR
   BegD,
   curD    : DATE;
   curJMode: LIKE(JMode.JMode);
   JMArrVol: NUMERIC[0];
   HldTime : L_PRoll.tTime;
 BEGIN
  SETZERO(_FullBal, _TimDone, JMArrVol, HldTime); SETEMPTY(JMArr);
  BegD:=L_Man.GetTakeOnDate(PeriodE);
  curD:=_Period;
  WHILE curD <= Today DO
   PROMPT(Staff.TSN + " - " + L_DatTim.DateStr(curD));
   SETEMPTY(curJMode);
   IF curD >= BegD THEN
    HISTCONF(curD, Staff, StaffLog);
    IF SEARCH(Sheet, TSN, Staff.TSN, L_DatTim.Per(curD), L_DatTim.DAY(curD)) THEN
     CONFORM(Sheet, JMode);
     IF JMode.Type = L_Sheet.jmType_TimDone THEN
      INC(_TimDone, Sheet.Tim);
     ELSIF JMode.Type # L_Sheet.jmType_HolTime THEN
      curJMode:=JMode.JMode;
     ELSIF L_Hld.DayIsHoliday(curD) &
           (Sheet.JMode = L_Sheet.jm_Hld(_Period)) & (Sheet.Source#L_Sheet.src_AvePay) THEN
      INC(HldTime, GetHldDayTime());
     END;
    END;
   ELSE
    HISTCONF(BegD, Staff, StaffLog);
   END;
   L_General.Assert(SEARCH(RegList, HumReg, StaffLog.Regime, L_DatTim.Per(curD), L_DatTim.DAY(curD)),
                    " ⠭ ० ࠡ "+StaffLog.Regime+"  "+L_DatTim.DateStr(curD));
   CONFORM(RegList, JMode);
   IF JMode.InFirm THEN
    INC(_FullBal, RegList.Durat);
    IF (RegList.Durat # 0) & ~!curJMode THEN
     L_Math.Math_InsInOrderedArray(JMArr, JMArrVol, curJMode);
    END;
   END;
   INC(curD);
  END; (* WHILE curD <= Today... *)
  IF _TimDone > 0 THEN
   INC(_TimDone, HldTime);
  END;
 END {SetBalTimes};

 PRIVATE PROCEDURE E_NeedCorrTimeWithOver(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(NeedCorrTimeWithOver), 0);
 END {E_NeedCorrTimeWithOver};

 PRIVATE PROCEDURE CorrectionByTime(): NUMERIC[4];
 BEGIN
  SetBalTimes();
  IF _FullBal = 0 THEN
   RETURN 0;
  ELSIF (_TimDone < _FullBal) | (E_NeedCorrTimeWithOver(_Period) & (_TimDone > _FullBal)) THEN
   RETURN _TimDone / _FullBal;
  ELSE
   RETURN 1;
  END;
 END {CorrectionByTime};

 PRIVATE PROCEDURE IncreaseToTariff(avans: NUMERIC[2]): NUMERIC[2];
  VAR
   HPay,
   MPay : NUMERIC[3];
 BEGIN
  SetBalTimes();
  CONFORM(StaffLog, Officer);
  CONFORM(Officer, WagePay);
  HISTCONF(_Period, WagePay, WagePayL);
  L_General.Assert(SEARCH(RegHead, HumReg, StaffLog.Regime, _Period),
                   " ᠭ ० ࠡ " + StaffLog.Regime + "  " + L_DatTim.PeriodStr(_Period));
  L_PRoll.GetHMPay(Today, RegHead.FullBal, HPay, MPay);
  RETURN Math.Max(HPay * _FullBal, avans);
 END {IncreaseToTariff};

 PUBLIC PROCEDURE GetDefaultAvnValue(): NUMERIC[2];
  VAR
   AvansbySum: SCAL[2];
   Avans     : NUMERIC[2];
   HPay,
   MPay      : NUMERIC[3];
 BEGIN
  L_Staff.GetAvans(Staff.TSN, _Period, AvansbySum, Avans);
  IF ~AvansbySum THEN
   HISTCONF(Today, Staff, StaffLog);
   CONFORM(StaffLog, Officer, WagePay);
   HISTCONF(_Period, WagePay, WagePayL);
   L_General.Assert(SEARCH(RegHead, HumReg, StaffLog.Regime, _Period),
                    " ᠭ ० ࠡ " + StaffLog.Regime + "  " + L_DatTim.PeriodStr(_Period));
   L_PRoll.GetHMPay(Today, RegHead.FullBal, HPay, MPay);
   Avans:=MPay * Avans / 100;
  END;
  RETURN Avans;
 END {GetDefaultAvnValue};

(*in E_Avn*)

 PRIVATE PROCEDURE E_PrintAll(): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(_Period, PROCREF(PrintAll), 1);
 END {E_PrintAll};

 PRIVATE PROCEDURE E_GetMinBankNote(): LIKE(Money.Sum);
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(_Period, PROCREF(GetMinBankNote), 100);
 END {E_GetMinBankNote};

 PRIVATE PROCEDURE E_GetMinSum(): LIKE(Money.Sum);
 BEGIN
  RETURN L_EC.ExecE_Func_Numeric(_Period, PROCREF(GetMinSum), 100);
 END {E_GetMinSum};

 PRIVATE PROCEDURE RoundAvnValue(S: LIKE(Money.Sum)): LIKE(Money.Sum);
  VAR
   RoundSum: NUMERIC[2];
 BEGIN
  RoundSum:=Math.Round(S, E_GetMinBankNote());
  IF RoundSum < E_GetMinSum() THEN
   RETURN 0;
  ELSE
   RETURN RoundSum;
  END;
 END {RoundAvnValue};

 PRIVATE PROCEDURE PrintPr(trgwReason: SCAL[2]);
 BEGIN
  MAKEPART(Pr, DlmLine, L_Str.PoolItem("  ४஢|  ४஢", trgwReason));
  SELECT(_Temp, _Temp, , trgwReason);
  WHILE OCCURE(_Temp) DO
   PROMPT(" " + _Temp._TSN);
   NARROWSEL(_Temp, _Cash);
   SEARCH(Cash, Cash, , _Temp._Cash);
   MAKEPART(Pr, CashTop);
   WHILE OCCURE(_Temp) DO
    SEARCH(Staff, TSN, , _Temp._TSN);
    CONFORM(Staff, Man);
    HISTCONF(PeriodE, Staff, StaffLog);
    CONFORM(StaffLog, Post);
    MAKEPART(Pr, Line);
    NEXT(_Temp);
   END; (* WHILE OCCURE(_Temp) ... *)
   NEXTINEXTENDEDSEL(_Temp, _Cash);
  END; (* WHILE OCCURE(_Temp) ... *)
 END {PrintPr};

 PRIVATE PROCEDURE InsTemp();
 BEGIN
  _Temp.wReason :=~!_Reason;
  _Temp._Cash   :=L_PDoc.GetStaffCash(PeriodE);
  _Temp._TSN    :=Staff.TSN;
  _Temp._FullBal:=_FullBal;
  _Temp._TimDone:=_TimDone;
  _Temp._Reason :=_Reason;
  _Temp._InitVal:=InitVal;
  _Temp._CorrVal:=CorrVal;
  _Temp._Sum    :=_Sum;
  INSERT(_Temp);
 END {InsTemp};

 PRIVATE PROCEDURE GetJMArrStr(): STRING[];
  VAR
   Result: STRING[];
   i     : NUMERIC[0];
 BEGIN
  i:=0; Result:="";
  WHILE (i<= HIGH(JMArr)) & ~!JMArr[i] DO
   Result:=L_Str.AddStrDlm(Result, ",")+JMArr[i];
   INC(i);
  END;
  IF ~!Result THEN
   Result:=": "+Result;
  END;
  RETURN Result;
 END {GetJMArrStr};

 PUBLIC PROCEDURE Advn();
  VAR
   ByCassa   : SCAL[2];
   RepNameMon,
   RepNamePrt: STRING[];
 BEGIN
  Today  :=Memo.ud_cd();
  _Period:=L_DatTim.MonthBeg(Today);
  PeriodE:=L_DatTim.MonthEnd(Today);
  L_General.Assert(_Period = L_DatTim.Per(SYSDATE()),
                   "  믮 ⮫쪮  ⥪饣 : "
                   + L_DatTim.PeriodStr(SYSDATE()));
  ByCassa:=L_PRoll.ByCassaLev(L_PDoc.ev_AdvnPay);
  STDFORM(L_StdFrm.sf_Choice("| ନ ⥦ 㬥" +
                             "| 뤠    " + L_DatTim.PeriodStr(_Period) +
                             "|" +
                             "| :" +
                             "|%################%" +
                             "|",
                             "%< ᯨ᪮| ᠬ>I"),
          , STOP, 1, ByCassa);

  L_PDoc.InitPDocGroup(L_PDoc.ev_AdvnPay);
 
  PASTE(E_Avn);
 
  RepNameMon:=L_General.rfn_byMonth(cRNMon, _Period);
  RepNamePrt:=L_General.NameConnection(cRNPrt);
  OPENREP(Mon, RepNameMon, Create);
  OPENREP(Pr,  RepNamePrt, Create);
  MAKEPART(Pr, Top);
 
  L_AFM.MakeIndex("_Temp", "wReason   : SCAL[2];"+
                           "_Cash     : LIKE(Cash.Cash);"+
                           "_TSN      : LIKE(Staff.TSN);"+
                           "_FullBal  : LIKE(Money.Tim);"+
                           "_TimDone  : LIKE(Money.Tim);"+
                           "_Reason   : STRING[32];"+
                           "_InitVal  : LIKE(PDocList.Sum);"+
                           "_CorrVal  : LIKE(PDocList.Sum);"+
                           "_Sum      : LIKE(PDocList.Sum)");
 
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   IF (Staff.Contract # L_Staff.cnt_OutStaff) & L_Env.RealTSN(Staff.TSN) THEN
    SETEMPTY(_FullBal, _TimDone); SETZERO(InitVal, CorrVal, _Sum);
    IF    ~L_Staff.InStateInPer(_Period, PeriodE) THEN
     PROMPT(Staff.TSN + " :   ");
    ELSIF L_Staff.IsLeave(_Period) THEN
     PROMPT(Staff.TSN + " : 㢮");
     _Reason:=" " + L_DatTim.DateStr(Staff.EndDate);
     InsTemp();
    ELSIF L_Man.GetTakeOnDate(PeriodE) > Today THEN
     PROMPT(Staff.TSN + " :  ਭ");
     _Reason:="ਭ "+L_DatTim.DateStr(L_Man.GetTakeOnDate(PeriodE));
     InsTemp();
    ELSE
     CONFORM(Staff, Man);
     PROMPT(Staff.TSN + " :  㬬 ");
     TRY
      L_PRoll.StaffCountUpOnDate(Staff.TSN, Today);
      InitVal:=GetAvnValue();
      SetCorrVal();
      _Sum:=RoundAvnValue(CorrVal);
      SETEMPTY(_Reason);
      IF InitVal = 0 THEN
       _Reason:=" ";
      ELSIF Corr > 0 THEN
       _Reason:="줮";
      ELSIF CorrVal # InitVal THEN
       _Reason:=L_Str.PoolItem("ࠡ⪠|ࠡ⪠", CorrVal > InitVal);
       IF CorrVal < InitVal THEN
        _Reason:=_Reason+GetJMArrStr();
       END;
      END;
     EXCEPT
     ON Exc:Exc_Raise DO
      IF Exc.ErrorCode = ec_NoAvn THEN
       _Reason:=Exc.Description;
       _Sum:=0;
      ELSE
       RAISE();
      END;
     END;
     IF _Sum > 0 THEN
      L_PDoc.AppendPDoc(_Sum);
     END;
     IF ~!_Reason | E_PrintAll() THEN
      InsTemp();
     END;
    END; (* IF IsLeave(_Period) ... *)
   END; (* IF L_Env.RealTSN... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 
  L_PDoc.DonePDocGroup(ByCassa);
 
  PrintPr(1);
  PrintPr(0);
 
  MAKEPART(Pr, Bot);
  CLOSEREP(Pr);
  CLOSEREP(Mon);
  L_AFM.AF_PurgeTemp("_Temp");
  LIKEMENU(Survey, L_PDoc.PDocListRepName(),
           Survey, RepNameMon,
           Survey, RepNamePrt);
 END {Advn};

END.
