(*
%Copyright   (c) Polak Computer System
%Author      30.10.1995 16:19:01 NAIL
%Purpose      ⥦ 㬥⮢  ᫥ 㤥ঠ
%Type        operation
%Specific    SYS
%Modified    10.04.2012 12:22:45 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_PayP, L_PDoc, L_PRoll, L_DatTim, Memo, P_Firm, L_Staff, L_AR, L_StdFrm;

 CONST
  RepName = "DedTr";

 PRIVATE PROCEDURE ProcessSingleDeduct(Silent: SCAL[2]);
  VAR
   Collect,
   Transfer: NUMERIC[2];
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF (Deduct.Firm # P_Firm.fomf(L_Staff.GetStaffMyFirm())) | L_PDoc.IsDeductPayP(Deduct.PayP) THEN
   PROMPT(" ⥦: " + PayP.PayP +
          " : "        + Deduct.TSN +
          " 㤥- # "   + Deduct.DedNbr);
   SELECT(DedAcnt, TSN, , Deduct.TSN, Deduct.DedNbr);
   SRCINSEL(DedAcnt, EQ, , Memo.gl_mb());
   IF OCCURE(DedAcnt) & (DedAcnt.NetDebt > 0) THEN
    L_PRoll.CheckSalDone(Memo.gl_mb());
    SAVE(Deduct);
    L_PayP.GetDedAcntDebts(Transfer, Collect);
    RESTORE(Deduct);
    L_PDoc.AppendPDoc(Transfer + Collect);
    Result:=1;
   END; (* IF OCCURE(DedAcnt) & ... *)
  END; (* IF Deduct.Firm # ... *)
  L_General.Assert(Silent | Result, "祣 ");
 END {ProcessSingleDeduct};

 PRIVATE PROCEDURE ProcessSinglePayP();
 BEGIN
  IF SELECT(Deduct, PayP, PayP.PayP) THEN
   WHILE OCCURE(Deduct) DO
    CONFORM(Deduct, Staff);
    IF OCCURE(Staff) THEN
     ProcessSingleDeduct(1);
    ELSE
     L_General.CallUs(~L_AR.DatabaseIsTransparent());
    END;
    NEXT(Deduct);
   END (* WHILE OCCURE(Deduct)... *);
  END;
 END {ProcessSinglePayP};

 VAR
  ByCassa: SCAL[2];

 PRIVATE PROCEDURE Init(_Event: L_PDoc.tEvent; ForDeduct: SCAL[2]);
  VAR
   FormStr: STRING[];
 BEGIN
  IF ForDeduct THEN
   ByCassa:=0;
   FormStr:="| ନ ⥦ 㬥" +
            "| ᫥ 㤥ঠ  "+L_DatTim.PeriodStr(Memo.gl_mb())+
            "|" +
            "| ,   ᫥," +
            "|室 ᫥ ᠬ⥫쭮 - " +
            "|㤠  ᫥  ";
   L_StdFrm.Choice(FormStr);
  ELSE
   ByCassa:=L_PRoll.ByCassaLev(_Event);
   FormStr:="| ନ ⥦ 㬥" +
            "| ᫥ 㤥ঠ  "+L_DatTim.PeriodStr(Memo.gl_mb())+
            "|" +
            "| :                  " +
            "|%31,2< ᯨ᪮| ᠬ>FO" +
            "|" +
            "|" +
            "|" +
            "|%<   !   >X  %< 믮 >DB";
   STDFORM(FormStr, , STOP, -1, ByCassa);
  END;
  L_PDoc.InitPDocGroup(_Event);
  OPENREP(Mon, L_General.NameConnection(RepName), Create);
 END {Init};

 PRIVATE PROCEDURE StreamPayP();
 BEGIN
  Init(L_PDoc.ev_DeductTransfer, 0);
  SELECT(PayP, PayP);
  WHILE OCCURE(PayP) DO
   ProcessSinglePayP();
   NEXT(PayP);
  END; (* WHILE OCCURE(PayP) ... *)
  L_PDoc.DonePDocGroup(ByCassa);
  CLOSEREP(Mon);
 END {StreamPayP};

 PRIVATE PROCEDURE SinglePayP();
 BEGIN
  L_General.Assert(ACCESS(PayP), " ⠭ 祭 ⥦");
  Init(L_PDoc.ev_OnePayPDeductTransfer, 0);
  ProcessSinglePayP();
  L_PDoc.DonePDocGroup(ByCassa);
  CLOSEREP(Mon);
 END {SinglePayP};

 PRIVATE PROCEDURE SingleDeduct();
 BEGIN
  L_General.Assert(ACCESS(Deduct), " ⠭ 㤥ঠ");
  Init(L_PDoc.ev_DeductTransfer, 1);
  CONFORM(Deduct, Staff, PayP);
  ProcessSingleDeduct(0);
  L_PDoc.DonePDocGroup(ByCassa);
  CLOSEREP(Mon);
 END {SingleDeduct};

END.
