(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose     ନ஢ ⥦ 㬥⮢  ᮢ 뤠  ⥪騩 
%Type        control
%Specific    SYS
%Modified    06.12.2013 18:05:08 POLAK\Gina
%Environment
*)

 MODULE MPD_PCal [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_DatTim, L_General, L_PDoc, L_PRoll, L_Staff, L_Env, L_OwnData,
        L_Str, Memo, L_APtm, L_StdFrm, L_AFM;

 CONST
  cRepName    = "Slp";
  cRepNameExt = "Sal";

 VAR
  CurMonth  : DATE;
  CreSld,
  TotCrd,
  ForFut,
  TakenSum,
  RemndSum,
  ToGetSum,
  LeaveSum,
  LimFinalSaldo,
  TakeLater,
  TotDec    : NUMERIC[2];
  NeedFutInc: SCAL[2];
  DeadLineDate: DATE;
  _Saldo    : LIKE(PCalc.Saldo);
  _LimFinalSaldo,
  _TakeLater,
  _ToTake,
  _Taken,
  _Remind,
  _ForFut,
  _LeaveSum  : NUMERIC[2];
  CurrentTurn: LIKE(Cash.Turn);
  Total_Sum,
  Cash_Sum   : NUMERIC[2][10];
  SubTitle,
  RepName,
  RepNameExt : STRING[];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
cRepName+"====", L, ""
CurMonth, L, "N.y"
SubTitle, C, ""
L_DatTim.IncMonth(L_DatTim.Per(SYSDATE()), +1), L, "D.N.y"
@
############################################################################ ########## #####
=#####=======================================================================================
|               ⮪ ନ஢   ᮢ 뤠  #######                |
|###########################################################################################|
|-------------------------------------------------------------------------------------------|
|     |                  |            |            |             |             |襭 |
|. |               |   騩|       |     뤠 |        㤥|   ᠫ줮 |
|     |                  |      ਮ|      㢮|. .| 뤠 |  ##########|
|-----|------------------|------------|------------|-------------|-------------|------------|
}
*)

(*
$P{ Line:
Staff.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
_ForFut, R, ",2-"
_LeaveSum, R, ",2-"
_Taken, R, ",2-"
_TakeLater, R, ",2-"
_LimFinalSaldo, R, ",2-"
@
|#####|##################|############|############|#############|#############|############|
}
*)

(*
$P{ Bot:
ForFut, R, ",2-"
LeaveSum, R, ",2-"
TakenSum, R, ",2-"
TakeLater, R, ",2-"
LimFinalSaldo, R, ",2-"
TotCrd, R, ",2-"
L_DatTim.IncMonth(CurMonth, +1), L, "D.N.y"
CreSld, R, ",2-"
ForFut, R, ",2-"
TotDec, R, ",2-"
LeaveSum, R, ",2-"
TakenSum, R, ",2-"
LimFinalSaldo, R, ",2-"
RemndSum, R, ",2-"
TakeLater, R, ",2-"
ToGetSum, R, ",2-"
@
|------------------------|------------|------------|-------------|-------------|------------|
|⮣                   |############|############|#############|#############|############|
|===========================================================================================|
| ।  ...............................................################|
|  ⮬ ᫥:                                                                              |
|  ।⮢ ᠫ줮  ##########..........................................################|
|   騥 ਮ.......................................................################|
|᪫砥  ...................................................################|
|  ⮬ ᫥:                                                                              |
|  㬬  㢮 ࠡ⭨.........................................################|
|  뤠   ࢠ...........................................################|
|  襭  ⥫쭮 ᠫ줮.......................................################|
|  뤠 ⪨ 㣫..........................................################|
|  㤥 뤠 .....................................................################|
|뤠.....................................................................################|
|===========================================================================================|
|                                        |                |           ⮬ ᫥            |
|                                   |         뤠|---------------------------------|
|                                        |                |           |           |
|----------------------------------------|----------------|----------------|----------------|
}
*)

(*
$P{ Cash_Line:
Cash.Cash, L, ""
Cash.Name, L, ""
Cash_Sum[L_PDoc.pd_RKO]+Cash_Sum[L_PDoc.pd_IPP], R, ",2-"
Cash_Sum[L_PDoc.pd_RKO], R, ",2-"
Cash_Sum[L_PDoc.pd_IPP], R, ",2-"
@
|## #####################################|################|################|################|
}
*)

(*
$P{ Cash_Bot:
Total_Sum[L_PDoc.pd_RKO]+Total_Sum[L_PDoc.pd_IPP], R, ",2-"
Total_Sum[L_PDoc.pd_RKO], R, ",2-"
Total_Sum[L_PDoc.pd_IPP], R, ",2-"
@
|----------------------------------------|----------------|----------------|----------------|
|⮣                                   |################|################|################|
=(c) Polak===================================================================================
}
*)

 PRIVATE PROCEDURE _MakeMonth();
 BEGIN
  CALL(CalcDed.CountUp());
 END {_MakeMonth};

 PRIVATE PROCEDURE IsLeaveInPerOrNext(P: DATE): SCAL[2]; (*   ਮ ⥪騩  - SYSDATE- *)
 BEGIN
  RETURN ~!Staff.EndDate &
         ((L_DatTim.Per(Staff.EndDate) >= P) & (L_DatTim.Per(Staff.EndDate) <= L_DatTim.Per(SYSDATE())));
 END {IsLeaveInPerOrNext};

 PRIVATE PROCEDURE NeedTurn(): SCAL[2];
 BEGIN
  L_General.CallUs(SEARCH(Cash, Cash, L_PDoc.GetStaffCash(Memo.ud_me())));
  RETURN Cash.Turn = CurrentTurn;
 END {NeedTurn};

 PRIVATE PROCEDURE MakeOneStaff();
 BEGIN
  PROMPT(Staff.TSN);
  SETZERO(_ForFut, _Taken, _LeaveSum, _TakeLater, _LimFinalSaldo);
  IF ~L_Staff.IsBegan(CurMonth) THEN
   PROMPT(Staff.TSN + " :  ਭ");
  ELSIF !CurrentTurn | NeedTurn() THEN
   _Saldo:=L_PRoll.OutSaldoFutInc(CurMonth, L_DatTim.Per(SYSDATE()), 0);
   IF _Saldo > 0 THEN
    INC(CreSld, _Saldo);
    _ForFut:=L_PRoll.OutSaldoFutInc(CurMonth, L_DatTim.Per(SYSDATE()), 1)-_Saldo;
   ELSE
    _Saldo:=L_PRoll.OutSaldoFutInc(CurMonth, L_DatTim.Per(SYSDATE()), 1);
    IF _Saldo > 0 THEN
     _ForFut:=_Saldo;
    END;
   END;
   _Saldo:=L_PRoll.OutSaldoFutInc(CurMonth, L_DatTim.Per(SYSDATE()), NeedFutInc);
   IF _Saldo > 0 THEN
    L_PRoll.Limit_ToTake(CurMonth, _ToTake, _Taken, _Remind, NeedFutInc);
    INC(TakenSum, _Taken);
    IF ~L_Staff.IsLeaveFinally(DeadLineDate) | L_PRoll.E_IsLeaveInPaySheet(CurMonth) THEN
     INC(RemndSum, _Remind);
     IF _ToTake > 0 THEN
      IF IsLeaveInPerOrNext(CurMonth) THEN
       L_APtm.TemporarySetMemoDate(SYSDATE(), PROCREF(_MakeMonth));
       _Saldo:=L_PRoll.OutSaldoFutInc(L_DatTim.Per(SYSDATE()), L_DatTim.Per(SYSDATE()), 0);
       IF _Saldo > 0 THEN
        IF _Saldo < _ToTake THEN
         _LimFinalSaldo:=_ToTake-_Saldo;
         _ToTake:=_Saldo;
        END;
       ELSE
        _LimFinalSaldo:=_ToTake;
        _ToTake:=0;
       END;
       INC(LimFinalSaldo, _LimFinalSaldo);
      END;
      IF _ToTake > 0 THEN
       L_PDoc.AppendPDoc(_ToTake);
       IF ~PD001.Create | ~L_PDoc.AppendStaff(_ToTake, 0) THEN
        _TakeLater:=_ToTake;
        INC(TakeLater, _TakeLater);
       ELSE
        INC(ToGetSum, _ToTake);
       END;
       ADD(CashL, CashL, , L_PDoc.GetStaffCash(Memo.ud_me()), PD001.PDocKind,
                           CashL._Sum, _ToTake);
      END;
     END;
    ELSE
     PROMPT(Staff.TSN + " :  㢮");
     _LeaveSum:=_ToTake + _Remind;
     INC(LeaveSum, _LeaveSum);
    END;
   END; (* IF _Saldo > 0 ... *)
  END; (* IF ~IsBegan( ... *)
  IF NeedFutInc THEN
   INC(ForFut, _ForFut);
  ELSE
   _ForFut:=0;
  END;
  IF (_ForFut#0) | (_Taken#0) | (_LeaveSum#0) | (_TakeLater#0) | (_LimFinalSaldo#0) THEN
   CONFORM(Staff, Man);
   MAKEPART(R, Line);
  END;
 END {MakeOneStaff};

 PRIVATE PROCEDURE intMassSal();
  VAR
   ByCassa: SCAL[2];
   oPrompt: PROMPT_LINE;
 BEGIN
  CurMonth:=Memo.ud_mb();
  oPrompt:=PROMPT_LINE.Create("ନ஢   ᮢ 뤠  " + L_DatTim.PeriodStr(CurMonth) + " (" + SubTitle + ")");
  L_General.Assert(L_APtm.MonthIsClosed(CurMonth, L_APtm.system_Salary),
                   "楤 믮 ᫥  ");
 
  CALL(A_CalcDed.CountUp_LeaveOnly());
 
  ByCassa:=L_PRoll.ByCassaLev(L_PDoc.ev_MainPay);
  STDFORM(L_StdFrm.sf_Choice("|ନ஢ ⥦ 㬥" +
                             "| 뤠 ௫  " + L_DatTim.PeriodStr(CurMonth) + "  " +
                             "|" + SubTitle +
                             "|" +
                             "| :             " +
                             "|%##############################%" +
                             "||",
                             "%,2< ᯨ᪮| ᠬ>O"),
          , , , ByCassa);
 
  NeedFutInc:=L_PRoll.E_MPD_PCalc_NeedFutInc(Memo.ud_me());
 
  L_PDoc.InitPDocGroup(L_PDoc.ev_MainPay);
 
  L_AFM.MakeMultipleIndex("CashL", "_Cash    : LIKE(Cash.Cash);"+
                                   "_PDocKind: LIKE(PDoc.PDocKind);"+
                                   "_Sum     : LIKE(PDocList.Sum)",
                             "CashL: _Cash, _PDocKind");
 
  RepName   :=L_General.rfn_byMonth(cRepName, CurMonth);
  RepNameExt:=L_General.rfn_byMonth(cRepNameExt, CurMonth);
  OPENREP(Mon, RepNameExt, Create);
  OPENREP(R,   RepName, Create);
  MAKEPART(R, Top);
 
  DeadLineDate:=L_DatTim.IncMonth(CurMonth, L_PRoll.E_DeadMonthForPaySheet(CurMonth));
  SETZERO(CreSld, TakenSum, RemndSum, ToGetSum, ForFut, TotCrd, LeaveSum, TakeLater, LimFinalSaldo);
 
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   MakeOneStaff();
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 
  TotCrd:=CreSld + ForFut;
  TotDec:=LeaveSum+TakenSum+RemndSum+TakeLater+LimFinalSaldo;
 
  L_PDoc.DonePDocGroup(ByCassa);
 
  CLOSEREP(Mon);
  MAKEPART(R, Bot);
 
  SETZERO(Total_Sum);
  SELECT(CashL, CashL);
  WHILE OCCURE(CashL) DO
   SETZERO(Cash_Sum);
   CHANGESEL(CashL, CashL, , CashL._Cash);
   WHILE OCCURE(CashL) DO
    INC(Cash_Sum[CashL._PDocKind],  CashL._Sum);
    INC(Total_Sum[CashL._PDocKind], CashL._Sum);
    NEXT(CashL);
   END; (* WHILE OCCURE(CashL) ... *)
   LAST(CashL);
   L_General.Assert(SEARCH(Cash, Cash, CashL._Cash), "   "+CashL._Cash);
   MAKEPART(R, Cash_Line);
   CHANGESEL(CashL, CashL);
   NEXT(CashL);
  END; (* WHILE OCCURE(CashL) ... *)
  MAKEPART(R, Cash_Bot);
  CLOSEREP(R);
 
  L_AFM.AF_PurgeTemp("CashL");
 
  LIKEMENU(Survey, RepNameExt,
           Survey, RepName,
           Survey, L_PDoc.PDocListRepName());
 END {intMassSal};

 PUBLIC PROCEDURE MassSal();
 BEGIN
  SubTitle:=" ᥬ ࠡ⭨";
  SETEMPTY(CurrentTurn);
  intMassSal();
 END {MassSal};

 PUBLIC PROCEDURE MassSal_Turn();
 BEGIN
  L_General.Assert(ACCESS(Cash), " ⠭ ।");
  CurrentTurn:=Cash.Turn;
  SubTitle:=" । "+L_Str.IntStr(Cash.Turn);
  intMassSal();
 END {MassSal_Turn};

END.
