(*
%Copyright   (c) Polak IT
%Author      26.11.2013 19:22:10 POLAK\San
%Purpose      ਨ 뤠   ꥪ ६
%Type        operation
%Specific    SYS
%Modified    23.12.2013 16:02:12 POLAK\LDA
%Environment
*)

 MODULE MS_His [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_OwnData, L_MDoc, L_Str, L_AFM, L_MathR, L_XDoc, L_StdFrm,
        FIO, Str, L_Car, L_Stock, Memo, L_XObj, L_Dest;

 PRIVATE TYPE
  tReportMode = SCAL[3];

 PRIVATE CONST
  rm_AllMathByMDoc       = 0;
  rm_SingleMathByMDoc    = 1;
  rm_SingleMathByGasStan = 2;

(*
$P{ Msh01_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
?, C, ""
"."+Car.BoxNbr+" ᭮ "+Car.StateNbr+" ઠ "+Mark.Mark+" "+Mark.Name, L, ""
@
###################################################### ########## #####
=#####=================================================================
|#####################################################################|
|#####################################################################|
|---------------------------------------------------------------------|
|#####################################################################|
}
*)

(*
$P{ Msh01_Head:
Math.Math, L, ""
Math.Name, L, ""
@
| ##### ###########################################################|
|---------------------------------------------------------------------|
|         |      ||     ⢮|          ஡   |
|           |          |   |               |        ᫥饩 뤠|
|-----------|----------|---|---------------|--------------------------|
}
*)

(*
$P{ Msh01_Line:
L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L, ""
MDoc.Date, L, "D.N.y"
L_MathR.MModeStr(MSH01.MMode), R, ""
L_MathR.DefaultFormatCir(MSH01.Math, MSH01.Qnt), R, ""
?, R, ",0"
@
|###########|##########|###|###############|##########################|
}
*)

(*
$P{ Msh01_Bot:
@
=(c) Polak=============================================================
}
*)

(*
$P{ Msh02_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
L_MDoc.GetMDocStrNbr(), C, ""
?, C, ""
"."+Car.BoxNbr+" ᭮ "+Car.StateNbr+" ઠ "+Mark.Mark+" "+Mark.Name, C, ""
@
################################################################################################# ########## #####
=#####============================================================================================================
|################################################################################################################|
|################################################################################################################|
|################################################################################################################|
|----------------------------------------------------------------------------------------------------------------|
|                                          |         |      ||       ⢮|     ஡   |
|---------------------------------------------|-----------|----------|---|-----------------|---------------------|
}
*)

(*
$P{ Msh02_Line:
Math.Math, L, ""
Math.Name, L, ""
L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L, ""
MDoc.Date, L, "D.N.y"
L_MathR.MModeStr(MSH01.MMode), R, ""
L_MathR.DefaultFormatCir(MSH01.Math, MSH01.Qnt), R, ""
L_MathR.DefaultMUnitSign(MSH01.Math), L, ""
MSH01.Run, R, ",0"
@
|##### #######################################|###########|##########|###|############# ###|#####################|
}
*)

(*
$P{ Msh02_Bot:
@
=(c) Polak========================================================================================================
}
*)

 PRIVATE PROCEDURE Create_MSH01();
 BEGIN
  L_AFM.MakeMultipleIndex("MSH01", "Math   : LIKE(Math.Math);" +
                                   "Date   : DATE;" +
                                   "DoneDTS: LIKE(MDoc.DoneDTS);"+
                                   "MMode  : LIKE(MMode.MMode);"+
                                   "MDRI   : LIKE(MDoc.RECORDID);"+
                                   "Qnt    : LIKE(MDocList.Qnt);"+
                                   "Run    : NUMERIC[0]",
                            "MSH01: Math, Date, DoneDTS, MMode, MDRI");
 END {Create_MSH01};

 PRIVATE PROCEDURE Add2MSH01(trgBoxNbr: LIKE(Car.BoxNbr); D: DATE);
  VAR
   trgRun: NUMERIC[0];
 BEGIN
  IF ~SEARCH(MSH01, MSH01, MDocList.Math, MDoc.Date, MDoc.DoneDTS, MDocList.MMode, MDoc.RECORDID) THEN
   trgRun:=L_Car.GetAccurateRunInPer(trgBoxNbr, MDoc.Date, D);
  ELSE
   trgRun:=0;
  END;
  (*ᯥࢠ SEARCH  IF ~ADD() + REPLACE ⮬  GetAccurateRunInPe   ࢠ  Esc   MSH01 ⠭  23.12.2013 13:16:02 POLAK\Bor 0100986*)
  ADD(MSH01, MSH01, , MDocList.Math, MDoc.Date, MDoc.DoneDTS, MDocList.MMode, MDoc.RECORDID,
                      MSH01.Qnt, MDocList.Qnt,
                      MSH01.Run, trgRun);
 END {Add2MSH01};

 PRIVATE PROCEDURE Gather(trgBoxNbr : LIKE(Car.BoxNbr);
                          trgMaths  : STRING[];
                          curDate   : DATE;
                          curDoneDTS: LIKE(MDoc.DoneDTS);
                          ReportMode: tReportMode);
  VAR
   l        : NUMERIC[0];
   Tlt      : STRING[];
   doIt     : SCAL[2];
   prvRun   : NUMERIC[0];
   dmyDest  : LIKE(Dest.Dest);
   FoundCnt : NUMERIC[0];
   PromptTxt: STRING[];
   trgXDocId: L_XDoc.tXDocId;
 BEGIN
  Create_MSH01();
  dmyDest:=L_Dest.erkn_GetSoft(SYSDATE(), L_Dest.erkn_FuelStationMovement);
  FoundCnt:=0;

  TRY [TERM_BY_USER(TERM_BY_USER_THROW), RESTORE_CURSORS(RC_ON)]
   SELECT(MDoc, BoxNbr, , trgBoxNbr);
   LAST(MDoc);
   WHILE OCCURE(MDoc) & ~!trgMaths DO
    IF (MDoc.Date < curDate) | (MDoc.DoneDTS < curDoneDTS) THEN
     IF (MDoc.Status # L_MDoc.st_Canceled) & (MDoc.Dest # dmyDest) THEN
      doIt:=(MDoc.MDocKind = L_MDoc.md_NOV) | (MDoc.MDocKind = L_MDoc.md_ViP);
      IF ~doIt THEN
       trgXDocId:=L_XDoc.GetSingleRefToXDocId(MDoc.XDocId);
       IF ~!trgXDocId & (L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_RprS) THEN
        L_XDoc.PositionOnXDoc(trgXDocId);
        IF ~RprS.Closed THEN
         doIt:=(MDoc.MDocKind = L_MDoc.md_MSP);
        END;
       END;
      END;
      IF doIt THEN
       PromptTxt:=L_DatTim.DateStr(MDoc.Date);
       IF ReportMode # rm_AllMathByMDoc THEN
        INC(PromptTxt, "  : "+L_Str.IntStr(FoundCnt)+".  ⠭  Esc.");
       END;
       PROMPT(PromptTxt);
       l:=Str.Length(trgMaths);
       SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
       WHILE OCCURE(MDocList) DO
        IF Str.Pos(trgMaths, MDocList.Math) < l THEN
         Add2MSH01(MDoc.BoxNbr, curDate);
         IF ReportMode = rm_AllMathByMDoc THEN
          trgMaths:=Str.Delete(trgMaths, Str.Pos(trgMaths, MDocList.Math), Str.Length(MDocList.Math)+1);
         ELSE
          INC(FoundCnt);
         END;
        END;
        NEXT(MDocList);
       END; (* WHILE OCCURE(MDocList) ... *)
      END; (* IF doIt *)
     END; (* IF MDoc.Status ... *)
    END; (* IF (MDoc.Date < curDate) | (MDoc.DoneDTS < curDoneDTS) ... *)
    PREV(MDoc);
   END; (* WHILE OCCURE(MDoc) ... *)
  EXCEPT
  ON Exc: Exc_TermByUser DO
   IF ReportMode = rm_AllMathByMDoc THEN
    RAISE();
   END;
  END;
 END {Gather};

 PRIVATE PROCEDURE Print(RepName   : STRING[];
                         RepTitle  : STRING[];
                         trgBoxNbr : LIKE(Car.BoxNbr);
                         curDate   : DATE;
                         ReportMode: tReportMode);
  VAR
   prvRun: NUMERIC[0];
 BEGIN
  SEARCH(Car, BoxNbr, , trgBoxNbr);
  L_Car.AccessMark(Car.BoxNbr, curDate);
  L_XDoc.sl_Init("    "+Car.BoxNbr);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF    ReportMode = rm_SingleMathByMDoc THEN
   MAKEPART(R, Msh01_Top, RepName, L_MDoc.GetMDocStrNbr(), RepTitle);
  ELSIF ReportMode = rm_AllMathByMDoc THEN
   MAKEPART(R, Msh02_Top, RepName, RepTitle);
  ELSIF ReportMode = rm_SingleMathByGasStan THEN
   MAKEPART(R, Msh01_Top, RepName, RepTitle, "");
  ELSE
   L_General.CallUs(0);
  END;

  SELECT(MSH01, MSH01);
  WHILE OCCURE(MSH01) DO
   SEARCH(Math, Math, , MSH01.Math);
   IF ReportMode # rm_AllMathByMDoc THEN
    MAKEPART(R, Msh01_Head);
   END;
   prvRun:=0;
   NARROWSEL(MSH01, Math);
   LAST(MSH01);
   WHILE OCCURE(MSH01) DO
    SEARCH(MDoc, RECORDID, , MSH01.MDRI);
    IF ReportMode = rm_AllMathByMDoc THEN
     MAKEPART(R, Msh02_Line);
    ELSE
     MAKEPART(R, Msh01_Line, MSH01.Run-prvRun);
    END; (* IF IF ReportMode = rm_AllMathByMDoc... *)
    L_XDoc.sl_AddItem(MDoc.XDocId, L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+"  "+L_DatTim.DateStr(MDoc.Date)
                                   + " " + Str.Align(L_MathR.DefaultFormatCir(MSH01.Math, MSH01.Qnt), 15, RIGHT));
    prvRun:=MSH01.Run;
    PREV(MSH01);
   END; (* WHILE OCCURE(MSH01) *)
   NEXTINEXTENDEDSEL(MSH01, Math);
  END; (* WHILE OCCURE(MSH01) ... *)
  IF ReportMode = rm_AllMathByMDoc THEN
   MAKEPART(R, Msh02_Bot);
  ELSE
   MAKEPART(R, Msh01_Bot);
  END;
  CLOSEREP(R);
  L_XDoc.sl_Done();
 END {Print};

 PUBLIC PROCEDURE MakeMsh(trgBoxNbr : LIKE(Car.BoxNbr);
                          trgMaths  : STRING[];
                          curDate   : DATE;
                          curDoneDTS: LIKE(MDoc.DoneDTS);
                          ReportMode: tReportMode;
                          RepName   : STRING[];
                          RepTitle  : STRING[]);
 BEGIN
  Gather(trgBoxNbr, trgMaths, curDate, curDoneDTS, ReportMode);
  Print(RepName, RepTitle, trgBoxNbr, curDate, ReportMode);
 END {MakeMsh};

 PUBLIC PROCEDURE Msh01();
 BEGIN
  ACCESS(MDocList);
  CONFORM(MDocList, MDoc);
  L_General.Assert(~!MDoc.BoxNbr, " ⥪饬   । ࠦ  ");
  MakeMsh(MDoc.BoxNbr, MDocList.Math, MDoc.Date, MDoc.DoneDTS, rm_SingleMathByMDoc, "Msh01", " 뤠   ");
 END {Msh01};

 PUBLIC PROCEDURE Msh02();
  VAR
   MathList: STRING[];
 BEGIN
  ACCESS(MDoc);
  L_General.Assert(~!MDoc.BoxNbr, " ⥪饬   । ࠦ  ");
  MathList:="";
  SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(MDocList) DO
   INC(MathList, MDocList.Math + "|");
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  MakeMsh(MDoc.BoxNbr, MathList, MDoc.Date, MDoc.DoneDTS, rm_AllMathByMDoc, "Msh02", "। 뤠   ");
 END {Msh02};

END.
