(*
%Copyright   (c) Polak Computer System
%Author      08.01.2002 20:28:11 GAV
%Type        report
%Specific    SYS
%Modified    09.11.2012 16:55:37 POLAK\Bor
%Environment
*)

 IMPORT Memo, L_General, Str, L_Acnt, L_DatTim, D_XObj, L_AFM, L_Str, L_XObj, L_AcCut, P_Firm;

 TYPE
  tViewType = SCAL[4];

 CONST
  vt_SAcnt_CAcnt = 0;
  vt_CAcnt_AcCut = 1;
  vt_AcCut_AcCut = 2;
  vt_CAcnt_SAcnt = 3;
  vt_Pool = " ⠬| ᯮ| ࠧ१|  ";

 PRIVATE PROCEDURE FRepName(D:DATE; RepName: STRING[]): STRING[];
 BEGIN
  IF Str.Length(RepName) = 3 THEN
   RETURN L_General.rfn_byMonth(RepName, D);
  ELSE
   RETURN L_General.NameConnection(RepName);
  END;
 END {FRepName};

 PRIVATE PROCEDURE SubTitle(XCC: D_XObj.XCContentType): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF    XCC = D_XObj.XCC_FullMath THEN
   Result:=" ਠ 業";
  ELSIF XCC = D_XObj.XCC_SingleMathType THEN
   Result:=MathType.MathType+" "+MathType.Name;
  ELSIF XCC = D_XObj.XCC_SingleMath THEN
   Result:=Math.Math+" "+Math.Name;
  ELSIF XCC = D_XObj.XCC_SingleAcCut THEN
   Result:=AcCut.AcCut+" "+AcCut.Name;
  ELSIF XCC = D_XObj.XCC_FullKA THEN
   Result:=" ᭮ ।⢠";
  ELSIF XCC = D_XObj.XCC_FP_Math THEN
   Result:="    楢";
  ELSIF XCC = D_XObj.XCC_SingleStorage THEN
   Result:=Storage.Storage+" "+Storage.Name;
  ELSIF XCC = D_XObj.XCC_SingleDeprecT  THEN
   Result:=DeprecT.DeprecT+" "+DeprecT.Name;
  ELSIF XCC = D_XObj.XCC_FP_KA THEN
   Result:="   楢";
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {SubTitle};

 PRIVATE PROCEDURE _MC2(XCC: D_XObj.XCContentType; Qnt: L_XObj.tQnt): STRING[];
 BEGIN
  IF XCC = D_XObj.XCC_SingleMath THEN
   RETURN FLDTOSTR(Qnt, "3.");
  ELSE
   RETURN " ";
  END;
 END {_SingleMath};

(*
$P{ Top:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
?, C, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|############################################################################|
|############################################################################|
}
*)

(*
$P{ CutHead:
MCX.Cut + " " + MCX.CutName, L, ""
@
|----------------------------------------------------------------------------|
|############################################################################|
}
*)

(*
$P{ SaldoTop:
?, L, "D.N.y"
?, L, ""
?, R, ""
?, R, ",2-"
@
|                                                                            |
|줮  ########## #################           ########## ################|
}
*)

(*
$P{ SaldoBot:
?, L, ""
?, R, ""
?, R, ",2-"
@
|                     #################           ########## ################|
}
*)

(*
$P{ Cir:
?, L, ""
?, R, ""
?, R, ",2-"
@
|                                                                            |
|  #######                               ########## ################|
}
*)

(*
$P{ Line:
MAX.Cut2 + " " + MAX.Cut2Name, L, ""
?, R, ""
MAX.Sum, R, ",2-"
@
| ############################################### ########## ################|
}
*)

(*
$P{ Bot:
@
=(C) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Create_MCX();
 BEGIN
  CreateFILE(MCX, "", " 楢  ꥪ⮢   ਮ", "");

  CreateFIELD(MCX, MyFirm,  P_Firm.tMyFirm,                 "", "",  "", " ࣠",    "");
  CreateFIELD(MCX, Cut,     STRING[32],                     "", "",  "", " ࠧ१",    "");
  CreateFIELD(MCX, CutName, STRING[48],                     "", "",  "", " ⭮ ࠧ१",    "");
  CreateFIELD(MCX, Sum, L_Acnt.tUnfoldedAcntVector,         "", "0", "", " 㬬", "");
  CreateFIELD(MCX, Qnt, L_Acnt.tUnfoldedAcntQuantityVector, "", "0", "", " ", "");

  CreateINDEX(MCX, Cut, UNIQUE, " ࠧ१", "", MyFirm, Cut);

  SetVersionOfFILE(MCX, 0000);
 END {Create_MCX};

 PRIVATE PROCEDURE Create_MAX();
 BEGIN
  CreateFILE(MAX, "", "   ꥪ⠬   ਮ", "");

  CreateFIELD(MAX, MyFirm,  P_Firm.tMyFirm,                 "", "",  "", " ࣠",    "");
  CreateFIELD(MAX, Cut,      STRING[32],           "", "",  "", " ࠧ१",   "");
  CreateFIELD(MAX, CirType,  LIKE(Apport.CirType), "", "",  "", "/।",         "");
  CreateFIELD(MAX, Cut2,     STRING[32],           "", "",  "", " ࠧ१",   "");
  CreateFIELD(MAX, Cut2Name, STRING[48],           "", "",  "", " ࠧ१",   "");
  CreateFIELD(MAX, Sum,      L_XObj.tSum,          "", "0", "", "稭 , 㬬", "");
  CreateFIELD(MAX, Qnt,      L_XObj.tQnt,          "", "0", "", "稭 , ⢮", "");

  CreateINDEX(MAX, Cut, UNIQUE, "", "", MyFirm, Cut, CirType, Cut2);

  SetVersionOfFILE(MAX, 0000);
 END {Create_MAX};

 PRIVATE PROCEDURE GetSAcntName(VAR _Name:STRING[]): STRING[];
  VAR _Sign:STRING[];
 BEGIN
  _Sign:=Str.Item(CAcnt.Sign, ".-/", 0);
  IF SELECT(CAcnt, Sign, _Sign) THEN
   _Name:=CAcnt.Name;
  ELSE
   _Name:="";
  END;
  RETURN _Sign;
 END {GetSAcntName};

 PRIVATE PROCEDURE PrepareMCX(VT: tViewType);
  VAR
   _Cut,
   _Cut2,
   _CutName,
   _Cut2Name : STRING[];
   _MyFirm   : P_Firm.tMyFirm;
 BEGIN
  Create_MCX();
  L_AFM.CreateTemp("MCX");
  Create_MAX();
  L_AFM.CreateTemp("MAX");
  SELECT(XC001, Cut1);
  WHILE OCCURE(XC001) DO
   PROMPT(XC001.Cut1);
   L_XObj.AccessXObject(XC001.Object);
   _MyFirm:=XObject.MyFirm;
   SETEMPTY(_Cut, _CutName);
   IF    (VT = vt_CAcnt_AcCut) | (VT = vt_CAcnt_SAcnt) THEN
    L_Acnt.StandOnCAcnt(Memo.ud_ut(), XC001.Cut1);
    _Cut    :=" " + CAcnt.Sign;
    _CutName:=CAcnt.Name;
   ELSIF VT = vt_AcCut_AcCut THEN
    SEARCH(AcCut, AcCut, , XC001.Cut1);
    _Cut    :="१ "+ L_Acnt.GetAcCutSign(Memo.ud_ut(), AcCut.AcCut) + "(" + AcCut.AcCut + ")";
    _CutName:=AcCut.Name;
   ELSIF VT = vt_SAcnt_CAcnt THEN
    L_Acnt.StandOnCAcnt(Memo.ud_ut(), XC001.Cut1);
    _Cut:=" " + GetSAcntName(_CutName);
   ELSE
    L_General.CallUs(0);
   END;
   IF ~ADD(MCX, Cut, _MyFirm, _Cut,
            MCX.Sum[L_Acnt.uavp_ISlDbt], XC001.uav_aSum[L_Acnt.uavp_ISlDbt],
            MCX.Sum[L_Acnt.uavp_ISlCrd], XC001.uav_aSum[L_Acnt.uavp_ISlCrd],
            MCX.Sum[L_Acnt.uavp_CirDbt], XC001.uav_aSum[L_Acnt.uavp_CirDbt],
            MCX.Sum[L_Acnt.uavp_CirCrd], XC001.uav_aSum[L_Acnt.uavp_CirCrd],
            MCX.Sum[L_Acnt.uavp_OSlDbt], XC001.uav_aSum[L_Acnt.uavp_OSlDbt],
            MCX.Sum[L_Acnt.uavp_OSlCrd], XC001.uav_aSum[L_Acnt.uavp_OSlCrd],
            MCX.Qnt[L_Acnt.uavp_ISlDbt], XC001.uav_aQnt[L_Acnt.uavp_ISlDbt],
            MCX.Qnt[L_Acnt.uavp_ISlCrd], XC001.uav_aQnt[L_Acnt.uavp_ISlCrd],
            MCX.Qnt[L_Acnt.uavp_CirDbt], XC001.uav_aQnt[L_Acnt.uavp_CirDbt],
            MCX.Qnt[L_Acnt.uavp_CirCrd], XC001.uav_aQnt[L_Acnt.uavp_CirCrd],
            MCX.Qnt[L_Acnt.uavp_OSlDbt], XC001.uav_aQnt[L_Acnt.uavp_OSlDbt],
            MCX.Qnt[L_Acnt.uavp_OSlCrd], XC001.uav_aQnt[L_Acnt.uavp_OSlCrd]) THEN
    MCX.CutName:=_CutName;
    REPLACE(MCX);
   END;
 
   SELECT(XA001, mfObject, , XC001.MyFirm, XC001.Object, XC001.Cut1);
   WHILE OCCURE(XA001) DO
    L_Acnt.StandOnCAcnt(Memo.ud_ut(), XA001.Cut2);
    IF    (VT = vt_AcCut_AcCut) | (VT = vt_CAcnt_AcCut) THEN
     SEARCH(AcCut2, AcCut2, , XA001.Cut2);
     _Cut2:=Str.Align(L_Acnt.GetAcCutSign(Memo.ud_ut(), AcCut2.AcCut2), Str.MaxLength(AcCut.Sign), LEFT) +
            "(" + AcCut2.AcCut2 + ")";
     _Cut2Name:=AcCut2.Name;
    ELSIF VT = vt_SAcnt_CAcnt THEN
     _Cut2:=Str.Align(CAcnt.Sign, Str.MaxLength(CAcnt.Sign), LEFT);
     _Cut2Name:=CAcnt.Name;
    ELSIF VT = vt_CAcnt_SAcnt THEN
     _Cut2:=GetSAcntName(_Cut2Name);
    ELSE
     L_General.CallUs(0);
    END;
    IF ~ADD(MAX, Cut, _MyFirm, MCX.Cut, XA001.CirType, _Cut2,
             MAX.Sum, XA001.Sum,
             MAX.Qnt, XA001.Qnt) THEN
     MAX.Cut2Name:=_Cut2Name;
     REPLACE(MAX);
    END;
    NEXT(XA001);
   END; (* WHILE OCCURE(XA001) ... *)
   NEXT(XC001);
  END; (* WHILE OCCURE(XC001) ... *)
 END {PrepareMCX};

 PRIVATE PROCEDURE PurgeMCX();
 BEGIN
  L_AFM.AF_PurgeTemp("MCX");
  L_AFM.AF_PurgeTemp("MAX");
 END {PurgeMCX};

 PRIVATE PROCEDURE PrintByCirType(XCC: D_XObj.XCContentType; CT: LIKE(Apport.CirType));
 BEGIN
  SELECT(MAX, Cut, , MCX.MyFirm, MCX.Cut, CT);
  WHILE OCCURE(MAX) DO
   IF (MAX.Sum # 0) | (MAX.Qnt # 0) THEN
    MAKEPART(R, Line, _MC2(XCC, MAX.Qnt));
   END;
   NEXT(MAX);
  END; (* WHILE OCCURE(MAX) ... *)
 END {PrintByCirType};

 PRIVATE PROCEDURE NeedDtlSaldo(XCC: D_XObj.XCContentType): SCAL[2];
 BEGIN
  IF XCC = D_XObj.XCC_SingleAcCut THEN
   RETURN AcCut.SldType = L_AcCut.sldt_DebitCredit;
  ELSE
   RETURN 0;
  END;
 END {NeedDtlSaldo};

 PRIVATE PROCEDURE MakeRep(RepName: STRING[]; XCC: D_XObj.XCContentType; VT: tViewType; AK: L_Acnt.tAccountingKind);
  VAR
   trgMyFirm: LIKE(MyFirm.MyFirm);
   trgOM    : L_XObj.tOriginsMap;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt(RepName);
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());

  L_XObj.SetupOrigins(XCC = D_XObj.XCC_SingleAcCut, trgOM, trgMyFirm);
  D_XObj.PointwiseBuildXC001(XCC,
                             EMPTYOF(L_XObj.tSection),
                             AK,
                             trgOM,
                             trgMyFirm,
                             D_XObj.XST_ByXObj,
                             D_XObj.XST_ByAcCut,
                             D_XObj.XST_ByAcCut2);
  PrepareMCX(VT);
 
  OPENREP(R, FRepName(Memo.ud_fr(), RepName), Create);
  SELECT(MCX, Cut);
  WHILE OCCURE(MCX) DO
   NARROWSEL(MCX, MyFirm);
   MAKEPART(R, Top, P_Firm.MyFirmName(MCX.MyFirm, Memo.ud_ut()),
                    RepName+"=====",
                    " 壠᪨ ஢ "+L_Str.PoolItem(vt_Pool, VT),
                    L_Str.PoolItem("  ਠ 業⥩| ⭮ ࠧ१", XCC = D_XObj.XCC_SingleAcCut)+" "+
                    L_Str.PoolItem(" ਮ| ਮ", AK)+
                    "  "+L_DatTim.DateStr(Memo.ud_fr())+"  "+L_DatTim.DateStr(Memo.ud_ut()),
                    SubTitle(XCC)+". "+L_XObj.GetOriginsStr(trgOM, trgMyFirm));
   WHILE OCCURE(MCX) DO
    MAKEPART(R, CutHead);
    IF NeedDtlSaldo(XCC) THEN
     MAKEPART(R, SaldoTop, Memo.ud_fr(), "",  _MC2(XCC, MCX.Qnt[L_Acnt.uavp_ISlDbt]), MCX.Sum[L_Acnt.uavp_ISlDbt]);
     MAKEPART(R, SaldoBot,               "।", _MC2(XCC, MCX.Qnt[L_Acnt.uavp_ISlCrd]), MCX.Sum[L_Acnt.uavp_ISlCrd]);
    ELSE
     MAKEPART(R, SaldoTop, Memo.ud_fr(), "",       _MC2(XCC, MCX.Qnt[L_Acnt.uavp_ISlDbt] - MCX.Qnt[L_Acnt.uavp_ISlCrd]),
                                                   MCX.Sum[L_Acnt.uavp_ISlDbt] - MCX.Sum[L_Acnt.uavp_ISlCrd]);
    END;
    MAKEPART(R, Cir, "",  _MC2(XCC, MCX.Qnt[L_Acnt.uavp_CirDbt]), MCX.Sum[L_Acnt.uavp_CirDbt]);
    PrintByCirType(XCC, L_Acnt.ct_Debit);
    MAKEPART(R, Cir, "।", _MC2(XCC, MCX.Qnt[L_Acnt.uavp_CirCrd]), MCX.Sum[L_Acnt.uavp_CirCrd]);
    PrintByCirType(XCC, L_Acnt.ct_Credit);
    IF NeedDtlSaldo(XCC) THEN
     MAKEPART(R, SaldoTop, Memo.ud_ut()+1, "",  _MC2(XCC, MCX.Qnt[L_Acnt.uavp_OSlDbt]), MCX.Sum[L_Acnt.uavp_OSlDbt]);
     MAKEPART(R, SaldoBot,                 "।", _MC2(XCC, MCX.Qnt[L_Acnt.uavp_OSlCrd]), MCX.Sum[L_Acnt.uavp_OSlCrd]);
    ELSE
     MAKEPART(R, SaldoTop, Memo.ud_ut()+1, "",       _MC2(XCC, MCX.Qnt[L_Acnt.uavp_OSlDbt] - MCX.Qnt[L_Acnt.uavp_OSlCrd]),
                                                     MCX.Sum[L_Acnt.uavp_OSlDbt] - MCX.Sum[L_Acnt.uavp_OSlCrd]);
    END;
    NEXT(MCX);
   END; (* WHILE OCCURE(MCX) ... *)
   MAKEPART(R, Bot);
   NEXTINEXTENDEDSEL(MCX, MyFirm);
  END;
  D_XObj.PurgeXC001();
  PurgeMCX();
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MakeRep};

 PUBLIC PROCEDURE MSM02();
 BEGIN
  MakeRep("MSM02", D_XObj.XCC_SingleMath, vt_SAcnt_CAcnt, L_Acnt.ak_Acn);
 END {MSM02};

 PUBLIC PROCEDURE MSM12();
 BEGIN
  MakeRep("MSM12", D_XObj.XCC_SingleMath, vt_CAcnt_AcCut, L_Acnt.ak_Acn);
 END {MSM12};

 PUBLIC PROCEDURE MSM22();
 BEGIN
  MakeRep("MSM22", D_XObj.XCC_SingleMath, vt_AcCut_AcCut, L_Acnt.ak_Acn);
 END {MSM22};

 PUBLIC PROCEDURE MST02();
 BEGIN
  MakeRep("MST02", D_XObj.XCC_SingleMath, vt_SAcnt_CAcnt, L_Acnt.ak_Tax);
 END {MST02};

 PUBLIC PROCEDURE MST12();
 BEGIN
  MakeRep("MST12", D_XObj.XCC_SingleMath, vt_CAcnt_AcCut, L_Acnt.ak_Tax);
 END {MST12};

 PUBLIC PROCEDURE MST22();
 BEGIN
  MakeRep("MST22", D_XObj.XCC_SingleMath, vt_AcCut_AcCut, L_Acnt.ak_Tax);
 END {MST22};

 PUBLIC PROCEDURE MSM06();
 BEGIN
  MakeRep("MSM06", D_XObj.XCC_SingleStorage, vt_SAcnt_CAcnt, L_Acnt.ak_Acn);
 END {MSM06};

 PUBLIC PROCEDURE MSM16();
 BEGIN
  MakeRep("MSM16", D_XObj.XCC_SingleStorage, vt_CAcnt_AcCut, L_Acnt.ak_Acn);
 END {MSM16};

 PUBLIC PROCEDURE MSM26();
 BEGIN
  MakeRep("MSM26", D_XObj.XCC_SingleStorage, vt_AcCut_AcCut, L_Acnt.ak_Acn);
 END {MSM26};

 PUBLIC PROCEDURE MS0();
 BEGIN
  MakeRep("MS0", D_XObj.XCC_FullMath, vt_SAcnt_CAcnt, L_Acnt.ak_Acn);
 END {MS0};

 PUBLIC PROCEDURE MS1();
 BEGIN
  MakeRep("MS1", D_XObj.XCC_FullMath, vt_CAcnt_AcCut, L_Acnt.ak_Acn);
 END {MS1};

 PUBLIC PROCEDURE MS2();
 BEGIN
  MakeRep("MS2", D_XObj.XCC_FullMath, vt_AcCut_AcCut, L_Acnt.ak_Acn);
 END {MS2};

 PUBLIC PROCEDURE MS3();
 BEGIN
  MakeRep("MS3", D_XObj.XCC_FullMath, vt_CAcnt_SAcnt, L_Acnt.ak_Acn);
 END {MS3};

 PUBLIC PROCEDURE MSM05();
 BEGIN
  MakeRep("MSM05", D_XObj.XCC_FP_Math, vt_SAcnt_CAcnt, L_Acnt.ak_Acn);
 END {MSM05};

 PUBLIC PROCEDURE MSM15();
 BEGIN
  MakeRep("MSM15", D_XObj.XCC_FP_Math, vt_CAcnt_AcCut, L_Acnt.ak_Acn);
 END {MSM15};

 PUBLIC PROCEDURE MSM25();
 BEGIN
  MakeRep("MSM25", D_XObj.XCC_FP_Math, vt_AcCut_AcCut, L_Acnt.ak_Acn);
 END {MSM25};

 PUBLIC PROCEDURE MST00();
 BEGIN
  MakeRep("MST00", D_XObj.XCC_FullMath, vt_SAcnt_CAcnt, L_Acnt.ak_Tax);
 END {MST00};

 PUBLIC PROCEDURE MST10();
 BEGIN
  MakeRep("MST10", D_XObj.XCC_FullMath, vt_CAcnt_AcCut, L_Acnt.ak_Tax);
 END {MST10};

 PUBLIC PROCEDURE MST20();
 BEGIN
  MakeRep("MST20", D_XObj.XCC_FullMath, vt_AcCut_AcCut, L_Acnt.ak_Tax);
 END {MST20};

 PUBLIC PROCEDURE AS0();
 BEGIN
  MakeRep("AS0", D_XObj.XCC_FullKA, vt_SAcnt_CAcnt, L_Acnt.ak_Acn);
 END {AS0};

 PUBLIC PROCEDURE AS1();
 BEGIN
  MakeRep("AS1", D_XObj.XCC_FullKA, vt_CAcnt_AcCut, L_Acnt.ak_Acn);
 END {AS1};

 PUBLIC PROCEDURE AS2();
 BEGIN
  MakeRep("AS2", D_XObj.XCC_FullKA, vt_AcCut_AcCut, L_Acnt.ak_Acn);
 END {AS2};

 PUBLIC PROCEDURE AS3();
 BEGIN
  MakeRep("AS3", D_XObj.XCC_FullKA, vt_CAcnt_SAcnt, L_Acnt.ak_Acn);
 END {AS3};

 PUBLIC PROCEDURE MSM08();
 BEGIN
  MakeRep("MSM08", D_XObj.XCC_FP_KA, vt_SAcnt_CAcnt, L_Acnt.ak_Acn);
 END {MSM08};

 PUBLIC PROCEDURE MSM18();
 BEGIN
  MakeRep("MSM18", D_XObj.XCC_FP_KA, vt_CAcnt_AcCut, L_Acnt.ak_Acn);
 END {MSM18};

 PUBLIC PROCEDURE MSM28();
 BEGIN
  MakeRep("MSM28", D_XObj.XCC_FP_KA, vt_AcCut_AcCut, L_Acnt.ak_Acn);
 END {MSM28};

 PUBLIC PROCEDURE MST04();
 BEGIN
  MakeRep("MST04", D_XObj.XCC_FullKA, vt_SAcnt_CAcnt, L_Acnt.ak_Tax);
 END {MST04};

 PUBLIC PROCEDURE MST14();
 BEGIN
  MakeRep("MST14", D_XObj.XCC_FullKA, vt_CAcnt_AcCut, L_Acnt.ak_Tax);
 END {MST14};

 PUBLIC PROCEDURE MST24();
 BEGIN
  MakeRep("MST24", D_XObj.XCC_FullKA, vt_AcCut_AcCut, L_Acnt.ak_Tax);
 END {MST24};

 PUBLIC PROCEDURE MSM01();
 BEGIN
  MakeRep("MSM01", D_XObj.XCC_SingleMathType, vt_SAcnt_CAcnt, L_Acnt.ak_Acn);
 END {MSM01};

 PUBLIC PROCEDURE MSM11();
 BEGIN
  MakeRep("MSM11", D_XObj.XCC_SingleMathType, vt_CAcnt_AcCut, L_Acnt.ak_Acn);
 END {MSM11};

 PUBLIC PROCEDURE MSM21();
 BEGIN
  MakeRep("MSM21", D_XObj.XCC_SingleMathType, vt_AcCut_AcCut, L_Acnt.ak_Acn);
 END {MSM21};

 PUBLIC PROCEDURE MSM07();
 BEGIN
  MakeRep("MSM07", D_XObj.XCC_SingleDeprecT, vt_SAcnt_CAcnt, L_Acnt.ak_Acn);
 END {MSM07};

 PUBLIC PROCEDURE MSM17();
 BEGIN
  MakeRep("MSM17", D_XObj.XCC_SingleDeprecT, vt_CAcnt_AcCut, L_Acnt.ak_Acn);
 END {MSM17};

 PUBLIC PROCEDURE MSM27();
 BEGIN
  MakeRep("MSM27", D_XObj.XCC_SingleDeprecT, vt_AcCut_AcCut, L_Acnt.ak_Acn);
 END {MSM27};

 PUBLIC PROCEDURE MSM03();
 BEGIN
  MakeRep("MSM03", D_XObj.XCC_SingleAcCut, vt_SAcnt_CAcnt, L_Acnt.ak_Acn);
 END {MSM03};

 PUBLIC PROCEDURE MSM23();
 BEGIN
  MakeRep("MSM23", D_XObj.XCC_SingleAcCut, vt_AcCut_AcCut, L_Acnt.ak_Acn);
 END {MSM23};

 PUBLIC PROCEDURE MST03();
 BEGIN
  MakeRep("MST03", D_XObj.XCC_SingleAcCut, vt_SAcnt_CAcnt, L_Acnt.ak_Tax);
 END {MST03};

 PUBLIC PROCEDURE MST23();
 BEGIN
  MakeRep("MST23", D_XObj.XCC_SingleAcCut, vt_AcCut_AcCut, L_Acnt.ak_Tax);
 END {MST23};

END.
