(*
%Copyright   (c) Polak Computer System
%Author      21.08.2001 19:43:50 RSN
%Purpose        . 業⥩  
%Type        report
%Specific    SYS
%Modified    23.04.2013 16:51:08 POLAK\MLB
%Environment
*)

 IMPORT L_Staff, L_OwnData, L_Str, L_General, Str, L_Basis, FIO,
        L_DatTim, L_Env, L_MathR, L_XObj, D_XObj, Memo;

 CONST
  RMNum = 12;

 TYPE
  tContentType = SCAL[RMNum];
  tViewType    = SCAL[3];

 CONST
  ct_allMathMove      =  1;
  ct_curMathMove      =  2;
  ct_curSortMove      =  3;
  ct_allMathDebet     =  5;
  ct_curTSNMove       =  6;
  ct_allTsnByMathMove =  7;
  ct_allMathCredit    =  8;
  ct_curMathRest      =  9;
  ct_allMathRestExcel = 10;
  ct_allMathMoveExcel = 11;

  vt_Move  = 0;
  vt_Rest  = 1;
  vt_InOut = 2;

 VAR
  _ContentType : tContentType;
  _ViewType    : tViewType;

  _XST_Cut1 : D_XObj.XCSortType;
  Top2Name,
  SubTitle  : STRING[];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName(), L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
SubTitle, C, ""
@
######################################################################################                                                                             ########## #####
=#####=============================================================================================================================================================================
|                                                          ਠ 業⥩  ਮ  ##########  ##########                                                    |
|#################################################################################################################################################################################|
}
*)

(*
$P{ Top1:
?, R, ""
?, L, ""
@
|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| ꥪ⮢ ###### #############################################################################################################################################################|
}
*)

(*
$P{ Top2:
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut() + 1, L, "D.N.y"
?, L, ""
@
|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|                                                 |      줮  ##########     |                          |             ।            |      줮  ##########     |
|#################################################|-------------------------------|-------------------------------|-------------------------------|-------------------------------|
|                                                 |      -|             㬬|      -|             㬬|      -|             㬬|      -|             㬬|
|-------------------------------------------------|------------|------------------|------------|------------------|------------|------------------|------------|------------------|
}
*)

(*
$P{ Line1:
?, L, ""
?, L, ""
?, R, "2."
?, R, ",2-"
?, R, "2."
?, R, ",2-"
?, R, "2."
?, R, ",2-"
?, R, "2."
?, R, ",2-"
@
|   ##### ########################################|############|##################|############|##################|############|##################|############|##################|
}
*)

(*
$P{ Cut3Line:
?, L, ""
?, L, ""
@
|##### ###########################################|            |                  |            |                  |            |                  |            |                  |
}
*)

(*
$P{ Tot1:
?, R, "2."
?, R, ",2-"
?, R, "2."
?, R, ",2-"
?, R, "2."
?, R, ",2-"
?, R, "2."
?, R, ",2-"
@
|-------------------------------------------------|------------|------------------|------------|------------------|------------|------------------|------------|------------------|
|⮣                                            |############|##################|############|##################|############|##################|############|##################|
}
*)

(*
$P{ Bot:
?, R, "2."
?, R, ",2-"
?, R, "2."
?, R, ",2-"
?, R, "2."
?, R, ",2-"
?, R, "2."
?, R, ",2-"
@
|-------------------------------------------------|------------|------------------|------------|------------------|------------|------------------|------------|------------------|
|ᥣ                                            |############|##################|############|##################|############|##################|############|##################|
=(c) Polak=========================================================================================================================================================================
}
*)

(*
$P{ Top3:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName(), L, ""
SubTitle, C, ""
@
############################################################################# ########## #####
=#####========================================================================================
|                             ਠ 業                                |
|############################################################################################|
}
*)

(*
$P{ MTypeTop:
?, L, ""
?, L, ""
@
|============================================================================================|
| ꥪ⮢  #### ######################################                           |
}
*)

(*
$P{ Cut2Top:
?, L, ""
?, L, ""
@
|--------------------------------------------------------------------------------------------|
| #### ################################                                                |
|--------------------------------------------------------------------------------------------|
|⭨/ꥪ                                 |  ⢮|        |           㬬|
}
*)

(*
$P{ MTop:
?, L, ""
@
|--------------------------------------------------------------------------------------------|
|#################################################|  ⢮|        |           㬬|
|-------------------------------------------------|------------|------------|----------------|
}
*)

(*
$P{ Cut3Top:
?, L, ""
?, L, ""
@
|-------------------------------------------------|------------|------------|----------------|
|##### ###########################################|            |            |                |
}
*)

(*
$P{ Line2:
?, L, ""
?, L, ""
?, R, "2."
?, R, ",2-"
?, R, ",2-"
@
|   ##### ########################################|############|############|################|
}
*)

(*
$P{ TotCut3:
?, R, ",2-"
@
|⮣                                            |            |            |################|
}
*)

(*
$P{ TotSort:
?, R, ",2-"
@
|---------------------------------------------------------------------------|----------------|
|⮣  ᥪ                                                           |################|
}
*)

(*
$P{ MTypeTot:
?, R, ",2-"
@
|---------------------------------------------------------------------------|----------------|
|⮣   ꥪ⮢                                                     |################|
}
*)

(*
$P{ Bot2:
?, R, ",2-"
@
|---------------------------------------------------------------------------|----------------|
|⮣                                                                      |################|
=(c) Polak====================================================================================
}
*)

 PRIVATE PROCEDURE ContentType(): D_XObj.XCContentType;
 BEGIN
  IF (MODE > 100) & (MODE < (RMNum+100)) THEN
   RETURN MODE - 100;
  ELSE
   L_General.BadMode(MODE);
  END;
 END {ContentType};

 PRIVATE PROCEDURE RepName(): STRING[];
 BEGIN
  IF    _ContentType = ct_allMathRestExcel THEN
   RETURN "MSSMD";
  ELSIF _ContentType = ct_allMathMoveExcel THEN
   RETURN "MSSMM";
  ELSIF _ContentType = ct_allMathMove THEN
   RETURN "SMC";
  ELSE
   RETURN "SMCM" + L_Str.IntStr(_ContentType);
  END;
 END {RepName};

 PRIVATE PROCEDURE FRepName(): STRING[];
 BEGIN
  IF Str.Length(RepName()) = 3 THEN
   RETURN L_General.NameAnyMonth(RepName(), Memo.ud_fr());
  ELSE
   RETURN L_General.NameConnection(RepName());
  END;
 END {FRepName};

 PRIVATE PROCEDURE _BuildBasis(_XCC: D_XObj.XCContentType; _Cut1, _Cut2, _Cut3, _Cut4: D_XObj.XCSortType; _VT: SCAL[3]);
 BEGIN
  _XST_Cut1:=_Cut1;
  _ViewType:=_VT;
  D_XObj.SMC02_Prepare(_XCC, _Cut1, _Cut2, _Cut3, _Cut4, _ViewType=vt_Rest);
 END {_BuildBasis};

 PRIVATE PROCEDURE BuildBasis();
 BEGIN
  IF    _ContentType = ct_allMathMove THEN
   SETEMPTY(SubTitle);
   Top2Name :=FLDTOSTR("ꥪ", "", 45)+ " ";
   _BuildBasis(D_XObj.XCC_FullWealth, D_XObj.XST_ByMathType, D_XObj.XST_TheSingle, D_XObj.XST_TheSingle, D_XObj.XST_ByMath, vt_Move);
  ELSIF _ContentType = ct_curMathMove THEN
   L_General.Assert(ACCESS(Math), " ⠭ ⥪騩 ꥪ ");
   SubTitle:="ꥪ " + Math.Math + " " + Math.Name;
   Top2Name :="⭨";
   _BuildBasis(D_XObj.XCC_SingleMath, D_XObj.XST_TheSingle, D_XObj.XST_TheSingle, D_XObj.XST_TheSingle, D_XObj.XST_ByTSN, vt_Move);
  ELSIF _ContentType = ct_curTSNMove THEN
   L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
   CONFORM(Staff, Man);
   SubTitle:="⭨ " + Staff.TSN + " " + Man.Name + " ( " + FLDTOSTR(Staff.Storage) + ")";
   Top2Name :=FLDTOSTR("ꥪ", "", 45)+ " ";
   _BuildBasis(D_XObj.XCC_SingleTSN, D_XObj.XST_ByMathType, D_XObj.XST_TheSingle, D_XObj.XST_TheSingle, D_XObj.XST_ByMath, vt_Move);
  ELSIF _ContentType = ct_curSortMove THEN
   L_General.Assert(ACCESS(Sort), " ⠭ ⥪騩 ᥪ");
   SubTitle:=" " + Sort.Sort + " " + Sort.Name;
   Top2Name :=FLDTOSTR("ꥪ", "", 45)+ " ";
   _BuildBasis(D_XObj.XCC_SingleSort, D_XObj.XST_ByMathType, D_XObj.XST_TheSingle, D_XObj.XST_TheSingle, D_XObj.XST_ByMath, vt_Move);
  ELSIF _ContentType = ct_allTsnByMathMove THEN
   SETEMPTY(SubTitle);
   Top2Name :=FLDTOSTR("⭨/ꥪ", "", 45)+ " ";
   _BuildBasis(D_XObj.XCC_FullWealth, D_XObj.XST_ByMathType, D_XObj.XST_TheSingle, D_XObj.XST_ByTSN, D_XObj.XST_ByMath, vt_Move);
  ELSIF (_ContentType = ct_allMathDebet) | (_ContentType = ct_allMathCredit) THEN
   SubTitle:=L_Str.PoolItem("ᠭ|室", _ContentType = ct_allMathDebet) +
             "  ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut());
   _BuildBasis(D_XObj.XCC_FullWealth, D_XObj.XST_ByMathType, D_XObj.XST_BySort, D_XObj.XST_ByTSN, D_XObj.XST_ByMath, vt_InOut);
  ELSIF _ContentType = ct_curMathRest THEN
   L_General.Assert(ACCESS(Math), " ⠭ ⥪騩 ꥪ ");
   SubTitle:=Str.Align("ꥪ " + Math.Math + " " + Math.Name, 92 - 21, LEFT) +
             "⪨  " + L_DatTim.DateStr(L_DatTim.NextPer(Memo.ud_mb()));
   Top2Name :="⭨";
   _BuildBasis(D_XObj.XCC_SingleMath, D_XObj.XST_TheSingle, D_XObj.XST_TheSingle, D_XObj.XST_TheSingle, D_XObj.XST_ByTSN, vt_Rest);
  ELSIF _ContentType = ct_allMathRestExcel THEN
   D_XObj.SMC01_Prepare(D_XObj.XCC_FullWealth, 1);
  ELSIF _ContentType = ct_allMathMoveExcel THEN
   D_XObj.SMC01_Prepare(D_XObj.XCC_FullWealth, 0);
  ELSE
   L_General.Error("MsSmm.BuildBasis. Error 1");
  END;
 END {BuildBasis};

 PRIVATE PROCEDURE excel_MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "C");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, ".");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "ꥪ⌓");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "");
  IF    _ContentType = ct_allMathRestExcel THEN
   L_Basis.wb_WrInQM(F, "-");
   L_Basis.wb_WrInQM(F, "⮨");
  ELSIF _ContentType = ct_allMathMoveExcel THEN
   L_Basis.wb_WrInQM(F, "珥-");
   L_Basis.wb_WrInQM(F, "珥⮨");
   L_Basis.wb_WrInQM(F, "⊮-");
   L_Basis.wb_WrInQM(F, "⮨");
   L_Basis.wb_WrInQM(F, "।⊮-");
   L_Basis.wb_WrInQM(F, "।⮨");
   L_Basis.wb_WrInQM(F, "-");
   L_Basis.wb_WrInQM(F, "⮨");
  ELSE
   L_General.Error("excel_MakeHeader.Error 1");
  END;
  L_Basis.wb_TermLine(F);
 END {excel_MakeHeader};

 PRIVATE PROCEDURE excel_MakeLine(F: STRING[]);
 BEGIN
  IF (_ContentType = ct_allMathMoveExcel) |
     ((SMC01.SldSum # 0) | (SMC01.SldQnt # 0)) THEN
   L_Basis.wb_WrScl(F, L_Staff.getDepart());
   L_Basis.wb_WrStr(F, L_Staff.getDepartName());
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
   L_Basis.wb_WrScl(F, Staff.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrScl(F, MathType.MathType);
   L_Basis.wb_WrStr(F, MathType.Name);
   L_Basis.wb_WrScl(F, Math.Math);
   L_Basis.wb_WrStr(F, Math.Name);
 
   L_Basis.wb_WrScl(F, AcCut.AcCut);
   L_Basis.wb_WrStr(F, AcCut.Name);
   L_Basis.wb_WrStr(F, L_MathR.DefaultMUnitSign(Math.Math));
   IF    _ContentType = ct_allMathRestExcel THEN
    L_Basis.wb_WrNum(F, SMC01.SldQnt, 2);
    L_Basis.wb_WrNum(F, SMC01.SldSum, 2);
   ELSIF _ContentType = ct_allMathMoveExcel THEN
    L_Basis.wb_WrNum(F, SMC01.SldQnt, 2);
    L_Basis.wb_WrNum(F, SMC01.SldSum, 2);
    L_Basis.wb_WrNum(F, SMC01.DbtQnt, 2);
    L_Basis.wb_WrNum(F, SMC01.DbtSum, 2);
    L_Basis.wb_WrNum(F, SMC01.CrdQnt, 2);
    L_Basis.wb_WrNum(F, SMC01.CrdSum, 2);
    L_Basis.wb_WrNum(F, SMC01.SldQnt + SMC01.DbtQnt - SMC01.CrdQnt, 2);
    L_Basis.wb_WrNum(F, SMC01.SldSum + SMC01.DbtSum - SMC01.CrdSum, 2);
   ELSE
    L_General.Error("excel_MakeLine.Error 1");
   END;
   L_Basis.wb_TermLine(F);
  END;
 END {excel_MakeLine};

 PRIVATE PROCEDURE MakeExcelReport();
 BEGIN
  excel_MakeHeader("R");
  SELECT(SMC01, TSN);
  WHILE OCCURE(SMC01) DO
   CONFORM(SMC01, Staff);
   CONFORM(Staff, Man);
   IF _ContentType = ct_allMathRestExcel THEN
    HISTCONF(Memo.ud_me(), Staff, StaffLog);
   ELSIF _ContentType = ct_allMathMoveExcel THEN
    HISTCONF(Memo.ud_ut(), Staff, StaffLog);
   END;
   CONFORM(StaffLog, Officer, Sort);
   NARROWSEL(SMC01, TSN);
   WHILE OCCURE(SMC01) DO
    PROMPT(".  " + SMC01.TSN + ",  " + SMC01.Math);
    CONFORM(SMC01, Math, MathType);
    CONFORM(SMC01, AcCut);
    excel_MakeLine("R");
    NEXT(SMC01);
   END;
   NEXTINEXTENDEDSEL(SMC01, TSN);
  END; (* WHILE OCCURE(SMC01) ... *)
 END {MakeExcelReport};

 PRIVATE PROCEDURE MakeStandartReport();
 VAR
  ct1SldSum,
  totSldSum,
  ct1CrdSum,
  totCrdSum,
  ct1DbtSum,
  totDbtSum: L_XObj.tSum;
  ct1SldQnt,
  totSldQnt,
  ct1CrdQnt,
  totCrdQnt,
  ct1DbtQnt,
  totDbtQnt: L_XObj.tQnt;
  cttSum,
  ct3Sum,
  ct2Sum,
  ct1Sum,
  totSum   : L_XObj.tSum;
  cttQnt,
  ct3Qnt,
  ct2Qnt   : L_XObj.tQnt;
  Cnt1,
  Cnt2,
  Cnt3     : NUMERIC[0];
 BEGIN
  IF _ViewType = vt_Move THEN
   SETZERO(totSldSum, totSldQnt, totCrdSum, totCrdQnt, totDbtSum, totDbtQnt);
   MAKEPART(R, Top);
   SELECT(SMC02, Cut1);
   WHILE OCCURE(SMC02) DO
    PROMPT(": " + SMC02.Cut1 + " " + SMC02.Cut3);
    NARROWSEL(SMC02, Cut1);
    SETZERO(Cnt1, ct1SldSum, ct1SldQnt, ct1CrdSum, ct1CrdQnt, ct1DbtSum, ct1DbtQnt);
    WHILE OCCURE(SMC02) DO
     NARROWSEL(SMC02, Cut2);
     WHILE OCCURE(SMC02) DO
      SETZERO(Cnt3);
      NARROWSEL(SMC02, Cut3);
      WHILE OCCURE(SMC02) DO
       IF Cnt1 = 0 THEN
        IF _XST_Cut1 # D_XObj.XST_TheSingle THEN
         MAKEPART(R, Top1, SMC02.Cut1, D_XObj.GetCutName(SMC02.Cut1, D_XObj.XCL_Tot1));
        END;
        MAKEPART(R, Top2, Top2Name);
       END;
       IF (Cnt3 = 0) & (_ContentType = ct_allTsnByMathMove) THEN
        MAKEPART(R, Cut3Line, SMC02.Cut3, D_XObj.GetCutName(SMC02.Cut3, D_XObj.XCL_Srt1));
       END;
       MAKEPART(R, Line1, SMC02.Cut4, D_XObj.GetCutName(SMC02.Cut4, D_XObj.XCL_Srt2),
                  SMC02.SldQnt, SMC02.SldSum,
                  SMC02.DbtQnt, SMC02.DbtSum,
                  SMC02.CrdQnt, SMC02.CrdSum,
                  SMC02.SldQnt+SMC02.DbtQnt-SMC02.CrdQnt, SMC02.SldSum+SMC02.DbtSum-SMC02.CrdSum);
       INC(Cnt1);
       INC(Cnt3);
       INC(ct1SldSum, SMC02.SldSum); INC(ct1SldQnt, SMC02.SldQnt);
       INC(ct1CrdSum, SMC02.CrdSum); INC(ct1CrdQnt, SMC02.CrdQnt);
       INC(ct1DbtSum, SMC02.DbtSum); INC(ct1DbtQnt, SMC02.DbtQnt);
       NEXT(SMC02);
      END;
      NEXTINEXTENDEDSEL(SMC02, Cut3);
     END; (* WHILE OCCURE(SMC02) ... *)
     INC(totSldSum, ct1SldSum); INC(totSldQnt, ct1SldQnt);
     INC(totCrdSum, ct1CrdSum); INC(totCrdQnt, ct1CrdQnt);
     INC(totDbtSum, ct1DbtSum); INC(totDbtQnt, ct1DbtQnt);
     IF _XST_Cut1 # D_XObj.XST_TheSingle THEN
      MAKEPART(R, Tot1, ct1SldQnt, ct1SldSum,
                        ct1DbtQnt, ct1DbtSum,
                        ct1CrdQnt, ct1CrdSum,
                        ct1SldQnt+ct1DbtQnt-ct1CrdQnt, ct1SldSum+ct1DbtSum-ct1CrdSum);
     END;
     NEXTINEXTENDEDSEL(SMC02, Cut2);
    END; (* WHILE OCCURE(SMC02) ... *)
    NEXTINEXTENDEDSEL(SMC02, Cut1);
   END; (* WHILE OCCURE(SMC02) ... *)
   MAKEPART(R, Bot, totSldQnt, totSldSum,
                    totDbtQnt, totDbtSum,
                    totCrdQnt, totCrdSum,
                    totSldQnt+totDbtQnt-totCrdQnt, totSldSum+totDbtSum-totCrdSum);
  ELSE
   SETZERO(totSum);
   MAKEPART(R, Top3);
   SELECT(SMC02, Cut1);
   WHILE OCCURE(SMC02) DO
    PROMPT(": " + SMC02.Cut1 + " " + SMC02.Cut3);
    NARROWSEL(SMC02, Cut1);
    SETZERO(Cnt1, ct1Sum);
    WHILE OCCURE(SMC02) DO
     NARROWSEL(SMC02, Cut2);
     SETZERO(Cnt2, ct2Sum, ct2Qnt);
     WHILE OCCURE(SMC02) DO
      NARROWSEL(SMC02, Cut3);
      SETZERO(Cnt3, cttSum, cttQnt);
      WHILE OCCURE(SMC02) DO
       IF    (_ContentType = ct_allMathDebet) THEN
        ct3Sum:=SMC02.DbtSum;
        ct3Qnt:=SMC02.DbtQnt;
       ELSIF (_ContentType = ct_curMathRest) THEN
        ct3Sum:=SMC02.SldSum+SMC02.DbtSum-SMC02.CrdSum;
        ct3Qnt:=SMC02.SldQnt+SMC02.DbtQnt-SMC02.CrdQnt;
       ELSE
        ct3Sum:=SMC02.CrdSum;
        ct3Qnt:=SMC02.CrdQnt;
       END;
       IF ct3Qnt # 0 THEN
        IF (Cnt1 = 0) & (_XST_Cut1 # D_XObj.XST_TheSingle) THEN
         MAKEPART(R, MTypeTop, SMC02.Cut1, D_XObj.GetCutName(SMC02.Cut1, D_XObj.XCL_Tot1));
        END;
        IF Cnt2 = 0 THEN
         IF _ViewType = vt_Rest THEN
          MAKEPART(R, MTop, Top2Name);
         ELSE
          MAKEPART(R, Cut2Top, SMC02.Cut2, D_XObj.GetCutName(SMC02.Cut2, D_XObj.XCL_Tot2));
         END;
        END;
        IF (Cnt3 = 0) & (_ViewType # vt_Rest) THEN
         MAKEPART(R, Cut3Top, SMC02.Cut3, D_XObj.GetCutName(SMC02.Cut3, D_XObj.XCL_Srt1));
        END;
        MAKEPART(R, Line2, SMC02.Cut4, D_XObj.GetCutName(SMC02.Cut4, D_XObj.XCL_Srt2), ct3Qnt, ct3Sum/ct3Qnt, ct3Sum);
        INC(cttSum, ct3Sum);
        INC(cttQnt, ct3Qnt);
        INC(Cnt1);
        INC(Cnt2);
        INC(Cnt3);
       END;
       NEXT(SMC02);
      END;
      IF (cttQnt # 0) & (_ViewType # vt_Rest)  THEN
       MAKEPART(R, TotCut3, cttSum);
      END;
      INC(ct2Sum, cttSum);
      INC(ct2Qnt, cttQnt);
      NEXTINEXTENDEDSEL(SMC02, Cut3);
     END; (* WHILE OCCURE(SMC02) ... *)
     IF (ct2Qnt # 0) & (_ViewType # vt_Rest)  THEN
      MAKEPART(R, TotSort, ct2Sum);
     END;
     INC(ct1Sum, ct2Sum);
     NEXTINEXTENDEDSEL(SMC02, Cut2);
    END; (* WHILE OCCURE(SMC02) ... *)
    IF (ct1Sum # 0) & (_XST_Cut1 # D_XObj.XST_TheSingle) THEN
     MAKEPART(R, MTypeTot, ct1Sum);
    END;
    INC(totSum, ct1Sum);
    NEXTINEXTENDEDSEL(SMC02, Cut1);
   END; (* WHILE OCCURE(SMC02) ... *)
   MAKEPART(R, Bot2, totSum);
  END;
 END {MakeStandartReport};

(* SMRest *)

 CONST
  SMRst_RepName = "SMRst";

(*
$P{ SMRst_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
SMRst_RepName, L, ""
Memo.ud_cd(), L, "D.N.y"
@
#############################################################                ########## #####
=#####=======================================================================================
|                         ᮪ ࠡ⭨, 㢮  ##########                        |
|                                 業                                 |
|-------------------------------------------------------------------------------------------|
|.                     |  |                                         |  -|
|----------------------------|--------|--------------------------------------------|--------|
}
*)

(*
$P{ SMRst_Line:
Staff.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
Staff.EndDate, L, "D.N.Y"
Math.Math, L, ""
Math.Name, L, ""
?, R, ""
@
|##### ######################|########|##### ######################################|########|
}
*)

(*
$P{ SMRst_Line_Add:
Math.Math, L, ""
Math.Name, L, ""
?, R, ""
@
|                            |        |##### ######################################|########|
}
*)

(*
$P{ SMRst_Bot:
@
=(c) Polak===================================================================================
}
*)

 PRIVATE PROCEDURE SMRst_Check();
  VAR
   _Qnt: L_XObj.tQnt;
   Cnt : NUMERIC[0];
 BEGIN
  Cnt:=0;
  D_XObj.SMC01_Prepare(D_XObj.XCC_SingleTSN, 1);
  IF SELECT(SMC01, TSN, Staff.TSN) THEN
   WHILE OCCURE(SMC01) DO
    _Qnt:=SMC01.SldQnt+SMC01.DbtQnt-SMC01.CrdQnt;
    IF _Qnt # 0 THEN
     CONFORM(SMC01, Math);
     IF Cnt = 0 THEN
      CONFORM(Staff, Man);
      MAKEPART(R, SMRst_Line,     L_MathR.DefaultFormatCir(Math.Math, _Qnt));
     ELSE
      MAKEPART(R, SMRst_Line_Add, L_MathR.DefaultFormatCir(Math.Math, _Qnt));
     END;
     INC(Cnt);
    END;
    NEXT(SMC01);
   END; (* WHILE OCCURE(SMC01) ... *)
  END;
  D_XObj.SMC01_Purge();
 END {SMRst_Check};

 PUBLIC PROCEDURE SMRst();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  OPENREP(R, L_General.NameConnection(SMRst_RepName), Create);
  MAKEPART(R, SMRst_Top);
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Staff.IsLeave(Memo.ud_cd()) THEN
    SMRst_Check();
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  MAKEPART(R, SMRst_Bot);
  CLOSEREP(R);
 END {SMRst};

BEGIN
 IF MODE = 100 THEN
  SMRst();
 ELSE
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  _ContentType:=ContentType();
  IF (_ContentType = ct_allMathRestExcel) |
     (_ContentType = ct_allMathMoveExcel) THEN
   FIO.Open(R, FRepName(), "REP", Create);
   BuildBasis();
   MakeExcelReport();
   D_XObj.SMC01_Purge();
   FIO.Close(R);
  ELSE
   OPENREP(R, FRepName(), Create);
   BuildBasis();
   MakeStandartReport();
   D_XObj.SMC02_Purge();
   CLOSEREP(R);
  END;
 END;
END.
