(*
%Copyright   (c) Polak Computer System
%Author      05.04.2000 16:55:59 SAM
%Purpose     ꥪ     ⥪訬 ப 㦡  砫 
%Type        report
%Specific    SYS
%Modified    01.08.2014 14:39:23 POLAK\GAV
%Environment
*)

 MODULE MS_SMOld [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, P_Firm, L_MathR, L_AFM, L_Acnt, P_Math, Math,
        L_Env, L_XObj, Memo, L_CUC, P_Officer, P_Post, L_Prop, L_Staff, L_Stock,
        L_Excel, FIO, L_Man;

 VAR
  OnDate     : DATE;
  LifeTime,
  Elapse     : NUMERIC[0];
  RestDbt,
  sRestDbt   : L_XObj.tQnt;
  EmptyNumber: NUMERIC[0];
  objXL,
  objWB,
  objWS      : OBJECT;
  wMF        : SCAL[2];

(*
$P{ Top:
P_Firm.FP_FirmName(MyFirm.Firm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName(), L, ""
Title(), C, ""
@
########################################################################## ########## #####
=#####=====================================================================================
|#########################################################################################|
}
*)

(*
$P{ StaffTop:
"⭨ " + Staff.TSN + " " + Man.Name, C, ""
@
|#########################################################################################|
}
*)


(*
$P{ LineT:
?, L, ""
@
|-----------------------------------------------------------------------------------------|
|#################################################|ଠ⨢|뤠 |ப|    %| ⢮|
|-------------------------------------------------|--------|-------|----|-----|-----------|
}
*)

(*
$P{ Line1:
Math.Math, L, ""
Math.Name, L, ""
LifeTime, R, "0"
?, L "N.y"
Elapse, R, "0"
Percent(), R, "0"
RestDbt, R, ""
DefaultMUnitSign(), L, ""
@
|#####|###########################################|########|#######|####|#####|####### ###|
}
*)

(*
$P{ LineM:
Math.Math, L, ""
Math.Name, L, ""
DefaultMUnitSign(), L, ""
@
|=========================================================================================|
| ##### ###############################################################################|
|-----------------------------------------------------------------------------------------|
|  |  ⢮                       |ଠ⨢|뤠 |ப|    %|        ###|
|-----|-------------------------------------------|--------|-------|----|-----|-----------|
}
*)

(*
$P{ Line:
Staff.TSN, L, ""
Man.Name, L, ""
LifeTime, R, "0"
?, L, "N.y"
Elapse, R, "0"
Percent(), R, "0"
RestDbt, R, ""
@
|#####|###########################################|########|#######|####|#####|###########|
}
*)

(*
$P{ All:
sRestDbt, R, "0"
@
|-----------------------------------------------------------------------------------------|
|ᥣ                                                                         ###########|
}
*)

(*
$P{ Bot:
@
=(c) Polak=================================================================================
}
*)

 PRIVATE PROCEDURE Percent(): NUMERIC[1];
 BEGIN
  L_General.Assert(LifeTime # 0, "㫥   ꥪ "+Math.Math);
  RETURN Elapse/LifeTime*100;
 END {Percent};

 PRIVATE PROCEDURE AllMode(): SCAL[2];
 BEGIN
  RETURN (MODE = 200) | (MODE = 203);
 END {AllMode};

 PRIVATE PROCEDURE SingleMode(): SCAL[2];
 BEGIN
  RETURN (MODE = 201) | (MODE = 202);
 END {SingleMode};

 PRIVATE PROCEDURE EUMode(): SCAL[2];
 BEGIN
  RETURN (MODE = 202);
 END {EUMode};

 PRIVATE PROCEDURE IncludeAllMathMode(): SCAL[2];
 BEGIN
  RETURN (MODE = 201) | (MODE = 202) | (MODE = 203);
 END {IncludeAllMath};

 PRIVATE PROCEDURE ToExcelMode(): SCAL[2];
 BEGIN
  RETURN (MODE = 203);
 END {ToExcelMode};

 PRIVATE PROCEDURE Title(): STRING[];
 BEGIN
  IF IncludeAllMathMode() THEN
   RETURN "ਠ 業, 騥 ப 㦡  " + L_DatTim.DateStr(OnDate);
  ELSE
   RETURN "ਠ 業  ⥪訬 ப 㦡  " + L_DatTim.DateStr(OnDate);
  END;
 END {Title};

 PRIVATE PROCEDURE RepName(): STRING[];
 BEGIN
  IF AllMode() THEN
   RETURN "MSSMO";
  ELSE
   RETURN "MSSMT";
  END;
 END {RepName};

 PRIVATE PROCEDURE DefaultMUnitSign(): STRING[];
 BEGIN
  IF Math.MathKind = L_MathR.mathk_Math THEN
   RETURN L_MathR.DefaultMUnitSign(Math.Math);
  ELSE
   RETURN ".";
  END;
 END {DefaultMUnitSign};

 PRIVATE PROCEDURE OneMathTSN(_TSN      : LIKE(Staff.TSN);
                              wMathTotal: SCAL[2];
                              PartName  : STRING[]);
  VAR
   TotCrd: L_XObj.tQnt;
 BEGIN
  IF SEARCH(Staff, TSN, _TSN) & SEARCH(mItem, Math, Math.Math, Staff.Storage) & SELECT(XCalc, XObject, mItem.XObject) THEN
   TotCrd:=0;
   L_AFM.MakeMultipleIndex("_OldM", "XDat: DATE; Dbt: NUMERIC[2]", "_OldM: XDat");
   WHILE OCCURE(XCalc) DO
    CONFORM(XCalc, XApport);
    WHILE OCCURE(XApport) DO
     CONFORM(XApport, Apport);
     IF XApport.WFDate < OnDate THEN
      IF Apport.CirType = L_Acnt.ct_Credit THEN
       INC(TotCrd, XApport.Qnt);
      ELSE
       IF (XApport.WFDate <= MMDA.DeadLine) | IncludeAllMathMode() THEN
        ADD(_OldM, _OldM, , XApport.WFDate, _OldM.Dbt, XApport.Qnt);
       END;
      END;
     END;
     NEXT(XApport);
    END; (* WHILE OCCURE(XApport) ... *)
    NEXT(XCalc);
   END; (* WHILE OCCURE(XCalc) ... *)
   CONFORM(Staff, Man);
   SELECT(_OldM, _OldM);
   WHILE OCCURE(_OldM) DO
    IF _OldM.Dbt > 0 THEN
     RestDbt :=Math.Max(_OldM.Dbt-TotCrd, 0);
     IF RestDbt THEN
      IF ToExcelMode() THEN
       L_Staff.PosToStaffLog(Staff.TSN, OnDate, 1);
       CONFORM(StaffLog, Sort);
       CONFORM(StaffLog, Post);
       CONFORM(StaffLog, Union);
       CONFORM(Math, MathType);
       IF wMF THEN
        CONFORM(Staff, MyFirm);
        L_Excel.ws_WrScl(objWS, MyFirm.MyFirm);
        L_Excel.ws_WrStr(objWS, MyFirm.Name);
       END;
       L_Excel.ws_WrScl(objWS, Staff.TSN);
       L_Excel.ws_WrStr(objWS, Man.Name);
       L_Excel.ws_WrScl(objWS, Post.Post);
       L_Excel.ws_WrStr(objWS, Post.Name);
       L_Excel.ws_WrScl(objWS, Sort.Sort);
       L_Excel.ws_WrStr(objWS, Sort.Name);
       L_Excel.ws_WrScl(objWS, Union.Union);
       L_Excel.ws_WrStr(objWS, Union.Name);
       L_Excel.ws_WrScl(objWS, Math.Math);
       L_Excel.ws_WrStr(objWS, Math.Name);
       L_Excel.ws_WrStr(objWS, MathType.Name);
       L_Excel.ws_WrDat(objWS, _OldM.XDat);
       L_Excel.ws_WrNum(objWS, MMDA.LifeTime);
       L_Excel.ws_WrNum(objWS, MMDA.LifeTime-L_DatTim.CompleteMonthsInIntvl(_OldM.XDat, OnDate));
       L_Excel.ws_TermLine(objWS);
      ELSE
       IF wMathTotal & (sRestDbt = 0) THEN
        MAKEPART(R, LineM);
       END;
       LifeTime:=MMDA.LifeTime;
       Elapse:=L_DatTim.CompleteMonthsInIntvl(_OldM.XDat, OnDate);
       MAKEPART(R, ^PartName, _OldM.XDat);
      END;
      INC(sRestDbt, RestDbt);
     END;
     DEC(TotCrd, _OldM.Dbt-RestDbt);
    END;
    NEXT(_OldM);
   END; (* WHILE OCCURE(_OldM) ... *)
   L_AFM.AF_PurgeTemp("_OldM");
  END;
 END {OneMathTSN};

 PRIVATE PROCEDURE Create_MMDA();
 BEGIN
  CreateFILE(MMDA, "", "६ 䠩", "");

  CreateFIELD(MMDA, Post,      LIKE(Post.Post),       "", "", "", "", "");
  CreateFIELD(MMDA, Sort,      LIKE(Sort.Sort),       "", "", "", "", "");
  CreateFIELD(MMDA, Officer,   LIKE(Officer.Officer), "", "", "", "", "");
  CreateFIELD(MMDA, Math,      LIKE(Math.Math),       "", "", "", "", "");
  CreateFIELD(MMDA, LifeTime,  NUMERIC[2],            "", "", "", "ப 㦡", "");
  CreateFIELD(MMDA, DeadLine,  DATE,                  "", "", "", " 砭 ப 㦡", "");

  CreateINDEXandLINK(MMDA, Math, PLURAL, Math , Math,  USER, "", "", Math, LifeTime);
  CreateINDEX(MMDA, OfcMath, UNIQUE, "", "", Math, Sort, Officer, Post);

  SetVersionOfFILE(MMDA, 0);
  L_AFM.AF_CreateTemp("MMDA", "MMDA");
 END {Create_MMDA};

 PRIVATE PROCEDURE GetLifeTimeFromMathProp(_Math: LIKE(Math.Math)): NUMERIC[0];
  VAR
   LifeTimeUnit: P_Math.tLifeTimeUnit;
   _LifeTime   : NUMERIC[0];
 BEGIN
  P_Math.GetLifeTime(_Math, OnDate-1, L_CUC.cnd_New, LifeTimeUnit, _LifeTime);
  IF LifeTimeUnit = P_Math.ltu_Month THEN
   RETURN _LifeTime;
  ELSE
   RETURN EmptyNumber;
  END;
 END {GetLifeTimeFromMathProp};

 PRIVATE PROCEDURE GatherBySingleOfficer();
  VAR
   ByPost        : SCAL[2];
   i, _LifeTime  : NUMERIC[0];
   arrMath       : LIKE(Math.Math)[P_Officer.mmda_Amount];
   arrParagraph  : STRING[][P_Officer.mmda_Amount];
   arrWorkingLife: NUMERIC[0][P_Officer.mmda_Amount];
   arrAmount     : P_Officer.tmmdaAmnt[P_Officer.mmda_Amount];
 BEGIN
  SETEMPTY(arrMath, arrParagraph, arrWorkingLife, arrAmount);
  IF    P_Officer.HasActualOfcPro(Officer.Sort, Officer.Officer, OnDate-1, P_Officer.P_MantoManDefenceAss) THEN
   P_Officer.Decode_MantoManDefenceAss(OfcPro.Value, arrMath, arrParagraph, arrWorkingLife, arrAmount);
   ByPost:=0;
  ELSIF P_Post.HasActualPro_Normal(Officer.Post, OnDate-1, P_Post.P_MantoManDefenceAss) THEN
   P_Officer.Decode_MantoManDefenceAss(PostPro.Value, arrMath, arrParagraph, arrWorkingLife, arrAmount);
   ByPost:=1;
  END;
  i:=0;
  WHILE (i < P_Officer.mmda_Amount) & ~!arrMath[i] DO
   L_General.CallUs(SEARCH(Math, Math, arrMath[i]));
   IF ~!arrWorkingLife[i] THEN
    _LifeTime:=arrWorkingLife[i];
   ELSE
    _LifeTime:=GetLifeTimeFromMathProp(Math.Math);
   END;
   IF ~!_LifeTime THEN
    IF ByPost THEN
     MMDA.Post   :=Officer.Post;
     SETEMPTY(MMDA.Sort, MMDA.Officer);
    ELSE
     SETEMPTY(MMDA.Post);
     MMDA.Sort   :=Officer.Sort;
     MMDA.Officer:=Officer.Officer;
    END;
    MMDA.Math    :=Math.Math;
    MMDA.LifeTime:=_LifeTime;
    MMDA.DeadLine:=L_DatTim.IncMonth(OnDate, -MMDA.LifeTime);
    INSERT(MMDA);
   END;
   INC(i);
  END; (* WHILE (i < P_Officer.mmda_Amount) &...*)
 END {GatherBySingleOfficer};

 PRIVATE PROCEDURE GatherByMath(_Math: LIKE(Math.Math));
  VAR
   _LifeTime: NUMERIC[0];
 BEGIN
  IF !_Math THEN
   SELECT(Math, LeafMK, , 1, L_MathR.mathk_Math);
  ELSE
   SELECT(Math, Math, , _Math);
  END;
  WHILE OCCURE(Math) DO
   PROMPT(":  " + Math.Math);
   _LifeTime:=GetLifeTimeFromMathProp(Math.Math);
   IF ~!_LifeTime THEN
    SETEMPTY(MMDA.Post, MMDA.Sort, MMDA.Officer);
    MMDA.Math    :=Math.Math;
    MMDA.LifeTime:=_LifeTime;
    MMDA.DeadLine:=L_DatTim.IncMonth(OnDate, -_LifeTime);
    INSERT(MMDA);
   END;
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)
 END {GatherByMath};

 PRIVATE PROCEDURE GatherMMDA();
 BEGIN
  SELECT(Officer, Officer);
  WHILE OCCURE(Officer) DO
   IF L_DatTim.IsActive_Inc(OnDate-1, Officer.Begin, Officer.Till) THEN
    PROMPT(":  " + Officer.Sort + "  " + Officer.Officer);
    GatherBySingleOfficer();
   END;
   NEXT(Officer);
  END; (* WHILE OCCURE(Officer) ... *)
  GatherByMath(EmptyNumber);
 END {GatherMMDA};

 PRIVATE PROCEDURE MakeAll();
 BEGIN
  L_AFM.MakeIndex("_MTSN", "MyFirm : LIKE(Staff.MyFirm);" +
                           "Math   : LIKE(Math.Math);" +
                           "TSN    : LIKE(Staff.TSN);" +
                           "Sort   : LIKE(Sort.Sort);" +
                           "Officer: LIKE(Officer.Officer);" +
                           "Post   : LIKE(Post.Post)");
  Create_MMDA();
  GatherMMDA();

  SELECT(MMDA, Math);
  WHILE OCCURE(MMDA) DO
   NARROWSEL(MMDA, Math);
   SELECT(mItem, Math, , MMDA.Math);
   WHILE OCCURE(mItem) DO
    CONFORM(mItem, Storage);
    IF (Storage.Type = L_Stock.st_AdvHolder) & L_DatTim.IsActive(OnDate-1, Storage.Begin, Storage.Till) THEN
     L_General.CallUs(SELECT(Staff, Storage, Storage.Storage));
     PROMPT(":  " + MMDA.Math + " ⭨ " + Staff.TSN);
     L_Staff.PosToStaffLog(Staff.TSN, OnDate-1, 1);
     CONFORM(StaffLog, Officer);
     DEFAULT(_MTSN);
     _MTSN.MyFirm :=Staff.MyFirm;
     _MTSN.Math   :=MMDA.Math;
     _MTSN.TSN    :=Staff.TSN;
     _MTSN.Sort   :=Officer.Sort;
     _MTSN.Officer:=Officer.Officer;
     _MTSN.Post   :=Officer.Post;
     INSERT(_MTSN);
    END;
    NEXT(mItem);
   END; (* WHILE OCCURE(mItem) ... *)
   NEXTINEXTENDEDSEL(MMDA, Math);
  END; (* WHILE OCCURE(MMDA) ... *)

  SELECT(_MTSN, _MTSN);
  WHILE OCCURE(_MTSN) DO
   NARROWSEL(_MTSN, MyFirm);
   SEARCH(MyFirm, MyFirm, , _MTSN.MyFirm);
   IF ~ToExcelMode() THEN
    IF LINENUM(R) > 0 THEN
     FORMFEED(R);
    END;
    MAKEPART(R, Top);
   END;
   WHILE OCCURE(_MTSN) DO
    NARROWSEL(_MTSN, Math);
    SEARCH(Math, Math, , _MTSN.Math);
    SETZERO(sRestDbt);
    WHILE OCCURE(_MTSN) DO
     PROMPT("ࠡ⪠:  " + Math.Math + " ⭨ " + _MTSN.TSN);
     IF SEARCH(MMDA, OfcMath, Math.Math, _MTSN.Sort,  _MTSN.Officer, EmptyNumber) |
        SEARCH(MMDA, OfcMath, Math.Math, EmptyNumber, EmptyNumber,   _MTSN.Post)  |
        SEARCH(MMDA, OfcMath, Math.Math, EmptyNumber, EmptyNumber,   EmptyNumber) THEN
      OneMathTSN(_MTSN.TSN, 1, "Line");
     END;
     NEXT(_MTSN);
    END; (* WHILE OCCURE(_MTSN) ... *)
    IF sRestDbt # 0 THEN
     IF ~ToExcelMode() THEN
      MAKEPART(R, All);
     END;
    END;
    NEXTINEXTENDEDSEL(_MTSN, Math);
   END; (* WHILE OCCURE(_MTSN) ... *)
   IF ~ToExcelMode() THEN
    MAKEPART(R, Bot);
   END;
   NEXTINEXTENDEDSEL(_MTSN, MyFirm);
  END; (* WHILE OCCURE(_MTSN) ... *)

  L_AFM.AF_PurgeTemp("MMDA");
  L_AFM.AF_PurgeTemp("_MTSN");
 END {MakeAll};

 PRIVATE PROCEDURE MakeOneTSN();
  VAR
   First  : SCAL[2];
   AprDate: DATE;
 BEGIN
  L_General.Assert(ACCESS(Staff), "室  㤭");
  CONFORM(Staff, MyFirm);
  CONFORM(Staff, Man);
  L_Staff.PosToStaffLog(Staff.TSN, OnDate-1, 1);
  CONFORM(StaffLog, Officer);
  Create_MMDA();
  GatherBySingleOfficer();

  MAKEPART(R, Top);
  MAKEPART(R, StaffTop);
  IF SELECT(mItem, Storage, Staff.Storage) THEN
   WHILE OCCURE(mItem) DO
    GatherByMath(mItem.Math);
    NEXT(mItem);
   END; (* WHILE OCCURE(mItem) ... *)
  END;

  First:=1;
  SETZERO(sRestDbt);
  SELECT(MMDA, Math);
  WHILE OCCURE(MMDA) DO
   CONFORM(MMDA, Math);
   NARROWSEL(MMDA, Math);
   SAVE(MMDA);
   IF SEARCH(MMDA, OfcMath, Math.Math, Officer.Sort,  Officer.Officer, EmptyNumber)  |
      SEARCH(MMDA, OfcMath, Math.Math, EmptyNumber,   EmptyNumber,     Officer.Post) |
      SEARCH(MMDA, OfcMath, Math.Math, EmptyNumber,   EmptyNumber,     EmptyNumber) THEN
    IF First THEN
     MAKEPART(R, LineT, "  ");
     First:=0;
    END;
    OneMathTSN(Staff.TSN, 0, "Line1");
   ELSE
    L_General.CallUs(0);
   END;
   RESTORE(MMDA);
   NEXTINEXTENDEDSEL(MMDA, Math);
  END; (* WHILE OCCURE(MMDA) ... *)
  L_AFM.AF_PurgeTemp("MMDA");

  RestDbt:=1;
  First:=1;
  L_MathR.StfKA_Prepare(Staff.TSN, OnDate);
  SELECT(StfKA, StfKA);
  WHILE OCCURE(StfKA) DO
   L_MathR.AccessMath(StfKA.Math);
   L_MathR.PosToKAG(Math.Math, OnDate-1);
   AprDate:=L_MathR.GetKeyAssAPrDate(Math.Math);
   LifeTime:=L_MathR.GetFullUL(AprDate, L_MathR.DprK_Acn);
   Elapse  :=L_DatTim.CompleteMonthsInIntvl(L_DatTim.NextPer(AprDate), OnDate);
   IF (LifeTime < Elapse) | IncludeAllMathMode() THEN
    IF First THEN
     MAKEPART(R, LineT, "");
     First:=0;
    END;
    MAKEPART(R, Line1, AprDate);
   END;
   NEXT(StfKA);
  END; (* WHILE OCCURE(StfKA) ... *)
  L_MathR.StfKA_Purge();

  MAKEPART(R, Bot);
 END {MakeOneTSN};

BEGIN
 RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
 IF EUMode() THEN
  OnDate:=L_DatTim.NextPer(SYSDATE());
 ELSE
  OnDate:=L_DatTim.NextPer(Memo.ud_mb());
 END;
 SETEMPTY(EmptyNumber);
 SETEMPTY(objXL, objWB);
 TRY
  IF ToExcelMode() THEN
   wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
   L_General.Assert(L_Excel.ExcelInstalled(), " ⠭ MS Excel");
   objXL:=CreateOBJECT("Excel.Application");
   objWB:=L_Excel.NewWorkbook(objXL, 1);
   objWS:=objWB.Sheets(1);
   L_Excel.ws_Init(objWS);
   IF wMF THEN
    L_Excel.ws_AddColumn(objWS, L_General.ft_SCAL,    4, "", "");
    L_Excel.ws_AddColumn(objWS, L_General.ft_STRING,  0, "'' ࣠", "");
   END;
   L_Excel.ws_AddColumn(objWS, L_General.ft_SCAL,    5, "", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_STRING,  0, "", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_SCAL,    3, "", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_STRING,  0, " ", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_SCAL,    3, "", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_STRING,  0, "", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_SCAL,    2, "⥣", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_STRING,  0, "⥣", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_SCAL,    5, " ", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_STRING,  0, "", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_STRING,  0, " ", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_DATE,    0, " 뤠", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_NUMERIC, 0, "ப 㦡", "");
   L_Excel.ws_AddColumn(objWS, L_General.ft_NUMERIC, 0, "⠢訩 ப 㦡", "");
   L_Excel.ws_TermLine(objWS);
  ELSE
   OPENREP(R, L_General.NameConnection(RepName()), Create);
  END;
  IF    AllMode() THEN
   MakeAll();
  ELSIF SingleMode() THEN
   MakeOneTSN();
  ELSE
   L_General.BadMode(MODE);
  END;
  IF ToExcelMode() THEN
   objWS.UsedRange.AutoFilter();
   objWS.UsedRange.EntireColumn.AutoFit();
   objWS.Visible:=1;
   objWS.Application.Visible:=1;
   objWB.SaveAs(FIO.MakePath(RepName(), "XLS", FIO.AsbSpecialFolders("ASBTemp")));
  ELSE
   CLOSEREP(R);
  END;
 EXCEPT
 ELSE
  L_Excel.CloseExcelAfterCrash(objXL, objWB);
  RAISE();
 END;
END.
