(*
%Copyright   (c) Polak IT
%Author      26.02.2010 10:42:06 POLAK\Bor
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    15.02.2013 17:58:05 POLAK\Bor
%Environment
*)

 MODULE MS_Staff [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_MathR, L_MDoc, L_XObj, L_AFM, D_XObj, P_Firm, P_Math, L_Str, Str, L_CUC;

(*
$P{ Top:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
L_DatTim.NextPer(Memo.ud_mb()), L, "D.N.y"
Staff.TSN+" "+Man.Name+" ( "+FLDTOSTR(Staff.Storage)+")", C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                             ਠ 業  ࠡ⭨  ##########                              |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|/                                              |     ᪮             | ⢮|
}
*)

(*
$P{ MTypeTop:
MathType.MathType, L, ""
MathType.Name+L_Str.PoolItem(" | (⮢ ᯨᠭ)", MtRst.ASpPrep), L, ""
@
|============================================================================================================|
|  ## #################################################################################################|
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ Line:
Math.Math, L, ""
GetMathName(), L, ""
?, L, ""
?, L, ""
L_MathR.DefaultFormatCir(MtRst.Math, MtRst.Rest), R, ""
DefaultMUnitSign(), L, ""
@
|##### ######################################################|####### ###########################|####### ###|
}
*)

(*
$P{ CUCLine:
CUCopy.CUCopy, L, ""
CUCopy.Serial, L, ""
@
|                                                            |####### ###########################|           |
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE DefaultMUnitSign(): STRING[];
 BEGIN
  IF Math.MathKind = L_MathR.mathk_Math THEN
   RETURN L_MathR.DefaultMUnitSign(Math.Math);
  ELSE
   RETURN ".";
  END;
 END {DefaultMUnitSign};

 PRIVATE PROCEDURE GetMathName(): STRING[];
  VAR
   _Mark: STRING[];
 BEGIN
  _Mark:=P_Math.GetMathProSoft(Math.Math, Memo.ud_cd(), P_Math.P_Model);
  IF ~!_Mark THEN
   RETURN Math.Name+" ન "+_Mark;
  ELSE
   RETURN Math.Name;
  END;
 END {GetMathName};

 PRIVATE PROCEDURE HasPreparedASp(trgMath: LIKE(Math.Math)): SCAL[2];
 BEGIN
  SELECT(MDocList, Math, , trgMath);
  WHILE OCCURE(MDocList) DO
   IF L_MDoc.md_asASp(MDocList.MDocKind) THEN
    CONFORM(MDocList, MDoc);
    IF MDoc.Status = L_MDoc.st_Prepared THEN
     RETURN 1;
    END;
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  RETURN 0;
 END {HasPreparedASp};

 PUBLIC PROCEDURE MSStf();
  CONST
   RepName = "MSStf";
  VAR
   Rest   : L_XObj.tQnt;
   Cnt    : NUMERIC[0];
   P      : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt(RepName);
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  L_AFM.MakeMultipleIndex("MtRst", "MyFirm  : LIKE(MyFirm.MyFirm);"+
                                   "MathType: LIKE(Math.MathType);"+
                                   "ASpPrep : SCAL[2];"+
                                   "Math    : LIKE(Math.Math);"+
                                   "MathKind: LIKE(Math.MathKind);"+
                                   "Rest    : "+GET_TYPE_SPEC(L_XObj.tQnt).Name,
                          "MtRst: MyFirm, MathType, ASpPrep, Math, MathKind");
  P:=L_DatTim.NextPer(Memo.ud_mb());
  OPENREP(R, L_General.NameConnection(RepName), Create);

  CONFORM(Staff, Man);
  PROMPT(" ");
  D_XObj.SMC02_Prepare(D_XObj.XCC_SingleTSN, D_XObj.XST_ByMathType, D_XObj.XST_TheSingle, D_XObj.XST_TheSingle, D_XObj.XST_ByMath, 1);

  SELECT(SMC02, Cut1);
  WHILE OCCURE(SMC02) DO
   NARROWSEL(SMC02, Cut1, Cut2, Cut3);
   WHILE OCCURE(SMC02) DO
    L_MathR.AccessMath(SMC02.Cut4);
    Rest:=SMC02.SldQnt+SMC02.DbtQnt-SMC02.CrdQnt;
    IF Rest # 0 THEN
     ADD(MtRst, MtRst, , Staff.MyFirm, Math.MathType, 0, Math.Math, Math.MathKind,
                         MtRst.Rest, Rest);
    END;
    NEXT(SMC02);
   END; (* WHILE OCCURE(SMC02) ... *)
   NEXTINEXTENDEDSEL(SMC02, Cut1, Cut2, Cut3);
  END; (* WHILE OCCURE(SMC02) ... *)

  PROMPT(" ");
  L_MathR.StfKA_Prepare(Staff.TSN, P);
  SELECT(StfKA, StfKA);
  WHILE OCCURE(StfKA) DO
   L_MathR.AccessMath(StfKA.Math);
   ADD(MtRst, MtRst, , Math.MyFirm, Math.MathType, HasPreparedASp(Math.Math), Math.Math, Math.MathKind,
                       MtRst.Rest, 1);
   NEXT(StfKA);
  END; (* WHILE OCCURE(StfKA) ... *)
  L_MathR.StfKA_Purge();

  IF SELECT(MtRst, MtRst) THEN
   MAKEPART(R, Top, P_Firm.FP_FirmName(P_Firm.fomf(MtRst.MyFirm), SYSDATE()), RepName);
   WHILE OCCURE(MtRst) DO
    NARROWSEL(MtRst, MyFirm);
    WHILE OCCURE(MtRst) DO
     NARROWSEL(MtRst, MathType, ASpPrep);
     SEARCH(MathType, MathType, , MtRst.MathType);
     MAKEPART(R, MTypeTop);
     WHILE OCCURE(MtRst) DO
      PROMPT(" "+MtRst.MathType+" "+MtRst.Math);
      L_MathR.AccessMath(MtRst.Math);
      Cnt:=0;
      IF SELECT(CUCopy, Math, MtRst.Math) THEN
       WHILE OCCURE(CUCopy) DO
        IF !CUCopy.Till &
           L_CUC.AccessMDocLCU(CUCopy.CUCopy, P) &
           ((MtRst.MathKind = L_MathR.mathk_KeyAs) |
            (L_CUC.GetCurMDocLCUStorage() = Staff.Storage)) THEN
         IF Cnt = 0 THEN
          MAKEPART(R, Line, CUCopy.CUCopy, CUCopy.Serial);
         ELSE
          MAKEPART(R, CUCLine);
         END;
         INC(Cnt);
        END;
        NEXT(CUCopy);
       END;
      END;
      IF Cnt = 0 THEN
       IF (MtRst.MathKind = L_MathR.mathk_KeyAs) &
             P_Math.HasActualMathPro(Math.Math, P, P_Math.P_Serial) THEN
        MAKEPART(R, Line, "", MathPro.Value);
       ELSE
        MAKEPART(R, Line, "", "");
       END;
      END;
      NEXT(MtRst);
     END; (* WHILE OCCURE(MtRst) ... *)
     NEXTINEXTENDEDSEL(MtRst, MathType, ASpPrep);
    END; (* WHILE OCCURE(MtRst) ... *)
    NEXTINEXTENDEDSEL(MtRst, MyFirm);
   END; (* WHILE OCCURE(MtRst) ... *)
   MAKEPART(R, Bot);
  ELSE
   MAKEPART(R, Top, P_Firm.FP_FirmName(P_Firm.fomf(Staff.MyFirm), SYSDATE()), RepName);
   MAKEPART(R, Bot);
  END; (* IF SELECT(MtRst, MtRst) ... *)
  L_AFM.AF_PurgeTemp("MtRst");
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MSStf};

END.