(*
%Copyright   (c) Polak Computer System
%Author      08.04.2002 14:23:51 LDA
%Purpose     㬥  ⥪饬 / 室  室/ࠣ  ਮ/ ଠ
%Type        report
%Specific    SYS
%Modified    22.09.2014 18:54:18 POLAK\San
%Environment
*)

 MODULE MS_Where [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_DatTim, L_MDoc, L_Basis, L_Str, L_AFM, L_Excel,
        L_Pmnt, L_MathR, L_XDoc, L_StdFrm, FIO, Str, L_Car, L_Stock,
        Memo, L_Cntr, L_XObj, P_MDoc, L_AR, P_Firm, L_Acnt, L_lsStore, L_JDoc;

 TYPE
  tObject   = SCAL[3];
  tRepType  = SCAL[3];
  tDocSorts = SCAL[3];

 CONST
  ds_All     = 0;
  ds_Outside = 1;
  ds_Inside  = 2;
  dsPool = "|쪮 譨|쪮 ७";

  dt_All     = 0;
  dt_Real    = 1;
  dt_Debit   = 2;
  dt_Credit  = 3;
  dtPool = "|쭮 |室|室";

  cur_Math     = 0;
  cur_CostItem = 1;
  cur_Storage  = 2;

  rt_All       = 0;
  rt_ByFirm    = 1;
  rt_ByCar     = 2;

 VAR
  RepName  : STRING[];
  RepType  : tRepType;
  curObject: tObject;
  wMF      : SCAL[2];

 PRIVATE PROCEDURE StorageNick(_Storage: LIKE(Storage.Storage)): STRING[];
 BEGIN
  IF !_Storage THEN
   RETURN "";
  ELSE
   SEARCH(Storage, Storage, , _Storage);
   IF (Storage.Type = L_Stock.st_AdvHolder) & SELECT(Staff, Storage, _Storage) THEN
    RETURN "."+Staff.TSN;
   ELSE
    RETURN _Storage;
   END;
  END;
 END {StorageNick};

 PRIVATE PROCEDURE _MModeStr(_MMode: LIKE(MMode.MMode)): STRING[];
 BEGIN
  IF !_MMode THEN
   RETURN "";
  ELSE
   RETURN L_MathR.MModeStr(MDLst.MMode);
  END;
 END {_MModeStr};

 PRIVATE PROCEDURE MDocStatNDone(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem("||", MDoc.Status)+L_Str.PoolItem(" |", MDoc.Done);
 END {MDocStatNDone};

 PRIVATE PROCEDURE _FirmName(_Firm: LIKE(Firm.Firm)): STRING[];
 BEGIN
  IF SEARCH(Firm, Firm, _Firm) THEN
   RETURN Firm.Name;
  ELSE
   RETURN "-";
  END;
 END {_FirmName};

 PRIVATE PROCEDURE _Column(D: DATE; _BoxNbr: LIKE(Car.BoxNbr)): LIKE(CarLog.Column);
 BEGIN
  IF ~!MDoc.BoxNbr THEN
   L_Car.StandOnCarLog(MDoc.BoxNbr, MDoc.Date);
   RETURN CarLog.Column;
  END;
  RETURN "";
 END {_Column};


(*
$P{ RepTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
?, C, ""
?, C, ""
@
##################################################################### ########## #####
=#####================================================================================
|####################################################################################|
|####################################################################################|
|####################################################################################|
}
*)

(*
$P{ st_Int:
MDocKind.Name, C, ""
@
|====================================================================================|
|####################################################################################|
|------------------------------------------------------------------------------------|
|  |      || 樨           ||     ||        㬬|⢮|
|-------|----------|--|-----------------------|-|-------|---|-------------|----------|
}
*)

(*
$P{ rl_Int:
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.y"
MDocStatNDone(), L, ""
MDoc.Dest, L, ""
Dest.Name, L, ""
MDLst.Dir, L, L_MDoc.mft_Pool_1Char
MDoc.Storage, L, ""
_MModeStr(MDLst.MMode), L, ""
MDLst.Sum, R, ",2-"
L_MathR.DefaultFormatCir(Math.Math, MDLst.Qnt), R, ""
@
|#######|##########|##|### ###################|#|#######|###|#############|##########|
}
*)

(*
$P{ st_Ext:
MDocKind.Name, C, ""
@
|====================================================================================|
|####################################################################################|
|------------------------------------------------------------------------------------|
|  |      ||ࠣ                   | ||        㬬|⢮|
|-------|----------|--|-----------------------------|---|---|-------------|----------|
}
*)

(*
$P{ rl_Ext:
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.y"
MDocStatNDone(), L, ""
MDoc.Firm, L, ""
_FirmName(MDoc.Firm), L, ""
MDoc.Dest, L, ""
_MModeStr(MDLst.MMode), L, ""
MDLst.Sum, R, ",2-"
L_MathR.DefaultFormatCir(Math.Math, MDLst.Qnt), R, ""
@
|#######|##########|##|#### ########################|###|###|#############|##########|
}
*)

(*
$P{ st_Ext1:
MDocKind.Name, C, ""
@
|====================================================================================|
|####################################################################################|
|------------------------------------------------------------------------------------|
|  |      ||ࠣ                   | |              㬬 ()|
|-------|----------|--|-----------------------------|---|----------------------------|
}
*)

(*
$P{ rl_Ext1:
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.y"
MDocStatNDone(), L, ""
MDoc.Firm, L, ""
_FirmName(MDoc.Firm), L, ""
MDoc.Dest, L, ""
MDLst.Sum, R, ",2-"
@
|#######|##########|##|#### ########################|###|############################|
}
*)

(*
$P{ st_NOV:
MDocKind.Name, C, ""
@
|====================================================================================|
|####################################################################################|
|------------------------------------------------------------------------------------|
|  |      || 樨           | ||  ||     ||⢮|
|-------|----------|--|-----------------------|----|--|-----|-|-------|---|----------|
}
*)

(*
$P{ rl_NOV:
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.y"
MDocStatNDone(), L, ""
MDoc.Dest, L, ""
Dest.Name, L, ""
MDoc.BoxNbr, L, ""
_Column(MDoc.Date, MDoc.BoxNbr), L, ""
MDoc.TSN, L, ""
MDLst.Dir, L, L_MDoc.mft_Pool_1Char
StorageNick(MDoc.Storage), L, ""
_MModeStr(MDLst.MMode), L, ""
L_MathR.DefaultFormatCir(Math.Math, MDLst.Qnt), R, ""
@
|#######|##########|##|### ###################|####|##|#####|#|#######|###|##########|
}
*)

(*
$P{ st_ViP:
MDocKind.Name, C, ""
@
|====================================================================================|
|####################################################################################|
|------------------------------------------------------------------------------------|
|  |      || 樨   | |||     ||        㬬|⢮|
|-------|----------|--|---------------|----|--|-|-------|---|-------------|----------|
}
*)

(*
$P{ rl_ViP:
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.y"
MDocStatNDone(), L, ""
MDoc.Dest, L, ""
Dest.Name, L, ""
MDoc.BoxNbr, L, ""
_Column(MDoc.Date, MDoc.BoxNbr), L, ""
MDLst.Dir, L, L_MDoc.mft_Pool_1Char
MDoc.Storage, L, ""
_MModeStr(MDLst.MMode), L, ""
MDLst.Sum, R, ",2-"
L_MathR.DefaultFormatCir(Math.Math, MDLst.Qnt), R, ""
@
|#######|##########|##|### ###########|####|##|#|#######|###|#############|##########|
}
*)

(*
$P{ st_TOV:
MDocKind.Name, C, ""
@
|====================================================================================|
|####################################################################################|
|------------------------------------------------------------------------------------|
|  |      || 樨                   |  ||     ||⢮|
|-------|----------|--|-------------------------------|-----|-|-------|---|----------|
}
*)

(*
$P{ rl_TOV:
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.y"
MDocStatNDone(), L, ""
MDoc.Dest, L, ""
Dest.Name, L, ""
MDoc.TSN,  L ""
MDLst.Dir, L, L_MDoc.mft_Pool_1Char
StorageNick(MDoc.Storage), L, ""
_MModeStr(MDLst.MMode), L, ""
L_MathR.DefaultFormatCir(Math.Math, MDLst.Qnt), R, ""
@
|#######|##########|##|### ###########################|#####|#|#######|###|##########|
}
*)

(*
$P{ st_MSP:
MDocKind.Name, C, ""
@
|====================================================================================|
|####################################################################################|
|------------------------------------------------------------------------------------|
|  |      || 樨        |  | |     |2    ||⢮|
|-------|----------|--|--------------------|-----|----|-------|-------|---|----------|
}
*)

(*
$P{ rl_MSP:
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.y"
MDocStatNDone(), L, ""
MDoc.Dest, L, ""
Dest.Name, L, ""
MDoc.TSN,  L ""
MDoc.BoxNbr, L, ""
StorageNick(MDoc.Storage), L, ""
StorageNick(MDoc.Storage2), L, ""
_MModeStr(MDLst.MMode), L, ""
L_MathR.DefaultFormatCir(Math.Math, MDLst.Qnt), R, ""
@
|#######|##########|##|### ################|#####|####|#######|#######|###|##########|
}
*)

(*
$P{ st_Dum:
MDocKind.Name, C, ""
@
|====================================================================================|
|####################################################################################|
|------------------------------------------------------------------------------------|
|  |      || 樨                          ||     |2    |  |
|-------|----------|--|--------------------------------------|-|-------|-------|-----|
}
*)

(*
$P{ rl_Dum:
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.y"
MDocStatNDone(), L, ""
MDoc.Dest, L, ""
Dest.Name, L, ""
MDLst.Dir, L, L_MDoc.mft_Pool_1Char
StorageNick(MDoc.Storage), L, ""
StorageNick(MDoc.Storage2), L, ""
MDoc.TSN,  L ""
@
|#######|##########|##|### ##################################|#|#######|#######|#####|
}
*)

(*
$P{ st_KeyAs:
MDocKind.Name, C, ""
@
|====================================================================================|
|####################################################################################|
|------------------------------------------------------------------------------------|
|  |      || 樨                                  ||     |  |
|-------|----------|--|----------------------------------------------|-|-------|-----|
}
*)

(*
$P{ rl_KeyAs:
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.y"
MDocStatNDone(), L, ""
MDoc.Dest, L, ""
Dest.Name, L, ""
MDLst.Dir, L, L_MDoc.mft_Pool_1Char
StorageNick(MDoc.Storage), L, ""
MDoc.TSN,  L ""
@
|#######|##########|##|### ##########################################|#|#######|#####|
}
*)

(*
$P{ st_Distrib:
MDocKind.Name, C, ""
@
|====================================================================================|
|####################################################################################|
|------------------------------------------------------------------------------------|
|  |      || 樨                        ||. ||        㬬|
|-------|----------|--|------------------------------------|-|-----|---|-------------|
}
*)

(*
$P{ rl_Distrib:
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.y"
MDocStatNDone(), L, ""
MDoc.Dest, L, ""
Dest.Name, L, ""
MDLst.Dir, L, L_MDoc.mft_Pool_1Char
MDoc.TSN, L, ""
_MModeStr(MDLst.MMode), L, ""
MDLst.Sum, R, ",2-"
@
|#######|##########|##|### ################################|#|#####|###|#############|
}
*)

(*
$P{ st_JDoc:
JDocKind.Name, C, ""
@
|====================================================================================|
|####################################################################################|
|------------------------------------------------------------------------------------|
|  |      ||ਬ砭                                    ||        㬬|
|-------|----------|--|----------------------------------------------|-|-------------|
}
*)

(*
$P{ rl_JDoc:
JDoc.JDoc, L, ""
JDoc.Date, L, "D.N.y"
L_Str.PoolItem("||", JDoc.Status)+L_Str.PoolItem(" |", JDoc.Done), L, ""
L_lsStore.GetAsSingleLine(JDoc.Comment), L, ""
MDLst.Dir, L, L_MDoc.mft_Pool_1Char
MDLst.Sum, R, ",2-"
@
|#######|##########|##|##############################################|#|#############|
}
*)


(*
$P{ MMode_Top:
@
|====================================================================================|
|                                                                             |
|------------------------------------------------------------------------------------|
|                                               |         室|         室|
|----------------------------------------------------|---------------|---------------|
}
*)

(*
$P{ Car_Total:
MDLst.BoxNbr, L, ""
Mark.Mark, L, ""
Mark.Name, L, ""
?, R, ""
@
|-------------------------------------------------------------------------|----------|
|⮣   #### ઠ #### #############################################|##########|
}
*)

(*
$P{ Car_Total2:
@
|====================================================================================|
}
*)

(*
$P{ MMode_Line:
MMode.MMode, L, ""
MMode.Name, L, ""
?, R, ""
?, R, ""
@
|### ################################################|###############|###############|
}
*)

(*
$P{ MMode_Bot:
@
=(c) Polak============================================================================
}
*)

 PRIVATE PROCEDURE Create_MDLst();
 BEGIN
  CREATE_TABLE(MDLst, , "ப -");

  CREATE_FIELD(MDLst, XDocKindId, L_XDoc.tXDocKindId,   , , , " (७) 㬥");
  CREATE_FIELD(MDLst, XDocId,     L_XDoc.tXDocId,       , , , "Id 㬥");
  CREATE_FIELD(MDLst, BoxNbr,     LIKE(Car.BoxNbr),     , , , "ࠦ");
  CREATE_FIELD(MDLst, MMode,      LIKE(MDocList.MMode), , , , "");
  CREATE_FIELD(MDLst, Dir,        L_MDoc.tMathFlowType, , , , "ࠢ");
  CREATE_FIELD(MDLst, Math,       LIKE(Math.Math),      , , , "");
  CREATE_FIELD(MDLst, CostItem,   LIKE(MDoc.CostItem),  , , , " 室  室");
  CREATE_FIELD(MDLst, Date,       DATE,                 , , , " 㬥");
  CREATE_FIELD(MDLst, Sum,        L_XObj.tSum,          , "0", , ", 㬬");
  CREATE_FIELD(MDLst, Qnt,        L_XObj.tQnt,          , "0", , ", ⢮");
  CREATE_FIELD(MDLst, VAT,        LIKE(MDocList.VAT),   , "0", , "");
  CREATE_FIELD(MDLst, IsDpl,      SCAL[2],              ,  , , " - 㡫  ⨯ ");

  CREATE_INDEX_AND_LINK(MDLst, MMode,    PLURAL, MMode,    MMode,    USER, , , MMode);
  CREATE_INDEX_AND_LINK(MDLst, Math,     PLURAL, Math,     Math,     USER, , , Math);
  CREATE_INDEX_AND_LINK(MDLst, CostItem, PLURAL, CostItem, CostItem, USER, , , CostItem);

  CREATE_INDEX(MDLst, MDLst,    PLURAL, , , XDocKindId, Date, MMode);
  CREATE_INDEX(MDLst, BoxNbr,   PLURAL, , , BoxNbr, XDocKindId, Date);
  CREATE_INDEX(MDLst, toPrint,  PLURAL, , , XDocKindId, Date);

  SET_VERSION_OF_TABLE(MDLst, 0);
  L_AFM.CreateTemp("MDLst");
 END {Create_MDLst};

 PRIVATE PROCEDURE PrintTotals();
  VAR
   Cir2: NUMERIC[2][2];
 BEGIN
  MAKEPART(R, MMode_Top);
  SELECT(MDLst, MMode);
  WHILE OCCURE(MDLst) DO
   NARROWSEL(MDLst, MMode);
   IF ~!MDLst.MMode THEN
    CONFORM(MDLst, MMode);
    SETZERO(Cir2);
    WHILE OCCURE(MDLst) DO
     PROMPT(" " + MDLst.XDocId);
     L_XDoc.PositionOnXDoc(MDLst.XDocId);
     CONFORM(MDoc, MDocKind);
     IF MDocKind.Activity THEN
      IF (MDLst.Dir = L_MDoc.mdd_Outgoing) | (MDLst.Dir = L_MDoc.mdd_Ingoing) THEN
       INC(Cir2[MDLst.Dir], MDLst.Qnt);
      END;
     END;
     NEXT(MDLst);
    END; (* WHILE OCCURE(MDLst) ... *)
    IF (Cir2[L_MDoc.mft_Debit] # 0) | (Cir2[L_MDoc.mft_Credit] # 0) THEN
     MAKEPART(R, MMode_Line, L_MathR.DefaultFormatCir(Math.Math, Cir2[L_MDoc.mdd_Ingoing]),
                             L_MathR.DefaultFormatCir(Math.Math, Cir2[L_MDoc.mdd_Outgoing]));
    END;
   END;
   NEXTINEXTENDEDSEL(MDLst, MMode);
  END; (* WHILE OCCURE(MDLst) ... *)
 END {PrintTotals};

 PRIVATE PROCEDURE AcceptableMDoc(DocSorts: tDocSorts; DocStorage: LIKE(Storage.Storage)): SCAL[2];
  VAR
   _Dir  : L_MDoc.tMathFlowType;
   Result: SCAL[2];
 BEGIN
  CONFORM(MDoc, MDocKind);
  IF    RepType = rt_All THEN
   Result:=1;
  ELSIF RepType = rt_ByFirm THEN
   Result:=MDoc.Firm = Firm.Firm;
  ELSIF RepType = rt_ByCar THEN
   Result:=MDocKind.MDocKind = L_MDoc.md_NOV;
  END;
  RETURN Result & (!DocStorage | (MDoc.Storage = DocStorage) | (MDoc.Storage2 = DocStorage)) &
                  ((DocSorts = ds_All)                                     |
                   ((DocSorts = ds_Outside) & L_MDoc.IsExternalMDocKind()) |
                   ((DocSorts = ds_Inside)  & L_MDoc.IsInternalMDocKind()));
 END {AcceptableMDoc};

 PRIVATE PROCEDURE AcceptableDir(DocTypes: SCAL[4]; _Dir: LIKE(MDocKind.Dir)): SCAL[2];
 BEGIN
  IF    (DocTypes = dt_All) | (MDocKind.Activity & (DocTypes = dt_Real)) THEN
   RETURN 1;
  ELSIF MDocKind.Activity THEN
   RETURN ((DocTypes = dt_Debit)  & (_Dir = L_MDoc.mdd_Ingoing)) |
          ((DocTypes = dt_Credit) & (_Dir = L_MDoc.mdd_Outgoing));
  ELSE
   RETURN 0;
  END;
 END {AcceptableDir};

 PRIVATE PROCEDURE PutXDocLst(trgXDocId  : L_XDoc.tXDocId;
                              trgIsDpl   : SCAL[2];
                              trgMMode   : LIKE(MDocList.MMode);
                              trgMath    : LIKE(Math.Math);
                              trgCostItem: LIKE(MDoc.CostItem);
                              trgDir     : L_MDoc.tMathFlowType;
                              trgCir0    : L_XObj.tSum;
                              trgCir2    : L_XObj.tQnt;
                              trgVAT     : L_XObj.tSum);
 BEGIN
  MDLst.XDocKindId:=L_XDoc.ExtractXDocKindId(trgXDocId);
  MDLst.XDocId    :=trgXDocId;
  MDLst.MMode     :=trgMMode;
  MDLst.Dir       :=trgDir;
  IF    L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_MDoc THEN
   MDLst.Date      :=MDoc.Date;
   MDLst.BoxNbr    :=MDoc.BoxNbr;
  ELSIF L_XDoc.ExtractXDocType(trgXDocId) = L_XDoc.xdt_JDoc THEN
   MDLst.Date      :=JDoc.Date;
   MDLst.BoxNbr    :=EMPTYOF(MDLst.BoxNbr);
  END;
  MDLst.Math      :=trgMath;
  MDLst.CostItem  :=trgCostItem;
  MDLst.Sum       :=trgCir0;
  MDLst.Qnt       :=trgCir2;
  MDLst.VAT       :=trgVAT;
  MDLst.IsDpl     :=trgIsDpl;
  INSERT(MDLst);
 END {PutXDocLst};

 PRIVATE PROCEDURE extPutMDLst(_IsDpl   : SCAL[2];
                               _MMode   : LIKE(MDocList.MMode);
                               _Math    : LIKE(Math.Math);
                               _CostItem: LIKE(MDoc.CostItem);
                               _Dir     : L_MDoc.tMathFlowType;
                               _Cir0    : L_XObj.tSum;
                               _Cir2    : L_XObj.tQnt;
                               _VAT     : L_XObj.tSum);
 BEGIN
  PutXDocLst(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), _IsDpl, _MMode, _Math, _CostItem, _Dir, _Cir0, _Cir2, _VAT);
 END {extPutMDLst};

 PRIVATE PROCEDURE PutMDLst(_MMode    : LIKE(MDocList.MMode);
                            _Math     : LIKE(Math.Math);
                            _CostItem : LIKE(MDoc.CostItem);
                            DocStorage: LIKE(Storage.Storage));
  VAR
   _IsDpl: SCAL[2];
 BEGIN
  _IsDpl:=0;
  IF !DocStorage | (MDoc.Storage = DocStorage) THEN
   extPutMDLst(_IsDpl, _MMode, _Math, _CostItem, L_MDoc.getMDocListMathFlowType(),
               MDocList.Sum, L_MDoc.GetMDocListCir2(), MDocList.VAT);
   _IsDpl:=1;
  END;
  IF ~!MDoc.Storage2 & (!DocStorage | (MDoc.Storage2 = DocStorage)) THEN
   extPutMDLst(_IsDpl, _MMode, _Math, _CostItem, L_MDoc.InvertMathFlowType(L_MDoc.getMDocListMathFlowType()),
               MDocList.Sum, L_MDoc.GetMDocListCir2(), MDocList.VAT);
  END;
 END {PutMDLst};

 PRIVATE PROCEDURE MakeExcelTop();
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", "");
  END;
  L_Basis.wb_WrStr("F", " 㬥");
  L_Basis.wb_WrStr("F", " 㬥");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "ﭨ");
  L_Basis.wb_WrStr("F", "ࠡ⠭");
  L_Basis.wb_WrStr("F", " 樨");
  L_Basis.wb_WrStr("F", " 樨");
  L_Basis.wb_WrStr("F", "࣠");
  L_Basis.wb_WrStr("F", "࣠");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", " ࠊ");
  L_Basis.wb_WrStr("F", " ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "2");
  L_Basis.wb_WrStr("F", "2");
  L_Basis.wb_WrStr("F", "ꥪ");
  L_Basis.wb_WrStr("F", "ꥪ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", " ꥪ⠊");
  L_Basis.wb_WrStr("F", " ꥪ");
  L_Basis.wb_WrStr("F", "ॣ");
  L_Basis.wb_WrStr("F", "ॣ");
  L_Basis.wb_WrStr("F", " ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "⢮");
  L_Basis.wb_WrStr("F", "㬬");
  L_Basis.wb_WrStr("F", "室騩 ");
  L_Basis.wb_WrStr("F", "⭨");
  L_Basis.wb_WrStr("F", "⭨");
  L_Basis.wb_WrStr("F", "ਬ砭");
  L_Basis.wb_WrStr("F", " 㬬");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "፮");
  L_Basis.wb_WrStr("F", "");
L_Basis.wb_WrStr("F", "");
L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_TermLine("F");
 END {MakeExcelTop};

 PRIVATE PROCEDURE MakeSubTitle(DoExcel: SCAL[2]; PartName: STRING[]);
 BEGIN
  IF ~DoExcel THEN
   MAKEPART(R, ^("st_" + PartName));
  END;
 END {MakeSubTitle};

 PRIVATE PROCEDURE MakeExcelLine(_xdt: L_XDoc.tXDocType;
                                 _Dir: L_MDoc.tMathFlowType;
                                 _Qnt: L_XObj.tQnt;
                                 _Sum: L_XObj.tSum;
                                 _VAT: LIKE(MDocList.VAT));
 BEGIN
  IF _xdt = L_XDoc.xdt_MDoc THEN
   IF wMF THEN
    CONFORM(MDoc, MyFirm);
    L_Basis.wb_WrScl("F", MyFirm.MyFirm);
    L_Basis.wb_WrStr("F", MyFirm.vzSign);
   END;
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", L_MDoc.MDocKindNick(MDoc.MDocKind, 1));
   L_Basis.wb_WrScl("F", MDoc.MDoc);
   L_Basis.wb_WrDat("F", MDoc.Date);
   L_Basis.wb_WrStr("F", L_Str.PoolItem("⮢|஢|㫨஢", MDoc.Status));
   L_Basis.wb_WrStr("F", L_Str.PoolItem("-|+", MDoc.Done));
   CONFORM(MDoc, Contract);
   CONFORM(MDoc,  Firm);
  ELSE
   IF wMF THEN
    CONFORM(JDoc, MyFirm);
    L_Basis.wb_WrScl("F", MyFirm.MyFirm);
    L_Basis.wb_WrStr("F", MyFirm.vzSign);
   END;
   L_Basis.wb_WrStr("F", "");
   L_Basis.wb_WrStr("F", L_JDoc.JDocKindNick(JDoc.JDocKind));
   L_Basis.wb_WrScl("F", JDoc.JDoc);
   L_Basis.wb_WrDat("F", JDoc.Date);
   L_Basis.wb_WrStr("F", L_Str.PoolItem("⮢|஢|㫨஢", JDoc.Status));
   L_Basis.wb_WrStr("F", L_Str.PoolItem("-|+", JDoc.Done));
   L_General.CLEAR("Contract");
   L_General.CLEAR("Firm");
   L_General.CLEAR("MDoc");
  END;
  IF OCCURE(Dest) THEN
   L_Basis.wb_WrScl("F", Dest.Dest);
   L_Basis.wb_WrStr("F", Dest.Name);
  ELSE
   L_Basis.wb_WrStr("F", "----");
   L_Basis.wb_WrStr("F", "-");
  END;
  IF OCCURE(Firm) THEN
   L_Basis.wb_WrScl("F", Firm.Firm);
   L_Basis.wb_WrStr("F", Firm.Name);
  ELSE
   L_Basis.wb_WrStr("F", "----");
   L_Basis.wb_WrStr("F", "-");
  END;
  IF OCCURE(Contract) THEN
   CONFORM(Contract, CntrT);
   L_Basis.wb_WrScl("F", Contract.Contract);
   L_Basis.wb_WrStr("F", Contract.Name);
   L_Basis.wb_WrStr("F", Contract.SrcNbr);
   L_Basis.wb_WrStr("F", L_Cntr.GetContractType_asStr());
   L_Basis.wb_WrScl("F", CntrT.CntrT);
   L_Basis.wb_WrStr("F", CntrT.Name);
  ELSE
   L_Basis.wb_WrStr("F", "-------");
   L_Basis.wb_WrStr("F", "-");
   L_Basis.wb_WrStr("F", "-");
   L_Basis.wb_WrStr("F", "-");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", "-");
  END;
  IF OCCURE(MDoc) & ~!MDoc.Storage THEN
   CONFORM(MDoc, Storage);
   L_Basis.wb_WrScl("F", Storage.Storage);
   L_Basis.wb_WrStr("F", Storage.Name);
  ELSE
   L_Basis.wb_WrStr("F", "-------");
   L_Basis.wb_WrStr("F", "-");
  END;
  IF OCCURE(MDoc) & ~!MDoc.Storage2 THEN
   CONFORM(MDoc, Storage2);
   L_Basis.wb_WrScl("F", Storage2.Storage2);
   L_Basis.wb_WrStr("F", Storage2.Name);
  ELSE
   L_Basis.wb_WrStr("F", "-------");
   L_Basis.wb_WrStr("F", "-");
  END;
  IF OCCURE(Math) THEN
   L_Basis.wb_WrScl("F", Math.Math);
   L_Basis.wb_WrStr("F", Math.Name);
   L_Basis.wb_WrStr("F", L_MathR.DefaultMUnitSign(Math.Math));
   L_Basis.wb_WrScl("F", MathType.MathType);
   L_Basis.wb_WrStr("F", MathType.Name);
   CONFORM(Math, CarUnit);
  ELSE
   L_Basis.wb_WrStr("F", "-----");
   L_Basis.wb_WrStr("F", "-");
   L_Basis.wb_WrStr("F", "-");
   L_Basis.wb_WrStr("F", "--");
   L_Basis.wb_WrStr("F", "-");
  END;
  IF OCCURE(CarUnit) THEN
   L_Basis.wb_WrStr("F", CarUnit.CarUnit);
   L_Basis.wb_WrStr("F", CarUnit.Name);
  ELSE
   L_Basis.wb_WrStr("F", "----");
   L_Basis.wb_WrStr("F", "-");
  END;
  L_Basis.wb_WrStr("F", L_Str.PoolItem(L_MDoc.mft_Pool_1Char, _Dir));
  IF OCCURE(MMode) THEN
   L_Basis.wb_WrStr("F", L_MathR.MModeStr(MMode.MMode));
  ELSE
   L_Basis.wb_WrStr("F", "---");
  END;
  L_Basis.wb_WrNum("F", _Qnt, 2);
  L_Basis.wb_WrNum("F", _Sum, 2);
  IF _xdt = L_XDoc.xdt_MDoc THEN
   L_Basis.wb_WrStr("F", MDoc.SrcNbr);
   L_Basis.wb_WrScl("F", MDoc.TSN);
   CONFORM(MDoc,  Man);
   L_Basis.wb_WrStr("F", Man.Name);
   L_Basis.wb_WrStr("F", P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Note));
  ELSE
   L_Basis.wb_WrStr("F", JDoc.SrcNbr);
   L_Basis.wb_WrScl("F", "-");
   L_Basis.wb_WrStr("F", "---");
   L_Basis.wb_WrStr("F", L_lsStore.Get(JDoc.Comment));
  END;
  L_Basis.wb_WrNum("F", _Sum+_VAT, 2);
  L_Basis.wb_WrNum("F", _VAT, 2);
  IF OCCURE(MDoc) & ~!MDoc.BoxNbr THEN
   L_Car.StandOnCarLog(MDoc.BoxNbr, MDoc.Date);
   L_Basis.wb_WrScl("F", CarLog.BoxNbr);
   L_Basis.wb_WrStr("F", CarLog.StateNbr);
   L_Basis.wb_WrScl("F", CarLog.Column);
  ELSE
   L_Basis.wb_WrScl("F", "");
   L_Basis.wb_WrStr("F", "----");
   L_Basis.wb_WrStr("F", "-");
  END;
  IF OCCURE(CostItem) THEN
L_Basis.wb_WrScl("F", CostItem.CostItem);
L_Basis.wb_WrStr("F", CostItem.Name);
   L_Basis.wb_WrScl("F", CostItem.CostItem);
   L_Basis.wb_WrStr("F", CostItem.Name);
  ELSE
L_Basis.wb_WrStr("F", "-------");
L_Basis.wb_WrStr("F", "-");
   L_Basis.wb_WrStr("F", "-------");
   L_Basis.wb_WrStr("F", "-");
  END;
  L_Basis.wb_TermLine("F");
 END {MakeExcelLine};

 PRIVATE PROCEDURE MakeLine(DoExcel: SCAL[2]; PartName: STRING[]);
  VAR
   s: STRING[];
 BEGIN
  IF DoExcel THEN
   CONFORM(MDLst, MMode);
   MakeExcelLine(L_XDoc.ExtractXDocType(MDLst.XDocId), MDLst.Dir, MDLst.Qnt, MDLst.Sum, MDLst.VAT);
  ELSE
   SETEMPTY(s);
   MAKEPART(R, ^("rl_" + PartName));
   IF    curObject = cur_Math THEN
    IF ~!MDLst.MMode THEN
     s:=" " + Str.Align(L_MathR.DefaultFormatCir(Math.Math, MDLst.Qnt), 10, RIGHT) +
        " " + L_MathR.MModeStr(MDLst.MMode);
    ELSE
     s:="               ";
    END;
   END;
   L_XDoc.sl_AddItem(MDLst.XDocId, L_XDoc.extXDocStr(MDLst.XDocId, L_XDoc.xdast_wStatus) + s);
  END;
 END {MakeLine};

 PRIVATE PROCEDURE ExecuteSetupDialog(DialogTitle   : STRING[];
                                      VAR DoExcel   : SCAL[2];
                                      VAR DocSorts  : tDocSorts;
                                      VAR DocTypes  : SCAL[4];
                                      VAR DocStorage: LIKE(Storage.Storage);
                                      VAR DocStatus : SCAL[2][3]);
  VAR
   SetStorage   : SCAL[2];
   StorageAsStr : STRING[];
 BEGIN
  StorageAsStr:=" ";
  SetStorage:=~!DocStorage;
  IF SetStorage THEN
   SEARCH(Storage, Storage, , DocStorage);
   StorageAsStr:=StorageAsStr + Storage.Storage + " " + Storage.Name;
  END;
  STDFORM(L_StdFrm.sf_Choice( "ଠ %#####%                               " +
                             "|" +
                             "|롮 ᮡ⥩  㬥⮢:         " +
                             "|" +
                             "| ⢨          %#################%" +
                             "|" +
                             "|ࠢ               %#################%" +
                             "|" +
                             "|%###########################################%" +
                             "|" +
                             "|%###########################################%" +
                             "|%###########################################%" +
                             "|%###########################################%",
                             "%<|Excel>I" +
                             "%AI" +
                             "%AI" +
                             "%<" + Str.Align(StorageAsStr, 38, LEFT) + ">" + L_Str.PoolItem("NE|E", SetStorage) +
                             "%<⮢>E" +
                             "%<஢>E" +
                             "%<㫨஢>E"),
          DialogTitle,
          ,
          1,
          DoExcel, dsPool, DocSorts, dtPool, DocTypes, SetStorage,
          DocStatus[L_MDoc.st_Prepared], DocStatus[L_MDoc.st_Passed], DocStatus[L_MDoc.st_Canceled]);
  IF ~SetStorage THEN
   SETEMPTY(DocStorage);
  END;
  IF DoExcel THEN
   L_General.Assert(L_Excel.ExcelInstalled(), "Excel  ⠭");
   wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  END;
 END {ExecuteSetupDialog};

 PRIVATE PROCEDURE AcceptableItem(_Math    : LIKE(Math.Math);
                                  _CostItem: LIKE(CostItem.CostItem)): SCAL[2];
 BEGIN
  RETURN ((curObject = cur_Math    ) & (_Math     = Math.Math        )) |
         ((curObject = cur_CostItem) & (_CostItem = CostItem.CostItem)) ;
 END {AcceptableItem};

 PRIVATE PROCEDURE psmdl_SetupField(Field: STRING[]): NUMERIC[0];
 BEGIN
  IF    ~!MDocList.^Field THEN
   RETURN MDocList.^Field;
  ELSIF ~!MDoc.^Field THEN
   RETURN MDoc.^Field;
  ELSE
   RETURN EMPTYOF(NUMERIC[0]);
  END;
 END {psmdl_SetupField};

 PRIVATE PROCEDURE PutSingleMDocList(DocStorage: LIKE(Storage.Storage));
  VAR
   _Math    : LIKE(Math.Math);
   _CostItem: LIKE(MDoc.CostItem);
 BEGIN
  PROMPT(L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc) + " " + MDocList.MDLNbr);
  _Math    :=psmdl_SetupField("Math");
  _CostItem:=psmdl_SetupField("CostItem");
  PutMDLst(MDocList.MMode, _Math, _CostItem, DocStorage);
 END {PutSingleMDocList};

 PRIVATE PROCEDURE DefinePartName(): STRING[];
  VAR
   _xdt: L_XDoc.tXDocType;
   _xdk: L_XDoc.tXDocKind;
   _xd : L_XDoc.tXDoc;
 BEGIN
  L_XDoc.DecodeXDocId(MDLst.XDocId, _xdt, _xdk, _xd);
  IF _xdt = L_XDoc.xdt_MDoc THEN
   SEARCH(MDocKind, MDocKind, , _xdk);

   IF    curObject = cur_Math THEN
    IF Math.MathKind = L_MathR.mathk_KeyAs THEN
     IF L_MDoc.KeyAssetsMDoc(_xdk) THEN
      RETURN "KeyAs";
     ELSE
      RETURN "Ext1";
     END;
    END;
   END;

   IF    !MDLst.Qnt & !MDLst.Sum THEN
    RETURN "Dum";
   ELSIF L_MDoc.IsExternalMDocKind() THEN
    IF !MDLst.Qnt THEN
     RETURN "Ext1";
    ELSE
     RETURN "Ext";
    END;
   ELSIF _xdk = L_MDoc.md_NOV THEN
    RETURN "NOV";
   ELSIF _xdk = L_MDoc.md_ViP THEN
    RETURN "ViP";
   ELSIF _xdk = L_MDoc.md_RNR THEN
    RETURN "Int";
   ELSIF _xdk = L_MDoc.md_MSP THEN
    RETURN "MSP";
   ELSIF L_MDoc.IsMDoc_woMath(_xdk) THEN
    RETURN "Distrib";
   ELSE
    RETURN "TOV";
   END;
  ELSE
   SEARCH(JDocKind, JDocKind, , _xdk);
   RETURN "JDoc";
  END;
 END {DefinePartName};

 PRIVATE PROCEDURE PrintSingleXDocKind(DoExcel       : SCAL[2];
                                       NeedPrintTitle: SCAL[2];
                                       VAR Cir2      : NUMERIC[2]);
  VAR
   PartName  : STRING[];
   PrintTitle: SCAL[2];
 BEGIN
  PartName:=DefinePartName();
  PrintTitle:=NeedPrintTitle;
  WHILE OCCURE(MDLst) DO
   PROMPT(" " + MDLst.XDocId);
   L_XDoc.PositionOnXDoc(MDLst.XDocId);
   IF    L_XDoc.ExtractXDocType(MDLst.XDocId) = L_XDoc.xdt_MDoc THEN
    CONFORM(MDoc,  Dest);
    CONFORM(MDoc,  MDocKind);
   END;
   CONFORM(MDLst, Math);
   IF OCCURE(Math) THEN
    CONFORM(Math,  MathType);
   END;
   CONFORM(MDLst, CostItem);
   IF PrintTitle THEN
    MakeSubTitle(DoExcel, PartName);
    PrintTitle:=0;
   END;
   IF ~MDLst.IsDpl THEN
    MakeLine(DoExcel, PartName);
   END;
   IF ~!MDLst.Qnt THEN
    INC(Cir2, MDLst.Qnt);
   END;
   NEXT(MDLst);
  END; (* WHILE OCCURE(MDLst) ... *)
 END {PrintSingleXDocKind};

 PRIVATE PROCEDURE MSWhr_DoBySelectedMDoc(DoExcel   : SCAL[2];
                                          DocSorts  : tDocSorts;
                                          DocStorage: LIKE(Storage.Storage);
                                          DocStatus : SCAL[2][3];
                                          BPer,
                                          EPer      : DATE);
 BEGIN
  SRCINSEL(MDoc, GE, , BPer);
  WHILE OCCURE(MDoc) & (MDoc.Date <= EPer) DO
   IF DocStatus[MDoc.Status] & AcceptableMDoc(DocSorts, DocStorage) THEN
    IF DoExcel | (MDoc.MDocKind = L_MDoc.md_RNR) THEN
     CONFORM(MDoc, MDocList);
     WHILE OCCURE(MDocList) DO
      PutSingleMDocList(DocStorage);
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList) ... *)
    ELSE
     IF L_MDoc.IsExternalMDocKind() THEN
      extPutMDLst(0, EMPTYOF(MDocList.MMode), MDoc.Math, MDoc.CostItem, L_MDoc.mft_None,
                  MDoc.Total, EMPTYOF(MDocList.Qnt), EMPTYOF(MDocList.VAT));
     ELSE
      extPutMDLst(0, EMPTYOF(MDocList.MMode), MDoc.Math, MDoc.CostItem, L_MDoc.mft_None,
                  EMPTYOF(MDocList.Sum), EMPTYOF(MDocList.Qnt), EMPTYOF(MDocList.VAT));
     END;
    END;
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) *)
 END {MSWhr_DoBySelectedMDoc};

 PRIVATE PROCEDURE PrintedDocConditionStr(DocStatus: SCAL[2][3]; DocStorage: LIKE(Storage.Storage)): STRING[];
  VAR
   S: STRING[];
 BEGIN
  S:="";
  IF DocStatus[L_MDoc.st_Prepared] THEN
   S:=S + "⮢";
  END;
  IF DocStatus[L_MDoc.st_Passed] THEN
   IF ~!S THEN
    S:=S + ", ";
   END;
   S:=S + "஢";
  END;
  IF DocStatus[L_MDoc.st_Canceled] THEN
   IF ~!S THEN
    S:=S + ", ";
   END;
   S:=S + "㫨஢";
  END;
  IF ~!DocStorage THEN
   SEARCH(Storage, Storage, , DocStorage);
   S:=S + " [ " + Storage.Storage + "]";
  END;
  S:="(" + S + ")";
  RETURN S;
 END {PrintedDocConditionStr};

 PRIVATE PROCEDURE MSWhr_Do_ByJDocList(trgXObject: LIKE(XObject.XObject);
                                       BPer,
                                       EPer      : DATE;
                                       DocStatus : SCAL[2][]);
  VAR
   trgOrigin : L_XObj.tOrigin;
   jdlPassCnt: SCAL[2];
   curDir    : L_MDoc.tMathFlowType;
 BEGIN
  L_General.CallUs(SEARCH(XObject, XObject, trgXObject));
  trgOrigin:=XObject.Origin;
  FOR_EACH jdlPassCnt DO
   IF jdlPassCnt = 0 THEN
    SETSEL(JDocList, XObject,  trgXObject);
   ELSE
    SETSEL(JDocList, XObject2, trgXObject);
   END;
   SRCINSEL(JDocList, GE, , BPer);
   WHILE OCCURE(JDocList) & (JDocList.Date <= EPer) DO
    CONFORM(JDocList, JDoc);
    IF DocStatus[JDoc.Status] THEN
     IF jdlPassCnt = 0 THEN
      SEARCH(Apport, Apport, , JDocList.Apport);
     ELSE
      SEARCH(Apport, Apport, , JDocList.Apport2);
     END;
     IF Apport.CirType = L_Acnt.ct_Credit THEN
      curDir:=L_MDoc.mft_Credit;
     ELSE
      curDir:=L_MDoc.mft_Debit;
     END;
     IF trgOrigin = L_XObj.o_CostItem THEN
      PutXDocLst(JDoc.XDocId, 0, EMPTYOF(MDocList.MMode),
                 EMPTYOF(Math.Math), CostItem.CostItem,
                 curDir, JDocList.Sum, 0, 0);
     ELSE
      PutXDocLst(JDoc.XDocId, 0, EMPTYOF(MDocList.MMode),
                 Math.Math, EMPTYOF(CostItem.CostItem),
                 curDir, JDocList.Sum, JDocList.Qnt, 0);
     END;
    END;
    NEXT(JDocList);
   END; (* WHILE OCCURE(JDocList) ... *)
  END (* FOR_EACH jdlPassCnt ... *);
 END {MSWhr_Do_ByJDocList};

 PRIVATE PROCEDURE MSWhr_Do(TimeCond: L_General.tTimeCond);
  VAR
   BPer,
   EPer        : DATE;
   Prefix,
   Title1,
   Title2,
   RepLine,
   DialogTitle,
   SubTitle    : STRING[];
   DocSorts    : SCAL[3];
   DocTypes    : SCAL[4];
   DocStorage  : LIKE(Storage.Storage);
   DocStatus   : SCAL[2][3];
   DoExcel     : SCAL[2];
   Cir2        : L_XObj.tQnt;
   _VAT        : L_XObj.tSum;
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  DocSorts  :=ds_All;
  DocTypes  :=dt_All;
  DoExcel   :=0;
  DocStorage:=L_Stock.DefaultStorage();
  DocStatus[L_MDoc.st_Prepared]:=1;
  DocStatus[L_MDoc.st_Passed]  :=1;
  DocStatus[L_MDoc.st_Canceled]:=0;
  IF    curObject = cur_Math THEN
   Prefix:="M";
   L_General.Assert(ACCESS(Math), " ࠭ ⥪騩 ");
   CONFORM(Math, MathType);
   Title1     :="樨  ꥪ "+Math.Math+" "+Math.Name;
   DialogTitle:=" 樨  ";
  ELSIF curObject = cur_CostItem THEN
   Prefix:="C";
   L_General.Assert(ACCESS(CostItem), " ࠭ ⥪  室  室");
   Title1     :="樨   "+CostItem.CostItem+" "+CostItem.Name;
   DialogTitle:=" 樨  ";
  ELSIF curObject = cur_Storage THEN
   Prefix:="S";
   L_General.Assert(ACCESS(Storage), " ࠭ ⥪饥  ࠭");
   Title1     :="樨   "+Storage.Storage+" "+Storage.Name;
   DialogTitle:=" 樨  ";
   SETEMPTY(DocStorage);
  END;
  IF    TimeCond = L_General.timeCond_InIntvl THEN
   BPer  :=Memo.ud_fr();
   EPer  :=Memo.ud_ut();
   Title2:=" ਮ  " + L_DatTim.DateStr(BPer) + "  " + L_DatTim.DateStr(EPer);
   DialogTitle:=DialogTitle + ",  ਮ ";
  ELSIF TimeCond = L_General.timeCond_Entire THEN
   BPer  :=MINOF(DATE);
   EPer  :=EMPTYOF(DATE);
   Title2:=" ଠ";
   DialogTitle:=DialogTitle + ",  ଠ ";
  ELSE
   L_General.CallUs(0);
  END;

  IF RepType = rt_ByCar THEN
   Prefix     :="B";
   Title2     :=Title2 + " ( ࠧ१ )";
  ELSE
   ExecuteSetupDialog(DialogTitle, DoExcel, DocSorts, DocTypes, DocStorage, DocStatus);
  END;

  IF DoExcel THEN
   RepName:="MSWhr";
  ELSE
   RepName:="MSW" + Prefix + L_Str.PoolItem("E|I", TimeCond = L_General.timeCond_InIntvl);
  END;
  Create_MDLst();
  IF curObject = cur_Storage THEN
   SELECT(MDoc, Storage, , Storage.Storage);
   MSWhr_DoBySelectedMDoc(DoExcel, DocSorts, DocStorage, DocStatus, BPer, EPer);
   SELECT(MDoc, Storage2, , Storage.Storage);
   MSWhr_DoBySelectedMDoc(DoExcel, DocSorts, DocStorage, DocStatus, BPer, EPer);
  ELSE
   IF    curObject = cur_Math THEN
    SELECT(MDoc, Math, , Math.Math);
   ELSIF curObject = cur_CostItem THEN
    SELECT(MDoc, CostItem, , CostItem.CostItem);
   END;
   MSWhr_DoBySelectedMDoc(DoExcel, DocSorts, DocStorage, DocStatus, BPer, EPer);
   IF    curObject = cur_Math THEN
    SETSEL(MDocList, Math, Math.Math);
   ELSIF curObject = cur_CostItem THEN
    SETSEL(MDocList, CostItem, CostItem.CostItem);
   END;
   SRCINSEL(MDocList, GE, , BPer);
   WHILE OCCURE(MDocList) & (MDocList.Date <= EPer) DO
    CONFORM(MDocList, MDoc);
    IF OCCURE(MDoc) THEN
     CONFORM(MDoc, MDocKind);
     IF DocStatus[MDoc.Status] & AcceptableMDoc(DocSorts, DocStorage) & AcceptableDir(DocTypes, L_MDoc.getMDocListMathFlowType()) THEN
      PutSingleMDocList(DocStorage);
     END;
    ELSE
     L_General.CallUs(~L_AR.DatabaseIsTransparent());
    END;
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)

   IF RepType # rt_ByCar THEN
    IF    curObject = cur_CostItem THEN
     MSWhr_Do_ByJDocList(CostItem.XObject, BPer, EPer, DocStatus);
    ELSIF curObject = cur_Math THEN
     SELECT(mItem, Math, , Math.Math);
     WHILE OCCURE(mItem) DO
      MSWhr_Do_ByJDocList(mItem.XObject, BPer, EPer, DocStatus);
      NEXT(mItem);
     END; (* WHILE OCCURE(mItem) ... *)
    END;
   END;
  END; (* IF curObject ... *)

  IF DoExcel THEN
   FIO.Open(F, L_General.NameConnection(RepName), "rep", Create);
   MakeExcelTop();
  ELSE
   L_XDoc.sl_Init(Title2);
   OPENREP(R, L_General.NameConnection(RepName), Create);
   MAKEPART(R, RepTop, Title1, PrintedDocConditionStr(DocStatus, DocStorage), Title2);
  END;

  IF RepType = rt_ByCar THEN
(*!*)
   SEARCH(MDocKind, MDocKind, , L_MDoc.md_NOV);
   MakeSubTitle(DoExcel, "NOV");
(*!*)
   SELECT(MDLst, BoxNbr);
   WHILE OCCURE(MDLst) DO
    NARROWSEL(MDLst, BoxNbr);
    SETZERO(Cir2);
    WHILE OCCURE(MDLst) DO
     NARROWSEL(MDLst, XDocKindId);
     PrintSingleXDocKind(DoExcel, 0, Cir2);
     NEXTINEXTENDEDSEL(MDLst, XDocKindId);
    END; (* WHILE OCCURE(MDLst) ... *)
    LAST(MDLst);
    IF ~DoExcel THEN
     L_Car.AccessMark(MDLst.BoxNbr, MDLst.Date);
     MAKEPART(R, Car_Total, L_MathR.DefaultFormatCir(Math.Math, Cir2));
    END;

    IF NEXTINEXTENDEDSEL(MDLst, BoxNbr) THEN
     IF ~DoExcel THEN
      MAKEPART(R, Car_Total2);
     END;
    END;
   END; (* WHILE OCCURE(MDLst) ... *)
  ELSE
   SELECT(MDLst, MDLst);
   WHILE OCCURE(MDLst) DO
    SETZERO(Cir2);
    NARROWSEL(MDLst, XDocKindId);
    PrintSingleXDocKind(DoExcel, 1, Cir2);
    NEXTINEXTENDEDSEL(MDLst, XDocKindId);
   END; (* WHILE OCCURE(MDLst) ... *)
  END;
  IF DoExcel THEN
   FIO.Close(F);
   L_Basis.PlayMakedRunTimeRep(RepName,
                               TimeCond,
                               Str.Slice(Title1, 0, 68),
                               0);
  ELSE
   IF (curObject = cur_Math) & (Math.MathKind = L_MathR.mathk_Math) THEN
    PrintTotals();
   END;
   MAKEPART(R, MMode_Bot);
   CLOSEREP(R);
   L_XDoc.sl_Done();
  END;
 END {MSWhr_Do};

(**********************************)

(*
$P{ Top_MRInv:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
?, C, ""
Firm.Firm, L, ""
Firm.Name, L, ""
@
###################################################################################                                         ########## #####
============================================================================================================================================
|                                          㬥  ਮ  ##########  ##########                                          |
|##########################################################################################################################################|
|------------------------------------------------------------------------------------------------------------------------------------------|
| ࠣ #### ################################################################                                                         |
}

$P{ MDocDir_Top_MRInv:
?, L, "室騥|室騥| ।|᪫᪨ ६饭"
@
|------------------------------------------------------------------------------------------------------------------------------------------|
|##################################################                                                                                        |
|------------------------------------------------------------------------------------------------------------------------------------------|
|      |㬥   |. |C|                                             |        ||        -|             㬬|
|----------|-----------|----------|-|------------------------------------------------|-----------------|---|------------|------------------|
}

$P{ MDocLine_MRInv:
MDoc.Date, L, "D.N.y"
L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L, ""
MDoc.SrcNbr, L, ""
MDoc.Status, L, "||"
?, R, ",2-"
@
|##########|###########|##########|#|                                                |                 |   |            |##################|
}

$P{ Line_MRInv:
Math.Math, L, ""
Math.Name, L, ""
Math.UnitedC, L, ""
L_MathR.DefaultMUnitSign(Math.Math), L, ""
?, R, ""
?, R, ",2-"
@
|          |           |          | |##### ##########################################|#################|###|############|##################|
}

$P{ Bot1_MRInv:
?, R, ",2-"
@
|-----------------------------------------------------------------------------------------------------------------------|------------------|
|ᥣ                                                                                                                  |##################|
}

$P{ Bot_MRInv:
@
=(c) Polak==================================================================================================================================
}
*)

 PRIVATE PROCEDURE MRInv_AccessMDoc();
 BEGIN
  SEARCH(MDoc, MDoc, , MRInv.MDocKind, MRInv.MDoc);
  CONFORM(MDoc, MDocKind);
 END {MRInv_AccessMDoc};

 PRIVATE PROCEDURE MRInv_OneDirection(_Dir    : L_MDoc.tMDocDir;
                                      DocSorts: SCAL[3];
                                      DocTypes: SCAL[4]);
  VAR
   PrintTop  : SCAL[2];
   MDoc_Sum,
   Math_Sum,
   EC_Sum,
   All_Sum   : NUMERIC[2];
   Math_Count: FLOAT;
 BEGIN
  PrintTop:=1;
  All_Sum :=0;

  SELECT(MRInv, MRInv, , _Dir);
  WHILE OCCURE(MRInv) DO
   MRInv_AccessMDoc();
   L_XDoc.sl_AddCurrentXDoc(L_XDoc.xdt_MDoc);
   PROMPT("⮢ : " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   MDoc_Sum:=0;
   SELECT(MDocList, MDLMath, , MDoc.MDocKind, MDoc.MDoc);
   WHILE OCCURE(MDocList) DO
    INC(MDoc_Sum, MDocList.Sum);
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
   IF PrintTop THEN
    PrintTop:=0;
    MAKEPART(R, MDocDir_Top_MRInv, _Dir);
   END;
   MAKEPART(R, MDocLine_MRInv, MDoc_Sum);
   INC(All_Sum, MDoc_Sum);
   FIRST(MDocList);
   WHILE OCCURE(MDocList) DO
    NARROWSEL(MDocList, Math);

    Math_Sum  :=0;
    Math_Count:=0;
    WHILE OCCURE(MDocList) DO
     PROMPT(MDocList.MDocKind + " " + MDocList.MDoc + " " + MDocList.MDLNbr);
     INC(Math_Sum,   MDocList.Sum);
     INC(Math_Count, L_MDoc.GetMDocListCir2());
     NEXT(MDocList);
    END; (* WHILE OCCURE(MDocList) ... *)
    LAST(MDocList);
    SEARCH(Math, Math, , MDocList.Math);
    MAKEPART(R, Line_MRInv, L_MathR.DefaultFormatCir(Math.Math, Math_Count),
                      Math_Sum);
    NEXTINEXTENDEDSEL(MDocList, Math);
   END; (* WHILE OCCURE(MDocList) ... *)
   NEXT(MRInv);
  END; (* WHILE OCCURE(MRInv) ... *)
  IF ~PrintTop THEN
   MAKEPART(R, Bot1_MRInv, All_Sum);
  END;
 END {MRInv_OneDirection};

 PRIVATE PROCEDURE MRInv_Do();
  VAR
   DocSorts  : SCAL[3];
   DocTypes  : SCAL[4];
   DoExcel   : SCAL[2];
   DocStorage: LIKE(Storage.Storage);
   DocStatus : SCAL[2][3];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.Assert(ACCESS(Firm), " ⠭ ࠣ");
  DocSorts  :=ds_Outside;
  DocTypes  :=dt_Real;
  DoExcel   :=0;
  DocStorage:=L_Stock.DefaultStorage();
  DocStatus[L_MDoc.st_Prepared]:=1;
  DocStatus[L_MDoc.st_Passed]  :=1;
  DocStatus[L_MDoc.st_Canceled]:=0;
  ExecuteSetupDialog("  㬥  ࠣ ( ਮ) ", DoExcel, DocSorts, DocTypes, DocStorage, DocStatus);
  L_AFM.MakeIndex("MRInv", "Dir     : SCAL[4](*L_MDoc.tMDocDir*);"+
                              "MDocKind: LIKE(MDoc.MDocKind);"+
                              "MDoc    : LIKE(MDoc.MDoc)");
  SELECT(MDoc, Firm, , Firm.Firm);
  WHILE OCCURE(MDoc) DO
   PROMPT("⮢ : " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   CONFORM(MDoc, MDocKind);
   IF L_DatTim.IsActive_Inc(MDoc.Date, Memo.ud_fr(), Memo.ud_ut()) &
      DocStatus[MDoc.Status] & AcceptableMDoc(DocSorts, DocStorage) & AcceptableDir(DocTypes, MDocKind.Dir) THEN
    MRInv.Dir     :=MDocKind.Dir;
    MRInv.MDocKind:=MDoc.MDocKind;
    MRInv.MDoc    :=MDoc.MDoc;
    INSERT(MRInv);
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
  IF DoExcel THEN
   RepName:="MRInv";
   FIO.Open(F, L_General.NameConnection(RepName), "rep", Create);
   MakeExcelTop();
   SELECT(MRInv, MRInv);
   WHILE OCCURE(MRInv) DO
    MRInv_AccessMDoc();
    PROMPT("⮢ : " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
    CONFORM(MDoc,  Car);
    CONFORM(MDoc,  Dest);
    CONFORM(MDoc, CostItem);
    CONFORM(MDoc, MDocList);
    FIRST(MDocList);
    WHILE OCCURE(MDocList) DO
     PROMPT(MDocList.MDocKind + " " + MDocList.MDoc + " " + MDocList.MDLNbr);
     CONFORM(MDocList, Math);
     CONFORM(Math,     MathType);
     CONFORM(MDocList, MMode);
     IF ~!MDocList.CostItem THEN
      CONFORM(MDocList, CostItem);
     END;
     MakeExcelLine(L_XDoc.xdt_MDoc, L_MDoc.getMDocListMathFlowType(), MDocList.Qnt, MDocList.Sum, MDocList.VAT);
     NEXT(MDocList);
    END; (* WHILE OCCURE(MDocList) ... *)
    NEXT(MRInv);
   END; (* WHILE OCCURE(MRInv) ... *)
   FIO.Close(F);
   L_Basis.PlayMakedRunTimeRep(RepName,
                               L_General.timeCond_InIntvl,
                               Str.Slice(" 㬥  ࠣ "+Firm.Firm, 0, 68),
                               0);
  ELSE
   RepName:="MSWFI";
   L_XDoc.sl_Init("  ࠣ " + Firm.Firm);
   OPENREP(R, L_General.NameConnection(RepName), Create);
   MAKEPART(R, Top_MRInv, PrintedDocConditionStr(DocStatus, DocStorage));
   MRInv_OneDirection(L_MDoc.mdd_Outgoing,  DocSorts, DocTypes);
   MRInv_OneDirection(L_MDoc.mdd_Ingoing,   DocSorts, DocTypes);
   MRInv_OneDirection(L_MDoc.mdd_Undefined, DocSorts, DocTypes);
   MRInv_OneDirection(L_MDoc.mdd_MSP,       DocSorts, DocTypes);
   MAKEPART(R, Bot_MRInv);
   CLOSEREP(R);
   L_XDoc.sl_Done();
  END;
 END {MRInv_Do};

(*
$P{ Top_MSMriA:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
"室  ᪫  ꥪ "+Math.Math+" "+Math.Name, C, ""
?, C, ""
L_MathR.DefaultMUnitSign(Math.Math), R, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|  |    || |ࠣ     ||         㬬|,%|      ###|         |      |⪫ %|
|       |        | |   |               |   |              |     |         |             |          |      |
|-------|--------|-|---|---------------|---|--------------|-----|---------|-------------|-------------|------|
}
*)

(*
$P{ Line_MSMriA:
MDoc.MDoc, L, ""
MDoc.Date, L, "D.N.Y"
MDoc.Status, L, "||"
Dest.Dest, L, ""
Firm.Firm, L, ""
Firm.Name, L, ""
L_MathR.MModeStr(MMode.MMode), L, ""
MDLst.Sum+MDLst.VAT, R, ",2-"
GetVAT(), R, "2."
L_MathR.DefaultFormatCir(Math.Math, MDLst.Qnt), R, ""
?, R, ",2-"
?, R, ",2-"
?, R, "1."
@
|#######|########|#|###|#### ##########|###|##############|#####|#########|#############|#############|######|
}
*)

(*
$P{ Bot_MSMriA:
?, R, ",2-"
?, R, ""
?, R, ",2-"
@
|------------------------------------------|--------------|-----|---------|-------------|-------------|------|
|ᥣ                                     |##############|     |#########|#############|             |   X  |
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE GetVAT(): NUMERIC[2];
 BEGIN
  IF MDLst.Sum # 0 THEN
   RETURN MDLst.VAT / MDLst.Sum * 100;
  ELSE
   RETURN 0;
  END;
 END {GetVAT};

 PRIVATE PROCEDURE CountDeviation(Price, AveragePrice: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF AveragePrice # 0 THEN
   RETURN (Price - AveragePrice) / AveragePrice * 100;
  ELSE
   RETURN 0;
  END;
 END {CountDeviation};

 PRIVATE PROCEDURE MSMriA_Do();
  VAR
   FullPrice,
   Price,
   TotalSum,
   TotalAmn,
   AveragePrice: NUMERIC[2];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.Assert(ACCESS(Math), " ࠭ ");
  RepName:="MSWNI";
  L_XDoc.sl_Init("室  ᪫  ਮ");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top_MSMriA, " ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut()));
  Create_MDLst();
  SETZERO(TotalSum, TotalAmn, AveragePrice);
  SETSEL(MDocList, Math, Math.Math);
  SRCINSEL(MDocList, GE, , Memo.ud_fr());
  WHILE OCCURE(MDocList) & (MDocList.Date <= Memo.ud_ut()) DO
   CONFORM(MDocList, MDoc);
   PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   IF (MDoc.Status # L_MDoc.st_Canceled) &
      ((L_Pmnt.IsAcptMDocKind(MDoc.MDocKind) & L_MDoc.IsIngoingMDocKind(MDoc.MDocKind)) | (MDoc.MDocKind = L_MDoc.md_NPr)) THEN
    INC(TotalSum, MDocList.Sum+MDocList.VAT);
    INC(TotalAmn, MDocList.Qnt);
    PutMDLst(MDocList.MMode, Math.Math, EMPTYOF(CostItem.CostItem), EMPTYOF(Storage.Storage));
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  IF TotalAmn # 0 THEN
   AveragePrice:=TotalSum / TotalAmn;
  END;
  SELECT(MDLst, MDLst);
  WHILE OCCURE(MDLst) DO
   PROMPT(" " + MDLst.XDocId);
   L_XDoc.PositionOnXDoc(MDLst.XDocId);
   CONFORM(MDLst, MMode);
   CONFORM(MDoc,  Dest);
   CONFORM(MDoc,  Firm);
   IF MDLst.Qnt # 0 THEN
    FullPrice:=(MDLst.Sum+MDLst.VAT) / MDLst.Qnt;
    Price    :=MDLst.Sum / MDLst.Qnt;
   ELSE
    FullPrice:=0;
    Price    :=0;
   END;
   MAKEPART(R, Line_MSMriA, FullPrice, Price, CountDeviation(FullPrice, AveragePrice));
   L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc),
                     L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) +
                     " " + L_DatTim.DateStr(MDoc.Date) +
                     " " + Dest.Dest + " " + Str.Align(Dest.Name, 20, LEFT));
   NEXT(MDLst);
  END; (* WHILE OCCURE(MDLst) ... *)
  MAKEPART(R, Bot_MSMriA, TotalSum, L_MathR.DefaultFormatCir(Math.Math, TotalAmn), AveragePrice);
  L_XDoc.sl_Done();
 END {MSMriA_Do};

 PUBLIC PROCEDURE MSWME();
 BEGIN
  RepType  :=rt_All;
  curObject:=cur_Math;
  MSWhr_Do(L_General.timeCond_Entire);
 END {MSWME};

 PUBLIC PROCEDURE MSWMI();
 BEGIN
  RepType  :=rt_All;
  curObject:=cur_Math;
  MSWhr_Do(L_General.timeCond_InIntvl);
 END {MSWMI};

 PUBLIC PROCEDURE MSWBI();
 BEGIN
  RepType  :=rt_ByCar;
  curObject:=cur_Math;
  MSWhr_Do(L_General.timeCond_InIntvl);
 END {MSWBI};

 PUBLIC PROCEDURE MSWCE();
 BEGIN
  RepType  :=rt_All;
  curObject:=cur_CostItem;
  MSWhr_Do(L_General.timeCond_Entire);
 END {MSWCE};

 PUBLIC PROCEDURE MSWCI();
 BEGIN
  RepType  :=rt_All;
  curObject:=cur_CostItem;
  MSWhr_Do(L_General.timeCond_InIntvl);
 END {MSWCI};

 PUBLIC PROCEDURE MSWSI();
 BEGIN
  RepType  :=rt_All;
  curObject:=cur_Storage;
  MSWhr_Do(L_General.timeCond_InIntvl);
 END {MSWSI};

 PUBLIC PROCEDURE MSWNI();
 BEGIN
  RepType  :=rt_All;
  MSMriA_Do();
 END {MSWNI};

 PUBLIC PROCEDURE MSWFI();
 BEGIN
  RepType  :=rt_ByFirm;
  MRInv_Do();
 END {MSWFI};

END.
