(*
%Copyright   (c) Polak Computer System
%Author      18.05.2002 15:43:23 SAN
%Purpose       ꥪ  (XObject)
%Type        operation
%Specific    SYS
%Modified    22.09.2014 18:36:17 POLAK\San
%Environment
*)

 MODULE MXO;

 IMPORT L_General, L_DatTim, L_XObj, L_MDoc, L_Acnt, L_MathR, L_AcCut, L_PDoc, L_StdFrm,
        Math, Memo, L_Cntr, L_Pmnt, L_XDoc, Str, L_AcsPnt, L_Str, L_JDoc, L_CI, L_AFM, L_Events;

 CONST
  SplitVATPrepayP = 01\08\2007;

 PROCEDURE int_mo_GetXCalcOutRSaldo(_AcCut: LIKE(AcCut.AcCut)): NUMERIC[2];
 BEGIN
  RETURN L_XObj.mo_GetOutRSaldo(_AcCut, Memo.gl_mb());
 END {int_mo_GetXCalcOutRSaldo};

 PROCEDURE mo_GetXCalcOutRSaldo(): NUMERIC[2];
 BEGIN
  RETURN int_mo_GetXCalcOutRSaldo(AcMthL.AcCut);
 END {mo_GetXCalcOutRSaldo};

 PROCEDURE MakeCompleteCir(trgXObject : LIKE(XObject.XObject);
                           trgAcCut   : LIKE(AcCut.AcCut);
                           trgApport  : LIKE(Apport.Apport);
                           trgXObject2: LIKE(XObject.XObject);
                           trgAcCut2  : LIKE(AcCut.AcCut);
                           trgApport2 : LIKE(Apport.Apport);
                           trgSum     : NUMERIC[2]);
  VAR
   trgXDocId: L_XDoc.tXDocId;
   trgSource: L_XObj.tSource;
 BEGIN
  IF trgSum # 0 THEN
   IF L_XObj.E_DoSecondSide(Memo.gl_mb()) THEN
    trgXDocId:=L_XDoc.curXDocId(L_XDoc.xdt_ACalc);
    trgSource:=L_XObj.src_ACalc;
    IF !trgXObject | !trgXObject2 THEN
     L_StdFrm.WrongDB("믮 ஭ ஢ ⨬" +
                      L_StdFrm.HR() + L_XDoc.XDocStr(trgXDocId) + ", ஢  ࠧ१ " + trgAcCut + "  " + trgAcCut2);
    END;
   ELSE
    SETEMPTY(trgXDocId);
    trgSource:=L_XObj.src_Payments;
   END;
   L_XObj.extMakeCompleteCir(0, trgXDocId,
                             +1, Memo.gl_mb(), trgXObject,  trgAcCut,  trgApport,  0,
                                               trgXObject2, trgAcCut2, trgApport2, 0,
                             trgSum, 0, trgSource);
  END;
 END {MakeCompleteCir};

 PRIVATE PROCEDURE MakeCanonicalCir(dbtXObject: LIKE(XObject.XObject);
                                    dbtAcCut  : LIKE(AcCut.AcCut);
                                    crdXObject: LIKE(XObject.XObject);
                                    crdAcCut  : LIKE(AcCut.AcCut);
                                    trgSum    : NUMERIC[2]);
 BEGIN
  MakeCompleteCir(dbtXObject, dbtAcCut, L_Acnt.E_Apport_MoneyDebit (Memo.gl_mb()),
                  crdXObject, crdAcCut, L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb()),
                  trgSum);
 END {MakeCanonicalCir};

 PROCEDURE intMakeCir(trgAcCut   : LIKE(AcCut.AcCut);
                      trgApport  : LIKE(Apport.Apport);
                      trgAcCut2  : LIKE(AcCut.AcCut);
                      trgApport2 : LIKE(Apport.Apport);
                      trgSum     : NUMERIC[2];
                      wCmpl      : SCAL[2]);
  VAR
   trgXObject2: LIKE(XObject.XObject);
 BEGIN
  IF wCmpl THEN
   trgXObject2:=XObject.XObject;
  ELSE
   SETEMPTY(trgXObject2);
  END;
  MakeCompleteCir(XObject.XObject, trgAcCut,  trgApport,
                  trgXObject2,     trgAcCut2, trgApport2,
                  trgSum);
 END {intMakeCir};

 PROCEDURE MakeCir(Sum: NUMERIC[2]);
 BEGIN
  intMakeCir(AcMthL.AcCut, AcMthL.Apport, AcMthL.AcCut2, AcMthL.Apport2, Sum, ~!AcMthL.Origin2);
 END {MakeCir};

 PROCEDURE _୮();
 BEGIN
  MakeCir(-mo_GetXCalcOutRSaldo());
 END {_୮};

 PROCEDURE _();
 BEGIN
  MakeCir(mo_GetXCalcOutRSaldo());
 END {_};

 PROCEDURE _();
  VAR
   _Saldo: L_XObj.tSum;
 BEGIN
  _Saldo:=mo_GetXCalcOutRSaldo();
  IF _Saldo > 0 THEN
   MakeCir(_Saldo);
  END;
 END {_};

 PROCEDURE _୮();
  VAR
   _Saldo: L_XObj.tSum;
 BEGIN
  _Saldo:=mo_GetXCalcOutRSaldo();
  IF _Saldo < 0 THEN
   MakeCir(-_Saldo);
  END;
 END {_୮};

 PRIVATE PROCEDURE GetTargetCostItemXObject(): LIKE(XObject.XObject);
 BEGIN
  TRY [ABORT_AFTER(AA_ON)]
   SEARCH(CostItem, CostItem, , L_kn.Get_wMF(Memo.gl_mb(), L_CI.erkn_VATAccountsBalancing, XObject.MyFirm));
   RETURN CostItem.XObject;
  EXCEPT
  END; (* TRY *)
 END {GetTargetCostItemXObject};

 PROCEDURE _ᠭ();
  VAR
   curSaldo   : L_XObj.tSum;
   trgXObject2: LIKE(XObject.XObject);
   trgAcCut,
   trgAcCut2  : LIKE(AcCut.AcCut);
 BEGIN
  curSaldo:=mo_GetXCalcOutRSaldo();
  IF curSaldo # 0 THEN
   trgXObject2:=GetTargetCostItemXObject();
   TRY [ABORT_AFTER(AA_ON)]
    trgAcCut :=L_Acnt.getAcMthL_AcCut (Memo.gl_mb());
    trgAcCut2:=L_Acnt.getAcMthL_AcCut2(Memo.gl_mb());
   EXCEPT
   END; (* TRY *)
   IF curSaldo < 0 THEN
    MakeCanonicalCir(XObject.XObject, trgAcCut,  trgXObject2,     trgAcCut2, (-1)*curSaldo);
   ELSE
    MakeCanonicalCir(trgXObject2,     trgAcCut2, XObject.XObject, trgAcCut,  (+1)*curSaldo);
   END;
  END;
 END {_ᠭ};

 PRIVATE PROCEDURE WriteOffRecExpSaldo();
  VAR
   x99AcCut,
   trgAcCut,
   cprAcCut,
   curAcCut,
   expAcCut,
   recAcCut  : LIKE(AcCut.AcCut);
   trgXObject: LIKE(XObject.XObject);
   expSaldo,
   recSaldo,
   trgSaldo  : L_XObj.tSum;
 BEGIN
  trgAcCut:=L_Acnt.GetSoftSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_RecExpSaldo);
  IF !trgAcCut THEN
   RETURN
  END;
  x99AcCut  :=L_kn.Get(Memo.gl_mb(), L_AcCut.erkn_Profit_Losses);
  trgXObject:=GetTargetCostItemXObject();

  expAcCut  :=L_Acnt.GetSoftSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItem_Default);

  IF ~!expAcCut THEN
   expSaldo:=(+1) * int_mo_GetXCalcOutRSaldo(expAcCut);
   IF expSaldo # 0 THEN
    cprAcCut:=L_Acnt.GetSoftSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostPrice);
    IF ~!cprAcCut THEN
     MakeCanonicalCir(XObject.XObject, cprAcCut, XObject.XObject, expAcCut, expSaldo);
     curAcCut:=cprAcCut;
    ELSE
     curAcCut:=expAcCut;
    END;
    MakeCanonicalCir(XObject.XObject, trgAcCut, XObject.XObject, curAcCut,        expSaldo);
    MakeCanonicalCir(XObject.XObject, trgAcCut, trgXObject,      curAcCut, (-1) * expSaldo);
   END;
  ELSE
   expSaldo:=0;
  END;

  recAcCut:=L_Acnt.GetSoftSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItemSale);
  IF ~!recAcCut THEN
   recSaldo:=(-1) * int_mo_GetXCalcOutRSaldo(recAcCut);
   IF recSaldo # 0 THEN
    MakeCanonicalCir(XObject.XObject, recAcCut, XObject.XObject, trgAcCut,        recSaldo);
    MakeCanonicalCir(trgXObject,      recAcCut, XObject.XObject, trgAcCut, (-1) * recSaldo);
   END;
  ELSE
   recSaldo:=0;
  END;
  trgSaldo:=recSaldo - expSaldo;
  IF trgSaldo < 0 THEN
   MakeCanonicalCir(trgXObject, x99AcCut, trgXObject, trgAcCut, (-1) * trgSaldo);
  ELSIF trgSaldo > 0 THEN
   MakeCanonicalCir(trgXObject, trgAcCut, trgXObject, x99AcCut, (+1) * trgSaldo);
  END;
 END {WriteOffRecExpSaldo};

 PROCEDURE GetComplementaryApport(_Apport: LIKE(Apport.Apport)): LIKE(Apport.Apport);
 BEGIN
  IF    _Apport = L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb()) THEN
   RETURN L_Acnt.E_Apport_MoneyDebit(Memo.gl_mb());
  ELSIF _Apport = L_Acnt.E_Apport_MoneyDebit(Memo.gl_mb()) THEN
   RETURN L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb());
  ELSE
   L_General.CallUs(0);
  END;
 END {GetComplementaryApport};

 PROCEDURE VATDst_TransitAcCut(): LIKE(AcCut.AcCut);
 BEGIN
  RETURN L_AcCut.erkn_Get(Memo.gl_mb(), L_AcCut.erkn_BoughtVATTransit);
 END {VATDst_TransitAcCut};

 PROCEDURE VATDst_TransitAcCut2(): LIKE(AcCut.AcCut);
 BEGIN
  RETURN L_AcCut.erkn_Get(Memo.gl_mb(), L_AcCut.erkn_VATAccumulation);
 END {VATDst_TransitAcCut2};

 PROCEDURE VATDst_TransitApport(): LIKE(Apport.Apport);
 BEGIN
  RETURN L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb());
 END {VATDst_TransitApport};

 PROCEDURE VATDstInCost_AcCut(): LIKE(AcCut.AcCut);
 BEGIN
  RETURN L_AcCut.erkn_GetSoft(Memo.gl_mb(), L_AcCut.erkn_BoughtVATInCost);
 END {VATDstInCost_AcCut};

 PROCEDURE MakeXXCir(_AcCut: LIKE(AcCut.AcCut); _Value: NUMERIC[2]);
 BEGIN
  intMakeCir(VATDst_TransitAcCut(), VATDst_TransitApport(), VATDst_TransitAcCut2(), GetComplementaryApport(VATDst_TransitApport()),
             (-1)*_Value, 1);
  IF _AcCut # VATDstInCost_AcCut() THEN
   intMakeCir(_AcCut, VATDst_TransitApport(), VATDst_TransitAcCut2(), GetComplementaryApport(VATDst_TransitApport()),
              _Value, 1);
  ELSE
   intMakeCir(_AcCut, VATDst_TransitApport(), L_Acnt.fictAcCut, EMPTYOF(Apport.Apport),
              _Value, 0);
  END;
 END {MakeXXCir};

 PROCEDURE SetAcCutArray(VAR Idx: NUMERIC[0]; VAR _AcCuts: LIKE(AcCut.AcCut)[];
                        _AcCut: LIKE(AcCut.AcCut));
 BEGIN
  IF ~!_AcCut THEN
   _AcCuts[Idx]:=_AcCut;
   INC(Idx);
  END;
 END {SetAcCutArray};

 PROCEDURE ();
  CONST
   VATDst_High = 8;
  VAR
   VATDst_AcCuts         : LIKE(AcCut.AcCut)[VATDst_High];
   VATDst_Components     : NUMERIC[2][VATDst_High];
   VATDst_ToDistribute,
   VATDst_ComponentsTotal,
   maxValue,
   _Value,
   Rest                  : NUMERIC[2];
   i,
   IdxOfMaxValue         : NUMERIC[0];
 BEGIN
  VATDst_ToDistribute:=int_mo_GetXCalcOutRSaldo(VATDst_TransitAcCut());
  IF VATDst_ToDistribute # 0 THEN
   VATDst_ToDistribute:=(-1)*VATDst_ToDistribute;
   SETEMPTY(VATDst_AcCuts);
   i:=0;
   SetAcCutArray(i, VATDst_AcCuts, VATDstInCost_AcCut());
   SetAcCutArray(i, VATDst_AcCuts, L_AcCut.erkn_GetSoft(Memo.gl_mb(), L_AcCut.erkn_BoughtKeyAssVAT));
   SetAcCutArray(i, VATDst_AcCuts, L_AcCut.erkn_GetSoft(Memo.gl_mb(), L_AcCut.erkn_BoughtInventoryVAT));
   SetAcCutArray(i, VATDst_AcCuts, L_AcCut.erkn_GetSoft(Memo.gl_mb(), L_AcCut.erkn_BoughtGoodsVAT));

   L_General.Assert(i>0, "  ࠧ१   ਮ⥭ 業");
   SETZERO(i, VATDst_ComponentsTotal);
   WHILE ~!VATDst_AcCuts[i] DO
    VATDst_Components[i]:=int_mo_GetXCalcOutRSaldo(VATDst_AcCuts[i]);
    L_General.Assert(VATDst_Components[i] >= 0,
                     "।⮢ ᠫ줮  ࠧ१ " + VATDst_AcCuts[i]);
    INC(VATDst_ComponentsTotal, VATDst_Components[i]);
    INC(i);
   END;
   IF VATDst_ComponentsTotal > 0 THEN

    Rest:=VATDst_ToDistribute;
    maxValue:=0;
    i:=0;
    WHILE ~!VATDst_AcCuts[i] DO
     IF VATDst_Components[i] # 0 THEN
      _Value:=VATDst_Components[i]/VATDst_ComponentsTotal*VATDst_ToDistribute;
      MakeXXCir(VATDst_AcCuts[i], _Value);
      DEC(Rest, _Value);
      IF Math.Abs(_Value) > Math.Abs(maxValue) THEN
       IdxOfMaxValue:=i;
      END;
     END;
     INC(i);
    END;
    IF Rest # 0 THEN
     MakeXXCir(VATDst_AcCuts[IdxOfMaxValue], Rest);
    END;
   END; (* IF VATDst_ComponentsTotal > 0 *)
  END; (* VATDst_ToDistribute # 0 *)
 END {};

 PROCEDURE ፄ2007();
  VAR
   oSld,
   cSld,
   bSld,
   trgV  : L_XObj.tSum;
   cAcCut,
   bAcCut: LIKE(XCalc.AcCut);
   Cnt   : NUMERIC[0];
 BEGIN
  IF (XObject.Origin = L_XObj.o_Contract) & (Memo.gl_mb() = SplitVATPrepayP) THEN
   L_XObj.AccessOrigin();
   IF Contract.Type = L_Cntr.ct_Sell THEN
    oSld:=L_Pmnt.vtbExtractTotal(L_Pmnt.GetContractBalance(Contract.Contract, Memo.gl_mb(), L_XDoc.min_DoneDTS, L_XDoc.min_DoneDTS));
    IF oSld < 0 THEN
     Cnt:=0;
     SELECT(XCalc, XObject, , XObject.XObject);
     WHILE OCCURE(XCalc) DO
      NARROWSEL(XCalc, AcCut);
      IF XCalc.AcCut # L_AcCut.erkn_Get(SYSDATE(), L_AcCut.erkn_OnlineBalance) THEN
       cAcCut:=XCalc.AcCut;
       SAVE(XCalc);
       cSld:=L_XObj.mo_GetOutRSaldo(XCalc.AcCut, L_DatTim.IncMonth(Memo.gl_mb(), -1));
       IF cSld # 0 THEN
        IF Cnt > 0 THEN
         L_General.Error(" " + Contract.Contract + " - 㫥 ᠫ줮  ᪮쪨 ᮢ ࠧ१");
        END;
        bSld:=cSld;
        bAcCut:=cAcCut;
        INC(Cnt);
       END;
       RESTORE(XCalc);
      END;
      NEXTINEXTENDEDSEL(XCalc, AcCut);
     END; (* WHILE OCCURE(XCalc) ... *)
     IF bSld > 0 THEN
      L_General.Error(" " + Contract.Contract + " - ᠫ줮   ⥫쭮?");
     ELSIF bSld = 0 THEN
      L_General.Error(" " + Contract.Contract + " - ᠫ줮   = 0?");
     ELSE
      trgV:=Math.Abs(oSld)-Math.Abs(bSld);
      intMakeCir(AcMthL.AcCut, AcMthL.Apport, bAcCut, GetComplementaryApport(AcMthL.Apport),
                 trgV, 1);
     END;
    END;
   END;
  END;
 END {ፄ2007};

 PRIVATE PROCEDURE BuildJDoc_ANY(trgJDocKind  : LIKE(JDocKind.JDocKind);
                                 baseFileId   : NUMERIC[0];
                                 baseRECORDID : NUMERIC[0];
                                 trgMyFirm    : LIKE(JDoc.MyFirm);
                                 FillJDoc     : PROC);
 BEGIN
  SAVE(XObject);
  IF SEARCH(JDoc, Prn, baseFileId, baseRECORDID, trgMyFirm, trgJDocKind, Memo.gl_mb()) THEN
   L_JDoc.JDoc_OnAnyModification(-1, 1, 1);
   CONFORM(JDoc, JDocList);
   REMSEL(JDocList);
   L_General.CallUs(JDoc.Done=0);
  END;
  FillJDoc();
  IF OCCURE(JDoc) THEN
   L_JDoc.JDoc_OnAnyModification(+1, 1, 1);
  END;
  RESTORE(XObject);
 END {BuildJDoc_ANY};

 PRIVATE PROCEDURE EmptyFillJDoc();
 BEGIN
 END {EmptyFillJDoc};

 PRIVATE PROCEDURE jd_Distr_byCostItem_Clear();
 BEGIN
  BuildJDoc_ANY(L_JDoc.jd_Distr, TABLE.Get("CostItem").Id, CostItem.RECORDID, CostItem.MyFirm, PROCREF(EmptyFillJDoc));
 END {jd_Distr_byCostItem_Clear};

 PRIVATE PROCEDURE jd_Distr_byCostItem(FillJDoc: PROC);
 BEGIN
  BuildJDoc_ANY(L_JDoc.jd_Distr, TABLE.Get("CostItem").Id, CostItem.RECORDID, CostItem.MyFirm, FillJDoc)
 END {jd_Distr_byCostItem};

 PROCEDURE dsf_PutJDocList(dbtXObject: LIKE(XObject.XObject);
                           dbtAcCut  : LIKE(AcCut.AcCut);
                           crdXObject: LIKE(XObject.XObject);
                           crdAcCut  : LIKE(AcCut.AcCut);
                           _Sum      : LIKE(JDocList.Sum));
 BEGIN
  DEFAULT(JDocList);
  JDocList.JDocKind:=JDoc.JDocKind;
  JDocList.JDoc    :=JDoc.JDoc;
  JDocList.XObject :=dbtXObject;
  JDocList.AcCut   :=dbtAcCut;
  JDocList.Apport  :=L_Acnt.E_Apport_MoneyDebit(Memo.gl_mb());
  JDocList.XObject2:=crdXObject;
  JDocList.AcCut2  :=crdAcCut;
  JDocList.Apport2 :=L_Acnt.E_Apport_MoneyCredit(Memo.gl_mb());
  JDocList.Sum     :=_Sum;
  SETZERO(JDocList.Qnt, JDocList.wQnt, JDocList.wQnt2);
  JDocList.Date    :=JDoc.Date;
  JDocList.DoneDTS :=JDoc.DoneDTS;
  INSERT(JDocList);
 END {dsf_PutJDocList};

 PROCEDURE dsf_FillJDoc();
  VAR
   mainXObject: LIKE(XObject.XObject);
   mainAcCut  : LIKE(AcCut.AcCut);
 BEGIN
  IF (Dfrls.Status = L_CI.dfst_Passed) &
     L_DatTim.IsActiveInIntvl_Inc(Memo.gl_mb(), Memo.gl_me(), Dfrls.BegDate, Dfrls.EndDate) THEN
   IF ~OCCURE(JDoc) THEN
    DEFAULT(JDoc);
    JDoc.JDocKind:=L_JDoc.jd_Dfrls;
    JDoc.Date    :=Memo.gl_mb();
    JDoc.MyFirm  :=CostItem.MyFirm;
    JDoc.SrcNbr  :=Dfrls.Dfrls;
    JDoc.Status  :=L_JDoc.st_Passed;
    JDoc.Done    :=0;
    JDoc.fiPrn   :=TABLE.Get("Dfrls").Id;
    JDoc.riPrn   :=Dfrls.RECORDID;
    L_JDoc.Insert_JDoc();
    L_XDoc.rf_coreInsert(JDoc.XDocId, L_XDoc.curXDocId(L_XDoc.xdt_Dfrls), L_XDoc.rft_BaseOn);
   ELSE
    JDoc.DoneDTS:=L_XDoc.GetSysDTS();
    REPLACE(JDoc);
   END;
   CONFORM(Dfrls, CostItem);
   mainXObject:=CostItem.XObject;
   mainAcCut  :=L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItem_Default);
   SELECT(DfrlsL, Dfrls, , Dfrls.Dfrls);
   WHILE OCCURE(DfrlsL) DO
    CONFORM(DfrlsL, CostItem);
    IF L_DatTim.Per(Dfrls.BegDate) = Memo.gl_mb() THEN
     dsf_PutJDocList(CostItem.XObject,
                      L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItemDfrls),
                     mainXObject,
                      mainAcCut,
                     DfrlsL.Sum);
    END;
    SETSEL(DfrlsLD, Dfrls, DfrlsL.Dfrls, DfrlsL.DfrlsL);
    IF SRCINSEL(DfrlsLD, LE, Memo.gl_mb()) THEN
     dsf_PutJDocList(CostItem.XObject,
                      L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItem_Default),
                     CostItem.XObject,
                      L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItemDfrls),
                     DfrlsLD.Sum);
    ELSE
     L_General.Error("ଫ ࠢ ᯨᠭ  " + Dfrls.Dfrls);
    END;
    NEXT(DfrlsL);
   END; (* WHILE OCCURE(DfrlsL) ... *)
  END;
 END {dsf_FillJDoc};

 PROCEDURE DoSingleDfrls();
 BEGIN
(*
  L_Acnt.ExecAcMth(Memo.gl_mb(), 97(*!*), Dfrls.Dest, EMPTYOF(MathType.MathType), EMPTYOF(MMode.MMode),
                   1, PROCREF(SimpleProceed), EMPTYOF(PROC));
*)
  BuildJDoc_ANY(L_JDoc.jd_Dfrls, TABLE.Get("Dfrls").Id, Dfrls.RECORDID, CostItem.MyFirm, PROCREF(dsf_FillJDoc))
 END {DoSingleDfrls};

 PROCEDURE GetCostItemFixedTKind(): LIKE(TKind.TKind);
  VAR
   _Math : LIKE(Math.Math);
   Result: LIKE(TKind.TKind);
 BEGIN
  SETEMPTY(Result);
  _Math:=L_CI.GetMathByCostItem(CostItem.CostItem, Memo.gl_me());
  IF ~!_Math & L_MathR.PosToLastCarLog(_Math, Memo.gl_me()) THEN
   Result:=CarLog.TKind;
  END;
  RETURN Result;
 END {GetCostItemFixedTKind};

 PROCEDURE d26_FillJDoc();
  VAR
   _Sum      : L_XObj.tSum;
   _TKind    : LIKE(TKind.TKind);
   crdAcCut,
   dbtAcCut  : LIKE(AcCut.AcCut);
 BEGIN
  crdAcCut:=L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItem_Default);
  _Sum:=int_mo_GetXCalcOutRSaldo(crdAcCut);
  IF _Sum # 0 THEN
   _TKind:=GetCostItemFixedTKind();
   IF    (_TKind = 01) | (_TKind = 02) THEN dbtAcCut:=317;
   ELSIF (_TKind = 03) | (_TKind = 04) THEN dbtAcCut:=318;
   ELSE                                     dbtAcCut:=750;
   END;
   IF ~OCCURE(JDoc) THEN
    DEFAULT(JDoc);
    JDoc.JDocKind:=L_JDoc.jd_Distr;
    JDoc.Date    :=Memo.gl_mb();
    JDoc.MyFirm  :=CostItem.MyFirm;
    JDoc.SrcNbr  :=CostItem.CostItem;
    JDoc.Status  :=L_JDoc.st_Passed;
    JDoc.Done    :=0;
    JDoc.fiPrn   :=TABLE.Get("CostItem").Id;
    JDoc.riPrn   :=CostItem.RECORDID;
    L_JDoc.Insert_JDoc();
    L_XDoc.rf_coreInsert(JDoc.XDocId, L_XDoc.curXDocId(L_XDoc.xdt_CostItem), L_XDoc.rft_BaseOn);
   ELSE
    JDoc.DoneDTS:=L_XDoc.GetSysDTS();
    REPLACE(JDoc);
   END;
   dsf_PutJDocList(EMPTYOF(XObject.XObject), dbtAcCut,
                   CostItem.XObject,         crdAcCut, _Sum);
  END;
 END {d26_FillJDoc};

 PROCEDURE d21_FillJDoc();
  VAR
   _Sum      : L_XObj.tSum;
   crdAcCut,
   dbtAcCut  : LIKE(AcCut.AcCut);
 BEGIN
  crdAcCut:=L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItem_Default);
  _Sum:=int_mo_GetXCalcOutRSaldo(crdAcCut);
  IF _Sum # 0 THEN
   dbtAcCut:=331;
   IF ~OCCURE(JDoc) THEN
    DEFAULT(JDoc);
    JDoc.JDocKind:=L_JDoc.jd_Distr;
    JDoc.Date    :=Memo.gl_mb();
    JDoc.MyFirm  :=CostItem.MyFirm;
    JDoc.SrcNbr  :=CostItem.CostItem;
    JDoc.Status  :=L_JDoc.st_Passed;
    JDoc.Done    :=0;
    JDoc.fiPrn   :=TABLE.Get("CostItem").Id;
    JDoc.riPrn   :=CostItem.RECORDID;
    L_JDoc.Insert_JDoc();
    L_XDoc.rf_coreInsert(JDoc.XDocId, L_XDoc.curXDocId(L_XDoc.xdt_CostItem), L_XDoc.rft_BaseOn);
   ELSE
    JDoc.DoneDTS:=L_XDoc.GetSysDTS();
    REPLACE(JDoc);
   END;
   dsf_PutJDocList(EMPTYOF(XObject.XObject), dbtAcCut,
                   CostItem.XObject,         crdAcCut, _Sum);
  END;
 END {d21_FillJDoc};

 PRIVATE PROCEDURE GetCostItemByFixedTKind(): LIKE(CostItem.CostItem);
  VAR
   Result: LIKE(CostItem.CostItem);
 BEGIN
  SETEMPTY(Result);
  IF L_MathR.PosToLastCarLog(L_CI.GetMathByCostItem(CostItem.CostItem, Memo.gl_me()), Memo.gl_me()) THEN
   IF ~!CarLog.TKind THEN
    SELECT(RouteLog, TKind, , CarLog.TKind);
    WHILE OCCURE(RouteLog) & !Result DO
     IF ~!RouteLog.CostItem & (RouteLog.Date <= Memo.gl_mb()) & (RouteLog.Till > Memo.gl_me()) THEN
      Result:=RouteLog.CostItem;
     END;
     NEXT(RouteLog);
    END; (* WHILE OCCURE(RouteLog) ... *)
   END;
  END;
  IF ~!Result THEN
   CONFORM(CarLog, Car);
   Result:=L_CI.E_GetActivityCostItem(Result, Memo.gl_me(), CostItem.MyFirm, 1);
  END;
  RETURN Result;
 END {GetCostItemByFixedTKind};

 PROCEDURE DistributeByRun(MonthAmount: NUMERIC[0]);
  VAR
   curMath    : LIKE(Math.Math);
   fixedCI    : LIKE(CostItem.CostItem);
   Sum2Dst,
   rSum,
   cSum       : L_XObj.tSum;
   crdAcCut,
   dbtAcCut   : LIKE(AcCut.AcCut);
   crdXObject : LIKE(XObject.XObject);
   trgCIKind  : LIKE(CIKind.CIKind);
   tRun,
   rRun       : LIKE(MathRun.Run);
   P          : DATE;
 BEGIN
  crdAcCut:=L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItem_Default);
  Sum2Dst :=int_mo_GetXCalcOutRSaldo(crdAcCut);
  IF Sum2Dst # 0 THEN
   curMath:=L_CI.GetMathByCostItem(CostItem.CostItem, Memo.gl_me());
   IF ~!curMath THEN
    IF ~OCCURE(JDoc) THEN
     DEFAULT(JDoc);
     JDoc.JDocKind:=L_JDoc.jd_Distr;
     JDoc.Date    :=Memo.gl_mb();
     JDoc.MyFirm  :=CostItem.MyFirm;
     JDoc.SrcNbr  :=CostItem.CostItem;
     JDoc.Status  :=L_JDoc.st_Passed;
     JDoc.Done    :=0;
     JDoc.fiPrn   :=TABLE.Get("CostItem").Id;
     JDoc.riPrn   :=CostItem.RECORDID;
     L_JDoc.Insert_JDoc();
     L_XDoc.rf_coreInsert(JDoc.XDocId, L_XDoc.curXDocId(L_XDoc.xdt_CostItem), L_XDoc.rft_BaseOn);
    ELSE
     JDoc.DoneDTS:=L_XDoc.GetSysDTS();
     REPLACE(JDoc);
    END;
    trgCIKind :=CostItem.CIKind;
    crdXObject:=CostItem.XObject;
    SAVE(CostItem);
    L_AFM.MakeMultipleIndex("mxo_Run", "CostItem: LIKE(CostItem.CostItem);"+
                                       "Run     : LIKE(MathRun.Run)",
                            "CostItem: CostItem");
    tRun:=0;
    P:=Memo.gl_mb();
    SETSEL(MathRun, Math, curMath);
    SRCINSEL(MathRun, GE, , L_DatTim.IncMonth(P, (-1) * (MonthAmount-1)));
    WHILE OCCURE(MathRun) & (MathRun.Period <= P) DO
     INC(tRun, MathRun.Run);
     ADD(mxo_Run, CostItem, , MathRun.CostItem,
          mxo_Run.Run, MathRun.Run);
     NEXT(MathRun);
    END; (* WHILE OCCURE(MathRun) ... *)
    IF tRun = 0 THEN
     fixedCI:=GetCostItemByFixedTKind();
     L_General.Assert(~!fixedCI, " ।   ९.  " + CostItem.CostItem);
     tRun:=9999;
     ADD(mxo_Run, CostItem, , fixedCI,
         mxo_Run.Run, tRun);
    END;
    rRun:=tRun;
    rSum:=Sum2Dst;
    SELECT(mxo_Run, CostItem);
    WHILE OCCURE(mxo_Run) DO
     IF mxo_Run.Run # 0 THEN
      IF mxo_Run.Run = rRun THEN
       cSum:=rSum;
      ELSE
       cSum:=Sum2Dst * (mxo_Run.Run / tRun);
      END;
      SELECT(CostItem, Parent, , mxo_Run.CostItem);
      LOOP
       IF ~OCCURE(CostItem) THEN
        L_General.Error(" 㯯  " + mxo_Run.CostItem + "    " + trgCIKind);
       ELSIF (CostItem.CIKind = trgCIKind) & L_DatTim.IsActive(Memo.gl_me(), CostItem.Begin, CostItem.Till) THEN
        EXIT;
       END;
       NEXT(CostItem);
      END; (* LOOP *)
      dsf_PutJDocList(CostItem.XObject,
                      L_Acnt.GetSpecificAcCutForCostItem(CostItem.CostItem, L_Acnt.acp_CostItem_Default),
                      crdXObject, crdAcCut, cSum);
      DEC(rRun, mxo_Run.Run);
      DEC(rSum, cSum);
     END;
     NEXT(mxo_Run);
    END; (* WHILE OCCURE(mxo_Run) ... *)
    RESTORE(CostItem);
   END; (* IF ~!curMath *)
  END; (* IF Sum2Dst # 0 *)
 END {DistributeByRun};

 PRIVATE PROCEDURE DistributeByRun_1();
 BEGIN
  DistributeByRun(1);
 END {DistributeByRun_1};

 PRIVATE PROCEDURE DistributeByRun_6();
 BEGIN
  DistributeByRun(6);
 END {DistributeByRun_6};

 PRIVATE PROCEDURE DoSingleCostItem();
 BEGIN
  IF    L_General.GetAPSiteID() = "HM" THEN
   IF (CostItem.CIKind = 0003) | (CostItem.CIKind = 0004) THEN
    jd_Distr_byCostItem(PROCREF(d26_FillJDoc))
   ELSE
    jd_Distr_byCostItem_Clear();
   END;
  ELSIF L_General.GetAPSiteID() = "55" THEN
   IF    (CostItem.CIKind = 0003) | (CostItem.CIKind = 0004) | (CostItem.CIKind = 0013) THEN
    jd_Distr_byCostItem(PROCREF(DistributeByRun_1))
   ELSIF (CostItem.CIKind = 0005) | (CostItem.CIKind = 0006) THEN
    jd_Distr_byCostItem(PROCREF(DistributeByRun_6))
   ELSE
    jd_Distr_byCostItem_Clear();
   END;
  ELSIF L_General.GetAPSiteID() = "KL" THEN
   IF (CostItem.CIKind = 0025) | (CostItem.CIKind = 0026) THEN (*, *)
    IF Memo.gl_mb() >= 01\05\2010 THEN
     jd_Distr_byCostItem(PROCREF(DistributeByRun_1))
    ELSE
     jd_Distr_byCostItem(PROCREF(d21_FillJDoc))
    END;
   ELSE
    jd_Distr_byCostItem_Clear();
   END;
  END;
  WriteOffRecExpSaldo();
 END {DoSingleCostItem};

 PROCEDURE XCalcPass(Proc: PROC);
  VAR
   _AcCut : LIKE(AcCut.AcCut);
 BEGIN
  SELECT(XCalc, XObject, , XObject.XObject);
  WHILE OCCURE(XCalc) DO
   _AcCut:=XCalc.AcCut;
   CHANGESEL(XCalc, XObject, , XObject.XObject, XCalc.AcCut);
   IF SRCINSEL(XCalc, EQ, Memo.gl_mb()) THEN
    CONFORM(XCalc, AcCut);
    PROMPT("१: "+XCalc.AcCut+", "+L_DatTim.DateStr(XCalc.XDat));
    Proc();
   END;
   SETSEL(XCalc, XObject, XObject.XObject);
   SRCINSEL(XCalc, GT, , _AcCut);
  END; (* WHILE OCCURE(XCalc) ... *)
 END {XCalcPass};

 PRIVATE PROCEDURE ProceedPrvMonth(ppmTransaction: NUMERIC[0]);
  VAR
   cur_gl_cd,
   P        : DATE;
 BEGIN
  cur_gl_cd:=Memo.gl_cd();
  P:=L_DatTim.IncMonth(L_DatTim.Per(cur_gl_cd), -1);
  WHILE ~L_XObj._IsXObjectDone(P, L_XObj.s_Payments) DO
   P:=L_DatTim.IncMonth(P, -1);
  END;
  TRY
   P:=L_DatTim.IncMonth(P, +1);
   WHILE P < L_DatTim.Per(cur_gl_cd) DO
    Memo.gl_SetCurDate(P);
    TRY [TRANSACTION(ppmTransaction), MSGSUPPRESSIONMODE(MSGSUPPRESS_NONE)]
     CALL(MXO.DoSingleXObject(0));
    EXCEPT
    END;
    P:=L_DatTim.IncMonth(P, +1);
   END;
  EXCEPT
  FINALLY
   Memo.gl_SetCurDate(cur_gl_cd);
  END;
 END {ProceedPrvMonth};

 PROCEDURE SimpleProceed();
 BEGIN
  ^AcMthL.Rule();
 END {SimpleProceed};

 PROCEDURE ud_Check(xdt: L_XDoc.tXDocType);
  VAR
   Ok: SCAL[2];
 BEGIN
  IF    xdt = L_XDoc.xdt_MDoc THEN
   Ok:=(MDoc.Done & (MDoc.Status # L_MDoc.st_Prepared)) | ~L_Pmnt.TakeMDocIntoAccount();
  ELSIF xdt = L_XDoc.xdt_PDoc THEN
   Ok:=(PDoc.Done & (PDoc.Status # L_PDoc.st_Prepared)) | ~L_Pmnt.TakePDocMDocIntoAccount();
  ELSIF xdt = L_XDoc.xdt_JDoc THEN
   Ok:=(JDoc.Done & (JDoc.Status # L_JDoc.st_Prepared));
  END;
  IF ~Ok THEN
   L_General.Error(L_XDoc.extXDocStr(L_XDoc.curXDocId(xdt), L_XDoc.xdast_wStatus));
  END;
 END {ud_Check};

 PROCEDURE GetFirstUndoneDoc(): STRING[];
  VAR
   _XDocId   : L_XDoc.tXDocId;
   jdlPassCnt: NUMERIC[0];
 BEGIN
  L_XObj.AccessOrigin();

  TRY
   TABLE.Get("PDocMDoc").AccessDataMode:=adm_SOFT;
   TABLE.Get("PDoc"    ).AccessDataMode:=adm_SOFT;
   TABLE.Get("MDoc"    ).AccessDataMode:=adm_SOFT;
   TABLE.Get("JDoc"    ).AccessDataMode:=adm_SOFT;
   TABLE.Get("JDocList").AccessDataMode:=adm_SOFT;
 
   SETSEL(PDocMDoc, Contract, Contract.Contract);
   FOR_EACH PDocMDoc DO
    IF PDocMDoc.PDocDate > Memo.gl_me() THEN
     EXIT;
    END;
    CONFORM(PDocMDoc, PDoc);
    ud_Check(L_XDoc.xdt_PDoc);
   END; (* FOR_EACH PDocMDoc *)
 
   SELECT(MDoc, Contract, , Contract.Contract);
   WHILE OCCURE(MDoc) DO
    NARROWSEL(MDoc, MDocKind);
    FOR_EACH MDoc DO
     IF MDoc.Date > Memo.gl_me() THEN
      EXIT;
     END;
     ud_Check(L_XDoc.xdt_MDoc);
    END; (* FOR_EACH MDoc *)
    NEXTINEXTENDEDSEL(MDoc, MDocKind);
   END; (* WHILE OCCURE(MDoc) ... *)
 
   jdlPassCnt:=0;
   REPEAT
    IF jdlPassCnt = 0 THEN
     SELECT(JDocList, XObject, , XObject.XObject);
    ELSE
     SELECT(JDocList, XObject2, , XObject.XObject);
    END;
    WHILE OCCURE(JDocList) & (JDocList.Date <= Memo.gl_me()) DO
     CONFORM(JDocList, JDoc);
     _XDocId:=L_JDoc.GetJDocOnBehalfOfXDocId();
     L_XDoc.PositionOnXDoc(_XDocId);
     ud_Check(L_XDoc.ExtractXDocType(_XDocId));
     NEXT(JDocList);
    END; (* WHILE OCCURE(JDocList) ... *)
    INC(jdlPassCnt);
   UNTIL jdlPassCnt = 2;
  EXCEPT
  ON Exc:Exc_Raise DO
   RETURN Exc.MsgOriginalText;
  END;
  RETURN "";
 END {GetFirstUndoneDoc};

 PROCEDURE CheckUndoneDocs();
  VAR
   Msg: STRING[];
 BEGIN
  Msg:=GetFirstUndoneDoc();
  L_General.Assert(!Msg, " ࠡ⠭  '⮢' 㬥, ਬ||"+Msg);
 END {CheckUndoneDocs};

 PROCEDURE E_NeedCheckContractSaldo(): SCAL[2];
 BEGIN
  RETURN (L_General.GetAPSiteID() # "IV");
 END {E_NeedCheckContractSaldo};

 PROCEDURE CheckContractSaldo();
  VAR
   curSaldo,
   balSaldo,
   obnSaldo: L_XObj.tSum;
   obnAcCut: LIKE(AcCut.AcCut);
   XDocStr : STRING[];
 BEGIN
  IF E_NeedCheckContractSaldo() THEN
   SAVE(Contract);
   L_XObj.AccessOrigin();
   IF (Contract.Type # L_Cntr.ct_Sell) | (Memo.gl_mb() >= SplitVATPrepayP) THEN
    obnAcCut :=L_AcCut.erkn_Get(SYSDATE(), L_AcCut.erkn_OnlineBalance);
    SETZERO(balSaldo, obnSaldo);
    SELECT(XCalc, XObject, , XObject.XObject);
    WHILE OCCURE(XCalc) DO
     NARROWSEL(XCalc, AcCut);
     IF SRCINSEL(XCalc, LE, Memo.gl_mb()) THEN
      IF (XCalc.AcCut = obnAcCut) | L_Pmnt.ItCntrBalAcCut(XCalc.AcCut, Memo.gl_mb()) THEN
       curSaldo:=L_XObj.mo_OutRSaldo();
       IF XCalc.AcCut = obnAcCut THEN
        INC(obnSaldo, curSaldo);
       ELSE
        INC(balSaldo, curSaldo);
       END;
      END;
     END;
     NEXTINEXTENDEDSEL(XCalc, AcCut);
    END; (* WHILE OCCURE(XCalc) ... *)
    IF balSaldo # obnSaldo THEN
     L_General.Error("ᮮ⢥⢨ ᮢ  ⨢ ᠫ줮   "+Contract.Contract+
                     "|஢ ᠭ 奬 権  楢  ");
    END;
   END;
   RESTORE(Contract);
  END;
 END {CheckContractSaldo};

 PROCEDURE DoSingleXObject(Force: SCAL[2]);
 BEGIN
  IF Force | ~L_XObj.IsXObjectDone(L_XObj.s_Payments) THEN
   L_AcsPnt.PassAccessPoint(0000015);
   L_XObj.AccessOrigin();
   IF (XObject.Origin = L_XObj.o_Math) |
      (XObject.Origin = L_XObj.o_KeyAss) THEN
    IF Force THEN
     CALL(MCM.mItem_Recount());
    ELSE
     CALL(MCM.mItem_CountUp());
    END;
   ELSE
    IF (XObject.Origin = L_XObj.o_Man) |
       (XObject.Origin = L_XObj.o_ESN) THEN
     CONFORM(mfMan, Man);
     L_XDoc.FixACalc("Man", mfMan.MyFirm, Memo.gl_mb());
    ELSE
     L_XDoc.FixACalc(L_XObj.GetOriginFileName(XObject.Origin), XObject.MyFirm, Memo.gl_mb());
    END;
    L_Acnt.RollbackXDoc(L_XDoc.curXDocId(L_XDoc.xdt_ACalc));
    L_XObj.ClearXApport(L_XObj.s_Payments, L_XObj.src_Payments);
    IF    XObject.Origin = L_XObj.o_CostItem THEN
     SETSEL(Dfrls, CostItem, CostItem.CostItem);
     FOR_EACH Dfrls DO
      PROMPT("ࠡ⪠  " + Dfrls.Dfrls);
      DoSingleDfrls();
     END; (* FOR_EACH Dfrls *)
     DoSingleCostItem();
    END;
    L_Acnt.ExecAcMth(Memo.gl_mb(), L_MDoc.DG_CnT, 000, EMPTYOF(MathType.MathType), EMPTYOF(MMode.MMode),
                     1, PROCREF(SimpleProceed), EMPTYOF(PROC));
    XCalcPass(PROCREF(L_XObj.RenXCalc));
    L_XObj.XODone_Set(Memo.gl_mb(), 1, 0);
 
    IF XObject.Origin = L_XObj.o_Contract THEN
     SAVE(Contract);
     L_XObj.AccessOrigin();
     L_Pmnt.CheckSpecialVATMDocDone(Contract.Contract, Memo.gl_mb());
     CheckUndoneDocs();
     CheckContractSaldo();
     RESTORE(Contract);
    END;
    L_XDoc.CompleteACalc();
   END; (* IF (XObject.Origin = L_XObj.o_Math) | ... *)
  END; (* IF Force ... *)
 END {DoSingleXObject};

 PRIVATE PROCEDURE intSingleCountUp(Force: SCAL[2]; ppmTransaction: NUMERIC[0]);
  VAR
   oPrompt: OBJECT; 
 BEGIN
  oPrompt:=PROMPTLINE.Create(L_Str.PoolItem("|", Force) + "   " + XObject.XObject + "  " + L_DatTim.PeriodStr(Memo.gl_mb()));
  ProceedPrvMonth(ppmTransaction);
  DoSingleXObject(Force);
 END {intSingleCountUp};

 PUBLIC PROCEDURE InteractiveCountUp(ForceRecount, ForXCalcDat: SCAL[2]);
  VAR
   curTable: STRING[];
   glP     : DATE;
 BEGIN
  curTable:=RTI.Get().CurZone.MasterTable.Name;
  IF ForXCalcDat THEN
   IF    curTable = "XCalc" THEN
    ACCESS(XCalc);
    glP:=XCalc.XDat;
   ELSIF curTable = "XODone" THEN
    ACCESS(XODone);
    glP:=XODone.Period;
   END;
  ELSE
   glP:=Memo.gl_mb();
  END;
  IF ~ACCESS(XObject) THEN
   IF ACCESS(^(curTable)) THEN
    CONFORM(^(CurTable), XObject);
   ELSE
    L_StdFrm.BlueStop("楢  ");
   END;
  END;
  Memo.gl_SetCurDate(glP);
  intSingleCountUp(ForceRecount, TRANSACTION_SLAVE);
 END {InteractiveCountUp};

 PUBLIC PROCEDURE SingleCountUp(ppmTransaction: NUMERIC[0]);
 BEGIN
  L_General.CallUs(OCCURE(XObject));
  intSingleCountUp(0, ppmTransaction);
 END {SingleCountUp};

END.
