(*
%Copyright   (c) Polak IT
%Author      27.10.2005 18:59:01 POLAK\San
%Purpose      ࣠樨 - ஫ 䨪樨  祥
%Type        control
%Specific    SYS
%Modified    09.01.2014 16:06:35 POLAK\Gina
%Environment
*)

 MODULE MyFirm [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, P_Firm, L_WDO, Str, L_Str, L_Stock, L_r2r, L_StdFrm;

 PRIVATE PROCEDURE Check_wMultipleMyFirm();
 BEGIN
  L_General.Assert(P_Firm.E_wMultipleMyFirm(SYSDATE()), "প ଥ   ⠭");
 END {Check_wMultipleMyFirm};

 PRIVATE PROCEDURE MyFirm_OnBeforeInsert();
 BEGIN
  Check_wMultipleMyFirm();
 END {MyFirm_OnBeforeInsert};

 PRIVATE PROCEDURE MyFirm_OnBeforeEdit();
 BEGIN
  Check_wMultipleMyFirm();
 END {MyFirm_OnBeforeEdit};

 PUBLIC PROCEDURE Edit();
 BEGIN
  IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   LIKEMENU(Edit, "MyFirmE 0");
  ELSE
   L_StdFrm.RedInform("প ଥ   ⠭.|" +
                      " 䨪 ⮫쪮 ᪨ ⮢  ࣠樨");
   LIKEMENU(View, "MyFirmE 1");
  END;
 END {Edit};

 PRIVATE PROCEDURE MyFirmE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="MyFirm";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (0, ["MyFirm.Firm"]);
  L_WDO.iMayBeEmpty  (0, ["MyFirm.Till", "MyFirm.vzSign"]);
  L_WDO.iZone        (0).ViewOnly:=~P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_WDO.iField       (1, "FirmAcnt.Type").Format:=P_Firm.fat_Pool;
  L_WDO.iSubwindow   (1, "mfBAE");
 END {MyFirmE_OnInitializeWindow};

 PRIVATE PROCEDURE MyFirm_OnBeforeDelete();
 BEGIN
  Check_wMultipleMyFirm();
  L_r2r.Owner_OnBeforeDelete("MyFirm");
 END {MyFirm_OnBeforeDelete};

 PRIVATE PROCEDURE MyFirm_Firm_OnSuccessfulChange();
  VAR
   _MyFirm: LIKE(MyFirm.MyFirm);
 BEGIN
  _MyFirm:=MyFirm.MyFirm;
  SELECT(MyFirm, Firm, , MyFirm.Firm);
  WHILE OCCURE(MyFirm) DO
   IF (MyFirm.MyFirm # _MyFirm) &
      (MyFirm.MyFirm # P_Firm.mf_Fict) THEN
    L_General.Error(" ࠣ " + MyFirm.Firm + " 㦥 ଫ '' ࣠ " + MyFirm.MyFirm);
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
 END {MyFirm_Firm_OnSuccessfulChange};

 PRIVATE PROCEDURE MyFirm_OnAfterEdIns();
 BEGIN
  IF ~SEARCH(FirmAcnt, Firm, MyFirm.Firm, P_Firm.fa_CashOffice) THEN
   P_Firm.AccessFirm(MyFirm.Firm);
   DEFAULT(FirmAcnt);
   FirmAcnt.Firm    :=Firm.Firm;
   FirmAcnt.FirmAcnt:=P_Firm.fa_CashOffice;
   FirmAcnt.Type    :=P_Firm.fat_CashOffice;
   FirmAcnt.Begin   :=Firm.Begin;
   FirmAcnt.AcntA   :="";
   INSERT(FirmAcnt);
  END;
  P_Firm.FillmfBnkAcn(0);
  IF    !MyFirm.vzSign THEN
   MyFirm.Sign:=L_Str.Repeat(CHR(196), Str.MaxLength(MyFirm.Sign));
  ELSIF Str.Length(MyFirm.vzSign) < Str.MaxLength(MyFirm.Sign) THEN
   MyFirm.Sign:=" " + MyFirm.vzSign + " " + L_Str.Repeat(CHR(196), Str.MaxLength(MyFirm.Sign));
  END;
  REPLACE(MyFirm);
 END {MyFirm_OnAfterEdIns};

 PRIVATE PROCEDURE MyFirm_OnAfterInsert();
  VAR
   Dummy: LIKE(MyFirm.Storage);
 BEGIN
  MyFirm_OnAfterEdIns();
  Dummy:=L_Stock.Obtain_MyFirmStorage(MyFirm.MyFirm, MyFirm.Begin);
 END {MyFirm_OnAfterInsert};

 PRIVATE PROCEDURE MyFirm_OnAfterEdit();
 BEGIN
  MyFirm_OnAfterEdIns();
  L_Stock.SetName_MyFirmStorage();
 END {MyFirm_OnAfterEdit};

 PRIVATE PROCEDURE SDfMyFrm_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit]);
  L_WDO.iScsChange   (0, ["MyPlace", "dfpAssigned", "MyFirm", "dfmAssigned"]);
  L_WDO.iField       (0, "dfmAssigned").Format:="-|";
  L_WDO.iField       (0, "dfpAssigned").Format:="-|";
  L_WDO.iProgs       (0, "MyFirm");
  L_WDO.CreateFormLink("MyFirm", "");
  L_WDO.CreateFormLink("MyPlace", "");
 END {SDfMyFrm_OnInitializeWindow};

 PRIVATE PROCEDURE SDfMyFrm_OnBeforeEdit();
 BEGIN
  L_WDO.cField("dfmAssigned").Modifiable:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  P_Firm.dfmAssigned:=P_Firm.dfmAssigned & L_WDO.cField("dfmAssigned").Modifiable;
  L_WDO.cField("dfmAssigned").Value:=P_Firm.dfmAssigned;
  L_WDO.cField("MyFirm").Modifiable:=P_Firm.dfmAssigned;
  L_WDO.cField("MyFirm").Value     :=P_Firm.defaultMyFirm;

  L_WDO.cField("dfpAssigned").Modifiable:=P_Firm.E_wMultipleMyPlace(SYSDATE());
  P_Firm.dfpAssigned:=P_Firm.dfpAssigned & L_WDO.cField("dfpAssigned").Modifiable;
  L_WDO.cField("dfpAssigned").Value :=P_Firm.dfpAssigned;
  L_WDO.cField("MyPlace").Modifiable:=P_Firm.dfpAssigned;
  L_WDO.cField("MyPlace").Value     :=P_Firm.defaultMyPlace;
  IF ~(L_WDO.cField("dfmAssigned").Modifiable | L_WDO.cField("dfpAssigned").Modifiable) THEN
   L_StdFrm.BlueStop(" 襬 ।⨨   ࠧ ,  ࠧ ந⢥ 頤");
  END;
 END {SDfMyFrm_OnBeforeEdit};

 PRIVATE PROCEDURE SDfMyFrm_dfmAssigned_OnSuccessfulChange();
 BEGIN
  L_WDO.cField("MyFirm").Modifiable :=RTI.Get().CurZone.ActiveField.Value;
 END {SDfMyFrm_dfmAssigned_OnSuccessfulChange};

 PRIVATE PROCEDURE SDfMyFrm_MyFirm_OnSuccessfulChange();
 BEGIN
  L_General.Assert(RTI.Get().CurZone.ActiveField.Value # P_Firm.mf_Fict,
                   "'' 0000    ⠭ ࣠樥  㬮砭");
 END {SDfMyFrm_MyFirm_OnSuccessfulChange};

 PRIVATE PROCEDURE SDfMyFrm_dfpAssigned_OnSuccessfulChange();
 BEGIN
  L_WDO.cField("MyPlace").Modifiable:=RTI.Get().CurZone.ActiveField.Value;
 END {SDfMyFrm_dfpAssigned_OnSuccessfulChange};

 PRIVATE PROCEDURE SDfMyFrm_MyPlace_OnSuccessfulChange();
 BEGIN
  L_General.Assert(RTI.Get().CurZone.ActiveField.Value # P_Firm.mp_Fict,
                   "'⮯' 0000    ⠭  㬮砭");
 END {SDfMyFrm_MyPlace_OnSuccessfulChange};

 PRIVATE PROCEDURE SDfMyFrm_OnAfterEdit();
 BEGIN
  P_Firm.SetDefaultMyFirm (L_WDO.cField("MyFirm").Value,  L_WDO.cField("dfmAssigned").Value);
  P_Firm.SetDefaultMyPlace(L_WDO.cField("MyPlace").Value, L_WDO.cField("dfpAssigned").Value);
 END {SDfMyFrm_OnAfterEdit};

 PRIVATE PROCEDURE mfBnkAcn_OnBeforeInsert();
 BEGIN
  L_General.Error("⠢ ⮢ ᪠ ⮫쪮  ᠭ ࠣ");
 END {mfBnkAcn_OnBeforeInsert};

 PRIVATE PROCEDURE mfBnkAcn_OnBeforeEdit();
 BEGIN
  L_General.Assert(mfBnkAcn.FirmAcnt # P_Firm.fa_CashOffice, "䨪  " + FLDTOSTR(P_Firm.fa_CashOffice, "L", 2) + " 饭");
  L_General.Assert(mfBnkAcn.MyFirm # P_Firm.mf_Fict, "䨪 ⮢  '' ࣠樨 " + mfBnkAcn.MyFirm + " 饭");
 END {mfBnkAcn_OnBeforeEdit};

 PRIVATE PROCEDURE mfBnkAcn_OnBeforeDelete();
 BEGIN
  L_General.Error(" ⮢ ᪠ ⮫쪮  ᠭ ࠣ");
 END {mfBnkAcn_OnBeforeDelete};

 PRIVATE PROCEDURE mfBnkAcn_OnAfterEdit();
 BEGIN
 END {mfBnkAcn_OnAfterEdit};

 PRIVATE PROCEDURE MyPlace_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="MyFirm";
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterEdit, L_WDO.e_OnAfterInsert]);
  L_WDO.iMayBeEmpty  (1, ["MyPlace.Till", "MyPlace.vzSign"]);
  L_WDO.iField       (1, "MyPlace.wMySite").Format:="-|";
  L_WDO.iZone        (1).PermanentFilter:="(MyPlace.MyPlace # 0000)";
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iProgs       (1, "MyFirm");
 END {MyPlace_OnInitializeWindow};

 PRIVATE PROCEDURE MyPlace_OnAfterEdIns();
 BEGIN
  IF    !MyPlace.vzSign THEN
   MyPlace.Sign:=L_Str.Repeat(CHR(196), Str.MaxLength(MyPlace.Sign));
  ELSIF Str.Length(MyPlace.vzSign) < Str.MaxLength(MyPlace.Sign) THEN
   MyPlace.Sign:=" " + MyPlace.vzSign + " " + L_Str.Repeat(CHR(196), Str.MaxLength(MyPlace.Sign));
  END;
  REPLACE(MyPlace);
 END {MyPlace_OnAfterEdIns};

 PRIVATE PROCEDURE MyPlace_OnAfterInsert();
 BEGIN
  MyPlace_OnAfterEdIns();
 END {MyPlace_OnAfterInsert};

 PRIVATE PROCEDURE MyPlace_OnAfterEdit();
 BEGIN
  MyPlace_OnAfterEdIns();
 END {MyPlace_OnAfterEdit};

 PRIVATE PROCEDURE MySite_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="MyFirm";
  L_WDO.iMayBeEmpty  (1, ["MySite.Till"]);
  L_WDO.iField       (1, "MySite.Main").Format:="-|";
  L_WDO.iZone        (1).ViewOnly:=1;
 END {MySite_OnInitializeWindow};

 PRIVATE PROCEDURE mfBAE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iUnmodifiable(0, ["mfBnkAcn.FirmAcnt"]);
  L_WDO.iMayBeEmpty  (0, ["mfBnkAcn.EndTime[1]", "mfBnkAcn.EndTime[0]", "mfBnkAcn.Contract"]);
  L_WDO.iField       (0, "FirmAcnt.Type").Format:=P_Firm.fat_Pool;
  L_WDO.iProgs       (0, "MyFirm");
 END {mfBAE_OnInitializeWindow};

BEGIN
 L_Events.ExecuteHandler();
END.
