(*
%Copyright   (c) Polak Computer System
%Author      17.10.2001 13:54:50 MOG
%Purpose     믨᪠ ⮢  ࠬ
%Type        operation
%Specific    LOC
%Modified    17.09.2014 09:48:48 POLAK\LDA
%Environment
*)

 MODULE M_Bills [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_OwnData, L_MDoc, L_Str, L_Money, L_Pmnt,
        L_XDoc, L_Events, L_AFM, L_StdFrm, L_Acnt, L_PDoc, L_Dest,
        L_Prop, L_EMail, L_APEMl, P_Firm, P_MDoc, P_Math, P_Man, L_MathR,
        Math, Str, Memo, E_Pmnt, E_Bills, E_Rpr, L_CWOrder, P_Cntr, L_WDO, L_IsSData,
        L_CarAD, L_Cntr, SysLog, L_Rpr, L_XObj, L_CUC, L_AR, L_Car, L_bp, L_AcsPnt;

 PRIVATE PERMANENT VAR
  targetDate,
  targetUpTo    : DATE;
  targetContract: LIKE(Contract.Contract);
  ProcessName   : STRING[][2];
  ScsCnt,
  ErrCnt        : NUMERIC[0];
  HaltAtEnd     : SCAL[2];

 PRIVATE CONST
  MessageLineLength = 78;
  MaxMessageRows    = 5;

(*
$P{ LogTop:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
ProcessName[0], C, ""
ProcessName[1], C, ""
@
############################################################################################# ########## #####
==============================================================================================================
|                                   ⮪ 믮 ᮢ 楤                                   |
|                                                                                                            |
|############################################################################################################|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|㬥                     |                                                                     |
|-----------------------------|------------------------------------------------------------------------------|
}
*)

(*
$P{ LogLine:
?, L, ""
?, L, ""
@
|#############################|##############################################################################|
}
*)

(*
$P{ LogBot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE MDocToPrint(): SCAL[2];
 BEGIN
  RETURN ~L_XDoc.XDocIsVerifiedCC(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
 END {MDocToPrint};

 PRIVATE PROCEDURE GeneratedMDocKindToSend(): SCAL[2];
 BEGIN
  RETURN MDoc.MDocKind = L_MDoc.md_ISF;
 END {GeneratedMDocKindToSend};

 PRIVATE PROCEDURE MDocToSend(): SCAL[2];
 BEGIN
  RETURN (MDoc.Status # L_MDoc.st_Canceled) &
         ~L_XDoc.XDocIsSent(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
 END {MDocToSend};

 PRIVATE PROCEDURE storeMaxMDoc(VAR Kind: LIKE(MDoc.MDocKind)[];
                                VAR Doc : LIKE(MDoc.MDoc)[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE ~!Kind[i] & (Kind[i] # MDoc.MDocKind) DO
   INC(i);
  END;
  IF !Kind[i] THEN
   Kind[i]:=MDoc.MDocKind;
  END;
  Doc[i]:=Math.Max(Doc[i], MDoc.MDoc);
 END {storeMaxMDoc};

 PRIVATE TYPE
  tObject = SCAL[3];
  tScope  = SCAL[2];

 PRIVATE CONST
  o_cdMDC          = 0;
  o_ISF            = 1;
  o_OfflineVATMDoc = 2;

  o_Pool       = ",   ||ᯥ樠 㬥   ";

  s_All      = 0;
  s_Contract = 1;

 PRIVATE PROCEDURE Object_asStr(Object: tObject): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(o_Pool, Object);
 END {Object_asStr};

 PRIVATE PROCEDURE cabc_IsTargetMDocKind(Object   : tObject;
                                         _MDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  IF    Object = o_cdMDC THEN
   RETURN (_MDocKind = L_MDoc.md_IsS) | (_MDocKind = L_MDoc.md_ISA) | (_MDocKind = L_MDoc.md_IAS);
  ELSIF Object = o_ISF THEN
   RETURN _MDocKind = L_MDoc.md_ISF;
  ELSIF Object = o_OfflineVATMDoc THEN
   RETURN L_Pmnt.IsVATMDocKind(_MDocKind);
  END;
 END {cabc_IsTargetMDocKind};

 PRIVATE PROCEDURE cabc_IsRequired(Object: tObject; Scope: tScope; curFrom: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF (Object = o_cdMDC) | (Object = o_ISF) THEN
   Result:=MDoc.SrcDate = targetDate;
  ELSE
   Result:=L_DatTim.IsActive_Inc(MDoc.Date, curFrom, targetUpTo) &
           (L_Pmnt.E_StageOfBuildingVATMDoc(L_DatTim.Per(MDoc.Date),
                                            MDoc.MDocKind, MDoc.Dest) = L_Pmnt.sbvmd_Offline) &
           (L_DatTim.Per(MDoc.WFPeriod) >= L_Pmnt.SpecialVATMDocClcPer(MDoc.Date));
  END;
  IF Scope = s_Contract THEN
   Result:=Result & (MDoc.Contract = targetContract);
  END;
  Result:=Result & (!P_Firm.curMyFirm | (MDoc.MyFirm = P_Firm.curMyFirm));
  RETURN Result;
 END {cabc_IsRequired};

 PRIVATE PROCEDURE AskForActionDoc(ProcessName: STRING[]; curFrom: DATE);
  CONST
   buttonLength = 16;
  VAR
   Msg: STRING[];
   Through: SCAL[2];
 BEGIN
  IF ~L_General.BatchExecution_IsRunning() THEN
   Through:=L_DatTim.MonthBeg(targetUpTo) <= curFrom;
   Msg:=ProcessName+"  " +
        L_DatTim.PeriodStr(curFrom) +
        "| |" +
        L_StdFrm.DrawButton( "⬥", buttonLength, "X") +
        " " +
        L_StdFrm.DrawButton("믮", buttonLength, L_Str.PoolItem("B|D", Through));
   IF ~Through THEN
    Msg:=Msg + L_StdFrm.DrawButton(" " +
                                   L_DatTim.DateStr(targetUpTo),
                                   buttonLength,
                                   "D");
   END;
   Through:=(STDFORM("|"+Msg, , QUESTION, -1) = 2) | Through;
   IF ~Through THEN
    targetUpTo:=L_DatTim.MonthEnd(curFrom);
    L_StdFrm.Choice(ProcessName+"   "+L_DatTim.PeriodStr(curFrom));
   END;
  END; (* ~L_General.BatchExecution_IsRunning() *)
 END {AskForActionDoc};

 PRIVATE PROCEDURE Condition_asStr(Object: tObject; Scope: tScope; curFrom: DATE): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF (Object = o_cdMDC) | (Object = o_ISF) THEN
   Result:=" " + L_DatTim.DateStr(targetDate);
  ELSE
   Result:=" ਮ  " + L_DatTim.PeriodStr(curFrom) + "  " + L_DatTim.PeriodStr(targetUpTo);
  END;
  IF Scope = s_Contract THEN
   Result:=Result + "   " + targetContract;
  END;
  RETURN "(᫮: " + Result + ")";
 END {Condition_asStr};

 PRIVATE PROCEDURE OpenLog(RepName, trgProcessName: STRING[]; MessageKind: L_AcsPnt.tMessageKind);
 BEGIN
  L_AcsPnt.ShowMessage(trgProcessName, MessageKind);
  IF Str.Length(RepName) = 5 THEN
   RepName:=L_General.NameConnection(RepName);
  END;
  OPENREP(Log, RepName, Create);
  Str.Format(ProcessName, trgProcessName, 76, NONE);
  SETZERO(ScsCnt, ErrCnt);
  SETEMPTY(HaltAtEnd);
 END {OpenLog};

 PRIVATE PROCEDURE MakeLogLine(XDocId: L_XDoc.tXDocId; Msg: STRING[]; VAR Count: NUMERIC[0]);
  VAR
   curMsg: STRING[];
   MsgArr: STRING[][MaxMessageRows];
   Line  : NUMERIC[0];
   DocStr: STRING[];
 BEGIN
  IF (ErrCnt = 0) & (ScsCnt = 0) THEN
   IF !P_Firm.curMyFirm THEN
    MAKEPART(Log, LogTop, P_Firm.MyFirmName(P_Firm.mf_Own, SYSDATE()));
   ELSE
    MAKEPART(Log, LogTop, P_Firm.MyFirmName(P_Firm.curMyFirm, SYSDATE()));
   END;
  END;
  IF ~!XDocId THEN
   DocStr:=L_XDoc.extXDocStr(XDocId, L_XDoc.xdast_wDate);
  ELSE
   SETEMPTY(DocStr);
  END;
  L_StdFrm.PrepareLongStringForASLPART(Msg, MsgArr, MessageLineLength);
  FOR_EACH curMsg IN MsgArr DO
   MAKEPART(Log, LogLine, DocStr, curMsg);
   DocStr:="";
  END;
  INC(Count);
 END {MakeLogLine};

 PRIVATE PROCEDURE MakeErrLine(XDocId: L_XDoc.tXDocId; Msg: STRING[]);
 BEGIN
  MakeLogLine(XDocId, Msg, ErrCnt);
 END {MakeErrLine};

 PRIVATE PROCEDURE MakeScsLinewMsg(XDocId: L_XDoc.tXDocId; Msg: STRING[]);
 BEGIN
  MakeLogLine(XDocId, Msg, ScsCnt);
 END {MakeScsLinewMsg};

 PRIVATE PROCEDURE MakeScsLine(XDocId: L_XDoc.tXDocId);
 BEGIN
  MakeScsLinewMsg(XDocId, "OK");
 END {MakeScsLine};

 PRIVATE PROCEDURE intCloseLog(Exc: Exc_Root; forceSurveyReport: SCAL[2]);
  VAR
   FinalMsg: STRING[];
 BEGIN
  IF ~!Exc THEN
   MakeErrLine(EMPTYOF(L_XDoc.tXDocId), " ࢠ: " + Exc.Description);
  END;
  IF (ErrCnt # 0) | (ScsCnt # 0) THEN
   MAKEPART(Log, LogBot);
  END;
  CLOSEREP(Log);
  IF    ~!Exc THEN
   L_General.HaltAndSurveyLastReport(Exc);
  ELSIF ~!HaltAtEnd & HaltAtEnd THEN
   L_StdFrm.RedInform(" ᮢ 楤  ⬥");
   L_General.HaltAndSurveyLastReport(EMPTYOF(Exc_Root));
  ELSE
   FinalMsg:=ProcessName[0] + "|" + ProcessName[1] +
             "|" +
             "ࠡ⠭ ᯥ譮 "+L_Str.IntStr(ScsCnt)+" 㬥⮢";
   IF ErrCnt = 0 THEN
    L_StdFrm.Inform(FinalMsg);
    IF forceSurveyReport & !L_bp.getCurId() THEN
     L_General.SurveyLastReport();
    END;
   ELSE
    L_StdFrm.RedInform(FinalMsg + "|" +
                       "஡  "+L_Str.IntStr(ErrCnt)+" 㬥⠬");
    IF !L_bp.getCurId() THEN
     L_General.SurveyLastReport();
    END;
   END;
  END;
 END {intCloseLog};

 PRIVATE PROCEDURE CloseLog();
 BEGIN
  intCloseLog(EMPTYOF(Exc_Root), 0);
 END {CloseLog};

 PRIVATE PROCEDURE CheckMDocToRemove_woHandicraft(wSuccessRegistration: SCAL[2]);
 BEGIN
  IF ~L_XDoc.XDoc_wo_Handicraft(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   IF !HaltAtEnd THEN
    HaltAtEnd:=~L_StdFrm.RedAlternative(" 㬥,  묨 믮 ⢨ ᫥ ⮯⮢" +
                                        "|த 믮 ᮢ 楤?" +
                                        "||" + "('' = ⬥ ᮢ 楤  ᠬ . . ⮪)");
   END;
   IF HaltAtEnd THEN
    MakeErrLine(MDoc.XDocId, "(⢨ ᫥ ⮯⮢)");
   ELSE
    L_General.SilentAdminOnly();
    IF wSuccessRegistration THEN
     MakeScsLine(MDoc.XDocId);
    END;
   END;
  ELSE
   IF wSuccessRegistration THEN
    MakeScsLine(MDoc.XDocId);
   END;
  END;
 END {CheckMDocToRemove_woHandicraft};

 PRIVATE PROCEDURE molvmd_SetupPeriod(VAR curFrom: DATE);
  VAR
   lastPossiblePeriod: DATE;
 BEGIN
  lastPossiblePeriod:=L_DatTim.IncMonth(L_DatTim.Per(SYSDATE()), -1);
  curFrom   :=Math.Min(Memo.ud_mb(), lastPossiblePeriod);
  targetUpTo:=L_DatTim.MonthEnd(lastPossiblePeriod);
 END {molvmd_SetupPeriod};

 PRIVATE PROCEDURE cabd_intDoAll(Object: tObject; Scope: tScope; molvmd_From: DATE);
  CONST
   dkNum = 8;
   RepName = "RmvMD";
  VAR
   remCnt,
   i             : NUMERIC[0];
   max_Kind      : LIKE(MDoc.MDocKind)[dkNum];
   max_Doc       : LIKE(MDoc.MDoc)    [dkNum];
   DependentMDocs: L_XDoc.tXDocCollection;
   curFrom       : DATE;
 BEGIN
  APP.Get().NewPrompt("/㫨஢ 㬥⮢");
  IF ~!molvmd_From THEN
   L_General.CallUs(Scope = s_Contract);
   L_General.CallUs(ACCESS(Contract));
   targetContract:=Contract.Contract;
   curFrom:=molvmd_From;
  ELSE
   L_General.SetConcurrentMode();
   IF Scope = s_Contract THEN
    L_General.Assert(ACCESS(Contract), " ⠭ ⥪騩 ");
    targetContract:=Contract.Contract;
   END; 
   IF (Object = o_cdMDC) | (Object = o_ISF) THEN
    targetDate:=Memo.ud_cd();
    SETEMPTY(curFrom);
    IF Scope = s_Contract THEN
     P_Firm.curMyFirm:=Contract.MyFirm;
    ELSE
     P_Firm.curMyFirm:=P_Firm.ChoiceMyFirm();
    END;
   ELSE
    molvmd_SetupPeriod(curFrom);
   END;
   OpenLog(RepName,
           " ࠭ ନ஢ : " + Object_asStr(Object) +
           L_Str.CRLF + Condition_asStr(Object, Scope, curFrom),
           L_AcsPnt.aprm_Choice);
  END; (* IF ~!molvmd_From *)
  SETEMPTY(max_Kind);
  SETZERO(remCnt, max_Doc);
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   SAVE(MDocKind);
   IF cabc_IsTargetMDocKind(Object, MDocKind.MDocKind) THEN
    IF Scope = s_Contract THEN
     SELECT(MDoc, Contract, , targetContract, MDocKind.MDocKind);
    ELSE
     SELECT(MDoc, MDKDate, , MDocKind.MDocKind);
    END;
    IF Object = o_OfflineVATMDoc THEN
     SRCINSEL(MDoc, GE, , curFrom);
    END;
    WHILE OCCURE(MDoc) & ((Object # o_OfflineVATMDoc) | (MDoc.Date <= targetUpTo)) DO
     PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
     IF (MDoc.Status # L_MDoc.st_Canceled) &
        cabc_IsRequired(Object, Scope, curFrom) &
        L_XDoc.XDocWasAutoBuild(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
      CheckMDocToRemove_woHandicraft(!molvmd_From);
      SAVE(MDoc);
      i:=0;
      DependentMDocs:=L_MDoc.GetDependentMDocXDC();
      WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
       storeMaxMDoc(max_Kind, max_Doc);
       IF L_XDoc.XDocWasAutoBuild(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc) & L_MDoc.E_RemoveRefTo() THEN
        CheckMDocToRemove_woHandicraft(!molvmd_From);
        IF Object = o_OfflineVATMDoc THEN
         L_MDoc.Cancel_MDoc();
        ELSE
         L_MDoc.Remove_MDoc();
        END;
        INC(remCnt);
       ELSE
        L_MDoc.BreakRef();
       END;
       INC(i);
      END; (* WHILE L_XDoc.xdc_PositionOn ... *)
      RESTORE(MDoc);
      storeMaxMDoc(max_Kind, max_Doc);
      IF Object = o_OfflineVATMDoc THEN
       L_MDoc.Cancel_MDoc();
       NEXT(MDoc);
      ELSE
       L_MDoc.Remove_MDoc();
      END;
      INC(remCnt);
     ELSE
      NEXT(MDoc);
     END;
    END;
   END;
   RESTORE(MDocKind);
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
  IF remCnt>0 THEN
   i:=0;
   WHILE ~!max_Kind[i] DO
    L_Pmnt.CheckRemoveOrder(max_Kind[i], max_Doc[i]);
    INC(i);
   END;
  END;
  IF !molvmd_From THEN
   IF Object = o_OfflineVATMDoc THEN
    IF    Scope = s_Contract THEN
     SELECT(Contract, Contract, , targetContract);
    ELSIF Scope = s_All THEN
     SELECT(Contract, Leaf, , 1);
    ELSE
     L_General.CallUs(0);
    END;
    WHILE OCCURE(Contract) DO
     PROMPT("ࠡ⪠ " + Contract.Contract);
     L_Pmnt.SetSpecialVATMDocDone(Contract.Contract, curFrom, 0, 0);
     NEXT(Contract);
    END; (* WHILE OCCURE(Contract) ... *)
    IF Scope = s_All THEN
     SysLog.Mark(RepName, " : " + Object_asStr(Object) +
                          "  " + L_DatTim.PeriodStr(curFrom) + "  " + L_DatTim.PeriodStr(targetUpTo));
    END;
   END; (* IF Object = o_OfflineVATMDoc *)
   CloseLog();
  END; (* IF !molvmd_From *)
 END {cabd_intDoAll};

 PRIVATE PROCEDURE cabd_DoAll(Object: tObject; Scope: tScope);
 BEGIN
  cabd_intDoAll(Object, Scope, EMPTYOF(DATE));
 END {cabd_DoAll};

 PUBLIC PROCEDURE RemoveOfflineVATMDoc_All();
 BEGIN
  cabd_intDoAll(o_OfflineVATMDoc, s_All, EMPTYOF(DATE));
 END {RemoveOfflineVATMDoc_All};

 PUBLIC PROCEDURE RemoveOfflineVATMDoc_Contract();
 BEGIN
  cabd_intDoAll(o_OfflineVATMDoc, s_Contract, EMPTYOF(DATE));
 END {RemoveOfflineVATMDoc_Contract};

 PRIVATE PROCEDURE cdMDC_PutSingleMDocKind(_MDocKind: LIKE(MDoc.MDocKind));
 BEGIN
  SELECT(MDoc, MDoc, , _MDocKind);
  WHILE OCCURE(MDoc) DO
   PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   IF (MDoc.SrcDate = targetDate) & (!P_Firm.curMyFirm | (MDoc.MyFirm = P_Firm.curMyFirm)) THEN
    cdMDC.MDocKind:=MDoc.MDocKind;
    cdMDC.MDoc    :=MDoc.MDoc;
    INSERT(cdMDC);
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) *)
 END {cdMDC_PutSingleMDocKind};

 PRIVATE PROCEDURE cdMDC_Prepare();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AFM.MakeIndex("cdMDC", "MDocKind: LIKE(MDoc.MDocKind);"+
                           "MDoc    : LIKE(MDoc.MDoc)");
  cdMDC_PutSingleMDocKind(L_MDoc.md_IsS);
  cdMDC_PutSingleMDocKind(L_MDoc.md_ISA);
  cdMDC_PutSingleMDocKind(L_MDoc.md_IAS);
 END {cdMDC_Prepare};

 PRIVATE PROCEDURE cdMDC_Purge();
 BEGIN
  L_AFM.AF_PurgeTemp("cdMDC");
 END {cdMDC_Purge};

 PRIVATE PROCEDURE InIndexForPrint(IsGnrtd: SCAL[2]);
 BEGIN
  IF MDocToPrint() & (MDoc.Status=L_MDoc.st_Passed) THEN
   MDtoP._Firm    :=MDoc.Firm;
   MDtoP._Contract:=MDoc.Contract;
   MDtoP._MDocKind:=MDoc.MDocKind;
   MDtoP._MDoc    :=MDoc.MDoc;
   MDtoP._IsGnrtd  :=IsGnrtd;
   INSERT(MDtoP);
  END;
 END {InIndexForPrint};

 PUBLIC PROCEDURE PrintBills();
  VAR
   i             : NUMERIC[0];
   DependentMDocs: L_XDoc.tXDocCollection;
 BEGIN
  SETEMPTY(P_Firm.curMyFirm);
  targetDate:=Memo.ud_cd();
  OpenLog("PrnMD", " ਣ  ⮢  "+L_DatTim.DateStr(targetDate)+"| 易   㬥⮢", L_AcsPnt.aprm_Inform);
  L_AFM.MakeIndex("MDtoP", "_Firm    : LIKE(Firm.Firm);"+
                           "_Contract: LIKE(Contract.Contract);"+
                           "_IsGnrtd : SCAL[2];"+
                           "_MDocKind: LIKE(MDoc.MDocKind);"+
                           "_MDoc    : LIKE(MDoc.MDoc)");
  cdMDC_Prepare();
  SELECT(cdMDC, cdMDC);
  WHILE OCCURE(cdMDC) DO
   SEARCH(MDoc, MDoc, , cdMDC.MDocKind, cdMDC.MDoc);
   InIndexForPrint(0);
   SAVE(MDoc);
   i:=0;
   DependentMDocs:=L_MDoc.GetDependentMDocXDC();
   WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
    IF MDoc.MDocKind = L_MDoc.md_ISF THEN
     InIndexForPrint(1);
    END;
    INC(i);
   END; (* WHILE L_XDoc.xdc_PositionOn ... *)
   RESTORE(MDoc);
   NEXT(cdMDC);
  END; (* WHILE OCCURE(MDoc) ... *)
  cdMDC_Purge();

  SELECT(MDtoP, MDtoP);
  WHILE OCCURE(MDtoP) DO
   SEARCH(MDoc, MDoc, , MDtoP._MDocKind, MDtoP._MDoc);
   PROMPT(" " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   TRY [TRANSACTION(TRANSACTION_SLAVE), MSG_SUPPRESSION(MSG_SUPPRESSION_NONE)]
    CALL(MDoc.StreamRePrint());
   EXCEPT
   END; (* TRY *)

   TRY [TRANSACTION(TRANSACTION_SLAVE)]
    CALL(MDoc.StreamPrint());
    MakeScsLine(MDoc.XDocId);
   EXCEPT
   ON Exc: Exc_Root DO
    MakeErrLine(MDoc.XDocId, "㬥  ⯥⠭! 稭: " + Exc.Description);
   END; (* TRY *)
   NEXT(MDtoP);
  END; (* WHILE OCCURE(MDtoP) ... *)
  L_AFM.AF_PurgeTemp("MDtoP");
  CloseLog();
 END {PrintBills};

 PRIVATE PROCEDURE StreamSendMDoc(): SCAL[2];
 BEGIN
  IF MDocToSend() THEN
   PROMPT("ࠢ " + MDoc.MDoc);
   TRY
    CALL(MDoc.StreamSending());
    RETURN 1;
   EXCEPT
   ON Exc: Exc_Root DO
    MakeErrLine(MDoc.XDocId, Exc.Description);
   END;
  END;
  RETURN 0;
 END {StreamSendMDoc};

 PUBLIC PROCEDURE SendBills();
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
 BEGIN
  targetDate:=Memo.ud_cd();
  OpenLog("SndBl",
          "ࠢ  ⮢  "+L_DatTim.DateStr(targetDate)+"  易   㬥⮢",
          L_AcsPnt.aprm_Inform);
  cdMDC_Prepare();
  SELECT(cdMDC, cdMDC);
  WHILE OCCURE(cdMDC) DO
   SEARCH(MDoc, MDoc, , cdMDC.MDocKind, cdMDC.MDoc);
   IF StreamSendMDoc() THEN
    MakeScsLine(MDoc.XDocId);
   END;
   SAVE(MDoc);
   i:=0;
   DependentMDocs:=L_MDoc.GetDependentMDocXDC();
   WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
    IF GeneratedMDocKindToSend() & StreamSendMDoc() THEN
     MakeScsLine(MDoc.XDocId);
    END;
    INC(i);
   END; (* WHILE L_XDoc.xdc_PositionOn ... *)
   RESTORE(MDoc);
   NEXT(cdMDC);
  END; (* WHILE OCCURE(cdMDC) ... *)
  cdMDC_Purge();
  CloseLog();
 END {SendBills};

 PUBLIC PROCEDURE MakeISFs();
 BEGIN
  P_Firm.curMyFirm:=P_Firm.ChoiceMyFirm();
  targetDate:=Memo.ud_cd();
  OpenLog("ISFs0", "ନ஢ ⮢-䠪  "+L_DatTim.DateStr(targetDate), L_AcsPnt.aprm_Inform);
  cdMDC_Prepare();
  SELECT(cdMDC, cdMDC);
  WHILE OCCURE(cdMDC) DO
   NARROWSEL(cdMDC, MDocKind);
   IF L_Pmnt.IsAcptMDocKind(cdMDC.MDocKind) THEN
    WHILE OCCURE(cdMDC) DO
     PROMPT("ନ஢ -䠪 " + cdMDC.MDoc);
     SEARCH(MDoc, MDoc, , cdMDC.MDocKind, cdMDC.MDoc);
     TRY
      L_Pmnt.Build_VATMDocs(1, L_Pmnt.sbvmd_Online);
      MakeScsLine(MDoc.XDocId);
     EXCEPT
     ON Exc: Exc_Root DO
      MakeErrLine(MDoc.XDocId, Exc.Description);
     END;
     NEXT(cdMDC);
    END; (* WHILE OCCURE(cdMDC) ... *)
   END;
   NEXTINEXTENDEDSEL(cdMDC, MDocKind);
  END; (* WHILE OCCURE(cdMDC) ... *)
  cdMDC_Purge();
  CloseLog();
 END {MakeISFs};

 PUBLIC PROCEDURE RemoveISFs_All();
 BEGIN
  cabd_DoAll(o_ISF, s_All);
 END {RemoveISFs_All};

 PRIVATE PROCEDURE molvmd_SingleContract(curFrom: DATE);
  VAR
   curXDocId,
   comXDocId : L_XDoc.tXDocId;
   ContextDsc: STRING[];
 BEGIN
  APP.Get().NewPrompt(" " + Contract.Contract);
  TRY
   SETEMPTY(comXDocId);
   L_General.SetConcurrentMode();
   L_General.CallUs(ACCESS(Contract));
   WHILE ~L_Pmnt.IsSpecialVATMDocDone(Contract.Contract, curFrom) DO
    curFrom:=L_DatTim.IncMonth(curFrom, -1);
   END;
   REPEAT
    curFrom:=L_DatTim.IncMonth(curFrom, +1);
   UNTIL (curFrom > targetUpTo) | ~L_Pmnt.IsSpecialVATMDocDone(Contract.Contract, curFrom);
   IF curFrom < targetUpTo THEN
    cabd_intDoAll(o_OfflineVATMDoc, s_Contract, curFrom);
    SAVE(Contract);
    SELECT(MDocKind, MDocKind);
    WHILE OCCURE(MDocKind) DO
     IF L_Pmnt.IsAcptMDocKind(MDocKind.MDocKind) THEN
      SAVE(MDocKind);
      SETSEL(MDoc, Contract, Contract.Contract, MDocKind.MDocKind);
      SRCINSEL(MDoc, GE, , curFrom);
      WHILE OCCURE(MDoc) & (MDoc.Date <= targetUpTo) DO
       IF (MDoc.Status # L_MDoc.st_Canceled) THEN
        curXDocId:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
        MOVMD.Contract:=Contract.Contract;
        MOVMD.Date    :=MDoc.Date;
        MOVMD.OrdVal  :=L_Pmnt.XDocOrderValue(curXDocId); (* ᭠砫  PDoc 06.10.2006 12:36:20 KLIN\San.Polak 0053199 *)
        MOVMD.DoneDTS :=MDoc.DoneDTS;
        MOVMD.XDocId  :=curXDocId;
        INSERT(MOVMD);
       END;
       NEXT(MDoc);
      END; (* WHILE OCCURE(MDoc) ... *)
      RESTORE(MDocKind);
     END;
     NEXT(MDocKind);
    END; (* WHILE OCCURE(MDocKind) ... *)
  
    SETSEL(PDocMDoc, Contract, Contract.Contract);
    SRCINSEL(PDocMDoc, GE, , curFrom);
    WHILE OCCURE(PDocMDoc) & (PDocMDoc.PDocDate <= targetUpTo) DO
     CONFORM(PDocMDoc, PDoc);
     IF (PDoc.Status # L_PDoc.st_Canceled) & L_Pmnt.TakePDocMDocIntoAccount() THEN
      curXDocId:=L_XDoc.curXDocId(L_XDoc.xdt_PDoc);
      IF ~SELECT(MOVMD, MOVMD, Contract.Contract, PDoc.Date, L_Pmnt.XDocOrderValue(curXDocId), PDoc.DoneDTS, curXDocId) THEN
       MOVMD.Contract:=Contract.Contract;
       MOVMD.Date    :=PDoc.Date;
       MOVMD.OrdVal  :=L_Pmnt.XDocOrderValue(curXDocId); (* ᭠砫  PDoc 06.10.2006 12:36:20 KLIN\San.Polak 0053199 *)
       MOVMD.DoneDTS :=PDoc.DoneDTS;
       MOVMD.XDocId  :=curXDocId;
       INSERT(MOVMD);
      END;
     END;
     NEXT(PDocMDoc);
    END; (* WHILE OCCURE(PDocMDoc) ... *)
  
    SELECT(MOVMD, MOVMD, , Contract.Contract);
    WHILE OCCURE(MOVMD) DO
     NARROWSEL(MOVMD, Date);
     WHILE OCCURE(MOVMD) DO
      L_XDoc.PositionOnXDoc(MOVMD.XDocId);
      comXDocId:=MOVMD.XDocId;
      PROMPT(" " + L_XDoc.extXDocStr(comXDocId, L_XDoc.xdast_wDate));
      IF L_XDoc.ExtractXDocType(MOVMD.XDocId) = L_XDoc.xdt_PDoc THEN
       IF ~L_Pmnt.VATMDocsAlreadyBuilt(L_Pmnt.sbvmd_Offline, PDoc.Date, L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, MOVMD.Contract) THEN
        L_Pmnt.AnalyzePaymentByContract(MOVMD.Contract, 1, L_Pmnt.sbvmd_Offline);
        IF L_Pmnt.VATMDocsAlreadyBuilt(L_Pmnt.sbvmd_Offline, PDoc.Date, L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, MOVMD.Contract) THEN
         MakeScsLine(PDoc.XDocId);
        END;
       END;
      ELSE
       IF ~L_Pmnt.VATMDocsAlreadyBuilt(L_Pmnt.sbvmd_Offline, MDoc.Date, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, MOVMD.Contract) THEN
        L_Pmnt.Build_VATMDocs(1, L_Pmnt.sbvmd_Offline);
        IF L_Pmnt.VATMDocsAlreadyBuilt(L_Pmnt.sbvmd_Offline, MDoc.Date, L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, MOVMD.Contract) THEN
         MakeScsLine(MDoc.XDocId);
        END;
       END;
      END;
      NEXT(MOVMD);
     END; (* WHILE OCCURE(MOVMD) ... *)
     NEXTINEXTENDEDSEL(MOVMD, Date);
    END; (* WHILE OCCURE(MOVMD) ... *)
  
    WHILE curFrom <= targetUpTo DO
     L_Pmnt.SetSpecialVATMDocDone(Contract.Contract, curFrom, 1, 0);
     curFrom:=L_DatTim.IncMonth(curFrom, +1);
    END;
    RESTORE(Contract);
   END; (* IF curFrom < targetUpTo *)
  EXCEPT
  ON Exc:Exc_Root DO
   MakeErrLine(comXDocId, Exc.Description);
   RAISE();
  END;
 END {molvmd_SingleContract};

 PRIVATE PROCEDURE MakeOfflineVATMDoc(Scope: tScope; RepName: STRING[]);
  VAR
   Object : tObject;
   D      : DATE;
   PrcName: STRING[];
   Through: SCAL[2];
   curFrom: DATE;
 BEGIN
  APP.Get().NewPrompt("ନ஢ ");
  Object:=o_OfflineVATMDoc;
  IF Scope = s_Contract THEN
   L_General.Assert(ACCESS(Contract), " ⠭ ⥪騩 ");
   L_Cntr.CheckIsContract();
   targetContract:=Contract.Contract;
   P_Firm.curMyFirm:=Contract.MyFirm;
   SELECT(Contract, Contract, , targetContract);
  ELSE
   SETEMPTY(P_Firm.curMyFirm);
   SETEMPTY(targetContract);
   SELECT(Contract, Leaf, , 1);
  END;
  molvmd_SetupPeriod(curFrom);
  PrcName:="ନ஢ : " + Object_asStr(Object);
  AskForActionDoc(PrcName, curFrom);
  OpenLog(RepName, PrcName + L_Str.CRLF + Condition_asStr(Object, Scope, curFrom), L_AcsPnt.aprm_None);
  TRY [TERMBYUSERMODE(TERMBYUSERMODE_THROW)]
   L_AFM.MakeIndex("MOVMD", "Contract: LIKE(Contract.Contract);"+
                            "Date    : DATE;"+
                            "OrdVal  : "+TYPENAMEOF(L_Pmnt.tXDocOrderValue)+";"+
                            "DoneDTS : FLOAT;"+
                            "XDocId  : "+TYPENAMEOF(L_XDoc.tXDocId));
   WHILE OCCURE(Contract) DO
    TRY [TRANSACTION(TRANSACTION_SLAVE), MSGSUPPRESSIONMODE(MSGSUPPRESS_NONE)]
     molvmd_SingleContract(curFrom);
    EXCEPT
    ON Exc:Exc_Root DO
     (*  ࠡ⪠  molvmd_SingleContract *)
    END;
    NEXT(Contract);
   END; (* WHILE OCCURE(Contract) ... *)
   IF Scope = s_All THEN
    SysLog.Mark(RepName, PrcName + "  " + L_DatTim.PeriodStr(curFrom) + "  " + L_DatTim.PeriodStr(targetUpTo));
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   intCloseLog(Exc, 0);
   L_General.CallUs(0);
  END;
  intCloseLog(EMPTYOF(Exc_Root), 0);
 END {MakeOfflineVATMDoc};

 PUBLIC PROCEDURE MakeOfflineVATMDoc_All();
  CONST
   bpId = "MPVDs";
 BEGIN
  L_bp.Begin(bpId, "ନ஢ ", L_bp.t_Prc_wRp, L_General.tc_inMonth);
  MakeOfflineVATMDoc(s_All, bpId);
  L_bp.End();
 END {MakeOfflineVATMDoc_All};

 PUBLIC PROCEDURE MakeOfflineVATMDoc_Contract();
 BEGIN
  MakeOfflineVATMDoc(s_Contract, "MPVDc");
 END {MakeOfflineVATMDoc_Contract};

 PUBLIC TYPE
  tPeriodicCntrQnt = FLOAT; (* L_XObj.tQnt    - . 0067789 *)

 PUBLIC PROCEDURE mb_CalcPeriodicCntrBillQnt(D: DATE): tPeriodicCntrQnt;
  VAR
   P,
   EndP,
   pad_Begin,
   pad_Till : DATE;
   Result   : tPeriodicCntrQnt;
 BEGIN
  EndP:=L_DatTim.MonthEnd(D);
  IF Contract.Begin <= EndP THEN
   P:=L_DatTim.MonthBeg(D);
   P_Cntr.GetPeriodicAcptDurationStrong(Contract.Contract, EndP, pad_Begin, pad_Till);
   pad_Till:=Math.Min(pad_Till, Contract.Till);
   Result:=L_DatTim.DATEINT(P, EndP, pad_Begin, L_DatTim.till2ED(pad_Till))/L_DatTim.MonthLen(D);
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {mb_CalcPeriodicCntrBillQnt};

 PUBLIC PROCEDURE FindMDocOfCntrOnDate(trgContract: LIKE(Contract.Contract);
                                       trgDate    : DATE;
                                       trgMDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
 BEGIN
  SELECT(MDoc, Contract, , trgContract, trgMDocKind, trgDate);
  LOOP
   IF ~OCCURE(MDoc) THEN
    RETURN 0;
   ELSIF MDoc.Status#L_MDoc.st_Canceled THEN
    RETURN 1;
   END;
   NEXT(MDoc);
  END; (* LOOP *)
 END {FindMDocOfCntrOnDate};

 PRIVATE PROCEDURE mb_MakeMDoc(trgMDocKind: LIKE(MDocKind.MDocKind);
                               trgSrcDate,
                               trgDate    : DATE;
                               trgDest    : LIKE(Dest.Dest);
                               trgMath    : LIKE(Math.Math);
                               trgSum     : L_XObj.tSum;
                               trgQnt     : L_XObj.tQnt);
  VAR
   curNetto: LIKE(MDocList.Sum);
   curVAT  : LIKE(MDocList.VAT);
 BEGIN
  IF FindMDocOfCntrOnDate(Contract.Contract, trgDate, trgMDocKind) THEN
   L_General.Error("  ⭮ ⮩ "+L_DatTim.DateStr(trgDate)+" 㦥 : " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
  END;
  DEFAULT(MDoc);
  MDoc.MDocKind:=trgMDocKind;
  L_MDoc.Insert_MDoc();
  MDoc.SrcDate :=trgSrcDate;
  MDoc.Date    :=trgDate;

  MDoc.PayDate :=L_Pmnt.GetMDocPayDate(P_Cntr.GetCntrProStrongNum(Contract.Contract, MDoc.SrcDate, P_Cntr.P_PaymentDay));
  MDoc.Firm    :=Contract.Firm;
  MDoc.Contract:=Contract.Contract;
  MDoc.TSN     :=L_MDoc.curUSER2MDocTSN(0);
  MDoc.Dest    :=trgDest;
  MDoc.CostItem:=L_MDoc.E_DefMDocCostItem();
  MDoc.Alower  :=L_MDoc.E_DefaultAlower(MDoc.Date);
  MDoc.Status  :=L_MDoc.st_Passed;
  MDoc.Total   :=0;
  REPLACE(MDoc);

  SEARCH(Math, Math, , trgMath);
  IF P_Cntr.GetSpecialAttitudeToVAT(MDoc.Contract, MDoc.Date) = P_Cntr.satVAT_woFeatures THEN
   IF L_General.IsPolakSpecific() THEN
    curVAT  :=L_Acnt.GetExclMathVAT(Math.Math, MDoc.Date, trgSum);
    curNetto:=trgSum;
   ELSE
    curVAT  :=L_Acnt.GetInclMathVAT(Math.Math, MDoc.Date, trgSum);
    curNetto:=trgSum-curVAT;
   END;
  ELSE
   curVAT  :=0;
   curNetto:=trgSum;
  END;
  L_MDoc.InsMDocList(Math.Math, L_MathR.mm_New, EMPTYOF(MDocList.VATMode), trgQnt, curNetto, curVAT);
  L_Pmnt.FillMDocListCstDclr(1);
  L_MDoc.MDoc_OnAnyModification(+1, 0, 0);
 END {mb_MakeMDoc};

 PRIVATE PROCEDURE mb_BuildByFixedSum(): SCAL[2];
  VAR
   regMDocKind,
   acpMDocKind : LIKE(MDoc.MDocKind);
   regSrcDate,
   regDate     : DATE;
   regDest     : LIKE(Dest.Dest);
   curQnt      : tPeriodicCntrQnt;
   curSum      : NUMERIC[2];
   Result      : SCAL[2];
 BEGIN
  Result:=1;
  regSrcDate:=Memo.ud_cd();
  regDate   :=L_DatTim.Per(regSrcDate)-1;
  regSrcDate:=Math.Max(regSrcDate, Contract.SrcDate);
  L_General.Assert(L_DatTim.IsActive(regDate, Contract.Begin, Contract.Till),
                   "⭠   ਮ ਬ ");
  L_General.Assert(P_Cntr.GetMakeBillsPayMode(Contract.Contract, regDate) = P_Cntr.mbpm_Recurrent,
                   "ࠪ     ਮ᪨");

  curQnt:=mb_CalcPeriodicCntrBillQnt(regDate);
  IF curQnt # 0 THEN
   curSum:=curQnt * P_Cntr.GetCntrProStrongNum(Contract.Contract, regDate, P_Cntr.P_Sum);
   P_Cntr.GetMakeBillsSettings(Contract.Contract, regDate,
                               regMDocKind, acpMDocKind);
   regDest:=P_Cntr.GetFirstAllowedDest(Contract.Contract, regDate);
   mb_MakeMDoc(regMDocKind, regSrcDate, regDate, regDest,
               P_Cntr.GetCntrProStrong(Contract.Contract, regDate, P_Cntr.P_SingleMath),
               curSum, curQnt);
   IF ~!acpMDocKind THEN
    IF L_Pmnt.IsAcceptableAddMDocKind(acpMDocKind) THEN
     SAVE(MDoc);
     L_Pmnt.Build_MDoc(acpMDocKind, 1, 1);
     RESTORE(MDoc);
    END;
   END;
  ELSE
   L_General.Error("⥪ ப ਮ᪮ ॠ樨");
  END;
  RETURN Result;
 END {mb_BuildByFixedSum};

 PRIVATE PROCEDURE E_SurroundMakeBill(Before, Stream: SCAL[2]);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Bills.SurroundMakeBill);
  IF ~!Local THEN
   Local(Before, Stream);
  END;
 END {E_SurroundMakeBill};

 PRIVATE PROCEDURE E_MakeBill(Stream: SCAL[2]; VAR addMsg: STRING[]): SCAL[2];
  VAR
   Local : PROC;
   Result: SCAL[2];
   mbm   : P_Cntr.tMakeBillsMth;
 BEGIN
  SAVE(Contract);
  addMsg:="";
  Result:=0;
  TRY
   mbm:=P_Cntr.GetMakeBillsMth(Contract.Contract, Memo.ud_cd());
   IF mbm # P_Cntr.mbm_Not THEN
    CONFORM(Contract, CntrT);
    IF    mbm = P_Cntr.mbm_FixedSum THEN
     Result:=mb_BuildByFixedSum();
    ELSIF mbm = P_Cntr.mbm_Special  THEN
     Local:=PROCREF(E_Bills.MakeBill);
     IF ~!Local THEN
      Result:=Local(Stream);
     ELSE
      L_General.Error(" । 楤 '樠쭮 浪 ⮢ ⮢'");
     END;
    END;
   END;
   IF Result THEN
    TRY
     L_Pmnt.ConfirmGeneratedDocs(Stream, MDoc.XDocId);
    EXCEPT
    ON Exc: Exc_Raise DO
     IF Stream THEN
      addMsg:=". "+L_XDoc.XDocStr(MDoc.XDocId)+" ⠫  ﭨ ' ࠡ⠭'. 稭: "+Exc.Description;
     ELSE
      RAISE();
     END;
    END; (* TRY *)
   END;
  EXCEPT
  FINALLY
   RESTORE(Contract);
  END;
  RETURN Result;
 END {E_MakeBill};

 PRIVATE PROCEDURE GatherByMDoc(XDT : L_XDoc.tXDocType;
                                P   : PROC;
                                PerB: DATE);
  VAR
   DependentMDocs: STRING[];
   i             : NUMERIC[0];
   curXDocId     : L_XDoc.tXDocId;
 BEGIN
  curXDocId     :=L_XDoc.curXDocId(XDT);
  DependentMDocs:=L_XDoc.GetDependentXDC(curXDocId, L_XDoc.xdt_MDoc);
  i:=0;
  WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
   IF (MDoc.Status # L_MDoc.st_Canceled) & P() &
      (!PerB | L_DatTim.IsActive_Inc(MDoc.Date, PerB, L_DatTim.MonthEnd(PerB))) THEN
    CONFORM(MDoc, MDocList);
    WHILE OCCURE(MDocList) DO
     ADD(TmMDL, XDocId, , curXDocId, MDocList.Math,
         TmMDL.MDPay, MDocList.Sum + MDocList.VAT);
     NEXT(MDocList);
    END; (* WHILE OCCURE(MDocList) ... *)
   END;
   INC(i);
  END; (* L_XDoc.xdc_PositionOn ... *)
 END {GatherByMDoc};

 PRIVATE PROCEDURE IsMDocKindRequiredContract(trgMDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
 BEGIN
  RETURN (trgMDocKind # L_MDoc.md_NOV) & (trgMDocKind # L_MDoc.md_TOV) & (trgMDocKind # L_MDoc.md_ViP);
 END {IsMDocKindRequiredContract};

 PRIVATE PROCEDURE E_FillDefMDocAttrByRprS();
  VAR
   Local : PROC;
 BEGIN
  Local:=PROCREF(E_Rpr.FillDefMDocAttrByRprS);
  IF ~!Local THEN
   Local();
  END;
 END {E_FillDefMDocAttrByRprS};

 PRIVATE PROCEDURE MakeNewMDoc(trgMDocKind: LIKE(MDocKind.MDocKind);
                               trgDate    : DATE;
                               trgStorage : LIKE(Storage.Storage);
                               byRprS     : SCAL[2]): L_XDoc.tXDocId;
 BEGIN
  IF trgMDocKind # L_MDoc.md_IsS THEN
   L_General.Assert(trgDate <= Memo.ud_cd(), "४⭠ ⥪   ନ஢ 㬥");
  END;
  L_General.Assert(SEARCH(MDocKind, MDocKind, trgMDocKind), "  㬥 " + trgMDocKind);

  DEFAULT(MDoc);
  MDoc.MDocKind:=trgMDocKind;
  MDoc.Date    :=Memo.ud_cd();
  L_MDoc.Insert_MDoc();
  MDoc.SrcDate :=MDoc.Date;
  IF L_MDoc.IsMDocKind_wAnyStorage() THEN
   MDoc.Storage :=trgStorage;
   IF trgMDocKind = L_MDoc.md_NOV THEN
    MDoc.BoxNbr:=Car.BoxNbr;
   END;
  END;
  IF IsMDocKindRequiredContract(trgMDocKind) THEN
   MDoc.Firm    :=Contract.Firm;
   MDoc.Contract:=Contract.Contract;
  END;
  MDoc.TSN     :=L_MDoc.curUSER2MDocTSN(0);
  MDoc.PayDate :=L_Pmnt.E_DefineMDocPayDate();
  IF byRprS THEN
   E_FillDefMDocAttrByRprS();
  END;
  IF !MDoc.Dest THEN
   MDoc.Dest:=L_MDoc.E_DefMDocDest(MDoc.Date);
  END;
  IF !MDoc.Dest THEN
   MDoc.Dest:=L_Acnt.E_FictDest();
  END;
  IF !MDoc.CostItem THEN
   MDoc.CostItem:=L_MDoc.E_DefMDocCostItem();
  END;
  IF !MDoc.Alower THEN
   MDoc.Alower:=L_MDoc.E_DefaultAlower(MDoc.Date);
  END;
  MDoc.Status  :=MDocKind.DfStatus;
  REPLACE(MDoc);

  RETURN MDoc.XDocId;
 END {MakeNewMDoc};

 PRIVATE PROCEDURE FinishGenerateMDoc(XDocIds: L_XDoc.tXDocCollection; trgMDocKind: LIKE(MDocKind.MDocKind));
  CONST
   ed_NothingToPay = "   ନ஢ ";
  VAR
   i  : NUMERIC[0];
   Msg: STRING[];
 BEGIN
  IF !XDocIds THEN
   IF !trgMDocKind THEN
    Msg:="㬥⮢";
   ELSE
    Msg:=L_MDoc.MDocKindNick(trgMDocKind, 1);
   END;
   RAISE(, ed_NothingToPay + Msg + "   " + L_DatTim.DateStr(Memo.ud_cd()));
  END;

  i:=0;
  WHILE ~!L_XDoc.xdc_Item(XDocIds, i) DO
   L_XDoc.PositionOnXDoc(L_XDoc.xdc_Item(XDocIds, i));
   CONFORM(MDoc, MDocList);
   IF ~OCCURE(MDocList) THEN
    RAISE(, ed_NothingToPay);
   END;
   L_MDoc.MDoc_OnAnyModification(+1, 0, 0);
   INC(i);
  END;
 END {FinishGenerateMDoc};

 PRIVATE PROCEDURE GenerateMDocBySpecificDeal(trgMDocKind: LIKE(MDocKind.MDocKind); trgDate: DATE): L_XDoc.tXDocCollection;
  VAR
   VAT,
   TotalSum: L_XObj.tSum;
   trgMath : LIKE(Math.Math);
   XDocIds : L_XDoc.tXDocCollection;
 BEGIN
  SETEMPTY(XDocIds);
  L_XDoc.xdc_Put(XDocIds, MakeNewMDoc(trgMDocKind, trgDate, EMPTYOF(Storage.Storage), 0));

  SELECT(TmMDL, Math);
  WHILE OCCURE(TmMDL) DO
   NARROWSEL(TmMDL, Math);
   trgMath:=TmMDL.Math;
   SETZERO(TotalSum);
   WHILE OCCURE(TmMDL) DO
    IF TmMDL.ToPay > 0 THEN
     INC(TotalSum, TmMDL.ToPay - TmMDL.MDPay);
    END;
    NEXT(TmMDL);
   END; (* WHILE OCCURE(TmMDL) ... *)
   IF TotalSum # 0 THEN
    VAT:=L_Acnt.GetInclMathVAT(trgMath, MDoc.Date, TotalSum);
    L_MDoc.extInsMDocList(trgMath, L_MathR.mm_New, EMPTYOF(MDocList.VATMode), 000, 1, TotalSum-VAT, VAT);
   END;
   NEXTINEXTENDEDSEL(TmMDL, Math);
  END; (* WHILE OCCURE(TmMDL) ... *)

  SELECT(TmMDL, XDocId);
  WHILE OCCURE(TmMDL) DO
   NARROWSEL(TmMDL, XDocId);
   L_XDoc.rf_Insert(L_XDoc.xdt_MDoc, TmMDL.XDocId, L_XDoc.rft_BaseOn);
   NEXTINEXTENDEDSEL(TmMDL, XDocId);
  END; (* WHILE OCCURE(TmMDL) ... *)
(* Purge , ⮡  ConfirmGenerate  뫮 ࠧ ३  㬥 (  "䠩  ⪫祭")*)
  L_AFM.AF_PurgeTemp("TmMDL");

  FinishGenerateMDoc(XDocIds, trgMDocKind);
  RETURN XDocIds;
 END {GenerateMDocBySpecificDeal};

 PRIVATE PROCEDURE IsFinalMDocKindForBuildMDoc(trgMDocKind: LIKE(MDocKind.MDocKind)): SCAL[2];
 BEGIN
  RETURN (trgMDocKind = L_MDoc.md_IsS) | (trgMDocKind = L_MDoc.md_IAS) | (trgMDocKind = L_MDoc.md_RPr);
 END {IsFinalMDocKindForBuildMDoc};

 PRIVATE PROCEDURE GetRealPayer(trgDate: DATE; trgFirm: LIKE(Firm.Firm)): LIKE(Firm.Firm);
  VAR
   Result: LIKE(Firm.Firm);
 BEGIN
  Result:=L_Rpr.E_GetRealPayer(trgDate, trgFirm);
  IF Result # trgFirm THEN
   L_StdFrm.Question(" 㬥 ନ  ࠣ " + Result + ",|" +
                     "   楬 ࠭ᯮ⭮ ।⢠ (" + trgFirm + ")");
  END;
  RETURN Result;
 END {GetRealPayer};

 PRIVATE PROCEDURE GenerateFinalMDocByRprS(trgMDocKind: LIKE(MDocKind.MDocKind);
                                           Temporary  : SCAL[2]): L_XDoc.tXDocCollection;
  VAR
   trgFirm: LIKE(Firm.Firm);
   XDocIds: L_XDoc.tXDocCollection;
 BEGIN
  APP.Get().NewPrompt("ନ஢ ");
  IF ~Temporary & L_Rpr.CheckExistsFinalMDoc() THEN
   L_General.Error("  ନ஢ " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
  END;
  L_Rpr.PrepareMayBePaidMDocData(Memo.ud_cd(), 1, 0);
  SETEMPTY(XDocIds);
  L_Rpr.AccessOrigin();
  IF    L_Rpr.IsRprS_w_OutCar() THEN
   L_Rpr.StandOnRprContract(GetRealPayer(Memo.ud_cd(), OutCar.Firm), Memo.ud_cd());
   L_XDoc.xdc_Put(XDocIds, MakeNewMDoc(trgMDocKind, RprS.OrdDate, EMPTYOF(Storage.Storage), 1));
  ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
   L_Rpr.StandOnRprContract(GetRealPayer(Memo.ud_cd(), OutCBlc.Firm), Memo.ud_cd());
   L_XDoc.xdc_Put(XDocIds, MakeNewMDoc(trgMDocKind, RprS.OrdDate, EMPTYOF(Storage.Storage), 1));
  ELSIF L_Rpr.IsRprS_w_Car() THEN
   IF    Temporary THEN
    (*GAV: MakeNewMDoc ॡ ,   ६ ᮡ⢥   , 筮 *)
    SEARCH(MDocKind, MDocKind, , trgMDocKind);
    DEFAULT(MDoc);
    MDoc.MDocKind:=trgMDocKind;
    MDoc.Date    :=Memo.ud_cd();
    L_MDoc.Insert_MDoc();
    MDoc.SrcDate :=MDoc.Date;
    MDoc.Contract:=L_Cntr.erkn_Get(MDoc.Date, L_Cntr.erkn_Fictive, L_Car.GetCarMyFirm(Car.BoxNbr, MDoc.Date));
    MDoc.TSN     :=L_MDoc.curUSER2MDocTSN(0);
    MDoc.PayDate :=L_Pmnt.E_DefineMDocPayDate();
    MDoc.Dest    :=L_MDoc.E_DefMDocDest(MDoc.Date);
    MDoc.CostItem:=L_MDoc.E_DefMDocCostItem();
    MDoc.Alower  :=L_MDoc.E_DefaultAlower(MDoc.Date);
    MDoc.Status  :=MDocKind.DfStatus;
    IF !MDoc.Dest THEN
     MDoc.Dest:=L_Acnt.E_FictDest();
    END;
    REPLACE(MDoc);
    L_XDoc.xdc_Put(XDocIds, MDoc.XDocId);
   ELSE
    trgFirm:=GetRealPayer(Memo.ud_cd(), L_Car.GetFirmOfCar(Memo.ud_cd()));
    IF trgFirm # L_Car.GetFirmOfCar(Memo.ud_cd()) THEN
     L_Rpr.StandOnRprContract(trgFirm, Memo.ud_cd());
     L_XDoc.xdc_Put(XDocIds, MakeNewMDoc(trgMDocKind, RprS.OrdDate, EMPTYOF(Storage.Storage), 1));
    ELSE
     L_General.Error(" ᮡ⢥  " + Car.BoxNbr + "  । ࠣ,|" +
                     " ஬   ନ஢ .||" +
                     "᫨  㢥७  ࠢ쭮 ᢮ ⢨,|" +
                     "  ");
    END;
   END;
  END;

  L_XDoc.rf_Insert(L_XDoc.xdt_MDoc, L_XDoc.curXDocId(L_XDoc.xdt_RprS), L_XDoc.rft_RefTo);

  SELECT(_MBPM, _MBPM);
  WHILE OCCURE(_MBPM) DO
   PROMPT("⠢ ப  :  " + _MBPM.Math);
   L_MDoc.extInsMDocList(_MBPM.Math, _MBPM.MMode, _MBPM.VATMode, _MBPM.MUNbr, _MBPM.Qnt, _MBPM.Sum, _MBPM.VAT);
   NEXT(_MBPM);
  END; (* WHILE OCCURE(_MBPM) ... *)

  IF L_General.GetAPSiteNumber() = 84 THEN
   CALL(IsSData.AutoBuildMDoc_wIsSData(L_IsSData.idm_Edit));
  END;

  L_Rpr.Purge_MBPM();
  FinishGenerateMDoc(XDocIds, trgMDocKind);
  RETURN XDocIds;
 END {GenerateFinalMDocByRprS};

 PUBLIC PROCEDURE GenerateTemporaryFinalMDocByRprS(trgMDocKind: LIKE(MDocKind.MDocKind));
  VAR
   Dummy: SCAL[2];
 BEGIN
  Dummy:=L_XDoc.xdc_PositionOn(GenerateFinalMDocByRprS(trgMDocKind, 1), 0);
 END {GenerateTemporaryFinalMDocByRprS};

 PRIVATE PROCEDURE intGenerateMDocByRprS(    trgMDocKind: LIKE(MDocKind.MDocKind);
                                             trgStorage : LIKE(Storage.Storage);
                                             trgMath    : LIKE(Math.Math);
                                             trgMMode   : LIKE(MMode.MMode);
                                             trgQnt     : L_XObj.tQnt;
                                             trgSum     : L_XObj.tSum;
                                         VAR Cnt        : NUMERIC[0];
                                         VAR XDocIds    : L_XDoc.tXDocCollection);
  VAR
   trgOpKind: L_CUC.tOpKind;
 BEGIN
  L_General.Assert(trgQnt >= 0, " " + trgMath + ": ⥫ ⮪ " + L_MathR.DefaultFormatCir(trgMath, trgQnt));
  IF trgQnt > 0 THEN
   IF Cnt = 0 THEN
    L_XDoc.xdc_Put(XDocIds, MakeNewMDoc(trgMDocKind, RprS.OrdDate, trgStorage, 1));
    L_XDoc.rf_Insert(L_XDoc.xdt_MDoc, L_XDoc.curXDocId(L_XDoc.xdt_RprS), L_XDoc.rft_RefTo);
   ELSE
    trgSum:=0;
   END;
   L_MDoc.InsMDocList(trgMath, trgMMode, EMPTYOF(MDocList.VATMode), trgQnt, trgSum, 0);
 
   IF SELECT(_RprCUCopies, _RprCUCopies) THEN
    WHILE OCCURE(_RprCUCopies) DO
     L_General.CallUs(~!MDoc.Dest);
     SETEMPTY(trgOpKind);
     IF    trgMDocKind = L_MDoc.md_NOV THEN
      trgOpKind:=L_CUC.ok_Setting;
     ELSIF trgMDocKind = L_MDoc.md_TOV THEN
      IF _RprCUCopies.CUCopy = RprS.CUCopy THEN
       trgOpKind:=L_CUC.ok_toIR;
      ELSE
       trgOpKind:=L_CUC.ok_Retire;
      END;
     ELSIF trgMDocKind = L_MDoc.md_ViP THEN
      IF _RprCUCopies.CUCopy = RprS.CUCopy THEN
       trgOpKind:=L_CUC.ok_frIR;
      END;
     END;
     L_General.CallUs(~!trgOpKind);
     L_CUC.InsMDocLCU(_RprCUCopies.CUCopy, MDocList.MDLNbr, trgOpKind);
     NEXT(_RprCUCopies);
    END; (* WHILE OCCURE(_RprCUCopies) ... *)

    SETSEL(_RprCUCopies, _RprCUCopies);
    REMSEL(_RprCUCopies);
   END;
   INC(Cnt);
  END;
 END {intGenerateMDocByRprS};

 PRIVATE PROCEDURE GetTotalSumForVIP(trgStorage: LIKE(Storage.Storage)): L_XObj.tSum;
  VAR
   Result  : L_XObj.tSum;
   trgPrice: L_XObj.tSum;
 BEGIN
  SETZERO(Result);
  TRY [RESTORE_CURSORS(RC_ON)]
   SEARCH(Storage, Storage, , trgStorage);
   SELECT(MathMvmnt, Storage, , trgStorage);
   WHILE OCCURE(MathMvmnt) DO
    IF MathMvmnt.Crd_WO # 0 THEN
     trgPrice:=L_MathR.GetANYMathPrice(MathMvmnt.Date, MathMvmnt.Math, Storage.MyFirm, L_MathR.MMode2PriceGrp(MathMvmnt.Date, MathMvmnt.Math, MathMvmnt.MMode));
     INC(Result, MathMvmnt.Crd_WO * trgPrice);
    END;
    NEXT(MathMvmnt);
   END; (* WHILE OCCURE(MathMvmnt) ... *)
  EXCEPT
  END; (* TRY *)
  RETURN Result;
 END {GetTotalSumForVIP};

 PRIVATE PROCEDURE GenerateMDocByRprS(trgMDocKind: LIKE(MDocKind.MDocKind)): L_XDoc.tXDocCollection;
  VAR
   i, Cnt                  : NUMERIC[0];
   trgQnt,
   TotQnt,
   ToRepairQnt             : L_XObj.tQnt;
   TotSum                  : L_XObj.tSum;
   trgMath                 : LIKE(Math.Math);
   trgMMode                : LIKE(MMode.MMode);
   trgCUCopy               : LIKE(CUCopy.CUCopy);
   trgStorage              : LIKE(Storage.Storage);
   XDocIds                 : L_XDoc.tXDocCollection;
   maxMDocDate             : DATE;
   lastMDoc,
   RestoreFromRepairDocList: STRING[];
 BEGIN
  L_Rpr.PrepareMathMovementByRprS(RprS.RprS);
  L_AFM.MakeIndex("_RprCUCopies", "CUCopy: LIKE(CUCopy.CUCopy)");
  SETEMPTY(XDocIds);
  L_Rpr.AccessOrigin();

  maxMDocDate:=L_DatTim.MINDATE();
  IF trgMDocKind = L_MDoc.md_ViP THEN
   SELECT(MathMvmnt, Storage);
   WHILE OCCURE(MathMvmnt) DO
    Cnt:=0;
    NARROWSEL(MathMvmnt, Storage);
    trgStorage:=MathMvmnt.Storage;
    TotSum    :=GetTotalSumForVIP(trgStorage);
    WHILE OCCURE(MathMvmnt) DO
     SETZERO(TotQnt);
     NARROWSEL(MathMvmnt, Math);
     trgMath:=MathMvmnt.Math;

     SAVE(MathMvmnt);
     SELECT(MathMvmnt, Storage, , trgStorage, trgMath, L_MathR.mm_InBadRepair);
     WHILE OCCURE(MathMvmnt) DO
      IF L_Rpr.IsTransferToRepair(MathMvmnt.XDocId, MathMvmnt.MMode) THEN
       IF maxMDocDate <= MathMvmnt.Date THEN
        maxMDocDate:=MathMvmnt.Date;
        lastMDoc   :=L_XDoc.extXDocStr(MathMvmnt.XDocId, L_XDoc.xdast_wDate);
       END;
       INC(TotQnt, MathMvmnt.Crd_WO);
       IF ~!MathMvmnt.CUCopy THEN
        ADD(_RprCUCopies, _RprCUCopies, , MathMvmnt.CUCopy);
       END;
      END;
      NEXT(MathMvmnt);
     END; (* WHILE OCCURE(MathMvmnt) ... *)

     ToRepairQnt:=TotQnt;
     IF TotQnt # 0 THEN
      SETEMPTY(RestoreFromRepairDocList);
      SELECT(MathMvmnt, Storage, , trgStorage, trgMath);
      WHILE OCCURE(MathMvmnt) DO
       IF L_Rpr.IsRestoreFromRepair(MathMvmnt.XDocId, MathMvmnt.MMode) THEN
        IF maxMDocDate <= MathMvmnt.Date THEN
         maxMDocDate:=MathMvmnt.Date;
         lastMDoc   :=L_XDoc.extXDocStr(MathMvmnt.XDocId, L_XDoc.xdast_wDate);
        END;
        DEC(TotQnt, MathMvmnt.Dbt);
        RestoreFromRepairDocList:=RestoreFromRepairDocList + L_XDoc.XDocStr(MathMvmnt.XDocId) + "  " +
                                                             L_DatTim.DateStr(MathMvmnt.Date) + ",  㬬 " +
                                                             Str.Align(L_Money.MoneyToStr(MathMvmnt.Date, "", MathMvmnt.DbtSum), 10, RIGHT) + "|";
        IF ~!MathMvmnt.CUCopy THEN
         L_General.Assert(SEARCH(_RprCUCopies, _RprCUCopies, MathMvmnt.CUCopy),
                          " ६ ⠭  " + MathMvmnt.CUCopy + ",   ६  ।");
         REMOVE(_RprCUCopies);
        END;
       END;
       NEXT(MathMvmnt);
      END; (* WHILE OCCURE(MathMvmnt) ... *)
     END;
     RESTORE(MathMvmnt);
     IF (ToRepairQnt # 0) & (TotQnt # 0) & ~!RestoreFromRepairDocList THEN
      L_StdFrm.Choice("  㦥  ଫ     ᪫:||" +
                      RestoreFromRepairDocList + "|" +
                      "室    㬬 " + L_Money.MoneyToStr(RprS.OrdDate, "", TotSum) + " (  )|" +
                      "㦥, , ⥭  ⮨ 饭 ");
     END;
     intGenerateMDocByRprS(trgMDocKind, trgStorage, trgMath, L_MathR.mm_Restored, TotQnt, TotSum, Cnt, XDocIds);

     NEXTINEXTENDEDSEL(MathMvmnt, Math);
    END; (* WHILE OCCURE(MathMvmnt) ... *)
    NEXTINEXTENDEDSEL(MathMvmnt, Storage);
   END; (* WHILE OCCURE(MathMvmnt) ... *)
  ELSE
   SELECT(MathMvmnt, Storage);
   WHILE OCCURE(MathMvmnt) DO
    Cnt:=0;
    NARROWSEL(MathMvmnt, Storage);
    trgStorage:=MathMvmnt.Storage;
    WHILE OCCURE(MathMvmnt) DO
     SETZERO(TotQnt);
     NARROWSEL(MathMvmnt, Math, MMode);
     trgMath  :=MathMvmnt.Math;
     trgMMode :=MathMvmnt.MMode;
     WHILE OCCURE(MathMvmnt) DO
      SETZERO(trgQnt);
      NARROWSEL(MathMvmnt, CUCopy);
      trgCUCopy:=MathMvmnt.CUCopy;
      WHILE OCCURE(MathMvmnt) DO
       IF maxMDocDate <= MathMvmnt.Date THEN
        maxMDocDate:=MathMvmnt.Date;
        lastMDoc   :=L_XDoc.extXDocStr(MathMvmnt.XDocId, L_XDoc.xdast_wDate);
       END;
       INC(trgQnt, MathMvmnt.Dbt-MathMvmnt.Crd-MathMvmnt.Crd_WO);
       NEXT(MathMvmnt);
      END; (* WHILE OCCURE(MathMvmnt) ... *)
      IF (trgQnt > 0) & ~!trgCUCopy THEN
       ADD(_RprCUCopies, _RprCUCopies, , trgCUCopy);
      END;
      INC(TotQnt, trgQnt);
      NEXTINEXTENDEDSEL(MathMvmnt, CUCopy);
     END; (* WHILE OCCURE(MathMvmnt) ... *)

     intGenerateMDocByRprS(trgMDocKind, trgStorage, trgMath, trgMMode, TotQnt, 0, Cnt, XDocIds);

     NEXTINEXTENDEDSEL(MathMvmnt, Math, MMode);
    END; (* WHILE OCCURE(MathMvmnt) ... *)

    NEXTINEXTENDEDSEL(MathMvmnt, Storage);
   END; (* WHILE OCCURE(MathMvmnt) ... *)
  END;

  IF ~!XDocIds THEN
   L_General.Assert(maxMDocDate <= Memo.ud_cd(), "⠭ ४⭠ ⥪  " + L_DatTim.DateStr(Memo.ud_cd()) + ":||" +
                    L_MDoc.MDocKindNick(trgMDocKind, 1) + "   ନ஢  ࠭|" +
                    "᫥ ଫ   " + lastMDoc);
  END;

  i:=0;
  WHILE ~!L_XDoc.xdc_Item(XDocIds, i) DO
   L_XDoc.PositionOnXDoc(L_XDoc.xdc_Item(XDocIds, i));
   CALL(MDoc.CheckMDocList());
   INC(i);
  END;
  FinishGenerateMDoc(XDocIds, trgMDocKind);
  RETURN XDocIds;
 END {GenerateMDocByRprS};

 PRIVATE PROCEDURE GatherSingleCWOrder(trgMDocKind: LIKE(MDocKind.MDocKind));
  VAR
   Dummy      : STRING[];
   IPMath     : LIKE(Math.Math);
   trgIPSum,
   trgTotSum,
   trgMDPaySum: NUMERIC[2];
   curXDocId  : L_XDoc.tXDocId;
 BEGIN
  PROMPT("ନ஢ " + L_MDoc.MDocKindNick(trgMDocKind, 1));
  IF CWOrder.Status # L_MDoc.st_Canceled THEN
   IF    trgMDocKind = L_MDoc.md_IsS THEN
    GatherByMDoc(L_XDoc.xdt_CWOrder, PROCREF(L_Pmnt.E_IsMayBePaidMDoc), EMPTYOF(DATE));
   ELSIF trgMDocKind = L_MDoc.md_ISA THEN
    L_General.Assert(CWOrder.Status = L_MDoc.st_Passed,
                     L_CWOrder.CWOrderStr() + "    ﭨ '஢'");
    L_Pmnt.CheckXDocIsInMDoc(L_XDoc.xdt_CWOrder, PROCREF(L_Pmnt.E_IsAcptMDoc));
    GatherByMDoc(L_XDoc.xdt_CWOrder, PROCREF(L_Pmnt.E_IsMayBePaidMDoc), EMPTYOF(DATE));
   END;
   curXDocId:=L_XDoc.curXDocId(L_XDoc.xdt_CWOrder);

   IF CWOrder.Status = L_MDoc.st_Passed THEN
    trgTotSum:=CWOrder.Sum + CWOrder.VAT;
    trgIPSum :=CWOrder.IPSum;
   ELSE
    trgTotSum:=CWOrder.p_Sum + CWOrder.p_VAT;
    trgIPSum :=CWOrder.p_IPSum;
   END;

   IF SELECT(TmMDL, XDocId, curXDocId) THEN
    SETZERO(trgMDPaySum);
    WHILE OCCURE(TmMDL) DO
     INC(trgMDPaySum, TmMDL.MDPay);
     NEXT(TmMDL);
    END; (* WHILE OCCURE(TmMDL) ... *)

    IF    trgMDPaySum = (trgTotSum + trgIPSum) THEN
     L_General.Error(L_CWOrder.CWOrderStr() + ": 㦥 祭");
    ELSIF trgMDPaySum < (trgTotSum + trgIPSum) THEN
     L_General.Error(L_CWOrder.CWOrderStr() + ": 筠 ॠ ⨬");
    ELSE
     L_General.Error(L_CWOrder.CWOrderStr() + ": 祭  ⮨ 鸞?");
    END;
   END;

   ADD(TmMDL, XDocId, , curXDocId, CWOrder.Math,
       TmMDL.ToPay, trgTotSum);
   IF L_CWOrder.GetCWOrder_IP_CalculateKind(CWOrder.Contract, CWOrder.Date) # P_Cntr.ipck_Free THEN
    IPMath:=L_CWOrder.E_GetIP_Math(CWOrder.Date);
    Dummy:=P_Math.GetMathProStrong(IPMath, CWOrder.Date, P_Math.P_SpecialAttitudeToVAT);
    ADD(TmMDL, XDocId, , curXDocId, IPMath,
        TmMDL.ToPay, trgIPSum);
   END;
  END;
 END {GatherSingleCWOrder};

 PRIVATE PROCEDURE GatherAllCWOrder(trgMDocKind: LIKE(MDocKind.MDocKind));
 BEGIN
  SELECT(CWOrder, Contract, , Contract.Contract);
  WHILE OCCURE(CWOrder) DO
   IF L_DatTim.IsActive_Inc(CWOrder.Date, Memo.ud_mb(), Memo.ud_me()) THEN
    TRY
     GatherSingleCWOrder(trgMDocKind);
     MakeScsLine(L_XDoc.curXDocId(L_XDoc.xdt_CWOrder));
    EXCEPT
    ON Exc: Exc_Root DO
     MakeErrLine(L_XDoc.curXDocId(L_XDoc.xdt_CWOrder), Exc.Description);
    END; (* TRY *)
   END;
   NEXT(CWOrder);
  END; (* WHILE OCCURE(CWOrder) ... *)
 END {GatherAllCWOrder};

 PRIVATE PROCEDURE GatherByCurrentCarAD(trgMDocKind: LIKE(MDocKind.MDocKind));
  VAR
   curXDocId       : L_XDoc.tXDocId;
   trgTotSum       : L_XObj.tSum;
   LastMDocInPeriod: SCAL[2];
 BEGIN
  PROMPT("ନ஢ " + L_MDoc.MDocKindNick(trgMDocKind, 1));
  IF CarAD.Status # L_MDoc.st_Canceled THEN
   IF    trgMDocKind = L_MDoc.md_IsS THEN
    L_Pmnt.CheckXDocIsInMDoc(L_XDoc.xdt_CarAD, PROCREF(L_Pmnt.E_IsMayBePaidMDoc));
   ELSIF trgMDocKind = L_MDoc.md_IAS THEN
    GatherByMDoc(L_XDoc.xdt_CarAD, PROCREF(L_Pmnt.E_IsAcptMDoc), Memo.ud_mb());
   END;
   curXDocId:=L_XDoc.curXDocId(L_XDoc.xdt_CarAD);
   CONFORM(CarAD, CarADL);
   WHILE OCCURE(CarADL) DO
    IF (trgMDocKind = L_MDoc.md_IsS) | L_DatTim.IsActiveInIntvl_Inc(CarADL.BegDate, CarADL.EndDate, Memo.ud_mb(), Memo.ud_me()) THEN
     LastMDocInPeriod:=L_CarAD.IsLastMDocInPeriod(Memo.ud_cd());
     IF trgMDocKind = L_MDoc.md_IsS THEN
      trgTotSum:=(CarADL.Cost[L_CarAD.psidx_Netto] + CarADL.Cost[L_CarAD.psidx_VAT]) * CarADL.Period;
     ELSE
      trgTotSum:=L_CarAD.CalcCarADLPartSum(CarADL.Cost[L_CarAD.psidx_Netto] + CarADL.Cost[L_CarAD.psidx_VAT], Memo.ud_cd(), LastMDocInPeriod);
     END;
     ADD(TmMDL, XDocId, , curXDocId, CarADL.Math,
         TmMDL.ToPay, trgTotSum);
     IF (trgMDocKind = L_MDoc.md_IsS) | (L_DatTim.MONTH(Memo.ud_cd()) = L_DatTim.MONTH(CarADL.BegDate)) THEN
      ADD(TmMDL, XDocId, , curXDocId, L_CarAD.E_GetMountMath(CarAD.Date),
          TmMDL.ToPay, CarADL.Mount[L_CarAD.psidx_Netto] + CarADL.Mount[L_CarAD.psidx_VAT]);
     END;
     IF (trgMDocKind = L_MDoc.md_IsS) | LastMDocInPeriod THEN
      ADD(TmMDL, XDocId, , curXDocId, L_CarAD.E_GetDismountMath(CarAD.Date),
          TmMDL.ToPay, CarADL.Dismount[L_CarAD.psidx_Netto] + CarADL.Dismount[L_CarAD.psidx_VAT]);
     END;
    END;
    NEXT(CarADL);
   END; (* WHILE OCCURE(CarADL) ... *)
  END;
 END {GatherByCurrentCarAD};

 PRIVATE PROCEDURE GetAddMDocKind(XDT: L_XDoc.tXDocType): LIKE(MDocKind.MDocKind);
  VAR
   Proc: PROC;
 BEGIN
  IF    XDT = L_XDoc.xdt_CWOrder THEN
   Proc:=PROCREF(L_CWOrder.IsAcceptableAddMDocKind);
  ELSIF XDT = L_XDoc.xdt_CarAD THEN
   Proc:=PROCREF(L_CarAD.IsAcceptableAddMDocKind);
  ELSIF XDT = L_XDoc.xdt_RprS THEN
   Proc:=PROCREF(L_Rpr.IsAcceptableAddMDocKind);
  ELSE
   L_General.Error("ନ஢   㬥⠬  '" + L_XDoc.Ref_FullName(XDT) + "'  ন");
  END;
  RETURN L_Pmnt.GetAddMDocKind(Proc, "ନ஢ 㬥⮢");
 END {GetAddMDocKind};

 PRIVATE PROCEDURE Create_TmpFiles();
 BEGIN
  CreateFILE(TmMDL, "", " 㬬  ", "");

  CreateFIELD(TmMDL, XDocId,   L_XDoc.tXDocId,  "", "",  "", "⥫᪨ XDocId", "");
  CreateFIELD(TmMDL, Math,     LIKE(Math.Math), "", "",  "", "", "");
  CreateFIELD(TmMDL, ToPay,    L_XObj.tSum,        "", "0", "", " ", "");
  CreateFIELD(TmMDL, MDPay,    L_XObj.tSum,        "", "0", "", "祭", "");

  CreateINDEX(TmMDL, XDocId, UNIQUE, "", "", XDocId, Math);
  CreateINDEX(TmMDL, Math,   PLURAL, "", "", Math);
  SetVersionOfFILE(TmMDL, 0);
  L_AFM.CreateTemp("TmMDL");
 END {Create_TmpFiles};

 PRIVATE PROCEDURE GatherByCurrentCWOrder(trgMDocKind: LIKE(MDocKind.MDocKind));
  CONST
   maxAm = 512;
  VAR
   curCWOrder: LIKE(CWOrder.CWOrder);
   curDate   : DATE;
   Ids       : L_XDoc.tXDocId[maxAm];
   toDo      : SCAL[2]       [maxAm];
   List      : STRING[];
   i, j      : NUMERIC[0];
 BEGIN
  L_CWOrder.AccessCWOrder();
  CONFORM(CWOrder, Contract);
  GatherSingleCWOrder(trgMDocKind);
  IF L_StdFrm.Alternative("  " + L_MDoc.MDocKindNick(trgMDocKind, 1) + " 㣨   ?") THEN
   curCWOrder:=CWOrder.CWOrder;
   curDate   :=CWOrder.Date;
   SETEMPTY(Ids);
   i         :=0;
   SAVE(CWOrder);
   SETSEL(CWOrder, Contract, Contract.Contract);
   SRCINSEL(CWOrder, GE, , L_DatTim.Per(curDate));
   WHILE OCCURE(CWOrder) & (CWOrder.Date <= L_DatTim.MonthEnd(curDate)) DO
    TRY
     IF CWOrder.CWOrder # curCWOrder THEN
      GatherSingleCWOrder(trgMDocKind);
      toDo[i]:=0;
     ELSE
      toDo[i]:=1;
      j      :=i;
     END;
     Ids[i]:=L_XDoc.curXDocId(L_XDoc.xdt_CWOrder);
     INC(i);
     L_General.RaiseLockReleaseException();
    EXCEPT
    ON Exc: Exc_Raise DO
     (*   -   *)
    END; (* TRY *)
    NEXT(CWOrder);
   END; (* WHILE OCCURE(CWOrder) ... *)
   RESTORE(CWOrder);
   L_AFM.AF_PurgeTemp("TmMDL");
   L_AFM.ReattachTemp("TmMDL", "TmMDL");
   LOOP
    List:="";
    i:=0;
    WHILE ~!Ids[i] DO
     L_XDoc.PositionOnXDoc(Ids[i]);
     List:=List + L_Str.PoolItem("-||*", toDo[i]) +
              " " + CWOrder.CWOrder +
              " " + L_DatTim.DateStr(CWOrder.Date) +
              " " + Str.Align(CWOrder.RouteDsc, 48, LEFT) +
              "|";
     INC(i);
    END;
    TRY
     j:=L_StdFrm.ShowListAsMenu_wInit(List, " ନ஢    ", j);
     toDo[j]:=~toDo[j];
    EXCEPT
    ON Exc: Exc_Raise DO
     i:=0;
     WHILE ~!Ids[i] DO
      IF toDo[i] THEN
       L_XDoc.PositionOnXDoc(Ids[i]);
       GatherSingleCWOrder(trgMDocKind);
      END;
      INC(i);
     END;
     EXIT;
    END;
   END; (* LOOP *)
  END;
 END {GatherByCurrentCWOrder};

 PRIVATE PROCEDURE HasCWOrderByContract(): SCAL[2];
 BEGIN
  RETURN SELECT(CWOrder, Contract, Contract.Contract);
 END {HasCWOrderByContract};

 PRIVATE PROCEDURE PrintGeneratedDocs(XDocIds: L_XDoc.tXDocCollection);
  VAR
   i        : NUMERIC[0];
   curXDocId: L_XDoc.tXDocId;
 BEGIN
  i:=0;
  LOOP
   curXDocId:=L_XDoc.xdc_Item(XDocIds, i);
   IF !curXDocId THEN
    EXIT;
   END;
   L_General.CallUs(L_XDoc.ExtractXDocType(curXDocId) = L_XDoc.xdt_MDoc);
   L_XDoc.PositionOnXDoc(curXDocId);
   IF L_MDoc.PrintMDocImmediately() THEN
    TRY
     Memo.gl_SetCurDate(MDoc.Date);
     CALL(MDoc.StreamRePrint());
     CALL(MDoc.StreamPrint());
    EXCEPT
    ON Exc:Exc_Root DO
     L_StdFrm.RedInform(Exc.MsgOriginalText);
    END;
   END;
   INC(i);
  END;
 END {PrintGeneratedDocs};

 PRIVATE PROCEDURE BuildAddDoc(Stream: SCAL[2]);
  CONST
   RepName = "PrtBA";
  VAR
   XDT        : L_XDoc.tXDocType;
   Dummy      : STRING[];
   XDocIds    : L_XDoc.tXDocCollection;
   trgMDocKind: LIKE(MDocKind.MDocKind);
 BEGIN
  Create_TmpFiles();
  IF ~Stream THEN
   XDT        :=L_XDoc.GetFileXDT(GE_CURFILE());
   trgMDocKind:=GetAddMDocKind(XDT);

   IF    XDT = L_XDoc.xdt_CWOrder THEN
    GatherByCurrentCWOrder(trgMDocKind);
    L_Pmnt.ConfirmGeneratedDocs(0, GenerateMDocBySpecificDeal(trgMDocKind, CWOrder.Date));
   ELSIF XDT = L_XDoc.xdt_CarAD THEN
    L_CarAD.AccessCarAD();
    L_General.Assert(CarAD.BegDate <= Memo.ud_me(), " ᤥ   砫");
    CONFORM(CarAD, Contract);
    GatherByCurrentCarAD(trgMDocKind);
    L_Pmnt.ConfirmGeneratedDocs(0, GenerateMDocBySpecificDeal(trgMDocKind, CarAD.Date));
   ELSIF XDT = L_XDoc.xdt_RprS THEN
    TRY [TRANSACTION(TRANSACTION_SLAVE2)]
     L_Rpr.AccessRprS();
     L_Rpr.CheckAcceptableRprSStatusForBuildMDoc(RprS.Status);
     IF IsFinalMDocKindForBuildMDoc(trgMDocKind) THEN
      IF (RprS.Status # L_Rpr.ms_Ready) & ~RprS.Done THEN
       L_General.Error(" " + RprS.RprS  +  "   ࠡ⠭ |" +
                       "室  ﭨ '" + L_Rpr.GetRprSStatus_AsStr(L_Rpr.ms_Ready) + "'");
      END;
      XDocIds:=GenerateFinalMDocByRprS(trgMDocKind, 0);
     ELSE
      L_AR.GrantRightsUnconditionally();
      XDocIds:=GenerateMDocByRprS(trgMDocKind);
     END;
     L_Pmnt.ConfirmGeneratedDocs(0, XDocIds);
    EXCEPT
    END; (* TRY *)
    PrintGeneratedDocs(XDocIds);
   END;
  ELSE
   L_General.Assert(ACCESS(Contract), " ࠭ ");
   IF HasCWOrderByContract() THEN
    trgMDocKind:=GetAddMDocKind(L_XDoc.xdt_CWOrder);
    OpenLog(RepName,
            "ନ஢ " + L_MDoc.MDocKindNick(trgMDocKind, 1) +
            L_Str.CRLF +
            "  " + Contract.Contract + "  " + L_DatTim.PeriodStr(Memo.ud_cd()),
            L_AcsPnt.aprm_Inform);
    GatherAllCWOrder(trgMDocKind);
    Dummy:=GenerateMDocBySpecificDeal(trgMDocKind, Memo.ud_mb());
    CloseLog();
   ELSE
    L_General.Error("⮪ ନ஢   ।ᬮ७");
   END;
  END;
 END {BuildAddDoc};

 PUBLIC PROCEDURE MakeBill_Contract();
  VAR
   Dummy: STRING[];
 BEGIN
  L_General.Assert(ACCESS(Contract), " ⠭ ⥪騩 ");
  CONFORM(Contract, CntrT);
  E_SurroundMakeBill(1, 0);
  IF    HasCWOrderByContract() THEN
   BuildAddDoc(1);
  ELSIF ~E_MakeBill(0, Dummy) THEN
   L_General.Error("⮬᪮ ନ஢   ।ᬮ७| "+Contract.Contract);
  END; (* IF HasCWOrderByContract() ... *)
  E_SurroundMakeBill(0, 0);
 END {MakeBill_Contract};

 PUBLIC PROCEDURE RemoveBill_Contract();
 BEGIN
  cabd_DoAll(o_cdMDC, s_Contract);
 END {RemoveBill_Contract};

 PRIVATE PROCEDURE ContractAsStrForLogFile(): STRING[];
 BEGIN
  RETURN " "+Contract.Contract+" " + Contract.CntrT + " " + Contract.Firm;
 END {ContractAsStrForLogFile};

 PUBLIC PROCEDURE MakeBills();
  CONST
   woBillRaiseDescription = " 㦥 . 10.09.2002 09:15:59 SAN";
  VAR
   addMsg: STRING[];
 BEGIN
  P_Firm.curMyFirm:=P_Firm.ChoiceMyFirm();
  targetDate:=Memo.ud_cd();
  L_General.Assert(L_DatTim.DAY(targetDate)=1,
                   " 믮 ⮩ 樨"+
                   "|⥪     ᫮ ");
  OpenLog(L_General.NameMonth("MBL"),
          "ନ஢ ⮢  "+L_DatTim.DateStr(targetDate)+"  ࠬ  ਮ᪮ ⮩",
          L_AcsPnt.aprm_Inform);
  E_SurroundMakeBill(1, 1);

  SETSEL(Contract, Leaf, 1);
  FOR_EACH Contract DO
   PROMPT(" "+Contract.Contract);
   IF Contract.MyFirm = P_Firm.curMyFirm THEN
    IF L_DatTim.IsActive(targetDate, Contract.Begin, Contract.Till) THEN
     TRY
      CONFORM(Contract, CntrT);
      IF E_MakeBill(1, addMsg) THEN
       MakeScsLinewMsg(MDoc.XDocId,
                       ContractAsStrForLogFile() +".  㬬 "+L_Money.MoneyToStr(targetDate, ",", MDoc.Total)+
                       addMsg);
      ELSE
       RAISE(1, woBillRaiseDescription);
      END;
     EXCEPT
     ON Exc: Exc_Raise DO
      IF Exc.MsgOriginalText # woBillRaiseDescription THEN
       MakeErrLine("", ContractAsStrForLogFile() + ". " + Exc.Description);
      END;
     END;
    END; (* IF Contract.Till > ... *)
   END;
  END; (* FOR_EACH Contract *)
  E_SurroundMakeBill(0, 1);
  intCloseLog(EMPTYOF(Exc_Root), 1);
 END {MakeBills};

 PUBLIC PROCEDURE RemoveBills_All();
 BEGIN
  cabd_DoAll(o_cdMDC, s_All);
 END {RemoveBills_All};

 PUBLIC PROCEDURE MakePDocwMDoc_ByCurrentMDoc();
  VAR
   byMDocXDocs,
   byFirmXDocs: L_XDoc.tXDocCollection;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode  :=adm_SOFT;
  TABLE.Get("XCalc"  ).AccessDataMode:=adm_RIDGE;
  TABLE.Get("XApport").AccessDataMode:=adm_RIDGE;
  TABLE.Get("XODone" ).AccessDataMode:=adm_RIDGE;
  TABLE.Get("XDocApr").AccessDataMode:=adm_RIDGE;
  L_MDoc.AccessMDoc();
  byMDocXDocs:=L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
  CONFORM(MDoc, Contract);
  IF L_Cntr.IsBudgetContract(Contract.Contract, MDoc.Date) THEN
   byFirmXDocs:=L_Pmnt.GetContractIncompletelyPaidMDocs(Contract.Contract, L_Pmnt.ipic_AutoPay);
  ELSE
   byFirmXDocs:=L_Pmnt.GetFirmIncompletelyPaidMDocs(Contract.Firm, Contract.MyFirm, L_Pmnt.ipic_AutoPay);
  END;

  IF ~!L_Pmnt.MakePDocwMDoc(byFirmXDocs, byMDocXDocs) THEN
   L_Pmnt.ConfirmGeneratedDocs(0, L_XDoc.XDocId(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc));
   CALL(PDocP.Print_Stream());
   L_General.SurveyLastReport();
  ELSE
   L_StdFrm.BlueStop("⥦ 㬥  ନ஢");
  END;
 END {MakePDocwMDoc_ByCurrentMDoc};

 PRIVATE PROCEDURE RunLocalProc(Local: PROC;
                                Msg  : STRING[]);
 BEGIN
  L_General.Assert(~!Local, " ঠ 楤 ⠢ " + Msg);
  Local();
 END {RunLocalProc};

 PRIVATE PROCEDURE E_ShowSalePrice();
 BEGIN
  IF (L_General.GetAPSiteID() = "53") THEN
   LIKEMENU(ShowWin, "IsSData 1 " + RTI.Get().CurWindow.OriginalName + " " + L_Str.IntStr(RTI.Get().CurZone.Number) + " IsSDataMode=0");
  ELSE
   ACCESS(MDoc);
   IF SELECT(MDocPro, MDoc, MDoc.MDocKind, MDoc.MDoc, 9524) THEN
    RunLocalProc(PROCREF(E_Bills.ShowSalePrice), "");
   ELSE
    LIKEMENU(ShowWin, "IsSData 1 " + RTI.Get().CurWindow.OriginalName + " " + L_Str.IntStr(RTI.Get().CurZone.Number) + " IsSDataMode=0");
   END;
  END;
 END {E_ShowSalePrice};

 PRIVATE PROCEDURE E_MakeSpecification();
 BEGIN
  RunLocalProc(PROCREF(E_Bills.MakeSpecification), "ᯥ䨪樨");
 END {E_MakeSpecification};

 CONST
  oi_Amount   = 5;

  oi_From     = 0;
  oi_To       = 1;
  oi_Subject  = 2;
  oi_Cc       = 3;
  oi_Body     = 4;

  dr_Amount            = 6;

  dr_TypeTechInfluence   = 0;
  dr_EqupmentState       = 1;
  dr_MechanicalDamage    = 2;
  dr_Integration         = 3;
  dr_DeclaredMalfunction = 4;
  dr_DoneJob             = 5;

  dr_ttf_WarrantyRepair       = 0;
  dr_ttf_PaymentRepair        = 1;
  dr_ttf_Diagnostics          = 2;
  dr_ttf_HardwareModification = 3;
  dr_ttf_SoftwareModification = 4;
  dr_ttf_AnotherThing         = 5;

 PRIVATE PERMANENT VAR
  v_dr_TypeTechInfluence    : SCAL[6];
  v_dr_Integration_Add,
  v_dr_DeclaredMalfunction,
  v_dr_MechanicalDamage_Add,
  v_dr_TypeTechInfluence_Add: STRING[];
  v_dr_DoneJob              : STRING[];
  v_dr_Integration,
  v_dr_EqupmentState,
  v_dr_MechanicalDamage     : SCAL[2];

 PRIVATE PROCEDURE InitOrderTemplate(VAR OrderTemplate: STRING[][]);
 BEGIN
  OrderTemplate[oi_From]   :="From: ";
  OrderTemplate[oi_To]     :="To: ";
  OrderTemplate[oi_Subject]:="Subject: ";
  OrderTemplate[oi_Cc]     :="Cc: ";
  OrderTemplate[oi_Body]   :="Body: ";
 END {InitOrderTemplate};

 PRIVATE PROCEDURE InitDRTemplate(): STRING[][dr_Amount];
  VAR
   _DRTemplate: STRING[][dr_Amount];
 BEGIN
  _DRTemplate[dr_TypeTechInfluence]  :="TypeTechInfluence: ";
  _DRTemplate[dr_EqupmentState]      :="EqupmentState: ";
  _DRTemplate[dr_MechanicalDamage]   :="MechanicalDamage: ";
  _DRTemplate[dr_Integration]        :="Integration: ";
  _DRTemplate[dr_DeclaredMalfunction]:="DeclaredMalfunction: ";
  _DRTemplate[dr_DoneJob]            :="DoneJob: ";
  RETURN _DRTemplate;
 END {InitDRTemplate};

 PRIVATE PROCEDURE GetValue(Template: STRING[]): STRING[];
  VAR
   tmpVal: STRING[];
 BEGIN
  SETEMPTY(tmpVal);
  SAVE(MDocPro);
  WHILE OCCURE(MDocPro) DO
   IF Str.Match(MDocPro.Value, Template + "*") THEN
    tmpVal:=tmpVal + Str.Slice(MDocPro.Value, Str.Length(Template), Str.Length(MDocPro.Value));
   END;
   NEXT(MDocPro);
  END; (* WHILE OCCURE(MDocPro)...*)
  RESTORE(MDocPro);
  RETURN tmpVal;
 END {GetValue};

 PRIVATE PROCEDURE FillVariables(VAR SrcVal: VARIANT;
                                 VAR AddStr: STRING[];
                                 Value     : STRING[]);
 BEGIN
  SrcVal:=STRTOFLD(L_Str.AnyItem(Value, ";", 0), SCAL);
  AddStr:=Str.Delete(Value, 0, Str.Length(L_Str.AnyItem(Value, ";", 0))+1);
 END {FillVariables};

 PRIVATE PROCEDURE SetWinFieldFormat();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("v_dr_TypeTechInfluence").Format:="࠭⨩ ६| ६|⨪| 䨣樨| |㣮";
  Fields("v_dr_MechanicalDamage").Format :="-|";
  Fields("v_dr_Integration").Format      :="-|";
  Fields("v_dr_EqupmentState").Format    :="ࠢ|ࠢ";
 END {SetWinFieldFormat};

 PRIVATE PROCEDURE SetWinFieldFlagEdit();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  IF v_dr_TypeTechInfluence # dr_ttf_AnotherThing THEN
   v_dr_TypeTechInfluence_Add:="";
  END;
  IF v_dr_Integration = 0 THEN
   v_dr_Integration_Add:="";
  END;
  IF v_dr_MechanicalDamage = 0 THEN
   v_dr_MechanicalDamage_Add:="";
  END;
  Fields:=RTI.Get().CurZone.Fields;
  Fields("v_dr_TypeTechInfluence_Add").Modifiable:=v_dr_TypeTechInfluence = dr_ttf_AnotherThing;
  Fields("v_dr_MechanicalDamage_Add").Modifiable :=v_dr_MechanicalDamage = 1;
  Fields("v_dr_Integration_Add").Modifiable      :=v_dr_Integration = 1;
 END {SetWinFieldFlagEdit};

 PRIVATE PROCEDURE SetOrderInForm(VAR OrderAttr: STRING[][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(OrderAttr) DO
   RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("OrderAttr", i)).Value:=OrderAttr[i];
   INC(i);
  END;
 END {SetOrderInForm};

 PRIVATE PROCEDURE MDoc_OnBeforeEdit();
  CONST
   DefWidth = 100;
   DefDepth = 40;
  VAR
   i, j,
   Width,
   Depth        : NUMERIC[0];
   Dummy, tmpVal: STRING[];
   Value        : STRING[][100];
   OrderAttr,
   OrderTemplate: STRING[][oi_Amount];
   DRTemplate   : STRING[][dr_Amount];
 BEGIN
  L_MDoc.AccessMDoc();
  IF RTI.Get().CurWindow.OriginalName = "P_6019" THEN
   L_General.Assert(MDoc.MDocKind = L_MDoc.md_ZNr, "  㯭 ⮫쪮   |" +
                                                   L_Str.IntStr(L_MDoc.md_ZNr) + " " + L_MDoc.GetMDocNameS(L_MDoc.md_ZNr));
  END;
  IF    MDoc.MDocKind = L_MDoc.md_VhS THEN
   IF L_XDoc.XDocIsSent(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
    L_StdFrm.Choice("㬥 ࠢ. த?");
   END;
   InitOrderTemplate(OrderTemplate);
   P_MDoc.GetMDocProArray(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Order, Value);
   SETEMPTY(OrderAttr);
   i:=0;
   WHILE i <= HIGH(OrderTemplate) DO
    j:=0;
    LOOP
     IF Str.Match(Value[j], OrderTemplate[i] + "*") THEN
      OrderAttr[i]:=Str.Delete(Value[j], 0, Str.Length(OrderTemplate[i]));
      LOOP
       INC(j);
       IF !Value[j] | ((i < HIGH(OrderTemplate)) & Str.Match(Value[j], OrderTemplate[i+1] + "*")) THEN
        EXIT;
       END;
       OrderAttr[i]:=OrderAttr[i] + Value[j];
      END; (* LOOP *)
     ELSE
      INC(j);
     END;
     IF !Value[j] THEN
      EXIT;
     END;
    END; (* LOOP *)
    INC(i);
   END; (* WHILE i <= HIGH(OrderTemplate)...*)
   SetOrderInForm(OrderAttr);
  ELSIF MDoc.MDocKind = L_MDoc.md_ZNr THEN
   GE_APPWIN_SIZE(Width, Depth);
   IF (Width < DefWidth) | (Depth < DefDepth) THEN
    L_StdFrm.Choice("    ।ᬠਢ|"+
                    "⠭ ࠧ襭   " + L_Str.IntStr(DefWidth) + " X " +
                    L_Str.IntStr(DefDepth) + ".| |" +
                    " ४⭠ ᮢ ");
   END;
   SETZERO(v_dr_TypeTechInfluence, v_dr_EqupmentState, v_dr_MechanicalDamage,
           v_dr_Integration);
   SETEMPTY(v_dr_TypeTechInfluence_Add, v_dr_MechanicalDamage_Add,
            v_dr_Integration_Add, v_dr_DeclaredMalfunction,
            v_dr_DoneJob);
   SetWinFieldFormat();
   IF P_MDoc.HasMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_DoneJob) THEN
    DRTemplate:=InitDRTemplate();
    i:=0;
    WHILE i < dr_Amount DO
     tmpVal:=GetValue(DRTemplate[i]);
     IF ~!tmpVal THEN
      IF    i = dr_TypeTechInfluence THEN
       FillVariables(v_dr_TypeTechInfluence, v_dr_TypeTechInfluence_Add, tmpVal);
      ELSIF i = dr_EqupmentState THEN
       FillVariables(v_dr_EqupmentState,     Dummy,                      tmpVal);
      ELSIF i = dr_MechanicalDamage THEN
       FillVariables(v_dr_MechanicalDamage,  v_dr_MechanicalDamage_Add,  tmpVal);
      ELSIF i = dr_Integration THEN
       FillVariables(v_dr_Integration,       v_dr_Integration_Add,       tmpVal);
      ELSIF i = dr_DeclaredMalfunction THEN
       v_dr_DeclaredMalfunction:=tmpVal;
      ELSIF i = dr_DoneJob THEN
       v_dr_DoneJob:=tmpVal;
      ELSE
       L_General.CallUs(0);
      END;
     END;
     INC(i);
    END; (* WHILE i < dr_Amount...*)
   END; (* IF P_MDoc.HasMDocPro(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Order)...*)
   SetWinFieldFlagEdit();
  END;
 END {MDoc_OnBeforeEdit};

 PRIVATE PROCEDURE MDoc__OnSuccessfulChange();
 BEGIN
  SetWinFieldFlagEdit();
 END {MDoc__OnSuccessfulChange};

 PRIVATE PROCEDURE GetProviderMath(_Firm: LIKE(Firm.Firm);
                                   _Math: LIKE(Math.Math);
                                   _Date: DATE;
                                   VAR
                                   Price: STRING[]): STRING[];
  VAR
   _Provider    : L_Prop.tArrayElement;
   _Price       : P_Math.tPI_Price;
   _PMath       : P_Math.tPI_ProvidersMath;
   _MainProvider: P_Math.tPI_MainProvider;
   i            : NUMERIC[0];
 BEGIN
  Price:="";
  P_Math.GetP_PurchaseInf(_Math, _Date, _Provider, _Price, _PMath, _MainProvider);
  i:=0;
  WHILE i <= HIGH(_Provider) DO
   IF STRTOFLD(_Provider[i], SCAL) = _Firm THEN
    Price:=FLDTOSTR(_Price[i], "2.");
    RETURN _PMath[i];
   END;
   INC(i);
  END; (* WHILE i <= HIGH(_Provider)...*)
  RETURN "";
 END {GetProviderMath};

 PRIVATE PROCEDURE GetOrderFromForm(VAR OrderAttr: STRING[][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  SETEMPTY(OrderAttr);
  i:=0;
  WHILE i <= HIGH(OrderAttr) DO
   OrderAttr[i]:=RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("OrderAttr", i)).Value;
   INC(i);
  END;
 END {GetOrderFromForm};

 PUBLIC PROCEDURE BuildOrder();
  CONST
   Dlm = " -- ";
  VAR
   i        : NUMERIC[0];
   Price,
   ExtPhone,
   IntPhone : STRING[];
   OrderAttr: STRING[][oi_Amount];
   _XDocId  : L_XDoc.tXDocId;
 BEGIN
  L_MDoc.AccessMDoc();
  GetOrderFromForm(OrderAttr);
  IF ~L_Prop.IsEmptyStrArray(OrderAttr) THEN
   L_StdFrm.Choice("ନ஢ ?");
  END;

  _XDocId:=L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
  IF ~SELECT(MDocList, MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   L_StdFrm.Question("⮩ 㬥?");
  END;
  OrderAttr[oi_From]   :=L_Pmnt.E_GetSenderEMail(_XDocId, MDoc.MyFirm);
  OrderAttr[oi_To]     :=L_EMail.AssembleContact(P_Firm.FP_FirmShortName(MDoc.Firm, MDoc.Date),
                                                   P_Firm.FP_email(MDoc.Firm, MDoc.Date));
  OrderAttr[oi_Subject]:=" "+MDoc.MDoc;
  OrderAttr[oi_Cc]     :=L_Pmnt.E_GetBlindCarbonCopyEMail(_XDocId, MDoc.MyFirm);
  CONFORM(MDoc, Contract);
  OrderAttr[oi_Body]   :="ࠢ!" + L_Str.CRLF +
                         ", ⠢ ";
  IF ~!Contract.SrcNbr THEN
   OrderAttr[oi_Body]  :=OrderAttr[oi_Body]+"   "+Contract.SrcNbr;
  END;
  OrderAttr[oi_Body]   :=OrderAttr[oi_Body]+":" + L_Str.CRLF + L_Str.CRLF;

  WHILE OCCURE(MDocList) DO
   PROMPT("ࠡ⪠ ப " + MDocList.MDLNbr);
   CONFORM(MDocList, Math);
   OrderAttr[oi_Body]  :=OrderAttr[oi_Body] +
                         "#" + L_Str.IntStr(MDocList.MDLNbr) +
                         " [" + Math.UnitedC + "] (" + GetProviderMath(MDoc.Firm, MDocList.Math, MDoc.Date, Price) + ") "+
                         FLDTOSTR(MDocList.Qnt, P_Math.GetMUnitFormat(MDocList.Math), 0) + " " + MUnit.Sign + " " + Price + L_Str.CRLF +
                         "    " + Dlm + Math.Name + L_Str.CRLF;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  SEARCH(Man, Man, , P_Man.curUSER2Man());
  ExtPhone:=P_Man.GetManWorkTelefon(Man.Man, MDoc.Date, P_Man.ci_ExtTelefon);
  IF !ExtPhone THEN
   ExtPhone:=P_Firm.FP_Phone(P_Firm.fomf(MDoc.MyFirm), MDoc.Date);
  END;
  IntPhone:=P_Man.GetManWorkTelefon(Man.Man, MDoc.Date, P_Man.ci_IntTelefon);
  IF ~!IntPhone THEN
   ExtPhone:=ExtPhone + " (*" + IntPhone + ")";
  END;
  OrderAttr[oi_Body]   :=             OrderAttr[oi_Body] +
                         L_Str.CRLF + " 㢠," +
                         L_Str.CRLF + Man.Name + ", " + P_Firm.MyFirmName(MDoc.MyFirm, MDoc.Date) +
                         L_Str.CRLF + ExtPhone;
  SetOrderInForm(OrderAttr);
  FIX_ALTERING();
 END {BuildOrder};

 PUBLIC PROCEDURE InsRemIntegration();
  CONST
   Integration_Pool = "譨  ⠭|㬥||᪮ ";
   Dlm = ";";
  VAR
   PosBeg, PosEnd: NUMERIC[0];
   _Integration  : STRING[];
 BEGIN
  _Integration:=L_Str.PoolItem(Integration_Pool, L_StdFrm.ShowListAsMenu(Integration_Pool, "⭮"));
  IF Str.Match(v_dr_Integration_Add, "*" + _Integration + "*") THEN
   PosBeg:=Str.Pos(v_dr_Integration_Add, _Integration);
   PosEnd:=Str.Pos(v_dr_Integration_Add, Dlm, PosBeg) + 1;
   v_dr_Integration_Add:=Str.Delete(v_dr_Integration_Add, PosBeg, Math.Max(Str.Length(_Integration), PosEnd - PosBeg));
  ELSE
   IF ~!v_dr_Integration_Add THEN
    IF Str.Slice(v_dr_Integration_Add, Str.Length(v_dr_Integration_Add)-1, 1) = Dlm THEN
     v_dr_Integration_Add:=v_dr_Integration_Add + _Integration + Dlm;
    ELSE
     v_dr_Integration_Add:=v_dr_Integration_Add + Dlm + _Integration + Dlm;
    END;
   ELSE
    v_dr_Integration_Add:=_Integration + Dlm;
   END;
  END;
 END {InsRemIntegration};

 PRIVATE PROCEDURE CheckEMailAddr(_Addr: STRING[]);
 BEGIN
  L_General.Assert(Str.Match(_Addr, "*<*@*>*"),
                   " ଠ :|" +
                   "'" + _Addr + "'" + "| |" +
                   " ஭   |" +
                   "।⠢  : '<' ⮢  '>'");
  L_General.Assert(~Str.Match(_Addr, "<*>*"),
                   " ଠ :|" +
                   "'" + _Addr + "'"+ "| |" +
                   "। ᮬ 室 㪠  ⥫/ࠢ⥫");
 END {CheckEMailAddr};

 PRIVATE PROCEDURE PutValueIntoStrArr(VAR DstArr  : STRING[][];
                                          _Value,
                                          Template: STRING[];
                                      VAR Idx     : NUMERIC[0]);
  CONST
   PropertyValueLength = Str.MaxLength(MDocPro.Value);
  VAR
   _Length: NUMERIC[0];
 BEGIN
  _Length:=PropertyValueLength - Str.Length(Template);
  WHILE ~!_Value DO
   DstArr[Idx]:=Template + Str.Slice(_Value,  0, _Length);
   _Value     :=Str.Delete(_Value, 0, _Length);
   INC(Idx);
  END; (* WHILE ~!_Value...*)
 END {PutValueIntoStrArr};

 PRIVATE PROCEDURE PrepareString(SrcVal: SCAL[100];
                                 AddStr: STRING[]): STRING[];
  VAR
   tmpVal: STRING[];
 BEGIN
  tmpVal:=FLDTOSTR(SrcVal);
  IF ~!AddStr THEN
   tmpVal:=tmpVal + ";" + AddStr;
  END;
  RETURN tmpVal;
 END {PrepareString};

 PRIVATE PROCEDURE InsCurMDocPro(_Property    : LIKE(Property.Property);
                                 ValueByString: STRING[][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE (i <= HIGH(ValueByString)) & (~!ValueByString[i]) DO
   P_MDoc.InsMDocPro(MDoc.MDocKind,
                     MDoc.MDoc,
                     _Property,
                     i + 1,
                     ValueByString[i]);
   INC(i);
  END; (* WHILE i <= HIGH(ValueByString)...*)
 END {InsCurMDocPro};

 PUBLIC PROCEDURE SendOrder();
  VAR
   OrderAttr    : STRING[][oi_Amount];
   FirmDataPDF  : STRING[];
   NeedSendOrder: SCAL[2];
 BEGIN
  GetOrderFromForm(OrderAttr);
  L_General.Assert(~!OrderAttr[oi_Body], "    ");
  CheckEMailAddr(OrderAttr[oi_From]);
  CheckEMailAddr(OrderAttr[oi_To]);
  CheckEMailAddr(OrderAttr[oi_Cc]);

  IF L_XDoc.XDocSomeTimeWasSent(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc) THEN
   NeedSendOrder:=L_StdFrm.RedAlternative("  㦥  ࠢ. ࠢ   e-mail ୮?");
  ELSE
   NeedSendOrder:=L_StdFrm.Alternative("ࠢ   e-mail?");
  END;

  IF NeedSendOrder THEN
   FirmDataPDF:=CALL(O_Firm.MakeOwnFirmEssentialElementsForOrder());
   L_APEMl.Send(OrderAttr[oi_To],
                OrderAttr[oi_From],
                L_APEMl.CurrentSenderContact(),
                L_EMail.EmptyContact(),
                OrderAttr[oi_Cc],
                OrderAttr[oi_Subject],
                FirmDataPDF,
                OrderAttr[oi_Body]);
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, L_XDoc.action_Sent);
   L_StdFrm.Inform(" ᯥ譮 ࠢ  ஭ ");
  END;
 END {SendOrder};

 PRIVATE PROCEDURE MDoc_OnAfterEdit();
  CONST
   PropertyValueLength = Str.MaxLength(MDocPro.Value);
  VAR
   ValueByString: STRING[PropertyValueLength][100];
   i, j         : NUMERIC[0];
   trgPropRow   : LIKE(MDocPro.PropRow);
   tmpValue     : STRING[];
   DRTemplate   : STRING[][dr_Amount];
   OrderAttr,
   OrderTemplate: STRING[][oi_Amount];
 BEGIN
  L_MDoc.AccessMDoc();
  IF    MDoc.MDocKind = L_MDoc.md_VhS THEN
   GetOrderFromForm(OrderAttr);
   L_General.Assert(~!OrderAttr[oi_Body], "    ");

   SELECT(MDocPro, MDoc, , MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Order);
   REMSEL(MDocPro);

   InitOrderTemplate(OrderTemplate);
   trgPropRow:=1;
   i         :=0;
   WHILE i <= HIGH(OrderAttr) DO
    IF ~!OrderAttr[i] THEN
     SETEMPTY(ValueByString);
     j:=0;
     LOOP
      ValueByString[j]:=Str.Slice(OrderTemplate[i] + OrderAttr[i], PropertyValueLength * j, PropertyValueLength);
      IF !ValueByString[j] THEN
       EXIT;
      END;
      INC(j);
     END; (* LOOP *)

     j:=0;
     WHILE (j <= HIGH(ValueByString)) & (~!ValueByString[j]) DO
      P_MDoc.InsMDocPro(MDoc.MDocKind,
                        MDoc.MDoc,
                        P_MDoc.P_Order,
                        trgPropRow,
                        ValueByString[j]);
      INC(j);
      INC(trgPropRow);
     END; (* WHILE j <= HIGH(ValueByString)...*)
    END;
    INC(i);
   END; (* WHILE i <= HIGH(OrderAttr)...*)
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc, L_XDoc.action_Edit);
   SendOrder();
  ELSIF MDoc.MDocKind = L_MDoc.md_ZNr THEN
   SETEMPTY(ValueByString);
   IF !v_dr_DoneJob THEN
    L_StdFrm.Choice(" 㪠 믮 ࠡ");
   END;
   DRTemplate:=InitDRTemplate();
   i:=0;
   j:=0;
   WHILE i < dr_Amount DO
    IF    i = dr_TypeTechInfluence THEN
     PutValueIntoStrArr(ValueByString, PrepareString(v_dr_TypeTechInfluence, v_dr_TypeTechInfluence_Add), DRTemplate[i], j);
    ELSIF i = dr_EqupmentState THEN
     PutValueIntoStrArr(ValueByString, PrepareString(v_dr_EqupmentState,     ""),                         DRTemplate[i], j);
    ELSIF i = dr_MechanicalDamage THEN
     PutValueIntoStrArr(ValueByString, PrepareString(v_dr_MechanicalDamage,  v_dr_MechanicalDamage_Add),  DRTemplate[i], j);
    ELSIF i = dr_Integration THEN
     PutValueIntoStrArr(ValueByString, PrepareString(v_dr_Integration,       v_dr_Integration_Add),       DRTemplate[i], j);
    ELSIF i = dr_DeclaredMalfunction THEN
     PutValueIntoStrArr(ValueByString, v_dr_DeclaredMalfunction,                                          DRTemplate[i], j);
    ELSIF i = dr_DoneJob THEN
     PutValueIntoStrArr(ValueByString, v_dr_DoneJob,                                                      DRTemplate[i], j);
    ELSE
     L_General.CallUs(0);
    END;
    INC(i);
   END; (* WHILE i < dr_Amount...*)
   InsCurMDocPro(P_MDoc.P_DoneJob, ValueByString);
  END;
 END {MDoc_OnAfterEdit};

 PUBLIC PROCEDURE SingleBuildAddDoc();
 BEGIN
  BuildAddDoc(0);
 END {SingleBuildAddDoc};

 PUBLIC PROCEDURE IsSData();
 BEGIN
  E_ShowSalePrice();
 END {IsSData};

 PUBLIC PROCEDURE MakeSpecification();
 BEGIN
  E_MakeSpecification();
 END {MakeSpecification};

BEGIN
 SETEMPTY(P_Firm.curMyFirm);
 L_Events.ExecuteHandler();
END.
