(*
%Copyright   (c) Polak Computer System
%Author      15.10.2001 12:42:58 SAN
%Purpose      ⮢
%Type        report
%Specific    SYS
%Modified    11.08.2014 14:38:51 POLAK\San
%Environment
*)

 MODULE NPDMD [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Str, L_MDoc, P_Firm, L_PDoc, L_Pmnt, L_XDoc, L_DatTim, L_StdFrm, L_AcCut, L_XObj, L_Acnt,
        L_AFM, FIO, L_Basis, Str, P_MDoc, Memo, L_Cntr, L_Russia, P_Cntr, Math, L_ctc, L_bp;

 PRIVATE TYPE
  tContent = SCAL[6];
  tAspect  = SCAL[4];

  tIVEnum = SCAL[7];
  tImportantValues = NUMERIC[2][MAXOF(tIVEnum)+1];

  tBalanceState  = SCAL[3];
  tPaymentPeriod = SCAL[6];
  tValuesToPaymentPeriod = NUMERIC[2][MAXOF(tPaymentPeriod)+1];

 PRIVATE CONST
  c_NotPaid = 0;
  c_Pays    = 1;
  c_Blnc    = 2;
  c_Full    = 3;
  c_BAll    = 4;
  c_bpFull  = 5;

  a_All     = 0;
  a_Firm    = 1;
  a_CntrT   = 2;
  a_Cntr    = 3;

  iv_Sums = 0;
  iv_InWr = 1;
  iv_Paid = 2;
  iv_Acpt = 3;
  iv_OkPd = 4;
  iv_OkAc = 5;
  iv_cSld = 6;

  iv_Pool = " | 拉|祭|㦥||㧪|줮";

  bs_Balanced = 0;
  bs_Debit    = 1;
  bs_Credit   = 2;

  pp_Month   = 0;
  pp_30Days  = 1;
  pp_Quarter = 2;
  pp_90Days  = 3;
  pp_Year    = 4;
  pp_360Days = 5;

  pp_Pool = "|30 |⠫|90 ||360 ";

 PRIVATE VAR
  OnDate      : DATE;
  OnTime      : TIME;
  Title       : STRING[];
  curContent  : tContent;
  curAspect   : tAspect;
  tIV         : tImportantValues;
  tPaid,
  tUnderpay   : NUMERIC[2];
  tCount      : NUMERIC[0];
  wMF         : SCAL[2];

(*
$P{ NP_Top:
P_Firm.FP_FirmShortName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
SYSDATE(), L, "D.N.y"
Title, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                                ᮮ⢥饩 ⮩  ##########                               |
|############################################################################################################|
}
*)

(*
$P{ NP_SectTop:
?, C, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|㬥   |室                  |      |  |ப |?|   ||       㬬|  |
|-----------|-------------------------------|----------|----|-----|-|----------|----|------------|-----------|
}
*)

(*
$P{ NP_Line:
L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L, ""
MDoc.SrcNbr, L, ""
MyFirm.Sign, L, ""
MDoc.SrcDate, L, "D.N.y"
MDoc.Date, L, "NY"
MDoc.PayDate, L, "D.N"
(MDoc.PayDate <= SYSDATE()), L, " |!"
Contract.CntrT, L, ""
Contract.Contract, L, ""
Contract.Firm, L, ""
L_Pmnt.vtbExtractTotal(L_Pmnt.GetMDocAcpt()), R, "2."
?, R, "2."
@
|###########|######################### #####|##########|####|#####|#|## #######|####|############|###########|
}
*)

(*
$P{ NP_SectBot:
tUnderpay, R, "2."
@
|------------------------------------------------------------------------------------------------|-----------|
|ᥣ                                                                                           |###########|
}
*)

(*
$P{ NP_Bot:
@
=(c) Polak====================================================================================================
}
*)

(*
$P{ Ps_Top:
P_Firm.FP_FirmShortName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.From(), L, "D.N.y"
Memo.UpTo(), L, "D.N.y"
Title, C, ""
@
############################################################# ########## #####
=#####========================================================================
|                  ਮ  ##########  ##########                 |
|############################################################################|
|----------------------------------------------------------------------------|
|㬥   |        |   ||      |㬥      |      㬬|
|-----------|----------|----------|----|----------|--------------|-----------|
}
*)

(*
$P{ Ps_Line:
L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L, ""
MDoc.SrcDate, L, "D.N.y"
Contract.CntrT, L, ""
Contract.Contract, L, ""
Contract.Firm, L, ""
?, L, "D.N.y"
?, L, ""
?, R, "2-"
@
|###########|##########|## #######|####|##########|##############|###########|
}
*)

(*
$P{ Ps_Bot:
tPaid, R, "2-"
@
|----------------------------------------------------------------|-----------|
|ᥣ                                                           |###########|
=(c) Polak====================================================================
}
*)

(*
$P{ Bl_Top:
P_Firm.FP_FirmShortName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Title, C, ""
@
########################################################################### ########## #####
=#####======================================================================================
|                               ﭨ ᯮ ᤥ                                |
|##########################################################################################|
}
*)

(*
$P{ Bl_SectTop:
?, L, ""
@
|------------------------------------------------------------------------------------------|
|##########################################################################################|
|------------------------------------------------------------------------------------------|
|㬥   |        |   ||       㬬|     拉|    祭|   㦥|
|-----------|----------|----------|----|------------|------------|------------|------------|
}
*)

(*
$P{ Bl_Line:
L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L, ""
MDoc.SrcDate,      L, "D.N.y"
Contract.CntrT,    L, ""
Contract.Contract, L, ""
Contract.Firm,     L, ""
?,                 R, "2-"
?,                 R, "2-"
?,                 R, "2-"
?,                 R, "2-"
@
|###########|##########|## #######|####|############|############|############|############|
}
*)

(*
$P{ Bl_SectBot:
tIV[iv_Sums], R, "2-"
tIV[iv_InWr], R, "2-"
tIV[iv_Paid], R, "2-"
tIV[iv_Acpt], R, "2-"
@
|--------------------------------------|------------|------------|------------|------------|
|ᥣ                                 |############|############|############|############|
}
*)

(*
$P{ Bl_Bot:
@
=(c) Polak==================================================================================
}
*)

(*
$P{ sp_Top:
P_Firm.FP_FirmShortName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
?, L, ""
?, L, "D.N.y"
"ࠣ " + Firm.Firm + " " + Firm.Name, C, ""
@
#####################################################################################################
=#####===============================================================================================
|                            ﭨ  ##########                         |
|                          ( ⮬ ⮢  㬥⮢)                           |
|###################################################################################################|
|---------------------------------------------------------------------------------------------------|
|ਮ                                                         |            |           ।|
|---------------------------------------------------------------|-----------------|-----------------|
}
*)

(*
$P{ sp_Line:
?, L, ""
?, R, ",2-"
?, R, ",2-"
@
|###############################################################|#################|#################|
}
*)

(*
$P{ sp_AgentSumTop:
@
|===================================================================================================|
|                                     ࠭祭 㬬                                   |
|---------------------------------------------------------------------------------------------------|
|                                      |   㬬 |      ᥣ |     ᥣ ।|
|---------------------------------------------|-----------------|-----------------|-----------------|
}
*)

(*
$P{ sp_AgentSumLine:
Contract.Contract, L, ""
Contract.Name, L, ""
?, R, ",2-"
?, R, ",2-"
?, R, ",2-"
@
|####### #####################################|#################|#################|#################|
}
*)



(*
$P{ sp_Bot:
@
=(c) Polak===========================================================================================
}
*)

 PRIVATE PROCEDURE NotClosedContractOnly(): SCAL[2];
 BEGIN
  RETURN (curAspect # a_Cntr) & (* ⭮  뢠 *)
         ((curContent = c_NotPaid) |
          (curContent = c_Blnc) |
          (curContent = c_Full) |
          (curContent = c_bpFull)
         );
 END {NotClosedContractOnly};

 PRIVATE PROCEDURE ContractCond(): SCAL[2];
 BEGIN
  IF ~Contract.Leaf THEN
   RETURN 0;
  ELSIF NotClosedContractOnly() THEN
   RETURN ~Contract.Closed;
  ELSE
   RETURN 1;
  END;
 END {ContractCond};

 PRIVATE PROCEDURE SetMDocClosed(D: DATE);
 BEGIN
  IF (curContent = c_BAll) & ~!MDoc.Closed THEN
   RETURN;
  END;
  IF MDoc.Status # L_MDoc.st_Prepared THEN
   MDoc.Closed:=D;
   TRY [MSGSUPPRESSIONMODE(MSGSUPPRESS_ALL), EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
    REPLACE(MDoc);
   EXCEPT
   ON Exc: Exc_NoRights DO
   ON Exc: Exc_AccessDeny DO
   END;
  END;
 END {SetMDocClosed};

 PRIVATE PROCEDURE SetContractClosed();
 BEGIN
  L_General.CallUs(((curContent = c_Full) | (curContent = c_bpFull)) & ~Contract.Closed & ~!Contract.Till);
  Contract.Closed:=1;
  TRY [MSGSUPPRESSIONMODE(MSGSUPPRESS_ALL), EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   REPLACE(Contract);
  EXCEPT
  ON Exc: Exc_NoRights DO
  ON Exc: Exc_AccessDeny DO
  END;
 END {SetContractClosed};

 PRIVATE PROCEDURE NP_ProceedMDoc();
  VAR
   Underpay: NUMERIC[2];
 BEGIN
  IF L_Pmnt.TakeMDocIntoAccount() THEN
   IF (MDoc.Status=L_MDoc.st_Passed) | (MDoc.Status=L_MDoc.st_Canceled) THEN
    Underpay:=L_Pmnt.vtbExtractTotal(L_Pmnt.GetMDocBalance(SYSDATE(), L_XDoc.max_DoneDTS));
    IF (Underpay # 0) & (P_MDoc.GetDealCheckType(MDoc.MDocKind, MDoc.MDoc) # P_MDoc.dct_DoNot) THEN
     IF ~L_Pmnt.E_IsSellMDoc() THEN
      Underpay:=-Underpay;
     END;
     CONFORM(MDoc, Contract);
     IF tCount = 0 THEN
      MAKEPART(R, NP_SectTop, L_Str.PoolItem("㯪|த", L_Pmnt.E_IsSellMDoc()));
     END;
     CONFORM(Contract, MyFirm);
     MAKEPART(R, NP_Line, Underpay);
     L_XDoc.sl_AddCurrentXDoc(L_XDoc.xdt_MDoc);
     INC(tCount);
     INC(tUnderpay, Underpay);
    ELSIF L_Pmnt.IsAcptMDocKind(MDoc.MDocKind) THEN
     SetMDocClosed(SYSDATE());
    END;
   END;
  ELSE
   SetMDocClosed(SYSDATE());
  END;
 END {NP_ProceedMDoc};

 PRIVATE PROCEDURE XX_ProceedOneMDocKind(_MDocKind: LIKE(MDoc.MDocKind);
                                 Proc     : PROC);
 BEGIN
  SELECT(_MDoc, MDoc, , _MDocKind);
  WHILE OCCURE(_MDoc) DO
   SEARCH(MDoc, MDoc, , _MDoc.MDocKind, _MDoc.MDoc);
   PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   Proc();
   NEXT(_MDoc);
  END; (* WHILE OCCURE(_MDoc) ... *)
 END {XX_ProceedOneMDocKind};

 PRIVATE PROCEDURE NP_ProceedSingleDir(Sell: SCAL[2]);
 BEGIN
  SETZERO(tCount, tUnderpay);
  SETSEL(MDocKind, MDocKind);
  FOR_EACH MDocKind DO
   IF L_Pmnt.IsMayBePaidMDocKind(MDocKind.MDocKind) THEN
    IF L_MDoc.IsSellMDocKind() &  Sell |
       L_MDoc.IsPrchMDocKind() & ~Sell THEN
     XX_ProceedOneMDocKind(MDocKind.MDocKind, PROCREF(NP_ProceedMDoc));
    END;
   END;
  END; (* FOR_EACH MDocKind *)
  IF tCount > 0 THEN
   MAKEPART(R, NP_SectBot);
  END;
 END {NP_ProceedSingleDir};

 PRIVATE PROCEDURE NP_Proceed(RepName: STRING[]);
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, NP_Top, RepName);
  NP_ProceedSingleDir(1);
  NP_ProceedSingleDir(0);
  MAKEPART(R, NP_Bot);
  CLOSEREP(R);
 END {NP_Proceed};

 PRIVATE PROCEDURE Ps_ProceedMDoc();
 BEGIN
  CONFORM(MDoc, Contract);
  MAKEPART(R, Ps_Line,
           _MDoc.PDocDate,
           L_PDoc.PDocStr(_MDoc.PDocKind, _MDoc.PDoc),
           _MDoc.byPDMDSum);
  L_XDoc.sl_AddCurrentXDoc(L_XDoc.xdt_MDoc);
  INC(tPaid, _MDoc.byPDMDSum);
 END {Ps_ProceedMDoc};

 PRIVATE PROCEDURE Ps_Proceed(RepName: STRING[]);
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Ps_Top, RepName);
  tPaid:=0;
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF L_MDoc.IsExternalMDocKind() THEN
    XX_ProceedOneMDocKind(MDocKind.MDocKind, PROCREF(Ps_ProceedMDoc));
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
  MAKEPART(R, Ps_Bot);
  CLOSEREP(R);
 END {Ps_Proceed};

 PRIVATE PROCEDURE Bl_GetByRefs(VAR _InWr, _Acpt: L_Pmnt.tValuesToBalance);
  VAR
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
 BEGIN
  SAVE(MDoc);
  i:=0;
  DependentMDocs:=L_MDoc.GetDependentMDocXDC();
  WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
   IF L_Pmnt.IsTransitiveMDoc(MDoc.MDocKind) THEN
    _InWr:=L_Pmnt.vtbAdd(_InWr, L_Pmnt.GetMDocAcpt());
    Bl_GetByRefs(_InWr, _Acpt);
   ELSIF L_Pmnt.IsAcptMDocKind(MDoc.MDocKind) & ~L_Pmnt.IsMayBePaidMDocKind(MDoc.MDocKind) THEN
    _Acpt:=L_Pmnt.vtbAdd(_Acpt, L_Pmnt.GetMDocAcptBalance());
   END;
   INC(i);
  END; (* WHILE L_XDoc.xdc_PositionOn ... *)
  RESTORE(MDoc);
 END {Bl_GetByRefs};

 PRIVATE PROCEDURE Bl_intProceedMDoc(VAR _Sums,
                                         _InWr,
                                         _Acpt,
                                         _Paid,
                                         _OkPd,
                                         _OkAc  : L_Pmnt.tValuesToBalance);
 BEGIN
  SETEMPTY(_Sums);
  IF L_Pmnt.TakeMDocIntoAccount() & (MDoc.Date <= OnDate) &
     ((curContent = c_BAll) | (P_MDoc.GetDealCheckType(MDoc.MDocKind, MDoc.MDoc) # P_MDoc.dct_DoNot)) THEN
   CONFORM(MDoc, Contract);
   IF (P_Cntr.GetBalanceType(Contract.Contract, MDoc.Date) = P_Cntr.ctbt_ByDeal) |
      (curAspect # a_All) | (curContent = c_Full) | (curContent = c_bpFull) THEN
    _Sums:=L_Pmnt.GetMDocAcptBalance();
    IF L_Pmnt.IsAcptMDocKind(MDoc.MDocKind) THEN
     _Acpt:=_Sums;
    ELSE
     SETZERO(_Acpt);
    END;
    SETZERO(_InWr);
    Bl_GetByRefs(_InWr, _Acpt);
    _Paid:=L_Pmnt.GetMDocPmntBalance(OnDate, L_XDoc.max_DoneDTS);
    IF ~L_Pmnt.E_IsSellMDoc() THEN
     _Paid:=L_Pmnt.vtbInv(_Paid);
     _Acpt:=L_Pmnt.vtbInv(_Acpt);
     _Sums:=L_Pmnt.vtbInv(_Sums);
    END;
    _OkPd:=L_Pmnt.vtbAdd(_Sums, _Paid);
    _OkAc:=L_Pmnt.vtbAdd(_Sums, L_Pmnt.vtbInv(_Acpt));
    IF (P_Cntr.GetBalanceType(Contract.Contract, MDoc.Date) # P_Cntr.ctbt_ByDeal) & (curContent # c_BAll) THEN
     SETZERO(_OkAc);
    END;
    IF (_OkPd[L_Pmnt.vtb_Total] # 0) | (_OkAc[L_Pmnt.vtb_Total] # 0) | (curContent = c_BAll) THEN
     _Paid:=L_Pmnt.vtbInv(_Paid);
    ELSE
     SETEMPTY(_Sums);
     SetMDocClosed(SYSDATE());
    END;
   END; (* IF P_Cntr.GetBalanceType(Contract.Contract, MDoc.Date) ... *)
  END;
 END {Bl_intProceedMDoc};

 PRIVATE PROCEDURE Bl_ProceedMDoc();
  VAR
   _Sums,
   _InWr,
   _Acpt,
   _Paid,
   _OkPd,
   _OkAc : L_Pmnt.tValuesToBalance;
   IV    : tImportantValues;
 BEGIN
  Bl_intProceedMDoc(_Sums, _InWr, _Acpt, _Paid, _OkPd, _OkAc);
  IF ~!_Sums[L_Pmnt.vtb_Total] THEN
   IV[iv_Sums]:=_Sums[L_Pmnt.vtb_Total];
   IV[iv_InWr]:=_InWr[L_Pmnt.vtb_Total];
   IV[iv_Acpt]:=_Acpt[L_Pmnt.vtb_Total];
   IV[iv_Paid]:=_Paid[L_Pmnt.vtb_Total];
   IF (IV[iv_Sums] # 0) | (IV[iv_InWr] # 0) | (IV[iv_Acpt] # 0) | (IV[iv_Paid] # 0) THEN
    INC(tIV[iv_Sums], IV[iv_Sums]);
    INC(tIV[iv_InWr], IV[iv_InWr]);
    INC(tIV[iv_Paid], IV[iv_Paid]);
    INC(tIV[iv_Acpt], IV[iv_Acpt]);
    IF tCount = 0 THEN
     MAKEPART(R, Bl_SectTop, L_Str.PoolItem("㯪|த", L_Pmnt.E_IsSellMDoc()));
    END;
    MAKEPART(R, Bl_Line, IV[iv_Sums], IV[iv_InWr], IV[iv_Paid], IV[iv_Acpt]);
    L_XDoc.sl_AddCurrentXDoc(L_XDoc.xdt_MDoc);
    INC(tCount);
   END;
  END; (* IF ~!Value ... *)
 END {Bl_ProceedMDoc};

 PRIVATE PROCEDURE Bl_ProceedSingleDir(Sell: SCAL[2]);
 BEGIN
  SETZERO(tIV, tCount);
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF L_Pmnt.IsMayBePaidMDocKind(MDocKind.MDocKind) THEN
    IF L_MDoc.IsSellMDocKind() &  Sell |
       L_MDoc.IsPrchMDocKind() & ~Sell THEN
     XX_ProceedOneMDocKind(MDocKind.MDocKind, PROCREF(Bl_ProceedMDoc));
    END;
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
  IF tCount > 0 THEN
   MAKEPART(R, Bl_SectBot);
  END;
 END {Bl_ProceedSingleDir};

 PRIVATE PROCEDURE Bl_Proceed(RepName: STRING[]);
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Bl_Top, RepName);
  Bl_ProceedSingleDir(1);
  Bl_ProceedSingleDir(0);
  MAKEPART(R, Bl_Bot);
  CLOSEREP(R);
 END {Bl_Proceed};

 PRIVATE PROCEDURE exl_MakeHeader(R: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(R, "");
   L_Basis.wb_WrInQM(R, "");
  END;
  L_Basis.wb_WrStr(R, "");
  L_Basis.wb_WrStr(R, "");
  L_Basis.wb_WrStr(R, "ਮ ਬ  ()");
  L_Basis.wb_WrStr(R, " ࠊ");
  L_Basis.wb_WrStr(R, " ");
  L_Basis.wb_WrStr(R, "ࠢ");
  L_Basis.wb_WrStr(R, " ");
  L_Basis.wb_WrStr(R, "易 ");
  L_Basis.wb_WrStr(R, " ");
  L_Basis.wb_WrStr(R, " ᫥  ᠫ줮  ");
  L_Basis.wb_WrStr(R, "࣠");
  L_Basis.wb_WrStr(R, "࣠");
  L_Basis.wb_WrStr(R, " ࠣ");
  L_Basis.wb_WrStr(R, " ࠣ");
  L_Basis.wb_WrStr(R, "䮭 ࠣ");
  L_Basis.wb_WrStr(R, "筨");
  L_Basis.wb_WrStr(R, "ﭨ 鸞");
  L_Basis.wb_WrStr(R, "ﭨ ");
  L_Basis.wb_WrStr(R, "ﭨ 㧪");
  L_Basis.wb_WrStr(R, "ﭨ ");
  L_Basis.wb_WrStr(R, " 㬥⠊");
  L_Basis.wb_WrStr(R, " 㬥⠍");
  L_Basis.wb_WrStr(R, " 㬥");
  L_Basis.wb_WrStr(R, "ﭨ 㬥");
  L_Basis.wb_WrStr(R, "㬥 祭  ᯮ");
  L_Basis.wb_WrStr(R, " 㬥");
  L_Basis.wb_WrStr(R, " 室");
  L_Basis.wb_WrStr(R, "ப ");
  L_Basis.wb_WrStr(R, "⥫");
  L_Basis.wb_WrStr(R, "");
  L_Basis.wb_WrStr(R, "");
  L_Basis.wb_WrStr(R, "");
  L_Basis.wb_TermLine(R);
 END {exl_MakeHeader};

 PRIVATE PROCEDURE exl_MakeLine(R    : STRING[];
                                D,
                                LastBalChD : DATE;
                                ns,
                                ps,
                                as,
                                bs   : tBalanceState;
                                iv   : tIVEnum;
                                Value: L_Pmnt.tValuesToBalance);
  VAR
   curMDocKind    : STRING[];
   curMDocKindNick: STRING[];
   curMDoc        : STRING[];
   curStatus      : STRING[];
   curDate        : DATE;
   curSrcDate     : DATE;
   curPayDate     : DATE;
   curPerm2Pay    : SCAL[2];
 BEGIN
  IF wMF THEN
   CONFORM(Contract, MyFirm);
   L_Basis.wb_WrScl(R, MyFirm.MyFirm);
   L_Basis.wb_WrStr(R, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(R, Contract.Contract);
  L_Basis.wb_WrStr(R, Contract.Name);
  L_Basis.wb_WrDat(R, Contract.Till);
  L_Basis.wb_WrScl(R, CntrT.CntrT);
  L_Basis.wb_WrStr(R, CntrT.Name);
  L_Basis.wb_WrStr(R, L_Cntr.GetContractType_asStr());
  L_Basis.wb_WrStr(R, L_Str.PoolItem("||", P_Cntr.GetBalanceType(Contract.Contract, D)));
  L_Basis.wb_WrStr(R, L_Str.PoolItem("|", P_Cntr.GetPayOblg(Contract.Contract, D)));
  L_Basis.wb_WrStr(R, P_Cntr.ppi_DescriptionOfGoods(Contract.Contract, D));
  L_Basis.wb_WrDat(R, LastBalChD);

  L_Basis.wb_WrScl(R, Firm.Firm);
  L_Basis.wb_WrStr(R, Firm.Name);

  L_Basis.wb_WrStr(R, P_Firm.FP_ContractorBriefName(Firm.Firm, OnDate));
  IF L_ctc.StandOnAdr_Reg(OnDate, Firm.Firm, 0) THEN
   L_Basis.wb_WrStr(R, L_ctc.curCtcAdr_asStr(L_Russia.af_Full));
  ELSE
   L_Basis.wb_WrStr(R, "");
  END;
  L_Basis.wb_WrStr(R, P_Firm.FP_Phone(Firm.Firm, OnDate));

  curPerm2Pay:=0;
  IF (iv = iv_cSld) THEN
   L_Basis.wb_WrStr(R, "");
   curMDocKind    :="--";
   curMDocKindNick:="--";
   curMDoc        :="--";
   curStatus      :="--";
   curDate        :=MINOF(DATE);
   curSrcDate     :=MINOF(DATE);
   curPayDate     :=MINOF(DATE);
  ELSE
   L_Basis.wb_WrStr(R, "");
   curMDocKind    :=MDoc.MDocKind;
   curMDocKindNick:=L_MDoc.MDocKindNick(MDoc.MDocKind, 1);
   curMDoc        :=MDoc.MDoc;
   curStatus      :=L_Str.PoolItem(L_MDoc.st_Pool, MDoc.Status);
   curDate        :=MDoc.Date;
   curSrcDate     :=MDoc.SrcDate;
   curPayDate     :=MDoc.PayDate;
   SETSEL(XDocFlow, XDocFlow, MDoc.XDocId);
   FOR_EACH XDocFlow DO
    IF (XDocFlow.Action = L_XDF.a_HandOriginal) | (XDocFlow.Action = L_XDF.a_HandCopy) THEN
     curPerm2Pay:=1;
     EXIT;
    END;
   END; (* FOR_EACH XDocFlow *)
  END;
  L_Basis.wb_WrScl(R, L_Str.PoolItem("||", ns));
  L_Basis.wb_WrScl(R, L_Str.PoolItem("||", ps));
  L_Basis.wb_WrScl(R, L_Str.PoolItem("||", as));
  L_Basis.wb_WrScl(R, L_Str.PoolItem("||।", bs));
  L_Basis.wb_WrStr(R, curMDocKind);
  L_Basis.wb_WrStr(R, curMDocKindNick);
  L_Basis.wb_WrStr(R, curMDoc);
  L_Basis.wb_WrStr(R, curStatus);
  L_Basis.wb_WrStr(R, L_Str.PoolItem("-|+", curPerm2Pay));
  L_Basis.wb_WrDat(R, curDate);
  L_Basis.wb_WrDat(R, curSrcDate);
  L_Basis.wb_WrDat(R, curPayDate);
  L_Basis.wb_WrStr(R, L_Str.PoolItem(iv_Pool, iv));
  L_Basis.wb_WrNum(R, Value[L_Pmnt.vtb_Total], 2);
  L_Basis.wb_WrNum(R, Value[L_Pmnt.vtb_Netto], 2);
  L_Basis.wb_WrNum(R, Value[L_Pmnt.vtb_VAT  ], 2);
  L_Basis.wb_TermLine(R);
 END {exl_MakeLine};

 PRIVATE PROCEDURE DefineBalanceState(Value: L_Pmnt.tValuesToBalance): tBalanceState;
 BEGIN
  IF    Value[L_Pmnt.vtb_Total] > 0 THEN
   RETURN bs_Debit;
  ELSIF Value[L_Pmnt.vtb_Total] < 0 THEN
   RETURN bs_Credit;
  ELSE
   RETURN bs_Balanced;
  END;
 END {DefineBalanceState};

 PRIVATE PROCEDURE GetLastBalanceChangePer(D: DATE): DATE;
  VAR
   Dbt, Crd: L_XObj.tSum;
 BEGIN
  SETSEL(XCalc, XObject, Contract.XObject, L_AcCut.erkn_Get(D, L_AcCut.erkn_OnlineBalance));
  SRCINSEL(XCalc, LE, , L_DatTim.Per(D));
  WHILE OCCURE(XCalc) DO
   SETZERO(Dbt, Crd);
   SELECT(XApport, WFD, , XCalc.XObject, XCalc.AcCut, XCalc.XDat);
   WHILE OCCURE(XApport) DO
    CONFORM(XApport, Apport);
    IF Apport.CirType = L_Acnt.ct_Credit THEN
     INC(Crd, XApport.Sum);
    ELSE
     INC(Dbt, XApport.Sum);
    END;
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
   IF (Dbt # 0) | (Crd # 0) THEN
    RETURN XCalc.XDat;
   END;
   PREV(XCalc);
  END; (* WHILE OCCURE(XCalc) ... *)
  RETURN L_DatTim.IncMonth(L_DatTim.Per(D), -1);
 END {GetLastBalanceChangePer};

 PRIVATE PROCEDURE intGetLastBalanceChangeDate(lastP: DATE): DATE;
  VAR
   Result: DATE;
 BEGIN
  SETEMPTY(Result);
  L_Pmnt.PrepareContractBalanceHistory(Contract.Contract, GetLastBalanceChangePer(lastP), OnDate);
  SETSEL(CnBHs, CnBHs, Contract.XObject);
  LAST(CnBHs);
  WHILE OCCURE(CnBHs) DO
   IF CnBHs.Value[L_Pmnt.vtb_Total] # 0 THEN
    Result:=CnBHs.Date;
    FIRST(CnBHs);
   END;
   PREV(CnBHs);
  END; (* WHILE OCCURE(CnBHs) ... *)
  L_AFM.AF_PurgeTemp("CnBHs");
  RETURN Result;
 END {intGetLastBalanceChangeDate};

 PRIVATE PROCEDURE GetLastBalanceChangeDate(): DATE;
  VAR
   Result: DATE;
 BEGIN
  Result:=intGetLastBalanceChangeDate(OnDate);
  IF !Result THEN
   Result:=intGetLastBalanceChangeDate(L_DatTim.MonthBeg(OnDate)-1);
  END;
  RETURN Result;
 END {GetLastBalanceChangeDate};

 PRIVATE PROCEDURE Bl_extProceedMDoc(LastBalChD: DATE);
  VAR
   _Sums,
   _InWr,
   _Acpt,
   _Paid,
   _OkPd,
   _OkAc  : L_Pmnt.tValuesToBalance;
   ns, ps,
   as, bs : tBalanceState;
 BEGIN
  Bl_intProceedMDoc(_Sums, _InWr, _Acpt, _Paid, _OkPd, _OkAc);
  IF ~!_Sums[L_Pmnt.vtb_Total] THEN
   ns:=DefineBalanceState(L_Pmnt.vtbAdd(_InWr, L_Pmnt.vtbInv(_Sums)));
   ps:=DefineBalanceState(L_Pmnt.vtbAdd(_Paid, L_Pmnt.vtbInv(_Sums)));
   as:=DefineBalanceState(L_Pmnt.vtbAdd(_Acpt, L_Pmnt.vtbInv(_Sums)));
   bs:=DefineBalanceState(L_Pmnt.vtbAdd(_Acpt, L_Pmnt.vtbInv(_Paid)));
   exl_MakeLine("R", MDoc.Date, LastBalChD, ns, ps, as, bs, iv_Sums, _Sums);
   exl_MakeLine("R", MDoc.Date, LastBalChD, ns, ps, as, bs, iv_InWr, _InWr);
   exl_MakeLine("R", MDoc.Date, LastBalChD, ns, ps, as, bs, iv_Paid, _Paid);
   exl_MakeLine("R", MDoc.Date, LastBalChD, ns, ps, as, bs, iv_Acpt, _Acpt);
   exl_MakeLine("R", MDoc.Date, LastBalChD, ns, ps, as, bs, iv_OkPd, _OkPd);
   exl_MakeLine("R", MDoc.Date, LastBalChD, ns, ps, as, bs, iv_OkAc, _OkAc);
   INC(tCount);
  END; (* IF ~!_Sums[ ... *)
 END {Bl_extProceedMDoc};

 PRIVATE PROCEDURE DoExcel(RepName: STRING[]; trgTimeCond: L_General.tTimeCond);
  VAR
   Balance    : L_Pmnt.tValuesToBalance;
   bs         : tBalanceState;
   LastBalChD : DATE;
   nxtContract: LIKE(Contract.Contract);
 BEGIN
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  exl_MakeHeader("R");

  nxtContract:=00000;

  LOOP (* WHILE ⮬   ᡨ SELECT  Contract,   SetContractClosed()  祭 祢 *)
   IF NotClosedContractOnly() THEN
    SETSEL(Contract, Closed, 0, 1);
   ELSE
    L_General.CallUs(0);
   END;
   IF SRCINSEL(Contract, GE, nxtContract) THEN
    nxtContract:=Contract.Contract+1;
   ELSE
    EXIT;
   END;

   PROMPT("⮢ .  " + Contract.Contract);
   CONFORM(Contract, CntrT);
   CONFORM(Contract, Firm);

   Balance:=L_Pmnt.GetContractBalance(Contract.Contract, OnDate, L_XDoc.max_DoneDTS, L_XDoc.max_DoneDTS);
   IF (Contract.Till <= OnDate) &
      (Balance[L_Pmnt.vtb_Total] = 0) &
      (P_Cntr.GetBalanceType(Contract.Contract, OnDate) # P_Cntr.ctbt_ByDeal) THEN
    SetContractClosed();
   ELSE
    tCount:=0;
    SELECT(_MDoc, Contract, , Contract.Contract);
    WHILE OCCURE(_MDoc) DO
     NARROWSEL(_MDoc, MDocKind);
     IF L_Pmnt.IsMayBePaidMDocKind(_MDoc.MDocKind) THEN
      WHILE OCCURE(_MDoc) DO
       SEARCH(MDoc, MDoc, , _MDoc.MDocKind, _MDoc.MDoc);
       IF tCount = 0 THEN
        LastBalChD:=GetLastBalanceChangeDate();
       END;
       Bl_extProceedMDoc(LastBalChD);
       NEXT(_MDoc);
      END; (* WHILE OCCURE(_MDoc) ... *)
     END;
     NEXTINEXTENDEDSEL(_MDoc, MDocKind);
    END; (* WHILE OCCURE(_MDoc) ... *)
    IF (Balance[L_Pmnt.vtb_Total] # 0) | (tCount > 0) | L_DatTim.IsActive(OnDate, Contract.Begin, Contract.Till) THEN
     IF tCount = 0 THEN
      LastBalChD:=GetLastBalanceChangeDate();
     END;
     bs:=DefineBalanceState(Balance);
     IF bs = bs_Credit THEN
      Balance:=L_Pmnt.vtbInv(Balance);
     END;
     exl_MakeLine("R", OnDate, LastBalChD, bs_Balanced, bs_Balanced, bs_Balanced, bs, iv_cSld, Balance);
    ELSIF Contract.Till <= OnDate THEN
     SetContractClosed();
    END;
   END;
  END; (* LOOP ... *)
  FIO.Close(R);
  IF curContent # c_bpFull THEN
   L_Basis.ExtPlayMakedRunTimeRep(RepName,
                                  FLDTOSTR(OnDate, "yND") + "_" +
                                  FLDTOSTR(OnTime, "HM"),
                                  trgTimeCond,
                                  Str.Slice("ﭨ ⮢  " +
                                            L_DatTim.DateStr(OnDate) + " " +
                                            L_DatTim.TimeStr(OnTime), 0, 68),
                                  0);
  END;
 END {DoExcel};

 PRIVATE PROCEDURE DoBAll(RepName: STRING[]);
 BEGIN
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  exl_MakeHeader("R");
  CONFORM(Contract, Firm);
  CONFORM(Contract, CntrT);
  tCount:=0;
  SELECT(_MDoc, MDoc);
  WHILE OCCURE(_MDoc) DO
   NARROWSEL(_MDoc, MDocKind);
   IF L_Pmnt.IsMayBePaidMDocKind(_MDoc.MDocKind) THEN
    WHILE OCCURE(_MDoc) DO
     SEARCH(MDoc, MDoc, , _MDoc.MDocKind, _MDoc.MDoc);
     PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
     Bl_extProceedMDoc(EMPTYOF(DATE));
     NEXT(_MDoc);
    END; (* WHILE OCCURE(_MDoc) ... *)
   END;
   NEXTINEXTENDEDSEL(_MDoc, MDocKind);
  END;  (* WHILE OCCURE(_MDoc) ... *)
  FIO.Close(R);
  L_Basis.ExtPlayMakedRunTimeRep(RepName,
                                 Contract.Contract + "_" +
                                 FLDTOSTR(OnDate, "yND") + "_" +
                                 FLDTOSTR(OnTime, "HM"),
                                 L_General.timeCond_Entire,
                                 Str.Slice(" ᤥ   " + Contract.Contract + "  " +
                                           L_DatTim.DateStr(OnDate) + " " +
                                           L_DatTim.TimeStr(OnTime), 0, 68),
                                 0);
 END {DoBAll};

 PRIVATE PROCEDURE RealContract(_Contract: LIKE(Contract.Contract)): SCAL[2];
 BEGIN
  RETURN (_Contract # 0000000) & Contract.Leaf;
 END {RealContract};

 PRIVATE PROCEDURE pi_PutSingleItem();
 BEGIN
  DEFAULT(_MDoc);
  IF curContent = c_Pays THEN
   IF PDocMDoc.PDocDate > Memo.ud_ut() THEN
   (* , ᪮ த TRY ᢥ   *)
    RETURN;
   END;
   _MDoc.PDocKind :=PDocMDoc.PDocKind;
   _MDoc.PDoc     :=PDocMDoc.PDoc;
   _MDoc.PDocDate :=PDocMDoc.PDocDate;
   _MDoc.byPDMDSum:=L_Pmnt.vtbExtractTotal(L_Pmnt.vtbGetByPDocMDoc());
   IF L_PDoc.IsOutPDoc(PDocMDoc.PDocKind) # (Contract.Type = L_Cntr.ct_Prch) THEN
    _MDoc.byPDMDSum:=-_MDoc.byPDMDSum;
   END;
   CONFORM(PDocMDoc, MDoc);
  END;
  _MDoc.MDocKind:=MDoc.MDocKind;
  _MDoc.MDoc    :=MDoc.MDoc;
  _MDoc.Contract:=MDoc.Contract;
  INSERT(_MDoc);
 END {pi_PutSingleItem};

 PRIVATE PROCEDURE pi_PutSingleContract();
  VAR
   OnDate: DATE;
 BEGIN
  PROMPT(".  "+Contract.Contract);
  IF RealContract(Contract.Contract) THEN
   IF curContent = c_Pays THEN
    SETSEL(PDocMDoc, Contract, Contract.Contract);
    SRCINSEL(PDocMDoc, GE, , Memo.ud_fr());
    WHILE OCCURE(PDocMDoc) DO
     CONFORM(PDocMDoc, PDoc);
     IF PDoc.Status # L_PDoc.st_Canceled THEN
      pi_PutSingleItem();
     END;
     NEXT(PDocMDoc);
    END; (* WHILE OCCURE(PDocMDoc) ... *)
   ELSE
    IF curContent = c_BAll THEN
     OnDate:=MINOF(DATE);
    ELSE
     OnDate:=EMPTYOF(DATE);
    END;
    SETSEL(MDocKind, MDocKind);
    FOR_EACH MDocKind DO
     IF L_Pmnt.IsMayBePaidMDocKind(MDocKind.MDocKind) THEN
      SETSEL(MDoc, CntrClsd, Contract.Contract, MDocKind.MDocKind);
      SRCINSEL(MDoc, GE, , OnDate);
      WHILE OCCURE(MDoc) DO
       pi_PutSingleItem();
       NEXT(MDoc);
      END; (* WHILE OCCURE(MDoc) ... *)
     END;
    END; (* FOR_EACH MDocKind *)
   END;
  END;
 END {pi_PutSingleContract};

 PRIVATE PROCEDURE RepName(): STRING[];
 BEGIN
  IF    (curContent = c_Full) | (curContent = c_BAll) | (curContent = c_bpFull) THEN
   RETURN "NPDM0";
  ELSIF (curContent = c_NotPaid) THEN
   RETURN "NPDM" + curAspect;
  ELSIF curContent = c_Pays THEN
   RETURN "Pays" + curAspect;
  ELSIF curContent = c_Blnc THEN
   RETURN "Blnc" + curAspect;
  ELSE
   L_General.CallUs(0);
  END;
 END {RepName};

 PRIVATE PROCEDURE intProceed(trgContent: tContent; trgAspect: tAspect; trgDate: DATE; trgTime: TIME; trgTimeCond: L_General.tTimeCond);
  VAR
   _BalanceType: P_Cntr.tBalanceType;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.SetCacheables(["Contract", "CntrPro", "FirmCtc", "FirmPro"]);

  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  OnDate:=trgDate;
  OnTime:=trgTime;

  curContent:=trgContent;
  curAspect :=trgAspect;
  IF curContent # c_bpFull THEN
   APP.Get().NewPrompt(RepName());
  END;
  L_AFM.MakeMultipleIndex("_MDoc", "MDocKind  : LIKE(MDoc.MDocKind);"+
                                   "MDoc      : LIKE(MDoc.MDoc);"+
                                   "Contract  : LIKE(Contract.Contract);"+
                                   "PDocKind  : LIKE(PDoc.PDocKind);"+
                                   "PDoc      : LIKE(PDoc.PDoc);"+
                                   "PDocDate  : DATE;"+
                                   "byPDMDSum : NUMERIC[2]",
                          "MDoc: MDocKind, MDoc, PDocKind, PDoc; Contract: Contract, MDocKind");
  IF    curAspect = a_All   THEN
   Title:=" ";
   IF NotClosedContractOnly() THEN
    SELECT(Contract, Closed, , 0, 1);
   ELSE
    SELECT(Contract, Leaf, , 1);
   END;

   WHILE OCCURE(Contract) DO
    pi_PutSingleContract();
    NEXT(Contract);
   END; (* WHILE OCCURE(Contract) ... *)
  ELSIF curAspect = a_Firm  THEN
   IF ~ACCESS(Firm) THEN
    CONFORM(^(GE_CURFILE()), Firm);
    L_General.Assert(OCCURE(Firm), " ⠭ ࠣ");
   END;
   Title:="ࠣ " + Firm.Firm + " " + Firm.Name;
   SELECT(Contract, Firm, , Firm.Firm, 1);
   WHILE OCCURE(Contract) DO
    IF ContractCond() THEN
     pi_PutSingleContract();
    END;
    NEXT(Contract);
   END; (* WHILE OCCURE(Contract) ... *)
  ELSIF curAspect = a_CntrT THEN
   L_General.Assert(ACCESS(CntrT), " ⠭  ஢");
   Title:=" ஢ " + CntrT.CntrT + " " + CntrT.Name;
   SELECT(Contract, CntrT, , CntrT.CntrT);
   WHILE OCCURE(Contract) DO
    IF ContractCond() THEN
     pi_PutSingleContract();
    END;
    NEXT(Contract);
   END; (* WHILE OCCURE(Contract) ... *)
  ELSIF curAspect = a_Cntr  THEN
   L_General.Assert(ACCESS(Contract), " ⠭ ");
   L_Cntr.CheckIsContract();
   IF curContent = c_Blnc THEN
    _BalanceType:=P_Cntr.GetBalanceType(Contract.Contract, L_DatTim.MAXDATE());
    IF _BalanceType # P_Cntr.ctbt_ByDeal THEN
     L_StdFrm.Inform(" ⨯     '"+L_Str.PoolItem(P_Cntr.ctbt_Pool, _BalanceType)+"'| 㤥 ᮤঠ 뢮 |"+
                     " ଠ  ᬮ   'ﭨ ᯮ  ᤥ'");
    END;
   END;
   Title:=" " + Contract.Contract + " " + Contract.Name;
   pi_PutSingleContract();
  END;
  IF (curContent = c_Full) | (curContent = c_bpFull) THEN
   DoExcel(RepName(), trgTimeCond);
  ELSIF curContent = c_BAll THEN
   DoBAll(RepName());
  ELSE
   L_XDoc.sl_Init("祭 㬥⮢");
   IF    curContent = c_NotPaid THEN
    NP_Proceed(RepName());
   ELSIF curContent = c_Pays THEN
    Ps_Proceed(RepName());
   ELSIF curContent = c_Blnc THEN
    Bl_Proceed(RepName());
   END;
   L_XDoc.sl_Done_woSurvey();
  END;
 END {intProceed};

 PRIVATE PROCEDURE Proceed(trgContent: tContent; trgAspect: tAspect);
 BEGIN
  intProceed(trgContent, trgAspect, SYSDATE(), SYSTIME(), L_General.tc_Entire);
 END {Proceed};

 PUBLIC PROCEDURE NPDM0_Full();
 BEGIN
  Proceed(c_Full, a_All);
 END {NPDM0_Full};

 PUBLIC PROCEDURE NPDM0_Full_ForTomorrow();
  CONST
   bpId = "NPDM0";
 BEGIN
  L_bp.Begin(bpId, "ﭨ ⮢  ᯥ⨢  ''", L_bp.t_Basis, L_General.tc_onDate);
  intProceed(c_bpFull, a_All, Memo.ud_cd(), 23:59, L_General.tc_onDate);
  L_bp.End();
 END {NPDM0_Full_ForTomorrow};

 PUBLIC PROCEDURE Pays_byAll();
 BEGIN
  Proceed(c_Pays, a_All);
 END {Pays_byAll};

 PUBLIC PROCEDURE BAll_byContract();
 BEGIN
  Proceed(c_BAll, a_Cntr);
 END {BAll_byContract};

 PUBLIC PROCEDURE NPDM_byContract();
 BEGIN
  Proceed(c_NotPaid, a_Cntr);
 END {NPDM_byContract};

 PUBLIC PROCEDURE Blnc_byContract();
 BEGIN
  Proceed(c_Blnc, a_Cntr);
 END {Blnc_byContract};

 PUBLIC PROCEDURE Pays_byContract();
 BEGIN
  Proceed(c_Pays, a_Cntr);
 END {Pays_byContract};

 PUBLIC PROCEDURE NPDM_byCntrT();
 BEGIN
  Proceed(c_NotPaid, a_CntrT);
 END {NPDM_byCntrT};

 PUBLIC PROCEDURE Pays_byCntrT();
 BEGIN
  Proceed(c_Pays, a_CntrT);
 END {Pays_byCntrT};

 PUBLIC PROCEDURE Blnc_byCntrT();
 BEGIN
  Proceed(c_Blnc, a_CntrT);
 END {Blnc_byCntrT};

 PUBLIC PROCEDURE NPDM_byFirm();
 BEGIN
  Proceed(c_NotPaid, a_Firm);
 END {NPDM_byFirm};

 PUBLIC PROCEDURE Pays_byFirm();
 BEGIN
  Proceed(c_Pays, a_Firm);
 END {Pays_byFirm};

 PRIVATE PROCEDURE pp_IncByDate(VAR ppValue: tValuesToPaymentPeriod;
                                     OnDate: DATE);
  VAR
   payD, payM, payY,
   onD,  onM,  onY  : NUMERIC[0];
 BEGIN
  UnPkDATE(OnDate, onD, onM, onY);
  UnPkDATE(PDoc.Date, payD, payM, payY);
  IF onY = payY THEN
   INC(ppValue[pp_Year], PDoc.Total);
   IF (onM DIV 3) = (payM DIV 3) THEN
    INC(ppValue[pp_Quarter], PDoc.Total);
   END;
   IF onM = payM THEN
    INC(ppValue[pp_Month], PDoc.Total);
   END;
  END;
  IF OnDate - PDoc.Date <= 360 THEN
   INC(ppValue[pp_360Days], PDoc.Total);
   IF OnDate - PDoc.Date <= 90 THEN
    INC(ppValue[pp_90Days], PDoc.Total);
    IF OnDate - PDoc.Date <= 30 THEN
     INC(ppValue[pp_30Days], PDoc.Total);
    END;
   END;
  END;
 END {pp_IncByDate};

 PRIVATE PROCEDURE pp_IncBySinglePDocKind(VAR ppValue: tValuesToPaymentPeriod; OnDate: DATE);
 BEGIN
  WHILE OCCURE(PDoc) DO
   PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   IF PDoc.Status # L_PDoc.st_Canceled THEN
    pp_IncByDate(ppValue, OnDate);
   END;
   NEXT(PDoc);
  END;
 END {pp_IncBySinglePDocKind};

 PRIVATE PROCEDURE PrintAgentLimSum(trgFirm: LIKE(Firm.Firm); D: DATE);
  VAR
   TSN     : LIKE(Staff.TSN);
   DocType,
   DocSer,
   DocNum,
   DocGiveS: STRING[];
   DocGiveD,
   DocExpD : DATE;
   totDebit,
   totCredit,
   CntrSum : NUMERIC[2];
   First   : SCAL[2];
 BEGIN
  First:=1;
  SELECT(Contract, Firm, , trgFirm, 1);
  WHILE OCCURE(Contract) DO
   PROMPT(Contract.Contract);
   IF L_DatTim.IsActive(D, Contract.Begin, Contract.Till) THEN
    P_Cntr.Get_FullOwnAgentInfo(Contract.Contract, D, TSN, DocType, DocSer, DocNum, DocGiveS, DocGiveD, DocExpD, CntrSum);
    IF ~!CntrSum THEN
     SETZERO(totDebit, totCredit);
     SELECT(PDocMDoc, Contract, , Contract.Contract);
     WHILE OCCURE(PDocMDoc) DO
      CONFORM(PDocMDoc, PDoc);
      IF PDoc.Status # L_PDoc.st_Canceled THEN
       IF L_PDoc.IsOutPDoc(PDocMDoc.PDocKind) THEN
        INC(totDebit, PDocMDoc.Total);
       ELSE
        INC(totCredit, PDocMDoc.Total);
       END;
      END;
      NEXT(PDocMDoc);
     END; (* WHILE OCCURE(PDocMDoc) ... *)
     IF First THEN
      MAKEPART(R, sp_AgentSumTop);
      First:=0;
     END;
     MAKEPART(R, sp_AgentSumLine, CntrSum, totDebit, totCredit);
    END;
   END;
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
 END {PrintAgentLimSum};

 PUBLIC PROCEDURE SumPays_byFirm();
  CONST
   RepName = "SumPD";
  VAR
   BegDate,
   sysDate : DATE;
   spDebit,
   spCredit: tValuesToPaymentPeriod;
   Period  : tPaymentPeriod;
   curFirm : LIKE(Firm.Firm);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(Firm);
  curFirm:=Firm.Firm;

  sysDate:=SYSDATE();
  BegDate:=Math.Min(L_DatTim.YearBeg(sysDate), sysDate - 360);
  SETZERO(spDebit, spCredit);
  SELECT(PDocKind, PDocKind);
  WHILE OCCURE(PDocKind) DO
   SETSEL(PDoc, PDKFirm, PDocKind.PDocKind, Firm.Firm);
   IF SRCINSEL(PDoc, GE, BegDate) THEN
    IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
     pp_IncBySinglePDocKind(spDebit, sysDate);
    ELSE
     pp_IncBySinglePDocKind(spCredit, sysDate);
    END;
   END;
   NEXT(PDocKind);
  END;

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, sp_Top, RepName, sysDate);
  FOR_EACH Period DO
   MAKEPART(R, sp_Line, L_Str.PoolItem(pp_Pool, Period), spDebit[Period], spCredit[Period]);
  END;

  PrintAgentLimSum(curFirm, sysDate);

  MAKEPART(R, sp_Bot);
  CLOSEREP(R);
 END {SumPays_byFirm};

 PUBLIC PROCEDURE Blnc_byFirm();
 BEGIN
  Proceed(c_Blnc, a_Firm);
 END {Blnc_byFirm};

END.
