(*
%Copyright   (c) Polak IT
%Author      20.05.2004 10:36:29 POLAK\ATS
%Purpose     訥 㬥  ਮ
%Type        report
%Specific    SYS
%Modified    13.03.2013 18:36:24 POLAK\GAV
%Environment
*)

 MODULE NRetD [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_XDoc, L_AFM, L_Dspt, P_Firm, FIO, L_Basis, L_Str, L_DatTim, DBD,
        L_MDoc, L_PDoc, L_ODoc, L_Cntr, L_bp, L_XDoc;

 CONST
  bpId = "NRetD";

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "㬥");
  L_Basis.wb_WrInQM(F, "㬥⍠");
  L_Basis.wb_WrInQM(F, "㬥⍠");
  L_Basis.wb_WrInQM(F, "㬥⒨");
  L_Basis.wb_WrInQM(F, "㬥₨");
  L_Basis.wb_WrInQM(F, "㬥₨");
  L_Basis.wb_WrInQM(F, "㬥⍮");
  L_Basis.wb_WrInQM(F, "㬥℠");
  L_Basis.wb_WrInQM(F, "㬥室멍");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "ﭨ ⠢");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "ࠢ६");
  L_Basis.wb_WrInQM(F, "⠢");
  L_Basis.wb_WrInQM(F, "⠢६");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "℮⠢");
  L_Basis.wb_WrInQM(F, "⍠");
  L_Basis.wb_WrInQM(F, "⥫");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "祭 ");
  L_Basis.wb_WrInQM(F, "㬥⌎");
  L_Basis.wb_WrInQM(F, "㬥⌎");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE FindRefPoint(_Type: LIKE(Dspt.Type);
                        _Dspt    : LIKE(Dspt.Dspt);
                        _RefPoint: LIKE(DsptTime.RefPoint)): SCAL[2];
 BEGIN
  RETURN SELECT(DsptTime, Dspt, _Type, _Dspt, _RefPoint) & LAST(DsptTime) & ~!DsptTime.Date;
 END {FindRefPoint};

 PRIVATE PROCEDURE wrRefPointDateTime(F        : STRING[];
                              _Type: LIKE(Dspt.Type);
                              _Dspt    : LIKE(Dspt.Dspt);
                              _RefPoint: LIKE(DsptTime.RefPoint));
 BEGIN
  IF SELECT(DsptTime, Dspt, _Type, _Dspt, _RefPoint) & LAST(DsptTime) THEN
   L_Basis.wb_WrDat(F, DsptTime.Date);
   L_Basis.wb_WrTim(F, DsptTime.Time);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
 END {wrRefPointDateTime};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
  VAR
   HasCntr         : SCAL[2];
   SingleRefDocId  : L_XDoc.tXDocId;
   SingleRefDocT   : L_XDoc.tXDocType;
   SingleRefDocKind: L_XDoc.tXDocKind;
   SingleRefDoc    : L_XDoc.tXDoc;
 BEGIN
  CONFORM(DsBdD, DsptDoc);
  CONFORM(DsptDoc, Dspt);

  L_Basis.wb_WrStr(F, L_Str.PoolItem(" | ", DsBdD.Type));
  CONFORM(Dspt, MyFirm);
  L_Basis.wb_WrScl(F, MyFirm.MyFirm);
  L_Basis.wb_WrStr(F, MyFirm.vzSign);

  P_Firm.AccessFirm(Dspt.Firm);
  L_Basis.wb_WrScl(F, Firm.Firm);
  L_Basis.wb_WrStr(F, Firm.Name);

  L_XDoc.PositionOnXDoc(DsptDoc.XDocId);
  L_Basis.wb_WrStr(F, DsptDoc.XDocId);
  L_Basis.wb_WrStr(F, L_ODoc.GetXDocName(DsptDoc.XDocId));
  L_Basis.wb_WrStr(F, L_ODoc.GetXDocName_Full(DsptDoc.XDocId));
  L_Basis.wb_WrStr(F, L_XDoc.Ref_FullName(DsptDoc.DocType));
  L_Basis.wb_WrStr(F, DsptDoc.DocKind);
  L_Basis.wb_WrStr(F, L_ODoc.GetXDocKindName(DsptDoc.XDocId));
  L_Basis.wb_WrScl(F, DsptDoc.Doc);
  L_Basis.wb_WrDat(F, L_ODoc.GetXDocDate(DsptDoc.XDocId));
  L_Basis.wb_WrStr(F, L_ODoc.GetXDocSrcNbr(DsptDoc.XDocId));

  IF    DsptDoc.DocType = L_XDoc.xdt_PDoc     THEN
   HasCntr:=0;
   SELECT(PDocMDoc, PDoc, , PDoc.PDocKind, PDoc.PDoc);
   WHILE OCCURE(PDocMDoc) DO
    IF ~!PDocMDoc.Contract THEN
     IF HasCntr & (PDocMDoc.Contract # Contract.Contract) THEN
      HasCntr:=0;
      LAST(PDocMDoc);
     ELSE
      HasCntr:=1;
      CONFORM(PDocMDoc, Contract);
     END;
    END;
    NEXT(PDocMDoc);
   END; (* WHILE OCCURE(PDocMDoc) ... *)
  ELSIF DsptDoc.DocType = L_XDoc.xdt_MDoc     THEN
   CONFORM(MDoc, Contract);
   HasCntr:=OCCURE(Contract);
  ELSIF DsptDoc.DocType = L_XDoc.xdt_Contract THEN
   HasCntr:=1;
  ELSIF DsptDoc.DocType = L_XDoc.xdt_ODoc     THEN
   HasCntr:=0;
   SingleRefDocId:=L_XDoc.GetSingleRefToXDocId(L_XDoc.curXDocId(L_XDoc.xdt_ODoc));
   IF ~!SingleRefDocId THEN
    L_XDoc.DecodeXDocId(SingleRefDocId, SingleRefDocT, SingleRefDocKind, SingleRefDoc);
    IF SingleRefDocT = L_XDoc.xdt_Contract THEN
     L_XDoc.PositionOnXDoc(SingleRefDocId);
     HasCntr:=1;
    END;
   END;
  ELSIF DsptDoc.DocType = L_XDoc.xdt_RWayS     THEN
   HasCntr:=0;
  ELSIF DsptDoc.DocType = L_XDoc.xdt_Packet     THEN
   HasCntr:=0;
  ELSE
   L_General.CallUs(0);
  END;

  L_Basis.wb_WrScl(F, DsBdD.Instance);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Dspt.InstancePool, DsBdD.Instance));
  L_Basis.wb_WrScl(F, DsBdD.CopyCnt);
  L_Basis.wb_WrScl(F, Dspt.Dspt);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Dspt.st_Pool, Dspt.Status));

  L_Basis.wb_WrDat(F, DsBdD.SendD);
  L_Basis.wb_WrTim(F, DsBdD.SendT);
  L_Basis.wb_WrDat(F, DsBdD.DelivD);
  L_Basis.wb_WrTim(F, DsBdD.DelivT);
  L_Basis.wb_WrDat(F, DsBdD.NoticeD);
  L_Basis.wb_WrTim(F, DsBdD.NoticeT);

  L_Basis.wb_WrNum(F, SYSDATE()-DsBdD.DelivD, 0);
  IF ~!DsBdD.NoticeD THEN
   L_Basis.wb_WrNum(F, SYSDATE()-DsBdD.NoticeD, 0);
  ELSE
   L_Basis.wb_WrNum(F, SYSDATE()-DsBdD.DelivD, 0);
  END;
  L_Basis.wb_WrStr(F, Dspt.Recip);
  IF HasCntr THEN
   L_Basis.wb_WrScl(F, Contract.Contract);
   L_Basis.wb_WrStr(F, Contract.Name);
   L_Basis.wb_WrStr(F, Contract.SrcNbr);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", DsBdD.DLPassed));

  P_Firm.PositionOnMyFirm(L_XDoc.GetMyFirmByXDocId(DsptDoc.XDocId));
  L_Basis.wb_WrScl(F, MyFirm.MyFirm);
  L_Basis.wb_WrStr(F, MyFirm.vzSign);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE Create_DsNdD();
 BEGIN
  CreateFILE(DsBdD, "", "᮪ 祭 㬥⮢", "");
  CreateFIELD(DsBdD, Type, LIKE(DsptDoc.Type), "", "", "", " ࠢ", "");
  CreateFIELD(DsBdD, Dspt,     LIKE(DsptDoc.Dspt),     "", "", "", "ࠢ", "");
  CreateFIELD(DsBdD, Nbr,      LIKE(DsptDoc.Nbr),      "", "", "", " ப", "");
  CreateFIELD(DsBdD, XDocId,   L_XDoc.tXDocId,         "", "", "", "䨪 㬥", "");
  CreateFIELD(DsBdD, Instance, LIKE(DsptDoc.Instance), "", "", "", "", "");
  CreateFIELD(DsBdD, CopyCnt,  L_XDoc.tCopyCnt,        "", "", "", "", "");
  CreateFIELD(DsBdD, SendD,    DATE,                   "", "", "", "", "");
  CreateFIELD(DsBdD, SendT,    TIME,                   "", "", "", "", "");
  CreateFIELD(DsBdD, DelivD,   DATE,                   "", "", "", "", "");
  CreateFIELD(DsBdD, DelivT,   TIME,                   "", "", "", "", "");
  CreateFIELD(DsBdD, NoticeD,  DATE,                   "", "", "", "", "");
  CreateFIELD(DsBdD, NoticeT,  TIME,                   "", "", "", "", "");
  CreateFIELD(DsBdD, DLPassed, SCAL[2],                "", "", "", "祭 ", "");

  CreateINDEXandLINK(DsBdD, DsBdD, PLURAL, DsptDoc, Dspt, USER, "", "", Type, Dspt, Nbr, CopyCnt);
  CreateINDEX       (DsBdD, XDocId, PLURAL,                     "", "", XDocId, Type, Instance, CopyCnt, DelivD, DelivT);

  SetVersionOfFILE(DsBdD, 0003);
  L_AFM.AF_CreateTemp("DsBdD", "DsBdD");
 END {Create_DsNdD};

 PRIVATE PROCEDURE MakeTempFile(trgFirm: LIKE(Firm.Firm));
  VAR
   trgOwn        : LIKE(DsptDoc.Own);
   DeadlinePassed: SCAL[2];
 BEGIN
  Create_DsNdD();
  SELECT(Dspt, DsptFirm);
  WHILE OCCURE(Dspt) DO
   NARROWSEL(Dspt, Type);
   IF    Dspt.Type = L_Dspt.t_Outgoing THEN
    trgOwn:=L_Dspt.d_Own;
   ELSIF Dspt.Type = L_Dspt.t_Incoming THEN
    trgOwn:=L_Dspt.d_Alien;
   ELSE
    L_General.CallUs(0);
   END;
   WHILE OCCURE(Dspt) DO
    NARROWSEL(Dspt, Firm);
    IF !trgFirm | (Dspt.Firm = trgFirm) THEN
     WHILE OCCURE(Dspt) DO
      IF Dspt.Status # L_Dspt.st_Canceled THEN
       SELECT(DsptDoc, Own, , trgOwn, Dspt.Type, Dspt.Dspt);
       WHILE OCCURE(DsptDoc) DO
        PROMPT("஢ " + DsptDoc.Type + " " + DsptDoc.Dspt + " " + DsptDoc.Nbr);
        DEFAULT(DsBdD);
        IF FindRefPoint(DsptDoc.Type, DsptDoc.Dspt, L_Dspt.rp_Send) THEN
         DsBdD.SendD:=DsptTime.Date;
         DsBdD.SendT:=DsptTime.Time;
        END;
        IF FindRefPoint(DsptDoc.Type, DsptDoc.Dspt, L_Dspt.rp_Delivery) |
           FindRefPoint(DsptDoc.Type, DsptDoc.Dspt, L_Dspt.rp_AlnCSProcess) |
           FindRefPoint(DsptDoc.Type, DsptDoc.Dspt, L_Dspt.rp_OwnCS_AdviceReceive) |
           FindRefPoint(DsptDoc.Type, DsptDoc.Dspt, L_Dspt.rp_AdviceReceive) THEN
         DsBdD.DelivD:=DsptTime.Date;
         DsBdD.DelivT:=DsptTime.Time;
        END;
        IF FindRefPoint(DsptDoc.Type, DsptDoc.Dspt, L_Dspt.rp_DelayNotice) THEN
         DsBdD.NoticeD:=DsptTime.Date;
         DsBdD.NoticeT:=DsptTime.Time;
        END;
        DeadlinePassed:=0;
        IF    ~!DsBdD.NoticeD THEN
         DeadlinePassed:=(SYSDATE() - DsBdD.NoticeD) > 21;
        ELSIF ~!DsBdD.DelivD THEN
         DeadlinePassed:=(SYSDATE() - DsBdD.DelivD)  > 21;
        ELSIF ~!DsBdD.SendD THEN
         DeadlinePassed:=(SYSDATE() - DsBdD.SendD)   > 28;
        END;
        DsBdD.Type:=DsptDoc.Type;
        DsBdD.Dspt    :=DsptDoc.Dspt;
        DsBdD.Nbr     :=DsptDoc.Nbr;
        DsBdD.XDocId  :=DsptDoc.XDocId;
        DsBdD.Instance:=DsptDoc.Instance;
        DsBdD.CopyCnt :=DsptDoc.CopyCnt;
        DsBdD.DLPassed:=DeadlinePassed;
        INSERT(DsBdD);
        NEXT(DsptDoc);
       END; (* WHILE OCCURE(DsptDoc) ... *)
      END; (* IF Dspt.Status # L_Dspt.st_Canceled *)
      NEXT(Dspt);
     END; (* WHILE OCCURE(Dspt) *)
    END; (* IF !trgFirm | (Dspt.Firm = trgFirm) *)
    NEXTINEXTENDEDSEL(Dspt, Firm);
   END; (* WHILE OCCURE(Dspt) *)
   NEXTINEXTENDEDSEL(Dspt, Type);
  END; (* WHILE OCCURE(Dspt) *)
 END {MakeTempFile};

 PRIVATE PROCEDURE ReverseType(_Type: LIKE(DsptDoc.Type)): LIKE(DsptDoc.Type);
 BEGIN
  IF    _Type = L_Dspt.t_Incoming THEN   RETURN L_Dspt.t_Outgoing;
  ELSIF _Type = L_Dspt.t_Outgoing THEN   RETURN L_Dspt.t_Incoming;
  ELSE
   L_General.CallUs(0);
  END;
 END {ReverseType};

 PRIVATE PROCEDURE RemoveOldAndRecivedDoc();
  VAR
   Need: SCAL[2];
 BEGIN
  SELECT(DsBdD, XDocId);
  WHILE OCCURE(DsBdD) DO
   CHANGESEL(DsBdD, XDocId, , DsBdD.XDocId, DsBdD.Type, DsBdD.Instance);
   LAST(DsBdD);
   WHILE PREV(DsBdD) DO
    REMOVE(DsBdD);
   END;
   LAST(DsBdD);
   CHANGESEL(DsBdD, XDocId);
   IF !DsBdD.DelivD THEN
    REMOVE(DsBdD);
   ELSE
    NEXT(DsBdD);
   END;
  END; (* WHILE OCCURE(DsBdD) ... *)

  SELECT(DsBdD, DsBdD);
  WHILE OCCURE(DsBdD) DO
   PROMPT("஢ઠ " + DsBdD.XDocId);
   Need:=1;

   SELECT(DsptDoc, XDocId, , DsBdD.XDocId, DsBdD.Type);
   WHILE Need & OCCURE(DsptDoc) DO
    Need:=(DsptDoc.Instance = DsBdD.Instance) |
          L_Dspt.XDocMustHaveCopyCnt(DsBdD.XDocId) & (DsptDoc.CopyCnt <= DsBdD.CopyCnt);
    NEXT(DsptDoc);
   END; (* WHILE OCCURE(DsptDoc) ... *)

   SELECT(DsptDoc, XDocId, , DsBdD.XDocId, ReverseType(DsBdD.Type));
   WHILE Need & OCCURE(DsptDoc) DO
    Need:=(DsptDoc.Instance # DsBdD.Instance) |
          L_Dspt.XDocMustHaveCopyCnt(DsBdD.XDocId) & (DsptDoc.CopyCnt # DsBdD.CopyCnt);
    NEXT(DsptDoc);
   END; (* WHILE OCCURE(DsptDoc) ... *)

   IF Need THEN
    IF    L_XDoc.ExtractXDocType(DsBdD.XDocId) = L_XDoc.xdt_PDoc     THEN
     L_XDoc.PositionOnXDoc(DsBdD.XDocId);
     Need:=PDoc.Status # L_PDoc.st_Canceled;
    ELSIF L_XDoc.ExtractXDocType(DsBdD.XDocId) = L_XDoc.xdt_MDoc     THEN
     L_XDoc.PositionOnXDoc(DsBdD.XDocId);
     Need:=MDoc.Status # L_MDoc.st_Canceled;
    ELSIF L_XDoc.ExtractXDocType(DsBdD.XDocId) = L_XDoc.xdt_ODoc     THEN
     L_XDoc.PositionOnXDoc(DsBdD.XDocId);
     Need:=ODoc.Status # L_ODoc.ods_Canceled;
    ELSIF L_XDoc.ExtractXDocType(DsBdD.XDocId) = L_XDoc.xdt_Contract THEN
     L_XDoc.PositionOnXDoc(DsBdD.XDocId);
     Need:=Contract.Begin < Contract.Till;
    ELSIF L_XDoc.ExtractXDocType(DsBdD.XDocId) = L_XDoc.xdt_RWayS THEN
     Need:=1;
    ELSIF L_XDoc.ExtractXDocType(DsBdD.XDocId) = L_XDoc.xdt_Packet THEN
     Need:=1;
    END;
   END;
   IF Need THEN
    NEXT(DsBdD);
   ELSE
    REMOVE(DsBdD);
   END;
  END; (* WHILE OCCURE(DsBdD) ... *)
 END {RemoveOldAndRecivedDoc};

 PRIVATE PROCEDURE intNRetD(trgFirm: LIKE(Firm.Firm));
 BEGIN
  MakeTempFile(trgFirm);
  RemoveOldAndRecivedDoc();
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
  SELECT(DsBdD, DsBdD);
  WHILE OCCURE(DsBdD) DO
   PROMPT(" " + DsBdD.XDocId);
   MakePart("R");
   NEXT(DsBdD);
  END; (* WHILE OCCURE(DsBdD) ... *)
  FIO.Close(R);
 END {intNRetD};

 PUBLIC PROCEDURE NRetD();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "訥 㬥", L_bp.t_Basis, L_General.tc_inIntvl);
  intNRetD("");
  L_bp.End();
 END {NRetD};

 PUBLIC PROCEDURE NRetD_ByFrim();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Firm), " ⠭ ࠣ");
  intNRetD(Firm.Firm);
  L_Basis.PlayMakedRunTimeRep(bpId, L_General.tc_inIntvl, "訥 㬥  ࠣ " + Firm.Firm, 0);
 END {NRetD_ByFrim};

END.
