(*
%Copyright   (c) Polak Computer System
%Author      27.04.1999 10:47:38 BOR
%Purpose     ஫ 䨪樨  ᢮
%Type        control
%Specific    AP
%Modified    29.08.2014 12:30:30 POLAK\San
%Environment
*)

 MODULE ObjPro [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

(*
  :
:
------------------------------------------------------------------------------------------------------------
|     |⠢                          |஢                   |                        |
|-----|---------------------------------|---------------------------------|--------------------------------|
|   |ANY_OnSetSubWindow               |ANY_OnSetSubWindow               |ANY_OnSetSubWindow              |
|     |                                 |Any_0_OnReposition               |Any_0_OnReposition              |
|     |Any_OnBeforeInsert               |Any_OnBeforeEdit                 |Any_OnBeforeDelete              |
|     |Any_0_OnReposition               |                                 |                                |
|-----|---------------------------------|---------------------------------|--------------------------------|
|᫥|Any_OnAfterInsert                |Any_OnAfterEdit                  |                          |
------------------------------------------------------------------------------------------------------------

: (祭 Local - StaffPro, ManPro, CarPro, ...)
------------------------------------------------------------------------------------------------------------
|     |⠢                          |஢                   |                        |
|-----|---------------------------------|---------------------------------|--------------------------------|
|   |PropChoice                       |                                 |                                |
|     |GetPrvPropertyValue              |                                 |                                |
|     |PropertyModificationAllowed      |PropertyModificationAllowed      |PropertyModificationAllowed     |
|     |---------------------------------|---------------------------------|--------------------------------|
|     |                                 |GetSubWindowName                 |GetSubWindowName                |
|     |                                 |P_*.OnReposition                 |P_*.OnReposition                |
|     |                                 |P_*.SetDataInForm             |P_*.SetDataInForm            |
|     |                                 |SetDataInStandartWindow          |SetDataInStandartWindow         |
|     |---------------------------------|---------------------------------|--------------------------------|
|     |P_*.GetPool4DocGiveS             |P_*.GetPool4DocGiveS             |CheckBackDateModificationAllowed|
|     |                                 |PropertyModificationAllowed      |                                |
|     |                                 |CheckBackDateModificationAllowed |                                |
|     |GetDefaultPropertyDate           |                                 |                                |
|     |SetSingleLineProperty            |SetSingleLineProperty            |                                |
|     |P_*.CommonOnBeforeInsert         |P_*.CommonOnBeforeEdit           |P_*.CommonOnBeforeDelete        |
|     |P_*.Local_OnBeforeInsert      |P_*.Local_OnBeforeEdit        |P_*.Local_OnBeforeDelete     |
|     |E_Prop.OnBeforeInsert            |E_Prop.OnBeforeEdit              |E_Prop.OnBeforeDelete           |
|     |P_*.CanHaveProp                  |                                 |                                |
|     |                                 |                                 |                                |
|     |---------------------------------|---------------------------------|--------------------------------|
|     |GetSubWindowName                 |                                 |                                |
|     |P_*.OnReposition                 |                                 |                                |
|     |P_*.SetDataInForm             |                                 |                                |
|     |SetDataInStandartWindow          |                                 |                                |
|-----|---------------------------------|---------------------------------|--------------------------------|
|᫥|P_*.GetDataFromForm              |P_*.GetDataFromForm              |                                |
|     |P_*.CanHavePro                   |P_*.CanHavePro                   |                                |
|     |P_*.Check  P_*.Local_Check    |P_*.Check  P_*.Local_Check    |                          |
|     |P_*.CommonOnAfterInsert          |P_*.CommonOnAfterEdit            |                                |
|     |P_*.Local_OnAfterInsert       |P_*.Local_OnAfterEdit         |                                |
|     |E_Prop.OnAfterInsert             |E_Prop.OnAfterEdit               |                                |
|     |CheckBackDateModificationAllowed |CheckBackDateModificationAllowed |                                |
------------------------------------------------------------------------------------------------------------
*)

 IMPORT Memo, Str, DBD, L_General, L_DatTim, L_Prop, L_Events, L_StdFrm,
        L_Str, L_SES, L_DBD, L_WDO, L_AcsPnt, L_r2r, L_AR, L_XDoc,
        L_Pool, E_Prop,

        P_Staff,  P_Car,    P_Mark,  P_Route,   P_EDOL,  P_Officer, P_EDOKnd,
        P_Math,   P_Man,    P_MDoc,  P_Firm,    P_Union, P_Sort,    P_PDoc,
        P_Cntr,   P_Post,   P_AveP,  P_OwnData, P_DsptM, P_CUC,     P_Storage,
        P_Exit,   P_MyFirm, P_TKind, P_Rpr,     P_CI,    P_ODoc,    P_MCList,
        P_Column, P_MyPlc,  P_MySite, P_MarkG;

 PRIVATE PERMANENT VAR
  scrc_Property       : LIKE(Property.Property);
  scrc_Value          : STRING[];
  pv_InsertingProperty: LIKE(Property.Property);

 PRIVATE TYPE
  pc_ShowType =SCAL[3];

 PRIVATE CONST
  InsertByWDO = 0;

  pc_ShowVisible = 0;
  pc_ShowAll     = 1;
  pc_ShowHidden  = 2;

 PRIVATE VAR
  pc_ChangeVis  : SCAL[2];
  pc_Prompt     : PROMPT_LINE;
  pc_MdfAlwdPool: STRING[][2];

 PRIVATE PROCEDURE GetModuleName(curProperty     : LIKE(Property.Property);
                                 curObject       : LIKE(Property.Object);
                                 SystemModuleOnly: SCAL[2]): STRING[];
 BEGIN
  IF SystemModuleOnly | ~L_Prop.IsLocalProperty(curProperty) THEN
   RETURN L_Prop.GetModuleName(curObject);
  ELSE
   RETURN "E_Prop";
  END;
 END {GetModuleName};

 PRIVATE PROCEDURE intGetQualifiedProcRef(curProperty     : LIKE(Property.Property);
                                          Name,
                                          AltName         : STRING[];
                                          SystemModuleOnly: SCAL[2]): PROC;
  VAR
   PrcName1,
   PrcName2 : STRING[];
   Local1,
   Local2: PROC;
 BEGIN
  SAVE(Property);
  L_Prop.PositionOnProperty(curProperty);
  PrcName1:=GetModuleName(curProperty, Property.Object, SystemModuleOnly)  + "." + Name;
  Local1:=PROCREF(^PrcName1);
  IF ~!AltName THEN
   PrcName2:=GetModuleName(curProperty, Property.Object, SystemModuleOnly) + "." + AltName;
   Local2:=PROCREF(^PrcName2);
   L_General.CallUs(!Local1 | !Local2);
  ELSE
   SETEMPTY(Local2);
  END;
  RESTORE(Property);
  IF ~!Local1 THEN
   RETURN Local1;
  ELSE
   RETURN Local2;
  END;
 END {intGetQualifiedProcRef};

 PRIVATE PROCEDURE GetQualifiedProcRef(curProperty: LIKE(Property.Property); Name, AltName: STRING[]): PROC;
 BEGIN
  RETURN intGetQualifiedProcRef(curProperty, Name, AltName, 0);
 END {GetQualifiedProcRef};

 PRIVATE PROCEDURE IsInsidePropertyObject(curProperty: LIKE(Property.Property)): SCAL[2];
  VAR
   Win      : FORM_WINDOW;
   trgObject: LIKE(Property.Object);
 BEGIN
  SAVE(Property);
  SEARCH(Property, Property, , curProperty);
  trgObject:=Property.Object;
  RESTORE(Property);

  IF L_Prop.IsCntrProObj(trgObject) & (RTI.Get().CurWindow.OriginalName = "FrmManCn") THEN
   RETURN 1;
  END;

  Win:=RTI.Get().CurWindow;
  WHILE ~!Win DO
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    IF DBD.LendFile(^(GE_CURFILE())) = GE_WZD_MASTER(Win.Name, 0) THEN
     IF ~!Win.Zones(0).Processes(0) &
        ((Win.Zones(0).Processes(0).Kind = FORM_PROCESS.Kind_Insert) |
         (Win.Zones(0).Processes(0).Kind = FORM_PROCESS.Kind_Edit)) THEN
      RETURN 1;
     END;
    END;
   EXCEPT
   ON Exc: Exc_RunTime DO
    IF Exc.ErrorCode # L_General.ec_rt_NoSuchZoneInWindow THEN
     RAISE();
    END;
   END; (* TRY *)
   IF ~!Win.ParentZone THEN
    Win:=Win.ParentZone.Window;
   ELSE
    SETEMPTY(Win);
   END;
  END;
  RETURN 0;
 END {IsInsidePropertyObject};

 PRIVATE PROCEDURE PropertyModificationAllowed(    curProperty: LIKE(Property.Property);
                                               VAR Msg        : STRING[]): SCAL[2];
  VAR
   Local : PROC;
   pma   : L_Prop.tModifAllowedCondition;
   objDsc: STRING[];
 BEGIN
  SETEMPTY(Msg);
  Local:=intGetQualifiedProcRef(curProperty, "PropertyModificationAllowed", "", 0);
  IF ~!Local THEN
   pma:=Local(curProperty);
   IF    (pma = L_Prop.mac_Inside) & ~IsInsidePropertyObject(curProperty) THEN
    SAVE(Property);
    SEARCH(Property, Property, , curProperty);
    objDsc:=L_Str.PoolItem(L_Prop.po_Pool_Genitive, Property.Object);
    Msg:="ଫ ᢮⢠ " + curProperty + " ᪠ ⮫쪮  䨪樨 " + objDsc +
         L_StdFrm.HR() +
         " ᭠砫   ।஢ " + objDsc + ",  ⥬ ଫ ᢮⢮" +
         L_StdFrm.HR() +
         ' ᬮ ᢮⢠ ᯮ "Shift+Enter"';
    RESTORE(Property);
   ELSIF pma = L_Prop.mac_Old THEN
    Msg:="⢮ " + curProperty + " ५  䨪樨  ";
   ELSIF pma = L_Prop.mac_AutoOnly THEN
    Msg:="䨪 ᢮⢠ " + curProperty + " ந ⮫쪮 ⮬᪨";
   END;
  END;
  RETURN !Msg;
 END {PropertyModificationAllowed};

 PRIVATE PROCEDURE IsMultilineProperty(curProperty: LIKE(Property.Property)): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=intGetQualifiedProcRef(curProperty, "IsMultilineProperty", "", 0);
  RETURN ~!Local & Local(curProperty);
 END {IsMultilineProperty};

 PRIVATE PROCEDURE SetSingleLineProperty(curProperty: LIKE(Property.Property));
  VAR
   IsMultiline: SCAL[2];
   curObject  : L_Prop.tProObject;
 BEGIN
  IF DBD.FieldExist(^(GE_CURFILE()), "PropRow") THEN
   SAVE(Property);
   L_Prop.PositionOnProperty(curProperty);
   curObject:=Property.Object;
   RESTORE(Property);
   IF ~L_Prop.IsEDOLProObj(curObject) THEN
    IsMultiline:=IsMultilineProperty(curProperty);
    IF ~IsMultiline THEN
     TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
      ^(GE_CURFILE()).PropRow:=00;
      REPLACE(^(GE_CURFILE()));
     EXCEPT
     ON Exc: Exc_RunTime DO
      IF L_General.IsUniquenessViolationException(Exc) THEN
       L_General.Error("  ᢮⢮ "+curProperty);
      ELSE
       RAISE();
      END;
     END; (* TRY *)
    END;
    IF ~!RTI.Get().CurZone.Fields(GE_CURFILE()+".PropRow") THEN
     RTI.Get().CurZone.Fields(GE_CURFILE()+".PropRow").Modifiable:=IsMultiline;
    END;
   END;
  END;
 END {SetSingleLineProperty};

 PRIVATE PROCEDURE pc_Property2Show(ShowAll: pc_ShowType): SCAL[2];
 BEGIN
  IF    ShowAll = pc_ShowAll THEN
   RETURN 1;
  ELSIF ShowAll = pc_ShowHidden THEN
   RETURN SEARCH(aoProLst, AcsObj, L_General.curUSER, Property.Property) & (aoProLst.Visible = 0) |
          ~Property.IsUsed & ~OCCURE(aoProLst);
  ELSIF ShowAll = pc_ShowVisible THEN
   RETURN SEARCH(aoProLst, AcsObj, L_General.curUSER, Property.Property) & (aoProLst.Visible = 1) |
          Property.IsUsed & ~OCCURE(aoProLst);
  ELSE
   L_General.CallUs(0);
  END;
 END {pc_Property2Show};

 PRIVATE PROCEDURE pc_PreparePools(curProObj: L_Prop.tProObject; ShowAll: pc_ShowType; trgTagValue: STRING[]; VAR PropsPool, TagsPool, Hidden: STRING[]);
  VAR
   suf,
   S        : STRING[];
   mod100,
   mod10,
   i        : NUMERIC[0];
   cntHidden: NUMERIC[0];
 BEGIN
  cntHidden:=0;
  SETEMPTY(PropsPool);
  IF !trgTagValue THEN
   SETEMPTY(TagsPool);
  END;
  SELECT(Property, PropObj, , curProObj);
  WHILE OCCURE(Property) DO
   IF !trgTagValue | Str.Match(Property.Tag, "*" + trgTagValue + "*") THEN
    IF pc_Property2Show(ShowAll) THEN
     INC(PropsPool, Property.Property + " " + Property.Name + "|");
    ELSE
     INC(cntHidden);
    END;
    IF !trgTagValue THEN
     i:=0;
     LOOP
      S:=Str.Item(Property.Tag, ";", i);
      IF !S THEN
       EXIT;
      END;
      IF !L_Str.PositionInPool(TagsPool, S) THEN
       INC(TagsPool, S + "|");
      END;
      INC(i);
     END; (* LOOP *)
    END; (* IF !trgTagValue *)
   END;
   NEXT(Property);
  END;
  IF !trgTagValue THEN
   IF ~!TagsPool THEN
    TagsPool:="" + "|" + TagsPool;
   ELSE
    TagsPool:="" + "|";
   END;
  END;
  IF ShowAll = pc_ShowAll THEN
   SETEMPTY(Hidden);
  ELSE
   mod100:=cntHidden MOD 100;
   mod10 :=cntHidden MOD 10;
   IF    (mod100 > 10) & (mod100 < 20) THEN SETEMPTY(suf);
   ELSIF mod10 = 1 THEN suf:= "";
   ELSIF mod10 = 2 THEN suf:= "";
   ELSIF mod10 = 3 THEN suf:= "";
   ELSIF mod10 = 4 THEN suf:= "";
   ELSE  SETEMPTY(suf);
   END;
   Hidden:=" " + L_Str.IntStr(cntHidden) + " ᢮" + suf;
  END;
 END {pc_PreparePools};

 PRIVATE PROCEDURE pc_GetVisible(curProperty: LIKE(Property.Property)): LIKE(aoProLst.Visible);
  VAR
   Result: LIKE(aoProLst.Visible);
 BEGIN
  IF SEARCH(aoProLst, AcsObj, L_General.curUSER, curProperty) THEN
   Result:=aoProLst.Visible;
  ELSE
   SEARCH(Property, Property, , curProperty);
   Result:=Property.IsUsed;
  END;
  RETURN Result;
 END {pc_GetVisible};

 PRIVATE PROCEDURE pc_GetProperty(PropsPool: STRING[]; curProp: NUMERIC[0]): LIKE(Property.Property);
 BEGIN
  RETURN Str.Item(L_Str.PoolItem(PropsPool, curProp), " ", 0);
 END {pc_GetProperty};

 PRIVATE PROCEDURE pc_GetMdfAlwd(trgProperty: LIKE(Property.Property)): STRING[];
  VAR
   p: NUMERIC[0];
 BEGIN
  p:=L_Str.PositionInPool(pc_MdfAlwdPool[1], trgProperty);
  RETURN L_Str.AnyItem(pc_MdfAlwdPool[0], "|", p);
 END {pc_GetMdfAlwd};

 PRIVATE PROCEDURE pc_GetModificationAllowed(curProperty: LIKE(Property.Property)): STRING[];
  VAR
   Result: STRING[];
   Local : PROC;
   pma   : L_Prop.tModifAllowedCondition;
   objDsc: STRING[];
 BEGIN
  SETEMPTY(Result);
  Local:=intGetQualifiedProcRef(curProperty, "PropertyModificationAllowed", "", 0);
  IF ~!Local THEN
   pma:=Local(curProperty);
   IF    pma = L_Prop.mac_Inside THEN
    SAVE(Property);
    SEARCH(Property, Property, , curProperty);
    objDsc:=L_Str.PoolItem(L_Prop.po_Pool_Genitive, Property.Object);
    Result:="ଫ ᢮⢠ ᪠ ⮫쪮  䨪樨 " + objDsc;
    RESTORE(Property);
   ELSIF pma = L_Prop.mac_Old THEN
    Result:="⢮ ५  䨪樨  ";
   ELSIF pma = L_Prop.mac_AutoOnly THEN
    Result:="䨪 ᢮⢠ ந ⮫쪮 ⮬᪨";
   END;
  END;
  RETURN Result;
 END {pc_GetModificationAllowed};

 PRIVATE PROCEDURE pc_onChangeProc(VarName : STRING[];
                                   PrvValue: ANYTYPE;
   
                                   VAR PropsPool : STRING[];
                                   VAR curProp   : NUMERIC[0];
   
                                   VAR TagsPool  : STRING[];
                                   VAR curTag    : NUMERIC[0];
   
                                   VAR curVisible: NUMERIC[0];
   
                                   VAR ShowAll   : pc_ShowType;
                                   VAR Hidden    : STRING[];
                                   VAR MdfAlwd   : STRING[]);
  VAR
   Redraw     : SCAL[2];
   trgProperty: LIKE(Property.Property);
   curProObj  : L_Prop.tProObject;
 BEGIN
  IF ~!pc_Prompt THEN
   SETEMPTY(pc_Prompt);
  END;
  Redraw :=0;
  SETEMPTY(trgProperty);
  SEARCH(Property, Property, , pc_GetProperty(PropsPool, curProp));
  curProObj:=Property.Object;
  IF    VarName = "curProp" THEN
   curVisible:=pc_GetVisible(Property.Property);
   MdfAlwd   :=pc_GetMdfAlwd(Property.Property);
  ELSIF VarName = "curTag" THEN
   Redraw:=1;
   IF (curTag = 0) | Str.Match(Property.Tag, "*" + L_Str.PoolItem(TagsPool, curTag) + "*") THEN
    trgProperty:=Property.Property;
   END;
  ELSIF VarName = "ShowAll" THEN
   Redraw:=1;
   IF pc_Property2Show(ShowAll) THEN
    trgProperty:=Property.Property;
   END;
  ELSIF VarName = "curVisible" THEN
   pc_ChangeVis:=1;
   REP(aoProLst, AcsObj, , L_General.curUSER, Property.Property,
       aoProLst.Visible, curVisible);
   IF ((ShowAll # pc_ShowHidden) & (curVisible = 0)) |
      ((ShowAll = pc_ShowHidden) & (curVisible = 1)) THEN
    IF pc_Property2Show(ShowAll) THEN
     TOOLTIP("⢮ " + Property.Property + " '" + Property.Name + "' 㤥 ");
    ELSE
     Redraw:=1;
     IF ShowAll = pc_ShowHidden THEN
      TOOLTIP("⢮ " + Property.Property + " '" + Property.Name + "' 㤥   ଠ쭮 ०");
     ELSE
      TOOLTIP("⢮ " + Property.Property + " '" + Property.Name + "' ");
     END;
     trgProperty:=pc_GetProperty(PropsPool, curProp+1);
     IF !trgProperty THEN
      IF curProp > 0 THEN
       trgProperty:=pc_GetProperty(PropsPool, curProp-1);
      ELSE
       TOOLTIP(" 뫨  ᢮⢠. ⠭ ० ⮡ࠦ ''");
       ShowAll:=pc_ShowAll;
       pc_PreparePools(curProObj, ShowAll, L_Str.PoolItem(TagsPool, curTag), PropsPool, TagsPool, Hidden);
      END;
     END;
    END;
   END;
  END;
  IF Redraw THEN
   IF curTag = 0 THEN pc_PreparePools(curProObj, ShowAll,                               "", PropsPool, TagsPool, Hidden);
   ELSE               pc_PreparePools(curProObj, ShowAll, L_Str.PoolItem(TagsPool, curTag), PropsPool, TagsPool, Hidden);
   END;
   IF !PropsPool THEN
    IF ShowAll # pc_ShowAll THEN
     TOOLTIP(" ⥪饬 ० ⮡ࠦ    ਣ ᢮⢠. ⠭ ० ⮡ࠦ ''");
     ShowAll:=pc_ShowAll;
     IF curTag = 0 THEN pc_PreparePools(curProObj, ShowAll,                               "", PropsPool, TagsPool, Hidden);
     ELSE               pc_PreparePools(curProObj, ShowAll, L_Str.PoolItem(TagsPool, curTag), PropsPool, TagsPool, Hidden);
     END;
    END;
   END;
   curProp:=0;
   IF ~!trgProperty THEN
    WHILE pc_GetProperty(PropsPool, curProp) # trgProperty DO
     INC(curProp);
    END;
   END;
   SEARCH(Property, Property, , pc_GetProperty(PropsPool, curProp));
   curVisible:=pc_GetVisible(Property.Property);
   MdfAlwd   :=pc_GetMdfAlwd(Property.Property);
  END;
 END {pc_onChangeProc};

 PRIVATE PROCEDURE PropChoice(curProperty: LIKE(Property.Property); curObject: L_Prop.tProObject): LIKE(Property.Property);
  CONST
   MinHeightList = 15;
   MaxHeightList = 30;
  VAR
   Res                : NUMERIC[0];
   PropsPool,
   TagsPool           : STRING[];
   HeightList,
   curProp,
   curTag             : NUMERIC[0];
   S,
   Msg,
   MdfAlwd,
   Hidden,
   bt                 : STRING[];
   ShowAll            : pc_ShowType;
   curVisible         : LIKE(aoProLst.Visible);
   i                  : NUMERIC[0];
   Result             : LIKE(Property.Property);
 BEGIN
  ShowAll     :=pc_ShowVisible;
  curTag      :=0;
  curProp     :=0;
  pc_ChangeVis:=0;
  HeightList  :=0;
  SETEMPTY(pc_Prompt, pc_MdfAlwdPool[0], pc_MdfAlwdPool[1]);
  SELECT(Property, PropObj, , curObject);
  WHILE OCCURE(Property) DO
   INC(HeightList);
   INC(pc_MdfAlwdPool[0], pc_GetModificationAllowed(Property.Property) + "|");
   INC(pc_MdfAlwdPool[1], Property.Property + "|");
   NEXT(Property);
  END; (* WHILE OCCURE(Property) ... *)
  IF    HeightList > MaxHeightList THEN
   HeightList:=MaxHeightList;
  ELSIF HeightList < MinHeightList THEN
   HeightList:=MinHeightList;
  END;
  pc_PreparePools(curObject, ShowAll, "", PropsPool, TagsPool, Hidden);
  IF !PropsPool THEN
   ShowAll:=pc_ShowAll;
   pc_Prompt:=PROMPT_LINE.Create("⠭ ० ⮡ࠦ ''. 믮 ன ");
   pc_PreparePools(curObject, ShowAll, "", PropsPool, TagsPool, Hidden);
  END;
  IF ~!curProperty THEN
   SEARCH(Property, Property, , curProperty);
   IF ~pc_Property2Show(ShowAll) THEN
    pc_Prompt:=PROMPT_LINE.Create("饥 ᢮⢮ " + curProperty + "  ன");
   ELSE
    WHILE pc_GetProperty(PropsPool, curProp) # curProperty DO
     INC(curProp);
    END;
   END;
  END;
  curProperty:=pc_GetProperty(PropsPool, curProp);
  SETEMPTY(Result);
  TRY [TRANSACTION(TRANSACTION_SLAVE2)]
   LOOP
    curVisible:=pc_GetVisible(curProperty);
    MdfAlwd   :=pc_GetMdfAlwd(curProperty);
    Msg:=L_StdFrm.intPartForm(
            "%<`᮪>M"
          + "%<`䨪 ( ⥣)>M"
          + "%,"+L_Str.IntStr(HeightList)+"AI"
          + "%AI"
          + "%< ⥪饣 ᢮⢠>M"
          + "%< {}㦭  ᢮⢮>E"
          + "%<` ⮡ࠦ>M"
          + "%<ଠ|| ⮫쪮 >I"
          + "%NI"
          + "%<ᮡ ଫ>M"
          + "%,3NI"
          + L_StdFrm.DrawButton(" ᢮⢮", 0, "B")
          + L_StdFrm.DrawButton("⮯", 0, "X"),
            "%#####################################################% %#########################%"
          + "|%#####################################################% %#########################%"
          + "|                                                                                  "
          + "|                                                        %#########################%"
          + "|                                                        %#########################%"
          + "|                                                                                  "
          + "|                                                        %#########################%"
          + "|                                                        %#########################%"
          + "|                                                                                  "
          + "|                                                        %#########################%"
          + "|                                                                                  "
          + "|                                                        %#########################%"
          + "|                                                        %#########################%"
          + "|||                                                                                  "
          + L_Str.Repeat("|", HeightList-MinHeightList)
          +"|%#################% %#####%"
          );
 
    Res:=STDFORM(Msg, "  ᢮⢠ ", INFORM_NEUTRAL, ,
                 PropsPool, curProp, TagsPool, curTag, curVisible, ShowAll, Hidden, MdfAlwd,
                 ,
                 PROCREF(pc_onChangeProc));
    IF Res=1 THEN
     SEARCH(Property, Property, , pc_GetProperty(PropsPool, curProp));
     Result:=Property.Property;
     EXIT;
    ELSIF Res = 0 THEN
     IF pc_ChangeVis THEN
      Res:=STDFORM("뫨  ன  ᢮"
                   + "|"
                   + L_StdFrm.DrawButton("࠭", 0, "D")
                   + L_StdFrm.DrawButton(" ࠭", 0, "B")
                   + L_StdFrm.DrawButton("  ", 0, "X"), " ᢮⢠", CHOICE);
      IF Res = 1 THEN
       EXIT;
      ELSIF Res = 2 THEN
       HALT();
      END;
     ELSE
      EXIT;
     END; (* IF pc_ChangeVis *)
    END; (* IF Res *)
   END; (* LOOP *)
  EXCEPT
  END; (* TRY *)
  IF !Result THEN
   HALT();
  END;
  RETURN Result;
 END {PropChoice};

 PRIVATE PROCEDURE PropChoice4TextVersion(curProperty: LIKE(Property.Property); curObject: L_Prop.tProObject): LIKE(Property.Property);
  VAR
   List,
   Dummy,
   HideSign  : STRING[];
   Properties: LIKE(Property.Property)[MAXOF(Property.Property)];
   p,
   curP      : NUMERIC[0];
   UsedOnly,
   wAddPoint : SCAL[2];
 BEGIN
  UsedOnly :=1;
  wAddPoint:=0;
  LOOP
   SETEMPTY(List, Properties, Dummy);
   SETZERO(p, curP);
   SELECT(Property, PropObj, , curObject);
   WHILE OCCURE(Property) DO
    IF L_DatTim.IsActive(Memo.ud_cd(), Property.Begin, Property.Till) THEN
     IF ~UsedOnly | Property.IsUsed THEN
      IF UsedOnly THEN
       HideSign:=" ";
      ELSE
       IF ~Property.IsUsed THEN
        HideSign:="- ";
       ELSE
        HideSign:="  ";
       END;
      END;
      List:=List + Property.Property +
            L_Str.PoolItem(" X|  ", PropertyModificationAllowed(Property.Property, Dummy)) + HideSign +
            Property.Name + "|";
      Properties[p]:=Property.Property;
      IF Property.Property = curProperty THEN
       curP:=p;
      END;
      INC(p);
     ELSE
      wAddPoint:=1;
     END;
    END;
    NEXT(Property);
   END; (* WHILE OCCURE(Property) ... *)
   IF wAddPoint THEN
    List:=List + "|" + "     !   ᢮⢠";
   END;
   curP:=L_StdFrm.ShowListAsMenu_wInit(List, " ᢮⢠", curP);
   IF curP < p THEN
    SEARCH(Property, Property, , Properties[curP]);
    IF ~Property.IsUsed THEN
     L_StdFrm.Choice("᫨  ⢨⥫쭮 㦭 ନ ᢮⢮ " + Property.Property + ",   ᫥" +
                     "||" +
                     "㢥   室 ன ࠢ筨 ᢮");
    END;
    RETURN Properties[curP];
   ELSE
    UsedOnly :=0;
    wAddPoint:=0;
   END;
  END; (* LOOP *)
 END {PropChoice4TextVersion};

 PRIVATE PROCEDURE ExecuteSystemSpecificHandler(curProperty: LIKE(Property.Property));
  VAR
   Local: PROC;
 BEGIN
  Local:=intGetQualifiedProcRef(curProperty, "Common" + L_Events.GetEventClassName(MODE), "", 1);
  IF ~!Local THEN
   Local();
  END;
 END {ExecuteSystemSpecificHandler};

 PRIVATE PROCEDURE ExecuteSpecificHandler(curProperty: LIKE(Property.Property); IsZoneEvent: SCAL[2]);
  VAR
   Local: PROC;
 BEGIN
  IF ~IsZoneEvent THEN
   Local:=GetQualifiedProcRef(curProperty, L_Events.GetEventClassName(MODE), L_Events.extGetInternalEventHandlerName(MODE));
  ELSE
   Local:=GetQualifiedProcRef(curProperty, L_Events.extGetInternalEventHandlerName(MODE), "");
  END;
  IF ~!Local THEN
   Local();
  END;
 END {ExecuteSpecificHandler};

 PRIVATE PROCEDURE ExecuteProc_wParameter(curProperty: LIKE(Property.Property); Name: STRING[]);
  VAR
   Local: PROC;
 BEGIN
(*ACCESS  ࠡ  ᢮⢠  P_xxx*)
  ACCESS(^(GE_CURFILE()));
  Local:=GetQualifiedProcRef(curProperty, Name, "");
  IF ~!Local THEN
   Local(curProperty);
  END;
 END {ExecuteProc_wParameter};

 PRIVATE PROCEDURE IsSimpleUserOf(curProperty: LIKE(Property.Property)): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=intGetQualifiedProcRef(curProperty, "IsSimpleUserOf", "", 0);
  IF ~!Local THEN
   RETURN Local(curProperty);
  ELSE
   RETURN "";
  END;
 END {IsSimpleUserOf};

 PRIVATE PROCEDURE GetSpecificSubWindowName(curProperty: LIKE(Property.Property)): STRING[];
  VAR
   Local : PROC;
   Result: STRING[];
 BEGIN
  Local:=intGetQualifiedProcRef(curProperty, "GetSubWindowName", "", 0);
  IF ~!Local THEN
   Result:=Local(curProperty);
  ELSE
   SETEMPTY(Result);
  END;
  IF !Result & ~!IsSimpleUserOf(curProperty) THEN
   Result:=L_Prop.wLinkWindowName;
  END;
  RETURN Result;
 END {GetSpecificSubWindowName};

 PRIVATE PROCEDURE GetObjectDescription(curObject: L_Prop.tProObject): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=L_Prop.GetSpecificAP_ObjectDescription(curObject);
  IF !Result THEN
   Result:=L_DBD.RecordToStr(TABLE.Get(L_Prop.ObjectFileName(curObject)));
  END;
  RETURN Result;
 END {GetObjectDescription};

 PRIVATE PROCEDURE SetObjectDescr(trgZone: FORM_ZONE);
  VAR
   Title    : STRING[];
   curTable : TABLE;
   curObject: L_Prop.tProObject;
 BEGIN
  IF ~!trgZone.Fields("ObjectTitle") & ~!trgZone.Fields("ObjectDescr") THEN
   curTable:=trgZone.MasterTable;
   curObject:=L_Str.PositionInPool(L_Prop.ObjFile_Pool, curTable.Name);
   IF !curObject THEN
    curObject:=L_Str.PositionInPool(L_Prop.PrpFile_Pool, curTable.Name);
    CONFORM(^(curTable.Name), ^(L_Str.PoolItem(L_Prop.ObjFile_Pool, curObject)));
   END;
   Title:=L_Prop.GetSpecificAP_ObjectTitle(curObject);
   IF !Title THEN
    Title:=L_Str.PoolItem(L_Prop.po_Pool, curObject)
   END;
   trgZone.Fields("ObjectTitle").Value:=Title;
   trgZone.Fields("ObjectDescr").Value:=GetObjectDescription(curObject);
  END;
 END {SetObjectDescr};

 PRIVATE PROCEDURE GetSubWindowName(curProperty: LIKE(Property.Property)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=GetSpecificSubWindowName(curProperty);
  IF !Result THEN
   Result:=L_Prop.GetStandartWindowName(GE_CURFILE());
  END;
  RETURN Result;
 END {GetSubWindowName};

 PRIVATE PROCEDURE CheckEmptyValue(curProperty: LIKE(Property.Property); curValue: STRING[]);
 BEGIN
  L_Prop.PositionOnProperty(curProperty);
  IF !curValue THEN
   IF L_Prop.MayBeEmptyValue() THEN
    IF L_Prop.IsCntrProObj(Property.Object) THEN
     L_StdFrm.Question("⮥ 祭 ᢮⢠ (᢮⢮ 㤥 ।  )");
    END;
   ELSE
    L_General.Error("祭 ᢮⢠    .|冷  ᢮ .  㬥樨.");
   END;
  END;
 END {CheckEmptyValue};

 PRIVATE PROCEDURE Check(curProperty: LIKE(Property.Property));
  VAR
   Local   : PROC;
   Date,
   EndDate : DATE;
   curTable: TABLE;
 BEGIN
  CheckEmptyValue(curProperty, ^(GE_CURFILE()).Value);
  Local:=GetQualifiedProcRef(curProperty, "CanHavePro", "");
  IF ~!Local THEN
   SETEMPTY(Date, EndDate);
   curTable:=DATABASE.Get().Tables(GE_CURFILE());
   IF ~!curTable.Fields("Date") THEN
    Date:=^(GE_CURFILE() + ".Date");
   END;
   IF ~!curTable.Fields("EndDate") THEN
    EndDate:=^(GE_CURFILE() + ".EndDate");
   END;
   Local(curProperty, Date);
   Local(curProperty, EndDate); 
  END;
  Local:=GetQualifiedProcRef(curProperty, "Check", GE_CURFILE()+"_Check");
  IF ~!Local THEN
   Local(curProperty);
  END;
 END {Check};

 PRIVATE PROCEDURE SetDataInStandartWindow(curProperty: LIKE(Property.Property));
  VAR
   Local   : PROC;
   Pool    : STRING[];
   curWin  : FORM_WINDOW;
   curZone : FORM_ZONE;
   curField: FORM_FIELD;
   mstTable: TABLE;
 BEGIN
  curWin  :=RTI.Get().CurWindow;
  curZone :=RTI.Get().CurZone;
  mstTable:=curZone.MasterTable;
  curField:=curZone.Fields("Value");
  curField.OwnerWindowOriginalName:="";
  curField.OwnerZoneNumber        :=0;
  curField.Template               :="";
  curField.TemplateIsStrict       :=0;
  curField.AskMode                :=FORM_FIELD.AskMode_System;
  IF ~!curProperty THEN
   Local:=GetQualifiedProcRef(curProperty, "GetPool", "Get"+mstTable.Name+"Pool");
   IF ~!Local THEN
    Pool:=Local(curProperty);
    IF ~!Pool THEN
     IF Pool = L_Prop.ChooseFileDialog THEN
      curField.AskMode:=FORM_FIELD.AskMode_Manual;
     ELSE
      L_Prop.PositionOnProperty(curProperty);
      curField.Template        :=Pool;
      curField.TemplateIsStrict:=(Property.Format = L_Prop.pf_StrongPool) | (Property.Format = L_Prop.pf_Special);
     END;
    END; (* IF ~!Pool...*)
   END; (* IF ~!Local *)
  END; (* IF *)
  curField.OnBeforeAsk:=(curField.AskMode = FORM_FIELD.AskMode_Manual);
 END {SetDataInStandartWindow};

 PRIVATE PROCEDURE acspntAdvice(curProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN "(ன 稩  ࠢ筨 '⢠ ꥪ⮢', " + curProperty + ")";
 END {acspntAdvice};

 PRIVATE PROCEDURE PassPropertyAccessPoint(curProperty: LIKE(Property.Property); curAcsPnt: LIKE(AcsPnt.AcsPnt));
 BEGIN
  L_AcsPnt.fullPassAccessPoint(curAcsPnt, "", acspntAdvice(curProperty));
 END {PassPropertyAccessPoint};

 PRIVATE PROCEDURE CheckBackDateModificationAllowed(curProperty: LIKE(Property.Property));
  VAR
   BPer,
   EPer : DATE;
   Local: PROC;
 BEGIN
  IF DBD.FieldExist(^(GE_CURFILE()), Date) THEN
   BPer:=^(GE_CURFILE()).Date;
   EPer:=^(GE_CURFILE()).EndDate;
   L_Prop.PositionOnProperty(curProperty);
   IF ~!Property.AlwDelay & (BPer < SYSDATE() - Property.AlwDelay) THEN
    IF ~!Property.apBDMdf THEN
     PassPropertyAccessPoint(curProperty, Property.apBDMdf);
    ELSE
     L_General.Assert_wReferToAdmin(L_General.IsAdmin(),
                                    "   稩 䨪樨 ᢮⢠  ᫮|" + acspntAdvice(curProperty));
    END;
   END;
  END;
 END {CheckBackDateModificationAllowed};

 PUBLIC PROCEDURE UpdateVal2Show(ProFileName: STRING[]);
  VAR
   Local      : PROC;
   newVal2Show: STRING[];
 BEGIN
  IF ~!DATABASE.Get().Tables(ProFileName).Fields("Val2Show") THEN
   Local:=GetQualifiedProcRef(^ProFileName.Property, "GetVal2Show", "");
   IF ~!Local THEN
    IF L_Prop.IsLocalProperty(^ProFileName.Property) THEN
     newVal2Show:=Local(^ProFileName.Property);
    ELSE
     newVal2Show:=Local();
    END;
   ELSE
    newVal2Show:=^(ProFileName).Value;
   END;
   IF newVal2Show # ^(ProFileName).Val2Show THEN
    TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     GRANTALLRIGHTS();
     ^(ProFileName).Val2Show:=newVal2Show;
     REPLACE(^(ProFileName));
    EXCEPT
    ON Exc: Exc_AccessDeny DO
     (*祣  *)
    ON Exc: Exc_Root DO
     RAISE();
    END; (* TRY *)
   END;
  END;
 END {UpdateVal2Show};

 PRIVATE PROCEDURE GetObjectFileProName(ObjectName: STRING[]): STRING[];
  VAR
   trgObject: L_Prop.tProObject;
 BEGIN
  trgObject:=L_Prop.GetObjProNum(ObjectName);
  L_General.CallUs(~!trgObject);
  RETURN L_Prop.ObjectFileProName(trgObject);
 END {GetObjectFileProName};

 PUBLIC PROCEDURE extViewSpecific(ObjFileName: STRING[]; curProRI: L_General.tRecordId);
  VAR
   fw             : FORM_WINDOW;
   trgEnv         : ENV;
   Params         : STRING[];
   WindowName,
   MasterTableName: STRING[];
 BEGIN
  MasterTableName:=RTI.Get().CurZone.MasterTable.Name;
  TABLE.Get(MasterTableName).AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(^MasterTableName), " ⠭ ꥪ");
  WindowName :=L_Prop.GetPropListWindowName(GetObjectFileProName(ObjFileName));
  trgEnv:=ENV.Create();
  trgEnv.Add("ObjTable", ObjFileName);
  IF ~!curProRI THEN
   Params:=" @ curProRI="+curProRI;
  ELSE
   SETEMPTY(Params);
  END;

  fw:=APPLICATION.Get().Forms.Load(WindowName,
                                   WindowName + "<" + RTI.Get().CurWindow.AssignedName + "_" + RTI.Get().CurZone.Number + ">",
                                   RTI.Get().CurZone,
                                   trgEnv);
  LIKEMENU(View, fw.Name + " 1 " + RTI.Get().CurWindow.Name + " " + L_Str.IntStr(RTI.Get().CurZone.Number) + Params);
 END {extViewSpecific};

 PUBLIC PROCEDURE ViewSpecific(ObjFileName: STRING[]);
 BEGIN
  extViewSpecific(ObjFileName, EMPTYOF(L_General.tRecordId));
 END {ViewSpecific};

 PUBLIC PROCEDURE View();
 BEGIN
  extViewSpecific(RTI.Get().CurZone.MasterTable.Name, EMPTYOF(L_General.tRecordId));
 END {View};

 PRIVATE PROCEDURE SetDefaultZoneParams(Z: FORM_ZONE);
 BEGIN
  Z.OnOpenZone  :=0; (* 0091481 ⮡    ।뢠 *)
  Z.OnReposition:=1;
  IF ~!Z.Fields("DocGiveS") THEN
   Z.Fields("DocGiveS").OnSuccessfulChange:=1;
  END;
  IF ~!Z.Fields("DocExpD") THEN
   Z.Fields("DocExpD").OnSuccessfulChange:=1;
  END;
  IF ~!Z.Fields("Value") THEN
   Z.Fields("Value").OnSuccessfulChange:=1;
  END;
 END {SetDefaultZoneParams};

 PRIVATE PROCEDURE ANY_OnInitializeWindow();
  VAR
   W        : FORM_WINDOW;
   Local    : PROC;
   ObjTable,
   ProTable : TABLE;
   trgObject: L_Prop.tProObject;
 BEGIN
  W:=RTI.Get().CurWindow;
  IF    (W.OriginalName = L_Prop.PropListWindowName) THEN
   ObjTable:=TABLE.Get(RTI.Get().CurProcess.Env.Item("ObjTable").Value);
   trgObject:=L_Prop.GetObjProNum(ObjTable.Name);
   L_General.CallUs(~!trgObject);
   W.SetMaster(ObjTable);
   L_WDO.iZone(0).SetMaster(ObjTable);
   ProTable:=TABLE.Get(L_Prop.ObjectFileProName(trgObject));
   L_WDO.iZone(1).SetMaster(ProTable);
   L_WDO.iWindow().MNUFileName:="ObjPro";
   L_WDO.iEvents      (0, [L_WDO.e_OnReposition]);
   L_WDO.iProgs       (0, "ObjPro");
   L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
   L_WDO.iProgs       (1, "ObjPro");
   L_WDO.iField       (1, "Property").Expression:=ProTable.Fields("Property").ObtainName();
   L_WDO.iField       (1, "Date").Expression    :=ProTable.Fields("Date").ObtainName();
   L_WDO.iField       (1, "EndDate").Expression :=ProTable.Fields("EndDate").ObtainName();
   IF DBD.FieldExist(^(ProTable.Name), "Val2Show") THEN
    L_WDO.iField      (1, "Val2Show").Expression:=ProTable.Fields("Val2Show").ObtainName();
   ELSE
    L_WDO.iField      (1, "Val2Show").Expression:=ProTable.Fields("Value").ObtainName();
   END;
  ELSIF (W.OriginalName = L_Prop.StandartWindowName) |
        (W.OriginalName = L_Prop.wLinkWindowName)    |
        (W.OriginalName = P_OwnData.wLinkWindowName) THEN
   ProTable:=RTI.Get().CurWindow.ParentZone.MasterTable;
   W.SetMaster(ProTable);
   L_WDO.iZone(0).SetMaster(ProTable);
   L_WDO.iWindow().MNUFileName:="ObjPro";
   L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
   L_WDO.iScsChange   (0, ["DocExpD", "Value", "Date", "DocGiveS"]);
   IF W.OriginalName = P_OwnData.wLinkWindowName THEN
    L_WDO.iUnmodifiable(0, "");
   ELSE
    L_WDO.iUnmodifiable(0, ["ObjectDescr", "ObjectTitle"]);
   END;
   L_WDO.iMayBeEmpty  (0, ["DocSer", "DocNum", "DocExpD", "DocGiveD", "Value", "DocGiveS"]);
   L_WDO.iProgs       (0, "ObjPro");
   L_WDO.iField       (0, "Date").Expression:=ProTable.Fields("Date").ObtainName();
   IF W.OriginalName = L_Prop.StandartWindowName THEN
    L_WDO.iField      (0, "Value").Expression:=ProTable.Fields("Value").ObtainName();
    L_WDO.iField      (0, "Value").OnBeforeAsk:=1;
    L_WDO.iField      (0, "Value").AskMode:=1;
   END;
  ELSIF (W.OriginalName = InsPropertyWindowName) THEN
   L_General.CallUs(InsertByWDO);
   L_WDO.iWindow().MNUFileName:="ObjPro";
   L_WDO.iZone(1).ViewOnly:=1;
  ELSE
   Local:=GetQualifiedProcRef(pv_InsertingProperty, L_Events.extGetInternalEventHandlerName(MODE), "");
   IF ~!Local THEN
    Local();
   END;
  END;
 END {ANY_OnInitializeWindow};

 PRIVATE PROCEDURE ANY_OnConformToWindow();
  VAR
   ObjFileName,
   PropFileName: STRING[];
 BEGIN
  IF RTI.Get().TrgWindow.OriginalName = L_Prop.PropListWindowName THEN
   L_General.Assert(ACCESS(^(RTI.Get().CurZone.MasterTable.Name)), " ⠭ ꥪ");
   ObjFileName:=RTI.Get().TrgWindow.Zones(0).MasterTable.Name;
   RTI.Get().TrgWindow.Title:="⢠ " + L_Str.PoolItem(L_Prop.po_Pool_Genitive, L_Prop.GetObjProNum(ObjFileName));
   IF RTI.Get().CurZone.MasterTable.Name # ObjFileName THEN
    CONFORM(^(RTI.Get().CurZone.MasterTable.Name), ^ObjFileName);
   END;
   SetObjectDescr(RTI.Get().TrgWindow.Zones(0));
   PropFileName:=GetObjectFileProName(ObjFileName);
   CONFORM((ObjFileName), (PropFileName));
   SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, (ObjFileName));
   IF ~!L_WDO.fz_AccessEnvVar(RTI.Get().TrgZone, "curProRI") THEN
    SE_WZD_CURSOR(RTI.Get().TrgWindow.Name, 0, (ObjFileName));

    SE_WZD_CURSOR(RTI.Get().TrgWindow.Name, 1, (PropFileName));
   END;
  END;
 END {ANY_OnConformToWindow};

 PRIVATE PROCEDURE ANY_1_OnZoneOpen();
  VAR
   curProperty: LIKE(Property.Property);
 BEGIN
  IF ACCESS(^(GE_CURFILE())) THEN
   curProperty:=^(GE_CURFILE()).Property;
  ELSE
   SAVE(Property);
   L_General.Assert(SELECT(Property, PropObj, L_Prop.GetObjNum(GE_CURFILE())), "  ᢮⢠  ࠢ筨?");
   curProperty:=Property.Property;
   RESTORE(Property);
  END;
  ExecuteSpecificHandler(curProperty, 1);
 END {ANY_1_OnZoneOpen};

 PRIVATE PROCEDURE UpdateLastVal2Show(ProFile: STRING[]);
  VAR
   Amount: NUMERIC[0];
 BEGIN
  SETZERO(Amount);
  LAST(^ProFile);
  WHILE OCCURE(^ProFile) & (Amount < 3) DO
   UpdateVal2Show(ProFile);
   INC(Amount);
   PREV(^ProFile);
  END; (* WHILE OCCURE(^ProFile) ... *)
 END {UpdateLastVal2Show};

 PUBLIC PROCEDURE UpdateCurObjectVal2Show(LandFile, ProFile: STRING[]);
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   ACCESS(^LandFile);
   TABLE.Get(ProFile).AccessDataMode:=AccessDataMode_SOFT;
   IF ProFile = "OwnDPro" THEN
    SELECT(OwnDPro, Property, , Property.Property);
   ELSE
    CONFORM(^LandFile, ^ProFile);
   END;
   TRY [TRANSACTION(TRANSACTION_SLAVE)]
    IF ProFile = "OwnDPro" THEN
     UpdateLastVal2Show("OwnDPro");
    ELSE
     WHILE OCCURE(^ProFile) DO
      NARROWSEL(^ProFile, Property);
      UpdateLastVal2Show(ProFile);
      NEXTINEXTENDEDSEL(^ProFile, Property);
     END; (* WHILE OCCURE(^ProFile) ... *)
    END;
   EXCEPT
   END; (* TRY *)
  EXCEPT
  ON Exc:Exc_Root DO
   RETURN
  END; (* TRY *)
 END {UpdateCurObjectVal2Show};

 PRIVATE PROCEDURE ANY_0_OnReposition();
  VAR
   W           : FORM_WINDOW;
   Z           : FORM_ZONE;
   DocAttr,
   PropFileName: STRING[];
   curProRI    : L_General.tRecordId;
   curProperty : LIKE(Property.Property);
 BEGIN
  W:=RTI.Get().CurWindow;
  Z:=RTI.Get().CurZone;
  IF (W.OriginalName = L_Prop.PropListWindowName) | (W.OriginalName = "Mtwo_SP") | (W.OriginalName = "OwnDPro") THEN
   PropFileName:=RTI.Get().CurWindow.Zones(1).MasterTable.Name;
   UpdateCurObjectVal2Show(W.MasterCursor.TABLE.Name, PropFileName);
   curProRI:=L_WDO.GetEnvVarValue("curProRI");
   IF ~!curProRI THEN
    SEARCH((PropFileName), RECORDID, , curProRI);
    SE_WZD_POSITION(W.Name, 1, (PropFileName));
   END;
  ELSE
   curProperty:=^(Z.MasterTable.Fields("Property").ObtainName());
   L_Prop.PositionOnProperty(curProperty);
   W.Title:=Property.Name + " (" + curProperty + ")";
   IF (W.OriginalName = L_Prop.wLinkWindowName) |
      (W.OriginalName = P_OwnData.wLinkWindowName) THEN
    WHILE Z.Links.Count DO
     Z.Links.Remove(Z.Links(0));
    END;
    L_WDO.CreateFormLink_Simple(IsSimpleUserOf(curProperty), "Value");
   END;
   IF ~!Z.Fields("DocNum") THEN
    DocAttr:=^(Z.MasterTable.Fields("DocNum").ObtainName());
    L_Prop.GetDocSerAndNum(DocAttr, Z.Fields("DocSer").Value, Z.Fields("DocNum").Value);
   END;
   IF ~!Z.Fields("DocGiveS") THEN
    Z.Fields("DocGiveS").Value:=^(Z.MasterTable.Fields("DocGiveS").ObtainName());
    Z.Fields("DocGiveD").Value:=^(Z.MasterTable.Fields("DocGiveD").ObtainName());
   END;
   IF ~!Z.Fields("DocExpD") THEN
    Z.Fields("DocExpD").Value :=^(Z.MasterTable.Fields("DocExpD").ObtainName());
   END;
 
   SetObjectDescr(RTI.Get().CurZone);
   ExecuteProc_wParameter(curProperty, "OnReposition");
   IF ~!GetSpecificSubWindowName(curProperty) THEN
    IF (W.OriginalName = L_Prop.wLinkWindowName) |
       (W.OriginalName = P_OwnData.wLinkWindowName) THEN
     Z.Fields("Value").Value:=L_r2r.DecodeReferenceStamp(^(Z.MasterTable.Fields("Value").ObtainName()));
    ELSE
     ExecuteProc_wParameter(curProperty, "SetDataInForm");
    END;
   ELSE
    SetDataInStandartWindow(curProperty);
   END;
  END;
 END {ANY_0_OnReposition};

 PRIVATE PROCEDURE ANY_OnBeforeEdIns(curProperty: LIKE(Property.Property));
  VAR
   Local   : PROC;
   Pool    : LIKE(Pool.Pool);
   curField: FORM_FIELD;
 BEGIN
  L_Prop.PositionOnProperty(curProperty);
  IF ~L_Prop.IsEDOLProObj(Property.Object) & (RTI.Get().CurWindow.OriginalName # GetSubWindowName(curProperty)) THEN
   L_General.Error("த 䨪樨 ");
  END;
  Local:=GetQualifiedProcRef(curProperty, "GetPool4DocGiveS", "");
  IF ~!Local THEN
   curField:=RTI.Get().CurZone.Fields("DocGiveS");
   IF !curField THEN
    curField:=RTI.Get().CurZone.Fields(RTI.Get().CurZone.MasterTable.Name + ".DocGiveS");
   END;
   IF ~!curField THEN
    Pool:=Local(curProperty);
    IF ~!Pool THEN
     curField.Template:=L_Pool.Get(Pool);
    ELSE
     SETEMPTY(curField.Template);
    END;
    curField.TemplateIsStrict:=0;
   END;
  END;
 END {ANY_OnBeforeEdIns};

 PRIVATE PROCEDURE ANY_OnBeforeEdit();
  VAR
   Msg        : STRING[];
   curProperty: LIKE(Property.Property);
 BEGIN
  curProperty:=^(RTI.Get().CurZone.MasterTable.Fields("Property").ObtainName());
  ANY_OnBeforeEdIns(curProperty);
  L_General.Assert(PropertyModificationAllowed(curProperty, Msg), Msg);
  CheckBackDateModificationAllowed(curProperty);
  SetSingleLineProperty(curProperty);
  ExecuteSystemSpecificHandler(curProperty);
  ExecuteSpecificHandler(curProperty, 0);
  L_r2r.User_OnBeforeModify(RTI.Get().CurZone.MasterTable.Name);
 END {ANY_OnBeforeEdit};

 PRIVATE PROCEDURE SelectAnyPro(curFile    : STRING[];
                                trgProperty: LIKE(Property.Property);
                                trgDate    : DATE;
                                trgPropRow : SCAL[100]): SCAL[2];
  VAR
   cooFile,
   curIndex,
   PartialIndexFieldsName: STRING[];
 BEGIN
  L_Prop.PositionOnProperty(trgProperty);
  IF L_Prop.IsOwnDProObj(Property.Object) THEN
   IF ~!trgDate THEN
    RETURN SELECT(OwnDPro, Property, trgProperty, trgDate);
   ELSE
    RETURN SELECT(OwnDPro, Property, trgProperty);
   END;
  ELSE
   cooFile:=DBD.LendFile(^curFile);
   IF ~!cooFile THEN
    curIndex              :=L_DBD.Get2FilesLinkIndexName(curFile, cooFile);
    PartialIndexFieldsName:=L_DBD.GetPartialIndexFieldsName(curFile, curIndex, DBD.IndexFieldAmount(^curFile, ^curIndex)-2);
    IF    ~!trgDate THEN
     RETURN SELECT(^curFile, ^curIndex, ^PartialIndexFieldsName, trgProperty, trgDate);
    ELSIF ~!trgPropRow THEN
     RETURN SELECT(^curFile, ^curIndex, ^PartialIndexFieldsName, trgProperty, trgPropRow);
    ELSE
     RETURN SELECT(^curFile, ^curIndex, ^PartialIndexFieldsName, trgProperty);
    END;
   ELSE
    RETURN 0;
   END;
  END;
 END {SelectAnyPro};

 PRIVATE PROCEDURE IsFirstInsertedProperty(curFile: STRING[]; curProperty: LIKE(Property.Property)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SAVE(^curFile);
  Result:=~SelectAnyPro(curFile, curProperty, EMPTYOF(DATE), EMPTYOF(SCAL[100]));
  RESTORE(^curFile);
  RETURN Result;
 END {IsFirstInsertedProperty};

 PRIVATE PROCEDURE GetDefaultPropertyDate(curProperty: LIKE(Property.Property)): DATE;
  VAR
   LendLink: LINK;
   curFile,
   LendFile: STRING[];
   _Date   : DATE;
   BDF, EDF: STRING[];
 BEGIN
  SETEMPTY(_Date);
  curFile:=GE_CURFILE();
  L_Prop.PositionOnProperty(curProperty);
  IF ~L_Prop.IsOwnDProObj(Property.Object) & IsFirstInsertedProperty(curFile, curProperty) THEN
   LendLink:=TABLE.Get(curFile).LendLink;
   IF ~!LendLink THEN
    LendFile:=LendLink.CooIndex.Table.Name;
    L_DBD.CollateValidityFieldNames(LendFile, BDF, EDF);
    IF BDF = "Begin" THEN
     CONFORM(^curFile, ^LendFile);
     _Date:=^(LendFile + "." + BDF);
     L_General.Assert(~!_Date,
                      "   ⢨ ꥪ " + TABLE.Get(LendFile).Description);
    END;
   END;
  END;
  RETURN _Date;
 END {GetDefaultPropertyDate};

 PRIVATE PROCEDURE GetPrvPropertyParams(    curProperty: LIKE(Property.Property);
                                        VAR trgValue   : STRING[];
                                        VAR trgRedefine: SCAL[9]);
  VAR
   curDate          : DATE;
   curPropRow       : NUMERIC[0];
   trgProperty      : LIKE(Property.Property);
   curFile          : STRING[];
   LastValueRequired: SCAL[2];
 BEGIN
  curFile:=GE_CURFILE();
  SAVE(^curFile);
  trgProperty:=GE_PVALUE(^curFile.Property);
  IF ~!trgProperty THEN
   SETEMPTY(curDate, curPropRow);
   LastValueRequired:=trgProperty # curProperty;
   IF LastValueRequired THEN
    trgProperty:=curProperty;
   ELSE
    IF    DBD.FieldExist(^(curFile), Date) THEN
     curDate   :=GE_PVALUE(^curFile.Date);
    ELSIF DBD.FieldExist(^(curFile), PropRow) THEN
     curPropRow:=GE_PVALUE(^curFile.PropRow);
    ELSE
(*
     L_General.CallUs(0);
*)
    END;
   END;

   IF SelectAnyPro(curFile, trgProperty, curDate, curPropRow) THEN
    IF LastValueRequired THEN
     LAST(^curFile);
    END;
    trgValue:=^curFile.Value;
    IF DBD.FieldExist(^(curFile), Redefine) THEN
     trgRedefine:=^curFile.Redefine;
    END;
   END;
  END; (* IF ~!curProperty...*)
  RESTORE(^curFile);
 END {GetPrvPropertyParams};

 PRIVATE PROCEDURE IsInsert_bySavedCopy(): SCAL[2];
 BEGIN
  RETURN L_WDO.GetEnvVarValue("InsMode") = "bySavedCopy";
 END {IsInsert_bySavedCopy};

 PRIVATE PROCEDURE GetPrvPropertyValue(curProperty: LIKE(Property.Property)): STRING[];
  VAR
   Dummy : SCAL[9];
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF    IsInsert_bySavedCopy() THEN
   Result:=scrc_Value;
  ELSIF Property.CopyPrvV = L_Prop.cpv_Yes THEN
   GetPrvPropertyParams(curProperty, Result, Dummy);
  END;
  RETURN Result;
 END {GetPrvPropertyValue};

 PRIVATE PROCEDURE GetPropertyRedefineValue(curProperty: LIKE(Property.Property)): SCAL[9];
  VAR
   Dummy : STRING[];
   Result: SCAL[9];
 BEGIN
  SETEMPTY(Result, Dummy);
  GetPrvPropertyParams(curProperty, Dummy, Result);
  RETURN Result;
 END {GetPropertyRedefineValue};

 PRIVATE PROCEDURE ANY_OnBeforeInsert();
  VAR
   trgDate    : DATE;
   prvValue   : STRING[];
   trgRedefine: SCAL[9];
   curProperty: LIKE(Property.Property);
 BEGIN
  curProperty:=pv_InsertingProperty;
  ANY_OnBeforeEdIns(curProperty);
  trgDate    :=GetDefaultPropertyDate(curProperty);
  prvValue   :=GetPrvPropertyValue(curProperty);
  trgRedefine:=GetPropertyRedefineValue(curProperty);

  ^(GE_CURFILE()).Property:=curProperty;
  ^(GE_CURFILE()).Value   :=prvValue;
  IF DBD.FieldExist(^(GE_CURFILE()), Date) THEN
   ^(GE_CURFILE()).Date    :=trgDate;
  END;
  IF DBD.FieldExist(^(GE_CURFILE()), Redefine) THEN
   ^(GE_CURFILE()).Redefine:=trgRedefine;
  END;
  REPLACE(^(GE_CURFILE()));
  SetSingleLineProperty(curProperty);
  ExecuteSystemSpecificHandler(curProperty);
  ExecuteSpecificHandler(curProperty, 0);
  ExecuteProc_wParameter(curProperty, "CanHaveProp");
  IF ~!trgDate | ~!prvValue THEN
   FIXALTERING();
  END;
 END {ANY_OnBeforeInsert};

 PRIVATE PROCEDURE CheckIllegalCharExists(trgDocNum: STRING[]);
  CONST
   IllegalChars = ".,;";
  VAR
   i,
   Length: NUMERIC[0];
   Char  : STRING[];
 BEGIN
  IF ~!trgDocNum THEN
   Length:=Str.Length(trgDocNum);
   i     :=0;
   LOOP
    Char:=L_Str.Char(IllegalChars, i);
    IF !Char THEN
     EXIT;
    END;
    L_General.Assert(Str.Pos(trgDocNum, Char) = Length,
                     ",  㬥 '" + trgDocNum + "'|" +
                     "ᮤন 饭 ᨬ '" + Char + "'");
    INC(i);
   END; (* LOOP *)
  END;
 END {CheckIllegalCharExists};

 PRIVATE PROCEDURE ANY_OnAfterModifyPrepare();
  VAR
   Fields     : FORM_FIELDS;
   curTable   : TABLE;
   curFile,
   trgDocNum  : STRING[];
   curProperty: LIKE(Property.Property);
 BEGIN
  Fields     :=RTI.Get().CurZone.Fields;
  curFile    :=RTI.Get().CurZone.MasterTable.Name;
  curTable   :=DATABASE.Get().Tables(curFile);
  curProperty:=^curFile.Property;
  IF    (RTI.Get().CurWindow.OriginalName = L_Prop.wLinkWindowName) |
        (RTI.Get().CurWindow.OriginalName = P_OwnData.wLinkWindowName) THEN
   CheckEmptyValue(curProperty, Fields("Value").Value);
   ^curFile.Value:=L_r2r.Put(curFile, IsSimpleUserOf(curProperty), Fields("Value").Value);
   REPLACE(^curFile);
  ELSIF RTI.Get().CurWindow.OriginalName = GetSpecificSubWindowName(curProperty) THEN
   ExecuteProc_wParameter(curProperty, "GetDataFromForm");
  END;

  UpdateVal2Show(curFile);

  IF ~!curTable.Fields("DocNum") THEN
   IF ~!Fields("DocSer") & ~!Fields("DocNum") THEN
    IF Str.Pos(Fields("DocNum").Value, " ") # Str.Length(Fields("DocNum").Value) THEN
     L_General.Error(" 㬥   ᮤঠ ஡");
    END;
    IF ~!Fields("DocSer").Value & !Fields("DocNum").Value THEN
     L_General.Error("䨪 㬥    ⮫쪮  ਨ");
    END;
    trgDocNum:=Str.Condense(Fields("DocSer").Value + " " + Fields("DocNum").Value);
    L_General.Assert(Str.Length(trgDocNum) <= Str.MaxLength(^curFile.DocNum),
                     " 䨪 㬥" +
                     "|'" + trgDocNum + "'" +
                     "|ॢ蠥 ᨬ쭮 ⨬." +
                     "||᫨  㢥७  ࠢ쭮 ᢮ ⢨," +
                     "|  ");
    ^curFile.DocNum:=trgDocNum;
   END; (* IF ~!Fields("DocSer") & ~!Fields("DocNum")...*)
   IF ~!Fields("DocGiveS") THEN
    ^curFile.DocGiveS:=Fields("DocGiveS").Value;
   END; (* IF ~!Fields("DocGiveS") ... *)
   IF ~!Fields("DocExpD") THEN
    ^curFile.DocExpD :=Fields("DocExpD").Value;
   END; (* IF ~!Fields("DocExpD") ... *)
   IF ~!Fields("DocGiveD") THEN
    ^curFile.DocGiveD:=Fields("DocGiveD").Value;
    IF ~!Fields("DocExpD") THEN
     L_General.Assert(!(^curFile.DocGiveD) | (^curFile.DocGiveD < ^curFile.DocExpD),
                      "⢨ 㬥 稢 ࠭  뤠?");
    END; (* IF ~!Fields("DocExpD") ... *)
   END; (* IF ~!Fields("DocGiveD") ... *)
   REPLACE(^curFile);

   CheckIllegalCharExists(^curFile.DocNum);
  END; (* IF ~!curTable.Fields("DocNum")...*)
 END {ANY_OnAfterModifyPrepare};

 PRIVATE PROCEDURE ANY_OnAfterEdIns();
  VAR
   curFile    : STRING[];
   curProperty: LIKE(Property.Property);
 BEGIN
  curFile    :=RTI.Get().CurZone.MasterTable.Name;
  curProperty:=^curFile.Property;

  L_Prop.SupportEndDate(curFile, curProperty, 1);

  IF ~IsInsidePropertyObject(curProperty) THEN
   L_DBD.CheckOwnersValidity(curFile);
  END;

  Check(curProperty);
  ExecuteSystemSpecificHandler(curProperty);
  ExecuteSpecificHandler(curProperty, 0);
  CheckBackDateModificationAllowed(curProperty);
 END {ANY_OnAfterEdIns};

 PRIVATE PROCEDURE ANY_OnAfterEdit();
 BEGIN
  ANY_OnAfterEdIns();
 END {ANY_OnAfterEdit};

 PRIVATE PROCEDURE ANY_OnAfterInsert();
 BEGIN
  ANY_OnAfterEdIns();
 END {ANY_OnAfterInsert};

 PRIVATE PROCEDURE ANY_OnBeforeDelete();
  VAR
   curProperty: LIKE(Property.Property);
 BEGIN
  curProperty:=^(RTI.Get().CurZone.MasterTable.Fields("Property").ObtainName());
  CheckBackDateModificationAllowed(curProperty);
  ExecuteSystemSpecificHandler(curProperty);
  L_Prop.SupportEndDate(GE_CURFILE(), curProperty, 0);
  ExecuteSpecificHandler(curProperty, 0);
  L_r2r.User_OnBeforeModify(RTI.Get().CurZone.MasterTable.Name);
 END {ANY_OnBeforeDelete};

 PRIVATE CONST
  InsPropertyWindowName = "InsPro";

 PUBLIC PROCEDURE ChoiceProperty();
  VAR
   w: FORM_WINDOW;
 BEGIN
  L_General.CallUs(InsertByWDO);
  IF ACCESS((RTI.Get().CurZone.MasterTable.Name)) THEN
   CONFORM((RTI.Get().CurZone.MasterTable.Name), Property);
   CHANGESEL(Property, PropObj);
  ELSE
   (* !!! *)
   SELECT(Property, PropObj, , L_Prop.StaffProObj);
   (* !!! *)
  END;
  w:=APP.Get().Forms.Load(InsPropertyWindowName,
                          InsPropertyWindowName + "<" + RTI.Get().CurWindow.Name + ">",
                          RTI.Get().CurWindow.Zones(0));
  w.Zones(1).PermanentFilter:="Property.Object=" + L_Str.IntStr(Property.Object);
  SE_WWD_CURSOR(w.Name,    Property);
  SE_WZD_CURSOR(w.Name, 1, Property);
  LIKEMENU(View, w.Name + " 1 " + RTI.Get().CurWindow.Name + " " + "0");
 END {ChoiceProperty};

 PUBLIC PROCEDURE InsertProperty();
 BEGIN
  L_General.CallUs(InsertByWDO);
  ACCESS(Property);
  LIKEMENU(Cancel, "NoSave", Ins, "@ curProperty=" + Property.Property);
 END {InsertProperty};

 PRIVATE PROCEDURE ANY_OnSetSubwindow();
  VAR
   Msg,
   WinName    : STRING[];
   Z          : FORM_ZONE;
   trgObject  : LIKE(Property.Object);
   curProperty: LIKE(Property.Property);
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert THEN
   IF IsInsert_bySavedCopy() & ~VAR_IMPL.Get(scrc_Property).Initialized THEN
    L_StdFrm.BlueHalt(" ࠭   ");
   END;

   IF L_Prop.IsOwnDProObj(L_Prop.GetObjNum(GE_CURFILE())) THEN
    L_General.CallUs(ACCESS(Property));
    curProperty:=Property.Property;
   ELSE
    IF InsertByWDO THEN
     curProperty:=L_WDO.GetEnvVarValue("curProperty");
     IF !curProperty THEN
      CALL(CallStub.AppendMacro("CALL, 'ObjPro.ChoiceProperty()'"));
      HALT();
     END;
    ELSE
     IF IsInsert_bySavedCopy() THEN
      curProperty:=scrc_Property;
     ELSE
      IF ACCESS(^(GE_CURFILE())) THEN
       curProperty:=^(GE_CURFILE()).Property;
      ELSE
       SETEMPTY(curProperty);
      END;
      IF L_StdFrm.wGUI() THEN
       curProperty:=PropChoice(curProperty, L_Prop.GetObjNum(GE_CURFILE()));
      ELSE
       curProperty:=PropChoice4TextVersion(curProperty, L_Prop.GetObjNum(GE_CURFILE()));
      END;
     END;
    END; (* IF InsertByWDO *)
   END; (* IF L_Prop.IsOwnDProObj *)
  ELSE
   ACCESS(^(GE_CURFILE()));
   curProperty:=^(GE_CURFILE()).Property;
  END;
  L_Prop.PositionOnProperty(curProperty);
  IF IsInsert_bySavedCopy() THEN
   trgObject:=L_Str.PositionInPool(L_Prop.PrpFile_Pool, RTI.Get().CurZone.MasterTable.Name);
   IF trgObject # Property.Object THEN
    L_General.Error("  ࠭  ᢮⢠ "+scrc_Property+" ꥪ '" + L_Str.PoolItem(L_Prop.po_Pool, Property.Object) + "',|" +
                    "    ᢮⢠ ꥪ '" + L_Str.PoolItem(L_Prop.po_Pool, trgObject) + "' ");
   END;
  END;

  pv_InsertingProperty:=curProperty;

  IF RTI.Get().CurProcess.Kind # FORM_PROCESS.Kind_ShowWin THEN
   IF ~!Property.apModify THEN
    PassPropertyAccessPoint(curProperty, Property.apModify);
   ELSE
    TRY
     DEFAULT(^(GE_CURFILE()));
     INSERT(^(GE_CURFILE()));
     L_General.RaiseLockReleaseException();
    EXCEPT
    ON Exc: Exc_NoRights DO
     L_General.Assert_wReferToAdmin(0, Exc.MsgOriginalText + "||" +
                                       "( 䨪樨 ᢮  ॣ㫨஢  ⮫쪮 "
                                     + " 䠩  楫,    ⭮ ᢮. "
                                     + ". ࠢ筨 '⢠ ꥪ⮢')");
    ON Exc: Exc_Root DO
     L_General.CheckIsLockReleaseException(Exc);
    END; (* TRY *)
    L_AR.GrantRightsForInteractiveModification(); (* 12.10.2011 12:50:31 POLAK\San    TRY *)
   END;
   L_General.Assert(PropertyModificationAllowed(Property.Property, Msg), Msg);
  END;
  WinName:=GetSubWindowName(curProperty);
  RTI.Get().CurZone.HasVariousSubwindows :=1;
  RTI.Get().CurZone.SubwindowOriginalName:=WinName;
  RTI.Get().CurZone.SubwindowAssignedName:=RTI.Get().CurZone.SubwindowOriginalName;
  IF (WinName = L_Prop.StandartWindowName) |
     (WinName = L_Prop.wLinkWindowName)    |
     (WinName = P_OwnData.wLinkWindowName) THEN
   INC(RTI.Get().CurZone.SubwindowAssignedName, "<" + RTI.Get().CurZone.MasterTable.Name + ">");
  ELSE
   Z:=APP.Get().Forms.Load(RTI.Get().CurZone.SubwindowOriginalName, RTI.Get().CurZone.SubwindowAssignedName).Zones(0);
   SetDefaultZoneParams(Z);
  END;
 END {ANY_OnSetSubwindow};

 PRIVATE PROCEDURE ANY_1_OnSetSubwindow();
 BEGIN
  ANY_OnSetSubwindow()
 END {ANY_1_OnSetSubwindow};

 PRIVATE PROCEDURE ANY_2_OnSetSubwindow();
 BEGIN
  ANY_OnSetSubwindow()
 END {ANY_2_OnSetSubwindow};

 PRIVATE PROCEDURE ANY_3_OnSetSubwindow();
 BEGIN
  ANY_OnSetSubwindow()
 END {ANY_3_OnSetSubwindow};

 PRIVATE PROCEDURE ANY_4_OnSetSubwindow();
 BEGIN
  ANY_OnSetSubwindow()
 END {ANY_4_OnSetSubwindow};

 PRIVATE PROCEDURE GetCurPropertyCode(): LIKE(Property.Property);
 BEGIN
  RETURN ^(RTI.Get().CurZone.MasterTable.Fields("Property").ObtainName());
 END {GetCurPropertyCode};

 PRIVATE PROCEDURE ANY_Date_OnSuccessfulChange();
 BEGIN
  ExecuteProc_wParameter(GetCurPropertyCode(), "Date_OnSuccessfulChange");
 END {ANY_Date_OnSuccessfulChange};

 PRIVATE PROCEDURE ANY_Value_OnBeforeAskForEdit();
 BEGIN
  ExecuteProc_wParameter(GetCurPropertyCode(), "OnBeforeAskForEdit");
 END {ANY_Value_OnBeforeAskForEdit};

 PRIVATE PROCEDURE ANY_Value_OnSuccessfulChange();
 BEGIN
  ExecuteProc_wParameter(GetCurPropertyCode(), "Value_OnSuccessfulChange");
 END {ANY_Value_OnSuccessfulChange};

 PRIVATE PROCEDURE ANY_DocGiveS_OnSuccessfulChange();
  VAR
   Pool       : LIKE(Pool.Pool);
   Local      : PROC;
   curDocGiveS: STRING[];
   curProperty: LIKE(Property.Property);
 BEGIN
  curProperty:=GetCurPropertyCode();
  Local:=GetQualifiedProcRef(curProperty, "GetPool4DocGiveS", "");
  IF ~!Local THEN
   Pool:=Local(curProperty);
   IF ~!Pool THEN
    IF ~!RTI.Get().CurZone.Fields("DocGiveS") THEN
     curDocGiveS:=RTI.Get().CurZone.Fields("DocGiveS").Value;
    ELSE
     curDocGiveS:=^(curTable.Fields("DocGiveS").ObtainName());
    END;
    L_Pool.Put(Pool, curDocGiveS);
   END;
  END;
 END {ANY_DocGiveS_OnSuccessfulChange};

 PRIVATE PROCEDURE ANY_DocExpD_OnSuccessfulChange();
  VAR
   curTable   : TABLE;
   curDate,
   curDocExpD : DATE;
   curProperty: LIKE(Property.Property);
 BEGIN
  curProperty:=GetCurPropertyCode();
  ExecuteSpecificHandler(curProperty, 0);
  curTable:=RTI.Get().CurZone.MasterTable;
  IF ~!RTI.Get().CurZone.Fields("DocExpD") THEN
   curDocExpD:=RTI.Get().CurZone.Fields("DocExpD").Value;
  ELSE
   curDocExpD:=^(curTable.Fields("DocExpD").ObtainName());
  END;
  IF ~!curDocExpD THEN
   curDate:=^(curTable.Fields("Date").ObtainName());
   IF curDocExpD <= curDate THEN
    L_General.Error(" 砭 ⢨ 㬥 (" + L_DatTim.DateStr(curDocExpD) + ")|" +
                    "    ଫ ᢮⢠ (" + L_DatTim.DateStr(curDate) + ")");
   END;
   IF (curDocExpD = L_DatTim.MonthEnd(curDocExpD)) & (curDate # L_DatTim.MonthEnd(curDate)) THEN
    L_StdFrm.Choice(" 㪠  " + L_DatTim.DateStr(curDocExpD) +
                    "| , ᫥  ⢨ 㬥  " + L_DatTim.DateStr(curDocExpD-1));
   END;
  END;
 END {ANY_DocExpD_OnSuccessfulChange};

 PRIVATE PROCEDURE ANY__OnBeforeAskForEdit();
 BEGIN
  ExecuteProc_wParameter(GetCurPropertyCode(), "OnBeforeAskForEdit");
 END {ANY__OnBeforeAskForEdit};

 PRIVATE PROCEDURE ANY__OnAskPhase1();
 BEGIN
  ExecuteProc_wParameter(GetCurPropertyCode(), "OnAskPhase1");
 END {ANY__OnAskPhase1};

 PRIVATE PROCEDURE ANY__OnAskPhase2();
 BEGIN
  ExecuteProc_wParameter(GetCurPropertyCode(), "OnAskPhase2");
 END {ANY__OnAskPhase2};

(*!!! 0091687 *)
 PRIVATE PROCEDURE ANY__OnSuccessfulChange();
 BEGIN
  IF RTI.Get().CurZone.ActiveField.Name = "DocGiveS" THEN
   ANY_DocGiveS_OnSuccessfulChange();
  ELSIF RTI.Get().CurZone.ActiveField.Name = "DocExpD" THEN
   ANY_DocExpD_OnSuccessfulChange();
  ELSE
   ExecuteProc_wParameter(GetCurPropertyCode(), "OnSuccessfulChange");
  END;
 END {ANY__OnSuccessfulChange};

 PRIVATE PROCEDURE CheckAcceptableMove(Dir: NUMERIC[0]);
  VAR
   Msg: STRING[];
   Idx: NUMERIC[0];
 BEGIN
  Idx:=L_Prop.GetCurVideoFieldArrIdx();
  L_General.Assert(~!Idx, "饥     ப. ६饭 .");
  IF Dir = -1 THEN
   DEC(Idx);
   Msg:=" ப - ࢠ. ६饭  ";
  ELSE
   INC(Idx);
   Msg:=" ப - ᫥. ६饭  ";
  END;
  L_General.Assert(~!RTI.Get().CurZone.Fields(L_Prop.BuildVideoFieldName(L_Prop.GetCurVideoFieldArrName(), Idx)), Msg);
 END {CheckAcceptableMove};

 PUBLIC PROCEDURE ANY_OnPropertyArrayItemMoveUp();
 BEGIN
  CheckAcceptableMove(-1);
  ExecuteProc_wParameter(GetCurPropertyCode(), "OnPropertyArrayItemMoveUp");
  FIX_ALTERING();
  LIKEMENU(Up, "");
 END {ANY_OnPropertyArrayItemMoveUp};

 PUBLIC PROCEDURE ANY_OnPropertyArrayItemMoveDown();
 BEGIN
  CheckAcceptableMove(+1);
  ExecuteProc_wParameter(GetCurPropertyCode(), "OnPropertyArrayItemMoveDown");
  FIX_ALTERING();
  LIKEMENU(Dn, "");
 END {ANY_OnPropertyArrayItemMoveDown};

 PRIVATE PROCEDURE AccessPro();
 BEGIN
  L_General.Assert(ACCESS(^(RTI.Get().CurZone.MasterTable.Name)), " ⠭ ⥪   '⢠'");
 END {AccessPro};

 PUBLIC PROCEDURE SaveCurRecordCopy();
 BEGIN
  AccessPro();
  scrc_Property:=^(RTI.Get().CurZone.MasterTable.Fields("Property").ObtainName());
  scrc_Value   :=^(RTI.Get().CurZone.MasterTable.Fields("Value").ObtainName());
  TOOLTIP(" ⥪饩  ࠭");
 END {SaveCurRecordCopy};

BEGIN
 IF L_Events.IsAfterEditInsertEvents(MODE) THEN
  ANY_OnAfterModifyPrepare();
 END;
 L_Events.extExecuteHandler("ANY");
END.
