(*
%Copyright   (c) Polak IT
%Author      17.05.2004 18:11:54 POLAK\ATS
%Purpose     ࠢ 䨪樥  㬥⮢
%Type        control
%Specific    SYS
%Modified    25.04.2014 17:21:53 POLAK\GAV
%Environment
*)

 MODULE ODoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_ODoc, L_Events, L_XDoc, FIO, Shell, L_Dspt, E_ODoc,
        L_Dspt, L_Str, Str, L_APtm, Memo, L_EDO, L_Staff, P_Firm, L_AFM,
        L_OwnData, L_DatTim, L_Basis, P_Cntr, L_WDO, L_lsStore, L_Prop,
        L_Pool, L_BarCode, L_StdFrm, L_Way, L_Env, L_BegRWS, P_Man, L_Sheet,
        P_Officer, P_ODoc, L_Cntr, L_EC, L_bp, P_EDOKnd, L_r2r, L_Man,
        L_Car, L_XDF, L_kn;

 PRIVATE CONST
  pool_AMOComplaints        = 0000982;

  v_AMO_Type              = "v_AMO_Type";
  v_AMO_Time              = "v_AMO_Time";
  v_AMO_EDOStr            = "v_AMO_EDOStr";
  v_AMO_Kind              = "v_AMO_Kind";
  v_AMO_Descript          = "v_AMO_Descript";
  v_AMO_AlcoholTestResult = "v_AMO_AlcoholTestResult";
  v_AMO_ATR1              = "v_AMO_ATR1";
  v_AMO_ATR2              = "v_AMO_ATR2";
  v_AMO_ATR3              = "v_AMO_ATR3";
  v_AMO_Complaints        = "v_AMO_Complaints";
  v_AMO_Temperature       = "v_AMO_Temperature";
  v_AMO_Pulse             = "v_AMO_Pulse";
  v_AMO_PressureHigh      = "v_AMO_PressureHigh";
  v_AMO_PressureLow       = "v_AMO_PressureLow";
  v_AMO_ATR1_Name         = "v_AMO_ATR1_Name";
  v_AMO_ATR3_Name         = "v_AMO_ATR3_Name";
  v_ManName               = "v_ManName";
  v_ODoc_SingleRefDocName = "v_ODoc_SingleRefDocName";
  v_ODoc_SingleRefDoc     = "v_ODoc_SingleRefDoc";
  v_ODoc_SingleRefDocT    = "v_ODoc_SingleRefDocT";
  v_ODoc_SingleRefDocKind = "v_ODoc_SingleRefDocKind";
  v_ODoc_Descr            = "v_ODoc_Descr";
  v_WarningStr            = "v_WarningStr";
  v_Template              = "v_Template";

  hncp_Pool_Scal2 = "㬥 ଫ ࠢ쭮|, 㬥 ଫ";
  hncp_Pool_Scal3 = hncp_Pool_Scal2 + "|⪮ ";
  hncp_No       = 0;
  hncp_Yes      = 1;
  hncp_NoDefect = 2;

 PRIVATE PROCEDURE E_GetReferenceXDocKindId(trgDate: DATE): L_XDoc.tXDocKindId;
  VAR
   Result: L_XDoc.tXDocKindId;
 BEGIN
  SETEMPTY(Result);
  IF    L_kn.Is(trgDate, L_ODoc.erkn_ContractMessage) |
        L_kn.Is(trgDate, L_ODoc.erkn_ContractAddIns)  |
        L_kn.Is(trgDate, L_ODoc.erkn_IngoingContractChange) THEN
   Result:=L_XDoc.XDocKindId(L_XDoc.xdt_Contract, L_XDoc.EmptyXDocKind);
  ELSIF L_kn.Is(trgDate, L_ODoc.erkn_MedicalExaminationAct) |
        L_kn.Is(trgDate, L_ODoc.erkn_RAccid) THEN
   Result:=L_XDoc.XDocKindId(L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind);
  ELSIF L_kn.Is(trgDate, L_ODoc.erkn_ForeignManMedExamAct) THEN
   Result:=L_XDoc.XDocKindId(L_XDoc.xdt_Man, L_XDoc.EmptyXDocKind);
  END;
  RETURN Result;
 END {E_GetReferenceXDocKindId};

 PRIVATE PROCEDURE IsBuildDocByBCS(): SCAL[2];
 BEGIN
  RETURN ~!L_WDO.AccessEnvVar("BuildDocByBCS");
 END {IsBuildDocByBCS};

 PRIVATE PROCEDURE SetDocName(xdid: L_XDoc.tXDocId);
  CONST
   ContractDescrLength = 64-1;
  VAR
   xdt             : L_XDoc.tXDocType;
   xdknd           : L_XDoc.tXDocKind;
   xd              : L_XDoc.tXDoc;
   ContractDescr   : STRING[][3];
   SingleRefDocName: STRING[];
 BEGIN
  IF ~!RTI.Get().CurZone.Fields(v_ODoc_SingleRefDocName) THEN
   IF ~!xdid THEN
    L_XDoc.PositionOnXDoc(xdid);
    L_XDoc.DecodeXDocId(xdid, xdt, xdknd, xd);
    IF xdt = L_XDoc.xdt_Contract THEN
     CONFORM(Contract, CntrT);
     CONFORM(Contract, Firm);
     ContractDescr[0]:=Contract.Name;
     ContractDescr[1]:=" " + Str.Align(Contract.SrcNbr, 16, LEFT) +
                       "  " + L_DatTim.DateStr(Contract.SrcDate) +
                       "  " + FLDTOSTR(Contract.CntrT, "L", 2) + " " + CntrT.Name;
     ContractDescr[2]:=Contract.Firm + " " + P_Firm.FP_FirmName(Contract.Firm, ODoc.Date);
     SingleRefDocName:=Str.Align(ContractDescr[0], ContractDescrLength, LEFT) + L_Str.CRLF +
                       Str.Align(ContractDescr[1], ContractDescrLength, LEFT) + L_Str.CRLF +
                       Str.Align(ContractDescr[2], ContractDescrLength, LEFT);
    ELSE
     SingleRefDocName:=L_XDoc.XDocStr(xdid);
    END;
   ELSE
    SETEMPTY(SingleRefDocName);
   END;
   RTI.Get().CurZone.Fields(v_ODoc_SingleRefDocName).Value:=SingleRefDocName;
  END;
 END {SetDocName};

 PRIVATE PROCEDURE SetODocFirmByReferenceDocument(xdid: L_XDoc.tXDocId);
 BEGIN
  SETEMPTY(ODoc.Firm);
  IF ~!xdid THEN
   ODoc.Firm:=L_XDoc.GetFirmByXDocId(xdid);
  END;
  REPLACE(ODoc);
 END {SetODocFirmByReferenceDocument};

 PRIVATE PROCEDURE SingleRefToXDocType(): L_XDoc.tXDocType;
  VAR
   xdt  : L_XDoc.tXDocType;
   xdknd: L_XDoc.tXDocKind;
 BEGIN
  CONFORM(ODoc, ODocKind);
  L_XDoc.DecodeXDocKindId(E_GetReferenceXDocKindId(ODoc.Date), xdt, xdknd);
  RETURN xdt;
 END {SingleRefToXDocType};

 PRIVATE PROCEDURE SingleRefToXDocKind(): L_XDoc.tXDocKind;
  VAR
   xdt  : L_XDoc.tXDocType;
   xdknd: L_XDoc.tXDocKind;
 BEGIN
  CONFORM(ODoc, ODocKind);
  L_XDoc.DecodeXDocKindId(E_GetReferenceXDocKindId(ODoc.Date), xdt, xdknd);
  RETURN xdknd;
 END {SingleRefToXDocKind};

 PRIVATE PROCEDURE SingleRefToXDoc(): L_XDoc.tXDoc;
  VAR
   xdt  : L_XDoc.tXDocType;
   xdknd: L_XDoc.tXDocKind;
   xd   : L_XDoc.tXDoc;
 BEGIN
  L_XDoc.DecodeXDocId(L_ODoc.curRefToXDoc_GetId(), xdt, xdknd, xd);
  RETURN xd;
 END {SingleRefToXDoc};

 PRIVATE PROCEDURE SetAddInsDescription();
  VAR
   xd                : L_XDoc.tXDoc;
   Template,
   AddInsVersionAsStr: STRING[];
 BEGIN
  SETEMPTY(Template);
  IF (ODoc.ODocKind = L_kn.GetSoft(SYSDATE(), L_ODoc.erkn_ContractAddIns)) THEN
   xd:=SingleRefToXDoc();
   IF ~!xd & ~!ODoc.Date THEN
    Template:=P_Cntr.GetContractAddInsTemplateName(xd, ODoc.Sense, ODoc.Date);
   END;
  END;
  IF ~!RTI.Get().CurZone.Fields(v_Template) THEN
   RTI.Get().CurZone.Fields(v_Template).Value:=Template;
  END;
 END {SetAddInsDescription};

 PRIVATE PROCEDURE ODoc__OnBeforeAskForEdit();
 BEGIN
  IF SingleRefToXDocType() # L_XDoc.xdt_Contract THEN
   L_XDoc.PositionInVideoSystem(L_XDoc.pm_WaitUserChoice, L_ODoc.curRefToXDoc_GetId(), "ODoc.AfterAsk()");
  END;
 END {ODoc__OnBeforeAskForEdit};

 PRIVATE PROCEDURE ODoc__OnAskPhase1();
 BEGIN
IF ~!L_ODoc.curRefToXDoc_GetId() THEN
 IF    (SingleRefToXDocType() = L_XDoc.xdt_Contract) & SEARCH(Contract, Contract, SingleRefToXDoc()) THEN
  L_WDO.PositionInOwnerZoneOfActiveField("Contract");
 ELSIF (SingleRefToXDocType() = L_XDoc.xdt_Man)      & SEARCH(Man,      Man,      SingleRefToXDoc()) THEN
  L_WDO.PositionInOwnerZoneOfActiveField("Man");
 END;
END;
 END {ODoc__OnAskPhase1};

 PRIVATE PROCEDURE ODoc__OnAskPhase2();
 BEGIN
  IF    (SingleRefToXDocType() = L_XDoc.xdt_Contract) THEN
   RTI.Get().CurZone.Fields(v_ODoc_SingleRefDoc).Value:=Contract.Contract;
  ELSIF (SingleRefToXDocType() = L_XDoc.xdt_Man) THEN
   RTI.Get().CurZone.Fields(v_ODoc_SingleRefDoc).Value:=Man.Man;
  END;
 END {ODoc__OnAskPhase2};

 PRIVATE PROCEDURE AddReference(xdid: L_XDoc.tXDocId);
 BEGIN
  L_XDoc.rf_Insert(L_XDoc.xdt_ODoc, xdid, L_XDoc.rft_RefTo);
 END {AddReference};

 PRIVATE PROCEDURE RemoveReference(xdid: L_XDoc.tXDocId);
 BEGIN
  L_XDoc.rf_Remove(L_XDoc.xdt_ODoc, xdid, L_XDoc.rft_RefTo);
 END {RemoveReference};

 PRIVATE PROCEDURE CheckStaff(trgTSN: LIKE(Staff.TSN));
 BEGIN
  IF ~!trgTSN THEN
   SEARCH(Staff, TSN, , trgTSN);
   L_Staff.PosToStaffLog(Staff.TSN, ODoc.Date, 1);
   IF ~L_Staff.rInState(ODoc.Date) THEN
    L_StdFrm.Choice("⭨  ⮨    " + L_DatTim.DateStr(ODoc.Date));
   END;
  END;
 END {CheckStaff};

 PRIVATE PROCEDURE ODoc_TSN_OnSuccessfulChange();
  VAR
   InRiskGroup: SCAL[2];
 BEGIN
  CheckStaff(ODoc.TSN);
  CONFORM(ODoc, ODocKind);
  IF L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct) THEN
   IF ~!ODoc.TSN THEN
    CONFORM(ODoc, Staff);
    CONFORM(Staff, Man);
    IF    L_DatTim.IsBirthDay(Man.Birth, ODoc.SrcDate)     THEN
     L_StdFrm.RedInform("  ஦");
    ELSIF L_DatTim.IsBirthDay(Man.Birth, ODoc.SrcDate - 1) THEN
     L_StdFrm.RedInform("   ஦");
    END;
    L_Staff.PosToStaffLog(Staff.TSN, ODoc.Date, 1);
    CONFORM(StaffLog, Officer);
    InRiskGroup:=P_Man.InRiskGroup(Staff.Man, ODoc.Date, L_Env.IsDriver());
   ELSE
    InRiskGroup:=0;
   END;
   L_WDO.getFieldInActiveZone(v_AMO_PressureHigh).MustBeNonempty:=InRiskGroup;
   L_WDO.getFieldInActiveZone(v_AMO_PressureLow).MustBeNonempty :=InRiskGroup;
   SetWarningStr();
  END;
 END {ODoc_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE asODoc_RefDoc_OnSuccessfulChange(newRefDocT: L_XDoc.tXDocType;
                                                    newRefDocK: L_XDoc.tXDocKind;
                                                    newRefDoc : L_XDoc.tXDoc);
  VAR
   prvRefToXDocId,
   newRefToXDocId : L_XDoc.tXDocId;
   DummyStr       : STRING[];
   DummyTSN       : LIKE(Staff.TSN);
 BEGIN
  L_General.Assert(~!ODoc.Date, " 㪠  㬥");
  CONFORM(ODoc, ODocKind);
  prvRefToXDocId:=L_ODoc.curRefToXDoc_GetId();
  IF ~!prvRefToXDocId THEN
   RemoveReference(prvRefToXDocId);
  END;

  IF ~!newRefDoc THEN
   IF newRefDocT = L_XDoc.xdt_Staff THEN
    L_General.Assert(SEARCH(Staff, TSN, newRefDoc), "  ⠡  " + FLDTOSTR(newRefDoc, "", 5));
    ODoc.TSN:=newRefDoc;
    REPLACE(ODoc);
    ODoc_TSN_OnSuccessfulChange();
   ELSE
    newRefToXDocId:=L_XDoc.XDocId(newRefDocT, newRefDocK, newRefDoc);
    L_General.Assert(L_XDoc.StandOnXDoc(newRefToXDocId),  "  㬥");
    AddReference(newRefToXDocId);
    IF L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct) THEN
     IF newRefDocT = L_XDoc.xdt_RWayS THEN
      L_ODoc.curRefToXDoc_PositionOn(L_XDoc.xdt_RWayS);
      L_General.Assert(RWayS.Status = L_Way.rwsStat_Given, '    ﭨ "뤠"');
      L_General.Assert(L_Env.RealTSN(RWayS.TSN),           ' 뤠  䨪⨢ ⥫');
      IF ~!ODoc.TSN & (RWayS.TSN # ODoc.TSN) THEN
       L_StdFrm.CrucialChoice("⥢  뤠  㣮 ⥫." +
                              "||⢨⥫쭮  㪠  ࠡ⭨?", L_APtm.g_MedInsp);
      END;
      ODoc.TSN:=RWayS.TSN;
      REPLACE(ODoc);
      ODoc_TSN_OnSuccessfulChange();
     ELSE
      L_General.CallUs(0);
     END;
    ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_ForeignManMedExamAct) THEN
     IF newRefDocT = L_XDoc.xdt_Man THEN
      L_ODoc.curRefToXDoc_PositionOn(L_XDoc.xdt_Man);
      L_General.Assert(~Man.rStaff, " ᫥ ஢   ࠡ⭨ ।");
      P_Man.GetAccessOutsiderInf(Man.Man, SYSDATE(), ODoc.Firm, DummyStr, DummyTSN);
      L_General.Assert(~!ODoc.Firm, " । ࠣ, ।⠢⥫ ண |" +
                                    Man.Name + "||(. -  5202)");
      REPLACE(ODoc);
      RTI.Get().CurZone.Fields(v_ManName).Value:=Man.Name;
     ELSE
      L_General.CallUs(0);
     END;
    ELSE
     IF newRefDocT = L_XDoc.xdt_Contract THEN
      L_Cntr.CheckIsContract();
      L_General.Assert(ODoc.MyFirm = Contract.MyFirm,
                       "'' ࣠   (" + Contract.MyFirm +
                       ") ⫨砥  㪠  祬 㬥 (" + ODoc.MyFirm + ")");
     END;
     SetDocName(newRefToXDocId);
     SetODocFirmByReferenceDocument(newRefToXDocId);
    END;
   END;
  END;
  SetAddInsDescription();
  L_WDO.SetFieldModifiable("ODoc.TSN", !newRefDoc);
 END {asODoc_RefDoc_OnSuccessfulChange};

 PRIVATE PROCEDURE FillEDOKindDescr(trgEDOKind: LIKE(EDOKind.EDOKind));
  VAR
   Min, Max        : NUMERIC[3];
   EDOKind_Interval: STRING[];
 BEGIN
  SETEMPTY(EDOKind_Interval);
  IF ~!trgEDOKind THEN
   L_General.Assert(~!ODoc.Date, "   襭");
   P_EDOKnd.Get_AnyInterval(trgEDOKind, ODoc.Date, P_EDOKnd.P_ProcInterval, Min, Max);
   IF ~!Min & ~!Max THEN
    EDOKind_Interval:=" 業⮢:  " + FLDTOSTR(Min, "2.", 0) + "  " + FLDTOSTR(Max, "2.", 0) + L_Str.CRLF;
   END;
   P_EDOKnd.Get_AnyInterval(trgEDOKind, ODoc.Date, P_EDOKnd.P_SumInterval, Min, Max);
   IF ~!Min & ~!Max THEN
    EDOKind_Interval:=EDOKind_Interval +
                      " 㬬     :  " + FLDTOSTR(Min, "2.", 0) + "  " + FLDTOSTR(Max, "2.", 0) + L_Str.CRLF;
   END;
  END;
  RTI.Get().CurZone.Fields("EDOKind_Interval").Value:=EDOKind_Interval;
 END {FillEDOKindDescr};

 PRIVATE PROCEDURE ODoc_ODoc_Staff_OnSuccessfulChange();
 BEGIN
  CheckStaff(RTI.Get().CurZone.ActiveField.Value);
 END {ODoc_ODoc_Staff_OnSuccessfulChange};

 PRIVATE PROCEDURE ODoc__OnSuccessfulChange();
  VAR
   Fields     : FORM_FIELDS;
   ActiveField: FORM_FIELD;
 BEGIN
  ActiveField:=RTI.Get().CurZone.ActiveField;
  Fields     :=RTI.Get().CurZone.Fields;
  IF    ActiveField.ExplicitName = v_AMO_Complaints THEN
   L_Pool.Put(pool_AMOComplaints, ActiveField.Value);
   Fields(v_AMO_Complaints).Template        :=L_Pool.Get(pool_AMOComplaints);
  ELSIF (ActiveField.ExplicitName = v_AMO_ATR1) |
        (ActiveField.ExplicitName = v_AMO_ATR2) |
        (ActiveField.ExplicitName = v_AMO_ATR3) THEN
   Fields(v_AMO_ATR2).Modifiable             :=Fields(v_AMO_ATR1).Value > 0;
   Fields(v_AMO_ATR3).Modifiable             :=Fields(v_AMO_ATR1).Value > 0;
   Fields(v_AMO_AlcoholTestResult).Modifiable:=Fields(v_AMO_ATR1).Value > 0;
   IF    ~!Fields(v_AMO_ATR2).Value THEN
    Fields(v_AMO_AlcoholTestResult).Value:=Fields(v_AMO_ATR2).Value;
   ELSIF ~!Fields(v_AMO_ATR3).Value THEN
    IF Fields(v_AMO_ATR3).Value <= 0.01 THEN
     Fields(v_AMO_AlcoholTestResult).Value:=0;
    END;
   ELSE
    Fields(v_AMO_AlcoholTestResult).Value:=~!Fields(v_AMO_ATR1).Value & (Fields(v_AMO_ATR1).Value > 0.01);
   END;
  ELSIF ActiveField.ExplicitName = "EDOKind" THEN
   FillEDOKindDescr(ActiveField.Value);
  ELSIF ActiveField.ExplicitName = "AuthorTSN" THEN
  (*祣  *)
  ELSIF ActiveField.ExplicitName = "RAccid_Time" THEN
   L_General.CallUs(SEARCH(RAccid, XDocId, ODoc.XDocId));
   RAccid.Time:=ActiveField.Value;
   REPLACE(RAccid);
  ELSIF ActiveField.ExplicitName = "RAccid_Place" THEN
   L_General.CallUs(SEARCH(RAccid, XDocId, ODoc.XDocId));
   RAccid.Place:=ActiveField.Value;
   REPLACE(RAccid);
   L_Pool.Put(L_ODoc.p_pool, RAccid.Place);
   ActiveField.Template:=L_Pool.Get(L_ODoc.p_pool);
  ELSIF ActiveField.ExplicitName = "RAccid_Kind" THEN
   L_General.CallUs(SEARCH(RAccid, XDocId, ODoc.XDocId));
   RAccid.Kind:=ActiveField.Value;
   REPLACE(RAccid);
  ELSIF ActiveField.ExplicitName = "RAccid_CntPass" THEN
   L_General.CallUs(SEARCH(RAccid, XDocId, ODoc.XDocId));
   RAccid.CntPass:=ActiveField.Value;
   REPLACE(RAccid);
  ELSIF ActiveField.ExplicitName = "RAccid_RWayS" THEN
   L_General.CallUs(SEARCH(RWayS, RWayS, ActiveField.Value));
   IF RWayS.Status # L_Way.rwsStat_Rated THEN
    L_StdFrm.Choice(" " + RWayS.RWayS + "  ⠪஢");
   END;
   ODoc.TSN    :=RWayS.TSN;
   ODoc.Date   :=RWayS.Date;
   REPLACE(ODoc);
   L_General.CallUs(SEARCH(RAccid, XDocId, ODoc.XDocId));
   RAccid.RWayS:=RWayS.RWayS;
   REPLACE(RAccid);
   L_General.CallUs(SEARCH(Car, BoxNbr, RWayS.BoxNbr));
   L_Car.AccessMark(Car.BoxNbr, RWayS.Date);
   Fields("Car_BoxNbr"  ).Value:=Car.BoxNbr;
   Fields("Car_StateNbr").Value:=Car.StateNbr;
   Fields("Mark_Mark"   ).Value:=Mark.Mark;
   Fields("Mark_Name"   ).Value:=Mark.Name;
   SETEMPTY(Fields("RAccid_Time").Value);
   asODoc_RefDoc_OnSuccessfulChange(SingleRefToXDocType(),
                                    SingleRefToXDocKind(),
                                    RWayS.RWayS);
  ELSIF ActiveField.ExplicitName = "RAccid_Intoxic" THEN
   L_General.CallUs(SEARCH(RAccid, XDocId, ODoc.XDocId));
   RAccid.Intoxic:=ActiveField.Value;
   REPLACE(RAccid);
  ELSIF ActiveField.ExplicitName = "HasNonCriticalProblem" THEN
   Fields("MsgProblem").Visible:=1;
   MsgProblem_SetColor(RTI.Get().CurWindow);
  ELSE
   asODoc_RefDoc_OnSuccessfulChange(SingleRefToXDocType(),
                                    SingleRefToXDocKind(),
                                    Fields(v_ODoc_SingleRefDoc).Value);
  END;
 END {ODoc__OnSuccessfulChange};

 PRIVATE PROCEDURE MsgProblem_SetColor(W: FORM_WINDOW);
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=W.Zones(0).Fields;
  IF    Fields("HasNonCriticalProblem").Value = hncp_No THEN
   Fields("MsgProblem").Color:=FORM_FIELD.Color_Text;
  ELSIF Fields("HasNonCriticalProblem").Value = hncp_Yes THEN
   Fields("MsgProblem").Color:=FORM_FIELD.Color_MarkedRecord;
  END;
 END {MsgProblem_SetColor};

 PRIVATE PROCEDURE ra_HasNonCriticalProblem(VAR MsgProblem: STRING[]): SCAL[2];
  VAR
   Result   : SCAL[2];
   NumViolat: NUMERIC[0];
   VilIdx   : SCAL[L_ODoc.CntViolat];
   Violat   : STRING[][L_ODoc.CntViolat];
 BEGIN
  SETEMPTY(MsgProblem);
  IF !RAccid.DatInsLS THEN
   INC(MsgProblem, " 㪠  ᫥ ⠦  " + L_Str.CRLF);
  END;
  IF !RAccid.DatInsRR THEN
   INC(MsgProblem, " 㪠  ᫥ ⠦  " + L_Str.CRLF);
  END;
  L_ODoc.Decode_Violat(RAccid.Violat, Violat);
  NumViolat:=0;
  FOR_EACH VilIdx DO
   IF ~!Violat[VilIdx] THEN
    INC(NumViolat);
   END;
  END;
  IF NumViolat = 0 THEN
   INC(MsgProblem, "   襭 " + L_Str.CRLF);
  END;
  IF ~SELECT(RAMemb, RAccid, RAccid.XDocId) THEN
   INC(MsgProblem, " 㣨 ⭨ " + L_Str.CRLF);
  END;
  IF ~L_XDoc.xdf_StandOnActual(RAccid.XDocId, L_XDoc.xdfk_SchemaRA) THEN
   L_General.CallUs(SEARCH(XDFKind, XDFKind, L_XDoc.xdfk_SchemaRA));
   INC(MsgProblem, " ਪ९ 䠩 ⨯ '" + XDFKind.Name + "'" + L_Str.CRLF);
  END;
  Result:=~!MsgProblem;
  RETURN Result;
 END {ra_HasNonCriticalProblem};

 PRIVATE PROCEDURE ram_CheckCarsHasDrivers(Soft: SCAL[2]);
  VAR
   CarName: LIKE(RAMemb.Name);
 BEGIN
  SELECT(RAMemb, RAccid, , RAccid.XDocId, L_ODoc.t_Car);
  WHILE OCCURE(RAMemb) DO
   CarName:=RAMemb.Name;
   SAVE(RAMemb);
   IF ~L_ODoc.ram_StandOnDriver() THEN
    L_StdFrm.ConditionalCHOICE("  '" + CarName + "'  㪠 ⥫", Soft);
   END;
   RESTORE(RAMemb);
   NEXT(RAMemb);
  END; (* WHILE OCCURE(RAMemb) ... *)
 END {ram_CheckCarsHasDrivers};

 PRIVATE PROCEDURE ram_CheckDmgS(Soft: SCAL[2]);
  VAR
   Msg: STRING[];
 BEGIN
  SELECT(RAMemb, Dmg, , RAccid.XDocId);
  WHILE OCCURE(RAMemb) DO
   IF (RAMemb.Dmg # L_ODoc.d_NoInjuries) & !RAMemb.DmgS THEN
    IF    RAMemb.Type = L_ODoc.t_Car THEN
     Msg:="  ଠ  ࡥ  '" + RAMemb.Name + "'";
    ELSIF RAMemb.Type = L_ODoc.t_Man THEN
     Msg:="  ଠ  ࡥ ⭨|" + L_Str.PoolItem(L_ODoc.w_Pool, RAMemb.Who) + " " + RAMemb.Name;
    ELSE
     L_General.CallUs();
    END;
    L_StdFrm.ConditionalCHOICE(Msg, Soft);
   END;
   NEXT(RAMemb);
  END; (* WHILE OCCURE(RAMemb) ... *)
 END {ram_CheckDmgS};

 PRIVATE PROCEDURE ra_CheckCriticalProblem();
 BEGIN
  L_General.CallUs(SEARCH(RAccid, XDocId, ODoc.XDocId));
  L_ODoc.StandOnRWayJByCurRAccid(0);
  ram_CheckCarsHasDrivers(0);
  ram_CheckDmgS(0);
  L_General.Assert(~!RAccid.Descr,    " ᠭ ");
  L_General.Assert(~!RAccid.Explanat, " ᭥ ⥫");
  L_General.Assert(~!RAccid.OurDmgS,  " 㪠 㬬 襣 ࡠ");
 END {ra_CheckCriticalProblem};

 PRIVATE PROCEDURE ODoc_OnBeforeEdIns(action: LIKE(XDocJrn.Action));
  VAR
   Fields               : FORM_FIELDS;
   refXDoc              : L_XDoc.tXDocId;
   AMO_Time             : TIME;
   AMO_Kind,
   AMO_Descript         : STRING[];
   AMO_AlcoholTestResult: SCAL[2];
   AMO_ATR1             : NUMERIC[2];
   AMO_ATR2             : SCAL[2];
   AMO_ATR3             : NUMERIC[2];
   AMO_Complaints       : STRING[];
   AMO_Temperature      : NUMERIC[4,1];
   AMO_Pulse            : NUMERIC[4,0];
   AMO_PressureHigh,
   AMO_PressureLow      : NUMERIC[4,0];
 BEGIN
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc, action);
  Fields:=RTI.Get().CurZone.Fields;
  CONFORM(ODoc, ODocKind);

  IF ODocKind.TSNRole = L_ODoc.tsnr_Initiator THEN
   IF !Fields("ODoc_Staff") THEN
    L_General.InformUs("   " + ODocKind.ODocKind + " ᠭ  㪠 '樠',|" +
                       "   '" + RTI.Get().CurWindow.Name + "'  |" +
                       " 㪠 'ࠡ⭨'");
   END;
  END;

  IF ~!Fields("ODoc.SrcNbr") THEN
   Fields("ODoc.SrcNbr").Modifiable    :=ODocKind.sn_Modif;
   Fields("ODoc.SrcNbr").MustBeNonempty:=1;
  END;
  IF ~!Fields("ODoc.Firm") THEN
   Fields("ODoc.Firm").Modifiable:=(ODocKind.Scope = L_ODoc.odks_External) &
                                   ~L_kn.Is(ODoc.Date, L_ODoc.erkn_ForeignManMedExamAct);
  END;

  IF L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct) |
     L_kn.Is(ODoc.Date, L_ODoc.erkn_ForeignManMedExamAct) THEN
   L_ODoc.amo_DecodeDescription(AMO_Time, AMO_Kind, AMO_Descript, AMO_AlcoholTestResult,
                                AMO_ATR1, AMO_ATR2, AMO_ATR3, AMO_Complaints, AMO_Temperature,
                                AMO_Pulse, AMO_PressureHigh, AMO_PressureLow);
   Fields(v_AMO_ATR2).Modifiable             :=AMO_ATR1 > 0;
   Fields(v_AMO_ATR3).Modifiable             :=AMO_ATR1 > 0;
   Fields(v_AMO_AlcoholTestResult).Modifiable:=AMO_ATR1 > 0;
   refXDoc:=L_ODoc.curRefToXDoc_GetId();
   Fields("ODoc.SrcDate").Modifiable         :=!refXDoc;
   Fields(v_AMO_Time).Modifiable             :=!refXDoc;
   Fields(v_AMO_ATR1).First                  :=~!refXDoc;
   IF L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct) THEN
    Fields("ODoc.TSN").Modifiable               :=!refXDoc;
    Fields("ODoc.TSN").First                    :=!refXDoc;
    ODoc_TSN_OnSuccessfulChange();
   END;
  END;
  IF L_kn.Is(ODoc.Date, L_ODoc.erkn_RAccid) THEN
   IF action = L_XDoc.action_Insert THEN
    DEFAULT(RAccid);
    RAccid.XDocId:=ODoc.XDocId;
    INSERT(RAccid);
   ELSE
    L_General.CallUs(SEARCH(RAccid, XDocId, ODoc.XDocId));
   END;
  END;
 END {ODoc_OnBeforeEdIns};

 PRIVATE PROCEDURE CheckODocModificationRequiredBCS();
 BEGIN
(*
  IF (L_BegRWS.E_UsingBarCodeScannerLevel(L_BegRWS.ubcr_Medic) = L_BarCode.bcsl_Normal) THEN
   L_StdFrm.ConditionalCHOICE("䨪 㬥 ࠧ蠥" +
                              "|⮫쪮  ᯮ짮 ᪠ -", L_General.IsAdmin());
  END;
*)
 END {CheckODocModificationRequiredBCS};

 PRIVATE PROCEDURE amo_PutDescript();
  VAR
   Fields : FORM_FIELDS;
 BEGIN
  SETEMPTY(ODoc.Descript);
  Fields:=RTI.Get().CurZone.Fields;
  L_Prop.putRecordElement_T  (ODoc.Descript, Fields(v_AMO_Time).Value);
  L_Prop.putRecordElement_Str(ODoc.Descript, Fields(v_AMO_Kind).Value);
  L_Prop.putRecordElement_Str(ODoc.Descript, Fields(v_AMO_Descript).Value);
  L_Prop.putRecordElement    (ODoc.Descript, Fields(v_AMO_AlcoholTestResult).Value);
  L_Prop.putRecordElement_Str(ODoc.Descript, Fields(v_AMO_Complaints).Value);
  L_Prop.putRecordElement    (ODoc.Descript, Fields(v_AMO_Temperature).Value);
  L_Prop.putRecordElement    (ODoc.Descript, Fields(v_AMO_Pulse).Value);
  L_Prop.putRecordElement    (ODoc.Descript, Fields(v_AMO_PressureHigh).Value);
  L_Prop.putRecordElement    (ODoc.Descript, Fields(v_AMO_PressureLow).Value);
  L_Prop.putRecordElement    (ODoc.Descript, Fields(v_AMO_ATR1).Value);
  L_Prop.putRecordElement    (ODoc.Descript, Fields(v_AMO_ATR2).Value);
  L_Prop.putRecordElement    (ODoc.Descript, Fields(v_AMO_ATR3).Value);
  REPLACE(ODoc);
 END {amo_PutDescript};

 PRIVATE PROCEDURE ODocWindowName(): STRING[];
  VAR
   XDocType: L_XDoc.tXDocType;
   Dummy   : L_XDoc.tXDocKind;
 BEGIN
  AccessODocKind();
  IF    L_kn.Is(SYSDATE(), L_ODoc.erkn_ContractMessage) THEN
   RETURN "ODE_CnMs";
  ELSIF L_kn.Is(SYSDATE(), L_ODoc.erkn_IngoingContractChange) THEN
   RETURN "ODE_CnChg";
  ELSIF L_kn.Is(SYSDATE(), L_ODoc.erkn_FirmMessage) THEN
   RETURN "ODE_FrMs";
  ELSIF L_kn.Is(SYSDATE(), L_ODoc.erkn_StaffExplanatoryNote) THEN
   RETURN "ODoc01";
  ELSIF L_kn.Is(SYSDATE(), L_ODoc.erkn_MedicalExaminationAct) THEN
   RETURN "OD_AMO";
  ELSIF L_kn.Is(SYSDATE(), L_ODoc.erkn_ForeignManMedExamAct) THEN
   RETURN "OD_AMOFM";
  ELSIF L_kn.Is(SYSDATE(), L_ODoc.erkn_RAccid) THEN
   RETURN "OD_RAcc";
  ELSIF L_kn.Is(SYSDATE(), L_ODoc.erkn_ViolationAct) THEN
   RETURN "OD_VA";
  ELSE
   L_XDoc.DecodeXDocKindId(E_GetReferenceXDocKindId(SYSDATE()), XDocType, Dummy);
   IF XDocType = L_XDoc.xdt_Contract THEN
    RETURN "ODocECnt";
   END;
  END;

  IF ODocKind.Scope = L_ODoc.odks_Internal THEN
   RETURN "ODoc01";
  ELSE
   RETURN "ODocE";
  END;
 END {ODocWindowName};

 PRIVATE PROCEDURE ODoc_OnBeforeInsert();
  VAR
   xdt      : L_XDoc.tXDocType;
   xdknd    : L_XDoc.tXDocKind;
   xd       : L_XDoc.tXDoc;
   DummyStr,
   ErrorMsg : STRING[];
   Fields   : FORM_FIELDS;
   DummyTSN : LIKE(Staff.TSN);
 BEGIN
  ODoc.XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_ODoc);
  ODoc.MyFirm:=P_Firm.DefineMyFirm();
  SETEMPTY(ODoc.mfNbr);
  REPLACE(ODoc);
  CONFORM(ODoc, ODocKind);
  ODoc.Status:=ODocKind.DfStatus;
  IF L_kn.Is(SYSDATE(), L_ODoc.erkn_MedicalExaminationAct) |
     L_kn.Is(SYSDATE(), L_ODoc.erkn_ForeignManMedExamAct) THEN
   Fields:=RTI.Get().CurZone.Fields;
   ODoc.SrcDate:=SYSDATE();
   Fields(v_AMO_Time).Value:=SYSTIME();
   ODoc.Date   :=L_BegRWS.DspDate(ODoc.SrcDate, SYSTIME());
   SETZERO(Fields(v_AMO_AlcoholTestResult).Value,
           Fields(v_AMO_ATR1).Value,
           Fields(v_AMO_ATR3).Value);
   IF L_kn.Is(SYSDATE(), L_ODoc.erkn_MedicalExaminationAct) THEN
    SETEMPTY(Fields(v_AMO_EDOStr).Value);
   END;
   SETEMPTY(Fields(v_AMO_Kind).Value,
            Fields(v_AMO_Descript).Value,
            Fields(v_AMO_ATR2).Value,
            Fields(v_AMO_Complaints).Value,
            Fields(v_AMO_Temperature).Value,
            Fields(v_AMO_Pulse).Value,
            Fields(v_AMO_PressureHigh).Value,
            Fields(v_AMO_PressureLow).Value);
   amo_PutDescript();
  END;

  IF IsBuildDocByBCS() THEN
   L_XDoc.DecodeXDocId(L_XDoc.ref_XDocId, xdt, xdknd, xd);
   IF ~!Fields(v_ODoc_SingleRefDocT) THEN
    Fields(v_ODoc_SingleRefDocT).Value:=xdt;
   END;
   IF ~!Fields(v_ODoc_SingleRefDocKind) THEN
    Fields(v_ODoc_SingleRefDocKind).Value:=xdknd;
   END;
   IF    xdt = L_XDoc.xdt_RWayS THEN
    L_XDoc.PositionOnXDoc(L_XDoc.ref_XDocId);
    ErrorMsg:=L_BegRWS.CheckAcceptableAction(L_BegRWS.GetRWaySActualAction(), L_XDoc.action_MedicalExamination);
    IF ~!ErrorMsg THEN
     L_General.Error(ErrorMsg);
    END;
    ODoc.TSN:=RWayS.TSN;
   ELSIF xdt = L_XDoc.xdt_Staff THEN
    ODoc.TSN:=xd;
   ELSIF xdt = L_XDoc.xdt_Man THEN
    L_XDoc.PositionOnXDoc(L_XDoc.ref_XDocId);
    Fields(v_ManName).Value:=Man.Name;
    P_Man.GetAccessOutsiderInf(Man.Man, SYSDATE(), ODoc.Firm, DummyStr, DummyTSN);
   END;
   asODoc_RefDoc_OnSuccessfulChange(xdt, xdknd, xd);
  ELSE
   CheckODocModificationRequiredBCS();
  END;
  REPLACE(ODoc);
  ODoc.SrcNbr:=L_ODoc.E_DefaultODocSrcNbr(ODoc.Date);
  REPLACE(ODoc);
  ODoc_OnBeforeEdIns(L_XDoc.action_Insert);
 END {ODoc_OnBeforeInsert};

 PRIVATE PROCEDURE ODoc_OnBeforeEdit();
  VAR
   reqToXDocId    : L_XDoc.tXDocId;
   xdt            : L_XDoc.tXDocType;
   xdknd          : L_XDoc.tXDocKind;
   xd             : L_XDoc.tXDoc;
   action         : LIKE(XDocJrn.Action);
   rwsActionTime,
   amoActionTimeB,
   amoActionTimeE : FLOAT;
 BEGIN
  CONFORM(ODoc, ODocKind);
  L_General.Assert_wReferToAdmin(~L_XDoc.XDocIsSent(L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc),
                                 "㬥 ࠢ");
  IF    L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct) |
        L_kn.Is(ODoc.Date, L_ODoc.erkn_ForeignManMedExamAct) THEN
   reqToXDocId:=L_ODoc.curRefToXDoc_GetId();
   IF ~!reqToXDocId THEN
    L_General.CallUs(ODoc.Status # L_ODoc.ods_Prepared);
    L_General.Assert(ODoc.Status # L_ODoc.ods_Canceled,
                     " ᬮ 㫨஢|| ⬥⪨ ᬮ   ᫥ ନ  ");
    SETSEL(XDocJrn, XDocJrn, L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc);
    LAST(XDocJrn);
    WHILE OCCURE(XDocJrn) &
          (XDocJrn.Action # L_XDoc.action_Insert) & (XDocJrn.Action # L_XDoc.action_Edit) DO
     PREV(XDocJrn);
    END; (* WHILE OCCURE(XDocJrn) ... *)
    PackVARIANTDATE(amoActionTimeB, XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec);
    PackVARIANTDATE(amoActionTimeE, XDocJrn.Date + (XDocJrn.EndTime < XDocJrn.BegTime), XDocJrn.EndTime, XDocJrn.EndSec);

    IF RTI.Get().CurZone.Fields(v_AMO_Kind).Value = L_Str.PoolItem(L_ODoc.amo_KindPool, L_ODoc.amok_Granted) THEN
     action:=L_XDoc.action_MedicalExamination;
    ELSE
     action:=L_XDoc.action_NotAllowedByMedic;
    END;

    IF L_XDoc.ExtractXDocType(reqToXDocId) = L_XDoc.xdt_RWayS THEN
     L_XDoc.PositionOnXDoc(reqToXDocId);

     IF L_BegRWS.GetRWaySActualAction() = action THEN
      PackVARIANTDATE(rwsActionTime, XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec);
      L_General.CallUs(amoActionTimeB <= rwsActionTime);
      L_General.Assert(rwsActionTime <= amoActionTimeE,
                       "  㦥  ⬥⪨ ᫥ ᬮ. ஢ 饭.");
      REMOVE(XDocJrn);
     ELSE
      L_General.Error("  㦥  ⬥⪨ ᫥ ᬮ. ஢ 饭.");
     END;
    END;
   END;
(*
  ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_ViolationAct) THEN
   L_r2r.User_OnBeforeModify(RTI.Get().CurZone.MasterTable.Name);
*)
  END;
  SetAddInsDescription();
  ODoc_OnBeforeEdIns(L_XDoc.action_Edit);
 END {ODoc_OnBeforeEdit};

 PRIVATE PROCEDURE FillODocDescr(Field: FORM_FIELD);
 BEGIN
  IF ACCESS(ODoc) & ~!ODoc.XDocId THEN
   Field.Value:=L_ODoc.GetXDocDescription(ODoc.XDocId, 0);
  ELSE
   SETEMPTY(Field.Value);
  END;
 END {FillODocDescr};

 PRIVATE PROCEDURE ODoc_OnAfterEdIns();
  VAR
   xdid        : L_XDoc.tXDocId;
   xdt         : L_XDoc.tXDocType;
   xdknd       : L_XDoc.tXDocKind;
   xd          : L_XDoc.tXDoc;
   action      : LIKE(XDocJrn.Action);
   trgEDOKind  : LIKE(EDOKind.EDOKind);
   Fields      : FORM_FIELDS;
   Field       : FORM_FIELD;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  CONFORM(ODoc, ODocKind);
  IF (ODocWindowName() = "OD_AMO") | (ODocWindowName() = "OD_AMOFM") THEN
   ODoc.Date:=L_BegRWS.DspDate(ODoc.SrcDate, RTI.Get().CurWindow.Zones(0).Fields(v_AMO_Time).Value);
   amo_PutDescript();
  END;

  IF ODocWindowName() # "OD_VA" THEN
   L_General.Assert(~!ODoc.TSN | (ODocKind.Scope # L_ODoc.odks_Internal),
                    " ७ 㬥⮢ 易⥫쭮 㪠 ࠡ⭨");
  ELSE
   trgEDOKind  :=Fields("EDOKind").Value;
   IF !ODoc.TSN THEN
    L_StdFrm.Choice(" 㪠 ࠡ⭨.    ⠭?");
   END;
   IF !trgEDOKind THEN
    L_StdFrm.Choice(" 㪠  襭");
   END;
   L_General.Assert(~!ODoc.Descript, "  ᠭ");
   IF P_ODoc.HasPro(ODoc.ODocKind, ODoc.ODoc, P_ODoc.P_Content) THEN
    L_r2r.User_OnBeforeModify("ODocPro");
    REMOVE(ODocPro);
   END;
   IF ~!trgEDOKind THEN
    P_ODoc.InsertProperty(ODoc.ODocKind, ODoc.ODoc, P_ODoc.P_Content, 1, "");
    ODocPro.Value:=P_ODoc.Encode_ViolationActContent(trgEDOKind);
    REPLACE(ODocPro);
   END;
  END;

  IF L_kn.Is(ODoc.Date, L_ODoc.erkn_FirmMessage) &
     (ODoc.Sense = L_ODoc.fms_PaymentReviseAct_InPer) THEN
   L_General.Assert(P_ODoc.HasPro(ODoc.ODocKind, ODoc.ODoc, P_ODoc.P_PaymentRevisePeriod),
                    "室 ନ ᢮⢮ " + L_Str.IntStr(P_ODoc.P_PaymentRevisePeriod));
  END;

  IF IsBuildDocByBCS() & (L_BarCode.GetBCSRegime() = L_BarCode.BCSr_Disconnect) THEN
   L_BarCode.SetBCSRegime(L_BarCode.BCSr_OnLine);
  END;
  IF L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct) |
     L_kn.Is(ODoc.Date, L_ODoc.erkn_ForeignManMedExamAct)  THEN
   IF     ODoc.Status = L_ODoc.ods_Passed THEN
    xdid:=L_XDoc.GetSingleRefToXDocId(L_XDoc.XDocId(L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc));
    IF ~!xdid THEN
     IF Fields(v_AMO_Kind).Value = L_Str.PoolItem(L_ODoc.amo_KindPool, L_ODoc.amok_Granted) THEN
      action:=L_XDoc.action_MedicalExamination;
     ELSE
      action:=L_XDoc.action_NotAllowedByMedic;
     END;
     L_XDoc.DecodeXDocId(xdid, xdt, xdknd, xd);
     IF xdt = L_XDoc.xdt_RWayS THEN
      L_XDoc.XDocJrn_Mark(xdt, xdknd, xd, action);
     END;
    END;
   ELSIF ODoc.Status = L_ODoc.ods_Prepared THEN
    L_General.Error(" 樭᪮ ᬮ ⨬ ⠢  ﭨ '⮢'");
   END;
  END;

  IF L_kn.Is(ODoc.Date, L_ODoc.erkn_RAccid) THEN
   IF ODoc.Status = L_ODoc.ods_Passed THEN
    ra_CheckCriticalProblem();
    L_General.Assert(RTI.Get().CurWindow.Zones(0).Fields("HasNonCriticalProblem").Value # hncp_Yes, "㬥 ଫ.| ࠭ 㬥  ﭨ '஢'");
   END;
  END;

  IF ODocKind.TSNRole = L_ODoc.tsnr_Initiator THEN
   Field:=Fields("ODoc_Staff");
   IF ~!Field THEN
    IF P_ODoc.HasPro(ODoc.ODocKind, ODoc.ODoc, P_ODoc.P_Staff) THEN
     L_r2r.User_OnBeforeModify("ODocPro");
     REMOVE(ODocPro);
    END;
    IF ~!Field.Value THEN
     P_ODoc.InsertProperty(ODoc.ODocKind, ODoc.ODoc, P_ODoc.P_Staff, 1, "");
     ODocPro.Value:=L_r2r.Put("ODocPro", "Staff", Field.Value);
     REPLACE(ODocPro);
    END;
   END;
  END;
  Field:=Fields("ODoc_Note");
  IF ~!Field THEN
   SELECT(ODocPro, ODoc, , ODoc.ODocKind, ODoc.ODoc, P_ODoc.P_Note);
   REMSEL(ODocPro);
   IF ~!Field.Value THEN
    P_ODoc.InsertProperty(ODoc.ODocKind, ODoc.ODoc, P_ODoc.P_Note, 1, Field.Value);
   END;
  END;
  FillODocDescr(RTI.Get().CurWindow.ParentZone.Window.Zones(0).Fields(v_ODoc_Descr));
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc);
 END {ODoc_OnAfterEdIns};

 PRIVATE PROCEDURE ODoc_OnAfterInsert();
 BEGIN
  ODoc_OnAfterEdIns();
  CONFORM(ODoc, ODocKind);
  IF ~SELECT(erkns, fi, TABLE.Get("ODocKind").Id, ODocKind.RECORDID) THEN
   L_XDF.XDoc_OnAfterInsert(ODoc.XDocId);
  END;
 END {ODoc_OnAfterInsert};

 PRIVATE PROCEDURE ODoc_OnAfterEdit();
 BEGIN
  ODoc_OnAfterEdIns();
 END {ODoc_OnAfterEdit};

 PRIVATE PROCEDURE ODoc_OnBeforeDelete();
 BEGIN
  CONFORM(ODoc, ODocKind);
  L_General.Error("  㬥⮢ |'" + ODocKind.Name + "' 饭.|" +
                  "ᯮ 㫨஢");
 END {ODoc_OnBeforeDelete};

 PRIVATE PROCEDURE ODoc_ODoc_OnSuccessfulChange();
 BEGIN
  L_General.Assert(~!ODoc.ODoc, " ⠢ ");
  L_XDoc.ChangeXDoc(L_XDoc.xdt_ODoc, ODoc.ODocKind, GE_PVALUE(), ODoc.ODoc);
 END {ODoc_ODoc_OnSuccessfulChange};

 PRIVATE PROCEDURE ODoc_Date_OnSuccessfulChange();
 BEGIN
  SetAddInsDescription();
 END {ODoc_Date_OnSuccessfulChange};

 PRIVATE PROCEDURE ODoc_OnInitializeWindow();
 BEGIN
  L_WDO.iField       (0, "v_ODoc_Descr").LineBreakEnable:=1;
  L_WDO.iEvents      (1, [L_WDO.e_OnReposition, L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).Narrowing:="ODoc.ODocKind = ODocKind.ODocKind";
  L_WDO.iField       (1, "ODoc.ODoc").ReverseSorting:=1;
  L_WDO.iField       (1, "ODoc.Status").Format:=L_ODoc.StatusPool(1);
  L_WDO.iEvents      (2, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete]);
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).PermanentFilter:="ODocKind.Scope=" + L_Str.IntStr(L_ODoc.odks_External);
  L_WDO.iProgs       (2, "ODoc");
 END {ODoc_OnInitializeWindow};

 PRIVATE PROCEDURE ODocInt_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ODoc";
  L_WDO.iField       (0, "v_ODoc_Descr").LineBreakEnable:=1;
  L_WDO.iField       (0, "ODocKind.TSNRole").Format:=L_ODoc.tsnr_Pool;
  L_WDO.iEvents      (1, [L_WDO.e_OnReposition, L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).Narrowing:="ODoc.ODocKind = ODocKind.ODocKind";
  L_WDO.iField       (1, "ODoc.ODoc").ReverseSorting:=1;
  L_WDO.iField       (1, "ODoc.Status").Format:=L_ODoc.StatusPool(1);
  L_WDO.iEvents      (2, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete]);
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).PermanentFilter:="ODocKind.Scope=" + L_Str.IntStr(L_ODoc.odks_Internal);
  L_WDO.iProgs       (2, "ODoc");
 END {ODocInt_OnInitializeWindow};

 PRIVATE PROCEDURE SetWarningStr();
  VAR
   WarningStr: STRING[];
 BEGIN
  WarningStr:=" ";
  IF OCCURE(ODoc) & ~!ODoc.TSN THEN
   CONFORM(ODoc, Staff);
   CONFORM(Staff, Man);
   IF    L_DatTim.IsBirthDay(Man.Birth, ODoc.SrcDate)     THEN
    WarningStr:=WarningStr + " ஦. ";
   ELSIF L_DatTim.IsBirthDay(Man.Birth, ODoc.SrcDate - 1) THEN
    WarningStr:=WarningStr + " ஦. ";
   END;
   L_Staff.PosToStaffLog(Staff.TSN, ODoc.Date, 1);
   CONFORM(StaffLog, Officer);
   IF P_Man.InRiskGroup(Staff.Man, ODoc.Date, L_Env.IsDriver()) THEN
    WarningStr:=WarningStr + P_Man.MedExaminationFeatures(Staff.Man, ODoc.Date, L_Env.IsDriver()) + ". ";
   END;
  END;
  L_WDO.getFieldInActiveZone(v_WarningStr).Value:=WarningStr;
 END {SetWarningStr};

 PRIVATE PROCEDURE GetEDOStr(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF SELECT(EDOLC, XDocId, L_XDoc.XDocId(L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc)) THEN
   CONFORM(EDOLC, EDOrderL);
   CONFORM(EDOrderL, EDOKind);
   Result:=EDOrderL.EDOrder + " " + EDOKind.Name;
   IF ~!EDOrderL.FixInPC THEN
    INC(Result, " (" + L_Str.PoolItem(L_EDO.GetFixInPCPool(EDOrderL.EDOGrp), EDOrderL.FixInPC) + ")");
   END;
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetEDOStr};

 PRIVATE PROCEDURE ODoc_OnTableReposition();
 BEGIN
  FillODocDescr(RTI.Get().CurWindow.Zones(0).Fields(v_ODoc_Descr));
 END {ODoc_OnTableReposition};

 PRIVATE PROCEDURE ODocInt_1_OnReposition();
 BEGIN
  ODoc_OnTableReposition();
 END {ODocInt_1_OnReposition};

 PRIVATE PROCEDURE ODoc_1_OnReposition();
 BEGIN
  ODoc_OnTableReposition();
 END {ODoc_1_OnReposition};

 PRIVATE PROCEDURE AnyODoc_OnReposition();
  VAR
   xdid  : L_XDoc.tXDocId;
   xdt   : L_XDoc.tXDocType;
   xdknd : L_XDoc.tXDocKind;
   xd    : L_XDoc.tXDoc;
   Fields: FORM_FIELDS;
 BEGIN
  AccessODocKind();
  L_ODoc.AccessODoc();

  Fields:=RTI.Get().CurZone.Fields;
  IF    ~!Fields("ODoc.ODSpcNam") THEN
   Fields("ODoc.ODSpcNam").Visible         :=ODocKind.CanNamed > L_ODoc.odkcn_No;
   Fields("ODoc.ODSpcNam").MustBeNonempty  :=ODocKind.CanNamed = L_ODoc.odkcn_Necessarily;
   Fields("ODSpcNam.RegName").Visible      :=Fields("ODoc.ODSpcNam").Visible;
  ELSIF ODocKind.CanNamed = L_ODoc.odkcn_Necessarily THEN
   L_General.Error("   㬥⮢ '" + ODocKind.ODocKind + " " + ODocKind.Name +
                   "'| ।ᬮ७ 易⥫  ᯥ樠쭮   㬥.|"+
                   "室 ࠢ 祭 ⮣   ࠢ筨   㬥⮢|"+
                   " ᮮ ࠡ稪  ஡");
  END; 

  IF ~!E_GetReferenceXDocKindId(ODoc.Date) THEN
   xdid:=L_ODoc.curRefToXDoc_GetId();
   IF ~!xdid THEN
    L_XDoc.DecodeXDocId(xdid, xdt, xdknd, xd);
    SetAddInsDescription();
   ELSE
    L_XDoc.DecodeXDocKindId(E_GetReferenceXDocKindId(ODoc.Date), xdt, xdknd);
    SETEMPTY(xd);
   END;
   SetDocName(xdid);
  ELSE
   SETEMPTY(xdid, xdt, xdknd, xd);
  END;
  IF ~!Fields(v_ODoc_SingleRefDocT) THEN
   Fields(v_ODoc_SingleRefDocT).Value:=xdt;
  END;
  IF ~!Fields(v_ODoc_SingleRefDocKind) THEN
   Fields(v_ODoc_SingleRefDocKind).Value:=xdk;
  END;
  IF ~!Fields(v_ODoc_SingleRefDoc) THEN
   Fields(v_ODoc_SingleRefDoc).Value:=xd;
  END;
  IF ~!Fields("ODoc.Sense") THEN
   Fields("ODoc.Sense").Format:=L_ODoc.E_GetSensePool(ODoc.ODocKind);
  END;
  IF ODocKind.TSNRole = L_ODoc.tsnr_Initiator THEN
   IF ~!Fields("ODoc_Staff") THEN
    Fields("ODoc_Staff").Value:=P_ODoc.GetProSoft(ODoc.ODocKind, ODoc.ODoc, P_ODoc.P_Staff);
   END;
  END;
  IF ~!Fields("ODoc_Note") THEN
   Fields("ODoc_Note").Value:=P_ODoc.GetProSoft(ODoc.ODocKind, ODoc.ODoc, P_ODoc.P_Note);
  END;
 END {AnyODoc_OnReposition};

 PRIVATE PROCEDURE ODoc01_0_OnReposition();
 BEGIN
  AnyODoc_OnReposition();
 END {ODoc01_0_OnReposition};

 PRIVATE PROCEDURE ODocE_0_OnReposition();
 BEGIN
  AnyODoc_OnReposition();
 END {ODocE_0_OnReposition};

 PRIVATE PROCEDURE ODE_CnMs_0_OnReposition();
 BEGIN
  AnyODoc_OnReposition();
 END {ODE_CnMs_0_OnReposition};

 PRIVATE PROCEDURE ODE_FrMs_0_OnReposition();
 BEGIN
  AnyODoc_OnReposition();
 END {ODE_FrMs_0_OnReposition};

 PRIVATE PROCEDURE ODE_CnChg_0_OnReposition();
 BEGIN
  AnyODoc_OnReposition();
 END {ODE_CnChg_0_OnReposition};

 PRIVATE PROCEDURE ODocECnt_0_OnReposition();
 BEGIN
  AnyODoc_OnReposition();
 END {ODocECnt_0_OnReposition};

 PRIVATE PROCEDURE AnyAMO_OnReposition();
  VAR
   Fields               : FORM_FIELDS;
   AMO_Time             : TIME;
   AMO_EDOStr,
   AMO_Kind,
   AMO_Descript         : STRING[];
   AMO_AlcoholTestResult: SCAL[2];
   AMO_ATR1             : NUMERIC[2];
   AMO_ATR2             : SCAL[2];
   AMO_ATR3             : NUMERIC[2];
   AMO_Complaints       : STRING[];
   AMO_Temperature      : NUMERIC[4,1];
   AMO_Pulse            : NUMERIC[4,0];
   AMO_PressureHigh,
   AMO_PressureLow      : NUMERIC[4,0];
 BEGIN
  AnyODoc_OnReposition();
  Fields:=RTI.Get().CurZone.Fields;

  L_ODoc.amo_DecodeDescription(AMO_Time, AMO_Kind, AMO_Descript, AMO_AlcoholTestResult,
                               AMO_ATR1, AMO_ATR2, AMO_ATR3, AMO_Complaints, AMO_Temperature,
                               AMO_Pulse, AMO_PressureHigh, AMO_PressureLow);
  Fields(v_AMO_Type).Value:=L_Str.PoolItem(L_ODoc.amo_TypePool, L_ODoc.amo_Type());

  IF L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct) THEN
   SetWarningStr();
   Fields(v_AMO_EDOStr).Value:=GetEDOStr();
  ELSE
   IF ~!Fields(v_ODoc_SingleRefDoc).Value THEN
    L_General.CallUs(SEARCH(Man, Man, Fields(v_ODoc_SingleRefDoc).Value));
    Fields(v_ManName).Value:=Man.Name;
   ELSE
    Fields(v_ManName).Value:="";
   END;
  END;
  Fields(v_AMO_Time).Value             :=AMO_Time;
  Fields(v_AMO_Kind).Value             :=AMO_Kind;
  Fields(v_AMO_Descript).Value         :=AMO_Descript;
  Fields(v_AMO_AlcoholTestResult).Value:=AMO_AlcoholTestResult;
  Fields(v_AMO_ATR1).Value             :=AMO_ATR1;
  Fields(v_AMO_ATR2).Value             :=AMO_ATR2;
  Fields(v_AMO_ATR3).Value             :=AMO_ATR3;
  Fields(v_AMO_Complaints).Value       :=AMO_Complaints;
  Fields(v_AMO_Temperature).Value      :=AMO_Temperature;
  Fields(v_AMO_Pulse).Value            :=AMO_Pulse;
  Fields(v_AMO_PressureHigh).Value     :=AMO_PressureHigh;
  Fields(v_AMO_PressureLow).Value      :=AMO_PressureLow;
  Fields(v_AMO_ATR1_Name).Value        :=L_EC.ExecE_Func_String(ODoc.Date, PROCREF(E_ODoc.amo_Alcotest1Name), "6510");
  Fields(v_AMO_ATR3_Name).Value        :=L_EC.ExecE_Func_String(ODoc.Date, PROCREF(E_ODoc.amo_Alcotest3Name), "6810  ਭ஬");
 END {AnyAMO_OnReposition};

 PRIVATE PROCEDURE OD_AMO_0_OnReposition();
 BEGIN
  AnyAMO_OnReposition();
 END {OD_AMO_0_OnReposition};

 PRIVATE PROCEDURE OD_AMOFM_0_OnReposition();
 BEGIN
  AnyAMO_OnReposition();
 END {OD_AMOFM_0_OnReposition};

 PRIVATE PROCEDURE OD_RAcc_0_OnReposition();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  AnyODoc_OnReposition();

  Fields:=RTI.Get().CurZone.Fields;
  L_General.CallUs(OCCURE(ODoc));
  IF SEARCH(RAccid, XDocId, ODoc.XDocId) THEN
   Fields("RAccid_Time").Value   :=RAccid.Time;
   Fields("RAccid_Place").Value  :=RAccid.Place;
   Fields("RAccid_Kind").Value   :=RAccid.Kind;
   Fields("RAccid_CntPass").Value:=RAccid.CntPass;
   Fields("RAccid_RWayS").Value  :=RAccid.RWayS;
   Fields("RAccid_Intoxic").Value:=RAccid.Intoxic;
   ra_PutNonCriticalProblemMsg(RTI.Get().CurWindow, ODoc.Status = L_ODoc.ods_Passed);
   IF ~!RAccid.RWayS THEN
    L_General.CallUs(SEARCH(RWayS, RWayS, RAccid.RWayS));
    L_General.CallUs(SEARCH(Car, BoxNbr, RWayS.BoxNbr));
    L_Car.AccessMark(Car.BoxNbr, RWayS.Date);
    Fields("Car_BoxNbr"  ).Value:=Car.BoxNbr;
    Fields("Car_StateNbr").Value:=Car.StateNbr;
    Fields("Mark_Mark"   ).Value:=Mark.Mark;
    Fields("Mark_Name"   ).Value:=Mark.Name;
   ELSE
    SETEMPTY(Fields("Car_BoxNbr").Value,
             Fields("Car_StateNbr").Value,
             Fields("Mark_Mark").Value,
             Fields("Mark_Name").Value);
   END;
  ELSE
   SETEMPTY(Fields("RAccid_Time").Value,
            Fields("RAccid_Place").Value,
            Fields("RAccid_Kind").Value,
            Fields("RAccid_CntPass").Value,
            Fields("RAccid_RWayS").Value,
            Fields("RAccid_Intoxic").Value,
            Fields("Car_BoxNbr").Value,
            Fields("Car_StateNbr").Value,
            Fields("Mark_Mark").Value,
            Fields("Mark_Name").Value);
  END;
  Fields("EDOStr"    ).Value:=GetEDOStr();
 END {OD_RAcc_0_OnReposition};

 PRIVATE PROCEDURE OD_VA_0_OnReposition();
  VAR
   trgEDOKind: LIKE(EDOKind.EDOKind);
 BEGIN
  AnyODoc_OnReposition();
  P_ODoc.Get_ViolationActContent(ODoc.ODocKind, ODoc.ODoc, trgEDOKind);
  L_WDO.cField("AuthorTSN").Value:=L_XDoc.GetXDocAuthorTSN(L_XDoc.xdt_ODoc);
  L_WDO.cField("EDOKind"  ).Value:=trgEDOKind;
  FillEDOKindDescr(trgEDOKind);
 END {OD_VA_0_OnReposition};

 PRIVATE PROCEDURE AccessODocKind();
 BEGIN
  L_General.Assert(ACCESS(ODocKind) |
                   ACCESS(ODoc) & SEARCH(ODocKind, ODocKind, ODoc.ODocKind),
                   " ⠭   㬥⮢");
 END {AccessODocKind};

 PRIVATE PROCEDURE Any_ODoc_OnOpenWindow();
 BEGIN
  AccessODocKind();
  L_WDO.iWindow().Title:=ODocKind.SName;
  L_WDO.iField(0, "ODoc.Status").Format:=L_ODoc.StatusPool(0);
  IF ~!L_WDO.iField(0, "ODocKind.TSNRole") THEN
   L_WDO.iField(0, "ODocKind.TSNRole").Format:=L_ODoc.tsnr_Pool;
  END;
 END {Any_ODoc_OnOpenWindow};

 PRIVATE PROCEDURE ODocE_0_OnZoneOpen();
 BEGIN
  Any_ODoc_OnOpenWindow();
 END {ODocE_0_OnZoneOpen};

 PRIVATE PROCEDURE ODoc01_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ODoc";
  L_WDO.iWindow().OnOpenWindow:=1;
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "ODoc.Descript").LineBreakEnable:=1;
  L_WDO.iField       (0, "Staff_Name").Expression:="SELF.Zone.LinkedFieldValue('TSNDate.Name')";
  L_WDO.iField       (0, "ODoc_Staff_Title").Value:="⭨";
  L_WDO.iScsChange   (0, ["ODoc.TSN", "ODoc_Staff"]);
  L_WDO.iUnmodifiable(0, ["ODoc.CopyCnt", "ODoc.ODoc", "ODoc.ODocKind", "ODoc_Staff_Title"]);
  L_WDO.iMayBeEmpty  (0, ["ODoc_Note", "ODoc.Descript", "ODoc.SrcNbr", "ODoc_Staff"]);

  L_WDO.CreateFormLink_Simple("Staff", "ODoc_Staff");
 END {ODoc01_OnInitializeWindow};

 PRIVATE PROCEDURE ODoc01_OnOpenWindow();
  VAR
   Visible: SCAL[2];
 BEGIN
  Any_ODoc_OnOpenWindow();
  Visible:=ODocKind.TSNRole=L_ODoc.tsnr_Initiator;
  L_WDO.iField       (0, "ODoc_Staff_Title").Visible:=Visible;
  L_WDO.iField       (0, "ODoc_Staff").Visible:=Visible;
  L_WDO.iField       (0, "ODoc_StaffName").Visible:=Visible;
 END {ODoc01_OnOpenWindow};

 PRIVATE PROCEDURE OD_AMO_0_OnZoneOpen();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Any_ODoc_OnOpenWindow();
  Fields(v_AMO_Kind).Template              :=L_ODoc.amo_KindPool;
  Fields(v_AMO_Kind).TemplateIsStrict      :=1;
  Fields(v_AMO_AlcoholTestResult).Format   :=L_ODoc.amo_atrPool;
  Fields(v_AMO_ATR2).Format                :=L_ODoc.amo_atrPool;
  Fields(v_AMO_Complaints).Template        :=L_Pool.Get(pool_AMOComplaints);
  Fields(v_AMO_Complaints).TemplateIsStrict:=0;
 END {OD_AMO_0_OnZoneOpen};

 PRIVATE PROCEDURE OD_AMOFM_0_OnZoneOpen();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Any_ODoc_OnOpenWindow();
  Fields(v_AMO_Kind).Template              :=L_ODoc.amo_KindPool;
  Fields(v_AMO_Kind).TemplateIsStrict      :=1;
  Fields(v_AMO_AlcoholTestResult).Format   :=L_ODoc.amo_atrPool;
  Fields(v_AMO_ATR2).Format                :=L_ODoc.amo_atrPool;
  Fields(v_AMO_Complaints).Template        :=L_Pool.Get(pool_AMOComplaints);
  Fields(v_AMO_Complaints).TemplateIsStrict:=0;
 END {OD_AMOFM_0_OnZoneOpen};

 PRIVATE PROCEDURE ODocECnt_0_OnZoneOpen();
 BEGIN
  Any_ODoc_OnOpenWindow();
  RTI.Get().CurZone.Fields(v_ODoc_SingleRefDocT).Format:=L_XDoc.ref_FullNames;
 END {ODocECnt_0_OnZoneOpen};

 PRIVATE PROCEDURE ODE_CnMs_0_OnZoneOpen();
 BEGIN
  Any_ODoc_OnOpenWindow();
  RTI.Get().CurZone.Fields("ODoc.Sense").Format:=L_ODoc.E_GetSensePool(ODocKind.ODocKind);
 END {ODE_CnMs_0_OnZoneOpen};

 PRIVATE PROCEDURE ODE_CnChg_0_OnZoneOpen();
 BEGIN
  Any_ODoc_OnOpenWindow();
 END {ODE_CnChg_0_OnZoneOpen};

 PRIVATE PROCEDURE ODE_FrMs_0_OnZoneOpen();
 BEGIN
  Any_ODoc_OnOpenWindow();
  RTI.Get().CurZone.Fields("ODoc.Sense").Format:=L_ODoc.E_GetSensePool(ODocKind.ODocKind);
 END {ODE_FrMs_0_OnZoneOpen};

 PRIVATE PROCEDURE OD_VA_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ODoc";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition, L_WDO.e_OnOpenZone]);
  L_WDO.iField       (0, "ODoc.Descript").LineBreakEnable:=1;
  L_WDO.iField       (0, "EDOKind_Interval").LineBreakEnable:=1;
  L_WDO.iField       (0, "Staff_Name").Expression:="SELF.Zone.LinkedFieldValue('TSNDate.Name')";
  L_WDO.iScsChange   (0, ["EDOKind"]);
  L_WDO.iUnmodifiable(0, ["ODoc.CopyCnt", "ODoc.ODoc", "ODoc.ODocKind",
                          "EDOKind_Interval", "EDOKind_Name",
                          "AuthorTSN", "AuthorStaff_Name"]);
  L_WDO.iMayBeEmpty  (0, ["ODoc.Descript", "EDOKind", "ODoc.TSN", "ODoc.SrcNbr"]);
  L_WDO.CreateFormLink("Staff", "Author");
  L_WDO.CreateFormLink("EDOKind", "");
 END {OD_VA_OnInitializeWindow};

 PRIVATE PROCEDURE OD_VA_0_OnZoneOpen();
 BEGIN
  Any_ODoc_OnOpenWindow();
 END {OD_VA_0_OnZoneOpen};

 PRIVATE PROCEDURE AnyODoc_1_OnSetSubwindow();
 BEGIN
  RTI.Get().CurZone.HasVariousSubwindows:=1;
  RTI.Get().CurZone.SubwindowOriginalName:=ODocWindowName();
  RTI.Get().CurZone.SubwindowAssignedName:=RTI.Get().CurZone.SubwindowOriginalName;
 END {AnyODoc_1_OnSetSubwindow};

 PRIVATE PROCEDURE ODoc_1_OnSetSubwindow();
 BEGIN
  AnyODoc_1_OnSetSubwindow();
 END {ODoc_1_OnSetSubwindow};

 PRIVATE PROCEDURE ODocInt_1_OnSetSubwindow();
 BEGIN
  AnyODoc_1_OnSetSubwindow();
 END {ODocInt_1_OnSetSubwindow};

 PRIVATE PROCEDURE ODoc_Sense_OnSuccessfulChange();
 BEGIN
  SetAddInsDescription();
 END {ODoc_Sense_OnSuccessfulChange};

 PUBLIC PROCEDURE AfterAsk();
  VAR
   xdt  : L_XDoc.tXDocType;
   xdknd: L_XDoc.tXDocKind;
   xd   : L_XDoc.tXDoc;
 BEGIN
  L_XDoc.DecodeXDocId(L_XDoc.ref_XDocId, xdt, xdknd, xd);
  RTI.Get().CurZone.Fields(v_ODoc_SingleRefDoc).Value:=xd;
  ODoc__OnSuccessfulChange();
 END {AfterAsk};

 PRIVATE PROCEDURE ODocKinE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "ODocKind.Name").First:=1;
  L_WDO.iScsChange   (0, ["ODocKind.CanNamed", "ODocKind.Scope",  "ODocKind.TSNRole"]);
  L_WDO.iMayBeEmpty  (0, ["ODocKind.SName", "ODocKind.DefPath"]);
  L_WDO.iProgs       (0, "ODoc");
 END {ODocKinE_OnInitializeWindow};

 PRIVATE PROCEDURE ODocKinE_0_OnReposition();
 BEGIN
  RTI.Get().CurZone.Fields("ODocKind.TSNRole").Modifiable:=ODocKind.Scope = L_ODoc.odks_Internal;
 END {ODocKinE_0_OnReposition};

 PRIVATE PROCEDURE ODocKind_Scope_OnSuccessfulChange();
 BEGIN
  RTI.Get().CurZone.Fields("ODocKind.TSNRole").Modifiable:=ODocKind.Scope = L_ODoc.odks_Internal;
 END {ODocKind_Scope_OnSuccessfulChange};

 PRIVATE PROCEDURE ODocKind_TSNRole_OnSuccessfulChange();
 BEGIN
  IF (ODocKind.TSNRole = L_ODoc.tsnr_Staff) & (GE_PVALUE() = L_ODoc.tsnr_Initiator) THEN
   SELECT(ODocPro, Property, , P_ODoc.P_Staff);
   WHILE OCCURE(ODocPro) DO
    PROMPT("஢ઠ " + ODocPro.ODocKind + " " + ODocPro.ODoc);
    IF ODocPro.ODocKind = ODocKind.ODocKind THEN
     L_General.Error("   묨 'ࠡ⭨',  ஫ ࠡ⭨ 饭");
    END;
    NEXT(ODocPro);
   END; (* WHILE OCCURE(ODocPro) ... *)
  END;
 END {ODocKind_TSNRole_OnSuccessfulChange};

 PRIVATE PROCEDURE ODocKind_CanNamed_OnSuccessfulChange();
 BEGIN
  IF ODocKind.CanNamed = L_ODoc.odkcn_No THEN
   SELECT(ODoc, ODoc, , ODocKind.ODocKind);
   WHILE OCCURE(ODoc) DO
    L_General.Assert(!ODoc.ODSpcNam, "稩 㬥 " + ODoc.ODoc + "  ⮥ ᯥ樠쭮 ");
    NEXT(ODoc);
   END; (* WHILE OCCURE(ODoc) ... *)
  END;
 END {ODocKind_CanNamed_OnSuccessfulChange};

 PRIVATE PROCEDURE GetEDOFixInPCStr(VAR FixInPCStr: STRING[]): SCAL[2];
 BEGIN
  IF SELECT(EDOLC, XDocId, L_XDoc.XDocId(L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc)) THEN
   CONFORM(EDOLC, EDOrderL);
   CONFORM(EDOrderL, EDOrder);
   IF ~!EDOrderL.FixInPC THEN
    FixInPCStr:=L_Str.PoolItem(L_EDO.GetFixInPCPool(EDOrderL.EDOGrp),
                               EDOrderL.FixInPC);
   ELSE
    FixInPCStr:="";
   END;
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {GetEDOFixInPCStr};

 PRIVATE PROCEDURE OD001_MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⢨");
  L_Basis.wb_WrInQM(F, "ࠢ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "卮");
  L_Basis.wb_WrInQM(F, "ﭨ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ਬ砭");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_TermLine(F);
 END {OD001_MakeTop};

 PRIVATE PROCEDURE OD001_MakeLine(F: STRING[]);
  VAR
   FixInPCStr: STRING[];
 BEGIN
  L_Basis.wb_WrScl(F, ODocKind.ODocKind);
  L_Basis.wb_WrStr(F, ODocKind.SName);
  L_Basis.wb_WrStr(F, ODocKind.Sign);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("७|譨", ODocKind.Scope));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|", ODocKind.Dir));
  L_Basis.wb_WrScl(F, ODoc.ODoc);
  L_Basis.wb_WrDat(F, ODoc.Date);
  L_Basis.wb_WrStr(F, ODoc.SrcNbr);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_ODoc.StatusPool(0), ODoc.Status));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_ODoc.E_GetSensePool(ODocKind.ODocKind), ODoc.Sense));
  L_Basis.wb_WrStr(F, L_Str.Left(ODoc.Descript, 128));
  IF ~!ODoc.TSN THEN
   CONFORM(ODoc, Staff);
   CONFORM(Staff, Man);
   L_Staff.PosToStaffLog(Staff.TSN, ODoc.Date, 1);
   CONFORM(StaffLog, Officer);
   CONFORM(Officer, Sort);
   CONFORM(Officer, Union);
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_ODoc.odswPool, L_ODoc.odsw_Staff));
   L_Basis.wb_WrScl(F, Staff.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
   L_Basis.wb_WrScl(F, Union.Union);
   L_Basis.wb_WrStr(F, Union.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "-----");
   L_Basis.wb_WrStr(F, "--------");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "--------");
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "--------");
  END;
  IF ~!ODoc.Firm THEN
   CONFORM(ODoc, Firm);
   L_Basis.wb_WrScl(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
  ELSE
   L_Basis.wb_WrStr(F, "----");
   L_Basis.wb_WrStr(F, "--------");
  END;
  L_Basis.wb_TermLine(F);
 END {OD001_MakeLine};

 PUBLIC PROCEDURE OD001();
  CONST
   bpId = "OD001";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, "  㬥⮢", L_bp.t_Basis, L_General.tc_inIntvl);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  OD001_MakeTop("F");
  TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_THROW)]
   SELECT(ODoc, ODKDate);
   WHILE OCCURE(ODoc) DO
    NARROWSEL(ODoc, ODocKind);
    CONFORM(ODoc, ODocKind);
    IF ~L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct) &
       ~L_kn.Is(ODoc.Date, L_ODoc.erkn_ViolationAct) THEN
     SRCINSEL(ODoc, GE, , Memo.ud_fr());
     WHILE OCCURE(ODoc) & (ODoc.Date <= Memo.ud_ut()) DO
      PROMPT(ODoc.ODocKind + " " + ODoc.ODoc);
      IF ODoc.Status # L_ODoc.ods_Canceled THEN
       OD001_MakeLine("F");
      END;
      NEXT(ODoc);
     END; (* WHILE OCCURE(ODoc) ... *)
    END; (* IF ~L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct)...*)
    NEXTINEXTENDEDSEL(ODoc, ODocKind);
   END; (* WHILE OCCURE(ODoc) *)
  EXCEPT
  END;
  FIO.Close(F);
  L_bp.End();
 END {OD001};

 PRIVATE PROCEDURE OD002_MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ᯥ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "ࠣ");
  L_Basis.wb_WrInQM(F, "ᮡ⨔");
  L_Basis.wb_WrInQM(F, "ਪ");
  L_Basis.wb_WrInQM(F, "ਪ卮");
  L_Basis.wb_WrInQM(F, "ਪ");
  L_Basis.wb_WrInQM(F, "筮");
  L_Basis.wb_WrInQM(F, "㬬");
  L_Basis.wb_WrInQM(F, "業");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "浪멍");
  L_Basis.wb_WrInQM(F, "祭");
  L_Basis.wb_WrInQM(F, "ਬ砭");
  L_Basis.wb_WrInQM(F, "஡");
  L_Basis.wb_WrInQM(F, "஡1");
  L_Basis.wb_WrInQM(F, "஡2");
  L_Basis.wb_WrInQM(F, "஡3");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "஢");
  L_Basis.wb_TermLine(F);
 END {OD002_MakeTop};

 PRIVATE PROCEDURE OD002_MakeLine(F: STRING[]);
  VAR
   FixInPCStr        : STRING[];
   _Time             : TIME;
   _Kind,
   _Descript         : STRING[];
   _AlcoholTestResult: SCAL[2];
   _ATR1             : NUMERIC[2];
   _ATR2             : SCAL[2];
   _ATR3             : NUMERIC[2];
   _Complaints       : STRING[];
   _Temperature      : NUMERIC[4,1];
   _Pulse,
   _PressureHigh,
   _PressureLow      : NUMERIC[4,0];

    DocT    : L_XDoc.tXDocType;
    DocKind : L_XDoc.tXDocKind;
    Doc     : L_XDoc.tXDoc;
    DocId   : L_XDoc.tXDocId;
    _RWayS  : LIKE(RWayS.RWayS);
 BEGIN
  L_Basis.wb_WrScl(F, ODoc.ODoc);
  L_Basis.wb_WrDat(F, ODoc.Date);

  DocId:=L_ODoc.curRefToXDoc_GetId();
  IF ~!DocId THEN
   L_XDoc.DecodeXDocId(DocId, DocT, DocKind, Doc);
   IF DocT = L_XDoc.xdt_RWayS THEN
    _RWayS:=Doc;
    L_Basis.wb_WrScl(F, _RWayS);
   ELSE
    L_Basis.wb_WrStr(F, "");
   END;
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;

  L_ODoc.amo_DecodeDescription(_Time, _Kind, _Descript, _AlcoholTestResult, _ATR1, _ATR2, _ATR3,
                               _Complaints, _Temperature, _Pulse, _PressureHigh, _PressureLow);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_ODoc.amo_TypePool, L_ODoc.amo_Type()));

  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc);
  WHILE XDocJrn.Action # L_XDoc.action_Insert DO
   NEXT(XDocJrn);
  END;
  CONFORM(XDocJrn, AcsObj);
  IF ~!AcsObj.Man THEN
   CONFORM(AcsObj, Man);
   L_Basis.wb_WrStr(F, Man.Name);
  ELSE
   L_Basis.wb_WrStr(F, AcsObj.FullName);
  END;

  IF L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct) THEN
   L_General.Assert(~!ODoc.TSN, " 㪠 ࠡ⭨   " + ODoc.ODoc);
   CONFORM(ODoc, Staff);
   CONFORM(Staff, Man);
   L_Staff.PosToStaffLog(Staff.TSN, ODoc.Date, 1);
   CONFORM(StaffLog, Officer);
   CONFORM(Officer, Sort);
   CONFORM(Officer, Union);
   L_Basis.wb_WrScl(F, Staff.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
   L_Basis.wb_WrScl(F, Union.Union);
   L_Basis.wb_WrStr(F, Union.Name);
   CONFORM(Officer, Post);
   L_Basis.wb_WrScl(F, Post.Post);
   L_Basis.wb_WrStr(F, Post.Name);
   CONFORM(ODoc, MyFirm);
   CONFORM(MyFirm, Firm);
   L_Basis.wb_WrStr(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
   L_Basis.wb_WrStr(F, P_Man.MedExaminationFeatures(Man.Man, ODoc.Date, L_Env.IsDriver()));
   IF GetEDOFixInPCStr(FixInPCStr) THEN
    L_Basis.wb_WrScl(F, EDOrder.EDOrder);
    L_Basis.wb_WrStr(F, EDOrder.SrcNum);
    L_Basis.wb_WrDat(F, EDOrder.Date);
    L_Basis.wb_WrStr(F, FixInPCStr);
    L_Basis.wb_WrNum(F, EDOrderL.BySum, 2);
    L_Basis.wb_WrNum(F, EDOrderL.ByPrc, 2);
   ELSE
    L_Basis.wb_WrStr(F, "");
    L_Basis.wb_WrStr(F, "");
    L_Basis.wb_WrStr(F, "");
    L_Basis.wb_WrStr(F, "");
    L_Basis.wb_WrStr(F, "");
    L_Basis.wb_WrStr(F, "");
   END;
  ELSE
   L_ODoc.curRefToXDoc_PositionOn(L_XDoc.xdt_Man);
   L_Basis.wb_WrScl(F, "");
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrScl(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrScl(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrScl(F, "");
   L_Basis.wb_WrStr(F, "");
   CONFORM(ODoc, Firm);
   L_Basis.wb_WrScl(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
   L_Basis.wb_WrStr(F, P_Man.MedExaminationFeatures(Man.Man, ODoc.Date, 1));
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrDat(F, ODoc.SrcDate);
  L_Basis.wb_WrTim(F, _Time);
  IF ~SELECT(od002, od002, Man.Man, ODoc.SrcDate) THEN
   ADD(od002, od002, , Man.Man, ODoc.SrcDate, 1);
  ELSE
   INC(od002.Cnt);
   REPLACE(od002);
  END;
  L_Basis.wb_WrNum(F, od002.Cnt, 0);
  L_Basis.wb_WrStr(F, _Kind);
  L_Basis.wb_WrStr(F, _Descript);
  IF ~!_AlcoholTestResult THEN
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_ODoc.amo_atrPool, _AlcoholTestResult));
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrNum(F, _ATR1, 2);
  IF ~!_ATR2 THEN
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_ODoc.amo_atrPool, _ATR2));
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrNum(F, _ATR3, 2);
  L_Basis.wb_WrStr(F, _Complaints);
  L_Basis.wb_WrNum(F, _Temperature, 1);
  L_Basis.wb_WrNum(F, _Pulse, 0);
  L_Basis.wb_WrNum(F, _PressureHigh, 0);
  L_Basis.wb_WrNum(F, _PressureLow, 0);
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_TermLine(F);
 END {OD002_MakeLine};

 PRIVATE PROCEDURE OD002_MakeLine_ApsendAMO(F: STRING[]; D: DATE; st: NUMERIC[0]; ByRWayS: SCAL[2]);
 BEGIN
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrDat(F, D);
  IF ByRWayS THEN
   L_Basis.wb_WrScl(F, RWayS.RWayS);
   CONFORM(RWayS, Staff);
   L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  ELSE
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_ODoc.amo_TypePool, st));
  L_Basis.wb_WrStr(F, "");
  CONFORM(Staff, Man);
  CONFORM(StaffLog, Officer);
  CONFORM(Officer, Sort);
  CONFORM(Officer, Union);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  CONFORM(Officer, Post);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  SEARCH(Firm, Firm, , L_Staff.GetFirmOfStaff());
  L_Basis.wb_WrStr(F, Firm.Firm);
  L_Basis.wb_WrStr(F, Firm.Name);
  L_Basis.wb_WrStr(F, P_Man.MedExaminationFeatures(Man.Man, D, L_Env.IsDriver()));
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_TermLine(F);
 END {OD002_MakeLine_ApsendAMO};

 PRIVATE PROCEDURE OD002_ODocList(D: DATE; odk: LIKE(ODocKind.ODocKind));
 BEGIN
  IF ~!odk THEN
   SEARCH(ODocKind, ODocKind, , odk);
   APP.Get().NewPrompt(ODocKind.ODocKind + " " + ODocKind.Name);
   SELECT(ODoc, ODKDate, , odk, D);
   WHILE OCCURE(ODoc) DO
    PROMPT(ODoc.ODoc);
    IF ODoc.Status # L_ODoc.ods_Canceled THEN
     OD002_MakeLine("F");
    END;
    NEXT(ODoc);
   END; (* WHILE OCCURE(ODoc) ... *)
  END;
 END {OD002_ODocList};

 PRIVATE PROCEDURE OD002_TestRWayS(D: DATE);
  VAR
   T   : TIME;
   Has,
   Need: SCAL[2][4];
   st  : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("");
  SELECT(RWayS, Date, , D);
  WHILE OCCURE(RWayS) DO
   PROMPT(RWayS.RWayS);
   SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
   SETZERO(Has, Need);
   st:=L_ODoc.amot_Undefined;
   WHILE OCCURE(XDocJrn) DO
    IF    XDocJrn.Action = L_XDoc.action_begDst THEN
     st:=L_ODoc.amot_First;
    ELSIF XDocJrn.Action = L_XDoc.action_CarDeparture THEN
     IF st = L_ODoc.amot_InterJob THEN
      IF (XDocJrn.BegTime - T) >= 3 THEN
       Need[L_ODoc.amot_InterJob]:=1;
      END;
     ELSE
      Need[L_ODoc.amot_First]:=1;
     END;
     IF L_BegRWS.CarIsUnderControlOfNextRWayS() THEN
      Need[L_ODoc.amot_Final]:=1;
      st:=L_ODoc.amot_Final;
     END;
    ELSIF XDocJrn.Action = L_XDoc.action_CarReturn THEN
     st:=L_ODoc.amot_InterJob;
     T :=XDocJrn.BegTime;
    ELSIF XDocJrn.Action = L_XDoc.action_AcceptCarReturn THEN
     Need[L_ODoc.amot_Final]:=1;
     st:=L_ODoc.amot_Final;
    ELSIF XDocJrn.Action = L_XDoc.action_MedicalExamination THEN
     Has[st]:=1;
    ELSIF XDocJrn.Action = L_XDoc.action_NotAllowedByMedic THEN
     Has[st]:=1;
     WHILE st < L_ODoc.amot_Final DO
      INC(st);
      Need[st]:=0;
     END;
     LAST(XDocJrn);
    END;
    NEXT(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)
   IF L_BegRWS.CarIsUnderControlOfPrevRWayS() THEN
    Need[L_ODoc.amot_First]:=1;
   END;
   st:=L_ODoc.amot_Undefined;
   WHILE st <= L_ODoc.amot_Final DO
    IF Need[st] & ~Has[st] THEN
     OD002_MakeLine_ApsendAMO("F", D, st, 1);
    END;
    INC(st);
   END;
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {OD002_TestRWayS};

 PRIVATE PROCEDURE OD002_TestOfficer(D: DATE; odk: LIKE(ODocKind.ODocKind));
  VAR
   val         : STRING[];
   IsHole      : SCAL[2];
   dummyTim    : LIKE(Sheet.Tim);
   dummyShtSign: LIKE(JMode.ShtSign);
   fromSheet   : SCAL[2];
 BEGIN
  IF ~!odk THEN
   APP.Get().NewPrompt("");
   SELECT(Staff, TSN);
   WHILE OCCURE(Staff) DO
    PROMPT(Staff.TSN);
    IF ~SELECT(ODoc, TSN, odk, Staff.TSN, D) | ~NEXT(ODoc) THEN
     IF L_Staff.rInState(D) THEN
      val:=P_Officer.GetProValueSoft(StaffLog.Sort, StaffLog.Officer, D, P_Officer.P_MedExamination);
      IF (val = "") | (val = "ਮ᪨  ") THEN
       val:=P_Man.GetManProSoft(Staff.Man, D, P_Man.P_MedExaminationFeatures);
       IF val # "᢮  ᬮ" THEN
        L_General.Assert(SEARCH(RegList, HumReg, StaffLog.Regime, L_DatTim.Per(D), L_DatTim.DAY(D)),
                         " ᠭ ० ࠡ " + StaffLog.Regime + "  " + L_DatTim.DateStr(D));
        L_Sheet.GetRealSheet(IsHole, dummyTim, dummyShtSign, fromSheet);
        IF JMode.Type = L_Sheet.jmType_TimDone THEN
         IF SELECT(ODoc, TSN, odk, Staff.TSN, D) THEN
          OD002_MakeLine_ApsendAMO("F", D, L_ODoc.amot_Undefined, 0);
         ELSE
          OD002_MakeLine_ApsendAMO("F", D, L_ODoc.amot_First, 0);
          OD002_MakeLine_ApsendAMO("F", D, L_ODoc.amot_Final, 0);
         END;
        END;
       END;
      END;
     END;
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
  END;
 END {OD002_TestOfficer};

 PUBLIC PROCEDURE OD002();
  CONST
   bpId = "OD002";
  VAR
   D        : DATE;
   odk_mea,
   odk_fmmea: LIKE(ODocKind.ODocKind);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_bp.Begin(bpId, " ᬮ஢", L_bp.t_Basis, L_General.tc_inIntvl);
  L_AFM.MakeIndex("od002", "Man: LIKE(Man.Man); D: DATE; Cnt: NUMERIC[0]");

  TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_THROW)]
   odk_mea  :=L_kn.GetSoft(Memo.ud_ut(), L_ODoc.erkn_MedicalExaminationAct);
   odk_fmmea:=L_kn.GetSoft(Memo.ud_ut(), L_ODoc.erkn_ForeignManMedExamAct);
  EXCEPT
  END;

  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  OD002_MakeTop("F");
  D:=Memo.ud_fr();
  WHILE D <= Memo.ud_ut() DO
   PROMPT(L_DatTim.DateStr(D));
   OD002_ODocList(D, odk_mea);
   OD002_ODocList(D, odk_fmmea);
   OD002_TestRWayS(D);
   OD002_TestOfficer(D, odk_mea);
   INC(D);
  END;
  FIO.Close(F);
  L_bp.End();
 END {OD002_Make};

 PUBLIC PROCEDURE LikeMenu_Ins();
 BEGIN
  LIKEMENU(Ins, "@ BuildDocByBCS=True");
 END {LikeMenu_Ins};

 PRIVATE PROCEDURE BuildODoc(RefDocId: L_XDoc.tXDocId; _CopyCnt: L_XDoc.tCopyCnt; VAR _Message: STRING[]);
  VAR
   xdt  : L_XDoc.tXDocType;
   xdknd: L_XDoc.tXDocKind;
   xd   : L_XDoc.tXDoc;
 BEGIN
  IF L_XDoc.IsAcceptableBCCommand(RefDocId, L_XDoc.cmd_BadXDocBC) THEN
   RefDocId:=L_XDoc.GetRequiredTypeXDoc_woBCS(L_XDoc.xdt_RWayS);
  END;
  L_XDoc.DecodeXDocId(RefDocId, xdt, xdknd, xd);
  IF (xdt = L_XDoc.xdt_RWayS) | (xdt = L_XDoc.xdt_Staff) THEN
   L_XDoc.ref_XDocId:=RefDocId;
   L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly,
                                L_XDoc.XDocKindId(L_XDoc.xdt_ODoc,
                                                  L_kn.Get(SYSDATE(), L_ODoc.erkn_MedicalExaminationAct)),
                                "ODoc.LikeMenu_Ins()");
  ELSIF (xdt = L_XDoc.xdt_Man) THEN
   L_XDoc.ref_XDocId:=RefDocId;
   L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly,
                                L_XDoc.XDocKindId(L_XDoc.xdt_ODoc,
                                                  L_kn.Get(SYSDATE(), L_ODoc.erkn_ForeignManMedExamAct)),
                                "ODoc.LikeMenu_Ins()");
  ELSE
   L_General.Error("⮬᪮ ନ஢  ᪠|⮫쪮   ,   ࠡ⭨ (ய)");
  END;
 END {BuildODoc};

 PUBLIC PROCEDURE amo_MakeAllRight();
 BEGIN
  L_General.Assert(RTI.Get().CurZone.Fields(v_AMO_AlcoholTestResult).Value # 1,
                   "⥫쭠 ஡  .   ᪥ ?");
  L_General.Assert(!RTI.Get().CurZone.Fields(v_AMO_Kind).Value |
                   (RTI.Get().CurZone.Fields(v_AMO_Kind).Value = L_Str.PoolItem(L_ODoc.amo_KindPool, L_ODoc.amok_Granted)),
                   " 㪠 稭 ᪠");
  IF ~!RTI.Get().CurZone.Fields(v_AMO_Complaints).Value &
     (RTI.Get().CurZone.Fields(v_AMO_Complaints).Value # "") THEN
   L_StdFrm.Choice(" ࠡ⭨  . ?");
  END;
  RTI.Get().CurZone.Fields(v_AMO_Complaints).Value:="";
  RTI.Get().CurZone.Fields(v_AMO_AlcoholTestResult).Value:=0;
  RTI.Get().CurZone.Fields(v_AMO_Kind).Value:=L_Str.PoolItem(L_ODoc.amo_KindPool, L_ODoc.amok_Granted);
  FIXALTERING();
  LIKEMENU(Cancel, "Save");
 END {amo_MakeAllRight};

 PRIVATE PROCEDURE ODocKind_OnAnyModification();
 BEGIN
  (* 0078979   㤠 25.06.2010 11:38:21 POLAK\MLB *)
 END {ODocKind_OnAnyModification};

 PRIVATE PROCEDURE ODocKind_OnAfterEdIns();
 BEGIN
  IF L_kn.Is(SYSDATE(), L_ODoc.erkn_RAccid) & (ODocKind.Scope # L_ODoc.odks_Internal) THEN
   L_kn.AccessERKN("ODocKind", L_ODoc.erkn_RAccid);
   L_General.Error("㬥  祭 '" + ERKN.Name + "'   ⮫쪮 ७");
  END;
 END {ODocKind_OnAfterEdIns};

 PRIVATE PROCEDURE ODocKind_OnAfterEdit();
 BEGIN
  ODocKind_OnAnyModification();
  ODocKind_OnAfterEdIns();
 END {ODocKind_OnAfterEdit};

 PRIVATE PROCEDURE ODocKind_OnAfterInsert();
 BEGIN
  ODocKind_OnAnyModification();
  ODocKind_OnAfterEdIns();
 END {ODocKind_OnAfterInsert};

 PRIVATE PROCEDURE ODocKind_OnBeforeDelete();
 BEGIN
  ODocKind_OnAnyModification();
 END {ODocKind_OnBeforeDelete};

 PRIVATE PROCEDURE formGet_RACertif();
  VAR
   Fields : FORM_FIELDS;
   Idx    : SCAL[L_ODoc.CntViolat];
   Violat : STRING[][L_ODoc.CntViolat];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   Violat[Idx]:=Fields(L_WDO.Fld_wIdx("Violat", Idx)).Value;
  END;
  L_ODoc.Encode_Violat(RAccid.Violat, Violat);
  REPLACE(RAccid);
 END {formGet_RACertif};

 PRIVATE PROCEDURE ra_PutNonCriticalProblemMsg(W: FORM_WINDOW; DocPassed: SCAL[2]);
  VAR
   Fields               : FORMFIELDS;
   MsgProblem           : STRING[];
 BEGIN
  Fields:=W.Zones(0).Fields;
  IF ra_HasNonCriticalProblem(MsgProblem) THEN
   IF ~DocPassed THEN
    Fields("HasNonCriticalProblem").Value:=hncp_Yes;
   ELSE
    Fields("HasNonCriticalProblem").Value:=hncp_No;
   END;
   Fields("HasNonCriticalProblem").Modifiable:=1;
  ELSE
   Fields("HasNonCriticalProblem").Value:=hncp_NoDefect;
   Fields("HasNonCriticalProblem").Modifiable:=0;
  END;
  Fields("MsgProblem").Value:=MsgProblem;
  Fields("MsgProblem").Visible:=Fields("HasNonCriticalProblem").Value # hncp_NoDefect;
  MsgProblem_SetColor(W);
 END {ra_PutNonCriticalProblemMsg};

 PRIVATE PROCEDURE RAccid_OnAfterEdIns();
 BEGIN
  IF    RTI.Get().CurWindow.OriginalName = "RACertif" THEN
   formGet_RACertif();
   ram_CheckCarsHasDrivers(1);
  END;
  ra_PutNonCriticalProblemMsg(RTI.Get().CurWindow.ParentZone.Window, 0);
 END {RAccid_OnAfterEdIns};

 PRIVATE PROCEDURE RAccid_OnAfterEdit();
 BEGIN
  RAccid_OnAfterEdIns();
 END {RAccid_OnAfterEdit};

 PRIVATE PROCEDURE RAccid_OnAfterInsert();
 BEGIN
  RAccid_OnAfterEdIns();
 END {RAccid_OnAfterInsert};

 PRIVATE PROCEDURE ra_CalculateTotalDmg(trgXDocId: LIKE(RAccid.XDocId));
 BEGIN
  L_General.CallUs(SEARCH(RAccid, XDocId, trgXDocId));
  IF ~!RAccid.OurDmgS THEN
   RAccid.TotDmgS:=RAccid.OurDmgS;
  ELSE
   RAccid.TotDmgS:=0;
  END;
  SETSEL(RAMemb, Dmg, RAccid.XDocId);
  SRCINSEL(RAMemb, GE, , L_ODoc.d_YesInjuries);
  WHILE OCCURE(RAMemb) DO
   IF ~!RAMemb.DmgS THEN
    INC(RAccid.TotDmgS, RAMemb.DmgS)
   END;
   NEXT(RAMemb);
  END; (* WHILE OCCURE(RAMemb) ... *)
  REPLACE(RAccid);
 END {ra_CalculateTotalDmg};

 PRIVATE PROCEDURE RAccid_OurDmgS_OnSuccessfulChange();
 BEGIN
  ra_CalculateTotalDmg(RAccid.XDocId);
 END {RAccid_OurDmgS_OnSuccessfulChange};

 PRIVATE PROCEDURE OD_RAcc_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ODoc";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "MsgProblem").LineBreakEnable:=1;
  L_WDO.iField       (0, "RAccid_RWayS").OwnerWindowOriginalName:="RWayS";
  L_WDO.iField       (0, "RAccid_RWayS").OwnerZoneNumber:=1;
  L_WDO.iScsChange   (0, ["HasNonCriticalProblem", "RAccid_Intoxic", "RAccid_Place", "RAccid_CntPass", "RAccid_RWayS", "RAccid_Time", "RAccid_Kind"]);
  L_WDO.iUnmodifiable(0, ["MsgProblem", "EDOStr", "Mark_Name", "Mark_Mark", "Car_StateNbr", "ODoc.ODoc", "Car_BoxNbr"]);
  L_WDO.iMayBeEmpty  (0, ["RAccid_Intoxic", "RAccid_Place", "RAccid_CntPass", "RAccid_Kind"]);
  L_WDO.iField       (0, "ODoc.Status"          ).Format:=L_ODoc.StatusPool(0);
  L_WDO.iField       (0, "RAccid_Kind"          ).Format:=L_ODoc.k_pool;
  L_WDO.iField       (0, "RAccid_Intoxic"       ).Format:=L_ODoc.i_pool;
  L_WDO.iField       (0, "HasNonCriticalProblem").Format:=hncp_Pool_Scal3;
  L_WDO.iField       (0, "HasNonCriticalProblem").Template        :=hncp_Pool_Scal2;
  L_WDO.iField       (0, "HasNonCriticalProblem").TemplateIsStrict:=1;
  L_WDO.iField       (0, "RAccid_Place"         ).Template        :=L_Pool.Get(L_ODoc.p_pool);
  L_WDO.iField       (0, "RAccid_Place"         ).TemplateIsStrict:=0;
  L_WDO.CreateFormLink("RWayS", "RAccid_");
 END {OD_RAcc_OnInitializeWindow};

 PRIVATE PROCEDURE ra_ANY_OnConformToWindow();
 BEGIN
  ACCESS(ODoc);
  L_General.CallUs(SELECT(RAccid, XDocId, ODoc.XDocId));
  SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, RAccid);
 END {ra_ANY_OnConformToWindow};

 PRIVATE PROCEDURE RADescr_OnConformToWindow();
 BEGIN
  ra_ANY_OnConformToWindow();
 END {RADescr_OnConformToWindow};

 PRIVATE PROCEDURE RACertif_OnConformToWindow();
 BEGIN
  ra_ANY_OnConformToWindow();
 END {RACertif_OnConformToWindow};

 PRIVATE PROCEDURE formSet_RACertif();
  VAR
   Fields: FORM_FIELDS;
   Idx   : SCAL[L_ODoc.CntViolat];
   Violat: STRING[][L_ODoc.CntViolat];
 BEGIN
  L_ODoc.Decode_Violat(RAccid.Violat, Violat);
  Fields:=RTI.Get().CurZone.Fields;

  FOR_EACH Idx DO
   Fields(L_WDO.Fld_wIdx("Violat", Idx)).Template        :=L_Pool.Get(L_ODoc.v_pool);
   Fields(L_WDO.Fld_wIdx("Violat", Idx)).TemplateIsStrict:=1;
   Fields(L_WDO.Fld_wIdx("Violat", Idx)).Value           :=Violat[Idx];
  END;
 END {formSet_RACertif};

 PRIVATE PROCEDURE RACertif_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit, L_WDO.e_OnAfterInsert, L_WDO.e_OnOpenZone]);
  L_WDO.iMayBeEmpty  (0, ["Violat_4", "Violat_3", "Violat_2", "Violat_1", "Violat_0"]);
  L_WDO.iProgs       (0, "ODoc");
  L_WDO.iField       (0, "RAccid.wGAIReg").Format:="|";

  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete]);
  L_WDO.iScsChange   (1, ["RAMemb.Name", "RAMemb.Dmg"]);
  L_WDO.iProgs       (1, "ODoc");
  L_WDO.iZone        (1).PermanentFilter:="RAMemb.Type=" + L_Str.IntStr(L_ODoc.t_Car);
  L_WDO.iField       (1, "RAMemb.Dmg").Format:=L_ODoc.dc_Pool;

  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iSubwindow   (2, "RAMembM");
  L_WDO.iProgs       (2, "ODoc");
  L_WDO.iZone        (2).PermanentFilter:="RAMemb.Type=" + L_Str.IntStr(L_ODoc.t_Man);
  L_WDO.iField       (2, "RAMemb.Dmg").Format:=L_ODoc.dm_Pool;
  L_WDO.iField       (2, "RAMemb.Who").Format:=L_ODoc.w_Pool;
  L_WDO.iField       (2, "RAMemb.Sex").Format:=L_Man.GetManSexPool();
 END {RACertif_OnInitializeWindow};

 PRIVATE PROCEDURE RACertif_0_OnZoneOpen();
 BEGIN
ACCESS(RAccid);
  formSet_RACertif();
 END {RACertif_0_OnZoneOpen};

 PRIVATE PROCEDURE RADamage_OnConformToWindow();
 BEGIN
  ra_ANY_OnConformToWindow();
 END {RADamage_OnConformToWindow};

 PRIVATE PROCEDURE RADamage_0_OnZoneOpen();
 BEGIN
ACCESS(RAccid);
  RTI.Get().CurWindow.Zones(1).PermanentFilter:="(RAMemb.RAccid=" + RAccid.XDocId + ") & (RAMemb.Dmg#" + L_Str.IntStr(L_ODoc.d_NoInjuries) + ")";
 END {RADamage_0_OnZoneOpen};

 PRIVATE PROCEDURE RAInstr_OnConformToWindow();
 BEGIN
  ra_ANY_OnConformToWindow();
 END {RAInstr_OnConformToWindow};

 PRIVATE PROCEDURE RAMembM_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeInsert]);
  L_WDO.iField       (0, "RAMemb.CarName").OnBeforeAsk:=1;
  L_WDO.iField       (0, "RAMemb.DmgStr").LineBreakEnable:=1;
  L_WDO.iField       (0, "RAMemb.Dmg").Format:=L_ODoc.dm_Pool;
  L_WDO.iField       (0, "RAMemb.Who").Format:=L_ODoc.w_Pool;
  L_WDO.iField       (0, "RAMemb.Sex").Format:=L_Man.GetManSexPool();
  L_WDO.iScsChange   (0, ["RAMemb.CarName", "RAMemb.Who", "RAMemb.Dmg"]);
  L_WDO.iMayBeEmpty  (0, ["RAMemb.CrtD"]);
  L_WDO.iProgs       (0, "ODoc");
 END {RAMembM_OnInitializeWindow};

 PRIVATE PROCEDURE RAMemb_OnBeforeEdit();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF RTI.Get().CurWindow.OriginalName = "RAMembM" THEN
   Fields("RAMemb.DmgStr" ).Modifiable:=RAMemb.Dmg # L_ODoc.d_NoInjuries;
   Fields("RAMemb.CarName").Modifiable:=RAMemb.Who # L_ODoc.w_Pedestrian;
  END;
 END {RAMemb_OnBeforeEdit};

 PRIVATE PROCEDURE RAMemb_OnBeforeInsert();
 BEGIN
  IF    RTI.Get().CurWindow.OriginalName = "RACertif" THEN
   RAMemb.Type:=L_ODoc.t_Car;
   REPLACE(RAMemb);
  ELSIF RTI.Get().CurWindow.OriginalName = "RAMembM"  THEN
   RAMemb.Type:=L_ODoc.t_Man;
   REPLACE(RAMemb);
  ELSIF RTI.Get().CurWindow.OriginalName = "RADamage"  THEN
   L_General.Error("⠢ 饭");
  ELSE
   L_General.CallUs(0);
  END;
 END {RAMemb_OnBeforeInsert};

 PRIVATE PROCEDURE RAMemb_OnBeforeDelete();
  CONST
   lnWho  = 8;
   lnSex  = 3;
   lnName = 32;
   lnCrtD = 13;
  VAR
   CarName : LIKE(RAMemb.Name);
   ErrorStr: STRING[];
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = "RADamage"  THEN
   L_General.Error(" 饭");
  ELSE
   IF    RAMemb.Type = L_ODoc.t_Car THEN
    CarName:=RAMemb.Name;
    SETEMPTY(ErrorStr);
    SAVE(RAMemb);
    SELECT(RAMemb, RAccid, , RAMemb.RAccid, L_ODoc.t_Man);
    WHILE OCCURE(RAMemb) DO
     IF RAMemb.CarName = CarName THEN
      INC(ErrorStr, Str.Align(L_Str.PoolItem(L_ODoc.w_Pool,         RAMemb.Who), lnWho,  LEFT) + "" +
                    Str.Align(L_Str.PoolItem(L_Man.GetManSexPool(), RAMemb.Sex), lnSex,  LEFT) + "" +
                    Str.Align(RAMemb.Name,                                       lnName, LEFT) + "" +
                    Str.Align(L_DatTim.DateStr(RAMemb.CrtD),                     lnCrtD, LEFT) + "|");
     END;
     NEXT(RAMemb);
    END; (* WHILE OCCURE(RAMemb) ... *)
    RESTORE(RAMemb);
    L_General.Assert(!ErrorStr, " ⥪   뫪:||" +
                                Str.Align("", lnWho, LEFT)            + "" +
                                Str.Align("", lnSex, LEFT)            + "" +
                                Str.Align("", lnName, LEFT)           + "" +
                                Str.Align(" ஦", lnCrtD, LEFT) + "|" +
                                L_Str.Repeat("", lnWho)  + "" +
                                L_Str.Repeat("", lnSex)  + "" +
                                L_Str.Repeat("", lnName) + "" +
                                L_Str.Repeat("", lnCrtD) + "|" +
                                ErrorStr);
   ELSIF RAMemb.Type = L_ODoc.t_Man  THEN
    (* nothing *)
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {RAMemb_OnBeforeDelete};

 PRIVATE PROCEDURE RAMemb_Name_OnSuccessfulChange();
  VAR
   NewName,
   OldName: LIKE(RAMemb.Name);
 BEGIN
  IF RAMemb.Type = L_ODoc.t_Car THEN
   OldName:=GE_PVALUE();
   NewName:=RAMemb.Name;
   SAVE(RAMemb);
   SELECT(RAMemb, RAccid, , RAMemb.RAccid, L_ODoc.t_Man);
   WHILE OCCURE(RAMemb) DO
    IF RAMemb.CarName = OldName THEN
     RAMemb.CarName:=NewName;
     REPLACE(RAMemb);
    END;
    NEXT(RAMemb);
   END; (* WHILE OCCURE(RAMemb) ... *)
   RESTORE(RAMemb);
  END;
 END {RAMemb_Name_OnSuccessfulChange};

 PRIVATE PROCEDURE ram_GetCarsPool(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(RAMemb);
  Result:=" |";
  SELECT(RAMemb, RAccid, , RAMemb.RAccid, L_ODoc.t_Car);
  WHILE OCCURE(RAMemb) DO
   INC(Result, RAMemb.Name + "|");
   NEXT(RAMemb);
  END; (* WHILE OCCURE(RAMemb) ... *)
  RESTORE(RAMemb);
  RETURN Result;
 END {ram_GetCarsPool};

 PRIVATE PROCEDURE RAMemb_CarName_OnBeforeAskForEdit();
  VAR
   CarsPool: STRING[];
   CarNum  : NUMERIC[0];
 BEGIN
  IF RAMemb.Type = L_ODoc.t_Man THEN
   CarsPool      :=ram_GetCarsPool();
   CarNum        :=L_StdFrm.ShowListAsMenu(CarsPool, "롮 ");
   RAMemb.CarName:=L_Str.PoolItem(CarsPool, CarNum);
   REPLACE(RAMemb);
  END;
 END {RAMemb_CarName_OnBeforeAskForEdit};

 PRIVATE PROCEDURE RAMemb_CarName_OnSuccessfulChange();
 BEGIN
  IF RAMemb.Type = L_ODoc.t_Man THEN
   L_General.ErrorInteractive_NonExistentOwner(~!L_Str.PositionInPool(ram_GetCarsPool(), RAMemb.CarName));
  END;
 END {RAMemb_CarName_OnSuccessfulChange};

 PRIVATE PROCEDURE RAMemb_Who_OnSuccessfulChange();
 BEGIN
  RTI.Get().CurZone.Fields("RAMemb.CarName").Modifiable:=RAMemb.Who # L_ODoc.w_Pedestrian;
  IF RAMemb.Who = L_ODoc.w_Pedestrian THEN
   SETEMPTY(RAMemb.CarName);
   REPLACE(RAMemb);
  END;
 END {RAMemb_Who_OnSuccessfulChange};

 PRIVATE PROCEDURE RAMemb_Dmg_OnSuccessfulChange();
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = "RAMembM" THEN
   RTI.Get().CurZone.Fields("RAMemb.DmgStr").Modifiable:=RAMemb.Dmg # L_ODoc.d_NoInjuries;
  END;
  IF RAMemb.Dmg = L_ODoc.d_NoInjuries THEN
   SETEMPTY(RAMemb.DmgStr, RAMemb.DmgS);
   REPLACE(RAMemb);
   ra_CalculateTotalDmg(RAMemb.RAccid);
  END;
 END {RAMemb_Dmg_OnSuccessfulChange};

 PRIVATE PROCEDURE RAMemb_DmgS_OnSuccessfulChange();
 BEGIN
  ra_CalculateTotalDmg(RAMemb.RAccid);
 END {RAMemb_DmgS_OnSuccessfulChange};

 PUBLIC PROCEDURE InsByBCS();
 BEGIN
  L_XDoc.DoByBarCode("ନ஢  㬥", PROCREF(BuildODoc), 0);
 END {InsByBCS};

 PRIVATE PROCEDURE View(trgScope: LIKE(ODocKind.Scope); AddToFatedName, PermanentFilter: STRING[]; curZoneNbr: NUMERIC[0]);
  VAR
   fw          : FORM_WINDOW;
   OriginalName,
   AssignedName: STRING[];
 BEGIN
  L_General.CallUs(~!trgScope);
  IF trgScope = L_ODoc.odks_Internal THEN
   OriginalName:="ODocInt";
  ELSE
   OriginalName:="ODoc";
  END;
  AssignedName:=OriginalName;
  IF ~!AddToFatedName THEN
   AssignedName:=AssignedName + "<xyz" + AddToFatedName + ">";
  END;

  fw:=APPLICATION.Get().Forms.Load(OriginalName, AssignedName);
  fw.Zones(2).PermanentFilter:=PermanentFilter;
  LIKEMENU(View, fw.Name + " " + L_Str.IntStr(curZoneNbr));
 END {View};

 PRIVATE PROCEDURE View_ByNotion(trgNotion: L_kn.tNotion);
  VAR
   trgODocKind: LIKE(ODocKind.ODocKind);
 BEGIN
  TRY [TABLE_FILTER_MODE(TABLE_FILTER_MODE_THROW)]
   trgODocKind:=L_kn.GetSoft(SYSDATE(), trgNotion);
  EXCEPT
  END; (* TRY *)
  IF !trgODocKind THEN
   L_kn.AccessERKN("ODocKind", trgNotion);
   L_StdFrm.BlueHalt("室   '  㬥⮢'  祭 '" + ERKN.Name + "'");
  END;
  SEARCH(ODocKind, ODocKind, , trgODocKind);
  View(ODocKind.Scope, ODocKind.ODocKind, "ODocKind.ODocKind=" + ODocKind.ODocKind, 1)
 END {View_ByNotion};

 PUBLIC PROCEDURE ViewMedicalExaminationAct();
 BEGIN
  View_ByNotion(L_ODoc.erkn_MedicalExaminationAct);
 END {ViewMedicalExaminationAct};

 PUBLIC PROCEDURE ViewForeignManMedExamAct();
 BEGIN
  View_ByNotion(L_ODoc.erkn_ForeignManMedExamAct);
 END {ViewForeignManMedExamAct};

 PUBLIC PROCEDURE ViewRAccid();
 BEGIN
  View_ByNotion(L_ODoc.erkn_RAccid);
 END {ViewRAccid};

 PRIVATE PROCEDURE View_ByScope(trgScope: LIKE(ODocKind.Scope));
 BEGIN
  View(trgScope, "", "ODocKind.Scope=" + trgScope, 2);
 END {View_ByScope};

 PUBLIC PROCEDURE ViewInt();
 BEGIN
  View_ByScope(L_ODoc.odks_Internal);
 END {ViewInt};

 PUBLIC PROCEDURE ViewExt();
 BEGIN
  View_ByScope(L_ODoc.odks_External);
 END {ViewExt};

 PUBLIC PROCEDURE OpenAddWin(WinName: STRING[]);
 BEGIN
  IF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit) |
     (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert) THEN
   LIKEMENU(Edit,    WinName + " 0 " + RTI.Get().CurWindow.Name + " " + RTI.Get().CurZone.Number);
  ELSE
   LIKEMENU(ShowWin, WinName + " 0 " + RTI.Get().CurWindow.Name + " " + RTI.Get().CurZone.Number);
  END;
 END {OpenAddWin};

 PRIVATE PROCEDURE ODSpcNam_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ODoc";
  L_WDO.iField       (0, "ODSpcNam.RegName").LineBreakEnable:=1;
  L_WDO.iZone        (1).RLevProg:="ODoc";
  L_WDO.iZone        (1).SubwindowOriginalName:="ODSpcNaE";
 END {ODSpcNam_OnInitializeWindow};

 PRIVATE PROCEDURE ODSpcNaE_OnInitializeWindow();
 BEGIN
  L_WDO.iMayBeEmpty  (0, ["ODSpcNam.Till"]);
  L_WDO.iField       (0, "ODSpcNam.Name").First:=1;
 END {ODSpcNaE_OnInitializeWindow};

 PRIVATE PROCEDURE ODE_CnChg_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ODoc";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition, L_WDO.e_OnOpenZone]);
  L_WDO.iField       (0, "ODoc.Descript").LineBreakEnable:=1;
  L_WDO.iField       (0, "v_ODoc_SingleRefDocName").LineBreakEnable:=1;
  L_WDO.iField       (0, "v_ODoc_SingleRefDoc").OnBeforeAsk:=1;
  L_WDO.iField       (0, "v_ODoc_SingleRefDoc").AskMode:=1;
  L_WDO.iField       (0, "v_ODoc_SingleRefDoc").OwnerWindowOriginalName:="Contract";
  L_WDO.iField       (0, "v_ODoc_SingleRefDoc").OwnerZoneNumber:=1;
  L_WDO.iScsChange   (0, ["v_ODoc_SingleRefDoc"]);
  L_WDO.iUnmodifiable(0, ["v_ODoc_SingleRefDocName", "ODoc.CopyCnt", "ODoc.ODoc", "ODoc.ODocKind"]);
  L_WDO.iMayBeEmpty  (0, ["ODoc.Descript", "ODoc.SrcNbr", "ODoc_Note"]);
 END {ODE_CnChg_OnInitializeWindow};

 PRIVATE PROCEDURE ODocE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ODoc";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition, L_WDO.e_OnOpenZone]);
  L_WDO.iField       (0, "ODoc.Descript").LineBreakEnable:=1;
  L_WDO.iUnmodifiable(0, ["ODoc.CopyCnt", "ODoc.ODoc", "ODoc.ODocKind"]);
  L_WDO.iMayBeEmpty  (0, ["ODoc.SrcNbr", "ODoc.Descript", "ODoc_Note"]);
 END {ODocE_OnInitializeWindow};

 PRIVATE PROCEDURE ODE_FrMs_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ODoc";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition, L_WDO.e_OnOpenZone]);
  L_WDO.iUnmodifiable(0, ["ODoc.CopyCnt", "ODoc.ODoc", "ODoc.ODocKind"]);
  L_WDO.iMayBeEmpty  (0, ["ODoc_Note", "ODoc.SrcNbr"]);
 END {ODE_FrMs_OnInitializeWindow};

 PRIVATE PROCEDURE ODE_CnMs_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ODoc";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition, L_WDO.e_OnOpenZone]);
  L_WDO.iField       (0, "v_ODoc_SingleRefDocName").LineBreakEnable:=1;
  L_WDO.iField       (0, "v_ODoc_SingleRefDoc").OnBeforeAsk:=1;
  L_WDO.iField       (0, "v_ODoc_SingleRefDoc").AskMode:=1;
  L_WDO.iField       (0, "v_ODoc_SingleRefDoc").OwnerWindowOriginalName:="Contract";
  L_WDO.iField       (0, "v_ODoc_SingleRefDoc").OwnerZoneNumber:=1;
  L_WDO.iScsChange   (0, ["v_ODoc_SingleRefDoc"]);
  L_WDO.iUnmodifiable(0, ["v_ODoc_SingleRefDocName", "ODoc.CopyCnt", "ODoc.ODoc", "ODoc.ODocKind"]);
  L_WDO.iMayBeEmpty  (0, ["ODoc_Note", "ODoc.SrcNbr"]);
 END {ODE_CnMs_OnInitializeWindow};

 PRIVATE PROCEDURE ODocECnt_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ODoc";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition, L_WDO.e_OnOpenZone]);
  L_WDO.iField       (0, "v_ODoc_SingleRefDocName").LineBreakEnable:=1;
  L_WDO.iField       (0, "v_ODoc_SingleRefDoc").OnBeforeAsk:=1;
  L_WDO.iField       (0, "v_ODoc_SingleRefDoc").AskMode:=1;
  L_WDO.iField       (0, "v_ODoc_SingleRefDoc").OwnerWindowOriginalName:="Contract";
  L_WDO.iField       (0, "v_ODoc_SingleRefDoc").OwnerZoneNumber:=1;
  L_WDO.iField       (0, "v_Template").LineBreakEnable:=1;
  L_WDO.iScsChange   (0, ["v_ODoc_SingleRefDoc", "ODoc.Sense"]);
  L_WDO.iUnmodifiable(0, ["v_ODoc_SingleRefDocName", "v_ODoc_SingleRefDocT", "v_Template", "ODoc.CopyCnt", "ODoc.ODoc", "ODoc.ODocKind"]);
  L_WDO.iMayBeEmpty  (0, ["ODoc_Note", "ODoc.SrcNbr"]);
 END {ODocECnt_OnInitializeWindow};

 PRIVATE PROCEDURE ODocStf_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ODoc";
  L_WDO.iZone        (0).ViewOnly:=1;
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iZone        (1).Narrowing:="ODoc.TSN=Staff.TSN";
 END {ODocStf_OnInitializeWindow};

 PRIVATE PROCEDURE ODocStf_1_OnSetSubwindow();
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_ShowWin THEN
   AnyODoc_1_OnSetSubwindow();
  ELSE
   RTI.Get().CurZone.SubwindowOriginalName:="";
  END;
 END {ODocStf_1_OnSetSubwindow};

BEGIN
 L_Events.ExecuteHandler();
END.
