(*
%Copyright   (c) Polak IT
%Author      17.08.2004 15:24:17 POLAK\ATS
%Purpose
%Type        operation
%Specific    SYS
%Modified    26.05.2014 09:51:35 POLAK\LDA
%Environment
*)

 MODULE ODocP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_MSO, E_ODoc, L_XDoc, L_ODoc, P_Firm, P_Cntr, Str, L_StdFrm, L_Events,
        L_DatTim, L_APEMl, L_EMail, L_Pmnt, L_Str, L_Staff, L_OwnData, L_FIO, L_Man, L_Russia,
        P_ODoc, P_Man, L_ctc, L_EC, L_XDF, L_APAR, L_kn;

(*
$P{ amo_Top1:
L_OwnData.ODFirmName(SYSDATE()), L, ""
"⮪ 樭᪮ ᬮ " + ODoc.ODoc, C, "", "B"
L_DatTim.FullDateStr(ODoc.Date), R, "", "B"
?, L, "H:M", "B"
@
################################################################################################

################################################################################################
########################################################################################## #####
}
*)

(*
$P{ amo_TopAMO:
Staff.TSN, L, "", "B"
Man.Name, L, "", "B"
Post.Name, L, "", "B"
Sort.Sort, L, "", "B"
Sort.Name, L, "", "B"
L_Staff.getDepartName(), L, "", "B"
@

. ##### ######################################### ###########################################
 ### ###################################### ⤥ ########################################
}
*)

(*
$P{ amo_TopFMMEA:
Man.Name, L, "", "B"
P_Firm.FP_ContractorBriefName(ODoc.Firm, ODoc.Date), L, "", "B"
@

 ᫥㥬 ###############################################################################
ࠣ       ###############################################################################
}
*)

(*
$P{ amo_Body1:
?, L, L_ODoc.amo_atrPool, "B"
L_EC.ExecE_Func_String(ODoc.Date, PROCREF(E_ODoc.amo_Alcotest1Name), "6510") + ":", L, ""
?, L, "2.", "B"
@
 ᫥:
஡  稥   堥 : ###########################
 ᫥ 堥     ################# #######
}
*)

(*
$P{ amo_atr2:
?, L, L_ODoc.amo_atrPool, "B"
@
 ᫥ 堥    㡪 客-७: #################
}
*)

(*
$P{ amo_atr3:
L_EC.ExecE_Func_String(ODoc.Date, PROCREF(E_ODoc.amo_Alcotest3Name), "6810  ਭ஬") + ":", L, ""
?, L, "2.", "B"
@
 ᫥ 堥     ################# #######
}
*)

(*
$P{ amo_Body2:
?, L, "", "B"
?, L, "", "B"
?, L, "", "B"
?, L, "", "B"
?, L, "", "B"
?, L, "", "B"
?, L, "", "B"
?, L, "", "B"
?, L, "", "B"
@

: ##########          : ##########          ਠ쭮 : #############
: ########################################################################################
祭: ####################################################################################
ਬ砭: ####################################################################################

஢ ᫥ #########################################################################
                       #########################################################################

                                                         _______________ #######################
}
*)

(*
$P{ amo_SuspendSigns:
L_Str.ShortName(Man.Name), L, ""
@


 १⠬ ᫥ , _______________  _______________ #######################
                                    (ᮣᥭ/ ᮣᥭ)
⥫.

________________________________________________________ _______________ _______________________

________________________________________________________ _______________ _______________________
}
*)

 PRIVATE PROCEDURE GetTemplate(OnDate: DATE): STRING[];
 BEGIN
  CONFORM(ODoc, ODocKind);
  IF    L_kn.Is(ODoc.Date, L_ODoc.erkn_ContractAddIns) THEN
   RETURN P_Cntr.GetContractAddInsTemplateName(Contract.Contract, ODoc.Sense, OnDate);
  ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_ContractMessage) THEN
   RETURN P_Cntr.GetContractMsgTemplateName(Contract.Contract, ODoc.Sense, OnDate);
  ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_FirmMessage) THEN
   IF    ODoc.Sense = L_ODoc.fms_BadPaidInvoices THEN
    RETURN "F_Msg01_01";
   ELSIF ODoc.Sense = L_ODoc.fms_PaymentReviseAct THEN
    RETURN "F_Msg02_01";
   ELSIF ODoc.Sense = L_ODoc.fms_PaymentReviseAct_InPer THEN
    RETURN "F_Msg03_01";
   END;
  ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_PowerOfAttorney) THEN
    RETURN "POAtt_01";
  ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_ForeignManMedExamAct) THEN
   RETURN "";
  ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_ViolationAct) THEN
   RETURN "OD_VA_01";
  ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_RAccid ) THEN
   RETURN "RAccid1";
  ELSIF ~!ODoc.Firm THEN
   RETURN "ODoc";
  ELSE
   RETURN "";
  END;
 END {GetTemplate};

 PRIVATE PROCEDURE amoTemp(_Temperature: NUMERIC[4,1]): STRING[];
 BEGIN
  IF ~!_Temperature THEN
   RETURN FLDTOSTR(_Temperature, "1.", 0);
  ELSE
   RETURN "ଠ쭠";
  END;
 END {amoTemp};

 PRIVATE PROCEDURE amoPulse(_Pulse: NUMERIC[4,0]): STRING[];
 BEGIN
  IF ~!_Pulse THEN
   RETURN L_Str.IntStr(_Pulse);
  ELSE
   RETURN "ଠ";
  END;
 END {amoPulse};

 PRIVATE PROCEDURE amoAD(_PressureHigh, _PressureLow: NUMERIC[4,0]): STRING[];
 BEGIN
  IF ~!_PressureHigh THEN
   RETURN L_Str.IntStr(_PressureHigh) + "/" + L_Str.IntStr(_PressureLow);
  ELSE
   RETURN "ଠ쭮";
  END;
 END {amoAD};

 PRIVATE PROCEDURE PrintSuspendSignsRequired(_AlcoholTestResult: SCAL[2];
                                             _Kind             : STRING[]): SCAL[2];
 BEGIN
  IF ~!_AlcoholTestResult THEN
   RETURN _AlcoholTestResult;
  ELSE
   RETURN (L_ODoc.amo_Kind() = L_ODoc.amok_Alcohol) | (L_ODoc.amo_Kind() = L_ODoc.amok_Drugs);
  END;
 END {PrintSuspendSignsRequired};

 PRIVATE PROCEDURE Print_AMO(PrpResult: L_MSO.PrpResultType);
  CONST
   RepName  = "ODAMO";
  VAR
   _Time             : TIME;
   medic, medicSN,
   _Kind,
   _Descript         : STRING[];
   _AlcoholTestResult: SCAL[2];
   _ATR1             : NUMERIC[2];
   _ATR2             : SCAL[2];
   _ATR3             : NUMERIC[2];
   _Complaints       : STRING[];
   _Temperature      : NUMERIC[4,1];
   _Pulse,
   _PressureHigh,
   _PressureLow      : NUMERIC[4,0];
   medicA            : STRING[][2];
 BEGIN
  APP.Get().NewPrompt("⮢ 㬥");
  L_ODoc.amo_DecodeDescription(_Time, _Kind, _Descript, _AlcoholTestResult, _ATR1, _ATR2, _ATR3,
                               _Complaints, _Temperature, _Pulse, _PressureHigh, _PressureLow);

  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc);
  WHILE XDocJrn.Action # L_XDoc.action_Insert DO
   NEXT(XDocJrn);
  END;
  CONFORM(XDocJrn, AcsObj);
  IF ~!AcsObj.Man THEN
   CONFORM(AcsObj, Man);
   L_Staff.StandOnAnyMainContract(AcsObj.Man, ODoc.Date);
   L_Staff.PosToStaffLog(Staff.TSN, ODoc.Date, 1);
   CONFORM(StaffLog, Post);
   medic  :=Post.Name + " " + Man.Name + ", ⠡. " + Staff.TSN;
   medicSN:=L_Str.ShortName(Man.Name);
  ELSE
   medic  :=AcsObj.FullName;
   medicSN:=L_Str.ShortName(AcsObj.FullName);
  END;

  IF PrpResult = L_MSO.PrpResult_Original THEN
   OPENREP(R, L_General.NameConnection(RepName), Print, CharsPerLine, 96,
                                                        Duplex, Off,
                                                        Orientation, Portrait,
                                                        PaperForm, A4);
  ELSE
   OPENREP(R, L_General.NameConnection(RepName), Create);
  END;
  SetPrintAttr(R, FontProperty, "/B");
  Str.Format(medicA, medic, 73, LEFT);

  MAKEPART(R, amo_Top1, _Time);
  IF    L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct) THEN
   L_General.Assert(~!ODoc.TSN, " 㪠 ࠡ⭨  ");
   CONFORM(ODoc, Staff);
   CONFORM(Staff, Man);
   L_Staff.PosToStaffLog(Staff.TSN, ODoc.Date, 1);
   CONFORM(StaffLog, Officer);
   CONFORM(Officer, Post);
   CONFORM(Officer, Sort);
   MAKEPART(R, amo_TopAMO);
  ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_ForeignManMedExamAct) THEN
   L_XDoc.PositionOnXDoc(L_XDoc.GetSingleRefToXDocId(L_XDoc.curXDocId(L_XDoc.xdt_ODoc)));
   MAKEPART(R, amo_TopFMMEA);
  END;

  MAKEPART(R, amo_Body1, _AlcoholTestResult, _ATR1);
  IF ~!_ATR2 THEN
   MAKEPART(R, amo_atr2, _ATR2);
  END;
  IF ~!_ATR3 THEN
   MAKEPART(R, amo_atr3, _ATR3);
  END;
  MAKEPART(R, amo_Body2, amoTemp(_Temperature), amoPulse(_Pulse), amoAD(_PressureHigh, _PressureLow),
                         _Complaints, _Kind, _Descript, medicA[0], medicA[1], medicSN);
  IF PrintSuspendSignsRequired(_AlcoholTestResult, _Kind) THEN
   MAKEPART(R, amo_SuspendSigns);
  END;
  CLOSEREP(R);
 END {Print_AMO};

 PRIVATE PROCEDURE CheckIfIsSent(_Action: LIKE(XDocJrn.Action));
 BEGIN
  L_General.Assert_wReferToAdmin(~L_XDoc.XDocIsSent(L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc),
                                 "㬥 ࠢ");
 END {CheckIfIsSent};

 PRIVATE PROCEDURE poap_SetDateVar(v: STRING[]; d: DATE);
  VAR
   fullStr: STRING[];
 BEGIN
  L_MSO.wordSetDateVar(v, d);
  L_MSO.wordSetVar(v + ".ByWord", Str.Small(L_DatTim.DateByWordStr(d)));
 END {poap_SetDateVar};

 PRIVATE PROCEDURE PowerOfAttorneyPrepare(Root: STRING[]);
 BEGIN
  poap_SetDateVar("ODoc.ExpirationDate", P_ODoc.GetExpirationDate(ODoc.ODocKind, ODoc.ODoc));
  CONFORM(ODoc, Staff);
  L_Staff.StaffFileFamily(ODoc.Date, ODoc.Date, Root + "Staff");
  CONFORM(Staff, Man);
  Root:=Root + "Staff.";
  L_MSO.wordSetVarsByFile_wPrefixE("Man",   Root, ~OCCURE(Man));
  L_MSO.wordSetVar(Root + "Man.Telephon", L_Man.ManPhone(ODoc.Date));
  L_Man.wordSetAddresses(Root + "Man.", Man.Man, ODoc.Date);
  IF ~L_Man.AccessManAdr(Man.Man, ODoc.Date, L_Russia.at_CtMA) THEN
   L_Man.AccessRgManAdr(Man.Man, ODoc.Date);
  END;
  CONFORM(ManAdr, Country);
  L_MSO.wordSetVarsByFile_wAlias("Country", Root + "Man.Citizenship");
  L_Staff.WordSetManName(Root);

  poap_SetDateVar("ODoc.Date", ODoc.Date);
  poap_SetDateVar("ODoc.SrcDate", ODoc.SrcDate);
 END {PowerOfAttorneyPrepare};

 PRIVATE PROCEDURE va_PutStaff(Root: STRING[]; trgTSN: LIKE(Staff.TSN));
 BEGIN
  IF ~!trgTSN THEN
   SEARCH(Staff, TSN, , trgTSN);
   CONFORM(Staff, Man);
   L_Staff.PosToStaffLog(Staff.TSN, ODoc.Date, 1);
   CONFORM(StaffLog, Officer);
   CONFORM(Officer, Post);
   CONFORM(Officer, Sort);
  END;

  L_MSO.wordSetVarsByFile_wPrefixE("Staff",   Root,                                 !trgTSN);
  L_MSO.wordSetVarsByFile_wPrefixE("Man",     Root + "Staff.",                      !trgTSN);
  L_MSO.wordSetVarsByFile_wPrefixE("Sort",    Root + "Staff.StaffLog.Officer.",     !trgTSN);
  L_MSO.wordSetVarsByFile_wPrefixE("Post",    Root + "Staff.StaffLog.Officer.",     !trgTSN);
 END {va_PutStaff};

 PRIVATE PROCEDURE va_PutStaff_ByXDocFlow(Root: STRING[]);
  VAR
   trgTSN: LIKE(Staff.TSN);
 BEGIN
  IF SELECT(XDocFlow, XDocFlow, L_XDoc.curXDocId(L_XDoc.xdt_ODoc)) THEN
   LAST(XDocFlow);
   WHILE OCCURE(XDocFlow) & ((XDocFlow.Action # L_XDF.a_Agreement) | !XDocFlow.To) DO
    PREV(XDocFlow);
   END; (* WHILE OCCURE(XDocFlow) ... *)
  END;
  IF OCCURE(XDocFlow) THEN
   trgTSN:=L_APAR.User2TSN(XDocFlow.SrcDate, XDocFlow.To);
  ELSE
   SETEMPTY(trgTSN);
  END;
  va_PutStaff(Root + "Receiver.", trgTSN);
 END {va_PutStaff_ByXDocFlow};

 PRIVATE PROCEDURE ViolationActPrepare(Root: STRING[]);
  VAR
   trgEDOKind: LIKE(EDOKind.EDOKind);
 BEGIN
  P_ODoc.Get_ViolationActContent(ODoc.ODocKind, ODoc.ODoc, trgEDOKind);
  SEARCH(EDOKind, EDOKind, , trgEDOKind);
  L_MSO.wordSetVarsByFile_wPrefixE("EDOKind", Root, ~OCCURE(EDOKind));

  va_PutStaff(Root, ODoc.TSN);

  va_PutStaff(Root + "Author.", L_XDoc.GetXDocAuthorTSN(L_XDoc.xdt_ODoc));

  va_PutStaff_ByXDocFlow(Root);
 END {ViolationActPrepare};

 PRIVATE PROCEDURE MakeAnyDoc(Stream: SCAL[2]; PrpResult: L_MSO.PrpResultType);
  VAR
   OnDate,
   _SrcDate     : DATE;
   refToXDocId  : L_XDoc.tXDocId;
   TemplateName,
   PrepareProc,
   Root,
   ODocName,
   SendToEMail  : STRING[];
   SendToContact: L_EMail.tContact;
   PrepareMode  : L_MSO.PrpModeType;
   Copies       : NUMERIC[0];
   cur_iri      : L_General.tInternalRecordId;
 BEGIN
  ACCESS(ODoc);
  IF PrpResult = L_MSO.PrpMode_Print THEN
   CheckIfIsSent(L_XDoc.action_Reprint);
  END;
  IF PrpResult = L_MSO.PrpResult_Original THEN
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc, L_XDoc.action_Reprint);
   INC(ODoc.CopyCnt); (* : 孨 ࠡ  ⨬ *)
   REPLACE(ODoc);
  END;
  refToXDocId:=L_XDoc.GetSingleRefToXDocId(L_XDoc.curXDocId(L_XDoc.xdt_ODoc));
  IF ~!refToXDocId THEN
   L_XDoc.PositionOnXDoc(refToXDocId);
  END;
  OnDate      :=ODoc.Date;
  TemplateName:=GetTemplate(OnDate);
  IF ~!TemplateName THEN
   TRY
    L_MSO.wordInitDocument(ODoc.SrcDate);
    PrepareMode:=L_MSO.GetStandartPrepareMode(PrpResult);
    Root       :="ODoc.";
    P_Firm.SetFirmDefaultData("Own", P_Firm.fomf(ODoc.MyFirm), ODoc.SrcDate, "");
    IF ~!ODoc.Firm THEN
     P_Firm.SetFirmData(Root, ODoc.Firm, ODoc.SrcDate, "", L_MSO.fps_Soft_asStr);
    END;
    L_MSO.wordSetVarsByFile("ODoc");
    IF OCCURE(Contract) THEN
     CONFORM(Contract, CntrT);
    END;
    L_MSO.wordSetVarsByFile_wPrefixE("Contract", Root,               ~OCCURE(Contract));
    L_MSO.wordSetVarsByFile_wPrefixE("CntrT",    Root + "Contract.", ~OCCURE(Contract));

    CONFORM(ODoc, ODocKind);
    L_MSO.wordSetVarsByFile_wPrefix("ODocKind", Root);
    L_MSO.wordSetVar(Root + "BarCode", L_XDoc.BarCode(L_XDoc.bck_IdIn17,
                                                      L_XDoc.xdt_ODoc,
                                                      ODoc.ODocKind,
                                                      ODoc.ODoc,
                                                      ODoc.CopyCnt));
    IF TemplateName # "ODoc" THEN
     IF    L_kn.Is(ODoc.Date, L_ODoc.erkn_FirmMessage) THEN
      CALL(O_Firm.MakeDocByODoc(PrpResult));
     ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_PowerOfAttorney) THEN
      PowerOfAttorneyPrepare(Root);
     ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_ViolationAct) THEN
      ViolationActPrepare(Root);
     ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_RAccid) THEN
      CALL(O_RAccid.MakeDoc(TemplateName, PrepareMode));
     ELSE
      CALL(O_Cntr.MakeDocByODoc());
     END;
    END;
(*
    IF Str.Match(TemplateName, "*##*") THEN
     TemplateName:=L_MSO.BuildTemplateName(TemplateName, P_Cntr.GetContractAddInsVersion(Contract.Contract, OnDate));
    END;
*)
    IF PrepareMode = L_MSO.PrpMode_Print THEN
     IF    L_kn.Is(ODoc.Date, L_ODoc.erkn_ContractAddIns) THEN
      Copies:=P_Cntr.GetContractAddInsCopies(Contract.Contract, ODoc.Sense, OnDate);
     ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_ContractMessage) THEN
      Copies:=P_Cntr.GetContractMsgCopies(Contract.Contract, ODoc.Sense, OnDate);
     ELSE
      Copies:=L_ODoc.E_ODocCopiesCount();
     END;
    ELSE
     Copies:=1;
    END;
    L_Pmnt.E_wordAsIfSignDocument(ODoc.MyFirm, OnDate, (PrpResult = L_MSO.PrpResult_Copy) | (PrpResult = L_MSO.PrpResult_Email));

    cur_iri:=L_General.iri_GetCurrent("ODoc");
    IF (PrepareMode = L_MSO.PrpMode_ToPDF) | (PrepareMode = L_MSO.PrpMode_ToImage) THEN
     L_MSO.MakeXDFWordDocument(cur_iri,
                               TemplateName,
                               Copies,
                               PrepareMode);
    ELSE
     L_MSO.MakeWordDocument(TemplateName,
                            Copies,
                            PrepareMode, "");
    END;

    IF PrpResult=L_MSO.PrpResult_Email THEN
     CONFORM(ODoc, ODocKind);
     ODocName:=L_Str.PoolItem(L_ODoc.E_GetSensePool(ODocKind.ODocKind), ODoc.Sense);
     IF !ODocName THEN
      ODocName:=ODocKind.SName;
     END;
     ODocName:=ODocName + " " + "(" + ODocKind.ODocKind + ")" + " " +
               ODoc.SrcNbr + "  " + L_DatTim.DateStr(ODoc.SrcDate);

     IF    ~!ODoc.Firm THEN
      CONFORM(ODoc, Firm);
      SendToContact:=L_EMail.AssembleContact(Firm.Name, P_Firm.FP_email(Firm.Firm, SYSDATE()));
     ELSIF ~!ODoc.TSN THEN
      CONFORM(ODoc, Staff);
      CONFORM(Staff, Man);
      SendToEMail:=P_Man.GetStaffWorkTelefon(SYSDATE(), P_Man.ci_EMail);
      IF !SendToEMail THEN
       SendToEMail:=L_ctc.GetCtcVal(0, Man.Contact, SYSDATE(), L_ctc.cvc_Home,  L_ctc.cvt_Email);
      END;
      IF !SendToEMail THEN
       SendToEMail:=L_ctc.GetCtcVal(0, Man.Contact, SYSDATE(), L_ctc.cvc_Other, L_ctc.cvt_Email);
      END;
      L_General.Assert(~!SendToEMail, " 㪠 EMail  ࠡ⭨ " + ODoc.TSN);
      SendToContact:=L_EMail.AssembleContact(L_Str.ShortName(Man.Name), SendToEMail);
     ELSE
      L_General.Error("ࠢ 㤠");
     END;
     L_APEMl.SendDocument(cur_iri, ODocName, SendToContact);
    END;
   EXCEPT
   ON Exc: Exc_Root DO
    IF PrpResult = L_MSO.PrpResult_Original THEN
     L_StdFrm.RedInform(L_General.ExcDescription(Exc));
    ELSE
     RAISE();
    END;
   END;
  ELSE
   (* ⠭ REP- (㤥?)*)
   IF    L_kn.Is(ODoc.Date, L_ODoc.erkn_MedicalExaminationAct) |
         L_kn.Is(ODoc.Date, L_ODoc.erkn_ForeignManMedExamAct)  THEN
    Print_AMO(PrpResult);
    IF PrpResult # L_MSO.PrpResult_Original THEN
     LIKEMENU(Survey, "");
    END;
   ELSE
    L_General.Error(" । 蠡  ");
   END;
  END;
 END {MakeAnyDoc};

 PUBLIC PROCEDURE SingleRePrint();
 BEGIN
  MakeAnyDoc(0, L_MSO.PrpMode_Print);
 END {SingleRePrint};

 PUBLIC PROCEDURE SinglePrePrint();
 BEGIN
  MakeAnyDoc(0, L_MSO.PrpMode_ToDoc);
 END {SinglePrePrint};

 PUBLIC PROCEDURE PrintCopy(Stream: SCAL[2]);
 BEGIN
  L_General.Assert(ACCESS(ODoc), " ⠭ ⥪騩 稩 㬥");
  TRY
   CONFORM(ODoc, ODocKind);
   L_General.Assert(L_kn.Is(ODoc.Date, L_ODoc.erkn_ContractAddIns)  |
                    L_kn.Is(ODoc.Date, L_ODoc.erkn_ContractMessage) |
                    L_kn.Is(ODoc.Date, L_ODoc.erkn_IngoingContractChange) |
                    L_kn.Is(ODoc.Date, L_ODoc.erkn_FirmMessage) |
                    L_kn.Is(ODoc.Date, L_ODoc.erkn_PowerOfAttorney),
                    "  '祣 㬥'    ।ᬮ७");
   L_General.Assert(L_XDoc.XDocIsVerifiedCC(L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc),
                    "  믮 ᫥ ⢥ত  㬥");
   MakeAnyDoc(0, L_MSO.PrpResult_Copy);
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc, L_XDoc.action_PrintCopy);
 END {PrintCopy};

 PUBLIC PROCEDURE Send(Stream: SCAL[2]);
 BEGIN
  L_General.Assert(ACCESS(ODoc), " ⠭ ⥪騩 稩 㬥");
  TRY
   CheckIfIsSent(L_XDoc.action_Sent);
   L_General.Assert(ODoc.Status=L_ODoc.ods_Passed, "  믮  㬥⮢  ﭨ '஢'");
   L_General.Assert(L_XDoc.XDocIsVerifiedCC(L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc),
                    "ࠢ 믮 ᫥ ⢥ত  㬥");
   MakeAnyDoc(0, L_MSO.PrpResult_Email);
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_ODoc, ODoc.ODocKind, ODoc.ODoc, L_XDoc.action_Sent);
 END {Send};

END.
