(*
%Copyright   (c) Polak Computer System
%Author      09.10.2000 19:45:57 SAM
%Purpose     ஫  ⭮ ᯨᠭ
%Type        control
%Specific    SYS
%Modified    19.09.2014 16:38:05 POLAK\Gina
%Environment
*)

 MODULE Officer [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_Events, L_General, P_Post, FIO, L_MSO, P_Firm, L_Str,
        P_Officer, L_StdFrm, L_ctc, P_MyFirm, L_DatTim, L_ACL, L_APtm, L_Prop,
        L_Pool, L_Staff, L_DBD, L_WDO, L_Acnt, L_PRoll, L_SysLog, L_Rpr;

 PRIVATE CONST
  pool_DirtyTypReason    = 0000969;
  pool_DirtyTypNutrition = 0000970;

 PRIVATE PROCEDURE intMakeCopy(srcOfficer: LIKE(Officer.Officer));
  VAR
   dstOfficer: LIKE(Officer.Officer);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   CHANGESEL(Officer, Officer, , Officer.Sort);
   dstOfficer:=0001;
   WHILE SRCINSEL(Officer, EQ, dstOfficer) DO
    INC(dstOfficer);
   END;
   SRCINSEL(Officer, EQ, , srcOfficer);
  EXCEPT
  END; (* TRY *)
  L_DBD.CopyFromSrcRecord("Officer", Officer.Sort + "|" + srcOfficer);
  Officer.Officer:=dstOfficer;
  REPLACE(Officer);

  SELECT(OfcDst, Officer, , Officer.Sort, srcOfficer);
  WHILE OCCURE(OfcDst) DO
   SAVE(OfcDst);
   OfcDst.Officer:=dstOfficer;
   INSERT(OfcDst);
   RESTORE(OfcDst);
   NEXT(OfcDst);
  END; (* WHILE OCCURE(OfcDst) ... *)

  SELECT(OfcShift, Officer, , Officer.Sort, srcOfficer);
  WHILE OCCURE(OfcShift) DO
   SAVE(OfcShift);
   OfcShift.Officer:=dstOfficer;
   INSERT(OfcShift);
   RESTORE(OfcShift);
   NEXT(OfcShift);
  END; (* WHILE OCCURE() ... *)
 END {intMakeCopy};

 PUBLIC PROCEDURE MakeCopy();
 BEGIN
  ACCESS(Officer);
  L_WDO.LaunchInsertBySource(Officer.Officer, "");
 END {MakeCopy};

 PRIVATE PROCEDURE Officer_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents(1, L_WDO.e_OnReposition);
  L_WDO.iSubwindow(1, "OfficerE");
  
  L_WDO.iEvents(2, L_WDO.e_OnSetSubwindow);
  L_WDO.iProgs(2, "ObjPro");
 END {Officer_OnInitializeWindow};

 PRIVATE PROCEDURE Officer_1_OnReposition();
 BEGIN
  CALL(ObjPro.UpdateCurObjectVal2Show("Officer", "OfcPro"));
 END {Officer_1_OnReposition};

 PRIVATE PROCEDURE SetDirtyTypPool(Z: FORM_ZONE);
 BEGIN
  Z.Fields("DirtyTyp.Power").Format   :=L_Staff.dtpwr_pool;
  Z.Fields("DirtyTyp.InjPower").Format:=L_Staff.dtinj_pool;
 END {SetDirtyTypPool};

 PRIVATE PROCEDURE OfficerE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeInsert, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["Officer.Contact", "Officer.BossSrt", "Officer.Begin"]);
  L_WDO.iMayBeEmpty  (0, ["Officer.Comment", "Officer.Till", "Officer.Contact",
                          "Officer.BossSrt", "Officer.BossOfc"]);

  L_WDO.iFieldAskMode(0, "Officer.BossSrt", FORM_FIELD.AskMode_Manual, "Sort", 1);
  L_WDO.iFieldAskMode(0, "Officer.BossOfc", FORM_FIELD.AskMode_Manual, "Sort", 1);

  L_WDO.iField       (0, "Officer.RspMAsst").Format:=L_Staff.rspma_pool;

  L_WDO.iProgs       (1, "Officer");

  L_WDO.iEvents      (3, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (3).Narrowing:="(OfcPro.Sort=Officer.Sort)&(OfcPro.Officer=Officer.Officer)";
  L_WDO.iProgs       (3, "ObjPro");
 END {OfficerE_OnInitializeWindow};

 PRIVATE PROCEDURE OfficerE_0_OnReposition();
 BEGIN
  RTI.Get().CurWindow.Zones(1).ViewOnly:=L_PRoll.UseSalDSet();
  RTI.Get().CurZone.Fields("Officer.SalDSet").Modifiable:=RTI.Get().CurWindow.Zones(1).ViewOnly;
  CALL(ObjPro.UpdateCurObjectVal2Show("Officer", "OfcPro"));
 END {OfficerE_0_OnReposition};

 PRIVATE PROCEDURE Officer_BossSrt_OnAskPhase1();
 BEGIN
 END {Officer_BossSrt_OnAskPhase1};

 PRIVATE PROCEDURE Officer_BossSrt_OnAskPhase2();
  VAR
   trgSort   : LIKE(Officer.Sort);
   trgOfficer: LIKE(Officer.Officer);
 BEGIN
  IF RTI.Get().TrgZone.MasterTable.Name = "Officer" THEN
   SAVE(Officer);
   GE_WZD_CURSOR(RTI.Get().TrgZone.Window.Name, RTI.Get().TrgZone.Number, Officer);
   trgSort   :=Officer.Sort;
   trgOfficer:=Officer.Officer;
   RESTORE(Officer);
  ELSE
   trgSort:=Sort.Sort;
   SETEMPTY(trgOfficer);
  END;
  Officer.BossSrt:=trgSort;
  Officer.BossOfc:=trgOfficer;
  REPLACE(Officer);
 END {Officer_BossSrt_OnAskPhase2};

 PRIVATE PROCEDURE Officer_BossSrt_OnSuccessfulChange();
 BEGIN
  IF ~!Officer.BossSrt THEN
   SEARCH(Sort, Sort, , Officer.BossSrt);
   L_Staff.CheckVeritableSort("ࠡ稥    樨஢ ⮫쪮  ᥪ஬");
  END;
 END {Officer_BossSrt_OnSuccessfulChange};

 PRIVATE PROCEDURE Officer_BossOfc_OnAskPhase1();
 BEGIN
  LIKEMENU(Ask, ". 2");
 END {Officer_BossOfc_OnAskPhase1};

 PRIVATE PROCEDURE Officer_BossOfc_OnAskPhase2();
 BEGIN
  Officer_BossSrt_OnAskPhase2();
 END {Officer_BossOfc_OnAskPhase2};

 PRIVATE PROCEDURE CheckBossesCycle();
 BEGIN
  IF ~!Officer.BossSrt THEN
   L_General.Assert(~!Officer.BossOfc, "   ।⢥ 㪮⥫"+
                                       "|    ६");
   IF L_Staff.IsBossOfficer(Officer.Sort, Officer.Officer, Officer.BossSrt, Officer.BossOfc) THEN
    L_General.Error("ୠ  稭");
   END;
   SAVE(Officer);
   SEARCH(Officer, Officer, , Officer.BossSrt, Officer.BossOfc);
   CheckBossesCycle();
   RESTORE(Officer);
  END;
 END {CheckBossesCycle};

 PRIVATE PROCEDURE AssertIsActive(Cond: SCAL[2]);
 BEGIN
  L_General.Assert(Cond, "⢮  "+L_Str.IntStr(P_Officer.P_LabourConditions)+" 室 ନ   ਮ ਬ ,"+
                         "|. ᢮⢮  "+L_DatTim.DateStr(OfcPro.Date));
 END {AssertIsActive};

 PRIVATE PROCEDURE CheckLabourConditions();
  VAR
   prvDocExpD: DATE;
 BEGIN
  L_General.Assert(SELECT(OfcPro, Officer, Officer.Sort, Officer.Officer, P_Officer.P_LabourConditions) & (OfcPro.Date <= Math.Max(L_Env.aptm_Start, Officer.Begin)),
                   "⢮  "+L_Str.IntStr(P_Officer.P_LabourConditions)+" 室 ନ   "+L_DatTim.DateStr(Math.Max(L_Env.aptm_Start, Officer.Begin)));
  SETEMPTY(prvDocExpD);
  WHILE OCCURE(OfcPro) DO
   AssertIsActive(!prvDocExpD | (OfcPro.Date = (prvDocExpD+1)));
   prvDocExpD:=OfcPro.DocExpD;
   NEXT(OfcPro);
  END; (* WHILE OCCURE(OfcPro) ... *)
  LAST(OfcPro);
  AssertIsActive(OfcPro.DocExpD >= Officer.Till);
 END {CheckLabourConditions};

 PRIVATE PROCEDURE Officer_OnAfterEdIns();
 BEGIN
  IF ~L_PRoll.UseSalDSet() THEN
   CONFORM(Officer, OfcDst);
   L_General.Assert(OCCURE(OfcDst), " 㪠 ᮡ । ௫");
  END;
  L_DBD.CheckOwnersValidity("Officer");
  IF !Officer.BossOfc & !Officer.BossSrt THEN
   L_StdFrm.Question("⢨⥫쭮  ।⢥ 㪮⥫?");
  END;
  CheckBossesCycle();
  CheckLabourConditions();
 END {Officer_OnAfterEdIns};

 PRIVATE PROCEDURE Officer_OnAfterEdit();
 BEGIN
  Officer_OnAfterEdIns();
  L_DBD.CheckUsersValidity("Officer");
 END {Officer_OnAfterEdit};

 PRIVATE PROCEDURE Officer_OnBeforeDelete();
 BEGIN
  L_ctc.BeforeOriginDelete (L_ctc.o_Officer);
 END {Officer_OnBeforeDelete};

 PRIVATE PROCEDURE Officer_OnBeforeInsert();
  VAR
   srcOfficer: LIKE(Officer.Officer);
 BEGIN
  srcOfficer:=L_WDO.GetInsertionSource();
  IF    ~!srcOfficer THEN
   IF !Officer.Sort THEN
    L_StdFrm.BlueHalt("⮢     ⥪ ");
   END;
   intMakeCopy(srcOfficer);
  ELSIF ~!Officer.Sort THEN
   CONFORM(Officer, Sort);
   L_Staff.CheckVeritableSort("ࠡ稥    樨஢ ⮫쪮  ᥪ஬");
   Officer.MyFirm:=Sort.MyFirm;
   REPLACE(Officer);
  ELSE
   L_StdFrm.BlueHalt("⠢     ⥪ ");
  END;
 END {Officer_OnBeforeInsert};

 PRIVATE PROCEDURE Officer_OnAfterInsert();
 BEGIN
  Officer_OnAfterEdIns();
 END {Officer_OnAfterInsert};

 PRIVATE PROCEDURE Officer_Contact_OnSuccessfulChange();
 BEGIN
  IF ~!Officer.Contact THEN
   CONFORM(Officer, Contact);
   L_General.Assert(Contact.Origin = L_ctc.o_Officer, " ᯮ짮 '⠪' ⮫쪮 ' '");
  END;
 END {Officer_Contact_OnSuccessfulChange};

 PRIVATE PROCEDURE Officer_Begin_OnSuccessfulChange();
  VAR
   srcOfficer: LIKE(Officer.Officer);
   srcRI     : LIKE(Officer.RECORDID);
 BEGIN
  srcOfficer:=L_WDO.GetInsertionSource();
  IF ~!srcOfficer THEN
   IF ~!GE_PVALUE() THEN
    L_StdFrm.Choice(" ᢮⢠  㤠  ⠢ , 㠫  " + L_DatTim.DateStr(Officer.Begin));
    SELECT(OfcPro, Officer, , Officer.Sort, Officer.Officer);
    WHILE OCCURE(OfcPro) DO
     L_Prop.RemoveCurrentPro("OfcPro");
    END; (* WHILE OCCURE(OfcPro) ... *)
   END;
   SAVE(Officer);
   SEARCH(Officer, Officer, , Officer.Sort, srcOfficer);
   srcRI:=Officer.RECORDID;
   RESTORE(Officer);
   L_Prop.CopyProRecords("Officer", srcRI, Officer.RECORDID);
  ELSE
   L_Prop.AnyProBeginChange("Officer", GE_PVALUE());
  END;
 END {Officer_Begin_OnSuccessfulChange};

 PUBLIC PROCEDURE MoveToOtherSort();
  VAR
   OldSort,
   NewSort   : LIKE(Sort.Sort);
   OldOfficer,
   NewOfficer: LIKE(Officer.Officer);
   OffName,
   FormStr   : STRING[];
 BEGIN
  L_General.Assert(ACCESS(Officer), " । ࠡ祥 ");

  IF SELECT(StaffLog, Officer, Officer.Sort, Officer.Officer) THEN
   L_General.Error(" ७ ࠡ祥 , ஥ 㦥 ਬ﫮| ࠡ⭨, ਬ ⠡. "+StaffLog.TSN);
  END;

  OldSort   :=Officer.Sort;
  OldOfficer:=Officer.Officer;

  CONFORM(Officer, Sort);
  CONFORM(Officer, Post);
  SETEMPTY(NewSort);
  OffName:=Officer.Officer + " " + Post.Name;
  FormStr:=L_StdFrm.sf_Choice("||७ ࠡ祥  " + OffName +
                              "|| ᥪ " + Sort.Sort + " " + Sort.Name +
                              "|| ᥪ %###%|", "%I");
  LOOP
   STDFORM(FormStr, "७ ࠡ祣 ", , 1, NewSort);
   IF    NewSort = OldSort THEN
    L_StdFrm.RedInform(" " + OffName + " 㦥  ᥪ " + OldSort);
   ELSIF ~SEARCH(Sort, Sort, NewSort) THEN
    L_StdFrm.RedInform("  ᥪ " + NewSort);
   ELSE
    EXIT;
   END;
  END; (*LOOP*)

  SAVE(Officer);
  IF SELECT(Officer, Sort, NewSort) THEN
   LAST(Officer);
   NewOfficer:=Officer.Officer + 1;
  ELSE
   NewOfficer:=1;
  END;
  RESTORE(Officer);

  SE_INTEGRITY(1);
  Officer.Sort   :=NewSort;
  Officer.Officer:=NewOfficer;
  Officer.MyFirm :=Sort.MyFirm;
  REPLACE(Officer);
  SE_INTEGRITY(0);
 END {MoveToOtherSort};

 PRIVATE PROCEDURE DirtyTyp_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, "");
  L_WDO.iSubwindow   (1, "DirtyTE");
  L_WDO.iProgs       (1, "Officer");
  SetDirtyTypPool(L_WDO.iZone(1));
 END {DirtyTyp_OnInitializeWindow};

 PRIVATE PROCEDURE DirtyTE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeInsert]);
  L_WDO.iScsChange   (0, ["DirtyTyp.Nutrition", "DirtyTyp.Reason"]);
  L_WDO.iMayBeEmpty  (0, ["DirtyTyp.Nutrition", "DirtyTyp.Reason", "DirtyTyp.Till",
                          "DirtyTyp.Hazards", "DirtyTyp.JobKind"]);
  L_WDO.iProgs       (0, "Officer");
  L_WDO.iZone(0).Fields("DirtyTyp.MedExPer").Format:=L_Staff.dtmep_Pool;
  SetDirtyTypPool(L_WDO.iZone(0));
 END {DirtyTE_OnInitializeWindow};

 PRIVATE PROCEDURE SetDirtyTypReasonTemplate();
 BEGIN
  RTI.Get().CurZone.Fields("DirtyTyp.Reason").Template:=L_Pool.Get(pool_DirtyTypReason);
 END {SetDirtyTypReasonTemplate};

 PRIVATE PROCEDURE SetDirtyTypNutritionTemplate();
 BEGIN
  RTI.Get().CurZone.Fields("DirtyTyp.Nutrition").Template:=L_Pool.Get(pool_DirtyTypNutrition);
 END {SetDirtyTypNutritionTemplate};

 PRIVATE PROCEDURE DirtyTyp_Reason_OnSuccessfulChange();
 BEGIN
  L_Pool.Put(pool_DirtyTypReason, DirtyTyp.Reason);
  SetDirtyTypReasonTemplate();
 END {DirtyTyp_Reason_OnSuccessfulChange};

 PRIVATE PROCEDURE DirtyTyp_Nutrition_OnSuccessfulChange();
 BEGIN
  L_Pool.Put(pool_DirtyTypNutrition, DirtyTyp.Nutrition);
  SetDirtyTypNutritionTemplate();
 END {DirtyTyp_Nutrition_OnSuccessfulChange};

 PRIVATE PROCEDURE DirtyTyp_OnBeforeEdIns();
 BEGIN
  SetDirtyTypReasonTemplate();
  SetDirtyTypNutritionTemplate();
 END {DirtyTyp_OnBeforeEdIns};

 PRIVATE PROCEDURE DirtyTyp_OnBeforeEdit();
 BEGIN
  DirtyTyp_OnBeforeEdIns();
 END {DirtyTyp_OnBeforeEdit};

 PRIVATE PROCEDURE DirtyTyp_OnBeforeInsert();
 BEGIN
  DirtyTyp_OnBeforeEdIns();
 END {DirtyTyp_OnBeforeInsert};

 PRIVATE PROCEDURE DstMode_OnInitializeWindow();
 BEGIN
  L_WDO.iScsChange   (1, ["DstMode.DstMode"]);
  L_WDO.iMayBeEmpty  (1, ["DstMode.Till"]);
  L_WDO.iField       (1, "DstMode.MnMth").Format:=L_PRoll.dmmm_Pool;
  L_WDO.iField       (1, "DstMode.SFMth").Format:=L_PRoll.dmsf_Pool;
  L_WDO.iProgs       (1, "Officer");
 END {DstMode_OnInitializeWindow};

 PRIVATE PROCEDURE DstMode_DstMode_OnSuccessfulChange();
  CONST
   SpecDstMode = 99;
 BEGIN
  L_General.Assert(DstMode.DstMode # SpecDstMode, "ᮡ ।   "+DstMode.DstMode+" ଫ ⮫쪮 ࠧࠡ稪");
 END {DstMode_DstMode_OnSuccessfulChange};

 PRIVATE PROCEDURE TimeKeep_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "TimKeepE");
  L_WDO.iField       (1, "TimeKeep.SrtOrder").Format:=L_Staff.tkso_pool;
 END {TimeKeep_OnInitializeWindow};

 PRIVATE PROCEDURE TimKeepE_OnInitializeWindow();
 BEGIN
  L_WDO.iMayBeEmpty  (0, ["TimeKeep.Till"]);
  L_WDO.iField       (0, "TimeKeep.SrtOrder").Format:=L_Staff.tkso_pool;
 END {TimKeepE_OnInitializeWindow};

 PRIVATE PROCEDURE SalDSetE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, L_WDO.e_OnBeforeInsert);
  L_WDO.iMayBeEmpty  (0, ["SalDSet.Till"]);
  L_WDO.iProgs       (0, "Officer");

  L_WDO.iEvents      (1, [L_WDO.e_OnAfterMdf]);
  L_WDO.iMayBeEmpty  (1, ["SalDSetL.Till"]);
  L_WDO.iProgs       (1, "Officer");

  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iField       (2, "ACSetL.ACPrp").Format:=L_Acnt.acp_Pool;
 END {SalDSetE_OnInitializeWindow};

 PRIVATE PROCEDURE SalDSet_OnBeforeInsert();
 BEGIN
  IF ~L_PRoll.UseSalDSet() THEN
   L_General.Error(" ᥩ  饭");
  END;
 END {SalDSet_OnBeforeInsert};

 PRIVATE PROCEDURE SalDSetL_OnAfterEdIns();
 BEGIN

 END {SalDSetL_OnAfterEdIns};

 PRIVATE PROCEDURE SalDSetL_OnAfterInsert();
 BEGIN

 END {SalDSetL_OnAfterInsert};

 PRIVATE PROCEDURE SalDSetL_OnAfterEdit();
 BEGIN

 END {SalDSetL_OnAfterEdit};

 PRIVATE PROCEDURE SalDSetL_OnBeforeDelete();
 BEGIN

 END {SalDSetL_OnBeforeDelete};

 PRIVATE PROCEDURE SalDSetL_OnAfterDelete();
 BEGIN

 END {SalDSetL_OnAfterDelete};

 PRIVATE PROCEDURE FbyBoss_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Officer";
  L_WDO.iEvents   (1, "");
  L_WDO.iZone     (1).HierarchicLink:=LINK.Get("Officer", "Boss");
  L_WDO.iField    (1, "Officer.Sort").Hierarchic:=1;
  L_WDO.iSubwindow(1, "OfficerE");
  L_WDO.iProgs (1, "Officer");
 END {FbyBoss_OnInitializeWindow};

 PRIVATE PROCEDURE Sort_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Officer";
  L_WDO.iZone     (1).HierarchicLink:=LINK.Get("Sort", "Parent");
  L_WDO.iField    (1, "Sort.Name").Hierarchic:=1;
  L_WDO.iSubwindow(1, "SortE");
  L_WDO.iProgs    (1, "Officer");
  IF L_WDO.IsLoadableAskClone() & (RTI.Get().CurWindow.AskSourceField.Name = "Sort.Parent") THEN
   L_WDO.iZone    (1).PermanentFilter:="Sort.Leaf = 0";
  END;
  L_WDO.iZone     (2).Narrowing:="Officer.Sort=Sort.Sort";
  L_WDO.iSubwindow(2, "OfficerE");
  L_WDO.iProgs (2, "Officer");
 END {Sort_OnInitializeWindow};

 PRIVATE PROCEDURE SortE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterMdf, L_WDO.e_OnReposition]);
  L_WDO.iMayBeEmpty  (0, ["Sort.Parent", "Sort.Till"]);
  L_WDO.iProgs       (0, "Officer");
  L_WDO.iScsChange   (0, ["Sort.Till"]);
  RTI.Get().CurWindow.Zones(0).FLevProg:="Officer";
 END {SortE_OnInitializeWindow};

 PRIVATE PROCEDURE SortE_0_OnReposition();
  VAR
   CantChangeLeaf: SCAL[2];
   Fields        : FORM_FIELDS;
 BEGIN
  IF Sort.Leaf THEN
   RTI.Get().CurWindow.Title:="";
  ELSE
   RTI.Get().CurWindow.Title:="ࠧ";
  END;
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Sort.IsRpr").Modifiable:=Sort.Leaf & (L_Rpr.RprLev(SYSDATE()) # L_Rpr.rprl_None);
  SAVE(Sort);
  CantChangeLeaf:=~!Sort.Sort & (SELECT(Officer, Officer, Sort.Sort) | SELECT(Sort, Parent, Sort.Sort));
  RESTORE(Sort);
  IF CantChangeLeaf THEN
   Fields("Sort.Leaf").Modifiable:=0;
   Fields("Sort.Leaf").First     :=0;
  ELSE
   Fields("Sort.Leaf").Modifiable:=1;
   Fields("Sort.Leaf").Color:=FORM_FIELD.Color_Field1 + Sort.Leaf; (* 0096280 ,  ஡    *)
   Fields("Sort.Leaf").First     :=1;
  END;
  Fields("Sort.Sort").First:=~Fields("Sort.Leaf").First;
 END {SortE_0_OnReposition};

 PRIVATE PROCEDURE GetSortStr(trgSort: LIKE(Sort.Sort)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(Sort);
  SEARCH(Sort, Sort, , trgSort);
  Result:=Sort.Sort + " '" + Sort.Name + "'";
  RESTORE(Sort);
  RETURN Result;
 END {GetSortStr};

 PRIVATE PROCEDURE CheckOfficers(curSort: LIKE(Sort.Sort));
 BEGIN
  SELECT(Officer, Officer, , Sort.Sort);
  WHILE OCCURE(Officer) DO
   CONFORM(Officer, Post);
   L_General.Assert(~!Officer.Till, "  ࠧ " + GetSortStr(curSort) + ".|" +
                                    "稭:     , ਬ|" +
                                    " " + Officer.Officer + "  " + Post.Post + " '" + Post.Name + "'");
   NEXT(Officer);
  END; (* WHILE OCCURE(Officer) ... *)
 END {CheckOfficers};

 PRIVATE PROCEDURE CheckSort(curSort: LIKE(Sort.Sort));
  VAR
   trgSort: LIKE(Sort.Sort);
 BEGIN
  SAVE(Sort);
  IF Sort.Leaf THEN
   CheckOfficers(curSort);
  ELSE
   trgSort:=Sort.Sort;
   SELECT(Sort, Parent, , trgSort);
   WHILE OCCURE(Sort) DO
    L_General.Assert(~!Sort.Till, "  ࠧ " + GetSortStr(curSort) + ".|" +
                                  "稭:     ࠧ, ਬ|"
                                  + GetSortStr(Sort.Sort));
    CheckSort(curSort);
    NEXT(Sort);
   END; (* WHILE OCCURE(Sort) ... *)
  END;
  RESTORE(Sort);
 END {CheckSort};

 PRIVATE PROCEDURE Sort_Till_OnSuccessfulChange();
 BEGIN
  IF ~!Sort.Till THEN
   CheckSort(Sort.Sort);
  END;
 END {Sort_Till_OnSuccessfulChange};

 PRIVATE PROCEDURE Sort_OnBeforeInsert();
 BEGIN
  IF L_WDO.InHierarchyInsMode() THEN
   Sort.Leaf:=0;
  ELSE
   Sort.Leaf:=1;
  END;
  Sort.MyFirm:=P_Firm.DefineMyFirm();
  REPLACE(Sort);
 END {Sort_OnBeforeInsert};

 PRIVATE PROCEDURE Sort_OnAfterEdIns();
  VAR
   curDprt: SCAL[2];
   prntMF : LIKE(MyFirm.MyFirm);
 BEGIN
  IF ~!Sort.Parent THEN
   SAVE(Sort);
   curDprt  :=Sort.isDprt;
   WHILE ~!Sort.Parent DO
    SEARCH(Sort, Sort, , Sort.Parent);
    IF Sort.isDprt & curDprt THEN
     L_General.Error(" ࠧ " + Sort.Sort + " 㦥  '窠'  ⤥");
    END;
   END;
   RESTORE(Sort);

   SAVE(Sort);
   SEARCH(Sort, Sort, , Sort.Parent);
   prntMF:=Sort.MyFirm;
   RESTORE(Sort);
   IF Sort.MyFirm # prntMF THEN
    L_StdFrm.CrucialChoice("ࠧ " + Sort.Parent + " ⭮  㣮 ' ࣠樨'",
                           L_APtm.g_Staff);
   END;
  END;
 END {Sort_OnAfterEdIns};

 PRIVATE PROCEDURE Sort_OnAfterEdit();
 BEGIN
  Sort_OnAfterEdIns();
 END {Sort_OnAfterEdit};

 PRIVATE PROCEDURE Sort_OnAfterInsert();
 BEGIN
  Sort_OnAfterEdIns();
 END {Sort_OnAfterInsert};

 PRIVATE PROCEDURE Sort_OnBeforeDelete();
 BEGIN
 END {Sort_OnBeforeDelete};

 PRIVATE PROCEDURE AlTypeE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents    (0, [L_WDO.e_OnAfterInsert, L_WDO.e_OnAfterEdit]);
  L_WDO.iMayBeEmpty(0, ["AlType.Till"]);
  L_WDO.iField     (0, "AlType.Begin").Modifiable:=0;
  L_WDO.iProgs     (0, "Officer");
  L_WDO.iEvents    (1, [L_WDO.e_OnAfterDelete, L_WDO.e_OnAfterInsert, L_WDO.e_OnAfterEdit]);
  L_WDO.iProgs     (1, "Officer");
 END {AlTypeE_OnInitializeWindow};

 PRIVATE PROCEDURE AlType_SupportBeginTill();
  VAR
   D: DATE;
 BEGIN
  ACCESS(AlType);
  IF SELECT(AlTypeL, AlType, AlType.AlType) THEN
   AlType.Begin:=AlTypeL.Begin;
   REPLACE(AlType);
   LAST(AlTypeL);
   L_General.Assert(AlType.Till > AlTypeL.Begin,
                    " 砭 ⢨ ᯮᮡ   " +
                    "| 砫 ப ਨ (" + L_DatTim.DateStr(AlTypeL.Begin) + ")");
   D:=AlType.Till;
   WHILE OCCURE(AlTypeL) DO
    AlTypeL.Till:=D;
    REPLACE(AlTypeL);
    D:=AlTypeL.Begin;
    PREV(AlTypeL);
   END; (* WHILE OCCURE(AlTypeL) ... *)
  ELSE
   L_General.Error("  㪠 த⥫쭮");
  END;
 END {AlType_SupportBeginTill};

 PRIVATE PROCEDURE AlType_OnAfterInsert();
 BEGIN
  AlType_SupportBeginTill();
 END {AlType_OnAfterInsert};

 PRIVATE PROCEDURE AlType_OnAfterEdit();
 BEGIN
  AlType_SupportBeginTill();
  L_DBD.CheckValidity("AlType");
 END {AlType_OnAfterEdit};

 PRIVATE PROCEDURE AlTypeL_OnAfterDelete();
 BEGIN
  AlType_SupportBeginTill();
 END {AlTypeL_OnAfterDelete};

 PRIVATE PROCEDURE AlTypeL_OnAfterInsert();
 BEGIN
  AlType_SupportBeginTill();
 END {AlTypeL_OnAfterInsert};

 PRIVATE PROCEDURE AlTypeL_OnAfterEdit();
 BEGIN
  AlType_SupportBeginTill();
 END {AlTypeL_OnAfterEdit};

 PUBLIC PROCEDURE scs_GetFilters_Sort_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "쪮 ⤥",  "Sort.isDprt=1", 1);
  L_WDO.PutNewFilter(Filters, "쪮 ᥪ", "Sort.Leaf=1",   1);
 END {scs_GetFilters_Sort_1};

BEGIN
 L_Events.ExecuteHandler();
END.
