(*
%Copyright   (c) Polak Computer System
%Author      23.04.2002 15:30:57 GAV
%Purpose
%Type        control
%Specific    SYS
%Modified    13.12.2012 11:18:36 POLAK\LDA
%Environment
*)

 MODULE OKOF [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events;

 PRIVATE PROCEDURE OKOF_OnBeforeInsert();
  VAR
   _Groups: LIKE(OKOF.Groups);
 BEGIN
  SAVE(OKOF);
  L_General.Assert(SEARCH(OKOF, OKOF, OKOF.Parent), " । ⥪ ");
  L_General.Assert(~OKOF.Leaf, "  ⮫쪮  㯯");
  _Groups:=OKOF.Groups;
  RESTORE(OKOF);
  OKOF.ByUser  :=1;
  OKOF.Groups  :=_Groups;
  REPLACE(OKOF);
 END {OKOF_OnBeforeInsert};

 PRIVATE PROCEDURE OKOF_OnBeforeEdit();
 BEGIN
  L_General.Assert(OKOF.ByUser,
                   "  ⮫쪮 ⥫ ." +
                   "|" +
                   " ᬮ ᯮ ⠭  ShiftEnter");
 END {OKOF_OnBeforeEdit};

 PRIVATE PROCEDURE OKOF_OnBeforeDelete();
 BEGIN
  L_General.Assert(OKOF.ByUser, " 㤠 ⮫쪮 ⥫ ");
 END {OKOF_OnBeforeDelete};

 PRIVATE PROCEDURE OKOF_OnAfterEdIns();
 BEGIN
  OKOF.iiName:=OKOF.Name;
  REPLACE(OKOF);
 END {OKOF_OnAfterEdIns};

 PRIVATE PROCEDURE OKOF_OnAfterInsert();
 BEGIN
  OKOF_OnAfterEdIns();
 END {OKOF_OnAfterInsert};

 PRIVATE PROCEDURE OKOF_OnAfterEdit();
 BEGIN
  OKOF_OnAfterEdIns();
 END {OKOF_OnAfterEdit};

 PRIVATE PROCEDURE OKOFE_1_OnReposition();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  IF ACCESS(OKOFAttr) THEN
   CONFORM(OKOFAttr, OKOFGrp);
   Fields("v_OKOFStr" ).Value:=OKOFGrp.OKOFStr;
   Fields("v_Descr"   ).Value:=OKOFGrp.Descr;
   Fields("v_Comment" ).Value:=OKOFGrp.Comment;
   Fields("v_DprGroup").Value:=OKOFGrp.DprGroup;
  ELSE
   Fields("v_OKOFStr" ).Value:="";
   Fields("v_Descr"   ).Value:="";
   Fields("v_Comment" ).Value:="";
   Fields("v_DprGroup").Value:="";
  END;
 END {OKOFE_1_OnReposition};

BEGIN
 L_Events.ExecuteHandler();
END.
