(*
%Copyright   (c) Polak Computer System
%Author      09.03.2004 15:40:58 POLAK\GAV
%Purpose     ନ஢ 㬥⮢    MS_Office
%Type        operation
%Specific    SYS
%Modified    13.03.2014 16:12:57 POLAK\GAV
%Environment
*)

 MODULE O_Car [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Car, L_DatTim, L_General, L_Man, L_MathR, L_MSO, L_Str,
        P_Firm, P_Man, Memo, P_Mark, E_Way, Str, P_Car, P_MyFirm,
        L_AR, Math, L_StdFrm, L_APtm;

 PRIVATE TYPE
  tDocSource = SCAL[2];

 PRIVATE CONST
  ds_Car     = 0;
  ds_VehPasp = 1;

 PRIVATE PROCEDURE SetWordGIBDDTrusteeMan(D: DATE);
  VAR
   Root  : STRING[];
   HasPro: SCAL[2];
 BEGIN
  Root:="TheDoc.Staff";
  HasPro:=P_MyFirm.HasActualPro(L_Car.GetCarMyFirm(Car.BoxNbr, D), D, P_MyFirm.P_GIBDDTrustee);

  IF HasPro THEN
   SEARCH(Staff, TSN, , P_MyFirm.GetTSNByMFPro(MFPro.MyFirm, D, P_MyFirm.P_GIBDDTrustee, 0));
   L_MSO.wordSetVar(Root + ".WrkPhone", P_Man.GetStaffWorkTelefon(D, P_Man.ci_ExtTelefon));
   CONFORM(Staff, Man);
   L_Man.wordSetAddresses(Root + ".Man.", Man.Man, D);
  ELSE
   L_StdFrm.Choice(" 㪠 ७     " + L_DatTim.DateStr(D) +
                   "|(᢮⢮ 8016  ࣠樨 " + L_Car.GetCarMyFirm(Car.BoxNbr, D) + ")");
   L_MSO.wordSetVar(Root + ".WrkPhone", "");
   L_MSO.wordSetVar(Root + ".Man.RgAdr.Full", "");
  END;

  L_MSO.wordSetVarsByFile_wAliasE("Man",     Root+".Man",             ~HasPro);
  L_MSO.wordSetVarsByFile_wAliasE("FirmPro", Root+".Man.TrustLetter", ~HasPro);
 END {SetWordGIBDDTrusteeMan};

 PRIVATE PROCEDURE GetGIBDDNameAndAddrForDeclaration(VAR GIBDDName, GIBDDAddr: STRING[]);
  VAR
   Local: PROC;
   tmpGIBDDName: STRING[];
 BEGIN
  SETEMPTY(tmpGIBDDName);
  Local:=PROCREF(E_Way.GetGIBDDNameAndAddr);
  IF ~!Local THEN
   Local(tmpGIBDDName, GIBDDAddr);
  END;
  IF !GIBDDName THEN
   GIBDDName:=tmpGIBDDName;
  END;
  STDFORM(Str.Align(":",    52, LEFT) + "|" + "%L50I|" +
          Str.Align("  ⥫䮭:", 52, LEFT) + "|" + "%L50,2KI|||" +
          "%C10<{}⬥>X   %C11<{}믮>DB",
          " 樮 ࠧ ",
          ,
          1,
          GIBDDName, GIBDDAddr);
 END {GetGIBDDNameAndAddrForDeclaration};

 PRIVATE PROCEDURE GAI_PrepareStdObjects(D: DATE; GIBDDName: STRING[]; HasASp: SCAL[2]);
  VAR
   GIBDDAddr       : STRING[];
   Root            : STRING[];
   HasCLIObligatory: SCAL[2];
 BEGIN
  CONFORM(CarLog, Mark);
  CONFORM(CarLog, Car);
  CONFORM(VehPasp, VehType, EnginTyp);

  P_Firm.SetFirmData("Own", L_Car.GetFirmOfCar(D), D, "", "");
  L_MSO.wordSetVar("OwnFirm.GNI", Str.Slice(P_Firm.FP_KPP(L_Car.GetFirmOfCar(D), D), 0, 4));
  L_MSO.wordSetVarsByFile         ("VehPasp");
  Root:="VehPasp.";
  L_MSO.wordSetVarsByFile_wPrefix ("Car",      Root);
  L_MSO.wordSetVarsByFile_wPrefix ("Mark",     Root);
  L_MSO.wordSetVarsByFile_wPrefixE("VehType",  Root, ~OCCURE(VehType));
  L_MSO.wordSetVarsByFile_wPrefixE("EnginTyp", Root, ~OCCURE(EnginTyp));
  Root:=Root + "Car.";
  L_MSO.wordSetVarsByFile_wPrefix ("CarLog",   Root);
  HasCLIObligatory:=P_Car.HasActualCarPro(Car.BoxNbr, D, P_Car.P_CLI_Obligatory);
  L_MSO.wordSetVarsByFile_wAliasE("CarPro", Root + "CLIObligatory", ~HasCLIObligatory);
  SETEMPTY(GIBDDAddr);
  GetGIBDDNameAndAddrForDeclaration(GIBDDName, GIBDDAddr);
  L_MSO.wordSetVar("TheDoc.OrgName", GIBDDName);
  L_MSO.wordSetVar("TheDoc.OrgAddr", GIBDDAddr);
  SetWordGIBDDTrusteeMan(D);
  L_MSO.wordSetVarsByFile_wPrefixE("MDoc",     "",      ~HasASp);
  L_MSO.wordSetVarsByFile_wPrefixE("MDocKind", "MDoc.", ~HasASp);
 END {GAI_PrepareStdObjects};

 PRIVATE PROCEDURE PosToCarLogByVehPasp(OnDate: DATE);
 BEGIN
  L_General.Assert(L_Car.StandOnCarLogFromVehPasp(VehPasp.VehPasp, OnDate),
                   "  ᮯ⠢   " + L_DatTim.DateStr(OnDate));
 END {PosToCarLogByVehPasp};

 PRIVATE PROCEDURE GAIUnreg_Prepare(OnDate: DATE; VAR Template: STRING[]);
  VAR
   HasASp: SCAL[2];
 BEGIN
  IF ~!CarLog.Math THEN
   HasASp:=L_MathR.AccessMDoc_asASp(CarLog.Math);
   IF HasASp THEN
    CONFORM(MDoc, MDocKind);
   ELSE
    L_StdFrm.Choice("ꥪ  " + CarLog.Math + "    ᯨᠭ  " + L_DatTim.DateStr(OnDate));
    HasASp:=0;
   END;
  ELSE
   HasASp:=0;
  END;

  GAI_PrepareStdObjects(OnDate, VehPasp.CertOrg, HasASp);
  L_MSO.wordSetVar("TheDoc.SubjectOfAsk", "  ");
 END {GAIUnreg_Prepare};

 PRIVATE PROCEDURE GAIReg_Prepare(OnDate: DATE; VAR Template: STRING[]);
 BEGIN
  GAI_PrepareStdObjects(OnDate, "", 0);
  L_MSO.wordSetVar("TheDoc.SubjectOfAsk", "⠢  ");
 END {GAIReg_Prepare};

 PRIVATE PROCEDURE PrepareCarObjects(OnDate: DATE);
  VAR
   Root: STRING[];
 BEGIN
  P_Firm.SetFirmData("Own", L_Car.GetFirmOfCar(OnDate), OnDate, "", "");
  CONFORM(CarLog, Mark);
  L_Car.AccessVehPasp(Car.BoxNbr, OnDate);
  L_General.Assert(ACCESS(VehPasp), " ࠭ᯮ⭮ ।⢠   㪠 ");
  L_MSO.wordSetVarsByFile_wPrefix("Car", "");
  Root:="Car.";
  L_MSO.wordSetVarsByFile_wPrefix("Mark",    Root);
  L_MSO.wordSetVarsByFile_wPrefix("VehPasp", Root);
  P_Firm.SetFirmData("Car.VehPasp.Owner", VehPasp.Firm, OnDate, "", "");
 END {PrepareCarObjects};

 PRIVATE PROCEDURE Decl_CLI(OnDate: DATE; VAR Template: STRING[]);
  VAR
   Root: STRING[];
   HasPrvCLIObligatory: SCAL[2];
 BEGIN
  P_Firm.SetFirmData("Own", L_Car.GetFirmOfCar(OnDate), OnDate, "", "");
  CONFORM(CarLog, Mark);
  L_Car.AccessVehPasp(Car.BoxNbr, OnDate);
  L_General.Assert(ACCESS(VehPasp), " ࠭ᯮ⭮ ।⢠   㪠 ");
  Root:="DCLI.";
  L_MSO.wordSetVarsByFile_wPrefix("Car", Root);
  Root:="DCLI.Car.";
  L_MSO.wordSetVar(Root + "SitPVol",
                   L_Str.IntStr(P_Mark.GetP_PVSitting(Mark.Mark, OnDate)));
  L_MSO.wordSetVarsByFile_wPrefix("Mark",    Root);
  L_MSO.wordSetVarsByFile_wPrefix("VehPasp", Root);
  HasPrvCLIObligatory:=P_Car.HasCarPro(Car.BoxNbr, OnDate, P_Car.P_CLI_Obligatory) & (CarPro.DocExpD < (OnDate + 60));
  L_MSO.wordSetVarsByFile_wAliasE("CarPro", Root + "PrvCLIObligatory", ~HasPrvCLIObligatory);
 END {Decl_CLI};

 PRIVATE PROCEDURE DefineFullDocList(Source: tDocSource);
  VAR
   addDocProc: PROC;
 BEGIN
  SETEMPTY(addDocProc);
  IF    Source = ds_Car THEN
   IF L_APtm.IsMTA() THEN
    L_MSO.dl_AddGroup("᪨ ⥫᪨ ନ");
    L_MSO.dl_AddDocInCurGroup("  ஢", "ATTChk01", "", "Memo.ud_cd()");
    L_MSO.dl_AddDocInCurGroup("⮪ ஢ ⮢ ⠭", "ATTChk02", "", "Memo.ud_cd()");
    L_MSO.dl_AddDocInCurGroup("⥫⢮ ⢥ত ᭠饭 ", "ATTChk03", "", "Memo.ud_cd()");
   END;
   IF (L_General.GetAPSiteNumber() = 26) |
      (L_General.GetAPSiteNumber() = 51) |
      (L_General.GetAPSiteNumber() = 53) THEN
    L_MSO.dl_AddDoc("  祭  ", "Decl_CLI", "", "Memo.ud_cd()");
   END;
   addDocProc :=PROCREF(E_Way.DefineAdditionalDocList);
  ELSIF Source = ds_VehPasp THEN
   L_MSO.dl_AddDoc("    ⠭  ", "GAIDecl2", "GAIReg_Prepare", "Memo.ud_cd()");
   L_MSO.dl_AddDoc("    ⨨  ", "GAIDecl2", "GAIUnreg_Prepare", "Memo.ud_cd()");
   L_MSO.dl_AddDoc("    ᥭ    ", "GAIDecl3", "GAIReg_Prepare", "Memo.ud_cd()");
   addDocProc :=PROCREF(E_Way.DefineAdditionalVPDocumentsList);
  ELSE
   L_General.CallUs(0);
  END;
  IF ~!addDocProc THEN
   addDocProc();
  END;
 END {DefineFullDocList};

 PRIVATE PROCEDURE GetPrepareProc(): PROC;
  VAR
   ProcName: STRING[];
 BEGIN
  ProcName:=MSODL.Proc;
  IF !ProcName THEN
   ProcName:=MSODL.Template;
  END;
  RETURN PROCREF(^ProcName);
 END {GetPrepareProc};

 PRIVATE PROCEDURE GetCarDocDate(DateDef: STRING[]): DATE;
  VAR
   Result : DATE;
   GetDate: PROC;
 BEGIN
  IF DateDef="Memo.ud_cd()"  THEN
   Result:=Math.Max(Memo.ud_cd(), Car.BegDate);
  ELSE
   GetDate:=PROCREF(^DateDef);
   L_General.CallUs(~!GetDate);
   Result:=GetDate();
  END;
  L_Car.StandOnCarLog(Car.BoxNbr, Result);
  RETURN Result;
 END {GetCarDocDate};

 PRIVATE PROCEDURE GetVehPaspDocDate(DateDef: STRING[]): DATE;
  VAR
   Result : DATE;
   GetDate: PROC;
 BEGIN
  IF DateDef="Memo.ud_cd()"  THEN
   Result:=Math.Max(Memo.ud_cd(), VehPasp.Begin);
  ELSE
   GetDate:=PROCREF(^DateDef);
   L_General.CallUs(~!GetDate);
   Result:=GetDate();
  END;
  PosToCarLogByVehPasp(Result);
  RETURN Result;
 END {GetVehPaspDocDate};

 PRIVATE PROCEDURE E_O_Car_Copies(TemplateName: STRING[]): NUMERIC[0];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Way.O_Car_Copies);
  IF ~!Local THEN
   RETURN Local(TemplateName);
  ELSE
   RETURN 1;
  END;
 END {E_O_Car_Copies};

 PRIVATE PROCEDURE intMakeDoc(Source         : tDocSource;
                              TemplateName,
                              DateDef,
                              TextParam      : STRING[];
                              PrpMode        : L_MSO.PrpModeType;
                              PrepareProc    : PROC;
                              wGrantAllRights: SCAL[2]);
  VAR
   docD              : DATE;
   Copies            : NUMERIC[0];
 BEGIN
  IF    Source = ds_Car THEN
   docD:=GetCarDocDate(DateDef);
  ELSIF Source = ds_VehPasp THEN
   docD:=GetVehPaspDocDate(DateDef);
  ELSE
   L_General.CallUs(0);
  END;
  IF wGrantAllRights THEN
   L_AR.GrantRightsUnconditionally();
  END;
  Copies:=E_O_Car_Copies(TemplateName);
  L_MSO.wordInitDocument(docD);
  IF    Source = ds_Car THEN
   PrepareCarObjects(docD);
  END;
  IF ~!PrepareProc THEN
   PrepareProc(docD, TemplateName);
  END;
  L_MSO.UseTmpDot:=0;
  L_MSO.MakeWordDocument(TemplateName, Copies, PrpMode, TextParam);
 END {intMakeDoc};

 PRIVATE PROCEDURE extMakeDoc(Source   : tDocSource;
                              TextParam: STRING[];
                              PrpMode  : L_MSO.PrpModeType);
 BEGIN
  intMakeDoc(Source,
             MSODL.Template,
             MSODL.DateDef,
             TextParam,
             PrpMode,
             GetPrepareProc(),
             1);
 END {extMakeDoc};

 PUBLIC PROCEDURE MakeDoc(Source: tDocSource);
  VAR
   PrpMode: L_MSO.PrpModeType;
 BEGIN
  IF    Source = ds_Car THEN
   L_General.Assert(ACCESS(Car), " ⠭ ");
  ELSIF Source = ds_VehPasp THEN
   L_General.Assert(ACCESS(VehPasp), " ⠭ ");
  END;
  DefineFullDocList(Source);
  PrpMode:=L_MSO.PrpMode_Print;
  L_MSO.dl_SelectDoc(PrpMode);
  extMakeDoc(Source, "", PrpMode);
 END {MakeDoc};

END.
