(*
%Copyright   (c) Polak Computer System
%Author      23.07.2001 21:57:21 MOG
%Purpose     ନ஢ 㬥⮢    MS_Office
%Type        operation
%Specific    SYS
%Modified    16.05.2014 19:28:18 POLAK\LDA
%Environment
*)

 MODULE O_Cntr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, L_General, L_DatTim, L_Str, L_MSO, E_ODoc, E_Cntr, P_Firm, L_FIO,
        P_Cntr, L_XDoc, L_Pmnt, L_Cntr, L_Prop, L_ODoc, L_MDoc,
        L_EMail, L_APEMl, L_kn;

 PRIVATE VAR
  ButtonLst,
  TemplateLst,
  DateDefLst,
  PrepareProcLst : STRING[];
  _Ver           : STRING[];
  _CopyCnt       : NUMERIC[0];

 PRIVATE PROCEDURE DefineStandartList();
 BEGIN
  ButtonLst     :=" |";
  DateDefLst    :="*|";
  TemplateLst   :="*|";
  PrepareProcLst:="SelectCntr|";
  AppendAdditionalList();
 END {DefineStandartList};

 PRIVATE PROCEDURE AppendSingleList(VAR rLst: STRING[]; aLst: STRING[]);
 BEGIN
  rLst:=rLst + aLst + "|";
 END {AppendSingleList};

 PRIVATE PROCEDURE AppendAdditionalList();
  VAR
   Local               : PROC;
   adtButtonLst,
   adtTemplateLst,
   adtDateDefLst,
   adtPrepareProcLst: STRING[];
 BEGIN
  Local:=PROCREF(E_Cntr.GetAdditionalDocumentsList);
  IF ~!Local THEN
   Local(adtButtonLst,
         adtTemplateLst,
         adtDateDefLst,
         adtPrepareProcLst);
   AppendSingleList(     ButtonLst,      adtButtonLst);
   AppendSingleList(   TemplateLst,    adtTemplateLst);
   AppendSingleList(    DateDefLst,     adtDateDefLst);
   AppendSingleList(PrepareProcLst, adtPrepareProcLst);
  END;
 END {AppendAdditionalList};

 PRIVATE PROCEDURE BarCode(): STRING[];
 BEGIN
  RETURN L_XDoc.BarCode(L_XDoc.bck_IdIn17, L_XDoc.xdt_Contract, 0, Contract.Contract, _CopyCnt);
 END {BarCode};

 PRIVATE PROCEDURE PrepareCntrObjects(Root: STRING[]; OnDate, SrcDate: DATE; PrepareProc: PROC);
  VAR
   r,
   OwnContractor,
   OtherContractor,
   ContractExtNaming: STRING[];
   d_Begin,
   d_Till           : DATE;
   pad_Begin,
   pad_Till         : DATE;
   _FirmAcnt        : LIKE(FirmAcnt.FirmAcnt);
   SingleMath       : LIKE(Math.Math);
   OwnFirmAcnt      : LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  APP.Get().NewPrompt("㧪 ᢥ   " + Contract.Contract);
  r:=Root + "Contract.";
  L_MSO.wordSetVarsByFile("Contract");
  L_MSO.wordSetVar(r+"BarCode", BarCode());
  P_Cntr.GetContractDuration(Contract.Contract, OnDate, d_Begin, d_Till);
  L_MSO.wordSetDateVar(r+"Duration.Begin", d_Begin);
  L_MSO.wordSetDateVar(r+"Duration.Till",  d_Till);

  P_Cntr.GetPeriodicAcptDuration(Contract.Contract, OnDate, pad_Begin, pad_Till);
  L_MSO.wordSetDateVar(r+"PeriodicAcptDuration.Begin", pad_Begin);
  L_MSO.wordSetDateVar(r+"PeriodicAcptDuration.Till",  pad_Till);

  OwnFirmAcnt:=P_Cntr.GetDefaultPayOwnFirmAcnt(Contract.Contract, SrcDate);
  P_Firm.SetFirmData(    "Own", P_Firm.fomf(Contract.MyFirm), SrcDate, OwnFirmAcnt, "");
  P_Firm.SetFirmData(r + "Own", P_Firm.fomf(Contract.MyFirm), SrcDate, OwnFirmAcnt, "");
  L_Cntr.wordSetOwnAgentVars(Contract.Contract, P_Firm.fomf(Contract.MyFirm), SrcDate, r+"OwnAgent");

  _FirmAcnt:=P_Cntr.GetDefaultPayFirmAcnt(Contract.Contract, SrcDate);
  CONFORM(Contract, Firm);

  IF L_Cntr.IsFictiveContract(Contract.Contract) THEN
   P_Firm.SetEmptyFirmData(r, "");
  ELSE
   P_Firm.SetFirmData(r, Firm.Firm, SrcDate, _FirmAcnt, "");
  END;
  L_Cntr.wordSetPartnerAgentVars(EMPTYOF(MDoc.MDocKind), EMPTYOF(MDoc.MDoc), Contract.Contract, Firm.Firm, SrcDate, r+"PartnerAgent");

  CONFORM(Contract, CntrT);
  L_MSO.wordSetVarsByFile_wPrefix("CntrT",    r);
  L_Cntr.SetConsignees(OnDate);

  P_Cntr.GetContractorsName(Contract.Contract, OnDate, OwnContractor, OtherContractor);
  L_MSO.wordSetVar(r+"OwnContractor",   OwnContractor);
  L_MSO.wordSetVar(r+"OtherContractor", OtherContractor);
  ContractExtNaming:=P_Cntr.ContractExtNaming(Contract.Contract, OnDate);
  L_MSO.wordSetVar(r+"ExtNaming.Nominative",  L_Prop.getRES(ContractExtNaming, 0));
  L_MSO.wordSetVar(r+"ExtNaming.Genitive",    L_Prop.getRES(ContractExtNaming, 1));
  L_MSO.wordSetVar(r+"ExtNaming.Dative",      L_Prop.getRES(ContractExtNaming, 2));
  L_MSO.wordSetVar(r+"ExtNaming.Accusative",  L_Prop.getRES(ContractExtNaming, 3));
  L_MSO.wordSetVar(r+"ExtNaming.Ablative",    L_Prop.getRES(ContractExtNaming, 4));
  L_MSO.wordSetVar(r+"ExtNaming.Prepositive", L_Prop.getRES(ContractExtNaming, 5));

  SingleMath:=P_Cntr.GetCntrProSoft(Contract.Contract, OnDate, P_Cntr.P_SingleMath);
  IF ~!SingleMath THEN
   L_MSO.wordSetVarsByFile_wPrefixE("Math", r, ~SEARCH(Math, Math, SingleMath));
  ELSE
   L_MSO.wordSetVarsByFile_wPrefixE("Math", r, 1);
  END;

  P_Cntr.O_SetProperty(Contract.Contract, OnDate, 0, r, "Sum",             "SetMoneyVar");
  P_Cntr.O_SetProperty(Contract.Contract, OnDate, 0, r, "PrepaymentValue", "SetMoneyVar");

  L_MSO.wordSetVar(r + "CntrAddendum",         P_Cntr.GetCntrAddendum(Contract.Contract, OnDate));
  L_MSO.wordSetVar(r + "SpecialAttitudeToVAT", L_Str.IntStr(P_Cntr.GetSpecialAttitudeToVAT(Contract.Contract, OnDate)));

  IF ~!PrepareProc THEN
   PrepareProc(OnDate, r);
  END;
 END {PrepareCntrObjects};

 PRIVATE PROCEDURE PrepareClaim(D: DATE; Root: STRING[]);
  VAR
   _Underpay          : L_Pmnt.tValuesToBalance;
   OverdueBacklogSum,
   TotalBacklogSum    : NUMERIC[2];
   r                  : STRING[];
   OnDate,
   ExpirationDate     : DATE;
 BEGIN
  SETEMPTY(ExpirationDate);
  IF (ODoc.Date >= 01\05\2014) | P_ODoc.HasPro(ODoc.ODocKind, ODoc.ODoc, P_ODoc.P_ExpirationDate) THEN
   ExpirationDate:=P_ODoc.GetExpirationDate(ODoc.ODocKind, ODoc.ODoc);
  END;
  IF !ExpirationDate THEN
   ExpirationDate:=L_Pmnt.DateOfPerformanceOfLiability(D, STRTOFLD(P_Cntr.GetCntrProStrong(Contract.Contract, D, P_Cntr.P_PaymentDay), FLOAT));
  END;
  L_MSO.wordSetDateVar("ODoc.ExpirationDate", ExpirationDate);

  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF L_Pmnt.IsMayBePaidMDocKind(MDocKind.MDocKind) THEN
    SETZERO(OverdueBacklogSum, TotalBacklogSum);
    SELECT(MDoc, CntrClsd, , Contract.Contract, MDocKind.MDocKind);
    SRCINSEL(MDoc, GE, , D);
    WHILE OCCURE(MDoc) DO
     PROMPT("஢ઠ ﭨ  " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
     IF L_Pmnt.E_IsSellMDoc() & (MDoc.Status=L_MDoc.st_Passed) & (MDoc.Date<=D) THEN
      _Underpay:=L_Pmnt.vtbAdd(L_Pmnt.GetMDocAcpt(), L_Pmnt.GetMDocPmntBalance(D, L_XDoc.max_DoneDTS));
      IF MDoc.PayDate <= D THEN
       INC(OverdueBacklogSum, _Underpay[L_Pmnt.vtb_Total]);
      END;
      INC(TotalBacklogSum, _Underpay[L_Pmnt.vtb_Total]);
     END;
     NEXT(MDoc);
    END; (* WHILE OCCURE(MDoc) *)

    r:=Root + "prbMDoc" + MDocKind.MDocKind + ".";
    L_MSO.wordSetMoneyVar(r + "Backlog.OverdueSum", D, OverdueBacklogSum);
    L_MSO.wordSetMoneyVar(r + "Backlog.TotalSum",   D, TotalBacklogSum);
   END; (* IF ... *)
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
 END {PrepareClaim};

 PRIVATE PROCEDURE E_DefineTemplateVerAndCopyCnt(OnDate      : DATE;
                                                 TemplateName: STRING[]);
  VAR
   Local: PROC;
 BEGIN
  _Ver    :=P_Cntr.GetContractVersion(Contract.Contract, OnDate);
  _CopyCnt:=0;
  Local:=PROCREF(E_Cntr.DefineTemplateVerAndCopyCnt);
  IF ~!Local THEN
   Local(OnDate, TemplateName, _Ver, _CopyCnt);
  END;
 END {E_DefineTemplateVerAndCopyCnt};

 PRIVATE PROCEDURE SelectCntr(    OnDate      : DATE;
                              VAR DateDef     : STRING[];
                              VAR TemplateName: STRING[];
                              VAR PrepareProc : STRING[]);
  VAR
   Local: PROC;
 BEGIN
  DateDef     :="Contract.Date";
  TemplateName:=P_Cntr.GetContractTemplateName(Contract.Contract, OnDate);
  SETEMPTY(PrepareProc);
  Local:=PROCREF(E_Cntr.SelectCntr);
  IF ~!Local THEN
   Local(DateDef, TemplateName, PrepareProc);
  END;
 END {SelectCntr};

 PRIVATE PROCEDURE GetAdditionalPrepareProc(D: DATE): PROC;
  VAR
   DateDef,
   ContractTemplateName,
   PrepareProc : STRING[];
 BEGIN
  SETEMPTY(DateDef, ContractTemplateName, PrepareProc);
  SelectCntr(D, DateDef, ContractTemplateName, PrepareProc);
  RETURN PROCREF(^PrepareProc);
 END {GetAdditionalPrepareProc};

 PRIVATE PROCEDURE intMakeAnyDoc(PrpResult: L_MSO.PrpResultType; Choice: NUMERIC[0]);
  VAR
   PrepareMode : L_MSO.PrpModeType;
   OnDate      : DATE;
   DateDef,
   TemplateName,
   PrpProcName : STRING[];
   PrepareProc : PROC;
   Copies      : NUMERIC[0];
   EMSubject   : STRING[];
   cur_iri     : L_General.tInternalRecordId;
 BEGIN
  L_Pmnt.AccessContract();
  DefineStandartList();
  PrepareMode :=L_MSO.GetStandartPrepareMode(PrpResult);

  DateDef     :=L_Str.PoolItem(DateDefLst,      Choice);
  PrpProcName :=L_Str.AnyItem(PrepareProcLst, "|", Choice);
  TemplateName:=L_Str.PoolItem(TemplateLst,     Choice);

  IF TemplateName = "*" THEN
   SelectCntr(Contract.Date, DateDef, TemplateName, PrpProcName);
  END;
  L_General.Assert(~!TemplateName, " ஢  " + Contract.CntrT + "  ন");
  PrepareProc :=STRTOFLD(PrpProcName, PROC);

  IF DateDef = "Contract.Date" THEN
   OnDate:=Contract.Date;
  ELSE
   L_General.Error("O_Cntr:  ᯮᮡ ।  " + DateDef);
  END;

  _CopyCnt :=0;
  IF Str.Match(TemplateName, "*##*") THEN
   E_DefineTemplateVerAndCopyCnt(OnDate, TemplateName);
   TemplateName:=L_MSO.BuildTemplateName(TemplateName, _Ver);
  END;
  L_MSO.wordInitDocument(OnDate);
  PrepareCntrObjects("", OnDate, OnDate, PrepareProc);
  IF PrepareMode = L_MSO.PrpMode_Print THEN
   Copies:=P_Cntr.GetContractCopies(Contract.Contract, OnDate);
  ELSE
   Copies:=1;
  END;

  cur_iri:=L_General.iri_GetCurrent("Contract");
  IF (PrepareMode = L_MSO.PrpMode_ToPDF) | (PrepareMode = L_MSO.PrpMode_ToImage) THEN
   L_MSO.MakeXDFWordDocument(cur_iri,
                             TemplateName,
                             Copies,
                             PrepareMode);
  ELSE
   L_MSO.MakeWordDocument(TemplateName,
                          Copies,
                          PrepareMode, "");
  END;

  IF PrpResult=L_MSO.PrpResult_Email THEN
   CONFORM(Contract, CntrT);
   CONFORM(Contract, Firm);
   EMSubject:=" " + Contract.SrcNbr +
             "  " + L_DatTim.DateStr(Contract.SrcDate) +
             ": " + CntrT.Name;

   L_APEMl.SendDocument(cur_iri,
                        EMSubject,
                        L_EMail.AssembleContact(Firm.Name, P_Firm.FP_email(Firm.Firm, SYSDATE())));
  END;
 END {intMakeAnyDoc};

 PRIVATE PROCEDURE E_GetPrepareProc(OnDate            : DATE;
                                    AddInsTemplateName: STRING[]): STRING[];
  VAR
   Local : PROC;
 BEGIN
  Local:=PROCREF(E_ODoc.ODocP_GetPrepareProc);
  IF ~!Local THEN
   RETURN Local(OnDate, AddInsTemplateName);
  ELSE
   RETURN "";
  END;
 END {E_GetPrepareProc};

 PUBLIC PROCEDURE MakeDocByODoc();
  VAR
   PrepareProc: STRING[];
   OnDate     : DATE;
 BEGIN
  ACCESS(ODoc);
  CONFORM(ODoc, ODocKind);
  _CopyCnt:=1; (* !?! *)
  IF    L_kn.Is(ODoc.Date, L_ODoc.erkn_ContractAddIns) THEN
   OnDate     :=ODoc.Date;
   PrepareProc:=E_GetPrepareProc(OnDate, P_Cntr.GetContractAddInsTemplateName(Contract.Contract, ODoc.Sense, OnDate));
   PrepareCntrObjects("", OnDate, ODoc.SrcDate, PROCREF(^PrepareProc));
  ELSIF L_kn.Is(ODoc.Date, L_ODoc.erkn_ContractMessage) THEN
   OnDate     :=ODoc.SrcDate;
   IF ODoc.Sense = 0 THEN
    PrepareCntrObjects("", OnDate, ODoc.SrcDate, PROCREF(PrepareClaim));
   ELSE
    PrepareCntrObjects("", OnDate, ODoc.SrcDate, GetAdditionalPrepareProc(OnDate));
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {MakeDocByODoc};

 PUBLIC PROCEDURE MakeDocByMDoc();
  VAR
   OnDate: DATE;
 BEGIN
  OnDate  :=MDoc.Date;
  _CopyCnt:=0;
  PrepareCntrObjects("MDoc.", OnDate, MDoc.SrcDate, GetAdditionalPrepareProc(OnDate));
 END {MakeDocByMDoc};

 PUBLIC PROCEDURE Print();
 BEGIN
  intMakeAnyDoc(L_MSO.PrpResult_Original, 0);
 END {Print};

 PUBLIC PROCEDURE Preview();
 BEGIN
  intMakeAnyDoc(L_MSO.PrpResult_Preview, 0);
 END {Preview};

 PUBLIC PROCEDURE Send();
 BEGIN
  intMakeAnyDoc(L_MSO.PrpResult_Email, 0);
 END {Send};

END.
