(*
%Copyright   (c) Polak Computer System
%Author      26.06.2002 20:26:07 LDA
%Purpose     ନ஢ 㬥⮢  ࠣ  MS_Office
%Type        operation
%Specific    SYS
%Modified    22.07.2014 13:16:18 POLAK\Bor
%Environment
*)

 MODULE O_Firm [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_MSO, L_Str, L_Env, L_General, L_DatTim, P_Firm,
        L_Prop, Math, L_AFM, E_Utils, L_Russia, L_Pmnt, L_XDoc, L_FIO, L_MDoc, L_EMail,
        Memo, L_Math, L_ctc, L_ODoc, L_PmntU, L_Cntr,
        L_Money, L_Acnt, P_ODoc, P_Cntr, L_kn;

 VAR
  ButtonLst,
  TemplateLst,
  DateDefLst,
  PrepareProcLst: STRING[];

 PRIVATE PROCEDURE Create_FirmP();
 BEGIN
  CREATE_TABLE(FirmP, , "६ 䠩 ᢮ ࠣ");

  CREATE_FIELD(FirmP, Property, LIKE(Property.Property), , , , "⢮");
  CREATE_FIELD(FirmP, Date,     DATE,                    , , , "");
  CREATE_FIELD(FirmP, EndDate,  DATE,                    , , , " 砭");
  CREATE_FIELD(FirmP, Value,    LIKE(FirmPro.Value),     , , , "祭");
  CREATE_FIELD(FirmP, DocNum,   LIKE(FirmPro.DocNum),    , , , " 㬥");
  CREATE_FIELD(FirmP, DocGiveS, LIKE(FirmPro.DocGiveS),  , , , " 뤠 㬥");
  CREATE_FIELD(FirmP, DocGiveD, DATE,                    , , , " 뤠 㬥");
  CREATE_FIELD(FirmP, DocExpD,  DATE,                    , , , "砭 ⢨ 㬥");

  CREATE_INDEX_AND_LINK(FirmP, Property, UNIQUE, Property, Property, USER, , , Property);

  SET_VERSION_OF_TABLE(FirmP, 0);
  L_AFM.CreateTemp("FirmP");
 END {Create_FirmP};

 PRIVATE PROCEDURE DefineStandartList();
 BEGIN
  ButtonLst     :="⪠ ࠢ  ࠣ| ࠣ|";
  TemplateLst   :="FirmData_01|FirmElms|";
  DateDefLst    :="Memo.ud_cd()|SYSDATE|";
  PrepareProcLst:="FirmData_Prepare|FirmElms_Prepare|";
  AppendAdditionalList();
 END {DefineStandartList};

 PRIVATE PROCEDURE AppendSingleList(VAR rLst: STRING[]; aLst: STRING[]);
 BEGIN
  rLst:=rLst+aLst+"|";
 END {AppendSingleList};

 PRIVATE PROCEDURE AppendAdditionalList();
  VAR
   Local               : PROC;
   adtButtonLst,
   adtTemplateLst,
   adtDateDefLst,
   adtPrepareProcLst: STRING[];
 BEGIN
  Local:=PROCREF(E_Utils.GetAdditionalDocumentsList);
  IF ~!Local THEN
   E_Utils.GetAdditionalDocumentsList(adtButtonLst,
                                      adtTemplateLst,
                                      adtDateDefLst,
                                      adtPrepareProcLst);
   AppendSingleList(     ButtonLst,      adtButtonLst);
   AppendSingleList(   TemplateLst,    adtTemplateLst);
   AppendSingleList(    DateDefLst,     adtDateDefLst);
   AppendSingleList(PrepareProcLst, adtPrepareProcLst);
  END;
 END {AppendAdditionalList};

 PRIVATE PROCEDURE SetOneFirmAcnt(Prefix,
                                  BankReq,
                                  AcntHolderName,
                                  SilentD,
                                  AcntA,
                                  BankName,
                                  BankCorAcnt,
                                  BankBIC          : STRING[]);
 BEGIN
  L_MSO.wordSetVar(Prefix + ".BankReq",        BankReq);
  L_MSO.wordSetVar(Prefix + ".AcntHolderName", AcntHolderName);
  L_MSO.wordSetVar(Prefix + ".SilentD",        SilentD);
  L_MSO.wordSetVar(Prefix + ".AcntA",          AcntA);
  L_MSO.wordSetVar(Prefix + ".Bank.Name",      BankName);
  L_MSO.wordSetVar(Prefix + ".Bank.CorAcnt",   BankCorAcnt);
  L_MSO.wordSetVar(Prefix + ".Bank.BIC",       BankBIC);
 END {SetOneFirmAcnt};

 PRIVATE PROCEDURE SetFirmAcnt(OnDate: DATE; Prefix: STRING[]);
  VAR
   Amount     : NUMERIC[0];
   _firm,
   _bank,
   _bic_,
   _inn_: STRING[];
   _acnt: STRING[][2];
 BEGIN
  Amount:=0;
  SELECT(FirmAcnt, Firm, , Firm.Firm);
  WHILE OCCURE(FirmAcnt) DO
   PROMPT(" " + FirmAcnt.FirmAcnt);
   IF (FirmAcnt.FirmAcnt # P_Firm.fa_CashOffice) & (FirmAcnt.Bank # P_Firm.FICT_BANK) &
      L_DatTim.IsActive(OnDate, FirmAcnt.Begin, FirmAcnt.Till) THEN
    P_Firm.GetFirmData(OnDate, _firm, _bank, _acnt, _bic_, _inn_, 0);
    SetOneFirmAcnt(Prefix + "Firm.FirmAcnt" + L_MSO.IndexStr(Amount),
                   P_Firm.FirmAcntAsStr(OnDate), _firm, P_Firm.IsSilentFirmAcnt(OnDate), _acnt[0], _bank, _acnt[1], _bic_);
    INC(Amount);
   END;
   NEXT(FirmAcnt);
  END; (* WHILE OCCURE(FirmAcnt) ... *)
  IF Amount = 0 THEN
   SetOneFirmAcnt(Prefix + "Firm.FirmAcnt" + L_MSO.IndexStr(Amount), "", "", "", "", "", "", "");
   Amount:=1;
  END;
  L_MSO.SetWordTable("FirmAcnt", Amount);
 END {SetFirmAcnt};

 PRIVATE PROCEDURE SetAllFirmProperty_Soft(OnDate: DATE);
  VAR
   CountLines: NUMERIC[0];
 BEGIN
  Create_FirmP();
  L_MSO.wordSetDateVar("Firm.Information.Date", OnDate);

  SELECT(Property, PropObj, , L_Prop.FirmProObj);
  WHILE OCCURE(Property) DO
   PROMPT("ࠡ⪠ ᢮⢠ " + Property.Property);
   IF (P_Firm.PropertyModificationAllowed(Property.Property) # L_Prop.mac_Old) &
      P_Firm.HasActualFirmPro(Firm.Firm, OnDate, Property.Property) THEN
    FirmP.Property:=Property.Property;
    FirmP.Date    :=FirmPro.Date;
    FirmP.EndDate :=FirmPro.EndDate;
    FirmP.Value   :=FirmPro.Value;
    FirmP.DocNum  :=FirmPro.DocNum;
    FirmP.DocGiveS:=FirmPro.DocGiveS;
    FirmP.DocGiveD:=FirmPro.DocGiveD;
    FirmP.DocExpD :=FirmPro.DocExpD;
    INSERT(FirmP);
   END;
   NEXT(Property);
  END; (* WHILE OCCURE(Property) ... *)

  CountLines:=0;
  SELECT(FirmP, Property);
  WHILE OCCURE(FirmP) DO
   PROMPT(FirmP.Property);
   CONFORM(FirmP, Property);
   L_MSO.wordSetVarsByFile_wAliasAndIndexE("FirmP",    "Firm.FirmPro", CountLines, 0);
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("Property", "Firm.FirmPro", CountLines, 0);
   INC(CountLines);
   NEXT(FirmP);
  END; (* WHILE OCCURE(FirmP) ... *)
  IF CountLines = 0 THEN
   L_MSO.wordSetVarsByFile_wAliasAndIndexE("FirmP",    "Firm.FirmPro", CountLines, 1);
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("Property", "Firm.FirmPro", CountLines, 1);
  END;
  L_MSO.SetWordTable("FirmPro", CountLines);
  L_AFM.AF_PurgeTemp("FirmP");
 END {SetAllFirmProperty_Soft};

 PRIVATE PROCEDURE SetAllFirmCtc(D: DATE);
  VAR
   CountLines: NUMERIC[0];
   _Coverage,
   _Type,
   _Value,
   _Comment  : STRING[];
 BEGIN
  CountLines:=0;
  SELECT(FirmCtc, fCKType, , Firm.Firm);
  WHILE OCCURE(FirmCtc) DO
   IF L_DatTim.IsActive(D, FirmCtc.Begin, FirmCtc.Till) THEN
    SETEMPTY(_Coverage, _Type, _Value, _Comment);
    SELECT(CtcVal, Contact, , FirmCtc.Contact);
    WHILE OCCURE(CtcVal) DO
     IF L_DatTim.IsActive(D, CtcVal.Begin, CtcVal.Till) THEN
      L_MSO._AddToStr(_Coverage, L_ctc.GetCtcValCoverage_asStr());
      L_MSO._AddToStr(_Type,     L_ctc.GetCtcValType_asStr());
      L_MSO._AddToStr(_Value,    CtcVal.Value);
      L_MSO._AddToStr(_Comment,  CtcVal.Comment);
     END;
     NEXT(CtcVal);
    END;
    CONFORM(FirmCtc, CtcKind);
    L_MSO.wordSetVarsByFile_wAliasAndIndexE("FirmCtc", "Firm.FirmCtc", CountLines, 0);
    L_MSO.wordSetVarsByFile_wIndexedPrefixE("CtcKind", "Firm.FirmCtc", CountLines, 0);
    L_MSO.wordSetVar("Firm.FirmCtc"+L_MSO.IndexStr(CountLines)+".CtcVal.Coverage", _Coverage);
    L_MSO.wordSetVar("Firm.FirmCtc"+L_MSO.IndexStr(CountLines)+".CtcVal.Type",     _Type);
    L_MSO.wordSetVar("Firm.FirmCtc"+L_MSO.IndexStr(CountLines)+".CtcVal.Value",    _Value);
    L_MSO.wordSetVar("Firm.FirmCtc"+L_MSO.IndexStr(CountLines)+".CtcVal.Comment",  _Comment);
    INC(CountLines)
   END;
   NEXT(FirmCtc);
  END; (* WHILE OCCURE(FirmCtc) ... *)
  IF CountLines = 0 THEN
   L_MSO.wordSetVarsByFile_wAliasAndIndexE("FirmCtc", "Firm.FirmCtc", CountLines, 1);
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("CtcKind", "Firm.FirmCtc", CountLines, 1);
   L_MSO.wordSetVar("Firm.FirmCtc"+L_MSO.IndexStr(CountLines)+".CtcVal.Coverage", "");
   L_MSO.wordSetVar("Firm.FirmCtc"+L_MSO.IndexStr(CountLines)+".CtcVal.Type",     "");
   L_MSO.wordSetVar("Firm.FirmCtc"+L_MSO.IndexStr(CountLines)+".CtcVal.Value",    "");
   L_MSO.wordSetVar("Firm.FirmCtc"+L_MSO.IndexStr(CountLines)+".CtcVal.Comment",  "");
  END;
  L_MSO.SetWordTable("FirmCtc", CountLines);
 END {SetAllFirmCtc};

 PRIVATE PROCEDURE SetAllFirmCtcAdr(D: DATE);
  VAR
   CountLines: NUMERIC[0];
   Prefix    : STRING[];
 BEGIN
  CountLines:=0;
  SELECT(FirmCtc, fCKType, , Firm.Firm);
  WHILE OCCURE(FirmCtc) DO
   IF L_DatTim.IsActive(D, FirmCtc.Begin, FirmCtc.Till) THEN
    IF SELECT(CtcAdr, Contact, FirmCtc.Contact) THEN
     WHILE OCCURE(CtcAdr) DO
      IF L_DatTim.IsActive(D, CtcAdr.Begin, CtcAdr.Till) THEN
       Prefix:="Firm.CtcAdr" + L_MSO.IndexStr(CountLines) + ".";
       L_MSO.wordSetVar(Prefix + "Type",     L_ctc.GetCtcAdrType_asStr(1));
       L_MSO.wordSetVar(Prefix + "PostKind", L_ctc.GetCtcAdrPostKind_asStr(0));
       L_MSO.wordSetVar(Prefix + "FullAddr", L_ctc.curCtcAdr_asStr(L_Russia.af_Full));
       L_MSO.wordSetVarsByFile_wAliasAndIndexE("FirmCtc", "Firm.CtcAdr", CountLines, 0);
       INC(CountLines);
      END;
      NEXT(CtcAdr);
     END;
    END; (* IF SELECT(CtcAdr ... *)
   END;
   NEXT(FirmCtc);
  END; (* WHILE OCCURE(FirmCtc) ... *)
  IF CountLines = 0 THEN
   Prefix:="Firm.CtcAdr" + L_MSO.IndexStr(0) + ".";
   L_MSO.wordSetVarsByFile_wAliasAndIndexE("FirmCtc", "Firm.CtcAdr", 0, 1);
   L_MSO.wordSetVar(Prefix + "Type",     "");
   L_MSO.wordSetVar(Prefix + "PostKind", "");
   L_MSO.wordSetVar(Prefix + "FullAddr", "");
  END;
  L_MSO.SetWordTable("FirmCtcAdr", CountLines);
 END {SetAllFirmCtcAdr};

 PRIVATE PROCEDURE FirmData_Prepare(OnDate: DATE; PrpResult: L_MSO.PrpResultType);
 BEGIN
  P_Firm.SetFirmData("", Firm.Firm, OnDate, EMPTYOF(FirmAcnt.FirmAcnt), "");
  SetAllFirmProperty_Soft(OnDate);
  SetAllFirmCtc(OnDate);
  SetAllFirmCtcAdr(OnDate);
  SetFirmAcnt(OnDate, "");
 END {FirmData_Prepare};

 PRIVATE PROCEDURE Prepare_F_Msg02(_Firm: LIKE(Firm.Firm); _MyFirm: P_Firm.tMyFirm; OnDate, actDate: DATE);
  VAR
   Root,
   r         : STRING[];
   _s, _d, _c,
   t_d, t_c  : L_Pmnt.tValuesToBalance;
   i         : NUMERIC[2];
   ShowLine  : SCAL[2];
 BEGIN
  P_Firm.SetFirmData("", _Firm, actDate, EMPTYOF(FirmAcnt.FirmAcnt), "");
  SELECT(Contract, Firm, , _Firm, 1);
  i:=0;
  SETZERO(t_c, t_d);
  LOOP
   SETEMPTY(_d, _c);
   IF ~OCCURE(Contract) THEN
    IF i > 0 THEN
     EXIT;
    ELSE
     ShowLine:=1;
    END;
   ELSIF (Contract.MyFirm = _MyFirm) &
         ~L_Cntr.IsBudgetContract(Contract.Contract, actDate) THEN
    SAVE(Contract);
    _s:=L_Pmnt.GetContractBalance(Contract.Contract, OnDate,
                                  L_XDoc.min_DoneDTS, L_XDoc.min_DoneDTS);
    RESTORE(Contract);
    CONFORM(Contract, CntrT);
    IF    _s[L_Pmnt.vtb_Netto]>0 THEN _d:= _s;
     t_d:=L_Pmnt.vtbAdd(t_d, _d);
    ELSIF _s[L_Pmnt.vtb_Netto]<0 THEN _c:=L_Pmnt.vtbInv(_s);
     t_c:=L_Pmnt.vtbAdd(t_c, _c);
    END;
    IF  (!Contract.SrcNbr | ~L_DatTim.IsActive(OnDate, Contract.Begin, Contract.Till)) & (_s[L_Pmnt.vtb_Netto]=0) THEN
     ShowLine:=0;
    ELSE
     ShowLine:=1;
    END;
   ELSE
    ShowLine:=0;
   END;
   Root:="Firm.";
   IF ShowLine THEN
    r:=Root+"Contract"+"["+L_Str.IntStr(i)+"]";
    L_MSO.wordSetVarsByFile_wAliasE("Contract", r, ~OCCURE(Contract));
    r:=r+".";
    L_MSO.wordSetVarsByFile_wPrefixE("CntrT", r,   ~OCCURE(Contract));
    L_PmntU.wordSetVTB(r+"Debit",  OnDate-1, _d);
    L_PmntU.wordSetVTB(r+"Credit", OnDate-1, _c);
    INC(i);
   END;
   IF OCCURE(Contract) THEN
    NEXT(Contract);
   END;
  END; (* LOOP ... *)
  r:=Root;
  L_PmntU.wordSetVTB(r+"Debit",  OnDate-1, t_d);
  L_PmntU.wordSetVTB(r+"Credit", OnDate-1, t_c);
  L_MSO.wordSetDateVar("XDoc.OnDate", OnDate);
  L_MSO.SetWordTable("CntrTbl", i);
 END {Prepare_F_Msg02};

 PRIVATE PROCEDURE ra_SetMyFirm(): P_Firm.tMyFirm;
  VAR
   MyFirms : P_Firm.tMyFirm[64];
   mfAmount: NUMERIC[0];
 BEGIN
  SETEMPTY(MyFirms);
  mfAmount:=0;
  L_General.Assert(SELECT(Contract, Firm, Firm.Firm, 1), "ࠣ   ஢");
  WHILE OCCURE(Contract) DO
   L_Math.Math_InsInOrderedArray(MyFirms, mfAmount, Contract.MyFirm);
   NEXT(Contract);
  END; (* WHILE OCCURE(Contract) ... *)
  IF mfAmount > 1 THEN
   RETURN P_Firm.extDefineMyFirm(SYSDATE(), MyFirms);
  ELSE
   RETURN MyFirms[0];
  END;
 END {ra_SetMyFirm};

 PRIVATE PROCEDURE RecAcnt(D: DATE; PrpResult: L_MSO.PrpResultType);
  VAR
   _MyFirm: P_Firm.tMyFirm;
 BEGIN
  _MyFirm:=ra_SetMyFirm();
  Prepare_F_Msg02(Firm.Firm, _MyFirm, D, D);
  L_MSO.wordSetDateVar("XDoc.Date", D);
  L_MSO.wordSetVar    ("XDoc.XDoc", Firm.Firm+FLDTOSTR(D, "\yND"));
  P_Firm.SetFirmData("MyFirm.", P_Firm.fomf(_MyFirm), D, EMPTYOF(FirmAcnt.FirmAcnt), "");
 END {RecAcnt};

 PRIVATE PROCEDURE fmsg03_PutLine(VAR Idx: NUMERIC[0]; n, d, c: STRING[]);
 BEGIN
  L_MSO.wordSetVar("XDoc.Line" + L_MSO.IndexStr(Idx) + ".Name",   n);
  L_MSO.wordSetVar("XDoc.Line" + L_MSO.IndexStr(Idx) + ".Debit",  d);
  L_MSO.wordSetVar("XDoc.Line" + L_MSO.IndexStr(Idx) + ".Credit", c);
  INC(Idx);
 END {fmsg03_PutLine};

 PRIVATE PROCEDURE fmsg03_PutCir(VAR Idx: NUMERIC[0]; d: DATE; n: STRING[]; cir: NUMERIC[2]);
 BEGIN
  IF cir < 0 THEN
   fmsg03_PutLine(Idx, n,                             "", L_Money.MoneyToStr(d, "", -cir));
  ELSE
   fmsg03_PutLine(Idx, n, L_Money.MoneyToStr(d, "", cir),                              "");
  END;
 END {fmsg03_PutCir};

 PRIVATE PROCEDURE fmsg03_PutDocCir(VAR Idx: NUMERIC[0]; cir: NUMERIC[2]);
  VAR
   n: STRING[];
 BEGIN
  L_XDoc.PositionOnXDoc(CnBHs.XDocId);
  n:=CHR(9) + " " + L_DatTim.DateStr(CnBHs.Date) + " " + L_ODoc.GetXDocName_Full(CnBHs.XDocId);
  fmsg03_PutCir(Idx, CnBHs.Date, n, cir);
 END {fmsg03_PutDocCir};

 PRIVATE PROCEDURE Prepare_F_Msg03(_Firm: LIKE(Firm.Firm); _MyFirm: P_Firm.tMyFirm; From, UpTo, actDate: DATE; PrpResult: L_MSO.PrpResultType);
  VAR
   Idx     : NUMERIC[0];
   InB     : L_Pmnt.tValuesToBalance;
   curSum,
   dCir,
   cCir,
   dFullInB,
   dFullB,
   cFullInB,
   cFullB,
   dCirTot,
   cCirTot : L_XObj.tSum;
   Alive   : SCAL[2];
   Text    : STRING[];
 BEGIN
  APP.Get().NewPrompt("ࠣ "+_Firm);
  Idx:=0;
  SETZERO(Idx, dCirTot, cCirTot, dFullInB, cFullInB, dFullB, cFullB);
  SELECT(Firm, Firm, , _Firm);
  SETSEL(Contract, Firm, Firm.Firm, 1);
  FOR_EACH Contract DO
   PROMPT(" "+Contract.Contract);
   IF (Contract.MyFirm = _MyFirm) & ~L_Cntr.IsBudgetContract(Contract.Contract, actDate) THEN
    L_Pmnt.PrepareContractBalanceHistory(Contract.Contract,
                                         L_DatTim.IncMonth(L_DatTim.Per(From), -1),
                                         UpTo-1);
    Alive:=L_DatTim.IsActiveInIntvl_Inc(From, UpTo, Contract.Begin, Contract.Till);
    IF SELECT(CnBHs, CnBHs, Contract.XObject) THEN
     IF SRCINSEL(CnBHs, LT, From) THEN
      InB:=CnBHs.Balance;
     ELSE
      SETZERO(InB);
     END;
     IF InB[L_Pmnt.vtb_Total] = 0 THEN
      Alive:=SRCINSEL(CnBHs, GE, From);
     ELSE
      Alive:=1;
     END;
     IF Alive THEN
      Text:="";
      IF ~!Contract.SrcNbr THEN
       Text:=Text + "  ";
      END;

      fmsg03_PutLine(Idx, Text +
                          L_XDoc.extXDocStr(L_XDoc.curXDocId(L_XDoc.xdt_Contract), L_XDoc.xdast_External) + " " +
                          Contract.Name,
                          "", "।");
      IF SRCINSEL(CnBHs, LT, From) THEN
       InB:=CnBHs.Balance;
      ELSE
       SETZERO(InB);
      END;
      SETZERO(dCir, cCir);
      fmsg03_PutCir(Idx, From, CHR(9) + "줮  " + L_DatTim.DateStr(From), InB[L_Pmnt.vtb_Total]);
      IF InB[L_Pmnt.vtb_Total] < 0 THEN
       INC(cFullInB, -InB[L_Pmnt.vtb_Total]);
      ELSE
       INC(dFullInB, InB[L_Pmnt.vtb_Total]);
      END;
      IF SRCINSEL(CnBHs, GE, From) THEN
       WHILE OCCURE(CnBHs) DO
        IF CnBHs.CirType = L_Acnt.ct_Debit THEN
         curSum:=CnBHs.Value[L_Pmnt.vtb_Total];
        ELSE
         curSum:=-CnBHs.Value[L_Pmnt.vtb_Total];
        END;
        IF curSum > 0 THEN
         INC(dCir, curSum);
        ELSE
         INC(cCir, -curSum);
        END;
        fmsg03_PutDocCir(Idx, curSum);
        NEXT(CnBHs);
       END; (* WHILE OCCURE(CnBHs) *)
      END;
      LAST(CnBHs);
      fmsg03_PutLine(Idx, CHR(9) + "⮣   ਮ",
                          L_Money.MoneyToStr(UpTo, "", dCir),
                          L_Money.MoneyToStr(UpTo, "", cCir));
      fmsg03_PutCir(Idx, UpTo,    CHR(9) + "줮  " + L_DatTim.DateStr(UpTo),
                                   CnBHs.Balance[L_Pmnt.vtb_Total]);
      fmsg03_PutLine(Idx, "", "", "");
      IF CnBHs.Balance[L_Pmnt.vtb_Total] < 0 THEN
       INC(cFullB, -CnBHs.Balance[L_Pmnt.vtb_Total]);
      ELSE
       INC(dFullB, CnBHs.Balance[L_Pmnt.vtb_Total]);
      END;
      INC(dCirTot, dCir);
      INC(cCirTot, cCir);
     END;
    END;
    L_AFM.AF_PurgeTemp("CnBHs");
   END;
  END; (* FOR_EACH Contract ... *)
  IF Idx = 0 THEN
   fmsg03_PutLine(Idx, " ᥬ ࠬ  襭", "", "");
  ELSE
   fmsg03_PutLine(Idx, "  ᥬ ࠬ", "", "।");
   fmsg03_PutLine(Idx, CHR(9) + "줮  " + L_DatTim.DateStr(From),         
                       L_Money.MoneyToStr(From, "", dFullInB),
                       L_Money.MoneyToStr(From, "", cFullInB));
   fmsg03_PutLine(Idx, CHR(9) + "⮣   ਮ", L_Money.MoneyToStr(UpTo, "", dCirTot),
                                                           L_Money.MoneyToStr(UpTo, "", cCirTot));
   fmsg03_PutLine(Idx, CHR(9) + "줮  " + L_DatTim.DateStr(UpTo),
                       L_Money.MoneyToStr(From, "", dFullB),
                       L_Money.MoneyToStr(From, "", cFullB));
  END;
  P_Firm.SetFirmData("", Firm.Firm, actDate, EMPTYOF(FirmAcnt.FirmAcnt), "");
  L_MSO.wordSetDateVar("XDoc.Period.From", From);
  L_MSO.wordSetDateVar("XDoc.Period.UpTo", UpTo);
  L_MSO.wordSetVar    ("XDoc.XDoc", Firm.Firm+FLDTOSTR(UpTo, "/yND"));
  L_MSO.SetWordTable("CntrTbl", Idx);
 END {Prepare_F_Msg03};

 PRIVATE PROCEDURE Prepare_F_Msg01(_Firm: LIKE(Firm.Firm); _MyFirm: P_Firm.tMyFirm; D: DATE);
  VAR
   Root: STRING[];
 BEGIN
  Root:="";
  P_Firm.SetFirmData(Root, _Firm, D, EMPTYOF(FirmAcnt.FirmAcnt), "");
  L_PmntU.wordPrepareFirmUnderpay(_Firm, _MyFirm, D, Root);
 END {Prepare_F_Msg01};

 PRIVATE PROCEDURE MakeDoc(OnDate      : DATE;
                           TemplateName: STRING[];
                           CopiesAmount: NUMERIC[0];
                           PrepareProc : PROC;
                           PrepareMode : L_MSO.PrpModeType;
                           PrpResult   : L_MSO.PrpResultType);
 BEGIN
  APP.Get().NewPrompt(TemplateName);
  L_General.Assert(ACCESS(Firm), " ⠭ ࠣ");
  L_MSO.wordInitDocument(OnDate);
  PrepareProc(OnDate, PrpResult);
  L_MSO.MakeWordDocument(TemplateName, CopiesAmount, PrepareMode, "");
 END {MakeDoc};

 PUBLIC PROCEDURE MakeFirmDoc();
  VAR
   PrepareMode : L_MSO.PrpModeType;
   Choice      : NUMERIC[0];
   d           : DATE;
   DateDef,
   TemplateName: STRING[];
   PrpProc     : PROC;
   PrpResult   : L_MSO.PrpResultType;
 BEGIN
  DefineStandartList();

  PrpResult   :=L_MSO.PrpResult_Preview;
  Choice      :=L_MSO.SelectDoc(ButtonLst, TemplateLst, PrpResult)-1;
  PrepareMode :=L_MSO.GetStandartPrepareMode(PrpResult);

  DateDef     :=L_Str.PoolItem(DateDefLst,      Choice);
  TemplateName:=L_Str.PoolItem(TemplateLst,     Choice);
  PrpProc     :=STRTOFLD(L_Str.AnyItem(PrepareProcLst, "|", Choice), PROC);
  IF    DateDef="Memo.ud_cd()"  THEN
   d:=Memo.ud_cd();
  ELSIF DateDef="SYSDATE"  THEN
   d:=SYSDATE();
  ELSE
   L_General.CallUs(0);
  END;
  d:=Math.Max(d, L_Env.aptm_Start);
  MakeDoc(d, TemplateName, 1, PrpProc, PrepareMode, PrpResult);
 END {MakeFirmDoc};

 PUBLIC PROCEDURE MakeDocByODoc(PrpResult: L_MSO.PrpResultType);
  VAR
   prpBegin,
   prpTill  : DATE;
 BEGIN
  ACCESS(ODoc);
  P_Firm.SetFirmData("MyFirm.", P_Firm.fomf(ODoc.MyFirm), ODoc.SrcDate, EMPTYOF(FirmAcnt.FirmAcnt), "");
  CONFORM(ODoc, ODocKind);
  IF L_kn.Is(ODoc.Date, L_ODoc.erkn_FirmMessage) THEN
   IF    ODoc.Sense = L_ODoc.fms_BadPaidInvoices THEN
    Prepare_F_Msg01(ODoc.Firm, ODoc.MyFirm, ODoc.Date);
   ELSIF ODoc.Sense = L_ODoc.fms_PaymentReviseAct THEN
    P_ODoc.GetPaymentRevisePeriod(ODoc.ODocKind, ODoc.ODoc, prpBegin, prpTill);
    Prepare_F_Msg02(ODoc.Firm, ODoc.MyFirm, prpBegin, ODoc.Date);
   ELSIF ODoc.Sense = L_ODoc.fms_PaymentReviseAct_InPer THEN
    P_ODoc.GetPaymentRevisePeriod(ODoc.ODocKind, ODoc.ODoc, prpBegin, prpTill);
    Prepare_F_Msg03(ODoc.Firm, ODoc.MyFirm, prpBegin, prpTill, ODoc.Date, PrpResult);
   ELSE
    L_General.CallUs(0);
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {MakeDocByODoc};

 PRIVATE PROCEDURE intFirmElms_Prepare(OnDate: DATE; _Acnt: LIKE(FirmAcnt.FirmAcnt); SenderEMail: STRING[]);
  VAR
   HasPro: SCAL[2];
 BEGIN
  IF ~!_Acnt THEN
   P_Firm.SetFirmData("", Firm.Firm, OnDate, _Acnt, "");
  ELSE
   P_Firm.SetFirmDefaultData("", Firm.Firm, OnDate, "");
  END;
  HasPro:=P_Firm.HasActualFirmPro(Firm.Firm, OnDate, P_Firm.P_OGRN);
  L_MSO.wordSetVarsByFile_wAliasE("FirmPro", "Firm.OGRN", ~HasPro);
  L_MSO.wordSetVar("Firm.SenderEMail", SenderEMail);
 END {intFirmElms_Prepare};

 PRIVATE PROCEDURE GetSenderEMail(OnDate: DATE): STRING[];
  VAR
   _MyFirm: LIKE(MyFirm.MyFirm);
 BEGIN
  _MyFirm:=P_Firm.GetMyFirmOfFirm(Firm.Firm);
  IF ~!_MyFirm THEN
   RETURN L_EMail.cp_EmailAdr(L_Pmnt.E_GetSenderEMail(L_XDoc.XDocId(L_XDoc.xdt_MDoc, L_MDoc.md_VhS, EMPTYOF(L_XDoc.tXDoc)), _MyFirm));
  ELSE
   RETURN P_Firm.FP_email(Firm.Firm, OnDate);
  END;
 END {GetSenderEMail};

 PRIVATE PROCEDURE FirmElms_Prepare(OnDate: DATE; PrpResult: L_MSO.PrpResultType);
 BEGIN
  intFirmElms_Prepare(OnDate, EMPTYOF(FirmAcnt.FirmAcnt), GetSenderEMail(OnDate));
 END {FirmElms_Prepare};

 PUBLIC PROCEDURE MakeOwnFirmEssentialElementsForOrder(): STRING[];
  VAR
   OnDate: DATE;
 BEGIN
  L_MDoc.AccessMDoc();
  P_Firm.AccessOwnFirm(MDoc.MyFirm);
  OnDate:=SYSDATE();
  L_MSO.wordInitDocument(OnDate);
  intFirmElms_Prepare(OnDate, P_Cntr.GetDefaultPayOwnFirmAcnt(MDoc.Contract, OnDate),
                      GetSenderEMail(OnDate));
  RETURN L_MSO.MakeWordDocument2File("FirmElms", "", L_MSO.PrpMode_ToPDF);
 END {MakeOwnFirmEssentialElementsForOrder};

 PUBLIC PROCEDURE RecAcntToDoc();
 BEGIN
  MakeDoc(Memo.ud_cd(), "RecAcnt", 1, PROCREF(RecAcnt), L_MSO.PrpMode_ToDoc, L_MSO.PrpResult_Preview);
 END {RecAcntToDoc};

 PUBLIC PROCEDURE RecAcntPrint();
 BEGIN
  MakeDoc(Memo.ud_cd(), "RecAcnt", 2, PROCREF(RecAcnt), L_MSO.PrpMode_Print, L_MSO.PrpResult_Original);
 END {RecAcntPrint};

END.
