(*
%Copyright   (c) Polak IT
%Author      04.12.2012 18:02:55 POLAK\GAV
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    18.09.2014 19:33:18 POLAK\Gina
%Environment
*)

 MODULE O_Man [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_MSO, E_Man, L_Staff, L_Man, P_Firm, Math, L_Env, L_Russia,
        L_Str, Memo, L_AR, P_Man, L_General, L_DatTim, L_APtm,
        L_PRoll, L_EC, E_Staff, L_Packet, L_Money, L_Math, L_AvePay;

 PRIVATE PROCEDURE DefineFullDocList();
  VAR
   addDocProc: PROC;
 BEGIN
(* ஢  O_Staff - ࠧ: -  ⮣    
  L_MSO.dl_AddGroup("ࠢ");
  L_MSO.dl_AddDocInCurGroup("ࠢ  ।⥫ ᬮ", "DME01", "", "SYSDATE");
 4   ᥬ  SELECT(Staff, MyFirm, , Staff.MyFirm, Staff.Man), .. ⥪騩 Staff 㦥  MyFirm
*)
  L_MSO.dl_AddDoc("ࠢ  ।⥫ ᬮ", "DME01", "", "SYSDATE");
  addDocProc:=PROCREF(E_Man.DefineAdditionalDocList);
  IF ~!addDocProc THEN
   addDocProc();
  END;
 END {DefineFullDocList};

 PRIVATE PROCEDURE E_O_Man_Copies(TemplateName: STRING[]): NUMERIC[0];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Man.O_Man_Copies);
  IF ~!Local THEN
   RETURN Local(TemplateName);
  ELSE
   RETURN 1;
  END;
 END {E_O_Man_Copies};

 PRIVATE PROCEDURE E_O_Man_GetAdditionalDocParams(    TemplateName   : STRING[];
                                                  VAR addTemplateName: STRING[];
                                                  VAR addTextParam   : STRING[];
                                                  VAR addPrepareProc : PROC;
                                                  VAR addPutInFields : SCAL[2]);
  VAR
   Local               : PROC;
   addPrepareProc_AsStr: STRING[];
 BEGIN
  SETEMPTY(addTemplateName, addTextParam, addPrepareProc);
  Local:=PROCREF(E_Man.O_Man_GetAdditionalDocParams);
  IF ~!Local THEN
   Local(TemplateName, addTemplateName, addTextParam, addPrepareProc_AsStr, addPutInFields);
   addPrepareProc:=PROCREF(^addPrepareProc_AsStr);
  END;
 END {E_O_Man_GetAdditionalDocParams};

 PRIVATE PROCEDURE DefineManMyFirm(D: DATE): LIKE(MyFirm.MyFirm);
 BEGIN
  L_General.Assert(Man.rStaff, "    ࠡ⭨ ।");
  RETURN P_Firm.DefineManMyFirm(Man.Man, D);
 END {DefineManMyFirm};

 PRIVATE PROCEDURE PrepareManObjects(D: DATE; ProcName: PROC);
 BEGIN
  PROMPT(Man.Man + ": ⮢ ");
  P_Firm.SetFirmDefaultData("Own", P_Firm.fomf(DefineManMyFirm(D)), D, "");
  L_MSO.wordSetVarsByFile("Man");
  L_MSO.wordSetVar("Man.Telephon", L_Man.ManPhone(D));
  L_Man.wordSetAddresses("Man.", Man.Man, D);
  IF ~L_Man.AccessManAdr(Man.Man, SYSDATE(), L_Russia.at_CtMA) THEN
   L_Man.AccessRgManAdr(Man.Man, SYSDATE());
  END;
  CONFORM(ManAdr, Country);
  L_MSO.wordSetVarsByFile_wAlias("Country", "Man.Citizenship");
  L_Staff.WordSetManName("");
  IF ~!ProcName THEN
   ProcName(D);
  END;
 END {PrepareManObjects};

 PRIVATE PROCEDURE GetPrepareProc(): PROC;
  VAR
   ProcName: STRING[];
 BEGIN
  ProcName:=MSODL.Proc;
  IF !ProcName THEN
   ProcName:=MSODL.Template;
  END;
  RETURN PROCREF(^ProcName);
 END {GetPrepareProc};

 PRIVATE PROCEDURE GetManDocDate(DateDef: STRING[]): DATE;
  VAR
   Result : DATE;
   GetDate: PROC;
 BEGIN
  IF    DateDef="Memo.ud_cd()"  THEN
   Result:=Memo.ud_cd();
  ELSIF DateDef="SYSDATE"  THEN
   Result:=SYSDATE();
  ELSE
   GetDate:=PROCREF(^DateDef);
   L_General.Assert(~!GetDate, "O_Man:  ᯮᮡ । ");
   Result:=GetDate();
  END;
  RETURN Math.Max(Result, L_Env.aptm_Start);
 END {GetManDocDate};

 PRIVATE PROCEDURE intMakeDoc(TemplateName,
                              DateDef,
                              TextParam      : STRING[];
                              PrpMode        : L_MSO.PrpModeType;
                              PrepareProc    : PROC;
                              wGrantAllRights: SCAL[2]);
  VAR
   docD              : DATE;
   Copies            : NUMERIC[0];
   addTextParam,
   addTemplateName   : STRING[];
   addPutInFields    : SCAL[2];
   addPrepareProc    : PROC;
 BEGIN
  docD:=GetManDocDate(DateDef);
  IF wGrantAllRights THEN
   L_AR.GrantRightsUnconditionally();
  END;
  Copies:=E_O_Man_Copies(TemplateName);
  E_O_Man_GetAdditionalDocParams(TemplateName, addTemplateName, addTextParam, addPrepareProc, addPutInFields);
  IF ~!addTemplateName THEN
   L_MSO.CreateTmpDot(TemplateName);
   L_MSO.wordInitDocument(docD);
   L_MSO.PutInFields:=addPutInFields;
   PrepareManObjects(docD, EMPTYOF(PROC));
   addPrepareProc(docD, TemplateName);
   L_MSO.MakeWordDocument(addTemplateName, 1, L_MSO.PrpMode_ToTmpDot, TemplateName + ";" + addTextParam);
  END;
  L_MSO.wordInitDocument(docD);
  PrepareManObjects(docD, PrepareProc);
  L_MSO.UseTmpDot:=~!addTemplateName;
  L_MSO.MakeWordDocument(TemplateName, Copies, PrpMode, TextParam);
 END {intMakeDoc};

 PRIVATE PROCEDURE extMakeDoc(TextParam: STRING[];
                              PrpMode  : L_MSO.PrpModeType);
 BEGIN
  intMakeDoc(MSODL.Template,
             MSODL.DateDef,
             TextParam,
             PrpMode,
             GetPrepareProc(),
             MSODL.IsLocal);
 END {extMakeDoc};

 PUBLIC PROCEDURE MakeDoc();
  VAR
   PrpMode: L_MSO.PrpModeType;
 BEGIN
  L_General.Assert(ACCESS(Man), " ⠭ ⥪騩 ࠡ⭨");
  DefineFullDocList();
  PrpMode:=L_MSO.PrpMode_Print;
  L_MSO.dl_SelectDoc(PrpMode);
  extMakeDoc("", PrpMode);
 END {MakeDoc};

 PRIVATE PROCEDURE DME01(D: DATE);
  VAR
   curDirtyTyp: LIKE(DirtyTyp.DirtyTyp);
   typ        : STRING[];
   curSort    : LIKE(Officer.Sort);
   curOfficer : LIKE(Officer.Officer);
 BEGIN
  L_General.Assert(P_Man.HasActualManPro(Man.Man, D, P_Man.P_HazardMedExamination),
                   " ନ ᢮⢮  5208");
  P_Man.Decode_HazardMedExamination(ManPro.Value, curDirtyTyp, typ);
  L_General.Assert(typ = L_Str.PoolItem(P_Man.GetManProPool(P_Man.P_HazardMedExamination), 0),
                   " ன ᬮ (" + typ + ")");
  L_MSO.wordSetVarsByFile_wAlias("ManPro", "Man.HazardMedExamination");
  L_General.Assert(P_Man.HasActualManPro(Man.Man, D, P_Man.P_StaffCandidate),
                   " ନ ᢮⢮  5207");
  P_Man.Decode_StaffCandidate(ManPro.Value, curSort, curOfficer);
  SEARCH(Officer, Officer, , curSort, curOfficer);
  SEARCH(DirtyTyp, DirtyTyp, , P_Officer.GetP_LCDirtyTyp(Officer.Sort, Officer.Officer, D));
  CONFORM(Officer, Sort);
  CONFORM(Officer, Post);
  L_General.Assert(DirtyTyp.DirtyTyp = curDirtyTyp,
                   "। ᫮  ࠢ  ᬮ" +
                   "| ᮮ⢥ ࠡ祬 ,  ஥ ⥭ ");

  L_MSO.wordSetVarsByFile_wAlias("DirtyTyp", "Man.StaffCandidate.DirtyTyp");
  L_MSO.wordSetVarsByFile_wAlias("Sort",     "Man.StaffCandidate.Sort");
  L_MSO.wordSetVarsByFile_wAlias("Officer",  "Man.StaffCandidate.Officer");
  L_MSO.wordSetVarsByFile_wAlias("Post",     "Man.StaffCandidate.Post");
  L_Staff.extSet_AsLeaderVars(D, P_Firm.fomf(DefineManMyFirm(D)), L_Staff.E_asLeader(D, L_Staff.sarr_Begun));
 END {DME01};

END.
