(*
%Copyright   (c) Polak Computer System
%Author      23.07.2001 21:57:21 MOG
%Purpose     ନ஢ 㬥⮢    MS_Office
%Type        operation
%Specific    SYS
%Modified    25.08.2014 17:33:50 POLAK\Bor
%Environment
*)

 MODULE O_Math [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Acnt, L_AFM, L_BarCode, L_Car, L_StdFrm,
        L_Man, L_EMail, L_MathR, L_MDoc, L_MSO, L_Staff, L_Str, L_XDoc,
        L_XObj, L_XDR, P_Math, P_MDoc, P_Firm,
        Math, Str, Memo, E_Prop, E_Stock, L_Env;

 (* Stickers *)

 PRIVATE CONST
  _SerialLen = 17;
  _MaskLen   = 9;
  _IndexLen  = _SerialLen - _MaskLen - 1; (* 1 - ஢ ࠧ *)

 PRIVATE PROCEDURE MathMask(): STRING[];
  CONST
   _Prefix = "240";
   _MathLen = _MaskLen-Str.Length(_Prefix);
 BEGIN
  RETURN _Prefix+L_Str.FixedIntStr(Math.Math, _MathLen);
 END {MathMask};

 PRIVATE PROCEDURE _Serial(i: NUMERIC[2]): STRING[];
 BEGIN
  RETURN L_BarCode.BarCode(MathMask()+L_Str.FixedIntStr(i, _IndexLen));
 END {_Serial};

 PRIVATE PROCEDURE Stick_PrepareObjects(D: DATE; _DocVer: NUMERIC[0]);
  VAR
   r,
   s,
   Root,
   _Mask  : STRING[];
   Amount,
   i,
   j      : NUMERIC[0];
 BEGIN
  _Mask:=MathMask();
  IF ~SEARCH(MathEAN, EAN, _Mask) THEN
   MathEAN.Math  :=Math.Math;
   MathEAN.EAN   :=_Mask;
   MathEAN.IsMask:=1;
   INSERT(MathEAN);
  END;
  i:=0;
  SETSEL(CUCopy, CUSrl, Math.Math);
  IF SRCINSEL(CUCopy, LT, _Mask+L_Str.Repeat("9", _IndexLen+1)) &
     Str.Match(CUCopy.Serial, _Mask+L_Str.Repeat("?", _IndexLen+1)) THEN
   s:=Str.Slice(CUCopy.Serial, _MaskLen, _IndexLen);
   IF L_Str.TestStrAlowChar(s, "09") THEN
    i:=STRTOFLD(s, NUMERIC);
   END;
  END;
  Amount:=10;
  IF (_DocVer=4) | (_DocVer=5) | (_DocVer=2) THEN
   Amount:=21;
  ELSIF (_DocVer=6) THEN
   Amount:=40;
  END;
  j:=0;
  WHILE j<Amount DO
   INC(i); INC(j);
   Root:="Sticker"+"["+L_Str.IntStr(j)+"]"+".";
   r:=Root;
   L_MSO.wordSetVar(r+"Serial", _Serial(i));
   L_MSO.wordSetVarsByFile_wPrefix("Math", r);
   L_MathR.StandOnVendor();
   CONFORM(Math, MUnit);
   CONFORM(Math, MathType);
   CONFORM(Math, CarUnit);
   r:=r+"Math.";
   L_MSO.wordSetVarsByFile_wPrefix("Vendor", r);
   L_MSO.wordSetVarsByFile_wPrefix("MUnit", r);
   L_MSO.wordSetVarsByFile_wPrefix("MathType", r);
   L_MSO.wordSetVarsByFile_wPrefix("CarUnit", r);
  END;
  P_Firm.SetFirmData("Own", L_MathR.GetFirmOfMath(), D, "", "");
 END {Stick_PrepareObjects};

 PRIVATE PROCEDURE Stick_Prepare(OnDate: DATE; VAR Template: STRING[]);
  VAR
   Version: STRING[];
 BEGIN
  Version :=P_Math.GetMathProSoft(Math.Math, SYSDATE(), E_Prop.P_MathStckVer);
  Template:=L_MSO.BuildTemplateName(Template, Version);
  IF ~!Version THEN
   Stick_PrepareObjects(OnDate, STRTOFLD(Version, NUMERIC));
  ELSE
   Stick_PrepareObjects(OnDate, 1);
  END;
 END {Stick_Prepare};

(* MInvCard *)

 PRIVATE PROCEDURE IsSystemXDocID(_XDocId: L_XDoc.tXDocId): SCAL[2];
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
   _XDoc    : L_XDoc.tXDoc;
 BEGIN
  L_XDoc.DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
  RETURN (_XDocType = L_XDoc.xdt_MDoc) & (_XDocKind = L_MDoc.md_Amr);
 END {IsSystemXDocID};

 PRIVATE PROCEDURE GetMDocCir(VAR CostSaldo, WearSaldo, MDocCost, MDocWear: NUMERIC[2]);
  VAR
   _BAcCuts,
   _WAcCuts  : L_MathR.tMathAcCutCollection;
   curSum    : L_XObj.tSum;
   i         : SCAL[RANGEOF(L_MathR.tMathAcCutCollection)];
   j         : SCAL[L_MathR.KA_NumWearAcnt];
   CurDocID  : L_XDoc.tXDocId;
   P,
   CurDocDate: LIKE(MDoc.Date);
 BEGIN
  CurDocID:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
  CurDocDate:=MDoc.Date;
  IF L_Env.KeyAssAcntLev(CurDocDate) = L_MathR.kaal_NoKeyAssets THEN
   P:=L_DatTim.NextPer(MDoc.Date);
  ELSE
   P:=L_DatTim.Per(MDoc.Date);
  END;
  SAVE(MDoc);
  L_XDR.PrepareEntryList(L_XDoc.xdt_Math, P, 0);
  RESTORE(MDoc);

  SAVE(MDoc);
  SETZERO(CostSaldo, WearSaldo, MDocCost, MDocWear);
  FOR_EACH j DO
   IF j # L_MathR.KA_All THEN
    E_Stock.GetKeyAssBalCostAcCuts(P, _BAcCuts, L_MathR.KA_All, L_MathR.KA_All, j);
    FOR_EACH i DO
     IF !_BAcCuts[i] THEN
      EXIT;
     END;
     curSum:=L_MathR.RemaindersR(P, _BAcCuts[i], L_Acnt.ct_Credit);
     IF curSum # 0 THEN
      INC(CostSaldo, curSum);
      ADD(_AC01, _AC01, , _BAcCuts[i]);
     END;
 
     IF SELECT(XDE01, AcCut, _BAcCuts[i]) THEN
      ADD(_AC01, _AC01, , _BAcCuts[i]);
      WHILE OCCURE(XDE01) DO
       NARROWSEL(XDE01, Apport, AcCut2);
       CONFORM(XDE01, Apport);
       WHILE OCCURE(XDE01) DO
        IF XDE01.Prt = L_XDR.xdr_XObject THEN
         IF CurDocID = XDE01.XDocId THEN
          IF Apport.CirType = L_Acnt.ct_Debit THEN
           INC(MDocCost, XDE01.Sum);
          ELSE
           DEC(MDocCost, XDE01.Sum);
          END;
         ELSIF ~IsSystemXDocID(XDE01.XDocId) THEN
          L_XDoc.PositionOnXDoc(XDE01.XDocId);
          IF MDoc.Date < CurDocDate THEN
           IF Apport.CirType = L_Acnt.ct_Debit THEN
            INC(CostSaldo, XDE01.Sum);
           ELSE
            DEC(CostSaldo, XDE01.Sum);
           END;
          END;
         END;
        END; (* IF XDE01.Prt = L_XDR.xdr_XObject ... *)
        NEXT(XDE01);
       END; (* WHILE OCCURE(XDE01) ... *)
       NEXTINEXTENDEDSEL(XDE01, Apport, AcCut2);
      END; (* WHILE OCCURE(XDE01) ... *)
     END;
    END; (* FOR_EACH i ... *)
 
    E_Stock.GetKeyAssWearAcCuts(P, _WAcCuts, L_MathR.KA_All, L_MathR.KA_All, j);
    IF ~!_WAcCuts[0] THEN
     L_General.CallUs(!_WAcCuts[1]);
     curSum:=L_MathR.RemaindersR(P, _WAcCuts[0], L_Acnt.ct_Debit);
     INC(WearSaldo, curSum);
 
     SELECT(XDE01, AcCut, , _WAcCuts[0]);
     WHILE OCCURE(XDE01) DO
      IF (XDE01.Prt = L_XDR.xdr_XObject) & IsSystemXDocID(XDE01.XDocId) THEN
       CONFORM(XDE01, Apport);
       IF Apport.CirType = L_Acnt.ct_Debit THEN
        DEC(WearSaldo, XDE01.Sum);
       ELSE
        INC(WearSaldo, XDE01.Sum);
       END;
      END;
      NEXT(XDE01);
     END; (* WHILE OCCURE(XDE01) ... *)
    END;
   END; (* IF j # L_MathR.KA_All ... *)
  END; (* FOR_EACH j ... *)
  RESTORE(MDoc);
 END {GetMDocCir};

 PRIVATE PROCEDURE GetMDocKindActionName(trgMDocKind: LIKE(MDoc.MDocKind)): STRING[];
 BEGIN
  IF    trgMDocKind = L_MDoc.md_APr THEN RETURN "  ᯫ ";
  ELSIF trgMDocKind = L_MDoc.md_APP THEN RETURN "६饭 ";
  ELSIF trgMDocKind = L_MDoc.md_ADo THEN RETURN "୨ ";
  ELSIF trgMDocKind = L_MDoc.md_ASp THEN RETURN "ᠭ ";
  ELSIF trgMDocKind = L_MDoc.md_ASO THEN RETURN " ⢥⢥ ";
  ELSIF trgMDocKind = L_MDoc.md_AVb THEN RETURN "⨥ ";
  ELSIF trgMDocKind = L_MDoc.md_APc THEN RETURN "८業 ";
  ELSE  L_General.InformUs("   " + trgMDocKind + "  ᠭ ᮮ⢥饥 ᮡ⨥");
  END;
 END {GetMDocKindActionName};

 PRIVATE PROCEDURE PrintRemainders(_Date: DATE; Print: SCAL[2]);
  VAR
   Norm: NUMERIC[2];
 BEGIN
  L_General.Assert(SEARCH(AcCut, AcCut, _AcCut02), " ࠧ१   : "+_AcCut02);
  IF Print THEN
   IF _AcCut02 = _PrevAcCut02 THEN
    SETEMPTY(_AcCut02);
   ELSE
    _PrevAcCut02:=_AcCut02;
    L_MSO._AddToStr(Str_AcntSign01, _AcntSign01);
    L_MSO._AddToStr(Str_AcCut01, _AcCut01);
   END;
  END;
 END {PrintRemainders};

 PRIVATE PROCEDURE Create__MDoc();
 BEGIN
  CREATE_TABLE(_MDoc);

  CREATE_FIELD(_MDoc, MDocKind, LIKE(MDoc.MDocKind), , , , " 㬥");
  CREATE_FIELD(_MDoc, MDoc,     LIKE(MDoc.MDoc),     , , , " 㬥");
  CREATE_FIELD(_MDoc, Date,     LIKE(MDoc.Date),     , , , " 㬥");

  CREATE_INDEX         (_MDoc, _MDoc,    PLURAL,                           , , Date, MDocKind, MDoc);
  CREATE_INDEX_AND_LINK(_MDoc, MDocKind, PLURAL, MDocKind, MDocKind, USER, , , MDocKind, Date);

  SET_VERSION_OF_TABLE(_MDoc, 0);

  L_AFM.CreateTemp("_MDoc");
 END {Create__MDoc};

 PRIVATE PROCEDURE MakeInvCard_02(D: DATE);
  VAR
   Whereabouts,
   Prefix        : STRING[];
   OcMDoc        : SCAL[2];
   APrDate,
   curMDocDate,
   curDate       : DATE;
   CountLines    : NUMERIC[0];
   CostSaldo,
   WearSaldo,
   MDocCost,
   MDocWear,
   OriginalCost,
   DepreciableVal: L_XObj.tSum;
   Str_AcntSign01,
   Str_AcCut01,
   ActionName    : STRING[];
 BEGIN
  PROMPT("⮢ ... ");
  P_Firm.SetFirmData("Own", L_MathR.GetFirmOfMath(), D, "", "");
  curDate:=D;
  L_APtm.wordSetTheDocCauseAndDraftsman(curDate, "⢥ত ⠭ ᪮ ᨨ  21.01.2003  7", "");

  CALL(MCM.Math_CountUp());

  L_MathR.StandOnVendor();

  L_MSO.IsDuplexDoc:=1;

  Prefix:="Math";
  L_MathR.Math_setWordVars    (curDate, Prefix, 0);
  Prefix:="Math.";
  L_MathR.KACar_setWordVars   (curDate, Prefix, 0);
  L_MathR.Precious_setWordVars(curDate, Prefix, 0);
  L_MSO.wordSetDateVar(Prefix + "InvCard.PrepareDate", curDate);

  L_AFM.MakeIndex("_AC01", "AcCut: LIKE(AcCut.AcCut)");

  Create__MDoc();
  L_XDR.InitEntryList();

  SELECT(MDocList, Math, , Math.Math);
  WHILE OCCURE(MDocList) DO
   IF L_MDoc.KeyAssetsMDoc(MDocList.MDocKind) THEN
    CONFORM(MDocList, MDoc);
    IF (MDoc.Status = L_MDoc.st_Passed) & (MDoc.MDocKind # L_MDoc.md_ADg) THEN
     IF (MDoc.Date <= curDate) THEN
      _MDoc.Date    :=Math.Max(MDoc.Date, L_Env.aptm_Start);
      _MDoc.MDocKind:=MDoc.MDocKind;
      _MDoc.MDoc    :=MDoc.MDoc;
      INSERT(_MDoc);
     END;
    END;
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList)... *)

  L_General.Assert(SELECT(_MDoc, _MDoc), " 㬥⮢  ꥪ  " +
                                         L_DatTim.DateStr(curDate));


  APrDate:=L_MathR.GetKeyAssAPrDate(Math.Math);
  IF L_Env.KeyAssAcntLev(APrDate) = L_MathR.kaal_NoKeyAssets THEN
   L_StdFrm.Question(" ⠥    ꥪ,|  砫  "+
                     "||窠    ४⭮");
  END;
  L_General.Assert(L_MDoc.md_asAPr(_MDoc.MDocKind), "襭 冷 ᫥ 㬥⮢");
  SEARCH(MDoc, MDoc, , _MDoc.MDocKind, _MDoc.MDoc);
  CONFORM(MDoc, MDocKind);
  L_MSO.wordSetVarsByFile_wPrefix("MDoc",     Prefix + "APr");
  L_MSO.wordSetDateVar(Prefix + "APrMDoc.Date", APrDate);
  L_MSO.wordSetVarsByFile_wPrefix("MDocKind", Prefix + "APrMDoc.");
  LAST(_MDoc);
  SEARCH(MDoc, MDoc, , _MDoc.MDocKind, _MDoc.MDoc);
  CONFORM(MDoc, MDocKind);
  L_MSO.wordSetVarsByFile_wPrefix ("MDoc",     Prefix+"Current");
  L_MSO.wordSetVarsByFile_wPrefix ("MDocKind", Prefix+"CurrentMDoc.");

  OcMDoc:=L_MDoc.md_asASp(_MDoc.MDocKind);
  L_MSO.wordSetVarsByFile_wPrefixE("MDoc",     Prefix+"ASp",      ~OcMDoc);
  L_MSO.wordSetVarsByFile_wPrefixE("MDocKind", Prefix+"ASpMDoc.", ~OcMDoc);

  IF OcMDoc THEN
   PREV(_MDoc);
   SEARCH(MDoc, MDoc, , _MDoc.MDocKind, _MDoc.MDoc);
  END;
  CONFORM(MDoc, Staff);
  L_Staff.PosToStaffLog(Staff.TSN, _MDoc.Date, 1);
  CONFORM(StaffLog, Sort);
  L_MSO.wordSetVarsByFile_wPrefixE("Sort", Prefix, ~OCCURE(Sort));

  SETEMPTY(Whereabouts);
  SETSEL(_MDoc, _MDoc);
  LAST(_MDoc);
  WHILE OCCURE(_MDoc) & !Whereabouts DO
   Whereabouts:=P_MDoc.GetMDocProSoft(_MDoc.MDocKind, _MDoc.MDoc, P_MDoc.P_KeyAssAddress);
   PREV(_MDoc);
  END;
  L_MSO.wordSetVar("Math.Whereabouts", Whereabouts);

  OriginalCost:=0;
  Prefix:="Math.MDoc";
  CountLines:=0;
  SELECT(_MDoc, _MDoc);
  WHILE OCCURE(_MDoc) | (CountLines < 4) DO
   IF ~OCCURE(_MDoc) | (_MDoc.MDocKind # L_MDoc.md_ADo) THEN
    IF OCCURE(_MDoc) THEN
     SEARCH(MDoc, MDoc, , _MDoc.MDocKind, _MDoc.MDoc);
     IF L_MDoc.md_asAPr(_MDoc.MDocKind) THEN
      curMDocDate:=APrDate;
     ELSE
      curMDocDate:=MDoc.Date;
     END;
     GetMDocCir(CostSaldo, WearSaldo, MDocCost, MDocWear);
     IF L_Env.KeyAssAcntLev(MDoc.Date) = L_MathR.kaal_NoKeyAssets THEN
      DepreciableVal:=CostSaldo;
     ELSE
      DepreciableVal:=CostSaldo-WearSaldo;
     END;
     IF ~L_MDoc.md_asASp(MDoc.MDocKind) THEN
      INC(DepreciableVal, MDocCost-MDocWear);
     END;
     IF L_MDoc.md_asAPr(MDoc.MDocKind) THEN
      INC(OriginalCost, CostSaldo + MDocCost);
     END;
     ActionName:=GetMDocKindActionName(MDoc.MDocKind);
     CONFORM(MDoc, Dest);
     CONFORM(MDoc, MDocKind);
     CONFORM(MDoc, Staff, Man);
     HISTCONF(_MDoc.Date, Staff, StaffLog);
     CONFORM(StaffLog, Sort);
    ELSE
     SETEMPTY(DepreciableVal, curMDocDate, ActionName);
    END;

    L_MSO.wordSetVarsByFile_wAliasAndIndexE("MDoc",     Prefix, CountLines, ~OCCURE(_MDoc));
    L_MSO.wordSetVarsByFile_wIndexedPrefixE("Dest",     Prefix, CountLines, ~OCCURE(_MDoc));
    L_MSO.wordSetVarsByFile_wIndexedPrefixE("MDocKind", Prefix, CountLines, ~OCCURE(_MDoc));
    L_MSO.wordSetVarsByFile_wIndexedPrefixE("Sort",     Prefix, CountLines, ~OCCURE(_MDoc));
    L_MSO.wordSetVarsByFile_wIndexedPrefixE("Man",      Prefix, CountLines, ~OCCURE(_MDoc));
    L_MSO.wordSetMoneyVar(Prefix + L_MSO.IndexStr(CountLines) + ".DepreciatedCost", curDate, DepreciableVal);
    L_MSO.wordSetDateVar (Prefix + L_MSO.IndexStr(CountLines) + ".MDocDate", curMDocDate);
    L_MSO.wordSetVar     (Prefix+L_MSO.IndexStr(CountLines)+".ActionName", ActionName);
 
    INC(CountLines);
   END;
   IF OCCURE(_MDoc) THEN
    NEXT(_MDoc);
   END;
  END; (* WHILE OCCURE(_MDoc)... *)
  L_MSO.SetWordTable("table1", CountLines);

  Prefix:="Math.";
  L_MSO.wordSetMoneyVar(Prefix + "BalCost", curDate, OriginalCost);

  SETEMPTY(Str_AcntSign01, Str_AcCut01);
  SELECT(_AC01, _AC01);
  WHILE OCCURE(_AC01) DO
   L_MSO._AddToStr(Str_AcntSign01, L_Acnt.GetCAcntSign(curDate, _AC01.AcCut));
   L_MSO._AddToStr(Str_AcCut01, _AC01.AcCut);
   NEXT(_AC01);
  END; (* WHILE OCCURE(_AC01) ... *)
  L_MSO.wordSetVar(Prefix + "CAcnt.Sign",  Str_AcntSign01);
  L_MSO.wordSetVar(Prefix + "AcCut.AcCut", Str_AcCut01);

  Prefix:="Math.ADoMDoc";
  SELECT(_MDoc, MDocKind, , L_MDoc.md_ADo);
  CountLines:=0;
  WHILE OCCURE(_MDoc) | (CountLines < 4) DO
   IF OCCURE(_MDoc) THEN
    SEARCH(MDoc, MDoc, , _MDoc.MDocKind, _MDoc.MDoc);
    GetMDocCir(CostSaldo, WearSaldo, MDocCost, MDocWear);
    CONFORM(MDoc, Dest);
    CONFORM(_MDoc, MDocKind);
    ActionName:=GetMDocKindActionName(MDoc.MDocKind)
   ELSE
    SETEMPTY(MDocCost, ActionName);
   END;
   L_MSO.wordSetVarsByFile_wAliasAndIndexE("MDoc",     Prefix, CountLines, ~OCCURE(_MDoc));
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("Dest",     Prefix, CountLines, ~OCCURE(_MDoc));
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("MDocKind", Prefix, CountLines, ~OCCURE(_MDoc));
   L_MSO.wordSetMoneyVar(Prefix+L_MSO.IndexStr(CountLines)+".Sum", curDate, MDocCost);
   L_MSO.wordSetVar     (Prefix+L_MSO.IndexStr(CountLines)+".ActionName", ActionName);
   INC(CountLines);
   IF OCCURE(_MDoc) THEN
    NEXT(_MDoc);
   END;
  END; (* WHILE OCCURE(_MDoc)... *)
  L_MSO.SetWordTable("table2", CountLines);

  L_XDR.DeInitEntryList();
  L_AFM.AF_PurgeTemp("_AC01");
  L_AFM.AF_PurgeTemp("_MDoc");
 END {MakeInvCard_02};

 PRIVATE PROCEDURE InvCard_02_Prepare(OnDate: DATE; VAR Template: STRING[]);
 BEGIN
  L_General.Assert(Math.MathKind = L_MathR.mathk_KeyAs,
                   "騩    ᭮ ।⢮");
  MakeInvCard_02(OnDate);
 END {InvCard_02_Prepare};

 PRIVATE PROCEDURE MakeDoc(TemplateName: STRING[];
                           PrepareProc : PROC;
                           PrepareMode : L_MSO.PrpModeType;
                           Copies      : NUMERIC[0]);
  VAR
   OnDate: DATE;
 BEGIN
  APP.Get().NewPrompt(TemplateName);
  L_General.Assert(ACCESS(Math), " ⠭ ꥪ");
  OnDate  :=Memo.ud_cd();
  L_MSO.wordInitDocument(OnDate);
  PrepareProc(OnDate, TemplateName);
  L_MSO.MakeWordDocument(TemplateName, Copies, PrepareMode, "");
 END {MakeDoc};

 PUBLIC PROCEDURE MakeMathDoc();
  CONST
   ButtonLst      = "ୠ 窠  ଥ -6|";
   TemplateLst    = "oc-6_02|";
   PrepareProcLst = "InvCard_02_Prepare|";
   CopiesLst      = "1|";
  VAR
   PrpResult      : L_MSO.PrpResultType;
   Choice         : NUMERIC[0];
 BEGIN
  PrpResult:=L_MSO.PrpResult_Original;
  Choice   :=L_MSO.SelectDoc(ButtonLst, TemplateLst, PrpResult) - 1;
  IF Choice >= 0 THEN
   MakeDoc(L_Str.PoolItem(TemplateLst, Choice),
           STRTOFLD(L_Str.PoolItem(PrepareProcLst, Choice), PROC),
           L_MSO.GetStandartPrepareMode(PrpResult),
           STRTOFLD(L_Str.PoolItem(CopiesLst, Choice), NUMERIC));
  END;
 END {MakeMathDoc};

 PUBLIC PROCEDURE Stick();
 BEGIN
  MakeDoc("Stick_##", PROCREF(Stick_Prepare), L_MSO.PrpMode_ToDoc, 1);
 END {Stick};

END.
