(*
%Copyright   (c) Polak Computer System
%Author      23.07.2001 21:57:21 MOG
%Purpose     ନ஢ 㬥⮢  񦭮 㬥  MS_Office
%Type        operation
%Specific    SYS
%Modified    24.09.2014 16:14:29 LDA
%Environment
*)

 MODULE O_PDoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, Math, L_DatTim, L_Money, L_PDoc, L_ExtAb, L_Dest, L_XObj, L_AFM, L_Staff,
        L_Str, L_MSO, L_Pmnt, L_MDoc, L_EMail, L_APEMl, L_XDoc, L_StdFrm, L_XDR, L_PmntU, L_AcCut,
        P_MDoc, P_Firm, P_MyFirm, Str, L_FIO, L_Print, L_Events, P_PDoc;

 PRIVATE PROCEDURE Prepare_IPP(D     : DATE;
                               Prefix: STRING[]);
  VAR
   fd_Condition,
   curCode,
   _Type,
   _Former,
   _KBK,
   _OKTMO,
   _Reason,
   _Period,
   _DocNbr,
   _DocDate,
   _OurCode     : STRING[];
   _PmntDate    : DATE;
 BEGIN
  IF L_PDoc.PDocMustHaveKPP() THEN
   fd_Condition:="KPP";
  ELSE
   fd_Condition:="XYZ";
   L_MSO.wordSetVar(Prefix + "OwnFirm.KPP", "");
   L_MSO.wordSetVar(Prefix + "Firm.KPP",    "");
  END;
  P_Firm.SetFirmData(Prefix, Firm.Firm, D, PDoc.FirmAcnt, fd_Condition);
  L_ExtAb.SliceExtAbout(PDoc.ExtAbout, _Former, _KBK, _OKTMO, _Reason,
                                       _Period, _DocNbr, _DocDate, _Type, curCode);
  L_MSO.wordSetVar(Prefix + "ExtAbout.Former",  _Former);
  L_MSO.wordSetVar(Prefix + "ExtAbout.KBK",     _KBK);
  L_MSO.wordSetVar(Prefix + "ExtAbout.OKTMO",   _OKTMO);
  L_MSO.wordSetVar(Prefix + "ExtAbout.Reason",  _Reason);
  L_MSO.wordSetVar(Prefix + "ExtAbout.Period",  _Period);
  L_MSO.wordSetVar(Prefix + "ExtAbout.DocNbr",  _DocNbr);
  L_MSO.wordSetVar(Prefix + "ExtAbout.DocDate", _DocDate);
  L_MSO.wordSetVar(Prefix + "ExtAbout.Type",    _Type);
  L_MSO.wordSetVar(Prefix + "ExtAbout.Code",    curCode);

  L_MSO.wordSetVar(Prefix + "About.Full",    L_PDoc.GetFullPDocAbout());
  IF !P_Firm.GetOurCode(Firm.Firm, D) THEN
   _OurCode:="";
  ELSE
   _OurCode:=": " + P_Firm.GetOurCode(Firm.Firm, D);
  END;
  L_MSO.wordSetVar(Prefix + "Firm.OwnFirm.OurCode", _OurCode);
  L_MSO.wordSetVar(Prefix + "NDS.ByWord",           L_PDoc.VatStr());

  L_MSO.wordSetVar(Prefix + "PmntKind.AsStr",       L_Str.PoolItem("⮩|⥫䮬|஭| ", PDoc.PmntKind));
  IF 1 (*ப ⥦    㪠  ᨨ*) |
       (D = PDoc.PrpDate) THEN
   _PmntDate:=EMPTYOF(DATE);
  ELSE
   _PmntDate:=FLDTOSTR(D, "D.N.y", 10);
  END;
  L_MSO.wordSetDateVar(Prefix + "PmntDate", _PmntDate);
 END {Prepare_IPP};

 PRIVATE PROCEDURE wordSetPDocVars(D: DATE; _Prefix: STRING[]; ForceEmpty: SCAL[2]);
  VAR
   _Total: LIKE(PDoc.Total);
 BEGIN
  IF ForceEmpty THEN
   SETEMPTY(_Total);
  ELSE
   _Total:=PDoc.Total;
  END;
  L_MSO.wordSetMoneyVar(_Prefix+"Total", D, _Total);
 END {wordSetPDocVars};

 PRIVATE PROCEDURE CheckPaidOutPDocs();
 BEGIN
  SAVE(PDocList);
  SAVE(PDoc);
  CONFORM(PDoc, PDocList);
  L_General.Assert(OCCURE(PDocList), " 㪠 ");
  CONFORM(PDocList, Staff);
  SELECT(Staff, MyFirm, , Staff.MyFirm, Staff.Man);
  WHILE OCCURE(Staff) DO
   SETSEL(PDocList, TSN, Staff.TSN);
   SRCINSEL(PDocList, GE, , PDoc.Date - 365*2);
   WHILE OCCURE(PDocList) DO
    CONFORM(PDocList, PDoc);
    IF (PDoc.Status # L_PDoc.st_Canceled) & L_Pmnt.IsAccountableManPDoc() THEN
     L_General.Assert(PDoc.Status = L_PDoc.st_Passed, L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+"   '஢'");
     L_General.Assert(PDoc.Done, L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+"   ࠡ⠭");
    END;
    NEXT(PDocList);
   END; (* WHILE OCCURE(PDocList) ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RESTORE(PDoc);
  RESTORE(PDocList);
 END {CheckPaidOutPDocs};

 PRIVATE PROCEDURE PositionOnAVOClearOff(): SCAL[2];
  VAR
   baseXDocId: L_XDoc.tXDocId;
   DependentPDocs: L_XDoc.tXDocCollection;
   i       : NUMERIC[0];
 BEGIN
  baseXDocId:=L_XDoc.curXDocId(L_XDoc.xdt_PDoc);
  DependentPDocs:=L_XDoc.GetDependentXDC(baseXDocId, L_XDoc.xdt_PDoc);
  i:=0;
  WHILE L_XDoc.xdc_PositionOn(DependentPDocs, i) DO
   IF (PDoc.Status # L_PDoc.st_Canceled) &
      (PDoc.Dest = L_Dest.erkn_GetSoft(PDoc.Date, L_Dest.erkn_SumPaidOutOnAccount)) THEN
    RETURN 1;
   END;
   INC(i);
  END; (* L_XDoc.xdc_PositionOn ... *)
  RETURN 0;
 END {PositionOnAVOClearOff};

 PRIVATE PROCEDURE IsPDocBasedOnAVO(trgXDocId: L_XDoc.tXDocId): SCAL[2];
  VAR
   baseXDocId  : L_XDoc.tXDocId;
   baseXDocType: L_XDoc.tXDocType;
   baseXDocKind: L_XDoc.tXDocKind;
 BEGIN
  baseXDocId:=L_XDoc.GetBaseOnXDocId(trgXDocId);
  IF ~!baseXDocId THEN
   L_XDoc.DecodeXDocKindId(baseXDocId, baseXDocType, baseXDocKind);
   RETURN (baseXDocType = L_XDoc.xdt_PDoc) & (baseXDocKind = L_PDoc.pd_AVO);
  END;
  RETURN 0;
 END {IsPDocBasedOnAVO};

 PRIVATE PROCEDURE GetAVOAdvance(VAR PDKndAdv: NUMERIC[2][MAXOF(PDoc.PDocKind)+1]; VAR TotAdv: NUMERIC[2]);
  VAR
   curD       : DATE;
   curDTS     : LIKE(PDoc.DoneDTS);
   curSum     : L_XObj.tSum;
   curXDocType: L_XDoc.tXDocType;
   curXDocKind: L_XDoc.tXDocKind;
   curXDoc    : L_XDoc.tXDoc;
   FoundPrvAVO: SCAL[2];
 BEGIN
  SETZERO(PDKndAdv, TotAdv);
  curDTS:=PDoc.DoneDTS;
  curD  :=PDoc.Date;

  SAVE(PDoc);
  CONFORM(PDoc, PDocList);
  CONFORM(PDocList, Staff);
  L_Pmnt.PrepareAccountableManBalanceHistory(Staff.Man, PDoc.MyFirm, L_DatTim.MINDATE(), curD);

  FoundPrvAVO:=0;
  SETSEL(CnBHs, CnBHs, L_XObj.GetManXObject(Staff.Man, PDoc.MyFirm));
  LAST(CnBHs);
  WHILE OCCURE(CnBHs) & ~FoundPrvAVO DO
   IF (CnBHs.Date<curD) | (CnBHs.DoneDTS<curDTS) THEN
    L_XDoc.DecodeXDocId(CnBHs.XDocId, curXDocType, curXDocKind, curXDoc);
    IF curXDocType = L_XDoc.xdt_PDoc THEN
     IF curXDocKind = L_PDoc.pd_AVO THEN
      FoundPrvAVO:=1;
     ELSIF L_PDoc.IsOutPDoc(curXDocKind) & ~IsPDocBasedOnAVO(CnBHs.XDocId) THEN
      curSum:=CnBHs.Value[L_Pmnt.vtb_Total];
      INC(PDKndAdv[curXDocKind], curSum);
      INC(TotAdv, curSum);
     END;
    END; (* IF L_XDoc.ExtractXDocType(CnBHs.XDocId) ... *)
   END;
   PREV(CnBHs);
  END; (* WHILE OCCURE(CnBHs) ... *)

  RESTORE(PDoc);
 END {GetAVOAdvance};

 PRIVATE PROCEDURE Prepare_AVO(D: DATE; Prefix: STRING[]);
  CONST
   maxI = 8;
  VAR
   Count,
   i      : NUMERIC[0];
   oc     : SCAL[2];
   _Prefix,
   _Alias : STRING[];
   PDKndAdv: NUMERIC[2][MAXOF(PDoc.PDocKind)+1];
   _ClearOff,
   _Rest,
   TotAdv   : NUMERIC[2];
   _DocName : STRING[];
   trgValue : L_Pmnt.tValuesToBalance;
 BEGIN
  L_APtm.wordSetTheDocCauseAndDraftsman(D, "⢥ত ⠭ ᪮ ᨨ  01.08.2001  55", "");
  CheckPaidOutPDocs();
  _Prefix:=Prefix;
  CONFORM(PDoc, PDocList);
  L_General.Assert(OCCURE(PDocList), " 㪠 ⭮ ");
  CONFORM(PDocList, Staff);
  CONFORM(Staff, Man);
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  CONFORM(StaffLog, Post);
  CONFORM(StaffLog, Sort);
  L_MSO.wordSetVarsByFile_wPrefix("PDocList", _Prefix);
  _Prefix:=Prefix+"PDocList.";
  L_MSO.wordSetVarsByFile_wPrefix("Staff",    _Prefix);
  _Prefix:=Prefix+"PDocList.Staff.";
  L_MSO.wordSetVarsByFile_wPrefix("Man",      _Prefix);
  L_MSO.wordSetVarsByFile_wPrefix("Sort",     _Prefix);
  L_MSO.wordSetVarsByFile_wPrefix("Post",     _Prefix);

  _Alias:="Advance";
  _Prefix:=_Alias+".";
  L_MSO.wordSetVar(_Prefix + "byRKO", "");
  L_MSO.wordSetVar(_Prefix + "byOther", "");
  L_MSO.wordSetVar(_Prefix + "OtherPDoc", "");
  GetAVOAdvance(PDKndAdv, TotAdv);

  trgValue:=L_Pmnt.GetAccountableManBalance(Staff.Man, Staff.MyFirm, PDoc.Date, L_XDoc.max_DoneDTS, PDoc.DoneDTS);
  _Rest:=trgValue[L_Pmnt.vtb_Total]-TotAdv;
  IF    _Rest >= 0 THEN
   L_MSO.wordSetMoneyVar(Prefix + "IniRest",    PDoc.Date, _Rest);
   L_MSO.wordSetVar(Prefix + "IniOverrun", "");
  ELSIF _Rest < 0 THEN
   L_MSO.wordSetVar(Prefix + "IniRest", "");
   L_MSO.wordSetMoneyVar(Prefix + "IniOverrun", PDoc.Date, -_Rest);
  END;

  i:=0;
  WHILE i<=MAXOF(PDoc.PDocKind) DO
   IF PDKndAdv[i] # 0 THEN
    IF i = L_PDoc.pd_RKO THEN
     L_MSO.wordSetMoneyVar(_Prefix + "byRKO", PDoc.Date, PDKndAdv[i]);
    ELSE
     L_MSO.wordSetMoneyVar(_Prefix + "byOther", PDoc.Date, PDKndAdv[i]);
     SEARCH(PDocKind, PDocKind, , i);
     L_MSO.wordSetVar(_Prefix + "OtherPDoc", PDocKind.SName);
    END;
   END;
   INC(i);
  END;
  L_MSO.wordSetMoneyVar(_Prefix + "Total", PDoc.Date, TotAdv);

  _Rest:=_Rest+TotAdv-PDoc.Total;
  IF    _Rest >= 0 THEN
   L_MSO.wordSetMoneyVar(Prefix + "FinRest",    PDoc.Date, _Rest);
   L_MSO.wordSetVar(Prefix + "FinOverrun", "");
  ELSIF _Rest < 0 THEN
   L_MSO.wordSetVar(Prefix + "FinRest", "");
   L_MSO.wordSetMoneyVar(Prefix + "FinOverrun", PDoc.Date, -_Rest);
  END;

  L_XDR.InitEntryList();
  L_XDR.PrepareEntryList(L_XDoc.xdt_PDoc, PDoc.Date, 0);
  _Prefix:="Entry.";
  SETZERO(i);
  SELECT(XDE01, XDE01, , L_XDoc.curXDocId(L_XDoc.xdt_PDoc), L_XDR.xdr_Total);
  WHILE OCCURE(XDE01) & (i < maxI) DO
   L_MSO.wordSetVar_wIndex(_Prefix+"Deb.Sum", L_Money.MoneyToStr(PDoc.Date, "", XDE01.Sum), i);
   L_MSO.wordSetVar_wIndex(_Prefix+"Crd.Sum", L_Money.MoneyToStr(PDoc.Date, "", XDE01.Sum), i);
   CONFORM(XDE01, AcCut);
   L_MSO.wordSetVar_wIndex(_Prefix+"Deb.ACSign", AcCut.Sign, i);
   CONFORM(XDE01, AcCut2);
   L_MSO.wordSetVar_wIndex(_Prefix+"Crd.ACSign", AcCut2.Sign, i);
   INC(i);
   NEXT(XDE01);
  END; (* WHILE OCCURE(XDE01) ... *)
  WHILE i < maxI DO
   L_MSO.wordSetVar_wIndex(_Prefix+"Deb.Sum", "", i);
   L_MSO.wordSetVar_wIndex(_Prefix+"Crd.Sum", "", i);
   L_MSO.wordSetVar_wIndex(_Prefix+"Deb.ACSign", "", i);
   L_MSO.wordSetVar_wIndex(_Prefix+"Crd.ACSign", "", i);
   INC(i);
  END;

  L_XDR.DeInitEntryList();

  SAVE(PDoc);
  _Alias:="ClearOff";
  _Prefix:=_Alias+".";
  oc:=PositionOnAVOClearOff();
  IF oc THEN
   CONFORM(PDoc, PDocKind);
   L_MSO.wordSetVar(_Prefix + "PDocKind.Dir", ~L_PDoc.IsOutPDoc(PDoc.PDocKind));
  ELSE
   L_MSO.wordSetVar(_Prefix + "PDocKind.Dir", "");
  END;
  L_MSO.wordSetVarsByFile_wAliasE("PDoc",      _Alias,  ~oc);
  L_MSO.wordSetVarsByFile_wPrefixE("PDocKind", _Prefix, ~oc);
  wordSetPDocVars(PDoc.Date, _Prefix, ~oc);
  RESTORE(PDoc);

  Count  :=0;
  i      :=0;
  _Prefix:=Prefix+"PDocMDoc";
  CONFORM(PDoc, PDocMDoc);
  oc:=OCCURE(PDocMDoc);
  WHILE oc | (i = 0) DO
   L_MSO.wordSetVarsByFile_wAliasAndIndexE("PDocMDoc", _Prefix, i, ~oc);
   IF oc THEN
    CONFORM(PDocMDoc, MDoc, MDocKind);
    INC(Count);
    L_MSO.wordSetVar(_Prefix+L_MSO.IndexStr(i)+".Idx", L_Str.IntStr(Count));
    _DocName:=P_MDoc.GetMDocProSoft(MDoc.MDocKind, MDoc.MDoc, P_MDoc.P_Note);
    IF !_DocName THEN
     _DocName:=MDocKind.SName;
    END;
   ELSE
    L_MSO.wordSetVar(_Prefix+L_MSO.IndexStr(i)+".Idx", " ");
    _DocName:="";
   END;
   L_MSO.wordSetVar(_Prefix+L_MSO.IndexStr(i)+".DocName", _DocName);
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("MDoc",     _Prefix, i, ~oc);
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("MDocKind", _Prefix, i, ~oc);
   INC(i);
   oc:=oc & NEXT(PDocMDoc);
  END; (* WHILE OCCURE(PDocMDoc) ... *)
  L_MSO.wordSetVar(_Prefix + "Count", L_Str.IntStr(Count));
  L_MSO.SetWordTable("table1", i);
 END {Prepare_AVO};

 PRIVATE PROCEDURE extIsAcceptablePDoc(wCheck, wCanceled: SCAL[2]; _MyFirm: LIKE(PDoc.MyFirm)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF L_PDoc.IsCashOfficePDoc(PDoc.PDocKind) & ((PDoc.Status # L_PDoc.st_Canceled) | wCanceled) THEN
   IF wCheck THEN
    L_PDoc.CheckTaxed();
    L_PDoc.CheckDone();
   END;
   IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
    Result:=PDoc.MyFirm = _MyFirm;
   ELSE
    Result:=1;
   END;
  END;
  RETURN Result;
 END {extIsAcceptablePDoc};

 PRIVATE PROCEDURE IsAcceptablePDoc(trgMyFirm: LIKE(PDoc.MyFirm)): SCAL[2];
 BEGIN
  RETURN extIsAcceptablePDoc(1, 0, trgMyFirm);
 END {IsAcceptablePDoc};

 PRIVATE PROCEDURE GetLastPDocSrcNbr(D: DATE; trgMyFirm: LIKE(PDoc.MyFirm); trgPDocKind: LIKE(PDoc.PDocKind)): LIKE(PDoc.SrcNbr);
  VAR
   Result: LIKE(PDoc.SrcNbr);
 BEGIN
  Result:="";
  SAVE(PDoc);
  SETSEL(PDoc, PDKDate, trgPDocKind);
  SRCINSEL(PDoc, LE, , D);
  WHILE OCCURE(PDoc) & !Result DO
   IF ~L_PDoc.IsUnClosedSalPDoc(PDoc.mfNbr) & IsAcceptablePDoc(trgMyFirm) THEN
    Result:=PDoc.SrcNbr;
   ELSE
    PREV(PDoc);
   END;
  END; (* WHILE OCCURE(PDoc) ... *)
  RESTORE(PDoc);
  RETURN Result;
 END {GetLastPDoc};

 PRIVATE PROCEDURE GetInSaldoForAIN(): L_XObj.tSum;
  VAR
   curDate    : DATE;
   curMyFirm  : LIKE(MyFirm.MyFirm);
   curPDocKind: LIKE(PDoc.PDocKind);
   curDoneDTS : LIKE(PDoc.DoneDTS);
   Result     : L_XObj.tSum;
 BEGIN
  curDate:=PDoc.Date;
  curMyFirm:=PDoc.MyFirm;
  curPDocKind:=PDoc.PDocKind;
  curDoneDTS:=PDoc.DoneDTS;

  L_PDoc.AccessGlobalXObject();
  Result:=L_XObj.mo_GetOutSaldo(L_kn.Get(curDate, L_AcCut.erkn_CentralCashOffice), L_DatTim.IncMonth(L_DatTim.Per(curDate), -1));

  SAVE(PDoc);
  SETSEL(PDoc, Date);
  SRCINSEL(PDoc, GE, , L_DatTim.Per(curDate));
  WHILE OCCURE(PDoc) & (PDoc.Date <= curDate) DO
   PROMPT(L_DatTim.DateStr(curDate) + " : 祭 室饣 ᠫ줮 " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   IF ~L_PDoc.IsUnClosedSalPDoc(PDoc.mfNbr) THEN
    IF IsAcceptablePDoc(curMyFirm) THEN
     IF (PDoc.PDocKind # curPDocKind) | (PDoc.Date < curDate) | (PDoc.DoneDTS < curDoneDTS) THEN
      IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
       DEC(Result, PDoc.Total);
      ELSE
       INC(Result, PDoc.Total);
      END;
     END;
    END;
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc)... *)

  RESTORE(PDoc);
  L_General.Assert(Result>=0,
                   "⥫쭮 ᠫ줮  " + L_DatTim.DateStr(curDate) + ": " + L_Money.MoneyToStr(curDate, "", Result));
  RETURN Result;
 END {GetInSaldoForAIN};

 PRIVATE PROCEDURE MonSpecStr(X: NUMERIC[2]): STRING[];
 BEGIN
  IF ~!X THEN
   RETURN L_Money.MoneyToSpecStr(PDoc.Date, "", X);
  ELSE
   RETURN "-";
  END;
 END {MonSpecStr};

 PRIVATE PROCEDURE Prepare_AIx(D: DATE; Prefix: STRING[]);
  VAR
   curPrefix: STRING[];
   Deficit,
   Excess,
   Saldo : L_XObj.tSum;
 BEGIN
  L_APtm.wordSetTheDocCauseAndDraftsman(D, "⢥ত ⠭ ᪮ ᨨ  18.08.1998  88", "");
  L_MSO.wordSetVar(Prefix + "OKVED_Code", P_MyFirm.OKVED_Code(PDoc.MyFirm, D));
  L_MSO.wordSetVar(Prefix + "OKVED_Name", P_MyFirm.OKVED_Name(PDoc.MyFirm, D));
  CONFORM(PDoc, PDocList);
  IF OCCURE(PDocList) THEN
   CONFORM(PDocList, Staff);
  ELSE
   SEARCH(Staff, TSN, , P_MyFirm.GetTSNByMFPro(PDoc.MyFirm, D, P_MyFirm.P_Cashier, 1));
  END;
  CONFORM(Staff, Man);
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  CONFORM(StaffLog, Post);
  CONFORM(StaffLog, Sort);
  curPrefix:=Prefix;
  L_MSO.wordSetVarsByFile_wPrefix("Staff", curPrefix);
  curPrefix:=Prefix+"Staff.";
  L_MSO.wordSetVarsByFile_wPrefix("Man",  curPrefix);
  L_MSO.wordSetVarsByFile_wPrefix("Sort", curPrefix);
  L_MSO.wordSetVarsByFile_wPrefix("Post", curPrefix);

  Saldo:=GetInSaldoForAIN();

  L_MSO.wordSetVar(Prefix + "LastRKO", GetLastPDocSrcNbr(D, PDoc.MyFirm, L_PDoc.pd_RKO));
  L_MSO.wordSetVar(Prefix + "LastPKO", GetLastPDocSrcNbr(D, PDoc.MyFirm, L_PDoc.pd_PKO));

  L_MSO.wordSetMoneyVar(Prefix + "Saldo",            D, Saldo);
  L_MSO.wordSetVar     (Prefix + "Saldo.MonSpecStr", MonSpecStr(Saldo));
  IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN                      (**)
   Deficit:=PDoc.Total;
   Excess :=EMPTYOF(L_XObj.tSum);
   Saldo  :=Saldo-PDoc.Total;
  ELSE                                                         (*誨*)
   Deficit:=EMPTYOF(L_XObj.tSum);
   Excess :=PDoc.Total;
   Saldo  :=Saldo+PDoc.Total;
  END;
  L_MSO.wordSetMoneyVar(Prefix + "Deficit",            D, Deficit);
  L_MSO.wordSetVar     (Prefix + "Deficit.MonSpecStr", MonSpecStr(Deficit));
  L_MSO.wordSetMoneyVar(Prefix + "Excess",             D, Excess);
  L_MSO.wordSetVar     (Prefix + "Excess.MonSpecStr",  MonSpecStr(Excess));

  L_MSO.wordSetMoneyVar(Prefix + "Fact",            D, Math.Max(0, Saldo));
  L_MSO.wordSetVar     (Prefix + "Fact.MonSpecStr", MonSpecStr(Math.Max(0, Saldo)));
 END {Prepare_AIx};

 PRIVATE PROCEDURE PrepareObjects(D: DATE);
  VAR
   Root,
   Prefix      : STRING[];
   i           : NUMERIC[0];
   _Underpay   : L_Pmnt.tValuesToBalance;
 BEGIN
  Prefix:="PDoc.";
  P_Firm.AccessOwnFirm(PDoc.MyFirm);
  P_Firm.SetFirmData(Prefix + "Own", Firm.Firm, D, PDoc.OwnAcnt,  "");
  IF P_MyFirm.HasActualPro(PDoc.MyFirm, D, P_MyFirm.P_Cashier) THEN
   L_MSO.wordSetVar(Prefix + "OwnFirm.Cashier.Name", P_MyFirm.CashName(PDoc.MyFirm, D));
  ELSE
   L_MSO.wordSetVar(Prefix + "OwnFirm.Cashier.Name", "");
  END;
  CONFORM(PDoc, Firm);
  L_MSO.wordSetVarsByFile("PDoc");
  CONFORM(PDoc, PDocKind);
  L_MSO.wordSetVarsByFile("PDocKind");
  L_MSO.wordSetVar("PDoc.BarCode", L_PDoc.BarCode());
  L_MSO.wordSetMoneyVar("PDoc.Total", D, PDoc.Total);
  L_MSO.wordSetMoneyVar("PDoc.Netto", D, PDoc.Total - L_Pmnt.ConvEtZ(PDoc.NDS));
  L_MSO.wordSetMoneyVar("PDoc.VAT",   D, PDoc.NDS); (*  ! ! *)
  L_MSO.wordSetVar("PDoc.About", L_PDoc.GetPDocComment());
  IF L_PDoc.PDocKindHasStructuredComment(PDoc.PDocKind) THEN
   L_MSO.wordSetVar("PDoc.About[0]", L_PDoc.GetPDocCommentPart(0));
   L_MSO.wordSetVar("PDoc.About[1]", L_PDoc.GetPDocCommentPart(1));
   L_MSO.wordSetVar("PDoc.About[2]", L_PDoc.GetPDocCommentPart(2));
  END;

  L_MSO.wordSetVar("PDoc.P_Comment",
                   P_PDoc.GetPDocProSoft(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_Comment));

  IF    PDoc.PDocKind = L_PDoc.pd_IPP THEN
   Prepare_IPP(D, Prefix);
  ELSIF PDoc.PDocKind = L_PDoc.pd_AVO THEN
   Prepare_AVO(D, Prefix);
  ELSIF (PDoc.PDocKind = L_PDoc.pd_AIN) |
        (PDoc.PDocKind = L_PDoc.pd_AII) THEN
   Prepare_AIx(D, Prefix);
  ELSIF L_PDoc.IsPDocKind_wPmntMsgAsMainForm(PDoc.PDocKind, PDoc.Date) THEN
   L_General.Assert(L_PDoc.IsPDocwMDoc(),
                    "⥦ 㬥    뫪  ");
   L_General.Assert(PDoc.Status = L_PDoc.st_Passed,
                    "⥦ 㬥   ஢");
   L_General.Assert(PDoc.Done,
                    "⥦ 㬥   ࠡ⠭");
   P_Firm.SetFirmData(Prefix, Firm.Firm, D, PDoc.FirmAcnt, L_MSO.fps_Soft_asStr);
   i:=0;
   CONFORM(PDoc, PDocMDoc);
   WHILE OCCURE(PDocMDoc) DO
    CONFORM(PDocMDoc, MDoc);
    CONFORM(MDoc, Contract);
    CONFORM(MDoc, MDocKind);
    CONFORM(Contract, CntrT);
    _Underpay:=L_Pmnt.GetMDocBalance(PDoc.Date, L_XDoc.max_DoneDTS);
    Root:="PDoc.PDocMDoc"+L_MSO.IndexStr(i);
    L_MSO.wordSetVarsByFile_wAlias("PDocMDoc", Root);
    L_PmntU.wordSetVTB(Root, D, L_Pmnt.vtbGetByPDocMDoc());
    Root:=Root+".MDoc";
    L_MSO.wordSetVarsByFile_wAlias("MDoc", Root);
    L_PmntU.wordSetVTB(Root, D, L_Pmnt.GetMDocAcpt());
    L_MSO.wordSetVar(Root+".BarCode", L_MDoc.BarCode());
    L_PmntU.wordSetVTB(Root+".Underpay", D, _Underpay);
    L_MSO.wordSetVarsByFile_wAlias("MDocKind", Root+".MDocKind");
    Root:=Root+".Contract";
    L_MSO.wordSetVarsByFile_wAlias("Contract", Root);
    Root:=Root+".CntrT";
    L_MSO.wordSetVarsByFile_wAlias("CntrT",    Root);
    NEXT(PDocMDoc);
    INC(i);
   END; (* WHILE OCCURE(PDocMDoc) ... *)
   L_MSO.extSetWordTable("PDocMDocTbl", i, L_MSO.tt_Soft);
 
   L_PmntU.wordPrepareFirmUnderpay(PDoc.Firm, PDoc.MyFirm, PDoc.Date, Root);
  ELSE
   L_General.Error(" ॠ   Word  " +
                   L_PDoc.PDocKindNick(PDoc.PDocKind, 1));
  END;
 END {PrepareObjects};

 PUBLIC PROCEDURE MakeDoc(PrepareMode: L_MSO.PrpModeType);
  VAR
   Copies    : NUMERIC[0];
   Subject,
   Template  : STRING[];
   cur_iri   : L_General.tInternalRecordId;
 BEGIN
  ACCESS(PDoc);
  L_MSO.wordInitDocument(PDoc.Date);
  PrepareObjects(PDoc.Date);
  IF L_PDoc.IsPDocKind_wPmntMsgAsMainForm(PDoc.PDocKind, PDoc.Date) THEN
   Template:="P_Msg##";
   IF PDoc.Date >= 06\09\2006 THEN
    Template:=L_MSO.BuildTemplateName(Template, "02");
   ELSE
    Template:=L_MSO.BuildTemplateName(Template, "01");
   END;
   Copies:=1;
   L_Pmnt.E_wordAsIfSignDocument(PDoc.MyFirm, PDoc.Date, PrepareMode = L_MSO.PrpMode_ToPDF);
  ELSE
   IF (PDoc.PDocKind = L_PDoc.pd_AIN) |
      (PDoc.PDocKind = L_PDoc.pd_AII) THEN
    Template:="PD18" + "_##";
   ELSE
    Template:="PD" + PDoc.PDocKind + "_##";
   END;
   Template:=L_MSO.BuildTemplateName(Template, L_PDoc.E_O_PDocP_GetTemplateVersion());
   Copies:=L_PDoc.E_DefaultPayLAmnt(PDoc.Date);
  END;

  IF (PrepareMode = L_MSO.PrpMode_ToPDF) | (PrepareMode = L_MSO.PrpMode_ToImage) THEN
   cur_iri:=L_General.iri_GetCurrent("PDoc");
   L_MSO.MakeXDFWordDocument(cur_iri,
                             Template,
                             Copies,
                             PrepareMode);
   IF L_PDoc.IsPDocKind_wPmntMsgAsMainForm(PDoc.PDocKind, PDoc.Date) THEN
    Subject:="⥦  - " + Str.Small(PDocKind.SName);
   ELSE
    Subject:=PDocKind.SName;
   END;
   Subject:=Subject + " " + "(" + PDocKind.PDocKind + ")" + " " +  PDoc.SrcNbr + "  " + L_DatTim.DateStr(PDoc.Date);
   L_APEMl.SendDocument(cur_iri,
                        Subject,
                        L_EMail.AssembleContact(Firm.Name, P_Firm.FP_email(Firm.Firm, SYSDATE())));
  ELSE
   L_MSO.MakeWordDocument(Template,
                          Copies,
                          PrepareMode, "");
  END;
 END {MakeDoc};

 PRIVATE PROCEDURE oldMakeDoc();
 BEGIN
  L_StdFrm.Choice("⥦  ⥯ ᭮ ଠ   . -  ⠪?");
  IF MODE > 170 THEN (*  *)
   MakeDoc(L_MSO.PrpMode_Print);
  ELSIF MODE > 150 THEN
   MakeDoc(L_MSO.PrpMode_ToImage);
  ELSIF MODE > 120 THEN
   MakeDoc(L_MSO.PrpMode_ToPDF);
  ELSIF MODE > 070 THEN (* ஥ *)
   MakeDoc(L_MSO.PrpMode_ToDoc);
  END;
 END {oldMakeDoc};

BEGIN
 IF MODE # L_Events.md_InIMPORT THEN
  oldMakeDoc();
 END;
END.
