(*
%Copyright   (c) Polak Computer System
%Author      20.03.2001 12:54:16 SAN
%Purpose     ନ஢ 㬥⮢  ࠡ⭨  MS_Office
%Type        operation
%Specific    SYS
%Modified    19.09.2014 17:35:41 POLAK\Gina
%Environment
*)

 MODULE O_Staff [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Math, Str, Memo,
        L_General, L_DatTim, L_MSO, L_Str, L_EC, L_Tax, L_AFM, L_Prop, L_Man, L_Env,
        L_StdFrm, L_ctc, L_Staff, L_AvePay, L_MathR, L_MDoc, L_Money, L_ManMlt, L_Russia, L_CUC,
        L_APtm, L_PRoll, L_Math, L_Sheet, L_AR, L_PDoc, L_Packet, L_Print, L_EDO, E_Staff, L_Car,
        P_Man, P_Firm, P_Officer, P_Post, P_Math, P_MyFirm, P_Staff, P_MyPlc, P_MySite,
        P_EDOL;

 PRIVATE TYPE
  tDocSource        = SCAL[4];
  tTablePrintMethod = SCAL[4];

 PRIVATE CONST
  ds_Staff  = 0;
  ds_Deduct = 1;
  ds_AvePay = 2;
  ds_TaxInq = 3;

  tpm_Empty    = 0;
  tpm_HandFill = 1;
  tpm_Limit    = 2;
  tpm_All      = 3;

 PRIVATE PROCEDURE E_AbnormalContractProlongation(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_Staff.AbnormalContractProlongation), 0);
 END {E_AbnormalContractProlongation};

 PRIVATE PROCEDURE E_T1_ExtraText(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_Staff.T1_ExtraText), "");
 END {E_T1_ExtraText};

 PRIVATE PROCEDURE E_T1_ExtraFooter(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_Staff.T1_ExtraFooter), "");
 END {E_T1_ExtraFooter};

 PRIVATE PROCEDURE E_T5_ExtraFooter(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_Staff.T5_ExtraFooter), "");
 END {E_T5_ExtraFooter};

 PRIVATE PROCEDURE E_T8_ExtraFooter(D: DATE): STRING[];
 BEGIN
  RETURN L_EC.ExecE_Func_String(D, PROCREF(E_Staff.T8_ExtraFooter), "");
 END {E_T8_ExtraFooter};

 PRIVATE PROCEDURE E_asLeaderForEDO(D: DATE): LIKE(SgnAuthR.SgnAuthR);
 BEGIN
  RETURN L_Staff.E_asLeader(D, L_Staff.sarr_EDOrder);
 END {E_asLeaderForEDO};

 PRIVATE PROCEDURE E_asLeaderForBegun(D: DATE): LIKE(SgnAuthR.SgnAuthR);
 BEGIN
  RETURN L_Staff.E_asLeader(D, L_Staff.sarr_Begun);
 END {E_asLeaderForBegun};

 PRIVATE PROCEDURE E_asLeaderForTwoOfficerOrder(D       : DATE;
                                                Sort1   : LIKE(Sort.Sort);
                                                Officer1: LIKE(Officer.Officer);
                                                Sort2   : LIKE(Sort.Sort);
                                                Officer2: LIKE(Officer.Officer)): LIKE(SgnAuthR.SgnAuthR);
  VAR
   SgnAuthR1,
   SgnAuthR2 : LIKE(SgnAuthR.SgnAuthR);
 BEGIN
  L_General.CallUs(SEARCH(Officer, Officer, Sort1, Officer1));
  SgnAuthR1:=E_asLeaderForEDO(D);
  L_General.CallUs(SEARCH(Officer, Officer, Sort2, Officer2));
  SgnAuthR2:=E_asLeaderForEDO(D);
  IF SgnAuthR1 = SgnAuthR2 THEN
   RETURN SgnAuthR1;
  ELSE
   RETURN "";
  END;
 END {E_asLeaderForTwoOfficerOrder};

 PRIVATE PROCEDURE E_GetT2Form(): L_Staff.tT2Form;
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Staff.GetT2Form);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN L_Staff.t2f_wT2_2_BeganInf;
  END;
 END {E_GetT2Form};

 PRIVATE PROCEDURE IsT2DefaultForm(T2Form: L_Staff.tT2Form): SCAL[2];
 BEGIN
  RETURN (T2Form = L_Staff.t2f_Default) | (T2Form = L_Staff.t2f_Default_A4);
 END {IsT2DefaultForm};

 PRIVATE PROCEDURE DischargeOnlyRoundLsPrint(): SCAL[2];
 BEGIN
  RETURN L_General.GetAPSiteNumber() # 84;
 END {DischargeOnlyRoundLsPrint};

 PRIVATE PROCEDURE E_gtn_T2(): STRING[];
  VAR
   T2Form: L_Staff.tT2Form;
 BEGIN
  T2Form:=E_GetT2Form();
  IF    T2Form = L_Staff.t2f_Default THEN
   RETURN "T2_Default";
  ELSIF T2Form = L_Staff.t2f_Default_A4 THEN
   RETURN "T2_Default_A4";
  ELSE
   RETURN "T2";
  END;
 END {E_gtn_T2};

 PRIVATE PROCEDURE E_gtn_LabourContract(): STRING[];
  CONST
   defaultTemplateName = "LbC01";
  VAR
   Local : PROC;
   Result: STRING[];
 BEGIN
  Local :=PROCREF(E_Staff.gtn_LabourContract);
  Result:=defaultTemplateName;
  IF ~!Local THEN
   Result:=Local(defaultTemplateName);
  END;
  RETURN Result;
 END {E_gtn_LabourContract};

 PRIVATE PROCEDURE E_gtn_ProbSht(): STRING[];
  CONST
   defaultTemplateName = "ProbSht";
  VAR
   Local : PROC;
   Result: STRING[];
 BEGIN
  Local :=PROCREF(E_Staff.GetProbShtTemplateName);
  IF ~!Local THEN
   Result:=Local(Memo.ud_cd());
  ELSE
   Result:=defaultTemplateName;
  END;
  RETURN Result;
 END {E_gtn_ProbSht};

 PRIVATE PROCEDURE DefineFullDocList(Source: tDocSource);
  VAR
   T2Form         : L_Staff.tT2Form;
   addDocProc     : PROC;
   RoundLs_DateDef: STRING[];
 BEGIN
  SETEMPTY(addDocProc);
  IF    Source = ds_Staff THEN
   L_MSO.dl_AddGroup(L_Staff.osgn_Tx_Forms);
   L_MSO.dl_AddDocInCurGroup(" ਥ  ࠡ (T-1)", "T1", "", "Staff.BegDate");
   L_MSO.dl_AddDocInCurGroup(" ॢ   ࠡ (T-5)", "T5", "", "StaffLog.Date");
   L_MSO.dl_AddDocInCurGroup(" ४饭 㤮  (T-8)", "T8", "", "Staff.EndDate");
   L_MSO.dl_AddGroup(L_Staff.osgn_StaffContracts);
   L_MSO.dl_AddDocInCurGroup("㤮 ", E_gtn_LabourContract(), "LbC01", "Staff.BegDate");
   L_MSO.dl_AddDocInCurGroup("⥫쭮 ᮣ襭  㤮 ", "AddLbC01", "", "Memo.ud_cd()");
   L_MSO.dl_AddDocInCurGroup("  ਠ쭮 ⢥⢥", "Liabilit", "", "Memo.ud_cd()");
   L_MSO.dl_AddGroup(L_Staff.osgn_T2);
   L_MSO.dl_AddDocInCurGroup("筠 窠 ࠡ⭨", E_gtn_T2(), "T2", "Staff.BegDate");
   T2Form:=E_GetT2Form();
   IF ~IsT2DefaultForm(T2Form) THEN
    L_MSO.dl_AddDocInCurGroup("   筮 窥 ࠡ⭨", "T2_2", "", "Memo.ud_cd()");
   END;
   IF T2Form # L_Staff.t2f_wT2_2_ActualInf THEN
    L_MSO.dl_AddDocInCurGroup("   筮 窥 ࠡ⭨ ()", "T2_2", "T2_2_Empty", "Memo.ud_cd()");
   END;
   L_MSO.dl_AddGroup(L_Staff.osgn_References);
   L_MSO.dl_AddDocInCurGroup(" ⮬,  ࠡ⠥  ।⨨", "Ref_Gnrl", "", "SYSDATE");
   L_MSO.dl_AddDocInCurGroup(" 宦   ()", "Rfrnc01", "", "SYSDATE");
   L_MSO.dl_AddDocInCurGroup(" . .   ⥫  ᨨ  ", "RDSV", "", "SYSDATE");
   L_MSO.dl_AddDocInCurGroup(" 祭 ", "Loan", "", "Memo.ud_cd()");
   L_MSO.dl_AddDocInCurGroup("  ᨤ", "ForCDL", "", "Memo.ud_cd()");
   L_MSO.dl_AddDocInCurGroup(" । ࠡ⪥   ॡ  ਮ", "SalAve", "", "SYSDATE");
   L_MSO.dl_AddDocInCurGroup(" । ࠡ⪥  ᮡ  ࠡ", "NBUSF", "", "Staff.EndDate");
   L_MSO.dl_AddDocInCurGroup(" ࠡ⪥  ਮ (12 楢)  ", "NVTEK", "", "SYSDATE");
   L_MSO.dl_AddGroup(L_Staff.osgn_Foreigners);
   L_MSO.dl_AddDocInCurGroup("  ਡ⨨ ࠭ ࠦ", "FCAN01", "", "Memo.ud_cd()");
   L_MSO.dl_AddDocInCurGroup("  ਢ祭  㤮 ⥫쭮  ", "FCAN02", "FCAN02_2EmploymentCenter_Prepare", "Memo.ud_cd()");
   L_MSO.dl_AddDocInCurGroup("  ਢ祭  㤮 ⥫쭮  ", "FCAN02", "FCAN02_2FMS_Prepare", "Memo.ud_cd()");
   L_MSO.dl_AddDocInCurGroup("  㢮쭥 ࠭ ࠦ  ", "FCAN03", "FCAN03_2EmploymentCenter_Prepare", "Staff.EndDate");
   L_MSO.dl_AddDocInCurGroup("  㢮쭥 ࠭ ࠦ  ", "FCAN03", "FCAN03_2FMS_Prepare", "Staff.EndDate");
   L_MSO.dl_AddDocInCurGroup("  த ࠧ襭  ࠡ", "AoFCWPP", "", "SYSDATE");
   L_MSO.dl_AddDoc("楢   砫   ⥪  (-54)", "T54A", "", "Memo.ud_cd()");
   L_MSO.dl_AddDoc("    筥   ⥫⢠", "PF_Adr", "", "SYSDATE");
   L_MSO.dl_AddDoc("筠 窠  ᯥ殤 (-6)", "MB6", "MB6_Prepare", "Memo.ud_cd()");
   L_MSO.dl_AddDoc("ࠢ  ਮ᪨ ᬮ", "DME02", "", "SYSDATE");
   IF DischargeOnlyRoundLsPrint() THEN
    RoundLs_DateDef:="Staff.EndDate";
   ELSE
    RoundLs_DateDef:="Memo.ud_cd()";
   END;
   L_MSO.dl_AddDoc("室 ", "RoundLst", "", RoundLs_DateDef);
   L_MSO.dl_AddDoc("  뤠  ⥫", "ApplDC01", "", "SYSDATE");
   addDocProc:=PROCREF(E_Staff.DefineAdditionalDocList);
   IF L_APtm.IsMTA() THEN
    L_MSO.dl_AddDoc("⠦஢ ", E_gtn_ProbSht(), "ProbShtPrepare", "Memo.ud_cd()");
   ELSIF L_General.GetAPSiteNumber() = 84 THEN
    L_MSO.dl_AddDoc("⠦஢ ", E_gtn_ProbSht(), "E_Staff.ProbShtPrepare", "Memo.ud_cd()");
   END;
  ELSIF Source = ds_Deduct THEN
   L_MSO.dl_AddDoc("ࠢ    ਮ", "Alimony", "", "Memo.ud_ut()");
(*
   L_MSO.dl_AddDoc("  ᫥ /  ᪨ ", "SalaryTr", "", "Deduct.BegDate");
*)
  ELSIF Source = ds_AvePay THEN
   L_MSO.dl_AddDoc("ਪ  ।⠢ ᪠ (T-6)", "T6", "", "AvePay.StartD");
   L_MSO.dl_AddDoc("஢筮 㤮⮢७ (T-10)", "T10", "", "AvePay.StartD");
   CONFORM(AvePay, AveType);
   IF AveType.AveNo = L_AvePay.aveno_Hldy THEN
    IF L_AvePay.AvePayHasJMode() THEN
     L_MSO.dl_AddDoc("᪠- (T-60)", "T60", "", "AvePay.StartD");
    ELSE
     L_MSO.dl_AddDoc("᪠- (T-61)", "T61", "", "AvePay.StartD");
    END;
   END;
   addDocProc:=PROCREF(E_Staff.DefineAdditionalAPDocumentsList);
  ELSIF Source = ds_TaxInq THEN
   L_MSO.dl_AddDoc("  ।⠢ ⠭  ⮢", "Tax_StD", "", "Memo.ud_cd()");
  ELSE
   L_General.CallUs(0);
  END;
  IF ~!addDocProc THEN
   addDocProc();
  END;
 END {DefineFullDocList};

 PRIVATE PROCEDURE Set_DocCause(D: DATE);
 BEGIN
  L_APtm.wordSetTheDocCauseAndDraftsman(D, "⢥ত ⠭ ᪮ ᨨ  05.01.2004  1", "");
 END {Set_DocCause};

 PRIVATE PROCEDURE T1(D: DATE; Root: STRING[]);
  VAR
   Local: PROC;
 BEGIN
  IF ~!Root THEN
   L_MSO.wordSetVar("E_T1_ExtraText",   E_T1_ExtraText(D));
   L_MSO.wordSetVar("E_T1_ExtraFooter", E_T1_ExtraFooter(D));
   L_Staff.Set_AsLeaderVars(D, E_asLeaderForBegun(D));

   Set_DocCause(D);
   Local:=PROCREF(E_Staff.JobCCXX_GetExtraFeatures);
   IF ~!Local THEN
    Local(Root, D);
   END;
  END;
 END {T1};

 PRIVATE PROCEDURE intWordSetLanguageAttr(Root, l_Name, l_Level, l_OKIN: STRING[]; i: NUMERIC[0]);
 BEGIN
  L_MSO.wordSetVar(Root + "Man.Language[" + L_Str.IntStr(i) + "].Name",  l_Name);
  L_MSO.wordSetVar(Root + "Man.Language[" + L_Str.IntStr(i) + "].Level", l_Level);
  L_MSO.wordSetVar(Root + "Man.Language[" + L_Str.IntStr(i) + "].OKIN",  l_OKIN);
 END {intWordSetLanguageAttr};

 PRIVATE PROCEDURE WordSetLanguageAttr(Root: STRING[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=1;
  IF SELECT(ManExpr, Man, Man.Man, L_Man.et_ForeignLanguage) THEN
   LAST(ManExpr);
   WHILE OCCURE(ManExpr) & (i <= 2) DO
    CONFORM(ManExpr, Expr);
    intWordSetLanguageAttr(Root, Expr.Name, Expr.Level, L_Man.GetManLangLevelAsOKIN(), i);
    INC(i);
    PREV(ManExpr);
   END; (* WHILE OCCURE(ManExpr) ... *)
  END;

  WHILE i <= 2 DO
   intWordSetLanguageAttr(Root, "", "", "", i);
   INC(i);
  END;
 END {WordSetLanguageAttr};

 PRIVATE PROCEDURE _SetEmptyEd(Root: STRING[]; idx: NUMERIC[0]);
 BEGIN
  L_MSO.wordSetVar(Root + "Man.Education[" + L_Str.IntStr(idx) + "].Name", "");
  L_MSO.wordSetVarsByFile_wAliasAndIndexE("ManActv", Root + "Man.Education", idx, 1);
  L_MSO.wordSetVarsByFile_wIndexedPrefixE("OKPDTR",  Root + "Man.Education", idx, 1);
  L_MSO.wordSetVarsByFile_wIndexedPrefixE("OKSO",    Root + "Man.Education", idx, 1);
 END {_SetEmpyEd};

 PRIVATE PROCEDURE CopyEd(Root: STRING[]; idx: NUMERIC[0]);
  VAR
   r: STRING[];
 BEGIN
  r:=Root + "Man.Education"+"["+L_Str.IntStr(idx)+"].";
  L_MSO.wordSetVar(r + "Name", ManActv.FndName);
  L_MSO.wordSetVarsByFile_wAliasAndIndexE("ManActv", Root + "Man.Education", idx, 0);
  IF ~!ManActv.DocType THEN
   L_MSO.wordSetVar(r + "DocType", L_Str.PoolItem(L_Man.eddoctype_Pool, ManActv.DocType));
  END;

  IF ~!ManActv.OKPDTR THEN
   CONFORM(ManActv, OKPDTR);
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("OKPDTR", Root + "Man.Education", idx, 0);
  END;
  IF ~!ManActv.OKSO THEN
   CONFORM(ManActv, OKSO);
   L_MSO.wordSetVarsByFile_wIndexedPrefixE("OKSO", Root + "Man.Education", idx, 0);
  END;
 END {CopyEd};

 PRIVATE PROCEDURE CheckSingleEducation(    Root            : STRING[];
                                            EdTypes         : LIKE(ManActv.EdType)[];
                                            trgNbr          : NUMERIC[0];
                                            MakeCopyRequired: SCAL[2];
                                            Idx             : NUMERIC[0];
                                        VAR sEdType0        : STRING[]);
  VAR
   i        : NUMERIC[0];
   Result   : SCAL[2];
   trgEdType: LIKE(ManActv.EdType);
 BEGIN
  Result:=0;
  i     :=0;
  LOOP
   IF Result | (i > HIGH(EdTypes)) THEN
    EXIT;
   END;
   trgEdType:=EdTypes[i];
   IF L_Man.ManAccessActv(L_Man.actvk_Education, trgEdType, trgNbr) THEN
    sEdType0:=L_Str.PoolItem(L_Man.edtype_Pool, trgEdType);
    IF MakeCopyRequired THEN
     CopyEd(Root, Idx);
    END;
   END;
   INC(i);
  END; (* LOOP *)
 END {CheckSingleEducation};

 PRIVATE PROCEDURE WordSetEducation_Part1(Root: STRING[]);
  VAR
   sEdType0: STRING[];
 BEGIN
  _SetEmptyEd(Root, 0);
  _SetEmptyEd(Root, 1);
  _SetEmptyEd(Root, 2);

  SETEMPTY(sEdType0);
  CheckSingleEducation(Root, L_Man.edtype_Secondary, 1, 0, EMPTYOF(NUMERIC[0]), sEdType0);
  CheckSingleEducation(Root, [L_Man.edtype_General, L_Man.edtype_Primary, L_Man.edtype_None], 1, 1, 0, sEdType0);
  CheckSingleEducation(Root, L_Man.edtype_PrimaryProf, 1, 1, 1, sEdType0);
  CheckSingleEducation(Root, L_Man.edtype_SecondaryProf, 1, 1, 0, sEdType0);
  CheckSingleEducation(Root, L_Man.edtype_SecondaryProf, 2, 1, 1, sEdType0);
  CheckSingleEducation(Root, L_Man.edtype_HighProf, 1, 1, 0, sEdType0);
  CheckSingleEducation(Root, L_Man.edtype_HighProf, 2, 1, 1, sEdType0);
  CheckSingleEducation(Root, L_Man.edtype_AfterHighProf, 1, 1, 2, sEdType0);

  IF !sEdType0 & ~!Root THEN
   L_StdFrm.Choice("  ଠ樨  ࠧ");
  END;

  L_MSO.wordSetVar(Root + "Man.Education.Type", sEdType0);   
  L_MSO.wordSetVar(Root + "Man.Education.OKIN", L_Man.GetManEducationLevelAsOKIN());
 END {WordSetEducation_Part1};

 PRIVATE PROCEDURE WordSetEducation_Part2(Root: STRING[]);
  VAR
   idx: NUMERIC[0];
 BEGIN
  SELECT(ManActv, Man, , Man.Man, 0);
  idx:=0;
  WHILE OCCURE(ManActv) DO
   IF ~!ManActv.OKPDTR THEN
    L_General.Assert(!ManActv.OKSO, "       ६");
    CONFORM(ManActv, OKPDTR);
    L_MSO.wordSetVarsByFile_wAliasAndIndexE("OKPDTR", Root + "Man.OKPDTR", idx, 0);
    INC(idx);
   END;
   NEXT(ManActv);
  END; (* WHILE OCCURE(ManActv) ... *)
  WHILE idx < 2 DO
   L_MSO.wordSetVarsByFile_wAliasAndIndexE("OKPDTR", Root + "Man.OKPDTR", idx, 1);
   INC(idx);
  END; (* WHILE idx < 2 ... *)
 END {WordSetEducation_Part2};

 PRIVATE PROCEDURE WordSetAllStages(Root: STRING[]);
 VAR
  Days,
  Months,
  Years         : STRING[][4];
  i             : NUMERIC[0];
  DaysOfStage,
  MonthsOfStage,
  YearsOfStage  : NUMERIC[0][L_Man.ins_Size];
  CntStageDate  : DATE      [L_Man.ins_Size];
  BegDate       : DATE;
 BEGIN
  L_Man.FillStages(Memo.ud_cd(), DaysOfStage, MonthsOfStage, YearsOfStage, CntStageDate, BegDate);
  L_MSO.wordSetDateVar(Root + "Man.Stage.Date", BegDate);
  i:=0;
  WHILE (i < 4) DO
   Days  [i]:=Str.Condense(FLDTOSTR(DaysOfStage  [i+1]));
   Months[i]:=Str.Condense(FLDTOSTR(MonthsOfStage[i+1]));
   Years [i]:=Str.Condense(FLDTOSTR(YearsOfStage [i+1]));
   INC(i);
  END;(*WHILE*)
  L_MSO.wordSetStrArray_wSuffix(Root + "Man.Stage", ".Days",   Days);
  L_MSO.wordSetStrArray_wSuffix(Root + "Man.Stage", ".Months", Months);
  L_MSO.wordSetStrArray_wSuffix(Root + "Man.Stage", ".Years",  Years);
 END {WordSetAllStages};

 PRIVATE PROCEDURE WordSetFamily(D: DATE; Root: STRING[]; MaxLines: NUMERIC[0]);
  VAR
   i: NUMERIC[0];
 BEGIN
  CONFORM(Man, ManFml);
  i:=0;
  WHILE OCCURE(ManFml) & (i < MaxLines) DO
   IF ManFml.EndDate >= D THEN
    L_MSO.wordSetVarsByFile_wAliasAndIndexE("ManFml", Root + "Man.ManFml", i, 0);
    INC(i);
   END;
   NEXT(ManFml);
  END; (* WHILE OCCURE(ManFml) ... *)

  WHILE i < MaxLines DO
   L_MSO.wordSetVarsByFile_wAliasAndIndexE("ManFml", Root + "Man.ManFml", i, 1);
   INC(i);
  END; (* WHILE i ... *)
 END {WordSetFamily};

 PRIVATE PROCEDURE EPoolItem(Pool: STRING[]; i: NUMERIC[0]): STRING[];
 BEGIN
  IF !i THEN
   RETURN "";
  ELSE
   RETURN L_Str.PoolItem(Pool, i);
  END;
 END {EPoolItem};

 PRIVATE PROCEDURE WordSetMilitaryInfo(D: DATE; Root: STRING[]);
  VAR
   SpSer, SpDsc,
   ComnSer, ComnDsc:STRING[];
 BEGIN
  SETEMPTY(SpSer, SpDsc, ComnSer, ComnDsc);
  L_ManMlt.GetManMltActualStatus(Man.Man, D);
  L_MSO.wordSetVar(Root + "Man.MltSort",     EPoolItem(L_ManMlt.mms_Pool, L_ManMlt.mmas_Sort));
  L_MSO.wordSetVar(Root + "Man.MltSpec",     L_ManMlt.mmas_Spec);  
  L_MSO.wordSetVar(Root + "Man.MltProfil",   EPoolItem(L_ManMlt.mmp_FullPool, L_ManMlt.mmas_Profil));  
  L_MSO.wordSetVar(Root + "Man.MltReady",    EPoolItem(L_ManMlt.mm_ReadyPool_Short, L_ManMlt.mmas_Ready));  
  L_MSO.wordSetVar(Root + "Man.MltDocType",  EPoolItem(L_ManMlt.mdt_FullPool, L_ManMlt.mmas_DocType));  
  L_MSO.wordSetVar(Root + "Man.MltDocSer",   L_ManMlt.mmas_DocSer);  
  L_MSO.wordSetVar(Root + "Man.MltDocNbr",   L_ManMlt.mmas_DocNbr);  
  L_MSO.wordSetVar(Root + "Man.MltDocGiveS", L_ManMlt.mmas_DocGiveS);  
  L_MSO.wordSetVar(Root + "Man.MltDocGiveD", L_DatTim.DateStr(L_ManMlt.mmas_DocGiveD));  

  IF    L_ManMlt.HasActualManMltEvent(Man.Man, D, L_ManMlt.mme_OrderX) THEN
   ComnSer:=ManMlt.CmndNum;
   ComnDsc:=ManMlt.Liter;
  ELSIF L_ManMlt.HasActualManMltEvent(Man.Man, D, L_ManMlt.mme_Reserv) THEN
   SpSer:=ManMlt.DocSer;  
   SpDsc:=ManMlt.DocNbr;  
  END;
  L_MSO.wordSetVar(Root + "Man.MltComnSer", ComnSer);  
  L_MSO.wordSetVar(Root + "Man.MltComnDsc", ComnDsc);  
  L_MSO.wordSetVar(Root + "Man.MltSpSer",   SpSer);  
  L_MSO.wordSetVar(Root + "Man.MltSpDsc",   SpDsc);  
  IF ~!L_ManMlt.mmas_MltDep THEN
   SEARCH(MltDep, MltDep, , L_ManMlt.mmas_MltDep);
  END;
  IF ~!L_ManMlt.mmas_MltRank THEN
   SEARCH(MltRank, MltRank, , L_ManMlt.mmas_MltRank);
  END;
  L_MSO.wordSetVarsByFile_wAliasE("MltDep",  Root + "Man.MltDep",  ~OCCURE(MltDep));
  L_MSO.wordSetVarsByFile_wAliasE("MltRank", Root + "Man.MltRank", ~OCCURE(MltRank));
 END {WordSetMilitaryInfo};

 PRIVATE PROCEDURE WordSetAppInf(Root: STRING[]);
  VAR
   Idx   : NUMERIC[0];
   AppInf: STRING[][5];
 BEGIN
  Idx:=0;
  SETEMPTY(AppInf);
  IF P_Man.HasActualManPro(Man.Man, SYSDATE(), P_Man.P_DriveSertification) THEN
   AppInf[Idx]:="⥫᪮ 㤮⮢७ " + ManPro.DocNum +
                "  " + L_DatTim.DateStr(ManPro.DocGiveD) +
                "; -  " + L_DatTim.DateStr(ManPro.DocExpD) +
                "; ⥣ਨ " + P_Man.GetDriveSertification_Category(Man.Man, SYSDATE());
   INC(Idx);
  END;
  L_MSO.wordSetStrArray(Root + "Man.AppInf", AppInf);
 END {WordSetAppInf};

 PRIVATE PROCEDURE GetTakeOnDate(D: DATE): DATE;
  VAR
   Result: DATE;
 BEGIN
  SAVE(StaffLog);
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  WHILE OCCURE(StaffLog) & (L_Staff.GetStaffLogType() # L_Staff.slkt_TakeOn) DO
   PREV(StaffLog);
  END;
  Result:=StaffLog.Date;
  RESTORE(StaffLog);
  RETURN Result;
 END {GetTakeOnDate};

 PRIVATE PROCEDURE WordSetSingleStaffLog(i         : NUMERIC[0];
                                         SD        : DATE;
                                         Root      : STRING[];
                                         forceEmpty: SCAL[2]);
  VAR
   Prefix: STRING[];
 BEGIN
  Prefix:=Root + L_Str.Var_wIdx("StaffLog", i);
  IF forceEmpty THEN
   L_MSO.wordSetDateVar(Prefix + ".Date",                       EMPTYOF(DATE));
   L_MSO.wordSetVar    (Prefix + ".Officer.DirtyTyp.Power",     "");
   L_MSO.wordSetVar    (Prefix + ".Sort.ParentsName",           "");
   L_MSO.wordSetVar    (Prefix + ".Sort.ParentsName.wBrackets", "");
   L_MSO.wordSetVar    (Prefix + ".Sort.Name",                  "");
   L_MSO.wordSetVar    (Prefix + ".Sort.Depart.Name",           "");
   L_MSO.wordSetVar    (Prefix + ".Sort.Depart.Service.Name",   "");
   L_MSO.wordSetVar    (Prefix + ".Post.Name",                  "");
   L_MSO.wordSetVar    (Prefix + ".Order",                      "");
   L_MSO.wordSetDateVar(Prefix + ".Order.Date",                 EMPTYOF(DATE));
  ELSE
   L_MSO.wordSetDateVar(Prefix + ".Date",                       StaffLog.Date);
   L_MSO.wordSetVar    (Prefix + ".Officer.DirtyTyp.Power",     L_Str.PoolItem(L_Staff.dtpwr_pool, DirtyTyp.Power));
   L_MSO.wordSetVar    (Prefix + ".Sort.ParentsName",           L_Staff.Sort_ParentsName());
   L_MSO.wordSetVar    (Prefix + ".Sort.ParentsName.wBrackets", "(" + L_Staff.Sort_ParentsName() + ")");
   L_MSO.wordSetVar    (Prefix + ".Sort.Name",                  Sort.Name);
   L_MSO.wordSetVar    (Prefix + ".Sort.Depart.Name",           L_Staff.getDepartName());
   L_MSO.wordSetVar    (Prefix + ".Sort.Depart.Service.Name",   L_Staff.getServiceName());
   L_MSO.wordSetVar    (Prefix + ".Post.Name",                  Post.Name);
   L_MSO.wordSetVar    (Prefix + ".Order",                      StaffLog.Order);
   L_MSO.wordSetDateVar(Prefix + ".Order.Date",                 StaffLog.OrdDate);
  END;
  L_Staff.wordSetWagePayVar(SD, Prefix + ".WagePay", forceEmpty);

  IF forceEmpty | (Post.ClsName = L_Staff.pcn_NoClasses) THEN
   L_MSO.wordSetVar    (Prefix + ".Class",                    "");
  ELSE
   L_MSO.wordSetVar    (Prefix + ".Class",                    L_Staff.GetStaffLogClass_asStr());
  END;
 END {WordSetSingleStaffLog};

 PRIVATE PROCEDURE IsUploadAlowed(TablePrintMethod: tTablePrintMethod; i, MaxLines: NUMERIC[0]): SCAL[2];
 BEGIN
  RETURN (TablePrintMethod = tpm_All)                |
         (TablePrintMethod = tpm_HandFill) & (i = 0) |
         (TablePrintMethod = tpm_Limit)    & (i < MaxLines);
 END {IsUploadAlowed};

 PRIVATE PROCEDURE PrintEmptyLinesRequired(TablePrintMethod: tTablePrintMethod): SCAL[2];
 BEGIN
  RETURN E_GetT2Form() # L_Staff.t2f_wT2_2_ActualInf;
 END {PrintEmptyLinesRequired};

 PRIVATE PROCEDURE WordSetStaffLogs(TakeOnDate, D   : DATE;
                                    Root            : STRING[];
                                    MaxLines        : NUMERIC[0];
                                    UploadInTable   : SCAL[2];
                                    TablePrintMethod: tTablePrintMethod;
                                    TableName       : STRING[];
                                    PrintEmptyLines : SCAL[2]);
  VAR
   SD: DATE;
   i : NUMERIC[0];
 BEGIN
  i:=0;
  IF TablePrintMethod # tpm_Empty THEN
   SETSEL(StaffLog, TSN, Staff.TSN);
   SRCINSEL(StaffLog, LE, , TakeOnDate);
   WHILE OCCURE(StaffLog) & IsUploadAlowed(TablePrintMethod, i, MaxLines) DO
    CONFORM(StaffLog, SLKind);
    IF ~L_Staff.IsDischargeStaffLog() & SLKind.PutInT2 THEN
     CONFORM(StaffLog, Officer);
     CONFORM(Officer, Sort);
     CONFORM(Officer, Post);
     CONFORM(Officer, WagePay);
     SD:=Math.Max(StaffLog.Date, L_Env.aptm_Start);
     HISTCONF(SD, WagePay, WagePayL);
     WordSetSingleStaffLog(i, SD, Root, 0);
     INC(i);
    END;
    NEXT(StaffLog);
   END; (* WHILE OCCURE(StaffLog) ... *)
  END;

  IF PrintEmptyLines THEN
   WHILE i < MaxLines DO
    WordSetSingleStaffLog(i, EMPTYOF(DATE), Root, 1);
    INC(i);
   END;
  END;

  IF UploadInTable THEN
   L_MSO.extSetWordTable(TableName, i, L_MSO.tt_Soft);
  END;
 END {WordSetStaffLogs};

 PRIVATE PROCEDURE WordSetSingleTrainingsInfo(D               : DATE;
                                              Root, Prefix    : STRING[];
                                              trgactvKind     : LIKE(ManActv.ActvKind);
                                              MaxLines        : NUMERIC[0];
                                              UploadInTable   : SCAL[2];
                                              TablePrintMethod: tTablePrintMethod;
                                              TableName       : STRING[]);
  VAR
   i   : NUMERIC[0];
   root: STRING[];
 BEGIN
  Root:=Root + "Man.";
  i:=0;
  IF TablePrintMethod # tpm_Empty THEN
   SELECT(ManActv, Man, , Staff.Man, trgactvKind);
   WHILE OCCURE(ManActv) & (ManActv.BegDate<=D) & IsUploadAlowed(TablePrintMethod, i, MaxLines) DO
    root:=Root + L_Str.Var_wIdx(Prefix, i);
    L_MSO.wordSetDateVar(root + ".BegDate", ManActv.BegDate);
    L_MSO.wordSetDateVar(root + ".EndDate", ManActv.EndDate);
    L_MSO.wordSetVar(root + ".EdType",      L_Str.PoolItem(L_Man.traintype_Pool, ManActv.EdType));
    L_MSO.wordSetVar(root + ".FndName",     ManActv.FndName);
    L_MSO.wordSetVar(root + ".DocType",     L_Str.PoolItem(L_Man.eddoctype_Pool, ManActv.DocType));
    L_MSO.wordSetVar(root + ".DocNum",      ManActv.DocNum);
    L_MSO.wordSetDateVar(root + ".DocDate", ManActv.DocDate);
    L_MSO.wordSetVar(root + ".Result",      ManActv.Result);
    INC(i);
    NEXT(ManActv);
   END; (* WHILE OCCURE(ManActv) ... *)
  END;

  IF PrintEmptyLinesRequired(TablePrintMethod) THEN
   WHILE i < MaxLines DO
    root:=Root + L_Str.Var_wIdx(Prefix, i);
    L_MSO.wordSetDateVar(root + ".BegDate", EMPTYOF(DATE));
    L_MSO.wordSetDateVar(root + ".EndDate", EMPTYOF(DATE));
    L_MSO.wordSetVar(root + ".EdType",      "");
    L_MSO.wordSetVar(root + ".FndName",     "");
    L_MSO.wordSetVar(root + ".DocType",     "");
    L_MSO.wordSetVar(root + ".DocNum",      "");
    L_MSO.wordSetDateVar(root + ".DocDate", EMPTYOF(DATE));
    L_MSO.wordSetVar(root + ".Result",      "");
    INC(i);
   END;
  END;

  IF UploadInTable THEN
   L_MSO.extSetWordTable(TableName, i, L_MSO.tt_Soft);
  END;
 END {WordSetSingleTrainingsInfo};

 PRIVATE PROCEDURE WordSetValidations(D: DATE; Root: STRING[]; MaxLines: NUMERIC[0]; UploadInTable: SCAL[2]; TablePrintMethod: tTablePrintMethod);
 BEGIN
  WordSetSingleTrainingsInfo(D, Root, "Validation", L_Man.actvk_Validation, MaxLines, UploadInTable, TablePrintMethod, "table4");
 END {WordSetValidations};

 PRIVATE PROCEDURE WordSetTrainings(D: DATE; Root: STRING[]; MaxLines: NUMERIC[0]; UploadInTable: SCAL[2]; TablePrintMethod: tTablePrintMethod);
 BEGIN
  WordSetSingleTrainingsInfo(D, Root, "Training", L_Man.actvk_FurtherTrain, MaxLines, UploadInTable, TablePrintMethod, "table5");
 END {WordSetTrainings};

 PRIVATE PROCEDURE WordSetRetrainings(D: DATE; Root: STRING[]; MaxLines: NUMERIC[0]; UploadInTable: SCAL[2]; TablePrintMethod: tTablePrintMethod);
 BEGIN
  WordSetSingleTrainingsInfo(D, Root, "Retraining", L_Man.actvk_Retrain, MaxLines, UploadInTable, TablePrintMethod, "table6");
 END {WordSetRetrainings};

 PRIVATE PROCEDURE WordSetRewards(D: DATE; Root: STRING[]; MaxLines: NUMERIC[0]; UploadInTable: SCAL[2]; TablePrintMethod: tTablePrintMethod);
 VAR
  i   : NUMERIC[0];
  root: STRING[];
 BEGIN
  root:="Man.";
  i:=0;
  IF TablePrintMethod # tpm_Empty THEN
   SELECT(ManExpr, Man, , Man.Man);
   WHILE OCCURE(ManExpr) & IsUploadAlowed(TablePrintMethod, i, MaxLines) DO
    IF L_Man.ExprIsStimulation(ManExpr.ExprType) | L_Man.ExprIsTribute(ManExpr.ExprType) THEN
     CONFORM(ManExpr, Expr);
     L_MSO.wordSetVar    (root + L_Str.Var_wIdx("Rewards", i),        Expr.Name);
     L_MSO.wordSetVar    (root + L_Str.Var_wIdx("RewardsDocName", i), Expr.Level);
     L_MSO.wordSetVar    (root + L_Str.Var_wIdx("RewardsDocNbr", i),  L_Man.GetManExprDocNum());
     L_MSO.wordSetDateVar(root + L_Str.Var_wIdx("RewardsDocDate", i), ManExpr.Date);
     INC(i);
    END;
    NEXT(ManExpr);
   END; (* WHILE ... *)
  END;

  IF PrintEmptyLinesRequired(TablePrintMethod) THEN
   WHILE i < MaxLines DO
    L_MSO.wordSetVar    (root + L_Str.Var_wIdx("Rewards", i),        "");
    L_MSO.wordSetVar    (root + L_Str.Var_wIdx("RewardsDocName", i), "");
    L_MSO.wordSetVar    (root + L_Str.Var_wIdx("RewardsDocNbr", i),  "");
    L_MSO.wordSetDateVar(root + L_Str.Var_wIdx("RewardsDocDate", i), EMPTYOF(DATE));
    INC(i);
   END;
  END;

  IF UploadInTable THEN
   L_MSO.extSetWordTable("table7", i, L_MSO.tt_Soft);
  END;
 END {WordSetRewards};

 PRIVATE PROCEDURE IsVacation(): SCAL[2];
 BEGIN
  CONFORM(AvePay,  AveType);
  RETURN (AveType.AveNo = L_AvePay.aveno_Hldy) & L_AvePay.AvePayHasJMode();
 END {IsVacation};

 PRIVATE PROCEDURE GetPFDateE(): DATE;
 BEGIN
  IF ~!AvePay.PFTill THEN
   RETURN AvePay.PFTill-1;
  ELSE
   RETURN AvePay.PFTill;
  END;
 END {GetPFDateE};

 PRIVATE PROCEDURE WordSetVacations(TakeOnDate, D   : DATE;
                                    Root            : STRING[];
                                    MaxLines        : NUMERIC[0];
                                    UploadInTable   : SCAL[2];
                                    TablePrintMethod: tTablePrintMethod;
                                    TableName       : STRING[];
                                    PrintEmptyLines : SCAL[2]);
  VAR
   Prefix: STRING[];
   i     : NUMERIC[0];
 BEGIN
  i:=0;
  IF TablePrintMethod # tpm_Empty THEN
   SETSEL(AvePay, TSN, Staff.TSN);
   SRCINSEL(AvePay, GE, , TakeOnDate);
   WHILE OCCURE(AvePay) & (AvePay.StartD <= D) & IsUploadAlowed(TablePrintMethod, i, MaxLines) DO
    CONFORM(AvePay, AveType);
    IF (AvePay.Status = L_AvePay.st_Estimated) & IsVacation() THEN
     Prefix:=Root + L_Str.Var_wIdx("Vacation", i);
     L_MSO.wordSetVar    (Prefix + ".Type",    AveType.Name);
     L_MSO.wordSetVar    (Prefix + ".DocNum",  AvePay.DocNum);
     L_MSO.wordSetDateVar(Prefix + ".DocDate", AvePay.DocDate);
     L_MSO.wordSetDateVar(Prefix + ".PFFrom",  AvePay.PFFrom);
     L_MSO.wordSetDateVar(Prefix + ".PFTill",  GetPFDateE());
     L_MSO.wordSetVar    (Prefix + ".Amount",  FLDTOSTR(AvePay.Amount, "0"));
     L_MSO.wordSetDateVar(Prefix + ".StartD",  AvePay.StartD);
     L_MSO.wordSetDateVar(Prefix + ".StopD",   AvePay.StopD);
     INC(i);
    END;
    NEXT(AvePay);
   END; (* WHILE OCCURE(AvePay) ... *)
  END;

  IF PrintEmptyLines THEN
   WHILE i < MaxLines DO
    Prefix:=Root + L_Str.Var_wIdx("Vacation", i);
    L_MSO.wordSetVar    (Prefix + ".Type",    "");
    L_MSO.wordSetDateVar(Prefix + ".PFFrom",  EMPTYOF(DATE));
    L_MSO.wordSetVar    (Prefix + ".DocNum",  "");
    L_MSO.wordSetDateVar(Prefix + ".DocDate", EMPTYOF(DATE));
    L_MSO.wordSetVar    (Prefix + ".PFTill",  "");
    L_MSO.wordSetVar    (Prefix + ".Amount",  "");
    L_MSO.wordSetDateVar(Prefix + ".StartD",  EMPTYOF(DATE));
    L_MSO.wordSetDateVar(Prefix + ".StopD",   EMPTYOF(DATE));
    INC(i);
   END;
  END;

  IF UploadInTable THEN
   L_MSO.extSetWordTable(TableName, i, L_MSO.tt_Soft);
  END;
 END {WordSetVacations};

 PRIVATE PROCEDURE WordSetSinglePrivilege(D   : DATE;
                                          Root: STRING[];
                                          Prop: LIKE(Property.Property);
                                          Idx : NUMERIC[0]): SCAL[2];
  VAR
   Name,
   Prefix: STRING[];
 BEGIN
  IF !Prop | P_Man.HasActualManPro(Man.Man, D, Prop) THEN
   Prefix:=Root + "Privilege" + L_MSO.IndexStr(Idx) + ".";
   IF    !Prop THEN
    SETEMPTY(Name);
   ELSIF Prop = P_Man.P_Invalid THEN
    Name:=" " + ManPro.Value + " 㯯";
   ELSIF Prop = P_Man.P_Pension THEN
    Name:="ᨮ " + Str.Small(ManPro.Value);
   ELSE
    CONFORM(ManPro, Property);
    Name:=Property.Name;
   END;
   L_MSO.wordSetVar(Prefix + "Name", Name);
   L_MSO.wordSetVarsByFile_wPrefixE("ManPro", Prefix, !Prop);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {WordSetSinglePrivilege};

 PRIVATE PROCEDURE WordSetPrivileges(D: DATE; Root: STRING[]; MaxLines: NUMERIC[0]; UploadInTable: SCAL[2]; TablePrintMethod: tTablePrintMethod);
  VAR
   i, j      : NUMERIC[0];
   Dummy     : SCAL[2];
   Privileges: LIKE(Property.Property)[10];
 BEGIN
  Root:=Root + "Man.";
  SETZERO(i, j);
  IF TablePrintMethod # tpm_Empty THEN
   SETEMPTY(Privileges);
   Privileges[0]:=P_Man.P_BattleActionVeteran;
   Privileges[1]:=P_Man.P_Chernobil;
   Privileges[2]:=P_Man.P_VeteranOfWork;
   Privileges[3]:=P_Man.P_LeningradBlockade;
   Privileges[4]:=P_Man.P_WorkFront;
   Privileges[5]:=P_Man.P_Invalid;
   Privileges[6]:=P_Man.P_Pension;
   Privileges[7]:=P_Man.P_MemberGPW;
 
   WHILE (j <= HIGH(Privileges)) & ~!Privileges[j] & IsUploadAlowed(TablePrintMethod, i, MaxLines) DO
    IF WordSetSinglePrivilege(D, Root, Privileges[j], i) THEN
     INC(i);
    END;
    INC(j);
   END; (* WHILE (j <= HIGH(Privileges)) &...*)
  END;

  IF PrintEmptyLinesRequired(TablePrintMethod) THEN
   WHILE i < MaxLines DO
    Dummy:=WordSetSinglePrivilege(D, Root, EMPTYOF(Property.Property), i);
    INC(i);
   END; (* WHILE i < MaxLines...*)
  END;

  IF UploadInTable THEN
   L_MSO.extSetWordTable("table9", i, L_MSO.tt_Soft);
  END;
 END {WordSetPrivileges};

 PRIVATE PROCEDURE GetStaffEndDate(): DATE;
  VAR
   Result: DATE;
 BEGIN
  SETEMPTY(Result);
  L_Staff.PosToStaffLog(Staff.TSN, Memo.ud_cd(), 0);
  WHILE !Result & OCCURE(StaffLog) DO
   IF L_Staff.IsDischargeStaffLog() |
      (L_Staff.GetStaffLogType() = L_Staff.slkt_TakeOnWithDischarge) THEN
    Result:=StaffLog.Date;
   END; (* IF L_Staff.IsDischargeStaffLog() *)
   NEXT(StaffLog);
  END; (* WHILE *)
  RETURN Result;
 END {GetStaffEndDate};

 PRIVATE PROCEDURE T2(D: DATE; Root: STRING[]);
  VAR
   TakeOnDate,
   StaffEndDate: DATE;
 BEGIN
  Set_DocCause(D);

  SELECT(StaffLog, TSN, , Staff.TSN);
  L_MSO.wordSetVar(Root + "Man.FmlState.OKIN",    L_Man.GetManFmlStateAsOKIN());
  L_MSO.wordSetVar(Root + "Man.Citizenship.OKIN", L_Man.GetManCitizenshipAsOKIN());
  L_Man.wordSetAddresses(Root + "Man.", Man.Man, D);
  WordSetLanguageAttr(Root);
  WordSetEducation_Part1(Root);
  WordSetEducation_Part2(Root);
  WordSetAllStages(Root);
  WordSetMilitaryInfo(Memo.ud_cd(), Root);
  WordSetAppInf(Root);
  IF ~!Root THEN
   L_MSO.wordSetDateVar("MakeDate", D);    
   L_Staff.PutPhoto(SYSDATE());
  ELSE
   L_Man.wordSetAddresses("Man", Man.Man, D);
  END;

  IF IsT2DefaultForm(E_GetT2Form()) THEN
   TakeOnDate:=GetTakeOnDate(D);
   WordSetFamily(               D, Root, 7);
   WordSetStaffLogs(TakeOnDate, D, Root, 12, 0, tpm_HandFill, "table3", PrintEmptyLinesRequired(tpm_HandFill));
   WordSetValidations(          D, Root, 4,  0, tpm_Limit);
   WordSetTrainings(            D, Root, 3,  0, tpm_Limit);
   WordSetRetrainings(          D, Root, 4,  0, tpm_Limit);
   WordSetRewards(              D, Root, 4,  0, tpm_Limit);
   WordSetVacations(TakeOnDate, D, Root, 10, 0, tpm_Empty, "table8", PrintEmptyLinesRequired(tpm_Empty));
   WordSetPrivileges(           D, Root, 3,  0, tpm_Limit);
  ELSE
   WordSetFamily(               D, Root, 6);
  END;

  SETEMPTY(StaffEndDate);
  IF E_GetT2Form() = L_Staff.t2f_wT2_2_ActualInf THEN
   StaffEndDate:=GetStaffEndDate();
  END;
  Root:=Root + "Staff.DischargeStafflog";
  IF ~!StaffEndDate THEN
   SEARCH(StaffLog, TSN, , Staff.TSN, StaffEndDate);
   StaffEndDate:=StaffEndDate - 1;
   L_MSO.wordSetVar(Root + ".SLKind.Reason", L_Staff.GetSLKindReason());
  ELSE
   L_MSO.wordSetVar(Root + ".SLKind.Reason", "");
  END;
  L_MSO.wordSetDateVar(Root + ".EndDate", StaffEndDate);
  L_MSO.wordSetVarsByFile_wAliasE("StaffLog", Root,           !StaffEndDate);
  L_MSO.wordSetVarsByFile_wAliasE("SLKind", Root + ".SLKind", !StaffEndDate);
 END {T2};

 PRIVATE PROCEDURE intT2_2(D: DATE; Root: STRING[]; TablePrintMethod: tTablePrintMethod);
  VAR
   TakeOnDate         : DATE;
   tmpTablePrintMethod: tTablePrintMethod;
 BEGIN
  IF ~!Root THEN
   L_MSO.wordSetDateVar("MakeDate", D);
   IF TablePrintMethod = tpm_Empty THEN
    L_MSO.wordSetVar("TheDoc.Number",                   "_____");
   ELSE
    L_MSO.wordSetVar("TheDoc.Number",                   "1");
   END;
   TakeOnDate:=GetTakeOnDate(D);
   WordSetStaffLogs(TakeOnDate, D, Root, 12, 1, TablePrintMethod, "table3", PrintEmptyLinesRequired(TablePrintMethod));
   tmpTablePrintMethod:=TablePrintMethod;
   IF TablePrintMethod # tpm_Empty THEN
    tmpTablePrintMethod:=tpm_All;
   END;
   WordSetValidations(          D, Root, 5,  1, tmpTablePrintMethod);
   WordSetTrainings(            D, Root, 6,  1, tmpTablePrintMethod);
   WordSetRetrainings(          D, Root, 4,  1, tmpTablePrintMethod);
   WordSetRewards(              D, Root, 8,  1, tmpTablePrintMethod);
   tmpTablePrintMethod:=TablePrintMethod;
   IF TablePrintMethod = tpm_HandFill THEN
    tmpTablePrintMethod:=tpm_Empty;
   END;
   WordSetVacations(TakeOnDate, D, Root, 23, 1, tmpTablePrintMethod, "table8", PrintEmptyLinesRequired(tmpTablePrintMethod));
   WordSetPrivileges(           D, Root, 3,  1, tmpTablePrintMethod);
  END;
 END {intT2_2};

 PRIVATE PROCEDURE T2_2(D: DATE; Root: STRING[]);
  VAR
   T2Form          : L_Staff.tT2Form;
   TablePrintMethod: tTablePrintMethod;
 BEGIN
  T2Form:=E_GetT2Form();
  IF    IsT2DefaultForm(T2Form) THEN
   TablePrintMethod:=tpm_Empty;
  ELSIF T2Form = L_Staff.t2f_wT2_2_BeganInf THEN
   TablePrintMethod:=tpm_HandFill;
  ELSIF T2Form = L_Staff.t2f_wT2_2_ActualInf THEN
   TablePrintMethod:=tpm_All;
  ELSE
   L_General.CallUs(0);
  END;
  intT2_2(D, Root, TablePrintMethod);
 END {T2_2};

 PRIVATE PROCEDURE T2_2_Empty(D: DATE; Root: STRING[]);
 BEGIN
  intT2_2(D, Root, tpm_Empty);
 END {T2_2_Empty};

 PRIVATE PROCEDURE T54A_WordSetSingleOrder(i         : NUMERIC[0];
                                           Root      : STRING[];
                                           forceEmpty: SCAL[2]);
  VAR
   trgDate    : DATE;
   trgPay     : NUMERIC[2];
   Prefix,
   trgDTPower,
   trgSortName,
   trgPostName: STRING[];
 BEGIN
  Prefix:=Root + L_Str.Var_wIdx("Order", i);
  L_MSO.wordSetVarsByFile_wAliasAndIndexE("_StfO",  Root+"Order", i, forceEmpty);

  SETEMPTY(trgSortName, trgPostName, trgDTPower, trgPay);
  IF forceEmpty THEN
   trgDate:=Memo.ud_cd();
  ELSE
   trgDate:=_StfO.Date;
   trgPay :=_StfO.Pay;
   IF ~!_StfO.Sort THEN
    SEARCH(Sort, Sort, , _StfO.Sort);
    SEARCH(Post, Post, , _StfO.Post);

    trgSortName:=Sort.Name + " (" + L_Staff.Sort_ParentsName() + ")";
    trgPostName:=Post.Name;
    trgDTPower :=L_Str.PoolItem(L_Staff.dtpwr_pool, _StfO.DTPower);
   END;
  END;

  L_MSO.wordSetMoneyVar(Prefix+".Pay", trgDate, trgPay);
  L_MSO.wordSetVar(Prefix+".SortName", trgSortName);
  L_MSO.wordSetVar(Prefix+".PostName", trgPostName);
  L_MSO.wordSetVar(Prefix+".DTPower",  trgDTPower);
 END {T54A_WordSetSingleOrder};

 PRIVATE PROCEDURE T54A_GetPay(D: DATE): NUMERIC[2];
 BEGIN
  IF L_PRoll.E_UsePersMPay(D) & (L_PRoll.GetPersAddValue(D) # 0) THEN
   RETURN Adding.Value;
  ELSE
   RETURN WagePayL.Pay[StaffLog.Class];
  END;
 END {T54A_GetPay};

 PRIVATE PROCEDURE T54A_WordSetOrders(BegPer, EndPer: DATE; Root: STRING[]);
  CONST
   MaxLines = 10;
  VAR
   i          : NUMERIC[0];
   D          : DATE;
   prvPay     : NUMERIC[2];
   prvSort    : LIKE(Sort.Sort);
   prvPost    : LIKE(Post.Post);
   prvDTPower : LIKE(DirtyTyp.Power);
   prvIsDschrg: SCAL[2];
 BEGIN
  L_AFM.MakeMultipleIndex("_StfO", "Date    : DATE;" +
                                   "DateE   : DATE;" +
                                   "IsDschrg: SCAL[2];" +
                                   "Order   : STRING[32];" +
                                   "Sort    : LIKE(Sort.Sort);" +
                                   "Post    : LIKE(Post.Post);" +
                                   "DTPower : LIKE(DirtyTyp.Power);" +
                                   "Pay     : NUMERIC[2]",
                          "_StfO:Date");

  SELECT(StaffLog, TSN, , Staff.TSN);
  WHILE OCCURE(StaffLog) DO
   IF L_Staff.OrderInIntvl(BegPer, EndPer) THEN
    D:=Math.Max(StaffLog.Date, BegPer);
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, WagePay);
    HISTCONF(D, WagePay, WagePayL);
    L_PRoll.AccessWagePayL(D);
    SEARCH(DirtyTyp, DirtyTyp, , P_Officer.GetP_LCDirtyTyp(Officer.Sort, Officer.Officer, D));
    _StfO.Date    :=StaffLog.Date;
    _StfO.DateE   :=StaffLog.DateE;
    _StfO.IsDschrg:=L_Staff.IsDischargeStaffLog();
    _StfO.Order   :=StaffLog.Order;
    IF _StfO.IsDschrg THEN
    _StfO.Order   :=_StfO.Order + " ()";
    END;
    _StfO.Pay     :=T54A_GetPay(D);
    _StfO.Sort    :=Officer.Sort;
    _StfO.Post    :=Officer.Post;
    _StfO.DTPower :=DirtyTyp.Power;
    INSERT(_StfO);
   END;
   NEXT(StaffLog);
  END; (* WHILE OCCURE(StaffLog) ... *)

  D:=BegPer;
  WHILE D <= EndPer DO
   IF ~SEARCH(_StfO, _StfO, D) THEN
    HISTCONF(D, Staff, StaffLog);
    IF OCCURE(StaffLog) THEN
     IF ~L_Staff.IsDischargeStaffLog() THEN
      CONFORM(StaffLog, Officer);
      CONFORM(Officer, WagePay);
      HISTCONF(D, WagePay, WagePayL);
      L_PRoll.AccessWagePayL(D);
      SEARCH(DirtyTyp, DirtyTyp, , P_Officer.GetP_LCDirtyTyp(Officer.Sort, Officer.Officer, D));

      _StfO.Date    :=D;
      _StfO.Order   :=" ⠢";
      _StfO.IsDschrg:=0;
      _StfO.Pay     :=T54A_GetPay(D);
      _StfO.Sort    :=Officer.Sort;
      _StfO.Post    :=Officer.Post;
      _StfO.DTPower :=DirtyTyp.Power;
      SETEMPTY(_StfO.DateE);
      INSERT(_StfO);
     END;
    END;
   END;
   D:=L_DatTim.IncMonth(D, +1);
  END;

  SETEMPTY(prvPay, prvSort, prvPost, prvDTPower, prvIsDschrg);
  i:=0;
  SELECT(_StfO, _StfO);
  WHILE OCCURE(_StfO) & IsUploadAlowed(tpm_All, i, MaxLines) DO
   IF (_StfO.Sort # prvSort) | (_StfO.Post # prvPost) | (_StfO.DTPower # prvDTPower) | (_StfO.IsDschrg # prvIsDschrg) | (_StfO.Pay # prvPay) THEN
    T54A_WordSetSingleOrder(i, Root, 0);
    prvSort    :=_StfO.Sort;
    prvPost    :=_StfO.Post;
    prvDTPower :=_StfO.DTPower;
    prvIsDschrg:=_StfO.IsDschrg;
    prvPay     :=_StfO.Pay;
    INC(i);
   END;
   NEXT(_StfO);
  END; (* WHILE OCCURE(_StfO) ... *)

  WHILE i < MaxLines DO
   T54A_WordSetSingleOrder(i, Root, 1);
   INC(i);
  END;

  L_MSO.extSetWordTable("Orders", i, L_MSO.tt_Soft);
 END {T54A_WordSetOrders};

 PRIVATE PROCEDURE T54A_GetTotNetDb(trgDedNbr: LIKE(Deduct.DedNbr); BegPer, EndPer: DATE): NUMERIC[2];
  VAR
   Result: NUMERIC[2];
 BEGIN
  SETZERO(Result);
  SETSEL(DedAcnt, TSN, Staff.TSN, trgDedNbr);
  SRCINSEL(DedAcnt, GE, , BegPer);
  WHILE OCCURE(DedAcnt) & (DedAcnt.Period <= EndPer) DO
   INC(Result, L_General.Denominate(BegPer, EndPer, DedAcnt.NetDebt));
   NEXT(DedAcnt);
  END; (* WHILE OCCURE(DedAcnt) ... *)
  RETURN Result;
 END {T54A_GetTotNetDb};

 PRIVATE PROCEDURE T54A(D: DATE; Root: STRING[]);
  VAR
   BegPer,
   EndPer,
   LeaveDate     : DATE;
   r,
   trgToPayStr   : STRING[];
   i,
   ChildrenAmount: NUMERIC[0];
   Dummy,
   TotNetDebt  : NUMERIC[2];
   trgBegPer,
   trgEndPer  : DATE;
 BEGIN
  IF ~!Root THEN
   Set_DocCause(D);
   BegPer:=L_DatTim.YearBeg(Memo.ud_cd());
   EndPer:=Memo.ud_cd();
   SETZERO(ChildrenAmount);
   SELECT(ManFml, Man, , Staff.Man);
   WHILE OCCURE(ManFml) DO
    IF (ManFml.Member = L_Man.fm_Child) & (L_DatTim.CompleteYearsInIntvl(ManFml.Birth, EndPer) < 18) THEN
     INC(ChildrenAmount);
    END;
    NEXT(ManFml);
   END; (* WHILE OCCURE(ManFml) ... *)
   L_MSO.wordSetVar("Man.ChildrenAmount", L_Str.IntStr(ChildrenAmount));
 
   IF L_Staff.rInState(Memo.ud_cd()) THEN
    SETEMPTY(LeaveDate);
   ELSE
    LeaveDate:=L_Man.GetRealEndDate(EndPer);
   END;
   L_MSO.wordSetDateVar("Staff.TakenOnDate", GetTakeOnDate(D));
   L_MSO.wordSetDateVar("Staff.LeaveDate",   LeaveDate);
 
   T54A_WordSetOrders(BegPer, EndPer, Root);
   WordSetVacations(BegPer, EndPer, Root, 10, 1, tpm_All, "Vacation", 0);
 
   L_Tax.Tax_InitValues(EndPer);
   Dummy:=L_Tax.Tax2001_GetOverTax(BegPer, EndPer, 0); (* Man_TotInc  Estimate*)

   SETZERO(i);
   SELECT(_MnTA, _MnTA, , Man.Man, L_Tax.Tax2001_mt_StD);
   WHILE OCCURE(_MnTA) DO
    L_Tax.Tax_AccessManTA_by_MnTA();
    PROMPT("⠭  : " + ManTA.TaxInq);
    CONFORM(ManTA, TaxAdv);

    L_MSO.wordSetVarsByFile_wAliasAndIndexE("ManTA",  Root+"ManTA", i, 0);
    L_MSO.wordSetVarsByFile_wIndexedPrefixE("TaxAdv", Root+"ManTA", i, 0);
    L_MSO.wordSetMoneyVar(Root+"ManTA"+L_MSO.IndexStr(i)+".TotalSum", D, L_Tax.GetTAValue(EndPer, 0));
    INC(i);

    NEXT(_MnTA);
   END; (* WHILE OCCURE(_MnTA) ... *)
   L_MSO.extSetWordTable("ManTA_Std", i, L_MSO.tt_Soft);
   L_Tax.Tax_FreeValues(BegPer);

   L_AFM.MakeIndex("_DedAcnt", "DedNbr  : LIKE(Deduct.DedNbr);" +
                               "MCode   : LIKE(MCList.MCode);" +
                               "ToPayStr: STRING[32];" +
                               "Period  : DATE");

   SELECT(Deduct, TSN, , Staff.TSN);
   WHILE OCCURE(Deduct) DO
    PROMPT("ঠ: " + Deduct.MCode);
    IF Deduct.DedType # L_PDoc.SPC_DEDTYPE THEN
     IF L_DatTim.IsActiveInIntvl_Inc(BegPer, EndPer, Deduct.BegDate, Deduct.EndDate) THEN
      CONFORM(Deduct, DedType);
      SETSEL(DedAcnt, TSN, Deduct.TSN, Deduct.DedNbr);
      SRCINSEL(DedAcnt, GE, , BegPer);
      WHILE OCCURE(DedAcnt) & (DedAcnt.Period<= EndPer) DO
       IF DedType.BaseNo > L_PRoll.dtbn_Sum THEN
        trgToPayStr:=FLDTOSTR(DedAcnt.ToPay, "2.") + "%";
       ELSE
        trgToPayStr:=L_Money.MoneyToStr(D, "", DedAcnt.ToPay) + " .";
       END;

       ADD(_DedAcnt, _DedAcnt, , Deduct.DedNbr, Deduct.MCode, trgToPayStr, DedAcnt.Period);

       NEXT(DedAcnt);
      END; (* WHILE OCCURE(DedAcnt) ... *)
     END;
    END;
    NEXT(Deduct);
   END; (* WHILE OCCURE(Deduct) ... *)

   SETZERO(i);
   SELECT(_DedAcnt, _DedAcnt);
   WHILE OCCURE(_DedAcnt) DO
    NARROWSEL(_DedAcnt, DedNbr, MCode, ToPayStr);
    SEARCH(Deduct, TSN, , Staff.TSN, _DedAcnt.DedNbr);
    CONFORM(Deduct, MCList);

    trgToPayStr:=_DedAcnt.ToPayStr;
    trgBegPer  :=_DedAcnt.Period;
    WHILE OCCURE(_DedAcnt) DO
     trgEndPer:=_DedAcnt.Period;
     LOOP
      NEXT(_DedAcnt);
      IF ~OCCURE(_DedAcnt) | (L_DatTim.IncMonth(trgEndPer, +1) # _DedAcnt.Period) THEN
       EXIT;
      END;
      trgEndPer:=_DedAcnt.Period;
     END; (* LOOP *)
     trgEndPer:=L_DatTim.MinDATE(Deduct.EndDate, trgEndPer);
     TotNetDebt :=T54A_GetTotNetDb(Deduct.DedNbr, trgBegPer, trgEndPer);
     IF TotNetDebt # 0 THEN
      r:=Root+"Deduct"+L_MSO.IndexStr(i)+".";
      L_MSO.wordSetVar     (r + "Deduct.Name",  MCList.Name);
      L_MSO.wordSetDateVar (r + "BegPer",       trgBegPer);
      L_MSO.wordSetDateVar (r + "EndPer",       trgEndPer);
      L_MSO.wordSetVar     (r + "ToPay.AsStr",  trgToPayStr);
      L_MSO.wordSetMoneyVar(r + "TotalSum", D,  TotNetDebt);
      INC(i);
     END;
    END; (* WHILE OCCURE(_DedAcnt) ... *)

    NEXTINEXTENDEDSEL(_DedAcnt, DedNbr, MCode, ToPayStr);
   END; (* WHILE OCCURE(_DedAcnt) ... *)

   L_MSO.extSetWordTable("Deduct", i, L_MSO.tt_Soft);
 
   L_MSO.wordSetDateVar("TheDoc.From", BegPer);
   L_MSO.wordSetDateVar("TheDoc.UpTo", EndPer);
  END;
 END {T54A};

 PRIVATE PROCEDURE T5(D: DATE; Root: STRING[]);
  VAR
   _Sort   : LIKE(Officer.Sort);
   _Officer: LIKE(Officer.Officer);
   Local   : PROC;
 BEGIN
  L_Staff.PosToStaffLog(Staff.TSN, D, 0);
  L_General.Assert((L_Staff.GetStaffLogType() = L_Staff.slkt_Move) |
                   (L_Staff.GetStaffLogType() = L_Staff.slkt_Prolongation),
                   " ⮩ 樨 ⥪饩     ॢ  த ");
  _Sort   :=StaffLog.Sort;
  _Officer:=StaffLog.Officer;
  L_General.CallUs(PREV(StaffLog));
  Set_DocCause(D);
  IF !Root THEN
   L_Staff.StaffFileFamily(D, StaffLog.Date, "oStaff");
  ELSE
   L_Staff.StaffFileFamily(D, StaffLog.Date, Root + "Prv");
   L_MSO.wordSetVar("E_T5_ExtraFooter", E_T5_ExtraFooter(D));
   L_Staff.Set_AsLeaderVars(D, E_asLeaderForTwoOfficerOrder(D, _Sort, _Officer, StaffLog.Sort, StaffLog.Officer));
   Local:=PROCREF(E_Staff.JobCCXX_GetExtraFeatures);
   IF ~!Local THEN
    Local(Root, D);
   END;
  END;
 END {T5};

 PRIVATE PROCEDURE T8(D: DATE; Root: STRING[]);
  VAR
   prvLbCNbr : LIKE(StaffLog.LbCNbr);
   prvLbCDate: LIKE(StaffLog.LbCDate);
   prvKindOfWork: STRING[];
 BEGIN
  IF ~!Root THEN
   Set_DocCause(D);
   L_MSO.wordSetDateVar(Root + "EndDate",       StaffLog.Date - 1);
   Root:=Root + "StaffLog";
   IF    L_Staff.GetStaffLogType() = L_Staff.slkt_TakeOnWithDischarge THEN
    L_MSO.wordSetVar(Root + ".Order",    StaffLog.dOrder);
    L_MSO.wordSetVar(Root + ".OrdDate",  L_DatTim.DateStr(StaffLog.dOrdDate));
    L_MSO.wordSetVar(Root + ".OrdCsAtr", StaffLog.dOrdCsAtr);
    SEARCH(SLKind, SLKind, , SLKind.dSLKind);
    L_MSO.wordSetVarsByFile_wPrefixE("SLKind", "Staff.StaffLog.", ~OCCURE(SLKind));
    L_MSO.wordSetVar("Staff.StaffLog.SLKind.Reason", L_Staff.GetSLKindReason());
   END;
   L_Staff.PosToStaffLog(Staff.TSN, StaffLog.Date - 1, 1);
   L_Staff.GetLabourContractAttr(StaffLog.Date, prvLbCNbr, prvLbCDate, prvKindOfWork);
   L_MSO.wordSetVar    (Root + ".LabourContract.Nbr",  prvLbCNbr);
   L_MSO.wordSetDateVar(Root + ".LabourContract.Date", prvLbCDate);
   L_MSO.wordSetVar    (Root + ".Officer.KindOfWork",  prvKindOfWork);
   L_MSO.wordSetVar    ("E_T8_ExtraFooter",            E_T8_ExtraFooter(D));
   L_Staff.Set_AsLeaderVars(D, E_asLeaderForBegun(D));
  END;
 END {T8};

 PRIVATE PROCEDURE RoundLst(D: DATE; Root: STRING[]);
  VAR
   i            : NUMERIC[0];
   Local        : PROC;
   Signatures   : STRING[][20];
   trgLbCNbr    : LIKE(StaffLog.LbCNbr);
   trgLbCDate   : LIKE(StaffLog.LbCDate);
   root,
   trgKindOfWork: STRING[];
 BEGIN
  IF ~!Root THEN
   IF DischargeOnlyRoundLsPrint() | ~L_Staff.rInState(D) THEN
    T8(D, Root);
   ELSE
    root:=Root + "StaffLog";
    L_MSO.wordSetVar(root + ".Order",    "");
    L_MSO.wordSetVar(root + ".OrdDate",  "");
    L_MSO.wordSetVar(root + ".OrdCsAtr", "");
    L_Staff.GetLabourContractAttr(D, trgLbCNbr, trgLbCDate, trgKindOfWork);
    L_MSO.wordSetVar    (root + ".LabourContract.Nbr",  trgLbCNbr);
    L_MSO.wordSetDateVar(root + ".LabourContract.Date", trgLbCDate);
    L_MSO.wordSetVar    (root + ".Officer.KindOfWork",  trgKindOfWork);
   END;

   L_MSO.wordSetDateVar(Root + "TakeOnDate", L_Man.GetTakeOnDate(D-1));
   SETEMPTY(Signatures);
   Local:=PROCREF(E_Staff.RoundLst_SignList);
   IF ~!Local THEN
    Local(D, Signatures);
   ELSE
    Signatures[0]:="⤥ ஢";
    Signatures[1]:="壠";
    Signatures[2]:="⤥ ଠ樮 孮";
   END;
   SETZERO(i);
   WHILE (i <= HIGH(Signatures)) & ~!Signatures[i] DO
    L_MSO.wordSetVar("Signature" + L_MSO.IndexStr(i), Signatures[i]);
    INC(i);
   END; (* WHILE i <= HIGH(Signatures) &...*)
   L_MSO.extSetWordTable("Signatures", i, L_MSO.tt_Soft);
  END;
 END {RoundLst};

 PRIVATE PROCEDURE AddWorkPer(_DateE: DATE; Idx: NUMERIC[0]; Alias: STRING[]; ForceEmpty: SCAL[2]);
 BEGIN
  L_MSO.wordSetVarsByFile_wIndexedPrefixE("StaffLog", Alias, Idx, ForceEmpty);
  L_MSO.wordSetVarsByFile_wIndexedPrefixE("PnsAttr",  Alias, Idx, ForceEmpty);
  IF ForceEmpty THEN
   L_MSO.wordSetDateVar(Alias + L_MSO.IndexStr(Idx) + ".DateE", EMPTYOF(DATE));
  ELSE
   L_MSO.wordSetDateVar(Alias + L_MSO.IndexStr(Idx) + ".DateE", _DateE);
  END;
 END {AddWorkPer};

 PRIVATE PROCEDURE Ref_Gnrl(D: DATE; Root: STRING[]);
 BEGIN
  L_Man.StandOnLastBegan(Staff.TSN, D);
  L_MSO.wordSetVarsByFile_wPrefixE("StaffLog", Root+"LastBegan.", 0);
  LAST(StaffLog);
  L_MSO.wordSetVarsByFile_wPrefixE("StaffLog", Root + "Discharge.", ~L_Staff.IsDischargeStaffLog());
  IF ~!Root THEN
   L_MSO.wordSetVar("OwnFirm.FondPns", P_MyFirm.NumInPFR(L_Staff.GetStaffMyFirm(), D));
   L_Staff.SetTheDocSignerVars(D,
                               P_MyFirm.GetTSNByMFPro(L_Staff.GetStaffMyFirm(), D, P_MyFirm.P_StaffDepChief, 1),
                               PROCREF(E_Staff.Ref_GnrlSigner));
  END;
 END {Ref_Gnrl};

 PRIVATE PROCEDURE Rfrnc01(D: DATE; Root: STRING[]);
  VAR
   local    : PROC;
   SignerTSN: LIKE(Staff.TSN);
 BEGIN
  L_Man.StandOnLastBegan(Staff.TSN, D);
  L_MSO.wordSetVarsByFile_wPrefixE("StaffLog", Root+"LastBegan.", 0);
  LAST(StaffLog);
  L_MSO.wordSetVarsByFile_wPrefixE("StaffLog", Root + "Discharge.", ~L_Staff.IsDischargeStaffLog());
  IF ~!Root THEN
   L_MSO.wordSetVar("OwnFirm.FondPns", P_MyFirm.NumInPFR(L_Staff.GetStaffMyFirm(), D));
   L_Staff.SetTheDocSignerVars(D,
                               P_MyFirm.GetTSNByMFPro(L_Staff.GetStaffMyFirm(), D, P_MyFirm.P_StaffDepChief, 1),
                               PROCREF(E_Staff.Rfrnc01Signer));
  END;
 END {Rfrnc01};

 PRIVATE PROCEDURE SalAve(D: DATE; Root: STRING[]);
  CONST
   MonthsMax = 12;
  VAR
   SumM    : LIKE(Money.Sum)[MonthsMax];
   BegMonth,
   NxtMonth,
   FstMonth,
   LstMonth: DATE;
   Count   : NUMERIC[0];
   avgSum  : LIKE(Money.Sum);
   NameSum,
   NamMonth: STRING[];
 BEGIN
  IF ~!Root THEN
   FstMonth:=L_DatTim.Per(Memo.ud_fr());
   LstMonth:=L_DatTim.Per(Memo.ud_ut());
   BegMonth:=L_DatTim.Per(L_Man.GetTakeOnDate(Memo.ud_ut()));
   IF    BegMonth > LstMonth THEN
    L_General.Error(" ﭨ  " + L_DatTim.PeriodStr(LstMonth) + " ࠡ⭨   ਭ.");
   ELSIF BegMonth > FstMonth THEN
    FstMonth:=BegMonth;
    L_StdFrm.Choice("⭨ ਭ  " + L_DatTim.PeriodStr(FstMonth) +
                    ".||⮢ ࠢ  ਮ " +
                    L_DatTim.PeriodStr(FstMonth) +"-"+ L_DatTim.PeriodStr(LstMonth) + "?");
   END;
   L_General.Assert(L_DatTim.MonthsInIntvl(FstMonth, L_DatTim.MonthEnd(LstMonth)) <= MonthsMax,
                    "ਮ ॢ蠥 " + L_Str.IntStr(MonthsMax) + " 楢");

   SETZERO(SumM);
   SAVE(Staff);
   SELECT(Staff, MyFirm, , Staff.MyFirm, Staff.Man);
   WHILE OCCURE(Staff) DO
    SETSEL(Money, TSN, Staff.TSN);
    SRCINSEL(Money, GE, , FstMonth);
    WHILE OCCURE(Money) & (Money.Closed <= LstMonth) DO
     PROMPT(L_DatTim.PeriodStr(Money.Closed));
     NARROWSEL(Money, Closed);
     L_General.Assert(L_APtm.MonthIsClosed(Money.Closed, L_APtm.system_Salary) |
                      L_PRoll.IsShtD_AP(Money.Closed),
                      " ⠭  " + L_DatTim.PeriodStr(Money.Closed));
     Count:=L_DatTim.MonthsInIntvl(FstMonth, L_DatTim.MonthEnd(Money.Closed))-1;
     WHILE OCCURE(Money) DO
      CONFORM(Money, MCList);
      IF (MCList.MCTyp = 0) & (MCList.ForDed[0] > 0) THEN
       INC(SumM[Count], L_General.Denominate(Money.Closed, D, Money.Sum));
      END;
      NEXT(Money);
     END;
     NEXTINEXTENDEDSEL(Money, Closed);
    END; (* WHILE OCCURE(Money)... *)
    NEXT(Staff);
   END;
   RESTORE(Staff);
  
   SETZERO(avgSum, Count);
   NxtMonth:=FstMonth;
   WHILE Count < MonthsMax DO
    IF NxtMonth <= LstMonth THEN
     NameSum :=L_Money.MoneyToStr(L_DatTim.Per(D), "", SumM[Count]);
     NamMonth:=FLDTOSTR(NxtMonth, "N.y", 0);
    ELSE
     NameSum :="X";
     NamMonth:="X";
    END;
    L_MSO.wordSetVar("NamMonth[" + L_Str.IntStr(Count) + "]", NamMonth);
    L_MSO.wordSetVar("NamSum[" + L_Str.IntStr(Count) + "]",  NameSum);
    INC(avgSum, SumM[Count]);
    INC(Count);
    NxtMonth:=L_DatTim.IncMonth(NxtMonth, 1);
   END;
   avgSum:=L_Math.ROUND(avgSum / L_DatTim.MonthsInIntvl(FstMonth,
                                                        L_DatTim.MonthEnd(LstMonth)), 0.01);

   L_MSO.wordSetVarsByFile("Staff");
   L_MSO.wordSetVarsByFile("Man");
   L_MSO.wordSetVar("BegPer", L_DatTim.PeriodStr(FstMonth));
   L_MSO.wordSetVar("EndPer", L_DatTim.PeriodStr(LstMonth));
   L_MSO.wordSetMoneyVar("AverageSum", D, avgSum);
   P_Firm.SetFirmDefaultData("Own", L_Staff.GetFirmOfStaff(), D, "");
   L_Staff.PosToStaffLog(Staff.TSN, D, 1);
   CONFORM(StaffLog, Post);
   L_MSO.wordSetVarsByFile("Post");
  END;  (* IF ~!Root ... *)
 END {SalAve};

 PRIVATE PROCEDURE PF_Adr(D: DATE; Root: STRING[]);
 BEGIN
  L_Staff.WordSetManName(Root);
  IF !Root THEN
   L_Man.wordSetAddresses("Man", Man.Man, D);
  ELSE
   L_Man.wordSetAddresses(Root+"Man.", Man.Man, D);
   L_MSO.wordSetVar("OwnFirm.FondPns", P_MyFirm.NumInPFR(L_Staff.GetStaffMyFirm(), D));
   L_MSO.wordSetVar("OwnFirm.AnkSenderName",     P_MyFirm.AnkSenderName    (L_Staff.GetStaffMyFirm(), D));
   L_MSO.wordSetVar("OwnFirm.AnkSenderPostName", P_MyFirm.AnkSenderPostName(L_Staff.GetStaffMyFirm(), D));
  END;
 END {PF_Adr};

 PRIVATE PROCEDURE Tax_StD(D: DATE; Root: STRING[]);
  VAR
   EmptyTaxInq: SCAL[2];
   CountLines : NUMERIC[0];
   _OwnCode   : LIKE(TaxAdv.OwnCode);
   _VCode     : LIKE(TaxAdv.VCode);
   _Name      : STRING[];
 BEGIN
  IF ~!Root THEN
   EmptyTaxInq:=1;
   L_General.Assert(L_Staff.rInState(D), "⭨  ⮨    "+L_DatTim.DateStr(D));
   L_Tax.Tax2001_InitCodes(D);
   L_MSO.wordSetVarsByFile_wPrefix("Man", "TaxInq.");
   L_Staff.PosToStaffLog(Staff.TSN, D, 1);
   CONFORM(StaffLog, Officer, Post);
   L_MSO.wordSetVarsByFile_wPrefix("Post" ,"TaxInq.Man.MainContract.Officer.");
   L_MSO.wordSetVarsByFile("TaxInq");
   SETZERO(CountLines);
   SELECT(ManTA, TaxInq, , TaxInq.TaxInq);
   WHILE OCCURE(ManTA) DO
    CONFORM(ManTA, TaxAdv);
    IF L_DatTim.IsActive_Inc(D, L_DatTim.Per(ManTA.StartD), ManTA.StopD) &
       (L_Tax.Tax_TaxAdv_Type() = L_Tax.Tax2001_mt_StD) THEN
     EmptyTaxInq:=0;
     L_MSO.wordSetVarsByFile_wAliasAndIndexE("ManTA", "TaxInq.ManTA", CountLines, 0);
     IF L_Tax.Tax2001_GetFromTable(L_Tax.Tax2001_taGetIdx(), _OwnCode, _VCode, _Name) THEN
      L_MSO.wordSetVar("TaxInq.ManTA["+L_Str.IntStr(CountLines)+"].TaxAdv.Name", _Name);
      L_MSO.wordSetVar("TaxInq.ManTA["+L_Str.IntStr(CountLines)+"].TaxAdv.VCode", _VCode);
      INC(CountLines);
     END; (* IF *)
    END; (* IF Condition(... *)
    NEXT(ManTA);
   END; (* WHILE OCCURE(ManTA) ... *)
   L_General.Assert(~EmptyTaxInq, "  ⠭  ⮢");
   L_MSO.SetWordTable("TaxInq", CountLines);
   L_Tax.Tax_FreeValues(D);
  END; (* IF ~!Root... *)
 END {Tax_StD};

 PRIVATE PROCEDURE FCAN_GetManDocName(_DocType: LIKE(Man.DocType)): STRING[];
 BEGIN
  IF    _DocType = 00 THEN RETURN "ᯮ";
  ELSIF _DocType = 01 THEN RETURN "  ஦";
  ELSIF _DocType = 02 THEN RETURN "㤮 ";
  ELSIF _DocType = 03 THEN RETURN "  ";
  ELSIF _DocType = 04 THEN RETURN " ";
  ELSIF _DocType = 05 THEN RETURN "ᯮ";
  ELSIF _DocType = 06 THEN RETURN ". ";
  ELSIF _DocType = 07 THEN RETURN " ";
  ELSIF _DocType = 08 THEN RETURN "ᯮ";
  ELSIF _DocType = 09 THEN RETURN " ";
  ELSIF _DocType = 10 THEN RETURN "࠭";
  ELSIF _DocType = 11 THEN RETURN "࠭";
  ELSIF _DocType = 12 THEN RETURN "  ";
  ELSIF _DocType = 13 THEN RETURN " ";
  ELSIF _DocType = 14 THEN RETURN " 猪";
  ELSIF _DocType = 15 THEN RETURN " ";
  ELSIF _DocType = 16 THEN RETURN "ᯮ";
  ELSIF _DocType = 17 THEN RETURN " ";
  ELSIF _DocType = 18 THEN RETURN "  ஦";
  ELSE
   L_General.Error("  㬥, 㤮⮢饣 筮 "+FLDTOSTR(_DocType, "0", 0));
  END;
 END {FCAN_GetManDocName};

 PRIVATE PROCEDURE FCAN_FormatPhone(S: STRING[]): STRING[];
  VAR
   i: NUMERIC[0];
   s: STRING[];
 BEGIN
  i:=0;
  s:="";
  WHILE ~!S[i] DO
   IF (S[i] >= "0") & (S[i] <= "9") THEN
    s:=s + S[i];
   END;
   INC(i);
  END;
  IF Str.Length(s) > 10 THEN
   s:=L_Str.Right(s, 10);
  END;
  RETURN s;
 END {FCAN_FormatPhone};

 PRIVATE PROCEDURE StandOnMigrNotifSenderMan(D: DATE);
  VAR
   Sender: LIKE(Staff.TSN);
 BEGIN
  Sender:=P_MyFirm.GetTSNByMFPro(Staff.MyFirm, D, P_MyFirm.P_MigrNotifSender, 0);
  IF !Sender THEN
   SEARCH(Man, Man, , P_Man.curUSER2Man());
  ELSE
   SAVE(Staff);
   SEARCH(Staff, TSN, , Sender);
   CONFORM(Staff, Man);
   RESTORE(Staff);
  END;
 END {StandOnMigrNotifSenderMan};

 PRIVATE PROCEDURE FCAN_SetSenderVars(D: DATE; wAddr: SCAL[2]; MaxPspSerChar: NUMERIC[0]);
  VAR
   SenderWrkPhone: STRING[];
 BEGIN
  SAVE(Man);
  StandOnMigrNotifSenderMan(D);
  L_MSO.SetValueDerivativesOnDate("TheDoc.Sender.Name", Man.Name, "SetManNameVar", D);
  L_MSO.wordSetVarsByFile_wAlias("Man", "TheDoc.Sender");
  L_MSO.wordSetVar("TheDoc.Sender.DocType.TenCharStr", FCAN_GetManDocName(Man.DocType));
  IF Str.Length(Man.PspSer) > MaxPspSerChar THEN
   L_MSO.wordSetVar("TheDoc.Sender.PspSer", Str.Replace(Man.PspSer, " ", ""));
  END;
  IF wAddr THEN
   L_Man.wordSetAddresses("TheDoc.Sender.", Man.Man, D);
  END;
  SenderWrkPhone:=P_Man.GetManWorkCtcInf(Man.Man, D, L_ctc.cvt_PhonePST);
  IF !SenderWrkPhone THEN
   SenderWrkPhone:=P_Firm.FP_Phone(P_Firm.fomf(Staff.MyFirm), D);
  END;
  L_MSO.wordSetVar("TheDoc.Sender.WrkPhone", FCAN_FormatPhone(SenderWrkPhone));
  RESTORE(Man);
 END {FCAN_SetSenderVars};

 PRIVATE PROCEDURE FCAN_Sender(D: DATE);
 BEGIN
  FCAN_SetSenderVars(D, 1, 4);
 END {FCAN_Sender};

 PRIVATE PROCEDURE FCAN_SetManPro_wSplitSerNum(HasPro: SCAL[2]; Alias: STRING[]);
  VAR
   DocSer,
   DocNum : STRING[];
 BEGIN
  L_MSO.wordSetVarsByFile_wAliasE("ManPro", Alias, ~HasPro);
  IF HasPro THEN
   L_Prop.GetDocSerAndNum(ManPro.DocNum, DocSer, DocNum);
  ELSE
   SETEMPTY(DocSer, DocNum);
  END;
  L_MSO.wordSetVar(Alias + ".DocSer", DocSer);
  L_MSO.wordSetVar(Alias + ".DocNum", DocNum);
 END {FCAN_SetManPro_wSplitSerNum};

 PRIVATE PROCEDURE FCAN01(D: DATE; Root: STRING[]);
 BEGIN
  IF ~!Root THEN
   L_MSO.wordSetVar(Root + "Man.DocType.TenCharStr", FCAN_GetManDocName(Man.DocType));
   IF Str.Length(Man.PspSer) > 4 THEN
    L_MSO.wordSetVar(Root + "Man.PspSer", Str.Replace(Man.PspSer, " ", ""));
   END;
   L_MSO.wordSetVar(Root + "Man.Telephon",           FCAN_FormatPhone(L_Man.ManPhone(D)));
   FCAN_SetManPro_wSplitSerNum(P_Man.HasActualManPro(Man.Man, D, P_Man.P_ForeignerLegalStatus),
                               Root + "Man.ForeignerLegalStatus");
   FCAN_SetManPro_wSplitSerNum(P_Man.HasManPro(Man.Man, D, P_Man.P_MigrationCard),
                               Root + "Man.MigrationCard");
   FCAN_Sender(D);
   L_MSO.wordSetVar("OwnFirm.Phone", FCAN_FormatPhone(P_Firm.FP_Phone(L_Staff.GetFirmOfStaff(), D)));

   IF L_Man.AccessManAdr(Man.Man, L_Man.GetTakeOnDate(D) - 1, L_Russia.at_DwMA) THEN
    L_Man.curManAdr_Set_glb_AdrVar();
    L_Russia.wordSetAddr_byPart(Root + "Man.PrvDwAdr");
   ELSE
    L_Russia.Set_glb_AdrVar_ToEmpty();
    L_Russia.wordSetAddr_byPart(Root + "Man.PrvDwAdr");
   END;
  END; (* IF ~!Root *)
 END {FCAN01};

 PRIVATE PROCEDURE FCAN_Attorney_Prepare(D: DATE; TemplateName: STRING[]); (* . 96.E_Staff *)
  VAR
   EndDate,
   SrcDate    : DATE;
   _LbCNbr    : STRING[];
   _LbCDate   : DATE;
   _KindOfWork: STRING[];
 BEGIN
  SETEMPTY(SrcDate, EndDate);
  IF    TemplateName = "FCAN01" THEN
   IF P_Man.HasManPro(Man.Man, D, P_Man.P_MigrationCard) THEN
    SrcDate:=ManPro.DocGiveD;
   END;
  ELSIF TemplateName = "FCAN02" THEN
   L_Staff.GetLabourContractAttr(D, _LbCNbr, _LbCDate, _KindOfWork);
   SrcDate:=_LbCDate;
  ELSIF TemplateName = "FCAN03" THEN
   SrcDate:=StaffLog.Date - 1;
  END;

  IF ~!SrcDate THEN
   EndDate:=SrcDate + 30;
  END;

  L_MSO.wordSetDateVar("TheDoc.SrcDate", SrcDate);
  L_MSO.wordSetDateVar("TheDoc.EndDate", EndDate);
  FCAN_Sender(D);
 END {FCAN_Attorney_Prepare};

 PRIVATE PROCEDURE FCAN0203_Prepare(D: DATE; ForLeave: SCAL[2]; Root, Recipient: STRING[]);
  VAR
   Dummy          : STRING[];
   Years,
   Months,
   Days           : NUMERIC[0];
   ContractEndDate: DATE;
 BEGIN
  IF ~!Root THEN
   L_MSO.wordSetVar(Root + "Man.DocType.TenCharStr", FCAN_GetManDocName(Man.DocType));
   L_MSO.wordSetVar(Root + "Man.Telephon",           FCAN_FormatPhone(L_Man.ManPhone(D)));
   FCAN_SetManPro_wSplitSerNum(P_Man.HasActualManPro(Man.Man, D, P_Man.P_LaborActivityLicense),
                               Root + "Man.LaborActivityLicense");
   L_MSO.wordSetVarsByFile_wAliasE("ManPro", Root + "Man.MigrationCard",
                                   ~P_Man.HasManPro(Man.Man, D, P_Man.P_MigrationCard));
   L_MSO.wordSetVarsByFile_wAliasE("ManPro", Root + "Man.ResidencePermit",
                                   ~P_Man.HasActualManPro(Man.Man, D, P_Man.P_ResidencePermit));
   IF ForLeave THEN
    L_MSO.wordSetVar(Root + "ContractLength.Years",  "XX");
    L_MSO.wordSetVar(Root + "ContractLength.Months", "XX");
    L_MSO.wordSetVar(Root + "ContractLength.Weeks",  "X");
    L_MSO.wordSetDateVar("Staff.EndDate", D);
   ELSE
    ContractEndDate:=L_Man.GetTimedContractEndDate(D);
    IF ~!ContractEndDate THEN
     L_DatTim.GetDatesDifferenceIn3Part(StaffLog.Date, ContractEndDate, Days, Months, Years);
     L_MSO.wordSetVar(Root + "ContractLength.Years",  L_Str.IntStr(Years));
     L_MSO.wordSetVar(Root + "ContractLength.Months", L_Str.IntStr(Months));
     L_MSO.wordSetVar(Root + "ContractLength.Weeks",  L_Str.IntStr(Days/7));
    ELSE
     L_MSO.wordSetVar(Root + "ContractLength.Years",  "");
     L_MSO.wordSetVar(Root + "ContractLength.Months", "");
     L_MSO.wordSetVar(Root + "ContractLength.Weeks",  "");
    END;
   END;

   WordSetAllStages(Root);

   L_MSO.wordSetVar("OwnFirm.Phone",      FCAN_FormatPhone(P_Firm.FP_Phone(L_Staff.GetFirmOfStaff(), D)));
   L_MSO.wordSetVar("OwnFirm.OKVED.Code", P_MyFirm.OKVED_Code(Staff.MyFirm, D));
   L_MSO.wordSetVar("OwnFirm.OKVED.Name", P_MyFirm.OKVED_Name(Staff.MyFirm, D));
   Dummy:=P_MySite.GetP_KPP(Staff.MyFirm, EMPTYOF(MyPlace.MyPlace), D);
   L_MSO.wordSetVar("OwnFirm.KPP.DocNum", P_MySite.GetMSProDocNum(Staff.MyFirm, EMPTYOF(MyPlace.MyPlace), D, P_MySite.P_KPP));
   Dummy:=P_Firm.FP_OGRN(L_Staff.GetFirmOfStaff(), D);
   L_MSO.wordSetVar("OwnFirm.OGRN.DocNum", FirmPro.DocNum);

   FCAN_SetSenderVars(D, 0, 6);
   L_MSO.wordSetVar("TheDoc.Recipient",                   Recipient);
  END;
 END {FCAN0203_Prepare};

 PRIVATE PROCEDURE FCAN02_2FMS_Prepare(D: DATE; Root: STRING[]);
 BEGIN
  FCAN0203_Prepare(D, 0, Root, P_MyFirm.GetProValueStrong(Staff.MyFirm, D, P_MyFirm.P_MigrationService));
 END {FCAN02_2FMS_Prepare};

 PRIVATE PROCEDURE FCAN02_2EmploymentCenter_Prepare(D: DATE; Root: STRING[]);
 BEGIN
  FCAN0203_Prepare(D, 0, Root, P_MyFirm.GetProValueStrong(Staff.MyFirm, D, P_MyFirm.P_EmploymentCenter));
 END {FCAN02_2EmploymentCenter_Prepare};

 PRIVATE PROCEDURE FCAN03_2FMS_Prepare(D: DATE; Root: STRING[]);
 BEGIN
  FCAN0203_Prepare(D-1, 1, Root, P_MyFirm.GetProValueStrong(Staff.MyFirm, D, P_MyFirm.P_MigrationService));
 END {FCAN03_2FMS_Prepare};

 PRIVATE PROCEDURE FCAN03_2EmploymentCenter_Prepare(D: DATE; Root: STRING[]);
 BEGIN
  FCAN0203_Prepare(D-1, 1, Root, P_MyFirm.GetProValueStrong(Staff.MyFirm, D, P_MyFirm.P_EmploymentCenter));
 END {FCAN03_2EmploymentCenter_Prepare};

 PRIVATE PROCEDURE AoFCWPP(D: DATE; Root: STRING[]);
  VAR
   FgnName: STRING[];
 BEGIN
  IF ~!Root THEN
   L_MSO.wordSetDateVar("MakeDate", D);
   FgnName:=P_Man.GetManProSoft(Man.Man, D, P_Man.P_ManForeignPassport);
   L_MSO.wordSetVar("Staff.Man.ForeignPassport.LastName", Str.Item(FgnName, " ", 0));
   L_MSO.wordSetVar("Staff.Man.ForeignPassport.FirstName", Str.Item(FgnName, " ", 1));
   L_MSO.wordSetVar("OwnFirm.OKVED.Code", P_MyFirm.OKVED_Code(Staff.MyFirm, D));
   L_MSO.wordSetVar("OwnFirm.OKVED.Name", P_MyFirm.OKVED_Name(Staff.MyFirm, D));
   L_MSO.wordSetVar("OwnFirm.OKATO", P_MyPlc.GetP_OKATO(Staff.MyFirm, EMPTYOF(MyPlace.MyPlace), D));
   L_MSO.wordSetDateVar("OwnFirm.OGRN.DocGiveD", P_Firm.GetFirmProDocGiveD(P_Firm.OWN_FIRM, D, P_Firm.P_OGRN));
   L_MSO.wordSetVarsByFile_wAliasE("ManPro", Root + "Man.ResidencePermit",
                                   ~P_Man.HasActualManPro(Man.Man, D, P_Man.P_ResidencePermit));
   L_MSO.wordSetVarsByFile_wAliasE("ManPro", Root + "Man.LaborLicense",
                                   ~P_Man.HasActualManPro(Man.Man, D, P_Man.P_LaborActivityLicense));
   SAVE(Man);
   StandOnMigrNotifSenderMan(D);
   L_MSO.SetValueDerivativesOnDate("TheDoc.Sender.Name", Man.Name, "SetManNameVar", D);
   RESTORE(Man);
  END;
 END {AoFCWPP};

 PRIVATE PROCEDURE RDSV(D: DATE; Root: STRING[]);
  VAR
   Sum  : NUMERIC[2];
   BegD,
   EndD : DATE;
 BEGIN
  IF ~!Root THEN
   BegD:=L_DatTim.YearBeg(Memo.ud_cd());
   EndD:=L_DatTim.YearEnd(Memo.ud_cd());
   L_MSO.wordSetDateVar("AcntPer", BegD);
   L_StdFrm.Choice("⥫   "+FLDTOSTR(BegD, "y ", 8));
   L_MSO.wordSetVar("Man.TaxDep",     P_Man.GetManProSoft(Man.Man, D, P_Man.P_TaxDep));
   L_MSO.wordSetVar("Man.DocCodeMNS", L_Man.GetManDocCodeMNS(D));
   Sum:=0;
   SETSEL(Packet, PacketKn, L_Packet.rcv_PensFund, L_Packet.knd_PF_DSV3);
   SRCINSEL(Packet, GE, , BegD);
   WHILE OCCURE(Packet) DO
    PROMPT(" " + Packet.Packet);
    IF (Packet.Status = L_Packet.st_Done) & (Packet.MyFirm = Staff.MyFirm) &
       L_DatTim.IsActiveInIntvl(Packet.PerB, Packet.PerE, BegD, EndD) &
       SEARCH(PckBody, Man, Man.Man, Packet.Packet) THEN
     INC(Sum, L_Packet.GetPckBodySum(Packet.Packet, PckBody.SeqNbr));
    END;
    NEXT(Packet);
   END;
   L_MSO.wordSetMoneyVar("Payment", D, Sum);
  END;
 END {RDSV};

 PRIVATE PROCEDURE ForCDL(D: DATE; Root: STRING[]);
  CONST
   months_inc =  6;
  VAR
   Prefix     : STRING[];
   incFrom,
   incUpTo    : DATE;
   incSum     : NUMERIC[2][months_inc];
   incIdx     : NUMERIC[0];
   TotalIncome: NUMERIC[2];
 BEGIN
  IF ~!Root THEN
   L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
 
   incFrom:=L_DatTim.IncMonth(L_DatTim.MonthBeg(D), 1 - months_inc);
   incUpTo:=L_DatTim.MonthEnd(D);
 
   L_StdFrm.Question(" 室  ਮ  " + L_DatTim.PeriodStr(incFrom) +
                     "  " + L_DatTim.PeriodStr(incUpTo));
 
   P_Firm.SetMyFirmDefaultData(Staff.MyFirm, incUpTo, "");
   Prefix:="Man.Loan.";
   L_MSO.wordSetDateVar("TheDoc.Date", SYSDATE());
   CONFORM(Staff, Man);
   L_MSO.wordSetVarsByFile("Man");
 
   SETZERO(incSum);
   SAVE(Staff);
   SELECT(Staff, MyFirm, , Staff.MyFirm, Staff.Man);
   WHILE OCCURE(Staff) DO
    SETSEL(Money, TSN, Staff.TSN);
    SRCINSEL(Money, GE, , incFrom);
    WHILE OCCURE(Money) & (Money.Closed <= incUpTo) DO
     PROMPT(L_DatTim.PeriodStr(Money.Closed));
     incIdx:=L_DatTim.CompleteMonthsInIntvl(incFrom, Money.Closed);
     NARROWSEL(Money, Closed);
     L_General.Assert(L_APtm.MonthIsClosed(Money.Closed, L_APtm.system_Salary) |
                      L_PRoll.IsShtD_AP(Money.Closed),
                      " ⠭  " + L_DatTim.PeriodStr(Money.Closed));
     WHILE OCCURE(Money) DO
      CONFORM(Money, MCList);
      IF (MCList.MCTyp = L_PRoll.mct_Credit) & MCList.ForDed[0] & (Money.Closed >= incFrom) THEN
       INC(incSum[incIdx], L_General.Denominate(Money.Closed, incUpTo, Money.Sum));
      END;
      NEXT(Money);
     END; (* WHILE OCCURE(Money)... *)
     NEXTINEXTENDEDSEL(Money, Closed);
    END; (* WHILE OCCURE(Money) & ... *)
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff)... *)
   RESTORE(Staff);

   SETZERO(incIdx, TotalIncome);
   WHILE incIdx < months_inc DO
    L_MSO.wordSetVar(Prefix + "Income" + L_MSO.IndexStr(incIdx) + ".Month",
                     L_DatTim.MonthStr(L_DatTim.IncMonth(incFrom, incIdx), 0) + " " +
                     L_Str.IntStr(L_DatTim.YEAR(L_DatTim.IncMonth(incFrom, incIdx))));
    L_MSO.wordSetMoneyVar(Prefix + "Income" + L_MSO.IndexStr(incIdx) + ".Sum", incUpTo, incSum[incIdx]);
    INC(TotalIncome, incSum[incIdx]);
    INC(incIdx);
   END;
 
   L_MSO.wordSetMoneyVar(Prefix + "TotalIncome", incUpTo, TotalIncome);
  END;
 END {ForCDL};

 PRIVATE PROCEDURE E_IsRequiredDecr(mcode: LIKE(MCList.MCode); VAR rdIdx: NUMERIC[0]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Staff.Loan_IsRequiredDecr);
  IF ~!Local THEN
   RETURN Local(mcode, rdIdx);
  ELSE
   RETURN 0;
  END;
 END {E_IsRequiredDecr};

 PRIVATE PROCEDURE E_GetRequiredDecrArray(VAR rdName: STRING[][MAXOF(MCList.MCode)]);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Staff.Loan_GetRequiredDecrArray);
  IF ~!Local THEN
   Local(rdName);
  ELSE
   SETEMPTY(rdName);
  END;
 END {E_GetRequiredDecrArray};

 PRIVATE PROCEDURE Loan(D: DATE; Root: STRING[]);
  VAR
   P,
   FstMonth,
   LstMonth    : DATE;
   ReqDecr,
   Decr        : NUMERIC[2][MAXOF(MCList.MCode)];
   rdName      : STRING[][MAXOF(MCList.MCode)];
   rdIdx,
   MonthAm,
   i, Idx      : NUMERIC[0];
   Sum,
   OtherDecr,
   _DebitSum,               (*㤥ঠ*)
   _CreditSum : NUMERIC[2]; (*室*)
   AlignStr,
   Prefix      : STRING[];
   MonthArr    : SCAL[2][100];
 BEGIN
  IF ~!Root THEN
   L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
   IF ~!PROCREF(E_Staff.Loan_SetPeriod) THEN
    E_Staff.Loan_SetPeriod(FstMonth, LstMonth);
   ELSE
    FstMonth:=L_DatTim.MonthBeg(Memo.ud_fr());
    LstMonth:=L_DatTim.MonthEnd(Memo.ud_ut());
   END;
   L_StdFrm.Question("ࠢ  ਮ  "+L_DatTim.DateStr(FstMonth)+"  "+L_DatTim.DateStr(LstMonth));
   MonthAm :=L_DatTim.MonthsInIntvl(FstMonth, LstMonth);
   L_General.Assert(MonthAm = 6, "ਮ   6 楢");
  
   SAVE(Staff);
   SETZERO(_CreditSum, Decr, MonthArr, ReqDecr, OtherDecr);
   SELECT(Staff, MyFirm, , Staff.MyFirm, Staff.Man);
   WHILE OCCURE(Staff) DO
    SETSEL(Money, TSN, Staff.TSN);
    SRCINSEL(Money, GE, , FstMonth);
    WHILE OCCURE(Money) & (Money.Closed <= LstMonth) DO
     PROMPT(L_DatTim.PeriodStr(Money.Closed));
     NARROWSEL(Money, Closed);
     L_General.Assert(L_APtm.MonthIsClosed(Money.Closed, L_APtm.system_Salary) |
                      L_PRoll.IsShtD_AP(Money.Closed),
                      " ⠭  " + L_DatTim.PeriodStr(Money.Closed));
     MonthArr[L_DatTim.CompleteMonthsInIntvl(FstMonth, Money.Closed)]:=1;
     WHILE OCCURE(Money) DO
      CONFORM(Money, MCList);
      IF MCList.ForDed[0] THEN
       Sum:=L_General.Denominate(Money.Closed, D, Money.Sum);
       IF    MCList.MCTyp=L_PRoll.mct_Credit THEN
        INC(_CreditSum, Sum);
       ELSIF MCList.MCTyp=L_PRoll.mct_Debit THEN
        IF E_IsRequiredDecr(MCList.MCode, rdIdx) THEN
         INC(ReqDecr[rdIdx], Sum);
        ELSE
         INC(Decr[MCList.MCode], Sum);
         INC(OtherDecr         , Sum);
        END;
       END;
      END;
      NEXT(Money);
     END; (* WHILE OCCURE(Money)... *)
     NEXTINEXTENDEDSEL(Money, Closed);
    END; (* WHILE OCCURE(Money)... *)
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff)... *)
   RESTORE(Staff);
 
   MonthAm:=0;
   P:=FstMonth;
   WHILE P<=LstMonth DO
    INC(MonthAm, MonthArr[L_DatTim.CompleteMonthsInIntvl(FstMonth, P)]);
    P:=L_DatTim.NextPer(P);
   END;
   L_General.Assert(MonthAm > 0, " ࠡ⪠      ਮ");
 
   P_Firm.SetMyFirmDefaultData(Staff.MyFirm, D, "");
   Prefix:="Man.Loan.";
   L_MSO.wordSetDateVar("TheDoc.Date", D);
   L_MSO.wordSetVar(Prefix+"Creditor", L_EC.ExecE_Func_String(D, PROCREF(E_Staff.Loan_Creditor), ""));
   IF P_Firm.Acnt_Manner(P_Firm.OWN_FIRM, D) THEN
    L_MSO.wordSetVar("OwnFirm" + ".AcntWLeader.Name.Short", "  壠 (㣮 ⭮ , 믮饣  㭪樨)   ࣠樨 ");
   END;
 
   L_Staff.PosToStaffLog(Staff.TSN, D, 1);
   CONFORM(Staff, Man);
   CONFORM(StaffLog, Post);
 
   L_MSO.wordSetVarsByFile("Staff");
   L_MSO.wordSetVarsByFile("Man");
   L_MSO.wordSetVarsByFile("Post");
  
   SETZERO(i, Idx, _DebitSum);
   E_GetRequiredDecrArray(rdName);
   WHILE i <= HIGH(ReqDecr) DO
    IF ~!rdName[i] THEN
     L_MSO.wordSetVar_wIndex(Prefix + "DecrName", rdName[i], Idx);
     IF ReqDecr[i] > 0 THEN
      L_MSO.wordSetVar_wIndex(Prefix + "DecrSum",
                              L_Money.MoneyToStr(L_DatTim.Per(D), ",", ReqDecr[i]) +
                              " (" + L_Money.ByWord(ReqDecr[i]) + ")",
                              Idx);
     ELSE
      L_MSO.wordSetVar_wIndex(Prefix + "DecrSum", "", Idx);
     END;
     INC(_DebitSum, ReqDecr[i]);
     INC(Idx);
    END;
    INC(i);
   END;
 
   IF Idx > 0 THEN
    L_MSO.wordSetVar_wIndex(Prefix + "DecrName", "稥 ⥦ (㪠 )", Idx);
    IF OtherDecr > 0 THEN
     L_MSO.wordSetVar_wIndex(Prefix + "DecrSum",  "", Idx);
    ELSE
     L_MSO.wordSetVar_wIndex(Prefix + "DecrSum",  "", Idx);
    END;
    AlignStr:="   ";
    INC(Idx);
   ELSE
    AlignStr:="";
   END;
 
   i:=0;
   WHILE i <= HIGH(Decr) DO
    IF Decr[i] > 0 THEN
     SEARCH(MCList, MCode, , i);
     L_MSO.wordSetVar_wIndex(Prefix + "DecrName", AlignStr + MCList.Name, Idx);
     L_MSO.wordSetVar_wIndex(Prefix + "DecrSum",
                             L_Money.MoneyToStr(L_DatTim.Per(D), "", Decr[i])  +
                             " (" + L_Money.ByWord(Decr[i]) + ")",
                             Idx);
     INC(_DebitSum, Decr[i]);
     INC(Idx);
    END;
    INC(i);
   END;
 
   _CreditSum:=_CreditSum;
 
   L_MSO.SetWordTable("table1", Idx);
   L_MSO.wordSetMoneyVar(Prefix+"CreditSum", D, _CreditSum);
   L_MSO.wordSetMoneyVar(Prefix+"DebitSum",  D, _DebitSum);
   IF ~!PROCREF(E_Staff.Loan_Specific) THEN
    E_Staff.Loan_Specific(D, LstMonth);
   END;
  END;
 END {Loan};

 PRIVATE PROCEDURE GetTimDone(P: DATE): LIKE(PCalc.TimDone);
  VAR
   Result: LIKE(PCalc.TimDone);
 BEGIN
  IF SEARCH(PCalc, TSN, Staff.TSN, P) THEN
   Result:=PCalc.TimDone;
   SELECT(Sheet, TSN, , Staff.TSN, P);
   WHILE OCCURE(Sheet) DO
    IF Sheet.SpKind = L_Sheet.spk_Juvenile THEN
     INC(Result, Sheet.SpTime);
    END;
    NEXT(Sheet);
   END; (* WHILE OCCURE(Sheet) ... *)
   RETURN Result;
  ELSE
   RETURN 0;
  END;
 END {GetTimDone};

 PRIVATE PROCEDURE WorkInCntPer(FstMonth, LstMonth: DATE): SCAL[2];
  VAR
   P: DATE;
 BEGIN
  P:=FstMonth;
  REPEAT
   IF GetTimDone(P) THEN
    RETURN 1;
   END;
   P:=L_DatTim.IncMonth(P, 1);
  UNTIL P > LstMonth;
  RETURN 0;
 END {WorkInCntPer};

 PRIVATE PROCEDURE GetPastMCode(Fr, Up: DATE; _MCode: LIKE(MCList.MCode); VAR _Sum: NUMERIC[2]);
 BEGIN
  _Sum:=0;
  SETSEL(Money, TSN, Staff.TSN);
  SRCINSEL(Money, GE, , Fr);
  WHILE OCCURE(Money) & (Money.Closed <= Up) DO
   CHANGESEL(Money, TSN, , Money.TSN, Money.Closed, Money.WFPeriod,
                           Money.ODate, Money.Period);
   SRCINSEL(Money, GE, , _MCode);
   WHILE OCCURE(Money) & (Money.MCode = _MCode) DO
    INC(_Sum, L_General.Denominate(Money.Closed, Money.Period, Money.Sum));
    NEXT(Money);
   END;
   LAST(Money);
   CHANGESEL(Money, TSN, , Money.TSN);
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
 END {GetPastMCode};

 PRIVATE PROCEDURE GetLongPerBonuses(First: DATE): NUMERIC[2];
  VAR
   _Tot,
   _Sum : NUMERIC[2];
 BEGIN
  _Tot:=0;
  SETSEL(MCList, MCPerNum);
  LAST(MCList);
  WHILE OCCURE(MCList) & (MCList.PerNum > 01) DO
   IF MCList.Index[L_AvePay.aveno_Hldy] THEN
    GetPastMCode(First,
                 L_DatTim.IncMonth(First, MCList.PerNum - 1),
                 MCList.MCode,
                 _Sum);
    INC(_Tot, _Sum / MCList.PerNum);
   END;
   PREV(MCList);
  END; (* WHILE OCCURE(MCList) ... *)
  RETURN _Tot;
 END {GetLongPerBonuses};

 PRIVATE PROCEDURE GetRegBal(P: DATE): LIKE(PCalc.HBal);
 BEGIN
  HISTCONF(P, Staff, StaffLog);
  IF OCCURE(StaffLog) THEN
   L_General.Assert(SEARCH(RegHead, HumReg, StaffLog.Regime, P),
                    " 䨪  ଠ樨  ⠪ ப");
   RETURN RegHead.FullBal;
  ELSE
   RETURN 0;
  END;
 END {GetRegBal};

 PRIVATE PROCEDURE GetHBal(P: DATE): LIKE(PCalc.HBal);
 BEGIN
  IF SEARCH(PCalc, TSN, Staff.TSN, P) THEN
   RETURN PCalc.HBal;
  ELSE
   RETURN GetRegBal(P);
  END;
 END {GetHBal};

 PRIVATE PROCEDURE GetCorBal(P: DATE): LIKE(PCalc.CorBal);
 BEGIN
  IF SEARCH(PCalc, TSN, Staff.TSN, P) THEN
   RETURN PCalc.CorBal;
  ELSE
   RETURN 0;
  END;
 END {GetCorBal};

 PRIVATE PROCEDURE GetWorkDays(P: DATE; VAR WDFc, WDClInState, x: NUMERIC[0]);
  VAR
   curHBal,
   curCorBal,
   curTimDone: L_PRoll.tTime;
 BEGIN
  SETZERO(WDClInState, x);
  L_APtm.MonthAccess(P);
  SELECT(Calendar, Period, , Month.Period);
  WHILE OCCURE(Calendar) DO
   PROMPT(L_DatTim.DateStr(Calendar.Date));
   IF (Calendar.WeekDay < L_DatTim.wd_Sat) THEN
    IF L_Staff.rInState(Calendar.Date) THEN
     INC(WDClInState);
    ELSE
     INC(x);
    END;
   END;
   NEXT(Calendar);
  END;
  curHBal   :=GetHBal(P);
  curCorBal :=GetCorBal(P);
  curTimDone:=GetTimDone(P);
  IF (curHBal > 0) THEN
   WDFc:=L_Math.MIN(curCorBal/curHBal, curTimDone/curHBal) * WDClInState;
  ELSIF (WDClInState=0) | ((curHBal=0) & (curCorBal=0) & (curTimDone=0)) THEN
   WDFc:=0;
  ELSE
   L_General.Error("㫥  ଠ ६  " + L_DatTim.PeriodStr(P));
  END;
 END {GetWorkDays};

 PRIVATE PROCEDURE NoAve(FstMonth, LstMonth: DATE; Text: STRING[]);
 BEGIN
  L_StdFrm.Inform("।  ࠡ⮪ ࠢ , ..| ࠡ "+Text+"  ⭮ ਮ " +
                  L_DatTim.PeriodStr(FstMonth) + " - " + L_DatTim.PeriodStr(LstMonth));
 END {NoAve};

 PRIVATE PROCEDURE GetAve1(P, CurMonth: DATE; VAR S, A: NUMERIC[2]; VAR T: NUMERIC[3]);
 BEGIN
  SETZERO(S, A, T);
  IF SELECT(Money, TSN, Staff.TSN, P) THEN
   L_PRoll.CheckSalDone(P);
  END;
  WHILE OCCURE(Money) DO
   CONFORM(Money, MCList);
   IF (MCList.PerNum = 01) & MCList.Index[L_AvePay.aveno_Hldy] THEN
    IF (MCList.TimeType # L_PRoll.tt_Include) THEN
     IF (MCList.TimeType > L_PRoll.tt_Exclude) THEN
      INC(T, Money.Tim);
      INC(S, L_General.Denominate(Money.Closed, CurMonth, Money.Sum));
     ELSE
      INC(A, L_General.Denominate(Money.Closed, CurMonth, Money.Sum));
     END;
    END;
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money ... *)
 END {GetAve1};

 PRIVATE PROCEDURE GetAveHldy(FstMonth, LstMonth, CurMonth: DATE): NUMERIC[2];
  VAR
   i       : NUMERIC[0];
   HBalForNormalSheet,
   H,
   h       : NUMERIC[3];
   S, B,
   s, a    : NUMERIC[2];
   P       : DATE;
   x (* ,  ࠡ⭨   㦥  ࠡ⠫  ।⨨*),
   __Days,
   _WDays,
   CWDays,
   OMDays  : NUMERIC[0];
  _AveH,
  _AveD,
  _AveM,
  _Days    : NUMERIC[2];
 BEGIN
  SETZERO(S, B, H, i, CWDays, _WDays, HBalForNormalSheet);
  P:=FstMonth;
  WHILE P <= LstMonth DO
   PROMPT(L_DatTim.DateStr(P));
   GetAve1(P, CurMonth, s, a, h);
   INC(S, (s + a));
   INC(B, GetLongPerBonuses(P));
   INC(H, h);
   GetWorkDays(P, OMDays, __Days, x);
   INC(CWDays, OMDays);
   INC(_WDays, __Days+x);
   L_General.Assert(SEARCH(Month, Period, P), "   "+L_DatTim.PeriodStr(P));
   INC(HBalForNormalSheet, Month.HBal);
   P:=L_DatTim.IncMonth(P, +1);
   INC(i);
  END;
  _AveM:=0;
  IF L_PRoll.E_IsSummationSheet(LstMonth) THEN
   IF H # 0 THEN
    _AveH:=(S + B) / H;
    _AveM:=_AveH * (HBalForNormalSheet / i);
   ELSE
    NoAve(FstMonth, LstMonth, "ᮢ");
   END;
  ELSE
   IF CWDays # 0 THEN
    _Days:=_WDays / i;
    _AveD:=S / CWDays + B / _WDays;
    _AveM:=_AveD * _Days;
   ELSE
    NoAve(FstMonth, LstMonth, "ᮢ");
   END;
  END;

  RETURN _AveM;
 END {GetAveHldy};

 PRIVATE PROCEDURE CheckCurrentAsMainForN_Busf(P: DATE);
  VAR
   _TSN : LIKE(Staff.TSN);
 BEGIN
  L_Staff.CheckCurrentAsMainForTax(L_Man.GetTakeOnDate(SYSDATE()));
  SAVE(Staff);
  L_Staff.StandOnMainContractByStaff(SYSDATE());
  _TSN:=Staff.TSN;
  RESTORE(Staff);
  IF Staff.TSN # _TSN THEN
   L_StdFrm.Choice("  ᫥ ࠪ (. ⠡. " + _TSN + ")");
  END;
 END {CheckCurrentAsMainForN_Busf};

 PRIVATE PROCEDURE NBUSF(D: DATE; Root: STRING[]);
  VAR
   avgSal        : NUMERIC[2];
   apNbr         : NUMERIC[0];
   BegDateInState,
   EndDateInState,
   EndPer,
   stdFstMonth,
   stdLstMonth,
   FstMonth,
   LstMonth      : DATE;
   FormStr       : STRING[];
 BEGIN
  IF ~!Root THEN
   EndDateInState:=Staff.EndDate;
   BegDateInState:=L_Man.GetTakeOnDate(EndDateInState);
   EndPer        :=L_DatTim.Per(EndDateInState);

   stdFstMonth:=L_DatTim.IncMonth(EndPer, -3);
   stdLstMonth:=L_DatTim.MonthEnd(L_DatTim.IncMonth(EndPer, -1));
   IF ~WorkInCntPer(stdFstMonth, stdLstMonth) THEN
    stdLstMonth:=stdFstMonth - 1;
    stdFstMonth:=L_DatTim.IncMonth(stdFstMonth, -3);
    IF ~WorkInCntPer(stdFstMonth, stdLstMonth) THEN
     stdFstMonth:=EndPer;
     stdLstMonth:=L_DatTim.MonthEnd(EndPer);
    END;
   END;
   FstMonth:=stdFstMonth;
   LstMonth:=stdLstMonth;
  
   FormStr:=L_StdFrm.sf_Choice("| ନ ࠢ  । ࠡ⭮ " +
                               "| । ࠧ ᮡ  ࠡ  ⨯." +
                               "|| ਮ  %#######%  %#######%|",
                               "%C<N.y>I" + "%C<N.y>I");
   STDFORM(FormStr, , INFORM, -1, FstMonth, LstMonth);
   LstMonth:=L_DatTim.MonthEnd(LstMonth);

   IF (FstMonth # stdFstMonth) | (LstMonth # stdLstMonth) THEN
    L_StdFrm.CrucialChoice(" ନ ࠢ  । ࠡ⭮  " +
                           "| ⠭  ਮ." +
                           "||   !", L_APtm.g_PayRoll);
   END;

   IF FstMonth < L_Env.aptm_Start THEN
    L_StdFrm.Choice("砫 ਮ  ᪠ ⮏.    !");
   END;

   CheckCurrentAsMainForN_Busf(SYSDATE());

   apNbr:=0;
   SELECT(AvePay, TSN, , Staff.TSN);
   WHILE OCCURE(AvePay) DO
    IF L_AvePay.IsRealAvePay() THEN
     CONFORM(AvePay, AveType);
     CONFORM(AvePay, AvePayP);
     WHILE OCCURE(AvePayP) DO
      CONFORM(AvePayP, JMode);
      IF ~!AveTypeP.JMode & (JMode.Type = L_Sheet.jmType_NonPAbsent) &
         L_DatTim.IsActiveInIntvl_Inc(Math.Max(BegDateInState, L_DatTim.IncMonth(EndPer, -12)),
                                      L_DatTim.MonthEnd(EndPer-1),
                                      AvePayP.StartD,
                                      AvePayP.StopD) THEN
       L_MSO.wordSetDateVar(Root + "AvePayP.StartD" + L_MSO.IndexStr(apNbr), AvePayP.StartD);
       L_MSO.wordSetDateVar(Root + "AvePayP.StopD"  + L_MSO.IndexStr(apNbr), AvePayP.StopD);
       L_MSO.wordSetVar(Root + "JMode" + L_MSO.IndexStr(apNbr) + ".Name", JMode.Name);
       INC(apNbr);
      END;
      NEXT(AvePayP);
     END; (* WHILE OCCURE(AvePayP) ... *)
    END;
    NEXT(AvePay);
   END; (* WHILE OCCURE(AvePay) ... *)
   WHILE apNbr < 8 DO
    L_MSO.wordSetDateVar(Root + "AvePayP.StartD" + L_MSO.IndexStr(apNbr), EMPTYOF(DATE));
    L_MSO.wordSetDateVar(Root + "AvePayP.StopD"  + L_MSO.IndexStr(apNbr), EMPTYOF(DATE));
    L_MSO.wordSetVar(Root + "JMode" + L_MSO.IndexStr(apNbr) + ".Name", "");
    INC(apNbr);
   END;

   avgSal:=GetAveHldy(FstMonth, LstMonth, L_DatTim.Per(SYSDATE()));
   L_MSO.wordSetMoneyVar(Root + "AvgSalary", D, avgSal);
  END;
  P_Firm.SetFirmDefaultData("Own", L_Staff.GetFirmOfStaff(), SYSDATE(), "");
  L_MSO.wordSetVar("OwnFirm.OldRegName", P_Firm.FP_ContractorBriefName(L_Staff.GetFirmOfStaff(), D));

 END {NBUSF};

 PRIVATE PROCEDURE GetDutyDgr(VAR HDay, DWeek: NUMERIC[0]; VAR AddInfo, Feature: STRING[]);
  CONST
   AddInfoFormStr = "| 㪠 ந ⥪,  㤥 뢥  ࠢ," +
                    "| ⠢   :                                     " +
                    "|" +
                    "|%66YI";
   FormButtons    = "||%< {}ਭ >B   %< {}⬥ >X";
   FormTitle      = "  ⥫쭮 ଠ樨 ";
 BEGIN
  HDay :=8;
  DWeek:=5;

  L_Staff.PosToStaffLog(Staff.TSN, Memo.ud_ut(), 0);
  CONFORM(StaffLog, Post);

  IF StaffLog.DutyDgr # 1 THEN
   STDFORM(AddInfoFormStr +
           "|__________________________________________________________________" +
           "|" +
           "|⭨   .  ࠢ 室 㪠:" +
           "|த⥫쭮 ࠡ祣  (): %3I" +
           "|⢮ ࠡ       : %3I" +
           "|" +
           FormButtons, FormTitle, INFORM, -1, AddInfo, HDay, DWeek);
   L_General.Assert((HDay > 0) & (HDay < 24) & (DWeek > 0) & (DWeek < 8),
                    " ॠ쭠 த⥫쭮 ࠡ祣 ६");
  ELSE
   STDFORM(AddInfoFormStr + FormButtons, FormTitle, INFORM, -1, AddInfo);
  END;

  CONFORM(StaffLog, RegMain);
  IF OCCURE(RegMain) & (RegMain.SlipGr = L_PRoll.rgt_SlipGr) THEN
   Feature:="ᬥ";
  ELSE
   SETEMPTY(Feature);
  END;
  CONFORM(StaffLog, Officer);
  IF L_Staff.OfficerHarmPwr(Memo.ud_ut()) > L_Staff.dtpwr_Acceptable THEN
   Feature:=L_Str.AddStrDlm(Feature, ", ") + "।";
  END;
 END {GetDutyDgr};

 PRIVATE PROCEDURE MoneyType(VAR _MoneyType: SCAL[3]);
 BEGIN
  L_General.Assert(L_APtm.MonthIsClosed(Money.Closed, L_APtm.system_Salary) |
                   L_PRoll.IsShtD_AP(Money.Closed),
                   " ⠭  " + L_DatTim.PeriodStr(Money.Closed));
  SETEMPTY(_MoneyType);
  CONFORM(Money, MCList);
  CONFORM(MCList, TaxAdv);
  IF TaxAdv.VCode = "2300" THEN
   _MoneyType:=2(*쭨*);
  ELSIF (MCList.PerNum = 01) & MCList.Index[L_AvePay.aveno_Hldy] THEN
   IF (MCList.TimeType # L_PRoll.tt_Include) THEN
    IF MCList.InSign[9] (*६  *)THEN
     _MoneyType:=1(*६*);
    ELSE
     _MoneyType:=0(*௫*);
    END;
   END;
  END;                          
 END {MoneyType};

 PRIVATE PROCEDURE NVTEK(D: DATE; Root: STRING[]);
  VAR
   HDay,
   DWeek   : NUMERIC[2];
   Idx     : NUMERIC[0];
   FstMonth,
   LstMonth,
   P, SysD : DATE;
   AddInfo,
   Feature : STRING[];
   SumM,
   _Sum    : NUMERIC[2][4];
   _MoneyType: SCAL[3];
 BEGIN
  IF ~!Root THEN
   FstMonth:=L_DatTim.Per(Memo.ud_fr());
   LstMonth:=L_DatTim.Per(Memo.ud_ut());
   L_General.Assert(L_DatTim.MonthsInIntvl(FstMonth, L_DatTim.MonthEnd(LstMonth)) = 12,
                    "ਮ  ⠢ 12 楢");

   STDFORM(L_StdFrm.sf_Choice("| ନ ࠢ   " +
                              "| । ࠡ⭮   ਮ" +
                              "|| ਮ  %#######%  %#######%|",
                              "%C<N.y>NI" + "%C<N.y>NI"),
          , INFORM, -1, FstMonth, LstMonth);

   IF Staff.BegDate > FstMonth THEN
    AddInfo:="⭨ ⮨   ।  " + L_DatTim.DateStr(Staff.BegDate) + "."
   ELSE
    AddInfo:="";
   END;

   GetDutyDgr(HDay, DWeek, AddInfo, Feature);
   L_MSO.wordSetVar(Root + "Feature", Feature);
   L_MSO.wordSetVar(Root + "AdditionalInfo", AddInfo);
   L_MSO.wordSetVar(Root + "WorkTime", L_Str.IntStr(HDay) + " . ࠡ.  " +
                                       L_Str.IntStr(DWeek) + " . ");

   SETZERO(_Sum, Idx);
   P:=FstMonth;
   SysD:=SYSDATE();
   WHILE P <= LstMonth DO
    PROMPT(L_DatTim.PeriodStr(P));
    SETZERO(SumM);
    SAVE(Staff);
    SELECT(Staff, MyFirm, , Staff.MyFirm, Staff.Man);
    WHILE OCCURE(Staff) DO
     SELECT(Money, PayFor, , Staff.TSN, P);
     WHILE OCCURE(Money) DO                      
      MoneyType(_MoneyType);
      IF ~!_MoneyType THEN
       INC(SumM[_MoneyType], L_General.Denominate(Money.Closed, SysD, Money.Sum));
      END;
      NEXT(Money);
     END; (* WHILE OCCURE(Money)... *)
     INC(SumM[1], GetLongPerBonuses(P));
     NEXT(Staff);
    END;
    RESTORE(Staff);

    FOR_EACH _MoneyType DO
     IF SumM[_MoneyType] = 0 THEN
      SETEMPTY(SumM[_MoneyType]);
     ELSE
      INC(_Sum[_MoneyType], SumM[_MoneyType]);
      INC(SumM[3], SumM[_MoneyType]);
     END;
    END;
    L_MSO.wordSetDateVar( Root + "Money.Month" + L_MSO.IndexStr(Idx), P);
    L_MSO.wordSetMoneyVar(Root + "Money.Type0" + L_MSO.IndexStr(Idx), D, SumM[0]);
    L_MSO.wordSetMoneyVar(Root + "Money.Type1" + L_MSO.IndexStr(Idx), D, SumM[1]);
    L_MSO.wordSetMoneyVar(Root + "Money.Type2" + L_MSO.IndexStr(Idx), D, SumM[2]);
    L_MSO.wordSetMoneyVar(Root + "Money.Sum"   + L_MSO.IndexStr(Idx), D, SumM[3]);
    INC(Idx);
    P:=L_DatTim.IncMonth(P, +1);
   END;

   _Sum[3]:=_Sum[0]+_Sum[1]+_Sum[2];
   L_MSO.wordSetMoneyVar(Root + "Money.Type0.Sum", D, _Sum[0]);
   L_MSO.wordSetMoneyVar(Root + "Money.Type1.Sum", D, _Sum[1]);
   L_MSO.wordSetMoneyVar(Root + "Money.Type2.Sum", D, _Sum[2]);
   L_MSO.wordSetMoneyVar(Root + "Money.Sum.Sum",   D, _Sum[3]);
  END;
 END {NVTEK};

 PRIVATE PROCEDURE DME02(D: DATE; Root: STRING[]);
  VAR
   curDirtyTyp: LIKE(DirtyTyp.DirtyTyp);
   typ        : STRING[];
 BEGIN
  IF ~!Root THEN
   L_General.Assert(P_Man.HasActualManPro(Staff.Man, D, P_Man.P_HazardMedExamination),
                    " ନ ᢮⢮  5208");
   P_Man.Decode_HazardMedExamination(ManPro.Value, curDirtyTyp, typ);
   L_General.Assert(typ = L_Str.PoolItem(P_Man.GetManProPool(P_Man.P_HazardMedExamination), 0),
                    " ன ᬮ (" + typ + ")");
   L_MSO.wordSetVarsByFile_wAlias("ManPro", "Staff.Man.HazardMedExamination");
   CONFORM(StaffLog, Officer);
   SEARCH(DirtyTyp, DirtyTyp, , P_Officer.GetP_LCDirtyTyp(Officer.Sort, Officer.Officer, D));
   L_General.Assert(DirtyTyp.DirtyTyp = curDirtyTyp,
                    "। ᫮  ࠢ  ᬮ" +
                    "| ᮮ⢥ ࠡ祬 ");
   L_MSO.wordSetVarsByFile_wAlias("DirtyTyp", "Staff.StaffLog.Officer.DirtyTyp");
   L_Staff.Set_AsLeaderVars(D, E_asLeaderForBegun(D));
  END; (* IF ~!Root *)
 END {DME02};

 PRIVATE PROCEDURE ApplDC01(D: DATE; Root: STRING[]);
  VAR
   LN,
   adr: STRING[];
 BEGIN
  IF ~!Root THEN
   L_Staff.PutScalablePhoto(SYSDATE(), 35);
   L_MSO.wordSetVarsByFile_wAliasE("ManPro", "Staff.Man.DriveSertification",
                                   ~P_Man.HasActualManPro(Man.Man, SYSDATE(), P_Man.P_DriveSertification));
   LN:=P_Man.GetDriveSertification_LatinName(Man.Man, SYSDATE());
   L_MSO.wordSetVar("Staff.Man.DriveSertification.LatinName", LN);
   L_MSO.wordSetVar("Staff.Man.DriveSertification.LatinName.Last",  Str.Item(LN, " ", 0));
   L_MSO.wordSetVar("Staff.Man.DriveSertification.LatinName.First", Str.Slice(LN, Str.Length(Str.Item(LN, " ", 0)), Str.Length(LN)));
   IF ~L_Man.AccessManAdr(Man.Man, SYSDATE(), L_Russia.at_DwMA) THEN
    L_Man.AccessRgManAdr(Man.Man, SYSDATE());
   END;
   L_Man.curManAdr_Set_glb_AdrVar();
   adr:=L_Russia.Adr_asStr(L_Russia.af_Post);
   IF ~!ManAdr.Zip THEN
    adr:=adr + ", " + ManAdr.Zip;
   END;
   L_MSO.wordSetVar(Root + ".Man.AdrSpcFormat",       adr);
   L_MSO.wordSetVar(Root + ".Man.AdrSpcFormat.Latin", L_Russia.RussianToTransliteration(adr));
  END;
 END {ApplDC01};

 PRIVATE PROCEDURE E_O_Staff_Copies(TemplateName: STRING[]): NUMERIC[0];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Staff.O_Staff_Copies);
  IF ~!Local THEN
   RETURN Local(TemplateName);
  ELSE
   RETURN 1;
  END;
 END {E_O_Staff_Copies};

 PRIVATE PROCEDURE E_O_Staff_GetAdditionalDocParams(    TemplateName   : STRING[];
                                                    VAR addTemplateName: STRING[];
                                                    VAR addTextParam   : STRING[];
                                                    VAR addPrepareProc : PROC;
                                                    VAR addPutInFields : SCAL[2]);
  VAR
   Local               : PROC;
   addPrepareProc_AsStr: STRING[];
 BEGIN
  SETEMPTY(addTemplateName, addTextParam, addPrepareProc);
  Local:=PROCREF(E_Staff.O_Staff_GetAdditionalDocParams);
  IF ~!Local THEN
   Local(TemplateName, addTemplateName, addTextParam, addPrepareProc_AsStr, addPutInFields);
   addPrepareProc:=PROCREF(^addPrepareProc_AsStr);
  END;
 END {E_O_Staff_GetAdditionalDocParams};

 PRIVATE PROCEDURE PutInWord_SingleAvePayP(Idx       : NUMERIC[0];
                                           ForceEmpty: SCAL[2]);
 BEGIN
(*!*)
L_MSO.wordSetVarsByFile_wIndex("AvePayP",  Idx, ForceEmpty);
IF ~ForceEmpty THEN
 L_MSO.wordSetVar("AvePayP"+L_MSO.IndexStr(Idx)+".Amount", FLDTOSTR(AvePayP.Amount, L_AvePay.DaysFormat(), 0));
END;
L_MSO.wordSetVarsByFile_wIndex("AveTypeP", Idx, ForceEmpty);
(*!*)
  L_MSO.wordSetVarsByFile_wAliasE("AvePayP",  "AvePay.AvePayP" + L_MSO.IndexStr(Idx), ForceEmpty);
  L_MSO.wordSetVarsByFile_wIndexedPrefixE("AveTypeP", "AvePay.AvePayP", Idx, ForceEmpty);
 END {PutInWord_SingleAvePayP};

 PRIVATE PROCEDURE T6(D: DATE);
  VAR
   Idx,
   AddDays    : NUMERIC[0];
   MainAvePayP: LIKE(AvePayP.AveTypeP);
 BEGIN
  Set_DocCause(D);
  L_Staff.Set_AsLeaderVars(D, E_asLeaderForEDO(D));
  CONFORM(AvePay, AveType);
  SELECT(AvePayP, AvePay, , AvePay.AvePay);
  SETEMPTY(MainAvePayP);
  Idx    :=0;
  AddDays:=0;
  WHILE OCCURE(AvePayP) DO
   CONFORM(AvePayP, AveTypeP);
   IF !MainAvePayP & (AveType.LimType = L_AvePay.avelim_Hldy) &
      ~!AveTypeP.JMode & (AveTypeP.DrtnIdx = L_AvePay.vt_Main) THEN
    PutInWord_SingleAvePayP(99, 0);
    MainAvePayP:=AvePayP.AveTypeP;
   ELSE
    PutInWord_SingleAvePayP(Idx, 0);
    INC(AddDays, AvePayP.Amount);
    INC(Idx);
   END;
   NEXT(AvePayP);
  END; (* WHILE OCCURE(AvePayP)...*)
  IF !MainAvePayP THEN
   PutInWord_SingleAvePayP(99, 1);
  END;
  IF Idx = 0 THEN
   PutInWord_SingleAvePayP(Idx, 1);
  END; (* WHILE Idx <= MinIdxAmnt...*)
  L_MSO.wordSetVar("AvePay.Additional.Amount", FLDTOSTR(AddDays, L_AvePay.DaysFormat(), 0));
  L_MSO.SetWordTable("AvePayP", Idx);
 END {T6};

 PRIVATE PROCEDURE T60T61(D: DATE);
 BEGIN
  T6(D);
  CALL(AvePay.MakeProtocol2Word());
 END {T60T61};

 PRIVATE PROCEDURE T60(D: DATE);
 BEGIN
  T60T61(D);
 END {T60};

 PRIVATE PROCEDURE T61(D: DATE);
  VAR
   trgLbCNbr    : LIKE(StaffLog.LbCNbr);
   trgLbCDate   : LIKE(StaffLog.LbCDate);
   root,
   trgKindOfWork: STRING[];
 BEGIN
  T60T61(D);
  root:="AvePay.Staff.StaffLog";
  L_Staff.PosToStaffLog(Staff.TSN, AvePay.StartD, 1);
  L_Staff.GetLabourContractAttr(StaffLog.Date, trgLbCNbr, trgLbCDate, trgKindOfWork);
  L_MSO.wordSetVar    (root + ".LabourContract.Nbr",  trgLbCNbr);
  L_MSO.wordSetDateVar(root + ".LabourContract.Date", trgLbCDate);
  L_MSO.wordSetVar    (root + ".Officer.KindOfWork",  trgKindOfWork);

  IF NEXT(StaffLog) & ((L_Staff.GetStaffLogType() = L_Staff.slkt_Discharge) |
                       (L_Staff.GetStaffLogType() = L_Staff.slkt_TakeOnWithDischarge)) THEN
   L_MSO.wordSetVarsByFile_wAlias("StaffLog", root);
  END;
 END {T61};

 PRIVATE PROCEDURE T10(D: DATE);
 BEGIN
 END {T10};

(*-6*)
 PRIVATE PROCEDURE Create_MMDA();
 BEGIN
  CreateFILE(MMDA, "", "६ 䠩", "");

  CreateFIELD(MMDA, Math,        LIKE(Math.Math), "", "", "", "", "");
  CreateFIELD(MMDA, Name,        LIKE(Math.Name), "", "", "", " ", "");
  CreateFIELD(MMDA, Paragraph,   STRING[10],      "", "", "", "ࠣ ", "");
  CreateFIELD(MMDA, MUnit,       STRING[32],      "", "", "", " ७", "");
  CreateFIELD(MMDA, WorkingLife, STRING[32],      "", "", "", "ப 㦡", "");
  CreateFIELD(MMDA, Amount,      STRING[10],      "", "", "", "⢮", "");

  CreateINDEX(MMDA, Math, UNIQUE, "", "", Math);

  SetVersionOfFILE(MMDA, 1);
  L_AFM.AF_CreateTemp("MMDA", "MMDA");
 END {Create_MMDA};

 PRIVATE PROCEDURE Create_TmpDb();
 BEGIN
  CreateFILE(TmpDb, "", "६ 䠩 뤠/⮢", "");

  CreateFIELD(TmpDb, Date,                DATE, "", "", "", " 뤠", "");
  CreateFIELD(TmpDb, Math,                LIKE(Math.Math), "", "", "", "", "");
  CreateFIELD(TmpDb, DateCr, DATE,        "", "", "", " ", "");
  CreateFIELD(TmpDb, Amnt, NUMERIC[2],    "", "0", "", "뤠", "");
  CreateFIELD(TmpDb, AmntS, STRING[32],   "", "0", "", "뤠", "");
  CreateFIELD(TmpDb, AmntCr, NUMERIC[2],  "", "", "", "", "");
  CreateFIELD(TmpDb, AmntSCr, STRING[32], "", "", "", " (ப)", "");
  CreateFIELD(TmpDb, Prc, STRING[32],     "", "", "", "業 ", "");
  CreateFIELD(TmpDb, Price, NUMERIC[3],   "", "0", "", "", "");
  CreateFIELD(TmpDb, PriceS, STRING[32],  "", "0", "", " (ப)", "");

  CreateINDEXandLINK(TmpDb, Math, UNIQUE, Math, Math, USER, "", "", Math, Date);
  SetVersionOfFILE(TmpDb, 0);
  L_AFM.AF_CreateTemp("TmpDb", "TmpDb");
 END {Create_TmpDb};

 PRIVATE PROCEDURE Create_TmpCr();
 BEGIN
  CreateFILE(TmpCr, "", "६ 䠩 ⮢", "");

  CreateFIELD(TmpCr, Date, DATE, "", "", "", " ", "");
  CreateFIELD(TmpCr, Math, LIKE(Math.Math), "", "", "", "", "");
  CreateFIELD(TmpCr, Amnt, NUMERIC[2], "", "0", "", "", "");

  CreateINDEXandLINK(TmpCr, Math, UNIQUE, Math, Math, USER, "", "", Math, Date);

  SetVersionOfFILE(TmpCr, 0);
  L_AFM.AF_CreateTemp("TmpCr", "TmpCr");
 END {Create_TmpCr};

 PRIVATE PROCEDURE CalcPrice();
 BEGIN
  TmpDb.Price :=L_MathR.GetMDLMathPrice();
  TmpDb.PriceS:=L_Money.MoneyToStr(MDoc.Date, "", TmpDb.Price);
  TmpDb.AmntS :=L_MathR.DefaultFormatCir(TmpDb.Math, TmpDb.Amnt) + " " +
                L_MathR.DefaultMUnitSign(TmpDb.Math);
  REPLACE(TmpDb);
 END {CalcPrice};

 PRIVATE PROCEDURE gbst_Put(mft: L_MDoc.tMathFlowType);
 BEGIN
  IF mft = L_MDoc.mft_Debit THEN
   ADD(TmpDb, Math, , MDocList.Math, MDoc.Date,
       TmpDb.Amnt, MDocList.Qnt);
   CalcPrice();
  ELSE
   ADD(TmpCr, Math, , MDocList.Math, MDoc.Date,
       TmpCr.Amnt, MDocList.Qnt);
  END;
 END {gbst_Put};

 PRIVATE PROCEDURE MB6_GatherBySingleTSN(trgMathType: LIKE(Math.MathType));
  VAR
   mft: L_MDoc.tMathFlowType;
 BEGIN
  Create_TmpDb();
  Create_TmpCr();
  IF ~!Staff.Storage THEN
   SELECT(MDoc, TSN, , Staff.TSN);
   WHILE OCCURE(MDoc) DO
    PROMPT(Staff.TSN + ": "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+" "+L_DatTim.DateStr(MDoc.Date));
    IF (MDoc.Storage # Staff.Storage) & (MDoc.Storage2 # Staff.Storage) THEN
     CONFORM(MDoc, MDocList);
     WHILE OCCURE(MDocList) DO
      CONFORM(MDocList, Math);
      IF Math.MathType = trgMathType THEN
       mft:=L_MDoc.InvertMathFlowType(L_MDoc.getMDocListStorageRelatedMathFlowType());
       IF L_MathR.IsAdvHolderFlow(mft) THEN
        gbst_Put(mft);
       END;
      END;
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList) ... *)
    END;
    NEXT(MDoc);
   END; (* WHILE OCCURE(MDoc) ... *)
   SELECT(MDoc, Storage, , Staff.Storage);
   WHILE OCCURE(MDoc) DO
    PROMPT(Staff.TSN + ": "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+" "+L_DatTim.DateStr(MDoc.Date));
    CONFORM(MDoc, MDocList);
    WHILE OCCURE(MDocList) DO
     CONFORM(MDocList, Math);
     IF Math.MathType = trgMathType THEN
      gbst_Put(L_MDoc.getMDocListStorageRelatedMathFlowType());
     END;
     NEXT(MDocList);
    END; (* WHILE OCCURE(MDocList) ... *)
    NEXT(MDoc);
   END; (* WHILE OCCURE(MDoc) ... *)
   SELECT(MDoc, Storage2, , Staff.Storage);
   WHILE OCCURE(MDoc) DO
    PROMPT(Staff.TSN + ": "+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc)+" "+L_DatTim.DateStr(MDoc.Date));
    CONFORM(MDoc, MDocList);
    WHILE OCCURE(MDocList) DO
     CONFORM(MDocList, Math);
     IF Math.MathType = trgMathType THEN
      gbst_Put(L_MDoc.InvertMathFlowType(L_MDoc.getMDocListStorageRelatedMathFlowType()));
     END;
     NEXT(MDocList);
    END; (* WHILE OCCURE(MDocList) ... *)
    NEXT(MDoc);
   END; (* WHILE OCCURE(MDoc) ... *)
  END;
 END {MB6_GatherBySingleTSN};

 PRIVATE PROCEDURE GetGroupMathMUnit(mainMath : LIKE(Math.Math);
                                     trgParent: LIKE(Math.Parent);
                                     trgMUnit : LIKE(MUnit.MUnit);
                                     Text     : STRING[]): LIKE(MUnit.MUnit);
 BEGIN
  SAVE(Math);
  SELECT(Math, Parent, , trgParent);
  WHILE OCCURE(Math) DO
   IF Math.Leaf = 1 THEN
    IF ~!trgMUnit THEN
     L_General.Assert(trgMUnit = Math.MUnit, Text + "||" +
                                             " 㯯஢筮  " + mainMath + ", 㪠  ᢮⢥,|" +
                                             " 室騥   㯯      ७.||" +
                                             "  " + Math.Math + " 㪠 㣠  ७ '" + L_MathR.DefaultMUnitSign(Math.Math) + "'");
    END;
    trgMUnit:=Math.MUnit;
   ELSE
    trgMUnit:=GetGroupMathMUnit(mainMath, Math.Math, trgMUnit, Text);
   END;
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)
  RESTORE(Math);
  RETURN trgMUnit;
 END {GetGroupMathMUnit};

 PRIVATE PROCEDURE GetMathMUnitSign(Text: STRING[]): STRING[];
  VAR
   trgMUnit: LIKE(MUnit.MUnit);
 BEGIN
  IF Math.Leaf = 1 THEN
   trgMUnit:=Math.MUnit;
  ELSE
   SETEMPTY(trgMUnit);
   trgMUnit:=GetGroupMathMUnit(Math.Math, Math.Math, trgMUnit, Text);
  END;
  L_General.Assert(~!trgMUnit, " 㤠 ।  ७  " + Math.Math);
  RETURN L_MathR.MUnitSign(trgMUnit);
 END {GetMathMUnitSign};

 PRIVATE PROCEDURE intMB6_Prepare(D: DATE; Root: STRING[]; trgMathType: LIKE(Math.MathType));
  VAR
   Text          : STRING[];
   i             : NUMERIC[0];
   arrMath       : LIKE(Math.Math)[P_Officer.mmda_Amount];
   arrParagraph  : STRING[][P_Officer.mmda_Amount];
   arrWorkingLife: NUMERIC[0][P_Officer.mmda_Amount];
   arrAmount     : P_Officer.tmmdaAmnt[P_Officer.mmda_Amount];
   _WorkingLife  : STRING[];
   _Prc          : NUMERIC[2];
   LifeTimeUnit  : P_Math.tLifeTimeUnit;
   LifeTime      : NUMERIC[0];
   Growth        : NUMERIC[0];
   Weight        : NUMERIC[1];
   SizeClothing  : NUMERIC[0];
   SizeShoes     : NUMERIC[1];
   SizeHat       : NUMERIC[0];
   SizeMittens   : NUMERIC[0];
   SizeGloves    : NUMERIC[1];
   SizeMask      : NUMERIC[0];
   SizeRespirator: NUMERIC[0];
 BEGIN
  IF ~!Root THEN
   L_Staff.PosToStaffLog(Staff.TSN, D, 1);
   CONFORM(StaffLog, Officer);
   SETEMPTY(arrMath, arrParagraph, arrWorkingLife, arrAmount);
   IF    P_Officer.HasActualOfcPro(StaffLog.Sort, StaffLog.Officer, D, P_Officer.P_MantoManDefenceAss) THEN
    P_Officer.Decode_MantoManDefenceAss(OfcPro.Value, arrMath, arrParagraph, arrWorkingLife, arrAmount);
    Text:=" " + Officer.Officer + ", ᥪ " + Officer.Sort + ", ᢮⢮ " + L_Str.IntStr(P_Officer.P_MantoManDefenceAss);
   ELSIF P_Post.HasActualPro(Officer.Post, D, P_Post.P_MantoManDefenceAss, L_Prop.dsc_Normal) THEN
    P_Officer.Decode_MantoManDefenceAss(PostPro.Value, arrMath, arrParagraph, arrWorkingLife, arrAmount);
    CONFORM(Officer, Post);
    Text:=" " + Officer.Post + " " + Post.Name + ", ᢮⢮ " + L_Str.IntStr(P_Post.P_MantoManDefenceAss);
   ELSE
    L_StdFrm.Question(" " + L_DatTim.DateStr(D) + "    |" +
                      " । 㠫쭮 |" +
                      "  ,   ࠡ祣 ");
   END;
   Create_MMDA();
   i:=0;
   WHILE (i < P_Officer.mmda_Amount) & ~!arrMath[i] DO
    L_General.CallUs(SEARCH(Math, Math, arrMath[i]));
    IF Math.MathType = trgMathType THEN
     MMDA.Math       :=arrMath[i];
     MMDA.Name       :=Math.Name;
     MMDA.Paragraph  :=arrParagraph[i];
     MMDA.MUnit      :=GetMathMUnitSign(Text);
     MMDA.Amount     :=L_Str.NumericStr(arrAmount[i], 2);
     _WorkingLife    :=L_Str.IntStr(arrWorkingLife[i]);
     IF !_WorkingLife THEN
      P_Math.GetLifeTime(Math.Math, D, L_CUC.cnd_New, LifeTimeUnit, LifeTime);
      IF LifeTimeUnit = P_Math.ltu_Month THEN
       _WorkingLife:=FLDTOSTR(LifeTime, "0");
      END;
     END;
     MMDA.WorkingLife:=_WorkingLife;
     INSERT(MMDA);
    END;
    INC(i);
   END;
 
   i:=0;
   SELECT(MMDA, Math);
   WHILE OCCURE(MMDA) DO
    L_MSO.wordSetVarsByFile_wAliasAndIndexE("MMDA", "Staff.MMDA", i, 0);
    INC(i);
    NEXT(MMDA);
   END; (* WHILE OCCURE(MMDA) ... *)
   IF i = 0 THEN
    L_MSO.wordSetVarsByFile_wAliasAndIndexE("MMDA", "Staff.MMDA", 0, 1);
   END;
   L_MSO.SetWordTable("MMDA", i);
 
   CONFORM(Staff, Man);
   L_MSO.wordSetVarsByFile_wPrefix("Man", "Staff.");

   P_Man.Get_AnthropometricInf(Man.Man, D, Growth,
                                           Weight,
                                           SizeClothing,
                                           SizeShoes,
                                           SizeHat,
                                           SizeMittens,
                                           SizeGloves,
                                           SizeMask,
                                           SizeRespirator);
   L_MSO.wordSetVar("Staff.Man.Height",         FLDTOSTR(Growth,         "0"));
   L_MSO.wordSetVar("Staff.Man.Weight",         FLDTOSTR(Weight,         "1."));
   L_MSO.wordSetVar("Staff.Man.ClothesSize",    FLDTOSTR(SizeClothing,   "0"));
   L_MSO.wordSetVar("Staff.Man.BootsSize",      FLDTOSTR(SizeShoes,      "1."));
   L_MSO.wordSetVar("Staff.Man.HatSize",        FLDTOSTR(SizeHat,        "0"));
   L_MSO.wordSetVar("Staff.Man.GauntletSize",   FLDTOSTR(SizeMittens,    "0"));
   L_MSO.wordSetVar("Staff.Man.GloveSize",      FLDTOSTR(SizeGloves,     "1."));
   L_MSO.wordSetVar("Staff.Man.Gas_maskSize",   FLDTOSTR(SizeMask,       "0"));
   L_MSO.wordSetVar("Staff.Man.RespiratorSize", FLDTOSTR(SizeRespirator, "0"));

   L_Staff.WordSetManName("Staff.");
   MB6_GatherBySingleTSN(trgMathType);
   SELECT(TmpCr, Math);
   WHILE OCCURE(TmpCr) DO
    IF SELECT(TmpDb, Math, TmpCr.Math) THEN
     WHILE OCCURE(TmpDb) &
           (TmpDb.Date < TmpCr.Date) &
           ~!TmpDb.DateCr DO
      NEXT(TmpDb);
     END; (* WHILE OCCURE(TmpDb) &...*)
     IF OCCURE(TmpDb) & (TmpDb.Date < TmpCr.Date) THEN
      TmpDb.DateCr :=TmpCr.Date;
      TmpDb.AmntCr :=TmpCr.Amnt;
      TmpDb.AmntSCr:=L_MathR.DefaultFormatCir(TmpDb.Math, TmpCr.Amnt) + " " +
                     L_MathR.DefaultMUnitSign(TmpDb.Math);
      IF SEARCH(MMDA, Math, TmpCr.Math) & ~!MMDA.WorkingLife THEN
       _Prc:=L_DatTim.MonthsInIntvl(TmpDb.Date, TmpDb.DateCr) / STRTOFLD(MMDA.WorkingLife, NUMERIC) * 100;
       IF _Prc > 100 THEN
        _Prc:=100;
       END;
       TmpDb.Prc   :=FLDTOSTR(100 - _Prc, "2.");
      END;
      REPLACE(TmpDb);
     END;
    END;
    NEXT(TmpCr);
   END; (* WHILE OCCURE(TmpCr) ... *)
 
   i:=0;
   SELECT(TmpDb, Math);
   WHILE OCCURE(TmpDb) DO
    PROMPT(TmpDb.Math);
    CONFORM(TmpDb, Math);
    CHANGESEL(TmpDb, Math, , TmpDb.Math);
    WHILE OCCURE(TmpDb) DO
     L_MSO.wordSetVarsByFile_wAliasAndIndexE("TmpDb", "Staff.InUse", i, 0);
     L_MSO.wordSetVarsByFile_wIndexedPrefixE("Math",  "Staff.InUse", i, 0);
     INC(i);
     NEXT(TmpDb);
    END; (* WHILE OCCURE(TmpDb) ... *)
    LAST(TmpDb);
    CHANGESEL(TmpDb, Math);
    NEXT(TmpDb);
   END; (* WHILE OCCURE(TmpDb) ... *)
 
   L_MSO.extSetWordTable("InUse", i, L_MSO.tt_Soft);
 
   L_AFM.AF_PurgeTemp("TmpCr");
   L_AFM.AF_PurgeTemp("TmpDb");
   L_AFM.AF_PurgeTemp("MMDA");
  END;
 END {intMB6_Prepare};

 PRIVATE PROCEDURE MB6_Prepare(D: DATE; Root: STRING[]);
 BEGIN
  intMB6_Prepare(D, Root, L_MathR.mtyp_Cloth);
 END {MB6_Prepare};

 PRIVATE PROCEDURE MB6_15_Prepare(D: DATE; Root: STRING[]);
 BEGIN
  (* 0097127 *)
  intMB6_Prepare(D, Root, 15(*뢠騥  ०騥 ⢠*));
 END {MB6_15_Prepare};

 PRIVATE PROCEDURE Alimony(D: DATE; Root: STRING[]);
  VAR
   P   : DATE;
   i   : NUMERIC[0];
   Sum : NUMERIC[2];
   root: STRING[];
 BEGIN
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
  root:=Root + "DedAcnt";
  SETZERO(Sum, i);
  SELECT(DedAcnt, TSN, , Deduct.TSN, Deduct.DedNbr);
  P:=Memo.ud_fr();
  WHILE P <= L_DatTim.Per(D) DO
   L_MSO.wordSetVarsByFile_wAliasAndIndexE("DedAcnt", root, i,
                                           ~SRCINSEL(DedAcnt, EQ, P));
   IF OCCURE(DedAcnt) & (DedAcnt.NetDebt >= 0) THEN
    INC(Sum, L_General.Denominate(DedAcnt.Period, D, DedAcnt.NetDebt));
   ELSE
    L_MSO.wordSetDateVar (root + L_MSO.IndexStr(i) + ".Period",  P);
    L_MSO.wordSetMoneyVar(root + L_MSO.IndexStr(i) + ".NetDebt", P, 0);
   END;
   INC(i);
   P:=L_DatTim.IncMonth(P, 1);
  END;
  L_MSO.wordSetMoneyVar(Root + "TotalPay",    D, Sum);
  L_MSO.wordSetDateVar (Root + "PeriodStart", Memo.ud_fr());
  L_MSO.wordSetDateVar (Root + "PeriodEnd",   D);
  L_MSO.SetWordTable("PaydByMonth", i);
 END {Alimony};

 PRIVATE PROCEDURE SalaryTr(D: DATE; Root: STRING[]);
  VAR
   root,
   _name,
   _bank,
   _bic_,
   _inn_ : STRING[];
   _acnt : STRING[][2];
 BEGIN
  L_General.Assert(Deduct.DedType = L_PDoc.SPC_DEDTYPE, " 㤥ঠ  ᯮ|" +
                                                        " ᫥ ࠡ⭮   ");
  L_Man.wordSetAddresses(Root + "Staff.Man.", Man.Man, D);
  IF ~!Deduct.FirmAcnt THEN
   CONFORM(Deduct, FirmAcnt);
   CONFORM(FirmAcnt, Bank);
  ELSE
   P_Firm.AccessSilentFirmAcnt(Deduct.Firm, D);
  END;
  P_Firm.SetFirmDefaultData("Deduct", Deduct.Firm, D, "");

  root:=Root + "Bank.";
  P_Firm.GetFirmData(D, _name, _bank, _acnt, _bic_, _inn_, 0);
  L_MSO.wordSetVar(root+"RegName",   _bank);
  L_MSO.wordSetVar(root+"CorAcnt",   _acnt[1]);
  L_MSO.wordSetVar(root+"BIC",       _bic_);
 END {SalaryTr};

 PRIVATE PROCEDURE PrintAddHol(D: DATE; Root: STRING[]);
  VAR
   i     : NUMERIC[0];
   Result: STRING[];
 BEGIN
  CONFORM(StaffLog, Officer);
  CONFORM(Officer, AlType);
  HISTCONF(D, AlType, AlTypeL);
  Result:="";
  i:=1;
  WHILE i <= HIGH(AlTypeL.Duration) DO
   IF AlTypeL.Duration[i] # 0 THEN
    Result:=L_Str.AddStrDlm(Result, "; ") +
            L_Str.PoolItem(" | . ᪮㤠 , १㬠   25.10.1974 N 298/-22" +
                           "| 뢭 ⠦ ࠡ" +
                           "| ନ஢ ࠡ稩 " +
                           "| 稬 ᭮", i) + " " +
            L_Str.IntStr(AlTypeL.Duration[i]) + " " +
            Str.EnumObject(AlTypeL.Duration[i], "||");
   END;
   INC(i);
  END;
  IF !Result THEN
   Result:=" ।⠢";
  END;
  L_MSO.wordSetVar(Root + "StaffLog.AddHolLength", Result);
 END {PrintAddHol};

 PRIVATE PROCEDURE lbc_PrintCommon(D: DATE; Root: STRING[]);
  VAR
   PersonalInfAccess,
   ExtraCondition,
   FixedDateContractReason: STRING[];
   CntrEnd                : DATE;
 BEGIN
  PrintAddHol(D, Root);
  L_MSO.wordSetVar(Root + "StaffLog.ExtraWagePayCondition", E_T1_ExtraText(D));
  SETEMPTY(FixedDateContractReason);
  IF StaffLog.ContDTyp = L_Staff.cdt_FixedDate THEN
   CntrEnd:=L_Man.GetTimedContractEndDate(D);
   IF ~!CntrEnd THEN
    FixedDateContractReason:="ப ⢨ 饣 :  "+L_DatTim.FullDateStr(StaffLog.Date)+
                                                              "  "+L_DatTim.FullDateStr(CntrEnd)+"."+
                             " ⥫⢠ (稭), 㦨訥 ᭮  祭 : ";
    IF L_Man.LaborActivityLicenseRequired(Man.Man, D) THEN
     FixedDateContractReason:=FixedDateContractReason+' " ࠢ  ࠭ ࠦ  ᨩ᪮ 樨", 筮 .';
    ELSE
     FixedDateContractReason:=FixedDateContractReason+'筮 .';
    END;
   ELSE
    IF ~!Root THEN
     L_StdFrm.Choice(" 㪠 ப ⢨ 筮 㤮 ");
    END;
    FixedDateContractReason:="ப ⢨ 饣 :  ।";
   END;
  END;
  L_MSO.wordSetVar(Root + "StaffLog.FixedDateContractReason", Str.Condense(FixedDateContractReason));

  SETEMPTY(ExtraCondition, PersonalInfAccess);
  ExtraCondition:="ᯮ 易 ६  ࠡ⭨ ࠧ";
  L_MSO.wordSetVar(Root + "StaffLog.ExtraCondition", ExtraCondition);

  IF P_Officer.HasActualPro_Normal(Officer.Sort, Officer.Officer, D, P_Officer.P_PersonalInfAccess) THEN
   PersonalInfAccess:=",  ⮬ ᫥  ᮭ " +
                      ",   樯, ⨢, ࠦ᪮-ࠢ  " +
                      "㣮 ⢥⢥  ᮮ⢥⢨  䥤ࠫ묨   襭 " +
                      ", ॣ㫨 祭, ࠡ   ᮭ .";
  ELSE
   PersonalInfAccess:="";
  END;
  L_MSO.wordSetVar(Root + "StaffLog.PersonalInfAccess", PersonalInfAccess);
 END {lbc_PrintCommon};

 PRIVATE PROCEDURE LbC01(D: DATE; Root: STRING[]);
  VAR
   Local: PROC;
 BEGIN
  lbc_PrintCommon(D, Root);
  Local:=PROCREF(E_Staff.LbC01Prepare);
  IF ~!Local THEN
   Local(D, Root);
  END;
 END {LbC01};

 PRIVATE PROCEDURE Liabilit(D: DATE; Root: STRING[]);
  VAR
   Local: PROC;
 BEGIN
  L_Staff.Set_AsLeaderVars(D, EMPTYOF(SgnAuthR.SgnAuthR));
  Local:=PROCREF(E_Staff.LiabilitPrepare);
  IF ~!Local THEN
   Local(D, Root);
  END;
 END {Liabilit};

 PRIVATE PROCEDURE AddLbC01(D: DATE; Root: STRING[]);
  VAR
   Local     : PROC;
 BEGIN
  lbc_PrintCommon(D, Root);
  Local:=PROCREF(E_Staff.AddLbC01Prepare);
  IF ~!Local THEN
   Local(D, Root);
  END;
 END {AddLbC01};

 PRIVATE PROCEDURE intPrepareStaffObjects(Root, _LbCNbr: STRING[]; _LbCDate: DATE; _KindOfWork: STRING[]; D: DATE; ProcName: PROC);
 BEGIN
  CONFORM(Staff, Man);
  L_MSO.wordSetVarsByFile_wPrefixE("Man",   Root, ~OCCURE(Man));
  L_MSO.wordSetVar(Root + "Man.Telephon", L_Man.ManPhone(D));
  L_Man.wordSetAddresses(Root + "Man.", Man.Man, D);
  IF ~L_Man.AccessManAdr(Man.Man, SYSDATE(), L_Russia.at_CtMA) THEN
   L_Man.AccessRgManAdr(Man.Man, SYSDATE());
  END;
  CONFORM(ManAdr, Country);
  L_MSO.wordSetVarsByFile_wAlias("Country", Root + "Man.Citizenship");
  L_Staff.WordSetManName(Root);
  L_MSO.wordSetVar    (Root + "StaffLog.LabourContract.Nbr",  _LbCNbr);
  L_MSO.wordSetDateVar(Root + "StaffLog.LabourContract.Date", _LbCDate);
  L_MSO.wordSetVar    (Root + "StaffLog.Officer.KindOfWork",  _KindOfWork);
  IF ~!ProcName THEN
   ProcName(D, Root);
  END;
 END {intPrepareStaffObjects};

 PRIVATE PROCEDURE PrepareStaffObjects(D: DATE; ProcName: PROC);
  VAR
   _LbCNbr : STRING[];
   _LbCDate: DATE;
   _KindOfWork: STRING[];
 BEGIN
  PROMPT(Staff.TSN + ": ⮢ ");
  P_Firm.SetFirmDefaultData("Own", L_Staff.GetFirmOfStaff(), D, "");
  L_Staff.StaffFileFamily(D, D, "Staff");
  L_Staff.GetLabourContractAttr(D, _LbCNbr, _LbCDate, _KindOfWork);
  intPrepareStaffObjects("Staff.", _LbCNbr, _LbCDate, _KindOfWork, D, ProcName);
  intPrepareStaffObjects("",       _LbCNbr, _LbCDate, _KindOfWork, D, ProcName);
 END {PrepareStaffObjects};

 PRIVATE PROCEDURE PrepareAPObjects(D: DATE; ProcName: PROC);
  VAR
   _PeriodLength: NUMERIC[0];
   Prefix       : STRING[];
 BEGIN
  CONFORM(AvePay, Staff);
  CONFORM(AvePay, AveType);
  CONFORM(Staff, Man);
  P_Firm.SetFirmDefaultData("Own", L_Staff.GetFirmOfStaff(), D, "");
  L_Staff.StaffFileFamily(D, D, "Staff");
  L_MSO.wordSetVarsByFile("AvePay");
  IF ~!AvePay.StopD THEN
   _PeriodLength:=AvePay.StopD-AvePay.StartD+1;
  ELSE
   _PeriodLength:=AvePay.Amount;
  END;
  L_MSO.wordSetVar("AvePay.Amount",       FLDTOSTR(AvePay.Amount, "0", 0));
  L_MSO.wordSetVar("AvePay.PeriodLength", FLDTOSTR(_PeriodLength, "0", 0));
  L_MSO.wordSetDateVar("AvePay.PFTill",   GetPFDateE());
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  CONFORM(StaffLog, Post);
  CONFORM(StaffLog, Officer);
(*!*)
L_MSO.wordSetVarsByFile("AveType");
L_MSO.wordSetVarsByFile("Staff");
L_MSO.wordSetVarsByFile("Man");
L_MSO.wordSetVarsByFile("Post");
L_MSO.wordSetVar("Man.ShortName", L_Str.ShortName(Man.Name));
(*!*)
  Prefix:="AvePay.";
  L_MSO.wordSetVarsByFile_wPrefixE("AveType",  Prefix, 1);
  L_MSO.wordSetVarsByFile_wPrefixE("Staff",    Prefix, 1);
  Prefix:=Prefix + "Staff.";
  L_MSO.wordSetVarsByFile_wPrefixE("Man",      Prefix, 1);
  L_MSO.wordSetVar(Prefix + "Man.Name.Short", L_Str.ShortName(Man.Name));
  L_MSO.wordSetVarsByFile_wPrefixE("StaffLog", Prefix, 1);
  Prefix:=Prefix + "StaffLog.";
  L_MSO.wordSetVarsByFile_wPrefixE("Officer",  Prefix, 1);
  Prefix:=Prefix + "Officer.";
  L_MSO.wordSetVarsByFile_wPrefixE("Post",     Prefix, 1);

  IF ~!ProcName THEN
   ProcName(D);
  END;
 END {PrepareAPObjects};

 PRIVATE PROCEDURE PrepareDeductObjects(D: DATE; ProcName: PROC);
  VAR
   Root: STRING[];
 BEGIN
  Root:="Deduct.";
  CONFORM(Deduct, Staff);
  CONFORM(Deduct, DedType);
  CONFORM(Staff, Man);
  P_Firm.SetFirmDefaultData("Own", L_Staff.GetFirmOfStaff(), D, "");
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  CONFORM(StaffLog, Post);
  L_MSO.wordSetVarsByFile("Deduct");
  L_MSO.wordSetVarsByFile_wPrefix("DedType",  "Deduct.");
  L_MSO.wordSetVarsByFile_wPrefix("Staff",    "Deduct.");
  L_MSO.wordSetVarsByFile_wPrefix("Man",      "Deduct.Staff.");
  L_MSO.wordSetVarsByFile_wPrefix("StaffLog", "Deduct.Staff.");
  L_MSO.wordSetVarsByFile_wPrefix("Post",     "Deduct.Staff.");
  L_MSO.wordSetDateVar(Root + "Staff.RealBegDate", L_Man.GetTakeOnDate(D));

  IF ~!ProcName THEN
   ProcName(D, Root);
  END;
 END {PrepareDeductObjects};

 PRIVATE PROCEDURE PrepareTaxInqObjects(D: DATE; ProcName: PROC);
 BEGIN
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  PrepareStaffObjects(D, ProcName);
 END {PrepareTaxInqObjects};

 PRIVATE PROCEDURE GetStaffDocDate(DateDef: STRING[]): DATE;
  VAR
   Result : DATE;
   GetDate: PROC;
 BEGIN
  IF    DateDef="StaffLog.Date" THEN
   L_Staff.PosToStaffLog(Staff.TSN, Memo.ud_cd(), 1);
   Result:=StaffLog.Date;
  ELSIF DateDef="Staff.BegDate" THEN
   Result:=L_Man.GetTakeOnDate(Memo.ud_cd());
   L_General.Assert(~!Result, " ⮩ 樨   㪠  ");
   SETSEL(StaffLog, TSN, Staff.TSN);
   LAST(StaffLog);
   WHILE OCCURE(StaffLog) &
    (L_Staff.GetStaffLogType() # L_Staff.slkt_TakeOn) &
    (L_Staff.GetStaffLogType() # L_Staff.slkt_TakeOnWithDischarge) DO
    PREV(StaffLog);
   END; (* WHILE OCCURE(StaffLog) ... *)
   IF StaffLog.Date # Result THEN
    L_StdFrm.Choice("   ⮏થ " + L_DatTim.DateStr(Memo.ud_cd()) +
                    "| ࠡ⭨  ਥ c " + L_DatTim.DateStr(StaffLog.Date) +
                    "||㬥 㤥 ⠭  ﭨ  " + L_DatTim.DateStr(Result));
   END;
  ELSIF DateDef="Staff.EndDate" THEN
   Result:=GetStaffEndDate();
   L_General.Assert(~!Result, " ⮩ 樨   㪠  㢮쭥");
  ELSIF DateDef="Memo.ud_cd()"  THEN
   Result:=Math.Max(Memo.ud_cd(), Staff.BegDate);
   L_Staff.PosToStaffLog(Staff.TSN, Result, 1);
  ELSIF DateDef="SYSDATE"  THEN
   Result:=SYSDATE();
   L_Staff.PosToStaffLog(Staff.TSN, Result, 1);
  ELSIF DateDef="LastBegan"  THEN
   L_Man.StandOnLastBegan(Staff.TSN, Memo.ud_cd());
   Result:=StaffLog.Date;
  ELSE
   GetDate:=PROCREF(^DateDef);
   L_General.Assert(~!GetDate, "O_Staff:  ᯮᮡ । ");
   Result:=GetDate();
   L_Staff.PosToStaffLog(Staff.TSN, Result, 1);
  END;
  RETURN Math.Max(Result, L_Env.aptm_Start);
 END {GetStaffDocDate};

 PRIVATE PROCEDURE GetAPDocDate(DateDef: STRING[]): DATE;
  VAR
   Result: DATE;
 BEGIN
  IF    DateDef = "AvePay.StartD" THEN
   Result:=AvePay.StartD;
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Math.Max(Result, L_Env.aptm_Start);
 END {GetAPDocDate};

 PRIVATE PROCEDURE GetDeductDocDate(DateDef: STRING[]): DATE;
  VAR
   Result: DATE;
 BEGIN
  IF    DateDef = "Memo.ud_ut()" THEN
   Result:=Memo.ud_ut();
  ELSIF DateDef = "Deduct.BegDate" THEN
   Result:=Deduct.BegDate;
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {GetDeductDocDate};

 PRIVATE PROCEDURE GetTaxInqDocDate(DateDef: STRING[]): DATE;
  VAR
   Result: DATE;
 BEGIN
  IF DateDef = "Memo.ud_cd()" THEN
   Result:=Memo.ud_cd();
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {GetTaxInqDocDate};

 PRIVATE PROCEDURE intMakeDoc(Source         : tDocSource;
                              TemplateName,
                              DateDef,
                              TextParam      : STRING[];
                              PrpMode        : L_MSO.PrpModeType;
                              PrepareProc    : PROC;
                              wGrantAllRights: SCAL[2]);
  VAR
   docD              : DATE;
   Copies            : NUMERIC[0];
   addTextParam,
   addTemplateName   : STRING[];
   addPutInFields    : SCAL[2];
   addPrepareProc,
   PrepareObjectsProc: PROC;
 BEGIN
  IF    Source = ds_Staff THEN
   docD              :=GetStaffDocDate(DateDef);
   PrepareObjectsProc:=PROCREF(PrepareStaffObjects);
  ELSIF Source = ds_Deduct THEN
   docD:=GetDeductDocDate(DateDef);
   PrepareObjectsProc:=PROCREF(PrepareDeductObjects);
  ELSIF Source = ds_AvePay THEN
   docD:=GetAPDocDate(DateDef);
   PrepareObjectsProc:=PROCREF(PrepareAPObjects);
  ELSIF Source = ds_TaxInq THEN
   docD:=GetTaxInqDocDate(DateDef);
   PrepareObjectsProc:=PROCREF(PrepareTaxInqObjects);
  ELSE
   L_General.CallUs(0);
  END;

  IF wGrantAllRights THEN
   L_AR.GrantRightsUnconditionally();
  END;

  Copies:=E_O_Staff_Copies(TemplateName);
  E_O_Staff_GetAdditionalDocParams(TemplateName, addTemplateName, addTextParam, addPrepareProc, addPutInFields);
  IF ~!addTemplateName THEN
   L_MSO.CreateTmpDot(TemplateName);
   L_MSO.wordInitDocument(docD);
   L_MSO.PutInFields:=addPutInFields;
   PrepareObjectsProc(docD, EMPTYOF(PROC));
   addPrepareProc(docD, TemplateName);
   L_MSO.MakeWordDocument(addTemplateName, 1, L_MSO.PrpMode_ToTmpDot, TemplateName + ";" + addTextParam);
  END;

  L_MSO.wordInitDocument(docD);
  PrepareObjectsProc(docD, PrepareProc);
  L_MSO.UseTmpDot:=~!addTemplateName;
  L_MSO.MakeWordDocument(TemplateName, Copies, PrpMode, TextParam);
 END {intMakeDoc};

 PRIVATE PROCEDURE extMakeDoc(Source   : tDocSource;
                              TextParam: STRING[];
                              PrpMode  : L_MSO.PrpModeType);
 BEGIN
  intMakeDoc(Source,
             MSODL.Template,
             MSODL.DateDef,
             TextParam,
             PrpMode,
             PROCREF(^(L_MSO.dl_GetPrepareProc())),
             MSODL.IsLocal);
 END {extMakeDoc};

 PRIVATE PROCEDURE MakeDoc(Source: tDocSource);
  VAR
   PrpMode: L_MSO.PrpModeType;
 BEGIN
  IF    Source = ds_Staff THEN
   L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  ELSIF Source = ds_Deduct THEN
   L_General.Assert(ACCESS(Deduct), " ⠭ 㤥ঠ");
  ELSIF Source = ds_AvePay THEN
   L_General.Assert(ACCESS(AvePay), " ⠭ 㬥  ⢨/ -।");
   L_General.Assert(L_AvePay.IsRealAvePay(), "㬥  ⢨/ -। 㫨஢");
  ELSIF Source = ds_TaxInq THEN
   L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
   L_General.Assert(ACCESS(TaxInq), " ࠭ ࠢ");
   L_General.Assert(TaxInq.InqType = L_Tax.inqt_Own, "ࠢ    '⢥ 䨪'");
  ELSE
   L_General.CallUs(0);
  END;

  DefineFullDocList(Source);
  PrpMode:=L_MSO.PrpMode_Print;
  L_MSO.dl_SelectDoc(PrpMode);

  extMakeDoc(Source, "", PrpMode);
 END {MakeDoc};

 PUBLIC PROCEDURE MakeStaffDoc();
 BEGIN
  MakeDoc(ds_Staff);
 END {MakeStaffDoc};

 PUBLIC PROCEDURE MakeDeductDoc();
 BEGIN
  MakeDoc(ds_Deduct)
 END {MakeDeductDoc};

 PUBLIC PROCEDURE MakeAPDoc();
 BEGIN
  MakeDoc(ds_AvePay);
 END {MakeAPDoc};

 PUBLIC PROCEDURE MakeTaxInqDoc();
 BEGIN
  MakeDoc(ds_TaxInq);
 END {MakeTaxInqDoc};

 PUBLIC PROCEDURE StreamPrintDoc(DocNameForStreamPrint: STRING[]);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   DefineFullDocList(ds_Staff);
   L_General.CallUs(~!DocNameForStreamPrint);
 
   L_General.Assert(SELECT(MSODL, Name, DocNameForStreamPrint), "  㬥 '" + DocNameForStreamPrint + "'  ⮪ ");
 
   extMakeDoc(ds_Staff, L_Print.GetPrinterName(L_Print.pt_Pass), L_MSO.PrpMode_Print);
  EXCEPT
  END; (* TRY *)
 END {StreamPrintDoc};

 PRIVATE PROCEDURE GetPassPrintDate(): DATE;
 BEGIN
  RETURN Math.Max(SYSDATE(), Staff.BegDate);
 END {GetPassPrintDate};

 PRIVATE PROCEDURE E_PassIntPrepare(D: DATE; Root: STRING[]);
  VAR
   Local: PROC;
 BEGIN
(*
஢ઠ  ⮩ Root -   맮 intPrepareStaffObjects. ⮣ 
*)
  IF ~!Root THEN
   Local:=PROCREF(E_Staff.PassIntPrepare);
   IF ~!Local THEN
    Local(D, Root);
   ELSE
    L_Staff.PassIntPrepare(D, 35);
   END;
  END;
 END {E_PassIntPrepare};

 PRIVATE PROCEDURE E_PassOutPrepare(D: DATE; Root: STRING[]);
  VAR
   Local: PROC;
 BEGIN
  IF ~!Root THEN
   Local:=PROCREF(E_Staff.PassOutPrepare);
   IF ~!Local THEN
    Local(D, Root);
   ELSE
    L_Staff.PassOutPrepare(D, 35);
   END;
  END;
 END {E_PassOutPrepare};

 PUBLIC PROCEDURE MakePassTemplate();
  VAR
   D              : DATE;
   Outsider       : SCAL[2];
   TemplateName,
   PassPrinterName: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Outsider       :=L_Staff.E_IsOutsider(SYSDATE());
  TemplateName   :=L_Staff.E_GetPassTemplateName(Outsider);
  L_General.Assert(~!TemplateName, "   ய  ஥");
  PassPrinterName:=L_Print.GetPrinterName(L_Print.pt_Pass);
  IF !PassPrinterName THEN
   L_StdFrm.RedInform(" ࠭ ਭ   ய᪮");
   LIKEMENU(Edit, "SpcPrntr 0 wAllPrntr=False wPrntr_4=True");
  END;
  IF Outsider THEN
   L_AR.GrantRightsUnconditionally();
   D:=SYSDATE();
   L_MSO.wordInitDocument(D);
   P_Firm.SetFirmDefaultData("Own", P_Firm.fomf(P_Firm.DefineMyFirm()), D, "");
   E_PassOutPrepare(D, "Man");
   L_MSO.MakeWordDocument(TemplateName, 1, L_MSO.PrpMode_Print, PassPrinterName);
  ELSE
   intMakeDoc(ds_Staff, TemplateName, "GetPassPrintDate", PassPrinterName, L_MSO.PrpMode_Print,
              PROCREF(E_PassIntPrepare), 1);
  END;
 END {MakePassTemplate};

 PUBLIC PROCEDURE ProbShtPrepare(D: DATE; Root: STRING[]);
  VAR
   List,
   r,
   RouteStr,
   PropVal  : STRING[];
   i,
   Choice   : NUMERIC[0];
 BEGIN
  IF ~!Root THEN
   SETSEL(EDOrderL, TSNGrOD, Staff.TSN, L_EDO.grp_Probation);
   IF SRCINSEL(EDOrderL, GE, D) THEN
    List:="";
    i:=0;
    WHILE OCCURE(EDOrderL) DO
     L_EDO.GetEDOLPropValue(P_EDOL.P_Route, PropVal);
     List:=List + L_DatTim.DateStr(EDOrderL.OcrDate) + " " +
                  EDOrderL.EDOrder + " " + EDOrderL.Row + " " +
                  Str.Align(PropVal, 15, LEFT) + "|";
     INC(i);
     NEXT(EDOrderL);
    END; (* WHILE OCCURE(EDOrderL) ... *)
    IF i > 1 THEN
     Choice:=L_StdFrm.ShowListAsMenu_wCaption(List, "롮 ਪ  ⠦஢",
                                              "       ਪ               |" +
                                              "");
    ELSE
     Choice:=0;
    END;
    SEARCH(EDOrderL, EDOrder, , Str.Item(L_Str.PoolItem(List, Choice), " ", 1),
                                Str.Item(L_Str.PoolItem(List, Choice), " ", 2));
    CONFORM(EDOrderL, EDOrder);
    L_MSO.wordSetVarsByFile_wPrefix("EDOrder" ,"Staff.");
    L_MSO.wordSetVarsByFile_wPrefix("EDOrderL" ,"Staff.EDOrder.");
    r:="Staff.EDOrder.EDOrderL.";
 
    L_EDO.GetEDOLPropValue(P_EDOL.P_Route, PropVal);
    RouteStr:="";
    i:=0;
    WHILE ~!L_Prop.getRES(PropVal, i) DO
     L_General.Assert(SEARCH(Route, Route, L_Prop.getRES(PropVal, i)),
                      "   " + L_Prop.getRES(PropVal, i));
     IF ~!RouteStr THEN
      RouteStr:=RouteStr + ", "(*CHR(11)*);
     END;
     RouteStr:=RouteStr + Route.Route + " " + Route.Name;
     INC(i);
    END;
    L_MSO.wordSetVar(r + "Route", RouteStr);
 
    L_EDO.GetEDOLPropValue(P_EDOL.P_BoxNbr, PropVal);
    IF ~!PropVal THEN
     L_General.Assert(SEARCH(Car, BoxNbr, PropVal), "   " + PropVal);
     L_Car.AccessMark(Car.BoxNbr, EDOrderL.OcrDate);
     L_MSO.wordSetVar(r + "Mark", Mark.Mark);
     L_MSO.wordSetVar(r + "Mark.Name", Mark.Name);
     L_MSO.wordSetVarsByFile_wPrefix("Car", r);
    ELSE
     L_EDO.GetEDOLPropValue(P_EDOL.P_MarkG, PropVal);
     L_MSO.wordSetVarsByFile_wPrefixE("Car", r, 1);
     L_MSO.wordSetVar(r + "Mark", "");
     IF ~!PropVal THEN
      L_General.Assert(SEARCH(MarkG, MarkG, PropVal), "  㯯 ப " + PropVal);
      L_MSO.wordSetVar(r + "Mark.Name", MarkG.Name);
     ELSE
      L_MSO.wordSetVar(r + "Mark.Name", "");
     END;
    END;
    L_EDO.GetEDOLPropValue(P_EDOL.P_TSN, PropVal);
    IF ~!PropVal THEN
     SAVE(Staff);
     SAVE(Man);
     L_General.Assert(SEARCH(Staff, TSN, PropVal), "  ࠡ⭨ " + PropVal);
     CONFORM(Staff, Man);
     L_MSO.wordSetVar(r + "Mentor.TSN", Staff.TSN);
     L_MSO.wordSetVar(r + "Mentor.Name", Man.Name);
     RESTORE(Man);
     RESTORE(Staff);
    ELSE
     L_MSO.wordSetVar(r + "Mentor.TSN", "");
     L_MSO.wordSetVar(r + "Mentor.Name", "");
    END;
    L_EDO.GetEDOLPropValue(P_EDOL.P_ProbationTime, PropVal);
    L_MSO.wordSetVar(r + "ProbationTime", PropVal);
   ELSE
    L_General.Assert(~L_EC.ExecE_Func_Scal2(D, PROCREF(E_Staff.NeedProbationEDO), 1),
                     "   ਪ  ⠦஢ c " + L_DatTim.DateStr(D));
    L_MSO.wordSetVarsByFile_wPrefixE("EDOrder" ,"Staff.", 1);
    L_MSO.wordSetVarsByFile_wPrefixE("EDOrderL" ,"Staff.EDOrder.", 1);
    r:="Staff.EDOrder.EDOrderL.";
    L_MSO.wordSetVar(r + "Route", "");
    L_MSO.wordSetVarsByFile_wPrefixE("Car", r, 1);
    L_MSO.wordSetVar(r + "Mark", "");
    L_MSO.wordSetVar(r + "Mark.Name", "");
    L_MSO.wordSetVar(r + "Mentor.TSN", "");
    L_MSO.wordSetVar(r + "Mentor.Name", "");
    L_MSO.wordSetVar(r + "ProbationTime", "");
   END; (* IF SRCINSEL(EDOrderL, GE, D) *)
  END; (* IF ~!Root *)
 END {ProbShtPrepare};

END.
