(*
%Copyright   (c) Polak Computer System
%Author      28.03.2000 11:15:04 SAN
%Purpose     ஫ 䨪樨 Packet
%Type        control
%Specific    SYS
%Modified    22.09.2014 19:20:39 POLAK\Bor
%Environment
*)

 MODULE Packet [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_Events, L_AFM, L_Packet, L_Prop, L_Str, L_StdFrm, L_DatTim, L_WDO, L_SysLog,
        P_Firm, FIO, Str, L_AFM, L_XDoc, L_ATER, Math, L_DBD;

 PRIVATE PERMANENT VAR
  trgInsTable: LIKE(ATERAttr.Table);
  trgInsRow  : LIKE(ATERAttr.Row);

 PRIVATE PROCEDURE PckATER_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Packet";
  L_WDO.iEvents      (0, [L_WDO.e_OnReposition, L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (0, ["Packet.MyPlace", "Packet.PerB", "Packet.PerE", "Packet.ATER", "Packet.Status"]);
  L_WDO.iUnmodifiable(0, ["MyPlaceTitle", "Packet.Receiver", "Packet.DataType", "Packet.Packet"]);
  L_WDO.iField       (0, "Packet.Status").Format:=L_Packet.st_Pool;
  L_WDO.iField       (0, "Packet.Receiver").Format:=L_Packet.rcv_Pool;
  L_WDO.iField       (0, "ATER.Kind").Format:=L_Packet.knd_Pool;
  L_WDO.iEvents      (1, [L_WDO.e_OnOpenZone]);
  L_WDO.iZone        (1).Narrowing:="PckATER.Packet=Packet.Packet";
  L_WDO.iSubwindow   (1, "PckATERE");
  L_WDO.iField       (1, "PckATER.ATERAttr").OwnerWindowOriginalName:="ATERE";
  L_WDO.iField       (1, "PckATER.ATERAttr").OwnerZoneNumber:=1;
  L_WDO.iProgs       (1, "Packet");
 END {PckATER_OnInitializeWindow};

 PRIVATE PROCEDURE SetupMyPlace(forEdit: SCAL[2]);
  VAR
   wMyPlace      : SCAL[2];
   theOnlyMyPlace: LIKE(MyPlace.MyPlace);
 BEGIN
  wMyPlace:=~!Packet.Kind & ~!Packet.PerE & L_Packet.Kind_wMyPlace(Packet.PerE, Packet.Kind);
  theOnlyMyPlace:=P_Firm.GetTheOnlyMyPlace(Packet.PerE, Packet.MyFirm);
  RTI.Get().CurZone.Fields("Packet.MyPlace").Visible:=wMyPlace & !theOnlyMyPlace;
  RTI.Get().CurZone.Fields("MyPlaceTitle"  ).Visible:=RTI.Get().CurZone.Fields("Packet.MyPlace").Visible;
  RTI.Get().CurZone.Fields("MyPlace.Name"  ).Visible:=RTI.Get().CurZone.Fields("Packet.MyPlace").Visible;
  IF forEdit THEN
   IF wMyPlace THEN
    IF ~!theOnlyMyPlace THEN
     Packet.MyPlace:=theOnlyMyPlace;
     REPLACE(Packet);
    END;
   ELSE
    SETEMPTY(Packet.MyPlace);
    REPLACE(Packet);
   END; (* IF wMyPlace *)
  END; (* IF forEdit *)
 END {SetupMyPlace};

 PRIVATE PROCEDURE SetFieldModifiable(Field: FORMFIELD; Modifiable: SCAL[2]);
 BEGIN
  IF ~!Field THEN
   Field.Modifiable:=Modifiable;
  END;
 END {SetFieldModifiable};

 PRIVATE PROCEDURE SetPacketFieldEdit();
  VAR
   FlagEdit: SCAL[2];
   Fields  : FORM_FIELDS;
 BEGIN
  FlagEdit:=(Packet.Status # L_Packet.st_Done) & ~IsPensFundMakedPacket();

  RTI.Get().CurWindow.Zones(1).ViewOnly:=~FlagEdit;

  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  SetFieldModifiable(Fields("Packet.Kind"),     FlagEdit);
  SetFieldModifiable(Fields("Packet.ExtNbr"),   FlagEdit);
  SetFieldModifiable(Fields("Packet.ATER"),     FlagEdit);
  SetFieldModifiable(Fields("Packet.DataType"), FlagEdit & L_Packet.IsSamplePacket());
  SetFieldModifiable(Fields("Packet.CorrType"), FlagEdit & L_Packet.IsSamplePacket());
  SetFieldModifiable(Fields("Packet.PerB"),     FlagEdit & (Packet.Kind # L_Packet.knd_PF_SZVK));
  SetFieldModifiable(Fields("Packet.PerE"),     FlagEdit & (Packet.Kind # L_Packet.knd_PF_SZVK));
 END {SetPacketFieldEdit};

 PRIVATE PROCEDURE PckATER_0_OnReposition();
 BEGIN
  SetupMyPlace(0);
  SetPacketFieldEdit();
 END {PckATER_0_OnReposition};

 PRIVATE PROCEDURE CheckPacketIsEmpty();
 BEGIN
  IF SELECT(PckATER, PckATER, Packet.Packet) THEN
   L_StdFrm.Choice(" 믮  樨 㤥 믮  ⪠ . த?");
   WHILE OCCURE(PckATER) DO
    PROMPT(" "  + PckATER.Table2 + " " + PckATER.Row2 + " " + PckATER.ATERAttr);
    REMOVE(PckATER);
   END; (* WHILE OCCURE(PckATER)...*)
  END;
 END {CheckPacketIsEmpty};

 PRIVATE PROCEDURE PckATERMustBeDeleted(): SCAL[2];
 BEGIN
  RETURN (PckATER.Source # L_Packet.src_Operator) | ~SEARCH(ATERAttr, ATER, Packet.ATER, PckATER.Table, PckATER.Row, PckATER.ATERAttr);
 END {PckATERMustBeDeleted};

 PRIVATE PROCEDURE ClearPacket(prvATER: LIKE(ATER.ATER));
  VAR
   prvKind                : LIKE(ATER.Kind);
   AllPckATERWasDeleted,
   ClearAllPckATERRequired: SCAL[2];
 BEGIN
  IF SELECT(PckATER, PckATER, Packet.Packet) THEN
   IF ~!prvATER THEN
    SAVE(ATER);
    SEARCH(ATER, ATER, , prvATER);
    prvKind:=ATER.Kind;
    RESTORE(ATER);
   ELSE
    L_General.CallUs(0);
   END;
   CONFORM(Packet, ATER);
   ClearAllPckATERRequired:=ATER.Kind # prvKind;

   IF ClearAllPckATERRequired THEN
    L_StdFrm.Choice(" 믮  樨 㤥 믮  ⪠ .");
   ELSE
    L_StdFrm.Choice(" 믮  樨 㤥 믮 ⪠ .|" +
                    "    㤠, ᫨   ଠ ");
   END;
   AllPckATERWasDeleted:=1;
   WHILE OCCURE(PckATER) DO
    PROMPT(" "  + PckATER.Table2 + " " + PckATER.Row2 + " " + PckATER.ATERAttr);
    IF ClearAllPckATERRequired | PckATERMustBeDeleted() THEN
     REMOVE(PckATER);
    ELSE
     AllPckATERWasDeleted:=0;

     PckATER.ATER:=ATER.ATER;
     REPLACE(PckATER);

     NEXT(PckATER);
    END;
   END; (* WHILE OCCURE(PckATER)...*)
   IF ~AllPckATERWasDeleted THEN
    L_StdFrm.Inform(" ਡ  묨 ﬨ  뫨 㤠.||" +
                    "室 ।쭮 ⥫쭮 ஢ ࠢ쭮 ");
   END;
  END;
 END {ClearPacket};

 PRIVATE PROCEDURE CheckOnlyOneDonePacketStamp();
  VAR
   curDTStamp : LIKE(Packet.DTStamp);
   curMyFirm  : LIKE(Packet.MyFirm);
   curDataType: LIKE(Packet.DataType);
   curCorrType: LIKE(Packet.CorrType);
 BEGIN
  IF (Packet.PerB >= 01\01\2013) & (*16.07.2013 18:33:01 POLAK\Bor. 0098251    2010,   ᯮ墠⨫*)
     (Packet.Status = L_Packet.st_Done) &
     ~L_Packet.IsSamplePacket() &
     L_Packet.MustBeOnlyOneDonePacketStamp() THEN

   curDTStamp :=Packet.DTStamp;
   curMyFirm  :=Packet.MyFirm;
   curDataType:=Packet.DataType;
   curCorrType:=Packet.CorrType;
   SAVE(Packet);
   SELECT(Packet, PacketKn, , Packet.Receiver, Packet.Kind, Packet.PerB, Packet.PerE);
   WHILE OCCURE(Packet) DO
    IF (Packet.Status = L_Packet.st_Done) &
       ~L_Packet.IsSamplePacket() &
       (curDTStamp # Packet.DTStamp) &
       (curMyFirm  = Packet.MyFirm) &
       (curDataType = Packet.DataType) &
       (curCorrType = Packet.CorrType) THEN
     L_General.Error(" ਮ  "+L_DatTim.DateStr(Packet.PerB)+"  "+L_DatTim.DateStr(Packet.PerE)+"|"+
                     "㦥    ﭨ '"+L_Str.PoolItem(L_Packet.st_Pool, Packet.Status)+"'|"+
                     " ଥ "+L_Str.PoolItem(L_Packet.knd_Pool, Packet.Kind)+"||"+
                     "⠬ "+L_Packet.PacketDTStampStr());
    END;
    NEXT(Packet);
   END; (* WHILE OCCURE(Packet) ... *)
   RESTORE(Packet);
  END;
 END {CheckOnlyOneDonePacketStamp};

 PRIVATE PROCEDURE intChangePacketStatus(newStatus: LIKE(Packet.Status));
 BEGIN
  SAVE(Packet);
  SELECT(Packet, PacketDS, , Packet.Receiver, Packet.DTStamp);
  WHILE OCCURE(Packet) DO
   IF Packet.Status # newStatus THEN
    L_SysLog.SingleMark_Init("Packet");
    Packet.Status:=newStatus;
    REPLACE(Packet);
    L_XDoc.Jrn_Mark(L_XDoc.curXDocId(L_XDoc.xdt_Packet), L_XDoc.action_AutoEdit);
    L_SysLog.SingleMark_Done("Packet");
    CheckOnlyOneDonePacketStamp();
   END;
   NEXT(Packet);
  END; (* WHILE OCCURE(Packet) ... *)
  RESTORE(Packet);
 END {intChangePacketStatus};

 PUBLIC PROCEDURE ChangePacketStatus();
  VAR
   newStatus: LIKE(Packet.Status);
 BEGIN
  AccessPacket();
  newStatus:=L_StdFrm.ShowListAsMenu_wInit(L_Packet.st_Pool, " ﭨ ⮢  ⠪ ⠬", Packet.Status);
  intChangePacketStatus(newStatus);
 END {ChangePacketStatus};

 PRIVATE PROCEDURE Packet_ATER_OnSuccessfulChange();
 BEGIN
  L_Packet.CheckActualPacketInPer();
  ClearPacket(GE_PVALUE());

  CONFORM(Packet, ATER);
  Packet.Kind:=ATER.Kind;
  REPLACE(Packet);
  SetupMyPlace(1);
 END {Packet_ATER_OnSuccessfulChange};

 PRIVATE PROCEDURE Packet_MyPlace_OnSuccessfulChange();
 BEGIN
  CheckPacketIsEmpty();
 END {Packet_MyPlace_OnSuccessfulChange};

 PRIVATE PROCEDURE Packet_PerB_OnSuccessfulChange();
 BEGIN
  CheckPacketIsEmpty();
 END {Packet_PerB_OnSuccessfulChange};

 PRIVATE PROCEDURE Packet_PerE_OnSuccessfulChange();
 BEGIN
  CheckPacketIsEmpty();
  SetupMyPlace(1);
 END {Packet_PerE_OnSuccessfulChange};

 PRIVATE PROCEDURE IsMultiPacket(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(Packet);
  SELECT(Packet, PacketDS, , Packet.Receiver, Packet.DTStamp);
  Result:=NEXT(Packet);
  RESTORE(Packet);
  RETURN Result;
 END {IsMultiPacket};

 PRIVATE PROCEDURE IsPensFundMakedPacket(): SCAL[2];
 BEGIN
  RETURN (Packet.Receiver = L_Packet.rcv_PensFund) & (Packet.DTStamp # L_Packet.SampleDTStamp);
 END {IsPensFundMakedPacket};

 PRIVATE PROCEDURE Packet_Status_OnSuccessfulChange();
  VAR
   Msg: STRING[];
 BEGIN
  IF    GE_PVALUE() = L_Packet.st_Canceled THEN
   Msg:="  ⬥ 㫨஢ ?";
  ELSIF Packet.Status = L_Packet.st_Canceled THEN
   Msg:="  㫨஢ ?";
  ELSE
   SETEMPTY(Msg);
  END;
  IF IsPensFundMakedPacket() & IsMultiPacket() THEN
   Msg:=L_Str.AddStrDlm(Msg, "||")+"㤥  ﭨ  ⮢  ⠪ ⠬";
  END;
  IF ~!Msg THEN
   L_StdFrm.Choice(Msg);
  END;
  IF IsPensFundMakedPacket() & IsMultiPacket() THEN
   intChangePacketStatus(Packet.Status);
  END;
  SetPacketFieldEdit();
 END {Packet_Status_OnSuccessfulChange};

 PRIVATE PROCEDURE Packet_Kind_OnSuccessfulChange();
  VAR
   oldPerB,
   oldPerE: DATE;
 BEGIN
  IF L_Packet.IsSamplePacket() THEN
   IF Packet.Kind = L_Packet.knd_PF_SZVK THEN
    oldPerB:=Packet.PerB;
    oldPerE:=Packet.PerE;
    Packet.PerB:=01\01\1900;
    Packet.PerE:=31\12\2001;
    IF (oldPerB # Packet.PerB) | (oldPerE # Packet.PerE) THEN
     TOOLTIP(" ਮ ");
    END;
    REPLACE(Packet);
   END;
   SetPacketFieldEdit();
  END;
 END {Packet_Kind_OnSuccessfulChange};

 PRIVATE PROCEDURE SetPacketHeaderWinFieldFlagFirst();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF    Packet.Status = L_Packet.st_Done THEN
   IF ~!Fields("Packet.Kind") THEN
    Fields("Packet.Kind").First   :=0;
   END;
   Fields("Packet.Receiver").First:=0;
   IF ~!Fields("Packet.ExtNbr") THEN
    Fields("Packet.ExtNbr").First :=0;
   END;
   Fields("Packet.Status").First  :=1;
  ELSIF !Packet.Receiver THEN
   Fields("Packet.Kind").First    :=0;
   Fields("Packet.Receiver").First:=1;
   Fields("Packet.ExtNbr").First  :=0;
   Fields("Packet.Status").First  :=0;
  ELSIF Packet.Receiver = L_Packet.rcv_PensFund THEN
   Fields("Packet.Kind").First    :=1;
   Fields("Packet.Receiver").First:=0;
   IF ~!Fields("Packet.ExtNbr") THEN
    Fields("Packet.ExtNbr").First :=0;
   END;
   Fields("Packet.Status").First  :=0;
  ELSIF Packet.Receiver = L_Packet.rcv_TaxDep THEN
   Fields("Packet.Kind").First    :=0;
   Fields("Packet.Receiver").First:=0;
   Fields("Packet.ExtNbr").First  :=1;
   Fields("Packet.Status").First  :=0;
  ELSE
   Fields("Packet.Receiver").First:=0;
   Fields("Packet.ExtNbr").First  :=1;
   Fields("Packet.Status").First  :=0;
  END;
 END {SetPacketHeaderWinFieldFlagFirst};

 PRIVATE PROCEDURE Packet0_1_OnReposition();
  VAR
   curContexts: STRING[];
 BEGIN
  curContexts:="View_Packet0_1";
  IF ACCESS(Packet) THEN
   IF L_Packet.IsPersPacket() THEN curContexts:="View_Packet0_1_RCD_Pers";
   END;
  END;
  RTI.Get().CurProcess.ReplaceContexts(curContexts);
 END {Packet0_1_OnReposition};

 PRIVATE PROCEDURE Packet2_1_OnReposition();
  VAR
   curContexts: STRING[];
 BEGIN
  curContexts:="View_Packet2";
  IF ACCESS(Packet) THEN
   IF    (Packet.Kind = L_Packet.knd_TT_AdvRep) |
         (Packet.Kind = L_Packet.knd_TT_Decl)     THEN curContexts:="View_Packet2_RCD_TT";
   ELSIF (Packet.Kind = L_Packet.knd_RSV_1)       THEN curContexts:="View_Packet2_RCD_RSV1";
   END;
  END;
  RTI.Get().CurProcess.ReplaceContexts(curContexts);
 END {Packet2_1_OnReposition};

 PRIVATE PROCEDURE Packet_OnBeforeInsert();
 BEGIN
  IF    Packet.Receiver = L_Packet.rcv_PensFund THEN
   L_General.Assert(L_Str.IsEqStrI(RTI.Get().CurWindow.OriginalName, "PacketE1"),
                    "⠢  ⮫쪮  'ࠧ'");
  ELSIF Packet.Receiver = L_Packet.rcv_TaxDep THEN
   Packet.Kind:=L_Packet.knd_TD_IncTax;
  END;
  IF Packet.Receiver = L_Packet.rcv_e_TaxDep THEN
   Packet.Status:=L_Packet.st_InProcess;
  ELSE
   Packet.Status:=L_Packet.st_Prepared;
  END;
  Packet.MyFirm:=P_Firm.DefineMyFirm();
  REPLACE(Packet);
  SetPacketHeaderWinFieldFlagFirst();

  L_XDoc.XDocJrn_Start(L_XDoc.xdt_Packet, L_XDoc.EmptyXDocKind, Packet.Packet, L_XDoc.action_Insert);
 END {Packet_OnBeforeInsert};

 PRIVATE PROCEDURE Packet_OnBeforeEdit();
 BEGIN
  IF Packet.Receiver = L_Packet.rcv_e_TaxDep THEN
   L_General.Assert_wReferToAdmin(Packet.Status#L_Packet.st_Done,
                                  "䨪  ( "+Packet.Packet+")  ﭨ '' 饭");
  END;
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_Packet, L_XDoc.EmptyXDocKind, Packet.Packet, L_XDoc.action_Edit);
  SetPacketHeaderWinFieldFlagFirst();
 END {Packet_OnBeforeEdit};

 PRIVATE PROCEDURE PacketOnBeforeDel();
 BEGIN
  L_General.CallUs(L_Packet.IsSamplePacket() | (Packet.Status = L_Packet.st_Canceled));

  IF SELECT(XDocJrn, XDocJrn, L_XDoc.xdt_Packet, L_XDoc.EmptyXDocKind, Packet.Packet) |
     (~L_Packet.IsSamplePacket() | ~IsOldSamplePacket()) THEN
   L_XDoc.XDoc_OnBeforeDelete(L_XDoc.curXDocId(L_XDoc.xdt_Packet));
  END;
  TRY [INTEGRITY(INTEGRITY_ON)]
   SETSEL(PckAttr, Packet, Packet.Packet);
   REMSEL(PckAttr);
   L_Packet.ErasePacketFiles();
  EXCEPT
  END;
 END {PacketOnBeforeDel};

 PRIVATE PROCEDURE Packet_OnBeforeDelete();
 BEGIN
  IF ~L_Packet.IsSamplePacket() THEN
   L_General.Assert(Packet.Status = L_Packet.st_Canceled,
                    "  饭. ᯮ '㫨஢'");
   L_General.PrgsOnly_wMes(" 㤠  ");
   L_StdFrm.Choice("  㤠  " + Packet.ExtNbr + "  ਮ  " +
                   L_DatTim.PeriodStr(Packet.PerB) + "  " + L_DatTim.PeriodStr(Packet.PerE) + "|" +
                   "ନ஢ " + L_Packet.PacketDTStampStr());
  END;
  PacketOnBeforeDel();
 END {Packet_OnBeforeDelete};

 PRIVATE PROCEDURE OnAfterEdInsAssert(Cond: SCAL[2]; Text: STRING[]);
  CONST
   Hint_SaveInPrepared = "||(६ 㬥  ࠭  ﭨ '⮢')";
 BEGIN
  IF ~Cond THEN
   IF Packet.Status = L_Packet.st_Prepared THEN
    L_StdFrm.Choice(Text);
   ELSE
    L_General.CallUs(L_Packet.IsAcceptablePacket());
    L_General.Error(Text+Hint_SaveInPrepared);
   END;
  END;
 END {OnAfterEdInsAssert};

 PRIVATE PROCEDURE Packet_OnAfterEdIns();
  VAR
   i,
   trgExtNbr  : NUMERIC[0];
   ExistPacket: SCAL[2][1E3];
   trgMyFirm  : LIKE(MyFirm.MyFirm);
   trgDataType: LIKE(Packet.DataType);
   trgMyPlace : LIKE(Packet.MyPlace);
 BEGIN
  IF L_Packet.Kind_wMyPlace(Packet.PerE, Packet.Kind) THEN
   P_Firm.CheckMyPlace_wMySite(Packet.PerE, Packet.MyPlace, Packet.MyFirm);
  END;

  IF    Packet.Receiver = L_Packet.rcv_e_TaxDep THEN
   L_Packet.CheckActualPacketInPer();
   L_General.Assert(L_Str.TestStrAlowChar(Packet.ExtNbr, "09"), "    ᫮: "+Packet.ExtNbr);
   trgExtNbr:=STRTOFLD(Packet.ExtNbr, NUMERIC);
   L_General.Assert(trgExtNbr <= HIGH(ExistPacket), "      " + L_Str.IntStr(HIGH(ExistPacket)));
   IF Packet.Status = L_Packet.st_Done THEN
    L_General.Assert(SELECT(PckATER, Packet, Packet.Packet), " 믮 ନ஢ ⭮");
   END;

   IF L_Packet.IsAcceptablePacket() THEN
    SETZERO(ExistPacket);
    trgMyFirm  :=Packet.MyFirm;
    trgDataType:=Packet.DataType;
    trgMyPlace :=Packet.MyPlace;
    SAVE(Packet);
    SELECT(Packet, PacketKn, , Packet.Receiver, Packet.Kind, Packet.PerB, Packet.PerE);
    WHILE OCCURE(Packet) DO
     IF L_Packet.IsAcceptablePacket() &
        (Packet.MyFirm = trgMyFirm) & (Packet.DataType = trgDataType) & (Packet.MyPlace = trgMyPlace) THEN
      trgExtNbr:=STRTOFLD(Packet.ExtNbr, NUMERIC);
      IF ExistPacket[trgExtNbr] THEN
       OnAfterEdInsAssert(0, " 㪠 ਮ 㦥    ஬ " + Packet.ExtNbr);
       LAST(Packet);
      END;
      ExistPacket[trgExtNbr]:=1;
     END;
     NEXT(Packet);
    END; (* WHILE OCCURE(Packet) ... *)
    RESTORE(Packet);
 
    OnAfterEdInsAssert(~ExistPacket[0], "     0");
    OnAfterEdInsAssert(ExistPacket[1],  "室     001");
 
    i:=2;
    WHILE i <= HIGH(ExistPacket) DO
     IF ExistPacket[i] & ~ExistPacket[i-1] THEN
      OnAfterEdInsAssert(0, "襭 ᫥⥫쭮 㬥樨 ⮢  㪠 ਮ");
      i:=HIGH(ExistPacket);
     END;
     INC(i);
    END; (* WHILE i <= HIGH(ExistPacket[1])...*)
   END; (* IF L_Packet.IsAcceptablePacket() ... *)

   Packet.ExtNbr:=L_Str.FixedIntStr(STRTOFLD(Packet.ExtNbr, NUMERIC), 3);
   REPLACE(Packet);
  ELSIF Packet.Receiver = L_Packet.rcv_PensFund THEN
   L_General.Assert(L_Str.TestStrAlowChar(Packet.ExtNbr, "09"), "    ᫮: "+Packet.ExtNbr);
   L_Packet.CheckActual_PF_PacketInPer();
  END;
  CheckOnlyOneDonePacketStamp();
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_Packet, L_XDoc.EmptyXDocKind, Packet.Packet);
 END {Packet_OnAfterEdIns};

 PRIVATE PROCEDURE Packet_OnAfterInsert();
 BEGIN
  Packet_OnAfterEdIns();
  IF Packet.Receiver = L_Packet.rcv_e_TaxDep THEN
   SE_WZD_POSITION("Packet2", 1, Packet);
  END;
 END {Packet_OnAfterInsert};

 PRIVATE PROCEDURE Packet_OnAfterEdit();
 BEGIN
  Packet_OnAfterEdIns();
 END {Packet_OnAfterEdit};

 PRIVATE PROCEDURE PckBody_OnBeforeDelete();
 BEGIN
  SETSEL(PckAttr, PckBody, PckBody.Packet, PckBody.SeqNbr);
  REMSEL(PckAttr);
 END {PckBody_OnBeforeDelete};

 PRIVATE PROCEDURE GetPacketReceiver(): LIKE(Packet.Receiver);
  VAR
   PWinName : STRING[];
 BEGIN
  PWinName:=RTI.Get().CurWindow.ParentZone.Window.OriginalName;
  IF    PWinName = "Packet0" THEN
   RETURN L_Packet.rcv_PensFund;
  ELSIF PWinName = "Packet1" THEN
   RETURN L_Packet.rcv_TaxDep;
  ELSE
   L_General.CallUs(0);
  END;
 END {GetPacketReceiver};

 PRIVATE PROCEDURE PacketE_0_OnReposition();
 BEGIN
  SetPacketFieldEdit();
  RTI.Get().CurZone.Fields("MyPlace.vzSign").Visible:=~!Packet.MyPlace;
 END {PacketE_0_OnReposition};

 PRIVATE PROCEDURE PacketE1_0_OnReposition();
 BEGIN
  SetPacketFieldEdit();
 END {PacketE1_0_OnReposition};

 PRIVATE PROCEDURE PacketE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Packet";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["Packet.Status"]);
  L_WDO.iUnmodifiable(0, ["Packet.Packet", "Packet.Receiver", "Packet.Receiver", "Packet.PrpDate", "Packet.CorrType", "Packet.DataType", "Packet.Receiver"]);
  L_WDO.iField       (0, "Packet.Status").Format:=L_Packet.st_Pool;
  L_WDO.iField       (0, "Packet.Kind").Format:=L_Packet.knd_Pool;
  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeDelete]);
  L_WDO.iField       (1, "PckBody.Man").First:=1;
  L_WDO.iProgs       (1, "Packet");
 END {PacketE_OnInitializeWindow};

 PRIVATE PROCEDURE PacketE1_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Packet";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["Packet.Kind", "Packet.Status"]);
  L_WDO.iField       (0, "Packet.Kind").First:=1;
  L_WDO.iUnmodifiable(0, ["Packet.Packet", "Packet.Receiver"]);
  L_WDO.iField       (0, "Packet.Kind").Format:=L_Packet.knd_Pool;
  L_WDO.iField       (0, "Packet.Status").Format:=L_Packet.st_SamplePool;
  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeDelete]);
  L_WDO.iField       (1, "PckBody.Man").First:=1;
  L_WDO.iProgs       (1, "Packet");
 END {PacketE1_OnInitializeWindow};

 PRIVATE PROCEDURE ATER_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Packet";
  L_WDO.iSubwindow   (1, "ATERE");
 END {ATER_OnInitializeWindow};

 PRIVATE PROCEDURE ATERE_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Packet";
  L_WDO.iZone        (0).ViewOnly:=1;
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete]);
  L_WDO.iField       (0, "ATER.Kind").Format:=L_Packet.knd_Pool;
  L_WDO.iProgs       (0, "Packet");
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow, L_WDO.e_OnBeforeInsert]);
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iZone        (1).HierarchicLink:=LINK.Get("ATERAttr", "Parent1");
  L_WDO.iField       (1, "ATERAttr.Table").Hierarchic:=1;
  L_WDO.iProgs       (1, "Packet");
  IF L_WDO.IsLoadableAskClone() & (RTI.Get().CurWindow.AskSourceField.Name = "ATERAttr.xmlPrnAA") THEN
   L_WDO.iZone        (1).ShowLeavesInHierarchicView:=0;
  END;
 END {ATERE_OnInitializeWindow};

 PRIVATE PROCEDURE ATER_OnBeforeInsert();
  VAR
   srcATER,
   dstATER: LIKE(ATER.ATER);
 BEGIN
  srcATER:=L_WDO.GetInsertionSource();
  IF ~!srcATER THEN
   L_DBD.CopyFromSrcRecord("ATER", srcATER);
   REPLACE(ATER);
   dstATER:=ATER.ATER;
   SELECT(ATERAttr, ATER, , srcATER);
   WHILE OCCURE(ATERAttr) DO
    PROMPT("஢ " + ATERAttr.Table);
    SAVE(ATERAttr);
    ATERAttr.ATER:=dstATER;
    INSERT(ATERAttr);
    RESTORE(ATERAttr);
    NEXT(ATERAttr);
   END; (* WHILE OCCURE(ATERAttr) ... *)
  END;
 END {ATER_OnBeforeInsert};

 PRIVATE PROCEDURE ATER_OnBeforeDelete();
 BEGIN
  L_General.SilentPrgsOnly();
  L_StdFrm.Choice("筮 㤠?");
  SELECT(ATERAttr, ATER, , ATER.ATER);
  REMSEL(ATERAttr);
 END {ATER_OnBeforeDelete};

 PRIVATE PROCEDURE GetTableName(trgTable: LIKE(ATERAttr.Table)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(ATERAttr);
  SELECT(ATERAttr, ATER, , Packet.ATER, trgTable, 00000);
  Result:="'" + ATERAttr.Name + "' ("+trgTable+")";
  L_General.CallUs(~NEXT(ATERAttr));
  RESTORE(ATERAttr);
  RETURN Result;
 END {GetTableName};

 PUBLIC PROCEDURE InsertTableCopy();
  VAR
   List,
   DummyStr   : STRING[];
   DummyScal  : SCAL[2];
   DummyArr   : STRING[][10];
   MultiTables: LIKE(ATERAttr.Table)[10];
   i, Choice  : NUMERIC[0];
   Tables2    : LIKE(ATERAttr.Row)[10];
 BEGIN
  L_General.Assert(~!Packet.ATER, " 㪠 ଠ ");
  L_General.CallUs(L_Packet.FSS_SheetwXML(Packet.ATER));
  L_General.Assert(SELECT(PckATER, Packet, Packet.Packet), " 믮 ନ஢ ⭮");
  SEARCH(ATER, ATER, , Packet.ATER);
  L_Packet.GetATERDescr(DummyStr, MultiTables, DummyArr, DummyArr, DummyScal);
  SETEMPTY(List);
  i:=0;
  WHILE (i <= HIGH(MultiTables)) & ~!MultiTables[i] DO
   IF MultiTables[i] # 0031(**) THEN
    SETSEL(PckATER, Table, Packet.Packet, MultiTables[i]);
    IF LAST(PckATER) THEN
     Tables2[i]:=PckATER.Table2 + 1;
    ELSE
     Tables2[i]:=00000;
    END;
    List:=List + " " + Tables2[i] + ", ⠡ " + GetTableName(MultiTables[i]) + "|";
   END;
   INC(i);
  END;
  Choice:=L_StdFrm.ShowListAsMenu(List, "⠢   ⠡");
  SELECT(ATERAttr, ATER, , ATER.ATER, MultiTables[Choice]);
  WHILE OCCURE(ATERAttr) DO
   IF (ATERAttr.Kind = L_ATER.aak_Data) | (ATERAttr.Kind = L_ATER.aak_ManualInput) THEN
    L_Packet.PutSingleValueInPacket(Tables2[Choice], 00000, "", L_Packet.src_System);
   END;
   NEXT(ATERAttr);
  END; (* WHILE OCCURE(ATERAttr) ... *)

  SELECT(PckATER, Table, , Packet.Packet, MultiTables[Choice], Tables2[Choice]);
  SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), PckATER);
 END {InsertTableCopy};

 PRIVATE PROCEDURE PckATER_1_OnZoneOpen();
  VAR
   Context: STRING[];
 BEGIN
  ACCESS(Packet);
  Context:="View_PckATER";
  IF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_View) & L_Packet.FSS_SheetwXML(Packet.ATER) THEN
   Context:="View_FSS_PckATER";
  END;
  RTI.Get().CurProcess.ReplaceContexts(Context);
 END {PckATER_1_OnZoneOpen};

 PRIVATE PROCEDURE PckATER_OnBeforeInsert();
  VAR
   Msg: STRING[];
 BEGIN
  L_General.Assert(~!Packet.ATER, " 㪠 ଠ ");
  Msg:="⠢ ਡ⮢  饭.||  묨 ᫥|ᯮ짮 쭮  ";
  IF L_Packet.FSS_SheetwXML(Packet.ATER) THEN
   Msg:=Msg + "|| ⠢   ⠡ ᫥|ᯮ짮 쭮  ਡ⮢ ";
  END;
  L_General.Error(Msg);
 END {PckATER_OnBeforeInsert};

 PRIVATE PROCEDURE PckATER_OnBeforeEdit();
 BEGIN
  CONFORM(PckATER, ATERAttr);
  L_General.Assert((ATERAttr.Kind = L_ATER.aak_ManualInput) | (ATERAttr.Kind = L_ATER.aak_Data),
                   "䨪 ਡ " + ATERAttr.ATERAttr + " '" + ATERAttr.Name + "'|饭");

  IF (PckATER.Source = L_Packet.src_System) & (ATERAttr.Kind # L_ATER.aak_ManualInput) THEN
   L_StdFrm.Question("䨪 ਡ  ''");
   L_StdFrm.Choice(" ।쭮   ।஢  ਡ⮢|" +
                   " ⭮ 䨪樨  ᪠ ");
   L_StdFrm.Question("  ⮪");
  END;
 END {PckATER_OnBeforeEdit};

 PRIVATE PROCEDURE IsTableCopy(): SCAL[2];
  VAR
   DummyStr   : STRING[];
   DummyScal  : SCAL[2];
   DummyArr   : STRING[][10];
   MultiTables: LIKE(ATERAttr.Table)[10];
   i          : NUMERIC[0];
 BEGIN
  SEARCH(ATER, ATER, , Packet.ATER);
  L_Packet.GetATERDescr(DummyStr, MultiTables, DummyArr, DummyArr, DummyScal);
  i:=0;
  WHILE (i <= HIGH(MultiTables)) & ~!MultiTables[i] DO
   IF PckATER.Table = MultiTables[i] THEN
    RETURN 1;
   END;
   INC(i);
  END;
  RETURN 0;
 END {IsTableCopy};

 PRIVATE PROCEDURE PckATER_OnBeforeDelete();
  VAR
   curRow     : LIKE(PckATER.Row);
   curRow2    : LIKE(PckATER.Row2);
   curATERAttr: LIKE(PckATER.ATERAttr);
 BEGIN
  ACCESS(PckATER);
  IF IsTableCopy() THEN
   L_General.Assert(L_Packet.FSS_SheetwXML(Packet.ATER), " ஢ ப  ⮩  饭");
   L_StdFrm.Choice("  " + PckATER.Table2 + ", ⠡ " + GetTableName(PckATER.Table));
   curRow     :=PckATER.Row;
   curRow2    :=PckATER.Row2;
   curATERAttr:=PckATER.ATERAttr;
   CHANGESEL(PckATER, Table, , Packet.Packet, PckATER.Table, PckATER.Table2);
   FIRST(PckATER);
   WHILE OCCURE(PckATER) DO
    IF (curRow # PckATER.Row) | (curRow2 # PckATER.Row2) | (curATERAttr # PckATER.ATERAttr) THEN
     REMOVE(PckATER);
    ELSE
     NEXT(PckATER);
    END;
   END;
  ELSE
   L_StdFrm.Choice("᫥ 㤠 ਡ 室|" +
                   "믮 楤  묨 ⮏.||" +
                   "  ⮪");
  END;
 END {PckATER_OnBeforeDelete};

 PRIVATE PROCEDURE PckATER_OnAfterEdIns();
  VAR
   Dummy: STRING[];
   Prod : NUMERIC[5];
 BEGIN
  CONFORM(PckATER, ATERAttr);
  IF ~!PckATER.Value THEN
   Dummy:=L_Packet.ConvATERAttrValue(PckATER.Value);
   IF    ATERAttr.Type = L_General.ft_NUMERIC THEN
    Prod:=STRTOFLD(PckATER.Value, NUMERIC) * Math.Pow(10, ATERAttr.Format);
    L_General.Assert(Prod MOD 1 = 0, "祭 ਡ " +
                                      "|  㪠뢠  筮  " + L_Str.IntStr(ATERAttr.Format) +
                                      "  ᫥ ⮩");
   END;
  ELSE
   L_General.Assert(~ATERAttr.NotEmpty,
                    "ਡ "  + ATERAttr.ATERAttr + " '" + ATERAttr.Name + "'|   ");
  END;
  PckATER.Source:=L_Packet.src_Operator;
  REPLACE(PckATER);
 END {PckATER_OnAfterEdIns};

 PRIVATE PROCEDURE PckATER_OnAfterEdit();
 BEGIN
  CONFORM(PckATER, ATERAttr);
  PckATER_OnAfterEdIns();
 END {PckATER_OnAfterEdit};

 PRIVATE PROCEDURE PckATER_OnAfterInsert();
 BEGIN
  PckATER_OnAfterEdIns();
 END {PckATER_OnAfterInsert};

 PRIVATE PROCEDURE Packet0_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Packet";
  L_WDO.iEvents      (1, [L_WDO.e_OnReposition]);
  L_WDO.iZone        (1).Narrowing:="Packet.Receiver=" + L_Str.IntStr(L_Packet.rcv_PensFund);
  L_WDO.iZone        (1).PermanentFilter:="Packet.DTStamp#0";
  L_WDO.iSubwindow   (1, "PacketE");
  L_WDO.iField       (1, "Packet.Status").Format:=L_Packet.st_ShortPool;
  L_WDO.iField       (1, "Packet.Kind").Format:=L_Packet.knd_Pool;
  L_WDO.iField       (1, "Packet.Packet").ReverseSorting:=1;
  L_WDO.iField       (1, "Packet.DTStamp").ReverseSorting:=1;
  L_WDO.iZone        (2).Narrowing:="(Packet.Receiver="+L_Str.IntStr(L_Packet.rcv_PensFund)+") & (Packet.DTStamp=0)";
  L_WDO.iSubwindow   (2, "PacketE1");
  L_WDO.iField       (2, "Packet.Kind").Format:=L_Packet.knd_Pool;
  L_WDO.iField       (2, "Packet.Status").Format:=L_Packet.st_SamplePool;
  L_WDO.iField       (2, "Packet.Packet").ReverseSorting:=1;
 END {Packet0_OnInitializeWindow};

 PRIVATE PROCEDURE Packet1_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Packet";
  L_WDO.iField       (1, "Packet.Status").Format:=L_Packet.st_ShortPool;
  L_WDO.iField       (1, "Packet.Packet").ReverseSorting:=1;
  L_WDO.iField       (1, "Packet.DTStamp").ReverseSorting:=1;
  L_WDO.iZone        (1).Narrowing:="Packet.Receiver="+L_Str.IntStr(L_Packet.rcv_TaxDep);
  L_WDO.iSubwindow   (1, "PacketE");
 END {Packet1_OnInitializeWindow};

 PRIVATE PROCEDURE Packet2_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Packet";
  L_WDO.iEvents      (1, [L_WDO.e_OnReposition]);
  L_WDO.iZone        (1).Narrowing:="Packet.Receiver="+L_Str.IntStr(L_Packet.rcv_e_TaxDep);
  L_WDO.iSubwindow   (1, "PckATER");
  L_WDO.iField       (1, "Packet.Packet").ReverseSorting:=1;
  L_WDO.iField       (1, "Packet.DTStamp").ReverseSorting:=1;
  L_WDO.iField       (1, "Packet.Status").Format:=L_Packet.st_ShortPool;
  L_WDO.iField       (1, "Packet.Kind").Format:=L_Packet.knd_Pool;
 END {Packet2_OnInitializeWindow};

 PRIVATE PROCEDURE ATERAttr_OnModifying();
 BEGIN
  L_General.SilentPrgsOnly();
  SetATERAttrFieldModifiable();
 END {ATERAttr_OnModifying};

 PRIVATE PROCEDURE SetATERAttrFieldModifiable();
 BEGIN
  SetFieldModifiable(RTI.Get().CurZone.Fields("ATERAttr.Format"), ATERAttr.Type=L_General.ft_NUMERIC);
 END {SetATERAttrFieldModifiable};

 PRIVATE PROCEDURE ATERAttr_OnBeforeInsert();
  VAR
   prnATERAttr: LIKE(ATERAttr.xmlPrnAA);
   prnTable   : LIKE(ATERAttr.xmlPrnTb);
 BEGIN
  ATERAttr_OnModifying();

  ATERAttr.Table :=trgInsTable;
  ATERAttr.Row   :=trgInsRow+1;
  ATERAttr.Column:=00;
  ATERAttr.Type  :=L_General.ft_STRING;
  ATERAttr.Leaf  :=0;
  REPLACE(ATERAttr);
  IF ~!ATERAttr.xmlPrnTb THEN
   SAVE(ATERAttr);
   SEARCH(ATERAttr, ATERAttr, , ATERAttr.ATER, ATERAttr.xmlPrnAA, ATERAttr.xmlPrnTb);
   IF ATERAttr.xmlElmTp # L_ATER.xet_ComplexElm THEN
    prnATERAttr:=ATERAttr.xmlPrnAA;
    prnTable   :=ATERAttr.xmlPrnTb;
    RESTORE(ATERAttr);
    ATERAttr.xmlPrnAA:=prnATERAttr;
    ATERAttr.xmlPrnTb:=prnTable;
    REPLACE(ATERAttr);
   ELSE
    RESTORE(ATERAttr);
   END;
  END;
 END {ATERAttr_OnBeforeInsert};

 PRIVATE PROCEDURE ATERAttr_OnBeforeEdit();
 BEGIN
  ATERAttr_OnModifying();
 END {ATERAttr_OnBeforeEdit};

 PRIVATE PROCEDURE ATERAttr_Type_OnSuccessfulChange();
 BEGIN
  SETEMPTY(ATERAttr.Format);
  REPLACE(ATERAttr);
  SetATERAttrFieldModifiable();
 END {ATERAttr_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE ATERAttr_OnBeforeDelete();
 BEGIN
  ATERAttr_OnModifying();
 END {ATERAttr_OnBeforeDelete};

 PRIVATE PROCEDURE IsOldSamplePacket(): SCAL[2];
  VAR
   lastDate: DATE;
 BEGIN
  L_General.CallUs(L_Packet.IsSamplePacket());
  SETSEL(XDocJrn, XDocJrn, L_XDoc.xdt_Packet, L_XDoc.EmptyXDocKind, Packet.Packet);
  IF ~LAST(XDocJrn) THEN
   lastDate:=10\07\2011; (*  ⮢-ࠧ殢   ୠ*)
  ELSE
   lastDate:=XDocJrn.Date;
  END;
  RETURN (SYSDATE() > (lastDate + 30));
 END {IsOldSamplePacket};

 PRIVATE PROCEDURE RemOldSamplePackets();
  VAR
   curPacket: LIKE(Packet.Packet);
 BEGIN
  L_General.CallUs(L_Packet.IsSamplePacket());
  TRY [INTEGRITY(INTEGRITY_ON)]
   SAVE(Packet);
   curPacket:=Packet.Packet;
   CHANGESEL(Packet, PckDTSPB, , Packet.Receiver, Packet.DTStamp);
   FIRST(Packet);
   WHILE OCCURE(Packet) DO
    PROMPT("  ࠧ殢: "+Packet.Packet);
    IF (Packet.Packet # curPacket) & IsOldSamplePacket() THEN
     PacketOnBeforeDel();
     REMOVE(Packet);
    ELSE
     NEXT(Packet);
    END;
   END; (* WHILE OCCURE(Packet) ... *)
   RESTORE(Packet);
  EXCEPT
  END; (* TRY *)
 END {RemOldSamplePackets};

 PUBLIC PROCEDURE MakePacket();
 BEGIN
  AccessPacket();
  RemOldSamplePackets();
  L_General.Assert(Packet.Status = L_Packet.st_Prepared, "ନ஢ ᢥ  ⮫쪮  ⠬-ࠧ栬  ﭨ '⮢'");
  IF    (Packet.Kind = L_Packet.knd_PF_ADV1) |
        (Packet.Kind = L_Packet.knd_PF_ADV2) |
        (Packet.Kind = L_Packet.knd_PF_ADV3) THEN
   CALL(Ank.ByCurrentPacket());
  ELSIF (Packet.Kind = L_Packet.knd_PF_SZV1)   |
        (Packet.Kind = L_Packet.knd_PF_SZV3)   |
        (Packet.Kind = L_Packet.knd_PF_SZV4)   |
        (Packet.Kind = L_Packet.knd_PF_SZV6)   |
        (Packet.Kind = L_Packet.knd_PF_SZV6_4) |
        (Packet.Kind = L_Packet.knd_PF_SPV1)   |
        (Packet.Kind = L_Packet.knd_PF_ADV6_2) |
        (Packet.Kind = L_Packet.knd_PF_ADV10)  |
        (Packet.Kind = L_Packet.knd_PF_ADV11) THEN
   CALL(ManIns.ByCurrentPacket());
  ELSIF (Packet.Kind = L_Packet.knd_PF_RSV1_6) THEN
   CALL(ManIns14.ByCurrentPacket());
  ELSIF (Packet.Kind = L_Packet.knd_PF_SPV2)   THEN
   CALL(SPV.ByCurrentPacket());
  ELSIF (Packet.Kind = L_Packet.knd_PF_SZVK) THEN
   CALL(SZVK, 102);
  ELSIF (Packet.Kind = L_Packet.knd_PF_DSV1) |
        (Packet.Kind = L_Packet.knd_PF_DSV3) THEN
   CALL(DSV.ByCurrentPacket());
  ELSIF (Packet.Kind = L_Packet.knd_PF_SZV6_3) THEN
   CALL(SZV_Inc.ByCurrentPacket());
  ELSE
   L_General.Error(" ⨯  '"+L_Str.PoolItem(L_Packet.knd_Pool, Packet.Kind)+"'   ମ ᢥ  ");
  END;
 END {MakePacket};

 PUBLIC PROCEDURE SingleManIns();
 BEGIN
  IF Memo.ud_fr() >= 01\01\2014 THEN
   CALL(ManIns14.SingleManIns());
  ELSE
   CALL(ManIns.SingleManIns());
  END;
 END {SingleManIns};

 PRIVATE PROCEDURE CopyPacketBrwToSample(SrcPacket, DstPacket: LIKE(Packet.Packet); File: STRING[]);
 BEGIN
  SELECT(^File, Packet, , SrcPacket);
  WHILE OCCURE(^File) DO
   SAVE(^File);
   ^File.Packet:=DstPacket;
   INSERT(^File);
   RESTORE(^File);
   NEXT(^File);
  END; (* WHILE OCCURE(^File) ... *)
 END {CopyPacketBrwToSample};

 PUBLIC PROCEDURE CopyPacketToSample();
  VAR
   srcPacket: LIKE(Packet.Packet);
 BEGIN
  AccessPacket();
  L_StdFrm.Question("஢   ࠧ?");
  srcPacket:=Packet.Packet;
  L_Packet.DefinePckMyFirm(L_Packet.bm_byPacket);
  L_Packet.InsSamplePFPacket(Packet.Kind, Packet.PerB, Packet.PerE, Packet.DataType, Packet.CorrType);

  CopyPacketBrwToSample(srcPacket, Packet.Packet, "PckATER");
  CopyPacketBrwToSample(srcPacket, Packet.Packet, "PckAttr");
  CopyPacketBrwToSample(srcPacket, Packet.Packet, "PckBody");
  L_WDO.PosToCurRecord("Packet", "", 0);
 END {CopyPacketToSample};

 PUBLIC PROCEDURE CopyPacketTrn();
 BEGIN
  AccessPacket();
  L_Packet.CopyPacketTrn();
 END {CopyPacketTrn};

 PRIVATE PROCEDURE AccessPacket();
 BEGIN
  L_General.Assert(ACCESS(Packet), " । ⥪騩 ");
 END {AccessPacket};

 PUBLIC PROCEDURE ShowPacketPrnFiles();
 BEGIN
  L_Packet.ShowPacketFiles(L_Packet.fp_Prn);
 END {ShowPacketPrnFiles};

 PUBLIC PROCEDURE ShowPacketTrnFile();
 BEGIN
  L_Packet.ShowPacketFiles(L_Packet.fp_Trn);
 END {ShowPacketTrnFile};

 PRIVATE PROCEDURE InsIntoTmp(VAR Amount: NUMERIC[0]);
  VAR
   f    : FIELD;
   Table: TABLE;
 BEGIN
  Table:=TABLE.Get("ATERAttr");
  FOR_EACH f IN Table.Fields DO
   ^("cAttr."+f.Name):=^("ATERAttr."+f.Name);
  END;
  SETEMPTY(cAttr.newTable);
  INSERT(cAttr);
  INC(Amount);
 END {InsIntoTmp};

 PRIVATE PROCEDURE intCopyParent(    trgTable   : LIKE(ATERAttr.Table);
                                     trgRow     : LIKE(ATERAttr.Row);
                                     trgATERAttr: LIKE(ATERAttr.ATERAttr);
                                 VAR Amount     : NUMERIC[0]);
 BEGIN
  SAVE(ATERAttr);
  SELECT(ATERAttr, Parent, , ATER.ATER, trgATERAttr, trgTable);
  WHILE OCCURE(ATERAttr) DO
   InsIntoTmp(Amount);
   intCopyParent(ATERAttr.Table, ATERAttr.Row, ATERAttr.ATERAttr, Amount);
   NEXT(ATERAttr);
  END; (* WHILE OCCURE(ATERAttr) ... *)
  RESTORE(ATERAttr);
 END {intCopyParent};

 PRIVATE PROCEDURE CopyTables(BySelectedATERAttr: SCAL[2]);
  VAR
   curTable,
   oldTable,
   newTable,
   tmpTable   : LIKE(ATERAttr.Table);
   curATERAttr,
   oldATERAttr: LIKE(ATERAttr.ATERAttr);
   Amount     : NUMERIC[0];
   ReserLab   : SCAL[2];
   Increment  : NUMERIC[0];
   f    : FIELD;
   Table: TABLE;
 BEGIN
  L_General.SilentPrgsOnly();
  L_General.Assert(ACCESS(ATER), " ࠭ ଠ ");
  L_General.Assert(ACCESS(ATERAttr), " ࠭ ਡ");

  SETEMPTY(newTable);
  SETZERO(Amount, ReserLab);
  L_AFM.AF_MakeDataBaseStructureCopy("ATERAttr", "cAttr", "newTable: LIKE(ATERAttr.Table)", L_AFM.tdm_None);
  IF BySelectedATERAttr THEN
   CONFORM(ATER, ATERAttr);
   WHILE OCCURE(ATERAttr) DO
    IF WITHLAB(ATERAttr, 0) THEN
     InsIntoTmp(Amount);
    END;
    NEXT(ATERAttr);
   END; (* WHILE OCCURE(ATERAttr) ... *)
  ELSE
   InsIntoTmp(Amount);
   intCopyParent(ATERAttr.Table, ATERAttr.Row, ATERAttr.ATERAttr, Amount);
  END;
  L_General.Assert(Amount # 0, " 뤥  ஢ ਡ⮢");

  STDFORM(L_StdFrm.sf_Choice("|⬥祭 ⮢           %####%" +
                             "|                                   " +
                             "| ⠡                %####%" +
                             "|                                   " +
                             "|%#################################%",
                             "%NI" +
                             "%I" +
                             "%< ⪨ ᫥ ஢>E"),
          "஢ 䠩",
          ,
          ,
          Amount, newTable, ReserLab);

  SELECT(cAttr, ATER, , ATER.ATER);
  curATERAttr:=cAttr.ATERAttr;
  Increment  :=newTable - cAttr.Table;

  SELECT(cAttr, ATER, , ATER.ATER);
  WHILE OCCURE(cAttr) DO
   oldTable   :=cAttr.Table;
   oldATERAttr:=cAttr.ATERAttr;
   tmpTable   :=oldTable + Increment;
   SAVE(cAttr);
   WHILE SELECT(cAttr, Parent, ATER.ATER, oldATERAttr, oldTable) DO
    cAttr.xmlPrnTb:=tmpTable;
    REPLACE(cAttr);
   END;
   RESTORE(cAttr);
   cAttr.newTable:=tmpTable;
   REPLACE(cAttr);
   NEXT(cAttr);
  END; (* WHILE OCCURE(cAttr) ... *)

  Table:=TABLE.Get("ATERAttr");
  SELECT(cAttr, ATER, , ATER.ATER);
  WHILE OCCURE(cAttr) DO
   FOR_EACH f IN Table.Fields DO
    IF f.Name = "Table" THEN
     ATERAttr.Table:=cAttr.newTable;
    ELSE
     ^("ATERAttr."+f.Name):=^("cAttr."+f.Name);
    END;
   END;
   INSERT(ATERAttr);
   NEXT(cAttr);
  END; (* WHILE OCCURE(cAttr) ... *)

  IF BySelectedATERAttr & ReserLab THEN
   CONFORM(ATER, ATERAttr);
   WHILE OCCURE(ATERAttr) DO
    IF WITHLAB(ATERAttr, 0) THEN
     RESETLAB(ATERAttr, 0);
     REPLACE(ATERAttr);
    END;
    NEXT(ATERAttr);
   END; (* WHILE OCCURE(ATERAttr) ... *)
  END;

  SEARCH(ATERAttr, ATERAttr, , ATER.ATER, curATERAttr, newTable);
  SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), ATERAttr);
 END {CopyTables};

 PUBLIC PROCEDURE CopySelectedATERAttr();
 BEGIN
  CopyTables(1);
 END {CopySelectedATERAttr};

 PUBLIC PROCEDURE CopyParent();
 BEGIN
  CopyTables(0);
 END {CopyParent};

 PRIVATE PROCEDURE MoveSingleTable(Dir, Shift: NUMERIC[0]; curTable: LIKE(ATERAttr.Table));
  VAR
   newTable: LIKE(ATERAttr.Table);
 BEGIN
  TRY [INTEGRITY(INTEGRITY_ON)]
   newTable:=curTable + Dir * Shift;
   L_General.Assert(~SELECT(ATERAttr, ATER, ATER.ATER, newTable), " ଠ 㦥  ⠡ " + curTable);
 
   WHILE SELECT(ATERAttr, ATER, ATER.ATER, curTable) DO
    ATERAttr.Table:=newTable;
    REPLACE(ATERAttr);
    NEXT(ATERAttr);
   END; (* WHILE OCCURE(ATERAttr) ... *)
 
   WHILE SELECT(ATERAttr, xmlPrnTb, ATER.ATER, curTable) DO
    ATERAttr.xmlPrnTb:=newTable;
    REPLACE(ATERAttr);
    NEXT(ATERAttr);
   END; (* WHILE OCCURE(ATERAttr) ... *)
  EXCEPT
  END; (* TRY *)
 END {MoveSingleTable};

 PRIVATE PROCEDURE GetShiftForMovingTable(Dir: NUMERIC[0]): NUMERIC[0];
  VAR
   Shift: NUMERIC[0];
 BEGIN
  Shift:=1;
  STDFORM(L_StdFrm.sf_Choice("|६ ⠡ " + L_Str.PoolItem("|", Dir=-1) + "  %###% 権|",
                             "%I"),
          "६饭 ⠡",
          ,
          ,
          Shift);
  RETURN Shift;
 END {GetShiftForMovingTable};

 PUBLIC PROCEDURE MoveCurrentTable(Dir: NUMERIC[0]);
 BEGIN
  L_General.SilentPrgsOnly();
  ACCESS(ATER);
  ACCESS(ATERAttr);
  MoveSingleTable(Dir, GetShiftForMovingTable(Dir), ATERAttr.Table);
 END {MoveCurrentTable};

 PUBLIC PROCEDURE MoveAllTablesFromCurrent(Dir: NUMERIC[0]);
  VAR
   Shift   : NUMERIC[0];
   curTable: LIKE(ATERAttr.Table);
 BEGIN
  L_General.SilentPrgsOnly();
  L_StdFrm.Question("।  ⠡ " + L_Str.PoolItem("|", Dir=-1) + ", 稭  ⥪饩?");
  Shift:=GetShiftForMovingTable(Dir);

  ACCESS(ATER);
  ACCESS(ATERAttr);
  curTable:=ATERAttr.Table;
  L_AFM.MakeIndex("AATbL", "Table: LIKE(ATERAttr.Table)");
  SETSEL(ATERAttr, ATER, ATER.ATER);
  SRCINSEL(ATERAttr, GE, , curTable);
  WHILE OCCURE(ATERAttr) DO
   NARROWSEL(ATERAttr, Table);
   AATbL.Table:=ATERAttr.Table;
   INSERT(AATbL);
   NEXTINEXTENDEDSEL(ATERAttr, Table);
  END; (* WHILE OCCURE(ATERAttr) ... *)

  SELECT(AATbL, AATbL);
  IF Dir = +1 THEN
   LAST(AATbL);
   WHILE OCCURE(AATbL) DO
    MoveSingleTable(Dir, Shift, AATbL.Table);
    PREV(AATbL);
   END; (* WHILE OCCURE(AATbL) ... *)
  ELSE
   WHILE OCCURE(AATbL) DO
    MoveSingleTable(Dir, Shift, AATbL.Table);
    NEXT(AATbL);
   END; (* WHILE OCCURE(AATbL) ... *)
  END;
 END {MoveAllTablesFromCurrent};

 PUBLIC PROCEDURE MoveRowsFromCurrent(Dir: NUMERIC[0]);
  VAR
   curRow  : LIKE(ATERAttr.Row);
   newRow  : NUMERIC[0];
   curATER : LIKE(ATER.ATER);
   trgShift: NUMERIC[0];
   curTable: LIKE(ATERAttr.Table);
 BEGIN
  trgShift:=1;
  STDFORM(L_StdFrm.sf_Choice("|६ ப " + L_Str.PoolItem("|", Dir=-1) + "  %###% 権|",
                             "%I"),
          "६饭 ப",
          ,
          ,
          trgShift);

  ACCESS(ATERAttr);
  curATER :=ATERAttr.ATER;
  curRow  :=ATERAttr.Row;
  curTable:=ATERAttr.Table;

  IF Dir = +1 THEN
   SELECT(ATERAttr, ATER, , curATER, curTable);
   LAST(ATERAttr);
   WHILE OCCURE(ATERAttr) & (ATERAttr.Row >= curRow) DO
    newRow:=ATERAttr.Row + trgShift * Dir;

    IF newRow > MAXOF(ATERAttr.Row) THEN
     L_General.Error(" ६ ப  - ᫨誮 让  ப  ⮬ ᤢ ⭮⥫쭮 ப " + ATERAttr.Row);
    END;
  
    ATERAttr.Row:=newRow;
    REPLACE(ATERAttr);
    PREV(ATERAttr);
   END; (* WHILE OCCURE(ATERAttr) ... *)
  ELSE
   SELECT(ATERAttr, ATER, , curATER, curTable);
   SRCINSEL(ATERAttr, GE, , curRow);
   WHILE OCCURE(ATERAttr) DO
    newRow:=ATERAttr.Row + trgShift * Dir;

    IF newRow < 0 THEN
     L_General.Error(" ६ ப  - ⥫  ப  ⮬ ᤢ ⭮⥫쭮 ப " + ATERAttr.Row);
    END;
 
    SAVE(ATERAttr);
    IF SELECT(ATERAttr, ATER, curATER, curTable, newRow) THEN
     L_StdFrm.Choice("  ப " + FLDTOSTR(newRow, "L0"));
    END;
    RESTORE(ATERAttr);

    ATERAttr.Row:=newRow;
    REPLACE(ATERAttr);
 
    NEXT(ATERAttr);
   END; (* WHILE OCCURE(ATERAttr) ... *)
  END;
 END {MoveRowsFromCurrent};

 PRIVATE PROCEDURE Packet_PutNewFilters(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "஬ '⢥࣭'  '㫨஢'", "(Packet.Status#"+L_Str.IntStr(L_Packet.st_Rejected)+") & (Packet.Status#"+L_Str.IntStr(L_Packet.st_Canceled)+")", 1);
 END {Packet_PutNewFilters};

 PUBLIC PROCEDURE scs_GetFilters_Packet0_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  Packet_PutNewFilters(Filters);
 END {scs_GetFilters_Packet0_1};

 PUBLIC PROCEDURE scs_GetFilters_Packet1_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  Packet_PutNewFilters(Filters);
 END {scs_GetFilters_Packet1_1};

 PUBLIC PROCEDURE scs_GetFilters_Packet2_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  Packet_PutNewFilters(Filters);
 END {scs_GetFilters_Packet2_1};

 PUBLIC PROCEDURE scs_GetFilters_ATERE_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "ਡ, ॡ騥 筮 ", "(ATERAttr.Kind=" + L_Str.IntStr(L_ATER.aak_ManualInput) + ")", 1);
  L_WDO.PutNewFilter(Filters, "쪮 ⥩",                      "(ATERAttr.xmlElmTp="+L_Str.IntStr(L_ATER.xet_ComplexElm)+")",  1);
  L_WDO.PutNewFilter(Filters, "쪮 ⮢ ",                 "(ATERAttr.xmlElmTp#"+L_Str.IntStr(L_ATER.xet_ComplexElm)+")",  1);
 END {scs_GetFilters_ATERE_1};

 PUBLIC PROCEDURE scs_GetFilters_PckATER_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "ਡ, ॡ騥 筮 ", "(PckATER.Source=" + L_Str.IntStr(L_Packet.src_Operator) + ")", 1);
 END {scs_GetFilters_PckATER_1};

 PUBLIC PROCEDURE ToggleFilter();
 BEGIN
  L_StdFrm.Inform("ᯮ ShiftTab.  01.10.2012 ⡮  㤥 ᤥ ⮫쪮 ⠬");
 END {ToggleFilter};

 PUBLIC PROCEDURE PosToMakedPackets(trgDTStamp: LIKE(Packet.DTStamp));
 BEGIN
  IF trgDTStamp # 0 THEN
   IF SELECT(Packet, PacketDS, L_Packet.rcv_PensFund, trgDTStamp) THEN
    SE_WZD_CURSOR(APP.Get().TopWindow.Name, APP.Get().TopWindow.ActiveZone.Number, Packet);
   END;
  END;
 END {PosToMakedPackets};

 PRIVATE PROCEDURE Packet_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Packet";
  L_WDO.iField       (1, "Packet.Status").Format:=L_Packet.st_ShortPool;
  L_WDO.iField       (1, "Packet.Receiver").Format:=L_Packet.rcv_Pool;
  L_WDO.iField       (1, "Packet.Kind").Format:=L_Packet.knd_Pool;
  L_WDO.iSubwindow   (1, "PacketE");
 END {Packet_OnInitializeWindow};

 PRIVATE PROCEDURE ATERAttr_xmlPrnAA_OnSuccessfulChange();
  VAR
   trg_xmlPrnTb: LIKE(ATERAttr.xmlPrnTb);
 BEGIN
  IF ~!ATERAttr.xmlPrnAA THEN
   L_General.Assert(~!ATERAttr.Table, "  ⠡");
   SAVE(ATERAttr);
   SELECT(ATERAttr, ATERAttr, , ATERAttr.ATER, ATERAttr.xmlPrnAA);
   L_General.Assert(ATERAttr.xmlElmTp = L_ATER.xet_ComplexElm, ATERAttr.ATERAttr + "   '᫮'");
   trg_xmlPrnTb:=ATERAttr.Table;
   WHILE NEXT(ATERAttr) DO
    IF ATERAttr.xmlElmTp = L_ATER.xet_ComplexElm THEN
     SETEMPTY(trg_xmlPrnTb);
    END;
   END;
   RESTORE(ATERAttr);
   ATERAttr.xmlPrnTb:=trg_xmlPrnTb;
   REPLACE(ATERAttr);
  END;
 END {ATERAttr_xmlPrnAA_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckFillParentFields(Cond: SCAL[2]; Msg: STRING[]);
 BEGIN
  IF ~Cond THEN
   IF ATERAttr.xmlElmTp # L_ATER.xet_ComplexElm THEN
    L_General.Error(Msg);
   ELSE
    L_StdFrm.Choice(Msg + "||" + "᪠ ⮫쪮  ਡ⮢ 孥 ஢ 娨");
   END;
  END;
 END {CheckFillParentFields};

 PRIVATE PROCEDURE ATERAttr_OnAfterEdIns();
 BEGIN
  CheckFillParentFields(~!ATERAttr.xmlPrnTb, "  த⥫᪠ ⠡");
  CheckFillParentFields(~!ATERAttr.xmlPrnAA, "  த⥫᪨ ਡ");
 END {ATERAttr_OnAfterEdIns};

 PRIVATE PROCEDURE ATERAttr_OnAfterInsert();
 BEGIN
  ATERAttr_OnAfterEdIns();
 END {ATERAttr_OnAfterInsert};

 PRIVATE PROCEDURE ATERAttr_OnAfterEdit();
 BEGIN
  ATERAttr_OnAfterEdIns();
 END {ATERAttr_OnAfterEdit};

 PRIVATE PROCEDURE ATERE_1_OnSetSubwindow();
 BEGIN
  IF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert) & ACCESS(ATERAttr) THEN
   trgInsTable:=ATERAttr.Table;
   trgInsRow  :=ATERAttr.Row;
  ELSE
   SETEMPTY(trgInsTable, trgInsRow);
  END;
  RTI.Get().CurZone.SubwindowOriginalName:="ATERAttr";
 END {ATERE_1_OnSetSubwindow};

 PRIVATE PROCEDURE IsParentWChild(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(ATERAttr);
  Result:=SELECT(ATERAttr, Parent, ATER.ATER, ATERAttr.ATERAttr, ATERAttr.Table);
  RESTORE(ATERAttr);
  RETURN Result;
 END {IsParentWChild};

 PRIVATE PROCEDURE intRemoveParent(trgTable: LIKE(ATERAttr.Table); trgRow: LIKE(ATERAttr.Row); trgATERAttr: LIKE(ATERAttr.ATERAttr));
 BEGIN
  TRY [INTEGRITY(INTEGRITY_ON)]
   WHILE SELECT(ATERAttr, Parent, ATER.ATER, trgATERAttr, trgTable) DO
    IF IsParentWChild() THEN
     intRemoveParent(ATERAttr.Table, ATERAttr.Row, ATERAttr.ATERAttr);
    ELSE
     REMOVE(ATERAttr);
    END;
   END; (* WHILE OCCURE(ATERAttr) ... *)
  EXCEPT
  END; (* TRY *)
 END {intRemoveParent};

 PUBLIC PROCEDURE RemoveParent();
 BEGIN
  ACCESS(ATERAttr);
  L_StdFrm.Choice("     稭 ᥩ");
  SAVE(ATERAttr);
  intRemoveParent(ATERAttr.Table, ATERAttr.Row, ATERAttr.ATERAttr);
  RESTORE(ATERAttr);
  REMOVE(ATERAttr);
 END {RemoveParent};

 PUBLIC PROCEDURE MakeCopy();
 BEGIN
  ACCESS(ATER);
  L_WDO.LaunchInsertBySource(ATER.ATER, "");
 END {MakeCopy};

 PUBLIC PROCEDURE extPosToPackets(trgMyFirm  : LIKE(MyFirm.MyFirm);
                                  trgReceiver: LIKE(Packet.Receiver);
                                  trgKind    : LIKE(Packet.Kind);
                                  trgPerB,
                                  trgPerE    : DATE;
                                  trgWindow  : STRING[]);
 BEGIN
  IF ~!trgKind THEN
   SETSEL(Packet, PacketKn, trgReceiver, trgKind, trgPerB, trgPerE);
  ELSE
   SETSEL(Packet, PacketEN, trgReceiver, trgPerB, trgPerE);
  END;
  IF LAST(Packet) THEN
   REPEAT
   UNTIL (Packet.MyFirm = trgMyFirm) | ~PREV(Packet);
  END;
  IF ~OCCURE(Packet) THEN
   L_StdFrm.Inform("    室饣 ");
   LAST(Packet);
  END;

  SE_WZD_CURSOR(trgWindow, 1, Packet);
 END {extPosToPackets};

 PUBLIC PROCEDURE PosToRefPackets();
  VAR
   trgKind: LIKE(Packet.Kind);
 BEGIN
  AccessPacket();
  IF    (Packet.Kind = L_Packet.knd_RSV_1)  THEN
   IF !L_Packet.Get_PF_PacketKind(L_Packet.Get_PF_StdPerB(Packet.PerE), L_Packet.Get_PF_StdPerE(Packet.PerE), L_Packet.dt_None, L_Packet.ct_None) THEN
    trgKind:=L_Packet.Get_PF_PacketKind(L_Packet.Get_PF_StdPerB(Packet.PerE), L_Packet.Get_PF_StdPerE(Packet.PerE), L_Packet.dt_Basic, L_Packet.ct_None);
   ELSE
    SETEMPTY(trgKind);
   END;
   LIKEMENU(View, "Packet0 1", CALL, "Packet.extPosToPackets("+L_Str.IntStr(Packet.MyFirm)+","+
                                                               L_Str.IntStr(L_Packet.rcv_PensFund)+","+
                                                               L_Str.IntStr(trgKind)+","+
                                                               FLDTOSTR(L_Packet.Get_PF_StdPerB(Packet.PerE), "D\N\y")+","+
                                                               FLDTOSTR(L_Packet.Get_PF_StdPerE(Packet.PerE), "D\N\y")+","+
                                                               '"Packet0")');
  ELSIF L_Packet.IsPersPacket() THEN
   LIKEMENU(View, "Packet2 1", CALL, "Packet.extPosToPackets("+L_Str.IntStr(Packet.MyFirm)+","+
                                                               L_Str.IntStr(L_Packet.rcv_e_TaxDep)+","+
                                                               L_Str.IntStr(L_Packet.knd_RSV_1)+","+
                                                               FLDTOSTR(L_DatTim.YearBeg(Packet.PerE), "D\N\y")+","+
                                                               FLDTOSTR(L_DatTim.Per(Packet.PerE), "D\N\y")+","+
                                                               '"Packet2")');
  ELSE
   L_General.CallUs(0);
  END;
 END {PosToRefPackets};

BEGIN
 L_Events.ExecuteHandler();
END.
