(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose     ஢ઠ ࠢ쭮  ப '祭 ⥦'
%Type        control
%Specific    SYS
%Modified    14.11.2013 20:11:28 POLAK\GAV
%Environment PayP.PayP = 00 - 
*)

 MODULE PayP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_PayP, L_StdFrm, L_Str, L_ExtAb, Str, Math,
        L_DatTim, L_OwnData, Memo, L_AFM, L_Staff, L_WDO, L_DBD;

 PRIVATE PROCEDURE TestPattern(s, Template: STRING[]);
  VAR t: STRING[];
 BEGIN
  PROMPT("ப '"+s+"'");
  TRY
   t:=L_PayP.MorphString(s, Template, PROCREF(), -1);
  EXCEPT
  ON Ex: Exc_Raise DO
   IF Ex.ErrorCode=-1 THEN
    L_StdFrm.Inform(Ex.Description);
   ELSE
    RAISE();
   END;
  ELSE
   RAISE();
  END;
 END {TestPattern};

 PRIVATE PROCEDURE PayP_LstTitle_OnSuccessfulChange();
 BEGIN
  TestPattern(PayP.LstTitle, L_PayP.ppt_ListTitle);
 END {PayP_LstTitle_OnSuccessfulChange};

 PRIVATE PROCEDURE PayP_LstAttr_OnSuccessfulChange();
  VAR
   curIndex: NUMERIC[0];
 BEGIN
  curIndex:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  IF ~!PayP.LstAttr[curIndex] THEN
   L_General.Assert(~L_PayP.IsEmptyAttr(curIndex) | (curIndex # 0),
                    "⮩ ਡ     ਡ⮬ ");
   L_General.Assert((PayP.LstAttr[curIndex] # L_PayP.a_Document) | (curIndex # 0),
                    "㬥     ਡ⮬ ");
   PayP.AttrName[curIndex]:=L_PayP.GetObjTitle(PayP.LstAttr[curIndex], curIndex);
   PayP.AttrLen [curIndex]:=L_PayP.GetDefaultObjLen(PayP.LstAttr[curIndex]);
  ELSE
   PayP.AttrName[curIndex]:="";
   SETEMPTY(PayP.AttrLen[curIndex]);
  END; (* IF ~!PayP.LstAttr[curIndex] ... *)
  REPLACE(PayP);
 END {PayP_LstAttr_OnSuccessfulChange};

 PRIVATE PROCEDURE PayP_AttrLen_OnSuccessfulChange();
  VAR
   curIndex: NUMERIC[0];
 BEGIN
  curIndex:=RTI.Get().CurZone.ActiveField.ArrayIndex;
  IF !PayP.AttrLen[curIndex] | !PayP.LstAttr[curIndex] THEN
   HALT();
  END;
 END {PayP_AttrLen_OnSuccessfulChange};

 PRIVATE PROCEDURE PayP_PayLMult_OnSuccessfulChange();
 BEGIN
  TestPattern(PayP.PayLMult[RTI.Get().CurZone.ActiveField.ArrayIndex], L_PayP.ppt_MultyPersPayment);
 END {PayP_PayLMult_OnSuccessfulChange};

 PRIVATE PROCEDURE PayP_PayLSngl_OnSuccessfulChange();
 BEGIN
  TestPattern(PayP.PayLSngl[RTI.Get().CurZone.ActiveField.ArrayIndex], L_PayP.ppt_SinglePersPayment);
 END {PayP_PayLSngl_OnSuccessfulChange};

 PRIVATE PROCEDURE SetFlagEdit(Field: STRING[]; FlagEdit: SCAL[2]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(^Field) DO
   RTI.Get().CurZone.Fields(Field+"["+L_Str.IntStr(i)+"]").Modifiable:=FlagEdit;
   INC(i);
  END;
 END {SetFlagEdit};

 PRIVATE PROCEDURE _SetFlagEdit(FlagEdit: SCAL[2]);
 BEGIN
  SetFlagEdit("PayP.LstTitle", FlagEdit);
  SetFlagEdit("PayP.LstAttr",  FlagEdit);
  SetFlagEdit("PayP.AttrLen",  FlagEdit);
  SetFlagEdit("PayP.AttrName", FlagEdit);
  SetFlagEdit("PayP.LstSum",   FlagEdit);
  SetFlagEdit("PayP.PstFile",  FlagEdit);
  SetFlagEdit("PayP.PayLMult", FlagEdit);
  SetFlagEdit("PayP.LstLines", FlagEdit);
 END {_SetFlagEdit};

 PRIVATE PROCEDURE PayP_Type_OnSuccessfulChange();
 BEGIN
  IF ~!PayP.Type THEN
   _SetFlagEdit(PayP.Type);
  END;
 END {PayP_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE PayPE_0_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("PayP.PayLSExt").AskMode:=FORM_FIELD.AskMode_Manual;
 END {PayPE_0_OnZoneOpen};

 PRIVATE PROCEDURE PayP_PayLSExt_OnBeforeAskForEdit();
 BEGIN
  LIKEMENU(Edit, "PayPLSE 0");
 END {PayP_PayLSExt_OnBeforeAskForEdit};

 PRIVATE PROCEDURE CheckPayPPayLSExt();
 BEGIN
  IF ~!PayP.PayLSExt THEN
   L_ExtAb.CheckPayPPayLSExt();
   TestPattern(PayP.PayLSExt, L_PayP.ppt_MDocPayment);
  END;
 END {CheckPayPPayLSExt};

 PRIVATE PROCEDURE PayP_PayLSExt_OnSuccessfulChange();
 BEGIN
  CheckPayPPayLSExt();
 END {PayP_PayLSExt_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckPatterns(ArrField: STRING[][]; Template: STRING[]);
  VAR
   i: NUMERIC[0];
   t: STRING[];
 BEGIN
  i:=0;
  WHILE i <= HIGH(ArrField) DO
   PROMPT("ப '"+ArrField[i]+"'");
   t:=L_PayP.MorphString(ArrField[i], Template, PROCREF(), -1);
   INC(i);
  END; (* WHILE (i < ... *)
 END {CheckPatterns};

 PRIVATE PROCEDURE AfterEditInsert();
  VAR
   AttrIdx: SCAL[L_PayP.MaxAttrAmnt];
   SumIdx : SCAL[L_PayP.MaxSumAmnt];
   Length : NUMERIC[0];
 BEGIN
  PayP.AttrMap:=0;
  IF PayP.PayP # 00 THEN
   Length      :=5; (*  ப  ࠧ⥫ (ਬ: |003| ) *)
   FOR_EACH AttrIdx DO
    IF ~!PayP.LstAttr[AttrIdx] THEN
     L_General.Assert(~!PayP.AttrName[AttrIdx], " 㪠  |"+
                                                L_Str.PoolItem("ࢮ|ண|쥣", AttrIdx)+
                                                " ਡ ");
     INCL(PayP.AttrMap, PayP.LstAttr[AttrIdx]);
     INC(Length, L_PayP.GetObjLen(PayP.LstAttr[AttrIdx], AttrIdx) + 1);
    END;
   END; (* FOR_EACH AttrIdx ... *)
   L_General.Assert((PayP.AttrMap # 0) | (PayP.Type # L_PayP.ppType_wSheet),  " ⨯ ' '   㪠 ਡ ");
   FOR_EACH SumIdx DO
    IF ~!PayP.LstSum[SumIdx] THEN
     INC(Length, L_PayP.GetObjLen(L_PayP.SumObj, SumIdx) + 1);
    END;
   END; (* FOR_EACH SumIdx ... *)
   L_General.Assert(Length <= L_PayP.MaxLength, "誮   ਭ |"+
                                                "ਭ  "+L_Str.IntStr(Length)+
                                                "|ᨬ쭠 ਭ "+L_Str.IntStr(L_PayP.MaxLength));
   CheckPatterns(PayP.LstTitle, L_PayP.ppt_ListTitle);
   CheckPatterns(PayP.PayLMult, L_PayP.ppt_MultyPersPayment);
   CheckPatterns(PayP.PayLSngl, L_PayP.ppt_SinglePersPayment);

   CheckPayPPayLSExt();
  END; (* IF PayP.PayP # 00 ... *)
  REPLACE(PayP);
 END {AfterEditInsert};

 PRIVATE PROCEDURE PayP_OnAfterEdit();
 BEGIN
  AfterEditInsert();
 END {PayP_OnAfterEdit};

 PRIVATE PROCEDURE BeforeEditInsert();
 BEGIN
  IF !PayP.Type | (PayP.Type=L_PayP.ppType_wSheet) THEN
   _SetFlagEdit(1);
  ELSE
   _SetFlagEdit(0);
  END;
 END {BeforeEditInsert};

 PRIVATE PROCEDURE PayP_OnBeforeEdit();
 BEGIN
  BeforeEditInsert();
 END {PayP_OnBeforeEdit};

 PRIVATE PROCEDURE intMakeCopy(srcPayP: LIKE(PayP.PayP));
 BEGIN
  L_DBD.CopyFromSrcRecord("PayP", srcPayP);
  REPLACE(PayP);
 END {intMakeCopy};

 PRIVATE PROCEDURE PayP_OnBeforeInsert();
  VAR
   srcPayP: LIKE(PayP.PayP);
 BEGIN
  srcPayP:=L_WDO.GetInsertionSource();
  IF ~!srcPayP THEN
   intMakeCopy(srcPayP);
  END;
  BeforeEditInsert();
 END {PayP_OnBeforeInsert};

 PRIVATE PROCEDURE PayP_OnAfterInsert();
 BEGIN
  AfterEditInsert();
 END {PayP_OnAfterInsert};

 PRIVATE PROCEDURE PayP_OnBeforeDelete();
 BEGIN
  L_General.Assert(PayP.PayP # 10, " 㤠 祭 ⥦ 10 "+PayP.Name);
 END {PayP_OnBeforeDelete};

 PRIVATE PROCEDURE PreparePoolForShow(Pool: STRING[]): STRING[];
  CONST
   maxLines = 128;
  VAR
   s                 : STRING[];
   descriptions,
   patterns          : STRING[][maxLines];
   curAppConsWidth,
   curAppConsHeight,
   patternlength,
   descriptionlength,
   Idx               : NUMERIC[0];
 BEGIN
  SETZERO(patternlength, descriptionlength, Idx);
  SETEMPTY(patterns, descriptions);
  LOOP
   s:=L_Str.PoolItem(Pool, Idx);
   IF !s THEN
    EXIT;
   END;
   patterns[Idx]    :='"'+Str.Item(s, ":", 0)+'"';
   descriptions[Idx]:=Str.Item(s, ":", 2);
   patternlength    :=Math.Max(patternlength,     Str.Length(patterns[Idx]));
   descriptionlength:=Math.Max(descriptionlength, Str.Length(descriptions[Idx]));
   INC(Idx);
  END;

  GE_APPWIN_SIZE(curAppConsWidth, curAppConsHeight);
  descriptionlength:=Math.Min(descriptionlength,
                              curAppConsWidth - patternlength - 7);

  Idx:=0;
  s  :="";
  WHILE ~!patterns[Idx] DO
   s:=s + Str.Align(patterns[Idx],     patternlength,     LEFT) + " " +
          Str.Align(descriptions[Idx], descriptionlength, LEFT) + "|";
   INC(Idx);
  END;
  RETURN s;
 END {PreparePoolForShow};

 PUBLIC PROCEDURE ShowPatternList();
  CONST
   ListTypePool = " ଫ   뫪  |" +
                  " ⢨  (௫)|" +
                  " 稨  (௫)|" +
                  "   (௫)";
  VAR
   Choice,
   ListType : NUMERIC[0];
   FieldName,
   Templates: STRING[];
   curField : FORM_FIELD;
   curTFName: STRING[];
 BEGIN
  curField:=RTI.Get().CurZone.ActiveField;
  curTFName:=curField.TableField.Name;
(*
  IF    curTFName = "PayLSExt" THEN ListType:=0; Templates:=L_PayP.ppt_MDocPayment;
  ELSIF curTFName = "PayLSngl" THEN ListType:=1; Templates:=L_PayP.ppt_SinglePersPayment;
*)
  IF    curTFName = "PayLSngl" THEN ListType:=1; Templates:=L_PayP.ppt_SinglePersPayment;
  ELSIF curTFName = "PayLMult" THEN ListType:=2; Templates:=L_PayP.ppt_MultyPersPayment;
  ELSIF curTFName = "LstTitle" THEN ListType:=3; Templates:=L_PayP.ppt_ListTitle;
  ELSE
   L_General.Error("   蠡  ।ᬮ७");
  END;
  Choice:=L_StdFrm.ShowListAsMenu(PreparePoolForShow(Templates), L_Str.PoolItem(ListTypePool, ListType));
  ^(curField.Name):=^(curField.Name) + "\" + Str.Item(L_Str.PoolItem(Templates, Choice), ":", 0);
  REPLACE(^(curField.TableField.Table.Name));
 END {ShowPatternList};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
PayP.PayP, L, ""
PayP.Name, L, ""
@
#############################################################                    ########## #####
=#####===========================================================================================
|###############################################################################################|
|-----------------------------------------------------------------------------------------------|
|祭 ⥦ ## #########################################################################|
|-----------------------------------------------------------------------------------------------|
|  |                 | 㤥ঠ        |ਭ    |    | |砫    |.    |
|-----|--------------------|---------------------|----------|----------|--|----------|----------|
}
*)

(*
$P{ Line:
Staff.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
MCList.MCode, L, ""
MCList.Name, L, ""
Staff.BegDate, L, "D.N.y"
Staff.EndDate, L, "D.N.y"
Deduct.DedNbr, L, ""
Deduct.BegDate, L, "D.N.y"
Deduct.EndDate, L, "D.N.y"
@
|#####|####################|### #################|##########|##########|##|##########|##########|
}
*)

(*
$P{ Bot:
@
=(c) Polak=======================================================================================
}
*)

 PRIVATE PROCEDURE Cond(TimeCond: L_General.tTimeCond): SCAL[2];
 BEGIN
  IF    TimeCond = L_General.tc_onDate THEN
   CONFORM(Deduct, Staff);
   RETURN L_Staff.rInState(Memo.ud_cd()) &
          L_DatTim.IsActive_Inc(Memo.ud_cd(), Deduct.BegDate, Deduct.EndDate);
  ELSIF TimeCond = L_General.tc_inIntvl THEN
   CONFORM(Deduct, Staff);
   RETURN L_DatTim.IsActiveInIntvl_Inc(Memo.ud_fr(), Memo.ud_ut(),
                                       Staff.BegDate, Staff.EndDate) &
          L_DatTim.IsActiveInIntvl_Inc(Memo.ud_fr(), Memo.ud_ut(),
                                       Deduct.BegDate, Deduct.EndDate);
  ELSIF TimeCond = L_General.tc_Entire THEN
   RETURN 1;
  ELSE
   L_General.CallUs(0);
  END;
 END {Cond};

 PRIVATE PROCEDURE PrintList(RepName: STRING[]; Title: STRING[]; TimeCond: L_General.tTimeCond);
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.Assert(ACCESS(PayP), " ⠭ 祭 ⥦");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, "ঠ  祭 ⥦ " + Title);
  L_AFM.MakeIndex("tmp", "TSN: LIKE(Deduct.TSN); DedNbr: LIKE(Deduct.DedNbr)");
  SELECT(Deduct, PayP, , PayP.PayP);
  WHILE OCCURE(Deduct) DO
   PROMPT("⮢: " + Deduct.TSN);
   IF Cond(TimeCond) THEN
    ADD(tmp, tmp, , Deduct.TSN, Deduct.DedNbr);
   END;
   NEXT(Deduct);
  END; (* WHILE OCCURE(Deduct) ... *)

  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   PROMPT(": " + tmp.TSN);
   SEARCH(Deduct, TSN, , tmp.TSN, tmp.DedNbr);
   CONFORM(Deduct, Staff);
   CONFORM(Staff, Man);
   CONFORM(Deduct, MCList);
   MAKEPART(R, Line);
   NEXT(tmp);
  END; (* WHILE OCCURE(tmp) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("tmp");
 END {PrintList};

 PUBLIC PROCEDURE MakeCopy();
 BEGIN
  ACCESS(PayP);
  L_WDO.LaunchInsertBySource(PayP.PayP, "");
 END {MakeCopy};

 PUBLIC PROCEDURE PayPD();
 BEGIN
  PrintList("PayPD", " " + L_DatTim.DateStr(Memo.ud_cd()), L_General.tc_onDate);
 END {PayPD};

 PUBLIC PROCEDURE PayPM();
 BEGIN
  PrintList("PayPM", " ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) +
                             "  " + L_DatTim.DateStr(Memo.ud_ut()), L_General.tc_inIntvl);
 END {PayPM};

 PUBLIC PROCEDURE PayPP();
 BEGIN
  PrintList("PayPP", "  ", L_General.tc_Entire);
 END {PayPP};

BEGIN
 L_Events.ExecuteHandler();
END.
