(*
%Copyright   (c) Polak Computer System
%Author      25.10.2001 18:44:42 BOR
%Purpose
%Type        report
%Specific    SYS
%Modified    24.09.2014 16:14:48 LDA
%Environment
*)

 MODULE PD100 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Basis, L_PDoc, FIO, L_Str, L_MDoc, P_Firm, Str, L_Prop,
        L_AFM, L_Money, L_XDR, Memo, L_XDoc, L_XObj, L_Acnt, P_MDoc, E_Prop, L_StdFrm, L_bp, L_IsSData;

 CONST
  s_In       = 0;
  s_Out      = 1;
  s_Turnover = 2;

 VAR
  wMF: SCAL[2];

 PRIVATE PROCEDURE convEmptyToZero(Value: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF !Value THEN
   RETURN 0;
  ELSE
   RETURN Value;
  END;
 END {convEmptyToZero};

 PRIVATE PROCEDURE PD100_MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "/");
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, "祭");
  L_Basis.wb_WrInQM(F, "ﭨ");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "㬬");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⁠");
  L_Basis.wb_WrInQM(F, "⁠");
  L_Basis.wb_WrInQM(F, "␠");
  L_Basis.wb_WrInQM(F, "灠");
  L_Basis.wb_WrInQM(F, "灠");
  L_Basis.wb_WrInQM(F, "琠");
  L_Basis.wb_WrInQM(F, ". ");
  L_Basis.wb_WrInQM(F, " ..");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " 㬥");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ࠊ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  IF L_General.IsPolakSpecific() THEN
   L_Basis.wb_WrInQM(F, "歠業");
   L_Basis.wb_WrInQM(F, "㬬 ᯥ歠業");
  END;
  L_Basis.wb_WrInQM(F, " ௫⭮ ");
  L_Basis.wb_WrInQM(F, "室 ");
  L_Basis.wb_TermLine(F);
 END {PD100_MakeHeader};

 VAR
  pd_Total,
  pd_NDS,
  pd_SaleTax : NUMERIC[2];

 PRIVATE PROCEDURE WrFirmAcnt(F: STRING[]; Empty: SCAL[2]);
 BEGIN
  IF Empty THEN
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  ELSE
   CONFORM(FirmAcnt, Bank);
   L_Basis.wb_WrScl(F, FirmAcnt.Bank);
   L_Basis.wb_WrStr(F, Bank.Name);
   L_Basis.wb_WrStr(F, FirmAcnt.AcntA);
  END;
 END {WrFirmAcnt};

 PRIVATE PROCEDURE PD100_MakePart(F         : STRING[];
                                  _MoneyKind: L_PDoc.tMoneyKind;
                                  _Date     : DATE;
                                  sType     : SCAL[4];
                                  byMDoc    : SCAL[2];
                                  _Total,
                                  _NDS,
                                  _SaleTax  : NUMERIC[2];
                                  Bribe     : NUMERIC[3];
                                  _XObject,
                                  _XObjectName,
                                  _TSN,
                                  _ManName: STRING[]);
 BEGIN
  L_Basis.wb_WrStr(F, L_Str.PoolItem("祥||", _MoneyKind));
  IF wMF THEN
   IF sType = s_Turnover THEN
    L_Basis.wb_WrScl(F, PDoc.MyFirm);
    CONFORM(PDoc, MyFirm);
   ELSE
    L_Basis.wb_WrScl(F, XObject.MyFirm);
    CONFORM(XObject, MyFirm);
   END;
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrDat(F, _Date);
  IF sType = s_Turnover THEN
   L_Basis.wb_WrStr(F, L_PDoc.PDocKindNick(PDoc.PDocKind, 1));
   L_Basis.wb_WrStr(F, L_Str.FixedIntStr(PDoc.PDoc, 7));
   L_Basis.wb_WrStr(F, PDoc.SrcNbr);
   L_General.Assert(~!PDoc.Dest, " 㪠  樨  " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   L_Basis.wb_WrScl(F, PDoc.Dest);
   L_Basis.wb_WrStr(F, Dest.Name);
   L_Basis.wb_WrStr(F, L_PDoc.PDocAbout(PDoc.PDocKind, PDoc.PDoc));
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_PDoc.st_Pool, PDoc.Status));
   IF ~!PDoc.Firm THEN
    L_Basis.wb_WrScl(F, PDoc.Firm);
    L_Basis.wb_WrScl(F, Firm.Name);
   ELSE
    L_Basis.wb_WrScl(F, "---");
    L_Basis.wb_WrScl(F, "---");
   END;
   L_Basis.wb_WrStr(F, L_Str.PoolItem("।|", ~L_PDoc.IsOutPDoc(PDoc.PDocKind)));
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrScl(F, "---");
   L_Basis.wb_WrScl(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrScl(F, "---");
   L_Basis.wb_WrScl(F, "---");
   L_Basis.wb_WrStr(F, L_Str.PoolItem("줮|줮", sType));
  END;
  L_Basis.wb_WrStr(F, _XObject);
  L_Basis.wb_WrStr(F, _XObjectName);
  L_Basis.wb_WrNum(F, _Total,   2);
  L_Basis.wb_WrNum(F, _NDS,     2);
  L_Basis.wb_WrNum(F, _SaleTax, 2);
  IF (sType = s_Turnover) & (L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Bank) THEN
   IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
    L_General.Assert(SEARCH(FirmAcnt, Firm, P_Firm.fomf(PDoc.MyFirm), PDoc.OwnAcnt),
                     " 㪠  ⥫騪  " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
    WrFirmAcnt(F, 0);
    WrFirmAcnt(F, ~SEARCH(FirmAcnt, Firm, PDoc.Firm, PDoc.FirmAcnt));
   ELSE
    WrFirmAcnt(F, ~SEARCH(FirmAcnt, Firm, PDoc.Firm, PDoc.FirmAcnt));
    L_General.Assert(SEARCH(FirmAcnt, Firm, P_Firm.fomf(PDoc.MyFirm), PDoc.OwnAcnt),
                     " 㪠  ⥫  " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
    WrFirmAcnt(F, 0);
   END;
  ELSE
   WrFirmAcnt(F, 1);
   WrFirmAcnt(F, 1);
  END;
  L_Basis.wb_WrStr(F, _TSN);
  L_Basis.wb_WrStr(F, _ManName);
  IF byMDoc | (sType # s_Turnover) | (PDoc.Status = L_PDoc.st_Prepared) THEN
   L_Basis.wb_WrStr(F, "-----");
  ELSE
   L_Basis.wb_WrStr(F, L_PDoc.GetCorAcnt(PDoc.PDocKind, PDoc.PDoc));
  END;
  IF byMDoc THEN
   L_Basis.wb_WrStr(F, L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   CONFORM(MDocList, Math, MathType);
   L_Basis.wb_WrScl(F, MathType.MathType);
   L_Basis.wb_WrStr(F, MathType.Name);
   L_Basis.wb_WrScl(F, Math.Math);
   L_Basis.wb_WrStr(F, Math.Name);
   L_Basis.wb_WrScl(F, CntrT.CntrT);
   L_Basis.wb_WrStr(F, CntrT.Name);
   L_Basis.wb_WrScl(F, Contract.Contract);
   L_Basis.wb_WrStr(F, Contract.Name);
   DEC(pd_Total,   _Total);
   DEC(pd_NDS,     _NDS);
   DEC(pd_SaleTax, _SaleTax);
  ELSE
   L_Basis.wb_WrStr(F, "-----");
   L_Basis.wb_WrStr(F, "-----");
   L_Basis.wb_WrStr(F, "-----");
   L_Basis.wb_WrStr(F, "-----");
   L_Basis.wb_WrStr(F, "-----");
   L_Basis.wb_WrStr(F, "-----");
   L_Basis.wb_WrStr(F, "-----");
   L_Basis.wb_WrStr(F, "-----");
   L_Basis.wb_WrStr(F, "-----");
  END;
  IF L_General.IsPolakSpecific() THEN
   L_Basis.wb_WrNum(F, Bribe,    3);
   L_Basis.wb_WrNum(F, _Total * (Bribe / (1 + Bribe)), 2);
  END;
  IF sType = s_Turnover THEN
   IF L_PDoc.IsSalPDoc() THEN
    L_Basis.wb_WrStr(F, L_Str.PoolItem(L_PDoc.typSalPDoc_pool, PDoc.Type));
   ELSE
    L_Basis.wb_WrStr(F, "");
   END;
   L_Basis.wb_WrStr(F, PDoc.SrcNbr);
  ELSE
   L_Basis.wb_WrStr(F, "");
   L_Basis.wb_WrStr(F, "");
  END;
  L_Basis.wb_TermLine(F);
 END {PD100_MakePart};

 PRIVATE PROCEDURE GetBegSaldo(_MoneyKind: L_PDoc.tMoneyKind; _XObject: LIKE(XObject.XObject); _Date: DATE): L_XObj.tSum;
  VAR
   Result: L_XObj.tSum;
   trgAcCut: LIKE(AcCut.AcCut);
 BEGIN
  IF    _MoneyKind = L_PDoc.mk_Cash THEN
   trgAcCut:=L_kn.GetSoft(_Date, L_AcCut.erkn_CentralCashOffice);
  ELSIF _MoneyKind = L_PDoc.mk_Bank THEN
   trgAcCut:=L_kn.GetSoft(_Date, L_AcCut.erkn_SettlementAccounts);
  ELSIF _MoneyKind = L_PDoc.mk_OprDskCash THEN
   trgAcCut:=L_kn.GetSoft(_Date, L_AcCut.erkn_OperationalCashOffices);
  ELSE
   L_General.CallUs(0);
  END;
  IF ~!trgAcCut THEN
   Result:=L_XObj.mo_GetOutSaldo(trgAcCut, L_DatTim.PrevPer(_Date));
  ELSE
   Result:=0;
  END;
  SAVE(PDoc);
  SAVE(XObject);
  SETSEL(PDoc, Date);
  SRCINSEL(PDoc, GE, , L_DatTim.Per(_Date));
  WHILE OCCURE(PDoc) & (PDoc.Date < _Date) DO
   PROMPT(L_DatTim.DateStr(_Date) + " : 祭 室饣 ᠫ줮 " +
          L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   IF PDoc.Status = L_PDoc.st_Passed THEN
    IF L_PDoc.MoneyKind(PDoc.PDocKind) = _MoneyKind THEN
     L_PDoc.AccessGlobalXObject();
     IF XObject.XObject = _XObject THEN
      IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
       DEC(Result, PDoc.Total);
      ELSE
       INC(Result, PDoc.Total);
      END;
     END;
    END;
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc)... *)
  RESTORE(XObject);
  RESTORE(PDoc);
  RETURN Result;
 END {GetBegSaldo};

 PRIVATE PROCEDURE Make_PD100(_Firm: LIKE(Firm.Firm); PDocListOnly: SCAL[2]; bpId: STRING[]);
  CONST
   EStr = "---";
  VAR
   _XObject,
   _XObjectName,
   _TSN,
   _ManName  : STRING[];
   md_Total,
   md_Rest,
   md_Current,
   _Saldo    : L_XObj.tSum;
   _MoneyKind: L_PDoc.tMoneyKind;
   BillData  : STRING[][300];
   Bribe     : NUMERIC[3];
   Dir       : NUMERIC[0];
 BEGIN
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  PD100_MakeHeader("R");
  L_AFM.MakeMultipleIndex("_PD10", "XObject  : LIKE(XObject.XObject);"+
                                   "Date     : DATE;" +
                                   "MoneyKind: SCAL[10];" +
                                   "Sum      : NUMERIC[2]",
                          "_PD10: XObject, Date");
  SETSEL(PDoc, Date);
  SRCINSEL(PDoc, GE, , Memo.ud_fr());
  WHILE OCCURE(PDoc) & (PDoc.Date <= Memo.ud_ut()) DO
   PROMPT(L_DatTim.DateStr(PDoc.Date)+" "+L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   IF (PDoc.Status # L_PDoc.st_Canceled) &
      (!_Firm | (PDoc.Firm = _Firm)) THEN
    _TSN:=EStr;
    _ManName:=EStr;
    _MoneyKind:=L_PDoc.MoneyKind(PDoc.PDocKind);
    IF _MoneyKind # L_PDoc.mk_Nothing THEN
     L_PDoc.AccessGlobalXObject();
     IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
      Dir:=-1;
     ELSE
      Dir:=1;
     END;
     ADD(_PD10, _PD10, ,XObject.XObject, PDoc.Date,
         _PD10.Sum, PDoc.Total * Dir);
     IF !_PD10.MoneyKind THEN
      _PD10.MoneyKind:=_MoneyKind;
      REPLACE(_PD10);
     END;
     _XObject    :=XObject.XObject;
     _XObjectName:=L_XObj.GetXObjectOriginName();
    ELSE
     _XObject    :=EStr;
     _XObjectName:=EStr;
    END;

    CONFORM(PDoc, Dest);
    CONFORM(PDoc, Firm);
    CONFORM(PDoc, PDocList);
    IF PDocListOnly THEN
     WHILE OCCURE(PDocList) DO
      PROMPT(L_DatTim.DateStr(PDoc.Date)+" "+L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc) + " " + PDocList.TSN);
      CONFORM(PDocList, Staff);
      CONFORM(Staff, Man);
      PD100_MakePart("R", _MoneyKind, PDoc.Date,
                          s_Turnover,
                          0,
                          PDocList.Sum,
                          0,
                          0,
                          0,
                          _XObject, _XObjectName,
                          Staff.TSN, Man.Name);
      NEXT(PDocList);
     END;
    ELSE
     IF OCCURE(PDocList) & ~NEXT(PDocList) THEN
      FIRST(PDocList);
      CONFORM(PDocList, Man);
      _TSN:=PDocList.TSN;
      _ManName:=Man.Name;
     ELSE
      _TSN:=EStr;
      _ManName:=L_Basis.ExclQM(L_PDoc.GetPDocCommentPart(0));
     END;
     IF L_PDoc.IsPDocwMDoc() THEN
      CONFORM(PDoc, PDocMDoc);
      WHILE OCCURE(PDocMDoc) DO
       CONFORM(PDocMDoc, MDoc);
       md_Total  :=0;
       pd_Total  :=PDocMDoc.Total;
       pd_NDS    :=convEmptyToZero(PDocMDoc.NDS);
       pd_SaleTax:=convEmptyToZero(PDocMDoc.SaleTax);
       CONFORM(MDoc, MDocList);
       WHILE OCCURE(MDocList) DO
        INC(md_Total, MDocList.Sum+MDocList.VAT);
        NEXT(MDocList);
       END; (* WHILE OCCURE(MDocList) ... *)
       CONFORM(MDoc, Contract);
       CONFORM(Contract, CntrT);
       CONFORM(Contract, Firm);
       IF md_Total # 0 THEN
        md_Rest:=md_Total;
        IF L_General.IsPolakSpecific() & (MDoc.MDocKind = L_MDoc.md_IsS) THEN
         P_MDoc.GetMDocProArray(MDoc.MDocKind, MDoc.MDoc, E_Prop.P_MkBill, BillData);
        ELSE
         SETEMPTY(BillData);
        END;
        CONFORM(MDoc, MDocList);
        WHILE OCCURE(MDocList) DO
         md_Current:=MDocList.Sum+MDocList.VAT;
         IF    SELECT(IsSData, MDoc, MDoc.MDocKind, MDoc.MDoc, MDocList.MDLNbr) THEN
          IF L_IsSData.AcceptableMathForCalculate(IsSData.ISDMType) THEN
           Bribe:=IsSData.Extra[L_IsSData.i_Extra_1];
          ELSE
           Bribe:=0;
          END;
         ELSIF ~!BillData[MDocList.MDLNbr-1] THEN
          Bribe:=convEmptyToZero(STRTOFLD(L_Str.AnyItem(L_Prop.getArrayItem(BillData[MDocList.MDLNbr-1], 0), ",", 5), NUMERIC));
         ELSE
          Bribe:=0;
         END;
         Bribe:=Bribe / 100;
         IF md_Current = md_Rest THEN
          PD100_MakePart("R", _MoneyKind, PDoc.Date,
                              s_Turnover,
                              1,
                              pd_Total,
                              pd_NDS,
                              pd_SaleTax,
                              Bribe,
                              _XObject, _XObjectName,
                              _TSN, _ManName);
         ELSE
          PD100_MakePart("R", _MoneyKind, PDoc.Date,
                              s_Turnover,
                              1,
                              PDocMDoc.Total                    * (md_Current/md_Total),
                              convEmptyToZero(PDocMDoc.NDS)     * (md_Current/md_Total),
                              convEmptyToZero(PDocMDoc.SaleTax) * (md_Current/md_Total),
                              Bribe,
                              _XObject, _XObjectName,
                              _TSN, _ManName);
         END;
         DEC(md_Rest, md_Current);
         NEXT(MDocList);
        END; (* WHILE OCCURE(MDocList) ... *)
       ELSE
        PD100_MakePart("R", _MoneyKind, PDoc.Date,
                            s_Turnover,
                            0,
                            pd_Total,
                            pd_NDS,
                            pd_SaleTax,
                            0,
                            _XObject, _XObjectName,
                            _TSN, _ManName);
       END; (* IF md_Total # 0 ... *)
       NEXT(PDocMDoc);
      END; (* WHILE OCCURE(PDocMDoc) ... *)
     ELSE
      PD100_MakePart("R", _MoneyKind, PDoc.Date,
                          s_Turnover,
                          0,
                          PDoc.Total,
                          convEmptyToZero(PDoc.NDS),
                          convEmptyToZero(PDoc.SaleTax),
                          0,
                          _XObject, _XObjectName,
                          _TSN, _ManName);
     END;
    END; (* IF PDocListOnly *)
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc) ... *)
  IF ~PDocListOnly THEN
   SELECT(_PD10, _PD10);
   WHILE OCCURE(_PD10) DO
    SEARCH(XObject, XObject, , _PD10.XObject);
    _Saldo:=GetBegSaldo(_PD10.MoneyKind, _PD10.XObject, Memo.ud_fr());
    _XObjectName:=L_XObj.GetXObjectOriginName();
    NARROWSEL(_PD10, XObject);
    WHILE OCCURE(_PD10) DO
     PD100_MakePart("R", _PD10.MoneyKind, _PD10.Date,
                         s_In,
                         0,
                         _Saldo,
                         0,
                         0,
                         0,
                         XObject.XObject, _XObjectName,
                         EStr, EStr);
     _Saldo:=_Saldo + _PD10.Sum;
     PD100_MakePart("R", _PD10.MoneyKind, _PD10.Date,
                         s_Out,
                         0,
                         _Saldo,
                         0,
                         0,
                         0,
                         XObject.XObject, _XObjectName,
                         EStr, EStr);
     NEXT(_PD10);
    END; (* WHILE OCCURE(_PD10) ... *)
    NEXTINEXTENDEDSEL(_PD10, XObject);
   END; (* WHILE OCCURE(_PD10) ... *)
  END;
  L_AFM.AF_PurgeTemp("_PD10");
  FIO.Close(R);
  IF ~!_Firm THEN
   L_Basis.ExtPlayMakedRunTimeRep(bpId,
                                  _Firm,
                                  L_General.timeCond_InIntvl,
                                  "⥦ 㬥 ࠣ",
                                  0);
  END;
 END {Make_PD100};

 PRIVATE PROCEDURE PD101_MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "");
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, "祭");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, "࣠");
  L_Basis.wb_WrInQM(F, " ꥪ");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "ꥪ");

  L_Basis.wb_WrInQM(F, "吠१");
  L_Basis.wb_WrInQM(F, "吠१");
  L_Basis.wb_WrInQM(F, "吠१");

  L_Basis.wb_WrInQM(F, "");

  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "१");
  L_Basis.wb_WrInQM(F, "१");

  L_Basis.wb_WrInQM(F, "");

  L_Basis.wb_WrInQM(F, "ᯮ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㬬");
  L_Basis.wb_TermLine(F);
 END {PD101_MakeTop};

 PRIVATE PROCEDURE PD101_MakeLine(F: STRING[]);
 BEGIN
  CONFORM(PDoc, Dest);
  CONFORM(PDoc, Firm);
  L_Basis.wb_WrStr(F, L_PDoc.PDocKindNick(PDoc.PDocKind, 1));
  L_Basis.wb_WrStr(F, FLDTOSTR(PDoc.PDoc, "0000\00000"));
  IF wMF THEN
   CONFORM(PDoc, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrDat(F, PDoc.Date);
  L_Basis.wb_WrScl(F, PDoc.Dest);
  L_Basis.wb_WrStr(F, Dest.Name);
  L_Basis.wb_WrStr(F, L_PDoc.PDocAbout(PDoc.PDocKind, PDoc.PDoc));
  L_Basis.wb_WrScl(F, PDoc.Firm);
  L_Basis.wb_WrScl(F, Firm.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_XObj.o_Pool, XObject.Origin));
  L_Basis.wb_WrScl(F, XObject.XObject);
  L_Basis.wb_WrStr(F, L_XObj.GetXObjectOriginName());
  L_Basis.wb_WrScl(F, AcCut.AcCut);
  L_Basis.wb_WrStr(F, AcCut.Sign);
  L_Basis.wb_WrStr(F, AcCut.Name);
  L_Basis.wb_WrStr(F, L_Acnt.GetCAcntSign(Memo.UpTo(), AcCut.AcCut));
  L_Basis.wb_WrScl(F, AcCut2.AcCut2);
  L_Basis.wb_WrStr(F, AcCut2.Sign);
  L_Basis.wb_WrStr(F, AcCut2.Name);
  L_Basis.wb_WrStr(F, L_Acnt.GetCAcntSign(Memo.UpTo(), AcCut2.AcCut2));
  L_Basis.wb_WrScl(F, Apport.Apport);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("।|", Apport.CirType));
  L_Basis.wb_WrNum(F, XDE01.Sum, 2);
  L_Basis.wb_TermLine(F);
 END {PD101_MakeLine};

 PRIVATE PROCEDURE Make_PD101(bpId: STRING[]);
 BEGIN
  L_XDR.InitEntryList();
  SETSEL(PDoc, Date);
  SRCINSEL(PDoc, GE, , Memo.From());
  WHILE OCCURE(PDoc) & (PDoc.Date <= Memo.UpTo()) DO
   PROMPT(L_DatTim.DateStr(PDoc.Date)+" "+L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   L_General.Assert(~!PDoc.Dest, " 㪠  樨  " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   L_XDR.PrepareEntryList(L_XDoc.xdt_PDoc, EMPTYOF(DATE), 1);
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc) ... *)

  FIO.Open(F, L_General.NameConnection(bpId), "rep", Create);
  PD101_MakeTop("F");
  SELECT(XDE01, XDE01);
  WHILE OCCURE(XDE01) DO
   L_XDoc.PositionOnXDoc(XDE01.XDocId);
   NARROWSEL(XDE01, XDocId, Prt, XObject);
   IF XDE01.Prt = L_XDR.xdr_XObject THEN
    L_XObj.AccessXObject(XDE01.XObject);
    WHILE OCCURE(XDE01) DO
     CONFORM(XDE01, AcCut);
     CONFORM(XDE01, Apport);
     CONFORM(XDE01, AcCut2);
     PD101_MakeLine("F");
     NEXT(XDE01);
    END;
   END;
   NEXTINEXTENDEDSEL(XDE01, XDocId, Prt, XObject);
  END; (* WHILE OCCURE(XDE01) ... *)

  L_XDR.DeInitEntryList();
  FIO.Close(F);
 END {Make_PD101};

(*
$P{ pdf_Top:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
?, C, ""
Firm.Firm, L, ""
Firm.Name, L, ""
@
###################################################################### ########## #####
=#####=================================================================================
|                   㬥  ਮ  ##########  ##########                    |
|#####################################################################################|
|ࠣ #### #####################################################################|
}
*)

(*
$P{ pdf_SubTop:
PDocKind.PDocKind, L, ""
PDocKind.Sign, L, ""
PDocKind.Name, L, ""
@
|-------------------------------------------------------------------------------------|
|## ### ##############################################################################|
|-------------------------------------------------------------------------------------|
|      |㬥 |      |祭                           ||         㬬|
|----------|---------|--------|-------------------------------------|--|--------------|
}
*)

 PRIVATE PROCEDURE _SumStr(Sum: NUMERIC[2]): STRING[];
 BEGIN
  IF Sum = 0 THEN
   RETURN "";
  ELSE
   RETURN FLDTOSTR(Sum, ",2-");
  END;
 END {_SumStr};

 PRIVATE PROCEDURE StatusDone(_Status: LIKE(PDoc.Status); _Done: LIKE(PDoc.Done)): STRING[];
 BEGIN
  RETURN Str.Item("||", "|", _Status) + Str.Item(" |", "|", _Done);
 END {StatusDone};

(*
$P{ pdf_Line:
PDoc.Date, L, "D.N.y"
PDoc.PDoc, L, ""
PDoc.SrcNbr, L, ""
L_PDoc.PDocAbout(PDoc.PDocKind, PDoc.PDoc), L, ""
StatusDone(PDoc.Status, PDoc.Done), L, ""
_SumStr(PDoc.Total), R, ""
@
|##########|#########|########|#####################################|##|##############|
}
*)

(*
$P{ pdf_SubBot:
PDocKind.Sign, L, ""
?, R, ",2-"
@
|----------------------------------------------------------------------|--------------|
|⮣  ###                                                          |##############|
}
*)

(*
$P{ pdf_Bot:
@
=(c) Polak=============================================================================
}
*)

 PRIVATE PROCEDURE PrintedDocConditionStr(DocStatus: SCAL[2][3]): STRING[];
  VAR
   S: STRING[];
 BEGIN
  S:="";
  IF DocStatus[L_PDoc.st_Prepared] THEN
   S:=S + "⮢";
  END;
  IF DocStatus[L_PDoc.st_Passed] THEN
   IF ~!S THEN
    S:=S + ", ";
   END;
   S:=S + "஢";
  END;
  IF DocStatus[L_PDoc.st_Canceled] THEN
   IF ~!S THEN
    S:=S + ", ";
   END;
   S:=S + "㫨஢";
  END;
  RETURN "(" + S + ")";
 END {PrintedDocConditionStr};

 PRIVATE PROCEDURE Make_PDFRM(DocStatus: SCAL[2][3]);
  CONST
   RepName = "PDFRM";
  VAR
   Total     : NUMERIC[2];
   MyFirmName: STRING[];
 BEGIN
  L_AFM.MakeIndex("tmp", "MyFirm  : "+GET_TYPE_SPEC(P_Firm.tMyFirm).Name +";"+
                         "PDocKind: LIKE(PDoc.PDocKind);"+
                         "PDoc    : LIKE(PDoc.PDoc)");
  SELECT(PDoc, Firm, , Firm.Firm);
  WHILE OCCURE(PDoc) DO
   PROMPT(PDoc.PDocKind + " " + PDoc.PDoc);
   IF L_DatTim.IsActive_Inc(PDoc.Date, Memo.ud_fr(), Memo.ud_ut()) & DocStatus[PDoc.Status] THEN
    IF wMF THEN
     ADD(tmp, tmp, , PDoc.MyFirm,   PDoc.PDocKind, PDoc.PDoc);
    ELSE
     ADD(tmp, tmp, , P_Firm.mf_Own, PDoc.PDocKind, PDoc.PDoc);
    END;
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   NARROWSEL(tmp, MyFirm);
   SAVE(Firm);
   MyFirmName:=P_Firm.MyFirmName(tmp.MyFirm, SYSDATE());
   RESTORE(Firm);
   MAKEPART(R, pdf_Top, MyFirmName, RepName, PrintedDocConditionStr(DocStatus));
   WHILE OCCURE(tmp) DO
    Total:=0;
    NARROWSEL(tmp, PDocKind);
    SEARCH(PDocKind, PDocKind, , tmp.PDocKind);
    MAKEPART(R, pdf_SubTop);
    WHILE OCCURE(tmp) DO
     SEARCH(PDoc, PDoc, , tmp.PDocKind, tmp.PDoc);
     MAKEPART(R, pdf_Line);
     INC(Total, PDoc.Total);
     NEXT(tmp);
    END; (* WHILE OCCURE(tmp) ... *)
    MAKEPART(R, pdf_SubBot, Total);
    NEXTINEXTENDEDSEL(tmp, PDocKind);
   END; (* WHILE OCCURE(tmp) ... *)
   MAKEPART(R, pdf_Bot);
   NEXTINEXTENDEDSEL(tmp, MyFirm);
  END; (* WHILE OCCURE(tmp) ... *)
  L_AFM.AF_PurgeTemp("tmp");
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {Make_PDFRM};

 PUBLIC PROCEDURE PDFRM_ByCurFirm();
  VAR
   DoExcel  : SCAL[2];
   DocStatus: SCAL[2][3];
   RepName  : STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_General.Assert(ACCESS(Firm), " ⠭ ࠣ");
  DocStatus[L_PDoc.st_Prepared]:=1;
  DocStatus[L_PDoc.st_Passed]  :=1;
  DocStatus[L_PDoc.st_Canceled]:=0;
  DoExcel:=0;
  STDFORM(L_StdFrm.sf_Choice("|ଠ %#####%                   " +
                             "|" +
                             "|%###############################%" +
                             "|%###############################%" +
                             "|%###############################%",
                             "%L<|Excel>I" +
                             "%<⮢>E" +
                             "%<஢>E" +
                             "%<㫨஢>E"),
          " ⥦ 㬥  ਮ ", , 1,
          DoExcel, DocStatus[L_PDoc.st_Prepared], DocStatus[L_PDoc.st_Passed], DocStatus[L_PDoc.st_Canceled]);
  IF DoExcel THEN
   RepName:="PD100";
   IF DocStatus[L_PDoc.st_Prepared] | DocStatus[L_PDoc.st_Canceled] THEN
    L_StdFrm.Inform("Excel- 뢠 ⮫쪮 ஢ 㬥");
   END;
   Make_PD100(Firm.Firm, 0, RepName);
  ELSE
   Make_PDFRM(DocStatus);
  END;
 END {PDFRM_ByCurFirm};

 PUBLIC PROCEDURE PD100();
  CONST
   bpId="PD100";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_bp.Begin(bpId, "⥦ 㬥", L_bp.t_Basis, L_General.tc_inIntvl);
  Make_PD100(EMPTYOF(Firm.Firm), 0, bpId);
  L_bp.End();
 END {PD100};

 PUBLIC PROCEDURE PD101();
  CONST
   bpId="PD101";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_bp.Begin(bpId, "⮪ ࠡ⪨ ⥦ 㬥⮢", L_bp.t_Basis, L_General.tc_inIntvl);
  Make_PD101(bpId);
  L_bp.End();
 END {PD101};

 PUBLIC PROCEDURE PD104_ByCurFirm();
  CONST
   RepName = "PD100";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_General.Assert(ACCESS(Firm), " ⠭ ࠣ");
  Make_PD100(Firm.Firm, 0, RepName);
 END {PD104_ByCurFirm};

 PUBLIC PROCEDURE PD103_PDocListOnly();
  CONST
   RepName="PD103";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  Make_PD100(EMPTYOF(Firm.Firm), 1, RepName);
  L_Basis.ExtPlayMakedRunTimeRep(RepName,
                                 "⭨",
                                 L_General.timeCond_InIntvl,
                                 "⥦ 㬥  ࠧ१ ࠡ⭨",
                                 0);
 END {PD103_PDocListOnly};

END.