(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose     ஫ 䨪樨 
%Type        control
%Specific    SYS
%Modified    24.09.2014 16:14:52 LDA
%Environment
*)

 MODULE PDoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, L_StdFrm, L_Acnt, L_Pmnt, L_Man, L_XObj,
        L_PDoc, L_MDoc, L_XDoc, L_Money, L_PRoll, L_Card, L_Str, L_XDR, L_ExtAb,
        L_AcCut, L_APtm, L_Staff, L_EC, L_Dest, L_AFM, L_CB, L_JDoc, L_AR,
        L_AcsPnt, L_SES, L_bp, L_ACL, P_Cntr, P_PDoc, P_Firm, P_OwnData, L_WDO,
        Str, Math, FIO, Memo, E_PDoc, L_kn, L_MSO;

 PUBLIC VAR
  _Dir: NUMERIC[0];

 PRIVATE VAR
  _CirSource: L_Acnt.tCirSource;

 PRIVATE PERMANENT VAR
  v_FirmToAskAcnt: LIKE(Firm.Firm);

 PRIVATE PROCEDURE E_CheckScope(): SCAL[2];
 BEGIN
  IF PDoc.Date >= 01\12\2008 THEN
   RETURN 1;
  ELSE
   IF L_PDoc.IsPDocwMDoc() THEN
    CONFORM(PDoc, PDocMDoc);
    CONFORM(PDocMDoc, MDoc);
   END;
   L_PDoc.AccessFirstAcMthL();
   WHILE OCCURE(AcMthL) DO
    IF AcMthL.CirSrc = L_Acnt.cs_PDocList THEN
     RETURN 1;
    END;
    NEXT(AcMthL);
   END;
  END;
  RETURN 0;
 END {E_CheckScope};

(*--- Procedures for successful change -------------------------------------*)

 PRIVATE PROCEDURE PDoc_PDoc_OnSuccessfulChange();
 BEGIN
  L_General.CallUs(0);
  L_General.Assert(~!PDoc.PDoc, " ⠢ ");
  L_XDoc.ChangeXDoc(L_XDoc.xdt_PDoc, PDoc.PDocKind, GE_PVALUE(), PDoc.PDoc);
 END {PDoc_PDoc_OnSuccessfulChange};

 PRIVATE PROCEDURE PDoc_mfNbr_OnSuccessfulChange();
 BEGIN
  L_PDoc.SetDefaultPDocSrcNbr();
 END {PDoc_mfNbr_OnSuccessfulChange};

 PRIVATE PROCEDURE PDoc_Firm_OnSuccessfulChange();
 BEGIN
  L_General.CallUs((PDoc.PDocKind = L_PDoc.pd_IPP) |
                   (PDoc.PDocKind = L_PDoc.pd_VPP) |
                   (PDoc.PDocKind = L_PDoc.pd_IMO) |
                   (PDoc.PDocKind = L_PDoc.pd_VMO) |
                   (PDoc.PDocKind = L_PDoc.pd_ITP) |
                   (PDoc.PDocKind = L_PDoc.pd_VTP) |
                   (PDoc.PDocKind = L_PDoc.pd_VPK) |
                   (PDoc.PDocKind = L_PDoc.pd_IPK) |
                   (PDoc.PDocKind = L_PDoc.pd_VPG) |
                   (PDoc.PDocKind = L_PDoc.pd_IPG));
  IF (PDoc.PDocKind # L_PDoc.pd_VPK) & (PDoc.PDocKind # L_PDoc.pd_IPK) THEN
   IF P_Firm.SoftAccessSilentFirmAcnt(PDoc.Firm, PDoc.Date) THEN
    PDoc.FirmAcnt:=FirmAcnt.FirmAcnt;
   ELSE
    SETEMPTY(PDoc.FirmAcnt);
   END;
   REPLACE(PDoc);
  END;
 END {PDoc_Firm_OnSuccessfulChange};

 PRIVATE PROCEDURE curFirmAcntIsAllowed();
  VAR
   AcntTypeName: STRING[];
 BEGIN
  L_General.Assert(FirmAcnt.FirmAcnt # P_Firm.fa_CashOffice, "뫪  業ࠫ  ⨬");
  IF L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Bank THEN
   AcntTypeName:="";
   L_General.Assert(FirmAcnt.Type # P_Firm.fat_OprCashDsk, "뫪  樮  ⨬");
  ELSE
   AcntTypeName:="";
   L_General.Assert(FirmAcnt.Type = P_Firm.fat_OprCashDsk, "뫪  ᪨  ⨬");
  END;
  L_General.Assert(L_DatTim.IsActive(PDoc.Date, FirmAcnt.Begin, FirmAcnt.Till),
                   AcntTypeName + " " + FirmAcnt.FirmAcnt + "    " + L_DatTim.DateStr(PDoc.Date));
 END {curFirmAcntIsAllowed};

 PRIVATE PROCEDURE PDoc_OwnAcnt_OnSuccessfulChange();
 BEGIN
  L_General.Assert(SEARCH(FirmAcnt, Firm, L_PDoc.GetPDocOwnFirm(), PDoc.OwnAcnt),
                   " 襩 ࣠樨    ஬ " + PDoc.OwnAcnt);
  curFirmAcntIsAllowed();
 END {PDoc_OwnAcnt_OnSuccessfulChange};

 PRIVATE PROCEDURE PDoc_FirmAcnt_OnSuccessfulChange();
 BEGIN
  CONFORM(PDoc, FirmAcnt);
  curFirmAcntIsAllowed();
 END {PDoc_FirmAcnt_OnSuccessfulChange};

 PRIVATE PROCEDURE PDoc_Status_OnSuccessfulChange();
 BEGIN
  IF PDoc.Status = L_PDoc.st_Passed THEN
   L_General.Assert(~L_PDoc.IsUnClosedSalPDoc(PDoc.mfNbr), "㬥  ६ ஬");
  END;
  IF    GE_PVALUE() = L_PDoc.st_Canceled THEN
   L_StdFrm.Choice("  ⬥ 㫨஢ 㬥?");
  ELSIF PDoc.Status = L_PDoc.st_Canceled THEN
   L_StdFrm.Choice("  㫨஢ 㬥?");
   IF ~!L_XDoc.GetAllDependentXDC(L_XDoc.curXDocId(L_XDoc.xdt_PDoc)) THEN
    L_StdFrm.Choice(" 易 㬥");
   END;
  END;
 END {PDoc_Status_OnSuccessfulChange};

 PUBLIC PROCEDURE CheckRefToPDoc();
 BEGIN
  SELECT(XDocRef, bXDocId, , PDoc.XDocId);
  WHILE OCCURE(XDocRef) DO
   IF XDocRef.RefType # L_XDoc.rft_wRelTo THEN
    L_General.Error("騩  ନ஢  ᭮ 㣨 㬥⮢");
   END;
   NEXT(XDocRef);
  END; (* WHILE OCCURE(XDocRef) *)
 END {CheckRefToPDoc};

 PRIVATE PROCEDURE PDoc_Dest_OnSuccessfulChange();
 BEGIN
  IF ~!GE_PVALUE(PDoc.Dest) THEN
   CheckRefToPDoc();
  END;
  SetPDocWindowFields();
 END {PDoc_Dest_OnSuccessfulChange};

 PRIVATE PROCEDURE PDoc_CalculateNDS(): SCAL[2];
 BEGIN
  RETURN (PDoc.PDocKind # L_PDoc.pd_RKO) &
         (PDoc.PDocKind # L_PDoc.pd_OVN) &
         (PDoc.PDocKind # L_PDoc.pd_CND) &
         (PDoc.PDocKind # L_PDoc.pd_PKO) &
         (PDoc.PDocKind # L_PDoc.pd_VhP) &
         (PDoc.PDocKind # L_PDoc.pd_IsP) ;
 END {PDoc_CalculateNDS};

 PRIVATE PROCEDURE _CheckAcAccuracyOfPDocSums(s: NUMERIC[2]; Msg: STRING[]);
 BEGIN
  IF ~!s THEN
   L_General.Assert(~!PDoc.Date, "  ");
   L_Money.CheckAcAccuracy(L_DatTim.Per(PDoc.Date), s, Msg);
  END;
 END {_CheckAcAccuracyOfPDocSums};

 PRIVATE PROCEDURE CheckAcAccuracyOfPDocSums(s: NUMERIC[2]);
 BEGIN
  _CheckAcAccuracyOfPDocSums(s, "");
 END {CheckAcAccuracyOfPDocSums};

 PRIVATE PROCEDURE PDoc_ANYTotal_OnSuccessfulChange(_Sum: NUMERIC[2]);
 BEGIN
  L_General.Assert(L_PDoc.PDocTotalFillMethod() # L_PDoc.pdtfm_byPDocList,
                   "  㬥  㬬   ᭮ ᯨ᪠ ࠡ⭨");
  L_General.Assert(L_PDoc.PDocTotalFillMethod() # L_PDoc.pdtfm_byPDocMDoc,
                   "  㬥  㬬   ᭮ 뫮  ");
  CheckAcAccuracyOfPDocSums(_Sum);
 END {PDoc_ANYTotal_OnSuccessfulChange};

 PRIVATE PROCEDURE PDoc_Total_OnSuccessfulChange();
 BEGIN
  PDoc_ANYTotal_OnSuccessfulChange(PDoc.Total);
  SetAddTaxes(~!PDoc.Total & PDoc_CalculateNDS(), 0);
 END {PDoc_Total_OnSuccessfulChange};

 PRIVATE PROCEDURE PDoc_NDS_OnSuccessfulChange();
 BEGIN
  PDoc_ANYTotal_OnSuccessfulChange(PDoc.NDS);
 END {PDoc_NDS_OnSuccessfulChange};

 PRIVATE PROCEDURE PDoc_SaleTax_OnSuccessfulChange();
 BEGIN
  PDoc_ANYTotal_OnSuccessfulChange(PDoc.SaleTax);
 END {PDoc_SaleTax_OnSuccessfulChange};

 PRIVATE PROCEDURE PDoc_Type_OnSuccessfulChange();
 BEGIN
  IF (PDoc.Status = L_PDoc.st_Canceled) THEN
   L_StdFrm.Choice("  ⨯ 㫨஢ 㬥");
  ELSE
   L_General.Assert(PDoc.Type # L_PDoc.typ_Mass,
                    "㬥  ᮢ 뤠 ᮧ ⮫쪮 ⮬᪨");
  END;
 END {PDoc_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE intSet_VATFieldFlagEdit(VATNotBan: SCAL[2]);
 BEGIN
  RTI.Get().CurZone.Fields("PDocMDoc.NDS").Modifiable:=VATNotBan;
 END {intSet_VATFieldFlagEdit};

 PRIVATE PROCEDURE Set_VATFieldFlagEdit();
 BEGIN
  L_General.Assert(SEARCH(MDoc, MDoc, PDocMDoc.MDocKind, PDocMDoc.MDoc),
                   "  ⮢ 㬥 " + L_MDoc.MDocStr(PDocMDoc.MDocKind, PDocMDoc.MDoc));
  intSet_VATFieldFlagEdit(L_MDoc.CalculateVAT() # L_MDoc.cvat_Impossible);
 END {Set_VATFieldFlagEdit};

 PRIVATE PROCEDURE PDocMDoc_MDocKind_OnSuccessfulChange();
 BEGIN
  SETEMPTY(PDocMDoc.Total, PDocMDoc.NDS);
  REPLACE(PDocMDoc);
  intSet_VATFieldFlagEdit(1);
 END {PDocMDoc_MDocKind_OnSuccessfulChange};

 PRIVATE PROCEDURE PDocMDoc_MDoc_OnSuccessfulChange();
  VAR
   prvMDocAcpt,
   newMDocAcpt: L_Pmnt.tValuesToBalance;
 BEGIN
  L_General.Assert(~!PDocMDoc.MDocKind,
                   " 㪠  易 ⮢୮ 㬥");
  IF ~!GE_PVALUE() THEN
   SEARCH(MDoc, MDoc, , PDocMDoc.MDocKind, GE_PVALUE());
   prvMDocAcpt:=L_Pmnt.GetMDocAcpt();
  ELSE
   SETEMPTY(prvMDocAcpt);
  END;
  intSet_VATFieldFlagEdit(1);
  CONFORM(PDocMDoc, MDoc);
  L_General.Assert(L_Pmnt.E_IsMayBePaidMDoc(),
                   "㬥 ⮣     ᭮  ");
  L_General.Assert(PDoc.MyFirm = MDoc.MyFirm,
                   "  㣮 ' ࣠樨'");
  PDocMDoc.Contract:=MDoc.Contract;
  PDocMDoc.Dest    :=MDoc.Dest;
  PDocMDoc.PDocDate:=PDoc.Date;
  SETEMPTY(PDocMDoc.NDS);
  REPLACE(PDocMDoc);

  IF (!PDocMDoc.Total | (PDocMDoc.Total = prvMDocAcpt[L_Pmnt.vtb_Total])) &
     (!PDocMDoc.NDS   | (PDocMDoc.NDS   = prvMDocAcpt[L_Pmnt.vtb_VAT]  )) THEN
   newMDocAcpt:=L_Pmnt.GetMDocAcpt();
   PDocMDoc.Total:=newMDocAcpt[L_Pmnt.vtb_Total];
   PDocMDoc.NDS  :=newMDocAcpt[L_Pmnt.vtb_VAT];
   REPLACE(PDocMDoc);
  ELSE
   L_StdFrm.Inform("'㬬'  '' ⠢  ");
  END;
  Set_VATFieldFlagEdit();
 END {PDocMDoc_MDoc_OnSuccessfulChange};

 PRIVATE PROCEDURE PDocMDoc_Total_OnSuccessfulChange();
  VAR
   Dummy: L_Pmnt.tValuesToBalance;
 BEGIN
  CheckAcAccuracyOfPDocSums(PDocMDoc.Total);
  L_General.Assert(~!PDocMDoc.MDocKind & ~!PDocMDoc.MDoc, "  뫪  ");
  CONFORM(PDocMDoc, MDoc);
  Dummy:=L_Pmnt.GetMDocAcpt();
  IF Dummy[L_Pmnt.vtb_Total] # 0 THEN
   PDocMDoc.NDS    :=PDocMDoc.Total/Dummy[L_Pmnt.vtb_Total]*Dummy[L_Pmnt.vtb_VAT];
   PDocMDoc.SaleTax:=PDocMDoc.Total/Dummy[L_Pmnt.vtb_Total]*Dummy[L_Pmnt.vtb_SaleTax];
  ELSE
   SetAddTaxes(L_MDoc.CalculateVAT() # L_MDoc.cvat_Impossible, Dummy[L_Pmnt.vtb_SaleTax] # 0);
  END;
  REPLACE(PDocMDoc);
 END {PDocMDoc_Total_OnSuccessfulChange};

 PRIVATE PROCEDURE PDocMDoc_NDS_OnSuccessfulChange();
 BEGIN
  CheckAcAccuracyOfPDocSums(PDocMDoc.NDS);
 END {PDocMDoc_NDS_OnSuccessfulChange};

 PRIVATE PROCEDURE PDocMDoc_SaleTax_OnSuccessfulChange();
 BEGIN
  CheckAcAccuracyOfPDocSums(PDocMDoc.SaleTax);
 END {PDocMDoc_SaleTax_OnSuccessfulChange};

 PRIVATE PROCEDURE PDoc_Date_OnSuccessfulChange(); 
 BEGIN
  L_General.Assert(~!PDoc.Date, " ⨬ ⠢ ");
  IF L_DatTim.Per(PDoc.Date) # L_DatTim.Per(GE_PVALUE()) THEN
   L_General.Assert(~PDoc.Done, "  ਮ 㬥    ࠡ⠭");
  END;
  L_General.Assert(~!PDoc.Dest, "   樨");
  IF L_PDoc.IsSalPDoc() & (PDoc.Type = L_PDoc.typ_Other) & L_PDoc.IsOutPDoc(PDoc.PDocKind) &
     (L_DatTim.Per(PDoc.Date) > L_DatTim.Per(GE_PVALUE())) THEN
   L_StdFrm.Question(" ⨯ 㬥 - 稩| |" +
                     ", ᫥ 㪠 ࠧ ⨯ |  믫  ᮢ 뤠");
  END;

  IF L_PDoc.SetNew_mfNbr_Required() THEN
   SETEMPTY(PDoc.mfNbr);
   REPLACE(PDoc);
   L_PDoc.CheckNCorrect_PDocNbrs();
  ELSE
   L_PDoc.SetDefaultPDocSrcNbr();
  END;
 END {PDoc_Date_OnSuccessfulChange};

(*-----------------------------------------------------------------------*)

 PRIVATE PROCEDURE GetRightStaffLog(_MCode: LIKE(MCList.MCode)): DATE;
  VAR
   Result: DATE;
 BEGIN
  TRY
   TABLE.Get("Money").AccessDataMode:=adm_SOFT;
   SELECT(Money, TSN, , PDocList.TSN, L_DatTim.Per(PDoc.Date), L_DatTim.Per(PDoc.Date));
   LOOP
    IF ~OCCURE(Money) THEN
     Result:=StaffLog.Date;
     EXIT;
    END;
    NARROWSEL(Money, ODate, Period);
    IF SRCINSEL(Money, EQ, _MCode, L_PRoll.src_PDoc) THEN
     Result:=Money.ODate;
     EXIT;
    END;
    NEXTINEXTENDEDSEL(Money, ODate, Period);
   END; (* LOOP *)
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Raise DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
  RETURN Result;
 END {GetRightStaffLog};

 PRIVATE PROCEDURE intSaveMoney(Sign      : NUMERIC[0];
                                trgMCode  : LIKE(MCList.MCode);
                                trgSum    : LIKE(Money.Sum);
                                trgXObject: LIKE(MoneyDst.XObject);
                                trgAcCut  : LIKE(MoneyDst.AcCut));
  VAR
   trgODate  : DATE;
   trgXDocId : LIKE(MoneyDst.XDocId);
 BEGIN
  trgODate:=GetRightStaffLog(trgMCode);
  IF L_DatTim.Per(PDoc.Date) >= 01\09\2012 THEN
   trgXDocId :=L_XDoc.curXDocId(L_XDoc.xdt_PDoc);
   L_General.CallUs(~!trgXObject & ~!trgAcCut);
  ELSE
   SETEMPTY(trgXDocId, trgXObject, trgAcCut);
  END;
  L_PRoll.detailedSaveMoney_AP(Sign, 1, L_DatTim.Per(PDoc.Date), trgMCode, L_DatTim.Per(PDoc.Date), trgODate, L_PRoll.src_PDoc,
                               trgXDocId, trgXObject, trgAcCut,
                               trgSum, 0);
 END {intSaveMoney};

 PRIVATE PROCEDURE Get_MCode(): LIKE(Money.MCode);
 BEGIN
  IF    L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Cash THEN
   IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN RETURN L_kn.Get(PDoc.Date, L_PRoll.erkn_MCList_PaidByCash);
   ELSE                                    RETURN L_kn.Get(PDoc.Date, L_PRoll.erkn_MCList_ReturnedByCash);
   END;
  ELSIF L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Bank THEN
   IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN RETURN L_kn.Get(PDoc.Date, L_PRoll.erkn_MCList_PaidByBank);
   ELSE                                    RETURN L_kn.Get(PDoc.Date, L_PRoll.erkn_MCList_ReturnedByBank);
   END;
  ELSE
   L_General.Error(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+"|  "+L_PDoc.PDocKindNick(PDoc.PDocKind, 1)+"    ௫");
  END;
 END {Get_MCode};

 PRIVATE PROCEDURE CorrectPCalc(Sign      : NUMERIC[0];
                                trgMCode  : LIKE(Money.MCode);
                                trgSum    : NUMERIC[2];
                                trgXObject: LIKE(MoneyDst.XObject);
                                trgAcCut  : LIKE(MoneyDst.AcCut));
  VAR
   _Method: SCAL[16];
 BEGIN
  IF L_PDoc.E_NeedCorrectPCalc(PDoc.Date) THEN
   L_General.SetConcurrentMode();
   CONFORM(PDocList, Staff);
   IF Staff.MyFirm # PDoc.MyFirm THEN
    L_General.Error(" ⮬   ࠡ⭨   易  묨" + L_StdFrm.HR() + "(ࠡ⭨ " + Staff.TSN + ")");
   END;
   CONFORM(Staff, Man);
   L_Staff.PosToStaffLog(PDocList.TSN, PDoc.Date, 1);
   _CheckAcAccuracyOfPDocSums(PDocList.Sum, Staff.TSN + " " + Man.Name);
   L_General.Assert(SEARCH(MCList, MCode, trgMCode), "    "+trgMCode);
 
   IF PDocList.State = L_PDoc.pdl_st_Paid THEN
    intSaveMoney(Sign, trgMCode, trgSum, trgXObject, trgAcCut);
   ELSE
    _Method:=L_PRoll.E_MethodOfPDocToMoney(PDoc.Date);
    IF (PDocList.State = L_PDoc.pdl_st_NotPaid) & (_Method = L_PRoll.pdtom_All) THEN
     intSaveMoney(Sign, L_kn.Get(PDoc.Date, L_PRoll.erkn_MCList_ToDeponent),   trgSum, trgXObject, trgAcCut);
     intSaveMoney(Sign, L_kn.Get(PDoc.Date, L_PRoll.erkn_MCList_FromDeponent), trgSum, trgXObject, trgAcCut);
    ELSIF (PDocList.State = L_PDoc.pdl_st_Deposited) & (_Method # L_PRoll.pdtom_PaidOnly)  THEN
     intSaveMoney(Sign, L_kn.Get(PDoc.Date, L_PRoll.erkn_MCList_ToDeponent),   trgSum, trgXObject, trgAcCut);
    END;
   END;
   IF Sign = 0 THEN
    L_PRoll.DedDone_AP_withoutCheck(L_DatTim.Per(PDoc.Date), 0);
   ELSE
    L_PRoll.DedDone_AP(L_DatTim.Per(PDoc.Date), 0);
   END;
  END;
 END {CorrectPCalc};

 PRIVATE PROCEDURE MakeStandartCirByPDoc();
 BEGIN
  L_Acnt.MakeStandartCir(_Dir, _CirSource);
 END {MakeStandartCirByPDoc};

 PUBLIC PROCEDURE 멋␠();
  CONST
   AcMthLError = "୮ ᠭ ஢  ࠢ '멋␠'";
  VAR
   _MCode      : LIKE(Money.MCode);
   i           : NUMERIC[0];
   acmthlAcCut,
   acmthlAcCut2,
   trgAcCut,
   slrAcCut,
   monAcCut    : LIKE(MoneyDst.AcCut);
   monXObject  : LIKE(MoneyDst.XObject);
 BEGIN
  L_General.Assert(OCCURE(PDocList), "室 㪠 ࠡ⭨");

  IF ~L_XDR.XDocRepDo() & L_PDoc.E_NeedCorrectPCalc(PDoc.Date) THEN
   L_PRoll.Salary_CheckNoTouch(PDoc.Date);
  END;

  acmthlAcCut :=L_Acnt.getAcMthL_AcCut(PDoc.Date);
  acmthlAcCut2:=L_Acnt.getAcMthL_AcCut2(PDoc.Date);
  IF PDoc.Date >= 01\01\2010 THEN
   slrAcCut:=L_AcCut.erkn_Get(PDoc.Date, L_AcCut.erkn_Salary);
   trgAcCut:=L_PRoll.GetSalaryAcCut(PDoc.Date);
   IF acmthlAcCut = slrAcCut THEN
    acmthlAcCut:=trgAcCut;
    monAcCut   :=acmthlAcCut2;
    L_General.Assert(~!AcMthL.Origin2, AcMthLError);
    L_Acnt.sc_PrepareXObject(AcMthL.Origin2, L_Acnt.cs_PDocList);
    monXObject:=XObject.XObject;
    L_General.Assert(acmthlAcCut2 # slrAcCut, AcMthLError);
   ELSIF acmthlAcCut2 = slrAcCut THEN
    acmthlAcCut2:=trgAcCut;
    monAcCut    :=acmthlAcCut;
    L_General.Assert(~!AcMthL.Origin1, AcMthLError);
    L_Acnt.sc_PrepareXObject(AcMthL.Origin1, L_Acnt.cs_PDocList);
    monXObject:=XObject.XObject;
   ELSE
    L_General.Error(AcMthLError);
   END;
  ELSE
   SETEMPTY(monAcCut);
  END;
  L_Acnt.sc_MakeCir(_Dir, L_DatTim.Per(PDoc.Date), L_Acnt.cs_PDocList,
                    AcMthL.Origin1, acmthlAcCut,  AcMthL.Apport,
                    AcMthL.Origin2, acmthlAcCut2, AcMthL.Apport2,
                    PDocList.Sum, 0, L_XObj.src_PDoc);
  i:=0;
  LOOP
   _MCode:=Str.Item(AcMthL.RulePar, ";", i);
   IF !_MCode THEN
    L_General.Assert(i>0, "  ࠬ ࠢ '멋␠'" + L_Acnt.AcMthIdForMessage(AcMthL.AcMth));
    EXIT;
   ELSE
    CorrectPCalc(_Dir, _MCode, PDocList.Sum, monXObject, monAcCut);
   END;
   INC(i);
  END; (* LOOP *)
 END {멋␠};

 PRIVATE PROCEDURE SimpleProceed();
 BEGIN
  IF !AcMthL.Rule THEN
   MakeStandartCirByPDoc();
  ELSE
   ^AcMthL.Rule();
  END;
 END {SimpleProceed};

 PRIVATE PROCEDURE ExecMth(_CS: L_Acnt.tCirSource);
  VAR
   _Dest: LIKE(Dest.Dest);
 BEGIN
  IF ~L_PDoc.IsPDoc_wJDocOnly() THEN
   _CirSource:=_CS;
   L_XDR.XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_PDoc);
   IF L_PDoc.IsPDocwMDoc() THEN
    _Dest:=MDoc.Dest;
   ELSE
    L_General.Assert(PDoc.Dest # L_Dest.PDocwMDocDest(), "    樨 " + L_Dest.PDocwMDocDest() + "   㪠 뫪  ");
    _Dest:=PDoc.Dest;
   END;
   L_Acnt.ExecAcMth(L_DatTim.Per(PDoc.Date), L_PDoc.PDocDGroup(PDoc.PDocKind), _Dest,
                    EMPTYOF(MathType.MathType),
                    EMPTYOF(MMode.MMode), 0,
                    PROCREF(SimpleProceed), EMPTYOF(PROC));
  END;
 END {ExecMth};

 PRIVATE PROCEDURE MakeSalPDocCir();
  VAR
   glbAcCut : LIKE(AcCut.AcCut);
   glbApport: LIKE(Apport.Apport);
 BEGIN
  glbAcCut:=L_PDoc.GetGlobalAcCutForSalPDoc(PDoc.Date);

  IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
   glbApport:=L_Acnt.E_Apport_MoneyCredit(PDoc.Date);
  ELSE
   glbApport:=L_Acnt.E_Apport_MoneyDebit(PDoc.Date);
  END;

  L_PDoc.AccessGlobalXObject();
  L_XDR.XDocId:=L_XDoc.curXDocId(L_XDoc.xdt_PDoc);

  L_Acnt.ProceedDoc_Begin();
  CONFORM(PDoc, PDocList);
  WHILE OCCURE(PDocList) DO
   PROMPT(PDocList.TSN);
   IF PDocList.State = L_PDoc.pdl_st_Paid THEN
    CONFORM(PDocList, Staff);
    L_Acnt.sc_MakeCir(_Dir, L_DatTim.Per(PDoc.Date), L_Acnt.cs_PDoc,
                      EMPTYOF(L_Acnt.tAcMthOrigin), L_PRoll.GetSalaryAcCut(PDoc.Date), EMPTYOF(Apport.Apport),
                      L_Acnt.amo_Global, glbAcCut, glbApport,
                      PDocList.Sum, 0, L_XObj.src_PDoc);
   END;
   NEXT(PDocList);
  END; (* WHILE OCCURE(PDocList) ... *)
  L_Acnt.ProceedDoc_End();
 END {MakeSalPDocCir};

 PRIVATE PROCEDURE IsPDocwComplexPDocList(): SCAL[2];
 BEGIN
  RETURN ~L_PDoc.IsSalPDoc() &
         SELECT(PDocList, PDoc, PDoc.PDocKind, PDoc.PDoc) & E_CheckScope();
 END {IsPDocwComplexPDocList};

 PRIVATE PROCEDURE PDocMDoc_CheckPDocCorrespondence();
  VAR
   _Total      : LIKE(PDoc.Total);
   _NDS        : LIKE(PDoc.NDS);
   _SaleTax    : LIKE(PDoc.SaleTax);
 BEGIN
  IF L_PDoc.IsPDocwMDoc() THEN
   IF SELECT(PDocMDoc, PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
    SAVE(PDocMDoc);
    SETZERO(_Total, _NDS, _SaleTax);
    SELECT(PDocMDoc, PDoc, , PDoc.PDocKind, PDoc.PDoc);
    WHILE OCCURE(PDocMDoc) DO
     INC(_Total,   PDocMDoc.Total);
     INC(_NDS,     L_Pmnt.ConvEtZ(PDocMDoc.NDS));
     INC(_SaleTax, L_Pmnt.ConvEtZ(PDocMDoc.SaleTax));
     CONFORM(PDocMDoc, MDoc);
     PDocMDoc.Contract:=MDoc.Contract;
     PDocMDoc.PDocDate:=PDoc.Date;
     REPLACE(PDocMDoc);
     NEXT(PDocMDoc);
    END; (* WHILE OCCURE(PDocMDoc) ... *)
    RESTORE(PDocMDoc);
    L_General.Assert(~((PDoc.PDocKind = L_PDoc.pd_VPK) | (PDoc.PDocKind = L_PDoc.pd_IPK)) | (_Total = 0),
                     "⮣ 㬬 㬥   㫥");
    IF L_PDoc.PDocTotalFillMethod() # L_PDoc.pdtfm_byPDocMDoc THEN
     L_General.Assert(L_Pmnt.ConvEtZ(PDoc.Total) = _Total,
                      "⮣  㬬 뫮    ᮢ  㬬 ");
    ELSE
     PDoc.Total:=_Total;
    END;
    IF L_PDoc.InPassingNoteSetting() THEN
     IF (L_Pmnt.ConvEtZ(PDoc.Total)   # _Total  ) |
        (L_Pmnt.ConvEtZ(PDoc.NDS)     # _NDS    ) |
        (L_Pmnt.ConvEtZ(PDoc.SaleTax) # _SaleTax) THEN
      L_General.Error("⨬  㬬   ० '⬥⪠ 宦'");
     END;
    END;
    IF L_Pmnt.ConvEtZ(PDoc.NDS) # _NDS THEN
     IF L_PDoc.PDocTotalFillMethod() = L_PDoc.pdtfm_Manual THEN
      L_StdFrm.Choice("⮣  㬬  뫮    ᮢ  㬬  " +
                      "|४஢ 㬬  ");
     END;
     PDoc.NDS:=_NDS;
    END;
    IF L_Pmnt.ConvEtZ(PDoc.SaleTax) # _SaleTax THEN
     IF L_PDoc.PDocTotalFillMethod() = L_PDoc.pdtfm_Manual THEN
      L_StdFrm.Choice("⮣  㬬  뫮    ᮢ  㬬  " +
                      "|४஢ 㬬  ");
     END;
     PDoc.SaleTax:=_SaleTax;
    END;
    REPLACE(PDoc);
   END; (* IF SELECT(PDocMDoc ... *)
  END; (* IF L_PDoc.IsPDocwMDoc() ... *)
 END {PDocMDoc_CheckPDocCorrespondence};

 PRIVATE PROCEDURE PDocList_CheckPDocCorrespondence(_s: NUMERIC[0]; _IsSalPDoc: SCAL[2]);
  VAR
   _Total    : LIKE(PDoc.Total);
   trgXObject: LIKE(MoneyDst.XObject);
   trgAcCut  : LIKE(MoneyDst.AcCut);
 BEGIN
  IF SELECT(PDocList, PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
   IF _IsSalPDoc THEN
    trgXObject:=L_PDoc.GetGlobalXObject(PDoc.MyFirm, L_PDoc.GetPDocOwnFirmAcnt());
    trgAcCut  :=L_PDoc.GetGlobalAcCutForSalPDoc(PDoc.Date);
   END;
   CheckAcAccuracyOfPDocSums(PDoc.Total);
   SETZERO(_Total);
   WHILE OCCURE(PDocList) DO
    PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc) + " : " + PDocList.TSN);
    CONFORM(PDocList, Staff);
    IF (Staff.MyFirm # PDoc.MyFirm) & ~L_PDoc.E_AllowAnyStaffMyFirmInPDocList() THEN
     L_General.Error("⭨ " + Staff.TSN + "  㣮  ࣠樨");
    END;
    IF PDocList.State = L_PDoc.pdl_st_Paid THEN
     INC(_Total, PDocList.Sum);
    END;
    IF _IsSalPDoc THEN
     CorrectPCalc(_s, Get_MCode(), PDocList.Sum, trgXObject, trgAcCut);
    END;
    PDocList.PDocDate:=PDoc.Date;
    REPLACE(PDocList);
    NEXT(PDocList);
   END; (* WHILE OCCURE(PDocList) ... *)
   IF _s # -1 THEN
    IF _IsSalPDoc & ~L_PDoc.InPassingNoteSetting() THEN
     PDoc.Total:=_Total;
     REPLACE(PDoc);
    ELSE
     L_General.Assert(PDoc.Total = _Total,
                      "⮣  㬬 ᯨ᪠ ࠡ⭨  ᮢ  㬬 ");
    END;
   END;
  ELSE
   L_General.Assert(~_IsSalPDoc | (_s = -1),
                   " ⥦ 㬥  ௫|" +
                   " ⢮  ࠩ   ப");
  END;
 END {PDocList_CheckPDocCorrespondence};

 PRIVATE PROCEDURE ShowDisharmoniousPayment();
  VAR
   bl_After,
   bl_Before : L_Pmnt.tValuesToBalance;
 BEGIN
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   IF L_Pmnt.TakeMDocIntoAccount() THEN
    bl_After:=L_Pmnt.GetMDocBalance(EMPTYOF(DATE), L_XDoc.max_DoneDTS);
    IF (bl_After[L_Pmnt.vtb_Total] # 0) |
       (bl_After[L_Pmnt.vtb_VAT]   # 0) THEN
     bl_Before:=L_Pmnt.vtbAdd(bl_After, L_Pmnt.vtbInv(L_Pmnt.vtbGetByPDocMDocBalance()));
     CONFORM(MDoc, Contract, CntrT);
     L_StdFrm.Choice("ﭨ     " + L_MDoc.MDocStr(PDocMDoc.MDocKind, PDocMDoc.MDoc) +
                     "|" +
                     "|                    ᥣ          .. " +
                     "|᫥  " + Str.Align(FLDTOSTR(bl_After [L_Pmnt.vtb_Total], "2-"), 18, RIGHT) + " " + Str.Align(FLDTOSTR(bl_After [L_Pmnt.vtb_VAT], "2-"), 18, RIGHT) +
                     "|     " + Str.Align(FLDTOSTR(bl_Before[L_Pmnt.vtb_Total], "2-"), 18, RIGHT) + " " + Str.Align(FLDTOSTR(bl_Before[L_Pmnt.vtb_VAT], "2-"), 18, RIGHT));
    END;
    L_General.RaiseLockReleaseException();
   END;
  EXCEPT
  ON Exc: Exc_Raise DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
 END {ShowDisharmoniousPayment};

 PRIVATE PROCEDURE GetAcMthLCirSource(): L_Acnt.tCirSource;
 BEGIN
  L_PDoc.AccessFirstAcMthL();
  IF OCCURE(AcMthL) THEN
   RETURN AcMthL.CirSrc;
  ELSE
   RETURN EMPTYOF(AcMthL.CirSrc);
  END;
 END {GetAcMthLCirSource};

 PRIVATE PROCEDURE CheckCurPer(_s: NUMERIC[0]; Stream: SCAL[2]);
 BEGIN
  Memo.gl_SetCurDate(PDoc.Date);
  IF (_s # 0) & (PDoc.Status = L_PDoc.st_Passed) THEN
   IF ~Stream THEN
    L_APtm.ANYSystem_CheckClcPer(L_APtm.system_PDoc);
    IF ~L_APtm.ANYSystem_Clc_CntIsEqual(L_APtm.system_PDoc) THEN
     L_General.SilentAdminOnly();
     L_StdFrm.Choice(", ,    ⮬ ");
    END;
   END;
   IF L_PDoc.IsSalPDoc() & L_PDoc.E_NeedCorrectPCalc(PDoc.Date) THEN
    L_PRoll.Salary_CheckNoTouch(PDoc.Date);
   END;
  END; (* IF _s # 0 *)
 END {CheckCurPer};

 PRIVATE PROCEDURE ProceedPDoc(_Done  : LIKE(PDoc.Done);
                               _s     : NUMERIC[0];
                               Stream : SCAL[2]);
  VAR
   PDocMDocCnt,
   PDocListCnt : NUMERIC[0];
   i           : NUMERIC[0];
 BEGIN
  L_PDoc.AccessPDoc();
  APP.Get().NewPrompt(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+" "+L_Str.PoolItem("⪠|ࠡ⪠", _Done));
  L_General.SetConcurrentMode();
  CheckCurPer(_s, Stream);
  IF (_s = 0) | (PDoc.Done # _Done) THEN
   IF PDoc.Status # L_PDoc.st_Canceled THEN
    L_General.Assert(~!PDoc.Firm, " 㪠 ࠣ");
    L_General.Assert(~!PDoc.Dest, " 㪠  樨");
    IF L_PDoc.IsSalPDoc() THEN
     PDocList_CheckPDocCorrespondence(_s, 1);
    ELSE
     L_General.Assert((PDoc.Type # L_PDoc.typ_Once) & (PDoc.Type # L_PDoc.typ_Mass),
                      "  ᮢ 㬥   ⮫쪮   70");
     PDocList_CheckPDocCorrespondence(_s, 0);
    END; (* IF IsSalPDoc() ... *)
    IF PDoc.Status = L_PDoc.st_Passed THEN
     _Dir:=_s;
     IF L_PDoc.IsSalPDoc() THEN
      MakeSalPDocCir();
     ELSIF L_PDoc.IsPDocwMDoc() | IsPDocwComplexPDocList() THEN
      SETZERO(PDocMDocCnt, PDocListCnt);
      CONFORM(PDoc, PDocMDoc);
      WHILE OCCURE(PDocMDoc) DO
       INC(PDocMDocCnt);
       NEXT(PDocMDoc);
      END; (* WHILE OCCURE(PDocMDoc) ... *)
      IF IsPDocwComplexPDocList() THEN
       CONFORM(PDoc, PDocList);
       WHILE OCCURE(PDocList) DO
        INC(PDocListCnt);
        NEXT(PDocList);
       END; (* WHILE OCCURE(PDocList) ... *)
      END;
      IF L_PDoc.IsPDocwMDoc() THEN
       L_General.Assert(PDocMDocCnt > 0,
                        "  뫪  ⮢ 㬥");
       CONFORM(PDoc, PDocMDoc);
       CONFORM(PDocMDoc, MDoc);
      END;
      IF (PDocListCnt > PDocMDocCnt) |
         ((PDocListCnt = 1) & (PDocMDocCnt = 1) & 
          (GetAcMthLCirSource()= L_Acnt.cs_PDocList)) THEN
       L_General.Assert(PDocMDocCnt <= 1,
                        "  ᪮쪮 뫮  ࠡ⭨." +
                        "|⨬ 㪠   뫪  ");
       CONFORM(PDoc, PDocList);
       L_Acnt.mpdl_First();
       WHILE OCCURE(PDocList) DO
        ExecMth(L_Acnt.cs_PDocList);
        L_Acnt.mpdl_Next();
        NEXT(PDocList);
       END; (* WHILE OCCURE(PDocList) ... *)
      ELSIF PDocMDocCnt >= 1 THEN
       L_General.Assert(PDocListCnt <= 1,
                        "  ᪮쪮 뫮  ." +
                        "|⨬ 㪠   ࠡ⭨");
       CONFORM(PDoc, PDocList);
       L_PDoc.AccessFirstPDocMDoc();
       WHILE OCCURE(PDocMDoc) DO
        CONFORM(PDocMDoc, MDoc);
        IF ~Stream & (_s # 0) THEN
         ShowDisharmoniousPayment();
        END;
        ExecMth(L_Acnt.cs_PDocMDoc);
        NEXT(PDocMDoc);
       END; (* WHILE OCCURE(PDocMDoc) ... *)
       IF _s = +1 THEN
        PDocMDoc_CheckPDocCorrespondence();
       END;
      ELSE
       L_General.CallUs(0);
      END;
     ELSE
      L_PDoc.AccessGlobalXObject();
      ExecMth(L_Acnt.cs_PDoc);
     END;
     IF L_Acnt.E_DoXDocApr(L_DatTim.Per(PDoc.Date), L_XObj.src_PDoc, L_XDoc.curXDocId(L_XDoc.xdt_PDoc)) THEN
      IF    (_s < 0) THEN
       L_Acnt.RollbackXDoc(PDoc.XDocId);
      ELSIF (_s > 0) THEN
       L_JDoc.XDoc_ProceedAnnexJDoc(_s, L_XDoc.xdt_PDoc);
       L_Acnt.RenXDocApr(PDoc.XDocId);
      ELSIF (_s = 0) THEN
       L_PDoc.CheckDone();
       L_XDR.XDocAprToEntryList(L_XDoc.xdt_PDoc);
      END;
     ELSE
      L_JDoc.XDoc_ProceedAnnexJDoc(_s, L_XDoc.xdt_PDoc);
     END;
    END; (* IF PDoc.Status = L_PDoc.st_Passed ... *)
   ELSE
    L_JDoc.XDoc_ProceedAnnexJDoc(_s, L_XDoc.xdt_PDoc);
    L_Acnt.RenXDocApr(PDoc.XDocId);
   END; (* IF PDoc.Status # L_PDoc.st_Canceled ... *)
   PDoc.Done:=_Done;
   IF _s = +1 THEN
    IF (PDoc.DoneDTS = L_XDoc.max_DoneDTS) | !PDoc.DoneDTS(*0053330*) THEN
     PDoc.DoneDTS:=L_XDoc.GetSysDTS();
    END;
   END;
   REPLACE(PDoc);
  END; (* IF PDoc.Done ... *)
 END {ProceedPDoc};

 PRIVATE PROCEDURE SetAVOCommentPart0();
 BEGIN
  IF SELECT(PDocList, PDoc, PDoc.PDocKind, PDoc.PDoc) & ~!PDocList.TSN THEN
   CONFORM(PDocList, Staff);
   CONFORM(Staff, Man);
   L_PDoc.SetPDocCommentPart(0, "("+PDocList.TSN+") "+Man.Name);
   REPLACE(PDoc);
  END;
 END {SetAVOCommentPart0};

 PRIVATE PROCEDURE CheckPDocAfterAVO();
 BEGIN
  SAVE(Staff);
  SAVE(PDoc);
  SAVE(PDocList);

  L_Pmnt.PrepareAccountableManBalanceHistory(Staff.Man, PDoc.MyFirm, PDoc.Date, EMPTYOF(DATE));

  RESTORE(Staff);
  RESTORE(PDocList);
  RESTORE(PDoc);

  SETSEL(CnBHs, CnBHs, L_XObj.GetManXObject(Staff.Man, PDoc.MyFirm));
  IF LAST(CnBHs) &
     ((CnBHs.Date > PDoc.Date) | (CnBHs.DoneDTS > PDoc.DoneDTS)) THEN
   L_General.Error("᫥ "+L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+" 㦥  㬥  ⠬" +
                   "| 묨 栬, ਬ, "+L_XDoc.extXDocStr(CnBHs.XDocId, L_XDoc.xdast_wDate));
  END;
 END {CheckPDocAfterAVO};

 PRIVATE PROCEDURE CheckPDocNotBasedOnAVO(curXDocId: L_XDoc.tXDocId);
  VAR
   baseXDocId: L_XDoc.tXDocId;
 BEGIN
  baseXDocId:=L_XDoc.GetBaseOnXDocId(curXDocId);
  IF ~!baseXDocId & (L_XDoc.ExtractXDocKindId(baseXDocId) = L_XDoc.XDocKindId(L_XDoc.xdt_PDoc, L_PDoc.pd_AVO)) THEN
   L_General.Error("騩  ନ஢  ᭮ "+L_XDoc.XDocStr(baseXDocId));
  END;
 END {CheckPDocNotBasedOnAVO};

 PRIVATE TYPE
  tAddDocKind = SCAL[1E4];

 PRIVATE CONST
  adk_VATMDoc   = 0;
  adkShift_PDoc = 1000;

 PRIVATE PROCEDURE _Generate_PDoc(dstPDocKind: LIKE(PDocKind.PDocKind)): L_XDoc.tXDocId;
  VAR
   dummyPDocKind,
   basePDocKind   : LIKE(PDoc.PDocKind);
   basePDoc       : LIKE(PDoc.PDoc);
   baseDate       : LIKE(PDoc.Date);
   baseMyFirm     : LIKE(PDoc.MyFirm);
   baseDest       : LIKE(PDoc.Dest);
   baseTotal      : LIKE(PDoc.Total);
   baseSrcNbr     : LIKE(PDoc.SrcNbr);
   spcComment0,
   spcComment1,
   spcComment2    : STRING[];
   genPDocId      : L_XDoc.tXDocId;
   ManBal         : L_Pmnt.tValuesToBalance;
 BEGIN
  L_PDoc.CheckPassed();

  basePDocKind:=PDoc.PDocKind;
  basePDoc    :=PDoc.PDoc;
  baseDate    :=PDoc.Date;
  baseMyFirm  :=PDoc.MyFirm;
  baseSrcNbr  :=PDoc.SrcNbr;
  IF L_PDoc.PDocKindHasStructuredComment(PDoc.PDocKind) THEN
   spcComment0 :=L_PDoc.GetPDocCommentPart(0);
   spcComment1 :=L_PDoc.GetPDocCommentPart(1);
   spcComment2 :="";
  ELSE
   spcComment0 :=L_PDoc.GetPDocComment();
   spcComment1 :="";
   spcComment2 :="";
  END;
  baseTotal   :=PDoc.Total;
  baseDest    :=PDoc.Dest;

  IF dstPDocKind = L_PDoc.pd_AVO THEN
   CheckPDocNotBasedOnAVO(L_XDoc.curXDocId(L_XDoc.xdt_PDoc));
  END;
  IF basePDocKind = L_PDoc.pd_AVO THEN
   SETZERO(ManBal);
   L_General.Assert(SELECT(PDocList, PDoc, PDoc.PDocKind, PDoc.PDoc), " 㪠 ⭮ ");
   CONFORM(PDocList, Staff);
   CheckPDocAfterAVO();

   ManBal:=L_Pmnt.GetAccountableManBalance(Staff.Man, PDoc.MyFirm, PDoc.Date, L_XDoc.max_DoneDTS, PDoc.DoneDTS);
   DEC(baseTotal, ManBal[L_Pmnt.vtb_Total]);

   IF (baseTotal = 0) |
      (L_PDoc.IsOutPDoc(dstPDocKind) = (baseTotal < 0)) THEN
    SETEMPTY(genPDocId);
    RETURN genPDocId;
   END;
   baseTotal:=Math.Abs(baseTotal);
   baseDest :=L_Dest.erkn_GetSoft(PDoc.Date, L_Dest.erkn_SumPaidOutOnAccount);
   IF L_PDoc.IsOutPDoc(dstPDocKind) THEN
    spcComment1:="室  ।";
   ELSE
    spcComment1:="⮪  ।";
   END;
   spcComment2 :="(ᮢ  " + PDoc.SrcNbr + "  " + L_DatTim.DateStr(baseDate) + ")";
  ELSIF basePDocKind = L_PDoc.pd_CND THEN
   spcComment1:="祭  祪. " + L_PDoc.GetPDocCommentPart(1);
   SEARCH(FirmAcnt, Firm, , L_PDoc.GetPDocOwnFirm(), PDoc.OwnAcnt);
   CONFORM(FirmAcnt, Bank);
   spcComment2 :="  " + baseSrcNbr + ", " + Bank.Name;
  END;

  SAVE(PDoc);
  CONFORM(PDoc, PDocList);
  SAVE(PDocList);

  DEFAULT(PDoc);
  PDoc.PDocKind:=dstPDocKind;
  PDoc.MyFirm  :=baseMyFirm;
  IF L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Bank THEN
   P_Firm.AccessSilentFirmAcnt(P_Firm.GetFirmOfMyFirm(PDoc.MyFirm), SYSDATE());
   PDoc.OwnAcnt :=FirmAcnt.FirmAcnt;
  END;
  IF L_PDoc.IsOurselvesPDoc(PDoc.PDocKind) THEN
   PDoc.PrpDate:=L_PDoc.GetActualPDocDate(0);
   PDoc.Status :=L_PDoc.st_Prepared;
  ELSE
   PDoc.PrpDate:=SYSDATE();
   PDoc.Status :=L_PDoc.st_Passed;
  END;
  PDoc.Date:=PDoc.PrpDate;
  L_PDoc.Insert_PDoc();
  IF (PDoc.PDocKind # L_PDoc.pd_AVO) THEN
   PDoc.Total:=baseTotal;
   PDoc.Dest :=baseDest;
  ELSE
   PDoc.Total:=0;
   PDoc.Dest :=L_Dest.PDocwMDocDest();
  END;
  PDoc.Firm:=L_PDoc.GetPDocOwnFirm();
  IF (PDoc.PDocKind = L_PDoc.pd_IPP) & (basePDocKind = L_PDoc.pd_AVO) THEN
   L_PDoc.StandOnSpecDeduct(PDocList.TSN);
   L_General.Assert(OCCURE(Deduct), " ࠡ⭨ "+PDocList.TSN+"   ⨢|室 㤥ঠ  "+L_DatTim.DateStr(PDoc.Date));
   PDoc.Firm:=Deduct.Firm;
   IF ~!Deduct.FirmAcnt THEN
    PDoc.FirmAcnt:=Deduct.FirmAcnt;
   ELSE
    P_Firm.AccessSilentFirmAcnt(PDoc.Firm, PDoc.Date);
    PDoc.FirmAcnt:=FirmAcnt.FirmAcnt;
   END;
   IF ~!Deduct.PCode THEN
    spcComment2:=spcComment2 + "  " + Deduct.PCode;
   END;
   PDoc.Queue:=5;
  END;
  IF L_PDoc.PDocKindHasStructuredComment(PDoc.PDocKind) THEN
   L_PDoc.SetStructuredPDocComment(spcComment0, spcComment1, spcComment2);
  ELSE
   L_PDoc.SetPDocComment(spcComment0 + " " + spcComment1 + " " + spcComment2);
  END;
  PDoc.Source  :=L_PDoc.src_Auto;
  PDoc.Type    :=L_PDoc.typ_Other;
  PDoc.Done    :=0;
  REPLACE(PDoc);

  RESTORE(PDocList);
  IF OCCURE(PDocList) THEN
   PDocList.PDocKind:=PDoc.PDocKind;
   PDocList.PDoc    :=PDoc.PDoc;
   IF basePDocKind = L_PDoc.pd_AVO THEN
    PDocList.Sum:=PDoc.Total;
   ELSIF (PDoc.PDocKind = L_PDoc.pd_AVO) THEN
    PDocList.Sum:=0;
   END;
   INSERT(PDocList);
  END;
  IF PDoc.PDocKind = L_PDoc.pd_AVO THEN
   SetAVOCommentPart0();
  END;
  genPDocId:=L_XDoc.curXDocId(L_XDoc.xdt_PDoc);
  L_PDoc.PDoc_OnAnyModification(+1, L_PDoc.np_No, 0);
  RESTORE(PDoc);
  L_XDoc.rf_InsertParent(genPDocId, L_XDoc.xdt_PDoc, L_XDoc.rft_BaseOn);
  RETURN genPDocId;
 END {_Generate_PDoc};

 PRIVATE PROCEDURE ConfirmHasGeneratedPDoc(Silent      : SCAL[2];
                                           targPDocKind: LIKE(PDoc.PDocKind);
                                           baseXDocId  : L_XDoc.tXDocId);
  VAR
   DependentPDocs: L_XDoc.tXDocCollection;
   i, gpc        : NUMERIC[0];
 BEGIN
  IF ~Silent THEN
   SAVE(PDoc);
   SETZERO(i, gpc);
   DependentPDocs:=L_XDoc.GetDependentXDC(baseXDocId, L_XDoc.xdt_PDoc);
   WHILE L_XDoc.xdc_PositionOn(DependentPDocs, i) DO
    IF PDoc.PDocKind = targPDocKind THEN
     INC(gpc);
    END;
    INC(i);
   END; (* L_XDoc.xdc_PositionOn ... *)
   IF gpc > 0 THEN
    L_StdFrm.Choice(" ᭮ " + L_XDoc.XDocStr(baseXDocId) +
                    "|"+
                    "㦥  ନ஢ "+L_PDoc.PDocKindNick(targPDocKind, 1));
   END;
   RESTORE(PDoc);
  END;
 END {ConfirmHasGeneratedPDoc};

 PRIVATE PROCEDURE Build_PDoc(dstPDocKind: LIKE(PDocKind.PDocKind); Silent: SCAL[2]);
 BEGIN
  ConfirmHasGeneratedPDoc(Silent, dstPDocKind, L_XDoc.curXDocId(L_XDoc.xdt_PDoc));
  L_Pmnt.ConfirmGeneratedDocs(Silent, _Generate_PDoc(dstPDocKind));
 END {Build_PDoc};

 PRIVATE PROCEDURE CheckPDocPP();
  VAR
   StatusStr: STRING[];
 BEGIN
  StatusStr:=L_Str.PoolItem("ப ⥦| ஢| 㫨஢", PDoc.Status);
  IF PDoc.Status=L_PDoc.st_Prepared THEN
   IF PDoc.Date < PDoc.PrpDate THEN
    L_StdFrm.Choice(StatusStr + " ࠭  ⮢|" +
                    " ࠢ묨? (" + L_DatTim.DateStr(PDoc.PrpDate) + ")");
    PDoc.Date:=PDoc.PrpDate;
    REPLACE(PDoc);
   END;
   L_General.Assert(PDoc.Date <= PDoc.PrpDate + 10,
                    "ப ⥦   ⮢  祬  10 ");
  END;
  IF PDoc.Date # PDoc.PrpDate THEN
   L_StdFrm.Choice(StatusStr + " ⫨砥   ⮢");
  END;
 END {CheckPDocPP};

 PRIVATE PROCEDURE CheckChangePDoc(_Action: STRING[]);
  CONST
   _Text = "|ࠩ ᭮|  ⨬ ";
 BEGIN
  L_PDoc.AccessPDoc();
  IF ~L_PDoc.InPassingNoteSetting() & L_PDoc.IsOurselvesPDoc(PDoc.PDocKind) THEN
   IF PDoc.Status = L_PDoc.st_Passed THEN
    L_StdFrm.Choice(_Action + " 㬥⮢  ᮬ '஢'"+_Text);
    L_General.AdminOnly();
   END;
  END;
  IF ~L_PDoc.InPassingNoteSetting() & L_PDoc.CB_IsUploadedPDoc(PDoc.PDocKind, PDoc.PDoc) THEN
   L_StdFrm.Choice(_Action + " 㬥⮢, ।  '-'"+_Text);
   L_General.AdminOnly();
  END;
 END {CheckChangePDoc};

 PRIVATE PROCEDURE MayCancelPDoc();
 BEGIN
  CheckChangePDoc("");
  IF L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Cash THEN
   ResetQueue(PDoc.Date);
  END;
  ProceedPDoc(0, -1, 0);
 END {MayCancelPDoc};

 PRIVATE PROCEDURE GetAddDocKind(Title: STRING[]): tAddDocKind;
  CONST
   pdknLength = 32;
  VAR
   adk : tAddDocKind[100];
   i   : NUMERIC[0];
   List: STRING[];
 BEGIN
  adk[0]:=adk_VATMDoc;
  List:="㬥   |";
  i:=1;
  SELECT(PDocKind, PDocKind);
  WHILE OCCURE(PDocKind) DO
   IF L_Pmnt.IsAcceptableAddPDocKind(PDocKind.PDocKind) THEN
    adk[i]:=adkShift_PDoc+PDocKind.PDocKind;
    List:=List + PDocKind.PDocKind + " "
               + Str.Align(PDocKind.SName, pdknLength, LEFT) + " ("
               + PDocKind.Sign + ")" + "|";
    INC(i);
   END;
   NEXT(PDocKind);
  END; (* WHILE OCCURE(PDocKind) ... *)
  IF i = 1 THEN
   i:=0;
  ELSE
   i:=L_StdFrm.ShowListAsMenu(List, Title);
  END;
  RETURN adk[i];
 END {GetAddDocKind};

 PUBLIC PROCEDURE BuildAddDoc();
  VAR
   addDocKind: tAddDocKind;
 BEGIN
  L_PDoc.AccessPDoc();
  addDocKind:=GetAddDocKind("ନ஢ 㬥");
  IF addDocKind = adk_VATMDoc THEN
   L_Pmnt.AnalyzePayment(0, L_Pmnt.sbvmd_Online);
  ELSE
   Build_PDoc(addDocKind-adkShift_PDoc, 0);
  END;
 END {BuildAddDoc};

 PUBLIC PROCEDURE BuildSpecVATMDocs();
 BEGIN
  L_PDoc.AccessPDoc();
  L_Pmnt.AnalyzePayment(0, L_Pmnt.sbvmd_Offline);
 END {BuildSpecVATMDocs};

 PRIVATE PROCEDURE RemoveGeneratedPDocs(remPDocKind: LIKE(PDoc.PDocKind);
                                        baseDocT   : SCAL[32];
                                        baseDocKind: SCAL[1E2];
                                        baseDoc    : SCAL[1E9]): STRING[];
  VAR
   remPDocList   : STRING[];
   DependentPDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
 BEGIN
  SAVE(PDoc);
  L_General.Assert((remPDocKind=L_PDoc.pd_PKO)|
                   (remPDocKind=L_PDoc.pd_OVN)|
                   (remPDocKind=L_PDoc.pd_VhP)|
                   (remPDocKind=L_PDoc.pd_IsP)|
                   (remPDocKind=L_PDoc.pd_IPP),
                   " 㬥 㤠 "+L_PDoc.PDocKindNick(remPDocKind, 1));
  remPDocList:="";
  DependentPDocs:=L_XDoc.GetDependentXDC(L_XDoc.XDocId(baseDocT, baseDocKind, baseDoc), L_XDoc.xdt_PDoc);
  i:=0;
  WHILE L_XDoc.xdc_PositionOn(DependentPDocs, i) DO
   IF PDoc.PDocKind = remPDocKind THEN
    remPDocList:=remPDocList + "|" + L_XDoc.XDocStr(L_XDoc.curXDocId(L_XDoc.xdt_PDoc));
    MayCancelPDoc();
    L_PDoc.Remove_PDoc(1);
   ELSE
    NEXT(PDoc);
   END;
   INC(i);
  END; (* WHILE L_XDoc.xdc_PositionOn ... *)
  RESTORE(PDoc);
  RETURN remPDocList;
 END {RemoveGeneratedPDocs};

 PUBLIC PROCEDURE RemAddDoc();
  VAR
   addDocKind: tAddDocKind;
 BEGIN
  L_PDoc.AccessPDoc();
  addDocKind:=GetAddDocKind(" 㬥");
  IF addDocKind = adk_VATMDoc THEN
   L_Pmnt.RemoveGeneratedVATMDocs(L_Pmnt.sbvmd_Online, L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc);
  ELSE
   L_Pmnt.ConfirmRemovingDocs(0, RemoveGeneratedPDocs(addDocKind-adkShift_PDoc, L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc));
  END;
 END {RemAddDoc};

 PUBLIC PROCEDURE RemSpecVATMDocs();
 BEGIN
  L_PDoc.AccessPDoc();
  L_Pmnt.RemoveGeneratedVATMDocs(L_Pmnt.sbvmd_Offline, L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc);
 END {RemSpecVATMDocs};

 PRIVATE PROCEDURE NewPDoc(checkFirmAcnt: SCAL[3]);
 BEGIN
  PDoc.PrpDate:=SYSDATE();
  PDoc.Date   :=PDoc.PrpDate;
  IF checkFirmAcnt > 0 THEN
   IF checkFirmAcnt = 2 THEN
    P_Firm.AccessSilentFirmAcnt(L_PDoc.GetPDocOwnFirm(), PDoc.Date);
    PDoc.OwnAcnt:=FirmAcnt.FirmAcnt;
   END;
   IF ~!PDoc.Firm & ~!PDoc.FirmAcnt &
      ~P_Firm.SoftCheckFirmAcnt(PDoc.Date, PDoc.Firm, PDoc.FirmAcnt) THEN
    SETEMPTY(PDoc.FirmAcnt);
   END;
  ELSE
   SETEMPTY(PDoc.FirmAcnt, PDoc.OwnAcnt);
  END;
 END {NewPDoc};

 PRIVATE PROCEDURE ResetQueue(D: DATE);
 BEGIN
  SAVE(PDoc);
  SETSEL(PDoc, Date);
  IF SRCINSEL(PDoc, LE, D) THEN
   LOOP
    L_General.Assert(OCCURE(PDoc), " 㤠  ᮢ 㬥");
    IF L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Cash THEN
     SETEMPTY(PDoc.Queue);
     REPLACE(PDoc);
     EXIT;
    END;
    PREV(PDoc);
   END; (* LOOP *)
  END;
  RESTORE(PDoc);
 END {ResetQueue};

 PRIVATE PROCEDURE SetPermanent();
  VAR
   _Date: LIKE(PDoc.Date);
 BEGIN
  L_General.Assert(L_PDoc.IsUnClosedSalPDoc(PDoc.mfNbr), "ਬ ⮫쪮    ६ ஬");
  _Date:=L_PDoc.GetActualPDocDate(1);
  L_StdFrm.Choice("᢮  ﭭ .|"+" 砭 뤠 "+L_DatTim.DateStr(_Date));
  ProceedPDoc(0, -1, 0);
  SETEMPTY(PDoc.mfNbr);
  SETEMPTY(PDoc.SrcNbr);
  PDoc.Date:=_Date;
  IF L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Cash THEN
   PDoc.Status:=L_PDoc.st_Passed;
   SETEMPTY(PDoc.Queue);
  END;
  REPLACE(PDoc);
  PDocList_CheckPDocCorrespondence(0, L_PDoc.IsSalPDoc());
  L_PDoc.CheckNCorrect_PDocNbrs();
 END {SetPermanent};

 PUBLIC PROCEDURE SetTemporary();
 BEGIN
  L_PDoc.AccessPDoc();
  L_General.Assert((PDoc.PDocKind = L_PDoc.pd_RKO) | (PDoc.PDocKind = L_PDoc.pd_IPP), " ਬ  "+L_PDoc.PDocKindNick(PDoc.PDocKind, 1));
  L_General.Assert(~L_PDoc.IsUnClosedSalPDoc(PDoc.mfNbr), "ਬ ⮫쪮    ﭭ ஬");
  L_StdFrm.Choice("᢮  ६ ");
  ProceedPDoc(0, -1, 0);
  L_PDoc.ForceUnClosedSalPDoc();
  PDoc.mfNbr:=L_PDoc.Temporary_mfNbr(PDoc.MyFirm, PDoc.PDocKind, PDoc.Date, 1);
  PDoc.Status:=L_PDoc.st_Prepared;
  REPLACE(PDoc);
  L_PDoc.CheckNCorrect_PDocNbrs();
 END {SetTemporary};

 PRIVATE PROCEDURE SetAddTaxes(sNDS, sSaleTax: SCAL[2]);
  VAR
   File   : STRING[];
   VATBase: NUMERIC[2];
   _Date  :  DATE;
 BEGIN
  L_General.Assert(~!PDoc.Date, "   'ப ⥦'");
  _Date:=PDoc.Date;
  File :=GE_CURFILE();
  SETEMPTY(^File.NDS, ^File.SaleTax);
  IF File = "PDoc" THEN
   VATBase:=PDoc.Total;
  ELSE
   VATBase:=PDocMDoc.Total;
  END;
  L_General.Assert(~!VATBase, "  㬬");
  IF sSaleTax THEN
   ^File.SaleTax:=L_Acnt.GetInclTaxByPrc(_Date, VATBase, P_OwnData.SaleTax(_Date));
   DEC(VATBase, ^File.SaleTax);
  END;
  IF sNDS THEN
   ^File.NDS:=L_Acnt.GetInclVAT(_Date, VATBase);
  END;
  REPLACE(^File);
 END {SetAddTaxes};

 PRIVATE PROCEDURE intCBUpload(CurrentOnly: SCAL[2]);
  VAR
   onDate   : DATE;
   toExport,
   Exported : NUMERIC[0];
   curClient: NUMERIC[0];
   Result,
   Msg      : STRING[];
 BEGIN
  ACCESS(PDoc);
  onDate:=PDoc.Date;
  L_AFM.MakeMultipleIndex("PD2Up", "MyFirm  : LIKE(PDoc.MyFirm);"+
                                   "Client  : NUMERIC[0];"+
                                   "PDocKind: LIKE(PDoc.PDocKind);"+
                                   "PDoc    : LIKE(PDoc.PDoc)",
                            "MyFirm: MyFirm, Client, PDocKind, PDoc;"+
                            "Client: Client, MyFirm, PDocKind, PDoc;");
  IF CurrentOnly THEN
   L_StdFrm.Question("।  -   ⮫쪮 ⥪饣 ");
   CHANGESEL(PDoc, PDoc, , PDoc.PDocKind, PDoc.PDoc);
  ELSE
   L_StdFrm.Question("।  -     ப ⥦ - " + L_DatTim.DateStr(onDate));
   CHANGESEL(PDoc, Date, , PDoc.Date);
   FIRST(PDoc);
  END;
  L_PDoc.PDoc_CheckNoTouch(L_DatTim.Per(onDate));
  WHILE OCCURE(PDoc) DO
   PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   IF L_PDoc.IsPDocToUpload() THEN
    curClient:=L_PDoc.CB_GetPDocClientBank(PDoc.PDocKind, PDoc.PDoc);
    IF curClient # 0 THEN
     PD2Up.MyFirm  :=PDoc.MyFirm;
     PD2Up.Client  :=curClient;
     PD2Up.PDocKind:=PDoc.PDocKind;
     PD2Up.PDoc    :=PDoc.PDoc;
     INSERT(PD2Up);
    END;
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc)... *)

  IF SELECT(PD2Up, MyFirm) THEN
   TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)]
    SETEMPTY(Msg);
    IF _CBPrintUploaded(onDate) THEN
     OPENREP(Mon, L_General.NameConnection("PDocP"), Print);
    ELSE
     OPENREP(Mon, L_General.NameConnection("PDocP"), Create);
    END;
    WHILE OCCURE(PD2Up) DO
     NARROWSEL(PD2Up, MyFirm, Client);
     SETZERO(toExport, Exported);
     Result:=E_PDoc.ClientBankOperation(PD2Up.Client, "OpenPacket");
     WHILE OCCURE(PD2Up) DO
      SEARCH(PDoc, PDoc, , PD2Up.PDocKind, PD2Up.PDoc);
      PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
      IF L_PDoc.IsPDocToUpload() THEN
       INC(toExport);
       TRY
        L_XDoc.XDocJrn_xMark(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, L_XDoc.action_Sent, 1);
        Result:=E_PDoc.ClientBankOperation(PD2Up.Client, "UploadPDoc");
       EXCEPT
       ON Exc: Exc_Root DO
        L_StdFrm.RedInform(Exc.MsgOriginalText);
       END; (* TRY *)
       IF L_PDoc.CB_IsUploadedPDoc(PDoc.PDocKind, PDoc.PDoc) THEN
        INC(Exported);
        TRY
         L_XDoc.XDocJrn_xMark(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, L_XDoc.action_Reprint, 1);
         CALL(PDocP.Print_InOpenRep());
        EXCEPT
        ELSE
        END; (* TRY *)
       END;
      END;
      NEXT(PD2Up);
     END; (* WHILE OCCURE(PD2Up) *)
     LAST(PD2Up);
     Result:=E_PDoc.ClientBankOperation(PD2Up.Client, "ClosePacket");
     SEARCH(MyFirm, MyFirm, , PD2Up.MyFirm);
     Msg:=Msg + "|" +
           L_Str.PoolItem(" |"+MyFirm.vzSign + " ", P_Firm.E_wMultipleMyFirm(SYSDATE())) +
           Str.Align(L_PDoc.CB_GetClientBankName(PD2Up.Client), 32, LEFT) +
           "   " + FLDTOSTR(toExport, "0", 3)   +
           "   " + FLDTOSTR(Exported, "0", 3)   ;
     NEXTINEXTENDEDSEL(PD2Up, MyFirm, Client);
    END; (* WHILE OCCURE(PD2Up) *)
    CLOSEREP(Mon);
    L_StdFrm.Inform("। ⥦ 㬥⮢ | " + Msg);
   EXCEPT
   Exc: Exc_Root DO
    RAISE();
   END; (* TRY *)
  ELSE
   L_StdFrm.Inform(" 㬥⮢  ।");
  END;
 END {intCBUpload};

 PUBLIC PROCEDURE CBUpload();
 BEGIN
  intCBUpload(0);
 END {CBUpload};

 PUBLIC PROCEDURE CBUploadSinglePDoc();
 BEGIN
  intCBUpload(1);
 END {CBUploadSinglePDoc};

 PUBLIC PROCEDURE CBCancelUpload();
  VAR
   Result: STRING[];
 BEGIN
  L_PDoc.AccessPDoc();
  L_General.Assert(L_PDoc.CB_IsUploadedPDoc(PDoc.PDocKind, PDoc.PDoc),
                   "  믮  㬥⮢, ।  '-'");
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, L_XDoc.action_Edit);
  Result:=E_PDoc.ClientBankOperation(L_PDoc.CB_GetPDocClientBank(PDoc.PDocKind, PDoc.PDoc),
                                     "CancelUpload");
 END {CBCancelUpload};

 PUBLIC PROCEDURE CBDwn_CheckNecessity(VAR Result: SCAL[2]; VAR nextRun: TIMESTAMP);
  VAR
   r        : STRING[];
   curClient: NUMERIC[0];
 BEGIN
  Result :=0;
  nextRun:=SYSTIMESTAMP() + 30/60/24;
  TRY
   L_AR.GrantRightsUnconditionally();
   curClient:=1; (*  -  ஭㬥஢  1 *)
   WHILE (curClient <= L_PDoc.E_cb_Amount(SYSDATE())) & ~Result DO
    IF L_PDoc.E_ClientBankNick(curClient) # L_PDoc.cb_NoCB_Nick THEN (* ??? *)
     r:=L_CB.CheckNew2DownloadPDoc(curClient); (* !!! *)
     IF (r # L_PDoc.cb_DownloadPDocNotRealized) & ~!r THEN
      Result:=1;
     END;
    END; (* IF *)
    INC(curClient);
   END; (* WHILE curClient ... *)
  EXCEPT
  END; (* TRY *)
 END {CBDwn_CheckNecessity};

 PUBLIC PROCEDURE CBDwn();
  CONST
   bpId = "CBDwn";
  VAR
   r,
   _forLikeMenu: STRING[];
   i,
   curClient,
   DownloadAmnt: NUMERIC[0];
   Silent,
   HasErrors   : SCAL[2];
 BEGIN
  L_bp.extBegin(bpId, "㧪  믨᮪  ᪮ ",
                L_bp.t_Prc_wRp, L_General.tc_Entire, L_bp.pt_StrictlyInTime);
  Silent:=L_General.BatchExecution_IsRunning();
  L_StdFrm.Question("㧪  믨᮪  ᪮   -");
  L_AR.GrantRightsUnconditionally();
  SETEMPTY(_forLikeMenu);
  SETZERO(DownloadAmnt, i, HasErrors);
  WHILE i < L_PDoc.E_cb_Amount(SYSDATE()) DO
   curClient:=i+1; (*  -  ஭㬥஢  1 *)
   IF L_PDoc.E_ClientBankNick(curClient) # L_PDoc.cb_NoCB_Nick THEN (* ??? *)
    TRY
     r:=E_PDoc.ClientBankOperation(curClient, "DownloadPDoc");
     IF r # L_PDoc.cb_DownloadPDocNotRealized THEN
      INC(DownloadAmnt);
      IF r#"" THEN
       IF _forLikeMenu#"" THEN
        _forLikeMenu:=_forLikeMenu+", ";
       END;
       _forLikeMenu:=_forLikeMenu + 'Survey, "' + r + '"';
      END;
     END;
    EXCEPT
    ON Exc: Exc_Root DO
     IF Silent THEN
      RAISE();
     ELSE
      HasErrors:=1;
      L_StdFrm.RedInform(Exc.MsgOriginalText);
     END;
    END; (* TRY *)
   END; (* IF *)
   INC(i);
  END; (* WHILE i ... *)

  IF ~HasErrors & (DownloadAmnt = 0) THEN
   L_General.Error(L_PDoc.cb_DownloadPDocNotRealized);
  ELSE
   IF !_forLikeMenu THEN
    IF    Silent THEN
     L_General.Error(" 믮  ।  㦥  믨᮪.||, , ஡");
    ELSIF ~HasErrors THEN
     L_StdFrm.RedInform(" 믨᮪  㦥");
    END; (* IF !_forLikeMenu *)
   END;
  END;
  L_bp.End_wMiltipleRep(_forLikeMenu);
 END {CBDwn};

 PUBLIC PROCEDURE CBDwn_ResultPathMask(VAR Result: STRING[]);
 BEGIN
  Result:=L_CB.drr_GetName() + "*.REP";
 END {CBDwn_ResultPathMask};

 PUBLIC PROCEDURE CBDwn_ViewResultReports();
  VAR
   ChooseFile    : CHOOSEFILEDIALOG;
   RepPathMask,
   ReportFullName: STRING[];
 BEGIN
  CBDwn_ResultPathMask(RepPathMask);
  ChooseFile                   :=CHOOSEFILEDIALOG.Create(RepPathMask);
  ChooseFile.FilesAreAcceptable:=1;
  ReportFullName               :=ChooseFile.Deal();
  IF ~!ReportFullName THEN
   LIKEMENU(Survey, ReportFullName);
  END;
 END {CBDwn_ViewResultReports};

 PUBLIC PROCEDURE CBCancelDownload();
  VAR
   Result: STRING[];
 BEGIN
  L_PDoc.AccessPDoc();
  L_General.Assert(P_PDoc.HasPDocPro(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_CBDlStamp),
                   "  믮  㬥⮢, ਭ  '-'");
  Result:=E_PDoc.ClientBankOperation(L_PDoc.CB_GetPDocClientBank(PDoc.PDocKind, PDoc.PDoc),
                                     "CancelDownloadPDoc");
 END {CBCancelDownload};

 PUBLIC PROCEDURE CBViewSrcFile();
  VAR
   _CB   : NUMERIC[0];
   Result: STRING[];
 BEGIN
  L_PDoc.AccessPDoc();
  L_General.Assert(P_PDoc.HasPDocPro(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_CBDlStamp),
                   "  믮  㬥⮢, ਭ  '-'");
  _CB    := L_PDoc.CB_GetPDocClientBank(PDoc.PDocKind, PDoc.PDoc);
  Result := E_PDoc.ClientBankOperation(_CB, "ViewSrcFile");
  IF ~!Result THEN
   LIKEMENU(EditText, Result + " -v " + L_CB.CB_GetTEDParamsForViewDownloadFile(_CB));
  END;
 END {CBViewSrcFile};

 PRIVATE PROCEDURE SetPDocWindowFields();
  VAR
   mdf_All,
   mdf_About,
   mdf_AnyTotal: SCAL[2];
   Fields      : FORM_FIELDS;
   AboutIdx    : SCAL[3];
   Field       : FORM_FIELD;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  mdf_All:=~L_PDoc.InPassingNoteSetting();
  mdf_AnyTotal:=~L_PDoc.InPassingNoteSetting() & (L_PDoc.PDocTotalFillMethod() = L_PDoc.pdtfm_Manual);
  L_WDO.SetFieldModifiable("PDoc.mfNbr",    mdf_All);
  L_WDO.SetFieldModifiable("PDoc.PrpDate",  mdf_All);
  L_WDO.SetFieldModifiable("PDoc.PmntKind", mdf_All);
  L_WDO.SetFieldModifiable("PDoc.Type",     mdf_All);
  L_WDO.SetFieldModifiable("PDoc.Total",    mdf_AnyTotal);
  L_WDO.SetFieldModifiable("PDoc.NDS",      mdf_AnyTotal);
  L_WDO.SetFieldModifiable("PDoc.Firm",     mdf_All);
  L_WDO.SetFieldModifiable("PDoc.FirmAcnt", mdf_All);
  L_WDO.SetFieldModifiable("PDoc.OwnAcnt",  mdf_All);

  mdf_About:=mdf_All;
  IF ~L_PDoc.InPassingNoteSetting() THEN
   mdf_About:=1;
   IF (PDoc.PDocKind = L_PDoc.pd_IPP) & L_XDoc.XDocWasAutoBuild(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
    IF L_General.IsPolakSpecific() & ~L_General.IsAdmin() THEN
     mdf_About:=0;
    END;
   END;
  END;

  FOR_EACH AboutIdx DO
   Field:=Fields("PDocAbout_" + AboutIdx);
   IF ~!Field THEN
    Field.Value:=L_PDoc.GetPDocCommentPart(AboutIdx);
    IF (AboutIdx = 0) & (RTI.Get().CurWindow.OriginalName = "PDocE11M") THEN
     Field.Modifiable :=0;
    ELSE
     Field.Modifiable :=mdf_About;
    END;
   END;
  END;

  L_WDO.SetFieldModifiable("PDoc.ExtAbout", mdf_About);
  L_WDO.SetFieldModifiable("PDoc.Queue", mdf_All);
  Fields("PDoc.Status").Modifiable:=L_PDoc.InPassingNoteSetting() | ~L_PDoc.IsOurselvesPDoc(PDoc.PDocKind);

  L_WDO.z_SetFieldModifiable(1, "PDocList.TSN", 1);
  L_WDO.z_SetFieldModifiable(1, "PDocList.Sum", 1);

  IF L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Cash THEN
   Fields("PDoc.Firm").Modifiable:=!PDoc.FirmAcnt;
   IF ~!Fields("PDoc.FirmAcnt") THEN
    Fields("PDoc.FirmAcnt").Visible:=~!PDoc.FirmAcnt;
    Fields("FirmAcnt.Name").Visible:=~!PDoc.FirmAcnt;
   END;
  END;
  Field:=Fields("P_Comment");
  IF ~!Field THEN
   Field.Value:=P_PDoc.GetPDocProSoft(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_Comment);
  END;
 END {SetPDocWindowFields};

 PRIVATE PROCEDURE SplitStr(S: STRING[]): STRING[];
  VAR
   Arr : STRING[][4];
   Res : STRING[];
   i   : NUMERIC[0];
 BEGIN
  Str.Format(Arr, S, Str.Length(S) / (Str.Length(S) DIV 60 + 1) + 10, LEFT);
  i  :=0;
  Res:="";
  WHILE (i < HIGH(Arr)) & (Arr[i] # "") DO
   Res:=Res + Str.Condense(Arr[i]) + "|";
   INC(i);
  END;
  RETURN Res;
 END {SplitStr};

 PRIVATE PROCEDURE GetFirmAcntBankReq(_Firm    : LIKE(PDoc.Firm);
                                      _FirmAcnt: LIKE(PDoc.FirmAcnt)): STRING[];
  VAR
   _Acnt: STRING[][2];
   _Name,
   _Bank,
   _BIC,
   _INN : STRING[];
 BEGIN
  L_General.Assert(~!_Firm, "室 㪠 ࠣ");
  L_General.Assert(~!_FirmAcnt, "室 㪠 ");
  L_General.Assert(SEARCH(Firm, Firm, _Firm),
                   " 㤠  ࠣ "+_Firm);
  L_General.Assert(SEARCH(FirmAcnt, Firm, _Firm, _FirmAcnt),
                   " 㤠   " + _FirmAcnt + " ࠣ " + _Firm);
  P_Firm.GetFirmData(PDoc.Date, _Name, _Bank, _Acnt, _BIC, _INN, 1);
  RETURN SplitStr(_Name) + " " + _INN + " .N " + _Acnt[0] + "|" +
         SplitStr(_Bank) + " " + _BIC + " / "  + _Acnt[1];
 END {GetFirmAcntBankReq};

 PUBLIC PROCEDURE InformFirmAcntBankReq();
  VAR
   curFieldName: STRING[];
 BEGIN
  L_PDoc.AccessPDoc();
  curFieldName:=RTI.Get().CurZone.ActiveField.Name;
  IF    curFieldName = "PDoc.OwnAcnt" THEN
   L_StdFrm.Inform(GetFirmAcntBankReq(L_PDoc.GetPDocOwnFirm(), PDoc.OwnAcnt));
  ELSIF curFieldName = "PDoc.FirmAcnt" THEN
   L_StdFrm.Inform(GetFirmAcntBankReq(PDoc.Firm, PDoc.FirmAcnt));
  ELSE
   L_General.Error("饥    ᪨ ⮬ ࠣ");
  END;
 END {InformFirmAcntBankReq};

 PUBLIC PROCEDURE SetNewPDocPDoc();
 BEGIN
  L_PDoc.AccessPDoc();
  SetPermanent();
  SE_WZD_POSITION(GE_CURWIN(), GE_CURZONE(), PDoc);
 END {SetNewPDocPDoc};

 PRIVATE PROCEDURE AccessPDocKind();
 BEGIN
  L_General.Assert(ACCESS(PDocKind), " ⠭ PDocKind");
 END {AccessPDocKind};

 PRIVATE PROCEDURE InBetweenClcPer(_TSN: LIKE(Staff.TSN); D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SETEMPTY(Result);
  SAVE(Staff);
  L_General.CallUs(SEARCH(Staff, TSN, _TSN));
  IF Staff.BegDate = L_DatTim.Per(D) THEN
   Result:=0;
  ELSE
   SAVE(PDoc);
   SAVE(PDocList);
   SETSEL(PDocList, TSN, _TSN);
   SRCINSEL(PDocList, GE, , L_DatTim.Per(D));
   WHILE OCCURE(PDocList) & !Result DO
    IF PDocList.State = L_PDoc.pdl_st_Paid THEN
     CONFORM(PDocList, PDoc);
     IF (PDoc.Source # L_PDoc.src_InProgress) & (PDoc.Status < L_PDoc.st_Canceled) THEN
      IF L_PDoc.IsSalPDoc() & (PDoc.Type = L_PDoc.typ_Mass) THEN
       Result:=D<=PDoc.Date;
      END;
     END;
    END;
    NEXT(PDocList);
   END; (* WHILE OCCURE(PDocList)... *)
   RESTORE(PDocList);
   RESTORE(PDoc);
  END;
  RESTORE(Staff);
  IF !Result THEN
   Result:=1;
  END;
  RETURN Result;
 END {InBetweenClcPer};

 PRIVATE PROCEDURE CheckType();
  VAR
   First: SCAL[2];
 BEGIN
  IF (PDoc.Source # L_PDoc.src_Auto) & (PDoc.Type = L_PDoc.typ_Other) & (PDoc.Status # L_PDoc.st_Canceled) &
     L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
   First:=1;
   SELECT(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc);
   WHILE OCCURE(PDocList) & First DO
    IF InBetweenClcPer(PDocList.TSN, PDoc.Date) THEN
     L_StdFrm.Question(" ⨯ 㬥 - 稩| |" +
                       ", ᫥ 㪠 ࠧ ⨯ |  믫  ᮢ 뤠");
     First:=0;
    END;
    NEXT(PDocList);
   END; (* WHILE OCCURE(PDocList) ... *)
  END;
 END {CheckType};

 PRIVATE PROCEDURE All_PDoc_OnAfterEditInsertEvents();
  CONST
   Message = "   㬥  ᮮ⢥   㬥";
  VAR
   prvContract: LIKE(Contract.Contract);
   Fields     : FORM_FIELDS;
   AboutIdx   : SCAL[3];
   Field      : FORM_FIELD;
   Comment    : STRING[][3];
 BEGIN
  IF L_PDoc.PDocKindHasStructuredComment(PDoc.PDocKind) THEN
   Fields:=RTI.Get().CurZone.Fields;
   FOR_EACH AboutIdx DO
    Field:=Fields("PDocAbout_" + AboutIdx);
    IF ~!Field THEN
     L_PDoc.SetPDocCommentPart(AboutIdx, Field.Value);
    END;
   END;
   REPLACE(PDoc);
  END;

  CONFORM(PDoc, PDocList);
  IF L_PDoc.IsOurselvesPDoc(PDoc.PDocKind) THEN
   L_General.Assert(L_PDoc.GoodYearPDoc(PDoc.PrpDate), Message);
  ELSE
   L_General.Assert(L_PDoc.GoodYearPDoc(PDoc.Date), Message);
  END;
  IF (PDoc.PDocKind = L_PDoc.pd_AVO) THEN
   PDocList.Sum:=PDoc.Total;
   REPLACE(PDocList);
   SetAVOCommentPart0();
  END;
  _CheckAcAccuracyOfPDocSums(PDoc.Total,   "㬬");
  _CheckAcAccuracyOfPDocSums(PDoc.NDS,     "");
  _CheckAcAccuracyOfPDocSums(PDoc.SaleTax, "");
  PDocMDoc_CheckPDocCorrespondence();
  PDocList_CheckPDocCorrespondence(0, L_PDoc.IsSalPDoc());

  IF    (PDoc.PDocKind = L_PDoc.pd_RKO)  |
        (PDoc.PDocKind = L_PDoc.pd_PKO)  THEN
   IF L_PDoc.IsSingleTSN_PDoc() THEN
    CONFORM(PDocList, Staff, Man);
    L_PDoc.SetPDocCommentPart(0, "("+Staff.TSN+") "+Man.Name);
   ELSIF ~OCCURE(PDocList) THEN
    L_General.Assert((PDoc.PDocKind = L_PDoc.pd_RKO) | ~!L_PDoc.GetPDocCommentPart(0),
                     " 'ਭ '");
   ELSE
    L_General.CallUs(PDoc.PDocKind # L_PDoc.pd_PKO);
   END;
   SETEMPTY(PDoc.Queue);
   REPLACE(PDoc);
  ELSIF (PDoc.PDocKind = L_PDoc.pd_IPP) |
        (PDoc.PDocKind = L_PDoc.pd_VPP) |
        (PDoc.PDocKind = L_PDoc.pd_ITP) |
        (PDoc.PDocKind = L_PDoc.pd_VTP)  THEN
   IF PDoc.Status # L_PDoc.st_Canceled THEN
    P_Firm.CheckFirmAcnt(PDoc.Date, L_PDoc.GetPDocOwnFirm(), PDoc.OwnAcnt);
    IF ~!PDoc.FirmAcnt THEN
     P_Firm.CheckFirmAcnt(PDoc.Date, PDoc.Firm, PDoc.FirmAcnt);
    ELSE
     L_StdFrm.Choice("    ࠣ "+PDoc.Firm);
    END;
    IF (PDoc.PDocKind = L_PDoc.pd_IPP) & L_PDoc.IsSalPDoc() THEN
     SETEMPTY(PDoc.payp);
     CONFORM(PDoc, PDocList);
     WHILE OCCURE(PDocList) DO
      CONFORM(PDocList, Staff);
      L_Staff.PosToStaffLog(PDocList.TSN, PDoc.Date, 1);
      L_PDoc.StandOnSpecDeduct(PDocList.TSN);
      L_General.Assert(OCCURE(Deduct), " ࠡ⭨ "+PDocList.TSN+"   ⨢|室 㤥ঠ  "+L_DatTim.DateStr(PDoc.Date));
      IF !PDoc.payp THEN
       PDoc.payp:=Deduct.PayP;
       REPLACE(PDoc);
      END;
      L_PDoc.CheckDeductFitforPDoc();
      IF !Deduct.FirmAcnt THEN
       SEARCH(FirmAcnt, FirmAcnt, , PDoc.Firm, PDoc.FirmAcnt);
       IF ~P_Firm.IsSilentFirmAcnt(PDoc.Date) THEN
        L_StdFrm.CrucialChoice(" 㤥ঠ ࠡ⭨ " + PDocList.TSN +
                               "  㪠   ࠣ."+
                               "||᫥ ௫ ⮣ ࠡ⭨   " +
                               "''  ࠣ " + PDoc.Firm, L_APtm.g_PayRoll);
       END;
      END;
      NEXT(PDocList);
     END; (* WHILE OCCURE(PDocList) ... *)
    END;
   END; (* IF PDoc.Status # ... *)
   CheckPDocPP();
   L_General.Assert(((PDoc.mfNbr MOD 1000) > 0) | L_PDoc.IsUnClosedSalPDoc(PDoc.mfNbr),
                    "᫥      ⫨묨  '000'");
  ELSIF (PDoc.PDocKind = L_PDoc.pd_OVN) | (PDoc.PDocKind = L_PDoc.pd_CND) THEN
   P_Firm.CheckFirmAcnt(PDoc.Date, L_PDoc.GetPDocOwnFirm(), PDoc.OwnAcnt);
  END;
  IF L_PDoc.IsOurselvesPDoc(PDoc.PDocKind) THEN
   IF (PDoc.Status=L_PDoc.st_Prepared) &
      (PDoc.Date < L_PDoc.GetActualPDocDate(1)) THEN
    L_StdFrm.Choice("樮  祭, ப ⥦ 㪠 ୮?");
   END;
  END;
  IF L_PDoc.IsSalPDoc() THEN
   IF (L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Cash) & (PDoc.Date >= L_PDoc.IncWorkDay(PDoc.PrpDate, +5)) THEN
    L_General.Error("砭 뤠      ࠡ     砫");
   END;
   CheckType();
  END;
  L_PDoc.CheckBudgetPDoc();
  IF L_PDoc.IsPDocwMDoc() THEN
   SETEMPTY(prvContract);
   SELECT(PDocMDoc, PDoc, , PDoc.PDocKind, PDoc.PDoc);
   WHILE OCCURE(PDocMDoc) DO
    SEARCH(MDoc, MDoc, , PDocMDoc.MDocKind, PDocMDoc.MDoc);
    IF PDoc.PDocKind = L_PDoc.pd_AVO THEN
     CONFORM(PDoc, PDocList);
     IF MDoc.TSN # PDocList.TSN THEN
      L_StdFrm.Choice("ᮮ⢥⢨ ࠡ⭨:| |" +
                      "㬥: " + L_PDoc.PDocKindNick(PDoc.PDocKind, 1) +  " " + PDoc.PDoc +
                      ", ⠡ " + PDocList.TSN + "|" +
                      "易 㬥: " + L_MDoc.MDocKindNick(MDoc.MDocKind, 1) + " " + MDoc.MDoc  +
                      ", ⠡ " + MDoc.TSN);
     END;
    ELSE
     CONFORM(MDoc, Contract);
     L_General.Assert((PDoc.Firm = Contract.Firm) |
                      P_Cntr.IsPaymentAgent(MDoc.Contract, PDoc.Date, PDoc.Firm),
                      " ᮢ ࠣ  ⥦  ⮢୮ 㬥.|" +
                      " 㬥 " + L_MDoc.MDocKindNick(MDoc.MDocKind, 1) + " " + MDoc.MDoc);
    END;
    NEXT(PDocMDoc);
   END; (* WHILE OCCURE(PDocMDoc)...*)
  END;
  IF ~L_PDoc.PDocKindHasStructuredComment(PDoc.PDocKind) THEN
   L_General.Assert(Str.Length(L_PDoc.GetFullPDocAbout()) <= L_PDoc.MaxPDocCommentLength,
                    "祭 ⥦ ॢ蠥 ⨬ ࠧ");
  END;

  Field:=RTI.Get().CurZone.Fields("P_Comment");
  IF ~!Field THEN
   P_PDoc.SetPDocPro(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_Comment, Field.Value);
  END;

  L_PDoc.PDoc_OnAnyModification(+1, L_PDoc.np_Try, 0);
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc);
 END {All_PDoc_OnAfterEditInsertEvents};

 PRIVATE PROCEDURE PDoc_OnBeforeEdit();
  VAR
   Count: NUMERIC[0];
 BEGIN
  IF PDoc.Done THEN
   Count:=0;
   CONFORM(PDoc, PDocList);
   WHILE OCCURE(PDocList) & (Count<=50) DO
    INC(Count);
    NEXT(PDocList);
   END; (* WHILE OCCURE(PDocList) ... *)
   L_General.Assert(Count <= 50, "  砥   |"+
                                 "室 ।⥫쭮 ந  ⪠|"+
                                 "㬥 ᮤন  50 ࠡ⭨");
  END;
  IF L_PDoc.InPassingNoteSetting() THEN
   L_General.Assert(L_PDoc.IsOurselvesPDoc(PDoc.PDocKind),
                   " 믮 ⮫쪮  ⥦ 㬥⮢  ,|" +
                   "ନ㥬 ᠬ⥫쭮");
  END;
  SetPDocWindowFields();
  CheckChangePDoc("");
  IF PDoc_wCopyCnt() THEN
   CheckIfIsSent(L_XDoc.action_Edit);
   MakeUnprinted(0);
  END;
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, L_XDoc.action_Edit);
  L_AR.GrantRightsForInteractiveModification();
  L_PDoc.PDoc_OnAnyModification(-1, L_PDoc.np_Yes, 0);
  P_PDoc.RemovePDocPro(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_Comment);
 END {PDoc_OnBeforeEdit};

 PRIVATE PROCEDURE PDoc_OnAfterEdit();
 BEGIN
  IF L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Cash THEN
   IF PDoc.mfNbr # GE_PVALUE(PDoc.mfNbr) THEN
    L_General.Assert(~L_PDoc.IsUnClosedSalPDoc(GE_PVALUE(PDoc.mfNbr)),
                     "᢮ ﭭ  ⢫ ᯥ樠쭮 楤ன");
   END;
  END;
  All_PDoc_OnAfterEditInsertEvents();
 END {PDoc_OnAfterEdit};

 PRIVATE PROCEDURE PDoc_OnBeforeInsert();
  VAR
   envMyFirm,
   envFirmAcnt: ENVVAR;
 BEGIN
  L_General.Assert(L_PDoc.IsRequiredPDocKind(PDoc.PDocKind, SYSDATE()) # L_PDoc.pdkrq_Disabled, "  "+L_PDoc.PDocKindNick(PDoc.PDocKind, 1)+"   ਬ"+L_StdFrm.HR()+"ᯮ   㬥⮢");
  SETEMPTY(envFirmAcnt);
  envMyFirm:=L_WDO.AccessEnvVar("trgMyFirm");
  IF ~!envMyFirm THEN
   PDoc.MyFirm:=envMyFirm.Value;
   envFirmAcnt:=L_WDO.AccessEnvVar("trgFirmAcnt");
  ELSE
   PDoc.MyFirm:=P_Firm.DefineMyFirm();
  END;
  SETEMPTY(PDoc.mfNbr);
  REPLACE(PDoc);
  IF PDoc_wCopyCnt() THEN
   MakeUnprinted(1);
  END;
  L_AR.GrantRightsForInteractiveModification();
  IF    L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Cash THEN
   NewPDoc(0);
   IF ~!envFirmAcnt THEN
    PDoc.FirmAcnt:=envFirmAcnt.Value;
    PDoc.Firm    :=L_PDoc.GetPDocOwnFirm();
   END;
  ELSIF (PDoc.PDocKind = L_PDoc.pd_POO) | (PDoc.PDocKind = L_PDoc.pd_ROO) THEN
   NewPDoc(0);
   IF ~!envFirmAcnt THEN
    PDoc.OwnAcnt:=envFirmAcnt.Value;
   END;
  ELSIF (PDoc.PDocKind = L_PDoc.pd_VPP) THEN
   NewPDoc(2);
   PDoc.Status  :=L_PDoc.st_Passed;
   PDoc.PmntKind:=L_PDoc.E_DefaultPDocPmntKind(PDoc.Date);
  ELSIF (PDoc.PDocKind = L_PDoc.pd_IPP) THEN
   NewPDoc(2);
   PDoc.Status  :=L_PDoc.st_Prepared;
   PDoc.PmntKind:=L_PDoc.E_DefaultPDocPmntKind(PDoc.Date);
  ELSIF (PDoc.PDocKind = L_PDoc.pd_VMO) | (PDoc.PDocKind = L_PDoc.pd_IMO) THEN
   NewPDoc(0);
  ELSIF (PDoc.PDocKind = L_PDoc.pd_VTP) THEN
   L_StdFrm.BlueHalt("⨬  㬥⮢  짮 ");
  ELSIF (PDoc.PDocKind = L_PDoc.pd_ITP) THEN
   NewPDoc(0);
  ELSIF (PDoc.PDocKind = L_PDoc.pd_OVN) THEN
   NewPDoc(2);
   PDoc.Status  :=L_PDoc.st_Prepared;
   PDoc.Firm    :=L_PDoc.GetPDocOwnFirm();
  ELSIF (PDoc.PDocKind = L_PDoc.pd_CND) THEN
   NewPDoc(2);
   PDoc.Status  :=L_PDoc.st_Prepared;
   PDoc.Firm    :=L_PDoc.GetPDocOwnFirm();
   L_PDoc.SetPDocComment("");
  ELSIF (PDoc.PDocKind = L_PDoc.pd_AVO) THEN
   NewPDoc(0);
   PDoc.Status  :=L_PDoc.st_Prepared;
   PDoc.Firm    :=L_PDoc.GetPDocOwnFirm();
   PDoc.Dest    :=L_Dest.PDocwMDocDest();
   L_PDoc.SetPDocComment("");
   SETZERO(PDoc.Total, PDoc.NDS, PDoc.SaleTax);
  ELSIF (PDoc.PDocKind = L_PDoc.pd_VPK) | (PDoc.PDocKind = L_PDoc.pd_IPK) THEN
   NewPDoc(0);
   PDoc.Firm    :=L_PDoc.GetPDocOwnFirm();
   PDoc.Status  :=L_PDoc.st_Passed;
   PDoc.Dest    :=L_Dest.PDocwMDocDest();
   SETZERO(PDoc.Total, PDoc.NDS, PDoc.SaleTax);
  ELSIF (PDoc.PDocKind = L_PDoc.pd_VhP) | (PDoc.PDocKind = L_PDoc.pd_IsP) THEN
   NewPDoc(0);
   PDoc.Firm    :=L_PDoc.GetPDocOwnFirm();
   PDoc.Status  :=L_PDoc.st_Passed;
  END;
  IF L_PDoc.IsOurselvesPDoc(PDoc.PDocKind) THEN
   PDoc.PrpDate:=L_PDoc.GetActualPDocDate(0);
   PDoc.Date   :=PDoc.PrpDate;
  END;
  PDoc.XDocId :=L_XDoc.curXDocId(L_XDoc.xdt_PDoc);
  PDoc.DoneDTS:=L_XDoc.max_DoneDTS;
  REPLACE(PDoc);
  L_PDoc.CheckNCorrect_PDocNbrs();
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, L_XDoc.action_Insert);
  SetPDocWindowFields();
 END {PDoc_OnBeforeInsert};

 PRIVATE PROCEDURE PDoc_OnAfterInsert();
 BEGIN
  All_PDoc_OnAfterEditInsertEvents();
 END {PDoc_OnAfterInsert};

 PRIVATE PROCEDURE PDoc_OnBeforeDelete();
 BEGIN
  L_AR.GrantRightsForInteractiveModification();
  MayCancelPDoc();
  IF L_XDoc.XDoc_wo_Handicraft(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
   IF P_PDoc.HasPDocPro(PDoc.PDocKind, PDoc.PDoc, P_PDoc.P_CBDlStamp) THEN
    L_General.Error("㦥  - 㬥 㤠  " +
                    L_StdFrm.HR() +
                    " 室 믮 楤|⬥ 㧪 믨᪨  ᪮ ");
   END;
   L_StdFrm.Choice(" ⮬᪨ ନ஢ ");
   L_PDoc.Remove_PDoc(0);
  ELSE
   L_General.Assert(PDoc.Status = L_PDoc.st_Canceled,
                    " 㬥 饭. ᯮ '㫨஢/'");
   L_General.Error("㬥 㤠  ");
  END;
 END {PDoc_OnBeforeDelete};

 PRIVATE PROCEDURE PDoc_OwnAcnt_OnBeforeAskForEdit();
 BEGIN
  v_FirmToAskAcnt:=L_PDoc.GetPDocOwnFirm();
  RTI.Get().CurZone.ActiveField.OwnerWindowOriginalName:="OwnAcnt";
 END {PDoc_OwnAcnt_OnBeforeAskForEdit};

 PRIVATE PROCEDURE PDoc_FirmAcnt_OnBeforeAskForEdit();
 BEGIN
  v_FirmToAskAcnt:=PDoc.Firm;
  RTI.Get().CurZone.ActiveField.OwnerWindowOriginalName:="OwnAcnt";
 END {PDoc_FirmAcnt_OnBeforeAskForEdit};

 PRIVATE PROCEDURE PDoc_OwnAcnt_OnAskPhase1();
  VAR
   FilterValue: STRING[];
 BEGIN
  IF    L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Bank       THEN
   FilterValue:=L_PDoc.GetFilterValueForOnlyBankFirmAcnt();
  ELSE
   FilterValue:="(FirmAcnt.Type=" + L_Str.IntStr(P_Firm.fat_OprCashDsk) + ")" ;
  END;
  L_WDO.GetOwnerZone(L_WDO.getActiveField()).PermanentFilter:=FilterValue;
  IF ~!PDoc.OwnAcnt THEN
   L_General.CallUs(SEARCH(FirmAcnt, Firm, L_PDoc.GetPDocOwnFirm(), PDoc.OwnAcnt));
   L_WDO.PositionInOwnerZoneOfActiveField("FirmAcnt");
  END;
 END {PDoc_OwnAcnt_OnAskPhase1};

 PRIVATE PROCEDURE PDoc_OwnAcnt_OnAskPhase2();
 BEGIN
  L_General.Assert(ACCESS(FirmAcnt), " ⠭  ");
  PDoc.OwnAcnt:=FirmAcnt.FirmAcnt;
  PDoc_OwnAcnt_OnSuccessfulChange();
  REPLACE(PDoc);
 END {PDoc_OwnAcnt_OnAskPhase2};

 PRIVATE PROCEDURE PDoc_pdlTSN_OnSuccessfulChange();
  VAR
   prvTSN,
   curTSN: LIKE(Staff.TSN);
 BEGIN
  prvTSN:=GE_PVALUE();
  IF ~!prvTSN THEN
   CheckRefToPDoc();
  END;
  curTSN:=RTI.Get().CurZone.ActiveField.Value;
  SEARCH(Staff, TSN, , curTSN);
  CONFORM(Staff, Man);
  IF SELECT(PDocList, PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
   PDocList.TSN:=curTSN;
   REPLACE(PDocList);
  ELSE
   PDocList.TSN     :=curTSN;
   PDocList.PDoc    :=PDoc.PDoc;
   PDocList.PDocKind:=PDoc.PDocKind;
   PDocList.PDocDate:=PDoc.Date;
   PDocList.Sum     :=0;
   PDocList.PDocDate:=PDoc.Date;
   PDocList.State   :=L_PDoc.pdl_st_Paid;
   INSERT(PDocList);
  END;
  SetAVOCommentPart0();
  RTI.Get().CurZone.Fields("PDocAbout_0").Value:=L_PDoc.GetPDocCommentPart(0);
  IF L_StdFrm.Alternative("믮 । ⥦?") THEN
   TRY
    L_Pmnt.DistributePayment();
   EXCEPT
   ON Exc: Exc_Halt DO
    HALT(0);
   END; (* TRY *)
  END;
 END {PDoc_pdlTSN_OnSuccessfulChange};

 PUBLIC PROCEDURE SetAnnexSign();
  VAR
   trgField: FORM_FIELD;
 BEGIN
  trgField:=RTI.Get().CurWindow.Zones(0).Fields("Dest.Name");
  IF ~!trgField THEN
   IF ~!L_XDoc.GetAnnexXDocId(L_XDoc.curXDocId(L_XDoc.xdt_PDoc)) THEN
    trgField.Color:=FORM_FIELD.Color_Field1;
   ELSE
    trgField.Color:=FORM_FIELD.Color_Field4;
   END;
  END;
 END {SetAnnexSign};

 PRIVATE PROCEDURE AnyPDoc_OnReposition();
  VAR
   _TSN     : LIKE(Staff.TSN);
   _ManName : LIKE(Man.Name);
   Fields   : FORM_FIELDS;
 BEGIN
  IF (PDoc.PDocKind = L_PDoc.pd_AVO) THEN
   IF SELECT(PDocList, PDoc, L_PDoc.pd_AVO, PDoc.PDoc) THEN
    CONFORM(PDocList, Staff);
    CONFORM(Staff, Man);
    _TSN    :=PDocList.TSN;
    _ManName:=Man.Name;
   ELSE
    SETEMPTY(_TSN, _ManName);
   END;
   Fields:=RTI.Get().CurZone.Fields;
   Fields("pdlTSN").Value :=_TSN;
  END;
  SetPDocWindowFields();
  SetAnnexSign();
 END {AnyPDoc_OnReposition};

 PRIVATE PROCEDURE PDocE01M_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE01M_0_OnReposition};

 PRIVATE PROCEDURE PDocE01L_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE01L_0_OnReposition};

 PRIVATE PROCEDURE PDocE02M_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE02M_0_OnReposition};

 PRIVATE PROCEDURE PDocE02L_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE02L_0_OnReposition};

 PRIVATE PROCEDURE PDocE03M_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE03M_0_OnReposition};

 PRIVATE PROCEDURE PDocE03L_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE03L_0_OnReposition};

 PRIVATE PROCEDURE PDocE04M_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE04M_0_OnReposition};

 PRIVATE PROCEDURE PDocE04L_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE04L_0_OnReposition};

 PRIVATE PROCEDURE PDocE05_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE05_0_OnReposition};

 PRIVATE PROCEDURE PDocE06_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE06_0_OnReposition};

 PRIVATE PROCEDURE PDocE07_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE07_0_OnReposition};

 PRIVATE PROCEDURE PDocE09_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE09_0_OnReposition};

 PRIVATE PROCEDURE PDocE10_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE10_0_OnReposition};

 PRIVATE PROCEDURE PDocE11M_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE11M_0_OnReposition};

 PRIVATE PROCEDURE PDocE12_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE12_0_OnReposition};

 PRIVATE PROCEDURE PDocE14_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE14_0_OnReposition};

 PRIVATE PROCEDURE PDocE16M_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE16M_0_OnReposition};

 PRIVATE PROCEDURE PDocE17M_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE17M_0_OnReposition};

 PRIVATE PROCEDURE PDocE18L_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE18L_0_OnReposition};

 PRIVATE PROCEDURE PDocE19_0_OnReposition();
 BEGIN
  AnyPDoc_OnReposition();
 END {PDocE19_0_OnReposition};

 PRIVATE PROCEDURE incTotal(VAR what: NUMERIC[2]; by: NUMERIC[2]; _s: NUMERIC[0]);
 BEGIN
  IF ~!by THEN
   IF !what THEN
    what:=0;
   END;
   INC(what, _s*by);
  END;
 END {incTotal};

 PRIVATE PROCEDURE PDocMDoc_OnChangeSum(_s: NUMERIC[2]);
 BEGIN
  IF L_PDoc.PDocTotalFillMethod() = L_PDoc.pdtfm_byPDocMDoc THEN
   incTotal(PDoc.Total,   PDocMDoc.Total,   _s);
   incTotal(PDoc.NDS,     PDocMDoc.NDS,     _s);
   incTotal(PDoc.SaleTax, PDocMDoc.SaleTax, _s);
   REPLACE(PDoc);
  END;
 END {PDocMDoc_OnChangeSum};

 PRIVATE PROCEDURE PDocMDoc_OnBeforeInsert();
 BEGIN
  intSet_VATFieldFlagEdit(1);
 END {PDocMDoc_OnBeforeInsert};

 PRIVATE PROCEDURE PDocMDoc_OnBeforeEdit();
 BEGIN
  Set_VATFieldFlagEdit();
  PDocMDoc_OnChangeSum(-1);
 END {PDocMDoc_OnBeforeEdit};

 PRIVATE PROCEDURE PDocMDoc_OnBeforeDelete();
 BEGIN
  PDocMDoc_OnChangeSum(-1);
 END {PDocMDoc_OnBeforeDelete};

 PRIVATE PROCEDURE PDocMDoc_OnAfterEditInsert();
 BEGIN
  PDocMDoc_OnChangeSum(+1);
 END {PDocMDoc_OnAfterEditInsert};

 PRIVATE PROCEDURE PDocMDoc_OnAfterEdit();
 BEGIN
  PDocMDoc_OnAfterEditInsert();
 END {PDocMDoc_OnAfterEdit};

 PRIVATE PROCEDURE PDocMDoc_OnAfterInsert();
 BEGIN
  PDocMDoc_OnAfterEditInsert();
 END {PDocMDoc_OnAfterInsert};

 PRIVATE CONST
  tt_Pool    = "ᮡ 1|ᮡ 2";
  tt_Comment = [" 㬬  ''  㬭   樥",
                " 㬬  ''    ஢  뤠" +
                "  ࠧ,   ᫥"];

  tt_Coeff   = 0;
  tt_MaxSumm = 2;

 PUBLIC PROCEDURE PDTrunc_Show();
 BEGIN
  L_PDoc.AccessPDoc();
  L_General.Assert(~PDoc.Done, "㬥    ࠡ⠭");
  L_General.Assert(L_PDoc.IsSalPDoc(),
                   "楤 ਬ ⮫쪮  ௫ ⥦ 㬥⮢");
  LIKEMENU(Edit, "PDTrunc 0 " + RTI.Get().CurWindow.OriginalName + " 0");
 END {PDTrunc_Show};

 PRIVATE PROCEDURE PDTrunc_OnConformToWindow();
 BEGIN
  (* nothing *)
 END {PDTrunc_OnConformToWindow};

 PRIVATE PROCEDURE PDTrunc_SetFieldsModifiable();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  Fields("Coeff").Modifiable:=(Fields("Type").Value = tt_Coeff);
 END {PDTrunc_SetFieldsModifiable};

 PRIVATE PROCEDURE PDTrunc_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="PDoc";
  L_WDO.iWindow().OnOpenWindow:=1;
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit]);
  L_WDO.iField       (0, "Comment").LineBreakEnable:=1;
  L_WDO.iField       (0, "Type").Format:=tt_Pool;
  L_WDO.iScsChange   (0, ["Coeff", "TotalSum", "Comment", "Type"]);
  L_WDO.iUnmodifiable(0, ["Comment"]);
  L_WDO.iProgs       (0, "PDoc");
 END {PDTrunc_OnInitializeWindow};

 PRIVATE PROCEDURE PDTrunc_OnOpenWindow();
 BEGIN
  RTI.Get().CurWindow.Isolated:=FORM_WINDOW.Isolated_Full;
 END {PDTrunc_OnOpenWindow};

 PRIVATE PROCEDURE GetCommentByType(): STRING[];
 BEGIN
  RETURN tt_Comment[RTI.Get().CurWindow.Zones(0).Fields("Type").Value];
 END {GetComment};

 PRIVATE PROCEDURE PDTrunc_OnBeforeEdit();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  L_AFM.MakeMultipleIndex("tmpPDL", "TSN: LIKE(Staff.TSN);" +
                                   "Sum: LIKE(PDocList.Sum)",
                         "TSN: TSN;" +
                         "Sum: Sum");
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  Fields("TotalSum").Value   :=PDoc.Total;
  Fields("Coeff").Value      :=1.00;
  Fields("MinBanknote").Value:=P_OwnData.TruncTo(PDoc.Date);
  Fields("Type").Value       :=0;
  Fields("Comment").Value    :=GetCommentByType();
  PDTrunc_SetFieldsModifiable();
 END {PDTrunc_OnBeforeEdit};

 PRIVATE PROCEDURE SetCoeffByType();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF Fields("Type").Value = tt_Coeff THEN
   Fields("Coeff").Value:=Fields("TotalSum").Value/PDoc.Total;
  ELSE
   Fields("Coeff").Value:=1;
  END;
 END {SetCoeffByType};

 PRIVATE PROCEDURE PDTrunc_Type_OnSuccessfulChange();
  VAR
   curField: FORM_FIELD;
   Fields  : FORM_FIELDS;
 BEGIN
  Fields  :=RTI.Get().CurZone.Fields;
  curField:=RTI.Get().CurZone.ActiveField;
  Fields("Comment").Value:=GetCommentByType();
  SetCoeffByType();
  PDTrunc_SetFieldsModifiable();
 END {PDTrunc_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE PDTrunc_TotalSum_OnSuccessfulChange();
 BEGIN
  SetCoeffByType();
 END {PDTrunc_TotalSum_OnSuccessfulChange};

 PRIVATE PROCEDURE PDTrunc_Coeff_OnSuccessfulChange();
 BEGIN
  RTI.Get().CurZone.Fields("TotalSum").Value:=PDoc.Total * RTI.Get().CurZone.Fields("Coeff").Value;
 END {PDTrunc_Coeff_OnSuccessfulChange};

 PUBLIC PROCEDURE PDTrunc_OnAfterEdit();
  VAR
   Coef,
   MinSum,
   FullSum,
   MinBanknote: NUMERIC[3];
   PDLAmount  : NUMERIC[0];
   Fields     : FORM_FIELDS;
 BEGIN
  Fields     :=RTI.Get().CurWindow.Zones(0).Fields;
  MinBanknote:=Fields("MinBanknote").Value;
  IF Fields("Type").Value = tt_Coeff THEN
   SETZERO(PDoc.Total);
   Coef:=Fields("Coeff").Value;
   CONFORM(PDoc, PDocList);
   WHILE OCCURE(PDocList) DO
    PROMPT(PDocList.TSN);
    PDocList.Sum:=L_PRoll.TruncMoneyTo(PDocList.Sum * Coef, MinBanknote);
    REPLACE(PDocList);
    IF PDocList.State = L_PDoc.pdl_st_Paid THEN
     INC(PDoc.Total, PDocList.Sum);
    END;
    NEXT(PDocList);
   END; (* WHILE OCCURE(PDocList)... *)
  ELSE
   FullSum:=Fields("TotalSum").Value;
   L_General.Assert(PDoc.Total >= FullSum, "'' 㬬 㬥     'ன'");
   L_AFM.MakeMultipleIndex("tmpPDL", "TSN: LIKE(Staff.TSN);" +
                                     "Sum: LIKE(PDocList.Sum)",
                           "TSN: TSN;" +
                           "Sum: Sum");
   CONFORM(PDoc, PDocList);
   PDLAmount:=0;
   WHILE OCCURE(PDocList) DO
    PROMPT(PDocList.TSN);
    IF PDocList.State = L_PDoc.pdl_st_Paid THEN
     ADD(tmpPDL, TSN, , PDocList.TSN,
                        tmpPDL.Sum, PDocList.Sum);
     INC(PDLAmount);
    END;
    NEXT(PDocList);
   END; (* WHILE OCCURE(PDocList) ... *)

   SETZERO(PDoc.Total);
   SELECT(tmpPDL, Sum);
   WHILE OCCURE(tmpPDL) DO
    PROMPT(tmpPDL.TSN);
    MinSum:=L_PRoll.TruncMoneyTo(FullSum/PDLAmount, MinBanknote);
    L_General.CallUs(SEARCH(PDocList, PDoc, PDoc.PDocKind, PDoc.PDoc, tmpPDL.TSN));
    IF tmpPDL.Sum <= MinSum THEN
     PDocList.Sum:=L_PRoll.TruncMoneyTo(tmpPDL.Sum, MinBanknote);
    ELSE
     PDocList.Sum:=MinSum;
    END;
    DEC(FullSum, PDocList.Sum);
    INC(PDoc.Total, PDocList.Sum);
    REPLACE(PDocList);
    DEC(PDLAmount);
    NEXT(tmpPDL);
   END; (* WHILE OCCURE(tmpPDL) ... *)
  END;
  Fields("TotalSum").Value:=PDoc.Total;
  REPLACE(PDoc);
 END {PDTrunc_OnAfterEdit};

 PRIVATE PROCEDURE TuneSubwindow(winName, ttlPool, ttlCommon, stVar, stPool: STRING[]; Item: NUMERIC[0]): FORM_WINDOW;
  VAR
   fw: FORM_WINDOW;
   ff: FORM_FIELDS;
 BEGIN
  IF !RTI.Get().CurWindow THEN
   fw:=APP.Get().Forms.Load(winName, winName + "<INDEPENDENT>");
  ELSE
   fw:=APP.Get().Forms.Load(winName);
  END;
  ff:=fw.Zones(0).Fields;
  fw.Title:=L_Str.PoolItem(ttlPool, Item) + " " + ttlCommon;
  IF ~!stVar THEN
   ff(stVar).Value:=L_Str.PoolItem(stPool, Item);
  END;
  RETURN fw;
 END {TuneSubwindow};

 PRIVATE PROCEDURE PrepareWindow(VAR subWinName: STRING[]; ForInsert: SCAL[2]): FORM_WINDOW;
  VAR
   Suffix: STRING[];
   Result: FORM_WINDOW;
 BEGIN
  SETEMPTY(Result);
  AccessPDocKind();
  IF    (PDocKind.PDocKind = L_PDoc.pd_VPK) |
        (PDocKind.PDocKind = L_PDoc.pd_IPK) THEN
   subWinName:="PDocE12";
   Result:=TuneSubwindow(subWinName, "室|室", "⥦ ४஢", "v_PDocSide",
                         "⥫騪|⥫", PDocKind.PDocKind = L_PDoc.pd_IPK);
  ELSIF (PDocKind.PDocKind = L_PDoc.pd_VhP) |
        (PDocKind.PDocKind = L_PDoc.pd_IsP) THEN
   subWinName:="PDocE14";
   Result:=TuneSubwindow(subWinName, "室騩|室騩", "⥦ 稩", "v_PDocSide",
                         "⥫騪|⥫", PDocKind.PDocKind = L_PDoc.pd_IsP);
  ELSIF (PDocKind.PDocKind = L_PDoc.pd_ROO) |
        (PDocKind.PDocKind = L_PDoc.pd_POO) THEN
   subWinName:="PDocE19";
   Result:=TuneSubwindow(subWinName, "室|室", "थ 樮 ", "v_Operation",
                         "뤠|ਭ ", PDocKind.PDocKind = L_PDoc.pd_POO);
  ELSIF (PDocKind.PDocKind = L_PDoc.pd_AIN) |
        (PDocKind.PDocKind = L_PDoc.pd_AII) THEN
   subWinName:="PDocE18L";
   Result:=TuneSubwindow(subWinName, " ਧ樨 (誨)| ਧ樨 ()", "", "",
                         "", PDocKind.PDocKind = L_PDoc.pd_AIN);
  ELSIF  PDocKind.PDocKind = L_PDoc.pd_VTP THEN
   (*  짮  *)
   subWinName:="";
  ELSE
   IF    (PDocKind.PDocKind = L_PDoc.pd_VMO) |
         (PDocKind.PDocKind = L_PDoc.pd_IMO) |
         (PDocKind.PDocKind = L_PDoc.pd_ITP) |
         (PDocKind.PDocKind = L_PDoc.pd_OVN) |
         (PDocKind.PDocKind = L_PDoc.pd_CND) THEN
    Suffix:="";
   ELSIF (PDocKind.PDocKind = L_PDoc.pd_VPG) |
         (PDocKind.PDocKind = L_PDoc.pd_IPG) |
         (PDocKind.PDocKind = L_PDoc.pd_AVO) THEN
    Suffix:="M";
   ELSE
    IF (PDocKind.PDocKind = L_PDoc.pd_RKO) |
       (PDocKind.PDocKind = L_PDoc.pd_PKO) THEN
     Suffix:="L";
    ELSE
     Suffix:="M";
    END;
    IF ~ForInsert THEN
     L_PDoc.AccessPDoc();
     IF L_PDoc.IsSalPDoc() |
       ( SELECT(PDocList, PDoc, PDoc.PDocKind, PDoc.PDoc) &
        ~SELECT(PDocMDoc, PDoc, PDoc.PDocKind, PDoc.PDoc) &
        ~L_PDoc.IsPDocwMDoc() ) THEN
      Suffix:="L";
     ELSE
      Suffix:="M";
     END;
    END;
   END;
   subWinName:="PDocE" + PDocKind.PDocKind + Suffix;
  END;
  RETURN Result;
 END {PrepareWindow};

 PRIVATE PROCEDURE PDoc_1_OnSetSubwindow();
  VAR
   SubwindowName,
   CommonContextName: STRING[];
   dmyFW            : FORM_WINDOW;
 BEGIN
  RTI.Get().CurZone.HasVariousSubwindows:=1;
  dmyFW:=PrepareWindow(SubwindowName, RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert);
  RTI.Get().CurZone.SubwindowOriginalName:=SubwindowName;
  SETEMPTY(CommonContextName);
  IF    RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_ShowWin THEN
   CommonContextName:="ShowWin_PDoc";
  ELSIF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit) | (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert) THEN
   CommonContextName:="EdIns_PDoc";
  ELSE
   CommonContextName:="";
  END;
  RTI.Get().CurProcess.ReplaceContexts(CommonContextName);
 END {PDoc_1_OnSetSubwindow};

 PRIVATE PROCEDURE _CBPrintUploaded(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(E_PDoc.CBPrintUploaded), 1);
 END {_CBPrintUploaded};

 PRIVATE PROCEDURE PDoc_ExtAbout_OnBeforeAskForEdit();
 BEGIN
  LIKEMENU(Edit, "PDocExAb 0");
 END {PDoc_ExtAbout_OnBeforeAskForEdit};

 PRIVATE PROCEDURE PDoc_ExtAbout_OnSuccessfulChange();
 BEGIN
  L_ExtAb.CheckPDocExtAbout();
 END {PDoc_ExtAbout_OnSuccessfulChange};

 PUBLIC PROCEDURE MakeProtocol();
 BEGIN
  L_PDoc.AccessPDoc();
  L_XDR.sl_Init("奬 権");
  L_XDR.InitEntryList();
  L_XDR.PrepareEntryList(L_XDoc.xdt_PDoc, EMPTYOF(DATE), 0);
  L_XDR.OutEntryList(L_XDoc.xdt_PDoc);
  L_XDR.DeInitEntryList();
  L_XDR.sl_Done();
 END {MakeProtocol};

 PRIVATE PROCEDURE InsPDoc(): LIKE(PDoc.PDoc);
 BEGIN
  PDoc.mfNbr:=L_PDoc.Temporary_mfNbr(PDoc.MyFirm, PDoc.PDocKind, PDoc.Date, 1);
  SETEMPTY(PDoc.PDoc);
  SETZERO(PDoc.Total);
  L_PDoc.Insert_PDoc();
  RETURN PDoc.PDoc;
 END {InsPDoc};

 PUBLIC PROCEDURE SplitPD();
  VAR
   _SumPDocNew,
   _SumPDocOld,
   _SumLimit: NUMERIC[2];
   First    : SCAL[2];
   _PDocNew : LIKE(PDoc.PDoc);
 BEGIN
  L_PDoc.AccessPDoc();
  L_General.Assert(L_PDoc.IsSalPDoc() &
                   ((PDoc.PDocKind = L_PDoc.pd_IPP) | (PDoc.PDocKind = L_PDoc.pd_RKO)),
                   "楤 ਬ ⮫쪮  ௫   ");
  L_General.Assert(~PDoc.Done, "㬥    ࠡ⠭");
  L_General.Assert(PDoc.Status=L_PDoc.st_Prepared, "⥦ 㬥   '⮢'");

  L_PDoc.PDoc_OnAnyModification(-1, L_PDoc.np_No, 0);
  _SumLimit:=PDoc.Total;
  LOOP
   STDFORM(L_StdFrm.sf_Choice("| ⥦ 㬥 " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc) + "." +
                              "|                                       " +
                              "|%##################% %############%    " +
                              "|                                       " +
                              "| ନ஢  ⥦ 㬥" +
                              "|                                       ",
                              "%<  㬬>T %R<,2->I"),
           " '' ",
           STOP,
           ,
           _SumLimit);
   IF PDoc.Total > _SumLimit THEN
    EXIT;
   ELSE
    L_StdFrm.Inform("࠭祭 㬬    祬 㬬  "+FLDTOSTR(_SumLimit, "2-", 0));
   END;
  END; (* LOOP *)

  First:=1; SETZERO(_SumPDocOld, _SumPDocNew);
  SELECT(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc);
  WHILE OCCURE(PDocList) DO
   PROMPT(PDocList.TSN);
   IF PDocList.State = L_PDoc.pdl_st_Paid THEN
    INC(_SumPDocOld, PDocList.Sum);
    IF _SumPDocOld > _SumLimit THEN
     DEC(_SumPDocOld, PDocList.Sum);
     IF First THEN
      SAVE(PDoc);
      _PDocNew:=InsPDoc();
      First:=0;
      RESTORE(PDoc);
     END;
     SAVE(PDocList);
     PDocList.PDoc:=_PDocNew;
     INSERT(PDocList);
     INC(_SumPDocNew, PDocList.Sum);
     RESTORE(PDocList);
     REMOVE(PDocList);
    ELSE
     NEXT(PDocList);
    END;
   ELSE
    NEXT(PDocList);
   END;
  END; (* WHILE OCCURE(PDocList)... *)
  L_General.Assert(_SumPDocOld > 0, " ࠧ   㬬 "+FLDTOSTR(_SumLimit, ",2-"));
  PDoc.Total:=_SumPDocOld;
  REPLACE(PDoc);
  L_PDoc.PDoc_OnAnyModification(+1, L_PDoc.np_Try, 0);

  L_General.CallUs(SEARCH(PDoc, PDoc, PDoc.PDocKind, _PDocNew));
  PDoc.Total:=_SumPDocNew;
  REPLACE(PDoc);
  L_PDoc.PDoc_OnAnyModification(+1, L_PDoc.np_Try, 0);

  L_StdFrm.Inform("ନ஢   : "+L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc)+
                  "| 㬬 "+FLDTOSTR(PDoc.Total, ",2-"));
 END {SplitPD};

 PUBLIC PROCEDURE ChangeAccPDocInDatePos();
  VAR
   curDoneDTS,
   trgDoneDTS  : LIKE(PDoc.DoneDTS);
   Prefix,
   sPDocDTS,
   curPDocStr: STRING[];
   curXDocId : L_XDoc.tXDocId;
   curMyFirm : P_Firm.tMyFirm;
   Need: SCAL[2];
 BEGIN
  L_PDoc.AccessPDoc();
  L_General.Assert(L_Pmnt.IsAccountableManPDoc(), "ਬ ⮫쪮   ⮢  묨 栬");
  L_General.Assert(PDoc.Status = L_PDoc.st_Passed, "㬥    ﭨ '஢'");

  curDoneDTS:=PDoc.DoneDTS;
  curMyFirm :=PDoc.MyFirm;
  curXDocId :=PDoc.XDocId;
  curPDocStr:=L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc);
  CONFORM(PDoc, PDocList);
  L_General.Assert(OCCURE(PDocList), " 㬥  㪠 ⭮ ");
  CONFORM(PDocList, Staff);
  CONFORM(Staff, Man);

  L_XDoc.sl_Init(" ।   ⭮  "+L_Man.Man_ManAsStr()+"  ");

  Need:=0;
  SAVE(PDoc);

  L_Pmnt.PrepareAccountableManBalanceHistory(Staff.Man, PDoc.MyFirm, PDoc.Date, PDoc.Date);
  SELECT(CnBHs, CnBHs, , L_XObj.GetManXObject(Staff.Man, PDoc.MyFirm));
  WHILE OCCURE(CnBHs) DO
   IF (CnBHs.XDocId # MAXOF(L_XDoc.tXDocId)) &
      (L_XDoc.ExtractXDocType(CnBHs.XDocId) = L_XDoc.xdt_PDoc) THEN
    IF CnBHs.XDocId = curXDocId THEN
     Prefix:="> ";
    ELSE
     Prefix:="  ";
     Need:=1;
    END;
    IF CnBHs.DoneDTS # L_XDoc.max_DoneDTS THEN
     sPDocDTS:=L_Str.DTSStr(CnBHs.DoneDTS);
    ELSE
     sPDocDTS:="--.--.---- --:--:--.---";
    END;
    L_XDoc.sl_AddItem(CnBHs.XDocId, Prefix+L_XDoc.extXDocStr(CnBHs.XDocId, L_XDoc.xdast_wStatus)+" ("+sPDocDTS+ ")");
   END; (* IF L_XDoc.ExtractXDocType(CnBHs.XDocId) ... *)
   NEXT(CnBHs);
  END; (* WHILE OCCURE(CnBHs) ... *)

  IF ~Need THEN
   L_StdFrm.BlueHalt("  易 㬥⮢  ");
  END;
  L_XDoc.sl_Show();
  L_General.Assert(L_XDoc.pvs_XDocId # curXDocId, " ⥪騩 㬥");
  L_XDoc.PositionOnXDoc(L_XDoc.pvs_XDocId);
  L_General.Assert(PDoc.DoneDTS # L_XDoc.max_DoneDTS, " 㬥    ");
  L_StdFrm.Choice(" 冷 ᫥ 㬥⮢ "+curPDocStr+"  "+
                  L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
  trgDoneDTS:=PDoc.DoneDTS;
  PDoc.DoneDTS:=curDoneDTS;
  REPLACE(PDoc);
  RESTORE(PDoc);
  PDoc.DoneDTS:=trgDoneDTS;
  REPLACE(PDoc);
 END {ChangeAccPDocInDatePos};

 PUBLIC PROCEDURE StreamMakeDone();
 BEGIN
  ProceedPDoc(1, +1, 1);
 END {StreamMakeDone};

 PUBLIC PROCEDURE StreamMakeUnDone();
 BEGIN
  ProceedPDoc(0, -1, 1);
 END {StreamMakeUnDone};

 PUBLIC PROCEDURE SingleMakeDone();
 BEGIN
  ProceedPDoc(1, +1, 0);
 END {SingleMakeDone};

 PUBLIC PROCEDURE SingleMakeUnDone();
 BEGIN
  ProceedPDoc(0, -1, 0);
 END {SingleMakeUnDone};

 PUBLIC PROCEDURE InternalMakeProtocol();
 BEGIN
  ProceedPDoc(1, 0, 0);
 END {InternalMakeProtocol};

 PRIVATE PROCEDURE Any_OnConformToWindow(_PDocKind: LIKE(PDocKind.PDocKind));
  VAR
   envXDocId: ENVVAR;
 BEGIN
  envXDocId:=L_WDO.fz_AccessEnvVar(RTI.Get().TrgWindow.Zones(0), "trgXDocId");
  IF ~!envXDocId THEN
   L_XDoc.PositionOnXDoc(envXDocId.Value);
  ELSE
   SELECT(PDoc, PDoc, , _PDocKind);
  END;
  SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, PDoc);
  SE_WZD_CURSOR(RTI.Get().TrgWindow.Name, 0, PDoc);
 END {Any_OnConformToWindow};

 PRIVATE PROCEDURE PDocE19_OnConformToWindow();
  VAR
   envXDocId: ENVVAR;
 BEGIN
  envXDocId:=L_WDO.fz_AccessEnvVar(RTI.Get().TrgWindow.Zones(0), "trgPDocKind");
  IF ~!envXDocId THEN
   Any_OnConformToWindow(envXDocId.Value);
  ELSE
   Any_OnConformToWindow(L_PDoc.pd_ROO);
  END;
 END {PDocE19_OnConformToWindow};

 PRIVATE PROCEDURE PDocE01L_OnConformToWindow();
 BEGIN
  Any_OnConformToWindow(L_PDoc.pd_RKO);
 END {PDocE01L_OnConformToWindow};

 PRIVATE PROCEDURE PDocE02M_OnConformToWindow();
 BEGIN
  Any_OnConformToWindow(L_PDoc.pd_PKO);
 END {PDocE02M_OnConformToWindow};

 PRIVATE PROCEDURE PDocE02L_OnConformToWindow();
 BEGIN
  Any_OnConformToWindow(L_PDoc.pd_PKO);
 END {PDocE02L_OnConformToWindow};

 PRIVATE CONST
  acspnt_MayAccess2AllPDoc = 0000042;

 PUBLIC PROCEDURE curUSERHasAccess2AllPDocKind(): SCAL[2];
 BEGIN
  RETURN L_AcsPnt.MayPassAccessPoint(acspnt_MayAccess2AllPDoc);
 END {curUSERHasAccess2AllPDocKind};

 PUBLIC PROCEDURE E_GetAllowedOprDsk(VAR trgMyFirm  : LIKE(MyFirm.MyFirm);
                                     VAR trgFirmAcnt: LIKE(FirmAcnt.FirmAcnt));
  VAR
   Filter: STRING[];
   i     : NUMERIC[0];
 BEGIN
  IF ~curUSERHasAccess2AllPDocKind() THEN
   Filter:="";
   SELECT(PDocKind, PDocKind);
   WHILE OCCURE(PDocKind) DO
    IF (L_PDoc.MoneyKind(PDocKind.PDocKind) # L_PDoc.mk_OprDskCash) &
       (L_PDoc.MoneyKind(PDocKind.PDocKind) # L_PDoc.mk_Cash      ) THEN
     IF ~!Filter THEN
      Filter:=Filter + "&";
     END;
     Filter:=Filter + "(PDocKind.PDocKind#" + PDocKind.PDocKind + ")";
    END;
    NEXT(PDocKind);
   END; (* WHILE OCCURE(PDocKind) ... *)
   TABLE.Get("PDocKind").Filter:=Filter;
  END;
  L_AR.GrantRightsUnconditionally();
(*
  i:=0;
  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF (MyFirm.MyFirm # P_MyFirm.mf_Fict) & L_DatTim.IsActive(SYSDATE(), MyFirm.Begin, MyFirm.Till) THEN
    SELECT(FirmAcnt, Firm, , MyFirm.Firm);
    WHILE OCCURE(FirmAcnt) DO
     IF (FirmAcnt.Type = L_PDoc.fat_OprCashDsk) & L_DatTim.IsActive(SYSDATE(), FirmAcnt.Begin, FirmAcnt.Till) THEN
      List:=List + MyFirm.Sign + " " + FirmAcnt.FirmAcnt + " " + FirmAcnt.Name + "|";
      INC(i);
     END;
     NEXT(FirmAcnt);
    END; (* WHILE OCCURE(FirmAcnt) ... *)
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
*)
  IF L_PDoc.dodAssigned THEN
   trgMyFirm  :=L_PDoc.dodMyFirm;
   trgFirmAcnt:=L_PDoc.dodFirmAcnt;
  ELSE
   L_General.Error(" ⠭ '樮   㬮砭'");
  END;
 END {E_GetAllowedOprDsk};

 PRIVATE PROCEDURE OprDskPDoc_OnEdIns(trgPDocKind: LIKE(PDocKind.PDocKind);
                                      trgMyFirm  : LIKE(MyFirm.MyFirm);
                                      trgFirmAcnt: LIKE(FirmAcnt.FirmAcnt);
                                      InsMode    : SCAL[2]);
  VAR
   trgWindow    : FORM_WINDOW;
   trgWindowName: STRING[];
 BEGIN
  SEARCH(PDocKind, PDocKind, , trgPDocKind);
  trgWindow:=PrepareWindow(trgWindowName, InsMode);
  IF !trgWindow THEN
   trgWindow:=APP.Get().Forms.Load(trgWindowName, trgWindowName + "<INDEPENDENT>", EMPTYOF(FORM_ZONE));
  END;
  trgWindow.WLevProg:="PDoc";
  IF InsMode THEN
   LIKEMENU(Ins, trgWindow.Name + " 0 @" + " trgPDocKind=" + trgPDocKind +
                                           " trgMyFirm="   + trgMyFirm +
                                           " trgFirmAcnt=" + trgFirmAcnt);
  ELSE
   LIKEMENU(ShowWin, trgWindow.Name + " 0 @" + " trgXDocId=" + L_XDoc.curXDocId(L_XDoc.xdt_PDoc));
  END;
 END {OprDskPDoc_OnEdIns};

 PUBLIC PROCEDURE CreateNewOprDskPDoc(_PDocKind: LIKE(PDoc.PDocKind));
  VAR
   trgMyFirm  : LIKE(MyFirm.MyFirm);
   trgFirmAcnt: LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  E_GetAllowedOprDsk(trgMyFirm, trgFirmAcnt);
  IF ~!trgFirmAcnt THEN
   OprDskPDoc_OnEdIns(_PDocKind, trgMyFirm, trgFirmAcnt, 1);
  END;
 END {CreateNewOprDskPDoc};

 PRIVATE PROCEDURE sodp_SinglePDocKind(_PDocKind  : LIKE(PDocKind.PDocKind);
                                       B,
                                       E          : DATE;
                                       trgMyFirm  : LIKE(MyFirm.MyFirm);
                                       trgFirmAcnt: LIKE(FirmAcnt.FirmAcnt));
 BEGIN
  SETSEL(PDoc, PDKDate, _PDocKind);
  SRCINSEL(PDoc, GE, , B);
  WHILE OCCURE(PDoc) & (PDoc.Date <= E) DO
   IF PDoc.MyFirm = trgMyFirm THEN
    IF (L_PDoc.MoneyKind(_PDocKind) = L_PDoc.mk_OprDskCash) & (PDoc.OwnAcnt  = trgFirmAcnt) |
       (L_PDoc.MoneyKind(_PDocKind) = L_PDoc.mk_Cash)       & (PDoc.FirmAcnt = trgFirmAcnt) THEN
     sodp.XDocId :=PDoc.XDocId;
     sodp.DoneDTS:=PDoc.DoneDTS;
     sodp.Date   :=PDoc.Date;
     INSERT(sodp);
    END;
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc) ... *)
 END {sodp_SinglePDocKind};

 PUBLIC PROCEDURE ShowOprDskPDocs(InPeriod: SCAL[2]);
  VAR
   B,
   E          : DATE;
   trgMyFirm  : LIKE(MyFirm.MyFirm);
   trgFirmAcnt: LIKE(FirmAcnt.FirmAcnt);
   Title      : STRING[];
 BEGIN
  IF InPeriod THEN
   E:=Memo.ud_ut();
   B:=Memo.ud_fr();
   Title:="㬥   ਮ";
  ELSE
   E:=SYSDATE();
   B:=E-1;
   Title:="㬥   ᫥  ";
  END;
  E_GetAllowedOprDsk(trgMyFirm, trgFirmAcnt);
  L_AFM.MakeMultipleIndex("sodp", "XDocId : LIKE(PDoc.XDocId);"+
                                  "DoneDTS: FLOAT;"+
                                  "Date   : DATE;",
                           "toShow: Date, DoneDTS, XDocId");
  sodp_SinglePDocKind(L_PDoc.pd_POO, B, E, trgMyFirm, trgFirmAcnt);
  sodp_SinglePDocKind(L_PDoc.pd_ROO, B, E, trgMyFirm, trgFirmAcnt);
  sodp_SinglePDocKind(L_PDoc.pd_PKO, B, E, trgMyFirm, trgFirmAcnt);
  IF SELECT(sodp, toShow) THEN
   L_XDoc.sl_Init(Title);
   WHILE OCCURE(sodp) DO
    L_XDoc.sl_AddItem(sodp.XDocId, L_XDoc.extXDocStr(sodp.XDocId, L_XDoc.xdast_wStatus));
    NEXT(sodp);
   END;
   L_XDoc.sl_Show();
   L_XDoc.PositionOnXDoc(L_XDoc.pvs_XDocId);
   OprDskPDoc_OnEdIns(PDoc.PDocKind, trgMyFirm, trgFirmAcnt, 0);
  ELSE
   L_StdFrm.Inform(" " + L_DatTim.DateStr(B) + "    㬥");
  END;
 END {ShowOprDskPDocs};

 PUBLIC PROCEDURE ShowOprDskRest();
  VAR
   trgMyFirm  : LIKE(MyFirm.MyFirm);
   trgFirmAcnt: LIKE(FirmAcnt.FirmAcnt);
   outSaldo   : L_XObj.tSum;
 BEGIN
  E_GetAllowedOprDsk(trgMyFirm, trgFirmAcnt);
  L_PDoc.AccessmfBnkAcn(trgMyFirm, trgFirmAcnt);
  CONFORM(mfBnkAcn, XObject);
  outSaldo:=L_XObj.mo_GetOutSaldo(L_kn.Get(SYSDATE(), L_AcCut.erkn_OperationalCashOffices), L_DatTim.Per(SYSDATE()));
  L_StdFrm.Inform("  楢  ⥪騩 ⮪ " + FLDTOSTR(outSaldo, "2-", 0));
 END {ShowOprDskRest};

 PRIVATE PROCEDURE SDfOprDs_SetupFields();
 BEGIN
  RTI.Get().CurZone.Fields("ff_FirmAcnt").Modifiable:=RTI.Get().CurZone.Fields("ff_Assigned").Value;
 END {SDfOprDs_SetupFields};

 PRIVATE PROCEDURE SDfOprDs_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit]);
  L_WDO.iField       (0, "ff_Assigned").Value :=L_PDoc.dodAssigned;
  L_WDO.iField       (0, "ff_Assigned").Format:="-|";
  L_WDO.iField       (0, "ff_MyFirm").Value     :=L_PDoc.dodMyFirm;
  L_WDO.iField       (0, "ff_Firm").Value  :=P_Firm.fomf(L_WDO.iField(0, "ff_MyFirm").Value);
  L_WDO.iField       (0, "ff_Firm").Visible:=0;
  L_WDO.iField       (0, "ff_FirmAcnt").Value:=L_PDoc.dodFirmAcnt;
  L_WDO.iField       (0, "ff_Firm").OnBeforeAsk:=1;
  L_WDO.iField       (0, "ff_Firm").AskMode:=FORM_FIELD.AskMode_Manual;
  L_WDO.iField       (0, "ff_FirmAcnt").OnBeforeAsk:=1;
  L_WDO.iScsChange   (0, ["ff_Firm", "ff_FirmAcnt", "ff_MyFirm", "ff_Assigned"]);
  L_WDO.iUnmodifiable(0, ["ff_FirmAcnt_Name"]);
  L_WDO.iProgs       (0, "PDoc");
  L_WDO.CreateFormLink("FirmAcnt", "ff_");
 END {SDfOprDs_OnInitializeWindow};

 PRIVATE PROCEDURE SDfOprDs_ff_FirmAcnt_OnBeforeAsk();
  VAR
   trgWindow: FORM_WINDOW;
 BEGIN
  trgWindow:=APP.Get().Forms.Load("FirmAcnt", "FirmAcnt<Ask>");
  trgWindow.Zones(1).PermanentFilter:="(FirmAcnt.Type=" + L_Str.IntStr(P_Firm.fat_OprCashDsk) + ")";
 END {SDfOprDs_ff_FirmAcnt_OnBeforeAsk};

 PRIVATE PROCEDURE SDfOprDs_OnBeforeEdit();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("ff_Assigned").Value   :=L_PDoc.dodAssigned;
  Fields("ff_MyFirm").Value     :=L_PDoc.dodMyFirm;
  Fields("ff_FirmAcnt").Value   :=L_PDoc.dodFirmAcnt;
  Fields("ff_MyFirm").Modifiable:=0;
  SDfOprDs_SetupFields();
 END {SDfOprDs_OnBeforeEdit};

 PRIVATE PROCEDURE SDfOprDs_ff_Assigned_OnSuccessfulChange();
 BEGIN
  SDfOprDs_SetupFields();
 END {SDfOprDs_ff_Assigned_OnSuccessfulChange};

 PRIVATE PROCEDURE SDfOprDs_ff_FirmAcnt_OnSuccessfulChange();
  VAR
   Fields  : FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_General.CallUs(SEARCH(FirmAcnt, FirmAcnt, Fields("ff_Firm").Value, Fields("ff_FirmAcnt").Value));
  IF FirmAcnt.Type # P_Firm.fat_OprCashDsk THEN
   L_General.Error("⨬ 롮 -   樮 ");
  END;
 END {SDfOprDs_ff_FirmAcnt_OnSuccessfulChange};

 PRIVATE PROCEDURE SDfOprDs_OnAfterEdit();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_PDoc.dodAssigned:=Fields("ff_Assigned").Value;
  L_PDoc.dodMyFirm  :=Fields("ff_MyFirm").Value;
  L_PDoc.dodFirmAcnt:=Fields("ff_FirmAcnt").Value;

  L_SES.PutValueAtCurTrn(L_SES.sit_User, "L_PDoc.dodAssigned", L_PDoc.dodAssigned);
  L_SES.PutValueAtCurTrn(L_SES.sit_User, "L_PDoc.dodMyFirm",   L_PDoc.dodMyFirm);
  L_SES.PutValueAtCurTrn(L_SES.sit_User, "L_PDoc.dodFirmAcnt", L_PDoc.dodFirmAcnt);
 END {SDfOprDs_OnAfterEdit};

 PRIVATE PROCEDURE PDocKind_OnAnyModification();
 BEGIN
  (* 0078979   㤠 25.06.2010 11:37:42 POLAK\MLB *)
 END {PDocKind_OnAnyModification};

 PRIVATE PROCEDURE PDocKind_OnAfterEdit();
 BEGIN
  PDocKind_OnAnyModification();
 END {PDocKind_OnAfterEdit};

 PRIVATE PROCEDURE PDocKind_OnAfterInsert();
 BEGIN
  PDocKind_OnAnyModification();
 END {PDocKind_OnAfterInsert};

 PRIVATE PROCEDURE PDocKind_OnBeforeDelete();
 BEGIN
  PDocKind_OnAnyModification();
 END {PDocKind_OnBeforeDelete};

 PRIVATE PROCEDURE PDoc_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().OnOpenWindow :=1;
  L_WDO.iField       (0, "PDoc.Comment").LineBreakEnable:=1;
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete, L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).Narrowing:="PDoc.PDocKind = PDocKind.PDocKind";
  L_WDO.iField       (1, "PDoc.PDoc").ReverseSorting:=1;
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iProgs       (2, "PDoc");
 END {PDoc_OnInitializeWindow};

 PRIVATE PROCEDURE PDoc_OnOpenWindow();
 BEGIN
  L_AcsPnt.PassAccessPoint(acspnt_MayAccess2AllPDoc);
 END {PDoc_OnOpenWindow};

 PRIVATE PROCEDURE PDocEXXM_OnIntializePDocMDocZone(zNum: NUMERIC[1]);
 BEGIN
  L_WDO.iSubwindow   (zNum, "PDMDE");
  L_WDO.iField       (zNum, "PDocMDoc.MDocKind").OwnerWindowOriginalName:="MDocEI";
  L_WDO.iField       (zNum, "PDocMDoc.MDocKind").OwnerZoneNumber:=2;
  L_WDO.iField       (zNum, "PDocMDoc.MDoc").OwnerWindowOriginalName:="MDocEI";
  L_WDO.iField       (zNum, "PDocMDoc.MDoc").OwnerZoneNumber:=1;
  L_WDO.iMayBeEmpty  (zNum, ["PDocMDoc.NDS"]);
 END {PDocEXXM_OnIntializePDocMDocZone};

 PRIVATE PROCEDURE PDocEXX_OnIntializemfBnkAcnZones(z1Num, z2Num: NUMERIC[1]);
 BEGIN
  L_WDO.iZone        (z1Num).ViewOnly:=1;
  L_WDO.iZone        (z1Num).Narrowing:="(mfBnkAcn.FirmAcnt=PDoc.OwnAcnt)&(mfBnkAcn.MyFirm=PDoc.MyFirm)";
  L_WDO.iZone        (z2Num).ViewOnly:=1;
  L_WDO.iZone        (z2Num).Narrowing:="(mfBnkAcn.MyFirm=PDoc.MyFirm)&(mfBnkAcn.FirmAcnt=PDoc.OwnAcnt)";
 END {PDocEXX_OnIntializemfBnkAcnZones};

 PRIVATE PROCEDURE PDocExx_OnInitializeWindow();
  VAR
   f: FORM_FIELD;
 BEGIN
  L_WDO.iWindow().MNUFileName:="PDoc";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["PDoc.Dest", "PDoc.mfNbr", "PDoc.Status", "PDoc.Total"]);
  L_WDO.iField       (0, "PDoc.Status").Format:=L_PDoc.st_Pool;
  f:=L_WDO.iField(0, "PDoc.PDoc");               f.Modifiable:=0;
  f:=L_WDO.iField(0, "PDoc.Date");               f.Modifiable:=1;
  f:=L_WDO.iField(0, "PDoc.Dest");               f.Modifiable:=1;
  f:=L_WDO.iField(0, "PDocStatus2"); IF ~!f THEN f.Modifiable:=0; END;
  f:=L_WDO.iField(0, "PDoc.SrcNbr"); IF ~!f THEN f.Modifiable:=1; END;
  f:=L_WDO.iField(0, "PDoc.NDS");
  IF ~!f THEN
   f.OnSuccessfulChange:=1;
   f.MustBeNonempty:=0;
  END;
  f:=L_WDO.iField(0, "PDoc.ExtAbout");
  IF ~!f THEN
   f.MustBeNonempty:=0;
   f.OnSuccessfulChange:=1;
   f.OnBeforeAsk:=1;
   f.AskMode:=FORM_FIELD.AskMode_Manual;
  END;
  f:=L_WDO.iField(0, "PDoc.OwnAcnt");
  IF ~!f THEN
   f.OnSuccessfulChange:=1;
   f.OnBeforeAsk:=1;
   f.AskMode:=FORM_FIELD.AskMode_Manual;
   f.OwnerWindowOriginalName:="OwnAcnt";
   f.OwnerZoneNumber:=1;
  END;
 END {PDocExx_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE01L_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.Dest").First:=1;
  L_WDO.iScsChange   (0, ["PDoc.Type", "PDoc.Date"]);
  L_WDO.iMayBeEmpty  (0, ["PDocAbout_2", "PDocAbout_0"]);
  L_WDO.iField       (0, "PDoc.Type").Format:=L_PDoc.typSalPDoc_pool;
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (1, ["PDocList.State"]);
 END {PDocE01L_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE01M_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.Dest").First:=1;
  L_WDO.iScsChange   (0, ["PDoc.Type", "PDoc.Date"]);
  L_WDO.iMayBeEmpty  (0, ["PDocAbout_2", "PDocAbout_0"]);
  L_WDO.iField       (0, "PDoc.Type").Format:=L_PDoc.typSalPDoc_pool;
  PDocEXXM_OnIntializePDocMDocZone(1);
 END {PDocE01M_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE02L_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.Dest").First:=1;
  L_WDO.iMayBeEmpty  (0, ["PDocAbout_0", "PDocAbout_2"]);
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
 END {PDocE02L_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE02M_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.FirmAcnt").OwnerWindowOriginalName:="OwnAcnt";
  L_WDO.iField       (0, "PDoc.Dest").First:=1;
  L_WDO.iScsChange   (0, ["PDoc.FirmAcnt"]);
  L_WDO.iMayBeEmpty  (0, ["PDocAbout_0", "PDocAbout_2"]);
  PDocEXXM_OnIntializePDocMDocZone(1);
 END {PDocE02M_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE03L_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.Comment").LineBreakEnable:=0;
  L_WDO.iField       (0, "PDoc.FirmAcnt").OwnerWindowOriginalName:="XFA";
  L_WDO.iField       (0, "PDoc.Dest").First:=1;
  L_WDO.iScsChange   (0, ["PDoc.Type", "PDoc.Firm", "PDoc.Date"]);
  L_WDO.iField       (0, "PDoc.Type").Format:=L_PDoc.typSalPDoc_pool;
  L_WDO.iField       (0, "P_Comment").LineBreakEnable:=1;
  L_WDO.iField       (0, "P_Comment").MustBeNonempty :=0;
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  PDocEXX_OnIntializemfBnkAcnZones(2, 3);
 END {PDocE03L_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE03M_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.Comment").LineBreakEnable:=0;
  L_WDO.iField       (0, "PDoc.FirmAcnt").OnBeforeAsk:=1;
  L_WDO.iField       (0, "PDoc.Dest").First:=1;
  L_WDO.iScsChange   (0, ["PDoc.Type", "PDoc.Firm", "PDoc.Date"]);
  L_WDO.iField       (0, "PDoc.Type").Format:=L_PDoc.typSalPDoc_pool;
  L_WDO.iField       (0, "P_Comment").LineBreakEnable:=1;
  L_WDO.iField       (0, "P_Comment").MustBeNonempty :=0;
  PDocEXXM_OnIntializePDocMDocZone(1);
  PDocEXX_OnIntializemfBnkAcnZones(2, 3);
 END {PDocE03M_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE04L_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.SrcNbr").First:=1;
  L_WDO.iScsChange   (0, ["PDoc.Firm"]);
  L_WDO.iMayBeEmpty  (0, ["PDoc.Comment", "PDoc.Queue", "PDoc.FirmAcnt", "PDoc.PrpDate", "PDoc.Dest", "P_Comment"]);
  L_WDO.iField       (0, "P_Comment").LineBreakEnable:=1;
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  PDocEXX_OnIntializemfBnkAcnZones(2, 3);
 END {PDocE04L_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE04M_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.SrcNbr").First:=1;
  L_WDO.iScsChange   (0, ["PDoc.Firm"]);
  L_WDO.iMayBeEmpty  (0, ["PDoc.Comment", "PDoc.Queue", "PDoc.FirmAcnt", "PDoc.PrpDate", "PDoc.Dest", "P_Comment"]);
  L_WDO.iField       (0, "P_Comment").LineBreakEnable:=1;
  PDocEXXM_OnIntializePDocMDocZone(1);
  PDocEXX_OnIntializemfBnkAcnZones(2, 3);
 END {PDocE04M_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE05_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.SrcNbr").First:=1;
  L_WDO.iScsChange   (0, ["PDoc.Firm"]);
  L_WDO.iMayBeEmpty  (0, ["PDoc.Dest", "PDoc.Queue", "PDoc.FirmAcnt"]);
  PDocEXXM_OnIntializePDocMDocZone(1);
  PDocEXX_OnIntializemfBnkAcnZones(3, 4);
 END {PDocE05_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE06_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.SrcNbr").First:=1;
  L_WDO.iScsChange   (0, ["PDoc.Firm"]);
  L_WDO.iMayBeEmpty  (0, ["PDoc.FirmAcnt", "PDoc.Dest", "PDoc.Queue"]);
  PDocEXXM_OnIntializePDocMDocZone(1);
  PDocEXX_OnIntializemfBnkAcnZones(3, 4);
 END {PDocE06_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE07_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.SrcNbr").First:=1;
  L_WDO.iScsChange   (0, ["PDoc.Firm"]);
  L_WDO.iMayBeEmpty  (0, ["PDoc.Queue", "PDoc.FirmAcnt", "PDoc.SrcNbr"]);
 END {PDocE07_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE09_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iMayBeEmpty  (0, ["PDocAbout_0", "PDoc.Dest"]);
  PDocEXXM_OnIntializePDocMDocZone(1);
  PDocEXX_OnIntializemfBnkAcnZones(2, 3);
  L_WDO.iEvents      (4, [L_WDO.e_OnAnyModification]);
 END {PDocE09_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE10_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.SrcNbr").First:=1;
  L_WDO.iMayBeEmpty  (0, ["PDocAbout_0"]);
  PDocEXXM_OnIntializePDocMDocZone(1);
  PDocEXX_OnIntializemfBnkAcnZones(2, 3);
  L_WDO.iEvents      (4, [L_WDO.e_OnAnyModification]);
 END {PDocE10_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE11M_OnInitializeWindow();
  VAR
   f: FORM_FIELD;
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iUnmodifiable(0, ["pdlManName"]);
  L_WDO.iMayBeEmpty  (0, ["PDocAbout_1", "PDocAbout_2"]);
  f:=L_WDO.iField(0, "pdlTSN");
  f.OwnerWindowOriginalName:="Staff_A";
  f.OwnerZoneNumber        :=1;
  f.First                  :=1;
  f.OnSuccessfulChange     :=1;
  PDocEXXM_OnIntializePDocMDocZone(1);
  L_WDO.CreateFormLink("Staff", "pdl");
 END {PDocE11M_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE12_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iScsChange   (0, ["PDoc.Firm"]);
  L_WDO.iUnmodifiable(0, ["v_PDocSide"]);
  L_WDO.iMayBeEmpty  (0, ["PDoc.Comment", "PDoc.SrcNbr"]);
  PDocEXXM_OnIntializePDocMDocZone(1);
 END {PDocE12_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE14_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.PrpDate").First:=1;
  L_WDO.iUnmodifiable(0, ["v_PDocSide"]);
  L_WDO.iMayBeEmpty  (0, ["PDoc.Comment"]);
  PDocEXXM_OnIntializePDocMDocZone(1);
  L_WDO.iEvents      (2, [L_WDO.e_OnAnyModification]);
 END {PDocE14_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE16M_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.SrcNbr").First:=1;
  L_WDO.iScsChange   (0, ["PDoc.Firm"]);
  L_WDO.iMayBeEmpty  (0, ["PDoc.FirmAcnt"]);
  PDocEXXM_OnIntializePDocMDocZone(1);
  PDocEXX_OnIntializemfBnkAcnZones(2, 3);
 END {PDocE16M_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE17M_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.SrcNbr").First:=1;
  L_WDO.iScsChange   (0, ["PDoc.Firm"]);
  L_WDO.iMayBeEmpty  (0, ["PDoc.FirmAcnt", "PDoc.Dest"]);
  PDocEXXM_OnIntializePDocMDocZone(1);
  PDocEXX_OnIntializemfBnkAcnZones(2, 3);
 END {PDocE17M_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE18L_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.Dest").First:=1;
  L_WDO.iMayBeEmpty  (0, ["PDocAbout_0", "PDocAbout_1", "PDocAbout_2"]);
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  L_WDO.iField       (1, "PDocList.Sum").Last:=1;
 END {PDocE18L_OnInitializeWindow};

 PRIVATE PROCEDURE PDocE19_OnInitializeWindow();
 BEGIN
  PDocExx_OnInitializeWindow();
  L_WDO.iField       (0, "PDoc.Dest").First:=1;
  L_WDO.iUnmodifiable(0, ["v_Operation"]);
  L_WDO.iMayBeEmpty  (0, ["PDocAbout_2", "PDocAbout_0"]);
  PDocEXXM_OnIntializePDocMDocZone(1);
  L_WDO.iField       (2, "PDocList.Sum").Last:=1;
  L_WDO.iZone        (3).ViewOnly:=1;
  L_WDO.iZone        (3).Narrowing:="(mfBnkAcn.MyFirm=PDoc.MyFirm)&(mfBnkAcn.FirmAcnt=PDoc.OwnAcnt)";
 END {PDocE19_OnInitializeWindow};

 PUBLIC PROCEDURE DistributePayment();
 BEGIN
  L_Pmnt.DistributePayment();
 END {DistributePayment};

 PUBLIC PROCEDURE FillPDocAbout();
 BEGIN
  IF ~!L_PDoc.GetPDocComment() THEN
   L_StdFrm.Choice(" ⥪  '祭 ⥦'?");
  END;
  L_PDoc.FillPDocAbout();
 END {FillPDocAbout};

 PRIVATE PROCEDURE PDocPro_0_OnReposition();
 BEGIN
  CALL(ObjPro.UpdateCurObjectVal2Show("PDoc", "PDocPro"));
 END {PDocPro_0_OnReposition};

 PRIVATE PROCEDURE CheckIfIsSent(trgAction: LIKE(XDocJrn.Action));
 BEGIN
  IF L_XDoc.XDocIsSent(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
   L_StdFrm.CrucialChoice("㬥  ࠢ", L_APtm.g_Acnt);
  END;
 END {CheckIfIsSent};

 PRIVATE PROCEDURE intPrint(Stream, Preview: SCAL[2]);
 BEGIN
  IF ~Stream THEN
   RTI.Get().TryBlock.AccessDataMode  :=adm_SOFT;
   TABLE.Get("XCalc"  ).AccessDataMode:=adm_RIDGE;
   TABLE.Get("XApport").AccessDataMode:=adm_RIDGE;
   TABLE.Get("XODone" ).AccessDataMode:=adm_RIDGE;
  END;

  ACCESS(PDoc);
  CheckCurPer(0, Stream);

  IF ~Stream THEN
   IF Preview THEN
    CALL(PDocP.Print_InFile());
   ELSE
    CALL(PDocP.Print());
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {intPrint};

 PUBLIC PROCEDURE SinglePrint();
 BEGIN
  intPrint(0, 0);
 END {SinglePrint};

 PUBLIC PROCEDURE StreamPrint();
 BEGIN
  intPrint(1, 0);
 END {StreamPrint};

 PUBLIC PROCEDURE SinglePrePrint();
 BEGIN
  intPrint(0, 1);
 END {SinglePrePrint};

 PRIVATE PROCEDURE MakeUnprinted(Force: SCAL[2]);
 BEGIN
  IF Force | L_XDoc.XDocIsPrinted(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
   INC(PDoc.CopyCnt);
   REPLACE(PDoc);
  END;
 END {MakeUnprinted};

 PRIVATE PROCEDURE PDoc_wCopyCnt(): SCAL[2];
 BEGIN
  RETURN L_PDoc.IsPDocKind_wPmntMsgAsMainForm(PDoc.PDocKind, Math.Min(SYSDATE(), PDoc.Date));
 END {PDoc_wCopyCnt};

 PRIVATE PROCEDURE intRePrint(Stream: SCAL[2]);
 BEGIN
  ACCESS(PDoc);
  IF PDoc_wCopyCnt() THEN
   CheckIfIsSent(L_XDoc.action_Reprint);
   CheckCurPer(0, Stream);
   MakeUnprinted(0);
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, L_XDoc.action_Reprint);
   IF ~Stream THEN
    LIKEMENU(CALL, "PDoc.SinglePrint()");
   END;
  ELSE
   IF ~Stream THEN
    SinglePrint();
   END;
  END;
 END {intRePrint};

 PUBLIC PROCEDURE SingleRePrint();
 BEGIN
  intRePrint(0);
 END {SingleRePrint};

 PUBLIC PROCEDURE StreamRePrint();
 BEGIN
  intRePrint(1);
 END {StreamRePrint};

 PRIVATE PROCEDURE intSend(Stream: SCAL[2]);
  VAR
   Local: PROC;
 BEGIN
  ACCESS(PDoc);
  TRY [ABORT_AFTER(AA_ON)]
   CheckIfIsSent(L_XDoc.action_Sent);
   L_PDoc.CheckPassed();
   IF PDoc_wCopyCnt() THEN
    IF ~L_XDoc.XDocIsVerifiedCC(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc) THEN
     L_StdFrm.WrongDB("। ࠢ 㬥 ᫥ ⢥न  ");
    END;
    CALL(O_PDoc.MakeDoc(L_MSO.PrpMode_ToPDF));
   ELSE
    L_General.Error("ࠢ  ⮣  ");
   END;
  EXCEPT
  END;
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, L_XDoc.action_Sent);
 END {Send};

 PUBLIC PROCEDURE SingleSending();
 BEGIN
  intSend(0);
 END {SingleSending};

 PUBLIC PROCEDURE StreamSending();
 BEGIN
  intSend(1);
 END {StreamSending};

 PRIVATE PROCEDURE intPrintCopy(Stream: SCAL[2]);
 BEGIN
  ACCESS(PDoc);
  L_General.Error("⮢   ॠ");
  L_XDoc.XDocJrn_Mark(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc, L_XDoc.action_PrintCopy);
 END {intPrintCopy};

 PUBLIC PROCEDURE SinglePrintCopy();
 BEGIN
  intPrintCopy(0);
 END {SinglePrintCopy};

 PUBLIC PROCEDURE StreamPrintCopy();
 BEGIN
  intPrintCopy(1);
 END {StreamPrintCopy};

BEGIN
 L_Events.ExecuteHandler();
END.
