(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     ஫ 䨪樨 PDocList
%Type        control
%Specific    SYS
%Modified    02.10.2012 14:08:58 POLAK\Gina
%Environment
*)

 MODULE PDocList [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, L_DatTim, L_PDoc, L_Money, L_PRoll, L_Staff,
        L_Pmnt, L_StdFrm;

 PRIVATE PROCEDURE Check();
 BEGIN
  L_Money.CheckAcAccuracy(L_DatTim.Per(PDocList.PDocDate), PDocList.Sum, " ");
  IF PDocList.Sum < 0 THEN
   L_StdFrm.Choice(" ⥫쭠 㬬| 㢥७  ᢮ ⢨?");
  END;
  CONFORM(PDocList, Staff);
  HISTCONF(PDoc.Date, Staff, StaffLog);
  L_General.Assert(OCCURE(StaffLog), "⭨ "+Staff.TSN+"  ਭ  "+L_DatTim.DateStr(PDoc.Date));
  IF ~L_Staff.InStateInPer(L_DatTim.MonthBeg(PDocList.PDocDate), L_DatTim.MonthEnd(PDocList.PDocDate)) THEN
   L_StdFrm.Choice("⭨ "+PDocList.TSN+"| ⮨    "+L_DatTim.PeriodStr(PDocList.PDocDate));
  END;
  L_General.Assert((L_PRoll.E_MethodOfPDocToMoney(PDoc.Date) # L_PRoll.pdtom_PaidOnly) |
                   (PDocList.State # L_PDoc.pdl_st_Deposited),
                   "ﭨ  ঠ");
 END {Check};

 PRIVATE PROCEDURE IsPDocTotalCorrespondWithPDocList(): SCAL[2];
  VAR
   _Total: LIKE(PDoc.Total);
 BEGIN
  SAVE(PDocList);
  SETZERO(_Total);
  SELECT(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc);
  WHILE OCCURE(PDocList) DO
   IF PDocList.State = L_PDoc.pdl_st_Paid THEN
    INC(_Total, PDocList.Sum);
   END;
   NEXT(PDocList);
  END; (* WHILE OCCURE(PDocList) ... *)
  RESTORE(PDocList);
  RETURN (_Total = L_Pmnt.ConvEtZ(PDoc.Total));
 END {IsPDocTotalCorrespondWithPDocList};

 PRIVATE PROCEDURE _PDocList_OnChangeSum(_s: NUMERIC[0]);
 BEGIN
  IF PDocList.State = L_PDoc.pdl_st_Paid THEN
   IF !PDoc.Total THEN
    PDoc.Total:=_s*PDocList.Sum;
   ELSE
    INC(PDoc.Total, _s*PDocList.Sum);
   END;
   REPLACE(PDoc);
  END;
 END {_PDocList_OnChangeSum};

 PRIVATE PROCEDURE PDocList_OnChangeSum(_s: NUMERIC[0]);
  CONST
   DontIt = " 㪠 㬬 27.06.2003 12:06:51 POLAK\San";
  VAR
   DoIt: SCAL[2];
 BEGIN
  IF ~L_PDoc.InPassingNoteSetting() THEN
   IF L_PDoc.PDocTotalFillMethod() = L_PDoc.pdtfm_byPDocList THEN
    _PDocList_OnChangeSum(_s);
   ELSIF L_PDoc.PDocTotalFillMethod() = L_PDoc.pdtfm_Manual THEN
    TRY
     IF _s = -1 THEN
      DoIt:=IsPDocTotalCorrespondWithPDocList();
     END;
     _PDocList_OnChangeSum(_s);
     IF _s = +1 THEN
      DoIt:=IsPDocTotalCorrespondWithPDocList();
     END;
     REPLACE(PDoc);
     IF ~DoIt THEN
      RAISE(, DontIt);
     END;
    EXCEPT
    ON Exc:Exc_Raise DO
     IF Exc.MsgOriginalText # DontIt THEN
      RAISE();
     END;
    END;
   END;
  END;
 END {PDocList_OnChangeSum};

 PRIVATE PROCEDURE PDocList_State_OnSuccessfulChange();
 BEGIN
  L_General.Assert(L_PDoc.IsSalPDoc() | L_PDoc.IsDeductPayP(PDoc.payp),
                   " ﭨ  ⮫쪮    ௫");
 END {PDocList_State_OnSuccessfulChange};

 PRIVATE PROCEDURE PDocList_TSN_OnSuccessfulChange();
 BEGIN
  IF ~!GE_PVALUE() THEN
  END;
 END {PDocList_TSN_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckModifyingPDoc();
 BEGIN
  IF PDoc.Type = L_PDoc.typ_Mass THEN
   L_StdFrm.Choice("  ᮢ ⥦ 㬥?");
  END;
  CALL(PDoc.CheckRefToPDoc());
 END {CheckModifyingPDoc};

 PRIVATE PROCEDURE SetPDocListWindowFields();
 BEGIN
(*
  RTI.Get().CurZone.Fields("PDocList.TSN").OnSuccessfulChange:=1;
*)
 END {SetPDocListWindowFields};

 PRIVATE PROCEDURE PDocList_OnBeforeEdit();
 BEGIN
  CheckModifyingPDoc();
  PDocList_OnChangeSum(-1);
  SetPDocListWindowFields();
 END {PDocList_OnBeforeEdit};

 PRIVATE PROCEDURE PDocList_OnBeforeInsert();
 BEGIN
  IF (PDoc.PDocKind = L_PDoc.pd_PKO) |
     (PDoc.PDocKind = L_PDoc.pd_OVN) |
     (PDoc.PDocKind = L_PDoc.pd_CND) |
     (PDoc.PDocKind = L_PDoc.pd_AVO)  THEN
   L_General.Assert(L_PDoc.IsSingleTSN_PDoc(),
                    " " + L_PDoc.PDocKindNick(PDoc.PDocKind, 1) + "    祫");
  END;
  CheckModifyingPDoc();
  IF L_PDoc.PDocTotalFillMethod() = L_PDoc.pdtfm_byPDocList THEN
   SAVE(PDocList);
   CONFORM(PDoc, PDocList);
   IF ~NEXT(PDocList) & ~((PDoc.Total = 0) | !PDoc.Total) THEN
    L_StdFrm.Choice(" 稨 ᯨ᪠ ࠡ⭨ 㬬     㪠 " +
                    "||⠭ 㬬  ࠢ ?");
    PDoc.Total:=0;
    REPLACE(PDoc);
   END;
   RESTORE(PDocList);
  END;
  PDocList.PDocDate:=PDoc.Date;
  REPLACE(PDocList);
  SetPDocListWindowFields();
 END {PDocList_OnBeforeInsert};

 PRIVATE PROCEDURE PDocList_OnBeforeDelete();
 BEGIN
  CheckModifyingPDoc();
  PDocList_OnChangeSum(-1);
 END {PDocList_OnBeforeDelete};

 PRIVATE PROCEDURE PDocList_OnAfterEdit();
 BEGIN
  Check();
  PDocList_OnChangeSum(+1);
 END {PDocList_OnAfterEdit};

 PRIVATE PROCEDURE PDocList_OnAfterInsert();
 BEGIN
  Check();
  PDocList_OnChangeSum(+1);
 END {PDocList_OnAfterInsert};

BEGIN
 L_Events.ExecuteHandler();
END.
