(*
%Copyright   (c) Polak Computer System
%Author      NAIL
%Purpose      ᯨ᪠  ⥦ 祭
%Purpose     믮   ࠢ PDocP
%Type        report
%Specific    SYS
%Modified    21.06.2013 20:40:58 POLAK\Gina
%Environment
*)

 MODULE PDocLP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_PayP, L_Str, L_PDoc, L_Money, L_AFM, L_DatTim, L_APtm, L_PayPRl, P_Firm,
        Str, DBD, E_PDoc, P_Staff;

 PRIVATE CONST
  PageBotDepth   = 10;
  ReportBotDepth = 15;
  ColumnAmount   = L_PayP.MaxAttrAmnt+L_PayP.MaxSumAmnt+1;
  SingleLine     = "----------------------------------------------------------------------------------------------------";
  DoubleLine     = "====================================================================================================";
  BlanksLine     = "                                                                                                    ";
  DotLine        = "....................................................................................................";

 PRIVATE VAR
  Title       : STRING[][4];
  Line,
  TtlLine,
  DlmLine,
  FilLine,
  SngLine,
  DblLine,
  BotLine,
  BlnLine,
  TdlLine,
  TotLine,
  PrfLine     : STRING[];
  E_Bot,
  ReportFooter: STRING[][16];
  SumStr      : STRING[80][3];

  _PDocStr    : STRING[12];

  Sum,
  PageSum     : NUMERIC[2] [L_PayP.MaxSumAmnt];
  SourceSum,
  TotalSum,
  TotPageSum  : NUMERIC[2];
  RuleForSum  : PROC;

  Content,
  ColTitle    : STRING[]   [ColumnAmount];
  ColType,
  ColLen      : NUMERIC[0] [ColumnAmount];
  ColPttrn,
  ColAlign    : STRING[5]  [ColumnAmount];
  ItemForIndex: STRING[];
  IndexPower  : NUMERIC[0];

  Depth,
  ColAmnt,
  SumAmnt,
  WidenCol,
  Page,
  LineNbr,
  TotalNbr,
  RepWidth,
  SumStrLen,
  BlnkAmnt,
  PageFooterDepth,
  E_BotDepth,
  ReportFooterDepth : NUMERIC[0];

  Pattern     : STRING[9];

  Has_DocAttr,
  FirstPass,
  _IsSalPDoc  : SCAL[2];

(*
$P { Pattern1 :
Line, L, ""
@
####################################################################
}
*)
(*
$P { Pattern2 :
Line, L, ""
@
##################################################################################
}
*)
(*
$P { Pattern3 :
Line, L, ""
@
###################################################################################################################
}
*)
(*
$P { Pattern4 :
Line, L, ""
@
######################################################################################################################################################
}
*)

 PRIVATE PROCEDURE NoRoomForLine(EndReport: SCAL[2]): SCAL[2];
 BEGIN
  RETURN LINENUM(Mon) > (Depth -
                         PageBotDepth -
                         ~EndReport*PageFooterDepth -
                         EndReport*(ReportBotDepth+E_BotDepth+
                                    (E_BotDepth>0)*1  +
                                    ReportFooterDepth +
                                    (ReportFooterDepth>0)*1) -
                                    2 - 2*(SumAmnt > 1));
 END {NoRoomForLine};

 PRIVATE PROCEDURE JustifyLine(VAR L: STRING[]; S, Fill: STRING[]);
 BEGIN
  IF RepWidth < (Str.Length(L) + Str.Length(S)+1) THEN
   L:=Str.Slice(L, 0, RepWidth-Str.Length(S)-1);
  END;
  L:=L + Str.Slice(Fill, 0, (RepWidth - Str.Length(L) - Str.Length(S))) + S;
 END {JustifyLine};

 PRIVATE PROCEDURE BegPage();
  VAR
   i        : NUMERIC[0];
   trgSrcNbr: STRING[];
 BEGIN
  IF LINENUM(Mon) = 0 THEN
   SETZERO(TotPageSum, PageSum, LineNbr, i);
   IF ~!PDoc.SrcNbr THEN
    trgSrcNbr:=PDoc.SrcNbr;
   ELSE
    trgSrcNbr:=L_Str.Repeat(" ", Str.MaxLength(PDoc.SrcNbr));
   END;
   Line:=FLDTOSTR(" ⥦ 祭 " + trgSrcNbr + "  " + L_DatTim.DateStr(PDoc.Date), "", RepWidth, "C");
   MAKEPART(Mon, ^Pattern);
   WHILE i <= HIGH(Title) DO
    IF ~!Title[i] THEN
     Line:=FLDTOSTR(Title[i], "", RepWidth, "C");
     MAKEPART(Mon, ^Pattern);
    END;
    INC(i);
   END;
   Line:=P_Firm.FP_FirmName(L_PDoc.GetPDocOwnFirm(), PDoc.Date);
   JustifyLine(Line, L_DatTim.DateStr(SYSDATE()) + " " +L_DatTim.TimeStr(SYSTIME()), BlanksLine + BlanksLine);
   MAKEPART(Mon, ^Pattern);
   Line:=DblLine;
   MAKEPART(Mon, ^Pattern);
   Line:=TtlLine;
   MAKEPART(Mon, ^Pattern);
  END;
 END {BegPage};

 PUBLIC PROCEDURE AsLeaderSigner(D: DATE; trgFirm: LIKE(Firm.Firm);
                                 VAR LeadPost, LeadName: STRING[]);
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PDoc.PDocLPAsLeaderSigner);
  IF ~!Local & P_Staff.AccessBySpdSrchV(P_Staff.P_SgnAuthR, Local(D), D) THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    SEARCH(Staff, TSN, , StaffPro.TSN);
    CONFORM(Staff, Man);
    LeadPost:=P_Firm.GetManAttrByTSN(Staff.TSN, D, P_Firm.mpt_ManPostName);
    LeadName:=L_Str.ShortName(Man.Name);
   EXCEPT
   END; (* TRY *)
  ELSE
   IF L_General.GetAPSiteID() = "SP" THEN
    LeadPost:="㪮⥫ ࣠樨";
   ELSE
    LeadPost:=P_Firm.FP_LeadPostName1(trgFirm, D);
   END;
   LeadName:=L_Str.ShortName(P_Firm.FP_LeadName(trgFirm, D));
  END;
 END {AsLeaderSigner};

 PRIVATE PROCEDURE SignEndOfPage();
  VAR
   LeadPost,
   LeadName: STRING[];
 BEGIN
  AsLeaderSigner(PDoc.Date, L_PDoc.GetPDocOwnFirm(), LeadPost, LeadName);
  Line:=PrfLine + LeadPost;
  JustifyLine(Line, "|", BlanksLine);
  MAKEPART(Mon, ^Pattern);
  Line:=BlnLine;
  MAKEPART(Mon, ^Pattern);
  Line:=PrfLine + "                ";
  JustifyLine(Line, FLDTOSTR(LeadName, " ")+"|", DotLine);
  MAKEPART(Mon, ^Pattern);
  Line:=BlnLine;
  MAKEPART(Mon, ^Pattern);
  Line:=PrfLine + " 壠 ";
  JustifyLine(Line, "|", BlanksLine);
  MAKEPART(Mon, ^Pattern);
  Line:=PrfLine + "                ";
  JustifyLine(Line, FLDTOSTR(P_Firm.FP_RealAcntName_Short(L_PDoc.GetPDocOwnFirm(), PDoc.Date), " ")+"|", DotLine);
  MAKEPART(Mon, ^Pattern);
  Line:=BlnLine;
  MAKEPART(Mon, ^Pattern);
 END {SignEndOfPage};

 PRIVATE PROCEDURE MakeBot(_EndPage: SCAL[2]; _Nbr: NUMERIC[0]; _Sum: NUMERIC[2]);
  VAR
   i: NUMERIC[0];
 BEGIN
  Line:=SngLine;
  MAKEPART(Mon, ^Pattern);
  IF _EndPage THEN
   Line:=" ᮤন ";
  ELSE
   Line:=" " + L_Str.IntStr(Page) + " ᮤন ";
  END;
  Line:=PrfLine + Line + L_Str.IntStr(_Nbr) + " " +
        Str.EnumObject(_Nbr, "||ᥩ")+"   㬬";
  JustifyLine(Line, (FLDTOSTR(_Sum, ",2-") + "|"), BlanksLine);
  MAKEPART(Mon, ^Pattern);
  Line:=SngLine;
  MAKEPART(Mon, ^Pattern);
  L_Str.FormatStr(SumStr, L_Money.ByWord(_Sum), SumStrLen);
  i:=0;
  WHILE i < 3 DO
   IF ~!SumStr[i] THEN
    Line:=PrfLine + FLDTOSTR(SumStr[i], "", SumStrLen) + "|";
   ELSE
    Line:=BlnLine;
   END;
   MAKEPART(Mon, ^Pattern);
   INC(i);
  END; (* WHILE i < 3 ... *)
 END {MakeBot};

 PRIVATE PROCEDURE EndPage(EndReport: SCAL[2]);
  VAR
   i: NUMERIC[0];
 BEGIN
  BegPage();
  WHILE ~NoRoomForLine(EndReport) DO
   Line:=DlmLine;
   MAKEPART(Mon, ^Pattern);
   Line:=FilLine;
   MAKEPART(Mon, ^Pattern);
  END;
  INC(TotalSum, TotPageSum);
  INC(TotalNbr, LineNbr);
  IF SumAmnt > 1 THEN
   Line:=TdlLine;
   MAKEPART(Mon, ^Pattern);
   Line:=TotLine;
   i:=0;
   WHILE i < SumAmnt DO
    Line:=Line + FLDTOSTR(PageSum[i], "2-", L_PayP.GetObjLen(L_PayP.SumObj, 0), "R") + "|";
    INC(i);
   END;
   MAKEPART(Mon, ^Pattern);
  END; (* IF SumAmnt > 1 ... *)
  MakeBot(0, LineNbr, TotPageSum);
  IF EndReport THEN
   MakeBot(1, TotalNbr, TotalSum);
   Line:=SngLine;
   MAKEPART(Mon, ^Pattern);
   Line:=BlnLine;
   MAKEPART(Mon, ^Pattern);

   IF E_BotDepth > 0 THEN
    i:=0;
    WHILE i < E_BotDepth DO
     Line:=PrfLine;
     JustifyLine(Line, E_Bot[i] + "|", BlanksLine+BlanksLine);
     MAKEPART(Mon, ^Pattern);
     INC(i);
    END;
   END;

   SignEndOfPage();

   IF ReportFooterDepth > 0 THEN
    Line:=SngLine;
    MAKEPART(Mon, ^Pattern);
    i:=0;
    WHILE i < ReportFooterDepth DO
     Line:=PrfLine;
     JustifyLine(Line, ReportFooter[i] + "|", BlanksLine+BlanksLine);
     MAKEPART(Mon, ^Pattern);
     INC(i);
    END;
   END;
(*!!!!*)
  ELSE
   IF PageFooterDepth>0 THEN
    SignEndOfPage();
   END; (* IF *)
  END;
  IF EndReport THEN
   Line:=BotLine;
  ELSE
   Line:="=================";
  END;
  JustifyLine(Line, "  " + FLDTOSTR(Page, "", 3, "R") + " ==", DblLine);
  MAKEPART(Mon, ^Pattern);
  FORMFEED(Mon);
  INC(Page);
 END {EndPage};

 PRIVATE PROCEDURE IsLastLine(): SCAL[2];
 BEGIN
  RETURN (LINENUM(Mon)>0) & (TotalNbr+LineNbr+1 = IndexPower);
 END {IsLastLine};

 PRIVATE PROCEDURE MakeLine();
  VAR
   i: NUMERIC[2];
 BEGIN
  IF NoRoomForLine(0) | (IsLastLine() & NoRoomForLine(1)) THEN
   EndPage(0);
  END;
  BegPage();
  CONFORM(Deduct, DedType);
  IF _IsSalPDoc THEN
   SEARCH(PDocList, PDoc, , PDoc.PDocKind, PDoc.PDoc, Deduct.TSN);
   RuleForSum(1, PDocList.Sum, Sum[0], Sum[1]);
  ELSE
   CONFORM(Deduct, DedAcnt);
   SRCINSEL(DedAcnt, EQ, , Memo.gl_mb());
   L_PayP.GetDedAcntDebts(Sum[0], Sum[1]);
  END; (* IF _IsSalPDoc ... *)
  IF Has_DocAttr THEN
   L_General.Assert(L_PDoc.IsActiveSpecDeduct(PDoc.Date),
                    "  㬥 ⨬ 뢮 ⮫쪮 |" +
                    "  ᫥ ௫  ");
   CONFORM(Deduct, Man);
  END;
  Sum[2]:=Sum[0]+Sum[1];
  i:=0;
  WHILE i < 3 DO
   INC(PageSum[i], Sum[i]);
   INC(i);
  END;
  INC(TotPageSum, Sum[2]);
  INC(LineNbr);
  Line:=DlmLine;
  MAKEPART(Mon, ^Pattern);
  PrepareLine(Content);
 END {MakeLine};

 PRIVATE PROCEDURE PrepareLine(VAR Objects: STRING[][ColumnAmount]);
  CONST
   MS = 10;
  VAR
   CurObj,
   CurLine: STRING[];
   ObjStr : STRING[][MS];
   i,
   Col,
   MaxSubStr: NUMERIC[0];
 BEGIN
  IF FirstPass THEN
   DlmLine:="|";
   FilLine:="|";
  END;
  i:=0; MaxSubStr:=0;
  WHILE i<=MaxSubStr DO
   Col:=0;
   Line:="|";
   REPEAT
    CurObj:=Objects[Col];
    IF FirstPass THEN
     Line:=Line + FLDTOSTR(  CurObj,            "", ColLen[Col], ColAlign[Col]);
     DlmLine:=DlmLine + Str.Slice(SingleLine, 0, ColLen[Col]);
     FilLine:=FilLine + Str.Slice(BlanksLine, 0, ColLen[Col]);
    ELSE
     SETEMPTY(ObjStr, CurLine);
     IF ColType[Col] = L_PayP.ot_String THEN
      Str.Format(ObjStr, Str.Condense(^CurObj), ColLen[Col], LEFT);
      IF ~!ObjStr[MaxSubStr+1] THEN
       INC(MaxSubStr);
       L_General.Assert(MaxSubStr<(MS-1), "誮 㧪 ⮫ '"+ColTitle[Col]+"'");
      END;
      CurLine:=FLDTOSTR(ObjStr[i], "", ColLen[Col], ColAlign[Col]);
     ELSIF i = 0 THEN
      CurLine:=FLDTOSTR(^CurObj, ColPttrn[Col], ColLen[Col], ColAlign[Col]);
     ELSE
      CurLine:=FLDTOSTR(" ",       "", ColLen[Col], ColAlign[Col]);
     END;
     Line:=Line+CurLine;
    END;
    IF Col = WidenCol THEN
     IF FirstPass THEN
      DlmLine:=DlmLine + Str.Slice(SingleLine, 0, BlnkAmnt);
      FilLine:=FilLine + Str.Slice(BlanksLine, 0, BlnkAmnt);
      INC(ColLen[Col], BlnkAmnt);
      Line:=Line + Str.Slice(BlanksLine, 0, BlnkAmnt);
     END;
    END;
    IF FirstPass THEN
     DlmLine:=DlmLine + "|";
     FilLine:=FilLine + "|";
    END;
    Line:=Line + "|";
    INC(Col);
   UNTIL Col = ColAmnt;
   INC(i);
   IF ~FirstPass THEN
    MAKEPART(Mon, ^Pattern);
    IF NoRoomForLine(0) THEN
     EndPage(0);
    END;
    BegPage();
   END;
  END; (* WHILE i<=MaxSubStr ...*)
  FirstPass:=0;
 END {PrepareLine};

 PRIVATE PROCEDURE InitSpecLines();
  VAR
   S: STRING[];
   i: NUMERIC[0];
 BEGIN
  FirstPass:=1;
  PrepareLine(ColTitle);
  TtlLine:=Line;
  S      :="|" + SingleLine + SingleLine;
  SngLine:=Str.Slice(S, 0, RepWidth - 1) + "|";
  S      :=DoubleLine + DoubleLine;
  DblLine:=Str.Slice(S, 0, RepWidth);
  S      :="|" + BlanksLine + BlanksLine;
  BlnLine:=Str.Slice(S, 0, RepWidth - 1) + "|";
  IF SumAmnt > 1 THEN
   S:="|";
   i:=0;
   WHILE i < SumAmnt DO
    S:=S + Str.Slice(SingleLine, 0, L_PayP.GetObjLen(L_PayP.SumObj, 0)) + "|";
    INC(i);
   END;
   TdlLine:=Str.Slice(SngLine, 0, RepWidth - Str.Length(S)) + S;
   TotLine:="|ᥣ" + Str.Slice(BlnLine, 1, RepWidth - Str.Length(S) - 6) + "|";
  END; (* IF SumAmnt > 1 ... *)
  PrfLine:=Str.Slice(BlnLine, 0, RepWidth - SumStrLen - 1);
  BotLine:="=(c) Polak";
 END {InitSpecLines};

 PRIVATE PROCEDURE GetListPattern();
  VAR
   Indx,
   Length,
   MaxLen  : NUMERIC[0];
   _LstName: STRING[][4];
 BEGIN
  Has_DocAttr:=0;
  PROMPT(_PDocStr+" ଠ஢ ");
  SETEMPTY(Content, ColTitle, ColPttrn, ColAlign, ColType);
  SETZERO(ColLen);
  Content [0]:=L_PayP.GetObjName (L_PayP.LineNbrObj, 0);
  ColTitle[0]:=L_PayP.GetObjTitle(L_PayP.LineNbrObj, 0);
  ColAlign[0]:=L_PayP.GetObjAlign(L_PayP.LineNbrObj);
  ColType [0]:=L_PayP.GetObjType (L_PayP.LineNbrObj);
  ColLen  [0]:=3;
  Length     :=5;
  MaxLen     :=3;
  Indx       :=0;
  ColAmnt    :=1;
  SumAmnt    :=0;
  WidenCol   :=1;
  WHILE Indx < L_PayP.MaxAttrAmnt DO
   IF ~!PayP.LstAttr[Indx] THEN
    Has_DocAttr:=Has_DocAttr | (PayP.LstAttr[Indx] = L_PayP.a_Document);
    Content [ColAmnt]:=L_PayP.GetObjName (PayP.LstAttr[Indx], 0);
    ColTitle[ColAmnt]:=PayP.AttrName[Indx];
    ColLen  [ColAmnt]:=L_PayP.GetObjLen  (PayP.LstAttr[Indx], Indx);
    ColAlign[ColAmnt]:=L_PayP.GetObjAlign(PayP.LstAttr[Indx]);
    ColType [ColAmnt]:=L_PayP.GetObjType (PayP.LstAttr[Indx]);
    IF ColLen[ColAmnt] >= MaxLen THEN
     MaxLen  :=ColLen[ColAmnt];
     WidenCol:=ColAmnt;
    END;
    INC(Length, ColLen[ColAmnt] + 1); (* 1 ᨬ - ࠧ⥫ *)
    INC(ColAmnt);
   END; (* IF ~!PayP.LstAttr[Indx] ... *)
   INC(Indx);
  END; (* WHILE (Indx < ... *)

  Indx       :=0;
  WHILE Indx<L_PayP.MaxSumAmnt DO
   IF ~!PayP.LstSum[Indx] THEN
    Content [ColAmnt]:=L_PayP.GetObjName (L_PayP.SumObj, Indx);
    ColTitle[ColAmnt]:=L_PayP.GetObjTitle(L_PayP.SumObj, Indx);
    ColLen  [ColAmnt]:=L_PayP.GetObjLen  (L_PayP.SumObj, Indx);
    ColPttrn[ColAmnt]:="2-";
    ColAlign[ColAmnt]:=L_PayP.GetObjAlign(L_PayP.SumObj);
    INC(Length, ColLen[ColAmnt] + 1);
    INC(SumAmnt);
    INC(ColAmnt);
   END; (* IF ~!PayP.LstSum[ ... *)
   INC(Indx);
  END; (* WHILE (Indx < ... *)

  IF    Length <= 068 THEN
   Pattern  :="Pattern1";
   RepWidth :=068;
  ELSIF Length <= 082 THEN
   Pattern  :="Pattern2";
   RepWidth :=082;
  ELSIF Length <= 115 THEN
   Pattern  :="Pattern3";
   RepWidth :=115;
  ELSIF Length <= L_PayP.MaxLength THEN
   Pattern  :="Pattern4";
   RepWidth :=L_PayP.MaxLength;
  ELSE
   L_General.Error("誮   ਭ |" +
                   "ਭ  "+FLDTOSTR(Length, "0")+"|"+
                   "ᨬ쭠 ਭ "+L_Str.IntStr(L_PayP.MaxLength));
  END;
  IF RepWidth = 068 THEN
   SumStrLen:=66;
  ELSE
   SumStrLen:=80;
  END;
  SAVE(Firm);
  CONFORM(PDoc, Firm);
  SETEMPTY(Title, _LstName);
  Str.Format(_LstName, PayP.LstTitle, RepWidth, LEFT);
  Indx:=0;
  WHILE Indx <= HIGH(Title) DO
   Title[Indx]:=L_PayP.MorphString(_LstName[Indx], L_PayP.ppt_ListTitle, PROCREF(L_PDoc.PRollFields), RepWidth);
   INC(Indx);
  END;  (* WHILE Indx < 4 *)

  RESTORE(Firm);
  BlnkAmnt:=RepWidth - Length;
  InitSpecLines();
  RuleForSum:=L_PayP.GetPayPLstProc();
 END {GetListPattern};

 PRIVATE PROCEDURE Ins_Ded();
 BEGIN
  L_General.Assert(~!^ItemForIndex,
                   " 㪠 祭 ਡ ஢|" +
                   "'" + DBD.FieldDescription(^(Str.Item(ItemForIndex, ".[", 0)), ^(Str.Item(ItemForIndex, ".[", 1)))+"'|" +
                   ". " + Staff.TSN + ", 㤥ঠ " + Deduct.DedNbr);
  _Ded._IndexBy:=^ItemForIndex;
  _Ded._TSN    :=Deduct.TSN;
  _Ded._Nbr    :=Deduct.DedNbr;
  INSERT(_Ded);
  INC(IndexPower);
 END {Ins_Ded};

 PRIVATE PROCEDURE MakeIndex();
 BEGIN
  IndexPower:=0;
  CONFORM(PDoc, PDocList);
  WHILE OCCURE(PDocList) DO
   CONFORM(PDocList, Staff, Man);
   PROMPT(_PDocStr+" : "+Staff.TSN);
   L_PDoc.ScanDeductTSN(Staff.TSN, PROCREF(Ins_Ded));
   NEXT(PDocList);
  END; (* WHILE OCCURE(PDocList) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE E_PDocLP_ReportFooter(VAR RF: STRING[][]; VAR RFDepth: NUMERIC[0];
                                         VAR BF: STRING[][]; VAR BFDepth: NUMERIC[0]);
  VAR
   Local: PROC;
 BEGIN
  SETEMPTY(RF, BF);
  RFDepth:=0; BFDepth:=0;
  Local:=PROCREF(E_PDoc.PDocLP_ReportFooter);
  IF ~!Local THEN
   Local(RF, RFDepth, BF, BFDepth);
  END;
 END {E_PDocLP_ReportFooter};

 PRIVATE PROCEDURE E_PDocLP_PageFooter(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_PDoc.PDocLP_PageFooter);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 0;
  END;
 END {E_PDocLP_PageFooter};

 PRIVATE PROCEDURE _Make();
 BEGIN
  SETZERO(TotalSum, TotalNbr, Sum, PageFooterDepth);
  SEARCH(PayP, PayP, , PDoc.payp);
  IF PayP.Type # L_PayP.ppType_Simple THEN
   Depth       :=PayP.LstLines;
   ItemForIndex:=L_PayP.GetObjName(PayP.LstAttr[0], 1);
   MakeIndex();
   IF (IndexPower > 1) | L_PayP.IsEmptyPaylSngl() THEN
    E_PDocLP_ReportFooter(ReportFooter, ReportFooterDepth, E_Bot, E_BotDepth);
    IF E_PDocLP_PageFooter() THEN
     PageFooterDepth:=4;
    END;
    GetListPattern();
    SetPrintAttr(Mon, LeftMargin, 20, RightMargin, 0,
                      CharsPerLine, RepWidth,
                      LinesPerPage, Depth+1(* ॢ ப*));
    Page:=1;
    SELECT(_Ded, _Ded);
    WHILE OCCURE(_Ded) DO
     PROMPT(_PDocStr+"  ᯨ᪠: "+_Ded._TSN);
     L_General.Assert(SEARCH(Deduct, TSN, _Ded._TSN, _Ded._Nbr), "Error 234" );
     MakeLine();
     NEXT(_Ded);
    END; (* WHILE OCCURE(_Ded) ... *)
    IF NoRoomForLine(1) THEN
     EndPage(0);
    END;
    EndPage(1);
    L_General.Assert(TotalSum = PDoc.Total, "㬬 ⥦ 祭  ᮢ  㬬  ᯨ");
   END; (* IF (IndexPower > 1) | ... *)
  END;
 END {_Make};

 PUBLIC PROCEDURE PDocLP(NewRep: SCAL[2]);
 BEGIN
  IF NewRep THEN
   OPENREP(Mon, L_General.NameConnection("PDocL"), Create);
  ELSE
   InitPrintAttr(Mon);
  END;

  L_AFM.MakeIndex("_Ded", "_IndexBy : LIKE(Deduct.PAddr[0]);"+
                          "_TSN     : LIKE(Staff.TSN);"+
                          "_Nbr     : LIKE(Deduct.DedNbr)");
  IF ~!PDoc.payp THEN
   _IsSalPDoc:=L_PDoc.IsSalPDoc();
   _PDocStr  :=L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc);
   IF ~!PDoc.ServDate THEN
    L_APtm.TemporarySetMemoDate(PDoc.ServDate, PROCREF(_Make));
   ELSE
    _Make();
   END;
  END; (* IF ~!PDoc.payp ... *)
 
  L_AFM.AF_PurgeTemp("_Ded");

  IF NewRep THEN
   CLOSEREP(Mon);
  ELSE
   InitPrintAttr(Mon);
  END;
 END {PDocLP};

END.
