(*
%Copyright   (c) Polak Computer System
%Author      28.06.2001 01:00:37 BOR
%Purpose     ஫ 䨪樨 ᢮ ꥪ⮢ Property
%Type        control
%Specific    SYS
%Modified    24.04.2014 16:28:48 POLAK\MLB
%Environment
*)

 MODULE Property [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Prop, L_Events, L_StdFrm, L_Str, L_WDO, L_AcsPnt;

 PRIVATE PROCEDURE Property_OnBeforeEdit();
 BEGIN
  L_General.SilentAdminOnly();
 END {Property_OnBeforeEdit};

 PRIVATE PROCEDURE Property_OnBeforeInsert();
 BEGIN
  L_General.Error("⠢ ᢮ 饭");
 END {Property_OnBeforeInsert};

 PRIVATE PROCEDURE Property_OnBeforeDelete();
 BEGIN
  L_General.Error(" ᢮ 饭");
 END {Property_OnBeforeDelete};

 PRIVATE PROCEDURE Property_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "PropertE");
  L_WDO.iField       (1, "Property.Object").Format:=L_Prop.po_Pool;
 END {Property_OnInitializeWindow};

 PRIVATE PROCEDURE PropertE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnBeforeDelete]);
  L_WDO.iScsChange   (0, ["Property.AlwDelay"]);
  L_WDO.iUnmodifiable(0, ["Property.Object", "Property.Name", "Property.Property", "Property.Format", "Property.Tag"]);
  L_WDO.iMayBeEmpty  (0, ["Property.AlwDelay", "Property.Till"]);
  L_WDO.iField       (0, "Property.Object").Format:=L_Prop.po_Pool;
  L_WDO.iField       (0, "Property.Format").Format:=L_Prop.pf_Pool;
  L_WDO.iZone        (1).ParentZone:=L_WDO.iZone(0);
  L_WDO.iZone        (1).PermanentFilter:="(AcsPnt.AcsPnt = Property.apModify) | (AcsPnt.AcsPnt = Property.apBDMdf)";
  L_WDO.iSubwindow   (1, "AcsPntE");
  L_WDO.iField       (1, "AcsPnt.Name").Hierarchic:=1;
 END {PropertE_OnInitializeWindow};

 PRIVATE PROCEDURE Property_AlwDelay_OnSuccessfulChange();
 BEGIN
  IF !Property.AlwDelay THEN
   IF ~!Property.apBDMdf THEN
    L_General.Error(" ।⥫쭮  ᯥ樠     ᫮");
   END;
  END;
 END {Property_AlwDelay_OnSuccessfulChange};

 PRIVATE PROCEDURE OwnDProA_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ObjPro";
  L_WDO.iSubwindow   (1, "OwnDPro");
  L_WDO.iZone        (1).Narrowing      :="Property.Object = " + L_Str.IntStr(L_Prop.OwnDProObj);
  L_WDO.iZone        (1).PermanentFilter:="Property.IsUsed = 1";
 END {OwnDProA_OnInitializeWindow};

 PUBLIC PROCEDURE scs_GetFilters_Property_1(VAR Filters: L_WDO.tFilters);
  VAR
   tag: STRING[];
   Idx: NUMERIC[0];
 BEGIN
  Idx:=0;
  LOOP
   tag:=L_Str.PoolItem(L_Prop.tag_Pool, Idx);
   IF !tag THEN
    EXIT;
   END;
   L_WDO.PutNewFilter(Filters, tag, "(Property.Tag=**" + tag + "*)", 1);
   INC(Idx);
  END; (* LOOP *)
 END {scs_GetFilters_Property_1};

BEGIN
 L_Events.ExecuteHandler();
END.
