(*
%Copyright   (c) Polak Computer System
%Author      11.12.1993 18:21:25 MOG
%Purpose     
%Type        report
%Specific    SYS
%Modified    24.06.2014 19:20:43 POLAK\Gina
%Environment
*)

 MODULE PrtSht [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_DatTim, L_General, L_Staff, L_PRoll, L_AFM, P_Firm, L_Str, L_PagePr, L_Env,
        L_EC, L_Sheet, E_PRoll, Memo, P_Officer, L_StdFrm, L_MSO, L_Acnt, L_APtm;

 TYPE
  tMakeMode    = SCAL[4];
  tContentType = SCAL[3];

 CONST
  PagLength = 75;

  mm_condSngTK = 0;
  mm_explSngTK = 1;
  mm_condAllTK = 2;
  mm_condSngTSN = 3;

  ct_Reg = 0;
  ct_Fct = 1;
  ct_Emp = 2;

  AbsCauseNum = 8;

 VAR
  Pass        : PROC;
  Sign        : LIKE(JMode.ShtSignE)[32];
  Time        : STRING[5][32];
  HourTotHalf,
  HourTot     : LIKE(RegHead.GrTime);
  SpTim       : LIKE(RegHead.SpTime);
  DaysTot,
  DaysTotHalf : LIKE(RegHead.GDay);
  Page        : NUMERIC[0];
  WkDay       : STRING[][32];
  HolTime     : NUMERIC[6, 3];
  Nbr         : NUMERIC[0];
  SignAbs     : LIKE(JMode.ShtSignE)[AbsCauseNum];
  DaysAbs     : LIKE(RegHead.GDay)[AbsCauseNum];
  HourAbs     : LIKE(RegHead.GrTime)[AbsCauseNum];
  PreparationDate,
  _CurDate    : DATE;
  Header      : STRING[][2];

  Root        : STRING[];

 PRIVATE PROCEDURE BlankMode(Content: tContentType): SCAL[2];
 BEGIN
  RETURN Content # ct_Fct;
 END {BlankMode};

 PRIVATE PROCEDURE E_PrtSht_GetHeader(Content: tContentType);
 BEGIN
  IF BlankMode(Content) THEN
   IF ~!PROCREF(E_PRoll.PrtSht_GetHeader) THEN
    E_PRoll.PrtSht_GetHeader(_CurDate, Header);
   ELSE
    Header[0]:="  ᯮ짮 ࠡ祣 ६";
    Header[1]:="    "
   END;
   SETEMPTY(PreparationDate);
  ELSE
   Header[0]:="  ᯮ짮 ࠡ祣 ६";
   Header[1]:="";
   PreparationDate:=SYSDATE();
  END;
 END {E_PrtSht_GetHeader};

 PRIVATE PROCEDURE SpecDate(): STRING[];
 BEGIN
  RETURN '"____" '+L_DatTim.MonthStr(SYSDATE(), 1)+' '+FLDTOSTR(SYSDATE(), "y ", 0, "L");
 END {SpecDate};

 PRIVATE PROCEDURE Get_DocCause(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF L_APtm.IsMTA() THEN
   Result:="⢥ত ਪ     31.12.2013  843";
  ELSE
   Result:="⢥ত ⠭ ᪮ ᨨ  05.01.2004  1";
  END;
  RETURN Result;
 END {Get_DocCause};

(*
$P{ RepTop:
Get_DocCause(), R, ""
P_Firm.FP_PersonFullName_wBranchName(Firm.Firm, SYSDATE()), L, ""
P_Firm.FP_OKPO(Firm.Firm, SYSDATE()), L, ""
Header[0], C, ""
Header[1], C, ""
PreparationDate, L, "D.N.y"
L_DatTim.Per(_CurDate), L, "D.N.y"
_CurDate, L, "D.N.y"
@
                                                                                                                                                                                                                                                    ஢ ଠ N -13
################################################################################################################################################################################################################################################################################
                                                                                                                                                                                                                                                                      ----------
                                                                                                                                                                                                                                                                      |     |
                                                                                                                                                                                                                                                                      |--------|
                                                                                                                                                                                                                                                        ଠ   |0301008 |
                                                                                                                                                                                                                                                                      |--------|
###################################################################################################################################                                                                                                                             |########|
                                                                                                                                                                                                                                                                      |--------|
____________________________________________________                                                                                                                                                                                                                  |        |
      ୮ ࠧ                                                                                                                                                                                                                          ----------
                                                                                                   ###########################################                                                                        ---------------------------------- -----------------------
                                                                                                   ###########################################                                                                        | 㬥| ⠢| |    ਮ   |
                                                                                                                                                                                                                      |               |                | |----------|----------|
                                                                                                                                                                                                                      |               |                | |         |        |
ਬ砭.                                                                                                                                                                                                           |---------------|----------------| |----------|----------|
  ᫥ ࠡ⭮     ࠢ  ( 7-9)  ਢ  裡  ਬ  ࣠樨 ⮬⨧஢  ࠡ⭮ .                                       |               |   ##########   | |##########|##########|
                                                                                                                                                                                                                      ---------------------------------- -----------------------
}
*)

(*
$P{ PageTop:
TimeKeep.TimeKeep, L, ""
TimeKeep.Name, L, ""
L_PagePr.PagePr_CurrentPage()-Page+1, R, "0"
WkDay[01], L, ""
WkDay[02], L, ""
WkDay[03], L, ""
WkDay[04], L, ""
WkDay[05], L, ""
WkDay[06], L, ""
WkDay[07], L, ""
WkDay[08], L, ""
WkDay[09], L, ""
WkDay[10], L, ""
WkDay[11], L, ""
WkDay[12], L, ""
WkDay[13], L, ""
WkDay[14], L, ""
WkDay[15], L, ""
WkDay[16], L, ""
WkDay[17], L, ""
WkDay[18], L, ""
WkDay[19], L, ""
WkDay[20], L, ""
WkDay[21], L, ""
WkDay[22], L, ""
WkDay[23], L, ""
WkDay[24], L, ""
WkDay[25], L, ""
WkDay[26], L, ""
WkDay[27], L, ""
WkDay[28], L, ""
WkDay[29], L, ""
WkDay[30], L, ""
WkDay[31], L, ""
@
(###) ####################################################################                                                                                                                                                                                   ###   -13
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
|  |, 樠                  |. |   01   |    02  |   03   |   04   |   05   |   06   |   07   |   08   |   09   |   10   |   11   |   12   |   13   |   14   |   15   |   X    | ࠡ⠭  | | -|                 稭              |
| |                                   |     |   ##   |    ##  |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |        |---------------|       | |-----------------------------------------------|
| /|-----------------------------------|-----|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|--------|1/2 |  |-------|-------| | | | | | | | | | | | |
|    |                                   |     |   16   |    17  |   18   |   19   |   20   |   21   |   22   |   23   |   24   |   25   |   26   |   27   |   28   |   29   |   30   |   31   |-------|-------|       |       | || || || || || ||
|    | ()              ||   ##   |    ##  |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |   ##   |/|/|  | ࠧ| |    | |    | |    | |    | |    | |    |
|----|-----------------------------------|-----|-----------------------------------------------------------------------------------------------------------------------------------------------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|
|  1 |                 2                 |  3  |                                                                       4                                                                       |   5   |   6   |  6.1  |  6.2  |10,  11|12,  13|14,  15|16,  17|18,  19|20,  21|
}
*)

(*
$P{ Line:
Nbr, R, ""
L_Str.ShortName(Man.Name), L, ""
StaffLog.TSN, L, ""
Sign[01], R, ""
Time[01], R, ""
Sign[02], R, ""
Time[02], R, ""
Sign[03], R, ""
Time[03], R, ""
Sign[04], R, ""
Time[04], R, ""
Sign[05], R, ""
Time[05], R, ""
Sign[06], R, ""
Time[06], R, ""
Sign[07], R, ""
Time[07], R, ""
Sign[08], R, ""
Time[08], R, ""
Sign[09], R, ""
Time[09], R, ""
Sign[10], R, ""
Time[10], R, ""
Sign[11], R, ""
Time[11], R, ""
Sign[12], R, ""
Time[12], R, ""
Sign[13], R, ""
Time[13], R, ""
Sign[14], R, ""
Time[14], R, ""
Sign[15], R, ""
Time[15], R, ""
DaysTotHalf, R, "0"
DaysTot, R, "0"
SpTim[1], R, "3."
SpTim[3], R, "3."
SignAbs[0], R, ""
DaysAbs[0], R, "0"
SignAbs[1], R, ""
DaysAbs[1], R, "0"
SignAbs[2], R, ""
DaysAbs[2], R, "0"
SignAbs[3], R, ""
DaysAbs[3], R, "0"
SignAbs[4], R, ""
DaysAbs[4], R, "0"
SignAbs[5], R, ""
DaysAbs[5], R, "0"
Post.Post, L, ""
Post.Name, L, ""
StaffLog.Regime, L, ""
Sign[16], R, ""
Time[16], R, ""
Sign[17], R, ""
Time[17], R, ""
Sign[18], R, ""
Time[18], R, ""
Sign[19], R, ""
Time[19], R, ""
Sign[20], R, ""
Time[20], R, ""
Sign[21], R, ""
Time[21], R, ""
Sign[22], R, ""
Time[22], R, ""
Sign[23], R, ""
Time[23], R, ""
Sign[24], R, ""
Time[24], R, ""
Sign[25], R, ""
Time[25], R, ""
Sign[26], R, ""
Time[26], R, ""
Sign[27], R, ""
Time[27], R, ""
Sign[28], R, ""
Time[28], R, ""
Sign[29], R, ""
Time[29], R, ""
Sign[30], R, ""
Time[30], R, ""
Sign[31], R, ""
Time[31], R, ""
HourTotHalf, R, "3."
HourTot, R, "3."
SpTim[2], R, "3."
HolTime, R, "3."
HourAbs[0], R, "3."
HourAbs[1], R, "3."
HourAbs[2], R, "3."
HourAbs[3], R, "3."
HourAbs[4], R, "3."
HourAbs[5], R, "3."
@
|----|-----------------------------------|-----|-----------------------------------------------------------------------------------------------------------------------------------------------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|
|####|###################################|#####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|        |    ###|    ###|#######|#######|##  ###|##  ###|##  ###|##  ###|##  ###|##  ###|
|    |### ###############################|#### |## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|## #####|#######|#######|#######|#######|#######|#######|#######|#######|#######|#######|
}
*)

(*
$P{ Filling:
@
|----|-----------------------------------|-----|-----------------------------------------------------------------------------------------------------------------------------------------------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|
|    |                                   |     |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |       |       |       |       |       |       |       |       |       |       |
|    |                                   |     |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |       |       |       |       |       |       |       |       |       |       |
}
*)

(*
$P{ EBFilling:
@
|----|-----------------------------------|-----|-----------------------------------------------------------------------------------------------------------------------------------------------|-------|-------|-------|-------|-------|-------|-------|-------|-------|-------|
|    |                                   |     |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |       |       |       |       |       |       |       |       |       |       |
|    |                                   |     |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |       |       |       |       |       |       |       |       |       |       |
|    |- - - - - - - - - - - - - - - - - -|- - -|- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -|- - - -|- - - -|- - - -|- - - -|- - - -|- - - -|- - - -|- - - -|- - - -|- - - -|
|    |                                   |     |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |       |       |       |       |       |       |       |       |       |       |
|    |                                   |     |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |        |       |       |       |       |       |       |       |       |       |       |
}
*)

(*
$P{ PageBot:
SYSDATE(), L "DNy"
SYSTIME(), L "HM"
@
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
⮢ " ⮏" (c) Polak                                                                                                                                                                                                                                ######## ####
}
*)

PROCEDURE E_sd_GetStaffAttributes(_Type: P_Firm.tMProType): STRING[];
 VAR
  Local: PROC;
  _TSN : LIKE(Staff.TSN);
BEGIN
 Local:=PROCREF(E_PRoll.PrtSht_GetStaffDepTSN);
 IF ~!Local THEN
  RETURN P_Firm.GetManAttrByTSN(Local(_CurDate), _CurDate, _Type);
 ELSE
  RETURN "___________________";
 END;
END {E_sd_GetStaffAttributes};

PROCEDURE E_sd_GetPostName(): STRING[];
BEGIN
 RETURN E_sd_GetStaffAttributes(P_Firm.mpt_ManPostName);
END {E_sd_GetPostName};

PROCEDURE E_sd_GetShortManName(): STRING[];
BEGIN
 RETURN L_Str.ShortName(E_sd_GetStaffAttributes(P_Firm.mpt_ManName));
END {E_sd_GetShortManName};

(*
$P{ RepBot:
SYSDATE(), L "DNy"
SYSTIME(), L "HM"
SpecDate(), L, ""
E_sd_GetPostName(), L, ""
E_sd_GetShortManName(), L, ""
SpecDate(), L, ""
@
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
⮢ " ⮏" (c) Polak                                                                                                                                                                                                                                ######## ####

⢥⢥ ___________________ __________ ___________________  㪮⥫ ୮ ___________________ ___________ ___________________ ############################# ⭨ ஢ ################### ___________ ################### ############################
                         ஢         ࠧ                       ஢                                       㦡                     ஢ 
}
*)

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, RepTop);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF (Mode = L_PagePr.m_Print) | (Mode = L_PagePr.m_RDoneTop) THEN
   MAKEPART(R, PageTop);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(PageBot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, PageBot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(RepBot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, RepBot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Fill);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Filling));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Filling);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE _EBFilling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(EBFilling));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, EBFilling);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_EBFilling};

 PRIVATE PROCEDURE GetIdxAbs(_ShtSignE: LIKE(JMode.ShtSignE)): SCAL[AbsCauseNum];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=0;
  WHILE Result<AbsCauseNum DO
   IF !SignAbs[Result] THEN
    SignAbs[Result]:=_ShtSignE;
    RETURN Result;
   ELSIF SignAbs[Result] = _ShtSignE THEN
    RETURN Result;
   END;
   INC(Result);
  END;
  RETURN EMPTYOF(Result);
 END {GetIdxAbs};

 PRIVATE PROCEDURE SetSign(): LIKE(JMode.ShtSignE);
 BEGIN
  IF ~!JMode.ShtSignE THEN
   RETURN JMode.ShtSignE;
  ELSE
   RETURN JMode.ShtSign;
  END;
 END {SetSign};

 PRIVATE PROCEDURE PReg();
 BEGIN
  IF RegHead.GrTime # 0 THEN
   CONFORM(RegList, JMode);
   IF    JMode.Type = L_Sheet.jmType_TimDone THEN
    INC(DaysTot);
    IF RegList.Day<=15 THEN
     INC(DaysTotHalf);
     INC(HourTotHalf,          RegList.GrTime);
    END;
    INC(HourTot,               RegList.GrTime);
    INC(SpTim[RegList.SpKind], RegList.SpTime);
    Time[RegList.Day]:=FLDTOSTR(RegList.GrTime, "2.", 5);
    Sign[RegList.Day]:=SetSign();
    IF JMode.PayHldy THEN
     INC(HolTime, L_Sheet.HolTimeByDate(RegList.Period+(RegList.Day-1), RegList.GrTime, RegList.DayTime));
    END;
   ELSE
    IF JMode.PrintHrs THEN
     Time[RegList.Day]:=FLDTOSTR(RegList.GrTime, "2.", 5);
    END;
    Sign[RegList.Day]:=SetSign();
   END;
  ELSE
   IF RegList.Durat = 0 THEN
    Sign[RegList.Day]:="";
   END;
  END;
 END {PReg};

 PRIVATE PROCEDURE CheckRegList(Cond: SCAL[2]; _Day: LIKE(RegList.Day));
 BEGIN
  L_General.Assert(Cond, "  䨪  ० "+StaffLog.Regime+
                         "| "+FLDTOSTR(_Day)+" ᫮");
 END {CheckRegList};

 PRIVATE PROCEDURE IncrTotal(VAR _Total: NUMERIC[5]; _Incr: NUMERIC[5]);
 BEGIN
  IF !_Total THEN
   _Total:=0;
  END;
  INC(_Total, _Incr);
 END {IncrTotal};

 PRIVATE PROCEDURE PFct();
  VAR
   Idx: SCAL[AbsCauseNum];
 BEGIN
  CONFORM(Sheet, JMode);
  IF JMode.Type = L_Sheet.jmType_TimDone THEN
   SAVE(RegList);
   INC(DaysTot);
   IF Sheet.Day<=15 THEN
    INC(DaysTotHalf);
    INC(HourTotHalf,        Sheet.Tim);
   END;
   INC(HourTot,             Sheet.Tim);
   INC(SpTim[Sheet.SpKind], Sheet.SpTime);
   Time[Sheet.Day]:=FLDTOSTR(Sheet.Tim, "2.", 5);
   Sign[Sheet.Day]:=SetSign();
   IF JMode.PayHldy THEN
    INC(HolTime, L_Sheet.HolTimeByDate(Sheet.Period+(Sheet.Day-1), Sheet.Tim, Sheet.DayTime));
   END;
   RESTORE(RegList);
  ELSE
   Idx:=GetIdxAbs(SetSign());
   IF ~!Idx THEN
    IncrTotal(DaysAbs[Idx], 1);
    IF JMode.PrintHrs THEN
     IncrTotal(HourAbs[Idx], Sheet.Tim);
    END;
   END;
   IF JMode.PrintHrs THEN
    Time[Sheet.Day]:=FLDTOSTR(Sheet.Tim, "2.", 5);
   END;
   Sign[Sheet.Day]:=SetSign();
  END;
 END {PFct};

 PRIVATE PROCEDURE StaffInStateInD(trgD: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(StaffLog);
  Result:=L_Staff.rInState(trgD);
  RESTORE(StaffLog);
  RETURN Result;
 END {StaffInStateInD};

 PRIVATE PROCEDURE OneDay(d: SCAL[32]; P: PROC);
  VAR D: DATE;
 BEGIN
  D:=L_DatTim.Per(_CurDate) + d - 1;
  IF StaffInStateInD(D) THEN
   IF L_Staff.InOrder(D) THEN
    P();
   ELSE
    Time[d]:="  X  ";
   END;
  ELSE
   Time[d]:="  ";
  END;
 END {OneDay};

 PRIVATE PROCEDURE PassFct();
 BEGIN
  SELECT(Sheet, TSN, , StaffLog.TSN, L_DatTim.Per(_CurDate));
  WHILE OCCURE(Sheet) & ((Sheet.Period+Sheet.Day-1)<=_CurDate) DO
   OneDay(Sheet.Day, PROCREF(PFct));
   NEXT(Sheet);
  END; (* WHILE *)
 END {PassFct};

 PRIVATE PROCEDURE E_Blank_wInformativeSheet(P: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(P, PROCREF(E_PRoll.Blank_wInformativeSheet), 0);
 END {E_Blank_wInformativeSheet};

 PRIVATE PROCEDURE PassReg();
  VAR
   _Day   : LIKE(RegList.Day);
   _Period: DATE;
 BEGIN
  _Day:=1; _Period:=L_DatTim.Per(_CurDate);
  CheckRegList(SELECT(RegList, HumReg, StaffLog.Regime, _Period), _Day);
  CONFORM(RegList, RegHead);
  WHILE OCCURE(RegList) DO
   CheckRegList(_Day=RegList.Day, _Day);
   IF E_Blank_wInformativeSheet(L_DatTim.Per(_CurDate)) &
      SEARCH(Sheet, TSN, StaffLog.TSN, _Period, _Day) &
      (Sheet.Source = L_Sheet.src_AvePay) THEN
    OneDay(Sheet.Day, PROCREF(PFct));
   ELSE
    OneDay(RegList.Day, PROCREF(PReg));
   END;
   IF NEXT(RegList) THEN
    INC(_Day);
   END;
  END; (* WHILE *)
  CheckRegList(_Day=L_DatTim.MonthLen(_Period), _Day);
 END {PassReg};

 PRIVATE PROCEDURE PassEmp();
 BEGIN
  SETEMPTY(HourTot, HourTotHalf, SpTim, HolTime, DaysTot, DaysTotHalf);
 END {PassEmp};

 PRIVATE PROCEDURE MakeLine();
 BEGIN
  SETZERO(HourTot, HourTotHalf, SpTim, HolTime, DaysTot, DaysTotHalf);
  SETEMPTY(Time, Sign, SignAbs, DaysAbs, HourAbs);
  CONFORM(StaffLog, Man, Officer, Post);
  Pass();
  L_PagePr.PagePr_BeforePrintLine(DEPTH("Line"));
  MAKEPART(R, Line);
  w_PutSingleStaff();
 END {MakeLine};

 PRIVATE PROCEDURE GetMkBlank(Content: tContentType; Mode: tMakeMode): SCAL[2];
 BEGIN
  RETURN (Mode=mm_explSngTK) | (Mode=mm_condSngTSN) |
         (BlankMode(Content)&TimeKeep.MkBlank) | (~BlankMode(Content)&TimeKeep.MkSheet);
 END {GetMkBlank};

 PRIVATE PROCEDURE AddToMyFirms(VAR MyFirms: P_Firm.tMyFirm[100]; _MyFirm: P_Firm.tMyFirm);
  VAR
   Idx: NUMERIC[0];
 BEGIN
  Idx:=0;
  WHILE ~!MyFirms[Idx] DO
   IF MyFirms[Idx] = _MyFirm THEN
    RETURN;
   END;
   INC(Idx);
  END;
  MyFirms[Idx]:=_MyFirm;
 END {AddToMyFirms};

 PRIVATE PROCEDURE w_PutSingleStaff();
  VAR
   i: NUMERIC[0];
   r: STRING[];
 BEGIN
  IF ~!Root THEN
   r:=Root + ".Line" + L_MSO.IndexStr(Nbr-1);
   L_MSO.wordSetVar(r + ".Number", L_Str.IntStr(Nbr));
   L_MSO.wordSetVar(r + ".Man.Name.Short", L_Str.ShortName(Man.Name));
   L_MSO.wordSetVar(r + ".Staff.Post.Name",  Post.Name);
   L_MSO.wordSetVar(r + ".Staff.TSN", Staff.TSN);
   i:=1;
   WHILE i <= 31 DO
    L_MSO.wordSetVar(r + ".Sign" + L_Str.FixedIntStr(i, 2), Sign[i]);
    L_MSO.wordSetVar(r + ".Time" + L_Str.FixedIntStr(i, 2), Time[i]);
    INC(i);
   END;
   i:=0;
   WHILE i < 8 DO
    L_MSO.wordSetVar(r + ".Abs" + L_Str.FixedIntStr(i, 1) + ".Sign" , SignAbs[i]);
    L_MSO.wordSetVar(r + ".Abs" + L_Str.FixedIntStr(i, 1) + ".Days" , L_Str.IntStr(DaysAbs[i]));
    IF ~!HourAbs[i] THEN
     L_MSO.wordSetVar(r + ".Abs" + L_Str.FixedIntStr(i, 1) + ".Hours", "(" + FLDTOSTR(HourAbs[i], "2.", 0) + ")");
    ELSE
     L_MSO.wordSetVar(r + ".Abs" + L_Str.FixedIntStr(i, 1) + ".Hours", "");
    END;
    INC(i);
   END;
   L_MSO.wordSetVar(r + ".Half1Days", L_Str.IntStr(DaysTotHalf));
   L_MSO.wordSetVar(r + ".Half2Days", L_Str.IntStr(DaysTot-DaysTotHalf));
   L_MSO.wordSetVar(r + ".TotalDays", L_Str.IntStr(DaysTot));
   L_MSO.wordSetVar(r + ".Half1Hours", FLDTOSTR(HourTotHalf, "2.", 0));
   L_MSO.wordSetVar(r + ".Half2Hours", FLDTOSTR(HourTot-HourTotHalf, "2.", 0));
   L_MSO.wordSetVar(r + ".TotalHours", FLDTOSTR(HourTot, "2.", 0));

   i:=0;
   SELECT(Money, TSN, , StaffLog.TSN, Memo.ud_mb(), Memo.ud_mb(), StaffLog.Date);
   WHILE OCCURE(Money) & (i < 8) DO
    IF (Money.Tim # 0) & (Money.Source = L_PRoll.src_Sheet) THEN
     L_MSO.wordSetVar(r + ".Mon" + L_Str.FixedIntStr(i, 1) + ".MCode", Money.MCode);
     L_MSO.wordSetVar(r + ".Mon" + L_Str.FixedIntStr(i, 1) + ".Acnt" , L_Acnt.GetCAcntSign(_CurDate, L_PRoll.GetMCListAcCut(Money.MCode, L_DatTim.Per(_CurDate))));
     L_MSO.wordSetVar(r + ".Mon" + L_Str.FixedIntStr(i, 1) + ".Hours", FLDTOSTR(Money.Tim, "2.", 0));
     INC(i);
    END;
    NEXT(Money);
   END; (* WHILE OCCURE(Money) ... *)
   WHILE i < 8 DO
    L_MSO.wordSetVar(r + ".Mon"  + L_Str.FixedIntStr(i, 1) + ".MCode", "");
    L_MSO.wordSetVar(r + ".Mon"  + L_Str.FixedIntStr(i, 1) + ".Acnt" , "");
    L_MSO.wordSetVar(r + ".Mon"  + L_Str.FixedIntStr(i, 1) + ".Hours", "");
    INC(i);
   END;
  END;
 END {w_PutSingleStaff};

 PRIVATE PROCEDURE w_InitSingleTimeKeep();
 BEGIN
  IF ~!Root THEN
   L_MSO.wordInitDocument(_CurDate);
  END;
 END {w_InitSingleTimeKeep};

 PRIVATE PROCEDURE w_PutSingleTimeKeep();
 BEGIN
  IF ~!Root THEN
   P_Firm.SetFirmDefaultData("My",  Firm.Firm, _CurDate, "");
   L_MSO.wordSetVar    (Root + ".OKPO", P_Firm.FP_OKPO(Firm.Firm, SYSDATE()));
   L_MSO.wordSetVarsByFile_wPrefix("TimeKeep", Root + ".");
   L_MSO.wordSetVar(Root + ".SrcNbr",  TimeKeep.TimeKeep + "/" + FLDTOSTR(Memo.ud_mb(), "N.y", 0));
   L_MSO.wordSetDateVar(Root + ".PrpDate", PreparationDate);
   L_MSO.wordSetDateVar(Root + ".From",    Memo.ud_mb());
   L_MSO.wordSetDateVar(Root + ".UpTo",    Memo.ud_me());
   L_MSO.SetWordTable("Sht01", Nbr);
   L_MSO.PutInTables:=L_MSO.Put_Values;
   L_MSO.MakeWordDocument("T13", 1, L_MSO.PrpMode_ToDoc, "");
  END;
 END {w_PutSingleTimeKeep};

 PRIVATE PROCEDURE MakeTimeKeep(Content: tContentType; Mode: tMakeMode);
  VAR
   MyFirms: P_Firm.tMyFirm[100];
 BEGIN
  IF GetMkBlank(Content, Mode) THEN
   IF    TimeKeep.SrtOrder = L_Staff.tkso_ByTSN          THEN SELECT(_TK, TSN, ,      TimeKeep.TimeKeep);
   ELSIF TimeKeep.SrtOrder = L_Staff.tkso_BySortTSN      THEN SELECT(_TK, Sort, ,     TimeKeep.TimeKeep);
   ELSIF TimeKeep.SrtOrder = L_Staff.tkso_ByOfcrTSN      THEN SELECT(_TK, Officer, ,  TimeKeep.TimeKeep);
   ELSIF TimeKeep.SrtOrder = L_Staff.tkso_ByOfcrShiftTSN THEN SELECT(_TK, OfcShift, , TimeKeep.TimeKeep);
   ELSE
    L_General.CallUs(0);
   END;

   IF OCCURE(_TK) | (Content # ct_Fct) THEN
    IF Mode = mm_explSngTK THEN
     SETEMPTY(MyFirms);
     WHILE OCCURE(_TK) DO
      NARROWSEL(_TK, _MyFirm);
      AddToMyFirms(MyFirms, _TK._MyFirm);
      NEXTINEXTENDEDSEL(_TK, _MyFirm);
     END;
     IF    !MyFirms[0] THEN
      SEARCH(Firm, Firm, , P_Firm.fomf(P_Firm.mf_Fict));
     ELSIF !MyFirms[1] THEN
      SEARCH(Firm, Firm, , P_Firm.fomf(MyFirms[0]));
     ELSE
      SEARCH(Firm, Firm, , P_Firm.fomf(P_Firm.extDefineMyFirm(_CurDate, MyFirms)));
     END;
     L_PagePr.PagePr_Init("R", PagLength, PROCREF(_RprtTop), PROCREF(_PageTop), PROCREF(_PageBot),
                                          PROCREF(_RprtBot), PROCREF(_EBFilling));
     L_PagePr.PagePr_Done();
     Page:=L_PagePr.PagePr_CurrentPage();
    END;

    WHILE OCCURE(_TK) DO
     SEARCH(Firm, Firm, , P_Firm.fomf(_TK._MyFirm));
     NARROWSEL(_TK, _MyFirm);
     w_InitSingleTimeKeep();
     L_PagePr.PagePr_Init("R", PagLength, PROCREF(_RprtTop), PROCREF(_PageTop), PROCREF(_PageBot),
                                          PROCREF(_RprtBot), PROCREF(_Filling));
     Nbr:=0;
     WHILE OCCURE(_TK) DO
      PROMPT(TimeKeep.TimeKeep + " : " + _TK._TSN);
      INC(Nbr);
      SEARCH(StaffLog, TSN, , _TK._TSN, _TK._Date);
      MakeLine();
      NEXT(_TK);
     END; (* WHILE OCCURE(_TK) ... *)
     NEXTINEXTENDEDSEL(_TK, _MyFirm);
     L_PagePr.PagePr_Done();
     w_PutSingleTimeKeep();
     Page:=L_PagePr.PagePr_CurrentPage();
    END;
   END (* IF OCCURE(_TK) ...*);
  END;
 END {MakeTimeKeep};

 PRIVATE PROCEDURE MakeIndexStaffLog();
 BEGIN
  IF L_Env.RealTSN(StaffLog.TSN) &
     L_Staff.OrderInMonth(L_DatTim.Per(_CurDate)) & ~L_Staff.IsDischargeStaffLog() THEN
   CONFORM(StaffLog, Staff);
   _TK._TK     :=Officer.TimeKeep;
   _TK._MyFirm :=L_Staff.GetStaffMyFirm();
   _TK._TSN    :=StaffLog.TSN;
   _TK._Sort   :=StaffLog.Sort;
   _TK._Officer:=StaffLog.Officer;
   _TK._ShftNum:=GetTSNShiftNumber(StaffLog.Sort, StaffLog.Officer, StaffLog.Regime);
   _TK._Date   :=StaffLog.Date;
   INSERT(_TK);
  END;
 END {MakeIndexStaffLog};

 PRIVATE PROCEDURE GetTSNShiftNumber(_Sort   : LIKE(Officer.Sort);
                                     _Officer: LIKE(Officer.Officer);
                                     _Regime : LIKE(RegMain.Regime)): LIKE(Shift.Number);
 BEGIN
  IF SEARCH(OfcShift, Officer, _Sort, _Officer, _Regime) THEN
   CONFORM(OfcShift, Shift);
   RETURN Shift.Number;
  ELSE
   RETURN P_Officer.ost_NoShift;
  END;
 END {GetTSNShiftNumber};

 PRIVATE PROCEDURE MakeIndex(Content: tContentType; Mode: tMakeMode);
 BEGIN
  L_AFM.MakeMultipleIndex("_TK", "_TK     : LIKE(TimeKeep.TimeKeep);"+
                                 "_MyFirm : "+GET_TYPE_SPEC(P_Firm.tMyFirm).Name +";"+
                                 "_TSN    : LIKE(Staff.TSN);"+
                                 "_Sort   : LIKE(Sort.Sort);"+
                                 "_Officer: LIKE(Officer.Officer);"+
                                 "_ShftNum: LIKE(Shift.Number);"+
                                 "_Date   : LIKE(StaffLog.Date)",
                          "TSN     : _TK, _MyFirm, _TSN, _Date;"+
                          "Sort    : _TK, _MyFirm, _Sort, _TSN;"+
                          "Officer : _TK, _MyFirm, _Sort, _Officer, _TSN;"+
                          "OfcShift: _TK, _MyFirm, _Sort, _Officer, _ShftNum, _TSN;"+
                          "JustTSN : _TSN");
  SETEMPTY(WkDay);
  SELECT(Calendar, Period, , L_DatTim.Per(_CurDate));
  WHILE OCCURE(Calendar) DO
   PROMPT(L_DatTim.DateStr(Calendar.Date));
   WkDay[Calendar.Day]:=L_DatTim.WeekDayShortStr(Calendar.WeekDay);
   NEXT(Calendar);
  END; (* WHILE OCCURE(Calendar) ... *)

  IF Mode = mm_condSngTSN THEN
   SELECT(StaffLog, TSN, , Staff.TSN);
   WHILE OCCURE(StaffLog) DO
    MakeIndexStaffLog();
    NEXT(StaffLog);
   END; (* WHILE OCCURE(StaffLog) ... *)
  ELSE
   IF Mode = mm_condAllTK THEN
    SELECT(TimeKeep, TimeKeep);
   ELSE
    CHANGESEL(TimeKeep, TimeKeep, , TimeKeep.TimeKeep);
   END;
   WHILE OCCURE(TimeKeep) DO
    IF GetMkBlank(Content, Mode) THEN
     SELECT(Officer, TimeKeep, , TimeKeep.TimeKeep);
     WHILE OCCURE(Officer) DO
      SELECT(StaffLog, Officer, , Officer.Sort, Officer.Officer);
      WHILE OCCURE(StaffLog) DO
       PROMPT(" "+TimeKeep.TimeKeep+" : "+StaffLog.TSN);
       MakeIndexStaffLog();
       NEXT(StaffLog);
      END; (* WHILE OCCURE(StaffLog) ... *)
      NEXT(Officer);
     END; (* WHILE OCCURE(Officer) ... *)
    END;
    NEXT(TimeKeep);
   END; (* WHILE OCCURE(TimeKeep) ... *)
  END; (* IF Mode = mm_condSngTSN *)
  IF Content = ct_Fct THEN
   SELECT(_TK, JustTSN);
   WHILE OCCURE(_TK) DO
    NARROWSEL(_TK, _TSN);
    SEARCH(Staff, TSN, , _TK._TSN);
    PROMPT("஫  " + Staff.TSN);
    IF ~L_PRoll.IsShtD_OnDate(_CurDate) THEN
     CALL(CalcDed.FillSheetOnDate());
    END;
    NEXTINEXTENDEDSEL(_TK, _TSN);
   END; (* WHILE OCCURE(_TK) ... *)
  END; (* IF Content = ct_Fct *)
 END {MakeIndex};

 PRIVATE PROCEDURE SetPatt();
 BEGIN
  SetPrintAttr(R, TopMargin,       6,
                  BottomMargin,    6,
                  RightMargin,     20,
                  LeftMargin,      20,
                  FontEnlargement, 1.3,
                  LinesPerPage,    PagLength);
 END {SetPatt};

 PRIVATE PROCEDURE Make(Content: tContentType; Mode: tMakeMode);
 BEGIN
  IF (SYSDATE() < Memo.ud_me()) & ~BlankMode(Content) THEN
   _CurDate:=Memo.ud_cd();
   L_StdFrm.Question("   襭.| ⠡  "+L_DatTim.DateStr(_CurDate));
  ELSE
   _CurDate:=Memo.ud_me();
  END;

  IF    Content = ct_Reg THEN
   Pass:=PROCREF(PassReg);
  ELSIF Content = ct_Fct THEN
   Pass:=PROCREF(PassFct);
  ELSE
   Pass:=PROCREF(PassEmp);
  END;

  E_PrtSht_GetHeader(Content);

  IF L_General.IsPolakSpecific() THEN
   Root:="Sht";
  ELSE
   SETEMPTY(Root);
  END;
  Page:=1;
  IF Mode = mm_condAllTK THEN
   MakeIndex(Content, Mode);
   OPENREP(R, L_General.NameMonth("Sht"), Create);
   SetPatt();
   SELECT(TimeKeep, TimeKeep);
   WHILE OCCURE(TimeKeep) DO
    MakeTimeKeep(Content, Mode);
    NEXT(TimeKeep);
   END; (* WHILE OCCURE(TimeKeep) ... *)
  ELSE
   IF Mode = mm_condSngTSN THEN
    L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
    L_Staff.PosToStaffLog(Staff.TSN, _CurDate, 1);
    CONFORM(StaffLog, Officer, TimeKeep);
   ELSE
    L_General.Assert(ACCESS(TimeKeep), " ⠭ ⠡騪");
   END;
   SAVE(TimeKeep);
   MakeIndex(Content, Mode);
   RESTORE(TimeKeep);
   OPENREP(R, L_General.NameConnection("Sheet"), Create);
   SetPatt();
   MakeTimeKeep(Content, Mode);
  END;
  CLOSEREP(R);
  IF !Root THEN
   L_General.SurveyLastReport();
  END;
 END {Make};

 PUBLIC PROCEDURE Reg_All();
 BEGIN
  IF L_APtm.IsOG() THEN
   CALL(OGSht.Reg_All());
  ELSE
   Make(ct_Reg, mm_condAllTK);
  END;
 END {Reg_All};

 PUBLIC PROCEDURE Reg_Sngl();
 BEGIN
  Make(ct_Reg, mm_condSngTK);
 END {Reg_Sngl};

 PUBLIC PROCEDURE Fct_All();
 BEGIN
  IF L_APtm.IsOG() THEN
   CALL(OGSht.Fct_All());
  ELSE
   Make(ct_Fct, mm_condAllTK);
  END;
 END {Fct_All};

 PUBLIC PROCEDURE Fct_Sngl();
 BEGIN
  Make(ct_Fct, mm_condSngTK);
 END {Fct_Sngl};

 PUBLIC PROCEDURE Emp_Sngl();
 BEGIN
  Make(ct_Emp, mm_condSngTK);
 END {Emp_Sngl};

 PUBLIC PROCEDURE EmptyBlank();
 BEGIN
  Make(ct_Emp, mm_explSngTK);
 END {EmptyBlank};

 PUBLIC PROCEDURE Fct_CurStaff();
 BEGIN
  IF L_APtm.IsOG() THEN
   CALL(OGSht.Fct_CurStaff());
  ELSE
   Make(ct_Fct, mm_condSngTSN);
  END;
 END {Fct_CurStaff};

END.
