(*
%Copyright   (c) Polak IT
%Author      15.12.2003 20:23:15 POLAK\LDA
%Purpose       ᢮⢠ 㬥
%Type        library
%Specific    SYS
%Modified    28.05.2014 19:38:10 POLAK\GAV
%Environment
*)

 MODULE P_AveP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tftYear    = SCAL[1E4];
  tftPayMode = SCAL[2];

 PUBLIC CONST
  P_SickList = 3000;
  P_Features = 3001;
  P_DaysAmount = 3002;

  ft_Limit_No   = 0;
  ft_Limit_Yes  = 1;
  ft_Limit_Pool = "|";

  ft_FirstDaysByFirm_Pool = "|2|1|3";

  ft_PayMode_2010 = 0;
  ft_PayMode_2011 = 1;
  ft_PayMode_Pool = " 2011|C 2011";

  sl_ModePool    = "㫠|樮|蠭";

  VAR
   RecordidArr: LIKE(ManFml.RECORDID)[20];

 IMPORT L_General, L_AvePay, L_Prop, L_Str, L_WDO, L_r2r, L_Man, Str, L_DatTim;

 PUBLIC PROCEDURE PropertyModificationAllowed(trgProperty: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF trgProperty = P_SickList THEN
   RETURN L_Prop.mac_Full;
  ELSE
   RETURN L_Prop.mac_Inside;
  END;
 END {PropertyModificationAllowed};

 PUBLIC PROCEDURE GetSubWindowName(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_SickList   THEN RETURN "P_3000";
  ELSIF trgProperty = P_Features   THEN RETURN "P_3001";
  ELSIF trgProperty = P_DaysAmount THEN RETURN "P_3002";
  ELSE                                  RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE GetPool(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF L_Prop.IsLocalProperty(trgProperty) THEN
   RETURN L_Prop.E_GetPool(trgProperty);
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PUBLIC PROCEDURE SearchPro(trgAvePay: LIKE(AvePay.AvePay); trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SELECT(AvePPro, AvePay, trgAvePay, trgProperty);
 END {SearchPro};

 PUBLIC PROCEDURE HasActualPro(trgAvePay: LIKE(AvePay.AvePay); trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SearchPro(trgAvePay, trgProperty) & ~!AvePPro.Value;
 END {HasActualPro};

 PRIVATE PROCEDURE GetProValue(trgAvePay  : LIKE(AvePay.AvePay);
                               trgProperty: LIKE(Property.Property);
                               Strong     : SCAL[2]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF HasActualPro(trgAvePay, trgProperty) THEN
   Result:=AvePPro.Value;
  ELSE
   SETEMPTY(Result);
   IF Strong THEN
    SEARCH(AvePay, AvePay, , trgAvePay);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("AvePay").Id, AvePay.RECORDID, trgProperty, EMPTYOF(DATE));
   END;
  END;
  RETURN Result;
 END {GetProValue};

 PUBLIC PROCEDURE GetProValueSoft(trgAvePay  : LIKE(AvePay.AvePay);
                                  trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetProValue(trgAvePay, trgProperty, 0);
 END {GetProValueSoft};

 PUBLIC PROCEDURE GetProValueStrong(trgAvePay  : LIKE(AvePay.AvePay);
                                    trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetProValue(trgAvePay, trgProperty, 1);
 END {GetProValueSoft};

 PRIVATE PROCEDURE GetFmlMember_Name(): STRING[];
 BEGIN
  RETURN Str.Align(L_Str.PoolItem(L_Man.FmlMemberPool, ManFml.Member), 10, LEFT) + " " + ManFml.Name;
 END {GetFmlMember_Name};

 PRIVATE PROCEDURE GetManFmlList(): STRING[];
  VAR
   Result: STRING[];
   i     : NUMERIC[0];
 BEGIN
  CONFORM(AvePPro, AvePay, Staff, Man, ManFml);
  SETEMPTY(RecordidArr, Result); i:=0;
  SELECT(ManFml, Man, , Man.Man);
  WHILE OCCURE(ManFml) DO
   Result:=Result +GetFmlMember_Name()+"|";
   RecordidArr[i]:=ManFml.RECORDID;
   INC(i);
   NEXT(ManFml);
  END; (* WHILE OCCURE(ManFml) ... *)
  RETURN Result;
 END {GetManFmlList};

 PRIVATE PROCEDURE SetFieldModifiable_Features(Fields: FORM_FIELDS);
 BEGIN
  IF Fields("PayMode").Value = ft_PayMode_2010 THEN
   L_General.Assert(!Fields("Year_0").Value & !Fields("Year_1").Value, " 2011   ਬ 㪠|⭮ ਮ ().|⭮, ᫥   ਮ");
  END;
  Fields("Year_0").Modifiable:=Fields("PayMode").Value # ft_PayMode_2010;
  Fields("Year_1").Modifiable:=Fields("PayMode").Value # ft_PayMode_2010;
 END {SetFieldModifiable_Features};

 PUBLIC PROCEDURE OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_Features THEN
   SetFieldModifiable_Features(RTI.Get().CurZone.Fields);
  END;
 END {OnSuccessfulChange};

 PUBLIC PROCEDURE CanHavePro(trgProperty: LIKE(Property.Property); D: DATE);
 BEGIN
  ACCESS(AvePay);
  CONFORM(AvePay, AveType);
  IF    (trgProperty = P_SickList) |
        (trgProperty = P_Features) THEN
   L_General.Assert(~!AvePay.AveType, " 㪠  㬥  ⢨/ -।");
   IF AveType.AveNo # L_AvePay.aveno_Sick THEN
    L_General.Error("⢮ " + trgProperty + " 㪠뢠 ⮫쪮  쭨 ⮢| |" +
                   "(⨯ ।   㬥   '/.')");
   END;
  ELSIF (trgProperty = P_DaysAmount) THEN
   L_General.Assert(~!AvePay.AveType, " 㪠  㬥  ⢨/ -।");
   IF (AveType.LimType # L_AvePay.avelim_Hldy) | L_AvePay.AvePayHasJMode() THEN
    L_General.Error("⢮ " + trgProperty + " 㪠뢠 ⮫쪮" +
                    "| 樨  ᯮ짮 ");
   END;
  END;
 END {CanHavePro};

 PUBLIC PROCEDURE Check(trgProperty: LIKE(Property.Property));
 BEGIN
  IF (trgProperty = P_DaysAmount) THEN
   L_Prop.CheckNumericValue(AvePPro.Value, "3.");
  END;
 END {Check};

 PUBLIC PROCEDURE sl_DecodeValue(VAR curDisease          : LIKE(Disease.Disease);
                                 VAR curFirm             : LIKE(Firm.Firm);
                                 VAR curResponsiblePerson: STRING[];
                                 VAR curMode             : STRING[];
                                 VAR curManFmlRID,
                                     curManFmlRID2       : LIKE(ManFml.RECORDID));
 BEGIN
  curDisease          :=L_r2r.Decode(L_Prop.getRES(AvePPro.Value, 0));
  curFirm             :=L_r2r.Decode(L_Prop.getRES(AvePPro.Value, 1));
  curResponsiblePerson:=L_Prop.getRES(AvePPro.Value, 2);
  curMode             :=L_Prop.getRES(AvePPro.Value, 3);
  curManFmlRID        :=L_r2r.Decode(L_Prop.getRES(AvePPro.Value, 4));
  curManFmlRID2       :=L_r2r.Decode(L_Prop.getRES(AvePPro.Value, 5));
 END {sl_DecodeValue};

 PUBLIC PROCEDURE Decode_Features(    curValue       : STRING[];
                                  VAR Limit,
                                      FirstDaysByFirm: STRING[];
                                  VAR Year_0,
                                      Year_1         : tftYear;
                                  VAR PayMode        : tftPayMode);
 BEGIN
  Limit          :=L_Prop.getRES(curValue, 0);
  FirstDaysByFirm:=L_Prop.getRES(curValue, 1);
  Year_0         :=L_Prop.getRES(curValue, 2);
  Year_1         :=L_Prop.getRES(curValue, 3);
  PayMode        :=L_Prop.getRES(curValue, 4);
 END {Decode_Features};

 PRIVATE PROCEDURE formSet_Features();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_Features(AvePPro.Value,
                  Fields("Limit").Value,
                  Fields("FirstDaysByFirm").Value,
                  Fields("Year_0").Value,
                  Fields("Year_1").Value,
                  Fields("PayMode").Value);
  Fields("Limit"          ).Template        :=ft_Limit_Pool;
  Fields("Limit"          ).TemplateIsStrict:=1;
  Fields("FirstDaysByFirm").Template        :=ft_FirstDaysByFirm_Pool;
  Fields("FirstDaysByFirm").TemplateIsStrict:=1;
  Fields("PayMode"        ).Format          :=ft_PayMode_Pool;
  SetFieldModifiable_Features(Fields);
 END {formSet_Features};

 PRIVATE PROCEDURE SetFmlMember_Name(curMemberRID: LIKE(ManFml.RECORDID); FmlMember_Name: FORM_FIELD): SCAL[20];
  VAR
   curManFmlList: STRING[];
 BEGIN
  curManFmlList:=GetManFmlList();
  IF !curManFmlList THEN
   FmlMember_Name.Visible:=0;
   RETURN "";
  ELSE
   FmlMember_Name.Visible:=1;
   FmlMember_Name.Format:=curManFmlList;
   IF ~!curMemberRID THEN
    SEARCH(ManFml, RECORDID, , curMemberRID);
    RETURN L_Str.PositionInPool(curManFmlList, GetFmlMember_Name());
   ELSE
    RETURN "";
   END;
  END;
 END {SetFmlMember_Name};

 PRIVATE PROCEDURE formSet_SickList();
  VAR
   Fields: FORM_FIELDS;
   curManFmlRID,
   curManFmlRID2: LIKE(ManFml.RECORDID);
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Mode").Template:=sl_ModePool;
  L_WDO.CreateFormLink("Firm", "");
  L_WDO.CreateFormLink("Disease", "");
  Fields("Disease_Sign").Expression:="SELF.Zone.LinkedFieldValue('" + "Disease" + ".Sign')";
  sl_DecodeValue(Fields("Disease").Value, Fields("Firm").Value, Fields("ResponsiblePerson").Value,
                 Fields("Mode").Value, curManFmlRID, curManFmlRID2);
  Fields("FmlMember_Name").Value :=SetFmlMember_Name(curManFmlRID,  Fields("FmlMember_Name"));
  Fields("FmlMember_Name2").Value:=SetFmlMember_Name(curManFmlRID2, Fields("FmlMember_Name2"));
 END {formSet_SickList};

 PUBLIC PROCEDURE SetDataInForm(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_SickList THEN formSet_SickList();
  ELSIF trgProperty = P_Features THEN formSet_Features();
  END;
 END {SetDataInForm};

 PRIVATE PROCEDURE GetFmlMemberRID(FmlMember_Name: FORM_FIELD): LIKE(ManFml.RECORDID);
  VAR
   curManFmlList: STRING[];
 BEGIN
  IF ~!FmlMember_Name.Value THEN
   curManFmlList:=GetManFmlList();
   RETURN RecordidArr[FmlMember_Name.Value];
  ELSE
   RETURN "";
  END;
 END {GetFmlMemberRID};

 PRIVATE PROCEDURE formGet_SickList();
  VAR
   Fields              : FORM_FIELDS;
   trgDisease          : LIKE(Disease.Disease);
   trgFirm             : LIKE(Firm.Firm);
   trgMode,
   trgResponsiblePerson: STRING[];
   trgManFmlRID2,
   trgManFmlRID        : LIKE(ManFml.RECORDID);
 BEGIN
  SETEMPTY(AvePPro.Value);
  Fields:=RTI.Get().CurZone.Fields;
  trgDisease          :=Fields("Disease").Value;
  trgFirm             :=Fields("Firm").Value;
  trgResponsiblePerson:=Fields("ResponsiblePerson").Value;
  trgMode             :=Fields("Mode").Value;
  trgManFmlRID        :=GetFmlMemberRID(Fields("FmlMember_Name"));;
  trgManFmlRID2       :=GetFmlMemberRID(Fields("FmlMember_Name2"));;

  L_Prop.putRES(AvePPro.Value, L_r2r.Put("AvePPro", "Disease", trgDisease));
  L_Prop.putRES(AvePPro.Value, L_r2r.Put("AvePPro", "Firm", trgFirm));
  L_Prop.putRES(AvePPro.Value, trgResponsiblePerson);
  L_Prop.putRES(AvePPro.Value, trgMode);
  L_Prop.putRES(AvePPro.Value, L_r2r.Put("AvePPro", "ManFml", trgManFmlRID));
  L_Prop.putRES(AvePPro.Value, L_r2r.Put("AvePPro", "ManFml", trgManFmlRID2));
  L_Prop.ConvEmptyRecordPropertyValue(AvePPro.Value);
  REPLACE(AvePPro);
 END {formGet_SickList};

 PRIVATE PROCEDURE GetVal2Show_SickList(): STRING[];
  VAR
   Result              : STRING[];
   curDisease          : LIKE(Disease.Disease);
   curFirm             : LIKE(Firm.Firm);
   curResponsiblePerson,
   curMode             : STRING[];
   curMember2,
   curMember           : LIKE(ManFml.RECORDID);
 BEGIN
  SETEMPTY(Result);
  sl_DecodeValue(curDisease, curFirm, curResponsiblePerson, curMode, curMember, curMember2);
  L_Prop.putRES(Result, curDisease);
  L_Prop.putRES(Result, curFirm);
  L_Prop.putRES(Result, curResponsiblePerson);
  L_Prop.putRES(Result, curMode);
  L_Prop.putRES(Result, curMember);
  L_Prop.putRES(Result, curMember2);
  RETURN Result;
 END {GetVal2Show_SickList};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
 BEGIN
  IF AvePPro.Property = P_SickList THEN
   RETURN GetVal2Show_SickList();
  ELSE
   RETURN AvePPro.Value;
  END;
 END {GetVal2Show};

 PUBLIC PROCEDURE Encode_Features(VAR curValue       : STRING[];
                                      Limit,
                                      FirstDaysByFirm: STRING[];
                                      Year_0,
                                      Year_1         : tftYear;
                                      PayMode        : tftPayMode);
 BEGIN
  SETEMPTY(curValue);
  L_Prop.putREV(curValue, Limit);
  L_Prop.putREV(curValue, FirstDaysByFirm);
  L_Prop.putREV(curValue, Year_0);
  L_Prop.putREV(curValue, Year_1);
  L_Prop.putREV(curValue, PayMode);
  AvePPro.Val2Show:=GetVal2Show();
  REPLACE(AvePPro);
 END {Encode_Features};

 PRIVATE PROCEDURE formGet_Features();
  VAR
   Fields: FORM_FIELDS;
   MinY,
   MaxY : tftYear;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_General.Assert(!Fields("Year_0").Value = !Fields("Year_1").Value, "뢠     ");
  IF ~!Fields("Year_0").Value THEN
   MaxY:=L_DatTim.YEAR(AvePay.StartD);
   MinY:=MaxY-20;
   L_General.Assert((Fields("Year_0").Value >= MinY) & (Fields("Year_0").Value <= MaxY), " ਮ ()    ࢠ  "+MinY+"  "+MaxY);
   L_General.Assert((Fields("Year_1").Value >= MinY) & (Fields("Year_1").Value <= MaxY), " ਮ ()    ࢠ  "+MinY+"  "+MaxY);
  END;
  Encode_Features(AvePPro.Value,
                  Fields("Limit").Value,
                  Fields("FirstDaysByFirm").Value,
                  Fields("Year_0").Value,
                  Fields("Year_1").Value,
                  Fields("PayMode").Value);
 END {formGet_Features};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_SickList THEN formGet_SickList();
  ELSIF trgProperty = P_Features THEN formGet_Features();
  END;
  REPLACE(AvePPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE Add_Features(trgAvePay      : LIKE(AvePay.AvePay);
                               Limit,
                               FirstDaysByFirm: STRING[];
                               Year_0,
                               Year_1         : tftYear;
                               PayMode        : tftPayMode);
 BEGIN
  L_General.CallUs(~HasActualPro(trgAvePay, P_Features));
  DEFAULT(AvePPro);
  AvePPro.AvePay  :=trgAvePay;
  AvePPro.Property:=P_Features;
  AvePPro.PropRow :=01;
  INSERT(AvePPro);
  Encode_Features(AvePPro.Value, Limit, FirstDaysByFirm, Year_0, Year_1, PayMode);
  AvePPro.Val2Show:=GetVal2Show();
  REPLACE(AvePPro);
 END {Add_Features};

 PUBLIC PROCEDURE Get_ft_PayMode(): tftPayMode;
  VAR
   Result         : tftPayMode;
   Limit,
   FirstDaysByFirm: STRING[];
   Year_0,
   Year_1         : tftYear;
 BEGIN
  Decode_Features(GetProValueSoft(AvePay.AvePay, P_Features), Limit, FirstDaysByFirm, Year_0, Year_1, Result);
  IF !Result THEN
   Result:=ft_PayMode_2011;
  ELSE
   L_General.Assert(AvePay.StartD < 01\01\2013, "冷 , ⢮訩  2011 ,"+
                                                "| ਬ  01.2013");
  END;
  RETURN Result;
 END {Get_ft_PayMode};

 PUBLIC PROCEDURE Get_ft_FirstDaysByFirm(): NUMERIC[0];
  VAR
   pi,
   Result         : NUMERIC[0];
   PayMode        : tftPayMode;
   Limit,
   FirstDaysByFirm: STRING[];
   Year_0,
   Year_1         : tftYear;
 BEGIN
  Decode_Features(GetProValueSoft(AvePay.AvePay, P_Features), Limit, FirstDaysByFirm, Year_0, Year_1, PayMode);
  IF !FirstDaysByFirm THEN
   Result:=0;
  ELSE
   pi:=L_Str.PositionInPool(ft_FirstDaysByFirm_Pool, FirstDaysByFirm);
   IF    pi = 0 THEN
    Result:=0;
   ELSIF pi = 1 THEN
    Result:=2;
   ELSIF pi = 2 THEN
    Result:=1;
   ELSIF pi = 3 THEN
    L_General.Assert(AvePay.StartD >= 01\01\2011, "    ࠡ⮤⥫ ਬ  01.2011");
    Result:=3;
   ELSE
    L_General.CallUs(0);
   END;
  END;
  RETURN Result;
 END {Get_ft_FirstDaysByFirm};

 PUBLIC PROCEDURE Get_DaysAmount(): NUMERIC[3];
 BEGIN
  IF HasActualPro(AvePay.AvePay, P_DaysAmount) THEN
   RETURN L_Prop.GetNumericValueFromStr(L_Prop.getRES(AvePPro.Value, 0));
  ELSE
   RETURN AvePay.Amount;
  END;
 END {Get_DaysAmount};

END.
