(*
%Copyright   (c) Polak IT
%Author      06.11.2008 17:16:36 POLAK\kns
%Purpose     ⥪  ࠡ  ᢮⢠ CostItem
%Type        library
%Specific    SYS
%Modified    10.12.2010 13:52:58 POLAK\SSV
%Environment
*)

 MODULE P_CI [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Prop;

 PUBLIC CONST
  P_VATMode = 7500;

 PUBLIC PROCEDURE GetPool(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    _Property = P_VATMode THEN
   RETURN " |।| ⮨";
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PRIVATE PROCEDURE HasAnyPro(_CostItem  : LIKE(CostItem.CostItem);
                             D          : DATE;
                             _Property  : LIKE(Property.Property);
                             CheckActual: SCAL[2]): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SAVE(CostItem);
  SEARCH(CostItem, CostItem, , _CostItem);
  LOOP
   IF SELECT(CIPro, CostItem, CostItem.CostItem, _Property) & SRCINSEL(CIPro, LE, D) THEN
    IF ~CheckActual | !CIPro.DocExpD | (D < CIPro.DocExpD) THEN
     Result:=1;
     EXIT;
    END;
   END;
   IF ~!CostItem.Parent THEN
    SEARCH(CostItem, CostItem, , CostItem.Parent);
   ELSE
    EXIT;
   END;
  END; (* LOOP ... *)
  RESTORE(CostItem);
  RETURN   Result;
 END {HasAnyPro};

 PUBLIC PROCEDURE HasPro(_CostItem: LIKE(CostItem.CostItem); D: DATE; _Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasAnyPro(_CostItem, D, _Property, 0);
 END {HasPro};

 PUBLIC PROCEDURE HasActualPro(_CostItem: LIKE(CostItem.CostItem); D: DATE; _Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasAnyPro(_CostItem, D, _Property, 1);
 END {HasActualPro};

 PUBLIC PROCEDURE GetProStrong(_CostItem: LIKE(CostItem.CostItem); D: DATE; _Property: LIKE(Property.Property)): LIKE(CIPro.Value);
 BEGIN
  IF HasActualPro(_CostItem, D, _Property) THEN
   RETURN CIPro.Value;
  END;
  SEARCH(CostItem, CostItem, , _CostItem);
  L_Prop.ShowUndefinedProValueError(TABLE.Get("CostItem").Id, CostItem.RECORDID, _Property, D);
 END {GetProStrong};

 PUBLIC PROCEDURE GetProSoft(_CostItem: LIKE(CostItem.CostItem); D: DATE; _Property: LIKE(Property.Property)): LIKE(CIPro.Value);
  VAR
   _Value: LIKE(CIPro.Value);
 BEGIN
  IF HasActualPro(_CostItem, D, _Property) THEN
   _Value:=CIPro.Value;
  ELSE
   SETEMPTY(_Value);
  END;
  RETURN _Value;
 END {GetProSoft};

 PUBLIC PROCEDURE AccessPro(_CostItem: LIKE(CostItem.CostItem); D: DATE; _Property: LIKE(Property.Property));
 BEGIN
  IF ~HasPro(_CostItem, D, _Property) THEN
   SEARCH(CostItem, CostItem, , _CostItem);
   L_Prop.ShowUndefinedProValueError(TABLE.Get("CostItem").Id, CostItem.RECORDID, _Property, D);
  END;
 END {AccessPro};

END.
