(*
%Copyright   (c) Polak Computer System
%Author      14.09.2001 15:52:04 GINA
%Purpose     ⥪  ࠡ  ᢮⢠ Contract
%Type        library
%Specific    SYS
%Modified    07.08.2014 17:44:51 POLAK\GAV
%Environment
*)

 MODULE P_Cntr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tInHouse              = SCAL[2];
  tReal                 = SCAL[3];
  tBalanceType          = SCAL[3];
  tPayOblg              = SCAL[2];
  tCURate               = SCAL[3];
  tCUCurrency           = SCAL[2];
  tIP_CalculateKind     = SCAL[6];
  tSpecialAttitudeToVAT = SCAL[5];
  tTemplateVersion      = SCAL[1E2];
  tAddInsKind           = SCAL[1E2];
  tMakeBillsPayMode     = SCAL[3];
  tMakeBillsMth         = SCAL[10];
  t_PriceLevelType      = SCAL[3];

 PUBLIC CONST
  P_Sum                           = 7310;
  P_PrepaymentValue               = 7311;
  P_IP_CalculateKind              = 7312;
  P_ContractorsName               = 7313;
  P_ExistanceReal                 = 7314;
  P_PaymentPeriod                 = 7315;
  P_WhichPP                       = 7316;
  P_PaymentDay                    = 7317;
  P_SingleMath                    = 7318;
  P_CURate                        = 7319;
  P_PaymentAgents                 = 7320;
  P_Consignees                    = 7321;
  P_PayPInfo                      = 7322;
  P_BalanceType                   = 7323;
  P_InHouse                       = 7324;
  P_PayOblg                       = 7325;
  P_DefaultPayFirmAcnt            = 7326;
  P_SpecialAttitudeToVAT          = 7327;
  P_DocumentsCirculationStructure = 7329;
  P_DocumentForms                 = 7330;
  P_Duration                      = 7331;
  P_AddIns                        = 7332;
  P_ContractVersion               = 7333;
  P_PropertyObjectDescription     = 7334;
  P_PartnerAgent                  = 7335;
  P_OwnAgent                      = 7336;
  P_MakeBillsSetting              = 7337;
  P_PayP                          = 7338;
  P_CntrAddendum                  = 7339; (* ⥫  ⥪  *)
  P_PriceLevel                    = 7340;
  P_AllowedCostItem               = 7341;
  P_PeriodicAcpt                  = 7342;
  P_PeriodicAcptDuration          = 7343;
  P_VATMode                       = 7344;
  P_AllowedDest                   = 7345;
  P_MainAcntSigner                = 7346;

  cur_c_Roubles = 0;
  cur_c_USD     = 1;

  cur_r_None      = 0;
  cur_r_Raise     = 1;
  cur_r_Arbitrary = 2;

  cur_RatePool     = "|      |ந";
  cur_CurrencyPool = "㡫| ";

  ctbt_ByDeal       = 0;
  ctbt_ByContract   = 1;
  ctbt_IsSingleDeal = 2;
  ctbt_Pool = "  ᤥ|   楫|- ᤥ";

  ipck_Free             = 0;
  ipck_PsgAmnt          = 1;
  ipck_Percent          = 2;
  ipck_PsgAmntORPercent = 3;
  ipck_TripAmnt         = 4;
  ipck_Other            = 5;
  ipck_Pool             = " 客 ᡮ| ⢠ ᠦ஢|業  ⮨ | ⢠ ᠦ஢,    । %| ⢠ ३ᮢ|祥";

  ctfp_Presence_asStr = "易⥫쭮| 易⥫쭮|--------------";

  ctfp_Strong    = 0;
  ctfp_Soft      = 1;
  ctfp_NotDefine = 2;

  satVAT_Pool = " ᮡ⥩|"+
                "  ꥪ⮬ |"+
                "த - ⥫騪 |"+
                "த ਬ |"+
                "த - 䨧,  饥  ।ਭ⥫";

  satVAT_woFeatures               = 0;
  satVAT_TaxFree                  = 1;
  satVAT_Seller_wENVD             = 2;
  satVAT_Seller_wUSNO             = 3;
  satVAT_SellerIsIndividualPerson = 4;

  pool_c1n = 0000946;
  pool_c2n = 0000947;
  pool_cen = 0000961;

  CaseAmount = 6;

  dfi_Text = 0;

  mbpm_LumpSum   = 0; (*tMakeBillsPayMode*)
  mbpm_Recurrent = 1;
  mbpm_Irregular = 2;
  mbpm_Pool   = "|ਮ᪠|ॣୠ";

  mbm_Pool = "|樠 冷|஢ 㬬  "; (*tMakeBillsMth*)
  mbm_Not      = 0;
  mbm_Special  = 1;
  mbm_FixedSum = 2;

  plt_Scale    = 0;
  plt_Charge   = 1;
  plt_Discount = 2;
  plt_Pool = " 誠|業|";

  dft_Contract = 0;
  dft_AddIns   = 1;
  dft_Msg      = 2;

  PropsAmount = 15;
  FirmsAmount = 15;

 IMPORT Str, L_General, L_Prop, L_DatTim, L_StdFrm, L_Str, P_OwnData,
        L_ExtAb, L_MSO, E_Prop, L_WDO, Math, L_Cntr, P_Firm, L_Pool, L_lsStore,
        P_MyFirm, L_Acnt, L_ODoc, L_r2r, L_ACL, L_Pmnt, P_MyPlc;

 PRIVATE CONST
  wLinkWindowName = "CntrPrL";

  cur_nbr_Rate     = 0;
  cur_nbr_Value    = 1;
  cur_nbr_Currency = 2;

  df_AIAmount  = 8;
  df_MsgAmount = 5;
  df_AISign    = "";
  df_MsgSign   = "饭";

  dpfat_OtherFirm = 0;
  dpfat_OwnFirm  = 1;

  af_CICount   = 3;
  ad_DestCount = 3;

  v_pac_MonthInPeriod = "v_pac_MonthInPeriod";
  v_pac_DocsPerPeriod = "v_pac_DocsPerPeriod";
  v_pac_FirstMonth    = "v_pac_FirstMonth";

  dcs_Amount  = 5;

 PRIVATE TYPE
  tFirms = LIKE(Firm.Firm)[FirmsAmount];
  tProps = LIKE(Property.Property)[PropsAmount];

 PUBLIC PROCEDURE IsSimpleUserOf(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_SingleMath THEN
   RETURN "Math";
  ELSIF trgProperty = P_PayP THEN
   RETURN "PayP";
  ELSIF trgProperty = P_MainAcntSigner THEN
   RETURN "Staff";
  ELSE
   RETURN "";
  END;
 END {IsSimpleUserOf};

 PUBLIC PROCEDURE PropertyModificationAllowed(trgProperty: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF trgProperty = P_AddIns THEN
   RETURN L_Prop.mac_Old;
  ELSE
   RETURN L_Prop.mac_Inside;
  END;
 END {PropertyModificationAllowed};

 PUBLIC PROCEDURE GetSubWindowName(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_ContractorsName               THEN RETURN "P_7313";
  ELSIF trgProperty = P_CURate                        THEN RETURN "P_7319";
  ELSIF trgProperty = P_PaymentAgents                 THEN RETURN "P_732x";
  ELSIF trgProperty = P_Consignees                    THEN RETURN "P_732x";
  ELSIF trgProperty = P_PayPInfo                      THEN RETURN "P_7322";
  ELSIF trgProperty = P_DefaultPayFirmAcnt            THEN RETURN "P_7326";
  ELSIF trgProperty = P_DocumentsCirculationStructure THEN RETURN "P_7329";
  ELSIF trgProperty = P_DocumentForms                 THEN RETURN "P_7330";
  ELSIF trgProperty = P_Duration                      THEN RETURN "P_7331";
  ELSIF trgProperty = P_AddIns                        THEN RETURN "P_7332";
  ELSIF trgProperty = P_PropertyObjectDescription     THEN RETURN "P_7334";
  ELSIF trgProperty = P_PartnerAgent                  THEN RETURN "P_7335";
  ELSIF trgProperty = P_OwnAgent                      THEN RETURN "P_7336";
  ELSIF trgProperty = P_MakeBillsSetting              THEN RETURN "P_7337";
  ELSIF trgProperty = P_CntrAddendum                  THEN RETURN "P_7339";
  ELSIF trgProperty = P_PriceLevel                    THEN RETURN "P_7340";
  ELSIF trgProperty = P_AllowedCostItem               THEN RETURN "P_7341";
  ELSIF trgProperty = P_PeriodicAcpt                  THEN RETURN "P_7342";
  ELSIF trgProperty = P_PeriodicAcptDuration          THEN RETURN "P_7343";
  ELSIF trgProperty = P_AllowedDest                   THEN RETURN "P_7345";
  ELSIF ~!IsSimpleUserOf(trgProperty)                 THEN RETURN wLinkWindowName;
  ELSE                                                     RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE GetPool(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_IP_CalculateKind THEN
   RETURN ipck_Pool;
  ELSIF trgProperty = P_PaymentPeriod THEN
   RETURN "||||⠫|";
  ELSIF trgProperty = P_WhichPP THEN
   RETURN "।騩|騩|騩|樠";
  ELSIF trgProperty = P_ExistanceReal THEN
   RETURN "||  ";
  ELSIF trgProperty = P_BalanceType THEN
   RETURN ctbt_Pool;
  ELSIF trgProperty = P_InHouse THEN
   RETURN "|";
  ELSIF trgProperty = P_PayOblg THEN
   RETURN "|";
  ELSIF trgProperty = P_SpecialAttitudeToVAT THEN
   RETURN satVAT_Pool;
  ELSIF trgProperty = P_VATMode THEN
   RETURN " |।| ⮨";
  ELSIF L_Prop.IsLocalProperty(trgProperty) THEN
   RETURN L_Prop.E_GetPool(trgProperty);
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PRIVATE PROCEDURE intHasPro(trgContract  : LIKE(Contract.Contract);
                             D            : DATE;
                             trgProperty  : LIKE(Property.Property);
                             CheckActual  : SCAL[2];
                             LookForParent: SCAL[2]): SCAL[2];
  VAR
   trgLeaf,
   Result  : SCAL[2];
 BEGIN
  Result:=0;
  SAVE(Contract);
  SEARCH(Contract, Contract, , trgContract);
  trgLeaf:=Contract.Leaf;
  LOOP
   SETSEL(CntrPro, Contract, Contract.Contract, trgProperty);
   IF SRCINSEL(CntrPro, LE, D) THEN
    IF trgLeaf THEN
     L_General.Assert(CntrPro.Redefine # L_Prop.rd_Necessary,
                      "祭 ᢮⢠ " + trgProperty + "   ८।" +
                      "|  " + trgContract);
    END;
    IF (~!CntrPro.Value | (CntrPro.Redefine = L_Prop.rd_Necessary)) &
       (~CheckActual | !CntrPro.DocExpD | (D < CntrPro.DocExpD)) THEN
     Result:=1;
     EXIT;
    END;
   END;
   IF LookForParent & ~!Contract.Parent THEN
    SEARCH(Contract, Contract, , Contract.Parent);
   ELSE
    EXIT;
   END;
  END; (* LOOP ... *)
  RESTORE(Contract);
  RETURN Result;
 END {intHasPro};

 PUBLIC PROCEDURE HasPro(trgContract: LIKE(Contract.Contract);
                         D          : DATE;
                         trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN intHasPro(trgContract, D, trgProperty, 0, 1);
 END {HasPro};

 PUBLIC PROCEDURE HasActualPro(trgContract: LIKE(Contract.Contract);
                               D          : DATE;
                               trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN intHasPro(trgContract, D, trgProperty, 1, 1);
 END {HasActualPro};

 PRIVATE PROCEDURE GetCntrPro(trgContract      : LIKE(Contract.Contract);
                              trgDate          : DATE;
                              trgProperty      : LIKE(Property.Property);
                              PresenceCondition: L_Prop.tPresenceCondition): LIKE(CntrPro.Value);
 BEGIN
  IF HasActualPro(trgContract, trgDate, trgProperty) THEN
   IF ~!IsSimpleUserOf(trgProperty) THEN
    RETURN Decode_CntrPro(CntrPro.Value, trgProperty);
   ELSE
    RETURN CntrPro.Value;
   END;
  ELSE
   IF PresenceCondition = L_Prop.pc_Strong THEN
    SEARCH(Contract, Contract, , trgContract);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("Contract").Id, Contract.RECORDID, trgProperty, trgDate);
   END;
   RETURN "";
  END;
 END {GetCntrPro};

 PUBLIC PROCEDURE GetCntrProSoft(trgContract: LIKE(Contract.Contract);
                                 trgDate    : DATE;
                                 trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetCntrPro(trgContract, trgDate, trgProperty, L_Prop.pc_Soft);
 END {GetCntrProSoft};

 PUBLIC PROCEDURE GetCntrProStrong(trgContract: LIKE(Contract.Contract);
                                   trgDate    : DATE;
                                   trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetCntrPro(trgContract, trgDate, trgProperty, L_Prop.pc_Strong);
 END {GetCntrProStrong};

 PRIVATE PROCEDURE CheckCntrPro(trgContract: LIKE(Contract.Contract);
                                D        : DATE;
                                trgProperty: LIKE(Property.Property));
 BEGIN
  IF ~HasPro(trgContract, D, trgProperty) THEN
   SEARCH(Contract, Contract, , trgContract);
   L_Prop.ShowUndefinedProValueError(TABLE.Get("Contract").Id, Contract.RECORDID, trgProperty, D);
  END;
 END {CheckCntrPro};

 PUBLIC PROCEDURE GetCntrProDate(trgContract: LIKE(Contract.Contract);
                                 D          : DATE;
                                 trgProperty: LIKE(Property.Property)): DATE;
 BEGIN
  CheckCntrPro(trgContract, D, trgProperty);
  RETURN CntrPro.Date;
 END {GetCntrProDate};

 PUBLIC PROCEDURE GetCntrProEndDate(trgContract: LIKE(Contract.Contract);
                                    D          : DATE;
                                    trgProperty: LIKE(Property.Property)): DATE;
 BEGIN
  CheckCntrPro(trgContract, D, trgProperty);
  RETURN CntrPro.EndDate;
 END {GetCntrProEndDate};

 PUBLIC PROCEDURE GetCntrProStrongNum(trgContract: LIKE(Contract.Contract);
                                      d         : DATE;
                                      trgProperty : LIKE(Property.Property)): FLOAT;
 BEGIN
  RETURN STRTOFLD(GetCntrProStrong(trgContract, d, trgProperty), FLOAT);
 END {GetCntrProStrongNum};

 PUBLIC PROCEDURE InsertNewProperty(trgContract : LIKE(Contract.Contract);
                                    trgDate     : DATE;
                                    trgProperty : LIKE(Property.Property);
                                    trgRedefine : LIKE(CntrPro.Redefine));
 BEGIN
  L_General.Assert(~SELECT(CntrPro, Contract, trgContract, trgProperty, trgDate),
                   "⠢ ᢮⢠ " + trgProperty + ":|" +
                   "㦥  ᢮⢮  " + L_DatTim.DateStr(trgDate) + "   " + trgContract);
  DEFAULT(CntrPro);
  CntrPro.Contract:=trgContract;
  CntrPro.Property:=trgProperty;
  CntrPro.Redefine:=trgRedefine;
  CntrPro.Date    :=trgDate;
  INSERT(CntrPro);
  CALL(Contract.t_OnAfterInsert_CntrPro());
  L_Prop.SupportEndDate("CntrPro", trgProperty, 1);
 END {InsertProperty};

 PRIVATE PROCEDURE MayBeRedefined(trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN (trgProperty # P_ExistanceReal);
 END {MayBeRedefined};

 PRIVATE PROCEDURE SetRedefineFormat();
  VAR
   RedefinePool: STRING[];
 BEGIN
  IF OCCURE(Contract) & OCCURE(CntrPro) THEN
   RTI.Get().CurZone.Fields("CntrPro.Redefine").Modifiable:=~Contract.Leaf & MayBeRedefined(CntrPro.Property);
   IF Contract.Leaf THEN
    RedefinePool:=" | | |᫥";
   ELSE
    RedefinePool:=L_Prop.rd_Pool;
   END;
   RTI.Get().CurZone.Fields("CntrPro.Redefine").Format:=RedefinePool;
  END;
 END {SetRedefineFormat};

 PRIVATE PROCEDURE OnBeforeModification();
 BEGIN
  L_General.Assert(CntrPro.Redefine # L_Prop.rd_TransferFromTemplate,
                   "᫥  ᮧ 䨫 ᢮⢠   䨪樨");
  SetRedefineFormat();
 END {OnBeforeModification};

 PUBLIC PROCEDURE OnBeforeEdit();
 BEGIN
  OnBeforeModification();
 END {OnBeforeEdit};

 PUBLIC PROCEDURE OnBeforeDelete();
 BEGIN
  OnBeforeModification();
  IF CntrPro.Property = P_CntrAddendum THEN
   CntrPro.Value:=L_lsStore.Replace(CntrPro.Value, "");
  END;
 END {OnBeforeDelete};

 PUBLIC PROCEDURE CommonOnBeforeInsert();
 BEGIN
  IF !CntrPro.Redefine THEN
   CONFORM(CntrPro, Property);
   IF Contract.Leaf THEN
    CntrPro.Redefine:=L_Prop.rd_No;
   ELSE
    CntrPro.Redefine:=MayBeRedefined(CntrPro.Property);
   END;
   REPLACE(CntrPro);
  END;
  OnBeforeModification();
 END {CommonOnBeforeInsert};

 PUBLIC PROCEDURE CanHaveProp(trgProperty: LIKE(Property.Property));
 BEGIN
  SAVE(CntrPro);
  IF ~!Contract.Parent &
     HasActualPro(Contract.Parent, SYSDATE(), trgProperty) &
     (CntrPro.Redefine = L_Prop.rd_No) THEN
   L_StdFrm.Choice(" " + L_DatTim.DateStr(SYSDATE()) + " c⢮ " + trgProperty +
                   "   ८।|(饭   ᮪ ஢ 娨)");
  END;
  RESTORE(CntrPro);
 END {CanHaveProp};

 PRIVATE PROCEDURE GetRateNumericFormat(Rate: tCURate): STRING[];
 BEGIN
  IF Rate = cur_r_Raise THEN
   RETURN "2.";
  ELSE
   RETURN "6.";
  END;
 END {GetRateNumericFormat};

 PRIVATE PROCEDURE Decode_CntrPro(trgValue   : LIKE(CntrPro.Value);
                                  trgProperty: LIKE(CntrPro.Property)): LIKE(CntrPro.Value);
 BEGIN
  L_General.CallUs(~!IsSimpleUserOf(trgProperty));
  RETURN L_r2r.DecodeReferenceStamp(trgValue);
 END {Decode_CntrPro};

 PRIVATE PROCEDURE formSet_CntrPro(trgProperty: LIKE(CntrPro.Property));
  VAR
   W: FORM_WINDOW;
   Z: FORM_ZONE;
 BEGIN
  W:=RTI.Get().CurWindow;
  Z:=RTI.Get().CurZone;
  IF W.OriginalName = wLinkWindowName THEN
   WHILE Z.Links.Count DO
    Z.Links.Remove(Z.Links(0));
   END;
   L_WDO.CreateFormLink_Simple(IsSimpleUserOf(Property.Property), "Value");
   Z.Fields("Value").Value:=Decode_CntrPro((^(Z.MasterTable.Fields("Value").ObtainName())), trgProperty);
  END;
 END {formSet_CntrPro};

 PRIVATE PROCEDURE Decode_PartnerAgent(    curValue: STRING[];
                                       VAR Name    : STRING[];
                                       VAR PostName: STRING[];
                                       VAR DocType : STRING[]);
 BEGIN
  Name    :=L_Prop.getRecordElement(curValue, 0);
  PostName:=L_Prop.getRecordElement(curValue, 1);
  DocType :=L_Prop.getRecordElement(curValue, 2);
 END {Decode_PartnerAgent};

 PRIVATE PROCEDURE formSet_PartnerAgent();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_PartnerAgent(CntrPro.Value, Fields("Name").Value, Fields("PostName").Value, Fields("DocType").Value);
 END {formSet_PartnerAgent};

 PRIVATE PROCEDURE formGet_PartnerAgent();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_Prop.putRES(CntrPro.Value, Fields("Name").Value);
  L_Prop.putRES(CntrPro.Value, Fields("PostName").Value);
  L_Prop.putRES(CntrPro.Value, Fields("DocType").Value);
  L_Prop.ConvEmptyRecordPropertyValue(CntrPro.Value);
 END {formGet_PartnerAgent};

 PUBLIC PROCEDURE Get_FullPartnerAgentInfo(    trgContract: LIKE(Contract.Contract);
                                               D          : DATE;
                                           VAR Name       : STRING[];
                                           VAR PostName   : STRING[];
                                           VAR DocType    : STRING[];
                                           VAR DocSer     : STRING[];
                                           VAR DocNum     : STRING[];
                                           VAR DocGiveS   : STRING[];
                                           VAR DocGiveD   : DATE;
                                           VAR DocExpD    : DATE);
  VAR
   trgValue: STRING[];
 BEGIN
  SETEMPTY(trgValue, DocSer, DocNum, DocGiveS, DocExpD, DocGiveD);
  IF HasActualPro(trgContract, D, P_PartnerAgent) THEN
   trgValue:=CntrPro.Value;
   DocGiveS:=CntrPro.DocGiveS;
   DocGiveD:=CntrPro.DocGiveD;
   DocExpD :=CntrPro.DocExpD;
   L_Prop.GetDocSerAndNum(CntrPro.DocNum, DocSer, DocNum);
  END;

  Decode_PartnerAgent(trgValue, Name, PostName, DocType);
 END {Get_FullPartnerAgentInfo};

 PRIVATE PROCEDURE Decode_OwnAgent(    curValue: STRING[];
                                   VAR TSN     : LIKE(Staff.TSN);
                                   VAR DocType : STRING[];
                                   VAR CntrSum : NUMERIC[2]);
 BEGIN
  TSN    :=L_Prop.getRES(curValue, 0);
  DocType:=L_Prop.getRES(curValue, 1);
  CntrSum:=L_Str.Str2Num(L_Prop.getRES(curValue, 2), "");
 END {Decode_OwnAgent};

 PUBLIC PROCEDURE formSet_OwnAgent();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_WDO.CreateFormLink("Staff", "");

  Decode_OwnAgent(CntrPro.Value, Fields("TSN").Value, Fields("DocType").Value, Fields("CntrSum").Value);
 END {formSet_OwnAgent};

 PRIVATE PROCEDURE formGet_OwnAgent();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_Prop.putREV(CntrPro.Value, Fields("TSN").Value);
  L_Prop.putRES(CntrPro.Value, Fields("DocType").Value);
  L_Prop.putREV(CntrPro.Value, Fields("CntrSum").Value);
  L_Prop.ConvEmptyRecordPropertyValue(CntrPro.Value);
 END {formGet_OwnAgent};

 PUBLIC PROCEDURE Get_FullOwnAgentInfo(     trgContract: LIKE(Contract.Contract);
                                            D          : DATE;
                                        VAR TSN        : LIKE(Staff.TSN);
                                        VAR DocType    : STRING[];
                                        VAR DocSer     : STRING[];
                                        VAR DocNum     : STRING[];
                                        VAR DocGiveS   : STRING[];
                                        VAR DocGiveD   : DATE;
                                        VAR DocExpD    : DATE;
                                        VAR CntrSum    : NUMERIC[2]);
  VAR
   trgValue: STRING[];
 BEGIN
  SETEMPTY(trgValue, DocSer, DocNum, DocGiveS, DocExpD, DocGiveD);
  IF HasActualPro(trgContract, D, P_OwnAgent) THEN
   trgValue:=CntrPro.Value;
   DocGiveS:=CntrPro.DocGiveS;
   DocGiveD:=CntrPro.DocGiveD;
   DocExpD :=CntrPro.DocExpD;
   L_Prop.GetDocSerAndNum(CntrPro.DocNum, DocSer, DocNum);
  END;

  Decode_OwnAgent(trgValue, TSN, DocType, CntrSum);
 END {Get_FullOwnAgentInfo};

 PRIVATE PROCEDURE mbs_PrepareForm();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Mode").Template           :=mbpm_Pool;
  Fields("Mode").TemplateIsStrict   :=1;
  Fields("MthPrep").Template        :=mbm_Pool;
  Fields("MthPrep").TemplateIsStrict:=1;

  L_WDO.CreateFormLink("MDocKind", "Regular");
  L_WDO.CreateFormLink("MDocKind", "Acpt");
 END {mbs_PrepareForm};

 PUBLIC PROCEDURE mbs_DecodeValue(Strong: SCAL[2]);
  VAR
   MthPrep: tMakeBillsMth;
   Fields : FORM_FIELDS;
 BEGIN
  Fields                         :=RTI.Get().CurZone.Fields;
  Fields("Mode").Value           :=L_Prop.getRecordElement(CntrPro.Value, 0);
  Fields("MthPrep").Value        :=L_Prop.getRecordElement(CntrPro.Value, 1);
  Fields("RegularMDocKind").Value:=L_Prop.getRecordElement(CntrPro.Value, 2);
  Fields("AcptMDocKind").Value   :=L_Prop.getRecordElement(CntrPro.Value, 3);

  MthPrep:=L_Str.PositionInPool(mbm_Pool, Fields("MthPrep").Value);
  Fields("RegularMDocKind").Modifiable:=MthPrep # mbm_Not;
  Fields("AcptMDocKind").Modifiable   :=(MthPrep # mbm_Not) &
                                        ~L_Pmnt.IsAcptMDocKind(Fields("RegularMDocKind").Value);
 END {mbs_DecodeValue};

 PRIVATE PROCEDURE Decode_AllowedCostItem(    curValue    : LIKE(CntrPro.Value);
                                          VAR trgCostItems: VARIANT);
  VAR
   i: SCAL[af_CICount];
 BEGIN
  FOR_EACH i DO
   trgCostItems[i]:=L_r2r.DecodeReferenceStamp(L_Prop.getRecordElement(curValue, i));
  END;
 END {Decode_AllowedCostItem};

 PRIVATE PROCEDURE formGet_AllowedCostItem();
  VAR
   i          : SCAL[af_CICount];
   curCostItem: LIKE(CostItem.CostItem);
 BEGIN
  FOR_EACH i DO
   curCostItem:=RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("CostItem", i)).Value;
   IF ~!curCostItem THEN
    L_Prop.putRES(CntrPro.Value, L_r2r.Put("CntrPro", "CostItem", curCostItem));
   END;
  END;
 END {formGet_AllowedCostItem};

 PRIVATE PROCEDURE formSet_AllowedCostItem();
  VAR
   i          : SCAL[af_CICount];
   CostItemArr: LIKE(CostItem.CostItem)[af_CICount];
 BEGIN
  Decode_AllowedCostItem(CntrPro.Value, CostItemArr);
  FOR_EACH i DO
   L_WDO.extCreateFormLink("CostItem", "", i);
   RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("CostItem", i)).Value:=CostItemArr[i];
  END;
 END {formSet_AllowedCostItem};

 PRIVATE PROCEDURE Decode_CntrAddendum(    curValue    : STRING[];
                                       VAR CntrAddendum: STRING[]);
 BEGIN
  CntrAddendum:=L_lsStore.Get(curValue);
 END {Decode_CntrAddendum};

 PRIVATE PROCEDURE formSet_CntrAddendum();
 BEGIN
  Decode_CntrAddendum(CntrPro.Value, RTI.Get().CurZone.Fields("CntrAddendum").Value);
 END {formSet_CntrAddendum};

 PRIVATE PROCEDURE formGet_CntrAddendum();
 BEGIN
  CntrPro.Value:=L_lsStore.Replace(CntrPro.Value, RTI.Get().CurZone.Fields("CntrAddendum").Value);
 END {formGet_CntrAddendum};

 PUBLIC PROCEDURE GetCntrAddendum(trgContract: LIKE(Contract.Contract); D: DATE): STRING[];
  VAR
   CntrAddendum: STRING[];
 BEGIN
  Decode_CntrAddendum(GetCntrProSoft(trgContract, D, P_CntrAddendum), CntrAddendum);
  RETURN CntrAddendum;
 END {GetCntrAddendum};

 PRIVATE PROCEDURE Decode_AllowedDest(    curValue: LIKE(CntrPro.Value);
                                      VAR trgDest : VARIANT);
  VAR
   i: SCAL[ad_DestCount];
 BEGIN
  FOR_EACH i DO
   trgDest[i]:=L_r2r.DecodeReferenceStamp(L_Prop.getRecordElement(curValue, i));
  END;
 END {Decode_AllowedDest};

 PRIVATE PROCEDURE formGet_AllowedDest();
  VAR
   i      : SCAL[ad_DestCount];
   curDest: LIKE(Dest.Dest);
 BEGIN
  FOR_EACH i DO
   curDest:=RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("Dest", i)).Value;
   IF ~!curDest THEN
    L_Prop.putRES(CntrPro.Value, L_r2r.Put("CntrPro", "Dest", curDest));
   END;
  END;
 END {formGet_AllowedDest};

 PRIVATE PROCEDURE formSet_AllowedDest();
  VAR
   i      : SCAL[ad_DestCount];
   DestArr: LIKE(Dest.Dest)[ad_DestCount];
 BEGIN
  Decode_AllowedDest(CntrPro.Value, DestArr);
  FOR_EACH i DO
   L_WDO.extCreateFormLink("Dest", "", i);
   RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("Dest", i)).Value:=DestArr[i];
  END;
 END {formSet_AllowedDest};

 PUBLIC PROCEDURE Check(trgProperty: LIKE(Property.Property));
  VAR
   DummyNum : NUMERIC[0];
   DummyDate: DATE;
 BEGIN
  IF trgProperty = P_ContractVersion THEN
   L_Prop.CheckScalValue(CntrPro.Value, "", MAXOF(tTemplateVersion));
  ELSIF (trgProperty = P_Sum) |
        (trgProperty = P_PrepaymentValue) THEN
   L_Prop.CheckNumericValue(CntrPro.Value, "2.");
  ELSIF trgProperty = P_PaymentDay THEN
   L_Prop.CheckNumericValue(CntrPro.Value, "");
  ELSIF trgProperty = P_MakeBillsSetting THEN
   mbs_DecodeValue(1);
  END;
 END {Check};

 PRIVATE PROCEDURE SetPeriodicAcptFieldModifiable();
  VAR
   Fields    : FORM_FIELDS;
   EveryMonth: SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  EveryMonth:=Fields(v_pac_MonthInPeriod).Value = 1;
  IF EveryMonth THEN
   Fields(v_pac_FirstMonth).Value:=EMPTYOF(DATE);
  END;
  Fields(v_pac_FirstMonth).MustBeNonempty:=~EveryMonth;
  Fields(v_pac_FirstMonth).Modifiable    :=~EveryMonth;
 END {SetPeriodicAcptFieldModifiable};

 PRIVATE PROCEDURE GetDefaultPayFirm(Type: NUMERIC[0]): LIKE(Firm.Firm);
 BEGIN
  CONFORM(CntrPro, Contract);
  IF Type = dpfat_OtherFirm THEN
   RETURN Contract.Firm;
  ELSE
   RETURN P_Firm.fomf(Contract.MyFirm);
  END;
 END {GetDefaultPayFirm};

 PRIVATE PROCEDURE SuccessfulChange_AllowedCostItem();
  VAR
   i, curIdx  : SCAL[af_CICount];
   curCostItem: LIKE(CostItem.CostItem);
 BEGIN
  curCostItem:=RTI.Get().CurZone.ActiveField.Value;
  curIdx     :=L_WDO.getCurFldIdx();

  IF ~!curCostItem THEN
   SEARCH(CostItem, CostItem, , curCostItem);
   L_General.Assert(CostItem.Leaf = 1, " ᯮ짮 㯯 ⥩ 室  室");

   FOR_EACH i DO
    IF (i # curIdx) & (curCostItem = RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("CostItem", i)).Value) THEN
     L_General.Error(" 㪠  " + curCostItem);
    END;
   END; (* FOR_EACH i ... *)
  END;
 END {SuccessfulChange_AllowedCostItem};

 PRIVATE PROCEDURE SuccessfulChange_AllowedDest();
  VAR
   i,
   curIdx : SCAL[ad_DestCount];
   curDest: LIKE(Dest.Dest);
 BEGIN
  curDest:=RTI.Get().CurZone.ActiveField.Value;
  curIdx :=L_WDO.getCurFldIdx();

  IF ~!curDest THEN
   FOR_EACH i DO
    IF (i # curIdx) & (curDest = RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("Dest", i)).Value) THEN
     L_General.Error(" 㪠  樨 " + curDest);
    END;
   END; (* FOR_EACH i ... *)
  END;
 END {SuccessfulChange_AllowedDest};

 PRIVATE PROCEDURE SuccessfulChange_ContractorsName();
  VAR
   trgPool  : LIKE(Pool.Pool);
   FieldName: STRING[];
 BEGIN
  CONFORM(CntrPro, Contract); (*஢ ᢮⢠   FrmManCh*)
  FieldName:=RTI.Get().CurZone.ActiveField.Name;
  IF    FieldName = "OwnContractor" THEN
   IF Contract.Type = L_Cntr.ct_Prch THEN
    trgPool:=pool_c2n;
   ELSE
    trgPool:=pool_c1n;
   END;
  ELSIF FieldName = "OtherContractor" THEN
   IF Contract.Type = L_Cntr.ct_Prch THEN
    trgPool:=pool_c1n;
   ELSE
    trgPool:=pool_c2n;
   END;
  ELSIF FieldName = "ExtContractNaming" THEN
   trgPool:=pool_cen;
  ELSE
   L_General.CallUs(0);
  END;

  L_Pool.Put(trgPool, RTI.Get().CurZone.ActiveField.Value);
  RTI.Get().CurZone.ActiveField.Template:=L_Pool.Get(trgPool);
 END {SuccessfulChange_ContractorsName};

 PRIVATE PROCEDURE FirmAcntDescr(_Firm    : LIKE(Firm.Firm);
                                 _FirmAcnt: LIKE(FirmAcnt.FirmAcnt)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(FirmAcnt);
  L_General.Assert(SEARCH(FirmAcnt, FirmAcnt, _Firm, _FirmAcnt),
                   "   " + _FirmAcnt + " ࠣ " + _Firm);

  L_General.Assert(L_DatTim.IsActive(CntrPro.Date, FirmAcnt.Begin, FirmAcnt.Till),
                   " " + FirmAcnt.FirmAcnt + " ࠣ " + FirmAcnt.Firm +
                   "    " + L_DatTim.DateStr(CntrPro.Date));

  CONFORM(FirmAcnt, Bank);
  Result:=Str.Align(Bank.Name, 24, LEFT) + " " + FirmAcnt.AcntA;
  RESTORE(FirmAcnt);
  RETURN Result;
 END {FirmAcntDescr};

 PRIVATE PROCEDURE GetDefaultPayFirmAcntList(_Firm: LIKE(Firm.Firm);
                                             D    : DATE): STRING[];
  VAR
   AcntPool: STRING[];
 BEGIN
  IF !D THEN
   D:=SYSDATE();
  END;
  SETEMPTY(AcntPool);
  SELECT(FirmAcnt, FirmAcnt, , _Firm);
  WHILE OCCURE(FirmAcnt) DO
   IF L_DatTim.IsActive(D, FirmAcnt.Begin, FirmAcnt.Till) &
      (FirmAcnt.Type # P_Firm.fat_CashOffice) & (FirmAcnt.Type # P_Firm.fat_OprCashDsk) THEN
    AcntPool:=AcntPool +"|" + FirmAcnt.FirmAcnt +" " + FirmAcntDescr(_Firm, FirmAcnt.FirmAcnt);
   END;
   NEXT(FirmAcnt);
  END; (* WHILE OCCURE(FirmAcnt) ... *)
  RETURN AcntPool;
 END {GetDefaultPayFirmAcntList};

 PRIVATE PROCEDURE GetFirmAcntDescr(Type: NUMERIC[0]; trgFirmAcnt: LIKE(FirmAcnt.FirmAcnt)): STRING[];
  VAR
   Result : STRING[];
   trgFirm: LIKE(Firm.Firm);
 BEGIN
  SETEMPTY(Result);
  trgFirm:=GetDefaultPayFirm(Type);
  CONFORM(CntrPro, Contract);
  IF Contract.Leaf = 1 THEN
   L_General.Assert(~!trgFirm, " । ࠣ (" + L_Str.PoolItem("㦠 ࣠| ࣠", Type) + ")  ");
  END;
  IF ~!trgFirmAcnt THEN
   Result:=FirmAcntDescr(trgFirm, trgFirmAcnt);
  END;
  RETURN Result;
 END {GetFirmAcntDescr};

 PRIVATE PROCEDURE SuccessfulChange_DefaultPayFirmAcnt();
  VAR
   Type       : NUMERIC[0];
   Descr      : STRING[];
   trgFirm    : LIKE(Firm.Firm);
   trgFirmAcnt: LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  L_General.Assert(~!CntrPro.Date, " 㪠  砫 ⢨ ᢮⢠");

  IF RTI.Get().CurZone.ActiveField.Name = "OtherFirmAcnt" THEN
   Type:=dpfat_OtherFirm;
  ELSE
   Type:=dpfat_OwnFirm;
  END;
  trgFirm    :=GetDefaultPayFirm(Type);
  trgFirmAcnt:=RTI.Get().CurZone.ActiveField.Value;
  IF ~!trgFirmAcnt THEN
   L_General.Assert(SEARCH(FirmAcnt, Firm, trgFirm, trgFirmAcnt), " ࠣ "+trgFirm+"  ᪨   ஬ "+trgFirmAcnt);
   L_General.Assert((FirmAcnt.Type # P_Firm.fat_CashOffice) & (FirmAcnt.Type # P_Firm.fat_OprCashDsk),
                    " " + trgFirmAcnt + "   ᪨ ⮬");
   Descr:=GetFirmAcntDescr(Type, trgFirmAcnt);
  ELSE
   SETEMPTY(Descr);
  END;
  RTI.Get().CurZone.Fields(RTI.Get().CurZone.ActiveField.Name + "_Descr").Value:=Descr;
 END {SuccessfulChange_DefaultPayFirmAcnt};

 PUBLIC PROCEDURE OnSuccessfulChange(trgProperty: LIKE(Property.Property));
  VAR
   Idx, i   : NUMERIC[0];
   FieldName: STRING[];
   _MDocKind: LIKE(MDocKind.MDocKind);
   MthPrep  : tMakeBillsMth;
   Fields   : FORM_FIELDS;
 BEGIN
  FieldName:=RTI.Get().CurZone.ActiveField.Name;
  Fields   :=RTI.Get().CurZone.Fields;
  IF    trgProperty = P_CURate THEN
   L_General.Assert(~!CntrPro.Date, "  砫 ⢨ ᢮⢠");
   IF    FieldName = "Rate" THEN
    SetCURateFieldModifiable();
   END;
   Fields("clcValue").Value:=Calc_clcValue(Fields("USDRate").Value, Fields("Rate").Value, Fields("Value").Value);
  ELSIF trgProperty = P_DefaultPayFirmAcnt THEN
   SuccessfulChange_DefaultPayFirmAcnt();
  ELSIF trgProperty = P_ContractorsName THEN
   SuccessfulChange_ContractorsName();
  ELSIF trgProperty = P_MakeBillsSetting THEN
   MthPrep:=L_Str.PositionInPool(mbm_Pool, Fields("MthPrep").Value);
   Fields("AcptMDocKind").Modifiable :=(MthPrep # mbm_Not) &
                                       ~L_Pmnt.IsAcptMDocKind(Fields("RegularMDocKind").Value);
   IF    FieldName = "MthPrep" THEN
    IF MthPrep =  mbm_Not THEN
     SETEMPTY(Fields("RegularMDocKind").Value, Fields("AcptMDocKind").Value);
    END;
    Fields("RegularMDocKind").Modifiable:=MthPrep # mbm_Not;
   ELSIF FieldName = "AcptMDocKind" THEN
    L_General.Assert(L_Pmnt.IsAcptMDocKind(Fields("AcptMDocKind").Value), "࠭    室  㧪");
   END;
  ELSIF trgProperty = P_AllowedCostItem THEN
   SuccessfulChange_AllowedCostItem();
  ELSIF trgProperty = P_PeriodicAcpt THEN
   IF FieldName = v_pac_MonthInPeriod THEN
    SetPeriodicAcptFieldModifiable();
   END;
  ELSIF trgProperty = P_AllowedDest THEN
   SuccessfulChange_AllowedDest();
  END;
 END {OnSuccessfulChange};

 PUBLIC PROCEDURE OnBeforeAskForEdit(trgProperty: LIKE(Property.Property));
  VAR
   AcntPool: STRING[];
   Type,
   Choice  : NUMERIC[0];
 BEGIN
  IF trgProperty = P_DefaultPayFirmAcnt THEN
   L_General.Assert(~!CntrPro.Date, "  ");
   IF RTI.Get().CurZone.ActiveField.Name = "OtherFirmAcnt" THEN
    Type:=dpfat_OtherFirm;
   ELSE
    Type:=dpfat_OwnFirm;
   END;

   AcntPool:=GetDefaultPayFirmAcntList(GetDefaultPayFirm(Type), CntrPro.Date);
   Choice:=0;
   IF ~!RTI.Get().CurZone.ActiveField.Value THEN
    Choice:=L_Str.PositionInPool(AcntPool, RTI.Get().CurZone.ActiveField.Value+" "+
                                           RTI.Get().CurZone.Fields(RTI.Get().CurZone.ActiveField.Name + "_Descr").Value);
   END;
   RTI.Get().CurZone.ActiveField.Value:=STRTOFLD(Str.Item(L_Str.PoolItem(AcntPool, L_StdFrm.ShowListAsMenu_wInit(AcntPool, "", Choice)), " ", 0), SCAL);
   SuccessfulChange_DefaultPayFirmAcnt();
  END;
 END {OnBeforeAskForEdit};

 PRIVATE PROCEDURE Decode_PayPInfo(    Value             : STRING[];
                                   VAR DescriptionOfGoods: STRING[];
                                   VAR KBK               : STRING[];
                                   VAR OKATO             : STRING[];
                                   VAR Former            : STRING[]);
 BEGIN
  IF ~!Value THEN
   DescriptionOfGoods:=L_Prop.getRecordElement(Value, 0);
   KBK               :=L_Prop.getRecordElement(Value, 1);
   OKATO             :=L_Prop.getRecordElement(Value, 2);
   Former            :=L_Prop.getRecordElement(Value, 3);
  ELSE
   SETEMPTY(DescriptionOfGoods, KBK, OKATO, Former);
  END;
 END {Decode_PayPInfo};

 PRIVATE PROCEDURE formSet_PayPInfo();
  VAR
   Idx   : NUMERIC[0];
   Fields: FORM_FIELDS;
   Former: STRING[];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Former").Template:=L_ExtAb.Former_Pool;
  Fields("Former").TemplateIsStrict:=1;
  Decode_PayPInfo(CntrPro.Value, Fields("DescriptionOfGoods").Value, Fields("KBK").Value, Fields("OKATO").Value, Former);
  IF ~!Former THEN
   Idx   :=L_Str.PositionInPool(L_ExtAb.Former_Pool_Short, Former);
   Former:=L_Str.PoolItem(L_ExtAb.Former_Pool, Idx);
  ELSE
   SETEMPTY(Former);
  END;
  Fields("Former").Value:=Former;
 END {formSet_PayPInfo};

 PUBLIC PROCEDURE ppi_DescriptionOfGoods_Ext(trgContract: LIKE(Contract.Contract);
                                             D          : DATE;
                                             pc         : L_Prop.tPresenceCondition): STRING[];
  VAR
   DescriptionOfGoods,
   KBK,
   OKATO,
   Former            : STRING[];
 BEGIN
  Decode_PayPInfo(GetCntrPro(trgContract, D, P_PayPInfo, pc), DescriptionOfGoods, KBK, OKATO, Former);
  IF pc = L_Prop.pc_Strong THEN
   L_General.Assert(~!DescriptionOfGoods, " ᢮⢥ " + L_Str.IntStr(P_PayPInfo) + "  " + trgContract + "    ' ⮢஢ (ࠡ, )'");
  END;
  RETURN DescriptionOfGoods;
 END {ppi_DescriptionOfGoods_Ext};

 PUBLIC PROCEDURE ppi_DescriptionOfGoods(trgContract: LIKE(Contract.Contract); D: DATE): STRING[];
 BEGIN
  RETURN ppi_DescriptionOfGoods_Ext(trgContract, D, L_Prop.pc_Soft);
 END {ppi_DescriptionOfGoods};

 PUBLIC PROCEDURE ppi_KBK(trgContract: LIKE(Contract.Contract); D: DATE): STRING[];
  VAR
   DescriptionOfGoods,
   KBK,
   OKATO,
   Former            : STRING[];
 BEGIN
  Decode_PayPInfo(GetCntrProStrong(trgContract, D, P_PayPInfo), DescriptionOfGoods, KBK, OKATO, Former);
  L_General.Assert(~!KBK, " ᢮⢥ " + L_Str.IntStr(P_PayPInfo) + "  " + trgContract + "    ' ⭮ 䨪樨'");
  RETURN KBK;
 END {ppi_KBK};

 PUBLIC PROCEDURE ppi_OKATO(trgContract: LIKE(Contract.Contract); D: DATE): STRING[];
  VAR
   DescriptionOfGoods,
   KBK,
   OKATO,
   Former            : STRING[];
 BEGIN
  Decode_PayPInfo(GetCntrProStrong(trgContract, D, P_PayPInfo), DescriptionOfGoods, KBK, OKATO, Former);
  IF !OKATO & (~!KBK | ~!Former) THEN
   OKATO:=P_MyPlc.GetP_OKATO(Contract.MyFirm, EMPTYOF(MyPlace.MyPlace), D);
  ELSIF !OKATO THEN
   L_General.Assert(~!OKATO, " ᢮⢥ " + L_Str.IntStr(P_PayPInfo) + "  " + trgContract + "    ''");
  END;
  RETURN OKATO;
 END {ppi_OKATO};

 PUBLIC PROCEDURE ppi_pmnt_Former(trgContract: LIKE(Contract.Contract); D: DATE): STRING[];
  VAR
   DescriptionOfGoods,
   KBK,
   OKATO,
   Former            : STRING[];
 BEGIN
  Decode_PayPInfo(GetCntrProStrong(trgContract, D, P_PayPInfo), DescriptionOfGoods, KBK, OKATO, Former);
  L_General.Assert(~!Former, " ᢮⢥ " + L_Str.IntStr(P_PayPInfo) + "  " + trgContract + "    'ନ⥫'");
  RETURN Former;
 END {ppi_pmnt_Former};

 PRIVATE PROCEDURE GetDateFromPropVal(Idx: NUMERIC[0]): DATE;
  VAR
   _DateAsStr: STRING[];
 BEGIN
  _DateAsStr:=L_Prop.getRecordElement(CntrPro.Value, Idx);
  L_Prop.CheckDateValue(_DateAsStr, "D.N.y");
  RETURN STRTOFLD(_DateAsStr, DATE, "D.N.y");
 END {GetDateFromPropVal};

 PRIVATE PROCEDURE Decode_Duration(    curValue: LIKE(CntrPro.Value);
                                   VAR Begin   : DATE;
                                   VAR Till    : DATE);
 BEGIN
  Begin:=L_Prop.GetDateFromStr(L_Prop.getRecordElement(curValue, 0), 1);
  Till :=L_Prop.GetDateFromStr(L_Prop.getRecordElement(curValue, 1), 1);
 END {Decode_Duration};

 PRIVATE PROCEDURE formSet_Duration();
 BEGIN
  Decode_Duration(CntrPro.Value,
                  RTI.Get().CurZone.Fields("Begin").Value,
                  RTI.Get().CurZone.Fields("Till").Value);
 END {formSet_Duration};

 PRIVATE PROCEDURE formGet_Duration();
  VAR
   Begin, Till: DATE;
 BEGIN
  Begin:=RTI.Get().CurZone.Fields("Begin").Value;
  Till :=RTI.Get().CurZone.Fields("Till").Value;
  L_General.Assert(~!Begin | !Till, " 稨  ''     ' '");
  L_General.Assert(!Begin | (Begin < Till), " ' '   ࠭  ''");

  L_Prop.putRED(CntrPro.Value, Begin);
  L_Prop.putRED(CntrPro.Value, Till);
  L_Prop.ConvEmptyRecordPropertyValue(CntrPro.Value);
 END {formGet_Duration};

 PRIVATE PROCEDURE Decode_PriceLevel(    curValue: LIKE(CntrPro.Value);
                                     VAR Type    : t_PriceLevelType;
                                     VAR Value   : NUMERIC[4]);
 BEGIN
  Type :=L_Str.PositionInPool(plt_Pool, L_Prop.getRecordElement(curValue, 0));
  Value:=L_Prop.GetNumericValueFromStr(L_Prop.getRecordElement(curValue, 1));
 END {Decode_PriceLevel};

 PRIVATE PROCEDURE formSet_PriceLevel();
 BEGIN
  Decode_PriceLevel(CntrPro.Value, RTI.Get().CurZone.Fields("Type").Value, RTI.Get().CurZone.Fields("Value").Value);
  RTI.Get().CurZone.Fields("Type").Format:=plt_Pool;
 END {formSet_PriceLevel};

 PRIVATE PROCEDURE formGet_PriceLevel();
  VAR
   Type : t_PriceLevelType;
   Value: NUMERIC[4];
 BEGIN
  Type :=RTI.Get().CurZone.Fields("Type").Value;
  Value:=RTI.Get().CurZone.Fields("Value").Value;
  L_General.Assert(~!Type = ~!Value, "  祭     ६");
  L_General.Assert(!Value | (Value >= 0), "祭    ⥫");
  IF ~!Type & ~!Value THEN
   L_Prop.putRES(CntrPro.Value, L_Str.PoolItem(plt_Pool, Type));
   L_Prop.putREV(CntrPro.Value, Value);
  END;
 END {formGet_PriceLevel};

 PRIVATE PROCEDURE intGetPeriodicAcptData(VAR MonthInPeriod, DocsPerPeriod: NUMERIC[0]; VAR FirstMonth: DATE);
 BEGIN
  MonthInPeriod:=L_Str.Str2Num(L_Prop.getRecordElement(CntrPro.Value, 0), "0");
  DocsPerPeriod:=L_Str.Str2Num(L_Prop.getRecordElement(CntrPro.Value, 1), "0");
  FirstMonth   :=L_Prop.GetDateFromStr(   L_Prop.getRecordElement(CntrPro.Value, 2), 1);
 END {intPeriodicAcptData};

 PRIVATE PROCEDURE Decode_ContractorsName(    curValue         : STRING[];
                                          VAR OwnContractor    : STRING[];
                                          VAR OtherContractor  : STRING[];
                                          VAR ExtContractNaming: STRING[]);
  VAR
   i        : NUMERIC[0];
   SingleVal: STRING[];
 BEGIN
  OwnContractor  :=L_Prop.getRecordElement(curValue, 0);
  OtherContractor:=L_Prop.getRecordElement(curValue, 1);
  SETEMPTY(ExtContractNaming);
  i:=0;
  WHILE i < CaseAmount DO
   ExtContractNaming:=ExtContractNaming + L_Prop.getRecordElement(curValue, i+2);
   INC(i);
   IF i < CaseAmount THEN
    ExtContractNaming:=ExtContractNaming + ";";
   END;
  END; (* WHILE i < CaseAmount...*)
  L_Prop.ConvEmptyRecordPropertyValue(ExtContractNaming);
 END {Decode_ContractorsName};

 PRIVATE PROCEDURE formSet_ContractorsName();
  VAR
   Fields               : FORM_FIELDS;
   ExtContractNamingPool: STRING[];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_ContractorsName(CntrPro.Value,
                         Fields("OwnContractor").Value,
                         Fields("OtherContractor").Value,
                         Fields("ExtContractNaming").Value);

  CONFORM(CntrPro, Contract);
  ExtContractNamingPool:=L_Pool.Get(pool_cen);
  IF Contract.Type = L_Cntr.ct_Prch THEN
   Fields("OwnContractor").Template  :=L_Pool.Get(pool_c2n);
   Fields("OtherContractor").Template:=L_Pool.Get(pool_c1n);
  ELSE
   Fields("OwnContractor").Template  :=L_Pool.Get(pool_c1n);
   Fields("OtherContractor").Template:=L_Pool.Get(pool_c2n);
  END;
  Fields("ExtContractNaming").Template:=ExtContractNamingPool;
 END {formSet_ContractorsName};

 PRIVATE PROCEDURE formGet_ContractorsName();
  VAR
   Fields         : FORM_FIELDS;
   OwnContractor,
   OtherContractor: STRING[];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  OwnContractor  :=Fields("OwnContractor").Value;
  OtherContractor:=Fields("OtherContractor").Value;
  L_General.Assert(!OwnContractor = !OtherContractor,
                   " ஭     ६");

  L_Prop.putRES(CntrPro.Value, OwnContractor);
  L_Prop.putRES(CntrPro.Value, OtherContractor);
  CntrPro.Value:=CntrPro.Value + Fields("ExtContractNaming").Value;

  L_Prop.ConvEmptyRecordPropertyValue(CntrPro.Value);
 END {formGet_ContractorsName};

 PRIVATE PROCEDURE Decode_DefaultPayFirmAcnt(    curValue     : LIKE(CntrPro.Value);
                                             VAR OtherFirmAcnt: LIKE(FirmAcnt.FirmAcnt);
                                             VAR OwnFirmAcnt  : LIKE(FirmAcnt.FirmAcnt));
 BEGIN
  OtherFirmAcnt:=L_Prop.getRecordElement(curValue, 0);
  OwnFirmAcnt  :=L_Prop.getRecordElement(curValue, 1);
 END {Decode_DefaultPayFirmAcnt};

 PRIVATE PROCEDURE formSet_DefaultPayFirmAcnt();
  VAR
   OwnFirmAcnt,
   OtherFirmAcnt: LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  Decode_DefaultPayFirmAcnt(CntrPro.Value, OtherFirmAcnt, OwnFirmAcnt);
  CONFORM(CntrPro, Contract);
  RTI.Get().CurZone.Fields("OtherFirmAcnt").Modifiable :=Contract.Leaf = 1;
  RTI.Get().CurZone.Fields("OtherFirmAcnt").Value      :=OtherFirmAcnt;
  RTI.Get().CurZone.Fields("OtherFirmAcnt_Descr").Value:=GetFirmAcntDescr(dpfat_OtherFirm, OtherFirmAcnt);
  RTI.Get().CurZone.Fields("OwnFirmAcnt").Value        :=OwnFirmAcnt;
  RTI.Get().CurZone.Fields("OwnFirmAcnt_Descr").Value  :=GetFirmAcntDescr(dpfat_OwnFirm,  OwnFirmAcnt);
 END {formSet_DefaultPayFirmAcnt};

 PRIVATE PROCEDURE formGet_DefaultPayFirmAcnt();
 BEGIN
  L_Prop.putREV(CntrPro.Value, RTI.Get().CurZone.Fields("OtherFirmAcnt").Value);
  L_Prop.putREV(CntrPro.Value, RTI.Get().CurZone.Fields("OwnFirmAcnt").Value);

  L_Prop.ConvEmptyRecordPropertyValue(CntrPro.Value);
 END {formGet_DefaultPayFirmAcnt};

 PRIVATE PROCEDURE Decode_PropertyObjectDescription(    curValue           : LIKE(CntrPro.Value);
                                                    VAR Address            : STRING[];
                                                    VAR Location           : STRING[];
                                                    VAR Area               : NUMERIC[1];
                                                    VAR Purpose            : STRING[];
                                                    VAR RegistrationInf    : STRING[];
                                                    VAR PreparationDeadline: DATE;
                                                    VAR ConveyanceDeadline : DATE);
 BEGIN
  Address            :=L_Prop.getRecordElement(curValue, 0);
  Location           :=L_Prop.getRecordElement(curValue, 1);
  Area               :=L_Prop.GetNumericValueFromStr(L_Prop.getRecordElement(curValue, 2));
  Purpose            :=L_Prop.getRecordElement(curValue, 3);
  RegistrationInf    :=L_Prop.getRecordElement(curValue, 4);
  PreparationDeadline:=L_Prop.GetDateFromStr(L_Prop.getRecordElement(curValue, 5), 1);
  ConveyanceDeadline :=L_Prop.GetDateFromStr(L_Prop.getRecordElement(curValue, 6), 1);
 END {Decode_PropertyObjectDescription};

 PRIVATE PROCEDURE formSet_PropertyObjectDescription();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_PropertyObjectDescription(CntrPro.Value, Fields("Address").Value,
                                                  Fields("Location").Value,
                                                  Fields("Area").Value,
                                                  Fields("Purpose").Value,
                                                  Fields("RegistrationInf").Value,
                                                  Fields("PreparationDeadline").Value,
                                                  Fields("ConveyanceDeadline").Value);
 END {formSet_PropertyObjectDescription};

 PRIVATE PROCEDURE formGet_PropertyObjectDescription();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;

  L_Prop.putRES(CntrPro.Value, Fields("Address").Value);
  L_Prop.putRES(CntrPro.Value, Fields("Location").Value);
  L_Prop.putREV(CntrPro.Value, Fields("Area").Value);
  L_Prop.putRES(CntrPro.Value, Fields("Purpose").Value);
  L_Prop.putRES(CntrPro.Value, Fields("RegistrationInf").Value);
  L_Prop.putRED(CntrPro.Value, Fields("PreparationDeadline").Value);
  L_Prop.putRED(CntrPro.Value, Fields("ConveyanceDeadline").Value);
  L_Prop.ConvEmptyRecordPropertyValue(CntrPro.Value);
 END {formGet_PropertyObjectDescription};

 PRIVATE PROCEDURE Decode_PeriodicAcptDuration(    curValue: LIKE(CntrPro.Value);
                                               VAR Begin   : DATE;
                                               VAR Till    : DATE);
 BEGIN
  Begin:=L_Prop.GetDateFromStr(L_Prop.getRecordElement(curValue, 0), 1);
  Till :=L_Prop.GetDateFromStr(L_Prop.getRecordElement(curValue, 1), 1);
 END {Decode_PeriodicAcptDuration};

 PRIVATE PROCEDURE formSet_PeriodicAcptDuration();
 BEGIN
  Decode_PeriodicAcptDuration(CntrPro.Value,
                              RTI.Get().CurZone.Fields("Begin").Value,
                              RTI.Get().CurZone.Fields("Till").Value);
 END {formSet_PeriodicAcptDuration};

 PRIVATE PROCEDURE formGet_PeriodicAcptDuration();
  VAR
   Begin, Till: DATE;
 BEGIN
  Begin:=RTI.Get().CurZone.Fields("Begin").Value;
  Till :=RTI.Get().CurZone.Fields("Till").Value;
  L_General.Assert(~!Begin | !Till, " 稨  ''     ' '");
  L_General.Assert(!Begin | (Begin < Till), " ' '   ࠭  ''");

  L_Prop.putRED(CntrPro.Value, Begin);
  L_Prop.putRED(CntrPro.Value, Till);
  L_Prop.ConvEmptyRecordPropertyValue(CntrPro.Value);
 END {formGet_PeriodicAcptDuration};

 PRIVATE PROCEDURE SetCURateFieldModifiable();
  VAR
   Fields : FORM_FIELDS;
   trgRate: tCURate;
 BEGIN
  Fields :=RTI.Get().CurZone.Fields;
  trgRate:=Fields("Rate").Value;
  Fields("Rate_asStr"    ).Value:="稭 " + L_Str.PoolItem("||", trgRate);
  Fields("Value_asStr"   ).Value:=L_Str.PoolItem("%|%|", trgRate);
  Fields("clcRate_asStr" ).Value:=L_Str.PoolItem("   | |   ", trgRate);
  Fields("clcValue_asStr").Value:=L_Str.PoolItem("%||%", trgRate);

  Fields("Value"      ).Modifiable:=trgRate # cur_r_None;
  Fields("Currency"   ).Modifiable:=trgRate # cur_r_None;
 END {SetCURateFieldModifiable};

 PRIVATE PROCEDURE Calc_clcValue(USDRate: FLOAT;
                                 Rate   : tCURate;
                                 Value  : FLOAT): FLOAT;
  VAR
   Result: FLOAT;
 BEGIN
  IF ~!Value & ~!USDRate THEN
   IF    Rate = cur_r_Raise THEN
    Result:=USDRate + USDRate * (Value / 100);
   ELSIF Rate = cur_r_Arbitrary THEN
    Result:=((Value * 100 ) / USDRate) - 100;
   ELSE
    Result:=EMPTYOF(FLOAT);
   END;
  ELSE
   Result:=EMPTYOF(FLOAT);
  END;
  RETURN Result;
 END {Calc_clcValue};

 PRIVATE PROCEDURE Decode_CURate(    trgValue: STRING[];
                                     D       : DATE;
                                 VAR USDRate : FLOAT;
                                 VAR Rate    : tCURate;
                                 VAR Value   : FLOAT;
                                 VAR Currency: tCUCurrency;
                                 VAR clcValue: FLOAT);
 BEGIN
  IF ~!D THEN
   USDRate:=P_OwnData.USDRate(D);
  ELSE
   SETEMPTY(USDRate);
  END;
  SETZERO(Currency, Rate, Value, clcValue);
  IF ~!trgValue THEN
   Rate:=L_Str.PositionInPool(cur_RatePool, L_Prop.getRecordElement(trgValue, cur_nbr_Rate));
   L_General.Assert(~!Rate, "୮ 祭 '" + L_Prop.getRecordElement(trgValue, cur_nbr_Rate) + "'");
   IF Rate # cur_r_None THEN
    Value   :=STRTOFLD(L_Prop.getRecordElement(trgValue, cur_nbr_Value), NUMERIC);
    Currency:=L_Str.PositionInPool(cur_CurrencyPool, L_Prop.getRecordElement(trgValue, cur_nbr_Currency));
    L_General.Assert(~!Currency, "୮ 祭 '" + L_Prop.getRecordElement(trgValue, cur_nbr_Currency) + "'");
    clcValue:=Calc_clcValue(USDRate, Rate, Value);
   END;
  END;
 END {Decode_CURate};

 PRIVATE PROCEDURE formSet_CURate();
  VAR
   Fields: FORM_FIELDS;
   USDRate : FLOAT;
   Rate    : tCURate;
   Value   : FLOAT;
   Currency: tCUCurrency;
   clcValue: FLOAT;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Currency").Format:=cur_CurrencyPool;
  Fields("Rate"    ).Format:=cur_RatePool;
  Decode_CURate(CntrPro.Value, CntrPro.Date, USDRate, Rate, Value, Currency, clcValue);
  Fields("USDRate" ).Value:=USDRate;
  Fields("Rate"    ).Value:=Rate;
  Fields("Value"   ).Value:=Value;
  Fields("Currency").Value:=Currency;
  Fields("clcValue").Value:=clcValue;
  SetCURateFieldModifiable();
 END {formSet_CURate};

 PUBLIC PROCEDURE GetCUR_Rate(trgContract: LIKE(Contract.Contract); D: DATE): tCURate;
  VAR
   USDRate : FLOAT;
   Result  : tCURate;
   Value   : FLOAT;
   Currency: tCUCurrency;
   clcValue: FLOAT;
 BEGIN
  IF HasActualPro(trgContract, D, P_CURate) THEN
   Decode_CURate(CntrPro.Value, CntrPro.Date, USDRate, Result, Value, Currency, clcValue);
  ELSE
   Result:=EMPTYOF(tCURate);
  END;
  RETURN Result;
 END {GetCUR_Rate};

 PUBLIC PROCEDURE GetCUR_Value(trgContract: LIKE(Contract.Contract); D: DATE): FLOAT;
  VAR
   USDRate : FLOAT;
   Rate    : tCURate;
   Result  : FLOAT;
   Currency: tCUCurrency;
   clcValue: FLOAT;
 BEGIN
  IF HasActualPro(trgContract, D, P_CURate) THEN
   Decode_CURate(CntrPro.Value, CntrPro.Date, USDRate, Rate, Result, Currency, clcValue);
  ELSE
   Result:=EMPTYOF(FLOAT);
  END;
  RETURN Result;
 END {GetCUR_Value};

 PUBLIC PROCEDURE GetCUR_Currency(trgContract: LIKE(Contract.Contract); D: DATE): tCUCurrency;
  VAR
   USDRate : FLOAT;
   Rate    : tCURate;
   Value   : FLOAT;
   Result  : tCUCurrency;
   clcValue: FLOAT;
 BEGIN
  IF HasActualPro(trgContract, D, P_CURate) THEN
   Decode_CURate(CntrPro.Value, CntrPro.Date, USDRate, Rate, Value, Result, clcValue);
  ELSE
   Result:=EMPTYOF(tCUCurrency);
  END;
  RETURN Result;
 END {GetCUR_Currency};

 PRIVATE PROCEDURE Decode_AddIns(    Value  : STRING[];
                                 VAR Kind   : STRING[];
                                 VAR Version: tTemplateVersion);
  VAR
   tmpValue: STRING[];
 BEGIN
  SETEMPTY(Kind, Version);
  IF ~!Value THEN
   Kind    :=L_Prop.getRecordElement(Value, 0);
   tmpValue:=L_Prop.getRecordElement(Value, 1);
   IF ~!tmpValue THEN
    L_Prop.CheckScalValue(tmpValue, "", MAXOF(tTemplateVersion));
    Version:=tmpValue;
   END;
  END;

 END {Decode_AddIns};

 PRIVATE PROCEDURE formSet_AddIns();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Kind").Template        :=L_Pool.Get(L_ODoc.pool_ContractAdInsSense);
  Fields("Kind").TemplateIsStrict:=1;
  Decode_AddIns(CntrPro.Value, Fields("Kind").Value, Fields("Version").Value);
 END {formSet_AddIns};

 PUBLIC PROCEDURE Decode_PaymentAgents(    Value: STRING[];
                                       VAR Firms: LIKE(Firm.Firm)[]);
  VAR
   Idx: NUMERIC[0];
 BEGIN
  SETEMPTY(Firms);
  Idx:=0;
  WHILE ~!L_Prop.getRecordElement(Value, Idx) DO
   Firms[Idx]:=STRTOFLD(L_r2r.DecodeReferenceStamp(L_Prop.getRecordElement(Value, Idx)), SCAL);
   INC(Idx);
  END;
 END {Decode_PaymentAgents};

 PRIVATE PROCEDURE formSet_PaymentAgents();
  VAR
   Fields: FORM_FIELDS;
   Firms : tFirms;
   Idx   : SCAL[FirmsAmount];
 BEGIN
  Decode_PaymentAgents(CntrPro.Value, Firms);
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   L_WDO.extCreateFormLink("Firm", "", Idx);
   Fields(L_WDO.Fld_wIdx("Firm", Idx)).Value:=Firms[Idx];
  END;
 END {formSet_PaymentAgents};

 PRIVATE PROCEDURE Decode_DocumentsCirculationStructure(    Value      : STRING[];
                                                        VAR arrMDocKind: LIKE(MDocKind.MDocKind)[];
                                                        VAR arrTemplate: STRING[][];
                                                        VAR arrVersion : tTemplateVersion[]);
  VAR
   Idx   : NUMERIC[0];
   Record: STRING[];
 BEGIN
  SETEMPTY(arrMDocKind, arrTemplate, arrVersion);
  Idx:=0;
  WHILE ~!L_Prop.getArrayItem(Value, Idx) DO
   Record          :=L_Prop.getArrayItem(Value, Idx);
   arrMDocKind[Idx]:=L_r2r.DecodeReferenceStamp(L_Prop.getRecordElement(Record, 0));
   arrTemplate[Idx]:=L_Prop.getRecordElement(Record, 1);
   arrVersion[Idx] :=L_Prop.getRecordElement(Record, 2);
   INC(Idx);
  END;
 END {Decode_DocumentsCirculationStructure};

 PRIVATE PROCEDURE formSet_DocumentsCirculationStructure();
  VAR
   Fields: FORM_FIELDS;
   Idx   : SCAL[dcs_Amount];
   arrMDocKind: LIKE(MDocKind.MDocKind)[dcs_Amount];
   arrTemplate: STRING[][dcs_Amount];
   arrVersion : tTemplateVersion[dcs_Amount];
 BEGIN
  Decode_DocumentsCirculationStructure(CntrPro.Value, arrMDocKind, arrTemplate, arrVersion);
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   L_WDO.extCreateFormLink("MDocKind", "", Idx);
   Fields(L_WDO.Fld_wIdx("MDocKind", Idx)).Value:=arrMDocKind[Idx];
   Fields(L_WDO.Fld_wIdx("Template", Idx)).Value:=arrTemplate[Idx];
   Fields(L_WDO.Fld_wIdx("Version",  Idx)).Value:=arrVersion[Idx];
  END;
 END {formSet_DocumentsCirculationStructure};

 PRIVATE PROCEDURE Decode_DocumentForms(    Value           : STRING[];
                                        VAR ContractTemplate: STRING[];
                                        VAR ContractCopies  : NUMERIC[0];
                                        VAR AITitle,
                                            AITemplate      : STRING[][df_AIAmount];
                                        VAR AICopies        : NUMERIC[0][df_AIAmount];
                                        VAR MsgTitle,
                                            MsgTemplate     : STRING[][df_MsgAmount];
                                        VAR MsgCopies       : NUMERIC[0][df_MsgAmount]);
  VAR
   i,
   AIIdx,
   MsgIdx     : NUMERIC[0];
   Title,
   Sign,
   SingleValue: STRING[];
 BEGIN
  SETEMPTY(ContractTemplate, ContractCopies, AITemplate, AITitle, AICopies, MsgTemplate, MsgTitle, MsgCopies);
  i:=0;
  LOOP
   AITitle[i]:=L_Str.AnyItem(L_Pool.Get(L_ODoc.pool_ContractAdInsSense), "|", i);
   IF !AITitle[i] THEN
    EXIT;
   END;
   INC(i);
  END; (* LOOP *)

  i:=0;
  LOOP
   MsgTitle[i]:=L_Str.AnyItem(L_Pool.Get(L_ODoc.pool_ContractMessageSense), "|", i);
   IF !MsgTitle[i] THEN
    EXIT;
   END;
   INC(i);
  END; (* LOOP *)

  IF ~!Value THEN
   SingleValue     :=Str.Item(Value, "[", 0);
   ContractTemplate:=Str.Condense(L_Prop.getRecordElement(SingleValue, 0));
   ContractCopies  :=STRTOFLD(L_Prop.getRecordElement(SingleValue, 1), NUMERIC);
   i:=0;
   LOOP
    SingleValue:=L_Prop.getArrayItem(Value, i);
    IF !SingleValue THEN
     EXIT;
    END;
    Title:=Str.Condense(L_Prop.getRecordElement(SingleValue, 0));
    Sign :=L_Prop.getRecordElement(SingleValue, 3);
    IF    Sign = df_MsgSign THEN
     MsgIdx:=L_Str.PositionInPool(L_Pool.Get(L_ODoc.pool_ContractMessageSense), Title);
     L_General.Assert(~!MsgIdx, "४⭠ ଠ 㬥  '" + Title + "'");
     L_General.Assert(!MsgTemplate[MsgIdx], "ଠ 㬥 |'" + Title + "'|㪠   ࠧ");
     MsgTemplate[MsgIdx]:=Str.Condense(L_Prop.getRecordElement(SingleValue, 1));
     MsgCopies  [MsgIdx]:=STRTOFLD(L_Prop.getRecordElement(SingleValue, 2), NUMERIC);
    ELSIF Sign = df_AISign THEN
     AIIdx:=L_Str.PositionInPool(L_Pool.Get(L_ODoc.pool_ContractAdInsSense), Title);
     L_General.Assert(~!AIIdx, "४⭠ ଠ 㬥  '" + Title + "'");
     L_General.Assert(!AITemplate[AIIdx], "ଠ 㬥 |'" + Title + "'|㪠   ࠧ");
     AITemplate[AIIdx]:=Str.Condense(L_Prop.getRecordElement(SingleValue, 1));
     AICopies  [AIIdx]:=STRTOFLD(L_Prop.getRecordElement(SingleValue, 2), NUMERIC);
    ELSE
     L_General.CallUs(0);
    END;
    INC(i);
   END; (* LOOP *)
  END;
 END {Decode_DocumentForms};

 PRIVATE PROCEDURE formSet_DocumentForms();
  VAR
   i          : NUMERIC[0];
   Fields     : FORM_FIELDS;
   AITitle,
   AITemplate : STRING[][df_AIAmount];
   AICopies   : NUMERIC[0][df_AIAmount];
   MsgTitle,
   MsgTemplate: STRING[][df_MsgAmount];
   MsgCopies  : NUMERIC[0][df_MsgAmount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_DocumentForms(CntrPro.Value,
                       Fields("ContractTemplate").Value,
                       Fields("ContractCopies"  ).Value,
                       AITitle,  AITemplate,  AICopies,
                       MsgTitle, MsgTemplate, MsgCopies);

  i:=0;
  WHILE i < df_AIAmount DO
   Fields(L_WDO.Fld_wIdx("AITitle",    i)).Visible:=~!AITitle[i];
   Fields(L_WDO.Fld_wIdx("AITemplate", i)).Visible:=~!AITitle[i];
   Fields(L_WDO.Fld_wIdx("AICopies",   i)).Visible:=~!AITitle[i];
   Fields(L_WDO.Fld_wIdx("AITitle",    i)).Value  :=AITitle[i];
   Fields(L_WDO.Fld_wIdx("AITemplate", i)).Value  :=AITemplate[i];
   Fields(L_WDO.Fld_wIdx("AICopies",   i)).Value  :=AICopies[i];
   INC(i);
  END; (* WHILE i < df_AIAmount *)
  i:=0;
  WHILE i < df_MsgAmount DO
   Fields(L_WDO.Fld_wIdx("MsgTitle",    i)).Visible:=~!MsgTitle[i];
   Fields(L_WDO.Fld_wIdx("MsgTemplate", i)).Visible:=~!MsgTitle[i];
   Fields(L_WDO.Fld_wIdx("MsgCopies",   i)).Visible:=~!MsgTitle[i];
   Fields(L_WDO.Fld_wIdx("MsgTitle",    i)).Value  :=MsgTitle[i];
   Fields(L_WDO.Fld_wIdx("MsgTemplate", i)).Value  :=MsgTemplate[i];
   Fields(L_WDO.Fld_wIdx("MsgCopies",   i)).Value  :=MsgCopies[i];
   INC(i);
  END; (* WHILE i < df_AIAmount *)
 END {formSet_DocumentForms};

 PUBLIC PROCEDURE SetDataInForm(trgProperty : LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_ContractorsName THEN
   formSet_ContractorsName();
  ELSIF trgProperty = P_CURate THEN
   formSet_CURate();
  ELSIF (trgProperty = P_PaymentAgents) | (trgProperty = P_Consignees) THEN
   formSet_PaymentAgents();
  ELSIF trgProperty = P_PayPInfo THEN
   formSet_PayPInfo();
  ELSIF trgProperty = P_DefaultPayFirmAcnt THEN
   formSet_DefaultPayFirmAcnt();
  ELSIF trgProperty = P_DocumentsCirculationStructure THEN
   formSet_DocumentsCirculationStructure();
  ELSIF trgProperty = P_DocumentForms THEN
   formSet_DocumentForms();
  ELSIF trgProperty = P_Duration THEN
   formSet_Duration();
  ELSIF trgProperty = P_AddIns THEN
   formSet_AddIns();
  ELSIF trgProperty = P_PropertyObjectDescription THEN
   formSet_PropertyObjectDescription();
  ELSIF trgProperty = P_PartnerAgent THEN
   formSet_PartnerAgent();
  ELSIF trgProperty = P_OwnAgent THEN
   formSet_OwnAgent();
  ELSIF trgProperty = P_MakeBillsSetting THEN
   mbs_PrepareForm();
   mbs_DecodeValue(0);
  ELSIF trgProperty = P_PriceLevel THEN
   formSet_PriceLevel();
  ELSIF trgProperty = P_AllowedCostItem THEN
   formSet_AllowedCostItem();
  ELSIF trgProperty = P_PeriodicAcpt THEN
   intGetPeriodicAcptData(RTI.Get().CurZone.Fields(v_pac_MonthInPeriod).Value,
                          RTI.Get().CurZone.Fields(v_pac_DocsPerPeriod).Value,
                          RTI.Get().CurZone.Fields(v_pac_FirstMonth).Value);
   SetPeriodicAcptFieldModifiable();
  ELSIF trgProperty = P_PeriodicAcptDuration THEN
   formSet_PeriodicAcptDuration();
  ELSIF trgProperty = P_AllowedDest THEN
   formSet_AllowedDest();
  ELSIF trgProperty = P_CntrAddendum THEN
   formSet_CntrAddendum();
  ELSIF ~!IsSimpleUserOf(trgProperty) THEN
   formSet_CntrPro(trgProperty);
  END;
 END {SetDataInForm};

 PRIVATE PROCEDURE GetDateAsStr(D: DATE): STRING[];
 BEGIN
  IF ~!D THEN
   RETURN L_DatTim.DateStr(D);
  ELSE
   RETURN "";
  END;
 END {GetDateAsStr};

 PRIVATE PROCEDURE mbs_EncodeValue();
 BEGIN
  CntrPro.Value:=      L_Str.CheckPresenceSemicolon(RTI.Get().CurZone.Fields("Mode").Value)    +
                 ";" + L_Str.CheckPresenceSemicolon(RTI.Get().CurZone.Fields("MthPrep").Value) +
                 ";" + Str.Condense(FLDTOSTR(RTI.Get().CurZone.Fields("RegularMDocKind").Value, "L", 0)) +
                 ";" + Str.Condense(FLDTOSTR(RTI.Get().CurZone.Fields("AcptMDocKind").Value, "L", 0)) ;
 END {mbs_EncodeValue};

 PRIVATE PROCEDURE Encode_CURate(VAR trgValue: STRING[];
                                     Rate    : tCURate;
                                     Value   : FLOAT;
                                     Currency: tCUCurrency);
 BEGIN
  L_Prop.putRES(trgValue, L_Str.PoolItem(cur_RatePool, Rate));
  IF Rate # cur_r_None THEN
   L_Prop.putRES(trgValue, FLDTOSTR(Value, GetRateNumericFormat(Rate)));
   L_Prop.putRES(trgValue, L_Str.PoolItem(cur_CurrencyPool, Currency));
  END;
 END {Encode_CURate};

 PRIVATE PROCEDURE formGet_CURate();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_CURate(CntrPro.Value, Fields("Rate").Value, Fields("Value").Value, Fields("Currency").Value);
 END {formGet_CURate};

 PRIVATE PROCEDURE Encode_PayPInfo(VAR Value             : STRING[];
                                       DescriptionOfGoods: STRING[];
                                       KBK               : STRING[];
                                       OKATO             : STRING[];
                                       Former            : STRING[]);
  VAR
   Element: STRING[];
 BEGIN
  IF ~!DescriptionOfGoods | ~!KBK | ~!OKATO | ~!Former THEN
   L_Prop.putRES(Value, DescriptionOfGoods);
   L_Prop.putRES(Value, KBK);
   L_Prop.putRES(Value, OKATO);
   IF ~!Former THEN
    Element:=L_Str.PoolItem(L_ExtAb.Former_Pool_Short, L_Str.PositionInPool(L_ExtAb.Former_Pool, Former));
   ELSE
    SETEMPTY(Element);
   END;
   L_Prop.putRES(Value, Element);
  END;
 END {Encode_PayPInfo};

 PRIVATE PROCEDURE formGet_PayPInfo();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_PayPInfo(CntrPro.Value, Fields("DescriptionOfGoods").Value, Fields("KBK").Value, Fields("OKATO").Value, Fields("Former").Value);
 END {formGet_PayPInfo};

 PRIVATE PROCEDURE Encode_AddIns(VAR Value: STRING[]; Kind: STRING[]; Version: tTemplateVersion);
 BEGIN
  L_Prop.putRES(Value, Kind);
  L_Prop.putRES(Value, Str.Condense(FLDTOSTR(Version)));
 END {Encode_AddIns};

 PRIVATE PROCEDURE formGet_AddIns();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_General.Assert(~!Fields("Kind").Value, " 㪠  ⥫쭮 ᮣ襭");
  Encode_AddIns(CntrPro.Value, Fields("Kind").Value, Fields("Version").Value);
 END {formGet_AddIns};

 PRIVATE PROCEDURE Encode_PaymentAgents(VAR Value: STRING[]; Firms: tFirms);
  VAR
   Idx: SCAL[FirmsAmount];
 BEGIN
  FOR_EACH Idx DO
   IF ~!Firms[Idx] THEN
    L_Prop.putRES(Value, L_r2r.Put("CntrPro", "Firm", Firms[Idx]));
   END;
  END;
 END {Encode_PaymentAgents};

 PRIVATE PROCEDURE formGet_PaymentAgents();
  VAR
   Fields: FORM_FIELDS;
   Firms : tFirms;
   Idx   : SCAL[FirmsAmount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   Firms[Idx]:=Fields(L_WDO.Fld_wIdx("Firm", Idx)).Value;
  END;
  Encode_PaymentAgents(CntrPro.Value, Firms);
 END {formGet_PaymentAgents};

 PRIVATE PROCEDURE Encode_DocumentsCirculationStructure(VAR Value      : STRING[];
                                                            arrMDocKind: LIKE(MDocKind.MDocKind)[dcs_Amount];
                                                            arrTemplate: STRING[][dcs_Amount];
                                                            arrVersion : tTemplateVersion[dcs_Amount]);
  VAR
   Idx   : SCAL[dcs_Amount];
   Record: STRING[];
 BEGIN
  FOR_EACH Idx DO
   IF ~!arrMDocKind[Idx] THEN
    SETEMPTY(Record);
    L_Prop.putRES(Record, L_r2r.Put("CntrPro", "MDocKind", arrMDocKind[Idx]));
    L_Prop.putRES(Record, arrTemplate[Idx]);
    L_Prop.putREV(Record, arrVersion[Idx]);
    L_Prop.putAIS(Value, Record);
   END;
  END;
 END {Encode_DocumentsCirculationStructure};

 PRIVATE PROCEDURE formGet_DocumentsCirculationStructure();
  VAR
   Fields     : FORM_FIELDS;
   Idx        : SCAL[dcs_Amount];
   i          : NUMERIC[0];
   arrMDocKind: LIKE(MDocKind.MDocKind)[dcs_Amount];
   arrTemplate: STRING[][dcs_Amount];
   arrVersion : tTemplateVersion[dcs_Amount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   arrMDocKind[Idx]:=Fields(L_WDO.Fld_wIdx("MDocKind", Idx)).Value;
   arrTemplate[Idx]:=Fields(L_WDO.Fld_wIdx("Template", Idx)).Value;
   arrVersion[Idx] :=Fields(L_WDO.Fld_wIdx("Version",  Idx)).Value;
   IF !arrMDocKind[Idx] & (~!arrTemplate[Idx] | ~!arrVersion[Idx]) THEN
    L_General.Error("   蠡    㪠   㬥");
   END;
  END;
  FOR_EACH Idx DO
   IF ~!arrMDocKind[Idx] THEN
    i:=0;
    WHILE i < dcs_Amount DO
     IF (i # Idx) & (arrMDocKind[Idx] = arrMDocKind[i]) THEN
      L_General.Error(" 㬥 " + arrMDocKind[Idx] + "   ᢮⢥   ࠧ") ;
     END;
     INC(i);
    END;
   END
  END;
  Encode_DocumentsCirculationStructure(CntrPro.Value, arrMDocKind, arrTemplate, arrVersion);
 END {formGet_DocumentsCirculationStructure};

 PUBLIC PROCEDURE Encode_CntrPro(trgValue   : LIKE(CntrPro.Value);
                                 trgProperty: LIKE(CntrPro.Property)): LIKE(CntrPro.Value);
  VAR
   Result    : LIKE(CntrPro.Value);
   SimpleUser: STRING[];
 BEGIN
  SimpleUser:=IsSimpleUserOf(trgProperty);
  L_General.CallUs(~!SimpleUser);
  IF !trgValue THEN
   SETEMPTY(Result);
  ELSE
   Result:=L_r2r.Put("CntrPro", SimpleUser, trgValue);
  END;
  RETURN Result;
 END {Encode_CntrPro};

 PRIVATE PROCEDURE Encode_DocumentForms(VAR Value           : STRING[];
                                            ContractTemplate: STRING[];
                                            ContractCopies  : NUMERIC[0];
                                            AITitle,
                                            AITemplate      : STRING[][df_AIAmount];
                                            AICopies        : NUMERIC[0][df_AIAmount];
                                            MsgTitle,
                                            MsgTemplate     : STRING[][df_MsgAmount];
                                            MsgCopies       : NUMERIC[0][df_MsgAmount]);
  VAR
   i        : NUMERIC[0];
   ArrayItem: STRING[];
 BEGIN
  Value:=Str.Condense(ContractTemplate) + ";" + L_Str.IntStr(ContractCopies);
  i:=0;
  WHILE i < df_AIAmount DO
   IF ~!AITemplate[i] THEN
    SETEMPTY(ArrayItem);
    L_Prop.putRES(ArrayItem, AITitle[i]);
    L_Prop.putRES(ArrayItem, AITemplate[i]);
    L_Prop.putREV(ArrayItem, AICopies[i]);
    L_Prop.putRES(ArrayItem, df_AISign);
    L_Prop.putAIS(Value, ArrayItem);
   END;
   INC(i);
  END; (* WHILE i < df_AIAmount...*)
  i:=0;
  WHILE i < df_MsgAmount DO
   IF ~!MsgTemplate[i] THEN
    SETEMPTY(ArrayItem);
    L_Prop.putRES(ArrayItem, MsgTitle[i]);
    L_Prop.putRES(ArrayItem, MsgTemplate[i]);
    L_Prop.putREV(ArrayItem, MsgCopies[i]);
    L_Prop.putRES(ArrayItem, df_MsgSign);
    L_Prop.putAIS(Value, ArrayItem);
   END;
   INC(i);
  END; (* WHILE i < df_MsgAmount...*)
 END {Encode_DocumentForms};

 PRIVATE PROCEDURE formGet_DocumentForms();
  VAR
   Fields     : FORM_FIELDS;
   i          : NUMERIC[0];
   AITitle,
   AITemplate : STRING[][df_AIAmount];
   AICopies   : NUMERIC[0][df_AIAmount];
   MsgTitle,
   MsgTemplate: STRING[][df_MsgAmount];
   MsgCopies  : NUMERIC[0][df_MsgAmount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  SETEMPTY(AITitle,  AITemplate,  AICopies, MsgTitle, MsgTemplate, MsgCopies);
  i:=0;
  WHILE i < df_AIAmount DO
   IF ~!Fields(L_WDO.Fld_wIdx("AITemplate", i)).Value THEN
    AITitle   [i]:=Fields(L_WDO.Fld_wIdx("AITitle",    i)).Value;
    AITemplate[i]:=Fields(L_WDO.Fld_wIdx("AITemplate", i)).Value;
    AICopies  [i]:=Fields(L_WDO.Fld_wIdx("AICopies",   i)).Value;
   END;
   INC(i);
  END; (* WHILE i < df_AIAmount...*)
  i:=0;
  WHILE i < df_MsgAmount DO
   IF ~!Fields(L_WDO.Fld_wIdx("MsgTemplate", i)).Value THEN
    MsgTitle   [i]:=Fields(L_WDO.Fld_wIdx("MsgTitle",    i)).Value;
    MsgTemplate[i]:=Fields(L_WDO.Fld_wIdx("MsgTemplate", i)).Value;
    MsgCopies  [i]:=Fields(L_WDO.Fld_wIdx("MsgCopies",   i)).Value;
   END;
   INC(i);
  END; (* WHILE i < df_MsgAmount...*)
  Encode_DocumentForms(CntrPro.Value, Fields("ContractTemplate").Value, Fields("ContractCopies").Value,
                       AITitle,  AITemplate,  AICopies, MsgTitle, MsgTemplate, MsgCopies);
 END {formGet_DocumentForms};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty : LIKE(Property.Property));
  VAR
   i: NUMERIC[0];
 BEGIN
  SETEMPTY(CntrPro.Value);
  IF    trgProperty = P_ContractorsName THEN
   formGet_ContractorsName();
  ELSIF trgProperty = P_CURate THEN
   formGet_CURate();
  ELSIF (trgProperty = P_PaymentAgents) | (trgProperty = P_Consignees) THEN
   formGet_PaymentAgents();
  ELSIF trgProperty = P_PayPInfo THEN
   formGet_PayPInfo();
  ELSIF trgProperty = P_DefaultPayFirmAcnt THEN
   formGet_DefaultPayFirmAcnt();
  ELSIF trgProperty = P_DocumentsCirculationStructure THEN
   formGet_DocumentsCirculationStructure();
  ELSIF trgProperty = P_DocumentForms THEN
   formGet_DocumentForms();
  ELSIF trgProperty = P_Duration THEN
   formGet_Duration();
  ELSIF trgProperty = P_AddIns THEN
   formGet_AddIns();
  ELSIF trgProperty = P_PropertyObjectDescription THEN
   formGet_PropertyObjectDescription();
  ELSIF trgProperty = P_PartnerAgent THEN
   formGet_PartnerAgent();
  ELSIF trgProperty = P_OwnAgent THEN
   formGet_OwnAgent();
  ELSIF trgProperty = P_MakeBillsSetting THEN
   mbs_EncodeValue();
  ELSIF trgProperty = P_PriceLevel THEN
   formGet_PriceLevel();
  ELSIF trgProperty = P_AllowedCostItem THEN
   formGet_AllowedCostItem();
  ELSIF trgProperty = P_PeriodicAcpt THEN
   CntrPro.Value:="";
   L_Prop.putREV(CntrPro.Value, RTI.Get().CurZone.Fields(v_pac_MonthInPeriod).Value);
   L_Prop.putREV(CntrPro.Value, RTI.Get().CurZone.Fields(v_pac_DocsPerPeriod).Value);
   L_Prop.putREV(CntrPro.Value, RTI.Get().CurZone.Fields(v_pac_FirstMonth).Value);
  ELSIF trgProperty = P_PeriodicAcptDuration THEN
   formGet_PeriodicAcptDuration();
  ELSIF trgProperty = P_AllowedDest THEN
   formGet_AllowedDest();
  ELSIF trgProperty = P_CntrAddendum THEN
   formGet_CntrAddendum();
  ELSIF ~!IsSimpleUserOf(trgProperty) THEN
   CntrPro.Value:=Encode_CntrPro(RTI.Get().CurZone.Fields("Value").Value, trgProperty);
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(CntrPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE IsPaymentAgent(trgContract: LIKE(Contract.Contract);
                                 D          : DATE;
                                 trgFirm    : LIKE(Firm.Firm)): SCAL[2];
  VAR
   i    : NUMERIC[3];
   Firms: tFirms;
 BEGIN
  Decode_PaymentAgents(GetCntrProSoft(trgContract, D, P_PaymentAgents), Firms);
  i:=0;
  LOOP
   IF !Firms[i] THEN
    RETURN 0;
   ELSIF Firms[i] = trgFirm THEN
    RETURN 1;
   END;
   INC(i);
  END;
 END {IsPaymentAgent};

 PUBLIC PROCEDURE GetContractProValueAsScal(trgContract: LIKE(Contract.Contract);
                                            D          : DATE;
                                            trgProperty: LIKE(Property.Property)): SCAL[1E3];
 BEGIN
  RETURN L_Prop.GetProValueAsScal(GetPool(trgProperty),
                                  GetCntrProStrong(trgContract, D, trgProperty));
 END {GetContractProValueAsScal};

 PUBLIC PROCEDURE GetInHouse(trgContract: LIKE(Contract.Contract); D: DATE): tInHouse;
 BEGIN
  RETURN GetContractProValueAsScal(trgContract, D, P_InHouse);
 END {GetInHouse};

 PUBLIC PROCEDURE GetReal(trgContract: LIKE(Contract.Contract); D: DATE): tReal;
 BEGIN
  RETURN GetContractProValueAsScal(trgContract, D, P_ExistanceReal);
 END {GetReal};

 PUBLIC PROCEDURE GetBalanceType(trgContract: LIKE(Contract.Contract); D: DATE): tBalanceType;
 BEGIN
  RETURN GetContractProValueAsScal(trgContract, D, P_BalanceType);
 END {GetBalanceType};

 PUBLIC PROCEDURE GetPayOblg(trgContract: LIKE(Contract.Contract); D: DATE): tPayOblg;
 BEGIN
  RETURN GetContractProValueAsScal(trgContract, D, P_PayOblg);
 END {GetPayOblg};

 PUBLIC PROCEDURE GetMakeBillsMth(trgContract: LIKE(Contract.Contract); D: DATE): tMakeBillsMth;
  VAR
   Result: tMakeBillsMth;
 BEGIN
  IF HasActualPro(trgContract, D, P_MakeBillsSetting) THEN
   Result:=L_Str.PositionInPool(mbm_Pool, L_Prop.getRecordElement(CntrPro.Value, 1));
  ELSE
   Result:=mbm_Not;
  END;
  RETURN Result;
 END {GetMakeBillsMth};

 PUBLIC PROCEDURE GetMakeBillsPayMode(trgContract: LIKE(Contract.Contract); D: DATE): tMakeBillsPayMode;
  VAR
   Result: tMakeBillsPayMode;
 BEGIN
  IF HasActualPro(trgContract, D, P_MakeBillsSetting) THEN
   Result:=L_Str.PositionInPool(mbpm_Pool, L_Prop.getRecordElement(CntrPro.Value, 0));
  ELSE
   Result:=mbpm_Irregular;
  END;
  RETURN Result;
 END {GetMakeBillsPayMode};

 PUBLIC PROCEDURE GetMakeBillsSettings(    trgContract    : LIKE(Contract.Contract);
                                           D              : DATE;
                                       VAR RegularMDocKind: LIKE(MDocKind.MDocKind);
                                       VAR AcptMDocKind   : LIKE(MDocKind.MDocKind));
 BEGIN
  L_General.Assert(GetMakeBillsMth(trgContract, D) # mbm_Not, "  " + trgContract + " ⮯⮢ ⮢  ।ᬮ७");
  RegularMDocKind:=L_Prop.getRecordElement(CntrPro.Value, 2);
  AcptMDocKind   :=L_Prop.getRecordElement(CntrPro.Value, 3);
 END {GetMakeBillsSettings};

 PUBLIC PROCEDURE GetSpecialAttitudeToVAT(trgContract: LIKE(Contract.Contract); D: DATE): tSpecialAttitudeToVAT;
  VAR
   tm    : P_MyFirm.tTaxationMode;
   Result: tSpecialAttitudeToVAT;
 BEGIN
  Result:=satVAT_woFeatures;
  IF HasActualPro(trgContract, D, P_SpecialAttitudeToVAT) THEN
   Result:=L_Str.PositionInPool(satVAT_Pool, CntrPro.Value);
  ELSE
   SAVE(Contract);
   SEARCH(Contract, Contract, , trgContract);
   IF Contract.Type = L_Cntr.ct_Sell THEN
    tm:=P_MyFirm.GetTaxationMode(Contract.MyFirm, D);
    IF    P_MyFirm.IsUSNO(tm)   THEN Result:=satVAT_Seller_wUSNO;
    ELSIF tm = P_MyFirm.tm_ENVD THEN Result:=satVAT_Seller_wENVD;
    END;
   END;
   RESTORE(Contract);
  END;
  RETURN Result;
 END {GetSpecialAttitudeToVAT};

 PUBLIC PROCEDURE Get_IP_CalculateKind(trgContract: LIKE(Contract.Contract); D: DATE): tIP_CalculateKind;
 BEGIN
  RETURN L_Str.PositionInPool(GetPool(P_IP_CalculateKind), GetCntrProStrong(trgContract, D, P_IP_CalculateKind));
 END {Get_IP_CalculateKind};

 PRIVATE PROCEDURE _GetDefaultPayFirmAcnt(trgContract: LIKE(Contract.Contract);
                                          D          : DATE;
                                          Type       : NUMERIC[0]): LIKE(FirmAcnt.FirmAcnt);
  VAR
   OtherFirmAcnt,
   OwnFirmAcnt  : LIKE(FirmAcnt.FirmAcnt);
   Result       : LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  SETEMPTY(Result);
  Decode_DefaultPayFirmAcnt(GetCntrProSoft(trgContract, D, P_DefaultPayFirmAcnt), OtherFirmAcnt, OwnFirmAcnt);
  IF Type = dpfat_OtherFirm THEN
   Result:=OtherFirmAcnt;
  ELSE
   Result:=OwnFirmAcnt;
  END;

  IF !Result THEN
   L_General.CallUs(SEARCH(Contract, Contract, trgContract));
   SAVE(Firm);
   SAVE(FirmAcnt);
   IF    Type = dpfat_OwnFirm THEN
    P_Firm.AccessSilentFirmAcnt(P_Firm.fomf(Contract.MyFirm), D);
    Result:=FirmAcnt.FirmAcnt;
   ELSIF P_Firm.SoftAccessSilentFirmAcnt(Contract.Firm, D) THEN
    Result:=FirmAcnt.FirmAcnt;
   END;
   RESTORE(FirmAcnt);
   RESTORE(Firm);
  END;
  RETURN Result;
 END {_GetDefaultPayFirmAcnt};

 PUBLIC PROCEDURE GetDefaultPayOwnFirmAcnt(trgContract: LIKE(Contract.Contract); D: DATE): LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  RETURN _GetDefaultPayFirmAcnt(trgContract, D, dpfat_OwnFirm);
 END {GetDefaultPayOwnFirmAcnt};

 PUBLIC PROCEDURE GetDefaultPayFirmAcnt(trgContract: LIKE(Contract.Contract); D: DATE): LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  RETURN _GetDefaultPayFirmAcnt(trgContract, D, dpfat_OtherFirm);
 END {GetDefaultPayFirmAcnt};

 PRIVATE PROCEDURE GetPropertyCode(ModuleName, PropName: STRING[]; Strong: SCAL[2]): LIKE(Property.Property);
  VAR
   Result: LIKE(Property.Property);
   PropertyAsStr: STRING[];
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   PropertyAsStr:=ModuleName+"P_"+PropName;
   Result       :=^(PropertyAsStr);
  EXCEPT
  ON Exc: Exc_Root DO
   IF (Exc.ErrorCode = 4) & ~Strong THEN
    SETEMPTY(Result);
   ELSE
    RAISE();
   END;
  END; (* TRY *)
  RETURN Result;
 END {GetPropertyCode};

 PUBLIC PROCEDURE O_SetProperty(trgContract: LIKE(Contract.Contract); d: DATE; Strong: SCAL[2]; Prefix, PropName, _subplist: STRING[]);
  VAR
   _name, t   : STRING[];
   trgProperty: LIKE(Property.Property);
 BEGIN
  SETEMPTY(trgProperty, t);
  trgProperty:=GetPropertyCode("E_Prop.", PropName, 0);
  IF !trgProperty THEN
   trgProperty:=GetPropertyCode("",       PropName, Strong);
  END;

  IF ~!trgProperty THEN
   IF Strong THEN
    t:=GetCntrProStrong(trgContract, d, trgProperty);
   ELSE
    t:=GetCntrProSoft(trgContract, d, trgProperty);
   END;
  END;
  _name:=Prefix + PropName;
  L_MSO.SetValueDerivatives(_name, t, _subplist);
  IF HasPro(trgContract, d, trgProperty) THEN
   L_MSO.wordSetDateVar(_name+".Date",    CntrPro.Date);
   L_MSO.wordSetDateVar(_name+".EndDate", CntrPro.EndDate);
  END;
 END {O_SetProperty};

 PUBLIC PROCEDURE OnReposition(trgProperty: LIKE(Property.Property));
 BEGIN
  IF ACCESS(CntrPro) THEN
   CONFORM(CntrPro, Contract);
   SetRedefineFormat();
  END;
 END {OnReposition};

 PUBLIC PROCEDURE GetTemplateNameAndVersion(trgContract : LIKE(Contract.Contract);
                                            D           : DATE;
                                            trgMDocKind : LIKE(MDocKind.MDocKind);
                                            VAR Template: STRING[];
                                            VAR Version : STRING[]);
  VAR
   i          : NUMERIC[0];
   arrMDocKind: LIKE(MDocKind.MDocKind)[dcs_Amount];
   arrTemplate: STRING[][dcs_Amount];
   arrVersion : tTemplateVersion[dcs_Amount];
 BEGIN
  SETEMPTY(Template, Version);
  IF HasActualPro(trgContract, D, P_DocumentsCirculationStructure) THEN
   Decode_DocumentsCirculationStructure(CntrPro.Value, arrMDocKind, arrTemplate, arrVersion);
   i:=0;
   WHILE ~!arrMDocKind[i] DO
    IF arrMDocKind[i] = trgMDocKind THEN
     Template:=arrTemplate[i];
     Version :=arrVersion[i];
    END;
    INC(i);
   END; (* WHILE ~!arrMDocKind[i]...*)
  END; (* IF HasActualPro...*)
 END {GetTemplateNameAndVersion};

 PUBLIC PROCEDURE GetTemplateName(trgContract: LIKE(Contract.Contract);
                                  D          : DATE;
                                  trgMDocKind: LIKE(MDocKind.MDocKind)): STRING[];
  VAR
   Template, Dummy: STRING[];
 BEGIN
  GetTemplateNameAndVersion(trgContract, D, trgMDocKind, Template, Dummy);
  RETURN Template;
 END {GetTemplateName};

 PUBLIC PROCEDURE GetTemplateVersion(trgContract: LIKE(Contract.Contract);
                                     D          : DATE;
                                     trgMDocKind: LIKE(MDocKind.MDocKind)): STRING[];
  VAR
   Dummy, Version: STRING[];
 BEGIN
  GetTemplateNameAndVersion(trgContract, D, trgMDocKind, Dummy, Version);
  RETURN Version;
 END {GetTemplateVersion};

 PUBLIC PROCEDURE GetContractorsName(    trgContract    : LIKE(Contract.Contract);
                                         D              : DATE;
                                     VAR OwnContractor  : STRING[];
                                     VAR OtherContractor: STRING[]);
  VAR
   Dummy: STRING[];
 BEGIN
  Decode_ContractorsName(GetCntrProSoft(trgContract, D, P_ContractorsName),
                         OwnContractor,
                         OtherContractor,
                         Dummy);
  IF !OwnContractor THEN
   OwnContractor  :="ᯮ⥫";
   OtherContractor:="稪";
  END;
 END {GetContractorsName};

 PUBLIC PROCEDURE ContractExtNaming(trgContract: LIKE(Contract.Contract); D: DATE): STRING[];
  VAR
   Dummy,
   Result: STRING[];
 BEGIN
  Decode_ContractorsName(GetCntrProSoft(trgContract, D, P_ContractorsName),
                         Dummy,
                         Dummy,
                         Result);
  IF !Result THEN
   Result:=";;;;஬; ";
  END;
  RETURN Result;
 END {ContractExtNaming};

 PUBLIC PROCEDURE GetContractDuration(    trgContract: LIKE(Contract.Contract);
                                          D          : DATE;
                                      VAR Begin      : DATE;
                                      VAR Till       : DATE);
 BEGIN
  Decode_Duration(GetCntrProSoft(trgContract, D, P_Duration), Begin, Till);
 END {GetContractDuration};

 PRIVATE PROCEDURE intGetPeriodicAcptDuration(    trgContract      : LIKE(Contract.Contract);
                                                  D                : DATE;
                                              VAR Begin            : DATE;
                                              VAR Till             : DATE;
                                                  PresenceCondition: L_Prop.tPresenceCondition);
 BEGIN
  Decode_PeriodicAcptDuration(GetCntrPro(trgContract, D, P_PeriodicAcptDuration, PresenceCondition), Begin, Till);
 END {intGetPeriodicAcptDuration};

 PUBLIC PROCEDURE GetPeriodicAcptDuration(    trgContract: LIKE(Contract.Contract);
                                              D          : DATE;
                                          VAR Begin      : DATE;
                                          VAR Till       : DATE);
 BEGIN
  intGetPeriodicAcptDuration(trgContract, D, Begin, Till, L_Prop.pc_Soft);
 END {GetPeriodicAcptDuration};

 PUBLIC PROCEDURE GetPeriodicAcptDurationStrong(    trgContract: LIKE(Contract.Contract);
                                                    D          : DATE;
                                                VAR Begin    : DATE;
                                                VAR Till     : DATE);
 BEGIN
  intGetPeriodicAcptDuration(trgContract, D, Begin, Till, L_Prop.pc_Strong);
 END {GetPeriodicAcptDuration};

 PUBLIC PROCEDURE GetContractVersion(trgContract: LIKE(Contract.Contract);
                                     D        : DATE): tTemplateVersion;
 BEGIN
  RETURN GetCntrProStrong(trgContract, D, P_ContractVersion);
 END {GetContractVersion};

 PRIVATE PROCEDURE GetContractFormTemplateName(trgContract: LIKE(Contract.Contract);
                                               Type     : SCAL[3];
                                               _Sense   : LIKE(ODoc.Sense);
                                               D        : DATE): STRING[];
  VAR
   ContractTemplate: STRING[];
   ContractCopies  : NUMERIC[0];
   AITitle,
   AITemplate      : STRING[][df_AIAmount];
   AICopies        : NUMERIC[0][df_AIAmount];
   MsgTitle,
   MsgTemplate     : STRING[][df_MsgAmount];
   MsgCopies       : NUMERIC[0][df_MsgAmount];
 BEGIN
  IF HasActualPro(trgContract, D, P_DocumentForms) THEN
   Decode_DocumentForms(CntrPro.Value,
                        ContractTemplate, ContractCopies,
                        AITitle,  AITemplate,  AICopies,
                        MsgTitle, MsgTemplate, MsgCopies);
   IF    Type = dft_Contract THEN
    RETURN ContractTemplate;
   ELSIF Type = dft_AddIns THEN
    RETURN AITemplate[_Sense];
   ELSIF Type = dft_Msg THEN
    RETURN MsgTemplate[_Sense];
   END;
   L_General.CallUs(0);
  ELSE
   RETURN "";
  END;
 END {GetContractFormTemplateName};

 PRIVATE PROCEDURE GetContractFormCopies(trgContract: LIKE(Contract.Contract);
                                         Type     : SCAL[3];
                                         _Sense   : LIKE(ODoc.Sense);
                                         D        : DATE): NUMERIC[0];
  VAR
   ContractTemplate: STRING[];
   ContractCopies  : NUMERIC[0];
   AITitle,
   AITemplate      : STRING[][df_AIAmount];
   AICopies        : NUMERIC[0][df_AIAmount];
   MsgTitle,
   MsgTemplate     : STRING[][df_MsgAmount];
   MsgCopies       : NUMERIC[0][df_MsgAmount];
 BEGIN
  IF HasActualPro(trgContract, D, P_DocumentForms) THEN
   Decode_DocumentForms(CntrPro.Value,
                        ContractTemplate, ContractCopies,
                        AITitle,  AITemplate,  AICopies,
                        MsgTitle, MsgTemplate, MsgCopies);
   IF    Type = dft_Contract THEN
    RETURN ContractCopies;
   ELSIF Type = dft_AddIns THEN
    RETURN AICopies[_Sense];
   ELSIF Type = dft_Msg THEN
    RETURN MsgCopies[_Sense];
   END;
   L_General.CallUs(0);
  ELSE
   RETURN "";
  END;
 END {GetContractFormCopies};

 PUBLIC PROCEDURE GetContractAddInsTemplateName(trgContract: LIKE(Contract.Contract);
                                                _Sense   : LIKE(ODoc.Sense);
                                                D        : DATE): STRING[];
 BEGIN
  RETURN GetContractFormTemplateName(trgContract, dft_AddIns, _Sense, D);
 END {GetContractAddInsTemplateName};

 PUBLIC PROCEDURE GetContractMsgTemplateName(trgContract: LIKE(Contract.Contract);
                                             _Sense   : LIKE(ODoc.Sense);
                                             D        : DATE): STRING[];
 BEGIN
  RETURN GetContractFormTemplateName(trgContract, dft_Msg, _Sense, D);
 END {GetContractMsgTemplateName};

 PUBLIC PROCEDURE GetContractTemplateName(trgContract: LIKE(Contract.Contract);
                                          D        : DATE): STRING[];
 BEGIN
  RETURN GetContractFormTemplateName(trgContract, dft_Contract, 0, D);
 END {GetContractTemplateName};

 PUBLIC PROCEDURE GetContractCopies(trgContract: LIKE(Contract.Contract);
                                     D       : DATE): NUMERIC[0];
  CONST
   defCopies = 2;
  VAR
   _Copies: NUMERIC[0];
 BEGIN
  _Copies:=GetContractFormCopies(trgContract, dft_Contract, 0, D);
  IF !_Copies THEN
   _Copies:=defCopies;
  END;
  RETURN _Copies;
 END {GetContractCopies};

 PUBLIC PROCEDURE GetContractAddInsCopies(trgContract: LIKE(Contract.Contract);
                                          _Sense   : LIKE(ODoc.Sense);
                                          D        : DATE): NUMERIC[0];
  CONST
   defCopies = 2;
  VAR
   _Copies: NUMERIC[0];
 BEGIN
  _Copies:=GetContractFormCopies(trgContract, dft_AddIns, _Sense, D);
  IF !_Copies THEN
   _Copies:=defCopies;
  END;
  RETURN _Copies;
 END {GetContractAddInsCopies};

 PUBLIC PROCEDURE GetContractMsgCopies(trgContract: LIKE(Contract.Contract);
                                          _Sense   : LIKE(ODoc.Sense);
                                          D        : DATE): NUMERIC[0];
  CONST
   defCopies = 2;
  VAR
   _Copies: NUMERIC[0];
 BEGIN
  _Copies:=GetContractFormCopies(trgContract, dft_Msg, _Sense, D);
  IF !_Copies THEN
   _Copies:=defCopies;
  END;
  RETURN _Copies;
 END {GetContractMsgCopies};

 PUBLIC PROCEDURE GetPropertyObjectDescription(trgContract            : LIKE(Contract.Contract);
                                               D                      : DATE;
                                               VAR Address            : STRING[];
                                               VAR Location           : STRING[];
                                               VAR Area               : NUMERIC[1];
                                               VAR Purpose            : STRING[];
                                               VAR RegistrationInf    : STRING[];
                                               VAR PreparationDeadline: DATE;
                                               VAR ConveyanceDeadline : DATE);
 BEGIN
  Decode_PropertyObjectDescription(GetCntrProSoft(trgContract, D, P_PropertyObjectDescription),
                                   Address,
                                   Location,
                                   Area,
                                   Purpose,
                                   RegistrationInf,
                                   PreparationDeadline,
                                   ConveyanceDeadline);
 END {GetPropertyObjectDescription};

 PUBLIC PROCEDURE GetPriceLevel(    trgContract: LIKE(Contract.Contract);
                                    D          : DATE;
                                VAR Type       : t_PriceLevelType;
                                VAR Value      : NUMERIC[4]);
 BEGIN
  Decode_PriceLevel(GetCntrProSoft(trgContract, D, P_PriceLevel), Type, Value);
 END {GetPriceLevel};

 PUBLIC PROCEDURE GetSingleCostItem(trgContract: LIKE(Contract.Contract); D: DATE): LIKE(CostItem.CostItem);
  VAR
   Result     : LIKE(CostItem.CostItem);
   CostItemArr: LIKE(CostItem.CostItem)[af_CICount];
   i          : SCAL[af_CICount];
 BEGIN
  Decode_AllowedCostItem(GetCntrProSoft(trgContract, D, P_AllowedCostItem), CostItemArr);
  SETEMPTY(Result);
  FOR_EACH i DO
   IF ~!CostItemArr[i] THEN
    IF !Result THEN
     Result:=CostItemArr[i];
    ELSE
     SETEMPTY(Result);
     EXIT;
    END;
   END;
  END (* FOR_EACH i ... *);
  RETURN Result;
 END {GetSingleCostItem};

 PUBLIC PROCEDURE IsAllowedCostItem(trgContract: LIKE(Contract.Contract);
                                    D          : DATE;
                                    trgCostItem: LIKE(CostItem.CostItem)): SCAL[2];
  VAR
   CostItemArr: LIKE(CostItem.CostItem)[af_CICount];
   i          : SCAL[af_CICount];
 BEGIN
  L_General.CallUs(~!trgCostItem);
  Decode_AllowedCostItem(GetCntrProSoft(trgContract, D, P_AllowedCostItem), CostItemArr);
  FOR_EACH i DO
   IF ~!CostItemArr[i] THEN
    IF CostItemArr[i] = trgCostItem THEN
     RETURN 1;
    ELSE
     CostItemArr[0]:=CostItemArr[i];
    END;
   END;
  END (* FOR_EACH i ... *);
  RETURN !CostItemArr[0];
 END {IsAllowedCostItem};

 PUBLIC PROCEDURE GetSingleDest(trgContract: LIKE(Contract.Contract); D: DATE): LIKE(Dest.Dest);
  VAR
   Result : LIKE(Dest.Dest);
   DestArr: LIKE(Dest.Dest)[ad_DestCount];
   i      : SCAL[ad_DestCount];
 BEGIN
  Decode_AllowedDest(GetCntrProSoft(trgContract, D, P_AllowedDest), DestArr);
  SETEMPTY(Result);
  FOR_EACH i DO
   IF ~!DestArr[i] THEN
    IF !Result THEN
     Result:=DestArr[i];
    ELSE
     SETEMPTY(Result);
     EXIT;
    END;
   END;
  END (* FOR_EACH i ... *);
  RETURN Result;
 END {GetSingleDest};

 PUBLIC PROCEDURE GetFirstAllowedDest(trgContract: LIKE(Contract.Contract); D: DATE): LIKE(Dest.Dest);
  VAR
   Result : LIKE(Dest.Dest);
   DestArr: LIKE(Dest.Dest)[ad_DestCount];
   i      : SCAL[ad_DestCount];
 BEGIN
  Decode_AllowedDest(GetCntrProStrong(trgContract, D, P_AllowedDest), DestArr);
  SETEMPTY(Result);
  FOR_EACH i DO
   IF ~!DestArr[i] THEN
    Result:=DestArr[i];
    EXIT;
   END;
  END; (* FOR_EACH i ... *)
  RETURN Result;
 END {GetFirstAllowedDest};

 PUBLIC PROCEDURE IsAllowedDest(trgContract: LIKE(Contract.Contract);
                                D          : DATE;
                                trgDest    : LIKE(Dest.Dest)): SCAL[2];
  VAR
   DestArr: LIKE(Dest.Dest)[ad_DestCount];
   i      : SCAL[ad_DestCount];
 BEGIN
  L_General.CallUs(~!trgDest);
  Decode_AllowedDest(GetCntrProSoft(trgContract, D, P_AllowedDest), DestArr);
  FOR_EACH i DO
   IF ~!DestArr[i] THEN
    IF DestArr[i] = trgDest THEN
     RETURN 1;
    ELSE
     DestArr[0]:=DestArr[i];
    END;
   END;
  END (* FOR_EACH i ... *);
  RETURN !DestArr[0];
 END {IsAllowedDest};

 PUBLIC PROCEDURE GetPeriodicAcptData(    trgContract   : LIKE(Contract.Contract);
                                          D             : DATE;
                                      VAR MonthInPeriod,
                                          DocsPerPeriod : NUMERIC[0];
                                      VAR FirstMonth    : DATE);
 BEGIN
  IF HasActualPro(trgContract, D, P_PeriodicAcpt) THEN
   intGetPeriodicAcptData(MonthInPeriod, DocsPerPeriod, FirstMonth);
  ELSE
   SETEMPTY(MonthInPeriod, DocsPerPeriod, FirstMonth);
  END;
 END {GetPeriodicAcptData};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   i          : NUMERIC[0];
   Record,
   Result     : STRING[];
   trgTSN     : LIKE(Staff.TSN);
   Dummy      : STRING[];
   dummySum   : NUMERIC[2];
   DestArr    : LIKE(Dest.Dest)[ad_DestCount];
   CostItemArr: LIKE(CostItem.CostItem)[af_CICount];
   Firms      : tFirms;
   Props      : tProps;
   arrMDocKind: LIKE(MDocKind.MDocKind)[dcs_Amount];
   arrTemplate: STRING[][dcs_Amount];
   arrVersion : tTemplateVersion[dcs_Amount];
   trgPayP    : LIKE(PayP.PayP);
   trgMath    : LIKE(Math.Math);
 BEGIN
  SETEMPTY(Result);
  IF    CntrPro.Property = P_AllowedCostItem THEN
   Decode_AllowedCostItem(CntrPro.Value, CostItemArr);
   i:=0;
   WHILE i < af_CICount DO
    IF ~!CostItemArr[i] THEN
     Result:=L_Str.AddStrDlm(Result, " ") + CostItemArr[i];
    END;
    INC(i);
   END;
  ELSIF CntrPro.Property = P_AllowedDest THEN
   Decode_AllowedDest(CntrPro.Value, DestArr);
   i:=0;
   WHILE i < ad_DestCount DO
    IF ~!DestArr[i] THEN
     Result:=L_Str.AddStrDlm(Result, " ") + DestArr[i];
    END;
    INC(i);
   END;
  ELSIF CntrPro.Property = P_OwnAgent THEN
   Decode_OwnAgent(CntrPro.Value, trgTSN, Dummy, dummySum);
   IF ~!trgTSN THEN
    SEARCH(Staff, TSN, , trgTSN);
    CONFORM(Staff, Man);
    Result:=Staff.TSN + " " + Man.Name;
   END;
  ELSIF (CntrPro.Property = P_PaymentAgents) | (CntrPro.Property = P_Consignees) THEN
   Decode_PaymentAgents(CntrPro.Value, Firms);
   i:=0;
   WHILE (i < FirmsAmount) & ~!Firms[i] DO
    L_Prop.putREV(Result, Firms[i]);
    INC(i);
   END;
  ELSIF CntrPro.Property = P_DocumentsCirculationStructure THEN
   Decode_DocumentsCirculationStructure(CntrPro.Value, arrMDocKind, arrTemplate, arrVersion);
   i:=0;
   WHILE i < dcs_Amount DO
    IF ~!arrMDocKind[i] THEN
     SETEMPTY(Record);
     L_Prop.putREV(Record, arrMDocKind[i]);
     L_Prop.putREV(Record, arrTemplate[i]);
     L_Prop.putREV(Record, arrVersion[i]);
     L_Prop.putAIS(Result, Record);
    END;
    INC(i);
   END;
  ELSIF CntrPro.Property = P_SingleMath THEN
   trgMath:=L_r2r.DecodeReferenceStamp(CntrPro.Value);
   IF ~!trgMath THEN
    SEARCH(Math, Math, , trgMath);
    Result:=Math.Math + " " + Math.Name;
   END;
  ELSIF CntrPro.Property = P_PayP THEN
   trgPayP:=L_r2r.DecodeReferenceStamp(CntrPro.Value);
   IF ~!trgPayP THEN
    SEARCH(PayP, PayP, , trgPayP);
    Result:=PayP.PayP + " " + PayP.Name;
   END;
  ELSIF CntrPro.Property = P_CntrAddendum THEN
   Decode_CntrAddendum(CntrPro.Value, Result);
  ELSIF CntrPro.Property = P_MainAcntSigner THEN
   trgTSN:=L_r2r.DecodeReferenceStamp(CntrPro.Value);
   IF ~!trgTSN THEN
    SEARCH(Staff, TSN, , trgTSN);
    CONFORM(Staff, Man);
    Result:=Staff.TSN + " " + Man.Name;
   END;
  ELSE
   Result:=CntrPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

END.
