(*
%Copyright   (c) Polak IT
%Author      16.08.2005 01:19:24 POLAK\San
%Purpose     ⥪  ࠡ  ᢮⢠ 
%Type        library
%Specific    SYS
%Modified    11.04.2014 15:56:02 POLAK\GAV
%Environment
*)

 MODULE P_CUC [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Prop, L_Str, L_Pool;

 PUBLIC CONST
  P_Location         = 7600;
  P_RetirementReason = 7601;
  P_AdditionalId     = 7602;
  P_UsingOptions     = 7603;

  rr_Pool = "ଠ⨢ |ଠ⨢ |襭||饭|த";

  uu_Pool = " 뤠  |";

  pool_rrDescription = 0000948;

 PUBLIC PROCEDURE GetSubWindowName(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF trgProperty = P_RetirementReason THEN RETURN "P_7601";
  ELSE                                     RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE GetPool(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_UsingOptions THEN
   RETURN " 뤠  |";
  ELSE
   RETURN "";
  END;
 END {GetMathProPool};

 PRIVATE PROCEDURE HasAnyCUCPro(trgCUCopy: LIKE(CUCopy.CUCopy); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SELECT(CUCPro, CUCopy, trgCUCopy, trgProperty) & SRCINSEL(CUCPro, LE, D);
 END {HasAnyCUCPro};

 PUBLIC PROCEDURE HasCUCPro(trgCUCopy: LIKE(CUCopy.CUCopy); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasAnyCUCPro(trgCUCopy, D, trgProperty);
 END {HasCUCPro};

 PUBLIC PROCEDURE HasActualCUCPro(trgCUCopy: LIKE(CUCopy.CUCopy); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasCUCPro(trgCUCopy, D, trgProperty) & (!CUCPro.DocExpD | (D < CUCPro.DocExpD));
 END {HasActualCUCPro};

 PUBLIC PROCEDURE GetCUCProSoft(trgCUCopy: LIKE(CUCopy.CUCopy); D: DATE; trgProperty: LIKE(Property.Property)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF HasActualCUCPro(trgCUCopy, D, trgProperty) THEN
   Result:=CUCPro.Value;
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetCUCProSoft};

 PRIVATE PROCEDURE Decode_RetirementReason(    Value      : STRING[];
                                           VAR Reason,
                                               Description,
                                               Comments   : STRING[]);
 BEGIN
  Reason     :=L_Prop.getRecordElement(Value, 0);
  Description:=L_Prop.getRecordElement(Value, 1);
  Comments   :=L_Prop.getRecordElement(Value, 2);
 END {Decode_RetirementReason};

 PRIVATE PROCEDURE formSet_RetirementReason();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Reason"     ).Template        :=rr_Pool;
  Fields("Reason"     ).TemplateIsStrict:=1;
  Fields("Description").Template        :=L_Pool.Get(pool_rrDescription);
  Fields("Description").TemplateIsStrict:=0;
  Decode_RetirementReason(CUCPro.Value, Fields("Reason").Value, Fields("Description").Value, Fields("Comments").Value);
 END {formSet_RetirementReason};

 PUBLIC PROCEDURE SetDataInForm(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_RetirementReason THEN
   formSet_RetirementReason();
  ELSE
   L_General.CallUs(0);
  END;
 END {SetDataInForm};

 PRIVATE PROCEDURE Encode_RetirementReason(VAR Value      : STRING[];
                                               Reason,
                                               Description,
                                               Comments   : STRING[]);
 BEGIN
  L_Prop.putRecordElement(Value, Reason);
  L_Prop.putRecordElement(Value, Description);
  L_Prop.putRecordElement(Value, Comments);
 END {Encode_RetirementReason};

 PRIVATE PROCEDURE formGet_RetirementReason();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_RetirementReason(CUCPro.Value, Fields("Reason").Value, Fields("Description").Value, Fields("Comments").Value);
 END {formGet_RetirementReason};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty: LIKE(Property.Property));
 BEGIN
  SETEMPTY(CUCPro.Value);
  IF    trgProperty = P_RetirementReason THEN
   formGet_RetirementReason();
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(CUCPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE GetRetirementReason(trgCUCopy: LIKE(CUCopy.CUCopy); D: DATE): STRING[];
  VAR
   Reason, Description, Comments: STRING[];
 BEGIN
  IF HasActualCUCPro(trgCUCopy, D, P_RetirementReason) THEN
   Decode_RetirementReason(CUCPro.Value, Reason, Description, Comments);
   RETURN Reason;
  ELSE
   RETURN "";
  END;
 END {GetRetirementReason};

 PUBLIC PROCEDURE GetRetirementDescription(trgCUCopy: LIKE(CUCopy.CUCopy); D: DATE): STRING[];
  VAR
   Reason, Description, Comments: STRING[];
 BEGIN
  IF HasActualCUCPro(trgCUCopy, D, P_RetirementReason) THEN
   Decode_RetirementReason(CUCPro.Value, Reason, Description, Comments);
   RETURN Description;
  ELSE
   RETURN "";
  END;
 END {GetRetirementDescription};

 PUBLIC PROCEDURE GetRetirementComments(trgCUCopy: LIKE(CUCopy.CUCopy); D: DATE): STRING[];
  VAR
   Reason, Description, Comments: STRING[];
 BEGIN
  IF HasActualCUCPro(trgCUCopy, D, P_RetirementReason) THEN
   Decode_RetirementReason(CUCPro.Value, Reason, Description, Comments);
   RETURN Comments;
  ELSE
   RETURN "";
  END;
 END {GetRetirementComments};

 PUBLIC PROCEDURE OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_RetirementReason THEN
   IF RTI.Get().CurZone.ActiveField.Name = "Description" THEN
    L_Pool.Put(pool_rrDescription, RTI.Get().CurZone.ActiveField.Value);
    RTI.Get().CurZone.Fields("Description").Template:=L_Pool.Get(pool_rrDescription);
   END;
  END;
 END {OnSuccessfulChange};

 PUBLIC PROCEDURE OnAfterEdIns();
 BEGIN
  IF CUCPro.Property = P_AdditionalId THEN
   CUCPro.SpdSrchV:=CUCPro.Value;
   REPLACE(CUCPro);
  END;
 END {OnAfterEdIns};

 PUBLIC PROCEDURE OnAfterEdit();
 BEGIN
  OnAfterEdIns();
 END {OnAfterEdit};

 PUBLIC PROCEDURE OnAfterInsert();
 BEGIN
  OnAfterEdIns();
 END {OnAfterInsert};

END.
