(*
%Copyright   (c) Polak Computer System
%Author      01.08.2001 17:52:51 BOR
%Purpose     ⥪  ࠡ  ᢮⢠ EDOKind
%Type        library
%Specific    AP
%Modified    02.10.2013 14:50:09 POLAK\LDA
%Environment
*)

 MODULE P_EDOKnd [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  P_PropertyList      = 0001;
  P_SumInterval       = 0002;
  P_ProcInterval      = 0003;
  P_TemplateTXT       = 0004;
  P_AddKind           = 0005;
  P_sraDsc            = 0006;
  P_ProbationTimeUnit = 0007;
  P_Expr              = 0008;

  MaxCntProperty = 15;

 IMPORT L_General, L_DatTim, L_Prop, Str, FIO, DBD, L_EDO, L_Man, L_Str, L_FIO, L_r2r, L_ACL, L_WDO;

 PUBLIC PROCEDURE IsSimpleUserOf(curProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    curProperty = P_AddKind THEN
   RETURN "AddKind";
  ELSIF curProperty = P_Expr    THEN
   RETURN "Expr";
  ELSE
   RETURN EMPTYOF(STRING[]);
  END;
 END {IsSimpleUserOf};

 PUBLIC PROCEDURE GetSubWindowName(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_PropertyList THEN RETURN "P_0001";
  ELSIF trgProperty = P_sraDsc THEN       RETURN "P_0006";
  ELSE                                    RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE GetPool(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_ProbationTimeUnit THEN
   RETURN "|ᬥ|㣮३";
  ELSIF trgProperty = P_TemplateTXT THEN
   RETURN L_Prop.ChooseFileDialog;
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PRIVATE PROCEDURE _AssertCompatibility(Cond: SCAL[2]);
 BEGIN
  L_General.Assert(Cond, "⢮  ⨬   ਪ 㯯 " + EDOKind.EDOGrp);
 END {_AssertCompatibility};

 PUBLIC PROCEDURE CanHaveProp(trgProperty: LIKE(Property.Property));
 BEGIN
  CONFORM(EDOKPro, EDOKind);
  IF trgProperty = P_sraDsc THEN
   _AssertCompatibility(EDOKind.EDOGrp=L_EDO.grp_SingleRegimeAlteration);
  ELSIF trgProperty = P_AddKind THEN
   _AssertCompatibility((EDOKind.EDOGrp=L_EDO.grp_Combining) | (EDOKind.EDOGrp=L_EDO.grp_Adding));
  ELSIF trgProperty = P_Expr THEN
   _AssertCompatibility(EDOKind.EDOGrp=L_EDO.grp_Reward);
  ELSIF trgProperty = P_ProbationTimeUnit THEN
   _AssertCompatibility((EDOKind.EDOGrp=L_EDO.grp_Probation) | (EDOKind.EDOGrp=L_EDO.grp_Permit));
  END;
 END {CanHaveProp};

 PRIVATE PROCEDURE CheckInterval();
  VAR
   Val1, Val2: STRING[];
 BEGIN
  Val1:=Str.Item(EDOKPro.Value, " ", 0);
  Val2:=Str.Item(EDOKPro.Value, " ", 1);
  L_Prop.CheckNumericValue(Val1, "");
  L_Prop.CheckNumericValue(Val2, "");
  L_General.Assert(~!Val1 & ~!Val2 & (STRTOFLD(Val1, NUMERIC)<=STRTOFLD(Val2, NUMERIC)), "ࢮ 祭     ࠢ ஬");
 END {CheckInterval};

 PRIVATE PROCEDURE CheckExpr();
  VAR
   trgValue: STRING[];
 BEGIN
  trgValue:=Decode_Pro(EDOKPro.Value, P_Expr);
  L_Prop.CheckScalValue(trgValue, "", MAXOF(Expr.Expr));
  L_General.Assert(SEARCH(Expr, Expr, trgValue), "  ⨦/ " + trgValue);
  L_General.Assert((Expr.ExprType = L_Man.et_Stimulation) | (Expr.ExprType = L_Man.et_Tribute),
                   "࠭ ⨦ - " +
                   L_Str.PoolItem(L_Man.et_Pool, Expr.ExprType) + ": " + Expr.Name +
                   " -   ࠤ  ७");
 END {CheckExpr};

 PRIVATE PROCEDURE CheckIsEDOLPro(trgProperty: LIKE(Property.Property));
 BEGIN
  IF ~!trgProperty THEN
   SAVE(Property);
   L_General.CallUs(SEARCH(Property, Property, trgProperty));
   L_General.Assert(Property.Object = L_Prop.EDOLProObj, "  ᢮⢮ ਪ  ᮭ");
   RESTORE(Property);
  END;
 END {CheckIsEDOLPro};

 PUBLIC PROCEDURE EDOKPro_Check(trgProperty: LIKE(Property.Property));
  VAR
   trgValue: STRING[];
 BEGIN
  IF    (trgProperty = P_SumInterval) |
        (trgProperty = P_ProcInterval)  THEN
   CheckInterval();
  ELSIF trgProperty = P_Expr THEN
   CheckExpr();
  ELSIF trgProperty = P_AddKind THEN
   trgValue:=Decode_Pro(EDOKPro.Value, P_AddKind);
   L_Prop.CheckScalValue(trgValue, "", MAXOF(AddKind.AddKind));
   L_General.Assert(SEARCH(AddKind, AddKind, trgValue), "    " + trgValue);
  ELSIF trgProperty = P_TemplateTXT THEN
   L_General.Assert(FIO.Exists(EDOKPro.Value + ".TXT"), "  䠩 " + EDOKPro.Value + ".TXT");
  END;
 END {EDOKPro_Check};

 PUBLIC PROCEDURE OnBeforeAskForEdit(trgProperty: LIKE(Property.Property));
  VAR
   ChooseFD    : CHOOSEFILEDIALOG;
   FullFileName: STRING[];
 BEGIN
  IF trgProperty = P_TemplateTXT THEN
   ChooseFD                     :=CHOOSEFILEDIALOG.Create("EDO*.txt");
   ChooseFD.FilesAreAcceptable  :=1;
   ChooseFD.FoldersAreAcceptable:=0;
   FullFileName                 :=ChooseFD.Deal();
   IF ~!FullFileName THEN
    EDOKPro.Value:=L_FIO.effp_FileName_woExt(FullFileName);
    REPLACE(EDOKPro);
   END;
  END;
 END {OnBeforeAskForEdit};

 PUBLIC PROCEDURE OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_PropertyList THEN
   CheckIsEDOLPro(RTI.Get().CurZone.ActiveField.Value);
  END;
 END {OnSuccessfulChange};

 PUBLIC PROCEDURE HasEDOKPro(trgEDOKind: LIKE(EDOKind.EDOKind); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SELECT(EDOKPro, EDOKind, trgEDOKind, trgProperty) & SRCINSEL(EDOKPro, LE, D);
 END {HasEDOKPro};

 PUBLIC PROCEDURE HasActualEDOKPro(trgEDOKind: LIKE(EDOKind.EDOKind); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasEDOKPro(trgEDOKind, D, trgProperty) & (!EDOKPro.DocExpD | (D < EDOKPro.DocExpD));
 END {HasActualEDOKPro};

 PRIVATE PROCEDURE Decode_Pro(trgValue   : STRING[];
                              trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  L_General.CallUs(~!IsSimpleUserOf(trgProperty));
  RETURN L_r2r.Decode(trgValue);
 END {Decode_Pro};

 PRIVATE PROCEDURE intGetPro(trgEDOKind : LIKE(EDOKind.EDOKind);
                             D          : DATE;
                             trgProperty: LIKE(Property.Property);
                             Strong     : SCAL[2]): LIKE(EDOKPro.Value);
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF HasActualEDOKPro(trgEDOKind, D, trgProperty) THEN
   IF ~!IsSimpleUserOf(trgProperty) THEN
    Result:=Decode_Pro(EDOKPro.Value, trgProperty);
   ELSE
    Result:=EDOKPro.Value;
   END;
  ELSE
   IF Strong THEN
    SEARCH(EDOKind, EDOKind, , trgEDOKind);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("EDOKind").Id, EDOKind.RECORDID, trgProperty, D);
   END;
  END;
  RETURN Result;
 END {intGetPro};

 PUBLIC PROCEDURE GetEDOKProStrong(trgEDOKind: LIKE(EDOKind.EDOKind); D: DATE; trgProperty: LIKE(Property.Property)): LIKE(EDOKPro.Value);
 BEGIN
  RETURN intGetPro(trgEDOKind, D, trgProperty, 1);
 END {GetEDOKProStrong};

 PUBLIC PROCEDURE GetEDOKProSoft(trgEDOKind: LIKE(EDOKind.EDOKind); D: DATE; trgProperty: LIKE(Property.Property)): LIKE(EDOKPro.Value);
 BEGIN
  RETURN intGetPro(trgEDOKind, D, trgProperty, 0);
 END {GetEDOKProSoft};

 PUBLIC PROCEDURE Decode_PropertyList(curValue: STRING[]; VAR arrProperty: LIKE(Property.Property)[]);
  VAR
   Idx: SCAL[MaxCntProperty];
 BEGIN
  SETEMPTY(arrProperty);
  FOR_EACH Idx DO
   arrProperty[Idx]:=L_r2r.Decode(L_Prop.getRES(curValue, Idx));
  END; {FOR_EACH Idx ...}
 END {Decode_PropertyList};

 PRIVATE PROCEDURE formSet_PropertyList();
  VAR
   Fields     : FORM_FIELDS;
   Idx        : SCAL[MaxCntProperty];
   arrProperty: LIKE(Property.Property)[MaxCntProperty];
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  Decode_PropertyList(EDOKPro.Value, arrProperty);
  FOR_EACH Idx DO
   L_WDO.extCreateFormLink("Property", "", Idx);
   Fields(L_Prop.BuildVideoFieldName("Property", Idx)).Value                  :=arrProperty[Idx];
   Fields(L_Prop.BuildVideoFieldName("Property", Idx)).OwnerWindowOriginalName:="Prop_Ask";
  END; (* FOR_EACH Idx ... *)
 END {formSet_PropertyList};

 PRIVATE PROCEDURE Decode_sraDsc(curValue: STRING[]; VAR HolydayJMode, WorkJMode: LIKE(JMode.JMode));
 BEGIN
  HolydayJMode:=L_r2r.Decode(L_Prop.getRES(curValue, 0));
  WorkJMode   :=L_r2r.Decode(L_Prop.getRES(curValue, 1));
 END {Decode_sraDsc};

 PRIVATE PROCEDURE formSet_sraDsc();
  VAR
   Fields      : FORM_FIELDS;
   HolydayJMode,
   WorkJMode   : LIKE(JMode.JMode);
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  Decode_sraDsc(EDOKPro.Value, HolydayJMode, WorkJMode);
  L_WDO.CreateFormLink("JMode", "Holyday");
  L_WDO.CreateFormLink("JMode", "Work");
  Fields("HolydayJMode").Value:=HolydayJMode;
  Fields("WorkJMode"   ).Value:=WorkJMode;
 END {formSet_sraDsc};

 PUBLIC PROCEDURE SetDataInForm(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_PropertyList THEN
   formSet_PropertyList();
  ELSIF trgProperty = P_sraDsc THEN
   formSet_sraDsc();
  END;
 END {SetDataInForm};

 PRIVATE PROCEDURE Encode_PropertyList(VAR curValue: STRING[]; arrProperty: LIKE(Property.Property)[]);
  VAR
   Idx: SCAL[MaxCntProperty];
 BEGIN
  SETEMPTY(curValue);
  FOR_EACH Idx DO
   IF ~!arrProperty[Idx] THEN
    L_Prop.putRES(curValue, L_r2r.Put("EDOKPro", "Property", arrProperty[Idx]));
   END;
  END; {FOR_EACH Idx ...}
 END {Encode_PropertyList};

 PRIVATE PROCEDURE formGet_PropertyList();
  VAR
   Fields     : FORM_FIELDS;
   Idx        : SCAL[MaxCntProperty];
   arrProperty: LIKE(Property.Property)[MaxCntProperty];
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  FOR_EACH Idx DO
   arrProperty[Idx]:=Fields(L_Prop.BuildVideoFieldName("Property", Idx)).Value;
  END; (* FOR_EACH Idx ... *)
  Encode_PropertyList(EDOKPro.Value, arrProperty);
 END {formGet_PropertyList};

 PRIVATE PROCEDURE Encode_sraDsc(VAR curValue: STRING[]; HolydayJMode, WorkJMode: LIKE(JMode.JMode));
 BEGIN
  SETEMPTY(curValue);
  L_Prop.putRES(curValue, L_r2r.Put("EDOKPro", "JMode", HolydayJMode));
  L_Prop.putRES(curValue, L_r2r.Put("EDOKPro", "JMode", WorkJMode));
 END {Encode_sraDsc};

 PRIVATE PROCEDURE formGet_sraDsc();
  VAR
   Fields      : FORM_FIELDS;
   HolydayJMode,
   WorkJMode   : LIKE(JMode.JMode);
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  HolydayJMode:=Fields("HolydayJMode").Value;
  WorkJMode   :=Fields("WorkJMode"   ).Value;
  Encode_sraDsc(EDOKPro.Value, HolydayJMode, WorkJMode);
 END {formGet_sraDsc};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty: LIKE(Property.Property));
 BEGIN
  SETEMPTY(EDOKPro.Value);
  IF    trgProperty = P_PropertyList THEN
   formGet_PropertyList();
  ELSIF trgProperty = P_sraDsc THEN
   formGet_sraDsc();
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(EDOKPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Result      : STRING[];
   Idx         : SCAL[MaxCntProperty];
   arrProperty : LIKE(Property.Property)[MaxCntProperty];
   HolydayJMode,
   WorkJMode   : LIKE(JMode.JMode);
 BEGIN
  IF EDOKPro.Property = P_PropertyList THEN
   SETEMPTY(Result);
   Decode_PropertyList(EDOKPro.Value, arrProperty);
   FOR_EACH Idx DO
    IF ~!arrProperty[Idx] THEN
     L_Prop.putRES(Result, arrProperty[Idx]);
    END;
   END; {FOR_EACH Idx DO ...}
  ELSIF EDOKPro.Property = P_sraDsc THEN
   SETEMPTY(Result);
   Decode_sraDsc(EDOKPro.Value, HolydayJMode, WorkJMode);
   L_Prop.putRES(Result, HolydayJMode);
   L_Prop.putRES(Result, WorkJMode);
  ELSIF IsSimpleUserOf(EDOKPro.Property) = "AddKind" THEN
   SEARCH(AddKind, AddKind, , Decode_Pro(EDOKPro.Value, EDOKPro.Property));
   Result:= AddKind.AddKind + " " + AddKind.Name;
  ELSIF IsSimpleUserOf(EDOKPro.Property) = "Expr"    THEN
   SEARCH(Expr, Expr, , Decode_Pro(EDOKPro.Value, EDOKPro.Property));
   Result:= Expr.Expr + " " + Expr.Name;
  ELSE
   Result:=EDOKPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PUBLIC PROCEDURE Get_sraDescription(    trgEDOKind: LIKE(EDOKind.EDOKind);
                                         D         : DATE;
                                         atWorkDay : SCAL[2];
                                     VAR trgJMode  : LIKE(JMode.JMode));
  VAR
   HolydayJMode,
   WorkJMode   : LIKE(JMode.JMode);
 BEGIN
  Decode_sraDsc(GetEDOKProStrong(trgEDOKind, D, P_sraDsc), HolydayJMode, WorkJMode);
  IF   atWorkDay THEN trgJMode:=WorkJMode;
  ELSE                trgJMode:=HolydayJMode;
  END;
 END {Get_sraDescription};

 PUBLIC PROCEDURE Get_AnyInterval(    trgEDOKind : LIKE(EDOKind.EDOKind);
                                      trgDate    : DATE;
                                      trgProperty: LIKE(Property.Property);
                                  VAR Min, Max   : NUMERIC[3]);
  VAR
   trgValue: LIKE(EDOKPro.Value);
 BEGIN
  SETEMPTY(Min, Max);
  trgValue:=GetEDOKProSoft(trgEDOKind, trgDate, trgProperty);
  IF ~!trgValue THEN
   Min:=STRTOFLD(Str.Item(trgValue, " ", 0), NUMERIC);
   Max:=STRTOFLD(Str.Item(trgValue, " ", 1), NUMERIC);
   L_General.Assert(~!Min & ~!Max, "୮ ଫ    ਪ.|⢮ " + trgProperty);
  END;
 END {Get_AnyInterval};

END.
