(*
%Copyright   (c) Polak Computer System
%Author      11.12.2001 16:20:02 SAN
%Purpose     ⥪  ࠡ  ᢮⢠ EDOrderL
%Type        library
%Specific    SYS
%Modified    12.09.2012 19:00:22 POLAK\Gina
%Environment
*)

 MODULE P_EDOL [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Prop, L_Staff, L_EDO, L_Way, L_WDO, L_r2r, L_DBD, DBD, L_StdFrm;

 PUBLIC CONST
  P_Explanation   = 0101;
  P_Comments      = 0102;
  P_Route         = 0103;
  P_SortGuilt     = 0105;
  P_Sort          = 0106;
  P_BoxNbr        = 0107;
  P_TSN           = 0108;
  P_MarkG         = 0109;
  P_CauseEntry    = 0111;
  P_ProbationTime = 0112;
  P_JRegime       = 0113;
  P_TKind         = 0114;
  P_Destination   = 0115;
  P_Purpose       = 0116;
  P_FundingSource = 0117;
  P_RegimeTimes   = 0118;
  P_PersonalInfo  = 0119;
  P_ConditionPlace= 0121;

 PRIVATE CONST
  wLinkWindowName = "EDOLPrL";

 PUBLIC PROCEDURE Decode_PersonalInfo(    PersonalInfo: STRING[];
                                      VAR OldManName  : STRING[];
                                      VAR NewManName  : STRING[]);
 BEGIN
  OldManName:=L_Prop.getRecordElement(PersonalInfo, 00);
  NewManName:=L_Prop.getRecordElement(PersonalInfo, 01);
 END {Decode_PersonalInfo};

 PUBLIC PROCEDURE MarkGTForEDOGrp(): LIKE(MarkGT.MarkGT);
  VAR
   _EDOGrp: LIKE(EDOGrp.EDOGrp);
 BEGIN
  IF OCCURE(EDOrderL) & ~!EDOrderL.EDOGrp THEN
   _EDOGrp:=EDOrderL.EDOGrp;
  ELSE
   _EDOGrp:=L_EDO.curEDOGrp;
  END;
  IF (_EDOGrp = L_EDO.grp_Probation)    |
     (_EDOGrp = L_EDO.grp_CancelPermit) |
     (_EDOGrp = L_EDO.grp_Permit)       THEN
   RETURN L_Way.mgt_AccessDriving;
  ELSE
   SEARCH(EDOGrp, EDOGrp, , _EDOGrp);
   L_General.Error(" ਪ 㯯 " + EDOGrp.Name +
                   "| ஥  㯯 ப  㪠  ᢮⢥");
  END;
 END {MarkGTForEDOGrp};

 PUBLIC PROCEDURE IsSimpleUserOf(curProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    curProperty = P_Route   THEN
   RETURN "Route";
  ELSIF curProperty = P_Sort    THEN
   RETURN "Sort";
  ELSIF curProperty = P_BoxNbr  THEN
   RETURN "Car";
  ELSIF curProperty = P_TSN     THEN
   RETURN "Staff";
  ELSIF curProperty = P_MarkG   THEN
   RETURN "MarkG";
  ELSIF curProperty = P_JRegime THEN
   RETURN "JRegime";
  ELSIF curProperty = P_TKind   THEN
   RETURN "TKind";
  ELSE
   RETURN "";
  END;
 END {IsSimpleUserOf};

 PUBLIC PROCEDURE GetSubWindowName(curProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF ~!IsSimpleUserOf(curProperty) THEN
   RETURN wLinkWindowName;
  ELSE
   RETURN "";
  END;
 END {GetSubWindowName};

 PRIVATE PROCEDURE Decode_EDOLPro(trgValue   : LIKE(EDOLPro.Value);
                                 trgProperty: LIKE(EDOLPro.Property)): LIKE(EDOLPro.Value);
 BEGIN
  L_General.CallUs(~!IsSimpleUserOf(trgProperty));
  RETURN L_r2r.DecodeReferenceStamp(trgValue);
 END {Decode_EDOLPro};

 PUBLIC PROCEDURE Decode_CurEDOLPro(): LIKE(EDOLPro.Value);
 BEGIN
  L_General.CallUs(OCCURE(EDOLPro));
  RETURN Decode_EDOLPro(EDOLPro.Value, EDOLPro.Property);
 END {Decode_CurEDOLPro};

 PUBLIC PROCEDURE Encode_EDOLPro(trgValue   : LIKE(EDOLPro.Value);
                                 trgProperty: LIKE(EDOLPro.Property)): LIKE(EDOLPro.Value);
  VAR
   SimpleUser: STRING[];
 BEGIN
  SimpleUser:=IsSimpleUserOf(trgProperty);
  L_General.CallUs(~!SimpleUser);
  RETURN L_r2r.Put("EDOLPro", SimpleUser, trgValue);
 END {Encode_EDOLPro};

 PUBLIC PROCEDURE GetDataFromForm(curProperty: LIKE(Property.Property));
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = wLinkWindowName THEN
   IF !IsSimpleUserOf(curProperty) THEN
    EDOLPro.Value:=RTI.Get().CurZone.Fields("Value").Value;
   ELSE
    EDOLPro.Value:=Encode_EDOLPro(RTI.Get().CurZone.Fields("Value").Value, curProperty);
   END;
   REPLACE(EDOLPro);
  END;
 END {GetDataFromForm};

 PUBLIC PROCEDURE SetDataInForm(curProperty: LIKE(Property.Property));
  VAR
   W: FORM_WINDOW;
   Z: FORM_ZONE;
 BEGIN
  W:=RTI.Get().CurWindow;
  Z:=RTI.Get().CurZone;
  IF W.OriginalName = wLinkWindowName THEN
   WHILE Z.Links.Count DO
    Z.Links.Remove(Z.Links(0));
   END;
   L_WDO.CreateFormLink_Simple(IsSimpleUserOf(Property.Property), "Value");
   Z.Fields("Value").Value:=L_r2r.DecodeReferenceStamp(^(Z.MasterTable.Fields("Value").ObtainName()));
  END;
 END {SetDataInForm};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Result    : STRING[];
   curValue  : LIKE(EDOLPro.Value);
   SimpleUser: STRING[];
 BEGIN
  IF !EDOLPro.Value THEN
   SETEMPTY(Result);
  ELSE
   SimpleUser:=IsSimpleUserOf(EDOLPro.Property);
   IF !SimpleUser THEN
    Result:=EDOLPro.Value;
   ELSE
    curValue:=Decode_CurEDOLPro();
    SEARCH(^SimpleUser, ^(L_DBD.GetPrimaryIndex(SimpleUser)), , curValue);
    IF    EDOLPro.Property = P_BoxNbr THEN
     CONFORM(Car, Mark);
     Result:=Car.BoxNbr + " " + Mark.Name;
    ELSIF EDOLPro.Property = P_TSN    THEN
     CONFORM(Staff, Man);
     Result:=Staff.TSN + " " + Man.Name;
    ELSIF DBD.FieldExist(^(SimpleUser), "Name") THEN
     Result:=^(SimpleUser + "." + L_DBD.GetPrimaryIndex(SimpleUser)) + " " + ^(SimpleUser + ".Name");
    ELSE
     L_General.CallUs(0);
    END;
   END; (* IF !SimpleUser ... *)
  END; (* IF !EDOLPro.Value ... *)
  RETURN Result;
 END {GetVal2Show};

 PUBLIC PROCEDURE PropertyModificationAllowed(trgProperty: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF (trgProperty = P_RegimeTimes)  |
     (trgProperty = P_PersonalInfo) THEN
   RETURN L_Prop.mac_AutoOnly;
  ELSE
   RETURN L_Prop.mac_Full;
  END;
 END {PropertyModificationAllowed};

 PUBLIC PROCEDURE EDOLPro_Check(trgProperty: LIKE(Property.Property));
 BEGIN
  IF ~!EDOLPro.Value THEN
   L_General.Assert(~!EDOrderL.OcrDate, "   ''");
   IF    trgProperty = P_TSN THEN
    L_Staff.CheckStringAsTSN(EDOrderL.OcrDate, Decode_CurEDOLPro(), EMPTYOF(PROC));
   ELSIF trgProperty = P_ProbationTime THEN
    L_Prop.CheckNumericValue(EDOLPro.Value, "");
   ELSIF trgProperty = P_MarkG THEN
    L_General.CallUs(SEARCH(MarkG, MarkG, Decode_CurEDOLPro()));
    L_General.Assert(L_DatTim.IsActive(EDOrderL.OcrDate, MarkG.Begin, MarkG.Till),
                     "㯯 ப    " + FLDTOSTR(EDOrderL.OcrDate));
   ELSIF trgProperty = P_Route THEN
    L_General.CallUs(SEARCH(Route, Route, Decode_CurEDOLPro()));
    L_General.Assert(L_DatTim.IsActive(EDOrderL.OcrDate, Route.Begin, Route.Till),
                     "    " + FLDTOSTR(EDOrderL.OcrDate));
   ELSIF trgProperty = P_RegimeTimes THEN
    IF !L_Prop.getRecordElement(EDOLPro.Value, 0) | !L_Prop.getRecordElement(EDOLPro.Value, 1) THEN
     L_StdFrm.Choice("६ 砫  砭 ᬥ   ");
    END;
    L_General.Assert((!L_Prop.getRecordElement(EDOLPro.Value, 2) = !L_Prop.getRecordElement(EDOLPro.Value, 3)) &
                     (!L_Prop.getRecordElement(EDOLPro.Value, 4) = !L_Prop.getRecordElement(EDOLPro.Value, 5)) &
                     (!L_Prop.getRecordElement(EDOLPro.Value, 6) = !L_Prop.getRecordElement(EDOLPro.Value, 7)),
                     "६ 砫  砭 뢠  ६");
   END;
  END;
 END {EDOLPro_Check};

 PUBLIC PROCEDURE OnBeforeInsert();
 BEGIN
  L_General.Error("⠢ 饭");
 END {OnBeforeInsert};

 PUBLIC PROCEDURE OnBeforeDelete();
 BEGIN
  L_General.Error(" 饭");
 END {OnBeforeDelete};

 PUBLIC PROCEDURE GetPool(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF L_Prop.IsLocalProperty(_Property) THEN
   RETURN L_Prop.E_GetPool(_Property);
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PUBLIC PROCEDURE HasAnyEDOLPro(_EDOrder : LIKE(EDOrder.EDOrder);
                                _Row     : LIKE(EDOLPro.Row);
                                _Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  SELECT(EDOLPro, EDOrder, , _EDOrder, _Row);
  WHILE OCCURE(EDOLPro) & (!EDOLPro.Value | (EDOLPro.Property#_Property)) DO
   NEXT(EDOLPro);
  END;
  RETURN OCCURE(EDOLPro);
 END {HasAnyEDOLPro};

 PUBLIC PROCEDURE HasEDOLPro(_EDOrder : LIKE(EDOrder.EDOrder);
                             _Row     : LIKE(EDOLPro.Row);
                             _Property: LIKE(Property.Property);
                             _PropRow : LIKE(EDOLPro.PropRow)): SCAL[2];
 BEGIN
  IF SELECT(EDOLPro, EDOrder, _EDOrder, _Row, _Property, _PropRow) THEN
   RETURN ~!EDOLPro.Value;
  ELSE
   RETURN 0;
  END;
 END {HasEDOLPro};

 PUBLIC PROCEDURE GetEDOLProStrong(_EDOrder : LIKE(EDOrder.EDOrder);
                                   _Row     : LIKE(EDOLPro.Row);
                                   _Property: LIKE(Property.Property);
                                   _PropRow : LIKE(EDOLPro.PropRow)): LIKE(EDOLPro.Value);
 BEGIN
  IF ~HasEDOLPro(_EDOrder, _Row, _Property, _PropRow) THEN
   SEARCH(EDOrderL, EDOrder, , _EDOrder, _Row);
   L_Prop.ShowUndefinedProValueError(TABLE.Get("EDOrderL").Id, EDOrderL.RECORDID, _Property, EMPTYOF(DATE));
  END;
  RETURN EDOLPro.Value;
 END {GetEDOLProStrong};

 PUBLIC PROCEDURE GetEDOLProSoft(_EDOrder : LIKE(EDOrder.EDOrder);
                                 _Row     : LIKE(EDOLPro.Row);
                                 _Property: LIKE(Property.Property);
                                 _PropRow : LIKE(EDOLPro.PropRow)): LIKE(EDOLPro.Value);
  VAR
   Result: LIKE(EDOLPro.Value);
 BEGIN
  IF HasEDOLPro(_EDOrder, _Row, _Property, _PropRow) THEN
   Result:=EDOLPro.Value;
  ELSE
   SETEMPTY(Result);
  END;
  RETURN Result;
 END {GetEDOLProSoft};

 PUBLIC PROCEDURE GetRegimeTimes(VAR BT, ET: TIME; VAR DBT, DET: TIME[3]): SCAL[2];
 BEGIN
  IF HasEDOLPro(EDOrderL.EDOrder, EDOrderL.Row, P_RegimeTimes, 00) THEN
   BT    :=STRTOFLD(L_Prop.getRecordElement(EDOLPro.Value, 0), TIME);
   ET    :=STRTOFLD(L_Prop.getRecordElement(EDOLPro.Value, 1), TIME);
   DBT[0]:=STRTOFLD(L_Prop.getRecordElement(EDOLPro.Value, 2), TIME);
   DET[0]:=STRTOFLD(L_Prop.getRecordElement(EDOLPro.Value, 3), TIME);
   DBT[1]:=STRTOFLD(L_Prop.getRecordElement(EDOLPro.Value, 4), TIME);
   DET[1]:=STRTOFLD(L_Prop.getRecordElement(EDOLPro.Value, 5), TIME);
   DBT[2]:=STRTOFLD(L_Prop.getRecordElement(EDOLPro.Value, 6), TIME);
   DET[2]:=STRTOFLD(L_Prop.getRecordElement(EDOLPro.Value, 7), TIME);
   RETURN 1;
  ELSE
   SETEMPTY(BT, ET, DBT, DET);
   RETURN 0;
  END; (* IF P_EDOL.HasEDOLPro ... *)
 END {GetRegimeTimes};

END.
