(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose       ᢮⢠ ꥪ⮢
%Type        library
%Specific    SYS
%Modified    18.08.2014 19:02:56 POLAK\Gina
*)

 MODULE P_Firm [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tMProType    = SCAL[4];
  tPartnerType = SCAL[4];
  tMyFirm      = SCAL[1E4];
  tMyPlace     = SCAL[1E4];

 PUBLIC CONST
  SM_Soft   = 0;
  SM_Strong = 1;

  mf_Fict = 0000;
  mf_Own  = 0001;

  mp_Fict = 0000;

  OWN_FIRM  = 0000;
  FICT_BANK = 000;

  fat_Settlement = 0;
  fat_Deposit    = 1;
  fat_Credit     = 2;
  fat_Current    = 3;
  fat_CashOffice = 4;
  fat_OprCashDsk = 5;

  fat_Pool = "|||||";

  fa_CashOffice = 00;

  P_StaffDepPhone          = 0015;
  P_Depart                 = 0024;
  P_OurCode                = 0025;
  P_BasisOfLeaderActivity  = 1013;
  P_KPP                    = 7099;
  P_RegName                = 7101;
  P_INN                    = 7105;
  P_OKPO                   = 7106;
  P_OGRN                   = 7107;
  P_FirmNameFP             = 7108;
  P_OKONH                  = 7115;

  mpt_ManName      = 0;
  mpt_ManPostName  = 1;
  mpt_ManINN       = 2;
  mpt_ManExtWrkTel = 3;

  fa_BankInBank     = 0;
  fa_BankInName     = 1;

  fa_AcntInAcnt     = 0;
  fa_AcntInBankAcnt = 1;
  fa_AcntInName     = 2;

  msi_Amount   = 7;

  msi_Name          = 0;
  msi_PostName      = 1;
  msi_ExtTel        = 2;
  msi_IntTelefon    = 3;
  msi_MblTelefon    = 4;
  msi_EMail         = 5;
  msi_EMail_for_SMS = 6;

  pt_Firm   = 0;
  pt_Man    = 1;
  pt_Owner  = 2;
  pt_Branch = 3;

  pt_Pool =  "࣠|᪮ |।ਭ⥫|";

  Acnt_MagicText_v1 = "ᯮ廊⥫묨 㬥⠬ ࣠樨   壠  ।ᬮ७";
  Acnt_MagicText_v2 = "  ।ᬮ७";

 PUBLIC PERMANENT VAR
  defaultMyFirm : tMyFirm;
  defaultMyPlace: tMyPlace;
  dfmAssigned,
  dfpAssigned   : SCAL[2];

  minMyPlace,
  maxMyPlace    : tMyPlace;

  minMyFirm,
  maxMyFirm     : tMyFirm;

 PUBLIC VAR
  curMyFirm: tMyFirm;

 IMPORT L_General, L_DatTim, L_Russia, L_Str, L_Staff, L_Prop, L_StdFrm,
        P_Man, Str, Math, L_MSO, L_Env, L_XObj, L_EC,
        L_SES, L_PCS, L_WDO, L_ctc, P_MyFirm, P_MySite, L_r2r, L_Man;

 PRIVATE VAR
  fps_Condition: SCAL[2];

 PUBLIC PROCEDURE PropertyModificationAllowed(Prop: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF    (Prop = P_RegName) | (Prop = P_INN) THEN
   RETURN L_Prop.mac_Inside;
  ELSIF (Prop = P_OKONH) THEN
   RETURN L_Prop.mac_Old;
  ELSE
   RETURN L_Prop.mac_Full;
  END;
 END {PropertyModificationAllowed};

 PUBLIC PROCEDURE GetMyFirmOfFirm(trgFirm: LIKE(Firm.Firm)): tMyFirm;
  VAR
   Result: tMyFirm;
 BEGIN
  SAVE(MyFirm);
  SETEMPTY(Result);
  SELECT(MyFirm, Firm, , trgFirm);
  WHILE OCCURE(MyFirm) DO
   IF MyFirm.MyFirm # mf_Fict THEN
    L_General.CallUs(!Result);
    Result:=MyFirm.MyFirm;
   END;
   NEXT(MyFirm);
  END;
  RESTORE(MyFirm);
  RETURN Result;
 END {GetMyFirmOfFirm};

 PRIVATE PROCEDURE _mfof(trgFirm: LIKE(Firm.Firm)): tMyFirm;
  VAR
   _MyFirm: tMyFirm;
 BEGIN
  _MyFirm:=GetMyFirmOfFirm(trgFirm);
  L_General.CallUs(~!_MyFirm);
  RETURN _MyFirm;
 END {_mfof};

 PUBLIC PROCEDURE IsOwnFirm(trgFirm: LIKE(Firm.Firm)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(MyFirm);
  Result:=~!GetMyFirmOfFirm(trgFirm);
  RESTORE(MyFirm);
  RETURN Result;
 END {IsOwnFirm};

 PUBLIC PROCEDURE PositionOnMyFirm(trgMyFirm: tMyFirm);
 BEGIN
  L_General.CallUs(SEARCH(MyFirm, MyFirm, trgMyFirm));
 END {PositionOnMyFirm};

 PUBLIC PROCEDURE fomf(trgMyFirm: tMyFirm): LIKE(Firm.Firm); (*Firm of MyFirm*)
  VAR
   Result: LIKE(Firm.Firm);
 BEGIN
  SAVE(MyFirm);
  PositionOnMyFirm(trgMyFirm);
  Result:=MyFirm.Firm;
  RESTORE(MyFirm);
  RETURN Result;
 END {fomf};

(*!*) PUBLIC PROCEDURE GetFirmOfMyFirm(_MyFirm: tMyFirm): LIKE(Firm.Firm);
 BEGIN
  RETURN fomf(_MyFirm);
 END {GetFirmOfMyFirm};

 PUBLIC PROCEDURE IsFirmCtcOfManOfFirm(trgContact: LIKE(FirmCtc.Contact); trgCKType: LIKE(FirmCtc.CKType)): SCAL[2];
 BEGIN
  IF trgCKType = L_ctc.ckt_Leader THEN
   CONFORM(FirmCtc, Firm);
   IF Firm.PrtnrTyp = pt_Man THEN
    L_ctc.AccessContact(trgContact);
    IF Contact.Origin = L_ctc.o_Man THEN
     RETURN 1;
    END;
   END;
  END;
  RETURN 0;
 END {IsFirmCtcOfManOfFirm};

 PUBLIC PROCEDURE GetManOfFirm(D: DATE; trgFirm: LIKE(Firm.Firm)): LIKE(Man.Man);
  VAR
   Result: LIKE(Man.Man);
 BEGIN
  SETEMPTY(Result);
  SETSEL(FirmCtc, fCKType, trgFirm, L_ctc.ckt_Leader);
  IF SRCINSEL(FirmCtc, LE, D) THEN
   IF IsFirmCtcOfManOfFirm(FirmCtc.Contact, FirmCtc.CKType) THEN
    SAVE(Man);
    L_General.CallUs(SEARCH(Man, Contact, Contact.Contact));
    Result:=Man.Man;
    RESTORE(Man);
   END;
  END;
  RETURN Result;
 END {GetManOfFirm};

 PUBLIC PROCEDURE GetSubWindowName(Prop: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    Prop = P_RegName THEN RETURN "P_7101";
  END;
  RETURN "";
 END {GetSubWindowName};

 PUBLIC PROCEDURE GetFirmProPool(Prop: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    L_Prop.IsLocalProperty(Prop) THEN
   RETURN L_Prop.E_GetPool(Prop);
  ELSE
   RETURN "";
  END;
 END {GetFirmProPool};

 PRIVATE PROCEDURE PutProValue(BeforeDelete: SCAL[2]; Prop: LIKE(Property.Property));
  VAR
   D                  : DATE;
   trgPrtnrTyp        : tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
 BEGIN
  D:=FirmPro.Date;
  SAVE(FirmPro);
  SETSEL(FirmPro, Firm, FirmPro.Firm, Prop);
  LAST(FirmPro);
  IF BeforeDelete & OCCURE(FirmPro) & (FirmPro.Date = D) THEN
   PREV(FirmPro);
  END; (* IF BeforeDelete &...*)
  IF OCCURE(FirmPro) THEN
   CONFORM(FirmPro, Firm);
   IF    Prop = P_INN THEN
    Firm._INN:=FirmPro.Value;
   ELSIF Prop = P_RegName THEN
    Decode_RegName(FirmPro.Value, trgPrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
    Firm.PrtnrTyp:=trgPrtnrTyp;
   END;
  ELSE
   IF    Prop = P_INN THEN
    SETEMPTY(Firm._INN);
   ELSIF Prop = P_RegName THEN
    Firm.PrtnrTyp:=pt_Firm;
   END;
  END;
  REPLACE(Firm);
  RESTORE(FirmPro);
 END {PutProValue};

 PRIVATE PROCEDURE CheckForeignINN_Kazakhstan(INN: STRING[]): SCAL[2];
  VAR
   Cnt,
   Sum,
   Digit,
   Weight,
   KR      : NUMERIC[0];
 BEGIN
  IF Str.Length(INN) # 12 THEN
   RETURN 0;
  END;
  KR :=10;
  Cnt:=1;
  WHILE (KR >= 10) & (Cnt <= 10) DO
   SETZERO(Sum, Digit);
   WHILE Digit < 11 DO
    Weight:=Digit - 10 * (Digit > 10 - Cnt) + Cnt;
    INC(Sum, STRTOFLD(INN[Digit], NUMERIC) * Weight);
    INC(Digit);
   END;
   KR:=Sum - (Sum DIV 11) * 11;
   INC(Cnt);
  END;

  IF Cnt = 10 THEN
   RETURN 0;
  ELSE
   RETURN KR = STRTOFLD(INN[11], NUMERIC);
  END;
 END {CheckForeignINN_Kazakhstan};

 PUBLIC PROCEDURE Check_INN(trgINN: STRING[]);
 BEGIN
  L_General.Assert(L_Str.TestStrAlowChar(trgINN, "09"), "   ஢ ᨬ");
  IF ~L_Russia.CheckINN(trgINN) & ~CheckForeignINN_Kazakhstan(trgINN) THEN
   L_General.Error("४ ");
  END;
 END {Check_INN};

 PUBLIC PROCEDURE CheckHeadFirm(trgFirm: LIKE(Firm.Firm); D: DATE);
  VAR
   PrtnrTyp           : tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
 BEGIN
  L_General.Assert(~!D, " ᭠砫 㪠  砫 ⢨");
  SAVE(FirmPro);
  SELECT(FirmPro, Firm, , trgFirm, P_RegName);
  WHILE OCCURE(FirmPro) DO
   Decode_RegName(FirmPro.Value, PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
   IF PrtnrTyp = pt_Branch THEN
    L_General.Error("ࠣ " + trgFirm + " 㦥  䨫 ࠣ " + HeadFirm);
   END;
   NEXT(FirmPro);
  END; (* WHILE OCCURE(FirmPro) ... *)
  RESTORE(FirmPro);
 END {CheckHeadFirm};

 PUBLIC PROCEDURE FirmPro_Check(Prop: LIKE(Property.Property));
  VAR
   Text,
   Pattern            : STRING[];
   chkR,
   chkV,
   Denom,
   _Value             : NUMERIC[0];
   PrtnrTyp           : tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
 BEGIN
  IF    Prop = P_INN THEN
   Check_INN(FirmPro.Value);
  ELSIF Prop = P_OKPO THEN
   SAVE(FirmPro);
   IF FP_PrtnrTyp(FirmPro.Firm, FirmPro.Date) = pt_Owner THEN
    Pattern:="9999999999";
   ELSE
    Pattern:="99999999";
   END;
   RESTORE(FirmPro);
   L_Str.CheckStrWMask(" ", FirmPro.Value, Pattern);
  ELSIF Prop = P_OKONH THEN
   L_Prop.CheckScalValue(FirmPro.Value, "", 1e5-1);
  ELSIF Prop = P_RegName THEN
   Decode_RegName(FirmPro.Value, PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
   CheckHeadFirm(HeadFirm, FirmPro.Date);
  ELSIF Prop = P_OGRN THEN
   SAVE(FirmPro);
   IF FP_PrtnrTyp(FirmPro.Firm, FirmPro.Date) = pt_Owner THEN
    Pattern:="999999999999999";
    Text   :="";
    Denom  :=13;
   ELSE
    Pattern:="9999999999999";
    Text   :="";
    Denom  :=11;
   END;
   RESTORE(FirmPro);
   L_Str.CheckStrWMask(" " + Text, FirmPro.Value, Pattern);

   _Value:=STRTOFLD(Str.Slice(FirmPro.Value, 0, Str.Length(FirmPro.Value)-1), NUMERIC);
   chkR  :=STRTOFLD(L_Str.Char(FirmPro.Value, Str.Length(FirmPro.Value)-1), NUMERIC);
   chkV  :=Math.Mod(Math.Mod(_Value, Denom), 10);
   L_General.Assert(chkV = chkR, "ࠢ  " + Text + "|( 室 ஢ ஫쭮 ࠧ鸞)");
  END;
 END {FirmPro_Check};

 PUBLIC PROCEDURE HasFirmPro(trgFirm: LIKE(Firm.Firm); D: DATE; Prop: LIKE(Property.Property)): SCAL[2];
 BEGIN
  SETSEL(FirmPro, Firm, trgFirm, Prop);
  RETURN SRCINSEL(FirmPro, LE, D);
 END {HasFirmPro};

 PUBLIC PROCEDURE HasActualFirmPro(trgFirm: LIKE(Firm.Firm); D: DATE; Prop: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasFirmPro(trgFirm, D, Prop) & (!FirmPro.DocExpD | (D < FirmPro.DocExpD));
 END {HasActualFirmPro};

 PUBLIC PROCEDURE GetFirmProStrong(trgFirm: LIKE(Firm.Firm); D: DATE; Prop: LIKE(Property.Property)): STRING[];
 BEGIN
  IF ~HasActualFirmPro(trgFirm, D, Prop) THEN
   SEARCH(Firm, Firm, , trgFirm);
   L_Prop.ShowUndefinedProValueError(TABLE.Get("Firm").Id, Firm.RECORDID, Prop, D);
  END;
  RETURN FirmPro.Value;
 END {GetFirmProStrong};

 PUBLIC PROCEDURE GetManAttrByTSN(trgTSN: LIKE(Staff.TSN); D: DATE; trgType: tMProType): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(Staff);
  L_General.CallUs(SEARCH(Staff, TSN, trgTSN));
  IF    trgType = mpt_ManName THEN
   SAVE(Man);
   CONFORM(Staff, Man);
   Result:=Man.Name;
   RESTORE(Man);
  ELSIF trgType = mpt_ManPostName THEN
   SAVE(StaffLog);
   SAVE(Officer);
   SAVE(Post);
   HISTCONF(D, Staff, StaffLog);
   IF ~OCCURE(StaffLog) THEN
    FIRST(StaffLog);
   END;
   CONFORM(StaffLog, Officer, Post);
   CONFORM(StaffLog, SLKind);
   Result:=Post.Name;
   IF SLKind.IsActing THEN
    Result:=Result + " (..)";
   END;
   RESTORE(StaffLog);
   RESTORE(Officer);
   RESTORE(Post);
  ELSIF trgType = mpt_ManINN THEN
   SAVE(Man);
   CONFORM(Staff, Man);
   Result:=Man.INN;
   RESTORE(Man);
  ELSIF trgType = mpt_ManExtWrkTel THEN
   Result:=P_Man.GetManWorkTelefon(Staff.Man, D, P_Man.ci_ExtTelefon);
   IF !Result THEN
    Result:=FP_Phone(GetFirmOfMyFirm(Staff.MyFirm), D);
   END;
  ELSE
   L_General.Error(" 祭 ᢮⢠  ।");
  END;
  RESTORE(Staff);
  RETURN Result;
 END {GetManAttrByTSN};

 PUBLIC PROCEDURE GetManINNByFirmCtc(): LIKE(Man.INN);
  VAR
   _INN  : LIKE(Man.INN);
 BEGIN
  L_General.CallUs(ACCESS(FirmCtc));
  CONFORM(FirmCtc, Contact);
  SAVE(Man);
  IF (Contact.Origin = L_ctc.o_Man) & SELECT(Man, Contact, Contact.Contact) THEN
   _INN:=Man.INN;
  ELSE
   _INN:="";
  END;
  RESTORE(Man);
  RETURN _INN;
 END {GetManINNByFirmCtc};

 PUBLIC PROCEDURE GetManINNByCKType(Strong : SCAL[2];
                                    trgFirm: LIKE(Firm.Firm);
                                    D      : DATE;
                                    ckt    : L_ctc.tCKType): LIKE(Man.INN);
 BEGIN
  IF StandOnFirmCtcByKindType(Strong, trgFirm, D, ckt) THEN
   RETURN GetManINNByFirmCtc();
  ELSE
   RETURN "";
  END;
 END {GetManINNByCKType};

 PUBLIC PROCEDURE GetFirmProSoft(trgFirm: LIKE(Firm.Firm); D: DATE; Prop: LIKE(Property.Property)): STRING[];
 BEGIN
  IF HasActualFirmPro(trgFirm, D, Prop) THEN
   RETURN FirmPro.Value;
  ELSE
   RETURN "";
  END;
 END {GetFirmProSoft};

 PRIVATE PROCEDURE GetFirmPro_wDefault(trgFirm    : LIKE(Firm.Firm);
                                       D          : DATE;
                                       Prop       : LIKE(Property.Property);
                                       _GetDefault: PROC): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=GetFirmProSoft(trgFirm, D, Prop);
  IF !Result THEN
   RETURN _GetDefault(trgFirm, D);
  ELSE
   RETURN Result;
  END;
 END {GetFirmPro_wDefault};

 PUBLIC PROCEDURE GetFirmPro_PartnerTypeDepend(trgFirm: LIKE(Firm.Firm);
                                               D      : DATE;
                                               Prop   : LIKE(Property.Property)): STRING[];
  VAR
   Value: STRING[];
 BEGIN
  Value:=GetFirmProSoft(trgFirm, D, Prop);
  IF !Value THEN
   SAVE(Firm);
   SEARCH(Firm, Firm, , trgFirm);
   IF L_DatTim.IsActive(D, Firm.Begin, Firm.Till) & (FP_PrtnrTyp(trgFirm, D) # pt_Man) THEN
    Value:=GetFirmProStrong(trgFirm, D, Prop);
   END;
   RESTORE(Firm);
  END;
  RETURN Value;
 END {GetFirmPro_PartnerTypeDepend};

 PUBLIC PROCEDURE AccessFirm(trgFirm: LIKE(Firm.Firm));
 BEGIN
  L_General.Assert(SEARCH(Firm, Firm, trgFirm), " ࠣ   "+ trgFirm);
 END {AccessFirm};

 PUBLIC PROCEDURE AccessOwnFirm(trgMyFirm: tMyFirm);
 BEGIN
  AccessFirm(GetFirmOfMyFirm(trgMyFirm));
 END {AccessOwnFirm};

 PUBLIC PROCEDURE GetRegNameValues(    trgFirm            : LIKE(Firm.Firm);
                                       D                  : DATE;
                                   VAR PrtnrTyp           : tPartnerType;
                                   VAR HeadFirm           : LIKE(Firm.Firm);
                                   VAR PersonFullName,
                                       BranchName,
                                       ContractorBriefName,
                                       BranchFullName     : STRING[]);
 BEGIN
  Decode_RegName(GetFirmProStrong(trgFirm, D, P_RegName), PrtnrTyp, HeadFirm,
                PersonFullName, BranchName, ContractorBriefName, BranchFullName);
 END {GetRegNameValues};

 PUBLIC PROCEDURE GetPartnerType_AsStr(PrtnrTyp: tPartnerType): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(pt_Pool, PrtnrTyp);
 END {GetPartnerType_AsStr};

 PUBLIC PROCEDURE FP_PrtnrTyp(trgFirm: LIKE(Firm.Firm); D: DATE): tPartnerType;
  VAR
   PrtnrTyp           : tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
 BEGIN
  GetRegNameValues(trgFirm, D, PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
  RETURN PrtnrTyp;
 END {FP_PrtnrTyp};

 PUBLIC PROCEDURE PartnerTypeIsPhysicalBody(_PrtnrTyp: tPartnerType): SCAL[2];
 BEGIN
  RETURN (_PrtnrTyp = pt_Man) | (_PrtnrTyp = pt_Owner);
 END {PartnerTypeIsPhysicalBody};

 PUBLIC PROCEDURE ContractorIsPhysicalBody(trgFirm: LIKE(Firm.Firm); D: DATE): SCAL[2];
 BEGIN
  RETURN PartnerTypeIsPhysicalBody(FP_PrtnrTyp(trgFirm, D));
 END {ContractorIsPhysicalBody};

 PUBLIC PROCEDURE FP_PersonFullName(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
  VAR
   PrtnrTyp           : tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
 BEGIN
  GetRegNameValues(trgFirm, D, PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
  RETURN PersonFullName;
 END {FP_PersonFullName};

 PUBLIC PROCEDURE FP_PersonFullName_wBranchName(trgFirm: LIKE(Firm.Firm); OnDate: DATE): STRING[];
  VAR
   PrtnrTyp           : tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
 BEGIN
  GetRegNameValues(trgFirm, OnDate, PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
  IF    ~!BranchFullName THEN
   RETURN BranchFullName;
  ELSIF ~!BranchName THEN
   RETURN PersonFullName + ", 䨫 " + BranchName;
  ELSE
   RETURN PersonFullName;
  END;
 END {FP_PersonFullName_wBranchName};

(*!*)PUBLIC PROCEDURE FP_FirmName(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN FP_ContractorBriefName(trgFirm, D);
 END {FP_FirmName};

 PUBLIC PROCEDURE FP_ContractorBriefName(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
  VAR
   PrtnrTyp           : tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
 BEGIN
  GetRegNameValues(trgFirm, D, PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
  RETURN ContractorBriefName;
 END {FP_ContractorBriefName};

 PUBLIC PROCEDURE FP_BranchName(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
  VAR
   PrtnrTyp           : tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
 BEGIN
  GetRegNameValues(trgFirm, D, PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
  RETURN BranchName;
 END {FP_BranchName};

 PUBLIC PROCEDURE MyFirmName(MyFirm: tMyFirm; D: DATE): STRING[];
 BEGIN
  RETURN FP_FirmName(GetFirmOfMyFirm(MyFirm), D);
 END {MyFirmName};

 PUBLIC PROCEDURE FP_FirmShortName(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  AccessFirm(trgFirm);
  RETURN Firm.Name;
 END {FP_FirmShortName};

 PUBLIC PROCEDURE StandOnFirmCtcByKindType(Strong : SCAL[2];
                                           trgFirm: LIKE(Firm.Firm);
                                           D      : DATE;
                                           ckt    : L_ctc.tCKType): SCAL[2];
 BEGIN
  SETSEL(FirmCtc, fCKType, trgFirm, ckt);
  IF SRCINSEL(FirmCtc, LE, D) & (FirmCtc.Till > D) THEN
   RETURN 1;
  ELSE
   IF Strong THEN
    L_General.Error(" ⠪ ⨯ '" + L_Str.PoolItem(L_ctc.ckt_Pool, ckt) + "'" +
                    "| '⠪ ࠣ' " + trgFirm + "  " + L_DatTim.DateStr(D));
   ELSE
    RETURN 0;
   END;
  END;
 END {StandOnFirmCtcByKindType};

 PUBLIC PROCEDURE GetFirmCtcVal(Strong : SCAL[2];
                                trgFirm: LIKE(Firm.Firm);
                                D      : DATE;
                                ckt    : L_ctc.tCKType;
                                cc     : L_ctc.tCoverage;
                                cvt    : L_ctc.tValType): STRING[];
 BEGIN
  IF StandOnFirmCtcByKindType(Strong, trgFirm, D, ckt) THEN
   RETURN L_ctc.GetCtcVal(Strong, FirmCtc.Contact, D, cc, cvt);
  ELSE
   RETURN "";
  END;
 END {GetFirmCtcVal};

 PUBLIC PROCEDURE gfcv_cc_Common(Strong: SCAL[2]; trgFirm: LIKE(Firm.Firm); D: DATE; vt: L_ctc.tValType): STRING[];
  VAR
   curPartnerType: tPartnerType;
   Result        : STRING[];
 BEGIN
  curPartnerType:=FP_PrtnrTyp(trgFirm, D);
  IF    curPartnerType = pt_Man THEN
   Result:=GetFirmCtcVal(Strong, trgFirm, D, L_ctc.ckt_Leader, L_ctc.cvc_Home, vt);
  ELSIF curPartnerType = pt_Owner THEN
   Result:=GetFirmCtcVal(SM_Soft, trgFirm, D, L_ctc.ckt_Common, L_ctc.cvc_Work, vt);
   IF !Result THEN
    Result:=GetFirmCtcVal(Strong, trgFirm, D, L_ctc.ckt_Leader, L_ctc.cvc_Work, vt);
   END;
  ELSE
   Result:=GetFirmCtcVal(Strong, trgFirm, D, L_ctc.ckt_Common, L_ctc.cvc_Work, vt);
  END;
  RETURN Result;
 END {gfcv_cc_Common};

 PUBLIC PROCEDURE FP_Phone(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN gfcv_cc_Common(IsOwnFirm(trgFirm), trgFirm, D, L_ctc.cvt_PhonePST);
 END {FP_Phone};

 PUBLIC PROCEDURE FP_ClrPhone(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN gfcv_cc_Common(0, trgFirm, D, L_ctc.cvt_PhoneClr);
 END {FP_ClrPhone};

 PUBLIC PROCEDURE FP_Fax(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN gfcv_cc_Common(0, trgFirm, D, L_ctc.cvt_Fax);
 END {FP_Fax};

 PUBLIC PROCEDURE FP_email(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN gfcv_cc_Common(0, trgFirm, D, L_ctc.cvt_Email);
 END {FP_email};

 PUBLIC PROCEDURE FP_Site(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN gfcv_cc_Common(0, trgFirm, D, L_ctc.cvt_WWW);
 END {FP_Site};

 PUBLIC PROCEDURE FP_AcntPhone(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=GetFirmCtcVal(0, trgFirm, D, L_ctc.ckt_AcntDep, L_ctc.cvc_Work, L_ctc.cvt_PhonePST);
  IF !Result THEN
   Result:=FP_Phone(trgFirm, D);
  END;
  RETURN Result;
 END {FP_AcntPhone};

 PUBLIC PROCEDURE FP_StaffDepPhone(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN GetFirmPro_wDefault(trgFirm, D, P_StaffDepPhone(*䮭 ⤥ ஢*), PROCREF(FP_Phone));
 END {FP_StaffDepPhone};

 PUBLIC PROCEDURE FP_ContactPersonName(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  IF StandOnFirmCtcByKindType(0, trgFirm, D, L_ctc.ckt_DftCtcPerson) THEN
   RETURN FirmCtc.Name;
  ELSE
   RETURN "";
  END;
 END {FP_ContactPersonName};

 PUBLIC PROCEDURE FP_ContactPersonPostName1(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  IF StandOnFirmCtcByKindType(0, trgFirm, D, L_ctc.ckt_DftCtcPerson) THEN
   RETURN FirmCtc.ECKName;
  ELSE
   RETURN "";
  END;
 END {FP_ContactPersonPostName};

 PUBLIC PROCEDURE extFP_LeadName(Strong: SCAL[2]; trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  IF StandOnFirmCtcByKindType(Strong, trgFirm, D, L_ctc.ckt_Leader) THEN
   RETURN FirmCtc.Name;
  ELSE
   RETURN "";
  END;
 END {extFP_LeadName};

 PUBLIC PROCEDURE FP_LeadName(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN extFP_LeadName(1, trgFirm, D);
 END {FP_LeadName};

 PUBLIC PROCEDURE extFP_LeadPostName1(Strong: SCAL[2]; trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  IF StandOnFirmCtcByKindType(Strong, trgFirm, D, L_ctc.ckt_Leader) THEN
   RETURN FirmCtc.ECKName;
  ELSE
   RETURN "";
  END;
 END {extFP_LeadPostName1};

 PUBLIC PROCEDURE FP_LeadPostName1(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN extFP_LeadPostName1(1, trgFirm, D);
 END {FP_LeadPostName1};

 PUBLIC PROCEDURE FP_BasisOfLeaderActivity(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN GetFirmProStrong(trgFirm, D, P_BasisOfLeaderActivity);
 END {FP_BasisOfLeaderActivity};

 PUBLIC PROCEDURE FP_StaffDepChiefName(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.StaffDepChiefName(_mfof(trgFirm), D);
 END {FP_StaffDepChiefName};

 PUBLIC PROCEDURE FP_StaffDepChiefPostName(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.StaffDepChiefPostName(_mfof(trgFirm), D);
 END {FP_StaffDepChiefPostName};

 PUBLIC PROCEDURE FP_AcntName(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  IF StandOnFirmCtcByKindType(0, trgFirm, D, L_ctc.ckt_MainAcnt) THEN
   RETURN FirmCtc.Name;
  ELSE
   RETURN "";
  END;
 END {FP_AcntName};

 PUBLIC PROCEDURE Acnt_Manner(trgFirm: LIKE(Firm.Firm);
                              D: DATE): SCAL[2];
 BEGIN
  IF StandOnFirmCtcByKindType(SM_Soft, trgFirm, D, L_ctc.ckt_Leader) THEN
   RETURN FirmCtc.Name = FP_AcntName(trgFirm, D);
  END;
  RETURN 0;
 END {Acnt_Manner};

 PUBLIC PROCEDURE FP_RealAcntName_Short(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  IF Acnt_Manner(trgFirm, D) THEN
   RETURN Acnt_MagicText_v2;
  ELSE
   RETURN L_Str.ShortName(FP_AcntName(trgFirm, D));
  END;
 END {FP_RealAcntName_Short};

 PUBLIC PROCEDURE FP_AcntPostName(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  IF StandOnFirmCtcByKindType(1, trgFirm, D, L_ctc.ckt_MainAcnt) THEN
   RETURN FirmCtc.ECKName;
  ELSE
   RETURN "";
  END;
 END {FP_AcntPostName};

 PUBLIC PROCEDURE FP_TaxCardResp(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.TaxCardResp(_mfof(trgFirm), D);
 END {FP_TaxCardResp};

 PUBLIC PROCEDURE FP_TaxCardCont(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.TaxCardCont(_mfof(trgFirm), D);
 END {FP_TaxCardCont};

 PUBLIC PROCEDURE FP_Tax3Sender(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.Tax3Sender(_mfof(trgFirm), D);
 END {FP_Tax3Sender};

 PUBLIC PROCEDURE FP_AnkSender(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.AnkSender(_mfof(trgFirm), D);
 END {FP_AnkSender};

 PUBLIC PROCEDURE FP_PFRInsSender(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.PFRInsSender(_mfof(trgFirm), D);
 END {FP_PFRInsSender};

 PUBLIC PROCEDURE FP_STxCont(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.STxCont(_mfof(trgFirm), D);
 END {FP_STxCont};

 PUBLIC PROCEDURE FP_CashName(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.CashName(_mfof(trgFirm), D);
 END {FP_CashName};

 PUBLIC PROCEDURE FP_AcntCashName(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.AcntCashName(_mfof(trgFirm), D);
 END {FP_AcntCashName};

 PUBLIC PROCEDURE FP_KPP(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  IF IsOwnFirm(trgFirm) THEN
   RETURN P_MySite.GetP_KPP(GetMyFirmOfFirm(trgFirm), EMPTYOF(MyPlace.MyPlace), D);
  ELSE
   RETURN GetFirmProStrong(trgFirm, D, P_KPP);
  END;
 END {FP_KPP};

 PUBLIC PROCEDURE FP_TaxDep(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.TaxDep(_mfof(trgFirm), D);
 END {FP_TaxDep};

 PUBLIC PROCEDURE FP_TaxDepCode(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.TaxDepCode(_mfof(trgFirm), D);
 END {FP_TaxDepCode};

 PUBLIC PROCEDURE FP_INN(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN GetFirmPro_PartnerTypeDepend(trgFirm, D, P_INN);
 END {FP_INN};

 PUBLIC PROCEDURE FP_OKPO(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN GetFirmPro_PartnerTypeDepend(trgFirm, D, P_OKPO);
 END {FP_OKPO};

 PUBLIC PROCEDURE FP_OGRN(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN GetFirmPro_PartnerTypeDepend(trgFirm, D, P_OGRN);
 END {FP_OGRN};

 PUBLIC PROCEDURE FP_OKONH(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  L_General.CallUs(0); (* 0101824 *)
  RETURN GetFirmProStrong(trgFirm, D, P_OKONH);
 END {FP_OKONH};

 PUBLIC PROCEDURE FP_FirmNameFP(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN GetFirmProStrong(trgFirm, D, P_FirmNameFP);
 END {FP_FirmNameFP};

 PUBLIC PROCEDURE FP_OKOPF_Code(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.OKOPF_Code(_mfof(trgFirm), D);
 END {FP_OKOPF_Code};

 PUBLIC PROCEDURE FP_OKOPF_Name(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.OKOPF_Name(_mfof(trgFirm), D);
 END {FP_OKOPF_Name};

 PUBLIC PROCEDURE FP_OKFS_Code(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.OKFS_Code(_mfof(trgFirm), D);
 END {FP_OKFS_Code};

 PUBLIC PROCEDURE FP_OKFS_Name(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN P_MyFirm.OKFS_Name(_mfof(trgFirm), D);
 END {FP_OKFS_Name};

 PUBLIC PROCEDURE FP_HeadFirm(trgFirm: LIKE(Firm.Firm); D: DATE): LIKE(Firm.Firm);
  VAR
   PrtnrTyp           : tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
 BEGIN
  GetRegNameValues(trgFirm, D, PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
  RETURN HeadFirm;
 END {FP_HeadFirm};

 PUBLIC PROCEDURE SoftAccessSilentFirmAcnt(trgFirm: LIKE(Firm.Firm); D: DATE): SCAL[2];
  VAR
   _FirmAcnt: LIKE(FirmAcnt.FirmAcnt);
   _Begin: LIKE(FirmAcnt.Begin);
 BEGIN
  _Begin:=MINOF(DATE);
  SETEMPTY(_FirmAcnt);
  SELECT(FirmAcnt, Firm, , trgFirm);
  WHILE OCCURE(FirmAcnt) DO
   IF FirmAcnt.SilentD & L_DatTim.IsActive(D, FirmAcnt.Begin, FirmAcnt.Till) THEN
    IF FirmAcnt.Begin > _Begin THEN
     _FirmAcnt:=FirmAcnt.FirmAcnt;
     _Begin   :=FirmAcnt.Begin;
    END;
   END;
   NEXT(FirmAcnt);
  END; (* WHILE OCCURE(FirmAcnt)... *)
  IF ~!_FirmAcnt THEN
   SEARCH(FirmAcnt, Firm, , trgFirm, _FirmAcnt);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {SoftAccessSilentFirmAcnt};

 PUBLIC PROCEDURE AccessSilentFirmAcnt(trgFirm: LIKE(Firm.Firm); D: DATE);
 BEGIN
  L_General.Assert(SoftAccessSilentFirmAcnt(trgFirm, D), "     "+L_DatTim.DateStr(D)+"|ࠣ "+trgFirm);
 END {AccessSilentFirmAcnt};

 PUBLIC PROCEDURE IsSilentFirmAcnt(D: DATE): SCAL[2];
  VAR
   _SilentFirmAcnt: LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  SETEMPTY(_SilentFirmAcnt);
  IF FirmAcnt.SilentD & L_DatTim.IsActive(D, FirmAcnt.Begin, FirmAcnt.Till) THEN
   SAVE(FirmAcnt);
   IF SoftAccessSilentFirmAcnt(FirmAcnt.Firm, D) THEN
    _SilentFirmAcnt:=FirmAcnt.FirmAcnt;
   END;
   RESTORE(FirmAcnt);
  END;
  RETURN (FirmAcnt.FirmAcnt = _SilentFirmAcnt);
 END {IsSilentFirmAcnt};

 PUBLIC PROCEDURE FP_BankReq(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  AccessFirm(trgFirm);
  AccessSilentFirmAcnt(trgFirm, D);
  RETURN FirmAcntAsStr(D);
 END {FP_BankReq};

 PRIVATE PROCEDURE CheckFirmPro(_Firm: LIKE(Firm.Firm); _Date: DATE; _Property: LIKE(Property.Property));
 BEGIN
  IF ~HasFirmPro(_Firm, _Date, _Property) THEN
   SEARCH(Firm, Firm, , _Firm);
   L_Prop.ShowUndefinedProValueError(TABLE.Get("Firm").Id, Firm.RECORDID, _Property, _Date);
  END;
 END {CheckFirmPro};

 PUBLIC PROCEDURE GetFirmProDocExpD(_Firm: LIKE(Firm.Firm); _Date: DATE; _Property: LIKE(Property.Property)): DATE;
 BEGIN
  CheckFirmPro(_Firm, _Date, _Property);
  RETURN FirmPro.DocExpD;
 END {GetFirmProDocExpD};

 PUBLIC PROCEDURE GetFirmProDocNum(_Firm: LIKE(Firm.Firm); _Date: DATE; _Property: LIKE(Property.Property)): STRING[];
 BEGIN
  CheckFirmPro(_Firm, _Date, _Property);
  RETURN FirmPro.DocNum;
 END {GetFirmProDocNum};

 PUBLIC PROCEDURE GetFirmProDocGiveS(_Firm: LIKE(Firm.Firm); _Date: DATE; _Property: LIKE(Property.Property)): STRING[];
 BEGIN
  CheckFirmPro(_Firm, _Date, _Property);
  RETURN FirmPro.DocGiveS;
 END {GetFirmProDocGiveS};

 PUBLIC PROCEDURE GetFirmProDocGiveD(_Firm: LIKE(Firm.Firm); _Date: DATE; _Property: LIKE(Property.Property)): DATE;
 BEGIN
  CheckFirmPro(_Firm, _Date, _Property);
  RETURN FirmPro.DocGiveD;
 END {GetFirmProDocGiveD};

 PUBLIC PROCEDURE GetDepart(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN GetFirmProSoft(trgFirm, D, P_Depart);
 END {GetDepart};

 PUBLIC PROCEDURE GetOurCode(trgFirm: LIKE(Firm.Firm); D: DATE): STRING[];
 BEGIN
  RETURN GetFirmProSoft(trgFirm, D, P_OurCode);
 END {GetOurCode};

 PRIVATE PROCEDURE GetParentFrmManCn(): FORM_WINDOW;
  VAR
   Result: FORM_WINDOW;
   Z     : FORM_ZONE;
 BEGIN
  Result:=RTI.Get().CurWindow;
  LOOP
   Z:=Result.ParentZone;
   IF    !Z THEN
    SETEMPTY(Result);
    EXIT;
   ELSE
    Result:=Z.Window;
    IF Result.OriginalName = "FrmManCn" THEN
     EXIT;
    END;
   END;
  END;
  RETURN Result;
 END {GetParentFrmManCn};

 PRIVATE PROCEDURE rn_SetWindFieldVisible();
  CONST
   shortDepth = 22;
   fullDepth  = 28;
  VAR
   Fields     : FORM_FIELDS;
   Depth      : NUMERIC[0];
   VisibleFlag: SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("PrtnrTyp").Modifiable:=!GetParentFrmManCn();

  Fields("HeadFirm"      ).Visible:=Fields("PrtnrTyp").Value = pt_Branch;
  Fields("HeadFirm_Name" ).Visible:=Fields("PrtnrTyp").Value = pt_Branch;
  Fields("BranchName"    ).Visible:=Fields("PrtnrTyp").Value = pt_Branch;
  Fields("BranchFullName").Visible:=Fields("PrtnrTyp").Value = pt_Branch;

  IF (RTI.Get().CurWindow.Depth # shortDepth) & (RTI.Get().CurWindow.Depth # fullDepth) THEN
   L_General.CallUs(0);
  END;
  IF ~PartnerTypeIsPhysicalBody(Fields("PrtnrTyp").Value) THEN
   SETEMPTY(Fields("DocSer").Value, Fields("DocNum").Value,
            Fields("DocGiveS").Value, Fields("DocGiveD").Value, Fields("DocExpD").Value);
   Depth:=shortDepth;
  ELSE
   Depth:=fullDepth;
  END;
  RTI.Get().CurWindow.Depth:=Depth;
 END {rn_SetWindFieldVisible};

 PUBLIC PROCEDURE Decode_RegName(    Value              : STRING[];
                                 VAR PrtnrTyp           : tPartnerType;
                                 VAR HeadFirm           : LIKE(Firm.Firm);
                                 VAR PersonFullName,
                                     BranchName,
                                     ContractorBriefName,
                                     BranchFullName     : STRING[]);
 BEGIN
  SETEMPTY(PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
  PrtnrTyp           :=L_Str.PositionInPool(pt_Pool, L_Prop.getRES(Value, 0));
  HeadFirm           :=L_r2r.Decode(L_Prop.getRES(Value, 1));
  PersonFullName     :=L_Prop.getRES(Value, 2);
  BranchName         :=L_Prop.getRES(Value, 3);
  ContractorBriefName:=L_Prop.getRES(Value, 4);
  BranchFullName     :=L_Prop.getRES(Value, 5);
 END {Decode_RegName};

 PRIVATE PROCEDURE formSet_RegName();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_WDO.CreateFormLink("Firm", "Head");
  Decode_RegName(FirmPro.Value,
                 Fields("PrtnrTyp"           ).Value,
                 Fields("HeadFirm"           ).Value,
                 Fields("PersonFullName"     ).Value,
                 Fields("BranchName"         ).Value,
                 Fields("ContractorBriefName").Value,
                 Fields("BranchFullName"     ).Value);
  IF !Fields("PrtnrTyp").Value THEN
   IF ~!GetParentFrmManCn() THEN
    Fields("PrtnrTyp").Value:=pt_Man;
   ELSE
    Fields("PrtnrTyp").Value:=pt_Firm;
   END;
  END;
  Fields("asPrtnrTyp1").Value :=Fields("PrtnrTyp").Value;
  Fields("asPrtnrTyp2").Value :=Fields("PrtnrTyp").Value;
  Fields("asPrtnrTyp3").Value :=Fields("PrtnrTyp").Value;
  Fields("PrtnrTyp"   ).Format:=pt_Pool;
  Fields("asPrtnrTyp1").Format:=" | | | ࣠";
  Fields("asPrtnrTyp2").Format:=" | | | 䨫";
  Fields("asPrtnrTyp3").Format:=" | | |  䨫";

  rn_SetWindFieldVisible();
 END {formSet_RegName};

 PUBLIC PROCEDURE SetDataInForm(Prop: LIKE(Property.Property));
 BEGIN
  IF Prop = P_RegName THEN
   formSet_RegName();
  END;
 END {SetDataInForm};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Result             : STRING[];
   PrtnrTyp           : tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
   PrtnrTypStr        : STRING[];
 BEGIN
  IF FirmPro.Property = P_RegName THEN
   SETEMPTY(Result);
   Decode_RegName(FirmPro.Value, PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);
   PrtnrTypStr:=GetPartnerType_AsStr(PrtnrTyp);
   Result:=PrtnrTypStr + ";" ;
   IF ~!HeadFirm THEN
    Result:=Result + HeadFirm;
   END;
   Result:=Result              + ";" +
           PersonFullName      + ";" +
           BranchName          + ";" +
           ContractorBriefName + ";" +
           BranchFullName;
  ELSE
   Result:=FirmPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PUBLIC PROCEDURE OnSuccessfulChange(Prop: LIKE(Property.Property));
  VAR
   ActiveField   : FORM_FIELD;
   Fields        : FORM_FIELDS;
   PersonFullName: STRING[];
 BEGIN
  ActiveField:=RTI.Get().CurZone.ActiveField;
  Fields     :=RTI.Get().CurZone.Fields;
  IF Prop = P_RegName THEN
   IF    ActiveField.Name = "HeadFirm" THEN
    CheckHeadFirm(Fields("HeadFirm").Value, FirmPro.Date);
    PersonFullName:=FP_PersonFullName(Fields("HeadFirm").Value, FirmPro.Date);
    IF !Fields("PersonFullName").Value | (Fields("PersonFullName").Value = PersonFullName) |
       (STDFORM("|     :" +
                "||" + PersonFullName +
                "||" + L_StdFrm.DrawButton("", 12, "X") +
                L_StdFrm.DrawButton(" {}⠢ 饥 ", 23, "B") +
                L_StdFrm.DrawButton(" {} ", 12, "DB"), , INFORM, -1) = 2) THEN
     Fields("PersonFullName").Value:=PersonFullName;
    END;
   ELSIF ActiveField.Name = "PrtnrTyp" THEN
    Fields("asPrtnrTyp1").Value :=ActiveField.Value;
    Fields("asPrtnrTyp2").Value :=ActiveField.Value;
    Fields("asPrtnrTyp3").Value :=ActiveField.Value;
    rn_SetWindFieldVisible();
   END;
  END;
 END {OnSuccessfulChange};

 PRIVATE PROCEDURE SetAdrFieldValue(trgCountry  : LIKE(Country.Country);
                                    trgRegion   : LIKE(Region.Region);
                                    trgZip,
                                    trgDistr,
                                    trgTown,
                                    trgVillage,
                                    trgStreet   : STRING[];
                                    trgTownT,
                                    trgVillageT,
                                    trgStreetT  : SCAL[250];
                                    trgHouse,
                                    trgBlock,
                                    trgBuild,
                                    trgFlat     : STRING[]);
 BEGIN
  L_WDO.setFieldValue("v_a_CountryC", trgCountry);
  IF SEARCH(Country, Country, trgCountry) THEN
   L_WDO.setFieldValue("v_a_Country", Country.Name);
  ELSE
   L_WDO.setFieldValue("v_a_Country", "");
  END;
  L_WDO.setFieldValue("v_a_ZIP",      trgZip);
  L_WDO.setFieldValue("v_a_RegionC",  trgRegion);
  IF SEARCH(Region, Region, trgRegion) THEN
   L_WDO.setFieldValue("v_a_Region",  Region.Name);
  ELSE
   L_WDO.setFieldValue("v_a_Region",  "");
  END;
  L_WDO.setFieldValue("v_a_Distr",    trgDistr);
  L_WDO.setFieldValue("v_a_Town",     trgTown);
  L_WDO.setFieldValue("v_a_Village",  trgVillage);
  L_WDO.setFieldValue("v_a_Street",   trgStreet);
  L_WDO.setFieldValue("v_a_TownT",    trgTownT);
  L_WDO.setFieldValue("v_a_VillageT", trgVillageT);
  L_WDO.setFieldValue("v_a_StreetT",  trgStreetT);
  L_WDO.setFieldValue("v_a_House",    trgHouse);
  L_WDO.setFieldValue("v_a_Block",    trgBlock);
  L_WDO.setFieldValue("v_a_Build",    trgBuild);
  L_WDO.setFieldValue("v_a_Flat",     trgFlat);
 END {SetAdrFieldValue};

 PUBLIC PROCEDURE Encode_RegName(VAR Value              : STRING[];
                                     PrtnrTyp           : tPartnerType;
                                     HeadFirm           : LIKE(Firm.Firm);
                                     PersonFullName,
                                     BranchName,
                                     ContractorBriefName,
                                     BranchFullName     : STRING[]);
 BEGIN
  L_Prop.putRES(Value, GetPartnerType_AsStr(PrtnrTyp));
  L_Prop.putRES(Value, L_r2r.Put("FirmPro", "Firm", HeadFirm));
  L_Prop.putREV(Value, PersonFullName);
  L_Prop.putREV(Value, BranchName);
  L_Prop.putREV(Value, ContractorBriefName);
  L_Prop.putREV(Value, BranchFullName);
 END {Encode_RegName};

 PRIVATE PROCEDURE formGet_RegName();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF Fields("PrtnrTyp").Value = pt_Branch THEN
   Encode_RegName(FirmPro.Value,
                  Fields("PrtnrTyp"           ).Value,
                  Fields("HeadFirm"           ).Value,
                  Fields("PersonFullName"     ).Value,
                  Fields("BranchName"         ).Value,
                  Fields("ContractorBriefName").Value,
                  Fields("BranchFullName"     ).Value);
  ELSE
   Encode_RegName(FirmPro.Value,
                  Fields("PrtnrTyp"           ).Value,
                  EMPTYOF(Firm.Firm),
                  Fields("PersonFullName"     ).Value,
                  EMPTYOF(STRING[]),
                  Fields("ContractorBriefName").Value,
                  EMPTYOF(STRING[]));
  END;
 END {formGet_RegName};

 PUBLIC PROCEDURE GetDataFromForm(Prop: LIKE(Property.Property));
 BEGIN
  SETEMPTY(FirmPro.Value);
  IF Prop = P_RegName THEN
   formGet_RegName();
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(FirmPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE FirmPro_OnBeforeEdIns();
  VAR
   trgWin: FORMWINDOW;
 BEGIN
  IF    FirmPro.Property = P_RegName THEN
   trgWin:=GetParentFrmManCn();
   IF ~!trgWin THEN
    FirmPro.DocNum  :=Str.Condense(trgWin.Zones(0).Fields("Firm_RegName_DocSer").Value + " " + trgWin.Zones(0).Fields("Firm_RegName_DocNum").Value);
    FirmPro.DocGiveS:=trgWin.Zones(0).Fields("Firm_RegName_DocGiveS").Value;
    FirmPro.DocGiveD:=trgWin.Zones(0).Fields("Firm_RegName_DocGiveD").Value;
    FirmPro.DocExpD :=trgWin.Zones(0).Fields("Firm_RegName_DocExpD").Value;
    REPLACE(FirmPro);
   END;
  ELSIF FirmPro.Property = P_KPP THEN
   IF IsOwnFirm(FirmPro.Firm) THEN
    L_StdFrm.BlueHalt(" ' ࣠樨' ᫥ 㪠뢠  ᢮⢠ ந⢥ 頤");
   END;
  END;
 END {FirmPro_OnBeforeEdIns};

 PUBLIC PROCEDURE FirmPro_OnBeforeEdit();
 BEGIN
  FirmPro_OnBeforeEdIns();
 END {FirmPro_OnBeforeEdit};

 PUBLIC PROCEDURE FirmPro_OnBeforeInsert();
 BEGIN
  FirmPro_OnBeforeEdIns();
 END {FirmPro_OnBeforeInsert};

 PUBLIC PROCEDURE FirmPro_OnAfterEdIns();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  IF    (FirmPro.Property = P_INN) THEN
   PutProValue(0, P_INN);
   FirmPro.SpdSrchV:=FirmPro.Value;
   REPLACE(FirmPro);
  ELSIF (FirmPro.Property = P_RegName) THEN
   L_General.Assert(~!FirmPro.Value, "⮥ 祭 ᢮⢠ " + FirmPro.Property + "  ᪠");
   PutProValue(0, FirmPro.Property);
   IF ~!GetParentFrmManCn() THEN
    CALL(FrmManCn.SetDocReq(L_WDO.getParentWindow()));
   ELSE
    Fields:=RTI.Get().CurWindow.ParentZone.Window.ParentZone.Fields;
    CALL(Firm.Firm_0_SetFields(Fields, 1));
   END;
  END;
 END {FirmPro_OnAfterEdIns};

 PUBLIC PROCEDURE FirmPro_OnBeforeDelete();
 BEGIN
  IF    FirmPro.Property = P_INN THEN
   PutProValue(1, P_INN);
  ELSIF FirmPro.Property = P_RegName THEN
   PutProValue(1, P_RegName);
  END;
 END {FirmPro_OnBeforeDelete};

 PUBLIC PROCEDURE FirmPro_OnAfterEdit();
 BEGIN
  FirmPro_OnAfterEdIns();
 END {FirmPro_OnAfterEdit};

 PUBLIC PROCEDURE FirmPro_OnAfterInsert();
 BEGIN
  FirmPro_OnAfterEdIns();
 END {FirmPro_OnAfterInsert};

 PRIVATE PROCEDURE _Assert(Cond: SCAL[2]; ErrText, Where: STRING[]);
 BEGIN
  L_General.Assert(Cond, Where + L_StdFrm.HR() + ErrText);
 END {_Assert};

 PRIVATE PROCEDURE CheckAcnt(Acnt: STRING[]; Where: STRING[]);
 BEGIN
  _Assert(Str.Length(Acnt)=20,         "⢮    ࠢ 20", Where);
  _Assert(Str.Slice(Acnt, 5, 3)="810", "    810",           Where);
 END {CheckAcnt};

 PRIVATE PROCEDURE CheckCheckDigit(Seq: STRING[]; Where: STRING[]);
  CONST
   VK="71371371371371371371371";
  VAR
   i, S: NUMERIC[0];
 BEGIN
  i:=0; S:=0;
  WHILE i<Str.Length(Seq) DO
   INC(S, STRTOFLD(Seq[i], NUMERIC) * STRTOFLD(VK[i], NUMERIC));
   INC(i);
  END;
  S:=S MOD 10;
  _Assert(S=0, "ࠢ    |( 室 ஢ઠ ஫쭮 ࠧ鸞)" +
               L_StdFrm.HR() + " ᭨ ࠢ ४", Where);
 END {CheckCheckDigit};

 PUBLIC PROCEDURE IsRKC(_BIC: LIKE(BankLog.BIC)): SCAL[2];
  VAR
   _Tmp: STRING[];
 BEGIN
  _Tmp:=Str.Slice(_BIC, 6, 3);
  RETURN (_Tmp="002") | (_Tmp="001") | (_Tmp="000");
 END {IsRKC};

 PUBLIC PROCEDURE FirmAcntBIC(D: DATE): LIKE(BankLog.BIC);
 BEGIN
  IF ~!FirmAcnt.BankBrn THEN
   CONFORM(FirmAcnt, BankBrn);
   HISTCONF(D, BankBrn, BankBrnL);
   IF ~!BankBrnL.BIC THEN
    RETURN BankBrnL.BIC;
   END;
  END; (* IF ~!FirmAcnt.BankBrn... *)
  CONFORM(FirmAcnt, Bank);
  HISTCONF(D, Bank, BankLog);
  IF OCCURE(BankLog) THEN
   RETURN BankLog.BIC;
  END;
 END {FirmAcntBIC};

 PUBLIC PROCEDURE CheckCorAcnt(_BIC    : LIKE(BankLog.BIC);
                               _CorAcnt: LIKE(BankLog.CorAcnt));
  VAR
   _Where,
   _WhereB: STRING[];
   _NumTmp: NUMERIC[0];
 BEGIN
  IF Bank.Bank # FICT_BANK THEN
   _Where :="ᯮ᪨   "+Bank.Bank;
   _WhereB:="  "+Bank.Bank;
   _Assert(L_Str.TestStrAlowChar(_BIC,      "09"), " ஢ ᨬ", _WhereB);
   IF ~!_CorAcnt THEN
    _Assert(L_Str.TestStrAlowChar(_CorAcnt, "09"), " ஢ ᨬ", _Where);
    IF Str.Length(_CorAcnt)>9 THEN
     CheckAcnt(_CorAcnt, _Where);
     _Assert(Str.Slice(_CorAcnt, 0, 3)="301", "   稭  301", _Where);
     _Assert(Str.Length(_BIC)=9, "⢮   ࠢ 9", _WhereB);
     _NumTmp:=STRTOFLD(Str.Slice(_BIC, 6, 3), NUMERIC);
     _Assert((050<=_NumTmp) & (_NumTmp<=999), " 稨 ᯮ᪮ |   稢 祭  050  999", _WhereB);
     _Assert(Str.Slice(_BIC, 0, 2)="04", "   稭  '04'( ᨨ)", _WhereB);
     _Assert(Str.Slice(_CorAcnt, 17, 3)=Str.Slice(_BIC, 6, 3), "   ᮮ⢥ ", _Where);
     CheckCheckDigit("0"+Str.Slice(_BIC, 4, 2)+_CorAcnt, _Where);
    END;
   ELSE
    IF Str.Length(_BIC)=9 THEN
     _Assert(IsRKC(_BIC), " ⢨ ᯮ᪮ |   稢  002,  001,  000", _WhereB);
    END;
   END;
  END;
 END {CheckCorAcnt};

 PUBLIC PROCEDURE CheckDigitBankAccount(D: DATE; trgAcntA: LIKE(FirmAcnt.AcntA); trgWhere: STRING[]);
  VAR
   Tmp     : STRING[23];
   _CorAcnt: LIKE(BankLog.CorAcnt);
   _BIC    : LIKE(BankLog.BIC);
 BEGIN
  CheckAcnt(trgAcntA, trgWhere);
  TRY [RESTORE_CURSORS(RC_ON)]
   CONFORM(FirmAcnt, Bank);
   HISTCONF(D, Bank, BankLog);
   IF OCCURE(BankLog) THEN
    L_General.Assert(D < BankLog.Till, " " + BankLog.Bank +
                               "    " + L_DatTim.DateStr(D));
    _CorAcnt:=BankLog.CorAcnt;
    _BIC    :=BankLog.BIC;
   ELSE
    SETEMPTY(_CorAcnt, _BIC);
   END;
   Tmp:=" "+FirmAcnt.Bank;
   IF ~!FirmAcnt.BankBrn THEN
    Tmp:=Tmp+" 䨫 "+FirmAcnt.BankBrn;
    CONFORM(FirmAcnt, BankBrn);
    HISTCONF(D, BankBrn, BankBrnL);
    L_General.Assert(OCCURE(BankBrnL) & (D < BankBrnL.Till),
                     " ப ४⮢ 䨫    " +
                     L_DatTim.DateStr(D) + "|" + Tmp);
    IF ~!BankBrnL.CorAcnt THEN
     _CorAcnt:=BankBrnL.CorAcnt;
    END;
    IF ~!BankBrnL.BIC THEN
     _BIC:=BankBrnL.BIC;
    END;
   END; (* IF ~!FirmAcnt.BankBrn... *)
   L_General.Assert(~!_BIC, "     :"+L_DatTim.DateStr(D)+"|"+Tmp);
   _Assert(Str.Length(_BIC)=9, "⢮   ࠢ 9", "  "+Bank.Bank);
   IF ~!_CorAcnt THEN
    Tmp:=    Str.Slice(_BIC, 6, 3)+trgAcntA;
   ELSE
    Tmp:="0"+Str.Slice(_BIC, 4, 2)+trgAcntA;
   END;
   CheckCheckDigit(Tmp, trgWhere);
  EXCEPT
  END; (* TRY *)
 END {CheckDigitBankAccount};

 PUBLIC PROCEDURE CheckAcntA(D: DATE);
  VAR
   Where: STRING[];
 BEGIN
  IF (FirmAcnt.Bank # FICT_BANK) & (FirmAcnt.Type # fat_CashOffice) & (FirmAcnt.Type # fat_OprCashDsk) THEN
   Where:="᪨  "+FirmAcnt.FirmAcnt+" ࠣ "+FirmAcnt.Firm;
   _Assert(L_Str.TestStrAlowChar(FirmAcnt.AcntA, "09"), " ஢ ᨬ", Where);
   IF Str.Length(FirmAcnt.AcntA) > 9 THEN
    CheckDigitBankAccount(D, FirmAcnt.AcntA, Where);
   END; (* IF Str.Length(FirmAcnt.AcntA)... *)
  END;
 END {CheckAcntA};

 PRIVATE PROCEDURE CheckBankIsActive(D        : DATE;
                                     LeadFile : STRING[];
                                     LogFile  : STRING[];
                                     trgFirm  : LIKE(FirmAcnt.Firm);
                                     _FirmAcnt: LIKE(FirmAcnt.FirmAcnt);
                                     _Str     : STRING[]);
  VAR
   _Text: STRING[];
 BEGIN
  _Text:="᪨   ஬ "+_FirmAcnt+" ࠣ "+trgFirm +
         "|  饬  " + L_DatTim.DateStr(D) + _Str;
  SAVE(^LeadFile);
  SAVE(^LogFile);
  CONFORM(FirmAcnt, ^LeadFile);
  HISTCONF(D, ^LeadFile, ^LogFile);
  L_General.Assert(OCCURE(^LogFile), _Text);
  L_General.Assert(^(LogFile + ".Till") > D, _Text);
  RESTORE(^LogFile);
  RESTORE(^LeadFile);
 END {CheckBankIsActive};

 PUBLIC PROCEDURE SoftCheckFirmAcnt(D        : DATE;
                                    trgFirm  : LIKE(FirmAcnt.Firm);
                                    _FirmAcnt: LIKE(FirmAcnt.FirmAcnt)): SCAL[2];
 BEGIN
  L_General.Assert(~!_FirmAcnt, "  ᪨  ࠣ "+trgFirm);
  L_General.Assert(_FirmAcnt # 00, " ᪮  ࠣ "+trgFirm+" 㪠 ");
  L_General.Assert(SEARCH(FirmAcnt, Firm, trgFirm, _FirmAcnt), " ࠣ "+trgFirm+"  ᪨   ஬ "+_FirmAcnt);
  IF ~!FirmAcnt.BankBrn THEN
   CheckBankIsActive(D, "BankBrn", "BankBrnL", trgFirm, _FirmAcnt, " 䨫 ");
  ELSE
   CheckBankIsActive(D, "Bank",    "BankLog",  trgFirm, _FirmAcnt, " ");
  END;
  RETURN L_DatTim.IsActive(D, FirmAcnt.Begin, FirmAcnt.Till);
 END {SoftCheckFirmAcnt};

 PUBLIC PROCEDURE CheckFirmAcnt(D        : DATE;
                                trgFirm  : LIKE(FirmAcnt.Firm);
                                _FirmAcnt: LIKE(FirmAcnt.FirmAcnt));
 BEGIN
  L_General.Assert(SoftCheckFirmAcnt(D, trgFirm, _FirmAcnt), " 騩  ࠣ "+trgFirm);
 END {CheckFirmAcnt};

 PRIVATE PROCEDURE DelQuMark(S: STRING[]): STRING[];
  VAR
   i, l: NUMERIC[0];
 BEGIN
  i:=0; l:=Str.Length(S);
  WHILE i<=l DO
   IF ~L_Str.TestStrAlowChar(S[i], "") & ~L_Str.TestStrAlowChar(S[i], "AZ") &
      ~L_Str.TestStrAlowChar(S[i], "09") THEN
    S:=Str.Delete(S, i, 1);
   ELSE
    INC(i);
   END;
  END;
  RETURN S;
 END {DelQuMark};

 PRIVATE PROCEDURE CmpBank_Msg(Strong   : SCAL[2];
                               _What    : STRING[];
                               _BIC     : LIKE(BIC.BIC);
                               _Bank    : LIKE(Bank.Bank);
                               _ValBank,
                               _ValBIC  : STRING[]);
 BEGIN
  L_StdFrm.ConditionalCHOICE("⫨砥 ᪨ ४ - " + _What + " ( " + _BIC + "):" +
                             Str.Align("|  "+_Bank+" - ",    68, LEFT) + "|" + _ValBank +
                             Str.Align("| ࠢ筨   - ", 68, LEFT) + "|" + _ValBIC,
                             ~Strong);
 END {CmpBank_Msg};

 PRIVATE PROCEDURE CmpBankProps(_Bank   : LIKE(Bank.Bank);
                                _BIC    : LIKE(BIC.BIC);
                                _CorAcnt: LIKE(BIC.CorAcnt);
                                _Name   : STRING[]);
 BEGIN
  IF SELECT(BIC, BIC) THEN
   IF SEARCH(BIC, BIC, _BIC) THEN
    IF ~!_CorAcnt & (_CorAcnt # BIC.CorAcnt) THEN
     CmpBank_Msg(1, "ᯮ.", _BIC, _Bank, _CorAcnt, BIC.CorAcnt);
    END;
    IF ~!_Name & (DelQuMark(Str.Cap(_Name)) # DelQuMark(Str.Cap(BIC.Name))) THEN
     CmpBank_Msg(0, " ", _BIC, _Bank, Str.Cap(_Name), BIC.Name);
    END;
   ELSE
    STDMSG(" "+_BIC+"   ࠢ筨  :| "+_Bank+" "+_Name, CHOICE);
   END; (* IF SEARCH... *)
  END;
 END {CmpBankProps};

 PRIVATE PROCEDURE GetFirmAcntData(    D    : DATE;
                                   VAR _Name: STRING[];
                                   VAR _Bank: STRING[][2];
                                   VAR _Acnt: STRING[][3];
                                   VAR _BIC_: STRING[];
                                   VAR _INN_: STRING[];
                                   wCmpByBIC: SCAL[2]);
 BEGIN
  SETEMPTY(_Acnt, _BIC_, _Bank);
  CONFORM(FirmAcnt, Bank, Firm);
  HISTCONF(D, Bank, BankLog);
  IF Bank.Bank # FICT_BANK THEN
   IF D >= L_General.DenominationDate() THEN
    CheckAcnt(FirmAcnt.AcntA, "᪨  " + FirmAcnt.FirmAcnt + " ࠣ " + FirmAcnt.Firm);
    IF OCCURE(BankLog) & ~!BankLog.CorAcnt THEN
     CheckAcnt(BankLog.CorAcnt, "ᯮ᪨   " + Bank.Bank);
    END;
   END;
  END;
  CheckAcntA(D);
  _INN_               :=FP_INN(Firm.Firm, D);
  L_General.Assert(!_INN_ | L_Russia.CheckINN(_INN_), "४  ࠣ " + Firm.Firm);
  _Acnt[fa_AcntInAcnt]:=FirmAcnt.AcntA;
  IF OCCURE(BankLog) THEN
   _Acnt[fa_AcntInBankAcnt]:=BankLog.CorAcnt;
   _BIC_                   :=BankLog.BIC;
   _Bank[fa_BankInBank]    :=L_Str.StrFormat(BankLog.RegName) + " " + BankLog.Region;
  END;
  IF ~!FirmAcnt.Name THEN
   _Name:=FirmAcnt.Name;
  ELSIF D >= 01\05\2010 THEN
   _Name:=FP_PersonFullName_wBranchName(Firm.Firm, D);
  ELSE
   _Name:=FP_FirmName(Firm.Firm, D);
  END;
  IF ~!FirmAcnt.BankBrn THEN
   CONFORM(FirmAcnt, BankBrn);
   HISTCONF(D, BankBrn, BankBrnL);
   IF !BankBrnL.BIC THEN
    IF ~!BankBrnL.CorAcnt THEN
     _Acnt[fa_AcntInAcnt]    :=BankBrnL.CorAcnt;
     _Acnt[fa_AcntInBankAcnt]:=BankLog.CorAcnt;
     _Acnt[fa_AcntInName]    :=FirmAcnt.AcntA;
    END;
    _Bank[fa_BankInName]:=Str.Condense(L_Str.StrFormat(BankBrnL.RegName) + " " + BankBrnL.Region);
   ELSE
    L_General.Assert(~!BankBrnL.CorAcnt,
                     " 稨 ᮡ⢥  䨫|" +
                     "   ᯮ᪨ |" +
                     " " + BankBrn.Bank + " 䨫 " + BankBrn.BankBrn);
    _BIC_                   :=BankBrnL.BIC;
    _Acnt[fa_AcntInBankAcnt]:=BankBrnL.CorAcnt;
    _Bank[fa_BankInBank]    :=L_Str.StrFormat(BankBrnL.RegName) + " " +
                              BankBrnL.Region;
   END;
  END; (* IF ~!FirmAcnt.BankBrn... *)

  IF Bank.Bank # FICT_BANK THEN
   CheckCorAcnt(_BIC_, _Acnt[fa_AcntInBankAcnt]);
   IF wCmpByBIC THEN
    CmpBankProps(Bank.Bank, _BIC_, _Acnt[fa_AcntInBankAcnt], _Bank[fa_BankInBank]);
   END;
  END;
 END {GetFirmAcntData};

 PUBLIC PROCEDURE GetFirmData(    D    : DATE;
                              VAR _Name: STRING[];
                              VAR _Bank: STRING[];
                              VAR _Acnt: STRING[][2];
                              VAR _BIC_: STRING[];
                              VAR _INN_: STRING[];
                              wCmpByBIC: SCAL[2]);
  VAR
   Banks: STRING[][2];
   Acnts: STRING[][3];
 BEGIN
  GetFirmAcntData(D, _Name, Banks, Acnts, _BIC_, _INN_, wCmpByBIC);

  _Acnt[fa_AcntInAcnt]    :=Acnts[fa_AcntInAcnt];
  _Acnt[fa_AcntInBankAcnt]:=Acnts[fa_AcntInBankAcnt];
  IF ~!Acnts[fa_AcntInName] THEN
   _Name:=_Name + " / " + Acnts[fa_AcntInName];
  END;

  _Bank:=Banks[fa_BankInBank];
  IF ~!Banks[fa_BankInName] THEN
   _Name:=_Name + " " + Banks[fa_BankInName];
  END;
 END {GetFirmData};

 PUBLIC PROCEDURE FirmAcntAsStr(D: DATE): STRING[];
  VAR
   _Str,
   _BIC_,
   _INN_,
   _Name : STRING[];
   Banks : STRING[][2];
   Acnts : STRING[][3];
 BEGIN
  GetFirmAcntData(D, _Name, Banks, Acnts, _BIC_, _INN_, 0);
  IF    ~!Acnts[fa_AcntInName] THEN
   _Str:=Acnts[fa_AcntInName] + "  " + Banks[fa_BankInName] + ",  " +
         Acnts[fa_AcntInAcnt] + "  ";
  ELSIF ~!Banks[fa_BankInName] THEN
   _Str:=Acnts[fa_AcntInAcnt] + "  " + Banks[fa_BankInName] + ", ";
  ELSE
   _Str:=Acnts[fa_AcntInAcnt] + "  ";
  END;
  _Str:=_Str + Banks[fa_BankInBank] + ",  " + _BIC_ + ", / " +
        Acnts[fa_AcntInBankAcnt];
  RETURN _Str;
 END {FirmAcntAsStr};

 PUBLIC PROCEDURE FirmHasSimplifiedTaxation(trgFirm: LIKE(Firm.Firm); D: DATE): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(L_Env.FirmHasSimplifiedTaxation);
  IF ~!Local THEN
   RETURN Local(trgFirm, D);
  ELSE
   RETURN 0;
  END;
 END {FirmHasSimplifiedTaxation};

 PRIVATE PROCEDURE _GetFirmProperty(trgFirm: LIKE(Firm.Firm);
                                    OnDate : DATE;
                                    Proc   : PROC): STRING[];
  VAR
   val: STRING[];
 BEGIN
  TRY
   L_General.DisableDebuggerExceptionBreak();
   val:=Proc(trgFirm, OnDate);
  EXCEPT
  ON Exc: Exc_Raise DO
   IF Exc.ErrorCode = -1 THEN
    IF fps_Condition = L_MSO.fps_Soft THEN
     val:="";
    ELSE
     L_General.Error(Exc.MsgOriginalText);
    END;
   ELSE
    RAISE();
   END; (* IF *)
  END; (* TRY *)
  RETURN val;
 END {_GetFirmProperty};

 PRIVATE PROCEDURE GetFirmProperty(trgFirm : LIKE(Firm.Firm);
                                   OnDate  : DATE;
                                   Property: STRING[]): STRING[];
 BEGIN
  RETURN _GetFirmProperty(trgFirm, OnDate, PROCREF("FP_" + Property));
 END {GetFirmProperty};

 PRIVATE PROCEDURE PropToSet(VariableName, Condition: STRING[]): SCAL[2];
 BEGIN
  IF !Condition                                      |
     (Str.Item(Condition, ", ", 0) = L_MSO.fps_Soft_asStr) |
     (Str.Item(Condition, ", ", 0, Str.Pos(Condition, VariableName)) = VariableName) THEN
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END; {PropToSet}

 PRIVATE PROCEDURE fpcs_Single(Alias       : STRING[];
                               trgFirm     : LIKE(Firm.Firm);
                               OnDate      : DATE;
                               VariableName,
                               _subplist,
                               Condition   : STRING[]);
 BEGIN
  IF PropToSet(VariableName, Condition) THEN
   L_MSO.SetValueDerivatives(Alias + "." + VariableName,
                             GetFirmProperty(trgFirm, OnDate, VariableName),
                             _subplist);
  END;
 END {fpcs_Single};

 PRIVATE PROCEDURE mfcs_Single(Alias       : STRING[];
                               trgFirm     : LIKE(Firm.Firm);
                               OnDate      : DATE;
                               VariableName,
                               _subplist,
                               Condition   : STRING[]);
  VAR
   _MyFirm: LIKE(MyFirm.MyFirm);
   Prc    : PROC;
 BEGIN
  IF PropToSet(VariableName, Condition) THEN
   _MyFirm:=GetMyFirmOfFirm(trgFirm);
   IF ~!_MyFirm THEN
    Prc:=PROCREF("P_MyFirm."+VariableName);
    L_MSO.SetValueDerivatives(Alias + "." + VariableName,
                              Prc(_MyFirm, OnDate),
                              _subplist);
   END;
  END;
 END {mfcs_Single};

 PRIVATE PROCEDURE cs_SetAttr(Alias, VariableName, Name, INN, PostName, ExtWrkTel: STRING[]);
 BEGIN
  L_MSO.SetValueDerivatives(Alias + "." + VariableName + ".Name", Name, "SetManNameVar");
  L_MSO.wordSetVar(Alias + "." + VariableName + ".INN", INN);
  L_MSO.wordSetVar(Alias + "." + VariableName + ".Post.Name", PostName);
  L_MSO.wordSetVar(Alias + "." + VariableName + ".ExtWrkTel", ExtWrkTel);
 END {cs_SetAttr};

 PRIVATE PROCEDURE mpcs_Attr_byGivenFirmCtc(Alias       : STRING[];
                                            OnDate      : DATE;
                                            VariableName: STRING[]);
 BEGIN
  cs_SetAttr(Alias, VariableName, FirmCtc.Name, GetManINNByFirmCtc(), FirmCtc.ECKName,
             L_ctc.GetCtcVal(SM_Soft, FirmCtc.Contact, OnDate, L_ctc.cvc_Work, L_ctc.cvt_PhonePST));
 END {mpcs_Attr_byGivenFirmCtc};

 PRIVATE PROCEDURE mpcs_Attr(Alias       : STRING[];
                             trgFirm     : LIKE(Firm.Firm);
                             OnDate      : DATE;
                             VariableName: STRING[];
                             ckt         : L_ctc.tCKType;
                             Condition   : STRING[];
                             ForceEmpty  : SCAL[2]);
 BEGIN
  IF PropToSet(VariableName, Condition) THEN
   IF ForceEmpty | ~StandOnFirmCtcByKindType(SM_Soft, trgFirm, OnDate, ckt) THEN
    cs_SetAttr(Alias, VariableName, "", "", "", "");
   ELSE
    mpcs_Attr_byGivenFirmCtc(Alias, OnDate, VariableName);
   END;
  END;
 END {mpcs_Attr};

 PRIVATE PROCEDURE mfcs_Attr(Alias       : STRING[];
                             trgFirm     : LIKE(Firm.Firm);
                             OnDate      : DATE;
                             VariableName: STRING[];
                             Condition   : STRING[];
                             ForceEmpty  : SCAL[2]);
  VAR
   _MyFirm: LIKE(MyFirm.MyFirm);
   trgTSN: LIKE(Staff.TSN);
 BEGIN
  IF PropToSet(VariableName, Condition) THEN
   _MyFirm:=GetMyFirmOfFirm(trgFirm);
   IF ~!_MyFirm THEN
    trgTSN:=P_MyFirm.GetTSNByMFPro(_MyFirm, OnDate, ^("P_MyFirm.P_" + VariableName), 0);
   ELSE
    SETEMPTY(trgTSN);
   END;
   IF ForceEmpty | !trgTSN THEN
    cs_SetAttr(Alias, VariableName, "", "", "", "");
   ELSE
    cs_SetAttr(Alias, VariableName, GetManAttrByTSN(trgTSN, OnDate, mpt_ManName),
                                    GetManAttrByTSN(trgTSN, OnDate, mpt_ManINN),
                                    GetManAttrByTSN(trgTSN, OnDate, mpt_ManPostName),
                                    GetManAttrByTSN(trgTSN, OnDate, mpt_ManExtWrkTel));
   END;
  END;
 END {mfcs_Attr};

 PRIVATE PROCEDURE SetFirmData_Simple(Alias    : STRING[];
                                      trgFirm  : LIKE(Firm.Firm);
                                      OnDate   : DATE;
                                      _Acnt    : LIKE(FirmAcnt.FirmAcnt);
                                      Condition: STRING[]);
  VAR
   _bankreq,
   _name,
   _bank,
   _bic_,
   _inn_              : STRING[];
   _acnt              : STRING[][2];
   _Acnt_Manner       : SCAL[2];
   PrtnrTyp           : tPartnerType;
   HeadFirm           : LIKE(Firm.Firm);
   PersonFullName,
   BranchName,
   BranchFullName,
   ContractorBriefName: STRING[];
   frmMan             : LIKE(Man.Man);
 BEGIN
  APP.Get().NewPrompt("㧪 ᢥ  ࠣ " + trgFirm);
  AccessFirm(trgFirm);
  L_MSO.wordSetVarsByFile_wAlias("Firm", Alias);
  IF ~!_Acnt THEN
   CheckFirmAcnt(OnDate, trgFirm, _Acnt);
   GetFirmData(OnDate, _name, _bank, _acnt, _bic_, _inn_, 0);
   _bankreq:=FirmAcntAsStr(OnDate);
  ELSE
   _inn_:=GetFirmProSoft(trgFirm, OnDate, P_INN);
   IF ContractorIsPhysicalBody(trgFirm, OnDate) THEN
    SETEMPTY(_name);
   ELSE
    _name   :=L_MSO.NoValuePrefix + "       ࠣ " + trgFirm + "  " + L_DatTim.DateStr(OnDate);
   END;
   _acnt[0]:=_name;
   _acnt[1]:=_name;
   _bank   :=_name;
   _bic_   :=_name;
   _bankreq:=_name;
  END;
  L_MSO.wordSetVar(Alias+".AcntHolderName", _name);
  L_MSO.wordSetVar(Alias+".INN",            _inn_);
  L_MSO.wordSetVar(Alias+".AcntA",          _acnt[0]);
  L_MSO.wordSetVar(Alias+".Bank.RegName",   _bank);
  L_MSO.wordSetVar(Alias+".Bank.CorAcnt",   _acnt[1]);
  L_MSO.wordSetVar(Alias+".Bank.BIC",       _bic_);
  L_MSO.wordSetVar(Alias+".BankReq",        _bankreq);

  GetRegNameValues(trgFirm, OnDate, PrtnrTyp, HeadFirm, PersonFullName, BranchName, ContractorBriefName, BranchFullName);

  L_MSO.wordSetVar(Alias+".RegName",                    ContractorBriefName); (*প  蠡*)
  L_MSO.wordSetVar(Alias+".PersonFullName_wBranchName", FP_PersonFullName_wBranchName(trgFirm, OnDate));
  L_MSO.wordSetVar(Alias+".PersonFullName",             PersonFullName);
  L_MSO.wordSetVar(Alias+".BranchName",                 BranchName);
  L_MSO.wordSetVar(Alias+".ContractorBriefName",        ContractorBriefName);
  L_MSO.wordSetVar(Alias+".ContractorIsPhysicalBody",   PartnerTypeIsPhysicalBody(PrtnrTyp));
  L_MSO.wordSetVar    (Alias+".RegName.DocNum",         FirmPro.DocNum);
  L_MSO.wordSetVar    (Alias+".RegName.DocGiveS",       FirmPro.DocGiveS);
  L_MSO.wordSetDateVar(Alias+".RegName.DocGiveD",       FirmPro.DocGiveD);
  L_MSO.wordSetDateVar(Alias+".RegName.DocExpD",        FirmPro.DocExpD);

  fps_Condition:=PropToSet(L_MSO.fps_Soft_asStr, Condition);

  fpcs_Single(Alias, trgFirm, OnDate, "StaffDepPhone",         "",      Condition);
  fpcs_Single(Alias, trgFirm, OnDate, "AcntPhone",             "",      Condition);
  fpcs_Single(Alias, trgFirm, OnDate, "Phone",                 "",      Condition);
  fpcs_Single(Alias, trgFirm, OnDate, "ClrPhone",              "",      Condition);
  fpcs_Single(Alias, trgFirm, OnDate, "Fax",                   "",      Condition);
  fpcs_Single(Alias, trgFirm, OnDate, "email",                 "",      Condition);
  fpcs_Single(Alias, trgFirm, OnDate, "Site",                  "",      Condition);
  fpcs_Single(Alias, trgFirm, OnDate, "BasisOfLeaderActivity", "",      Condition);
  fpcs_Single(Alias, trgFirm, OnDate, "KPP",                   "",      Condition);
  fpcs_Single(Alias, trgFirm, OnDate, "HeadFirm",              "",      Condition);
  fpcs_Single(Alias, trgFirm, OnDate, "OKPO",                  "",      Condition);
  fpcs_Single(Alias, trgFirm, OnDate, "OGRN",                  "",      Condition);

  mfcs_Single(Alias, trgFirm, OnDate, "TaxDepCode",            "",      Condition);
  mfcs_Single(Alias, trgFirm, OnDate, "TaxDep",                "",      Condition);

  mpcs_Attr(Alias, trgFirm, OnDate, "Leader", L_ctc.ckt_Leader,   Condition, 0);
  mpcs_Attr(Alias, trgFirm, OnDate, "Acnt",   L_ctc.ckt_MainAcnt, Condition, 0);

  mfcs_Attr(Alias, trgFirm, OnDate, "StaffDepChief", Condition, 0);
  mfcs_Attr(Alias, trgFirm, OnDate, "MainEngineer",  Condition, 0);

  mpcs_Attr(Alias, trgFirm, OnDate, "ContactPerson", L_ctc.ckt_DftCtcPerson, Condition, 0);

  _Acnt_Manner:=Acnt_Manner(trgFirm, OnDate);
  L_MSO.wordSetVar(Alias + ".Acnt.Manner",       L_Str.IntStr(_Acnt_Manner));
  IF _Acnt_Manner THEN
   mpcs_Attr(Alias, trgFirm, OnDate, "AcntWLeader", L_ctc.ckt_MainAcnt, Condition, 1);
   L_MSO.wordSetVar(Alias + ".AcntWLeader.Name",       Acnt_MagicText_v1);
   L_MSO.wordSetVar(Alias + ".AcntWLeader.Name.Short", Acnt_MagicText_v1);
(* 02.03.2004 09:36:20 POLAK\San -  ᮢ⨬  묨 蠡 *)
   L_MSO.wordSetVar(Alias + ".AcntName",               "");
   L_MSO.wordSetVar(Alias + ".AcntName.Short",         "");
  ELSE
   mpcs_Attr(Alias, trgFirm, OnDate, "AcntWLeader", L_ctc.ckt_MainAcnt, Condition, 0);
  END;

  IF L_ctc.StandOnAdr_Reg(OnDate, trgFirm, 0) THEN
   L_ctc.curCtcAdr_Set_glb_AdrVar();
   L_Russia.wordSetAddr_byPart(Alias+".Addr");
  ELSE
   frmMan:=GetManOfFirm(OnDate, trgFirm);
   IF ~!frmMan & L_Man.AccessManAdr(frmMan, OnDate, L_Russia.at_RgMA) THEN
    L_Man.curManAdr_Set_glb_AdrVar();
    L_Russia.wordSetAddr_byPart(Alias+".Addr");
   ELSE
    L_Russia.Set_glb_AdrVar_ToEmpty();
    L_Russia.wordSetAddr_byPart(Alias+".Addr");
   END;
  END;

  IF L_ctc.StandOnAdr_Fct(OnDate, trgFirm, 0) THEN
   L_ctc.curCtcAdr_Set_glb_AdrVar();
   L_Russia.wordSetAddr_byPart(Alias+".FAddr");
  ELSE
   L_Russia.Set_glb_AdrVar_ToEmpty();
   L_Russia.wordSetAddr_byPart(Alias+".FAddr");
  END;

  IF L_ctc.StandOnAdr_Pst(OnDate, trgFirm, 0) THEN
   L_ctc.curCtcAdr_Set_glb_AdrVar();
   L_Russia.wordSetAddr_byPart(Alias+".PAddr");
  ELSE
   L_Russia.Set_glb_AdrVar_ToEmpty();
   L_Russia.wordSetAddr_byPart(Alias+".PAddr");
  END;
 END {SetFirmData_Simple};

 PRIVATE PROCEDURE GetFirmAcntSoft(trgFirm: LIKE(Firm.Firm); D: DATE): LIKE(FirmAcnt.FirmAcnt);
  VAR
   Result: LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  SAVE(FirmAcnt);
  IF SoftAccessSilentFirmAcnt(trgFirm, D) THEN
   Result:=FirmAcnt.FirmAcnt;
  ELSE
   L_General.Assert(~IsOwnFirm(trgFirm), "ࠣ " + trgFirm + ":    㬮砭  "+L_DatTim.DateStr(D));
   SETEMPTY(Result);
  END;
  RESTORE(FirmAcnt);
  RETURN Result;
 END {GetFirmAcntSoft};

 PUBLIC PROCEDURE SetFirmData_wAlias(Alias    : STRING[];
                                     trgFirm  : LIKE(Firm.Firm);
                                     OnDate   : DATE;
                                     trgAcnt  : LIKE(FirmAcnt.FirmAcnt);
                                     Condition: STRING[]);
  VAR
   headFirm,
   persFirm: LIKE(Firm.Firm);
   persAcnt: LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  SetFirmData_Simple(Alias, trgFirm, OnDate, trgAcnt, Condition);
  SAVE(Firm);
  IF PropToSet("HeadFirm", Condition) THEN
   headFirm:=FP_HeadFirm(trgFirm, OnDate);
   IF ~!headFirm THEN
    SetFirmData_Simple(Alias+".HeadFirm", headFirm, OnDate, "", "");
   END;
  END;
  IF FP_PrtnrTyp(trgFirm, OnDate) = pt_Branch THEN
   persFirm:=FP_HeadFirm(trgFirm, OnDate);
   persAcnt:=GetFirmAcntSoft(persFirm, OnDate)
  ELSE
   persFirm:=trgFirm;
   persAcnt:=trgAcnt;
  END;
  SetFirmData_Simple(Alias+".Person", persFirm, OnDate, persAcnt, Condition);
  RESTORE(Firm);
 END {SetFirmData_wAlias};

 PUBLIC PROCEDURE SetFirmContactPersonData_wAlias(Alias    : STRING[];
                                                  trgFirm  : LIKE(Firm.Firm);
                                                  trgId    : LIKE(FirmCtc.Id);
                                                  OnDate   : DATE);
 BEGIN
  IF SEARCH(FirmCtc, Id, trgFirm, trgId) THEN
   mpcs_Attr_byGivenFirmCtc(Alias, OnDate, "ContactPerson");
   IF L_ctc.extStandOnAdr_Pst(OnDate, trgFirm, trgId, 0) THEN
    L_ctc.curCtcAdr_Set_glb_AdrVar();
    L_Russia.wordSetAddr_byPart(Alias+".PAddr");
   END;
   IF L_ctc.extStandOnAdr_Fct(OnDate, trgFirm, trgId, 0) THEN
    L_ctc.curCtcAdr_Set_glb_AdrVar();
    L_Russia.wordSetAddr_byPart(Alias+".FAddr");
   END;
  END;
 END {SetFirmContactPersonData_wAlias};

 PUBLIC PROCEDURE SetFirmData(Prefix   : STRING[];
                              trgFirm  : LIKE(Firm.Firm);
                              OnDate   : DATE;
                              _Acnt    : LIKE(FirmAcnt.FirmAcnt);
                              Condition: STRING[]);
 BEGIN
  SetFirmData_wAlias(Prefix + "Firm", trgFirm, OnDate, _Acnt, Condition);
 END {SetFirmData};

 PUBLIC PROCEDURE SetFirmDefaultData(Prefix: STRING[]; trgFirm: LIKE(Firm.Firm); D: DATE; Condition: STRING[]);
  VAR
   tmp      : STRING[];
   _FirmAcnt: LIKE(FirmAcnt.FirmAcnt);
 BEGIN
  SAVE(Firm);
  SAVE(FirmAcnt);
  SAVE(Bank);
  SAVE(BankLog);
  SAVE(BankBrn);
  SAVE(BankBrnL);
  SetFirmData(Prefix, trgFirm, D, GetFirmAcntSoft(trgFirm, D), Condition);
  RESTORE(BankBrnL);
  RESTORE(BankBrn);
  RESTORE(BankLog);
  RESTORE(Bank);
  RESTORE(FirmAcnt);
  RESTORE(Firm);

  SETEMPTY(tmp);
  IF L_ctc.StandOnAdr_Fct(D, trgFirm, 0) THEN
   IF ~!CtcAdr.Town THEN
    tmp:=". " + CtcAdr.Town;
   ELSE
    tmp:=CtcAdr.RegionN;
   END;
  END;
  L_MSO.wordSetVar(Prefix + "Firm.City", tmp);
 END {SetFirmDefaultData};

 PUBLIC PROCEDURE SetMyFirmDefaultData(_MyFirm: tMyFirm; D: DATE; Condition: STRING[]);
 BEGIN
  SetFirmDefaultData("Own", GetFirmOfMyFirm(_MyFirm), D, Condition);
  SetFirmDefaultData("My",  GetFirmOfMyFirm(_MyFirm), D, Condition);
 END {SetMyFirmDefaultData};

 PUBLIC PROCEDURE SetEmptyFirmData(Prefix, Condition: STRING[]);
 BEGIN
  SAVE(Firm);
  SAVE(FirmAcnt);
  AccessSilentFirmAcnt(OWN_FIRM, SYSDATE());
  SetFirmData(Prefix, OWN_FIRM, SYSDATE(), FirmAcnt.FirmAcnt, Condition);
  L_MSO.SetEmptyRootVars(Prefix + "Firm");
  RESTORE(FirmAcnt);
  RESTORE(Firm);
 END {SetEmptyFirmData};

 PUBLIC PROCEDURE FillmfBnkAcn(AfterFirmEditInsert: SCAL[2]);
 BEGIN
  IF MyFirm.MyFirm # mf_Fict THEN
   SELECT(FirmAcnt, Firm, , MyFirm.Firm);
   WHILE OCCURE(FirmAcnt) DO
    IF ~SEARCH(mfBnkAcn, MyFirm, MyFirm.MyFirm, FirmAcnt.FirmAcnt) THEN
     mfBnkAcn.MyFirm  :=MyFirm.MyFirm;
     mfBnkAcn.Firm    :=FirmAcnt.Firm;
     mfBnkAcn.FirmAcnt:=FirmAcnt.FirmAcnt;
     SETEMPTY(mfBnkAcn.XObject, mfBnkAcn.Contract, mfBnkAcn.EndTime);
     INSERT(mfBnkAcn);
     L_XObj.AfterOriginInsert(L_XObj.o_Global, mfBnkAcn.MyFirm);
     IF AfterFirmEditInsert THEN
      STDMSG(" ᠭ ' ࣠樨' " + MyFirm.MyFirm + "   " + FirmAcnt.FirmAcnt +
             ".||  ਡ  ' ࣠樨'.", INFORM);
     END;
    END;
    NEXT(FirmAcnt);
   END; (* WHILE OCCURE(FirmAcnt) ... *)
  END;
 END {FillmfBnkAcn};

 PUBLIC PROCEDURE E_wMultipleMyFirm(D: DATE): SCAL[2];
 BEGIN
  RETURN L_EC.ExecE_Func_Scal2(D, PROCREF(L_Env.wMultipleMyFirm), 0);
 END {E_wMultipleMyFirm};

 PUBLIC PROCEDURE SetMyFirmForFilter();
 BEGIN
  IF  dfmAssigned THEN
   minMyFirm:=defaultMyFirm;
   maxMyFirm:=defaultMyFirm;
  ELSE
   minMyFirm:=MINOF(tMyFirm);
   maxMyFirm:=MAXOF(tMyFirm);
  END;
 END {SetMyFirmForFilter};

 PUBLIC PROCEDURE SetDefaultMyFirm(trgMyFirm: tMyFirm; trgAssigned: SCAL[2]);
 BEGIN
  L_General.Assert(trgMyFirm # mf_Fict, "' ࣠' 0000    ⠭  㬮砭");
  defaultMyFirm:=trgMyFirm;
  dfmAssigned  :=trgAssigned;
  L_SES.PutValueAtSlaveTrn(L_SES.sit_User, "dfmAssigned",   dfmAssigned);
  L_SES.PutValueAtSlaveTrn(L_SES.sit_User, "defaultMyFirm", defaultMyFirm);
  SetMyFirmForFilter();
  L_PCS.SetApplicationTitle();
 END {SetDefaultMyFirm};

 PUBLIC PROCEDURE E_wMultipleMyPlace(D: DATE): SCAL[2];
  VAR
   Cnt: NUMERIC[0];
 BEGIN
  SAVE(MyPlace);
  Cnt:=0;
  SELECT(MyPlace, MyPlace);
  WHILE OCCURE(MyPlace) DO
   INC(Cnt, L_DatTim.IsActive(D, MyPlace.Begin, MyPlace.Till) & (MyPlace.MyPlace # mp_Fict));
   NEXT(MyPlace);
  END; (* WHILE OCCURE(MyPlace) ... *)
  RESTORE(MyPlace);
  RETURN Cnt > 1;
 END {E_wMultipleMyPlace};

 PUBLIC PROCEDURE GetTheOnlyMyPlace(D: DATE; trgMyFirm: tMyFirm): LIKE(MyPlace.MyPlace);
  VAR
   trgMySite: LIKE(MySite.MySite);
   Result   : LIKE(MyPlace.MyPlace);
 BEGIN
  SAVE(MySite);
  SETEMPTY(trgMySite);
  SELECT(MySite, MyFirm, , trgMyFirm);
  LOOP
   IF ~OCCURE(MySite) THEN
    EXIT;
   ELSIF L_DatTim.IsActive(D, MySite.Begin, MySite.Till) THEN
    IF !trgMySite THEN
     trgMySite:=MySite.MySite;
    ELSE
     SETEMPTY(trgMySite);
     EXIT;
    END;
   END;
   NEXT(MySite);
  END; (* LOOP *)
  IF ~!trgMySite THEN
   SEARCH(MySite, MySite, , trgMySite);
   Result:=MySite.MyPlace;
  ELSE
   SETEMPTY(Result);
  END;
  RESTORE(MySite);
  RETURN Result;
 END {GetTheOnlyMyPlace};

 PUBLIC PROCEDURE GetMainMyPlace(D: DATE; trgMyFirm: tMyFirm): LIKE(MyPlace.MyPlace);
  VAR
   Result: LIKE(MyPlace.MyPlace);
 BEGIN
  SAVE(MySite);
  SETEMPTY(Result);
  SELECT(MySite, MyFirm, , trgMyFirm);
  WHILE OCCURE(MySite) DO
   IF MySite.Main & L_DatTim.IsActive(D, MySite.Begin, MySite.Till) THEN
    L_General.CallUs(!Result);
    Result:=MySite.MyPlace;
   END;
   NEXT(MySite);
  END; (* WHILE OCCURE(MySite) *)
  RESTORE(MySite);
  L_General.CallUs(~!Result);
  RETURN Result;
 END {GetMainMyPlace};

 PUBLIC PROCEDURE GetMainMySite(D: DATE; trgMyFirm: tMyFirm): LIKE(MySite.MySite);
  VAR
   Result: LIKE(MySite.MySite);
 BEGIN
  SAVE(MySite);
  SETEMPTY(Result);
  SELECT(MySite, MyFirm, , trgMyFirm);
  WHILE OCCURE(MySite) DO
   IF MySite.Main & L_DatTim.IsActive(D, MySite.Begin, MySite.Till) THEN
    L_General.CallUs(!Result);
    Result:=MySite.MySite;
   END;
   NEXT(MySite);
  END; (* WHILE OCCURE(MySite) *)
  RESTORE(MySite);
  L_General.CallUs(~!Result);
  RETURN Result;
 END {GetMainMySite};

 PUBLIC PROCEDURE CheckMyPlace_wMySite(D: DATE; trgMyPlace: LIKE(MySite.MyPlace); trgMyFirm: LIKE(MySite.MyFirm));
  VAR
   Cnt: NUMERIC[0];
 BEGIN
  IF trgMyPlace = mp_Fict THEN
   L_General.Error("ਬ '⮯ 頤' 0000 ⨬");
  ELSE
   SAVE(MyPlace);
   SAVE(MySite);
   SEARCH(MyPlace, MyPlace, , trgMyPlace);
   IF ~MyPlace.wMySite THEN
    L_General.Error("ਬ '⮯ 頤' " + trgMyPlace + " ⨬   ⥪");
   END;
   Cnt:=0;
   SELECT(MySite, MyPlace, , trgMyPlace);
   WHILE OCCURE(MySite) DO
    INC(Cnt, (MySite.MyFirm = trgMyFirm) & L_DatTim.IsActive(D, MySite.Begin, MySite.Till));
    NEXT(MySite);
   END; (* WHILE OCCURE(MySite) ... *)
   IF Cnt = 0 THEN
    L_General.Error("'⮯ 頤' " + trgMyPlace + "  '' " + trgMyFirm + " ᮢ⨬");
   ELSE
    L_General.CallUs(Cnt = 1);
   END;
   RESTORE(MyPlace);
   RESTORE(MySite);
  END;
 END {CheckMyPlace_wMySite};

 PUBLIC PROCEDURE SetMyPlaceForFilter();
 BEGIN
  IF  dfpAssigned THEN
   minMyPlace:=defaultMyPlace;
   maxMyPlace:=defaultMyPlace;
  ELSE
   minMyPlace:=MINOF(tMyPlace);
   maxMyPlace:=MAXOF(tMyPlace);
  END;
 END {SetMyPlaceForFilter};

 PUBLIC PROCEDURE SetDefaultMyPlace(trgMyPlace: tMyPlace; trgAssigned: SCAL[2]);
 BEGIN
  L_General.Assert(trgMyPlace # mp_Fict, "'⮯' 0000    ⠭  㬮砭");
  defaultMyPlace:=trgMyPlace;
  dfpAssigned   :=trgAssigned;
  L_SES.PutValueAtSlaveTrn(L_SES.sit_User, "dfpAssigned",    dfpAssigned);
  L_SES.PutValueAtSlaveTrn(L_SES.sit_User, "defaultMyPlace", defaultMyPlace);
  SetMyPlaceForFilter();
  L_PCS.SetApplicationTitle();
 END {SetDefaultMyPlace};

 PUBLIC PROCEDURE IsAllowedMyPlace(trgMyPlace: tMyPlace): SCAL[2];
 BEGIN
  RETURN ~dfpAssigned | (trgMyPlace = defaultMyPlace) | (trgMyPlace = mp_Fict);
 END {IsAllowedMyPlace};

 PUBLIC PROCEDURE GetDefaultMyPlaceName(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF dfpAssigned THEN
   SAVE(MyPlace);
   SEARCH(MyPlace, MyPlace, , defaultMyPlace);
   Result:=MyPlace.Name;
   RESTORE(MyPlace);
  ELSE
   Result:="";
  END;
  RETURN Result;
 END {GetDefaultMyPlaceName};

 PUBLIC PROCEDURE IsAllowedMyFirm(trgMyFirm: tMyFirm): SCAL[2];
 BEGIN
  RETURN ~dfmAssigned | (trgMyFirm = defaultMyFirm) | (trgMyFirm = mf_Fict);
 END {IsAllowedMyFirm};

 PUBLIC PROCEDURE GetDefaultMyFirmName(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF dfmAssigned THEN
   SAVE(MyFirm);
   SEARCH(MyFirm, MyFirm, , defaultMyFirm);
   Result:=MyFirm.Name;
   RESTORE(MyFirm);
  ELSE
   Result:="";
  END;
  RETURN Result;
 END {GetDefaultMyFirmName};

 PUBLIC PROCEDURE IsAllowedMyPF(trgMyFirm: tMyFirm; trgMyPlace: tMyPlace): SCAL[2];
 BEGIN
  RETURN IsAllowedMyFirm(trgMyFirm) & IsAllowedMyPlace(trgMyPlace);
 END {IsAllowedMyPF};

 PRIVATE PROCEDURE DefaultMyFirm(): tMyFirm;
 BEGIN
  IF E_wMultipleMyFirm(SYSDATE()) THEN
   IF VAR_IMPL.Get(dfmAssigned).Initialized & dfmAssigned THEN
    RETURN defaultMyFirm;
   ELSE
    RETURN EMPTYOF(tMyFirm);
   END;
  ELSE
   RETURN mf_Own; (*    E_. ਬ,  81 ᫥  室 *)
  END;
 END {DefaultMyFirm};

 PUBLIC PROCEDURE extDefineMyFirm(D: DATE; MyFirms: tMyFirm[]): tMyFirm;
  VAR
   List   : STRING[];
   i,
   Count  : NUMERIC[0];
 BEGIN
  SETEMPTY(List);
  SETZERO(i, Count);
  WHILE (i<=HIGH(MyFirms)) & ~!MyFirms[i] DO
   PositionOnMyFirm(MyFirms[i]);
   IF (MyFirm.MyFirm # mf_Fict) & L_DatTim.IsActive(D, MyFirm.Begin, MyFirm.Till) THEN
    List:=List + MyFirm.MyFirm + " " + Str.Align(MyFirm.Name, 32, LEFT) + " " + MyFirm.vzSign + "|";
    INC(Count);
   END;
   INC(i);
  END;
  IF Count = 0 THEN
   L_General.Error("   㠫쭮 ' ࣠樨'");
  ELSIF Count = 1 THEN
   i:=0;
  ELSE
   i:=L_StdFrm.ShowListAsMenu(List, "롮 '' ࣠樨");
  END;
  RETURN Str.Item(L_Str.PoolItem(List, i), " ", 0);
 END {extDefineMyFirm};

 PUBLIC PROCEDURE ChoiceMyFirm(): tMyFirm;
  VAR
   Result : tMyFirm;
   MyFirms: tMyFirm[100];
   i      : NUMERIC[0];
 BEGIN
  SETEMPTY(MyFirms);
  i:=0;
  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   MyFirms[i]:=MyFirm.MyFirm;
   INC(i);
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
  Result:=extDefineMyFirm(SYSDATE(), MyFirms);
  RETURN Result;
 END {ChoiceMyFirm};

 PUBLIC PROCEDURE DefineMyFirm(): tMyFirm;
  VAR
   Result : tMyFirm;
 BEGIN
  Result:=DefaultMyFirm();
  IF !Result THEN
   Result:=ChoiceMyFirm();
  END;
  RETURN Result;
 END {DefineMyFirm};

 PUBLIC PROCEDURE DefineManMyFirm(_Man: LIKE(Man.Man); D: DATE): tMyFirm;
  VAR
   Result : tMyFirm;
   MyFirms: tMyFirm[100];
   i      : NUMERIC[0];
 BEGIN
  SETEMPTY(MyFirms);
  i:=0;
  SELECT(mfMan, Man, , _Man);
  WHILE OCCURE(mfMan) DO
   MyFirms[i]:=mfMan.MyFirm;
   INC(i);
   NEXT(mfMan);
  END; (* WHILE OCCURE(mfMan) ... *)
  Result:=extDefineMyFirm(D, MyFirms);
  RETURN Result;
 END {DefineManMyFirm};

 PUBLIC PROCEDURE SetCurMyFirm();
 BEGIN
  curMyFirm:=DefineMyFirm();
 END {SetCurMyFirm};

 PUBLIC PROCEDURE CheckMyFirmEQ(_MyFirm1: tMyFirm; Text1: STRING[]; _MyFirm2: tMyFirm; Text2: STRING[]);
 BEGIN
  L_General.Assert(_MyFirm1 = _MyFirm2, " ᮢ ' ࣠樨'  "+Text1+"  "+Text2);
 END {CheckMyFirmEQ};

 PUBLIC PROCEDURE Fill_ContractorBriefName(VAR _ContractorBriefName: STRING[];
                                               D                   : DATE;
                                               _PrtnrTyp           : tPartnerType;
                                               _HeadFirm           : LIKE(Firm.Firm);
                                               _BranchName,
                                               _PersonFullName     : STRING[]);
 BEGIN
  IF ~!_ContractorBriefName THEN
   L_StdFrm.Choice("  ᮪饭  ࠣ.  ?");
  END;
  IF _PrtnrTyp = pt_Branch THEN
   L_General.Assert(~!D, " ᭠砫 㪠  砫 ⢨");
   L_General.Assert(~!_HeadFirm, " ᭠砫 㪠  ࣠");
   _ContractorBriefName:='"' + _BranchName + '" - 䨫 ' + FP_ContractorBriefName(_HeadFirm, D);
  ELSE
   _ContractorBriefName:=_PersonFullName;
  END;
 END {Fill_ContractorBriefName};

END.
