(*
%Copyright   (c) Polak Computer System
%Author      06.03.2000 19:13:16 SAN
%Purpose     ⥪  ࠡ  ᢮⢠ Man
%Type        library
%Specific    SYS
%Modified    24.09.2014 16:14:36 LDA
%Environment
*)

 MODULE P_Man [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tNDFLStatus           = SCAL[10];
  tNDFLDaysInRussia     = SCAL[1E4];
  tMassSendKind         = SCAL[99];
  tForeignerLegalStatus = SCAL[4];

 PUBLIC CONST
  P_MedicalSertification       = 0201;
  P_DriveSertification         = 0202;
  P_PersonalMedicalBook        = 0203;
  P_LaborActivityLicense       = 0204;
  P_ResidencePermit            = 0205;
  P_Fluorography               = 0206;
  P_Vaccination                = 0207;
  P_PINCode                    = 0208;
  P_TractorDriverSertification = 0209;
  P_ManPhoto                   = 5050;
  P_Invalid                    = 5100;
  P_Pension                    = 5101;
  P_ForeignerLegalStatus       = 5102;
  P_ManName_inPFRF             = 5105;
  P_ManName                    = 5106;
  P_MemberGPW                  = 5110; (* Great patriotic war *)
  P_MemberOMI                  = 5112; (* obligatory medical insurance *)
  P_BattleActionVeteran        = 5120;
  P_Chernobil                  = 5121;
  P_VeteranOfWork              = 5122;
  P_LeningradBlockade          = 5123;
  P_WorkFront                  = 5124;
  P_TaxDep                     = 5130;
  P_ManFictWorker              = 5145;
  P_SMSMassSendReceiver        = 5146;
  P_AnthropometricInf          = 5151;
  P_TradeUnionMember           = 5152;
  P_ManForeignPassport         = 5155;
  P_EmploymentCertificate      = 5200;
  P_Pass                       = 5201;
  P_AccessToTerritory          = 5202;
  P_MedExaminationFeatures     = 5203;
  P_MigrationCard              = 5204;
  P_SalaryInAPFY               = 5205;
  P_SpecificNDFL               = 5206;
  P_StaffCandidate             = 5207;
  P_HazardMedExamination       = 5208;

  fls_Commorancy      = 0;
  fls_Commorancy_wSIN = 1;
  fls_TempResidence   = 2;
  fls_ResidencePermit = 3;

  ci_ExtTelefon    = 0;
  ci_IntTelefon    = 1;
  ci_MblTelefon    = 2;
  ci_EMail         = 3;
  ci_EMail_for_SMS = 4;

  apfy_Amount = 3;

  att_CarAmount = 2;

  v_Amnt            = 9;
  v_PossibilityPool = "⨢|襭";
  v_KindPool        = "-|| A| B|ਯ|饢 䠫| 23||६";

  ar_Granted  = 0;
  ar_Denied   = 1;
  ar_BadPIN   = 2;
  ar_EmptyPIN = 3;

  ndfls_Auto        = 0;
  ndfls_Resident    = 1;
  ndfls_Nonresident = 2;
  ndfls_Pool        = "। ⮬᪨||१";

  msk_All                           = 0;
  msk_FemaleOnly                    = 1;
  msk_MaleOnly                      = 2;
  msk_DrGuNextDayRegimeNotification = 3;
  msk_UserDefined                   = 4;

  msk_Amount = 10;

  pool_AcsGroup                   = 0000991;
  pool_UserDefinedSMSMassSendKind = 0001001;

  dc_Amount = 4;
  dc_Pool   = "ABCD";
  dc_A      = 0;
  dc_Has    = 1;
  dc_AddE   = 2;

  dcn_Amount = 16;

  v_hme_DirtyTyp = "DirtyTyp";
  v_hme_Type     = "Type";

 IMPORT L_General, L_Staff, L_Str, Str, L_DatTim, L_Prop, L_StdFrm, L_ACS,
        FIO, L_Man, Math, E_Utils, L_WDO, L_SpcEq, L_FIO, L_r2r,
        L_ctc, L_AR, L_Russia, L_Print, L_Pool, L_PRoll, L_APtm, L_EDO, P_EDOL;

 PRIVATE TYPE
  tContactInf          = SCAL[5];
  tAuthorizationResult = SCAL[4];
  tDriveCategories     = SCAL[3][dc_Amount];

 PRIVATE CONST
  SizeClothing_Pool  = "34|36|38|40|42|44|46|48|50|52|54|56|58|60|62|64|66|68|70";
  SizeShoes_Pool     = "35|35.5|36|36.5|37|37.5|38|38.5|39|39.5|40|40.5|41|41.5|42|42.5|43|43.5|44|44.5|45|45.5|46|46.5|47|47.5|48";
  SizeHat_Pool       = "50|51|52|53|54|55|56|57|58|59|60|61|62|63|64|65";
  SizeMittens_Pool   = "0|1|2|3";
  SizeGloves_Pool    = "6.5|7|7.5|8|8.5|9|9.5|10|10.5|11|11.5|12|12.5|13|13.5";
  SizeMask_Pool      = "0|1|2|3|4";
  SizeRespirator_Pool= "0|1|2";

 PUBLIC PROCEDURE GetSubWindowName(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_DriveSertification THEN   RETURN "P_0202";
  ELSIF trgProperty = P_Vaccination THEN          RETURN "P_0207";
  ELSIF trgProperty = P_ManName THEN              RETURN "P_5106";
  ELSIF trgProperty = P_TaxDep THEN               RETURN "P_5130";
  ELSIF trgProperty = P_SMSMassSendReceiver THEN  RETURN "P_5146";
  ELSIF trgProperty = P_AnthropometricInf THEN    RETURN "P_5151";
  ELSIF trgProperty = P_Pass THEN                 RETURN "P_5201";
  ELSIF trgProperty = P_AccessToTerritory THEN    RETURN "P_5202";
  ELSIF trgProperty = P_SalaryInAPFY THEN         RETURN "P_5205";
  ELSIF trgProperty = P_SpecificNDFL THEN         RETURN "P_5206";
  ELSIF trgProperty = P_StaffCandidate THEN       RETURN "P_5207";
  ELSIF trgProperty = P_HazardMedExamination THEN RETURN "P_5208";
  ELSE                                            RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE GetManProPool(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_MedicalSertification THEN
   RETURN "  窠|  窠   ⠪ |  ࠭祭|࠭祭 ";
  ELSIF trgProperty = P_Invalid THEN
   RETURN "I|II|III";
  ELSIF trgProperty = P_Pension THEN
   RETURN " | |   ନ|  |樠쭠";
  ELSIF trgProperty = P_ForeignerLegalStatus THEN
   RETURN "६ ॡ뢠|६ ॡ뢠  㦥 客  |६ ஦|  ⥫⢮";
  ELSIF (trgProperty = P_MemberGPW) |
        (trgProperty = P_MemberOMI) |
        (trgProperty = P_Chernobil) |
        (trgProperty = P_VeteranOfWork) |
        (trgProperty = P_LeningradBlockade) |
        (trgProperty = P_WorkFront) |
        (trgProperty = P_ManFictWorker) |
        (trgProperty = P_TradeUnionMember) |
        (trgProperty = P_Fluorography)  THEN
   RETURN "|";
  ELSIF (trgProperty = P_MedExaminationFeatures) THEN
   RETURN "㯯 ᪠|᢮  ᬮ";
  ELSIF trgProperty = P_PersonalMedicalBook THEN
   RETURN "⮢|";
  ELSIF (trgProperty = P_EmploymentCertificate) |
        (trgProperty = P_LaborActivityLicense) |
        (trgProperty = P_ResidencePermit) |
        (trgProperty = P_MigrationCard) THEN
   RETURN "|";
  ELSIF trgProperty = P_ManPhoto THEN
   RETURN L_Prop.ChooseFileDialog;
  ELSIF trgProperty = P_HazardMedExamination THEN
   RETURN "뤠 ࠢ|饭  ࠡ| 饭  ࠡ";
  ELSIF L_Prop.IsLocalProperty(trgProperty) THEN
   RETURN L_Prop.E_GetPool(trgProperty);
  ELSE
   RETURN "";
  END;
 END {GetManProPool};

 PUBLIC PROCEDURE GetPool4DocGiveS(trgProperty: LIKE(Property.Property)): LIKE(Pool.Pool);
 BEGIN
  IF    trgProperty = P_MedicalSertification THEN
   RETURN 0000998;
  ELSIF trgProperty = P_TradeUnionMember THEN
   RETURN 0000999;
  ELSIF trgProperty = P_LaborActivityLicense THEN
   RETURN 0001002;
  ELSE
   RETURN EMPTYOF(Pool.Pool);
  END;
 END {GetPool4DocGiveS};

 PUBLIC PROCEDURE GetManName(trgMan: LIKE(Man.Man); D: DATE): STRING[];
  VAR
   PersonalInfo: STRING[];
   MinD        : DATE;
   Result,
   NewManName  : STRING[];
 BEGIN
  SAVE(Man);
  SAVE(Staff);
  L_General.CallUs(SEARCH(Man, Man, trgMan));
  Result:=Man.Name;
  IF L_Man.E_ManNameModificationThroughEDOrder() THEN
   MinD:=MAXOF(DATE);
   TRY
    L_AR.GrantRightsUnconditionally();
    SELECT(Staff, Man, , trgMan);
    WHILE OCCURE(Staff) DO
     SETSEL(EDOrderL, TSNGrOD, Staff.TSN, L_EDO.grp_ChangePersonalInfo);
     SRCINSEL(EDOrderL, GE, , D);
     WHILE OCCURE(EDOrderL) & (EDOrderL.OcrDate <= MinD) DO
      PROMPT(EDOrderL.EDOrder);
      IF L_EDO.AcceptableEDOrderL() THEN
       MinD:=EDOrderL.OcrDate;
       L_EDO.GetEDOLPropValue(P_EDOL.P_PersonalInfo, PersonalInfo);
       P_EDOL.Decode_PersonalInfo(PersonalInfo, Result, NewManName);
      END;
      NEXT(EDOrderL);
     END; (* WHILE OCCURE(EDOrderL) ... *)
     NEXT(Staff);
    END; (* WHILE OCCURE(Staff) ... *)
   EXCEPT
   END;
  ELSIF HasManPro(trgMan, D, P_ManName) THEN
   Result:=ManPro.Value;
  END;
  RESTORE(Staff);
  RESTORE(Man);
  RETURN Result;
 END {GetManName};

 PUBLIC PROCEDURE GetPhotoArchiveFolder(): STRING[];
  VAR
   Local : PROC;
   Result: STRING[];
 BEGIN
  Result:="IMAGES\PHOTO";
  Local :=PROCREF(E_Utils.GetPhotoArchiveFolder);
  IF ~!Local THEN
   Result:=Local();
  END;
  Result:=FIO.FullPath(Result);
  RETURN Result;
 END {GetPhotoArchiveFolder};

 PUBLIC PROCEDURE GetFullPhotoFileName(FileName: STRING[]): STRING[];
 BEGIN
  IF ~!FileName THEN
   RETURN FIO.FullPath(FIO.BuildPath(FileName, , GetPhotoArchiveFolder()));
  ELSE
   RETURN "";
  END;
 END {GetFullPhotoFileName};

 PUBLIC PROCEDURE PrintPhoto(pj: PRINTJOB; X, Y, Width, Height: FLOAT; D: DATE);
  VAR
   FileName: STRING[];
 BEGIN
  TRY
   FileName:=GetFullPhotoFileName(GetManProSoft(Man.Man, D, P_ManPhoto));
  EXCEPT
  ON Exc: Exc_Root DO
   L_StdFrm.RedInform(" 㤠  ⮣||" + Exc.MsgOriginalText);
   SETEMPTY(FileName);
  END;
  IF ~!FileName THEN
   L_Print.PrintPicture(pj, X, Y, Width, Height, FileName);
  END;
 END {PrintPhoto};

 PRIVATE PROCEDURE Decode_AccessToTerritory(    curValue      : STRING[];
                                            VAR Firm          : LIKE(Firm.Firm);
                                            VAR Aim           : STRING[];
                                            VAR ResponsibleTSN: LIKE(Staff.TSN);
                                            VAR AcsGroup      : STRING[];
                                            VAR CarMark       : STRING[][att_CarAmount];
                                            VAR StateNbr      : STRING[][att_CarAmount]);
 BEGIN
  Firm          :=L_r2r.Decode(L_Prop.getRES(curValue, 0));
  Aim           :=L_Prop.getRES(curValue, 1);
  ResponsibleTSN:=L_r2r.Decode(L_Prop.getRES(curValue, 2));
  AcsGroup      :=L_Prop.getRES(curValue, 3);
  CarMark[0]    :=L_Prop.getRES(curValue, 4);
  StateNbr[0]   :=L_Prop.getRES(curValue, 5);
  CarMark[1]    :=L_Prop.getRES(curValue, 6);
  StateNbr[1]   :=L_Prop.getRES(curValue, 7);
 END {Decode_AccessToTerritory};

 PRIVATE PROCEDURE SetOutsiderDescrFieldsModifiable();
  VAR
   Fields    : FORM_FIELDS;
   Modifiable: SCAL[2];
 BEGIN
  CONFORM(ManPro, Man);
  Fields:=RTI.Get().CurZone.Fields;
  Modifiable:=~Man.rStaff | (~!ManPro.Date & L_Staff.E_IsOutsider(ManPro.Date));
  Fields("ResponsibleTSN").Modifiable:=Modifiable;
  Fields("Firm").Modifiable          :=Modifiable;
  Fields("Aim").Modifiable           :=Modifiable;
 END {SetOutsiderDescrFieldsModifiable};

 PRIVATE PROCEDURE formSet_AccessToTerritory();
  VAR
   i       : NUMERIC[0];
   Fields  : FORM_FIELDS;
   CarMark,
   StateNbr: STRING[][att_CarAmount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("AcsGroup").Template        :=L_Pool.Get(pool_AcsGroup);
  Fields("AcsGroup").TemplateIsStrict:=1;
  Fields("AcsGroup").Modifiable      :=~!Str.Replace(Fields("AcsGroup").Template, "|", "");
  SetOutsiderDescrFieldsModifiable();

  Decode_AccessToTerritory(ManPro.Value, Fields("Firm").Value, Fields("Aim").Value,
                           Fields("ResponsibleTSN").Value, Fields("AcsGroup").Value,
                           CarMark, StateNbr);

  i:=0;
  WHILE i <= HIGH(CarMark) DO
   Fields(L_WDO.Fld_wIdx("CarMark", i+1)).Value :=CarMark[i];
   Fields(L_WDO.Fld_wIdx("StateNbr", i+1)).Value:=StateNbr[i];
   INC(i);
  END; (* WHILE i <= HIGH(CarMark)...*)
 END {formSet_AccessToTerritory};

 PUBLIC PROCEDURE Encode_AccessToTerritory(trgFirm          : LIKE(Firm.Firm);
                                           trgAim           : STRING[];
                                           trgResponsibleTSN: LIKE(Staff.TSN);
                                           trgAcsGroup      : STRING[];
                                           trgCarMark       : STRING[][att_CarAmount];
                                           trgStateNbr      : STRING[][att_CarAmount]);
  VAR
   i: NUMERIC[0];
 BEGIN
  IF L_Staff.E_IsOutsider(ManPro.Date) THEN
   IF ~!trgResponsibleTSN THEN
    SEARCH(Staff, TSN, , trgResponsibleTSN);
    L_General.Assert(L_Staff.rInState(ManPro.Date), "⭨ "+Staff.TSN+"  ⮨    "+L_DatTim.DateStr(ManPro.Date));
   END;
   L_General.Assert(~!trgAim | ~!trgFirm | ~!trgResponsibleTSN | ~!trgAcsGroup,
                    " 㪠 㯯 㯠 / ᠭ ஭ ");
  END;
  L_General.Assert(!trgCarMark[0] = !trgStateNbr[0], "    ⮬ 1");
  L_General.Assert(!trgCarMark[1] = !trgStateNbr[1], "    ⮬ 2");

  L_Prop.putRES(ManPro.Value, L_r2r.Put("ManPro", "Firm", trgFirm));
  L_Prop.putRES(ManPro.Value, trgAim);
  L_Prop.putRES(ManPro.Value, L_r2r.Put("ManPro", "Staff", trgResponsibleTSN));
  L_Prop.putRES(ManPro.Value, trgAcsGroup);
  i:=0;
  WHILE i <= HIGH(trgCarMark) DO
   L_Prop.putRES(ManPro.Value, trgCarMark[i]);
   L_Prop.putRES(ManPro.Value, trgStateNbr[i]);
   INC(i);
  END; (* WHILE i <= HIGH(trgCarMark)...*)
  L_Prop.ConvEmptyRecordPropertyValue(ManPro.Value);
 END {Encode_AccessToTerritory};

 PRIVATE PROCEDURE formGet_AccessToTerritory();
  VAR
   i                : NUMERIC[0];
   Fields           : FORM_FIELDS;
   trgFirm          : LIKE(Firm.Firm);
   trgAim           : STRING[];
   trgResponsibleTSN: LIKE(Staff.TSN);
   trgAcsGroup      : STRING[];
   trgCarMark,
   trgStateNbr      : STRING[][att_CarAmount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  trgFirm          :=Fields("Firm").Value;
  trgAim           :=Fields("Aim").Value;
  trgResponsibleTSN:=Fields("ResponsibleTSN").Value;
  trgAcsGroup      :=Fields("AcsGroup").Value;

  i:=0;
  WHILE i <= HIGH(trgCarMark) DO
   trgCarMark[i] :=Fields(L_WDO.Fld_wIdx("CarMark", i+1)).Value;
   trgStateNbr[i]:=Fields(L_WDO.Fld_wIdx("StateNbr", i+1)).Value;
   INC(i);
  END; (* WHILE i <= HIGH(trgCarMark)...*)

  CONFORM(ManPro, Man);
  Encode_AccessToTerritory(trgFirm, trgAim, trgResponsibleTSN, trgAcsGroup, trgCarMark, trgStateNbr);
 END {formGet_AccessToTerritory};

 PUBLIC PROCEDURE Decode_Vaccination(VAR Kind       : STRING[][];
                                     VAR Possibility: SCAL[2][];
                                     VAR Date       : DATE[];
                                     VAR SerNbr     : STRING[][];
                                     VAR UsefulTime : DATE[]);
  VAR
   i          : NUMERIC[0];
   Idx        : SCAL[v_Amnt];
   SingleValue: STRING[];
 BEGIN
  SETEMPTY(Kind, Possibility, Date, SerNbr, UsefulTime);
  IF ~!ManPro.Value THEN
   i:=0;
   LOOP
    SingleValue:=L_Prop.getAIS(ManPro.Value, i);
    IF !SingleValue THEN
     EXIT;
    END;
    Idx             :=L_Str.PositionInPool(v_KindPool, L_Prop.getRES(SingleValue, 0));
    L_General.CallUs(~!Idx);
    Kind[Idx]       :=L_Str.PoolItem(v_KindPool, Idx);
    Possibility[Idx]:=L_Prop.getRES(SingleValue, 1);
    Date[Idx]       :=L_Prop.GetDateFromStr(L_Prop.getRES(SingleValue, 2), 1);
    SerNbr[Idx]     :=L_Prop.getRES(SingleValue, 3);
    UsefulTime[Idx] :=L_Prop.GetDateFromStr(L_Prop.getRES(SingleValue, 4), 1);
    INC(i);
   END; (* LOOP *)
  END; (* IF ~!ManPro.Value ... *)
 END {Decode_Vaccination};

 PRIVATE PROCEDURE GetAnyVaccinationPossibility(Dir: NUMERIC[0]; VAR Possibility: SCAL[2][]): SCAL[2];
  VAR
   dummyKind      : STRING[][v_Amnt];
   dummyDate      : DATE    [v_Amnt];
   dummySerNbr    : STRING[][v_Amnt];
   dummyUsefulTime: DATE    [v_Amnt];
   Result         : SCAL[2];
 BEGIN
  SETEMPTY(Possibility);
  Result:=0;
  SAVE(ManPro);
  CHANGESEL(ManPro, Man, , ManPro.Man, ManPro.Property);
  IF (Dir = -1) & PREV(ManPro) |
     (Dir = +1) & NEXT(ManPro) |
     (Dir =  0) & ~!ManPro.Value THEN
   Result:=1;
   Decode_Vaccination(dummyKind,
                      Possibility,
                      dummyDate,
                      dummySerNbr,
                      dummyUsefulTime);
  END;
  RESTORE(ManPro);
  RETURN Result;
 END {GetAnyVaccinationPossibility};

 PRIVATE PROCEDURE CheckP_Vaccination();
  CONST
   i_Prv = 0;
   i_Nxt = 1;
   i_Cur = 2;
  VAR
   Kind            : STRING[][v_Amnt];
   Date            : DATE    [v_Amnt];
   SerNbr          : STRING[][v_Amnt];
   UsefulTime      : DATE    [v_Amnt];
   Idx             : SCAL    [v_Amnt];
   PrvPossibility,
   CurPossibility,
   NxtPossibility  : SCAL[2][v_Amnt];
   VaccinationExist: SCAL[2][3];
 BEGIN
  IF ~!ManPro.Value THEN
   Decode_Vaccination(Kind, CurPossibility, Date, SerNbr, UsefulTime);
   VaccinationExist[0]:=GetAnyVaccinationPossibility(-1, PrvPossibility);
   VaccinationExist[1]:=GetAnyVaccinationPossibility(+1, NxtPossibility);

   FOR_EACH Idx DO
    IF    ~!PrvPossibility[Idx] & !CurPossibility[Idx] THEN
     L_General.Error("襭 楯窠 樭権  '" + Kind[Idx] + "'|" +
                     " ।饬 ᢮⢥ 樭権 , 祬  ⥪饬");
    ELSIF VaccinationExist[1] & !NxtPossibility[Idx] & ~!CurPossibility[Idx] THEN
     L_General.Error("襭 楯窠 樭権  '" + Kind[Idx] + "'|" +
                     " ⥪饬 ᢮⢥ 樭権 , 祬  ᫥饬");
    END;
   END; (* FOR_EACH Idx...*)
  END;
 END {CheckP_Vaccination};

 PRIVATE PROCEDURE CheckP_DriveSertification();
  VAR
   MaxExpD: DATE;
 BEGIN
  L_General.Assert(~!ManPro.DocExpD, " 㪠  砭 ⢨ 㬥");
  IF ~!ManPro.DocGiveD THEN
   L_General.Assert(ManPro.DocGiveD <= ManPro.Date,
                    " ᢮⢠      뤠 ⥫᪮ 㤮⮢७");
   MaxExpD:=L_DatTim.IncCalendarMonth(ManPro.DocGiveD, 120);
   IF    ManPro.DocExpD > MaxExpD THEN
    L_General.Error("ப ⢨ ⥫᪮ 㤮⮢७     10 ");
   ELSIF ManPro.DocExpD < MaxExpD THEN
    L_StdFrm.Choice("ப ⢨ ⥫᪮ 㤮⮢७  10 ?");
   END;
  ELSE
   MaxExpD:=L_DatTim.IncCalendarMonth(ManPro.Date, 120);
   L_General.Assert(ManPro.DocExpD <= MaxExpD,
                    "ப ⢨ ⥫᪮ 㤮⮢७     10 ");
  END;
 END {CheckP_DriveSertification};

 PRIVATE PROCEDURE sapfy_Check();
  VAR
   i         : SCAL[apfy_Amount];
   ArrayItem : STRING[];
   tmpValue0,
   tmpValue1,
   tmpValue2 : NUMERIC[3];
 BEGIN
  FOR_EACH i DO
   ArrayItem:=L_Prop.getAIS(ManPro.Value, i);
   tmpValue0:=L_Prop.GetNumericValueFromStr(L_Prop.getRES(ArrayItem, 0));
   tmpValue1:=L_Prop.GetNumericValueFromStr(L_Prop.getRES(ArrayItem, 1));
   tmpValue2:=L_Prop.GetNumericValueFromStr(L_Prop.getRES(ArrayItem, 2));
   L_General.Assert(!tmpValue0 = !tmpValue1, "  ࠡ⮪   ६");
   IF ~!tmpValue0 THEN
    L_General.Assert(2009 <= tmpValue0,
                     "ࠡ⮪  2009  뢠.  室 ᫥  । ");
    L_General.Assert(tmpValue0 <= L_DatTim.YEAR(SYSDATE()),
                     "   ࠡ⪠  騩 : "+L_Str.IntStr(tmpValue0));
   END;
   IF ~!tmpValue2 THEN
    L_General.Assert(~!tmpValue0, "     ६");
    L_General.Assert((tmpValue2>=0) & (tmpValue2<=366), "    0  366");
   END;
  END;
 END {sapfy_Check};

 PRIVATE PROCEDURE Check_TaxDep();
  VAR
   curDocSer,
   curDocNbr,
   curTaxDep: STRING[];
 BEGIN
  L_General.Assert((!ManPro.DocGiveD & !ManPro.DocNum) | (~!ManPro.DocGiveD & ~!ManPro.DocNum),
                    ",    뤠 㬥|    ६");
  L_Prop.GetDocSerAndNum(ManPro.DocNum, curDocSer, curDocNbr);
  L_General.Assert(!curDocNbr | (L_Str.TestStrAlowChar(curDocNbr, "09") & (Str.Length(curDocNbr) >= 7)),
                   " ᢨ⥫⢠  ᮤঠ   7 ");
  IF ~!ManPro.DocGiveD THEN
   L_General.Assert(ManPro.DocGiveD <= ManPro.Date,
                    " ⠭        뤠 㬥");
  END;
  curTaxDep:=L_Prop.getRES(ManPro.Value, 0);
  IF ~!curDocSer & (Str.Slice(curTaxDep, 0, 2) # curDocSer) THEN
   L_StdFrm.Choice(" 2  a    ࠢ ਨ 㬥");
  END;
  IF L_WDO.cField("INN").Modifiable THEN
   CONFORM(ManPro, Man);
   IF Str.Slice(Man.INN, 0, 4) # curTaxDep THEN
    L_StdFrm.Choice(" 4     ࠢ  ");
   END;
  END;
 END {Check_TaxDep};

 PRIVATE PROCEDURE Check_ManName();
 BEGIN
  L_Man.CheckName(ManPro.Value);
  SAVE(ManPro);
  SELECT(ManPro, Man, , ManPro.Man, P_ManName);
  IF ~NEXT(ManPro) THEN
   TOOLTIP(" ⢮,  ,  ᢮|" +
           ". ᮡ ଫ ᢮⢠ " + L_Str.FixedIntStr(P_ManName, 4) + "  㬥樨");
  END;
  RESTORE(ManPro);
 END {Check_ManName};

 PUBLIC PROCEDURE Check(trgProperty: LIKE(Property.Property));
  VAR
   ManPhotoFullFileName: STRING[];
   curNDFLStatus       : tNDFLStatus;
   dmyNDFLDaysInRussia : tNDFLDaysInRussia;
 BEGIN
  IF    trgProperty = P_Vaccination THEN
   CheckP_Vaccination();
  ELSIF trgProperty = P_ManPhoto THEN
   ManPhotoFullFileName:=GetFullPhotoFileName(ManPro.Value);
   L_General.Assert(FIO.Exists(ManPhotoFullFileName),
                    " '" + ManPhotoFullFileName + "'  ");
  ELSIF trgProperty = P_SalaryInAPFY THEN
   sapfy_Check();
  ELSIF trgProperty = P_SpecificNDFL THEN
   GetNDFLInf(curNDFLStatus, dmyNDFLDaysInRussia);
   IF curNDFLStatus = ndfls_Auto THEN
    CheckNDFL(1, ManPro.Date);
   ELSIF (curNDFLStatus = ndfls_Resident) & (ManPro.DocExpD > (L_DatTim.YearEnd(ManPro.Date)+1)) THEN
    L_General.Error("    祭 ");
   END;
  ELSIF trgProperty = P_MedicalSertification THEN
   L_General.Assert(~!ManPro.DocExpD, " 㪠  砭 ⢨ 㬥");
  ELSIF trgProperty = P_DriveSertification THEN
   CheckP_DriveSertification();
  ELSIF trgProperty = P_ForeignerLegalStatus THEN
   L_General.Assert(L_Man.Man_Citizen(ManPro.Man, ManPro.Date) > L_Man.ct_Russia,
                   "   ࠭ ࠦ  "+L_DatTim.DateStr(ManPro.Date));
  ELSIF trgProperty = P_TaxDep THEN
   Check_TaxDep();
  ELSIF trgProperty = P_ManName THEN
   Check_ManName();
  END;
 END {Check};

 PRIVATE PROCEDURE GetNotClosedMonth(D: DATE): DATE;
 BEGIN
  D:=L_DatTim.Per(D);
  IF D > SYSDATE() THEN            (*᫨誮  ਮ  *)
   D:=L_DatTim.NextPer(SYSDATE()); (* ᠭ  *)
  END;
  WHILE L_APtm.MonthIsClosed(D, L_APtm.system_Salary) DO
   D:=L_DatTim.IncMonth(D, +1);
  END;
  RETURN D;
 END {GetNotClosedMonth};

 PRIVATE PROCEDURE ResetSal(pvalueDate: DATE);
  VAR
   P: DATE;
   First: SCAL[2];
   curAPFYYear: NUMERIC[0][apfy_Amount];
   dmyAPFYSal : NUMERIC[2][apfy_Amount];
   dmyAPFYDays: NUMERIC[0][apfy_Amount];
   minAPFY    : NUMERIC[0];
   i          : SCAL[apfy_Amount];
 BEGIN
  IF    ManPro.Property = P_SpecificNDFL THEN
   IF !pvalueDate THEN
    P:=GetNotClosedMonth(ManPro.Date);
   ELSE
    P:=GetNotClosedMonth(Math.Min(ManPro.Date, pvalueDate));
   END;
   SELECT(Staff, Man, , ManPro.Man);
   WHILE OCCURE(Staff) DO
    L_PRoll.DedDone_AP(Math.Max(L_DatTim.Per(Staff.BegDate), P), 0);
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
  ELSIF ManPro.Property = P_SalaryInAPFY THEN
   sapfy_DecodeValue(curAPFYYear, dmyAPFYSal, dmyAPFYDays);
   minAPFY:=MAXOF(minAPFY);
   FOR_EACH i DO
    IF ~!curAPFYYear[i] THEN
     minAPFY:=Math.Min(minAPFY, curAPFYYear[i]);
    END;
   END;
   minAPFY:=Math.Max(minAPFY+1, 2011);
   First:=1;
   SELECT(Staff, Man, , ManPro.Man);
   WHILE OCCURE(Staff) DO
    IF (Staff.Contract # L_Staff.cnt_ExternalCombine) & (Staff.Contract # L_Staff.cnt_OutStaff) &
       SELECT(AvePay, TSN, Staff.TSN) & SRCINSEL(AvePay, GE, PackDATE(1, 0, minAPFY)) THEN
     P:=Math.Max(PackDATE(1, 0, minAPFY), L_DatTim.Per(Staff.BegDate));
     IF First THEN
      L_StdFrm.Choice("㤥 믮  १⮢   㬥⠬  "+L_DatTim.PeriodStr(P)+",|"+
                      "᫥ ப஫஢  ᮡ ");
      First:=0;
     END;
     L_PRoll.AveDone_AP(P, 0);
    END; (* IF SELECT(AvePay) ... *)
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
  END;
 END {ResetSal};

 PUBLIC PROCEDURE PropertyModificationAllowed(trgProperty: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF    (trgProperty = P_PINCode) | (trgProperty = P_Pass) THEN
   RETURN L_Prop.mac_AutoOnly;
  ELSIF trgProperty = P_ManName THEN
   IF L_Man.E_ManNameModificationThroughEDOrder() THEN
    RETURN L_Prop.mac_Old;
   ELSE
    RETURN L_Prop.mac_Full;
   END;
  ELSIF trgProperty = P_TaxDep THEN
   ACCESS(Man);
   IF !Man.INN THEN
    RETURN L_Prop.mac_Inside;
   ELSE
    RETURN L_Prop.mac_Full;
   END;
  ELSE
   RETURN L_Prop.mac_Full;
  END;
 END {PropertyModificationAllowed};

 PRIVATE PROCEDURE CheckModificationAllowed(Text: STRING[]);
 BEGIN
  IF ManPro.Property = P_ManPhoto THEN
   L_General.Assert_wReferToAdmin(0, Text);
  END;
 END {CheckModificationAllowed};

 PUBLIC PROCEDURE OnBeforeDelete();
 BEGIN
  CheckModificationAllowed(" ᢮⢠");
  ResetSal(EMPTYOF(DATE));
 END {OnBeforeDelete};

 PRIVATE PROCEDURE ds_StdLatinName(OldStyle: SCAL[2]): STRING[];
  VAR
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  CONFORM(ManPro, Man);
  IF OldStyle THEN
   L_Man.curMan_SplitName(Surname, FirstName, Patronymic);
   RETURN Str.Condense(L_Russia.RussianToTransliteration(Surname) + " " +
                       L_Russia.RussianToTransliteration(FirstName));
  ELSE
   RETURN Str.Condense(L_Russia.RussianToTransliteration(Man.Name));
  END;
 END {ds_StdLatinName};

 PUBLIC PROCEDURE OnBeforeInsert();
  VAR
   zeroCategories: tDriveCategories;
 BEGIN
  IF    ManPro.Property = P_AccessToTerritory THEN
   ManPro.DocNum  :=L_Str.Right(ManPro.Man, 5);
   ManPro.DocGiveD:=SYSDATE();
   REPLACE(ManPro);
(*  ELSIF ManPro.Property = P_DriveSertification THEN
   IF !ManPro.Value THEN
    SETZERO(zeroCategories);
    Encode_DriveSertification(ManPro.Value, zeroCategories, 0, "", ds_StdLatinName());
    REPLACE(ManPro);
   END;
*)
  END;
 END {OnBeforeInsert};

 PUBLIC PROCEDURE OnAfterEdit();
 BEGIN
  IF    (ManPro.Property = P_SpecificNDFL) |
        (ManPro.Property = P_SalaryInAPFY) THEN
   ResetSal(GE_PVALUE(ManPro.Date));
  END;
 END {OnAfterEdit};

 PUBLIC PROCEDURE OnAfterInsert();
 BEGIN
  IF    (ManPro.Property = P_SpecificNDFL) |
        (ManPro.Property = P_SalaryInAPFY) THEN
   ResetSal(EMPTYOF(DATE));
  END;
 END {OnAfterInsert};

 PUBLIC PROCEDURE HasManPro(trgMan: LIKE(Man.Man); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  SETSEL(ManPro, Man, trgMan, trgProperty);
  RETURN SRCINSEL(ManPro, LE, D);
 END {HasManPro};

 PUBLIC PROCEDURE AccessManPro(trgMan: LIKE(Man.Man); D: DATE; trgProperty: LIKE(Property.Property));
 BEGIN
  IF ~HasManPro(trgMan, D, trgProperty) THEN
   SEARCH(Man, Man, , trgMan);
   L_Prop.ShowUndefinedProValueError(TABLE.Get("Man").Id, Man.RECORDID, trgProperty, D);
  END;
 END {AccessManPro};

 PRIVATE PROCEDURE IsPropertyAllowedSpeedSearch(trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN (trgProperty = P_Pass);
 END {IsPropertyAllowedSpeedSearch};

 PUBLIC PROCEDURE GetSpeedSearchResults(D: DATE; trgProperty: LIKE(Property.Property); SearchValue: STRING[]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  L_General.CallUs(IsPropertyAllowedSpeedSearch(trgProperty));
  SETEMPTY(Result);
  SETSEL(ManPro, Property, trgProperty, Str.Cap(SearchValue));
  FOR_EACH ManPro DO
   IF L_DatTim.IsActive_Inc(D, ManPro.Date, ManPro.EndDate) THEN
    Result:=L_Str.AddStrDlm(Result, "|") + ManPro.Man;
   END;
  END; (* FOR_EACH ManPro *)
  RETURN Result;
 END {GetSpeedSearchResults};

 PUBLIC PROCEDURE SingleSpeedSearch(D: DATE; trgProperty: LIKE(Property.Property); SearchValue: STRING[]): SCAL[2];
 BEGIN
  L_General.CallUs(IsPropertyAllowedSpeedSearch(trgProperty));
  SETSEL(ManPro, Property, trgProperty, Str.Cap(SearchValue));
  FOR_EACH ManPro DO
   IF L_DatTim.IsActive_Inc(D, ManPro.Date, ManPro.EndDate) THEN
    RETURN 1;
   END;
  END; (* FOR_EACH ManPro *)
  RETURN 0;
 END {SingleSpeedSearch};

 PUBLIC PROCEDURE HasActualManPro(trgMan: LIKE(Man.Man); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasManPro(trgMan, D, trgProperty) & (!ManPro.DocExpD | (D < ManPro.DocExpD));
 END {HasActualManPro};

 PUBLIC PROCEDURE HasActualManProInIntvl(trgMan     : LIKE(Man.Man);
                                         From,
                                         UpTo       : DATE;
                                         trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  SETSEL(ManPro, Man, trgMan, trgProperty);
  IF SRCINSEL(ManPro, LE, From) | SRCINSEL(ManPro, GE, From) THEN
   WHILE OCCURE(ManPro) & (ManPro.Date <= UpTo) DO
    IF L_DatTim.IsActiveInIntvl(From, UpTo, ManPro.Date, ManPro.DocExpD) THEN
     RETURN 1;
    END;
    NEXT(ManPro);
   END; (* WHILE OCCURE(ManPro) ... *)
  END;
  RETURN 0;
 END {HasActualManProInPer};

 PUBLIC PROCEDURE GetManProStrong(trgMan: LIKE(Man.Man); D: DATE; trgProperty: LIKE(Property.Property)): LIKE(ManPro.Value);
 BEGIN
  IF HasActualManPro(trgMan, D, trgProperty) THEN
   RETURN ManPro.Value;
  END;
  SEARCH(Man, Man, , trgMan);
  L_Prop.ShowUndefinedProValueError(TABLE.Get("Man").Id, Man.RECORDID, trgProperty, D);
 END {GetManProStrong};

 PUBLIC PROCEDURE GetManProSoft(trgMan: LIKE(Man.Man); D: DATE; trgProperty: LIKE(Property.Property)): LIKE(ManPro.Value);
  VAR
   _Value: LIKE(ManPro.Value);
 BEGIN
  IF HasActualManPro(trgMan, D, trgProperty) THEN
   _Value:=ManPro.Value;
  ELSE
   SETEMPTY(_Value);
  END;
  RETURN _Value;
 END {GetManProSoft};

 PUBLIC PROCEDURE GetManProDate(trgMan: LIKE(Man.Man); D: DATE; trgProperty: LIKE(Property.Property)): DATE;
 BEGIN
  AccessManPro(trgMan, D, trgProperty); RETURN ManPro.Date;
 END {GetManProDate};

 PUBLIC PROCEDURE GetManProEndDate(trgMan: LIKE(Man.Man); D: DATE; trgProperty: LIKE(Property.Property)): DATE;
 BEGIN
  AccessManPro(trgMan, D, trgProperty); RETURN ManPro.EndDate;
 END {GetManProEndDate};

 PUBLIC PROCEDURE GetManProDocNum(trgMan: LIKE(Man.Man); D: DATE; trgProperty: LIKE(Property.Property)): LIKE(ManPro.DocNum);
 BEGIN
  AccessManPro(trgMan, D, trgProperty); RETURN ManPro.DocNum;
 END {GetManProDocNum};

 PUBLIC PROCEDURE GetManProDocGiveS(trgMan: LIKE(Man.Man); D: DATE; trgProperty: LIKE(Property.Property)): LIKE(ManPro.DocGiveS);
 BEGIN
  AccessManPro(trgMan, D, trgProperty); RETURN ManPro.DocGiveS;
 END {GetManProDocGiveS};

 PUBLIC PROCEDURE GetManProDocGiveD(trgMan: LIKE(Man.Man); D: DATE; trgProperty: LIKE(Property.Property)): LIKE(ManPro.DocGiveD);
 BEGIN
  AccessManPro(trgMan, D, trgProperty); RETURN ManPro.DocGiveD;
 END {GetManProDocGiveD};

 PUBLIC PROCEDURE GetManProDocExpD(trgMan: LIKE(Man.Man); D: DATE; trgProperty: LIKE(Property.Property)): DATE;
 BEGIN
  AccessManPro(trgMan, D, trgProperty); RETURN ManPro.DocExpD;
 END {GetManProDocExpD};

 PRIVATE PROCEDURE GetWorkCtcVal(D         : DATE;
                                 cvt       : L_ctc.tValType;
                                 trgContact: LIKE(Contact.Contact);
                                 trgInherit: LIKE(CtcVal.Inherit)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF L_ctc.PosToInheritCtcVal(trgContact, D, L_ctc.cvc_Work, cvt, trgInherit) THEN
   Result:=CtcVal.Value;
  END;
  RETURN Result;
 END {GetWorkCtcVal};

 PRIVATE PROCEDURE GetwApplExtPhoneWithExt(D         : DATE;
                                           cvt       : L_ctc.tValType;
                                           ParContact: LIKE(Contact.Contact);
                                           trgContact: LIKE(Contact.Contact) ): STRING[];
  VAR
   Ext,
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF ~!trgContact THEN
   IF L_ctc.cvt_IswApplExtPhone(cvt) & L_ctc.PosToCtcVal(trgContact, D, L_ctc.cvc_Work, L_ctc.cvt_Extension) THEN
    Ext:=CtcVal.Value;
    IF L_ctc.PosToInheritCtcVal(ParContact, D, L_ctc.cvc_Work, cvt, L_ctc.cvi_wApplExt) THEN
     Result:=CtcVal.Value + " (*" + Ext + ")";
    END;
   END;
  END;
  IF !Result THEN
   Result:=GetWorkCtcVal(D, cvt, ParContact, L_ctc.cvi_wApplExt);
   IF !Result THEN
    IF !trgContact THEN
     Result:=GetWorkCtcVal(D, cvt, ParContact, L_ctc.cvi_Inherit);
    ELSE
     Result:=GetWorkCtcVal(D, cvt, ParContact, L_ctc.cvi_NotInherit);
    END;
   END;
  END;
  RETURN Result;
 END {GetwApplExtPhoneWithExt};

 PRIVATE PROCEDURE GetOfficerManwApplExtPhoneWithExt(D: DATE; cvt : L_ctc.tValType): STRING[];
  VAR
   Result : STRING[];
   _ManCtc: LIKE(Man.Contact);
 BEGIN
  SETEMPTY(Result);
  _ManCtc:=Man.Contact;

  IF OCCURE(Staff) & (Staff.BegDate <= D) THEN
   L_Staff.PosToStaffLog(Staff.TSN, D, 1);
   CONFORM(StaffLog, Officer);
   IF OCCURE(Officer) & ~!Officer.Contact THEN
    Result:=GetwApplExtPhoneWithExt(D, cvt, Officer.Contact, _ManCtc);
   END;
  END;

  RETURN Result;
 END {GetOfficerManwApplExtPhoneWithExt};

 PUBLIC PROCEDURE GetManWorkCtcInf(trgMan: LIKE(Man.Man); D: DATE; cvt: L_ctc.tValType): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  SAVE(Man);
  IF SEARCH(Man, Man, trgMan) THEN
   IF ~!Man.Contact THEN
    Result:=GetwApplExtPhoneWithExt(D, cvt, Man.Contact, Man.Contact);
   END;
 
   IF !Result THEN
    SAVE(Staff);
    IF L_Staff.IsStandOnAnyMainContract(Man.Man, D) THEN
     Result:=GetOfficerManwApplExtPhoneWithExt(D, cvt);
    END;
    RESTORE(Staff);
   END;
  END;
  RESTORE(Man);
  RETURN Result;
 END {GetManWorkCtcInf};

 PUBLIC PROCEDURE GetStaffWorkCtcInf(trgTSN: LIKE(Staff.TSN); D: DATE; cvt: L_ctc.tValType): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  SAVE(Staff);
  IF SEARCH(Staff, TSN, trgTSN) THEN
   SAVE(Man);
   CONFORM(Staff, Man);
   IF ~!Man.Contact THEN
    Result:=GetwApplExtPhoneWithExt(D, cvt, Man.Contact, Man.Contact);
   END;

   IF !Result THEN
    Result:=GetOfficerManwApplExtPhoneWithExt(D, cvt);
   END;
   RESTORE(Man);
  END;
  RESTORE(Staff);
  RETURN Result;
 END {GetStaffWorkCtcInf};

 PRIVATE PROCEDURE convContactInf2ValType(ci_Type: tContactInf): L_ctc.tValType;
 BEGIN
  IF    ci_Type = ci_ExtTelefon    THEN RETURN L_ctc.cvt_PhonePST;
  ELSIF ci_Type = ci_IntTelefon    THEN RETURN L_ctc.cvt_PhoneLoc;
  ELSIF ci_Type = ci_MblTelefon    THEN RETURN L_ctc.cvt_PhoneClr;
  ELSIF ci_Type = ci_EMail         THEN RETURN L_ctc.cvt_Email;
  ELSIF ci_Type = ci_EMail_for_SMS THEN RETURN L_ctc.cvt_SMSEml;
  END;
 END {convContactInf2ValType};

 PUBLIC PROCEDURE GetStaffWorkTelefon(D: DATE; ci_Type: tContactInf): STRING[];
 BEGIN
  RETURN GetStaffWorkCtcInf(Staff.TSN, D, convContactInf2ValType(ci_Type));
 END {GetStaffWorkTelefon};

 PUBLIC PROCEDURE GetManWorkTelefon(trgMan: LIKE(Man.Man); D: DATE; ci_Type: tContactInf): STRING[];
 BEGIN
  RETURN GetManWorkCtcInf(trgMan, D, convContactInf2ValType(ci_Type));
 END {GetManWorkTelefon};

 PUBLIC PROCEDURE Try_curUSER2Man(): LIKE(Man.Man);
  VAR
   Result: LIKE(Man.Man);
 BEGIN
  SAVE(AcsObj);
  SEARCH(AcsObj, AcsObj, , L_General.curUSER);
  Result:=AcsObj.Man;
  RESTORE(AcsObj);
  RETURN Result;
 END {Try_curUSER2Man};

 PUBLIC PROCEDURE curUSER2Man(): LIKE(Man.Man);
  VAR
   Result: LIKE(Man.Man);
 BEGIN
  Result:=Try_curUSER2Man();
  IF !Result THEN
   L_General.Error(" ࠢ筨 '짮⥫' ᫥ 㪠     '" + APP.Get().MyConnection.LoginName + "'");
  END;
  RETURN Result;
 END {curUSER2Man};

 PUBLIC PROCEDURE GetFullNameOfCurrentUser(D: DATE): STRING[];
  VAR
   curMan: LIKE(Man.Man);
   Result: STRING[];
 BEGIN
  IF L_General.BatchExecution_IsRunning() THEN
   SAVE(AcsObj);
   SEARCH(AcsObj, AcsObj, , L_General.BatchExecution_AuthorAscObj());
   curMan:=AcsObj.Man;
   RESTORE(AcsObj);
  ELSE
   curMan:=Try_curUSER2Man();
  END;
  IF ~!curMan THEN
   SAVE(Man);
   SEARCH(Man, Man, , curMan);
   Result:=Man.Name;
   RESTORE(Man);
  ELSE
   Result:=APP.Get().MyConnection.FullName;
  END;
  RETURN Result;
 END {GetFullNameOfCurrentUser};

 PUBLIC PROCEDURE CanHaveProp(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_LaborActivityLicense THEN
   L_General.Assert(L_Man.LaborActivityLicenseRequired(ManPro.Man, SYSDATE()),
                    "ࠢ  㤮 ⥫쭮  ⮣   ॡ");
  ELSIF trgProperty = P_MigrationCard THEN
   IF ~L_Man.AccessManAdr(ManPro.Man, SYSDATE(), L_Russia.at_CtMA) THEN
    L_Man.AccessRgManAdr(ManPro.Man, SYSDATE());
   END;
   L_General.Assert(ManAdr.Country # L_Russia.c_Russia, "樮  뤠 ⮫쪮 ࠭栬!");
  ELSIF trgProperty = P_ResidencePermit THEN
   L_General.Assert(L_Man.Man_Citizen(ManPro.Man, SYSDATE()) > L_Man.ct_Moscow,
                   " 뤠 ⮫쪮 த!");
  END;
 END {CanHaveProp};

 PRIVATE PROCEDURE SetWinFieldFlagEdit(trgProperty: LIKE(Property.Property));
  VAR
   curNDFLStatus: STRING[];
   Fields       : FORM_FIELDS;
   Idx          : NUMERIC[0];
   OldStyle     : SCAL[2];
 BEGIN
  IF trgProperty = P_SpecificNDFL THEN
   L_WDO.getFieldValue("v_NDFLStatus", curNDFLStatus);
   IF curNDFLStatus = L_Str.PoolItem(ndfls_Pool, ndfls_Auto) THEN
    L_WDO.SetFieldModifiable("v_NDFLDaysInRussia", 1);
   ELSE
    L_WDO.setFieldValue("v_NDFLDaysInRussia", EMPTYOF(tNDFLDaysInRussia));
    L_WDO.SetFieldModifiable("v_NDFLDaysInRussia", 0);
   END;
  ELSIF trgProperty = P_DriveSertification THEN
   Fields     :=RTI.Get().CurZone.Fields;
   OldStyle:=Fields("OldStyle").Value;
   Fields("Trolleybus").Visible:=OldStyle;
   Fields(L_WDO.Fld_wIdx("DrvCategory", 0)).Visible:=OldStyle;
   Idx:=1;
   WHILE Idx <= 3 DO
    Fields(L_WDO.Fld_wIdx("DrvCategory", Idx)).Visible:=OldStyle;
    Fields(L_WDO.Fld_wIdx(L_WDO.Fld_wIdx("DrvCategory", Idx), 2)).Visible:=OldStyle;
    INC(Idx);
   END;
   Idx:=0;
   WHILE Idx <= 15 DO
    Fields(L_WDO.Fld_wIdx("DrvCategoryNew", Idx)).Modifiable:=~OldStyle;
    INC(Idx);
   END;
  END;
 END {SetWinFieldFlagEdit};

 PRIVATE PROCEDURE ds_OldStyle2New(Fields: FORM_FIELDS);
 BEGIN
  Fields("DrvCategoryNew_0" ).Value:=Fields("DrvCategory_0").Value;
  Fields("DrvCategoryNew_1" ).Value:=Fields("DrvCategory_0").Value;
  Fields("DrvCategoryNew_2" ).Value:=Fields("DrvCategory_1").Value;
  Fields("DrvCategoryNew_3" ).Value:=Fields("DrvCategory_1").Value;
  Fields("DrvCategoryNew_4" ).Value:=Fields("DrvCategory_2").Value;
  Fields("DrvCategoryNew_5" ).Value:=Fields("DrvCategory_2").Value;
  Fields("DrvCategoryNew_6" ).Value:=Fields("DrvCategory_3").Value;
  Fields("DrvCategoryNew_7" ).Value:=Fields("DrvCategory_3").Value;
  Fields("DrvCategoryNew_8" ).Value:=Fields("DrvCategory_1_2").Value;
  Fields("DrvCategoryNew_9" ).Value:=Fields("DrvCategory_2_2").Value;
  Fields("DrvCategoryNew_10").Value:=Fields("DrvCategory_2_2").Value;
  Fields("DrvCategoryNew_11").Value:=Fields("DrvCategory_3_2").Value;
  Fields("DrvCategoryNew_12").Value:=Fields("DrvCategory_3_2").Value;
  Fields("DrvCategoryNew_13").Value:=Fields("DrvCategory_0").Value |
                                     Fields("DrvCategory_1").Value |
                                     Fields("DrvCategory_2").Value |
                                     Fields("DrvCategory_3").Value;
  Fields("DrvCategoryNew_14").Value:=0;
  Fields("DrvCategoryNew_15").Value:=Fields("Trolleybus").Value;
 END {ds_OldStyle2New};

 PRIVATE PROCEDURE ds_NewStyle2Old(Fields: FORM_FIELDS);
 BEGIN
  Fields("DrvCategory_0").Value  :=Fields("DrvCategoryNew_0" ).Value;
  Fields("DrvCategory_1").Value  :=Fields("DrvCategoryNew_2" ).Value;
  Fields("DrvCategory_2").Value  :=Fields("DrvCategoryNew_4" ).Value;
  Fields("DrvCategory_3").Value  :=Fields("DrvCategoryNew_6" ).Value;
  Fields("DrvCategory_1_2").Value:=Fields("DrvCategoryNew_8" ).Value;
  Fields("DrvCategory_2_2").Value:=Fields("DrvCategoryNew_9" ).Value;
  Fields("DrvCategory_3_2").Value:=Fields("DrvCategoryNew_11").Value;
  Fields("Trolleybus").Value     :=Fields("DrvCategoryNew_15").Value;
 END {ds_NewStyle2Old};

 PUBLIC PROCEDURE OnSuccessfulChange(trgProperty: LIKE(Property.Property));
  VAR
   Idx        : NUMERIC[0];
   Fields     : FORM_FIELDS;
   Possibility: SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF    trgProperty = P_SpecificNDFL THEN
   SetWinFieldFlagEdit(trgProperty);
  ELSIF trgProperty = P_DriveSertification THEN
   IF RTI.Get().CurZone.ActiveField.Name = "OldStyle" THEN
    IF Fields("OldStyle").Value THEN
     ds_NewStyle2Old(Fields);
    ELSE
     SETEMPTY(Fields(L_WDO.Fld_wIdx("DrvCategory", 0)).Value, Fields("Trolleybus").Value);
     Idx:=1;
     WHILE Idx <= 3 DO
      SETEMPTY(Fields(L_WDO.Fld_wIdx("DrvCategory", Idx)).Value,
               Fields(L_WDO.Fld_wIdx(L_WDO.Fld_wIdx("DrvCategory", Idx), 2)).Value);
      INC(Idx);
     END;
    END;
    IF Fields("LatinName").Value = ds_StdLatinName(~Fields("OldStyle").Value) THEN
     Fields("LatinName").Value:=ds_StdLatinName(Fields("OldStyle").Value);
    END;
   END;
   IF Fields("OldStyle").Value THEN
    ds_OldStyle2New(Fields);
   END;
   SetWinFieldFlagEdit(trgProperty);
  ELSIF trgProperty = P_Vaccination THEN
   IF Str.Match(RTI.Get().CurZone.ActiveField.Name, "Possibility_*") THEN
    Possibility:=RTI.Get().CurZone.ActiveField.Value;
    IF !Possibility THEN
     Possibility:=1;
    END;
    Idx:=L_WDO.getFldIdx(RTI.Get().CurZone.ActiveField.Name);
    SETEMPTY(Fields(L_WDO.Fld_wIdx("Date",        Idx)).Value,
             Fields(L_WDO.Fld_wIdx("SerNbr",      Idx)).Value,
             Fields(L_WDO.Fld_wIdx("UsefulTime",  Idx)).Value);
    Fields(L_WDO.Fld_wIdx("Date",        Idx)).Modifiable:=Possibility;
    Fields(L_WDO.Fld_wIdx("SerNbr",      Idx)).Modifiable:=Possibility;
    Fields(L_WDO.Fld_wIdx("UsefulTime",  Idx)).Modifiable:=Possibility;
   END;
  END;
 END {OnSuccessfulChange};

 PUBLIC PROCEDURE Date_OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_AccessToTerritory THEN
   SetOutsiderDescrFieldsModifiable();
  END;
 END {Date_OnSuccessfulChange};

 PRIVATE PROCEDURE ds_IsNewStyle(curVal: STRING[]): SCAL[2];
 BEGIN
  RETURN !L_Prop.getAIS(curVal, 0);
 END {ds_IsNewStyle};

 PUBLIC PROCEDURE GetCurDriveSertification_NewStyleCategory(): STRING[];
 BEGIN
  RETURN L_Prop.getAIS(ManPro.Value, 4);
 END {GetCurDriveSertification_Category};

 PUBLIC PROCEDURE GetDriveSertification_Category(trgMan: LIKE(Man.Man); D: DATE): STRING[];
 BEGIN
  IF HasActualManPro(trgMan, D, P_DriveSertification) THEN
   IF ds_IsNewStyle(ManPro.Value) THEN
    RETURN L_Prop.getAIS(ManPro.Value, 4);
   ELSE
    RETURN L_Prop.getAIS(ManPro.Value, 0);
   END;
  ELSE
   RETURN "";
  END;
 END {GetDriveSertification_Category};

 PUBLIC PROCEDURE GetDriveSertification_NewStyleCategory(trgMan: LIKE(Man.Man); D: DATE): STRING[];
 BEGIN
  IF HasActualManPro(trgMan, D, P_DriveSertification) THEN
   RETURN L_Prop.getAIS(ManPro.Value, 4);
  ELSE
   RETURN "";
  END;
 END {GetDriveSertification_NewStyleCategory};

 PUBLIC PROCEDURE ds_HasCategory(trgMan: LIKE(Man.Man); D: DATE; trgCat: STRING[]): SCAL[2];
 BEGIN
  RETURN Str.Match(";"+GetDriveSertification_NewStyleCategory(trgMan, D)+";", "*;"+trgCat+";*");
 END {ds_HasCategory};

 PUBLIC PROCEDURE GetDriveSertification_LatinName(trgMan: LIKE(Man.Man); D: DATE): STRING[];
 BEGIN
  IF HasActualManPro(trgMan, D, P_DriveSertification) THEN
   RETURN L_Prop.getAIS(ManPro.Value, 3);
  ELSE
   RETURN "";
  END;
 END {GetDriveSertification_LatinName};

(*PUBLIC ⮫쪮   *)
 PUBLIC  PROCEDURE Decode_DriveSertification(    curVal     : LIKE(ManPro.Value);
                                             VAR DrvCategory: tDriveCategories;
                                             VAR dc         : SCAL[2][dcn_Amount];
                                             VAR Trolleybus : SCAL[2];
                                             VAR Comments,
                                                 LatinName  : STRING[]);
   VAR
   i,
   Idx,
   DrvCat   : NUMERIC[0];
   Category,
   iCat,
   Letter   : STRING[];
   Val      : SCAL[3];
 BEGIN
  Trolleybus:=L_Prop.getAIS(curVal, 1) = "1";
  Comments  :=L_Prop.getAIS(curVal, 2);
  LatinName :=L_Prop.getAIS(curVal, 3);
  IF ~ds_IsNewStyle(curVal) THEN
   SETZERO(DrvCategory, i);
   Category  :=L_Prop.getAIS(curVal, 0);
   iCat      :=L_Prop.getRES(Category, i);
   WHILE ~!iCat DO
    IF Str.Item(iCat, "", 0) # 'E' THEN
     Letter:=iCat;
     Val   :=dc_Has;
    ELSE
     Letter:=Str.Item(iCat, "", 1);
     Val   :=dc_AddE;
    END;
    Idx:=Str.Pos(dc_Pool, Letter);
    IF Idx < dc_Amount THEN
     DrvCategory[Idx]:=Val;
    END;
    INC(i);
    iCat:=L_Prop.getRES(Category, i);
   END; (* WHILE ~!iCat ... *)
  ELSE
   SETEMPTY(DrvCategory);
  END;
  Category  :=L_Prop.getAIS(curVal, 4);
  SETZERO(dc, i);
  WHILE ~!L_Prop.getRES(Category, i) DO
   dc[L_Str.PositionInPool(L_Way.mc_Pool, L_Prop.getRES(Category, i))]:=1;
   INC(i);
  END; (* WHILE ~!iCat ... *)
 END {Decode_DriveSertification};

 PRIVATE PROCEDURE formSet_DriveSertification();
  VAR
   DrvCategory: tDriveCategories;
   Idx        : SCAL[dc_Amount];
   Fields     : FORM_FIELDS;
   i: SCAL[dcn_Amount];
   dc: SCAL[2][dcn_Amount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("OldStyle").Value:=~ds_IsNewStyle(ManPro.Value);
  Decode_DriveSertification(ManPro.Value, DrvCategory, dc, Fields("Trolleybus").Value, Fields("Comments").Value, Fields("LatinName").Value);
  IF !Fields("LatinName").Value THEN
   Fields("LatinName").Value:=ds_StdLatinName(Fields("OldStyle").Value);
  END;
  FOR_EACH Idx DO
   IF Fields("OldStyle").Value THEN
    Fields(L_WDO.Fld_wIdx("DrvCategory", Idx)).Value:=DrvCategory[Idx] # 0;
    IF Idx > 0 THEN
     Fields(L_WDO.Fld_wIdx(L_WDO.Fld_wIdx("DrvCategory", Idx), 2)).Value:=DrvCategory[Idx] = dc_AddE;
    END;
   ELSE
    SETEMPTY(Fields(L_WDO.Fld_wIdx("DrvCategory", Idx)).Value);
    IF Idx > 0 THEN
     SETEMPTY(Fields(L_WDO.Fld_wIdx(L_WDO.Fld_wIdx("DrvCategory", Idx), 2)).Value);
    END;
   END;
  END;
  FOR_EACH i DO
   Fields(L_WDO.Fld_wIdx("DrvCategoryNew", i)).Value:=dc[i];
  END;
 END {formSet_DriveSertification};

 PRIVATE PROCEDURE dc_AddStrValue(DrvCategory: tDriveCategories; Has: SCAL[3]; AddS: STRING[]; VAR Val: STRING[]);
  VAR
   Idx: SCAL[dc_Amount];
   s  : STRING[];
 BEGIN
  FOR_EACH Idx DO
   IF DrvCategory[Idx] >= Has THEN
    s:=AddS + L_Str.Char(dc_Pool, Idx);
    L_Prop.putREV(Val, s);
   END;
  END;
 END {dc_AddStrValue};

(*PUBLIC ⮫쪮   *)
 PUBLIC PROCEDURE Encode_DriveSertification(VAR curVal     : LIKE(ManPro.Value);
                                                DrvCategory: tDriveCategories;
                                                dc         : SCAL[2][dcn_Amount];
                                                Trolleybus : SCAL[2];
                                                Comments,
                                                LatinName  : STRING[]);
  VAR
   Val: STRING[];
   i  : SCAL[dcn_Amount];
 BEGIN
  SETEMPTY(Val, curVal);
  IF ~!DrvCategory[0] THEN
   dc_AddStrValue(DrvCategory, dc_Has,  "",   Val);
   dc_AddStrValue(DrvCategory, dc_AddE, "E", Val);
  END;
  L_Prop.putAIS(curVal, Val);
  L_Prop.putAIS(curVal, Trolleybus);
  L_Prop.putAIS(curVal, Comments);
  L_Prop.putAIS(curVal, LatinName);
  SETEMPTY(Val);
  FOR_EACH i DO
   IF dc[i] THEN
    L_Prop.putRES(Val, L_Str.PoolItem(L_Way.mc_Pool, i));
   END;
  END;
  L_Prop.putAIS(curVal, Val);
 END {Encode_DriveSertification};

 PRIVATE PROCEDURE dc_Check(dc: SCAL[2][dcn_Amount];i1, i2: NUMERIC[0]);
 BEGIN
  L_General.Assert(~dc[i1] | dc[i2], "⥣ " + L_Str.PoolItem(L_Way.mc_Pool, i1) +
                                     "     ⥣ਨ " + L_Str.PoolItem(L_Way.mc_Pool, i2));
 END {dc_Check};

 PRIVATE PROCEDURE formGet_DriveSertification();
  VAR
   DrvCategory: tDriveCategories;
   Idx        : SCAL[dc_Amount];
   i          : SCAL[dcn_Amount];
   Fields     : FORM_FIELDS;
   dc         : SCAL[2][dcn_Amount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH i DO
   dc[i]:=Fields(L_WDO.Fld_wIdx("DrvCategoryNew", i)).Value;
  END;
  IF Fields("OldStyle").Value THEN
   FOR_EACH Idx DO
    DrvCategory[Idx]:=Fields(L_WDO.Fld_wIdx("DrvCategory", Idx)).Value;
    IF (Idx > 0) & Fields(L_WDO.Fld_wIdx(L_WDO.Fld_wIdx("DrvCategory", Idx), 2)).Value THEN
     L_General.Assert(DrvCategory[Idx], "⥣ E" + dc_Pool[Idx] + "     ⥣ਨ " + dc_Pool[Idx]);
     DrvCategory[Idx]:=dc_AddE;
    END;
   END;
  ELSE
   dc_Check(dc, 0, 1);
   dc_Check(dc, 2, 3);
   dc_Check(dc, 4, 5);
   dc_Check(dc, 6, 7);
   dc_Check(dc, 8, 2);
   dc_Check(dc, 9, 4);
   dc_Check(dc, 10, 5);
   dc_Check(dc, 11, 6);
   dc_Check(dc, 12, 7);
   SETEMPTY(DrvCategory);
  END;
  Encode_DriveSertification(ManPro.Value, DrvCategory, dc, Fields("Trolleybus").Value, Fields("Comments").Value, Fields("LatinName").Value);
 END {formGet_DriveSertification};

 PUBLIC PROCEDURE sapfy_DecodeValue(VAR APFYYear: SCAL[1E4][]; VAR APFYSal: NUMERIC[2][]; VAR APFYDays: NUMERIC[0][]);
  VAR
   i        : SCAL[apfy_Amount];
   ArrayItem: STRING[];
 BEGIN
  SETEMPTY(APFYYear, APFYSal, APFYDays);
  FOR_EACH i DO
   ArrayItem:=L_Prop.getAIS(ManPro.Value, i);
   APFYYear[i]:=L_Prop.GetNumericValueFromStr(L_Prop.getRES(ArrayItem, 0));
   APFYSal[i] :=L_Prop.GetNumericValueFromStr(L_Prop.getRES(ArrayItem, 1));
   APFYDays[i]:=L_Prop.GetNumericValueFromStr(L_Prop.getRES(ArrayItem, 2));
  END;
 END {sapfy_DecodeValue};

 PRIVATE PROCEDURE formSet_SpecificNDFL();
  VAR
   tmpValue: STRING[];
 BEGIN
  tmpValue:=L_Prop.getRES(ManPro.Value, 0);
  IF !tmpValue THEN
   L_WDO.setFieldValue("v_NDFLStatus", L_Str.PoolItem(ndfls_Pool, ndfls_Auto));
  ELSE
   L_WDO.setFieldValue("v_NDFLStatus", tmpValue);
  END;
  L_WDO.setFieldValue("v_NDFLDaysInRussia", L_Prop.getRES(ManPro.Value, 1));
  L_WDO.SetFieldStrongTemplate("v_NDFLStatus", ndfls_Pool);
 END {formSet_SpecificNDFL};

 PUBLIC PROCEDURE GetNDFLInf(VAR curNDFLStatus: tNDFLStatus; VAR curNDFLDaysInRussia: tNDFLDaysInRussia);
 BEGIN
  curNDFLStatus:=L_Str.PositionInPool(ndfls_Pool, L_Prop.getRES(ManPro.Value, 0));
  curNDFLDaysInRussia:=L_Prop.getRES(ManPro.Value, 1);
  IF !curNDFLDaysInRussia THEN
   curNDFLDaysInRussia:=0;
  END;
 END {GetNDFLInf};

 PRIVATE PROCEDURE ManualChooseManPhoto();
  VAR
   ChooseFD          : CHOOSEFILEDIALOG;
   FullFileName,
   PhotoArchiveFolder: STRING[];
 BEGIN
  PhotoArchiveFolder           :=GetPhotoArchiveFolder();
  L_FIO.MakeSubDirs(PhotoArchiveFolder);
  IF L_General.IsAcceptableProcessorVersion(014260150) THEN
   ChooseFD                     :=CHOOSEFILEDIALOG.Create(FIO.BuildPath("*.*", , PhotoArchiveFolder));
  ELSE
   ChooseFD                     :=CHOOSEFILEDIALOG.Create(FIO.BuildPath("*.jpg", , PhotoArchiveFolder));
  END;
  ChooseFD.FilesAreAcceptable  :=1;
  ChooseFD.FoldersAreAcceptable:=0;
  FullFileName                 :=ChooseFD.Deal();
  IF ~!FullFileName THEN
   ManPro.Value:=L_FIO.effp_FileName(FullFileName);
   REPLACE(ManPro);
  END;
 END {ManualChooseManPhoto};

 PUBLIC PROCEDURE CheckPINCode(EncryptPIN,
                               PINCode    : STRING[];
                               trgMan     : LIKE(Man.Man);
                               D          : DATE;
                               Silent     : SCAL[2]): tAuthorizationResult;
 BEGIN
  TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
   IF DECRYPTSTR(EncryptPIN, PINCode, CALG_RC2, , , CSP_NAME_MS_BASE) = (FLDTOSTR(PINCode) + FLDTOSTR(trgMan)) THEN
    RETURN ar_Granted;
   ELSE
    RETURN ar_Denied;
   END;
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF    Exc.ErrorCode = 482 THEN
    RETURN ar_Denied;
   ELSIF (Exc.ErrorCode = 138) |
         (Exc.ErrorCode = 164) |
         (Exc.ErrorCode = 165) THEN
    L_General.Assert(Silent, Exc.MsgOriginalText);
    RETURN ar_BadPIN;
   ELSE
    L_General.Assert(Silent, "ந諠 訡  ஢થ - (" +
                             L_Str.IntStr(Exc.ErrorCode) + ")| |" +
                             "   ⤥ ஢");
    RETURN ar_BadPIN;
   END;
  ELSE
   RAISE();
  END; (* TRY *)
 END {CheckPINCode};

 PRIVATE PROCEDURE Decode_Pass(    curValue: STRING[];
                               VAR CardType: L_ACS.tCardType;
                               VAR CardCode: NUMERIC[0]);
 BEGIN
  CardType:=L_Str.PositionInPool(L_ACS.ct_Pool, L_Prop.getRES(curValue, 0));
  CardCode:=STRTOFLD(L_Prop.getRES(curValue, 1), NUMERIC);
 END {Decode_Pass};

 PRIVATE PROCEDURE formSet_Pass();
  VAR
   CardType: L_ACS.tCardType;
   CardCode: NUMERIC[0];
 BEGIN
  Decode_Pass(ManPro.Value, CardType, CardCode);
  RTI.Get().CurZone.Fields("CardCode").Value:=CardCode;
 END {formSet_Pass};

 PUBLIC PROCEDURE E_msk_GetPool(): STRING[];
  CONST
   defMassSendKind ="ᥬ 㤭|ᥬ 騭|ᥬ 稭|饭 ⥫  ࠬ  ० ࠡ  ";
 BEGIN
  RETURN defMassSendKind + "|" + L_Pool.Get(pool_UserDefinedSMSMassSendKind);
 END {E_msk_GetPool};

 PRIVATE PROCEDURE Decode_AnthropometricInf(    curValue      : STRING[];
                                            VAR Growth        : NUMERIC[0];
                                            VAR Weight        : NUMERIC[1];
                                            VAR SizeClothing  : NUMERIC[0];
                                            VAR SizeShoes     : NUMERIC[1];
                                            VAR SizeHat       : NUMERIC[0];
                                            VAR SizeMittens   : NUMERIC[0];
                                            VAR SizeGloves    : NUMERIC[1];
                                            VAR SizeMask      : NUMERIC[0];
                                            VAR SizeRespirator: NUMERIC[0]);
 BEGIN
  IF !curValue THEN
   SETEMPTY(Growth,
            Weight,
            SizeClothing,
            SizeShoes,
            SizeHat,
            SizeMittens,
            SizeGloves,
            SizeMask,
            SizeRespirator);
  ELSE
   Growth        :=STRTOFLD(L_Prop.getRES(curValue, 0), NUMERIC);
   Weight        :=STRTOFLD(L_Prop.getRES(curValue, 1), NUMERIC);
   SizeClothing  :=STRTOFLD(L_Prop.getRES(curValue, 2), NUMERIC);
   SizeShoes     :=STRTOFLD(L_Prop.getRES(curValue, 3), NUMERIC);
   SizeHat       :=STRTOFLD(L_Prop.getRES(curValue, 4), NUMERIC);
   SizeMittens   :=STRTOFLD(L_Prop.getRES(curValue, 5), NUMERIC);
   SizeGloves    :=STRTOFLD(L_Prop.getRES(curValue, 6), NUMERIC);
   SizeMask      :=STRTOFLD(L_Prop.getRES(curValue, 7), NUMERIC);
   SizeRespirator:=STRTOFLD(L_Prop.getRES(curValue, 8), NUMERIC);
  END;
 END {Decode_AnthropometricInf};

 PUBLIC PROCEDURE Get_AnthropometricInf(    trgMan        : LIKE(Man.Man);
                                            D             : DATE;
                                        VAR Growth        : NUMERIC[0];
                                        VAR Weight        : NUMERIC[1];
                                        VAR SizeClothing  : NUMERIC[0];
                                        VAR SizeShoes     : NUMERIC[1];
                                        VAR SizeHat       : NUMERIC[0];
                                        VAR SizeMittens   : NUMERIC[0];
                                        VAR SizeGloves    : NUMERIC[1];
                                        VAR SizeMask      : NUMERIC[0];
                                        VAR SizeRespirator: NUMERIC[0]);
 BEGIN
  Decode_AnthropometricInf(GetManProSoft(trgMan, D, P_AnthropometricInf),
                           Growth,
                           Weight,
                           SizeClothing,
                           SizeShoes,
                           SizeHat,
                           SizeMittens,
                           SizeGloves,
                           SizeMask,
                           SizeRespirator);
 END {Get_AnthropometricInf};

 PRIVATE PROCEDURE fsai_DecorField(Field: FORM_FIELD; pool: STRING[]; VAR val: FLOAT);
 BEGIN
  Field.Template        :=pool;
  Field.TemplateIsStrict:=1;
  Field.Value           :=val;
 END {fsai_DecorField};

 PRIVATE PROCEDURE formSet_AnthropometricInf();
  VAR
   Fields        : FORM_FIELDS;
   SizeClothing  : NUMERIC[0];
   SizeShoes     : NUMERIC[1];
   SizeHat       : NUMERIC[0];
   SizeMittens   : NUMERIC[0];
   SizeGloves    : NUMERIC[1];
   SizeMask      : NUMERIC[0];
   SizeRespirator: NUMERIC[0];
   Growth        : NUMERIC[0];
   Weight        : NUMERIC[1];
 BEGIN
  Decode_AnthropometricInf(ManPro.Value,
                           Growth,
                           Weight,
                           SizeClothing,
                           SizeShoes,
                           SizeHat,
                           SizeMittens,
                           SizeGloves,
                           SizeMask,
                           SizeRespirator);
  Fields:=RTI.Get().CurZone.Fields;
  fsai_DecorField(Fields("SizeClothing"  ), SizeClothing_Pool,   SizeClothing);
  fsai_DecorField(Fields("SizeShoes"     ), SizeShoes_Pool,      SizeShoes);
  fsai_DecorField(Fields("SizeHat"       ), SizeHat_Pool,        SizeHat);
  fsai_DecorField(Fields("SizeMittens"   ), SizeMittens_Pool,    SizeMittens);
  fsai_DecorField(Fields("SizeGloves"    ), SizeGloves_Pool,     SizeGloves);
  fsai_DecorField(Fields("SizeMask"      ), SizeMask_Pool,       SizeMask);
  fsai_DecorField(Fields("SizeRespirator"), SizeRespirator_Pool, SizeRespirator);
 END {formSet_AnthropometricInf};

 PRIVATE PROCEDURE formSet_Vaccination();
  VAR
   Fields     : FORM_FIELDS;
   Kind       : STRING[][v_Amnt];
   Idx        : SCAL    [v_Amnt];
   Date       : DATE    [v_Amnt];
   SerNbr     : STRING[][v_Amnt];
   UsefulTime : DATE    [v_Amnt];
   Possibility: SCAL[2] [v_Amnt];
   Modifiable : SCAL[2];
 BEGIN
  Decode_Vaccination(Kind, Possibility, Date, SerNbr, UsefulTime);
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   Fields(L_WDO.Fld_wIdx("Kind",        Idx)).Format:=v_KindPool;
   Fields(L_WDO.Fld_wIdx("Possibility", Idx)).Format:=v_PossibilityPool;
   Fields(L_WDO.Fld_wIdx("Kind",        Idx)).Value :=Idx;
   Fields(L_WDO.Fld_wIdx("Possibility", Idx)).Value :=Possibility[Idx];
   Fields(L_WDO.Fld_wIdx("Date",        Idx)).Value :=Date[Idx];
   Fields(L_WDO.Fld_wIdx("SerNbr",      Idx)).Value :=SerNbr[Idx];
   Fields(L_WDO.Fld_wIdx("UsefulTime",  Idx)).Value :=UsefulTime[Idx];
   Modifiable:=~!Possibility[Idx] & Possibility[Idx];
   Fields(L_WDO.Fld_wIdx("Date",        Idx)).Modifiable:=Modifiable;
   Fields(L_WDO.Fld_wIdx("SerNbr",      Idx)).Modifiable:=Modifiable;
   Fields(L_WDO.Fld_wIdx("UsefulTime",  Idx)).Modifiable:=Modifiable;
  END; (* FOR_EACH Idx...*)
 END {formSet_Vaccination};

 PRIVATE PROCEDURE Decode_SMSMassSendReceiver(    curValue  : STRING[];
                                              VAR Kinds     : tMassSendKind[];
                                              VAR IsReceiver: SCAL[2][]);
  VAR
   i        : NUMERIC[0];
   Pool,
   Singleval: STRING[];
 BEGIN
  Pool:=E_msk_GetPool();
  SETEMPTY(Kinds, IsReceiver);
  i:=0;
  LOOP
   Singleval:=L_Prop.getAIS(curValue, i);
   IF !Singleval THEN
    EXIT;
   END;
   Kinds[i]     :=L_Str.PositionInPool(Pool, L_Prop.getRES(Singleval, 0));
   IsReceiver[i]:=L_Prop.getRES(Singleval, 1);
   INC(i);
  END; (* LOOP *)
 END {Decode_SMSMassSendReceiver};

 PRIVATE PROCEDURE formSet_SMSMassSendReceiver();
  VAR
   D          : DATE;
   i          : NUMERIC[0];
   Pool,
   tmpValue   : STRING[];
   Fields     : FORMFIELDS;
   trgReceiver: SCAL[2];
   Kinds      : tMassSendKind[msk_Amount];
   IsReceiver : SCAL[2][msk_Amount];
 BEGIN
  Decode_SMSMassSendReceiver(ManPro.Value, Kinds, IsReceiver);
  Fields:=RTI.Get().CurZone.Fields;
  Pool  :=E_msk_GetPool();
  SETZERO(i);
  LOOP
   IF !Fields(L_WDO.Fld_wIdx("Kind", i)) THEN
    EXIT;
   END;
   Fields(L_WDO.Fld_wIdx("Kind", i)).Format      :=Pool;
   Fields(L_WDO.Fld_wIdx("IsReceiver", i)).Format:="|";

   Fields(L_WDO.Fld_wIdx("Kind", i)).Value       :=Kinds[i];
   Fields(L_WDO.Fld_wIdx("IsReceiver", i)).Value :=IsReceiver[i];
   INC(i);
  END; (* LOOP *)
 END {formSet_SMSMassSendReceiver};

 PRIVATE PROCEDURE formGet_SMSMassSendReceiver();
  VAR
   i, j       : NUMERIC[0];
   Pool,
   SingleValue: STRING[];
   Fields     : FORMFIELDS;
   Kinds      : tMassSendKind[msk_Amount];
   IsReceiver : SCAL[2][msk_Amount];
   SingleKind : tMassSendKind;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  SETEMPTY(Kinds, IsReceiver);
  SETZERO(i);
  LOOP
   IF !Fields(L_WDO.Fld_wIdx("Kind", i)) THEN
    EXIT;
   END;
   Kinds[i]     :=Fields(L_WDO.Fld_wIdx("Kind", i)).Value;
   IsReceiver[i]:=Fields(L_WDO.Fld_wIdx("IsReceiver", i)).Value;
   L_General.Assert(~!Kinds[i]=~!IsReceiver[i], "ப " + L_Str.IntStr(i+1) + ":  뫪    祭|" +
                                                "    ६");
   INC(i);
  END; (* LOOP *)

  Pool:=E_msk_GetPool();
  SETZERO(i);
  WHILE i <= HIGH(Kinds) DO
   SingleKind:=Kinds[i];
   IF ~!SingleKind THEN
    SETZERO(j);
    WHILE j <= HIGH(Kinds) DO
     IF (i # j) & (SingleKind = Kinds[j]) THEN
      L_General.Error(" 뫪 '" + L_Str.PoolItem(Pool, SingleKind) + "' 㪠 |" +
                      "(ப " + L_Str.IntStr(i+1) + "  ப " + L_Str.IntStr(j+1) + ")");
     END;
     INC(j);
    END; (* WHILE j <= HIGH(Kinds)...*)
   END;
   INC(i);
  END; (* WHILE i <= HIGH(Kinds)...*)

  SETZERO(i);
  WHILE i <= HIGH(Kinds) DO
   IF ~!Kinds[i] THEN
    SETEMPTY(SingleValue);
    L_Prop.putRES(SingleValue, L_Str.PoolItem(Pool, Kinds[i]));
    L_Prop.putRES(SingleValue, IsReceiver[i]);
    L_Prop.putAIS(ManPro.Value, SingleValue);
   END;
   INC(i);
  END; (* WHILE i <= HIGH(Kinds)...*)
 END {formGet_SMSMassSendReceiver};

 PRIVATE PROCEDURE formSet_SalaryInAPFY();
  VAR
   i       : SCAL[apfy_Amount];
   APFYYear: SCAL[1E4][apfy_Amount];
   APFYSal : NUMERIC[2][apfy_Amount];
   APFYDays: NUMERIC[0][apfy_Amount];
   Fields  : FORM_FIELDS;
 BEGIN
  sapfy_DecodeValue(APFYYear, APFYSal, APFYDays);
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH i DO
   Fields(L_Prop.BuildVideoFieldName("v_APFYYear", i)).Value:=APFYYear[i];
   Fields(L_Prop.BuildVideoFieldName("v_APFYSal", i)).Value :=APFYSal[i];
   Fields(L_Prop.BuildVideoFieldName("v_APFYDays", i)).Value:=APFYDays[i];
  END;
 END {formSet_SalaryInAPFY};

 PUBLIC PROCEDURE Decode_StaffCandidate(    curValue  : LIKE(ManPro.Value);
                                        VAR curSort   : LIKE(Officer.Sort);
                                        VAR curOfficer: LIKE(Officer.Officer));
 BEGIN
  curSort   :=L_r2r.Decode(L_Prop.getRES(curValue, 0));
  curOfficer:=L_Str.PoolItem(L_r2r.Decode(L_Prop.getRES(curValue, 1)), 1);
 END {Decode_StaffCandidate};

 PRIVATE PROCEDURE formSet_StaffCandidate();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_StaffCandidate(ManPro.Value, Fields("Sort").Value, Fields("Officer").Value);
 END {formSet_StaffCandidate};

 PRIVATE PROCEDURE formGet_StaffCandidate();
  VAR
   Fields: FORM_FIELDS;
   Dummy : STRING[];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_Prop.putRES(ManPro.Value, L_r2r.Put("ManPro", "Sort", Fields("Sort").Value));
  SEARCH(Officer, Officer, , Fields("Sort").Value, Fields("Officer").Value);
  L_Prop.putRES(ManPro.Value, L_r2r.PutReference("ManPro", "Officer"));
 END {formGet_StaffCandidate};

 PUBLIC PROCEDURE Decode_HazardMedExamination(    curValue   : LIKE(ManPro.Value);
                                              VAR curDirtyTyp: LIKE(DirtyTyp.DirtyTyp);
                                              VAR typ        : STRING[]);
 BEGIN
  curDirtyTyp:=L_r2r.Decode(L_Prop.getRES(curValue, 0));
  typ        :=L_Prop.getRES(curValue, 1);
 END {Decode_HazardMedExamination};

 PRIVATE PROCEDURE formSet_HazardMedExamination();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_HazardMedExamination(ManPro.Value, Fields(v_hme_DirtyTyp).Value, Fields(v_hme_Type).Value);
  L_WDO.CreateFormLink("DirtyTyp", "");
  Fields(v_hme_Type).Template        :=GetManProPool(P_HazardMedExamination);
  Fields(v_hme_Type).TemplateIsStrict:=1;
 END {formSet_HazardMedExamination};

 PRIVATE PROCEDURE formGet_HazardMedExamination();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_Prop.putRES(ManPro.Value, L_r2r.Put("ManPro", "DirtyTyp", Fields(v_hme_DirtyTyp).Value));
  L_Prop.putRES(ManPro.Value, Fields(v_hme_Type).Value);
 END {formGet_HazardMedExamination};

 PRIVATE PROCEDURE formSet_TaxDep();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("TaxDepCode").Value:=L_Prop.getRES(ManPro.Value, 0);
  CONFORM(ManPro, Man);
  Fields("INN").Value         :=Man.INN;
  Fields("INN").Modifiable    :=!Man.INN;
  Fields("INN").MustBeNonempty:=1;
 END {formSet_TaxDep};

 PRIVATE PROCEDURE formGet_TaxDep();
  VAR
   Fields: FORM_FIELDS;
   curINN: LIKE(Man.INN);
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  SETEMPTY(ManPro.Value);
  ManPro.Value:=Fields("TaxDepCode").Value;
  CONFORM(ManPro, Man);
  IF !Man.INN THEN
   curINN:=Fields("INN").Value;
   L_General.Assert(L_Russia.CheckINN(curINN), "४ ");
   IF SELECT(Man, INN, curINN) THEN
    L_General.Error("    ⠪ :  " + L_Man.Man_ManAsStr());
   END;
   CONFORM(ManPro, Man);
   Man.INN:=curINN;
   REPLACE(Man);
  END;
 END {formGet_TaxDep};

 PUBLIC PROCEDURE OnBeforeAskForEdit(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_ManPhoto THEN
   ManualChooseManPhoto();
  END;
 END {OnBeforeAskForEdit};

 PRIVATE PROCEDURE formSet_ManName();
 BEGIN
  L_WDO.cField("ManName").Value:=ManPro.Value;
 END {formSet_ManName};

 PRIVATE PROCEDURE formGet_ManName();
 BEGIN
  ManPro.Value:=L_WDO.cField("ManName").Value;
 END {formGet_ManName};

 PUBLIC PROCEDURE SetDataInForm(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_DriveSertification   THEN formSet_DriveSertification();
  ELSIF trgProperty = P_AnthropometricInf    THEN formSet_AnthropometricInf();
  ELSIF trgProperty = P_Vaccination          THEN formSet_Vaccination();
  ELSIF trgProperty = P_Pass                 THEN formSet_Pass();
  ELSIF trgProperty = P_AccessToTerritory    THEN formSet_AccessToTerritory();
  ELSIF trgProperty = P_SalaryInAPFY         THEN formSet_SalaryInAPFY();
  ELSIF trgProperty = P_SpecificNDFL         THEN formSet_SpecificNDFL();
  ELSIF trgProperty = P_SMSMassSendReceiver  THEN formSet_SMSMassSendReceiver();
  ELSIF trgProperty = P_StaffCandidate       THEN formSet_StaffCandidate();
  ELSIF trgProperty = P_HazardMedExamination THEN formSet_HazardMedExamination();
  ELSIF trgProperty = P_TaxDep               THEN formSet_TaxDep();
  ELSIF trgProperty = P_ManName              THEN formSet_ManName();
  END;
  SetWinFieldFlagEdit(trgProperty);
 END {SetDataInForm};

 PRIVATE PROCEDURE _EncodeValue(_ValueArr: STRING[][];
                                File     : STRING[]);
  VAR
   i  : NUMERIC[0];
   Dlm: STRING[1];
 BEGIN
  i  :=0;
  Dlm:="";
  WHILE i <= HIGH(_ValueArr) DO
   ^File.Value:=^File.Value + Dlm + _ValueArr[i];
   Dlm:=";";
   INC(i);
  END; (* WHILE i <= HIGH(_ValueArr)...*)
 END {_EncodeValue};

 PRIVATE PROCEDURE PutNotEmptyValue(VAR Result: STRING[]; Value: ANYTYPE; NameVal: STRING[]);
  VAR
   ValT: TYPESPEC;
 BEGIN
  IF ~!Value THEN
   IF ~!Result THEN
    Result:=Result + "; ";
   END;
   ValT:=GET_TYPE_SPEC(Value);
   L_General.CallUs(ValT.Id = TYPESPEC.Id_Numeric);
   IF ValT.Precision = 0 THEN
    Result:= Result + NameVal + " " + FLDTOSTR(Value, "0");
   ELSE
    Result:= Result + NameVal + " " + FLDTOSTR(Value, L_Str.IntStr(ValT.Precision) + ".");
   END;
  END;
 END {PutNotEmptyValue};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   i                : NUMERIC[0];
   Result,
   ArrayItem,
   tmpVal           : STRING[];
   Kind             : STRING[][v_Amnt];
   Idx              : SCAL    [v_Amnt];
   Date             : DATE    [v_Amnt];
   SerNbr           : STRING[][v_Amnt];
   UsefulTime       : DATE    [v_Amnt];
   Possibility      : SCAL[2] [v_Amnt];
   Growth           : NUMERIC[0];
   Weight           : NUMERIC[1];
   SizeClothing     : NUMERIC[0];
   SizeShoes        : NUMERIC[1];
   SizeHat          : NUMERIC[0];
   SizeMittens      : NUMERIC[0];
   SizeGloves       : NUMERIC[1];
   SizeMask         : NUMERIC[0];
   SizeRespirator   : NUMERIC[0];
   trgAim,
   trgAcsGroup      : STRING[];
   trgResponsibleTSN: LIKE(Staff.TSN);
   trgFirm          : LIKE(Firm.Firm);
   trgCarMark,
   trgStateNbr      : STRING[][att_CarAmount];
   CardType         : L_ACS.tCardType;
   CardCode         : NUMERIC[0];
 BEGIN
  SETEMPTY(Result);
  IF    ManPro.Property = P_Vaccination THEN
   Decode_Vaccination(Kind, Possibility, Date, SerNbr, UsefulTime);
   FOR_EACH Idx DO
    IF ~!Kind[Idx] THEN
     SETEMPTY(ArrayItem);
     L_Prop.putRES(ArrayItem, Kind[Idx]);
     L_Prop.putRES(ArrayItem, L_Str.PoolItem(v_PossibilityPool, Possibility[Idx]));
     IF Possibility[Idx] THEN
      L_Prop.putRED(ArrayItem, Date[Idx]);
      L_Prop.putRES(ArrayItem, SerNbr[Idx]);
      L_Prop.putRED(ArrayItem, UsefulTime[Idx]);
     END;
     L_Prop.putAIS(Result, ArrayItem);
    END; (* IF ~!Possibility ... *)
   END; (* FOR_EACH Idx...*)
  ELSIF ManPro.Property = P_AnthropometricInf THEN
   Decode_AnthropometricInf(ManPro.Value,
                            Growth,
                            Weight,
                            SizeClothing,
                            SizeShoes,
                            SizeHat,
                            SizeMittens,
                            SizeGloves,
                            SizeMask,
                            SizeRespirator);
   PutNotEmptyValue(Result, Growth,         "");
   PutNotEmptyValue(Result, Weight,         "");
   PutNotEmptyValue(Result, SizeClothing,   "");
   PutNotEmptyValue(Result, SizeShoes,      "");
   PutNotEmptyValue(Result, SizeHat,        "");
   PutNotEmptyValue(Result, SizeMittens,    "㪠");
   PutNotEmptyValue(Result, SizeGloves,     "⪨");
   PutNotEmptyValue(Result, SizeMask,       "⨢");
   PutNotEmptyValue(Result, SizeRespirator, "ᯨ");
  ELSIF ManPro.Property = P_AccessToTerritory THEN
   Decode_AccessToTerritory(ManPro.Value,
                            trgFirm, trgAim, trgResponsibleTSN, trgAcsGroup, trgCarMark, trgStateNbr);
   IF ~!trgFirm THEN
    SAVE(Firm);
    SEARCH(Firm, Firm, , trgFirm);
    L_Prop.putRES(Result, Firm.Firm + " " + Firm.Name);
    RESTORE(Firm);
   END;
   IF ~!trgAim THEN
    L_Prop.putRES(Result, trgAim);
   END;
   IF ~!trgResponsibleTSN THEN
    SAVE(Staff);
    SAVE(Man);
    SEARCH(Staff, TSN, , trgResponsibleTSN);
    CONFORM(Staff, Man);
    L_Prop.putRES(Result, Staff.TSN + " " + Man.Name);
    RESTORE(Man);
    RESTORE(Staff);
   END;
   IF ~!trgAcsGroup THEN
    L_Prop.putRES(Result, trgAcsGroup);
   END;
   i:=0;
   WHILE i <= HIGH(trgCarMark) DO
    IF ~!trgCarMark[i] THEN
     L_Prop.putRES(Result, trgCarMark[i] + " " + trgStateNbr[i]);
    END;
    INC(i);
   END; (* WHILE i <= HIGH(CarMark)...*)
  ELSIF ManPro.Property = P_Pass THEN
   Decode_Pass(ManPro.Value, CardType, CardCode);
   Result:=" " + Str.Replace(L_ACS.CardCodeAsStr(CardCode), " ", " N ");
  ELSIF ManPro.Property = P_StaffCandidate THEN
   Decode_StaffCandidate(ManPro.Value, Result, tmpVal);
   Result:=" " + Result + "  " + tmpVal;
  ELSIF ManPro.Property = P_HazardMedExamination THEN
   Decode_HazardMedExamination(ManPro.Value, tmpVal, Result);
  ELSE
   Result:=ManPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PRIVATE PROCEDURE formGet_SalaryInAPFY();
  VAR
   i        : SCAL[apfy_Amount];
   ArrayItem: STRING[];
   Fields   : FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH i DO
   SETEMPTY(ArrayItem);
   L_Prop.putREV(ArrayItem, Fields(L_Prop.BuildVideoFieldName("v_APFYYear", i)).Value);
   L_Prop.putREV(ArrayItem, Fields(L_Prop.BuildVideoFieldName("v_APFYSal", i)).Value);
   L_Prop.putREV(ArrayItem, Fields(L_Prop.BuildVideoFieldName("v_APFYDays", i)).Value);
   L_Prop.putAIS(ManPro.Value, ArrayItem);
  END;
 END {formGet_SalaryInAPFY};

 PUBLIC PROCEDURE CheckNDFL(Soft: SCAL[2]; D: DATE);
  VAR
   RealBegDate: DATE;
 BEGIN
  SAVE(Staff);
  IF SELECT(Staff, Man, ManPro.Man) THEN
   RealBegDate:=L_Man.GetTotTakeOnDate(L_DatTim.MonthEnd(D), 0);
   IF ManPro.Date # RealBegDate THEN
    L_StdFrm.ConditionalCHOICE("⢮ "+L_Str.IntStr(P_SpecificNDFL)+
                               "  ᮮ⢥  ਥ.  ࠧ:"+
                               "|᢮⢮ ଫ  "+L_DatTim.DateStr(ManPro.Date)+
                               "| ਥ          "+L_DatTim.DateStr(RealBegDate),
                               Soft);
   END;
  END;
  RESTORE(Staff);
 END {CheckNDFL};

 PRIVATE PROCEDURE formGet_SpecificNDFL();
  VAR
   curNDFLStatus      : STRING[];
   curNDFLDaysInRussia: tNDFLDaysInRussia;
 BEGIN
  L_WDO.getFieldValue("v_NDFLStatus", curNDFLStatus);
  L_WDO.getFieldValue("v_NDFLDaysInRussia", curNDFLDaysInRussia);
  L_Prop.putRES(ManPro.Value, curNDFLStatus);
  L_Prop.putRES(ManPro.Value, L_Str.IntStr(curNDFLDaysInRussia));
 END {formGet_SpecificNDFL};

 PRIVATE PROCEDURE formGet_AnthropometricInf();
  CONST
   MinGrowth = 140;
   MaxGrowth = 200;
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF ~!Fields("Growth").Value THEN
   IF (Fields("Growth").Value > MaxGrowth) | (Fields("Growth").Value < MinGrowth) THEN
    L_StdFrm.Choice(" 㢥७,  㪠 ࠢ ");
   END;
  END;
  L_Prop.putREV(ManPro.Value, Fields("Growth"        ).Value);
  L_Prop.putREV(ManPro.Value, Fields("Weight"        ).Value);
  L_Prop.putREV(ManPro.Value, Fields("SizeClothing"  ).Value);
  L_Prop.putREV(ManPro.Value, Fields("SizeShoes"     ).Value);
  L_Prop.putREV(ManPro.Value, Fields("SizeHat"       ).Value);
  L_Prop.putREV(ManPro.Value, Fields("SizeMittens"   ).Value);
  L_Prop.putREV(ManPro.Value, Fields("SizeGloves"    ).Value);
  L_Prop.putREV(ManPro.Value, Fields("SizeMask"      ).Value);
  L_Prop.putREV(ManPro.Value, Fields("SizeRespirator").Value);
 END {formGet_AnthropometricInf};

 PRIVATE PROCEDURE formGet_Vaccination();
  VAR
   Idx        : SCAL[v_Amnt];
   Fields     : FORM_FIELDS;
   ArrayItem  : STRING[];
   Possibility: SCAL[2];
   SerNbr     : STRING[];
   Date,
   UsefulTime : DATE;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   Possibility:=Fields(L_WDO.Fld_wIdx("Possibility", Idx)).Value;
   Date       :=Fields(L_WDO.Fld_wIdx("Date",        Idx)).Value;
   SerNbr     :=Fields(L_WDO.Fld_wIdx("SerNbr",      Idx)).Value;
   UsefulTime :=Fields(L_WDO.Fld_wIdx("UsefulTime",  Idx)).Value;
   IF ~!Possibility THEN
    IF    ~Possibility & (~!Date | ~!SerNbr | ~!UsefulTime) THEN
     L_General.CallUs(0);
    ELSIF Possibility & (!Date | !SerNbr) THEN
     L_General.Error("     ᠭ 樭樨 '" + L_Str.PoolItem(v_KindPool, Idx) + "'");
    END;

    SETEMPTY(ArrayItem);
    L_Prop.putRES(ArrayItem, L_Str.PoolItem(v_KindPool, Idx));
    L_Prop.putRES(ArrayItem, Possibility);
    IF Possibility THEN
     L_Prop.putRED(ArrayItem, Date);
     L_Prop.putRES(ArrayItem, SerNbr);
     L_Prop.putRED(ArrayItem, UsefulTime);
    END;
    L_Prop.putAIS(ManPro.Value, ArrayItem);
   END; (* IF ~!Possibility ... *)
  END; (* FOR_EACH Idx...*)
 END {formGet_Vaccination};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty: LIKE(Property.Property));
 BEGIN
  SETEMPTY(ManPro.Value);
  IF    trgProperty = P_DriveSertification   THEN formGet_DriveSertification();
  ELSIF trgProperty = P_AnthropometricInf    THEN formGet_AnthropometricInf();
  ELSIF trgProperty = P_Vaccination          THEN formGet_Vaccination();
  ELSIF trgProperty = P_AccessToTerritory    THEN formGet_AccessToTerritory();
  ELSIF trgProperty = P_SalaryInAPFY         THEN formGet_SalaryInAPFY();
  ELSIF trgProperty = P_SpecificNDFL         THEN formGet_SpecificNDFL();
  ELSIF trgProperty = P_SMSMassSendReceiver  THEN formGet_SMSMassSendReceiver();
  ELSIF trgProperty = P_StaffCandidate       THEN formGet_StaffCandidate();
  ELSIF trgProperty = P_HazardMedExamination THEN formGet_HazardMedExamination();
  ELSIF trgProperty = P_TaxDep               THEN formGet_TaxDep();
  ELSIF trgProperty = P_ManName              THEN formGet_ManName();
  ELSE                                            L_General.CallUs(0);
  END;
  REPLACE(ManPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE InsertProperty(trgMan      : LIKE(Man.Man);
                                 D           : DATE;
                                 trgProperty : LIKE(Property.Property);
                                 Value       : STRING[];
                                 Silent      : SCAL[2];
                                 trgDocNum,
                                 trgDocGiveS : STRING[];
                                 trgDocGiveD,
                                 trgDocExpD  : DATE);
 BEGIN
  IF SELECT(ManPro, Man, trgMan, trgProperty, D) THEN
   L_General.Assert(Silent,
                    " " + trgMan + "|" + "㦥  ᢮⢮ " + trgProperty + "|" +
                    "  " + L_DatTim.DateStr(D));
   REMOVE(ManPro);
  END;
  DEFAULT(ManPro);
  ManPro.Man     :=trgMan;
  ManPro.Property:=trgProperty;
  ManPro.Date    :=D;
  ManPro.Value   :=Value;
  ManPro.DocNum  :=trgDocNum;
  ManPro.DocGiveD:=trgDocGiveD;
  ManPro.DocGiveS:=trgDocGiveS;
  ManPro.DocExpD :=trgDocExpD;
  INSERT(ManPro);
  L_Prop.SupportEndDate("ManPro", trgProperty, 1);
  CALL(ObjPro.UpdateVal2Show("ManPro"));
 END {InsertProperty};

 PUBLIC PROCEDURE InsertProperty_woDoc(trgMan     : LIKE(Man.Man);
                                       D          : DATE;
                                       trgProperty: LIKE(Property.Property);
                                       Value      : STRING[];
                                       Silent     : SCAL[2]);
 BEGIN
  InsertProperty(trgMan, D, trgProperty, Value, Silent,
                 "", "", EMPTYOF(DATE), EMPTYOF(DATE));
 END {InsertProperty_woDoc};

 PRIVATE VAR
  pcrO_ProximityReader: OBJECT; (*PROXIMITYREADER*)
  CardCode            : NUMERIC[0];

 PRIVATE PROCEDURE int_PercoProximityReader_Prepare(Type: NUMERIC[0]);
  VAR
   CommPort: NUMERIC[0];
 BEGIN
  CommPort:=STRTOFLD(L_SpcEq.GetSpcEqValue(L_SpcEq.et_pcr_COMPort), NUMERIC);
  L_General.Assert(~!CommPort, " 㪠  COM- 뢠⥫ ᪮⠪ |"+
                               "ॡ 㪠  |" +
                               "  'ன ᯥ樠쭮 㤮'");
  pcrO_ProximityReader:=PROXIMITYREADER.Get(Type, CommPort);
  pcrO_ProximityReader.Open:=1;
 END {int_PercoProximityReader_Prepare};

 PRIVATE PROCEDURE pcr_PercoProximityReader_Prepare(CardType: L_ACS.tCardType);
 BEGIN
  int_PercoProximityReader_Prepare(PROXIMITYREADER.Type_PERCo);
 END {pcr_PercoProximityReader_Prepare};

 PRIVATE PROCEDURE pcr_ParsecProximityReader_Prepare(CardType: L_ACS.tCardType);
 BEGIN
  pcrO_ProximityReader:=PROXIMITYREADER.Get(PROXIMITYREADER.Type_ParsecPRx08);
  pcrO_ProximityReader.Open:=1;
 END {pcr_ParsecProximityReader_Prepare};

 PRIVATE PROCEDURE pcr_SevenSealsProximityReader_Prepare(CardType: L_ACS.tCardType);
 BEGIN
  int_PercoProximityReader_Prepare(PROXIMITYREADER.Type_SevenSeals);
 END {pcr_ParsecProximityReader_Prepare};

 PRIVATE PROCEDURE pcr_ProximityReader_CardCodeIdle(): NUMERIC[0];
  VAR
   Err: NUMERIC[0];
 BEGIN
  Err:=pcrO_ProximityReader.GetCardCode(CardCode);
  IF    Err = PROXIMITYREADER.Error_GetOK THEN
   RETURN 1;
  ELSIF Err = PROXIMITYREADER.Error_NoCard THEN
   RETURN -1;
  ELSIF Err = PROXIMITYREADER.Error_InvalidData THEN
   L_General.Error("뢠⥫ ᪮⠪   祭  ࠢ");
  ELSE
   L_General.Error("訡 ⥭   "+ FLDTOSTR(Err, "0"));
  END;
 END {pcr_ProximityReader_CardCodeIdle};

 PRIVATE PROCEDURE pcr_ProximityReader_Finish();
 BEGIN
  pcrO_ProximityReader.Open:=0;
 END {pcr_ProximityReader_Finish};

 PUBLIC PROCEDURE gcc_Init(VAR gcc_Prepare, gcc_CardCodeIdle, gcc_Finish: PROC);
  VAR
   ProximityCardReader: L_SpcEq.tProximityCardReaderType;
 BEGIN
  ProximityCardReader:=L_SpcEq.GetSpcEqValue(L_SpcEq.et_ProximityCardReader);
  IF    ProximityCardReader = L_SpcEq.pcr_NotAlowed THEN
   L_General.Error("뢠⥫ ᪮⠪   ⨢஢." +
                   "||ॡ  ᯮ짮 ⮣ ன⢠" +
                   '|  "ன ᯥ樠쭮 㤮"');
  ELSIF ProximityCardReader = L_SpcEq.pcr_Perco THEN
   gcc_Prepare     :=PROCREF(pcr_PercoProximityReader_Prepare);
   gcc_CardCodeIdle:=PROCREF(pcr_ProximityReader_CardCodeIdle);
   gcc_Finish      :=PROCREF(pcr_ProximityReader_Finish);
  ELSIF ProximityCardReader = L_SpcEq.pcr_Parsec THEN
   gcc_Prepare     :=PROCREF(pcr_ParsecProximityReader_Prepare);
   gcc_CardCodeIdle:=PROCREF(pcr_ProximityReader_CardCodeIdle);
   gcc_Finish      :=PROCREF(pcr_ProximityReader_Finish);
  ELSIF ProximityCardReader = L_SpcEq.pcr_SevenSeals THEN
   gcc_Prepare     :=PROCREF(pcr_SevenSealsProximityReader_Prepare);
   gcc_CardCodeIdle:=PROCREF(pcr_ProximityReader_CardCodeIdle);
   gcc_Finish      :=PROCREF(pcr_ProximityReader_Finish);
  ELSE
   L_General.CallUs(0);
  END;
 END {gcc_Init};

 PUBLIC PROCEDURE gcc_Readout(): NUMERIC[0];
 BEGIN
  RETURN CardCode;
 END {gcc_Readout};

 PUBLIC PROCEDURE ManualGetCardCode(ErrMsg, Style: STRING[]): NUMERIC[0];
  VAR
   Ser, Nbr: NUMERIC[0];
 BEGIN
  LOOP
   SETEMPTY(CardCode, Ser, Nbr);
   IF ~!ErrMsg THEN
    Style :="STOP";
    ErrMsg:=L_StdFrm.HR() + ErrMsg;
   END;
   STDFORM(L_StdFrm.sf_Choice("| %####%  %##########%|" +
                              ErrMsg,
                              "%<N>I %<N>I"),
           "   ",
           ^Style,
           ,
           Ser, Nbr);
   SETEMPTY(ErrMsg);
   IF Nbr >= 65536 THEN
    ErrMsg:="  ";
   ELSE
    CardCode:=Ser * 65536 + Nbr;
    EXIT;
   END;
  END (* LOOP *);
  RETURN CardCode;
 END {ManualGetCardCode};

 PUBLIC PROCEDURE GetCardCode(CardType  : L_ACS.tCardType;
                              Operation,
                              ErrMsg,
                              Text      : STRING[]): NUMERIC[0];
  VAR
   gcc_Prepare,
   gcc_CardCodeIdle,
   gcc_Finish       : PROC;
   asCardCode       : STRING[];
   Palette          : STRING[];
 BEGIN
  SETEMPTY(Palette);
  IF ~L_SpcEq.IsInstalled(L_SpcEq.et_ProximityCardReader) THEN
   IF L_General.IsAdmin() THEN
    IF !ErrMsg THEN
     L_StdFrm.Choice("뢠⥫ ᪮⠪   ⨢஢." +
                     "||, ,    -ய᪠ ."+
                     "||  -ய᪠ ?");
     RETURN ManualGetCardCode(ErrMsg, Palette);
    END;
   END;
   L_General.Error("뢠⥫ ᪮⠪   ⨢஢." +
                   "||ॡ  ᯮ짮 ⮣ ன⢠" +
                   '|  "ன ᯥ樠쭮 㤮"');
  END;
  gcc_Init(gcc_Prepare, gcc_CardCodeIdle, gcc_Finish);
  TRY
   gcc_Prepare(CardType);
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.Error(Str.Replace(Exc.MsgOriginalText, ";", "||"));
  END;
  SETEMPTY(CardCode);
  asCardCode:="   뢠⥫";
  IF ~!ErrMsg THEN
   Palette:="STOP";
   ErrMsg :=ErrMsg + "||";
  END;
  STDFORM("|" + ErrMsg + Text + "%C33NI|", " " + Operation + " ", ^Palette, , asCardCode, gcc_CardCodeIdle);
  gcc_Finish();
  RETURN CardCode;
 END {GetCardCode};

 PUBLIC PROCEDURE InteractiveAccessStaffByMan(OnDate: DATE; AccessLeaved: SCAL[2]): SCAL[2];
 BEGIN
  IF ~ACCESS(Staff) THEN
   L_General.Assert(ACCESS(Man), " ࠭ ⥪騩 ࠡ⭨");
   SELECT(Staff, Man, , Man.Man);
   WHILE OCCURE(Staff) & ~L_Staff.rInState(OnDate) DO
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
  ELSE
   CONFORM(Staff, Man);
  END;
  RETURN OCCURE(Staff) | L_Man.InteractiveAccessStaffByMan(AccessLeaved);
 END {InteractiveAccessStaffByMan};

 PUBLIC PROCEDURE GetPassAttributes(    trgMan  : LIKE(Man.Man);
                                        D       : DATE;
                                    VAR CardType: L_ACS.tCardType;
                                    VAR CardCode: NUMERIC[0]);
 BEGIN
  Decode_Pass(GetManProSoft(trgMan, D, P_Pass), CardType, CardCode);
 END {GetPassAttributes};

 PRIVATE PROCEDURE GetAnyContactInf(trgMan: LIKE(Man.Man); D: DATE; cvc: L_ctc.tCoverage; ci: tContactInf): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(Man);
  SEARCH(Man, Man, , trgMan);
  Result:=L_ctc.GetCtcVal(0, Man.Contact, D, cvc, convContactInf2ValType(ci));
  RESTORE(Man);
  RETURN Result;
 END {GetAnyContactInf};

 PUBLIC PROCEDURE GetWorkContactInf(trgMan: LIKE(Man.Man); D: DATE; ci: tContactInf): STRING[];
 BEGIN
  RETURN GetAnyContactInf(trgMan, D, L_ctc.cvc_Work, ci);
 END {GetWorkContactInf};

 PUBLIC PROCEDURE GetHomeContactInf(trgMan: LIKE(Man.Man); D: DATE; ci: tContactInf): STRING[];
 BEGIN
  RETURN GetAnyContactInf(trgMan, D, L_ctc.cvc_Home, ci);
 END {GetHomeContactInf};

 PUBLIC PROCEDURE GetAllClrPhones(    trgMan  : LIKE(Man.Man);
                                      trgDate : DATE;
                                  VAR PhoneClr: STRING[][]);
 BEGIN
  PhoneClr[L_ctc.cvc_Work]:=GetWorkContactInf(trgMan, trgDate, ci_MblTelefon);
  PhoneClr[L_ctc.cvc_Home]:=GetHomeContactInf(trgMan, trgDate, ci_MblTelefon);
 END {GetAllClrPhones};

 PUBLIC PROCEDURE GetAnyClrPhone(trgMan  : LIKE(Man.Man);
                                 trgDate : DATE): STRING[];
  VAR
   Result: STRING[];
   Phones: STRING[][2];
 BEGIN
  GetAllClrPhones(trgMan, trgDate, Phones);
  Result:=Phones[L_ctc.cvc_Work];
  IF !Result THEN
   Result:=Phones[L_ctc.cvc_Home];
  END;
  RETURN Result;
 END {GetAnyClrPhone};

 PRIVATE PROCEDURE GetStringProValueAsScal(trgProperty: LIKE(Property.Property)): NUMERIC[0];
  VAR
   Pool: STRING[];
 BEGIN
  L_General.CallUs(OCCURE(ManPro));
  Pool:=GetManProPool(trgProperty);
  L_General.CallUs(~!Pool);
  L_General.CallUs(~!ManPro.Value);
  RETURN L_Str.PositionInPool(Pool, ManPro.Value);
 END {GetStringProValueAsScal};

 PUBLIC PROCEDURE GetForeignerLegalStatus(trgMan: LIKE(Man.Man); D: DATE): tForeignerLegalStatus;
 BEGIN
  IF HasActualManPro(trgMan, D, P_ForeignerLegalStatus) THEN
   RETURN GetStringProValueAsScal(P_ForeignerLegalStatus);
  ELSE
   RETURN fls_Commorancy;
  END;
 END {GetForeignerLegalStatus};

 PUBLIC PROCEDURE GetAccessOutsiderInf(    trgMan                 : LIKE(Man.Man);
                                           trgDate                : DATE;
                                       VAR Outsider_Firm          : LIKE(Firm.Firm);
                                       VAR Outsider_Aim           : STRING[];
                                       VAR Outsider_ResponsibleTSN: LIKE(Staff.TSN));
  VAR
   Dummy : STRING[];
   Dummy2: STRING[][att_CarAmount];
 BEGIN
  Decode_AccessToTerritory(GetManProSoft(trgMan, trgDate, P_AccessToTerritory),
                           Outsider_Firm, Outsider_Aim, Outsider_ResponsibleTSN, Dummy, Dummy2, Dummy2);
 END {GetAccessOutsiderInf};

 PUBLIC PROCEDURE GetAccessOutsiderCar(    trgMan  : LIKE(Man.Man);
                                           trgDate : DATE;
                                       VAR CarMark : STRING[][att_CarAmount];
                                       VAR StateNbr: STRING[][att_CarAmount]);
  VAR
   Dummy: STRING[];
 BEGIN
  Decode_AccessToTerritory(GetManProSoft(trgMan, trgDate, P_AccessToTerritory),
                           Dummy, Dummy, Dummy, Dummy, CarMark, StateNbr);
 END {GetAccessOutsiderCar};

 PUBLIC PROCEDURE GetAcsGroup(trgMan: LIKE(Man.Man); trgDate: DATE): STRING[];
  VAR
   Dummy,
   AcsGroup: STRING[];
   Dummy2  : STRING[][att_CarAmount];
 BEGIN
  Decode_AccessToTerritory(GetManProSoft(trgMan, trgDate, P_AccessToTerritory),
                           Dummy, Dummy, Dummy, AcsGroup, Dummy2, Dummy2);
  RETURN AcsGroup;
 END {GetAcsGroup};

 PUBLIC PROCEDURE IsSMSMassSendReceiver(trgMan          : LIKE(Man.Man);
                                        trgDate         : DATE;
                                        ms_Kind         : tMassSendKind;
                                        PropertyRequired: SCAL[2]): SCAL[2];
  VAR
   i         : NUMERIC[0];
   Result    : SCAL[2];
   Kinds     : tMassSendKind[msk_Amount];
   IsReceiver: SCAL[2][msk_Amount];
 BEGIN
  Decode_SMSMassSendReceiver(GetManProSoft(trgMan, trgDate, P_SMSMassSendReceiver), Kinds, IsReceiver);
  SETEMPTY(Result);
  SETZERO(i);
  LOOP
   IF (i > HIGH(Kinds)) | ~!Result THEN
    EXIT;
   END;
   IF ms_Kind = Kinds[i] THEN
    Result:=IsReceiver[i];
   END;
   INC(i);
  END; (* LOOP *)

  IF !Result THEN
   IF PropertyRequired THEN
    Result:=0;
   ELSE
    Result:=1;
   END;
  END;
  RETURN Result;
 END {IsSMSMassSendReceiver};

 PUBLIC PROCEDURE InRiskGroup(trgMan: LIKE(Man.Man); trgDate: DATE; IsDriver: SCAL[2]): SCAL[2];
 BEGIN
  IF HasActualManPro(trgMan, trgDate, P_MedExaminationFeatures) THEN
   RETURN GetStringProValueAsScal(P_MedExaminationFeatures) = 0;
  ELSIF IsDriver THEN
   L_General.CallUs(SEARCH(Man, Man, trgMan));
   RETURN L_DatTim.CompleteYearsInIntvl(Man.Birth, trgDate) >= 55;
  ELSE
   RETURN 0;
  END;
 END {InRiskGroup};

 PUBLIC PROCEDURE MedExaminationFeatures(trgMan: LIKE(Man.Man); trgDate: DATE; IsDriver: SCAL[2]): STRING[];
 BEGIN
  IF    HasActualManPro(trgMan, trgDate, P_MedExaminationFeatures) THEN
   RETURN ManPro.Value;
  ELSIF InRiskGroup(trgMan, trgDate, IsDriver) THEN
   RETURN L_Str.PoolItem(GetManProPool(P_MedExaminationFeatures), 0);
  ELSE
   RETURN "";
  END;
 END {MedExaminationFeatures};

 PUBLIC PROCEDURE OnAskPhase1(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_StaffCandidate THEN
   IF RTI.Get().CurZone.ActiveField.Name = "Officer" THEN
    LIKEMENU(Ask, ". 2");
   END;
  END;
 END {OnAskPhase1};

 PUBLIC PROCEDURE OnAskPhase2(trgProperty: LIKE(Property.Property));
  VAR
   trgSort   : LIKE(Officer.Sort);
   trgOfficer: LIKE(Officer.Officer);
 BEGIN
  IF trgProperty = P_StaffCandidate THEN
   IF RTI.Get().TrgZone.MasterTable.Name = "Officer" THEN
    SAVE(Officer);
    GE_WZD_CURSOR(RTI.Get().TrgZone.Window.Name, RTI.Get().TrgZone.Number, Officer);
    trgSort   :=Officer.Sort;
    trgOfficer:=Officer.Officer;
    RESTORE(Officer);
   ELSE
    trgSort:=Sort.Sort;
    SETEMPTY(trgOfficer);
   END;
   RTI.Get().CurZone.Fields("Sort").Value   :=trgSort;
   RTI.Get().CurZone.Fields("Officer").Value:=trgOfficer;
  END;
 END {OnAskPhase2};

 PUBLIC PROCEDURE P_0202_OnInitializeWindow();
  VAR
   i: NUMERIC[0];
   s: STRING[];
 BEGIN
  L_WDO.iWindow().MNUFileName:="ObjPro";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iUnmodifiable(0, ["ObjectDescr", "ObjectTitle"]);
  L_WDO.iMayBeEmpty  (0, ["Comments", "DocGiveS", "DocSer", "DocNum", "DocExpD", "DocGiveD", "Trolleybus"]);
  L_WDO.iScsChange   (0, ["DrvCategory_0", "DrvCategory_1", "DrvCategory_2", "DrvCategory_3",
                          "DrvCategory_1_2", "DrvCategory_2_2", "DrvCategory_3_2", "Trolleybus", "OldStyle"]);
  L_WDO.iProgs       (0, "ObjPro");
  L_WDO.iField       (0, "OldStyle").Format:="|";
  L_WDO.iField       (0, L_WDO.Fld_wIdx("DrvCategory", 0)).Format:="-|A";
  i:=1;
  WHILE i <= 3 DO
   L_WDO.iField       (0, L_WDO.Fld_wIdx("DrvCategory", i)).Format:="-|"+dc_Pool[i];
   L_WDO.iField       (0, L_WDO.Fld_wIdx(L_WDO.Fld_wIdx("DrvCategory", i), 2)).Format:="---|E"+dc_Pool[i];
   INC(i);
  END;
  L_WDO.iField       (0, "Trolleybus").Format:="-|";
  i:=0;
  WHILE i <= 15 DO
   s:=L_Str.PoolItem(L_Way.mc_Pool, i);
   L_WDO.iField       (0, L_WDO.Fld_wIdx("DrvCategoryNew", i)).Format:=L_Str.Repeat("-", Str.Length(s)) + "|" + s;
   INC(i);
  END;
 END {P_0202_OnInitializeWindow};

 PUBLIC PROCEDURE P_5207_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (0, ["Officer"]);
  L_WDO.iUnmodifiable(0, ["ObjectDescr", "ObjectTitle"]);
  L_WDO.iFieldAskMode(0, "Sort",    FORM_FIELD.AskMode_Manual, "Sort", 1);
  L_WDO.iFieldAskMode(0, "Officer", FORM_FIELD.AskMode_Manual, "Sort", 1);
  L_WDO.iField       (0, "Officer_Post").Expression:="SELF.Zone.LinkedFieldValue('Officer.Post')";
  L_WDO.iField       (0, "Post_Name"   ).Expression:="SELF.Zone.LinkedFieldValue('Officer->Post.Name')";
  L_WDO.iProgs       (0, "ObjPro");
  L_WDO.CreateFormLink("Sort", "");
  L_WDO.CreateFormLink("Officer", "");
 END {P_5207_OnInitializeWindow};

 PUBLIC PROCEDURE P_5202_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iField       (0, "ResponsibleTSN").OwnerWindowOriginalName:="Staff";
  L_WDO.iField       (0, "ResponsibleTSN").OwnerZoneNumber:=1;
  L_WDO.iScsChange   (0, ["ManPro.Date", "DocExpD", "AcsGroup"]);
  L_WDO.iUnmodifiable(0, ["ObjectDescr", "ObjectTitle", "ResponsibleStaff_Name", "Firm_Name"]);
  L_WDO.iMayBeEmpty  (0, ["DocSer", "DocNum", "DocExpD", "DocGiveD", "DocGiveS", "CarMark_2", "CarMark_1", "StateNbr_2", "StateNbr_1", "AcsGroup", "Aim", "Firm", "ResponsibleTSN"]);
  L_WDO.iProgs       (0, "ObjPro");
  L_WDO.CreateFormLink("Firm", "");
  L_WDO.CreateFormLink("Staff", "Responsible");
 END {P_5202_OnInitializeWindow};

 PUBLIC PROCEDURE P_5106_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iUnmodifiable(0, ["ObjectTitle", "ObjectDescr"]);
  L_WDO.iProgs       (0, "ObjPro");
 END {P_5106_OnInitializeWindow};


END.
