(*
%Copyright   (c) Polak Computer System
%Author      31.10.2000 19:45:21 RSN
%Purpose     ⥪  ࠡ  ᢮⢠ Math
%Type        library
%Specific    SYS
%Modified    07.08.2014 17:40:13 POLAK\GAV
%Environment
*)

 MODULE P_Math [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PRIVATE CONST
  pi_Amount          = 6;
  rat_RouteGrpAmount = 10;

 PUBLIC TYPE
  tPreciousMetals        = NUMERIC[9];
  tPI_Price              = NUMERIC[18, 5][pi_Amount];
  tPI_ProvidersMath      = STRING[64][pi_Amount];
  tPI_MainProvider       = STRING[][pi_Amount];
  tSpecialAttitudeToVAT  = SCAL[4];
  tLifeTimeUnit          = SCAL[2];
  tRAT_RouteGroup        = STRING[][rat_RouteGrpAmount];
  tRAT_Price             = NUMERIC[2][rat_RouteGrpAmount];
  tSPCurrency            = SCAL[3];
  tRAT_PerCoefCountType  = SCAL[10];
  tCompositionSetType    = STRING[];

 PUBLIC CONST
  P_Remainders           = 7000;
  P_LifeTime             = 7002;
  P_Model                = 7003;
  P_Residence            = 7004;
  P_PriceOfOver          = 7005;
  P_PreciousMetals       = 7006;
  P_Tariff               = 7007;
  P_Warranty             = 7008;
  P_KARightReg           = 7009;
  P_MobilizationDestinat = 7010;
  P_FloorSpace           = 7011;
  P_SpecialAttitudeToVAT = 7012;
  P_VATMode              = 7013;
  P_Serial               = 7014;
  P_Description          = 7015;
  P_SalePrice            = 7016;
  P_CompositionSet       = 7020;
  P_Usage                = 7021;
  P_ParentMath           = 7022;
  P_PurchasesInf         = 7051;
  P_SpcRefs              = 7052; (* ५ 0085385 *)
  P_PropertyTax          = 7053;
  P_DomesticManufacture  = 7054;
  P_MyPlace              = 7055;

  pm_Amount = 4;
  PreciousMetalsPool = "ॡ||⨭|";
  pm_Argentum  = 0;
  pm_Aurum     = 1;
  pm_Platinum  = 2;
  pm_Palladium = 3;

  satVAT_woFeatures    = 0;
  satVAT_TaxFree       = 1;
  satVAT_IncentiveRate = 2;
  satVAT_ZeroRate      = 3;
  satVAT_Pool = " ᮡ⥩| |죮⭠ ⠢|⠢ 0%";
  satVAT_ReasonPoolCen = 0000963;

  cpt_None   = 0;
  cpt_Soft   = 1;
  cpt_Strong = 2;

  ltu_Pool       = ".|";
  ltu_Pool_Short = ".|.";
  ltu_ThousandKm = 0;
  ltu_Month      = 1;

  spc_Pool = "㡫||業";

  spc_Rouble = 0;
  spc_Dollar = 1;
  spc_Extra  = 2;

  tar_VATPool = " | ";

  poo_Amount = 15;

  smr_Amount = 10;
  cs_Amount  = 15;

  rem_Min = 0; (*tRemainders*)
  rem_Max = 1;

 IMPORT L_General, L_DatTim, L_Prop, L_Money, L_CUC, L_WDO, L_Pool, L_Str, L_Way, L_StdFrm, L_MathR,
        L_Acnt, L_XObj, P_Mark, P_Firm, P_Route, P_OwnData, Str, FIO, Math, L_r2r, L_ACL;

 PUBLIC TYPE
  tRemainders = L_XObj.tQnt[2];

 PRIVATE CONST
  v_Providers     = "ProviderFirm";
  v_Price         = "Price";
  v_ProvidersMath = "ProvidersMath";
  v_MainProvider  = "MainProvider";

  pin_Provider      = 0;
  pin_Price         = 1;
  pin_ProvidersMath = 2;
  pin_MainProvider  = 3;

  csi_Math   = 0;
  csi_Amount = 1;
  csi_Type   = 2;

  MainProviderPool = "|";

  cs_TypePool = "-|";

  sf_MathSpcPath = "MathSpcPath";

  lt_Amount = MAXOF(L_CUC.tCondition) + 1;

 PUBLIC PROCEDURE PropertyModificationAllowed(_Property: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF (_Property = P_SpcRefs) THEN
   RETURN L_Prop.mac_Old;
  ELSE
   RETURN L_Prop.mac_Full;
  END;
 END {PropertyModificationAllowed};

 PRIVATE PROCEDURE GetTariffSubWindowName(): STRING[];
 BEGIN
  CanHaveProp(P_Tariff);
  ACCESS(Math);
  IF    Math.MathType = L_MathR.mtyp_CWOrdIncome THEN
   RETURN "P_7007A";
  ELSIF Math.MathType = L_MathR.mtyp_AdvertisingServices THEN
   RETURN "P_7007B";
  END;
 END {GetTariffSubWindowName};

 PUBLIC PROCEDURE GetSubWindowName(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    _Property = P_Remainders           THEN RETURN "P_7000";
  ELSIF _Property = P_LifeTime             THEN RETURN "P_7002";
  ELSIF _Property = P_PriceOfOver          THEN RETURN "P_7005";
  ELSIF _Property = P_PreciousMetals       THEN RETURN "P_7006";
  ELSIF _Property = P_Tariff               THEN RETURN GetTariffSubWindowName();
  ELSIF _Property = P_SpecialAttitudeToVAT THEN RETURN "P_7012";
  ELSIF _Property = P_SalePrice            THEN RETURN "P_7016";
  ELSIF _Property = P_CompositionSet       THEN RETURN "P_7020";
  ELSIF _Property = P_PurchasesInf         THEN RETURN "P_7051";
  ELSIF _Property = P_SpcRefs              THEN RETURN "P_7052";
  ELSIF _Property = P_PropertyTax          THEN RETURN "P_7053";
  ELSE                                          RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE IsSimpleUserOf(curProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    curProperty = P_ParentMath THEN RETURN "Math";
  ELSIF curProperty = P_MyPlace    THEN RETURN "MyPlace";
  ELSE                                  RETURN "";
  END;
 END {IsSimpleUserOf};

 PUBLIC PROCEDURE GetMathProPool(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    _Property = P_KARightReg THEN
   RETURN "|";
  ELSIF _Property = P_MobilizationDestinat THEN
   RETURN "ᯮ㥬  ⥪饬 ந⢥|ᯮ㥬  ⥪饬 ந⢥";
  ELSIF _Property = P_VATMode THEN
   RETURN " |।| ⮨";
  ELSIF L_Prop.IsLocalProperty(_Property) THEN
   RETURN L_Prop.E_GetPool(_Property);
  ELSIF _Property = P_DomesticManufacture THEN
   RETURN "|";
  ELSE
   RETURN "";
  END;
 END {GetMathProPool};

 PRIVATE PROCEDURE Decode_PurchasesInf(    val           : STRING[];
                                       VAR Providers     : LIKE(Firm.Firm)[];
                                       VAR Prices        : tPI_Price;
                                       VAR ProvidersMaths: tPI_ProvidersMath;
                                       VAR MainProviders : tPI_MainProvider);
  VAR
   i: SCAL[pi_Amount];
   SingleValue: STRING[];
 BEGIN
   SETEMPTY(Providers, Prices, ProvidersMaths, MainProviders);
   FOR_EACH i DO
    SingleValue      :=L_Prop.getAIS(val, i);
    Providers[i]     :=L_r2r.DecodeReferenceStamp(L_Prop.getRES(SingleValue, pin_Provider));
    Prices   [i]     :=L_Str.Str2Num(L_Prop.getRES(SingleValue, pin_Price), "5-");
    ProvidersMaths[i]:=L_Prop.getRES(SingleValue, pin_ProvidersMath);
    MainProviders[i] :=L_Prop.getRES(SingleValue, pin_MainProvider);
   END; (* FOR_EACH i ...*)
 END {Decode_PurchasesInf};

 PRIVATE PROCEDURE formSet_PurchasesInf();
  VAR
   ff            : FORM_FIELDS;
   f             : FORM_FIELD;
   piIdx         : SCAL[pi_Amount];
   Providers     : LIKE(Firm.Firm)[pi_Amount];
   Prices        : tPI_Price;
   ProvidersMaths: tPI_ProvidersMath;
   MainProviders : tPI_MainProvider;
 BEGIN
  ff:=RTI.Get().CurZone.Fields;
  FOR_EACH piIdx DO
   Decode_PurchasesInf(MathPro.Value, Providers, Prices, ProvidersMaths, MainProviders);
   ff(L_Prop.BuildVideoFieldName(v_Providers,     piIdx)).Value:=Providers     [piIdx];
   ff(L_Prop.BuildVideoFieldName(v_Price,         piIdx)).Value:=Prices        [piIdx];
   ff(L_Prop.BuildVideoFieldName(v_ProvidersMath, piIdx)).Value:=ProvidersMaths[piIdx];
   f:=ff(L_Prop.BuildVideoFieldName(v_MainProvider,  piIdx));
   f.Template        :=MainProviderPool;
   f.TemplateIsStrict:=1;
   f.Value           :=MainProviders [piIdx];
   L_WDO.extCreateFormLink("Firm", "Provider", piIdx);
  END; (* FOR_EACH piIdx ...*)
 END {formSet_PurchasesInf};

 PRIVATE PROCEDURE formGet_PurchasesInf();
  VAR
   Result,
   snglVal: STRING[];
   piIdx  : SCAL[pi_Amount];
   ff     : FORM_FIELDS;
   firm   : LIKE(Firm.Firm);
 BEGIN
  MathPro.Value:="";
  ff:=RTI.Get().CurZone.Fields;
  FOR_EACH piIdx DO
   firm:=ff(L_Prop.BuildVideoFieldName(v_Providers, piIdx)).Value;
   IF ~!firm | ~!ff(L_Prop.BuildVideoFieldName(v_Price, piIdx)).Value THEN
    snglVal:="";
    IF ~!firm THEN
     L_Prop.putRES(snglVal, L_r2r.Put("MathPro", "Firm", firm));
    ELSE
     L_Prop.putRES(snglVal, "");
    END;
    L_Prop.putRES(snglVal, ConvNumericValueToStr(ff(L_Prop.BuildVideoFieldName(v_Price, piIdx)).Value));
    L_Prop.putRES(snglVal, ff(L_Prop.BuildVideoFieldName(v_ProvidersMath, piIdx)).Value);
    L_Prop.putRES(snglVal, ff(L_Prop.BuildVideoFieldName(v_MainProvider, piIdx)).Value);
    L_Prop.putAIS(MathPro.Value, snglVal);
   END;
  END (* FOR_EACH i ...*);
 END {formGet_PurchasesInf};

 PRIVATE PROCEDURE Check_PurchasesInf();
  VAR
   wo_ProviderAmnt,
   MainProviderAmnt,
   Cnt              : NUMERIC[0];
   piIdx            : SCAL[pi_Amount];
   Providers        : LIKE(Firm.Firm)[pi_Amount];
   Prices           : tPI_Price;
   ProvidersMaths   : tPI_ProvidersMath;
   MainProviders    : tPI_MainProvider;
 BEGIN
  Decode_PurchasesInf(MathPro.Value, Providers, Prices, ProvidersMaths, MainProviders);
  SETZERO(wo_ProviderAmnt, MainProviderAmnt, Cnt);
  FOR_EACH piIdx DO
   IF ~!Providers[piIdx] | ~!Prices[piIdx] THEN
    INC(wo_ProviderAmnt, !Providers[piIdx]);
    L_General.Assert(~!L_Str.PositionInPool(MainProviderPool, MainProviders[piIdx]),
                     "୮ 祭  ⠢騪");
    INC(MainProviderAmnt, MainProviders[piIdx] = L_Str.PoolItem(MainProviderPool, 1));
    IF ~!Providers[piIdx] THEN
     L_General.Assert(SEARCH(Firm, Firm, Providers[piIdx]),
                       "  ⠢騪 " + Providers[piIdx]);
    END;
    L_General.Assert(~!Providers[piIdx] | !ProvidersMaths[piIdx],
                     " 㪠뢠  ⠢騪  । ⠢騪!");
    L_General.Assert(wo_ProviderAmnt < 2,
                     "  ⠢騪  㪠뢠 ⮫쪮  ࠧ!");
    L_General.Assert(MainProviderAmnt < 2,
                     "  ⮫쪮  ᭮ ⠢騪!");
    L_General.Assert((Cnt <= 1) | (wo_ProviderAmnt = 0),
                     "᫨ 㪠 । ⠢騪,|" +
                     "   ⢥ ⠢騪!");
    L_General.Assert(~!MainProviders[piIdx], "室 㪠 ⨯ ⠢騪 (᭮/ ᭮)!");
    L_General.Assert((MainProviders[piIdx] # L_Str.PoolItem(MainProviderPool, 1)) | ~!Providers[piIdx],
                     "। ⠢騪    ᭮ ⠢騪!");
   END; (* IF ~!Providers[piIdx] | ~!Prices[piIdx] *)
  END; (* FOR_EACH piIdx ...*)
 END {Check_PurchasesInf};

 PRIVATE PROCEDURE Check_CompositionSet();
  VAR
   Idx      : SCAL[cs_Amount];
   arrMath  : LIKE(Math.Math)    [cs_Amount];
   arrAmount: NUMERIC[0]         [cs_Amount];
   arrType  : tCompositionSetType[cs_Amount];
   FillLine,
   EmptyLine: SCAL[2];
 BEGIN
  Decode_CompositionSet(MathPro.Value, arrMath, arrAmount, arrType);
  FOR_EACH Idx DO
   EmptyLine:= !arrMath[Idx] *  !arrType[Idx] *  !arrAmount[Idx];
   FillLine :=~!arrMath[Idx] * ~!arrType[Idx] * ~!arrAmount[Idx];
   L_General.Assert(EmptyLine # FillLine,
                    "ப " + L_Str.IntStr(Idx + 1) + ":|" +
                    "      ᮢᥬ");
  END; (* FOR_EACH Idx DO ... *)
 END {Check_CompositionSet};

 PUBLIC PROCEDURE Check(_Property: LIKE(Property.Property));
 BEGIN
  IF    (_Property = P_FloorSpace)   |
        (_Property = P_Warranty)     THEN
   L_Prop.CheckNumericValue(MathPro.Value, "");
  ELSIF (_Property = P_CompositionSet) THEN
   Check_CompositionSet();
  ELSIF (_Property = P_PurchasesInf) THEN
   Check_PurchasesInf();
  END;
 END {Check};

 PUBLIC PROCEDURE HasMathPro(trgMath: LIKE(Math.Math); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  SETSEL(MathPro, Math, trgMath, trgProperty);
  RETURN SRCINSEL(MathPro, LE, D);
 END {HasMathPro};

 PUBLIC PROCEDURE HasActualMathPro(_Math: LIKE(Math.Math); D: DATE; _Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasMathPro(_Math, D, _Property) & (!MathPro.DocExpD | (D < MathPro.DocExpD));
 END {HasActualMathPro};

 PRIVATE PROCEDURE intGet(trgMath    : LIKE(Math.Math);
                          D          : DATE;
                          trgProperty: LIKE(Property.Property);
                          Strong     : SCAL[2];
                          Actual     : SCAL[2]): STRING[];
  VAR
   Has   : SCAL[2];
   Result: LIKE(MathPro.Value);
 BEGIN
  SETEMPTY(Result);
  IF Actual THEN
   Has:=HasActualMathPro(trgMath, D, trgProperty);
  ELSE
   Has:=HasMathPro(trgMath, D, trgProperty);
  END;
  IF Has THEN
   Result:=MathPro.Value;
  ELSE
   IF Strong THEN
    SEARCH(Math, Math, , trgMath);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("Math").Id, Math.RECORDID, trgProperty, D);
   END;
  END;
  RETURN Result;
 END {intGet};

 PUBLIC PROCEDURE GetMathProStrong(trgMath: LIKE(Math.Math); D: DATE; trgProperty: LIKE(Property.Property)): LIKE(MathPro.Value);
 BEGIN
  RETURN intGet(trgMath, D, trgProperty, 1, 1);
 END {GetMathProStrong};

 PUBLIC PROCEDURE GetMathProSoft(trgMath: LIKE(Math.Math); D: DATE; trgProperty: LIKE(Property.Property)): LIKE(MathPro.Value);
 BEGIN
  RETURN intGet(trgMath, D, trgProperty, 0, 1);
 END {GetMathProSoft};

 PUBLIC PROCEDURE GetMathProDate(trgMath: LIKE(Math.Math); D: DATE; trgProperty: LIKE(Property.Property)): DATE;
  VAR
   dummy: STRING[];
 BEGIN
  dummy:=intGet(trgMath, D, trgProperty, 1, 0);
  RETURN MathPro.Date;
 END {GetMathProDate};

 PUBLIC PROCEDURE GetMathProEndDate(trgMath: LIKE(Math.Math); D: DATE; trgProperty: LIKE(Property.Property)): DATE;
  VAR
   dummy: STRING[];
 BEGIN
  dummy:=intGet(trgMath, D, trgProperty, 1, 0);
  RETURN MathPro.EndDate;
 END {GetMathProEndDate};

 PUBLIC PROCEDURE CanHaveProp(curProperty: LIKE(Property.Property));
 BEGIN
  IF    curProperty = P_Tariff THEN
   ACCESS(Math);
   CONFORM(Math, MathType);
   L_General.Assert((Math.MathType = L_MathR.mtyp_CWOrdIncome) |
                    (Math.MathType = L_MathR.mtyp_AdvertisingServices),
                    " ᢮⢮  ਬ   |" +
                    Math.MathType + " " + MathType.Name);
  ELSIF curProperty = P_MyPlace THEN
   ACCESS(Math);
   IF Math.MathKind # L_MathR.mathk_KeyAs THEN
    L_General.Error(" ᢮⢮ ਬ ⮫쪮  '᭮ ।⢠'");
   END;
  END;
 END {CanHaveProp};

 PRIVATE PROCEDURE Decode_Tariff_CWOrder(    trgValue         : STRING[];
                                         VAR MarkG            : LIKE(MarkG.MarkG);
                                         VAR Tariff_wVAT      : SCAL[2];
                                         VAR HourlyPay        : NUMERIC[2];
                                         VAR NightHourlyAdding: NUMERIC[2];
                                         VAR HldHourlyAdding  : NUMERIC[2];
                                         VAR WaitTimAdding    : NUMERIC[2];
                                         VAR MinOrderLength   : NUMERIC[1];
                                         VAR Speed            : NUMERIC[0];
                                         VAR OverRunPay       : NUMERIC[2]);
 BEGIN
  SETEMPTY(MarkG, Tariff_wVAT, HourlyPay, NightHourlyAdding, HldHourlyAdding, WaitTimAdding, MinOrderLength, Speed, OverRunPay);
  IF ~!trgValue THEN
   MarkG            :=L_r2r.DecodeReferenceStamp(L_Prop.getRES(trgValue, 0));
   Tariff_wVAT      :=L_Prop.getRES(trgValue, 1);
   HourlyPay        :=L_Prop.GetNumericValueFromStr(L_Prop.getRES(trgValue, 2));
   NightHourlyAdding:=L_Prop.GetNumericValueFromStr(L_Prop.getRES(trgValue, 3));
   HldHourlyAdding  :=L_Prop.GetNumericValueFromStr(L_Prop.getRES(trgValue, 4));
   WaitTimAdding    :=L_Prop.GetNumericValueFromStr(L_Prop.getRES(trgValue, 5));
   MinOrderLength   :=L_Prop.GetNumericValueFromStr(L_Prop.getRES(trgValue, 6));
   Speed            :=L_Prop.GetNumericValueFromStr(L_Prop.getRES(trgValue, 7));
   OverRunPay       :=L_Prop.GetNumericValueFromStr(L_Prop.getRES(trgValue, 8));
  END;
 END {Decode_Tariff_CWOrder};

 PRIVATE PROCEDURE formSet_Tariff_CWOrder();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  RTI.Get().CurWindow.Title   :="   ॢ (" + MathPro.Property + ")";
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Tariff_wVAT").Format:=tar_VATPool;
  L_WDO.CreateFormLink("MarkG", "");

  Decode_Tariff_CWOrder(MathPro.Value, Fields("MarkG").Value,           Fields("Tariff_wVAT").Value,
                                       Fields("HourlyPay").Value,       Fields("NightHourlyAdding").Value,
                                       Fields("HldHourlyAdding").Value, Fields("WaitTimAdding").Value,
                                       Fields("MinOrderLength").Value,  Fields("Speed").Value,
                                       Fields("OverRunPay").Value);
 END {formSet_Tariff_CWOrder};

 PRIVATE PROCEDURE SuccessfulChange_Tariff();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  IF RTI.Get().CurZone.ActiveField.Name = "MarkG" THEN
   SEARCH(MarkG, MarkG, , RTI.Get().CurZone.ActiveField.Value);
   L_General.Assert(MarkG.MarkGT = L_Way.mgt_OrderIncome, "㯯 ப    " + FLDTOSTR(L_Way.mgt_OrderIncome, "L0", 3));
  END;
 END {SuccessfulChange_Tariff};

 PRIVATE PROCEDURE Decode_Tariff_CarAD(    trgValue        : STRING[];
                                       VAR MountingPrice   : NUMERIC[2];
                                       VAR DismantlingPrice: NUMERIC[2];
                                       VAR PerCoefCountType: tRAT_PerCoefCountType;
                                       VAR RouteGArr       : tRAT_RouteGroup;
                                       VAR PriceArr        : tRAT_Price);
  VAR
   i         : NUMERIC[0];
   Item,
   RouteGPool: STRING[];
 BEGIN
  RouteGPool:=P_Route.GetRouteProPool(P_Route.P_AdvertisingGroup);
  SETEMPTY(MountingPrice, DismantlingPrice, PerCoefCountType, RouteGArr, PriceArr);
  IF ~!trgValue THEN
   MountingPrice   :=L_Str.Str2Num(L_Prop.getRES(trgValue, 0), "2-");
   DismantlingPrice:=L_Str.Str2Num(L_Prop.getRES(trgValue, 1), "2-");
   PerCoefCountType:=L_Prop.getRES(trgValue, 2);

   i:=0;
   WHILE i <= HIGH(RouteGArr) DO
    Item:=L_Prop.getAIS(trgValue, i);
    IF ~!Item THEN
     RouteGArr[i]:=L_Prop.getRES(Item, 0);
     PriceArr[i] :=L_Str.Str2Num(L_Prop.getRES(Item, 1), "2-");
    END;
    INC(i);
   END; (* WHILE i <= HIGH(RouteGArr)...*)
  END;
 END {Decode_Tariff_CarAD};

 PRIVATE PROCEDURE formSet_Tariff_CarAD();
  VAR
   i        : NUMERIC[0];
   Pool     : STRING[];
   Fields   : FORM_FIELDS;
   RouteGArr: tRAT_RouteGroup;
   PriceArr : tRAT_Price;
 BEGIN
  RTI.Get().CurWindow.Title:="  㣨  ࠭ ४ (" + MathPro.Property + ")";
  Fields:=RTI.Get().CurZone.Fields;
  Decode_Tariff_CarAD(MathPro.Value, Fields("MountingPrice").Value,
                                     Fields("DismantlingPrice").Value,
                                     Fields("PerCoefCountType").Value,
                                     RouteGArr,
                                     PriceArr);
  Pool:=P_Route.GetRouteProPool(P_Route.P_AdvertisingGroup);
  i   :=0;
  WHILE i <= HIGH(RouteGArr) DO
   Fields(L_WDO.Fld_wIdx("RouteG", i)).Value:=RouteGArr[i];
   Fields(L_WDO.Fld_wIdx("Price", i)).Value :=PriceArr[i];;

   Fields(L_WDO.Fld_wIdx("RouteG", i)).Template:=Pool;
   Fields(L_WDO.Fld_wIdx("RouteG", i)).TemplateIsStrict:=1;
   INC(i);
  END;
 END {formSet_Tariff_CarAD};

 PRIVATE PROCEDURE formSet_Tariff();
 BEGIN
  CONFORM(MathPro, Math);
  IF    Math.MathType = L_MathR.mtyp_CWOrdIncome THEN
   formSet_Tariff_CWOrder();
  ELSIF Math.MathType = L_MathR.mtyp_AdvertisingServices THEN
   formSet_Tariff_CarAD();
  END;
 END {formSet_Tariff};

 PRIVATE PROCEDURE formGet_Tariff_CWOrder();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_Prop.putRES(MathPro.Value, L_r2r.Put("MathPro", "MarkG", Fields("MarkG").Value));
  L_Prop.putREV(MathPro.Value, Fields("Tariff_wVAT").Value);
  L_Prop.putREV(MathPro.Value, Fields("HourlyPay").Value);
  L_Prop.putREV(MathPro.Value, Fields("NightHourlyAdding").Value);
  L_Prop.putREV(MathPro.Value, Fields("HldHourlyAdding").Value);
  L_Prop.putREV(MathPro.Value, Fields("WaitTimAdding").Value);
  L_Prop.putREV(MathPro.Value, Fields("MinOrderLength").Value);
  L_Prop.putREV(MathPro.Value, Fields("Speed").Value);
  L_Prop.putREV(MathPro.Value, Fields("OverRunPay").Value);
  L_Prop.ConvEmptyRecordPropertyValue(MathPro.Value);
 END {formGet_Tariff_CWOrder};

 PRIVATE PROCEDURE formGet_Tariff_CarAD();
  VAR
   i         : NUMERIC[0];
   Fields    : FORM_FIELDS;
   Item,
   RouteGPool: STRING[];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;

  L_General.Assert(~!Fields("MountingPrice").Value, " 㪠 ⮨ ⠦");
  L_General.Assert(~!Fields("DismantlingPrice").Value, " 㪠 ⮨ ⠦");

  L_Prop.putRES(MathPro.Value, FLDTOSTR(Fields("MountingPrice").Value, "2-"));
  L_Prop.putRES(MathPro.Value, FLDTOSTR(Fields("DismantlingPrice").Value, "2-"));
  L_Prop.putREV(MathPro.Value, Fields("PerCoefCountType").Value);

  RouteGPool:=P_Route.GetRouteProPool(P_Route.P_AdvertisingGroup);
  i         :=0;
  LOOP
   IF !Fields(L_WDO.Fld_wIdx("RouteG", i)) THEN
    EXIT;
   END;
   SETEMPTY(Item);
   L_Prop.putRES(Item, Fields(L_WDO.Fld_wIdx("RouteG", i)).Value);
   L_Prop.putRES(Item, FLDTOSTR(Fields(L_WDO.Fld_wIdx("Price", i)).Value, "2-"));
   IF    Fields(L_WDO.Fld_wIdx("RouteG", i)).Value = L_Str.PoolItem(RouteGPool, 0) THEN
    L_General.Assert(!Fields(L_WDO.Fld_wIdx("Price", i)).Value,
                     " 㯯 ⮢ '" + Fields(L_WDO.Fld_wIdx("RouteG", i)).Value + "'   㪠뢠");
   ELSIF !Fields(L_WDO.Fld_wIdx("RouteG", i)).Value # !Fields(L_WDO.Fld_wIdx("Price", i)).Value THEN
    L_General.Error("   㯯 ⮢|" + "     楫  㯯");
   END;
   L_Prop.putAIS(MathPro.Value, Item);
   INC(i);
  END; (* LOOP *)

  L_Prop.ConvEmptyRecordPropertyValue(MathPro.Value);
 END {formGet_Tariff_CarAD};

 PRIVATE PROCEDURE formGet_Tariff();
 BEGIN
  CONFORM(MathPro, Math);
  IF    Math.MathType = L_MathR.mtyp_CWOrdIncome THEN
   formGet_Tariff_CWOrder();
  ELSIF Math.MathType = L_MathR.mtyp_AdvertisingServices THEN
   formGet_Tariff_CarAD();
  END;
 END {formGet_Tariff};

 PUBLIC PROCEDURE GetCWOrderTariff(    trgMath          : LIKE(Math.Math);
                                       D                : DATE;
                                   VAR MarkG            : LIKE(MarkG.MarkG);
                                   VAR Tariff_wVAT      : SCAL[2];
                                   VAR HourlyPay        : NUMERIC[2];
                                   VAR NightHourlyAdding: NUMERIC[2];
                                   VAR HldHourlyAdding  : NUMERIC[2];
                                   VAR WaitTimAdding    : NUMERIC[2];
                                   VAR MinOrderLength   : NUMERIC[1];
                                   VAR Speed            : NUMERIC[0];
                                   VAR OverRunPay       : NUMERIC[2]);
 BEGIN
  Decode_Tariff_CWOrder(GetMathProSoft(trgMath, D, P_Tariff),
                        MarkG,
                        Tariff_wVAT,
                        HourlyPay,
                        NightHourlyAdding,
                        HldHourlyAdding,
                        WaitTimAdding,
                        MinOrderLength,
                        Speed,
                        OverRunPay);
 END {GetCWOrderTariff};

 PUBLIC PROCEDURE GetAdvertisingServicesTariff(    _Math           : LIKE(Math.Math);
                                                   D               : DATE;
                                               VAR Mount           : NUMERIC[2];
                                               VAR Dismount        : NUMERIC[2];
                                               VAR PerCoefCountType: tRAT_PerCoefCountType;
                                               VAR RouteGroup      : tRAT_RouteGroup;
                                               VAR Price           : tRAT_Price);
 BEGIN
  Decode_Tariff_CarAD(GetMathProSoft(_Math, D, P_Tariff),
                      Mount,
                      Dismount,
                      PerCoefCountType,
                      RouteGroup,
                      Price);
 END {GetAdvertisingServicesTariff};

 PUBLIC PROCEDURE IsCompositeMath(trgMath: LIKE(Math.Math); D: DATE): SCAL[2];
 BEGIN
  RETURN HasActualMathPro(trgMath, D, P_CompositionSet);
 END {IsCompositeMath}; 

 PUBLIC PROCEDURE SetMathUnitedCInPurchasesInf();
  VAR
   Idx         : NUMERIC[0];
   UnitedCField: FORM_FIELD;
 BEGIN
  Idx:=L_WDO.getFldIdx(RTI.Get().CurZone.ActiveField.Name);
  L_General.Assert(~!Idx, " । ப,| ன ॡ ⠢  ந⥫");
  ACCESS(Math);
  UnitedCField:=RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx(v_ProvidersMath, Idx));
  IF ~!UnitedCField.Value & (UnitedCField.Value # Math.UnitedC) THEN
   L_StdFrm.Question("  ந⥫ '" + UnitedCField.Value + "'|" +
                     " 祭  ࠢ筨 '" + Math.UnitedC + "'?");
  END;
  UnitedCField.Value:=Math.UnitedC;
  FIX_ALTERING();
 END {SetMathUnitedCInPurchasesInf};

 PUBLIC PROCEDURE GetMUnitFormat(_Math: LIKE(Math.Math)): STRING[];
  VAR
   _Format: STRING[];
 BEGIN
  SAVE(Math);
  SEARCH(Math, Math, , _Math);
  CONFORM(Math, MUnit);
  _Format:=MUnit.Format;
  IF MUnit.Format > 0 THEN
   _Format:=_Format+".";
  END;
  RESTORE(Math);
  RETURN _Format;
 END {GetMUnitFormat};

 PRIVATE PROCEDURE cs_SetDefaultValue(Idx: NUMERIC[0]; forceEmpty: SCAL[2]);
  VAR
   ff: FORM_FIELDS;
 BEGIN
  ff:=RTI.Get().CurZone.Fields;
  IF forceEmpty | !ff(L_Prop.BuildVideoFieldName("Math", Idx)).Value THEN
   SETEMPTY(ff(L_Prop.BuildVideoFieldName("Math",      Idx)).Value,
            ff(L_Prop.BuildVideoFieldName("Type",      Idx)).Value,
            ff(L_Prop.BuildVideoFieldName("Amount",    Idx)).Value,
            ff(L_Prop.BuildVideoFieldName("MUnitSign", Idx)).Value);
  ELSE
   IF !ff(L_Prop.BuildVideoFieldName("Type", Idx)).Value & !ff(L_Prop.BuildVideoFieldName("Amount", Idx)).Value THEN
    ff(L_Prop.BuildVideoFieldName("Type",   Idx)).Value:=L_Str.PoolItem(cs_TypePool, 1);
    ff(L_Prop.BuildVideoFieldName("Amount", Idx)).Value:=1;
   END;
   ff(L_Prop.BuildVideoFieldName("MUnitSign", Idx)).Value:=L_MathR.DefaultMUnitSign(ff(L_Prop.BuildVideoFieldName("Math", Idx)).Value);
  END;
 END {cs_SetDefaultValue};

 PRIVATE PROCEDURE ArrayItemMove_CompositionSet(Dir: NUMERIC[0]);
 BEGIN
  L_Prop.ArrayItemMove(Dir, ["Math", "Amount", "Type"]);
 END {ArrayItemMove_CompositionSet};

 PUBLIC PROCEDURE OnPropertyArrayItemMoveUp(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_CompositionSet THEN
   ArrayItemMove_CompositionSet(-1);
  END;
 END {OnPropertyArrayItemMoveUp};

 PUBLIC PROCEDURE OnPropertyArrayItemMoveDown(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_CompositionSet THEN
   ArrayItemMove_CompositionSet(+1);
  END;
 END {OnPropertyArrayItemMoveDown};

 PUBLIC PROCEDURE Date_OnSuccessfulChange(_Property: LIKE(Property.Property));
 BEGIN
  IF _Property = P_PriceOfOver THEN
   SetFieldsModifiable_PriceOfOver(MathPro.Date);
  END;
 END {Date_OnSuccessfulChange};

 PRIVATE PROCEDURE SuccessfulChange_Remainders();
  VAR
   i         : SCAL[smr_Amount];
   curIdx    : NUMERIC[0];
   curStorage: LIKE(Storage.Storage);
 BEGIN
  curStorage:=RTI.Get().CurZone.ActiveField.Value;
  curIdx    :=L_WDO.getCurFldIdx();

  IF ~!curStorage THEN
   FOR_EACH i DO
    IF (i # curIdx) & (curStorage = RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("Storage", i)).Value) THEN
     L_General.Error("ப " + L_Str.IntStr(i+1) + ": 㦥 㪠  " + curStorage);
    END;
   END; (* FOR_EACH i ...*)
  END;
 END {SuccessfulChange_Remainders};

 PUBLIC PROCEDURE OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_LifeTime THEN
   SuccessfulChange_LifeTime();
  ELSIF trgProperty = P_Remainders THEN
   SuccessfulChange_Remainders();
  ELSIF trgProperty = P_CompositionSet THEN
   cs_SetDefaultValue(L_Prop.GetCurVideoFieldArrIdx(), 0);
  ELSIF trgProperty = P_Tariff THEN
   SuccessfulChange_Tariff();
  END;
 END {OnSuccessfulChange};

 PUBLIC PROCEDURE Value_OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_MyPlace THEN
   L_General.Assert(STRTOFLD(RTI.Get().CurZone.Fields("Value").Value, NUMERIC) # P_Firm.mp_Fict,
                    "'⮯' "+L_Str.FixedIntStr(P_Firm.mp_Fict, 4)+"    㪠  ᢮⢥");
  END;
 END {Value_OnSuccessfulChange};

 PUBLIC PROCEDURE GetSpcFolder(i: NUMERIC[0]): STRING[];
 BEGIN
  IF i=0 THEN
   RETURN FIO.AsbSpecialFolders(sf_MathSpcPath);
  ELSE
   RETURN "";
  END;
 END {GetSpcFolder};

 PUBLIC PROCEDURE OnBeforeAskForEdit(trgProperty: LIKE(Property.Property));
  VAR
   relPath,
   Dummy   : STRING[];
 BEGIN
  IF    trgProperty = P_SpcRefs THEN
   IF RTI.Get().CurZone.ActiveField.Name = "Offline" THEN
    relPath:=GetSpcFolder(0);
    Dummy:=FIO.ChooseFile(FIO.MakePath("*.*", , relPath));
    IF ~!Dummy THEN
     IF ~!relPath THEN
      IF Str.Pos(Dummy, relPath) = 0 THEN
       Dummy:=Str.Delete(Dummy, 0, Str.Length(relPath));
       IF L_Str.Char(Dummy, 0) = "\" THEN
        Dummy:=Str.Delete(Dummy, 0, 1);
       END;
      ELSE
       L_StdFrm.Choice(" ᯮ  ⠭⭮ ?");
      END;
     END;
     RTI.Get().CurZone.Fields("Offline").Value:=Dummy;
    END;
   END;
  ELSIF trgProperty = P_Tariff THEN
   IF RTI.Get().CurZone.ActiveField.Name = "MarkG" THEN
    L_Way.v_MarkGT:=L_Way.mgt_OrderIncome;
   END;
  END;
 END {OnBeforeAskForEdit};

 PUBLIC PROCEDURE PropertyTax(trgMath: LIKE(Math.Math); D: DATE; VAR Code: P_OwnData.tPropTaxCode; VAR Rate: P_OwnData.tPropTaxRate);
 BEGIN
  IF HasActualMathPro(trgMath, D, P_PropertyTax) THEN
   Decode_PropertyTax(MathPro.Value, Code, Rate);
  ELSE
   SETEMPTY(Code, Rate);
  END;
 END {PropertyTax};

 PRIVATE PROCEDURE Decode_LifeTime(    trgValue : STRING[];
                                   VAR Unit     : tLifeTimeUnit;
                                   VAR Condition: L_CUC.tCondition[lt_Amount];
                                   VAR LifeTime : NUMERIC[0][lt_Amount]);
  VAR
   i           : NUMERIC[0];
   SingleVal   : STRING[];
   trgCondition: L_CUC.tCondition;
 BEGIN
  SETEMPTY(Unit, Condition, LifeTime);
  IF ~!trgValue THEN
   Unit:=L_Str.AnyItem(MathPro.Value, "[", 0);
   i   :=0;
   LOOP
    SingleVal   :=L_Prop.getAIS(trgValue, i);
    IF !SingleVal THEN
     EXIT;
    END;
    trgCondition           :=L_Prop.getRES(SingleVal, 0);
    Condition[trgCondition]:=trgCondition;
    LifeTime[trgCondition] :=L_Str.Str2Num(L_Prop.getRES(SingleVal, 1), "0");
    INC(i);
   END; (* LOOP *)
  END;
 END {Decode_LifeTime};

 PRIVATE PROCEDURE formSet_LifeTime();
  VAR
   i           : NUMERIC[0];
   Fields      : FORM_FIELDS;
   trgUnit     : tLifeTimeUnit;
   trgCondition: L_CUC.tCondition[lt_Amount];
   trgLifeTime : NUMERIC[0][lt_Amount];
 BEGIN
  Decode_LifeTime(MathPro.Value, trgUnit, trgCondition, trgLifeTime);
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Unit").Format:=ltu_Pool;
  IF !trgUnit THEN
   trgUnit:=ltu_Month;
  END;
  Fields("Unit").Value :=trgUnit;
  i:=0;
  WHILE i < lt_Amount DO
   IF ~!Fields(L_WDO.Fld_wIdx("Condition", i)) THEN
    Fields(L_WDO.Fld_wIdx("Condition", i)).Format:=L_CUC.cnd_Pool;
    IF (i = L_CUC.cnd_New) | (i = L_CUC.cnd_Restored) THEN
     IF !trgCondition[i] THEN
      trgCondition[i]:=i;
     END;
    END;
    Fields(L_WDO.Fld_wIdx("Condition", i)).Value :=trgCondition[i];
    Fields(L_WDO.Fld_wIdx("LifeTime", i)).Value:=trgLifeTime[i];
   END;
   INC(i);
  END; (* WHILE (i < lt_Amount...*)
  Fields(L_WDO.Fld_wIdx("LifeTime", L_CUC.cnd_Restored)).Modifiable:=trgUnit = ltu_ThousandKm;
 END {formSet_LifeTime};

 PRIVATE PROCEDURE SuccessfulChange_LifeTime();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  IF RTI.Get().CurZone.ActiveField.Name = "Unit" THEN
   Fields:=RTI.Get().CurZone.Fields;
   Fields(L_WDO.Fld_wIdx("LifeTime", L_CUC.cnd_Restored)).Modifiable:=RTI.Get().CurZone.ActiveField.Value = ltu_ThousandKm;
   SETEMPTY(Fields(L_WDO.Fld_wIdx("LifeTime", L_CUC.cnd_Restored)).Value);
  END;
 END {SuccessfulChange_LifeTime};

 PRIVATE PROCEDURE formGet_LifeTime();
  VAR
   i       : NUMERIC[0];
   Fields  : FORM_FIELDS;
   trgValue: STRING[];
 BEGIN
  Fields       :=RTI.Get().CurWindow.Zones(0).Fields;
  MathPro.Value:=Fields("Unit").Value;
  i:=0;
  WHILE i < lt_Amount DO
   IF ~!Fields(L_WDO.Fld_wIdx("Condition", i)) THEN
    IF ~!Fields(L_WDO.Fld_wIdx("LifeTime", i)).Value THEN
     SETEMPTY(trgValue);
     L_Prop.putREV(trgValue, Fields(L_WDO.Fld_wIdx("Condition", i)).Value);
     L_Prop.putREV(trgValue, Fields(L_WDO.Fld_wIdx("LifeTime", i)).Value);
     L_Prop.putAIS(MathPro.Value, trgValue);
    END;
   END;
   INC(i);
  END; (* WHILE i < lt_Amount...*)
 END {formGet_LifeTime};

 PUBLIC PROCEDURE GetLifeTime(    trgMath  : LIKE(Math.Math);
                                  D        : DATE;
                                  Condition: L_CUC.tCondition;
                              VAR Unit     : tLifeTimeUnit;
                              VAR LifeTime : NUMERIC[0]);
  VAR
   Dummy      : L_CUC.tCondition[lt_Amount];
   trgLifeTime: NUMERIC[0][lt_Amount];
 BEGIN
  Decode_LifeTime(GetMathProSoft(trgMath, D, P_LifeTime), Unit, Dummy, trgLifeTime);
  LifeTime:=trgLifeTime[Condition];
 END {GetLifeTime};

 PRIVATE PROCEDURE Decode_Remainders(    curValue         : STRING[];
                                     VAR TotalMinRemainder,
                                         TotalMaxRemainder: L_XObj.tQnt;
                                     VAR Storages         : LIKE(Storage.Storage)[];
                                     VAR MinRemainders,
                                         MaxRemainders     : L_XObj.tQnt[]);
  VAR
   i          : NUMERIC[0];
   SingleValue: STRING[];
 BEGIN
  SETEMPTY(TotalMinRemainder, TotalMaxRemainder, Storages, MinRemainders, MaxRemainders);
  IF ~!curValue THEN
   SingleValue:=L_Prop.getAIS(curValue, 0);
   TotalMinRemainder:=L_Prop.GetNumericValueFromStr(L_Prop.getRES(SingleValue, 0));
   TotalMaxRemainder:=L_Prop.GetNumericValueFromStr(L_Prop.getRES(SingleValue, 1));
   i                :=1;
   LOOP
    SingleValue:=L_Prop.getAIS(curValue, i);
    IF !SingleValue THEN
     EXIT;
    END;
    Storages[i-1]  :=L_r2r.DecodeReferenceStamp(L_Prop.getRES(SingleValue, 0));
    MinRemainders[i-1]:=L_Prop.GetNumericValueFromStr(L_Prop.getRES(SingleValue, 1));
    MaxRemainders[i-1]:=L_Prop.GetNumericValueFromStr(L_Prop.getRES(SingleValue, 2));
    INC(i);
   END; (* LOOP *)
  END;
 END {Decode_Remainders};

 PRIVATE PROCEDURE formSet_Remainders();
  VAR
   i                : NUMERIC[0];
   Fields           : FORM_FIELDS;
   TotalMinRemainder,
   TotalMaxRemainder: L_XObj.tQnt;
   Storages         : LIKE(Storage.Storage)[smr_Amount];
   MinRemainders,
   MaxRemainders    : L_XObj.tQnt[smr_Amount];
 BEGIN
  Decode_Remainders(MathPro.Value, TotalMinRemainder, TotalMaxRemainder, Storages, MinRemainders, MaxRemainders);
  Fields:=RTI.Get().CurZone.Fields;
  Fields("TotalMinRemainder").Value:=TotalMinRemainder;
  Fields("TotalMaxRemainder").Value:=TotalMaxRemainder;
  i:=0;
  WHILE ~!Fields(L_WDO.Fld_wIdx("Storage", i)) DO
   Fields(L_WDO.Fld_wIdx("Storage", i)).Value     :=Storages[i];
   Fields(L_WDO.Fld_wIdx("MinRemainder", i)).Value:=MinRemainders[i];
   Fields(L_WDO.Fld_wIdx("MaxRemainder", i)).Value:=MaxRemainders[i];
   L_WDO.extCreateFormLink("Storage", "", i);
   INC(i);
  END; (* ~!Fields(L_WDO.Fld_wIdx("Storage", i))...*)
 END {formSet_MinRemainder};

 PRIVATE PROCEDURE formGet_Remainders();
  VAR
   i                     : SCAL[smr_Amount];
   Fields                : FORM_FIELDS;
   TotalMinRemainder,
   TotalMaxRemainder,
   totStorageMinRemainder,
   totStorageMaxRemainder: L_XObj.tQnt;
   Storages              : LIKE(Storage.Storage)[smr_Amount];
   MinRemainders,
   MaxRemainders         : L_XObj.tQnt[smr_Amount];
   trgValue              : STRING[];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;

  TotalMinRemainder:=Fields("TotalMinRemainder").Value;
  TotalMaxRemainder:=Fields("TotalMaxRemainder").Value;
  IF ~!TotalMinRemainder & (TotalMinRemainder < 0) THEN
   L_General.Error("⥫  ⮪  楫  ।");
  END;
  IF ~!TotalMaxRemainder & (TotalMaxRemainder < 0) THEN
   L_General.Error("⥫ ᨬ ⮪  楫  ।");
  END;
  SETEMPTY(Storages, MinRemainders, MaxRemainders);
  SETZERO(totStorageMinRemainder, totStorageMaxRemainder);
  FOR_EACH i DO
   Storages[i]     :=Fields(L_WDO.Fld_wIdx("Storage", i)).Value;
   MinRemainders[i]:=Fields(L_WDO.Fld_wIdx("MinRemainder", i)).Value;
   MaxRemainders[i]:=Fields(L_WDO.Fld_wIdx("MaxRemainder", i)).Value;
   IF ~!MinRemainders[i] & (MinRemainders[i] < 0) THEN
    L_General.Error("ப " + L_Str.IntStr(i+1) + ": ⥫  ⮪");
   END;
   L_General.Assert(~!Storages[i]=~!MinRemainders[i], "ப " + L_Str.IntStr(i+1) + ":    ⮪|" +
                                                      "    ६");
   IF ~!MaxRemainders[i] THEN
    L_General.Assert(~!Storages[i], "ப " + L_Str.IntStr(i+1) + ": ᨬ ⮪|" +
                                    "㪠뢠 ⮫쪮   ");
   END;
   IF ~!MaxRemainders[i] & (MaxRemainders[i] < MinRemainders[i]) THEN
    L_General.Error("ப " + L_Str.IntStr(i+1) + ": ᨬ ⮪  쭮");
   END;
   IF ~!MinRemainders[i] THEN
    INC(totStorageMinRemainder, MinRemainders[i]);
   END;
   IF ~!MaxRemainders[i] THEN
    INC(totStorageMaxRemainder, MaxRemainders[i]);
   END;
  END; (* FOR_EACH i ...*)
  IF ~!TotalMinRemainder & (TotalMinRemainder # 0) & (totStorageMinRemainder # 0) THEN
   L_General.Assert(TotalMinRemainder >= totStorageMinRemainder, " ⮪  楫  । (" + FLDTOSTR(TotalMinRemainder, "2.") + ")|" +
                                                                 "    㬬୮ 쭮 ⪠|" +
                                                                 " ᥬ  (" + FLDTOSTR(totStorageMinRemainder, "2.") + ")");
  END;
  IF ~!TotalMaxRemainder & (TotalMaxRemainder # 0) & (totStorageMaxRemainder # 0) THEN
   L_General.Assert(TotalMaxRemainder >= totStorageMaxRemainder, "ᨬ ⮪  楫  । (" + FLDTOSTR(TotalMaxRemainder, "2.") + ")|" +
                                                                 "    㬬୮ ᨬ쭮 ⪠|" +
                                                                 " ᥬ  (" + FLDTOSTR(totStorageMaxRemainder, "2.") + ")");
  END;

  SETEMPTY(trgValue);
  L_Prop.putREV(trgValue, TotalMinRemainder);
  L_Prop.putREV(trgValue, TotalMaxRemainder);
  L_Prop.putAIS(MathPro.Value, trgValue);

  FOR_EACH i DO
   IF ~!Storages[i] THEN
    SETEMPTY(trgValue);
    L_Prop.putRES(trgValue, L_r2r.Put("MathPro", "Storage", Storages[i]));
    L_Prop.putREV(trgValue, MinRemainders[i]);
    L_Prop.putREV(trgValue, MaxRemainders[i]);
    L_Prop.putAIS(MathPro.Value, trgValue);
   END;
  END; (* FOR_EACH curStorage ...*)
  L_Prop.ConvEmptyRecordPropertyValue(MathPro.Value);
 END {formGet_Remainders};

 PRIVATE PROCEDURE intGetRemainders(trgMath   : LIKE(Math.Math);
                                    trgDate   : DATE;
                                    trgStorage: LIKE(Storage.Storage)): tRemainders;
  VAR
   i                : SCAL[smr_Amount];
   Result           : tRemainders;
   TotalMinRemainder,
   TotalMaxRemainder: L_XObj.tQnt;
   Storages         : LIKE(Storage.Storage)[smr_Amount];
   MinRemainders,
   MaxRemainders    : L_XObj.tQnt[smr_Amount];
 BEGIN
  Decode_Remainders(GetMathProSoft(trgMath, trgDate, P_Remainders),
                    TotalMinRemainder, TotalMaxRemainder, Storages, MinRemainders, MaxRemainders);
  SETEMPTY(Result);
  IF !trgStorage THEN
   IF ~!TotalMinRemainder THEN
    Result[rem_Min]:=TotalMinRemainder;
   ELSE
    Result[rem_Min]:=0;
   END;
   Result[rem_Max]:=TotalMaxRemainder;
  ELSE
   FOR_EACH i DO
    IF    !Storages[i] THEN
     EXIT;
    ELSIF trgStorage = Storages[i] THEN
     Result[rem_Min]:=MinRemainders[i];
     Result[rem_Max]:=MaxRemainders[i];
     EXIT;
    END;
   END; (* FOR_EACH i ...*)
  END;
  RETURN Result;
 END {intGetRemainders};

 PUBLIC PROCEDURE GetRemainders(trgMath: LIKE(Math.Math); trgDate: DATE): tRemainders;
 BEGIN
  RETURN intGetRemainders(trgMath, trgDate, EMPTYOF(Storage.Storage));
 END {GetRemainders};

 PUBLIC PROCEDURE GetStorageRemainders(trgMath   : LIKE(Math.Math);
                                       trgDate   : DATE;
                                       trgStorage: LIKE(Storage.Storage)): tRemainders;
 BEGIN
  RETURN intGetRemainders(trgMath, trgDate, trgStorage);
 END {GetStorageRemainders};

 PUBLIC PROCEDURE GetMinRemainder(trgMath: LIKE(Math.Math); trgDate: DATE): L_XObj.tQnt;
  VAR
   Dummy: tRemainders;
 BEGIN
  Dummy:=GetRemainders(trgMath, trgDate);
  RETURN Dummy[rem_Min];
 END {GetMinRemainder};

 PUBLIC PROCEDURE GetStorageMinRemainder(trgMath   : LIKE(Math.Math);
                                         trgDate   : DATE;
                                         trgStorage: LIKE(Storage.Storage)): L_XObj.tQnt;
  VAR
   Dummy: tRemainders;
 BEGIN
  Dummy:=GetStorageRemainders(trgMath, trgDate, trgStorage);
  RETURN Dummy[rem_Min];
 END {GetStorageMinRemainder};

 PUBLIC PROCEDURE GetMinRemainders(trgMath   : LIKE(Math.Math);
                                   trgDate   : DATE;
                                   VAR Storages: LIKE(Storage.Storage)[];
                                   VAR Values  : L_XObj.tQnt[]);
  VAR
   dmyNUMERIC: L_XObj.tQnt;
   dmyArray  : L_XObj.tQnt[smr_Amount];
 BEGIN
  Decode_Remainders(GetMathProSoft(trgMath, trgDate, P_Remainders),
                    dmyNUMERIC, dmyNUMERIC, Storages, Values, dmyArray);
 END {GetMinRemainders};

 PRIVATE PROCEDURE Decode_SpecialAttitudeToVAT(Value: STRING[]; VAR Name, Reason: STRING[]);
 BEGIN
  Name  :=L_Prop.getRES(Value, 0);
  Reason:=L_Prop.getRES(Value, 1);
 END {Decode_SpecialAttitudeToVAT};

 PRIVATE PROCEDURE formSet_SpecialAttitudeToVAT();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Name").Template          :=satVAT_Pool;
  Fields("Name").TemplateIsStrict  :=1;
  Fields("Reason").Template        :=L_Pool.Get(satVAT_ReasonPoolCen);
  Fields("Reason").TemplateIsStrict:=1;
  Decode_SpecialAttitudeToVAT(MathPro.Value, Fields("Name").Value, Fields("Reason").Value);
 END {formSet_SpecialAttitudeToVAT};

 PRIVATE PROCEDURE Decode_PropertyTax(Value: STRING[]; VAR Code: P_OwnData.tPropTaxCode; VAR Rate: P_OwnData.tPropTaxRate);
 BEGIN
  Code:=STRTOFLD(L_Prop.getRES(Value, 0), SCAL);
  Rate:=STRTOFLD(L_Prop.getRES(Value, 1), NUMERIC);
 END {Decode_PropertyTax};

 PRIVATE PROCEDURE formSet_PropertyTax();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_PropertyTax(MathPro.Value, Fields("Code").Value, Fields("Rate").Value);
 END {formSet_PropertyTax};

 PRIVATE PROCEDURE Decode_SalePrice(Value: STRING[]; VAR Currency: STRING[]; VAR Price: NUMERIC[5]);
 BEGIN
  Currency:=L_Prop.getRES(Value, 0);
  Price   :=STRTOFLD(L_Prop.getRES(Value, 1), NUMERIC);
 END {Decode_SalePrice};

 PRIVATE PROCEDURE formSet_SalePrice();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Currency").Template        :=spc_Pool;
  Fields("Currency").TemplateIsStrict:=1;
  Decode_SalePrice(MathPro.Value, Fields("Currency").Value, Fields("Price").Value);
 END {formSet_SalePrice};

 PRIVATE PROCEDURE Decode_SpcRefs(Value: STRING[]; VAR Offline, Online: STRING[]);
 BEGIN
  Offline:=L_Prop.getAIS(Value, 0);
  Online :=L_Prop.getAIS(Value, 1);
 END {Decode_SpcRefs};

 PRIVATE PROCEDURE formSet_SpcRefs();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_SpcRefs(MathPro.Value, Fields("Offline").Value, Fields("Online").Value);
 END {formSet_SpcRefs};

 PRIVATE PROCEDURE Decode_PriceOfOver(    Value    : STRING[];
                                      VAR arrMyFirm: LIKE(MyFirm.MyFirm)[];
                                      VAR arrPrice : NUMERIC[2][]);
  VAR
   i          : NUMERIC[0];
   SingleValue: STRING[];
 BEGIN
  SETEMPTY(arrMyFirm, arrPrice);
  i:=0;
  WHILE i < poo_Amount DO
   SingleValue:=L_Prop.getAIS(Value, i);
   IF ~!SingleValue THEN
    arrMyFirm[i]:=L_r2r.DecodeReferenceStamp(L_Prop.getRES(SingleValue, 0));
    IF ~!L_Prop.getRES(SingleValue, 1) THEN
     arrPrice[i]:=STRTOFLD(L_Prop.getRES(SingleValue, 1), NUMERIC);
    END;
   END;
   INC(i);
  END;
 END {Decode_PriceOfOver};

 PUBLIC PROCEDURE GetPriceOfOver(trgMath: LIKE(Math.Math); trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): NUMERIC[2];
  VAR
   arrMyFirm: LIKE(MyFirm.MyFirm)[poo_Amount];
   arrPrice : NUMERIC[2][poo_Amount];
   i        : NUMERIC[0];
 BEGIN
  L_General.Assert(HasActualMathPro(trgMath, D, P_PriceOfOver),
                   " ⠭ 業   ⮯  " + L_DatTim.DateStr(D) + ":| " + trgMath + ", ᢮⢮ "+L_Str.IntStr(P_PriceOfOver));
  Decode_PriceOfOver(MathPro.Value, arrMyFirm, arrPrice);
  i:=0;
  WHILE i < poo_Amount DO
   IF arrMyFirm[i] = trgMyFirm THEN
    RETURN arrPrice[i];
   END;
   INC(i);
  END;
  L_General.Error(" '' ࣠樨 " + trgMyFirm +
                  "| ⠭ 業   ⮯ " + trgMath + "  " + L_DatTim.DateStr(D));
 END {GetPriceOfOver};

 PRIVATE PROCEDURE SetFieldsModifiable_PriceOfOver(trgDate: DATE);
  VAR
   D              : DATE;
   i              : NUMERIC[0];
   wMultipleMyFirm: SCAL[2];
   Fields         : FORM_FIELDS;
 BEGIN
  IF !trgDate THEN D:=SYSDATE();
  ELSE             D:=trgDate;
  END;
  wMultipleMyFirm:=P_Firm.E_wMultipleMyFirm(D);
  Fields         :=RTI.Get().CurZone.Fields;
  i:=0;
  WHILE i < poo_Amount DO
   Fields(L_WDO.Fld_wIdx("MyFirm", i)).Modifiable:=wMultipleMyFirm;
   Fields(L_WDO.Fld_wIdx("Price",  i)).Modifiable:=wMultipleMyFirm;
   INC(i);
  END;
  IF ~wMultipleMyFirm THEN
   Fields(L_WDO.Fld_wIdx("MyFirm", 0)).Value     :=P_Firm.mf_Own;
   Fields(L_WDO.Fld_wIdx("Price",  0)).Modifiable:=1;
  END;
 END {SetFieldsModifiable_PriceOfOver};

 PRIVATE PROCEDURE formSet_PriceOfOver();
  VAR
   Fields   : FORM_FIELDS;
   Idx      : SCAL[poo_Amount];
   arrMyFirm: LIKE(MyFirm.MyFirm)[poo_Amount];
   arrPrice : NUMERIC[2][poo_Amount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_PriceOfOver(MathPro.Value, arrMyFirm, arrPrice);
  FOR_EACH Idx DO
   L_WDO.extCreateFormLink("MyFirm", "", Idx);
   Fields(L_WDO.Fld_wIdx("MyFirm", Idx)).Value:=arrMyFirm[Idx];
   Fields(L_WDO.Fld_wIdx("Price",  Idx)).Value:=arrPrice[Idx];
  END;
  SetFieldsModifiable_PriceOfOver(MathPro.Date);
 END {formSet_PriceOfOver};

 PUBLIC PROCEDURE Decode_PreciousMetals(Value: STRING[]; VAR PreciousMetals: tPreciousMetals[pm_Amount]);
  VAR
   Idx: SCAL[pm_Amount];
 BEGIN
  SETZERO(PreciousMetals);
  FOR_EACH Idx DO
   IF ~!L_Prop.getRES(Value, Idx) THEN
    PreciousMetals[Idx]:=STRTOFLD(L_Prop.getRES(Value, Idx), NUMERIC);
   END
  END; (* FOR_EACH Idx ...*)
 END {Decode_PreciousMetals};

 PRIVATE PROCEDURE formSet_PreciousMetals();
  VAR
   Fields        : FORM_FIELDS;
   Idx           : SCAL[pm_Amount];
   PreciousMetals: tPreciousMetals[pm_Amount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_PreciousMetals(MathPro.Value, PreciousMetals);
  FOR_EACH Idx DO
   Fields(L_WDO.Fld_wIdx("PreciousMetals", Idx)).Value:=PreciousMetals[Idx];
  END; (* FOR_EACH Idx ... *)
 END {formSet_PreciousMetals};

 PUBLIC PROCEDURE Decode_CompositionSet(    curValue : STRING[];
                                        VAR arrMath  : LIKE(Math.Math)[];
                                        VAR arrAmount: NUMERIC[0][];
                                        VAR arrType  : tCompositionSetType[]);
  VAR
   i           : NUMERIC[0];
   SingleValue : STRING[];
 BEGIN
  SETEMPTY(arrMath, arrAmount, arrType);
  i:=0;
  WHILE i < cs_Amount DO
   SingleValue :=L_Prop.getAIS(curValue, i);
   arrMath  [i]:=L_r2r.Decode(L_Prop.getRES(SingleValue, csi_Math));
   arrAmount[i]:=L_Str.Str2Num(L_Prop.getRES(SingleValue, csi_Amount), "3.");
   arrType  [i]:=L_Prop.getRES(SingleValue, csi_Type);
   INC(i);
  END; (* WHILE i < cs_Amount...*)
 END {Decode_CompositionSet};

 PUBLIC PROCEDURE GetCompositionSetType(curType: STRING[]): SCAL[2];
 BEGIN
  RETURN L_Str.PositionInPool(cs_TypePool, curType);
 END {GetCompositionSetType};

 PRIVATE PROCEDURE formSet_CompositionSet();
  VAR
   Fields   : FORM_FIELDS;
   Idx      : SCAL[cs_Amount];
   arrMath  : LIKE(Math.Math)    [cs_Amount];
   arrAmount: NUMERIC[0]         [cs_Amount];
   arrType  : tCompositionSetType[cs_Amount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_CompositionSet(MathPro.Value, arrMath, arrAmount, arrType);
  FOR_EACH Idx DO
   L_WDO.extCreateFormLink("Math", "", Idx);
   Fields(L_Prop.BuildVideoFieldName("Math",  Idx)).Value:=arrMath  [Idx];
   Fields(L_Prop.BuildVideoFieldName("Amount",Idx)).Value:=arrAmount[Idx];
   Fields(L_Prop.BuildVideoFieldName("Type",  Idx)).Value:=arrType  [Idx];
   Fields(L_Prop.BuildVideoFieldName("Type",  Idx)).Template        :=cs_TypePool;
   Fields(L_Prop.BuildVideoFieldName("Type",  Idx)).TemplateIsStrict:=1;
   IF ~!arrMath[Idx] THEN
    Fields(L_Prop.BuildVideoFieldName("MUnitSign", Idx)).Value:=L_MathR.DefaultMUnitSign(arrMath[Idx]);
   END;
  END; (* FOR_EACH Idx DO ... *)
 END {formSet_CompositionSet};

 PUBLIC PROCEDURE SetDataInForm(_Property: LIKE(Property.Property));
 BEGIN
  IF    _Property = P_LifeTime             THEN
   formSet_LifeTime();
  ELSIF _Property = P_Remainders           THEN
   formSet_Remainders();
  ELSIF _Property = P_SpecialAttitudeToVAT THEN
   formSet_SpecialAttitudeToVAT();
  ELSIF _Property = P_PropertyTax          THEN
   formSet_PropertyTax();
  ELSIF _Property = P_SalePrice            THEN
   formSet_SalePrice();
  ELSIF _Property = P_SpcRefs              THEN
   formSet_SpcRefs();
  ELSIF _Property = P_PriceOfOver          THEN
   formSet_PriceOfOver();
  ELSIF _Property = P_Tariff THEN
   formSet_Tariff();
  ELSIF (_Property = P_CompositionSet)     THEN
   formSet_CompositionSet();
  ELSIF (_Property = P_PreciousMetals)     THEN
   formSet_PreciousMetals();
  ELSIF _Property = P_PurchasesInf         THEN
   formSet_PurchasesInf();
  END;
 END {SetDataInForm};

 PUBLIC PROCEDURE ConvNumericValueToStr(_Price: NUMERIC[5]): STRING[];
  VAR
   tmpValue: STRING[];
 BEGIN
  tmpValue:=FLDTOSTR(_Price);
  LOOP
   IF Str.Slice(tmpValue, Str.Length(tmpValue)-1, 1) = "0" THEN
    tmpValue:=Str.Delete(tmpValue, Str.Length(tmpValue) - 1, 1);
   ELSE
    RETURN Str.Condense(tmpValue);
   END;
   IF Str.Slice(tmpValue, Str.Length(tmpValue)-1, 1) = "." THEN
    RETURN Str.Condense(Str.Delete(tmpValue, Str.Length(tmpValue) - 1, 1));
   END;
  END; (* LOOP *)
 END {ConvNumericValueToStr};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   SingleValue,
   s1, s2, Result   : STRING[];
   piIdx            : SCAL[pi_Amount];
   Providers        : LIKE(Firm.Firm)[pi_Amount];
   Prices           : tPI_Price;
   ProvidersMaths   : tPI_ProvidersMath;
   MainProviders    : tPI_MainProvider;
   i                : SCAL[smr_Amount];
   j                : NUMERIC[0];
   TotalMinRemainder,
   TotalMaxRemainder: L_XObj.tQnt;
   Storages         : LIKE(Storage.Storage)[smr_Amount];
   MinRemainders,
   MaxRemainders    : L_XObj.tQnt[smr_Amount];
   arrMyFirm        : LIKE(MyFirm.MyFirm)[poo_Amount];
   arrPrice         : NUMERIC[2][poo_Amount];
   trgMarkG         : LIKE(MarkG.MarkG);
   Tariff_wVAT      : SCAL[2];
   HourlyPay        : NUMERIC[2];
   NightHourlyAdding: NUMERIC[2];
   HldHourlyAdding  : NUMERIC[2];
   WaitTimAdding    : NUMERIC[2];
   MinOrderLength   : NUMERIC[1];
   Speed            : NUMERIC[0];
   OverRunPay       : NUMERIC[2];
   Fields           : FORM_FIELDS;
   trgUnit          : tLifeTimeUnit;
   trgCondition     : L_CUC.tCondition[lt_Amount];
   trgLifeTime      : NUMERIC[0][lt_Amount];
 BEGIN
  SETEMPTY(Result);
  IF    MathPro.Property = P_LifeTime THEN
   Decode_LifeTime(MathPro.Value, trgUnit, trgCondition, trgLifeTime);
   i:=0;
   WHILE i < lt_Amount DO
    IF ~!trgCondition[i] THEN
     Result:=L_Str.AddStrDlm(Result, ", ") + L_Str.PoolItem(L_CUC.cnd_Pool, i) + ":" + FLDTOSTR(trgLifeTime[i], "0") + " " + L_Str.PoolItem(ltu_Pool_Short, trgUnit);
    END;
    INC(i);
   END; (* WHILE i < lt_Amount...*)
  ELSIF MathPro.Property = P_Remainders THEN
   Decode_Remainders(MathPro.Value, TotalMinRemainder, TotalMaxRemainder, Storages, MinRemainders, MaxRemainders);
   IF ~!TotalMinRemainder | ~!TotalMaxRemainder THEN
    Result:=" ।: "+FLDTOSTR(TotalMinRemainder, "2.")+"; "+FLDTOSTR(TotalMaxRemainder, "2.");
   END;
   FOR_EACH i DO
    IF !Storages[i] THEN
     EXIT;
    END;
    Result:=L_Str.AddStrDlm(Result, "; ")+" "+Storages[i]+": "+FLDTOSTR(MinRemainders[i], "2.")+"; "+FLDTOSTR(MaxRemainders[i], "2.");;
   END; (* FOR_EACH i ... *)
  ELSIF MathPro.Property = P_PurchasesInf THEN
   s1:="";
   s2:="";
   Decode_PurchasesInf(MathPro.Value, Providers, Prices, ProvidersMaths, MainProviders);
   FOR_EACH piIdx DO
    IF ~!Prices[piIdx] | ~!Providers[piIdx] THEN
     IF MainProviders[piIdx] = L_Str.PoolItem(MainProviderPool, 1) THEN
      s1:=FLDTOSTR(Providers[piIdx]) + " " + ConvNumericValueToStr(Prices[piIdx]);
     ELSIF !Providers[piIdx] THEN
      RETURN ".: " + ConvNumericValueToStr(Prices[piIdx]);
     ELSE
      s2:=L_Str.AddStrDlm(s2, ", ") + Providers[piIdx] + " " + ConvNumericValueToStr(Prices[piIdx]);
     END;
    END;
   END;
   IF !s1 THEN
    IF !s2 THEN
     Result:="";
    ELSE
     Result:=": " + s2;
    END;
   ELSE
    IF !s2 THEN
     Result:=": " + s1;
    ELSE
     Result:=": " + s1 + "; : " + s2;
    END;
   END;
  ELSIF MathPro.Property = P_ParentMath     THEN
   SAVE(Math);
   SEARCH(Math, Math, , L_r2r.DecodeReferenceStamp(MathPro.Value));
   Result:=Math.Math + " " + Math.Name;
   RESTORE(Math);
  ELSIF MathPro.Property = P_PriceOfOver THEN
   Decode_PriceOfOver(MathPro.Value, arrMyFirm, arrPrice);
   j:=0;
   WHILE j < poo_Amount DO
    IF ~!arrPrice[j] THEN
     SETEMPTY(SingleValue);
     L_Prop.putREV(SingleValue, arrMyFirm[j]);
     L_Prop.putREV(SingleValue, arrPrice [j]);
     L_Prop.putAIS(Result, SingleValue);
    END;
    INC(j);
   END;
  ELSIF MathPro.Property = P_MyPlace THEN
   Result:=L_Prop.GetMyPlaceVal2Show(MathPro.Value);
  ELSIF MathPro.Property = P_Tariff THEN
   CONFORM(MathPro, Math);
   IF    Math.MathType = L_MathR.mtyp_CWOrdIncome THEN
    Decode_Tariff_CWOrder(MathPro.Value,
                          trgMarkG,
                          Tariff_wVAT,
                          HourlyPay,
                          NightHourlyAdding,
                          HldHourlyAdding,
                          WaitTimAdding,
                          MinOrderLength,
                          Speed,
                          OverRunPay);
    IF ~!trgMarkG THEN
     SEARCH(MarkG, MarkG, , trgMarkG);
     Result:=MarkG.Name + ", ";
    END;
    Result:=Result + L_Money.MoneyToStr(MathPro.Date, "", HourlyPay) + " /, " +
                     ". " + FLDTOSTR(MinOrderLength, "1.") + " .";
   ELSE
    Result:=MathPro.Value;
   END;
  ELSIF MathPro.Property = P_CompositionSet THEN
   Result:=GetCompositionSetVal2Show(MathPro.Value);
  ELSE
   Result:=MathPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PRIVATE PROCEDURE Encode_SpecialAttitudeToVAT(VAR Value: STRING[]; Name, Reason: STRING[]);
 BEGIN
  L_Prop.putREV(Value, Name);
  L_Prop.putREV(Value, Reason);
 END {Encode_SpecialAttitudeToVAT};

 PRIVATE PROCEDURE formGet_SpecialAttitudeToVAT();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_SpecialAttitudeToVAT(MathPro.Value, Fields("Name").Value, Fields("Reason").Value);
 END {formGet_SpecialAttitudeToVAT};

 PRIVATE PROCEDURE Encode_PropertyTax(VAR Value: STRING[]; Code: P_OwnData.tPropTaxCode; Rate: P_OwnData.tPropTaxRate);
 BEGIN
  L_Prop.putREV(Value, Code);
  L_Prop.putREV(Value, Rate);
 END {Encode_PropertyTax};

 PRIVATE PROCEDURE formGet_PropertyTax();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_PropertyTax(MathPro.Value, Fields("Code").Value, Fields("Rate").Value);
 END {formGet_PropertyTax};

 PRIVATE PROCEDURE Encode_SalePrice(VAR Value: STRING[]; Currency: STRING[]; Price: NUMERIC[5]);
 BEGIN
  L_Prop.putREV(Value, Currency);
  L_Prop.putREV(Value, Price);
 END {Encode_SalePrice};

 PRIVATE PROCEDURE formGet_SalePrice();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_SalePrice(MathPro.Value, Fields("Currency").Value, Fields("Price").Value);
 END {formGet_SalePrice};

 PRIVATE PROCEDURE Encode_SpcRefs(VAR Value: STRING[]; Offline, Online: STRING[]);
 BEGIN
  L_Prop.putAIS(Value, Offline);
  L_Prop.putAIS(Value, Online);
 END {Encode_SpcRefs};

 PRIVATE PROCEDURE formGet_SpcRefs();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_SpcRefs(MathPro.Value, Fields("Offline").Value, Fields("Online").Value);
 END {formGet_SpcRefs};

 PRIVATE PROCEDURE Encode_PriceOfOver(VAR Value    : STRING[];
                                          arrMyFirm: LIKE(MyFirm.MyFirm)[];
                                          arrPrice : NUMERIC[2][]);
  VAR
   i          : NUMERIC[0];
   refMyFirm,
   SingleValue: STRING[];
 BEGIN
  i:=0;
  WHILE i < poo_Amount DO
   IF ~!arrPrice[i] THEN
    SETEMPTY(SingleValue);
    IF ~!arrMyFirm[i] THEN
     L_Prop.putRES(SingleValue, L_r2r.Put("MathPro", "MyFirm", arrMyFirm[i]));
    ELSE
     L_Prop.putRES(SingleValue, "");
    END;
    L_Prop.putREV(SingleValue, arrPrice [i]);
    L_Prop.putAIS(Value, SingleValue);
   END;
   INC(i);
  END;
 END {Encode_PriceOfOver};

 PRIVATE PROCEDURE formGet_PriceOfOver();
  VAR
   Fields   : FORM_FIELDS;
   Idx      : SCAL[poo_Amount];
   arrMyFirm: LIKE(MyFirm.MyFirm)[poo_Amount];
   arrPrice : NUMERIC[2][poo_Amount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   arrMyFirm[Idx]:=Fields(L_WDO.Fld_wIdx("MyFirm", Idx)).Value;
   arrPrice [Idx]:=Fields(L_WDO.Fld_wIdx("Price",  Idx)).Value;
   IF !arrPrice[Idx] & ~!arrMyFirm[Idx] THEN
    L_General.Error(" 㪠 業  '' ࣠樨 " + arrMyFirm[Idx]);
   END;
  END;
  Encode_PriceOfOver(MathPro.Value, arrMyFirm, arrPrice);
 END {formGet_PriceOfOver};

 PRIVATE PROCEDURE ConvFldToStr(trgValue: tPreciousMetals): STRING[];
  VAR
   Length  : NUMERIC[0];
   tmpValue: STRING[];
 BEGIN
  IF    !trgValue THEN
   RETURN "";
  ELSIF trgValue = 0 THEN
   RETURN "0.0";
  ELSIF Math.Mod(trgValue, Math.Trunc(trgValue)) = 0 THEN
   RETURN FLDTOSTR(trgValue, "1.");
  ELSE
   tmpValue:=FLDTOSTR(trgValue, L_Str.IntStr(PRECISIONOF(tPreciousMetals)) + ".");
   Length:=Str.Length(tmpValue);
   WHILE Str.Slice(tmpValue, Length - 1, 1) = "0" DO
    tmpValue:=Str.Delete(tmpValue, Length - 1, 1);
    DEC(Length);
   END; (* WHILE Str.Slice(tmpValue, Length - 1, 1) = "0"...*)
   RETURN tmpValue;
  END;
 END {ConvFldToStr};

 PRIVATE PROCEDURE Encode_PreciousMetals(VAR Value: STRING[]; PreciousMetals: tPreciousMetals[pm_Amount]);
  VAR
   Idx        : SCAL[pm_Amount];
   HasNotEmpty: SCAL[2];
 BEGIN
  HasNotEmpty:=0;
  FOR_EACH Idx DO
   HasNotEmpty:=HasNotEmpty | ~!PreciousMetals[Idx];
   L_Prop.putRES(Value, ConvFldToStr(PreciousMetals[Idx]));
  END; (* FOR_EACH Idx ...*)
  IF ~HasNotEmpty THEN
   SETEMPTY(Value);
  END;
 END {Encode_PreciousMetals};

 PRIVATE PROCEDURE formGet_PreciousMetals();
  VAR
   Fields        : FORM_FIELDS;
   Idx           : SCAL[pm_Amount];
   PreciousMetals: tPreciousMetals[pm_Amount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   PreciousMetals[Idx]:=Fields(L_WDO.Fld_wIdx("PreciousMetals", Idx)).Value;
  END; (* FOR_EACH Idx ... *)
  Encode_PreciousMetals(MathPro.Value, PreciousMetals);
 END {formGet_PreciousMetals};

 PRIVATE PROCEDURE Encode_CompositionSet(VAR curValue : STRING[];
                                             arrMath  : LIKE(Math.Math)[];
                                             arrAmount: NUMERIC[0][];
                                             arrType  : tCompositionSetType[]);
  VAR
   i       : NUMERIC[0];
   tmpValue: STRING[];
 BEGIN
  SETEMPTY(curValue);
  i:=0;
  WHILE i < cs_Amount DO
   IF ~!arrMath[i] THEN
    SETEMPTY(tmpValue);
    L_Prop.putRES(tmpValue, L_r2r.Put("MathPro", "Math", arrMath[i]));
    L_Prop.putREV(tmpValue, arrAmount[i]);
    L_Prop.putRES(tmpValue, arrType[i]);
    L_Prop.putAIS(curValue, tmpValue);
   END;
   INC(i);
  END (* WHILE i < cs_Amount...*);
 END {Encode_CompositionSet};

 PRIVATE PROCEDURE GetCompositionSetVal2Show(curValue : STRING[]): STRING[];
  VAR
   i        : NUMERIC[0];
   Result,
   tmpValue : STRING[];
   arrMath  : LIKE(Math.Math)    [cs_Amount];
   arrAmount: NUMERIC[0]         [cs_Amount];
   arrType  : tCompositionSetType[cs_Amount];
 BEGIN
  Decode_CompositionSet(curValue, arrMath, arrAmount, arrType);
  SETEMPTY(Result);
  i:=0;
  WHILE i < cs_Amount DO
   IF ~!arrMath[i] THEN
    SETEMPTY(tmpValue);
    L_Prop.putRES(tmpValue, arrMath[i]);
    L_Prop.putREV(tmpValue, arrAmount[i]);
    L_Prop.putRES(tmpValue, arrType[i]);
    L_Prop.putAIS(Result, tmpValue);
   END;
   INC(i);
  END (* WHILE i < cs_Amount...*);
  RETURN Result;
 END {GetCompositionSetVal2Show};

 PRIVATE PROCEDURE formGet_CompositionSet();
  VAR
   Fields   : FORM_FIELDS;
   Idx      : SCAL[cs_Amount];
   arrMath  : LIKE(Math.Math)    [cs_Amount];
   arrAmount: NUMERIC[0]         [cs_Amount];
   arrType  : tCompositionSetType[cs_Amount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   arrMath  [Idx]:=Fields(L_Prop.BuildVideoFieldName("Math",   Idx)).Value;
   arrAmount[Idx]:=Fields(L_Prop.BuildVideoFieldName("Amount", Idx)).Value;
   arrType  [Idx]:=Fields(L_Prop.BuildVideoFieldName("Type",   Idx)).Value;
  END; (* FOR_EACH Idx DO ... *)
  Encode_CompositionSet(MathPro.Value, arrMath, arrAmount, arrType);
 END {formGet_CompositionSet};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty: LIKE(Property.Property));
  BEGIN
  SETEMPTY(MathPro.Value, MathPro.Val2Show);
  IF    trgProperty = P_LifeTime THEN
   formGet_LifeTime();
  ELSIF trgProperty = P_Remainders THEN
   formGet_Remainders();
  ELSIF trgProperty = P_PriceOfOver THEN
   formGet_PriceOfOver();
  ELSIF trgProperty = P_PreciousMetals THEN
   formGet_PreciousMetals();
  ELSIF trgProperty = P_Tariff THEN
   formGet_Tariff();
  ELSIF trgProperty = P_CompositionSet THEN
   formGet_CompositionSet();
  ELSIF trgProperty = P_PurchasesInf THEN
   formGet_PurchasesInf();
  ELSIF trgProperty = P_SpcRefs THEN
   formGet_SpcRefs();
  ELSIF trgProperty = P_SalePrice THEN
   formGet_SalePrice();
  ELSIF trgProperty = P_SpecialAttitudeToVAT THEN
   formGet_SpecialAttitudeToVAT();
  ELSIF trgProperty = P_PropertyTax THEN
   formGet_PropertyTax();
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(MathPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE GetPPrice(_Math          : LIKE(Math.Math);
                            D              : DATE;
                            ExpPeriod      : NUMERIC[0];
                            wCheckExpPeriod: SCAL[2];
                            VAR Msg        : STRING[]): NUMERIC[5];
  VAR
   Width    : NUMERIC[0];
   _Vendor  : LIKE(Math.Vendor);
   _MathName: STRING[];
   piIdx         : SCAL[pi_Amount];
   Providers     : LIKE(Firm.Firm)[pi_Amount];
   Prices        : tPI_Price;
   ProvidersMaths: tPI_ProvidersMath;
   MainProviders : tPI_MainProvider;
 BEGIN
  IF HasActualMathPro(_Math, D, P_PurchasesInf) THEN
   GE_APPWIN_SIZE(Width);
   DEC(Width, 6);

   IF wCheckExpPeriod THEN
    SAVE(Math);
    L_General.CallUs(SEARCH(Math, Math, _Math));
    _Vendor  :=Math.Vendor;
    _MathName:=Math.Name;
    IF (_Vendor # L_MathR.vnd_Ourselves) & ((D - MathPro.Date) > ExpPeriod) THEN
     Msg:=L_Str.AddStrDlm(Msg, "|") + Str.Align(_Math + " " + _MathName, Width, LEFT);
    END;
    RESTORE(Math);
   END;
   Decode_PurchasesInf(MathPro.Value, Providers, Prices, ProvidersMaths, MainProviders);
   FOR_EACH piIdx DO
    IF MainProviders[piIdx] = L_Str.PoolItem(MainProviderPool, 1) THEN
     RETURN Prices[piIdx];
    END;
   END;
   RETURN Prices[0];
  END;
  RETURN EMPTYOF(Prices[0]);
 END {GetPPrice};

 PUBLIC PROCEDURE GetSpcRef(trgMath: LIKE(Math.Math); D: DATE; Idx: NUMERIC[0]): STRING[];
  VAR
   Offline, Online: STRING[];
 BEGIN
  IF HasActualMathPro(trgMath, D, P_SpcRefs) THEN
   Decode_SpcRefs(MathPro.Value, Offline, Online);
   IF    Idx = 0 THEN
    RETURN Offline;
   ELSIF Idx = 1 THEN
    RETURN Online;
   END
  ELSE
   RETURN "";
  END;
 END {GetSpcRef};

 PUBLIC PROCEDURE GetSpecialAttitudeToVAT(trgMath: LIKE(Math.Math); D: DATE): tSpecialAttitudeToVAT;
  VAR
   Name, Reason: STRING[];
 BEGIN
  IF HasActualMathPro(trgMath, D, P_SpecialAttitudeToVAT) THEN
   Decode_SpecialAttitudeToVAT(MathPro.Value, Name, Reason);
   RETURN L_Str.PositionInPool(satVAT_Pool, Name);
  ELSE
   RETURN satVAT_woFeatures;
  END;
 END {GetSpecialAttitudeToVAT};


 PUBLIC PROCEDURE GetP_PurchaseInf(    _Math        : LIKE(Math.Math);
                                       D            : DATE;
                                   VAR _Firm        : L_Prop.tArrayElement;
                                   VAR _Price       : tPI_Price;
                                   VAR _PMath       : tPI_ProvidersMath;
                                   VAR _MainProvider: tPI_MainProvider);
  VAR
   i: NUMERIC[0];
 BEGIN
  SETEMPTY(_Firm, _Price, _PMath, _MainProvider);
  IF HasActualMathPro(_Math, D, P_PurchasesInf) THEN
   Decode_PurchasesInf(MathPro.Value, _Firm, _Price, _PMath, _MainProvider);
  END;
 END {GetP_PurchaseInf};

 PUBLIC PROCEDURE GetParentMath(_Math: LIKE(Math.Math); D: DATE): LIKE(Math.Math);
  VAR
   result: LIKE(Math.Math);
 BEGIN
  SETEMPTY(result);
  IF HasActualMathPro(_Math, D, P_ParentMath) THEN
   result:=L_r2r.DecodeReferenceStamp(MathPro.Value);
  END;
  RETURN result;
 END {GetParentMath};

 PUBLIC PROCEDURE GetMyPlace(trgMath: LIKE(Math.Math); D: DATE): LIKE(Math.Math);
  VAR
   Result: LIKE(Math.Math);
 BEGIN
  IF HasActualMathPro(trgMath, D, P_MyPlace) THEN
   Result:=L_r2r.DecodeReferenceStamp(MathPro.Value);
  ELSE
   SAVE(Math);
   SEARCH(Math, Math, , trgMath);
   Result:=P_Firm.GetMainMyPlace(D, Math.MyFirm);
   RESTORE(Math);
  END;
  RETURN Result;
 END {GetMyPlace};

 PUBLIC PROCEDURE GetSalePrice(    trgMath : LIKE(Math.Math);
                                   D       : DATE;
                               VAR Currency: tSPCurrency;
                               VAR Price   : NUMERIC[5]);
  VAR
   strCurrency: STRING[];
 BEGIN
  SETEMPTY(Currency, Price);
  IF HasActualMathPro(trgMath, D, P_SalePrice) THEN
   Decode_SalePrice(MathPro.Value, strCurrency, Price);
   Currency:=L_Str.PositionInPool(spc_Pool, strCurrency);
  END;
 END {GetSalePrice};

 PUBLIC PROCEDURE IsDomesticManufacture(trgMath: LIKE(Math.Math); D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(Math);
  L_General.CallUs(SEARCH(Math, Math, trgMath));
  Result:=(Math.Vendor = L_MathR.vnd_Ourselves);
  IF ~Result THEN
   SAVE(MathType);
   CONFORM(Math, MathType);
   Result:=(MathType.Category = L_Acnt.mtc_Gains) | (MathType.Category = L_Acnt.mtc_Expenses);
   RESTORE(MathType);
  END;
  RESTORE(Math);
  RETURN Result | HasActualMathPro(trgMath, D, P_DomesticManufacture);
 END {IsDomesticManufacture};

 PUBLIC PROCEDURE OnAfterEdIns();
 BEGIN
  IF MathPro.Property = P_ParentMath THEN
   MathPro.SpdSrchV:=L_r2r.DecodeReferenceStamp(MathPro.Value);
   REPLACE(MathPro);
  END;
 END {OnAfterEdIns};

 PUBLIC PROCEDURE OnAfterInsert();
 BEGIN
  OnAfterEdIns();
 END {OnAfterEdit};

 PUBLIC PROCEDURE OnAfterEdit();
 BEGIN
  OnAfterEdIns();
 END {OnAfterEdit};

 PUBLIC PROCEDURE P_7007A_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iField       (0, "MarkG").OnBeforeAsk:=1;
  L_WDO.iScsChange   (0, ["DocExpD", "MarkG"]);
  L_WDO.iUnmodifiable(0, ["MarkG_Name", "ObjectTitle", "ObjectDescr"]);
  L_WDO.iMayBeEmpty  (0, ["DocExpD"]);
  L_WDO.iProgs       (0, "ObjPro");
 END {P_7007A_OnInitializeWindow};

END.
