(*
%Copyright   (c) Polak IT
%Author      15.01.2010 17:07:00 POLAK\GAV
%Purpose
%Type        library
%Specific    SYS
%Modified    17.09.2014 18:24:11 POLAK\Gina
%Environment
*)

 MODULE P_MCList [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tAttitude2SFee = SCAL[4];
  tAttitude2IInj = SCAL[3];
  tForFuture     = SCAL[4];
  tSMPrintMode   = SCAL[3];

 PUBLIC CONST
  P_Attitude2SFee  = 3600;
  P_SMPrintMode    = 3601;
  P_inBonus        = 3602;
  P_Attitude2IInj  = 3603;
  P_ForFuture      = 3604;
  P_PayOnDischarge = 3605;
  P_Comment        = 3606;
  P_DstMode        = 3607;

  a2sf_NotObject      = 0;
  a2sf_NotTaxable     = 1;
  a2sf_Taxable        = 2;
  a2sf_LimitedTaxable = 3;
  a2sf_Pool = "  ꥪ⮬| ||  ࠭祭";

  a2ii_NotObject      = 0;
  a2ii_NotTaxable     = 1;
  a2ii_Taxable        = 2;
  a2ii_Pool = "  ꥪ⮬| |";

  mcfp_inNextPeriod   = 0;
  mcfp_ChangeMCode    = 1;
  mcfp_OnlyInFOT      = 2;
  mcfp_Nothing        = 3;
  mcfp_Pool =  "뢠  ᫥ ਮ" +
              "|  ᫥/㤥ঠ" +
              "|뢠   ᫥,      ᫥ ਮ";

  smpm_SystemSrc = 0; (*tSMPrintMode*)
  smpm_AllSrc    = 1;
  smpm_Nothing   = 2;
  smpm_Pool      = " 뢠|뢠  ";

  BonBaseAmount = 6; (* ᫮   ᫥ ६  㬬  ࠬ *)

 PUBLIC PERMANENT VAR
  oldestModificated: DATE;

 PRIVATE CONST
  dm_mf_Amount = 7;

 PUBLIC PROCEDURE inBonus(trgMCode: LIKE(MCList.MCode);
                          P       : DATE;
                          Idx     : NUMERIC[0]): SCAL[2];
  VAR
   curValue: LIKE(MCPro.Value);
 BEGIN
  IF ~!trgMCode & HasActualPro(trgMCode, P, P_inBonus) THEN
   curValue:=L_Prop.getRES(MCPro.Value, Idx);
   IF ~!curValue THEN
    RETURN L_Str.StrToScal(curValue);
   END;
  END;
  RETURN 0;
 END {inBonus};

 PUBLIC PROCEDURE E_MCListBonusName(i: SCAL[BonBaseAmount]): STRING[];
  VAR
   Local: PROC;
   Value: STRING[];
 BEGIN
  Local:=PROCREF(E_PRoll.MCListBonusName);
  SETEMPTY(Value);
  IF ~!Local THEN
   Value:=Local(i);
  END;
  RETURN Value;
 END {E_MCListBonusName};

 PUBLIC PROCEDURE P_inBonus_PutToForm(trgZone: FORM_ZONE; P: DATE);
  VAR
   i       : SCAL[BonBaseAmount];
   curName : STRING[];
   f_Nam,
   f_Val   : FORMFIELD;
 BEGIN
  FOR_EACH i DO
   f_Val  :=trgZone.Fields(L_Prop.BuildVideoFieldName("v_BonusVal",  i));
   f_Nam  :=trgZone.Fields(L_Prop.BuildVideoFieldName("v_BonusName", i));
   curName:=E_MCListBonusName(i);
   f_Nam.Visible:=~!curName;
   f_Val.Visible:=~!curName;
   f_Val.Value :=inBonus(MCList.MCode, P, i);
   IF ~!curName THEN
    f_Val.Format:="|";
    f_Nam.Value :=curName;
   END;
  END; (* FOR_EACH i ... *)
 END {P_inBonus_PutToForm};

 PUBLIC PROCEDURE P_inBonus_GetFromForm();
  VAR
   i       : SCAL[BonBaseAmount];
   curValue: STRING[];
 BEGIN
  FOR_EACH i DO
   L_WDO.getFieldValue(L_Prop.BuildVideoFieldName("v_BonusVal", i), curValue);
   L_Prop.putREV(MCPro.Value, curValue);
  END; (* FOR_EACH i ... *)
 END {P_inBonus_GetFromForm};

 PUBLIC PROCEDURE PropertyModificationAllowed(curProperty: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF    (curProperty = P_DstMode) & ~L_PRoll.UseSalDSet() THEN
   RETURN L_Prop.mac_AutoOnly;
  END;
  RETURN L_Prop.mac_Inside;
 END {PropertyModificationAllowed};

 PUBLIC PROCEDURE GetSubWindowName(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    _Property = P_Attitude2SFee THEN
   RETURN "P_3600";
  ELSIF _Property = P_inBonus THEN
   RETURN "P_3602";
  ELSIF _Property = P_Attitude2IInj THEN
   RETURN "P_3603";
  ELSIF _Property = P_DstMode THEN
   RETURN "P_3607";
  ELSE
   RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE GetPool(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    _Property = P_SMPrintMode THEN
   RETURN smpm_Pool;
  ELSIF _Property = P_ForFuture THEN
   RETURN mcfp_Pool;
  ELSIF _Property = P_PayOnDischarge THEN
   RETURN " |";
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PRIVATE PROCEDURE SetFieldState_Attitude2SFee();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Limit"   ).Modifiable:=Fields("Attitude").Value = a2sf_LimitedTaxable;
  Fields("CorMCode").Modifiable:=Fields("Attitude").Value = a2sf_LimitedTaxable;
 END {SetFieldState_Attitude2SFee};

 PRIVATE PROCEDURE dm_mfn(i: SCAL[dm_mf_Amount]; n: STRING[]): STRING[];
 BEGIN
  RETURN "mf" + i + "_" + n;
 END {dm_mfn};

 PUBLIC PROCEDURE SFS_DstMode();
  VAR
   Fields: FORM_FIELDS;
   i     : SCAL[dm_mf_Amount];
   byMF  : SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("CostItem").Modifiable:=0;
  Fields("AcCut"   ).Modifiable:=0;
  IF ~!Fields("DstMode").Value THEN
   SEARCH(DstMode, DstMode, , Fields("DstMode").Value);
   IF DstMode.MnMth = L_PRoll.dmmm_byMCList THEN
    Fields("CostItem").Modifiable:=1;
   ELSE
    Fields("CostItem").Value:="";
   END;
   IF (DstMode.MnMth = L_PRoll.dmmm_byManXCalc) | (DstMode.MnMth = L_PRoll.dmmm_ByAcCut) THEN
    Fields("AcCut").Modifiable:=1;
   ELSE
    Fields("AcCut").Value:="";
   END;
  END;
  FOR_EACH i DO
   Fields(dm_mfn(i, "MyFirm"  )).Modifiable:=Fields("CostItem").Modifiable & !Fields("CostItem").Value;
   Fields(dm_mfn(i, "CostItem")).Modifiable:=Fields("CostItem").Modifiable & !Fields("CostItem").Value;
  END;
 END {SFS_DstMode};

 PUBLIC PROCEDURE OnSuccessfulChange(curProperty: LIKE(Property.Property));
  VAR
   Fields   : FORM_FIELDS;
   FieldName: STRING[];
   CorMCode : LIKE(MCList.MCode);
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FieldName:=RTI.Get().CurZone.ActiveField.Name;
  IF    curProperty = P_Attitude2SFee THEN
   IF    FieldName = "Attitude" THEN
    SetFieldState_Attitude2SFee();
    IF Fields("Attitude").Value # a2sf_LimitedTaxable THEN
     SETEMPTY(Fields("Limit").Value, Fields("CorMCode").Value);
    END;
   END;
  ELSIF curProperty = P_DstMode THEN
   IF    FieldName = "DstMode" THEN
    SFS_DstMode();
   ELSIF FieldName = "CostItem" THEN
    SFS_DstMode();
   ELSE
    L_General.CallUs(0);
   END;
  END;
 END {OnSuccessfulChange};

 PUBLIC PROCEDURE HasPro(trgMCode: LIKE(MCList.MCode); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SELECT(MCPro, MCode, trgMCode, trgProperty) & SRCINSEL(MCPro, LE, D);
 END {HasPro};

 PUBLIC PROCEDURE HasActualPro(trgMCode   : LIKE(MCList.MCode);
                               D          : DATE;
                               trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasPro(trgMCode, D, trgProperty) & (!MCPro.DocExpD | (D < MCPro.DocExpD));
 END {HasActualPro};

 PRIVATE PROCEDURE intGetPro(trgMCode   : LIKE(MCList.MCode);
                             D          : DATE;
                             trgProperty: LIKE(Property.Property);
                             Strong     : SCAL[2]): LIKE(MCPro.Value);
  VAR
   Result: LIKE(MCPro.Value);
 BEGIN
  IF HasActualPro(trgMCode, D, trgProperty) THEN
   Result:=MCPro.Value;
  ELSE
   SETEMPTY(Result);
   IF Strong THEN
    SEARCH(MCList, MCode, , trgMCode);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("MCList").Id, MCList.RECORDID, trgProperty, D);
   END;
  END;
  RETURN Result;
 END {intGetPro};

 PUBLIC PROCEDURE GetProStrong(trgMCode   : LIKE(MCList.MCode);
                               D          : DATE;
                               trgProperty: LIKE(Property.Property)): LIKE(MCPro.Value);
 BEGIN
  RETURN intGetPro(trgMCode, D, trgProperty, 1);
 END {GetProStrong};

 PUBLIC PROCEDURE GetProSoft(trgMCode   : LIKE(MCList.MCode);
                             D          : DATE;
                             trgProperty: LIKE(Property.Property)): LIKE(MCPro.Value);
 BEGIN
  RETURN intGetPro(trgMCode, D, trgProperty, 0);
 END {GetProSoft};

 PRIVATE PROCEDURE Decode_Attitude2SFee(    curValue: STRING[];
                                        VAR Attitude: tAttitude2SFee;
                                        VAR Limit   : NUMERIC[2];
                                        VAR CorMCode: LIKE(MCList.MCode));

 BEGIN
  IF !L_Prop.getRES(curValue, 0) THEN
   SETEMPTY(Attitude);
  ELSE
   Attitude:=L_Prop.GetProValueAsScal(a2sf_Pool, L_Prop.getRES(curValue, 0));
  END;
  Limit   :=L_Prop.GetNumericValueFromStr(L_Prop.getRES(curValue, 1));
  CorMCode:=L_r2r.Decode(L_Prop.getRES(curValue, 2));
 END {Decode_Attitude2SFee};

 PRIVATE PROCEDURE formSet_Attitude2SFee();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_Attitude2SFee(MCPro.Value, Fields("Attitude").Value, Fields("Limit").Value, Fields("CorMCode").Value);
  L_WDO.CreateFormLink("MCList", "Cor");
  Fields("Attitude").Format:=a2sf_Pool;
  SetFieldState_Attitude2SFee();
 END {formSet_Attitude2SFee};

 PRIVATE PROCEDURE Check_Attitude2SFee();
  VAR
   Attitude: tAttitude2SFee;
   Limit   : NUMERIC[2];
   CorMCode: LIKE(MCList.MCode);
 BEGIN
  Decode_Attitude2SFee(MCPro.Value, Attitude, Limit, CorMCode);
  IF Attitude = a2sf_LimitedTaxable THEN
   L_General.Assert(~!Limit, " 㪠 㬬 ࠭祭");
   L_General.Assert(~!CorMCode, " 㪠  ᫥");
  ELSE
   L_General.Assert(!Limit, "㬬 ࠭祭  㪠뢠");
   L_General.Assert(!CorMCode, " ᫥  㪠뢠");
  END;
 END {Check_Attitude2SFee};

 PRIVATE PROCEDURE Encode_Attitude2SFee(VAR curValue: STRING[];
                                            Attitude: tAttitude2SFee;
                                            Limit   : NUMERIC[2];
                                            CorMCode: LIKE(MCList.MCode));
 BEGIN
  SETEMPTY(curValue);
  L_Prop.putRES(curValue, L_Str.PoolItem(a2sf_Pool, Attitude));
  IF Attitude = a2sf_LimitedTaxable THEN
   L_Prop.putREV(curValue, Limit);
   L_Prop.putRES(curValue, L_r2r.Put("MCPro", "MCList", CorMCode));
  END;
 END {Encode_Attitude2SFee};

 PRIVATE PROCEDURE GetSpdSrchV_Attitude2SFee(curValue: STRING[]): LIKE(MCPro.SpdSrchV);
  VAR
   Attitude: tAttitude2SFee;
   Limit   : NUMERIC[2];
   CorMCode: LIKE(MCList.MCode);
 BEGIN
  Decode_Attitude2SFee(curValue, Attitude, Limit, CorMCode);
  RETURN L_Str.PoolItem(a2sf_Pool, Attitude);
 END {GetSpdSrchV_Attitude2SFee};

 PRIVATE PROCEDURE formGet_Attitude2SFee();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_Attitude2SFee(MCPro.Value, Fields("Attitude").Value, Fields("Limit").Value, Fields("CorMCode").Value);
  MCPro.SpdSrchV:=GetSpdSrchV_Attitude2SFee(MCPro.Value);
 END {formGet_Attitude2SFee};

 PRIVATE PROCEDURE ibfb_Decode();
 BEGIN
  CONFORM(MCPro, MCList);
  P_inBonus_PutToForm(L_WDO.getActiveZone(), MCPro.Date);
 END {ibfb_Decode};

 PRIVATE PROCEDURE ibfb_Encode();
 BEGIN
  P_inBonus_GetFromForm();
 END {ibfb_Encode};

 PRIVATE PROCEDURE Decode_DstMode(curValue: STRING[];
                                  VAR DstMode   : LIKE(DstMode.DstMode);
                                  VAR CostItem  : LIKE(CostItem.CostItem);
                                  VAR AcCut     : LIKE(AcCut.AcCut);
                                  VAR mfMyFirm  : LIKE(MyFirm.MyFirm)[];
                                  VAR mfCostItem: LIKE(CostItem.CostItem)[]);
  VAR
   i: SCAL[dm_mf_Amount];
 BEGIN
  DstMode :=L_r2r.Decode(L_Prop.getRES(curValue, 0));
  CostItem:=L_r2r.Decode(L_Prop.getRES(curValue, 1));
  AcCut   :=L_r2r.Decode(L_Prop.getRES(curValue, 2));
  FOR_EACH i DO
   mfMyFirm[i]  :=L_r2r.Decode(L_Prop.getRES(curValue, 3 + 2*i));
   mfCostItem[i]:=L_r2r.Decode(L_Prop.getRES(curValue, 4 + 2*i));
  END;
 END {Decode_DstMode};

 PUBLIC PROCEDURE StandOnDstMode(trgMCode: LIKE(MCList.MCode); P: DATE);
 BEGIN
  IF L_PRoll.UseSalDSet() THEN
   SEARCH(DstMode, DstMode, , L_r2r.Decode(L_Prop.getRES(GetProStrong(trgMCode, P, P_DstMode), 0)));
  ELSE
   SAVE(MCList);
   SEARCH(MCList, MCode, , trgMCode);
   CONFORM(MCList, DstMode);
   RESTORE(MCList);
  END;
 END {StandOnDstMode};

 PRIVATE PROCEDURE formGet_DstMode();
  VAR
   i: SCAL[7];
 BEGIN
  MCPro.Value:="";
  L_Prop.putRES(MCPro.Value, L_r2r.Put("MCPro", "DstMode" , RTI.Get().CurZone.Fields("DstMode" ).Value));
  L_Prop.putRES(MCPro.Value, L_r2r.Put("MCPro", "CostItem", RTI.Get().CurZone.Fields("CostItem").Value));
  L_Prop.putRES(MCPro.Value, L_r2r.Put("MCPro", "AcCut"   , RTI.Get().CurZone.Fields("AcCut"   ).Value));

  FOR_EACH i DO
   L_Prop.putRES(MCPro.Value, L_r2r.Put("MCPro", "MyFirm",   RTI.Get().CurZone.Fields(dm_mfn(i, "MyFirm"  )).Value));
   L_Prop.putRES(MCPro.Value, L_r2r.Put("MCPro", "CostItem", RTI.Get().CurZone.Fields(dm_mfn(i, "CostItem")).Value));
  END;
 END {formGet_DstMode};

 PUBLIC PROCEDURE SetDataInForm(_Property: LIKE(Property.Property));
  VAR
   i         : SCAL[dm_mf_Amount];
   mfMyFirm  : LIKE(MyFirm.MyFirm)[dm_mf_Amount];
   mfCostItem: LIKE(CostItem.CostItem)[dm_mf_Amount];
 BEGIN
  IF    _Property = P_Attitude2SFee  THEN
   formSet_Attitude2SFee();
  ELSIF _Property = P_inBonus THEN
   ibfb_Decode();
  ELSIF _Property = P_Attitude2IInj THEN
   formSet_Attitude2IInj();
  ELSIF _Property = P_DstMode THEN
   Decode_DstMode(MCPro.Value, RTI.Get().CurZone.Fields("DstMode").Value,
                               RTI.Get().CurZone.Fields("CostItem").Value,
                               RTI.Get().CurZone.Fields("AcCut").Value,
                               mfMyFirm, mfCostItem);
   FOR_EACH i DO
    RTI.Get().CurZone.Fields(dm_mfn(i, "MyFirm"  )).Value:=mfMyFirm[i];
    RTI.Get().CurZone.Fields(dm_mfn(i, "CostItem")).Value:=mfCostItem[i];
   END;
   SFS_DstMode();
  END;
 END {SetDataInForm};

 PUBLIC PROCEDURE GetDataFromForm(_Property: LIKE(Property.Property));
 BEGIN
  SETEMPTY(MCPro.Value);
  IF    _Property = P_Attitude2SFee THEN
   formGet_Attitude2SFee();
  ELSIF _Property = P_inBonus THEN
   ibfb_Encode();
  ELSIF _Property = P_Attitude2IInj THEN
   formGet_Attitude2IInj();
  ELSIF _Property = P_DstMode THEN
   formGet_DstMode();
  END;
  REPLACE(MCPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE Check(trgProperty: LIKE(Property.Property));
  VAR
   i     : SCAL[dm_mf_Amount];
   Fields: FORM_FIELDS;
 BEGIN
  IF    trgProperty = P_Attitude2SFee THEN
   Check_Attitude2SFee();
  ELSIF trgProperty = P_DstMode THEN
   Fields:=RTI.Get().CurZone.Fields;
   FOR_EACH i DO
    IF !Fields(dm_mfn(i, "MyFirm")).Value # !Fields(dm_mfn(i, "CostItem")).Value THEN
     L_StdFrm.WrongDB(" ''  ''  ६");
    END;
    IF ~!Fields(dm_mfn(i, "MyFirm")).Value THEN
     SEARCH(CostItem, CostItem, , Fields(dm_mfn(i, "CostItem")).Value);
     IF Fields(dm_mfn(i, "MyFirm")).Value # CostItem.MyFirm THEN
      L_StdFrm.WrongDB("   " + Fields(dm_mfn(i, "CostItem")).Value + "  ᮮ⢥ 㪠  ᢮⢥");
     END;
    END;
    Fields(dm_mfn(i, "MyFirm"  )).Modifiable:=Fields("CostItem").Modifiable & !Fields("CostItem").Value;
    Fields(dm_mfn(i, "CostItem")).Modifiable:=Fields("CostItem").Modifiable & !Fields("CostItem").Value;
   END;
  END;
 END {Check};

 PUBLIC PROCEDURE a2sf_Attitude(trgMCode: LIKE(MCList.MCode); D: DATE): tAttitude2SFee;
  VAR
   Attitude: tAttitude2SFee;
   Limit   : NUMERIC[2];
   CorMCode: LIKE(MCList.MCode);
 BEGIN
  Decode_Attitude2SFee(GetProStrong(trgMCode, D, P_Attitude2SFee), Attitude, Limit, CorMCode);
  RETURN Attitude;
 END {a2sf_Attitude};

 PUBLIC PROCEDURE a2sf_Limit(trgMCode: LIKE(MCList.MCode); D: DATE): NUMERIC[2];
  VAR
   Attitude: tAttitude2SFee;
   Limit   : NUMERIC[2];
   CorMCode: LIKE(MCList.MCode);
 BEGIN
  Decode_Attitude2SFee(GetProStrong(trgMCode, D, P_Attitude2SFee), Attitude, Limit, CorMCode);
  RETURN Limit;
 END {a2sf_Limit};

 PUBLIC PROCEDURE a2sf_CorMCode(trgMCode: LIKE(MCList.MCode); D: DATE): LIKE(MCList.MCode);
  VAR
   Attitude: tAttitude2SFee;
   Limit   : NUMERIC[2];
   CorMCode: LIKE(MCList.MCode);
 BEGIN
  Decode_Attitude2SFee(GetProStrong(trgMCode, D, P_Attitude2SFee), Attitude, Limit, CorMCode);
  RETURN CorMCode;
 END {a2sf_CorMCode};

 PRIVATE PROCEDURE OnModification();
 BEGIN
  IF    MCPro.Property = P_Attitude2SFee THEN
   MCPro.SpdSrchV:=GetSpdSrchV_Attitude2SFee(MCPro.Value);
   REPLACE(MCPro);
  ELSIF (MCPro.Property = P_ForFuture) | (MCPro.Property = P_PayOnDischarge) THEN
   MCPro.SpdSrchV:=MCPro.Value;
   REPLACE(MCPro);
  END;
  oldestModificated:=Math.Min(oldestModificated, MCPro.Date);
 END {OnModification};

 PUBLIC PROCEDURE OnAfterInsert();
 BEGIN
  OnModification();
 END {OnAfterInsert};

 PUBLIC PROCEDURE OnAfterEdit();
 BEGIN
  OnModification();
 END {OnAfterEdit};

 PUBLIC PROCEDURE InsertProperty(Silent    : SCAL[2];
                                 _MCode    : LIKE(MCList.MCode);
                                 _Date     : DATE;
                                 _Property : LIKE(Property.Property);
                                 _Value    : STRING[];
                                 _DocNum,
                                 _DocGiveS : STRING[];
                                 _DocGiveD,
                                 _DocExpD  : DATE);
 BEGIN
  IF SELECT(MCPro, MCode, _MCode, _Property, _Date) THEN
   L_General.Assert(Silent,
                    "⠢ ᢮⢠ " + _Property + ": 㦥  ᢮⢮  " + L_DatTim.DateStr(_Date));
   REMOVE(MCPro);
  END;
  DEFAULT(MCPro);
  MCPro.MCode   :=_MCode;
  MCPro.Property:=_Property;
  MCPro.Date    :=_Date;
  MCPro.Value   :=_Value;
  MCPro.DocNum  :=_DocNum;
  MCPro.DocGiveD:=_DocGiveD;
  MCPro.DocGiveS:=_DocGiveS;
  MCPro.DocExpD :=_DocExpD;
  INSERT(MCPro);
  L_Prop.SupportEndDate("MCPro", _Property, 1);
 END {InsertProperty};

 PRIVATE PROCEDURE Decode_Attitude2IInj(    curValue: STRING[];
                                        VAR Attitude: tAttitude2IInj);
 BEGIN
  IF !curValue THEN
   SETEMPTY(Attitude);
  ELSE
   Attitude:=L_Prop.GetProValueAsScal(a2ii_Pool, L_Prop.getRES(curValue, 0));
  END;
 END {Decode_Attitude2IInj};

 PRIVATE PROCEDURE formSet_Attitude2IInj();
  VAR
   Attitude: tAttitude2IInj;
 BEGIN
  Decode_Attitude2IInj(MCPro.Value, Attitude);
  L_WDO.SetFieldFormat("AttitudeII", a2ii_Pool);
  L_WDO.setFieldValue("AttitudeII", Attitude);
 END {formSet_Attitude2IInj};

 PRIVATE PROCEDURE formGet_Attitude2IInj();
  VAR
   Attitude: tAttitude2IInj;
 BEGIN
  L_WDO.getFieldValue("AttitudeII", Attitude);
  L_Prop.putRES(MCPro.Value, L_Str.PoolItem(a2ii_Pool, Attitude));
  MCPro.SpdSrchV:=MCPro.Value;
 END {formGet_Attitude2IInj};

 PUBLIC PROCEDURE a2ii_Attitude(_MCode: LIKE(MCList.MCode); D: DATE): tAttitude2IInj;
  VAR
   Attitude: tAttitude2IInj;
 BEGIN
  Decode_Attitude2IInj(GetProStrong(_MCode, D, P_Attitude2IInj), Attitude);
  RETURN Attitude;
 END {a2ii_Attitude};

 PUBLIC PROCEDURE GetForFuture(trgMCode: LIKE(MCList.MCode); D: DATE): tForFuture;
  VAR
   curValue: STRING[];
 BEGIN
  curValue:=GetProSoft(trgMCode, D, P_ForFuture);
  IF ~!curValue THEN
   RETURN L_Prop.GetProValueAsScal(mcfp_Pool, curValue);
  ELSE
   RETURN mcfp_Nothing;
  END;
 END {GetForFuture};

 PUBLIC PROCEDURE GetPayOnDischarge(trgMCode: LIKE(MCList.MCode); D: DATE): SCAL[2];
 BEGIN
  RETURN !GetProSoft(trgMCode, D, P_PayOnDischarge);
 END {GetPayOnDischarge};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Result     : STRING[];
   curDstMode : LIKE(DstMode.DstMode);
   curCostItem: LIKE(CostItem.CostItem);
   curAcCut   : LIKE(AcCut.AcCut);
   Attitude   : tAttitude2SFee;
   Limit      : NUMERIC[2];
   CorMCode   : LIKE(MCList.MCode);
   dmyMyFirm  : LIKE(MyFirm.MyFirm)[dm_mf_Amount];
   dmyCostItem: LIKE(CostItem.CostItem)[dm_mf_Amount];
 BEGIN
  IF MCPro.Property = P_DstMode THEN
   Decode_DstMode(MCPro.Value, curDstMode, curCostItem, curAcCut, dmyMyFirm, dmyCostItem);
   Result:=curDstMode;
   IF   ~!curCostItem THEN
    SEARCH(CostItem, CostItem, , curCostItem);
    INC(Result, ", " + curCostItem + " " + CostItem.Name);
   ELSIF ~!curAcCut THEN
    SEARCH(AcCut, AcCut, , curAcCut);
    INC(Result, ", " + curAcCut + " " + AcCut.Name);
   ELSE
    SEARCH(DstMode, DstMode, , curDstMode);
    INC(Result, " " + DstMode.Name);
   END;
  ELSIF MCPro.Property = P_Attitude2SFee THEN
   Decode_Attitude2SFee(MCPro.Value, Attitude, Limit, CorMCode);
   SETEMPTY(Result);
   L_Prop.putRES(Result, L_Str.PoolItem(a2sf_Pool, Attitude));
   IF Attitude = a2sf_LimitedTaxable THEN
    L_Prop.putREV(Result, Limit);
    L_Prop.putRES(Result, CorMCode);
   END;
  ELSE
   Result:=MCPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PUBLIC PROCEDURE Get_DstMode(trgMCode: LIKE(MCList.MCode);
                              P       : DATE;
                              VAR trgDstMode : LIKE(DstMode.DstMode);
                              VAR trgCostItem: LIKE(CostItem.CostItem);
                              VAR trgAcCut   : LIKE(AcCut.AcCut));
  VAR
   i         : SCAL[dm_mf_Amount];
   mfMyFirm  : LIKE(MyFirm.MyFirm)[dm_mf_Amount];
   mfCostItem: LIKE(CostItem.CostItem)[dm_mf_Amount];
 BEGIN
  Decode_DstMode(GetProStrong(trgMCode, P, P_DstMode), trgDstMode, trgCostItem, trgAcCut, mfMyFirm, mfCostItem);
  SEARCH(DstMode, DstMode, , trgDstMode);
  IF DstMode.MnMth = L_PRoll.dmmm_byMCList THEN
   IF !trgCostItem THEN
    FOR_EACH i DO
     IF mfMyFirm[i] = Staff.MyFirm THEN
      trgCostItem:=mfCostItem[i];
      RETURN ;
     END;
    END;
    L_StdFrm.WrongDB(" ᢮⢥ " + L_Str.FixedIntStr(P_DstMode, 4) + "  / " + trgMCode + "  㪠    " + Staff.MyFirm);
   END;
  END;
 END {Get_DstMode};

 PUBLIC PROCEDURE Get_SMPrintMode(trgMCode: LIKE(MCList.MCode); D: DATE): tSMPrintMode;
  VAR
   curValue: LIKE(MCPro.Value);
 BEGIN
  curValue:=GetProSoft(trgMCode, D, P_SMPrintMode);
  IF ~!curValue THEN
   RETURN L_Prop.GetProValueAsScal(smpm_Pool, curValue);
  ELSE
   RETURN smpm_Nothing;
  END;
 END {Get_SMPrintMode};

 PUBLIC PROCEDURE P_3607_OnInitializeWindow();
  VAR
   i: SCAL[dm_mf_Amount];
 BEGIN
  L_WDO.iWindow().MNUFileName:="ObjPro";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnOpenZone, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["DstMode", "CostItem"]);
  L_WDO.iUnmodifiable(0, ["ObjectDescr", "ObjectTitle", "AcCut_Name", "CostItem_Name", "DstMode_Name"]);
  L_WDO.iProgs       (0, "ObjPro");
  L_WDO.CreateFormLink("DstMode", "");
  L_WDO.CreateFormLink("CostItem", "");
  L_WDO.CreateFormLink("AcCut", "");
  IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   L_WDO.iMayBeEmpty(0, "CostItem");
   FOR_EACH i DO
    L_WDO.CreateFormLink("MyFirm",   "mf"+i+"_");
    L_WDO.CreateFormLink("CostItem", "mf"+i+"_");
    L_WDO.iUnmodifiable(0, "mf"+i+"_CostItem_Name");
    L_WDO.iMayBeEmpty(0, dm_mfn(i, "MyFirm"));
    L_WDO.iMayBeEmpty(0, dm_mfn(i, "CostItem"));
  END;
  ELSE
   L_WDO.iWindow().Depth:=14;
  END;
 END {P_3607_OnInitializeWindow};

END.