(*
%Copyright   (c) Polak Computer System
%Author      01.02.2001 19:31:12 BOR
%Purpose     ⥪  ࠡ  ᢮⢠ MDoc
%Type        library
%Specific    SYS
%Modified    07.08.2014 17:39:09 POLAK\GAV
%Environment
*)

 MODULE P_MDoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tDealCheckType = SCAL[2];

 PUBLIC CONST
  P_KeyAssBaseOrder     = 6000;
  P_KeyAssAddress       = 6001;
  P_KeyAssMovReason     = 6003;
  P_KeyAssWhatNotProper = 6004;
  P_KeyAssWhatNeed      = 6005;
  P_KeyAssTestResult    = 6006;
  P_Findings            = 6007;
  P_ListOfDocs          = 6008;
  P_Order               = 6009;
  P_Reason              = 6010;
  P_Condition           = 6011;
  P_AboutGIBDD          = 6012;
  P_Results             = 6013;
  P_Commission          = 6014;
  P_Approval            = 6015;
  P_BilCURate           = 6016;
  P_Through             = 6017;
  P_AdditionalInf       = 6018;
  P_DoneJob             = 6019;
  P_DealCheckType       = 6020;
  P_PartnerAgent        = 6021;
  P_Note                = 6022;
  P_ServiceNote         = 6023;
  P_DoSpecVATMDoc       = 6024;
  P_PcBkData            = 6025;
  P_AddMDLNames         = 6026;

  dct_Obvious = 0;
  dct_DoNot   = 1;

  dsvmd_Auto = 0;
  dsvmd_No   = 1;
  dsvmd_Pool = "⮬᪨| ନ஢";

  sn_AutoBuildIdent = "殮   ";

  sv_Pool = "|㦥 ⬥⪨";

  CommissMembersAmnt = 15;

 IMPORT L_General, L_DatTim, L_MDoc, L_Prop, L_Staff, Str, L_Str, P_OwnData, P_Cntr, L_StdFrm, P_Firm,
        L_Pmnt, L_Pool, E_Prop, L_r2r, L_WDO, L_APtm;

 PRIVATE CONST
  pool_KeyAssAddress = 0000951;
  pool_Findings      = 0000955;
  pool_ListOfDocs    = 0000956;
  pool_Reason        = 0000957;
  pool_Condition     = 0000958;

 PUBLIC PROCEDURE PropertyModificationAllowed(_Property: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF    (_Property = P_DealCheckType) |
        (_Property = P_DoSpecVATMDoc) |
        (_Property = P_PcBkData     ) THEN
   RETURN L_Prop.mac_Full;
  ELSIF (_Property = P_Order        ) |
        (_Property = P_AdditionalInf) |
        (_Property = P_DoneJob      ) |
        (_Property = P_Note         ) |
        (_Property = P_AddMDLNames  ) THEN
   RETURN L_Prop.mac_AutoOnly;
  ELSE
   RETURN L_Prop.mac_Inside;
  END;
 END {PropertyModificationAllowed};

 PUBLIC PROCEDURE GetSubWindowName(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    _Property = P_KeyAssBaseOrder THEN RETURN "P_6000";
  ELSIF _Property = P_Commission      THEN RETURN "P_6014";
  ELSIF _Property = P_Approval        THEN RETURN "P_6015";
  ELSIF _Property = P_BilCURate       THEN RETURN "P_6016";
  ELSIF _Property = P_PartnerAgent    THEN RETURN "P_6021";
  ELSIF _Property = P_PcBkData        THEN RETURN "P_6025";
  ELSE                                     RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE CanHaveProp(trgProperty: LIKE(Property.Property));
 BEGIN
  CONFORM(MDocPro, MDoc);
  IF    trgProperty = P_PcBkData THEN
   IF MDoc.MDocKind # L_MDoc.md_DPk THEN
    L_General.Error("   㯮   ⮫쪮  ");
   END;
  END;
 END {CanHaveProp};

 PUBLIC PROCEDURE GetKeyAssAddressPool(): STRING[];
 BEGIN
  RETURN L_Pool.Get(pool_KeyAssAddress);
 END {GetKeyAssAddressPool};

 PUBLIC PROCEDURE GetMDocProPool(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    _Property = P_DealCheckType THEN
   RETURN " ᮡ⥩|᪫  ஫ ᤥ";
  ELSIF _Property = P_KeyAssAddress THEN
   RETURN  GetKeyAssAddressPool();
  ELSIF _Property = P_Findings THEN
   RETURN L_Pool.Get(pool_Findings);
  ELSIF _Property = P_ListOfDocs THEN
   RETURN L_Pool.Get(pool_ListOfDocs);
  ELSIF _Property = P_Reason THEN
   RETURN L_Pool.Get(pool_Reason);
  ELSIF _Property = P_Condition THEN
   RETURN L_Pool.Get(pool_Condition);
  ELSIF _Property = P_DoSpecVATMDoc THEN
   RETURN dsvmd_Pool;
  ELSIF L_Prop.IsLocalProperty(_Property) THEN
   RETURN L_Prop.E_GetPool(_Property);
  ELSE
   RETURN "";
  END;
 END {GetMDocProPool};

 PUBLIC PROCEDURE CheckTSN(D: DATE; Value: STRING[]);
 BEGIN
  L_Prop.CheckScalValue(Value, "", MAXOF(Staff.TSN));
  L_Staff.CheckStringAsTSN(D, Value, EMPTYOF(PROC));
 END {CheckTSN};

 PRIVATE PROCEDURE Check_Commission();
  VAR
   Idx              : SCAL[CommissMembersAmnt];
   Chairman         : LIKE(Staff.TSN);
   Members          : LIKE(Staff.TSN)[CommissMembersAmnt];
   OrderOfCommission: STRING[];
 BEGIN
  Decode_Commission(MDocPro.Value, Chairman, Members, OrderOfCommission);
  CONFORM(MDocPro, MDoc);
  CheckTSN(MDoc.Date, Chairman);
  FOR_EACH Idx DO
   IF ~!Members[Idx] THEN
    CheckTSN(MDoc.Date, Members[Idx]);
   END;
  END;
 END {Check_Commission};

 PUBLIC PROCEDURE MDocPro_Check(_Property: LIKE(Property.Property));
  VAR
   trgTSN     : LIKE(Staff.TSN);
   trgName,
   trgPostName: STRING[];
 BEGIN
  IF    _Property = P_Commission THEN
   Check_Commission();
  ELSIF _Property = P_Approval THEN
   Decode_Approval(MDocPro.Value, trgTSN, trgName, trgPostName);
   IF ~!trgTSN THEN
    CONFORM(MDocPro, MDoc);
    CheckTSN(MDoc.Date, trgTSN);
   END;
  END;
 END {MDocPro_Check};

 PUBLIC PROCEDURE HasMDocPro(_MDocKind: LIKE(MDoc.MDocKind); _MDoc: LIKE(MDoc.MDoc); _Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SELECT(MDocPro, MDoc, _MDocKind, _MDoc, _Property) & ~!MDocPro.Value;
 END {HasMDocPro};

 PUBLIC PROCEDURE HasActualMDocPro(_MDocKind: LIKE(MDoc.MDocKind); _MDoc: LIKE(MDoc.MDoc); _Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasMDocPro(_MDocKind, _MDoc, _Property);
 END {HasActualMDocPro};

 PRIVATE PROCEDURE intGetPro(trgMDocKind: LIKE(MDoc.MDocKind);
                             trgMDoc    : LIKE(MDoc.MDoc);
                             trgProperty: LIKE(Property.Property);
                             Strong     : SCAL[2]): LIKE(MDocPro.Value);
  VAR
   Result: LIKE(MDocPro.Value);
 BEGIN
  IF HasActualMDocPro(trgMDocKind, trgMDoc, trgProperty) THEN
   Result:=MDocPro.Value;
  ELSE
   SETEMPTY(Result);
   IF Strong THEN
    SEARCH(MDoc, MDoc, , trgMDocKind, trgMDoc);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("MDoc").Id, MDoc.RECORDID, trgProperty, EMPTYOF(DATE));
   END;
  END;
  RETURN Result;
 END {intGetPro};

 PUBLIC PROCEDURE GetMDocProStrong(trgMDocKind: LIKE(MDoc.MDocKind); trgMDoc: LIKE(MDoc.MDoc); trgProperty: LIKE(Property.Property)): LIKE(MDocPro.Value);
 BEGIN
  RETURN intGetPro(trgMDocKind, trgMDoc, trgProperty, 1);
 END {GetMDocProStrong};

 PUBLIC PROCEDURE GetMDocProSoft(trgMDocKind: LIKE(MDoc.MDocKind); trgMDoc: LIKE(MDoc.MDoc); trgProperty: LIKE(Property.Property)): LIKE(MDocPro.Value);
 BEGIN
  RETURN intGetPro(trgMDocKind, trgMDoc, trgProperty, 0);
 END {GetMDocProSoft};

 PUBLIC PROCEDURE GetMDocProArray(_MDocKind : LIKE(MDoc.MDocKind);
                                  _MDoc     : LIKE(MDoc.MDoc);
                                  _Property : LIKE(Property.Property);
                                  VAR _Value: STRING[][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  SETEMPTY(_Value);
  SELECT(MDocPro, MDoc,, _MDocKind, _MDoc, _Property);
  i:=0;
  WHILE OCCURE(MDocPro) & (i <= HIGH(_Value)) DO
   _Value[i]:=MDocPro.Value;
   INC(i);
   NEXT(MDocPro);
  END;
 END {GetMDocProArray};

 PRIVATE PROCEDURE CheckAcceptableValueLength(trgValue: STRING[]);
  VAR
   Dummy: LIKE(MDocPro.Value);
 BEGIN
  SETEMPTY(Dummy);
  L_Prop.CheckAcceptableStringLength(Dummy, trgValue);
 END {CheckAcceptableValueLength};

 PUBLIC PROCEDURE InsMDocPro(trgMDocKind: LIKE(MDoc.MDocKind);
                             trgMDoc    : LIKE(MDoc.MDoc);
                             trgProperty: LIKE(MDocPro.Property);
                             trgRow     : LIKE(MDocPro.PropRow);
                             trgValue   : STRING[]);
 BEGIN
  CheckAcceptableValueLength(trgValue);
  DEFAULT(MDocPro);
  MDocPro.MDocKind:=trgMDocKind;
  MDocPro.MDoc    :=trgMDoc;
  MDocPro.PropRow :=trgRow;
  MDocPro.Property:=trgProperty;
  MDocPro.Value   :=trgValue;
  INSERT(MDocPro);
  CALL(ObjPro.UpdateVal2Show("MDocPro"));
 END {InsMDocPro};

 PUBLIC PROCEDURE RemoveMDocPro(_MDocKind : LIKE(MDoc.MDocKind);
                                _MDoc     : LIKE(MDoc.MDoc);
                                _Property : LIKE(Property.Property));
 BEGIN
  IF SELECT(MDocPro, MDoc, _MDocKind, _MDoc, _Property) THEN
   REMSEL(MDocPro);
  END;
 END {RemoveMDocPro};

 PUBLIC PROCEDURE IsMultilineProperty(_Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN (_Property = P_KeyAssAddress) |
         (_Property = P_Findings     ) |
         (_Property = P_ListOfDocs   ) |
         (_Property = P_Order        ) |
         (_Property = P_DoneJob      ) |
         (_Property = P_AddMDLNames  ) ;
 END {IsMultilineProperty};

 PUBLIC PROCEDURE IsMDocListProperty(trgProperty: LIKE(Property.Property)): SCAL[2];
  VAR
   Result: SCAL[2];
   Local : PROC;
 BEGIN
  Result:=0;
  IF (trgProperty = P_AddMDLNames) THEN
   Result:=1;
  ELSE
   Local:=PROCREF(E_Prop.IsMDocListProperty);
   IF ~!Local THEN
    Result:=Local(trgProperty);
   END;
  END;
  RETURN Result;
 END {IsMDocListProperty};

 PRIVATE PROCEDURE GetPostName_Approval(trgTSN: LIKE(Staff.TSN)): STRING[];
 BEGIN
  IF ~!trgTSN THEN
   CONFORM(MDocPro, MDoc);
   RETURN P_Firm.GetManAttrByTSN(trgTSN, MDoc.Date, P_Firm.mpt_ManPostName);
  ELSE
   RETURN "";
  END;
 END {GetPostName_Approval};

 PRIVATE PROCEDURE SetFieldState_Approval();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("aprvlPostName").Modifiable:=!Fields("aprvlTSN").Value;
  Fields("aprvlName"    ).Modifiable:=!Fields("aprvlTSN").Value;
 END {SetFieldState_Approval};

 PRIVATE PROCEDURE ChangeMDocPropRow(trgMDocKind   : LIKE(MDocPro.MDocKind);
                                     trgMDoc       : LIKE(MDocPro.MDoc);
                                     trgProperty   : LIKE(MDocPro.Property);
                                     oldMDProNbr,
                                     newMDProNbr   : LIKE(MDocPro.PropRow));
 BEGIN
  IF SEARCH(MDocPro, MDoc, trgMDocKind, trgMDoc, trgProperty, oldMDProNbr) THEN
   MDocPro.PropRow:=newMDProNbr;
   REPLACE(MDocPro);
  END;
 END {ChangeMDocPropRow};

 PUBLIC PROCEDURE MoveMDocListPro(trgMDocKind: LIKE(MDocPro.MDocKind);
                                  trgMDoc    : LIKE(MDocPro.MDoc);
                                  oldMDLNbr,
                                  newMDLNbr: LIKE(MDocList.MDLNbr));
  CONST
   maxMDPNbr = MAXOF(MDocPro.PropRow);
 BEGIN
  SELECT(Property, PropObj, , L_Prop.MDocProObj);
  WHILE OCCURE(Property) DO
   IF IsMDocListProperty(Property.Property) THEN
    ChangeMDocPropRow(trgMDocKind, trgMDoc, Property.Property, oldMDLNbr, maxMDPNbr);
    ChangeMDocPropRow(trgMDocKind, trgMDoc, Property.Property, newMDLNbr, oldMDLNbr);
    ChangeMDocPropRow(trgMDocKind, trgMDoc, Property.Property, maxMDPNbr, newMDLNbr);
   END;
   NEXT(Property);
  END; (* WHILE OCCURE(Property) ... *)
 END {MoveMDocListPro};

 PUBLIC PROCEDURE OnSuccessfulChange(_Property: LIKE(Property.Property));
  VAR
   trgTSN: LIKE(Staff.TSN);
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF    _Property = P_Approval THEN
   trgTSN:=Fields("aprvlTSN").Value;
   IF ~!trgTSN THEN
    L_General.Assert(SEARCH(Staff, TSN, trgTSN), " " + trgTSN + "  ");
    Fields("aprvlName").Value:=Staff.Name;
   ELSE
    SETEMPTY(Fields("aprvlName").Value);
   END;
   Fields("aprvlPostName").Value:=GetPostName_Approval(trgTSN);
   SetFieldState_Approval();
  ELSIF _Property = P_BilCURate THEN
   Fields("BilCURate").Value:=CountCURate(Fields("USDRate").Value, Fields("RatedInc").Value);
  ELSIF _Property = P_PcBkData THEN
   CONFORM(MDocPro, MDoc);
   IF RTI.Get().CurZone.ActiveField.Name = "INN" THEN
    IF SELECT(Firm, INN, RTI.Get().CurZone.ActiveField.Value) & ~NEXT(Firm) THEN
     FIRST(Firm);
     Fields("Firm"    ).Value:=Firm.Firm;
     Fields("FirmName").Value:=P_Firm.FP_ContractorBriefName(Firm.Firm, MDoc.Date);
    ELSE
     P_Firm.Check_INN(Fields("INN").Value);
     SETEMPTY(Fields("Firm"    ).Value,
              Fields("FirmName").Value);
    END;
   ELSIF RTI.Get().CurZone.ActiveField.Name = "Firm" THEN
    IF ~!RTI.Get().CurZone.ActiveField.Value THEN
     SEARCH(Firm, Firm, , RTI.Get().CurZone.ActiveField.Value);
     Fields("INN"     ).Value:=P_Firm.FP_INN(Firm.Firm, MDoc.Date);
     Fields("FirmName").Value:=P_Firm.FP_ContractorBriefName(Firm.Firm, MDoc.Date);
    ELSE
     SETEMPTY(Fields("INN"     ).Value,
              Fields("FirmName").Value);
    END;
   END;
   SetupFields_PcBkData(Fields);
  END;
 END {OnSuccessfulChange};

 PUBLIC PROCEDURE Decode_KeyAssBaseOrder(    curValue : STRING[];
                                         VAR BO_Name,
                                             BO_DocNum: STRING[];
                                         VAR BO_Date  : DATE);
 BEGIN
  BO_Name  :=L_Prop.getRES(curValue, 0);
  BO_DocNum:=L_Prop.getRES(curValue, 1);
  BO_Date  :=L_Prop.GetDateFromStr(L_Prop.getRES(curValue, 2), 0);
 END {Decode_KeyAssBaseOrder};

 PRIVATE PROCEDURE formSet_KeyAssBaseOrder();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_KeyAssBaseOrder(MDocPro.Value, Fields("BO_Name").Value, Fields("BO_DocNum").Value, Fields("BO_Date").Value);
 END {formSet_KeyAssBaseOrder};

 PUBLIC PROCEDURE Decode_PartnerAgent(    curValue: STRING[];
                                      VAR Name,
                                          PostName,
                                          DocKind,
                                          DocSer,
                                          DocNbr,
                                          DocGiveS: STRING[];
                                      VAR DocGiveD,
                                          DocExpD : DATE);
 BEGIN
  Name    :=L_Prop.getRES(curValue, 0);
  PostName:=L_Prop.getRES(curValue, 1);
  DocKind :=L_Prop.getRES(curValue, 2);
  DocSer  :=L_Prop.getRES(curValue, 3);
  DocNbr  :=L_Prop.getRES(curValue, 4);
  DocGiveD:=L_Prop.GetDateFromStr(L_Prop.getRES(curValue, 5), 0);
  DocExpD :=L_Prop.GetDateFromStr(L_Prop.getRES(curValue, 6), 0);
  DocGiveS:=L_Prop.getRES(curValue, 7);
 END {Decode_PartnerAgent};

 PRIVATE PROCEDURE formSet_PartnerAgent();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_PartnerAgent(MDocPro.Value,
                      Fields("paName").Value,
                      Fields("paPostName").Value,
                      Fields("paDocKind").Value,
                      Fields("paDocSer").Value,
                      Fields("paDocNbr").Value,
                      Fields("paDocGiveS").Value,
                      Fields("paDocGiveD").Value,
                      Fields("paDocExpD").Value);
 END {formSet_PartnerAgent};

 PUBLIC PROCEDURE Decode_Approval(    curValue   : STRING[];
                                  VAR trgTSN     : LIKE(Staff.TSN);
                                  VAR trgName,
                                      trgPostName: STRING[]);
  VAR
   tmpVal: STRING[];
 BEGIN
  SETEMPTY(trgTSN, trgName, trgPostName);
  tmpVal:=L_Prop.getRES(curValue, 0);
  IF ~!tmpVal THEN
   IF L_r2r.IsStampStr(tmpVal) THEN
    SEARCH(Staff, TSN, , L_r2r.Decode(tmpVal));
    CONFORM(Staff, Man);
    trgTSN     :=Staff.TSN;
    trgName    :=Man.Name;
    trgPostName:=GetPostName_Approval(trgTSN);
   ELSE
    SETEMPTY(trgTSN);
    trgName    :=tmpVal;
    trgPostName:=L_Prop.getRES(curValue, 1);
   END;
  END;
 END {Decode_Approval};

 PRIVATE PROCEDURE formSet_Approval();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_Approval(MDocPro.Value, Fields("aprvlTSN").Value, Fields("aprvlName").Value, Fields("aprvlPostName").Value);
  L_WDO.CreateFormLink("Staff", "aprvl");
  SetFieldState_Approval();
 END {formSet_Approval};

 PUBLIC PROCEDURE Decode_PcBkData(curValue: STRING[];
                                  VAR trgINN,
                                      trgFirmName: STRING[];
                                  VAR trgFirm    : LIKE(Firm.Firm);
                                  VAR trgSrcNbr  : STRING[];
                                  VAR trgSrcDate : DATE);
 BEGIN
  trgINN     :=L_Prop.getRES(curValue, 0);
  trgFirm    :=L_r2r.Decode(L_Prop.getRES(curValue, 1));
  trgFirmName:=L_Prop.getRES(curValue, 2);
  trgSrcNbr  :=L_Prop.getRES(curValue, 3);
  trgSrcDate :=STRTOFLD(L_Prop.getRES(curValue, 4), DATE);
 END {Decode_PcBkData};

 PRIVATE PROCEDURE SetupFields_PcBkData(Fields: FORM_FIELDS);
 BEGIN
  Fields("INN"     ).Modifiable:=!Fields("Firm").Value;
  Fields("FirmName").Modifiable:=!Fields("Firm").Value;
 END {SetupFields_PcBkData};

 PRIVATE PROCEDURE formSet_PcBkData();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_WDO.CreateFormLink("Firm", "");
  Decode_PcBkData(MDocPro.Value, Fields("INN").Value, Fields("FirmName").Value, Fields("Firm").Value,
                  Fields("SrcNbr").Value, Fields("SrcDate").Value);
  SetupFields_PcBkData(Fields);
 END {formSet_PcBkData};

 PRIVATE PROCEDURE formGet_PcBkData();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_Prop.putRES(MDocPro.Value, Fields("INN"     ).Value);
  L_Prop.putRES(MDocPro.Value, L_r2r.Put("MDocPro", "Firm", Fields("Firm").Value));
  L_Prop.putRES(MDocPro.Value, Fields("FirmName").Value);
  L_Prop.putRES(MDocPro.Value, Fields("SrcNbr"  ).Value);
  L_Prop.putRED(MDocPro.Value, Fields("SrcDate" ).Value);
 END {formGet_PcBkData};

 PUBLIC PROCEDURE SetDefault_PcBkData();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  IF L_APtm.IsMTA() THEN
   ACCESS(MDoc);
   IF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Acceptance) & (MDoc.MDocKind = L_MDoc.md_DPk) THEN
    Fields:=RTI.Get().CurZone.Fields;
    IF ~!Fields("INN").Value THEN
     L_StdFrm.Choice("  !");
    END;
    CONFORM(MDoc, Firm);
    Fields("INN"     ).Value:=P_Firm.FP_INN(Firm.Firm, MDoc.Date);
    Fields("Firm"    ).Value:=Firm.Firm;
    Fields("FirmName").Value:=P_Firm.FP_ContractorBriefName(Firm.Firm, MDoc.Date);
    Fields("SrcNbr"  ).Value:=FLDTOSTR(MDoc.Date, "N", 2) + "/" + P_Firm.GetOurCode(Firm.Firm, MDoc.Date);
    Fields("SrcDate" ).Value:=L_DatTim.IncWorkDay(L_DatTim.MonthEnd(MDoc.Date)+1, -1);
    FIX_ALTERING();
   ELSE
    L_General.Error(" 㬥   '⥫' ");
   END;
  ELSE
   L_General.Error("砭  ।ᬮ७");
  END;
 END {SetDefault_PcBkData};

 PUBLIC PROCEDURE Decode_Commission(    curValue         : STRING[];
                                    VAR Chairman         : LIKE(Staff.TSN);
                                    VAR Members          : LIKE(Staff.TSN)[CommissMembersAmnt];
                                    VAR OrderOfCommission: STRING[]);
  VAR
   Idx       : SCAL[CommissMembersAmnt];
   AllMembers: STRING[];
 BEGIN
  AllMembers:=Str.Item(curValue, " ", 0);
  Chairman  :=STRTOFLD(L_r2r.Decode(L_Prop.getRES(AllMembers, 0)), SCAL);
  FOR_EACH Idx DO
   Members[Idx]:=STRTOFLD(L_r2r.Decode(L_Prop.getRES(AllMembers, Idx + 1)), SCAL);
  END;
  OrderOfCommission:=Str.Slice(curValue, Str.Pos(curValue, " ") + 1, Str.Length(curValue) - Str.Pos(curValue, " "));
 END {Decode_Commission};

 PRIVATE PROCEDURE formSet_Commission();
  VAR
   Idx              : SCAL[CommissMembersAmnt];
   Fields           : FORM_FIELDS;
   Chairman         : LIKE(Staff.TSN);
   Members          : LIKE(Staff.TSN)[CommissMembersAmnt];
   OrderOfCommission: STRING[];
 BEGIN
  Decode_Commission(MDocPro.Value, Chairman, Members, OrderOfCommission);
  Fields:=RTI.Get().CurZone.Fields;
  L_WDO.CreateFormLink("Staff", "Chairman");
  Fields("ChairmanTSN").Value:=Chairman;
  FOR_EACH Idx DO
   IF ~!Fields(L_WDO.Fld_wIdx("MemberTSN", Idx)) THEN
    L_WDO.extCreateFormLink("Staff", "Member", Idx);
    Fields(L_WDO.Fld_wIdx("MemberTSN", Idx)).Value:=Members[Idx];
   END;
  END;
  Fields("OrderOfCommission").Value:=OrderOfCommission;
 END {formSet_Commission};

 PUBLIC PROCEDURE GetCURate(curValue: STRING[]): FLOAT;
 BEGIN
  RETURN L_Str.Str2Num(L_Prop.getRES(curValue, 0), "");
 END {GetCURate};

 PRIVATE PROCEDURE CountCURate(VAR USDRate: NUMERIC[6]; VAR RatedInc: NUMERIC[4]): NUMERIC[6];
 BEGIN
  IF !USDRate  THEN USDRate :=0; END;
  IF !RatedInc THEN RatedInc:=0; END;
  RETURN USDRate + USDRate * (RatedInc / 100);
 END {CountCURate};

 PRIVATE PROCEDURE Decode_BilCURate(VAR BilCURate,
                                        USDRate  : NUMERIC[6];
                                    VAR RatedInc : NUMERIC[4]);
 BEGIN
  L_General.CallUs(OCCURE(MDocPro));
  CONFORM(MDocPro, MDoc);
  IF ~!MDocPro.Value THEN
   BilCURate:=GetCURate(MDocPro.Value);
   L_General.Assert(~!BilCURate, " ।    㬥 " + MDoc.MDoc);
   USDRate  :=L_Str.Str2Num(L_Prop.getRES(MDocPro.Value, 1), "");
   RatedInc :=L_Str.Str2Num(L_Prop.getRES(MDocPro.Value, 2), "");
  ELSE
   USDRate:=P_OwnData.USDRate(MDoc.Date);
   IF ~!MDoc.Contract & P_Cntr.HasActualPro(MDoc.Contract, MDoc.Date, P_Cntr.P_CURate) THEN
    IF P_Cntr.GetCUR_Rate(MDoc.Contract, MDoc.Date) = P_Cntr.cur_r_Raise THEN
     RatedInc :=P_Cntr.GetCUR_Value(MDoc.Contract, MDoc.Date);
     BilCURate:=CountCURate(USDRate, RatedInc);
    ELSE
     RatedInc :=0;
     BilCURate:=P_Cntr.GetCUR_Value(MDoc.Contract, MDoc.Date);
    END;
   ELSE
    RatedInc :=0;
    BilCURate:=USDRate;
   END;
  END;
 END {Decode_BilCURate};

 PRIVATE PROCEDURE formSet_BilCURate();
  VAR
   Fields: FORM_FIELDS;
   CntrHasActualCURate: SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_BilCURate(Fields("BilCURate").Value, Fields("USDRate").Value, Fields("RatedInc").Value);
  CntrHasActualCURate:=~!MDoc.Contract & P_Cntr.HasActualPro(MDoc.Contract, MDoc.Date, P_Cntr.P_CURate);
  IF CntrHasActualCURate THEN
   Fields("USDRate" ).Modifiable:=~CntrHasActualCURate;
   Fields("RatedInc").Modifiable:=~CntrHasActualCURate;
  END;
 END {formSet_BilCURate};

 PUBLIC PROCEDURE SetDataInForm(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_KeyAssBaseOrder THEN formSet_KeyAssBaseOrder();
  ELSIF trgProperty = P_Commission      THEN formSet_Commission();
  ELSIF trgProperty = P_Approval        THEN formSet_Approval();
  ELSIF trgProperty = P_BilCURate       THEN formSet_BilCURate();
  ELSIF trgProperty = P_PartnerAgent    THEN formSet_PartnerAgent();;
  ELSIF trgProperty = P_PcBkData        THEN formSet_PcBkData();
  END;
 END {SetDataInForm};

 PRIVATE PROCEDURE Encode_PartnerAgent(VAR curValue: STRING[];
                                           Name,
                                           PostName,
                                           DocKind,
                                           DocSer,
                                           DocNbr,
                                           DocGiveS: STRING[];
                                           DocGiveD,
                                           DocExpD : DATE);
 BEGIN
  SETEMPTY(curValue);
  IF ~!Name | ~!PostName | ~!DocKind | ~!DocSer | ~!DocNbr | ~!DocGiveD | ~!DocExpD  | ~!DocGiveS THEN
   L_Prop.putRES(curValue, Name);
   L_Prop.putRES(curValue, PostName);
   L_Prop.putRES(curValue, DocKind);
   L_Prop.putRES(curValue, DocSer);
   L_Prop.putRES(curValue, DocNbr);
   L_Prop.putRED(curValue, DocGiveD);
   L_Prop.putRED(curValue, DocExpD);
   L_Prop.putRES(curValue, DocGiveS);
  END;
 END {Encode_PartnerAgent};

 PRIVATE PROCEDURE formGet_PartnerAgent();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_PartnerAgent(MDocPro.Value,
                      Fields("paName").Value,
                      Fields("paPostName").Value,
                      Fields("paDocKind").Value,
                      Fields("paDocSer").Value,
                      Fields("paDocNbr").Value,
                      Fields("paDocGiveS").Value,
                      Fields("paDocGiveD").Value,
                      Fields("paDocExpD").Value);
 END {formGet_PartnerAgent};

 PRIVATE PROCEDURE Encode_Approval(VAR curValue   : STRING[];
                                       trgTSN     : LIKE(Staff.TSN);
                                       trgName,
                                       trgPostName: STRING[]);
 BEGIN
  SETEMPTY(curValue);
  IF    ~!trgTSN THEN
   curValue:=L_r2r.Put("MDocPro", "Staff", trgTSN);
  ELSIF ~!trgName THEN
   L_Prop.putRES(curValue, trgName);
   L_Prop.putRES(curValue, trgPostName);
  END;
 END {Encode_Approval};

 PRIVATE PROCEDURE formGet_Approval();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_General.Assert(!Fields("aprvlName").Value = !Fields("aprvlPostName").Value,
                   "       ६");
  Encode_Approval(MDocPro.Value, Fields("aprvlTSN").Value, Fields("aprvlName").Value, Fields("aprvlPostName").Value);
 END {formGet_Approval};

 PRIVATE PROCEDURE Encode_Commission(VAR curValue            : STRING[];
                                         Chairman         : LIKE(Staff.TSN);
                                         Members          : LIKE(Staff.TSN)[CommissMembersAmnt];
                                         OrderOfCommission: STRING[]);
  VAR
   Idx: SCAL[CommissMembersAmnt];
 BEGIN
  SETEMPTY(curValue);
  L_Prop.putRES(curValue, L_r2r.Put("MDocPro", "Staff", Chairman));
  FOR_EACH Idx DO
   IF ~!Members[Idx] THEN
    L_Prop.putRES(curValue, L_r2r.Put("MDocPro", "Staff", Members[Idx]));
   END;
  END;
  curValue:=curValue + " " + OrderOfCommission;
 END {Encode_Commission};

 PRIVATE PROCEDURE formGet_Commission();
  VAR
   Idx    : SCAL[CommissMembersAmnt];
   Fields : FORM_FIELDS;
   Members: LIKE(Staff.TSN)[CommissMembersAmnt];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  SETEMPTY(Members);
  FOR_EACH Idx DO
   IF ~!Fields(L_WDO.Fld_wIdx("MemberTSN", Idx)) THEN
    Members[Idx]:=Fields(L_WDO.Fld_wIdx("MemberTSN", Idx)).Value;
   END;
  END;
  Encode_Commission(MDocPro.Value, Fields("ChairmanTSN").Value, Members, Fields("OrderOfCommission").Value);
 END {formGet_Commission};

 PRIVATE PROCEDURE Encode_KeyAssBaseOrder(VAR curValue : STRING[];
                                              BO_Name,
                                              BO_DocNum: STRING[];
                                              BO_Date  : DATE);
 BEGIN
  SETEMPTY(curValue);
  IF ~!BO_Name | ~!BO_DocNum | ~!BO_Date THEN
   L_Prop.putRES(curValue, BO_Name);
   L_Prop.putRES(curValue, BO_DocNum);
   L_Prop.putRED(curValue, BO_Date);
  END;
 END {Encode_KeyAssBaseOrder};

 PRIVATE PROCEDURE formGet_KeyAssBaseOrder();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_KeyAssBaseOrder(MDocPro.Value, Fields("BO_Name").Value, Fields("BO_DocNum").Value, Fields("BO_Date").Value);
 END {formGet_KeyAssBaseOrder};

 PRIVATE PROCEDURE Encode_BilCURate(VAR curValue : STRING[];
                                        BilCURate,
                                        USDRate  : NUMERIC[6];
                                        RatedInc : NUMERIC[4]);
 BEGIN
  SETEMPTY(curValue);
  IF ~!BilCURate | ~!USDRate | ~!RatedInc THEN
   IF BilCURate # CountCURate(USDRate, RatedInc) THEN
    L_Prop.putRES(curValue, FLDTOSTR(BilCURate, "6."));
   ELSE
    L_Prop.putRES(curValue, FLDTOSTR(BilCURate, "6."));
    L_Prop.putRES(curValue, FLDTOSTR(USDRate,   "4."));
    L_Prop.putRES(curValue, FLDTOSTR(RatedInc,  "2."));
   END;
  END;
 END {Encode_BilCURate};

 PRIVATE PROCEDURE formGet_BilCURate();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_BilCURate(MDocPro.Value, Fields("BilCURate").Value, Fields("USDRate").Value, Fields("RatedInc").Value);
 END {formGet_BilCURate};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty: LIKE(Property.Property));
 BEGIN
  SETEMPTY(MDocPro.Value);
  IF    trgProperty = P_KeyAssBaseOrder THEN formGet_KeyAssBaseOrder();
  ELSIF trgProperty = P_Commission      THEN formGet_Commission();
  ELSIF trgProperty = P_Approval        THEN formGet_Approval();
  ELSIF trgProperty = P_BilCURate       THEN formGet_BilCURate();
  ELSIF trgProperty = P_PartnerAgent    THEN formGet_PartnerAgent();
  ELSIF trgProperty = P_PcBkData        THEN formGet_PcBkData();
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(MDocPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE GetDealCheckType(_MDocKind: LIKE(MDoc.MDocKind);
                                   _MDoc: LIKE(MDoc.MDoc)): tDealCheckType;
 BEGIN
  IF HasActualMDocPro(_MDocKind, _MDoc, P_DealCheckType) THEN
   RETURN L_Prop.GetProValueAsScal(GetMDocProPool(P_DealCheckType), MDocPro.Value);
  ELSE
   RETURN dct_Obvious;
  END;
 END {GetDealCheckType};

 PRIVATE PROCEDURE pa_GetDocumentGiveS();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF ~!Fields("paDocGiveS").Value THEN
   L_StdFrm.Choice(" ࠭   ࣠, 뤠襬 㬥,  ");
  END;
  Fields("paDocGiveS").Value:=P_Firm.FP_FirmName(MDoc.Firm, MDoc.Date);
 END {pa_GetDocumentGiveS};

 PRIVATE PROCEDURE int_pa_GetDataFromFirmPro();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  L_General.Assert(~!MDoc.Firm, " 㬥  । ࠣ");
  Fields:=RTI.Get().CurZone.Fields;
  IF ~!Fields("paName").Value   | ~!Fields("paPostName").Value | ~!Fields("paDocKind").Value  | ~!Fields("paDocSer").Value |
     ~!Fields("paDocNbr").Value | ~!Fields("paDocGiveS").Value | ~!Fields("paDocGiveD").Value | ~!Fields("paDocExpD").Value THEN
   L_StdFrm.Choice("  ࠭   ");
  END;
  SETEMPTY(Fields("paDocKind").Value, Fields("paDocSer").Value, Fields("paDocNbr").Value, Fields("paDocGiveS").Value, Fields("paDocGiveD").Value, Fields("paDocExpD").Value);
  Fields("paName").Value    :=P_Firm.FP_ContactPersonName(MDoc.Firm, MDoc.Date);
  Fields("paPostName").Value:=P_Firm.FP_ContactPersonPostName1(MDoc.Firm, MDoc.Date);
  pa_GetDocumentGiveS();
 END {int_pa_GetDataFromFirmPro};

 PUBLIC PROCEDURE pa_GetDataFromFirmPro(GetOnlyGiveS: SCAL[2]);
  VAR
   Choice: NUMERIC[0];
 BEGIN
  IF GetOnlyGiveS THEN
   pa_GetDocumentGiveS();
  ELSE
   Choice:=L_StdFrm.ShowListAsMenu("⠪⭮ |", "।⠢⥫ ࠣ");
   IF Choice = 0 THEN
    int_pa_GetDataFromFirmPro();
   END;
  END;
 END {pa_GetDataFromFirmPro();};

 PUBLIC PROCEDURE extSetMDocPro(trgMDocKind: LIKE(MDoc.MDocKind);
                                trgMDoc    : LIKE(MDoc.MDoc);
                                trgProperty: LIKE(Property.Property);
                                trgPropRow : LIKE(MDocPro.PropRow);
                                trgValue   : STRING[]);
 BEGIN
  IF    SEARCH(MDocPro, MDoc, trgMDocKind, trgMDoc, trgProperty, trgPropRow) THEN
   IF ~!trgValue THEN
    CheckAcceptableValueLength(trgValue);
    MDocPro.Value:=trgValue;
    REPLACE(MDocPro);
    CALL(ObjPro.UpdateVal2Show("MDocPro"));
   ELSE
    REMOVE(MDocPro);
   END;
  ELSIF ~!trgValue THEN
   InsMDocPro(trgMDocKind, trgMDoc, trgProperty, trgPropRow, trgValue);
  END;
 END {extSetMDocPro};

 PUBLIC PROCEDURE SetMDocPro(trgMDocKind: LIKE(MDoc.MDocKind);
                             trgMDoc    : LIKE(MDoc.MDoc);
                             trgProperty: LIKE(Property.Property);
                             trgValue   : STRING[]);
 BEGIN
  extSetMDocPro(trgMDocKind, trgMDoc, trgProperty, 01, trgValue);
 END {SetMDocPro};

 PRIVATE PROCEDURE MDocPro_OnAnyModification();
  VAR
   Zone : FORM_ZONE;
   Field: FORM_FIELD;
 BEGIN
  CONFORM(MDocPro, MDoc);
  IF    MDocPro.Property = P_ServiceNote THEN
   Zone:=RTI.Get().CurWindow.ParentZone;
   IF ~!Zone THEN
    Zone:=Zone.Window.ParentZone;
    IF ~!Zone THEN
     Field:=Zone.Fields("v_MDoc_ServiceNote");
     IF ~!Field THEN
      Field.Value:=L_Str.PoolItem(sv_Pool, ~!MDocPro.Value);
     END;
    END;
   END;
  ELSIF MDocPro.Property = P_DealCheckType THEN
   L_Pmnt.ResetMDocClosed();
  ELSIF MDocPro.Property = P_DoSpecVATMDoc THEN
   IF (MDoc.Status # L_MDoc.st_Canceled) & ~!MDoc.Contract & L_Pmnt.TakeMDocIntoAccount() THEN
    L_Pmnt.SetSpecialVATMDocDone(MDoc.Contract, L_DatTim.Per(MDoc.Date), 0, 0);
   END;
  END;
 END {MDocPro_OnAnyModification};

 PUBLIC PROCEDURE IsAutoBuildServiceNote(trgValue: STRING[]): SCAL[2];
 BEGIN
  RETURN Str.Item(trgValue, ";", 0) = sn_AutoBuildIdent;
 END {IsAutoBuildServiceNote};

 PRIVATE PROCEDURE MDocPro_OnBeforeAnyModification();
 BEGIN
  IF    MDocPro.Property = P_DoSpecVATMDoc THEN
   L_StdFrm.Choice("!|䨪  ᢮⢠   楯 ନ஢ |" +
                   " ਢ  室 ন  ");
  ELSIF MDocPro.Property = P_ServiceNote THEN
   L_General.Assert(~IsAutoBuildServiceNote(MDocPro.Value),
                    "䨪 ⮬᪨ ନ஢ ᢮⢠ 饭");
  END;
 END {MDocPro_OnBeforeAnyModification};

 PUBLIC PROCEDURE MDocPro_OnBeforeInsert();
 BEGIN
  IF MDocPro.Property = P_BilCURate THEN
   formSet_BilCURate();
   formGet_BilCURate();
   REPLACE(MDocPro);
   FIXALTERING();
  END;
  MDocPro_OnBeforeAnyModification();
 END {MDocPro_OnBeforeInsert};

 PUBLIC PROCEDURE MDocPro_OnBeforeEdit();
 BEGIN
  MDocPro_OnBeforeAnyModification();
 END {MDocPro_OnBeforeEdit};

 PUBLIC PROCEDURE MDocPro_OnBeforeDelete();
 BEGIN
  MDocPro_OnBeforeAnyModification();
 END {MDocPro_OnBeforeDelete};

 PUBLIC PROCEDURE MDocPro_OnAfterEdit();
 BEGIN
  MDocPro_OnAnyModification();
 END {MDocPro_OnAfterEdit};

 PUBLIC PROCEDURE MDocPro_OnAfterInsert();
 BEGIN
  MDocPro_OnAnyModification();
 END {MDocPro_OnAfterInsert};

 PUBLIC PROCEDURE Value_OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_KeyAssAddress THEN L_Pool.Put(pool_KeyAssAddress, MDocPro.Value);
  ELSIF trgProperty = P_Findings      THEN L_Pool.Put(pool_Findings,      MDocPro.Value);
  ELSIF trgProperty = P_ListOfDocs    THEN L_Pool.Put(pool_ListOfDocs,    MDocPro.Value);
  ELSIF trgProperty = P_Reason        THEN L_Pool.Put(pool_Reason,        MDocPro.Value);
  ELSIF trgProperty = P_Condition     THEN L_Pool.Put(pool_Condition,     MDocPro.Value);
  END;
 END {Value_OnSuccessfulChange};

 PUBLIC PROCEDURE DoSpecVATMDoc(_MDocKind: LIKE(MDoc.MDocKind); _MDoc: LIKE(MDoc.MDoc)): SCAL[2];
  VAR
   _Value: LIKE(MDocPro.Value);
 BEGIN
  _Value:=GetMDocProSoft(_MDocKind, _MDoc, P_DoSpecVATMDoc);
  IF ~!_Value THEN
   RETURN L_Str.PositionInPool(dsvmd_Pool, _Value);
  ELSE
   RETURN dsvmd_Auto;
  END;
 END {DoSpecVATMDoc};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Result           : STRING[];
   trgFirm          : LIKE(Firm.Firm);
   trgINN,
   trgFirmName,
   trgSrcNbr        : STRING[];
   trgSrcDate       : DATE;
   Idx              : SCAL[CommissMembersAmnt];
   Chairman         : LIKE(Staff.TSN);
   Members          : LIKE(Staff.TSN)[CommissMembersAmnt];
   OrderOfCommission: STRING[];
   trgTSN           : LIKE(Staff.TSN);
   trgName,
   trgPostName      : STRING[];
 BEGIN
  IF     MDocPro.Property = P_PcBkData THEN
   Decode_PcBkData(MDocPro.Value, trgINN, trgFirmName, trgFirm, trgSrcNbr, trgSrcDate);
   Result:=trgSrcNbr + ";" + L_DatTim.DateStr(trgSrcDate) + ";" + trgINN + ";" + trgFirmName;
  ELSIF  MDocPro.Property = P_Commission THEN
   SETEMPTY(Result);
   Decode_Commission(MDocPro.Value, Chairman, Members, OrderOfCommission);
   L_Prop.putRES(Result, Chairman);
   FOR_EACH Idx DO
    IF ~!Members[Idx] THEN
     L_Prop.putRES(Result, Members[Idx]);
    END;
   END;
   Result:=Result + " " + OrderOfCommission;
  ELSIF MDocPro.Property = P_Approval THEN
   Decode_Approval(MDocPro.Value, trgTSN, trgName, trgPostName);
   SETEMPTY(Result);
   IF    ~!trgTSN THEN
    Result:=trgTSN + " " + trgName;
   ELSIF ~!trgName THEN
    L_Prop.putRES(Result, trgName);
    L_Prop.putRES(Result, trgPostName);
   END;
  ELSE
   Result:=MDocPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PUBLIC PROCEDURE GetNote(trgMDocKind: LIKE(MDoc.MDocKind); trgMDoc: LIKE(MDoc.MDoc)): STRING[];
  VAR
   i      : NUMERIC[0];
   Result : STRING[];
   PropArr: STRING[][100];
 BEGIN
  SETEMPTY(Result);
  GetMDocProArray(trgMDocKind, trgMDoc, P_Note, PropArr);
  i:=0;
  WHILE i <= HIGH(PropArr) DO
   Result:=Result + " " + PropArr[i];
   INC(i);
  END; (* WHILE i <= HIGH(PropArr)...*)
  RETURN Str.Condense(Result);
 END {GetNote};

END.
