(*
%Copyright   (c) Polak IT
%Author      15.01.2007 17:37:23 POLAK\GAV
%Purpose     ⥪  ࠡ  ᢮⢠ MyFirm
%Type        library
%Specific    SYS
%Modified    18.08.2014 18:54:22 POLAK\Gina
%Environment
*)

 MODULE P_MyFirm [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tTaxationMode = SCAL[4];
  tPropTaxCode  = SCAL[1e7];
  tPropTaxRate  = NUMERIC[2];
  tTaxDepCode   = SCAL[1e4];
  tNumInPFR     = STRING[14];
  tTravmObligTariff    = NUMERIC[5];
  tTravmObligTariffInc = NUMERIC[0];

 PUBLIC CONST
  P_RegistrationInFSS   = 8002;
  P_TaxationMode        = 8003;
  P_StaffDepChief       = 8004;
  P_TaxCardResp         = 8005;
  P_TaxCardCont         = 8006;
  P_Tax3Sender          = 8007;
  P_AnkSender           = 8008;
  P_PFRInsSender        = 8009;
  P_StxCont             = 8010;
  P_Cashier             = 8011;
  P_AcntCashier         = 8012;
  P_MainEngineer        = 8013;
  P_MainEconomist       = 8014;
  P_LegalDepChief       = 8015;
  P_GIBDDTrustee        = 8016;
  P_PropertyTax         = 8017;
  P_TaxDep              = 8018;
  P_EmploymentCenter    = 8019;
  P_MigrationService    = 8020;
  P_MigrNotifSender     = 8021;
  P_PensFund            = 8022;
  P_MSTF                = 8023;
  P_StatisticRegister   = 8024;

  tm_Common              = 0;
  tm_USNO_Income         = 1;
  tm_USNO_IncomeWOCharge = 2;
  tm_ENVD                = 3;
  tm_Pool = "騩| (室)| (室, 㬥襭  稭 室)|E";

 IMPORT L_Prop, Str, L_General, L_Str, P_Man, P_Firm, L_ctc, L_WDO, L_r2r, L_PCS;

 PRIVATE TYPE
  tElmelementRegistrationInFSS = SCAL[8];

 PRIVATE CONST
  v_NumInPFR   = "v_NumInPFR";
  v_PFRDepName = "v_PFRDepName";

  v_NumInMSTF = "v_NumInMSTF";
  v_MSTFName  = "v_MSTFName";

  erfss_OKVED             = 0; (*tElmelementRegistrationInFSS*)
  erfss_OKVEDName         = 1;
  erfss_RegistrationCode  = 2;
  erfss_TravmObligTariff  = 3;
  erfss_SubordinationCode = 4;
  erfss_SupplementaryCode = 5;
  erfss_FSSName           = 6;
  erfss_TravmObligTariffInc = 7;

 PUBLIC PROCEDURE IsSimpleUserOf(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF (trgProperty=P_StaffDepChief) | 
     (trgProperty=P_TaxCardResp)   | 
     (trgProperty=P_TaxCardCont)   |
     (trgProperty=P_Tax3Sender)    | 
     (trgProperty=P_AnkSender)     | 
     (trgProperty=P_PFRInsSender)  |
     (trgProperty=P_StxCont)       | 
     (trgProperty=P_Cashier)       |
     (trgProperty=P_AcntCashier)   |
     (trgProperty=P_MainEngineer)  |
     (trgProperty=P_MainEconomist) |
     (trgProperty=P_LegalDepChief) |
     (trgProperty=P_GIBDDTrustee)  |
     (trgProperty=P_MigrNotifSender) THEN
   RETURN "Staff";
  ELSE
   RETURN "";
  END;
 END {IsSimpleUserOf};

 PUBLIC PROCEDURE GetPool(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    _Property = P_TaxationMode THEN
   RETURN tm_Pool;
  ELSIF L_Prop.IsLocalProperty(_Property) THEN
   RETURN L_Prop.E_GetPool(_Property);
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PRIVATE PROCEDURE Decode_RegistrationInFSS(    Value                  : STRING[];
                                            VAR trgOKVED,
                                                trgOKVEDName,
                                                trgFSSRegistrationCode,
                                                trgFSSSubordinationCode,
                                                trgFSSSupplementaryCode,
                                                trgFSSName             : STRING[];
                                            VAR trgTravmObligTariff    : tTravmObligTariff;
                                            VAR trgTravmObligTariffInc : tTravmObligTariffInc);
 BEGIN
  trgOKVED               :=L_Prop.getRES(Value, erfss_OKVED);
  trgOKVEDName           :=L_Prop.getRES(Value, erfss_OKVEDName);
  trgFSSRegistrationCode :=L_Prop.getRES(Value, erfss_RegistrationCode);
  trgTravmObligTariff    :=L_Prop.GetNumericValueFromStr(L_Prop.getRES(Value, erfss_TravmObligTariff));
  trgFSSSubordinationCode:=L_Prop.getRES(Value, erfss_SubordinationCode);
  trgFSSSupplementaryCode:=L_Prop.getRES(Value, erfss_SupplementaryCode);
  trgFSSName             :=L_Prop.getRES(Value, erfss_FSSName);
  trgTravmObligTariffInc :=L_Prop.GetNumericValueFromStr(L_Prop.getRES(Value, erfss_TravmObligTariffInc));
 END {Decode_RegistrationInFSS};

 PRIVATE PROCEDURE formSet_RegistrationInFSS();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_RegistrationInFSS(MFPro.Value,
                           Fields("OKVED").Value,
                           Fields("OKVEDName").Value,
                           Fields("FSSRegistrationCode").Value,
                           Fields("FSSSubordinationCode").Value,
                           Fields("FSSSupplementaryCode").Value,
                           Fields("FSSName").Value,
                           Fields("TravmObligTariff").Value,
                           Fields("TravmObligTariffInc").Value);
 END {formSet_RegistrationInFSS};

 PRIVATE PROCEDURE Decode_PropertyTax(    Value: STRING[];
                                      VAR PropTaxCode: tPropTaxCode;
                                      VAR PropTaxRate: tPropTaxRate);
 BEGIN
  PropTaxCode:=STRTOFLD(L_Prop.getRES(Value, 0), SCAL);
  PropTaxRate:=STRTOFLD(L_Prop.getRES(Value, 1), NUMERIC, "2.");
 END {Decode_PropertyTax};

 PRIVATE PROCEDURE formSet_PropertyTax();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_PropertyTax(MFPro.Value, Fields("PropTaxCode").Value, Fields("PropTaxRate").Value);
 END {formSet_PropertyTax};

 PRIVATE PROCEDURE Decode_TaxDep(    Value                : STRING[];
                                 VAR trgUltimateTaxDepCode: tTaxDepCode;
                                 VAR trgUltimateTaxDep    : STRING[];
                                 VAR trgIntermedTaxDepCode: tTaxDepCode;
                                 VAR trgIntermedTaxDep    : STRING[]);
 BEGIN
  trgUltimateTaxDepCode:=STRTOFLD(L_Prop.getRES(Value, 0), SCAL);
  trgUltimateTaxDep    :=L_Prop.getRES(Value, 1);
  trgIntermedTaxDepCode:=STRTOFLD(L_Prop.getRES(Value, 2), SCAL);
  trgIntermedTaxDep    :=L_Prop.getRES(Value, 3);
 END {Decode_TaxDep};

 PRIVATE PROCEDURE formSet_TaxDep();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_TaxDep(MFPro.Value, Fields("UltimateTaxDepCode").Value,
                             Fields("UltimateTaxDep").Value,
                             Fields("IntermedTaxDepCode").Value,
                             Fields("IntermedTaxDep").Value);
 END {formSet_TaxDep};

 PRIVATE PROCEDURE Encode_TaxDep(VAR Value                : STRING[];
                                     trgUltimateTaxDepCode: tTaxDepCode;
                                     trgUltimateTaxDep    : STRING[];
                                     trgIntermedTaxDepCode: tTaxDepCode;
                                     trgIntermedTaxDep    : STRING[]);
 BEGIN
  L_Prop.putRecordElement(Value, trgUltimateTaxDepCode);
  L_Prop.putRecordElement(Value, trgUltimateTaxDep);
  L_Prop.putRecordElement(Value, trgIntermedTaxDepCode);
  L_Prop.putRecordElement(Value, trgIntermedTaxDep);
 END {Encode_TaxDep};

 PRIVATE PROCEDURE formGet_TaxDep();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_General.Assert(!Fields("IntermedTaxDepCode").Value = !Fields("IntermedTaxDep").Value, "   ஬筮  |   ६");
  Encode_TaxDep(MFPro.Value, Fields("UltimateTaxDepCode").Value,
                             Fields("UltimateTaxDep").Value,
                             Fields("IntermedTaxDepCode").Value,
                             Fields("IntermedTaxDep").Value);
 END {formGet_TaxDep};

 PRIVATE PROCEDURE spf_DecodeValue(_Property: LIKE(Property.Property); Strong: SCAL[2]);
  VAR
   CurZone: FORM_ZONE;
 BEGIN
  IF    _Property = P_PensFund THEN
   CurZone:=L_WDO.getActiveZone();
   SetPensFundData(CurZone.Fields(v_NumInPFR).Value,  CurZone.Fields(v_PFRDepName).Value);
  ELSIF _Property = P_MSTF THEN
   CurZone:=L_WDO.getActiveZone();
   SetPensFundData(CurZone.Fields(v_NumInMSTF).Value,  CurZone.Fields(v_MSTFName).Value);
  END;
 END {spf_DecodeValue};

 PRIVATE PROCEDURE Decode_StatisticRegister(    Value    : STRING[];
                                            VAR OKOGU,
                                                OKFS,
                                                OKFSName,
                                                OKOPF,
                                                OKOPFName: STRING[]);
 BEGIN
  SETEMPTY(OKOGU, OKFS, OKFSName, OKOPF, OKOPFName);
  OKOGU    :=L_Prop.getRecordElement(Value, 0);

  OKFS     :=L_Prop.getRecordElement(Value, 1);
  OKFSName :=L_Prop.getRecordElement(Value, 2);

  OKOPF    :=L_Prop.getRecordElement(Value, 3);
  OKOPFName:=L_Prop.getRecordElement(Value, 4);
 END {Decode_StatisticRegister};

 PRIVATE PROCEDURE formSet_StatisticRegister();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_StatisticRegister(MFPro.Value, Fields("OKOGU"    ).Value,
                                        Fields("OKFS"     ).Value,
                                        Fields("OKFSName" ).Value,
                                        Fields("OKOPF"    ).Value,
                                        Fields("OKOPFName").Value);
 END {formSet_StatisticRegister};

 PUBLIC PROCEDURE SetDataInForm(_Property: LIKE(Property.Property));
 BEGIN
  IF    _Property = P_RegistrationInFSS THEN
   formSet_RegistrationInFSS();
  ELSIF _Property = P_PropertyTax THEN
   formSet_PropertyTax();
  ELSIF _Property = P_TaxDep      THEN
   formSet_TaxDep();
  ELSIF (_Property = P_PensFund)  |
        (_Property = P_MSTF)      THEN
   spf_DecodeValue(_Property, 0);
  ELSIF _Property = P_StatisticRegister THEN
   formSet_StatisticRegister();
  END;
 END {SetDataInForm};

 PRIVATE PROCEDURE Encode_RegistrationInFSS(VAR Value                  : STRING[];
                                                trgOKVED,
                                                trgOKVEDName,
                                                trgFSSRegistrationCode,
                                                trgFSSSubordinationCode,
                                                trgFSSSupplementaryCode,
                                                trgFSSName             : STRING[];
                                                trgTravmObligTariff    : tTravmObligTariff;
                                                trgTravmObligTariffInc : tTravmObligTariffInc);
 BEGIN
  L_Prop.putRecordElement(Value, trgOKVED);
  L_Prop.putRecordElement(Value, trgOKVEDName);
  L_Prop.putRecordElement(Value, trgFSSRegistrationCode);
  L_Prop.putRecordElement(Value, trgTravmObligTariff);
  L_Prop.putRecordElement(Value, trgFSSSubordinationCode);
  L_Prop.putRecordElement(Value, trgFSSSupplementaryCode);
  L_Prop.putRecordElement(Value, trgFSSName);
  L_Prop.putRecordElement(Value, trgTravmObligTariffInc);
 END {Encode_RegistrationInFSS};

 PRIVATE PROCEDURE ErrOKVED(Cond: SCAL[2]; curOKVED: STRING[]);
 BEGIN
  L_General.Assert(Cond, "४⭠    '" + curOKVED + "'|" +
                         "  ᮤঠ , ࠧ 窮, ଠ 99.99.99");
 END {ErrOKVED};

 PRIVATE PROCEDURE formGet_RegistrationInFSS();
  VAR
   Fields  : FORM_FIELDS;
   SingleChar,
   curOKVED: STRING[];
   i       : NUMERIC[0];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  curOKVED:=Fields("OKVED").Value;
  L_General.Assert(!curOKVED = !Fields("OKVEDName").Value,
                   "    ᪮ ⥫쭮|" +
                   "    ६");
  IF ~!curOKVED THEN
   ErrOKVED(Str.Match(curOKVED, "??.*"), curOKVED);
   i:=0;
   WHILE i < Str.Length(curOKVED) DO
    SingleChar:=L_Str.Char(curOKVED, i);
    ErrOKVED(L_Str.TestStrAlowChar(SingleChar, "09") | L_Str.TestStrAlowChar(SingleChar, ".."), curOKVED);
    INC(i);
   END;
   ErrOKVED(SingleChar#".", curOKVED);
  END;
  Encode_RegistrationInFSS(MFPro.Value,
                           curOKVED,
                           Fields("OKVEDName").Value,
                           Fields("FSSRegistrationCode").Value,
                           Fields("FSSSubordinationCode").Value,
                           Fields("FSSSupplementaryCode").Value,
                           Fields("FSSName").Value,
                           Fields("TravmObligTariff").Value,
                           Fields("TravmObligTariffInc").Value);
 END {formGet_RegistrationInFSS};

 PRIVATE PROCEDURE Encode_PropertyTax(VAR Value: STRING[];
                                          PropTaxCode: tPropTaxCode;
                                          PropTaxRate: tPropTaxRate);
 BEGIN
  L_Prop.putRecordElement(Value, PropTaxCode);
  L_Prop.putRecordElement(Value, PropTaxRate);
 END {Encode_PropertyTax};

 PRIVATE PROCEDURE formGet_PropertyTax();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_PropertyTax(MFPro.Value, Fields("PropTaxCode").Value, Fields("PropTaxRate").Value);
 END {formGet_PropertyTax};

 PRIVATE PROCEDURE Encode_StatisticRegister(VAR Value    : STRING[];
                                                OKOGU,
                                                OKFS,
                                                OKFSName,
                                                OKOPF,
                                                OKOPFName: STRING[]);
 BEGIN
  IF ~!OKOGU | ~!OKFS | ~!OKFSName | ~!OKOPF | ~!OKOPFName THEN
   L_Prop.putRecordElement(Value, OKOGU);
   L_Prop.putRecordElement(Value, OKFS);
   L_Prop.putRecordElement(Value, OKFSName);
   L_Prop.putRecordElement(Value, OKOPF);
   L_Prop.putRecordElement(Value, OKOPFName);
  END;
 END {Encode_StatisticRegister};

 PRIVATE PROCEDURE formGet_StatisticRegister();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_General.Assert(!Str.Condense(Fields("OKFS").Value) = !Str.Condense(Fields("OKFSName" ).Value),
                   "    ᮡ⢥|" +
                   "    ६");
  L_General.Assert(!Str.Condense(Fields("OKOPF").Value) = !Str.Condense(Fields("OKOPFName").Value),
                   "   ࣠樮-ࠢ |" +
                   "    ६");
  Encode_StatisticRegister(MFPro.Value, Fields("OKOGU"    ).Value,
                                        Fields("OKFS"     ).Value,
                                        Fields("OKFSName" ).Value,
                                        Fields("OKOPF"    ).Value,
                                        Fields("OKOPFName").Value);
 END {formGet_StatisticRegister};

 PUBLIC PROCEDURE GetDataFromForm(_Property: LIKE(Property.Property));
  VAR
   CurZone  : FORM_ZONE;
   _NumInPfr: tNumInPFR;
   NumInMSTF: STRING[];
 BEGIN
  SETEMPTY(MFPro.Value);
  IF    _Property = P_RegistrationInFSS THEN
   formGet_RegistrationInFSS();
  ELSIF _Property = P_PropertyTax THEN
   formGet_PropertyTax();
  ELSIF _Property = P_TaxDep THEN
   formGet_TaxDep();
  ELSIF _Property = P_PensFund THEN
   CurZone  :=L_WDO.getActiveZone();
   _NumInPfr:=CurZone.Fields(v_NumInPFR).Value;
   L_Str.CheckStrWMask("樮   ", _NumInPfr, "999-999-999999");
   L_Prop.putRecordElement(MFPro.Value, _NumInPfr);
   L_Prop.putRecordElement(MFPro.Value, CurZone.Fields(v_PFRDepName).Value);
  ELSIF _Property = P_MSTF THEN
   CurZone  :=L_WDO.getActiveZone();
   NumInMSTF:=CurZone.Fields(v_NumInMSTF).Value;
   IF ~L_Str.TestStrAlowChar(NumInMSTF, "09") THEN
    L_General.Error("४ ॣ樮    " + NumInMSTF);
   END;
   L_General.Assert(Str.Length(NumInMSTF) = 15, "樮      15 ᨬ");
   L_Prop.putRecordElement(MFPro.Value, NumInMSTF);
   L_Prop.putRecordElement(MFPro.Value, CurZone.Fields(v_MSTFName).Value);
  ELSIF _Property = P_StatisticRegister THEN
   formGet_StatisticRegister();
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(MFPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF IsSimpleUserOf(MFPro.Property) = "Staff" THEN
   SEARCH(Staff, TSN, , L_r2r.DecodeReferenceStamp(MFPro.Value));
   CONFORM(Staff, Man);
   Result:=Staff.TSN + " " + Man.Name;
  ELSE
   Result:=MFPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PUBLIC PROCEDURE GetSubWindowName(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    _Property = P_RegistrationInFSS     THEN RETURN "P_8002";
  ELSIF _Property = P_PropertyTax           THEN RETURN "P_8017";
  ELSIF _Property = P_TaxDep                THEN RETURN "P_8018";
  ELSIF _Property = P_PensFund              THEN RETURN "P_8022";
  ELSIF _Property = P_MSTF                  THEN RETURN "P_8023";
  ELSIF _Property = P_StatisticRegister     THEN RETURN "P_8024";
  ELSE
   RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE HasPro(trgMyFirm: LIKE(MyFirm.MyFirm);
                         D        : DATE;
                         trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  SETSEL(MFPro, MyFirm, trgMyFirm, trgProperty);
  RETURN SRCINSEL(MFPro, LE, D);
 END {HasPro};

 PUBLIC PROCEDURE HasActualPro(trgMyFirm: LIKE(MyFirm.MyFirm);
                               D        : DATE;
                               _Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasPro(trgMyFirm, D, _Property) & (!MFPro.DocExpD | (D < MFPro.DocExpD));
 END {HasActualPro};

 PRIVATE PROCEDURE GetProValue(trgMyFirm        : LIKE(MyFirm.MyFirm);
                               D                : DATE;
                               trgProperty      : LIKE(Property.Property);
                               PresenceCondition: L_Prop.tPresenceCondition): STRING[];
  VAR
   Result: LIKE(MFPro.Value);
 BEGIN
  IF HasActualPro(trgMyFirm, D, trgProperty) THEN
   IF ~!IsSimpleUserOf(trgProperty) THEN
    Result:=L_r2r.DecodeReferenceStamp(MFPro.Value);
   ELSE
    Result:=MFPro.Value;
   END;
  ELSE
   IF PresenceCondition = L_Prop.pc_Strong THEN
    SEARCH(MyFirm, MyFirm, , trgMyFirm);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("MyFirm").Id, MyFirm.RECORDID, trgProperty, D);
   ELSE
    SETEMPTY(Result);
   END; (* IF *)
  END; (* IF *)
  RETURN Result;
 END {GetProValue};

 PUBLIC PROCEDURE GetProValueSoft(trgMyFirm: LIKE(MyFirm.MyFirm);
                                  D        : DATE;
                                  _Property: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetProValue(trgMyFirm, D, _Property, L_Prop.pc_Soft);
 END {GetProValueSoft};

 PUBLIC PROCEDURE GetProValueStrong(trgMyFirm: LIKE(MyFirm.MyFirm);
                                    D        : DATE;
                                    _Property: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetProValue(trgMyFirm, D, _Property, L_Prop.pc_Strong);
 END {GetProValueSoft};

 PRIVATE PROCEDURE GetElement_RegistrationInFSS(trgMyFirm : LIKE(MyFirm.MyFirm);
                                                trgDate   : DATE;
                                                trgElement: tElmelementRegistrationInFSS): STRING[];
 BEGIN
  RETURN L_Prop.getRES(GetProValueStrong(trgMyFirm, trgDate, P_RegistrationInFSS), trgElement);
 END {GetElement_RegistrationInFSS};

 PUBLIC PROCEDURE OKVED_Code(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN GetElement_RegistrationInFSS(trgMyFirm, D, erfss_OKVED);
 END {OKVED_Code};

 PUBLIC PROCEDURE OKVED_Name(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN GetElement_RegistrationInFSS(trgMyFirm, D, erfss_OKVEDName);
 END {OKVED_Name};

 PUBLIC PROCEDURE FSSRegistrationCode(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN GetElement_RegistrationInFSS(trgMyFirm, D, erfss_RegistrationCode);
 END {FSSRegistrationCode};

 PUBLIC PROCEDURE FSSSubordinationCode(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN GetElement_RegistrationInFSS(trgMyFirm, D, erfss_SubordinationCode);
 END {FSSSubordinationCode};

 PUBLIC PROCEDURE TravmObligTariff(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): tTravmObligTariff;
 BEGIN
  RETURN STRTOFLD(GetElement_RegistrationInFSS(trgMyFirm, D, erfss_TravmObligTariff), NUMERIC);
 END {TravmObligTariff};

 PUBLIC PROCEDURE TravmObligTariffInc(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): tTravmObligTariffInc;
 BEGIN
  RETURN STRTOFLD(GetElement_RegistrationInFSS(trgMyFirm, D, erfss_TravmObligTariffInc), NUMERIC);
 END {TravmObligTariffInc};

 PUBLIC PROCEDURE FSSSupplementaryCode(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN GetElement_RegistrationInFSS(trgMyFirm, D, erfss_SupplementaryCode);
 END {FSSSupplementaryCode};

 PUBLIC PROCEDURE FSSName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN GetElement_RegistrationInFSS(trgMyFirm, D, erfss_FSSName);
 END {FSSName};

 PUBLIC PROCEDURE IsUSNO(tm: tTaxationMode): SCAL[2];
 BEGIN
  RETURN (tm = tm_USNO_Income) | (tm = tm_USNO_IncomeWOCharge);
 END {IsUSNO};

 PUBLIC PROCEDURE GetTaxationMode(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): tTaxationMode;
 BEGIN
  IF HasActualPro(trgMyFirm, D, P_TaxationMode) THEN
   RETURN L_Prop.GetProValueAsScal(tm_Pool, MFPro.Value);
  ELSE
   RETURN tm_Common;
  END;
 END {GetTaxationMode};

 PRIVATE PROCEDURE StaffName(trgTSN: LIKE(Staff.TSN); D: DATE): STRING[];
 BEGIN
  RETURN P_Firm.GetManAttrByTSN(trgTSN, D, P_Firm.mpt_ManName);
 END {StaffName};

 PRIVATE PROCEDURE StaffPostName(trgTSN: LIKE(Staff.TSN); D: DATE): STRING[];
 BEGIN
  RETURN P_Firm.GetManAttrByTSN(trgTSN, D, P_Firm.mpt_ManPostName);
 END {StaffPostName};

 PRIVATE PROCEDURE StaffExtWrkTel(trgTSN: LIKE(Staff.TSN); D: DATE): STRING[];
 BEGIN
  RETURN P_Firm.GetManAttrByTSN(trgTSN, D, P_Firm.mpt_ManExtWrkTel);
 END {StaffExtWrkTel};

 PUBLIC PROCEDURE GetTSNByMFPro(trgMyFirm  : LIKE(MyFirm.MyFirm);
                                D          : DATE;
                                trgProperty: LIKE(Property.Property);
                                Strong     : SCAL[2]): LIKE(Staff.TSN);
 BEGIN
  RETURN GetProValue(trgMyFirm, D, trgProperty, Strong);
 END {GetTSNByMFPro};

 PUBLIC PROCEDURE StaffDepChiefName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffName(GetTSNByMFPro(trgMyFirm, D, P_StaffDepChief, 1), D);
 END {StaffDepChiefName};

 PUBLIC PROCEDURE StaffDepChiefPostName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffPostName(GetTSNByMFPro(trgMyFirm, D, P_StaffDepChief, 1), D);
 END {StaffDepChiefPostName};

 PUBLIC PROCEDURE MainEngineerName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffName(GetTSNByMFPro(trgMyFirm, D, P_MainEngineer, 1), D);
 END {MainEngineerName};

 PUBLIC PROCEDURE MainEngineerPostName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffPostName(GetTSNByMFPro(trgMyFirm, D, P_MainEngineer, 1), D);
 END {MainEngineerPostName};

 PUBLIC PROCEDURE MainEconomistName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffName(GetTSNByMFPro(trgMyFirm, D, P_MainEconomist, 1), D);
 END {MainEconomistName};

 PUBLIC PROCEDURE MainEconomistPostName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffPostName(GetTSNByMFPro(trgMyFirm, D, P_MainEconomist, 1), D);
 END {MainEconomistPostName};

 PUBLIC PROCEDURE TaxCardResp(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   _TSN: LIKE(Staff.TSN);
 BEGIN
  _TSN:=GetTSNByMFPro(trgMyFirm, D, P_TaxCardResp, 1);
  RETURN StaffPostName(_TSN, D) + ";" + StaffName(_TSN, D);
 END {TaxCardResp};

 PUBLIC PROCEDURE TaxCardCont(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   _TSN: LIKE(Staff.TSN);
 BEGIN
  _TSN:=GetTSNByMFPro(trgMyFirm, D, P_TaxCardCont, 0);
  IF ~!_TSN THEN
   RETURN StaffPostName(_TSN, D) + ";" + StaffName(_TSN, D);
  ELSE
   RETURN L_PCS.GetPostNameOfCurrentUser(D) + ";" + L_PCS.GetFullNameOfCurrentUser(D);
  END;
 END {TaxCardCont};

 PUBLIC PROCEDURE Tax3Sender(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   _TSN: LIKE(Staff.TSN);
 BEGIN
  _TSN:=GetTSNByMFPro(trgMyFirm, D, P_Tax3Sender, 1);
  RETURN StaffPostName(_TSN, D) + ";" + StaffName(_TSN, D);
 END {Tax3Sender};

 PUBLIC PROCEDURE Tax3SenderPostName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffPostName(GetTSNByMFPro(trgMyFirm, D, P_Tax3Sender, 1), D);
 END {Tax3SenderPostName};

 PUBLIC PROCEDURE Tax3SenderName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffName(GetTSNByMFPro(trgMyFirm, D, P_Tax3Sender, 1), D);
 END {Tax3SenderName};

 PUBLIC PROCEDURE Tax3SenderPhone(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffExtWrkTel(GetTSNByMFPro(trgMyFirm, D, P_Tax3Sender, 1), D);
 END {Tax3SenderPhone};

 PUBLIC PROCEDURE AnkSender(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   _TSN: LIKE(Staff.TSN);
 BEGIN
  _TSN:=GetTSNByMFPro(trgMyFirm, D, P_AnkSender, 1);
  RETURN StaffPostName(_TSN, D) + ";" + StaffName(_TSN, D) + ";" + StaffExtWrkTel(_TSN, D);
 END {AnkSender};

 PUBLIC PROCEDURE AnkSenderName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffName(GetTSNByMFPro(trgMyFirm, D, P_AnkSender, 1), D);
 END {AnkSenderName};

 PUBLIC PROCEDURE AnkSenderPostName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffPostName(GetTSNByMFPro(trgMyFirm, D, P_AnkSender, 1), D);
 END {AnkSenderPostName};

 PUBLIC PROCEDURE PFRInsSender(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   _TSN: LIKE(Staff.TSN);
 BEGIN
  _TSN:=GetTSNByMFPro(trgMyFirm, D, P_PFRInsSender, 1);
  RETURN StaffPostName(_TSN, D) + ";" + StaffName(_TSN, D) + ";" + StaffExtWrkTel(_TSN, D);
 END {PFRInsSender};

 PUBLIC PROCEDURE STxCont(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   _TSN: LIKE(Staff.TSN);
 BEGIN
  _TSN:=GetTSNByMFPro(trgMyFirm, D, P_STxCont, 1);
  RETURN StaffPostName(_TSN, D) + ";" + StaffName(_TSN, D) + ";" + StaffExtWrkTel(_TSN, D);
 END {STxCont};

 PUBLIC PROCEDURE CashName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffName(GetTSNByMFPro(trgMyFirm, D, P_Cashier, 1), D);
 END {CashName};

 PUBLIC PROCEDURE AcntCashName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffName(GetTSNByMFPro(trgMyFirm, D, P_AcntCashier, 1), D);
 END {AcntCashName};

 PUBLIC PROCEDURE LegalDepChiefName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffName(GetTSNByMFPro(trgMyFirm, D, P_LegalDepChief, 1), D);
 END {LegalDepChiefName};

 PUBLIC PROCEDURE LegalDepChiefName_Soft(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   _TSN: LIKE(Staff.TSN);
 BEGIN
  _TSN:=GetTSNByMFPro(trgMyFirm, D, P_LegalDepChief, 0);
  IF ~!_TSN THEN
   RETURN StaffName(_TSN, D);
  ELSE
   RETURN "";
  END;
 END {LegalDepChiefName_Soft};

 PUBLIC PROCEDURE LegalDepChiefPostName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
 BEGIN
  RETURN StaffPostName(GetTSNByMFPro(trgMyFirm, D, P_LegalDepChief, 1), D);
 END {LegalDepChiefPostName};

 PUBLIC PROCEDURE PropertyTax(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE; VAR PropTaxCode: tPropTaxCode; VAR PropTaxRate: tPropTaxRate);
 BEGIN
  Decode_PropertyTax(GetProValueStrong(trgMyFirm, D, P_PropertyTax), PropTaxCode, PropTaxRate);
 END {PropertyTax};

 PUBLIC PROCEDURE TaxDep(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   trgUltimateTaxDepCode: tTaxDepCode;
   trgUltimateTaxDep    : STRING[];
   trgIntermedTaxDepCode: tTaxDepCode;
   trgIntermedTaxDep    : STRING[];
 BEGIN
  Decode_TaxDep(GetProValueStrong(trgMyFirm, D, P_TaxDep), trgUltimateTaxDepCode, trgUltimateTaxDep, trgIntermedTaxDepCode, trgIntermedTaxDep);
  RETURN trgUltimateTaxDep;
 END {TaxDep};

 PUBLIC PROCEDURE TaxDepCode(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): tTaxDepCode;
  VAR
   trgUltimateTaxDepCode: tTaxDepCode;
   trgUltimateTaxDep    : STRING[];
   trgIntermedTaxDepCode: tTaxDepCode;
   trgIntermedTaxDep    : STRING[];
 BEGIN
  Decode_TaxDep(GetProValueStrong(trgMyFirm, D, P_TaxDep), trgUltimateTaxDepCode, trgUltimateTaxDep, trgIntermedTaxDepCode, trgIntermedTaxDep);
  RETURN trgUltimateTaxDepCode;
 END {TaxDepCode};

 PUBLIC PROCEDURE IntermedTaxDepCode(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): tTaxDepCode;
  VAR
   trgUltimateTaxDepCode: tTaxDepCode;
   trgUltimateTaxDep    : STRING[];
   trgIntermedTaxDepCode: tTaxDepCode;
   trgIntermedTaxDep    : STRING[];
 BEGIN
  Decode_TaxDep(GetProValueStrong(trgMyFirm, D, P_TaxDep), trgUltimateTaxDepCode, trgUltimateTaxDep, trgIntermedTaxDepCode, trgIntermedTaxDep);
  IF ~!trgIntermedTaxDepCode THEN
   RETURN trgIntermedTaxDepCode;
  ELSE
   RETURN trgUltimateTaxDepCode;
  END;
 END {IntermedTaxDepCode};

 PRIVATE PROCEDURE SetPensFundData(VAR _NumInPFR: tNumInPFR; VAR _PFRDepName: STRING[]);
 BEGIN
  _NumInPFR  :=L_Prop.getRES(MFPro.Value, 0);
  _PFRDepName:=L_Prop.getRES(MFPro.Value, 1);
 END {SetPensFundData};

 PUBLIC PROCEDURE NumInPFR(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): tNumInPFR;
  VAR
   Dummy      : LIKE(MFPro.Value);
   _NumInPFR  : tNumInPFR;
   _PFRDepName: STRING[];
 BEGIN
  Dummy:=GetProValueStrong(trgMyFirm, D, P_PensFund);
  SetPensFundData(_NumInPFR, _PFRDepName);
  RETURN _NumInPFR;
 END {NumInPFR};

 PUBLIC PROCEDURE PFRDepName(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   Dummy      : LIKE(MFPro.Value);
   _NumInPFR  : tNumInPFR;
   _PFRDepName: STRING[];
 BEGIN
  Dummy:=GetProValueStrong(trgMyFirm, D, P_PensFund);
  SetPensFundData(_NumInPFR, _PFRDepName);
  L_General.Assert(~!_PFRDepName, " ᢮⢥ "+FLDTOSTR(P_PensFund, "")+" '' ࣠樨 " + trgMyFirm +
                   "| । 祭  ' ਠ쭮 ࣠ '");
  RETURN _PFRDepName;
 END {PFRDepName};

 PRIVATE PROCEDURE SetMSTFData(VAR NumInMSTF: STRING[]; VAR MSTFName: STRING[]);
 BEGIN
  NumInMSTF:=L_Prop.getRES(MFPro.Value, 0);
  MSTFName :=L_Prop.getRES(MFPro.Value, 1);
 END {SetPensFundData};

 PUBLIC PROCEDURE NumInMSTF(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   Dummy,
   NumInMSTF,
   MSTFName: STRING[];
 BEGIN
  Dummy:=GetProValueStrong(trgMyFirm, D, P_MSTF);
  SetMSTFData(NumInMSTF, MSTFName);
  RETURN NumInMSTF;
 END {NumInMSTF};

 PUBLIC PROCEDURE P_8002_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="ObjPro";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iUnmodifiable(0, ["ObjectTitle", "ObjectDescr"]);
  L_WDO.iMayBeEmpty  (0, ["FSSSupplementaryCode", "TravmObligTariffInc"]);
  L_WDO.iProgs       (0, "ObjPro");
 END {P_8002_OnInitializeWindow};

 PUBLIC PROCEDURE OKOPF_Code(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   OKOGU,
   OKFS,
   OKFSName,
   OKOPF,
   OKOPFName: STRING[];
 BEGIN
  Decode_StatisticRegister(GetProValueStrong(trgMyFirm, D, P_StatisticRegister),
                           OKOGU, OKFS, OKFSName, OKOPF, OKOPFName);
  RETURN OKOPF;
 END {OKOPF_Code};

 PUBLIC PROCEDURE OKOPF_Name(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   OKOGU,
   OKFS,
   OKFSName,
   OKOPF,
   OKOPFName: STRING[];
 BEGIN
  Decode_StatisticRegister(GetProValueStrong(trgMyFirm, D, P_StatisticRegister),
                           OKOGU, OKFS, OKFSName, OKOPF, OKOPFName);
  RETURN OKOPFName;
 END {OKOPF_Name};

 PUBLIC PROCEDURE OKFS_Code(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   OKOGU,
   OKFS,
   OKFSName,
   OKOPF,
   OKOPFName: STRING[];
 BEGIN
  Decode_StatisticRegister(GetProValueStrong(trgMyFirm, D, P_StatisticRegister),
                           OKOGU, OKFS, OKFSName, OKOPF, OKOPFName);
  RETURN OKFS;
 END {OKFS_Code};

 PUBLIC PROCEDURE OKFS_Name(trgMyFirm: LIKE(MyFirm.MyFirm); D: DATE): STRING[];
  VAR
   OKOGU,
   OKFS,
   OKFSName,
   OKOPF,
   OKOPFName: STRING[];
 BEGIN
  Decode_StatisticRegister(GetProValueStrong(trgMyFirm, D, P_StatisticRegister),
                           OKOGU, OKFS, OKFSName, OKOPF, OKOPFName);
  RETURN OKFSName;
 END {OKFS_Name};

END.
