(*
%Copyright   (c) Polak IT
%Author      30.07.2012 14:02:23 POLAK\Gina
%Purpose     ⢠ ⮯ ந⢥ 頤
%Type        library
%Specific    SYS
%Modified    13.02.2014 14:08:36 POLAK\LDA
%Environment
*)

 MODULE P_MyPlc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  P_OKTMO = 5600;

 IMPORT L_Prop, L_r2r, P_Firm;

 PUBLIC PROCEDURE HasPro(trgMyPlace : LIKE(MPPro.MyPlace);
                         trgDate    : DATE;
                         trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SELECT(MPPro, MyPlace, trgMyPlace, trgProperty) & SRCINSEL(MPPro, LE, trgDate);
 END {HasPro};

 PUBLIC PROCEDURE HasActualPro(trgMyPlace : LIKE(MPPro.MyPlace);
                               trgDate    : DATE;
                               trgProperty: LIKE(Property.Property)):  SCAL[2];
 BEGIN
  RETURN HasPro(trgMyPlace, trgDate, trgProperty) & (!MPPro.DocExpD | (trgDate < MPPro.DocExpD));
 END {HasActualPro};

 PRIVATE PROCEDURE GetProValue(trgMyPlace       : LIKE(MPPro.MyPlace);
                               trgDate          : DATE;
                               trgProperty      : LIKE(Property.Property);
                               PresenceCondition: L_Prop.tPresenceCondition): STRING[];
  VAR
   Result: LIKE(MPPro.Value);
 BEGIN
  IF HasActualPro(trgMyPlace, trgDate, trgProperty) THEN
   Result:=MPPro.Value;
  ELSE
   IF PresenceCondition = L_Prop.pc_Strong THEN
    SEARCH(MyPlace, MyPlace, , trgMyPlace);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("MyPlace").Id, MyPlace.RECORDID, trgProperty, trgDate);
   ELSE
    SETEMPTY(Result);
   END; (* IF *)
  END; (* IF *)
  RETURN Result;
 END {GetProValue};

 PUBLIC PROCEDURE GetProValueSoft(trgMyPlace : LIKE(MPPro.MyPlace);
                                  trgDate    : DATE;
                                  trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetProValue(trgMyPlace, trgDate, trgProperty, L_Prop.pc_Soft);
 END {GetProValueSoft};

 PUBLIC PROCEDURE GetProValueStrong(trgMyPlace : LIKE(MPPro.MyPlace);
                                    trgDate    : DATE;
                                    trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetProValue(trgMyPlace, trgDate, trgProperty, L_Prop.pc_Strong);
 END {GetProValueStrong};

 PUBLIC PROCEDURE GetP_OKTMO(trgMyFirm: P_Firm.tMyFirm; trgMyPlace: LIKE(MPPro.MyPlace); trgDate: DATE): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF ~!trgMyPlace & (trgMyPlace # P_Firm.mp_Fict) THEN
   SAVE(MyPlace);
   SEARCH(MyPlace, MyPlace, , trgMyPlace);
   IF MyPlace.wMySite THEN
    Result:=GetProValueStrong(trgMyPlace, trgDate, P_OKTMO);
   END;
   RESTORE(MyPlace);
  END;
  IF !Result THEN
   Result:=GetProValueStrong(P_Firm.GetMainMyPlace(trgDate, trgMyFirm), trgDate, P_OKTMO);
  END;
  RETURN Result;
 END {GetP_OKTMO};

 (*!!!*)PUBLIC PROCEDURE GetP_OKATO(trgMyFirm: P_Firm.tMyFirm; trgMyPlace: LIKE(MPPro.MyPlace); trgDate: DATE): STRING[];
 BEGIN
  RETURN GetP_OKTMO(trgMyFirm, trgMyPlace, trgDate);
 END {GetP_OKATO};

END.
