(*
%Copyright   (c) Polak IT
%Author      14.08.2012 11:07:35 POLAK\Gina
%Purpose     ⢠ ந⢥ 頤
%Type        library
%Specific    SYS
%Modified    11.03.2014 20:13:37 POLAK\Gina
%Environment
*)

 MODULE P_MySite [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  P_KPP = 5601;

 IMPORT L_Prop, L_r2r, P_Firm, L_DatTim, L_General;

 PUBLIC PROCEDURE HasPro(trgMySite  : LIKE(MySite.MySite);
                         trgDate    : DATE;
                         trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SELECT(MSPro, MySite, trgMySite, trgProperty) & SRCINSEL(MSPro, LE, trgDate);
 END {HasPro};

 PUBLIC PROCEDURE HasActualPro(trgMySite  : LIKE(MySite.MySite);
                               trgDate    : DATE;
                               trgProperty: LIKE(Property.Property)):  SCAL[2];
 BEGIN
  RETURN HasPro(trgMySite, trgDate, trgProperty) & (!MSPro.DocExpD | (trgDate < MSPro.DocExpD));
 END {HasActualPro};

 PRIVATE PROCEDURE GetProValue(trgMySite        : LIKE(MySite.MySite);
                               trgDate          : DATE;
                               trgProperty      : LIKE(Property.Property);
                               PresenceCondition: L_Prop.tPresenceCondition): STRING[];
  VAR
   Result: LIKE(MSPro.Value);
 BEGIN
  IF HasActualPro(trgMySite, trgDate, trgProperty) THEN
   Result:=MSPro.Value;
  ELSE
   IF PresenceCondition = L_Prop.pc_Strong THEN
    SEARCH(MySite, MySite, , trgMySite);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("MySite").Id, MySite.RECORDID, trgProperty, trgDate);
   ELSE
    SETEMPTY(Result);
   END; (* IF *)
  END; (* IF *)
  RETURN Result;
 END {GetProValue};

 PUBLIC PROCEDURE GetProValueSoft(trgMySite  : LIKE(MySite.MySite);
                                  trgDate    : DATE;
                                  trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetProValue(trgMySite, trgDate, trgProperty, L_Prop.pc_Soft);
 END {GetProValueSoft};

 PUBLIC PROCEDURE GetProValueStrong(trgMySite  : LIKE(MySite.MySite);
                                    trgDate    : DATE;
                                    trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetProValue(trgMySite, trgDate, trgProperty, L_Prop.pc_Strong);
 END {GetProValueStrong};

 PRIVATE PROCEDURE CheckMSPro(trgMySite: LIKE(MySite.MySite); trgDate: DATE; trgProperty: LIKE(Property.Property));
 BEGIN
  IF ~HasPro(trgMySite, trgDate, trgProperty) THEN
   SEARCH(MySite, MySite, , trgMySite);
   L_Prop.ShowUndefinedProValueError(TABLE.Get("MySite").Id, MySite.RECORDID, trgProperty, trgDate);
  END;
 END {CheckMSPro};

 PUBLIC PROCEDURE GetMySite(trgMyFirm: P_Firm.tMyFirm; trgMyPlace: LIKE(MyPlace.MyPlace); trgDate: DATE): LIKE(MySite.MySite);
  VAR
   Result: LIKE(MySite.MySite);
   Cnt   : NUMERIC[0];
 BEGIN
  SETEMPTY(Result);
  IF ~!trgMyPlace & (trgMyPlace # P_Firm.mp_Fict) THEN
   SAVE(MyPlace);
   SEARCH(MyPlace, MyPlace, , trgMyPlace);
   IF MyPlace.wMySite THEN
    Cnt:=0;
    SELECT(MySite, MyPlace, , trgMyPlace);
    WHILE OCCURE(MySite) DO
     IF (MySite.MyFirm = trgMyFirm) & L_DatTim.IsActive(trgDate, MySite.Begin, MySite.Till) THEN
      Result:=MySite.MySite;
      INC(Cnt);
     END;
     NEXT(MySite);
    END; (* WHILE OCCURE(MySite) ... *)
    IF Cnt = 0 THEN
     L_General.Error("'⮯ 頤' " + trgMyPlace + "  '' " + trgMyFirm + " ᮢ⨬");
    ELSE
     L_General.CallUs(Cnt = 1);
    END;
   END; (* IF MyPlace.wMySite... *)
   RESTORE(MyPlace);
  END;
  IF !Result THEN
   Result:=P_Firm.GetMainMySite(trgDate, trgMyFirm);
  END;
  RETURN Result;
 END {GetMySite};

 PUBLIC PROCEDURE GetMSProDocExpD(trgMyFirm: P_Firm.tMyFirm; trgMyPlace: LIKE(MyPlace.MyPlace); trgDate: DATE; trgProperty: LIKE(Property.Property)): DATE;
 BEGIN
  CheckMSPro(GetMySite(trgMyFirm, trgMyPlace, trgDate), trgDate, trgProperty);
  RETURN MSPro.DocExpD;
 END {GetMSProDocExpD};

 PUBLIC PROCEDURE GetMSProDocNum(trgMyFirm: P_Firm.tMyFirm; trgMyPlace: LIKE(MyPlace.MyPlace); trgDate: DATE; trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  CheckMSPro(GetMySite(trgMyFirm, trgMyPlace, trgDate), trgDate, trgProperty);
  RETURN MSPro.DocNum;
 END {GetMSProDocNum};

 PUBLIC PROCEDURE GetMSProDocGiveS(trgMyFirm: P_Firm.tMyFirm; trgMyPlace: LIKE(MyPlace.MyPlace); trgDate: DATE; trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  CheckMSPro(GetMySite(trgMyFirm, trgMyPlace, trgDate), trgDate, trgProperty);
  RETURN MSPro.DocGiveS;
 END {GetMSProDocGiveS};

 PUBLIC PROCEDURE GetMSProDocGiveD(trgMyFirm: P_Firm.tMyFirm; trgMyPlace: LIKE(MyPlace.MyPlace); trgDate: DATE; trgProperty: LIKE(Property.Property)): DATE;
 BEGIN
  CheckMSPro(GetMySite(trgMyFirm, trgMyPlace, trgDate), trgDate, trgProperty);
  RETURN MSPro.DocGiveD;
 END {GetMSProDocGiveD};

 PUBLIC PROCEDURE GetP_KPP(trgMyFirm: P_Firm.tMyFirm; trgMyPlace: LIKE(MyPlace.MyPlace); trgDate: DATE): STRING[];
 BEGIN
  RETURN GetProValueStrong(GetMySite(trgMyFirm, trgMyPlace, trgDate), trgDate, P_KPP);
 END {GetP_KPP};

END.