(*
%Copyright   (c) Polak Computer System
%Author      29.08.2000 12:42:38 GINA
%Purpose     ⥪  ࠡ  ᢮⢠ OfcPro
%Type        library
%Specific    SYS
%Modified    18.09.2014 15:50:31 POLAK\Gina
%Environment
*)

 MODULE P_Officer [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  P_VacancyAmount      = 3999;
  P_MedExamination     = 4010;
  P_MedBook            = 4011;
  P_KindOfWork         = 4013;
  P_OfcBonus           = 4020;
  P_OfcHarm            = 4021;
  P_OfcIntens          = 4022;
  P_OfcHarmFactor      = 4023;
  P_YPScale            = 4024;
  P_MantoManDefenceAss = 4025;
  P_EarningValue       = 4030;
  P_SpecialSTx         = 4050;
  P_AuthorizedStorages = 4051;
  P_CommercInfAccess   = 4052;
  P_AveIndexation      = 4053;
  P_PersonalInfAccess  = 4054;
  P_CertificatLbrCond  = 4055;
  P_LabourConditions   = 4056;

  vim_byWhole      = 0;
  vim_byClass      = 1;
  vim_notDefine    = 2;

  oct_AllClasses   = 0;

  ost_NoShift      = 0;
  ost_AllShifts    = 99;

  ClassAmount   = 8+1;
  ShiftAmount   = 9(*4*)+1;
  VacancyAmount = ClassAmount*ShiftAmount;
  mmda_Amount   = 15;
  ob_Amount     = 6;

 PRIVATE CONST
  as_Amount       = 10;
  pool_KindOfWork = 0000954;

  v_DirtyTyp = "DirtyTyp";

 PUBLIC TYPE
  tVacancyInfillMethod = SCAL[3];
  tOfficerShiftType    = SCAL[100];
  tVacancyConception   = NUMERIC[4, 1][VacancyAmount];
  tStorages            = LIKE(Storage.Storage)[as_Amount];
  tmmdaAmnt            = NUMERIC[2];
  tSpecialEvaluation   = SCAL[2];

 IMPORT L_Prop, L_General, L_DatTim, L_StdFrm, L_Str, L_Stock, L_Pool, P_Union,
        Math, FIO, Str, L_WDO, L_r2r, L_ACL, L_FIO, E_PRoll, L_Staff;

 PRIVATE TYPE
  tOfcBonus = NUMERIC[3][ob_Amount];

 PRIVATE CONST
  Pool_ClassSign = "|1|2|3|4|5|6|7|8";
  wofaha_Pool    = "|";

 PUBLIC PROCEDURE PropertyModificationAllowed(trgProperty: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF    trgProperty = P_LabourConditions THEN
   RETURN L_Prop.mac_Inside;
  ELSE
   RETURN L_Prop.mac_Full;
  END;
 END {PropertyModificationAllowed};

 PUBLIC PROCEDURE GetSubWindowName(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_OfcBonus           THEN RETURN "P_4020";
  ELSIF trgProperty = P_MantoManDefenceAss THEN RETURN "P_4025";
  ELSIF trgProperty = P_VacancyAmount      THEN RETURN "P_3999";
  ELSIF trgProperty = P_EarningValue       THEN RETURN "P_4030";
  ELSIF trgProperty = P_AuthorizedStorages THEN RETURN "P_4051";
  ELSIF trgProperty = P_AveIndexation      THEN RETURN "P_4053";
  ELSIF trgProperty = P_LabourConditions   THEN RETURN "P_4056";
  ELSE                                          RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE GetPool(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_MedExamination THEN
   RETURN "ਮ᪨||ਮ᪨  ";
  ELSIF trgProperty = P_MedBook THEN
   RETURN "|";
  ELSIF trgProperty = P_SpecialSTx THEN
   RETURN "|";
  ELSIF trgProperty = P_CommercInfAccess THEN
   RETURN "࠭祭|";
  ELSIF trgProperty = P_KindOfWork THEN
   RETURN L_Pool.Get(pool_KindOfWork);
  ELSIF trgProperty = P_PersonalInfAccess THEN
   RETURN "|";
  ELSIF L_Prop.IsLocalProperty(trgProperty) THEN
   RETURN L_Prop.E_GetPool(trgProperty);
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PRIVATE PROCEDURE NeedFullMonth(trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN ((P_OfcBonus <= trgProperty) & (trgProperty <= P_YPScale)) |
         (trgProperty = P_EarningValue) | (trgProperty = P_SpecialSTx) | (trgProperty = P_AveIndexation) |
         L_Prop.IsLocalProperty(trgProperty);
 END {NeedFullMonth};

 PUBLIC PROCEDURE CheckExpValidity(trgProperty: LIKE(Property.Property); trgDate, trgDocExpD: DATE);
 BEGIN
  IF NeedFullMonth(trgProperty) THEN
   L_General.Assert((trgDate=L_DatTim.MonthBeg(trgDate)) & (!trgDocExpD | (trgDocExpD=L_DatTim.MonthBeg(trgDocExpD))),
                    "⢮  ⢮ 楫 ᫮ 楢");
  END;
 END {CheckExpValidity};

 PUBLIC PROCEDURE Check(trgProperty: LIKE(Property.Property));
  VAR
   JobDescrName: STRING[];
 BEGIN
  CheckExpValidity(trgProperty, OfcPro.Date, OfcPro.DocExpD);
  IF    (trgProperty = P_OfcHarm)    |
        (trgProperty = P_OfcIntens)  |
        (trgProperty = P_OfcHarmFactor) THEN
   L_Prop.CheckNumericValue(OfcPro.Value, "");
  END;
 END {Check};

 PUBLIC PROCEDURE HasPro(trgSort    : LIKE(Sort.Sort);
                         trgOfficer : LIKE(Officer.Officer);
                         D          : DATE;
                         trgProperty: LIKE(Property.Property);
                         dsc        : L_Prop.tOnDateSearchCondition): SCAL[2];
 BEGIN
  IF dsc = L_Prop.dsc_Exactly THEN
   L_General.CallUs(D = L_DatTim.Per(D));
  END;
  SELECT(OfcPro, Officer, , trgSort, trgOfficer, trgProperty);
  IF     dsc = L_Prop.dsc_Normal THEN
   SRCINSEL(OfcPro, LE, , D);
  ELSIF (dsc = L_Prop.dsc_Exactly) |
        (dsc = L_Prop.dsc_Exactly_OnAnyDate) THEN
   SRCINSEL(OfcPro, EQ, , D);
  ELSE
   L_General.CallUs(0);
  END;
  RETURN OCCURE(OfcPro);
 END {HasPro};

 PUBLIC PROCEDURE HasActualPro(trgSort    : LIKE(Sort.Sort);
                               trgOfficer : LIKE(Officer.Officer);
                               D          : DATE;
                               trgProperty: LIKE(Property.Property);
                               dsc        : L_Prop.tOnDateSearchCondition): SCAL[2];
 BEGIN
  RETURN HasPro(trgSort, trgOfficer, D, trgProperty, dsc) &
         (!OfcPro.DocExpD | (D < OfcPro.DocExpD));
 END {HasActualPro};

 PUBLIC PROCEDURE HasActualPro_Normal(trgSort    : LIKE(Sort.Sort);
                                      trgOfficer : LIKE(Officer.Officer);
                                      D          : DATE;
                                      trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasActualPro(trgSort, trgOfficer, D, trgProperty, L_Prop.dsc_Normal);
 END {HasActualPro_Normal};

(*!!!*) PUBLIC PROCEDURE HasActualOfcPro(trgSort    : LIKE(Sort.Sort);
                                         trgOfficer : LIKE(Officer.Officer);
                                         D          : DATE;
                                         trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasActualPro_Normal(trgSort, trgOfficer, D, trgProperty);
 END {HasActualOfcPro};

 PUBLIC PROCEDURE GetProValue(trgSort    : LIKE(Sort.Sort);
                              trgOfficer : LIKE(Officer.Officer);
                              D          : DATE;
                              trgProperty: LIKE(Property.Property);
                              dsc        : L_Prop.tOnDateSearchCondition;
                              pc         : L_Prop.tPresenceCondition): LIKE(OfcPro.Value);
 BEGIN
  IF HasActualPro(trgSort, trgOfficer, D, trgProperty, dsc) THEN
   RETURN OfcPro.Value;
  ELSE
   IF pc = L_Prop.pc_Strong THEN
    SEARCH(Officer, Officer, , trgSort, trgOfficer);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("Officer").Id, Officer.RECORDID, trgProperty, D);
   ELSE
    RETURN "";
   END;
  END;
 END {GetProValue};

 PUBLIC PROCEDURE GetProValueStrong(trgSort    : LIKE(Sort.Sort);
                                    trgOfficer : LIKE(Officer.Officer);
                                    D          : DATE;
                                    trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetProValue(trgSort, trgOfficer, D, trgProperty, L_Prop.dsc_Normal, L_Prop.pc_Strong);
 END {GetProValueStrong};

(*!!!*) PUBLIC PROCEDURE GetOfcProSoft(trgSort    : LIKE(Sort.Sort);
                                       trgOfficer : LIKE(Officer.Officer);
                                       D          : DATE;
                                       trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetProValue(trgSort, trgOfficer, D, trgProperty, L_Prop.dsc_Normal, L_Prop.pc_Soft);
 END {GetOfcProSoft};

 PUBLIC PROCEDURE GetProValueSoft(trgSort    : LIKE(Sort.Sort);
                                  trgOfficer : LIKE(Officer.Officer);
                                  D          : DATE;
                                  trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetProValue(trgSort, trgOfficer, D, trgProperty, L_Prop.dsc_Normal, L_Prop.pc_Soft);
 END {GetProValueSoft};

 PRIVATE PROCEDURE GetClassSign(trgClass: NUMERIC[0]): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(Pool_ClassSign, trgClass);
 END {GetClassSign};

 PRIVATE PROCEDURE GetClassSignFromStr(Value: STRING[]): STRING[];
 BEGIN
  RETURN Str.Item(Value, "[", 0);
 END {GetClassSignFromStr};

 PRIVATE PROCEDURE InfillMethodVacancy_ByClass(Value: STRING[]): SCAL[2];
 BEGIN
  RETURN Str.Cap(GetClassSignFromStr(Value)) # Str.Cap(GetClassSign(0));
 END {InfillMethodVacancy_ByClass};

 PUBLIC PROCEDURE GetInfillMethodOfVacancy(trgSort   : LIKE(Sort.Sort);
                                           trgOfficer: LIKE(Officer.Officer);
                                           D         : DATE): tVacancyInfillMethod;
 BEGIN
  IF ~HasActualPro_Normal(trgSort, trgOfficer, D, P_VacancyAmount) THEN
   RETURN vim_notDefine;
  ELSIF InfillMethodVacancy_ByClass(OfcPro.Value) THEN
   RETURN vim_byClass;
  ELSE
   RETURN vim_byWhole;
  END;
 END {GetInfillMethodOfVacancy};

 PUBLIC PROCEDURE PrepareVacancyConception(    trgSort   : LIKE(Sort.Sort);
                                               trgOfficer: LIKE(Officer.Officer);
                                               D         : DATE;
                                           VAR VC        : tVacancyConception): SCAL[2];
  VAR
   FillByClass: SCAL[2];
 BEGIN
  IF HasActualPro_Normal(trgSort, trgOfficer, D, P_VacancyAmount) THEN
   SETZERO(VC);
   Decode_VacancyAmount(OfcPro.Value, VC, FillByClass);
   RETURN 1;
  ELSE
   SETEMPTY(VC);
   RETURN 0;
  END;
 END {PrepareVacancyConception};

 PUBLIC PROCEDURE extGetVacancyAmount(VC      : tVacancyConception;
                                      trgClass: LIKE(StaffLog.Class);
                                      trgShift: tOfficerShiftType): NUMERIC[2];
  VAR
   fromClass,
   uptoClass,
   fromShift,
   uptoShift: NUMERIC[0];
   Result   : NUMERIC[2];
 BEGIN
  Result:=0;
  IF trgClass = oct_AllClasses THEN
   fromClass:=0;
   uptoClass:=ClassAmount;
  ELSE
   fromClass:=trgClass;
   uptoClass:=fromClass+1;
  END;
  WHILE fromClass < uptoClass DO
   IF trgShift = ost_AllShifts THEN
    fromShift:=0;
    uptoShift:=ShiftAmount;
   ELSE
    fromShift:=trgShift;
    uptoShift:=fromShift+1;
   END;
   WHILE fromShift < uptoShift DO
    INC(Result, VC[fromClass * ShiftAmount + fromShift]);
    INC(fromShift);
   END; (* WHILE fromShift <... *)
   INC(fromClass);
  END; (* WHILE fromClass <...*)
  RETURN Result;
 END {extGetVacancyAmount};

 PRIVATE PROCEDURE intGetVacancyAmount(trgSort   : LIKE(Sort.Sort);
                                       trgOfficer: LIKE(Officer.Officer);
                                       D         : DATE;
                                       trgClass  : LIKE(StaffLog.Class);
                                       trgShift  : tOfficerShiftType): NUMERIC[2];
  VAR
   VC: tVacancyConception;
 BEGIN
  IF PrepareVacancyConception(trgSort, trgOfficer, D, VC) THEN
   RETURN extGetVacancyAmount(VC, trgClass, trgShift);
  ELSE
   RETURN 0;
  END;
 END {intGetVacancyAmount};

 PUBLIC PROCEDURE GetVacancyAmount(trgSort   : LIKE(Sort.Sort);
                                   trgOfficer: LIKE(Officer.Officer);
                                   D         : DATE;
                                   trgClass  : LIKE(StaffLog.Class)): NUMERIC[2];
 BEGIN
  RETURN intGetVacancyAmount(trgSort, trgOfficer, D, trgClass, ost_AllShifts);
 END {GetVacancyAmount};

 PUBLIC PROCEDURE GetVacancyAmount_byOneShift(trgSort   : LIKE(Sort.Sort);
                                              trgOfficer: LIKE(Officer.Officer);
                                              D         : DATE;
                                              trgClass  : LIKE(StaffLog.Class);
                                              trgShift  : tOfficerShiftType): NUMERIC[2];
 BEGIN
  RETURN intGetVacancyAmount(trgSort, trgOfficer, D, trgClass, trgShift);
 END {GetVacancyAmount_byOneShift};

 PUBLIC PROCEDURE GetEarningValue_ByOneClass(trgSort   : LIKE(Sort.Sort);
                                             trgOfficer: LIKE(Officer.Officer);
                                             D         : DATE;
                                             trgClass  : LIKE(StaffLog.Class)): NUMERIC[3];
  VAR
   EarningValue: NUMERIC[14, 3][ClassAmount];
 BEGIN
  IF HasActualPro_Normal(trgSort, trgOfficer, D, P_EarningValue) THEN
   Decode_EarningValue(OfcPro.Value, EarningValue);
   RETURN EarningValue[trgClass];
  ELSE
   RETURN 0;
  END;
 END {GetEarningValue_ByOneClass};

 PUBLIC PROCEDURE GetRealShiftAmount(): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=0;
  ACCESS(Officer);
  SELECT(OfcShift, Officer, , Officer.Sort, Officer.Officer);
  WHILE OCCURE(OfcShift) DO
   CONFORM(OfcShift, Shift);
   Result:=Math.Max(Result, Shift.Number);
   NEXT(OfcShift);
  END; (* WHILE OCCURE(OfcShift) ... *)
  L_General.Assert(Result < ShiftAmount, "誮  ᬥ");
  RETURN Result;
 END {GetRealShiftAmount};

 PRIVATE PROCEDURE Decode_AveIndexation(Value: STRING[]; VAR AveIndexation: P_Union.tAveIndexationArr);
  VAR
   Idx: NUMERIC[0];
 BEGIN
  SETEMPTY(AveIndexation);
  Idx:=0;
  WHILE Idx <= HIGH(AveIndexation) DO
   IF ~!L_Prop.getRES(Value, Idx) THEN
    AveIndexation[Idx]:=STRTOFLD(L_Prop.getRES(Value, Idx), NUMERIC);
   END;
   INC(Idx);
  END;
 END {Decode_AveIndexation};

 PUBLIC PROCEDURE GetAveIndexation(trgSort   : LIKE(Sort.Sort);
                                   trgOfficer: LIKE(Officer.Officer);
                                   D         : DATE;
                                   trgAveNo  : LIKE(AveType.AveNo)): P_Union.tAveIndexation;
  VAR
   AveIndexation: P_Union.tAveIndexationArr;
 BEGIN
  IF HasActualPro(trgSort, trgOfficer, D, P_AveIndexation, L_Prop.dsc_Exactly) THEN
   Decode_AveIndexation(OfcPro.Value, AveIndexation);
   RETURN AveIndexation[trgAveNo];
  ELSE
   RETURN 1;
  END;
 END {GetAveIndexation};

 PRIVATE PROCEDURE formSet_AveIndexation();
  VAR
   AveIndexation: P_Union.tAveIndexationArr;
   Idx          : NUMERIC[0];
   Fields       : FORM_FIELDS;
 BEGIN
  Decode_AveIndexation(OfcPro.Value, AveIndexation);
  Fields:=RTI.Get().CurZone.Fields;
  Idx:=0;
  WHILE Idx <= HIGH(AveIndexation) DO
   Fields(L_WDO.Fld_wIdx("AveIndexation", Idx)).Value:=AveIndexation[Idx];
   INC(Idx);
  END;
 END {formSet_AveIndexation};

 PUBLIC PROCEDURE OnSuccessfulChange_MantoManDefenceAss();
  VAR
   Fields     : FORM_FIELDS;
   ActiveField: FORM_FIELD;
   Idx        : NUMERIC[0];
 BEGIN
  Fields     :=RTI.Get().CurZone.Fields;
  ActiveField:=RTI.Get().CurZone.ActiveField;
  Idx:=L_WDO.getCurFldIdx();
  IF ActiveField.Name = L_WDO.Fld_wIdx("Math", Idx) THEN
   Fields(L_WDO.Fld_wIdx("Paragraph",   Idx)).Modifiable:=~!ActiveField.Value;
   Fields(L_WDO.Fld_wIdx("WorkingLife", Idx)).Modifiable:=~!ActiveField.Value;
   Fields(L_WDO.Fld_wIdx("Amount",      Idx)).Modifiable:=~!ActiveField.Value;
   IF !ActiveField.Value THEN
    SETEMPTY(Fields(L_WDO.Fld_wIdx("Paragraph",   Idx)).Value,
             Fields(L_WDO.Fld_wIdx("WorkingLife", Idx)).Value,
             Fields(L_WDO.Fld_wIdx("Amount",      Idx)).Value);
   END;
  END;
 END {OnSuccessfulChange_MantoManDefenceAss};

 PRIVATE PROCEDURE OnSuccessfulChange_VacancyAmount();
  VAR
   i          : SCAL[VacancyAmount];
   FillByClass,
   Exclaimed  : SCAL[2];
   Fields     : FORM_FIELDS;
   ActiveField: FORM_FIELD;
 BEGIN
  ActiveField:=RTI.Get().CurZone.ActiveField;
  IF ActiveField.Name = "FillByClass" THEN
   FillByClass:=ActiveField.Value;
   L_General.Assert(~!FillByClass, "     ");
   Fields:=RTI.Get().CurZone.Fields;
   Exclaimed:=0;
   FOR_EACH i DO
    IF Fields(L_WDO.Fld_wIdx("VacancyAmnt", i)).Value # 0 THEN
     IF ~Exclaimed THEN
      L_StdFrm.Choice(" ⢠ ᨩ '" +
                      L_Str.PoolItem(" 楫  | ࠧ鸞",  FillByClass) + "'?");
      L_StdFrm.Choice("!| ,  '" +
                      L_Str.PoolItem(" 楫  | ࠧ鸞", ~FillByClass) + "',  㤠!");
      Exclaimed:=1;
     END; (* IF *)
     Fields(L_WDO.Fld_wIdx("VacancyAmnt", i)).Value:=0;
    END; (* IF *)
   END; (* FOR_EACH i ... *)
   Vacancy_SetFlagEditOfWinField();
  END;
  CalcVacancyAmntSumFields();
 END {OnSuccessfulChange_VacancyAmount};

 PUBLIC PROCEDURE OnSuccessfulChange(trgProperty: LIKE(Property.Property));
  VAR
   FieldName: STRING[];
   Idx      : NUMERIC[0];
   CurZone  : FORM_ZONE;
 BEGIN
  IF    trgProperty = P_VacancyAmount THEN
   OnSuccessfulChange_VacancyAmount();
  ELSIF trgProperty = P_MantoManDefenceAss THEN
   OnSuccessfulChange_MantoManDefenceAss();
  ELSIF trgProperty = P_AuthorizedStorages THEN
   CurZone  :=RTI.Get().CurZone;
   FieldName:=CurZone.ActiveField.Name;
   Idx      :=L_Prop.GetCurVideoFieldArrIdx();
   IF FieldName = L_WDO.Fld_wIdx("Storage", Idx) THEN
    IF ~!CurZone.Fields(FieldName).Value THEN
     L_Stock.CheckIsSelectableStorage(CurZone.Fields(FieldName).Value);
    END;
   END;
  END;
 END {OnSuccessfulChange};

 PRIVATE PROCEDURE GetClassIdx(tmp: STRING[]): NUMERIC[0];
  VAR
   Idx: NUMERIC[0];
 BEGIN
  Idx:=L_Str.PositionInPool(Pool_ClassSign, tmp);
  L_General.Assert(~!Idx, " । ࠧ: "+tmp);
  RETURN Idx;
 END {GetClassIdx};

 PRIVATE PROCEDURE Vacancy_SetFlagEditOfWinField();
  VAR
   RealShiftAmount: NUMERIC[0];
   i              : SCAL[VacancyAmount];
   ShiftNum       : SCAL[ShiftAmount];
   Fields         : FORM_FIELDS;
 BEGIN
  RealShiftAmount:=GetRealShiftAmount();
  Fields         :=RTI.Get().CurZone.Fields;
  FOR_EACH i DO
   ShiftNum:=i MOD ShiftAmount;
   Fields(L_WDO.Fld_wIdx("VacancyAmnt", i)).Modifiable:=(ShiftNum <= RealShiftAmount) & ((i >= ShiftAmount) = Fields("FillByClass").Value);
  END; (* FOR_EACH i ... *)
 END {Vacancy_SetFlagEditOfWinField};

 PRIVATE PROCEDURE Decode_VacancyAmount(    Value      : STRING[];
                                        VAR VacancyAmnt: NUMERIC[14, 2][];
                                        VAR FillByClass: SCAL[2]);
  VAR
   i, j, Idx: NUMERIC[0];
   S,
   Element  : STRING[];
 BEGIN
  i:=0;
  LOOP
   Element:=Str.Condense(Str.Item(Value, "]", i));
   IF !Element THEN
    EXIT;
   END; (* IF *)
   Idx    :=GetClassIdx(GetClassSignFromStr(Element)) * ShiftAmount;
   Element:=L_Prop.getAIS(Value, i);
   j      :=0;
   WHILE j < ShiftAmount DO
    S:=L_Prop.getRES(Element, j);
    IF !S THEN
     VacancyAmnt[Idx+j]:=0;
    ELSE
     VacancyAmnt[Idx+j]:=STRTOFLD(S, FLOAT);
    END;
    INC(j);
   END; (* WHILE j < ShiftAmount...*)
   INC(i);
  END; (* LOOP *)
  FillByClass:=InfillMethodVacancy_ByClass(Value);
 END {Decode_VacancyAmount};

 PRIVATE PROCEDURE CalcVacancyAmntSumFields();
  VAR
   i     : SCAL[10];
   j     : SCAL[9];
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH i DO
   Fields(L_WDO.Fld_wIdx("VacancyAmntSum", i)).Value:=0;
   FOR_EACH j DO
    IF j # 0 THEN
     INC(Fields(L_WDO.Fld_wIdx("VacancyAmntSum", i)).Value, Fields(L_WDO.Fld_wIdx("VacancyAmnt", j*10+i)).Value);
    END;
   END;
  END;
 END {CalcVacancyAmntSumFields};

 PRIVATE PROCEDURE formSet_VacancyAmount();
  VAR
   Fields         : FORM_FIELDS;
   RealShiftAmount: NUMERIC[0];
   VacancyAmnt    : tVacancyConception;
   FillByClass    : SCAL[2];
   i              : SCAL[VacancyAmount];
 BEGIN
  Fields                      :=RTI.Get().CurZone.Fields;
  Fields("FillByClass").Format:=" 楫  | ࠧ鸞";
  RealShiftAmount             :=GetRealShiftAmount();
  SETZERO(VacancyAmnt);
  IF ~!OfcPro.Value THEN
   Decode_VacancyAmount(OfcPro.Value, VacancyAmnt, FillByClass);
  ELSE
   SAVE(OfcPro);
   CHANGESEL(OfcPro, Officer, , OfcPro.Sort, OfcPro.Officer, OfcPro.Property);
   IF PREV(OfcPro) THEN
    FillByClass:=InfillMethodVacancy_ByClass(OfcPro.Value);
   ELSE
    FillByClass:=0;
   END;
   RESTORE(OfcPro);
  END; (* IF *)
  Fields("FillByClass").Value:=FillByClass;
  FOR_EACH i DO
   Fields(L_WDO.Fld_wIdx("VacancyAmnt", i)).Value:=VacancyAmnt[i];
  END;
  Vacancy_SetFlagEditOfWinField();
  CalcVacancyAmntSumFields();
 END {formSet_VacancyAmount};

 PRIVATE PROCEDURE formGet_AuthorizedStorages();
  VAR
   S,
   trgValue: STRING[];
   Idx     : SCAL[as_Amount];
   Fields  : FORM_FIELDS;
 BEGIN
  SETEMPTY(trgValue, S);
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   IF ~!Fields(L_WDO.Fld_wIdx("Storage", Idx)).Value THEN
    L_Prop.putAIS(S, L_r2r.Put("OfcPro", "Storage", Fields(L_WDO.Fld_wIdx("Storage", Idx)).Value));
   END;
  END;
  L_Prop.putRES(trgValue, S);
  L_Prop.putRES(trgValue, L_Str.PoolItem(wofaha_Pool, Fields("WriteOffFromAdvanceHolderAllowed").Value));
  OfcPro.Value:=trgValue;
 END {formGet_AuthorizedStorages};

 PRIVATE PROCEDURE Decode_AuthorizedStorages(    Value                           : STRING[];
                                             VAR Storages                        : tStorages;
                                             VAR WriteOffFromAdvanceHolderAllowed: SCAL[2]);
  VAR
   Idx: SCAL[as_Amount];
 BEGIN
  FOR_EACH Idx DO
   Storages[Idx]:=L_r2r.DecodeReferenceStamp(L_Prop.getAIS(L_Prop.getRES(Value, 0), Idx));
  END;
  WriteOffFromAdvanceHolderAllowed:=!Value | L_Str.PositionInPool(wofaha_Pool, L_Prop.getRES(Value, 1));
 END {Decode_AuthorizedStorages};

 PRIVATE PROCEDURE formSet_AuthorizedStorages();
  VAR
   Idx                             : SCAL[as_Amount];
   Fields                          : FORM_FIELDS;
   Storages                        : tStorages;
   WriteOffFromAdvanceHolderAllowed: SCAL[2];
 BEGIN
  Decode_AuthorizedStorages(OfcPro.Value, Storages, WriteOffFromAdvanceHolderAllowed);
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   L_WDO.extCreateFormLink("Storage", "", Idx);
   Fields(L_WDO.Fld_wIdx("Storage_Type", Idx)).Expression:="SELF.Zone.LinkedFieldValue('" + L_WDO.Fld_wIdx("Storage", Idx) + ".Type')";
   Fields(L_WDO.Fld_wIdx("Storage_Type", Idx)).Format    :=L_Stock.st_Pool_SH;
   Fields(L_WDO.Fld_wIdx("Storage", Idx)).Value          :=Storages[Idx];
  END;
  Fields("WriteOffFromAdvanceHolderAllowed").Format:=wofaha_Pool;
  Fields("WriteOffFromAdvanceHolderAllowed").Value :=WriteOffFromAdvanceHolderAllowed;
 END {formSet_AuthorizedStorages};

 PRIVATE PROCEDURE Decode_MantoManDefenceAss_OneRow(    Value      : STRING[];
                                                    VAR Math       : LIKE(Math.Math);
                                                    VAR Paragraph  : STRING[];
                                                    VAR WorkingLife: NUMERIC[0];
                                                    VAR Amount     : tmmdaAmnt);
 BEGIN
  Math       :=L_r2r.DecodeReferenceStamp(L_Prop.getRES(Value, 0));
  Paragraph  :=L_Prop.getRES(Value, 1);
  WorkingLife:=STRTOFLD(L_Prop.getRES(Value, 2), SCAL);
  Amount     :=STRTOFLD(L_Prop.getRES(Value, 3), FLOAT);
  IF !Amount THEN
   Amount:=1;
  END;
 END {Decode_MantoManDefenceAss_OneRow};

 PUBLIC PROCEDURE Decode_MantoManDefenceAss(    Value         : LIKE(OfcPro.Value);
                                            VAR arrMath       : LIKE(Math.Math)[mmda_Amount];
                                            VAR arrParagraph  : STRING[][mmda_Amount];
                                            VAR arrWorkingLife: NUMERIC[0][mmda_Amount];
                                            VAR arrAmount     : tmmdaAmnt[mmda_Amount]);
  VAR
   Idx   : SCAL[mmda_Amount];
   OneRow: STRING[];
 BEGIN
  SETEMPTY(arrMath, arrParagraph, arrWorkingLife, arrAmount);
  FOR_EACH Idx DO
   OneRow:=L_Prop.getAIS(Value, Idx);
   IF ~!OneRow THEN
    Decode_MantoManDefenceAss_OneRow(OneRow, arrMath[Idx], arrParagraph[Idx], arrWorkingLife[Idx], arrAmount[Idx]);
   END;
  END;
 END {Decode_MantoManDefenceAss};

 PRIVATE PROCEDURE Encode_MantoManDefenceAss_OneRow(VAR Value      : STRING[];
                                                        File       : STRING[];
                                                        trgMath    : LIKE(Math.Math);
                                                        Paragraph  : STRING[];
                                                        WorkingLife: NUMERIC[0];
                                                        Amount     : tmmdaAmnt);
 BEGIN
  SETEMPTY(Value);
  IF ~!trgMath | ~!Paragraph | ~!WorkingLife | ~!Amount THEN
   L_Prop.putRES(Value, L_r2r.Put(File, "Math", trgMath));
   L_Prop.putRES(Value, Paragraph);
   L_Prop.putREV(Value, WorkingLife);
   IF !Amount THEN
    Amount:=1;
   END;
   L_Prop.putREV(Value, Amount);
  END;
 END {Encode_MantoManDefenceAss_OneRow};

 PRIVATE PROCEDURE Encode_MantoManDefenceAss(VAR Value         : LIKE(OfcPro.Value);
                                                 File          : STRING[];
                                                 arrMath       : LIKE(Math.Math)[mmda_Amount];
                                                 arrParagraph  : STRING[][mmda_Amount];
                                                 arrWorkingLife: NUMERIC[0][mmda_Amount];
                                                 arrAmount     : tmmdaAmnt[mmda_Amount]);
  VAR
   Idx   : SCAL[mmda_Amount];
   OneRow: STRING[];
 BEGIN
  SETEMPTY(Value);
  FOR_EACH Idx DO
   Encode_MantoManDefenceAss_OneRow(OneRow, File, arrMath[Idx], arrParagraph[Idx], arrWorkingLife[Idx], arrAmount[Idx]);
   IF ~!OneRow THEN
    L_Prop.putAIS(Value, OneRow);
   END;
  END;
 END {Encode_MantoManDefenceAss};

 PUBLIC PROCEDURE formSet_MantoManDefenceAss(File: STRING[]);
  VAR
   Fields        : FORM_FIELDS;
   Idx           : SCAL[mmda_Amount];
   arrMath       : LIKE(Math.Math)[mmda_Amount];
   arrParagraph  : STRING[][mmda_Amount];
   arrWorkingLife: NUMERIC[0][mmda_Amount];
   arrAmount     : tmmdaAmnt[mmda_Amount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_MantoManDefenceAss(^(File + ".Value"), arrMath, arrParagraph, arrWorkingLife, arrAmount);
  FOR_EACH Idx DO
   L_WDO.extCreateFormLink("Math", "", Idx);
   Fields(L_WDO.Fld_wIdx("Math",        Idx)).Value:=arrMath       [Idx];
   Fields(L_WDO.Fld_wIdx("Paragraph",   Idx)).Value:=arrParagraph  [Idx];
   Fields(L_WDO.Fld_wIdx("WorkingLife", Idx)).Value:=arrWorkingLife[Idx];
   Fields(L_WDO.Fld_wIdx("Amount",      Idx)).Value:=arrAmount     [Idx];

   Fields(L_WDO.Fld_wIdx("Paragraph",   Idx)).Modifiable:=~!Fields(L_WDO.Fld_wIdx("Math", Idx)).Value;
   Fields(L_WDO.Fld_wIdx("WorkingLife", Idx)).Modifiable:=~!Fields(L_WDO.Fld_wIdx("Math", Idx)).Value;
   Fields(L_WDO.Fld_wIdx("Amount",      Idx)).Modifiable:=~!Fields(L_WDO.Fld_wIdx("Math", Idx)).Value;
  END;
 END {formSet_MantoManDefenceAss};

 PRIVATE PROCEDURE Decode_EarningValue(    Value       : STRING[];
                                       VAR EarningValue: NUMERIC[2][ClassAmount]);
  VAR
   Idx            : NUMERIC[0];
   EarningValueStr,
   Element        : STRING[];
 BEGIN
  SETZERO(EarningValue, Idx);
  LOOP
   Element:=Str.Condense(Str.Item(Value, "]", Idx));
   IF !Element THEN
    EXIT;
   END;
   EarningValueStr:=L_Prop.getAIS(Value, Idx);
   IF ~!EarningValueStr THEN
    EarningValue[GetClassIdx(GetClassSignFromStr(Element))]:=STRTOFLD(EarningValueStr, NUMERIC);
   END;
   INC(Idx);
  END;
 END {Decode_EarningValue};

 PRIVATE PROCEDURE formSet_EarningValue();
  VAR
   Fields      : FORM_FIELDS;
   Idx         : SCAL[ClassAmount];
   EarningValue: NUMERIC[2][ClassAmount];
 BEGIN
  Decode_EarningValue(OfcPro.Value, EarningValue);
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   IF Idx # 0 THEN
    Fields(L_WDO.Fld_wIdx("EarningValue", Idx)).Value:=EarningValue[Idx];
   END;
  END;
 END {formSet_EarningValue};

 PRIVATE PROCEDURE Decode_OfcBonus(Value: STRING[]; VAR OfcBonus: tOfcBonus);
  VAR
   Idx: SCAL[ob_Amount];
 BEGIN
  SETEMPTY(OfcBonus);
  FOR_EACH Idx DO
   IF ~!L_Prop.getRES(Value, Idx) THEN
    OfcBonus[Idx]:=STRTOFLD(L_Prop.getRES(Value, Idx), NUMERIC);
   END;
  END;
 END {Decode_OfcBonus};

 PUBLIC PROCEDURE E_OfficerBonusName(i: SCAL[ob_Amount]): STRING[];
  VAR
   Local: PROC;
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF    i = 0 THEN
   Result:="筠";
  ELSE
   Local:=PROCREF(E_PRoll.OfficerBonusName);
   IF ~!Local THEN
    Result:=Local(i);
   END;
  END;
  RETURN Result;
 END {E_OfficerBonusName};

 PRIVATE PROCEDURE formSet_OfcBonus();
  VAR
   OfcBonus: tOfcBonus;
   Fields  : FORM_FIELDS;
   Idx     : SCAL[ob_Amount];
   curName : STRING[];
 BEGIN
  Decode_OfcBonus(OfcPro.Value, OfcBonus);
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   curName:=E_OfficerBonusName(Idx);
   Fields(L_WDO.Fld_wIdx("OfcBonusName", Idx)).Value:=curName;
   Fields(L_WDO.Fld_wIdx("OfcBonus", Idx)).Value    :=OfcBonus[Idx];
   Fields(L_WDO.Fld_wIdx("OfcBonus", Idx)).Visible  :=~!curName;
  END;
 END {formSet_OfcBonus};

 PUBLIC PROCEDURE Decode_LabourConditions(    curValue   : LIKE(OfcPro.Value);
                                          VAR curDirtyTyp: LIKE(DirtyTyp.DirtyTyp);
                                          VAR curSpecialEvaluation: tSpecialEvaluation);
 BEGIN
  curDirtyTyp         :=L_r2r.Decode(L_Prop.getRES(curValue, 0));
  curSpecialEvaluation:=L_Prop.getRES(curValue, 1);
 END {Decode_LabourConditions};

 PRIVATE PROCEDURE formSet_LabourConditions();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("SpecialEvaluation").Format:="-|";
  Decode_LabourConditions(OfcPro.Value, Fields(v_DirtyTyp).Value, Fields("SpecialEvaluation").Value);
  L_WDO.CreateFormLink("DirtyTyp", "");
 END {formSet_LabourConditions};

 PRIVATE PROCEDURE formGet_LabourConditions();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_Prop.putRES(OfcPro.Value, L_r2r.Put("OfcPro", "DirtyTyp", Fields(v_DirtyTyp).Value));
  L_Prop.putRES(OfcPro.Value, Fields("SpecialEvaluation").Value);
 END {formGet_LabourConditions};

 PUBLIC PROCEDURE SetDataInForm(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_VacancyAmount      THEN formSet_VacancyAmount();
  ELSIF trgProperty = P_EarningValue       THEN formSet_EarningValue();
  ELSIF trgProperty = P_MantoManDefenceAss THEN formSet_MantoManDefenceAss("OfcPro");
  ELSIF trgProperty = P_AuthorizedStorages THEN formSet_AuthorizedStorages();
  ELSIF trgProperty = P_AveIndexation      THEN formSet_AveIndexation();
  ELSIF trgProperty = P_OfcBonus           THEN formSet_OfcBonus();
  ELSIF trgProperty = P_LabourConditions   THEN formSet_LabourConditions();
  END;
 END {SetDataInForm};

 PUBLIC PROCEDURE GetVal2Show_MantoManDefenceAss(Value: STRING[]): STRING[];
  VAR
   Result        : STRING[];
   Idx           : SCAL[mmda_Amount];
   arrMath       : LIKE(Math.Math)[mmda_Amount];
   arrParagraph  : STRING[][mmda_Amount];
   arrWorkingLife: NUMERIC[0][mmda_Amount];
   arrAmount     : tmmdaAmnt[mmda_Amount];
 BEGIN
  SETEMPTY(Result);
  Decode_MantoManDefenceAss(Value, arrMath, arrParagraph, arrWorkingLife, arrAmount);
  FOR_EACH Idx DO
   IF ~!arrMath[Idx] THEN
    Result:=Result + "[" + arrMath[Idx] + ";" + arrParagraph[Idx] + ";" + L_Str.IntStr(arrWorkingLife[Idx]) + ";" + L_Str.NumericStr(arrAmount[Idx], 2) + "]";
   END;
  END;
  RETURN Result;
 END {GetVal2Show_MantoManDefenceAss};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Storages                        : tStorages;
   WriteOffFromAdvanceHolderAllowed: SCAL[2];
   i                               : NUMERIC[0];
   Result                          : STRING[];
   curSpecialEvaluation            : tSpecialEvaluation;
 BEGIN
  IF OfcPro.Property = P_AuthorizedStorages THEN
   Decode_AuthorizedStorages(OfcPro.Value, Storages, WriteOffFromAdvanceHolderAllowed);
   Result:=": " + L_Str.PoolItem("|", WriteOffFromAdvanceHolderAllowed);
   i:=0;
   WHILE ~!Storages[i] DO
    INC(Result, ", " + Storages[i]);
    INC(i);
   END;
  ELSIF OfcPro.Property = P_MantoManDefenceAss THEN
   Result:=GetVal2Show_MantoManDefenceAss(OfcPro.Value);
  ELSIF OfcPro.Property = P_LabourConditions THEN
   Decode_LabourConditions(OfcPro.Value, Result, curSpecialEvaluation);
   SEARCH(DirtyTyp, DirtyTyp, , Result);
   INC(Result, "; "+L_Staff.GetDirtyTypPower_asStr());
  ELSE
   Result:=OfcPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PUBLIC PROCEDURE formGet_MantoManDefenceAss(File: STRING[]);
  VAR
   Idx           : SCAL[mmda_Amount];
   Fields        : FORM_FIELDS;
   arrMath       : LIKE(Math.Math)[mmda_Amount];
   arrParagraph  : STRING[][mmda_Amount];
   arrWorkingLife: NUMERIC[0][mmda_Amount];
   arrAmount     : tmmdaAmnt[mmda_Amount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   arrMath       [Idx]:=Fields(L_WDO.Fld_wIdx("Math",        Idx)).Value;
   arrParagraph  [Idx]:=Fields(L_WDO.Fld_wIdx("Paragraph",   Idx)).Value;
   arrWorkingLife[Idx]:=Fields(L_WDO.Fld_wIdx("WorkingLife", Idx)).Value;
   arrAmount     [Idx]:=Fields(L_WDO.Fld_wIdx("Amount",      Idx)).Value;
  END;
  Encode_MantoManDefenceAss(^(File + ".Value"), File, arrMath, arrParagraph, arrWorkingLife, arrAmount);
 END {formGet_MantoManDefenceAss};

 PRIVATE PROCEDURE Encode_EarningValue(VAR Value       : STRING[];
                                           EarningValue: NUMERIC[2][ClassAmount]);
  VAR
   Idx            : SCAL[ClassAmount];
   EarningValueStr: STRING[];
 BEGIN
  FOR_EACH Idx DO
   IF EarningValue[Idx] # 0 THEN
    INC(Value, GetClassSign(Idx));
    EarningValueStr:=L_Str.NumericStr(EarningValue[Idx], 2);
    L_Prop.putAIS(Value, EarningValueStr);
   END;
  END;
 END {Encode_EarningValue};

 PRIVATE PROCEDURE formGet_EarningValue();
  VAR
   Fields      : FORM_FIELDS;
   Idx         : SCAL[ClassAmount];
   EarningValue: NUMERIC[2][ClassAmount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  SETZERO(EarningValue);
  FOR_EACH Idx DO
   IF (Idx # 0) & ~!Fields(L_WDO.Fld_wIdx("EarningValue", Idx)).Value THEN
    EarningValue[Idx]:=Fields(L_WDO.Fld_wIdx("EarningValue", Idx)).Value;
   END;
  END;
  Encode_EarningValue(OfcPro.Value, EarningValue);
 END {formGet_EarningValue};

 PRIVATE PROCEDURE formGet_OfcBonus();
  VAR
   OfcBonus: tOfcBonus;
   Fields  : FORM_FIELDS;
   Idx     : SCAL[ob_Amount];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   OfcBonus[Idx]:=Fields(L_WDO.Fld_wIdx("OfcBonus", Idx)).Value;
   L_Prop.putREV(OfcPro.Value, OfcBonus[Idx]);
  END;
 END {formGet_OfcBonus};

 PRIVATE PROCEDURE Encode_AveIndexation(VAR Value: STRING[]; AveIndexation: P_Union.tAveIndexationArr);
  VAR
   Idx: NUMERIC[0];
 BEGIN
  IF ~L_Prop.IsEmptyNumArray(AveIndexation) THEN
   Idx:=0;
   WHILE Idx <= HIGH(AveIndexation) DO
    L_Prop.putREV(Value, AveIndexation[Idx]);
    INC(Idx);
   END;
  END;
 END {Encode_AveIndexation};

 PRIVATE PROCEDURE formGet_AveIndexation();
  VAR
   AveIndexation: P_Union.tAveIndexationArr;
   Idx          : NUMERIC[0];
   Fields       : FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Idx:=0;
  WHILE Idx <= HIGH(AveIndexation) DO
   AveIndexation[Idx]:=Fields(L_WDO.Fld_wIdx("AveIndexation", Idx)).Value;
   INC(Idx);
  END;
  P_Union.CheckIndexation(AveIndexation);
  Encode_AveIndexation(OfcPro.Value, AveIndexation);
 END {formGet_AveIndexation};

 PRIVATE PROCEDURE Encode_VacancyAmount(VAR Value      : STRING[];
                                            VacancyAmnt: NUMERIC[14, 2][];
                                            FillByClass: SCAL[2]);
  VAR
   Class,
   MaxClass,
   RealShiftAmount,
   i,
   MaxShifts,
   AbsIdx,
   TotalShiftsInClass   : NUMERIC[0];
   VacancyAmountByClass,
   ClassSign,
   tmp                  : STRING[];
 BEGIN
  IF FillByClass THEN
   MaxClass:=ClassAmount;
   Class   :=1;
  ELSE
   MaxClass:=1;
   Class   :=0;
  END;
  RealShiftAmount:=GetRealShiftAmount();
  WHILE Class < MaxClass DO
   SETEMPTY(VacancyAmountByClass);
   ClassSign:=GetClassSign(Class);
   AbsIdx   :=Class*ShiftAmount;
   i        :=1;
   SETZERO(TotalShiftsInClass);
   WHILE i < ShiftAmount DO
    INC(TotalShiftsInClass, VacancyAmnt[AbsIdx+i]);
    INC(i);
   END;
   IF (VacancyAmnt[AbsIdx] # 0) | (TotalShiftsInClass # 0) THEN
    IF TotalShiftsInClass = 0 THEN MaxShifts:=0;
    ELSE                           MaxShifts:=RealShiftAmount;
    END;
    i:=0;
    SETEMPTY(tmp);
    WHILE i <= MaxShifts DO
     L_Prop.putRES(tmp, L_Str.NumericStr(VacancyAmnt[AbsIdx+i], 1));
     INC(i);
    END; (* WHILE i <= MaxShifts...*)
    VacancyAmountByClass:=ClassSign;
    L_Prop.putAIS(VacancyAmountByClass, tmp);
   END; (* IF *)
   INC(Value, VacancyAmountByClass);
   INC(Class);
  END; (* WHILE Class < MaxClass...*)
 END {Encode_VacancyAmount};

 PRIVATE PROCEDURE formGet_VacancyAmount();
  VAR
   VacancyAmnt: NUMERIC[14, 2][VacancyAmount];
   i          : SCAL[VacancyAmount];
   Fields     : FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  SETZERO(VacancyAmnt);
  FOR_EACH i DO
   VacancyAmnt[i]:=Fields(L_WDO.Fld_wIdx("VacancyAmnt", i)).Value;
  END;
  Encode_VacancyAmount(OfcPro.Value, VacancyAmnt, Fields("FillByClass").Value);
 END {formGet_VacancyAmount};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty: LIKE(Property.Property));
 BEGIN
  SETEMPTY(OfcPro.Value, OfcPro.Val2Show);
  IF    trgProperty = P_VacancyAmount      THEN formGet_VacancyAmount();
  ELSIF trgProperty = P_EarningValue       THEN formGet_EarningValue();
  ELSIF trgProperty = P_MantoManDefenceAss THEN formGet_MantoManDefenceAss("OfcPro");
  ELSIF trgProperty = P_AuthorizedStorages THEN formGet_AuthorizedStorages();
  ELSIF trgProperty = P_AveIndexation      THEN formGet_AveIndexation();
  ELSIF trgProperty = P_OfcBonus           THEN formGet_OfcBonus();
  ELSIF trgProperty = P_LabourConditions   THEN formGet_LabourConditions();
  ELSE                                          L_General.CallUs(0);
  END;
  REPLACE(OfcPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE Value_OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_KindOfWork THEN
   L_Pool.Put(pool_KindOfWork, OfcPro.Value);
  END;
 END {Value_OnSuccessfulChange};

 PUBLIC PROCEDURE GetOfcBonus(Idx: SCAL[ob_Amount]; D: DATE): NUMERIC[3];
  VAR
   OfcBonus: tOfcBonus;
 BEGIN
  Decode_OfcBonus(GetProValueSoft(Officer.Sort, Officer.Officer, L_DatTim.MonthEnd(D), P_OfcBonus), OfcBonus);
  IF !OfcBonus[Idx] THEN
   RETURN 0;
  ELSE
   RETURN OfcBonus[Idx];
  END;
 END {GetOfcBonus};

 PUBLIC PROCEDURE GetP_AuthorizedStorages(    Sort                            : LIKE(Sort.Sort);
                                              Officer                         : LIKE(Officer.Officer);
                                              D                               : DATE;
                                          VAR Storages                        : tStorages;
                                          VAR WriteOffFromAdvanceHolderAllowed: SCAL[2]);
 BEGIN
  Decode_AuthorizedStorages(GetProValueSoft(Sort, Officer, D, P_AuthorizedStorages), Storages, WriteOffFromAdvanceHolderAllowed);
 END {GetP_AuthorizedStorages};

 PUBLIC PROCEDURE GetP_LabourConditions(    Sort                : LIKE(Sort.Sort);
                                            Officer             : LIKE(Officer.Officer);
                                            D                   : DATE;
                                        VAR curDirtyTyp         : LIKE(DirtyTyp.DirtyTyp);
                                        VAR curSpecialEvaluation: tSpecialEvaluation);
 BEGIN
  Decode_LabourConditions(GetProValueStrong(Sort, Officer, D, P_LabourConditions), curDirtyTyp, curSpecialEvaluation);
 END {GetP_LabourConditions};

 PUBLIC PROCEDURE GetP_LCDirtyTyp(Sort   : LIKE(Sort.Sort);
                                  Officer: LIKE(Officer.Officer);
                                  D      : DATE): LIKE(DirtyTyp.DirtyTyp);
  VAR
   curDirtyTyp           : LIKE(DirtyTyp.DirtyTyp);
   dummySpecialEvaluation: tSpecialEvaluation;
 BEGIN
  Decode_LabourConditions(GetProValueStrong(Sort, Officer, D, P_LabourConditions), curDirtyTyp, dummySpecialEvaluation);
  RETURN curDirtyTyp;
 END {GetP_LCDirtyTyp};

END.
