(*
%Copyright   (c) Polak Computer System
%Author      01.06.2004 21:09:46 POLAK\GAV
%Purpose     ⥪  ࠡ  ᠭ "襩 ࣠樨"
%Type        library
%Specific    SYS
%Modified    04.07.2014 14:49:49 Bor
%Environment
*)

 MODULE P_OwnData [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  P_UnusualWayIncPlan        = 9000;
  P_PFRTuning                = 9001;
  P_WeatherConditions        = 9002;
  P_MessageInWayDoc          = 9003;
  P_InternetSettings         = 9005;
  P_RetirementCommiss        = 9006;
  P_BackupPath               = 9007;
  P_DspControlTimes          = 9008;
  P_FuelNormCorrection       = 9009;
  P_Temperature              = 9010;
  P_SalesVolumes             = 9011;
  P_RAccidCommiss            = 9012;
  P_Tariff                   = 9013;
  P_TruncTo                  = 9015;
  P_TruncMon                 = 9016;
  P_USDRate                  = 9018;
  P_SaleTax                  = 9019;
  P_RWaySBlank               = 9020;
  P_ProgressBonus            = 9021;
  P_HaulsAndPrice            = 9022;
  P_DrvSalByTicket           = 9023;
  P_PasVolNorm               = 9024;
  P_TradeUnionFirm           = 9025;
  P_TckOfficeShifts          = 9026;
  P_MainTckKind              = 9027;
  P_ACS_Parameters           = 9028;
  P_XDocMdfBan               = 9029;

  wLinkWindowName = "OwnDPrL";

  MaxUCDLines    = 99;
  MaxTariffLines = 10;
  fnc_Amount     = 15;

  udl_Pool  = "|";
  upc_Pool  = "|";
  wa_Pool   = "|";

  scsc_FTP   = 0;
  scsc_EMail = 1;

  scsc_Pool = "FTP|EMail";

  acsp_OutpostAmount    = 20;

  acsp_SystemTypePool       = " ⠭|PERCo 15000|Parsec|PERCo-S-20";
  c_acsp_SrvType_Empty      = 0;
  c_acsp_SrvType_Perco      = 1;
  c_acsp_SrvType_Parsec     = 2;
  c_acsp_SrvType_Perco_S20  = 3;

  CommissMembersAmnt = 15;

 PUBLIC TYPE
  t_acsp_SystemType    = SCAL[4];
  tPropTaxCode         = SCAL[1e7];
  tPropTaxRate         = NUMERIC[2];
  tSprtCrspSendChannel = SCAL[2];

 IMPORT L_General, L_APtm, L_DatTim, Str, L_Str, P_Firm, L_StdFrm, Math, L_Pmnt, L_iga,
        L_Prop, L_XDoc, L_ACS, L_TRS, L_SysLog, DBD, L_AFM, L_FIO, L_WDO, L_r2r, L_Way;

 PUBLIC PROCEDURE IsSimpleUserOf(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF trgProperty = P_TradeUnionFirm THEN
   RETURN "Firm";
  ELSE
   RETURN "";
  END;
 END {IsSimpleUserOf};

 PUBLIC PROCEDURE GetSubWindowName(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_UnusualWayIncPlan        THEN RETURN "P_9000";
  ELSIF trgProperty = P_PFRTuning                THEN RETURN "P_9001";
  ELSIF trgProperty = P_MessageInWayDoc          THEN RETURN "P_9003";
  ELSIF trgProperty = P_InternetSettings         THEN RETURN "P_9005";
  ELSIF trgProperty = P_RetirementCommiss        THEN RETURN "P_9006";
  ELSIF trgProperty = P_BackupPath               THEN RETURN "P_9007";
  ELSIF trgProperty = P_DspControlTimes          THEN RETURN "P_9008";
  ELSIF trgProperty = P_FuelNormCorrection       THEN RETURN "P_9009";
  ELSIF trgProperty = P_Temperature              THEN RETURN "P_9010";
  ELSIF trgProperty = P_SalesVolumes             THEN RETURN "P_9011";
  ELSIF trgProperty = P_RAccidCommiss            THEN RETURN "P_9012";
  ELSIF trgProperty = P_Tariff                   THEN RETURN "P_9013";
  ELSIF trgProperty = P_PasVolNorm               THEN RETURN "P_9024";
  ELSIF trgProperty = P_TckOfficeShifts          THEN RETURN "P_9026";
  ELSIF trgProperty = P_MainTckKind              THEN RETURN "P_9027";
  ELSIF trgProperty = P_ACS_Parameters           THEN RETURN "P_9028";
  ELSIF ~!IsSimpleUserOf(trgProperty)            THEN RETURN wLinkWindowName;
  ELSE
   RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE Check(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_TruncTo THEN
   L_Prop.CheckNumericValue(OwnDPro.Value, "");
  ELSIF trgProperty = P_TruncMon THEN
   L_Prop.CheckNumericValue(OwnDPro.Value, "");
  ELSIF trgProperty = P_BackupPath THEN
   L_General.Assert(L_FIO.IsFullUNCPath(OwnDPro.Value),
                    '"' + OwnDPro.Value + '"||   ⥬  ଠ UNC.');
  ELSIF trgProperty = P_USDRate THEN
   L_Prop.CheckNumericValue(OwnDPro.Value, "");
  ELSIF trgProperty = P_SaleTax THEN
   L_Prop.CheckNumericValue(OwnDPro.Value, "");
  ELSIF trgProperty = P_ProgressBonus THEN
   L_Prop.CheckNumericValue(OwnDPro.Value, "");
  END;
 END {Check};

 PRIVATE PROCEDURE acsp_SetField();
  VAR
   i           : NUMERIC[0];
   Fields      : FORM_FIELDS;
   SystemType  : t_acsp_SystemType;
   Visible,
   Modifiable  : SCAL[2];
   OutpostTitle_Enter,
   OutpostTitle_Exit: STRING[];
 BEGIN
  Fields    :=RTI.Get().CurZone.Fields;
  SystemType:=Fields("SystemType").Value;
  Modifiable:=SystemType # c_acsp_SrvType_Empty;
  Visible   :=SystemType = c_acsp_SrvType_Perco_S20;

  Fields("SystemServer").Modifiable    :=Modifiable;
  Fields("DateAccount").Modifiable     :=Modifiable;

  IF    SystemType = c_acsp_SrvType_Perco THEN
   OutpostTitle_Enter:=".";
   OutpostTitle_Exit :="";
  ELSIF SystemType = c_acsp_SrvType_Perco_S20 THEN
   OutpostTitle_Enter:="窠 室";
   OutpostTitle_Exit :="窠 室";
  ELSE
   OutpostTitle_Enter:="  ";
   OutpostTitle_Exit :="";
  END;
  Fields("OutpostTitle_Enter").Value   :=OutpostTitle_Enter;
  Fields("OutpostTitle_Exit").Visible  :=Visible;
  Fields("OutpostTitle_Exit").Value    :=OutpostTitle_Exit;

  i:=1;
  LOOP
   IF !Fields(L_WDO.Fld_wIdx("Site", i)) THEN
    EXIT;
   END;
   Fields(L_WDO.Fld_wIdx("Site", i)).Modifiable       :=Modifiable;
   Fields(L_WDO.Fld_wIdx("o_Enter", i)).Modifiable    :=Modifiable;
   Fields(L_WDO.Fld_wIdx("o_Exit", i)).Visible        :=Visible;
   Fields(L_WDO.Fld_wIdx("o_Exit", i)).Modifiable     :=Modifiable;
   Fields(L_WDO.Fld_wIdx("OutpostName", i)).Modifiable:=Modifiable;
   Fields(L_WDO.Fld_wIdx("Perimeter", i)).Modifiable  :=Modifiable;
   Fields(L_WDO.Fld_wIdx("Outpost", i)).Modifiable    :=Modifiable;
   INC(i);
  END;
 END {acsp_SetField};

 PRIVATE PROCEDURE SuccessfulChange_MainTckKind();
  VAR
   i,
   curIdx    : NUMERIC[0];
   Field     : FORM_FIELD;
   curTckKind: LIKE(TckKind.TckKind);
 BEGIN
  curTckKind:=RTI.Get().CurZone.ActiveField.Value;
  curIdx    :=L_WDO.getCurFldIdx();
  IF ~!curTckKind THEN
   i:=0;
   LOOP
    Field:=RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("TckKind", i));
    IF !Field THEN
     EXIT;
    END;
    IF (i # curIdx) & (curTckKind = Field.Value) THEN
     L_General.Error(" 㪠   " + curTckKind);
    END;
    INC(i);
   END; (* LOOP *)
  END;
 END {SuccessfulChange_MainTckKind};

 PRIVATE PROCEDURE SuccessfulChange_UnusualWayIncPlan(Idx: NUMERIC[0]);
  VAR
   Fields     : FORM_FIELDS;
   trgPlEqFc  : SCAL[2];
 BEGIN
  Fields     :=RTI.Get().CurZone.Fields;
  trgPlEqFc  :=Fields(L_WDO.Fld_wIdx("PlEqFc", Idx)).Value;
  IF trgPlEqFc = 1 THEN
   SETEMPTY(Fields(L_WDO.Fld_wIdx("CorrPlan", Idx)).Value);
  END;
  Fields(L_WDO.Fld_wIdx("CorrPlan", Idx)).Modifiable:=trgPlEqFc = 0;
 END {SuccessfulChange_UnusualWayIncPlan};

 PUBLIC PROCEDURE OnSuccessfulChange(trgProperty: LIKE(Property.Property));
  VAR
   curFN: STRING[];
   Idx  : NUMERIC[0];
 BEGIN
  IF    trgProperty = P_ACS_Parameters THEN
   IF    RTI.Get().CurZone.ActiveField.Name = "SystemType" THEN
    acsp_SetField();
   ELSIF Str.Match(RTI.Get().CurZone.ActiveField.Name, "Outpost_*") THEN
    IF ~!GE_PVALUE() THEN
     L_StdFrm.Choice("   窨 室  ||" +
                     " 䨪   祭 ᭮,|" +
                     "᫨  ⮩ 窥 㦥 뫨 㧪 室");
    END;
   END;
  ELSIF trgProperty = P_MainTckKind THEN
   SuccessfulChange_MainTckKind();
  ELSIF trgProperty = P_UnusualWayIncPlan THEN
   SuccessfulChange_UnusualWayIncPlan(L_Prop.GetCurVideoFieldArrIdx());
  ELSE
   curFN:=L_Prop.GetCurVideoFieldArrName();
   Idx  :=L_Prop.GetCurVideoFieldArrIdx();
   IF    trgProperty = P_Tariff THEN
    IF curFN = "ScalBase" THEN
     Tariff_SetFieldsFormat(Idx);
    END;
   ELSIF trgProperty = P_FuelNormCorrection THEN
    IF curFN = "MyFirm" THEN
     fnc_SetFieldFormats(Idx);
    END;
   END;
  END;
 END {OnSuccessfulChange};

 PRIVATE PROCEDURE SetPFRTuningData(VAR curPacketSize, curAncPacketSize: NUMERIC[0]);
 BEGIN
  curPacketSize:=STRTOFLD(L_Prop.getRES(OwnDPro.Value, 0), NUMERIC);
  curAncPacketSize:=STRTOFLD(L_Prop.getRES(OwnDPro.Value, 1), NUMERIC);
 END {SetPFRTuningData};

 PRIVATE PROCEDURE bp_SetDataInForm();
 BEGIN
  RTI.Get().CurWindow.Zones(0).Fields("BackUpPath").Value:=OwnDPro.Value;
 END {bp_SetDataInForm};

 PRIVATE PROCEDURE Tariff_SetFieldsFormat(Idx: NUMERIC[0]);
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF !Fields(L_WDO.Fld_wIdx("ScalBase", Idx)).Value THEN
   SETEMPTY(Fields(L_WDO.Fld_wIdx("ScalStep",  Idx)).Value,
            Fields(L_WDO.Fld_wIdx("PriceBase", Idx)).Value,
            Fields(L_WDO.Fld_wIdx("PriceStep", Idx)).Value);
  END;
  Fields(L_WDO.Fld_wIdx("ScalStep",  Idx)).Modifiable    :=~!Fields(L_WDO.Fld_wIdx("ScalBase", Idx)).Value;
  Fields(L_WDO.Fld_wIdx("PriceBase", Idx)).Modifiable    :=~!Fields(L_WDO.Fld_wIdx("ScalBase", Idx)).Value;
  Fields(L_WDO.Fld_wIdx("PriceStep", Idx)).Modifiable    :=~!Fields(L_WDO.Fld_wIdx("ScalBase", Idx)).Value;
  Fields(L_WDO.Fld_wIdx("ScalStep",  Idx)).MustBeNonempty:=~!Fields(L_WDO.Fld_wIdx("ScalBase", Idx)).Value;
  Fields(L_WDO.Fld_wIdx("PriceBase", Idx)).MustBeNonempty:=~!Fields(L_WDO.Fld_wIdx("ScalBase", Idx)).Value;
  Fields(L_WDO.Fld_wIdx("PriceStep", Idx)).MustBeNonempty:=~!Fields(L_WDO.Fld_wIdx("ScalBase", Idx)).Value;
 END {Tariff_SetFieldsFormat};

 PRIVATE PROCEDURE Decode_Tariff(    Value    : STRING[];
                                 VAR ScalBase,
                                     ScalStep,
                                     PriceBase,
                                     PriceStep: NUMERIC[2][]);
  VAR
   Idx: NUMERIC[0];
   s  : STRING[];
 BEGIN
  SETEMPTY(ScalBase, ScalStep, PriceBase, PriceStep);
  Idx:=0;
  s  :=L_Prop.getRES(Value, Idx);
  WHILE ~!s DO
   ScalBase[Idx] :=STRTOFLD(Str.Item(s, " ", 0), NUMERIC);
   ScalStep[Idx] :=STRTOFLD(Str.Item(s, " ", 1), NUMERIC);
   PriceBase[Idx]:=STRTOFLD(Str.Item(s, " ", 2), NUMERIC);
   PriceStep[Idx]:=STRTOFLD(Str.Item(s, " ", 3), NUMERIC);
   INC(Idx);
   s:=L_Prop.getRES(Value, Idx);
  END;
 END {Decode_Tariff};

 PRIVATE PROCEDURE formSet_Tariff();
  VAR
   Idx      : SCAL[MaxTariffLines];
   Fields   : FORM_FIELDS;
   ScalBase,
   ScalStep,
   PriceBase,
   PriceStep: NUMERIC[2][MaxTariffLines];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_Tariff(OwnDPro.Value, ScalBase, ScalStep, PriceBase, PriceStep);
  FOR_EACH Idx DO
   Fields(L_WDO.Fld_wIdx("ScalBase",  Idx)).Value:=ScalBase [Idx];
   Fields(L_WDO.Fld_wIdx("ScalStep",  Idx)).Value:=ScalStep [Idx];
   Fields(L_WDO.Fld_wIdx("PriceBase", Idx)).Value:=PriceBase[Idx];
   Fields(L_WDO.Fld_wIdx("PriceStep", Idx)).Value:=PriceStep[Idx];
   Tariff_SetFieldsFormat(Idx);
  END;
 END {formSet_Tariff};

 PRIVATE PROCEDURE Decode_TckOfficeShifts(Value: STRING[]; VAR Plan, Fact: TIME);
  VAR
   Item: STRING[];
 BEGIN
  Item:=L_Prop.getArrayItem(Value, 0);
  Plan:=STRTOFLD(L_Prop.getRES(Item, 0), TIME);
  Fact:=STRTOFLD(L_Prop.getRES(Item, 1), TIME);
 END {Decode_TckOfficeShifts};

 PRIVATE PROCEDURE formSet_TckOfficeShifts();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_TckOfficeShifts(OwnDPro.Value, Fields("tos_PlanTime").Value, Fields("tos_FactTime").Value);
 END {formSet_TckOfficeShifts};

 PUBLIC PROCEDURE GetP_TckOfficeShifts(    OnDate: DATE;
                                       VAR InDate: DATE;
                                       VAR Plan,
                                           Fact  : TIME);
 BEGIN
  Decode_TckOfficeShifts(GetOwnDProStrong(OnDate, P_TckOfficeShifts), Plan, Fact);
  InDate:=OwnDPro.Date;
 END {GetP_TckOfficeShifts};

 PRIVATE PROCEDURE Decode_MainTckKind(    curValue  : LIKE(OwnDPro.Value);
                                      VAR TckKindArr: LIKE(TckKind.TckKind)[]);
  VAR
   i        : NUMERIC[0];
   singleVal: LIKE(TckKind.TckKind);
 BEGIN
  SETEMPTY(TckKindArr);
  i:=0;
  LOOP
   singleVal:=STRTOFLD(L_r2r.DecodeReferenceStamp(L_Prop.getRES(curValue, i)), SCAL);
   IF !singleVal THEN
    EXIT;
   END;
   TckKindArr[i]:=singleVal;
   INC(i);
  END; (* LOOP *)
 END {Decode_MainTckKind};

 PRIVATE PROCEDURE formSet_MainTckKind();
  VAR
   i         : NUMERIC[0];
   Field     : FORM_FIELD;
   TckKindArr: LIKE(TckKind.TckKind)[100];
 BEGIN
  Decode_MainTckKind(OwnDPro.Value, TckKindArr);
  i:=0;
  LOOP
   Field:=RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("TckKind", i));
   IF !Field THEN
    EXIT;
   END;
   L_WDO.extCreateFormLink("TckKind", "", i);
   Field.Value:=TckKindArr[i];
   INC(i);
  END; (* LOOP *)
 END {formSet_MainTckKind};

 PRIVATE PROCEDURE Encode_MainTckKind(VAR Value     : LIKE(OwnDPro.Value);
                                          TckKindArr: LIKE(TckKind.TckKind)[]);
  VAR
   curTckKind: LIKE(TckKind.TckKind);
 BEGIN
  SETEMPTY(Value);
  FOR_EACH curTckKind IN TckKindArr DO
   L_Prop.putRES(Value, L_r2r.Put("OwnDPro", "TckKind", curTckKind));
  END;
 END {Encode_MainTckKind};

 PRIVATE PROCEDURE formGet_MainTckKind();
  VAR
   i         : NUMERIC[0];
   Fields    : FORM_FIELDS;
   TckKindArr: LIKE(TckKind.TckKind)[100];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  i:=0;
  SETEMPTY(TckKindArr);
  WHILE ~!Fields(L_WDO.Fld_wIdx("TckKind", i)) DO
   TckKindArr[i]:=Fields(L_WDO.Fld_wIdx("TckKind", i)).Value;
   INC(i);
  END; (* WHILE ~!Fields ... *)
  Encode_MainTckKind(OwnDPro.Value, TckKindArr);
 END {formGet_MainTckKind};

 PRIVATE PROCEDURE Decode_ACS_Parameters(    trgValue        : LIKE(OwnDPro.Value);
                                         VAR SystemType      : t_acsp_SystemType;
                                         VAR SystemServer    : STRING[];
                                         VAR DateAccount     : DATE;
                                             wOutposts       : SCAL[2]);
  VAR
   i         : NUMERIC[0];
   S, Item   : STRING[];
   trgOutpost: LIKE(ACSEvent.Outpost);
   trg_o_Enter,
   trg_o_Exit: NUMERIC[0];
 BEGIN
  IF wOutposts THEN
   IF ~DBD.FileExist(Outpost) THEN
    CreateFILE(Outpost, "", "", "");
  
    CreateFIELD(Outpost, Nbr,       NUMERIC[0],             "", "",  "", "", "");
    CreateFIELD(Outpost, Site,      STRING[16],             "", "",  "", "", "");
    CreateFIELD(Outpost, o_Enter,   NUMERIC[0],             "", "",  "", "", "");
    CreateFIELD(Outpost, o_Exit,    NUMERIC[0],             "", "",  "", "", "");
    CreateFIELD(Outpost, Name,      STRING[16],             "", "",  "", "", "");
    CreateFIELD(Outpost, Perimeter, SCAL[2],                "", "",  "", "", "");
    CreateFIELD(Outpost, Outpost,   LIKE(ACSEvent.Outpost), "", "",  "", "", "");
  
    CreateINDEX(Outpost, Nbr,     UNIQUE, "", "", Nbr);
    CreateINDEX(Outpost, o_Enter, UNIQUE, "", "", o_Enter);
    CreateINDEX(Outpost, o_Exit,  UNIQUE, "", "", o_Exit);
    CreateINDEX(Outpost, Outpost, PLURAL, "", "", Outpost);
    CreateINDEX(Outpost, Site,    PLURAL, "", "", Site);
    SetVersionOfFILE(Outpost, 0);
   END;
   L_AFM.AF_CreateTemp("Outpost", "Outpost");
  END;

  SETEMPTY(SystemServer, DateAccount);
  IF ~!trgValue THEN
   SystemType      :=L_Str.StrToScal(L_Prop.getRES(trgValue, 0));
   SystemServer    :=L_Prop.getRES(trgValue, 1);
   SETEMPTY(DateAccount);
   IF SystemType # c_acsp_SrvType_Empty THEN
    S:=L_Prop.getRES(trgValue, 2);
    IF L_Prop.IsDateValue(S, "D.N.y") THEN
     DateAccount:= STRTOFLD(S, DATE);
    END;
   END;

   IF wOutposts THEN
    Outpost.Nbr      :=0;
    Outpost.Site     :="???";
    Outpost.o_Enter  :=0;
    Outpost.o_Exit   :=0;
    Outpost.Name     :="???";
    Outpost.Perimeter:=0;
    Outpost.Outpost  :=0;
    INSERT(Outpost);

    i:=0;
    LOOP
     Item:=L_Prop.getArrayItem(trgValue, i);
     IF !Item THEN
      EXIT;
     END;
     trgOutpost:=L_Prop.getRES(Item, 5);
     IF ~!trgOutpost THEN
      trg_o_Enter:=STRTOFLD(L_Prop.getRES(Item, 1), NUMERIC);
      trg_o_Exit :=STRTOFLD(L_Prop.getRES(Item, 2), NUMERIC);
      L_General.Assert(~SEARCH(Outpost, o_Enter, trg_o_Enter), "  窠 室     " + L_Str.IntStr(trg_o_Enter));
      IF ~!trg_o_Exit THEN
       L_General.Assert(~SEARCH(Outpost, o_Exit,  trg_o_Exit),  "  窠 室     " + L_Str.IntStr(trg_o_Exit));
      END;
      Outpost.Nbr      :=i+1;
      Outpost.Site     :=L_Prop.getRES(Item, 0);
      Outpost.o_Enter  :=trg_o_Enter;
      Outpost.o_Exit   :=trg_o_Exit;
      Outpost.Name     :=L_Prop.getRES(Item, 3);
      Outpost.Perimeter:=L_Prop.getRES(Item, 4);
      Outpost.Outpost  :=trgOutpost;
      INSERT(Outpost);
     END;
     INC(i);
    END (* LOOP *);
   END;
  ELSE
   SystemType:=c_acsp_SrvType_Empty;
  END;
 END {Decode_ACS_Parameters};

 PUBLIC PROCEDURE Purge_Outposts();
 BEGIN
  L_AFM.AF_PurgeTemp("Outpost");
 END {Purge_Outposts};

 PRIVATE PROCEDURE formSet_ACS_Parameters();
  VAR
   i               : NUMERIC[0];
   Fields          : FORM_FIELDS;
   SystemType      : t_acsp_SystemType;
   SystemServer    : STRING[];
   DateAccount     : DATE;
 BEGIN
  Decode_ACS_Parameters(OwnDPro.Value, SystemType, SystemServer, DateAccount, 1);
  Fields:=RTI.Get().CurZone.Fields;
  Fields("SystemType").Format     :=acsp_SystemTypePool;
  Fields("SystemType").Value      :=SystemType;
  Fields("SystemServer").Value    :=SystemServer;
  Fields("DateAccount").Value     :=DateAccount;

  i:=1;
  LOOP
   IF !Fields(L_WDO.Fld_wIdx("Site", i)) THEN
    EXIT;
   END;
   Fields(L_WDO.Fld_wIdx("Site", i)).Template        :=L_ACS.E_GetACSSitePool();
   Fields(L_WDO.Fld_wIdx("Site", i)).TemplateIsStrict:=1;
   Fields(L_WDO.Fld_wIdx("Perimeter", i)).Format     :="|";
   SETEMPTY(Fields(L_WDO.Fld_wIdx("Site", i)).Value,
            Fields(L_WDO.Fld_wIdx("o_Enter", i)).Value,
            Fields(L_WDO.Fld_wIdx("o_Exit", i)).Value,
            Fields(L_WDO.Fld_wIdx("OutpostName", i)).Value,
            Fields(L_WDO.Fld_wIdx("Perimeter", i)).Value,
            Fields(L_WDO.Fld_wIdx("Outpost", i)).Value);
   INC(i);
  END;

  SELECT(Outpost, Nbr);
  WHILE OCCURE(Outpost) DO
   IF Outpost.Nbr # 0 THEN
    L_General.CallUs(~!Fields(L_WDO.Fld_wIdx("o_Enter", Outpost.Nbr)));
    Fields(L_WDO.Fld_wIdx("Site", Outpost.Nbr)).Value       :=Outpost.Site;
    Fields(L_WDO.Fld_wIdx("o_Enter", Outpost.Nbr)).Value    :=Outpost.o_Enter;
    Fields(L_WDO.Fld_wIdx("o_Exit", Outpost.Nbr)).Value     :=Outpost.o_Exit;
    Fields(L_WDO.Fld_wIdx("OutpostName", Outpost.Nbr)).Value:=Outpost.Name;
    Fields(L_WDO.Fld_wIdx("Perimeter", Outpost.Nbr)).Value  :=Outpost.Perimeter;
    Fields(L_WDO.Fld_wIdx("Outpost", Outpost.Nbr)).Value    :=Outpost.Outpost;
   END;
   NEXT(Outpost);
  END; (* WHILE OCCURE(Outpost) ... *)

  Purge_Outposts();

  acsp_SetField();
 END {formSet_ACS_Parameters};

 PRIVATE PROCEDURE formGet_ACS_Parameters();
  VAR
   i         : NUMERIC[0];
   S         : STRING[];
   Fields    : FORM_FIELDS;
   SystemType: t_acsp_SystemType;
   FillLine,
   EmptyLine : SCAL[2];
 BEGIN
  Fields    :=RTI.Get().CurZone.Fields;
  SystemType:=Fields("SystemType").Value;
  IF (SystemType # c_acsp_SrvType_Empty) & (!Fields("SystemServer").Value) THEN
   L_StdFrm.Choice("  設 ࢥ ");
  END;
  L_Prop.putRES(OwnDPro.Value, SystemType);
  L_Prop.putRES(OwnDPro.Value, Fields("SystemServer").Value);
  IF ~!Fields("DateAccount").Value THEN
   L_Prop.putRES(OwnDPro.Value, FLDTOSTR(Fields("DateAccount").Value, "D.N.y"));
  ELSE
   L_Prop.putRES(OwnDPro.Value, "");
  END;

  i:=1;
  LOOP
   IF !Fields(L_WDO.Fld_wIdx("o_Enter", i)) THEN
    EXIT;
   END;
   S:=Str.Condense(Fields(L_WDO.Fld_wIdx("Site", i)).Value + ";" +
                   L_Str.IntStr(Fields(L_WDO.Fld_wIdx("o_Enter", i)).Value) + ";" +
                   L_Str.IntStr(Fields(L_WDO.Fld_wIdx("o_Exit", i)).Value) + ";" +
                   Fields(L_WDO.Fld_wIdx("OutpostName", i)).Value + ";" +
                   FLDTOSTR(Fields(L_WDO.Fld_wIdx("Perimeter", i)).Value, "N0", 0) + ";" +
                   FLDTOSTR(Fields(L_WDO.Fld_wIdx("Outpost", i)).Value, "N0", 0));
   FillLine :=~!Fields(L_WDO.Fld_wIdx("Site", i)).Value &
              ~!Fields(L_WDO.Fld_wIdx("OutpostName", i)).Value &
              ~!Fields(L_WDO.Fld_wIdx("Perimeter", i)).Value &
              ~!Fields(L_WDO.Fld_wIdx("Outpost", i)).Value;
   EmptyLine:=!Fields(L_WDO.Fld_wIdx("Site", i)).Value &
              !Fields(L_WDO.Fld_wIdx("OutpostName", i)).Value &
              !Fields(L_WDO.Fld_wIdx("Perimeter", i)).Value &
              !Fields(L_WDO.Fld_wIdx("Outpost", i)).Value;

   IF SystemType # c_acsp_SrvType_Perco_S20 THEN
    FillLine :=FillLine  & ~!Fields(L_WDO.Fld_wIdx("o_Enter", i)).Value;
    EmptyLine:=EmptyLine &  !Fields(L_WDO.Fld_wIdx("o_Enter", i)).Value;
   ELSE
    FillLine :=FillLine  & (~!Fields(L_WDO.Fld_wIdx("o_Enter", i)).Value | ~!Fields(L_WDO.Fld_wIdx("o_Exit", i)).Value);
    EmptyLine:=EmptyLine & ( !Fields(L_WDO.Fld_wIdx("o_Enter", i)).Value |  !Fields(L_WDO.Fld_wIdx("o_Exit", i)).Value);
   END;

   L_General.Assert(EmptyLine # FillLine,
                    "ப " + L_Str.IntStr(i + 1) + ":|" +
                    "      ६");

   IF SystemType = c_acsp_SrvType_Perco_S20 THEN
    IF FillLine THEN
     IF    !Fields(L_WDO.Fld_wIdx("o_Enter", i)).Value THEN
      L_StdFrm.Choice(" 㪠  窨 室");
     ELSIF !Fields(L_WDO.Fld_wIdx("o_Exit", i)).Value THEN
      L_StdFrm.Choice(" 㪠  窨 室");
     END;
    END;
   END;

   L_Prop.putArrayItem(OwnDPro.Value, S);
   INC(i);
  END;
 END {formGet_ACS_Parameters};

 PRIVATE PROCEDURE Decode_OwnDPro(trgValue   : LIKE(OwnDPro.Value);
                                  trgProperty: LIKE(OwnDPro.Property)): LIKE(OwnDPro.Value);
 BEGIN
  L_General.CallUs(~!IsSimpleUserOf(trgProperty));
  RETURN L_r2r.DecodeReferenceStamp(trgValue);
 END {Decode_OwnDPro};

 PRIVATE PROCEDURE formSet_OwnDPro(trgProperty: LIKE(OwnDPro.Property));
  VAR
   W: FORM_WINDOW;
   Z: FORM_ZONE;
 BEGIN
  W:=RTI.Get().CurWindow;
  Z:=RTI.Get().CurZone;
  IF W.OriginalName = wLinkWindowName THEN
   WHILE Z.Links.Count DO
    Z.Links.Remove(Z.Links(0));
   END;
   L_WDO.CreateFormLink_Simple(IsSimpleUserOf(Property.Property), "Value");
   Z.Fields("Value").Value:=Decode_OwnDPro((^(Z.MasterTable.Fields("Value").ObtainName())), trgProperty);
  END;
 END {formSet_OwnDPro};

 PUBLIC PROCEDURE Decode_Commiss(    Value            : STRING[];
                                 VAR Chairman         : LIKE(Staff.TSN);
                                 VAR Members          : LIKE(Staff.TSN)[CommissMembersAmnt];
                                 VAR OrderOfCommission: STRING[]);
  VAR
   Idx       : SCAL[CommissMembersAmnt];
   AllMembers: STRING[];
 BEGIN
  AllMembers:=Str.Item(Value, " ", 0);
  Chairman  :=STRTOFLD(L_r2r.DecodeReferenceStamp(L_Prop.getRES(AllMembers, 0)), SCAL);
  FOR_EACH Idx DO
   Members[Idx]:=STRTOFLD(L_r2r.DecodeReferenceStamp(L_Prop.getRES(AllMembers, Idx + 1)), SCAL);
  END;
  OrderOfCommission:=Str.Slice(Value, Str.Pos(Value, " ") + 1, Str.Length(Value) - Str.Pos(Value, " "));
 END {Decode_Commiss};

 PRIVATE PROCEDURE formSet_Commiss();
  VAR
   Idx              : SCAL[CommissMembersAmnt];
   Fields           : FORM_FIELDS;
   Chairman         : LIKE(Staff.TSN);
   Members          : LIKE(Staff.TSN)[CommissMembersAmnt];
   OrderOfCommission: STRING[];
 BEGIN
  Decode_Commiss(OwnDPro.Value, Chairman, Members, OrderOfCommission);
  Fields:=RTI.Get().CurZone.Fields;
  L_WDO.CreateFormLink("Staff", "Chairman");
  Fields("ChairmanTSN").Value:=Chairman;
  FOR_EACH Idx DO
   IF ~!Fields(L_WDO.Fld_wIdx("MemberTSN", Idx)) THEN
    L_WDO.extCreateFormLink("Staff", "Member", Idx);
    Fields(L_WDO.Fld_wIdx("MemberTSN", Idx)).Value:=Members[Idx];
   END;
  END;
  Fields("OrderOfCommission").Value:=OrderOfCommission;
 END {formSet_Commiss};

 PRIVATE PROCEDURE formSet_RetirementCommiss();
 BEGIN
  formSet_Commiss();
 END {formSet_RetirementCommiss};

 PRIVATE PROCEDURE formSet_RAccidCommiss();
 BEGIN
  formSet_Commiss();
 END {formSet_RAccidCommiss};

 PRIVATE PROCEDURE Encode_Commiss(VAR Value            : STRING[];
                                      Chairman         : LIKE(Staff.TSN);
                                      Members          : LIKE(Staff.TSN)[CommissMembersAmnt];
                                      OrderOfCommission: STRING[]);
  VAR
   Idx: SCAL[CommissMembersAmnt];
 BEGIN
  L_Prop.putRES(Value, L_r2r.Put("OwnDPro", "Staff", Chairman));
  FOR_EACH Idx DO
   IF ~!Members[Idx] THEN
    L_Prop.putRES(Value, L_r2r.Put("OwnDPro", "Staff", Members[Idx]));
   END;
  END;
  Value:=Value + " " + OrderOfCommission;
 END {Encode_Commiss};

 PRIVATE PROCEDURE formGet_Commiss();
  VAR
   Idx    : SCAL[CommissMembersAmnt];
   Fields : FORM_FIELDS;
   Members: LIKE(Staff.TSN)[CommissMembersAmnt];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  SETEMPTY(Members);
  FOR_EACH Idx DO
   IF ~!Fields(L_WDO.Fld_wIdx("MemberTSN", Idx)) THEN
    Members[Idx]:=Fields(L_WDO.Fld_wIdx("MemberTSN", Idx)).Value;
   END;
  END;
  Encode_Commiss(OwnDPro.Value, Fields("ChairmanTSN").Value, Members, Fields("OrderOfCommission").Value);
 END {formGet_Commiss};

 PRIVATE PROCEDURE formGet_RetirementCommiss();
 BEGIN
  formGet_Commiss();
 END {formGet_RetirementCommiss};

 PRIVATE PROCEDURE formGet_RAccidCommiss();
 BEGIN
  formGet_Commiss();
 END {formGet_RAccidCommiss};

 PRIVATE PROCEDURE fnc_SetFieldFormats(Idx: NUMERIC[0]);
  VAR
   fModifiable,
   fNotEmpty   : SCAL[2];
   Fields      : FORM_FIELDS;
 BEGIN
  Fields     :=RTI.Get().CurZone.Fields;
  fModifiable:=(Idx=0) | P_Firm.E_wMultipleMyFirm(OwnDPro.Date);
  fNotEmpty  :=(Idx=0) | ~!Fields(L_WDO.Fld_wIdx("MyFirm", Idx)).Value;
  Fields(L_WDO.Fld_wIdx("MyFirm",   Idx)).Modifiable    :=P_Firm.E_wMultipleMyFirm(OwnDPro.Date);
  Fields(L_WDO.Fld_wIdx("FNC_Move", Idx)).Modifiable    :=fModifiable;
  Fields(L_WDO.Fld_wIdx("FNC_Heat", Idx)).Modifiable    :=fModifiable;
  Fields(L_WDO.Fld_wIdx("FNC_Warm", Idx)).Modifiable    :=fModifiable;
  Fields(L_WDO.Fld_wIdx("FNC_Move", Idx)).MustBeNonempty:=fNotEmpty;
  Fields(L_WDO.Fld_wIdx("FNC_Heat", Idx)).MustBeNonempty:=fNotEmpty;
  Fields(L_WDO.Fld_wIdx("FNC_Warm", Idx)).MustBeNonempty:=fNotEmpty;
 END {fnc_SetFieldFormats};

 PRIVATE PROCEDURE fnc_SE_WFD();
  VAR
   Idx: SCAL[fnc_Amount];
 BEGIN
  IF ~P_Firm.E_wMultipleMyFirm(OwnDPro.Date) THEN
   IF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit) |
      (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert) THEN
    RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("MyFirm", 0)).Value:=L_Str.IntStr(P_Firm.mf_Own);
    FIXALTERING();
   END;
  END;
  FOR_EACH Idx DO
   fnc_SetFieldFormats(Idx);
  END;
 END {fnc_SE_WFD};

 PUBLIC PROCEDURE Decode_FuelNormCorrection(    curValue: STRING[];
                                            VAR MF      : LIKE(MyFirm.MyFirm)[fnc_Amount];
                                            VAR FNC_Move,
                                                FNC_Heat,
                                                FNC_Warm: NUMERIC[3][fnc_Amount]);
  VAR
   Idx        : SCAL[fnc_Amount];
   SingleValue: STRING[];
 BEGIN
  FOR_EACH Idx DO
   SingleValue  :=L_Prop.getArrayItem(curValue, Idx);
   MF      [Idx]:=STRTOFLD(L_r2r.DecodeReferenceStamp(L_Prop.getRES(SingleValue, 0)), SCAL);
   FNC_Move[Idx]:=STRTOFLD(L_Prop.getRES(SingleValue, 1), NUMERIC);
   FNC_Heat[Idx]:=STRTOFLD(L_Prop.getRES(SingleValue, 2), NUMERIC);
   FNC_Warm[Idx]:=STRTOFLD(L_Prop.getRES(SingleValue, 3), NUMERIC);
  END;
 END {Decode_FuelNormCorrection};

 PRIVATE PROCEDURE formSet_FuelNormCorrection();
  VAR
   Idx      : SCAL[fnc_Amount];
   MF       : LIKE(MyFirm.MyFirm)[fnc_Amount];
   FNC_Move,
   FNC_Heat,
   FNC_Warm : NUMERIC[3][fnc_Amount];
   Fields   : FORM_FIELDS;
 BEGIN
  Decode_FuelNormCorrection(OwnDPro.Value, MF, FNC_Move, FNC_Heat, FNC_Warm);
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   L_WDO.extCreateFormLink("MyFirm", "", Idx);
   Fields(L_WDO.Fld_wIdx("MyFirm",   Idx)).Value:=MF[Idx];
   Fields(L_WDO.Fld_wIdx("FNC_Move", Idx)).Value:=FNC_Move[Idx];
   Fields(L_WDO.Fld_wIdx("FNC_Heat", Idx)).Value:=FNC_Heat[Idx];
   Fields(L_WDO.Fld_wIdx("FNC_Warm", Idx)).Value:=FNC_Warm[Idx];
  END;
  fnc_SE_WFD();
 END {formSet_FuelNormCorrection};

 PRIVATE PROCEDURE Encode_FuelNormCorrection(VAR dstValue: STRING[];
                                                 MF      : STRING[][fnc_Amount];
                                                 FNC_Move,
                                                 FNC_Heat,
                                                 FNC_Warm: NUMERIC[3][fnc_Amount]);
  VAR
   Idx        : SCAL[fnc_Amount];
   SingleValue: STRING[];
 BEGIN
  FOR_EACH Idx DO
   IF ~!MF[Idx] THEN
    SETEMPTY(SingleValue);
    L_Prop.putRES(SingleValue, L_r2r.Put("OwnDPro", "MyFirm", MF[Idx]));
    L_Prop.putREV(SingleValue, FNC_Move[Idx]);
    L_Prop.putREV(SingleValue, FNC_Heat[Idx]);
    L_Prop.putREV(SingleValue, FNC_Warm[Idx]);
    L_Prop.putAIS(dstValue, SingleValue);
   END;
  END;
 END {Encode_FuelNormCorrection};

 PRIVATE PROCEDURE formGet_FuelNormCorrection();
  VAR
   Idx      : SCAL[fnc_Amount];
   MF       : STRING[][fnc_Amount];
   FNC_Move,
   FNC_Heat,
   FNC_Warm : NUMERIC[3][fnc_Amount];
   Fields   : FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   MF      [Idx]:=Fields(L_WDO.Fld_wIdx("MyFirm",   Idx)).Value;
   FNC_Move[Idx]:=Fields(L_WDO.Fld_wIdx("FNC_Move", Idx)).Value;
   FNC_Heat[Idx]:=Fields(L_WDO.Fld_wIdx("FNC_Heat", Idx)).Value;
   FNC_Warm[Idx]:=Fields(L_WDO.Fld_wIdx("FNC_Warm", Idx)).Value;
   IF ~!FNC_Move[Idx] & ~!FNC_Heat[Idx] & ~!FNC_Warm[Idx] THEN
    IF Idx # 0 THEN
     L_General.Assert(~!MF[0], "  '' ࣠  ࢮ ப." +
                               "|稥 㣨 ப ⨬.");
     L_General.Assert(~!MF[Idx], " '' ࣠  㪠뢠 ⮫쪮  ࢮ ப");
    END;
   ELSE
    L_General.Assert(!MF[Idx], " 㪠 ४஢  '' ࣠樨 " + MF[Idx]);
   END;
  END;
  Encode_FuelNormCorrection(OwnDPro.Value, MF, FNC_Move, FNC_Heat, FNC_Warm);
 END {formGet_FuelNormCorrection};

 PRIVATE PROCEDURE Decode_DspControlTimes(Value: STRING[]; VAR DspRepTime, DspPassTime: TIME);
 BEGIN
  DspRepTime :=STRTOFLD(L_Prop.getRES(Value, 0), TIME, "H:M");
  DspPassTime:=STRTOFLD(L_Prop.getRES(Value, 1), TIME, "H:M");
 END {Decode_DspControlTimes};

 PRIVATE PROCEDURE formSet_DspControlTimes();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_DspControlTimes(OwnDPro.Value, Fields("DspRepTime").Value, Fields("DspPassTime").Value);
 END {formSet_DspControlTimes};

 PRIVATE PROCEDURE Decode_MessageInWayDoc(Value: STRING[]; VAR MessageToDriver, MessageToGuard: STRING[]);
 BEGIN
  MessageToDriver:=L_Prop.getArrayItem(Value, 0);
  MessageToGuard :=L_Prop.getArrayItem(Value, 1);
 END {Decode_MessageInWayDoc};

 PRIVATE PROCEDURE formSet_MessageInWayDoc();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_MessageInWayDoc(OwnDPro.Value, Fields("MessageToDriver").Value, Fields("MessageToGuard").Value);
 END {formSet_MessageInWayDoc};

 PRIVATE PROCEDURE Decode_Temperature(Value: STRING[]; VAR DayTemp, NightTemp: NUMERIC[2]);
 BEGIN
  DayTemp  :=STRTOFLD(L_Prop.getRES(Value, 0), NUMERIC);
  NightTemp:=STRTOFLD(L_Prop.getRES(Value, 1), NUMERIC);
 END {Decode_Temperature};

 PRIVATE PROCEDURE formSet_Temperature();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_Temperature(OwnDPro.Value, Fields("DayTemp").Value, Fields("NightTemp").Value);
 END {formSet_Temperature};

 PRIVATE PROCEDURE Decode_SalesVolumes(Value: STRING[]; VAR Taxable, NotTaxable: NUMERIC[2]);
 BEGIN
  Taxable   :=STRTOFLD(L_Prop.getRES(Value, 0), NUMERIC);
  NotTaxable:=STRTOFLD(L_Prop.getRES(Value, 1), NUMERIC);
 END {Decode_SalesVolumes};

 PRIVATE PROCEDURE formSet_SalesVolumes();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_SalesVolumes(OwnDPro.Value, Fields("Taxable").Value, Fields("NotTaxable").Value);
 END {formSet_SalesVolumes};

 PUBLIC PROCEDURE Decode_PasVolNorm(    Value: STRING[];
                                    VAR Full_Big,
                                        Full_VeryBig,
                                        Stand_Big,
                                        Stand_VeryBig,
                                        Full_Small,
                                        Stand_Small,
                                        Full_Middle,
                                        Stand_Middle: NUMERIC[1]);
 BEGIN
  Full_Big     :=STRTOFLD(L_Prop.getRES(Value, 0), NUMERIC);
  Full_VeryBig :=STRTOFLD(L_Prop.getRES(Value, 1), NUMERIC);
  Stand_Big    :=STRTOFLD(L_Prop.getRES(Value, 2), NUMERIC);
  Stand_VeryBig:=STRTOFLD(L_Prop.getRES(Value, 3), NUMERIC);
  Full_Small   :=STRTOFLD(L_Prop.getRES(Value, 4), NUMERIC);
  Stand_Small  :=STRTOFLD(L_Prop.getRES(Value, 5), NUMERIC);
  Full_Middle  :=STRTOFLD(L_Prop.getRES(Value, 6), NUMERIC);
  Stand_Middle :=STRTOFLD(L_Prop.getRES(Value, 7), NUMERIC);
 END {Decode_PasVolNorm};

 PRIVATE PROCEDURE formSet_PasVolNorm();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_PasVolNorm(OwnDPro.Value,
                    Fields("Full_Big").Value,
                    Fields("Full_VeryBig").Value,
                    Fields("Stand_Big").Value,
                    Fields("Stand_VeryBig").Value,
                    Fields("Full_Small").Value,
                    Fields("Stand_Small").Value,
                    Fields("Full_Middle").Value,
                    Fields("Stand_Middle").Value);
 END {formSet_PasVolNorm};

 PRIVATE PROCEDURE Encode_PasVolNorm(VAR Value: STRING[];
                                         Full_Big,
                                         Full_VeryBig,
                                         Stand_Big,
                                         Stand_VeryBig,
                                         Full_Small,
                                         Stand_Small,
                                         Full_Middle,
                                         Stand_Middle: NUMERIC[1]);
 BEGIN
  L_Prop.putRES(Value, FLDTOSTR(Full_Big,      "1.", 0));
  L_Prop.putRES(Value, FLDTOSTR(Full_VeryBig,  "1.", 0));
  L_Prop.putRES(Value, FLDTOSTR(Stand_Big,     "1.", 0));
  L_Prop.putRES(Value, FLDTOSTR(Stand_VeryBig, "1.", 0));
  L_Prop.putRES(Value, FLDTOSTR(Full_Small,    "1.", 0));
  L_Prop.putRES(Value, FLDTOSTR(Stand_Small,   "1.", 0));
  L_Prop.putRES(Value, FLDTOSTR(Full_Middle,   "1.", 0));
  L_Prop.putRES(Value, FLDTOSTR(Stand_Middle,  "1.", 0));
 END {Encode_PasVolNorm};

 PRIVATE PROCEDURE formGet_PasVolNorm();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_PasVolNorm(OwnDPro.Value,
                    Fields("Full_Big").Value,
                    Fields("Full_VeryBig").Value,
                    Fields("Stand_Big").Value,
                    Fields("Stand_VeryBig").Value,
                    Fields("Full_Small").Value,
                    Fields("Stand_Small").Value,
                    Fields("Full_Middle").Value,
                    Fields("Stand_Middle").Value);
 END {formGet_PasVolNorm};

 PRIVATE PROCEDURE Decode_InternetSettings(    Value              : STRING[];
                                           VAR SMTPServer         : STRING[];
                                           VAR UseDedicatedLine   : SCAL[2];
                                           VAR EMailDomain        : STRING[];
                                           VAR SprtCrspSendChannel: STRING[];
                                           VAR UseProtectedChnl   : SCAL[2];
                                           VAR wAuthentication    : SCAL[2]);
 BEGIN
  SMTPServer         :=L_Prop.getRES(Value, 0);
  UseDedicatedLine   :=L_Str.PositionInPool(udl_Pool, L_Prop.getRES(Value, 1));
  EMailDomain        :=L_Prop.getRES(Value, 2);
  SprtCrspSendChannel:=L_Prop.getRES(Value, 3);
  UseProtectedChnl   :=L_Str.PositionInPool(upc_Pool, L_Prop.getRES(Value, 4));
  wAuthentication    :=L_Str.PositionInPool(wa_Pool,  L_Prop.getRES(Value, 5));
  IF !UseProtectedChnl THEN
   UseProtectedChnl:=1;
  END;
  IF !wAuthentication THEN
   wAuthentication:=0;
  END;
 END {Decode_InternetSettings};

 PRIVATE PROCEDURE formSet_InternetSettings();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("UseDedicatedLine").Format             :=udl_Pool;
  Fields("UseProtectedChnl").Format             :=upc_Pool;
  Fields("wAuthentication").Format              :=wa_Pool;
  Fields("SprtCrspSendChannel").Template        :=scsc_Pool;
  Fields("SprtCrspSendChannel").TemplateIsStrict:=1;
  Decode_InternetSettings(OwnDPro.Value,
                          Fields("SMTPServer").Value,
                          Fields("UseDedicatedLine").Value,
                          Fields("EMailDomain").Value,
                          Fields("SprtCrspSendChannel").Value,
                          Fields("UseProtectedChnl").Value,
                          Fields("wAuthentication").Value);
 END {formSet_InternetSettings};

 PRIVATE PROCEDURE ArrayItemMove_UnusualWayIncPlan(Dir: NUMERIC[0]);
 BEGIN
  L_Prop.ArrayItemMove(Dir, ["ExitMask", "WDWay", "WDInc", "PlEqFc", "CorrPlan"]);
 END {ArrayItemMove_UnusualWayIncPlan};

 PRIVATE PROCEDURE SetCDWeekDay();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF SEARCH(Calendar, Date, OwnDPro.Date) THEN
   Fields("ClndWDInc").Value:=Calendar.WDInc;
   Fields("ClndWDWay").Value:=Calendar.WDWay;
  ELSE
   SETEMPTY(Fields("ClndWDInc").Value, Fields("ClndWDWay").Value);
  END;
 END {SetCDWeekDay};

 PRIVATE PROCEDURE Decode_UnusualWayIncPlan(    Value   : STRING[];
                                            VAR ExitMask: STRING[9][];
                                            VAR WDInc,
                                                WDWay   : SCAL[9][];
                                            VAR PlEqFc  : SCAL[2][];
                                            VAR CorrPlan: NUMERIC[1][]);
  VAR
   S  : STRING[];
   Idx: NUMERIC[0];
 BEGIN
  SETEMPTY(ExitMask, WDInc, WDWay, PlEqFc, CorrPlan);
  Idx:=0;
  LOOP
   S:=L_Prop.getRES(Value, Idx);
   IF !S THEN
    EXIT;
   END;
   ExitMask[Idx]:=Str.Item(S, " ", 0);
   WDWay[Idx]   :=STRTOFLD(Str.Item(S, " ", 1), SCAL);
   WDInc[Idx]   :=STRTOFLD(Str.Item(S, " ", 2), SCAL);
   PlEqFc[Idx]  :=STRTOFLD(Str.Item(S, " ", 3), SCAL);
   CorrPlan[Idx]:=STRTOFLD(Str.Item(S, " ", 4), NUMERIC);
   INC(Idx);
  END; (* LOOP *)
 END {Decode_UnusualWayIncPlan};

 PRIVATE PROCEDURE formSet_UnusualWayIncPlan();
  VAR
   Idx     : NUMERIC[0];
   Fields  : FORM_FIELDS;
   ExitMask: STRING[9][MaxUCDLines];
   WDInc,
   WDWay   : SCAL[9][MaxUCDLines];
   PlEqFc  : SCAL[2][MaxUCDLines];
   CorrPlan: NUMERIC[1][MaxUCDLines];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_UnusualWayIncPlan(OwnDPro.Value, ExitMask, WDInc, WDWay, PlEqFc, CorrPlan);
  SetCDWeekDay();
  Fields("ClndWDWay").Format:=L_DatTim.WDStr_0;
  Fields("ClndWDInc").Format:=L_DatTim.WDStr_0;
  Idx:=0;
  LOOP
   IF !Fields(L_WDO.Fld_wIdx("ExitMask", Idx)) THEN
    EXIT;
   END;
   Fields(L_WDO.Fld_wIdx("WDInc",    Idx)).Format:=L_DatTim.WDStr_0 + "| ";
   Fields(L_WDO.Fld_wIdx("WDWay",    Idx)).Format:=L_DatTim.WDStr_0 + "| ";
   Fields(L_WDO.Fld_wIdx("PlEqFc",   Idx)).Format:="|";
   Fields(L_WDO.Fld_wIdx("ExitMask", Idx)).Value :=ExitMask[Idx];
   Fields(L_WDO.Fld_wIdx("WDInc",    Idx)).Value :=WDInc   [Idx];
   Fields(L_WDO.Fld_wIdx("WDWay",    Idx)).Value :=WDWay   [Idx];
   Fields(L_WDO.Fld_wIdx("PlEqFc",   Idx)).Value :=PlEqFc  [Idx];
   IF PlEqFc[Idx] = 0 THEN
    Fields(L_WDO.Fld_wIdx("CorrPlan", Idx)).Value :=CorrPlan[Idx];
   END;
   Fields(L_WDO.Fld_wIdx("CorrPlan", Idx)).Modifiable:=PlEqFc[Idx] = 0;

   INC(Idx);
  END; (* LOOP *)
 END {formSet_UnusualWayIncPlan};

 PUBLIC PROCEDURE SetDataInForm(trgProperty: LIKE(Property.Property));
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF    trgProperty = P_UnusualWayIncPlan        THEN formSet_UnusualWayIncPlan();
  ELSIF trgProperty = P_PFRTuning                THEN SetPFRTuningData(Fields("PacketSize").Value, Fields("AnkPacketSize").Value);
  ELSIF trgProperty = P_MessageInWayDoc          THEN formSet_MessageInWayDoc();
  ELSIF trgProperty = P_InternetSettings         THEN formSet_InternetSettings();
  ELSIF trgProperty = P_RetirementCommiss        THEN formSet_RetirementCommiss();
  ELSIF trgProperty = P_RAccidCommiss            THEN formSet_RAccidCommiss();
  ELSIF trgProperty = P_BackupPath               THEN bp_SetDataInForm();
  ELSIF trgProperty = P_DspControlTimes          THEN formSet_DspControlTimes();
  ELSIF trgProperty = P_FuelNormCorrection       THEN formSet_FuelNormCorrection();
  ELSIF trgProperty = P_Temperature              THEN formSet_Temperature();
  ELSIF trgProperty = P_SalesVolumes             THEN formSet_SalesVolumes();
  ELSIF trgProperty = P_Tariff                   THEN formSet_Tariff();
  ELSIF trgProperty = P_PasVolNorm               THEN formSet_PasVolNorm();
  ELSIF trgProperty = P_TckOfficeShifts          THEN formSet_TckOfficeShifts();
  ELSIF trgProperty = P_MainTckKind              THEN formSet_MainTckKind();
  ELSIF trgProperty = P_ACS_Parameters           THEN formSet_ACS_Parameters();
  ELSIF ~!IsSimpleUserOf(trgProperty)            THEN formSet_OwnDPro(trgProperty);
  END;
 END {SetDataInForm};

 PRIVATE PROCEDURE GetPFRTuningData();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  OwnDPro.Value:="";
  Fields:=RTI.Get().CurZone.Fields;
  L_Prop.putREV(OwnDPro.Value, Fields("PacketSize").Value);
  L_Prop.putREV(OwnDPro.Value, Fields("AnkPacketSize").Value);
 END {GetPFRTuningData};

 PRIVATE PROCEDURE Encode_DspControlTimes(VAR Value: STRING[]; DspRepTime, DspPassTime: TIME);
 BEGIN
  IF ~!DspRepTime | ~!DspPassTime THEN
   L_Prop.putRES(Value, FLDTOSTR(DspRepTime,  "H:M"));
   L_Prop.putRES(Value, FLDTOSTR(DspPassTime, "H:M"));
  END;
 END {Encode_DspControlTimes};

 PRIVATE PROCEDURE formGet_DspControlTimes();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_DspControlTimes(OwnDPro.Value, Fields("DspRepTime").Value, Fields("DspPassTime").Value);
 END {formGet_DspControlTimes};

 PRIVATE PROCEDURE Encode_MessageInWayDoc(VAR Value: STRING[]; MessageToDriver, MessageToGuard: STRING[]);
 BEGIN
  IF ~!MessageToDriver | ~!MessageToGuard THEN
   L_Prop.putArrayItem(Value, MessageToDriver);
   L_Prop.putArrayItem(Value, MessageToGuard);
  END;
 END {Encode_MessageInWayDoc};

 PRIVATE PROCEDURE formGet_MessageInWayDoc();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_MessageInWayDoc(OwnDPro.Value, Fields("MessageToDriver").Value, Fields("MessageToGuard").Value);
 END {formGet_MessageInWayDoc};

 PRIVATE PROCEDURE Encode_TckOfficeShifts(VAR Value: STRING[]; Plan, Fact: TIME);
  VAR
   Item: STRING[];
 BEGIN
  SETEMPTY(Item);
  L_Prop.putRET(Item, Plan);
  L_Prop.putRET(Item, Fact);
  SETEMPTY(Value);
  L_Prop.putArrayItem(Value, Item);
 END {Encode_TckOfficeShifts};

 PRIVATE PROCEDURE formGet_TckOfficeShifts();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_TckOfficeShifts(OwnDPro.Value, Fields("tos_PlanTime").Value, Fields("tos_FactTime").Value);
 END {formGet_TckOfficeShifts};

 PUBLIC PROCEDURE SetP_TckOfficeShifts(D: DATE; Fact: TIME);
  VAR
   Value: STRING[];
   Plan : TIME;
   Dummy: TIME;
 BEGIN
  Value:=GetOwnDProStrong(D, P_TckOfficeShifts);
  Decode_TckOfficeShifts(Value, Plan, Dummy);
  Encode_TckOfficeShifts(Value, Plan, Fact);
  IF OwnDPro.Date # D THEN
   InsertProperty(D, P_TckOfficeShifts, Value, 0, "",
                  LOGINNAME() + ": " + L_DatTim.CompleteSystimeStr(),
                  EMPTYOF(DATE), EMPTYOF(DATE));
  ELSE
   OwnDPro.Value:=Value;
   REPLACE(OwnDPro);
  END;
 END {SetP_TckOfficeShifts};

 PRIVATE PROCEDURE Encode_Temperature(VAR Value: STRING[]; DayTemp, NightTemp: NUMERIC[2]);
 BEGIN
  IF ~!DayTemp | ~!NightTemp THEN
   L_Prop.putRES(Value, FLDTOSTR(DayTemp,   "2."));
   L_Prop.putRES(Value, FLDTOSTR(NightTemp, "2."));
  END;
 END {Encode_Temperature};

 PRIVATE PROCEDURE formGet_Temperature();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_Temperature(OwnDPro.Value, Fields("DayTemp").Value, Fields("NightTemp").Value);
 END {formGet_Temperature};

 PRIVATE PROCEDURE Encode_SalesVolumes(VAR Value: STRING[]; Taxable, NotTaxable: NUMERIC[2]);
 BEGIN
  IF ~!Taxable | ~!NotTaxable THEN
   L_Prop.putRES(Value, FLDTOSTR(Taxable,    "2."));
   L_Prop.putRES(Value, FLDTOSTR(NotTaxable, "2."));
  END;
 END {Encode_SalesVolumes};

 PRIVATE PROCEDURE formGet_SalesVolumes();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_SalesVolumes(OwnDPro.Value, Fields("Taxable").Value, Fields("NotTaxable").Value);
 END {formGet_SalesVolumes};

 PRIVATE PROCEDURE Encode_InternetSettings(VAR Value              : STRING[];
                                               SMTPServer         : STRING[];
                                               UseDedicatedLine   : SCAL[2];
                                               EMailDomain        : STRING[];
                                               SprtCrspSendChannel: STRING[];
                                               UseProtectedChnl   : SCAL[2];
                                               wAuthentication    : SCAL[2]);
 BEGIN
  IF ~!SMTPServer | ~!UseDedicatedLine | ~!EMailDomain | ~!SprtCrspSendChannel |
     ~!UseProtectedChnl | ~!wAuthentication THEN
   L_Prop.putREV(Value, SMTPServer);
   L_Prop.putRES(Value, L_Str.PoolItem(udl_Pool, UseDedicatedLine));
   L_Prop.putREV(Value, EMailDomain);
   L_Prop.putREV(Value, SprtCrspSendChannel);
   L_Prop.putRES(Value, L_Str.PoolItem(upc_Pool, UseProtectedChnl));
   L_Prop.putRES(Value, L_Str.PoolItem(wa_Pool,  wAuthentication));
  END;
 END {Encode_InternetSettings};

 PRIVATE PROCEDURE formGet_InternetSettings();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_InternetSettings(OwnDPro.Value,
                          Fields("SMTPServer").Value,
                          Fields("UseDedicatedLine").Value,
                          Fields("EMailDomain").Value,
                          Fields("SprtCrspSendChannel").Value,
                          Fields("UseProtectedChnl").Value,
                          Fields("wAuthentication").Value);
 END {formGet_InternetSettings};

 PRIVATE PROCEDURE Encode_Tariff(VAR Value    : STRING[];
                                     ScalBase,
                                     ScalStep,
                                     PriceBase,
                                     PriceStep: NUMERIC[2][]);
  VAR
   Idx   : NUMERIC[0];
   Record: STRING[];
 BEGIN
  Idx:=0;
  WHILE ~!ScalBase[Idx] DO
   Record:=FLDTOSTR(ScalBase[Idx],  "2.", 0) + " " +
           FLDTOSTR(ScalStep[Idx],  "2.", 0) + " " +
           FLDTOSTR(PriceBase[Idx], "2.", 0) + " " +
           FLDTOSTR(PriceStep[Idx], "2.", 0);
   L_Prop.putREV(Value, Record);
   INC(Idx);
  END;
 END {Encode_Tariff};

 PRIVATE PROCEDURE formGet_Tariff();
  VAR
   Idx      : SCAL[MaxTariffLines];
   Fields   : FORM_FIELDS;
   ScalBase,
   ScalStep,
   PriceBase,
   PriceStep: NUMERIC[2][MaxTariffLines];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  FOR_EACH Idx DO
   ScalBase [Idx]:=Fields(L_WDO.Fld_wIdx("ScalBase",  Idx)).Value;
   ScalStep [Idx]:=Fields(L_WDO.Fld_wIdx("ScalStep",  Idx)).Value;
   PriceBase[Idx]:=Fields(L_WDO.Fld_wIdx("PriceBase", Idx)).Value;
   PriceStep[Idx]:=Fields(L_WDO.Fld_wIdx("PriceStep", Idx)).Value;
  END;
  Encode_Tariff(OwnDPro.Value, ScalBase, ScalStep, PriceBase, PriceStep);
 END {formGet_Tariff};

 PRIVATE PROCEDURE formGet_UnusualWayIncPlan();
  VAR
   Idx      : NUMERIC[0];
   Record   : STRING[];
   Fields   : FORM_FIELDS;
   ExitMask : STRING[9];
   WDInc,
   WDWay    : SCAL[9];
   PlEqFc   : SCAL[2];
   CorrPlan : NUMERIC[1];
   FillLine,
   EmptyLine: SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Idx   :=0;
  LOOP
   IF !Fields(L_WDO.Fld_wIdx("ExitMask", Idx)) THEN
    EXIT;
   END;

   ExitMask:=Fields(L_WDO.Fld_wIdx("ExitMask", Idx)).Value;
   WDInc   :=Fields(L_WDO.Fld_wIdx("WDInc",    Idx)).Value;
   WDWay   :=Fields(L_WDO.Fld_wIdx("WDWay",    Idx)).Value;
   PlEqFc  :=Fields(L_WDO.Fld_wIdx("PlEqFc",   Idx)).Value;
   CorrPlan:=Fields(L_WDO.Fld_wIdx("CorrPlan", Idx)).Value;

   EmptyLine:= !ExitMask &  !WDInc &  !WDWay &  !PlEqFc;
   FillLine :=~!ExitMask & ~!WDInc & ~!WDWay & ~!PlEqFc;
   IF PlEqFc = 0 THEN
    FillLine :=FillLine  & ~!CorrPlan;
    EmptyLine:=EmptyLine &  !CorrPlan;
   END;
   L_General.Assert(EmptyLine # FillLine, "ப " + L_Str.IntStr(Idx+1) + ":|" +
                                          "      ६");

   IF ~!ExitMask THEN
    Record:=L_Str.CheckPresenceSemicolon(ExitMask) + " " +
            WDWay    + " " +
            WDInc    + " " +
            PlEqFc   + " " +
            FLDTOSTR(CorrPlan, "1.", 0);
    L_Prop.putREV(OwnDPro.Value, Record);
   END;

   INC(Idx);
  END; (* LOOP *)
 END {formGet_UnusualWayIncPlan};

 PUBLIC PROCEDURE Encode_OwnDPro(trgValue   : LIKE(OwnDPro.Value);
                                 trgProperty: LIKE(OwnDPro.Property)): LIKE(OwnDPro.Value);
  VAR
   Result    : LIKE(OwnDPro.Value);
   SimpleUser: STRING[];
 BEGIN
  SimpleUser:=IsSimpleUserOf(trgProperty);
  L_General.CallUs(~!SimpleUser);
  IF !trgValue THEN
   SETEMPTY(Result);
  ELSE
   Result:=L_r2r.Put("OwnDPro", SimpleUser, trgValue);
  END;
  RETURN Result;
 END {Encode_OwnDPro};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty: LIKE(Property.Property));
 BEGIN
  SETEMPTY(OwnDPro.Value);
  IF    trgProperty = P_UnusualWayIncPlan     THEN
   formGet_UnusualWayIncPlan();
  ELSIF trgProperty = P_PFRTuning             THEN
   GetPFRTuningData();
  ELSIF trgProperty = P_MessageInWayDoc       THEN
   formGet_MessageInWayDoc();
  ELSIF trgProperty = P_InternetSettings      THEN
   formGet_InternetSettings()
  ELSIF trgProperty = P_RetirementCommiss     THEN
   formGet_RetirementCommiss();
  ELSIF trgProperty = P_RAccidCommiss         THEN
   formGet_RAccidCommiss();
  ELSIF trgProperty = P_BackupPath            THEN
   OwnDPro.Value:=RTI.Get().CurWindow.Zones(0).Fields("BackUpPath").Value;
  ELSIF trgProperty = P_DspControlTimes       THEN
   formGet_DspControlTimes();
  ELSIF trgProperty = P_FuelNormCorrection    THEN
   formGet_FuelNormCorrection();
  ELSIF trgProperty = P_Temperature           THEN
   formGet_Temperature();
  ELSIF trgProperty = P_SalesVolumes          THEN
   formGet_SalesVolumes();
  ELSIF trgProperty = P_Tariff                THEN
   formGet_Tariff();
  ELSIF trgProperty = P_PasVolNorm            THEN
   formGet_PasVolNorm();
  ELSIF trgProperty = P_TckOfficeShifts       THEN
   formGet_TckOfficeShifts();
  ELSIF trgProperty = P_MainTckKind           THEN
   formGet_MainTckKind();
  ELSIF trgProperty = P_ACS_Parameters        THEN
   formGet_ACS_Parameters();
  ELSIF ~!IsSimpleUserOf(trgProperty) THEN
   OwnDPro.Value:=Encode_OwnDPro(RTI.Get().CurZone.Fields("Value").Value, trgProperty);
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(OwnDPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Record,
   Result           : STRING[];
   Idx              : SCAL[CommissMembersAmnt];
   i                : NUMERIC[0];
   j                : SCAL[fnc_Amount];
   Chairman         : LIKE(Staff.TSN);
   Members          : LIKE(Staff.TSN)[CommissMembersAmnt];
   OrderOfCommission: STRING[];
   TckKindArr       : LIKE(TckKind.TckKind)[100];
   MF               : LIKE(MyFirm.MyFirm)[fnc_Amount];
   FNC_Move,
   FNC_Heat,
   FNC_Warm         : NUMERIC[3][fnc_Amount];
   SystemType       : t_acsp_SystemType;
   SystemServer     : STRING[];
   DateAccount      : DATE;
 BEGIN
  SETEMPTY(Result);
  IF    (OwnDPro.Property = P_RetirementCommiss) | (OwnDPro.Property = P_RAccidCommiss)     THEN
   Decode_Commiss(OwnDPro.Value, Chairman, Members, OrderOfCommission);
   L_Prop.putREV(Result, Chairman);
   FOR_EACH Idx DO
    IF ~!Members[Idx] THEN
     L_Prop.putREV(Result, Members[Idx]);
    END;
   END;
   Result:=Result + " " + OrderOfCommission;
  ELSIF OwnDPro.Property = P_MainTckKind THEN
   Decode_MainTckKind(OwnDPro.Value, TckKindArr);
   i:=0;
   WHILE ~!TckKindArr[i] DO
    L_Prop.putREV(Result, TckKindArr[i]);
    INC(i);
   END;
  ELSIF OwnDPro.Property = P_FuelNormCorrection THEN
   Decode_FuelNormCorrection(OwnDPro.Value, MF, FNC_Move, FNC_Heat, FNC_Warm);
   FOR_EACH j DO
    IF ~!MF[j] THEN
     SETEMPTY(Record);
     L_Prop.putREV(Record, MF      [j]);
     L_Prop.putREV(Record, FNC_Move[j]);
     L_Prop.putREV(Record, FNC_Heat[j]);
     L_Prop.putREV(Record, FNC_Warm[j]);
     L_Prop.putArrayItem(Result, Record);
    END;
   END;
  ELSIF OwnDPro.Property = P_ACS_Parameters THEN
   Decode_ACS_Parameters(OwnDPro.Value, SystemType, SystemServer, DateAccount, 0);

   Result:=" " + L_Str.PoolItem(acsp_SystemTypePool, SystemType);
   IF SystemType # c_acsp_SrvType_Empty THEN
    IF ~!SystemServer THEN
     Result:=Result + "  " + SystemServer;
    END;
    IF ~!DateAccount THEN
     Result:=Result + ".  砫  室 " + L_DatTim.DateStr(DateAccount);
    END;
   END;
  ELSIF IsSimpleUserOf(OwnDPro.Property) = "Firm" THEN
   SEARCH(Firm, Firm, , L_r2r.DecodeReferenceStamp(OwnDPro.Value));
   Result:=Firm.Firm + " " + Firm.Name;
  ELSE
   Result:=OwnDPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PUBLIC PROCEDURE Date_OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_UnusualWayIncPlan THEN
   RTI.Get().CurZone.Fields("DocExpD").Value:=OwnDPro.Date + 1;
   REPLACE(OwnDPro);
   SetCDWeekDay();
  ELSIF trgProperty = P_FuelNormCorrection THEN
   fnc_SE_WFD();
  ELSIF (trgProperty = P_Tariff) & L_APtm.IsMTA() & (OwnDPro.Date >= 01\04\2007) THEN
   L_StdFrm.Inform(" ᫥ 04.2007 㪠  ணࠬ." +
                   "||  䮢   ࠧࠡ稪" +
                   "|(᫨ ॡ㥬    ঠ).");
  END;
 END {Date_OnSuccessfulChange};

 PUBLIC PROCEDURE PropertyModificationAllowed(trgProperty: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF   trgProperty = P_XDocMdfBan THEN
   RETURN L_Prop.mac_AutoOnly;
  ELSE
   RETURN L_Prop.mac_Full;
  END;
 END {PropertyModificationAllowed};

 PRIVATE PROCEDURE TckKindIsInArr(trgTckKind: LIKE(TckKind.TckKind); TckKindArr: LIKE(TckKind.TckKind)[]): SCAL[2];
  VAR
   Result    : SCAL[2];
   curTckKind: LIKE(TckKind.TckKind);
 BEGIN
  Result:=0;
  FOR_EACH curTckKind IN TckKindArr DO
   IF trgTckKind = curTckKind THEN
    Result:=1;
    EXIT;
   END;
  END;
  RETURN Result;
 END {TckKindIsInArr};

 PRIVATE PROCEDURE omtkm_CheckTRS(From: DATE; VAR TaxedCnt: NUMERIC[0]);
 BEGIN
  APP.Get().NewPrompt("஢ઠ ");
  TaxedCnt:=0;
  SETSEL(TckRcS, Date);
  SRCINSEL(TckRcS, GE, , From);
  WHILE ~TaxedCnt & OCCURE(TckRcS) DO
   PROMPT(TckRcS.TckRcS);
   INC(TaxedCnt, SELECT(TckRcJ, TckRcS, TckRcS.TckRcS));
   NEXT(TckRcS);
  END; (* WHILE OCCURE(TckRcS) ... *)
 END {omtkm_CheckTRS};

 PRIVATE PROCEDURE OnMainTckKindModification(From: DATE; pVal, nVal: STRING[]);
  VAR
   TaxedCnt: NUMERIC[0];
   pTckKindArr,
   nTckKindArr : LIKE(TckKind.TckKind)[100];
 BEGIN
  omtkm_CheckTRS(From, TaxedCnt);
  IF TaxedCnt THEN
   L_StdFrm.Choice("  ⠪஢  ᫥ " + L_DatTim.DateStr(From) + "." +
                   "||㤥 ந  ᠦ஢ (    ࠡ⠭).");
   Decode_MainTckKind(pVal, pTckKindArr);
   Decode_MainTckKind(nVal, nTckKindArr);
   SELECT(TckKind, TckKind);
   WHILE OCCURE(TckKind) DO
    IF TckKindIsInArr(TckKind.TckKind, pTckKindArr) # TckKindIsInArr(TckKind.TckKind, nTckKindArr) THEN
     SAVE(TckKind);
     L_TRS.CorrectPsg(TckKind.TckKind, From);
     RESTORE(TckKind);
    END; (* Str.Match(pVal ...*)
    NEXT(TckKind);
   END; (* WHILE OCCURE(TckKind) ... *)
  END;
 END {OnMainTckKindModification};

 PRIVATE PROCEDURE SalesVolumes_OnAnyModification(Strong: SCAL[2]);
  VAR
   VATClcPer: DATE;
 BEGIN
  VATClcPer:=L_Pmnt.ConvPer2VATClcPer(L_DatTim.Per(OwnDPro.Date));
  IF (OwnDPro.Date = VATClcPer) | L_Acnt.E_IsMonthlyKeyAssVATDistr(OwnDPro.Date) THEN
   L_iga.Repeal(L_iga.a_RedistributeVAT, VATClcPer, "");
  ELSE
   L_General.Assert(~Strong, "⭠    ࠢ 砫  ਮ ("+L_DatTim.DateStr(VATClcPer)+")");
  END;
 END {SalesVolumes_OnAnyModification};

 PRIVATE PROCEDURE AfterEdIns_MainTckKind(AfterEdit: SCAL[2]);
  VAR
   pVal   : STRING[];
   trgDate: DATE;
 BEGIN
  SAVE(OwnDPro);
  CHANGESEL(OwnDPro, Property, , P_MainTckKind);
  IF PREV(OwnDPro) THEN
   pVal:=OwnDPro.Value;
  ELSE
   pVal:="";
  END;
  RESTORE(OwnDPro);

  IF AfterEdit THEN
   trgDate:=Math.Min(GE_PVALUE(OwnDPro.Date), OwnDPro.Date);
  ELSE
   trgDate:=OwnDPro.Date;
  END;

  OnMainTckKindModification(trgDate, pVal, OwnDPro.Value);
  IF AfterEdit THEN
   OnMainTckKindModification(trgDate, GE_PVALUE(OwnDPro.Value), OwnDPro.Value);
  END;
 END {AfterEdIns_MainTckKind};

 PUBLIC PROCEDURE OnAfterEdit();
  VAR
   Dummy         : STRING[];
   oldDateAccount,
   newDateAccount: DATE;
   oldSystemType,
   newSystemType : t_acsp_SystemType;
 BEGIN
  IF    OwnDPro.Property = P_ACS_Parameters THEN
   Decode_ACS_Parameters(OwnDPro.Value,            newSystemType, Dummy, newDateAccount, 1);
   Decode_ACS_Parameters(GE_PVALUE(OwnDPro.Value), oldSystemType, Dummy, oldDateAccount, 0);

   IF    oldSystemType = newSystemType THEN
    IF ~!oldDateAccount & (newDateAccount < oldDateAccount) THEN
     L_StdFrm.Choice(" ⠭  ࠭  砫  室" +
                     "|᫥ 㧪  㦥 室" +
                     "|㤥  ਮ, 稭  " + L_DatTim.DateStr(newDateAccount));
     L_ACS.Correct_sesfLastLoadUnloaded(newDateAccount, oldDateAccount, 0);
    END;
   ELSIF newSystemType # c_acsp_SrvType_Empty THEN
    L_ACS.Correct_sesfLastLoadUnloaded(newDateAccount, newDateAccount, 0);
   END;
  ELSIF OwnDPro.Property = P_MainTckKind THEN
   AfterEdIns_MainTckKind(1);
  ELSIF OwnDPro.Property = P_SalesVolumes THEN
   SalesVolumes_OnAnyModification(1);
  END; (*IF OwnDPro.Property ...*)
 END {OnAfterEdit};

 PUBLIC PROCEDURE OnAfterInsert();
 BEGIN
  IF    OwnDPro.Property = P_MainTckKind THEN
   AfterEdIns_MainTckKind(0);
  ELSIF OwnDPro.Property = P_SalesVolumes THEN
   SalesVolumes_OnAnyModification(1);
  END; (*IF OwnDPro.Property ...*)
 END {OnAfterInsert};

 PUBLIC PROCEDURE OnBeforeDelete();
 BEGIN
  IF    OwnDPro.Property = P_MainTckKind THEN
   OnMainTckKindModification(OwnDPro.Date, OwnDPro.Value, "");
  ELSIF OwnDPro.Property = P_SalesVolumes THEN
   SalesVolumes_OnAnyModification(0);
  END; (*IF OwnDPro.Property ...*)
 END {OnBeforeDelete};

 PUBLIC PROCEDURE GetPool(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_RWaySBlank THEN
   RETURN "";
  ELSIF L_Prop.IsLocalProperty(trgProperty) THEN
   RETURN L_Prop.E_GetPool(trgProperty);
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PUBLIC PROCEDURE HasOwnDPro(D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  SETSEL(OwnDPro, Property, trgProperty);
  RETURN SRCINSEL(OwnDPro, LE, D);
 END {HasOwnDPro};

 PUBLIC PROCEDURE HasActualOwnDPro(D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasOwnDPro(D, trgProperty) & (!OwnDPro.DocExpD | (D < OwnDPro.DocExpD));
 END {HasActualOwnDPro};

 PRIVATE PROCEDURE GetOwnDProValue(D          : DATE;
                                   trgProperty: LIKE(Property.Property);
                                   pc         : L_Prop.tPresenceCondition): LIKE(OwnDPro.Value);
  VAR
   Result: LIKE(OwnDPro.Value);
 BEGIN
  IF HasActualOwnDPro(D, trgProperty) THEN
   IF ~!IsSimpleUserOf(trgProperty) THEN
    Result:=L_r2r.DecodeReferenceStamp(OwnDPro.Value);
   ELSE
    Result:=OwnDPro.Value;
   END;
  ELSE
   IF pc = L_Prop.pc_Strong THEN
    L_General.Error(" ன  । 祭 ᢮⢠ " + trgProperty + "  " + L_DatTim.DateStr(D));
   ELSE
    SETEMPTY(Result);
   END; (* IF *)
  END; (* IF *)
  RETURN Result;
 END {GetOwnDProValue};

 PUBLIC PROCEDURE GetOwnDProStrong(D: DATE; trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetOwnDProValue(D, trgProperty, L_Prop.pc_Strong);
 END {GetOwnDProStrong};

 PUBLIC PROCEDURE GetOwnDProSoft(D: DATE; trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN GetOwnDProValue(D, trgProperty, L_Prop.pc_Soft);
 END {GetOwnDProSoft};

 PUBLIC PROCEDURE GetUnusualWayIncPlan(    D       : DATE;
                                           trgExit : LIKE(StExit.Exit);
                                       VAR ExitMask: STRING[9];
                                       VAR WDInc,
                                           WDWay   : SCAL[9];
                                       VAR PlEqFc  : SCAL[2];
                                       VAR CorrPlan: NUMERIC[1]);
  VAR
   Idx        : NUMERIC[0];
   arrExitMask: STRING[9][MaxUCDLines];
   arrWDInc,
   arrWDWay   : SCAL[9][MaxUCDLines];
   arrPlEqFc  : SCAL[2][MaxUCDLines];
   arrCorrPlan: NUMERIC[1][MaxUCDLines];
 BEGIN
  SETEMPTY(ExitMask, WDInc, WDWay, PlEqFc, CorrPlan);
  IF HasActualOwnDPro(D, P_UnusualWayIncPlan) THEN
   Decode_UnusualWayIncPlan(OwnDPro.Value, arrExitMask, arrWDInc, arrWDWay, arrPlEqFc, arrCorrPlan);
   Idx:=0;
   WHILE !ExitMask & ~!arrExitMask[Idx] & (Idx <= HIGH(arrExitMask)) DO
    IF Str.Match(trgExit, arrExitMask[Idx] + "*") THEN
     ExitMask:=arrExitMask[Idx];
     WDInc   :=arrWDInc[Idx];
     WDWay   :=arrWDWay[Idx];
     PlEqFc  :=arrPlEqFc[Idx];
     CorrPlan:=arrCorrPlan[Idx];
    END;
    INC(Idx);
   END; (* WHILE !ExitMask & ... *)
  END;
 END {GetUnusualWayIncPlan};

 PUBLIC PROCEDURE IsPlanEqualFactDay(D: DATE): SCAL[2];
  VAR
   ExitMask: STRING[9];
   WDInc,
   WDWay   : SCAL[9];
   PlEqFc  : SCAL[2];
   CorrPlan: NUMERIC[1];
 BEGIN
  GetUnusualWayIncPlan(D, SEJobs.Exit, ExitMask, WDInc, WDWay, PlEqFc, CorrPlan);
  IF ~!PlEqFc THEN
   RETURN PlEqFc;
  END;
  RETURN 0;
 END {IsPlanEqualFactDay};

 PUBLIC PROCEDURE IncPlanCorr(D: DATE): NUMERIC[1];
  VAR
   ExitMask: STRING[9];
   WDInc,
   WDWay   : SCAL[9];
   PlEqFc  : SCAL[2];
   CorrPlan: NUMERIC[1];
 BEGIN
  GetUnusualWayIncPlan(D, SEJobs.Exit, ExitMask, WDInc, WDWay, PlEqFc, CorrPlan);
  IF ~!CorrPlan THEN
   RETURN CorrPlan;
  END;
  RETURN 0;
 END {IncPlanCorr};

 PUBLIC PROCEDURE ODPacketSize(D: DATE): NUMERIC[0];
  VAR
   dmyValue        : STRING[];
   curPacketSize,
   dmyAnkPacketSize: NUMERIC[0];
 BEGIN
  dmyValue:=GetOwnDProStrong(D, P_PFRTuning);
  SetPFRTuningData(curPacketSize, dmyAnkPacketSize);
  RETURN curPacketSize;
 END {ODPacketSize};

 PUBLIC PROCEDURE ODAnkPacketSize(D: DATE): NUMERIC[0];
  VAR
   dmyValue        : STRING[];
   dmyPacketSize,
   curAnkPacketSize: NUMERIC[0];
 BEGIN
  dmyValue:=GetOwnDProStrong(D, P_PFRTuning);
  SetPFRTuningData(dmyPacketSize, curAnkPacketSize);
  RETURN curAnkPacketSize;
 END {ODAnkPacketSize};

 PUBLIC PROCEDURE ODSMTPServer(D: DATE): STRING[];
  VAR
   SMTPServer         : STRING[];
   UseDedicatedLine   : SCAL[2];
   EMailDomain        : STRING[];
   SprtCrspSendChannel: STRING[];
   UseProtectedChnl   : SCAL[2];
   wAuthentication    : SCAL[2];
 BEGIN
  Decode_InternetSettings(GetOwnDProStrong(D, P_InternetSettings),
                          SMTPServer,
                          UseDedicatedLine,
                          EMailDomain,
                          SprtCrspSendChannel,
                          UseProtectedChnl,
                          wAuthentication);
  RETURN SMTPServer;
 END {ODSMTPServer};

 PUBLIC PROCEDURE UseDedicatedLine(D: DATE): SCAL[2];
  VAR
   SMTPServer         : STRING[];
   UseDedicatedLine   : SCAL[2];
   EMailDomain        : STRING[];
   SprtCrspSendChannel: STRING[];
   UseProtectedChnl   : SCAL[2];
   wAuthentication    : SCAL[2];
 BEGIN
  Decode_InternetSettings(GetOwnDProStrong(D, P_InternetSettings),
                          SMTPServer,
                          UseDedicatedLine,
                          EMailDomain,
                          SprtCrspSendChannel,
                          UseProtectedChnl,
                          wAuthentication);
  RETURN UseDedicatedLine;
 END {UseDedicatedLine};

 PUBLIC PROCEDURE SMTPUseProtectedChnl(D: DATE): SCAL[2];
  VAR
   SMTPServer         : STRING[];
   UseDedicatedLine   : SCAL[2];
   EMailDomain        : STRING[];
   SprtCrspSendChannel: STRING[];
   UseProtectedChnl   : SCAL[2];
   wAuthentication    : SCAL[2];
 BEGIN
  Decode_InternetSettings(GetOwnDProStrong(D, P_InternetSettings),
                          SMTPServer,
                          UseDedicatedLine,
                          EMailDomain,
                          SprtCrspSendChannel,
                          UseProtectedChnl,
                          wAuthentication);
  RETURN UseProtectedChnl;
 END {SMTPUseProtectedChnl};

 PUBLIC PROCEDURE SMTPWithAuthentication(D: DATE): SCAL[2];
  VAR
   SMTPServer         : STRING[];
   UseDedicatedLine   : SCAL[2];
   EMailDomain        : STRING[];
   SprtCrspSendChannel: STRING[];
   UseProtectedChnl   : SCAL[2];
   wAuthentication    : SCAL[2];
 BEGIN
  Decode_InternetSettings(GetOwnDProStrong(D, P_InternetSettings),
                          SMTPServer,
                          UseDedicatedLine,
                          EMailDomain,
                          SprtCrspSendChannel,
                          UseProtectedChnl,
                          wAuthentication);
  RETURN wAuthentication;
 END {SMTPWithAuthentication};

 PUBLIC PROCEDURE EMailDomain(D: DATE): STRING[];
  VAR
   SMTPServer         : STRING[];
   UseDedicatedLine   : SCAL[2];
   EMailDomain        : STRING[];
   SprtCrspSendChannel: STRING[];
   UseProtectedChnl   : SCAL[2];
   wAuthentication    : SCAL[2];
 BEGIN
  Decode_InternetSettings(GetOwnDProStrong(D, P_InternetSettings),
                          SMTPServer,
                          UseDedicatedLine,
                          EMailDomain,
                          SprtCrspSendChannel,
                          UseProtectedChnl,
                          wAuthentication);
  RETURN EMailDomain;
 END {EMailDomain};

 PUBLIC PROCEDURE GetSprtCrspSendChannel(D: DATE): tSprtCrspSendChannel;
  VAR
   SMTPServer         : STRING[];
   UseDedicatedLine   : SCAL[2];
   EMailDomain        : STRING[];
   SprtCrspSendChannel: STRING[];
   UseProtectedChnl   : SCAL[2];
   wAuthentication    : SCAL[2];
 BEGIN
  Decode_InternetSettings(GetOwnDProStrong(D, P_InternetSettings),
                          SMTPServer,
                          UseDedicatedLine,
                          EMailDomain,
                          SprtCrspSendChannel,
                          UseProtectedChnl,
                          wAuthentication);
  IF !SprtCrspSendChannel THEN
   RETURN scsc_FTP;
  ELSE
   RETURN L_Str.PositionInPool(scsc_Pool, SprtCrspSendChannel);
  END;
 END {GetSprtCrspSendChannel};

 PUBLIC PROCEDURE DspRepTime(D: DATE): TIME;
  VAR
   trgDspRepTime, trgDspPassTime: TIME;
 BEGIN
  Decode_DspControlTimes(GetOwnDProStrong(D, P_DspControlTimes), trgDspRepTime, trgDspPassTime);
  RETURN trgDspRepTime;
 END {DspRepTime};

 PUBLIC PROCEDURE DspPassTime(D: DATE): TIME;
  VAR
   trgDspRepTime, trgDspPassTime: TIME;
 BEGIN
  Decode_DspControlTimes(GetOwnDProStrong(D, P_DspControlTimes), trgDspRepTime, trgDspPassTime);
  RETURN trgDspPassTime;
 END {DspPassTime};

 PRIVATE PROCEDURE fnc_Get(    D          : DATE;
                               trgMyFirm  : LIKE(MyFirm.MyFirm);
                           VAR dstFNC_Move,
                               dstFNC_Heat,
                               dstFNC_Warm: NUMERIC[3]);
  VAR
   Idx      : SCAL[fnc_Amount];
   MF       : LIKE(MyFirm.MyFirm)[fnc_Amount];
   FNC_Move,
   FNC_Heat,
   FNC_Warm : NUMERIC[3][fnc_Amount];
   FindFNC  : SCAL[2];
 BEGIN
  Decode_FuelNormCorrection(GetOwnDProStrong(D, P_FuelNormCorrection), MF, FNC_Move, FNC_Heat, FNC_Warm);
  IF ~P_Firm.E_wMultipleMyFirm(D) THEN
   IF !trgMyFirm THEN
    trgMyFirm:=P_Firm.mf_Own;
   END;
   L_General.CallUs(trgMyFirm = P_Firm.mf_Own);
  END;
  SETEMPTY(dstFNC_Move, dstFNC_Heat, dstFNC_Warm);
  FindFNC:=0;
  FOR_EACH Idx DO
   IF !MF[Idx] | (trgMyFirm = MF[Idx]) THEN
    dstFNC_Move:=FNC_Move[Idx];
    dstFNC_Heat:=FNC_Heat[Idx];
    dstFNC_Warm:=FNC_Warm[Idx];
    FindFNC    :=1;
    EXIT;
   END;
  END;
  IF ~FindFNC THEN
   L_General.Assert(P_Firm.E_wMultipleMyFirm(D),
                    " ⠭ ४  ⮯  " + L_DatTim.DateStr(D));
   L_General.Assert(~!trgMyFirm, "⠭ ࠧ筠 ४  ⮯  '' ࣠権");
   L_General.Error(" '' ࣠樨 " + trgMyFirm +
                   "| ⠭ ४  ⮯  " + L_DatTim.DateStr(D));
  END;
 END {fnc_Get};

 PUBLIC PROCEDURE FCorMove(D: DATE; trgMyFirm: LIKE(MyFirm.MyFirm)): NUMERIC[3];
  VAR
   dstFNC_Move,
   dstFNC_Heat,
   dstFNC_Warm: NUMERIC[3];
 BEGIN
  fnc_Get(D, trgMyFirm, dstFNC_Move, dstFNC_Heat, dstFNC_Warm);
  RETURN dstFNC_Move;
 END {FCorMove};

 PUBLIC PROCEDURE FCorHeat(D: DATE; trgMyFirm: LIKE(MyFirm.MyFirm)): NUMERIC[3];
  VAR
   dstFNC_Move,
   dstFNC_Heat,
   dstFNC_Warm: NUMERIC[3];
 BEGIN
  fnc_Get(D, trgMyFirm, dstFNC_Move, dstFNC_Heat, dstFNC_Warm);
  RETURN dstFNC_Heat;
 END {FCorHeat};

 PUBLIC PROCEDURE FCorWarm(D: DATE; trgMyFirm: LIKE(MyFirm.MyFirm)): NUMERIC[3];
  VAR
   dstFNC_Move,
   dstFNC_Heat,
   dstFNC_Warm: NUMERIC[3];
 BEGIN
  fnc_Get(D, trgMyFirm, dstFNC_Move, dstFNC_Heat, dstFNC_Warm);
  RETURN dstFNC_Warm;
 END {FCorWarm};

 PUBLIC PROCEDURE Temperature(D: DATE; VAR Values: NUMERIC[3][2]);
 BEGIN
  SETEMPTY(Values);
  Decode_Temperature(GetOwnDProStrong(D, P_Temperature), Values[0], Values[1]);
 END {Temperature};

 PUBLIC PROCEDURE GetSalesVolumes(D: DATE; VAR Taxable, NotTaxable: NUMERIC[2]);
 BEGIN
  Decode_SalesVolumes(GetOwnDProStrong(D, P_SalesVolumes), Taxable, NotTaxable);
 END {GetSalesVolumes};

 PUBLIC PROCEDURE FillTariffs(    D         : DATE;
                              VAR ScalBase,
                                  ScalStep,
                                  PriceBase,
                                  PriceStep : NUMERIC[2][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  SETEMPTY(ScalBase, ScalStep, PriceBase, PriceStep);
  IF (D >= 01\04\2007) & L_APtm.IsMTA() THEN
   IF    D >= 01\01\2014 THEN
    L_General.Assert(ACCESS(Route), " ⠭ ");
    L_Way.StandOnRouteTKind(D);
    ScalBase[0] :=0; ScalStep[0] :=5;     PriceBase[1]:=30;
    ScalBase[1] :=5; ScalStep[1] :=2.5;
    IF TKind.FnMode = L_Way.tkfnm_Commerce THEN
     PriceBase[0]:=25; PriceStep[0]:=25;
     PriceStep[1]:=5;
    ELSE
     PriceBase[0]:=26; PriceStep[0]:=26;
     PriceStep[1]:=4;
    END;
   ELSIF D >= 01\01\2013 THEN
    L_General.Assert(ACCESS(Route), " ⠭ ");
    L_Way.StandOnRouteTKind(D);
    ScalBase[0] :=0; ScalStep[0] :=5;   PriceBase[0]:=25; PriceStep[0]:=25;
    ScalBase[1] :=5; ScalStep[1] :=2.5;
    IF TKind.FnMode = L_Way.tkfnm_Commerce THEN
     PriceBase[1]:=30; PriceStep[1]:=5;
    ELSE
     PriceBase[1]:=29; PriceStep[1]:=4;
    END;
   ELSIF D >= 01\01\2011 THEN
    ScalBase[0] :=0; ScalStep[0] :=5;   PriceBase[0]:=23; PriceStep[0]:=23;
    ScalBase[1] :=5; ScalStep[1] :=2.5; PriceBase[1]:=26; PriceStep[1]:=4;
   ELSIF    D >= 01\01\2010 THEN
    ScalBase[0] :=0; ScalStep[0] :=5;   PriceBase[0]:=22; PriceStep[0]:=22;
    ScalBase[1] :=5; ScalStep[1] :=2.5; PriceBase[1]:=26; PriceStep[1]:=4;
   ELSIF D >= 01\01\2009 THEN
    ScalBase[0] :=0; ScalStep[0] :=5;   PriceBase[0]:=20; PriceStep[0]:=20;
    ScalBase[1] :=5; ScalStep[1] :=2.5; PriceBase[1]:=24; PriceStep[1]:=4;
    i:=1;
    REPEAT
     INC(i);
     ScalBase[i]:=ScalBase[i-1]+2.5;
     ScalStep[i]:=2.5;
     IF ScalBase[i] MOD 5 = 0 THEN
      PriceBase[i]:=PriceBase[i-1]+4;
      PriceStep[i]:=4;
     ELSE
      IF ScalBase[i] = 15.0 THEN
       PriceBase[i]:=PriceBase[i-1]+4;
       PriceStep[i]:=4;
      ELSE
       PriceBase[i]:=PriceBase[i-1]+3;
       PriceStep[i]:=3;
      END;
     END;
    UNTIL ScalBase[i] > 67.5;
   ELSIF D >= 01\01\2008 THEN
    ScalBase[0] :=0; ScalStep[0] :=5;   PriceBase[0]:=17; PriceStep[0]:=3;
    ScalBase[1] :=5; ScalStep[1] :=2.5; PriceBase[1]:=20; PriceStep[1]:=3;
   ELSE
    ScalBase[0] :=0; ScalStep[0] :=5;   PriceBase[0]:=15; PriceStep[0]:=15;
    ScalBase[1] :=5; ScalStep[1] :=2.5; PriceBase[1]:=17; PriceStep[1]:=3;
    i:=1;
    REPEAT
     INC(i);
     ScalBase[i]:=ScalBase[i-1]+2.5;
     ScalStep[i]:=2.5;
     IF ScalBase[i] MOD 5 = 0 THEN
      PriceBase[i]:=PriceBase[i-1]+2;
      PriceStep[i]:=2;
     ELSE
      PriceBase[i]:=PriceBase[i-1]+3;
      PriceStep[i]:=3;
     END;
    UNTIL ScalBase[i] > 67.5;
   END;
  ELSE
   Decode_Tariff(GetOwnDProStrong(D, P_Tariff), ScalBase, ScalStep, PriceBase, PriceStep);
  END;
 END {FillTariffs};

 PUBLIC PROCEDURE BackupAdditionalRootPath(D: DATE): STRING[];
 BEGIN
  RETURN L_Prop.getRES(GetOwnDProStrong(D, P_BackupPath), 0);
 END {BackupAdditionalRootPath};

 PUBLIC PROCEDURE TruncTo(D: DATE): NUMERIC[2];
 BEGIN
  RETURN STRTOFLD(GetOwnDProStrong(D, P_TruncTo), NUMERIC, "2.");
 END {TruncTo};

 PUBLIC PROCEDURE USDRate(D: DATE): NUMERIC[4];
 BEGIN
  RETURN STRTOFLD(GetOwnDProStrong(D, P_USDRate), NUMERIC, "4.");
 END {USDRate};

 PUBLIC PROCEDURE SaleTax(D: DATE): NUMERIC[3];
 BEGIN
  RETURN STRTOFLD(GetOwnDProStrong(D, P_SaleTax), NUMERIC, "3.");
 END {ODSaleTax};

 PUBLIC PROCEDURE MessageToDriver(D: DATE): STRING[];
  VAR
   trgMessageToDriver, trgMessageToGuard: STRING[];
 BEGIN
  Decode_MessageInWayDoc(GetOwnDProSoft(D, P_MessageInWayDoc), trgMessageToDriver, trgMessageToGuard);
  RETURN trgMessageToDriver;
 END {MessageToDriver};

 PUBLIC PROCEDURE MessageToGuard(D: DATE): STRING[];
  VAR
   trgMessageToDriver, trgMessageToGuard: STRING[];
 BEGIN
  Decode_MessageInWayDoc(GetOwnDProSoft(D, P_MessageInWayDoc), trgMessageToDriver, trgMessageToGuard);
  RETURN trgMessageToGuard;
 END {MessageToGuard};

 PUBLIC PROCEDURE GetACSSystemServerType(D: DATE): t_acsp_SystemType;
  VAR
   Result          : t_acsp_SystemType;
   Dummy           : STRING[];
   DummyDateAccount: DATE;
 BEGIN
  IF HasActualOwnDPro(D, P_ACS_Parameters) THEN
   Decode_ACS_Parameters(OwnDPro.Value, Result, Dummy, DummyDateAccount, 0);
  ELSE
   Result:=c_acsp_SrvType_Empty;
  END;
  RETURN Result;
 END {GetACSSystemServerType};

 PUBLIC PROCEDURE GetACSSystemServer(    D         : DATE;
                                     VAR ServerType: t_acsp_SystemType;
                                     VAR Server    : STRING[]);
  VAR
   DummyDate: DATE;
 BEGIN
  SETEMPTY(Server, ServerType);
  IF HasActualOwnDPro(D, P_ACS_Parameters) THEN
   Decode_ACS_Parameters(OwnDPro.Value, ServerType, Server, DummyDate, 0);
  ELSE
   L_General.Error("  ࠬ ᮯ殮  ");
  END;
 END {GetACSSystemServer};

 PUBLIC PROCEDURE GetACSAccountDate(D: DATE): DATE;
  VAR
   ServerType: t_acsp_SystemType;
   Dummy     : STRING[];
   Result    : DATE;
 BEGIN
  SETEMPTY(Result);
  ServerType:=c_acsp_SrvType_Empty;
  IF HasActualOwnDPro(D, P_ACS_Parameters) THEN
   Decode_ACS_Parameters(OwnDPro.Value, ServerType, Dummy, Result, 0);
  END;
  L_General.Assert(ServerType # c_acsp_SrvType_Empty, "  ⠭.");
  RETURN Result;
 END {GetACSAccountDate};

 PUBLIC PROCEDURE GetACSSystemOutposts(D: DATE);
  VAR
   ServerType : t_acsp_SystemType;
   Server     : STRING[];
   DateAccount: DATE;
 BEGIN
  IF HasActualOwnDPro(D, P_ACS_Parameters) THEN
   Decode_ACS_Parameters(OwnDPro.Value, ServerType, Server, DateAccount, 1);
  ELSE
   L_General.Error("  ࠬ ᮯ殮  ");
  END;
 END {GetACSSystemOutposts};

 PUBLIC PROCEDURE GetACSSiteByOutpost(trgOutpost: LIKE(ACSEvent.Outpost)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  SELECT(Outpost, Outpost, , trgOutpost);
  WHILE OCCURE(Outpost) DO
   IF ~!Result THEN
    L_General.CallUs(Result = Outpost.Site);
   END;
   Result:=Outpost.Site;
   NEXT(Outpost);
  END; (* WHILE OCCURE(Outpost) ... *)
  L_General.CallUs(~!Result);
  RETURN Result;
 END {GetACSSiteByOutpost};

 PUBLIC PROCEDURE xdmb_Get(VAR pB, pE: DATE[L_XDoc.txdclsAmount]);
  VAR
   class : NUMERIC[0];
   Single: STRING[];
 BEGIN
  SETEMPTY(pB, pE);
  IF HasActualOwnDPro(SYSDATE(), P_XDocMdfBan) THEN
   class:=MINOF(L_XDoc.tXDocClass);
   WHILE class < L_XDoc.txdclsAmount DO
    Single:=L_Prop.getArrayItem(OwnDPro.Value, class);
    pB[class]:=STRTOFLD(L_Prop.getRES(Single, 0), DATE);
    pE[class]:=STRTOFLD(L_Prop.getRES(Single, 1), DATE);
    INC(class);
   END;
  END;
 END {xdmb_Get};

 PUBLIC PROCEDURE xdmb_ShowCurrent();
  VAR
   pB,
   pE    : DATE[L_XDoc.txdclsAmount];
   class : NUMERIC[0];
   Msg,
   ClassName,
   PrdStr   : STRING[];
 BEGIN
  Msg:="|" +
       Str.Align("  㬥⮢", 48, LEFT) + " " +
       Str.Align("C", 10, LEFT) + "  " + Str.Align("", 10, LEFT) +
       "|" +
       L_Str.Repeat("", 48 + 1 + 10 + 2 + 10) +
       "|";
  xdmb_Get(pB, pE);
  class:=MINOF(L_XDoc.tXDocClass);
  WHILE class < L_XDoc.txdclsAmount DO
   ClassName:=L_Str.PoolItem(L_XDoc.xdcls_Pool, class);
   IF ~!ClassName THEN
    IF ~!pE[class] THEN
     PrdStr:=L_DatTim.DateStr(pB[class]) + "  " + L_DatTim.DateStr(pE[class]);
    ELSE
     PrdStr:="";
    END;
    Msg:=Msg + Str.Align(ClassName, 48, LEFT) + " " + Str.Align(PrdStr, 10+2+10, LEFT) + "|";
   END;
   INC(class);
  END;
  STDFORM(Msg+ "||"+L_StdFrm.DrawButton("", 10, "X"), " ﭨ  䨪樨 ࢨ 㬥⮢ ", INFORM);
 END {xdmb_ShowCurrent};

 PUBLIC PROCEDURE xdmb_Put(class: L_XDoc.tXDocClass; cpB, cpE: DATE);
  VAR
   pB,
   pE     : DATE[L_XDoc.txdclsAmount];
   Single : STRING[];
   MakeNew: SCAL[2];
 BEGIN
  xdmb_Get(pB, pE);
  pB[class]:=cpB;
  pE[class]:=cpE;
  IF ~HasActualOwnDPro(SYSDATE(), P_XDocMdfBan) | (OwnDPro.Date # L_DatTim.Per(SYSDATE())) THEN
   MakeNew:=1;
   DEFAULT(OwnDPro);
   OwnDPro.Property:=P_XDocMdfBan;
   OwnDPro.Date    :=L_DatTim.Per(SYSDATE());
   INSERT(OwnDPro);
   L_Prop.SupportEndDate("OwnDPro", P_XDocMdfBan, 1);
  ELSE
   MakeNew:=0;
   L_SysLog.SingleMark_Init("OwnDPro");
  END;
  SETEMPTY(OwnDPro.Value);
  FOR_EACH class DO
   SETEMPTY(Single);
   IF ~!pB[class] | ~!pE[class] THEN
    L_Prop.putRES(Single, FLDTOSTR(pB[class]));
    L_Prop.putRES(Single, FLDTOSTR(pE[class]));
   END;
   L_Prop.putArrayItem(OwnDPro.Value, Single);
  END;
  REPLACE(OwnDPro);
  IF MakeNew THEN
   L_SysLog.SingleMark_AutoBuild("OwnDPro");
  ELSE
   L_SysLog.SingleMark_Done("OwnDPro");
  END;
 END {xdmb_Put};

 PUBLIC PROCEDURE InsertProperty(D         : DATE;
                                 trgProperty : LIKE(Property.Property);
                                 _Value    : STRING[];
                                 Silent    : SCAL[2];
                                 _DocNum,
                                 _DocGiveS : STRING[];
                                 _DocGiveD,
                                 _DocExpD  : DATE);
 BEGIN
  IF SELECT(OwnDPro, Property, trgProperty, D) THEN
   L_General.Assert(Silent,
                    "  ⮩ " + trgProperty + "|" +
                    "  " + L_DatTim.DateStr(D));
   REMOVE(OwnDPro);
  END;
  DEFAULT(OwnDPro);
  OwnDPro.Property:=trgProperty;
  OwnDPro.Date    :=D;
  SETEMPTY(OwnDPro.EndDate);
  OwnDPro.Value   :=_Value;
  OwnDPro.DocNum  :=_DocNum;
  OwnDPro.DocGiveD:=_DocGiveD;
  OwnDPro.DocGiveS:=_DocGiveS;
  OwnDPro.DocExpD :=_DocExpD;
  INSERT(OwnDPro);
  L_Prop.SupportEndDate("OwnDPro", trgProperty, 1);
  CALL(ObjPro.UpdateVal2Show("OwnDPro"));
 END {InsertProperty};

 PRIVATE PROCEDURE ArrayItemMove_ACS_Parameters(Dir: NUMERIC[0]);
 BEGIN
  L_Prop.ArrayItemMove(Dir, ["Site", "o_Enter", "o_Exit", "OutpostName", "Perimeter", "Outpost"]);
 END {ArrayItemMove_ACS_Parameters};

 PUBLIC PROCEDURE OnPropertyArrayItemMoveUp(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_ACS_Parameters THEN
   ArrayItemMove_ACS_Parameters(-1);
  ELSIF trgProperty = P_UnusualWayIncPlan THEN
   ArrayItemMove_UnusualWayIncPlan(-1);
  END;
 END {OnPropertyArrayItemMoveUp};

 PUBLIC PROCEDURE OnPropertyArrayItemMoveDown(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_ACS_Parameters THEN
   ArrayItemMove_ACS_Parameters(+1);
  ELSIF trgProperty = P_UnusualWayIncPlan THEN
   ArrayItemMove_UnusualWayIncPlan(+1);
  END;
 END {OnPropertyArrayItemMoveDown};

 PRIVATE PERMANENT VAR
  imtk_OwnDPro_Date : DATE;
  imtk_OwnDPro_Value: LIKE(OwnDPro.Value);
  imtk_TckKindRIDArr: LIKE(TckKind.RECORDID)[100];

 PUBLIC PROCEDURE IsMainTckKind(trgTckKind: LIKE(TckKind.TckKind); trgDate: DATE): SCAL[2];
  VAR
   curValue : LIKE(OwnDPro.Value);
   i        : NUMERIC[0];
   singleVal: LIKE(TckKind.RECORDID);
   Result   : SCAL[2];
 BEGIN
  curValue:=GetOwnDProStrong(trgDate, P_MainTckKind);
  IF ~VAR_IMPL.Get(imtk_OwnDPro_Date).Initialized | (imtk_OwnDPro_Date  # OwnDPro.Date) |
                                                    (imtk_OwnDPro_Value # curValue    ) THEN
   imtk_OwnDPro_Date :=OwnDPro.Date;
   imtk_OwnDPro_Value:=curValue;
   SETEMPTY(imtk_TckKindRIDArr);
   i:=0;
   LOOP
    singleVal:=STRTOFLD(Str.Item(L_Prop.getRES(curValue, i), ",", 1), SCAL);
    IF !singleVal THEN
     EXIT;
    END;
    imtk_TckKindRIDArr[i]:=singleVal;
    INC(i);
   END; (* LOOP *)
  END;
  SAVE(TckKind);
  SEARCH(TckKind, TckKind, , trgTckKind);
  Result:=0;
  FOR_EACH singleVal IN imtk_TckKindRIDArr DO
   IF TckKind.RECORDID = singleVal THEN
    Result:=1;
    EXIT;
   END;
  END;
  RESTORE(TckKind);
  RETURN Result;
 END {IsMainTckKind};

 PUBLIC PROCEDURE P_9000_OnInitializeWindow();
  VAR
   i: NUMERIC[0];
 BEGIN
  L_WDO.iWindow().MNUFileName:="ObjPro";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iUnmodifiable(0, ["xyzDate", "ClndWDInc", "ClndWDWay"]);
  L_WDO.iScsChange   (0, "Date");
  L_WDO.iMayBeEmpty  (0, "DocExpD");
  i:=0;
  WHILE ~!L_WDO.iField(0, L_WDO.Fld_wIdx("ExitMask", i)) DO
   L_WDO.iScsChange   (0, L_WDO.Fld_wIdx("PlEqFc",   i));
   L_WDO.iMayBeEmpty  (0, L_WDO.Fld_wIdx("ExitMask", i));
   L_WDO.iMayBeEmpty  (0, L_WDO.Fld_wIdx("WDWay",    i));
   L_WDO.iMayBeEmpty  (0, L_WDO.Fld_wIdx("WDInc",    i));
   L_WDO.iMayBeEmpty  (0, L_WDO.Fld_wIdx("PlEqFc",   i));
   L_WDO.iMayBeEmpty  (0, L_WDO.Fld_wIdx("CorrPlan", i));
   INC(i);
  END;
  L_WDO.iProgs       (0, "ObjPro");
 END {P_9000_OnInitializeWindow};

 PUBLIC PROCEDURE P_9028_OnInitializeWindow();
  VAR
   i: NUMERIC[0];
 BEGIN
  L_WDO.iWindow().MNUFileName:="ObjPro";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iScsChange   (0, "SystemType");
  L_WDO.iUnmodifiable(0, ["OutpostTitle_Exit", "OutpostTitle_Enter"]);
  L_WDO.iMayBeEmpty  (0, ["DateAccount", "SystemServer"]);

  i:=1;
  WHILE ~!L_WDO.iField(0, L_WDO.Fld_wIdx("Site", i)) DO
   L_WDO.iMayBeEmpty  (0, L_WDO.Fld_wIdx("Site", i));
   L_WDO.iMayBeEmpty  (0, L_WDO.Fld_wIdx("o_Enter", i));
   L_WDO.iMayBeEmpty  (0, L_WDO.Fld_wIdx("o_Exit", i));
   L_WDO.iMayBeEmpty  (0, L_WDO.Fld_wIdx("OutpostName", i));
   L_WDO.iMayBeEmpty  (0, L_WDO.Fld_wIdx("Perimeter", i));
   L_WDO.iMayBeEmpty  (0, L_WDO.Fld_wIdx("Outpost", i));
   L_WDO.iScsChange   (0, L_WDO.Fld_wIdx("Outpost", i));
   INC(i);
  END; (* LOOP *)
  L_WDO.iProgs       (0, "ObjPro");
 END {P_9028_OnInitializeWindow};

END.
