(*
%Copyright   (c) Polak Computer System
%Author      06.09.2002 14:13:44 POLAK\LDA
%Purpose       ᢮⢠ 
%Type        control
%Specific    SYS
%Modified    17.04.2014 12:41:28 POLAK\MLB
%Environment
*)

 MODULE P_Post [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  P_MantoManDefenceAss = 2001;

 IMPORT L_General, L_Prop, Str, L_DatTim, P_Officer, FIO, L_WDO;

 PUBLIC PROCEDURE GetSubWindowName(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_MantoManDefenceAss THEN RETURN "P_2001";
  ELSE                                          RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE GetPool(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    L_Prop.IsLocalProperty(trgProperty) THEN
   RETURN L_Prop.E_GetPool(trgProperty);
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PUBLIC PROCEDURE HasPro(trgPost              : LIKE(Post.Post);
                         trgDate              : DATE;
                         trgProperty          : LIKE(Property.Property);
                         OnDateSearchCondition: L_Prop.tOnDateSearchCondition): SCAL[2];
 BEGIN
  IF OnDateSearchCondition = L_Prop.dsc_Exactly THEN
   L_General.CallUs(trgDate = L_DatTim.Per(trgDate));
  END;
  SELECT(PostPro, Post, , trgPost, trgProperty);
  IF     OnDateSearchCondition = L_Prop.dsc_Normal THEN
   SRCINSEL(PostPro, LE, , trgDate);
  ELSIF (OnDateSearchCondition = L_Prop.dsc_Exactly) |
        (OnDateSearchCondition = L_Prop.dsc_Exactly_OnAnyDate) THEN
   SRCINSEL(PostPro, EQ, , trgDate);
  ELSE
   L_General.CallUs(0);
  END;
  RETURN OCCURE(PostPro);
 END {HasPro};

 PUBLIC PROCEDURE HasActualPro(trgPost              : LIKE(Post.Post);
                               trgDate              : DATE;
                               trgProperty          : LIKE(Property.Property);
                               OnDateSearchCondition: L_Prop.tOnDateSearchCondition): SCAL[2];
 BEGIN
  RETURN HasPro(trgPost, trgDate, trgProperty, OnDateSearchCondition) &
         (!PostPro.DocExpD | (trgDate < PostPro.DocExpD));
 END {HasActualPro};

 PUBLIC PROCEDURE HasActualPro_Normal(trgPost    : LIKE(Post.Post);
                                      trgDate    : DATE;
                                      trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasActualPro(trgPost, trgDate, trgProperty, L_Prop.dsc_Normal);
 END {HasActualPro_Normal};

 PUBLIC PROCEDURE GetProValue(trgPost              : LIKE(Post.Post);
                              trgDate              : DATE;
                              trgProperty          : LIKE(Property.Property);
                              OnDateSearchCondition: L_Prop.tOnDateSearchCondition;
                              PresenceCondition    : L_Prop.tPresenceCondition): LIKE(PostPro.Value);
 BEGIN
  IF HasActualPro(trgPost, trgDate, trgProperty, OnDateSearchCondition) THEN
   RETURN PostPro.Value;
  ELSE
   IF PresenceCondition = L_Prop.pc_Strong THEN
    SEARCH(Post, Post, , trgPost);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("Post").Id, Post.RECORDID, trgProperty, trgDate);
   ELSE
    RETURN "";
   END; (* IF *)
  END; (* IF *)
 END {GetProValue};

 PUBLIC PROCEDURE GetProValueSoft(trgPost    : LIKE(Post.Post);
                                  trgDate    : DATE;
                                  trgProperty: LIKE(Property.Property)): LIKE(PostPro.Value);
 BEGIN
  RETURN GetProValue(trgPost, trgDate, trgProperty, L_Prop.dsc_Normal, L_Prop.pc_Soft);
 END {GetProValueSoft};

 PUBLIC PROCEDURE GetProValueStrong(trgPost    : LIKE(Post.Post);
                                    trgDate    : DATE;
                                    trgProperty: LIKE(Property.Property)): LIKE(PostPro.Value);
 BEGIN
  RETURN GetProValue(trgPost, trgDate, trgProperty, L_Prop.dsc_Normal, L_Prop.pc_Strong);
 END {GetProValueSoft};

 PUBLIC PROCEDURE SetDataInForm(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_MantoManDefenceAss THEN
   P_Officer.formSet_MantoManDefenceAss("PostPro");
  END;
 END {SetDataInForm};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty: LIKE(Property.Property));
 BEGIN
  SETEMPTY(PostPro.Value);
  IF trgProperty = P_MantoManDefenceAss THEN
   P_Officer.formGet_MantoManDefenceAss("PostPro");
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(PostPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF PostPro.Property = P_MantoManDefenceAss THEN
   Result:=P_Officer.GetVal2Show_MantoManDefenceAss(PostPro.Value);
  ELSE
   Result:=PostPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PUBLIC PROCEDURE OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_MantoManDefenceAss THEN
   P_Officer.OnSuccessfulChange_MantoManDefenceAss();
  END;
 END {OnSuccessfulChange};

END.
