(*
%Copyright   (c) Polak Computer System
%Author      01.02.2001 17:43:36 SAM
%Purpose     ⥪  ࠡ  ᢮⢠ SortPro
%Type        library
%Specific    SYS
%Modified    11.08.2014 11:40:29 POLAK\San
%Environment
*)

 MODULE P_Sort [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC TYPE
  tgcwo = SCAL[5];

 PUBLIC CONST
  P_BrigadeContract        = 5800;
  P_GroupCycleWO_Main      = 5801;
  P_GroupCycleWO_Optional1 = 5802;
  P_GroupCycleWO_Optional2 = 5803;
  P_GroupCycleWO_Optional3 = 5804;
  P_MyPlace                = 5805;
  P_GroupCycleWO_Optional4 = 5806;

 PUBLIC CONST
  gcwo_Main      = 0;
  gcwo_Optional1 = 1;
  gcwo_Optional2 = 2;
  gcwo_Optional3 = 3;
  gcwo_Optional4 = 4;
  gcwo_NamePool = "᭮ 㯯 横 鸞|"            +
                  "⥫ (1) 㯯 横 鸞|" +
                  "⥫ (2) 㯯 横 鸞|" +
                  "⥫ (3) 㯯 横 鸞|" +
                  "⥫ (4) 㯯 横 鸞|" ;

  MaxCntExitClss = 32;

 IMPORT L_General, Str, L_Prop, L_Str, L_WDO, L_r2r, P_Firm, L_Staff, E_Prop;

 PRIVATE CONST
  CycleInWorkDays_pool      = " |ࠡ ";
  CycleInWorkDays_poolShort = "|";

 PRIVATE PROCEDURE IsVeritableSortPro(trgProperty: LIKE(Property.Property)): SCAL[2];
  VAR
   Local : PROC;
   Result: SCAL[2];
 BEGIN
  Result:=1;
  IF L_Prop.IsLocalProperty(trgProperty) THEN
   Local:=PROCREF(E_Prop.IsVeritableObjPro);
   IF ~!Local THEN
    Result:=Local(trgProperty);
   END;
  ELSIF (trgProperty = P_MyPlace) THEN
   Result:=0;
  END;
  RETURN Result;
 END {IsVeritableSortPro};

 PUBLIC PROCEDURE CanHaveProp(trgProperty: LIKE(Property.Property));
 BEGIN
  IF IsVeritableSortPro(trgProperty) THEN
   CONFORM(SortPro, Sort);
   L_Staff.CheckVeritableSort("⢮ " + trgProperty + "  ⮫쪮  ᥪ஢");
  END;
 END {CanHaveProp};

 PRIVATE PROCEDURE IsGroupCycleWO(trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN (trgProperty = P_GroupCycleWO_Main)      |
         (trgProperty = P_GroupCycleWO_Optional1) |
         (trgProperty = P_GroupCycleWO_Optional2) |
         (trgProperty = P_GroupCycleWO_Optional3) |
         (trgProperty = P_GroupCycleWO_Optional4) ;
 END {IsGroupCycleWO};

 PUBLIC PROCEDURE IsSimpleUserOf(curProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF curProperty = P_MyPlace THEN
   RETURN "MyPlace";
  ELSE
   RETURN "";
  END;
 END {IsSimpleUserOf};

 PUBLIC PROCEDURE GetSubWindowName(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF IsGroupCycleWO(trgProperty) THEN
   RETURN "P_580X";
  ELSE
   RETURN "";
  END;
 END {GetSubWindowName};

 PRIVATE PROCEDURE Decode_GroupCycleWO(    Val            : STRING[];
                                       VAR arrExitClss    : LIKE(ExitClss.ExitClss)[];
                                       VAR CycleLen       : NUMERIC[0];
                                       VAR CycleInWorkDays: SCAL[2];
                                           Strong         : SCAL[2]);
  VAR
   Idx,
   pos: NUMERIC[0];
   EC : STRING[];
 BEGIN
  SETEMPTY(CycleLen, CycleInWorkDays, EC, arrExitClss);
  TRY
   CycleLen       :=L_Prop.GetNumericValueFromStr(L_Prop.getRES(Val, 0));
   CycleInWorkDays:=L_Prop.getRES(Val, 1);
  EXCEPT
  ELSE
   IF Strong THEN
    RAISE();
   END;
  END; (* TRY *)
  IF Strong THEN
   L_General.Assert(~!CycleLen,   " 㪠 ⢮ ७   室");
   L_General.Assert(CycleLen > 0, "⢮ ७   室    0");
  END;
  pos:=L_Str.GetPosOfNextDelimiter(Val, ";", 0)   + 1;
  pos:=L_Str.GetPosOfNextDelimiter(Val, ";", pos) + 1;
  EC :=Str.Slice(Val, pos, Str.Length(Val));
  Idx:=0;
  WHILE (Idx < MaxCntExitClss) & ~!L_r2r.DecodeReferenceStamp(L_Prop.getRES(EC, Idx)) DO
   arrExitClss[Idx]:=L_r2r.DecodeReferenceStamp(L_Prop.getRES(EC, Idx));
   INC(Idx);
  END;
 END {Decode_GroupCycleWO};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Result         : STRING[];
   trgMyPlace     : LIKE(MyPlace.MyPlace);
   arrExitClss    : LIKE(ExitClss.ExitClss)[MaxCntExitClss];
   Idx,
   CycleLen       : NUMERIC[0];
   CycleInWorkDays: SCAL[2];
 BEGIN
  IF    IsGroupCycleWO(SortPro.Property) THEN
   Decode_GroupCycleWO(SortPro.Value, arrExitClss, CycleLen, CycleInWorkDays, 1);
   Result:=L_Str.IntStr(CycleLen) + L_Str.PoolItem(CycleInWorkDays_poolShort, CycleInWorkDays);
   Idx:=0;
   WHILE (Idx < MaxCntExitClss) & ~!arrExitClss[Idx] DO
    Result:= Result + ";" + arrExitClss[Idx];
    INC(Idx);
   END;
  ELSIF SortPro.Property = P_MyPlace THEN
   trgMyPlace:=L_r2r.DecodeReferenceStamp(SortPro.Value);
   IF ~!trgMyPlace THEN
    SEARCH(MyPlace, MyPlace, , trgMyPlace);
    Result:=MyPlace.MyPlace + " " + MyPlace.Name;
   END;
  ELSE
   Result:=SortPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PUBLIC PROCEDURE SetDataInForm(trgProperty: LIKE(Property.Property));
  VAR
   Fields     : FORM_FIELDS;
   arrExitClss: LIKE(ExitClss.ExitClss)[MaxCntExitClss];
   Idx        : SCAL[MaxCntExitClss];
 BEGIN
  IF IsGroupCycleWO(trgProperty)  THEN
   Fields                          :=RTI.Get().CurWindow.Zones(0).Fields;
   Fields("CycleInWorkDays").Format:=CycleInWorkDays_pool;
   Decode_GroupCycleWO(SortPro.Value, arrExitClss, Fields("CycleLen").Value, Fields("CycleInWorkDays").Value, 0);
   FOR_EACH Idx DO
    L_WDO.extCreateFormLink("ExitClss", "", Idx);
    Fields(L_Prop.BuildVideoFieldName("ExitClss", Idx)).Value:=arrExitClss[Idx];
   END;
  END;
 END {SetDataInForm};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty: LIKE(Property.Property));
  VAR
   Idx     : SCAL[MaxCntExitClss];
   Fields  : FORM_FIELDS;
   HasOneEC: SCAL[2];
 BEGIN
  SETEMPTY(SortPro.Value);
  IF IsGroupCycleWO(trgProperty) THEN
   Fields       :=RTI.Get().CurWindow.Zones(0).Fields;
   SortPro.Value:=L_Str.IntStr(Fields("CycleLen").Value) + ";" + Fields("CycleInWorkDays").Value;
   HasOneEC:=0;
   FOR_EACH Idx DO
    IF ~!Fields(L_Prop.BuildVideoFieldName("ExitClss", Idx)).Value THEN
     HasOneEC:=1;
     INC(SortPro.Value, ";" + L_r2r.Put("SortPro", "ExitClss", Fields(L_Prop.BuildVideoFieldName("ExitClss", Idx)).Value));
    END;
   END; (* FOR_EACH Idx ... *)
   L_General.Assert(HasOneEC, " 㪠    室 横");
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(SortPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE GetProPool(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_BrigadeContract THEN
   RETURN "|";
  ELSIF L_Prop.IsLocalProperty(trgProperty) THEN
   RETURN L_Prop.E_GetPool(trgProperty);
  ELSE
   RETURN "";
  END;
 END {GetProPool};

 PRIVATE PROCEDURE HasAnyPro(trgSort    : LIKE(Sort.Sort);
                             D          : DATE;
                             trgProperty: LIKE(Property.Property);
                             CheckActual: SCAL[2]): SCAL[2];
  VAR
   NeedGo2Parent,
   Result       : SCAL[2];
 BEGIN
  Result       :=0;
  NeedGo2Parent:=~IsVeritableSortPro(trgProperty);
  SAVE(Sort);
  SEARCH(Sort, Sort, , trgSort);
  LOOP
   IF SELECT(SortPro, Sort, Sort.Sort, trgProperty) & SRCINSEL(SortPro, LE, D) THEN
    IF ~CheckActual | !SortPro.DocExpD | (D < SortPro.DocExpD) THEN
     Result:=1;
     EXIT;
    END;
   END;
   IF NeedGo2Parent & ~!Sort.Parent THEN
    SEARCH(Sort, Sort, , Sort.Parent);
   ELSE
    EXIT;
   END;
  END; (* LOOP ... *)
  RESTORE(Sort);
  RETURN Result;
 END {HasAnyPro};

 PUBLIC PROCEDURE HasPro(trgSort: LIKE(Sort.Sort); D: DATE; trgProperty: LIKE(Property.Property)):  SCAL[2];
 BEGIN
  RETURN HasAnyPro(trgSort, D, trgProperty, 0);
 END {HasPro};

 PUBLIC PROCEDURE HasActualPro(trgSort: LIKE(Sort.Sort); D: DATE; trgProperty: LIKE(Property.Property)):  SCAL[2];
 BEGIN
  RETURN HasAnyPro(trgSort, D, trgProperty, 1);
 END {HasActualPro};

 PRIVATE PROCEDURE Decode_Pro(trgValue   : STRING[];
                              trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  L_General.CallUs(~!IsSimpleUserOf(trgProperty));
  RETURN L_r2r.DecodeReferenceStamp(trgValue);
 END {Decode_Pro};

 PRIVATE PROCEDURE intGetPro(trgSort    : LIKE(Sort.Sort);
                             D          : DATE;
                             trgProperty: LIKE(Property.Property);
                             Actual     : SCAL[2];
                             Strong     : SCAL[2]): STRING[];
  VAR
   Has   : SCAL[2];
   Result: STRING[];
 BEGIN
  IF Actual THEN
   Has:=HasActualPro(trgSort, D, trgProperty);
  ELSE
   Has:=HasPro(trgSort, D, trgProperty);
  END;
  SETEMPTY(Result);
  IF Has THEN
   IF ~!IsSimpleUserOf(trgProperty) THEN
    Result:=Decode_Pro(SortPro.Value, trgProperty);
   ELSE
    Result:=SortPro.Value;
   END;
  ELSE
   IF Strong THEN
    SEARCH(Sort, Sort, , trgSort);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("Sort").Id, Sort.RECORDID, trgProperty, D);
   END;
  END;
  RETURN Result;
 END {intGetPro};

 PUBLIC PROCEDURE GetProStrong(trgSort: LIKE(Sort.Sort); D: DATE; trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN intGetPro(trgSort, D, trgProperty, 1, 1);
 END {GetProStrong};

 PUBLIC PROCEDURE GetProSoft(trgSort: LIKE(Sort.Sort); D: DATE; trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN intGetPro(trgSort, D, trgProperty, 1, 0);
 END {GetProSoft};

 PUBLIC PROCEDURE GetGroupCycleWO(    trgSort        : LIKE(Sort.Sort);
                                      D              : DATE;
                                  VAR arrExitClss    : LIKE(ExitClss.ExitClss)[];
                                  VAR CycleLen       : NUMERIC[0];
                                  VAR CycleInWorkDays: SCAL[2];
                                      GroupCycle     : tgcwo);
 BEGIN
  SETEMPTY(arrExitClss, CycleLen, CycleInWorkDays);
  IF ((GroupCycle = gcwo_Main)      & HasActualPro(trgSort, D, P_GroupCycleWO_Main))      |
     ((GroupCycle = gcwo_Optional1) & HasActualPro(trgSort, D, P_GroupCycleWO_Optional1)) |
     ((GroupCycle = gcwo_Optional2) & HasActualPro(trgSort, D, P_GroupCycleWO_Optional2)) |
     ((GroupCycle = gcwo_Optional3) & HasActualPro(trgSort, D, P_GroupCycleWO_Optional3)) |
     ((GroupCycle = gcwo_Optional4) & HasActualPro(trgSort, D, P_GroupCycleWO_Optional4)) THEN
   Decode_GroupCycleWO(SortPro.Value, arrExitClss, CycleLen, CycleInWorkDays, 1);
  END;
 END {GetGroupCycleWO};

 PUBLIC PROCEDURE Value_OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_MyPlace THEN
   L_General.Assert(STRTOFLD(RTI.Get().CurZone.Fields("Value").Value, NUMERIC) # P_Firm.mp_Fict,
                    "'⮯' "+L_Str.FixedIntStr(P_Firm.mp_Fict, 4)+"    㪠  ᢮⢥");
  END;
 END {Value_OnSuccessfulChange};

 PRIVATE PROCEDURE GetMyPlaceExplicit(trgSort: LIKE(Sort.Sort); trgD: DATE): LIKE(MyPlace.MyPlace);
  VAR
   Result: LIKE(MyPlace.MyPlace);
 BEGIN
  SETEMPTY(Result);
  SAVE(MyPlace);
  IF SEARCH(MyPlace, MyPlace, 0002) THEN
   Result:=GetProSoft(trgSort, trgD, P_MyPlace);
  END;
  RESTORE(MyPlace);
  RETURN Result;
 END {GetMyPlaceExplicit};

 PUBLIC PROCEDURE GetMyPlace(trgSort: LIKE(Sort.Sort); trgD: DATE): LIKE(MyPlace.MyPlace);
  VAR
   Result: LIKE(MyPlace.MyPlace);
 BEGIN
  Result:=GetMyPlaceExplicit(trgSort, trgD);
  IF !Result THEN
   SAVE(Sort);
   SEARCH(Sort, Sort, , trgSort);
   Result:=P_Firm.GetMainMyPlace(trgD, Sort.MyFirm);
   RESTORE(Sort);
  END;
  RETURN Result;
 END {GetMyPlace};

END.
