(*
%Copyright   (c) Polak Computer System
%Author      25.02.2000 11:02:48 SAN
%Purpose       ᢮⢠ ࠡ⭨
%Type        library
%Specific    SYS
%Modified    08.09.2014 13:32:21 POLAK\Bor
%Environment
*)

 MODULE P_Staff [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  P_SpecificForPF         = 0099;
  P_ExcludedTSNForPF      = 0100;
  P_BuyFlats              = 0110;
  P_SpecifyTax            = 0120;
  P_RegimeForMkBegRWS     = 0210;
  P_FixedGuard            = 0213;
  P_ProbationFixing       = 0214;
  P_HasAccessToKKM        = 0221;
  P_SortForMkBegRWS       = 0225;
  P_PowerSubscribeDsptPck = 0226;
  P_DrvInstructor         = 0227;
  P_ProhibitInBegRWayS    = 0228;
  P_SubstitutionInBegRWS  = 0229;
  P_ExitClass4two         = 0232;
  P_SgnAuthR              = 0233;
  P_BegInFirm             = 0510;
  P_Advance               = 0901;

 IMPORT L_General, L_DatTim, L_Prop, Str, L_Staff, L_Str, L_two, L_WDO, Math, P_Sort, L_BegRWS,
        L_r2r, L_ACL, L_StdFrm;

 PUBLIC CONST
  ec4twoft_Individual   = 0;
  ec4twoft_Cyclic       = 1;
  ec4twoft_InSector     = 2;
  ec4two_FixingTypePool = " |㠫 横|㯯 横 鸞 ᥪ";
  ec4two_CycleNamePool  = " ࠡ稩 |||樠쭠";
  ec4twoc_ByRegime      = 0;
  ec4twoc_Decade        = 1;
  ec4twoc_Month         = 2;
  ec4twoc_Special       = 3;

 PRIVATE CONST
  MaxCntExitClss        = 15;

 PUBLIC PROCEDURE PropertyModificationAllowed(trgProperty: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF    (trgProperty = P_BuyFlats)   |
        (trgProperty = P_SpecifyTax) |
        (trgProperty = P_ProhibitInBegRWayS) THEN
   RETURN L_Prop.mac_Old;
  ELSE
   RETURN L_Prop.mac_Full;
  END;
 END {PropertyModificationAllowed};

 PUBLIC PROCEDURE IsSimpleUserOf(curProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    curProperty = P_SpecificForPF        THEN RETURN "PnsAttr";
  ELSIF curProperty = P_SortForMkBegRWS      THEN RETURN "Sort";
  ELSIF curProperty = P_SubstitutionInBegRWS THEN RETURN "Staff";
  ELSIF curProperty = P_FixedGuard           THEN RETURN "Staff";
  ELSIF curProperty = P_ProbationFixing      THEN RETURN "Staff";
  ELSE                                            RETURN "";
  END;
 END {IsSimpleUserOf};

 PUBLIC PROCEDURE GetProbationers4Tutor(trgTSN: LIKE(Staff.TSN); D: DATE; VAR Probationers: LIKE(Staff.TSN)[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  SETEMPTY(Probationers);
  i:=0;
  SETSEL(StaffPro, Property, P_ProbationFixing, trgTSN);
  SRCINSEL(StaffPro, LE, , D);
  WHILE OCCURE(StaffPro) DO
   PROMPT(StaffPro.TSN + " " + L_DatTim.DateStr(StaffPro.Date));
   IF L_DatTim.IsActive_Inc(D, StaffPro.Date, StaffPro.EndDate) THEN
    CONFORM(StaffPro, Staff);
    Probationers[i]:=Staff.TSN;
    INC(i);
   END;
   PREV(StaffPro);
  END; (* WHILE OCCURE(StaffPro) ... *)
 END {GetProbationers4Tutor};

 PUBLIC PROCEDURE AccessBySpdSrchV(_Property: LIKE(StaffPro.Property);
                                   _SpdSrchV: LIKE(StaffPro.SpdSrchV);
                                   _Date    : LIKE(StaffPro.Date)): SCAL[2];
 BEGIN
  SETSEL(StaffPro, Property, _Property, _SpdSrchV);
  RETURN SRCINSEL(StaffPro, LE, _Date) &
         L_DatTim.IsActive_Inc(_Date, StaffPro.Date, StaffPro.EndDate);
 END {AccessBySpdSrchV};

 PUBLIC PROCEDURE GetStaffProPool(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    _Property = P_SpecifyTax THEN
   RETURN " |騩  ६ ";
  ELSIF _Property = P_ExcludedTSNForPF THEN
   RETURN "|";
  ELSIF _Property = P_HasAccessToKKM THEN
   RETURN "|";
  ELSIF _Property = P_PowerSubscribeDsptPck THEN
   RETURN "|";
  ELSIF _Property = P_DrvInstructor THEN
   RETURN "|";
  ELSIF _Property = P_ProhibitInBegRWayS THEN
   RETURN "饭|";
  ELSIF L_Prop.IsLocalProperty(_Property) THEN
   RETURN L_Prop.E_GetPool(_Property);
  ELSE
   RETURN "";
  END;
 END {GetStaffProPool};

 PUBLIC PROCEDURE GetSubWindowName(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    _Property = P_RegimeForMkBegRWS THEN RETURN "P_0210";
  ELSIF _Property = P_ExitClass4two     THEN RETURN "P_0232";
  ELSIF _Property = P_SgnAuthR          THEN RETURN "P_0233";
  ELSE                                       RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE CanHavePro(trgProperty: LIKE(Property.Property); D: DATE);
 BEGIN
  ACCESS(Staff);
  IF    trgProperty = P_RegimeForMkBegRWS THEN
   IF !D THEN
    D:=L_DatTim.IncMonth(L_DatTim.MonthBeg(SYSDATE()), 1);
   END;
   L_Staff.PosToStaffLog(Staff.TSN, D, 1);
   CONFORM(StaffLog, Officer);
   L_General.Assert(~!L_two.E_Mtwo_Who(D), "⢮ " + trgProperty + " '" + Property.Name + "'|" +
                                           "।祭  ࠡ⭨, 砥  ");
  END;
 END {CanHavePro};

 PUBLIC PROCEDURE StaffPro_Check(trgProperty : LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_Advance THEN
   L_Prop.CheckNumericValue(StaffPro.Value, "");
  ELSIF trgProperty = P_BegInFirm THEN
   L_Prop.CheckDateValue(StaffPro.Value, "D.N.y");
  ELSIF trgProperty = P_SortForMkBegRWS THEN
   SEARCH(Sort, Sort, , L_r2r.Decode(StaffPro.Value));
   L_Staff.CheckVeritableSort("");
  END;
 END {StaffPro_Check};

 PUBLIC PROCEDURE HasStaffPro(trgTSN: LIKE(Staff.TSN); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  SETSEL(StaffPro, TSN, trgTSN, trgProperty);
  RETURN SRCINSEL(StaffPro, LE, D);
 END {HasStaffPro};

 PUBLIC PROCEDURE HasActualStaffPro(trgTSN: LIKE(Staff.TSN); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasStaffPro(trgTSN, D, trgProperty) & (!StaffPro.DocExpD | (D < StaffPro.DocExpD));
 END {HasActualStaffPro};

 PRIVATE PROCEDURE Decode_Pro(trgValue   : STRING[];
                              trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  L_General.CallUs(~!IsSimpleUserOf(trgProperty));
  RETURN L_r2r.Decode(trgValue);
 END {Decode_Pro};

 PUBLIC PROCEDURE GetFixedGuard(trgValue: STRING[]): LIKE(Staff.TSN);
 BEGIN
  RETURN STRTOFLD(Decode_Pro(trgValue, P_FixedGuard), SCAL);
 END {GetFixedGuard};

 PRIVATE PROCEDURE intGetPro(trgTSN     : LIKE(Staff.TSN);
                             D          : DATE;
                             trgProperty: LIKE(Property.Property);
                             Strong     : SCAL[2]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF HasActualStaffPro(trgTSN, D, trgProperty) THEN
   IF ~!IsSimpleUserOf(trgProperty) THEN
    Result:=Decode_Pro(StaffPro.Value, trgProperty);
   ELSE
    Result:=StaffPro.Value;
   END;
  ELSE
   IF Strong THEN
    SEARCH(Staff, TSN, , trgTSN);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("Staff").Id, Staff.RECORDID, trgProperty, D);
   END;
  END;
  RETURN Result;
 END {intGetPro};

 PUBLIC PROCEDURE GetStaffProStrong(trgTSN: LIKE(Staff.TSN); D: DATE; trgProperty: LIKE(Property.Property)): LIKE(StaffPro.Value);
 BEGIN
  RETURN intGetPro(trgTSN, D, trgProperty, 1);
 END {GetStaffProStrong};

 PUBLIC PROCEDURE GetStaffProSoft(trgTSN: LIKE(Staff.TSN); D: DATE; trgProperty: LIKE(Property.Property)): LIKE(StaffPro.Value);
 BEGIN
  RETURN intGetPro(trgTSN, D, trgProperty, 0);
 END {GetStaffProSoft};

 PUBLIC PROCEDURE GetP_SortForMkBegRWS(trgTSN: LIKE(Staff.TSN); D: DATE): LIKE(StaffPro.Value);
 BEGIN
  RETURN GetStaffProSoft(trgTSN, D, P_SortForMkBegRWS);
 END {GetP_SortForMkBegRWS};

 PUBLIC PROCEDURE GetP_FixedGuard(trgTSN: LIKE(Staff.TSN); D: DATE): LIKE(StaffPro.Value);
 BEGIN
  RETURN GetStaffProSoft(trgTSN, D, P_FixedGuard);
 END {GetP_FixedGuard};

 PUBLIC PROCEDURE GetP_SpecificForPF(trgTSN: LIKE(Staff.TSN); D: DATE): LIKE(PnsAttr.PnsAttr);
 BEGIN
  RETURN GetStaffProSoft(trgTSN, D, P_SpecificForPF);
 END {GetP_SpecificForPF};

 PRIVATE PROCEDURE GetTSNFromReferenceStamp(): LIKE(Staff.TSN);
  VAR
   Result: LIKE(Staff.TSN);
 BEGIN
  SAVE(Staff);
  Result:=L_r2r.Decode(StaffPro.Value);
  RESTORE(Staff);
  RETURN Result;
 END {GetTSNFromReferenceStamp};

 PUBLIC PROCEDURE Get_SubstitutionInBegRWS(trgTSN: LIKE(Staff.TSN); D: DATE): LIKE(Staff.TSN);
 BEGIN
  RETURN GetStaffProSoft(trgTSN, D, P_SubstitutionInBegRWS);
 END {Get_SubstitutionInBegRWS};

 PUBLIC PROCEDURE GetP_BuyFlats(trgTSN: LIKE(Staff.TSN); D: DATE): LIKE(StaffPro.Value);
 BEGIN
  RETURN GetStaffProSoft(trgTSN, D, P_BuyFlats);
 END {GetP_BuyFlats};

 PRIVATE PROCEDURE SetSortCycleExitClssList(trgTSN: LIKE(Staff.TSN); D: DATE; Strong: SCAL[2]);
  VAR
   arrExitClss    : LIKE(ExitClss.ExitClss)[P_Sort.MaxCntExitClss];
   SortECList     : STRING[];
   Idx,
   CycleLen       : NUMERIC[0];
   CycleInWorkDays: SCAL[2];
   trgSort        : LIKE(Sort.Sort);
   GroupCycle     : P_Sort.tgcwo;
   Fields         : FORM_FIELDS;
 BEGIN
  SAVE(StaffPro);
  trgSort:=L_BegRWS.GetSortOfStaff(trgTSN, D);
  RESTORE(StaffPro);
  Fields    :=RTI.Get().CurWindow.Zones(0).Fields;
  GroupCycle:=Fields("GroupCycle").Value;
  IF ~!GroupCycle THEN
   P_Sort.GetGroupCycleWO(trgSort, D, arrExitClss, CycleLen, CycleInWorkDays, GroupCycle);
   SETEMPTY(SortECList);
   Idx:=0;
   WHILE (Idx < P_Sort.MaxCntExitClss) & ~!arrExitClss[Idx] DO
    SortECList:=SortECList + FLDTOSTR(Idx+1, "L", 2) + " " + arrExitClss[Idx] + "|";
    INC(Idx);
   END;
   IF !SortECList THEN
    L_General.Assert(~Strong, " " +trgSort + ":  " +
                              L_Str.PoolItem(P_Sort.gcwo_NamePool, GroupCycle) + " ᮢ 室");
    SETEMPTY(Fields("GroupCycleStartDate").Value,
             Fields("GroupCycleStartECIdx").Value,
             Fields("GroupCycle").Value);
   END;
   Fields("GroupCycleStartECIdx").Format:=SortECList;
  END;
 END {SetSortCycleExitClssList};

 PRIVATE PROCEDURE SetFields_ExitClass4two(Strong: SCAL[2]);
  VAR
   Idx          : SCAL[MaxCntExitClss];
   trgFixingType: SCAL[3];
   Fields       : FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  trgFixingType                  :=Fields("FixingType").Value;
  Fields("FixingType").Modifiable:=~!StaffPro.Date;
  IF trgFixingType = ec4twoft_InSector THEN
   SetSortCycleExitClssList(StaffPro.TSN, StaffPro.Date, Strong);
  ELSE
   SETEMPTY(Fields("GroupCycleStartDate").Value, Fields("GroupCycleStartECIdx").Value);
  END;
  Fields("FullDayScheduleExitClss").Visible        :=trgFixingType = ec4twoft_Individual;
  Fields("FullDayScheduleExitClss_Name").Visible   :=trgFixingType = ec4twoft_Individual;
  Fields("ChangeableScheduleExitClss").Visible     :=trgFixingType = ec4twoft_Individual;
  Fields("ChangeableScheduleExitClss_Name").Visible:=trgFixingType = ec4twoft_Individual;
  Fields("Cycle").Visible                          :=trgFixingType = ec4twoft_Cyclic;
  Fields("CycleLen").Visible                       :=(trgFixingType = ec4twoft_Cyclic) & (Fields("Cycle").Value = ec4twoc_Special);
  Fields("GroupCycle").Visible                     :=trgFixingType = ec4twoft_InSector;
  Fields("GroupCycleStartECIdxDate").Visible       :=trgFixingType = ec4twoft_InSector;
  Fields("GroupCycleStartDate").Visible            :=(trgFixingType = ec4twoft_InSector) & ~!Fields("GroupCycle").Value;
  Fields("GroupCycleStartECIdx").Visible           :=(trgFixingType = ec4twoft_InSector) & ~!Fields("GroupCycle").Value;
  FOR_EACH Idx DO
   Fields(L_Prop.BuildVideoFieldName("CycleExitClss", Idx)).Visible     :=trgFixingType = ec4twoft_Cyclic;
   Fields(L_Prop.BuildVideoFieldName("CycleExitClss_Name", Idx)).Visible:=trgFixingType = ec4twoft_Cyclic;
  END; (* FOR_EACH Idx ...*)
 END {SetFields_ExitClass4two};

 PRIVATE PROCEDURE Decode_SgnAuthR(    curValue   : STRING[];
                                   VAR trgSgnAuthR: LIKE(SgnAuthR.SgnAuthR);
                                   VAR trgDocType : STRING[]);
 BEGIN
  trgSgnAuthR:=L_r2r.Decode(L_Prop.getRecordElement(curValue, 0));
  trgDocType :=L_Prop.getRecordElement(curValue, 1);
 END {Decode_SgnAuthR};

 PRIVATE PROCEDURE formSet_SgnAuthR();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_WDO.CreateFormLink("SgnAuthR", "");

  Decode_SgnAuthR(StaffPro.Value, Fields("SgnAuthR").Value, Fields("DocType").Value);
 END {formSet_SgnAuthR};

 PRIVATE PROCEDURE formGet_SgnAuthR();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  SEARCH(SgnAuthR, SgnAuthR, , Fields("SgnAuthR").Value);

  L_Prop.putRES(StaffPro.Value, L_r2r.Put("StaffPro", "SgnAuthR", Fields("SgnAuthR").Value));
  L_Prop.putRES(StaffPro.Value, Fields("DocType").Value);
 END {formGet_SgnAuthR};

 PUBLIC PROCEDURE Date_OnSuccessfulChange(_Property: LIKE(Property.Property));
 BEGIN
  IF _Property = P_ExitClass4two THEN
   RTI.Get().CurZone.Fields("FixingType").Modifiable:=~!StaffPro.Date;
   SetSortCycleExitClssList(StaffPro.TSN, StaffPro.Date, 1);
  END; (* IF _Property = P_ExitClass4two ...*)
 END {Date_OnSuccessfulChange};

 PUBLIC PROCEDURE OnSuccessfulChange(_Property: LIKE(Property.Property));
  VAR
   ActiveFieldName: STRING[];
 BEGIN
  IF   _Property = P_ExitClass4two THEN
   ActiveFieldName:=RTI.Get().CurZone.ActiveField.Name;
   IF    (ActiveFieldName = "FixingType") |
         (ActiveFieldName = "Cycle")      THEN
    SetFields_ExitClass4two(1);
   ELSIF ActiveFieldName = "GroupCycle" THEN
    SETEMPTY(RTI.Get().CurZone.Fields("GroupCycleStartECIdx").Value);
    SetFields_ExitClass4two(1);
   END;
  END;
 END {OnSuccessfulChange};

 PRIVATE PROCEDURE DecodeExitClss_ExitClass4two(ECStamp: STRING[]): STRING[];
 BEGIN
  RETURN L_r2r.Decode(ECStamp);
 END {DecodeExitClss_ExitClass4two};

 PRIVATE PROCEDURE GetCycleExitClss_ExitClass4two(EC: STRING[]; Idx: SCAL[MaxCntExitClss]): STRING[];
 BEGIN
  RETURN DecodeExitClss_ExitClass4two(L_Prop.getRecordElement(EC, Idx));
 END {GetCycleExitClss_ExitClass4two};

 PUBLIC PROCEDURE Decode_ExitClass4two(    srcValue                  : STRING[];
                                           Strong                    : SCAL[2];
                                       VAR FixingType                : SCAL[3];
                                       VAR FullDayScheduleExitClss   : LIKE(ExitClss.ExitClss);
                                       VAR ChangeableScheduleExitClss: LIKE(ExitClss.ExitClss);
                                       VAR Cycle                     : SCAL[4];
                                       VAR CycleLen                  : NUMERIC[0];
                                       VAR arrExitClss               : LIKE(ExitClss.ExitClss)[];
                                       VAR GroupCycle                : P_Sort.tgcwo;
                                       VAR GroupCycleStartECIdx      : NUMERIC[0];
                                       VAR GroupCycleStartDate       : DATE);
  VAR
   EC,
   trgValue: STRING[];
   Idx     : NUMERIC[0];
 BEGIN
  SETEMPTY(FixingType,
           FullDayScheduleExitClss, ChangeableScheduleExitClss,
           Cycle, CycleLen, EC,
           GroupCycleStartDate, GroupCycle, GroupCycleStartECIdx, arrExitClss);
  IF ~!srcValue THEN
   FixingType:=L_Prop.getArrayItem(srcValue, 0);
   trgValue  :=L_Prop.getArrayItem(srcValue, 1);
   IF    FixingType = ec4twoft_Individual THEN
    FullDayScheduleExitClss   :=DecodeExitClss_ExitClass4two(L_Prop.getRecordElement(trgValue, 0));
    ChangeableScheduleExitClss:=DecodeExitClss_ExitClass4two(L_Prop.getRecordElement(trgValue, 1));
   ELSIF FixingType = ec4twoft_Cyclic     THEN
    L_General.Assert(~Strong | ~!L_Prop.getRecordElement(trgValue, 0), " 㪠 ⨯ 横");
    Cycle   :=L_Prop.getRecordElement(trgValue, 0);
    L_General.Assert(~Strong | ~!Cycle, "୮ 祭 横 '" + L_Prop.getRecordElement(trgValue, 0) + "'");
    CycleLen:=L_Prop.GetNumericValueFromStr(L_Prop.getRecordElement(trgValue, 1));
    EC      :=Str.Delete(trgValue, 0, Str.Length(L_Prop.getRecordElement(trgValue, 0)) + 1 +
                                      Str.Length(L_Prop.getRecordElement(trgValue, 1)) + 1);
    IF Strong THEN
     L_General.Assert(~!Cycle, "室 㪠 横");
     IF Cycle = ec4twoc_Special THEN
      L_General.Assert(~!CycleLen,   "室 㪠 ⢮   ᯥ樠쭮 横");
      L_General.Assert(CycleLen > 0, "୮ ⢮   ᯥ樠쭮 横");
     END;
     L_General.Assert(~!Str.Item(EC, ";", 0),
                      "室 㪠    ९  室");
    END;
    Idx:=0;
    WHILE (Idx < MaxCntExitClss) & ~!GetCycleExitClss_ExitClass4two(EC, Idx) DO
     arrExitClss[Idx]:=GetCycleExitClss_ExitClass4two(EC, Idx);
     INC(Idx);
    END; (* WHILE (Idx < ... *)
   ELSIF FixingType = ec4twoft_InSector   THEN
    IF ~!L_Prop.getRecordElement(trgValue, 2) THEN
     GroupCycleStartECIdx:=STRTOFLD(L_Prop.getRecordElement(trgValue, 2), NUMERIC);
    ELSE
     GroupCycleStartDate:=L_Prop.GetDateFromStr(L_Prop.getRecordElement(trgValue, 0), Strong);
     IF Strong THEN
      L_General.Assert(GroupCycleStartDate <= Math.Max(SYSDATE(), StaffPro.Date),
                       "⨬   㯫  横 ᥪ");
     END;
    END;
    IF ~!L_Prop.getRecordElement(trgValue, 1) THEN
     GroupCycle:=L_Prop.getRecordElement(trgValue, 1);
    ELSE
     GroupCycle:=0;
    END;
   END;
  END;
 END {Decode_ExitClass4two};

 PRIVATE PROCEDURE Decode_RegimeForMkBegRWS(VAR Regime: LIKE(RegMain.Regime);
                                            VAR Shift : NUMERIC[0]);
 BEGIN
  Regime:=L_r2r.Decode(L_Prop.getRecordElement(StaffPro.Value, 0));
  Shift :=STRTOFLD(L_Prop.getRecordElement(StaffPro.Value, 1), NUMERIC);
 END {Decode_RegimeForMkBegRWS};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   tmpResult,
   Result                    : STRING[];
   arrExitClss               : LIKE(ExitClss.ExitClss)[MaxCntExitClss];
   FixingType                : SCAL[3];
   Cycle                     : SCAL[4];
   CycleLen                  : NUMERIC[0];
   GroupCycle                : P_Sort.tgcwo;
   GroupCycleStartDate       : DATE;
   GroupCycleStartECIdx      : NUMERIC[0];
   FullDayScheduleExitClss   : LIKE(ExitClss.ExitClss);
   ChangeableScheduleExitClss: LIKE(ExitClss.ExitClss);
   Idx                       : NUMERIC[0];
   Regime                    : LIKE(RegMain.Regime);
   Shift                     : NUMERIC[0];
   trgSgnAuthR               : LIKE(SgnAuthR.SgnAuthR);
   Dummy                     : STRING[];
 BEGIN
  IF StaffPro.Property = P_RegimeForMkBegRWS THEN
   Decode_RegimeForMkBegRWS(Regime, Shift);
   Result:=" " + Regime + "  " + L_Str.IntStr(Shift);
  ELSIF StaffPro.Property = P_ExitClass4two THEN
   SETEMPTY(Result, tmpResult);
   Decode_ExitClass4two(StaffPro.Value, 0, FixingType,
                        FullDayScheduleExitClss, ChangeableScheduleExitClss,
                        Cycle, CycleLen, arrExitClss,
                        GroupCycle, GroupCycleStartECIdx, GroupCycleStartDate);
   L_Prop.putArrayItem(Result, L_Str.PoolItem(ec4two_FixingTypePool, FixingType));
   IF    FixingType = ec4twoft_Individual THEN
    L_Prop.putRES(tmpResult, FullDayScheduleExitClss);
    L_Prop.putRES(tmpResult, ChangeableScheduleExitClss);
   ELSIF FixingType = ec4twoft_Cyclic     THEN
    IF ~!Cycle THEN
     L_Prop.putRES(tmpResult, L_Str.PoolItem(ec4two_CycleNamePool, Cycle));
    ELSE
     L_Prop.putRES(tmpResult, "");
    END;
    IF (Cycle = ec4twoc_Special) & ~!CycleLen THEN
     L_Prop.putRES(tmpResult, L_Str.IntStr(CycleLen));
    ELSE
     L_Prop.putRES(tmpResult, "");
    END;
    Idx:=0;
    WHILE (Idx < MaxCntExitClss) & ~!arrExitClss[Idx] DO
     L_Prop.putRES(tmpResult, arrExitClss[Idx]);
     INC(Idx);
    END; (* WHILE (Idx < ... *)
   ELSIF FixingType = ec4twoft_InSector   THEN
    L_Prop.putRecordElement_D  (tmpResult, GroupCycleStartDate);
    IF ~!GroupCycle THEN
     L_Prop.putRES(tmpResult, L_Str.PoolItem(P_Sort.gcwo_NamePool, GroupCycle));
    ELSE
     L_Prop.putRES(tmpResult, "");
    END;
    IF ~!GroupCycleStartECIdx THEN
     L_Prop.putRES(tmpResult, L_Str.IntStr(GroupCycleStartECIdx));
    ELSE
     L_Prop.putRES(tmpResult, "");
    END;
   ELSE
    L_General.CallUs(0);
   END;
   L_Prop.putArrayItem(Result, tmpResult);
  ELSIF StaffPro.Property = P_SpecificForPF        THEN
   SEARCH(PnsAttr, PnsAttr, , L_r2r.Decode(StaffPro.Value));
   Result:=PnsAttr.PnsAttr + " " + PnsAttr.Name;
  ELSIF StaffPro.Property = P_SortForMkBegRWS      THEN
   SEARCH(Sort, Sort, , L_r2r.Decode(StaffPro.Value));
   Result:=Sort.Sort + " " + Sort.Name;
  ELSIF IsSimpleUserOf(StaffPro.Property) = "Staff" THEN
   SEARCH(Staff, TSN, , GetTSNFromReferenceStamp());
   CONFORM(Staff, Man);
   Result:=Staff.TSN + " " + Man.Name;
  ELSIF StaffPro.Property = P_SgnAuthR THEN
   Decode_SgnAuthR(StaffPro.Value, trgSgnAuthR, Dummy);
   SEARCH(SgnAuthR, SgnAuthR, , trgSgnAuthR);
   Result:=SgnAuthR.SgnAuthR + " " + SgnAuthR.Name;
  ELSE
   Result:=StaffPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PRIVATE PROCEDURE formSet_ExitClass4two();
  VAR
   Idx                       : SCAL[MaxCntExitClss];
   Fields                    : FORM_FIELDS;
   arrExitClss               : LIKE(ExitClss.ExitClss)[MaxCntExitClss];
   FixingType                : SCAL[3];
   Cycle                     : SCAL[4];
   CycleLen                  : NUMERIC[0];
   GroupCycle                : P_Sort.tgcwo;
   GroupCycleStartDate       : DATE;
   GroupCycleStartECIdx      : NUMERIC[0];
   FullDayScheduleExitClss   : LIKE(ExitClss.ExitClss);
   ChangeableScheduleExitClss: LIKE(ExitClss.ExitClss);
 BEGIN
  Fields                     :=RTI.Get().CurZone.Fields;
  Fields("Cycle").Format     :=ec4two_CycleNamePool;
  Fields("FixingType").Format:=ec4two_FixingTypePool;
  Fields("GroupCycle").Format:=P_Sort.gcwo_NamePool;
  Decode_ExitClass4two(StaffPro.Value, 0, FixingType,
                       FullDayScheduleExitClss, ChangeableScheduleExitClss,
                       Cycle, CycleLen, arrExitClss,
                       GroupCycle, GroupCycleStartECIdx, GroupCycleStartDate);
  L_WDO.CreateFormLink("ExitClss", "FullDaySchedule");
  L_WDO.CreateFormLink("ExitClss", "ChangeableSchedule");
  FOR_EACH Idx DO
   L_WDO.extCreateFormLink("ExitClss", "Cycle", Idx);
   Fields(L_Prop.BuildVideoFieldName("CycleExitClss",Idx)).Value:=arrExitClss[Idx];
  END; (* FOR_EACH Idx ... *)

  IF (RTI.Get().CurWindow.OriginalName = GetSubWindowName(P_ExitClass4two)) THEN
   Fields("FixingType").Value                :=FixingType;
   Fields("GroupCycle").Value                :=GroupCycle;
   Fields("FullDayScheduleExitClss").Value   :=FullDayScheduleExitClss;
   Fields("ChangeableScheduleExitClss").Value:=ChangeableScheduleExitClss;
   Fields("Cycle").Value                     :=Cycle;
   Fields("CycleLen").Value                  :=CycleLen;
   Fields("GroupCycleStartDate").Value       :=GroupCycleStartDate;
   Fields("GroupCycleStartECIdx").Value      :=GroupCycleStartECIdx;
  END;
  SetFields_ExitClass4two(0);
 END {formSet_ExitClass4two};

 PUBLIC PROCEDURE GetP_RegimeForMkBegRWS(    trgTSN: LIKE(Staff.TSN);
                                             D     : DATE;
                                         VAR Regime: LIKE(RegMain.Regime);
                                         VAR Shift : NUMERIC[0]);
 BEGIN
  IF HasActualStaffPro(trgTSN, D, P_RegimeForMkBegRWS) THEN
   Decode_RegimeForMkBegRWS(Regime, Shift);
  ELSE
   SETEMPTY(Regime, Shift);
  END;
 END {GetP_RegimeForMkBegRWS};

 PRIVATE PROCEDURE formSet_RegimeForMkBegRWS();
  VAR
   Fields: FORM_FIELDS;
   Regime: LIKE(RegMain.Regime);
   Shift : NUMERIC[0];
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  L_WDO.CreateFormLink("RegMain", "");
  Decode_RegimeForMkBegRWS(Regime, Shift);
  Fields("Regime").Value:=Regime;
  Fields("Shift").Value :=Shift;
 END {formSet_RegimeForMkBegRWS};

 PUBLIC PROCEDURE SetDataInForm(_Property: LIKE(Property.Property));
 BEGIN
  IF    (_Property = P_ExitClass4two)     THEN
   formSet_ExitClass4two();
  ELSIF (_Property = P_RegimeForMkBegRWS) THEN
   formSet_RegimeForMkBegRWS();
  ELSIF (_Property = P_SgnAuthR)          THEN
   formSet_SgnAuthR();
  END;
 END {SetDataInForm};

 PUBLIC PROCEDURE Encode_ExitClass4two(VAR dstValue                  : STRING[];
                                           FixingType                : SCAL[3];
                                           FullDayScheduleExitClss   : LIKE(ExitClss.ExitClss);
                                           ChangeableScheduleExitClss: LIKE(ExitClss.ExitClss);
                                           Cycle                     : SCAL[4];
                                           CycleLen                  : NUMERIC[0];
                                           CycleExitClss             : LIKE(ExitClss.ExitClss)[];
                                           GroupCycle                : P_Sort.tgcwo;
                                           GroupCycleStartECIdx      : NUMERIC[0];
                                           GroupCycleStartDate       : DATE);
  VAR
   trgValue: STRING[];
   Idx     : SCAL[MaxCntExitClss];
   HasOneEC: SCAL[2];
 BEGIN
  SETEMPTY(dstValue);
  L_Prop.putArrayItem(dstValue, FixingType);
  SETEMPTY(trgValue);
  IF    FixingType = ec4twoft_Individual THEN
   L_General.Assert(~!FullDayScheduleExitClss | ~!ChangeableScheduleExitClss,
                    " 㪠  室   楫,   ᬥ 䨪");
   L_Prop.putRES(trgValue, L_r2r.Put("StaffPro", "ExitClss", FullDayScheduleExitClss));
   L_Prop.putRES(trgValue, L_r2r.Put("StaffPro", "ExitClss", ChangeableScheduleExitClss));
  ELSIF FixingType = ec4twoft_Cyclic     THEN
   L_Prop.putRES(trgValue, Cycle);
   IF Cycle = ec4twoc_Special THEN
    L_Prop.putRES(trgValue, L_Str.IntStr(CycleLen));
   ELSE
    L_Prop.putRES(trgValue, "");
   END;
   HasOneEC:=0;
   FOR_EACH Idx DO
    IF ~!CycleExitClss[Idx] THEN
     L_Prop.putRES(trgValue, L_r2r.Put("StaffPro", "ExitClss", CycleExitClss[Idx]));
     HasOneEC:=1;
    END;
   END; (* FOR_EACH Idx ... *)
   L_General.Assert(HasOneEC, " 㪠    室  横");
  ELSIF FixingType = ec4twoft_InSector   THEN
   L_General.Assert(!GroupCycleStartDate | !GroupCycleStartECIdx,
                    "뢠  砫  室   宦  横,|" +
                    " 祭 ६  ");
   L_General.Assert(~!GroupCycleStartDate | ~!GroupCycleStartECIdx,
                    " 㪠 砫  室   宦  横");
   L_Prop.putRecordElement_D  (trgValue, GroupCycleStartDate);
   L_Prop.putRES(trgValue, GroupCycle);
   L_Prop.putRES(trgValue, L_Str.IntStr(GroupCycleStartECIdx));
  END;
  L_Prop.putArrayItem(dstValue, trgValue);
 END {Encode_ExitClass4two};

 PRIVATE PROCEDURE formGet_ExitClass4two();
  VAR
   Fields       : FORM_FIELDS;
   CycleExitClss: LIKE(ExitClss.ExitClss)[MaxCntExitClss];
   Idx          : SCAL[MaxCntExitClss];
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  FOR_EACH Idx DO
   IF ~!Fields(L_Prop.BuildVideoFieldName("CycleExitClss", Idx)).Value THEN
    CycleExitClss[Idx]:=FLDTOSTR(Fields(L_Prop.BuildVideoFieldName("CycleExitClss", Idx)).Value);
   ELSE
    SETEMPTY(CycleExitClss[Idx]);
   END;
  END; (* FOR_EACH Idx ... *)
  Encode_ExitClass4two(StaffPro.Value,
                       Fields("FixingType").Value,
                       Fields("FullDayScheduleExitClss").Value, Fields("ChangeableScheduleExitClss").Value,
                       Fields("Cycle").Value, Fields("CycleLen").Value, CycleExitClss,
                       Fields("GroupCycle").Value, Fields("GroupCycleStartECIdx").Value, Fields("GroupCycleStartDate").Value);
 END {formGet_ExitClass4two};

 PRIVATE PROCEDURE formGet_RegimeForMkBegRWS();
  VAR
   Fields    : FORM_FIELDS;
   StrRegMain: STRING[];
   curRegime : LIKE(RegMain.Regime);
   curShift  : NUMERIC[0];
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  curRegime:=Fields("Regime").Value;
  curShift :=Fields("Shift").Value;
  IF ~!curRegime | ~!curShift THEN
   L_General.Assert(~!curRegime & ~!curShift, "    ०,  ᤢ");
   L_General.Assert(Math.Abs(curShift)<=100, "     100 ");
   IF (SEARCH(RegHead, HumReg, curRegime, L_DatTim.Per(StaffPro.Date)) |
       (SELECT(RegHead, HumReg, curRegime) & LAST(RegHead))) &
      (Math.Abs(curShift)>2*RegHead.Cycle) THEN
    L_StdFrm.Choice(" ॢ蠥 横  祬   ࠧ");
   END;
   StrRegMain:=L_r2r.Put("StaffPro", "RegMain", Fields("Regime").Value);
   L_Prop.putREV(StaffPro.Value, StrRegMain);
   L_Prop.putREV(StaffPro.Value, curShift);
  END;
 END {formGet_RegimeForMkBegRWS};

 PUBLIC PROCEDURE GetDataFromForm(_Property: LIKE(Property.Property));
 BEGIN
  SETEMPTY(StaffPro.Value);
  IF    _Property = P_RegimeForMkBegRWS THEN
   formGet_RegimeForMkBegRWS();
  ELSIF _Property = P_ExitClass4two     THEN
   formGet_ExitClass4two();
  ELSIF _Property = P_SgnAuthR          THEN
   formGet_SgnAuthR();
  ELSE
   L_General.CallUs(0);
  END;
  REPLACE(StaffPro);
 END {GetDataFromForm};

 PUBLIC PROCEDURE Mtwo_SP_1_OnZoneOpen();
  VAR
   Filter: STRING[];
 BEGIN
  Filter:="";
  INC(Filter,       "(StaffPro.Property=" + L_Str.IntStr(P_RegimeForMkBegRWS)    + ")");
  INC(Filter, "|" + "(StaffPro.Property=" + L_Str.IntStr(P_ExitClass4two)        + ")");
  INC(Filter, "|" + "(StaffPro.Property=" + L_Str.IntStr(P_FixedGuard)           + ")");
  INC(Filter, "|" + "(StaffPro.Property=" + L_Str.IntStr(P_SortForMkBegRWS)      + ")");
  INC(Filter, "|" + "(StaffPro.Property=" + L_Str.IntStr(P_ProhibitInBegRWayS)   + ")");
  INC(Filter, "|" + "(StaffPro.Property=" + L_Str.IntStr(P_SubstitutionInBegRWS) + ")");
  Filter:="(StaffPro.EndDate >= Memo.MonthB) & (" + Filter + ")";
  L_WDO.InstallPermanentFilter(Filter);
 END {Mtwo_SP_1_OnZoneOpen};

 PRIVATE PROCEDURE StaffPro_OnModification();
  VAR
   trgSgnAuthR: LIKE(SgnAuthR.SgnAuthR);
   Dummy      : STRING[];
 BEGIN
  IF    (StaffPro.Property = P_RegimeForMkBegRWS) | (StaffPro.Property = P_ExitClass4two) THEN
   L_two.m_MarkAsNotActual(StaffPro.TSN, StaffPro.Date, StaffPro.EndDate);
  ELSIF StaffPro.Property = P_SubstitutionInBegRWS THEN
   L_two.m_MarkAsNotActual(StaffPro.TSN, StaffPro.Date, StaffPro.EndDate);
   StaffPro.SpdSrchV:=GetTSNFromReferenceStamp();
   REPLACE(StaffPro);
  ELSIF (StaffPro.Property = P_FixedGuard) | (StaffPro.Property = P_ProbationFixing) THEN
   StaffPro.SpdSrchV:=GetTSNFromReferenceStamp();
   REPLACE(StaffPro);
  ELSIF StaffPro.Property = P_SgnAuthR THEN
   Decode_SgnAuthR(StaffPro.Value, trgSgnAuthR, Dummy);
   StaffPro.SpdSrchV:=trgSgnAuthR;
   REPLACE(StaffPro);
  END;
 END {StaffPro_OnModification};

 PUBLIC PROCEDURE StaffPro_OnAfterInsert();
 BEGIN
  StaffPro_OnModification();
 END {StaffPro_OnAfterInsert};

 PUBLIC PROCEDURE StaffPro_OnAfterEdit();
 BEGIN
  StaffPro_OnModification();
 END {StaffPro_OnAfterEdit};

 PUBLIC PROCEDURE StaffPro_OnBeforeDelete();
 BEGIN
  StaffPro_OnModification();
 END {StaffPro_OnBeforeDelete};

 PUBLIC PROCEDURE StaffPro_OnBeforeEdit();
 BEGIN
  StaffPro_OnModification();
 END {StaffPro_OnBeforeEdit};


END.
