(*
%Copyright   (c) Polak IT
%Author      05.09.2005 10:38:27 POLAK\GAV
%Purpose       ᢮⢠  ࠭
%Type        library
%Specific    SYS
%Modified    06.06.2013 18:51:48 POLAK\Gina
%Environment
*)

 MODULE P_Storage [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Stock, Str, L_Str, L_Prop, L_WDO, L_qs, Math, L_r2r, L_StdFrm, L_DatTim;

 PRIVATE CONST
  dcc_Pool       = "|";

  gss_ArrAmnt    = 20;
  gss_ArrAmntOut = 3;

 PUBLIC TYPE
  tPump         = SCAL[100];
  tNozzle       = SCAL[100];
  tOwnPumpArr   = tPump[gss_ArrAmnt];
  tOwnNozzleArr = tNozzle[gss_ArrAmnt];
  tOwnMathArr   = LIKE(Math.Math)[gss_ArrAmnt];

  tOutNozzleArr = tNozzle[gss_ArrAmntOut];
  tOutMathArr   = LIKE(Math.Math)[gss_ArrAmntOut];

 PUBLIC CONST
  P_DocCircCharacteristic = 3500;
  P_StoringFeatures       = 3501;
  P_GasStanSetup          = 3502;

  qsa_StoringType = 0;

  MaxGasStanPumpAmount = 12;

 PUBLIC PROCEDURE GetSubWindowName(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    trgProperty = P_DocCircCharacteristic THEN
   RETURN "P_3500";
  ELSIF trgProperty = P_StoringFeatures THEN
   RETURN "P_3501";
  ELSIF trgProperty = P_GasStanSetup THEN
   RETURN "P_3502";
  ELSE
   RETURN "";
  END;
 END {GetSubWindowName};

 PUBLIC PROCEDURE GetPool(trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  IF L_Prop.IsLocalProperty(trgProperty) THEN
   RETURN L_Prop.E_GetPool(trgProperty);
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PRIVATE PROCEDURE CheckExpValidity(trgProperty: LIKE(Property.Property); trgDate, trgDocExpD: DATE);
 BEGIN
  L_General.Assert((trgDate=L_DatTim.MonthBeg(trgDate)) & (!trgDocExpD | (trgDocExpD=L_DatTim.MonthBeg(trgDocExpD))),
                   "⢮  ⢮ 楫 ᫮ 楢");
 END {CheckExpValidity};

 PUBLIC PROCEDURE Check(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_StoringFeatures THEN
   CheckExpValidity(trgProperty, StrgPro.Date, StrgPro.DocExpD);
  END;
 END {Check};

 PUBLIC PROCEDURE qsa_SetStoringType_Set(trgMyFirm: LIKE(MyFirm.MyFirm); stType: L_Stock.tStoringType): LIKE(qs.Value);
 BEGIN
  RETURN trgMyFirm + " " + L_Str.FixedIntStr(stType, 2);
 END {qsa_SetStoringTypeValue};

 PUBLIC PROCEDURE qsa_Conv2Value(trgAttr: LIKE(qs.Attr); VAR (*sic!*) trgSource: VARIANT): LIKE(qs.Value);
 BEGIN
  L_General.CallUs(0);
 END {qsa_Conv2Value};

 PRIVATE PROCEDURE Decode_StoringFeatures(    curValue          : STRING[];
                                          VAR StoringType       : L_Stock.tStoringType;
                                          VAR DontCheckXCalcRest: SCAL[2]);
 BEGIN
  SETEMPTY(StoringType, DontCheckXCalcRest);
  StoringType       :=L_Str.PositionInPool(L_Stock.storingType_Pool, L_Prop.getRES(curValue, 0));
  DontCheckXCalcRest:=L_Prop.GetNumericValueFromStr(L_Prop.getRES(curValue, 1));
 END {Decode_StoringFeatures};

 PRIVATE PROCEDURE formSet_StoringFeatures();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("StoringType").Format       :=L_Stock.storingType_Pool;
  Fields("DontCheckXCalcRest").Format:="-|";

  Decode_StoringFeatures(StrgPro.Value, Fields("StoringType").Value, Fields("DontCheckXCalcRest").Value);
 END {formSet_StoringFeatures};

 PRIVATE PROCEDURE formGet_StoringFeatures();
  VAR
   StoringType: L_Stock.tStoringType;
 BEGIN
  SETEMPTY(StrgPro.Value);
  StoringType:=RTI.Get().CurZone.Fields("StoringType").Value;
  L_Prop.putRES(StrgPro.Value, L_Str.PoolItem(L_Stock.storingType_Pool, StoringType));
  L_Prop.putREV(StrgPro.Value, RTI.Get().CurZone.Fields("DontCheckXCalcRest").Value);

  CONFORM(StrgPro, Storage);
  L_qs.byPro_Add("StrgPro", qsa_StoringType, qsa_SetStoringType_Set(Storage.MyFirm, StoringType));
 END {formGet_StoringFeatures};

 PRIVATE PROCEDURE Decode_DocCircCharacteristic(    curValue    : STRING[];
                                                VAR OnLine,
                                                    ImdPrint    : SCAL[2];
                                                VAR ShiftBegTime: TIME;
                                                VAR ShiftSLength: NUMERIC[6,3]);
 BEGIN
  IF !curValue THEN
   SETZERO(OnLine, ImdPrint);
   SETEMPTY(ShiftBegTime, ShiftSLength);
  ELSE
   OnLine      :=L_Str.PositionInPool(dcc_Pool, L_Prop.getRES(curValue, 0));
   ImdPrint    :=L_Str.PositionInPool(dcc_Pool, L_Prop.getRES(curValue, 1));
   ShiftBegTime:=STRTOFLD(L_Prop.getRES(curValue, 2), TIME);
   ShiftSLength:=STRTOFLD(L_Prop.getRES(curValue, 3), NUMERIC);
  END;
 END {Decode_DocCircCharacteristic};

 PRIVATE PROCEDURE formSet_DocCircCharacteristic();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_DocCircCharacteristic(StrgPro.Value,
                               Fields("OnLine").Value,
                               Fields("ImdPrint").Value,
                               Fields("ShiftBegTime").Value,
                               Fields("ShiftSLength").Value);
  Fields("OnLine"  ).Format:=dcc_Pool;
  Fields("ImdPrint").Format:=dcc_Pool;
 END {formSet_DocCircCharacteristic};

 PRIVATE PROCEDURE Decode_GasStanSetup(    curValue  : STRING[];
                                       VAR OwnPumps  : tOwnPumpArr;
                                       VAR OwnNozzles: tOwnNozzleArr;
                                       VAR OwnMaths  : tOwnMathArr;
                                       VAR OutNozzles: tOutNozzleArr;
                                       VAR OutMaths  : tOutMathArr);
  VAR
   i     : NUMERIC[0];
   tmpStr,
   Record: STRING[];
 BEGIN
  tmpStr:=Str.Item(curValue, " ", 0);
  i:=0;
  WHILE i <= HIGH(OwnNozzles) DO
   Record    :=L_Prop.getAIS(tmpStr, i);
   OwnPumps[i]   :=L_Prop.getRES(Record, 0);
   OwnNozzles[i] :=L_Prop.getRES(Record, 1);
   OwnMaths[i]:=L_r2r.Decode(L_Prop.getRES(Record, 2));
   INC(i);
  END (* WHILE i <= HIGH(OwnNozzles)...*);

  tmpStr:=Str.Item(curValue, " ", 1);
  i:=0;
  WHILE i <= HIGH(OutNozzles) DO
   Record      :=L_Prop.getAIS(tmpStr, i);
   OutNozzles[i]:=L_Prop.getRES(Record, 0);
   OutMaths[i]  :=L_r2r.Decode(L_Prop.getRES(Record, 1));
   INC(i);
  END (* WHILE i <= HIGH(OutNozzles)...*);
 END {Decode_GasStanSetup};

 PRIVATE PROCEDURE formSet_GasStanSetup();
  VAR
   i         : NUMERIC[0];
   Fields    : FORM_FIELDS;
   OwnPumps  : tOwnPumpArr;
   OwnNozzles: tOwnNozzleArr;
   OwnMaths  : tOwnMathArr;
   OutNozzles: tOutNozzleArr;
   OutMaths  : tOutMathArr;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Decode_GasStanSetup(StrgPro.Value,
                      OwnPumps, OwnNozzles, OwnMaths,
                                OutNozzles, OutMaths);
  i:=0;
  WHILE i <= HIGH(OwnNozzles) DO
   Fields(L_WDO.Fld_wIdx("OwnPump",   i)).Value:=OwnPumps[i];
   Fields(L_WDO.Fld_wIdx("OwnNozzle", i)).Value:=OwnNozzles[i];
   Fields(L_WDO.Fld_wIdx("OwnMath",   i)).Value:=OwnMaths[i];
   L_WDO.extCreateFormLink("Math", "Own", i);
   INC(i);
  END; (* WHILE i <= HIGH(OwnNozzles)...*)

  i:=0;
  WHILE i <= HIGH(OutNozzles) DO
   Fields(L_WDO.Fld_wIdx("OutNozzle", i)).Value:=OutNozzles[i];
   Fields(L_WDO.Fld_wIdx("OutMath",   i)).Value:=OutMaths[i];
   L_WDO.extCreateFormLink("Math", "Out", i);
   INC(i);
  END; (* WHILE i <= HIGH(OutNozzles)...*)
 END {formSet_GasStanSetup};

 PUBLIC PROCEDURE SetDataInForm(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_DocCircCharacteristic THEN formSet_DocCircCharacteristic();
  ELSIF trgProperty = P_StoringFeatures       THEN formSet_StoringFeatures();
  ELSIF trgProperty = P_GasStanSetup          THEN formSet_GasStanSetup();
  END;
 END {SetDataInForm};

 PRIVATE PROCEDURE Encode_DocCircCharacteristic(VAR curValue    : STRING[];
                                                    OnLine,
                                                    ImdPrint    : SCAL[2];
                                                    ShiftBegTime: TIME;
                                                    ShiftSLength: NUMERIC[6,3]);
 BEGIN
  SETEMPTY(curValue);
  L_Prop.putRES(curValue, L_Str.PoolItem(dcc_Pool, OnLine));
  L_Prop.putRES(curValue, L_Str.PoolItem(dcc_Pool, ImdPrint));
  L_Prop.putRET(curValue, ShiftBegTime);
  L_Prop.putREV(curValue, ShiftSLength);
 END {Encode_DocCircCharacteristic};

 PRIVATE PROCEDURE formGet_DocCircCharacteristic();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Encode_DocCircCharacteristic(StrgPro.Value,
                               Fields("OnLine").Value,
                               Fields("ImdPrint").Value,
                               Fields("ShiftBegTime").Value,
                               Fields("ShiftSLength").Value);
 END {formGet_DocCircCharacteristic};

 PUBLIC PROCEDURE P_3502_OnInitializeWindow();
  VAR
   i          : NUMERIC[0];
   fn_Pump,
   fn_Nozzle,
   fn_Math,
   fn_MathName: STRING[];
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification]);
  L_WDO.iUnmodifiable(0, ["ObjectDescr", "ObjectTitle"]);
  i:=0;
  WHILE i < gss_ArrAmnt DO
   fn_Pump    :=L_WDO.Fld_wIdx("OwnPump", i);
   fn_Nozzle  :=L_WDO.Fld_wIdx("OwnNozzle", i);
   fn_Math    :=L_WDO.Fld_wIdx("OwnMath", i);
   fn_MathName:=L_WDO.Fld_wIdx("OwnMath_Name", i);

   L_WDO.iScsChange   (0, fn_Pump);
   L_WDO.iScsChange   (0, fn_Nozzle);
   L_WDO.iUnmodifiable(0, fn_MathName);
   L_WDO.iMayBeEmpty  (0, fn_Pump);
   L_WDO.iMayBeEmpty  (0, fn_Nozzle);
   L_WDO.iMayBeEmpty  (0, fn_Math);
   INC(i);
  END; (* WHILE i < gss_ArrAmnt...*)

  i:=0;
  WHILE i < gss_ArrAmntOut DO
   fn_Nozzle  :=L_WDO.Fld_wIdx("OutNozzle", i);
   fn_Math    :=L_WDO.Fld_wIdx("OutMath", i);
   fn_MathName:=L_WDO.Fld_wIdx("OutMath_Name", i);
   L_WDO.iScsChange   (0, fn_Nozzle);
   L_WDO.iUnmodifiable(0, fn_MathName);
   L_WDO.iMayBeEmpty  (0, fn_Nozzle);
   L_WDO.iMayBeEmpty  (0, fn_Math);
   INC(i);
  END; (* WHILE i < gss_ArrAmntOut...*)

  L_WDO.iProgs       (0, "ObjPro");
 END {P_3502_OnInitializeWindow};

 PRIVATE PROCEDURE Encode_GasStanSetup(VAR curValue  : STRING[];
                                           OwnPumps  : tOwnPumpArr;
                                           OwnNozzles: tOwnNozzleArr;
                                           OwnMaths  : tOwnMathArr;
                                           OutNozzles: tOutNozzleArr;
                                           OutMaths  : tOutMathArr);
  VAR
   i     : NUMERIC[0];
   Record: STRING[];
 BEGIN
  SETEMPTY(curValue);
  i:=0;
  WHILE i <= HIGH(OwnNozzles) DO
   IF ~!OwnPumps[i] & ~!OwnNozzles[i] & ~!OwnMaths[i] THEN
    SETEMPTY(Record);
    L_Prop.putRES(Record, OwnPumps[i]);
    L_Prop.putRES(Record, OwnNozzles[i]);
    L_Prop.putRES(Record, L_r2r.Put("StrgPro", "Math", OwnMaths[i]));
    L_Prop.putAIS(curValue, Record);
   END;
   INC(i);
  END; (* WHILE i <= HIGH(OwnNozzles)...*)
  INC(curValue, " ");

  i:=0;
  WHILE i <= HIGH(OutNozzles) DO
   IF ~!OutNozzles[i] & ~!OutMaths[i] THEN
    SETEMPTY(Record);
    L_Prop.putRES(Record, OutNozzles[i]);
    L_Prop.putRES(Record, L_r2r.Put("StrgPro", "Math", OutMaths[i]));
    L_Prop.putAIS(curValue, Record);
   END;
   INC(i);
  END; (* WHILE i <= HIGH(OutNozzles)...*)
 END {Encode_GasStanSetup};

 PRIVATE PROCEDURE CheckString_GasStanSetup(IsOutNozzle: SCAL[2]; Pump: tPump; Nozzle: tNozzle; trgMath: LIKE(Math.Math); ErrorStr: STRING[]);
 BEGIN
  IF ~!Pump | ~!Nozzle | ~!trgMath THEN
   IF IsOutNozzle THEN
    L_General.Assert(!Nozzle = !trgMath,
                     ErrorStr + "      ६");
   ELSE
    L_General.Assert((!Pump = !Nozzle) & (!Pump = !trgMath),
                     ErrorStr + "      ६");
    L_General.Assert(Pump >= 1, ErrorStr + "⨬  ");
   END;
   L_General.Assert(Nozzle # 0, ErrorStr + "⨬  ⮫");
  END;
 END {CheckString_GasStanSetup};

 PRIVATE PROCEDURE GetGasStanTotalPumpAmount(OwnPumps: tOwnPumpArr): NUMERIC[0];
  VAR
   i, Result   : NUMERIC[0];
   ArrUniqPumps: tPump[100];
 BEGIN
  SETZERO(ArrUniqPumps);
  i:=0;
  WHILE i <= HIGH(OwnPumps) DO
   IF ~!OwnPumps[i] THEN
    ArrUniqPumps[OwnPumps[i]]:=1;
   END;
   INC(i);
  END; (* WHILE i <= HIGH(OwnPumps)...*)

  SETZERO(Result);
  i:=0;
  WHILE i <= HIGH(ArrUniqPumps) DO
   INC(Result, ArrUniqPumps[i]);
   INC(i);
  END; (* WHILE i <= HIGH(ArrUniqPumps)...*)
  RETURN Result;
 END {GetGasStanTotalPumpAmount};

 PRIVATE PROCEDURE formGet_GasStanSetup();
  VAR
   i,
   PumpAmount: NUMERIC[0];
   Fields    : FORM_FIELDS;
   OwnPumps,
   DummyPumps: tOwnPumpArr;
   OwnNozzles: tOwnNozzleArr;
   OwnMaths  : tOwnMathArr;
   OutNozzles: tOutNozzleArr;
   OutMaths  : tOutMathArr;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  i:=0;
  WHILE ~!Fields(L_WDO.Fld_wIdx("OwnNozzle",   i)) DO
   OwnPumps[i]  :=Fields(L_WDO.Fld_wIdx("OwnPump",   i)).Value;
   OwnNozzles[i]:=Fields(L_WDO.Fld_wIdx("OwnNozzle", i)).Value;
   OwnMaths[i]  :=Fields(L_WDO.Fld_wIdx("OwnMath",   i)).Value;
   CheckString_GasStanSetup(0, OwnPumps[i], OwnNozzles[i], OwnMaths[i], "⢥ , ப: " + L_Str.IntStr(i+1) + ": ");
   INC(i);
  END; (* WHILE ~!Fields(L_WDO.Fld_wIdx("OwnPump",   i))...*)

  PumpAmount:=GetGasStanTotalPumpAmount(OwnPumps);
  IF PumpAmount > MaxGasStanPumpAmount THEN
   L_General.Error("⢮      " + L_Str.IntStr(MaxGasStanPumpAmount) + ", ᠭ " + L_Str.IntStr(PumpAmount) + ".||" +
                   "᫨   ⢨⥫쭮 ⠪ ⢮ ,   ࠡ稪");
  END;

  SETEMPTY(DummyPumps);
  i:=0;
  WHILE ~!Fields(L_WDO.Fld_wIdx("OutNozzle",   i)) DO
   OutNozzles[i]:=Fields(L_WDO.Fld_wIdx("OutNozzle", i)).Value;
   OutMaths[i]  :=Fields(L_WDO.Fld_wIdx("OutMath",   i)).Value;
   CheckString_GasStanSetup(1, DummyPumps[i], OutNozzles[i], OutMaths[i], "஭ , ப: " + L_Str.IntStr(i+1) + ": ");
   INC(i);
  END; (* WHILE ~!Fields(L_WDO.Fld_wIdx("OutNozzle",   i)) ... *)

  Encode_GasStanSetup(StrgPro.Value,
                      OwnPumps, OwnNozzles, OwnMaths,
                                OutNozzles, OutMaths);
  L_Prop.ConvEmptyRecordPropertyValue(StrgPro.Value);
  L_StdFrm.Inform("⮡  㯨  ᨫ,|" +
                  "짮⥫ 室 ॢ  'ࠢ ⠭'");
 END {formGet_GasStanSetup};

 PUBLIC PROCEDURE GetDataFromForm(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_DocCircCharacteristic THEN formGet_DocCircCharacteristic();
  ELSIF trgProperty = P_StoringFeatures       THEN formGet_StoringFeatures();
  ELSIF trgProperty = P_GasStanSetup          THEN formGet_GasStanSetup();
  ELSE                                             L_General.CallUs(0);
  END;
  REPLACE(StrgPro);
 END {GetDataFromForm};

 PRIVATE PROCEDURE GetVal2Show_GasStanSetup(): STRING[];
  VAR
   i         : NUMERIC[0];
   Record,
   Result    : STRING[];
   OwnPumps  : tOwnPumpArr;
   OwnNozzles: tOwnNozzleArr;
   OwnMaths  : tOwnMathArr;
   OutNozzles: tOutNozzleArr;
   OutMaths  : tOutMathArr;
 BEGIN
  SETEMPTY(Result);
  Decode_GasStanSetup(StrgPro.Value,
                      OwnPumps, OwnNozzles, OwnMaths,
                                OutNozzles, OutMaths);

  i:=0;
  WHILE i <= HIGH(OwnNozzles) DO
   IF ~!OwnPumps[i] & ~!OwnNozzles[i] & ~!OwnMaths[i] THEN
    SETEMPTY(Record);
    L_Prop.putRES(Record, OwnPumps[i]);
    L_Prop.putRES(Record, OwnNozzles[i]);
    L_Prop.putRES(Record, OwnMaths[i]);
    L_Prop.putAIS(Result, Record);
   END;
   INC(i);
  END; (* WHILE i <= HIGH(OwnNozzles)...*)
  INC(Result, " ");

  i:=0;
  WHILE i <= HIGH(OutNozzles) DO
   IF ~!OutNozzles[i] & ~!OutMaths[i] THEN
    SETEMPTY(Record);
    L_Prop.putRES(Record, OutNozzles[i]);
    L_Prop.putRES(Record, OutMaths[i]);
    L_Prop.putAIS(Result, Record);
   END;
   INC(i);
  END; (* WHILE i <= HIGH(OutNozzles)...*)
  RETURN Result;
 END {GetVal2Show_GasStanSetup};

 PUBLIC PROCEDURE GetVal2Show(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF StrgPro.Property = P_GasStanSetup THEN
   Result:=GetVal2Show_GasStanSetup();
  ELSE
   Result:=StrgPro.Value;
  END;
  RETURN Result;
 END {GetVal2Show};

 PRIVATE PROCEDURE OnBeforeModification();
 BEGIN
  IF StrgPro.Property = P_StoringFeatures THEN
   L_qs.OnBeforeDelete("StrgPro");
  END;
 END {OnBeforeModification};

 PUBLIC PROCEDURE OnBeforeEdit();
 BEGIN
  OnBeforeModification();
 END {OnBeforeEdit};

 PUBLIC PROCEDURE OnBeforeDelete();
 BEGIN
  OnBeforeModification();
 END {OnBeforeDelete};

 PRIVATE PROCEDURE CheckNozzles(curPump           : tPump;
                                curNozzle         : tNozzle;
                                curNozzleFieldName: STRING[];
                                CheckOwnNozzles   : SCAL[2]);
  VAR
   Idx       : NUMERIC[0];
   Fields    : FORM_FIELDS;
   trgPump   : tPump;
   trgNozzle : tNozzle;
   fld_Nozzle: FORM_FIELD;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Idx:=0;
  LOOP
   IF CheckOwnNozzles THEN
    fld_Nozzle:=Fields(L_WDO.Fld_wIdx("OwnNozzle", Idx));
   ELSE
    fld_Nozzle:=Fields(L_WDO.Fld_wIdx("OutNozzle", Idx));
   END;

   IF !fld_Nozzle THEN
    EXIT;
   END;

   trgNozzle:=fld_Nozzle.Value;
   IF CheckOwnNozzles THEN
    trgPump:=Fields(L_WDO.Fld_wIdx("OwnPump",   Idx)).Value;
   ELSE
    SETEMPTY(trgPump);
   END;

   IF curNozzleFieldName # fld_Nozzle.Name THEN
    IF (trgPump # curPump) & (trgNozzle = curNozzle) THEN
     L_General.Error("⮫ " + curNozzle + " 㦥 㪠  ப " + L_Str.IntStr(Idx+1) + " ᠭ " +
                     L_Str.PoolItem("஭ |ᮡ⢥ ", CheckOwnNozzles) + "||" +
                     "  ⮫⮢  ⮫쪮  ।  ");
    END;
   END;
   INC(Idx);
  END; (* LOOP *)
 END {CheckNozzles};

 PRIVATE PROCEDURE CheckNozzleIsUnique();
  VAR
   i,
   curIdx            : NUMERIC[0];
   curPump           : tPump;
   curNozzle         : tNozzle;
   IsOutNozzle       : SCAL[2];
   curNozzleFieldName: STRING[];
 BEGIN
  curIdx:=L_WDO.getCurFldIdx();
  IF Str.Match(RTI.Get().CurZone.ActiveField.Name, "*Out*") THEN
   SETEMPTY(curPump);
   curNozzleFieldName:=L_WDO.Fld_wIdx("OutNozzle", curIdx);
   curNozzle         :=RTI.Get().CurZone.Fields(curNozzleFieldName).Value;
   IsOutNozzle       :=1;
  ELSE
   curPump           :=RTI.Get().CurZone.Fields(L_WDO.Fld_wIdx("OwnPump",   curIdx)).Value;
   curNozzleFieldName:=L_WDO.Fld_wIdx("OwnNozzle", curIdx);
   curNozzle         :=RTI.Get().CurZone.Fields(curNozzleFieldName).Value;
   IsOutNozzle       :=0;
  END;

  IF (~IsOutNozzle & ~!curPump & ~!curNozzle) |
     ( IsOutNozzle & ~!curNozzle) THEN
   CheckNozzles(curPump, curNozzle, curNozzleFieldName, 1);
   CheckNozzles(curPump, curNozzle, curNozzleFieldName, 0);
  END;
 END {CheckNozzleIsUnique};

 PUBLIC PROCEDURE OnSuccessfulChange(trgProperty: LIKE(Property.Property));
 BEGIN
  IF trgProperty = P_GasStanSetup THEN
   CheckNozzleIsUnique();
  END;
 END {OnSuccessfulChange};

 PUBLIC PROCEDURE HasPro(trgStorage: LIKE(Storage.Storage); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SELECT(StrgPro, Storage, trgStorage, trgProperty) & SRCINSEL(StrgPro, LE, D);
 END {HasPro};

 PUBLIC PROCEDURE AccessPro(trgStorage: LIKE(Storage.Storage); D: DATE; trgProperty: LIKE(Property.Property));
 BEGIN
  IF ~HasPro(trgStorage, D, trgProperty) THEN
   SEARCH(Storage, Storage, , trgStorage);
   L_Prop.ShowUndefinedProValueError(TABLE.Get("Storage").Id, Storage.RECORDID, trgProperty, D);
  END;
 END {AccessPro};

 PUBLIC PROCEDURE HasActualPro(trgStorage: LIKE(Storage.Storage); D: DATE; trgProperty: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasPro(trgStorage, D, trgProperty) & (!StrgPro.DocExpD | (D < StrgPro.DocExpD));
 END {HasActualPro};

 PRIVATE PROCEDURE intGetPro(trgStorage : LIKE(Storage.Storage);
                             D          : DATE;
                             trgProperty: LIKE(Property.Property);
                             Strong     : SCAL[2]): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF HasActualPro(trgStorage, D, trgProperty) THEN
   Result:=StrgPro.Value;
  ELSE
   IF Strong THEN
    SEARCH(Storage, Storage, , trgStorage);
    L_Prop.ShowUndefinedProValueError(TABLE.Get("Storage").Id, Storage.RECORDID, trgProperty, D);
   END;
  END;
  RETURN Result;
 END {intGetPro};

 PUBLIC PROCEDURE GetProStrong(trgStorage: LIKE(Storage.Storage); D: DATE; trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN intGetPro(trgStorage, D, trgProperty, 1);
 END {GetProStrong};

 PUBLIC PROCEDURE GetProSoft(trgStorage: LIKE(Storage.Storage); D: DATE; trgProperty: LIKE(Property.Property)): STRING[];
 BEGIN
  RETURN intGetPro(trgStorage, D, trgProperty, 0);
 END {GetProSoft};

 PUBLIC PROCEDURE GetGasStanSetup(    trgStorage: LIKE(Storage.Storage);
                                      D         : DATE;
                                  VAR OwnPumps  : tOwnPumpArr;
                                  VAR OwnNozzles: tOwnNozzleArr;
                                  VAR OwnMaths  : tOwnMathArr;
                                  VAR OutNozzles: tOutNozzleArr;
                                  VAR OutMaths  : tOutMathArr);
 BEGIN
  Decode_GasStanSetup(GetProSoft(trgStorage, D, P_GasStanSetup),
                      OwnPumps, OwnNozzles, OwnMaths,
                                OutNozzles, OutMaths);
 END {GetGasStanSetup};

 PUBLIC PROCEDURE IsOnLine(trgStorage: LIKE(Storage.Storage); D: DATE): SCAL[2];
  VAR
   Result,
   ImdPrint    : SCAL[2];
   ShiftBegTime: TIME;
   ShiftSLength: NUMERIC[6, 3];
 BEGIN
  Decode_DocCircCharacteristic(GetProSoft(trgStorage, D, P_DocCircCharacteristic),
                               Result,
                               ImdPrint,
                               ShiftBegTime,
                               ShiftSLength);
  RETURN Result;
 END {IsOnLine};

 PUBLIC PROCEDURE ImdPrint(trgStorage: LIKE(Storage.Storage); D: DATE): SCAL[2];
  VAR
   OnLine,
   Result      : SCAL[2];
   ShiftBegTime: TIME;
   ShiftSLength: NUMERIC[6, 3];
 BEGIN
  Decode_DocCircCharacteristic(GetProSoft(trgStorage, D, P_DocCircCharacteristic),
                               OnLine,
                               Result,
                               ShiftBegTime,
                               ShiftSLength);
  RETURN Result;
 END {ImdPrint};

 PUBLIC PROCEDURE GetShiftParams(    trgStorage: LIKE(Storage.Storage);
                                     D         : DATE;
                                 VAR BegTime   : TIME;
                                 VAR SLength   : NUMERIC[3]);
  VAR
   OnLine,
   ImdPrint: SCAL[2];
   ValueStr: STRING[];
 BEGIN
  ValueStr:=GetProSoft(trgStorage, D, P_DocCircCharacteristic);
  IF ~!ValueStr THEN
   Decode_DocCircCharacteristic(ValueStr, OnLine, ImdPrint, BegTime, SLength);
  ELSE
   BegTime:=00:00;
   SLength:=24;
  END;
 END {GetShiftParams};

 PUBLIC PROCEDURE StoringType(trgStorage: LIKE(Storage.Storage); D: DATE): L_Stock.tStoringType;
  VAR
   Dummy         : SCAL[2];
   trgStoringType: L_Stock.tStoringType;
 BEGIN
  Decode_StoringFeatures(GetProSoft(trgStorage, D, P_StoringFeatures), trgStoringType, Dummy);
  IF !trgStoringType THEN
   trgStoringType:=L_Stock.storingType_Usual;
  END;
  RETURN trgStoringType;
 END {StoringType};

 PUBLIC PROCEDURE DontCheckXCalcRest(trgStorage: LIKE(Storage.Storage); D: DATE): SCAL[2];
  VAR
   Dummy                : L_Stock.tStoringType;
   trgDontCheckXCalcRest: SCAL[2];
 BEGIN
  Decode_StoringFeatures(GetProSoft(trgStorage, D, P_StoringFeatures), Dummy, trgDontCheckXCalcRest);
  IF !trgDontCheckXCalcRest THEN
   trgDontCheckXCalcRest:=0;
  END;
  RETURN trgDontCheckXCalcRest;
 END {DontCheckXCalcRest};

 PUBLIC PROCEDURE IsAnyFuelOrOilStoringType(trgStoringType: L_Stock.tStoringType): SCAL[2];
 BEGIN
  RETURN (trgStoringType = L_Stock.storingType_Fuel)    |
         (trgStoringType = L_Stock.storingType_OutFuel) |
         (trgStoringType = L_Stock.storingType_Oil)
 END {IsAnyFuelOrOilStoringType};

 PUBLIC PROCEDURE IsFuelStation(trgStorage: LIKE(Storage.Storage)): SCAL[2];
 BEGIN
  RETURN StoringType(trgStorage, SYSDATE()) = L_Stock.storingType_Fuel;
 END {IsFuelStation};

 PUBLIC PROCEDURE IsOutFuelStation(trgStorage: LIKE(Storage.Storage)): SCAL[2];
 BEGIN
  RETURN StoringType(trgStorage, SYSDATE()) = L_Stock.storingType_OutFuel;
 END {IsOutFuelStation};

 PUBLIC PROCEDURE IsOilStation(trgStorage: LIKE(Storage.Storage)): SCAL[2];
 BEGIN
  RETURN StoringType(trgStorage, SYSDATE()) = L_Stock.storingType_Oil;
 END {IsOilStation};

 PUBLIC PROCEDURE IsAnyFuelStation(trgStorage: LIKE(Storage.Storage)): SCAL[2];
 BEGIN
  RETURN IsFuelStation(trgStorage) | IsOutFuelStation(trgStorage);
 END {IsAnyFuelStation};

 PUBLIC PROCEDURE IsAnyFuelOrOilStation(trgStorage: LIKE(Storage.Storage)): SCAL[2];
 BEGIN
  RETURN IsAnyFuelOrOilStoringType(StoringType(trgStorage, SYSDATE()));
 END {IsAnyFuelAndOrStation};

 PUBLIC PROCEDURE IsRepair(trgStorage: LIKE(Storage.Storage);
                           trgDate   : DATE): SCAL[2];
 BEGIN
  RETURN StoringType(trgStorage, trgDate) = L_Stock.storingType_Repair;
 END {IsRepair};

 PUBLIC PROCEDURE CanHaveProp(trgProperty: LIKE(Property.Property));
 BEGIN
  IF    trgProperty = P_DocCircCharacteristic THEN
   CONFORM(StrgPro, Storage);
   L_General.Assert(Storage.Type = L_Stock.st_Stock,
                   "ᮡ 㬥⮮   |  ࠭  ⨯");
  ELSIF trgProperty = P_GasStanSetup THEN
   SAVE(Storage);
   IF ~IsFuelStation(StrgPro.Storage) THEN
    L_General.Error("⢮ " + trgProperty + " ।祭    ");
   END;
   RESTORE(Storage);
  END;
 END {CanHaveProp};

END.
