(*
%Copyright   (c) Polak IT
%Author      20.06.2008 17:43:58 POLAK\kns
%Purpose     ⥪  ࠡ  ᢮⢠ TKind
%Type        library
%Specific    SYS
%Modified    10.12.2010 13:32:44 POLAK\SSV
%Environment
*)

 MODULE P_TKind [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Prop, L_General, L_Str, L_DatTim;

 PUBLIC CONST
  P_VehicleInReserv           = 1501;

 PUBLIC PROCEDURE Check(_Property: LIKE(Property.Property));
 BEGIN
  IF    _Property = P_VehicleInReserv THEN
   L_Prop.CheckNumericValue(TKindPro.Value, "");
   L_General.Assert(STRTOFLD(TKindPro.Value, NUMERIC) >= 0,
                    "⢮   १ࢥ    ⥫.");
  END;
 END {Check};

 PUBLIC PROCEDURE HasPro(_TKind: LIKE(TKind.TKind); _Date: DATE; _Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN SELECT(TKindPro, TKind, _TKind, _Property) & SRCINSEL(TKindPro, LE, _Date);
 END {HasPro};

 PUBLIC PROCEDURE HasActualPro(_TKind: LIKE(TKind.TKind); _Date: DATE; _Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  RETURN HasPro(_TKind, _Date, _Property) & (!TKindPro.DocExpD | (_Date < TKindPro.DocExpD));
 END {HasActualPro};

 PUBLIC PROCEDURE GetProStrong(_TKind: LIKE(TKind.TKind); _Date: DATE; _Property: LIKE(Property.Property)): LIKE(TKindPro.Value);
 BEGIN
  IF ~HasActualPro(_TKind, _Date, _Property) THEN
   SEARCH(TKind, TKind, , _TKind);
   L_Prop.ShowUndefinedProValueError(TABLE.Get("TKind").Id, TKind.RECORDID, _Property, _Date);
  END;
  RETURN TKindPro.Value;
 END {GetProStrong};

 PUBLIC PROCEDURE GetProSoft(_TKind: LIKE(TKind.TKind); _Date: DATE; _Property: LIKE(Property.Property)): LIKE(TKindPro.Value);
  VAR
   _Value: LIKE(TKindPro.Value);
 BEGIN
  IF HasActualPro(_TKind, _Date, _Property) THEN
   _Value:=TKindPro.Value;
  ELSE
   SETEMPTY(_Value);
  END;
  RETURN _Value;
 END {GetProSoft};
END.