(*
%Copyright   (c) Polak Computer System
%Author      23.03.1999 10:38:47 SAN
%Purpose       ᯮ짮 ࠢ
%Type        report
%Specific    SYS
%Modified    14.03.2013 17:43:49 POLAK\LDA
%Environment
*)

 MODULE Rule [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_OwnData, L_Events, L_DatTim, L_Card, L_XDR, L_MathR;

 PRIVATE VAR
  RepName     : STRING[];
  NotFirstPage: SCAL[2];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
RuleStr(), C, ""
?, C, ""
@
####################################################################################### ########## #####
=#####==================================================================================================
|######################################################################################################|
|######################################################################################################|
|------------------------------------------------------------------------------------------------------|
|⮤                                ||      |     | /                             |    |
|-------------------------------------|--|-------|-------|------------------------------------|--------|
}
*)

(*
$P{ Line:
MoneyMth.Method, L, ""
MoneyMth.Name, L, ""
MoneyMth.MthType, L, ""
MMthLog.Date, L, "N.y"
MMthLog.Till, L, "N.y"
MCList.MCode, L, ""
MCList.Name, L, ""
MoneyRul.Number, R, "3."
@
|#### ################################|##|#######|#######|### ################################|########|
}
*)

(*
$P{ Bot:
@
=(c) Polak==============================================================================================
}
*)

(*
$P{ AcMthTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
@
####################################################################            ########## #####
=#####==========================================================================================
|##############################################################################################|
|----------------------------------------------------------------------------------------------|
|㯯 権                    | 樨                        |      |     |  |
|-----------------------------------|------------------------------------|-------|-------|-----|
}
*)

(*
$P{ AcMthLine:
AcMth.DGroup, L, ""
DGroup.Name, L, ""
AcMth.Dest, L, ""
Dest.Name, L, ""
AcMthH.Date, L, "N.y"
AcMthH.Till, L, "N.y"
AcMth.AcMth, L, ""
@
|## ################################|### ################################|#######|#######|#####|
}
*)

(*
$P{ AcMthBot:
@
=(c) Polak======================================================================================
}
*)

(*
$P{ MtyIdxTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
RuleStr(), C, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|############################################################################|
|----------------------------------------------------------------------------|
|  ⥫ 筮 ⥫      | 筮  | c| |
|---------------------------------------|-----------|-----------|------------|
}
*)

(*
$P{ MtyIdxLine:
MtyIdx.MtyIdx, L, ""
MtyIdx.Name, L, ""
MtyIdx.RoundMth, C, "楫|1 |2 |3 |죨"
MtyIdx.Begin, L, "N.y"
MtyIdx.Till, L, "N.y"
@
|  ## ################################  |  #######  |  #######  |  #######   |
}
*)

(*
$P{ MtyIdxBot:
@
=(c) Polak====================================================================
}
*)

(*
$P{ EDOKindTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
RuleStr(), C, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|############################################################################|
|----------------------------------------------------------------------------|
| ਪ                          |㯯  ਪ|      |     |
|--------------------------------------|---------------------|-------|-------|
}
*)

(*
$P{ EDOKindLine:
EDOKind.EDOKind, L, ""
EDOKind.Name, L, ""
EDOKind.EDOGrp, L, ""
EDOGrp.Name, L, ""
EDOKind.Begin, L, "N.y"
EDOKind.Till, L, "N.y"
@
|### ##################################|## ##################|#######|#######|
}
*)

(*
$P{ EDOKindBot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE FormFeedIfNeeded();
 BEGIN
  IF NotFirstPage THEN
   FORMFEED(R);
  ELSE
   NotFirstPage:=1;
  END;
 END {FormFeedIfNeeded};

 PRIVATE PROCEDURE WherePrefix(OperatingOnly: SCAL[2]): STRING[];
 BEGIN
  IF OperatingOnly THEN RETURN "ᯮ짮  " + L_DatTim.PeriodStr(Memo.ud_mb()) + " ";
  ELSE                  RETURN "ᯮ짮 ";
  END;
 END {WherePrefix};

 PRIVATE PROCEDURE RuleStr(): STRING[];
 BEGIN
  RETURN 'ࠢ "' + Rule.Rule + ' ' + Rule.Name + '"';
 END {RuleStr};

 PRIVATE PROCEDURE MakeForMethods(OperatingOnly: SCAL[2]);
 BEGIN
  IF SELECT(MoneyRul, Rule, Rule.Rule) THEN
   FormFeedIfNeeded();
   MAKEPART(R, Top, WherePrefix(OperatingOnly) + " ⮤");
   WHILE OCCURE(MoneyRul) DO
    PROMPT(MoneyRul.Method + " " + MoneyRul.MCode);
    CONFORM(MoneyRul, MMthLog);
    CONFORM(MMthLog, MoneyMth);
    IF ~OperatingOnly | L_DatTim.IsActive(Memo.ud_mb(), MMthLog.Date, MMthLog.Till) THEN
     CONFORM(MoneyRul, MCList);
     MAKEPART(R, Line);
    END;
    NEXT(MoneyRul);
   END; (* WHILE OCCURE(MoneyRul)... *)
   MAKEPART(R, Bot);
  END;
 END {MakeForMethods};

 PRIVATE PROCEDURE MakeAcMthLPart();
 BEGIN
  CONFORM(AcMthL, AcMthH);
  CONFORM(AcMthH, AcMth);
  CONFORM(AcMth, DGroup);
  CONFORM(AcMth, Dest);
  MAKEPART(R, AcMthLine);
  L_XDR.sl_AddItem(AcMth.AcMth, AcMth.DGroup   + " " + FLDTOSTR(DGroup.Name,   "", 32) +
                                "  " +
                                AcMth.Dest     + " " + FLDTOSTR(Dest.Name,     "", 32));
 END {MakeAcMthLPart};

 PRIVATE PROCEDURE MakeForOperations(OperatingOnly: SCAL[2]);
 BEGIN
  IF SELECT(AcMthL, Rule, Rule.Rule) THEN
   FormFeedIfNeeded();
   MAKEPART(R, AcMthTop, RuleStr() + ". " + WherePrefix(OperatingOnly) + " ");
   WHILE OCCURE(AcMthL) DO
    CONFORM(AcMthL, AcMthH);
    CONFORM(AcMthH, AcMth);
    PROMPT(AcMth.DGroup + " " + AcMth.Dest);
    IF ~OperatingOnly | L_DatTim.IsActive(Memo.ud_mb(), AcMthH.Date, AcMthH.Till) THEN
     MakeAcMthLPart();
    END;
    NEXT(AcMthL);
   END; (* WHILE OCCURE(AcMthL) ... *)
   MAKEPART(R, AcMthBot);
  END;
 END {MakeForOperations};

 PRIVATE PROCEDURE MakeForMonthlyStorage(OperatingOnly: SCAL[2]);
 BEGIN
  IF SELECT(MtyIdx, Rule, Rule.Rule) THEN
   FormFeedIfNeeded();
   MAKEPART(R, MtyIdxTop, WherePrefix(OperatingOnly) + " ⥫ 筮 ⥫");
   WHILE OCCURE(MtyIdx) DO
    PROMPT(MtyIdx.MtyIdx);
    IF ~OperatingOnly | L_DatTim.IsActive(Memo.ud_mb(), MtyIdx.Begin, MtyIdx.Till) THEN
     MAKEPART(R, MtyIdxLine);
    END;
    NEXT(MtyIdx);
   END; (* WHILE OCCURE(MtyIdx) ... *)
   MAKEPART(R, MtyIdxBot);
  END;
 END {MakeForMonthlyStorage};

 PRIVATE PROCEDURE MakeForEDOKind(OperatingOnly: SCAL[2]);
 BEGIN
  IF SELECT(EDOKind, Rule, Rule.Rule) THEN
   FormFeedIfNeeded();
   MAKEPART(R, EDOKindTop, WherePrefix(OperatingOnly) + "  ਪ  ᮭ");
   WHILE OCCURE(EDOKind) DO
    PROMPT(EDOKind.EDOKind);
    IF ~OperatingOnly | L_DatTim.IsActive(Memo.ud_cd(), EDOKind.Begin, EDOKind.Till) THEN
     CONFORM(EDOKind, EDOGrp);
     MAKEPART(R, EDOKindLine);
    END;
    NEXT(EDOKind);
   END; (* WHILE OCCURE(EDOKind) ... *)
   MAKEPART(R, EDOKindBot);
  END;
 END {MakeForEDOKind};

 PRIVATE PROCEDURE WhereRule(OperatingOnly: SCAL[2]);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Rule), " ⠭ ⥪饥 ࠢ");
  L_XDR.sl_Init("奬 権");
  NotFirstPage:=0;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MakeForMethods(OperatingOnly);
  MakeForOperations(OperatingOnly);
  MakeForMonthlyStorage(OperatingOnly);
  MakeForEDOKind(OperatingOnly);
  CLOSEREP(R);
  L_XDR.sl_Done();
 END {WhereRule};

 PUBLIC PROCEDURE WRULE();
 BEGIN
  RepName:="WRULE";
  WhereRule(1);
 END {WRULE};

 PUBLIC PROCEDURE WRUL1();
 BEGIN
  RepName:="WRUL1";
  WhereRule(0);
 END {WRUL1};

 PRIVATE PROCEDURE SetRuleCardTypePool();
 BEGIN
  RTI.Get().CurZone.Fields("Rule.CardType").Format:=L_Card.RussianPool;
 END {SetRuleCardTypePool};

 PRIVATE PROCEDURE Rule_1_OnZoneOpen();
 BEGIN
  SetRuleCardTypePool();
 END {Rule_1_OnZoneOpen};

 PRIVATE PROCEDURE RuleE_0_OnZoneOpen();
 BEGIN
  SetRuleCardTypePool();
 END {RuleE_0_OnZoneOpen};

 PUBLIC PROCEDURE EditRule();
 BEGIN
  L_General.SilentPrgsOnly();
  ACCESS(^(GE_CURFILE()));
  IF GE_CURFILE() # "Rule" THEN
   CONFORM(^(GE_CURFILE()), Rule);
  END;
  LIKEMENU(EditText, L_Card.GetTEDParamsForEditRule());
 END {EditRule};

BEGIN
 L_Events.ExecuteHandler();
END.
