(*
%Copyright   (c) Polak IT
%Author      07.07.2004 20:15:46 POLAK\San
%Purpose      楢 ⮢    ⮢
%Type        convertor
%Specific    SYS
%Modified    10.04.2012 12:26:00 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_APtm, Memo, L_DatTim, L_Events, L_XObj, L_PRoll;

 PUBLIC PROCEDURE RecalculateCurrentMan(PerB, PerE: DATE);
  VAR
   _CurDate,
   _Period : DATE;
 BEGIN
  L_General.Assert(ACCESS(Man), " । ⥪   ᯨ᪥ 䨧");

  _CurDate:=Memo.tmp_cd();
  SELECT(mfMan, Man, , Man.Man);
  WHILE OCCURE(mfMan) DO
   L_XObj.AccessXObject(mfMan.XObject);
   _Period:=PerE;
   WHILE _Period >= PerB DO
    L_APtm.ChangeMemoDate(_Period);
    L_XObj.ClearXApport(L_XObj.s_Payments, L_XObj.src_Salary);
    _Period:=L_DatTim.IncMonth(_Period, -1);
   END; (* WHILE _Period >= ... *)
   NEXT(mfMan);
  END; (* WHILE OCCURE(mfMan) ... *)

  _Period:=PerB;
  WHILE _Period <= PerE DO
   L_APtm.ChangeMemoDate(_Period);
   SELECT(mfMan, Man, , Man.Man);
   WHILE OCCURE(mfMan) DO
    SAVE(mfMan);
    SELECT(Staff, MyFirm, , mfMan.MyFirm, mfMan.Man);
    WHILE OCCURE(Staff) DO
     SELECT(Money, TSN, , Staff.TSN, _Period);
     WHILE OCCURE(Money) DO
      CONFORM(Money, MCList);
      L_PRoll.KeepMoneyInXCalc(Money.Sum);
      NEXT(Money);
     END; (* WHILE OCCURE(Money) ... *)
     NEXT(Staff);
    END; (* WHILE OCCURE(Staff) ... *)
    RESTORE(mfMan);
    NEXT(mfMan);
   END; (* WHILE OCCURE(mfMan) ... *)
   _Period:=L_DatTim.IncMonth(_Period, +1);
  END;
  L_APtm.ChangeMemoDate(_CurDate);
 END {RecalculateCurrentMan};

 PRIVATE PROCEDURE RecalculateCurrentStaff(PerB, PerE: DATE);
 BEGIN
  L_General.Assert(ACCESS(Staff), " । ⥪   ᯨ᪥ ࠡ⭨");
  CONFORM(Staff, Man);
  STDMSG("    ⮢  ਮ " +
         L_DatTim.PeriodStr(PerB)+" - "+L_DatTim.PeriodStr(PerE) +
         "| " + Man.Name, CHOICE);
  RecalculateCurrentMan(PerB, PerE);
 END {RecalculateCurrentStaff};

 PRIVATE PROCEDURE RecalculateAll(PerB, PerE: DATE);
 BEGIN
  STDMSG("    ⮢  ਮ " +
         L_DatTim.PeriodStr(PerB)+" - "+L_DatTim.PeriodStr(PerE) +
         "| ᥬ ࠡ⭨", CHOICE);
  FLOCK(Man,      Share);
  FLOCK(Staff,    Share);
  FLOCK(AcCut,    Share);
  FLOCK(Apport,   Share);
  FLOCK(XObject,  Share);
  FLOCK(Money,    Share);
  FLOCK(MCList,   Share);
  FLOCK(XCalc,    Monopol);
  FLOCK(XApport,  Monopol);
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   PROMPT("    ⮢ " + Man.Man);
   RecalculateCurrentMan(PerB, PerE);
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
 END {RecalculateAll};

BEGIN
 IF    MODE = L_Events.md_SingleMakeDone THEN
  RecalculateCurrentStaff(L_DatTim.Per(Memo.From()), L_DatTim.Per(Memo.UpTo()));
 ELSIF MODE = L_Events.md_StreamMakeDone THEN
  RecalculateAll(L_DatTim.Per(Memo.From()), L_DatTim.Per(Memo.UpTo()));
 ELSE
  L_General.BadMode(MODE);
 END;
END.