(*
%Copyright   (c) Polak IT
%Author      10.02.2012 15:06:39 POLAK\San
%Purpose     ᫥ १ࢮ  ᪠ (ࠡ⭨)
%Type        operation
%Specific    SYS
%Modified    07.07.2014 19:10:19 POLAK\GAV
%Environment
*)

 MODULE S0001 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_bp, L_SFee, P_Firm, Memo, L_DatTim, L_Man, L_AvePay, L_Staff, L_Acnt, L_XObj,
        L_APtm, L_AcCut, L_iga, L_StdFrm, L_OTx, L_Env, L_AFM, L_Str, L_PRoll, L_ACL, Math, E_PRoll,
        L_EC, L_Acnt;

 PRIVATE TYPE
  tPrcValue = NUMERIC[6];

 PRIVATE CONST
  Type_Pool = "||||";
  t_Monthly   = 0;
  t_Leaved    = 1;
  t_Inventory = 2;
  t_Salary    = 3;
  t_Saldo     = 4;


 PRIVATE VAR
  basAcCut,
  salAcCut   : LIKE(AcCut.AcCut);
  hldAveType : LIKE(AveType.AveType);
  crdApport,
  dbtApport  : LIKE(Apport.Apport);

(*
$P{ Top:
P_Firm.MyFirmName(MyFirm.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                          ⮪ ᫥ १ࢠ   ᪮  #######                        |
|------------------------------------------------------------------------------------------------------------|
|     |                         |   |        ᫥       |                                              |
|. |                      ||-------------------------|ਨ                                   |
|     |                         |   |       |      ।|                                              |
|-----|-------------------------|---|------------|------------|----------------------------------------------|
}
*)

(*
$P{ Line:
Staff.TSN, L, ""
Man.Name, L, ""
?, L, Type_Pool
?, R, "2-"
?, R, "2-"
?, L, ""
@
|#####|#########################|###|############|############|##############################################|
}
*)

(*
$P{ SubBot:
@
|------------------------------------------------------------------------------------------------------------|
|                               |   |        ᫥       |                 ⢮                   |
|                               ||-------------------------|----------------------------------------------|
|                               |   |       |      ।|            ⭨|                   |
|                          |---|------------|------------|----------------------|-----------------------|
}
*)

(*
$P{ Bot_Line:
_Total.Type, R, Type_Pool
?, R, ""
?, R, ""
_Total.StfAmount, R, "0"
?, R, ""
@
|                               |###|############|############|######################|#######################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

(*
$P{ Bot_Saldo:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE InsertTrialAvePay(trgAveType: LIKE(AveType.AveType); D: DATE);
  VAR
   RealBegD: DATE;
 BEGIN
  L_General.Assert(SEARCH(AveType, AveType, trgAveType) & L_DatTim.IsActive(L_DatTim.Per(D), AveType.Begin, AveType.Till),
                   " 㬥  ⢨/ -। " + trgAveType +
                   "|     " + L_DatTim.PeriodStr(D));
  SELECT(AvePay, PerAvTyp, , L_DatTim.Per(D), trgAveType, Staff.TSN);
  WHILE OCCURE(AvePay) & (AvePay.Status # L_AvePay.st_Estimated) DO
   NEXT(AvePay);
  END; (* WHILE OCCURE(AvePay) ... *)
  IF ~OCCURE(AvePay) THEN
   D:=L_DatTim.MonthEnd(D);
   RealBegD:=L_Man.GetTakeOnDate(D);
   WHILE SEARCH(AvePay, TSN, Staff.TSN, D, trgAveType) DO
    DEC(D);
   END;
   L_General.CallUs(D>=RealBegD);
   DEFAULT(AvePay);
   AvePay.AveType:=trgAveType;
   AvePay.Period :=L_DatTim.Per(D);
   AvePay.TSN    :=Staff.TSN;
   AvePay.Flags  :=0;
   AvePay.Status :=L_AvePay.st_Estimated;
   INSERT(AvePay);
   CALL(AvePay.FillAvePayP());
   SELECT(AvePayP, AvePay, , AvePay.AvePay);
   AvePayP.StartD:=D;
   AvePayP.Amount:=1;
   REPLACE(AvePayP);
   LOOP
    SAVE(AvePayP);
    IF NEXT(AvePayP) THEN
     REMOVE(AvePayP);
     RESTORE(AvePayP);
    ELSE
     RESTORE(AvePayP);
     EXIT;
    END;
   END; (* LOOP *)
   CALL(AvePay.AvePayP_Close(1));
  END;
 END {InsertTrialAvePay};

 PUBLIC PROCEDURE GetStaffAvePayAverage(trgAveType: LIKE(AveType.AveType); P: DATE): LIKE(AvePay.Average);
  VAR
   Result: LIKE(AvePay.Average);
 BEGIN
  TRY
   InsertTrialAvePay(trgAveType, P);
   CALL(AvePay.AvePay_OnStreamingProceed(1));
   Result:=AvePay.Average;
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc:Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  RETURN Result;
 END {GetStaffAvePayAverage};

 PRIVATE PROCEDURE S0001_Init(P: DATE);
 BEGIN
  basAcCut:=L_AcCut.erkn_Get(P, L_AcCut.erkn_VacationProvision);
  salAcCut:=L_AcCut.erkn_Get(P, L_AcCut.erkn_Salary); (* 쪮 ⮬,   鸞  㦭 *)
  SELECT(AveType, AveType);
  LOOP
   L_General.Assert(OCCURE(AveType), " ଫ     樨  ᯮ짮 ");
   IF (AveType.AveNo = L_AvePay.aveno_Hldy) &
      (AveType.LimType = L_AvePay.avelim_Hldy) &
      L_DatTim.IsActive(P, AveType.Begin, AveType.Till) THEN
    IF SELECT(AveTypeP, AveType, AveType.AveType) THEN
     WHILE OCCURE(AveTypeP) & !AveTypeP.JMode DO
      NEXT(AveTypeP);
     END; (* WHILE OCCURE(AveTypeP) ... *)
     IF ~OCCURE(AveTypeP) THEN
      hldAveType:=AveType.AveType;
      EXIT;
     END;
    END; (* IF SELECT(AveTypeP ... *)
   END; (* IF (AveType.AveNo ... *)
   NEXT(AveType);
  END; (* LOOP *)
 END {S0001_Init};

 PRIVATE PROCEDURE E_S0001_StartP(): DATE;
 BEGIN
  RETURN L_EC.ExecE_Func_Date(SYSDATE(), PROCREF(E_PRoll.S0001_StartP), Math.Max(01\01\2012, L_Env.aptm_Start));
 END {E_S0001_StartP};

 PRIVATE PROCEDURE S0001_PreliminaryCheck(P: DATE);
 BEGIN
  L_StdFrm.Question("᫥ १ࢠ   ᪮  " + L_DatTim.PeriodStr(P));
  L_General.Assert(P >= E_S0001_StartP(),
                   "᫥ १ࢠ ந  " + L_DatTim.PeriodStr(E_S0001_StartP()));
  L_General.Assert(L_APtm.MonthIsClosed(P, L_APtm.system_Salary),
                   "᫥ १ࢠ ᫥ 믮 ᫥  " +
                   " (⥬ '" + L_APtm.SystemName(L_APtm.system_Salary) + "')");
  IF L_iga.ActionHasProperPredecessor(L_iga.a_VacationProvision, L_iga.a_CloseMonth_Salary, P) THEN
   L_StdFrm.Choice("᫥ १ࢠ  " + L_DatTim.PeriodStr(P) + " 㦥 믮." +
                   "||" +
                   " ࠢ     ⥫⢠, ॡ騥 ?");
  END;
  IF L_APtm.MonthIsClosed(P, L_APtm.system_Payments) THEN
   L_StdFrm.Choice("᫥ १ࢠ  ᪮  " + L_DatTim.PeriodStr(P) + ":  " +
                   " (⥬ '" + L_APtm.SystemName(L_APtm.system_Payments) + "')");
  END;
 END {S0001_PreliminaryCheck};

 PRIVATE PROCEDURE S0001_Clear();
  VAR
   SourcesToClear: SCAL[2][100];
 BEGIN
  SETZERO(SourcesToClear);
  SourcesToClear[L_XObj.src_OnSalary]:=1;
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Staff,    L_XObj.s_Payments, SourcesToClear, 0);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_CostItem, L_XObj.s_Payments, SourcesToClear, 0);
  L_XObj.xMultipleClearXApportOfObjectsType(L_XObj.o_Global,   L_XObj.s_Payments, SourcesToClear, 0);
 END {S0001_Clear};

 PRIVATE PROCEDURE S0001_PutSingleValue(curTSN: LIKE(Staff.TSN); P: DATE; curSum: NUMERIC[2];
                                        VAR curPrc: tPrcValue);
  VAR
   curSFeePrc : tPrcValue;
   curTrvmPrc : P_MyFirm.tTravmObligTariff;
   trgAcCut   : LIKE(AcCut.AcCut);
   trgCostItem: LIKE(CostItem.CostItem);
 BEGIN
  L_General.CallUs(Staff.TSN = curTSN);
  L_Staff.PosToStaffLog(Staff.TSN, L_DatTim.MonthEnd(P), 1);
  L_PRoll.GetOfficerDstAttr(L_PRoll.dm_MainSalary, P, 1, trgAcCut, trgCostItem);
  L_XObj.AccessXObjectByOrigin(L_XObj.o_Staff);
  L_XObj.mo_MakeCir(+1, basAcCut, P, crdApport, trgAcCut,
                    curSum, L_XObj.src_OnSalary);
  curSFeePrc:=L_SFee.TaxAllPart(P, 100) / 100;
  curTrvmPrc:=L_OTx.TravmObligTariff_InvalidCoef(MyFirm.MyFirm, P, Staff.Man) / 100;
  curPrc:=curSFeePrc + curTrvmPrc;
  SEARCH(XObject, XObject, , L_XObj.GetRecastXObject(MyFirm.MyFirm));
  L_XObj.mo_MakeCir(+1, basAcCut, P, crdApport, trgAcCut,
                    curSum*curPrc, L_XObj.src_OnSalary);
  IF ~!trgCostItem THEN
   SEARCH(CostItem, CostItem, , trgCostItem);
   L_XObj.AccessXObjectByOrigin(L_XObj.o_CostItem);
   L_XObj.mo_MakeCir(+1, trgAcCut, P, dbtApport, basAcCut,
                     curSum*(1+curPrc), L_XObj.src_OnSalary);

  ELSE
   L_General.CallUs(~L_PRoll.UseSalDSet());
  END;
 END {S0001_PutSingleValue};

 PRIVATE PROCEDURE MakePart(trgType     : SCAL[4];
                            trgDayAmount: NUMERIC[2];
                            trgDebit    : NUMERIC[2];
                            trgCredit   : NUMERIC[2];
                            trgComment  : STRING[]);
 BEGIN
  MAKEPART(R, Line, trgType, trgDebit, trgCredit, trgComment);

  ADD(_Total, _Total, , MyFirm.MyFirm, trgType,
      _Total.StfAmount, 1,
      _Total.DayAmount, trgDayAmount,
      _Total.Debit,     trgDebit,
      _Total.Credit,    trgCredit);
 END {MakePart};

 PRIVATE PROCEDURE S0001_PutMonthly(curTSN: LIKE(Staff.TSN); P: DATE);
  VAR
   curPrc      : tPrcValue;
   curAverage  : LIKE(AvePay.Average);
   curDays2Pay : NUMERIC[2];
   curSum      : NUMERIC[2];
   MonthLen,
   StageInMonth: NUMERIC[0];
   simStr      : STRING[];
 BEGIN
  L_General.CallUs(Staff.TSN = curTSN);
  curAverage:=GetStaffAvePayAverage(hldAveType, P);
  L_General.CallUs(Staff.TSN = curTSN);
  L_Staff.PosToStaffLog(Staff.TSN, L_DatTim.MonthEnd(P), 1);
  CONFORM(StaffLog, Officer, AlType);
  HISTCONF(L_DatTim.MonthEnd(P), AlType, AlTypeL);
  curDays2Pay :=AlTypeL.Duration[L_Staff.ati_Main] +
                AlTypeL.Duration[L_Staff.ati_HarmPwr] +
                AlTypeL.Duration[L_Staff.ati_Continuity] +
                AlTypeL.Duration[L_Staff.ati_UnNorm] +
                AlTypeL.Duration[L_Staff.ati_Other] +
                AlTypeL.Duration[5] +
                AlTypeL.Duration[6];
                (* + AlType.Duration[L_Staff.ati_OverNorm]: GAV:   ᢥ孮   . *)
  MonthLen    :=L_DatTim.MonthEnd(P) - P + 1;
  StageInMonth:=L_AvePay.GetStage4VacationInMonth(curTSN, P);
  IF StageInMonth # MonthLen THEN
   curDays2Pay:=curDays2Pay * StageInMonth / MonthLen / 12;
   simStr     :=" " + L_Str.IntStr(StageInMonth);
  ELSE
   curDays2Pay:=curDays2Pay / 12;
   simStr     :="";
  END;
  curSum:=curDays2Pay * curAverage;
  S0001_PutSingleValue(curTSN, P, curSum, curPrc);

  MakePart(t_Monthly,
           curDays2Pay,
           0,
           curSum,
           FLDTOSTR( curDays2Pay, "2.",  6) +
           FLDTOSTR(  curAverage, "2-", 10) +
           FLDTOSTR(curPrc * 100, "2.", 12) +
           simStr);
 END {S0001_PutMonthly};

 PRIVATE PROCEDURE S0001_BalanceLeaved(curTSN: LIKE(Staff.TSN); P: DATE);
  VAR
   sldSum: NUMERIC[2];
   curPrc: tPrcValue;
 BEGIN
  IF ~L_APtm.MonthIsClosed(P, L_APtm.system_Payments) THEN
   L_General.CallUs(Staff.TSN = curTSN);
   IF (Staff.EndDate <= L_DatTim.MonthEnd(P)) & (Staff.EndDate > L_DatTim.IncYear(P, -1)) THEN
    L_XObj.AccessXObjectByOrigin(L_XObj.o_Staff);
    sldSum:=L_XObj.mo_GetOutSaldo(basAcCut, P);
    IF sldSum # 0 THEN
     S0001_PutSingleValue(curTSN, P, sldSum, curPrc);
     MakePart(t_Leaved,
              0,
              0,
              sldSum,
              FLDTOSTR(curPrc * 100, "2.", 12));
    END;
   END;
  END;
 END {S0001_BalanceLeaved};

 PRIVATE PROCEDURE S0001_AnnualInventory(curTSN: LIKE(Staff.TSN); P: DATE);
  VAR
   curAve,
   curSld,
   curSum,
   curAverage : NUMERIC[2];
   curDays2Pay: NUMERIC[2];
   curPrc     : tPrcValue;
 BEGIN
  IF L_DatTim.MONTH(P) = 11 THEN
   L_General.CallUs(Staff.TSN = curTSN);
   IF L_Staff.IsBegan(P) & (Staff.EndDate > L_DatTim.MonthEnd(P)) THEN
    curDays2Pay:=L_AvePay.GetVacationDaysAcntSaldo(Staff.TSN, L_DatTim.IncMonth(P, 1));
    curAverage :=GetStaffAvePayAverage(hldAveType, P);
    curAve:=curDays2Pay * curAverage;
    L_XObj.AccessXObjectByOrigin(L_XObj.o_Staff);
    curSld:=(-1) * L_XObj.mo_GetOutRSaldo(basAcCut, P);
    curSum:=curAve - curSld;
    IF curSum # 0 THEN
     S0001_PutSingleValue(curTSN, P, curSum, curPrc);
     MakePart(t_Inventory,
              curDays2Pay,
              0,
              curSum,
              FLDTOSTR( curDays2Pay, "2.",  6) +
              FLDTOSTR(  curAverage, "2-", 10) +
              FLDTOSTR(  curAve,     "2-", 10) +
              FLDTOSTR(  curSld,     "2-", 10));
    END;
   END;
  END;
 END {S0001_AnnualInventory};

 PRIVATE PROCEDURE S0001_PutBySalary(curTSN: LIKE(Staff.TSN); P: DATE);
 BEGIN
  L_General.CallUs(Staff.TSN = curTSN);
  L_XObj.AccessXObjectByOrigin(L_XObj.o_Staff);
  SELECT(XApport, XObject, , XObject.XObject, salAcCut, P);
  WHILE OCCURE(XApport) DO
   IF (XApport.WFDate = P) & (XApport.AcCut2 = basAcCut) THEN
    SAVE(XApport);
    L_XObj.mo_MakeCir(+1, basAcCut, P, dbtApport, salAcCut, XApport.Sum, L_XObj.src_OnSalary);
    RESTORE(XApport);
    MakePart(t_Salary,
             0,
             XApport.Sum,
             0,
             "");
   END;
   NEXT(XApport);
  END; (* WHILE OCCURE(XApport) ... *)
 END {S0001_PutBySalary};

 PRIVATE PROCEDURE ConvZeroToEmpty(Val: NUMERIC[2]; Format: STRING[]): STRING[];
 BEGIN
  IF Val = 0 THEN
   RETURN "";
  ELSE
   RETURN FLDTOSTR(Val, Format);
  END;
 END {ConvZeroToEmpty};

 PUBLIC PROCEDURE S0001();
  CONST
   bpId = "S0001";
  VAR
   begP,
   endP       : DATE;
   curTSN     : LIKE(Staff.TSN);
 BEGIN
  L_bp.Begin(bpId, "᫥ १ࢠ  ᪮  ", L_bp.t_Prc_wRp, L_General.tc_inMonth);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AFM.MakeMultipleIndex("_Total", "MyFirm   : LIKE(MyFirm.MyFirm);" +
                                    "Type     : SCAL[4];" +
                                    "StfAmount: NUMERIC[0];" +
                                    "DayAmount: NUMERIC[2];" +
                                    "Debit    : NUMERIC[2];" +
                                    "Credit   : NUMERIC[2]",
                          "_Total:MyFirm,Type");
  begP:=Memo.ud_mb();
  endP:=Memo.ud_me();
  S0001_PreliminaryCheck(begP);
  crdApport:=L_Acnt.E_Apport_MoneyCredit(begP);
  dbtApport:=L_Acnt.E_Apport_MoneyDebit(begP);
  S0001_Clear();
  OPENREP(R, L_General.rfn_byMonth(bpId, begP), Create);
  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF (MyFirm.MyFirm # P_Firm.mf_Fict) & L_DatTim.IsActiveInIntvl_Inc(MyFirm.Begin, L_DatTim.till2ED(MyFirm.Till), begP, endP) THEN
    MAKEPART(R, Top, bpId, begP);
    S0001_Init(begP);
    SELECT(Staff, TSN);
    WHILE OCCURE(Staff) DO
     PROMPT("⭨: " + Staff.TSN);
     IF (Staff.MyFirm = MyFirm.MyFirm) & L_Staff.IsLabourContract(Staff.Contract) &
        L_Env.RealTSN(Staff.TSN) THEN
      CONFORM(Staff, Man);
      SAVE(Staff);
      curTSN:=Staff.TSN;
      IF L_Staff.InStateInPer(begP, endP) THEN
       S0001_PutMonthly(curTSN, begP);
      END;
      S0001_PutBySalary(curTSN, begP);
      S0001_BalanceLeaved(curTSN, begP);
      S0001_AnnualInventory(curTSN, begP);
      RESTORE(Staff);
     END;  (* IF (Staff.MyFirm... *)

     (* 0092104 .7.2 *)
     IF (Staff.MyFirm = MyFirm.MyFirm) & (Staff.Contract = L_Staff.cnt_ContractorsAgreement) &
        L_Env.RealTSN(Staff.TSN) & (begP < 01\09\2012) THEN
      CONFORM(Staff, Man);
      SAVE(Staff);
      curTSN:=Staff.TSN;
      S0001_BalanceLeaved(curTSN, begP);
      RESTORE(Staff);
     END;

     NEXT(Staff);
    END; (* WHILE OCCURE(Staff) ... *)
    IF SELECT(_Total, _Total, MyFirm.MyFirm) THEN
     MAKEPART(R, SubBot);
     WHILE OCCURE(_Total) DO
      MAKEPART(R, Bot_Line, ConvZeroToEmpty(_Total.Debit, "2-"),
                            ConvZeroToEmpty(_Total.Credit, "2-"),
                            ConvZeroToEmpty(_Total.DayAmount, "2."));
      NEXT(_Total);
     END; (* WHILE OCCURE(_Total) ... *)
    END;
    MAKEPART(R, Bot);
   END; (* IF MyFirm ... *)
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) *)
  CLOSEREP(R);
  L_iga.Put(L_iga.a_VacationProvision, begP, "");
  L_bp.End();
 END {S0001};

 PUBLIC PROCEDURE S0001_PutSaldo();
  CONST
   RepName = "S0001";
  VAR
   StartP,
   P          : DATE;
   totSrc,
   totClc,
   curClc     : NUMERIC[2];
   stfAmount  : NUMERIC[0];
   curAverage : LIKE(AvePay.Average);
   curDays2Pay: NUMERIC[2];
   Proportion : FLOAT;
   oPrompt    : PROMPTLINE;
   wCrdSld    : SCAL[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  StartP:=E_S0001_StartP();
  P:=L_DatTim.IncMonth(StartP, -1);
  L_General.Assert(Memo.ud_mb() = P, "楤   믮  " + L_DatTim.PeriodStr(P));
  SEARCH(MyFirm, MyFirm, , P_Firm.mf_Own);
  S0001_Init(P);
  totSrc :=0;
  wCrdSld:=1;
  STDFORM("|줮   "+L_Acnt.GetCAcntSign(StartP, basAcCut)+"  ⭮襭 ᪮|| "+L_DatTim.DateStr(StartP)+" (  !)||%RI" +
          "|" +
          "|%<뢠 २ᯮ짮 >E" +
          "|" +
          "|%< {}믮 >DB  %< {}⬥>X",
          " ନ ᠫ줮 ", INFORM, 1, totSrc, wCrdSld);
  IF totSrc = 0 THEN
   oPrompt:=PROMPTLINE.Create(" ᠫ줮  १ࢠ");
  ELSE
   oPrompt:=PROMPTLINE.Create("। ᠫ줮  १ࢠ");
  END;

  S0001_Clear();
  L_AFM.MakeMultipleIndex("tmpVl", "TSN     : LIKE(Staff.TSN);" +
                                   "Value   : NUMERIC[2];" +
                                   "Days2Pay: NUMERIC[2];" +
                                   "Average: LIKE(AvePay.Average)",
                           "TSN: TSN");
  crdApport:=901;
  totClc   :=0;
  stfAmount:=0;
  SELECT(Staff, MyFirm, , MyFirm.MyFirm);
  WHILE OCCURE(Staff) DO
   PROMPT("⮢: " + Staff.TSN);
   IF L_Staff.IsBegan(P) & L_Staff.rInState(StartP) THEN
    curDays2Pay:=L_AvePay.GetVacationDaysAcntSaldo(Staff.TSN, StartP);
    IF L_Staff.IsLabourContract(Staff.Contract) THEN
     curAverage :=GetStaffAvePayAverage(hldAveType, P);
     tmpVl.TSN  :=Staff.TSN;
     tmpVl.Value:=curDays2Pay * curAverage;
     tmpVl.Days2Pay:=curDays2Pay;
     tmpVl.Average :=curAverage;
 
     IF (tmpVl.Value > 0) | (wCrdSld & (tmpVl.Value < 0)) THEN
      INC(stfAmount);
      INC(totClc, tmpVl.Value);
      INSERT(tmpVl);
     END;
    ELSIF curDays2Pay > 0 THEN
     L_StdFrm.Warning("⭨ " + Staff.TSN + ", ⨯  '"+L_Str.PoolItem(L_Staff.cnt_Pool_Full, Staff.Contract)+"': ⠥ ?");
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  OPENREP(R, L_General.rfn_byMonth(RepName, P), Create);
  MAKEPART(R, Top, RepName, P);
  IF totSrc = 0 THEN
   Proportion:=1;
   totSrc:=totClc;
  ELSE
   Proportion:=totSrc / totClc;
  END;
  SELECT(tmpVl, TSN);
  WHILE OCCURE(tmpVl) DO
   SEARCH(Staff, TSN, , tmpVl.TSN);
   PROMPT("ନ஢ ஢: " + Staff.TSN);
   IF stfAmount = 1 THEN
    curClc:=totSrc;
   ELSE
    curClc:=tmpVl.Value * Proportion;
   END;
   DEC(totSrc, curClc);
   DEC(stfAmount);
   L_XObj.AccessXObjectByOrigin(L_XObj.o_Staff);
   L_XObj.mo_MakeCir(+1, basAcCut, P, crdApport, L_AcCut.Fictive(), curClc, L_XObj.src_OnSalary);
   CONFORM(Staff, Man);
   MAKEPART(R, Line, t_Saldo, , curClc,
                     FLDTOSTR(tmpVl.Days2Pay, "2.",  6) +
                     FLDTOSTR(tmpVl.Average,  "2-", 10));
   NEXT(tmpVl);
  END; (* WHILE OCCURE(tmpVl) ... *)
  MAKEPART(R, Bot_Saldo, "   ᠫ줮  "+L_DatTim.DateStr(StartP)+" (⭮ ᠫ줮) ⠢ "+FLDTOSTR(totClc, "2-", 0));
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {S0001_PutSaldo};

END.
