(*
%Copyright   (c) Polak Computer System
%Author      19.08.2002 09:56:42 POLAK\GAV
%Purpose       ERH
%Type        operation
%Specific    SYS
%Modified    09.08.2013 10:31:11 POLAK\LDA
%Environment
*)

 MODULE SendErh [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_EMail, L_APEMl, L_Str, L_StdFrm, P_Man, FIO, Str, L_HTTP, L_FIO;

 PRIVATE CONST
  stByEMail = 0;
  stByFTP   = 1;

 PRIVATE PROCEDURE GetZIPContent(ZipContentFileName: STRING[]; VAR Amount, Sizes: NUMERIC[0]): STRING[];
  VAR
   S,
   FileMask,
   FileList,
   srcFileName: STRING[];
 BEGIN
  SETEMPTY(FileList);
  SETZERO(Amount);
  FIO.Open(F, ZipContentFileName, "", Input);
  WHILE FIO.RdStr(F, S) DO
   FIO.SplitPath(S, srcFileName, , FileMask);
   FileList:=FileList + srcFileName + "|";
   INC(Sizes, L_FIO.GetFileSize(S));
   INC(Amount);
  END; (* WHILE FIO.RdStr(F, S)... *)
  FIO.Close(F);
  RETURN FileList;
 END {GetZIPContent};

 PRIVATE PROCEDURE GetShortAPSiteNumber(): SCAL[1E2];
  VAR
   Result: SCAL[1E4];
 BEGIN
  Result:=L_General.GetAPSiteNumber();
  L_General.CallUs(Result <= MAXOF(SCAL[1E2]));
  RETURN Result;
 END {GetShortAPSiteNumber};

 PRIVATE PROCEDURE SendAnyFiles(SendType: SCAL[2]);
  CONST
   ftpRoot  = "ftp://ftp.polak.nichost.ru";
   ftpLogin = "polak_AP_TT";
   ftpPass  = "2gZG6A8Fbw3d5HX6HKQzUw==";
  VAR
   Msg,
   SendTo,
   ftpPath,
   FileMask,
   st_Field,
   st_Var,
   Prefix,
   FileList,
   ContactName,
   ZipFileName,
   srcFileName,
   srcFullFileName,
   ZipContentFileName,
   fName, fExt, fPath: STRING[];
   React,
   Amount,
   DummyChoice,
   FilesSize  : NUMERIC[3];
   ToContact  : L_EMail.tContact;
   ChooseFD   : CHOOSEFILEDIALOG;
 BEGIN
  IF ~APP.Get().SupportMode THEN
   L_General.SilentAdminOnly();
  END;
  ZipFileName       :=FIO.FullPath(FIO.MakePath("ReqFiles", "zip", FIO.AsbSpecialFolders("ASBTemp")));
  ZipContentFileName:=FIO.FullPath(FIO.MakePath("ZipCont",  "txt", FIO.AsbSpecialFolders("ASBTemp")));
  IF FIO.Exists(ZipContentFileName) & (L_FIO.GetFileSize(ZipContentFileName) > 0 ) &
     (STDFORM(L_StdFrm.PartForm("%< ⬥ >X" +
                                "%<   >B" +
                                "%< த ࠡ  騬 >DB" +
                                "@" +
                                "|  ⮢ ᯨ᮪ 䠩." +
                                "|" +
                                "|%##########%  %###############%  %##################################%"),
                                " ⮢ 䠩  ࠢ ",
                                ,
                                1) = 1) THEN
   FIO.Erase(ZipFileName);
   FIO.Erase(ZipContentFileName);
  END;

  IF FIO.Exists(ZipContentFileName) THEN
   FIO.Open(F, ZipContentFileName, "", Append);
  ELSE
   FIO.Open(F, ZipContentFileName, "", Create);
  END;

  FileMask   :="*.*";
  SETZERO(FilesSize, Amount);
  LOOP
   ChooseFD                     :=CHOOSEFILEDIALOG.Create(FileMask);
   ChooseFD.FilesAreAcceptable  :=1;
   ChooseFD.FoldersAreAcceptable:=0;
   srcFullFileName:=ChooseFD.Deal();
   IF !srcFullFileName THEN
    EXIT;
   END;
   FIO.WrStr(F, srcFullFileName);
   FIO.WrLn(F);
   INC(Amount);
   FileMask:=FIO.BuildPath("*.*", , L_FIO.effp_Folder(srcFullFileName));
  END; (* LOOP *)
  FIO.Close(F);
  FileList :=GetZIPContent(ZipContentFileName, Amount, FilesSize);
  FilesSize:=FilesSize / 1024; (**)
  L_General.Assert(Amount > 0, " ⮢ ᯨ᪠ 䠩  ࠢ");


  IF    SendType = stByEMail THEN
   IF APP.Get().SupportMode THEN
    SendTo     :=L_Str.AnyItem(LOGINNAME(), ".", 0);
    IF L_Str.IsEqStrI(SendTo, "SAN") THEN
     SendTo:="SLA";
    END;
    ContactName:=FULLNAME();
    Prefix     :="";
   ELSE
    SendTo     :="support";
    ContactName:=L_APEMl.aps_Name;
    Prefix     :="N";
   END;
   st_Field:=Str.Align("|%L< ࠢ: email>T %7"+Prefix+"I@" + L_APEMl.OurSiteDomain, 67, LEFT);
   st_Var  :=", SendTo";
  ELSIF SendType = stByFTP THEN
   IF APP.Get().SupportMode THEN
    SendTo     :=L_Str.AnyItem(LOGINNAME(), ".", 0);
    IF L_Str.IsEqStrI(SendTo, "SAN") THEN
     SendTo:="SLA";
    END;
    st_Field   :=Str.Align("|%< ࠢ: "+ftpRoot+"/upload/" + GetShortAPSiteNumber() + "/>T%5<>I", 68, LEFT);
    st_Var     :=", SendTo";
   ELSE
    SETEMPTY(SendTo);
    st_Field   :=Str.Align("| ࠢ: "+ftpRoot+"/upload/support/", 66, LEFT);
    st_Var     :="";
   END;
  END;

  SETZERO(DummyChoice);
  React:=STDFORM("|祭 ࠭ 䠩 (" + L_Str.IntStr(Amount) + " .)" +
                 "|%L63,10<" + FileList + "|>I||||||||||" +
                 Str.Align("|騩 ࠧ     : " + Str.Condense(FLDTOSTR(FilesSize)) + "Kb", 66, LEFT) +
                 st_Field +
                 "||" +
                 "%< ⬥ >X  %<   ࠢ >DB  %< ࠢ >B",
                 " ࠢ 䠩 ",
                 ,
                 1,
                 ^("DummyChoice" + st_Var));
  IF React = 2 THEN
   SETEMPTY(ZipFileName);
  END;
  FIO.Open(F, ZipContentFileName, "", Input);
  WHILE FIO.RdStr(F, FileList) DO
   IF    React = 1 THEN
    PROMPT("娢 " + srcFullFileName);
    L_General.Assert(L_General.Launch_PKZIP("-add", FileList, ZipFileName) = L_General.eprc_Normal,
                     "訡  娢樨");
   ELSIF React = 2 THEN
    FIO.SplitPath(FileList, fName, fExt, fPath);
    IF Str.Length(fName) > 8 THEN
     FileList:=FOLDER_ENTRY.Create(FileList).ShortPath;
    ELSE
     FileList:=FIO.FullPath(FIO.MakePath(fName, fExt, FOLDER_ENTRY.Create(fPath).ShortPath));
    END;
    ZipFileName:=ZipFileName + FileList + "|";
   END;
  END; (* WHILE FIO.RdStr(F, FileList)... *)
  FIO.Close(F);

  IF    SendType = stByEMail THEN
   L_General.Assert(~!SendTo, " 㪠 ⥫");
   ToContact:=L_EMail.AssembleContactFromParts(ContactName, SendTo, L_APEMl.OurSiteDomain);
   L_APEMl.EasySend(ToContact, L_APEMl.ToSupportOwnFirmContact(), GetShortAPSiteNumber() + " ॡ 䠩 ",
                    ZipFileName, "ࠢ⥫: " + P_Man.GetFullNameOfCurrentUser(SYSDATE()));
   Msg:=" ࠢ  ஭ ";
  ELSIF SendType = stByFTP THEN
   ftpPath:="upload\" + GetShortAPSiteNumber() + "\";
   IF ~!SendTo THEN
    ftpPath:=ftpPath + SendTo + "\";
   END;
   L_HTTP.ftpPutFile(ftpRoot, ftpLogin, ftpPass, ZipFileName, ftpPath);
   Msg:=" ࠢ  FTP ࢥ";
  END;
  FIO.Erase(ZipFileName);
  FIO.Erase(ZipContentFileName);
  L_StdFrm.Inform(Msg);
 END {SendAnyFiles};

 PUBLIC PROCEDURE Send_ByEMail();
 BEGIN
  SendAnyFiles(stByEMail);
 END {Send_ByEMail};

 PUBLIC PROCEDURE Send_ByFTP();
 BEGIN
  SendAnyFiles(stByFTP);
 END {Send_ByFTP};

END.
