(*
%Copyright   (c) Polak Computer System
%Author      SAN
%Purpose     ⠭ ⥪饩 
%Type        operation
%Specific    sys
%Modified    05.02.2014 18:12:35 POLAK\LDA
*)

 MODULE SetDfDat [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_DatTim, Memo, L_WDO, Math, L_Str, L_Env, Str, L_SES, L_Hld, L_StdFrm;

 PRIVATE PROCEDURE fillSetCDFields(Window: FORM_WINDOW;
                                   Date  : DATE);
  VAR
   Fields  : FORM_FIELDS;
   curDay  : SCAL[32];
   curMonth: SCAL[12];
   curYear : NUMERIC[0];
 BEGIN
  Fields:=Window.Zones(0).Fields;
  Fields("Date").Value :=Date;
  UnPkDATE(Date, curDay, curMonth, curYear);
  Fields("Day").Value  :=curDay;
  Fields("Month").Value:=curMonth;
  Fields("Year").Value :=curYear;
  Fields("WkDay").Value:=L_DatTim.WEEKDAY(Date);
 END {fillSetCDFields};

 PRIVATE PROCEDURE formSet_SetCD_Int(Window: FORM_WINDOW);
 BEGIN
  fillSetCDFields(Window, Memo.ud_cd());
 END {formSet_SetCD_Int};

 PRIVATE PROCEDURE SetCD_OnOpenWindow();
  VAR
   ILikeNormalDateFormat: SCAL[2];
 BEGIN
  IF ~L_SES.GetValue(L_SES.sit_User, "ILikeNormalDateFormat", ILikeNormalDateFormat) THEN
   ILikeNormalDateFormat:=1;
  END;
  L_WDO.cField("Day").First :=~ILikeNormalDateFormat;
  L_WDO.cField("Date").First:=ILikeNormalDateFormat;
  formSet_SetCD_Int(RTI.Get().CurWindow);
 END {SetCD_OnOpenWindow};

 PRIVATE PROCEDURE SetCD_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().OnOpenWindow:=1;
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit]);
  L_WDO.iScsChange   (0, ["Date", "Year", "Month", "Day"]);
  L_WDO.iUnmodifiable(0, ["WkDay", "L_APtm.ClcPer[4]", "L_APtm.ClcPer[3]", "L_APtm.ClcPer[2]", "L_APtm.ClcPer[1]", "L_APtm.ClcPer[0]"]);
  L_WDO.iField       (0, "Month").Format:=L_DatTim._Month_1;
  L_WDO.iField       (0, "WkDay").Format:=L_DatTim.WDStr_0;
  L_WDO.iProgs       (0, "SetDfDat");
 END {SetCD_OnInitializeWindow};

 PRIVATE PROCEDURE SetCD_Date_OnSuccessfulChange();
  VAR
   ILikeNormalDateFormat: SCAL[2];
 BEGIN
  ILikeNormalDateFormat:=1;
  fillSetCDFields(RTI.Get().CurWindow, RTI.Get().CurZone.ActiveField.Value);
  L_SES.PutValueAtSlaveTrn(L_SES.sit_User, "ILikeNormalDateFormat", ILikeNormalDateFormat);
 END {SetCD_Date_OnSuccessfulChange};

 PRIVATE PROCEDURE SetCD_AnyDatePart_OnSuccessfulChange();
  VAR
   curDate              : DATE;
   ILikeNormalDateFormat: SCAL[2];
 BEGIN
  ILikeNormalDateFormat:=0;
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   curDate:=PackDATE(L_WDO.cField("Day").Value, L_WDO.cField("Month").Value, L_WDO.cField("Year").Value);
  EXCEPT
  ON Exc: Exc_Root DO
   IF Exc.ErrorCode = L_General.ec_rt_InvalidDate THEN
    L_General.Error("⨬ ");
   ELSE
    RAISE();
   END;
  END; (* TRY *)
  L_WDO.cField("Date").Value :=curDate;
  L_WDO.cField("WkDay").Value:=L_DatTim.WEEKDAY(curDate);
  L_SES.PutValueAtSlaveTrn(L_SES.sit_User, "ILikeNormalDateFormat", ILikeNormalDateFormat);
 END {SetCD_AnyDatePart_OnSuccessfulChange};

 PRIVATE PROCEDURE SetCD_Day_OnSuccessfulChange();
 BEGIN
  SetCD_AnyDatePart_OnSuccessfulChange();
 END {SetCD_Day_OnSuccessfulChange};

 PRIVATE PROCEDURE SetCD_Month_OnSuccessfulChange();
 BEGIN
  SetCD_AnyDatePart_OnSuccessfulChange();
 END {SetCD_Month_OnSuccessfulChange};

 PRIVATE PROCEDURE SetCD_Year_OnSuccessfulChange();
 BEGIN
  SetCD_AnyDatePart_OnSuccessfulChange();
 END {SetCD_Year_OnSuccessfulChange};

 PRIVATE PROCEDURE SetCD_OnAfterEdit();
 BEGIN
  Memo.ud_SetCurDate(L_WDO.cField("Date").Value);
 END {SetCD_OnAfterEdit};

 PRIVATE PROCEDURE SetCD(curDate: DATE);
  VAR
   Form: FORM_WINDOW;
 BEGIN
  L_General.Assert(SEARCH(Calendar, Date, curDate),
                   "    ࠢ筨 '' "+L_DatTim.DateStr(curDate));
  Memo.ud_SetCurDate(curDate);
  FOR_EACH Form IN APP.Get().Forms DO
   IF Form.OriginalName = "SetCD" THEN
    formSet_SetCD_Int(Form);
   END;
  END; (* FOR_EACH *)
 END {SetCD};

 PUBLIC PROCEDURE SetCD_SysDate();
 BEGIN
  SetCD(SYSDATE());
 END {SetCD_SysDate};

 PUBLIC PROCEDURE SysDate();
 BEGIN
  SetCD(SYSDATE());
 END {SysDate};

 PUBLIC PROCEDURE NextMonth_Ext(D: DATE);
 BEGIN
  SetCD(L_DatTim.IncCalendarMonth(D, 1));
 END {NextMonth_Ext};

 PUBLIC PROCEDURE SetCD_NextMonth();
 BEGIN
  NextMonth_Ext(L_WDO.cField("Date").Value);
 END {SetCD_NextMonth};

 PUBLIC PROCEDURE NextMonth();
 BEGIN
  NextMonth_Ext(Memo.ud_cd());
 END {NextMonth};

 PUBLIC PROCEDURE PrvMonth_Ext(D: DATE);
 BEGIN
  SetCD(L_DatTim.IncCalendarMonth(D, -1));
 END {PrvMonth_Ext};

 PUBLIC PROCEDURE SetCD_PrvMonth();
 BEGIN
  PrvMonth_Ext(L_WDO.cField("Date").Value);
 END {SetCD_PrvMonth};

 PUBLIC PROCEDURE PrvMonth();
 BEGIN
  PrvMonth_Ext(Memo.ud_cd());
 END {PrvMonth};

 PUBLIC PROCEDURE MoveToAnyDay_Ext(D: DATE);
 BEGIN
  SetCD(D);
 END {MoveToAnyDay_Ext};

 PUBLIC PROCEDURE SetCD_MoveForwardToOneDay();
 BEGIN
  MoveToAnyDay_Ext(L_WDO.cField("Date").Value+1);
 END {SetCD_MoveForwardToOneDay};

 PUBLIC PROCEDURE MoveForwardToOneDay();
 BEGIN
  MoveToAnyDay_Ext(Memo.ud_cd()+1);
 END {MoveForwardToOneDay};

 PUBLIC PROCEDURE SetCD_MoveBackwardToOneDay();
 BEGIN
  MoveToAnyDay_Ext(L_WDO.cField("Date").Value-1);
 END {SetCD_MoveBackwardToOneDay};

 PUBLIC PROCEDURE MoveBackwardToOneDay();
 BEGIN
  MoveToAnyDay_Ext(Memo.ud_cd()-1);
 END {MoveBackwardToOneDay};

 PUBLIC PROCEDURE ChooseMonthDay_Ext(D: DATE);
  VAR
   List    : STRING[];
   nWD, rWD: L_DatTim.tWeekday;
   rWDAsStr: STRING[];
   trgDate,
   newDate,
   MonthBeg,
   MonthEnd: DATE;
 BEGIN
  SETEMPTY(List);
  MonthBeg:=L_DatTim.MonthBeg(D);
  MonthEnd:=L_DatTim.MonthEnd(D);
  trgDate :=MonthBeg;
  WHILE trgDate <= MonthEnd DO
   nWD:=L_DatTim.WEEKDAY(trgDate);
   rWD:=L_Hld.WeekDay_TransfersConsidered(trgDate);
   IF rWD # nWD THEN
    rWDAsStr:="/ " + L_DatTim.WeekDayStr(rWD, 0);
   ELSE
    rWDAsStr:="";
   END;
   List:=List + Str.Align(L_Str.FixedIntStr(L_DatTim.DAY(trgDate), 2), 2, RIGHT) +
                " " +
                Str.Align(L_DatTim.WeekDayStr(nWD, 0), 11, LEFT) +
                " " +
                Str.Align(rWDAsStr, 11+2, LEFT) + "|";
   INC(trgDate);
  END;
  newDate:=MonthBeg +
           L_StdFrm.ShowListAsMenu_wInit(List,
                                         " 롮 ⥪饣  " + L_DatTim.PeriodStr(D),
                                         L_DatTim.DAY(D)-1);
  SetCD(newDate);
 END {ChooseMonthDay_Ext};

 PUBLIC PROCEDURE SetCD_ChooseMonthDay();
 BEGIN
  ChooseMonthDay_Ext(L_WDO.cField("Date").Value);
 END {SetCD_ChooseMonthDay};

 PRIVATE PROCEDURE intSetInt(trgFrom, trgUpTo: DATE; wCancelAndSave: SCAL[2]);
 BEGIN
  L_WDO.cField("From").Value:=trgFrom;
  L_WDO.cField("UpTo").Value:=trgUpTo;
  IF wCancelAndSave THEN
   FIXALTERING();
   LIKEMENU(Cancel, "Save");
  END;
 END {intSetInt};

 PRIVATE PROCEDURE SetInt(trgFrom, trgUpTo: DATE);
 BEGIN
  intSetInt(trgFrom, trgUpTo, 1);
 END {SetInt};

 PRIVATE PROCEDURE Int_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().OnOpenWindow:=1;
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterEdit]);
  L_WDO.iField       (0, "UpTo").Last:=1;
  L_WDO.iProgs       (0, "SetDfDat");
 END {Int_OnInitializeWindow};

 PRIVATE PROCEDURE Int_OnOpenWindow();
 BEGIN
  intSetInt(Memo.ud_fr(), Memo.ud_ut(), 0);
 END {Int_OnOpenWindow};

 PRIVATE PROCEDURE Int_OnAfterEdit();
  VAR
   trgFrom,
   trgUpTo: DATE;
 BEGIN
  trgFrom:=L_WDO.cField("From").Value;
  trgUpTo:=L_WDO.cField("UpTo").Value;
  L_General.Assert(trgFrom <= trgUpTo, " 砫 ਮ   砭 ਮ");
  IF trgFrom < L_Env.aptm_Start THEN
   L_StdFrm.Choice("⠭ ਮ  砫 ᯫ樨 ⮏");
  END;
  Memo.SetIntvl(trgFrom, trgUpTo);
 END {Int_OnAfterEdit};

 PRIVATE PROCEDURE SafeIncMonth(Date: DATE; i: NUMERIC[0]): DATE;
 BEGIN
  IF Date = L_DatTim.MonthEnd(Date) THEN
   RETURN L_DatTim.MonthEnd(L_DatTim.IncMonth(L_DatTim.MonthBeg(Date), i));
  ELSE
   RETURN L_DatTim.IncCalendarMonth(Date, i);
  END;
 END {SafeIncMonth};

 PRIVATE PROCEDURE QuartalBeg(d: DATE): DATE;
  VAR D, M, Y: NUMERIC[0];
 BEGIN
  UnPkDATE(d, D, M, Y); RETURN PackDATE(1, M DIV 3 * 3, Y);
 END {QuartalBeg};

 PUBLIC PROCEDURE SetInt_SingleCurDate();
 BEGIN
  SetInt(Memo.ud_cd(), Memo.ud_cd());
 END {SetInt_SingleCurDate};

 PUBLIC PROCEDURE SetInt_FromCurMonthBegToCurDate();
 BEGIN
  SetInt(L_DatTim.MonthBeg(Memo.ud_cd()), Memo.ud_cd());
 END {SetInt_FromCurMonthBegToCurDate};

 PUBLIC PROCEDURE SetInt_WholeCurMonth();
 BEGIN
  SetInt(L_DatTim.MonthBeg(Memo.ud_cd()), L_DatTim.MonthEnd(Memo.ud_cd()));
 END {SetInt_WholeCurMonth};

 PUBLIC PROCEDURE SetInt_FromCurYearBegToCurMonthEnd();
 BEGIN
  SetInt(L_DatTim.YearBeg(Memo.ud_cd()), L_DatTim.MonthEnd(Memo.ud_cd()));
 END {SetInt_FromCurYearBegToCurMonthEnd};

 PUBLIC PROCEDURE SetInt_WholePrvMonth();
 BEGIN
  SetInt(L_DatTim.IncMonth(L_DatTim.MonthBeg(SYSDATE()), -1), L_DatTim.MonthBeg(SYSDATE()) - 1);
 END {SetInt_WholePrvMonth};

 PUBLIC PROCEDURE SetInt_FromCurMonthBegToYesterday();
 BEGIN
  SetInt(L_DatTim.MonthBeg(SYSDATE()), SYSDATE() - 1);
 END {SetInt_FromCurMonthBegToYesterday};

 PUBLIC PROCEDURE SetInt_FromCurYearBegToPrvMonthEnd();
 BEGIN
  SetInt(L_DatTim.YearBeg(L_DatTim.MonthBeg(SYSDATE()) - 1), L_DatTim.MonthBeg(SYSDATE()) - 1);
 END {SetInt_FromCurYearBegToPrvMonthEnd};

 PUBLIC PROCEDURE SetInt_SingleSysDate();
 BEGIN
  SetInt(SYSDATE(), SYSDATE());
 END {SetInt_SingleSysDate};

 PUBLIC PROCEDURE SetInt_WholePrvQuartal();
 BEGIN
  SetInt(L_DatTim.IncMonth(QuartalBeg(SYSDATE()), -3), QuartalBeg(SYSDATE()) - 1);
 END {SetInt_WholePrvQuartal};

 PUBLIC PROCEDURE SetInt_MoveForwardToOneDay();
 BEGIN
  SetInt(Memo.ud_fr() + 1, Memo.ud_ut() + 1);
 END {SetInt_MoveForwardToOneDay};

 PUBLIC PROCEDURE SetInt_MoveForwardToOneMonth();
 BEGIN
  SetInt(SafeIncMonth(Memo.ud_fr(), +1), SafeIncMonth(Memo.ud_ut(), +1));
 END {SetInt_MoveForwardToOneMonth};

 PUBLIC PROCEDURE SetInt_MoveForwardToOneYear();
 BEGIN
  SetInt(SafeIncMonth(Memo.ud_fr(), +12), SafeIncMonth(Memo.ud_ut(), +12));
 END {SetInt_MoveForwardToOneYear};

 PUBLIC PROCEDURE SetInt_MoveBackwardToOneDay();
 BEGIN
  SetInt(Memo.ud_fr() - 1, Memo.ud_ut() - 1);
 END {SetInt_MoveBackwardToOneDay};

 PUBLIC PROCEDURE SetInt_MoveBackwardToOneMonth();
 BEGIN
  SetInt(SafeIncMonth(Memo.ud_fr(), -1), SafeIncMonth(Memo.ud_ut(), -1));
 END {SetInt_MoveBackwardToOneMonth};

 PUBLIC PROCEDURE SetInt_MoveBackwardToOneYear();
 BEGIN
  SetInt(SafeIncMonth(Memo.ud_fr(), -12), SafeIncMonth(Memo.ud_ut(), -12));
 END {SetInt_MoveBackwardToOneYear};

BEGIN
 L_Events.ExecuteHandler();
END.
