(*
%Copyright   (c) Polak Computer System
%Author      SAN
%Purpose      ஫ 䨪樨 ⠡
%Type        control
%Specific    SYS
%Modified    14.08.2014 12:55:58 POLAK\Gina
%Environment
*)

 MODULE Sheet [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_PRoll, L_Events, L_Sheet, L_General, L_Staff, L_DatTim, L_AR, L_AcsPnt, L_StdFrm;

 PRIVATE PROCEDURE Sheet_OnBeforeModification();
 BEGIN
  L_General.Assert((Sheet.Source=L_Sheet.src_Regime  )|
                   (Sheet.Source=L_Sheet.src_Operator)|
                   (Sheet.Source=L_Sheet.src_EDOrder ),
                   " ⬥⮪, ᤥ ⮬᪨, 饭");

  IF ~L_PRoll.Salary_Clc_CntIsEqual() THEN
   L_AcsPnt.PassAccessPoint(0000052); (* 䨪 ⠡ ࠡ⭨  ⮬  *)
  ELSE
   L_AR.GrantRightsForInteractiveModification();
  END;
 END {Sheet_OnBeforeModification};

 PRIVATE PROCEDURE ChkHld();
 BEGIN
  CONFORM(Sheet, JMode);
  IF JMode.Type = L_Sheet.jmType_HolTime THEN
   L_General.Assert((Sheet.Tim=0) & (Sheet.SpTime=0) & (!Sheet.DayTime | (Sheet.DayTime=0)), "室   㫥 ६");
  END;
 END {ChkHld};

 PRIVATE PROCEDURE Sheet_OnBeforeEdit();
 BEGIN
  Sheet_OnBeforeModification();
  L_PRoll.Salary_CheckClcPer();
  Sheet.Source:=L_Sheet.src_Operator; REPLACE(Sheet);
  CONFORM(Sheet, Staff);
  L_PRoll.ShtDone(0);
 END {Sheet_OnBeforeEdit};

 PRIVATE PROCEDURE RegimeWithShift(): SCAL[2];
 BEGIN
  CONFORM(Sheet, Staff);
  L_Staff.PosToStaffLog(Sheet.TSN, Sheet.Period+Sheet.Day-1, 1);
  L_General.Assert(SELECT(RegList, HumReg, StaffLog.Regime, Sheet.Period), "  ० ࠡ "+StaffLog.Regime+"  "+L_DatTim.PeriodStr(Sheet.Period));
  WHILE OCCURE(RegList) DO
   IF ~!RegList.DayTime & (RegList.DayTime#RegList.GrTime) & (RegList.DayTime#0) THEN
    RETURN 1;
   END;
   NEXT(RegList);
  END; (* WHILE OCCURE(RegList) ... *)
  RETURN 0;
 END {RegimeWithShift};

 PRIVATE PROCEDURE ApplyJModeForOperator(): SCAL[2];
 BEGIN
  RETURN (Sheet.JMode # L_Sheet.jm_Line(Sheet.Period)) &
         (Sheet.JMode # L_Sheet.jm_LineHld(Sheet.Period));
 END {ApplyJModeForOperator};

 PRIVATE PROCEDURE Sheet_OnAfterEdit();
 BEGIN
  ChkHld();
  L_General.Assert(Sheet.JMode#L_Sheet.jm_RatherEarly(Sheet.Period), " ࠢ  ࠡ  ⠡");
  L_General.Assert(L_DatTim.InPatIntvl(JMode.Begin, JMode.Till,
                                       Sheet.Period, L_DatTim.MonthEnd(Sheet.Period)),
                                       " ࠡ  ⠡ " + JMode.JMode + "    " + L_DatTim.PeriodStr(Sheet.Period));
  L_General.Assert(ApplyJModeForOperator(),
                   " ࠡ "+Sheet.JMode+"  ⮫쪮  ᮮ⢥ 㬥⮢."+
                   "|᪨ ⬥⪨ 饭");
  IF ~!Sheet.DayTime THEN
   L_General.Assert(Sheet.DayTime<=Sheet.Tim, "६  ⪨     ६  ᬥ");
   IF ~RegimeWithShift() THEN
    L_StdFrm.Choice("६  ⪨     .| ࠡ "+StaffLog.Regime+"    ⪠");
   END;
  ELSE
   L_General.Assert(~RegimeWithShift() | (Sheet.Tim=0), "६  ⪨   .| ࠡ "+StaffLog.Regime+"   ⪠");
  END;
 END {Sheet_OnAfterEdit};

 PUBLIC PROCEDURE Sheet_OnBeforeInsert();
 BEGIN
  L_General.Error("'筮'   ᥩ  ⠡ 饭");
 END {Sheet_OnBeforeInsert};

 PRIVATE PROCEDURE Sheet_OnBeforeDelete();
 BEGIN
  Sheet_OnBeforeModification();
  L_PRoll.Salary_CheckClcPer();
  CONFORM(Sheet, Staff);
  L_PRoll.ShtDone(0);
 END {Sheet_OnBeforeDelete};

 PRIVATE PROCEDURE JMode_SetModifiable();
 BEGIN
  RTI.Get().CurZone.Fields("JMode.PaySpTim").Modifiable:=JMode.Type = L_Sheet.jmType_TimDone;
  RTI.Get().CurZone.Fields("JMode.PayHldy").Modifiable :=JMode.Type = L_Sheet.jmType_TimDone;
 END {JMode_SetModifiable};

 PRIVATE PROCEDURE JMode_Type_OnSuccessfulChange();
 BEGIN
  IF JMode.Type # L_Sheet.jmType_TimDone THEN
   JMode.PaySpTim:=0;
   JMode.PayHldy :=0;
   REPLACE(JMode);
  END;
  JMode_SetModifiable();
 END {JMode_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE JModeE_0_OnReposition();
 BEGIN
  JMode_SetModifiable();
 END {JModeE_0_OnReposition};

 PRIVATE PROCEDURE JMode_OnAfterEdIns();
 BEGIN
  L_DBD.CheckValidity("JMode");
 END {JMode_OnAfterEdIns};

 PRIVATE PROCEDURE JMode_OnAfterEdit();
 BEGIN
  JMode_OnAfterEdIns();
 END {JMode_OnAfterEdit};

 PRIVATE PROCEDURE JMode_OnAfterInsert();
 BEGIN
  JMode_OnAfterEdIns();
 END {JMode_OnAfterEdit};

BEGIN
 L_Events.ExecuteHandler();
END.
