(*
%Copyright   (c) Polak Computer System
%Author      SAN
%Purpose       ⠡
%Type        control
%Specific    SYS
%Modified    14.08.2014 16:49:48 POLAK\Gina
%Environment
*)

 MODULE SheetP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Math, L_General, L_Card, L_EDO, L_Hld, L_Sheet, L_Money,
        L_PRoll, L_Staff, L_DatTim, L_APtm, L_Env, L_Way, Memo,
        L_StdFrm, L_TRS, P_MCList, L_Str, L_OwnData;

 TYPE
  tHMPay = FLOAT;

 CONST
  JModeMax      = MAXOF(Sheet.JMode);

 VAR
  Tims            : L_PRoll.tTime[JModeMax+1]; { ᮢ -    ⥫쭮 }
  Days            : NUMERIC[0][JModeMax+1];    {   -    ⥫쭮 }
  SpT             : L_PRoll.tTime[4];
  PaidAbsent,
  NonPAbsent,
  TotalAbsent,
  HolTime_MGT,         (*ᣮ࠭: ࠧ "ᢥ ",   䨪 室*)
  HolTime         : L_PRoll.tTime;
  MPay,
  HPay            : tHMPay;
  BonSum          : LIKE(Money.Sum)[P_MCList.BonBaseAmount];
  BonTim          : LIKE(Money.Tim)[P_MCList.BonBaseAmount];
  HolDays,
  CorWDays,
  Days_TotalAbsent,
  Days_PaidAbsent,
  Days_NonPAbsent : NUMERIC[0];
  _HBal           : LIKE(PCalc.HBal);
  _CorBal         : LIKE(PCalc.CorBal);
  _TimDone        : LIKE(PCalc.TimDone);
  BonusMCode      : SCAL[2][MAXOF(MCList.MCode)+1];
  InSign_Base     : LIKE(Money.Sum)[HIGH(MCList.InSign)];
  InSign_Time     : LIKE(Money.Tim)[HIGH(MCList.InSign)];

  curRuleHasMoney : SCAL[2];
  ktmLPartIsEmpty : SCAL[2];
  IsNewStaffLog   : SCAL[2];
  MonthB,
  MonthE          : DATE;

(*
$P{ ktm_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, C, ""
@
############################################################################################# ########## #####
==============================================================================================================
|############################################################################################################|
}
*)

(*
$P{ ktm_Bot:
@
=(c) Polak====================================================================================================
}
*)

(*
$P{ ktm_SubTop:
? , L, ""
@
|############################################################################################################|
}
*)

(*
$P{ ktm_Delimitter:
@
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ ktm_RuleBot:
MCList.MCode, L, ""
MCList.Name, L, ""
?, R, ""
?, R, ""
@
|### ################################                                           ####### #####################|
}
*)

(*
$P{ ktm_Line:
?, L, ""
@
|               #############################################################################################|
}
*)

 PUBLIC PROCEDURE ktm_DoIt(): SCAL[2];
 BEGIN
  RETURN (L_PRoll.curCountUp = L_PRoll.cu_snglFull_wKTM);
 END {ktm_DoIt};

 PUBLIC PROCEDURE ktm_MakePartTop();
 BEGIN
  MAKEPART(ktm_R, ktm_Top, "⮪   ⠡, " + L_DatTim.PeriodStr(Memo.gl_mb()) + ", " + Staff.TSN + " " + Man.Name);
 END {ktm_MakePartTop};

 PUBLIC PROCEDURE ktm_MakePartBot();
 BEGIN
  MAKEPART(ktm_R, ktm_Bot);
 END {ktm_MakePartBot};

 PRIVATE PROCEDURE ktm_PutPair(Text, Value: STRING[]);
 BEGIN
  IF ktm_DoIt() THEN
   IF ~VAR_IMPL.Get(IsNewStaffLog).Initialized THEN
    IsNewStaffLog:=1;
    CONFORM(StaffLog, Officer);
    CONFORM(Officer, Post);
    MAKEPART(ktm_R, ktm_SubTop, Post.Name + " (" + L_DatTim.DateStr(StaffLog.Date) +
                                ", " + StaffLog.Sort + ", " + StaffLog.Officer +
                                ", " + StaffLog.Regime + ")");
    ktm_PutDelimitter();
   END;
   IF VAR_IMPL.Get(ktmLPartIsEmpty).Initialized & ktmLPartIsEmpty THEN
    ktmLPartIsEmpty:=0;
    ktm_PutDelimitter();
   END;
   IF !Value THEN
    MAKEPART(ktm_R, ktm_Line, Text);
   ELSE
    MAKEPART(ktm_R, ktm_Line, Text + ": " + Value);
   END;
  END;
 END {ktm_PutPair};

 PRIVATE PROCEDURE ktm_Put(Text: STRING[]; VAR (* ⮫쪮  ࠭ ⨯ *) Value: FLOAT);
  VAR
   Prec  : NUMERIC[0];
   Format: STRING[];
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Prec:=PRECISIONOF(Value);
  EXCEPT
  ON Exc: Exc_Syntax DO
   IF Exc.ErrorCode = 10 THEN
    Prec:=3;
   ELSE
    RAISE();
   END;
  END; (* TRY *)
  IF Prec = 0 THEN
   Format:="0";
  ELSE
   Format:=L_Str.IntStr(Prec) + ".";
  END;
  ktm_PutPair(Text, FLDTOSTR(Value, Format , 0));
 END {ktm_Put};

 PRIVATE PROCEDURE ktm_PutMoney(Text: STRING[]; Value: NUMERIC[2]);
 BEGIN
  ktm_PutPair(Text, FLDTOSTR(Value,  "2-", 0));
 END {ktm_Put};

 PRIVATE PROCEDURE ktm_PutBoolean(Text: STRING[]; Value: SCAL[2]);
 BEGIN
  ktm_PutPair(Text, L_Str.PoolItem("|", Value));
 END {ktm_PutBoolean};

 PRIVATE PROCEDURE ktm_PutDelimitter();
 BEGIN
  IF ktm_DoIt() THEN
   MAKEPART(ktm_R, ktm_Delimitter);
  END;
 END {ktm_PutDelimitter};

 PRIVATE PROCEDURE CheckBegin(Begin: DATE);
 BEGIN
  L_General.Assert(MonthB >= Begin, "ࠢ "+RTI.Get().Stack.Item(1).Proc.Name+"   "+L_DatTim.PeriodStr(Begin));
 END {CheckBegin};

 PRIVATE PROCEDURE CheckTill(Till: DATE);
 BEGIN
  L_General.Assert(MonthB < Till, "ࠢ "+RTI.Get().Stack.Item(1).Proc.Name+"   "+L_DatTim.PeriodStr(Till));
 END {CheckTill};

 PRIVATE PROCEDURE E_NoPayBecauseIsLeave(VAR _EndDate: LIKE(Staff.EndDate); LeavePeriod: DATE): SCAL[2];
  VAR
   NoPay: SCAL[2];
 BEGIN
  SETEMPTY(_EndDate);
  NoPay:=0;
  SAVE(StaffLog);
  SAVE(SLKind);
  CHANGESEL(StaffLog, TSN, , StaffLog.TSN);
  WHILE OCCURE(StaffLog) & (StaffLog.Date <= L_DatTim.MonthEnd(LeavePeriod)) DO
   IF L_Staff.IsDischargeStaffLog() THEN
    CONFORM(StaffLog, SLKind);
    _EndDate:=StaffLog.Date - 1;
    NoPay   :=SLKind.IsGodRsn = 0;
    LAST(StaffLog);
   END;
   NEXT(StaffLog);
  END; (* WHILE OCCURE(StaffLog) ... *)
  RESTORE(SLKind);
  RESTORE(StaffLog);
  IF ~!PROCREF(NoPayBecauseIsLeave) THEN
   NoPay:=NoPayBecauseIsLeave(NoPay);
  END;
  RETURN NoPay;
 END {E_NoPayBecauseIsLeave};

 PRIVATE PROCEDURE ExplicitMoneyMan(P      : DATE;
                                    _Sum   : L_PRoll.tSum;
                                    _Tim   : L_PRoll.tTime;
                                    _Source: LIKE(Money.Source));
 BEGIN
  L_PRoll.SaveMoney(+1, MoneyRul.MCode, P, _Source, _Sum, _Tim);
  IF ktm_DoIt() THEN
   curRuleHasMoney:=1;
   IF ktmLPartIsEmpty THEN
    ktm_PutDelimitter();
   END;
   IF _Source = L_PRoll.src_SheetDec THEN
    MAKEPART(ktm_R, ktm_RuleBot, "!", L_Money.MoneyToStr(MonthB, "", Math.Abs(_Sum)) +"(" + L_Str.NumericStr(_Tim, 3) + ")");
   ELSE
    MAKEPART(ktm_R, ktm_RuleBot, "",       L_Money.MoneyToStr(MonthB, "",          _Sum ) +"(" + L_Str.NumericStr(_Tim, 3) + ")");
   END;
  END;
 END {ExplicitMoneyMan};

 PRIVATE PROCEDURE CanPayByMCode(trgMCode: LIKE(MCList.MCode); LeavePeriod: DATE): SCAL[2];
  VAR
   dmyEndDate: LIKE(Staff.EndDate);
 BEGIN
  RETURN  P_MCList.GetPayOnDischarge(trgMCode, LeavePeriod) |
         ~E_NoPayBecauseIsLeave(dmyEndDate, LeavePeriod);
 END {CanPayByMCode};

 PRIVATE PROCEDURE MoneyMan(s: L_PRoll.tSum; t: L_PRoll.tTime);
 BEGIN
  IF CanPayByMCode(MoneyRul.MCode, MonthB) THEN
   ExplicitMoneyMan(MonthB, s, t, L_PRoll.src_Sheet);
  END;
 END {MoneyMan};

 PRIVATE PROCEDURE MoneyManWithStorno(IncSum: L_PRoll.tSum; DecSum: L_PRoll.tSum; t: L_PRoll.tTime);
 BEGIN
  IF CanPayByMCode(MoneyRul.MCode, MonthB) THEN
   ExplicitMoneyMan(MonthB, IncSum, t, L_PRoll.src_Sheet);
   IF DecSum # 0 THEN
    IF IncSum = DecSum THEN
     ExplicitMoneyMan(MonthB, -DecSum, -t, L_PRoll.src_SheetDec);
    ELSE
     ExplicitMoneyMan(MonthB, -DecSum,  0, L_PRoll.src_SheetDec);
    END;
   END;
  END;
 END {MoneyManWithStorno};

 PRIVATE PROCEDURE HourPay(t: L_PRoll.tTime);
 BEGIN
  MoneyMan(HPay * t * MoneyRul.Number, t);
 END {HourPay};

 PRIVATE PROCEDURE HourPayBySpecHPay(t: L_PRoll.tTime; n: NUMERIC[3]; SpecHPay: tHMPay);
 BEGIN
  MoneyMan(SpecHPay * t * n, t);
 END {HourPayBySpecHPay};

 PRIVATE PROCEDURE _PayOver(tim: L_PRoll.tTime; day: NUMERIC[0]);
  VAR over, superover: FLOAT;
 BEGIN
  over:=tim - _CorBal;
  IF over > 0 THEN
   superover:=over - day * 2.0;
   IF superover > 0 THEN
    MoneyMan(HPay * (over+superover) * MoneyRul.Number, over);
   ELSE
    MoneyMan(HPay *  over            * MoneyRul.Number, over);
   END;
  END;
 END {_PayOver};

 PRIVATE PROCEDURE PayOver(tim: L_PRoll.tTime; day: NUMERIC[0]);
 BEGIN
  IF Staff.Contract = L_Staff.cnt_Basic THEN
   _PayOver(tim, day);
  END;
 END {PayOver};

 PRIVATE PROCEDURE PayOverBySpecHPay(tim: L_PRoll.tTime; day: NUMERIC[0]; SpecHPay: tHMPay);
  VAR
   _HPay: tHMPay;
 BEGIN
  _HPay:=HPay;
  HPay:=SpecHPay;
  PayOver(tim, day);
  HPay:=_HPay;
 END {PayOverBySpecHPay};

 PRIVATE PROCEDURE _PayOverBySpecHPay(tim: L_PRoll.tTime; day: NUMERIC[0]; SpecHPay: tHMPay);
  VAR
   _HPay: tHMPay;
 BEGIN
  _HPay:=HPay;
  HPay:=SpecHPay;
  _PayOver(tim, day);
  HPay:=_HPay;
 END {_PayOverBySpecHPay};

 PRIVATE PROCEDURE Bonus(p: FLOAT; t: L_PRoll.tTime);
 BEGIN
  MoneyMan(HPay * t * MoneyRul.Number * p / 100, t);
 END {Bonus};

 PRIVATE PROCEDURE PropPay(s: L_PRoll.tSum; t: L_PRoll.tTime);
 BEGIN
  MoneyMan(s * t * MoneyRul.Number / RegHead.FullBal, t);
 END {PropPay};

 PRIVATE PROCEDURE MonthPay(s: L_PRoll.tSum);
 BEGIN
  PropPay(s, _HBal - TotalAbsent);
 END {MonthPay};

 PRIVATE PROCEDURE AccessMCList(_MCode: LIKE(Money.MCode));
 BEGIN
  SAVE(MCList);
  L_General.Assert(SEARCH(MCList, MCode, _MCode) &
                   L_DatTim.InPatIntvl(MCList.Begin, MCList.Till, MonthB, MonthE),
                   "     "+L_DatTim.PeriodStr(MonthB)+"   "+_MCode);
  RESTORE(MCList);
 END {AccessMCList};

 PRIVATE PROCEDURE GetMoneyTimSrc(_MCode: LIKE(Money.MCode); _Source: LIKE(Money.Source)): LIKE(Money.Tim);
  VAR
   _Tim: LIKE(Money.Tim);
 BEGIN
  AccessMCList(_MCode);
  SAVE(Money);
  _Tim:=0;
  SELECT(Money, PayFor, , Staff.TSN, MonthB);
  WHILE OCCURE(Money) DO
   IF (Money.MCode = _MCode) & (Money.ODate = StaffLog.Date) &
      (!_Source | (Money.Source=_Source)) THEN
    INC(_Tim, Money.Tim);
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
  RESTORE(Money);
  RETURN _Tim;
 END {GetMoneyTimSrc};

 PUBLIC PROCEDURE GetMoneyTim(_MCode: LIKE(Money.MCode)): LIKE(Money.Tim);
 BEGIN
  RETURN GetMoneyTimSrc(_MCode, EMPTYOF(Money.Source));
 END {GetMoneyTim};

 PRIVATE PROCEDURE GetMoneySumSrc(_MCode: LIKE(Money.MCode); _Source: LIKE(Money.Source)): LIKE(Money.Sum);
  VAR
   _Sum: LIKE(Money.Sum);
 BEGIN
  AccessMCList(_MCode);
  SAVE(Money);
  _Sum:=0;
  SELECT(Money, PayFor, , Staff.TSN, MonthB);
  WHILE OCCURE(Money) DO
   IF (Money.MCode = _MCode) & (Money.ODate = StaffLog.Date) THEN
    INC(_Sum, Money.Sum);
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
  RESTORE(Money);
  RETURN _Sum;
 END {GetMoneySumSrc};

 PRIVATE PROCEDURE GetMoneySum(_MCode: LIKE(Money.MCode)): LIKE(Money.Sum);
 BEGIN
  RETURN GetMoneySumSrc(_MCode, EMPTYOF(Money.Source));
 END {GetMoneySum};

 PRIVATE PROCEDURE GetGate(VAR D1, D2: DATE);
 BEGIN
  IF    StaffLog.Date < MonthB THEN
   D1:=MonthB;
  ELSE
   L_General.CallUs(StaffLog.Date <= MonthE);
   D1:=StaffLog.Date;
  END;
  IF ~!StaffLog.DateE & (StaffLog.DateE < MonthE) THEN
   IF StaffLog.DateE < MonthB THEN
    D2:=MonthB - 1;
   ELSE
    D2:=StaffLog.DateE;
   END;
  ELSE
   D2:=MonthE;
  END;
 END {GetGate};

 PRIVATE PROCEDURE GetBonusBase();
  VAR
   i: SCAL[P_MCList.BonBaseAmount+1];
 BEGIN
  SETZERO(BonSum, BonTim, InSign_Base, InSign_Time);
  SELECT(Money, PayFor, , Staff.TSN, MonthB);
  WHILE OCCURE(Money) DO
   IF (Money.ODate = StaffLog.Date) & (Money.WFPeriod = MonthB) THEN
    CONFORM(Money, MCList); i:=0;
    WHILE i < P_MCList.BonBaseAmount DO
     IF P_MCList.inBonus(MCList.MCode, Money.Period, i) THEN
      L_General.Assert(MCList.MCTyp=L_PRoll.mct_Credit, "⨬ ਬ  㤥ঠ|ਧ '뢠  ६'| 㤥ঠ "+MCList.MCode);
      INC(BonSum[i], L_General.UnDenominate(Money.Closed, MonthB, Money.Sum));
      IF MCList.TimeType THEN
       INC(BonTim[i], Money.Tim);
      END;
     END; (* IF MCList ... *)
     INC(i);
    END; (* WHILE i < ... *)
    IF MCList.InSign[L_PRoll.mcis_FullSalary] THEN
     INC(InSign_Base[L_PRoll.mcis_FullSalary], L_General.UnDenominate(Money.Closed, MonthB, Money.Sum));
     IF MCList.TimeType THEN
      INC(InSign_Time[L_PRoll.mcis_FullSalary], Money.Tim);
     END;
    END;
   END; (* IF Money.ODate ... *)
   NEXT(Money);
  END; (* WHILE OCCURE(Money)... *)
 END {GetBonusBase};

 (*==========================================================*)

 PRIVATE PROCEDURE IsLastLogBeforeDischarge(): SCAL[2];
  VAR
   _IsLastLogBeforeDischarge: SCAL[2];
 BEGIN
  SAVE(StaffLog);
  _IsLastLogBeforeDischarge:=NEXT(StaffLog) &
                             ~L_Staff.ItsNotLastDischargeStaffLog();
  RESTORE(StaffLog);
  RETURN _IsLastLogBeforeDischarge;
 END {IsLastLogBeforeDischarge};

 PRIVATE PROCEDURE GetDayTime(): LIKE(Sheet.DayTime);
 BEGIN
  IF (RegList.DayTime=RegList.GrTime) | (RegList.DayTime = 0) THEN
   RETURN EMPTYOF(RegList.DayTime);
  ELSE
   RETURN RegList.DayTime;
  END;
 END {GetDayTime};

 PRIVATE PROCEDURE ExceptHolidLine(): SCAL[2];
 BEGIN
  RETURN (MonthB >= 01\06\2008) & (JMode.JMode=L_Sheet.jm_LineHld(MonthB));
 END {ExceptHolidLine};

 PRIVATE PROCEDURE IsJModeHolTime(curJMode: LIKE(JMode.JMode)): SCAL[2];
  VAR
   Result: LIKE(JMode.Type);
 BEGIN
  SAVE(JMode);
  L_General.CallUs(SEARCH(JMode, JMode, curJMode));
  L_General.CallUs(~JMode.DecrBal);
  Result:=JMode.Type = L_Sheet.jmType_HolTime;
  RESTORE(JMode);
  RETURN Result;
 END {IsJModeHolTime};

 PRIVATE PROCEDURE extInState(D: DATE): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(StaffLog);
  Result:=L_Staff.rInState(D);
  RESTORE(StaffLog);
  RETURN Result;
 END {extInState};

 PRIVATE PROCEDURE GetBal();
  VAR
   CurDate,
   RealDate,
   D1, D2    : DATE;
   _RDay     : LIKE(RegHead.RDay);
   _IsDSL    : SCAL[2];
   byEDOJMode: LIKE(JMode.JMode);
   _HolTime  : L_PRoll.tTime;
 BEGIN
  SETZERO(_TimDone, _CorBal, _HBal, _RDay,
          Tims, Days, SpT, HolTime, HolTime_MGT, HolDays, CorWDays,
          PaidAbsent, NonPAbsent, Days_PaidAbsent, Days_NonPAbsent);

  GetGate(D1, D2);
 
  IF D1 <= D2 THEN (*        *)
   RealDate:=SYSDATE();
   _IsDSL:=L_Staff.IsDischargeStaffLog();
   L_General.Assert(SEARCH(RegHead, HumReg, StaffLog.Regime, MonthB),
                    " ० " + StaffLog.Regime + "  ᠭ   " + L_DatTim.PeriodStr(MonthB));
   SELECT(JMode, JMode); (*sic*)
   SELECT(RegList, HumReg, , StaffLog.Regime, MonthB);
   WHILE OCCURE(RegList) DO
    CurDate:=RegList.Period + (RegList.Day - 1);
    IF (D1 <= CurDate) & (D2 >= CurDate) THEN
     byEDOJMode:=L_EDO.sra_GetSpecifiedJMode(Staff.TSN, CurDate);
     SEARCH(Sheet, TSN, , Staff.TSN, MonthB, RegList.Day);
     IF ~OCCURE(Sheet) | L_Sheet.ReplaceableSheet() | (Sheet.Source=L_Sheet.src_EDOrder) THEN
      IF _IsDSL THEN
       L_Sheet.UpdateSheet(CurDate, L_Sheet.jm_ContractBreak(CurDate), 0, L_Sheet.spk_None, 0, 0, L_Sheet.src_StaffLog);
      ELSIF CurDate > RealDate THEN
       L_Sheet.UpdateSheet(CurDate, L_Sheet.jm_RatherEarly(CurDate), RegList.Durat, L_Sheet.spk_None, 0, 0, L_Sheet.src_Regime);
      ELSIF ~!byEDOJMode THEN
       IF IsJModeHolTime(byEDOJMode) THEN
        L_Sheet.UpdateSheet(CurDate, byEDOJMode, 0, L_Sheet.spk_None, 0, EMPTYOF(RegList.DayTime), L_Sheet.src_EDOrder);
       ELSE
        L_Sheet.UpdateSheet(CurDate, byEDOJMode, RegList.Durat, L_Sheet.spk_None, 0, GetDayTime(), L_Sheet.src_EDOrder);
       END;
      ELSE
       IF L_PRoll.E_SpecifiedHld(CurDate) THEN
        L_Sheet.UpdateSheet(CurDate, L_Sheet.jm_Hld(CurDate), 0, L_Sheet.spk_None, 0, EMPTYOF(Sheet.DayTime), L_Sheet.src_Regime);
       ELSE
        L_Sheet.UpdateSheet(CurDate, RegList.JMode, RegList.GrTime, RegList.SpKind, RegList.SpTime, GetDayTime(), L_Sheet.src_Regime);
       END;
      END;
     ELSE
      L_General.Assert(~_IsDSL,
                       "㤠 ⬥⪨  ⠡  ਮ 뢠  ࠪ");
      IF ~!byEDOJMode & (byEDOJMode # Sheet.JMode) & ~L_Sheet.E_IsUnknownAbsence(byEDOJMode) THEN
       L_StdFrm.Choice(L_DatTim.DateStr(CurDate) + " - ⬥⪠ , 祬  ਪ?");
      END;
     END; (* IF ~OCCURE(Sheet) ... *)
  
     IF Sheet.JMode # JMode.JMode (*sic*) THEN
      CONFORM(Sheet, JMode);
      L_General.Assert(L_DatTim.InPatIntvl(JMode.Begin, JMode.Till,
                                           Sheet.Period, L_DatTim.MonthEnd(Sheet.Period)),
                                           " ࠡ  ⠡ " + JMode.JMode + "    " + L_DatTim.PeriodStr(Sheet.Period));
     END;
     IF JMode.Type = L_Sheet.jmType_HolTime THEN
      L_General.Assert((Sheet.Tim=0) & (Sheet.SpTime=0) & (!Sheet.DayTime | (Sheet.DayTime=0)), "室   㫥 ६| " + L_DatTim.DateStr(CurDate));
     END;

     INC(Tims[Sheet.JMode], Sheet.Tim);
     INC(Days[Sheet.JMode]);

     IF JMode.InFirm THEN
      INC(_HBal, RegList.Durat);
      INC(_RDay, RegList.Durat > 0);
      IF    JMode.Type = L_Sheet.jmType_TimDone THEN
       INC(_TimDone, Sheet.Tim);
      ELSIF JMode.Type = L_Sheet.jmType_PaidAbsent THEN
       INC(PaidAbsent, Sheet.Tim);
       INC(Days_PaidAbsent);
      ELSE
       INC(NonPAbsent, Sheet.Tim);
       INC(Days_NonPAbsent);
      END; (* IF JMode.Type ... *)
   
      IF Sheet.Tim#0 THEN
       IF JMode.PayHldy & ~ExceptHolidLine() THEN
        _HolTime:=L_Sheet.HolTimeByDate(CurDate, Sheet.Tim, Sheet.DayTime);
        IF L_Hld.DayIsHoliday(CurDate) THEN
         INC(HolDays);
        END;
        IF (Sheet.DayTime > 0) &
           (Sheet.Tim # Sheet.DayTime) &
           L_Hld.DayIsHoliday(CurDate + 1) &
           (Sheet.Tim > Sheet.DayTime) THEN
         INC(HolDays);
        END;
        INC(HolTime, _HolTime);
        IF RegList.Durat = 0 THEN
         INC(HolTime_MGT, _HolTime);
        END;
       END; (* IF JMode.PayHldy ... *)
 
       IF JMode.DecrBal THEN
        IF (MonthB >= 01\11\2012) & (StaffLog.DutyDgr < 1) & (Sheet.Source = L_Sheet.src_AvePay) THEN
         DEC(_CorBal, RegList.Durat);
        ELSE
         DEC(_CorBal, Sheet.Tim);
        END;
        DEC(CorWDays);
       END;
      END;
   
      IF JMode.PaySpTim THEN
       INC(SpT[Sheet.SpKind], Sheet.SpTime);
      END;
     END; (* IF JMode.InFirm ... *)
    END; (* IF IF (D1 <= CurDate) ... *)
    NEXT(RegList);
   END; (* WHILE OCCURE(RegList) ... *)
  END; (* IF D1 <= D2 ... *)

  IF ~extInState(MonthB) & L_Staff.FirstLogInMonth() THEN
   SELECT(Sheet, TSN, , Staff.TSN, MonthB);
   WHILE OCCURE(Sheet) & ((Sheet.Period + Sheet.Day - 1) < D1) DO
    L_General.Assert(L_Sheet.ReplaceableSheet(),
                     "㤠 ⬥⪨  ⠡  ⮣  ਭ?");
    REMOVE(Sheet);
   END;
  END;
  IF ~extInState(MonthE) & IsLastLogBeforeDischarge() THEN
   SETSEL(Sheet, TSN, Staff.TSN, MonthB);
   SRCINSEL(Sheet, GE, , L_DatTim.DAY(D2 + 1));
   WHILE OCCURE(Sheet) DO
    L_General.Assert(L_Sheet.ReplaceableSheet(),
                     "㤠 ⬥⪨  ⠡ ᫥ 㢮쭥?");
    REMOVE(Sheet);
   END;
  END;

  INC(CorWDays, _RDay);
  INC(_CorBal,  _HBal);
  L_General.Assert(_CorBal >= 0, "⥫  ࠡ祣 ६.||" +
                                 " 稭:  ० ࠡ ᫥ ࠡ⪨     |" +
                                 "㬥⮢  ⢨/ -।.                ||" +
                                 "室 믮 '  㬥⠬'  ,        |" +
                                 " ஬  㬥  ⢨/ -।,|" +
                                 "室騩  ⥪騩 .  " +
                                 Staff.TSN + "                  ");

  TotalAbsent     :=     PaidAbsent +      NonPAbsent;
  Days_TotalAbsent:=Days_PaidAbsent + Days_NonPAbsent;

  INC(PCalc.TimDone, _TimDone);
  INC(PCalc.CorBal, _CorBal);
  INC(PCalc.HBal, _HBal);

  REPLACE(PCalc);
 END {GetBal};

 PRIVATE PROCEDURE GetFeeSum(curType     : LIKE(FOrder.Type);
                             curPeriod   : LIKE(FOrder.Period);
                             curMCode    : LIKE(MCList.MCode);
                             curODate    : LIKE(Money.ODate);
                             curValue    : L_PRoll.tSum;
                             curCheckSum,
                             curAllODate : SCAL[2]): NUMERIC[2];
  VAR
   OtherODSum,
   Result,
   BaseSum,
   MadeSum : L_PRoll.tSum;
 BEGIN
  IF curType = L_PRoll.fot_BySum THEN
   Result:=curValue;
  ELSE
   SETZERO(OtherODSum, BaseSum, MadeSum);
   SELECT(Money, PayFor, , Staff.TSN, curPeriod); 
   WHILE OCCURE(Money) DO
    IF (Money.MCode = curMCode) & (Money.WFPeriod <= MonthB) THEN
     IF Money.ODate = curODate THEN
      IF Money.Source # L_PRoll.src_OrderP THEN
       L_General.Assert((Money.Source # L_PRoll.src_System) &
                        (Money.Source # L_PRoll.src_FtSht) &
                        (Money.Source # L_PRoll.src_XCalc),
                        "⨬ ਬ 業 ਪ|" +
                        " ⥬ ஢   " + curMCode);
       INC(BaseSum, L_General.UnDenominate(Money.Closed, MonthB, Money.Sum));
      ELSE
       INC(MadeSum, L_General.UnDenominate(Money.Closed, MonthB, Money.Sum));
      END;
     ELSE
      INC(OtherODSum, L_General.UnDenominate(Money.Closed, MonthB, Money.Sum));
     END; (* IF Money.ODate = curODate... *)
    END;
    NEXT(Money);
   END; (* WHILE OCCURE(Money) ... *)
   L_General.Assert(BaseSum >= 0, "⥫쭠 㬬   /" + curMCode +
                                  "|⨬ ਬ 業 ਪ");
   IF curCheckSum & (BaseSum = 0) & (OtherODSum # 0) & ~curAllODate THEN
    L_StdFrm.Choice(",  ਪ 㪠 ୠ  /" +
                    L_StdFrm.HR() +
                    "ਪ  業   / " + curMCode + " ଫ  / " + L_DatTim.DateStr(curODate) + "," +
                    "|  ⭮ ⪥ 㬬   / ࠢ , " +
                    "|  㫥 㬬  㣨 /");
   END;
   Result:=BaseSum * curValue / 100;
   IF -(MadeSum + Result) > BaseSum THEN
    INC(Result, -(MadeSum + Result) - BaseSum);
   END;
  END;
  RETURN Result;
 END {GetFeeSum};

 PRIVATE PROCEDURE GetFeeTim(): L_PRoll.tTime;
 BEGIN
  IF FOrder.Type = L_PRoll.fot_BySum THEN
   RETURN FOrderL.Tim;
  ELSE
   RETURN 0;
  END;
 END {GetFeeTim};

 PRIVATE PROCEDURE SetBonusMCode();
 BEGIN
  BonusMCode[MoneyRul.MCode]:=1;
 END {SetBonusMCode};

 PRIVATE PROCEDURE CheckODate(_ODate: DATE; curAllODate: SCAL[2]; Msg: STRING[]): SCAL[2];
 BEGIN
  IF curAllODate | (StaffLog.Date = _ODate) THEN
   RETURN 1;
  ELSE
   L_General.Assert(_ODate <= MonthE, "  / 饣 | " + Msg);
   SAVE(StaffLog);
   L_General.Assert(SEARCH(StaffLog, TSN, StaffLog.TSN, _ODate), "  /| " + Msg);
   RESTORE(StaffLog);
   RETURN (_ODate < StaffLog.Date) &
          (StaffLog.Date <= MonthB);
  END;
 END {CheckODate};

 PRIVATE PROCEDURE GetODateForFee(): DATE;
 BEGIN
  IF ~!FOrderL.ODate THEN
   RETURN FOrderL.ODate;
  ELSE
   RETURN StaffLog.Date;
  END;
 END {GetODateForFee};

 PRIVATE PROCEDURE AbsorbeFee(_Type   : LIKE(FOrder.Type);
                              BonusFee: SCAL[2];
                              _Source : LIKE(Money.Source));
  VAR
   Dummy: L_PRoll.tSum;
 BEGIN
  SELECT(FOrderL, TSN, , Staff.TSN, MonthB);
  WHILE OCCURE(FOrderL) DO
   CONFORM(FOrderL, FOrder);
   L_General.Assert(FOrder.Done, " ࠡ⠭ ਪ "+ L_EDO.FOrderName());
   IF L_EDO.IsRealFOrder() THEN
    L_General.Assert(~!FOrderL.ODate | FOrderL.AllODate,
                     "室 㪠  /  ਪ  |" + L_EDO.FOrderName());
    L_EDO.CheckAllODate();
    IF (FOrder.Type = _Type) & (BonusMCode[FOrder.MCode] = BonusFee) &
       CheckODate(FOrderL.ODate, FOrderL.AllODate, "ਪ  / - " + L_EDO.FOrderName()) THEN
     IF CanPayByMCode(FOrder.MCode, FOrder.Period) THEN
      Dummy:=GetFeeSum(FOrder.Type, FOrder.Period, FOrder.MCode, GetODateForFee(),
                       FOrderL.Value, 1, FOrderL.AllODate);
      L_PRoll.detailedSaveMoney(+1, FOrder.MCode, FOrder.Period, GetODateForFee(), _Source,
                                L_XDoc.curXDocId(L_XDoc.xdt_FOrder), L_XObj.GetXObjectBy_fi_ri(FOrder.fiCO, FOrder.riCO), EMPTYOF(MoneyDst.AcCut),
                                Dummy, GetFeeTim());
     END;
    END;
   END; (* IF L_EDO.IsRealFOrder... *)
   NEXT(FOrderL);
  END;
 END {AbsorbeFee};

 PRIVATE PROCEDURE ExcludeForLeaved(_EndDate: LIKE(Staff.EndDate));
  VAR
   _MCode : LIKE(Money.MCode);
 BEGIN
  SETSEL(Money, TSN, Staff.TSN, MonthB, MonthB, StaffLog.Date);
  SRCINSEL(Money, GE, , L_DatTim.Per(_EndDate));
  WHILE OCCURE(Money) DO
   _MCode :=Money.MCode;
   CONFORM(Money, MCList);
   IF P_MCList.GetPayOnDischarge(_MCode, Money.Period) THEN
    WHILE OCCURE(Money) & (_MCode = Money.MCode) DO
     NEXT(Money);
    END;
   ELSE
    L_General.Assert(MCList.MCTyp=L_PRoll.mct_Credit, "⨬ ਬ  㤥ঠ|ਧ ' 믫稢  㢮쭥'| 㤥ঠ "+MCList.MCode);
    WHILE OCCURE(Money) & (_MCode = Money.MCode) DO
     IF (Money.Sum # 0) &
        (Money.Source # L_PRoll.src_Operator) &
        (Money.Source # L_PRoll.src_Sheet   ) &
        (Money.Source # L_PRoll.src_SheetDec) &
        (Money.Source # L_PRoll.src_OrderP  ) &
        (Money.Source # L_PRoll.src_OrderS  ) THEN
      L_PRoll.MakeMoneyStorno(L_PRoll.src_Sheet);
     END;
     NEXT(Money);
    END;
   END; (* IF P_MCList.GetPayOnDischarge ... *)
  END; (* WHILE OCCURE(Money) ... *)
 END {ExcludeForLeaved};

 PRIVATE PROCEDURE SimpleProceedRule();
 BEGIN
  IF ktm_DoIt() & CanPayByMCode(MoneyRul.MCode, MonthB) THEN
   CONFORM(MoneyRul, MCList);
   curRuleHasMoney:=0;
   ktmLPartIsEmpty:=1;

   ^MoneyRul.Rule();
   IF ~curRuleHasMoney THEN
    IF ktmLPartIsEmpty THEN
     ktm_PutDelimitter();
    END;
    MAKEPART(ktm_R, ktm_RuleBot, "", "X");
   END;
  ELSE
   ^MoneyRul.Rule();
  END;
 END {SimpleProceedRule};

 PRIVATE PROCEDURE PasteAll();
 BEGIN
  PASTE(^(L_Card.GetCardName(L_Card.t_SHT, MonthB)));
  PASTE(^(L_Card.GetCardName(L_Card.t_SHP, MonthB)));
 END {PasteAll};

 PRIVATE PROCEDURE SheetP_ExecMethod(trgMethod: LIKE(MoneyMth.Method);
                                     trgProc  : PROC);
 BEGIN
  L_PRoll.ExecMethod(MonthB, trgMethod, trgProc, EMPTYOF(PROC));
 END {SheetP_ExecMethod};

 PRIVATE PROCEDURE ExecAddKind(Bonus: SCAL[2]);
  VAR
   BegDate,
   EndDate: DATE;
   NeedExecMethod: SCAL[2];
 BEGIN
  IF L_PRoll.E_IndividualAddingCalc(MonthB) THEN
   GetGate(BegDate, EndDate);
   SETSEL(Adding, TSN, Staff.TSN);
   LAST(Adding);
   WHILE OCCURE(Adding) DO
    CHANGESEL(Adding, TSN, , Staff.TSN, Adding.AddKind);
    IF SRCINSEL(Adding, LE, EndDate) THEN
     CONFORM(Adding, AddKind);
     LOOP
      IF ~OCCURE(Adding) THEN
       EXIT;
      END;
      IF !Adding.UpTo | (BegDate <= Adding.UpTo) THEN
       IF    AddKind.IsBonus & ~Bonus THEN
        SheetP_ExecMethod(AddKind.Method, PROCREF(SetBonusMCode));
       ELSIF AddKind.IsBonus = Bonus THEN
        NeedExecMethod:=1;
        IF ~!Adding._EDOrder THEN
         L_General.CallUs(SEARCH(EDOrderL, EDOrder, Adding._EDOrder, Adding._Row));
         CONFORM(EDOrderL, EDOrder);
         IF L_EDO.E_EDO_Level(EDOrder.Date) > 0 THEN
          L_EDO.EDorderMustBeSigned(MonthB);
          NeedExecMethod:=EDOrder.State = L_EDO.st_ordSigned;
         END;
        END;
        IF NeedExecMethod THEN
         SheetP_ExecMethod(AddKind.Method, PROCREF(SimpleProceedRule));
        END;
       END;
      ELSIF ~AddKind.CrossSt THEN
       EXIT;
      END;
      PREV(Adding);
     END; (* LOOP... *)
    END; (* IF SRCINSEL(Adding... *)
    FIRST(Adding);
    CHANGESEL(Adding, TSN, , Staff.TSN);
    PREV(Adding);
   END; (* WHILE OCCURE(Adding) ... *)
  END; (* IF L_PRoll.E_IndividualAddingCalc ... *)
 END {ExecAddKind};

 PRIVATE PROCEDURE intExecEDOrder(Bonus: SCAL[2]; trgGroup: L_EDO.tGroup; trgMthType: LIKE(MthType.MthType));
  VAR
   NeedExecMethod: SCAL[2];
 BEGIN
  SELECT(EDOrderL, TSNGrCl, , Staff.TSN, trgGroup, MonthB);
  WHILE OCCURE(EDOrderL) DO
   IF (EDOrderL.Status = L_EDO.st_Passed) &
      ((~Bonus & (EDOrderL.BySum # 0)) | (Bonus & (EDOrderL.ByPrc # 0))) THEN
    CONFORM(EDOrderL, EDOKind);
    CONFORM(EDOKind, MoneyMth);
    L_EDO.CheckMthType(EDOKind.EDOKind, MoneyMth.MthType);
    IF !trgMthType | (trgMthType=MoneyMth.MthType) THEN
     CONFORM(EDOrderL, EDOrder);
     L_General.Assert(~!EDOrderL.ODate | EDOrderL.AllODate,
                      "室 㪠  /  ਪ  ᮭ|" + L_EDO.EDOrderName());
     L_EDO.EDO_CheckAllODate();
     IF CheckODate(EDOrderL.ODate, EDOrderL.AllODate, "ਪ " + L_EDO.EDOrderName()) THEN
      NeedExecMethod:=1;
      IF L_EDO.E_EDO_Level(EDOrder.Date) > 0 THEN
       L_EDO.EDorderMustBeSigned(MonthB);
       NeedExecMethod:=EDOrder.State = L_EDO.st_ordSigned;
      END;
      IF NeedExecMethod & (EDOrderL.Type < L_EDO.type_Cancel) THEN
       SheetP_ExecMethod(EDOKind.Method, PROCREF(SimpleProceedRule));
      END;
     END; (* IF CheckODate ... *)
    END; (* IF !trgMthType... *)
   END; (* IF EDOrderL.Status ... *)
   NEXT(EDOrderL);
  END; (* WHILE OCCURE(EDOrderL) ... *)
 END {intExecEDOrder};

 PRIVATE PROCEDURE ExecEDOrder(Bonus: SCAL[2]; trgMthType: LIKE(MthType.MthType));
 BEGIN
  IF L_PRoll.E_ReflectEDOrder(MonthB) THEN
   SELECT(EDOGrp, EDOGrp);
   WHILE OCCURE(EDOGrp) DO
    IF L_EDO.IsGroup_wPay(EDOGrp.EDOGrp) THEN
     SAVE(EDOGrp);
     intExecEDOrder(Bonus, EDOGrp.EDOGrp, trgMthType);
     RESTORE(EDOGrp);
    END;
    NEXT(EDOGrp);
   END; (* WHILE OCCURE(EDOGrp) ... *)
  END; (* IF L_PRoll.E_ReflectEDOrder ... *)
 END {ExecEDOrder};

 PRIVATE PROCEDURE ExecAvePay();
 BEGIN
  SELECT(AvePay, Period, , MonthB, Staff.TSN);
  WHILE OCCURE(AvePay) DO
   CONFORM(AvePay, AveType);
   IF (AveType.Pass = 1) & L_Staff.InOrder(AvePay.StartD) THEN
    SAVE(PCalc);
    SAVE(StaffLog);
    CALL(AvePay.AvePay_OnStreamingProceed(0));
    RESTORE(StaffLog);
    RESTORE(PCalc);
   END;
   NEXT(AvePay);
  END; (* WHILE OCCURE(AvePay) ... *)
  CONFORM(StaffLog, Officer, Post, WagePay);
  HISTCONF(MonthB, WagePay, WagePayL);
 END {ExecAvePay};

 PRIVATE PROCEDURE TestRWaySStaffInState();
 BEGIN
  L_General.Assert_wReferToAdmin(RWayS.Date <= Staff.EndDate,
                                 "    ᫥  㢮쭥," +
                                 "|ਬ,  " + RWayS.RWayS + "  " + L_DatTim.DateStr(RWayS.Date));
 END {TestRWaySStaffInState};

 PRIVATE PROCEDURE TestCurrentRWayDoc(_Done: SCAL[2]; _Date: DATE; _Text: STRING[]): SCAL[2];
  VAR
   Msg: STRING[];
 BEGIN
  IF ~_Done THEN
   Msg:=" ࠡ⠭ 㬥  " + L_DatTim.PeriodStr(MonthB) +
        ",|ਬ " + _Text + "  " + L_DatTim.DateStr(_Date);
   IF ~L_APtm.MonthIsClosed(MonthB, L_APtm.system_Salary) THEN
    IF ktm_DoIt() THEN
     ktm_PutDelimitter();
     MAKEPART(ktm_R, ktm_SubTop, "!!! " + L_Str.Replace(Msg, "|", " ") + " !!!");
    END;
    IF ~L_General.KioskExecution_IsRunning() THEN
     L_StdFrm.Choice(Msg);
    END;
   ELSE
    L_General.Error(Msg);
   END;
  END;
  RETURN ~_Done;
 END {TestCurrentRWayDoc};

 PRIVATE PROCEDURE TestCurrentRWayS(): SCAL[2];
 BEGIN
  TestRWaySStaffInState();
  RETURN TestCurrentRWayDoc(RWayS.Done, RWayS.Date, " " + RWayS.RWayS);
 END {TestCurrentRWayS};

 PRIVATE PROCEDURE TestAllRWayS();
  VAR
   D1,
   D2,
   D        : DATE;
   HasUndone: SCAL[2];
 BEGIN
  IF L_Env.RealTSN(Staff.TSN) & L_Staff.OrderInMonth(MonthB) THEN
   GetGate(D1, D2);
   HasUndone:=0;
   IF    L_PRoll.curCountUp = L_PRoll.cu_strmUpToDate THEN
    D:=Memo.gl_cd();
   ELSIF L_Staff.IsLeaveFinally(MonthB) THEN
    D:=MAXOF(DATE);
   ELSE
    D:=Math.Min(SYSDATE() - 1, MonthE);
   END;
   D2:=Math.Min(D, D2);
   SETSEL(RWayS, TSN, Staff.TSN);
   SRCINSEL(RWayS, GE, , D1);
   WHILE ~HasUndone & OCCURE(RWayS) & (RWayS.Date <= D2) DO
    HasUndone:=TestCurrentRWayS();
    NEXT(RWayS);
   END;

   SETSEL(WayLMen, TSN, Staff.TSN);
   SRCINSEL(WayLMen, GE, , D1);
   WHILE ~HasUndone & OCCURE(WayLMen) & (WayLMen.RWayDate <= D2) DO
    CONFORM(WayLMen, RWayS);
    HasUndone:=TestCurrentRWayS();
    NEXT(WayLMen);
   END;

   IF L_Way.E_TckRcLevel(MonthB) THEN
    SETSEL(TckRcS, TSN, Staff.TSN);
    SRCINSEL(TckRcS, GE, , D1);
    WHILE ~HasUndone & OCCURE(TckRcS) & (TckRcS.Date <= D2) DO
     HasUndone:=TestCurrentRWayDoc(TckRcS.Done, TckRcS.Date, " " + TckRcS.TckRcS);
     IF TckRcS.AsWho = L_Way.trs_Chopper THEN
      CONFORM(TckRcS, TckRcJ);
      WHILE ~HasUndone & OCCURE(TckRcJ) DO
       SEARCH(RWayS, RWayS, , TckRcJ.asRWayS);
       HasUndone:=TestCurrentRWayS();
       NEXT(TckRcJ);
      END; (* WHILE OCCURE(TckRcJ) ... *)
     END;
     NEXT(TckRcS);
    END; (* WHILE OCCURE(TckRcS) ... *)

    IF L_Staff.IsLeaveFinally(MonthB) THEN
     L_General.Assert_wReferToAdmin(~SELECT(TckRcS, sTSN, L_TRS.trsStat_Ordered, Staff.TSN),
                                    " " + Staff.TSN +
                                    "|騩 ࠡ⭨  殮 ");
    END;
   END; (* IF L_Way.E_TckRcLevel(MonthB) *)
  END; (* L_Env.RealTSN(Staff.TSN)... *)
 END {TestAllRWayS};

 PRIVATE PROCEDURE MakePartRepWhithTariffRate();
 BEGIN
  ktm_PutDelimitter();
  ktm_PutMoney("ᮢ  ", HPay);
  ktm_PutMoney(" ", MPay);
  ktm_Put("ଠ  ० ࠡ", RegHead.FullBal);
  ktm_Put("ଠ ६", _HBal);
  ktm_Put("४஢ ଠ ६", _CorBal);
  ktm_Put("ࠡ⠭", _TimDone);
 END {MakePartRepWhithTariffRate};

 PUBLIC PROCEDURE Proceed();
  VAR
   _EndDate: LIKE(Staff.EndDate);
   oPrompt : PROMPT_LINE;
 BEGIN
  oPrompt:=PROMPT_LINE.Create("  ⠡");
  MonthB:=Memo.gl_mb();
  MonthE:=Memo.gl_me();
  CONFORM(StaffLog, Officer, Post, WagePay);
  HISTCONF(MonthB, WagePay, WagePayL);
  PasteAll();
  GetBal();
  SETZERO(BonusMCode);
  AbsorbeFee(L_PRoll.fot_BySum, 0(*  ६*), L_PRoll.src_OrderS);

  IF L_Staff.OrderInMonth(MonthB) THEN
   Sht_GetPay(); (* -ᨬ 楤 *)
   MakePartRepWhithTariffRate();
   SheetP_ExecMethod(L_PRoll.GetMethod(MonthB, L_PRoll.mthtyp_MonthlyCalc),
                     PROCREF(SimpleProceedRule));
   SheetP_ExecMethod(L_PRoll.GetMethod(MonthB, L_PRoll.mthtyp_SheetCalc),
                     PROCREF(SimpleProceedRule));
   ExecAddKind(0);
  ELSE
   SETEMPTY(HPay, MPay);
  END; (* IF L_Staff.OrderInMonth ... *)

  IF MonthB >= 01\04\2012 THEN
   ExecEDOrder(0, EMPTYOF(MthType.MthType));
   ExecEDOrder(1, L_PRoll.mthtyp_SheetCalc);
  ELSE
   ExecEDOrder(0, EMPTYOF(MthType.MthType));
  END;

  SheetP_ExecMethod(L_PRoll.GetMethod(MonthB, L_PRoll.mthtyp_BonusCalc),
                    PROCREF(SetBonusMCode));

  AbsorbeFee(L_PRoll.fot_ByPrc, 0(*  ६*), L_PRoll.src_OrderP);

  GetBonusBase();
  IF L_Staff.OrderInMonth(MonthB) THEN
   SheetP_ExecMethod(L_PRoll.GetMethod(MonthB, L_PRoll.mthtyp_BonusCalc),
                     PROCREF(SimpleProceedRule));
   ExecAddKind(1);
  END; (* IF L_Staff.OrderInMonth ... *)

  IF MonthB >= 01\04\2012 THEN
   ExecEDOrder(1, L_PRoll.mthtyp_BonusCalc);
   ExecEDOrder(1, L_PRoll.mthtyp_EDOrder);
  ELSE
   ExecEDOrder(1, EMPTYOF(MthType.MthType));
  END;

  AbsorbeFee(L_PRoll.fot_ByPrc, 1(* ६*), L_PRoll.src_OrderP);
  ExecClientPart();
  ExecAvePay();
  IF E_NoPayBecauseIsLeave(_EndDate, MonthB) THEN
   ExcludeForLeaved(_EndDate);
  END;
  IF SEARCH(MthType, MthType, L_PRoll.mthtyp_LastCalc) THEN
   GetBonusBase();
   SheetP_ExecMethod(L_PRoll.GetMethod(MonthB, L_PRoll.mthtyp_LastCalc),
                     PROCREF(SimpleProceedRule));
  END;
 END {Proceed};

 PRIVATE PROCEDURE intFillSheetByRegMain(wRWaySTest: SCAL[2]);
  VAR
   oPrompt: PROMPT_LINE;
 BEGIN
  oPrompt:=PROMPT_LINE.Create(" ⠡");
  MonthB:=Memo.gl_mb();
  MonthE:=Memo.gl_me();
  L_PRoll.ShtDone(0);
  IF wRWaySTest THEN
   TestAllRWayS();
  END;
  GetBal();
 END {intFillSheetByRegMain};

 PUBLIC PROCEDURE FillSheetByRegMain();
 BEGIN
  intFillSheetByRegMain(1);
 END {FillSheetByRegMain};

 PUBLIC PROCEDURE FillSheetByRegMainWORWaysTest();
 BEGIN
  intFillSheetByRegMain(0);
 END {FillSheetByRegMainWORWaysTest};

END.
