(*
%Copyright   (c) Polak IT
%Author      05.01.2007 17:43:15 POLAK\Gina
%Purpose        sheetp
%Type        library,to paste
%Specific    SYS
%Modified    12.09.2014 12:49:29 POLAK\Gina
%Environment
*)

 IMPORT Memo, L_General, L_DatTim, P_Man, L_Str, L_StdFrm, L_Staff, L_PRoll, L_EDO, L_Env, L_Sheet,
        Str, Math, L_AvePay, L_AP;

 TYPE
  tPerOfEDOrderL = SCAL[2];

 CONST
  pedo_ByOcrDate = 0; (*tPerOfEDOrderL*)
  pedo_ByClosed  = 1;

  jm_BusinessTrip = 11(*஢*);

(*--   ⥩ -------------------------------------------------*)

 PUBLIC PROCEDURE GetBabyAddValueLen(): NUMERIC[6];
  VAR
   B, E,
   UpTo : DATE;
   DILen: NUMERIC[0];
 BEGIN
  GetGate(B, E);
  UpTo:=Math.Min(E, Adding.UpTo);
  DILen:=L_DatTim.DATEINT(B, E, Adding.From, UpTo);
  IF (DILen > 0) & (Adding.From <= SYSDATE()) THEN
   L_General.Assert((Days[L_Sheet.jm_ParentalLeave] > 0) |
                    (Days[L_Sheet.jm_ParentalLeaveUntil3Y] > 0) |
                    (Days[L_Sheet.jm_MaternityLeave] > 0) |
                    (StaffLog.DutyDgr<1),
                    "稥   室  ॡ| ᮮ⢥ ⬥⮪  ⠡");
  END;
  RETURN DILen/L_DatTim.MonthLen(Memo.gl_mb());
 END {GetBabyAddValueLen};

 PRIVATE PROCEDURE 室_15_।(MinSum, MaxSum: NUMERIC[2]);
  VAR
   DayToPay: NUMERIC[7];
 BEGIN
  L_General.Assert(Memo.gl_mb()>=01\01\2007, "ࠢ '室_15_।'    01.2007");
  MinSum:=MinSum * L_PRoll.RegionalCoeff(Memo.gl_mb()) * GetBabyAddValueLen();
  MaxSum:=MaxSum * L_PRoll.RegionalCoeff(Memo.gl_mb()) * GetBabyAddValueLen();
  IF Adding.Value # 0 THEN
   IF Memo.gl_mb()>=01\05\2007 THEN
    DayToPay:=GetBabyAddValueLen() * 30.4;
   ELSE
    DayToPay:=Math.Round(GetBabyAddValueLen() * L_DatTim.MonthLen(Memo.gl_mb()));
   END;
   MoneyMan(Math.Min(MaxSum, Math.Max(MinSum, DayToPay * Adding.Value * 0.40)), 0);
  END;
 END {室_15_।};

 PUBLIC PROCEDURE 室_15_।1();
 BEGIN
  IF    Memo.gl_mb()>=01\01\2014 THEN
   室_15_।(2576.63, 1000000.00);
  ELSIF Memo.gl_mb()>=01\01\2013 THEN
   室_15_।(2453.93, 1000000.00);
  ELSIF Memo.gl_mb()>=01\01\2012 THEN
   室_15_।(2326.00, 1000000.00);
  ELSIF Memo.gl_mb()>=01\01\2011 THEN
   室_15_।(2194.34, 13825.80);
  ELSIF Memo.gl_mb()>=01\01\2010 THEN
   室_15_।(2060.41, 13833.33);
  ELSIF Memo.gl_mb()>=01\01\2009 THEN
   室_15_।(1873.10, 7492.40);
  ELSIF Memo.gl_mb()>=01\07\2008 THEN
   室_15_।(1657.61, 6630.44);
  ELSIF Memo.gl_mb()>=01\01\2008 THEN
   室_15_।(1627.50, 6510);
  ELSE
   室_15_।(  1500, 6000);
  END;
 END {室_15_।1};

 PUBLIC PROCEDURE 室_15_।2();
 BEGIN
  IF    Memo.gl_mb()>=01\01\2014 THEN
   室_15_।(5153.24, 1000000.00);
  ELSIF Memo.gl_mb()>=01\01\2013 THEN
   室_15_।(4907.85, 1000000.00);
  ELSIF Memo.gl_mb()>=01\01\2012 THEN
   室_15_।(4651.99, 1000000.00);
  ELSIF Memo.gl_mb()>=01\01\2011 THEN
   室_15_।(4388.67, 13825.80);
  ELSIF Memo.gl_mb()>=01\01\2010 THEN
   室_15_।(4120.82, 13833.33);
  ELSIF Memo.gl_mb()>=01\01\2009 THEN
   室_15_।(3746.20, 7492.40);
  ELSIF Memo.gl_mb()>=01\07\2008 THEN
   室_15_।(3315.22, 6630.44);
  ELSIF Memo.gl_mb()>=01\01\2008 THEN
   室_15_।(3255, 6510);
  ELSE
   室_15_।(3000, 6000);
  END;
 END {室_15_।2};

 PUBLIC PROCEDURE 室_30();
 BEGIN
  IF Adding.Value # 0 THEN
   MoneyMan(50 * GetBabyAddValueLen(), 0);
  END;
 END {室_30};

 PUBLIC PROCEDURE ();
 BEGIN
  IF EDOrderL.BySum # 0 THEN
   ExplicitMoneyMan(Memo.gl_mb(), -EDOrderL.BySum, 0, L_PRoll.src_OrderS);
  END;
 END {};

 PUBLIC PROCEDURE ();
 BEGIN
  IF EDOrderL.BySum # 0 THEN
   ExplicitMoneyMan(Memo.gl_mb(), EDOrderL.BySum, 0, L_PRoll.src_OrderS);
  END;
 END {};

 PRIVATE PROCEDURE TestCorrectClosed(_Period: DATE; _MCode: LIKE(MCList.MCode));
 BEGIN
  IF (EDOrder.Closed>=01\10\2009) & (_Period # EDOrder.Closed) THEN
   IF _Period >= L_Env.aptm_Start THEN
    L_StdFrm.ConditionalCHOICE("ਪ  ᮭ " + Str.Condense(L_Str.Left(L_EDO.EDOrderName(), 40)) +
                               " ( " + EDOrder.EDOrder + ")  " + L_DatTim.PeriodStr(_Period) +
                               "|᫥ ७  ᮮ⢥騩 (" + L_DatTim.PeriodStr(_Period) + ") ",
                               ~SEARCH(MthType, MthType, L_PRoll.mthtyp_LastCalc));
   ELSE
    L_StdFrm.RedInform("६  ௫  "+L_DatTim.PeriodStr(_Period) +
                       "|᫥ ᫨  ਪ");
   END;
  END;
 END {TestCorrectClosed};

 PRIVATE PROCEDURE int६(Prc: LIKE(EDOrderL.ByPrc); _Source: LIKE(Money.Source); curPEDO: tPerOfEDOrderL);
  VAR
   Sum: NUMERIC[2];
   Per: DATE;
 BEGIN
  IF (Prc # 0) & CanPayByMCode(MoneyRul.MCode, Memo.gl_mb()) THEN
   IF curPEDO = pedo_ByOcrDate THEN
    Per:=L_DatTim.Per(EDOrderL.OcrDate);
    TestCorrectClosed(Per, MoneyRul.MCode);
   ELSE
    Per:=EDOrderL.Closed;
   END;
   Sum:=GetFeeSum(L_PRoll.fot_ByPrc, Per, MoneyRul.MCode, StaffLog.Date, -1 * Prc, 0, EDOrderL.AllODate);
   ExplicitMoneyMan(Per, Sum, 0, _Source);
  END;
 END {int६};

 PUBLIC PROCEDURE ();
 BEGIN
  int६(EDOrderL.ByPrc, L_PRoll.src_OrderP, pedo_ByOcrDate);
 END {};

 PUBLIC PROCEDURE 撌();
 BEGIN
  int६(EDOrderL.ByPrc, L_PRoll.src_OrderP, pedo_ByClosed);
 END {撌};

 PUBLIC PROCEDURE ();
 BEGIN
  int६(100 - EDOrderL.ByPrc, L_PRoll.src_Sheet, pedo_ByOcrDate);
 END {};

 PRIVATE PROCEDURE IsInvalidForToFullSalary(): SCAL[2];
 BEGIN
  IF P_Man.HasActualManPro(Staff.Man, Memo.gl_me(), P_Man.P_Invalid) THEN
   L_General.Assert(~!L_Str.PositionInPool("I|II|III", ManPro.Value), "SHT_:  ।  "+ManPro.Value);
   RETURN (ManPro.Value="I") | (ManPro.Value="II");
  ELSE
   RETURN 0;
  END;
 END {IsInvalidForToFullSalary};

 PRIVATE PROCEDURE NoAddPay(AdditionalPaymentName: STRING[]);
 BEGIN
  L_StdFrm.Choice("     ࠡ⪠ "+AdditionalPaymentName+",|"+
                  "..    ᫥:|"+
                  "ਪ  / "+L_DatTim.DateStr(StaffLog.Date));
 END {NoAddPay};

 PRIVATE PROCEDURE ࠡ⪠(AdditionalPaymentName: STRING[]);
  VAR
   ToFullSalaryTime: LIKE(Money.Tim);
 BEGIN
  L_General.Assert(Memo.gl_mb() >= 01\08\2008, "ࠢ "+MoneyRul.Rule+"    08.2008");
  IF Memo.gl_mb() >= 01\04\2011 THEN
   ToFullSalaryTime:=_CorBal - _TimDone;
  ELSE
   ToFullSalaryTime:=_CorBal - likeTims00();
  END;
  IF ToFullSalaryTime > 0 THEN
   IF InSign_Time[L_PRoll.mcis_FullSalary] = 0 THEN
    L_General.Assert(InSign_Base[L_PRoll.mcis_FullSalary] = 0, "㫥 ६,   㫥 ࠡ⮪    ");
    NoAddPay(AdditionalPaymentName);
   ELSE
    IF InSign_Base[L_PRoll.mcis_FullSalary] > 0 THEN
     MoneyMan(InSign_Base[L_PRoll.mcis_FullSalary]/InSign_Time[L_PRoll.mcis_FullSalary]*ToFullSalaryTime, ToFullSalaryTime);
    ELSE
     NoAddPay(AdditionalPaymentName);
    END;
   END;
  END;
 END {ࠡ⪠};

 PUBLIC PROCEDURE ();
 BEGIN
  IF (Staff.Contract=L_Staff.cnt_Basic) & (StaffLog.DutyDgr >= 1) & IsInvalidForToFullSalary() THEN
   ࠡ⪠(" ");
  END;
 END {};

 PUBLIC PROCEDURE ᢫();
 BEGIN
  IF (Staff.Contract=L_Staff.cnt_Basic) & (StaffLog.DutyDgr >= 1) & ~IsInvalidForToFullSalary() &
     (L_DatTim.CompleteYearsInIntvl(Man.Birth, Memo.gl_mb()) < 18) THEN
   ࠡ⪠(" 裡  ᮢ襭⨥");
  END;
 END {᢫};

 PRIVATE PROCEDURE AvePayHasJMode(trgJMode: LIKE(JMode.JMode)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(AveTypeP);
  Result:=0;
  SELECT(AveTypeP, AveType, , AvePay.AveType);
  WHILE OCCURE(AveTypeP) & ~Result DO
   IF AveTypeP.JMode=trgJMode THEN
    Result:=1;
   END;
   NEXT(AveTypeP);
  END; (* WHILE OCCURE(AveTypeP) *)
  RESTORE(AveTypeP);
  RETURN Result;
 END {AvePayHasJMode};

 PRIVATE PROCEDURE GetAvpAverage(): NUMERIC[2];
  VAR
   OnDate: DATE;
 BEGIN
  OnDate:=Adding.From;
  TRY [RESTORE_CURSORS(RC_ON)]
   SETSEL(AvePay, EBDTSN, Staff.TSN);
   IF SRCINSEL(AvePay, GE, OnDate) THEN
    CONFORM(AvePay, AveType);
    WHILE OCCURE(AvePay) & ~(L_AvePay.IsRealAvePay() & AvePayHasJMode(jm_BusinessTrip) & (AveType.AveNo=L_AvePay.aveno_Avrg)) DO
     IF NEXT(AvePay) THEN
      CONFORM(AvePay, AveType);
     END;
    END;
   END;
   IF ~OCCURE(AvePay) | ~((AvePay.StartD = Adding.From) & (AvePay.StopD=Adding.UpTo)) THEN
    L_StdFrm.WrongDB(" ' '  "+L_DatTim.DateStr(Adding.From)+"  "+L_DatTim.DateStr(Adding.UpTo)+":"+
                     "|  '஢  '  ⠪  ਮ");
   END;
   L_General.Assert(AvePay.Average > 0, "㫥 ।   ' '");
   RETURN AvePay.Average;
  EXCEPT
  END; (* TRY *)
 END {GetAvpAverage};

 PRIVATE CONST
  st_Work    = 0;
  st_SurPass = 1;
  st_Training= 2;

 PRIVATE VAR
  SochiTims: L_PRoll.tTime[5];

 PRIVATE PROCEDURE SetSochiTims();
 BEGIN
  SochiTims[st_Work]    :=L_AP.AcsMonthlyFull(L_AP.mthlWho_Staff, 80(*६ '᭮' ࠡ, *));
  SochiTims[st_SurPass] :=L_AP.AcsMonthlyFull(L_AP.mthlWho_Staff, 81(*६ ॣ, *));
  SochiTims[st_Training]:=L_AP.AcsMonthlyFull(L_AP.mthlWho_Staff, 82(*६ ⠦஢, *));
 END {SetSochiTims};

 PRIVATE PROCEDURE GetDays11(VAR T: NUMERIC[3]);
 BEGIN
  IF Sheet.JMode = jm_BusinessTrip THEN
   INC(T);
  END;
 END {GetDays11};

 PRIVATE PROCEDURE GetTims11(VAR T: NUMERIC[3]);
 BEGIN
  IF Sheet.JMode = jm_BusinessTrip THEN
   INC(T, Sheet.Tim);
  END;
 END {GetTims11};

 PRIVATE PROCEDURE GetTimsCorBal(VAR T: NUMERIC[3]);
 BEGIN
  CONFORM(Sheet, JMode);
  IF JMode.InFirm THEN
   SEARCH(RegList, HumReg, , StaffLog.Regime, Sheet.Period, Sheet.Day);
   INC(T, RegList.Durat);
   IF JMode.DecrBal & (JMode.JMode # jm_BusinessTrip) THEN
    DEC(T, Sheet.Tim);
   END;
  END;
 END {GetTimsCorBal};

 PRIVATE PROCEDURE IsLastAddingInMonth(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  Result:=0;
  SAVE(Adding);
  CHANGESEL(Adding, TSN, , Adding.TSN, Adding.AddKind);
  Result:=~NEXT(Adding) | (Adding.From > MonthE); (* 0102225 *);
  RESTORE(Adding);
  RETURN Result;
 END {IsLastAddingInMonth};

 PRIVATE PROCEDURE GetTimeByAdding(GetTime: PROC): L_PRoll.tTime;
  VAR
   Result: L_PRoll.tTime;
   B,
   E     : DATE;
 BEGIN
  Result:=0;
  SAVE(Adding);
  CHANGESEL(Adding, TSN, , Adding.TSN, Adding.AddKind);
  REPEAT
   GetGate(B, E);
   IF Adding.From > B THEN
    B:=Adding.From;
   END;
   IF ~!Adding.UpTo & (Adding.UpTo < E) THEN
    E:=Adding.UpTo;
   END;
   SELECT(Sheet, TSN, , Staff.TSN, MonthB);
   SRCINSEL(Sheet, EQ, , L_DatTim.DAY(B));
   WHILE OCCURE(Sheet) & (Sheet.Day <= L_DatTim.DAY(E)) DO
    GetTime(Result);
    NEXT(Sheet);
   END; (* WHILE OCCURE(Sheet) ... *)
  UNTIL ~PREV(Adding) | (Adding.UpTo < MonthB); (* 0102225 *)
  RESTORE(Adding);
  RETURN Result;
 END {GetTimeByAdding};

 PRIVATE PROCEDURE 税(curTS: LIKE(WagePayL.Pay[0]); curTime: NUMERIC[3]; curSummationSheet: SCAL[2]);
 BEGIN
  IF curTS > 0 THEN
   IF curSummationSheet THEN
    MoneyMan(curTS * curTime, curTime);
   ELSE
    MoneyMan(curTS * curTime, GetTimeByAdding(PROCREF(GetTims11)));
   END;
  END;
 END {税};

 PUBLIC PROCEDURE 稏।();
  VAR
   avpAverage: NUMERIC[2];
   WorkTime,
   PaidTime,
   curTime   : L_PRoll.tTime;
   IsSummationSheet: SCAL[2];
 BEGIN
  CheckTill(01\08\2014);
  IsSummationSheet:=L_PRoll.E_IsSummationSheet(Adding.From);
  SetSochiTims();
  WorkTime:=SochiTims[st_Work]+SochiTims[st_SurPass]+SochiTims[st_Training];
  PaidTime:=GetMoneyTim(MoneyRul.MCode);
  IF (L_General.GetAPSiteID() # "29") & (L_General.GetAPSiteID() # "55") THEN
   PaidTime:=PaidTime - GetMoneyTimSrc(MoneyRul.MCode, L_PRoll.src_OrderS);
  END;
  curTime:=WorkTime - PaidTime;
  IF (WorkTime > 0) & ((MonthB>=01\01\2014) | (curTime > 0)) THEN
   L_General.Assert(IsSummationSheet, " : ⥫   㬬஢ ");
   avpAverage:=GetAvpAverage();
   税(avpAverage, curTime, IsSummationSheet);
  END;
 END {稏।};

 PRIVATE PROCEDURE SochiAddPay(addAverage, avpAverage: LIKE(WagePayL.Pay[0]); curNormTim, curTime: L_PRoll.tTime; curSummationSheet: SCAL[2]);
  VAR
   S: L_PRoll.tSum;
 BEGIN
  IF curTime = curNormTim THEN
   S:=Math.Max(0, Adding.Value - avpAverage*curTime);
  ELSE
   S:=Math.Max(0, addAverage - avpAverage) * curTime;
  END;
  IF curSummationSheet THEN
   MoneyMan(S, curTime);
  ELSE
   MoneyMan(S, GetTimeByAdding(PROCREF(GetTims11)));
  END;
 END {SochiAddPay};

 PUBLIC PROCEDURE 稍();
  VAR
   avpAverage: NUMERIC[2];
   curNormTim,
   curTime   : L_PRoll.tTime;
   IsSummationSheet: SCAL[2];
 BEGIN
  CheckTill(01\08\2014);
  IF ~IsLastAddingInMonth() THEN
   RETURN;
  END;
  IsSummationSheet:=L_PRoll.E_IsSummationSheet(Adding.From);
  avpAverage:=GetAvpAverage();
  SetSochiTims();
  curTime:=SochiTims[st_Work]+SochiTims[st_SurPass]+SochiTims[st_Training];
  IF curTime = 0 THEN
   IF IsSummationSheet THEN
    curNormTim:=RegHead.FullBal;
    curTime   :=GetTimeByAdding(PROCREF(GetTims11));
   ELSE
    curNormTim:=RegHead.RDay;
    curTime   :=GetTimeByAdding(PROCREF(GetDays11));
   END;
   L_General.Assert(curTime>0, " ६   ' '");
   SochiAddPay(Adding.Value/curNormTim, avpAverage, curNormTim, curTime, IsSummationSheet);
  ELSE
   curNormTim:=RegHead.FullBal;
   SochiAddPay(Adding.Value/curNormTim, avpAverage, curNormTim, SochiTims[st_Work], IsSummationSheet);
   SochiAddPay(40000/curNormTim, avpAverage, curNormTim, SochiTims[st_SurPass], IsSummationSheet);
   SochiAddPay(40000/curNormTim, avpAverage, curNormTim, SochiTims[st_Training], IsSummationSheet);
  END;
 END {稍};

 PUBLIC PROCEDURE 稏ࠧ();
  VAR
   avpAverage: NUMERIC[2];
   curTime   : L_PRoll.tTime;
   IsSummationSheet: SCAL[2];
 BEGIN
  CheckTill(01\08\2014);
  IF ~IsLastAddingInMonth() THEN
   RETURN;
  END;
  curTime:=L_AP.AcsMonthlyFull(L_AP.mthlWho_Staff, 83(*६ ࠧ筮, *));
  IF curTime > 0 THEN
   IsSummationSheet:=L_PRoll.E_IsSummationSheet(Adding.From);
   L_General.Assert(IsSummationSheet, " ࠧ    ।  ঠ");
   avpAverage:=GetAvpAverage();
   税(avpAverage, curTime, IsSummationSheet);
  END;
 END {稏ࠧ};

 PUBLIC PROCEDURE 稑();
  VAR
   avpAverage: NUMERIC[2];
   over,
   curTime   : L_PRoll.tTime;
   IsSummationSheet: SCAL[2];
 BEGIN
  CheckTill(01\08\2014);
  IF ~IsLastAddingInMonth() THEN
   RETURN;
  END;
  curTime:=SochiTims[st_Work]+SochiTims[st_SurPass]+SochiTims[st_Training] -
           L_AP.AcsMonthlyFull(L_AP.mthlWho_Staff, 83(*६ ࠧ筮, *));
  over:=curTime - GetTimeByAdding(PROCREF(GetTimsCorBal));
  IF over > 0 THEN
   IsSummationSheet:=L_PRoll.E_IsSummationSheet(Adding.From);
   L_General.Assert(IsSummationSheet, " ᢥ    ।  ঠ");
   avpAverage:=GetAvpAverage();
   税(avpAverage, over, IsSummationSheet);
  END;
 END {稑};

 PUBLIC PROCEDURE 稑();
  VAR
   DILen: NUMERIC[0];
 BEGIN
  CheckTill(01\08\2014);
  L_General.Assert(~!Adding.UpTo, "  "+Adding.AddKind+"     ''");
  DILen:=L_DatTim.DATEINT(MonthB, MonthE, Adding.From, Adding.UpTo);
  IF DILen > 0 THEN
   MoneyMan(700 * DILen, 0);
  END;
 END {稑};

END.
