(*
%Copyright   (c) Polak IT
%Author      18.12.2003 18:40:05 POLAK\Gina
%Purpose      쭨  믫
%Type        report
%Specific    SYS
%Modified    25.09.2013 20:53:35 POLAK\Gina
%Environment
*)

 MODULE SickR [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, Memo, L_AFM, L_DatTim, L_Str, L_AvePay, P_Firm,
        L_Basis, FIO, P_AveP, E_Utils, L_FSS, L_AcCut, L_bp, L_XDoc;

 CONST
  RepName = "SickR";

 VAR
  wMF: SCAL[2];

 PRIVATE PROCEDURE E_SickR_NeedSumByFirm(): SCAL[2];
 BEGIN
  RETURN ~!PROCREF(E_Utils.SickR_Get_MCodeByFirm);
 END {E_SickR_NeedSumByFirm};

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, " ᮡ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ⥫");
  L_Basis.wb_WrInQM(F, " 㬥");
  L_Basis.wb_WrInQM(F, "ਮ 㬥");
  L_Basis.wb_WrInQM(F, "ਮ");
  L_Basis.wb_WrInQM(F, "㬬 믫");
  L_Basis.wb_WrInQM(F, " ᥣ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "砫 ਮ");
  IF E_SickR_NeedSumByFirm() THEN
   L_Basis.wb_WrInQM(F, "㬬 믫 ࠡ⮤⥫");
  END;
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakeLine(F: STRING[];
                            _DocNumStr, _DocPerStr, _DocStartDStr: STRING[];
                            _Sum, _SumByFirm: NUMERIC[2];
                            _Closed: DATE;
                            _DaysTot, _DaysFSS: NUMERIC[0]);
 BEGIN
  IF wMF THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrStr(F, MCList.Name);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, L_Str.ShortName(Man.Name));
  L_Basis.wb_WrStr(F, _DocNumStr);
  L_Basis.wb_WrStr(F, _DocPerStr);
  L_Basis.wb_WrDat(F, _Closed);
  L_Basis.wb_WrNum(F, _Sum, 2);
  L_Basis.wb_WrNum(F, _DaysTot, 0);
  L_Basis.wb_WrNum(F, _DaysFSS, 0);
  L_Basis.wb_WrStr(F, _DocStartDStr);
  IF E_SickR_NeedSumByFirm() THEN
   L_Basis.wb_WrNum(F, _SumByFirm, 2);
  END;
  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PRIVATE PROCEDURE OneMCList(_MCode: LIKE(MCList.MCode); ByFirm: SCAL[2]);
  VAR
   curMCode: LIKE(Money.MCode);
 BEGIN
  IF ~!_MCode THEN
   L_General.Assert(SEARCH(MCList, MCode, _MCode), "   ᫥ "+_MCode);
 
   SETSEL(Money, MCode, _MCode);
   SRCINSEL(Money, GE, , Memo.ud_fr());
   WHILE OCCURE(Money) & (Money.Closed <= Memo.ud_ut()) DO
    IF (Money.Sum # 0) & ~SELECT(MnLst, MnLst, Money.RECORDID) THEN
     PROMPT(Money.TSN);
     IF SELECT(MoneyDst, MoneyDst, Money.RECORDID) & ~!MoneyDst.XDocId THEN
      WHILE OCCURE(MoneyDst) DO
       IF MoneyDst.Sum # 0 THEN
        IF ByFirm & SELECT(APLst, APLst, Money.TSN, Money.Closed, GetAvePay()) THEN
         curMCode:=APLst.MCode;
        ELSE
         curMCode:=Money.MCode;
        END;
        ADD(APLst, APLst, , Money.TSN, Money.Closed, GetAvePay(), curMCode,
                            APLst.SumFSS,    MoneyDst.Sum * ~ByFirm,
                            APLst.SumByFirm, MoneyDst.Sum * ByFirm);
        ADD(MnLst, MnLst, , Money.RECORDID);
       END;
       NEXT(MoneyDst);
      END; (* WHILE OCCURE(MoneyDst) ... *)
     ELSE
      ADD(Tmp01, Tmp01, , Money.TSN, Money.Closed, Money.Period,
                          Tmp01.SumFSS,    Money.Sum * ~ByFirm,
                          Tmp01.SumByFirm, Money.Sum * ByFirm);
     END; (* IF SELECT(MoneyDst... *)
    END;
    NEXT(Money);
   END; (* WHILE OCCURE(Money) ... *)
  END;
 END {OneMCList};

 PRIVATE PROCEDURE Put(_MCode: LIKE(MCList.MCode));
  VAR
   DocStartDStr,
   DocPerStr,
   DocNumStr  : STRING[];
   _SumByFirm,
   _Sum       : NUMERIC[2];
   DaysTot,
   DaysFSS    : NUMERIC[0];
   AveTypeList: STRING[];
 BEGIN
  SELECT(APLst, APLst);
  WHILE OCCURE(APLst) DO
   IF !APLst.AvePay THEN
    SETEMPTY(DocNumStr, DocPerStr, DocStartDStr);
    SETZERO(DaysTot, DaysFSS);
   ELSE
    SEARCH(AvePay, AvePay, , APLst.AvePay);
    DocNumStr   :=AvePay.DocNum;
    DocPerStr   :=L_DatTim.DateStr(AvePay.StartD)+"-"+L_DatTim.DateStr(AvePay.StopD);
    DocStartDStr:=L_DatTim.DateStr(AvePay.StartD);
    DaysTot:=AvePay.Amount;
    DaysFSS:=AvePay.Amount-P_AveP.Get_ft_FirstDaysByFirm();
   END;
   SEARCH(Staff, TSN, , APLst.TSN);
   CONFORM(Staff, Man);
   SEARCH(MCList, MCode, , APLst.MCode);
   MakeLine("R", DocNumStr, DocPerStr, DocStartDStr, APLst.SumFSS, APLst.SumByFirm, APLst.Closed, DaysTot, DaysFSS);
   NEXT(APLst);
  END;

  IF SELECT(Tmp01, Tmp01) THEN
   AveTypeList:=L_FSS.GetAveTypeList(Memo.ud_ut(), _MCode);
   WHILE OCCURE(Tmp01) DO
    SETEMPTY(DocNumStr, DocPerStr, DocStartDStr);
    SETZERO(_Sum, _SumByFirm, DaysTot, DaysFSS);
    CHANGESEL(Tmp01, Tmp01, , Tmp01._TSN, Tmp01._Closed);
    WHILE OCCURE(Tmp01) DO

     SETSEL(AvePay, EBDTSN, Tmp01._TSN);
     SRCINSEL(AvePay, GE, , Tmp01._Period);
     WHILE OCCURE(AvePay) DO
      IF ~SEARCH(Tmp02, Tmp02, AvePay.AvePay) & ~SELECT(APLst, AvePay, AvePay.AvePay) &
         (AvePay.Status = L_AvePay.st_Estimated) &
         ~!L_Str.PositionInPool(AveTypeList, AvePay.AveType) &
         L_FSS.IsInPer() THEN
       ADD(Tmp02, Tmp02, , AvePay.AvePay);
       DocNumStr:=L_Str.AddStrDlm(DocNumStr, ", ")+AvePay.DocNum;
       DocPerStr:=L_Str.AddStrDlm(DocPerStr, ", ")+L_DatTim.DateStr(AvePay.StartD)+"-"+L_DatTim.DateStr(AvePay.StopD);
       DocStartDStr:=L_Str.AddStrDlm(DocStartDStr, ", ")+L_DatTim.DateStr(AvePay.StartD);
       INC(DaysTot, AvePay.Amount);
       INC(DaysFSS, AvePay.Amount-P_AveP.Get_ft_FirstDaysByFirm());
      END;
      NEXT(AvePay);
     END; (* WHILE OCCURE(AvePay) ... *)

     INC(_Sum,       Tmp01.SumFSS);
     INC(_SumByFirm, Tmp01.SumByFirm);
     NEXT(Tmp01);
    END; (* WHILE OCCURE(Tmp01) ... *)
    LAST(Tmp01);
    SEARCH(Staff, TSN, , Tmp01._TSN);
    CONFORM(Staff, Man);
    MakeLine("R", DocNumStr, DocPerStr, DocStartDStr, _Sum, _SumByFirm, Tmp01._Closed, DaysTot, DaysFSS);
    CHANGESEL(Tmp01, Tmp01);
    NEXT(Tmp01);
   END;
  END;
 END {Put};

 PRIVATE PROCEDURE Gather();
  VAR
   MCodeListByFirm,
   MCodeList: STRING[];
   i        : NUMERIC[0];
   sie      : L_FSS.tsie;
 BEGIN
  FOR_EACH sie DO
   MCodeList:=E_Utils.XOMN8_Get_MCode(Memo.ud_ut(), sie, L_FSS.TaxGroupAll, 0);
 
   IF E_SickR_NeedSumByFirm() THEN
    MCodeListByFirm:=E_Utils.SickR_Get_MCodeByFirm(Memo.ud_ut(), sie, L_FSS.TaxGroupAll, 0);
   ELSE
    SETEMPTY(MCodeListByFirm);
   END;
 
   i:=0;
   WHILE ~!L_Str.PoolItem(MCodeList, i) | ~!L_Str.PoolItem(MCodeListByFirm, i) DO
    SELECT(Tmp01, Tmp01);
    REMSEL(Tmp01);
    SELECT(Tmp02, Tmp02);
    REMSEL(Tmp02);
    SELECT(APLst, APLst);
    REMSEL(APLst);
    OneMCList(L_Str.PoolItem(MCodeList, i), 0);
    OneMCList(L_Str.PoolItem(MCodeListByFirm, i), 1);
    Put(L_Str.PoolItem(MCodeList, i));
    INC(i);
   END;
  END
 END {Gather};

 PRIVATE PROCEDURE GetAvePay(): LIKE(AvePay.AvePay);
  VAR
   _XDocType : L_XDoc.tXDocType;
   _XDocKind : L_XDoc.tXDocKind;
   _XDoc     : L_XDoc.tXDoc;
 BEGIN
  IF !MoneyDst.XDocId THEN
   RETURN EMPTYOF(AvePay.AvePay);
  ELSE
   L_XDoc.DecodeXDocId(MoneyDst.XDocId, _XDocType, _XDocKind, _XDoc);
   RETURN _XDoc;
  END;
 END {GetAvePay};

 PUBLIC PROCEDURE SickR();
  CONST
   bpId = "SickR";
 BEGIN
  L_bp.Begin(bpId, " 믫  쭨 ⠬", L_bp.t_Basis, L_General.tc_inIntvl);
  L_General.Assert(~!PROCREF(E_Utils.XOMN8_Get_MCode(), " ।  ᫥  ᮡ  믫| ᮮ  ࠧࠡ稪");
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());

  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
 
  FIO.Open(R, L_General.NameConnection(bpId), "rep", Create);
  MakeHeader("R");

  L_AFM.MakeMultipleIndex("Tmp01", "_TSN   : LIKE(Money.TSN);"+
                                   "_Closed: LIKE(Money.Closed);"+
                                   "_Period: LIKE(Money.Period);"+
                                   "SumFSS   : NUMERIC[2];"+
                                   "SumByFirm: NUMERIC[2]",
                          "Tmp01: _TSN, _Closed, _Period");
  L_AFM.MakeIndex("Tmp02", "_AvePay: LIKE(AvePay.AvePay)");
 
  L_AFM.MakeMultipleIndex("APLst", "TSN      : LIKE(Money.TSN);"+
                                   "Closed   : LIKE(Money.Closed);"+
                                   "AvePay   : LIKE(AvePay.AvePay);"+
                                   "MCode    : LIKE(Money.MCode);"+
                                   "SumFSS   : NUMERIC[2];"+
                                   "SumByFirm: NUMERIC[2]",
                          "APLst: TSN, Closed, AvePay, MCode; AvePay: AvePay");
  L_AFM.MakeIndex("MnLst", "RECORDID: LIKE(Money.RECORDID)");

  Gather();

  L_AFM.AF_PurgeTemp("Tmp01");
  L_AFM.AF_PurgeTemp("Tmp02");
  L_AFM.AF_PurgeTemp("APLst");
  L_AFM.AF_PurgeTemp("MnLst");

  FIO.Close(R);
  L_bp.End();
 END {SickR};

END.