(*
%Copyright   (c) Polak Computer System
%Author      09.11.2001 13:49:23 GAV
%Purpose     ⭨    ६饭  ਮ
%Type        report
%Specific    SYS
%Modified    22.10.2013 13:30:52 POLAK\GAV
%Environment
*)

 MODULE SLKind [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_OwnData, L_AFM, L_DatTim, L_Man, L_Events, L_Str, L_WDO, L_Staff, L_AR;

(*
$P{Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), R, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
"⭨   ६饭 " + SLKind.Name, C, ""
Memo.ud_fr(), R, "D.N.y"
Memo.ud_ut(), R, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|                    ਮ c ##########  ##########                     |
}
*)

(*
$P{Header:
Union.Union, L, ""
Union.Name, L, ""
@
|----------------------------------------------------------------------------|
|⥣ ## ###############################################################|
|----------------------------------------------------------------------------|
|  |  ⢮         |           |||!|      |
|-----|-----------------------------|--------------------|-|----|-|----------|
}
*)

(*
$P{Line:
StaffLog.TSN, L, ""
Man.Name, L, ""
Post.Name, L, ""
StaffLog.Class, L, ""
StaffLog.Regime, L, ""
StfL.Ord, L, " |!"
StaffLog.Date, L, "D.N.y"
@
|#####|#############################|####################|#|####|#|##########|
}
*)

(*
$P{Bot:
@
=(c) Polak====================================================================
}
*)

 PUBLIC PROCEDURE RwSLK();
  CONST
   RepName = "RwSLK";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(SLKind), " ⠭  ६饭");
 
  L_AFM.MakeIndex("StfL", "Order1: STRING[16];"+
                             "_TSN  : LIKE(StaffLog.TSN);"+
                             "_Date : DATE;"+
                             "Ord   : SCAL[2]");
 
  OPENREP(R, L_General.NameConnection(RepName + "_" + SLKind.SLKind), Create);

  MAKEPART(R, Top, RepName);
  SELECT(StaffLog, SLKind, , SLKind.SLKind);
  WHILE OCCURE(StaffLog) DO
   PROMPT(StaffLog.TSN);
   CONFORM(StaffLog, Officer);
   IF OCCURE(Officer) THEN
    IF L_DatTim.IsActive_Inc(StaffLog.Date, Memo.ud_fr(), Memo.ud_ut()) THEN
     StfL.Order1:=Officer.Union;
     StfL._TSN  :=StaffLog.TSN;
     StfL._Date :=StaffLog.Date;
     StfL.Ord   :=0;
     INSERT(StfL);
    ELSIF L_DatTim.IsActive_Inc(StaffLog.OrdDate, Memo.ud_fr(), Memo.ud_ut()) THEN
     CONFORM(StaffLog, Officer);
     StfL.Order1:=Officer.Union;
     StfL._TSN  :=StaffLog.TSN;
     StfL._Date :=StaffLog.Date;
     StfL.Ord   :=1;
     INSERT(StfL);
    END;
   ELSE
    L_General.CallUs(~L_AR.DatabaseIsTransparent());
   END;
   NEXT(StaffLog);
  END; (* WHILE OCCURE(StaffLog) ... *)
 
  SELECT(StfL, StfL);
  WHILE OCCURE(StfL) DO
   NARROWSEL(StfL, Order1);
   SEARCH(Union, Union, , StfL.Order1);
   MAKEPART(R, Header);
   WHILE OCCURE(StfL) DO
    SEARCH(StaffLog, TSN, , StfL._TSN, StfL._Date);
    PROMPT(StaffLog.TSN);
    CONFORM(StaffLog, Post);
    CONFORM(StaffLog, Staff);
    CONFORM(Staff, Man);
    MAKEPART(R, Line);
    NEXT(StfL);
   END; (* WHILE OCCURE(StfL) ... *)
   NEXTINEXTENDEDSEL(StfL, Order1);
  END; (* WHILE OCCURE(StfL) ... *)
  L_AFM.AF_PurgeTemp("StfL");
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {RwSLK};

 PRIVATE PROCEDURE SLKindE_SetFields();
  VAR
   Fields: FORM_FIELDS;
   v     : SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  v:=(SLKind.Type # L_Staff.slkt_Discharge) & (SLKind.Type # L_Staff.slkt_Prolongation);
  Fields("TypeForIsTemp"  ).Visible:=v;
  Fields("SLKind.IsTemp"  ).Visible:=v;
  v:=(SLKind.Type = L_Staff.slkt_Move) | (SLKind.Type = L_Staff.slkt_Prolongation);
  Fields("TextForChgLbc"  ).Visible:=v;
  Fields("SLKind.ChngLbC" ).Visible:=v;
  v:=SLKind.Type # L_Staff.slkt_Discharge;
  Fields("TextForIsAct"   ).Visible:=v;
  Fields("SLKind.IsActing").Visible:=v;
  v:=SLKind.Type = L_Staff.slkt_Discharge;
  Fields("TextForGoodRs"  ).Visible:=v;
  Fields("SLKind.IsGodRsn").Visible:=v;
  Fields("SLKind.dSLKind" ).Modifiable:=SLKind.Type = L_Staff.slkt_TakeOnWithDischarge;
  Fields("SLKind.PutInT2" ).Modifiable:=SLKind.Type = L_Staff.slkt_Move;
 END {SLKindE_SetFields};

 PRIVATE PROCEDURE SLKind_Type_OnSuccessfulChange();
 BEGIN
  SLKindE_SetFields();
  SLKind.Sign:=L_Str.PoolItem("|-->|||/", SLKind.Type);
  IF SLKind.Type # L_Staff.slkt_Move THEN
   SLKind.PutInT2:=1;
  END;
  IF SLKind.Type # L_Staff.slkt_TakeOnWithDischarge THEN
   SETEMPTY(SLKind.dSLKind);
  END;
  REPLACE(SLKind);
 END {SLKind_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE SLKind_dSLKind_OnSuccessfulChange();
 BEGIN
  SEARCH(SLKind, SLKind, , SLKind.dSLKind);
  L_General.Assert(SLKind.Type = L_Staff.slkt_Discharge, "  㢮쭥");
  L_General.Assert(SLKind.IsGodRsn, "ਥ ᫥ 㢮쭥  㢠⥫쭮 稭?");
 END {SLKind_dSLKind_OnSuccessfulChange};

 PRIVATE PROCEDURE SLKind_IsGodRsn_OnSuccessfulChange();
 BEGIN
  IF ~SLKind.IsGodRsn & SELECT(SLKind, dSLKind, SLKind.SLKind) THEN
   L_General.Error(" 㢮쭥 ᯮ  '㢮쭥/ਥ' " + SLKind.SLKind +
                   "|쭥   ⮫쪮  㢠⥫쭮 稭");
  END;
 END {SLKind_IsGodRsn_OnSuccessfulChange};

 PRIVATE PROCEDURE SLKindE_0_OnReposition();
 BEGIN
  IF OCCURE(SLKind) THEN
   SLKindE_SetFields();
  END;
 END {SLKindE_0_OnReposition};

 PRIVATE PROCEDURE SLKind_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow(1, "SLKindE");
  L_WDO.iField    (1, "SLKind.Type").Format:=L_Staff.slkt_Pool;
 END {SLKind_OnInitializeWindow};

 PRIVATE PROCEDURE SLKindE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["SLKind.Type", "SLKind.dSLKind", "SLKind.IsGodRsn"]);
  L_WDO.iUnmodifiable(0, ["TextForGoodRs", "TextForChgLbc", "TextForIsAct", "TypeForIsTemp"]);
  L_WDO.iMayBeEmpty  (0, ["SLKind.LCA_SPrg", "SLKind.LCA_Prg", "SLKind.LCA_Part", "SLKind.NormAct", "SLKind.LCA_No", "SLKind.Till"]);
  L_WDO.iField       (0, "SLKind.Type").Format:=L_Staff.slkt_Pool;
 END {SLKindE_OnInitializeWindow};

BEGIN
 L_Events.ExecuteHandler();
END.
