(*
%Copyright   (c) Polak IT
%Author      14.08.2002 17:06:45 LDA
%Purpose      ࠡ祣 ६
%Type        report
%Specific    SYS
%Modified    24.07.2014 15:26:45 POLAK\LDA
%Environment
*)

 MODULE SLRXX [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_OwnData, L_SysLog, L_DatTim, L_AFM, L_Str, L_XDoc, L_DBD, L_StdFrm,
        Str, SysLog, Math, DBD, L_APtm, FIO, L_Basis;

 PRIVATE CONST
  other_Object = "祥";
  other_Mnp    = MAXOF(SYSLOG.Mnp) + 1;

  fld_None      = "None";
  Ed_RepName    = "EditD";
  Title         = " ࠡ  㬥⠬";

 PRIVATE VAR
  RepName: STRING[];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|                     ࠡ祣 ६ 짮⥫                     |
|                     ਮ  ##########  ##########                    |
|============================================================================|
}
*)

(*
$P{ UserLine:
Tmp.User, L, ""
@
|짮⥫ #######################################                        |
|----------------------------------------------------------------------------|
|       |ꥪ                                        ||ᥣ,  |
|---------------|----------------------------------------------|---|---------|
}
*)

 PRIVATE PROCEDURE GetTmpMnpAsStr(): STRING[];
 BEGIN
  IF Tmp.Mnp = other_Mnp THEN
   RETURN "稥 ⢨";
  ELSE
   RETURN L_Str.PoolItem("⠢||", Tmp.Mnp);
  END;
 END {GetTmpMnpAsStr};

(*
$P{ Line:
GetTmpMnpAsStr(), L, ""
?, L, ""
?, R, "0"
?, R, "3."
@
|###############|##############################################|###|#########|
}
*)

(*
$P{ Dlm:
@
|------------------------------------------------------------------|---------|
}
*)

(*
$P{ TotalLine:
?, L, ""
?, R, "3."
@
|##################################################################|#########|
|============================================================================|
}
*)

(*
$P{ Bot:
?, R, "3."
@
| ⮣  ਮ:                                                 |#########|
=(c) Polak====================================================================
}
*)


 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "६ 䠩", "");

  CreateFIELD(Tmp, User,   LIKE(SYSLOG.User),   "", "",  "", "짮⥫", "");
  CreateFIELD(Tmp, Mnp,    SCAL[MAXOF(SYSLOG.Mnp)+2], "", "",  "", " 樨", "");
  CreateFIELD(Tmp, Object, LIKE(SYSLOG.Object), "", "",  "", "ꥪ", "");
  CreateFIELD(Tmp, Date,   DATE,                "", "",  "", "", "");
  CreateFIELD(Tmp, BTime,  TIME,                "", "",  "", "६ 砫", "");
  CreateFIELD(Tmp, BSec,   LIKE(SYSLOG.BSec),   "", "",  "", "㭤 砫", "");
  CreateFIELD(Tmp, ETime,  TIME,                "", "",  "", "६ 砭", "");
  CreateFIELD(Tmp, ESec,   LIKE(SYSLOG.ESec),   "", "0", "", "㭤 砭", "");
  CreateFIELD(Tmp, Comment,LIKE(SYSLOG.Comment),"", "",  "", "਩", "");

  CreateINDEX(Tmp, Tmp,   PLURAL, "", "", User, Date, BTime);
  CreateINDEX(Tmp, User,  PLURAL, "", "", User, Date, Object, Mnp, BTime, ETime);
  CreateINDEX(Tmp, TmpSL, PLURAL, "", "", User, Mnp, Date, BTime, BSec);
  CreateINDEX(Tmp, SL1,   PLURAL, "", "", Date, BTime, BSec);

  SetVersionOfFILE(Tmp, 0);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE GetBorder(VAR BegWorkTime,
                                 EndWorkTime : TIME);
 BEGIN
  SAVE(Tmp);
  CHANGESEL(Tmp, Tmp, , Tmp.User, Tmp.Date);
  FIRST(Tmp);
  BegWorkTime:=Tmp.BTime;
  LAST(Tmp);
  EndWorkTime:=Tmp.ETime;
  RESTORE(Tmp);
 END {GetBorderAndFullWorkTime};

 PRIVATE PROCEDURE PrintRep();
  VAR
   Interval,
   TotalTime,
   TotalTime_ByDay,
   TotalTime_ByUser,
   FullWorkTime     : FLOAT;
   MnpAmount        : NUMERIC[0];
   BegWorkTime,
   EndWorkTime      : TIME;
 BEGIN
  TotalTime:=0;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  SELECT(Tmp, User);
  WHILE OCCURE(Tmp) DO
   CHANGESEL(Tmp, User, , Tmp.User);
   MAKEPART(R, UserLine);
   TotalTime_ByUser:=0;
   WHILE OCCURE(Tmp) DO
    CHANGESEL(Tmp, User, , Tmp.User, Tmp.Date);
    TotalTime_ByDay:=0;
    WHILE OCCURE(Tmp) DO
     PROMPT(" "+Tmp.User+" "+L_DatTim.DateStr(Tmp.Date));
     CHANGESEL(Tmp, User, , Tmp.User, Tmp.Date, Tmp.Object);
     WHILE OCCURE(Tmp) DO
      MnpAmount:=0;
      Interval :=0;
      CHANGESEL(Tmp, User, , Tmp.User, Tmp.Date, Tmp.Object, Tmp.Mnp);
      WHILE OCCURE(Tmp) DO
       INC(MnpAmount);
       INC(Interval, ((Tmp.ETime - Tmp.BTime) + (Tmp.ESec - Tmp.BSec) / (60*60)));
       NEXT(Tmp);
      END; (* WHILE OCCURE(Tmp) ... *)
      INC(TotalTime_ByDay, Interval);
      LAST(Tmp);
      MAKEPART(R, Line, L_SysLog.GetObjectDescription(Tmp.Object), MnpAmount, Interval);
      CHANGESEL(Tmp, User, , Tmp.User, Tmp.Date, Tmp.Object);
      NEXT(Tmp);
     END; (* WHILE OCCURE(Tmp) ... *)
     LAST(Tmp);
     CHANGESEL(Tmp, User, , Tmp.User, Tmp.Date);
     NEXT(Tmp);
    END; (* WHILE OCCURE(Tmp) ... *)
    INC(TotalTime_ByUser, TotalTime_ByDay);
    LAST(Tmp);
    GetBorder(BegWorkTime, EndWorkTime);
    MAKEPART(R, Dlm);
    MAKEPART(R, TotalLine, "६ ࠡ  "+L_DatTim.DateStr(Tmp.Date)+
                           "  " +L_DatTim.TimeStr(BegWorkTime)+
                           "  "+L_DatTim.TimeStr(EndWorkTime),
                           TotalTime_ByDay);
    CHANGESEL(Tmp, User, , Tmp.User);
    NEXT(Tmp);
   END; (* WHILE OCCURE(Tmp) ... *)
   INC(TotalTime, TotalTime_ByUser);
   LAST(Tmp);
   MAKEPART(R, TotalLine, "ᥣ  ࠡ⭨:",
                           TotalTime_ByUser);
   CHANGESEL(Tmp, User);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, Bot, TotalTime);
  CLOSEREP(R);
 END {PrintRep};

 PRIVATE PROCEDURE sl_FullETime(): NUMERIC[0];
 BEGIN
  RETURN ((SYSLOG.ETime<SYSLOG.BTime)*24+(SYSLOG.ETime-00:00))*60*60 + (SYSLOG.ESec);
 END {sl_FullETime};

 PRIVATE PROCEDURE PutTmp(_Mnp: SCAL[other_Mnp+1]; _Object: LIKE(SYSLOG.Object));
 BEGIN
  Tmp.User   :=SYSLOG.User;
  Tmp.Mnp    :=_Mnp;
  Tmp.Date   :=SYSLOG.Date;
  Tmp.Object :=_Object;
  Tmp.Comment:=SYSLOG.Comment;
  Tmp.BTime  :=SYSLOG.BTime;
  Tmp.BSec   :=SYSLOG.BSec;
  Tmp.ETime  :=SYSLOG.ETime;
  Tmp.ESec   :=SYSLOG.ESec;
  INSERT(Tmp);
 END {PutTmp};

 PRIVATE PROCEDURE GatherBySingleUser();
  VAR
   curETime: NUMERIC[0];
 BEGIN
  IF SRCINSEL(SYSLOG, GE, Memo.ud_fr()) THEN
   WHILE OCCURE(SYSLOG) & (SYSLOG.Date <= Memo.ud_ut()) DO
    PROMPT(SYSLOG.User+" "+L_DatTim.DateStr(SYSLOG.Date));
    NARROWSEL(SYSLOG, Date);
    WHILE OCCURE(SYSLOG) DO
     IF (SYSLOG.Object # "Memo") THEN
      curETime:=sl_FullETime();
      IF (SYSLOG.Mnp = SysLog.Insert) |
         (SYSLOG.Mnp = SysLog.Edit  ) |
         (SYSLOG.Mnp = SysLog.Delete) THEN
       PutTmp(SYSLOG.Mnp, SYSLOG.Object);
      ELSE
       PutTmp(other_Mnp, other_Object);
      END;
      WHILE NEXT(SYSLOG) & (sl_FullETime() <= curETime) DO
      END; (* WHILE  *)
     ELSE
      NEXT(SYSLOG);
     END; (* IF *)
    END; (* WHILE OCCURE(SYSLOG) ... *)
    NEXTINEXTENDEDSEL(SYSLOG, Date);
   END; (* WHILE OCCURE(SYSLOG) & (SYSLOG.Date <= Memo.ud_ut())...*)
  END; (* IF *)
 END {GatherBySingleUser};

 PRIVATE PROCEDURE Make();
 BEGIN
  IF L_General.IsAdmin() THEN
   SELECT(SYSLOG, SYSLOG);
   WHILE OCCURE(SYSLOG) DO
    NARROWSEL(SYSLOG, User);
    PROMPT(SYSLOG.User);
    GatherBySingleUser();
    NEXTINEXTENDEDSEL(SYSLOG, User);
   END; (* WHILE OCCURE(SYSLOG) ... *)
  ELSE
   SELECT(SYSLOG, SYSLOG, , LOGINNAME());
   GatherBySingleUser();
  END;
 END {Make};

 PUBLIC PROCEDURE SLR00();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepName:="SLR00";
  Create_Tmp();
  Make();
  PrintRep();
  L_General.SurveyLastReport();
 END {SLR00};

(*
$P{ SL_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
###################################################################################### ########## #####
=#####=================================================================================================
|                          樨  ਮ  ##########  ##########                           |
}

$P{ SL_SubTop:
Tmp.User, L, ""
Tmp.Mnp, L, L_General.sle_Pool
@
|=====================================================================================================|
|######## #########################                                                                   |
|-----------------------------------------------------------------------------------------------------|
|      |६   |쥪          |ਨ                                                     |
|----------|--------|----------------|----------------------------------------------------------------|
}

$P{ SL_Line:
Tmp.Date, L, "D.N.y"
Tmp.BTime, L, "H:M"
Tmp.BSec, L, "0"
Tmp.Object, L, ""
Tmp.Comment, L, ""
@
|##########|#####:##|################|################################################################|
}

$P{ SL_Bot:
@
=(c) Polak=============================================================================================
}
*)

 PRIVATE PROCEDURE SL_PrepareTemp();
 BEGIN
  SELECT(SYSLOG, SYSLOG);
  WHILE OCCURE(SYSLOG) DO
   CHANGESEL(SYSLOG, SYSLOG, , SYSLOG.User);
   SRCINSEL(SYSLOG, GE, , Memo.ud_fr());
   WHILE OCCURE(SYSLOG) & (SYSLOG.Date <= Memo.ud_ut()) DO
    PROMPT(SYSLOG.User + " " + L_DatTim.DateStr(SYSLOG.Date));
    PutTmp(SYSLOG.Mnp, SYSLOG.Object);
    NEXT(SYSLOG);
   END; (* WHILE OCCURE(SYSLOG) ... *)
   LAST(SYSLOG);
   CHANGESEL(SYSLOG, SYSLOG);
   NEXT(SYSLOG);
  END; (* WHILE OCCURE(SYSLOG) ... *)
 END {SL_PrepareTemp};

 PRIVATE PROCEDURE SL_MakeReport();
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, SL_Top);
  SELECT(Tmp, TmpSL);
  WHILE OCCURE(Tmp) DO
   CHANGESEL(Tmp, TmpSL, , Tmp.User, Tmp.Mnp);
   MAKEPART(R, SL_SubTop);
   WHILE OCCURE(Tmp) DO
    PROMPT(Tmp.User + " " + Tmp.Mnp + " " + L_DatTim.DateStr(Tmp.Date));
    MAKEPART(R, SL_Line);
    NEXT(Tmp);
   END; (* WHILE OCCURE(Tmp) ... *)
   LAST(Tmp);
   CHANGESEL(Tmp, TmpSL);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, SL_Bot);
  CLOSEREP(R);
 END {SL_MakeReport};

 PUBLIC PROCEDURE SLR01();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepName:="SLR01";
  Create_Tmp();
  SL_PrepareTemp();
  SL_MakeReport();
  L_General.SurveyLastReport();
 END {SLR01};

(*
$P{ SL1_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
############################################################################################### ########## #####
=#####==========================================================================================================
|                          "" 樨  ਮ  ##########  ##########                           |
|--------------------------------------------------------------------------------------------------------------|
|ꥪ          |      |६   |짮.|ਨ                                                     |
|----------------|----------|--------|--------|----------------------------------------------------------------|
}

$P{ SL1_Line:
Tmp.Object, L, ""
Tmp.Date, L, "D.N.y"
Tmp.BTime, L, "H:M"
Tmp.BSec, L, "0"
Tmp.User, L, ""
Tmp.Comment, L, ""
@
|################|##########|#####:##|########|################################################################|
}

$P{ SL1_Bot:
@
=(c) Polak======================================================================================================
}

*)

 PRIVATE PROCEDURE SL1_PrepareTemp();
 BEGIN
  SELECT(SYSLOG, SYSLOG1, , SysLog.UserEvent);
  WHILE OCCURE(SYSLOG) DO
   CHANGESEL(SYSLOG, SYSLOG1, , SYSLOG.Mnp, SYSLOG.Object);
   SRCINSEL(SYSLOG, GE, , Memo.ud_fr());
   WHILE OCCURE(SYSLOG) & (SYSLOG.Date <= Memo.ud_ut()) DO
    PROMPT(SYSLOG.Object + " " + L_DatTim.DateStr(SYSLOG.Date));
    PutTmp(SYSLOG.Mnp, SYSLOG.Object);
    NEXT(SYSLOG);
   END; (* WHILE OCCURE(SYSLOG) ... *)
   LAST(SYSLOG);
   CHANGESEL(SYSLOG, SYSLOG1, , SYSLOG.Mnp);
   NEXT(SYSLOG);
  END; (* WHILE OCCURE(SYSLOG) ... *)
 END {SL1_PrepareTemp};

 PRIVATE PROCEDURE SL1_MakeReport();
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, SL1_Top);
  SELECT(Tmp, SL1);
  WHILE OCCURE(Tmp) DO
   PROMPT(L_DatTim.DateStr(Tmp.Date));
   MAKEPART(R, SL1_Line);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, SL1_Bot);
  CLOSEREP(R);
 END {SL1_MakeReport};

 PUBLIC PROCEDURE SLR02();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  RepName:="SLR02";
  Create_Tmp();
  SL1_PrepareTemp();
  SL1_MakeReport();
  L_General.SurveyLastReport();
 END {SLR02};

(*
$P{SLR03_Top1:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
}
*)

(*
$P{SLR03_Top2:
?, C, ""
@
|############################################################################################################|
}
*)

(*
$P{ SLR03_Text:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
}
*)

(*
$P{ SLR03_SubTop1:
SYSLOG_.BegDTS, L, "D.N.Y H:M:S"
?, R, ""
SYSLOG_.SYSLOG_, L, ""
@
|============================================================================================================|
|################# ############################################################################### ##########|
}
*)

(*
$P{ SLR03_SubTop2:
?, L, ""
@
|  ##########################################################################################################|
}
*)


(*
$P{ SLR03_ModTop:
@
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ SLR03_Line:
?, L, ""
?, L, ""
?, L, ""
@
|############################|#######################################|#######################################|
}
*)

(*
$P{ SLR03_XDJTop:
@
|------------------------------------------------------------------------------------------------------------|
|      |砫  |砭.|          |                                            |த|
|----------|--------|--------|------------------|----------------------------------------------------|-------|
}
*)

(*
$P{ SLR03_XDJLine:
XDocJrn.Date, L, "D.N.y"
XDocJrn.BegTime, L, "H:M"
FLDTOSTR(Math.Trunc(XDocJrn.BegSec), "L", 2), L, ""
XDocJrn.EndTime, L, "H:M"
FLDTOSTR(Math.Trunc(XDocJrn.EndSec), "L", 2), L, ""
XDocJrn.Action, L, L_XDoc.action_Pool
XDocJrn.AcsObj, L, ""
AcsObj.Name, L, ""
AcsObj.FullName, L, ""
?, R, ""
?, L, ""
@
|##########|#####:##|#####:##|##################|##### ############### ##############################|####:##|
}
*)

(*
$P{ SLR03_Bot1:
@
==============================================================================================================
}
*)

(*
$P{ SLR03_Bot2:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE MakePart(RecordCode,
                            RecordName,
                            Operation,
                            LinkedFieldCode,
                            LinkedFileName,
                            FieldDsc,
                            Value_BeforeModification,
                            Value_AfterModification  : STRING[]);
 BEGIN
  L_Basis.wb_WrDat("R", L_DatTim.GetDateOfTIMESTAMP(SYSLOG_.BegDTS));
  L_Basis.wb_WrTim("R", L_DatTim.GetTimeOfTIMESTAMP(SYSLOG_.BegDTS));
  L_Basis.wb_WrTim("R", L_DatTim.GetTimeOfTIMESTAMP(SYSLOG_.EndDTS));
  L_Basis.wb_WrNum("R", (SYSLOG_.EndDTS - SYSLOG_.BegDTS) * 24 * 60 * 60, 0);
  L_Basis.wb_WrStr("R", Operation);
  L_Basis.wb_WrScl("R", SYSLOG_.AcsObj);
  L_Basis.wb_WrStr("R", AcsObj.Name);
  L_Basis.wb_WrStr("R", AcsObj.FullName);
  L_Basis.wb_WrStr("R", RecordCode);
  L_Basis.wb_WrStr("R", RecordName);
  L_Basis.wb_WrStr("R", LinkedFileName);
  L_Basis.wb_WrScl("R", LinkedFieldCode);
  L_Basis.wb_WrStr("R", FieldDsc);
  L_Basis.wb_WrStr("R", Value_BeforeModification);
  L_Basis.wb_WrStr("R", Value_AfterModification);

  L_Basis.wb_TermLine("R");
 END {MakePart};

 PRIVATE PROCEDURE GetObjValueOfCurrentRec(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SAVE(SYSLOGD);
  IF SELECT(SYSLOGD, SYSLOG_, SYSLOG_.SYSLOG_) &
     LAST(SYSLOGD) &
     L_SysLog.IsTerminatingKind(SYSLOGD.Kind) THEN
   Result:=L_SysLog.GetFullDescr(SYSLOGD.SYSLOG_, SYSLOGD.SYSLOGD);
  ELSE
   Result:="";
  END;
  RESTORE(SYSLOGD);
  RETURN Result;
 END {GetObjValueOfCurrentRec};

 PRIVATE PROCEDURE ConvObjValueOfCurrentRec(): STRING[];
 BEGIN
  RETURN Str.Replace(GetObjValueOfCurrentRec(), "|", ", ");
 END {ConvObjValueOfCurrentRec};

 PRIVATE PROCEDURE GetSysLogDKind(): LIKE(SYSLOGD.Kind);
 BEGIN
  SELECT(SYSLOGD, SYSLOG_, , SYSLOG_.SYSLOG_);
  LAST(SYSLOGD);
  RETURN SYSLOGD.Kind;
 END {GetSysLogDKind};

 PRIVATE PROCEDURE GetKind_asStr(): STRING[];
 BEGIN
  RETURN L_Str.PoolItem(L_SysLog.knd_Pool, GetSysLogDKind());
 END {GetKind_asStr};

 PRIVATE TYPE
  tFormat = SCAL[2];

 PRIVATE CONST
  f_REP = 0;
  f_XLS = 1;

 PRIVATE VAR
  FindRecordsInSYSLOG_: SCAL[2];

 PRIVATE PROCEDURE AddTo_SysL();
 BEGIN
  IF SYSLOG_.tmpRcCnt = 0 THEN
   ADD(_SysL, _SysL, , SYSLOG_.SYSLOG_);
   FindRecordsInSYSLOG_:=1;
  END;
 END {AddTo_SysL};

 PRIVATE PROCEDURE SLR03_Fill_SysLByCurSelect(Format: tFormat);
 BEGIN
  IF Format = f_XLS THEN
   SRCINSEL(SYSLOG_, LE, , Memo.ud_ut());
  ELSE
   LAST(SYSLOG_);
  END;
  WHILE OCCURE(SYSLOG_) & ((Format = f_REP) | (SYSLOG_.Date >= Memo.ud_fr())) DO
   PROMPT(SYSLOG_.SYSLOG_);
   AddTo_SysL();
   PREV(SYSLOG_);
  END; (* WHILE OCCURE(SYSLOG_) ... *)
 END {SLR03_Fill_SysLByCurSelect};

 PRIVATE PROCEDURE SLR03_Fill_SysL(_fiLend      : LIKE(SYSLOG_.fiLend);
                                   _riLend      : LIKE(SYSLOG_.riLend);
                                   FileId       : LIKE(SYSLOG_.fiOwn);
                                   ObjValue     : STRING[];
                                   Format       : tFormat;
                                   Force_woRecId: SCAL[2]);
 BEGIN
  IF ~Force_woRecId | ~OCCURE(SYSLOG_) THEN
   SELECT(SYSLOG_, Lend, , _fiLend, _riLend);
   IF Format = f_XLS THEN
    SRCINSEL(SYSLOG_, LE, , Memo.ud_ut());
   ELSE
    LAST(SYSLOG_);
   END;
  END;
  WHILE OCCURE(SYSLOG_) & ((Format = f_REP) | (SYSLOG_.Date >= Memo.ud_fr())) DO
   PROMPT(SYSLOG_.SYSLOG_);
   IF (FileId = SYSLOG_.fiOwn) & (ObjValue = GetObjValueOfCurrentRec()) THEN
    AddTo_SysL();
   END;
   PREV(SYSLOG_);
  END; (* WHILE OCCURE(SYSLOG_) ... *)
 END {SLR03_Fill_SysL};

 PRIVATE PROCEDURE SLR03_IndexOneFile(File, ObjValue: STRING[]; Format: tFormat; Force_woRecId: SCAL[2]);
  VAR
   FileId: LIKE(SYSLOG_.fiOwn);
   RecId : LIKE(SYSLOG_.riOwn);
   LName : STRING[];
 BEGIN
  FileId:=DBD.FileNameToId(File);
  IF ~Force_woRecId & DBD.FieldExist(^File, RECORDID) THEN
   RecId :=^File.RECORDID;
   SELECT(SYSLOG_, Own, ,  FileId, RecId);
   SLR03_Fill_SysLByCurSelect(Format);
   SELECT(SYSLOG_, Lend, , FileId, RecId);
   SLR03_Fill_SysLByCurSelect(Format);
  ELSE
   L_SysLog.GetLendWithRECORDID(File, LName, RecId);
   IF ~!RecId THEN
    SLR03_Fill_SysL(DBD.FileNameToId(LName), RecId, FileId, ObjValue, Format, Force_woRecId);
   ELSE
    L_General.CallUs(Force_woRecId);
   END;
  END;
 END {SLR03_IndexOneFile};

 PRIVATE PROCEDURE SLR03_MakeRep_CurSel(CurFile, ObjValue: STRING[]; Format: tFormat);
  VAR
   Table      : TABLE;
   Field      : FIELD;
   Operation,
   FileDescr,
   FieldDescr : STRING[];
   i          : NUMERIC[0];
   First      : SCAL[2];
   Head       : STRING[];
   RecordName : STRING[];
   SysLogDKind: LIKE(SYSLOGD.Kind);
 BEGIN
  IF DBD.FieldExist(^(CurFile), Name) THEN
   RecordName:=^(CurFile + ".Name");
  ELSE
   SETEMPTY(RecordName);
  END;
  LAST(_SysL);
  WHILE OCCURE(_SysL) DO
   PROMPT(_SysL.SYSLOG_);
   SEARCH(SYSLOG_, SYSLOG_, , _SysL.SYSLOG_);
   CONFORM(SYSLOG_, AcsObj);
   Table:=DATABASE.Get().TableById(SYSLOG_.fiOwn);
   IF ~!Table THEN
    FileDescr:=Table.Description;
   ELSE
    FileDescr:=SYSLOG_.Object + " (䠩   )";
   END;

   Operation  :=GetKind_asStr();
   Head       :=Operation+" "+AcsObj.Name+" ("+AcsObj.AcsObj+" ";
   Head       :=Head+Str.Slice(AcsObj.FullName, 0, 79-1-Str.Length(Head))+")";
   SysLogDKind:=GetSysLogDKind();
   IF Format = f_REP THEN
    MAKEPART(R, SLR03_SubTop1, Head);
   END;
   IF (Format = f_REP) & ((SysLogDKind = L_SysLog.knd_Insert) | (SysLogDKind = L_SysLog.knd_AutoBuild)) THEN
    MAKEPART(R, SLR03_Text, "⠢   " + FileDescr + " (" + ConvObjValueOfCurrentRec() + ")");
   ELSE
    MAKEPART(R, SLR03_SubTop2, "'" + ConvObjValueOfCurrentRec() + "' ("+ FileDescr + ")");
    First:=1;
    SELECT(SYSLOGD, SYSLOG_, , SYSLOG_.SYSLOG_);
    WHILE OCCURE(SYSLOGD) & ~L_SysLog.IsTerminatingKind(SYSLOGD.Kind) DO
     FieldDescr:="   ";
     IF ~!Table THEN
      Field:=Table.FieldById(SYSLOGD.FieldId);
      IF ~!Field THEN
       FieldDescr:=Field.Description;
      END;
     END;
     IF First THEN
      IF Format = f_REP THEN
       MAKEPART(R, SLR03_ModTop);
      END;
      First:=0;
     END;
     IF SYSLOGD.FieldIdx # 0 THEN
      FieldDescr:=Str.Slice(FieldDescr, 0, 28-4)+"["+FLDTOSTR(SYSLOGD.FieldIdx, "", 2)+"]";
     END;
     IF Format = f_REP THEN
      MAKEPART(R, SLR03_Line, FieldDescr,
                              L_Str.CutLongStr(L_SysLog.GetFieldValue_BeforeModification(SYSLOG_.SYSLOG_, SYSLOGD.SYSLOGD), 41),
                              L_Str.CutLongStr(L_SysLog.GetFieldValue_AfterModification(SYSLOG_.SYSLOG_, SYSLOGD.SYSLOGD), 41));
     ELSE
      MakePart(ObjValue,
               RecordName,
               Operation,
               ConvObjValueOfCurrentRec(),
               FileDescr,
               FieldDescr,
               L_SysLog.GetFieldValue_BeforeModification(SYSLOG_.SYSLOG_, SYSLOGD.SYSLOGD),
               L_SysLog.GetFieldValue_AfterModification(SYSLOG_.SYSLOG_, SYSLOGD.SYSLOGD));
     END;
     NEXT(SYSLOGD);
    END; (* WHILE OCCURE(SYSLOGD) ... *)
   END; (* IF GetSysLogDKind() = L_SysLog.knd_Insert...*)
   PREV(_SysL);
  END; (* WHILE OCCURE(_SysL) ... *)
 END {SLR03_MakeRep_CurSel};

 PRIVATE PROCEDURE SLR03_MakeRep(File, ObjValue: STRING[]; Format: tFormat);
 BEGIN
  IF SELECT(_SysL, _SysL) THEN
   SLR03_MakeRep_CurSel(File, ObjValue, Format);
  ELSE
   IF Format = f_REP THEN
    MAKEPART(R, SLR03_Text, "ୠ஢ 䨪樨 ,     ୠ .");
   END;
  END;
 END {SLR03_MakeRep};

 PRIVATE PROCEDURE SLR03_MakeJrn(File, ObjValue: STRING[]);
  VAR
   IsLast  : SCAL[2];
   XDocType: L_XDoc.tXDocType;
   XDocKind: L_XDoc.tXDocKind;
   XDoc    : L_XDoc.tXDoc;
   Duration: NUMERIC[0];
 BEGIN
  XDocType:=L_XDoc.GetFileXDT(File);
  MAKEPART(R, SLR03_Top1, "SLR03");
  MAKEPART(R, SLR03_Top2, "ୠ 権  裡  㬥⮬");
  MAKEPART(R, SLR03_Top2, "'" + L_SysLog.GetObjectDescription(File) + "' " + Str.Replace(ObjValue, "|", ", "));
  IF ~!XDocType & L_XDoc.XDocTypeHasXDocJrn(XDocType) THEN
   L_XDoc.DecodeXDocId(L_XDoc.curXDocId(XDocType), XDocType, XDocKind, XDoc);
   MAKEPART(R, SLR03_XDJTop);
   SELECT(XDocJrn, XDocJrn, , XDocType, XDocKind, XDoc);
   LAST(XDocJrn);
   IsLast:=1;
   WHILE OCCURE(XDocJrn) DO
    CONFORM(XDocJrn, AcsObj);
    IF ~!XDocJrn.EndTime THEN
     Duration:=(XDocJrn.EndTime - XDocJrn.BegTime) * 60 * 60 + XDocJrn.EndSec - XDocJrn.BegSec;
     MAKEPART(R, SLR03_XDJLine, Math.Div(Duration, 60), L_Str.FixedIntStr(Math.Mod(Duration, 60), 2));
    ELSE
     L_General.CallUs(IsLast);
    END;
    IsLast:=0;
    PREV(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)
  ELSE
   MAKEPART(R, SLR03_Text, "ୠ஢ 権  裡  묨 㬥⠬  .");
  END;
  MAKEPART(R, SLR03_Bot1);
 END {SLR03_MakeJrn};

 PRIVATE PROCEDURE SLR03_Make(File, ObjectDescription, ObjValue: STRING[]; Format: tFormat);
 BEGIN
  IF Format = f_REP THEN
   MAKEPART(R, SLR03_Top2, "祭 䨪権  䠩");
   MAKEPART(R, SLR03_Top2, "'" + L_SysLog.GetObjectDescription(File) + "' " + Str.Replace(ObjValue, "|", ", "));
   MAKEPART(R, SLR03_Top2, " 易   ᥩ 㣨 䠩");
  END;
  IF L_APtm.TakedInSysLog(File) THEN
   L_AFM.MakeIndex("_SysL", "SYSLOG_: LIKE(SYSLOG_.SYSLOG_)");
   SLR03_IndexOneFile(File, ObjValue, Format, 0);
   SLR03_MakeRep(File, ObjValue, Format);
   IF (Format = f_REP ) & DBD.FieldExist(^File, RECORDID) THEN
    IF SELECT(_SysL, _SysL) THEN
     SEARCH(SYSLOG_, SYSLOG_, , _SysL.SYSLOG_);
     CHANGESEL(SYSLOG_, Lend);
     NARROWSEL(SYSLOG_, fiLend, riLend);
     PREV(SYSLOG_);
    ELSE
     SETSEL(SYSLOG_, Lend);
    END;
    REMSEL(_SysL);
    SLR03_IndexOneFile(File, ObjValue, Format, 1);
    IF SELECT(_SysL, _SysL) THEN
     MAKEPART(R, SLR03_Top2, L_Str.Repeat("=", 108));
     MAKEPART(R, SLR03_Top2, "祭 䨪権  ७ 䨪樨 ");
     MAKEPART(R, SLR03_Top2, "(ᢥ  ᮤঠ 筮)");
     SLR03_MakeRep(File, ObjValue, Format);
    END;
   END;
   L_AFM.AF_PurgeTemp("_SysL");
  ELSE
   IF Format = f_REP THEN
    MAKEPART(R, SLR03_Text, "ୠ஢ 䨪樨  .");
   END;
  END;
  IF Format = f_REP THEN
   MAKEPART(R, SLR03_Bot2);
  END;
 END {SLR03_Make};

 PUBLIC PROCEDURE SLR03();
  CONST
   RepName = "SLR03";
  VAR
   CurFile,
   ObjValue: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  CurFile:=L_General.GetCurWinMasterTable();
  L_General.Assert(ACCESS(^CurFile), " ⠭ ꥪ");
  ObjValue:=L_DBD.GetPrimaryIndexValue(CurFile);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  SLR03_MakeJrn(CurFile, ObjValue);
  SLR03_Make   (CurFile, L_SysLog.GetObjectDescription(CurFile), ObjValue, f_REP);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {SLR03};

 PRIVATE PROCEDURE MakeHeader();
 BEGIN
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_WrInQM("R", "砫");
  L_Basis.wb_WrInQM("R", "砭");
  L_Basis.wb_WrInQM("R", "த⥫쭮");
  L_Basis.wb_WrInQM("R", "");
  L_Basis.wb_WrInQM("R", " 짮⥫");
  L_Basis.wb_WrInQM("R", " 짮⥫");
  L_Basis.wb_WrInQM("R", " 짮⥫");
  L_Basis.wb_WrInQM("R", "  ࠢ筨");
  L_Basis.wb_WrInQM("R", "  ࠢ筨");
  L_Basis.wb_WrInQM("R", " 䠩");
  L_Basis.wb_WrInQM("R", "   䠩");
  L_Basis.wb_WrInQM("R", "  ()");
  L_Basis.wb_WrInQM("R", "祭  ");
  L_Basis.wb_WrInQM("R", "祭 ᫥ ");

  L_Basis.wb_TermLine("R");
 END {MakeHeader};

 PUBLIC PROCEDURE SLR04();
  CONST
   RepName = "SLR04";
  VAR
   CurFile,
   PrimIndex,
   ObjValue,
   ObjectDescription: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  CurFile:=L_General.GetCurWinMasterTable();
  ObjectDescription:=L_SysLog.GetObjectDescription(CurFile);
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeHeader();
  PrimIndex:=L_DBD.GetPrimaryIndex(CurFile);
  FindRecordsInSYSLOG_:=0;
  SELECT(^CurFile, ^PrimIndex);
  WHILE OCCURE(^CurFile) DO
   ObjValue:=L_DBD.GetIndexValue(CurFile, PrimIndex);
   PROMPT(ObjValue);
   SLR03_Make(CurFile, ObjectDescription, ObjValue, f_XLS);
   NEXT(^CurFile);
  END; (* WHILE OCCURE(^CurFile) ... *)
  FIO.Close(R);
  IF FindRecordsInSYSLOG_ THEN
   L_Basis.PlayMakedRunTimeRep(RepName,
                               L_General.timeCond_InIntvl,
                               "  ࠢ筨 '" + DBD.FileDescription(^CurFile) + "'  易    㣨 䠩" ,
                               0);
  ELSE
   L_StdFrm.Inform("  ࠢ筨 '"+ ObjectDescription + "'  ਮ  " +
                   L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut()) + "  ");
  END;
 END {SLR04};

(*
$P{ TopDelRs:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
?, L, "D.N.y"
?, L, "D.N.y"
?, L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                                                                                             |
|############################################################################################################|
|                                     ਮ  ##########  ##########                                    |
|------------------------------------------------------------------------------------------------------------|
|짮⥫                      |/६         |#####################################################|
|----------------------------------|-------------------|-----------------------------------------------------|
}
*)

(*
$P{ LineDelRs:
AcsObj.Name,     L, ""
AcsObj.FullName, L, ""
SYSLOG_.BegDTS,  L, "D.N.y H:M:S"
SYSLOGD.Descr,   L, ""
@
|######## #########################|###################|#####################################################|
}
*)

(*
$P{ BotDelRs:
@
=(c) Polak====================================================================================================
}
*)

 PUBLIC PROCEDURE DelRs();
  CONST
   RepName = "DelRs";
  VAR
   Index,
   CurFile,
   IndDescr: STRING[];
   BegD,
   EndD    : DATE;
   Fields  : INDEXFIELDS;
   i       : NUMERIC[0];
 BEGIN
  CurFile:=L_General.GetCurWinMasterTable();
  Index  :=L_DBD.GetPrimaryIndex(CurFile);
  Fields :=TABLE.Get(CurFile).Indexes(Index).Fields;
  SETEMPTY(IndDescr);
  i:=0;
  WHILE i < Fields.Count DO
   IF ~!IndDescr THEN
    INC(IndDescr, ", ");
   END;
   INC(IndDescr, Fields(i).Description);
   INC(i);
  END;
  BegD:=Memo.ud_fr();
  EndD:=Memo.ud_ut();
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, TopDelRs, RepName, " 䠩 '" + DBD.FileDescription(^CurFile) + "'", BegD, EndD, IndDescr);
  SELECT(SYSLOG_, SYSLOG_1, , CurFile);
  SRCINSEL(SYSLOG_, GE, , BegD);
  WHILE OCCURE(SYSLOG_) & (SYSLOG_.Date <= EndD) DO
   SETSEL(SYSLOGD, SYSLOG_, SYSLOG_.SYSLOG_);
   LAST(SYSLOGD);
   PROMPT(L_DatTim.TimestampStr(SYSLOG_.BegDTS));
   IF SYSLOGD.Kind = L_SysLog.knd_Delete THEN
    CONFORM(SYSLOG_, AcsObj);
    MAKEPART(R, LineDelRs);
   END;
   NEXT(SYSLOG_);
  END; (* WHILE OCCURE(SYSLOG_) ... *)
  MAKEPART(R, BotDelRs);
  CLOSEREP(R);
  LIKEMENU(Survey, "");
 END {DelRs};

END.
