(*
%Copyright   (c) Polak IT
%Author      15.12.2008 09:08:18 POLAK\LDA
%Purpose      㬥⮢  ᥪ  ⤥
%Type        report
%Specific    AP
%Modified    20.08.2013 18:14:04 POLAK\MLB
%Environment
*)

 MODULE Sort [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Staff, L_MSO, P_Firm, D_Staff, Memo, L_Events, L_Str,
        L_AR;

 PRIVATE PROCEDURE PrepareStaffObjects(D: DATE; Root: STRING[]);
 BEGIN
  PROMPT(Staff.TSN + ": ⮢ ");
  L_Staff.StaffFileFamily(D, D, Root);
  CONFORM(Staff, Man);
  L_MSO.wordSetVarsByFile_wPrefixE("Man",   Root + ".", ~OCCURE(Man));
 END {PrepareStaffObjects};

 PRIVATE PROCEDURE T7Prepare(D: DATE; byWhat: D_Staff.t_ofcSubject);
  VAR
   Root         : STRING[];
   Cnt          : NUMERIC[0];
   BasDuration,
   AddDuration  : NUMERIC[0];
   DurationAsStr: STRING[];
 BEGIN
  Root:="T7.";
  IF    byWhat = D_Staff.ofc_BySort THEN
   L_General.Assert(ACCESS(Sort), " ࠭ ࠧ");
   L_MSO.wordSetVar(Root + "Sort.ParentsName", L_Staff.Sort_ParentsName());
  ELSIF byWhat = D_Staff.ofc_All THEN
   L_MSO.wordSetVar(Root + "Sort.ParentsName", "");
  ELSE
   L_General.Error("  " + byWhat + "  ஥");
  END;
  L_MSO.wordSetVarsByFile_wPrefixE("Sort",   Root, ~OCCURE(Sort));

  D_Staff.Prepare_Stl01(L_General.timeCond_OnDate, byWhat, D_Staff.sld_Simple);
  L_AR.GrantRightsUnconditionally();
  Cnt:=0;
  SELECT(Stl01, Sort);
  WHILE OCCURE(Stl01) DO
   CHANGESEL(Stl01, Sort, , Stl01.Sort);
   WHILE OCCURE(Stl01) DO
    CONFORM(Stl01, Staff);
    Root:="T7L"+L_MSO.IndexStr(Cnt) + ".Staff";
    PrepareStaffObjects(D, Root);
    CONFORM(Stl01, Officer);
    CONFORM(Officer, AlType);
    IF OCCURE(AlType) THEN
     HISTCONF(D, AlType, AlTypeL);
     BasDuration:=AlTypeL.Duration[L_Staff.ati_Main];
     AddDuration:=AlTypeL.Duration[L_Staff.ati_HarmPwr]+
                  AlTypeL.Duration[L_Staff.ati_Continuity]+
                  AlTypeL.Duration[L_Staff.ati_UnNorm]+
                  AlTypeL.Duration[L_Staff.ati_Other];
     DurationAsStr:=L_Str.IntStr(BasDuration);
     IF AddDuration # 0 THEN
      DurationAsStr:=DurationAsStr + "+" + L_Str.IntStr(AddDuration);
     END;
    ELSE
     DurationAsStr:="";
    END;
    L_MSO.wordSetVar(Root + ".AlDuration",  DurationAsStr);
    INC(Cnt);
    NEXT(Stl01);
   END; (* WHILE OCCURE(Stl01) ... *)
   LAST(Stl01);
   CHANGESEL(Stl01, Sort);
   NEXT(Stl01);
  END; (* WHILE OCCURE(Stl01) ... *)
  D_Staff.Purge_Stl01();
  L_General.Assert(Cnt # 0, "   ࠡ⭨");
  L_MSO.SetWordTable("StaffList", Cnt);
  L_MSO.PutInTables:=L_MSO.Put_Values;
 END {T7Prepare};

 PRIVATE PROCEDURE MakeDoc(byWhat: D_Staff.t_ofcSubject);
  VAR
   D: DATE;
 BEGIN
  D:=Memo.ud_cd();
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_MSO.wordInitDocument(D);
  P_Firm.SetFirmDefaultData("Own", P_Firm.fomf(P_Firm.mf_Own), D, "");
  T7Prepare(D, byWhat);
  L_MSO.MakeWordDocument("T7", 1, L_MSO.PrpMode_ToDoc, "");
 END {MakeDoc};

 PUBLIC PROCEDURE T7ByAll();
 BEGIN
  MakeDoc(D_Staff.ofc_All);
 END {T7ByAll};

 PUBLIC PROCEDURE T7BySort();
 BEGIN
  MakeDoc(D_Staff.ofc_BySort);
 END {T7BySort};

BEGIN
 L_Events.ExecuteHandler();
END.
