(*
%Copyright   (c) Polak Computer System
%Author      28.04.2010 15:50:07 POLAK\MLB
%Purpose     ࠡ稪 ᮡ⨩  "ਡ ᯥ. ਭ஢"
%Type        operation
%Specific    SYS
%Modified    31.12.2013 12:19:34 POLAK\LDA
%Environment
*)

 MODULE SpcPrntr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT FIO, Str, L_General, L_Str, L_SES, L_Print, L_Events, L_WDO, L_Prop, L_StdFrm;

 PRIVATE PERMANENT VAR
  curAPPWidth,
  curAPPHeight: NUMERIC[0];

 PRIVATE PROCEDURE SpcPrntr_OnInitializeWindow();
 BEGIN
  IF ~L_StdFrm.wGUI() THEN
   L_WDO.iWindow().OnOpenWindow :=1;
   L_WDO.iWindow().OnCloseWindow:=1;
  END;
  L_WDO.iWindow().MNUFileName  :="SpcPrntr";
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit]);
  L_WDO.iField       (0, "FilePath_1").OnBeforeAsk:=1;
  L_WDO.iField       (0, "FilePath_0").OnBeforeAsk:=1;
  L_WDO.iScsChange   (0, ["PrinterName_0", "PrinterName_1", "PrinterName_2", "PrinterName_3", "PrinterName_4",
                          "PrinterName_5", "PrinterName_6", "PrinterName_7", "PrinterName_8",
                          "PaperTrayType_5", "PaperTrayType_6", "PaperTrayType_7"]);
  L_WDO.iMayBeEmpty  (0, ["PrinterName_0", "PrinterName_1", "PrinterName_2", "PrinterName_3", "PrinterName_4",
                          "PrinterName_5", "PrinterName_6", "PrinterName_7", "PrinterName_8",
                          "FilePath_0", "FilePath_1", "FileName_1", "PaperForm_2", "PaperForm_3",
                          "BandType_3", "ShtLft", "ShtTop",
                          "PaperTrayIdx_5", "PaperTrayIdx_6", "PaperTrayIdx_7",
                          "PaperTrayType_5", "PaperTrayType_6", "PaperTrayType_7"]);
  L_WDO.iProgs       (0, "SpcPrntr");
 END {SpcPrntr_OnInitializeWindow};

 PRIVATE PROCEDURE SpcPrntr_OnOpenWindow();
 BEGIN
  GE_APPWIN_SIZE(curAPPWidth, curAPPHeight);
  IF (curAPPWidth < L_General.MainWindowStandartWidth()) | (curAPPHeight < L_General.MainWindowStandartHeight()) THEN
   SE_APPWIN_SIZE(L_General.MainWindowStandartWidth(), L_General.MainWindowStandartHeight());
  END;
 END {SpcPrntr_OnOpenWindow};

 PRIVATE PROCEDURE SpcPrntr_OnCloseWindow();
 BEGIN
  IF (curAPPWidth < L_General.MainWindowStandartWidth()) | (curAPPHeight < L_General.MainWindowStandartHeight()) THEN
   SE_APPWIN_SIZE(curAPPWidth, curAPPHeight);
  END;
 END {SpcPrntr_OnCloseWindow};

 PRIVATE PROCEDURE wPrntr(PrinterType: L_Print.tPrinterType): SCAL[2];
 BEGIN
  IF    PrinterType = L_Print.pt_Default THEN
   RETURN 0;
  ELSIF L_WDO.GetEnvVarValue("wAllPrntr") # "False" THEN
   RETURN L_WDO.GetEnvVarValue("wPrntr" + "_" + L_Str.IntStr(PrinterType)) # "False";
  ELSE
   RETURN L_WDO.GetEnvVarValue("wPrntr" + "_" + L_Str.IntStr(PrinterType)) = "True";
  END;
 END {wPrntr};

 PRIVATE PROCEDURE FldName(Name: STRING[]; PrinterType: L_Print.tPrinterType): STRING[];
 BEGIN
  RETURN L_WDO.Fld_wIdx(Name, PrinterType);
 END {FldName};

 PRIVATE PROCEDURE SpcPrntr_AnyFilePath_OnBeforeAsk();
  VAR
   Path       : STRING[];
   PrinterType: L_Print.tPrinterType;
   ChooseDir  : CHOOSEFILEDIALOG;
   Zone       : FORM_ZONE;
 BEGIN
  Zone       :=RTI.Get().CurZone;
  PrinterType:=L_Prop.GetVideoFieldArrIdx(Zone.ActiveField.Name);
  Path       :=Zone.Fields(FldName("FilePath", PrinterType)).Value;
  IF !Path | ~FIO.DirExists(Path) THEN
   Path:=CHOOSEFILEDIALOG.NameMask_Drives;
  ELSE
   Path:=FIO.BuildPath("*.*", , Path);
  END;
  ChooseDir                     :=CHOOSEFILEDIALOG.Create(Path);
  ChooseDir.FilesAreAcceptable  :=0;
  ChooseDir.FoldersAreAcceptable:=1;
  Path:=ChooseDir.Deal();
  IF ~!Path THEN
   Zone.Fields(FldName("FilePath", PrinterType)).Value:=Path;
  END;
 END {SpcPrntr_AnyFilePath_OnBeforeAsk};

 PRIVATE PROCEDURE SpcPrntr_FilePath_0_OnBeforeAsk();
 BEGIN
  SpcPrntr_AnyFilePath_OnBeforeAsk();
 END {SpcPrntr_FilePath_0_OnBeforeAsk};

 PRIVATE PROCEDURE SpcPrntr_FilePath_1_OnBeforeAsk();
 BEGIN
  SpcPrntr_AnyFilePath_OnBeforeAsk();
 END {SpcPrntr_FilePath_1_OnBeforeAsk};

 PRIVATE PROCEDURE GetPaperTrayIdxModifiable(PaperTrayType: L_Print.tPaperTrayType;
                                             PrinterType  : L_Print.tPrinterType): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF PaperTrayType = L_Print.ptt_Specified THEN
   Result:=wPrntr(PrinterType);
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {GetPaperTrayIdxModifiable};

 PRIVATE PROCEDURE SetFieldsModifiable(PrinterType: L_Print.tPrinterType);
  VAR
   Fields      : FORM_FIELDS;
   PrinterName : STRING[];
   wPrinterType: SCAL[2];
 BEGIN
  Fields     :=RTI.Get().CurZone.Fields;
  Fields("ShtLft").Modifiable:=wPrntr(L_Print.pt_Doc2Blank) & ~!Fields(FldName("PrinterName", L_Print.pt_Doc2Blank)).Value;
  Fields("ShtTop").Modifiable:=Fields("ShtLft").Modifiable;
  PrinterName :=Fields(FldName("PrinterName", PrinterType)).Value;
  wPrinterType:=wPrntr(PrinterType) & ~!PrinterName;
  IF    PrinterType = L_Print.pt_PDF THEN
   Fields(FldName("FilePath",      PrinterType)).Modifiable:=wPrinterType;
  ELSIF PrinterType = L_Print.pt_Image THEN
   Fields(FldName("FilePath",      PrinterType)).Modifiable:=wPrinterType;
   Fields(FldName("FileName",      PrinterType)).Modifiable:=wPrinterType;
  ELSIF PrinterType = L_Print.pt_Stick THEN
   Fields(FldName("PaperForm",     PrinterType)).Modifiable:=wPrinterType;
  ELSIF PrinterType = L_Print.pt_Cheque THEN
   Fields(FldName("BandType",      PrinterType)).Modifiable:=wPrinterType;
   Fields(FldName("PaperForm",     PrinterType)).Modifiable:=wPrinterType;
  ELSIF L_Print.IsNormalPrinterType(PrinterType) THEN
   Fields(FldName("PaperTrayType", PrinterType)).Modifiable:=wPrinterType;
   Fields(FldName("PaperTrayIdx",  PrinterType)).Modifiable:=GetPaperTrayIdxModifiable(Fields(FldName("PaperTrayType", PrinterType)).Value, PrinterType) & ~!PrinterName;
  END;
 END {SetFieldsModifiable};

 PRIVATE PROCEDURE SetFieldTemplate(Field: FORM_FIELD; trgTemplate: STRING[]);
 BEGIN
  Field.Template        :=trgTemplate;
  Field.TemplateIsStrict:=1;
 END {SetFieldTemplate};

 PRIVATE PROCEDURE SpcPrntr_OnBeforeEdit();
  VAR
   PrinterList  : STRING[];
   PrinterType  : L_Print.tPrinterType;
   PaperForm,
   PrinterName,
   FilePath,
   FileName     : STRING[];
   BandType     : L_Print.tBandType;
   PaperTrayType: L_Print.tPaperTrayType;
   PaperTrayIdx : L_Print.tPaperTrayIdx;
   Fields       : FORM_FIELDS;
 BEGIN
  Fields     :=RTI.Get().CurZone.Fields;
  PrinterList:=L_Print.GetPrinterList();
  L_Print.GetBlankMargins(Fields("ShtLft").Value, Fields("ShtTop").Value);
  FOR_EACH PrinterType DO
   PrinterName                                           :=L_Print.GetPrinterName(PrinterType);
   Fields(FldName("PrinterName", PrinterType)).Value     :=PrinterName;
   Fields(FldName("PrinterName", PrinterType)).Modifiable:=wPrntr(PrinterType);
   SetFieldTemplate(Fields(FldName("PrinterName", PrinterType)), PrinterList);
   IF    L_Print.IsVirtualPrinterType(PrinterType) THEN
    IF ~!PrinterName THEN L_Print.GetPA_Virtual(PrinterType, PrinterName, FilePath, FileName);
    ELSE                  SETEMPTY(FilePath, FileName);
    END;
    Fields(FldName("FilePath",  PrinterType)).AskMode:=FORM_FIELD.AskMode_Manual;
    Fields(FldName("FilePath",  PrinterType)).Value  :=FilePath;
    IF PrinterType = L_Print.pt_Image THEN
     Fields(FldName("FileName",  PrinterType)).Value :=FileName;
    END;
   ELSIF PrinterType = L_Print.pt_Stick THEN
    IF ~!PrinterName THEN L_Print.GetPA_Stick(PrinterName, PaperForm);
    ELSE                  SETEMPTY(PaperForm);
    END;
    Fields(FldName("PaperForm", PrinterType)).Value:=PaperForm;
    SetFieldTemplate(Fields(FldName("PaperForm", PrinterType)), L_Print.pf_Stick_Pool);
   ELSIF PrinterType = L_Print.pt_Cheque THEN
    IF ~!PrinterName THEN L_Print.GetPA_Cheque(PrinterName, PaperForm, BandType);
    ELSE                  SETEMPTY(PaperForm, BandType);
    END;
    Fields(FldName("BandType",  PrinterType)).Format:=L_Print.bt_Pool;
    Fields(FldName("BandType",  PrinterType)).Value :=BandType;
    Fields(FldName("PaperForm", PrinterType)).Value :=PaperForm;
    SetFieldTemplate(Fields(FldName("PaperForm", PrinterType)), L_Print.pf_Cheque_Pool);
   ELSIF PrinterType = L_Print.pt_Pass THEN
    (* nothing *)
   ELSIF L_Print.IsNormalPrinterType(PrinterType) THEN
    IF ~!PrinterName THEN L_Print.GetPA_Normal(PrinterType, PrinterName, PaperTrayType, PaperTrayIdx);
    ELSE                  SETEMPTY(PaperTrayType, PaperTrayIdx);
    END;
    Fields(FldName("PaperTrayType", PrinterType)).Format:=L_Print.ptt_Pool;
    Fields(FldName("PaperTrayType", PrinterType)).Value :=PaperTrayType;
    Fields(FldName("PaperTrayIdx",  PrinterType)).Format:=L_Print.GetTrayList(PrinterName);
    Fields(FldName("PaperTrayIdx",  PrinterType)).Value :=L_Print.GetTrayIdxByNo(PrinterName, PaperTrayIdx);
   END;
   SetFieldsModifiable(PrinterType);
  END; (* FOR_EACH PrinterType ...*)
 END {SpcPrntr_OnBeforeEdit};

 PRIVATE PROCEDURE PA_Check(PrinterType: L_Print.tPrinterType; ItsOK: SCAL[2]);
 BEGIN
  L_General.Assert(ItsOK, "ਡ " + L_Print.PrinterTypeAsStr(PrinterType) + "     ६");
 END {PA_Check};

 PRIVATE PROCEDURE SpcPrntr_OnAfterEdit();
  VAR
   PrinterType  : L_Print.tPrinterType;
   trgValue,
   SESValId,
   PrinterName,
   TrayIdxAsStr,
   PaperForm,
   FilePath,
   FileName     : STRING[];
   BandType     : L_Print.tBandType;
   PaperTrayType: L_Print.tPaperTrayType;
   PaperTrayIdx : L_Print.tPaperTrayIdx;
   trgSbjIdType : L_SES.tSbjIdType;
   Fields       : FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_SES.PutValueAtCurTrn(L_SES.sit_Station, "Memo.ShtTop",  FLDTOSTR(Fields("ShtTop").Value));
  L_SES.PutValueAtCurTrn(L_SES.sit_Station, "Memo.ShtLft",  FLDTOSTR(Fields("ShtLft").Value));
  FOR_EACH PrinterType DO
   SETEMPTY(trgValue);
   PrinterName:=Fields(FldName("PrinterName", PrinterType)).Value;
   IF ~!PrinterName THEN
    PrinterName:=L_Print.TS_ScourSingle(PrinterName);
   END;
   IF    L_Print.IsVirtualPrinterType(PrinterType) THEN
    FilePath:=Fields(FldName("FilePath", PrinterType)).Value;
    IF    (PrinterType = L_Print.pt_Image) THEN
     FileName:=Fields(FldName("FileName", PrinterType)).Value;
    ELSIF (PrinterType = L_Print.pt_PDF) & ~!FilePath THEN
     FileName:="*.PDF";
    ELSE
     SETEMPTY(FileName);
    END;
    IF ~!PrinterName | ~!FilePath | ~!FileName THEN
     PA_Check(PrinterType, !PrinterName = !FilePath);
     L_General.Assert(FIO.DirExists(FilePath), "⠫ '" + FilePath + "'  ");
     trgValue:=L_Str.CheckPresenceSemicolon(PrinterName) + ";" +
               L_Str.CheckPresenceSemicolon(FilePath)    + ";" +
               L_Str.CheckPresenceSemicolon(FileName) ;
    END;
   ELSIF PrinterType = L_Print.pt_Stick THEN
    PaperForm:=Fields(FldName("PaperForm", PrinterType)).Value;
    IF ~!PrinterName | ~!PaperForm THEN
     PA_Check(PrinterType, !PrinterName = !PaperForm);
     trgValue:=L_Str.CheckPresenceSemicolon(PrinterName) + ";" +
               L_Str.CheckPresenceSemicolon(PaperForm) ;
    END;
   ELSIF PrinterType = L_Print.pt_Cheque THEN
    IF wPrntr(PrinterType) THEN
     PaperForm:=Fields(FldName("PaperForm", PrinterType)).Value;
     BandType :=Fields(FldName("BandType",  PrinterType)).Value;
     IF ~!PrinterName | ~!BandType | ~!PaperForm THEN
      PA_Check(PrinterType, (!PrinterName = !BandType) & (!PrinterName = !PaperForm));
      trgValue:=L_Str.CheckPresenceSemicolon(PrinterName) + ";" +
                L_Str.CheckPresenceSemicolon(BandType)    + ";" +
                L_Str.CheckPresenceSemicolon(PaperForm) ;
     END;
    END;
   ELSIF PrinterType = L_Print.pt_Pass THEN
    trgValue:=L_Str.CheckPresenceSemicolon(PrinterName);
   ELSIF L_Print.IsNormalPrinterType(PrinterType) THEN
    PaperTrayType:=Fields(FldName("PaperTrayType", PrinterType)).Value;
    PaperTrayIdx :=Fields(FldName("PaperTrayIdx",  PrinterType)).Value;
    SETEMPTY(TrayIdxAsStr);
    IF ~!PrinterName | ~!PaperTrayType THEN
     PA_Check(PrinterType, !PrinterName = !PaperTrayType);
     IF PaperTrayType = L_Print.ptt_Specified THEN
      L_General.Assert(~!PaperTrayIdx, " 㪠  ⪠ ਭ " + L_Print.PrinterTypeAsStr(PrinterType));
      TrayIdxAsStr:=L_Str.IntStr(L_Print.GetTrayNoByIdx(PrinterName, PaperTrayIdx));
     END;
     trgValue:=L_Str.CheckPresenceSemicolon(PrinterName)   + ";" +
               L_Str.CheckPresenceSemicolon(PaperTrayType) + ";" +
               L_Str.CheckPresenceSemicolon(TrayIdxAsStr) ;
    END;
   END;
   SESValId    :=L_Print.PrinterTypeSESValId(PrinterType);
   trgSbjIdType:=L_Print.PrinterTypeSESSbjIdType(PrinterType);
   IF ~!trgValue | L_SES.PosToSES(trgSbjIdType, SESValId) THEN
    L_SES.PutValueAtCurTrn(trgSbjIdType, SESValId, trgValue);
   END;
  END; (* FOR_EACH PrinterType ...*)
 END {SpcPrntr_OnAfterEdit};

 PRIVATE PROCEDURE SpcPrntr_AnyPrinterName_OnSuccessfulChange();
  VAR
   Fields     : FORM_FIELDS;
   TrayList   : STRING[];
   ActiveField: FORM_FIELD;
   PrinterType: L_Print.tPrinterType;
 BEGIN
  Fields     :=RTI.Get().CurZone.Fields;
  ActiveField:=RTI.Get().CurZone.ActiveField;
  PrinterType:=L_WDO.getCurFldIdx();
  IF    PrinterType = L_Print.pt_PDF THEN
   IF !ActiveField.Value THEN
    SETEMPTY(Fields(FldName("FilePath", PrinterType)).Value);
   END;
  ELSIF PrinterType = L_Print.pt_Image THEN
    IF !ActiveField.Value THEN
     SETEMPTY(Fields(FldName("FilePath", PrinterType)).Value,
              Fields(FldName("FileName", PrinterType)).Value);
    END;
  ELSIF PrinterType = L_Print.pt_Stick THEN
   IF !ActiveField.Value THEN
    SETEMPTY(Fields(FldName("PaperForm", PrinterType)).Value);
   END;
  ELSIF PrinterType = L_Print.pt_Cheque THEN
   IF !ActiveField.Value THEN
    SETEMPTY(Fields(FldName("PaperForm", PrinterType)).Value,
             Fields(FldName("BandType",  PrinterType)).Value);
   END;
  ELSIF PrinterType = L_Print.pt_Pass THEN
   (* nothing *)
  ELSIF L_Print.IsNormalPrinterType(PrinterType) THEN
   SETEMPTY(Fields(FldName("PaperTrayIdx", PrinterType)).Value);
   IF !ActiveField.Value THEN
    SETEMPTY(Fields(FldName("PaperTrayType", PrinterType)).Value);
    IF PrinterType = L_Print.pt_Doc2Blank THEN
     SETEMPTY(Fields("ShtLft").Value, Fields("ShtTop").Value);
    END;
   ELSE
    TrayList:=L_Print.GetTrayList(ActiveField.Value);
    Fields(FldName("PaperTrayIdx", PrinterType)).Format:=TrayList;
    IF ~!TrayList THEN
     Fields(FldName("PaperTrayType", PrinterType)).Value:=L_Print.ptt_Main;
    ELSE
     Fields(FldName("PaperTrayType", PrinterType)).Value:=L_Print.ptt_Manual;
    END;
   END;
  END;
  SetFieldsModifiable(PrinterType);
 END {SpcPrntr_AnyPrinterName_OnSuccessfulChange};

 PRIVATE PROCEDURE SpcPrntr_PrinterName_0_OnSuccessfulChange();
 BEGIN
  SpcPrntr_AnyPrinterName_OnSuccessfulChange();
 END {SpcPrntr_PrinterName_0_OnSuccessfulChange};

 PRIVATE PROCEDURE SpcPrntr_PrinterName_1_OnSuccessfulChange();
 BEGIN
  SpcPrntr_AnyPrinterName_OnSuccessfulChange();
 END {SpcPrntr_PrinterName_1_OnSuccessfulChange};

 PRIVATE PROCEDURE SpcPrntr_PrinterName_2_OnSuccessfulChange();
 BEGIN
  SpcPrntr_AnyPrinterName_OnSuccessfulChange();
 END {SpcPrntr_PrinterName_2_OnSuccessfulChange};

 PRIVATE PROCEDURE SpcPrntr_PrinterName_3_OnSuccessfulChange();
 BEGIN
  SpcPrntr_AnyPrinterName_OnSuccessfulChange();
 END {SpcPrntr_PrinterName_3_OnSuccessfulChange};

 PRIVATE PROCEDURE SpcPrntr_PrinterName_4_OnSuccessfulChange();
 BEGIN
  SpcPrntr_AnyPrinterName_OnSuccessfulChange();
 END {SpcPrntr_PrinterName_4_OnSuccessfulChange};

 PRIVATE PROCEDURE SpcPrntr_PrinterName_5_OnSuccessfulChange();
 BEGIN
  SpcPrntr_AnyPrinterName_OnSuccessfulChange();
 END {SpcPrntr_PrinterName_5_OnSuccessfulChange};

 PRIVATE PROCEDURE SpcPrntr_PrinterName_6_OnSuccessfulChange();
 BEGIN
  SpcPrntr_AnyPrinterName_OnSuccessfulChange();
 END {SpcPrntr_PrinterName_6_OnSuccessfulChange};

 PRIVATE PROCEDURE SpcPrntr_PrinterName_7_OnSuccessfulChange();
 BEGIN
  SpcPrntr_AnyPrinterName_OnSuccessfulChange();
 END {SpcPrntr_PrinterName_7_OnSuccessfulChange};

 PRIVATE PROCEDURE SpcPrntr_AnyPaperTrayType_OnSuccessfulChange();
  VAR
   Printer    : PRINTER;
   PrinterType: L_Print.tPrinterType;
 BEGIN
  PrinterType:=L_WDO.getCurFldIdx();
  IF    RTI.Get().CurZone.ActiveField.Value = L_Print.ptt_Specified THEN
   L_General.Assert(~!L_WDO.cField(FldName("PaperTrayIdx", PrinterType)).Format,
                    " 㤠 । ᯨ᮪ 㯭 ⪮ ਭ");
  ELSIF RTI.Get().CurZone.ActiveField.Value = L_Print.ptt_Manual THEN
   Printer:=PRINTERS.Create().Item(L_WDO.cField(FldName("PrinterName", PrinterType)).Value);
   L_General.Assert(~!Printer.ASBPrintSettings.ManualPaperTray, " ਭ  ⪠ 筮 ");
  ELSE
   SETEMPTY(L_WDO.cField(FldName("PaperTrayIdx", PrinterType)).Value);
  END;
  SetFieldsModifiable(PrinterType);
 END {SpcPrntr_AnyPaperTrayType_OnSuccessfulChange};

 PRIVATE PROCEDURE SpcPrntr_PaperTrayType_5_OnSuccessfulChange();
 BEGIN
  SpcPrntr_AnyPaperTrayType_OnSuccessfulChange();
 END {SpcPrntr_PaperTrayType_5_OnSuccessfulChange};

 PRIVATE PROCEDURE SpcPrntr_PaperTrayType_6_OnSuccessfulChange();
 BEGIN
  SpcPrntr_AnyPaperTrayType_OnSuccessfulChange();
 END {SpcPrntr_PaperTrayType_6_OnSuccessfulChange};

 PRIVATE PROCEDURE SpcPrntr_PaperTrayType_7_OnSuccessfulChange();
 BEGIN
  SpcPrntr_AnyPaperTrayType_OnSuccessfulChange();
 END {SpcPrntr_PaperTrayType_7_OnSuccessfulChange};

BEGIN
 L_Events.ExecuteHandler();
END.
