(*
%Copyright   (c) Polak IT
%Author      16.07.2004 09:56:56 POLAK\LDA
%Purpose     Support - ᯮ
%Type        control
%Specific    AP
%Modified    27.03.2014 18:48:48 POLAK\Bor
%Environment
*)

 MODULE SprtCrsp [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, FIO, P_Man, L_SprtCrsp, L_StdFrm, L_DatTim, L_General, L_Str, Shell, L_APEMl,
        L_EMail, L_XDoc, Str, L_XML, L_Prop, L_lsStore, L_OwnData, E_Utils, Memo,
        Math, L_HTTP, L_FIO, L_AcsPnt, P_OwnData, L_Msg, L_AR, L_WDO, L_ACL;

 PRIVATE CONST
  srt_Pool = "孨᪮ ॡ|  ";

 PRIVATE PERMANENT VAR
  ChoosenRequestT    : LIKE(SprtCrsp.RequestT);

 PRIVATE PROCEDURE E_SprtCrsp_IsAdvancedUser(): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.SprtCrsp_IsAdvancedUser);
  IF ~!Local THEN
   RETURN Local();
  ELSE
   RETURN 0;
  END;
 END {E_SprtCrsp_IsAdvancedUser};

 PRIVATE PROCEDURE GetRootAttachmentsFolder(): STRING[];
  VAR
   AttachmentsFolder: STRING[];
 BEGIN
  AttachmentsFolder:=FIO.AsbSpecialFolders("SupportAttachments");
  IF !AttachmentsFolder THEN
   AttachmentsFolder:=FIO.BuildPath("SprtAttchmnts", , FIO.AsbSpecialFolders("ClientProjectRoot"));
  END;
  RETURN L_FIO.MakeDir(AttachmentsFolder);
 END {GetRootAttachmentsFolder};

 PRIVATE PROCEDURE GetAttachmentsFolder(): STRING[];
 BEGIN
  RETURN FIO.FullPath(FIO.BuildPath(SprtCrsp.SprtCrsp, , GetRootAttachmentsFolder()));
 END {GetAttachmentsFolder};

 PRIVATE PROCEDURE GetToSendFolder(): STRING[];
  VAR
   ts_Folder: STRING[];
 BEGIN
  ts_Folder:=FIO.AsbSpecialFolders("sca_ToSend");
  IF !ts_Folder THEN
   ts_Folder:=FIO.BuildPath("ToSend", , GetRootAttachmentsFolder());
  ELSE
   ts_Folder:=FIO.FullPath(ts_Folder);
  END;
  RETURN L_FIO.MakeDir(ts_Folder);
 END {GetToSendFolder};

 PRIVATE PROCEDURE GetFullAttachmentPath(): STRING[];
 BEGIN
  RETURN FIO.BuildPath(SprtCrsA.Attchmnt, , GetAttachmentsFolder());
 END {GetFullAttachmentPath};

 PRIVATE PROCEDURE _GetPureFileName(FullFileName, RootFolder: STRING[]): STRING[];
 BEGIN
  RETURN Str.Delete(FIO.UNCPath(FullFileName), 0, Str.Length(FIO.UNCPath(RootFolder))+1);
 END {_GetPureFileName};

 PRIVATE PROCEDURE GetPureFileName(FullFileName: STRING[]): STRING[];
 BEGIN
  RETURN _GetPureFileName(FullFileName, GetAttachmentsFolder());
 END {GetPureFileName};

 PRIVATE PROCEDURE SprtCrsAFileExists(_Attchmnt: STRING[]): SCAL[2];
 BEGIN
  SELECT(SprtCrsA, SprtCrsp, , SprtCrsp.SprtCrsp);
  WHILE OCCURE(SprtCrsA) DO
   IF _Attchmnt = SprtCrsA.Attchmnt THEN
    RETURN 1;
   END;
   NEXT(SprtCrsA);
  END; (* WHILE OCCURE(SprtCrsA) ... *)
  RETURN 0;
 END {SprtCrsAFileExists};

 PRIVATE PROCEDURE FillSprtCrsA(DirPath: STRING[]; VAR Amount: NUMERIC[0]);
  VAR
   File                   : OBJECT;
   ShortFileName          : STRING[];
   AttachmentFolder       : FOLDERENTRY;
   AttachmentFolderContent: ENUMERATOR;
 BEGIN
  IF FIO.DirExists(DirPath) THEN
   AttachmentFolder       :=FOLDERENTRY.Create(DirPath);
   AttachmentFolderContent:=CreateENUMERATOR(AttachmentFolder.FolderContent);
   WHILE ~AttachmentFolderContent.AtEnd() DO
    File:=AttachmentFolderContent.Item();
    IF ~File.Attributes.Directory THEN
     ShortFileName:=GetPureFileName(File.Path);
     IF ~SprtCrsAFileExists(ShortFileName) THEN
      DEFAULT(SprtCrsA);
      SprtCrsA.SprtCrsp:=SprtCrsp.SprtCrsp;
      SprtCrsA.Attchmnt:=ShortFileName;
      INSERT(SprtCrsA);
      INC(Amount);
     END;
    ELSE
     FillSprtCrsA(File.Path, Amount);
    END;
    AttachmentFolderContent.MoveNext();
   END; (* WHILE ~AttachmentFolderContent.AtEnd...*)
  END;
 END {FillSprtCrsA};

 PRIVATE PROCEDURE SprtType(Upper: SCAL[2]): STRING[];
  VAR
   Res: STRING[];
 BEGIN
  Res:=L_Str.PoolItem("|  ", L_SprtCrsp.IsAddition());
  IF Upper THEN
   Res:=Str.Cap(Res, 0, 1);
  END;
  RETURN Res;
 END {SprtType};

 PRIVATE PROCEDURE HasNewFilesInToSendFolder(ToSendFolder: FOLDERENTRY): SCAL[2];
  VAR
   File               : OBJECT;
   ToSendFolderContent: ENUMERATOR;
 BEGIN
  ToSendFolderContent:=CreateENUMERATOR(ToSendFolder.FolderContent);
  WHILE ~ToSendFolderContent.AtEnd() DO
   File:=ToSendFolderContent.Item();
   IF ~File.Attributes.Directory THEN
    IF ~SprtCrsAFileExists(L_FIO.effp_FileName(File.Path)) THEN
     RETURN 1;
    END;
   ELSE
    HasNewFilesInToSendFolder(FOLDERENTRY.Create(File.Path));
   END;
   ToSendFolderContent.MoveNext();
  END; (* WHILE ~ToSendFolderContent.AtEnd()...*)
  RETURN 0;
 END {HasNewFilesInToSendFolder};

 PRIVATE PROCEDURE GetSigleFolderFromToSendFolder(ToSendFolder: FOLDERENTRY; AlreadyInformAboutNewFiles: SCAL[2]);
  VAR
   File               : OBJECT;
   DstFileName,
   AttachmentsFolder  : STRING[];
   SrcFileName        : STRING[];
   ToSendFolderContent: ENUMERATOR;
   AttachmentsFolderAlreadyCreate: SCAL[2];
 BEGIN
  AttachmentsFolderAlreadyCreate:=0;
  ToSendFolderContent:=CreateENUMERATOR(ToSendFolder.FolderContent);
  IF ~ToSendFolderContent.AtEnd() & HasNewFilesInToSendFolder(ToSendFolder) THEN
   IF AlreadyInformAboutNewFiles | L_StdFrm.RedAlternative(" ᮤন ࠡ祣 ⠫ ToSend  " + SprtType(0) + "?") THEN
    AlreadyInformAboutNewFiles:=1;
    WHILE ~ToSendFolderContent.AtEnd() DO
     File:=ToSendFolderContent.Item();
     IF ~File.Attributes.Directory THEN
      IF ~AttachmentsFolderAlreadyCreate THEN
       AttachmentsFolder:=L_FIO.MakeDir(GetAttachmentsFolder());
      END;

      SrcFileName:=L_FIO.effp_FileName(File.Path);
      DstFileName:=FIO.BuildPath(SrcFileName, , AttachmentsFolder);
 
      IF ~FIO.Exists(DstFileName) THEN
       L_FIO.FileCopy(File.Path, DstFileName);
      END;
     ELSE
      GetSigleFolderFromToSendFolder(FOLDERENTRY.Create(File.Path), AlreadyInformAboutNewFiles);
     END;
     ToSendFolderContent.MoveNext();
    END; (* WHILE ~ToSendFolderContent.AtEnd()...*)
   END;
  END;
 END {GetSigleFolderFromToSendFolder};

 PRIVATE PROCEDURE intCopyFilesFromToSendFolder(Manual: SCAL[2]);
  VAR
   Amount           : NUMERIC[0];
   ToSendPath,
   AttachmentsFolder: STRING[];
 BEGIN
  ToSendPath:=GetToSendFolder();
  IF FIO.DirExists(ToSendPath) THEN
   GetSigleFolderFromToSendFolder(FOLDERENTRY.Create(ToSendPath), 0);
   Amount           :=0;
   AttachmentsFolder:=GetAttachmentsFolder();
   FillSprtCrsA(AttachmentsFolder, Amount);
   IF Manual & (Amount = 0) THEN
    L_StdFrm.RedInform("⠫ |" + AttachmentsFolder + "|");
   END;
  END;
 END {intCopyFilesFromToSendFolder};

 PUBLIC PROCEDURE CopyFilesFromToSendFolder();
 BEGIN
  intCopyFilesFromToSendFolder(1);
 END {CopyFilesFromToSendFolder};

 PRIVATE PROCEDURE GetdlDateFlagEdit(): SCAL[2];
 BEGIN
  RETURN SprtCrsp.DeadLine = L_SprtCrsp.dl_BySpecifiedDate;
 END {GetdlDateFlagEdit};

 PRIVATE PROCEDURE GetdlTimeFlagEdit(): SCAL[2];
 BEGIN
  RETURN (SprtCrsp.DeadLine = L_SprtCrsp.dl_Today) |
         (SprtCrsp.DeadLine = L_SprtCrsp.dl_BySpecifiedDate);
 END {GetdlTimeFlagEdit};

 PRIVATE PROCEDURE IsAlarmSprtCrsp(): SCAL[2];
 BEGIN
  RETURN SprtCrsp.RequestT = L_SprtCrsp.rt_Alarm;
 END {IsAlarmSprtCrsp};

 PRIVATE PROCEDURE SetPurposeCaption();
  VAR
   PurposeCaption: STRING[];
 BEGIN
  SETEMPTY(PurposeCaption);
  IF ~!SprtCrsp.RequestT THEN
   IF    SprtCrsp.RequestT = L_SprtCrsp.rt_TaskSolution THEN
    PurposeCaption:=" ஡ (!)  ";
   ELSIF IsAlarmSprtCrsp() THEN
    PurposeCaption:=" 稫";
   ELSIF SprtCrsp.RequestT = L_SprtCrsp.rt_Addition THEN
    PurposeCaption:=" ";
   END;
  END;
  IF ~!RTI.Get().CurZone.Fields("PurposeCaption") THEN
   RTI.Get().CurZone.Fields("PurposeCaption").Value:=PurposeCaption;
  END;
 END {SetPurposeCaption};

 PRIVATE PROCEDURE SprtCrsp_SetModifiable();
  VAR
   Fields      : FORM_FIELDS;
   IsAddition,
   scModifiable: SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  scModifiable:=(SprtCrsp.Status = L_SprtCrsp.st_Prepared) & (SprtCrsp.RequestT # L_SprtCrsp.rt_AutoBuild);
  IsAddition  :=L_SprtCrsp.IsAddition();
  Fields("SprtCrsp.Parent").Modifiable:=0;

  scModifiable:=scModifiable & ~!SprtCrsp.RequestT;
  IF (SprtCrsp.RequestT = L_SprtCrsp.rt_ErrorCorrection) |
     (SprtCrsp.RequestT = L_SprtCrsp.rt_AutoBuild)       THEN
   Fields("Action").Modifiable:=scModifiable;
   Fields("Object").Modifiable:=scModifiable;
   Fields("Prompt").Modifiable:=scModifiable;
  END;
  Fields("Purpose").Modifiable            :=scModifiable;
  Fields("SprtCrsp.Status").Modifiable    :=(SprtCrsp.Status = L_SprtCrsp.st_Prepared) | (SprtCrsp.Status = L_SprtCrsp.st_Canceled);
  Fields("SprtCrsp.Name").Modifiable      :=scModifiable;
  Fields("SprtCrsp.DeadLine").Modifiable  :=scModifiable & ~IsAddition & ~IsAlarmSprtCrsp();
  Fields("SprtCrsp.dlDate").Modifiable    :=scModifiable & GetdlDateFlagEdit() & ~IsAddition;
  Fields("SprtCrsp.dlTime").Modifiable    :=scModifiable & GetdlTimeFlagEdit() & ~IsAddition;
  Fields("SprtCrsp.dlTime").MustBeNonempty:=SprtCrsp.DeadLine # L_SprtCrsp.dl_BySpecifiedDate;

  Fields("SprtCrsp.Author").Modifiable    :=scModifiable & ~IsAlarmSprtCrsp();
  Fields("SprtCrsp.Customer").Modifiable  :=scModifiable & ~IsAlarmSprtCrsp();

  Fields("TextForParent").Visible         :=IsAddition;
  Fields("SprtCrsp.Parent").Visible       :=IsAddition;

  scModifiable:=~!SprtCrsp.AgrDate | IsAddition;
  Fields("SprtCrsp.AgrDate").Visible      :=scModifiable;
  Fields("SprtCrsp.AgrTime").Visible      :=scModifiable;
  Fields("SprtCrsp.AgrDate").Modifiable   :=scModifiable;
  Fields("SprtCrsp.AgrTime").Modifiable   :=scModifiable;
  Fields("TextForAgrDate").Visible        :=scModifiable;

  IF IsAlarmSprtCrsp() THEN
   Fields("Purpose").First          :=1;
  ELSE
   Fields("SprtCrsp.DeadLine").First:=~IsAddition;
   Fields("SprtCrsp.Name").First    :=IsAddition;
  END;
 END {SprtCrsp_SetModifiable};

 PRIVATE PROCEDURE SprtCrsp_OnBeforeEdIns(_Action: LIKE(XDocJrn.Action));
 BEGIN
  L_AcsPnt.PassAccessPoint(0000023);
  L_XDoc.XDocJrn_Start(L_XDoc.xdt_SprtCrsp, L_XDoc.EmptyXDocKind, SprtCrsp.SprtCrsp, _Action);
 END {SprtCrsp_OnBeforeEdIns};

 PRIVATE PROCEDURE SprtCrsp_OnBeforeEdit();
  VAR
   Fields  : FORM_FIELDS;
   FlagEdit: SCAL[2];
 BEGIN
  IF RTI.Get().CurWindow.OriginalName # "SprtCrspD" THEN
   SprtCrsp_OnBeforeEdIns(L_XDoc.action_Edit);
   IF IsUnrealDeadline(0) THEN
    SetDeadlineDT();
    FIXALTERING()
   END;
  ELSE
   Fields:=RTI.Get().CurZone.Fields;
   L_General.Assert(SprtCrsp.Status # L_SprtCrsp.st_Prepared, "ॡ  ࠢ");
   FlagEdit:=SprtCrsp.Status # L_SprtCrsp.st_Canceled;
   Fields("SprtCrsp.Status").Modifiable  :=FlagEdit;
   Fields("SprtCrsp.DoneType").Modifiable:=FlagEdit;
   Fields("SprtCrsp.AgrDate").Modifiable :=FlagEdit;
   Fields("SprtCrsp.AgrTime").Modifiable :=FlagEdit;
   Fields("SprtCrsp.FctDate").Modifiable :=SprtCrsp.Status = L_SprtCrsp.st_Done;

   Fields("Comment").Value:=L_lsStore.Get(SprtCrsp.Comment);

   IF FlagEdit & !SprtCrsp.AgrDate THEN
    SprtCrsp.AgrDate:=Deadline();
    REPLACE(SprtCrsp);
   END;

   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_SprtCrsp, L_XDoc.EmptyXDocKind, SprtCrsp.SprtCrsp, L_XDoc.action_begRcp);
  END;
 END {SprtCrsp_OnBeforeEdit};

 PRIVATE PROCEDURE StandOnParentSprt();
  VAR
   _SprtCrsp,
   _Parent  : LIKE(SprtCrsp.SprtCrsp);
 BEGIN
  IF L_SprtCrsp.IsAddition() THEN
   _SprtCrsp:=SprtCrsp.SprtCrsp;
   _Parent  :=SprtCrsp.Parent;
   L_General.CallUs(SEARCH(SprtCrsp, SprtCrsp, _Parent));
  END;
 END {StandOnParentSprt};

 PRIVATE PROCEDURE SprtCrsp_SyncAddition();
  VAR
   curSprtCrsp        : LIKE(SprtCrsp.SprtCrsp);
   _SprtCrsp          : LIKE(SprtCrsp.SprtCrsp);
   _Status            : LIKE(SprtCrsp.Status);
   _DoneType          : LIKE(SprtCrsp.DoneType);
   _dlDate            : LIKE(SprtCrsp.dlDate);
   _dlTime            : LIKE(SprtCrsp.dlTime);
   _AgrDate           : LIKE(SprtCrsp.AgrDate);
   _AgrTime           : LIKE(SprtCrsp.AgrTime);
   _DeadLine          : LIKE(SprtCrsp.DeadLine);
 BEGIN
  IF ~L_SprtCrsp.IsAddition() THEN
   _SprtCrsp:=SprtCrsp.SprtCrsp;
   _Status  :=SprtCrsp.Status;
   _DoneType:=SprtCrsp.DoneType;
   _dlDate  :=SprtCrsp.dlDate;
   _dlTime  :=SprtCrsp.dlTime;
   _AgrDate :=SprtCrsp.AgrDate;
   _AgrTime :=SprtCrsp.AgrTime;
   _DeadLine:=SprtCrsp.DeadLine;

   IF    _Status = L_SprtCrsp.st_Sent THEN
    SELECT(SprtCrsp, Parent, , _SprtCrsp);
    WHILE OCCURE(SprtCrsp) DO
     SprtCrsp.dlDate  :=_dlDate;
     SprtCrsp.dlTime  :=_dlTime;
     SprtCrsp.AgrDate :=_AgrDate;
     SprtCrsp.AgrTime :=_AgrTime;
     SprtCrsp.DeadLine:=_DeadLine;
     REPLACE(SprtCrsp);
     NEXT(SprtCrsp);
    END; (* WHILE OCCURE(SprtCrsp) ... *)
   ELSIF _Status = L_SprtCrsp.st_Done THEN
    SELECT(SprtCrsp, Parent, , _SprtCrsp);
    WHILE OCCURE(SprtCrsp) DO
     L_General.Assert(SprtCrsp.Status # L_SprtCrsp.st_Prepared,
                      " , ⠪     " + SprtCrsp.SprtCrsp + "|" +
                      "室  ﭨ " + L_Str.PoolItem(L_SprtCrsp.st_Pool, SprtCrsp.Status));
     IF (SprtCrsp.Status = L_SprtCrsp.st_Sent) | (SprtCrsp.Status = _Status) THEN
      SprtCrsp.Status  :=_Status;
      SprtCrsp.DoneType:=_DoneType;
     END;
     SprtCrsp.dlDate  :=_dlDate;
     SprtCrsp.dlTime  :=_dlTime;
     SprtCrsp.AgrDate :=_AgrDate;
     SprtCrsp.AgrTime :=_AgrTime;
     SprtCrsp.DeadLine:=_DeadLine;
     REPLACE(SprtCrsp);
     NEXT(SprtCrsp);
    END; (* WHILE OCCURE(SprtCrsp) ... *)
   END;
  END;
 END {SprtCrsp_SyncAddition};

 PRIVATE PROCEDURE HaveAgrDateTime(): SCAL[2];
 BEGIN
  RETURN ~!SprtCrsp.AgrDate & ((SprtCrsp.AgrDate # SprtCrsp.dlDate) | (SprtCrsp.AgrTime # SprtCrsp.dlTime));
 END {HaveAgrDateTime};

 PRIVATE PROCEDURE FillSprtDatTim(VAR D: DATE; VAR T: TIME);
 BEGIN
  IF HaveAgrDateTime() THEN
   D:=SprtCrsp.AgrDate;
   T:=SprtCrsp.AgrTime;
  ELSE
   D:=SprtCrsp.dlDate;
   T:=SprtCrsp.dlTime;
  END;
 END {FillSprtDatTim};

 PRIVATE PROCEDURE IsUnrealDeadline(Shift: FLOAT): SCAL[2];
  VAR
   _AgrDateTime: FLOAT;
   _dlTime     : TIME;
   _dlDate     : DATE;
 BEGIN
  IF ~!SprtCrsp.dlDate THEN
   SETEMPTY(_dlDate, _dlTime);
   FillSprtDatTim(_dlDate, _dlTime);
   IF ~!_dlTime THEN
    _AgrDateTime:=L_SprtCrsp.aps_GetLocalDatTime(_dlDate, _dlTime);
   ELSE
    _AgrDateTime:=L_SprtCrsp.aps_GetLocalDatTime(_dlDate - 1, L_SprtCrsp.aps_EndWork);
   END;
   RETURN _AgrDateTime + Shift < L_SprtCrsp.MinDeadline();
  END;
  RETURN 0;
 END {IsUnrealDeadline};

 PRIVATE PROCEDURE CheckDeadline(FinalCheck: SCAL[2]; Shift: FLOAT);
  VAR
   Msg: STRING[];
   dlD: DATE;
   dlT: TIME;
 BEGIN
  IF ~IsAlarmSprtCrsp() THEN
   Msg:="㦡 প ࠡ⠥  㤭  " + L_DatTim.TimeStr(L_SprtCrsp.aps_GetLocalTime(L_SprtCrsp.aps_BegWork)) +
        "  " + L_DatTim.TimeStr(L_SprtCrsp.aps_GetLocalTime(L_SprtCrsp.aps_EndWork)) + "." +
        "||   ᯮ  ࠭ " + L_DatTim.DTStampStr(L_SprtCrsp.MinDeadline()) + "." +
        "||  ப ᯮ ᫥ 㪠||ᮣᮢ ப ᯮ";
   IF L_SprtCrsp.IsAcceptableTimeForAlarm() THEN
    Msg:=Msg + "||᫨  㢥७,   ७ 砩 " +
               "|஡  筮,  饩 ⫠⥫," +
               "|᫥ ନ   'ॡ 筠 !'";
   END;
   IF IsUnrealDeadline(Shift) &
      (FinalCheck |
       (SprtCrsp.DeadLine # L_SprtCrsp.dl_BySpecifiedDate) & (SprtCrsp.DeadLine # L_SprtCrsp.dl_Today)) THEN

    SETEMPTY(dlD, dlT);
    FillSprtDatTim(dlD, dlT);
    IF ~!dlT THEN
     L_General.Error("⠭ ப ᯮ  " +
                     L_DatTim.DateTimeStr(dlD, dlT) + ".||" + Msg);
    ELSE
     L_General.Error("⠭ ப ᯮ  " +
                     L_DatTim.DateStr(dlD) + ".||" + Msg);
    END;

   END;
   IF FinalCheck & (SprtCrsp.DeadLine = L_SprtCrsp.dl_Immediately) &
      (L_DatTim.GetSysVARIANTDATE() + 31 / 60 / 24 < L_SprtCrsp.MinDeadline()) THEN
    L_StdFrm.Choice(Msg);
   END;
  ELSE
   L_General.Assert(L_SprtCrsp.IsAcceptableTimeForAlarm(),
                    "ࠢ   'ॡ 筠 !'|" +
                    " ६ 筮 ० ࠡ 㦡 প|" +
                    "( " + L_DatTim.TimeStr(L_SprtCrsp.aps_GetLocalTime(L_SprtCrsp.aps_EndWork)) + "  " +
                     L_DatTim.TimeStr(L_SprtCrsp.aps_GetLocalTime(L_SprtCrsp.aps_BegWork)) + ")|饭!||" +
                    " ଫ  ᯮ 묨 ⨯ .");

  END;
 END {CheckDeadline};

 PRIVATE PROCEDURE CheckParent();
  VAR
   _SprtCrsp  : LIKE(SprtCrsp.SprtCrsp);
   curSprtCrsp: LIKE(SprtCrsp.SprtCrsp);
 BEGIN
  curSprtCrsp:=SprtCrsp.SprtCrsp;
  _SprtCrsp  :=SprtCrsp.Parent;
  IF ~!_SprtCrsp THEN
   SAVE(SprtCrsp);
   StandOnParentSprt();
(*
   CheckDeadline(1, 10 / 24 / 60);
*)
   L_General.Assert(~L_SprtCrsp.IsAddition(), "  ,     ");
   L_General.Assert(SprtCrsp.Status = L_SprtCrsp.st_Sent, "  ⮫쪮    ﭨ 'ࠢ'");
   SELECT(SprtCrsp, Parent, , _SprtCrsp);
   WHILE OCCURE(SprtCrsp) DO
    IF (SprtCrsp.SprtCrsp # curSprtCrsp) &
       (SprtCrsp.Status = L_SprtCrsp.st_Prepared) THEN
     L_General.Error("  " + SprtCrsp.Parent + " 㦥  ⮢  " +
                     SprtCrsp.SprtCrsp + ". 㦭 ।஢ .");
    END;
    NEXT(SprtCrsp);
   END; (* WHILE OCCURE(SprtCrsp) ... *)
 
   RESTORE(SprtCrsp);
   SprtCrsp_SyncAddition();
  END;
 END {CheckParent};

 PRIVATE PROCEDURE CheckClientMaySendRequests();
 BEGIN
  IF L_General.GetAPSiteNumber() = 90 THEN
   L_General.Error(" ᫥ ଫ  ⮏ 殢");
  END;
 END {CheckClientMaySendRequests};

 PRIVATE PROCEDURE SprtCrsp_OnBeforeInsert();
  VAR
   _Parent  : LIKE(SprtCrsp.Parent);
   _dlDate  : LIKE(SprtCrsp.dlDate);
   _dlTime  : LIKE(SprtCrsp.dlTime);
   _AgrDate : LIKE(SprtCrsp.AgrDate);
   _AgrTime : LIKE(SprtCrsp.AgrTime);
   _DeadLine: LIKE(SprtCrsp.DeadLine);
 BEGIN
  CheckClientMaySendRequests();
  IF ChoosenRequestT = L_SprtCrsp.rt_Addition THEN
   IF !SprtCrsp.Parent THEN
    SprtCrsp.Parent:=GE_PVALUE(SprtCrsp.SprtCrsp);
    REPLACE(SprtCrsp);
   END;
   L_General.Assert(~!SprtCrsp.Parent, "⠢      ᮡ⢥ ");
   SAVE(SprtCrsp);
   WHILE ~!SprtCrsp.Parent DO
    L_General.CallUs(SEARCH(SprtCrsp, SprtCrsp, SprtCrsp.Parent));
   END;
   _Parent  :=SprtCrsp.SprtCrsp;
   _dlDate  :=SprtCrsp.dlDate;
   _dlTime  :=SprtCrsp.dlTime;
   IF HaveAgrDateTime() THEN
    _AgrDate :=SprtCrsp.AgrDate;
    _AgrTime :=SprtCrsp.AgrTime;
   ELSE
    _AgrDate :=SprtCrsp.dlDate;
    _AgrTime :=SprtCrsp.dlTime;
   END;
   _DeadLine:=SprtCrsp.DeadLine;
   RESTORE(SprtCrsp);
  ELSE
   SETEMPTY(_Parent, _dlDate, _dlTime, _AgrDate, _AgrTime, _DeadLine);
  END;
  SprtCrsp.Parent  :=_Parent;
  SprtCrsp.RequestT:=ChoosenRequestT;
  SprtCrsp.dlDate  :=_dlDate;
  SprtCrsp.dlTime  :=_dlTime;
  SprtCrsp.AgrDate :=_AgrDate;
  SprtCrsp.AgrTime :=_AgrTime;
  SprtCrsp.DeadLine:=_DeadLine;

  IF IsAlarmSprtCrsp() THEN
   SprtCrsp.DeadLine:=L_SprtCrsp.dl_Immediately;
   SETEMPTY(SprtCrsp.Author, SprtCrsp.Customer);
   SprtCrsp.Name   :="७ 맮 ";
   REPLACE(SprtCrsp);
  END;
  REPLACE(SprtCrsp);

  CheckParent();

  SprtCrsp.PrpDate :=SYSDATE();
  SprtCrsp.PrpTime :=SYSTIME();
  SprtCrsp.Status  :=L_SprtCrsp.st_Prepared;
  IF E_SprtCrsp_IsAdvancedUser() THEN
   SprtCrsp.Author:=L_SprtCrsp.GetAuthorName();
  END;
  REPLACE(SprtCrsp);

  SprtCrsp_SyncAddition();

  SprtCrsp_OnBeforeEdIns(L_XDoc.action_Insert);

  intCopyFilesFromToSendFolder(0);
 END {SprtCrsp_OnBeforeInsert};

 PRIVATE PROCEDURE GetItemFromPurpose(    _Purpose     : STRING[];
                                          begIdx       : NUMERIC[0];
                                      VAR Headers      : STRING[][];
                                          PurposeLength: NUMERIC[0]): STRING[];
  VAR
   Item   : STRING[];
   j,
   Pos,
   begPos,
   endPos : NUMERIC[0];
 BEGIN
  SETEMPTY(Item);
  begPos:=Str.Pos(_Purpose, Headers[begIdx]);
  endPos:=PurposeLength;
  IF begPos < PurposeLength THEN
   IF begIdx < HIGH(Headers) THEN
    j     :=0;
    endPos:=PurposeLength;
    LOOP
     IF j # begIdx THEN
      IF j > HIGH(Headers) THEN
       EXIT;
      END;
      Pos:=Str.Pos(_Purpose, Headers[j]);
      IF Pos > begPos THEN
       endPos:=Math.Min(endPos, Pos);
      END;
     END;
     INC(j);
    END; (* LOOP *)
    L_General.CallUs(endPos > begPos);
   END;
   begPos:=begPos + Str.Length(Headers[begIdx]);
   Item  :=Str.Condense(Str.Slice(_Purpose, begPos, endPos - begPos));
   IF (Str.Length(Item) > 2) & (Str.Slice(Item, Str.Length(Item) - 2, 2) = L_Str.CRLF) THEN
    Item:=Str.Delete(Item, Str.Length(Item) - 2, 2);
   END;
  END;
  RETURN Item;
 END {GetItemFromPurpose};

 PRIVATE PROCEDURE DecodeSprtCrsp(VAR trgAction, trgObject, trgPrompt, trgPurpose: STRING[]);
  VAR
   Headers      : STRING[][4];
   srcPurpose   : STRING[];
   PurposeLength: NUMERIC[0];
 BEGIN
  srcPurpose:=L_lsStore.Get(SprtCrsp.Purpose);
  IF (SprtCrsp.RequestT = L_SprtCrsp.rt_ErrorCorrection) |
     (SprtCrsp.RequestT = L_SprtCrsp.rt_AutoBuild)       THEN
   SETEMPTY(trgAction, trgObject, trgPrompt, trgPurpose);
   IF ~!srcPurpose THEN
    Headers[0]:=L_SprtCrsp.h_Action;
    Headers[1]:=L_SprtCrsp.h_Object;
    Headers[2]:=L_SprtCrsp.h_Prompt;
    Headers[3]:=L_SprtCrsp.h_Purpose;

    PurposeLength:=Str.Length(srcPurpose);
    trgAction :=GetItemFromPurpose(srcPurpose, 0, Headers, PurposeLength);
    trgObject :=GetItemFromPurpose(srcPurpose, 1, Headers, PurposeLength);
    trgPrompt :=GetItemFromPurpose(srcPurpose, 2, Headers, PurposeLength);
    trgPurpose:=GetItemFromPurpose(srcPurpose, 3, Headers, PurposeLength);
    IF !trgAction & !trgObject & !trgPrompt & !trgPurpose & ~!srcPurpose THEN
     trgPurpose:=srcPurpose;
    END;
   END;
  ELSE
   trgPurpose :=srcPurpose;
  END;
 END {DecodeSprtCrsp};

 PRIVATE PROCEDURE XMLPutUTC(SprtNode: L_XML.tNode; D: DATE; T: TIME; DateNode, TimeNode: STRING[]);
  VAR
   UTC: FLOAT;
 BEGIN
  IF ~!D & ~!T THEN
   LOCALTOUNIVERSALVARIANTTIME(UTC, L_DatTim.GetVARIANTDATE(D, T, 0));
   L_XML.bd_PutLeafNode(SprtNode, DateNode, L_DatTim.DateStr(L_DatTim.GetDateOfVARIANTDATE(UTC)));
   L_XML.bd_PutLeafNode(SprtNode, TimeNode, L_DatTim.TimeStr(L_DatTim.GetTimeOfVARIANTDATE(UTC)));
  ELSE
   IF !D THEN
    L_XML.bd_PutLeafNode(SprtNode, DateNode, "");
   ELSE
    L_XML.bd_PutLeafNode(SprtNode, DateNode, L_DatTim.DateStr(D));
   END;
   L_General.CallUs(!T);
   L_XML.bd_PutLeafNode(SprtNode, TimeNode, "");
  END;
 END {XMLPutUTC};

 PRIVATE PROCEDURE XML_PutSingleSprtCrsp(SprtNode: L_XML.tNode);
  VAR
   trgAction,
   trgObject,
   trgPrompt,
   trgPurpose: STRING[];
   SenderName: STRING[];
   ClientNick: STRING[2];
   trg_dlDate: DATE;
   trg_dlTime: TIME;
   curMan    : LIKE(Man.Man);
 BEGIN
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_SprtCrsp,          SprtCrsp.SprtCrsp);
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_Parent,            SprtCrsp.Parent);
  XMLPutUTC(SprtNode, SYSDATE(),        SYSTIME(),        L_SprtCrsp.xmln_Date,    L_SprtCrsp.xmln_Time);
  XMLPutUTC(SprtNode, SprtCrsp.PrpDate, SprtCrsp.PrpTime, L_SprtCrsp.xmln_PrpDate, L_SprtCrsp.xmln_PrpTime);
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_Subject,           SprtCrsp.Name);
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_RequestT,          L_Str.PoolItem(L_SprtCrsp.rt_Pool, SprtCrsp.RequestT));
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_DeadLine,          L_Str.PoolItem(L_SprtCrsp.dl_Pool, SprtCrsp.DeadLine));
  FillSprtDatTim(trg_dlDate, trg_dlTime);
  XMLPutUTC(SprtNode, trg_dlDate, trg_dlTime, L_SprtCrsp.xmln_dlDate, L_SprtCrsp.xmln_dlTime);
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_Author,            SprtCrsp.Author);
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_Customer,          SprtCrsp.Customer);
  curMan:=P_Man.Try_curUSER2Man();
  IF ~!curMan THEN
   SEARCH(Man, Man, , curMan);
   SenderName:=L_Str.ShortName(Man.Name);
  ELSE
   SenderName:=SprtCrsp.Author;
  END;
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_Sender,            SenderName);
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_SenderEMail,       L_APEMl.CurUserContact(0));
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_ReplyToType,       L_APEMl.ReplyToType());
  DecodeSprtCrsp(trgAction, trgObject, trgPrompt, trgPurpose);
  IF (SprtCrsp.RequestT = L_SprtCrsp.rt_ErrorCorrection) |
     (SprtCrsp.RequestT = L_SprtCrsp.rt_AutoBuild)       THEN
   L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_Action,           trgAction);
   L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_Object,           trgObject);
   L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_Prompt,           trgPrompt);
   L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_Purpose,          trgPurpose);
  ELSE
   L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_Purpose,          trgPurpose);
  END;
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_NormativeDocument, SprtCrsp.NormDoc);
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_Attachments,       GetAttachmentsList());
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_Version,           "5.2");
  IF L_General.IsPolakSpecific() THEN
   ClientNick:="PL";
  ELSE
   ClientNick:=DATABASE.Get().Name;
  END;
  L_XML.bd_PutLeafNode(SprtNode, L_SprtCrsp.xmln_Client,            ClientNick);
 END {XML_PutSingleSprtCrsp};

 PRIVATE PROCEDURE PrepareXML(): STRING[];
  VAR
   rootNode   : L_XML.tNode;
   XMLFileName: STRING[];
 BEGIN
  rootNode:=L_XML.bd_Create("Objective");
  L_XML.DoConvertRestrictedChars();
  XML_PutSingleSprtCrsp(L_XML.bd_PutNode(rootNode, L_SprtCrsp.xmln_SprtCrsp, ""));
  L_XML.bd_PutLeafNode(rootNode, "Amount",     L_Str.IntStr(1));
  XMLFileName:=L_FIO.tf_GetFullPath(SprtCrsp.SprtCrsp, "xml");
  L_XML.bd_Save(L_XML.bd_GetDocument(rootNode), XMLFileName);
  RETURN XMLFileName;
 END {PrepareXML};

 PRIVATE PROCEDURE ZipSingleAttachment(ZipFileName, FullFileName: STRING[]);
  VAR
   ZipFileSize: NUMERIC[3];
 BEGIN
  L_General.Assert(L_General.Launch_PKZIP("-add -max -dir=relative -attr=all -times=modify",
                   FullFileName,
                   ZipFileName) = L_General.eprc_Normal,
                   "訡  娢஢ 䠩 " + FullFileName + "|孨᪮ ॡ  ࠢ");
  FIO.Open(F, ZipFileName, , Input);
  ZipFileSize:=FIO.Size(F) / 1000000;
  FIO.Close(F);
  IF ZipFileSize>5 THEN
   FIO.Erase(ZipFileName);
   L_General.Error("誮 让 ࠧ  (zip) "+L_Str.NumericStr(ZipFileSize, 1) +" |ᨬ ࠧ           5.0 ");
  END;
 END {ZipSingleAttachment};

 PRIVATE PROCEDURE ZipAddAttach(ToFTP: SCAL[2]): STRING[];
  VAR
   ZipFileName: STRING[];
 BEGIN
  ZipFileName:=FIO.FullPath(FIO.BuildPath(DATABASE.Get().Name + "_TT_" + SprtCrsp.SprtCrsp, "zip", FIO.AsbSpecialFolders("ASBTemp")));
  SELECT(SprtCrsA, SprtCrsp, , SprtCrsp.SprtCrsp);
  WHILE OCCURE(SprtCrsA) DO
   ZipSingleAttachment(ZipFileName, FIO.BuildPath(SprtCrsA.Attchmnt, "", GetAttachmentsFolder()));
   NEXT(SprtCrsA);
  END; (* WHILE OCCURE(SprtCrsA) ... *)
  ZipSingleAttachment(ZipFileName, PrepareXML());

  RETURN ZipFileName;
 END {ZipAddAttach};

 PRIVATE PROCEDURE GetAttachmentsList(): STRING[];
  VAR
   FileList: STRING[];
 BEGIN
  SETEMPTY(FileList);
  CONFORM(SprtCrsp, SprtCrsA);
  WHILE OCCURE(SprtCrsA) DO
   FileList:=L_Str.AddStrDlm(FileList, ";") + SprtCrsA.Attchmnt;
   NEXT(SprtCrsA);
  END; (* WHILE OCCURE(SprtCrsA) ... *)
  RETURN FileList;
 END {GetAttachmentsList};

 PRIVATE PROCEDURE intAttachWholeSupportAttachmentsFolder(Silent: SCAL[2]);
  VAR
   AttachmentsFolder: STRING[];
   Amount           : NUMERIC[0];
 BEGIN
  AttachmentsFolder:=GetAttachmentsFolder();
  IF FIO.DirExists(AttachmentsFolder) THEN
   IF ~Silent THEN
    L_StdFrm.Question("  ᮤন ⠫|" + AttachmentsFolder + "| " + SprtType(0) + "?");
   END;
   SETZERO(Amount);
   FillSprtCrsA(AttachmentsFolder, Amount);
   IF Amount # 0 THEN
    IF ~Silent THEN
     L_StdFrm.Inform("  " + SprtType(0) + " 䠩: " + L_Str.IntStr(Amount));
    END;
   END;
  ELSE
   IF ~Silent THEN
    L_StdFrm.RedInform("⠫|" + AttachmentsFolder + "| ,  䠩  ᮥ  " + SprtType(0));
   END;
  END;

  CONFORM(SprtCrsp, SprtCrsA);
  WHILE OCCURE(SprtCrsA) DO
   IF ~FIO.Exists(GetFullAttachmentPath()) THEN
    REMOVE(SprtCrsA);
   ELSE
    NEXT(SprtCrsA);
   END;
  END; (* WHILE OCCURE(SprtCrsA) ... *)
 END {intAttachWholeSupportAttachmentsFolder};

 PRIVATE PROCEDURE SendCorrespondenceByEMail(fAddition: SCAL[2];
                                             _Subject : STRING[]): SCAL[2];
  VAR
   Result            : SCAL[2];
   FrContact,
   ToContact,
   SnContact         : L_EMail.tContact;
   Login,
   ZipFileName,
   AttachmentFileName: STRING[];
 BEGIN
  ZipFileName:=ZipAddAttach(0);
  IF ~L_General.IsOurEngineeringCopy() THEN
   IF ~fAddition & IsAlarmSprtCrsp() THEN
    ToContact:=L_EMail.AssembleContact("Polak: Alarm", "Alarm@Polak.ru");
   ELSE
    ToContact:=L_APEMl.APSupportContact();
   END;
  ELSE
   LOOP
    Login:=LOGINNAME();
    IF L_Str.IsEqStrI(Login, "SAN") THEN
     Login:="SLA";
    END;
 
    ToContact:=L_APEMl.AssembleOwnContact(FULLNAME(), Login);
    STDFORM(L_StdFrm.sf_Choice("| ⥫ %" + L_Str.Repeat("#", Str.Length(ToContact)) + "%|",
                               "%LYI"),
            "⮢ ࠢ  ",
            ,
            ,
            ToContact);
    IF !ToContact THEN
     IF L_StdFrm.Alternative(SprtType(1) + ":  㪠  ࠢ⥫.|| ﭨ  ࠢ?") THEN
      ToContact:=L_EMail.EmptyContact();
      EXIT;
     END;
    ELSE
     EXIT;
    END;
   END; (* LOOP *)
  END;
  IF ~L_EMail.IsEmptyContact(ToContact) THEN
   AttachmentFileName:=FIO.BuildPath(L_FIO.effp_FileName_woExt(ZipFileName), L_SprtCrsp.ZIPExtForGoogleMail, L_FIO.effp_Folder(ZipFileName));
   FIO.RenMov(ZipFileName, , AttachmentFileName);
   SnContact:=L_APEMl.CurUserContact(0);
   FrContact:=L_APEMl.ToSupportOwnFirmContact();
   L_APEMl.Send(ToContact, FrContact, SnContact, L_EMail.EmptyContact(), L_EMail.EmptyContact(),
                _Subject, AttachmentFileName, L_lsStore.Get(SprtCrsp.Purpose));
   Result:=1;
  ELSE
   Result:=0;
  END;
  IF ~!ZipFileName THEN
   FIO.Erase(ZipFileName);
  END;
  RETURN Result;
 END {SendCorrespondenceByEMail};

 PRIVATE PROCEDURE SendCorrespondenceToFTP(fAddition: SCAL[2]): SCAL[2];
  CONST
   PolakEngineeringFTPPath = "\\POLAKNT03\PRJ_CURRENTS\Journal\TXT\FTP\";
  VAR
   FTP,
   ZipFileName          : STRING[];
   ProductiveJournalCopy: SCAL[2];
 BEGIN
  ZipFileName:=ZipAddAttach(1);
  IF L_General.IsOurEngineeringCopy() THEN
   ProductiveJournalCopy:=0;
   STDFORM(L_StdFrm.sf_Choice("롮 ⥫            |"+
                              "%############################%|",
                              "%,2<ୠ  ୠ|  ୠ>O"),
           " ࠢ   FTP  ୮  ",
           ,
           ,
           ProductiveJournalCopy);
  ELSE
   ProductiveJournalCopy:=1;
  END;

  IF ProductiveJournalCopy THEN
(*
   IF ~L_General.IsOurSite() THEN
    FTP:="polak.ru";
   ELSE
    FTP:="ftp.polak.dom";
   END;
   L_HTTP.ftpPutFile(FTP, "ftpclient", "Y3/uLdyXxiU=", ZipFileName, "upload\Ingoing\");
*)
   FTP:="ftp://ftp.polak.nichost.ru";
   L_HTTP.ftpPutFile(FTP, "polak_AP_TT", "2gZG6A8Fbw3d5HX6HKQzUw==", ZipFileName, "\");
  ELSE
   L_FIO.FileCopy(ZipFileName, FIO.BuildPath(L_FIO.effp_FileName(ZipFileName), , PolakEngineeringFTPPath));
  END;
  IF ~!ZipFileName THEN
   FIO.Erase(ZipFileName);
  END;
  RETURN 1;
 END {SendCorrespondenceToFTP};

 PRIVATE PROCEDURE GetSprtCrspSendChannel(UseMainChannel: SCAL[2]): P_OwnData.tSprtCrspSendChannel;
  VAR
   SprtCrspSendChannel: P_OwnData.tSprtCrspSendChannel;
 BEGIN
  SprtCrspSendChannel:=P_OwnData.GetSprtCrspSendChannel(SYSDATE());
  IF ~UseMainChannel THEN
   SprtCrspSendChannel:=~SprtCrspSendChannel;
  END;
  RETURN SprtCrspSendChannel;
 END {GetSprtCrspSendChannel};

 PRIVATE PROCEDURE GetFolderFilesAmount(Folder: STRING[]): NUMERIC[0];
  VAR
   Result                 : NUMERIC[0];
   File                   : OBJECT;
   AttachmentFolder       : FOLDERENTRY;
   AttachmentFolderContent: ENUMERATOR;
 BEGIN
  SETZERO(Result);
  IF FIO.DirExists(Folder) THEN
   AttachmentFolder       :=FOLDERENTRY.Create(Folder);
   AttachmentFolderContent:=CreateENUMERATOR(AttachmentFolder.FolderContent);
   WHILE ~AttachmentFolderContent.AtEnd() DO
    File:=AttachmentFolderContent.Item();
    IF ~File.Attributes.Directory THEN
     INC(Result);
    ELSE
     INC(Result, GetFolderFilesAmount(File.Path));
    END;
    AttachmentFolderContent.MoveNext();
   END; (* WHILE ~AttachmentFolderContent.AtEnd...*)
  END;
  RETURN Result;
 END {GetFolderFilesAmount};

 PRIVATE PROCEDURE DeleteEmptySupportAttachmentsFolder();
  VAR
   AttachmentsFolder: STRING[];
 BEGIN
  AttachmentsFolder:=GetAttachmentsFolder();
  IF FIO.DirExists(AttachmentsFolder) & (GetFolderFilesAmount(AttachmentsFolder) = 0) THEN
   L_FIO.RemoveDir(AttachmentsFolder);
  END;
 END {DeleteEmptySupportAttachmentsFolder};

 PUBLIC PROCEDURE Send(UseMainChannel: SCAL[2]);
  VAR
   SubjName,
   _Subject   : STRING[];
   fAddition,
   SuccessSend: SCAL[2];
 BEGIN
  L_General.CallUs(ACCESS(SprtCrsp));
  fAddition:=L_SprtCrsp.IsAddition();
  SubjName :=L_Str.PoolItem(srt_Pool, fAddition);
  IF ~fAddition & IsAlarmSprtCrsp() THEN
   _Subject:=SprtCrsp.SprtCrsp;
  ELSE
   IF fAddition THEN
    _Subject:=" " + SprtCrsp.Parent + " (" + SprtCrsp.SprtCrsp + ") " + SprtCrsp.Name;
   ELSE
    _Subject:=" " + SprtCrsp.SprtCrsp + " " + SprtCrsp.Name;
   END;
  END;
  IF SprtCrsp.RequestT # L_SprtCrsp.rt_AutoBuild THEN
   intCopyFilesFromToSendFolder(0);
   intAttachWholeSupportAttachmentsFolder(1);
  END;
  DeleteEmptySupportAttachmentsFolder();
  IF GetSprtCrspSendChannel(UseMainChannel) = P_OwnData.scsc_FTP THEN
   SuccessSend:=SendCorrespondenceToFTP(fAddition);
  ELSE
   SuccessSend:=SendCorrespondenceByEMail(fAddition, _Subject);
  END;
  IF SuccessSend THEN
   SprtCrsp.Status:=L_SprtCrsp.st_Sent;
   REPLACE(SprtCrsp);
   L_XDoc.XDocJrn_Mark(L_XDoc.xdt_SprtCrsp, L_XDoc.EmptyXDocKind, SprtCrsp.SprtCrsp, L_XDoc.action_Sent);
   L_StdFrm.TimedINFORM(" | " + SubjName + " ᯥ譮 ࠢ|", 10);
  ELSE
   L_StdFrm.TimedINFORM_AsSTOP(" | " + SubjName + "  ࠢ!|", 10);
  END;

  IF SprtCrsp.RequestT # L_SprtCrsp.rt_AutoBuild THEN
   TRY
    L_FIO.ClearDir(GetToSendFolder());
   EXCEPT
   ON Exc: Exc_Root DO
    L_StdFrm.TimedINFORM_AsSTOP(" ⪥ ࠡ祩   ஡:||" + Exc.MsgOriginalText, 10);
   END; (* TRY *)
  END;
 END {Send};

 PUBLIC PROCEDURE SendAutoBuildSprtCrsp();
  CONST
   Text = " 㤠 ࠢ ⮬᪨ ⮢  ";
  VAR
   curSprtCrsp: LIKE(SprtCrsp.SprtCrsp);
   ErrorText  : STRING[];
 BEGIN
  PROMPT("ࠢ ⮬᪨ ⮢ ");
  TRY [TRANSACTION(TRANSACTION_SLAVE), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   SETSEL(SprtCrsp, PrpDate);
   LAST(SprtCrsp);
   WHILE OCCURE(SprtCrsp) & (SprtCrsp.PrpDate > (SYSDATE()-30)) DO
    IF (SprtCrsp.RequestT = L_SprtCrsp.rt_AutoBuild) &
       (SprtCrsp.Status   = L_SprtCrsp.st_Prepared)  THEN
     SAVE(SprtCrsp);
     TRY [TRANSACTION(TRANSACTION_SLAVE)]
      curSprtCrsp:=SprtCrsp.SprtCrsp;
      Send(1);
     EXCEPT
     ON Exc: Exc_Root DO
      L_General.CallUs(SEARCH(SprtCrsp, SprtCrsp, curSprtCrsp));
      IF (SprtCrsp.Status = L_SprtCrsp.st_Prepared)  &
         L_DatTim.TS2FL(L_DatTim.GetTIMESTAMP(SprtCrsp.PrpDate, SprtCrsp.PrpTime)) <= L_DatTim.TS2FL(SYSTIMESTAMP()-30/60/24) THEN
       SAVE(Message);
       IF ~SELECT(Message, RecordId, TABLE.Get("SprtCrsp").Id, SprtCrsp.RECORDID) THEN
        L_General.CallUs(L_AR.StandOnGroup(L_General.AdminGroupName()));
        ErrorText:=" ᮮ饭  ஡:" + L_Str.CRLF + Exc.Description + L_Str.CRLF + Exc.ProgramFile + "." + L_Str.IntStr(Exc.Row) + "." + L_Str.IntStr(Exc.Column) + " (" + L_Str.IntStr(Exc.ErrorCode) + ")";
        L_Msg.MakeCurRecordMsgFromRobot(AcsObj.AcsObj, "SprtCrsp", Text + SprtCrsp.SprtCrsp + "  " + L_DatTim.DateStr(SprtCrsp.PrpDate) + " " + L_DatTim.TimeStr(SprtCrsp.PrpTime) + L_Str.CRLF + ErrorText);
        L_Msg.NotifyCurMessage(1);
       END;
       RESTORE(Message);
      END;
     END; (* TRY *)
     RESTORE(SprtCrsp);
    END;
    PREV(SprtCrsp);
   END; (* WHILE OCCURE(SprtCrsp) ... *)
  EXCEPT
  END; (* TRY *)
 END {SendAutoBuildSprtCrsp};

 PUBLIC PROCEDURE SendCorrespondence(UseMainChannel, ManualSend: SCAL[2]);
  VAR
   SubjName : STRING[];
   fAddition: SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(SprtCrsp), " ࠭ ⥪饥 孨᪮ ॡ");

  fAddition:=L_SprtCrsp.IsAddition();
  SubjName :=L_Str.PoolItem(srt_Pool, fAddition);
  IF fAddition THEN
   SAVE(SprtCrsp);
   StandOnParentSprt();
   L_General.Assert(SprtCrsp.Status = L_SprtCrsp.st_Sent, "᭮  " + SprtCrsp.SprtCrsp + "    ﭨ 'ࠢ'");
   CheckDeadline(1, 0);
   RESTORE(SprtCrsp);
  ELSE
   CheckDeadline(1, 0);
  END;

  IF SprtCrsp.Status = L_SprtCrsp.st_Sent THEN
   L_StdFrm.CrucialChoice(SubjName + " 㦥 뫮 ࠢ.|ࠢ ୮?", L_General.AdminGroupName());
  ELSE
   L_General.Assert(SprtCrsp.Status = L_SprtCrsp.st_Prepared,
                    SubjName + "    ﭨ '⮢'");
  END;

  IF    ~fAddition & IsAlarmSprtCrsp() THEN
   L_StdFrm.Choice("७ 맮  ⮏");
  ELSIF ManualSend THEN
   L_StdFrm.Question("ࠢ " + Str.Small(SubjName, 0, 1) + "  㦡 প ⮏?||" +
                     " ࠢ : " + L_Str.PoolItem(P_OwnData.scsc_Pool, GetSprtCrspSendChannel(UseMainChannel)));
  END;
  Send(UseMainChannel);
 END {SendCorrespondence};

 PRIVATE PROCEDURE SprtCrsp_OnAfterEdIns();
  CONST
   MaxAlarmLength = 512;
  VAR
   React     : NUMERIC[0];
   Fields    : FORM_FIELDS;
   Dummy,
   SubjName,
   dstPurpose: STRING[];
   pAgrDate: LIKE(SprtCrsp.AgrDate);
   pAgrTime: LIKE(SprtCrsp.AgrTime);
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF SprtCrsp.RequestT = L_SprtCrsp.rt_ErrorCorrection THEN
   dstPurpose:=L_SprtCrsp.h_Action  + Fields("Action").Value + L_Str.CRLF +
               L_SprtCrsp.h_Object  + Fields("Object").Value + L_Str.CRLF +
               L_SprtCrsp.h_Prompt  + Fields("Prompt").Value + L_Str.CRLF +
               L_SprtCrsp.h_Purpose + Fields("Purpose").Value;
  ELSE
   dstPurpose:=Fields("Purpose").Value;
  END;
  IF SprtCrsp.RequestT = L_SprtCrsp.rt_Addition THEN
   SAVE(SprtCrsp);
   pAgrDate:=SprtCrsp.AgrDate;
   pAgrTime:=SprtCrsp.AgrTime;
   StandOnParentSprt();
   SprtCrsp.AgrDate:=pAgrDate;
   SprtCrsp.AgrTime:=pAgrTime;
   REPLACE(SprtCrsp);
   RESTORE(SprtCrsp);
  END;
  L_XDoc.XDocJrn_Stop(L_XDoc.xdt_SprtCrsp, L_XDoc.EmptyXDocKind, SprtCrsp.SprtCrsp);
  IF SprtCrsp.Status = L_SprtCrsp.st_Prepared THEN
   IF IsAlarmSprtCrsp() THEN
    L_General.Assert(Str.Length(Fields("Purpose").Value) <= MaxAlarmLength,
                     " ७ 맮   ॢ " + L_Str.IntStr(MaxAlarmLength) + " ᨬ");
   END;
   SprtCrsp.Purpose:=L_lsStore.Replace(SprtCrsp.Purpose, dstPurpose);
   REPLACE(SprtCrsp);
   CheckDeadline(1, 0);
   SubjName :=L_Str.PoolItem(srt_Pool, L_SprtCrsp.IsAddition());
   IF L_StdFrm.Alternative("ࠢ " + Str.Small(SubjName, 0, 1) + "  㦡 প ⮏?||" +
                           " ࠢ : " + L_Str.PoolItem(P_OwnData.scsc_Pool, GetSprtCrspSendChannel(1))) THEN
    LIKEMENU(CALL, "SprtCrsp.SendCorrespondence(1, 0)");
   END;
  END;
 END {SprtCrsp_OnAfterEdIns};

 PRIVATE PROCEDURE IsSetDoneTypeWindow(): SCAL[2];
 BEGIN
  RETURN Str.Match(GE_CURWIN(), "SprtCrspD*");
 END {IsSetDoneTypeWindow};

 PRIVATE PROCEDURE SprtCrsp_OnAfterEdit();
 BEGIN
  IF IsSetDoneTypeWindow() THEN
   IF    SprtCrsp.Status = L_SprtCrsp.st_Sent THEN
    L_General.Assert(!SprtCrsp.DoneType, " ࠢ  १ 믮  㪠뢠");
    IF SprtCrsp.DeadLine # L_SprtCrsp.dl_InFuture THEN
     L_General.Assert(~!SprtCrsp.AgrDate, " 㪠 ᮣᮢ ப ᯮ");
    END;
   ELSIF SprtCrsp.Status = L_SprtCrsp.st_Done THEN
    L_General.Assert(~!SprtCrsp.DoneType, " 믮    㪠 १ 믮");
    IF (SprtCrsp.DoneType # L_SprtCrsp.dt_DoneAsIs) & !RTI.Get().CurZone.Fields("Comment").Value THEN
     L_General.Error("   ⠪ १⮬ 믮     '਩'");
    END;
   END;
   SprtCrsp.Comment :=L_lsStore.Replace(SprtCrsp.Comment, RTI.Get().CurZone.Fields("Comment").Value);
   REPLACE(SprtCrsp);
  ELSE
   SprtCrsp_OnAfterEdIns();
  END;
  SprtCrsp_SyncAddition();
 END {SprtCrsp_OnAfterEdit};

 PRIVATE PROCEDURE SprtCrsp_OnAfterInsert();
 BEGIN
  SprtCrsp_OnAfterEdIns();
 END {SprtCrsp_OnAfterInsert};

 PRIVATE PROCEDURE SetSprtCrspFieldPool(z: FORM_ZONE);
 BEGIN
  z.Fields("SprtCrsp.Status").Format  :=L_SprtCrsp.st_Pool;
  z.Fields("SprtCrsp.RequestT").Format:=L_SprtCrsp.rt_Pool;
  z.Fields("SprtCrsp.DeadLine").Format:=L_SprtCrsp.dl_Pool;
 END {SetSprtCrspFieldPool};

 PRIVATE PROCEDURE SprtCrspE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "Purpose").LineBreakEnable:=1;
  SetSprtCrspFieldPool(L_WDO.iZone(0));
  L_WDO.iScsChange   (0, ["SprtCrsp.Parent", "SprtCrsp.RequestT", "SprtCrsp.dlTime", "SprtCrsp.dlDate", "SprtCrsp.DeadLine", "SprtCrsp.Status"]);
  L_WDO.iUnmodifiable(0, ["SprtCrsp.RequestT", "Writer", "PurposeCaption", "TextForAgrDate", "AttachmentsFolder", "SprtCrsp.PrpTime", "SprtCrsp.PrpDate", "SprtCrsp.SprtCrsp"]);
  L_WDO.iMayBeEmpty  (0, ["SprtCrsp.Customer", "SprtCrsp.AgrTime", "SprtCrsp.AgrDate"]);
  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeDelete]);
  L_WDO.iProgs       (1, "SprtCrsp");
 END {SprtCrspE_OnInitializeWindow};

 PRIVATE PROCEDURE SprtCrspE0_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "Purpose").LineBreakEnable:=1;
  SetSprtCrspFieldPool(L_WDO.iZone(0));
  L_WDO.iScsChange   (0, ["SprtCrsp.RequestT", "SprtCrsp.Parent", "SprtCrsp.dlTime", "SprtCrsp.dlDate", "SprtCrsp.DeadLine", "SprtCrsp.Status"]);
  L_WDO.iUnmodifiable(0, ["SprtCrsp.RequestT", "Writer", "SprtCrsp.AgrTime", "TextForAgrDate", "SprtCrsp.AgrDate", "AttachmentsFolder", "SprtCrsp.PrpTime", "SprtCrsp.PrpDate", "SprtCrsp.SprtCrsp"]);
  L_WDO.iMayBeEmpty  (0, ["SprtCrsp.Customer"]);
  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeDelete]);
  L_WDO.iProgs       (1, "SprtCrsp");
 END {SprtCrspE0_OnInitializeWindow};

 PRIVATE PROCEDURE SprtCrsp_OnBeforeDelete();
  VAR
   Msg: STRING[];
 BEGIN
  Msg:=" 饭";
  IF    SprtCrsp.Status = L_SprtCrsp.st_Sent THEN
   Msg:=SprtType(1) + " ࠢ. " + Msg;
  ELSIF SprtCrsp.Status = L_SprtCrsp.st_Done THEN
   Msg:=SprtType(1) + " 믮. " + Msg;
  ELSIF SprtCrsp.Status # L_SprtCrsp.st_Canceled THEN
   Msg:=Msg + ". ᯮ '㫨஢'";
  END;
  L_General.Error(Msg);
 END {SprtCrsp_OnBeforeDelete};

 PRIVATE PROCEDURE GetRealDeadLineDate(Date: DATE): DATE;
 BEGIN
  RETURN L_DatTim.GetDateOfVARIANTDATE(L_SprtCrsp.FirstWorkingDT(Date));
 END {GetRealDeadLineDate};

 PRIVATE PROCEDURE SetDeadlineDT();
 BEGIN
  SETEMPTY(SprtCrsp.dlDate, SprtCrsp.dlTime);
  IF    SprtCrsp.DeadLine = L_SprtCrsp.dl_Today THEN
   SprtCrsp.dlDate:=SYSDATE();
   IF SYSTIME() < 16:00 THEN
    SprtCrsp.dlTime:=16:30;
   END;
  ELSIF SprtCrsp.DeadLine = L_SprtCrsp.dl_ByTomorrow THEN
   SprtCrsp.dlDate:=GetRealDeadLineDate(SYSDATE() + 1);
  ELSIF SprtCrsp.DeadLine = L_SprtCrsp.dl_WithinWeek THEN
   SprtCrsp.dlDate:=GetRealDeadLineDate(SYSDATE() + 7);
  ELSIF SprtCrsp.DeadLine = L_SprtCrsp.dl_WithinMonth THEN
   SprtCrsp.dlDate:=GetRealDeadLineDate(L_DatTim.IncCalendarMonth(SYSDATE(), 1));
  END;
  REPLACE(SprtCrsp);
 END {SetDeadlineDT};

 PRIVATE PROCEDURE SprtCrsp_DeadLine_OnSuccessfulChange();
 BEGIN
  SetDeadlineDT();
  SprtCrsp_SetModifiable();
  CheckDeadline(0, 0);
 END {SprtCrsp_DeadLine_OnSuccessfulChange};

 PRIVATE PROCEDURE SprtCrsp_dlDate_OnSuccessfulChange();
 BEGIN
  CheckDeadline(0, 0);
 END {SprtCrsp_dlDate_OnSuccessfulChange};

 PRIVATE PROCEDURE SprtCrsp_dlTime_OnSuccessfulChange();
 BEGIN
  CheckDeadline(0, 0);
 END {SprtCrsp_dlTime_OnSuccessfulChange};

 PRIVATE PROCEDURE SprtCrsp_Status_OnSuccessfulChange();
  VAR
   curAddition: LIKE(SprtCrsp.SprtCrsp);
   _Status    : LIKE(SprtCrsp.Status);
 BEGIN
  IF IsSetDoneTypeWindow() THEN
   IF    (SprtCrsp.Status = L_SprtCrsp.st_Canceled) |
         (SprtCrsp.Status = L_SprtCrsp.st_Prepared) THEN
    L_General.Error("  ﭨ 饭");
   END;
   RTI.Get().CurZone.Fields("SprtCrsp.FctDate").Modifiable:=SprtCrsp.Status = L_SprtCrsp.st_Done;
   IF (SprtCrsp.Status = L_SprtCrsp.st_Done) & !SprtCrsp.FctDate THEN
    SprtCrsp.FctDate:=SYSDATE();
   ELSE
    SETEMPTY(SprtCrsp.FctDate);
   END;
   REPLACE(SprtCrsp);
  ELSE
   IF    (SprtCrsp.Status = L_SprtCrsp.st_Sent) |
         (SprtCrsp.Status = L_SprtCrsp.st_Done) THEN
    L_General.Error("ﭨ '" + L_Str.PoolItem(L_SprtCrsp.st_Pool, SprtCrsp.Status) + "' ⠭ ⮫쪮 ⮬᪨");
   END;
   IF    GE_PVALUE() = L_SprtCrsp.st_Canceled THEN
    L_StdFrm.Choice("  ⬥ 㫨஢ 孨᪮ ॡ?");
    SETEMPTY(SprtCrsp.DoneType);
    REPLACE(SprtCrsp);
   ELSIF SprtCrsp.Status = L_SprtCrsp.st_Canceled THEN
    L_StdFrm.Choice("  㫨஢ 孨᪮ ॡ?");
    SprtCrsp.DoneType:=L_SprtCrsp.dt_Canceled;
    REPLACE(SprtCrsp);
   END;
   IF L_SprtCrsp.IsAddition() THEN
    curAddition:=SprtCrsp.SprtCrsp;
    _Status    :=SprtCrsp.Status;
    SAVE(SprtCrsp);
    StandOnParentSprt();
    IF (_Status = L_SprtCrsp.st_Prepared) &
       (SprtCrsp.Status # L_SprtCrsp.st_Prepared) & (SprtCrsp.Status # L_SprtCrsp.st_Sent) THEN
     L_General.Error(" ﭨ ,|" +
                     "⠪  ᭮  室  ﭨ " + L_Str.PoolItem(L_SprtCrsp.st_Pool, SprtCrsp.Status));
    END;

    IF _Status = L_SprtCrsp.st_Prepared THEN
     SELECT(SprtCrsp, Parent, , SprtCrsp.SprtCrsp);
     WHILE OCCURE(SprtCrsp) DO
      IF (SprtCrsp.Status = L_SprtCrsp.st_Prepared) & (SprtCrsp.SprtCrsp # curAddition) THEN
       L_General.Error(" ﭨ ,|" +
                       "⠪  㦥     " + SprtCrsp.SprtCrsp + "| ﭨ " + L_Str.PoolItem(L_SprtCrsp.st_Pool, SprtCrsp.Status));
      END;
      NEXT(SprtCrsp);
     END; (* WHILE OCCURE(SprtCrsp) ... *)
    END;

    RESTORE(SprtCrsp);
   END;
   SprtCrsp_SetModifiable();
  END;
 END {SprtCrsp_Status_OnSuccessfulChange};

 PRIVATE PROCEDURE SprtCrsp_Parent_OnSuccessfulChange();
 BEGIN
  CheckParent();
  SprtCrsp_SetModifiable();
 END {SprtCrsp_Parent_OnSuccessfulChange};

 PRIVATE PROCEDURE FileAlreadyInDstFolder(SrcFolder: STRING[]): SCAL[2];
 BEGIN
  RETURN Str.Match(SrcFolder, GetAttachmentsFolder() + "*");
 END {FileAlreadyInDstFolder};

 PRIVATE PROCEDURE PutAttachmentToDstFolder(SrcFullFileName: STRING[];
                                            InsNewSprtCrsA : SCAL[2]);
  VAR
   SrcFolder,
   SrcFileName,
   DstFolder,
   DstFullFileName: STRING[];
 BEGIN
  DstFolder:=L_FIO.MakeDir(GetAttachmentsFolder());
  FIO.SplitPath(SrcFullFileName, SrcFileName, , SrcFolder);
  IF ~FileAlreadyInDstFolder(SrcFolder) THEN
   DstFullFileName:=FIO.BuildPath(SrcFileName, , DstFolder);
   IF FIO.Exists(DstFullFileName) THEN
    L_StdFrm.Choice("  䠩 " + DstFullFileName + "|" +
                    "த 樨 ਢ   ");
   END;
   L_FIO.ExactFileCopy(SrcFullFileName, DstFullFileName);
  ELSE
   DstFullFileName:=SrcFullFileName;
  END;
  IF InsNewSprtCrsA THEN
   DEFAULT(SprtCrsA);
   SprtCrsA.SprtCrsp:=SprtCrsp.SprtCrsp;
   INSERT(SprtCrsA);
  END;
  SprtCrsA.Attchmnt:=L_FIO.effp_FileName(DstFullFileName);
  REPLACE(SprtCrsA);
 END {PutAttachmentToDstFolder};

 PRIVATE PROCEDURE CheckAttachmentFileExist();
  VAR
   FullFileName: STRING[];
 BEGIN
  FullFileName:=GetFullAttachmentPath();
  L_General.Assert(FIO.Exists(FullFileName),
                   " ⠫  ࠢ   䠩 " +
                   FullFileName +
                   "|" +
                   "(" + SprtType(0) + " " + SprtCrsp.SprtCrsp + ")");
 END {CheckAttachmentFileExist};

 PRIVATE PROCEDURE intAttachSingleFile(InsNewSprtCrsA: SCAL[2]);
  VAR
   Dummy,
   _Attchmnt,
   FullFileName: STRING[];
   Amount      : NUMERIC[0];
 BEGIN
  FullFileName:=FIO.ChooseFile("*.*");
  IF ~!FullFileName THEN
   ACCESS(SprtCrsp);
   _Attchmnt:=L_FIO.effp_FileName(FullFileName);
   SAVE(SprtCrsA);
   SETZERO(Amount);
   SELECT(SprtCrsA, SprtCrsp, , SprtCrsp.SprtCrsp);
   WHILE OCCURE(SprtCrsA) DO
    IF _Attchmnt = SprtCrsA.Attchmnt THEN
     INC(Amount);
    END;
    NEXT(SprtCrsA);
   END; (* WHILE OCCURE(SprtCrsA) ... *)
   L_General.Assert(Amount = 0, "  뫪  䠩 " + _Attchmnt);
   RESTORE(SprtCrsA);

   PutAttachmentToDstFolder(FullFileName, InsNewSprtCrsA);
  END;
 END {intAttachSingleFile};

 PRIVATE PROCEDURE SprtCrsA_Attchmnt_OnBeforeAskForEdit();
 BEGIN
  L_General.Assert(ACCESS(SprtCrsA), " ࠭ ⥪饥 ");
  intAttachSingleFile(0);
 END {SprtCrsA_Attchmnt_OnBeforeAskForEdit};

 PUBLIC PROCEDURE ShowAttachment();
  VAR
   Ext, Dummy,
   FullFileName: STRING[];
 BEGIN
  L_General.Assert(ACCESS(SprtCrsA), " ࠭ ⥪饥 ");
  CONFORM(SprtCrsA, SprtCrsp);
  CheckAttachmentFileExist();
  FullFileName:=GetFullAttachmentPath();
  FIO.SplitPath(SprtCrsA.Attchmnt, Dummy, Ext);
  IF L_Str.IsEqStrI(Ext, "REP") THEN
   LIKEMENU(Survey, FullFileName);
  ELSE
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    Shell.Execute("open", FullFileName, , GetAttachmentsFolder());
   EXCEPT
   ON Exc: Exc_Root DO
    L_General.Error(" 㤠   ᬮ 䠩" +
                    FullFileName + "| |" +
                    "   ஡ - ७ '" + Ext + "'|" +
                    " ᮯ⠢ ਫ,   ண|" +
                    "᫥ 뢠  䠩.||" +
                    "஡ ᠬ⥫쭮  ன Windows|" +
                    "ᮯ⠢ ७ '" + Ext + "' 室 ਫ|" +
                    "   .");
   END; (* TRY *)
  END;
 END {ShowAttachment};

 PRIVATE PROCEDURE intOpenAttachmentFolder(wMakeDir: SCAL[2]);
  VAR
   AttachmentsFolder: STRING[];
 BEGIN
  AttachmentsFolder:=GetAttachmentsFolder();
  IF wMakeDir THEN
   AttachmentsFolder:=L_FIO.MakeDir(AttachmentsFolder);
  ELSE
   L_General.Assert(FIO.DirExists(AttachmentsFolder), "  , ⠫|" + AttachmentsFolder +
                    "| .");
  END;
  Shell.Execute("open", AttachmentsFolder);
 END {intOpenAttachmentFolder};

 PUBLIC PROCEDURE OpenAttachmentFolder();
 BEGIN
  intOpenAttachmentFolder(1);
 END {OpenAttachmentFolder};

 PUBLIC PROCEDURE OpenAttachmentFolder_FromShowTable();
 BEGIN
  ACCESS(SprtCrsp);
  intOpenAttachmentFolder(0);
 END {OpenAttachmentFolder_FromShowTable};

 PRIVATE PROCEDURE GetErrorDescriptionFromECN(): STRING[];
  VAR
   SingleStr,
   ErrorList,
   FullErrorList,
   ECNErrorHeader: STRING[];
   ECNErrorHeadLen,
   Pos,
   Amount,
   Choice,
   curWidth,
   curHeight,
   ECNSize       : NUMERIC[0];
 BEGIN
  GE_APPWIN_SIZE(curWidth, curHeight);
  FIO.Open(F, FIO.BuildPath(DATABASE.Get().Name, "ECN"), , Input);
  ECNSize:=FIO.Size(F);

  L_General.Assert(ECNSize # 0, "ୠ 訡 ");
  IF ECNSize <= 25000 THEN
   Pos:=0;
  ELSE
   Pos:=ECNSize - 25000;
  END;

  FIO.Seek(F, Pos);
(* ய᪠  ப,   ᯮ樮஢ -  ࠢ    砫 㤥*)
  L_General.CallUs(FIO.RdStr(F, SingleStr));

  SETEMPTY(ErrorList, FullErrorList, ECNErrorHeader);
  SETZERO(Amount);
  WHILE FIO.RdStr(F, SingleStr) DO
   PROMPT("⥭ ୠ 訡 " + L_Str.IntStr(Amount));
   IF ~Str.Match(SingleStr, "*।०:*") &
      ~Str.Match(SingleStr, "*᪫祭 ࠡ⠭*") THEN
    SingleStr    :=L_Str.Replace(SingleStr, "|", "");
    SingleStr    :=L_Str.Replace(SingleStr, CHR(255), " ");
    FullErrorList:=L_Str.AddStrDlm(FullErrorList, "|") + SingleStr;
 
    IF Str.Length(SingleStr) > (curWidth - 4) THEN
     IF SingleStr[21] = ';' THEN (*0074832*)
      ECNErrorHeadLen:=Str.ItemPos(SingleStr, ";", 3)-1;
     ELSE
      ECNErrorHeadLen:=Str.ItemPos(SingleStr, " ", 4)-1;
     END;
     ECNErrorHeader:=Str.Slice(SingleStr, 0, ECNErrorHeadLen);
     SingleStr:=ECNErrorHeader + " ... " + L_Str.Right(SingleStr, curWidth - Str.Length(ECNErrorHeader) - 9);
    END;
    ErrorList:=L_Str.AddStrDlm(ErrorList, "|") + SingleStr;
 
    INC(Amount);
   END;
  END;
  FIO.Close(F);

  Choice:=L_StdFrm.ShowListAsMenu_wInit(ErrorList+"|", "祭 ᫥ 訡", Amount-1);
  RETURN L_Str.PoolItem(FullErrorList, Choice);
 END {GetErrorDescriptionFromECN};

 PUBLIC PROCEDURE PutErrorDescriptionFromECNInSprtCrsp();
 BEGIN
  RTI.Get().CurZone.Fields("Purpose").Value:=L_Str.AddStrDlm(RTI.Get().CurZone.Fields("Purpose").Value, L_Str.CRLF) + GetErrorDescriptionFromECN();
  L_StdFrm.Inform("  㪠 ⥫⢠,|   訡.");
 END {PutErrorDescriptionFromECNInSprtCrsp};

 PRIVATE PROCEDURE SetWriter();
  VAR
   curWriter  : STRING[];
   WriterField: FORM_FIELD;
 BEGIN
  WriterField:=RTI.Get().CurWindow.Zones(0).Fields("Writer");
  IF ~!WriterField THEN
   IF SELECT(XDocJrn, XDocJrn, L_XDoc.xdt_SprtCrsp, L_XDoc.EmptyXDocKind, SprtCrsp.SprtCrsp) THEN
    CONFORM(XDocJrn, AcsObj);
    curWriter:=AcsObj.FullName;
   ELSE
    curWriter:="";
   END;
   WriterField.Value:=curWriter;
  END;
 END {SetWriter};

 PRIVATE PROCEDURE AnySprtCrsp_OnReposition();
  VAR
   Fields    : FORM_FIELDS;
   trgAction,
   trgObject,
   trgPrompt,
   trgPurpose: STRING[];
 BEGIN
  DecodeSprtCrsp(trgAction, trgObject, trgPrompt, trgPurpose);
  Fields:=RTI.Get().CurZone.Fields;
  IF (SprtCrsp.RequestT = L_SprtCrsp.rt_ErrorCorrection) |
     (SprtCrsp.RequestT = L_SprtCrsp.rt_AutoBuild)       THEN
   Fields("Action").Value:=trgAction;
   Fields("Object").Value:=trgObject;
   Fields("Prompt").Value:=trgPrompt;
  END;
  Fields("Purpose").Value          :=trgPurpose;
  Fields("AttachmentsFolder").Value:="(" + GetAttachmentsFolder() + ")";

  SetPurposeCaption();
  SetWriter();
  SprtCrsp_SetModifiable();
 END {AnySprtCrsp_OnReposition};

 PRIVATE PROCEDURE SprtCrspE_0_OnReposition();
 BEGIN
  AnySprtCrsp_OnReposition();
 END {SprtCrspE_0_OnReposition};

 PRIVATE PROCEDURE SprtCrspE0_0_OnReposition();
 BEGIN
  AnySprtCrsp_OnReposition();
 END {SprtCrspE0_0_OnReposition};

 PRIVATE PROCEDURE SprtCrsA_OnBeforeDelete();
  VAR
   FileName: STRING[];
 BEGIN
  L_General.Assert(ACCESS(SprtCrsA), " ࠭ ⥪饥 ");
  FileName:=GetFullAttachmentPath();
  L_StdFrm.Choice(" 䠩|" + FileName);
  FIO.Erase(FileName);
 END {SprtCrsA_OnBeforeDelete};

 PRIVATE PROCEDURE SprtCrsp_OnInitializeWindow();
 BEGIN
  L_WDO.iField       (0, "hasNext_lsStore").Format:=L_lsStore.hasNext_Pool;
  L_WDO.iField       (0, "lsStore.Value").LineBreakEnable:=1;
  L_WDO.iField       (0, "lsStore.Value").FontSize:=FORM_FIELD.fs_Normal;
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iField       (1, "SprtCrsp.SprtCrsp").Hierarchic:=1;
  L_WDO.iZone        (1).HierarchicLink:=LINK.Get("SprtCrsp", "Parent");
  L_WDO.iField       (1, "SprtCrsp.SprtCrsp").ReverseSorting:=1;
  L_WDO.iField       (1, "SprtCrsp.Status").Format:=L_SprtCrsp.st_ShortPool;
  L_WDO.iField       (1, "SprtCrsp.DoneType").Format:=L_SprtCrsp.dt_ShortPool;
  L_WDO.iField       (1, "SprtCrsp.RequestT").Format:=L_SprtCrsp.rt_Pool_Short;
 END {SprtCrsp_OnInitializeWindow};

 PRIVATE PROCEDURE Deadline(): DATE;
 BEGIN
  IF    ~!SprtCrsp.AgrDate THEN
   RETURN SprtCrsp.AgrDate;
  ELSIF SprtCrsp.DeadLine # L_SprtCrsp.dl_InFuture THEN
   IF (SprtCrsp.DeadLine = L_SprtCrsp.dl_Immediately) |
      (SprtCrsp.DeadLine = L_SprtCrsp.dl_Today) THEN
    RETURN SprtCrsp.PrpDate;
   ELSE
    RETURN SprtCrsp.dlDate;
   END;
  ELSE
   RETURN EMPTYOF(DATE);
  END;
 END {Deadline};

 PRIVATE PROCEDURE SprtCrspD_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="SprtCrsp";
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit]);
  L_WDO.iField       (0, "Comment").LineBreakEnable:=1;
  L_WDO.iField       (0, "SprtCrsp.Status").Format  :=L_SprtCrsp.st_Pool;
  L_WDO.iField       (0, "SprtCrsp.DoneType").Format:=L_SprtCrsp.dt_Pool;
  L_WDO.iScsChange   (0, ["SprtCrsp.Status", "SprtCrsp.DoneType"]);
  L_WDO.iUnmodifiable(0, ["SprtCrsp.PrpDate", "SprtCrsp.SprtCrsp"]);
  L_WDO.iMayBeEmpty  (0, ["SprtCrsp.AgrTime", "Comment", "SprtCrsp.AgrDate", "SprtCrsp.DoneType"]);
 END {SprtCrspD_OnInitializeWindow};

 PRIVATE PROCEDURE SprtCrsp_DoneType_OnSuccessfulChange();
 BEGIN
  L_General.Assert(SprtCrsp.DoneType # L_SprtCrsp.dt_Canceled, " १ 믮  ⠭ ⮫쪮 ⮬᪨");
 END {SprtCrsp_DoneType_OnSuccessfulChange};

(*
$P{ SprtCrsp_Top_S:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
SprtCrsp.SprtCrsp, L, ""
SprtCrsp.PrpDate, L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|             孨᪮ ॡ #######  ##########                   |
}
*)

(*
$P{ SprtCrsp_Dlm_S:
@
|----------------------------------------------------------------------------|
}
*)

(*
$P{ SprtCrsp_Line_S:
?, L, ""
@
|############################################################################|
}
*)

(*
$P{ SprtCrsp_Bot_S:
@
=(c) Polak====================================================================
}
*)

(*
$P{ SprtCrsp_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
SprtCrsp.SprtCrsp, L, ""
SprtCrsp.PrpDate, L, "D.N.y"
@
############################################################################################# ########## #####
=#####========================================================================================================
|                           孨᪮ ॡ #######  ##########                                     |
}
*)

(*
$P{ SprtCrsp_Dlm:
@
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ SprtCrsp_Line:
?, L, ""
@
|############################################################################################################|
}
*)

(*
$P{ SprtCrsp_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE PrintArr(Prefix, S: STRING[]; LineLength: NUMERIC[0]);
  CONST
   MaxLines = 750;
  VAR
   Text    : STRING[][MaxLines];
   Rest    : STRING[];
   i,
   LastLine: NUMERIC[0];
 BEGIN
  Str.Format(Text, Prefix + " " + S, LineLength, LEFT, Rest);
  L_General.CallUs(!Rest);
  LastLine:=MaxLines-1;
  WHILE (LastLine >= 0) & !Text[LastLine] DO
   DEC(LastLine);
  END; (* WHILE (LastLine >= 0) & !Text[LastLine]...*)
  i:=0;
  WHILE i <= LastLine DO
   MAKEPART(R, SprtCrsp_Line, Text[i]);
   INC(i);
  END;
 END {PrintArr};

 PUBLIC PROCEDURE ViewFullSprtCrsp();
  CONST
   RepName = "SprtC";
   LineLength = 108;
  VAR
   dlDateAsStr: STRING[];
 BEGIN
  L_General.Assert(ACCESS(SprtCrsp), " ࠭ ⥪饥 孨᪮ ॡ");
  PROMPT("ࠡ⪠...");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, SprtCrsp_Top, RepName);
  MAKEPART(R, SprtCrsp_Dlm);
  PrintArr(" ॡ      :", L_Str.PoolItem(L_SprtCrsp.rt_Pool, SprtCrsp.RequestT), LineLength);
  PrintArr("⠪⭮      :", SprtCrsp.Author,   LineLength);
  PrintArr("               :", SprtCrsp.Customer, LineLength);
  PrintArr("ଠ⨢ 㬥:", SprtCrsp.NormDoc,  LineLength);
  PrintArr("                :", SprtCrsp.Name,     LineLength);
  IF ~!SprtCrsp.dlDate THEN
   dlDateAsStr:=L_DatTim.DateStr(SprtCrsp.dlDate);
  ELSE
   dlDateAsStr:="";
  END;
  PrintArr("ப ᯮ     :", L_Str.PoolItem(L_SprtCrsp.dl_Pool, SprtCrsp.DeadLine) + " " + dlDateAsStr, LineLength);
  MAKEPART(R, SprtCrsp_Dlm);
  PrintArr("               :", L_lsStore.Get(SprtCrsp.Purpose), LineLength);
  MAKEPART(R, SprtCrsp_Dlm);

  PrintArr("ﭨ           :", L_Str.PoolItem(L_SprtCrsp.st_Pool, SprtCrsp.Status), LineLength);
  IF ~!SprtCrsp.DoneType THEN
   PrintArr(" 믮:", L_Str.PoolItem(L_SprtCrsp.dt_Pool, SprtCrsp.DoneType), LineLength);
  ELSE
   MAKEPART(R, SprtCrsp_Line, " 믮:");
  END;
  MAKEPART(R, SprtCrsp_Dlm);
  PrintArr("਩         :", L_lsStore.Get(SprtCrsp.Comment), LineLength);
  MAKEPART(R, SprtCrsp_Bot);
  CLOSEREP(R);
 END {ViewFullSprtCrsp};

(*
$P{ ExpSC_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|              믮  㪠 ப   ##########             |
|----------------------------------------------------------------------------|
|  |      |                                    |ப ᯮ.||
|-------|----------|----------------------------------------|------------|---|
}
*)

(*
$P{ ExpSC_Top2:
@
|----------------------------------------------------------------------------|
|                            ப ᯮ                           |
|----------------------------------------------------------------------------|
}
*)

(*
$P{ ExpSC_Line:
SprtCrsp.SprtCrsp, L ,""
SprtCrsp.PrpDate, L, "D.N.y"
SprtCrsp.Name, L, ""
?, L, ""
?, L, "D.N.y"
?, R, "0"
@
|#######|##########|########################################|# ##########|###|
}
*)

(*
$P{ ExpSC_Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE intShowExpireSprtCrsp(AtAutoexec: SCAL[2]);
  CONST
   RepName = "ExpSC";
   dl_ShortPool = "!||||";
  VAR
   OnDate,
   _dlDate: DATE;
   First  : SCAL[2];
   Count  : NUMERIC[0];
   dCount : NUMERIC[3];
   Delay  : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" 祭 ");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  OnDate:=Memo.ud_cd();
  IF ~AtAutoexec THEN
   L_XDoc.sl_Init("祭 ");
   OPENREP(R, L_General.NameConnection(RepName), Create);
   MAKEPART(R, ExpSC_Top, RepName, OnDate);
  END;
  Count:=0;
  dCount:=0;
  SELECT(SprtCrsp, Status, , L_SprtCrsp.st_Sent);
  WHILE OCCURE(SprtCrsp) DO
   PROMPT(SprtCrsp.SprtCrsp);
   IF ~L_SprtCrsp.IsAddition() THEN
    _dlDate:=Deadline();
    IF _dlDate < OnDate THEN
     IF ~AtAutoexec THEN
      MAKEPART(R, ExpSC_Line, L_Str.PoolItem(dl_ShortPool, SprtCrsp.DeadLine), _dlDate, OnDate - _dlDate);
      L_XDoc.sl_AddItem(L_XDoc.curXDocId(L_XDoc.xdt_SprtCrsp), L_XDoc.XDocStr(L_XDoc.curXDocId(L_XDoc.xdt_SprtCrsp)) + " " + Str.Slice(SprtCrsp.Name, 0, 64));
     END;
     INC(Count);
     INC(dCount, OnDate-_dlDate);
    END;
   END;
   NEXT(SprtCrsp);
  END; (* WHILE OCCURE(SprtCrsp) ... *)

  IF AtAutoexec THEN
   IF Count > 0 THEN
    dCount:=dCount/Count;
    L_StdFrm.TimedINFORM_AsSTOP("| '孨᪨ ॡ',  믮 ᯮ⥫  㪠 ப!" +
                                "||(⢮ '': " +
                                L_Str.IntStr(Count) + " " + Str.EnumObject(Count, "㪠|㪨|") +
                                ", । 襭 ப: " +
                                L_Str.IntStr(dCount) + " " + Str.EnumObject(dCount, "||") + ")", 60);
   END;
  ELSE
   FIRST(SprtCrsp);
   First:=1;
   WHILE OCCURE(SprtCrsp) DO
    PROMPT(SprtCrsp.SprtCrsp);
    IF ~L_SprtCrsp.IsAddition() THEN
     _dlDate:=Deadline();
     IF !_dlDate THEN
      IF First THEN
       MAKEPART(R, ExpSC_Top2);
      END;
      MAKEPART(R, ExpSC_Line, L_Str.PoolItem(dl_ShortPool, SprtCrsp.DeadLine));
      L_XDoc.sl_AddItem(L_XDoc.curXDocId(L_XDoc.xdt_SprtCrsp), L_XDoc.XDocStr(L_XDoc.curXDocId(L_XDoc.xdt_SprtCrsp)) + " " + Str.Slice(SprtCrsp.Name, 0, 64));
      First:=0;
     END;
    END;
    NEXT(SprtCrsp);
   END; (* WHILE OCCURE(SprtCrsp) ... *)
   MAKEPART(R, ExpSC_Bot);
   CLOSEREP(R);
   L_XDoc.sl_Done();
  END;
 END {intShowExpireSprtCrsp};

 PRIVATE PROCEDURE ChooseSprtCrspRequestT();
  VAR
   i           : NUMERIC[0];
   RequestTList: STRING[];
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert THEN
   SETEMPTY(RequestTList);
   i:=0;
   WHILE i < L_SprtCrsp.rt_AutoBuild DO
    RequestTList:=RequestTList + L_Str.PoolItem(L_SprtCrsp.rt_Pool, i) + "|";
    INC(i);
   END;
   ChoosenRequestT:=L_StdFrm.ShowListAsMenu(RequestTList, " 孨᪮ ॡ");

   IF    ChoosenRequestT = L_SprtCrsp.rt_Alarm THEN
    L_StdFrm.Choice(" 㢥७,   ७ 砩 |" +
                    "஡  筮,  饩 ⫠⥫?");
    IF ~L_SprtCrsp.IsAcceptableTimeForAlarm() THEN
     L_General.Error("७ 맮 㦡 প |" +
                     "⮫쪮  ࠡ祥 ६ (室   ६  " +
                     L_DatTim.TimeStr(L_SprtCrsp.aps_GetLocalTime(L_SprtCrsp.aps_EndWork)) + "  " +
                     L_DatTim.TimeStr(L_SprtCrsp.aps_GetLocalTime(L_SprtCrsp.aps_BegWork)) + ")." +
                     "|| 㦡 প ࠡ⠥  筮 ०,|"+
                     "⮬ ᯮ 묨 ⨯ ");
    END;
   ELSIF ChoosenRequestT = L_SprtCrsp.rt_Addition THEN
    ACCESS(SprtCrsp);
    IF !SprtCrsp.Parent THEN
     L_General.Assert(SprtCrsp.RequestT # L_SprtCrsp.rt_Alarm, "   '" + L_Str.PoolItem(L_SprtCrsp.rt_Pool, L_SprtCrsp.rt_Alarm) + "' " +
                                                               "  ନ");
     L_General.Assert(SprtCrsp.Status = L_SprtCrsp.st_Sent, "  ⮫쪮    ﭨ 'ࠢ'");
    ELSE
     SAVE(SprtCrsp);
     StandOnParentSprt();
     L_General.Assert(SprtCrsp.Status = L_SprtCrsp.st_Sent, "  ⮫쪮    ﭨ 'ࠢ'");
     RESTORE(SprtCrsp);
    END;
   END;
  ELSE
   IF ACCESS(SprtCrsp) THEN
    ChoosenRequestT:=SprtCrsp.RequestT;
   ELSE
    L_General.Error(" ");
   END;
  END;
 END {ChooseSprtCrspRequestT};

 PRIVATE PROCEDURE SprtCrsp_1_OnSetSubwindow();
  VAR
   SubWindowName: STRING[];
 BEGIN
  IF (RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit) &
     ACCESS(SprtCrsp) & ((SprtCrsp.Status = L_SprtCrsp.st_Sent) | (SprtCrsp.Status = L_SprtCrsp.st_Done)) THEN
   TOOLTIP("ࠢ  ࠡ⠭ 孨᪨ ॡ   ।஢," +
           "|⮬ 뢠  '  믮'." +
           '| ᬮ ᮡ⢥  ᫥ ᯮ짮 "Shift+Enter"');
   L_General.Assert(~L_SprtCrsp.IsAddition(), "⬥⪨  믮 ᫥    (  )");
   SubWindowName:="SprtCrspD";
  ELSE
   ChooseSprtCrspRequestT();
   IF (ChoosenRequestT = L_SprtCrsp.rt_ErrorCorrection) |
      (ChoosenRequestT = L_SprtCrsp.rt_AutoBuild)       THEN
    SubWindowName:="SprtCrspE0";
   ELSE
    SubWindowName:="SprtCrspE";
   END;
  END;
  RTI.Get().CurZone.HasVariousSubwindows :=1;
  RTI.Get().CurZone.SubwindowOriginalName:=SubWindowName;
 END {SprtCrsp_1_OnSetSubwindow};

 PUBLIC PROCEDURE Send_ByMainChannel();
 BEGIN
  SendCorrespondence(1, 1);
 END {Send_ByMainChannel};

 PUBLIC PROCEDURE Send_ByReservChannel();
 BEGIN
  SendCorrespondence(0, 1);
 END {Send_ByReservChannel};

 PUBLIC PROCEDURE ShowExpireSprtCrsp();
 BEGIN
  intShowExpireSprtCrsp(0);
 END {ShowExpireSprtCrsp};

 PUBLIC PROCEDURE ShowExpireSprtCrsp_AtAutoexec();
 BEGIN
  intShowExpireSprtCrsp(1);
 END {ShowExpireSprtCrsp_AtAutoexec};

 PUBLIC PROCEDURE InsertAttachment();
 BEGIN
  intAttachSingleFile(1);
 END {InsertAttachment};

 PUBLIC PROCEDURE EditAttachment();
 BEGIN
  L_General.Assert(ACCESS(SprtCrsA), " ࠭ ⥪饥 ");
  intAttachSingleFile(0);
 END {EditAttachment};

 PUBLIC PROCEDURE AttachWholeSupportAttachmentsFolder();
 BEGIN
  intAttachWholeSupportAttachmentsFolder(0);
 END {AttachWholeSupportAttachmentsFolder};

 PUBLIC PROCEDURE SetAuthorName();
 BEGIN
  SprtCrsp.Author:=L_SprtCrsp.GetAuthorName();
  REPLACE(SprtCrsp);
 END {SetAuthorName};

 PUBLIC PROCEDURE scs_GetFilters_SprtCrsp_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "  ࠡ",              "(SprtCrsp.Status="   + L_Str.IntStr(L_SprtCrsp.st_Sent)     + ")", 1);
  L_WDO.PutNewFilter(Filters, "ࠢ 㬥", "(SprtCrsp.Status="   + L_Str.IntStr(L_SprtCrsp.st_Prepared) + ")", 1);
  L_WDO.PutNewFilter(Filters, "쪮 ⮬᪨ ", "(SprtCrsp.RequestT=" + L_Str.IntStr(L_SprtCrsp.rt_AutoBuild)+ ")", 1);
  L_WDO.PutNewFilter(Filters, "஬ ⮬᪨ ",  "(SprtCrsp.RequestT#" + L_Str.IntStr(L_SprtCrsp.rt_AutoBuild)+ ")", 1);
 END {scs_GetFilters_SprtCrsp_1};

BEGIN
 L_Events.ExecuteHandler();
END.
