(*
%Copyright   (c) Polak Computer System
%Author      SAN
%Purpose     ନ஢  楢   ਨ 믫  ⠢  㤭
%Type        control
%Specific    SYS
%Modified    16.09.2014 17:41:12 POLAK\San
%Environment
*)

 MODULE Staff [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_Events, L_Staff, L_Str, L_DatTim, L_PRoll, L_WDO,
        L_Sheet, L_Man, L_DBD, L_XDoc, L_Pmnt, L_APtm, L_StdFrm, L_two,
        L_AcCut, L_Stock, L_XObj, P_Man, P_Firm, Math, Str, E_Staff, L_Env,
        L_AcsPnt, L_MDoc, L_AR, L_PDoc, L_Prop, L_ACS, SysLog, L_SysLog, L_OwnData, L_EDO, L_ACL;

 PRIVATE PERMANENT VAR
  curStaffLog_DateE_Type    : STRING[];
  OtherInformationAboutStaff: STRING[][2];

 PRIVATE CONST
  pc_InStopList  = "STOPLIST";
  PINCodeLength  = 4;
  pcs_Unknow     = 0;
  pcs_Givenout   = 1;
  pcs_InStopList = 2;

 PRIVATE VAR
  StaffMyFirm: P_Firm.tMyFirm;
  NoTouchTSN : LIKE(Staff.TSN);

 PRIVATE PROCEDURE Close();
  VAR
   _DateE: LIKE(StaffLog.Date);
 BEGIN
  L_General.Assert(SELECT(StaffLog, TSN, Staff.TSN), "     ப  ਥ");
  L_General.CallUs(Staff.BegDate = StaffLog.Date);
  LAST(StaffLog);
  IF L_Staff.IsDischargeStaffLog() THEN
   _DateE:=StaffLog.Date-1;
  ELSE
   SETEMPTY(_DateE);
  END;
  L_General.CallUs(Staff.EndDate = _DateE);
  REPEAT
   StaffLog.DateE:=_DateE;
   REPLACE(StaffLog);
   _DateE:=StaffLog.Date-1;
  UNTIL ~PREV(StaffLog);
 END {Close};

 PRIVATE PROCEDURE CheckOverlap(Aux: LIKE(Staff.Contract); Msg: STRING[]; B, E: DATE; NeedOvlp, GlobalScope: SCAL[2]);
  VAR
   Days   : NUMERIC[0];
 BEGIN
  Days:=0;
  IF GlobalScope THEN
   SELECT(Staff, Man, , Man.Man, Aux);
  ELSE
   SELECT(Staff, MyFirm, , StaffMyFirm, Man.Man, Aux);
  END;
  WHILE OCCURE(Staff) DO
   IF !NoTouchTSN | (Staff.TSN # NoTouchTSN) THEN
    INC(Days, L_DatTim.DATEINT(B, E, Staff.BegDate, Staff.EndDate));
    L_General.Assert(NeedOvlp | (Days = 0), Msg)
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  L_General.Assert(~NeedOvlp | (Days = (E-B+1)), Msg);
 END {CheckOverlap};

 PRIVATE PROCEDURE GetStaffEndDate(): DATE;
 BEGIN
  IF !Staff.EndDate THEN
   RETURN MAXOF(DATE);
  ELSE
   RETURN Staff.EndDate;
  END;
 END {GetStaffEndDate};

 PRIVATE PROCEDURE CheckManApplicability();
 BEGIN
  L_General.Assert(Man.rStaff # L_Man.rs_None,
                  "⨬ ଫ ࠡ⭨  뫪   " + L_Man.Man_ManAsStr() +
                  "|| ଫ  㣨 楫");
 END {CheckManApplicability};

 PRIVATE PROCEDURE CheckContracts(checkContractorsAgreement: SCAL[2]);
  VAR
   B, E   : DATE;
   i, j   : NUMERIC[0];
 BEGIN
  CONFORM(Staff, Man);
  IF Man.rStaff = L_Man.rs_OutStaff THEN
   L_General.Assert(Staff.Contract = L_Staff.cnt_OutStaff,
                   " ଫ  '祭' ."+
                   "| ଫ  ᪠ ⮫쪮  ஢ '"+L_Str.PoolItem(L_Staff.cnt_Pool_Full, L_Staff.cnt_OutStaff)+"'."+
                   "|, ᫥ ନ ");
  END;
  SETEMPTY(NoTouchTSN);
  CheckManApplicability();
  SAVE(Staff);
  StaffMyFirm:=Staff.MyFirm;
  B:=Staff.BegDate;
  E:=GetStaffEndDate();
  IF Staff.Contract = L_Staff.cnt_Basic THEN
   NoTouchTSN:=Staff.TSN;
   CheckOverlap(L_Staff.cnt_Basic, "४⨥ ᭮ ࠪ⮢", B, E, 0, 1);
   SETEMPTY(NoTouchTSN);
   CheckOverlap(L_Staff.cnt_ExternalCombine, "४뢠 譥 ᮢ⥫⢮", B, E, 0, 0);
   j:=0;
   LOOP
    i:=0;
    SELECT(Staff, MyFirm, , StaffMyFirm, Man.Man, L_Staff.cnt_InternalCombine);
    WHILE OCCURE(Staff) & (i < j) DO
     NEXT(Staff); INC(i);
    END; (* WHILE OCCURE(Staff) ... *)
    IF ~OCCURE(Staff) THEN
     EXIT;
    END;
    CheckOverlap(L_Staff.cnt_Basic, "襭 ७ ᮢ⥫⢮",
                 Staff.BegDate, GetStaffEndDate(), 1, 0);
    INC(j);
   END; (* LOOP ... *)
  ELSIF (Staff.Contract = L_Staff.cnt_ExternalCombine) | (Staff.Contract = L_Staff.cnt_OutStaff) THEN
   CheckOverlap(L_Staff.cnt_Basic, "४뢠 ᭮ ࠪ", B, E, 0, 0);
   CheckOverlap(L_Staff.cnt_InternalCombine, " ७ ᮢ⥫⢮", B, E, 0, 0);
  ELSIF Staff.Contract = L_Staff.cnt_InternalCombine THEN
   CheckOverlap(L_Staff.cnt_Basic, " ᭮ ࠪ", B, E, 1, 0);
   CheckOverlap(L_Staff.cnt_ExternalCombine, " 譥 ᮢ⥫⢮", B, E, 0, 0);
  ELSIF Staff.Contract = L_Staff.cnt_ContractorsAgreement THEN
   IF checkContractorsAgreement THEN
    SELECT(Staff, MyFirm, , StaffMyFirm, Man.Man);
    WHILE OCCURE(Staff) DO
     CheckContracts(0);
     NEXT(Staff);
    END; (* WHILE OCCURE(Staff) ... *)
   END;
  ELSE
   L_General.Error("࠭ ⨯ ");
  END;
  RESTORE(Staff);
 END {CheckContracts};

 PRIVATE PROCEDURE CheckManInvariability();
  VAR
   P: DATE;
 BEGIN
  IF Staff.Man # GE_PVALUE(Staff.Man) THEN
   L_General.Error("⨬  䨧᪮ .|| ࠢ 訡筮 㪠 " +
                   "|᫥ 㤠   ࠪ| ନ ࠡ⭨ .");
  END;
 END {CheckManInvariability};

 PRIVATE PERMANENT VAR
  ManToReferByNewStaff: LIKE(Man.Man);

 PRIVATE PROCEDURE CheckManHasAnotherStaff(_TSN: LIKE(Staff.TSN); _Man: LIKE(Staff.Man));
  CONST
   BasicLen = 70;
  VAR
   MOTop,
   MOSign,
   Msg    : STRING[];
   Len    : NUMERIC[0];
 BEGIN
  IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   Len:=BasicLen + 6;
   MOTop:="    ";
  ELSE
   Len:=BasicLen;
   MOTop:="";
  END;
  SAVE(Staff);
  L_General.CallUs(SEARCH(Man, Man, _Man));
  Msg:="";
  SELECT(Staff, Man, , _Man);
  WHILE OCCURE(Staff) DO
   IF Staff.TSN # _TSN THEN
    IF !Msg THEN
     Msg:="࠭ 䨧 "+L_Str.IntStr(Man.Man) + " " + Man.Name +
          "|" +
          "|, 㡥,   ࠫ ࠢ쭮 䨧᪮ ."+
          "|   䨧  宦   㣨 ४⠬| |"+
          Str.Align(" 騥  䨧 " + L_Str.IntStr(Man.Man) + " ࠪ:", Len, LEFT)+
          "||" +
          Str.Align(MOTop + "                                     ", Len, LEFT) +
          "|" +
          L_Str.Repeat("", Len) +
          "|";
    END;
    SETSEL(StaffLog, TSN, Staff.TSN);
    LAST(StaffLog);
    CONFORM(StaffLog, Post);
    CONFORM(StaffLog, Sort);
    IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
     CONFORM(Staff, MyFirm);
     MOSign:=Str.Align(MyFirm.vzSign, 6, LEFT);
    ELSE
     MOSign:="";
    END;
    Msg:=Msg + Str.Align(MOSign + Staff.TSN +
                         " " + L_Str.PoolItem(L_Staff.cnt_Pool, Staff.Contract) +
                         " " + L_DatTim.DateStr(Staff.BegDate) +
                         " " + L_DatTim.DateStr(Staff.EndDate) +
                         " " + Str.Align(Sort.Name, 19, LEFT) +
                         " " + Str.Align(Post.Name, 19, LEFT),
                         Len, LEFT) + "|";
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  IF ~!Msg THEN
   L_StdFrm.Question(Msg);
  END;
  RESTORE(Staff);
 END {CheckManHasAnotherStaff};

 PUBLIC PROCEDURE MakeNewTSN();
 BEGIN
  ACCESS(Man);
  CheckManApplicability();
  L_StdFrm.Question("ନ  ࠪ ( ࠡ⭨)");
  ManToReferByNewStaff:=Man.Man;
  LIKEMENU(View, "Staff_A 1", Ins, "StaffE 0");
 END {MakeNewTSN};

 PRIVATE PROCEDURE StaffE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["Staff.Contract", "Staff.Man"]);
  L_WDO.iUnmodifiable(0, ["Staff.BegDate", "Staff.EndDate"]);
  IF L_APtm.IsOG() THEN
   L_WDO.iUnmodifiable(0, ["Staff.TSN"]);
  END;
  L_WDO.iField       (0, "Staff.Contract").Format:=L_Staff.cnt_Pool_Full;
  L_WDO.iSubwindow   (1, "StaffEE");
 END {StaffE_OnInitializeWindow};

 PRIVATE PROCEDURE Staff_A_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "StaffE");
  L_WDO.iField       (1, "Staff.Contract").Format:=L_Staff.cnt_Pool;
 END {Staff_A_OnInitializeWindow};

 PRIVATE PROCEDURE Staff_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "StaffE");
  L_WDO.iField       (1, "Staff.Contract").Format:=L_Staff.cnt_Pool;
 END {Staff_OnInitializeWindow};

 PRIVATE PROCEDURE LoadPhoto();
 BEGIN
  IF ~!Staff.Man THEN
   RTI.Get().CurZone.Fields("Photo").Value:=L_GUI.SoftLoadPicture(P_Man.GetFullPhotoFileName(P_Man.GetManProSoft(Staff.Man, Memo.ud_cd(), P_Man.P_ManPhoto)));
  ELSE
   RTI.Get().CurZone.Fields("Photo").Value:=EMPTYOF(PICTURE);
  END;
 END {LoadPhoto};

 PRIVATE PROCEDURE StaffE_0_OnReposition();
 BEGIN
  LoadPhoto();
 END {StaffE_0_OnReposition};

 PRIVATE PROCEDURE Staff_OnBeforeEdIns();
 BEGIN
  L_AR.GrantRightsForInteractiveModification();
 END {Staff_OnBeforeEdIns};

 PRIVATE PROCEDURE Staff_TSN_SetOnBeforeAsk(OnBeforeAsk: SCAL[2]);
 BEGIN
  RTI.Get().CurWindow.Zones(0).Fields("Staff.TSN").AskMode:=WFD_ASK_SYSTEM;
  RTI.Get().CurWindow.Zones(0).Fields("Staff.TSN").OnBeforeAsk:=OnBeforeAsk;
 END {Staff_TSN_SetOnBeforeAsk};

 PRIVATE PROCEDURE Staff_OnBeforeEdit();
 BEGIN
  Staff_OnBeforeEdIns();
  Staff_TSN_SetOnBeforeAsk(0);
 END {Staff_OnBeforeEdit};

 PRIVATE PROCEDURE Staff_OnBeforeInsert();
  VAR
   FlagEdit: SCAL[2];
 BEGIN
  Staff_OnBeforeEdIns();
  Staff_TSN_SetOnBeforeAsk(1);
  FlagEdit:=1;
  IF VAR_IMPL.Get(ManToReferByNewStaff).Initialized THEN
   IF ~!ManToReferByNewStaff THEN
    TRY
     FlagEdit:=0;
     SEARCH(Man, Man, , ManToReferByNewStaff);
     Staff.Man   :=Man.Man;
     REPLACE(Staff);
     intStaff_Man_OnSuccessfulChange();
    EXCEPT
    FINALLY
     SETEMPTY(ManToReferByNewStaff);
    END; (* TRY *)
   END;
  END;
  Staff.MyFirm:=P_Firm.DefineMyFirm();
  REPLACE(Staff);
  RTI.Get().CurZone.Fields("Staff.Man").Modifiable:=FlagEdit;
 END {Staff_OnBeforeInsert};

 PRIVATE PROCEDURE Staff_OnAfterInsert();
  VAR
   dmyXObject: LIKE(XObject.XObject);
 BEGIN
  Close();
  CheckContracts(0);
  L_Man.CheckManActvForPrvWork(Staff.Man);
  L_XObj.AfterOriginInsert(L_XObj.o_Staff, Staff.MyFirm);
  dmyXObject:=L_XObj.ObtainManXObject(Staff.Man, Staff.MyFirm);
 END {Staff_OnAfterInsert};

 PRIVATE PROCEDURE Staff_OnAfterEdit();
 BEGIN
  Close();
  CheckContracts(1);
  CheckManInvariability();
  L_Stock.SetName_AdvHolderStorage();
 END {Staff_OnAfterEdit};

 PRIVATE PROCEDURE RemoveUnusedStaff();
  VAR
   trgTSN: LIKE(Staff.TSN);
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
  PROMPT(" ࠪ "+Staff.TSN);
  L_AcsPnt.PassAccessPoint(0000011);
  L_General.Assert(SELECT(StaffLog, TSN, Staff.TSN) & ~NEXT(StaffLog), "뫨 ਪ ஬ ਥ");

  Memo.gl_SetCurDate(Staff.BegDate);

  SE_INTEGRITY(1);
  SELECT(StaffLog, TSN, , Staff.TSN);
  SELECT(SLKind, SLType, , L_Staff.slkt_Discharge);
  WHILE OCCURE(SLKind) & ~L_DatTim.IsActive(StaffLog.Date+1, SLKind.Begin, SLKind.Till) DO
   NEXT(SLKind);
  END; (* OCCURE(SLKind) ... *)
  L_General.Assert(OCCURE(SLKind), "   饣  㢮쭥");
  StaffLog.SLKind:=SLKind.SLKind;
  INC(StaffLog.Date);
  SETEMPTY(StaffLog.CntrEnd);
  INSERT(StaffLog);
  CALL(StaffLog.StaffLog_OnAfterInsert());
  RemoveFromWO();
  APP.Get().NewPrompt("");
  PROMPT("஢ઠ 뫮  ࠡ⭨");
  L_DBD.CheckUsers("Staff");

  Close();

  PROMPT("஢ઠ  ௫");
  CONFORM(Staff, Man);
  L_Sheet.MayADDSheet(Staff.BegDate, L_Sheet.jm_ContractBreak(Staff.BegDate),
                      L_Sheet.src_Operator);
  L_Sheet.UpdateSheet(Staff.BegDate, L_Sheet.jm_ContractBreak(Staff.BegDate), 0, 0, 0, 0, L_Sheet.src_Operator);
  CALL(CalcDed.CountUp()); (*Mode_SimplyCountUp*)
  SELECT(Money, TSN, , Staff.TSN);
  WHILE OCCURE(Money) DO
   IF (Money.Tim = 0) & (Money.Sum = 0) THEN
SE_INTEGRITY(1);
    L_PRoll.Remove_Money(1);
   ELSE
    NEXT(Money);
   END;
  END; (* WHILE OCCURE(Money) ... *)
  L_General.Assert(~SELECT(Money, TSN, Staff.TSN),
                   " 㤠 -  ᫥/㤥ঠ");

  IF ~!Staff.Storage THEN
   L_Stock.mItem_CheckAllIsZero(EMPTYOF(Math.Math), Staff.Storage, 1);
   IF SEARCH(Storage2, Storage2, Staff.Storage) THEN
SE_INTEGRITY(1);
    TestUseStorage("Storage2");
    REMOVE(Storage2);
   END;
   CONFORM(Staff, Storage);
   SETEMPTY(Staff.Storage);
   REPLACE(Staff);
SE_INTEGRITY(1);
   TestUseStorage("Storage");
   REMOVE(Storage);
  END;

  trgTSN   :=Staff.TSN;
  L_XObj.BeforeOriginDelete(L_XObj.o_Staff);

  PROMPT();
  SAVE(Staff);
  IF SELECT(Staff, Man, Man.Man) & ((Staff.TSN # trgTSN) | NEXT(Staff)) THEN
   L_StdFrm.Choice("  ࠪ " + trgTSN + " 㤥 㤠." +
                   "|   ⠭ ( ࠪ " + Staff.TSN + ")");
  ELSE
   L_StdFrm.Choice("  ࠪ " + trgTSN + " 㤥 㤠." +
                   "|    ᠬ⥫쭮, ᫨   㦭 ( " + L_Man.Man_ManAsStr() + ")");
  END;

  RESTORE(Staff);
  SE_INTEGRITY(0);
 END {RemoveUnusedStaff};

 PRIVATE PROCEDURE Staff_OnBeforeDelete();
 BEGIN
  RemoveUnusedStaff();
 END {Staff_OnBeforeDelete};

 PRIVATE CONST
  lengthTSN = Str.Length(FLDTOSTR(MAXOF(Staff.TSN), "L", 0, "L"));
 PRIVATE VAR
  FreeTSNList: STRING[];

 PRIVATE PROCEDURE PutItemToFreeTSNList(begTSN, endTSN: NUMERIC[0]);
  VAR
   Item: STRING[];
 BEGIN
  IF endTSN >= begTSN THEN
   IF (endTSN - begTSN) = 0 THEN
    Item:=FLDTOSTR(begTSN, "L", lengthTSN) + "  " + FLDTOSTR(begTSN, "L", lengthTSN) + "  " + L_Str.Repeat(" ", lengthTSN)      + "  ";
   ELSIF (endTSN - begTSN) = 1 THEN
    Item:=FLDTOSTR(begTSN, "L", lengthTSN) + "  " + FLDTOSTR(begTSN, "L", lengthTSN) + ", " + FLDTOSTR(endTSN, "L", lengthTSN) + "  ";
   ELSE
    Item:=FLDTOSTR(begTSN, "L", lengthTSN) + "  " + FLDTOSTR(begTSN, "L", lengthTSN) + ".." + FLDTOSTR(endTSN, "L", lengthTSN) + "  " + FLDTOSTR(endTSN - begTSN + 1, "", lengthTSN);
   END;
   FreeTSNList:=FreeTSNList + "|" + Item;
  END;
 END {PutItemToFreeTSNList};

 PRIVATE PROCEDURE Staff_TSN_OnBeforeAsk();
  VAR
   Idx     : NUMERIC[0];
   firstTSN,
   lastTSN,
   prevTSN : LIKE(Staff.TSN);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  firstTSN:=MINOF(Staff.TSN);
  lastTSN :=MAXOF(Staff.TSN);
  SETEMPTY(FreeTSNList);
  SAVE(Staff);
  IF SELECT(Staff, TSN) & ~!Staff.TSN THEN
   PutItemToFreeTSNList(firstTSN, Staff.TSN-1);
   LOOP
    PROMPT(" ᢮ ⠡ ஢ "+Staff.TSN);
    prevTSN:=Staff.TSN;
    IF NEXT(Staff) & ~!Staff.TSN THEN
     PutItemToFreeTSNList(prevTSN+1, Staff.TSN-1);
    ELSE
     EXIT;
    END;
   END; (* LOOP *)
   PutItemToFreeTSNList(prevTSN+1, lastTSN);
  ELSE
   PutItemToFreeTSNList(firstTSN,  lastTSN);
  END;
  RESTORE(Staff);
  Idx:=L_StdFrm.ShowListAsMenu_wCaption(FreeTSNList, " ", L_Str.Repeat(" ", lengthTSN) + "  " + Str.Align("", lengthTSN*2 + 2, LEFT) + "  " +  Str.Align("", lengthTSN, RIGHT) +
                                                                         "|" +
                                                                         L_Str.Repeat("", lengthTSN) + "" + L_Str.Repeat("", lengthTSN*2 + 2)           + "" +  L_Str.Repeat("", lengthTSN));
  L_General.Assert(ACCESS(Staff), " । ⥪騩 ࠡ⭨");
  SE_INTEGRITY(1);
  Staff.TSN:=Str.Slice(L_Str.PoolItem(FreeTSNList, Idx), 0, lengthTSN);
  REPLACE(Staff);
 END {Staff_TSN_OnBeforeAsk};

 PRIVATE PROCEDURE Staff_Contract_OnSuccessfulChange();
  VAR
   P       : DATE;
   OldAcCut: LIKE(AcCut.AcCut);
 BEGIN
  IF ~L_Staff.IsLabourContract(Staff.Contract) THEN
   L_StdFrm.Question("⠭ ⨯  '" + L_Staff.GetStaffContract_asStr() + "'");
  END;
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit THEN
   P:=Math.Max(L_Env.aptm_Start, L_DatTim.Per(Staff.BegDate));
   L_General.Assert_wReferToAdmin(~L_APtm.MonthIsClosed(P, L_APtm.system_Salary),
                                  " ஢  㤮   ᫮|"+
                                  "  㤮  ᫥ ନ  ࠪ");
   TRY [ABORT_AFTER(AA_ON)]
    Staff.Contract:=GE_PVALUE();
    REPLACE(Staff);
    OldAcCut:=L_PRoll.GetSalaryAcCut(P);
   EXCEPT
   END; (* TRY *)
   IF (L_PRoll.GetSalaryAcCut(P) # OldAcCut) & SELECT(XCalc, XObject, Staff.XObject) THEN
    L_General.Error("    ᮡ  ⭮襭  ⭮ ࠧ१.||"+
                    "㦭 㤠    ࠡ⭨  ନ ");
   END;
   L_PRoll.AveDone_AP_withoutCheck(P, 0);
  END;
 END {Staff_Contract_OnSuccessfulChange};

 PRIVATE PROCEDURE intStaff_Man_OnSuccessfulChange();
 BEGIN
  L_Man.CheckIfManIsIdentified(Staff.Man, 1);
  CheckManHasAnotherStaff(Staff.TSN, Staff.Man);
  CONFORM(Staff, Man);
  Staff.Name:=L_Man.GetStaffName();
  IF L_APtm.IsOG() THEN
   TRY [INTEGRITY(INTEGRITY_ON), EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    Staff.TSN :=Staff.Man;
    REPLACE(Staff);
   EXCEPT
   ON Exc: Exc_Root DO
    IF Exc.ErrorCode = L_General.ec_rt_UniquenessViolation THEN
     L_General.InformUs("㦭 ନ   ⠡   , ⮬  ...");
    END;
   END; (* TRY *)
  END;
  REPLACE(Staff);
  LoadPhoto();
 END {intStaff_Man_OnSuccessfulChange};

 PRIVATE PROCEDURE Staff_Man_OnSuccessfulChange();
 BEGIN
  intStaff_Man_OnSuccessfulChange();
  IF L_APtm.IsOG() THEN
   CONFORM(Man, am);
   CONFORM(am, MyFirm);
   L_General.Assert(Staff.MyFirm = am.MyFirm, " ⭮  㣮  (" + MyFirm.vzSign + ")");
  END;
 END {Staff_Man_OnSuccessfulChange};

 PRIVATE PROCEDURE E_StaffGetOtherInformationAboutStaff();
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Staff.GetOtherInformationAboutStaff);
  IF ~!Local THEN
   Local(OtherInformationAboutStaff);
  END;
 END {E_StaffGetOtherInformationAboutStaff};

 PRIVATE PROCEDURE StaffNow_OnInitializeWindow();
 BEGIN
  L_WDO.iZone        (0).ViewOnly:=1;
  L_WDO.iZone        (0).OnRedraw:=1;
  L_WDO.iProgs       (0, "Staff");
 END {StaffNow_OnInitializeWindow};

 PRIVATE PROCEDURE StaffNow_0_OnRedraw();
 BEGIN
  L_General.CallUs(ACCESS(Staff));
  HISTCONF(Memo.ud_cd(), Staff, StaffLog);
  curStaffLog_DateE_Type:=" ";
  SETEMPTY(OtherInformationAboutStaff);
  IF OCCURE(StaffLog) THEN
   IF    !StaffLog.DateE THEN
    curStaffLog_DateE_Type:=" ";
   ELSIF StaffLog.DateE = Staff.EndDate THEN
    curStaffLog_DateE_Type:=" 㢮쭥";
   ELSE
    curStaffLog_DateE_Type:="ॢ";
   END;
   E_StaffGetOtherInformationAboutStaff();
  END;
 END {StaffNow_0_OnRedraw};

 PRIVATE PROCEDURE StaffNow_OnConformToWindow();
 BEGIN
  GE_WWD_CURSOR(RTI.Get().CurWindow.Name, Staff);
  SE_WWD_CURSOR(RTI.Get().ConformTargetWindow.Name, Staff);
 END {StaffNow_OnConformToWindow};

 PRIVATE PROCEDURE RemoveFromWO();
  VAR
   i: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" 筮 鸞");
  SAVE(Staff);
  SAVE(StaffLog);
  IF SELECT(Mtwo, TSN, Staff.TSN) THEN
   REMSEL(Mtwo);
  END;
  SETSEL(Mtwo, Per);
  SRCINSEL(Mtwo, GE, , L_DatTim.Per(Staff.BegDate));
  WHILE OCCURE(Mtwo) DO
   PROMPT(" 筮 鸞: " + L_DatTim.DateStr(Mtwo.Per));
   i:=0;
   WHILE i<=HIGH(Mtwo.CooTSN) DO
    IF Mtwo.CooTSN[i] = Staff.TSN THEN
     SETEMPTY(Mtwo.CooTSN);
     Mtwo.Actual:=0;
     REPLACE(Mtwo);
    END;
    INC(i);
   END;
   NEXT(Mtwo);
  END; (* WHILE OCCURE(Mtwo) ... *)

  IF SELECT(Dtwo, TSN, Staff.TSN) THEN
   REMSEL(Dtwo);
  END;
  SETSEL(Dtwo, DGuardTSN);
  SRCINSEL(Dtwo, GE, , Staff.BegDate);
  WHILE OCCURE(Dtwo) DO
   NARROWSEL(Dtwo, Date);
   PROMPT("  冷: " + L_DatTim.DateStr(Dtwo.Date));
   IF SRCINSEL(Dtwo, GE, Staff.TSN) THEN
    WHILE Dtwo.GuardTSN=Staff.TSN DO
     SETEMPTY(Dtwo.GuardTSN, Dtwo.GuardNam);
     L_two.d_c_FillDependent();
     NEXT(Dtwo);
    END; (* WHILE OCCURE(Dtwo) ... *)
   END;
   NEXTINEXTENDEDSEL(Dtwo, Date);
  END; (* WHILE OCCURE(Dtwo) ... *)

  IF SELECT(Ptwo, TSN, Staff.TSN) THEN
   REMSEL(Ptwo);
  END;
  RESTORE(Staff);
  RESTORE(StaffLog);
 END {RemoveFromWO};

 PRIVATE PROCEDURE TestUseStorage(File: STRING[]);
 BEGIN
  PROMPT("஢ઠ ᯮ짮  ࠭ "+Staff.Storage);
  IF ~L_DBD.TestUsers(File, 1) THEN
   L_General.Assert(~SELECT(MDoc, ^File, Staff.Storage), " ࠭ "+Staff.Storage+" ᯮ| "+L_MDoc.GetMDocStrNbr());
   L_DBD.CheckUsers(File);
  END;
 END {TestUseStorage};

 PUBLIC PROCEDURE ShowAccountableStaffBalance(Full: SCAL[2]);
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  IF L_PDoc.E_AllowAnyStaffMyFirmInAnyPDocList() THEN
   ShowAccountableManBalance(Full);
  ELSE
   L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly,
                                L_Pmnt.ShowAccountableManHistory(Staff.Man, Staff.MyFirm, Full), "");
  END;
 END {ShowAccountableStaffBalance};

 PUBLIC PROCEDURE ShowAccountableManBalance(Full: SCAL[2]);
  VAR
   List     : STRING[];
   mfList   : STRING[];
   cntItem  : NUMERIC[0];
   trgMyFirm: LIKE(MyFirm.MyFirm);
 BEGIN
  L_General.Assert(ACCESS(Man), " ⠭ 䨧᪮ ");
  SETEMPTY(List, mfList);
  SETZERO(cntItem);
  SELECT(mfMan, Man, , Man.Man);
  WHILE OCCURE(mfMan) DO
   CONFORM(mfMan, MyFirm);
   List  :=List + MyFirm.MyFirm + " " + Str.Align(MyFirm.Name, 32, LEFT) + " " + MyFirm.vzSign + "|";
   mfList:=mfList + MyFirm.MyFirm + "|";
   INC(cntItem);
   NEXT(mfMan);
  END;

  IF cntItem = 1 THEN
   trgMyFirm:=L_Str.PoolItem(mfList, 0);
  ELSE
   trgMyFirm:=L_Str.PoolItem(mfList, L_StdFrm.ShowListAsMenu(List, "롮 '' ࣠樨"));
  END;
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly,
                               L_Pmnt.ShowAccountableManHistory(Man.Man, trgMyFirm, Full), "");
 END {ShowAccountableManBalance};

 PUBLIC PROCEDURE ViewSalaryDepositXCalc();
 BEGIN
  Memo.gl_SetCurDate(SYSDATE());
  CALL(CalcDed.CountUp());
  CALL(XCalc.ViewStaffManXCalcByERKN(L_AcCut.erkn_SalaryDeposit));
 END {ViewSalaryDepositXCalc};

 PUBLIC PROCEDURE SetStaffStorage();
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  IF ~!Staff.Storage THEN
   L_StdFrm.BlueStop("⭨ 㦥 ᮯ⠢  ⭮ ");
  END;
  L_StdFrm.Choice("  ନ ࠡ⭨  ⭮ ?"+
                  "||" +
                  "(筮,  뢠 㦭  ।  /  /)");
  L_StdFrm.Inform("ଫ  " + L_Stock.Obtain_AdvHolderStorage(Staff.TSN, Staff.BegDate));
 END {SetStaffStorage};

 PUBLIC PROCEDURE ShowPhoto();
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
  CONFORM(Staff, Man);
  CALL(Man.ShowPhoto());
 END {ShowPhoto};

(*
$P{ CardCode_Distribution:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Man.Man, L, ""
?, L, "L"
?, L, "L"
?, L, ""
?, L, ""
Man.Name, L, ""
?, L, ""
?, L, ""
@
########################################################## ########## #####


               뤠 ᪮⠪⭮ -ய᪠ N #####

뤠 ᪮⠪⭠ -ய:  ####,  ##### (##########)




ᮭ쭠  㯠 ਭ ।.

  ⠭   ࠡ⭨.

 ᤠ ࠡ⭨  ⤥ ஢  㢮쭥

 ᫮ ࠭  ᯫ樨 ᪮⠪⭮  饭.






稫 ##### ##################################                ___________


뤠   ##### ##################################                ___________
}
*)

(*
$P{ CardCode_Retirement:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Man.Man, L, ""
?, L, "L"
?, L, "L"
?, L, ""
?, L, ""
Man.Name, L, ""
?, L, ""
?, L, ""
@
########################################################## ########## #####


                 ᪮⠪⭮ -ய᪠ N ####

 ᪮⠪⭠ -ய:  ####  ##### (##########)





   ##### ##################################                 ___________


ਭ ##### ##################################                 ___________
}
*)

(*
$P{ CardCode_PutInStopList:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Man.Man, L, ""
?, L, "L"
?, L, "L"
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
########################################################## ########## #####


        饭  ⮯- ᪮⠪⭮ -ய᪠ N ####

᪮⠪⭠ -ய  ####  ##### (##########),
뤠 ##################################################################
饭  ⮯-.


ᯮ⥫ ##### ##################################            ___________
}
*)

(*
$P{ CardCode_ThrowFromStopList:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
Man.Man, L, ""
?, L, "L"
?, L, "L"
?, L, ""
?, L, ""
?, L, ""
@
########################################################## ########## #####


       㤠  ⮯- ᪮⠪⭮ -ய᪠ N ####

᪮⠪⭠ -ய  ####  ##### (##########)
㤠  ⮯-.



ᯮ⥫ ##### ##################################            ___________
}
*)

 PRIVATE PROCEDURE PosToPuttingCardInStopList(CardCode: NUMERIC[0]): SCAL[2];
  VAR
   Result : SCAL[2];
   trgMan : LIKE(Man.Man);
   maxDate: DATE;
 BEGIN
  SETEMPTY(trgMan);
  Result :=0;
  maxDate:=MINOF(DATE);
  SELECT(ManPro, Property, , P_Man.P_Pass, L_Str.IntStr(CardCode));
  WHILE OCCURE(ManPro) DO
   IF maxDate <= ManPro.Date THEN
    trgMan :=ManPro.Man;
    maxDate:=ManPro.Date;
    Result :=ManPro.DocGiveS = pc_InStopList;
   END;
   NEXT(ManPro);
  END; (* WHILE OCCURE(ManPro) ... *)
  IF ~!trgMan THEN
   SEARCH(ManPro, Man, , trgMan, P_Man.P_Pass, maxDate);
  END;
  RETURN Result;
 END {PosToPuttingCardInStopList};

 PRIVATE PROCEDURE AccessManByProximityCard(    D         : DATE;
                                                Operation : STRING[];
                                            VAR CardCode  : NUMERIC[0];
                                            VAR CardFamily: NUMERIC[0];
                                            VAR CardNumber: NUMERIC[0];
                                            VAR pcs       : L_Staff.tProximityCardStatus);
 BEGIN
  SETEMPTY(CardCode);
  CardCode:=P_Man.GetCardCode(L_ACS.ct_Wiegand26, Operation, "", "");
  IF ~!CardCode THEN
   CardFamily:=L_ACS.Wiegand26CardFamily(CardCode);
   CardNumber:=L_ACS.Wiegand26CardNumber(CardCode);
   IF    P_Man.SingleSpeedSearch(D, P_Man.P_Pass, L_Str.IntStr(CardCode)) THEN
    CONFORM(ManPro, Man);
    pcs:=pcs_Givenout;
   ELSIF PosToPuttingCardInStopList(CardCode) THEN
    CONFORM(ManPro, Man);
    pcs:=pcs_InStopList;
   ELSE
    pcs:=pcs_Unknow;
   END;
   L_ACS.perco_ForgetGotCardCode();
  ELSE
   SETEMPTY(pcs);
  END;
 END {AccessManByProximityCard};

 PRIVATE PROCEDURE AccessRealManByProximityCard(    D         : DATE;
                                                    Operation : STRING[];
                                                VAR CardCode  : NUMERIC[0];
                                                VAR CardFamily: NUMERIC[0];
                                                VAR CardNumber: NUMERIC[0];
                                                VAR pcs       : L_Staff.tProximityCardStatus;
                                                VAR ErrMsg    : STRING[]);
 BEGIN
  AccessManByProximityCard(D, Operation, CardCode, CardFamily, CardNumber, pcs);
  IF !pcs THEN
   ErrMsg:="  ⠭!";
  ELSIF    pcs = pcs_InStopList THEN
   ErrMsg:=" ᥭ  StopList!"
  ELSIF pcs = pcs_Unknow THEN
   ErrMsg:="    뤠!";
  ELSE
   ErrMsg:="";
  END;
 END {AccessRealManByProximityCard};

 PUBLIC PROCEDURE AuthoriseByProximityCard(Operation: STRING[]);
  VAR
   CardFamily,
   CardNumber,
   CardCode  : NUMERIC[0];
   ErrMsg    : STRING[];
   OnDate    : DATE;
   pcs       : L_Staff.tProximityCardStatus;
 BEGIN
  AccessRealManByProximityCard(SYSDATE(), Operation, CardCode, CardFamily, CardNumber, pcs, ErrMsg);
  L_General.Assert(!ErrMsg, ErrMsg);
 END {AuthoriseByProximityCard};

 PRIVATE PROCEDURE CloseManPro(_Date: DATE; _DocGiveS: STRING[]);
 BEGIN
  ManPro.DocExpD :=_Date;
  ManPro.DocGiveS:=_DocGiveS;
  REPLACE(ManPro);
  L_Prop.SupportEndDate("ManPro", P_Man.P_Pass, 1);
 END {CloseManPro};

 PRIVATE PROCEDURE ProximityCardOperation(pc_Create: SCAL[2]);
  CONST
   CardType = L_ACS.ct_Wiegand26;
   DeadLine = 5;
  VAR
   DocNum    : STRING[];
   CardFamily,
   CardNumber,
   CardCode  : NUMERIC[0];
   curTSN    : LIKE(Staff.TSN);
   Msg,
   ErrMsg,
   curManName: STRING[];
   OnDate    : DATE;
   SpecialRetirement: SCAL[3];
   ManRole   : STRING[];
   asTSN     : STRING[];
 BEGIN
  OnDate    :=SYSDATE();
  curTSN    :=L_Staff.Man2TSN(OnDate, P_Man.curUSER2Man(), EMPTYOF(P_Firm.tMyFirm), 0, 1);
  curManName:=P_Man.GetFullNameOfCurrentUser(OnDate);
  IF   pc_Create & ACCESS(Staff) THEN
   CONFORM(Staff, Man);
   L_General.Assert(L_Staff.InStateInPer(OnDate, OnDate + DeadLine),
                    "⭨ " + Staff.TSN + "  室    " + L_DatTim.DateStr(OnDate) + "." +
                    L_StdFrm.HR() +
                    "᫨ ࠡ⭨   㯨  ࠡ, ய  |" +
                    "뤠  ࠭ 祬  " + L_Str.IntStr(DeadLine) + " .  室  ࠡ.||" +
                    "᫨ ࠡ⭨  ஭ ।⠢⥫,|" +
                    "ய 室 뤠 䨧᪮ ");
   asTSN  :=Staff.TSN;
   ManRole:="⭨ " + Staff.TSN;
  ELSIF P_Man.InteractiveAccessStaffByMan(OnDate, ~pc_Create) THEN
   asTSN  :=Staff.TSN;
   ManRole:="⭨ " + Staff.TSN;
  ELSE
   asTSN  :="/";
   ManRole:="";
  END;
  L_Man.CheckIfManIsIdentified(Man.Man, 1);
  L_General.Assert(~pc_Create | ~P_Man.HasActualManPro(Man.Man, OnDate, P_Man.P_Pass),
                   " 㦥  -ய.|" +
                   "᫨ 室 ନ 뤠  ,|" +
                   "ॡ ନ ⨥ ன .");
  SETEMPTY(ErrMsg, CardCode);
  SpecialRetirement:=0;
  PROMPT(L_Str.PoolItem("⨥ -ய᪠|뤠 -ய᪠", pc_Create));
  LOOP
   CardCode:=P_Man.GetCardCode(CardType,
                               L_Str.PoolItem("⨥ -ய᪠|뤠 -ய᪠", pc_Create),
                               ErrMsg,
                               ManRole + " " + L_Str.ShortName(Man.Name) + "||");
   SETEMPTY(ErrMsg);
   IF ~!CardCode THEN
    IF    P_Man.SingleSpeedSearch(OnDate, P_Man.P_Pass, L_Str.IntStr(CardCode)) THEN
     IF pc_Create THEN
      ErrMsg:="  㦥 뤠  " + L_Str.IntStr(ManPro.Man) + ".||" +
              "।⥫쭮 室 ନ|⨥   .";
     ELSE
      L_General.Assert(ManPro.Man = Man.Man,
                       "।  뤠 㣮  (" + L_Str.IntStr(ManPro.Man) + ")");
     END;
    ELSIF ~pc_Create THEN
     L_StdFrm.Choice("।   ॣ஢  ⮏."+
                     "|,  १ ᡮ   뤠");
     SpecialRetirement:=2;
    END;
    IF ~pc_Create THEN
     IF P_Man.HasActualManPro(Man.Man, OnDate, P_Man.P_Pass) THEN
      IF (ManPro.Date = OnDate) THEN
       SpecialRetirement:=1;
      END;
     ELSE
      L_General.CallUs(SpecialRetirement = 2);
     END;
    END;

    IF pc_Create THEN
     L_General.Assert(~PosToPuttingCardInStopList(CardCode), " ᥭ  StopList! 뤠 !");
    END;
   END;
   IF !ErrMsg THEN
    EXIT;
   END;
   L_ACS.perco_ForgetGotCardCode();
  END; (* LOOP *)

  IF ~!CardCode THEN
   TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)]
    L_General.CallUs(CardType = L_ACS.ct_Wiegand26);
    CardFamily:=L_ACS.Wiegand26CardFamily(CardCode);
    CardNumber:=L_ACS.Wiegand26CardNumber(CardCode);
    IF SpecialRetirement = 1 THEN
     REMOVE(ManPro);
     SETSEL(ManPro, Man, Man.Man, P_Man.P_Pass);
     IF LAST(ManPro) THEN
      L_Prop.SupportEndDate("ManPro", P_Man.P_Pass, 1);
     END;
     L_ACS.CM_Withdraw(CardCode);
     L_StdFrm.Inform("ଫ 孨᪮ ⨥ , 뤠 ᥣ");
    ELSIF SpecialRetirement = 2 THEN
     L_ACS.CM_Withdraw(CardCode);
     L_StdFrm.Inform("ଫ 孨᪮ ⨥ , ॣ஢  ⮏");
    ELSE
     IF pc_Create THEN
      DocNum:=L_ACS.CardCodeAsStr(CardCode);
      P_Man.InsertProperty(Man.Man, OnDate, P_Man.P_Pass,
                           L_Str.PoolItem(L_ACS.ct_Pool, CardType) + ";" + L_Str.IntStr(CardCode),
                           1, DocNum, "", OnDate, EMPTYOF(DATE));
      ManPro.SpdSrchV:=L_Str.IntStr(CardCode);
      REPLACE(ManPro);
      L_ACS.CM_PutStaff(CardCode);
      Msg:="ଫ 뤠 .|| 㤥 ⠭ ' 뤠'";
     ELSE
      CloseManPro(OnDate, "");
      L_ACS.CM_Withdraw(CardCode);
      Msg:="ଫ ⨥ .|| 㤥 ⠭ ' '";
     END;
     L_StdFrm.Inform(Msg);
     LOOP
      TRY
       OPENREP(R, L_General.NameConnection("Distribution"), Print);
       IF pc_Create THEN
        MAKEPART(R, CardCode_Distribution, CardFamily, CardNumber, FLDTOSTR(CardCode, "L", 10), asTSN, curTSN, curManName);
       ELSE
        MAKEPART(R, CardCode_Retirement,   CardFamily, CardNumber, FLDTOSTR(CardCode, "L", 10), asTSN, curTSN, curManName);
       END;
       CLOSEREP(R);
       EXIT;
      EXCEPT
      ON Exc: Exc_Root DO
       L_StdFrm.RedInform(Exc.MsgOriginalText +
                          "||" +
                          " ࠭ ஡   ''");
      END; (* TRY *)
     END; (* LOOP *)
    END; (* IF SpecialRetirement *)
   EXCEPT
   END;
  ELSE
   L_StdFrm.RedInform(L_Str.PoolItem("⨥|뤠", pc_Create) + " ய᪠ ࢠ" +
                      L_Str.PoolItem("|", pc_Create));
  END;
 END {ProximityCardOperation};

 PUBLIC PROCEDURE CreateProximityCard();
 BEGIN
  ProximityCardOperation(1);
 END {CreateProximityCard};

 PUBLIC PROCEDURE RetirementProximityCard();
 BEGIN
  ProximityCardOperation(0);
 END {RetirementProximityCard};

 PUBLIC PROCEDURE PutProximityCardInStopList();
  VAR
   OnDate     : DATE;
   CardType   : L_ACS.tCardType;
   CardFamily,
   CardNumber,
   CardCode   : NUMERIC[0];
   CardHolder : STRING[];
   curManName : STRING[];
   curTSN     : LIKE(Staff.TSN);
 BEGIN
  OnDate:=SYSDATE();
  curTSN    :=L_Staff.Man2TSN(OnDate, P_Man.curUSER2Man(), EMPTYOF(P_Firm.tMyFirm), 0, 1);;
  curManName:=P_Man.GetFullNameOfCurrentUser(OnDate);
  IF P_Man.InteractiveAccessStaffByMan(OnDate, 1) THEN
   CardHolder:="⭨ " + Staff.TSN + "(" + Man.Name + ")";
  ELSE
   CardHolder:="᪮  " + L_Str.FixedIntStr(Man.Man, 5) + "(" + Man.Name + ")";
  END;
  P_Man.GetPassAttributes(Man.Man, OnDate, CardType, CardCode);
  L_General.Assert(~!CardCode, " ࠡ⭨  饩 -ய᪠");
  L_General.CallUs(CardType = L_ACS.ct_Wiegand26);
  CardFamily:=L_ACS.Wiegand26CardFamily(CardCode);
  CardNumber:=L_ACS.Wiegand26CardNumber(CardCode);
  PROMPT("饭 -ய᪠  ⮯-");
  L_StdFrm.Choice(" -ய " + L_ACS.CardCodeAsStr(CardCode) + "  ⮯-");
  CloseManPro(OnDate, pc_InStopList);
  L_ACS.CM_ToStopList(CardCode);
  L_StdFrm.Inform(" 饭  ⮯-|| 㤥 ⠭ ");
  LOOP
   TRY
    OPENREP(R, L_General.NameConnection("Distribution"), Print);
    MAKEPART(R, CardCode_PutInStopList, CardFamily, CardNumber, FLDTOSTR(CardCode, "L", 10), CardHolder,
                                        curTSN, curManName);
    CLOSEREP(R);
    EXIT;
   EXCEPT
   ON Exc: Exc_Root DO
    L_StdFrm.RedInform(Exc.MsgOriginalText +
                       "||" +
                       " ࠭ ஡   ''");
   END; (* TRY *)
  END; (* LOOP *)
  SysLog.Mark("PCrd_PutInSL", L_ACS.CardCodeAsStr(CardCode));
 END {PutProximityCardInStopList};

 PUBLIC PROCEDURE ThrowProximityCardFromStopList();
  CONST
   CardType = L_ACS.ct_Wiegand26;
  VAR
   CardFamily,
   CardNumber,
   CardCode     : NUMERIC[0];
   OnDate       : DATE;
   curManName: STRING[];
   curTSN    : LIKE(Staff.TSN);
 BEGIN
  OnDate:=SYSDATE();
  curTSN    :=L_Staff.Man2TSN(OnDate, P_Man.curUSER2Man(), EMPTYOF(P_Firm.tMyFirm), 0, 1);
  curManName:=P_Man.GetFullNameOfCurrentUser(OnDate);
  SETEMPTY(CardCode);
  CardCode:=P_Man.GetCardCode(CardType, " -ய᪠  ⮯-", "", "");
  IF ~!CardCode THEN
   L_General.Assert(PosToPuttingCardInStopList(CardCode), " ଫ ᥭ   ⮯-");
   ManPro.DocGiveS:=pc_InStopList + "  " + L_DatTim.DateStr(OnDate);
   REPLACE(ManPro);
   CONFORM(ManPro, Man);
   L_General.CallUs(CardType = L_ACS.ct_Wiegand26);
   L_ACS.CM_ThrowFromStopList(CardCode);
   L_StdFrm.Inform(" 㤠  ⮯-|| 㤥 ⠭ ");
   CardFamily:=L_ACS.Wiegand26CardFamily(CardCode);
   CardNumber:=L_ACS.Wiegand26CardNumber(CardCode);
   LOOP
    TRY
     OPENREP(R, L_General.NameConnection("Distribution"), Print);
     MAKEPART(R, CardCode_ThrowFromStopList, CardFamily, CardNumber, FLDTOSTR(CardCode, "L", 10),
                                             curTSN, curManName);
     CLOSEREP(R);
     EXIT;
    EXCEPT
    ON Exc: Exc_Root DO
     L_StdFrm.RedInform(Exc.MsgOriginalText +
                        "||" +
                        " ࠭ ஡   ''");
    END; (* TRY *)
   END; (* LOOP *)
   SysLog.Mark("PCrd_ThrowFromSL", L_ACS.CardCodeAsStr(CardCode));
  END;
 END {ThrowProximityCardFromStopList};

 PUBLIC PROCEDURE CheckProximityCard();
  VAR
   CardFamily,
   CardNumber,
   CardCode     : NUMERIC[0];
   curCardHolder: STRING[];
   OnDate       : DATE;
   pcs          : L_Staff.tProximityCardStatus;
 BEGIN
  OnDate:=SYSDATE();
  AccessRealManByProximityCard(SYSDATE(), "஢ઠ -ய᪠",
                               CardCode, CardFamily, CardNumber, pcs, curCardHolder);
  IF ~!pcs THEN
   IF (pcs = pcs_Givenout) | (pcs = pcs_InStopList) THEN
    curCardHolder:=Man.Name + "||" + curCardHolder;
    IF L_Staff.IsStandOnAnyMainContract(Man.Man, OnDate+365) THEN
     curCardHolder:=Staff.TSN + " " + curCardHolder;
    END;
   END;
   L_StdFrm.Inform("᪮⠪⭠ -ய:|" +
                   L_ACS.CardCodeAsStr(CardCode) + " (" + FLDTOSTR(CardCode, "L", 10) + ")" +
                   "||" +
                   curCardHolder);
  END;
 END {CheckProximityCard};

 PUBLIC PROCEDURE ACS_RenovateStaffInfo();
  VAR
   IsStaff : SCAL[2];
   CardType: L_ACS.tCardType;
   CardCode: NUMERIC[0];
 BEGIN
  IF ACCESS(Staff) THEN
   L_General.Assert(L_Staff.rInState(SYSDATE()), "⭨ 㦥 㢮.||" +
                                                 "᫨  騩    ஭ ।⠢⥫,|" +
                                                 " ଠ樨 ᫥ 믮  ࠢ筨 ");
   IsStaff:=1;
   CONFORM(Staff, Man);
  ELSE
   IsStaff:=P_Man.InteractiveAccessStaffByMan(SYSDATE(), 0);
  END;
  P_Man.GetPassAttributes(Man.Man, SYSDATE(), CardType, CardCode);
  L_General.Assert(~!CardCode, " " + L_Str.PoolItem("஭ ।⠢⥫|ࠡ⭨", IsStaff) + "  饩 -ய᪠");
  PROMPT(" ଠ樨  " + L_Str.PoolItem("஭ ।⠢⥫|ࠡ⭨", IsStaff) + " (⮏->)");
  L_ACS.CM_Renovate(CardCode);
  L_StdFrm.Inform("ଠ ");
 END {ACS_RenovateStaffInfo};

 PRIVATE PROCEDURE TooSimplePINCode(PINCode: STRING[PINCodeLength]): SCAL[2];
  VAR
   i     : NUMERIC[0];
   Symbol,
   Template: STRING[];
 BEGIN
  Symbol  :=Str.Slice(PINCode, 0, 1);
  Template:="";
  i:=0;
  WHILE i < PINCodeLength DO
   Template:=Template + Symbol;
   INC(i);
  END; (* WHILE i < PINCodeLength...*)
  RETURN PINCode = Template;
 END {TooSimplePINCode};

(*
$P{ PINCode_Notification:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Man.Sex, L, "| "
L_DatTim.FullDateStr(SYSDATE()), L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
           N #####



    ########## .  #####  ᮡ-
筮 㪠 ᥪ -.
   - ⢮
#######################################


    饭#  室 ࠭ 
ᥪ ᢮ -    -
⢨ ࠧ襭 - -
஭ 栬.













########################################

##### ##################################

                             ___________

##### ##################################

                             ___________
}
*)

 PUBLIC PROCEDURE CreatePassword();
  VAR
   newPINCode,
   confPINCode: STRING[PINCodeLength];
   ErrMsg,
   FullName   : STRING[];
   _Date      : DATE;
   curMan     : LIKE(Man.Man);
   curTSN     : LIKE(Staff.TSN);
 BEGIN
  L_AcsPnt.PassAccessPoint(0000035);
  curTSN  :=L_Staff.Man2TSN(SYSDATE(), P_Man.curUSER2Man(), EMPTYOF(P_Firm.tMyFirm), 0, 1);;
  FullName:=P_Man.GetFullNameOfCurrentUser(SYSDATE());
  L_General.Assert(ACCESS(Staff), " ࠭ ࠡ⭨");
  L_General.Assert(~SEARCH(ManPro, Man, Staff.Man, P_Man.P_PINCode, SYSDATE()),
                   "  -  " + L_DatTim.DateStr(SYSDATE()) + "| |" +
                   " - ᪠    ࠧ  ");

  CONFORM(Staff, Man);
  curMan:=Staff.Man;
  LOOP
   SETEMPTY(newPINCode, confPINCode);
   STDFORM(L_StdFrm.sf_Choice("|ࠢ, %###########################################%" +
                              "|" +
                              "| ᥪ " + L_Str.IntStr(PINCodeLength) + "- ᫮" +
                              "|ᮭ 䨪樮  (-)."+
                              "|" +
                              "|- ।砥  믮 " +
                              "|権, ॡ ⢥ত ⮣,   -  ." +
                              "|(ਬ, ᬮ 襣 ⭮ " +
                              "| ଠ樮 ᪥)" +
                              "|" +
                              "|  -,  ४ 뢠" +
                              "| ࠭ ᢮ -.  ᮮ頩 ஭ 栬 ᢮ -." +
                              "|" +
                              "|----------------------------------------------" +
                              "|-                %####% " +
                              "|"+
                              "|⢥ত - %####%|",
                              "%LNI" +
                              "%LSI" +
                              "%LSI"),
           " -",
           ,
           ,
           Man.Name, newPINCode, confPINCode);
   ErrMsg:="";
   IF    ~L_Prop.IsNumericValue(newPINCode, "") THEN
    ErrMsg:="-   ⮫쪮  ";
   ELSIF Str.Length(Str.Condense(newPINCode)) # PINCodeLength THEN
    ErrMsg:="-     " + L_Str.IntStr(PINCodeLength) + "- ᨬ";
   ELSIF newPINCode # confPINCode THEN
    ErrMsg:=" ਣ  ⢥ত -  ᮢ";
   ELSIF TooSimplePINCode(newPINCode) THEN
    ErrMsg:=" ४ 㪠뢠 ᫨誮 ⮩ -";
   END;

   IF !ErrMsg THEN
    OPENREP(R, L_General.NameConnection("Notif"), Print);
    SetPrintAttr(R, PaperForm,    A4,
                    Orientation,  Landscape,
                    CharsPerLine, 40,
                    LeftMargin,   20,
                    RightMargin,  10,
                    TopMargin,    7 + 297 - 148,
                    BottomMargin, 20,
                    LinesPerPage, DEPTH(PINCode_Notification));
    TRY
     P_Man.InsertProperty(Staff.Man,
                          SYSDATE(),
                          P_Man.P_PINCode,
                          ENCRYPTSTR(newPINCode + Staff.Man,
                                     newPINCode,
                                     CALG_RC2,
                                     ,
                                     ,
                                     CSP_NAME_MS_BASE),
                          0,
                          "",
                          curTSN + ", " + L_DatTim.TimeStr(SYSTIME()),
                          SYSDATE(),
                          EMPTYOF(DATE));
     L_SysLog.SingleMark_AfterInsert("ManPro");
     MAKEPART(R, PINCode_Notification, curMan,
                                       P_Firm.GetManAttrByTSN(curTSN, SYSDATE(), P_Firm.mpt_ManPostName),
                                       Staff.TSN,
                                       Man.Name,
                                       curTSN,
                                       FullName);
     L_StdFrm.Inform("- ᯥ譮 ࠭");
    EXCEPT
    ON Exc: Exc_RunTime DO
     IF Exc.ErrorCode = 480 THEN
      L_General.CallUs(0);
     ELSE
      RAISE();
     END;
    ELSE
     RAISE();
    END; (* TRY *)
    EXIT;
   ELSE
    L_StdFrm.RedInform(ErrMsg + "| |" + " ");
   END;
  END; (* LOOP *)
 END {CreatePassword};

 PRIVATE PROCEDURE EDOTSN_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="EDOrder";
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification, L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).Narrowing:="EDOrderL.TSN=Staff.TSN";
  L_WDO.iZone        (1).PermanentFilter:=L_EDO.GetOrderLSrcPermanentFilter(L_EDO.ot_EDO);
  L_WDO.iField       (1, "EDOrderL.ODate").AskMode:=1;
  L_WDO.iField       (1, "EDOrderL.ODate").OwnerWindowOriginalName:="StaffE";
  L_WDO.iField       (1, "EDOrderL.ODate").OwnerZoneNumber        :=1;
  L_WDO.iModifiable  (1, "");
  L_WDO.iScsChange   (1, ["EDOrderL.ODate", "EDOrderL.AllODate"]);
  L_WDO.iProgs       (1, "Staff");
 END {EDOTSN_OnInitializeWindow};

 PRIVATE PROCEDURE EDOrderL_OnBeforeInsert();
 BEGIN
  L_General.CallUs(0);
 END {EDOrderL_OnBeforeInsert};

 PRIVATE PROCEDURE EDOrderL_OnBeforeDelete();
 BEGIN
  L_General.CallUs(0);
 END {EDOrderL_OnBeforeDelete};

 PRIVATE PROCEDURE EDOrderL_OnBeforeEdit();
 BEGIN
  IF L_EDO.IsGroup_wAllODate(EDOrderL.EDOGrp) THEN
   L_WDO.cField("EDOrderL.AllODate").Modifiable:=1;
   L_WDO.cField("EDOrderL.ODate"   ).Modifiable:=~EDOrderL.AllODate;
  ELSIF L_EDO.IsGroup_wPay(EDOrderL.EDOGrp) THEN
   L_WDO.cField("EDOrderL.AllODate").Modifiable:=0;
   L_WDO.cField("EDOrderL.ODate"   ).Modifiable:=1;
  ELSE
   L_General.Error(" ⮬ ਪ  ।ᬮ७ ⠭  /");
  END;
 END {EDOrderL_OnBeforeEdit};

 PRIVATE PROCEDURE EDOrderL_OnAfterEdit();
 BEGIN
  CONFORM(EDOrderL, Staff);
  L_PRoll.ShtDone_AP(EDOrderL.Closed, 0);
 END {EDOrderL_OnAfterEdit};

 PRIVATE PROCEDURE EDOrderL_AllODate_OnSuccessfulChange();
 BEGIN
  IF EDOrderL.AllODate THEN
   CONFORM(EDOrderL, EDOrder);
   CONFORM(EDOrderL, Staff);
   L_EDO.EDO_CheckAllODate();
   SETEMPTY(EDOrderL.ODate);
   REPLACE(EDOrderL);
  END;
  L_WDO.cField("EDOrderL.ODate").Modifiable:=~EDOrderL.AllODate;
 END {EDOrderL_AllODate_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_ODate_OnSuccessfulChange();
 BEGIN
  IF ~SEARCH(StaffLog, TSN, EDOrderL.TSN, EDOrderL.ODate) THEN
   L_General.Error(" 㪠 ( ) ࠢ  /");
  END;
 END {EDOrderL_ODate_OnSuccessfulChange};

 PRIVATE PROCEDURE EDOrderL_ODate_OnAskPhase1();
 BEGIN
 END {EDOrderL_ODate_OnAskPhase1};

 PRIVATE PROCEDURE EDOrderL_ODate_OnAskPhase2();
 BEGIN
  EDOrderL.ODate:=StaffLog.Date;
  REPLACE(EDOrderL);
 END {EDOrderL_ODate_OnAskPhase2};

 PRIVATE PROCEDURE EDOTSN_1_OnSetSubwindow();
 BEGIN
  CALL(EDOrder.OnSetEDOrderSubwindow(1));
 END {EDOTSN_1_OnSetSubwindow};

 PRIVATE PROCEDURE FOrdTSN_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="FOrder";
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification]);
  L_WDO.iZone        (1).Narrowing:="FOrderL.TSN=Staff.TSN";
  L_WDO.iZone        (1).PermanentFilter:=L_EDO.GetOrderLSrcPermanentFilter(L_EDO.ot_FO);
  L_WDO.iField       (1, "FOrderL.ODate").AskMode:=1;
  L_WDO.iField       (1, "FOrderL.ODate").OwnerWindowOriginalName:="StaffE";
  L_WDO.iField       (1, "FOrderL.ODate").OwnerZoneNumber:=1;
  L_WDO.iUnmodifiable(1, ["FOrderL._Closed", "FOrderL.Value"]);
  L_WDO.iScsChange   (1, ["FOrderL.ODate", "FOrderL.AllODate"]);
  L_WDO.iProgs       (1, "Staff");
  L_WDO.iZone        (1).ZLevProg:="Staff";
 END {FOrdTSN_OnInitializeWindow};

 PUBLIC PROCEDURE scs_GetFilters_FOrdTSN_1(VAR Filters: L_WDO.tFilters);
 BEGIN
  L_WDO.PutNewFilter(Filters, "ਪ  ⥪饬 ", "(FOrderL._Closed=Memo.MonthB)", 1);
 END {scs_GetFilters_FOrdTSN_1};

 PRIVATE PROCEDURE FOrderL_OnBeforeEdit();
 BEGIN
  L_WDO.cField("FOrderL.AllODate").Modifiable:=1;
  L_WDO.cField("FOrderL.ODate"   ).Modifiable:=~FOrderL.AllODate;
 END {FOrderL_OnBeforeEdit};

 PRIVATE PROCEDURE FOrderL_OnAfterEdit();
 BEGIN
  CONFORM(FOrderL, Staff);
  L_PRoll.ShtDone_AP(FOrderL._Closed, 0);
 END {FOrderL_OnAfterEdit};

 PRIVATE PROCEDURE FOrderL_AllODate_OnSuccessfulChange();
 BEGIN
  IF FOrderL.AllODate THEN
   CONFORM(FOrderL, FOrder);
   CONFORM(FOrderL, Staff);
   L_EDO.CheckAllODate();
  END;
  L_WDO.cField("FOrderL.ODate").Modifiable:=~FOrderL.AllODate;
 END {FOrderL_AllODate_OnSuccessfulChange};

 PRIVATE PROCEDURE FOrderL_ODate_OnSuccessfulChange();
 BEGIN
  IF ~!FOrderL.ODate THEN
   L_General.Assert(SEARCH(StaffLog, TSN, FOrderL.TSN, FOrderL.ODate), " 㪠 ( ) ࠢ  /");
  END;
 END {FOrderL_ODate_OnSuccessfulChange};

 PRIVATE PROCEDURE FOrderL_ODate_OnAskPhase1();
 BEGIN
 END {FOrderL_ODate_OnAskPhase1};

 PRIVATE PROCEDURE FOrderL_ODate_OnAskPhase2();
 BEGIN
  FOrderL.ODate:=StaffLog.Date;
  REPLACE(FOrderL);
 END {FOrderL_ODate_OnAskPhase2};

BEGIN
 L_Events.ExecuteHandler();
END.
