(*
%Copyright   (c) Polak Computer System
%Author      16.05.2002 19:10:29 LDA
%Purpose     ᮪ , ࠡ⠢  ਮ
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:27:00 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_DatTim, L_OwnData, L_Staff, L_Str, L_AFM, P_Man, Memo;

 CONST
  RepName = "St008";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
@
######################################################################################### ########## #####
=#####====================================================================================================
|########################################################################################################|
|--------------------------------------------------------------------------------------------------------|
|                        |㯯|.  |. | ᨨ     |⭨                        |
}
*)

(*
$P{ Delimiter:
@
|--------------------------|------|----------|----------|---------------|--------------------------------|
}
*)


(*
$P{ Line:
?, L, ""
?, L, ""
?, L, ""
?, L, "D.N.y"
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|##### ####################|######|##########|##########|###############|#### ###########################|
}
*)

(*
$P{ Bot:
?, L, ""
@
|--------------------------------------------------------------------------------------------------------|
|ᥣ #### 祫                                                                                      |
=(c) Polak================================================================================================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "", "");

  CreateFIELD(Tmp, Man,      LIKE(Man.Man),   "", "", "", " ",  "");
  CreateFIELD(Tmp, Name,     LIKE(Man.Name),  "", "", "", " ",    "");
  CreateFIELD(Tmp, TSN,      LIKE(Staff.TSN), "", "", "", ".", "");
  CreateFIELD(Tmp, PostName, LIKE(Post.Name), "", "", "", "", "");

  CreateINDEX(Tmp, Name, PLURAL, "", "", Name);
  CreateINDEX(Tmp, Man,  UNIQUE, "", "", Man);

  SetVersionOfFILE(Tmp, 0);
 END {Create_Tmp};

 PRIVATE PROCEDURE Do(From, UpTo: DATE);
 BEGIN
  SELECT(ManPro, Property, , P_Man.P_Invalid);
  WHILE OCCURE(ManPro) DO
   PROMPT(ManPro.Man);
   SAVE(ManPro);
   IF P_Man.HasActualManProInIntvl(ManPro.Man, From, UpTo, P_Man.P_Invalid) &
      ~SEARCH(Tmp, Man, ManPro.Man) THEN
    CONFORM(ManPro, Man);
    IF L_Staff.IsStandOnAnyMainContract(Man.Man, UpTo) THEN
     L_Staff.PosToStaffLog(Staff.TSN, UpTo, 1);
     IF L_Staff.OrderInIntvl(From, UpTo) THEN
      CONFORM(StaffLog, Officer, Post);
      Tmp.Man     :=Man.Man;
      Tmp.TSN     :=Staff.TSN;
      Tmp.Name    :=Man.Name;
      Tmp.PostName:=Post.Name;
      INSERT(Tmp);
     END;
    END;
   END;
   RESTORE(ManPro);
   NEXT(ManPro);
  END; (* WHILE OCCURE(ManPro) ... *)
 END {Do};

 PRIVATE PROCEDURE PrintRep(From, UpTo: DATE);
  VAR
   LineCnt,
   Total   : NUMERIC[0];
   DocExpDS: STRING[10];
   PensPro : STRING[];
 BEGIN
  SETZERO(Total);
  OPENREP(R, L_General.NameConnection(RepName), Create);

  MAKEPART(R, Top, "᮪ , ࠡ⠢  ਮ  " +
                   L_DatTim.DateStr(From) + "  " +
                   L_DatTim.DateStr(UpTo));
  SELECT(Tmp, Name);
  WHILE OCCURE(Tmp) DO
   SELECT(ManPro, Man, , Tmp.Man, P_Man.P_Invalid);
   IF SRCINSEL(ManPro, LE, From) | SRCINSEL(ManPro, GE, From) THEN
    LineCnt:=0;
    WHILE OCCURE(ManPro) & (ManPro.Date < UpTo) DO
     IF !ManPro.DocExpD THEN
      DocExpDS:="筮";
     ELSE
      DocExpDS:=L_DatTim.DateStr(ManPro.DocExpD);
     END;
     IF LineCnt = 0 THEN
      SAVE(ManPro);
      PensPro:=P_Man.GetManProSoft(Tmp.Man, UpTo, P_Man.P_Pension);
      RESTORE(ManPro);
      MAKEPART(R, Delimiter);
      MAKEPART(R, Line, Tmp.Man,
                        L_Str.ShortName(Tmp.Name),
                        ManPro.Value,
                        ManPro.DocGiveD,
                        DocExpDS,
                        PensPro,
                        Tmp.TSN,
                        Tmp.PostName);
      INC(Total);
     ELSE
      MAKEPART(R, Line, , , ManPro.Value, ManPro.DocGiveD, DocExpDS);
     END;
     INC(LineCnt);
     NEXT(ManPro);
    END; (* WHILE OCCURE(ManPro) ... *)
   END;
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, Bot, Total);
 END {PrintRep};

BEGIN
 Create_Tmp();
 L_AFM.AF_CreateTemp("Tmp", "Tmp");
 Do(Memo.From(), Memo.UpTo());
 PrintRep(Memo.From(), Memo.UpTo());
 L_AFM.AF_PurgeTemp("Tmp");
END.

