(*
%Copyright   (c) Polak Computer System
%Author      15.02.1995 12:56:20 SAN
%Purpose     ஫ 䨪樨 StaffLog
%Type        control
%Specific    SYS
%Modified    04.09.2014 13:59:02 POLAK\Gina
%Environment
*)

 MODULE StaffLog [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Events, L_Staff, L_Man, L_Sheet, L_PRoll, L_Str,
        L_StdFrm, P_Officer, L_two, L_Way, L_WDO, L_APtm, Math, L_Env, L_Pool,
        L_AcsPnt, L_DBD, L_EDO, Str, SysLog, P_Firm;

 CONST
  pool_StaffLogOrdCsAtr = 0000945;

 PRIVATE PROCEDURE TestRWaySnSheet(D: DATE);
  CONST
   RWMsg = "室 ⪠    ६饭";
  VAR
   NewLog    : DATE;
   oPrompt   : PROMPTLINE;
   chkMyPlace: SCAL[2];
   newMyPlace: P_Firm.tMyPlace;
 BEGIN
  oPrompt:=PROMPTLINE.Create("஢ઠ");
  SAVE(StaffLog);
  IF NEXT(StaffLog) THEN
   NewLog:=StaffLog.Date;
  ELSE
   SETEMPTY(NewLog);
  END;
  RESTORE(StaffLog);

  SELECT(Sheet, TSN, , Staff.TSN);
  SRCINSEL(Sheet, GE, , L_DatTim.Per(D), L_DatTim.DAY(D));
  WHILE OCCURE(Sheet) & ((Sheet.Period+Sheet.Day-1)<NewLog) DO
   oPrompt.Text:=" "+L_DatTim.DateStr(Sheet.Period+Sheet.Day-1);
   L_General.Assert((Sheet.Source = L_Sheet.src_Regime  ) |
                    (Sheet.Source = L_Sheet.src_Operator) |
                    (Sheet.Source = L_Sheet.src_EDOrder ) |
                    (Sheet.Source = L_Sheet.src_StaffLog),
                    "㤠筠 䨪 ⠡ "+ L_DatTim.DateStr(Sheet.Period+Sheet.Day-1)+
                    "| " +
                    "| ⬥⪨  ⥢ ⮢  㬥⮢" +
                    "|᫥  ६饭." +
                    "|, ᫥ ।⥫쭮 ⪠ /, " +
                    "|/  㬥.");
   NEXT(Sheet);
  END; (* WHILE OCCURE(Sheet) ... *)

  chkMyPlace:=0;
  SELECT(RWayS, TSN, , StaffLog.TSN);
  SRCINSEL(RWayS, GE, , D);
  WHILE OCCURE(RWayS) & (RWayS.Date<NewLog) DO
   oPrompt.Text:=": "+RWayS.RWayS;
   L_General.Assert(~RWayS.Done | (RWayS.Status#L_Way.rwsStat_Rated), RWMsg);
   IF ~chkMyPlace THEN
    TRY
     newMyPlace:=L_Way.GetMyPlace(RWayS.Date, RWayS.BoxNbr, RWayS.TSN, RWayS.Exit);
     IF newMyPlace # RWayS.MyPlace THEN
      RWayS.MyPlace:=newMyPlace;
      REPLACE(RWayS);
     END;
    EXCEPT
    ON Exc: Exc_Raise DO
     L_General.Assert_wReferToAdmin(0, Exc.MsgOriginalText);
     chkMyPlace:=1;
    END; (* TRY *)
   END; (* IF ~chkMyPlace *)
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  SELECT(WayLMen, TSN, , StaffLog.TSN);
  SRCINSEL(WayLMen, GE, , D);
  WHILE OCCURE(WayLMen) & (WayLMen.RWayDate<NewLog) DO
   oPrompt.Text:=": "+WayLMen.RWayS;
   CONFORM(WayLMen, RWayS);
   L_General.Assert(~RWayS.Done | (RWayS.Status#L_Way.rwsStat_Rated), RWMsg);
   NEXT(WayLMen);
  END; (* WHILE OCCURE(WayLMen) ... *)
 END {TestRWaySnSheet};

 PRIVATE PROCEDURE _Spread(File: STRING[]; InRussian: STRING[]; New, Old: DATE; Proc: STRING[]);
  VAR
   Fnd,
   Cnt : NUMERIC[0];
 BEGIN
  Cnt:=0; Fnd:=0;
  WHILE OCCURE(^File) DO INC(Cnt);
   PROMPT("஫ 楫⭮  " + InRussian + " : " + FLDTOSTR(Cnt, "0", 7));
   IF ~!^File.ODate THEN
    IF ^File.ODate = Old THEN
     IF Fnd = 0 THEN
      L_StdFrm.Choice(" ஢  " + InRussian);
     END;
     ^Proc(New);
     INC(Fnd);
    ELSE
     NEXT(^File);
    END; (* ^File.ODate = Old ... *)
   ELSE
    NEXT(^File);
   END;
  END; (* WHILE OCCURE(^File) ... *)
 END {_Spread};

 PRIVATE PROCEDURE PasteMoney(New: DATE);
 BEGIN
  L_PRoll.Paste_Money(New);
 END {PasteMoney};

 PRIVATE PROCEDURE PasteFOrderL(New: DATE);
 BEGIN
  FOrderL.ODate:=New;
  REPLACE(FOrderL);
  NEXT(FOrderL);
 END {PasteFOrderL};

 PRIVATE PROCEDURE PasteEDOrderL(New: DATE);
 BEGIN
  EDOrderL.ODate:=New;
  REPLACE(EDOrderL);
  NEXT(EDOrderL);
 END {PasteEDOrderL};

 PRIVATE PROCEDURE PasteMonthly(New: DATE);
  VAR
   _Monthly: LIKE(Monthly.Monthly);
   _TSN    : LIKE(Monthly.TSN);
   _Who    : LIKE(Monthly.Who);
   _Period : LIKE(Monthly.Period);
   _MtyIdx : LIKE(Monthly.MtyIdx);
   _Source : LIKE(Monthly.Source);
   _Proof  : LIKE(Monthly.Proof);
 BEGIN
  SAVE(Monthly);
  _TSN   :=Monthly.TSN;
  _Who   :=Monthly.Who;
  _Period:=Monthly.Period;
  _MtyIdx:=Monthly.MtyIdx;
  _Source:=Monthly.Source;
  _Proof :=Monthly.Proof;
  ADD(Monthly, TSN, ,
               _TSN, _Period, New, _Who, _Source, _MtyIdx,
               Monthly.Proof, _Proof);
  _Monthly:=Monthly.Monthly;
  RESTORE(Monthly);
  CONFORM(Monthly, MonthRt);
  WHILE OCCURE(MonthRt) DO
   _Proof :=MonthRt.Proof;
   SAVE(MonthRt);
   ADD(MonthRt, Monthly, , _Monthly, MonthRt.Route, MonthRt.Mark, MonthRt.Proof, _Proof);
   RESTORE(MonthRt);
   REMOVE(MonthRt);
  END; (* WHILE OCCURE(MonthRt) ... *)
  REMOVE(Monthly);
 END {PasteMonthly};

 PRIVATE PROCEDURE SpreadODate(New, Old: DATE);
 BEGIN
  SELECT(Money, PayFor, , StaffLog.TSN);
  _Spread("Money", "⭮ ", New, Old, "PasteMoney");
  SELECT(FOrderL, TSN, , StaffLog.TSN);
  _Spread("FOrderL", "ਪ  /", New, Old, "PasteFOrderL");
  SELECT(EDOrderL, TSN, , StaffLog.TSN);
  _Spread("EDOrderL", "ਪ  ᮭ", New, Old, "PasteEDOrderL");
  SELECT(Monthly, TSN, , StaffLog.TSN);
  _Spread("Monthly", "筮 ⥫", New, Old, "PasteMonthly");
 END {SpreadODate};

 PRIVATE PROCEDURE ClearHandBy(P: DATE);
  VAR
   oPrompt: PROMPTLINE;
 BEGIN
  oPrompt:=PROMPTLINE.Create("⪠");
  IF ~L_Staff.IsDischargeStaffLog() THEN
   SELECT(Money, TSN, , Staff.TSN);
   SRCINSEL(Money, GE, , P);
   WHILE OCCURE(Money) DO
    oPrompt.Text:=" ஢   "+L_DatTim.PeriodStr(Money.Closed)+" : "+Money.MCode;
    IF ~!Money.ODate & (Money.Source = L_PRoll.src_Operator) & (Money.Period >= P) THEN
     SETEMPTY(Money.ODate);
     REPLACE(Money);
     SRCINSEL(Money, GE, , P);
    END;                 
    NEXT(Money);
   END; (* WHILE OCCURE(Money) ... *)

   SELECT(FOrderL, TSN, , Staff.TSN);
   SRCINSEL(FOrderL, GE, , P);
   WHILE OCCURE(FOrderL) DO
    oPrompt.Text:="ਪ  / " + FOrderL.FOrder;
    CONFORM(FOrderL, FOrder);
    IF ~!FOrderL.ODate & (FOrder.Period >= P) THEN
     SETEMPTY(FOrderL.ODate);
     REPLACE(FOrderL);
    END;
    NEXT(FOrderL);
   END; (* WHILE OCCURE(FOrderL) ... *)

   SELECT(EDOrderL, TSN, , Staff.TSN);
   SRCINSEL(EDOrderL, GE, , P);
   WHILE OCCURE(EDOrderL) DO
    oPrompt.Text:="ਪ  ᮭ " + EDOrderL.EDOrder;
    CONFORM(EDOrderL, EDOrder);
    IF ~!EDOrderL.ODate & (EDOrder.Closed >= P) THEN
     SETEMPTY(EDOrderL.ODate);
     REPLACE(EDOrderL);
    END;
    NEXT(EDOrderL);
   END; (* WHILE OCCURE(EDOrderL) ... *)
  END;
 END {ClearHandBy};

 PRIVATE PROCEDURE _AveDone_AP(P: DATE);
 BEGIN
  CONFORM(StaffLog, Officer);
  L_two.m_MakeNotActual(P);
  P:=Math.Max(Math.Max(L_Env.aptm_Start, L_DatTim.Per(Staff.BegDate)), P);
  L_PRoll.AveDone_AP_withoutCheck(P, 0);
 END {_AveDone_AP};

 PRIVATE PROCEDURE SignOverInLog();
 BEGIN
  SysLog.Mark("StaffLog", " ⭮ ᯨᠭ" +
                          " ⠡ " + StaffLog.TSN +
                          " ᥪ " + StaffLog.Sort +
                          "  " + StaffLog.Officer +
                          "  " + StaffLog.Class);
 END {SignOverInLog};

 PRIVATE PROCEDURE CheckOfficerExcess();
  VAR
   _Class  : LIKE(StaffLog.Class);
   _Date   : DATE;
   _Total,
   _Amount : NUMERIC[3];
   vim     : P_Officer.tVacancyInfillMethod;
   oPrompt : PROMPTLINE;
 BEGIN
  IF ~L_Staff.IsDischargeStaffLog() & L_Staff.E_NeedCheckOfficerExcess(SYSDATE()) THEN
   oPrompt:=PROMPTLINE.Create("஫ ᯮ ⭮ ᯨᠭ");
   _Date  :=StaffLog.Date;
   _Amount:=0;
   CONFORM(StaffLog, Officer);
   vim:=P_Officer.GetInfillMethodOfVacancy(Officer.Sort, Officer.Officer, _Date);
   IF    vim = P_Officer.vim_notDefine THEN
    L_StdFrm.Question(" ⭮ ᯨᠭ  㪠 ᨨ");
    SignOverInLog();
   ELSE
    IF    vim = P_Officer.vim_byWhole THEN
     _Class:=P_Officer.oct_AllClasses;
    ELSE
     _Class:=StaffLog.Class;
    END;
    _Amount:=P_Officer.GetVacancyAmount(Officer.Sort, Officer.Officer, _Date, _Class);
    IF _Amount > 0 THEN
     DEC(_Amount, StaffLog.DutyDgr);
     TRY
      TABLE.Get("StaffLog").AccessDataMode:=AccessDataMode_SOFT;
      _Total:=0;
      SAVE(StaffLog);
      CHANGESEL(StaffLog, Officer, , StaffLog.Sort, StaffLog.Officer);
      FIRST(StaffLog);
      WHILE OCCURE(StaffLog) DO INC(_Total);
       oPrompt.Text:=L_Str.IntStr(_Total);
       IF (StaffLog.TSN # Staff.TSN) &
          ((vim = P_Officer.vim_byWhole) | (StaffLog.Class = _Class)) & L_Staff.InOrder(_Date) THEN
        DEC(_Amount, StaffLog.DutyDgr);
       END;
       NEXT(StaffLog);
      END; (* WHILE OCCURE(StaffLog)... *)
      RESTORE(StaffLog);
      IF L_Staff.E_NeedCheckOfficerExcess(SYSDATE())=2 THEN
       TABLE.Get("EDOrderL").AccessDataMode:=AccessDataMode_SOFT;
       SELECT(EDOrderL, Officer, , StaffLog.Sort, StaffLog.Officer);
       WHILE OCCURE(EDOrderL) DO INC(_Total);
        oPrompt.Text:=L_Str.IntStr(_Total);
        IF ~EDOrderL.Status & L_DatTim.IsActive(_Date, EDOrderL.OcrDate, EDOrderL.EndDate) &
           ((vim = P_Officer.vim_byWhole) | (EDOrderL.Class = _Class)) THEN
         CONFORM(EDOrderL, EDOKind);
         IF EDOKind.EDOGrp = L_EDO.grp_Combining THEN
          DEC(_Amount, EDOrderL.ByPrc/100);
         END;
        END;
        NEXT(EDOrderL);
       END; (* WHILE OCCURE(EDOrderL) ... *)
      END;
     EXCEPT
     END;
     IF _Amount < 0 THEN
      L_StdFrm.Choice("ॢ襭 䠪᪮ ᫥   ᯨᠭ");
      SignOverInLog();
     END;
    ELSE
     L_StdFrm.Choice(" ᯨᠭ  ।ᬮ७ 䨪 " + StaffLog.Class);
     SignOverInLog();
    END; (* IF _Amount > 0 ... *)
   END; (* IF vim = ... *)
  END;
 END {CheckOfficerExcess};

 PRIVATE PROCEDURE CheckActualAdding(AfterIns: SCAL[2]);
  VAR
   _Sort   : LIKE(StaffLog.Sort);
   _Officer: LIKE(StaffLog.Officer);
 BEGIN
  IF ~L_Staff.IsDischargeStaffLog() & L_Staff.E_NeedCheckActualAdding(SYSDATE()) THEN
   SETEMPTY(_Sort);
   IF AfterIns THEN
    SAVE(StaffLog);
    CHANGESEL(StaffLog, TSN, , StaffLog.TSN);
    IF PREV(StaffLog) THEN
     _Sort   :=StaffLog.Sort;
     _Officer:=StaffLog.Officer;
    END;
    RESTORE(StaffLog);
   ELSE
    _Sort   :=GE_PVALUE(StaffLog.Sort);
    _Officer:=GE_PVALUE(StaffLog.Officer);
   END;
   CONFORM(StaffLog, SLKind);
   IF ~!_Sort & (((StaffLog.Sort # _Sort) | (StaffLog.Officer # _Officer)) | (AfterIns & (SLKind.Type = L_Staff.slkt_TakeOn))) THEN
    SELECT(Adding, TSN, , Staff.TSN);
    WHILE OCCURE(Adding) DO
     IF (Adding.From < StaffLog.Date) &
        (!Adding.UpTo | (Adding.UpTo >= StaffLog.Date)) THEN
      L_StdFrm.Choice("⭨  騥 ᮭ .|,    ਬ   ࠡ祬 ");
      SysLog.Mark("StaffLog", "  " +
                              " ⠡ " + StaffLog.TSN +
                              " ᥪ " + StaffLog.Sort +
                              "  " + StaffLog.Officer +
                              "  " + Adding.AddKind);
      RETURN;
     END;
     NEXT(Adding);
    END; (* WHILE OCCURE(Adding) ... *)
   END;
  END;
 END {CheckActualAdding};

 PRIVATE PROCEDURE NeedCntrEnd(): SCAL[2];
 BEGIN
  RETURN SLKind.IsTemp | (SLKind.Type = L_Staff.slkt_Prolongation);
 END {NeedCntrEnd};

 PRIVATE PROCEDURE StaffEE_0_OnSetupFields();
  VAR
   F               : FORM_FIELDS;
   IsAnyDschrg,
   IsTakeAndDschrg,
   IsExactlyDschrg : SCAL[2];
 BEGIN
  F:=RTI.Get().CurZone.Fields;
  IF ~!StaffLog.SLKind THEN
   CONFORM(StaffLog, SLKind);
   IsTakeAndDschrg:=SLKind.Type = L_Staff.slkt_TakeOnWithDischarge;
   IsExactlyDschrg:=SLKind.Type = L_Staff.slkt_Discharge;
   IsAnyDschrg    :=IsExactlyDschrg | IsTakeAndDschrg;
   F("StaffLog.dOrder"   ).Visible  :=IsTakeAndDschrg;
   F("StaffLog.dOrdDate" ).Visible  :=IsTakeAndDschrg;
   F("StaffLog.dOrdCsAtr").Visible  :=IsTakeAndDschrg;
   F("StaffLog.CntrEnd" ).Modifiable:=~!StaffLog.CntrEnd | NeedCntrEnd();
   F("StaffLog.Sort"    ).Modifiable:=~IsAnyDschrg;
   F("StaffLog.Officer" ).Modifiable:=~IsAnyDschrg;
   F("StaffLog.Class"   ).Modifiable:=~IsAnyDschrg;
   F("StaffLog.Regime"  ).Modifiable:=~IsExactlyDschrg;
   F("StaffLog.DutyDgr" ).Modifiable:=~IsExactlyDschrg;
   F("StaffLog.TrialPer").Modifiable:=~IsExactlyDschrg;
   F("StaffLog.ContDTyp").Modifiable:=SLKind.Type = L_Staff.slkt_Move;
   IF (SLKind.Type = L_Staff.slkt_Move) | (SLKind.Type = L_Staff.slkt_Prolongation) THEN
    F("LbcTitle").Value:="⥫쭮 ᮣ襭  㤮 ";
    F("StaffLog.LbCDate" ).Modifiable:=SLKind.ChngLbC;
    F("StaffLog.LbCNbr"  ).Modifiable:=SLKind.ChngLbC;
   ELSE
    CONFORM(StaffLog, Staff);
    IF Staff.Contract = L_Staff.cnt_OutStaff THEN
     F("StaffLog.LbCDate" ).Modifiable:=0;
     F("StaffLog.LbCNbr"  ).Modifiable:=0;
     F("LbcTitle").Value:="";
    ELSE
     F("StaffLog.LbCDate" ).Modifiable:=(SLKind.Type = L_Staff.slkt_TakeOn) | IsTakeAndDschrg;
     F("StaffLog.LbCNbr"  ).Modifiable:=(SLKind.Type = L_Staff.slkt_TakeOn) | IsTakeAndDschrg;
     F("LbcTitle").Value:="㤮 ";
    END;
   END;
  ELSE
   F("StaffLog.dOrder"   ).Visible:=0;
   F("StaffLog.dOrdDate" ).Visible:=0;
   F("StaffLog.dOrdCsAtr").Visible:=0;
   F("StaffLog.ContDTyp" ).Modifiable:=0;
   F("StaffLog.CntrEnd"  ).Modifiable:=0;
   F("StaffLog.LbCDate"  ).Modifiable:=0;
   F("StaffLog.LbCNbr"   ).Modifiable:=0;
   F("LbcTitle").Value:="㤮 ";
  END;
 END {StaffEE_0_OnSetupFields};

 PRIVATE PROCEDURE CheckStaffLogOrder(prv, cur: LIKE(SLKind.Type));
  VAR
   Ok: SCAL[2];
 BEGIN
  Ok:=(cur = L_Staff.slkt_TakeOn) = (!prv | (prv = L_Staff.slkt_Discharge));
  L_General.Assert(Ok, "⨬ 冷 ᫥ ਪ  ६饭");
 END {CheckStaffLogOrder};

 VAR
  pContDTyp: LIKE(StaffLog.ContDTyp);
  pSort    : LIKE(StaffLog.Sort);
  pOfficer : LIKE(StaffLog.Officer);
  pRegime  : LIKE(StaffLog.Regime);
  pClass   : LIKE(StaffLog.Class);
  pDutyDgr : LIKE(StaffLog.DutyDgr);

 PRIVATE PROCEDURE StoreStaffLogFields();
 BEGIN
  pContDTyp:=StaffLog.ContDTyp;
  pSort    :=StaffLog.Sort;
  pOfficer :=StaffLog.Officer;
  pRegime  :=StaffLog.Regime;
  pClass   :=StaffLog.Class;
  pDutyDgr :=StaffLog.DutyDgr;
 END {StoreStaffLogFields};

 PRIVATE PROCEDURE RecallStaffLogFields(wContDTyp: SCAL[2]);
 BEGIN
  IF wContDTyp THEN
   StaffLog.ContDTyp:=pContDTyp;
  END;
  StaffLog.Sort    :=pSort;
  StaffLog.Officer :=pOfficer;
  StaffLog.Regime  :=pRegime;
  StaffLog.Class   :=pClass;
  StaffLog.DutyDgr :=pDutyDgr;
  REPLACE(StaffLog);
 END {RecallStaffLogFields};

 PRIVATE PROCEDURE SetStaffLogFields();
  VAR
   _prv,
   _cur        : LIKE(SLKind.Type);
   isReturnMove: SCAL[2];
   _Date       : LIKE(StaffLog.Date);
 BEGIN
  L_General.Assert(~!StaffLog.SLKind, "室 㪠  ६饭");
  IF L_Staff.IsDischargeStaffLog() THEN
   _Date:=StaffLog.vDate+1;
  ELSE
   _Date:=StaffLog.vDate;
  END;
  _cur:=L_Staff.GetStaffLogType();
  SAVE(StaffLog);
  IF (StaffLog.Date # _Date) & SEARCH(StaffLog, TSN, StaffLog.TSN, _Date) THEN
   IF L_Staff.IsDischargeStaffLog() & (_cur = L_Staff.slkt_TakeOn) THEN
    L_General.Error(" த 㤮   㢮쭥  ਥ ' '" +
                    "|᫥ ᯮ짮  ६饭 ᮮ⢥饣 ⨯");
   ELSE
    L_General.Error("  ਪ  ਥ / ॢ  "+L_DatTim.DateStr(_Date));
   END;
  END;
  RESTORE(StaffLog);
  StaffLog.Date:=_Date;
  REPLACE(StaffLog);
  isReturnMove:=StaffLog.SLKind = L_Man.ReturnToPermanentPlaceSLKind;
  SAVE(StaffLog);
  IF PREV(StaffLog) THEN
   _prv:=L_Staff.GetStaffLogType();
   IF isReturnMove THEN
    LOOP
     CONFORM(StaffLog, SLKind);
     IF (SLKind.Type = L_Staff.slkt_TakeOn) |
        (SLKind.Type = L_Staff.slkt_TakeOnWithDischarge) |
        ((SLKind.Type = L_Staff.slkt_Move) & ~SLKind.IsTemp) THEN
      EXIT;
     END;
     L_General.Assert(PREV(StaffLog),
                      "  ਪ  ६饭,   ந ");
    END;
   END;
   StoreStaffLogFields();
  ELSE
   SETEMPTY(_prv, pSort);
  END;
  RESTORE(StaffLog);
  _cur:=L_Staff.GetStaffLogType();
  CheckStaffLogOrder(_prv, _cur);
  SAVE(StaffLog);
  IF NEXT(StaffLog) THEN
   CheckStaffLogOrder(_cur, L_Staff.GetStaffLogType());
  END;
  RESTORE(StaffLog);
  IF !StaffLog.Sort | isReturnMove THEN
   IF ~!pSort & (_cur # L_Staff.slkt_TakeOn) THEN
    RecallStaffLogFields(0);
   ELSE
    IF Staff.Contract = L_Staff.cnt_Basic THEN
     StaffLog.DutyDgr:=1.0;
    ELSE
     StaffLog.DutyDgr:=0.5;
    END;
   END;
   REPLACE(StaffLog);
  END;
 END {SetStaffLogFields};

 PRIVATE PROCEDURE DateIsAfterNormalLeeway(D: DATE): SCAL[2];
 BEGIN
  RETURN D < L_DatTim.IncWorkDay(SYSDATE(), -L_Staff.E_StaffNormalLeeway(SYSDATE()));
 END {DateIsAfterNormalLeeway};

 PRIVATE PROCEDURE GrantAllRights();
 BEGIN
  L_AcsPnt.PassAccessPoint(0000003);
 END {GrantAllRights};

 PRIVATE PROCEDURE CheckRights(D: DATE);
 BEGIN
  IF DateIsAfterNormalLeeway(D) THEN
   L_AcsPnt.PassAccessPoint(0000002);
  ELSE
   GrantAllRights();
  END;
 END {CheckRights};

 PRIVATE PROCEDURE PrevContDTyp(): LIKE(StaffLog.ContDTyp);
  VAR
   _ContDTyp: LIKE(StaffLog.ContDTyp);
 BEGIN
  SAVE(StaffLog);
  CHANGESEL(StaffLog, TSN, , StaffLog.TSN);
  IF PREV(StaffLog) THEN
   _ContDTyp:=StaffLog.ContDTyp;
  ELSE
   SETEMPTY(_ContDTyp);
  END;
  RESTORE(StaffLog);
  RETURN _ContDTyp;
 END {PrevContDTyp};

 PRIVATE PROCEDURE FillLbCAttributes();
 BEGIN
  CONFORM(StaffLog, SLKind);
  IF ~!StaffLog.SLKind &
     ((SLKind.Type = L_Staff.slkt_Move)         & SLKind.ChngLbC |
      (SLKind.Type = L_Staff.slkt_Prolongation) & SLKind.ChngLbC |
      (SLKind.Type = L_Staff.slkt_TakeOn)                        |
      (SLKind.Type = L_Staff.slkt_TakeOnWithDischarge)) THEN
   IF ~!StaffLog.Date &
      L_Staff.E_DefaultLabourContractNumeration(StaffLog.Date) &
      !StaffLog.LbCNbr THEN
    StaffLog.LbCNbr :=StaffLog.TSN + "/" + FLDTOSTR(StaffLog.Date, "yND");
    StaffLog.LbCDate:=StaffLog.Date;
    REPLACE(StaffLog);
   END;
  ELSE
   SETEMPTY(StaffLog.LbCNbr, StaffLog.LbCDate);
   REPLACE(StaffLog);
  END;
 END {FillLbCAttributes};

 PRIVATE PROCEDURE StaffLog_vDate_OnSuccessfulChange();
 BEGIN
  CheckRights(Math.Min(GE_PVALUE(StaffLog.vDate), StaffLog.vDate));
  SetStaffLogFields();
  StaffEE_0_OnSetupFields();
  FillLbCAttributes();
 END {StaffLog_vDate_OnSuccessfulChange};

 PRIVATE PROCEDURE StaffLog_SLKind_OnSuccessfulChange();
  VAR
   oldType: LIKE(SLKind.Type);
 BEGIN
  IF ~!GE_PVALUE(StaffLog.SLKind) THEN
   SEARCH(SLKind, SLKind, , GE_PVALUE(StaffLog.SLKind));
   oldType:=SLKind.Type;
   SEARCH(SLKind, SLKind, , StaffLog.SLKind);
   IF SLKind.Type # oldType THEN
    L_General.Assert(RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert,
                     "⨬  ⨯ ६饭");
   END;
  END;
  CONFORM(StaffLog, SLKind);
  IF (SLKind.Type = L_Staff.slkt_TakeOn) |
     (SLKind.Type = L_Staff.slkt_TakeOnWithDischarge) THEN
   IF SLKind.IsTemp THEN
    StaffLog.ContDTyp:=L_Staff.cdt_FixedDate;
   ELSE
    StaffLog.ContDTyp:=L_Staff.cdt_Permanent;
   END;
   REPLACE(StaffLog);
  ELSIF !StaffLog.ContDTyp | (SLKind.Type # L_Staff.slkt_Move) THEN
   StaffLog.ContDTyp:=PrevContDTyp();
   REPLACE(StaffLog);
  END;
  IF ~!StaffLog.Date THEN
   SetStaffLogFields();
  END;
  StaffEE_0_OnSetupFields();
  FillLbCAttributes();
 END {StaffLog_SLKind_OnSuccessfulChange};

 PRIVATE PROCEDURE StaffLog_ContDTyp_OnSuccessfulChange();
 BEGIN
  StaffEE_0_OnSetupFields();
 END {StaffLog_ContDTyp_OnSuccessfulChange};

 PRIVATE PROCEDURE StaffLog_Sort_OnSuccessfulChange();
 BEGIN
  CONFORM(StaffLog, Sort);
  L_Staff.CheckVeritableSort("");
 END {StaffLog_Sort_OnSuccessfulChange};

 PRIVATE PROCEDURE StaffLog_Officer_OnSuccessfulChange();
 BEGIN
  CONFORM(StaffLog, Staff);
  CONFORM(StaffLog, Officer);
  L_General.Assert(Staff.MyFirm = Officer.MyFirm,
                   "'' ࣠樨  ࠪ  ࠡ祬  ࠧ")
 END {StaffLog_Officer_OnSuccessfulChange};

 PRIVATE PROCEDURE StaffLog_AnyOrdCsAtr_OnSuccessfulChange(val: STRING[]);
  VAR
   OrdCsAtrPool: STRING[];
 BEGIN
  L_Pool.Put(pool_StaffLogOrdCsAtr, val);
  OrdCsAtrPool:=L_Pool.Get(pool_StaffLogOrdCsAtr);
  RTI.Get().CurZone.Fields("StaffLog.OrdCsAtr" ).Template:=OrdCsAtrPool;
  RTI.Get().CurZone.Fields("StaffLog.dOrdCsAtr").Template:=OrdCsAtrPool;
 END {StaffLog_AnyOrdCsAtr_OnSuccessfulChange};

 PRIVATE PROCEDURE StaffLog_OrdCsAtr_OnSuccessfulChange();
 BEGIN
  StaffLog_AnyOrdCsAtr_OnSuccessfulChange(StaffLog.OrdCsAtr);
 END {StaffLog_OrdCsAtr_OnSuccessfulChange};

 PRIVATE PROCEDURE StaffLog_dOrdCsAtr_OnSuccessfulChange();
 BEGIN
  StaffLog_AnyOrdCsAtr_OnSuccessfulChange(StaffLog.dOrdCsAtr);
 END {StaffLog_dOrdCsAtr_OnSuccessfulChange};

 PRIVATE PROCEDURE StaffLog_OnBeforeEdit();
 BEGIN
  CheckRights(StaffLog.Date);
 END {StaffLog_OnBeforeEdit};

 PRIVATE PROCEDURE StaffLog_OnBeforeInsert();
 BEGIN
 END {StaffLog_OnBeforeInsert};

 PRIVATE PROCEDURE SupportSettingBegDate();
  VAR
   P          : DATE;
   JumpForward: SCAL[2];
 BEGIN
  IF Staff.BegDate # StaffLog.Date THEN
   IF ~!Staff.BegDate THEN
    L_StdFrm.Choice("   ਥ");
   END;
   JumpForward:=~!Staff.BegDate &
                (L_DatTim.Per(StaffLog.Date) > L_DatTim.Per(Staff.BegDate));
   Staff.BegDate:=StaffLog.Date;
   REPLACE(Staff);
   P:=L_DatTim.Per(Staff.BegDate);
   IF P < L_Env.aptm_Start THEN
    P:=L_DatTim.IncMonth(L_Env.aptm_Start, -1);
   END;
   SELECT(Sheet, TSN, , Staff.TSN);
   WHILE OCCURE(Sheet) & (Sheet.Period < P) DO
    L_Sheet.MayREPCurSheet();
    REMOVE(Sheet);
   END; (* WHILE OCCURE(Sheet) ... *)
   IF JumpForward THEN
    SELECT(Money, TSN, , Staff.TSN);
    WHILE OCCURE(Money) DO
     IF Money.WFPeriod < P THEN
      L_General.Assert(~L_APtm.MonthIsClosed(Money.Closed, L_APtm.system_Salary), " 㤠 ஢  ⮬ |஢  "+L_DatTim.PeriodStr(Money.Closed)+"  "+L_DatTim.PeriodStr(Money.WFPeriod));
      L_General.Assert(Money.Sum = 0,
                       " 㫥 ஢  ⭮ | |"+
                       "६ (!) 㪠 ࠧ  㫥 ⠢|"+
                       " ࠢ ࠡ祥     㫥 䭮 ⠢,|"+
                       "⠩    㡥,     ⠫ 㫥 ᫥.|"+
                       "᫥ ⮣ ࠢ  ਥ  ୨ 㦭 ࠧ (ࠡ祥 )");
      L_PRoll.Remove_Money(1);
     ELSE
      NEXT(Money);
     END;
    END; (* WHILE OCCURE(Money) ... *)
   END;
   SELECT(PCalc, TSN, , Staff.TSN);
   WHILE OCCURE(PCalc) & (PCalc.Period < P) DO
    L_General.Assert((PCalc.Saldo=0)&(PCalc.Incr=0)&(PCalc.Decr=0)&(PCalc.FutInc=0), "⨬   ਥ|..  楢   㫥 祭  "+L_DatTim.PeriodStr(PCalc.Period));
    REMOVE(PCalc);
   END; (* WHILE OCCURE(PCalc) ... *)
   IF OCCURE(PCalc) THEN
    L_General.Assert(PCalc.Saldo=0, "⨬   ਥ|..  楢   㫥 ᠫ줮  "+L_DatTim.DateStr(PCalc.Period));
   END;
   _AveDone_AP(P);
  END;
 END {SupportSettingBegDate};

 PRIVATE PROCEDURE SupportSettingEndDate();
  VAR
   ShtDonePer,
   curEndDate: DATE;
   DaysOutState: NUMERIC[0];
 BEGIN
  IF L_Staff.GetStaffLogType() = L_Staff.slkt_Discharge THEN
   curEndDate:=StaffLog.Date-1;
  ELSE
   SETEMPTY(curEndDate);
  END;
  IF Staff.EndDate # curEndDate THEN
   IF    !Staff.EndDate THEN
    IF L_Events.IsAfterEditInsertEvents(RTI.Get().StartMode) THEN
     L_StdFrm.Choice("   㢮쭥");
    END;
   ELSIF !curEndDate THEN
    L_StdFrm.Choice("   㢮쭥");
    DaysOutState:=SYSDATE() - Staff.EndDate;
    IF DaysOutState > 365 THEN
     L_StdFrm.ConditionalCHOICE("  㢮쭥 諮 "+L_Str.IntStr(DaysOutState)+" "+Str.EnumObject(DaysOutState, "||")+"."+
                                "| ଫ ਥ   ⠡ ",
                                DaysOutState < (365*2));
    END;
    L_Man.CheckManActvForPrvWork(Staff.Man);
   ELSE
    L_StdFrm.Choice("   㢮쭥");
   END;
   ShtDonePer:=L_DatTim.Per(Math.Min(Staff.EndDate, curEndDate));
   IF L_Staff.IsBegan(L_DatTim.IncMonth(ShtDonePer, -1)) &
      (SYSDATE() < L_PRoll.GetFinalCalcDate(L_DatTim.IncMonth(ShtDonePer, -1))) THEN
    ShtDonePer:=L_DatTim.IncMonth(ShtDonePer, -1);
   END;
   L_PRoll.ShtDone_AP_withoutCheck(ShtDonePer, 0);
   Staff.EndDate:=curEndDate;
   REPLACE(Staff);
   SELECT(MCFix, TSN, , Staff.TSN);
   WHILE OCCURE(MCFix) & (MCFix.Begin <= Staff.EndDate) DO
    MCFix.Dschrg:=Staff.EndDate;
    REPLACE(MCFix);
    NEXT(MCFix);
   END; (* WHILE OCCURE(MCFix) ... *)
   IF OCCURE(MCFix) THEN
    L_General.Error("⭨  ९   " + L_DatTim.DateStr(MCFix.Begin));
   END;
  END;
 END {SupportSettingEndDate};

 PRIVATE PROCEDURE SupportLogOrder(ApartD: DATE);
  VAR
   _prv,
   _cur : LIKE(SLKind.Type);
 BEGIN
  SAVE(StaffLog);
  SETEMPTY(_prv);
  L_General.Assert(SELECT(StaffLog, TSN, StaffLog.TSN) &
                   (StaffLog.Date#ApartD), " 㤠  ਪ  /");
  SupportSettingBegDate();
  WHILE OCCURE(StaffLog) DO
   IF StaffLog.Date # ApartD THEN
    CONFORM(StaffLog, SLKind);
    _cur:=SLKind.Type;
    CheckStaffLogOrder(_prv, _cur);
    IF _cur # L_Staff.slkt_Discharge THEN
     StoreStaffLogFields();
     IF StaffLog.ContDTyp # PrevContDTyp() THEN
      IF (_cur = L_Staff.slkt_Move) | (_cur = L_Staff.slkt_Prolongation) THEN
       L_General.Assert(SLKind.ChngLbC,
                        "ॢ  " + L_DatTim.DateStr(StaffLog.Date) + ":| ६饭 " +
                        StaffLog.SLKind + "  ।ᬠਢ  筮 ");
       L_General.Assert(StaffLog.ContDTyp = L_Staff.cdt_Permanent,
                        "ॢ  " + L_DatTim.DateStr(StaffLog.Date) + ":" +
                        "|⨬  ⨯ 㤮 " +
                        "| ' । ப'  ''");
      END;
     END;
    ELSE
     RecallStaffLogFields(1);
    END;
    _prv:=_cur;
   END;
   NEXT(StaffLog);
  END; (* WHILE OCCURE(StaffLog) ... *)
  L_General.CallUs(LAST(StaffLog) & ((StaffLog.Date#ApartD) | PREV(StaffLog)));
  SupportSettingEndDate();
  RESTORE(StaffLog);
 END {SupportLogOrder};

 PRIVATE PROCEDURE CheckLogOrderChange(PDate: DATE);
  VAR
   prvDate,
   nxtDate: DATE;
 BEGIN
  IF PDate # StaffLog.Date THEN
   CHANGESEL(StaffLog, TSN, , StaffLog.TSN);
   SAVE(StaffLog);
   IF PREV(StaffLog) THEN
    prvDate:=StaffLog.Date;
   ELSE
    prvDate:=MINOF(DATE);
   END;
   RESTORE(StaffLog);
   SAVE(StaffLog);
   IF NEXT(StaffLog) THEN
    nxtDate:=StaffLog.Date;
   ELSE
    SETEMPTY(nxtDate);
   END;
   RESTORE(StaffLog);
   IF ~L_DatTim.IsActive_Inc(PDate, prvDate, nxtDate) THEN
    L_StdFrm.Choice("  冷 ᫥ ਪ  ६饭");
   END;
  END;
 END {CheckLogOrderChange};

 PRIVATE PROCEDURE CheckContDTypChange();
  VAR
   _ContDTyp: LIKE(StaffLog.ContDTyp);
 BEGIN
  IF L_Staff.GetStaffLogType() = L_Staff.slkt_Move THEN
   IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit THEN
    _ContDTyp:=GE_PVALUE(StaffLog.ContDTyp);
   ELSE
    _ContDTyp:=PrevContDTyp();
   END;
   IF StaffLog.ContDTyp # _ContDTyp THEN
    L_AcsPnt.PassAccessPoint(0000010);
   END;
  END;
 END {CheckContDTypChange};

 PRIVATE PROCEDURE CheckEDOrderL();
 BEGIN
  IF ~!Staff.EndDate THEN
   SELECT(EDOrderL, TSN, , Staff.TSN);
   LAST(EDOrderL);
   LOOP
    IF ~OCCURE(EDOrderL) THEN
     EXIT;
    ELSE
     PROMPT(EDOrderL.EDOrder);
     CONFORM(EDOrderL, EDOrder);
     IF L_EDO.HasAffectOnPayRoll() & (EDOrder.State # L_EDO.st_ordSigned) THEN
      L_StdFrm.Warning("騩 ࠡ⭨  ᠭ ਪ, ਬ|" + L_EDO.EDOrderName());
      EXIT;
     END;
    END;
    PREV(EDOrderL);
   END;
  END;
 END {CheckEDOrderL};

 PRIVATE PROCEDURE StaffEE_OnInitializeWindow();
  VAR
   OrdCsAtrPool: STRING[];
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "StaffLog.SLKind").First:=1;
  L_WDO.iScsChange   (0, ["StaffLog.ContDTyp", "StaffLog.vDate", "StaffLog.Sort", "StaffLog.Officer",
                          "StaffLog.SLKind", "StaffLog.OrdCsAtr", "StaffLog.dOrdCsAtr"]);
  L_WDO.iMayBeEmpty  (0, ["StaffLog.OrdCsAtr", "StaffLog.OrdDate", "StaffLog.Order", "StaffLog.CntrEnd"]);
  L_WDO.iUnmodifiable(0, ["LbcTitle"]);
  L_WDO.iFieldAskMode(0, "StaffLog.Sort",    FORM_FIELD.AskMode_Manual, "Sort", 1);
  L_WDO.iFieldAskMode(0, "StaffLog.Officer", FORM_FIELD.AskMode_Manual, "Sort", 1);
  L_WDO.iField       (0, "Staff.Contract"   ).Format:=L_Staff.cnt_Pool_Full;
  L_WDO.iField       (0, "StaffLog.ContDTyp").Format:=L_Staff.cdt_Pool_Full;
  L_WDO.iField       (0, "Post.ClsName"     ).Format:=L_Staff.pcn_Pool_Full;
  OrdCsAtrPool:=L_Pool.Get(pool_StaffLogOrdCsAtr);
  L_WDO.iField       (0, "StaffLog.OrdCsAtr" ).Template:=OrdCsAtrPool;
  L_WDO.iField       (0, "StaffLog.dOrdCsAtr").Template:=OrdCsAtrPool;
 END {StaffEE_OnInitializeWindow};

 PRIVATE PROCEDURE StaffLog_Sort_OnAskPhase1();
 BEGIN
 END {StaffLog_Sort_OnAskPhase1};

 PRIVATE PROCEDURE StaffLog_Sort_OnAskPhase2();
  VAR
   trgSort   : LIKE(Officer.Sort);
   trgOfficer: LIKE(Officer.Officer);
 BEGIN
  IF RTI.Get().TrgZone.MasterTable.Name = "Officer" THEN
   SAVE(Officer);
   GE_WZD_CURSOR(RTI.Get().TrgZone.Window.Name, RTI.Get().TrgZone.Number, Officer);
   trgSort   :=Officer.Sort;
   trgOfficer:=Officer.Officer;
   RESTORE(Officer);
  ELSE
   trgSort:=Sort.Sort;
   SETEMPTY(trgOfficer);
  END;
  StaffLog.Sort   :=trgSort;
  StaffLog.Officer:=trgOfficer;
  REPLACE(StaffLog);
 END {StaffLog_Sort_OnAskPhase2};

 PRIVATE PROCEDURE StaffLog_Officer_OnAskPhase1();
 BEGIN
  LIKEMENU(Ask, ". 2");
 END {StaffLog_Officer_OnAskPhase1};

 PRIVATE PROCEDURE StaffLog_Officer_OnAskPhase2();
 BEGIN
  StaffLog_Sort_OnAskPhase2();
 END {StaffLog_Officer_OnAskPhase2};

 PRIVATE PROCEDURE StaffEE_0_OnReposition();
 BEGIN
  StaffEE_0_OnSetupFields();
 END {StaffEE_0_OnReposition};

 PRIVATE PROCEDURE StaffLog_OnAfterEdIns(NeedAveDone: SCAL[2]; AfterIns: SCAL[2]);
 BEGIN
  GrantAllRights();
  SupportLogOrder(EMPTYOF(DATE));
  CheckContDTypChange();
  IF ~L_Staff.IsDischargeStaffLog() THEN
   L_General.Assert(StaffLog.DutyDgr <= 1.000, "     1.000");
   L_DBD.CheckOwnersValidity("StaffLog");
  END; (*IF ~L_Staff.IsDischargeStaffLog... *)
  CONFORM(StaffLog, SLKind);
  IF     !StaffLog.CntrEnd & NeedCntrEnd() THEN
   L_StdFrm.Choice(" ६饭  㪠  ''?");
  ELSIF ~!StaffLog.CntrEnd & ~NeedCntrEnd() THEN
   L_StdFrm.Choice(" 㢥७  室 㪠  ''?");
  END;
  IF ~!StaffLog.CntrEnd THEN
   L_General.Assert(StaffLog.Date <= StaffLog.CntrEnd, " 砭    ࠭  砫");
  END;
  L_General.Assert(StaffLog.Date < SLKind.Till, "騩  ६饭");
  CONFORM(StaffLog, RegMain);
  L_General.Assert(L_DatTim.InPatIntvl(RegMain.Begin, RegMain.Till, Math.Max(StaffLog.Date, L_Env.aptm_Start), StaffLog.DateE), "騩 ० ࠡ "+RegMain.Regime);
  IF (SLKind.Type = L_Staff.slkt_TakeOn) & NeedAveDone THEN
   SAVE(StaffLog);
   IF PREV(StaffLog) THEN
    _AveDone_AP(L_DatTim.Per(StaffLog.Date));
   END;
   RESTORE(StaffLog);
  END;
  CheckOfficerExcess();
  CheckActualAdding(AfterIns);
  CheckEDOrderL();
 END {StaffLog_OnAfterEdIns};

 PRIVATE PROCEDURE StaffLog_OnAfterEdit();
  VAR
   Oldest: DATE;
   DateChanged: SCAL[2];
 BEGIN
  DateChanged:=GE_PVALUE(StaffLog.Date) # StaffLog.Date;
  StaffLog_OnAfterEdIns(DateChanged | (GE_PVALUE(StaffLog.SLKind) # StaffLog.SLKind), 0);
  Oldest:=Math.Min(GE_PVALUE(StaffLog.Date), StaffLog.Date);
  IF DateChanged THEN
   CheckLogOrderChange(GE_PVALUE(StaffLog.Date));
   SpreadODate(StaffLog.Date, GE_PVALUE(StaffLog.Date));
  END;
  IF ~L_General.IsLegalRecordModification("StaffLog", "Order|OrdDate|OrdCsAtr|LbCNbr|LbcDate") THEN
   IF ~L_General.IsLegalRecordModification("StaffLog", "CntrEnd|TrialPer") THEN
    TestRWaySnSheet(Oldest);
   END;
   _AveDone_AP(L_DatTim.Per(Oldest));
  END;
 END {StaffLog_OnAfterEdit};

 PUBLIC PROCEDURE StaffLog_OnAfterInsert();
 BEGIN
  StaffLog_OnAfterEdIns(1, 1);
  CheckLogOrderChange(EMPTYOF(DATE));
  TestRWaySnSheet(StaffLog.Date);
  ClearHandBy(L_DatTim.Per(StaffLog.Date));
  _AveDone_AP(L_DatTim.Per(StaffLog.Date));
 END {StaffLog_OnAfterInsert};

 PRIVATE PROCEDURE StaffLog_OnBeforeDelete();
  VAR
   NewDate: DATE;
 BEGIN
  CheckRights(StaffLog.Date);
  SupportLogOrder(StaffLog.Date);
  TestRWaySnSheet(StaffLog.Date);
  _AveDone_AP(L_DatTim.Per(StaffLog.Date));
  SETEMPTY(NewDate);
  CHANGESEL(StaffLog, TSN, , StaffLog.TSN);
  SAVE(StaffLog);
  WHILE PREV(StaffLog) & L_Staff.IsDischargeStaffLog() DO
  END;
  L_General.CallUs(OCCURE(StaffLog));
  NewDate:=StaffLog.Date;
  RESTORE(StaffLog);
  SpreadODate(NewDate, StaffLog.Date);
 END {StaffLog_OnBeforeDelete};

BEGIN
 L_Events.ExecuteHandler();
END.
