(*
%Copyright   (c) Polak Computer System
%Author      20.02.2005 13:49:58 POLAK\San
%Purpose     ஫ 䨪樨 Storage
%Type        control
%Specific    SYS
%Modified    24.06.2014 18:43:07 POLAK\LDA
%Environment
*)

 MODULE Storage [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_Stock, L_Str, Memo, L_StdFrm, L_CUC,
        L_DBD, L_WDO, L_SES, L_Env, P_Firm, L_AFM, L_Staff, L_TRS,
        L_OwnData, L_DatTim, L_Acnt, L_XObj, L_qs, L_r2r, L_APtm, L_AR;

 PRIVATE PROCEDURE SetTill();
  VAR
   _Till: DATE;
 BEGIN
  SETSEL(StrgLog, Storage, Storage.Storage);
  IF LAST(StrgLog) THEN
   L_General.Assert(StrgLog.Date < Storage.Till, " ९  砫 ⢨  ࠭?");
   _Till:=Storage.Till;
   REPEAT
    StrgLog.Till:=_Till;
    REPLACE(StrgLog);
    _Till:=StrgLog.Date;
    PREV(StrgLog);
   UNTIL ~OCCURE(StrgLog);
   FIRST(StrgLog);
   L_General.Assert(StrgLog.Date >= Storage.Begin, " ९  砫 ⢨  ࠭?");
  END;
 END {SetTill};

 PRIVATE PROCEDURE CopyRecord(Interactive, IsInsert: SCAL[2]; oldValue: LIKE(Storage2.Storage2));
  VAR
   curField: FIELD;
 BEGIN
  FOR_EACH curField IN TABLE.Get("Storage2").Fields DO
   ^(curField.ObtainName()):=^(TABLE.Get("Storage").Fields(curField.Number).ObtainName());
  END;
  IF IsInsert THEN
   INSERT(Storage2);
  ELSE
   REPLACE(Storage2);
  END;
  SetTill();
  IF ~!oldValue THEN
   SETSEL(Strg2Log, Storage2, oldValue);
   REMSEL(Strg2Log);
  END;
  SELECT(StrgLog, Storage, , Storage.Storage);
  WHILE OCCURE(StrgLog) DO
   FOR_EACH curField IN TABLE.Get("Strg2Log").Fields DO
    ^(curField.ObtainName()):=^(TABLE.Get("StrgLog").Fields(curField.Number).ObtainName());
   END;
   INSERT(Strg2Log);
   NEXT(StrgLog);
  END; (* WHILE OCCURE(StrgLog) ... *)
 END {CopyRecord};

 PRIVATE PROCEDURE AccessStorage2(_Storage: LIKE(Storage.Storage));
 BEGIN
  L_General.CallUs(SEARCH(Storage2, Storage2, _Storage));
 END {AccessStorage2};

 PRIVATE PROCEDURE BagIsEmpty(D: DATE): SCAL[2];
  VAR
   tickets: L_TRS.tPackedTck[100];
   i      : NUMERIC[0];
 BEGIN
  IF SELECT(TckRcD, Storage, Storage.Storage) THEN
   IF SRCINSEL(TckRcD, GT, D) THEN
    L_TRS.GetStorageTckSummary(Storage.Storage, TckRcD.TckRcS, TckRcD.TckRcD, 1, tickets);
   ELSE
    L_TRS.GetStorageTckSummary(Storage.Storage, "", "", 1, tickets);
   END;
   i:=0;
   WHILE ~!tickets[i] DO
    IF (L_TRS.pt_GetState(tickets[i]) = L_TRS.ts_New) | (L_TRS.pt_GetState(tickets[i]) = L_TRS.ts_inBag) THEN
     RETURN 0;
    END;
    INC(i);
   END;
  END;
  RETURN 1;
 END {BagIsEmpty};

 PRIVATE PROCEDURE Storage_OnAfterEdIns();
  VAR
   Dummy: L_Stock.tFixedStorages;
   asTSN: LIKE(Staff.TSN);
 BEGIN
  IF (Storage.Type = L_Stock.st_TckBag) THEN
   IF  ~!Storage.Till THEN
    L_General.Assert(BagIsEmpty(Storage.Till), "㬪   ");
   END;
   SETSEL(TckRcD, Storage, Storage.Storage);
   SRCINSEL(TckRcD, GE, , 01\01\2010);
   SETSEL(StrgLog, Storage, Storage.Storage);
   WHILE OCCURE(TckRcD) DO
    PROMPT("஢ઠ ९. " + L_DatTim.DateStr(TckRcD.Date));
    CONFORM(TckRcD, TckRcS);
    IF SRCINSEL(StrgLog, LE, TckRcS.Date) THEN
     IF (TckRcD.TSN # StrgLog.TSN) & (StrgLog.Date = TckRcS.Date) THEN
      IF ~PREV(StrgLog) THEN
       SRCINSEL(StrgLog, LE, , TckRcS.Date);
      END;
     END;
     IF TckRcD.TSN # StrgLog.TSN THEN
      SRCINSEL(StrgLog, LE, , TckRcS.Date);
      L_General.Error("⨬  ९  ਮ,    ."+
                      "||" +
                      " " + TckRcD.TckRcD + "   " + TckRcS.TckRcS + "  " + L_DatTim.DateStr(TckRcS.Date) +
                      ", ࠡ⭨ " + TckRcD.TSN + ", " +
                      "|" +
                      " ९  " + L_DatTim.DateStr(StrgLog.Date) + " 㪠 ࠡ⭨ " + StrgLog.TSN);

     END;  (* IF TckRcD.TSN # ... *)
    ELSE
     L_General.Error("  " + TckRcD.TckRcD + "   " + TckRcS.TckRcS + "  " + L_DatTim.DateStr(TckRcS.Date) +
                     ", ࠡ⭨ " + TckRcD.TSN + "," +
                     "|" +
                     "९    ");

    END;
    NEXT(TckRcD);
   END; (* WHILE OCCURE(TckRcD) ... *)
  END;

  SELECT(StrgLog, Storage, , Storage.Storage);
  WHILE OCCURE(StrgLog) DO
   IF L_Env.RealTSN(StrgLog.TSN) THEN
    CONFORM(StrgLog, Staff);
    L_General.Assert(Staff.MyFirm = Storage.MyFirm,
                     "⭨ " + Staff.TSN + ":  ࣠, 祬  ");
    Dummy:=L_Stock.GetStaffFixedStorages(StrgLog.TSN, StrgLog.Date, Storage.Type);
   END;
   NEXT(StrgLog);
  END; (* WHILE OCCURE(StrgLog) ... *)
 END {Storage_OnAfterEdIns};

 PRIVATE PROCEDURE TckBag_MakeCUCopy(_Math: LIKE(Math.Math));
 BEGIN
  L_StdFrm.Choice("ନ஢   ꥪ " + _Math);
  DEFAULT(CUCopy);
  CUCopy.Math   :=_Math;
  SETEMPTY(CUCopy.CUCopy, CUCopy.Serial, CUCopy.Comment, CUCopy.MnfDate);
  CUCopy.InitRun:=0;
  CUCopy.Storage:=Storage.Storage;
  CUCopy.Origin :=L_CUC.o_Other;
  CUCopy.Begin  :=Storage.Begin;
  CUCopy.Till   :=Storage.Till;
  INSERT(CUCopy);
  CUCopy.Serial :=L_CUC.GetDefaultSerial(CUCopy.CUCopy);
  REPLACE(CUCopy);
 END {TckBag_MakeCUCopy};

 PRIVATE PROCEDURE TckBag_RemoveCUCopy();
 BEGIN
  L_StdFrm.Choice(" " + CUCopy.CUCopy + " 㤥 㤠");
  REMOVE(CUCopy);
 END {TckBag_RemoveCUCopy};

 PRIVATE PROCEDURE TckBag_MakeLinkToCUCopy(_CUCopy: LIKE(CUCopy.CUCopy));
 BEGIN
  L_General.CallUs(SEARCH(CUCopy, CUCopy, _CUCopy));
  CUCopy.Storage:=Storage.Storage;
  REPLACE(CUCopy);
 END {TckBag_MakeLinkToCUCopy};

 PRIVATE PROCEDURE AccessStrgKind();
 BEGIN
  IF ACCESS(Storage) & ~!Storage.StrgKind THEN
   CONFORM(Storage, StrgKind);
  ELSE
   L_General.Assert(ACCESS(StrgKind), " ⠭ ⥪    ");
  END;
 END {AccessStrgKind};

 PRIVATE PROCEDURE Storage_OnAfterEdit();
  VAR
   ff: FORM_FIELDS;
 BEGIN
  AccessStorage2(GE_PVALUE(Storage.Storage));
  CopyRecord(1, 0, Storage2.Storage2);
  Storage_OnAfterEdIns();
  IF Storage.Type = L_Stock.st_TckBag THEN
   ff:=RTI.Get().CurZone.Fields;
   IF SELECT(CUCopy, Storage, GE_PVALUE(Storage.Storage)) THEN
    IF    !ff("ff_CUCopy").Value THEN
     TckBag_RemoveCUCopy();
     TckBag_MakeCUCopy(ff("ff_Math").Value);
    ELSIF ff("ff_CUCopy").Value # CUCopy.CUCopy THEN
     TckBag_RemoveCUCopy();
     TckBag_MakeLinkToCUCopy(ff("ff_CUCopy").Value);
    END;
   ELSIF ~!ff("ff_CUCopy").Value THEN
    TckBag_MakeLinkToCUCopy(ff("ff_CUCopy").Value);
   ELSE
    TckBag_MakeCUCopy(ff("ff_Math").Value);
   END;
  END;
 END {Storage_OnAfterEdit};

 PUBLIC PROCEDURE Storage_OnAfterNoninteractiveEdit();
 BEGIN
  AccessStorage2(Storage.Storage);
  CopyRecord(0, 0, Storage.Storage);
  Storage_OnAfterEdIns();
 END {Storage_OnAfterNoninteractiveEdit};

 PUBLIC PROCEDURE Storage_OnAfterNoninteractiveInsert();
 BEGIN
  CopyRecord(0, 1, "");
  Storage_OnAfterEdIns();
 END {Storage_OnAfterNoninteractiveInsert};

 PRIVATE PROCEDURE Storage_OnAfterInsert();
 BEGIN
  CopyRecord(1, 1, "");
  Storage_OnAfterEdIns();
  IF Storage.Type = L_Stock.st_TckBag THEN
   IF ~!RTI.Get().CurZone.Fields("ff_CUCopy").Value THEN
    TckBag_MakeLinkToCUCopy(RTI.Get().CurZone.Fields("ff_CUCopy").Value);
   ELSE
    TckBag_MakeCUCopy(RTI.Get().CurZone.Fields("ff_Math").Value);
   END;
  END;
 END {Storage_OnAfterInsert};

 PRIVATE PROCEDURE CheckManualModification(AllowToAdmin: SCAL[2]);
  CONST
   AutoStrgMsg = " ࠭    ⮫쪮 ⮬᪨";
  VAR
   IsAutoStrg: SCAL[2];
   Fields: FORM_FIELDS;
 BEGIN
  AccessStrgKind();
  IsAutoStrg:=(StrgKind.Type # L_Stock.st_Stock) &
              (StrgKind.Type # L_Stock.st_Distributor) &
              (StrgKind.Type # L_Stock.st_TckBag);
  IF IsAutoStrg THEN;
   IF AllowToAdmin THEN
    L_General.Assert_wReferToAdmin(0, AutoStrgMsg);
   ELSE
    L_General.Error(AutoStrgMsg);
   END;
  END;
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Storage.Name").Modifiable :=~IsAutoStrg;
  IF ~!Fields("Storage.Sign") THEN
   Fields("Storage.Sign").Modifiable :=~IsAutoStrg;
  END;
  Fields("Storage.Begin").Modifiable:=~IsAutoStrg;
 END {CheckManualModification};

 PRIVATE PROCEDURE Storage_OnBeforeInsert();
 BEGIN
  CheckManualModification(0);
  AccessStrgKind();
  Storage.Begin   :=Memo.ud_cd();
  Storage.Type    :=StrgKind.Type;
  Storage.Apparent:=StrgKind.Apparent;
  Storage.MyFirm  :=P_Firm.DefineMyFirm();
  REPLACE(Storage);
 END {Storage_OnBeforeInsert};

 PRIVATE PROCEDURE Storage_OnBeforeEdit();
 BEGIN
  CheckManualModification(1);
 END {Storage_OnBeforeEdit};

 PRIVATE PROCEDURE Storage_OnBeforeDelete();
 BEGIN
  CheckManualModification(0);
  L_General.Assert(~SELECT(StrgLog, Storage, Storage.Storage),
                   "। 㤠  ࠭ ᫥  ९");
  L_Stock.mItem_CheckAllIsZero(EMPTYOF(Math.Math), Storage.Storage, 1);
  AccessStorage2(Storage.Storage);
  TRY
   REMOVE(Storage2);
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = 223 THEN
    L_General.Error("   㤠, ⮬ " +
                    "|  뫠  㣮 䠩");
   ELSE
    RAISE();
   END;
  END; (* TRY *)
  L_qs.OnBeforeDelete("Storage");
  L_r2r.Owner_OnBeforeDelete("Storage");
 END {Storage_OnBeforeDelete};

 PRIVATE PROCEDURE StorageE_0_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("StrgKind.Type").Format:=L_Stock.st_Pool_PL;
 END {StorageE_0_OnZoneOpen};

 PRIVATE PROCEDURE StrgE1_0_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("StrgKind.Type").Format:=L_Stock.st_Pool_PL;
 END {StrgE1_0_OnZoneOpen};

 PRIVATE PROCEDURE StrgLog_OnBeforeInsert();
  VAR
   D: DATE;
 BEGIN
  SAVE(StrgLog);
  SELECT(StrgLog, Storage, , StrgLog.Storage);
  IF ~!StrgLog.Date THEN
   IF ~SRCINSEL(StrgLog, EQ, Memo.ud_cd()) THEN
    D:=Memo.ud_cd();
   ELSE
    SETEMPTY(D);
   END;
  ELSE
   ACCESS(Storage);
   D:=Storage.Begin;
  END;
  RESTORE(StrgLog);
  StrgLog.Date:=D;
  REPLACE(StrgLog);
 END {StrgLog_OnBeforeInsert};

 PRIVATE PROCEDURE StrgLog_OnBeforeDelete();
 BEGIN
  (*nothing*)
 END {StrgLog_OnBeforeDelete};

 PRIVATE PROCEDURE StrgLog_OnAfterEdIns();
  VAR
   IsLastLog: SCAL[2];
 BEGIN
  IF Storage.Type = L_Stock.st_TckBag THEN
   SAVE(StrgLog);
   CHANGESEL(StrgLog, Storage, , StrgLog.Storage);
   IsLastLog:=~NEXT(StrgLog);
   RESTORE(StrgLog);
   L_General.Assert(~IsLastLog | BagIsEmpty(StrgLog.Date), "㬪   ");
   CONFORM(StrgLog, Staff);
   L_General.Assert(~L_Env.RealTSN(Staff.TSN) | L_Staff.rInState(StrgLog.Date),
                    "⭨     " + L_DatTim.DateStr(StrgLog.Date));
  END;
 END {StrgLog_OnAfterEdIns};

 PRIVATE PROCEDURE StrgLog_OnAfterInsert();
 BEGIN
  StrgLog_OnAfterEdIns();
 END {StrgLog_OnAfterInsert};

 PRIVATE PROCEDURE StrgLog_OnAfterEdit();
 BEGIN
  StrgLog_OnAfterEdIns();
 END {StrgLog_OnAfterEdit};

 PRIVATE PROCEDURE Storage_1_OnSetSubwindow();
  VAR
   SubwindowName: STRING[];
 BEGIN
  AccessStrgKind();
  IF StrgKind.Type = L_Stock.st_Distributor THEN
   SubwindowName:="StrgE1";
  ELSE
   SubwindowName:="StorageE";
  END;
  RTI.Get().CurZone.SubwindowOriginalName:=SubwindowName;
 END {Storage_1_OnSetSubwindow};

 PRIVATE PROCEDURE Strg2_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Storage";
  L_WDO.iEvents      (1, [L_WDO.e_OnAnyModification, L_WDO.e_OnAfterDelete]);
  L_WDO.iZone        (1).Narrowing:="Storage.StrgKind=96";
  L_WDO.iSubwindow   (1, "StrgE2");
 END {Strg2_OnInitializeWindow};

 PRIVATE PROCEDURE StrgE2_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "ff_CUCopy").OnBeforeAsk:=1;
  L_WDO.iField       (0, "ff_Math").OwnerWindowOriginalName:="Math";
  L_WDO.iScsChange   (0, ["ff_CUCopy", "ff_Math"]);
  L_WDO.iUnmodifiable(0, ["Storage.Storage"]);
  L_WDO.iMayBeEmpty  (0, ["Storage.Till", "ff_CUCopy"]);
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeInsert]);
  L_WDO.iProgs       (1, "Storage");
  L_WDO.CreateFormLink("Math",   "ff_");
  L_WDO.CreateFormLink("CUCopy", "ff_");

  RTI.Get().CurWindow.OnOpenWindow :=1;
 END {StrgE2_OnInitializeWindow};

 PRIVATE PROCEDURE StrgE2_0_OnReposition();
  VAR
   EditFlag: SCAL[2];
   Users   : STRING[][64];
 BEGIN
  IF ACCESS(Storage) & SELECT(CUCopy, Storage, Storage.Storage) THEN
   CONFORM(CUCopy, Math);
   RTI.Get().CurZone.Fields("ff_Math").Value  :=Math.Math;
   RTI.Get().CurZone.Fields("ff_CUCopy").Value:=CUCopy.CUCopy;
   L_DBD.GetActiveUsers("Storage", Users);
   EditFlag  :=(Users[0] = "CUCopy") & !Users[1];
   L_General.CallUs(L_DBD.TestUsers("CUCopy", 1));
  ELSE
   SETEMPTY(RTI.Get().CurZone.Fields("ff_Math").Value, RTI.Get().CurZone.Fields("ff_CUCopy").Value);
   EditFlag  :=1;
  END;
  RTI.Get().CurZone.Fields("ff_Math"  ).Modifiable:=EditFlag;
  RTI.Get().CurZone.Fields("ff_CUCopy").Modifiable:=EditFlag;
 END {StrgE2_0_OnReposition};

 PRIVATE PROCEDURE StrgE2_OnOpenWindow();
 BEGIN
  IF L_APtm.IsTicketCashier() THEN
   L_AR.GrantRightsForInteractiveModification();
  END;
 END {StrgE2_OnOpenWindow};

 PRIVATE PROCEDURE Storage__OnBeforeAskForEdit();
 BEGIN
  IF RTI.Get().CurZone.ActiveField.Name = "ff_CUCopy" THEN
   IF ~!RTI.Get().CurZone.Fields("ff_Math").Value THEN
    RTI.Get().CurZone.Fields("ff_CUCopy").OwnerWindowOriginalName:="CUCopy";
   ELSE
    RTI.Get().CurZone.Fields("ff_CUCopy").OwnerWindowOriginalName:="CUCopyA";
   END;
  END;
 END {Storage__OnBeforeAskForEdit};

 PRIVATE PROCEDURE Storage__OnSuccessfulChange();
 BEGIN
  IF    RTI.Get().CurZone.ActiveField.Name = "ff_Math" THEN
   SETEMPTY(RTI.Get().CurZone.Fields("ff_CUCopy").Value);
  ELSIF RTI.Get().CurZone.ActiveField.Name = "ff_CUCopy" THEN
   IF ~!RTI.Get().CurZone.Fields("ff_CUCopy").Value THEN
    L_General.Assert(SEARCH(CUCopy, CUCopy, RTI.Get().CurZone.Fields("ff_CUCopy").Value), "   " + RTI.Get().CurZone.Fields("ff_CUCopy").Value);
    L_General.Assert(!CUCopy.Storage | (CUCopy.Storage = Storage.Storage),
                     "  " + CUCopy.CUCopy + " 㦥 㪠 㣮  ࠭");
    L_General.Assert(L_DBD.TestUsers("CUCopy", 1),
                     " " + CUCopy.CUCopy + " ᯮ  㣨 䠩");
    CONFORM(CUCopy, Math);
    RTI.Get().CurZone.Fields("ff_Math").Value:=Math.Math;
   END;
  END;
 END {Storage__OnSuccessfulChange};

 PRIVATE PROCEDURE SDfStrg_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit]);
  L_WDO.iField       (0, "dsAssigned").Format:="-|";
  L_WDO.iScsChange   (0, ["Storage", "dsAssigned"]);
  L_WDO.iProgs       (0, "Storage");
  L_WDO.CreateFormLink("Storage", "");
 END {SDfStrg_OnInitializeWindow};

 PRIVATE PROCEDURE SDfStrg_OnBeforeEdit();
 BEGIN
  L_WDO.cField("dsAssigned").Value  :=L_Stock.dsAssigned;
  L_WDO.cField("Storage").Modifiable:=L_Stock.dsAssigned;
  L_WDO.cField("Storage").Value     :=L_Stock.defaultStorage;
 END {SDfStrg_OnBeforeEdit};

 PRIVATE PROCEDURE SDfStrg_dsAssigned_OnSuccessfulChange();
 BEGIN
  L_WDO.cField("Storage").Modifiable:=L_WDO.cField("dsAssigned").Value;
 END {SDfStrg_dsAssigned_OnSuccessfulChange};

 PRIVATE PROCEDURE SDfStrg_Storage_OnSuccessfulChange();
 BEGIN
  L_Stock.CheckIsAuthorizedStorage(L_WDO.cField("Storage").Value);
 END {SDfStrg_Storage_OnSuccessfulChange};

 PRIVATE PROCEDURE SDfStrg_OnAfterEdit();
 BEGIN
  L_Stock.defaultStorage:=L_WDO.cField("Storage").Value;
  L_Stock.dsAssigned    :=L_WDO.cField("dsAssigned").Value;
  L_SES.PutValueAtCurTrn(L_SES.sit_User, "L_Stock.defaultStorage", L_Stock.defaultStorage);
  L_SES.PutValueAtCurTrn(L_SES.sit_User, "L_Stock.dsAssigned",     L_Stock.dsAssigned);
 END {SDfStrg_OnAfterEdit};

 PUBLIC PROCEDURE ChangeStorage_StrgKind();
  VAR
   StrgKinds: L_Stock.tStorageKind[MAXOF(L_Stock.tStorageKind)+1];
   List     : STRING[];
   i,
   c        : NUMERIC[0];
 BEGIN
  ACCESS(Storage);
  L_General.Assert_wReferToAdmin(0, "    ⥪饣 ");
  SETEMPTY(c);
  List:="";
  i:=0;
  SELECT(StrgKind, StrgKind);
  WHILE OCCURE(StrgKind) DO
   IF (StrgKind.Type = L_Stock.st_Stock) | (StrgKind.Type = L_Stock.st_Distributor) THEN
    StrgKinds[i]:=StrgKind.StrgKind;
    List:=List + StrgKind.StrgKind + " " + StrgKind.Name + "|";
    IF StrgKind.StrgKind = Storage.StrgKind THEN
     c:=i;
    END;
    INC(i);
   END;
   NEXT(StrgKind);
  END; (* WHILE OCCURE(StrgKind) ... *)
  L_General.Assert(~!c, "饭   ⥪饣 ");
  Storage.StrgKind:=StrgKinds[L_StdFrm.ShowListAsMenu_wInit(List, " 롮   ", c)];
  REPLACE(Storage);
  CONFORM(Storage, StrgKind);
  Storage.Type    :=StrgKind.Type;
  Storage.Apparent:=StrgKind.Apparent;
  REPLACE(Storage);
  Storage_OnAfterNoninteractiveEdit();
 END {ChangeStorage_StrgKind};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
}
*)

(*
$P{ Top1:
?, R, ""
Memo.ud_cd(), L, "D.N.y"
@
|------------------------------------------------------------------------------------------------------------|
|                              ###################  㬪  ##########                              |
|------------------------------------------------------------------------------------------------------------|
|    |                                    |⭨                       |ਬ砭         |
|-------|------------------------------------------------|-------------------------------|-------------------|
}
*)

(*
$P{ FirmTop:
?, L, ""
@
|############################################################################################################|
}
*)

(*
$P{ Line:
Storage.Storage, L, ""
Storage.Name, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|#######|################################################|##### #########################|###################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PUBLIC PROCEDURE UnfixedBags();
  VAR
   StorageFixedStaff: LIKE(Staff.TSN);
   bagIsEmpty,
   bagIsFixed       : SCAL[2];
 BEGIN
  L_AFM.MakeIndex("tmp", "_Firm   : LIKE(Firm.Firm);" +
                         "Fixed   : SCAL[2];" +
                         "_Storage: LIKE(Storage.Storage);" +
                         "Empty   : SCAL[2];" +
                         "TSN     : LIKE(Staff.TSN)");
  SELECT(Storage, StrgKind, , L_Stock.sk_TckBag);
  WHILE OCCURE(Storage) DO
   PROMPT(Storage.Storage);
   IF L_DatTim.IsActive(Memo.ud_cd(), Storage.Begin, Storage.Till) THEN
    StorageFixedStaff:=L_Stock.GetStorageFixedStaff(Storage.Storage, Memo.ud_cd());
    IF ~!StorageFixedStaff THEN
     L_General.CallUs(SELECT(Staff, TSN, StorageFixedStaff));
    END;
    bagIsEmpty:=BagIsEmpty(EMPTYOF(DATE));
    bagIsFixed:=~!StorageFixedStaff & L_Staff.rInState(Memo.ud_cd());
    IF bagIsEmpty | ~bagIsFixed THEN
     ADD(tmp, tmp, , P_Firm.fomf(Storage.MyFirm), bagIsFixed, Storage.Storage, bagIsEmpty, StorageFixedStaff);
    END;
   END;
   NEXT(Storage);
  END; (* WHILE OCCURE(Storage) ... *)

  OPENREP(R, L_General.NameConnection("UnfBg"), Create);
  MAKEPART(R, Top, "UnfBg");
  SELECT(tmp, tmp);
  WHILE OCCURE(tmp) DO
   NARROWSEL(tmp, _Firm);
   MAKEPART(R, FirmTop, P_Firm.FP_FirmName(tmp._Firm, SYSDATE()));
   WHILE OCCURE(tmp) DO
    NARROWSEL(tmp, Fixed);
    MAKEPART(R, Top1, L_Str.PoolItem("९| ९", tmp.Fixed));
    WHILE OCCURE(tmp) DO
     SEARCH(Storage, Storage, , tmp._Storage);
     IF ~!tmp.TSN THEN
      SEARCH(Staff, TSN, , tmp.TSN);
      CONFORM(Staff, Man);
      MAKEPART(R, Line, tmp.TSN, L_Str.ShortName(Man.Name), L_Str.PoolItem("㬪  |", tmp.Empty));
     ELSE
      MAKEPART(R, Line,        ,                          , L_Str.PoolItem("㬪  |", tmp.Empty));
     END;
     NEXT(tmp);
    END; (* WHILE OCCURE(tmp) ... *)
    NEXTINEXTENDEDSEL(tmp, Fixed);
   END; (* WHILE OCCURE(tmp) ... *)
   IF NEXTINEXTENDEDSEL(tmp, _Firm) THEN
    MAKEPART(R, FirmTop, L_Str.Repeat("=", 110));
   END;
  END; (* WHILE OCCURE(tmp) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("tmp");
  L_General.SurveyLastReport();
 END {UnfixedBags};

 PRIVATE PROCEDURE GetStrgKindPermanentFilter(): STRING[];
 BEGIN
  RETURN "(StrgKind.Type#"+L_Str.IntStr(L_Stock.st_TckBag)+")&(StrgKind.Type#"+L_Str.IntStr(L_Stock.st_Car)+")";
 END {GetStrgKindPermanentFilter};

 PRIVATE PROCEDURE Storage_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Storage";
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).PermanentFilter:=GetStrgKindPermanentFilter();
  L_WDO.iField       (2, "StrgKind.Type").Format:=L_Stock.st_Pool_PL;
  L_WDO.iEvents      (1, [L_WDO.e_OnSetSubwindow]);
  L_WDO.iZone        (1).Narrowing:="Storage.StrgKind=StrgKind.StrgKind";
 END {Storage_OnInitializeWindow};

 PRIVATE PROCEDURE StrgKind_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeInsert]);
  L_WDO.iZone        (1).PermanentFilter:=GetStrgKindPermanentFilter();
  L_WDO.iScsChange   (1, ["StrgKind.StrgKind", "StrgKind.Type"]);
  L_WDO.iField       (1, "StrgKind.Type").Format:=L_Stock.st_Pool_PL;
  L_WDO.iProgs       (1, "Storage");
 END {StrgKind_OnInitializeWindow};

PRIVATE PROCEDURE StrgKind_OnBeforeInsert();
BEGIN
 StrgKind.Apparent:=1;
 REPLACE(StrgKind);
END {StrgKind_OnBeforeInsert};

 PRIVATE PROCEDURE IsSelectableStrgKindType(): SCAL[2];
 BEGIN
  RETURN ~!L_Str.PoolItem(L_Stock.st_Pool_Selectable, StrgKind.Type);
 END {IsSelectableStrgKindType};

 PRIVATE PROCEDURE StrgKind_OnBeforeEdit();
 BEGIN
  IF ~IsSelectableStrgKindType() THEN
   L_General.Error("  " + StrgKind.StrgKind + " १ࢨ஢ ⮏.|䨪 ");
  END;
 END {StrgKind_OnBeforeEdit};

 PRIVATE PROCEDURE StrgKind_StrgKind_OnSuccessfulChange();
 BEGIN
  IF  (StrgKind.StrgKind = L_Stock.sk_AdvHolder) |
      (StrgKind.StrgKind = L_Stock.sk_Contract)  |
      (StrgKind.StrgKind = L_Stock.sk_Car)       |
      (StrgKind.StrgKind = L_Stock.sk_TckBag)    |
      (StrgKind.StrgKind = L_Stock.sk_MyFirm) THEN
   L_General.Error(" " + StrgKind.StrgKind + " १ࢨ஢ ⮏");
  END;
 END {StrgKind_StrgKind_OnSuccessfulChange};

 PRIVATE PROCEDURE StrgKind_Type_OnSuccessfulChange();
 BEGIN
  L_General.Assert(IsSelectableStrgKindType(),
                   "   '" + L_Str.PoolItem(L_Stock.st_Pool_PL, StrgKind.Type) + "' 砥 ⮫쪮 ⮏");
 END {StrgKind_Type_OnSuccessfulChange};

BEGIN
 L_Events.ExecuteHandler();
END.
