(*
%Copyright   (c) Polak IT
%Author      01.09.2011 20:08:33 POLAK\Bor
%Purpose       
%Type        report
%Specific    SYS
%Modified    17.01.2013 17:27:45 POLAK\Bor
%Environment
*)

 MODULE StOrd [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_XObj, L_MDoc, L_XDoc, L_Acnt, L_AcCut, L_AFM, L_MathR, L_Str,
        L_Basis, L_XDF, P_Firm, FIO, L_AR, L_APAR;

 PRIVATE PROCEDURE MakeTop(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, " ꥪ⠊");
  L_Basis.wb_WrInQM(F, " ꥪ");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, "ꥪ");
  L_Basis.wb_WrInQM(F, " ७");

  L_Basis.wb_WrInQM(F, " 㬥⠊");
  L_Basis.wb_WrInQM(F, " 㬥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "室 ");
  L_Basis.wb_WrInQM(F, " 㬥");
  L_Basis.wb_WrInQM(F, "室 ");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, " 樨");
  L_Basis.wb_WrInQM(F, "訫");
  L_Basis.wb_WrInQM(F, "訫");
  L_Basis.wb_WrInQM(F, "⢮");
  L_Basis.wb_WrInQM(F, "⢨");
  L_Basis.wb_WrInQM(F, " ⢨");
  L_Basis.wb_WrInQM(F, "஫ ப");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");

  L_Basis.wb_TermLine(F);
 END {MakeTop};

 PRIVATE PROCEDURE MakeLine(F: STRING[]; curQnt: L_XObj.tQnt);
  VAR
   curXDocType: L_XDoc.tXDocType;
   curXDocKind: L_XDoc.tXDocKind;
   curXDoc    : L_XDoc.tXDoc;
 BEGIN
  L_Basis.wb_WrScl(F, MathType.MathType);
  L_Basis.wb_WrStr(F, MathType.Name);
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrStr(F, L_MathR.DefaultMUnitSign(Math.Math));

  L_General.CallUs(L_XDoc.ExtractXDocType(MSHst.XDocId) = L_XDoc.xdt_MDoc);
  L_XDoc.PositionOnXDoc(MSHst.XDocId);
  CONFORM(MDoc, Dest);
  CONFORM(MDoc, Alower);

  L_Basis.wb_WrScl(F, MDoc.MDocKind);
  L_Basis.wb_WrStr(F, L_MDoc.MDocKindNick(MDoc.MDocKind, 1));
  L_Basis.wb_WrScl(F, MDoc.MDoc);
  L_Basis.wb_WrStr(F, MDoc.SrcNbr);
  L_Basis.wb_WrDat(F, MDoc.Date);
  L_Basis.wb_WrDat(F, MDoc.SrcDate);
  L_Basis.wb_WrScl(F, Dest.Dest);
  L_Basis.wb_WrScl(F, Dest.Name);
  IF OCCURE(Alower) THEN
   L_Basis.wb_WrScl(F, Alower.Alower);
   L_Basis.wb_WrStr(F, Alower.Name);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;

  L_Basis.wb_WrNum(F, curQnt, 2);
  IF OCCURE(XDocFlow) THEN
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_XDF.a_Pool_1, XDocFlow.Action));
   L_Basis.wb_WrDat(F, XDocFlow.SrcDate);
   L_Basis.wb_WrDat(F, XDocFlow.TrgDate);

   IF !XDocFlow.OnBehalf THEN
    SEARCH(Staff, TSN, , XDocFlow.Author);
   ELSE
    SEARCH(Staff, TSN, , XDocFlow.OnBehalf);
   END;
   CONFORM(Staff, Man);
   L_Basis.wb_WrStr(F, Staff.TSN+" "+Man.Name);

   IF ~!XDocFlow.To THEN
    SEARCH(AcsObj, AcsObj, , XDocFlow.To);
    IF AcsObj.Type = L_AR.aot_User THEN
     SEARCH(Staff, TSN, , L_APAR.User2TSN(XDocFlow.SrcDate, XDocFlow.To));
     CONFORM(Staff, Man);
     L_Basis.wb_WrScl(F, Staff.TSN+" "+Man.Name);
    ELSE
     L_Basis.wb_WrScl(F, AcsObj.AcsObj+" "+AcsObj.FullName);
    END;
   ELSE
    L_Basis.wb_WrStr(F, "---");
   END;
   L_Basis.wb_WrStr(F, XDocFlow.RslTxt);
  ELSE
   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrDat(F, EMPTYOF(DATE));
   L_Basis.wb_WrDat(F, EMPTYOF(DATE));

   CONFORM(MDoc, Staff);
   CONFORM(Staff, Man);
   L_Basis.wb_WrStr(F, Staff.TSN+" "+Man.Name);

   L_Basis.wb_WrStr(F, "---");
   L_Basis.wb_WrStr(F, "---");
  END;

  L_Basis.wb_TermLine(F);
 END {MakeLine};

 PRIVATE PROCEDURE GetXDocDoneDTS(trgXDocId: L_XDoc.tXDocId): L_XDoc.tDoneDTS;
  VAR
   Result: L_XDoc.tDoneDTS;
   curRefFileName: STRING[];
   curDoneDTSField: FIELD;
 BEGIN
  SETEMPTY(Result);
  curRefFileName:=L_XDoc.Ref_FileName(L_XDoc.ExtractXDocType(trgXDocId));
  curDoneDTSField:=TABLE.Get(curRefFileName).Fields("DoneDTS");
  L_General.CallUs(~!curDoneDTSField);
  TRY
   L_General.CallUs(L_XDoc.StandOnXDoc(trgXDocId));
   Result:=^(curDoneDTSField.ObtainName());
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  RETURN Result;
 END {GetXDocDoneDTS};

 PRIVATE PROCEDURE AddXCalcSel(trgSld: L_XObj.tQnt);
  VAR

   leftSide: SCAL[2];
   curQnt  : L_XObj.tQnt;
 BEGIN
  SETSEL(XApport, WFD, XCalc.XObject, XCalc.AcCut);
  LAST(XApport);
  WHILE OCCURE(XApport) DO
   NARROWSEL(XApport, WFDate);
   WHILE OCCURE(XApport) DO
    CONFORM(XApport, Apport);
    FOR_EACH leftSide DO
     L_XObj.SelectXDocAprByXApport(leftSide);
     WHILE OCCURE(XDocApr) DO
      IF (( leftSide & (XDocApr.wQnt MOD 2)) |
          (~leftSide & (XDocApr.wQnt DIV 2))) &
          (XDocApr.Qnt # 0) THEN
       IF Apport.CirType = L_Acnt.ct_Credit THEN
        curQnt:=-XDocApr.Qnt;
       ELSE
        curQnt:=XDocApr.Qnt;
       END;
       ADD(MSHst, MSHst, , mItem.MyFirm, mItem.Math, XDocApr.XDat, L_XDoc.GetXDocDate(XDocApr.XDocId),
                           GetXDocDoneDTS(XDocApr.XDocId), XDocApr.XDocId,
           MSHst.Qnt, curQnt);
      END;
      NEXT(XDocApr);
     END; (* WHILE OCCURE(XDocApr) ... *)
    END; (* FOR_EACH leftSide ... *)
    PREV(XApport);
   END; (* WHILE OCCURE(XApport) *)
   FIRST(XApport);

   SETSEL(MSHst, MSHst, mItem.MyFirm, mItem.Math, XApport.WFDate);
   LAST(MSHst);
   WHILE OCCURE(MSHst) DO
    DEC(trgSld, MSHst.Qnt);
    SETSEL(XDocFlow, XDocFlow, MSHst.XDocId); (*   樨  XDocFlow*)
    MakeLine("R", MSHst.Qnt);
    FIRST(XDocFlow);
    WHILE OCCURE(XDocFlow) DO
     MakeLine("R", 0);
     NEXT(XDocFlow);
    END; (* WHILE OCCURE(XDocFlow) ... *)
    IF trgSld = 0 THEN
     RETURN;
    END;
    PREV(MSHst);
   END; (* WHILE OCCURE(MSHst) ... *)

   CHANGESEL(XApport, WFD, , XApport.XObject, XApport.AcCut);
   PREV(XApport);
  END; (* WHILE OCCURE(XApport) *)
 END {AddXCalcSel};

 PRIVATE PROCEDURE MakeOneAcCut(trgAcCut: LIKE(AcCut.AcCut));
  VAR
   curQnt: L_XObj.tQnt;
 BEGIN
  L_General.CallUs(SEARCH(AcCut, AcCut, trgAcCut));
  SELECT(XCalc, AcCut, , AcCut.AcCut);
  WHILE OCCURE(XCalc) DO
   PROMPT(XCalc.XObject);
   NARROWSEL(XCalc, XObject);
   CONFORM(XCalc, XObject);
   IF XObject.Origin = L_XObj.o_Math THEN
    L_XObj.AccessOrigin();
    CONFORM(mItem, Math);
    CONFORM(Math, MathType);
    LAST(XCalc);
    curQnt:=L_XObj.qo_OutSaldo();
    IF curQnt # 0 THEN
     AddXCalcSel(curQnt);
    END;
   END;
   NEXTINEXTENDEDSEL(XCalc, XObject);
  END; (* WHILE OCCURE(XCalc) *)
 END {MakeOneAcCut};

 PRIVATE PROCEDURE MakeRep();
  VAR
   curAcCut: LIKE(AcCut.AcCut);
 BEGIN
  L_General.Assert(SEARCH(MDocKind, MDocKind, L_MDoc.md_ZMC), "     ");
  L_AFM.MakeIndex("_ACut", "AcCut: LIKE(AcCut.AcCut)");
  SELECT(AcMth, DGroup, , MDocKind.DGroup);
  WHILE OCCURE(AcMth) DO
   IF L_DatTim.IsActive(SYSDATE(), AcMth.Begin, AcMth.Till) THEN
    SETSEL(AcMthH, AcMth, AcMth.AcMth);
    SRCINSEL(AcMthH, LE, , SYSDATE());
    IF SELECT(AcMthL, AcMth, AcMthH.AcMth, AcMthH.Date) THEN
     IF AcMthL.AcCut # L_AcCut.Fictive() THEN
      ADD(_ACut, _ACut, , AcMthL.AcCut);
     END;
    END;
   END;
   NEXT(AcMth);
  END; (* WHILE OCCURE(AcMth) ... *)

  L_AFM.MakeMultipleIndex("MSHst", "MyFirm   : LIKE(MyFirm.MyFirm);"+
                                   "Math     : LIKE(Math.Math);"+
                                   "XDat     : DATE;"+
                                   "Date     : DATE;"+
                                   "DoneDTS  : "+GET_TYPE_SPEC(L_XDoc.tDoneDTS).Name+";"+
                                   "XDocId   : "+GET_TYPE_SPEC(L_XDoc.tXDocId).Name+";"+
                                   "Qnt      : "+GET_TYPE_SPEC(L_XObj.tQnt).Name,
                          "MSHst: MyFirm, Math, XDat, Date, DoneDTS, XDocId");

  L_General.Assert(SELECT(_ACut, _ACut), "    ࠧ१    ");
  WHILE OCCURE(_ACut) DO
   MakeOneAcCut(_ACut.AcCut);
   NEXT(_ACut);
  END; (* WHILE OCCURE(_ACut) ... *)

  L_AFM.AF_PurgeTemp("MSHst");
  L_AFM.AF_PurgeTemp("_ACut");
 END {MakeRep};

 PUBLIC PROCEDURE StOrd();
  CONST
   RepName = "StOrd";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  MakeTop("R");

  MakeRep();
  FIO.Close(R);
  L_Basis.PlayMakedRunTimeRep(RepName, L_General.tc_Entire, "  ", 0);
 END {StOrd};

END.
