(*
%Copyright   (c) Polak Computer System
%Author      06.09.2002 11:56:01 GAV
%Purpose     ﭨ ᪨ ⮢  
%Type        report
%Specific    SYS
%Modified    24.09.2014 16:14:56 LDA
%Environment
*)

 MODULE St_BA_CO [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_XObj, L_General, L_DatTim, L_PDoc, L_AFM, P_Firm, L_Str, L_MathR, L_StdFrm;

 CONST
  MaxLevel = 3;

 PRIVATE PROCEDURE Prompt(_Date: DATE; Stage: STRING[]);
 BEGIN
  PROMPT(L_DatTim.DateStr(_Date) + Stage + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
 END {Prompt};

 PRIVATE PROCEDURE NeedPDoc(): SCAL[2];
 BEGIN
  RETURN (PDoc.Status # L_PDoc.st_Canceled) & (L_PDoc.MoneyKind(PDoc.PDocKind) # L_PDoc.mk_Nothing);
 END {NeedPDoc};

 PRIVATE PROCEDURE CheckPDoc();
 BEGIN
  L_PDoc.CheckDone();
  L_PDoc.CheckTaxed();
 END {CheckPDoc};

 PRIVATE PROCEDURE Access_BACO();
 BEGIN
  IF    L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Cash THEN
   SEARCH(_BACO, FirmAcnt, , PDoc.MyFirm, P_Firm.fa_CashOffice);
  ELSIF L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Bank  THEN
   SEARCH(_BACO, FirmAcnt, , PDoc.MyFirm, PDoc.OwnAcnt);
  END;
 END {Access_BACO};

 PRIVATE PROCEDURE CountPDoc(Level: SCAL[MaxLevel]);
  VAR
   i: SCAL[MaxLevel + 1];
   Sign: NUMERIC[0];
 BEGIN
  Access_BACO();
  L_General.CallUs(OCCURE(_BACO));
  IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
   Sign:=-1;
  ELSE
   Sign:=1;
  END;
  i:=Level;
  WHILE i < MaxLevel DO
   L_General.Assert(~!PDoc.Total, " । 㬬  㬥 "+L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   INC(_BACO.Rest[i], Sign * PDoc.Total);
   INC(i);
  END;
  REPLACE(_BACO);
 END {CountPDoc};

 PRIVATE PROCEDURE MakeIndex(_Date: DATE);
  VAR
   xacc: L_MathR.tMathAcCutCollection;
   i   : NUMERIC[0];
   faXO: LIKE(XObject.XObject);
 BEGIN
  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF MyFirm.MyFirm # P_Firm.mf_Fict THEN
    SELECT(FirmAcnt, FirmAcnt, , MyFirm.Firm);
    WHILE OCCURE(FirmAcnt) DO
     SELECT(_BACO, FirmAcnt, , EMPTYOF(MyFirm.Firm));
     faXO:=L_PDoc.GetGlobalXObject(MyFirm.MyFirm, FirmAcnt.FirmAcnt);
     IF ~!faXO THEN
      L_XObj.AccessXObject(faXO);
      _BACO.MyFirm  :=MyFirm.MyFirm;
      _BACO.FirmAcnt:=FirmAcnt.FirmAcnt;
      _BACO.Name    :=L_XObj.GetXObjectOriginName();
      _BACO.IsCurFA :=0;
      xacc:=L_MathR.GetXObjectAcCutCollection(XObject.XObject);
      i:=0;
      WHILE ~!xacc[i] DO
       SEARCH(AcCut, AcCut, , xacc[i]);
       IF L_kn.Is(_Date, L_AcCut.erkn_CentralCashOffice) |
          L_kn.Is(_Date, L_AcCut.erkn_SettlementAccounts) THEN
        _BACO.Rest[0]:=L_XObj.mo_GetInSaldo(xacc[i], L_DatTim.Per(_Date));
        IF _BACO.Rest[0] # 0 THEN
         _BACO.Rest[1]:=_BACO.Rest[0];
         _BACO.Rest[2]:=_BACO.Rest[0];
         L_General.Assert(~OCCURE(_BACO), " ꥪ " + XObject.XObject + "   祬  ࠧ१  㫥 ᠫ줮");
         INSERT(_BACO);
        END;
       END;
       INC(i);
      END; (* WHILE ~!xacc[i].. *)
      IF ~OCCURE(_BACO) THEN
       SETZERO(_BACO.Rest);
       INSERT(_BACO);
      END;
     END; (* IF ~!faXO.. *)
     NEXT(FirmAcnt);
    END; (* WHILE OCCURE(FirmAcnt) ... *)
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)

  SELECT(PDoc, Date);
  SRCINSEL(PDoc, GE, , L_DatTim.Per(_Date));
  WHILE OCCURE(PDoc) & (PDoc.Date < _Date) DO
   Prompt(_Date, ": 祭 室饣 ᠫ줮 ");
   IF NeedPDoc() THEN
    CheckPDoc();
    CountPDoc(0);
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc)... *)

  WHILE OCCURE(PDoc) DO
   IF NeedPDoc() THEN
    IF (PDoc.Status = L_PDoc.st_Passed) |
       L_PDoc.CB_IsUploadedPDoc(PDoc.PDocKind, PDoc.PDoc) THEN
     CountPDoc(1);
    ELSE
     CountPDoc(2);
    END;
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE CheckLastDocuments(VAR _Date: DATE);
  VAR
   DateChanged: SCAL[2];
 BEGIN
  SELECT(PDoc, Date);
  SRCINSEL(PDoc, GE, , L_DatTim.IncWorkDay(_Date, -5));
  DateChanged:=0;
  WHILE OCCURE(PDoc) & (PDoc.Date < _Date) DO
   Prompt(_Date, ": ஢ઠ  㬥⮢ ");
   TRY
    CheckPDoc();
   EXCEPT
   ON Exc:Exc_Raise DO
    STDMSG(" ࠡ⠭ 㬥  " + L_DatTim.DateStr(PDoc.Date) +
           "| | ⮢    ?| ", CHOICE);
    _Date:=PDoc.Date;
    DateChanged:=1;
   ELSE
    RAISE();
   END;
   IF DateChanged THEN
    SRCINSEL(PDoc, GE, , L_DatTim.IncWorkDay(_Date, -5));
    DateChanged:=0;
   ELSE
    NEXT(PDoc);
   END;
  END; (* WHILE OCCURE(PDoc)... *)
 END {CheckLastDocuments};

 PUBLIC PROCEDURE StBACO();
  VAR
   curDate   : DATE;
   MessageStr: STRING[];
 BEGIN
  curDate:=SYSDATE();
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(PDoc);
  SAVE(PDoc);
  CheckLastDocuments(curDate);
  L_AFM.MakeMultipleIndex("_BACO", "MyFirm  : LIKE(PDoc.MyFirm);"+
                                   "FirmAcnt: LIKE(FirmAcnt.FirmAcnt);" +
                                   "Name    : STRING[64];" +
                                   "IsCurFA : SCAL[2];"+
                                   "Rest    : NUMERIC[2]["+L_Str.IntStr(MaxLevel)+"]",
                          "FirmAcnt: MyFirm, FirmAcnt");

  MakeIndex(curDate);

  RESTORE(PDoc);
  IF OCCURE(PDoc) THEN
   Access_BACO();
   IF OCCURE(_BACO) THEN
    _BACO.IsCurFA:=1;
    REPLACE(_BACO);
   END;
  END;
  MessageStr:=  "                                                                   ஢묨/              |" +
                "ꥪ                                                "+L_DatTim.DateStr(curDate)+"  ࠢ묨⮢묨";

  SELECT(_BACO, FirmAcnt);
  WHILE OCCURE(_BACO) DO
   IF (_BACO.Rest[0] # 0) |(_BACO.Rest[1] # 0) |(_BACO.Rest[2] # 0) THEN
    MessageStr:=MessageStr +
                "|" +
                "|" + L_Str.PoolItem(" |*", _BACO.IsCurFA) + FLDTOSTR(_BACO.Name, "", 50) +
                "" + FLDTOSTR(_BACO.Rest[0], ",2-", 15) +
                "" + FLDTOSTR(_BACO.Rest[1], ",2-", 15) +
                "" + FLDTOSTR(_BACO.Rest[2], ",2-", 15) ;
   END;
   NEXT(_BACO);
  END; (* WHILE OCCURE(_BACO) ... *)
  L_AFM.AF_PurgeTemp("_BACO");

  IF curDate # SYSDATE() THEN L_StdFrm.RedInform(MessageStr);
  ELSE                        L_StdFrm.Inform   (MessageStr);
  END;
 END {StBACO};

END.
