(*
%Copyright   (c) Polak Computer System
%Author      01.02.1999 14:56:15 SAN
%Purpose      믨᪨  ⭮ 
%Type        report
%Specific    SYS
%Modified    24.09.2014 16:15:04 LDA
%Environment
*)

 MODULE St_Of_Ac [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_PDoc, L_Money, L_XObj, L_Str, L_AFM, P_Firm, Memo, L_StdFrm, L_Acnt;

 PRIVATE TYPE
  tMode = SCAL[3];

 PRIVATE CONST
  LinesInPage  = 40;
  RepWidth     = 140;
  LineSpacCoef = 0.82;

  m_CurDay    = 0;
  m_Period    = 1;
  m_PrvWrkDay = 2;

 PRIVATE VAR
  FirstPage,
  PagesInDate,
  CurLine     : NUMERIC[0];

(*
$P{ Top:
P_Firm.MyFirmName(MyFirm.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
FirstPage + PagesInDate, R, ""
?, C, ""
?, C, ""
"(ꥪ " + XObject.XObject + ")", C, ""
?, L, ""
?, R, ""
@
######################################################################################################################    ########## #####
                                                                                                                                N ####

##########################################################################################################################################
##########################################################################################################################################
##########################################################################################################################################
==========================================================================================================================================
|##########################################################################################################|##############|              |
}             
*)

(*
$P{ pwd_Top:
?, L, ""
?, L, ""
"(ꥪ " + XObject.XObject + ")", L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, R, ""
@
##########################################################################################################################################
##########################################################################################################################################
######################################################################################################################### ########## #####
==========================================================================================================================================
|##########################################################################################################|##############|              |
}             
*)

(*
$P{ e_PDTop:
@

==========================================================================================================================================
|                                    ࠡ⠭ 㬥  㬥  ﭨ "⮢"                                    |
}             
*)

(*
$P{ SubTop:
@
|----------------------------------------------------------------------------------------------------------|--------------|--------------|
|㬥      .    |      |                |ࠣ                         | |  |        室|        室|
|-----------------------------|---------|--------------------|-----------------------------------|---|-----|--------------|--------------|
}
*)

(*
$P{ Line:
L_PDoc.PDocKindNick(PDoc.PDocKind, 1), L, ""
PDoc.PDoc, L, ""
PDoc.SrcNbr, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
PDoc.Dest, L, ""
L_PDoc.GetCorAcnt(PDoc.PDocKind, PDoc.PDoc), L, ""
?, R, ""
?, R, ""
@
|### ######### ############ ##|#########|####################|###################################|###|#####|##############|##############|
}
*)

(*
$P{ EndOfPage:
?, L, ""
@
|----------------------------------------------------------------------------------------------------------|--------------|--------------|
|७  ᫥ ࠭                                                                             |##############|              |
=(c) Polak================================================================================================================================
}
*)

(*
$P{ EndOfDay:
?, R, ""
?, R, ""
?, R, ""
@
|----------------------------------------------------------------------------------------------------------|--------------|--------------|
|⮣                                                                                               |##############|##############|
|----------------------------------------------------------------------------------------------------------|--------------|--------------|
|⮪                                                                                         |##############|              |
}
*)

(*
$P{ EndOfDayDlm:
@
=(c) Polak================================================================================================================================
}
*)

(*
$P{ pwd_EndOfDayDlm:
@
==========================================================================================================================================

}
*)

(*
$P{ e_XCalcDtlTop:
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
                                                                                              ########## #####
==============================================================================================================
|                         室 ᠫ줮  ᪨ ⠬   믨᪠                           |
|------------------------------------------------------------------------------------------------------------|
|ꥪ                                               |    |  ᪨ |         믨᪠|   |
|-----------------------------------------------------|--------|-----------------|----------------|----------|
}             
*)

(*
$P{ e_XCalcDtlLine:
L_XObj.GetXObjectOriginName(), L, ""
?, L, "   |!!!"
?, L, "D.N.Y"
?, R, ",2-"
?, R, ",2-"
?, R, ""
@
|################################################# ###|########|#################|################|##########|
}             
*)

(*
$P{ e_XCalcDtlBot:
@
==============================================================================================================

}
*)

 PRIVATE PROCEDURE _MoneyToStr(_Date: DATE; M: NUMERIC[2]): STRING[];
 BEGIN
  RETURN L_Money.MoneyToStr(_Date, ",", M);
 END {_MoneyToStr};

 PRIVATE PROCEDURE AcceptablePDoc(_FirmAcnt: LIKE(FirmAcnt.FirmAcnt)): SCAL[2];
 BEGIN
  RETURN (L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Bank) &
         ((PDoc.OwnAcnt = _FirmAcnt) | !_FirmAcnt);
 END {AcceptablePDoc};

 PRIVATE PROCEDURE NeedPDoc(_FirmAcnt: LIKE(FirmAcnt.FirmAcnt)): SCAL[2];
 BEGIN
  RETURN AcceptablePDoc(_FirmAcnt) & (PDoc.Status = L_PDoc.st_Passed);
 END {NeedPDoc};

 PRIVATE PROCEDURE Prompt(Msg: STRING[]; _Date: DATE);
 BEGIN
  PROMPT(L_DatTim.DateStr(_Date) + " " + Msg);
 END {Prompt};

 PRIVATE PROCEDURE PromptFA(Msg: STRING[]; _Date: DATE);
 BEGIN
  Prompt(" " + FirmAcnt.Firm + ", " + FirmAcnt.FirmAcnt + ": " + Msg, _Date);
 END {PromptFA};

 PRIVATE PROCEDURE CheckSaldo(D: DATE; Saldo: L_XObj.tSum);
 BEGIN
  IF Saldo < 0 THEN
   L_StdFrm.Choice("⥫쭮 ᠫ줮  " +
                   L_DatTim.DateStr(D) + " (" + _MoneyToStr(D, Saldo) + ").  " +
                   FirmAcnt.Firm + ", " + FirmAcnt.FirmAcnt);
  END;
 END {CheckSaldo};

 PRIVATE PROCEDURE GetInSaldo(_Date: DATE; Strong: SCAL[2]): NUMERIC[2];
  VAR
   P      : DATE;
   InSaldo: NUMERIC[2];
 BEGIN
  APP.Get().NewPrompt(" 室饣 ᠫ줮");
  P      :=L_DatTim.Per(_Date);
  InSaldo:=L_XObj.mo_GetInRSaldo(L_kn.Get(P, L_AcCut.erkn_SettlementAccounts), P);
  L_General.Assert(InSaldo = L_XObj.mo_GetInSaldo(L_kn.Get(P, L_AcCut.erkn_SettlementAccounts), P),
                   L_XObj.GetXObjectOriginName()+
                   "|줮  "+L_DatTim.DateStr(P)+"|  १ ࠢ  ᫮|室  冷");
  SAVE(PDoc);
  SELECT(PDoc, Date);
  SRCINSEL(PDoc, GE, , P);
  WHILE OCCURE(PDoc) & (PDoc.Date < _Date) DO
   PromptFA(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc), _Date);
   IF NeedPDoc(FirmAcnt.FirmAcnt) & (PDoc.MyFirm = MyFirm.MyFirm) THEN
    IF    PDoc.Done THEN
     IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
      DEC(InSaldo, PDoc.Total);
     ELSE
      INC(InSaldo, PDoc.Total);
     END;
    ELSIF Strong THEN
     L_PDoc.CheckDone();
    END;
   END;
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc)... *)
  RESTORE(PDoc);
  CheckSaldo(_Date, InSaldo);
  RETURN InSaldo;
 END {GetInSaldo};

 PRIVATE PROCEDURE GetOutSaldo(_Date: DATE; InSaldo, Inc, Dec: NUMERIC[2]): NUMERIC[2];
  VAR
   OutSaldo: NUMERIC[2];
 BEGIN
  OutSaldo:=InSaldo + Inc - Dec;
  CheckSaldo(_Date+1, OutSaldo);
  RETURN OutSaldo;
 END {GetOutSaldo};

 PRIVATE PROCEDURE GetCorFirmData(    _Date : DATE;
                                  VAR _BIC  : LIKE(BankLog.BIC);
                                  VAR _AcntA: LIKE(FirmAcnt.AcntA);
                                  VAR _Name : LIKE(Firm.Name));
  VAR
   Dummy: STRING[];
   _Acnt: STRING[][2];
 BEGIN
  SAVE(FirmAcnt);
  SAVE(Firm);
  IF !PDoc.FirmAcnt THEN
   SETEMPTY(_AcntA, _BIC, _Name);
   IF ~!PDoc.Firm THEN
    CONFORM(PDoc, Firm);
    _Name:=P_Firm.FP_FirmShortName(Firm.Firm, _Date);
   END;
  ELSE
   CONFORM(PDoc, FirmAcnt);
   P_Firm.GetFirmData(_Date, _Name, Dummy, _Acnt, _BIC, Dummy, 0);
   _Name :=P_Firm.FP_FirmShortName(Firm.Firm, _Date);
   _AcntA:=_Acnt[P_Firm.fa_AcntInAcnt];
  END;
  RESTORE(Firm);
  RESTORE(FirmAcnt);
 END {GetCorFirmData};

 PRIVATE PROCEDURE PrintSingleLine(_Date: DATE);
  VAR
   _BIC     : LIKE(BankLog.BIC);
   _Name    : STRING[];
   _AcntA   : LIKE(FirmAcnt.AcntA);
   DocTotStr: STRING[30][2];
 BEGIN
  DocTotStr[0]:=" ";
  DocTotStr[1]:=" ";
  DocTotStr[L_PDoc.IsOutPDoc(PDoc.PDocKind)]:=_MoneyToStr(_Date, PDoc.Total);
  GetCorFirmData(_Date, _BIC, _AcntA, _Name);
  MAKEPART(R, Line, L_Str.PoolItem("||", PDoc.Status) + L_Str.PoolItem("-|", PDoc.Done),
                    _BIC,
                    _AcntA,
                    _Name,
                    DocTotStr[0],
                    DocTotStr[1]);
 END {PrintSingleLine};

 PRIVATE PROCEDURE IsPrvWorkDayReport(Mode: tMode): SCAL[2];
 BEGIN
  RETURN Mode = m_PrvWrkDay;
 END {IsPrvWorkDayReport};

 PRIVATE PROCEDURE MakeNextLine(    Mode   : tMode;
                                    _Date  : DATE;
                                VAR InSaldo: NUMERIC[2];
                                VAR curInc : NUMERIC[2];
                                VAR curDec : NUMERIC[2]);
  VAR
   Title1,
   Title2,
   InSaldoTitle: STRING[];
   OutSaldo    : NUMERIC[2];
 BEGIN
  IF CurLine = 0 THEN
   IF (PagesInDate = 0) | IsPrvWorkDayReport(Mode) THEN
    InSaldo     :=GetInSaldo(_Date, 1);
    InSaldoTitle:="⮪  砫 ";
    SAVE(PDoc);
    SELECT(PDoc, Date);
    SRCINSEL(PDoc, LT, , _Date);
    LOOP
     IF ~OCCURE(PDoc) THEN
      EXIT;
     END;
     PromptFA("祭  室饣 ᠫ줮 " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc), _Date);
     IF NeedPDoc(FirmAcnt.FirmAcnt) & (PDoc.MyFirm = MyFirm.MyFirm) THEN
      InSaldoTitle:="⮪   " + L_DatTim.DateStr(PDoc.Date);
      EXIT;
     END;
     PREV(PDoc);
    END; (* LOOP *)
    RESTORE(PDoc);

    Title1:=P_Firm.MyFirmName(MyFirm.MyFirm, SYSDATE()) + ", 믨᪠  ᪮   " + L_DatTim.DateStr(_Date);
    Title2:=P_Firm.FirmAcntAsStr(_Date);
    IF IsPrvWorkDayReport(Mode) THEN
     MAKEPART(R, pwd_Top, Title1, Title2, InSaldoTitle, _MoneyToStr(_Date, InSaldo));
    ELSE
     MAKEPART(R, Top,     Title1, Title2, InSaldoTitle, _MoneyToStr(_Date, InSaldo));
    END;
    MAKEPART(R, SubTop);
   ELSE
    OutSaldo:=GetOutSaldo(_Date, InSaldo, curInc, curDec);
    MAKEPART(R, EndOfPage, _MoneyToStr(_Date, OutSaldo));
    FORMFEED(R);
    MAKEPART(R, Top, "७  ।饩 ࠭", _MoneyToStr(_Date, OutSaldo));
    MAKEPART(R, SubTop);
   END;
   INC(PagesInDate);
  END;
  PromptFA(" " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc), PDoc.Date);
  PrintSingleLine(_Date);
  IF L_PDoc.IsOutPDoc(PDoc.PDocKind) THEN
   INC(curDec, PDoc.Total);
  ELSE
   INC(curInc, PDoc.Total);
  END;
  CurLine:=(CurLine + 1) MOD LinesInPage;
 END {MakeNextLine};

 PRIVATE PROCEDURE CheckSingleXCalcDtl(_Date: DATE);
 BEGIN
  CONFORM(FirmAcnt, Firm);
  L_General.Assert(SEARCH(XCalcDtl, XObject, mfBnkAcn.XObject, _Date, L_kn.Get(_Date, L_AcCut.erkn_SettlementAccounts)),
                   L_XObj.GetXObjectOriginName() + ":|" +
                   " 室 ᠫ줮   믨᮪   " + L_DatTim.DateStr(_Date) +
                   L_StdFrm.HR() +
                   "室 믮 楤 㧪 믨᮪  ");
  L_General.Assert(XCalcDtl.Correct,
                   L_XObj.GetXObjectOriginName() + ":|" +
                   "⮢୮ ᠫ줮  " + L_DatTim.DateStr(_Date));
 END {CheckSingleXCalcDtl};

 PRIVATE PROCEDURE OpenReport(RepName: STRING[]);
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  SetPrintAttr(R, RightMargin,     0,
                  MinCharsPerLine, RepWidth * LineSpacCoef,
                  SpreadChrInLine, RepWidth);
 END {OpenReport};

 PRIVATE PROCEDURE Conv(Value: NUMERIC[2]): STRING[];
 BEGIN
  IF Value = 0 THEN
   RETURN "";
  ELSE
   RETURN FLDTOSTR(Value, ",2-");
  END;
 END {Conv};

 PRIVATE PROCEDURE CheckXCalcDtl(ChkDate: DATE; MakeRep: SCAL[2]; VAR HasError: SCAL[2]);
  VAR
   Mismatch: STRING[];
 BEGIN
  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF MyFirm.MyFirm # P_Firm.mf_Fict THEN
    SELECT(FirmAcnt, Firm, , MyFirm.Firm);
    WHILE OCCURE(FirmAcnt) DO
     IF (FirmAcnt.FirmAcnt # P_Firm.fa_CashOffice) &
        (FirmAcnt.Type     # P_Firm.fat_Deposit) &
        (L_PDoc.CB_GetClientBank(ChkDate, MyFirm.MyFirm) # 0) THEN
      L_XObj.AccessXObject(L_PDoc.GetGlobalXObject(MyFirm.MyFirm, FirmAcnt.FirmAcnt));

      LOOP
       IF SELECT(XCalcDtl, XObject, XObject.XObject, ChkDate, L_kn.Get(ChkDate, L_AcCut.erkn_SettlementAccounts)) |
          L_DatTim.IsWorkDay(ChkDate) | (ChkDate = SYSDATE()) THEN
        EXIT;
       END;
       INC(ChkDate);
      END; (* LOOP *)

      IF L_DatTim.IsActive_Inc(ChkDate, FirmAcnt.Begin, FirmAcnt.Till) THEN
       PromptFA("", ChkDate);
       CheckSingleXCalcDtl(ChkDate);
       IF MakeRep THEN
        SEARCH(_InSaldo, MyFirm, , MyFirm.MyFirm, XObject.XObject, FirmAcnt.FirmAcnt, ChkDate);
        Mismatch:=Conv(_InSaldo.InSaldo-XCalcDtl.RSlSum);
        MAKEPART(R, e_XCalcDtlLine, ~!Mismatch, ChkDate, _InSaldo.InSaldo, XCalcDtl.RSlSum, Mismatch);
       ELSE
        ADD(_InSaldo, MyFirm, , MyFirm.MyFirm, XObject.XObject, FirmAcnt.FirmAcnt, ChkDate,
            _InSaldo.InSaldo, GetInSaldo(ChkDate, 0));
        IF XCalcDtl.RSlSum # _InSaldo.InSaldo THEN
         HasError:=1;
        END;
       END;
      END; (* IF L_DatTim.IsActive_Inc(ChkDate, FirmAcnt.Begin, FirmAcnt.Till) ...*)
     END; (* IF (FirmAcnt.FirmAcnt # P_Firm.fa_CashOffice) &... *)
     NEXT(FirmAcnt);
    END; (* WHILE OCCURE(FirmAcnt)... *)
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
 END {CheckXCalcDtl};

 PRIVATE PROCEDURE CheckPDoc(    trgDate    : DATE;
                                 trgMyFirm  : LIKE(MyFirm.MyFirm);
                                 trgFirmAcnt: LIKE(FirmAcnt.FirmAcnt);
                                 MakeRep    : SCAL[2];
                             VAR HasError   : SCAL[2]);
  VAR
   P: DATE;
 BEGIN
  APP.Get().NewPrompt(" ࠡ⠭  ஢ ");
  SELECT(PDoc, PDKStat);
  WHILE OCCURE(PDoc) DO
   NARROWSEL(PDoc, PDocKind);
   PROMPT(L_PDoc.PDocKindNick(PDoc.PDocKind, 1));
   IF L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Bank THEN
    WHILE OCCURE(PDoc) DO
     NARROWSEL(PDoc, Status);
     IF PDoc.Status # L_PDoc.st_Canceled THEN
      WHILE OCCURE(PDoc) DO
       NARROWSEL(PDoc, Done);
       IF (PDoc.Status = L_PDoc.st_Prepared) | ~PDoc.Done THEN
        SRCINSEL(PDoc, LT, , trgDate);
        WHILE OCCURE(PDoc) & (PDoc.Date < trgDate) & (MakeRep | ~HasError) DO
         Prompt(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc), PDoc.Date);
         IF (PDoc.MyFirm = trgMyFirm)    &
            (PDoc.Status # L_PDoc.st_Canceled) &
            AcceptablePDoc(trgFirmAcnt) THEN
          IF (PDoc.Status = L_PDoc.st_Prepared) | ~PDoc.Done THEN
           IF MakeRep THEN
            PrintSingleLine(trgDate);
           ELSE
            HasError:=1;
           END;
          END;
         END; (* IF (PDoc.MyFirm = trgMyFirm) &...*)
         NEXT(PDoc);
        END; (* WHILE OCCURE(PDoc) ... *)
       END; (* IF (PDoc.Status = L_PDoc.st_Prepared) | ~PDoc.Done...*)
       NEXTINEXTENDEDSEL(PDoc, Done);
      END; (* WHILE OCCURE(PDoc) ... *)
     END; (* IF PDoc.Status # L_PDoc.st_Canceled...*)
     NEXTINEXTENDEDSEL(PDoc, Status);
    END; (* WHILE OCCURE(PDoc) ... *)
   END; (* IF L_PDoc.MoneyKind(PDoc.PDocKind) = L_PDoc.mk_Bank...*)
   NEXTINEXTENDEDSEL(PDoc, PDocKind);
  END; (* WHILE OCCURE(PDoc) ... *)
 END {CheckPDoc};

 PRIVATE PROCEDURE HasProblemPDoc(chkDate: DATE; MakeRep: SCAL[2]): SCAL[2];
  VAR
   HasError: SCAL[2];
 BEGIN
  APP.Get().NewPrompt("ઠ 室 ᠫ줮  ᪨ ⠬   믨᪠  ");
  IF MakeRep THEN
   OpenReport("SOfA4");
   MAKEPART(R, e_XCalcDtlTop);
  END;

  HasError:=0;
  CheckXCalcDtl(chkDate  , MakeRep, HasError);
  CheckXCalcDtl(chkDate+1, MakeRep, HasError);

  IF MakeRep THEN
   MAKEPART(R, e_XCalcDtlBot);
   MAKEPART(R, e_PDTop);
   MAKEPART(R, SubTop);
  END;

  SELECT(_InSaldo, MyFirm);
  WHILE OCCURE(_InSaldo) & (MakeRep | ~HasError) DO
   NARROWSEL(_InSaldo, MyFirm, XObject, FirmAcnt);
   LAST(_InSaldo);
   CheckPDoc(_InSaldo.Date, _InSaldo.MyFirm, _InSaldo.FirmAcnt, MakeRep, HasError);
   NEXTINEXTENDEDSEL(_InSaldo, MyFirm, XObject, FirmAcnt);
  END; (* WHILE OCCURE(_InSaldo) ... *)

  IF MakeRep THEN
   MAKEPART(R, EndOfDayDlm);
   CLOSEREP(R);
   L_General.SurveyLastReport();
  END;
  RETURN HasError;
 END {HasProblemPDoc};

 PRIVATE PROCEDURE Check(chkDate: DATE);
  VAR
   Dummy: SCAL[2];
 BEGIN
  L_AFM.MakeMultipleIndex("_InSaldo", "MyFirm  : LIKE(MyFirm.MyFirm);"+
                                      "XObject : LIKE(XObject.XObject);"+
                                      "FirmAcnt: LIKE(FirmAcnt.FirmAcnt);"+
                                      "Date    : DATE;"+
                                      "InSaldo : NUMERIC[2]",
                          "MyFirm:MyFirm,XObject,FirmAcnt,Date");

  IF HasProblemPDoc(chkDate, 0) THEN
   Dummy:=HasProblemPDoc(chkDate, 1);
  END;
 END {Check};

 PRIVATE PROCEDURE StOfAc(Mode: tMode);
  VAR
   fr,
   ut,
   _Date  : DATE;
   curInc,
   curDec : NUMERIC[2];
   RepName: STRING[];
   InSaldo: NUMERIC[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;

  IF    Mode = m_CurDay THEN
   fr     :=Memo.ud_cd();
   ut     :=Memo.ud_cd();
   RepName:="SOfA1";
  ELSIF Mode = m_Period THEN
   fr     :=Memo.ud_fr();
   ut     :=Memo.ud_ut();
   RepName:="SOfA2";
  ELSIF Mode = m_PrvWrkDay THEN
   fr     :=L_DatTim.IncWorkDay(SYSDATE(), -1);
   ut     :=fr;
   RepName:="SOfA3";
   Check(fr);
  ELSE
   L_General.CallUs(0);
  END;

  L_AFM.MakeIndex("_PDCS", "_MyFirm  : LIKE(PDoc.MyFirm);"+
                           "_FirmAcnt: LIKE(FirmAcnt.FirmAcnt);"+
                           "_Date    : DATE;"+
                           "_Type    : SCAL[2];"+
                           "_Sum     : NUMERIC[2];"+
                           "_PDocKind: LIKE(PDoc.PDocKind);"+
                           "_PDoc    : LIKE(PDoc.PDoc)");
  _Date:=fr;
  WHILE _Date <= ut DO
   SELECT(PDoc, Date, , _Date);
   WHILE OCCURE(PDoc) DO
    Prompt("⮢  " + L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc), _Date);
    IF NeedPDoc(EMPTYOF(FirmAcnt.FirmAcnt)) THEN
     L_PDoc.CheckDone();
     _PDCS._MyFirm  :=PDoc.MyFirm;
     _PDCS._FirmAcnt:=PDoc.OwnAcnt;
     _PDCS._Date    :=_Date;
     _PDCS._Type    :=L_PDoc.IsOutPDoc(PDoc.PDocKind);
     _PDCS._Sum     :=PDoc.Total;
     _PDCS._PDocKind:=PDoc.PDocKind;
     _PDCS._PDoc    :=PDoc.PDoc;
     INSERT(_PDCS);
    END;
    NEXT(PDoc);
   END; (* WHILE OCCURE(PDoc) ... *)
   INC(_Date);
  END;

  OpenReport(RepName);

  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF MyFirm.MyFirm # P_Firm.mf_Fict THEN
    _Date:=fr;
    WHILE _Date <= ut DO
     SELECT(FirmAcnt, Firm, , MyFirm.Firm);
     WHILE OCCURE(FirmAcnt) DO
      PromptFA("", _Date);
      IF SELECT(_PDCS, _PDCS, MyFirm.MyFirm, FirmAcnt.FirmAcnt, _Date) THEN
       L_General.Assert(L_DatTim.IsActive(_Date, FirmAcnt.Begin, FirmAcnt.Till),
                        "   饬 ");
       L_XObj.AccessXObject(L_PDoc.GetGlobalXObject(MyFirm.MyFirm, FirmAcnt.FirmAcnt));
       FirstPage:=1;
       SETZERO(InSaldo, curInc, curDec, PagesInDate, CurLine);
       WHILE OCCURE(_PDCS) DO
        SEARCH(PDoc, PDoc, , _PDCS._PDocKind, _PDCS._PDoc);
        MakeNextLine(Mode, _Date, InSaldo, curInc, curDec);
        NEXT(_PDCS);
       END; (* WHILE OCCURE(_PDCS) ... *)
       MAKEPART(R, EndOfDay, _MoneyToStr(_Date, curInc),
                             _MoneyToStr(_Date, curDec),
                             _MoneyToStr(_Date, GetOutSaldo(_Date, InSaldo, curInc, curDec)));
       IF ~IsPrvWorkDayReport(Mode) THEN
        MAKEPART(R, EndOfDayDlm);
        FORMFEED(R);
       ELSE
        MAKEPART(R, pwd_EndOfDayDlm);
       END;
      END;
      NEXT(FirmAcnt);
     END; (* WHILE OCCURE(FirmAcnt)... *)
     INC(_Date);
    END; (* WHILE _Date <= ut ... *)
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {StOfAc};

 PUBLIC PROCEDURE StOfAc_ByCurDay();
 BEGIN
  StOfAc(m_CurDay);
 END {StOfAc_ByCurDay};

 PUBLIC PROCEDURE StOfAc_ByPeriod();
 BEGIN
  StOfAc(m_Period);
 END {StOfAc_ByPeriod};

 PUBLIC PROCEDURE StOfAc_ByPrvWrkDay();
 BEGIN
  StOfAc(m_PrvWrkDay);
 END {StOfAc_ByPrvWrkDay};

END.
