(*
%Copyright   (c) Polak Computer System
%Author      11.04.2002 15:21:12 LDA
%Purpose     ன ⥬ 㦥  MSOffice
%Type        operation
%Specific    SYS
%Modified    15.04.2014 10:57:28 POLAK\LDA
%Environment
*)

 MODULE SYS_ENV [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT FIO, DBD, L_General, Str, L_Str, L_MSO, L_MSWStp(* ஢ ࢥ ⮬⨧樨 ASB*),
        L_StdFrm, L_SpcEq, L_BarCode, SysLog, L_Basis, L_EMail,
        L_APEMl, P_OwnData, L_SES, L_Guard, L_DatTim, L_FIO;

 PUBLIC PROCEDURE SetXLTTemplateUsingStage();
 BEGIN
  IF ~VAR_IMPL.Get(L_Basis.UsingStage).Initialized THEN
   L_Basis.UsingStage:=L_Basis.us_UserTemplate;
  END;
  IF STDFORM("뢠 MS Excel 蠡, ।⠢ ࠧࠡ稪:||" +
             "%38,2<쪮 ᢮ 蠡                   |, ।⠢ ࠧࠡ稪>O|||" +
             L_StdFrm.DrawButton("⠭", 12, "B") + "                 " +
             L_StdFrm.DrawButton("⬥", 8, "X"),
             ,
             INFORM,
             ,
             L_Basis.UsingStage) THEN
  END;
 END {SetXLTTemplateUsingStage};

 PUBLIC PROCEDURE MSWord_SetUp();
  VAR
   newUsingStage: SCAL[3];
   DotFolder,
   DotFullName  : STRING[];
 BEGIN
  L_General.SilentAdminOnly();
  IF VAR_IMPL.Get(L_MSO.UsingStage).Initialized THEN
   newUsingStage:=L_MSO.UsingStage;
  ELSE
   newUsingStage:=L_MSO.us_Using;
  END;
  STDFORM(L_StdFrm.sf_Choice("%#####################%||",
                             "%,3<|ࠡ⪠ 蠡|㡫 蠡>O"),
          " ࠡ  MS Word",
          ,
          ,
          newUsingStage);

  IF newUsingStage = L_MSO.us_Publication THEN
   IF ~APP.Get().ProductiveCopy THEN
    DotFolder:=L_MSO.TMP_LIBFolder;
   ELSE
    DotFolder:=L_MSO.BY_USERFolder;
   END;
   DotFullName:=FIO.ChooseFile(FIO.BuildPath("*.dot", , DotFolder));
   IF ~!DotFullName THEN
    L_MSO.UsingStage:=L_MSO.us_Using;
    L_MSO.wordInitDocument(SYSDATE());
    L_MSO.UsingStage:=L_MSO.us_Publication;
    L_MSO.MakeWordDocument(DotFullName, 1, L_MSO.PrpMode_ToDoc, "");
    newUsingStage:=L_MSO.us_Using;
    L_StdFrm.Inform(" " + DotFullName + "||⮢  㡫樨");
   END;
  END;
  L_MSO.UsingStage:=newUsingStage;
 END {MSWord_SetUp};

 PUBLIC PROCEDURE MSExcel_SetUp();
 BEGIN
  L_MSWStp.MSExcel_SetUp();
 END {MSExcel_SetUp};

 PUBLIC PROCEDURE Fonts_SetUp();
 BEGIN
  L_MSWStp.Fonts_SetUp();
 END {Fonts_SetUp};

 PUBLIC PROCEDURE SpcEq_Setup();
 BEGIN
  L_SpcEq.Setup();
 END {SpcEq_Setup};

 PUBLIC PROCEDURE TestDaylightSavingTimeSwitch();
  VAR
   fileName: STRING[];
   pDTS,
   cDTS    : TIMESTAMP;
   tot,
   bad     : NUMERIC[0];
 BEGIN
  L_General.Assert(L_General.GetOSPlatform() >= L_General.osp_Win9x,
                   "஢ ᫥ ⮫쪮 Windows 9x  ");
  fileName:=FIO.FirstPath(L_General.NameConnection("_____") + ".rep");
  SETZERO(tot, bad);
  WHILE tot < 10 DO
   pDTS:=L_DatTim.GetSysTIMESTAMP();
   FIO.Open(F, fileName, , Create);
   FIO.Close(F);
   FIO.Open(F, fileName, , Output);
   FIO.SetFileTime(F, , , pDTS);
   FIO.Close(F);
   cDTS:=L_FIO.GetFileLastModifiedDTS(fileName);
   FIO.Erase(fileName);
   IF pDTS # cDTS THEN
    INC(bad);
   END;
   INC(tot);
  END; (* WHILE ... *)
  IF bad > 0  THEN
   L_General.Error("  䨣樨 ࠡ祩 ⠭樨  ஡  ६." +
                   "|" + L_Str.IntStr(bad) + " 㤠 ⮪  " + L_Str.IntStr(tot) +
                   "|" + "    設 ");
  ELSE
   L_StdFrm.Inform("  ६  浪");
  END;
 END {TestDaylightSavingTimeSwitch};

 PUBLIC PROCEDURE ShowInstalledRenewals();
  CONST
   DefaultUpdTemplate = "*.upd";
  VAR
   updf_DTS      : TIMESTAMP;
   updf_Name,
   UpdPrefix,
   PathToUpdFiles: STRING[];
   fso           : OBJECT;
   Files         : ENUMERATOR;
 BEGIN
  SETEMPTY(updf_Name);
  fso           :=CreateOBJECT("Scripting.FileSystemObject");
  PathToUpdFiles:=FIO.MakePath("DEF", , FIO.AsbSpecialFolders("ClientProjectRoot"));
  Files         :=CreateENUMERATOR(fso.GetFolder(PathToUpdFiles).Files);
  WHILE ~Files.AtEnd() DO
   IF L_General.IsPolakSpecific() THEN
    UpdPrefix:="PL";
   ELSE
    UpdPrefix:=DBD.BaseName();
   END;
   IF Str.Match(Files.Item().Name, UpdPrefix + DefaultUpdTemplate) THEN
    updf_Name:=L_FIO.effp_FileName_woExt(Files.Item().Name);
    updf_DTS :=L_FIO.GetFileLastModifiedDTS(Files.Item().Path);
   END;
   Files.MoveNext();
  END; (* WHILE ~Files.AtEnd ... *)
  L_General.Assert(~!updf_Name, "  ᢥ  ⠭ ");
  L_StdFrm.Inform(" : " + Str.Align(updf_Name, 16, LEFT) + "|" +
                  "⠭: " + L_DatTim.TimestampStr(updf_DTS));
 END {ShowInstalledRenewals};

 PUBLIC PROCEDURE BarCodeScanner_SetMode();
  VAR
   React      : NUMERIC[0];
   curbcs_Mode: SCAL[2];
 BEGIN
  L_General.Assert(L_General.IsOurSite() | L_General.IsAdmin(),
                   "   稩  믮 ⮩ 樨");
  L_BarCode.InitializeMode();
  curbcs_Mode:=L_BarCode.bcs_Mode;
  React:=STDFORM(" ࠡ  ᪠஬ -:||" +
                 "%,2<ଠ|⫠>O|||" +
                 L_StdFrm.DrawButton("⠭", 12, "B") + " " +
                 L_StdFrm.DrawButton("⬥", 12, "X"),
                 ,
                 ,
                 1,
                 curbcs_Mode);
  IF curbcs_Mode # L_BarCode.bcs_Mode THEN
   IF ~APP.Get().ProductiveCopy |
      L_StdFrm.RedAlternative(" ⠭ " + L_Str.PoolItem("|", curbcs_Mode) + " ० ࠡ ᪠ -|" +
                              "ந  㤥 䨪஢  ⥬ ୠ|"+
                              "த?") THEN
    L_BarCode.bcs_Mode:=curbcs_Mode;
    IF APP.Get().ProductiveCopy THEN
     SysLog.Mark("BCS_Mode", L_Str.PoolItem("|", L_BarCode.bcs_Mode));
    END;
   END;
  END;
 END {BarCodeScanner_SetMode};

 PRIVATE PROCEDURE IsRobot(): SCAL[2];
 BEGIN
  RETURN L_General.IsEndUser() | L_Guard.IsGuardConnection(APP.Get().MyConnection);
 END {IsRobot};

 PUBLIC PROCEDURE SetSMTPAuthenticationData();
  CONST
   DialogWidth = 100;
  VAR
   From,
   Sender     : L_EMail.tContact;
   ReplyToType: SCAL[3];
   FormStr,
   OwnEMail,
   SMTPSrv,
   rttPool,
   encrPW,
   pw         : STRING[];
   Done,
   wAuthentication: SCAL[2];
 BEGIN
  L_General.Assert(RTI.Get().TryBlock.MSG_SUPPRESSION # MSG_SUPPRESSION_ALL,
                   "ॡ 믮 ன ⭮  ஭ ");
  From    :=L_APEMl.ToSupportOwnFirmContact();
  SMTPSrv :=P_OwnData.ODSMTPServer(SYSDATE());
  OwnEMail:=L_APEMl.CurUserEMail(~IsRobot());
  rttPool :=" ' ' (" + From + ")|" + "  (" + OwnEMail + ")| ";

  IF ~L_SES.GetValue(L_SES.sit_User, L_APEMl.sesvi_EMailReplyToType, ReplyToType) THEN
   ReplyToType:=0;
  END;

  FormStr:="|  %L" + L_Str.IntStr(DialogWidth-10) + L_Str.PoolItem("NI|I", IsRobot()) +
           "| : %L" + L_Str.IntStr(DialogWidth-10) + "NI" +
           "|ࢥ    %L" + L_Str.IntStr(DialogWidth-10) + "NI";

  wAuthentication:=P_OwnData.SMTPWithAuthentication(SYSDATE());
  pw:="";
  IF wAuthentication THEN
   IF L_SES.GetValue(L_SES.sit_WindowsProfile, L_APEMl.sesvi_SMTP_Password, encrPW) THEN
    TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     pw:=DECRYPTSTR(encrPW, CSECR_PKCU, CALG_3DES, 0, CALG_MD5, CSP_NAME_MS_STRONG, CSP_TYPE_RSA_FULL);
    EXCEPT
    ON Exc: Exc_RunTime DO
     IF (Exc.ErrorCode = L_General.ec_rt_IncorrectlyEncodedString) |
        (Exc.ErrorCode = L_General.ec_rt_CantDecodeString) THEN
      (* ஢뢠*)
      L_StdFrm.RedInform(" 㤠 ஢ ஫  ⭮  ஭ .||" +
                         "室  ஫   믮 ஢|" +
                         "ࠡᯮᮡ ࠢ EMail  ⮏");
      pw:="";
     ELSE
      RAISE();
     END;
    END; (* TRY *)
   END;
   FormStr:=FormStr +
            "||஫    %L" + L_Str.IntStr(DialogWidth-10) + "SI";
  ELSE
   FormStr:=FormStr +
            "||஫    %L" + L_Str.IntStr(DialogWidth-10) + "NI";
  END;
  FormStr:=FormStr + "|" +
           "|" + Str.Align("뢠  ⢥   ⢥:", DialogWidth, LEFT) +
           "|%L" + L_Str.IntStr(DialogWidth-4) + ",3AO|||";
  FormStr:=FormStr + "|%C32<஢  {}࠭>B    %C32<{}⬥>Z";
  Done:=0;
  REPEAT
   STDFORM(FormStr,
           " ன ⭮  ࠡ祩   ࠢ EMail ।⢠ ⮏ ", , ,
           OwnEMail, From, SMTPSrv, pw, rttPool, ReplyToType);
   L_SES.PutValueAtCurTrn(L_SES.sit_User, L_APEMl.sesvi_EMailReplyToType, ReplyToType);
   IF IsRobot() THEN
    L_SES.PutValueAtCurTrn(L_SES.sit_WindowsProfile, L_APEMl.sesvi_EMail, OwnEMail);
   END;
   L_General.CallUs(SEARCH(AcsObj, AcsObj, L_General.curUSER));
   IF ~!AcsObj.Man THEN
    CONFORM(AcsObj, Man);
    Sender:=L_EMail.AssembleContact(Man.Name, OwnEMail);
   ELSE
    Sender:=L_EMail.AssembleContact(AcsObj.FullName, OwnEMail);
   END;
   PROMPT("ࠢ塞 ⮢ 쬮...");
   TRY
    encrPW:=ENCRYPTSTR(pw, CSECR_PKCU, CALG_3DES, 0, CALG_MD5, CSP_NAME_MS_STRONG, CSP_TYPE_RSA_FULL);
    IF wAuthentication THEN
     L_SES.PutValueAtCurTrn(L_SES.sit_WindowsProfile, L_APEMl.sesvi_SMTP_Password, encrPW);
    END;
    L_APEMl.Send(Sender, From, Sender, L_EMail.EmptyContact(), L_EMail.EmptyContact(),
                 "", "", "஢ઠ ࠡᯮᮡ ࠢ EMail  ⮏");
    Done:=1;
   EXCEPT
   ON Exc: Exc_Raise DO
    L_StdFrm.RedInform(Exc.MsgOriginalText);
   END; (* TRY *)
  UNTIL Done;
 END {SetSMTPAuthenticationData};

BEGIN (* ஢ ࢥ ⮬⨧樨 ASB*)
END.
