(*
%Copyright   (c) Polak Computer System
%Author      06.08.2002 15:52:44 RSN
%Purpose      ⮢  /
%Type        report
%Specific    SYS
%Modified    19.04.2013 17:33:32 POLAK\MLB
%Environment
*)

 MODULE T0003 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, D_Slr, L_General, L_Basis, L_Str, FIO, L_PRoll, P_Firm, L_AcCut, L_Acnt, L_STx, L_bp, L_Staff;

 VAR
  byTSN,
  wMF  : SCAL[2];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㯯");
  L_Basis.wb_WrInQM(F, "㯯");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㯯  ६");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "㬬");
  L_Basis.wb_WrInQM(F, "६");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "ᮡ ");
  IF byTSN THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "筨");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "१");
   L_Basis.wb_WrInQM(F, "१");
   L_Basis.wb_WrInQM(F, "१");
   L_Basis.wb_WrInQM(F, "");
  ELSE
   L_Basis.wb_WrInQM(F, "१");
   L_Basis.wb_WrInQM(F, "१");
   L_Basis.wb_WrInQM(F, "१");
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "室  ।  ᪠");
  END;
  L_Basis.wb_WrInQM(F, " ਮ");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  IF wMF THEN
   CONFORM(Mn001, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  CONFORM(Mn001, MCList, MCGroup);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|", MCList.MCTyp));
  L_Basis.wb_WrScl(F, MCGroup.MCGroup);
  L_Basis.wb_WrStr(F, MCGroup.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+|", MCGroup.FOT));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("---||", MCList.TimeType));
  L_Basis.wb_WrScl(F, MCList.MCode);
  L_Basis.wb_WrStr(F, MCList.Name);
  L_Basis.wb_WrDat(F, Mn001.Period);
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  L_Basis.wb_WrScl(F, Officer.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  IF SEARCH(Shift, Shift, Mn001.Shift) THEN
   L_Basis.wb_WrScl(F, Shift.Shift);
   L_Basis.wb_WrStr(F, Shift.Name);
  ELSE
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "------");
  END;
  L_Basis.wb_WrScl(F, Mn001.Class);
  L_Basis.wb_WrNum(F, Mn001.DutyDgr, 2);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|||", Mn001.Citizen));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|", Mn001.ContDTyp));
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|||", Mn001.Contract));
  L_Basis.wb_WrNum(F, Mn001.Sum, 2);
  L_Basis.wb_WrNum(F, Mn001.Tim, 3);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|", Mn001.Sex));
  L_Basis.wb_WrScl(F, TimeKeep.Cash);
  L_Basis.wb_WrScl(F, Officer.Officer);
  L_Basis.wb_WrStr(F, L_Str.PoolItem(L_STx.SpcSTx_pool, L_STx.SpecificSTx(Officer.Sort, Officer.Officer, Memo.ud_fr(), Mn001.MyFirm)));
  IF byTSN THEN
   L_Basis.wb_WrScl(F, Staff.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_PRoll.src_Pool, Mn001.Source));
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", Mn001.Sign));
   L_AcCut.PositionOnAcCut(Mn001.AcCut);
   L_Basis.wb_WrScl(F, AcCut.AcCut);
   L_Basis.wb_WrStr(F, AcCut.Name);
   L_Basis.wb_WrStr(F, L_Acnt.GetAcCutSign(Mn001.Closed, AcCut.AcCut));
   L_Basis.wb_WrStr(F, L_Acnt.GetCAcntSign(Mn001.Closed, AcCut.AcCut));
  ELSE
   L_AcCut.PositionOnAcCut(Mn001.AcCut);
   L_Basis.wb_WrScl(F, AcCut.AcCut);
   L_Basis.wb_WrStr(F, AcCut.Name);
   L_Basis.wb_WrStr(F, L_Acnt.GetAcCutSign(Mn001.Closed, AcCut.AcCut));
   L_Basis.wb_WrStr(F, L_Acnt.GetCAcntSign(Mn001.Closed, AcCut.AcCut));
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", MCList.Index[0]>0));
  END;
  L_Basis.wb_WrDat(F, Mn001.WFPeriod);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE ConformByOfficer();
 BEGIN
  CONFORM(Mn001, Officer);
  CONFORM(Officer, TimeKeep, Cash);
  CONFORM(Officer, Sort);
  CONFORM(Officer, Post);
  CONFORM(Officer, Union);
 END {ConformByOfficer};

 PRIVATE PROCEDURE T0003_Family(RepName: STRING[]; trg_byTSN: SCAL[2]);
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  byTSN:=trg_byTSN;
  D_Slr.extPrepare_Mn001(Memo.ud_fr(), Memo.ud_ut(), byTSN, 0, 0, 0);
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  MakeHeader("R");
  IF byTSN THEN
   SELECT(Mn001, TSN);
   WHILE OCCURE(Mn001) DO
    ConformByOfficer();
    CONFORM(Mn001, Man);
    NARROWSEL(Mn001, TSN, ODate);
    WHILE OCCURE(Mn001) DO
     PROMPT(": " + Mn001.TSN);
     MakePart("R");
     NEXT(Mn001);
    END; (* WHILE OCCURE(Mn001) ... *)
    NEXTINEXTENDEDSEL(Mn001, TSN, ODate);
   END; (* WHILE OCCURE(Mn001) ... *)
  ELSE
   SELECT(Mn001, Officer);
   WHILE OCCURE(Mn001) DO
    ConformByOfficer();
    NARROWSEL(Mn001, Sort, Officer);
    WHILE OCCURE(Mn001) DO
     PROMPT(": c " + Mn001.Sort + " / " + Mn001.Officer + "  / " + Mn001.MCode);
     MakePart("R");
     NEXT(Mn001);
    END; (* WHILE OCCURE(Mn001) ... *)
    NEXTINEXTENDEDSEL(Mn001, Sort, Officer);
   END; (* WHILE OCCURE(Mn001) ... *)
  END;
  FIO.Close(R);
 END {T0003_Family};

 PUBLIC PROCEDURE T0003();
  CONST
   bpId = "T0003";
 BEGIN
  L_bp.Begin(bpId, " ⮢  ௫", L_bp.t_Basis, L_General.tc_inIntvl);
  T0003_Family(bpId, 0);
  L_bp.End();
 END {T0003};

 PUBLIC PROCEDURE T0093();
  CONST
   bpId = "T0093";
 BEGIN
  L_bp.Begin(bpId, " ࠡ⭮   ࠡ⭨", L_bp.t_Basis, L_General.tc_inIntvl);
  T0003_Family(bpId, 1);
  L_bp.End();
 END {T0093};

END.
