(*
%Copyright   (c) Polak Computer System
%Author      16.08.2002 15:52:26 RSN
%Purpose       
%Type        report
%Specific    SYS
%Modified    22.08.2014 17:31:47 POLAK\Gina
%Environment
*)

 MODULE T0005 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, D_Slr, L_Basis, L_AFM, L_PRoll, L_Staff, L_Man, P_Firm,
        FIO, Math, L_STx, L_bp, L_Sheet, L_Str, Memo;

 VAR
  byTSN: SCAL[2];
  wMF  : SCAL[2];
  BPer,
  EPer : DATE;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ࠡ");
  L_Basis.wb_WrInQM(F, " ࠡ");
  L_Basis.wb_WrInQM(F, " 宧");
  L_Basis.wb_WrInQM(F, "ந");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "襭 ।ᯨ筮 ( )");
  L_Basis.wb_WrInQM(F, "ᮢ");
  L_Basis.wb_WrInQM(F, "ଠ ६()");
  L_Basis.wb_WrInQM(F, "४ ");
  L_Basis.wb_WrInQM(F, "ࠡ⠭");
  L_Basis.wb_WrInQM(F, "ࠡ⪠");
  L_Basis.wb_WrInQM(F, "ࠡ⪠");
  L_Basis.wb_WrInQM(F, "ࠪ");
  L_Basis.wb_WrInQM(F, "।");
  L_Basis.wb_WrInQM(F, "᫥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "᫥___ࠬ");
  L_Basis.wb_WrInQM(F, "ᮡ ");
  L_Basis.wb_WrInQM(F, "騪");
  L_Basis.wb_WrInQM(F, "騪");
  IF byTSN THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[];
                            _JMode      : LIKE(JMode.JMode);
                            _JModeName  : LIKE(JMode.Name);
                            _JModeInFirm: LIKE(JMode.InFirm);
                            _JModeType  : LIKE(JMode.Type);
                            _Days,
                            _AveCntDec  : NUMERIC[3];
                            _Hours,
                            _FullBal,
                            _CorrBal,
                            _TimDone,
                            _OverTime,
                            _UnderTim   : L_PRoll.tTime;
                            _AveCnt     : NUMERIC[3];
                            _InState,
                            _AmntCntr   : NUMERIC[0]);
 BEGIN
  IF wMF THEN
   CONFORM(SL002, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrStr(F, FLDTOSTR(SL002.Citizen, L_Man.ctz_Pool));
  L_Basis.wb_WrStr(F, FLDTOSTR(SL002.Sex, "|"));
  IF ~!_JMode THEN
   L_Basis.wb_WrScl(F, _JMode);
   L_Basis.wb_WrStr(F, _JModeName);
   L_Basis.wb_WrStr(F, FLDTOSTR(_JModeInFirm, "-|+"));
   L_Basis.wb_WrStr(F, FLDTOSTR(_JModeType=L_Sheet.jmType_TimDone, "-|+"));
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Sheet.jmType_Pool, _JModeType));
  ELSE
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "--------------");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "-");
   L_Basis.wb_WrStr(F, "--------------");
  END;
  L_Basis.wb_WrNum(F, _Days, 0);
  L_Basis.wb_WrNum(F, _AveCntDec, 3);
  L_Basis.wb_WrNum(F, _Hours, 3);
  L_Basis.wb_WrNum(F, _FullBal, 3);
  L_Basis.wb_WrNum(F, _CorrBal, 3);
  L_Basis.wb_WrNum(F, _TimDone, 3);
  L_Basis.wb_WrNum(F, _OverTime, 3);
  L_Basis.wb_WrNum(F, _UnderTim, 3);
  L_Basis.wb_WrStr(F, FLDTOSTR(SL002.Contract, L_Staff.cnt_Pool));
  L_Basis.wb_WrNum(F, _AveCnt, 3);
  L_Basis.wb_WrNum(F, _InState, 0);
  L_Basis.wb_WrNum(F, SL002.DutyDgr, 3);
  L_Basis.wb_WrScl(F, Post.Post);
  L_Basis.wb_WrStr(F, Post.Name);
  L_Basis.wb_WrScl(F, L_Staff.getService());
  L_Basis.wb_WrStr(F, L_Staff.getServiceName());
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  IF SEARCH(Shift, Shift, SL002.Shift) THEN
   L_Basis.wb_WrScl(F, Shift.Shift);
   L_Basis.wb_WrStr(F, Shift.Name);
  ELSE
   L_Basis.wb_WrStr(F, "--");
   L_Basis.wb_WrStr(F, "------");
  END;
  L_Basis.wb_WrNum(F, _AmntCntr, 0);
  L_Basis.wb_WrStr(F, FLDTOSTR(SL002.SpecSTx, L_STx.SpcSTx_pool));
  L_Basis.wb_WrInQM(F, TimeKeep.TimeKeep);
  L_Basis.wb_WrInQM(F, TimeKeep.Name);
  IF byTSN THEN
   L_Basis.wb_WrScl(F, Staff.TSN);
   L_Basis.wb_WrStr(F, Man.Name);
  END;
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE Create_SL002();
 BEGIN
  CreateFILE(SL002, "", "ࠡ⠭ ६", "");

  CreateFIELD(SL002, MyFirm,   P_Firm.tMyFirm,       "", "", "", "'' ࣠", "");
  CreateFIELD(SL002, Sort,     LIKE(Sort.Sort),      "", "", "", "", "");
  CreateFIELD(SL002, Officer,  LIKE(Officer.Officer),"", "", "", " ", "");
  CreateFIELD(SL002, Contract, LIKE(Staff.Contract), "", "", "", "ࠪ", "");
  CreateFIELD(SL002, Citizen,  SCAL[4],              "", "", "", "ࠦ⢮", "");
  CreateFIELD(SL002, Sex,      LIKE(Man.Sex),        "", "", "", "", "");
  CreateFIELD(SL002, DutyDgr,  LIKE(StaffLog.DutyDgr), "", "", "", "⥯  - ⭠  / ( <1 -  )", "");
  CreateFIELD(SL002, Shift,    LIKE(Shift.Shift),    "", "", "", "", "");
  CreateFIELD(SL002, SpecSTx,  L_STx.tSpecificSTx,   "", "", "", "ᮡ ", "");
  CreateFIELD(SL002, FullBal,  L_PRoll.tTime,        "", "", "", "  ࠡ祣 ६", "");
  CreateFIELD(SL002, CorrBal,  L_PRoll.tTime,        "", "", "", "४஢  ࠡ祣 ६", "");
  CreateFIELD(SL002, TimDone,  L_PRoll.tTime,        "", "", "", "ࠡ⠭ ᮢ", "");
  CreateFIELD(SL002, InState,  NUMERIC[0],           "", "", "", "᫥   ਮ   ", "");
  CreateFIELD(SL002, AmntCntr, NUMERIC[0],           "", "", "", "᫥  ࠬ", "");
  CreateFIELD(SL002, OverTime, L_PRoll.tTime,        "", "", "", "ࠡ⪠", "");
  CreateFIELD(SL002, UnderTim, L_PRoll.tTime,        "", "", "", "ࠡ⪠", "");
  CreateFIELD(SL002, DaysInF,  NUMERIC[3],           "", "", "", "  宧", "");
  CreateFIELD(SL002, xDays,    NUMERIC[3],           "", "", "", "ࠡ⠭ ", "");

  IF byTSN THEN
   CreateFIELD(SL002, TSN, LIKE(Staff.TSN), "", "", "", "", "");
   CreateINDEXandLINK(SL002, TSN, UNIQUE, Staff, TSN, USER, "", "",  TSN, Sort, Officer, Contract, Citizen, Sex, DutyDgr, Shift, MyFirm, SpecSTx);
   CreateINDEXandLINK(SL002, Officer, PLURAL, Officer, Officer, USER, "", "", Sort, Officer);
  ELSE
   CreateINDEXandLINK(SL002, Officer, UNIQUE, Officer, Officer, USER, "", "", Sort, Officer, Contract, Citizen, Sex, DutyDgr, Shift, MyFirm, SpecSTx);
  END;

  CreateINDEXandLINK(SL002, Sort,  PLURAL, Sort,  Sort,  USER, "", "", Sort);
  CreateINDEXandLINK(SL002, MyFirm, PLURAL, MyFirm,  MyFirm,   USER, "", "", MyFirm);

  SetVersionOfFILE(SL002, 2);
 END {Create_SL002};

 PRIVATE PROCEDURE Create_SH002();
 BEGIN
  CreateFILE(SH002, "", "६   ࠡ", "");

  CreateFIELD(SH002, MyFirm,   P_Firm.tMyFirm,         "", "", "", "'' ࣠", "");
  CreateFIELD(SH002, Sort,     LIKE(Sort.Sort),        "", "", "", "", "");
  CreateFIELD(SH002, Officer,  LIKE(Officer.Officer),  "", "", "", " ", "");
  CreateFIELD(SH002, Contract, LIKE(Staff.Contract),   "", "", "", "ࠪ", "");
  CreateFIELD(SH002, Citizen,  SCAL[4],                "", "", "", "ࠦ⢮", "");
  CreateFIELD(SH002, Sex,      LIKE(Man.Sex),          "", "", "", "", "");
  CreateFIELD(SH002, DutyDgr,  LIKE(StaffLog.DutyDgr), "", "", "", "⥯  - ⭠  / ( <1 -  )", "");
  CreateFIELD(SH002, Shift,    LIKE(Shift.Shift),      "", "", "", "", "");
  CreateFIELD(SH002, SpecSTx,  L_STx.tSpecificSTx,     "", "", "", "ᮡ ", "");
  CreateFIELD(SH002, JMode,    LIKE(JMode.JMode),      "", "", "", " ࠡ", "");
  CreateFIELD(SH002, Hours,    L_PRoll.tTime,          "", "", "", "ࠡ⠭ ᮢ", "");
  CreateFIELD(SH002, Days,     NUMERIC[3],             "", "", "", "ࠡ⠭ ", "");

  IF byTSN THEN
   CreateFIELD(SH002, TSN,    LIKE(Staff.TSN), "", "", "", "", "");
   CreateINDEXandLINK(SH002, TSN, UNIQUE, SL002, TSN, BORROW, "", "",  TSN, Sort, Officer, Contract, Citizen, Sex, DutyDgr, Shift, MyFirm, SpecSTx, JMode);
  ELSE
   CreateINDEXandLINK(SH002, Officer, UNIQUE, SL002, Officer, BORROW, "", "",  Sort, Officer, Contract, Citizen, Sex, DutyDgr, Shift, MyFirm, SpecSTx, JMode);
  END;
  CreateINDEXandLINK(SH002, JMode, PLURAL, JMode, JMode, USER, "", "", JMode);

  SetVersionOfFILE(SH002, 2);
 END {Create_SH002};

 VAR
  glbIndexValStr: STRING[];
  glbShift      : LIKE(Shift.Shift);
  glbSpecSTx    : L_STx.tSpecificSTx;

 PRIVATE PROCEDURE AddSH002();
 BEGIN
  ADD(SH002, ^(glbIndexValStr+", Sh001.JMode"),
             SH002.Hours, Sh001.Hours,
             SH002.Days,  Sh001.Days);
 END {AddSH002};

 PRIVATE PROCEDURE PrepareIndex();
  VAR
   curDaysInFirm,
   curDaysFullDuty: NUMERIC[3];
 BEGIN
  IF byTSN THEN
   glbIndexValStr:="TSN, , SL001.TSN, SL001.Sort, SL001.Officer, Staff.Contract, SL001.Citizen, Man.Sex, SL001.DutyDgr, glbShift, SL001.MyFirm, glbSpecSTx";
  ELSE
   glbIndexValStr:="Officer, , SL001.Sort, SL001.Officer, Staff.Contract, SL001.Citizen, Man.Sex, SL001.DutyDgr, glbShift, SL001.MyFirm, glbSpecSTx";
  END;
  SETSEL(SL001, TSN);
  FOR_EACH SL001 DO
   PROMPT(" " + SL001.TSN);
   CONFORM(SL001, Staff);
   CONFORM(Staff, Man);
   L_General.Assert(SEARCH(StaffLog, TSN, SL001.TSN, SL001.ODate),
                    ' ६ ⮢ 䠩 "ࠡ⠭ ६ ࠡ⭨"' +
                    '|ᥭ   ६饭 ࠡ⭨.' +
                    '|| ⮢  䠩 .');
   IF SEARCH(OfcShift, Officer, StaffLog.Sort, StaffLog.Officer, StaffLog.Regime) THEN
    glbShift:=OfcShift.Shift;
   ELSE
    SETEMPTY(glbShift);
   END;
   glbSpecSTx:=L_STx.SpecificSTx(StaffLog.Sort, StaffLog.Officer, BPer, Staff.MyFirm);

   D_Slr.GetFromSh001(curDaysInFirm, curDaysFullDuty, PROCREF(AddSH002));
   ADD(SL002, ^glbIndexValStr,
              SL002.FullBal, SL001.FullBal,
              SL002.CorrBal, SL001.CorrBal,
              SL002.TimDone, SL001.TimDone,
              SL002.InState, SL001._InState,
              SL002.AmntCntr, SL001.IsMain,
              SL002.OverTime, Math.Max(0, SL001.TimDone - SL001.CorrBal),
              SL002.UnderTim, Math.Max(0, SL001.CorrBal - SL001.TimDone),
              SL002.DaysInF,  curDaysInFirm,
              SL002.xDays,    curDaysFullDuty);
  END; (* FOR_EACH SL001 *)
 END {PrepareIndex};

 PRIVATE PROCEDURE Make(bpId: STRING[]);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  BPer:=Memo.ud_fr();
  EPer:=Memo.ud_ut();
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());

  D_Slr.Prepare_SL001(BPer, EPer);
 
  Create_SL002(); L_AFM.AF_CreateTemp("SL002", "SL002");
  Create_SH002(); L_AFM.AF_CreateTemp("SH002", "SH002");
  PrepareIndex();
 
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
 
  IF byTSN THEN
   SETSEL(SL002, TSN);
  ELSE
   SETSEL(SL002, Officer);
  END;
  FOR_EACH SL002 DO
   IF byTSN THEN
    PROMPT(": " + SL002.TSN);
   ELSE
    PROMPT(": ᥪ " + SL002.Sort + ",  " + SL002.Officer);
   END;
   CONFORM(SL002,  Sort);
   CONFORM(SL002,  Officer);
   CONFORM(Officer, Union);
   CONFORM(Officer, Post);
   CONFORM(Officer, TimeKeep);
   IF byTSN THEN
    CONFORM(SL002, Staff);
    CONFORM(Staff, Man);
   END;
   MakePart("R", "", "","","", 0, SL002.xDays/(EPer-BPer+1),
                      0, SL002.FullBal, SL002.CorrBal, SL002.TimDone,
                      SL002.OverTime, SL002.UnderTim,
                      SL002.DaysInF/(EPer-BPer+1), SL002.InState,
                      SL002.AmntCntr);
   CONFORM(SL002, SH002);
   FOR_EACH SH002 DO
    CONFORM(SH002, JMode);
    MakePart("R", SH002.JMode, JMode.Name, JMode.InFirm, JMode.Type,
                  SH002.Days, 0, SH002.Hours, 0, 0, 0, 0, 0, 0, 0, 0);
   END; (* FOR_EACH SH002 *)
  END; (* FOR_EACH SL002 *)

  FIO.Close(R);
 END {Make};

 PUBLIC PROCEDURE T0005();
  CONST
   bpId = "T0005";
 BEGIN
  byTSN:=0;
  L_bp.Begin(bpId, "  ", L_bp.t_Basis, L_General.tc_inIntvl);
  Make(bpId);
  L_bp.End();
 END {T0005};

 PUBLIC PROCEDURE T0095();
  CONST
   bpId = "T0095";
 BEGIN
  byTSN:=1;
  L_bp.Begin(bpId, "    ࠡ⭨", L_bp.t_Basis, L_General.tc_inIntvl);
  Make(bpId);
  L_bp.End();
 END {T0095};

END.
