(*
%Copyright   (c) Polak Computer System
%Author      05.09.2001 20:51:52 BOR
%Purpose     ⭮ ᯨᠭ: ⠭  ᥣ
%Type        report
%Specific    SYS
%Modified    18.09.2014 15:44:24 POLAK\Gina
%Environment
*)

 MODULE T0300 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Basis, L_Man, L_Staff, D_Staff, P_Officer, P_Firm, FIO, L_Str, Memo, L_bp, L_PRoll;

 PRIVATE VAR
  wMF         : SCAL[2];
  _Salary     : NUMERIC[3][P_Officer.ClassAmount];
  _Troubles   : SCAL[2][P_Officer.ClassAmount];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
  VAR
   obCnt: SCAL[P_Officer.ob_Amount];
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "㦡");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "।");
  L_Basis.wb_WrInQM(F, "।");
  L_Basis.wb_WrInQM(F, "।");
  L_Basis.wb_WrInQM(F, "ࠢ᭮");
  L_Basis.wb_WrInQM(F, "⠭");
  L_Basis.wb_WrInQM(F, "।᪮");
  L_Basis.wb_WrInQM(F, "।᪮");
  L_Basis.wb_WrInQM(F, "ᮡ⨊");
  L_Basis.wb_WrInQM(F, "ᮡ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ਬ砭");
  L_Basis.wb_WrInQM(F, "䨪  ਪ  /");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "筨");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "ᮭ");
  L_Basis.wb_WrInQM(F, "ਠ쭠 ⢥⢥");
  L_Basis.wb_WrInQM(F, "  ।");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "  ᮭ ");
  L_Basis.wb_WrInQM(F, "  । ᫮");
  L_Basis.wb_WrInQM(F, "㬥  樨");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "?");
L_Basis.wb_WrInQM(F, "");
  FOR_EACH obCnt DO
   IF ~!P_Officer.E_OfficerBonusName(obCnt) THEN
    L_Basis.wb_WrInQM(F, "६ "+P_Officer.E_OfficerBonusName(obCnt));
   END;
  END;
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE GetProSoft(_Property: LIKE(Property.Property)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF _Property = P_Officer.P_CertificatLbrCond THEN
   IF P_Officer.HasActualPro_Normal(Officer.Sort, Officer.Officer, Memo.ud_cd(), _Property) THEN
    Result:=OfcPro.DocNum;
   ELSE
    SETEMPTY(Result);
   END;
  ELSE
   Result:=P_Officer.GetProValueSoft(Officer.Sort, Officer.Officer, Memo.ud_cd(), _Property);
  END;
  IF !Result THEN
   Result:="-";
  END;
  RETURN Result;
 END {GetProSoft};

 PRIVATE PROCEDURE MakePart(F          : STRING[];
                            trgClass   : LIKE(StaffLog.Class);
                            trgDutyDgr : LIKE(StaffLog.DutyDgr);
                            trgVac     : NUMERIC[2];
                            PersonalPay: NUMERIC[2]);
  VAR
   obCnt: SCAL[P_Officer.ob_Amount];
 BEGIN
  IF (trgDutyDgr # 0) | (trgVac # 0) THEN
   IF wMF THEN
    CONFORM(Sort, MyFirm);
    L_Basis.wb_WrScl(F, MyFirm.MyFirm);
    L_Basis.wb_WrStr(F, MyFirm.vzSign);
   END;
   L_Staff.StandOnShiftByShiftNum(Ofc01.Sort, Ofc01.Officer, Ofc01.ShiftNum);
   L_Basis.wb_WrScl(F, L_Staff.getService());
   L_Basis.wb_WrStr(F, L_Staff.getServiceName());
   L_Basis.wb_WrScl(F, L_Staff.getDepart());
   L_Basis.wb_WrStr(F, L_Staff.getDepartName());
   L_Basis.wb_WrScl(F, Sort.Sort);
   L_Basis.wb_WrStr(F, Sort.Name);
   L_Basis.wb_WrScl(F, Officer.Officer);
   L_Basis.wb_WrScl(F, Post.Post);
   L_Basis.wb_WrStr(F, Post.Name);
   IF ~!Post.OKPDTR THEN
    L_Basis.wb_WrScl(F, OKPDTR.OKPDTR);
    L_Basis.wb_WrStr(F, OKPDTR.Name);
   ELSE
    L_Basis.wb_WrScl(F, "-");
    L_Basis.wb_WrStr(F, "-");
   END;
   L_Basis.wb_WrScl(F, WagePay.WagePay);
   L_Basis.wb_WrStr(F, WagePay.Name);
   IF trgClass # 0 THEN
    L_Basis.wb_WrNum(F, WagePayL.Pay[trgClass], 2);
    L_Basis.wb_WrScl(F, trgClass);
   ELSE
    IF OCCURE(Stl01) THEN
     L_Basis.wb_WrNum(F, WagePayL.Pay[Stl01.Class], 2);
    ELSE
     L_Basis.wb_WrNum(F, WagePayL.Pay[1], 2);
    END;
    L_Basis.wb_WrScl(F, "-");
   END;
   L_Basis.wb_WrScl(F, Union.Union);
   L_Basis.wb_WrStr(F, Union.Name);
   L_Basis.wb_WrScl(F, PayKind.PayKind);
   L_Basis.wb_WrScl(F, PayKind.Name);
   L_Basis.wb_WrScl(F, DirtyTyp.DirtyTyp);
   L_Basis.wb_WrStr(F, DirtyTyp.Name);
   L_Basis.wb_WrStr(F, L_Staff.GetDirtyTypPower_asStr());
   L_Basis.wb_WrStr(F, L_Staff.GetDirtyTypInjPower_asStr());
   L_Basis.wb_WrStr(F, DirtyTyp.Nutrition);
   L_Basis.wb_WrScl(F, AlType.AlType);
   L_Basis.wb_WrStr(F, AlType.Name);
   L_Basis.wb_WrScl(F, PnsAttr.PnsAttr);
   L_Basis.wb_WrStr(F, PnsAttr.Name);
   L_Basis.wb_WrScl(F, Shift.Shift);
   L_Basis.wb_WrStr(F, Shift.Name);
   L_Basis.wb_WrScl(F, Shift.Number);
   L_Basis.wb_WrStr(F, FLDTOSTR(Officer.Real, "-|+"));
   L_Basis.wb_WrStr(F, Officer.Comment);
   IF OCCURE(Stl01) THEN
    L_Basis.wb_WrScl(F, Stl01.Class);
    L_Basis.wb_WrScl(F, Stl01.TSN);
    L_Basis.wb_WrStr(F, Man.Name);
    L_General.CallUs(SEARCH(RegMain, HumReg, Stl01.Regime));
    L_Basis.wb_WrStr(F, Stl01.Regime);
    L_Basis.wb_WrStr(F, RegMain.Name);
    L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Staff.cnt_Pool, Staff.Contract));
    L_Basis.wb_WrStr(F, L_Man.CitizenAsStr(Man.Man, Memo.ud_cd()));
    L_Basis.wb_WrDat(F, Stl01.OBegDate);
    L_Basis.wb_WrDat(F, Stl01.OEndDate);
    L_Basis.wb_WrStr(F, L_Str.PoolItem("|||", Stl01.Source));
   ELSE
    L_Basis.wb_WrScl(F, "-");
    L_Basis.wb_WrScl(F, "-");
    L_Basis.wb_WrScl(F, "-");
    L_Basis.wb_WrScl(F, "-");
    L_Basis.wb_WrScl(F, "-");
    L_Basis.wb_WrScl(F, "-");
    L_Basis.wb_WrScl(F, "-");
    L_Basis.wb_WrScl(F, "-");
    L_Basis.wb_WrScl(F, "-");
    L_Basis.wb_WrStr(F, "");
   END;
   L_Basis.wb_WrNum(F, _Salary[trgClass], 3);
   L_Basis.wb_WrNum(F, PersonalPay, 2);
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", Officer.IsMResp));
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", Officer.RspMoney));
   L_Basis.wb_WrStr(F, L_Str.PoolItem(L_Staff.rspma_pool, Officer.RspMAsst));
   L_Basis.wb_WrStr(F, GetProSoft(P_Officer.P_PersonalInfAccess));
   L_Basis.wb_WrStr(F, GetProSoft(P_Officer.P_OfcHarm));
   L_Basis.wb_WrStr(F, GetProSoft(P_Officer.P_CertificatLbrCond));
   L_Basis.wb_WrNum(F, trgDutyDgr, 3);
   L_Basis.wb_WrNum(F, trgVac, 2);
   L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", _Troubles[trgClass]));
IF OCCURE(Stl01) THEN
 L_Basis.wb_WrStr(F, Stl01.Regime);
ELSE
 L_Basis.wb_WrScl(F, "-");
END;
   FOR_EACH obCnt DO
    IF ~!P_Officer.E_OfficerBonusName(obCnt) THEN
     L_Basis.wb_WrNum(F, P_Officer.GetOfcBonus(obCnt, Memo.ud_cd()), 3);
    END;
   END;
   L_Basis.wb_TermLine(F);
  END;
 END {MakePart};

 PRIVATE PROCEDURE GetClassAsVcnByClass(VcnByClass: SCAL[2]; Class: LIKE(StaffLog.Class)): LIKE(StaffLog.Class);
 BEGIN
  IF VcnByClass THEN
   RETURN Stl01.Class;
  ELSE
   RETURN 0;
  END;
 END {GetClassAsVcnByClass};

 PUBLIC PROCEDURE T0300();
  CONST
   bpId="T0300";
  VAR
   i          : NUMERIC[0];
   VcnByClass : SCAL[2];
   TotDutyDgr : NUMERIC[3][P_Officer.ClassAmount];
   PersonalPay: NUMERIC[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.SetCacheables(["Man", "Staff", "StaffLog"]);
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  L_bp.Begin(bpId, "⠭", L_bp.t_Basis, L_General.tc_onDate);
  D_Staff.Prepare_Stl01(L_General.timeCond_OnDate, D_Staff.ofc_All, D_Staff.sld_wSheet);
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
  SELECT(Ofc01, Officer);
  WHILE OCCURE(Ofc01) DO
   CONFORM(Ofc01, Officer);
   PROMPT(Officer.Sort+" "+Officer.Officer);
   CONFORM(Officer, Post);
   CONFORM(Post,    OKPDTR);
   CONFORM(Officer, Sort);
   CONFORM(Officer, WagePay);
   CONFORM(Officer, Union);
   CONFORM(Officer, PayKind);
   SEARCH(DirtyTyp, DirtyTyp, , P_Officer.GetP_LCDirtyTyp(Officer.Sort, Officer.Officer, Memo.ud_cd()));
   CONFORM(Officer, AlType);
   CONFORM(Officer, PnsAttr);
   HISTCONF(Memo.ud_cd(), WagePay, WagePayL);
   L_PRoll.AccessWagePayL(Memo.ud_cd());
   SETZERO(TotDutyDgr);
   SELECT(Stl01, Officer, , Ofc01.Sort, Ofc01.Officer, Ofc01.ShiftNum);
   WHILE OCCURE(Stl01) DO
    INC(TotDutyDgr[Stl01.Class], Stl01.RealDD);
    INC(TotDutyDgr[0],           Stl01.RealDD);
    NEXT(Stl01);
   END; (* WHILE OCCURE(Stl01) ... *)

   SETZERO(PersonalPay);
   VcnByClass:=P_Officer.GetInfillMethodOfVacancy(Officer.Sort, Officer.Officer, Memo.ud_cd()) = P_Officer.vim_byClass;
   IF VcnByClass THEN
    i           :=1;
   ELSE
    i           :=0;
    _Troubles[i]:=Ofc01.Vacancy[i] # TotDutyDgr[i];
   END;
   WHILE i < P_Officer.ClassAmount DO
    _Salary[i]  :=P_Officer.GetEarningValue_ByOneClass(Officer.Sort, Officer.Officer, Memo.ud_cd(), i);
    IF VcnByClass THEN
     _Troubles[i]:=Ofc01.Vacancy[i] # TotDutyDgr[i];
    ELSE
     _Troubles[i]:=_Troubles[0];
    END;
    MakePart("R", i, 0, Ofc01.Vacancy[i], PersonalPay);
    INC(i);
   END;
   SELECT(Stl01, Officer, , Ofc01.Sort, Ofc01.Officer, Ofc01.ShiftNum);
   WHILE OCCURE(Stl01) DO
    PROMPT(Stl01.Sort+" "+Stl01.Officer);
    CONFORM(Stl01, Staff, Man);
    PersonalPay:=0;
    IF (Stl01.Source # D_Staff.ofcs_byEDO) & L_PRoll.E_UsePersMPay(Memo.ud_cd()) THEN
     SEARCH(StaffLog, TSN, , Stl01.TSN, Stl01.OBegDate);
     PersonalPay:=L_PRoll.GetPersAddValue(Memo.ud_cd());
    END;
    MakePart("R", GetClassAsVcnByClass(VcnByClass, Stl01.Class), Stl01.DutyDgr, 0, PersonalPay);
    NEXT(Stl01);
   END; (* WHILE OCCURE(Stl01) ... *)
   NEXT(Ofc01);
  END; (* WHILE OCCURE(Ofc01) ... *)
  D_Staff.Purge_Stl01();
  FIO.Close(R);
  L_bp.End();
 END {T0300};

END.
