(*
%Copyright   (c) Polak Computer System
%Author      11.09.1995 18:50:07 SAN
%Purpose      ਫ N3  室 
%Type        report
%Specific    SYS
%Modified    12.05.2014 13:25:49 POLAK\Gina
%Environment
*)

 MODULE T3_1998 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_OwnData, L_Tx2000, L_PRoll, L_Tax, L_Staff,
        L_Money, L_Russia, L_Str, L_AFM, L_Man, P_Staff, P_Firm,
        Str, Math, FIO, Memo, L_ctc;

 TYPE
  tMode        = SCAL[4];

 CONST
  mode_ToPaper         = 0; (*tMode*)
  mode_ByCurrentPacket = 1;
  mode_ForInq          = 2;
  mode_All             = 3;

 VAR
  CurP, CurPE: DATE;
  curMode    : tMode;

 PRIVATE PROCEDURE ToPaper(): SCAL[2];
 BEGIN
  RETURN curMode = mode_ToPaper;
 END {ToPaper};

 PRIVATE PROCEDURE AllMode(): SCAL[2];
 BEGIN
  RETURN curMode = mode_All;
 END {AllMode};

 PRIVATE PROCEDURE ManRgStrType(_RgStrTs : LIKE(ManAdr.StreetT)): STRING[6];
 BEGIN
  IF !_RgStrTs THEN RETURN ""; END;
  RETURN Str.Item(" |||||||-|||-|-|", "|", _RgStrTs);
 END {ManRgStrType};

 PRIVATE PROCEDURE ManRgPType(_RgPTs: LIKE(ManAdr.VillageT)): STRING[6];
 BEGIN
  IF !_RgPTs THEN RETURN ""; END;
  IF _RgPTs >= 20 THEN
   RETURN Str.Item("|/||||/|/||||||-||/||-|||||", "|", _RgPTs-20);
  ELSE
   RETURN Str.Item(" |/|/|/|||||/|/ ||-||||||||", "|", _RgPTs);
  END;
 END {ManRgPType};

 PRIVATE PROCEDURE DocNum(): STRING[];
 BEGIN
  RETURN FLDTOSTR(Man.Man, "", 6)+"/"+FLDTOSTR(SYSDATE(), "yND")+FLDTOSTR(SYSTIME(), "HM");
 END {DocNum};

 PRIVATE PROCEDURE GetFADR(): STRING[250];
  VAR
   S    : STRING[250];
 BEGIN
  SETEMPTY(S);
  IF L_ctc.StandOnAdr_Reg(CurPE, P_Firm.OWN_FIRM, 0) THEN
   S:="," + CtcAdr.Zip +
      "," + CtcAdr.Region +
      "," + CtcAdr.Distr +
      "," + CtcAdr.Town + " " +
      "," + CtcAdr.Village +
      "," + CtcAdr.Street +
      "," + CtcAdr.House +
      "," + CtcAdr.Block +
      "," + CtcAdr.Flat;
  END;
  RETURN Str.Cap(S);
 END {GetFADR};

 CONST
  NbrStrLen = 14;
  IncAm     = 08;
  DecAm     = 08;
  MaxAm     = Math.Max(IncAm, DecAm);
  MaxPacket = 50;
  _Firm     = 0000;
  VER = "  (C) POLAK COMPUTER SYSTEM";

 VAR
  NAM,
  INN,
  IDO             : STRING[];
  _Limits         : NUMERIC[2][12];
  _SovInc         : STRING[NbrStrLen][12];
  _VCode          : LIKE(TaxAdv.VCode)[MaxAm];
  _LCode          : LIKE(TaxAdv.LCode)[MaxAm];
  _AdvInc,
  _LimVal         : STRING[NbrStrLen][MaxAm];
  nAdvInc,
  nLimVal         : NUMERIC[2][MaxAm];
  ArrIdx          : NUMERIC[0];
  _CCode          : LIKE(ManAdr.Country);
  _Zip            : LIKE(ManAdr.Zip);
  _RCode          : LIKE(ManAdr.Region);
  _Distr          : LIKE(ManAdr.Distr);
  _PName1,
  _PName2         : STRING[32];
  _Street         : LIKE(ManAdr.Street);
  _House          : LIKE(ManAdr.House);
  _Block          : STRING[32];
  _Flat           : LIKE(ManAdr.Flat);
  _Value          : STRING[];
  Err             : STRING[100];
  IncToTrn        : STRING[250];
  TotValInc,
  TotPaidTax      : NUMERIC[2];
  Type3Result     : SCAL[3];

  FirstFieldInLine: SCAL[2];
  _Address        : STRING[250];

(*
$P{ Part1:
?, L, ""
CurP, L, "y"
DocNum(), L, ""
INN, L, ""
NAM, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, ""
Man.INN, L, ""
Man.Name, L, ""
?, L, ""
Man.PspSer, L, ""
Man.PspNbr, L, ""
Man.Birth, L, "D"
Man.Birth, L, "N"
Man.Birth, L, "y"
_CCode, L, ""
_Zip, L, ""
_RCode, L, ""
_Distr, L, ""
_PName1, L, ""
_PName2, L, ""
_Street, L, ""
_House, L, ""
_Block, L, ""
_Flat, L, ""
GetResidentStatus(), L, "2|1"
Staff.Contract, L, "1|2|2|2|2"
?, L, ""
@
                                                ਫ N 3  樨 㤠⢥  㦡   29.06.95 N 35
================================================================================================================================
|            |  #### |                    ࠢ  室 䨧᪮   ####            | N ####################|
|============|=================================================================================================================|
|     1      |1.1.  ############ |1.2.  ।, ࣠樨, ० / , , ⢮ 䨧.  |
|------------|-----------------------     #####################################################################################|
|  |1.3. ⠪ ⥫䮭     #####################################################################################|
|筨   |-----------------------------------------------------------------------------------------------------------------|
|믫     |1.4.       |  ######    ॣ ##    ########################################################|
|            |                | த ###################################### . 㭪 #######################################|
|            |                |  ##########################################  #####  #############  ##### |
|============|=================================================================================================================|
|     2      |2.1.  ############ |2.2.  #################################################################################|
|------------|-----------------------------------------------------------------------------------------------------------------|
|   |2.3.   㬥,      |      |2.4. ,  㬥      |2.5.          | ᫮ |  |   |
|⥫  |㤮⮢饣 筮      |  ##  |     ########## #######          |     ஦     |   ##  |   ##  | #### |
|室      |-----------------------------------------------------------------------------------------------------------------|
|            |2.6.       |  ࠭ ###     ######     ॣ ##    #####################################|
|            |ﭭ     | த ###################################### . 㭪 #######################################|
|            | ⥫⢠|  ##########################################  #####  #############  ##### |
|            |-----------------------------------------------------------------------------------------------------------------|
|            |2.7.                 |     |2.8.  ࠡ        |     |2.9.  ਮ                   |
|            |(1-१,2-१)  |  #  |(1-᭮,2-᭮)|  #  |###############################################|
}
*)

(*
$P{ Part2:
_SovInc[00], R, ""
_SovInc[01], R, ""
_SovInc[02], R, ""
_SovInc[03], R, ""
_SovInc[04], R, ""
_SovInc[05], R, ""
_SovInc[06], R, ""
_SovInc[07], R, ""
_SovInc[08], R, ""
_SovInc[09], R, ""
_SovInc[10], R, ""
_SovInc[11], R, ""
_VCode[0], L, ""
_AdvInc[0], R, ""
_LCode[0], L, ""
_LimVal[0], R, ""
_VCode[4], L, ""
_AdvInc[4], R, ""
_LCode[4], L, ""
_LimVal[4], R, ""
_VCode[1], L, ""
_AdvInc[1], R, ""
_LCode[1], L, ""
_LimVal[1], R, ""
_VCode[5], L, ""
_AdvInc[5], R, ""
_LCode[5], L, ""
_LimVal[5], R, ""
_VCode[2], L, ""
_AdvInc[2], R, ""
_LCode[2], L, ""
_LimVal[2], R, ""
_VCode[6], L, ""
_AdvInc[6], R, ""
_LCode[6], L, ""
_LimVal[6], R, ""
_VCode[3], L, ""
_AdvInc[3], R, ""
_LCode[3], L, ""
_LimVal[3], R, ""
_VCode[7], L, ""
_AdvInc[7], R, ""
_LCode[7], L, ""
_LimVal[7], R, ""
@
|============|=================================================================================================================|
|     3      |3.1. 㯭  |         |        ࠫ|           |         ५|            |           |
|------------| 室  栬| ##############| ##############| ##############| ##############| ##############| ##############|
|    |                 |---------------|---------------|---------------|---------------|---------------|---------------|
| 室   |                 |           |         |       |        |         |        |
|            |                 | ##############| ##############| ##############| ##############| ##############| ##############|
|            |-----------------|-----------------------------------------------------------------------------------------------|
|            |3.2.  室|   |  㬬 室| ᪨|  㬬 ᪨|   |  㬬 室| ᪨|  㬬 ᪨|
|            |  -|室|              | (室)|     (室)|室|              | (室)|     (室)|
|            | ਮ      |------|--------------|----------|--------------|------|--------------|----------|--------------|
|            |                 | #### |##############|    ##    |##############| #### |##############|    ##    |##############|
|            |                 | #### |##############|    ##    |##############| #### |##############|    ##    |##############|
|            |                 | #### |##############|    ##    |##############| #### |##############|    ##    |##############|
|            |                 | #### |##############|    ##    |##############| #### |##############|    ##    |##############|
}
*)

(*
$P{ Part21:
_VCode[00], L, ""
_AdvInc[00], R, ""
_VCode[02], L, ""
_AdvInc[02], R, ""
_VCode[04], L, ""
_AdvInc[04], R, ""
_VCode[06], L, ""
_AdvInc[06], R, ""
_VCode[01], L, ""
_AdvInc[01], R, ""
_VCode[03], L, ""
_AdvInc[03], R, ""
_VCode[05], L, ""
_AdvInc[05], R, ""
_VCode[07], L, ""
_AdvInc[07], R, ""
@
|============|=================================================================================================================|
|     4      |   |   |         㬬|     |   |         㬬|     |   |         㬬|     |   |         㬬|   |
|------------|   |------|--------------|     |------|--------------|     |------|--------------|     |------|--------------|   |
|   |   |  ##  |##############|     |  ##  |##############|     |  ##  |##############|     |  ##  |##############|   |
|ந- |   |  ##  |##############|     |  ##  |##############|     |  ##  |##############|     |  ##  |##############|   |
|  |   -----------------------     -----------------------     -----------------------     -----------------------   |
|            |    ꥪ,  ஬ ந    ந⥫  ਮ⥭        |
|            | _______________________________________________________________________________________________________________ |
|            | _______________________________________________________________________________________________________________ |
}
*)

(*
$P{ Part3:
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
L_Money.MoneyToStr(CurP, "", 0), R, ""
L_Money.MoneyToStr(CurP, "", 0), R, ""
L_Money.MoneyToStr(CurP, "", 0), R, ""
L_Money.MoneyToStr(CurP, "", 0), R, ""
L_Money.MoneyToStr(CurP, "", 0), R, ""
L_Money.MoneyToStr(CurP, "", 0), R, ""
L_Money.MoneyToStr(CurP, "", 0), R, ""
L_Money.MoneyToStr(CurP, "", 0), R, ""
L_Money.MoneyToStr(CurP, "", 0), R, ""
?, L, ""
?, L, "D"
?, L, "N"
?, L, "y"
?, L, "H:M"
@
|============|=================================================================================================================|
|     5      |5.1.  (室)   㬬        ##############   |5.2.    㬬        ##############   |
|------------|-----------------------------------------------------------------------------------------------------------------|
|ᯮ  |5.3. 㬬         |            |         | 㬬   |      ᫥   |       㤥ঠ   |
|   |室:            |   ##############   |   ##############   | : |   ##############   |   ##############   |
|易-      |-------------------|--------------------|--------------------|---------|--------------------|--------------------|
|⥫     |5.4. 㬬 - |               |          | 㬬   |      ᫥   |       㤥ঠ   |
|            |樥⮢  :|   ##############   |   ##############   | : |   ##############   |   ##############   |
|            |-------------------|--------------------|--------------------|---------|--------------------|--------------------|
|            |5.5. 㬬 -   |               |          | 㬬   |      ᫥   |       㤥ঠ   |
|            |ਠ쭮 룮:   |   ##############   |   ##############   | : |   ##############   |   ##############   |
|            |-----------------------------------------------------------------------------------------------------------------|
|            |5.6. 㬬 , । |              | 5.7. 稥  ।ਭ⥫, ⭮ ࠪ⨪, ७-|   |
|            |᪠   ᯥ |##############|⥫ ᭮  㤥ঠ 室   筨| - |
|            |                                |              |믫 (1- ⢥ত騩 㬥, 2- . .)|   |
|==============================================================================================================================|
|.壠()                                |                                  |       | ᫮ |  |   |
|                                                     |#####################################|⠢|   ##  |   ##  | #### |
=(c) Polak================================================================================================================#####=

  ..
}
*)

(*
$P{ Line:
Man.Man, L, ""
Err, L, ""
@
##############|##########################################################
}
*)

 PRIVATE PROCEDURE GetResidentStatus(): SCAL[2];
 BEGIN
  RETURN L_Man.Man_Citizen(Man.Man, CurP)<=L_Man.ct_Russia;
 END {GetResidentStatus};

 PRIVATE PROCEDURE HasInStateJMode(P: DATE): SCAL[2];
 BEGIN
  SELECT(Sheet, TSN, , Staff.TSN, P);
  WHILE OCCURE(Sheet) DO
   CONFORM(Sheet, JMode);
   IF JMode.InFirm THEN
    RETURN 1;
   END;
   NEXT(Sheet);
  END; (* WHILE OCCURE(Sheet)... *)
  RETURN 0;
 END {HasInStateJMode};

 PRIVATE PROCEDURE GetRomeStr(El: SCAL[2]): STRING[80];
  VAR
   ye,
   no,
   S      : STRING[80];
   W      : SCAL[2][12];
   P      : DATE;
   i      : SCAL[13];
 BEGIN
  ye:="01  ,02  ,03  ,04  ,05  ,06  ,07  ,08  ,09  ,10  ,11  ,12";
  no:="__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__";
  SETZERO(W);
  SAVE(Staff);
  SELECT(Staff, Man, , Man.Man);
  WHILE OCCURE(Staff) DO
   P:=L_DatTim.YearBeg(CurP);
   WHILE P <= CurP DO
    IF L_Staff.IsWorking(P) & HasInStateJMode(P) THEN
     W[L_DatTim.MONTH(P)]:=1;
    END;
    P:=L_DatTim.IncMonth(P, +1);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RESTORE(Staff);
  i:=0; S:=" ";
  WHILE i < 12 DO
   IF W[i] THEN
    IF El THEN
     S:=S + "1";
    ELSE
     S:=S + Str.Item(ye, ",", i);
    END;
   ELSE
    IF El THEN
     S:=S + "0";
    ELSE
     S:=S + Str.Item(no, ",", i);
    END;
   END;
   INC(i);
  END;
  RETURN S;
 END {GetRomeStr};

 PRIVATE PROCEDURE GetNbrStr(N: NUMERIC[2]): STRING[80];
  VAR
   S: STRING[80];
   L: NUMERIC[0];
 BEGIN
  S:=L_Money.MoneyToStr(CurP, "", N);
  L:=Str.Length(S);
  L_General.Assert(L < NbrStrLen, "   ᥫ!   Polak");
  RETURN S;
 END {GetNbrStr};

 PRIVATE PROCEDURE MoneyToTrn(N: NUMERIC[2]): STRING[64];
 BEGIN
  RETURN FLDTOSTR(N, "2.", 0);
 END {MoneyToTrn};

 PRIVATE PROCEDURE AddStr(VAR S, s: STRING[250]; DivChar: STRING[10]);
 BEGIN
  IF ~!s & ~!DivChar THEN
   s:=DivChar+s;
  END;
  IF    ~!s & ~!S THEN
   S:=S+s;
  ELSIF ~!s THEN
   S:=s;
  END;
 END {AddStr};

 PRIVATE PROCEDURE Man_Adress();
  VAR
   S, tmp: STRING[250];
 BEGIN
  L_Man.AccessRgManAdr(Man.Man, CurP);
  SETEMPTY(_CCode, _Zip, _RCode, _Distr, _PName1, _PName2, _Street, _House, _Block, _Flat);
  _CCode:=ManAdr.Country;
  _Zip  :=ManAdr.Zip;
  _RCode:=ManAdr.Region;
  _Distr:=ManAdr.Distr;
  IF ~!ManAdr.Town THEN
   _PName1:=ManAdr.Town;
  END;
  IF ~!ManAdr.VillageT THEN
   AddStr(_PName2, ManAdr.Village, "");
   tmp:=ManRgPType(ManAdr.VillageT);
   AddStr(_PName2, tmp, " ");
  END;
  AddStr(_Street, ManAdr.Street, "");
  tmp:=ManRgStrType(ManAdr.StreetT);
  AddStr(_Street, tmp, " ");
  _House:=ManAdr.House;
  AddStr(_Block,  ManAdr.Block, "");
  AddStr(_Block,  ManAdr.Build, ".");
  _Flat:=ManAdr.Flat;
 END {Man_Adress};

 PRIVATE PROCEDURE TypePart1();
  VAR
   dummy: SCAL[2];
 BEGIN
  PROMPT(Man.Man + " : " + Staff.TSN + " - ଠ N3 -  1");
  Man_Adress();

  dummy:=L_ctc.StandOnAdr_Reg(CurPE, P_Firm.OWN_FIRM, 1);
  MAKEPART(R, Part1, L_OwnData.ODTaxDepCode(SYSDATE()),
                     L_OwnData.ODAcntPhone(SYSDATE()),
                     CtcAdr.Zip, CtcAdr.Region, CtcAdr.Distr, CtcAdr.Town,
                     CtcAdr.Village, CtcAdr.Street, CtcAdr.House, CtcAdr.Block, CtcAdr.Flat,
                     L_Man.GetManDocCode(Man.DocType),
                     GetRomeStr(0)
          );
 END {TypePart1};

 PRIVATE PROCEDURE PrepareToPrint(NeedLim: SCAL[2]);
  VAR i: NUMERIC[0];
 BEGIN
  i:=0; IncToTrn:=" ";
  WHILE ~!_VCode[i] DO
   IF i > 0 THEN
    IncToTrn:=IncToTrn+";";
   END;
   _AdvInc[i]:=GetNbrStr(nAdvInc[i]);
   IncToTrn:=IncToTrn+_VCode[i]+","+MoneyToTrn(nAdvInc[i]);
   IF NeedLim THEN
    IF !_LCode[i] THEN
     _LCode[i]:="- ";
     _LimVal[i]:=      " -      ";
     IncToTrn:=IncToTrn+","+"0"+","+MoneyToTrn(0);
    ELSE
     _LimVal[i]:=GetNbrStr(nLimVal[i]);
     IncToTrn:=IncToTrn+","+_LCode[i]+","+MoneyToTrn(nLimVal[i]);
    END;
   END;
   INC(i);
  END;
  IncToTrn:=Str.Condense(IncToTrn);
 END {PrepareToPrint};

 PRIVATE PROCEDURE InitArr();
 BEGIN
  SETEMPTY(_VCode, _LCode, _AdvInc, _LimVal);
  SETZERO(ArrIdx, nAdvInc, nLimVal);
 END {InitArr};

 PRIVATE PROCEDURE GetIdx(__VCode: LIKE(TaxAdv.VCode)): NUMERIC[0];
  VAR i: NUMERIC[0];
 BEGIN
  IF ~!__VCode THEN
   i:=0;
   WHILE i < ArrIdx DO
    IF ~!_VCode[i] & (_VCode[i] = __VCode) THEN
     RETURN i;
    END;
    INC(i);
   END;
   RETURN i;
  ELSE
   RETURN ArrIdx;
  END;
 END {GetIdx};

 PRIVATE PROCEDURE SetDataForPart2(__VCode, __LCode: LIKE(TaxAdv.VCode); __AdvInc, __LimVal: NUMERIC[2]);
  VAR Idx: NUMERIC[0];
 BEGIN
  IF (__AdvInc # 0) | (__LimVal # 0) THEN
   L_General.Assert(~!__VCode | ~!__LCode, "  㪠  室   ᪨");
   Idx:=GetIdx(__VCode);
   IF Idx < ArrIdx THEN
    IF ~!_LCode[Idx] THEN
     L_General.Assert(~!__LCode & (__LCode=_LCode[Idx]), " ᮢ  ᪨| 室 "+__VCode);
    END;
    INC(nAdvInc[Idx], __AdvInc);
    INC(nLimVal[Idx], __LimVal);
   ELSE
    IF ~!__VCode THEN
     _VCode[Idx]:=__VCode;
    END;
    IF ~!__LCode THEN
     L_General.Assert(~!__VCode, "  㪠  室| ᪨ "+__LCode);
     _LCode[Idx]:=__LCode;
    ELSE
     L_General.Assert(__LimVal = 0, "  㪠  ᪨| 室 "+__VCode);
    END;
    nAdvInc[Idx]:=__AdvInc;
    nLimVal[Idx]:=__LimVal;
    INC(ArrIdx);
   END;
  END; (* IF (__AdvInc # 0)... *)
 END {SetDataForPart2};

 PRIVATE PROCEDURE Set_Limits(_AdvInc: NUMERIC[2][12]; LimVal: NUMERIC[2]);
  VAR i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE (LimVal > 0) & (i < 12) DO
   IF _AdvInc[i] > 0 THEN
    IF _AdvInc[i] >= LimVal THEN
     INC(_Limits[i], LimVal);
    ELSE
     INC(_Limits[i], _AdvInc[i]);
    END;
    DEC(LimVal, _AdvInc[i]);
   END;
   INC(i);
  END; (* WHILE i < ... *)
 END {Set_Limits};

 PRIVATE PROCEDURE OneTAReason(_Reason: LIKE(TaxAdv.Reason); VAR AdvInc: NUMERIC[2][12]; VAR Tot: NUMERIC[2]; Type: SCAL[2]; _LCode: LIKE(TaxAdv.LCode));
  VAR
   EstArr,
   _AdvInc : NUMERIC[2][12];
   Dummy,
   LimVal  : NUMERIC[2];
   i       : NUMERIC[0];
   _VCode_ : LIKE(TaxAdv.VCode);
 BEGIN
  SELECT(TaxAdv, TAReason, , _Reason);
  WHILE OCCURE(TaxAdv) DO
   SETZERO(_AdvInc, LimVal);
   SAVE(TaxAdv);
   IF L_Tx2000._GetOneTaxAdv(CurP, CurP, TaxAdv.Reason, TaxAdv.TaxAdv, _AdvInc, LimVal, 0(*not other org*)) THEN
    i:=0;
    WHILE i <= 11 DO
     INC(AdvInc[i], _AdvInc[i]);
     INC(i);
    END;
    IF Type = 0(*室*) THEN
     _VCode_:=TaxAdv.VCode;
     IF (TaxAdv.TaxAdv = 30) | (TaxAdv.TaxAdv = 00) THEN
      _VCode_:="0200";
     END;
     INC(Tot, LimVal);
     IF ~!TaxAdv.LCode THEN
      SetDataForPart2(_VCode_, TaxAdv.LCode, L_Tx2000.GetArrSum(_AdvInc), LimVal);
      Set_Limits(_AdvInc, LimVal);
     ELSE
      SetDataForPart2(_VCode_, "",           L_Tx2000.GetArrSum(_AdvInc), LimVal);
      L_General.Assert(LimVal=0, " 㪠  ᪨  䨪樨 " + TaxAdv.TaxAdv);
     END;
    ELSE       (**)
     IF L_Tx2000.NeedEstimate(TaxAdv.TaxAdv) & L_Tx2000.EstimateDone() THEN
      L_Tx2000.GetEstimateArr(_AdvInc, EstArr);
      Dummy:=L_Tx2000.GetArrSum(EstArr);
      INC(Tot, Dummy);
      SetDataForPart2(_LCode,     "", Dummy, 0);
     END;
     Dummy:=L_Tx2000.GetArrSum(_AdvInc);
     INC(Tot, Dummy);
     SetDataForPart2(TaxAdv.LCode, "", Dummy, 0);
    END;
   END; (* IF L_Tx2000._GetOneTaxAdv(... *)
   RESTORE(TaxAdv);
   NEXT(TaxAdv);
  END; (* WHILE OCCURE(TaxAdv) ... *)
 END {OneTAReason};

 PRIVATE PROCEDURE GetPurInc(PIncSel: SCAL[3]; VAR _PurInc: NUMERIC[2][12]; __VCode:LIKE(TaxAdv.VCode));
  VAR PurInc: NUMERIC[2];
 BEGIN
  SETZERO(_PurInc);
  L_Tx2000.GetPureIncome(CurP, _PurInc, PIncSel);
  PurInc   :=L_Tx2000.GetArrSum(_PurInc);
  IF PurInc # 0 THEN
   SetDataForPart2(__VCode, "", PurInc, 0);
  END;
 END {GetPurInc};

 PRIVATE PROCEDURE AddManStr(VAR s1: STRING[250]; IsString: SCAL[2]; NeedZpt: SCAL[2]);
 BEGIN
  IF NeedZpt & ~FirstFieldInLine THEN
   FIO.WrStr(T, ',');
  END;
  FirstFieldInLine:=0;
  IF ~!s1 THEN
   FIO.WrStr(T, Str.Condense(s1));
  END;
 END {AddManStr};

 PRIVATE PROCEDURE AddManSt1(s: STRING[250]; IsString: SCAL[2]; NeedZpt: SCAL[2]);
 BEGIN
  AddManStr(s, IsString, NeedZpt);
 END {AddManSt1};

 PRIVATE PROCEDURE __GetOneReason(Proc: STRING[32]; P, F: DATE; _Reason: LIKE(TaxAdv.Reason); VAR S: NUMERIC[2][]);
  VAR
   Sum    : NUMERIC[2][12];
   Lim    : NUMERIC[2];
 BEGIN
  SELECT(_MnTA, _MnTA, , Man.Man, _Reason);
  WHILE OCCURE(_MnTA) DO
   SAVE(_MnTA);
   L_Tax.Tax_AccessManTA_by_MnTA();
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
   CONFORM(ManTA, TaxAdv);
   SETZERO(Sum, Lim);
   IF L_Tx2000._GetOneTaxAdv(P, F, _Reason, _MnTA._TaxAdv, Sum, Lim, 0(*not other org*)) THEN
    ^Proc(_Reason, Sum, Lim, S);
   END; (* IF Get ... *)
   RESTORE(_MnTA);
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
   LAST(_MnTA);
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType);
   NEXT(_MnTA);
  END; (* WHILE OCCURE(_MnTA) ... *)
 END {__GetOneReason};

 PRIVATE PROCEDURE _GetOneReason_Wo_Lim(P, F: DATE; _Reason: LIKE(TaxAdv.Reason); VAR S: NUMERIC[2][]);
 BEGIN
  __GetOneReason("L_Tx2000._Wo_Lim", P, F, _Reason, S);
 END {_GetOneReason_Wo_Lim};

 PRIVATE PROCEDURE _GetOneReason(P, F: DATE; _Reason: LIKE(TaxAdv.Reason); VAR S: NUMERIC[2][]);
 BEGIN
  __GetOneReason("L_Tx2000._W_Lim", P, F, _Reason, S);
 END {_GetOneReason};

 PRIVATE PROCEDURE BuyFlats(): STRING[250];
  VAR
   _Dummy  : NUMERIC[2][12];
   LimVal  : NUMERIC[2];
 BEGIN
  SETZERO(_Dummy);
  IF L_Tx2000.GetOneTaxAdv(CurP, CurP, 4(*_tr_DecWA*), 19(**), _Dummy, LimVal) THEN
   RETURN P_Staff.GetP_BuyFlats(Staff.TSN, CurP);
  ELSE
   RETURN "";
  END;
 END {BuyFlats};

 PRIVATE PROCEDURE TypePart3(WithPrint: SCAL[2]; NeedInit: SCAL[2]): SCAL[3];
  VAR
   IncWA,
   PaidPns,
   PaidPnsA,
   PaidTax,
   ClcTax,
   ToTax   : NUMERIC[2];
   Dummy,
   _IncInBase,
   _PurInc,
   _PurInc1,
   _PurInc2,
   _TotInc : NUMERIC[2][12];
   IncInBase,
   PurInc  : NUMERIC[2];
   ValInc,
   TotLim,
   LimVal,
   TotInc,
   TotDec  : NUMERIC[2];
   i       : NUMERIC[0];
   tmp     : STRING[250];
   _Dummy  : NUMERIC[2];
 BEGIN
  IF WithPrint THEN
   PROMPT(Man.Man + " : " + Staff.TSN + " - ଠ N3 -  2");
  END;

  IF NeedInit THEN
   L_Tx2000.NTax_InitValues(CurP);
  ELSE
   L_Tx2000.FillManIsWorking(CurP);
  END;
 
  InitArr();
  GetPurInc(1, _PurInc1, "0200");
  GetPurInc(2, _PurInc2, "0300");

  SETZERO(TotLim, _PurInc, _IncInBase, _Limits);
  OneTAReason(0, _PurInc,    TotLim, 0, "");             (* pure inc   *)
  OneTAReason(1, _IncInBase, TotLim, 0, "");             (* inc w/a    *)

  PrepareToPrint(1);
  i:=0; tmp:=" ";
  WHILE i <= 11 DO
   _PurInc[i]:=_PurInc[i] + _PurInc1[i] + _PurInc2[i];
   _TotInc[i]:=_PurInc[i] + _IncInBase[i] - _Limits[i];
   _SovInc[i]:=GetNbrStr(_TotInc[i]);
   tmp:=tmp+MoneyToTrn(_TotInc[i]);
   IF i < 11 THEN
    tmp:=tmp+",";
   END;
   INC(i);
  END;
  tmp:=Str.Condense(tmp);

  L_General.Assert(TotLim = L_Tx2000.GetArrSum(_Limits), "Error 23455");

  IF WithPrint THEN
   IF ToPaper() THEN
    MAKEPART(R, Part2);
   ELSE
    AddManSt1("室:", 0, 0);
    AddManSt1(tmp, 0, 0);
    NewLine();
    AddManSt1("室:", 0, 0);
    IF ~!IncToTrn THEN
     AddManSt1(IncToTrn, 0, 0);
    ELSE
     AddManSt1("0200,0.00,0,0.00", 0, 0);
    END;
    NewLine();
   END; (* IF ToPaper()... *)
  END; (* IF WithPrint... *)

  IF WithPrint THEN
   PROMPT(Man.Man + " : " + Staff.TSN + " - ଠ N3 -  3");
  END;

  PurInc   :=L_Tx2000.GetArrSum(   _PurInc);
  IncInBase:=L_Tx2000.GetArrSum(_IncInBase);

  TotInc   :=L_Tx2000.GetArrSum(_TotInc);

  L_Tx2000.SetManTotInc(_TotInc);

  SETZERO(IncWA);
  _GetOneReason_Wo_Lim(CurP, CurP, 1, IncWA); (* inc w/a    *)

  InitArr();
  SETZERO(Dummy, TotDec, PaidPns, PaidTax);
  OneTAReason(2, Dummy, TotDec, 1, "22");                (* personal   *)
  OneTAReason(3, Dummy, TotDec, 1, "31");                (* children   *)
  OneTAReason(4, Dummy, TotDec, 1, "");                  (* expand w/a *)

  _GetOneReason(CurP, CurP, 5, PaidTax); (* paid tax   *)
  _GetOneReason(CurP, CurP, 8, PaidPns); (* paid pns   *)
  PaidPnsA:=PaidPns;
  L_Tx2000.GetTaxAndPens(CurP, PaidTax, PaidPns, PaidPnsA);
  IF PaidPns#0 THEN
   INC(TotDec, PaidPns);
   SetDataForPart2("10", "", PaidPns, 0);
  ELSIF PaidPnsA#0 THEN
   SetDataForPart2("10", "", PaidPnsA, 0);
  END;

  IF WithPrint THEN
   PrepareToPrint(0);
   IF ToPaper() THEN
    MAKEPART(R, Part21);
   ELSE
    IF ~!IncToTrn THEN
     AddManSt1(":", 0, 0);
     AddManSt1(IncToTrn, 0, 0);
     NewLine();
    END;

    tmp:=BuyFlats();
    IF ~!tmp THEN
     AddManSt1(":", 0, 0);
     AddManSt1(Str.Cap(tmp), 0, 0);
     NewLine();
    END;
   END; (* IF ToPaper()... *)
  ELSE
   tmp:=BuyFlats();
  END; (* IF WithPrint... *)

  TotDec:=Math.Min(TotDec, TotInc);
  ToTax :=TotInc-TotDec;

  ClcTax:=L_Tx2000.GetOverTax(CurP, CurP)+PaidTax;

  SETZERO(_Dummy);
  IF L_Tx2000.GetOneTaxAdv(CurP, CurP, 5(*_tr_PdTax*), 08(*_ta_OvrTax*), _Dummy, LimVal) THEN
   DEC(PaidTax, _Dummy);
  END;

  ValInc:=PurInc+IncWA;

  IF WithPrint THEN
   IF ToPaper() THEN
    MAKEPART(R, Part3,
               GetNbrStr(TotLim ),
               GetNbrStr(TotDec ),
               GetNbrStr(ValInc),
               GetNbrStr(ToTax  ),
               GetNbrStr(ClcTax ),
               GetNbrStr(PaidTax),
               L_Str.ShortName(L_OwnData.ODAcntName(SYSDATE())),
               SYSDATE(),
               SYSDATE(),
               SYSDATE(),
               SYSTIME()
            );
   ELSE
    AddManSt1("㬬:", 0, 0);
    AddManSt1(MoneyToTrn(TotLim), 0, 0);
    NewLine();
    AddManSt1("㬬:", 0, 0);
    AddManSt1(MoneyToTrn(TotDec), 0, 0);
    NewLine();
    AddManSt1("㬬:", 0, 0);
    AddManSt1(MoneyToTrn(ValInc), 0, 0);
    NewLine();
    AddManSt1("㬬:", 0, 0);
    AddManSt1(MoneyToTrn(ToTax), 0, 0);
    NewLine();
    AddManSt1("㬬:", 0, 0);
    AddManSt1(MoneyToTrn(ClcTax), 0, 0);
    NewLine();
    AddManSt1("㬬:", 0, 0);
    AddManSt1(MoneyToTrn(PaidTax), 0, 0);
    NewLine();
    INC(TotValInc, ValInc);
    INC(TotPaidTax, PaidTax);
    MAKEPART(D, DLine, FLDTOSTR(Man.Man, "0", 8), GetSpecFIO(Man.Name), L_Money.MoneyToStr(CurP, "", ValInc), L_Money.MoneyToStr(CurP, "", PaidTax));
   END; (* IF ToPaper()... *)
   RETURN 1;
  ELSE
   IF (ValInc #0) THEN
    RETURN 1;
   ELSIF
    (TotLim #0)|
    (TotDec #0)|
    (ToTax  #0)|
    (ClcTax #0)|
    (PaidTax#0) THEN
    RETURN 2;
   ELSE
    RETURN 0;
   END;
  END; (* IF WithPrint... *)
 END {TypePart3};

 PRIVATE PROCEDURE NewLine();
 BEGIN
  FIO.WrLn(T);
  FirstFieldInLine:=1;
 END {NewLine};

 PRIVATE PROCEDURE GetAdr(): STRING[250];
  VAR
   tmp,
   S    : STRING[250];
 BEGIN
  Err:="";
  IF !ManAdr.Country | (ManAdr.Country=0) THEN Err:="  ࠭"; RETURN ""; END;
  IF ManAdr.Country = L_Russia.c_Russia THEN  S:=",";
  ELSE                                        S:=ManAdr.Country + ",,,,,,,,,"; RETURN S;
  END;

  S:=S+ManAdr.Zip + ",";

  IF !ManAdr.Region THEN
   IF ManAdr.Country = L_Russia.c_Russia THEN
    Err:="  ॣ"; RETURN "";
   ELSE
    S:=S+",";
   END;
  ELSE
   IF ManAdr.Region=0 THEN
    Err:="㫥  ॣ"; RETURN "";
   END;
   S:=S+ManAdr.Region + ",";
  END;

  IF ~!ManAdr.Distr THEN
   tmp:=Str.Item(ManAdr.Distr, " ", 1);
   IF ~!tmp THEN Err:=" - ..  ᫮"; RETURN ""; END;
   S:=S+Str.Cap(ManAdr.Distr)+" -,";
  ELSE
   S:=S+",";
  END;

  IF ~!ManAdr.Town THEN
   S:=S+Str.Cap(ManAdr.Town)+" ,";
  ELSE
   S:=S+",";
  END;

  IF    !ManAdr.VillageT & ~!ManAdr.Village THEN
   Err:=" ⨯  㭪"; RETURN "";
  ELSIF ~!ManAdr.VillageT & !ManAdr.Village THEN
   Err:="  㭪"; RETURN "";
  ELSIF ~!ManAdr.Village THEN
   S:=S+Str.Cap(ManAdr.Village)+" "+ManRgPType(ManAdr.VillageT);
  END;
  S:=S+",";
  IF    !ManAdr.StreetT & ~!ManAdr.Street THEN
   Err:="  㫨"; RETURN "";
  ELSIF ~!ManAdr.StreetT & !ManAdr.Street THEN
   Err:="  㫨"; RETURN "";
  ELSIF ~!ManAdr.Street THEN
   S:=S+Str.Cap(ManAdr.Street)+" "+ManRgStrType(ManAdr.StreetT);
  END;
  S:=S+",";
  IF ~!ManAdr.House THEN
   S:=S+Str.Cap(ManAdr.House);
  ELSE
   IF ~!ManAdr.Flat THEN
    Err:="  ,    ";
   END;
   IF ~!ManAdr.Block THEN
    Err:="  ,    ";
   END;
   IF ~!ManAdr.Build THEN
    Err:="  ஥,    ";
   END;
  END;
  S:=S+",";
  IF ~!ManAdr.Block THEN
   S:=S+Str.Cap(ManAdr.Block);
  END;
  IF ~!ManAdr.Build THEN
   IF ~!ManAdr.Block THEN
    S:=S+" ";
   END;
   S:=S+" "+Str.Cap(ManAdr.Build);
  END;
  S:=S+",";
  IF ~!ManAdr.Flat THEN
   S:=S+Str.Cap(ManAdr.Flat);
  END;

  RETURN S;
 END {GetAdr};

 PRIVATE PROCEDURE PutAdr(): STRING[250];
  VAR
  _Address: STRING[250];
 BEGIN
  L_Man.AccessRgManAdr(Man.Man, CurPE);
  _Address:=GetAdr();
  IF !_Address THEN
   _Address:=",,,,,,,,,";
  ELSIF ~!Err THEN
  END;
  L_General.Assert(Str.Length(_Address) <=120, "   120 ᨬ| 䨧᪮ ");
  RETURN _Address;
 END {PutAdr};

 PRIVATE PROCEDURE GetSpecFIO(S: STRING[250]): STRING[250];
  VAR
   s, s1: STRING[255];
   i: NUMERIC[0];
 BEGIN
  S:=Str.Cap(S);
  s:=Str.Item(S, " ", 0);
  i:=1;
  LOOP
   s1:=Str.Item(S, " ", i);
   IF !s1 THEN EXIT END;
   s:=s+","+s1;
   INC(i);
  END;
  RETURN s;
 END {GetSpecFIO};

 PRIVATE PROCEDURE MakeOneMan();
 BEGIN
  L_General.Assert(SEARCH(Staff, TSN, _MN._TSN), "Error 234");
  CONFORM(Staff, Man);
  PROMPT(Man.Man);
  AddManSt1(":", 0, 0);
  AddManSt1(IDO+FLDTOSTR(L_DatTim.YearBeg(CurP), "Y", 2)+FLDTOSTR(Man.Man, "0", 8), 0, 0);
  NewLine();

  AddManSt1("⠄:", 0, 0);
  AddManSt1(FLDTOSTR(SYSDATE(), "D.N.y"), 0, 0);
  NewLine();

  IF ~!Man.INN THEN
   AddManSt1(":", 0, 0);
   AddManSt1(FLDTOSTR(Man.INN, "0"), 0, 0);
   NewLine();
  END;

  AddManSt1(":", 0, 0);
  AddManSt1(GetSpecFIO(Man.Name), 0, 0);
  NewLine();

  AddManSt1(":", 0, 0);
  AddManSt1(L_Man.GetManDocCode(Man.DocType), 0, 0);
  AddManSt1(Man.PspSer+" "+Man.PspNbr, 0, 1);
  NewLine();

  AddManSt1("⠐:", 0, 0);
  AddManSt1(FLDTOSTR(Man.Birth, "D.N.y"), 0, 0);
  NewLine();

  AddManSt1(":", 0, 0);
  AddManSt1(PutAdr(), 0, 0);
  NewLine();

  AddManSt1("ᔋ:", 0, 0);
  AddManSt1(FLDTOSTR(Str.Item("2|1", "|", GetResidentStatus()), "0"), 0, 0);
  NewLine();

  AddManSt1("⮄:", 0, 0);
  AddManSt1(FLDTOSTR(Str.Item("1|2|2|2|2", "|", Staff.Contract), "0"), 0, 0);
  NewLine();

  AddManSt1("ਮ:", 0, 0);
  AddManSt1(GetRomeStr(1), 0, 0);
  NewLine();

  Type3Result:=TypePart3(1, 0);

  AddManSt1("@@@", 0, 0);
  NewLine();
 END {MakeOneMan};

(*
$P{ DTit:
CurP, L, "y"
NAM, L, ""
INN, L, ""
?, L, ""
?, L, ""
?, L, ""
@
                                 N ____
                 ᢥ  室 䨧᪨   #### 

                          ࠢ⥫
/ ࠡ⮤⥫ ################################################
 ࠡ⮤⥫              ################################################
⮢                 ################################################
䮭 壠            ################################################

                          ⥫
                        ################################################
⮢ 
䮭 ᯥ

==============================================================================
|   N    |       , , ⢮        |    㬬     |     㬬    |
|ࠢ |         ⥫騪           |      |  㤥ঠ |
|        |                                     |    室    |        |
|--------|-------------------------------------|--------------|--------------|
}
*)

(*
$P{ DLine:
?, L, ""
?, L, ""
?, R, ""
?, R, ""
@
|########|#####################################|##############|##############|
}
*)

(*
$P{ DBot:
?, R, ""
?, R, ""
?, L, ""
?, L, ""
?, L, ""
@
|----------------------------------------------|--------------|--------------|
|⮣                                         |##############|##############|
==============================================================================

ᥣ ।⠢ 㬥⮢ ##################

㪮⥫              ____________________ (#############################)

 壠         ____________________ (#############################)
                                ()          (, , ⢮)

                          ..

 ।⠢  
"__"____________ _____ . ____________________ (_____________________________)
                                ()         (... ⭮ )

 ਭ  
"__"____________ _____ . ____________________ (_____________________________)
                                ()      (...   ᯥ)
}
*)

 PRIVATE PROCEDURE PacketTitle(PackNum: NUMERIC[0]);
 BEGIN
  FirstFieldInLine:=1;
  AddManSt1(":", 1, 0);
  AddManSt1(IDO+L_DatTim.SysDateTimeStamp(), 1, 0);
  NewLine();
  AddManSt1(":", 1, 0);
  AddManSt1("", 1, 0);
  NewLine();
  AddManSt1(":", 1, 0);
  AddManSt1(NAM, 1, 0);
  NewLine();
  AddManSt1(":", 0, 0);
  AddManSt1(L_OwnData.ODAcntPhone(SYSDATE()), 0, 0);
  NewLine();
  AddManSt1(":", 1, 0);
  AddManSt1(GetFADR(), 0, 0);
  NewLine();
  _Value:=P_Firm.FP_Tax3Sender(Firm.Firm, SYSDATE());
  AddManSt1(":", 0, 0);
  AddManSt1(Str.Cap(Str.Item(_Value, ";", 0)), 0, 0);
  NewLine();
  AddManSt1(":", 0, 0);
  _Value:=Str.Item(_Value, ";", 1);
  AddManSt1(GetSpecFIO(_Value), 0, 0);
  NewLine();
  AddManSt1(":", 0, 0);
  AddManSt1(FLDTOSTR(ManAmou[PackNum], "0"), 0, 0);
  NewLine();
  AddManSt1("ண:", 0, 0);
  AddManSt1(VER, 0, 0);
  NewLine();
  MAKEPART(D, DTit, L_OwnData.ODFirmAddr(SYSDATE()), L_OwnData.ODAcntPhone(SYSDATE()), L_OwnData.ODTaxDepCode(SYSDATE()));
 END {PacketTitle};

 PRIVATE PROCEDURE PacketBottom(PackNum: NUMERIC[0]);
 BEGIN
  AddManSt1("===", 0, 0);
  MAKEPART(D, DBot, L_Money.MoneyToStr(CurP, "", TotValInc),
                    L_Money.MoneyToStr(CurP, "", TotPaidTax),
                    ManAmou[PackNum],
                    L_Str.ShortName(L_OwnData.ODLeadName(SYSDATE())),
                    L_Str.ShortName(L_OwnData.ODAcntName(SYSDATE())));
  FORMFEED(D);
 END {PacketBottom};

 PRIVATE PROCEDURE GetFileExt(): STRING[32];
 BEGIN
  RETURN "TXT";
 END {GetFileExt};

 PRIVATE PROCEDURE GetFileName(PackNum: SCAL[MaxPacket]): STRING[32];
 BEGIN
  RETURN "S"+Str.Slice(INN, 4, 5)+FLDTOSTR(PackNum);
 END {GetFileName};

 PRIVATE PROCEDURE GetPacketNum(): SCAL[MaxPacket];
 BEGIN
  IF Staff.Contract = 1(*.ᮢ⥫*) THEN
   RETURN 1;
  ELSE
   RETURN 2;
  END;
 END {GetPacketNum};

 PRIVATE PROCEDURE MakeIndex();
  VAR
   Cnt,
   PacketNum: SCAL[MaxPacket];
 BEGIN
  OPENREP(R, L_General.NameConnection("BdAdr"), Create);
  SETZERO(ManAmou);
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   SAVE(Man);
   SETZERO(Cnt);
   PROMPT(" "+Man.Man);
   SELECT(Staff, Man, , Man.Man);
   WHILE OCCURE(Staff) DO
    IF L_Staff.IsMainForTax(CurPE) THEN
     L_General.Assert(Cnt=0, "2  ࠪ -   Polak");
     INC(Cnt);
     Type3Result:=TypePart3(0, 1);
     IF    Type3Result = 2 THEN
      Err:="  室,   ᪨,  ,  ";
      MAKEPART(R, Line);
     ELSIF Type3Result = 1 THEN
      _Address:=GetAdr();
      IF !_Address THEN
       MAKEPART(R, Line);
      ELSIF ~!Man.INN & ~L_Russia.CheckINN(Man.INN) THEN
       Err:="४ ";
       MAKEPART(R, Line);
      ELSE
       PacketNum:=GetPacketNum();
       INC(ManAmou[PacketNum]);
       _MN._PacketNum:=PacketNum;
       _MN._Man      :=Man.Man;
       _MN._TSN      :=Staff.TSN;
       INSERT(_MN);
      END;
     END;
    END; (* IF L_Staff.IsMainForTax ... *)
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   RESTORE(Man);
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
  CLOSEREP(R);
 END {MakeIndex};

 PRIVATE PROCEDURE MakeAll();
  VAR
   PacketNum: SCAL[MaxPacket];
 BEGIN
  OPENREP(D, L_General.NameConnection("Reest"), Create);
  SELECT(_MN, _MN);
  WHILE OCCURE(_MN) DO
   PacketNum:=_MN._PacketNum;
   SETZERO(TotValInc, TotPaidTax);
   CHANGESEL(_MN, _MN, , PacketNum);
   FIO.Open(T, GetFileName(PacketNum), GetFileExt(), Create);
   PacketTitle(PacketNum);
   WHILE OCCURE(_MN) DO
    MakeOneMan();
    NEXT(_MN);
   END; (* WHILE OCCURE(_MN)... *)
   PacketBottom(PacketNum);
   FIO.Close(T);
   LAST(_MN);
   CHANGESEL(_MN, _MN);
   NEXT(_MN);
  END; (* WHILE OCCURE(_MN)... *)
  CLOSEREP(D);
 END {MakeAll};

 PRIVATE PROCEDURE CheckPer();
 BEGIN
  L_StdFrm.Choice("C  ਮ  "+L_DatTim.DateStr(L_DatTim.YearBeg(CurP))+"  "+L_DatTim.DateStr(CurPE));
 END {CheckPer};

 PRIVATE PROCEDURE CheckPer1();
 BEGIN
  L_General.Assert(L_DatTim.YearBeg(CurP)<01\01\1999, "ணࠬ ।祭  ᢥ ⮫쪮  1999 ");
 END {CheckPer1};

 VAR
  ManAmou: NUMERIC[0][MaxPacket];
  PacketNum: SCAL[MaxPacket];

 PRIVATE PROCEDURE StandOnMain(D: DATE);
 BEGIN
  SELECT(Staff, Man, , Man.Man);
  WHILE OCCURE(Staff) DO
   IF L_Staff.IsMainForTax(D) THEN
    RETURN;
   END;
   NEXT(Staff);
  END;
 END {StandOnMain};

 PUBLIC PROCEDURE T3_1998(trgMode: tMode);
 BEGIN
  curMode:=trgMode;
  IF (curMode # mode_ToPaper) & (curMode # mode_All) THEN
   L_StdFrm.BlueStop("    ⮣ ਮ");
  END;
  CurP :=Memo.ud_mb();
  CurPE:=Memo.ud_me();
  CheckPer();
 
  NAM :=Str.Cap(P_Firm.FP_FirmName(_Firm, CurPE));
  INN :=L_OwnData.ODINN(CurPE);
  IDO :=INN+"**";
  L_AFM.MakeIndex("_MN", "_PacketNum: SCAL[50]            ;"+
                         "_Man      : LIKE(Man.Man)       ;"+
                         "_TSN      : LIKE(Staff.TSN)      ");
 
  IF ToPaper() THEN
   OPENREP(R, L_General.NameConnection("Tax03"), Create);
  
   L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
 
   CONFORM(Staff, Man);
 
   L_Staff.CheckCurrentAsMainForTax(CurPE);
  
   PROMPT(Man.Man + " : " + Staff.TSN + " - ଠ N3 -  0");
  
   L_General.Assert(L_PRoll.IsDedD(), " ⠭  " + L_DatTim.PeriodStr(CurP));
  
   CONFORM(Staff, Man);
  
   TypePart1();
  
   Type3Result:=TypePart3(1, 1);
   L_Tax.Tax_FreeValues(CurP);
 
   CLOSEREP(R);
   L_AFM.AF_PurgeTemp("_MN");
   LIKEMENU(Survey, "");
  ELSIF AllMode() THEN
   CheckPer1();
   MakeIndex();
   MakeAll();
   L_Tax.Tax_FreeValues(CurP);
  END;
  L_AFM.AF_PurgeTemp("_MN");
 END {T3_1998};

END.