(*
%Copyright   (c) Polak Computer System
%Author      11.09.1995 18:50:07 SAN
%Purpose      ਫ N3  室 
%Type        report
%Specific    SYS
%Modified    16.05.2014 13:17:48 POLAK\Gina
%Environment
*)

 MODULE T3_2000 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_OwnData, L_PRoll, L_Tx2000, L_Tax, L_Staff,
        L_Money, L_Str, L_AFM, L_Russia, L_Man, P_Staff, P_Man, P_Firm,
        Str, Math, FIO, Memo, P_OwnData, L_ctc;

 TYPE
  tMode        = SCAL[4];

 CONST
  mode_ToPaper         = 0; (*tMode*)
  mode_All             = 3;

 VAR
  CurP, CurPE: DATE;
  _FictOnly  : SCAL[2];
  curMode    : tMode;

 PRIVATE PROCEDURE ToPaper(): SCAL[2];
 BEGIN
  RETURN curMode = mode_ToPaper;
 END {ToPaper};

 PRIVATE PROCEDURE AllMode(): SCAL[2];
 BEGIN
  RETURN curMode = mode_All;
 END {AllMode};

 PRIVATE PROCEDURE DocNum(): STRING[];
 BEGIN
  RETURN FLDTOSTR(Man.Man, "", 6)+"/"+FLDTOSTR(SYSDATE(), "yND")+FLDTOSTR(SYSTIME(), "HM");
 END {DocNum};

 PRIVATE PROCEDURE FictOnly(): SCAL[2];
 BEGIN
  RETURN _FictOnly;
 END {FictOnly};

 PRIVATE PROCEDURE GetNbrStr(N: NUMERIC[2]): STRING[80];
  VAR
   S: STRING[80];
 BEGIN
  S:=FLDTOSTR(N, "2-", 0);
  L_General.Assert(Str.Length(S) < NbrStrLen, "   ᥫ!   Polak");
  RETURN S;
 END {GetNbrStr};

 PRIVATE PROCEDURE GetNbrStrIntg(N: NUMERIC[2]): STRING[80];
  VAR
   S: STRING[80];
 BEGIN
  S:=FLDTOSTR(N, "0=");
  L_General.Assert(Str.Length(S) < NbrStrLen, "   ᥫ!   Polak");
  RETURN S;
 END {GetNbrStrIntg};

 CONST
  Path      = "REP\T3\";
  NbrStrLen = 14;
  IncAm     = 08;
  DecAm     = 08;
  MaxAm     = Math.Max(IncAm, DecAm);
  MaxPacket = 50;

 VAR
  NAM,
  INN,
  KPP,
  IDO: STRING[];
  _Firm: LIKE(Firm.Firm);
  _Limits: NUMERIC[2][12];
  _SovInc: STRING[NbrStrLen][12];
  _VCode : LIKE(TaxAdv.VCode)[MaxAm];
  _LCode : LIKE(TaxAdv.LCode)[MaxAm];
  _AdvInc,
  _LimVal: STRING[NbrStrLen][MaxAm];
  nAdvInc,
  nLimVal: NUMERIC[2][MaxAm];
  ArrIdx : NUMERIC[0];
  IncToTrn: STRING[250];
  TotValInc,
  TotPaidTaxF,
  TotPaidTaxC: NUMERIC[2];
  Type3Result: SCAL[3];
  ManAmou    : NUMERIC[0][MaxPacket];
  ErrCnt     : NUMERIC[0];

  _ValInc,
  _TotInc : NUMERIC[2][12];

  _Town,
  _Village,
  _Street,
  _Block  : STRING[32];

  FirstFieldInLine: SCAL[2];

(*
$P{ Part1:
P_Firm.FP_TaxDepCode(Firm.Firm, SYSDATE()), L, ""
CurP, L, "y"
DocNum(), L, ""
INN+"/"+KPP, L, ""
P_Firm.FP_AcntPhone(Firm.Firm, SYSDATE()), L, ""
NAM, L, ""
Man.INN, L, ""
?, L, ""
Man.Name, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, "D"
?, L, "N"
?, L, "y"
?, L, ""
?, L, ""
?, L, ""
?, L, ""
_Town, L, ""
_Village, L, ""
_Street, L, ""
?, L, ""
_Block, L, ""
?, L, ""
GetResidentStatus(), L, "2|1"
Staff.Contract, L, "1|2|2|2|2"
GetRomeStr(0), L, ""
@
                                            ਫ N 3  樨 㤠⢥  㦡 ᨨ  29.06.95 N 35
================================================================================================================================
|            |  #### |                    ࠢ  室 䨧᪮   ####            | N ####################|
|============|=================================================================================================================|
|     1      |1.1.  ###################### | 1.2. ⠪ ⥫䮭 #######################################################|
|------------|-----------------------------------------------------------------------------------------------------------------|
|  |1.3.  ।, ࣠樨, ० / , , ⢮ 䨧᪮                  |
|筨   |#################################################################################################################|
|믫     |                                                                                                                 |
|============|=================================================================================================================|
|     2      |2.1.  ############ |2.2.   #### |2.3.  ##############################################################|
|------------|-----------------------------------------------------------------------------------------------------------------|
|   |2.4.   㬥,      |      |2.5. ,  㬥      |2.6.          | ᫮ |  |   |
|⥫  |㤮⮢饣 筮      |  ##  |     ########## #######          |     ஦     |   ##  |   ##  | #### |
|室      |-----------------------------------------------------------------------------------------------------------------|
|            |2.7.       |  ࠭ ###     ॣ ##     ######    #####################################|
|            |ﭭ     | த ##################################### . 㭪 ########################################|
|            | ⥫⢠|  ########################################  ######  ##############  ######|
|            |-----------------------------------------------------------------------------------------------------------------|
|            |2.8.                 |     |2.9.  ࠡ        |     |2.10.  ਮ                  |
|            |(1-१,2-१)  |  #  |(1-᭮,2-᭮)|  #  |###############################################|
}
*)

(*
$P{ Part2:
_VCode[0], L, ""
_AdvInc[0], R, ""
_LCode[0], L, ""
_LimVal[0], R, ""
_VCode[4], L, ""
_AdvInc[4], R, ""
_LCode[4], L, ""
_LimVal[4], R, ""
_VCode[1], L, ""
_AdvInc[1], R, ""
_LCode[1], L, ""
_LimVal[1], R, ""
_VCode[5], L, ""
_AdvInc[5], R, ""
_LCode[5], L, ""
_LimVal[5], R, ""
_VCode[2], L, ""
_AdvInc[2], R, ""
_LCode[2], L, ""
_LimVal[2], R, ""
_VCode[6], L, ""
_AdvInc[6], R, ""
_LCode[6], L, ""
_LimVal[6], R, ""
_VCode[3], L, ""
_AdvInc[3], R, ""
_LCode[3], L, ""
_LimVal[3], R, ""
_VCode[7], L, ""
_AdvInc[7], R, ""
_LCode[7], L, ""
_LimVal[7], R, ""
_SovInc[00], R, ""
_SovInc[01], R, ""
_SovInc[02], R, ""
_SovInc[03], R, ""
_SovInc[04], R, ""
_SovInc[05], R, ""
_SovInc[06], R, ""
_SovInc[07], R, ""
_SovInc[08], R, ""
_SovInc[09], R, ""
_SovInc[10], R, ""
_SovInc[11], R, ""
@
|============|=================================================================================================================|
|     3      | 室     |   |  㬬 室| ᪨|  㬬 ᪨|   |  㬬 室| ᪨|  㬬 ᪨|
|------------|  -|室|              | (室)|     (室)|室|              | (室)|     (室)|
|    | ਮ      |------|--------------|----------|--------------|------|--------------|----------|--------------|
|      |                 | #### |##############|    ##    |##############| #### |##############|    ##    |##############|
|室     |                 | #### |##############|    ##    |##############| #### |##############|    ##    |##############|
|            |                 | #### |##############|    ##    |##############| #### |##############|    ##    |##############|
|            |                 | #### |##############|    ##    |##############| #### |##############|    ##    |##############|
|============|=================================================================================================================|
|     4      |㯭       |         |        ࠫ|           |         ५|            |           |
|------------|室   栬| ##############| ##############| ##############| ##############| ##############| ##############|
|            |                 |---------------|---------------|---------------|---------------|---------------|---------------|
|            |                 |           |         |       |        |         |        |
|            |                 | ##############| ##############| ##############| ##############| ##############| ##############|
}
*)

(*
$P{ Part21:
_VCode[00], L, ""
_AdvInc[00], R, ""
_VCode[02], L, ""
_AdvInc[02], R, ""
_VCode[04], L, ""
_AdvInc[04], R, ""
_VCode[06], L, ""
_AdvInc[06], R, ""
_VCode[01], L, ""
_AdvInc[01], R, ""
_VCode[03], L, ""
_AdvInc[03], R, ""
_VCode[05], L, ""
_AdvInc[05], R, ""
_VCode[07], L, ""
_AdvInc[07], R, ""
?, L, ""
@
|============|=================================================================================================================|
|     5      |   |   |         㬬|     |   |         㬬|     |   |         㬬|     |   |         㬬|   |
|------------|   |------|--------------|     |------|--------------|     |------|--------------|     |------|--------------|   |
|   |   |  ##  |##############|     |  ##  |##############|     |  ##  |##############|     |  ##  |##############|   |
|ந- |   |  ##  |##############|     |  ##  |##############|     |  ##  |##############|     |  ##  |##############|   |
|  |   -----------------------     -----------------------     -----------------------     -----------------------   |
|            |    ꥪ,  ஬ ந    ந⥫  ਮ⥭        |
|            | ############################################################################################################### |
|            |                                                                                                                 |
}
*)

(*
$P{ Part3:
?, R, ""
?, R, ""
?, R, ""
?, R, ""
GetNbrStr(0), R, ""
GetNbrStrIntg(0), R, ""
GetNbrStrIntg(0), R, ""
GetNbrStrIntg(0), R, ""
GetNbrStr(0), R, ""
GetNbrStrIntg(0), R, ""
GetNbrStrIntg(0), R, ""
GetNbrStrIntg(0), R, ""
GetNbrStrIntg(0), R, ""
?, R, ""
?, L, ""
SYSDATE(), L, "D"
SYSDATE(), L, "N"
SYSDATE(), L, "y"
SYSTIME(), L, "H:M"
@
|============|=================================================================================================================|
|     6      |                             |                㬬  室            |               㬬               |
|------------|                             |-----------------------------------------|-----------------------------------------|
|ᯮ  |                             |               |          |         ᫥|          㤥ঠ|
|   |-----------------------------|--------------------|--------------------|--------------------|--------------------|
|易-      |6.1. 㯭       |                    |                    |                    |                    |
|⥫     | 室:                      |    ################|    ################|    ################|    ################|
|            |-----------------------------|--------------------|--------------------|--------------------|--------------------|
|            |6.2. 㬬 樥⮢    |                    |                    |                    |                    |
|            | :                   |    ################|    ################|    ################|    ################|
|            |-----------------------------|--------------------|--------------------|--------------------|--------------------|
|            |6.3. ਠ쭠 룮   |                    |                    |                    |                    |
|            |     客|                    |                    |                    |                    |
|            | 믫⠬                    |    ################|    ################|    ################|    ################|
|            |-----------------------------------------------------------------------------------------------------------------|
|            |6.4. 㬬 , ।  |                |6.5.㬬     |                    |
|            |᪠  ᭠ᯥ    |################| 室 ⭮                  |    ################|
|==============================================================================================================================|
|.壠()                                |                                  |       | ᫮ |  |   |
|                                                     |#####################################|⠢|   ##  |   ##  | #### |
=(c) Polak================================================================================================================#####=

  ..
}
*)

(*
$P{ BdTop:
NAM, L, ""
SYSDATE(), L, "D.N.Y"
SYSTIME(), L, "H:M"
@
############################################################### ######## #####
=BdAdr========================================================================
|                       祭  ᢥ  室                      |
|----------------------------------------------------------------------------|
|᪮ |稭                                                     |
|---------------|------------------------------------------------------------|
}
*)

(*
$P{ BdLine:
Man.Man, L, ""
?, L, ""
@
|###############|############################################################|
}
*)

(*
$P{ BdBot:
ErrCnt, R, "0"
@
|----------------------------------------------------------------------------|
|⮣ #### 䨧᪨                                                    |
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE GetResidentStatus(): SCAL[2];
 BEGIN
  RETURN L_Man.Man_Citizen(Man.Man, CurP)<=L_Man.ct_Russia;
 END {GetResidentStatus};

 PRIVATE PROCEDURE HasInStateJMode(P: DATE): SCAL[2];
 BEGIN
  SELECT(Sheet, TSN, , Staff.TSN, P);
  WHILE OCCURE(Sheet) DO
   CONFORM(Sheet, JMode);
   IF JMode.InFirm THEN
    RETURN 1;
   END;
   NEXT(Sheet);
  END; (* WHILE OCCURE(Sheet)... *)
  RETURN 0;
 END {HasInStateJMode};

 PRIVATE PROCEDURE GetRomeStr(El: SCAL[2]): STRING[80];
  VAR
   ye,
   no,
   S      : STRING[80];
   W      : SCAL[2][12];
   P      : DATE;
   i      : SCAL[13];
 BEGIN
  ye:="01  ,02  ,03  ,04  ,05  ,06  ,07  ,08  ,09  ,10  ,11  ,12";
  no:="__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__";
  SETZERO(W);
  SAVE(Staff);
  SELECT(Staff, Man, , Man.Man);
  WHILE OCCURE(Staff) DO
   P:=L_DatTim.YearBeg(CurP);
   WHILE P <= CurP DO
    IF (~FictOnly() & L_Staff.IsWorking(P) & HasInStateJMode(P)) |
       (_ValInc[L_DatTim.MONTH(P)] # 0) THEN
     W[L_DatTim.MONTH(P)]:=1;
    END;
    P:=L_DatTim.IncMonth(P, +1);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RESTORE(Staff);
  i:=0; SETEMPTY(S);
  WHILE i < 12 DO
   IF W[i] THEN
    IF El THEN
     S:=S + "1";
    ELSE
     S:=S + Str.Item(ye, ",", i);
    END;
   ELSE
    IF El THEN
     S:=S + "0";
    ELSE
     S:=S + Str.Item(no, ",", i);
    END;
   END;
   INC(i);
  END;
  RETURN S;
 END {GetRomeStr};

 PRIVATE PROCEDURE MoneyToTrn(N: NUMERIC[2]): STRING[64];
 BEGIN
  RETURN FLDTOSTR(N, "2.", 0);
 END {MoneyToTrn};

 PRIVATE PROCEDURE MoneyToTrnIntg(N: NUMERIC[2]): STRING[64];
 BEGIN
  RETURN FLDTOSTR(N, "0", 0);
 END {MoneyToTrnIntg};

 PRIVATE PROCEDURE TypePart1();
  VAR
   S,
   tmp     : STRING[250];
   _TaxDep : LIKE(ManPro.Value);
 BEGIN
  PROMPT(Man.Man + " : " + Staff.TSN + " - ଠ N3 -  1");

  _TaxDep :=P_Man.GetManProSoft(Man.Man, SYSDATE(), P_Man.P_TaxDep);
  IF !Man.INN THEN
   L_Tax.StandOnManAdrForTax(Man.Man, CurPE);
   tmp:=L_Man.GetAdrForTax(S);
   IF ~!tmp THEN
    Error(tmp);
   END;
   L_Man.PrepareRgManAdressForTax_37(CurP, _Town, _Village, _Street, _Block);
   MAKEPART(R, Part1, _TaxDep, L_Man.GetManDocCode(Man.DocType), Man.PspSer,
                      Man.PspNbr, Man.Birth, Man.Birth, Man.Birth,
                      ManAdr.Country, ManAdr.Region, ManAdr.Zip, ManAdr.Distr,
                      ManAdr.House, ManAdr.Flat);
  ELSE
   SETEMPTY(_Village, _Street, _Block, _Town);
   MAKEPART(R, Part1, _TaxDep, "");
  END;
 END {TypePart1};

 PRIVATE PROCEDURE PrepareToPrint(NeedLim: SCAL[2]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  IncToTrn:=" ";
  WHILE ~!_VCode[i] DO
   IF i > 0 THEN
    IncToTrn:=IncToTrn+";";
   END;
   _AdvInc[i]:=GetNbrStr(nAdvInc[i]);
   IncToTrn:=IncToTrn+_VCode[i]+","+MoneyToTrn(nAdvInc[i]);
   IF NeedLim THEN
    IF !_LCode[i] THEN
     _LCode[i]:="- ";
     _LimVal[i]:=      " -      ";
     IncToTrn:=IncToTrn+","+"0"+","+MoneyToTrn(0);
    ELSE
     _LimVal[i]:=GetNbrStr(nLimVal[i]);
     IncToTrn:=IncToTrn+","+_LCode[i]+","+MoneyToTrn(nLimVal[i]);
    END;
   END;
   INC(i);
  END;
  IncToTrn:=Str.Condense(IncToTrn);
 END {PrepareToPrint};

 PRIVATE PROCEDURE InitArr();
 BEGIN
  SETEMPTY(_VCode, _LCode, _AdvInc, _LimVal);
  SETZERO(ArrIdx, nAdvInc, nLimVal);
 END {InitArr};

 PRIVATE PROCEDURE GetIdx(__VCode: LIKE(TaxAdv.VCode)): NUMERIC[0];
  VAR i: NUMERIC[0];
 BEGIN
  IF ~!__VCode THEN
   i:=0;
   WHILE i < ArrIdx DO
    IF ~!_VCode[i] & (_VCode[i] = __VCode) THEN
     RETURN i;
    END;
    INC(i);
   END;
   RETURN i;
  ELSE
   RETURN ArrIdx;
  END;
 END {GetIdx};

 PRIVATE PROCEDURE SetDataForPart2(__VCode, __LCode: LIKE(TaxAdv.VCode); __AdvInc, __LimVal: NUMERIC[2]);
  VAR
   Idx: NUMERIC[0];
 BEGIN
  IF (__AdvInc # 0) | (__LimVal # 0) THEN
   L_General.Assert(~!__VCode | ~!__LCode, "  㪠  室   ᪨");
   Idx:=GetIdx(__VCode);
   IF Idx < ArrIdx THEN
    IF ~!_LCode[Idx] THEN
     L_General.Assert(~!__LCode & (__LCode=_LCode[Idx]), " ᮢ  ᪨| 室 "+__VCode);
    END;
    INC(nAdvInc[Idx], __AdvInc);
    INC(nLimVal[Idx], __LimVal);
   ELSE
    IF ~!__VCode THEN
     _VCode[Idx]:=__VCode;
    END;
    IF ~!__LCode THEN
     L_General.Assert(~!__VCode, "  㪠  室| ᪨ "+__LCode);
     _LCode[Idx]:=__LCode;
    ELSE
     L_General.Assert(__LimVal = 0, "  㪠  ᪨| 室 "+__VCode);
    END;
    nAdvInc[Idx]:=__AdvInc;
    nLimVal[Idx]:=__LimVal;
    INC(ArrIdx);
   END;
  END; (* IF (__AdvInc # 0)... *)
 END {SetDataForPart2};

 PRIVATE PROCEDURE Set_Limits(_AdvInc: NUMERIC[2][12]; LimVal: NUMERIC[2]);
  VAR i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE (LimVal > 0) & (i < 12) DO
   IF _AdvInc[i] > 0 THEN
    IF _AdvInc[i] >= LimVal THEN
     INC(_Limits[i], LimVal);
    ELSE
     INC(_Limits[i], _AdvInc[i]);
    END;
    DEC(LimVal, _AdvInc[i]);
   END;
   INC(i);
  END; (* WHILE i < ... *)
 END {Set_Limits};

 PRIVATE PROCEDURE OneTAReason(_Reason: LIKE(TaxAdv.Reason); VAR AdvInc: NUMERIC[2][12]; VAR Tot: NUMERIC[2]; Type: SCAL[2]; _LCode: LIKE(TaxAdv.LCode));
  VAR
   EstArr,
   _AdvInc : NUMERIC[2][12];
   Dummy,
   LimVal  : NUMERIC[2];
   i       : NUMERIC[0];
   _VCode_ : LIKE(TaxAdv.VCode);
 BEGIN
  SELECT(TaxAdv, TAReason, , _Reason);
  WHILE OCCURE(TaxAdv) DO
   SETZERO(_AdvInc, LimVal);
   SAVE(TaxAdv);
   IF L_Tx2000._GetOneTaxAdv(CurP, CurP, TaxAdv.Reason, TaxAdv.TaxAdv, _AdvInc, LimVal, 0) THEN
    i:=0;
    WHILE i <= 11 DO
     INC(AdvInc[i], _AdvInc[i]);
     INC(i);
    END;
    IF Type = 0(*室*) THEN
     _VCode_:=TaxAdv.VCode;
     IF (TaxAdv.TaxAdv = 30) | (TaxAdv.TaxAdv = 00) THEN
      _VCode_:="0200";
     END;
     INC(Tot, LimVal);
     IF ~!TaxAdv.LCode THEN
      SetDataForPart2(_VCode_, TaxAdv.LCode, L_Tx2000.GetArrSum(_AdvInc), LimVal);
      Set_Limits(_AdvInc, LimVal);
     ELSE
      SetDataForPart2(_VCode_, "",           L_Tx2000.GetArrSum(_AdvInc), LimVal);
      L_General.Assert(LimVal=0, " 㪠  ᪨  䨪樨 " + TaxAdv.TaxAdv);
     END;
    ELSE       (**)
     IF L_Tx2000.NeedEstimate(TaxAdv.TaxAdv) & L_Tx2000.EstimateDone() THEN
      L_Tx2000.GetEstimateArr(_AdvInc, EstArr);
      Dummy:=L_Tx2000.GetArrSum(EstArr);
      INC(Tot, Dummy);
      IF (_Reason=3(*_tr_Child*)) & (TaxAdv.DefValue=2) THEN
       _LCode:="46";
      END;
      SetDataForPart2(_LCode,     "", Dummy, 0);
     END;
     Dummy:=L_Tx2000.GetArrSum(_AdvInc);
     INC(Tot, Dummy);
     SetDataForPart2(TaxAdv.LCode, "", Dummy, 0);
    END;
   END; (* IF L_Tx2000._GetOneTaxAdv ... *)
   RESTORE(TaxAdv);
   NEXT(TaxAdv);
  END; (* WHILE OCCURE(TaxAdv) ... *)
 END {OneTAReason};

 PRIVATE PROCEDURE GetPurInc(PIncSel: SCAL[3]; VAR _PurInc: NUMERIC[2][12]; __VCode:LIKE(TaxAdv.VCode));
  VAR PurInc: NUMERIC[2];
 BEGIN
  SETZERO(_PurInc);
  IF ~FictOnly() THEN
   L_Tx2000.GetPureIncome(CurP, _PurInc, PIncSel);
   PurInc   :=L_Tx2000.GetArrSum(_PurInc);
   IF PurInc # 0 THEN
    SetDataForPart2(__VCode, "", PurInc, 0);
   END;
  END;
 END {GetPurInc};

 PRIVATE PROCEDURE AddManStr(VAR s1: STRING[250]; IsString: SCAL[2]; NeedZpt: SCAL[2]);
 BEGIN
  IF NeedZpt & ~FirstFieldInLine THEN
   FIO.WrStr(T, ',');
  END;
  FirstFieldInLine:=0;
  IF ~!s1 THEN
   FIO.WrStr(T, Str.Condense(s1));
  END;
 END {AddManStr};

 PRIVATE PROCEDURE AddManSt1(s: STRING[250]; IsString: SCAL[2]; NeedZpt: SCAL[2]);
 BEGIN
  AddManStr(s, IsString, NeedZpt);
 END {AddManSt1};

 PRIVATE PROCEDURE __GetOneReason(Proc: STRING[32]; P, F: DATE; _Reason: LIKE(TaxAdv.Reason); VAR S: NUMERIC[2][]);
  VAR
   Sum    : NUMERIC[2][12];
   Lim    : NUMERIC[2];
 BEGIN
  SELECT(_MnTA, _MnTA, , Man.Man, _Reason);
  WHILE OCCURE(_MnTA) DO
   SAVE(_MnTA);
   L_Tax.Tax_AccessManTA_by_MnTA();
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
   CONFORM(ManTA, TaxAdv);
   SETZERO(Sum, Lim);
   IF L_Tx2000._GetOneTaxAdv(P, F, _Reason, _MnTA._TaxAdv, Sum, Lim, 0) THEN
    ^Proc(_Reason, Sum, Lim, S);
   END; (* IF Get ... *)
   RESTORE(_MnTA);
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
   LAST(_MnTA);
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType);
   NEXT(_MnTA);
  END; (* WHILE OCCURE(_MnTA) ... *)
 END {__GetOneReason};

 PRIVATE PROCEDURE _GetOneReason_Wo_Lim(P, F: DATE; _Reason: LIKE(TaxAdv.Reason); VAR S: NUMERIC[2][]);
 BEGIN
  __GetOneReason("L_Tx2000._Wo_Lim", P, F, _Reason, S);
 END {_GetOneReason_Wo_Lim};

 PRIVATE PROCEDURE _GetOneReason(P, F: DATE; _Reason: LIKE(TaxAdv.Reason); VAR S: NUMERIC[2][]);
 BEGIN
  __GetOneReason("L_Tx2000._W_Lim", P, F, _Reason, S);
 END {_GetOneReason};

 PRIVATE PROCEDURE BuyFlats(): STRING[250];
  VAR
   _Dummy  : NUMERIC[2][12];
   LimVal  : NUMERIC[2];
 BEGIN
  SETZERO(_Dummy);
  IF L_Tx2000._GetOneTaxAdv(CurP, CurP, 4(*_tr_DecWA*), 19(**), _Dummy, LimVal, 0) THEN
   RETURN P_Staff.GetP_BuyFlats(Staff.TSN, CurP);
  ELSE
   RETURN "";
  END;
 END {BuyFlats};

 PRIVATE PROCEDURE ExclNegInc(VAR Array: NUMERIC[2][]);
  VAR
   i,
   j: NUMERIC[0];
 BEGIN
  IF L_Tx2000.GetArrSum(Array) > 0 THEN
   i:=HIGH(Array);
   WHILE i >= 0 DO
    IF Array[i] < 0 THEN
     j:=i;
     WHILE j >= 0 DO
      IF Array[j]+Array[i] >= 0 THEN
       INC(Array[j], Array[i]);
       Array[i]:=0;
      END;
      DEC(j);
     END;
    END;
    DEC(i);
   END;
   i:=0;
   WHILE i <= HIGH(Array) DO
    IF Array[i] < 0 THEN
     j:=i;
     WHILE j <= HIGH(Array) DO
      IF Array[j]+Array[i] >=0 THEN
       INC(Array[i+1], Array[i]);
       Array[i]:=0;
      END;
      INC(j);
     END;
    END;
    INC(i);
   END;
  END;
 END {ExclNegInc};

 VAR
  T3PrtErr: SCAL[2][10];

 PRIVATE PROCEDURE TypePart3(WithPrint: SCAL[2]; NeedInit: SCAL[2]): SCAL[3];
  VAR
   IncWA,
   PaidPns,
   PaidPnsA,
   RetnTaxF,
   RetnTaxC,
   PaidTaxF,
   PaidTaxC: NUMERIC[2];
   ClcTaxF,
   ClcTaxC,
   ToTax   : NUMERIC[2];
   Dummy,
   _IncInBase,
   _PurInc,
   _PurInc1,
   _PurInc2: NUMERIC[2][12];
   IncInBase,
   PurInc  : NUMERIC[2];
   ValInc,
   TotLim,
   LimVal,
   TotInc,
   TotDec  : NUMERIC[2];
   i       : NUMERIC[0];
   tmp     : STRING[250];
   OverTax,
   室,
   ,
   _Dummy  : NUMERIC[2];
 BEGIN
  IF WithPrint THEN
   PROMPT(Man.Man + " : " + Staff.TSN + " - ଠ N3 -  2");
  END;

  IF NeedInit THEN
   L_Tx2000._NTax_InitValues(CurP, FictOnly());
  ELSE
   L_Tx2000.FillManIsWorking(CurP);
  END;

  InitArr();
  GetPurInc(0, _PurInc1, "0200");
  SETZERO(_PurInc2);

  SETZERO(TotLim, _PurInc, _IncInBase, _Limits);
  OneTAReason(0, _PurInc,    TotLim, 0, "");             (* pure inc   *)
  OneTAReason(1, _IncInBase, TotLim, 0, "");             (* inc w/a    *)

  PrepareToPrint(1);
  i:=0;
  WHILE i <= 11 DO
   _PurInc[i]:=_PurInc[i] + _PurInc1[i] + _PurInc2[i];
   _ValInc[i]:=_PurInc[i] + _IncInBase[i];
   _TotInc[i]:=_ValInc[i] - _Limits[i];
   INC(i);
  END;
  室:=L_Tx2000.GetArrSum(nAdvInc);
    :=L_Tx2000.GetArrSum(nLimVal);

  ExclNegInc(_TotInc);

  i:=0; tmp:=" ";
  WHILE i <= 11 DO
   _SovInc[i]:=GetNbrStr(_TotInc[i]);
   tmp:=tmp+MoneyToTrn(_TotInc[i]);
   IF i < 11 THEN
    tmp:=tmp+",";
   END;
   INC(i);
  END;
  tmp:=Str.Condense(tmp);

  L_General.Assert(TotLim = L_Tx2000.GetArrSum(_Limits), "Error 23455");

  IF WithPrint THEN
   IF ToPaper() THEN
    TypePart1();
    MAKEPART(R, Part2);
   ELSE
    AddManSt1("ਮ:", 0, 0);
    AddManSt1(GetRomeStr(1), 0, 0);
    NewLine();
  
    AddManSt1("室:", 0, 0);
    IF ~!IncToTrn THEN
     AddManSt1(IncToTrn, 0, 0);
    ELSE
     AddManSt1("0200,0.00,0,0.00", 0, 0);
    END;
    NewLine();
    AddManSt1("室:", 0, 0);
    AddManSt1(tmp, 0, 0);
    NewLine();
   END; (* IF ToPaper() ... *)
  END; (* IF WithPrint... *)

  IF WithPrint THEN
   PROMPT(Man.Man + " : " + Staff.TSN + " - ଠ N3 -  3");
  END;

  PurInc   :=L_Tx2000.GetArrSum(   _PurInc);
  IncInBase:=L_Tx2000.GetArrSum(_IncInBase);

  TotInc   :=L_Tx2000.GetArrSum(_TotInc);

  L_Tx2000.__GetOverTax(CurP, CurP, ClcTaxF, ClcTaxC, FictOnly());

  SETZERO(IncWA);
  _GetOneReason_Wo_Lim(CurP, CurP, 1, IncWA); (* inc w/a    *)

  InitArr();
  SETZERO(Dummy, TotDec, PaidPns, PaidTaxF, PaidTaxC);
  OneTAReason(2, Dummy, TotDec, 1, "22");                (* personal   *)
  OneTAReason(3, Dummy, TotDec, 1, "31");                (* children   *)
  OneTAReason(4, Dummy, TotDec, 1, "");                  (* expand w/a *)

  _GetOneReason(CurP, CurP,10, PaidTaxF);(* paid F tax   *)
  _GetOneReason(CurP, CurP, 5, PaidTaxC);(* paid C tax   *)
  _GetOneReason(CurP, CurP, 8, PaidPns); (* paid pns     *)
  PaidPnsA:=PaidPns;
  IF ~FictOnly() THEN
   L_Tx2000._GetTaxAndPens(CurP, PaidTaxF, PaidTaxC, PaidPns, PaidPnsA);
  END;

  IF PaidPns#0 THEN
   INC(TotDec, PaidPns);
   SetDataForPart2("10", "", PaidPns, 0);
  ELSIF PaidPnsA#0 THEN
   SetDataForPart2("10", "", PaidPnsA, 0);
  END;

  IF WithPrint THEN
   PrepareToPrint(0);
   IF ToPaper() THEN
    MAKEPART(R, Part21, BuyFlats());
   ELSE
    IF ~!IncToTrn THEN
     AddManSt1(":", 0, 0);
     AddManSt1(IncToTrn, 0, 0);
     NewLine();
    END;

    tmp:=BuyFlats();
    IF ~!tmp THEN
     AddManSt1(":", 0, 0);
     AddManSt1(Str.Cap(tmp), 0, 0);
     NewLine();
    END;
   END; (* IF ToPaper() ... *)
  ELSE
   tmp:=BuyFlats();
  END; (* IF WithPrint... *)

  TotDec:=Math.Min(TotDec, TotInc);
  ToTax :=TotInc-TotDec;
  INC(ClcTaxC, PaidTaxC + PaidTaxF);

  SETZERO(OverTax); (* 모뢠 ९ *)
  IF L_Tx2000._GetOneTaxAdv(CurP, CurP, 5(*_tr_PdTxC*), 08(*_ta_OvrTxC*), OverTax, LimVal, 0) THEN
   DEC(PaidTaxC, OverTax);
  END;
  SETZERO(_Dummy);
  IF L_Tx2000._GetOneTaxAdv(CurP, CurP,10(*_tr_PdTxF*), 48(*_ta_OvrTxF*), _Dummy, LimVal, 0) THEN
   DEC(PaidTaxF, _Dummy);
  END;
  INC(OverTax, _Dummy);

  ValInc:=PurInc+IncWA;

  SETZERO(RetnTaxF, RetnTaxC);
  IF PaidTaxF<0 THEN
   RetnTaxF:=-PaidTaxF;
   PaidTaxF:=0;
  END;
  IF PaidTaxC<0 THEN
   RetnTaxC:=-PaidTaxC;
   PaidTaxC:=0;
  END;

  IF WithPrint THEN
   ClcTaxC:=Math.Max(ClcTaxC, 0);
   IF ToPaper() THEN
    MAKEPART(R, Part3,
               GetNbrStr(ValInc),
               GetNbrStrIntg(ToTax  ),
               GetNbrStrIntg(ClcTaxC),
               GetNbrStrIntg(PaidTaxC),
               GetNbrStrIntg(RetnTaxC),
               L_Str.ShortName(P_Firm.FP_AcntName(Firm.Firm, SYSDATE())));
   ELSE
    AddManSt1("㬬:", 0, 0);
    AddManSt1(MoneyToTrn(ValInc), 0, 0);
    NewLine();
    AddManSt1("㬬:", 0, 0);
    AddManSt1(MoneyToTrn(ToTax), 0, 0);
    NewLine();
    AddManSt1("㬬:", 0, 0);
    AddManSt1(MoneyToTrnIntg(ClcTaxC), 0, 0);
    NewLine();
    AddManSt1("㬬:", 0, 0);
    AddManSt1(MoneyToTrnIntg(PaidTaxC), 0, 0);
    NewLine();
    IF RetnTaxC#0 THEN
     AddManSt1(":", 0, 0);
     AddManSt1(MoneyToTrnIntg(RetnTaxC), 0, 0);
     NewLine();
    END;
    INC(TotValInc, ValInc);
    INC(TotPaidTaxF, PaidTaxF);
    INC(TotPaidTaxC, PaidTaxC);
    MAKEPART(D, DLine, FLDTOSTR(Man.Man, "0", 8), GetSpecFIO(Man.Name), GetNbrStr(ValInc), GetNbrStr(PaidTaxC));
    SETEMPTY(T3PrtErr);
    IF OverTax#0 THEN
     T3PrtErr[00]:=ClcTaxC=(PaidTaxC+OverTax);
    END;
    IF !T3PrtErr[00] | ~T3PrtErr[00] THEN
     T3PrtErr[01]:=ClcTaxC#PaidTaxC;
    END;
    _Dummy:=室-;
    T3PrtErr[02]:=TotInc#_Dummy; (*ᮢ㯭=-᪨*)
    _Dummy:=ValInc--TotDec;
    T3PrtErr[03]:=ToTax#_Dummy;  (*=-᪨-*)
    MAKEPART(T3Prt, T3Prt_Line,
                    GetNbrStr(室),
                    GetNbrStr(),
                    GetNbrStr(TotInc),
                    GetNbrStr(TotDec),
                    GetNbrStr(ValInc),
                    GetNbrStr(ToTax),
                    GetNbrStr(ClcTaxC),
                    GetNbrStr(PaidTaxC),
                    GetNbrStr(RetnTaxC));
   END; (* IF ToPaper() ... *)
   RETURN 1;
  ELSE
   IF (ValInc >0) THEN
    RETURN 1;
   ELSIF
    (ValInc  <0)|
    (TotLim  #0)|
    (TotDec  #0)|
    (ToTax   #0)|
    (ClcTaxF #0)|
    (ClcTaxC #0)|
    (PaidTaxF#0)|
    (PaidTaxC#0) THEN
    RETURN 2;
   ELSIF
    (RetnTaxF#0)|
    (RetnTaxC#0) THEN
    RETURN 0;
   ELSE
    RETURN 0;
   END;
  END; (* IF WithPrint... *)
 END {TypePart3};

 PRIVATE PROCEDURE NewLine();
 BEGIN
  FIO.WrLn(T);
  FirstFieldInLine:=1;
 END {NewLine};

 PRIVATE PROCEDURE GetSpecFIO(S: STRING[250]): STRING[250];
  VAR
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  L_Str.SplitManName(Str.Cap(S), Surname, FirstName, Patronymic);
  RETURN Surname+","+FirstName+","+Patronymic;
 END {GetSpecFIO};

 PRIVATE PROCEDURE MakeOneMan();
  VAR
   _Value   : STRING[];
   Err,
   _Address : STRING[250];
   HasINN   : SCAL[2];
 BEGIN
  L_General.Assert(SEARCH(Staff, TSN, _MN._TSN), "Error 234");
  CONFORM(Staff, Man);
  PROMPT(Man.Man);
  AddManSt1(":", 0, 0);
  AddManSt1(IDO+FLDTOSTR(L_DatTim.YearBeg(CurP), "y")+FLDTOSTR(Man.Man, "0", 8), 0, 0);
  NewLine();

  AddManSt1("⠄:", 0, 0);
  AddManSt1(FLDTOSTR(SYSDATE(), "D.N.y"), 0, 0);
  NewLine();

  HasINN:=~!Man.INN;

  IF HasINN THEN
   AddManSt1(":", 0, 0);
   AddManSt1(FLDTOSTR(Man.INN, "0"), 0, 0);
   NewLine();
   AddManSt1(":", 0, 0);
   _Value :=P_Man.GetManProSoft(Man.Man, SYSDATE(), P_Man.P_TaxDep);
   AddManSt1(_Value, 0, 0);
   NewLine();
  END;

  AddManSt1(":", 0, 0);
  AddManSt1(GetSpecFIO(Man.Name), 0, 0);
  NewLine();

  IF ~HasINN THEN
   AddManSt1(":", 0, 0);
   AddManSt1(L_Man.GetManDocCode(Man.DocType), 0, 0);
   AddManSt1(Man.PspSer+" "+Man.PspNbr, 0, 1);
   NewLine();
 
   AddManSt1("⠐:", 0, 0);
   AddManSt1(FLDTOSTR(Man.Birth, "D.N.y"), 0, 0);
   NewLine();
 
   AddManSt1(":", 0, 0);
   L_Tax.StandOnManAdrForTax(Man.Man, CurPE);
   Err:=L_Man.GetAdrForTax(_Address);
   AddManSt1(_Address, 0, 0);
   NewLine();
  END;

  AddManSt1("ᔋ:", 0, 0);
  AddManSt1(FLDTOSTR(Str.Item("2|1", "|", GetResidentStatus()), "0"), 0, 0);
  NewLine();

  AddManSt1("⮄:", 0, 0);
  IF ~FictOnly() THEN
   AddManSt1(FLDTOSTR(Str.Item("1|2|2|2|2", "|", Staff.Contract), "0"), 0, 0);
  ELSE
   IF P_Man.HasActualManPro(Man.Man, CurPE, P_Man.P_ManFictWorker) THEN
    AddManSt1("1", 0, 0);
   ELSE
    AddManSt1("2", 0, 0);
   END;
  END;
  NewLine();

  Type3Result:=TypePart3(1, 0);

  AddManSt1("@@@", 0, 0);
  NewLine();
 END {MakeOneMan};

(*
$P{ DTit:
CurP, L, "y"
NAM, L, ""
INN+"/"+KPP, L, ""
L_ctc.GetAdr_Pst(CurPE, Firm.Firm), L, ""
P_Firm.FP_AcntPhone(Firm.Firm, SYSDATE()), L, ""
P_Firm.FP_TaxDepCode(Firm.Firm, SYSDATE()), L, ""
@

                                                                              ਫ N 10
                                                   樨    29  1995 . N 35

                                        N ____
                        ᢥ  室 䨧᪨   #### 

---------------------------------------------------------------------------------------------
|ࠢ⥫                                                                                |
|-------------------------------------------------------------------------------------------|
|/  |                                                                        |
|ࠡ⮤⥫      |########################################################################|
|------------------|------------------------------------------------------------------------|
| ࠡ⮤⥫  |########################################################################|
|------------------|------------------------------------------------------------------------|
|⮢     |########################################################################|
|------------------|------------------------------------------------------------------------|
|䮭 壠|########################################################################|
---------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------
|⥫                                                                                 |
|------------------|------------------------------------------------------------------------|
|            |########################################################################|
|------------------|------------------------------------------------------------------------|
|⮢     |                                                                        |
|------------------|------------------------------------------------------------------------|
|䮭 ᯥ|                                                                        |
---------------------------------------------------------------------------------------------
=============================================================================================
|   N    |       , , ⢮        |   㬬     |  㬬  㤥ঠ  |
|ࠢ |         ⥫騪           |       室        |                |
|--------|-------------------------------------|---------------------|----------------------|
}
*)

(*
$P{ DLine:
?, L, ""
?, L, ""
?, R, ""
?, R, ""
@
|########|#####################################|#####################|######################|
}
*)

(*
$P{ DBot:
?, R, ""
?, R, ""
?, L, ""
?, L, ""
?, L, ""
@
|----------------------------------------------|---------------------|----------------------|
|⮣                                         |#####################|######################|
=============================================================================================

ᥣ ।⠢ 㬥⮢ ##################

㪮⥫              ____________________ (############################################)

 壠         ____________________ (############################################)
                                ()          (, , ⢮)

                          ..

 ।⠢  
"___"_____________ _____ . __________________ (____________________________________________)
                                ()         (... ⭮ )

 ਭ  
"___"_____________ _____ . __________________ (____________________________________________)
                                ()         (...   ᯥ)
}
*)

(*
$P{ T3Prt_Top:
L_OwnData.ODFirmName(CurPE), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
L_DatTim.YearBeg(CurP), L, "D.N.y"
CurPE, L, "D.N.y"
@
###########################################################################                                                                                                                                  ########## #####
=T3Prt=======================================================================================================================================================================================================================
|                                                                     ⮪ ନ஢ ᢥ  室   ਮ  ##########  ##########                                                                      |
|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|஡:                                                                                                                                                                                                                  |
| 0 - /  裡  室  ਮ                                                                                                                                                               |
| 1 - /                                                                                                                                                                                                  |
| 2 - (ᮢ㯭 室)  ࠢ (-᪨)                                                                                                                                                                          |
| 3 - ( 室)  ࠢ (-᪨-)                                                                                                                                                                   |
|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|  ஡ |   N    |       , , ⢮        |            |            |           室          |              |              |              |              |              |              |              |
|-----------|        |                                     |         |ਮ   |-----------------------------|      室|         |       㬬|       㬬|     㬬|     㬬|      |
| 0| 1| 2| 3|ࠢ |         ⥫騪           |            |            |       |        |              |              |              |              |              |              |              |
|--|--|--|--|--------|-------------------------------------|------------|------------|--------------|--------------|--------------|--------------|--------------|--------------|--------------|--------------|--------------|
}
*)

(*
$P{ T3Prt_Line:
T3PrtErr[00], R, " |0"
T3PrtErr[01], R, " |1"
T3PrtErr[02], R, " |2"
T3PrtErr[03], R, " |3"
FLDTOSTR(Man.Man, "0", 8), L, ""
GetSpecFIO(Man.Name), L, ""
FLDTOSTR(Man.INN, "0"), L, ""
GetRomeStr(1), L, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
@
|##|##|##|##|########|#####################################|############|############|##############|##############|##############|##############|##############|##############|##############|##############|##############|
}
*)

(*
$P{ T3Prt_Bot:
@
=(c) Polak===================================================================================================================================================================================================================
}
*)

 PRIVATE PROCEDURE PacketTitle(PackNum: NUMERIC[0]);
  VAR
  _Value : LIKE(FirmPro.Value);
 BEGIN
  IF ErrCnt # 0 THEN
   AddManSt1("XXXX", 1, 0);
  END;
  FirstFieldInLine:=1;
  AddManSt1(":", 1, 0);
  AddManSt1(IDO+L_DatTim.SysDateTimeStamp(), 1, 0);
  NewLine();
  AddManSt1(":", 1, 0);
  AddManSt1("2000", 1, 0);
  NewLine();
  AddManSt1(":", 1, 0);
  AddManSt1(P_Firm.FP_TaxDepCode(Firm.Firm, SYSDATE()), 1, 0);
  NewLine();
  AddManSt1(":", 1, 0);
  AddManSt1(NAM, 1, 0);
  NewLine();
  AddManSt1(":", 0, 0);
  AddManSt1(P_Firm.FP_AcntPhone(Firm.Firm, SYSDATE()), 0, 0);
  NewLine();
  _Value:=P_Firm.FP_Tax3Sender(Firm.Firm, SYSDATE());
  AddManSt1(":", 0, 0);
  _Value:=Str.Item(_Value, ";", 1);
  AddManSt1(GetSpecFIO(_Value), 0, 0);
  NewLine();
  AddManSt1(":", 0, 0);
  AddManSt1(FLDTOSTR(ManAmou[PackNum], "0"), 0, 0);
  NewLine();
  AddManSt1("@@@", 0, 0);
  NewLine();
  MAKEPART(D, DTit);
 END {PacketTitle};

 PRIVATE PROCEDURE PacketBottom(PackNum: NUMERIC[0]);
 BEGIN
  AddManSt1("===", 0, 0);
  MAKEPART(D, DBot, L_Money.MoneyToStr(CurP, "", TotValInc),
                    L_Money.MoneyToStr(CurP, "", TotPaidTaxC),
                    ManAmou[PackNum],
                    P_Firm.FP_LeadName(Firm.Firm, SYSDATE()),
                    P_Firm.FP_AcntName(Firm.Firm, SYSDATE()));
  FORMFEED(D);
 END {PacketBottom};

 PRIVATE PROCEDURE GetFileExt(): STRING[32];
 BEGIN
  IF ErrCnt = 0 THEN
   RETURN "TXT";
  ELSE
   RETURN "XXT";
  END;
 END {GetFileExt};

 PRIVATE PROCEDURE GetFileName(S: STRING[1]; PackNum: SCAL[MaxPacket]): STRING[32];
 BEGIN
  RETURN Path+S+Str.Slice(INN, 4, 5)+FLDTOSTR(PackNum);
 END {GetFileName};

 PRIVATE PROCEDURE GetPacketNum(): SCAL[MaxPacket];
 BEGIN
  IF ~FictOnly() THEN
   RETURN 1;
  ELSE
   RETURN 9;
  END;
 END {GetPacketNum};

 PRIVATE PROCEDURE MakePBdLine(SErr: STRING[]);
 BEGIN
  MAKEPART(R, BdLine, SErr);
  INC(ErrCnt);
 END {MakePBdLine};

 PRIVATE PROCEDURE AdditionalCheck(): SCAL[2];
  VAR
   Err,
   _Address : STRING[250];
   PrvErrCnt : LIKE(ErrCnt);
 BEGIN
  PrvErrCnt:=ErrCnt;
  IF ~!Man.INN THEN
   IF ~L_Russia.CheckINN(Man.INN) THEN
    MakePBdLine("४ ");
   END;
   L_Man.AccessRgManAdr(Man.Man, CurP);
   IF ~P_Man.HasActualManPro(Man.Man, SYSDATE(), P_Man.P_TaxDep) |
      !ManPro.Value THEN
    MakePBdLine(" 㪠     ⥫⢠");
   END;
  ELSE
   Err:=L_Man.CheckDocument();
   IF ~!Err THEN
    MakePBdLine(Err);
   ELSE
    L_Tax.StandOnManAdrForTax(Man.Man, CurPE);
    Err:=L_Man.GetAdrForTax(_Address);
    IF ~!Err | !_Address THEN
     MakePBdLine(Err);
    ELSIF Str.Length(_Address) > 120 THEN
     MakePBdLine("   120 ᨬ");
    END;
   END;
  END;
  RETURN ErrCnt=PrvErrCnt;
 END {AdditionalCheck};

 PRIVATE PROCEDURE AnyFilesName(S: STRING[5]): STRING[];
 BEGIN
  IF AllMode() THEN
   RETURN Path+S+"_"+FLDTOSTR(L_DatTim.YearBeg(CurP), "Y");
  ELSE
   RETURN L_General.NameConnection(S);
  END;
 END {AnyFilesName};

 PRIVATE PROCEDURE PrepareIndex(All: SCAL[2]);
  VAR
   Cnt,
   PacketNum: SCAL[MaxPacket];
 BEGIN
  OPENREP(R, AnyFilesName("BdAdr"), Create);
  MAKEPART(R, BdTop);
  SETZERO(ManAmou);
  IF All THEN
   SELECT(Man, Man);
  ELSE
   SELECT(Man, Man, , Man.Man (*!!!*));
  END;
  WHILE OCCURE(Man) DO
   SAVE(Man);
   SETZERO(Cnt);
   PROMPT(" "+Man.Man);
   SELECT(Staff, Man, , Man.Man);
   WHILE OCCURE(Staff) DO
    IF L_Staff.IsMainForTax(CurPE) THEN
     L_General.Assert(Cnt=0, "2  ࠪ -   Polak");
     INC(Cnt);
     Type3Result:=TypePart3(0, 1);
     IF    Type3Result = 2 THEN
      MakePBdLine("  室,   ᪨,  ,  ");
     ELSIF Type3Result = 1 THEN
      IF AdditionalCheck() THEN
       IF All THEN
        PacketNum:=GetPacketNum();
       ELSE
        PacketNum:=0;
       END;
       INC(ManAmou[PacketNum]);
       _MN._PacketNum:=PacketNum;
       _MN._Man      :=Man.Man;
       _MN._TSN      :=Staff.TSN;
       INSERT(_MN);
      END;
     END;
    END; (* IF IsMainForTax ... *)
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   RESTORE(Man);
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
  MAKEPART(R, BdBot);
  CLOSEREP(R);
 END {PrepareIndex};

 PRIVATE PROCEDURE Make();
  VAR
   PacketNum: SCAL[MaxPacket];
 BEGIN
  SELECT(_MN, _MN);
  WHILE OCCURE(_MN) DO
   PacketNum:=_MN._PacketNum;
   SETZERO(TotValInc, TotPaidTaxF, TotPaidTaxC);
   CHANGESEL(_MN, _MN, , PacketNum);
   OPENREP(D, GetFileName("R", PacketNum), Create);
   FIO.Open(T, GetFileName("S", PacketNum), GetFileExt(), Create);
   PacketTitle(PacketNum);
   WHILE OCCURE(_MN) DO
    MakeOneMan();
    NEXT(_MN);
   END; (* WHILE OCCURE(_MN)... *)
   PacketBottom(PacketNum);
   CLOSEREP(D);
   FIO.Close(T);
   LAST(_MN);
   CHANGESEL(_MN, _MN);
   NEXT(_MN);
  END; (* WHILE OCCURE(_MN)... *)
 END {Make};

 PRIVATE PROCEDURE MakeAll(All: SCAL[2]);
 BEGIN
  IF ~FIO.DirExists(Path) THEN
   FIO.MkDir(Path);
  END;
  ErrCnt:=0;
  PrepareIndex(All);
  OPENREP(T3Prt, AnyFilesName("T3Prt"), Create);
  MAKEPART(T3Prt, T3Prt_Top);
  Make();
  MAKEPART(T3Prt, T3Prt_Bot);
  CLOSEREP(T3Prt);
  L_Tax.Tax_FreeValues(CurP);
  IF ErrCnt # 0 THEN
   L_StdFrm.Inform("   諨 ࠫ ஢."+
                   "| |ନ஢ 䠩    ᤠ   ᯥ."+
                   "| |室 ࠢ 訡 ( )   ᢥ");
   L_AFM.AF_PurgeTemp("_MN");
   LIKEMENU(Survey, AnyFilesName("BdAdr"));
  END;
 END {MakeAll};

 PRIVATE PROCEDURE CheckPer(withVariants: SCAL[2]);
  VAR
   S: STRING[];
 BEGIN
  S:="  ਮ  "+L_DatTim.DateStr(L_DatTim.YearBeg(CurP))+"  "+L_DatTim.DateStr(CurPE);
  IF withVariants THEN
   S:="|"+S+"||"+"%<    믫⠬ 襩 ࣠樨   >DB"+
            "|" +"%<  믫⠬   >B" +
            "|" +"%<            ⬥               >Z" ;
   _FictOnly:=(STDFORM(S, , STOP) = 2);
  ELSE
   L_StdFrm.Choice(S);
   _FictOnly:=0;
  END;
 END {CheckPer};

 PRIVATE PROCEDURE StandOnMain(D: DATE);
 BEGIN
  SELECT(Staff, Man, , Man.Man);
  WHILE OCCURE(Staff) DO
   IF L_Staff.IsMainForTax(D) THEN
    RETURN;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {StandOnMain};

 PUBLIC PROCEDURE T3_2000(trgMode: tMode);
 BEGIN
  curMode:=trgMode;
  IF (curMode # mode_ToPaper) & (curMode # mode_All) THEN
   L_StdFrm.BlueStop("    ⮣ ਮ");
  END;
  CurP :=Memo.ud_mb();
  CurPE:=Memo.ud_me();
  CheckPer(L_Tax.E_NeedOtherFirmToT3(L_DatTim.YearBeg(CurP)));
  IF ~FictOnly() THEN
   _Firm:=P_Firm.OWN_FIRM;
  ELSE
   _Firm:=P_OwnData.GetOwnDProStrong(CurPE, P_OwnData.P_TradeUnionFirm);
  END;
  L_General.Assert(SEARCH(Firm, Firm, _Firm), " ࠢ筨 ࣠権  ࣠ "+_Firm);
 
  NAM:=Str.Cap(P_Firm.FP_FirmName(_Firm, CurPE));
  INN:=P_Firm.FP_INN(Firm.Firm, CurPE);
  L_General.Assert((Str.Length(INN)=10) & L_Str.TestStrAlowChar(INN, "09"), " ଠ   ࣠樨 "+_Firm);
  KPP:=P_Firm.FP_KPP(Firm.Firm, CurPE);
  L_General.Assert((Str.Length(KPP)= 9) & L_Str.TestStrAlowChar(KPP, "09"), " ଠ   ࣠樨 "+_Firm);
 
  IDO:=INN+"**"+KPP;
 
  L_AFM.MakeIndex("_MN", "_PacketNum: SCAL[50]            ;"+
                         "_Man      : LIKE(Man.Man)       ;"+
                         "_TSN      : LIKE(Staff.TSN)      ");
 
  IF ToPaper() THEN                       (* ଠ 3 *)
   L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
   OPENREP(R, L_General.NameConnection("Tax03"), Create);
  
   L_Staff.CheckCurrentAsMainForTax(CurPE);
  
   CONFORM(Staff, Man);
  
   PROMPT(Man.Man + " : " + Staff.TSN + " - ଠ N3 -  0");
  
   L_General.Assert(L_PRoll.IsDedD(), " ⠭  " + L_DatTim.PeriodStr(CurP));
  
   Type3Result:=TypePart3(1, 1);
   L_Tax.Tax_FreeValues(CurP);
   CLOSEREP(R);
   L_AFM.AF_PurgeTemp("_MN");
   LIKEMENU(Survey, "");
  ELSIF AllMode() THEN
   MakeAll(1);
   L_AFM.AF_PurgeTemp("_MN");
   LIKEMENU(Survey, AnyFilesName("T3Prt"));
  END;
 END {T3_2000};

END.
