(*
%Copyright   (c) Polak Computer System
%Author      23.01.2001 12:16:34 GINA
%Purpose       室  ( ᥬ ;   )
%Type        report
%Specific    SYS
%Modified    19.08.2014 17:14:16 POLAK\Bor
%Environment
*)

 MODULE T3_2001 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_OwnData, L_AFM, L_Str, L_Staff, L_Tax, L_Packet,
        L_Russia, L_Man, L_STx, L_Acnt, L_PRoll, P_Man, P_Firm, L_XObj, L_StdFrm,
        FIO, Math, Str, Memo, L_Env, P_OwnData, P_MyFirm, P_MySite;

 TYPE
  tMode        = SCAL[4];

 CONST
  mode_ToPaper         = 0; (*tMode*)
  mode_ByCurrentPacket = 1;
  mode_ForInq          = 2;
  mode_All             = 3;

 VAR
  CurP, CurPE: DATE;
  Path       : STRING[];
  _FictOnly  : SCAL[2];
  NumInTrFile: NUMERIC[0];
  curMode    : tMode;

 PRIVATE PROCEDURE ToPaper(): SCAL[2];
 BEGIN
  RETURN curMode = mode_ToPaper;
 END {ToPaper};

 PRIVATE PROCEDURE ByCurrentPacket(): SCAL[2];
 BEGIN
  RETURN curMode = mode_ByCurrentPacket;
 END {ByCurrentPacket};

 PRIVATE PROCEDURE MakeForInq(): SCAL[2];
 BEGIN
  RETURN curMode = mode_ForInq;
 END {MakeForInq};

 PRIVATE PROCEDURE AllMode(): SCAL[2];
 BEGIN
  RETURN curMode = mode_All;
 END {AllMode};

 PRIVATE PROCEDURE SubTitle(): STRING[];
 BEGIN
  IF    ToPaper()         THEN RETURN " 㬠 ⥫";
  ELSIF MakeForInq()      THEN RETURN " , 騬 '।  ᪠'";
  ELSIF ByCurrentPacket() THEN RETURN " , 室騬  ⥪騩 ";
  ELSIF AllMode()         THEN RETURN " ᥬ ";
  ELSE
   L_General.CallUs(0);
  END;
 END {SubTitle};

 PRIVATE PROCEDURE DocNum(): STRING[];
 BEGIN
  RETURN FLDTOSTR(Man.Man, "", 6)+"/"+FLDTOSTR(SYSDATE(), "yND")+FLDTOSTR(SYSTIME(), "HM");
 END {DocNum};

 PRIVATE PROCEDURE FictOnly(): SCAL[2];
 BEGIN
  RETURN _FictOnly;
 END {FictOnly};

 PRIVATE PROCEDURE GetNbrStr(N: NUMERIC[2]): STRING[];
  VAR
   S: STRING[];
 BEGIN
  S:=FLDTOSTR(N, "2.", 0);
  L_General.Assert(Str.Length(S) < NbrStrLen, "   ᥫ!   Polak");
  RETURN S;
 END {GetNbrStr};

 PRIVATE PROCEDURE GetNbrStrIntg(N: NUMERIC[2]): STRING[];
  VAR
   S: STRING[];
 BEGIN
  S:=FLDTOSTR(N, "0");
  L_General.Assert(Str.Length(S) < NbrStrLen, "   ᥫ!   Polak");
  RETURN S;
 END {GetNbrStrIntg};

 PRIVATE PROCEDURE GetNbrStrEmpty(N: NUMERIC[2]): STRING[];
  VAR
   S: STRING[];
 BEGIN
  IF N = 0 THEN
   RETURN "";
  ELSE
   S:=FLDTOSTR(N, "2.", 0);
   L_General.Assert(Str.Length(S) < NbrStrLen, "   ᥫ!   Polak");
  END;
  RETURN S;
 END {GetNbrStrEmpty};

 CONST
  NbrStrLen = 14;
  MaxAm     = 08;
  MaxPacket = 50;
  RepDepth  = 90;
  Copyright = " ⮏ (c) Polak";

 TYPE
  tSumsAsStr = STRING[NbrStrLen][12];
  tType3Result = SCAL[10];

 VAR
  NAM,
  INN,
  KPP,
  IDO: STRING[];
  _Firm   : LIKE(Firm.Firm);
  _Limits : NUMERIC[2][12];
  _SovInc : tSumsAsStr;
  _VCode  : LIKE(TaxAdv.VCode)[MaxAm];
  _LCode  : LIKE(TaxAdv.LCode)[MaxAm];
  _AdvInc,
  _LimVal : STRING[NbrStrLen][MaxAm];
  nAdvInc,
  nLimVal : NUMERIC[2][MaxAm];
  ArrIdx  : NUMERIC[0];
  IncToTrnNR,
  IncToTrn: STRING[250];
  TotTaxStx,
  TotValInc,
  TotPaidTax: NUMERIC[2];
  Type3Result: tType3Result;
  ManAmount  : NUMERIC[0];
  ErrCnt  : NUMERIC[0];

  _ValInc,
  _TotInc : NUMERIC[2][12];

  _Town,
  _Village,
  _Street,
  _Block  : STRING[32];

  FirstFieldInLine: SCAL[2];
  NeedSheet2 : SCAL[2];
  LimIncVCode: LIKE(TaxAdv.VCode);
  LimIncArray: NUMERIC[2][12];
  _LimInc : tSumsAsStr;

  LimIncVCode_Sheet2: LIKE(TaxAdv.VCode)[6];
  LimIncArray00_Sheet2,
  LimIncArray01_Sheet2,
  LimIncArray02_Sheet2,
  LimIncArray03_Sheet2,
  LimIncArray04_Sheet2,
  LimIncArray05_Sheet2: NUMERIC[2][12];

  _TaxAdv: LIKE(TaxAdv.TaxAdv);

(*
$P{ Part1:
CurP, L, "y"
DocNum(), L, ""
P_MyFirm.TaxDepCode(L_Packet.PckMyFirm, SYSDATE()), L, ""
INN+"/"+KPP, L, ""
P_Firm.FP_AcntPhone(Firm.Firm, SYSDATE()), L, ""
NAM, L, ""
Man.INN, L, ""
L_Tax.Tax_IsResident(CurPE), L, "2|1"
Man.Name, L, ""
?, L, ""
?, L, ""
?, L, ""
?, L, "D"
?, L, "N"
?, L, "y"
?, L, ""
?, L, ""
?, L, ""
?, L, ""
_Town, L, ""
_Village, L, ""
_Street, L, ""
?, L, ""
_Block, L, ""
?, L, ""
@
================================================================================================================================
|               ࠢ  室 䨧᪮    ####  N | #################### |   ####  |          ଠ 2-|
|                 樠쭮  ()               |                      |              |                      |
|==============================================================================================================================|
|     1      |1.1. / -   ⮢-࣠権 ###################### | 1.2. ⠪ ⥫䮭                |
|------------|      -   ⮢ - 㠫 ।ਭ⥫      |      ##################################|
|     |-----------------------------------------------------------------------------------------------------------------|
|   |1.3.  ࣠樨 / , , ⢮ 㠫쭮 ।ਭ⥫                           |
| -    |#################################################################################################################|
|筨   |-----------------------------------------------------------------------------------------------------------------|
|室      |1.4.           |1.5.                  | 1.6. , , ⢮                                     |
|(- |     ############ |(1-१,2-१) # |      ###########################################################|
|⥫騪 |-----------------------------------------------------------------------------------------------------------------|
|())  |1.7.   㬥,      |      |1.8. ,  㬥      |1.9.          | ᫮ |  |   |
|䨧᪮  |㤮⮢饣 筮      |  ##  |     ########## #######          |     ஦     |   ##  |   ##  | #### |
| -      |-----------------------------------------------------------------------------------------------------------------|
|⥫  |1.10.      |  ࠭ ###     ######     ॣ ##    #####################################|
|室      |ﭭ     | த ##################################### . 㭪 ########################################|
|            | ⥫⢠|  ########################################  ######  ##############  ######|
}
*)


(*
$P{ Part2:
_VCode[0], L, ""
_AdvInc[0], R, ""
_LCode[0], L, ""
_LimVal[0], R, ""
_VCode[4], L, ""
_AdvInc[4], R, ""
_LCode[4], L, ""
_LimVal[4], R, ""
_VCode[1], L, ""
_AdvInc[1], R, ""
_LCode[1], L, ""
_LimVal[1], R, ""
_VCode[5], L, ""
_AdvInc[5], R, ""
_LCode[5], L, ""
_LimVal[5], R, ""
_VCode[2], L, ""
_AdvInc[2], R, ""
_LCode[2], L, ""
_LimVal[2], R, ""
_VCode[6], L, ""
_AdvInc[6], R, ""
_LCode[6], L, ""
_LimVal[6], R, ""
_VCode[3], L, ""
_AdvInc[3], R, ""
_LCode[3], L, ""
_LimVal[3], R, ""
_VCode[7], L, ""
_AdvInc[7], R, ""
_LCode[7], L, ""
_LimVal[7], R, ""
_SovInc[00], R, ""
_SovInc[01], R, ""
_SovInc[02], R, ""
_SovInc[03], R, ""
_SovInc[04], R, ""
_SovInc[05], R, ""
_SovInc[06], R, ""
_SovInc[07], R, ""
_SovInc[08], R, ""
_SovInc[09], R, ""
_SovInc[10], R, ""
_SovInc[11], R, ""
_LimInc[00], R, ""
_LimInc[01], R, ""
_LimInc[02], R, ""
_LimInc[03], R, ""
_LimInc[04], R, ""
_LimInc[05], R, ""
LimIncVCode, L, ""
_LimInc[06], R, ""
_LimInc[07], R, ""
_LimInc[08], R, ""
_LimInc[09], R, ""
_LimInc[10], R, ""
_LimInc[11], R, ""
@
|============|=================================================================================================================|
|室,     | 2 |2.1.         |   |  㬬 室| |  㬬 |   |  㬬 室| |  㬬 |
|뢥  |---|室       |室|              |          |              |室|              |          |              |
|         |13%|      |------|--------------|----------|--------------|------|--------------|----------|--------------|
|। |   |             | #### |##############|   ####   |##############| #### |##############|   ####   |##############|
|   |   |             | #### |##############|   ####   |##############| #### |##############|   ####   |##############|
|,       |   |             | #### |##############|   ####   |##############| #### |##############|   ####   |##############|
|  |   |             | #### |##############|   ####   |##############| #### |##############|   ####   |##############|
|     |   |-------------------------------------------------------------------------------------------------------------|
| ⠢   |   |2.2.         |         |        ࠫ|           |         ५|            |           |
|            |   |室       | ##############| ##############| ##############| ##############| ##############| ##############|
|            |   | 栬   |---------------|---------------|---------------|---------------|---------------|---------------|
|            |   |             |           |         |       |        |         |        |
|            |   |             | ##############| ##############| ##############| ##############| ##############| ##############|
|            |   |-------------------------------------------------------------------------------------------------------------|
|            |   |2.2.1.       |         |        ࠫ|           |         ५|            |           |
|            |   |室       | ##############| ##############| ##############| ##############| ##############| ##############|
|            |   | 栬   |---------------|---------------|---------------|---------------|---------------|---------------|
|            |   |       |           |         |       |        |         |        |
|            |   |室 ####  | ##############| ##############| ##############| ##############| ##############| ##############|
}
*)

(*
$P{ Part21:
_VCode[00], L, ""
_AdvInc[00], R, ""
_VCode[02], L, ""
_AdvInc[02], R, ""
_VCode[04], L, ""
_AdvInc[04], R, ""
_VCode[06], L, ""
_AdvInc[06], R, ""
_VCode[01], L, ""
_AdvInc[01], R, ""
_VCode[03], L, ""
_AdvInc[03], R, ""
_VCode[05], L, ""
_AdvInc[05], R, ""
_VCode[07], L, ""
_AdvInc[07], R, ""
@
|            |   |-------------------------------------------------------------------------------------------------------------|
|            |   |2.3.         |  |         㬬|   |  |         㬬|   |  |         㬬|   |  |         㬬|
|            |   |⠭  |-----|--------------|   |-----|--------------|   |-----|--------------|   |-----|--------------|
|            |   |       | ####|##############|   | ####|##############|   | ####|##############|   | ####|##############|
|            |   |             | ####|##############|   | ####|##############|   | ####|##############|   | ####|##############|
}
*)

(*
$P{ Part3:
?, R, ""
?, R, ""
?, R, ""
?, R, ""
_VCode[0], L, ""
_AdvInc[0], R, ""
_LCode[0], L, ""
_LimVal[0], R, ""
_VCode[2], L, ""
_AdvInc[2], R, ""
_LCode[2], L, ""
_LimVal[2], R, ""
_VCode[1], L, ""
_AdvInc[1], R, ""
_LCode[1], L, ""
_LimVal[1], R, ""
_VCode[3], L, ""
_AdvInc[3], R, ""
_LCode[3], L, ""
_LimVal[3], R, ""
?, R, ""
?, R, ""
?, R, ""
@
|            |   |-------------------------------------------------------------------------------------------------------------|
|            |   |2.4. ᯮ      |2.4.1.          |2.4.2.     |2.4.3. 㬬         |2.4.4. 㬬         |
|            |   |            |         㬬 室|         㬬 室|    ᫥|     㤥ঠ|
|            |   |易⥫         |     ################|     ################|     ################|     ################|
|            |---|-------------------------------------------------------------------------------------------------------------|
|            | 3 |3.1.        |3.1.1.          |3.1.2. 㬬 , |3.1.3. 㬬         |3.1.4. 㬬         |
|            |---|                     |         㬬 室| ਭ     |    ᫥|     㤥ঠ|
|            |30%|                     |                     |                     |                     |                     |
|            |   |---------------------|---------------------------------------------------------------------------------------|
|            |   |3.2. 室          |   |  㬬 室|   |  㬬 |   |  㬬 室|   |  㬬 |
|            |   |१⮢         |室|              ||              |室|              ||              |
|            |   |                     |------|--------------|------|--------------|------|--------------|------|--------------|
|            |   |                     | #### |##############| #### |##############| #### |##############| #### |##############|
|            |   |                     | #### |##############| #### |##############| #### |##############| #### |##############|
|            |   |-------------------------------------------------------------------------------------------------------------|
|            |   |3.2.1. ᯮ    |3.2.1.1.        |                     |3.2.1.2. 㬬       |3.2.1.3. 㬬       |
|            |   |            |         㬬 室|                     |    ᫥|     㤥ঠ|
|            |   |易⥫         |     ################|                     |     ################|     ################|
}
*)

(*
$P{ Part31:
_VCode[0], L, ""
_AdvInc[0], R, ""
_LCode[0], L, ""
_LimVal[0], R, ""
_VCode[2], L, ""
_AdvInc[2], R, ""
_LCode[2], L, ""
_LimVal[2], R, ""
_VCode[1], L, ""
_AdvInc[1], R, ""
_LCode[1], L, ""
_LimVal[1], R, ""
_VCode[3], L, ""
_AdvInc[3], R, ""
_LCode[3], L, ""
_LimVal[3], R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
(L_Str.ShortName(P_Firm.FP_AcntName(Firm.Firm, SYSDATE()))), L, ""
SYSDATE(), L, "D"
SYSDATE(), L, "N" 
SYSDATE(), L, "y" 
SYSTIME(), L, "H:M"
@
|            |---|-------------------------------------------------------------------------------------------------------------|
|            | 4 |4.1.         |   |  㬬 室| |  㬬 |   |  㬬 室| |  㬬 |
|            |---|室       |室|              |          |              |室|              |          |              |
|            |35%|      |------|--------------|----------|--------------|------|--------------|----------|--------------|
|            |   |             | #### |##############|   ####   |##############| #### |##############|   ####   |##############|
|            |   |             | #### |##############|   ####   |##############| #### |##############|   ####   |##############|
|            |   |-------------------------------------------------------------------------------------------------------------|
|            |   |4.2. ᯮ      |4.2.1.          |4.2.2.     |4.2.3. 㬬         |4.2.4. 㬬         |
|            |   |            |         㬬 室|         㬬 室|    ᫥|     㤥ঠ|
|            |   |易⥫         |     ################|     ################|     ################|     ################|
|============|=================================================================================================================|
|     5      |5.1.  㬬            |                     |5.2.  㬬            |                     |
|------------| ᫥:                     |     ################| 㤥ঠ:                      |     ################|
| 㬬 |----------------------------------|---------------------|----------------------------------|---------------------|
|    |5.3. 㬬       |                     |5.4. 㬬, ⥭  㯫  |                     |
|⮣      |  室      |                     |   2001 .,  |                     |
|  |:                              |     ################|  室  :           |     ################|
|ਮ     |----------------------------------|---------------------|----------------------------------|---------------------|
|            |5.5.                  |                     |5.6.                |                     |
|            |  ⥫騪            |     ################|  ⮬                |     ################|
|            |----------------------------------|---------------------|----------------------------------|---------------------|
|            |5.7. 㬬 , ।     |                     |                                  |                     |
|            |  ᪠   ࣠   |     ################|                                  |                     |
|==============================================================================================================================|
|   (⥫騪         |...                               |       | ᫮ |  |   |
| 樠쭮  ())                 |#####################################|⠢|   ##  |   ##  | #### |
=(c) Polak================================================================================================================#####=

  ..
}
*)

(*
$P{ PartSheet2:
CurP, L, "y"
P_MyFirm.TaxDepCode(L_Packet.PckMyFirm, SYSDATE()), L, ""
INN+"/"+KPP, L, ""
LimIncVCode_Sheet2[0], C, ""
LimIncVCode_Sheet2[1], C, ""
LimIncVCode_Sheet2[2], C, ""
LimIncVCode_Sheet2[3], C, ""
LimIncVCode_Sheet2[4], C, ""
LimIncVCode_Sheet2[5], C, ""
GetNbrStrEmpty(LimIncArray00_Sheet2[00]), R, ""
GetNbrStrEmpty(LimIncArray01_Sheet2[00]), R, ""
GetNbrStrEmpty(LimIncArray02_Sheet2[00]), R, ""
GetNbrStrEmpty(LimIncArray03_Sheet2[00]), R, ""
GetNbrStrEmpty(LimIncArray04_Sheet2[00]), R, ""
GetNbrStrEmpty(LimIncArray05_Sheet2[00]), R, ""
GetNbrStrEmpty(LimIncArray00_Sheet2[01]), R, ""
GetNbrStrEmpty(LimIncArray01_Sheet2[01]), R, ""
GetNbrStrEmpty(LimIncArray02_Sheet2[01]), R, ""
GetNbrStrEmpty(LimIncArray03_Sheet2[01]), R, ""
GetNbrStrEmpty(LimIncArray04_Sheet2[01]), R, ""
GetNbrStrEmpty(LimIncArray05_Sheet2[01]), R, ""
GetNbrStrEmpty(LimIncArray00_Sheet2[02]), R, ""
GetNbrStrEmpty(LimIncArray01_Sheet2[02]), R, ""
GetNbrStrEmpty(LimIncArray02_Sheet2[02]), R, ""
GetNbrStrEmpty(LimIncArray03_Sheet2[02]), R, ""
GetNbrStrEmpty(LimIncArray04_Sheet2[02]), R, ""
GetNbrStrEmpty(LimIncArray05_Sheet2[02]), R, ""
GetNbrStrEmpty(LimIncArray00_Sheet2[03]), R, ""
GetNbrStrEmpty(LimIncArray01_Sheet2[03]), R, ""
GetNbrStrEmpty(LimIncArray02_Sheet2[03]), R, ""
GetNbrStrEmpty(LimIncArray03_Sheet2[03]), R, ""
GetNbrStrEmpty(LimIncArray04_Sheet2[03]), R, ""
GetNbrStrEmpty(LimIncArray05_Sheet2[03]), R, ""
GetNbrStrEmpty(LimIncArray00_Sheet2[04]), R, ""
GetNbrStrEmpty(LimIncArray01_Sheet2[04]), R, ""
GetNbrStrEmpty(LimIncArray02_Sheet2[04]), R, ""
GetNbrStrEmpty(LimIncArray03_Sheet2[04]), R, ""
GetNbrStrEmpty(LimIncArray04_Sheet2[04]), R, ""
GetNbrStrEmpty(LimIncArray05_Sheet2[04]), R, ""
GetNbrStrEmpty(LimIncArray00_Sheet2[05]), R, ""
GetNbrStrEmpty(LimIncArray01_Sheet2[05]), R, ""
GetNbrStrEmpty(LimIncArray02_Sheet2[05]), R, ""
GetNbrStrEmpty(LimIncArray03_Sheet2[05]), R, ""
GetNbrStrEmpty(LimIncArray04_Sheet2[05]), R, ""
GetNbrStrEmpty(LimIncArray05_Sheet2[05]), R, ""
GetNbrStrEmpty(LimIncArray00_Sheet2[06]), R, ""
GetNbrStrEmpty(LimIncArray01_Sheet2[06]), R, ""
GetNbrStrEmpty(LimIncArray02_Sheet2[06]), R, ""
GetNbrStrEmpty(LimIncArray03_Sheet2[06]), R, ""
GetNbrStrEmpty(LimIncArray04_Sheet2[06]), R, ""
GetNbrStrEmpty(LimIncArray05_Sheet2[06]), R, ""
GetNbrStrEmpty(LimIncArray00_Sheet2[07]), R, ""
GetNbrStrEmpty(LimIncArray01_Sheet2[07]), R, ""
GetNbrStrEmpty(LimIncArray02_Sheet2[07]), R, ""
GetNbrStrEmpty(LimIncArray03_Sheet2[07]), R, ""
GetNbrStrEmpty(LimIncArray04_Sheet2[07]), R, ""
GetNbrStrEmpty(LimIncArray05_Sheet2[07]), R, ""
GetNbrStrEmpty(LimIncArray00_Sheet2[08]), R, ""
GetNbrStrEmpty(LimIncArray01_Sheet2[08]), R, ""
GetNbrStrEmpty(LimIncArray02_Sheet2[08]), R, ""
GetNbrStrEmpty(LimIncArray03_Sheet2[08]), R, ""
GetNbrStrEmpty(LimIncArray04_Sheet2[08]), R, ""
GetNbrStrEmpty(LimIncArray05_Sheet2[08]), R, ""
GetNbrStrEmpty(LimIncArray00_Sheet2[09]), R, ""
GetNbrStrEmpty(LimIncArray01_Sheet2[09]), R, ""
GetNbrStrEmpty(LimIncArray02_Sheet2[09]), R, ""
GetNbrStrEmpty(LimIncArray03_Sheet2[09]), R, ""
GetNbrStrEmpty(LimIncArray04_Sheet2[09]), R, ""
GetNbrStrEmpty(LimIncArray05_Sheet2[09]), R, ""
GetNbrStrEmpty(LimIncArray00_Sheet2[10]), R, ""
GetNbrStrEmpty(LimIncArray01_Sheet2[10]), R, ""
GetNbrStrEmpty(LimIncArray02_Sheet2[10]), R, ""
GetNbrStrEmpty(LimIncArray03_Sheet2[10]), R, ""
GetNbrStrEmpty(LimIncArray04_Sheet2[10]), R, ""
GetNbrStrEmpty(LimIncArray05_Sheet2[10]), R, ""
GetNbrStrEmpty(LimIncArray00_Sheet2[11]), R, ""
GetNbrStrEmpty(LimIncArray01_Sheet2[11]), R, ""
GetNbrStrEmpty(LimIncArray02_Sheet2[11]), R, ""
GetNbrStrEmpty(LimIncArray03_Sheet2[11]), R, ""
GetNbrStrEmpty(LimIncArray04_Sheet2[11]), R, ""
GetNbrStrEmpty(LimIncArray05_Sheet2[11]), R, ""
P_MyFirm.NumInPFR(L_Packet.PckMyFirm, CurPE), L, ""
L_Man.GetManSINumber_asStr(), L, ""
?, R, "2."
?, R, "2."
?, R, "2."
?, R, "2."
?, R, "2."
?, R, "2."
?, R, "2."
?, R, "2."
(L_Str.ShortName(P_Firm.FP_AcntName(Firm.Firm, SYSDATE()))), L, ""
SYSDATE(), L, "D"
SYSDATE(), L, "N" 
SYSDATE(), L, "y" 
SYSTIME(), L, "H:M"
@
========================================================================================================================= 2=
| ࠢ  室 䨧᪮    樠쭮  ()  ####  N |           |   #### | ଠ 2-|
|==============================================================================================================================|
|     1      |1.1. / -   ⮢-࣠権 ######################                                          |
|            |      -   ⮢ - 㠫 ।ਭ⥫                                               |
|------------|-----------------------------------------------------------------------------------------------------------------|
|     2      |\  室| ##############| ##############| ##############| ##############| ##############| ##############|
|------------|-----------------|---------------|---------------|---------------|---------------|---------------|---------------|
|室      |           | ##############| ##############| ##############| ##############| ##############| ##############|
| 栬  |-----------------|---------------|---------------|---------------|---------------|---------------|---------------|
|            |ࠫ          | ##############| ##############| ##############| ##############| ##############| ##############|
|            |-----------------|---------------|---------------|---------------|---------------|---------------|---------------|
|            |             | ##############| ##############| ##############| ##############| ##############| ##############|
|            |-----------------|---------------|---------------|---------------|---------------|---------------|---------------|
|            |५           | ##############| ##############| ##############| ##############| ##############| ##############|
|            |-----------------|---------------|---------------|---------------|---------------|---------------|---------------|
|            |              | ##############| ##############| ##############| ##############| ##############| ##############|
|            |-----------------|---------------|---------------|---------------|---------------|---------------|---------------|
|            |             | ##############| ##############| ##############| ##############| ##############| ##############|
|            |-----------------|---------------|---------------|---------------|---------------|---------------|---------------|
|            |             | ##############| ##############| ##############| ##############| ##############| ##############|
|            |-----------------|---------------|---------------|---------------|---------------|---------------|---------------|
|            |           | ##############| ##############| ##############| ##############| ##############| ##############|
|            |-----------------|---------------|---------------|---------------|---------------|---------------|---------------|
|            |         | ##############| ##############| ##############| ##############| ##############| ##############|
|            |-----------------|---------------|---------------|---------------|---------------|---------------|---------------|
|            |          | ##############| ##############| ##############| ##############| ##############| ##############|
|            |-----------------|---------------|---------------|---------------|---------------|---------------|---------------|
|            |           | ##############| ##############| ##############| ##############| ##############| ##############|
|            |-----------------|---------------|---------------|---------------|---------------|---------------|---------------|
|            |          | ##############| ##############| ##############| ##############| ##############| ##############|
|------------|-----------------------------------------------------------------------------------------------------------------|
|     3      |室,  ஬  ᮮ⢥⢨|             | 室|  㬬 室| |  㬬 |             |
|------------| ⥫⢮ ꥪ   |             |----------|--------------|----------|--------------|             |
|            |।⠢ 죮           |             |          |              |          |              |             |
|------------|-----------------------------------------------------------------------------------------------------------------|
|     4      |室, 祭  த    |             | 室|  㬬 室| 室|  㬬 室|             |
|------------|⢠                        |             |----------|--------------|----------|--------------|             |
|            |                                 |             |          |              |          |              |             |
|------------|-----------------------------------------------------------------------------------------------------------------|
|     5      |5.1. 樮  -|##################|5.2. 客 ᢨ⥫⢠   |#################|
|            | ⥫騪  ()           |                  | 䨧᪮ -⥫ 室|                 |
|------------|------------------------------------------------------------------------------------------------------------------
|5.3.|5.3.1. ᨮ 䮭               |                  |
|  | ᨩ᪮ 樨                |  ################|
|  -|-------------------------------------|------------------|
|᫥ |5.3.2.  樠쭮              |                  |
|     | 客 ᨩ᪮ 樨    |  ################|
|樠쭮 |-------------------------------------|------------------|
|      |5.3.3. ࠫ 䮭 易⥫쭮|                  |
|()    | 樭᪮ 客        |  ################|
|            |-------------------------------------|------------------|
|            |5.3.4. ਠ 䮭 易-   |                  |
|            | ⥫쭮 樭᪮ 客   |  ################|
|------------|--------------------------------------------------------|
|     6      |6.1. ᨮ 䮭                 |                  |
|------------| ᨩ᪮ 樨                |  ################|
|  |-------------------------------------|------------------|
|᫥ |6.2.  樠쭮                |                  |
|㬬   | 客 ᨩ᪮ 樨    |  ################|
|            |-------------------------------------|------------------|
|            |6.3. ࠫ 䮭 易⥫-     |                  |
|            | 樭᪮ 客        |  ################|
|            |-------------------------------------|------------------|
|            |6.4. ਠ 䮭 易-     |                  |
|            | ⥫쭮 樭᪮ 客   |  ################|
|==============================================================================================================================|
|   (⥫騪         |...                               |       | ᫮ |  |   |
| 樠쭮  ())                 |#####################################|⠢|   ##  |   ##  | #### |
=(c) Polak================================================================================================================#####=

  ..}
*)

(*
$P{ BdTop:
NAM, L, ""
SYSDATE(), L, "D.N.Y"
SYSTIME(), L, "H:M"
@
############################################################### ######## #####
=BdAdr========================================================================
|                       祭  ᢥ  室                      |
|----------------------------------------------------------------------------|
|᪮ |稭                                                     |
|---------------|------------------------------------------------------------|
}
*)

(*
$P{ BdLine:
Man.Man, L, ""
?, L, ""
@
|###############|############################################################|
}
*)

(*
$P{ BdBot:
ErrCnt, R, "0"
@
|----------------------------------------------------------------------------|
|⮣ #### 䨧᪨                                                    |
=(c) Polak====================================================================
}
*)

 VAR
  PacketNumberStr,
  MakedFileName: STRING[][MaxPacket+2];
  PacketInserted,
  MakedFiles,
  ErrFileIdx   :NUMERIC[0];

 PRIVATE PROCEDURE CreateANYFile(IsRepFile: SCAL[2]; Alias, Name: STRING[]);
 BEGIN
  IF IsRepFile THEN
   OPENREP(^Alias, Name, Create);
  ELSE
   IF ~ToPaper() & FIO.Exists(Name) THEN
    L_StdFrm.Choice("!  " + Name + "|㦥 !");
   END;
   FIO.Open(^Alias, Name, "", Create);
  END;
  MakedFileName[MakedFiles]:=FIO.FullPath(FIO.FirstPath(Name));
  INC(MakedFiles);
 END {CreateANYFile};

 PRIVATE PROCEDURE HasInStateJMode(P: DATE): SCAL[2];
 BEGIN
  SELECT(Sheet, TSN, , Staff.TSN, P);
  WHILE OCCURE(Sheet) DO
   CONFORM(Sheet, JMode);
   IF JMode.InFirm THEN
    RETURN 1;
   END;
   NEXT(Sheet);
  END; (* WHILE OCCURE(Sheet)... *)
  RETURN 0;
 END {HasInStateJMode};

 PRIVATE PROCEDURE GetRomeStr(El: SCAL[2]): STRING[];
  VAR
   ye,
   no,
   S      : STRING[];
   W      : SCAL[2][12];
   P      : DATE;
   i      : SCAL[13];
 BEGIN
  ye:="01  ,02  ,03  ,04  ,05  ,06  ,07  ,08  ,09  ,10  ,11  ,12";
  no:="__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__  ,__";
  SETZERO(W);
  SAVE(Staff);
  SELECT(Staff, MyFirm, , L_Packet.PckMyFirm, Man.Man);
  WHILE OCCURE(Staff) DO P:=L_DatTim.YearBeg(CurP);
   WHILE P <= CurP DO
    IF (~FictOnly() & L_Staff.IsWorking(P) & HasInStateJMode(P)) | (_ValInc[L_DatTim.MONTH(P)]#0) THEN
     W[L_DatTim.MONTH(P)]:=1;
    END;
    P:=L_DatTim.IncMonth(P, +1);
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  RESTORE(Staff);
  i:=0; SETEMPTY(S);
  WHILE i < 12 DO
   IF W[i] THEN
    IF El THEN
     S:=S + "1";
    ELSE
     S:=S + Str.Item(ye, ",", i);
    END;
   ELSE
    IF El THEN
     S:=S + "0";
    ELSE
     S:=S + Str.Item(no, ",", i);
    END;
   END;
   INC(i);
  END;
  RETURN S;
 END {GetRomeStr};

 PRIVATE PROCEDURE MoneyToTrn(N: NUMERIC[2]): STRING[];
 BEGIN
  RETURN FLDTOSTR(N, "2.", 0);
 END {MoneyToTrn};

 PRIVATE PROCEDURE MoneyToTrnIntg(N: NUMERIC[2]): STRING[];
 BEGIN
  RETURN FLDTOSTR(N, "0", 0);
 END {MoneyToTrnIntg};

 PRIVATE PROCEDURE TypePart1();
  VAR
   S,
   tmp     : STRING[];
 BEGIN
  PROMPT(Man.Man + " : " + Staff.TSN + " - ଠ N3 -  1");

  IF !Man.INN THEN

   L_Tax.StandOnManAdrForTax(Man.Man, CurPE);
   tmp:=L_Man.GetAdrForTax(S);
   IF ~!tmp THEN
    L_General.Error(tmp);
   END;
   L_Man.PrepareManAdressForTax_37(CurPE, _Town, _Village, _Street, _Block);
   MAKEPART(R, Part1, L_Man.GetManDocCode(Man.DocType), Man.PspSer, Man.PspNbr,
                      Man.Birth, Man.Birth, Man.Birth,
                      ManAdr.Country, ManAdr.Zip, ManAdr.Region, ManAdr.Distr,
                      ManAdr.House, ManAdr.Flat);
  ELSE
   SETEMPTY(_Village, _Street, _Block, _Town);
   MAKEPART(R, Part1, "");
  END;
 END {TypePart1};

 PRIVATE PROCEDURE PrepareToPrint(NeedLim, WithLimOnly: SCAL[2]);
  VAR i: NUMERIC[0];
 BEGIN
  i:=0; SETEMPTY(IncToTrn, IncToTrnNR);
  WHILE ~!_VCode[i] DO
   IF ~!IncToTrn THEN
    IncToTrn:=IncToTrn+";";
   END;
   IF ~!IncToTrnNR THEN
    IncToTrnNR:=IncToTrnNR+";";
   END;
   _AdvInc[i]:=GetNbrStr(nAdvInc[i]);
   IF ~WithLimOnly | ~!_LCode[i] THEN
    IncToTrn:=IncToTrn+_VCode[i]+","+MoneyToTrn(nAdvInc[i]);
   END;
   IncToTrnNR:=IncToTrnNR+_VCode[i]+","+MoneyToTrn(nAdvInc[i]);
   IF NeedLim THEN
    IF ~!_LCode[i] THEN
     _LimVal[i]:=GetNbrStr(nLimVal[i]);
     IncToTrn:=IncToTrn+","+_LCode[i]+","+MoneyToTrn(nLimVal[i]);
    ELSIF ~WithLimOnly THEN
     IncToTrn:=IncToTrn+","+"0"+","+MoneyToTrn(0);
    END;
   END;
   INC(i);
  END;
  IncToTrn:=Str.Condense(IncToTrn);
  IncToTrnNR:=Str.Condense(IncToTrnNR);
 END {PrepareToPrint};

 PRIVATE PROCEDURE InitArr();
 BEGIN
  SETEMPTY(_VCode, _LCode, _AdvInc, _LimVal, LimIncVCode);
  SETZERO(ArrIdx, nAdvInc, nLimVal, NeedSheet2, LimIncArray);
 END {InitArr};

 PRIVATE PROCEDURE GetIdx(__VCode: LIKE(TaxAdv.VCode)): NUMERIC[0];
  VAR i: NUMERIC[0];
 BEGIN
  IF ~!__VCode THEN
   i:=0;
   WHILE i < ArrIdx DO
    IF ~!_VCode[i] & (_VCode[i] = __VCode) THEN
     RETURN i;
    END;
    INC(i);
   END;
   RETURN i;
  ELSE
   RETURN ArrIdx;
  END;
 END {GetIdx};

 PRIVATE PROCEDURE SetDataForPart2(__VCode, __LCode: LIKE(TaxAdv.VCode); __AdvInc, __LimVal: NUMERIC[2]);
  VAR Idx: NUMERIC[0];
 BEGIN
  IF (__AdvInc # 0) | (__LimVal # 0) THEN
   IF __VCode[0] = "0" THEN
    __VCode:=Str.Delete(__VCode, 0, 1);
   END;
   L_General.Assert(~!__VCode | ~!__LCode, "  㪠  室   ᪨");
   Idx:=GetIdx(__VCode);
   IF Idx < ArrIdx THEN
    IF ~!_LCode[Idx] THEN
     L_General.Assert(~!__LCode & (__LCode=_LCode[Idx]), " ᮢ  ᪨| 室 "+__VCode);
    END;
    INC(nAdvInc[Idx], __AdvInc);
    INC(nLimVal[Idx], __LimVal);
   ELSE
    IF ~!__VCode THEN
     _VCode[Idx]:=__VCode;
    END;
    IF ~!__LCode THEN
     L_General.Assert(~!__VCode, "  㪠  室| ᪨ "+__LCode);
     _LCode[Idx]:=__LCode;
    ELSE
     L_General.Assert(__LimVal = 0, "  㪠  ᪨| 室 "+__VCode);
    END;
    nAdvInc[Idx]:=__AdvInc;
    nLimVal[Idx]:=__LimVal;
    INC(ArrIdx);
   END;
  END; (* IF (__AdvInc # 0)... *)
 END {SetDataForPart2};

 PRIVATE PROCEDURE Set_Limits(_AdvInc: NUMERIC[2][12]; LimVal: NUMERIC[2]);
  VAR i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE (LimVal > 0) & (i < 12) DO
   IF _AdvInc[i] > 0 THEN
    IF _AdvInc[i] >= LimVal THEN
     INC(_Limits[i], LimVal);
    ELSE
     INC(_Limits[i], _AdvInc[i]);
    END;
    DEC(LimVal, _AdvInc[i]);
   END;
   INC(i);
  END; (* WHILE i < ... *)
 END {Set_Limits};

 PRIVATE PROCEDURE AddArr(VAR Dst: NUMERIC[2][12]; Src: NUMERIC[2][12]);
  VAR
   i: SCAL[12];
 BEGIN
  FOR_EACH i DO
   INC(Dst[i], Src[i]);
  END;
 END {AddArr};

 PRIVATE PROCEDURE OneTAReason(_MdfType: LIKE(TaxAdv.Reason); VAR AdvInc: NUMERIC[2][12]; VAR Tot: NUMERIC[2]; _LCode: LIKE(TaxAdv.LCode));
  VAR
   EstArr,
   _AdvInc : NUMERIC[2][12];
   Dummy,
   LimVal  : NUMERIC[2];
   i       : NUMERIC[0];
   _VCode_ : LIKE(TaxAdv.VCode);
   _LCode_ : LIKE(TaxAdv.VCode);
   IncLimNbr: NUMERIC[0];
 BEGIN
  IncLimNbr:=0;
  SELECT(_MnTA, _MnTA, , Man.Man, _MdfType);
  WHILE OCCURE(_MnTA) DO
   SAVE(_MnTA);
   L_Tax.Tax_AccessManTA_by_MnTA();
   CONFORM(ManTA, TaxAdv);
   SETZERO(_AdvInc, LimVal);
   IF L_Tax.Tax2001__GetOneTaxAdv(CurP, CurP, _MdfType, TaxAdv.TaxAdv, _AdvInc, LimVal, 0) THEN
    AddArr(AdvInc, _AdvInc);
    IF _MdfType = L_Tax.Tax2001_mt_Inc THEN
     IF TaxAdv.TaxAdv = 30(*Tax2001__oc_NYInc*) THEN
      _VCode_:=L_Tax.Tax2001_PureIncomVCode;
     ELSE
      _VCode_:=TaxAdv.VCode;
     END;
     _LCode_:=L_Tax.Tax2001_taGetLCode();
     INC(Tot, LimVal);
     SetDataForPart2(_VCode_, _LCode_, L_Tax.Tax2001_GetArrSum(_AdvInc), LimVal);
     IF ~!_LCode_ THEN
      Set_Limits(_AdvInc, LimVal);
      INC(IncLimNbr);
      IF IncLimNbr > 1 THEN
       LimIncVCode_Sheet2[IncLimNbr-1]:=TaxAdv.VCode;
       IF    IncLimNbr = 2 THEN
        AddArr(LimIncArray01_Sheet2, _AdvInc);
       ELSIF IncLimNbr = 3 THEN
        AddArr(LimIncArray02_Sheet2, _AdvInc);
       ELSIF IncLimNbr = 4 THEN
        AddArr(LimIncArray03_Sheet2, _AdvInc);
       ELSIF IncLimNbr = 5 THEN
        AddArr(LimIncArray04_Sheet2, _AdvInc);
       ELSIF IncLimNbr = 6 THEN
        AddArr(LimIncArray05_Sheet2, _AdvInc);
       ELSE
        L_General.Error("誮   室");
       END;
       NeedSheet2:=1;
       SETEMPTY(LimIncVCode, LimIncArray);
      ELSE
       LimIncVCode:=TaxAdv.VCode;
       AddArr(LimIncArray, _AdvInc);
       LimIncVCode_Sheet2[0]:=TaxAdv.VCode;
       AddArr(LimIncArray00_Sheet2, _AdvInc);
      END;
     END;
    ELSE       (**)
     Dummy:=L_Tax.Tax2001_GetArrSum(_AdvInc);
     SetDataForPart2(TaxAdv.VCode,     "", Dummy, 0);
     INC(Tot, Dummy);
    END;
   END; (* IF Tax2001__GetOneTaxAdv ... *)
   RESTORE(_MnTA);
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType, _MnTA._TaxAdv);
   LAST(_MnTA);
   CHANGESEL(_MnTA, _MnTA, , _MnTA._Man, _MnTA._MdfType);
   NEXT(_MnTA);
  END; (* WHILE OCCURE(_MnTA) ... *)
 END {OneTAReason};

 PRIVATE PROCEDURE GetPurInc(VAR _PurInc: NUMERIC[2][12]; __VCode:LIKE(TaxAdv.VCode));
  VAR PurInc: NUMERIC[2];
 BEGIN
  SETZERO(_PurInc);
  IF ~FictOnly() THEN
   L_Tax.Tax2001_GetPureIncome(CurP, _PurInc);
   PurInc:=L_Tax.Tax2001_GetArrSum(_PurInc);
   IF PurInc # 0 THEN
    SetDataForPart2(__VCode, "", PurInc, 0);
   END;
  END;
 END {GetPurInc};

 PRIVATE PROCEDURE AddManStr(s1: STRING[]; IsString: SCAL[2]; NeedZpt: SCAL[2]);
 BEGIN
  IF NeedZpt & ~FirstFieldInLine THEN
   FIO.WrStr(T, ',');
  END;
  FirstFieldInLine:=0;
  IF ~!s1 THEN
   FIO.WrStr(T, Str.Condense(s1));
  END;
 END {AddManStr};

 PRIVATE PROCEDURE ExclNegInc(VAR Array: NUMERIC[2][]);
  VAR
   i,
   j: NUMERIC[0];
 BEGIN
  IF L_Tax.Tax2001_GetArrSum(Array) > 0 THEN
   i:=HIGH(Array);
   WHILE i >= 0 DO
    IF Array[i] < 0 THEN
     j:=i;
     WHILE j >= 0 DO
      IF Array[j]+Array[i] >= 0 THEN
       INC(Array[j], Array[i]);
       Array[i]:=0;
      END;
      DEC(j);
     END;
    END;
    DEC(i);
   END;
   i:=0;
   WHILE i <= HIGH(Array) DO
    IF Array[i] < 0 THEN
     j:=i;
     WHILE j <= HIGH(Array) DO
      IF Array[j]+Array[i] >=0 THEN
       INC(Array[i+1], Array[i]);
       Array[i]:=0;
      END;
      INC(j);
     END;
    END;
    INC(i);
   END;
  END;
 END {ExclNegInc};

 PRIVATE PROCEDURE PutOneStrNotZero(NameStr: STRING[]; N: NUMERIC[2]; Intg: SCAL[2]);
 BEGIN
  IF N#0 THEN
   AddManStr(NameStr, 0, 0);
   IF Intg THEN
    AddManStr(MoneyToTrnIntg(N), 0, 0);
   ELSE
    AddManStr(MoneyToTrn    (N), 0, 0);
   END;
   NewLine();
  END;
 END {PutOneStrNotZero};

 PRIVATE PROCEDURE GetOneVCode_Sheet2(VAR S: STRING[]; _VCode: STRING[]; _LimInc: NUMERIC[2]);
  VAR
   tmp: STRING[];
 BEGIN
  tmp:=GetNbrStrEmpty(_LimInc);
  IF ~!tmp THEN
   IF ~!S THEN
    S:=S+",";
   END;
   S:=S+_VCode+","+tmp
  END;
  RETURN S;
 END {GetOneVCode_Sheet2};

 PRIVATE PROCEDURE RoundToNumeric2(N: NUMERIC[2]): NUMERIC[2];
 BEGIN
  RETURN N;
 END {RoundToNumeric2};

 PRIVATE PROCEDURE Get_Stx(VAR _TaxBasePFR, _TaxBaseFSS, _TaxBaseFFOMS, _TaxBaseTFOMS,
                       _TaxPFR, _TaxFSS, _TaxFFOMS, _TaxTFOMS: NUMERIC[2]);
  VAR
   _TaxBaseStx: NUMERIC[2]; (*  : ꥪ    饥 *)
 BEGIN
  SETZERO(_TaxBaseStx,
          _TaxBasePFR, _TaxBaseFSS, _TaxBaseFFOMS, _TaxBaseTFOMS,
          _TaxPFR, _TaxFSS, _TaxFFOMS, _TaxTFOMS);

  SETSEL(XCalc, XObjDate, L_STx.GetManXObject(Man.Man, L_Packet.PckMyFirm));
  SRCINSEL(XCalc, GE, , L_DatTim.YearBeg(CurP));
  WHILE OCCURE(XCalc) DO
   SELECT(XApport, XObject, , XCalc.XObject, XCalc.AcCut, XCalc.XDat);
   WHILE OCCURE(XApport) & (XApport.XDat<=CurPE) DO
    CONFORM(XApport, Apport);
    IF Apport.CirType = L_Acnt.ct_Credit THEN
     IF    (XApport.AcCut = L_STx.STx_TotAcCut) |
           (XApport.AcCut = L_STx.STx_ExlAcCut)  THEN
      INC(_TaxBaseStx, XApport.Sum);
     ELSIF (XApport.AcCut = L_STx.STx_GetPoBAcCut(L_STx.stxp_PFRF)) |
           (XApport.AcCut = L_STx.STx_GetBnfAcCut(L_STx.stxp_PFRF)) THEN
      INC(_TaxBasePFR, XApport.Sum);
     ELSIF (XApport.AcCut = L_STx.STx_GetPoBAcCut(L_STx.stxp_SSRF)) |
           (XApport.AcCut = L_STx.STx_GetBnfAcCut(L_STx.stxp_SSRF)) THEN
      INC(_TaxBaseFSS, XApport.Sum);
     ELSIF (XApport.AcCut = L_STx.STx_GetPoBAcCut(L_STx.stxp_MSFF)) |
           (XApport.AcCut = L_STx.STx_GetBnfAcCut(L_STx.stxp_MSFF)) THEN
      INC(_TaxBaseFFOMS, XApport.Sum);
     ELSIF (XApport.AcCut = L_STx.STx_GetPoBAcCut(L_STx.stxp_MSTF)) |
           (XApport.AcCut = L_STx.STx_GetBnfAcCut(L_STx.stxp_MSTF)) THEN
      INC(_TaxBaseTFOMS, XApport.Sum);
     ELSIF XApport.AcCut = L_STx.STx_GetTaxAcCut(L_STx.stxp_PFRF) THEN
      INC(_TaxPFR, XApport.Sum);
     ELSIF XApport.AcCut = L_STx.STx_GetTaxAcCut(L_STx.stxp_SSRF) THEN
      INC(_TaxFSS, XApport.Sum);
     ELSIF XApport.AcCut = L_STx.STx_GetTaxAcCut(L_STx.stxp_MSFF) THEN
      INC(_TaxFFOMS, XApport.Sum);
     ELSIF XApport.AcCut = L_STx.STx_GetTaxAcCut(L_STx.stxp_MSTF) THEN
      INC(_TaxTFOMS, XApport.Sum);
     END;
    END; (* IF Apport.CirType = ... *)
    NEXT(XApport);
   END; (* WHILE OCCURE(XApport) ... *)
   NEXT(XCalc);
  END; (* WHILE OCCURE(XCalc) ... *)
  _TaxBasePFR  :=_TaxBasePFR+_TaxBaseStx;
  _TaxBaseFSS  :=_TaxBaseFSS+_TaxBaseStx;
  _TaxBaseFFOMS:=_TaxBaseFFOMS+_TaxBaseStx;
  _TaxBaseTFOMS:=_TaxBaseTFOMS+_TaxBaseStx;
 END {Get_Stx};

 PRIVATE PROCEDURE InitSheet2Arr();
 BEGIN
  SETEMPTY(LimIncVCode_Sheet2);
  SETZERO (LimIncArray00_Sheet2,
           LimIncArray01_Sheet2,
           LimIncArray02_Sheet2,
           LimIncArray03_Sheet2,
           LimIncArray04_Sheet2,
           LimIncArray05_Sheet2);
 END {InitSheet2Arr};

 VAR
  T3PrtErr: SCAL[2][10];

 PRIVATE PROCEDURE TypePart3(WithPrint: SCAL[2]; NeedInit: SCAL[2]): tType3Result;
  VAR
   RetnTax,
   PaidTax,
   EnfTax,
   ClcByThirdScaleTax,
   ClcTax,
   ToTax : NUMERIC[2];
   Dummy,
   _PurInc,
   _PurInc1,
   _PurInc2: NUMERIC[2][12];
   ValInc,
   TotLim,
   LimVal,
   TotInc,
   TotDec  : NUMERIC[2];
   i       : NUMERIC[0];
   tmp,
   LimIncStr,
   IncomeByMonthsAsStr: STRING[];
   HasIncomeByMonthsAsStr,
   HasLimIncStr: SCAL[2];
   _Dummy  : NUMERIC[2];
   _MainScale: L_Tax.tTax2001_ScalesType;
   msValInc, msToTax,
   msClcTax, msPaidTax,
   ssValInc,
   ssClcTax, ssPaidTax,
   tsValInc, tsToTax,
   tsClcTax, tsPaidTax: STRING[];
   OverTax,
   DbtTax,
   CrdTax  : NUMERIC[2];
   TotnAdvInc,
   TotnLimVal: NUMERIC[2];
   TaxBaseStx, TaxStx,
   TaxBasePFR, TaxBaseFSS, TaxBaseFFOMS, TaxBaseTFOMS,
   TaxPFR,     TaxFSS,     TaxFFOMS,     TaxTFOMS: NUMERIC[2];
 BEGIN
  IF WithPrint THEN
   PROMPT(Man.Man + " : " + Staff.TSN + " - ଠ N3 -  2");
  END;

  IF NeedInit THEN
   L_Tax.Tax2001__InitValues(CurP, FictOnly());
  ELSE
   L_Tax.Tax_FillManIsWorking(CurP);
  END;

  _MainScale:=L_Tax.Tax_GetScaleForMainScale(CurP);
  InitArr();
  L_Tax.SetTax2001_ScaleToGather(_MainScale);
  SETZERO(TotLim, _PurInc1, _Limits, _TotInc, _ValInc);
  SETZERO(OverTax, DbtTax, RetnTax);
  SETEMPTY(_SovInc, _LimInc);
  InitSheet2Arr();
  SETZERO (TotnAdvInc, TotnLimVal);
 
  IF _MainScale = L_Tax.Tax2001_MainScale THEN
   GetPurInc(_PurInc, L_Tax.Tax2001_PureIncomVCode);
   OneTAReason(L_Tax.Tax2001_mt_Inc, _PurInc1, TotLim, "");

   PrepareToPrint(1, 0);
   i:=0;
   WHILE i <= 11 DO
    _ValInc[i]:=_PurInc[i] + _PurInc1[i];
    _TotInc[i]:=_ValInc[i] - _Limits[i];
    INC(i);
   END;
   INC(TotnAdvInc, L_Tax.Tax2001_GetArrSum(nAdvInc));
   INC(TotnLimVal, L_Tax.Tax2001_GetArrSum(nLimVal));
 
   ExclNegInc(_TotInc);

   i:=0;
   SETEMPTY(IncomeByMonthsAsStr);
   LimIncStr:=LimIncVCode+",";
   SETZERO(HasLimIncStr, HasIncomeByMonthsAsStr);
   WHILE i <= 11 DO
    _SovInc[i]:=GetNbrStr(_TotInc[i]);
    IF ~!LimIncArray[i] THEN
     _LimInc[i]:=GetNbrStr(LimIncArray[i]);
     LimIncStr:=LimIncStr+_LimInc[i];
     HasLimIncStr:=HasLimIncStr | (LimIncArray[i]#0);
    END;
    IncomeByMonthsAsStr:=IncomeByMonthsAsStr+MoneyToTrn(_TotInc[i]);
    HasIncomeByMonthsAsStr:=HasIncomeByMonthsAsStr | (_TotInc[i]#0);
    IF i < 11 THEN
     IncomeByMonthsAsStr:=IncomeByMonthsAsStr+",";
     LimIncStr:=LimIncStr+",";
    END;
    INC(i);
   END;
  END;

  L_General.Assert(TotLim = L_Tax.Tax2001_GetArrSum(_Limits), "Error 23455");

  IF WithPrint THEN
   IF ToPaper() THEN
    TypePart1();
    MAKEPART(R, Part2);
   ELSE
    IF (_MainScale = L_Tax.Tax2001_MainScale) THEN
     IF ~!IncToTrn THEN
      AddManStr("室:", 0, 0);
      AddManStr(IncToTrn, 0, 0);
      NewLine();
     END;
     IF HasIncomeByMonthsAsStr | ~!IncToTrn THEN
      AddManStr("室:", 0, 0);
      AddManStr(IncomeByMonthsAsStr, 0, 0);
      NewLine();
     END;
     IF ~NeedSheet2 & ~!LimIncVCode & HasLimIncStr THEN
      AddManStr("室ኮ:", 0, 0);
      AddManStr(LimIncStr, 0, 0);
      NewLine();
     END;
    END;
   END; (* IF ToPaper() ... *)
  END; (* IF WithPrint... *)

  IF WithPrint THEN
   PROMPT(Man.Man + " : " + Staff.TSN + " - ଠ N3 -  3");
  END;

  TotInc:=L_Tax.Tax2001_GetArrSum(   _TotInc);
  ClcByThirdScaleTax:=L_Tax._Tax2001_GetClcTax(CurP, CurP,
                                               FictOnly(), L_Tax.Tax2001_ThrdScale);
  ClcTax:=L_Tax._Tax2001_GetClcTax(CurP, CurP,
                                   FictOnly(), L_Tax.Tax2001_EvryScale);
  PaidTax:=L_Tax._Tax2001_GetPaidTax(CurP, CurP,
                                     FictOnly(), L_Tax.Tax2001_EvryScale);
  DEC(ClcTax, ClcByThirdScaleTax);
  DEC(PaidTax, ClcByThirdScaleTax);

  SETZERO(EnfTax);
  L_Tax.Tax2001_GetOneType(CurP, CurP, L_Tax.Tax2001_mt_EFT, EnfTax);

  IF ClcTax > PaidTax THEN
   DbtTax:=ClcTax-PaidTax;
   CrdTax:=0;
  ELSE
   DbtTax:=0;
   CrdTax:=PaidTax-ClcTax;
  END;

  InitArr();
  SETZERO(Dummy, TotDec);

  IF L_Tax.Tax_IsResident(CurPE) THEN
   OneTAReason(L_Tax.Tax2001_mt_StD, Dummy, TotDec, "");       (* ⠭   *)
  END;

  IF WithPrint THEN
   PrepareToPrint(0, 0);
   IF ToPaper() THEN
    MAKEPART(R, Part21);
   ELSE
    IF ~!IncToTrn THEN
     AddManStr(":", 0, 0);
     AddManStr(IncToTrn, 0, 0);
     NewLine();
    END;
   END; (* IF ToPaper() ... *)
  END; (* IF WithPrint... *)

  TotDec:=Math.Min(TotDec, TotInc);
  ToTax :=TotInc-TotDec;

  SETZERO(OverTax); (* 모뢠 ९ *)
  L_Tax.Tax2001_GetOneOwnCode(CurP, CurP, L_Tax.Tax2001__oc_PYTax, OverTax);
  L_Tax.Tax2001_GetOneOwnCode(CurP, CurP, L_Tax.Tax2001__oc_OYRec, OverTax);
  IF OverTax#0 THEN
   DEC(PaidTax, OverTax);
  END;

  ValInc:=L_Tax.Tax2001_GetArrSum(_ValInc);

  SETZERO(RetnTax);
  IF PaidTax<0 THEN
   RetnTax:=-PaidTax;
   PaidTax:=0;
   IF ~WithPrint & (RetnTax>OverTax) THEN
    IF ToPaper() THEN
     L_General.Error("'⥭' ॢ蠥 '९'");
    ELSE
     RETURN 3;
    END;
   END;
   DEC(OverTax, RetnTax);
   RetnTax:=0;
  END;

  InitArr();
  IF _MainScale = L_Tax.Tax2001_ScndScale THEN
   GetPurInc(_PurInc, L_Tax.Tax2001_PureIncomVCode);
   L_Tax.SetTax2001_ScaleToGather(L_Tax.Tax2001_MainScale);  (* ᮡ 室  Tax2001_MainScale *)
   OneTAReason(L_Tax.Tax2001_mt_Inc, _PurInc1, TotLim, "");
   PrepareToPrint(1, 1);
   i:=0;
   WHILE i <= 11 DO
    _ValInc[i]:=_PurInc[i] + _PurInc1[i];
    _TotInc[i]:=_ValInc[i] - _Limits[i];
    INC(i);
   END;
   INC(TotnAdvInc, L_Tax.Tax2001_GetArrSum(nAdvInc));
   INC(TotnLimVal, L_Tax.Tax2001_GetArrSum(nLimVal));
   TotInc:=L_Tax.Tax2001_GetArrSum(_TotInc);
   ValInc:=L_Tax.Tax2001_GetArrSum(_ValInc);
   TotDec:=Math.Min(TotDec, TotInc);
   ToTax :=TotInc-TotDec;
  END; (* IF _MainScale... *)

  IF PaidTax >= EnfTax THEN
   DEC(PaidTax, EnfTax);
  END;

  SETEMPTY(msValInc, msToTax, msClcTax, msPaidTax,
           ssValInc,          ssClcTax, ssPaidTax,
           tsValInc, tsToTax, tsClcTax, tsPaidTax);
  IF _MainScale = L_Tax.Tax2001_MainScale THEN
   msValInc :=GetNbrStr(ValInc);
   msToTax  :=GetNbrStr(ToTax);
   msClcTax :=GetNbrStrIntg(ClcTax);
   msPaidTax:=GetNbrStrIntg(PaidTax);
  ELSE
   ssValInc :=GetNbrStr(ValInc);
   ssClcTax :=GetNbrStrIntg(ClcTax);
   ssPaidTax:=GetNbrStrIntg(PaidTax);
  END;

  IF WithPrint THEN
   IF ToPaper() THEN
    MAKEPART(R, Part3,
                msValInc,
                msToTax,
                msClcTax,
                msPaidTax,
                ssValInc,
                ssClcTax,
                ssPaidTax
            );
   ELSE
    IF _MainScale = L_Tax.Tax2001_MainScale THEN
     IF HasIncomeByMonthsAsStr |
        ((ValInc#0) | (ToTax#0) | (ClcTax#0) | (PaidTax#0)) THEN
      AddManStr("㬬:", 0, 0);
      AddManStr(MoneyToTrn(ValInc), 0, 0);
      NewLine();
      AddManStr("㬬:", 0, 0);
      AddManStr(MoneyToTrn(ToTax), 0, 0);
      NewLine();
      AddManStr("㬬:", 0, 0);
      AddManStr(MoneyToTrnIntg(ClcTax), 0, 0);
      NewLine();
      AddManStr("㬬:", 0, 0);
      AddManStr(MoneyToTrnIntg(PaidTax), 0, 0);
      NewLine();
     END;
    ELSE
     AddManStr(":", 0, 0);
     IF ~!IncToTrnNR THEN
      AddManStr(IncToTrnNR, 0, 0);
     ELSE
      AddManStr("2000,0.00", 0, 0);
     END;
     NewLine();
     IF ~!IncToTrn THEN
      AddManStr("獐:", 0, 0);
      AddManStr(IncToTrn, 0, 0);
      NewLine();
     END;
     AddManStr("㬬:", 0, 0);
     AddManStr(MoneyToTrn(ValInc), 0, 0);
     NewLine();
     AddManStr(":", 0, 0);
     AddManStr(MoneyToTrnIntg(ClcTax), 0, 0);
     NewLine();
     AddManStr(":", 0, 0);
     AddManStr(MoneyToTrnIntg(PaidTax), 0, 0);
     NewLine();
    END; (* IF _MainScale = L_Tax.Tax2001_MainScale.. *)
    SETEMPTY(T3PrtErr);
    T3PrtErr[00]:=TotnAdvInc#ValInc; (*   室=  栬*)
    T3PrtErr[02]:=TotInc#RoundToNumeric2(ValInc-TotnLimVal); (*ᮢ㯭=-᪨*)
    T3PrtErr[03]:=ToTax#RoundToNumeric2(ValInc-TotnLimVal-TotDec); (*=-᪨-*)
   END; (* IF ToPaper() ... *)
  END; (* IF WithPrint... *)

  InitArr();
  L_Tax.SetTax2001_ScaleToGather(L_Tax.Tax2001_ThrdScale);
  SETZERO(TotLim, _PurInc2, _Limits);
  OneTAReason(L_Tax.Tax2001_mt_Inc, _PurInc2, TotLim, "");
  PrepareToPrint(1, 1);
  _Dummy:=L_Tax.Tax2001_GetArrSum(_PurInc2);
  IF _Dummy # 0 THEN
   INC(ValInc, _Dummy);
   INC(ToTax,  _Dummy);
   tsValInc:=GetNbrStr(_Dummy);
   tsToTax :=tsValInc;
   _Dummy:=L_Tax._Tax2001_GetOverTax(CurP, CurP, FictOnly(), L_Tax.Tax2001_ThrdScale);
   INC(ClcTax,  _Dummy);
   INC(PaidTax, _Dummy);
   tsClcTax :=GetNbrStrIntg(_Dummy);
   tsPaidTax:=tsClcTax;
  END;

  IF WithPrint THEN
   IF ~FictOnly() THEN
    Get_Stx(TaxBasePFR, TaxBaseFSS, TaxBaseFFOMS, TaxBaseTFOMS,
            TaxPFR, TaxFSS, TaxFFOMS, TaxTFOMS);
   ELSE
    SETZERO(TaxBasePFR, TaxBaseFSS, TaxBaseFFOMS, TaxBaseTFOMS,
            TaxPFR, TaxFSS, TaxFFOMS, TaxTFOMS);
   END;
  END;

  IF ~NeedSheet2 THEN
   InitSheet2Arr();
  END;

  IF WithPrint THEN
   IF ToPaper() THEN
    MAKEPART(R, Part31,
                tsValInc, tsToTax,
                tsClcTax, tsPaidTax,
                ClcTax,   PaidTax,
                RetnTax,  OverTax,
                DbtTax,   CrdTax,  EnfTax
            );
    FORMFEED(R);
    MAKEPART(R, PartSheet2,
                TaxBasePFR, TaxBaseFSS, TaxBaseFFOMS, TaxBaseTFOMS,
                TaxPFR,     TaxFSS,     TaxFFOMS,     TaxTFOMS);
   ELSE
    IF ~!IncToTrnNR THEN
     AddManStr("室:", 0, 0);
     AddManStr(IncToTrnNR, 0, 0);
     NewLine();
     IF ~!IncToTrn THEN
      AddManStr(":", 0, 0);
      AddManStr(IncToTrn, 0, 0);
      NewLine();
     END;
    END;
    IF ~!tsValInc | ~!tsToTax | ~!tsClcTax | ~!tsPaidTax THEN
     AddManStr("㬬:", 0, 0);
     AddManStr(tsValInc, 0, 0);
     NewLine();
     AddManStr(":", 0, 0);
     AddManStr(tsToTax, 0, 0);
     NewLine();
     AddManStr(":", 0, 0);
     AddManStr(tsClcTax, 0, 0);
     NewLine();
     AddManStr(":", 0, 0);
     AddManStr(tsPaidTax, 0, 0);
     NewLine();
    END;

    AddManStr("㬬:", 0, 0);
    AddManStr(MoneyToTrnIntg(ClcTax), 0, 0);
    NewLine();
    AddManStr("㬬:", 0, 0);
    AddManStr(MoneyToTrnIntg(PaidTax), 0, 0);
    NewLine();

    PutOneStrNotZero(":", RetnTax, 1);
    PutOneStrNotZero("㬬:",   OverTax, 1);
    PutOneStrNotZero(":",    DbtTax,  1);
    PutOneStrNotZero(":",    CrdTax,  1);
    PutOneStrNotZero("᪈:", EnfTax,  1);

    IF NeedSheet2 THEN
     AddManStr("匥:", 0, 0);
     i:=0; SETEMPTY(IncomeByMonthsAsStr);
     WHILE i<= 11 DO
      SETEMPTY(tmp);
      GetOneVCode_Sheet2(tmp, LimIncVCode_Sheet2[0], LimIncArray00_Sheet2[i]);
      GetOneVCode_Sheet2(tmp, LimIncVCode_Sheet2[1], LimIncArray01_Sheet2[i]);
      GetOneVCode_Sheet2(tmp, LimIncVCode_Sheet2[2], LimIncArray02_Sheet2[i]);
      GetOneVCode_Sheet2(tmp, LimIncVCode_Sheet2[3], LimIncArray03_Sheet2[i]);
      GetOneVCode_Sheet2(tmp, LimIncVCode_Sheet2[4], LimIncArray04_Sheet2[i]);
      GetOneVCode_Sheet2(tmp, LimIncVCode_Sheet2[5], LimIncArray05_Sheet2[i]);
      IF ~!tmp THEN
       IF ~!IncomeByMonthsAsStr THEN
        IncomeByMonthsAsStr:=IncomeByMonthsAsStr+";";
       END;
       IncomeByMonthsAsStr:=IncomeByMonthsAsStr+L_Str.FixedIntStr(i+1, 2)+","+tmp;
      END;
      INC(i);
     END;
     AddManStr(IncomeByMonthsAsStr, 0, 0);
     NewLine();
    END;

    IF ~!L_Man.GetManSINumber_asStr() THEN
     AddManStr(":", 0, 0);
     AddManStr(L_Man.GetManSINumber_asStr(), 0, 0);
     NewLine();
    END;
    AddManStr(":", 0, 0);
    AddManStr(MoneyToTrn(TaxBasePFR)+","+MoneyToTrn(TaxBaseFSS)+","+MoneyToTrn(TaxBaseFFOMS)+","+MoneyToTrn(TaxBaseTFOMS), 0, 0);
    NewLine();
    AddManStr(":", 0, 0);
    AddManStr(MoneyToTrn(TaxPFR)+","+MoneyToTrn(TaxFSS)+","+MoneyToTrn(TaxFFOMS)+","+MoneyToTrn(TaxTFOMS), 0, 0);
    NewLine();
    TaxStx:=TaxPFR+TaxFSS+TaxFFOMS+TaxTFOMS;

    INC(TotValInc, ValInc);
    INC(TotPaidTax, PaidTax);
    INC(TotTaxStx, TaxStx);
    MAKEPART(D, DLine, GetNbrStr(ValInc), GetNbrStrIntg(PaidTax),
                       GetNbrStr(TaxStx));
    IF (ClcTax # (PaidTax+OverTax)) THEN
     T3PrtErr[01]:=1;
    END;
    MAKEPART(T3Prt, T3Prt_Line,
                    GetNbrStr(TotnAdvInc),
                    GetNbrStr(TotnLimVal),
                    GetNbrStr(TotInc),
                    GetNbrStr(TotDec),
                    GetNbrStr(ValInc),
                    GetNbrStr(ToTax),
                    GetNbrStr(ClcTax),
                    GetNbrStr(PaidTax),
                    GetNbrStr(RetnTax),
                    GetNbrStr(OverTax),
                    GetNbrStr(DbtTax),
                    GetNbrStr(CrdTax),
                    GetNbrStr(EnfTax));
   END; (* IF ToPaper() ... *)
   RETURN 1;
  ELSE
   IF (ValInc>0) | (ToTax>0) THEN
    RETURN 1;
   ELSIF
    (ValInc  <0)|
    (TotLim  #0)|
    (TotDec  #0)|
    (ToTax   #0)|
    (ClcTax  #0)|
    (PaidTax #0) THEN
    RETURN 2;
   ELSIF
    (RetnTax#0) THEN
    RETURN 0;
   ELSE
    RETURN 0;
   END;
  END; (* IF WithPrint... *)
 END {TypePart3};

 PRIVATE PROCEDURE NewLine();
 BEGIN
  FIO.WrLn(T);
  FirstFieldInLine:=1;
 END {NewLine};

 PRIVATE PROCEDURE GetSpecFIO(S: STRING[250]): STRING[250];
  VAR
   Surname,
   FirstName,
   Patronymic: STRING[];
 BEGIN
  L_Str.SplitManName(Str.Cap(S), Surname, FirstName, Patronymic);
  RETURN Surname+","+FirstName+","+Patronymic;
 END {GetSpecFIO};

 PRIVATE PROCEDURE MakeOneMan();
  VAR
   Err,
   _Address : STRING[250];
   HasINN   : SCAL[2];
 BEGIN
  L_General.Assert(SEARCH(Staff, TSN, _MN._TSN), "Error 234");
  INC(NumInTrFile);
  CONFORM(Staff, Man);
  PROMPT(Man.Man);
  AddManStr(":", 0, 0);
  AddManStr(IDO+FLDTOSTR(CurP, "y")+FLDTOSTR(Man.Man, "0", 8), 0, 0);
  NewLine();

  AddManStr("⠄:", 0, 0);
  AddManStr(FLDTOSTR(SYSDATE(), "D.N.y"), 0, 0);
  NewLine();

  HasINN:=~!Man.INN;

  IF HasINN THEN
   AddManStr(":", 0, 0);
   AddManStr(FLDTOSTR(Man.INN, "0"), 0, 0);
   NewLine();
  END;

  AddManStr("ᔋ:", 0, 0);
  AddManStr(FLDTOSTR(Str.Item("2|1", "|", L_Tax.Tax_IsResident(CurPE)), "0"), 0, 0);
  NewLine();

  AddManStr(":", 0, 0);
  AddManStr(GetSpecFIO(Man.Name), 0, 0);
  NewLine();

  IF ~HasINN THEN
   AddManStr(":", 0, 0);
   AddManStr(L_Man.GetManDocCode(Man.DocType), 0, 0);
   AddManStr(Man.PspSer+" "+Man.PspNbr, 0, 1);
   NewLine();
 
   AddManStr("⠐:", 0, 0);
   AddManStr(FLDTOSTR(Man.Birth, "D.N.y"), 0, 0);
   NewLine();
 
   AddManStr(":", 0, 0);
   L_Tax.StandOnManAdrForTax(Man.Man, CurPE);
   Err:=L_Man.GetAdrForTax(_Address);
   AddManStr(_Address, 0, 0);
   NewLine();
  END;

  Type3Result:=TypePart3(1, 0);

  AddManStr("@@@", 0, 0);
  NewLine();
 END {MakeOneMan};

(*
$P{ DTit:
CurP, L, "y"
SYSDATE(), L, "D.N.y"
P_MyFirm.TaxDepCode(L_Packet.PckMyFirm, SYSDATE()), L, ""
NAM, L, ""
INN+"/"+KPP, L, ""
P_MyFirm.NumInPFR(L_Packet.PckMyFirm, CurPE), L, ""
P_Firm.FP_AcntName(Firm.Firm, SYSDATE()), L, ""
ManAmount, L, "0"
@
                                                
                         ᢥ  室 䨧᪨   ####   
                                       樠쭮  ()
                                _____  ##########   ########
---------------------------------------------------------------------------------------------------------
|  (⥫騪  樠쭮  ()):                                |
|#######################################################################################################|
|   (⥫騪  樠쭮  ()): ########################|
|樮  ⥫騪  樠쭮  ()  : ####################|
| ⢥⢥ : ###############################################################################|
|⢮ ।⠢ 㬥⮢ (ࠢ  室   樠쭮 ()): ##########|
---------------------------------------------------------------------------------------------------------
                                        ।⠢ 㬥
=========================================================================================================
|   N    |          , , ⢮           |  騩  室  |騩 㤥ঠ|騩 ᫥- |
|ࠢ |                                           |                |           | 樠  |
|        |                                           |                |                | ()   |
|--------|-------------------------------------------|----------------|----------------|----------------|
}
*)

(*
$P{ DLine:
FLDTOSTR(Man.Man, "0", 8), L, ""
GetSpecFIO(Man.Name), L, ""
?, R, ""
?, R, ""
?, R, ""
@
|########|###########################################|################|################|################|
}
*)

(*
$P{ DBot:
GetNbrStr(TotValInc), R, ""
GetNbrStrIntg(TotPaidTax), R, ""
GetNbrStr(TotTaxStx), R, ""
@
|----------------------------------------------------|----------------|----------------|----------------|
|⮣                                               |################|################|################|
=========================================================================================================


  
(⥫騪  樠쭮  ())  ________________________

                          ..

 ।⠢   ࣠  "_____"_____________________ ________ .

 ਭ   ࣠       "_____"_____________________ ________ .

 ࠡ⭨  ࣠   ___________________________________________
}
*)

(*
$P{ T3Prt_Top:
L_OwnData.ODFirmName(CurPE), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
L_DatTim.YearBeg(CurP), L, "D.N.y"
CurPE, L, "D.N.y"
@
###########################################################################                                                                                                                                                                                              ########## #####
=T3Prt===================================================================================================================================================================================================================================================================================
|                                                                                                           ⮪ ନ஢ ᢥ  室   ਮ  ##########  ##########                                                                                            |
|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|஡:                                                                                                                                                                                                                                                                              |
| 0 - ( 室)   室  ࠢ ( 室)  栬                                                                                                                                                                                                              |
| 1 - /                                                                                                                                                                                                                                                              |
| 2 - (ᮢ㯭 室)  ࠢ (-᪨)                                                                                                                                                                                                                                      |
| 3 - ( 室)  ࠢ (-᪨-)                                                                                                                                                                                                                               |
|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|  ஡ |   N    |       , , ⢮        |            |            |           室          |              |              |              |              |              |              |              |              |              |              |              |
|-----------|        |                                     |         |ਮ   |-----------------------------|      室|         |       㬬|       㬬|     㬬|     㬬|     |       㬬|        |        |     ᪈|
| 0| 1| 2| 3|ࠢ |         ⥫騪           |            |            |       |        |              |              |              |              |              |              |              |              |              |              |              |
|--|--|--|--|--------|-------------------------------------|------------|------------|--------------|--------------|--------------|--------------|--------------|--------------|--------------|--------------|--------------|--------------|--------------|--------------|--------------|
}
*)

(*
$P{ T3Prt_Line:
T3PrtErr[00], R, " |0"
T3PrtErr[01], R, " |1"
T3PrtErr[02], R, " |2"
T3PrtErr[03], R, " |3"
FLDTOSTR(Man.Man, "0", 8), L, ""
GetSpecFIO(Man.Name), L, ""
FLDTOSTR(Man.INN, "0"), L, ""
GetRomeStr(1), L, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
@
|##|##|##|##|########|#####################################|############|############|##############|##############|##############|##############|##############|##############|##############|##############|##############|##############|##############|##############|##############|
}
*)

(*
$P{ T3Prt_Bot:
@
=(c) Polak===============================================================================================================================================================================================================================================================================
}
*)

 PRIVATE PROCEDURE PacketTitle(PackNum: NUMERIC[0]);
  VAR
  _Value : LIKE(FirmPro.Value);
 BEGIN
  IF ErrCnt # 0 THEN
   AddManStr("XXXX", 1, 0);
  END;
  FirstFieldInLine:=1;
  AddManStr(":", 1, 0);
  AddManStr(IDO+L_DatTim.SysDateTimeStamp(), 1, 0);
  NewLine();
  AddManStr(":", 1, 0);
  AddManStr("2001", 1, 0);
  NewLine();
  AddManStr(":", 1, 0);
  AddManStr(P_MyFirm.TaxDepCode(L_Packet.PckMyFirm, SYSDATE()), 1, 0);
  NewLine();
  AddManStr(":", 1, 0);
  AddManStr(NAM, 1, 0);
  NewLine();
  AddManStr(":", 0, 0);
  AddManStr(P_Firm.FP_AcntPhone(Firm.Firm, SYSDATE()), 0, 0);
  NewLine();
  _Value:=P_Firm.FP_Tax3Sender(Firm.Firm, SYSDATE());
  AddManStr(":", 0, 0);
  _Value:=Str.Item(_Value, ";", 1);
  AddManStr(GetSpecFIO(_Value), 0, 0);
  NewLine();
  AddManStr(":", 0, 0);
  AddManStr(FLDTOSTR(ManAmount, "0"), 0, 0);
  NewLine();
  AddManStr("㦈:", 0, 0);
  AddManStr(Copyright, 0, 0);
  NewLine();
  AddManStr("@@@", 0, 0);
  NewLine();
  MAKEPART(D, DTit);
 END {PacketTitle};

 PRIVATE PROCEDURE PacketBottom(PackNum: NUMERIC[0]);
 BEGIN
  AddManStr("===", 0, 0);
  MAKEPART(D, DBot);
  FORMFEED(D);
 END {PacketBottom};

 PRIVATE PROCEDURE GetFileExt(): STRING[32];
 BEGIN
  IF ErrCnt = 0 THEN
   RETURN "TXT";
  ELSE
   RETURN "XXT";
  END;
 END {GetFileExt};

 PRIVATE PROCEDURE GetFileName(S: STRING[1]; PackNum: SCAL[MaxPacket]): STRING[32];
 BEGIN
  RETURN FIO.MakePath(S+Str.Slice(INN, 4, 5)+FLDTOSTR(PackNum), , Path);
 END {GetFileName};

 PRIVATE PROCEDURE GetPacketNum(): SCAL[MaxPacket];
 BEGIN
  IF ByCurrentPacket() THEN
   RETURN Packet.ExtNbr;
  ELSIF ToPaper() THEN
   RETURN 00;
  ELSIF FictOnly() THEN
   RETURN 09;
  ELSIF MakeForInq() THEN
   RETURN 11+L_DatTim.MONTH(CurP);
  ELSE
   RETURN 01;
  END;
 END {GetPacketNum};

 PRIVATE PROCEDURE MakePBdLine(SErr: STRING[]);
 BEGIN
  IF MakeForInq() THEN
   L_General.Error(SErr);
  ELSE
   MAKEPART(R, BdLine, SErr);
   INC(ErrCnt);
  END;
 END {MakePBdLine};

 PRIVATE PROCEDURE AdditionalCheck(): SCAL[2];
  VAR
   Err,
   _Address : STRING[250];
   PrvErrCnt: NUMERIC[0];
 BEGIN
  PrvErrCnt:=ErrCnt;
  IF ~!Man.INN THEN
   IF ~L_Russia.CheckINN(Man.INN) THEN
    MakePBdLine("४ ");
   END;
   L_Man.AccessRgManAdr(Man.Man, CurP);
  ELSE
   Err:=L_Man.CheckDocument();
   IF ~!Err THEN
    MakePBdLine(Err);
   ELSE
    L_Tax.StandOnManAdrForTax(Man.Man, CurPE);
    Err:=L_Man.GetAdrForTax(_Address);
    IF ~!Err | !_Address THEN
     MakePBdLine(Err);
    ELSIF Str.Length(_Address) > 120 THEN
     MakePBdLine("   120 ᨬ");
    END;
   END;
  END;
  RETURN ErrCnt=PrvErrCnt;
 END {AdditionalCheck};

 PRIVATE PROCEDURE PutManInIndex(_Man: LIKE(Man.Man));
  VAR
   Cnt,
   PacketNum: SCAL[MaxPacket];
 BEGIN
  SETZERO(Cnt);
  SEARCH(Man, Man, , _Man);
  PROMPT(" "+Man.Man);
  SELECT(Staff, MyFirm, , L_Packet.PckMyFirm, Man.Man);
  WHILE OCCURE(Staff) DO
   IF L_Staff.IsMainForTax(CurPE) THEN
    L_General.Assert(Cnt=0, "2  ࠪ -   Polak");
    INC(Cnt);
    Type3Result:=TypePart3(0, 1);
    IF    Type3Result = 2 THEN
     MakePBdLine("  室,   ᪨,  ,  ");
    ELSIF Type3Result = 3 THEN
     MakePBdLine("'⥭' ॢ蠥 '९'");
    ELSIF Type3Result = 1 THEN
     IF AdditionalCheck() THEN
      PacketNum:=GetPacketNum();
      INC(ManAmount);
      _MN._PacketNum:=PacketNum;
      _MN._Man      :=Man.Man;
      _MN._TSN      :=Staff.TSN;
      INSERT(_MN);
     END;
    END;
   END; (* IF L_Staff.IsMainForTax ... *)
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {PutManInIndex};

 PRIVATE PROCEDURE PrepareIndex();
 BEGIN
  IF ToPaper() THEN
   PutManInIndex(Man.Man);
  ELSE
   SELECT(Man, Man);
   WHILE OCCURE(Man) DO
    SAVE(Man);
    PutManInIndex(Man.Man);
    RESTORE(Man);
    NEXT(Man);
   END; (* WHILE OCCURE(Man) ... *)
  END;
 END {PrepareIndex};

 PRIVATE PROCEDURE PrepareIndexForPacket();
 BEGIN
  SELECT(PckBody, Packet, , Packet.Packet);
  WHILE OCCURE(PckBody) DO
   PutManInIndex(PckBody.Man);
   NEXT(PckBody);
  END; (* WHILE OCCURE(PckBody) ... *)
 END {PrepareIndexForPacket};

 PRIVATE PROCEDURE PrepareANYIndex(BuildProc: PROC);
 BEGIN
  ErrFileIdx:=MakedFiles;
  CreateANYFile(1, "R", GetFileName("E", GetPacketNum())+".REP");
  MAKEPART(R, BdTop);
  SETZERO(ManAmount);
  BuildProc();
  MAKEPART(R, BdBot);
  CLOSEREP(R);
 END {PrepareANYIndex};

 PRIVATE PROCEDURE CheckForInq(_TaxInq: LIKE(TaxInq.InqType)): SCAL[2];
 BEGIN
  SETSEL(TaxInq, Man, Man.Man, _TaxInq);
  SRCINSEL(TaxInq, GE, , L_DatTim.YearBeg(CurP));
  WHILE OCCURE(TaxInq) & (TaxInq.Date < CurPE) DO
   CONFORM(TaxInq, ManTA);
   WHILE OCCURE(ManTA) DO
    IF ManTA.TaxAdv = _TaxAdv THEN
     RETURN 1;
    END;
    NEXT(ManTA);
   END; (* WHILE OCCURE(ManTA) ... *)
   NEXT(TaxInq);
  END; (* WHILE OCCURE(TaxInq) *)
  RETURN 0;
 END {CheckForInq};

 PRIVATE PROCEDURE PrepareIndexForInq();
  VAR
   PacketNum,
   Cnt       :NUMERIC[0];
 BEGIN
  ErrCnt:=0;
  SETZERO(ManAmount);
  L_Tax.Tax2001_InitCodes(L_DatTim.YearBeg(CurP));
  L_Tax.Tax_StandOnSingleSpecifiedTaxAdv(L_DatTim.YearBeg(CurP), L_Tax.Tax2001__oc_EFTax, "");
  _TaxAdv:=TaxAdv.TaxAdv;
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   PROMPT(" " + Man.Man);
   L_General.Assert(~CheckForInq(L_Tax.inqt_Own), "㦥 筠 ࠢ!");
   IF CheckForInq(L_Tax.inqt_Auto) THEN
    SAVE(Man);
    SETZERO(Cnt);
    PROMPT(" "+Man.Man);
    SELECT(Staff, MyFirm, , L_Packet.PckMyFirm, Man.Man);
    WHILE OCCURE(Staff) DO
     IF L_Staff.IsMainForTax(CurPE) THEN
      L_General.Assert(Cnt=0, "2  ࠪ -   Polak");
      INC(Cnt);
      Type3Result:=TypePart3(0, 1);
      L_General.Assert((Type3Result # 2), "  室,   ᪨,  ,  ");
      IF (Type3Result = 1) & AdditionalCheck() THEN
       PacketNum:=GetPacketNum();
       INC(ManAmount);
       _MN._PacketNum:=PacketNum;
       _MN._Man      :=Man.Man;
       _MN._TSN      :=Staff.TSN;
       INSERT(_MN);
      END;
     END; (* IF L_Staff.IsMainForTax ... *)
     NEXT(Staff);
    END; (* WHILE OCCURE(Staff) ... *)
    RESTORE(Man);
   END;
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
 END {PrepareIndexForInq};

 PRIVATE PROCEDURE Make();
  VAR
   PacketNum: SCAL[MaxPacket];
 BEGIN
  SETZERO(TotValInc, TotPaidTax, TotTaxStx);
  SELECT(_MN, _MN);
  WHILE OCCURE(_MN) DO
   PacketNum:=_MN._PacketNum;
   SETZERO(TotValInc, TotPaidTax, TotTaxStx);
   CHANGESEL(_MN, _MN, , PacketNum);
   CreateANYFile(1, "D", GetFileName("R", PacketNum)+".REP");
   CreateANYFile(0, "T", GetFileName("S", PacketNum)+"."+GetFileExt());
   PacketTitle(PacketNum);
   WHILE OCCURE(_MN) DO
    MakeOneMan();
    NEXT(_MN);
   END; (* WHILE OCCURE(_MN)... *)
   PacketBottom(PacketNum);
   CLOSEREP(D);
   FIO.Close(T);
   LAST(_MN);
   CHANGESEL(_MN, _MN);
   NEXT(_MN);
  END; (* WHILE OCCURE(_MN)... *)
 END {Make};

 PRIVATE PROCEDURE MakeAll();
 BEGIN
  L_AFM.MakeIndex("_MN", "_PacketNum: SCAL[50]            ;"+
                            "_Man      : LIKE(Man.Man)       ;"+
                            "_TSN      : LIKE(Staff.TSN)      ");
  IF ~FIO.DirExists(Path) THEN
   FIO.MkDir(Path);
  END;
  ErrCnt:=0;
  IF ByCurrentPacket() THEN
   PrepareANYIndex(PROCREF(PrepareIndexForPacket));
  ELSE
   IF MakeForInq() THEN
    PrepareIndexForInq();
   ELSE
    PrepareANYIndex(PROCREF(PrepareIndex));
   END;
  END;
  CreateANYFile(1, "T3Prt", GetFileName("T", GetPacketNum())+".REP");
  MAKEPART(T3Prt, T3Prt_Top);
  Make();
  MAKEPART(T3Prt, T3Prt_Bot);
  CLOSEREP(T3Prt);
  IF ~ToPaper() & (ErrCnt = 0) THEN
   IF ~ByCurrentPacket() THEN
    InsertPacket();
   END;
   Packet.PrpDate:=SYSDATE();
   Packet.DTStamp:=STRTOFLD(L_DatTim.SysDateTimeStamp(), NUMERIC);
   Packet.Sums[0]:=TotValInc;
   Packet.Sums[1]:=TotPaidTax;
   REPLACE(Packet);
  END;
  L_Tax.Tax_FreeValues(CurP);
  L_AFM.AF_PurgeTemp("_MN");
 END {MakeAll};

 PRIVATE PROCEDURE CheckPer(withVariants: SCAL[2]);
  VAR
   S: STRING[];
 BEGIN
  S:="  ਮ  "+L_DatTim.DateStr(L_DatTim.YearBeg(CurP))+"  "+L_DatTim.DateStr(CurPE) +
     "||"+SubTitle();
  IF withVariants THEN
   S:="|"+S+"||"+"%<    믫⠬ 襩 ࣠樨   >DB"+
            "|" +"%<  믫⠬   >B" +
            "|" +"%<            ⬥               >Z" ;
   _FictOnly:=(STDFORM(S, , STOP) = 2);
  ELSE
   L_StdFrm.Choice(S);
   _FictOnly:=0;
  END;
 END {CheckPer};

 PRIVATE PROCEDURE InsertPacket();
 BEGIN
  L_General.Assert(SELECT(_MN, _MN), "     祭  ");
  L_Packet.InsIncTaxPacket(L_Str.IntStr(GetPacketNum()), EMPTYOF(MyPlace.MyPlace), L_DatTim.YearBeg(CurP), CurPE);
  PacketNumberStr[PacketInserted]:=FLDTOSTR(Packet.Packet);
  INC(PacketInserted);
  WHILE OCCURE(_MN) DO
   PROMPT(" " + _MN._Man);
   DEFAULT(PckBody);
   PckBody.Packet:=Packet.Packet;
   PckBody.Man:=_MN._Man;
   INSERT(PckBody);
   NEXT(_MN);
  END; (* WHILE OCCURE(_MN) ... *)
 END {InsertPacket};

 PRIVATE PROCEDURE ShowMakedFiles();
  VAR
   ViewFormStr,
   LikeMenuStr,
   Palette     :STRING[];
   i           :NUMERIC[0];
 BEGIN
  IF (ManAmount > 0) | (ErrCnt > 0) THEN
   IF ErrCnt # 0 THEN
    ViewFormStr:="|" +
                 "   諨 ࠫ ஢."+
                 "|ନ஢ 䠩    ᤠ   ᯥ."+
                 "|室 ࠢ 訡   ᢥ"+
                 "|(  "+MakedFileName[ErrFileIdx]+") | | ";
        Palette:="STOP";
   ELSE
    ViewFormStr:=" | ";
        Palette:="INFORM";
   END;
   IF (PacketInserted > 0) THEN
    ViewFormStr:=ViewFormStr + " :";
    i:=0;
    WHILE i < PacketInserted DO
     IF (i > 0) THEN
      ViewFormStr:=ViewFormStr + ",";
     END;
     ViewFormStr:=ViewFormStr + " " + PacketNumberStr[i];
     INC(i);
    END;
    ViewFormStr:=ViewFormStr + " | |";
   END;
   ViewFormStr:=ViewFormStr + " 䠩:|";
   SETEMPTY(LikeMenuStr);
   i:=0;
   WHILE i < MakedFiles DO
    IF (ErrCnt # 0) | (i # ErrFileIdx) THEN
     ViewFormStr:=ViewFormStr + MakedFileName[i] + " |";
     LikeMenuStr:=LikeMenuStr + "Survey," + '"' + MakedFileName[i] + '"' + ",";
    END;
    INC(i);
   END;
   ViewFormStr:=ViewFormStr + "|%<  >B %<  室  >X";
   IF STDFORM(ViewFormStr, ":", ^Palette) = 1 THEN
    LIKEMENU(^LikeMenuStr);
   END;
  ELSE
   L_StdFrm.Inform(" 室   ᢥ");
  END;
 END {ShowMakedFiles};

 PUBLIC PROCEDURE T3_2001(trgMode: tMode);
 BEGIN
  curMode:=trgMode;
  IF curMode > mode_All THEN
   L_StdFrm.BlueStop("    ⮣ ਮ");
  END;
  NumInTrFile:=0;
  Path:=FIO.MakePath("REP\T3");
  IF ~FIO.DirExists(Path) THEN
   FIO.MkDir(Path);
  END;
 
  IF    ToPaper() THEN
   L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
   L_Packet.DefinePckMyFirm(L_Packet.bm_byStaff);
  ELSIF ByCurrentPacket() THEN
   L_General.Assert(ACCESS(Packet), " ⠭ ");
   L_Packet.DefinePckMyFirm(L_Packet.bm_byPacket);
  ELSE
   L_Packet.DefinePckMyFirm(L_Packet.bm_byAll);
  END;
 
  IF ByCurrentPacket() THEN
   L_DatTim.CheckWMIntvl(Packet.PerB, Packet.PerE);
   L_General.Assert(SELECT(PckBody, Packet, Packet.Packet), " ");
   CurP :=L_DatTim.MonthBeg(Packet.PerE);
   CurPE:=Packet.PerE;
  ELSE
   CurP :=Memo.ud_mb();
   CurPE:=Memo.ud_me();
  END;
 
  IF ToPaper() THEN
   Path:=FIO.MakePath("TEMP", , Path);
  ELSE
   Path:=FIO.MakePath(L_Str.IntStr(L_DatTim.YEAR(CurP)), , Path);
  END;
  SETEMPTY(MakedFileName, PacketNumberStr, ErrFileIdx);
  SETZERO(MakedFiles, PacketInserted);
 
  CheckPer(L_Tax.E_NeedOtherFirmToT3(L_DatTim.YearBeg(CurP)));
  IF ~FictOnly() THEN
   _Firm:=P_Firm.fomf(L_Packet.PckMyFirm);
  ELSE
   _Firm:=P_OwnData.GetOwnDProStrong(CurPE, P_OwnData.P_TradeUnionFirm);
  END;
  P_Firm.AccessFirm(_Firm);
 
  NAM:=Str.Cap(P_Firm.FP_FirmName(_Firm, CurPE));
  INN:=P_Firm.FP_INN(Firm.Firm, CurPE);
  L_General.Assert((Str.Length(INN)=10) & L_Str.TestStrAlowChar(INN, "09"), " ଠ   ࣠樨 "+_Firm);
  KPP:=P_MySite.GetP_KPP(P_Firm.GetMyFirmOfFirm(Firm.Firm), EMPTYOF(MyPlace.MyPlace), CurPE);
  L_General.Assert((Str.Length(KPP)= 9) & L_Str.TestStrAlowChar(KPP, "09"), " ଠ   ࣠樨 "+_Firm);
 
  IDO:=INN+"**"+KPP;
 
  IF ToPaper() THEN                       (* ଠ 3 *)
   L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
   OPENREP(R, L_General.NameConnection("Tax03"), Create);
   SetPrintAttr(R, MinLinesPerPage, RepDepth, MaxPages, 1,
                   FontEnlargement, 1.2);
   L_Staff.CheckCurrentAsMainForTax(CurPE);
   CONFORM(Staff, Man);
   PROMPT(Man.Man + " : " + Staff.TSN + " - ଠ N3 -  0");
   L_General.Assert(L_PRoll.IsDedD_AP(CurP), " ⠭  " + L_DatTim.PeriodStr(CurP));
   Type3Result:=TypePart3(1, 1);
   L_Tax.Tax_FreeValues(CurP);
   CLOSEREP(R);
   L_General.SurveyLastReport();
  ELSE
   MakeAll();
   ShowMakedFiles();
  END;
 END {T3_2001};

END.
