(*
%Copyright    (c) Polak IT
%Author       24.06.2014 13:03:26 POLAK\Gina
%Purpose      ଠ -51 ⭠ 
%Type         report
%Specific     SYS
%Modified     25.07.2014 14:34:37 POLAK\Gina
*)

 TYPE
  tMakeMode    = SCAL[4];

 CONST
  mm_condSngTK = 0;
  mm_condAllTK = 2;

  CrdAmount = 10;

 VAR
  HolTime,
  HourTot     : LIKE(RegHead.GrTime);
  DaysTot     : LIKE(RegHead.GDay);
  Nbr         : NUMERIC[0];
  MonthB,
  MonthE      : DATE;
  TaxMC       : LIKE(MCList.MCode);
  DbtName,
  CrdName     : LIKE(MCGroup.Name)[CrdAmount];
  CrdSum,
  DbtSum      : L_PRoll.tSum[CrdAmount];
  CrdIdx      : SCAL[100][MAXOF(MCGroup.MCGroup)];
  C70,
  D70,
  ToTkPS      : L_PRoll.tSum;

  Root        : STRING[];

 PRIVATE PROCEDURE Set_DocCause(D: DATE);
 BEGIN
  L_MSO.wordSetVar("TheDoc.Cause",     L_APtm.GetTheDocCause(D, "⢥ত ⠭ ᪮ ᨨ  05.01.2004  1"));
  L_MSO.wordSetVar("TheDoc.Draftsman", L_APtm.GetTheDocDraftsman(D, ""));
 END {Set_DocCause};

 PRIVATE PROCEDURE SumStr(S: L_PRoll.tSum): STRING[];
 BEGIN
  IF S = 0 THEN
   RETURN "";
  ELSE
   RETURN L_Money.MoneyToStr(MonthB, "", S);
  END;
 END {SumStr};

 PRIVATE PROCEDURE w_PutSingleStaff();
  VAR
   r: STRING[];
   i: SCAL[CrdAmount];
 BEGIN
  r:=Root + ".Line" + L_MSO.IndexStr(Nbr-1);
  L_MSO.wordSetVar(r + ".Number", L_Str.IntStr(Nbr));
  L_MSO.wordSetVar(r + ".Man.Name.Short", L_Str.ShortName(Man.Name));
  L_MSO.wordSetVar(r + ".Staff.Post.Name",  Post.Name);
  L_MSO.wordSetVar(r + ".Staff.TSN", Staff.TSN);
  L_Staff.wordSetWagePayVar(MonthE, r + ".Staff.WagePay", 0);
  L_MSO.wordSetVar(r + ".Staff.HourTot", L_Str.NumericStr(HourTot, PRECISIONOF(HourTot)));
  L_MSO.wordSetVar(r + ".Staff.HolTime", L_Str.NumericStr(HolTime, PRECISIONOF(HolTime)));
  FOR_EACH i DO;
   L_MSO.wordSetVar_wIndex(r + ".Staff.CrdSum", SumStr(CrdSum[i]), i);
  END;
  L_MSO.wordSetVar_wIndex(r + ".Staff.DbtSum", SumStr(DbtSum[0]), 0);
  L_MSO.wordSetVar_wIndex(r + ".Staff.DbtSum", SumStr(DbtSum[1]), 1);
  L_MSO.wordSetVar_wIndex(r + ".Staff.DbtSum", SumStr(DbtSum[2]), 2);
  L_MSO.wordSetVar(r + ".Staff.C70",    SumStr(C70));
  L_MSO.wordSetVar(r + ".Staff.D70",    SumStr(D70));
  L_MSO.wordSetVar(r + ".Staff.ToTkPS", SumStr(ToTkPS));
 END {w_PutSingleStaff};

 PRIVATE PROCEDURE w_Init();
 BEGIN
  L_MSO.wordInitDocument(MonthE);
  Set_DocCause(MonthE);
 END {w_Init};

 PRIVATE PROCEDURE w_Put(Mode: tMakeMode);
  VAR
   i: SCAL[CrdAmount];
 BEGIN
  P_Firm.SetFirmDefaultData("My",  Firm.Firm, MonthE, "");
  L_MSO.wordSetVar    (Root + ".OKPO", P_Firm.FP_OKPO(Firm.Firm, SYSDATE()));
  IF Mode = mm_condSngTK THEN
   L_MSO.wordSetVarsByFile_wPrefix("TimeKeep", Root + ".");
   L_MSO.wordSetVar(Root + ".SrcNbr",  TimeKeep.TimeKeep + "/" + FLDTOSTR(MonthE, "N.y", 0));
  ELSE
   L_MSO.wordSetVar(Root + ".TimeKeep.Name", "");
   L_MSO.wordSetVar(Root + ".SrcNbr",  "001/" + FLDTOSTR(MonthE, "N.y", 0));
  END;
  L_MSO.wordSetDateVar(Root + ".PrpDate", SYSDATE());
  L_MSO.wordSetDateVar(Root + ".From",    MonthB);
  L_MSO.wordSetDateVar(Root + ".UpTo",    MonthE);
  FOR_EACH i DO;
   L_MSO.wordSetVar_wIndex(Root + ".CrdName", CrdName[i], i);
  END;
  L_MSO.wordSetVar_wIndex(Root + ".DbtName", DbtName[0], 0);
  L_MSO.wordSetVar_wIndex(Root + ".DbtName", DbtName[1], 1);
  L_MSO.wordSetVar_wIndex(Root + ".DbtName", DbtName[2], 2);
  L_MSO.SetWordTable("Sht01", Nbr);
  L_MSO.PutInTables:=L_MSO.Put_Values;
  L_MSO.MakeWordDocument("T51", 1, L_MSO.PrpMode_ToDoc, "");
 END {w_Put};

 PRIVATE PROCEDURE PassSheet();
 BEGIN
  SELECT(Sheet, TSN, , Staff.TSN, MonthB);
  WHILE OCCURE(Sheet) & ((Sheet.Period+Sheet.Day-1)<=MonthE) DO
   CONFORM(Sheet, JMode);
   IF JMode.Type = L_Sheet.jmType_TimDone THEN
    INC(DaysTot);
    INC(HourTot, Sheet.Tim);
    IF JMode.PayHldy THEN
     INC(HolTime, L_Sheet.HolTimeByDate(Sheet.Period+(Sheet.Day-1), Sheet.Tim, Sheet.DayTime));
    ELSE
     INC(HolTime, Sheet.Tim);
    END;
   END;
   NEXT(Sheet);
  END; (* WHILE *)
 END {PassSheet};

 PRIVATE PROCEDURE PassMoney();
 BEGIN
  SETZERO(CrdSum, DbtSum);
  SELECT(Money, TSN, , Staff.TSN, MonthB);
  WHILE OCCURE(Money) DO
   CONFORM(Money, MCList, MCGroup);
   IF MCList.MCTyp = L_PRoll.mct_Credit THEN
    INC(CrdSum[CrdIdx[MCGroup.MCGroup]], Money.Sum);
    INC(CrdSum[CrdAmount-1], Money.Sum);
   ELSE
    IF (Money.MCode # L_kn.GetSoft(MonthB, L_PRoll.erkn_MCList_PaidByCash)) &
       (Money.MCode # L_kn.GetSoft(MonthB, L_PRoll.erkn_MCList_PaidByBank)) THEN
     IF MCList.MCode = TaxMC THEN
      INC(DbtSum[0], Money.Sum);
     ELSE
      INC(DbtSum[1], Money.Sum);
     END;
     INC(DbtSum[2], Money.Sum);
    END;
   END;
   NEXT(Money);
  END; (* WHILE OCCURE(Money) ... *)
 END {PassMoney};

 PRIVATE PROCEDURE IsDebitPDoc(): SCAL[2];
 BEGIN
  RETURN (PDoc.PDocKind = L_PDoc.pd_RKO) | (PDoc.PDocKind = L_PDoc.pd_IPP);
 END {IsDebitPDoc};

 PRIVATE PROCEDURE PassPCalc();
  VAR
   TakenByPDoc,
   Taken,
   InpRest,
   _OutSaldoFutInc: L_PRoll.tSum;
 BEGIN
  SETZERO(TakenByPDoc, Taken, C70, D70);
  SELECT(PDocList, TSN, , Staff.TSN);
  SRCINSEL(PDocList, GE, , MonthB);
  WHILE OCCURE(PDocList) & (PDocList.PDocDate <= MonthE) DO
   IF PDocList.State = L_PDoc.pdl_st_Paid THEN
    CONFORM(PDocList, PDoc);
    IF L_PDoc.IsSalPDoc() THEN
     L_PDoc.CheckDone();
     IF PDoc.Status # L_PDoc.st_Canceled THEN
      IF IsDebitPDoc() THEN
       INC(TakenByPDoc, PDocList.Sum);
       IF PDoc.Type # L_PDoc.typ_Mass THEN
        INC(Taken, PDocList.Sum);
       END;
      END;
     END; (* IF PDoc.Status ... *)
    END; (* IF L_PDoc.IsSalPDoc()... *)
   END;
   NEXT(PDocList);
  END;

  L_General.Assert(SEARCH(PCalc, TSN, Staff.TSN, MonthB), " ப   " + L_DatTim.PeriodStr(MonthB));
  InpRest:=PCalc.Saldo + Taken - TakenByPDoc;
  INC(DbtSum[1], Taken);
  INC(DbtSum[2], Taken);
  IF InpRest >= 0 THEN
   C70:= InpRest; (*  ࣠樥*)
  ELSE
   D70:=-InpRest; (*  ࠡ⭨*)
  END;
  _OutSaldoFutInc:=L_PRoll.OutSaldoFutInc(MonthB, MonthB, L_PRoll.E_MPD_PCalc_NeedFutInc(MonthB));
  IF _OutSaldoFutInc > 0 THEN
   ToTkPS:=_OutSaldoFutInc;
  ELSE
   ToTkPS:=0;
  END;
 END {PassPCalc};

 PRIVATE PROCEDURE MakeLine();
 BEGIN
  SETZERO(HourTot, HolTime, DaysTot);
  CONFORM(StaffLog, Man, Officer, Post);
  CONFORM(Officer, WagePay);
  HISTCONF(MonthE, WagePay, WagePayL);
  CONFORM(StaffLog, Staff);
  L_PRoll.AccessWagePayL(MonthE);
  PassSheet();
  PassMoney();
  PassPCalc();
  w_PutSingleStaff();
 END {MakeLine};

 PRIVATE PROCEDURE MakeTimeKeep(Mode: tMakeMode);
 BEGIN
  SELECT(MyFirm, MyFirm);
  WHILE OCCURE(MyFirm) DO
   IF Mode = mm_condSngTK THEN
    SELECT(_TK, TSN, , MyFirm.MyFirm, TimeKeep.TimeKeep);
   ELSE
    SELECT(_TK, TSN, , MyFirm.MyFirm);
   END;
   IF OCCURE(_TK) THEN
    SEARCH(Firm, Firm, , P_Firm.fomf(_TK._MyFirm));
    w_Init();
    Nbr:=0;
    WHILE OCCURE(_TK) DO
     PROMPT(_TK._TK + " : " + _TK._TSN);
     INC(Nbr);
     SEARCH(StaffLog, TSN, , _TK._TSN, _TK._Date);
     MakeLine();
     NEXT(_TK);
    END; (* WHILE OCCURE(_TK) ... *)
    w_Put(Mode);
   END;
   NEXT(MyFirm);
  END; (* WHILE OCCURE(MyFirm) ... *)
 END {MakeTimeKeep};

 PRIVATE PROCEDURE MakeIndexStaffLog();
 BEGIN
  _TK._TK     :=Officer.TimeKeep;
  _TK._MyFirm :=L_Staff.GetStaffMyFirm();
  _TK._TSN    :=StaffLog.TSN;
  _TK._Sort   :=StaffLog.Sort;
  _TK._Officer:=StaffLog.Officer;
  _TK._ShftNum:=GetTSNShiftNumber(StaffLog.Sort, StaffLog.Officer, StaffLog.Regime);
  _TK._Date   :=StaffLog.Date;
  INSERT(_TK);
 END {MakeIndexStaffLog};

 PRIVATE PROCEDURE GetTSNShiftNumber(_Sort   : LIKE(Officer.Sort);
                                     _Officer: LIKE(Officer.Officer);
                                     _Regime : LIKE(RegMain.Regime)): LIKE(Shift.Number);
 BEGIN
  IF SEARCH(OfcShift, Officer, _Sort, _Officer, _Regime) THEN
   CONFORM(OfcShift, Shift);
   RETURN Shift.Number;
  ELSE
   RETURN P_Officer.ost_NoShift;
  END;
 END {GetTSNShiftNumber};

 PRIVATE PROCEDURE MakeIndex(Mode: tMakeMode);
 BEGIN
  L_AFM.MakeMultipleIndex("_TK", "_TK     : LIKE(TimeKeep.TimeKeep);"+
                                 "_MyFirm : "+GET_TYPE_SPEC(P_Firm.tMyFirm).Name +";"+
                                 "_TSN    : LIKE(Staff.TSN);"+
                                 "_Sort   : LIKE(Sort.Sort);"+
                                 "_Officer: LIKE(Officer.Officer);"+
                                 "_ShftNum: LIKE(Shift.Number);"+
                                 "_Date   : LIKE(StaffLog.Date)",
                          "TSN: _MyFirm, _TK, _TSN, _Date");

  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(" "+Staff.TSN);
   IF L_Env.RealTSN(Staff.TSN) & (SELECT(Money, TSN, Staff.TSN, MonthB) | L_Staff.IsWorking(MonthB)) THEN
    L_Staff.PosToStaffLog(Staff.TSN, MonthE, 1);
    CONFORM(StaffLog, Officer);
    IF (Mode = mm_condAllTK) | (Officer.TimeKeep = TimeKeep.TimeKeep) THEN
     MakeIndexStaffLog();
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE SetMCGroupArray();
  VAR
   i: SCAL[CrdAmount];
   Done: SCAL[2];
 BEGIN
  SETEMPTY(CrdName, DbtName);
  i:=0;
  SELECT(MCGroup, MCGroup);
  WHILE OCCURE(MCGroup) DO
   Done:=0;
   SELECT(MCList, MCGroup, , MCGroup.MCGroup);
   WHILE ~Done & OCCURE(MCList) DO
    IF L_DatTim.IsActive(MonthB, MCList.Begin, MCList.Till) & (MCList.MCTyp = L_PRoll.mct_Credit) THEN
     IF i<CrdAmount-2 THEN
      CrdName[i]:=MCGroup.Name;
      CrdIdx[MCGroup.MCGroup]:=i;
      INC(i);
     ELSE
      CrdIdx[MCGroup.MCGroup]:=CrdAmount-2;
     END;
     Done:=1;
    END;
    NEXT(MCList);
   END; (* WHILE OCCURE(MCList) ... *)
   NEXT(MCGroup);
  END; (* WHILE OCCURE(MCGroup) ... *)

  CrdName[CrdAmount-2]:="祥";
  CrdName[CrdAmount-1]:="ᥣ";

  DbtName[00]:="";
  DbtName[01]:="祥";
  DbtName[02]:="ᥣ";
 END {SetMCGroupArray};

 PRIVATE PROCEDURE Make(Mode: tMakeMode);
 BEGIN
  MonthB:=Memo.ud_mb();
  MonthE:=Memo.ud_me();
  L_General.Assert(L_APtm.MonthIsClosed(MonthB, L_APtm.system_Salary), "   ");
  L_APtm.CheckIfBeforeSystemStart(MonthB, L_APtm.system_Salary);

  TaxMC:=L_Tax.Tax_Get_mc_Tax(MonthB, 0);

  SetMCGroupArray();

  Root:="T51";
  IF Mode = mm_condSngTK THEN
   L_General.Assert(ACCESS(TimeKeep), " ⠭ ⠡騪");
  END;
  MakeIndex(Mode);
  MakeTimeKeep(Mode);
 END {Make};

 PUBLIC PROCEDURE T51_All();
 BEGIN
  Make(mm_condAllTK);
 END {T51_All};

 PUBLIC PROCEDURE T51_Sngl();
 BEGIN
  Make(mm_condSngTK);
 END {T51_Sngl};

END.
