(*
%Copyright   (c) Polak Computer System
%Author      07.02.2002 17:31:02 SAN
%Purpose     㠫쭮 ࠧ 㤥ঠ 室   N ⥩
%Type        report
%Specific    SYS
%Modified    08.09.2014 12:17:18 POLAK\Bor
%Environment
*)

 IMPORT Memo, L_General, L_APtm, L_Tax, L_Str, P_Firm, Math, L_DatTim, L_AFM, DBD;

 VAR
  tPaidTaxT,
  tPaidTax1,
  tPaidTax2,
  tPaidTax3,
  tPaidTax4 : NUMERIC[2];

(*
$P { Top:
P_Firm.MyFirmName(P_Firm.curMyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_mb(), L, "N.y"
@
########################################################################## ########## #####
=#####=====================================================================================
|                                ঠ   #######                                |
|-----------------------------------------------------------------------------------------|
|                      |         13%|         30%|         35%|          9%|       ⮣|
|------------------------|------------|------------|------------|------------|------------|
}

(*
$P { Line:
Man.Man, L, ""
L_Str.ShortName(Man.Name), L, ""
?, R, "2-"
?, R, "2-"
Tax01.PaidTax3, R, "2-"
Tax01.PaidTax4, R, "2-"
Tax01.PaidTaxT, R, "2-"
@
|##### ##################|############|############|############|############|############|
}
*)

$P { Bot:
tPaidTax1, R, "2-"
tPaidTax2, R, "2-"
tPaidTax3, R, "2-"
tPaidTax4, R, "2-"
tPaidTaxT, R, "2-"
@
|------------------------|------------|------------|------------|------------|------------|
|⮣                   |############|############|############|############|############|
=(c) Polak=================================================================================
}
*)

 PRIVATE PROCEDURE ManHasAnyContract(OnDate: DATE): SCAL[2];
 BEGIN
  SETSEL(Staff, MyFirm, P_Firm.curMyFirm, Man.Man);
  FOR_EACH Staff DO
   IF Staff.BegDate <= OnDate THEN
    RETURN 1;
   END;
  END; (* FOR_EACH Staff *)
  RETURN 0;
 END {ManHasAnyContract};

 PRIVATE PROCEDURE DoItOnPer(P: DATE; _Dir: NUMERIC[0]);
  VAR
   mMainScale : L_Tax.tTax2001_ScalesType;
   mPaidTaxT,
   mPaidTaxM,
   mPaidTax1,
   mPaidTax2,
   mPaidTax3,
   mPaidTax4  : NUMERIC[2];
 BEGIN
  APP.Get().NewPrompt(" "+L_DatTim.PeriodStr(P));
  SETZERO(tPaidTaxT, tPaidTax1, tPaidTax2, tPaidTax3, tPaidTax4);
  SETSEL(Man, Man);
  FOR_EACH Man DO
   PROMPT(" " + Man.Man);
   IF ManHasAnyContract(L_DatTim.MonthEnd(P)) THEN
    L_Tax.Tax_InitValues(P);
    L_Tax.Tax_FillManIsWorking(P);
    mPaidTaxT:=0;
    L_Tax.Tax2001_GetTax(P, mPaidTaxT);
    mPaidTax3:=Math.Min(Math.Max(0, mPaidTaxT),
                        L_Tax._Tax2001_GetClcTax(P,
                                                 P,
                                                 0,
                                                 L_Tax.Tax2001_ThrdScale));
    mPaidTax4:=Math.Min(Math.Max(0, mPaidTaxT-mPaidTax3),
                        L_Tax._Tax2001_GetClcTax(P,
                                                 P,
                                                 0,
                                                 L_Tax.Tax2001_FrthScale));

    mPaidTaxM:=mPaidTaxT-mPaidTax3-mPaidTax4;
    mMainScale:=L_Tax.Tax_GetScaleForMainScale(P);
    IF    mMainScale = L_Tax.Tax2001_MainScale THEN
     mPaidTax1:=mPaidTaxM;
     mPaidTax2:=0;
    ELSIF mMainScale = L_Tax.Tax2001_ScndScale THEN
     mPaidTax2:=mPaidTaxM;
     mPaidTax1:=0;
    ELSE
     L_General.CallUs(0);
    END;
    IF (mPaidTax1 # 0) | (mPaidTax2 # 0) | (mPaidTax3 # 0) | (mPaidTax4 # 0) THEN
     ADD(Tax01, Man, , Man.Man,
         Tax01.PaidTaxT, mPaidTaxT*_Dir,
         Tax01.PaidTaxM, mPaidTaxM*_Dir,
         Tax01.PaidTax1, mPaidTax1*_Dir,
         Tax01.PaidTax2, mPaidTax2*_Dir,
         Tax01.PaidTax3, mPaidTax3*_Dir,
         Tax01.PaidTax4, mPaidTax4*_Dir);
    END;
   END;
  END; (* FOR_EACH Man *)
  L_Tax.Tax_FreeValues(P);
 END {DoItOnPer};

 PRIVATE PROCEDURE Tax01();
  CONST
   RepName = "Tax01";
  VAR
   P      : DATE;
   curTax1,
   curTax2: NUMERIC[2];
 BEGIN
  APP.Get().NewPrompt("("+RepName+")");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.SetCacheables(["Staff", "StaffLog", "ManTA", "ManAdr"]);

  P:=Memo.ud_mb();
  L_General.Assert(L_APtm.MonthIsClosed(P, L_APtm.system_Salary), "   ");
  IF P_Firm.E_wMultipleMyFirm(SYSDATE()) THEN
   P_Firm.curMyFirm:=P_Firm.ChoiceMyFirm();
  ELSE
   P_Firm.curMyFirm:=P_Firm.mf_Own;
  END;
  L_AFM.MakeMultipleIndex("Tax01", "Man     : LIKE(Man.Man);"+
                                   "PaidTaxT: NUMERIC[2];"+
                                   "PaidTaxM: NUMERIC[2];"+
                                   "PaidTax1: NUMERIC[2];"+
                                   "PaidTax2: NUMERIC[2];"+
                                   "PaidTax3: NUMERIC[2];"+
                                   "PaidTax4: NUMERIC[2] ",
                             "Man: Man");
  DoItOnPer(P, +1);
  IF P > L_DatTim.YearBeg(P) THEN
   IF DBD.FileExist("_MnTA") THEN
    L_AFM.AF_CreateTemp("_MnTA","_MnTA");
   END;
   DoItOnPer(L_DatTim.IncMonth(P, -1), -1);
  END;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  SETSEL(Tax01, Man);
  FOR_EACH Tax01 DO
   SEARCH(Man, Man, , Tax01.Man);
   IF P >= 01\01\2011 THEN
    IF L_Tax.Tax_GetScaleForMainScale(P) = L_Tax.Tax2001_MainScale THEN
     curTax1:=Tax01.PaidTaxM;
     curTax2:=0;
    ELSE
     curTax1:=0;
     curTax2:=Tax01.PaidTaxM;
    END;
   ELSE
    curTax1:=Tax01.PaidTax1;
    curTax2:=Tax01.PaidTax2;
   END;
   MAKEPART(R, Line, curTax1, curTax2);
   INC(tPaidTaxT, Tax01.PaidTaxT);
   INC(tPaidTax1, curTax1);
   INC(tPaidTax2, curTax2);
   INC(tPaidTax3, Tax01.PaidTax3);
   INC(tPaidTax4, Tax01.PaidTax4);
  END; (* FOR_EACH Tax01 *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("Tax01");
  L_General.SurveyLastReport();
 END {Tax01};

END.
