(*
%Copyright   (c) Polak Computer System
%Author      04.02.2000 12:13:20 SAN
%Purpose     প    ଠ樨
%Type        operation
%Specific    SYS
%Modified    13.05.2014 18:53:49 POLAK\Gina
%Environment
*)

 MODULE TaxFrms [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_AFM, Str, L_Str, L_DatTim, L_Packet, L_StdFrm, L_WDO;

 PRIVATE PROCEDURE _PoolItem(Pool: STRING[]; Item: NUMERIC[0]): STRING[];
 BEGIN
  IF ~!Item THEN
   RETURN L_Str.PoolItem(Pool, Item);
  END;
  RETURN "   ";
 END {_PoolItem};

 PRIVATE PROCEDURE ShowPackets(trgReceiver: LIKE(Packet.Receiver));
  VAR
   Caption,
   sl_Pck,
   sl_List  : STRING[];
   sl_Cur   : NUMERIC[0];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Man), " ⠭ ");
  L_AFM.MakeIndex("Pack", "PerB    : DATE;"+
                          "PerE    : DATE;"+
                          "Kind    : LIKE(Packet.Kind);"+
                          "DTStamp : LIKE(Packet.DTStamp);"+
                          "Packet  : LIKE(Packet.Packet)");

  IF SELECT(PckBody, Man, Man.Man) THEN
   WHILE OCCURE(PckBody) DO
    PROMPT(" "+PckBody.Packet);
    CONFORM( PckBody, Packet);
    IF Packet.Receiver=trgReceiver THEN
     Pack.PerB    :=Packet.PerB;
     Pack.PerE    :=Packet.PerE;
     Pack.Kind    :=Packet.Kind;
     Pack.DTStamp :=Packet.DTStamp;
     Pack.Packet  :=Packet.Packet;
     INSERT(Pack);
    END;
    NEXT(PckBody);
   END; (* WHILE OCCURE(PckBody) ... *)
   PROMPT("");
  END;

  SETSEL(Pack, Pack);
  IF LAST(Pack) THEN
   SETEMPTY(sl_Pck, sl_List);
   WHILE OCCURE(Pack) DO
    SEARCH(Packet, Packet, , Pack.Packet);
    sl_Pck :=sl_Pck +  Packet.Packet + "|";
    sl_List:=sl_List +
             Str.Align(L_Str.PoolItem(L_Packet.knd_Pool, Packet.Kind), 10, LEFT)+""+
             Str.Align(Packet.ExtNbr, 8, LEFT)+""+
             L_DatTim.DateStr(Packet.PerB)+" "+L_DatTim.DateStr(Packet.PerE)+""+
             L_Packet.PacketDTStampStr() + "" +
             Packet.Packet+""+
             L_Str.PoolItem(L_Packet.st_ShortPool, Packet.Status)+""+
             _PoolItem("   ||", Packet.DataType)+""+
             _PoolItem("   ||", Packet.CorrType)  + "|";
    PREV(Pack);
   END; (* WHILE OCCURE(Pack) ... *)

   Caption:="ଠ        ਮ               ⠬                   " + "|" +
            "";
   sl_Cur:=L_StdFrm.ShowListAsMenu_wCaption(sl_List, " ᢥ  "+L_Str.PoolItem(L_Packet.rcv_Pool, trgReceiver), Caption);
   SEARCH(Packet, Packet, , L_Str.PoolItem(sl_Pck, sl_Cur));
   L_WDO.PosToCurRecord("Packet", "", 0);
  ELSE
   L_StdFrm.BlueHalt("  "+Man.Man+"  ନ஢     "+L_Str.PoolItem(L_Packet.rcv_Pool, trgReceiver));
  END;
  L_AFM.AF_PurgeTemp("Pack");
 END {ShowPackets};

 PUBLIC PROCEDURE ShowPacketsT3();
 BEGIN
  ShowPackets(L_Packet.rcv_TaxDep);
 END {ShowPacketsT3};

 PUBLIC PROCEDURE ShowPacketsManIns();
 BEGIN
  ShowPackets(L_Packet.rcv_PensFund);
 END {ShowPacketsManIns};

END.
