(*
%Copyright   (c) Polak Computer System
%Author      11.01.2000 13:46:39 SAN
%Purpose     ஫ 䨪樨 ࠢ  室 
%Type        control
%Specific    SYS
%Modified    26.02.2014 16:11:03 POLAK\Gina
%Environment
*)

 MODULE TaxInq [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Tax, Str, L_OwnData, L_AFM, L_Events, L_StdFrm, Memo, L_APtm, L_DatTim,
        L_WDO, Math, L_Env, L_Str, L_Money, SysLog;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, "N.y"
?, L, "N.y"
Man.Man+" "+Man.Name, C, ""
@
############################################################# ########## #####
==============================================================================
|        騥 䨪樨   #######  #######        |
|############################################################################|
|----------------------------------------------------------------------------|
|                               |          |       |            |  ࠢ   |
| 䨪樨                |         |     |    稭|------------|
|                               |          |       |            |       |
|-------------------------------|----------|-------|------------|------------|
}
*)

(*
$P{ Line:
TaxAdv.TaxAdv, L, ""
TaxAdv.Name, L, ""
_MTA._StartD, L, "D.N.y"
_MTA._StopD, L, "N.y"
_MTA._Value, R, "2."
Str.Item("|| | | |||", "|", _MTA._InqType), L, ""
_MTA._Date, L, "D.N.y"
@
|## ############################|##########|#######|############|# ##########|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE ChAuto();
 BEGIN
  L_General.Assert(TaxInq.InqType#L_Tax.inqt_Auto, "䨪 ⮬᪨ ஢ 饭");
 END {ChAuto};

 PUBLIC PROCEDURE ShowActiveTA();
  VAR
   D: DATE;
   curNumber: NUMERIC[0];
 BEGIN
  D:=Memo.gl_mb();
  L_AFM.MakeIndex("_MTA", "_InqType: LIKE(TaxInq.InqType);"+
                          "_Date   : DATE                ;"+
                          "_TaxAdv : LIKE(TaxAdv.TaxAdv) ;"+
                          "_TaxInq : LIKE(ManTA.TaxInq)  ;"+
                          "_StartD : DATE                ;"+
                          "_StopD  : DATE                ;"+
                          "_Value  : LIKE(ManTA.Value)   ;"+
                          "Number  : NUMERIC[0]           ");
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  CONFORM(Staff, Man);
  OPENREP(R, L_General.NameConnection("ActTA"), Create);
  MAKEPART(R, Top, L_DatTim.YearBeg(D), D);
  TRY
   L_Tax.Tax_InitValues(D);
  EXCEPT
  ON Exc: Exc_Raise DO
   L_StdFrm.RedInform(  "祭  䨪権 㤥 ."
                      + "|, ᥭ   ࠢ  ࠢ"
                      + "||(" + Exc.MsgOriginalText + ")");
  END;

  curNumber:=0;
  SELECT(_MnTA, _MnTA, , Man.Man);
  WHILE OCCURE(_MnTA) DO
   L_Tax.Tax_AccessManTA_by_MnTA();
   CONFORM(ManTA, TaxInq);
   _MTA._InqType:=TaxInq.InqType;
   _MTA._Date   :=TaxInq.Date;
   _MTA._TaxAdv :=ManTA.TaxAdv;
   _MTA._TaxInq :=ManTA.TaxInq;
   _MTA._StartD :=ManTA.StartD;
   _MTA._StopD  :=ManTA.StopD;
   _MTA._Value  :=ManTA.Value;
   _MTA.Number  :=curNumber;
   INSERT(_MTA);
   INC(curNumber);
   NEXT(_MnTA);
  END; (* WHILE OCCURE(_MnTA) ... *)
  L_Tax.Tax_FreeValues(D);

  SELECT(_MTA, _MTA);
  WHILE OCCURE(_MTA) DO
   SEARCH(TaxAdv, TaxAdv, , _MTA._TaxAdv);
   MAKEPART(R, Line);
   NEXT(_MTA);
  END; (* WHILE OCCURE(_MTA) ... *)                  
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("_MTA");
 END {ShowActiveTA};

 PRIVATE PROCEDURE TaxInq_OnBeforeEdit();
 BEGIN
  ChAuto();
 END {TaxInq_OnBeforeEdit};

 PRIVATE PROCEDURE TaxInq_OnBeforeDelete();
 BEGIN
  ChAuto();
  L_General.Error(" ࠢ 饭.|筮 㤠  ᥩ  ࠢ");
 END {TaxInq_OnBeforeDelete};

 PRIVATE PROCEDURE TaxInq_OnAfterEditInsert();
 BEGIN
  ChAuto();
  L_APtm.TemporaryChangeMemoDate(TaxInq.Date, PROCREF(ShowActiveTA));
  LIKEMENU(Survey, "");
 END {TaxInq_OnAfterEditInsert};

 PRIVATE PROCEDURE TaxInq_OnAfterEdit();
 BEGIN
  TaxInq_OnAfterEditInsert();
 END {TaxInq_OnAfterEdit};

 PRIVATE PROCEDURE TaxInq_OnAfterInsert();
 BEGIN
  TaxInq_OnAfterEditInsert();
 END {TaxInq_OnAfterInsert};

 PRIVATE PROCEDURE TaxAdv_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow(1, "TaxAdvE");
  L_WDO.iField    (1, "TaxAdv.OwnCode").Format:=L_Tax.Tax2001__oc_Pool;
 END {TaxAdv_OnInitializeWindow};

 PRIVATE PROCEDURE Get_EFT_MnTA();
  VAR
   i: NUMERIC[0];
 BEGIN
  L_AFM.MakeIndex("_MTEF", "_Nbr    : NUMERIC[0]          ;"+
                           "_TaxInq : LIKE(ManTA.TaxInq)  ;"+
                           "_TaxAdv : LIKE(TaxAdv.TaxAdv) ;"+
                           "_StartD : LIKE(ManTA.StartD)  ;"+
                           "_Sum    : LIKE(ManTA.Value)    ");
  SETZERO(i);
  SELECT(_MnTA, _MnTA, , Man.Man, L_Tax.Tax2001_mt_EFT);
  WHILE OCCURE(_MnTA) DO
   L_Tax.Tax_AccessManTA_by_MnTA();
   _MTEF._Nbr    :=i;
   _MTEF._TaxInq :=ManTA.TaxInq;
   _MTEF._TaxAdv :=ManTA.TaxAdv;
   _MTEF._StartD :=ManTA.StartD;
   _MTEF._Sum    :=ManTA.Value;
   INSERT(_MTEF);
   INC(i);
   NEXT(_MnTA);
  END; (* WHILE OCCURE(_MnTA) ... *)
  L_Tax.Tax_FreeValues(Memo.gl_mb());
 END {Get_EFT_MnTA};

 PRIVATE PROCEDURE MnStr(trgSum: NUMERIC[2]): STRING[];
 BEGIN
  RETURN L_Money.MoneyToStr(Memo.gl_mb(), ",", trgSum);
 END {MnStr};

 PUBLIC PROCEDURE ClearEnforcementTA();
  VAR
   i       : NUMERIC[0];
   Idx     : NUMERIC[0][12];
   PoolIns,
   _StrIdx,
   Msg     : STRING[];
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  CONFORM(Staff, Man);
  L_Tax.Tax_InitValues(Memo.gl_mb());
  Get_EFT_MnTA();
  SETZERO(Idx);
  SETEMPTY(Msg, _StrIdx, PoolIns);
  SELECT(_MTEF, _MTEF);
  WHILE OCCURE(_MTEF) DO
   Msg:=Msg + "%#################################%||";
   PoolIns:=PoolIns + "%<" + L_DatTim.DateStr(_MTEF._StartD)+"   " + MnStr(_MTEF._Sum) + ">E";
   _StrIdx:=_StrIdx +" Idx["+L_Str.IntStr(_MTEF._Nbr)+"],";
   NEXT(_MTEF);
  END; (* WHILE OCCURE(_MTEF) ... *)                  
  IF ~!_StrIdx THEN
   _StrIdx:=Str.Slice(_StrIdx, 0, Str.Length(_StrIdx)-1);
   STDFORM(L_StdFrm.sf_Choice("|⭨                        " +
                              "||" + Man.Name +
                              "|| '।  ᪠'" +
                              "||" + Msg,
                              PoolIns),
           " '।  ᪠'", INFORM, , ^_StrIdx);
   i:=0;
   WHILE i < 12 DO
    IF Idx[i] = 1 THEN
     L_General.CallUs(SELECT(_MTEF, _MTEF, i));
     L_General.CallUs(SELECT(ManTA, TaxInq, _MTEF._TaxInq, _MTEF._TaxAdv, _MTEF._StartD));
     IF STDFORM(L_StdFrm.sf_Choice("| 㢥७,   " + L_DatTim.PeriodStr(ManTA.StartD) +
                                   "|| ଫ﫨 㬥  ।  ᪠" +
                                   "|| ࠢ  㬬 " + MnStr(ManTA.Value) + " 㦭 㤠 ?" +
                                   "||",
                                   ""),
                " '।  ᪠'", STOP, ) THEN
      SysLog.Mark("ManTA", Man.Man + "   " + ManTA.TaxAdv + "  㬬 " + MnStr(ManTA.Value));
      REMOVE(ManTA);
      IF ~SELECT(ManTA, TaxInq, _MTEF._TaxInq) THEN
       IF SEARCH(TaxInq, TaxInq, _MTEF._TaxInq) THEN
        SysLog.Mark("TaxInq", Man.Man + "  ⮬᪮ ࠢ " + TaxInq.TaxInq);
        REMOVE(TaxInq);
       END;
      END;
     END;
    END;
    INC(i);
   END;
  ELSE
   L_StdFrm.Inform(" 뫮 ।  ᪠!");
  END;
  L_AFM.AF_PurgeTemp("_MTEF");
 END {ClearEnforcementTA};

 PUBLIC PROCEDURE MakeNewVersion();
  VAR
   D    : DATE;
   First: SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(TaxInq), " ⠭  ࠢ");
  D:=Memo.ud_mb();
  STDFORM(L_StdFrm.sf_Choice("|  䨪樨   ࠢ " + TaxInq.TaxInq +
                             "| ᮧ     %##########%",
                             "%<D.N.y>I" + "|"),
          "   ࠢ", , , D);
  IF D # L_DatTim.MonthBeg(D) THEN
   L_StdFrm.Choice("    砫 ?");
  END;
  First:=1;
  SELECT(ManTA, TaxInq, , TaxInq.TaxInq);
  WHILE OCCURE(ManTA) DO
   IF D <= ManTA.StopD THEN
    L_General.Assert(D > ManTA.StartD, "  ࠢ  䨪樨, " +
                                       "騥  " + L_DatTim.DateStr(ManTA.StartD) + "." +
                                       "||   " + L_DatTim.DateStr(D-1));
    IF First THEN
     SETEMPTY(TaxInq.TaxInq);
     TaxInq.Date:=D;
     INSERT(TaxInq);
     First:=0;
    END;
    SAVE(ManTA);
    ManTA.StartD:=D;
    ManTA.TaxInq:=TaxInq.TaxInq;
    INSERT(ManTA);
    RESTORE(ManTA);
    ManTA.StopD:=D - 1;
    REPLACE(ManTA);
   END;
   NEXT(ManTA);
  END; (* WHILE OCCURE(ManTA) ... *)
  IF First THEN
   L_StdFrm.Inform("  䨪権,    ᤥ");
  END;
 END {MakeNewVersion};

 PRIVATE PROCEDURE Tax_ClearFormedTaxAdv(PerB, PerE: DATE);
 BEGIN
  SETSEL(TaxInq, MyFirm, Staff.MyFirm, Man.Man, L_Tax.inqt_Auto);
  SRCINSEL(TaxInq, GE, , PerB);
  WHILE OCCURE(TaxInq) & (TaxInq.Date<=PerE) DO
   CONFORM(TaxInq, ManTA);
   WHILE OCCURE(ManTA) DO
    REMOVE(ManTA);
   END; (* WHILE OCCURE(ManTA) ... *)
   REMOVE(TaxInq);
  END; (* WHILE OCCURE(TaxInq) ... *)
 END {Tax_ClearFormedTaxAdv};

 PRIVATE PROCEDURE ReCalcNDFL(PerB, PerE: DATE; Silent: SCAL[2]);
  VAR
   Per: DATE;
 BEGIN
  L_APtm.CheckIfBeforeSystemStart(PerE, L_APtm.system_Salary);
  PerB:=Math.Max(PerB, L_Env.aptm_Start);
  L_General.Assert(ACCESS(Staff), " । ࠡ⭨");
  CONFORM(Staff, Man);
  IF ~Silent THEN
   L_StdFrm.Choice(" "+Man.Name+":||   ਮ "+
                   L_DatTim.PeriodStr(PerB)+" - "+L_DatTim.PeriodStr(PerE));
  END;
  SE_INTEGRITY(1);
  Tax_ClearFormedTaxAdv(PerB, PerE);
  L_Tax.Tax2001_InitCodes(PerE);

  L_Tax.ReCalcInClosedYear:=1;

  Per:=PerB;
  WHILE Per <= PerE DO
   PROMPT(" "+Man.Man+":   "+L_DatTim.PeriodStr(Per));
   Memo.gl_SetCurDate(Per);
   SELECT(Staff, Man, , Man.Man);
   WHILE OCCURE(Staff) DO
    IF SEARCH(PCalc, TSN, Staff.TSN, Per) THEN
     PCalc.PurToTax:=0;
     SELECT(Money, TSN, , Staff.TSN, Per);
     WHILE OCCURE(Money) DO
      CONFORM(Money, MCList);
      L_Tax.Tax_FormTaxAdvByMoney(Money.Sum);
      NEXT(Money);
     END; (* WHILE OCCURE(Money) ... *)
     REPLACE(PCalc);
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   Per:=L_DatTim.IncMonth(Per, +1);
  END;
 END {ReCalcNDFL};

 PUBLIC PROCEDURE ReCalcNDFLCurStaff();
 BEGIN
  ReCalcNDFL(L_DatTim.YearBeg(Memo.ud_mb()), Memo.ud_mb(), 0);
 END {ReCalcNDFLCurStaff};

 PRIVATE PROCEDURE TaxAdvE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnReposition]);
  L_WDO.iMayBeEmpty  (0, ["TaxAdv.Till"]);
  L_WDO.iField       (0, "TaxAdv.OwnCode").Format:=L_Tax.Tax2001__oc_Pool;
  L_WDO.iScsChange   (0, ["TaxAdv.OwnCode"]);
  L_WDO.iProgs       (0, "TaxInq");
 END {TaxAdvE_OnInitializeWindow};

 PRIVATE PROCEDURE TaxAdv_OwnCode_OnSuccessfulChange();
 BEGIN
  RTI.Get().CurZone.Fields("TaxAdv.VCode").Modifiable:=TaxAdv.OwnCode=L_Tax.Tax2001__oc_IsMNS;
  IF TaxAdv.OwnCode # L_Tax.Tax2001__oc_IsMNS THEN
   SETEMPTY(TaxAdv.VCode);
   REPLACE(TaxAdv);
  END;
 END {TaxAdv_OwnCode_OnSuccessfulChange};

 PRIVATE PROCEDURE TaxAdvE_0_OnReposition();
 BEGIN
  RTI.Get().CurZone.Fields("TaxAdv.VCode").Modifiable:=TaxAdv.OwnCode=L_Tax.Tax2001__oc_IsMNS;
 END {TaxAdvE_0_OnReposition};

 PRIVATE PROCEDURE TaxInq_OnInitializeWindow();
 BEGIN
  L_WDO.iZone        (1).Narrowing:="(TaxInq.MyFirm=Staff.MyFirm)&(TaxInq.Man=Staff.Man)";
  L_WDO.iZone        (1).PermanentFilter:="TaxInq.InqType # "+ L_Str.IntStr(L_Tax.inqt_Auto);
  L_WDO.iSubwindow   (1, "TaxInqE");
  L_WDO.iField       (1, "TaxInq.InqType").Format:=L_Tax.inqt_Pool;
 END {TaxInq_OnInitializeWindow};

 PRIVATE PROCEDURE TaxInqE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeEdit]);
  L_WDO.iUnmodifiable(0, ["TaxInq.TaxInq"]);
  L_WDO.iMayBeEmpty  (0, ["TaxInq.SrcNum"]);
  L_WDO.iField       (0, "TaxInq.InqType").Format:=L_Tax.inqt_Pool;
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeEdit]);
  L_WDO.iScsChange   (1, ["ManTA.StartD"]);
  L_WDO.iMayBeEmpty  (1, ["ManTA.StopD", "ManTA.Value"]);
 END {TaxInqE_OnInitializeWindow};

BEGIN
 L_Events.ExecuteHandler();
END.
