(*
%Copyright    (c) Polak IT
%Author       04.07.2014 18:01:53 POLAK\LDA
%Purpose      㧪   Excel
%Type         report
%Specific     SYS
%Modified     14.07.2014 17:51:05 POLAK\LDA
*)

 MODULE TBS01 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PRIVATE CONST
  Level_Pool     = "| ண 浪|१|㯯 |ꥪ  ()";
  SumColumnWidth = 18;

 PRIVATE VAR
  curLevel          : LIKE(ccTBS1.Level);
  curRECORDID       : LIKE(ccTBS1.RECORDID);
  UploadQuantity    : SCAL[2];
  ObjectDetailRIArr : LIKE(ccTBS1.RECORDID)[10];
  trgObjectDetailIdx,
  curObjectDetailIdx: NUMERIC[0];
  SumNumberFormat,
  QntNumberFormat   : STRING[];

 PRIVATE PROCEDURE ConvZeroNumToEmpty(Value: NUMERIC[2]): NUMERIC[2];
 BEGIN
  IF Value = 0 THEN
   SETEMPTY(Value);
  END;
  RETURN Value;
 END {ConvZeroNumToEmpty};

 PRIVATE PROCEDURE CalcQnt(trgPerB: DATE; trgAK: LIKE(ccTBSH.AK); VAR trgQnt: L_XObj.tQnt[]);
  VAR
   dmySum : L_XObj.tSum;
   curQnt,
   curSld : L_XObj.tQnt;
 BEGIN
  SAVE(ccTBS1);
  SETZERO(trgQnt);
  IF (ccTBS1.Level > 2 (*l_AcCut *)) & L_MathR.AcCutOfRealStock(ccTBS1.AcCut) THEN
   IF !ccTBS1.XObject THEN
    SETSEL(ccTBS1, Parent, ccTBS1.RECORDID, 1);
   ELSE
    CHANGESEL(ccTBS1, RECORDID, , ccTBS1.RECORDID);
   END;
   curSld:=0;
   FOR_EACH ccTBS1 DO
    IF ~!ccTBS1.XObject THEN
     SETSEL(XCalc, XObject, ccTBS1.XObject, ccTBS1.AcCut);
     IF SRCINSEL(XCalc, LT, trgPerB) THEN
      IF trgAK = L_Acnt.ak_Acn THEN curQnt:=L_XObj.qo_OutSaldo();
      ELSE                          L_XObj.OutRSaldo(dmySum, curQnt);
      END;
      INC(curSld, curQnt);
     END;
    END;
    SETSEL(ccTBS2, TBS1, ccTBS1.RECORDID);
    FOR_EACH ccTBS2 DO
     INC(trgQnt[L_Acnt.uavp_CirDbt], ccTBS2.dQnt);
     INC(trgQnt[L_Acnt.uavp_CirCrd], ccTBS2.cQnt);
    END; (* FOR_EACH ccTBS2 *)
   END; (* FOR_EACH ccTBS1 *)
   IF curSld >= 0 THEN
    trgQnt[L_Acnt.uavp_ISlDbt]:= curSld;
   ELSE
    trgQnt[L_Acnt.uavp_ISlCrd]:=-curSld;
   END;
   INC(curSld, trgQnt[L_Acnt.uavp_CirDbt] - trgQnt[L_Acnt.uavp_CirCrd]);
   IF curSld >= 0 THEN
    trgQnt[L_Acnt.uavp_OSlDbt]:= curSld;
   ELSE
    trgQnt[L_Acnt.uavp_OSlCrd]:=-curSld;
   END;
  END; (* IF ccTBS1.Level > l_AcCut ... *)
  RESTORE(ccTBS1);
 END {CalcQnt};

 PUBLIC PROCEDURE IsZeroNumArray(Array: L_XObj.tQnt[]): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(Array) DO
   IF Array[i] # 0 THEN
    RETURN 0;
   END;
   INC(i);
  END; (* WHILE i <= HIGH(Array)...*)
  RETURN 1;
 END {IsZeroNumArray};

 PRIVATE PROCEDURE PrintLine(VAR curRow: NUMERIC[0]);
  VAR
   begRow: NUMERIC[0];
   trgQnt: L_XObj.tQnt[6];
 BEGIN
  begRow:=curRow;
  L_Excel.wsn_WrStr(L_Str.Repeat("     ", curObjectDetailIdx) + ccTBS1.Sign + " " + ccTBS1.Name);
  L_Excel.wsn_WrNum(ConvZeroNumToEmpty(ccTBS1.Value[L_Acnt.uavp_ISlDbt]));
  L_Excel.wsn_WrNum(ConvZeroNumToEmpty(ccTBS1.Value[L_Acnt.uavp_ISlCrd]));
  L_Excel.wsn_WrNum(ConvZeroNumToEmpty(ccTBS1.Value[L_Acnt.uavp_CirDbt]));
  L_Excel.wsn_WrNum(ConvZeroNumToEmpty(ccTBS1.Value[L_Acnt.uavp_CirCrd]));
  L_Excel.wsn_WrNum(ConvZeroNumToEmpty(ccTBS1.Value[L_Acnt.uavp_OSlDbt]));
  L_Excel.wsn_WrNum(ConvZeroNumToEmpty(ccTBS1.Value[L_Acnt.uavp_OSlCrd]));

  IF UploadQuantity THEN
   CalcQnt(ccTBSH.PerB, ccTBSH.AK, trgQnt);
   IF ~IsZeroNumArray(trgQnt) THEN
    L_Excel.wsn_TermLine();
    INC(curRow);
 
    L_Excel.wsn_MergeCells(begRow, 1, curRow, 1, L_Excel.xlLeft, L_Excel.xlTop);
    L_Excel.wsn_SkipCols(1);
 
    L_Excel.wsn_WrNumF(ConvZeroNumToEmpty(trgQnt[L_Acnt.uavp_ISlDbt]), QntNumberFormat);
    L_Excel.wsn_WrNumF(ConvZeroNumToEmpty(trgQnt[L_Acnt.uavp_ISlCrd]), QntNumberFormat);
    L_Excel.wsn_WrNumF(ConvZeroNumToEmpty(trgQnt[L_Acnt.uavp_CirDbt]), QntNumberFormat);
    L_Excel.wsn_WrNumF(ConvZeroNumToEmpty(trgQnt[L_Acnt.uavp_CirCrd]), QntNumberFormat);
    L_Excel.wsn_WrNumF(ConvZeroNumToEmpty(trgQnt[L_Acnt.uavp_OSlDbt]), QntNumberFormat);
    L_Excel.wsn_WrNumF(ConvZeroNumToEmpty(trgQnt[L_Acnt.uavp_OSlCrd]), QntNumberFormat);
   END;
  END;
  L_Excel.wsn_TermLine();
  INC(curRow);
 END {PrintLine};

 PRIVATE PROCEDURE GetParentLevel(): LIKE(ccTBS1.Level);
  VAR
   Result: LIKE(ccTBS1.Level);
 BEGIN
  SAVE(ccTBS1);
  SEARCH(ccTBS1, RECORDID, , ccTBS1.Parent);
  Result:=ccTBS1.Level;
  RESTORE(ccTBS1);
  RETURN Result;
 END {GetParentLevel};

 PRIVATE PROCEDURE SelectByObjectDetail(trgParent: LIKE(ccTBS1.RECORDID)): SCAL[2];
 BEGIN
  IF !trgObjectDetailIdx | (curObjectDetailIdx > trgObjectDetailIdx) THEN
   SELECT(ccTBS1, TBSH, , ccTBSH.RECORDID, trgParent);
  ELSE
   SELECT(ccTBS1, RECORDID, , ObjectDetailRIArr[curObjectDetailIdx]);
  END;
  RETURN OCCURE(ccTBS1);
 END {SelectByObjectDetail};

 PRIVATE PROCEDURE UploadSingle_ccTBS1(VAR curRow: NUMERIC[0]);
  VAR
   begRow,
   endRow,
   GroupDepth: NUMERIC[0];
   prnLevel,
   trgLevel  : LIKE(ccTBS1.Level);
 BEGIN
  APP.Get().NewPrompt(ccTBS1.Sign + " " + ccTBS1.Name);

  PrintLine(curRow);

  INC(curObjectDetailIdx);
  prnLevel:=ccTBS1.Level;
  SAVE(ccTBS1);
  IF SelectByObjectDetail(ccTBS1.RECORDID) & (ccTBS1.Level <= curLevel) THEN
   begRow  :=curRow;
   trgLevel:=ccTBS1.Level;

   FOR_EACH ccTBS1 DO
    UploadSingle_ccTBS1(curRow);
   END; (* FOR_EACH ccTBS1 *)

   L_Excel.wsn_TermLine();
   INC(curRow);

   endRow:=curRow - 1;

   IF !trgObjectDetailIdx THEN
    GroupDepth:=trgLevel - prnLevel;
   ELSE
    GroupDepth:=1;
   END;

   WHILE GroupDepth > 0 DO
    L_Excel.wsn_Worksheet().Range(L_Str.IntStr(endRow)+":"+L_Str.IntStr(begRow)).Rows.Group();
    DEC(GroupDepth);
   END;
  END;
  RESTORE(ccTBS1);
  DEC(curObjectDetailIdx);
 END {UploadSingle_ccTBS1};

 PRIVATE PROCEDURE SetSumSubColumn(Title: STRING[]);
  VAR
   Column: NUMERIC[0];
 BEGIN
  L_Excel.wsn_AddHeaderItem(Title, SumColumnWidth, 0);
  Column:=L_Excel.wsn_CurCell().Column-1;
  L_Excel.wsn_Worksheet().Columns(Column).HorizontalAlignment:=L_Excel.xlRight;
  L_Excel.wsn_Worksheet().Columns(Column).NumberFormat       :=SumNumberFormat;
 END {SetSumSubColumn};

 PRIVATE PROCEDURE AddSumColumn(Title: STRING[]);
  VAR
   curCell: OBJECT;
 BEGIN
  curCell:=L_Excel.wsn_CurCell();
  L_Excel.wsn_AddHeaderItem(Title, SumColumnWidth * 2, 0);
  L_Excel.wsn_AddHeaderSubItem();
  SetSumSubColumn("");
  SetSumSubColumn("।");
  L_Excel.wsn_HeaderReturnFromSubItem();

  curCell.HorizontalAlignment:=L_Excel.xlCenter;
 END {AddSumColumn};

 PRIVATE PROCEDURE SetTableTitle(Title: STRING[]);
 BEGIN
  L_Excel.wsn_SetCurCellFontSize(14);
  L_Excel.wsn_WrStr(Title);
  L_Excel.wsn_TermLine();
 END {SetTableTitle};

 PRIVATE PROCEDURE TBS01_ExcelTop();
  VAR
   i          : NUMERIC[0];
   Title,
   HeaderTitle: STRING[];
 BEGIN
  Title:="⭮-ᠫ줮 ";
  IF ccTBSH.MyFirm # P_Firm.mf_Fict THEN
   P_Firm.PositionOnMyFirm(ccTBSH.MyFirm);
   Title:=Title + " (" + MyFirm.vzSign + ")";
  END;
  SetTableTitle(Title);
  SetTableTitle(L_Str.PoolItem(" ਮ| ਮ", ccTBSH.AK) + " " + L_DatTim.DateStr(ccTBSH.PerB) + "  " + L_DatTim.DateStr(ccTBSH.PerE));

  L_Excel.wsn_TermLine();

  L_Excel.wsn_StartHeader();
  SETEMPTY(HeaderTitle);
  i:=0;
  WHILE i <= curLevel DO
   HeaderTitle:=L_Str.AddStrDlm(HeaderTitle, "/") + L_Str.PoolItem(Level_Pool, i);
   INC(i);
  END;
  L_Excel.wsn_AddHeaderItem(HeaderTitle, 60, 0);
  L_Excel.wsn_Worksheet().Columns(L_Excel.wsn_CurCell().Column-1).HorizontalAlignment:=L_Excel.xlLeft;

  AddSumColumn("室饥 ᠫ줮");
  AddSumColumn("");
  AddSumColumn("室饥 ᠫ줮");

  L_Excel.wsn_StopHeader();
 END {TBS01_ExcelTop};

 PRIVATE PROCEDURE TBS01_MakeExcel(objWB: OBJECT);
  VAR
   curRow   : NUMERIC[0];
   PageSetup: OBJECT;
 BEGIN
  L_Excel.ws_Create(objWB, "");
  TBS01_ExcelTop();

  curRow            :=L_Excel.wsn_CurCell().Row;
  curObjectDetailIdx:=0;

  IF SelectByObjectDetail(EMPTYOF(ccTBS1.Parent)) THEN
   WHILE OCCURE(ccTBS1) DO
    UploadSingle_ccTBS1(curRow);
    NEXT(ccTBS1);
   END; (* WHILE OCCURE(ccTBS1) ... *)
  END;

  L_Excel.wsn_Worksheet().Cells(1, 1).HorizontalAlignment:=L_Excel.xlCenter;
  L_Excel.wsn_Worksheet().Cells(2, 1).HorizontalAlignment:=L_Excel.xlCenter;
  L_Excel.wsn_FreezePanes(6, 2);

  PageSetup                   :=L_Excel.wsn_Worksheet().PageSetup;
  PageSetup.Orientation       :=L_Excel.xlLandscape;
  PageSetup.LeftMargin        :=objWB.Application.CentimetersToPoints(1);
  PageSetup.TopMargin         :=objWB.Application.CentimetersToPoints(1);
  PageSetup.RightMargin       :=objWB.Application.CentimetersToPoints(1);
  PageSetup.BottomMargin      :=objWB.Application.CentimetersToPoints(1);
  PageSetup.HeaderMargin      :=objWB.Application.CentimetersToPoints(0.5);
  PageSetup.FooterMargin      :=objWB.Application.CentimetersToPoints(0.5);
  PageSetup.CenterHorizontally:=L_Excel.xlTrue;

  PageSetup.Zoom          :=CreateVARIANT(Boolean, L_Excel.xlFalse);
  PageSetup.FitToPagesWide:=1;
  PageSetup.FitToPagesTall:=CreateVARIANT(Boolean, L_Excel.xlFalse);

  L_Excel.wsn_PaintGrid(L_Excel.xlThin, 0);
  L_Excel.wsn_Worksheet().Outline.ShowLevels(1);
 END {TBS01_MakeExcel};

 PRIVATE PROCEDURE GetAnyParentObjectDescrFromCurLevel(    trgLevel: LIKE(ccTBS1.Level);
                                                       VAR ParentRI: LIKE(ccTBS1.RECORDID)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result, ParentRI);
  SAVE(ccTBS1);
  LOOP
   IF (ccTBS1.Level <= trgLevel) | !ccTBS1.Parent THEN
    EXIT;
   END;
   SEARCH(ccTBS1, RECORDID, , ccTBS1.Parent);
  END; (* LOOP *)
  IF ccTBS1.Level = trgLevel THEN
   Result  :=L_Str.PoolItem(Level_Pool, ccTBS1.Level) + " " + ccTBS1.Sign;
   ParentRI:=ccTBS1.RECORDID;
  END;
  RESTORE(ccTBS1);
  RETURN Result;
 END {GetAnyParentObjectDescrFromCurLevel};

 PRIVATE PROCEDURE PrepareObjectDetailList(VAR ObjectDetailList: STRING[]);
  VAR
   i, j        : NUMERIC[0];
   ParentRI    : LIKE(ccTBS1.RECORDID);
   Parent_AsStr: STRING[];
 BEGIN
  SEARCH(ccTBS1, RECORDID, , curRECORDID);

  SETEMPTY(ObjectDetailRIArr);
  SETZERO(i, j);
  ObjectDetailList:="" + "|";
  WHILE i < curLevel DO
   Parent_AsStr:=GetAnyParentObjectDescrFromCurLevel(i, ParentRI);
   IF ~!Parent_AsStr THEN
    ObjectDetailList    :=ObjectDetailList + "|" + Parent_AsStr + "|";
    ObjectDetailRIArr[j]:=ParentRI;
    INC(j);
   END;
   INC(i);
  END;
 END {PrepareObjectDetailList};

 PRIVATE PROCEDURE CheckUploadQuantityPossibility(trgLevel      : LIKE(ccTBS1.Level);
                                                  UploadQuantity: SCAL[2]): SCAL[2];
 BEGIN
  IF UploadQuantity & (trgLevel < 3 (*l_XOGroup*)) THEN
   L_StdFrm.RedInform("㧪 ⢥ ⥫  ⮫쪮  㧪 |" +
                      "  ꥪ '" + L_Str.PoolItem(Level_Pool, 3) + "'   ");
   RETURN 0;
  END;
  RETURN 1;
 END {CheckUploadQuantityPossibility};

 PRIVATE PROCEDURE s_onChangeProc(    VarName         : STRING[];
                                      PrvValue        : ANYTYPE;
                                  VAR curLevel        : LIKE(ccTBS1.Level);
                                  VAR ObjectDetailList: STRING[];
                                  VAR curObjectDetail : NUMERIC[0];
                                  VAR UploadQuantity  : SCAL[2]);
  VAR
   Dummy: SCAL[2];
 BEGIN
  IF    VarName = "curLevel" THEN
   PrepareObjectDetailList(ObjectDetailList);
   Dummy:=CheckUploadQuantityPossibility(curLevel, UploadQuantity);
  ELSIF VarName = "UploadQuantity" THEN
   Dummy:=CheckUploadQuantityPossibility(curLevel, UploadQuantity);
  END;
 END {s_onChangeProc};

 PRIVATE PROCEDURE Settings();
  VAR
   i,
   LevelAmount,
   curObjectDetailIdx: NUMERIC[0];
   LevelList,
   ObjectDetailList  : STRING[];
 BEGIN
  ACCESS(ccTBS1);
  SEARCH(ccTBSH, RECORDID, , ccTBS1.ccTBSH);
  curRECORDID:=ccTBS1.RECORDID;
  curLevel   :=ccTBS1.Level;

  i:=0;
  SETEMPTY(LevelList);
  LOOP
   IF !L_Str.PoolItem(Level_Pool, i) THEN
    EXIT;
   END;
   LevelList:=L_Str.AddStrDlm(LevelList, "|") + L_Str.Repeat(" ", i) + L_Str.PoolItem(Level_Pool, i);
   INC(i);
  END; (* LOOP *)

  PrepareObjectDetailList(ObjectDetailList);

  trgObjectDetailIdx:=0;
  UploadQuantity    :=0;
  LevelAmount       :=MAXOF(ccTBS1.Level) + 1;
  LOOP
   STDFORM(L_StdFrm.sf_Choice("㦠 ꥪ                           " +
                              "|%###########################################%" +
                              L_Str.Repeat("|", LevelAmount)+
                              "|" +
                              "⠫ 㦠                 " +
                              "|%###########################################%" +
                              "|" +
                              "|%###########################################%",
                              "%,"+L_Str.IntStr(LevelAmount)+"<"+LevelList+">O" +
                              "%AI"+
                              "%<㦠 ⢥ ⥫>E" ),
           "⭮-ᠫ줮 ",
           INFORM_NEUTRAL,
           ,
           curLevel, ObjectDetailList, trgObjectDetailIdx, UploadQuantity,
           ,
           PROCREF(s_onChangeProc));
   IF CheckUploadQuantityPossibility(curLevel, UploadQuantity) THEN
    EXIT;
   END;
  END; (* LOOP *)
  IF trgObjectDetailIdx = 0 THEN
   SETEMPTY(trgObjectDetailIdx);
  ELSE
   DEC(trgObjectDetailIdx);
  END;
  SumNumberFormat:="# ##0"+L_Excel.DecimalSeparator()+"00";
  QntNumberFormat:="0"+L_Excel.DecimalSeparator()+"000";
 END {Settings};

 PUBLIC PROCEDURE TBS01();
  VAR
   RepName: STRING[];
 BEGIN
  Settings();
  RepName :="TBS01_"+ccTBSH.AK+"_"+FLDTOSTR(ccTBSH.PerB, "YND")+"_"+FLDTOSTR(ccTBSH.PerE, "YND")+"_"+FLDTOSTR(SYSTIMESTAMP(), "yNDHMS");
  L_Excel.BuildRep(PROCREF(TBS01_MakeExcel), FIO.AsbSpecialFolders("ASBTemp"), RepName, 0, 1);
 END {TBS01};

END.
