(*
%Copyright   (c) Polak IT
%Author      11.01.2009 08:51:46 POLAK\LDA
%Purpose     ⠢   c 2009 
%Type        Library card
%Specific    SYS
%Modified    05.03.2010 10:48:36 POLAK\LDA
%Environment
*)

 IMPORT L_Car, L_Russia, L_General;

 PROCEDURE GetTransportTaxRate(_BPer    : DATE;
                               _IRC_VehT: LIKE(VehType.IRC_VehT);
                               _Age     : NUMERIC[0];
                               _EngPower: LIKE(VehPasp.EngPower)): NUMERIC[2];
  VAR
   i: NUMERIC[0];
   Scale  : NUMERIC[1][8];
   TaxRate: NUMERIC[2][8];
 BEGIN
  SETEMPTY(Scale, TaxRate);
  IF _IRC_VehT = L_Car.ircvt_NotQualified THEN
   RETURN 0;
  END;
  IF Region.Region = L_Russia.reg_50 THEN
   IF _BPer >= 01\01\2009 THEN
    IF    _IRC_VehT = L_Car.ircvt_PassengerCar THEN
     Scale[0]:=0.0;   TaxRate[0]:=7.00;
     Scale[1]:=100.0; TaxRate[1]:=26.00;
     Scale[2]:=150.0; TaxRate[2]:=39.00;
     Scale[3]:=200.0; TaxRate[3]:=65.00;
     Scale[4]:=250.0; TaxRate[4]:=130.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Motorcycle THEN
     Scale[0]:=0.0;   TaxRate[0]:=7.00;
     Scale[1]:=20.0;  TaxRate[1]:=13.00;
     Scale[2]:=35.0;  TaxRate[2]:=42.00;
    ELSIF (_IRC_VehT = L_Car.ircvt_Bus_wUL_UpTo5Year) |
          (_IRC_VehT = L_Car.ircvt_Bus_wUL_Over5Year) THEN
     IF _Age <= 5 THEN
      Scale[0]:=0.0;   TaxRate[0]:=22.00;
      Scale[1]:=200.0; TaxRate[1]:=44.00;
     ELSE
      Scale[0]:=0.0;   TaxRate[0]:=26.00;
      Scale[1]:=200.0; TaxRate[1]:=52.00;
     END;
    ELSIF (_IRC_VehT = L_Car.ircvt_Truck_wUL_UpTo5Year) |
          (_IRC_VehT = L_Car.ircvt_Truck_wUL_Over5Year) THEN
     IF _Age <= 5 THEN
      Scale[0]:=0.0;   TaxRate[0]:=17.00;
      Scale[1]:=100.0; TaxRate[1]:=22.00;
      Scale[2]:=150.0; TaxRate[2]:=28.00;
      Scale[3]:=200.0; TaxRate[3]:=39.00;
      Scale[4]:=250.0; TaxRate[4]:=50.00;
     ELSE
      Scale[0]:=0.0;   TaxRate[0]:=20.00;
      Scale[1]:=100.0; TaxRate[1]:=26.00;
      Scale[2]:=150.0; TaxRate[2]:=33.00;
      Scale[3]:=200.0; TaxRate[3]:=46.00;
      Scale[4]:=250.0; TaxRate[4]:=59.00;
     END;
    ELSIF _IRC_VehT = L_Car.ircvt_SelfPropelledCar THEN
     Scale[0]:=0.0;   TaxRate[0]:=16.00;
    ELSIF _IRC_VehT = L_Car.ircvt_SnowMobile THEN
     Scale[0]:=0.0;   TaxRate[0]:=25.00;
     Scale[1]:=50.0;  TaxRate[1]:=50.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Boat THEN
     Scale[0]:=0.0;   TaxRate[0]:=50.00;
     Scale[1]:=100.0; TaxRate[1]:=100.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Yacht THEN
     Scale[0]:=0.0;   TaxRate[0]:=100.00;
     Scale[1]:=100.0; TaxRate[1]:=200.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Scooter THEN
     Scale[0]:=0.0;   TaxRate[0]:=125.00;
     Scale[1]:=100.0; TaxRate[1]:=250.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Barge THEN
     Scale[0]:=0.0;   TaxRate[0]:=52.00;
    ELSIF _IRC_VehT = L_Car.ircvt_AirCraft THEN
     Scale[0]:=0.0;   TaxRate[0]:=125.00;
    ELSIF _IRC_VehT = L_Car.ircvt_JetAirplane THEN
     Scale[0]:=0.0;   TaxRate[0]:=100.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Glider THEN
     Scale[0]:=0.0;   TaxRate[0]:=780.00;
    END;
   END;
  ELSIF Region.Region = L_Russia.reg_77 THEN
   IF      _BPer >= 01\01\2009 THEN
    IF     _IRC_VehT = L_Car.ircvt_PassengerCar THEN
     Scale[0]:=0.0;   TaxRate[0]:=7.00;
     Scale[1]:=100.0; TaxRate[1]:=20.00;
     Scale[2]:=125.0; TaxRate[2]:=30.00;
     Scale[3]:=150.0; TaxRate[3]:=38.00;
     Scale[4]:=175.0; TaxRate[4]:=45.00;
     Scale[5]:=200.0; TaxRate[5]:=60.00;
     Scale[6]:=225.0; TaxRate[6]:=75.00;
     Scale[7]:=250.0; TaxRate[7]:=150.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Motorcycle THEN
     Scale[0]:=0.0;   TaxRate[0]:=7.00;
     Scale[1]:=20.0;  TaxRate[1]:=15.00;
     Scale[2]:=35.0;  TaxRate[2]:=50.00;
    ELSIF (_IRC_VehT = L_Car.ircvt_Bus_wUL_UpTo5Year) |
          (_IRC_VehT = L_Car.ircvt_Bus_wUL_Over5Year) THEN
     IF _Age <= 5 THEN
      Scale[0]:=0.0;   TaxRate[0]:=10.00;
      Scale[1]:=110.0; TaxRate[1]:=17.00;
      Scale[2]:=200.0; TaxRate[2]:=35.00;
     ELSE
      Scale[0]:=0.0;   TaxRate[0]:=15.00;
      Scale[1]:=110.0; TaxRate[1]:=26.00;
      Scale[2]:=200.0; TaxRate[2]:=55.00;
     END;
    ELSIF (_IRC_VehT = L_Car.ircvt_Truck_wUL_UpTo5Year) |
          (_IRC_VehT = L_Car.ircvt_Truck_wUL_Over5Year) THEN
     IF _Age <= 5 THEN
      Scale[0]:=0.0;   TaxRate[0]:=10.00;
      Scale[1]:=100.0; TaxRate[1]:=17.00;
      Scale[2]:=150.0; TaxRate[2]:=25.00;
      Scale[3]:=200.0; TaxRate[3]:=35.00;
      Scale[4]:=250.0; TaxRate[4]:=45.00;
     ELSE
      Scale[0]:=0.0;   TaxRate[0]:=15.00;
      Scale[1]:=100.0; TaxRate[1]:=26.00;
      Scale[2]:=150.0; TaxRate[2]:=38.00;
      Scale[3]:=200.0; TaxRate[3]:=55.00;
      Scale[4]:=250.0; TaxRate[4]:=70.00;
     END;
    ELSIF _IRC_VehT = L_Car.ircvt_SelfPropelledCar THEN
     Scale[0]:=0.0;  TaxRate[0]:=20.00;
    ELSIF _IRC_VehT = L_Car.ircvt_SnowMobile THEN
     Scale[0]:=0.0;   TaxRate[0]:=25.0;
     Scale[1]:=50.0;  TaxRate[1]:=50.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Boat THEN
     Scale[0]:=0.0;   TaxRate[0]:=50.00;
     Scale[1]:=100.0; TaxRate[2]:=100.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Yacht THEN
     Scale[0]:=0.0;   TaxRate[0]:=100.00;
     Scale[1]:=100.0; TaxRate[1]:=200.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Scooter THEN
     Scale[0]:=0.0;   TaxRate[0]:=125.00;
     Scale[1]:=100.0; TaxRate[1]:=250.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Barge THEN
     Scale[0]:=0.0;   TaxRate[0]:=65.00;
    ELSIF _IRC_VehT = L_Car.ircvt_AirCraft THEN
     Scale[0]:=0.0;   TaxRate[0]:=125.00;
    ELSIF _IRC_VehT = L_Car.ircvt_JetAirplane THEN
     Scale[0]:=0.0;   TaxRate[0]:=100.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Glider THEN
     Scale[0]:=0.0;   TaxRate[0]:=800.00;
    END;
   END;
  ELSIF Region.Region = L_Russia.reg_72 THEN
   IF _BPer >= 01\01\2009 THEN
    IF    _IRC_VehT = L_Car.ircvt_PassengerCar THEN
     Scale[0]:=0.0;   TaxRate[0]:=10.00;
     Scale[1]:=100.0; TaxRate[1]:=30.00;
     Scale[2]:=150.0; TaxRate[2]:=34.00;
     Scale[3]:=200.0; TaxRate[3]:=40.00;
     Scale[4]:=250.0; TaxRate[4]:=66.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Motorcycle THEN
     Scale[0]:=0.0;   TaxRate[0]:=4.00;
     Scale[1]:=20.0;  TaxRate[1]:=8.00;
     Scale[2]:=35.0;  TaxRate[2]:=20.00;
    ELSIF (_IRC_VehT = L_Car.ircvt_Bus_wUL_UpTo5Year) |
          (_IRC_VehT = L_Car.ircvt_Bus_wUL_Over5Year) THEN
     Scale[0]:=0.0;   TaxRate[0]:=30.00;
     Scale[1]:=200.0; TaxRate[1]:=40.00;
    ELSIF (_IRC_VehT = L_Car.ircvt_Truck_wUL_UpTo5Year) |
          (_IRC_VehT = L_Car.ircvt_Truck_wUL_Over5Year) THEN
     Scale[0]:=0.0;   TaxRate[0]:=25.00;
     Scale[1]:=100.0; TaxRate[1]:=40.00;
     Scale[2]:=150.0; TaxRate[2]:=50.00;
     Scale[3]:=200.0; TaxRate[3]:=65.00;
     Scale[4]:=250.0; TaxRate[4]:=85.00;
    ELSIF _IRC_VehT = L_Car.ircvt_SelfPropelledCar THEN
     Scale[0]:=0.0;   TaxRate[0]:=25.00;
    ELSIF _IRC_VehT = L_Car.ircvt_SnowMobile THEN
     Scale[0]:=0.0;   TaxRate[0]:=10.00;
     Scale[1]:=50.0;  TaxRate[1]:=20.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Boat THEN
     Scale[0]:=0.0;   TaxRate[0]:=20.00;
     Scale[1]:=100.0; TaxRate[1]:=40.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Yacht THEN
     Scale[0]:=0.0;   TaxRate[0]:=50.00;
     Scale[1]:=100.0; TaxRate[1]:=100.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Scooter THEN
     Scale[0]:=0.0;   TaxRate[0]:=50.00;
     Scale[1]:=100.0; TaxRate[1]:=100.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Barge THEN
     Scale[0]:=0.0;   TaxRate[0]:=40.00;
    ELSIF _IRC_VehT = L_Car.ircvt_AirCraft THEN
     Scale[0]:=0.0;   TaxRate[0]:=50.00;
    ELSIF _IRC_VehT = L_Car.ircvt_JetAirplane THEN
     Scale[0]:=0.0;   TaxRate[0]:=50.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Glider THEN
     Scale[0]:=0.0;   TaxRate[0]:=400.00;
    END;
   END;
  ELSE
   L_General.Error(" ࠭ᯮ⭮   ॣ " + Region.Region + "  ন");
  END;
  L_General.Assert(~!Scale[0], " ⨯   䨪樨  " + _IRC_VehT);

  i:=1;
  WHILE ~!Scale[i] & (Scale[i] < _EngPower) DO
   INC(i);
  END;
  RETURN TaxRate[i-1];
 END {GetTransportTaxRate};

END.
