(*
%Copyright   (c) Polak IT
%Author      25.12.2012 12:51:36 POLAK\LDA
%Purpose     ⠢   2013 
%Type
%Specific    SYS
%Modified    15.01.2013 16:56:58 POLAK\LDA
%Environment
*)

 IMPORT L_Car, L_Russia, L_General;

 PROCEDURE GetTransportTaxRate(_BPer    : DATE;
                               _IRC_VehT: LIKE(VehType.IRC_VehT);
                               _Age     : NUMERIC[0];
                               _EngPower: LIKE(VehPasp.EngPower)): NUMERIC[2];
  VAR
   i      : NUMERIC[0];
   Scale  : NUMERIC[1][8];
   TaxRate: NUMERIC[2][8];
 BEGIN
  SETEMPTY(Scale, TaxRate);
  IF _IRC_VehT = L_Car.ircvt_NotQualified THEN
   RETURN 0;
  END;
  IF _BPer >= 01\01\2013 THEN
   IF Region.Region = L_Russia.reg_50 THEN
    IF    _IRC_VehT = L_Car.ircvt_PassengerCar THEN
     Scale[0]:=0.0;   TaxRate[0]:=7.00;
     Scale[1]:=100.0; TaxRate[1]:=29.00;
     Scale[2]:=150.0; TaxRate[2]:=43.00;
     Scale[3]:=200.0; TaxRate[3]:=72.00;
     Scale[4]:=250.0; TaxRate[4]:=143.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Motorcycle THEN
     Scale[0]:=0.0;   TaxRate[0]:=8.00;
     Scale[1]:=20.0;  TaxRate[1]:=14.00;
     Scale[2]:=35.0;  TaxRate[2]:=46.00;
    ELSIF (_IRC_VehT = L_Car.ircvt_Bus_wUL_UpTo5Year) |
          (_IRC_VehT = L_Car.ircvt_Bus_wUL_Over5Year) THEN
     IF _Age <= 5 THEN
      Scale[0]:=0.0;   TaxRate[0]:=24.00;
      Scale[1]:=200.0; TaxRate[1]:=48.00;
     ELSE
      Scale[0]:=0.0;   TaxRate[0]:=29.00;
      Scale[1]:=200.0; TaxRate[1]:=57.00;
     END;
    ELSIF (_IRC_VehT = L_Car.ircvt_Truck_wUL_UpTo5Year) |
          (_IRC_VehT = L_Car.ircvt_Truck_wUL_Over5Year) THEN
     IF _Age <= 5 THEN
      Scale[0]:=0.0;   TaxRate[0]:=17.00;
      Scale[1]:=100.0; TaxRate[1]:=22.00;
      Scale[2]:=150.0; TaxRate[2]:=28.00;
      Scale[3]:=200.0; TaxRate[3]:=39.00;
      Scale[4]:=250.0; TaxRate[4]:=50.00;
     ELSE
      Scale[0]:=0.0;   TaxRate[0]:=22.00;
      Scale[1]:=100.0; TaxRate[1]:=29.00;
      Scale[2]:=150.0; TaxRate[2]:=36.00;
      Scale[3]:=200.0; TaxRate[3]:=51.00;
      Scale[4]:=250.0; TaxRate[4]:=65.00;
     END;
    ELSIF _IRC_VehT = L_Car.ircvt_SelfPropelledCar THEN
     Scale[0]:=0.0;   TaxRate[0]:=18.00;
    ELSIF _IRC_VehT = L_Car.ircvt_SnowMobile THEN
     Scale[0]:=0.0;   TaxRate[0]:=25.00;
     Scale[1]:=50.0;  TaxRate[1]:=50.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Boat THEN
     Scale[0]:=0.0;   TaxRate[0]:=55.00;
     Scale[1]:=100.0; TaxRate[1]:=110.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Yacht THEN
     Scale[0]:=0.0;   TaxRate[0]:=110.00;
     Scale[1]:=100.0; TaxRate[1]:=220.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Scooter THEN
     Scale[0]:=0.0;   TaxRate[0]:=138.00;
     Scale[1]:=100.0; TaxRate[1]:=275.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Barge THEN
     Scale[0]:=0.0;   TaxRate[0]:=57.00;
    ELSIF _IRC_VehT = L_Car.ircvt_AirCraft THEN
     Scale[0]:=0.0;   TaxRate[0]:=138.00;
    ELSIF _IRC_VehT = L_Car.ircvt_JetAirplane THEN
     Scale[0]:=0.0;   TaxRate[0]:=110.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Glider THEN
     Scale[0]:=0.0;   TaxRate[0]:=858.00;
    END;
   ELSIF Region.Region = L_Russia.reg_77 THEN
    IF     _IRC_VehT = L_Car.ircvt_PassengerCar THEN
     Scale[0]:=0.0;   TaxRate[0]:=12.00;
     Scale[1]:=100.0; TaxRate[1]:=25.00;
     Scale[2]:=125.0; TaxRate[2]:=35.00;
     Scale[3]:=150.0; TaxRate[3]:=45.00;
     Scale[4]:=175.0; TaxRate[4]:=50.00;
     Scale[5]:=200.0; TaxRate[5]:=65.00;
     Scale[6]:=225.0; TaxRate[6]:=75.00;
     Scale[7]:=250.0; TaxRate[7]:=150.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Motorcycle THEN
     Scale[0]:=0.0;   TaxRate[0]:=7.00;
     Scale[1]:=20.0;  TaxRate[1]:=15.00;
     Scale[2]:=35.0;  TaxRate[2]:=50.00;
    ELSIF (_IRC_VehT = L_Car.ircvt_Bus_wUL_UpTo5Year) |
          (_IRC_VehT = L_Car.ircvt_Bus_wUL_Over5Year) THEN
     Scale[0]:=0.0;   TaxRate[0]:=15.00;
     Scale[1]:=110.0; TaxRate[1]:=26.00;
     Scale[2]:=200.0; TaxRate[2]:=55.00;
    ELSIF (_IRC_VehT = L_Car.ircvt_Truck_wUL_UpTo5Year) |
          (_IRC_VehT = L_Car.ircvt_Truck_wUL_Over5Year) THEN
     Scale[0]:=0.0;   TaxRate[0]:=15.00;
     Scale[1]:=100.0; TaxRate[1]:=26.00;
     Scale[2]:=150.0; TaxRate[2]:=38.00;
     Scale[3]:=200.0; TaxRate[3]:=55.00;
     Scale[4]:=250.0; TaxRate[4]:=70.00;
    ELSIF _IRC_VehT = L_Car.ircvt_SelfPropelledCar THEN
     Scale[0]:=0.0;  TaxRate[0]:=25.00;
    ELSIF _IRC_VehT = L_Car.ircvt_SnowMobile THEN
     Scale[0]:=0.0;   TaxRate[0]:=25.0;
     Scale[1]:=50.0;  TaxRate[1]:=50.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Boat THEN
     Scale[0]:=0.0;   TaxRate[0]:=100.00;
     Scale[1]:=100.0; TaxRate[2]:=200.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Yacht THEN
     Scale[0]:=0.0;   TaxRate[0]:=200.00;
     Scale[1]:=100.0; TaxRate[1]:=400.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Scooter THEN
     Scale[0]:=0.0;   TaxRate[0]:=250.00;
     Scale[1]:=100.0; TaxRate[1]:=500.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Barge THEN
     Scale[0]:=0.0;   TaxRate[0]:=200.00;
    ELSIF _IRC_VehT = L_Car.ircvt_AirCraft THEN
     Scale[0]:=0.0;   TaxRate[0]:=250.00;
    ELSIF _IRC_VehT = L_Car.ircvt_JetAirplane THEN
     Scale[0]:=0.0;   TaxRate[0]:=200.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Glider THEN
     Scale[0]:=0.0;   TaxRate[0]:=2000.00;
    END;
   ELSIF Region.Region = L_Russia.reg_72 THEN
    IF    _IRC_VehT = L_Car.ircvt_PassengerCar THEN
     Scale[0]:=0.0;   TaxRate[0]:=10.00;
     Scale[1]:=100.0; TaxRate[1]:=30.00;
     Scale[2]:=150.0; TaxRate[2]:=34.00;
     Scale[3]:=200.0; TaxRate[3]:=40.00;
     Scale[4]:=250.0; TaxRate[4]:=66.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Motorcycle THEN
     Scale[0]:=0.0;   TaxRate[0]:=4.00;
     Scale[1]:=20.0;  TaxRate[1]:=8.00;
     Scale[2]:=35.0;  TaxRate[2]:=20.00;
    ELSIF (_IRC_VehT = L_Car.ircvt_Bus_wUL_UpTo5Year) |
          (_IRC_VehT = L_Car.ircvt_Bus_wUL_Over5Year) THEN
     Scale[0]:=0.0;   TaxRate[0]:=30.00;
     Scale[1]:=200.0; TaxRate[1]:=40.00;
    ELSIF (_IRC_VehT = L_Car.ircvt_Truck_wUL_UpTo5Year) |
          (_IRC_VehT = L_Car.ircvt_Truck_wUL_Over5Year) THEN
     Scale[0]:=0.0;   TaxRate[0]:=25.00;
     Scale[1]:=100.0; TaxRate[1]:=40.00;
     Scale[2]:=150.0; TaxRate[2]:=50.00;
     Scale[3]:=200.0; TaxRate[3]:=65.00;
     Scale[4]:=250.0; TaxRate[4]:=85.00;
    ELSIF _IRC_VehT = L_Car.ircvt_SelfPropelledCar THEN
     Scale[0]:=0.0;   TaxRate[0]:=25.00;
    ELSIF _IRC_VehT = L_Car.ircvt_SnowMobile THEN
     Scale[0]:=0.0;   TaxRate[0]:=10.00;
     Scale[1]:=50.0;  TaxRate[1]:=20.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Boat THEN
     Scale[0]:=0.0;   TaxRate[0]:=20.00;
     Scale[1]:=100.0; TaxRate[1]:=40.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Yacht THEN
     Scale[0]:=0.0;   TaxRate[0]:=50.00;
     Scale[1]:=100.0; TaxRate[1]:=100.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Scooter THEN
     Scale[0]:=0.0;   TaxRate[0]:=50.00;
     Scale[1]:=100.0; TaxRate[1]:=100.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Barge THEN
     Scale[0]:=0.0;   TaxRate[0]:=40.00;
    ELSIF _IRC_VehT = L_Car.ircvt_AirCraft THEN
     Scale[0]:=0.0;   TaxRate[0]:=50.00;
    ELSIF _IRC_VehT = L_Car.ircvt_JetAirplane THEN
     Scale[0]:=0.0;   TaxRate[0]:=50.00;
    ELSIF _IRC_VehT = L_Car.ircvt_Glider THEN
     Scale[0]:=0.0;   TaxRate[0]:=400.00;
    END;
   ELSE
    L_General.Error(" ࠭ᯮ⭮   ॣ " + Region.Region + "  ন");
   END;
   L_General.Assert(~!Scale[0], " ⨯   䨪樨  " + _IRC_VehT);
  ELSE
   L_General.CallUs(0);
  END; (* IF _BPer >= 01\01\2013...*)

  i:=1;
  WHILE ~!Scale[i] & (Scale[i] < _EngPower) DO
   INC(i);
  END;
  RETURN TaxRate[i-1];
 END {GetTransportTaxRate};

END.
