(*
%Copyright   (c) Polak IT
%Author      30.05.2012 12:59:04 POLAK\MLB
%Purpose      ᪮ ଠ樨
%Type        control
%Specific    AP
%Modified    29.10.2013 17:04:34 POLAK\MLB
%Environment
*)
 MODULE UIStat [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, L_General, L_Prop, L_Str, L_SES, FIO, L_Basis, L_DatTim, L_FIO, L_StdFrm, L_AFM, P_Man;

 PRIVATE CONST
  rn_Version = "";
  rn_OS      = "";
  rn_Monitor = "";
  rn_MAC     = "MAC-";
  rn_User    = "짮⥫";
  rn_Comp    = "";
  rn_Proc    = "";

  Version        = 2;
  ValId          = "UserDescription";
  suiteAmnt      = 16;
  MaxMonitorAmnt = 2;
  ts_Pool        =" | |Client|TerminalAgent|AutomationServer|Utility|Editor";

  RepName = "UIStt";
  Title   = "஢ઠ ଠ樨  ";

 PRIVATE PROCEDURE Encode_OSInformation(): STRING[];
  VAR
   OSName,
   Record,
   Result     : STRING[];
   platform   : SCAL[4];
   major      : NUMERIC[0];
   minor      : NUMERIC[0];
   build      : NUMERIC[0];
   csdver     : STRING[];
   productType: NUMERIC[0];
   suite      : SCAL[2][suiteAmnt];
   wow64      : NUMERIC[0];
   productId  : NUMERIC[0];
   Idx        : SCAL[suiteAmnt];
 BEGIN
  SETEMPTY(Result, Record);
  OSName    :=L_General.GetOSName();
  OSVERSION(platform, major, minor, build, csdver, productType, suite, wow64, productId);
  L_Prop.putRecordElement(Record, rn_OS);
  L_Prop.putRecordElement(Record, OSName);
  L_Prop.putRecordElement(Record, platform);
  L_Prop.putRecordElement(Record, major);
  L_Prop.putRecordElement(Record, minor);
  L_Prop.putRecordElement(Record, build);
  L_Prop.putRecordElement(Record, csdver);
  L_Prop.putRecordElement(Record, productType);
  FOR_EACH Idx DO
   L_Prop.putRecordElement(Record, suite[Idx]);
  END;
  L_Prop.putRecordElement(Record, wow64);
  L_Prop.putRecordElement(Record, productId);
  L_Prop.putArrayItem(Result, Record);
  RETURN Result;
 END {Encode_OSInformation};

 PRIVATE PROCEDURE Encode_MonitorsInformation(): STRING[];
  VAR
   Result,
   Resolution,
   Record            : STRING[];
   Primary           : SCAL[2];
   MonitorsCollection: MONITORS;
   curMonitor        : MONITOR;
   Idx               : NUMERIC[0];
 BEGIN
  SETEMPTY(Result);
  MonitorsCollection:=MONITORS.Create();
  Idx               :=0;
  WHILE Idx < MonitorsCollection.Count DO
   SETEMPTY(Record);
   curMonitor:=MonitorsCollection.Item(Idx);
   Primary   :=curMonitor.Primary;
   Resolution:=L_Str.IntStr(curMonitor.Screen.Right - curMonitor.Screen.Left) + "x" +
               L_Str.IntStr(curMonitor.Screen.Bottom - curMonitor.Screen.Top);
   L_Prop.putRecordElement(Record, rn_Monitor);
   L_Prop.putRecordElement(Record, Idx);
   L_Prop.putRecordElement(Record, Primary);
   L_Prop.putRecordElement(Record, Resolution);
   L_Prop.putArrayItem(Result, Record);
   INC(Idx);
  END; (* WHILE Idx < ... *)
  RETURN Result;
 END {Encode_MonitorsInformation};

 PRIVATE PROCEDURE Encode_MACAddressInformation(): STRING[];
  VAR
   Result,
   Record,
   MAC       : STRING[];
   Idx, N    : NUMERIC[0];
 BEGIN
  SETEMPTY(Result, Record);
  MAC       :=PSTATION();
  L_Prop.putRecordElement(Record, rn_MAC);
  L_Prop.putRecordElement(Record, MAC);
  N         :=(Str.Length(MAC) DIV 2) - 1;
  Idx       :=1;
  WHILE Idx <= N DO
   MAC:=Str.Insert(MAC, "-", Idx*3-1);
   INC(Idx);
  END; (* WHILE Idx <= ... *)
  L_Prop.putRecordElement(Record, MAC);
  L_Prop.putArrayItem(Result, Record);
  RETURN Result;
 END {Encode_MACAddressInformation};

 PRIVATE PROCEDURE Encode_UserInformation(): STRING[];
  VAR
   Result,
   UserId,
   Record  : STRING[];
   TypeSes,
   Age     : NUMERIC[0];
   curMan  : LIKE(Man.Man);
 BEGIN
  SETEMPTY(Result, Record, Age);
  UserId:=L_General.curUSER;
  IF L_General.GetAPSiteNumber() # 00 THEN
   curMan:=P_Man.Try_curUSER2Man();
   IF ~!curMan THEN
    SEARCH(Man, Man, , curMan);
    Age:=L_DatTim.CompleteYearsInIntvl(Man.Birth, SYSDATE());
   END;
  END;
  TypeSes:=APPLICATION.Get().MyConnection.Type;
  L_Prop.putRecordElement(Record, rn_User);
  L_Prop.putRecordElement(Record, UserId);
  L_Prop.putRecordElement(Record, Age);
  L_Prop.putRecordElement(Record, TypeSes);
  L_Prop.putArrayItem(Result, Record);
  RETURN Result;
 END {Encode_UserInformation};

 PRIVATE PROCEDURE Encode_ComputerInformation(): STRING[];
  CONST
   strComputer = ".";
  VAR
   oWMI       : OBJECT;
   oComps     : OBJECT;
   oComp      : OBJECT;
   CompName,
   NumOfProcs,
   TotPhysMem,
   Record,
   Result     : STRING[];
 BEGIN
  SETEMPTY(Result);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   oWMI  := GET_OBJECT("winmgmts:{impersonationLevel=impersonate}!\\" + strComputer + "\root\cimv2");
   oComps:= oWMI.ExecQuery("Select * from Win32_ComputerSystem");
   FOR_EACH oComp IN oComps DO
    CompName  :=oComp.Name;
    NumOfProcs:=FLDTOSTR(oComp.NumberOfProcessors,  "N0", 0);
    TotPhysMem:=FLDTOSTR(oComp.TotalPhysicalMemory, "N0", 0);
    SETEMPTY(Record);
    L_Prop.putRecordElement(Record, rn_Comp);
    L_Prop.putRecordElement(Record, CompName);
    L_Prop.putRecordElement(Record, NumOfProcs);
    L_Prop.putRecordElement(Record, TotPhysMem);
    L_Prop.putArrayItem(Result, Record);
   END; (* FOR_EACH ...*)
  EXCEPT
  ON Exc: Exc_Object DO
   (* nothing *)
  ELSE
   RAISE();
  END;
  RETURN Result;
 END {Encode_ComputerInformation};

 PRIVATE PROCEDURE Encode_ProcessorsInformation(): STRING[];
  CONST
   strComputer = ".";
  VAR
   oWMI       : OBJECT;
   oProcessors: OBJECT;
   oProcessor : OBJECT;
   DeviceID,
   ProcName,
   ProcId,
   Description,
   Caption,
   ClockSpeed,
   Status,
   Record,
   Result     : STRING[];
 BEGIN
  SETEMPTY(Result);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   oWMI       := GET_OBJECT("winmgmts:\\" + strComputer + "\root\cimv2");
   oProcessors:= oWMI.ExecQuery("Select * from Win32_Processor");
   FOR_EACH oProcessor IN oProcessors DO
    DeviceID   :=oProcessor.DeviceID;
    ProcName   :=oProcessor.Name;
    ProcId     :=oProcessor.ProcessorId;
    Description:=oProcessor.Description;
    Caption    :=oProcessor.Caption;
    ClockSpeed :=FLDTOSTR(oProcessor.MaxClockSpeed, "N0", 0);
    Status     :=oProcessor.Status;
    SETEMPTY(Record);
    L_Prop.putRecordElement(Record, rn_Proc);
    L_Prop.putRecordElement(Record, DeviceID);
    L_Prop.putRecordElement(Record, ProcName);
    L_Prop.putRecordElement(Record, ProcId);
    L_Prop.putRecordElement(Record, Description);
    L_Prop.putRecordElement(Record, Caption);
    L_Prop.putRecordElement(Record, ClockSpeed);
    L_Prop.putRecordElement(Record, Status);
    L_Prop.putArrayItem(Result, Record);
    EXIT;
   END;
  EXCEPT
  ON Exc: Exc_Object DO
   (* nothing *)
  ELSE
   RAISE();
  END;
  RETURN Result;
 END {Encode_ProcessorsInformation};

 PRIVATE PROCEDURE Encode_VersionInformation(): STRING[];
  VAR
   Record,
   Result: STRING[];
 BEGIN
  SETEMPTY(Result, Record);
  L_Prop.putRecordElement(Record, rn_Version);
  L_Prop.putRecordElement(Record, Version);
  L_Prop.putArrayItem(Result, Record);
  RETURN Result;
 END {Encode_VersionInformation};

 PRIVATE PROCEDURE Decode_VersionInformation(Value: STRING[]; VAR Version: NUMERIC[0]);
 BEGIN
  IF !Value THEN
   Version:=0;
  ELSE
   Version:=STRTOFLD(L_Prop.getRecordElement(L_Prop.getArrayItem(Value, 0), 1), SCAL);
  END;
 END {Decode_VersionInformation};

 PRIVATE PROCEDURE DecodeValue(    trgValue  : STRING[];
                               VAR trgVersion,
                                   trgOS,
                                   trgMonitor,
                                   trgMAC,
                                   trgUser,
                                   trgComp,
                                   trgProc   : STRING[]);
  VAR
   RecordName,
   Record    : STRING[];
   Idx       : NUMERIC[0];
 BEGIN
  SETEMPTY(trgVersion, trgOS, trgMonitor, trgMAC, trgUser, trgComp, trgProc);
  Idx:=0;
  LOOP
   Record:=L_Prop.getArrayItem(trgValue, Idx);
   IF !Record THEN
    EXIT;
   END;
   RecordName:=L_Prop.getRecordElement(Record, 0);
   IF    RecordName = rn_Version THEN L_Prop.putArrayItem(trgVersion, Record);
   ELSIF RecordName = rn_OS      THEN L_Prop.putArrayItem(trgOS,      Record);
   ELSIF RecordName = rn_Monitor THEN L_Prop.putArrayItem(trgMonitor, Record);
   ELSIF RecordName = rn_MAC     THEN L_Prop.putArrayItem(trgMAC,     Record);
   ELSIF RecordName = rn_User    THEN L_Prop.putArrayItem(trgUser,    Record);
   ELSIF RecordName = rn_Comp    THEN L_Prop.putArrayItem(trgComp,    Record);
   ELSIF RecordName = rn_Proc    THEN L_Prop.putArrayItem(trgProc,    Record);
   ELSE
    L_General.CallUs(0);
   END;
   INC(Idx);
  END; (* LOOP ... *)
 END {DecodeValue};

 PRIVATE PROCEDURE GetUIStatVersion(): NUMERIC[0];
  VAR
   Result    : NUMERIC[0];
   trgVersion,
   trgOS,
   trgMonitor,
   trgMAC,
   trgUser,
   trgComp,
   trgProc   : STRING[];
 BEGIN
  L_General.CallUs(OCCURE(SES));
  DecodeValue(SES.Value, trgVersion, trgOS, trgMonitor, trgMAC, trgUser, trgComp, trgProc);
  Decode_VersionInformation(trgVersion, Result);
  RETURN Result;
 END {GetUIStatVersion};

 PUBLIC PROCEDURE Gather();
  VAR
   Description: STRING[];
 BEGIN
  APP.Get().NewPrompt("஢ઠ ଠ樨  ");
  IF ~L_SES.PosToSES(L_SES.sit_StationAcsObj, ValId) | (SES.UpdTime <= (SYSTIMESTAMP()-10)) | (GetUIStatVersion() < Version) THEN
   SETEMPTY(Description);
   INC(Description, Encode_VersionInformation());
   INC(Description, Encode_OSInformation());
   INC(Description, Encode_MonitorsInformation());
   INC(Description, Encode_MACAddressInformation());
   INC(Description, Encode_UserInformation());
   INC(Description, Encode_ComputerInformation());
   INC(Description, Encode_ProcessorsInformation());
   L_SES.PutValueAtCurTrn(L_SES.sit_StationAcsObj, ValId, Description);
  END;
 END {Gather};

 PRIVATE PROCEDURE Create_UIStt();
  VAR
   SuiteIdx: SCAL[suiteAmnt];
   MonitIdx: SCAL[MaxMonitorAmnt];
 BEGIN
  CreateFILE(UIStt, "", "ଠ  ", "");

  CreateFIELD(UIStt, Client,   SCAL[1E4],  "", "", "", "", "");
  (* rn_Version *)
  CreateFIELD(UIStt, Version,  NUMERIC[0], "", "", "", "", "");
  CreateFIELD(UIStt, UpdDate,  DATE,       "", "", "", " ", "");
  CreateFIELD(UIStt, RepDate,  DATE,       "", "", "", " ᡮ ⨪", "");
  CreateFIELD(UIStt, DownTime, SCAL[1E3],  "", "", "", "ਮ ", "");
  (* rn_OS *)
  CreateFIELD(UIStt, OSName,   STRING[64], "", "", "", "OSName", "");
  CreateFIELD(UIStt, Platform, SCAL[4],    "", "", "", "Platform", "");
  CreateFIELD(UIStt, major,    NUMERIC[0], "", "", "", "major", "");
  CreateFIELD(UIStt, minor,    NUMERIC[0], "", "", "", "minor", "");
  CreateFIELD(UIStt, build,    NUMERIC[0], "", "", "", "build", "");
  CreateFIELD(UIStt, csdver,   STRING[64], "", "", "", "csdver", "");
  CreateFIELD(UIStt, prodType, NUMERIC[0], "", "", "", "productType", "");
  FOR_EACH SuiteIdx DO
   CreateFIELD(UIStt, ^("suite" + L_Str.IntStr(SuiteIdx)),  SCAL[2],    "", "", "", "suite" + L_Str.IntStr(SuiteIdx), "");
  END;
  CreateFIELD(UIStt, wow64,    NUMERIC[0], "", "", "", "wow64", "");
  CreateFIELD(UIStt, prodId,   NUMERIC[0], "", "", "", "productId", "");
  (* rn_Monitor *)
  FOR_EACH MonitIdx DO
   CreateFIELD(UIStt, ^("Primary" + L_Str.IntStr(MonitIdx)),  SCAL[2],    "", "", "", "Primary"    + L_Str.IntStr(MonitIdx), "");
   CreateFIELD(UIStt, ^("Resolut" + L_Str.IntStr(MonitIdx)),  STRING[10],   "", "", "", "Resolution" + L_Str.IntStr(MonitIdx), "");
  END;
  (* rn_MAC *)
  CreateFIELD(UIStt, MAC,      STRING[12], "", "", "", "MAC", "");
  CreateFIELD(UIStt, MACForm,  STRING[17], "", "", "", "MAC formatted", "");
  (* rn_User *)
  CreateFIELD(UIStt, UserId,   LIKE(AcsObj.AcsObj),  "", "", "", "UserId", "");
  CreateFIELD(UIStt, Age,      NUMERIC[0],           "", "", "", "  楫 ", "");
  CreateFIELD(UIStt, TypeSes,  NUMERIC[0],           "", "", "", " 祭", "");
  (* rn_Comp *)
  CreateFIELD(UIStt, CompName, STRING[32], "", "", "", " ", "");
  CreateFIELD(UIStt, NumOfPrc, NUMERIC[0], "", "", "", "⢮ ஢", "");
  CreateFIELD(UIStt, TotPhMem, NUMERIC[0], "", "", "", "ꥬ ", "");
  (* rn_Proc *)
  CreateFIELD(UIStt, DeviceID, STRING[64],   "", "", "", "DeviceID", "");
  CreateFIELD(UIStt, ProcName, STRING[64],   "", "", "", "ProcName", "");
  CreateFIELD(UIStt, ProcId,   STRING[64],   "", "", "", "ProcId", "");
  CreateFIELD(UIStt, Descr,    STRING[64],   "", "", "", "Description", "");
  CreateFIELD(UIStt, Caption,  STRING[64],   "", "", "", "Caption", "");
  CreateFIELD(UIStt, ClockSp,  STRING[64],   "", "", "", "ClockSpeed", "");
  CreateFIELD(UIStt, Status,   STRING[64],   "", "", "", "Status", "");
  (* calculated fields *)
  CreateFIELD(UIStt, PrtCom,   FLOAT,        "", "", "", " ࠡ 짮⥫  ஬", "");
  CreateFIELD(UIStt, PrtUs,    FLOAT,        "", "", "", " ᯮ짮  짮⥫", "");

  CreateINDEX(UIStt, ClComp,   PLURAL, "", "", Client, CompName);
  CreateINDEX(UIStt, ClUser,   PLURAL, "", "", Client, UserId);

  SetVersionOfFILE(UIStt, 1);
  L_AFM.AF_CreateTemp("UIStt", "UIStt");
 END {Create_UIStt};

 PRIVATE PROCEDURE Client_Header(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
 END {Client_Header};

 PRIVATE PROCEDURE Gather_Client();
 BEGIN
  UIStt.Client:=L_General.GetAPSiteNumber();
 END {Gather_Client};

 PRIVATE PROCEDURE Client_Part();
 BEGIN
  L_Basis.wb_WrScl("F", UIStt.Client);
 END {Client_Part};

 PRIVATE PROCEDURE Version_Header(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, " ᡮ ⨪");
  L_Basis.wb_WrInQM(F, "ਮ ");
 END {Version_Header};

 PRIVATE PROCEDURE Gather_Version(trgVersion: NUMERIC[0]);
 BEGIN
  PROMPT(" ଠ樨: " + SES.SbjId + " " + rn_Version);
  UIStt.Version :=trgVersion;
  UIStt.UpdDate :=L_DatTim.GetDateOfTIMESTAMP(SES.UpdTime);
  UIStt.RepDate :=SYSDATE();
  UIStt.DownTime:=(UIStt.RepDate - UIStt.UpdDate) DIV 10;
 END {Gather_Version};

 PRIVATE PROCEDURE Version_Part();
 BEGIN
  L_Basis.wb_WrScl("F", L_Str.IntStr(UIStt.Version));
  L_Basis.wb_WrDat("F", UIStt.UpdDate);
  L_Basis.wb_WrDat("F", UIStt.RepDate);
  L_Basis.wb_WrScl("F", UIStt.DownTime);
 END {Version_Part};

 PRIVATE PROCEDURE OS_Header(F: STRING[]);
  VAR
   Idx: SCAL[suiteAmnt];
 BEGIN
  L_Basis.wb_WrInQM(F, rn_OS + ": OSName");
  L_Basis.wb_WrInQM(F, rn_OS + ": platform");
  L_Basis.wb_WrInQM(F, rn_OS + ": major");
  L_Basis.wb_WrInQM(F, rn_OS + ": minor");
  L_Basis.wb_WrInQM(F, rn_OS + ": build");
  L_Basis.wb_WrInQM(F, rn_OS + ": csdver");
  L_Basis.wb_WrInQM(F, rn_OS + ": productType");
  FOR_EACH Idx DO
   L_Basis.wb_WrInQM(F, rn_OS + ": suite[" + L_Str.IntStr(Idx) + "]");
  END;
  L_Basis.wb_WrInQM(F, rn_OS + ": wow64");
  L_Basis.wb_WrInQM(F, rn_OS + ": productId");
 END {OS_Header};

 PRIVATE PROCEDURE Gather_OS(trgOS: STRING[]);
  VAR
   Value: STRING[];
   Idx  : SCAL[suiteAmnt];
 BEGIN
  PROMPT(" ଠ樨: " + SES.SbjId + " " + rn_OS);
  Value         :=L_Prop.getArrayItem(trgOS, 0);
  UIStt.OSName  :=L_Prop.getRecordElement(Value, 1);
  UIStt.Platform:=STRTOFLD(L_Prop.getRecordElement(Value, 2), SCAL);
  UIStt.major   :=STRTOFLD(L_Prop.getRecordElement(Value, 3), SCAL);
  UIStt.minor   :=STRTOFLD(L_Prop.getRecordElement(Value, 4), SCAL);
  UIStt.build   :=STRTOFLD(L_Prop.getRecordElement(Value, 5), SCAL);
  UIStt.csdver  :=L_Prop.getRecordElement(Value, 6);
  UIStt.prodType:=STRTOFLD(L_Prop.getRecordElement(Value, 7), SCAL);
  FOR_EACH Idx DO
   ^("UIStt.suite" + L_Str.IntStr(Idx)):=STRTOFLD(L_Prop.getRecordElement(Value, 8+Idx), SCAL);
  END;
  UIStt.wow64   :=STRTOFLD(L_Prop.getRecordElement(Value, 9+Idx), SCAL);
  UIStt.prodId  :=STRTOFLD(L_Prop.getRecordElement(Value, 10+Idx), SCAL);
 END {Gather_OS};

 PRIVATE PROCEDURE OS_Part();
  VAR
   Idx: SCAL[suiteAmnt];
 BEGIN
  L_Basis.wb_WrStr("F", UIStt.OSName);
  L_Basis.wb_WrScl("F", UIStt.Platform);
  L_Basis.wb_WrNum("F", UIStt.major, 0);
  L_Basis.wb_WrNum("F", UIStt.minor, 0);
  L_Basis.wb_WrNum("F", UIStt.build, 0);
  L_Basis.wb_WrStr("F", UIStt.csdver);
  L_Basis.wb_WrNum("F", UIStt.prodType, 0);
  FOR_EACH Idx DO
   L_Basis.wb_WrScl("F", ^("UIStt.suite" + L_Str.IntStr(Idx)));
  END;
   L_Basis.wb_WrNum("F", UIStt.wow64, 0);
   L_Basis.wb_WrNum("F", UIStt.prodId, 0);
 END {OS_Part};

 PRIVATE PROCEDURE Monitor_Header(F: STRING[]);
  VAR
   Idx: SCAL[MaxMonitorAmnt];
 BEGIN
  FOR_EACH Idx DO
   L_Basis.wb_WrInQM(F, rn_Monitor + " " + L_Str.IntStr(Idx) + ": Primary");
   L_Basis.wb_WrInQM(F, rn_Monitor + " " + L_Str.IntStr(Idx) + ": Resolution");
  END; (* WHILE Idx < ... *)
 END {Monitor_Header};

 PRIVATE PROCEDURE Gather_Monitor(trgMonitor: STRING[]);
  VAR
   Idx   : SCAL[MaxMonitorAmnt];
   Record : STRING[];
 BEGIN
  PROMPT(" ଠ樨: " + SES.SbjId + " " + rn_Monitor);
  FOR_EACH Idx DO
   Record:=L_Prop.getArrayItem(trgMonitor, Idx);
   IF ~!Record THEN
    ^("UIStt.Primary" + L_Str.IntStr(Idx)):=STRTOFLD(L_Prop.getRecordElement(Record, 2), SCAL);
    ^("UIStt.Resolut" + L_Str.IntStr(Idx)):=L_Prop.getRecordElement(Record, 3);
   ELSE
    SETEMPTY(^("UIStt.Primary" + L_Str.IntStr(Idx)),
             ^("UIStt.Resolut" + L_Str.IntStr(Idx)));
   END;
  END;
 END {Gather_Monitor};

 PRIVATE PROCEDURE Monitor_Part();
  VAR
   Idx: SCAL[MaxMonitorAmnt];
 BEGIN
  FOR_EACH Idx DO
   L_Basis.wb_WrScl("F", ^("UIStt.Primary" + L_Str.IntStr(Idx)));
   L_Basis.wb_WrStr("F", ^("UIStt.Resolut" + L_Str.IntStr(Idx)));
  END; (* WHILE Idx < ... *)
 END {Monitor_Part};

 PRIVATE PROCEDURE MACAddress_Header(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, rn_MAC + ": address");
  L_Basis.wb_WrInQM(F, rn_MAC + ": formatted address");
 END {MACAddress_Header};

 PRIVATE PROCEDURE GetMAC(trgMAC: STRING[]; Formatted: SCAL[2]): STRING[];
  VAR
   Num: NUMERIC[0];
 BEGIN
  IF ~Formatted THEN Num:=1;
  ELSE               Num:=2;
  END;
  RETURN L_Prop.getRecordElement(L_Prop.getArrayItem(trgMAC, 0), Num);
 END {GetMAC};

 PRIVATE PROCEDURE Gather_MACAddress(trgMAC: STRING[]);
 BEGIN
  PROMPT(" ଠ樨: " + SES.SbjId + " " + rn_MAC);
  UIStt.MAC    :=GetMAC(trgMAC, 0);
  UIStt.MACForm:=GetMAC(trgMAC, 1);
 END {Gather_MACAddress};

 PRIVATE PROCEDURE MACAddress_Part();
 BEGIN
  L_Basis.wb_WrStr("F", UIStt.MAC);
  L_Basis.wb_WrStr("F", UIStt.MACForm);
 END {MACAddress_Part};

 PRIVATE PROCEDURE UserInfo_Header(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, rn_User + ": UserId");
  L_Basis.wb_WrInQM(F, rn_User + ": Age");
  L_Basis.wb_WrInQM(F, rn_User + ": TypeSes");
 END {UserInfo_Header};

 PRIVATE PROCEDURE Gather_UserInfo(trgUser: STRING[]);
  VAR
   Value : STRING[];
 BEGIN
  PROMPT(" ଠ樨: " + SES.SbjId + " " + rn_User);
  Value        :=L_Prop.getArrayItem(trgUser, 0);
  UIStt.UserId :=L_Prop.getRecordElement(Value, 1);
  UIStt.Age    :=STRTOFLD(L_Prop.getRecordElement(Value, 2), NUMERIC);
  UIStt.TypeSes:=STRTOFLD(L_Prop.getRecordElement(Value, 3), NUMERIC);
 END {Gather_UserInfo};

 PRIVATE PROCEDURE UserInfo_Part();
 BEGIN
  L_Basis.wb_WrScl("F", UIStt.UserId);
  L_Basis.wb_WrNum("F", UIStt.Age, 0);
  L_Basis.wb_WrStr("F", L_Str.PoolItem(ts_Pool, UIStt.TypeSes));
 END {UserInfo_Part};

 PRIVATE PROCEDURE ComputerInfo_Header(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, rn_Comp + ": CompName");
  L_Basis.wb_WrInQM(F, rn_Comp + ": NumOfProcs");
  L_Basis.wb_WrInQM(F, rn_Comp + ": TotPhysMem");
 END {ComputerInfo_Header};

 PRIVATE PROCEDURE Gather_ComputerInfo(trgComp: STRING[]);
  VAR
   Value: STRING[];
 BEGIN
  PROMPT(" ଠ樨: " + SES.SbjId + " " + rn_Comp);
  Value         :=L_Prop.getArrayItem(trgComp, 0);
  UIStt.CompName:=L_Prop.getRecordElement(Value, 1);
  UIStt.NumOfPrc:=STRTOFLD(L_Prop.getRecordElement(Value, 2), SCAL);
  UIStt.TotPhMem:=STRTOFLD(L_Prop.getRecordElement(Value, 3), SCAL);
 END {Gather_ComputerInfo};

 PRIVATE PROCEDURE ComputerInfo_Part();
 BEGIN
  L_Basis.wb_WrStr("F", UIStt.CompName);
  L_Basis.wb_WrNum("F", UIStt.NumOfPrc, 0);
  L_Basis.wb_WrNum("F", UIStt.TotPhMem, 0);
 END {ComputerInfo_Part};

 PRIVATE PROCEDURE ProcessorInfo_Header(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, rn_Proc + ": DeviceID");
  L_Basis.wb_WrInQM(F, rn_Proc + ": ProcName");
  L_Basis.wb_WrInQM(F, rn_Proc + ": ProcId");
  L_Basis.wb_WrInQM(F, rn_Proc + ": Description");
  L_Basis.wb_WrInQM(F, rn_Proc + ": Caption");
  L_Basis.wb_WrInQM(F, rn_Proc + ": ClockSpeed");
  L_Basis.wb_WrInQM(F, rn_Proc + ": Status");
 END {ProcessorInfo_Header};

 PRIVATE PROCEDURE Gather_ProcessorInfo(trgProc: STRING[]);
  VAR
   Value: STRING[];
 BEGIN
  PROMPT(" ଠ樨: " + SES.SbjId + " " + rn_Proc);
  Value         :=L_Prop.getArrayItem(trgProc, 0);
  UIStt.DeviceID:=L_Prop.getRecordElement(Value, 1);
  UIStt.ProcName:=L_Prop.getRecordElement(Value, 2);
  UIStt.ProcId  :=L_Prop.getRecordElement(Value, 3);
  UIStt.Descr   :=L_Prop.getRecordElement(Value, 4);
  UIStt.Caption :=L_Prop.getRecordElement(Value, 5);
  UIStt.ClockSp :=L_Prop.getRecordElement(Value, 6);
  UIStt.Status  :=L_Prop.getRecordElement(Value, 7);
 END {Gather_ProcessorInfo};

 PRIVATE PROCEDURE ProcessorInfo_Part();
 BEGIN
  L_Basis.wb_WrStr("F", UIStt.DeviceID);
  L_Basis.wb_WrStr("F", UIStt.ProcName);
  L_Basis.wb_WrStr("F", UIStt.ProcId);
  L_Basis.wb_WrStr("F", UIStt.Descr);
  L_Basis.wb_WrStr("F", UIStt.Caption);
  L_Basis.wb_WrStr("F", UIStt.ClockSp);
  L_Basis.wb_WrStr("F", UIStt.Status);
 END {ProcessorInfo_Part};

 PRIVATE PROCEDURE CalcFields_Header(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, " ᯮ짮  짮⥫");
  L_Basis.wb_WrInQM(F, " ࠡ 짮⥫  ஬");
 END {CalcFields_Header};

 PRIVATE PROCEDURE CalcFields_Part();
 BEGIN
  L_Basis.wb_WrNum("F", UIStt.PrtUs,  10);
  L_Basis.wb_WrNum("F", UIStt.PrtCom, 10);
 END {CalcFields_Part};

 PRIVATE PROCEDURE GetCntRecord(): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=0;
  SAVE(UIStt);
  FIRST(UIStt);
  WHILE OCCURE(UIStt) DO
   INC(Result);
   NEXT(UIStt);
  END; (* WHILE OCCURE(UIStt) ... *)
  RESTORE(UIStt);
  RETURN Result;
 END {GetCntRecord};

 PRIVATE PROCEDURE Gather_CalculatedFields_UIStt();
  VAR
   CntUsers,
   CntComps: NUMERIC[0];
 BEGIN
  SELECT(UIStt, ClComp);
  WHILE OCCURE(UIStt) DO
   NARROWSEL(UIStt, Client);
   WHILE OCCURE(UIStt) DO
    NARROWSEL(UIStt, CompName);
    WHILE OCCURE(UIStt) DO
     PROMPT(" 塞 : " + UIStt.Client + " " + UIStt.CompName + " " + UIStt.UserId);
     UIStt.PrtUs:=1/GetCntRecord();
     REPLACE(UIStt);
     NEXT(UIStt);
    END; (* WHILE OCCURE(UIStt) ... *)
    NEXTINEXTENDEDSEL(UIStt, CompName);
   END; (* WHILE OCCURE(UIStt) ... *)
   NEXTINEXTENDEDSEL(UIStt, Client);
  END; (* WHILE OCCURE(UIStt) ... *)

  SELECT(UIStt, ClUser);
  WHILE OCCURE(UIStt) DO
   NARROWSEL(UIStt, Client);
   WHILE OCCURE(UIStt) DO
    NARROWSEL(UIStt, UserId);
    WHILE OCCURE(UIStt) DO
     PROMPT(" 塞 : " + UIStt.Client + " " + UIStt.UserId + " " + UIStt.CompName);
     UIStt.PrtCom:=1/GetCntRecord();
     REPLACE(UIStt);
     NEXT(UIStt);
    END; (* WHILE OCCURE(UIStt) ... *)
    NEXTINEXTENDEDSEL(UIStt, UserId);
   END; (* WHILE OCCURE(UIStt) ... *)
   NEXTINEXTENDEDSEL(UIStt, Client);
  END; (* WHILE OCCURE(UIStt) ... *)
 END {Gather_CalculatedFields_UIStt};

 PRIVATE PROCEDURE Gather_UIStt();
  VAR
   trgVersion,
   trgOS,
   trgMonitor,
   trgMAC,
   trgUser,
   trgComp,
   trgProc   : STRING[];
   NumVersion: NUMERIC[0];
 BEGIN
  SELECT(SES, SIdTVId, , L_SES.sit_StationAcsObj, ValId);
  WHILE OCCURE(SES) DO
   DecodeValue(SES.Value, trgVersion, trgOS, trgMonitor, trgMAC, trgUser, trgComp, trgProc);
   Decode_VersionInformation(trgVersion, NumVersion);
   IF NumVersion = Version THEN
    DEFAULT(UIStt);
    Gather_Client();
    Gather_Version(NumVersion);
    Gather_OS(trgOS);
    Gather_Monitor(trgMonitor);
    Gather_MACAddress(trgMAC);
    Gather_UserInfo(trgUser);
    Gather_ComputerInfo(trgComp);
    Gather_ProcessorInfo(trgProc);
    INSERT(UIStt);
   END;
   NEXT(SES);
  END; (* WHILE OCCURE(SES) ... *)

  Gather_CalculatedFields_UIStt();
 END {Gather_UIStt};

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  Client_Header(F);
  Version_Header(F);
  OS_Header(F);
  Monitor_Header(F);
  MACAddress_Header(F);
  UserInfo_Header(F);
  ComputerInfo_Header(F);
  ProcessorInfo_Header(F);
  CalcFields_Header(F);
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart();
 BEGIN
  Client_Part();
  Version_Part();
  OS_Part();
  Monitor_Part();
  MACAddress_Part();
  UserInfo_Part();
  ComputerInfo_Part();
  ProcessorInfo_Part();
  CalcFields_Part();
  L_Basis.wb_TermLine("F");
 END {MakePart};

 PUBLIC PROCEDURE MakeRep(wHeader: SCAL[2]; FileName: STRING[]);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_FINISHED;
  Create_UIStt();
  Gather_UIStt();
  FIO.Open(F, FileName, "REP", Create);
  IF wHeader THEN
   MakeHeader("F");
  END;
  SELECT(UIStt, ClComp);
  WHILE OCCURE(UIStt) DO
   PROMPT("뢮 ଠ樨: " + UIStt.CompName + " " + UIStt.UserId);
   MakePart();
   NEXT(UIStt);
  END; (* WHILE OCCURE(UIStt) ... *)
  FIO.Close(F);
 END {MakeRep};

 PUBLIC PROCEDURE MakeConsolidatingRep();
  VAR
   D          : DROPTARGETDIALOG;
   DroppedFile: DROPPEDFILE;
   Idx        : NUMERIC[0];
   dstFileName: STRING[];
 BEGIN
  D              :=DROPTARGETDIALOG.Create();
  D.MayMoveOnDrop:=0;
  D.Title        :="롮 䠩  ନ஢  " + RepName;
  IF D.Deal() THEN
   dstFileName:=L_General.NameConnection(RepName);
   FIO.Open(Dst, dstFileName, "REP", Create);
   MakeHeader("Dst");
   Idx:=0;
   WHILE Idx < D.DroppedFiles.Count DO
    DroppedFile:=D.DroppedFiles(Idx);
    FIO.Open(Src, DroppedFile.Path, "", Input);
    FIO.Copy(Src, Dst);
    FIO.Close(Src);
    INC(Idx);
   END;
   FIO.Close(Dst);
   L_Basis.PlayMakedRunTimeRep(RepName, L_General.tc_Entire, Title, 0);
   FIO.Erase(dstFileName);
  ELSE
   L_StdFrm.Inform(" ࠭   䠩");
  END;
 END {MakeConsolidatingRep};

END.