(*
%Copyright   (c) Polak IT
%Author      15.12.2004 15:05:35 POLAK\Bor
%Purpose     ଫ ᤥ
%Type        report
%Specific    SYS
%Modified    18.09.2013 18:29:27 POLAK\Bor
%Environment
*)

 MODULE UnComMD [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_DatTim, L_XDoc, L_MDoc, L_PDoc, L_Pmnt, L_AFM, L_Dest, L_Str,
        Str, Math, P_Cntr, P_MDoc, Memo, L_Cntr;

 PRIVATE TYPE
  tContent = SCAL[4];

 PRIVATE CONST
  c_byFirm     = 0;
  c_byContract = 1;
  c_byAll      = 2;
  c_DvrOnly    = 3;

  DocsChainMaxLength = 5;

 PRIVATE TYPE
  tChainCheckPrc  = PROC[DocsChainMaxLength];
  tChainObligatory = SCAL[2][DocsChainMaxLength];

 PRIVATE CONST
  dk_MayBePaidMDoc  = 0;
  dk_TransitiveMDoc = 1;
  dk_AcptMDoc       = 2;
  dk_VATMDoc        = 3;

  dk_Pool = " |७|| ";

 PRIVATE VAR
  ChainCheckPrc  : tChainCheckPrc;
  ChainObligatory: tChainObligatory;
  _UpTo          : DATE;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|                                           ଫ ᤥ                                           |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|㬥   |      || 樨         |         㬬| 㬥|஡                  |
|-----------|----------|-------|---------------------|--------------|-------------|--------------------------|
}
*)

(*
$P{ Line:
L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L, ""
MDoc.Date, L, "D.N.y"
MDoc.Contract, L, ""
MDoc.Dest, L, ""
Dest.Name, L, ""
MDoc.Total, R, "2-"
?, L, ""
?, L, ""
@
|###########|##########|#######|### #################|##############|#############|##########################|
}
*)


(*
$P{ pa_Top:
@
|============================================================================================================|
|                                     㬥 ਮ᪮ ॠ樨                                     |
|------------------------------------------------------------------------------------------------------------|
|                                       |ਮ         |  㬥⮢|  ଫ 㬥⮢|
|----------------------------------------------|---------------|----------------------|----------------------|
}
*)

(*
$P{ pa_Line:
Contract.Contract, L, ""
Contract.Name, L, ""
?, C, ""
_PrMD.DocsPlan, R, ""
_PrMD.DocsFact, R, ""
@
|####### ######################################|###############|######################|######################|
}
*)



(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE Create__MDoc();
 BEGIN
  CreateFILE(_MDoc, "", "", "");
  CreateFIELD(_MDoc, Contract,  LIKE(MDoc.Contract), "", "", "", "", "");
  CreateFIELD(_MDoc, MDocKind,  LIKE(MDoc.MDocKind), "", "", "", " 㬥", "");
  CreateFIELD(_MDoc, MDoc,      LIKE(MDoc.MDoc), "", "", "", "", "");
  CreateFIELD(_MDoc, Date,      LIKE(MDoc.Date), "", "", "", "", "");
  CreateFIELD(_MDoc, LostDoc,   SCAL[DocsChainMaxLength], "", "", "", "ﭭ 㬥  楯窥", "");
  CreateFIELD(_MDoc, Delta,     LIKE(MDoc.Total), "", "", "", "", "");
  CreateFIELD(_MDoc, Msg,       STRING[62], "", "", "", "", "");

  CreateINDEXandLINK(_MDoc, Contract, PLURAL, Contract, Contract, USER, "", "", Contract, MDocKind, MDoc, LostDoc);
  CreateINDEXandLINK(_MDoc, MDoc,     PLURAL, MDoc,     MDoc,     USER, "", "", MDocKind, MDoc);
  CreateINDEX(_MDoc, Date, PLURAL, "", "", Date, MDocKind, MDoc, LostDoc);

  SetVersionOfFILE(_MDoc, 000);
 END {Create__MDoc};

 PRIVATE PROCEDURE InsIndex(DK   : SCAL[DocsChainMaxLength];
                            Delta: LIKE(MDoc.Total);
                            Msg  : STRING[]);
 BEGIN
  _MDoc.Contract:=Contract.Contract;
  _MDoc.MDocKind:=MDoc.MDocKind;
  _MDoc.MDoc    :=MDoc.MDoc;
  _MDoc.Date    :=MDoc.Date;
  _MDoc.LostDoc :=DK;
  _MDoc.Delta   :=Delta;
  _MDoc.Msg     :=Msg;
  INSERT(_MDoc);
 END {InsIndex};

 PRIVATE PROCEDURE IsMayBePaidRealMDocKind(_MDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  RETURN (_MDocKind # L_MDoc.md_VOD) & (_MDocKind # L_MDoc.md_IOD) & L_Pmnt.IsMayBePaidMDocKind(_MDocKind);
 END {IsMayBePaidRealMDocKind};

 PRIVATE PROCEDURE NeedCheckMDocKind(_MDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  RETURN IsMayBePaidRealMDocKind(_MDocKind) | L_Pmnt.IsTransitiveMDoc(_MDocKind) | L_Pmnt.IsAcptMDocKind(_MDocKind);
 END {NeedCheckMDocKind};

 PRIVATE PROCEDURE IsMayBePaidMDoc(): SCAL[2];
 BEGIN
  RETURN (MDoc.Status # L_MDoc.st_Canceled) & IsMayBePaidRealMDocKind(MDoc.MDocKind);
 END {IsMayBePaidMDoc};

 PRIVATE PROCEDURE IsTransitiveMDoc(): SCAL[2];
 BEGIN
  RETURN (MDoc.Status # L_MDoc.st_Canceled) & L_Pmnt.IsTransitiveMDoc(MDoc.MDocKind);
 END {IsTransitiveMDoc};

 PRIVATE PROCEDURE IsAcptMDoc(): SCAL[2];
 BEGIN
  RETURN (MDoc.Status # L_MDoc.st_Canceled) & L_Pmnt.IsAcptMDocKind(MDoc.MDocKind);
 END {IsAcptMDoc};

 PRIVATE PROCEDURE IsVATMDoc(): SCAL[2];
 BEGIN
  RETURN (MDoc.Status # L_MDoc.st_Canceled) &
         L_Pmnt.IsVATMDocKind(MDoc.MDocKind) &
         (L_Pmnt.E_StageOfBuildingVATMDoc(MDoc.Date, MDoc.MDocKind, MDoc.Dest) = L_Pmnt.sbvmd_Online);
 END {IsVATMDoc};

 PRIVATE PROCEDURE NeedAcptMDoc(curDocId: L_XDoc.tXDocId): SCAL[2];
  VAR
   i    : NUMERIC[0];
   Find : SCAL[2];
   XDocs: L_XDoc.tXDocCollection;
 BEGIN
  SAVE(MDoc);
  XDocs:=L_XDoc.GetAllRefToXDC(curDocId);
  Find:=0;
  i:=0;
  WHILE ~Find & L_XDoc.xdc_PositionOn(XDocs, i) DO
   IF    L_XDoc.ExtractXDocType(L_XDoc.xdc_Item(XDocs, i)) = L_XDoc.xdt_MDoc THEN
    Find := (MDoc.Status # L_MDoc.st_Canceled);
   ELSIF L_XDoc.ExtractXDocType(L_XDoc.xdc_Item(XDocs, i)) = L_XDoc.xdt_PDoc THEN
    Find := (PDoc.Status # L_PDoc.st_Canceled);
   END;
   INC(i);
  END; (* WHILE L_XDoc.xdc_PositionOn ... *)
  RESTORE(MDoc);
  RETURN ~Find;
 END {NeedAcptMDoc};

 PRIVATE PROCEDURE IsNeedRelatedDoc(curDocId: L_XDoc.tXDocId; SrcDK, DstDK: SCAL[DocsChainMaxLength]): SCAL[2];
 BEGIN
  IF    SrcDK = dk_AcptMDoc THEN
   IF DstDK = dk_VATMDoc THEN
    RETURN L_Pmnt.NeedOnlineVATMDoc();
   END;
  ELSIF SrcDK = dk_VATMDoc THEN
   IF DstDK = dk_AcptMDoc THEN
    RETURN NeedAcptMDoc(curDocId);
   END;
  ELSIF SrcDK = dk_TransitiveMDoc THEN
   RETURN (MDoc.Total # 0);
  END;
  RETURN 1;
 END {IsNeedRelatedDoc};

 PRIVATE PROCEDURE GetNextDK(SrcDK: SCAL[DocsChainMaxLength]; Dir: NUMERIC[0]): SCAL[DocsChainMaxLength];
  VAR
   DstDK: SCAL[DocsChainMaxLength];
 BEGIN
  DstDK:=SrcDK;
  LOOP
   IF    Dir = +1 THEN
    IF DstDK = MAXOF(DstDK) THEN
     EXIT;
    END;
   ELSIF Dir = -1 THEN
    IF DstDK = MINOF(DstDK) THEN
     EXIT;
    END;
   ELSE
    L_General.CallUs(0);
   END;
   INC(DstDK, Dir);
   IF ~!ChainCheckPrc[DstDK] THEN
    RETURN DstDK;
   END;
  END;
  RETURN EMPTYOF(DstDK);
 END {GetNextDK};

 PRIVATE PROCEDURE CheckXDC(curDocId: L_XDoc.tXDocId;
                            GetXDC  : PROC;
                            SrcDK,
                            DstDK   : SCAL[DocsChainMaxLength];
                            Dir     : NUMERIC[0]);
  VAR
   i,
   Cnt  : NUMERIC[0];
   MDocs: L_XDoc.tXDocCollection;
   Delta: LIKE(MDoc.Total);
 BEGIN
  IF ~!DstDK & ~ChainCheckPrc[DstDK]() THEN
   SAVE(MDoc);
   MDocs:=GetXDC(curDocId, L_XDoc.xdt_MDoc);
   Delta:=MDoc.Total;
   SETZERO(Cnt, i);
   WHILE L_XDoc.xdc_PositionOn(MDocs, i) DO
    IF ChainCheckPrc[DstDK]() THEN
     INC(Cnt);
     DEC(Delta, MDoc.Total);
    END;
    INC(i);
   END; (* WHILE L_XDoc.xdc_PositionOn ... *)
   RESTORE(MDoc);
   IF Cnt = 0 THEN
    IF ~ChainObligatory[DstDK] THEN
     CheckXDC(curDocId, GetXDC, SrcDK, GetNextDK(DstDK, Dir), Dir);
    ELSIF IsNeedRelatedDoc(curDocId, SrcDK, DstDK) THEN
     InsIndex(DstDK, 0, "");
    END;
   ELSIF (Dir = +1) & (Delta # 0) THEN
    InsIndex(DstDK, Delta, "");
   END;
  END;
 END {CheckXDC};

 PRIVATE PROCEDURE SetDocsChain(OnDate: DATE);
 BEGIN
  (*  । 楯窠 㬥⮢  ᨬ  , . 0040387*)
  SETEMPTY(ChainCheckPrc); SETZERO(ChainObligatory);

  IF P_Cntr.GetBalanceType(Contract.Contract, OnDate) = P_Cntr.ctbt_ByDeal THEN
   ChainCheckPrc[dk_MayBePaidMDoc] :=PROCREF(IsMayBePaidMDoc);
  END;
  ChainCheckPrc[dk_TransitiveMDoc]:=PROCREF(IsTransitiveMDoc);
  ChainCheckPrc[dk_AcptMDoc]      :=PROCREF(IsAcptMDoc);
  ChainCheckPrc[dk_VATMDoc]       :=PROCREF(IsVATMDoc);

  ChainObligatory[dk_MayBePaidMDoc] :=1;
  ChainObligatory[dk_TransitiveMDoc]:=0;
  ChainObligatory[dk_AcptMDoc]      :=1;
  ChainObligatory[dk_VATMDoc]       :=1;
 END {SetDocsChain};

 PRIVATE PROCEDURE ProceedOneMDoc();
  VAR
   prvDocId,
   nxtDocId,
   curDocId: L_XDoc.tXDocId;
   SrcDK,
   DstDK   : SCAL[DocsChainMaxLength];
 BEGIN
  PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));

  IF (MDoc.Status = L_MDoc.st_Passed) &
     (P_MDoc.GetDealCheckType(MDoc.MDocKind, MDoc.MDoc) # P_MDoc.dct_DoNot) &
     L_Pmnt.TakeMDocIntoAccount() THEN

   SetDocsChain(MDoc.Date);
   TRY
    curDocId:=L_XDoc.curXDocId(L_XDoc.xdt_MDoc);
    FOR_EACH SrcDK DO
     IF ~!ChainCheckPrc[SrcDK] & ChainCheckPrc[SrcDK]() THEN
      CheckXDC(curDocId, PROCREF(L_XDoc.GetRefToXDC),     SrcDK, GetNextDK(SrcDK, -1), -1);
      CheckXDC(curDocId, PROCREF(L_XDoc.GetDependentXDC), SrcDK, GetNextDK(SrcDK, +1), +1);
     END;
    END; (* FOR_EACH SrcDK ... *)
   EXCEPT
   ON Exc: Exc_Root DO
    InsIndex("", 0, Exc.Description);
   END; (* TRY *)
  END;
 END {ProceedOneMDoc};

 PRIVATE PROCEDURE NeedCheckPeriodicMDoc(): SCAL[2];
 BEGIN
  RETURN P_Cntr.HasPro(Contract.Contract, _UpTo, P_Cntr.P_PeriodicAcpt);
 END {NeedCheckPeriodicMDoc();};

 PRIVATE PROCEDURE MakePeriodicAcptIndex();
  VAR
   D,
   PerB,
   pad_Begin,
   pad_Till,
   pad_ED       : DATE;
   MonthInPeriod,
   DocsPerPeriod: NUMERIC[0];
   FirstMonth   : DATE;
   IsLastMonthInPer: SCAL[2];
   Months,
   DocsFact     : NUMERIC[0];
 BEGIN
  D:=Math.Min(_UpTo, L_DatTim.till2ED(Contract.Till));
  WHILE D >= Contract.Begin DO
   P_Cntr.GetPeriodicAcptDurationStrong(Contract.Contract, D, pad_Begin, pad_Till);
   pad_ED:=L_DatTim.till2ED(pad_Till);
   IF L_DatTim.IsActiveInIntvl_Inc(L_DatTim.MonthBeg(D), L_DatTim.MonthEnd(D), pad_Begin, pad_ED) THEN
    D:=Math.Min(D, pad_ED);
    P_Cntr.GetPeriodicAcptData(Contract.Contract, D, MonthInPeriod, DocsPerPeriod, FirstMonth);
    IF !MonthInPeriod THEN
     L_Prop.ShowUndefinedProValueError(TABLE.Get("Contract").Id, Contract.RECORDID, P_Cntr.PeriodicAcptData, D);
    ELSIF MonthInPeriod = 1 THEN
     IsLastMonthInPer:=1;
    ELSE
     Months:=(L_DatTim.YEAR(D)-L_DatTim.YEAR(FirstMonth))*12 + (L_DatTim.MONTH(D)-L_DatTim.MONTH(FirstMonth))+1;
     IF ~!pad_ED & (L_DatTim.Per(D) = L_DatTim.Per(pad_ED)) THEN
      IsLastMonthInPer:=1;
     ELSE
      IsLastMonthInPer:=((Months MOD MonthInPeriod) = 0);
     END;
    END;
    IF IsLastMonthInPer THEN
     DEFAULT(_PrMD);
     _PrMD.Contract:=Contract.Contract;
     _PrMD.PerE    :=L_DatTim.MonthEnd(D);
     _PrMD.PerB    :=Math.Max(L_DatTim.IncMonth(L_DatTim.MonthBeg(D), -MonthInPeriod+1), L_DatTim.MonthBeg(pad_Begin));
     _PrMD.DocsPlan:=DocsPerPeriod;
     INSERT(_PrMD);
    END;
   END;
   D:=L_DatTim.MonthBeg(D)-1;
  END;

  IF SELECT(_PrMD, _PrMD, Contract.Contract) THEN
   PerB:=_PrMD.PerB;
   WHILE OCCURE(_PrMD) DO
    IF PerB > _PrMD.PerB THEN
     _PrMD.PerB:=PerB;
     REPLACE(_PrMD);
    END;
    DocsFact:=0;
    SELECT(MDoc, Contract, , Contract.Contract);
    WHILE OCCURE(MDoc) DO
     NARROWSEL(MDoc, MDocKind);
     IF L_Pmnt.IsAcptMDocKind(MDoc.MDocKind) THEN
      SRCINSEL(MDoc, GE, , _PrMD.PerB);
      WHILE OCCURE(MDoc) & (MDoc.Date <= _PrMD.PerE) DO
       IF MDoc.Status # L_MDoc.st_Canceled THEN
        INC(DocsFact);
       END;
       NEXT(MDoc);
      END; (* WHILE OCCURE(MDoc) ... *)
     END;
     NEXTINEXTENDEDSEL(MDoc, MDocKind);
    END; (* WHILE OCCURE(MDoc) ... *)
    _PrMD.DocsFact:=DocsFact;
    REPLACE(_PrMD);
    PerB:=_PrMD.PerE + 1;
    NEXT(_PrMD);
   END; (* WHILE OCCURE(_PrMD) ... *)
  END;
 END {MakePeriodicAcptIndex};

 PRIVATE PROCEDURE ProceedOneContract();
  VAR
   NeedChPerMD: SCAL[2];
   Int        : NUMERIC[2];
 BEGIN
  APP.Get().NewPrompt(" "+Contract.Contract);
  SAVE(Contract);
  NeedChPerMD:=NeedCheckPeriodicMDoc();
  IF NeedChPerMD THEN
   MakePeriodicAcptIndex();
  END;

  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF NeedCheckMDocKind(MDocKind.MDocKind) THEN
    SELECT(MDoc, CntrClsd, , Contract.Contract, MDocKind.MDocKind, EMPTYOF(DATE));
    WHILE OCCURE(MDoc) DO
     IF MDoc.Date <= _UpTo THEN
      ProceedOneMDoc();
     END;
     NEXT(MDoc);
    END; (* WHILE OCCURE(MDoc) ... *)
   END; (* IF NeedCheckMDocKind( ... *)
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)

  RESTORE(Contract);
 END {ProceedOneContract};

 PRIVATE PROCEDURE MakeRep(RepName: STRING[]; trgContent: tContent);
  VAR
   Title    : STRING[];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  IF    trgContent = c_byFirm THEN
   L_General.Assert(ACCESS(Firm), " ⠭ ࠣ");
   _UpTo  :=SYSDATE();
   Title  :=" ࠣ "+Firm.Firm+" "+Firm.Name;
   SELECT(Contract, Firm, , Firm.Firm, 1);
  ELSIF trgContent = c_byContract THEN
   L_General.Assert(ACCESS(Contract), " ࠭ ");
   L_Cntr.CheckIsContract();
   _UpTo:=SYSDATE();
   Title  :="  "+Contract.Contract+" "+Contract.Name;
   SELECT(Contract, Contract, , Contract.Contract);
  ELSIF trgContent = c_byAll THEN
   _UpTo  :=Memo.ud_cd();
   Title  :=" ᥬ  "+L_DatTim.DateStr(_UpTo);
   SELECT(Contract, Closed, , 0, 1);
  ELSIF trgContent = c_DvrOnly THEN
   _UpTo  :=Memo.ud_cd();
   Title  :="쪮  ७⥩  ᥬ ࠣ⠬  "+L_DatTim.DateStr(_UpTo);
   SELECT(Contract, Closed, , 0, 1);
  ELSE
   L_General.CallUs(0);
  END;

  APP.Get().NewPrompt("("+RepName+") "+Str.Small("ଫ ᤥ "+Title));
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, Title);

  Create__MDoc(); L_AFM.AF_CreateTemp("_MDoc", "_MDoc");
  L_AFM.MakeMultipleIndex("_PrMD", "Contract: LIKE(Contact.Contact);"+
                                   "PerB: DATE;"+
                                   "PerE: DATE;"+
                                   "DocsPlan: NUMERIC[0];"+
                                   "DocsFact: NUMERIC[0]",
                          "_PrMD: Contract, PerE");

  IF trgContent = c_DvrOnly THEN
   SELECT(MDoc, MDocKind, , L_MDoc.md_Dvr, EMPTYOF(DATE));
   WHILE OCCURE(MDoc) DO
    IF MDoc.Date <= _UpTo THEN
     CONFORM(MDoc, Contract);
     ProceedOneMDoc();
    END;
    NEXT(MDoc);
   END; (* WHILE OCCURE(MDoc) ... *)
  ELSE
   WHILE OCCURE(Contract) DO
    ProceedOneContract();
    NEXT(Contract);
   END; (* WHILE OCCURE(Contract) ... *)
  END;

  SELECT(_MDoc, Date);
  WHILE OCCURE(_MDoc) DO
   CONFORM(_MDoc, MDoc);
   CONFORM(MDoc, Dest);
   IF !_MDoc.Msg THEN
    MAKEPART(R, Line, L_Str.PoolItem(dk_Pool, _MDoc.LostDoc), L_Str.PoolItem("| 㬬", _MDoc.Delta # 0));
   ELSE
    MAKEPART(R, Line, , _MDoc.Msg);
   END;
   NEXT(_MDoc);
  END; (* WHILE OCCURE(_MDoc) ... *)

  IF SELECT(_PrMD, _PrMD) THEN
   MAKEPART(R, pa_Top);
   WHILE OCCURE(_PrMD) DO
    IF _PrMD.DocsPlan # _PrMD.DocsFact THEN
     L_General.CallUs(SEARCH(Contract, Contract, _PrMD.Contract));
     IF L_DatTim.Per(_PrMD.PerB) = L_DatTim.Per(_PrMD.PerE) THEN
      MAKEPART(R, pa_Line, L_DatTim.PeriodStr(_PrMD.PerB));
     ELSE
      MAKEPART(R, pa_Line, L_DatTim.PeriodStr(_PrMD.PerB)+"-"+L_DatTim.PeriodStr(_PrMD.PerE));
     END;
    END;
    NEXT(_PrMD);
   END; (* WHILE OCCURE(_PrMD) ... *)
  END;

  MAKEPART(R, Bot);
  CLOSEREP(R);

  L_XDoc.sl_Init(" 㬥");
  SELECT(_MDoc, MDoc);
  WHILE OCCURE(_MDoc) DO
   CONFORM(_MDoc, MDoc);
   CONFORM(MDoc, Dest);
   L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc),
                     L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) +
                     " " + L_DatTim.DateStr(MDoc.Date) + " " + MDoc.Dest +
                     " " + Str.Align(Dest.Name, 30, LEFT)+FLDTOSTR(MDoc.Total, "2-", 15, "R"));
   NEXT(_MDoc);
  END; (* WHILE OCCURE(_MDoc) ... *)

  L_AFM.AF_PurgeTemp("_MDoc");
  L_AFM.AF_PurgeTemp("_PrMD");
  L_XDoc.sl_Done();
 END {MakeRep};

 PUBLIC PROCEDURE UnMDC();
 BEGIN
  MakeRep("UnMDC", c_byContract);
 END {UnMDC};

 PUBLIC PROCEDURE UnMDF();
 BEGIN
  MakeRep("UnMDF", c_byFirm);
 END {UnMDF};

 PUBLIC PROCEDURE UnMDA();
 BEGIN
  MakeRep("UnMDA", c_byAll);
 END {UnMDA};

 PUBLIC PROCEDURE UnDvr();
 BEGIN
  MakeRep("UnDvr", c_DvrOnly);
 END {UnDvr};

END.
