(*
%Copyright   (c) Polak Computer System
%Author      14.11.2000 19:42:58 BOR
%Purpose      ࠣ⮢
%Type        tools
%Specific    sys
%Modified    26.09.2012 23:18:48 POLAK\Bor
%Environment
*)

 MODULE UnionOrg [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_OwnData, L_DatTim, L_AFM, L_Str, L_PDoc, P_Firm, L_r2r,
        Memo, Str, L_Cntr, Math, L_StdFrm;

 PRIVATE TYPE
  tObject     = SCAL[2];
  tCheckValue = SCAL[2];

 PRIVATE CONST
  o_Firm = 0;
  o_Bank = 1;

  cv_INNorBIC = 0;
  cv_Name     = 1;

 PRIVATE VAR
  _Code,
  _Value  : LIKE(FirmPro.Value);
  NumErr  : NUMERIC[0];
  RepName : STRING[5];

(*
$P{ RepTop3:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
}
*)

(*
$P{ RepSubTop3:
?, L, ""
?, L, "| "
?, L, "|"
@
|----------------------------------------------------------------------------|
|############################################################################|
|----------------------------------------------------------------------------|
|########|H                                          |############|
|--------|------------------------------------------------------|------------|
}
*)

(*
$P{ RepLine3:
?, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|#### ###|######################################################|############|
}
*)

(*
$P{ Dlm:
@
|--------|------------------------------------------------------|------------|
}
*)

(*
$P{ RepBot3:
?, R, ""
@
|---------------------------------------------------------------|------------|
|ᥣ ࠣ⮢                                      |############|
=(c) Polak====================================================================
}
*)

(*
$P{ RepTop2:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, ""
@
############################################################# ########## #####
==============================================================================
|   ७  ####  䨫  #### 뫨 ந    |
|                 ᪨  ᫥ ࠣ⮢:                 |
|----------------------------------------------------------------------------|
|                                                    |         |   ᫥   |
|ࠣ                                          |-----------|-----------|
|                                                    |||||
}
*)

(*
$P{ RepLine2:
FirmAcnt.Firm, R, ""
Firm.Name, L, ""
FirmAcnt.Bank, L, ""
FirmAcnt.BankBrn, L, ""
?, L, ""
?, L, ""
@
|----------------------------------------------------|----|------|----|------|
|##### ##############################################|####|######|####|######|
}
*)

(*
$P{ RepBot2:
@
=(c) Polak====================================================================
}
*)

(*
$P{ RepTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
@
####################################################################### ########## #####
========================================================================================
|                    , 騥 ᮮ⢥⢨  ࠢ筨                  |
|--------------------------------------------------------------------------------------|
|||ᮮ⢥⢨ ࠢ筨                                      |      |
|----|------|----------------------------------------------------------------|---------|
}
*)

(*
$P{ RepLine:
Bank.Bank, L, ""
?, L, ""
?, L, ""
?, L, ""
@
|### |######|################################################################|#########|
}
*)

(*
$P{ RepBot:
@
=(c) Polak==============================================================================
}
*)

 PRIVATE PROCEDURE Create__Frms(Object: tObject);
 BEGIN
  CREATE_TABLE(_Frms, , "ࠣ");
  IF Object = o_Firm THEN
   CREATE_FIELD(_Frms, Code, LIKE(Firm.Firm),  , , , "");
  ELSE
   CREATE_FIELD(_Frms, Code, SCAL[1E6],        , , , "");
  END;
  CREATE_FIELD(_Frms, Name,  LIKE(Bank.Name), , , , "");
  CREATE_FIELD(_Frms, Value, STRING[244],     , , , "஢塞 ᢮⢮");

  CREATE_INDEX(_Frms, Value, PLURAL, , , Value);
  CREATE_INDEX(_Frms, Name,  PLURAL, , , Name);
  SET_VERSION_OF_TABLE(_Frms, 0);
 END {Create__Frms};

 PRIVATE PROCEDURE ConditionCheck(CheckValue: tCheckValue; Cond: LIKE(BankBrn.Name); wBranch: SCAL[2]): SCAL[2];
 BEGIN
  IF    CheckValue = cv_INNorBIC THEN
   IF    _Value # _Frms.Value THEN
    RETURN 0;
   ELSIF wBranch THEN
    RETURN (P_Firm.FP_PrtnrTyp(_Code, Memo.ud_cd())      # P_Firm.pt_Branch) &
           (P_Firm.FP_PrtnrTyp(_Frms.Code, Memo.ud_cd()) # P_Firm.pt_Branch);
   ELSE
    RETURN 1;
   END;
  ELSIF CheckValue = cv_Name THEN
   RETURN Str.Cap(Str.Condense(Cond)) = Str.Cap(Str.Condense(_Frms.Name));
  ELSE
   L_General.CallUs(0);
  END;
 END {ConditionCheck};

 PRIVATE PROCEDURE Executing(_File, _FCode, _FName: STRING[]);
  VAR
   AddCode: STRING[];
 BEGIN
  IF    ~!_Value THEN
   IF    _File = "BankBrn" THEN
    AddCode:=BankBrn.Bank;
    _Frms.Code:=AddCode+^_File.^_FCode;
   ELSIF _File = "Bank" THEN
    _Frms.Code :=^_File.^_FCode+"000";
   ELSE
    _Frms.Code :=^_File.^_FCode;
   END;
   _Frms.Name  :=^_File.^_FName;
   _Frms.Value :=_Value;
   INSERT(_Frms);
  ELSE
   IF (_File # "BankBrn") &
      ((_File # "Firm") | (Firm.PrtnrTyp # P_Firm.pt_Man)) THEN
    MAKEPART(R, RepLine3, ^_File.^_FCode, "", ^_File.^_FName);
    INC(NumErr);
   END;
  END;
 END {Executing};

 PRIVATE PROCEDURE PrepareTempFile(_File, _FileLog, _Index, _FCode, _FName, _FValue: STRING[]; Object: tObject);
 BEGIN
  SELECT(^_File, ^_Index);
  WHILE OCCURE(^_File) DO
   IF _File = "Firm" THEN
    PROMPT(" ࠡ⪠ " + ^_File.^_FCode);
   ELSE
    PROMPT(" ࠡ⪠.  " + ^_File.Bank  + " " + ^_File.^_FCode);
   END;
   IF L_DatTim.IsActive(Memo.ud_cd(), ^_File.Begin, ^_File.Till) THEN
    SETEMPTY(_Value);
    IF    Object = o_Firm THEN
     TRY
      _Value:=P_Firm.FP_INN(^_File.^_FCode, Memo.ud_cd());
     EXCEPT
     ON Exc: Exc_Raise DO
     ELSE
      RAISE();
     END; (* TRY *)
    ELSIF Object = o_Bank THEN
     HISTCONF(Memo.ud_cd(), ^_File, ^_FileLog);
     IF OCCURE(^_FileLog) THEN
      IF Memo.ud_cd() < ^_FileLog.Till THEN
       _Value:=^_FileLog.^_FValue;
      END;
     END;
    ELSE
     L_General.CallUs(0);
    END;
    Executing(_File, _FCode, _FName);
   END;
   NEXT(^_File);
  END; (* WHILE OCCURE(^_File) ... *)
 END {PrepareTempFile};

 PRIVATE PROCEDURE SliceCode(_Code: STRING[]; VAR _Code1, _Code2: STRING[]);
 BEGIN
  IF Str.Length(_Code) = 4 THEN
   _Code1:=_Code;
   _Code2:="";
  ELSE
   _Code1:=Str.Slice(_Code, 0, 3);
   _Code2:=Str.Slice(_Code, 3, 3);
   IF _Code2="000" THEN
    _Code2:="";
   END;
  END;
 END {SliceCode};

 PRIVATE PROCEDURE CheckFirmProp(_Index: STRING[]; CheckValue: tCheckValue; wBranch: SCAL[2]);
  VAR
   _Code1,
   _Code2   : STRING[];
   _Name    : LIKE(Bank.Name);
   PrintMain: SCAL[2];
   Cnt      : NUMERIC[0];
 BEGIN
  SETZERO(PrintMain, Cnt);
  IF SELECT(_Frms, ^_Index) THEN
   _Code :=_Frms.Code;
   _Name :=_Frms.Name;
   _Value:=_Frms.Value;
   NEXT(_Frms);
   WHILE OCCURE(_Frms) DO
    PROMPT("஢塞 " + _Frms.Code);
    IF ConditionCheck(CheckValue, _Name, wBranch) THEN
     IF ~PrintMain THEN
      PrintMain:=1;
      IF Cnt > 0 THEN
       MAKEPART(R, Dlm);
      END;
      INC(Cnt);
      SliceCode(_Code, _Code1, _Code2);
      MAKEPART(R, RepLine3, _Code1, _Code2, _Name, _Value);
      INC(NumErr);
     END;
     SliceCode(_Frms.Code, _Code1, _Code2);
     MAKEPART(R, RepLine3, _Code1, _Code2, _Frms.Name, _Frms.Value);
     INC(NumErr);
    ELSE
     SETZERO(PrintMain);
     _Code :=_Frms.Code;
     _Name :=_Frms.Name;
     _Value:=_Frms.Value;
    END;
    NEXT(_Frms);
   END; (* WHILE OCCURE(_Frms) ... *)
  END;
 END {CheckFirmProp};

 PRIVATE PROCEDURE GetTmpOrg(File, Field : STRING[]): LIKE(Firm.Firm);
  VAR
   _Org, CurOrg: LIKE(Firm.Firm);
 BEGIN
  SELECT(^File, ^Field);
  _Org:=^(File + "." + Field);
  WHILE OCCURE(^File) DO
   CurOrg:=^(File + "." + Field);
   IF _Org # CurOrg THEN
    RETURN _Org;
   END;
   INC(_Org);
   NEXT(^File);
  END; (* WHILE OCCURE(^File) ... *)
  L_General.CallUs(0);
 END {GetTmpOrg};

 PRIVATE PROCEDURE GetMaxPropertyNameLength(srcFirm, dstFirm: LIKE(Firm.Firm)): NUMERIC[0];
  VAR
   MaxPropertyNameLength: NUMERIC[0];
   DoIt                 : SCAL[2];
 BEGIN
  MaxPropertyNameLength:=0;
  SELECT(FirmPro, Firm, , srcFirm);
  WHILE OCCURE(FirmPro) DO
   NARROWSEL(FirmPro, Property);
   SAVE(FirmPro);
   DoIt:=SELECT(FirmPro, Firm, dstFirm, FirmPro.Property);
   RESTORE(FirmPro);
   IF DoIt THEN
    CONFORM(FirmPro, Property);
    MaxPropertyNameLength:=Math.Max(Str.Length(Property.Name), MaxPropertyNameLength);
   END;
   NEXTINEXTENDEDSEL(FirmPro, Property);
  END (* WHILE OCCURE(FirmPro) ... *);
  RETURN MaxPropertyNameLength;
 END {GetMaxPropertyNameLength};

 PRIVATE PROCEDURE MoveFirmCtc(srcFirm, dstFirm: LIKE(Firm.Firm));
  VAR
   deltaId,
   deltaFirmCtc: NUMERIC[0];
 BEGIN
  SETSEL(FirmCtc, Id, dstFirm);
  IF LAST(FirmCtc) THEN
   deltaId:=FirmCtc.Id;
  ELSE
   deltaId:=1;
  END;
  SETSEL(FirmCtc, Firm, dstFirm);
  IF LAST(FirmCtc) THEN
   deltaFirmCtc:=FirmCtc.FirmCtc;
  ELSE
   deltaFirmCtc:=1;
  END;

  WHILE SELECT(FirmCtc, Id, srcFirm) DO
   FirmCtc.Firm:=dstFirm;
   INC(FirmCtc.Id, deltaId);
   INC(FirmCtc.FirmCtc, deltaFirmCtc);
   IF ~!FirmCtc.Parent THEN
    INC(FirmCtc.Parent, deltaId);
   END;
   REPLACE(FirmCtc);
  END;
 END {MoveFirmCtc};

 PRIVATE PROCEDURE intMergeFirm(D: DATE; srcFirm, dstFirm: LIKE(Firm.Firm));
  VAR
   srcBegin    : LIKE(Firm.Begin);
   srcTill     : LIKE(Firm.Till);
   TmpFirm     : LIKE(Firm.Firm);
   _AcntN,
   _FirmAcntT,
   _FirmAcntF  : LIKE(FirmAcnt.FirmAcnt);
   _AcntA      : LIKE(FirmAcnt.AcntA);
   _SilentD    : LIKE(FirmAcnt.SilentD);
   _Type       : LIKE(FirmAcnt.Type);
   _Begin      : DATE;
   _Till       : DATE;
   _Bank       : LIKE(FirmAcnt.Bank);
   _BankBrn    : LIKE(FirmAcnt.BankBrn);
   S           : STRING[];
   FoundAcnt   : SCAL[2];
   MaxWidth    : NUMERIC[0];
   DoIt        : SCAL[2];
   old_prnFirm,
   new_prnFirm : LIKE(Contract.prnFirm);
   MaxPropertyNameLength: NUMERIC[0];
   srcFirmName,
   dstFirmName : STRING[];
 BEGIN
  APP.Get().NewPrompt(srcFirm + " -> " + dstFirm);
  SEARCH(Firm, Firm, , srcFirm);
  L_r2r.Owner_OnBeforeDelete("Firm");
  srcFirmName:=Firm.Name;
  SEARCH(Firm, Firm, , dstFirm);
  dstFirmName:=Firm.Name;
  L_StdFrm.Choice(" ᯮ짮 ࠣ" +
                   "| |" +
                   srcFirm + " " + srcFirmName +
                   "|" +
                   "" +
                   "|" +
                   dstFirm + " " + dstFirmName);

  L_General.Assert(srcFirm # dstFirm, "  ᮡ?");
  SETEMPTY(old_prnFirm, new_prnFirm);
  old_prnFirm:=L_Cntr.intGetGroupParent(L_Cntr.iit_FirmGroup, srcFirm, 0, 1, EMPTYOF(Contract.Contract));
  IF ~!old_prnFirm THEN
   new_prnFirm:=L_Cntr.intGetGroupParent(L_Cntr.iit_FirmGroup, dstFirm, 1, 0, EMPTYOF(Contract.Contract));
  END;

  L_General.CallUs(SEARCH(Firm, Firm, srcFirm));
  srcBegin:=Firm.Begin;
  srcTill :=Firm.Till;

  L_General.Assert(SEARCH(Firm, Firm, dstFirm), "  ࠣ   " + dstFirm);
  Firm.Begin:=Math.Min(Firm.Begin, srcBegin);
  Firm.Till :=Math.Max(Firm.Till,  srcTill);
  REPLACE(Firm);

  TmpFirm:=GetTmpOrg("Firm", "Firm");

  L_General.Assert(!P_Firm.GetFirmProSoft(srcFirm, D, P_Firm.P_INN) | (P_Firm.FP_INN(dstFirm, D) = P_Firm.FP_INN(srcFirm, D)),
                   " ᫨ ࠣ⮢  ᮢ !");

  GE_APPWIN_SIZE(MaxWidth);
  DEC(MaxWidth, 6);
  MaxPropertyNameLength:=GetMaxPropertyNameLength(srcFirm, dstFirm);
  S:="";
  SELECT(FirmPro, Firm, , srcFirm);
  WHILE OCCURE(FirmPro) DO
   NARROWSEL(FirmPro, Property);
   SAVE(FirmPro);
   DoIt:=SELECT(FirmPro, Firm, dstFirm, FirmPro.Property);
   RESTORE(FirmPro);
   IF DoIt THEN
    CONFORM(FirmPro, Property);
    S:= S + "|" + Str.Slice(Str.Align(Property.Name, MaxPropertyNameLength, LEFT)+": "+Str.Align(FirmPro.Value, MaxWidth - MaxPropertyNameLength + 2, LEFT), 0, MaxWidth);
    REMSEL(FirmPro);
    SELECT(FirmPro, Firm, , srcFirm);
   ELSE
    NEXTINEXTENDEDSEL(FirmPro, Property);
   END;
  END (* WHILE OCCURE(FirmPro) ... *);

  IF ~!S THEN
   L_StdFrm.Choice(" 㤠 ᢮⢠ ࠣ " + srcFirm + ":|" + S);
  END;

  SETSEL(FirmAcnt, Firm, dstFirm);
  IF LAST(FirmAcnt) THEN
   _AcntN:=FirmAcnt.FirmAcnt;
  ELSE
   _AcntN:=0;
  END;

  SELECT(FirmAcnt, Firm, , srcFirm);
  WHILE OCCURE(FirmAcnt) & (FirmAcnt.Firm = srcFirm) DO
   _AcntA    :=FirmAcnt.AcntA;
   _SilentD  :=FirmAcnt.SilentD;
   _Type     :=FirmAcnt.Type;
   _Begin    :=FirmAcnt.Begin;
   _Till     :=FirmAcnt.Till;
   _Bank     :=FirmAcnt.Bank;
   _BankBrn  :=FirmAcnt.BankBrn;
   _FirmAcntF:=FirmAcnt.FirmAcnt;
   SAVE(FirmAcnt);

   SELECT(FirmAcnt, Firm, , dstFirm);
   SETZERO(FoundAcnt);
   WHILE OCCURE(FirmAcnt) & (FirmAcnt.Firm = dstFirm) DO
    IF (FirmAcnt.AcntA = _AcntA) & L_DatTim.IsActiveInIntvl(FirmAcnt.Begin, FirmAcnt.Till, _Begin, _Till) THEN
     FoundAcnt := 1;
     IF FirmAcnt.Type # _Type THEN
      L_General.Error("!|  ("+FirmAcnt.AcntA+")| ࠧ ⨯  ࠣ⮢");
     END;
     IF FirmAcnt.SilentD # _SilentD THEN
      L_General.Error("!|  ("+FirmAcnt.AcntA+")|    ࠣ⮢");
     END;
     IF FirmAcnt.Begin # _Begin THEN
      FirmAcnt.Begin:=L_DatTim.MinDATE(FirmAcnt.Begin, _Begin);
      REPLACE(FirmAcnt);
     END;
     IF FirmAcnt.Till # _Till THEN
      FirmAcnt.Till:=L_DatTim.MaxDATE(FirmAcnt.Till, _Till);
      REPLACE(FirmAcnt);
     END;
     IF FirmAcnt.Bank # _Bank THEN
      L_General.Error("!|  ("+FirmAcnt.AcntA+")|室  ࠧ .|室 ਢ   ᮮ⢥⢨");
     END;

     _FirmAcntT:=FirmAcnt.FirmAcnt;

     TRY [INTEGRITY(INTEGRITY_OFF)]
      FirmAcnt.Firm:=TmpFirm;
      REPLACE(FirmAcnt);
     EXCEPT
     END;
   
     TRY [INTEGRITY(INTEGRITY_ON)]
      SEARCH(FirmAcnt, Firm, , srcFirm, _FirmAcntF);
      FirmAcnt.Firm    :=dstFirm;
      FirmAcnt.FirmAcnt:=_FirmAcntT;
      REPLACE(FirmAcnt);
     EXCEPT
     END;
    
     TRY [INTEGRITY(INTEGRITY_OFF)]
      FirmAcnt.Firm    :=srcFirm;
      FirmAcnt.FirmAcnt:=_FirmAcntF;
      REPLACE(FirmAcnt);
     
      SEARCH(FirmAcnt, Firm, , TmpFirm, _FirmAcntT);
      FirmAcnt.Firm:=dstFirm;
      REPLACE(FirmAcnt);
     EXCEPT
     END;
    ELSIF FirmAcnt.SilentD & _SilentD THEN
     L_General.Assert(~L_DatTim.IsActiveInIntvl(FirmAcnt.Begin, FirmAcnt.Till, _Begin, _Till),
                      "祭 ਮ ⢨   ⮢" +
                      "|" +
                      "|ࠣ " + srcFirm + ", / " + _AcntA         + ",   " + L_DatTim.DateStr(_Begin)         + "  " + L_DatTim.DateStr(_Till) +
                      "|ࠣ " + dstFirm + ", / " + FirmAcnt.AcntA + ",   " + L_DatTim.DateStr(FirmAcnt.Begin) + "  " + L_DatTim.DateStr(FirmAcnt.Till) +
                      "||室 ਢ   ᮮ⢥⢨");
    END; (* IF ...*)

    NEXT(FirmAcnt);
   END; (* WHILE OCCURE(FirmAcnt) ... *)

   RESTORE(FirmAcnt);

   IF ~FoundAcnt THEN
    INC(_AcntN);
    TRY [INTEGRITY(INTEGRITY_ON)]
     FirmAcnt.Firm    :=dstFirm;
     FirmAcnt.FirmAcnt:=_AcntN;
     REPLACE(FirmAcnt);
    EXCEPT
    END;
    SELECT(FirmAcnt, Firm, , srcFirm);
   ELSE
    REMOVE(FirmAcnt);
   END;
  END; (* WHILE OCCURE(FirmAcnt) ...*)

  MoveFirmCtc(srcFirm, dstFirm);

  TRY [INTEGRITY(INTEGRITY_OFF)]
   SEARCH(Firm, Firm, , dstFirm);
   Firm.Firm:=TmpFirm;
   REPLACE(Firm);
  EXCEPT
  END;

  TRY [INTEGRITY(INTEGRITY_ON)]
   SELECT(FirmAcnt, Firm, , srcFirm);
   REMSEL(FirmAcnt);
 
   SEARCH(Firm, Firm, , srcFirm);
   Firm.Firm:=dstFirm;
   REPLACE(Firm);
  EXCEPT
  END;

  TRY [INTEGRITY(INTEGRITY_OFF)]
   REMOVE(Firm);
  EXCEPT
  END;

  TRY [INTEGRITY(INTEGRITY_ON)]
   SEARCH(Firm, Firm, , TmpFirm);
   Firm.Firm:=dstFirm;
   REPLACE(Firm);
  EXCEPT
  END;

  IF ~!old_prnFirm THEN
   L_General.CallUs(~!new_prnFirm);
   WHILE SELECT(Contract, prnFirm, old_prnFirm) DO
    PROMPT("ࠡ⪠ " + Contract.Contract);
    Contract.prnFirm:=new_prnFirm;
    REPLACE(Contract);
   END; (* WHILE SELECT(Contract, prnFirm, old_prnFirm)...*)
 
   SEARCH(Contract, Contract, , old_prnFirm);
   REMOVE(Contract);
  END;
  CALL(Contract.ReplicationFirmNameToContracts(dstFirm));
 END {intMergeFirm};

 PUBLIC PROCEDURE MergeFirm();
  VAR
   dstFirm: LIKE(Firm.Firm);
 BEGIN
  L_General.AdminOnly();
  L_General.Assert(ACCESS(Firm), " ⠭ ࠣ");
  L_General.Assert(~P_Firm.IsOwnFirm(Firm.Firm), " ࣠ ᫨ !");

  SETEMPTY(dstFirm);
  LOOP
   STDFORM(L_StdFrm.sf_Choice("|  ࠣ " + Firm.Firm + "  ७ᥭ," +
                              "|᫥ 祣  ࠣ 㤥 㤠." +
                              "|  ࠣ⮬ ꥤ ?||%####%|",
                              "%I"),
           "ꥤ ࠣ⮢",
           ,
           ,
           dstFirm);
   IF dstFirm = P_Firm.OWN_FIRM THEN
    L_StdFrm.RedInform("ࠣ 0000 饭 ᫨  㣨");
   ELSE
    EXIT;
   END;
  END; (* LOOP *)
  intMergeFirm(SYSDATE(), Firm.Firm, dstFirm);
 END {MergeFirm};

 PRIVATE PROCEDURE GetLastNumberBankBrn(_Bank: LIKE(Bank.Bank)): LIKE(BankBrn.BankBrn);
 BEGIN
  SETSEL(BankBrn, Bank, _Bank);
  IF LAST(BankBrn) THEN
   RETURN BankBrn.BankBrn;
  END;
  RETURN 0;
 END {GetLastNumberBankBrn};

 PRIVATE PROCEDURE ChangeBankLink(SrcBank, DstBank: LIKE(Bank.Bank));
  VAR
   TmpBank: LIKE(Firm.Firm);
 BEGIN
  TmpBank:=GetTmpOrg("Bank", "Bank");

  TRY [INTEGRITY(INTEGRITY_OFF)]
   SEARCH(Bank, Bank, , DstBank);
   Bank.Bank:=TmpBank;
   REPLACE(Bank);
  EXCEPT
  END;

  TRY [INTEGRITY(INTEGRITY_ON)]
   SEARCH(Bank, Bank, , SrcBank);
   Bank.Bank:=DstBank;
   REPLACE(Bank);
  EXCEPT
  END;

  TRY [INTEGRITY(INTEGRITY_OFF)]
   REMOVE(Bank);
  EXCEPT
  END;

  TRY [INTEGRITY(INTEGRITY_ON)]
   SEARCH(Bank, Bank, , TmpBank);
   Bank.Bank:=DstBank;
   REPLACE(Bank);
  EXCEPT
  END;
 END {ChangeBankLink};

 PRIVATE PROCEDURE SupportBankLogTill(_Bank: LIKE(Bank.Bank));
  VAR
   _Date: DATE;
 BEGIN
  SETEMPTY(_Date);
  SETSEL(BankLog, Bank, _Bank);
  LAST(BankLog);
  WHILE OCCURE(BankLog) DO
   BankLog.Till:=_Date;
   REPLACE(BankLog);
   _Date:=BankLog.Date;
   PREV(BankLog);
  END; (* WHILE OCCURE(BankLog)...*)
 END {SupportBankLogTill};

 PRIVATE PROCEDURE intMergeBank(SrcBank, DstBank: LIKE(Bank.Bank));
  VAR
   _Date      : DATE;
   LastBankBrn: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(SrcBank + " -> " + DstBank);
  L_General.Assert(SrcBank # DstBank, "  ᮡ?");
  SEARCH(Bank, Bank, , SrcBank);
  L_r2r.Owner_OnBeforeDelete("Bank");
  L_General.Assert(SEARCH(Bank, Bank, DstBank), "     " + DstBank);

  TRY [INTEGRITY(INTEGRITY_ON)]
   WHILE SELECT(BankLog, Bank, SrcBank) DO
    SAVE(BankLog);
    _Date:=BankLog.Date;
    L_General.Assert(~SEARCH(BankLog, Bank, DstBank, _Date),
                     "ﭨ  |" +
                     "  砫 ⢨ ४⮢  " +
                     L_DatTim.DateStr(_Date));
    RESTORE(BankLog);
    BankLog.Bank:=DstBank;
    REPLACE(BankLog);
   END; (* WHILE SELECT(BankLog, Bank, SrcBank)... *)
   SupportBankLogTill(DstBank);
 
   LastBankBrn:=GetLastNumberBankBrn(DstBank);
 
   WHILE SELECT(BankBrn, Bank, SrcBank) DO
    INC(LastBankBrn);
    BankBrn.Bank   :=DstBank;
    BankBrn.BankBrn:=LastBankBrn;
    REPLACE(BankBrn);
   END; (* WHILE SELECT(BankBrn, Bank, SrcBank)... *)
  EXCEPT
  END;

  ChangeBankLink(SrcBank, DstBank);
 END {intMergeBank};

 PUBLIC PROCEDURE MergeBank();
  VAR
   DstBank: LIKE(Bank.Bank);
 BEGIN
  L_General.AdminOnly();
  L_General.Assert(ACCESS(Bank), " ⠭ ⥪騩 ");
  SETEMPTY(DstBank);
  STDFORM(L_StdFrm.sf_Choice("|   " + Bank.Bank + "  ७ᥭ,|" +
                             "᫥ 祣   㤥 㤠." +
                             "|   ꥤ ?||%###%|",
                             "%I"),
          "ꥤ ",
          ,
          ,
          DstBank);
  intMergeBank(Bank.Bank, DstBank);
 END {MergeBank};

 PRIVATE PROCEDURE MakeBankBranch(SrcBank, DstBank: LIKE(Bank.Bank));
  VAR
   LastBankBrn: NUMERIC[0];
   _Begin,
   _Till      : DATE;
 BEGIN
  APP.Get().NewPrompt("७  " + SrcBank + "  䨫  "+ DstBank);
  L_General.Assert(SrcBank # DstBank, " ᤥ  䨫 ᠬ ᥡ");
  SEARCH(Bank, Bank, , SrcBank);
  L_r2r.Owner_OnBeforeDelete("Bank");
  _Begin:=Bank.Begin;
  _Till :=Bank.Till;
  L_General.Assert(SEARCH(Bank, Bank, DstBank), "      " + DstBank);

  IF SELECT(BankBrn, Bank, SrcBank) THEN
   L_General.Assert(~NEXT(BankBrn), "!| |" +
                    " 믮 ७  " + SrcBank +
                    ",| ..    ᪮쪮 䨫");
   L_StdFrm.Choice("!| |  " + SrcBank + "  䨫 |" +
                   "|  ७  " + SrcBank + "    " + DstBank +
                   "|  䨫 㤥 㭨⮦");
  END;

  OPENREP(R, L_General.NameConnection("RepCg"), Create);
  MAKEPART(R, RepTop2, SrcBank, DstBank);

  TRY [INTEGRITY(INTEGRITY_ON)]
   LastBankBrn:=GetLastNumberBankBrn(DstBank);
   INC(LastBankBrn);
 
   BankBrn.Bank   :=DstBank;
   BankBrn.BankBrn:=LastBankBrn;
   BankBrn.Name   :=Bank.Name;
   BankBrn.Phone  :=Bank.Phone;
   BankBrn.Begin  :=_Begin;
   BankBrn.Till   :=_Till;
   INSERT(BankBrn);
 
   WHILE SELECT(FirmAcnt, Bank, SrcBank) DO
    CONFORM(FirmAcnt, Firm);
    MAKEPART(R, RepLine2, DstBank, L_Str.IntStr(LastBankBrn));
    FirmAcnt.Bank   :=DstBank;
    FirmAcnt.BankBrn:=LastBankBrn;
    REPLACE(FirmAcnt);
   END; (* WHILE SELECT(FirmAcnt, Bank, SrcBank) ... *)
 
   MAKEPART(R, RepBot2);
 
   SELECT(BankLog, Bank, , SrcBank);
   WHILE OCCURE(BankLog) DO
    BankBrnL.Bank   :=DstBank;
    BankBrnL.BankBrn:=LastBankBrn;
    BankBrnL.Date   :=BankLog.Date;
    BankBrnL.Till   :=BankLog.Till;
    BankBrnL.RegName:=BankLog.RegName;
    BankBrnL.Region :=BankLog.Region;
    BankBrnL.BIC    :=BankLog.BIC;
    BankBrnL.CorAcnt:=BankLog.CorAcnt;
    INSERT(BankBrnL);
    NEXT(BankLog);
   END; (* WHILE OCCURE(BankLog) ...*)
 
   SELECT(BankBrn, Bank, , SrcBank);
   REMSEL(BankBrn);
 
   SELECT(BankLog, Bank, , SrcBank);
   REMSEL(BankLog);
 
   SEARCH(Bank, Bank, , SrcBank);
   REMOVE(Bank);
  EXCEPT
  END;
 
  L_General.SurveyLastReport();
 END {MakeBankBranch};

 PUBLIC PROCEDURE TransformBankToBankBranch();
  VAR
   DstBank: LIKE(Bank.Bank);
 BEGIN
  L_General.AdminOnly();
  L_General.Assert(ACCESS(Bank), " ⠭ ⥪騩 ");
  SETEMPTY(DstBank);
  STDFORM(L_StdFrm.sf_Choice("|   "+Bank.Bank+"  ७ᥭ," +
                             "|᫥ 祣   㤥 㤠." +
                             "|   ||%###%|",
                             "%I"),
          "७   䨫",
          ,
          ,
          DstBank);
  MakeBankBranch(Bank.Bank, DstBank);
 END {TransformBankToBankBranch};

 PRIVATE PROCEDURE CheckOneBankBrn(file: STRING[]; _BankBrn: LIKE(BankBrn.BankBrn));
  VAR
   BankName: STRING[];
   _BIC    : LIKE(BankLog.BIC);
   _CorAcnt: LIKE(BankLog.CorAcnt);
 BEGIN
  IF (file = "BankBrnL") & ~!BankBrnL.CorAcnt THEN
   _CorAcnt:=BankBrnL.CorAcnt;
  ELSE
   _CorAcnt:=BankLog.CorAcnt;
  END;
  IF (file = "BankBrnL") & ~!BankBrnL.BIC THEN
   _BIC:=BankBrnL.BIC;
  ELSE
   _BIC:=BankLog.BIC;
  END;
  IF Memo.ud_cd() < ^file.Till THEN
   IF SEARCH(BIC, BIC, _BIC) THEN
    IF ~P_Firm.IsRKC(_BIC) THEN
     IF !_CorAcnt THEN
      MAKEPART(R, RepLine, _BankBrn, "  .", _BIC);
     END;
     IF BIC.CorAcnt # _CorAcnt THEN
      MAKEPART(R, RepLine, _BankBrn, ". "+_CorAcnt+"  ᮢ  ࠢ", _BIC);
     END;
     IF (file # "BankBrnL") | ~!BankBrnL.BIC THEN
      BankName:=Str.Condense(L_Str.StrFormat(^file.RegName) + " " + ^file.Region);
      IF Str.Cap(Str.Condense(BIC.Name)) # Str.Cap(BankName) THEN
       MAKEPART(R, RepLine, _BankBrn, " "+BankName+"  ᮢ  ࠢ", _BIC);
      END;
     END;
    END;
   ELSE
    MAKEPART(R, RepLine, _BankBrn, " ࠢ筨   ", _BIC);
   END;
  END;
 END {CheckOneBankBrn};

 PUBLIC PROCEDURE RepCg();
  VAR
   _BIC    : LIKE(BankLog.BIC);
   _CorAcnt: LIKE(BankLog.CorAcnt);
 BEGIN
  L_General.Assert(SELECT(BIC, BIC), "ࠢ筨   ");
  OPENREP(R, L_General.NameConnection("RepCg"), Create);
  MAKEPART(R, RepTop);
  SELECT(Bank, Bank);
  WHILE OCCURE(Bank) DO
   PROMPT("஢ઠ " + Bank.Bank);
   IF L_DatTim.IsActive(Memo.ud_cd(), Bank.Begin, Bank.Till) THEN
    HISTCONF(Memo.ud_cd(), Bank, BankLog);
    IF OCCURE(BankLog) THEN
     CheckOneBankBrn("BankLog", "");
    END;
    SELECT(BankBrn, Bank, , Bank.Bank);
    WHILE OCCURE(BankBrn) DO
     HISTCONF(Memo.ud_cd(), BankBrn, BankBrnL);
     IF OCCURE(BankBrnL) THEN
      CheckOneBankBrn("BankBrnL", BankBrn.BankBrn);
     END;
     NEXT(BankBrn);
    END; (* WHILE OCCURE(BankBrn) ... *)
   END;
  NEXT(Bank);
  END; (* WHILE OCCURE(Bank) ... *)
  MAKEPART(R, RepBot);
 END {RepCg};

 PRIVATE PROCEDURE CheckFirms();
 BEGIN
  RepName := "DpINN";
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, RepTop3, "ࠣ, 騥 ४⭮  ᢮⢮ ");
  MAKEPART(R, RepSubTop3, "ࠣ   ", 0);
  PrepareTempFile("Firm", "" , "Firm", "Firm", "Name", "Value", o_Firm);
  MAKEPART(R, RepSubTop3, "ࠣ  묨 ", 0, 0);
  CheckFirmProp("Value", cv_INNorBIC, 1);
  MAKEPART(R, RepSubTop3, "ࠣ  묨 ﬨ", 0, 0);
  CheckFirmProp("Name", cv_Name, 0);
 END; {CheckFirms}

 PRIVATE PROCEDURE CheckBanks();
 BEGIN
  RepName := "DpBIC";
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, RepTop3, ", 騥 ४⭮  ");
  MAKEPART(R, RepSubTop3, "  묨 ", 1);
  PrepareTempFile("Bank",    "BankLog",  "Bank",    "Bank",    "Name", "BIC", o_Bank);
  PrepareTempFile("BankBrn", "BankBrnL", "BankBrn", "BankBrn", "Name", "BIC", o_Bank);
  MAKEPART(R, RepSubTop3, "  묨 ", 1, 1);
  CheckFirmProp("Value", cv_INNorBIC, 0);
  MAKEPART(R, RepSubTop3, "  묨 ﬨ", 1, 1);
  CheckFirmProp("Name", cv_Name, 0);
 END {CheckBanks};

 PRIVATE PROCEDURE CheckAnyObject(Object: tObject);
 BEGIN
  SETZERO(NumErr);
  Create__Frms(Object);
  L_AFM.CreateTemp("_Frms");
  IF    Object = o_Firm THEN
   CheckFirms();
  ELSIF Object = o_Bank THEN
   CheckBanks();
  ELSE
   L_General.CallUs(0);
  END;
  MAKEPART(R, RepBot3, NumErr);
  L_AFM.AF_PurgeTemp("_Frms");
 END {CheckAnyObject};

 PUBLIC PROCEDURE DpINN();
 BEGIN
  CheckAnyObject(o_Firm);
 END {DpINN};

 PUBLIC PROCEDURE DpBIC();
 BEGIN
  CheckAnyObject(o_Bank);
 END {DpBIC};

END.
