(*
%Copyright   (c) Polak Computer System
%Author      02.07.2002 10:15:32 GAV
%Purpose
%Type        report
%Specific    SYS
%Modified    12.02.2014 19:15:54 POLAK\San
%Environment
*)

 MODULE UnOve [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_DatTim, E_Utils, L_Env, L_PagePr, L_OwnData, L_AFM, L_General, L_Way,
        L_Staff, Memo, L_Sheet, L_Basis, FIO, L_Man, L_Str, Math, L_bp, P_Firm, P_Sort;

 VAR
  RepName,
  Title    : STRING[];
  p_Don,
  p_Arr,
  p_Ovr,
  tk_Don,
  tk_Arr,
  tk_Ovr,
  _Hld,
  _Bal,
  _Don,
  _Arr,
  _Ovr     : FLOAT;
  Last     : SCAL[2];
  TK       : LIKE(TimeKeep.TimeKeep);
  TKName   : LIKE(TimeKeep.Name);

 PRIVATE PROCEDURE E_UnOver_UnOv_Cnd(_Bal, _Don, _Arr, _Ovr: NUMERIC[3]): SCAL[2];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(E_Utils.UnOv_Cnd);
  IF ~!Local THEN
   RETURN Local(_Bal, _Don, _Arr, _Ovr);
  ELSE
   RETURN (_Arr > 0) | (_Ovr > 0.5*_Bal);
  END;
 END {E_UnOver_UnOv_Cnd};

 PRIVATE PROCEDURE _COND(ChSheetCond: SCAL[3]): SCAL[2];
 BEGIN
  IF    (ChSheetCond = 0) THEN
   RETURN TimeKeep.ChSheet;
  ELSIF (ChSheetCond = 1) THEN
   RETURN ~TimeKeep.ChSheet;
  ELSE
   RETURN 1;
  END;
 END {_COND};

(*
$P{ MainTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
Title+" (᭮ ࠡ)", C, ""
TK, L, ""
TKName, L, ""
@
############################################################# ########## #####
=#####========================================================================
|        ࠡ⪠/ࠡ⪠  ਮ  ##########  ##########        |
|############################################################################|
|----------------------------------------------------------------------------|
| ### #######################################                          |
}
*)

(*
$P{ Top:
@
|----------------------------------------------------------------------------|
|. |                           | . |ࠡ⪠|ࠡ|ࠡ|
|-----|------------------------------|---------|---------|---------|---------|
}
*)

 PRIVATE PROCEDURE _ToStr(_Val:NUMERIC[2]): STRING[];
 BEGIN
  IF (_Val > 0) THEN
   RETURN FLDTOSTR(_Val, "2.");
  ELSE
   RETURN "";
  END;
 END {_ToStr};

(*
$P{ Line:
Staff.TSN, L, ""
Man.Name, L, ""
_Bal, R, "2."
_ToStr(_Don), R, ""
_ToStr(_Arr), R, ""
_ToStr(_Ovr), R, ""
@
|#####|##############################|#########|#########|#########|#########|
}
*)

(*
$P{ Filling:
@
|     |                              |         |         |         |         |
}
*)

(*
$P{ Bot:
L_PagePr.PagePr_CurrentPage(), R, "0"
@
=(c) Polak========================================================== ###===
}
*)

(*
$P{ SubTotal:
TKName, L, ""
tk_Don, R, "2."
tk_Arr, R, "2."
tk_Ovr, R, "2."
@
|----------------------------------------------|---------|---------|---------|
|⮣  ⠡ ##############################|#########|#########|#########|
}
*)

(*
$P{ RepBot:
p_Don, R, "2."
p_Arr, R, "2."
p_Ovr, R, "2."
@
|==============================================|=========|=========|=========|
|⮣  ।                          |#########|#########|#########|
}
*)

 PRIVATE PROCEDURE _RprtTop(Mode: SCAL[20]);
 BEGIN
  IF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, MainTop);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtTop};

 PRIVATE PROCEDURE _PageTop(Mode: SCAL[20]);
 BEGIN
  IF (Mode = L_PagePr.m_Print) | (Mode = L_PagePr.m_RDoneTop)  THEN
   MAKEPART(R, Top);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageTop};

 PRIVATE PROCEDURE _PageBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Bot));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Bot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_None);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_PageBot};

 PRIVATE PROCEDURE _RprtBot(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   IF Last THEN
    L_PagePr.PagePr_SetResult(DEPTH(SubTotal)+DEPTH(RepBot)+DEPTH(Bot));
   ELSE
    L_PagePr.PagePr_SetResult(DEPTH(SubTotal)+DEPTH(Bot));
   END;
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, SubTotal);
   IF Last THEN
    MAKEPART(R, RepBot);
   END;
   MAKEPART(R, Bot);
  ELSIF Mode = L_PagePr.m_HowBot THEN
   L_PagePr.PagePr_SetResult(L_PagePr.pbot_Fill);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_RprtBot};

 PRIVATE PROCEDURE _Filling(Mode: SCAL[20]);
 BEGIN
  IF    Mode = L_PagePr.m_Depth THEN
   L_PagePr.PagePr_SetResult(DEPTH(Filling));
  ELSIF Mode = L_PagePr.m_Print THEN
   MAKEPART(R, Filling);
  ELSE
   L_PagePr.PagePr_BadCallMode(0);
  END;
 END {_Filling};

 PRIVATE PROCEDURE MakeIndex(ChSheetCond: SCAL[3]);
 BEGIN
  L_AFM.MakeIndex("_unvr", "TimeKeep: LIKE(TimeKeep.TimeKeep);TSN: LIKE(Staff.TSN);Date: DATE");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Env.RealTSN(Staff.TSN) & (Staff.Contract = L_Staff.cnt_Basic) THEN
    HISTCONF(Math.Max(Staff.BegDate, Memo.ud_fr()), Staff, StaffLog);
    WHILE OCCURE(StaffLog) & (StaffLog.Date <= Memo.ud_ut()) DO
     IF ~L_Staff.IsDischargeStaffLog() THEN
      CONFORM(StaffLog, Officer);
      CONFORM(Officer, TimeKeep);
      IF _COND(ChSheetCond) THEN
       _unvr.TimeKeep:=Officer.TimeKeep;
       _unvr.TSN:=StaffLog.TSN;
       _unvr.Date:=StaffLog.Date;
       INSERT(_unvr);
      END;
     END;
     NEXT(StaffLog);
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE GetGate(VAR B, E: DATE);
 BEGIN
  B:=Math.Max(StaffLog.Date,  Memo.ud_fr());
  E:=Math.Min(StaffLog.DateE, Memo.ud_ut());
 END {GetGate};

 PRIVATE PROCEDURE CountValues();
  VAR
   BegDate,
   EndDate: DATE;
   HBal,
   NightTime: NUMERIC[3];
 BEGIN
  CONFORM(StaffLog, Staff);
  GetGate(BegDate, EndDate);
  L_Sheet.GetBalInf(BegDate, EndDate, 0, _Don, HBal, _Bal, NightTime, _Hld);
  IF (_Bal > _Don) THEN
   _Arr:=_Bal - _Don;
   _Ovr:=0;
  ELSE
   _Arr:=0;
   _Ovr:=_Don - _Bal;
  END;
 END {CountValues};

 PRIVATE PROCEDURE MakeRep1(ChSheetCond: SCAL[3]);
 BEGIN
  MakeIndex(ChSheetCond);
 
  SETZERO(p_Don, p_Arr, p_Ovr);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  SELECT(_unvr, _unvr);
  WHILE OCCURE(_unvr) DO
   CHANGESEL(_unvr, _unvr, , _unvr.TimeKeep);
   SEARCH(TimeKeep, TimeKeep, , _unvr.TimeKeep);
   TK    :=TimeKeep.TimeKeep;
   TKName:=TimeKeep.Name;

   SAVE(_unvr);
   LAST(_unvr);
   CHANGESEL(_unvr, _unvr);
   Last:=~NEXT(_unvr);
   RESTORE(_unvr);

   L_PagePr.PagePr_Init("R", 64, PROCREF(_RprtTop),
                                 PROCREF(_PageTop),
                                 PROCREF(_PageBot),
                                 PROCREF(_RprtBot),
                                 PROCREF(_Filling));
   SETZERO(tk_Don, tk_Arr, tk_Ovr);
   WHILE OCCURE(_unvr) DO
    PROMPT(_unvr.TimeKeep + " " +_unvr.TSN);
    SEARCH(StaffLog, TSN, , _unvr.TSN, _unvr.Date);
    CountValues();
    INC(tk_Don, _Don);
    INC(tk_Arr, _Arr);
    INC(tk_Ovr, _Ovr);
    IF (E_UnOver_UnOv_Cnd(_Bal, _Don, _Arr, _Ovr) # 0) THEN
     CONFORM(Staff, Man);
     L_PagePr.PagePr_BeforePrintLine(DEPTH("Line"));
     MAKEPART(R, Line);
    END;
    NEXT(_unvr);
   END; (* WHILE OCCURE(_unvr) ... *)
   INC(p_Don, tk_Don);   INC(p_Arr, tk_Arr);   INC(p_Ovr, tk_Ovr);
   L_PagePr.PagePr_Done();

   LAST(_unvr);
   CHANGESEL(_unvr, _unvr);
   NEXT(_unvr);
  END; (* WHILE OCCURE(_unvr) ... *)
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("_unvr");
 END {MakeRep1};

 PRIVATE VAR
  wMF,
  wMP: SCAL[2];

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  IF wMF THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  IF wMP THEN
   L_Basis.wb_WrInQM(F, "");
   L_Basis.wb_WrInQM(F, "");
  END;
  L_Basis.wb_WrInQM(F, " ");
  L_Basis.wb_WrInQM(F, "騪");
  L_Basis.wb_WrInQM(F, "騪");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " ⥫⢠");
  L_Basis.wb_WrInQM(F, "४஢ ");
  L_Basis.wb_WrInQM(F, "ࠡ⪠");
  L_Basis.wb_WrInQM(F, "ࠡ");
  L_Basis.wb_WrInQM(F, "ࠡ");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "ࠧ");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[]);
 BEGIN
  IF wMF THEN
   CONFORM(Staff, MyFirm);
   L_Basis.wb_WrScl(F, MyFirm.MyFirm);
   L_Basis.wb_WrStr(F, MyFirm.vzSign);
  END;
  IF wMP THEN
   SEARCH(MyPlace, MyPlace, , P_Sort.GetMyPlace(Officer.Sort, Memo.ud_ut()));
   L_Basis.wb_WrScl(F, MyPlace.MyPlace);
   L_Basis.wb_WrStr(F, MyPlace.Name);
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem("|", TimeKeep.ChSheet));
  L_Basis.wb_WrScl(F, TimeKeep.TimeKeep);
  L_Basis.wb_WrStr(F, TimeKeep.Name);
  L_Basis.wb_WrScl(F, StaffLog.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, L_Man.CitizenAsStr(Man.Man, Memo.ud_ut()));
  L_Basis.wb_WrNum(F, _Bal, 3);
  L_Basis.wb_WrNum(F, _Don, 3);
  L_Basis.wb_WrNum(F, _Arr, 3);
  L_Basis.wb_WrNum(F, _Ovr, 3);
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrNum(F, _Hld, 3);
  L_Basis.wb_WrNum(F, StaffLog.DutyDgr, 3);
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE MakeRep2(bpId: STRING[]);
 BEGIN
  wMF:=P_Firm.E_wMultipleMyFirm(SYSDATE());
  wMP:=P_Firm.E_wMultipleMyPlace(SYSDATE());
  FIO.Open(R, L_General.NameConnection(bpId), "REP", Create);
  MakeHeader("R");
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF L_Env.RealTSN(Staff.TSN) & (Staff.Contract = L_Staff.cnt_Basic) THEN
    CONFORM(Staff, Man);
    HISTCONF(Math.Max(Staff.BegDate, Memo.ud_fr()), Staff, StaffLog);
    WHILE OCCURE(StaffLog) & (StaffLog.Date <= Memo.ud_ut()) DO
     IF ~L_Staff.IsDischargeStaffLog() THEN
      CONFORM(StaffLog, TimeKeep);
      CONFORM(StaffLog, Officer);
      CONFORM(Officer,  Sort);
      CONFORM(Officer,  Union);
      CountValues();
      MakePart("R");
     END;
     NEXT(StaffLog);
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
  FIO.Close(R);
 END {MakeRep2};

 PUBLIC PROCEDURE UnOve();
  CONST
   bpId = "UnOve";
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Way.WarnUnDoneRWayS(Memo.ud_fr(), Memo.ud_ut());
  L_bp.Begin(bpId, "ࠡ⪠, ࠡ⪠ (᭮ ࠡ)", L_bp.t_Basis, L_General.tc_inIntvl);
  MakeRep2(bpId);
  L_bp.End();
 END {UnOve};

 PUBLIC PROCEDURE UnOv0();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Way.WarnUnDoneRWayS(Memo.ud_fr(), Memo.ud_ut());
  RepName:="UnOv0";
  Title  :="⭨  ⠡쭮 ";
  MakeRep1(0);
 END {UnOv0};

 PUBLIC PROCEDURE UnOv1();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Way.WarnUnDoneRWayS(Memo.ud_fr(), Memo.ud_ut());
  RepName:="UnOv1";
  Title  :="⭨  ⠡ ⮬";
  MakeRep1(1);
 END {UnOv1};

 PUBLIC PROCEDURE UnOv2();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Way.WarnUnDoneRWayS(Memo.ud_fr(), Memo.ud_ut());
  RepName:="UnOv2";
  Title  :=" ࠡ⭨";
  MakeRep1(2);
 END {UnOv2};

END.
