(*
%Copyright    (c) Polak IT
%Author       12.08.2014 19:49:39 POLAK\Bor
%Purpose
%Type         control, report, temporary, convertor, operation, library, to paste
%Specific     AP, AP_PC, SYS, LOC, TOOL
%Modified     13.08.2014 18:48:26 POLAK\Bor
*)

(*
$P{ Top:
P_Firm.MyFirmName(Contract.MyFirm, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Contract.Contract+" "+Contract.Name, C, ""
L_DatTim.MonthBeg(SYSDATE()), L, "D.N.y"
?, L, "2-"
@
################################################################################### ########## #####
=#####==============================================================================================
|                                                                        |
|##################################################################################################|
|--------------------------------------------------------------------------------------------------|
|줮  ##########: #######################                                                     |
|--------------------------------------------------------------------------------------------------|
|                | 樨                             |        |          |% |
|----------------------|-----------------------------------------|-------------|-------------|-----|
}
*)

(*
$P{ Line:
L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc), L, ""
MDoc.Date, L, "D.N.y"
MDoc.Dest, L, ""
Dest.Name, L, ""
? R, "2-"
? R, "2-"
? R, "2."
@
|########### ##########|### #####################################|#############|#############|#####|
}
*)

(*
$P{ Bot:
@
=(c) Polak==========================================================================================
}
*)


 PUBLIC PROCEDURE bvmd_GetBalanceAlteration(oBal: L_Pmnt.tValuesToBalance;
                                            VAR
                                             pInc,
                                             nInc: L_Pmnt.tValuesToBalance);
 BEGIN
  SETZERO(pInc, nInc);
  IF oBal[L_Pmnt.vtb_Total] < 0 THEN
   nInc:=L_Pmnt.vtbInv(oBal);
  ELSE
   pInc:=L_Pmnt.vtbInv(oBal);
  END;
 END {bvmd_GetBalanceAlteration};

 PRIVATE PROCEDURE GetRelatedVATMDC(BuildMode  : L_Pmnt.tVATMDocBuildMode;
                                    v          : L_Pmnt.tValuesToBalance);
  CONST
   relXDocAmount = 1000;
  VAR
   i              : SCAL[relXDocAmount];
   relXDocId      : L_XDoc.tXDocId[relXDocAmount];
   relXDocValue   : NUMERIC[2]    [relXDocAmount * RANGEOF(L_Pmnt.tValuesToBalance)];
   relatedBM      : L_Pmnt.tVATMDocBuildMode;
   curNetto,
   curVAT         : NUMERIC[2];
 BEGIN
  relatedBM:=L_Pmnt.vmdbm_GetRelatedBM(BuildMode);
  IF ~!relatedBM THEN
   L_Pmnt.GetRelatedVATMDocCollection(Contract.Contract,
                                      SYSDATE(),
                                      relatedBM,
                                      BuildMode,
                                      v,
                                      relXDocId, relXDocValue);
  ELSE
   SETEMPTY(relXDocId);
  END;

  FOR_EACH i DO
   IF !relXDocId[i] THEN
    EXIT;
   END;
   L_XDoc.PositionOnXDoc(relXDocId[i]);
   CONFORM(MDoc, Dest);
   curNetto:=relXDocValue[L_Pmnt.vtb_Netto + i*RANGEOF(L_Pmnt.tValuesToBalance)];
   curVAT  :=relXDocValue[L_Pmnt.vtb_VAT   + i*RANGEOF(L_Pmnt.tValuesToBalance)];
   MAKEPART(R, Line, curNetto, curVAT, curVAT/curNetto*100);
   L_XDoc.sl_AddItem(relXDocId[i], L_MDoc.GetMDocStrNbr());
  END;
 END {GetRelatedVATMDC};

 PUBLIC PROCEDURE UnSVT();
  CONST
   RepName = "UnSVT";
  VAR
   oBal,
   curAcpt,
   pInc,
   nInc        : L_Pmnt.tValuesToBalance;
 BEGIN
  APP.Get().NewPrompt("("+RepName+")");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(Contract);
  L_General.Assert(Contract.Leaf, "  ਬ  㯯஢ ᥩ");
  L_Pmnt.CheckSpecialVATMDocDone(Contract.Contract, SYSDATE());

  OPENREP(R, L_General.NameConnection(RepName), Create);
  oBal:=L_Pmnt.GetContractBalance(Contract.Contract, L_DatTim.MonthBeg(SYSDATE()),
                                  L_XDoc.min_DoneDTS,
                                  L_XDoc.min_DoneDTS);

  MAKEPART(R, Top, RepName, oBal[L_Pmnt.vtb_Total]);
  L_XDoc.sl_Init(" ");

  bvmd_GetBalanceAlteration(oBal, pInc, nInc);
  IF Contract.Type = L_Cntr.ct_Sell THEN
   IF    pInc[L_Pmnt.vtb_Total]<0 THEN
    GetRelatedVATMDC(L_Pmnt.vmdbm_Pstpayment, L_Pmnt.vtbInv(pInc));
   ELSIF pInc[L_Pmnt.vtb_Total]>0 THEN
    GetRelatedVATMDC(L_Pmnt.vmdbm_Underpay, pInc);
   END;
   IF    nInc[L_Pmnt.vtb_Total]<0 THEN
    GetRelatedVATMDC(L_Pmnt.vmdbm_Prepayment, L_Pmnt.vtbInv(nInc));
   ELSIF nInc[L_Pmnt.vtb_Total]>0 THEN
    GetRelatedVATMDC(L_Pmnt.vmdbm_PrpReturn (*vmdbm_OnPrpShpmt*), nInc);
   END;
  ELSE                         (* 㯪 *)
   IF    nInc[L_Pmnt.vtb_Total]<0 THEN
    GetRelatedVATMDC(L_Pmnt.vmdbm_PrchUndpay, L_Pmnt.vtbInv(nInc));
   ELSIF nInc[L_Pmnt.vtb_Total]>0 THEN
    GetRelatedVATMDC(L_Pmnt.vmdbm_PrchPstpay, nInc);
   END;
  END; (* IF Contract.Type...*)

  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_XDoc.sl_Done();
 END {UnSVT};

END.
