(*
%Copyright   (c) Polak IT
%Author      04.03.2009 16:50:29 POLAK\LDA
%Purpose     ७ ⮏
%Type        operation
%Specific    SYS
%Modified    25.08.2014 17:28:25 POLAK\Bor
%Environment
*)

 MODULE U_AP [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_AR, L_General, L_DatTim, L_StdFrm, L_APtm, L_Car, L_Env, L_Tax, L_XDoc, L_PDoc, L_MDoc,
        L_AFM, L_PRoll, Math, L_AvePay, L_Staff, L_Way, L_OwnData, L_RT, L_CUC, L_Rpr, L_MSWStp, L_ACS,
        L_SysLog;

 PRIVATE PROCEDURE extAdaptationAcsObj(Silent: SCAL[2]);
  VAR
   asl  : OBJECT;
   Dummy: STRING[];
 BEGIN
  IF ~Silent THEN
   L_General.AdminOnly();
   L_StdFrm.CrucialChoice(" ࠢ筨 '짮⥫'.||" +
                          "㤥 ந ⪠ SID  짮⥫|" +
                          "    ᭮ Active Directory.||" +
                          " ᪨ ᭠ , 室  㢥७  ᢮ ⢨|" +
                          " 稭  樨, ਢ襩  室 樨.",
                          L_General.AdminGroupName());
  END;

  IF L_MSWStp.NeedElevation() THEN
   TRY
    asl := L_MSWStp.GetElevatedASL("U_AP", L_MSWStp.aslDBModification_On);
    asl.IndicatorDelay:=0;
    PROMPT(" ࠢ筨 '짮⥫'");
    asl.Proc("extAdaptationAcsObj", 1);
   EXCEPT
   ON e: Exc_Object DO
    L_MSWStp.AsbApplicationErrorHandler(e);
   END;
  ELSE
   GRANTALLRIGHTS();
 
   SELECT(AcsObj, Name);
   WHILE OCCURE(AcsObj) DO
    PROMPT(" AcsObj: " + AcsObj.Name);
    SETEMPTY(AcsObj.ID);
    REPLACE(AcsObj);
    NEXT(AcsObj);
   END; (* WHILE OCCURE(AcsObj) ... *)
  
   SELECT(AcsObj2, Name);
   WHILE OCCURE(AcsObj2) DO
    PROMPT(" AcsObj2: " + AcsObj2.Name);
    SETEMPTY(AcsObj2.ID);
    REPLACE(AcsObj2);
    NEXT(AcsObj2);
   END; (* WHILE OCCURE(AcsObj2) ... *)

   Dummy:=L_AR.extRenovateUsersByAD(1);
  END;
 END {extAdaptationAcsObj};

 PUBLIC PROCEDURE AdaptationAcsObj();
 BEGIN
  extAdaptationAcsObj(0);
 END {AdaptationAcsObj};

 PRIVATE PROCEDURE extRenewAcsObj(Silent: SCAL[2]);
  VAR
   asl      : OBJECT;
   wasRemove: SCAL[2];
 BEGIN
  IF ~Silent THEN
   L_General.SilentPrgsOnly();
   L_StdFrm.Choice("ࢮ砫쭮  ࠢ筨 '짮⥫'.|" +
                   " 騥 짮⥫  㯯 짮⥫  㤠.");
  END;

  IF L_MSWStp.NeedElevation() THEN
   TRY
    asl := L_MSWStp.GetElevatedASL("U_AP", L_MSWStp.aslDBModification_On);
    asl.IndicatorDelay:=0;
    PROMPT("ࢮ砫쭮  ࠢ筨 '짮⥫'");
    asl.Proc("extRenewAcsObj", 1);
   EXCEPT
   ON e: Exc_Object DO
    L_MSWStp.AsbApplicationErrorHandler(e);
   END;
  ELSE
   TRY [INTEGRITY(INTEGRITY_ON)]
    PROMPT("⪠ ⠢ 㯯 짮⥫");
    GRANTALLRIGHTS();

    SETSEL(AOMem, AOMem);
    REMSEL(AOMem);
   
    SELECT(AcsObj, Name);
    WHILE OCCURE(AcsObj) DO
     wasRemove:=0;
     PROMPT(" " + AcsObj.Name);
     TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
      SEARCH(AcsObj2, AcsObj2, , AcsObj.AcsObj);
      REMOVE(AcsObj);
      REMOVE(AcsObj2);
      wasRemove:=1;
     EXCEPT
     ON Exc: Exc_RunTime DO
      IF Exc.ErrorCode # 223 THEN
       RAISE();
      END;
     END; (* TRY *)
   
     IF ~wasRemove & OCCURE(AcsObj) THEN
      NEXT(AcsObj)
     END;
    END; (* WHILE OCCURE(AcsObj) ... *)
 
    extAdaptationAcsObj(1);
   EXCEPT
   END; (* TRY *)
  END;
 END {extRenewAcsObj};

 PUBLIC PROCEDURE RenewAcsObj();
 BEGIN
  extRenewAcsObj(0);
 END {RenewAcsObj};

 PUBLIC PROCEDURE CloseMonthUntilPmnt();
  VAR
   P: DATE;
 BEGIN
  L_StdFrm.Choice(" ⮢: ⨥ 楢  " + L_DatTim.PeriodStr(Memo.ud_mb()));
  L_General.PrgsOnly();
  P:=L_DatTim.IncMonth(Memo.ud_mb(), -1);
  SELECT(Month, Period);
  WHILE OCCURE(Month) & (Month.Period < P) DO
   IF ~Month.NoTouch[L_APtm.system_Payments] THEN
    CALL(Month.CloseMonth(L_APtm.system_Payments))
   END;
   NEXT(Month);
  END; (* WHILE OCCURE(Month) ... *)
  Memo.gl_SetCurDate(P);
  CALL(A_Pmnt.InternalClose());
 END {CloseMonthUntilPmnt};

 PUBLIC PROCEDURE CloseToStart();
  VAR
   _Period: DATE;
 BEGIN
  L_General.SilentPrgsOnly();
  _Period:=L_Env.aptm_Start;
  L_General.SilentAdminOnly();
  L_StdFrm.Choice("   "+L_DatTim.DateStr(_Period)+"|㤥 믮  ⪠   ꥪ⮢");
  L_General.Assert(~L_APtm.MonthIsClosed(L_DatTim.IncMonth(_Period, -1), L_APtm.system_Salary), L_DatTim.DateStr(_Period)+" 㦥 ");
 
  SELECT(Month, Period);
  WHILE OCCURE(Month) DO
   IF Month.Period < _Period THEN
    Month.NoTouch[L_APtm.system_Salary]  :=1;
    Month.NoTouch[L_APtm.system_Math]    :=1;
    Month.NoTouch[L_APtm.system_PDoc]    :=1;
    Month.NoTouch[L_APtm.system_KeyAss]  :=1;
    Month.NoTouch[L_APtm.system_Payments]:=1;
    REPLACE(Month);
   END;
   NEXT(Month);
  END; (* WHILE OCCURE(Month) ... *)
 
  TRY [INTEGRITY(INTEGRITY_ON)]
  
   SELECT(Staff, TSN);
   WHILE OCCURE(Staff) DO
    PROMPT(Staff.TSN + " : ⪠ PCalc, Money");
    SELECT(PCalc, TSN, , Staff.TSN);
    WHILE OCCURE(PCalc) DO
     IF PCalc.Period < _Period THEN
      PCalc.Saldo   :=0;
      PCalc.Incr    :=0;
      PCalc.Decr    :=0;
      PCalc.FutInc  :=0;
      PCalc.PurToTax:=0;
      PCalc.Done[3]:=1; (**)
      PCalc.Done[0]:=1; (**)
      PCalc.Done[1]:=1; (**)
     ELSE
      PCalc.Saldo:=0;
      SETZERO(PCalc.Done);
     END;
     REPLACE(PCalc);
     NEXT(PCalc);
    END;
  
    SELECT(Money, TSN, , Staff.TSN);
    WHILE OCCURE(Money) DO
     IF (Money.Closed   < _Period) |
        (Money.WFPeriod < _Period) THEN
      L_PRoll.Remove_Money(1);
     ELSE
      NEXT(Money);
     END;
    END; (* WHILE OCCURE(Money)... *)
    NEXT(Staff);
   END; (* WHILE OcStaff... *)
  
   SELECT(Man, Man);
   WHILE OCCURE(Man) DO
    PROMPT(" ⮬.  ࠢ:  " + Man.Man);
    SELECT(TaxInq, Man, , Man.Man, L_Tax.inqt_Auto);
    WHILE OCCURE(TaxInq) & (TaxInq.Date < _Period) DO
     REMOVE(TaxInq);
    END; (* WHILE OCCURE(TaxInq) ... *)
    NEXT(Man);
   END; (* WHILE OCCURE(Man) ... *)
  
   IF L_General.GetAPSiteID() # "NF" THEN
    SELECT(RWayS, Date);
    WHILE OCCURE(RWayS) & (RWayS.Date < _Period) DO
     PROMPT("   " + L_DatTim.DateStr(RWayS.Date));
     SETSEL(Dtwo, RWayS, RWayS.RWayS);
     REMSEL(Dtwo);
  
     SELECT(CWOrder, RWayS, , RWayS.RWayS);
     WHILE OCCURE(CWOrder) DO
      SETSEL(XDocJrn, XDocJrn, L_XDoc.xdt_CWOrder, L_XDoc.EmptyXDocKind, CWOrder.CWOrder);
      REMSEL(XDocJrn);
  
      REMOVE(CWOrder);
     END; (* WHILE OCCURE(CWOrder) ... *)
     SETSEL(rtExit, RWayS, RWayS.RWayS);
     REMSEL(rtExit);
  
     SETSEL(XDocJrn, XDocJrn, L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
     REMSEL(XDocJrn);
     REMOVE(RWayS);
    END; (* WHILE OCCURE(RWayS) ... *)
   END;
   
   SETSEL(XCalc, XObject);
   REMSEL(XCalc);

   SELECT(Monthly, TSN);
   WHILE OCCURE(Monthly) DO
    IF Monthly.Period < _Period THEN
     REMOVE(Monthly);
    ELSE
     NEXT(Monthly);
    END;
   END; (* WHILE OCCURE(Monthly) ... *)
  
   IF L_General.GetAPSiteID() # "NF" THEN
    SELECT(Car, BoxNbr);
    WHILE OCCURE(Car) DO
     PROMPT(" ஡: . "+Car.BoxNbr);
     SELECT(CarRun, BoxNbr, , Car.BoxNbr);
     WHILE OCCURE(CarRun) & (CarRun.Date < _Period) DO
      REMOVE(CarRun);
     END; (* WHILE OCCURE(CarRun) ... *)
     IF OCCURE(CarRun) THEN
      CarRun.TotRun:=0;
      REPLACE(CarRun);
      L_Car.BalCarRun();
     END;
     NEXT(Car);
    END; (* WHILE OCCURE(Car) ... *)
   END;
  
  EXCEPT
  END; (* TRY *)
 END {CloseToStart};

 PRIVATE PROCEDURE AccessRegHead(P: DATE);
 BEGIN
  L_General.Assert(SEARCH(RegHead, HumReg, StaffLog.Regime, P),
                   "  ० ࠡ " + StaffLog.Regime + "  " + L_DatTim.PeriodStr(P));
 END {AccessRegHead};

 PRIVATE PROCEDURE CalculateByNetNo();
  VAR
   WrkDays,
   HldDays : NUMERIC[0];
   Date    : DATE;
 BEGIN
  CONFORM(AvePay, Staff);
  L_Staff.PosToStaffLog(Staff.TSN, AvePayP.StartD, 1);
  AccessRegHead(L_DatTim.Per(AvePayP.StartD));
  IF ~!AveTypeP.JMode | AveType.Pass THEN
   SETZERO(WrkDays, HldDays);
   Date:=AvePayP.StartD;
   SETSEL(RegList, HumReg, StaffLog.Regime);
   SRCINSEL(RegList, EQ, , L_DatTim.Per(Date), L_DatTim.DAY(Date));
   WHILE (~!AvePayP.StopD  & (Date <= AvePayP.StopD))      |
         (~!AvePayP.Amount & (WrkDays < AvePayP.Amount)) DO
    L_General.Assert(OCCURE(RegList), " ० ࠡ  ଠ樨  ⠪ ப");
    IF L_AvePay.RegListIsInNet() THEN
     INC(WrkDays);
    ELSE
     INC(HldDays);
    END;
    INC(Date);
    NEXT(RegList);
   END; (* WHILE ... *)
   IF !AvePayP.Amount THEN
    AvePayP.Amount:=WrkDays;
   ELSIF !AvePayP.StopD THEN
    AvePayP.StopD :=Date-1;
   END;
  END;
 END {CalculateByNetNo};

 PRIVATE PROCEDURE SetAvePayDates();
 BEGIN
  CONFORM(AvePay, AvePayP);
  AvePay.StartD:=AvePayP.StartD;
  SETZERO(AvePay.Amount);
  WHILE OCCURE(AvePayP) DO
   INC(AvePay.Amount, AvePayP.Amount);
   AvePay.StopD:=AvePayP.StopD;
   NEXT(AvePayP);
  END;
 END {SetAvePayDates};

 PRIVATE PROCEDURE AvePayP_Close();
 BEGIN
  CONFORM(AvePayP, AveTypeP);
  CONFORM(AveTypeP, AveType);
  SETEMPTY(AvePayP.Amount);
  CalculateByNetNo();
  REPLACE(AvePayP);
 END {AvePayP_Close};

 PUBLIC PROCEDURE CutAvePay();
 BEGIN
  AvePay.Period:=L_Env.aptm_Start;
  REPLACE(AvePay);
  SELECT(AvePayP, AvePay, , AvePay.AvePay);
  WHILE OCCURE(AvePayP) DO
   IF AvePayP.StopD < L_Env.aptm_Start THEN
    REMOVE(AvePayP);
   ELSIF AvePayP.StartD < L_Env.aptm_Start THEN
    AvePayP.StartD:=L_Env.aptm_Start;
    REPLACE(AvePayP);
    AvePayP_Close();
    NEXT(AvePayP);
   ELSE
    NEXT(AvePayP);
   END;
  END; (* WHILE OCCURE(AvePayP) ... *)
  SetAvePayDates();
 END {CutAvePay};

 PRIVATE PROCEDURE EmptyJMode(): SCAL[2];
  VAR
   IsEmpty: SCAL[2];
 BEGIN
  IsEmpty:=1;
  SELECT(AvePayP, AvePay, , AvePay.AvePay);
  WHILE OCCURE(AvePayP) & IsEmpty DO
   CONFORM(AvePayP, AveTypeP);
   IsEmpty:=IsEmpty & !AveTypeP.JMode;
   NEXT(AvePayP);
  END; (* WHILE OCCURE(AvePayP) ... *)
  RETURN IsEmpty;
 END {EmptyJMode};

 PRIVATE PROCEDURE ClearAvePay();
 BEGIN
  APP.Get().NewPrompt("४஢ 㬥⮢");
  SELECT(AvePay, AvePay);
  WHILE OCCURE(AvePay) DO
   PROMPT("⭨ "+AvePay.TSN+", 㬥 " + AvePay.AvePay);
   IF  AvePay.Period < L_Env.aptm_Start THEN
    IF ~L_AvePay.IsRealAvePay() | (AvePay.StopD < L_Env.aptm_Start) | EmptyJMode() THEN
     TRY [INTEGRITY(INTEGRITY_ON)]
      REMOVE(AvePay);
     EXCEPT
     END; (* TRY *)
    ELSE
     IF AvePay.StartD < L_Env.aptm_Start THEN
      CutAvePay();
     END;
     REPLACE(AvePay);
     CONFORM(AvePay, Staff);
     L_PRoll.AveDone_AP(AvePay.Period, 0);
     NEXT(AvePay);
    END;
   ELSE
    NEXT(AvePay);
   END;
  END; (* WHILE OCCURE(AvePay) ... *)
 END {ClearAvePay};

 PRIVATE PROCEDURE ClearSheet();
  VAR
   Cnt,
   S1,
   S2  : NUMERIC[0];
   T   : TIME;
 BEGIN
  APP.Get().NewPrompt("⪠ ⠡  '᪠' ⮏ઠ");
  FLOCK(Sheet, Share);

  SETZERO(Cnt);
 
  SELECT(Sheet, TSN);
  WHILE OCCURE(Sheet) DO
   INC(Cnt);
   PROMPT("⭨ " + Sheet.TSN);
   IF Sheet.Period < L_Env.aptm_Start THEN
    IF Cnt MOD 1000 = 0 THEN
     T:=SYSTIME(S1);
     T:=SYSTIME(S2);
     WHILE Math.Abs(S2-S1) < 3 DO
      T:=SYSTIME(S2);
     END;
    END;
    REMOVE(Sheet);
   ELSE
    NEXT(Sheet);
   END;
  END; (* WHILE OCCURE(Sheet) ... *)
 END {ClearSheet};

 PUBLIC PROCEDURE ClearAvePayToStart();
 BEGIN
  L_General.SilentPrgsOnly();
  L_StdFrm.Choice(" 㬥  ⠡  "+L_DatTim.DateStr(L_Env.aptm_Start));
  L_General.Assert(L_General.GetAPSiteID() # "NF", " ঠ. AvePay  ᪠ 㤠 ");
  ClearAvePay();
  ClearSheet();
 END {ClearAvePayToStart};

 PRIVATE PROCEDURE InsStExit(_Exit: LIKE(StExit.Exit);
                             _Route: LIKE(SEJobs.Route);
                             _Name: LIKE(StExit.Name);
                             _WJCode: LIKE(SEJobs.WJCode));
 BEGIN
  L_General.Assert(~SEARCH(StExit, Exit, _Exit), "  室 "+_Exit);
  StExit.Exit:=_Exit;
  StExit.Name:=_Name;
  StExit.ExitClss:=900000;
  StExit.Gap    :=0;
  StExit.Change :=0;
  StExit.DspConn:=0;
  StExit.TotT  :=8.000;
  StExit.LineT :=8.000;
  StExit.NightT:=0.000;
  StExit.Run    :=0.00;
  StExit.PaidRun:=0.00;
  StExit.PaidT:=0.000;
  StExit.FromD:=L_Env.aptm_Start;
  SETEMPTY(StExit.UpDate);
  StExit.BegTime:=08:00;
  StExit.TripAm:=0;
  StExit.OnDays[0]:=1;
  StExit.OnDays[1]:=1;
  StExit.OnDays[2]:=1;
  StExit.OnDays[3]:=1;
  StExit.OnDays[4]:=1;
  StExit.OnDays[5]:=1;
  StExit.OnDays[6]:=1;
  StExit.OnDays[7]:=1;
  StExit.OutBox:=0;
  StExit.StopTim:=16:00;
  StExit.Strict:=1;
  StExit.Suppl:=0;
  StExit.Type:=01;
  StExit.GuNeed:=0;
  SETEMPTY(StExit.GuBTime);
  SETEMPTY(StExit.GuETime);
  StExit.MinPV:=0;
  SETEMPTY(StExit.MaxPV);
  StExit.ActivKnd:=L_Way.seak_OnDays;
  StExit.ClndAppl:=L_Way.seca_Calendar;
  INSERT(StExit);

  SEJobs.Route:=_Route;
  SEJobs.Trip:=_Exit * 100 + 1;
  SEJobs.Exit:=_Exit;
  SEJobs.WJCode:=_WJCode;
  SEJobs.Day:=01;
  SEJobs.StartT:=08:00;
  SEJobs.StopT:=16:00;
  SEJobs.Modif:=001;
  SEJobs.RtMVer:=00;
  SEJobs.Dir:=0;
  SEJobs.BoxTick:=0;
  SEJobs.DCor:=1.0000;
  SEJobs.FromD:=L_Env.aptm_Start;
  SETEMPTY(SEJobs.UpDate);
  SEJobs.TooOld:=0;
  INSERT(SEJobs);
 END {InsStExit};

 PRIVATE PROCEDURE InsRoute(_Route: LIKE(Route.Route);
                            _Name: LIKE(Route.Name);
                            _MaxSpeed: LIKE(Route.MaxSpeed);
                            _Exit: LIKE(StExit.Exit);
                            _WJCode: LIKE(SEJobs.WJCode));
 BEGIN
  L_General.Assert(~SEARCH(Route, Route, _Route), "   "+_Route);
  Route.Route:=_Route;
  Route.Name :=_Name;
  SETEMPTY(Route.TKind, Route.JRegime, Route.VCor, Route.dSign, Route.Till);
  Route.IncSel:=0;
  Route.MaxSpeed:=_MaxSpeed;
  Route.Begin:=L_Env.aptm_Start;
  INSERT(Route);
 
  RoutMod.Route:=Route.Route;
  RoutMod.Modif:=001;
  RoutMod.Name:=Route.Name;
  RoutMod.Dir:=0;
  RoutMod.InPsp:=1;
  SETZERO(RoutMod.Run, RoutMod.Tim, RoutMod.TimSign);
  RoutMod.FCor:=1.000;
  RoutMod.FromD:=L_Env.aptm_Start;
  SETEMPTY(RoutMod.UpDate);
  INSERT(RoutMod);
  InsStExit(_Exit, _Route, _Name, _WJCode);
 END {InsRoute};

 PUBLIC PROCEDURE InsSpcRoute();
 BEGIN
  L_General.SilentPrgsOnly();
  L_StdFrm.Choice(" ⮢, 室| ࠡ  ॢ");
 
  L_General.Assert(~SEARCH(ExitClss, ExitClss, 900000), "   室 900000");
  ExitClss.ExitClss:=900000;
  ExitClss.Name:='裂 室';
  ExitClss.Sign:='';
  ExitClss.Begin:=L_Env.aptm_Start;
  SETEMPTY(ExitClss.Till);
  ExitClss.BegType:=07;
  ExitClss.Strict:=1;
  SETEMPTY(ExitClss.ERKN);
  INSERT(ExitClss);
 
  InsRoute('3000', '',                 80, 000003000, '10');
  InsRoute('3001', ' 㦨', 80, 000003001, '10');
  InsRoute('3002', '㧮 㦨', 80, 000003002, '10');
  InsRoute('3004', 'ॣ',               80, 000003004, '10');
  InsRoute('9000', '騩 ६',        0,  000009000, '30');
  InsRoute('9001', '',                0,  000009001, '51');
  InsRoute('9002', '⮩',               0,  000009002, '52');
  InsRoute('9003', '-1',                  0,  000009003, '32');
  InsRoute('9004', '-2',                  0,  000009004, '31');
 END {InsSpcRoute};

 PRIVATE PROCEDURE intSetPDocDone(_PDocKind: LIKE(PDoc.PDocKind); _Status: LIKE(PDoc.Status); P: DATE);
 BEGIN
  WHILE SELECT(PDoc, PDKStat, _PDocKind, _Status, 0) & (PDoc.Date < P) DO
   PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   PDoc.Done:=1;
   REPLACE(PDoc);
   NEXT(PDoc);
  END; (* WHILE OCCURE(PDoc) ... *)
 END {intSetPDocDone};

 PRIVATE PROCEDURE intSetPDocPassed(_PDocKind: LIKE(PDoc.PDocKind); P: DATE);
 BEGIN
  WHILE SELECT(PDoc, PDKStat, _PDocKind, L_PDoc.st_Prepared, 1 (*㦥  ࠡ⠭*)) & (PDoc.Date < P) DO
   PROMPT(L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
   PDoc.Status:=L_PDoc.st_Passed;
   REPLACE(PDoc);
  END; (* WHILE OCCURE(PDoc) ... *)
 END {intSetPDocPassed};

 PUBLIC PROCEDURE SetPDocPassedAndDone();
  VAR
   P: DATE;
 BEGIN
  L_StdFrm.Choice("    " + L_DatTim.PeriodStr(Memo.ud_mb())+"| | ⮢ - '஢'| ࠡ⠭ - 'ࠡ⠭'?");
  L_General.PrgsOnly();
  P:=Memo.ud_mb();

  SELECT(PDocKind, PDocKind);
  WHILE OCCURE(PDocKind) DO
   intSetPDocDone(PDocKind.PDocKind, L_PDoc.st_Prepared, P);
   intSetPDocDone(PDocKind.PDocKind, L_PDoc.st_Passed,   P);
   intSetPDocDone(PDocKind.PDocKind, L_PDoc.st_Canceled, P);
   intSetPDocPassed(PDocKind.PDocKind, P); (* 㦥  ⮢ ࠡ⠫*)
   NEXT(PDocKind);
  END; (* WHILE OCCURE(PDocKind) ... *)
 END {SetPDocPassedAndDone};

 PRIVATE PROCEDURE FillBySingleRWaySStatus(_Status: LIKE(RWayS.Status));
 BEGIN
  SELECT(RWayS, sRWayS, , _Status);
  WHILE OCCURE(RWayS) DO
   PROMPT(" " + RWayS.RWayS);
   L_RT.rtc_Insert(L_XDoc.xdt_RWayS, RWayS.BoxNbr);
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)
 END {FillBySingleRWaySStatus};

 PUBLIC PROCEDURE rtc_Renew();
 BEGIN
  SETSEL(rtCar, DDBoxNbr);
  REMSEL(rtCar);

  FillBySingleRWaySStatus(L_Way.rwsStat_Ordered);
  FillBySingleRWaySStatus(L_Way.rwsStat_Given);

  SELECT(RprS, cRprS, , 0);
  WHILE OCCURE(RprS) DO
   PROMPT(" " + RprS.RprS);
   IF L_Rpr.IsRprS_w_Car() THEN
    CONFORM(RprS, CUCopy);
    L_CUC.AccessOrigin();
    L_RT.rtc_Insert(L_XDoc.xdt_RprS, Car.BoxNbr);
   END;
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)

  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   PROMPT(" " + Car.BoxNbr);
   IF L_Env.RealBoxNbr(Car.BoxNbr)                    &
      L_Car.CarIsInOperation(Car.BoxNbr, SYSDATE()) THEN
    L_RT.rtc_Insert(EMPTYOF(L_XDoc.tXDocType), Car.BoxNbr);
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {rtc_Renew};

(* ࠢ筨    *)
 PRIVATE PROCEDURE GetDGroup(trgDGroup: LIKE(DGroup.DGroup); trgName: STRING[]): LIKE(DGroup.DGroup);
 BEGIN
  IF ~SEARCH(DGroup, DGroup, trgDGroup) THEN
   DGroup.DGroup:=trgDGroup;
   DGroup.Name  :=trgName;
   INSERT(DGroup);
  END; (* IF ~SEARCH(DGroup ... *)
  RETURN DGroup.DGroup;
 END {GetDGroup};

 PRIVATE PROCEDURE InsDGroup(trgDGroup: LIKE(DGroup.DGroup); trgName: LIKE(DGroup.Name));
  VAR
   dmyDGroup: LIKE(DGroup.DGroup);
 BEGIN
  dmyDGroup:=GetDGroup(trgDGroup, trgName);
 END {InsDGroup};

 PRIVATE PROCEDURE InsPDocKind(trgPDocKind: LIKE(PDocKind.PDocKind);
                               trgName    : LIKE(PDocKind.Name);
                               trgSName   : LIKE(PDocKind.SName);
                               trgDGroup  : LIKE(PDocKind.DGroup));
 BEGIN
  APP.Get().NewPrompt(L_PDoc.PDocKindNick(trgPDocKind, 1));
  IF (L_PDoc.IsRequiredPDocKind(trgPDocKind, SYSDATE()) # L_PDoc.pdkrq_Disabled) &
     ~SEARCH(PDocKind, PDocKind, trgPDocKind) THEN
   PDocKind.PDocKind:=trgPDocKind;
   PDocKind.Name    :=trgName;
   PDocKind.SName   :=trgSName;
   PDocKind.DGroup  :=GetDGroup(trgDGroup, trgName);
   PDocKind.Sign    :=L_PDoc.PDocKindNick(trgPDocKind, 1);
   INSERT(PDocKind);
  END;
 END {InsPDocKind};

 PRIVATE PROCEDURE intInsMDocKind(trgMDocKind: LIKE(MDocKind.MDocKind);
                                  trgName    : LIKE(MDocKind.Name);
                                  trgSName   : LIKE(MDocKind.SName);
                                  trgExtSName: LIKE(MDocKind.ExtSName);
                                  trgDGroup  : LIKE(MDocKind.DGroup);
                                  trgScope   : LIKE(MDocKind.Scope);
                                  trgDir     : LIKE(MDocKind.Dir);
                                  trgActivity: LIKE(MDocKind.Activity);
                                  trg_wCUCopy: LIKE(MDocKind.wCUCopy);
                                  trgDfStatus: LIKE(MDocKind.DfStatus);
                                  trgImdPrint: LIKE(MDocKind.ImdPrint);
                                  trgPrpPrint: LIKE(MDocKind.PrpPrint);
                                  trg_imOC   : LIKE(MDocKind.imOC);
                                  trg_imDO   : LIKE(MDocKind.imDO);
                                  trg_imTD   : LIKE(MDocKind.imTD));
 BEGIN
  APP.Get().NewPrompt(L_MDoc.MDocKindNick(trgMDocKind, 1));
  IF (L_MDoc.IsRequiredMDocKind(trgMDocKind, SYSDATE()) # L_MDoc.mdkrq_Disabled) &
     ~SEARCH(MDocKind, MDocKind, trgMDocKind) THEN
   MDocKind.MDocKind:=trgMDocKind;
   MDocKind.Name    :=trgName;
   MDocKind.SName   :=trgSName;
   MDocKind.ExtSName:=trgExtSName;
   MDocKind.DGroup  :=GetDGroup(trgDGroup, trgName);
   MDocKind.Scope   :=trgScope;
   MDocKind.Dir     :=trgDir;
   MDocKind.Sign    :=L_MDoc.MDocKindNick(trgMDocKind, 1);
   MDocKind.Activity:=trgActivity;
   MDocKind.wCUCopy :=trg_wCUCopy;
   MDocKind.DfStatus:=trgDfStatus;
   MDocKind.ImdPrint:=trgImdPrint;
   MDocKind.PrpPrint:=trgPrpPrint;
   MDocKind.imOC    :=trg_imOC;
   MDocKind.imDO    :=trg_imDO;
   MDocKind.imTD    :=trg_imTD;
   INSERT(MDocKind);
  END;
 END {intInsMDocKind};

 PRIVATE PROCEDURE InsMDocKind(trgMDocKind: LIKE(MDocKind.MDocKind);
                               trgName    : LIKE(MDocKind.Name);
                               trgSName   : LIKE(MDocKind.SName);
                               trgExtSName: LIKE(MDocKind.ExtSName);
                               trgDGroup  : LIKE(MDocKind.DGroup);
                               trgScope   : LIKE(MDocKind.Scope);
                               trgDir     : LIKE(MDocKind.Dir);
                               trgActivity: LIKE(MDocKind.Activity);
                               trg_wCUCopy: LIKE(MDocKind.wCUCopy);
                               trgDfStatus: LIKE(MDocKind.DfStatus);
                               trgImdPrint: LIKE(MDocKind.ImdPrint);
                               trgPrpPrint: LIKE(MDocKind.PrpPrint));
  VAR
   trg_imOC: LIKE(MDocKind.imOC);
   trg_imDO: LIKE(MDocKind.imDO);
   trg_imTD: LIKE(MDocKind.imTD);
 BEGIN
  trg_imOC:=L_MDoc.im_No;
  trg_imDO:=L_MDoc.im_No;
  trg_imTD:=L_MDoc.im_No;
  IF L_MDoc.IsRequiredMDocKind(trgMDocKind, SYSDATE()) = L_MDoc.mdkrq_Required THEN
   IF L_MDoc.KeyAssetsMDoc(trgMDocKind) THEN
    trg_imOC:=L_MDoc.im_Basic;
   ELSIF (trgScope = L_MDoc.mds_Internal) & ~L_MDoc.IsMDoc_woMath(trgMDocKind) THEN
    trg_imDO:=L_MDoc.im_Basic;
   ELSE
    trg_imTD:=L_MDoc.im_Basic;
   END;
  END;
  intInsMDocKind(trgMDocKind, trgName, trgSName, trgExtSName, trgDGroup, trgScope, trgDir,
                 trgActivity, trg_wCUCopy, trgDfStatus, trgImdPrint, trgPrpPrint,
                 trg_imOC, trg_imDO, trg_imTD);
 END {InsMDocKind};

 PRIVATE PROCEDURE CheckFullPDocKind();
  VAR
   dmySign    : STRING[];
   curPDocKind: LIKE(PDoc.PDocKind);
 BEGIN
  APP.Get().NewPrompt("஢ઠ  ࠢ筨  ");
  FOR_EACH curPDocKind DO
   PROMPT(curPDocKind);
   IF ~SEARCH(PDocKind, PDocKind, curPDocKind) THEN
    TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     dmySign:=L_PDoc.PDocKindNick(curPDocKind, 1);
    EXCEPT
    ON Exc: Exc_Raise DO
     dmySign:="";
    END; (* TRY *)
    IF ~!dmySign THEN
     L_General.CallUs(L_PDoc.IsRequiredPDocKind(curPDocKind, SYSDATE()) = L_PDoc.pdkrq_Disabled);
    END;
   END; (* IF ~SEARCH(PDocKind ... *)
  END; (* FOR_EACH ... *)
 END {CheckFullPDocKind};

 PRIVATE PROCEDURE CheckFullMDocKind();
  VAR
   dmySign    : STRING[];
   curMDocKind: LIKE(MDoc.MDocKind);
 BEGIN
  APP.Get().NewPrompt("஢ઠ  ࠢ筨  ");
  FOR_EACH curMDocKind DO
   PROMPT(curMDocKind);
   IF ~SEARCH(MDocKind, MDocKind, curMDocKind) THEN
    TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     dmySign:=L_MDoc.MDocKindNick(curMDocKind, 1);
    EXCEPT
    ON Exc: Exc_Raise DO
     dmySign:="";
    END; (* TRY *)
    IF ~!dmySign THEN
     L_General.CallUs(L_MDoc.IsRequiredMDocKind(curMDocKind, SYSDATE()) = L_MDoc.mdkrq_Disabled);
    END;
   END; (* IF ~SEARCH(MDocKind ... *)
  END; (* FOR_EACH ... *)
 END {CheckFullPDocKind};

 PUBLIC PROCEDURE FillPDocKindAndMDocKind();
 BEGIN
  APP.Get().NewPrompt(" ࠢ筨    ");
  InsDGroup(00, "⨢");
  InsDGroup(08, "ᠭ   室");
  InsDGroup(09, "⨧ ");
  InsDGroup(19, "⥫쭠 ⠪஢");
  InsDGroup(20, "業 ");
  InsDGroup(98, "஢ ⮢  ");

  InsPDocKind(L_PDoc.pd_RKO, "室 ᮢ थ",
                             "室 थ",                   01);
  InsPDocKind(L_PDoc.pd_PKO, "室 ᮢ थ",
                             "室 थ",                   02);
  InsPDocKind(L_PDoc.pd_IPP, "室騥 ⥦ 祭",
                             "室饥 ⥦ 祭",     03);
  InsPDocKind(L_PDoc.pd_VPP, "室騥 ⥦ 祭",
                             "室饥 ⥦ 祭",      04);
  InsPDocKind(L_PDoc.pd_IMO, "室騥 ਠ थ",
                             "室騩 ਠ थ",      03);
  InsPDocKind(L_PDoc.pd_VMO, "室騥 ਠ थ",
                             "室騩 ਠ थ",       04);
  InsPDocKind(L_PDoc.pd_ITP, "室騥 ॡ-祭",
                             "室饥 ॡ-祭",    03);
  InsPDocKind(L_PDoc.pd_VTP, "室騥 ॡ-祭",
                             "室饥 ॡ-祭",     04);
  InsPDocKind(L_PDoc.pd_OVN, "   묨",
                             "   묨",     28);
  InsPDocKind(L_PDoc.pd_CND, "  祭 ",
                             "  祭 ",            29);
  InsPDocKind(L_PDoc.pd_AVO, "ᮢ ",
                             "ᮢ ",                   30);
  InsPDocKind(L_PDoc.pd_VPK, "室騥 ⥦ ४஢",
                             "室 ⥦ ४஢",  31);
  InsPDocKind(L_PDoc.pd_IPK, "室騥 ⥦ ४஢",
                             "室 ⥦ ४஢", 32);
  InsPDocKind(L_PDoc.pd_VhP, "室騥 ⥦ 稥",
                             "室騩 ⥦",                   33);
  InsPDocKind(L_PDoc.pd_IsP, "室騥 ⥦ 稥",
                             "室騩 ⥦",                  34);
  InsPDocKind(L_PDoc.pd_AIN, " ਧ樨 ()",
                             " ਧ樨 ()",    35);
  InsPDocKind(L_PDoc.pd_ROO, "室 थ ",
                             "室 थ ",                22);
  InsPDocKind(L_PDoc.pd_POO, "室 थ ",
                             "室 थ ",                23);
  InsPDocKind(L_PDoc.pd_AII, " ਧ樨 (誨)",
                             " ਧ樨 (誨)",      36);
  CheckFullPDocKind();

  intInsMDocKind(L_MDoc.md_NPr, "  室",
                                "  室",
                                "  室",
                 05, L_MDoc.mds_Internal, L_MDoc.mdd_Ingoing,
                 1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_GetFromStock, 0,
                 L_MDoc.im_No, L_MDoc.im_Basic, L_MDoc.im_No);
  InsMDocKind(L_MDoc.md_TOV, "ॡ  -",
                             "ॡ  -",
                             "ॡ- ( )",
              06, L_MDoc.mds_Internal, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_GetFromStock, 1);
  InsMDocKind(L_MDoc.md_NOV, "  -",
                             "  -",
                             "  ",
              07, L_MDoc.mds_Internal, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_GetFromStock, 1);
  InsMDocKind(L_MDoc.md_APr, " ਥ ",
                             " ਥ ",
                             " ਥ ᭮ ।",
              10, L_MDoc.mds_Internal, L_MDoc.mdd_Undefined,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_GetFromStock, 1);
  InsMDocKind(L_MDoc.md_APP, " । ",
                             " । ",
                             " । ᭮ ।",
              11, L_MDoc.mds_Internal, L_MDoc.mdd_Undefined,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_GetFromStock, 1);
  InsMDocKind(L_MDoc.md_ADo, "୨ ",
                             "୨ ",
                             " ୨樨 ᭮ ।",
              12, L_MDoc.mds_Internal, L_MDoc.mdd_Undefined,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_GetFromStock, 1);
  InsMDocKind(L_MDoc.md_ASp, " ᯨᠭ ",
                             " ᯨᠭ ",
                             " ᯨᠭ ᭮ ।",
              13, L_MDoc.mds_Internal, L_MDoc.mdd_Undefined,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_GetFromStock, 1);
  InsMDocKind(L_MDoc.md_ASO, " ᬥ ⢥⢥  ",
                             " ᬥ ⢥⢥  ",
                             " ᬥ ⢥⢥  ᭮ ।⢠",
              14, L_MDoc.mds_Internal, L_MDoc.mdd_Undefined,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_GetFromStock, 1);
  InsMDocKind(L_MDoc.md_DDA, " ஢",
                             "㬥  ஢",
                             "㬥  ஢",
              16, L_MDoc.mds_Internal, L_MDoc.mdd_Undefined,
              0, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_AVb, "  ",
                             "  ",
                             "  -। ꥪ ᭮ ।",
              17, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_APc, "८業 ",
                             "८業 ",
                             " ८業 ᭮ ।",
              37, L_MDoc.mds_Internal, L_MDoc.mdd_Undefined,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_Spc, "䨪樨",
                             "䨪",
                             "䨪",
              39, L_MDoc.mds_Internal, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_IsS, " 室騥",
                             " 室騩",
                             "",
              40, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              0, 0, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 0);
  InsMDocKind(L_MDoc.md_ITN, "  室騥",
                             "ୠ  室",
                             "ୠ ",
              41, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_ISF, "-䠪 뤠",
                             "-䠪 뤠",
                             "-䠪",
              42, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              0, 0, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_IAS, " ᤠ-ਥ 室騥",
                             " ᤠ-ਥ 室騩",
                             " ᤠ-ਥ",
              43, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_VSF, "-䠪 ਭ",
                             "-䠪 ਭ",
                             "-䠪",
              44, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              0, 0, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_IAU, " ਥ-। ⠭ (孨᪨)",
                             " ਥ-। ⠭ (孨᪨)",
                             "",
              45, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              0, 0, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_Nrd, "",
                             "",
                             "",
              46, L_MDoc.mds_Internal, L_MDoc.mdd_Outgoing,
              0, 0, L_MDoc.st_Passed, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_DPr, "㬥  த",
                             "㬥  த",
                             "㬥  த",
              42, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              0, 0, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_DPk, "㬥  㯮",
                             "㬥  㯮",
                             "㬥  㯮",
              44, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              0, 0, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_VhS, " 室騥",
                             " 室騩",
                             "",
              50, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              0, 0, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_VhA, " 室騥",
                             " 室騩",
                             " ᤠ-ਥ",
              51, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              1, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_VTN, "  室騥",
                             "ୠ ",
                             "ୠ ",
              52, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              1, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_Dvr, "७",
                             "७",
                             "७",
              53, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              0, 0, L_MDoc.st_Passed, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_RPk, "㬥 ஧筮 㯪",
                             "㬥 ஧筮 㯪",
                             "㬥 ஧筮 㯪",
              54, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_RPr, "㬥 ஧筮 த",
                             "㬥 ஧筮 த",
                             "㬥 ஧筮 த",
              55, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_OBK, " ⭮ ",
                             " ⭮ ",
                             " ⭮ ",
              56, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_PPk, "㬥  㯮",
                             "㬥  㯮",
                             "㬥  㯮",
              57, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_RNR, "। ᪫㥬 室",
                             "। ᪫㥬 室",
                             "। ᪫㥬 室",
              58, L_MDoc.mds_Internal, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_GetFromStock, 1);
  InsMDocKind(L_MDoc.md_PPr, "㬥  த",
                             "㬥  த",
                             "㬥  த",
              59, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_PPR, "㬥  த ( )",
                             "㬥  த ( )",
                             "㬥  த ( )",
              59, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_MSP, "᪫᪨ ६饭",
                             "᪫᪮ ६饭",
                             "ॡ- (᪫᪮ ६饭)",
              60, L_MDoc.mds_Internal, L_MDoc.mdd_MSP,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_GetFromStock, 1);
  InsMDocKind(L_MDoc.md_ViP, "  ந⢠",
                             "  ந⢠",
                             "ॡ- ( )",
              61, L_MDoc.mds_Internal, L_MDoc.mdd_Ingoing,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_GetFromStock, 1);
  intInsMDocKind(L_MDoc.md_VPC, "譨 ६饭 ",
                                "譥 ६饭 ",
                                "譥 ६饭 ",
                 62, L_MDoc.mds_External, L_MDoc.mdd_MSP,
                 1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_GetFromStock, 1,
                 L_MDoc.im_No, L_MDoc.im_Basic, L_MDoc.im_No);
  InsMDocKind(L_MDoc.md_ISA, "室騥 -",
                             "室騩 -",
                             "- ᤠ-ਥ ",
              64, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 0);
  InsMDocKind(L_MDoc.md_ZNr, "-",
                             "-",
                             "-",
              65, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              1, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_RPU, "  ᮭ (㤥ঠ)",
                             "  ᮭ (㤥ঠ)",
                             "  ᮭ (㤥ঠ)",
              67, L_MDoc.mds_Internal, L_MDoc.mdd_Outgoing,
              0, 0, L_MDoc.st_Passed, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_RPN, "  ᮭ (᫥)",
                             "  ᮭ (᫥)",
                             "  ᮭ (᫥)",
              68, L_MDoc.mds_Internal, L_MDoc.mdd_Ingoing,
              0, 0, L_MDoc.st_Passed, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_RSZ, "।   ",
                             "।   ",
                             "।   ",
              69, L_MDoc.mds_Internal, L_MDoc.mdd_Undefined,
              0, 0, L_MDoc.st_Passed, L_MDoc.mdkip_No, 1);

  InsMDocKind(L_MDoc.md_TCh, " 祪",
                             " 祪",
                             " 祪",
              21, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_GetFromStock, 1);
  InsMDocKind(L_MDoc.md_PPK, "㬥  㯮 ( )",
                             "㬥  㯮 ( )",
                             "㬥  㯮 ( )",
              57, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              1, 1, L_MDoc.st_Passed, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_ZMC, "  ",
                             "  ",
                             "  ",
              72, L_MDoc.mds_Internal, L_MDoc.mdd_Undefined,
              0, 0, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_NDk, " 樨",
                             " ",
                             " ",
              80, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              1, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_IAP, " ਥ-। ࠢ 室騥",
                             " ਥ-। ࠢ 室騩",
                             " ਥ-। ࠢ",
              41, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 0);
  InsMDocKind(L_MDoc.md_VAP, " ਥ-। ࠢ 室騥",
                             " ਥ-। ࠢ 室騩",
                             " ਥ-। ࠢ",
              52, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              1, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 0);
  InsMDocKind(L_MDoc.md_VAU, " ਥ-। (孨᪨) 室騥",
                             " ਥ-। (孨᪨) 室騩",
                             "",
              89, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              0, 0, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 0);
  InsMDocKind(L_MDoc.md_PCh, "室 祪",
                             "室 祪",
                             "室 祪",
              91, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              1, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_RCh, "室 祪",
                             "室 祪",
                             "室 祪",
              92, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              1, 1, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 1);
  InsMDocKind(L_MDoc.md_PIO, "  襭 ਮ ⭮ ᯫ樨",
                             "  襭 ਮ ⭮ ᯫ樨",
                             "  襭 ਮ ⭮ ᯫ樨",
              93, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              0, 0, L_MDoc.st_Passed, L_MDoc.mdkip_No, 0);
  InsMDocKind(L_MDoc.md_VOD, "室騥   ",
                             "室   ",
                             "室   ",
              40, L_MDoc.mds_External, L_MDoc.mdd_Outgoing,
              0, 0, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 0);
  InsMDocKind(L_MDoc.md_IOD, "室騥   ",
                             "室   ",
                             "室   ",
              50, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              0, 0, L_MDoc.st_Prepared, L_MDoc.mdkip_No, 0);
  InsMDocKind(L_MDoc.md_NlO, " 易⥫⢠",
                             " 易⥫⢮",
                             " 易⥫⢮",
              50, L_MDoc.mds_External, L_MDoc.mdd_Ingoing,
              0, 0, L_MDoc.st_Passed, L_MDoc.mdkip_No, 0);
  CheckFullMDocKind();
 END {FillPDocKindAndMDocKind};

 PUBLIC PROCEDURE InteractiveFillPDocKindAndMDocKind();
 BEGIN
  L_StdFrm.Question(" ࠢ筨    ");
  L_General.SilentPrgsOnly();
  FillPDocKindAndMDocKind();
 END {InteractiveFillPDocKindAndMDocKind};

 PUBLIC PROCEDURE perco_UploadAll();
 BEGIN
  L_ACS.PutAllMan();
  L_General.SurveyLastReport();
 END {perco_UploadAll};

 PUBLIC PROCEDURE perco_ControllersIdList();
 BEGIN
  L_ACS.perco_GetControllersIdList();
 END {perco_ControllersIdList};

(*
$P{ SLDL2_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, ""
?, L, ""
@
################################################ ########## #####
=#####===========================================================
|                  ୠ 䨪権                |
|---------------------------------------------------------------|
|               |#################|#################|      %|
|-------------------|-----------------|-----------------|-------|
}
*)

(*
$P{ SLDL2_Line:
SLDAMNT.File, L, ""
SLDAMNT.prvAmnt, R, "0"
SLDAMNT.curAmnt, R, "0"
?, R, "2."
@
|###################|#################|#################|#######|
}
*)

(*
$P{ SLDL2_Bot:
@
=(c) Polak=======================================================
}
*)

 PRIVATE PROCEDURE IsInsert(): SCAL[2];
 BEGIN
  SETSEL(SYSLOGD, SYSLOG_, SYSLOG_.SYSLOG_);
  LAST(SYSLOGD);
  L_General.CallUs(SYSLOGD.Kind < L_SysLog.knd_Field);
  RETURN (SYSLOGD.Kind = L_SysLog.knd_Insert) | (SYSLOGD.Kind = L_SysLog.knd_AutoBuild);
 END {IsInsert};

 PRIVATE PROCEDURE CalcAmount(PerIdx: SCAL[2]; VAR PerAsStr: STRING[]);
  VAR
   trgFile    : STRING[];
   curIsInsert: SCAL[2];
   BegDate,
   EndDate: DATE;
   TotalAmount: NUMERIC[0][2];
 BEGIN
  IF PerIdx = 0 THEN
   EndDate:=L_DatTim.IncMonth(Memo.ud_mb(), -1)-1;
  ELSE
   EndDate:=Memo.ud_mb()-1;
  END;
  BegDate:=L_DatTim.IncMonth(EndDate, -1);
  PerAsStr:=FLDTOSTR(BegDate, "D.N.Y") + "-" + FLDTOSTR(EndDate, "D.N.Y");

  SELECT(SYSLOG_, SYSLOG_1);
  WHILE OCCURE(SYSLOG_) DO
   SETZERO(TotalAmount);
   NARROWSEL(SYSLOG_, Object);
   IF SEARCH(dbFile, dbFile, SYSLOG_.fiOwn) THEN
    trgFile:=dbFile.Name;
   ELSE
    trgFile:=SYSLOG_.Object;
   END;
   SRCINSEL(SYSLOG_, GE, , BegDate);
   WHILE OCCURE(SYSLOG_) & (SYSLOG_.Date <= EndDate) DO
    PROMPT(": " + trgFile + " " + L_DatTim.DateStr(SYSLOG_.Date));
    IF SYSLOG_.tmpRcCnt = 0 THEN
     curIsInsert:=IsInsert();
     SELECT(SYSLOGD, SYSLOG_, , SYSLOG_.SYSLOG_);
     WHILE OCCURE(SYSLOGD) DO
      IF ~curIsInsert | (SYSLOGD.Kind # L_SysLog.knd_Field) THEN
       INC(TotalAmount[PerIdx]);
      END;
      NEXT(SYSLOGD);
     END; (* WHILE OCCURE(SYSLOGD) ... *)
    END;
    NEXT(SYSLOG_);
   END; (* WHILE OCCURE(SYSLOG_) ... *)

   ADD(SLDAMNT, File, , trgFile,
       SLDAMNT.prvAmnt, TotalAmount[0],
       SLDAMNT.curAmnt, TotalAmount[1]);
   NEXTINEXTENDEDSEL(SYSLOG_, Object);
  END; (* WHILE OCCURE(SYSLOG_) ... *)
 END {CalcAmount};

 PUBLIC PROCEDURE CheckSYSLOGDAmount();
  CONST
   RepName   = "SLDL2";
   MinAmount = 50;
  VAR
   Prc         : NUMERIC[2];
   BegDate,
   EndDate     : DATE;
   prvPer_AsStr,
   curPer_AsStr: STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_AFM.MakeMultipleIndex("SLDAMNT", "File   : STRING[30];" +
                                     "prvAmnt: NUMERIC[0];" +
                                     "curAmnt: NUMERIC[0]",
                          "File:File;" +
                          "curAmnt:curAmnt,File");

  CalcAmount(0, prvPer_AsStr);
  CalcAmount(1, curPer_AsStr);

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, SLDL2_Top, RepName, prvPer_AsStr, curPer_AsStr);
  SETSEL(SLDAMNT, curAmnt);
  LAST(SLDAMNT);
  WHILE OCCURE(SLDAMNT) DO
   PROMPT(SLDAMNT.File);
   IF SLDAMNT.prvAmnt = 0 THEN
    SETEMPTY(Prc);
   ELSE
    Prc:=((SLDAMNT.curAmnt * 100) / SLDAMNT.prvAmnt) - 100;
   END;
   MAKEPART(R, SLDL2_Line, Prc);
   PREV(SLDAMNT);
  END; (* WHILE OCCURE(SLDAMNT) ... *)
  MAKEPART(R, SLDL2_Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {CheckSYSLOGDAmount};

BEGIN (* ஢ ࢥ ⮬⨧樨 ASB*)
END.
