(*
%Copyright   (c) Polak IT
%Author      25.02.2009 11:11:19 San
%Purpose      (): ࢨ ⨫
%Type        tool
%Specific    SYS
%Modified    26.10.2012 20:29:48 POLAK\Bor
%Environment
*)

 MODULE U_Stock [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_OwnData, L_CUC, L_XDoc, L_MathR, L_MDoc, L_StdFrm, L_AP,
        Math, E_Stock, L_Env, L_Way, L_Acnt, L_Acnt, L_XObj;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
@
############################################################# ########## #####
=#####==========================================================================
|                  ⠢訥  ᮯ⠢ ꥪ                  |
|------------------------------------------------------------------------------|
|.|᭮  |ઠ                                 |         |        |!|
}
*)

(*
$P{ Line:
CarLog.BoxNbr, L, ""
CarLog.StateNbr, L, ""
CarLog.Mark, L, ""
Mark.Name, L, ""
CarLog.Date, L, "D.N.y"
CarLog.DateE, L, "D.N.y"
L_Env.KeyAssAcntLev(CarLog.DateE) = L_MathR.kaal_WithActProcess, L, " |!"
@
|----|----------|--------------------------------------|----------|----------|-|
|####|##########|#### #################################|##########|##########|#|
}
*)

(*
$P{ Line1:
CarLog.Date, L, "D.N.y"
CarLog.DateE, L, "D.N.y"
L_Env.KeyAssAcntLev(CarLog.DateE) = L_MathR.kaal_WithActProcess, L, " |!"
@
|    |          |                                      |##########|##########|#|
}
*)

(*
$P{ Bot:
@
=(c) Polak======================================================================
}
*)

 PUBLIC PROCEDURE CrWoM();
  CONST
   RepName = "CrWoM";
  VAR
   FirstLine: SCAL[2];
 BEGIN
  APP.Get().NewPrompt(RepName);
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
 
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   IF L_Env.KeyAssAcntLev(Car.EndDate) = L_MathR.kaal_WithActProcess THEN
    FirstLine:=1;
    SELECT(CarLog, BoxNbr, , Car.BoxNbr);
    WHILE OCCURE(CarLog) DO
     PROMPT(CarLog.BoxNbr);
     IF L_Env.RealBoxNbr(CarLog.BoxNbr) THEN
      IF !CarLog.Math THEN
       IF FirstLine THEN
        CONFORM(CarLog, Mark);
        MAKEPART(R, Line);
        FirstLine:=0;
       ELSE
        MAKEPART(R, Line1);
       END;
      END;
     END;
     NEXT(CarLog);
    END; (* WHILE OCCURE(CarLog) ... *)
   END;
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {CrWoM};

 PRIVATE PROCEDURE IsMDocWithKeyAss(): SCAL[2];
  VAR
   HasKeyAs,
   HasMath: SCAL[2];
 BEGIN
  IF L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) THEN
   RETURN 1;
  END;
  HasMath:=0;
  HasKeyAs:=0;
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   CONFORM(MDocList, Math);
   IF    Math.MathKind = L_MathR.mathk_Math THEN
    HasMath:=1;
   ELSIF Math.MathKind = L_MathR.mathk_KeyAs THEN
    HasKeyAs:=1;
   ELSE
    L_General.CallUs(0);
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  IF HasMath & HasKeyAs THEN
   L_General.Error(" ᬥ蠭     |"+L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
  END;
  RETURN HasKeyAs;
 END {IsMDocWithKeyAss};

 PRIVATE PROCEDURE HasEntranceXDocApr(_XDocId: L_XDoc.tXDocId;
                                      _XDocDate: DATE;
                                      _Source: L_XObj.tSource): SCAL[2];
 BEGIN
  IF L_Acnt.E_DoXDocApr(_XDocDate, _Source, _XDocId) THEN
   SELECT(XDocApr, XDocApr, , _XDocId);
   WHILE OCCURE(XDocApr) DO
    IF    (~!XDocApr.XObject  & L_Acnt.IsEntranceApport(XDocApr.Apport)) |
          (~!XDocApr.XObject2 & L_Acnt.IsEntranceApport(XDocApr.Apport2)) THEN
     RETURN 1;
    END;
    NEXT(XDocApr);
   END; (* WHILE OCCURE(XDocApr) ... *)
   RETURN 0;
  ELSE
   RETURN 1;
  END
 END {HasEntranceXDocApr};

 PRIVATE PROCEDURE IsEntranceMDoc(P: DATE): SCAL[2];
 BEGIN
  RETURN (MDoc.MDocKind = L_MDoc.md_ViP) & (MDoc.Date = (P-1)) &
         HasEntranceXDocApr(MDoc.XDocId, MDoc.Date, L_XObj.src_MDoc);
 END {IsEntranceMDoc};

 PUBLIC PROCEDURE RemoveOldMDoc();
  VAR
   math_Start: DATE;
 BEGIN
  L_General.SilentPrgsOnly();
  math_Start:=Memo.ud_mb();
  L_StdFrm.Choice("   ᪫  "+L_DatTim.PeriodStr(math_Start)+"?");
  TRY [INTEGRITY(INTEGRITY_ON)]
   SELECT(MDoc, Date);
   WHILE OCCURE(MDoc) & (MDoc.Date < math_Start) DO
    PROMPT(L_DatTim.DateStr(MDoc.Date));
    IF !MDoc.Contract & ~IsMDocWithKeyAss() & ~IsEntranceMDoc(math_Start) THEN
     L_General.CallUs(~MDoc.Done);
     IF SELECT(XDocApr, XDocApr, MDoc.XDocId) THEN
      REMSEL(XDocApr);
     END;
     L_XDoc.XDoc_OnBeforeDelete(MDoc.XDocId);
     REMOVE(MDoc);
    ELSE
     NEXT(MDoc);
    END;
   END; (* WHILE OCCURE(MDoc) ... *)
  EXCEPT
  END; (* TRY *)
 END {RemoveOldMDoc};

 PUBLIC PROCEDURE TestMathCUCopyMovement();
 BEGIN
  L_General.SilentPrgsOnly();
  L_CUC.TestMathCUCopyMovement();
 END {TestMathCUCopyMovement};

 PRIVATE PROCEDURE fmm_Flush(_Per: DATE; Runs: LIKE(MathMty.Proof)[]);
  VAR
   i      : NUMERIC[0];
   _MtyIdx: LIKE(MtyIdx.MtyIdx);
 BEGIN
  i:=0;
  WHILE i < E_Stock.MtyRunSize DO
   IF Runs[i] # 0 THEN
    _MtyIdx:=i+E_Stock.MtyRunBeg;
    L_General.CallUs(SEARCH(MtyIdx, MtyIdx, _MtyIdx));
    ADD(MathMty, Math, , Math.Math, _Per, L_AP.mthlSrc_RWayS, _MtyIdx,
                         MathMty.Proof, Runs[i]);
   END;
   INC(i);
  END;
 END {fmm_Flush};

 PRIVATE PROCEDURE fmm_MakeOneCarLog(_From, _UpTo: DATE);
  VAR
   P,
   B,
   E: DATE;
   Runs: LIKE(MathMty.Proof)[E_Stock.MtyRunSize+1];
   _MtyIdx: LIKE(MtyIdx.MtyIdx);
 BEGIN
  P:=_From;
  WHILE P <= _UpTo DO
   B:=Math.Max(P, CarLog.Date);
   E:=Math.Min(L_DatTim.MonthEnd(P), CarLog.DateE);
   SETZERO(Runs);
   SETSEL(RWayS, BoxNbr, Car.BoxNbr);
   SRCINSEL(RWayS, GE, , B);
   WHILE OCCURE(RWayS) & (RWayS.Date<=E) DO
    IF RWayS.Done THEN
     PROMPT(": "+RWayS.BoxNbr+" : "+L_DatTim.DateStr(RWayS.Date)+" : "+RWayS.RWayS);
     CONFORM(RWayS, RWayJ);
     WHILE OCCURE(RWayJ) DO
      IF RWayJ.Run # 0 THEN
       CONFORM(RWayJ, Route);
       _MtyIdx:=E_Stock.TKind2MtyIdx(RWayS.Date, L_Way.GetRouteTKind(RWayS.Date, 1));
       INC(Runs[_MtyIdx-E_Stock.MtyRunBeg], RWayJ.Run * RWayJ.Fact);
      END;
      NEXT(RWayJ);
     END; (* WHILE OCCURE(RWayJ) ... *)
    END;
    NEXT(RWayS);
   END; (* WHILE OCCURE(RWayS) ... *)
   fmm_Flush(P, Runs);
   P:=L_DatTim.IncMonth(P, +1);
  END;
  L_MathR.ResetMathDone_AP(Math.Math, _From);
 END {fmm_MakeOneCarLog};

 PUBLIC PROCEDURE FillMathMty();
  VAR
   _From,
   _UpTo: DATE;
 BEGIN
  L_General.SilentPrgsOnly();
  _From:=L_DatTim.Per(SYSDATE());
  WHILE (L_Env.KeyAssAcntLev(_From-1) = L_MathR.kaal_WithActProcess) & (_From > L_Env.aptm_Start) DO
   _From:=L_DatTim.PrevPer(_From);
  END;
  _UpTo:=SYSDATE();
  L_StdFrm.Choice(" ⥫  ஡    "+ "|ਮ  " +
                  L_DatTim.DateStr(_From) + "  " + L_DatTim.DateStr(_UpTo));
 
  FLOCK(RWayS,   Share);
  FLOCK(RWayJ,   Share);
  FLOCK(SEJobs,  Share);
  FLOCK(Route,   Share);
  FLOCK(Car,     Share);
  FLOCK(CarLog,  Share);
  FLOCK(Math,    Share);
  FLOCK(MathMty, Monopol);
 
  PROMPT("⪠");
  SETSEL(MathMty, Math);
  REMSEL(MathMty);
 
  SELECT(Car, BoxNbr);
  WHILE OCCURE(Car) DO
   SELECT(CarLog, BoxNbr, , Car.BoxNbr);
   WHILE OCCURE(CarLog) DO
    PROMPT(CarLog.BoxNbr);
    IF L_Env.RealBoxNbr(CarLog.BoxNbr) THEN
     IF ~!CarLog.Math THEN
      CONFORM(CarLog, Math);
      fmm_MakeOneCarLog(_From, _UpTo);
     END;
    END;
    NEXT(CarLog);
   END; (* WHILE OCCURE(CarLog) ... *)
   NEXT(Car);
  END; (* WHILE OCCURE(Car) ... *)
 END {FillMathMty};

END.