(*
%Copyright   (c) Polak Computer System
%Author      20.08.2002 15:56:42 MOG
%Purpose         MS Word
%Type        report
%Specific    LOC
%Modified    17.07.2014 18:26:18 POLAK\San
%Environment
*)

 MODULE VAT02 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Str, L_MSO, L_Str, Math, L_General, L_DatTim, L_XObj, L_Acnt, P_Firm, L_AcCut,
        L_Pmnt, L_MDoc, Memo, L_StdFrm, L_AFM, P_MyPlc, P_MySite, L_Packet;

 PRIVATE TYPE
  tTaxPer = SCAL[2];

 PRIVATE CONST
  tp_Month   = 0;
  tp_Quartal = 1;

  dt_Initial    = 0;
  dt_Correction = 1;

 PRIVATE VAR
  TaxPer              : SCAL[2];
  PerB,
  PerE                : DATE;
  IsFirstQuartalPacket: SCAL[2];
 
  ᫥20,
  ᫥20,
  ᫥18,
  ᫥18,
  ᫥덠,
  ᫥끠,
  ᫥C易,
  ᫥C易,
  ᫥ᥣ,
  ᫥ᥣ,
  ।멍,
  ।멍,
  ।멍,
  ।멍稩,
  ⇠⥭덠,
  ₮•᠍,
  •ᥣ,
  ⍠멀ᥣ,
  ᥣ,
  ᫥,
  ᫥饭: NUMERIC[0];

  ।멍_2,
  ।멍_2_1,
  ।멍_2,
  ।멍_2,
  ।멍稩_2 : NUMERIC[2];

                      : STRING[];
  ⮨ᥣ,
  ਮ⥭ᥣ,
  தᥣ           : NUMERIC[0];


 PRIVATE PROCEDURE IsAfter2009(): SCAL[2];
 BEGIN
  RETURN PerE >= 01\01\2009;
 END {IsAfter2009};

 PRIVATE PROCEDURE IsAfter2007(): SCAL[2];
 BEGIN
  RETURN PerE >= 01\01\2007;
 END {IsAfter2007};

 PRIVATE PROCEDURE IsAfter2006(): SCAL[2];
 BEGIN
  RETURN PerE >= 01\01\2006;
 END {IsAfter2006};

 PRIVATE PROCEDURE IsAfter200503(): SCAL[2];
 BEGIN
  RETURN PerE >= 01\03\2005;
 END {IsAfter200503};

 PRIVATE PROCEDURE IsAfter2004(): SCAL[2];
 BEGIN
  RETURN PerE >= 01\01\2004;
 END {IsAfter2004};

 PRIVATE PROCEDURE wordSetIntVar(File, _var: STRING[]);
 BEGIN
  L_MSO.wordSetVar(File+"."+_var, L_Str.IntStr(^_var));
 END {wordSetIntVar};

 PRIVATE PROCEDURE AtWorkDay(d: DATE): DATE;
 BEGIN
  L_General.Assert(SEARCH(Calendar, Date, d), L_DatTim.DateStr(d)+"   ");
  WHILE Calendar.WeekDay > L_DatTim.wd_Fri DO
   INC(d); L_General.Assert(SEARCH(Calendar, Date, d), L_DatTim.DateStr(d)+"   ");
  END;
  RETURN d;
 END {AtWorkDay};

 PRIVATE PROCEDURE PrepareFiscalAgent(Prefix: STRING[]);
  VAR
   Count     : NUMERIC[0];
   Alias     : STRING[];
 BEGIN
  Count:=0;
  SELECT(TmpFA, TmpFA);
  WHILE OCCURE(TmpFA) DO
   Alias:=Prefix+".2"+L_MSO.IndexStr(Count)+".";
   L_MSO.wordSetVar(Alias+"⥫騪", TmpFA.FirmName);
   L_MSO.wordSetVar(Alias+"⥫騪",          TmpFA.INN);
   L_MSO.wordSetVar(Alias+"᫥⥍",         L_Str.IntStr(TmpFA.VAT));
   INC(Count);
   NEXT(TmpFA);
  END; (* WHILE OCCURE(TmpFA) ... *)
  L_MSO.SetWordTable("2", Count);
 END {PrepareFiscalAgent};

 PRIVATE PROCEDURE PrepareObjects(d: DATE);
  VAR
   TaxPer_Str,
   TaxPerKind,
   TaxPerCode: STRING[];
 BEGIN
  L_MSO.wordSetDateVar("TaxDecl.Date",   d);
  IF IsAfter2009() THEN
   IF    TaxPer = tp_Month THEN
    TaxPerCode:=L_Str.FixedIntStr(L_DatTim.MONTH(d) + 1, 2);
   ELSIF TaxPer = tp_Quartal THEN
    TaxPerCode:=L_Str.FixedIntStr(20+L_DatTim.QUARTAL(d) + 1, 2);
   END;
  ELSE
   IF    TaxPer = tp_Month THEN
    TaxPer_Str:=L_DatTim.MonthStr(d, 0);
    TaxPerKind:="1";
    TaxPerCode:=L_Str.FixedIntStr(L_DatTim.MONTH(d) + 1, 2);
   ELSIF TaxPer = tp_Quartal THEN
    TaxPer_Str:=L_Str.IntStr(L_DatTim.QUARTAL(d) + 1) + " ⠫";
    TaxPerKind:="3";
    TaxPerCode:=L_Str.FixedIntStr(L_DatTim.QUARTAL(d) + 1, 2);
   END;
   L_MSO.wordSetVar("TaxDecl.TaxPer", TaxPer_Str+" "+L_Str.IntStr(L_DatTim.YEAR(d)));
   L_MSO.wordSetVar("TaxDecl.TaxPerKind", TaxPerKind);
  END;
  L_MSO.wordSetVar("TaxDecl.TaxPerCode", TaxPerCode);
  wordSetIntVar("TaxDecl", "᫥20");
  wordSetIntVar("TaxDecl", "᫥20");
  wordSetIntVar("TaxDecl", "᫥18");
  wordSetIntVar("TaxDecl", "᫥18");
  wordSetIntVar("TaxDecl", "᫥C易");
  wordSetIntVar("TaxDecl", "᫥C易");
  wordSetIntVar("TaxDecl", "᫥끠");
  wordSetIntVar("TaxDecl", "᫥덠");
  wordSetIntVar("TaxDecl", "᫥ᥣ");
  wordSetIntVar("TaxDecl", "᫥ᥣ");
  wordSetIntVar("TaxDecl", "।멍");
  wordSetIntVar("TaxDecl", "।멍");
  wordSetIntVar("TaxDecl", "।멍");
  wordSetIntVar("TaxDecl", "।멍稩");
  wordSetIntVar("TaxDecl", "⇠⥭덠");
  wordSetIntVar("TaxDecl", "₮•᠍");
  wordSetIntVar("TaxDecl", "•ᥣ");
  wordSetIntVar("TaxDecl", "⍠멀ᥣ");
  wordSetIntVar("TaxDecl", "ᥣ");
  wordSetIntVar("TaxDecl", "᫥");
  wordSetIntVar("TaxDecl", "᫥饭");
  L_MSO.wordSetVar("TaxDecl.", );
  wordSetIntVar("TaxDecl", "ਮ⥭ᥣ");
  wordSetIntVar("TaxDecl", "தᥣ");
  wordSetIntVar("TaxDecl", "⮨ᥣ");
  PrepareFiscalAgent("TaxDecl");
 END {PrepareObjects};

 PRIVATE PROCEDURE MakeDoc(d, _SrcDate: DATE; DocType: SCAL[2]; CorrNum: NUMERIC[0]);
  VAR
   Template: STRING[];
 BEGIN
  L_MSO.wordInitDocument(d);
  P_Firm.SetFirmDefaultData("Own", P_Firm.fomf(P_Firm.curMyFirm), d, "");

  L_MSO.wordSetDateVar("TaxDecl.SrcDate",           _SrcDate);
  L_MSO.wordSetVar    ("TaxDecl.DocType",           L_Str.PoolItem("1|3", DocType));
  L_MSO.wordSetVar    ("TaxDecl.CorrNum",           L_Str.IntStr(CorrNum));
  L_MSO.wordSetVar    ("OwnFirm.OKATO",             P_MyPlc.GetP_OKATO(P_Firm.curMyFirm, EMPTYOF(MyPlace.MyPlace), d));
  L_MSO.wordSetVar    ("OwnFirm.KPP.DocNum",        P_MySite.GetMSProDocNum(P_Firm.curMyFirm, EMPTYOF(MyPlace.MyPlace), d, P_MySite.P_KPP));
  L_MSO.wordSetVar    ("OwnFirm.KPP.DocGiveS",      P_MySite.GetMSProDocGiveS(P_Firm.curMyFirm, EMPTYOF(MyPlace.MyPlace), d, P_MySite.P_KPP));
  L_MSO.wordSetVar    ("OwnFirm.KPP.DocGiveS.Code", Str.Slice(P_MySite.GetP_KPP(P_Firm.curMyFirm, EMPTYOF(MyPlace.MyPlace), d), 0, 4));
  L_MSO.wordSetDateVar("OwnFirm.KPP.DocGiveD",      P_MySite.GetMSProDocGiveD(P_Firm.curMyFirm, EMPTYOF(MyPlace.MyPlace), d, P_MySite.P_KPP));

  PrepareObjects(d);

  IF    IsAfter2009()   THEN Template:="VAT_06";
  ELSIF IsAfter2007()   THEN Template:="VAT_05";
  ELSIF IsAfter2006()   THEN Template:="VAT_04";
  ELSIF IsAfter200503() THEN Template:="VAT_03";
  ELSIF IsAfter2004()   THEN Template:="VAT_02";
  ELSE                       Template:="VAT_01";
  END;

  L_MSO.MakeWordDocument(Template, 1, L_MSO.PrpMode_ToDoc, "");
 END {MakeDoc};

 PRIVATE PROCEDURE D(AcCut, CorAcCut: LIKE(AcCut.AcCut)): NUMERIC[2];
  VAR r: L_Acnt.tAcntVector;
 BEGIN
  r:=L_XObj.GetTaxVector_Total(P_Firm.curMyFirm, AcCut, CorAcCut, PerB, PerE);
  RETURN r[L_Acnt.avp_Debit];
 END {D};

 PRIVATE PROCEDURE C(AcCut, CorAcCut: LIKE(AcCut.AcCut)): NUMERIC[2];
  VAR r: L_Acnt.tAcntVector;
 BEGIN
  r:=L_XObj.GetTaxVector_Total(P_Firm.curMyFirm, AcCut, CorAcCut, PerB, PerE);
  RETURN r[L_Acnt.avp_Credit];
 END {D};

 PRIVATE PROCEDURE GetAcCutsBySignPattern(    D       : DATE;
                                              _SignPat: STRING[];
                                          VAR _AcCuts : LIKE(AcCut.AcCut)[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  SETEMPTY(_AcCuts);
  IF ~!_SignPat THEN
   i:=0;
   SELECT(AcCut, AcCut);
   WHILE OCCURE(AcCut) DO
    PROMPT("஢ ࠧ१ " + AcCut.AcCut);
    IF L_DatTim.IsActive(D, AcCut.Begin, AcCut.Till) &
       Str.Match(L_Acnt.GetAcCutSign(D, AcCut.AcCut), _SignPat) THEN
     _AcCuts[i]:=AcCut.AcCut;
     INC(i);
    END;
    NEXT(AcCut);
   END; (* WHILE OCCURE(AcCut) ... *)
  END;
 END {GetAcCutsBySignPattern};

 PRIVATE PROCEDURE DC1(_AcCut: LIKE(AcCut.AcCut); _SignPat: STRING[]; avp: L_Acnt.tAcntVectorPart): NUMERIC[2];
  VAR
   AcCutsBySignPat: LIKE(AcCut.AcCut)[128];
   r              : L_Acnt.tAcntVector;
   i              : NUMERIC[0];
   Result         : NUMERIC[2];
 BEGIN
  Result:=0;
  GetAcCutsBySignPattern(PerE, _SignPat, AcCutsBySignPat);
  i:=0;
  WHILE ~!AcCutsBySignPat[i] DO
   r:=L_XObj.GetTaxVector_Total(P_Firm.curMyFirm, _AcCut, AcCutsBySignPat[i], PerB, PerE);
   INC(Result, r[avp]);
   INC(i);
  END;
  RETURN Result;
 END {DC1};

 PRIVATE PROCEDURE D1(_AcCut: LIKE(AcCut.AcCut); _SignPat: STRING[]): NUMERIC[2];
 BEGIN
  RETURN DC1(_AcCut, _SignPat, L_Acnt.avp_Debit);
 END {D1};

 PRIVATE PROCEDURE C1(_AcCut: LIKE(AcCut.AcCut); _SignPat: STRING[]): NUMERIC[2];
 BEGIN
  RETURN DC1(_AcCut, _SignPat, L_Acnt.avp_Credit);
 END {C1};

 PRIVATE PROCEDURE GetXYZ(dbfv_AcCut_: LIKE(AcCut.AcCut)): NUMERIC[2];
  VAR
   AcCuts_19,
   AcCuts_60: LIKE(AcCut.AcCut)[128];
   r        : L_Acnt.tAcntVector;
   i, j     : NUMERIC[0];
   Result   : NUMERIC[2];
 BEGIN
  Result:=0;
  GetAcCutsBySignPattern(PerE, "19*", AcCuts_19);
  GetAcCutsBySignPattern(PerE, "60*", AcCuts_60);
  i:=0;
  WHILE ~!AcCuts_19[i] DO
   r:=L_XObj.GetTaxVector2AcCut2_Total(P_Firm.curMyFirm, AcCuts_19[i], PerB, PerE);
   INC(Result, r[L_Acnt.avp_Debit]);
   r:=L_XObj.GetTaxVector_Total(P_Firm.curMyFirm, AcCuts_19[i], dbfv_AcCut_, PerB, PerE);
   DEC(Result, r[L_Acnt.avp_Credit]);
   j:=0;
   WHILE ~!AcCuts_60[j] DO
    r:=L_XObj.GetTaxVector_Total(P_Firm.curMyFirm, AcCuts_19[i], AcCuts_60[j], PerB, PerE);
    DEC(Result, r[L_Acnt.avp_Credit]);
    INC(j);
   END;
   INC(i);
  END;
  RETURN Result;
 END {GetXYZ};

 PRIVATE PROCEDURE ⫮멍⠢(Total: NUMERIC[2]): NUMERIC[2];
  VAR
   t,
   r   : NUMERIC[2];
   Sign: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" ⫮   ⠢");
  r:=0;
  t:=0;
  SELECT(MDoc, MDKDate, , L_MDoc.md_DPr);
  SRCINSEL(MDoc, GE, , PerB);
  WHILE OCCURE(MDoc) & (MDoc.Date <= L_DatTim.MonthEnd(PerE)) DO
   PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   IF    L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Pstpayment) THEN
    Sign:=+1;
   ELSIF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Underpay) THEN
    Sign:=-1;
   ELSE
    Sign:=0;
   END;
   IF (Sign # 0) & L_Pmnt.IsVATMDocToKeepInBook() & (MDoc.MyFirm = P_Firm.curMyFirm) THEN
    CONFORM(MDoc, MDocList);
    WHILE OCCURE(MDocList) DO
     IF L_Pmnt.GetMDocListVATRate() = L_Pmnt.vr_20 THEN
      INC(r, Sign*MDocList.VAT);
     END;
     INC(t, Sign*MDocList.VAT);
     NEXT(MDocList);
    END; (* WHILE OCCURE(MDocList) ... *)
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
  L_General.Assert(Total = t,
                   " ⫮   ⠢:" +
                   "|" +
                   "ᮮ⢥⢨  楢   㬥⮢   ");
  RETURN r;
 END {⫮멍⠢};

 PRIVATE PROCEDURE GetPrpReturn(): NUMERIC[2];
  VAR
   Result: NUMERIC[2];
   v     : L_Pmnt.tValuesToBalance;
 BEGIN
  APP.Get().NewPrompt("  ।");
  Result:=0;
  SELECT(MDoc, MDKDate, , L_MDoc.md_DPr);
  SRCINSEL(MDoc, GE, , PerB);
  WHILE OCCURE(MDoc) & (MDoc.Date <= L_DatTim.MonthEnd(PerE)) DO
   PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   IF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_PrpReturn) & L_Pmnt.IsVATMDocToKeepInBook() & (MDoc.MyFirm = P_Firm.curMyFirm) THEN
    v:=L_Pmnt.GetMDocAcpt();
    INC(Result, v[L_Pmnt.vtb_VAT]);
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
  RETURN Result;
 END {GetPrpReturn};

 PRIVATE PROCEDURE CheckRateOfPrepayments(oldRate: L_Pmnt.tVATRates);
 BEGIN
  APP.Get().NewPrompt("஫ ⢨ ॢ ⠢ ");
  SELECT(MDoc, MDKDate, , L_MDoc.md_DPr);
  SRCINSEL(MDoc, GE, , PerB);
  WHILE OCCURE(MDoc) & (MDoc.Date <= L_DatTim.MonthEnd(PerE)) DO
   PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   IF L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Prepayment) & (MDoc.MyFirm = P_Firm.curMyFirm) THEN
    CONFORM(MDoc, MDocList);
    WHILE OCCURE(MDocList) DO
     L_General.Assert(L_Pmnt.GetMDocListVATRate() # oldRate,
                      "।  ॢ襩 ⠢ ");
     NEXT(MDocList);
    END; (* WHILE OCCURE(MDocList) ... *)
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {CheckRateOfPrepayments};

 PRIVATE PROCEDURE Get_woVAT(VAR SellSum, PrchSum: NUMERIC[2]);
  VAR
   Result: NUMERIC[2];
   satVAT: P_Cntr.tSpecialAttitudeToVAT;
 BEGIN
  APP.Get().NewPrompt("த  㯪  ");
  SETZERO(SellSum, PrchSum);
  SELECT(MDocKind, MDocKind);
  WHILE OCCURE(MDocKind) DO
   IF L_Pmnt.IsAcptMDocKind(MDocKind.MDocKind) THEN
    SELECT(MDoc, MDKDate, , MDocKind.MDocKind);
    SRCINSEL(MDoc, GE, , PerB);
    WHILE OCCURE(MDoc) & (MDoc.Date <= L_DatTim.MonthEnd(PerE)) DO
     PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
     IF (MDoc.MyFirm = P_Firm.curMyFirm) THEN
      CONFORM(MDoc, MDocList);
      WHILE OCCURE(MDocList) DO
       IF MDocList.VAT = 0 THEN
        satVAT:=P_Cntr.GetSpecialAttitudeToVAT(MDoc.Contract, MDoc.Date);
        IF satVAT # P_Cntr.satVAT_TaxFree THEN
         IF (P_Math.GetSpecialAttitudeToVAT(MDocList.Math, MDoc.Date) = P_Math.satVAT_TaxFree) |
            (satVAT = P_Cntr.satVAT_Seller_wENVD) |
            (satVAT = P_Cntr.satVAT_Seller_wUSNO) |
            (satVAT = P_Cntr.satVAT_SellerIsIndividualPerson) THEN
          IF    L_MDoc.IsSellMDocKind() THEN
           INC(SellSum, MDocList.Sum);
          ELSIF L_MDoc.IsPrchMDocKind() THEN
           INC(PrchSum, MDocList.Sum);
          ELSE
           L_General.CallUs(0);
          END;
         END;
        END; (* IF satVAT # P_Cntr.satVAT_TaxFree *)
       END;
       NEXT(MDocList);
      END; (* WHILE OCCURE(MDocList) ... *)
     END;
     NEXT(MDoc);
    END; (* WHILE OCCURE(MDoc) ... *)
   END;
   NEXT(MDocKind);
  END; (* WHILE OCCURE(MDocKind) ... *)
 END {Get_woVAT};

 PRIVATE PROCEDURE FiscalAgentLeaseDest(): LIKE(Dest.Dest);
 BEGIN
  IF    L_General.GetAPSiteID() = "HM" THEN
   RETURN 500;
  ELSIF L_General.GetAPSiteID() = "55" THEN
   RETURN 447;
  ELSIF (L_General.GetAPSiteNumber() = 91) & ~APP.Get().ProductiveCopy THEN
   RETURN 606;
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {FiscalAgentLeaseDest};

 PRIVATE PROCEDURE GetFiscalAgent(): L_XObj.tSum;
  VAR
   fa_Dest    : LIKE(Dest.Dest);
   curFirmName: STRING[];
   s          : NUMERIC[0];
   v          : L_Pmnt.tValuesToBalance;
   Result     : L_XObj.tSum;
 BEGIN
  L_AFM.MakeMultipleIndex("TmpFA", "sortFN: STRING[64];"+
                                   "INN: STRING[12];"+
                                   "FirmName: LIKE(FirmPro.Value);"+
                                   "VAT:"+GET_TYPE_SPEC(L_XObj.tSum).Name,
                                   "TmpFA: sortFN, INN");

  L_AFM.MakeIndex("TmpCt", "Contract: LIKE(Contract.Contract)");

  fa_Dest:=FiscalAgentLeaseDest();
  IF ~!fa_Dest THEN
   SELECT(MDocKind, MDocKind);
   WHILE OCCURE(MDocKind) DO
    IF L_Pmnt.IsVATMDocKind(MDocKind.MDocKind) THEN
     SETSEL(MDoc, MDKDest, MDocKind.MDocKind, fa_Dest);
     SRCINSEL(MDoc, GE, , PerB);
     WHILE OCCURE(MDoc) & (MDoc.Date <= L_DatTim.MonthEnd(PerE)) DO
      PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
      IF (MDoc.MyFirm = P_Firm.curMyFirm) & (MDoc.Status = L_MDoc.st_Passed) THEN
       curFirmName:=P_Firm.FP_ContractorBriefName(MDoc.Firm, MDoc.Date);
       IF L_MDoc.IsSellMDocKind() THEN
        s:=+1;
       ELSE
        s:=-1;
       END;
       v:=L_Pmnt.GetMDocAcpt();
       IF ~ADD(TmpFA, TmpFA, curFirmName, P_Firm.FP_INN(MDoc.Firm, MDoc.Date), TmpFA.VAT, s * v[L_Pmnt.vtb_VAT]) THEN
        TmpFA.FirmName:=curFirmName;
        REPLACE(TmpFA);
       END;
       ADD(TmpCt, TmpCt, , MDoc.Contract);
      END;
      NEXT(MDoc);
     END; (* WHILE OCCURE(MDoc) ... *)
    END;
    NEXT(MDocKind);
   END; (* WHILE OCCURE(MDocKind) ... *)
  END;

  Result:=0;
  SELECT(TmpCt, TmpCt);
  WHILE OCCURE(TmpCt) DO
   SELECT(MDoc, Contract, , TmpCt.Contract);
   WHILE OCCURE(MDoc)  DO
    NARROWSEL(MDoc, MDocKind);
    CONFORM(MDoc, MDocKind);
    IF L_MDoc.IsPrchMDocKind() & L_Pmnt.IsVATMDocKind(MDocKind.MDocKind) THEN
     SRCINSEL(MDoc, GE, , PerB);
     WHILE OCCURE(MDoc) & (MDoc.Date <= L_DatTim.MonthEnd(PerE)) DO
      PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
      IF (MDoc.Status = L_MDoc.st_Passed) & L_Pmnt.IsSpecifiedVATMDoc(L_Pmnt.vmdbm_Acceptance) THEN
       CONFORM(MDoc, MDocList);
       WHILE OCCURE(MDocList) DO
        IF MDocList.VAT # 0 THEN
         INC(Result, MDocList.VAT - L_Acnt.VATPartInCost(L_Acnt.cvat_Allow, MDocList.VAT, MDocList.VATMode));
        END;
        NEXT(MDocList);
       END; (* WHILE OCCURE(MDocList) ... *)
      END;
      NEXT(MDoc);
     END; (* WHILE OCCURE(MDoc) ... *)
    END;
    NEXTINEXTENDEDSEL(MDoc, MDocKind);
   END; (* WHILE OCCURE(MDoc) ... *)
   NEXT(TmpCt);
  END; (* WHILE OCCURE(TmpCt) ... *)
  RETURN Result;
 END {GetFiscalAgent};

 PRIVATE PROCEDURE Prepare();
  VAR
   dbfv_AcCut_,
   dbfv_AcCut_⫮,
   dbfv_AcCut_㯠⥫,
   dbfv_AcCut_ਮ,
   dbfv_AcCut_ਮ,
   dbfv_AcCut_ਮ       : LIKE(AcCut.AcCut);

   ⫮__,
   ⫮20,
   த__                 : NUMERIC[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt("⮢");

  dbfv_AcCut_   := L_AcCut.erkn_GetSoft(PerE, L_AcCut.erkn_VATAccumulation);
  dbfv_AcCut_⫮   := L_AcCut.erkn_GetSoft(PerE, L_AcCut.erkn_VATUnderpay);
  dbfv_AcCut_㯠⥫   := L_AcCut.erkn_GetSoft(PerE, L_AcCut.erkn_VATPrepay);
  dbfv_AcCut_ਮ    := L_AcCut.erkn_GetSoft(PerE, L_AcCut.erkn_BoughtInventoryVAT);
  dbfv_AcCut_ਮ := L_AcCut.erkn_GetSoft(PerE, L_AcCut.erkn_BoughtGoodsVAT);
  dbfv_AcCut_ਮ     := L_AcCut.erkn_GetSoft(PerE, L_AcCut.erkn_BoughtKeyAssVAT);

  ⫮__:=C(dbfv_AcCut_, dbfv_AcCut_⫮);
  த__   :=C1(dbfv_AcCut_, "90*")+C1(dbfv_AcCut_, "91*");

  IF IsAfter2004() THEN
   ⫮20:=⫮멍⠢(⫮__);
  
   ᫥20:=⫮20;
   ᫥18:=த__ + (⫮__-⫮20);
  ELSE
   ᫥20:=த__ + ⫮__;
   ᫥18:=0;
  END;
  ᫥20:=᫥20*(100/20);
  ᫥18:=᫥18*(100/18);
  ᫥덠     :=C(dbfv_AcCut_, dbfv_AcCut_㯠⥫);
  IF IsAfter2004() THEN
   CheckRateOfPrepayments(L_Pmnt.GetStandartVATRate(31\12\2003));
   ᫥끠:=᫥덠*(118/18);
  ELSE
   ᫥끠:=᫥덠*(120/20);
  END;
  ᫥C易     :=᫥끠;
  ᫥C易    :=᫥덠;
 
  ᫥ᥣ      :=᫥20+
                            ᫥18+
                            ᫥C易;
 
  ᫥ᥣ     :=᫥20+
                            ᫥18+
                            ᫥C易;
 
  ।멍_2    :=D(dbfv_AcCut_, dbfv_AcCut_ਮ);
  ।멍_2:=D(dbfv_AcCut_, dbfv_AcCut_ਮ);
  ।멍稩_2:=D(dbfv_AcCut_, dbfv_AcCut_ਮ);
  ।멍_2      :=D1(dbfv_AcCut_, "19*")+
                                   D(dbfv_AcCut_, L_AcCut.erkn_GetSoft(PerE, L_AcCut.erkn_BoughtVATInCost));

  ।멍    :=Math.Round(।멍_2, 1);
  ।멍:=Math.Round(।멍_2, 1);
  ।멍稩:=Math.Round(।멍稩_2, 1);
  ।멍      :=Math.Round(।멍_2, 1);

  ।멍_2_1:=।멍_2+
                               ।멍_2+
                               ।멍稩_2;
  L_General.Assert(।멍_2=।멍_2_1,
                   "।멍 -  室  ⠬  19  019 ⠬");

  ⍠멀ᥣ:=GetFiscalAgent();
  DEC(।멍, ⍠멀ᥣ);

  ₮•᠍      :=GetPrpReturn();
  INC(।멍, ₮•᠍);

  ⇠⥭덠      :=D(dbfv_AcCut_, dbfv_AcCut_㯠⥫)-
                                 ₮•᠍;

  •ᥣ        :=⇠⥭덠;

  ᥣ              :=।멍+
                                 •ᥣ+
                                 ⍠멀ᥣ;

  ᫥:=0;
  ᫥饭:=0;
  IF ᫥ᥣ>=ᥣ THEN
   ᫥    :=᫥ᥣ-ᥣ;
  ELSE
   ᫥饭:=ᥣ-᫥ᥣ;
  END;

  IF L_General.IsPolakSpecific() THEN :="1010256";
  ELSE                                :="1010800";
  END;

  Get_woVAT(தᥣ, ਮ⥭ᥣ);

  ⮨ᥣ:=GetXYZ(dbfv_AcCut_);
 END {Prepare};

 PUBLIC PROCEDURE VAT02(MonthInquiry: SCAL[2]);
  CONST
   VAT_Deadline = 20;
  VAR
   d,
   _SrcDate                     : DATE;
   RepPerStr                    : STRING[];
   DocType                      : SCAL[2];
   CorrNum                      : NUMERIC[0];
 BEGIN
  IF MonthInquiry THEN
   PerB:=Memo.ud_mb();
   PerE:=Memo.ud_mb();
   TaxPer:=tp_Month;
   RepPerStr:=L_DatTim.PeriodStr(PerB);
  ELSE
   PerB:=L_Pmnt.ConvPer2VATClcPer(Memo.ud_mb());
   PerE:=Memo.ud_mb();
   TaxPer:=tp_Quartal;
   IF ~L_DatTim.IsLastMonthOfQuartal(PerE) THEN
    L_StdFrm.Choice(" 㤥 ⮢   ⠫");
   END;
   RepPerStr:=L_DatTim.FullQuartStr(PerE, 3);
  END;
  P_Firm.curMyFirm:=L_Pmnt.DefineMyFirm_wVAT(PerE);
  d:=L_DatTim.MonthEnd(PerE);
  _SrcDate:=Math.Min(SYSDATE(), AtWorkDay((d+1)+VAT_Deadline-1));
  DocType :=0;
  SETEMPTY(CorrNum);
  LOOP
   STDFORM(L_StdFrm.sf_Choice("|⮢     " + RepPerStr + "||" +
                              " ⮢ %##########%                             ||" +
                              " 㬥   %##############%  ४஢ %##%|",
                              "%<D.N.y>I  %<ࢨ|४騩>I %YI"),
           "    ",
           ,
           ,
           _SrcDate, DocType, CorrNum);
   IF    (DocType = dt_Correction) & !CorrNum THEN
    L_StdFrm.RedInform(" 㪠  ४஢");
   ELSIF (DocType = dt_Initial) & ~!CorrNum THEN
    L_StdFrm.RedInform(" ᫥ 㪠뢠  ४஢");
   ELSE
    EXIT;
   END;
  END; (* LOOP *)

  Prepare();

  MakeDoc(d, _SrcDate, DocType, CorrNum);
 END {VAT02};

 PRIVATE PROCEDURE psf_Num(pn: STRING[]);
 BEGIN
  L_Packet.psf_Num(pn, ^pn, 0000, 0000);
 END {psf_Num};

 PUBLIC PROCEDURE DoATER();
  VAR
   Count: NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt(" 묨 ⥬  '  '");
  P_Firm.curMyFirm:=Packet.MyFirm;
  L_Packet.CheckQuartalATER(1(*!!!*), IsFirstQuartalPacket, PerB, PerE);

  L_Packet.ClearATER(0);

  Prepare();

  L_Packet.psf_Str("", L_Packet.GetIdFile("NO_NDS"), 0000, 0000);

  psf_Num("᫥18");
  psf_Num("᫥18");

  psf_Num("᫥ᥣ");
  psf_Num("᫥C易");
  psf_Num("᫥C易");

  psf_Num("।멍");
  psf_Num("•ᥣ");
  psf_Num("⍠멀ᥣ");
  psf_Num("ᥣ");

  psf_Num("᫥");
  psf_Num("᫥饭");

  L_Packet.psf_Str("", , 0000, 0000);
  psf_Num("⮨ᥣ");
  psf_Num("தᥣ");
  psf_Num("ਮ⥭ᥣ");

  Count:=0;
  SELECT(TmpFA, TmpFA);
  WHILE OCCURE(TmpFA) DO
   L_Packet.psf_Str("2_⥫騪", TmpFA.FirmName, Count, 0000);
   L_Packet.psf_Str("2_⥫騪", TmpFA.INN, Count, 0000);
   L_Packet.psf_Num("2_᫥⥍", TmpFA.VAT, Count, 0000);
   INC(Count);
   NEXT(TmpFA);
  END; (* WHILE OCCURE(TmpFA) ... *)

  L_Packet.FinishATER(L_Packet.st_InProcess);
 END {DoATER};

END.
