(*
%Copyright   (c) Polak Computer System
%Author      03.07.2002 11:58:57 LDA
%Purpose     ஫ 䨪樨  ⮪
%Type        control, report
%Specific    SYS
%Modified    16.09.2013 16:41:14 POLAK\GAV
%Environment
*)

 MODULE WagePayL [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_Events, L_APtm, L_DatTim, L_OwnData, L_StdFrm, L_Money, L_WDO, L_DBD;

 PRIVATE PROCEDURE CheckRights();
 BEGIN
  L_General.Assert_wReferToAdmin(~L_APtm.MonthIsClosed(WagePayL.Period, L_APtm.system_Salary),
                                 " 䭮 ⪨  ⮬ ");
 END {CheckRights};

 PRIVATE PROCEDURE WagePayL_OnBeforeEdit();
 BEGIN
  CheckRights();
 END {WagePayL_OnBeforeEdit};

 PRIVATE PROCEDURE WagePayL_OnBeforeDelete();
 BEGIN
  CheckRights();
 END {WagePayL_OnBeforeDelete};

 PRIVATE PROCEDURE WagePayL_Period_OnSuccessfulChange();
 BEGIN
  CheckRights();
 END {WagePayL_Period_OnSuccessfulChange};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
########################################################################################################################### ########## #####
=#####======================================================================================================================================
|##########################################################################################################################################|
|------------------------------------------------------------------------------------------------------------------------------------------|
|    |                                                |     |                 ⠢  䨪                 |ᯮ|
| |                                    ||-----------------------------------------------------------------| .|
|    |                                                |     |       1  |       2  |       3  |       4  |       5  |       6  |⭮ |
}
*)

(*
$P{ Line:
WagePay.WagePay, L, ""
WagePay.Name, L, ""
WagePayL.Type, C, "|  "
WagePayL.Pay[1], R, "3-"
WagePayL.Pay[2], R, "3-"
WagePayL.Pay[3], R, "3-"
WagePayL.Pay[4], R, "3-"
WagePayL.Pay[5], R, "3-"
WagePayL.Pay[6], R, "3-"
?, C, " |"
@
|----|------------------------------------------------|-----|----------|----------|----------|----------|----------|----------|------------|
|####|################################################|#####|##########|##########|##########|##########|##########|##########|      #     |
}
*)

(*
$P{ CoefLine:
WagePayL.PayCoef[1], R, "3."
WagePayL.PayCoef[2], R, "3."
WagePayL.PayCoef[3], R, "3."
WagePayL.PayCoef[4], R, "3."
WagePayL.PayCoef[5], R, "3."
WagePayL.PayCoef[6], R, "3."
@
|    |                                                |     |##########|##########|##########|##########|##########|##########|            |
}
*)

(*
$P{ Bot:
@
=(c) Polak==================================================================================================================================
}
*)

 PRIVATE PROCEDURE IsActiveWagePay(D: DATE): SCAL[2];
 BEGIN
  SELECT(Officer, WagePay, , WagePay.WagePay);
  WHILE OCCURE(Officer) DO
   IF L_DatTim.IsActive_Inc(D, Officer.Begin, Officer.Till) THEN
    RETURN 1;
   END;
   NEXT(Officer);
  END; (* WHILE OCCURE(Officer) ... *)
  RETURN 0;
 END {IsActiveWagePay};

 PUBLIC PROCEDURE WPayL();
  CONST
   RepName = "WPayL";
  VAR
   D: DATE;
 BEGIN
  D:=Memo.ud_cd();
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, " ⪨  " + L_DatTim.DateStr(D));
  SELECT(WagePay, WagePay);
  WHILE OCCURE(WagePay) DO
   PROMPT(WagePay.WagePay);
   IF L_DatTim.IsActive(D, WagePay.Begin, WagePay.Till) THEN
    HISTCONF(D, WagePay, WagePayL);
    IF OCCURE(WagePayL) THEN
     MAKEPART(R, Line, IsActiveWagePay(D));
     IF ~!WagePayL.PayCoef[1] |
        ~!WagePayL.PayCoef[2] |
        ~!WagePayL.PayCoef[3] |
        ~!WagePayL.PayCoef[4] |
        ~!WagePayL.PayCoef[5] |
        ~!WagePayL.PayCoef[6] THEN
      MAKEPART(R, CoefLine);
     END;
    END;
   END;
   NEXT(WagePay);
  END; (* WHILE OCCURE(WagePay) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {WPayL};

 PUBLIC PROCEDURE MakeNewVersions();
  CONST
   RepName = "WPayN";
  VAR
   P    : DATE;
   _Type: LIKE(WagePayL.Type);
   Base : NUMERIC[2];
   i,
   Cnt   : NUMERIC[0];
 BEGIN
  SETZERO(Base, _Type);
  P:=Memo.ud_mb();
  STDFORM(L_StdFrm.sf_Choice("| %#######%  %########%  ⠢.|"+
                             "|ਬ   ⠢ %##########%|",
                             "%<N.y>I %<|ᮢ>I"+
                             "%<2->I"),
           ,
           ,
           ,
           P, _Type, Base);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, "⮪   ⮪  " + L_DatTim.PeriodStr(P) + ". " +
                            " ⠢ " + L_Money.MoneyToStr(P, "", Base));
  SELECT(WagePay, WagePay);
  WHILE OCCURE(WagePay) DO
   PROMPT(WagePay.WagePay);
   IF L_DatTim.IsActive(P, WagePay.Begin, WagePay.Till) & SELECT(WagePayL, WagePay, WagePay.WagePay) THEN
    LAST(WagePayL);
    IF WagePayL.Type = _Type THEN
     L_General.Assert(WagePayL.Period <= P, "䭠 ⪠ " + WagePay.WagePay + " " + WagePay.Name +
                                            "|㦥 ।  " + L_DatTim.PeriodStr(WagePayL.Period));
     i:=1; Cnt:=0;
     WHILE i <= HIGH(WagePayL.PayCoef) DO
      IF ~! WagePayL.PayCoef[i] THEN
       WagePayL.Pay[i]:=Base * WagePayL.PayCoef[i];
       INC(Cnt);
      END;
      INC(i);
     END;
     IF Cnt > 0 THEN
      IF WagePayL.Period = P THEN
       REPLACE(WagePayL);
      ELSE
       WagePayL.Period:=P;
       INSERT(WagePayL);
      END;
      MAKEPART(R, Line, IsActiveWagePay(P));
      MAKEPART(R, CoefLine);
     END;
    END;
   END;
   NEXT(WagePay);
  END; (* WHILE OCCURE(WagePay) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MakeNewVersions};

 PRIVATE PROCEDURE WagePayL_OnAfterEdIns();
 BEGIN
  (* Nothing special - its just for sysloging *)
 END {WagePayL_OnAfterEdIns};

 PRIVATE PROCEDURE WagePayL_OnAfterEdit();
 BEGIN
  WagePayL_OnAfterEdIns();
 END {WagePayL_OnAfterEdit};

 PRIVATE PROCEDURE WagePayL_OnAfterInsert();
 BEGIN
  WagePayL_OnAfterEdIns();
 END {WagePayL_OnAfterInsert};

 PRIVATE PROCEDURE WagePay_OnAfterEdIns();
 BEGIN
  (* Nothing special - its just for sysloging *)
  L_DBD.CheckValidity("WagePay");
 END {WagePay_OnAfterEdIns};

 PRIVATE PROCEDURE WagePay_OnAfterEdit();
 BEGIN
  WagePay_OnAfterEdIns();
 END {WagePay_OnAfterEdit};

 PRIVATE PROCEDURE WagePay_OnAfterInsert();
 BEGIN
  WagePay_OnAfterEdIns();
 END {WagePay_OnAfterInsert};

 PUBLIC PROCEDURE MakeCopy();
 BEGIN
  ACCESS(WagePay);
  L_WDO.LaunchInsertBySource(WagePay.WagePay, "");
 END {MakeCopy};

 PRIVATE PROCEDURE GetFreeWagePay(): LIKE(WagePay.WagePay);
  VAR
   Result,
   prevWagePay,
   firstWagePay,
   lastWagePay  : LIKE(WagePay.WagePay);
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  firstWagePay:=MINOF(WagePay.WagePay);
  lastWagePay :=MAXOF(WagePay.WagePay);
  SETEMPTY(Result);
  SAVE(WagePay);
  IF SELECT(WagePay, WagePay) & ~!WagePay.WagePay THEN
   IF firstWagePay < WagePay.WagePay THEN
    Result:=firstWagePay;
   ELSE
    LOOP
     prevWagePay:=WagePay.WagePay;
     IF NEXT(WagePay) & ~!WagePay.WagePay THEN
      IF prevWagePay + 1 < WagePay.WagePay THEN
       Result:=prevWagePay + 1;
       EXIT;
      END;
     ELSE
      EXIT;
     END;
    END; (* LOOP *)
    IF !Result THEN
     L_General.CallUs(prevWagePay + 1 <= lastWagePay);
     Result:=prevWagePay + 1;
    END;
   END;
  ELSE
   Result:=firstWagePay;
  END;
  RESTORE(WagePay);
  RETURN Result;
 END {GetFreeWagePay};

 PRIVATE PROCEDURE WagePay_Begin_OnSuccessfulChange();
  VAR
   srcWagePay: LIKE(WagePay.WagePay);
 BEGIN
  srcWagePay:=L_WDO.GetInsertionSource();
  IF ~!srcWagePay THEN
   IF ~!GE_PVALUE() & SELECT(WagePayL, WagePay, WagePay.WagePay) THEN
    L_StdFrm.Choice("  ⠢ 㤥 㤠  ⠢ , 㠫쭠  " + L_DatTim.PeriodStr(WagePay.Begin));
    REMSEL(WagePayL);
   END;
   SETSEL(WagePayL, WagePay, srcWagePay);
   SRCINSEL(WagePayL, LE, , WagePay.Begin);
   WHILE OCCURE(WagePayL) DO
    SAVE(WagePayL);
    IF WagePayL.Period < WagePay.Begin THEN
     WagePayL.Period:=WagePay.Begin;
    END;
    WagePayL.WagePay:=WagePay.WagePay;
    INSERT(WagePayL);
    RESTORE(WagePayL);
    NEXT(WagePayL);
   END; (* WHILE OCCURE(WagePayL) ... *)
  END;
 END {WagePay_Begin_OnSuccessfulChange};

 PRIVATE PROCEDURE intMakeCopy(OldWagePay, NewWagePay: LIKE(WagePay.WagePay));
  VAR
   wpName: STRING[];
 BEGIN
  SAVE(WagePay);
  L_General.CallUs(SEARCH(WagePay, WagePay, OldWagePay));
  wpName:=WagePay.Name;
  RESTORE(WagePay);
  SETEMPTY(WagePay.Begin, WagePay.Till);
  WagePay.Name   :=wpName;
  WagePay.WagePay:=NewWagePay;
  REPLACE(WagePay);
 END {intMakeCopy};

 PRIVATE PROCEDURE WagePay_OnBeforeInsert();
  VAR
   srcWagePay: LIKE(WagePay.WagePay);
 BEGIN
  srcWagePay:=L_WDO.GetInsertionSource();
  IF ~!srcWagePay THEN
   intMakeCopy(srcWagePay, GetFreeWagePay());
  END;
 END {WagePay_OnBeforeInsert};

 PRIVATE PROCEDURE WagePay_OnBeforeDelete();
 BEGIN
  (* Nothing special - its just for sysloging *)
 END {WagePay_OnBeforeDelete};

 PRIVATE PROCEDURE WagePayE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeInsert]);
  L_WDO.iScsChange   (0, ["WagePay.Begin"]);
  L_WDO.iMayBeEmpty  (0, ["WagePay.Till"]);
  L_WDO.iProgs       (0, "WagePayL");
  L_WDO.iSubwindow   (1, "WageP_EE");
 END {WagePayE_OnInitializeWindow};

BEGIN
 L_Events.ExecuteHandler();
END.
