(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose      ௫  SYSDATE   1- ᫮  SYSDATE, ନ஢ 
%Type        operation
%Specific    SYS
%Modified    13.07.2012 20:17:58 POLAK\Gina
*)

 MODULE WholeSal [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_DatTim, L_General, L_Str, L_PDoc, L_PRoll, L_Staff, L_Print,
        L_Env, L_APtm, Memo, L_Money, L_StdFrm, L_XDoc;

 PRIVATE TYPE
  tPDocMode     = SCAL[2];
  tForMonthMode = SCAL[2];

 PRIVATE CONST
  pdm_Normal   = 0;
  pdm_ForceRKO = 1;

  fmm_wCur    = 0;
  fmm_PrvOnly = 1;

  pdt_Single     = 0;
  pdt_Cumulative = 1;

 PRIVATE PROCEDURE IntCalcSalOnly();
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   CALL(ManRW.MakeDoneRWaySwSkipUnTaxed_ByStaff()); (* ᪠ ⠪஢. \  SYSDATE   *)
  EXCEPT
  END; (* TRY *)
  CALL(CalcDed.CountUp());
 END {IntCalcSalOnly};

 PRIVATE PROCEDURE _MakeMonth();
 BEGIN
  IntCalcSalOnly();
  IF ~L_APtm.MonthIsClosed(Memo.gl_mb(), L_APtm.system_Salary) THEN
   CALL(SMPrint.SMPrint_Stream());
  END;
 END {_MakeMonth};

 PRIVATE PROCEDURE MakeMonth(P: DATE);
 BEGIN
  IF (P>=L_Env.aptm_Start) & L_Staff.IsBegan(P) THEN
   L_APtm.TemporaryChangeMemoDate(P, PROCREF(_MakeMonth));
  END;
 END {MakeMonth};

 PRIVATE PROCEDURE SumToGet(P: DATE): NUMERIC[2];
 BEGIN
  IF ~L_Staff.IsBegan(P) THEN
   RETURN 0;
  ELSE
   RETURN L_PRoll.Get_ToTakeEO(P);
  END;
 END {SumToGet};

 PRIVATE PROCEDURE NotifyUnClosedPDoc();
  VAR
   Found: SCAL[2];
   List : STRING[];
 BEGIN
  Found:=0; List:="";
  SELECT(PDocList, TSN, , Staff.TSN);
  SRCINSEL(PDocList, GE, , L_DatTim.IncMonth(L_DatTim.Per(SYSDATE()), -2));
  WHILE OCCURE(PDocList) & ~Found DO
   CONFORM(PDocList, PDoc);
   IF L_PDoc.IsUnClosedSalPDoc(PDoc.mfNbr) & (PDoc.Status # L_PDoc.st_Canceled) THEN
    List:=List + L_XDoc.extXDocStr(L_XDoc.curXDocId(L_XDoc.xdt_PDoc), L_XDoc.xdast_wDate) +", "+
               L_Str.Left(L_PDoc.PDocAbout(PDoc.PDocKind, PDoc.PDoc), 32)+
               ", 㬬 "+L_Money.MoneyToStr(PDoc.Date, ",", PDocList.Sum)+"|";
    Found:=1;
   END;
   NEXT(PDocList);
  END; (* WHILE OCCURE(PDocList) ... *)
  IF Found THEN
   L_StdFrm.Choice("  ⥫   ࠡ⭨ "+Staff.TSN+":||"+List);
  END;
 END {NotifyUnClosedPDoc};

 PRIVATE PROCEDURE Do(PDocMode: tPDocMode; ForMonthMode: tForMonthMode; pdt: SCAL[2]);
  VAR
   Cur,
   Prv            : DATE;
   fullMonRepName : STRING[];
   _SumToGet      : NUMERIC[2];
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  PROMPT(Staff.TSN);
  L_StdFrm.Question("' ௫' " +
                    L_Str.PoolItem(" ⥪騩 |  ", ForMonthMode) +
                    "  ନ஢" +
                    "||" +
                    L_Str.PoolItem(" | ", L_PDoc.ForceUnClosedPay) +
                    L_Str.PoolItem("⥦ 㬥| ", PDocMode));

  Memo.gl_SetCurDate(SYSDATE());

  IF pdt = pdt_Cumulative THEN
   L_PDoc.ForceUnClosedSalPDoc();
  END;
  NotifyUnClosedPDoc();

  IF PDocMode = pdm_ForceRKO THEN
   L_PDoc.ForceEOrdPay();
  END;

  fullMonRepName:=L_General.NameConnection("Money");
  OPENREP(Mon, fullMonRepName, Create);
 
  Cur:=L_DatTim.Per(SYSDATE());
  Prv:=L_DatTim.IncMonth(Cur, -1);
 
  L_Print.SetPageNbr(0);            (* SMPrint.SMPrint_Stream()*)
  MakeMonth(Prv);
  IF    ForMonthMode = fmm_wCur THEN
   MakeMonth(Cur);
   _SumToGet:=SumToGet(Cur);
   L_PDoc.InitPDocGroup(L_PDoc.ev_CurWholeSal);
   TRY
    L_PDoc.AppendPDoc(_SumToGet);
   EXCEPT
   END; (* TRY *)
  ELSIF ForMonthMode = fmm_PrvOnly THEN
   L_PDoc.InitPDocGroup(L_PDoc.ev_PrvWholeSal);
   _SumToGet:=SumToGet(Prv);
   TRY
    L_PDoc.AppendPDoc(_SumToGet);
   EXCEPT
   END; (* TRY *)
  END; (* IF    ForMonthMode = ... *)
 
  IF LINENUM(Mon) # 0 THEN
   FORMFEED(Mon);              (* .㬥   *)
  END;

  L_PDoc.ExtDonePDocGroup(0, ~L_PDoc.ForceUnClosedPay);
  IF L_PDoc.ForceUnClosedPay & (_SumToGet # 0) THEN
   L_StdFrm.Inform("㬬 "+L_Money.MoneyToStr(PDoc.Date, ",", _SumToGet)+"||" +
                   "    "+L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc));
  END;

  CLOSEREP(Mon);

  IF (ForMonthMode = fmm_wCur) & (_SumToGet > 0) THEN
   CALL(CalcDed.CountUp());
  END;

  LIKEMENU(Survey, fullMonRepName);
 END {Do};

 PUBLIC PROCEDURE ExtCalcSalOnly();
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ⥪騩 ࠡ⭨");
  PROMPT(Staff.TSN);
  IntCalcSalOnly();
 END {ExtCalcSalOnly};

 PUBLIC PROCEDURE Cur_PD_Sngl();
 BEGIN
  Do(pdm_Normal, fmm_wCur, pdt_Single);
 END {Cur_PD_Sngl};

 PUBLIC PROCEDURE Prv_PD_Sngl();
 BEGIN
  Do(pdm_Normal, fmm_PrvOnly, pdt_Single);
 END {Prv_PD_Sngl};

 PUBLIC PROCEDURE Cur_KO_Sngl();
 BEGIN
  Do(pdm_ForceRKO, fmm_wCur, pdt_Single);
 END {Cur_KO_Sngl};

 PUBLIC PROCEDURE Prv_KO_Sngl();
 BEGIN
  Do(pdm_ForceRKO, fmm_PrvOnly, pdt_Single);
 END {Prv_KO_Sngl};

 PUBLIC PROCEDURE Cur_PD_Cmlt();
 BEGIN
  Do(pdm_Normal, fmm_wCur, pdt_Cumulative);
 END {Cur_PD_Cmlt};

 PUBLIC PROCEDURE Prv_PD_Cmlt();
 BEGIN
  Do(pdm_Normal, fmm_PrvOnly, pdt_Cumulative);
 END {Prv_PD_Cmlt};

 PUBLIC PROCEDURE Cur_KO_Cmlt();
 BEGIN
  Do(pdm_ForceRKO, fmm_wCur, pdt_Cumulative);
 END {Cur_KO_Cmlt};

 PUBLIC PROCEDURE Prv_KO_Cmlt();
 BEGIN
  Do(pdm_ForceRKO, fmm_PrvOnly, pdt_Cumulative);
 END {Prv_KO_Cmlt};

END.
