(*
%Copyright   (c) Polak IT
%Author      15.09.2009 09:39:24 POLAK\LDA
%Purpose
%Type        report
%Specific    LOC
%Modified    10.04.2012 12:31:05 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_OwnData, L_General, L_AFM, L_DatTim, L_MDoc, P_Storage, L_MathR, L_XDoc, Memo, L_Str, L_Car,
        L_AR;

 CONST
  rm_Staff = 0;
  rm_Car   = 1;

 VAR
  RepMode: NUMERIC[0];
  RepName: STRING[];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
"  ᮡ  裡  㬥⠬  ਮ", C, ""
?, L, "D.N.y"
?, L, "D.N.y"
?, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|                                     ਮ  ##########  ##########                                    |
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|/६         |               |㬥                         |                      |
|-------------------|-----------------------|---------------------------------|------------------------------|
}
*)

PROCEDURE TimestampStr(_DTS: TIMESTAMP): STRING[];
BEGIN
 RETURN FLDTOSTR(_DTS, "D.N.y H:M:S");
END {TimestampStr};

(*
$P{ Line:
TimestampStr(WrkJrn.DTS), L, ""
?, L, ""
?, L, ""
L_Str.ShortName(L_AR.GetAcsObjManName()), L, ""
@
|###################|#######################|#################################|##############################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE intInsIntoWrkJrn(_DTS: TIMESTAMP; _IsFuelMD: SCAL[2]);
  VAR
   _XDocId: L_XDoc.tXDocId;
 BEGIN
  _XDocId:=L_XDoc.XDocId(XDocJrn.XDocType, XDocJrn.XDocKind, XDocJrn.XDoc);
  IF ~SEARCH(WrkJrn, WrkJrn, _DTS, _XDocId, XDocJrn.Action) THEN
   WrkJrn.DTS     :=_DTS;
   WrkJrn.XDocId  :=_XDocId;
   WrkJrn.Action  :=XDocJrn.Action;
   WrkJrn.IsFuelMD:=_IsFuelMD;
   WrkJrn.AcsObj  :=XDocJrn.AcsObj;
   INSERT(WrkJrn);
  END;
 END {intInsIntoWrkJrn};

 PRIVATE PROCEDURE InsIntoWrkJrn(_IsFuelMD: SCAL[2]);
 BEGIN
  intInsIntoWrkJrn(PackTIMESTAMP(XDocJrn.Date, XDocJrn.BegTime, XDocJrn.BegSec), _IsFuelMD);
 END {InsIntoWrkJrn};

 PRIVATE PROCEDURE AcceptableRWaySAction(_Action: LIKE(XDocJrn.Action)): SCAL[2];
 BEGIN
  RETURN (_Action = L_XDoc.action_begInsert) |
         (_Action = L_XDoc.action_AutoBuild) |
         (_Action = L_XDoc.action_Insert) |
         (_Action = L_XDoc.action_AcceptCarDeparture) |
         (_Action = L_XDoc.action_begDst) |
         (_Action = L_XDoc.action_begDstCncl) |
         (_Action = L_XDoc.action_begRcp) |
         (_Action = L_XDoc.action_begRcpCncl) |
         (_Action = L_XDoc.action_CarDeparture) |
         (_Action = L_XDoc.action_CarReturn) |
         (_Action = L_XDoc.action_AcceptCarReturn) |
         (_Action = L_XDoc.action_ChainCor) |
         (_Action = L_XDoc.action_MedicalExamination) |
         (_Action = L_XDoc.action_NotAllowedByMedic);
 END {AcceptableRWaySAction};

 PRIVATE PROCEDURE AcceptableTckRcXAction(_Action: LIKE(XDocJrn.Action)): SCAL[2];
 BEGIN
  RETURN (_Action = L_XDoc.action_begInsert) |
         (_Action = L_XDoc.action_AutoBuild) |
         (_Action = L_XDoc.action_Insert) |
         (_Action = L_XDoc.action_begDst) |
         (_Action = L_XDoc.action_begRcp);
 END {AcceptableTckRcXAction};

 PRIVATE PROCEDURE ProceedSingleRWayS(BPer, EPer: DATE);
 BEGIN
  PROMPT("  " + RWayS.RWayS);
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RWayS, L_XDoc.EmptyXDocKind, RWayS.RWayS);
  SRCINSEL(XDocJrn, GE, , BPer);
  WHILE OCCURE(XDocJrn) & (XDocJrn.Date <= EPer) DO
   IF AcceptableRWaySAction(XDocJrn.Action) THEN
    InsIntoWrkJrn(0);
   END;
   NEXT(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ... *)
 END {ProceedSingleRWayS};

 PRIVATE PROCEDURE IsStaffInRprS(): SCAL[2];
 BEGIN
  SELECT(RprP, RprS, , RprS.RprS);
  WHILE OCCURE(RprP) DO
   IF RprP.TSN = Staff.TSN THEN
    RETURN 1;
   END;
   NEXT(RprP);
  END; (* WHILE OCCURE(RprP) ... *)
  RETURN 0;
 END {IsStaffInRprS};

 PRIVATE PROCEDURE StandOnPuttingIntoOperation(): SCAL[2];
 BEGIN
  LAST(XDocJrn);
  WHILE OCCURE(XDocJrn) DO
   IF    XDocJrn.Action = L_XDoc.action_rprPuttingIntoOperation THEN
    RETURN 1;
   ELSIF XDocJrn.Action = L_XDoc.action_rprCnclPuttingIntoOperation THEN
    RETURN 0;
   END;
   PREV(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ... *)
  RETURN 0;
 END {StandOnPuttingIntoOperation};

 PRIVATE PROCEDURE ProceedSingleRprS(FindPuttingIntoOperation: SCAL[2]);
 BEGIN
  PROMPT("  " + RprS.RprS);
  IF ((RepMode = rm_Staff) & IsStaffInRprS()) |
     ((RepMode = rm_Car)   & (RprS.CUCopy = CUCopy.CUCopy)) THEN
   SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS);
   IF    ~FindPuttingIntoOperation THEN
    intInsIntoWrkJrn(PackTIMESTAMP(RprS.OrdDate, RprS.OrdTime, 00), 0);
   ELSIF StandOnPuttingIntoOperation() THEN
    intInsIntoWrkJrn(PackTIMESTAMP(RprS.EDate, RprS.ETime, 00), 0);
   END;
  END;
 END {ProceedSingleRprS};

 PRIVATE PROCEDURE IsAcceptableTckRcS(VAR _asRWayS: LIKE(RWayS.RWayS)[]): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  IF RepMode = rm_Staff THEN
   RETURN 1
  ELSE
   i:=0;
   WHILE i <= HIGH(_asRWayS) DO
    IF ~!_asRWayS[i] & SEARCH(RWayS, RWayS, _asRWayS[i]) & (RWayS.BoxNbr = Car.BoxNbr) THEN
     RETURN 1;
    END;
    INC(i);
   END; (* WHILE i <= HIGH(TckRcS.asRWayS)... *)
   RETURN 0;
  END;
 END {IsAcceptableTckRcS};

 PRIVATE PROCEDURE ProceedSingleTckRcS(BPer, EPer: DATE);
 BEGIN
  SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_TckRcS, L_XDoc.EmptyXDocKind, TckRcS.TckRcS);
  SRCINSEL(XDocJrn, GE, , BPer);
  WHILE OCCURE(XDocJrn) & (XDocJrn.Date <= EPer) DO
   IF AcceptableTckRcXAction(XDocJrn.Action) THEN
    InsIntoWrkJrn(0);
   END;
   NEXT(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ... *)
 END {ProceedSingleTckRcS};

 PRIVATE PROCEDURE GetActionAsStr(): STRING[];
  VAR
   _XDocId  : L_XDoc.tXDocId;
   ActionAsStr: STRING[];
 BEGIN
  IF WrkJrn.IsFuelMD THEN
   RETURN "ࠢ";
  ELSE
   ActionAsStr:=L_Str.PoolItem(L_XDoc.action_Pool, WrkJrn.Action);
   IF (WrkJrn.Action = L_XDoc.action_begInsert)  |
      (WrkJrn.Action = L_XDoc.action_AutoBuild)  |
      (WrkJrn.Action = L_XDoc.action_Insert)     |
      (WrkJrn.Action = L_XDoc.action_begDst)     |
      (WrkJrn.Action = L_XDoc.action_begDstCncl) |
      (WrkJrn.Action = L_XDoc.action_begRcp)     |
      (WrkJrn.Action = L_XDoc.action_begRcpCncl) THEN
    ActionAsStr:=ActionAsStr + " " + L_XDoc.Ref_ShortName(L_XDoc.ExtractXDocType(WrkJrn.XDocId));
   END;
   RETURN ActionAsStr;
  END;
 END {GetActionAsStr};

 PRIVATE PROCEDURE PrintRep(BPer, EPer: DATE);
  VAR
   _XDocId  : L_XDoc.tXDocId;
   Title,
   XDocAsStr: STRING[];
 BEGIN
  IF    RepMode = rm_Staff THEN
   CONFORM(Staff, Man);
   Title:="⭨ " + Staff.TSN + " " + Man.Name;
  ELSIF RepMode = rm_Car THEN
   L_Car.StandOnCarLog(Car.BoxNbr, EPer);
   CONFORM(CarLog, Mark);
   Title:="࠭ᯮ୮ ।⢮ " + Car.BoxNbr + " " + CarLog.StateNbr + " " + Mark.Name;
  END;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, BPer, EPer, Title);

  SETEMPTY(_XDocId);
  SELECT(WrkJrn, WrkJrn);
  LAST(WrkJrn);
  WHILE OCCURE(WrkJrn) DO
   PROMPT(" " + WrkJrn.XDocId);
   IF _XDocId # WrkJrn.XDocId THEN
    L_XDoc.PositionOnXDoc(WrkJrn.XDocId);
    XDocAsStr:=L_XDoc.XDocStr(WrkJrn.XDocId);
    _XDocId  :=WrkJrn.XDocId;
   ELSE
    SETEMPTY(XDocAsStr);
   END;
   SEARCH(AcsObj, AcsObj, , WrkJrn.AcsObj);
   MAKEPART(R, Line, GetActionAsStr(), XDocAsStr);
   PREV(WrkJrn);
  END; (* WHILE OCCURE(WrkJrn) ... *)
  MAKEPART(R, Bot);

  SELECT(WrkJrn, XDocId);
  WHILE OCCURE(WrkJrn) DO
   NARROWSEL(WrkJrn, XDocId);
   L_XDoc.sl_AddItem(WrkJrn.XDocId, L_XDoc.XDocStr(WrkJrn.XDocId));
   NEXTINEXTENDEDSEL(WrkJrn, XDocId);
  END; (* WHILE OCCURE(WrkJrn) ... *)
 END {PrintRep};

 PRIVATE PROCEDURE ProceedAllMDoc(BPer, EPer: DATE);
 BEGIN
  SRCINSEL(MDoc, GE, , BPer);
  WHILE OCCURE(MDoc) & (MDoc.Date <= EPer) DO
   PROMPT(" " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_MDoc, MDoc.MDocKind, MDoc.MDoc);
   InsIntoWrkJrn((MDoc.MDocKind = L_MDoc.md_NOV)          &
                 P_Storage.IsAnyFuelStation(MDoc.Storage) &
                 (L_MathR.E_GetSingleRefToXDocType(SYSDATE(), MDoc.MDocKind, MDoc.Storage) = L_XDoc.xdt_RWayS));
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {ProceedAllMDoc};

 PRIVATE PROCEDURE MakeFullHistory(BPer, EPer: DATE);
  VAR
   i: NUMERIC[0];
 BEGIN
  L_XDoc.sl_Init("");
  L_AFM.MakeMultipleIndex("WrkJrn", "DTS     : TIMESTAMP;" +
                                    "XDocId  : "+TYPENAMEOF(L_XDoc.tXDocId)+";" +
                                    "Action  : LIKE(XDocJrn.Action);" +
                                    "IsFuelMD: SCAL[2];" +
                                    "AcsObj  : LIKE(AcsObj.AcsObj)",
                             "WrkJrn: DTS, XDocId, Action;" +
                             "XDocId: XDocId");

  IF    RepMode = rm_Staff THEN
   SELECT(RWayS, TSN, , Staff.TSN);
  ELSIF RepMode = rm_Car THEN
   SELECT(RWayS, BoxNbr, , Car.BoxNbr);
  END;
  SRCINSEL(RWayS, GE, , BPer);
  WHILE OCCURE(RWayS) & (RWayS.Date <= EPer) DO
   ProceedSingleRWayS(BPer, EPer);
   NEXT(RWayS);
  END; (* WHILE OCCURE(RWayS) ... *)

  IF    RepMode = rm_Staff THEN
   SELECT(WayLMen, TSN, , Staff.TSN);
   SRCINSEL(WayLMen, GE, , BPer);
   WHILE OCCURE(WayLMen) & (WayLMen.RWayDate <= EPer) DO
    CONFORM(WayLMen, RWayS);
    ProceedSingleRWayS(BPer, EPer);
    NEXT(WayLMen);
   END; (* WHILE OCCURE(WayLMen) ... *)
  ELSIF RepMode = rm_Car THEN
   SELECT(WayLCar, BoxNbr, , Car.BoxNbr);
   SRCINSEL(WayLCar, GE, , BPer);
   WHILE OCCURE(WayLCar) & (WayLCar.RWayDate <= EPer) DO
    CONFORM(WayLCar, RWayS);
    ProceedSingleRWayS(BPer, EPer);
    NEXT(WayLCar);
   END; (* WHILE OCCURE(WayLCar) ... *)
  END;

  IF    RepMode = rm_Staff THEN
   SELECT(MDoc, TSN, , Staff.TSN);
   WHILE OCCURE(MDoc) DO
    NARROWSEL(MDoc, MDocKind);
    ProceedAllMDoc(BPer, EPer);
    NEXTINEXTENDEDSEL(MDoc, MDocKind);
   END; (* WHILE OCCURE(MDoc) ... *)
  ELSIF RepMode = rm_Car THEN
   SELECT(MDoc, BoxNbr, , Car.BoxNbr);
   ProceedAllMDoc(BPer, EPer);
  END;

  SELECT(RprS, OrdDate);
  SRCINSEL(RprS, GE, , BPer);
  WHILE OCCURE(RprS) & (RprS.OrdDate <= EPer) DO
   ProceedSingleRprS(0);
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)

  SELECT(RprS, EDate);
  SRCINSEL(RprS, GE, , BPer);
  WHILE OCCURE(RprS) & (RprS.EDate <= EPer) DO
   ProceedSingleRprS(1);
   NEXT(RprS);
  END; (* WHILE OCCURE(RprS) ... *)

  IF    RepMode = rm_Staff THEN
   SELECT(TckRcS, TSN, , Staff.TSN);
  ELSIF RepMode = rm_Car THEN
   SELECT(TckRcS, Date);
  END;
  SRCINSEL(TckRcS, GE, , BPer);
  WHILE OCCURE(TckRcS) & (TckRcS.Date <= EPer) DO
   PROMPT("  " + TckRcS.TckRcS);
   IF IsAcceptableTckRcS(TckRcS.asRWayS) THEN
    ProceedSingleTckRcS(BPer, EPer);
   END;

   IF RepMode = rm_Staff THEN
    SELECT(TckRcD, TckRcS, , TckRcS.TckRcS);
    SRCINSEL(TckRcD, GE, , BPer);
    WHILE OCCURE(TckRcD) & (TckRcD.Date <= EPer) DO
     PROMPT("  " + TckRcD.TckRcS + " " + TckRcD.TckRcD);
     SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_TckRcD, L_XDoc.EmptyXDocKind, TckRcD.TckRcD);
     IF L_DatTim.IsActive_Inc(XDocJrn.Date, BPer, EPer) THEN
      InsIntoWrkJrn(0);
     END;
     NEXT(TckRcD);
    END; (* WHILE OCCURE(TckRcD) ... *)
   END;
   NEXT(TckRcS);
  END; (* WHILE OCCURE(TckRcS) ... *)

  IF RepMode = rm_Staff THEN
   SELECT(TckRcC, TSN, , Staff.TSN);
   SRCINSEL(TckRcC, GE, , BPer);
   WHILE OCCURE(TckRcC) & (TckRcC.Date <= EPer) DO
    PROMPT("  " + TckRcC.TckRcS + " " + TckRcC.TckRcC);
    SELECT(XDocJrn, XDocJrn, , L_XDoc.xdt_TckRcC, L_XDoc.EmptyXDocKind, TckRcC.TckRcC);
    InsIntoWrkJrn(0);
    NEXT(TckRcC);
   END; (* WHILE OCCURE(TckRcC) ... *)
  END;

  PrintRep(BPer, EPer);
  L_XDoc.sl_Done();
 END {MakeFullHistory};

 PRIVATE PROCEDURE StfWJ();
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.Assert(ACCESS(Staff), " ࠭ ࠡ⭨");
  RepName:="StfWJ";
  RepMode:=rm_Staff;
  MakeFullHistory(Memo.ud_fr(), Memo.ud_ut());
 END {StfWJ};

 PRIVATE PROCEDURE CarWJ();
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_General.Assert(ACCESS(Car), " ࠭ ");
  CONFORM(Car, CUCopy);
  RepName:="CarWJ";
  RepMode:=rm_Car;
  MakeFullHistory(Memo.ud_fr(), Memo.ud_ut());
 END {CarWJ};

END.
