(*
%Copyright   (c) Polak Computer System
%Author      MOG
%Purpose     ஫ 䨪樨 XCalc
%Type        control
%Specific    SYS
%Modified    24.09.2014 16:15:08 LDA
*)

 MODULE XCalc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PRIVATE CONST
  ESN_XCalc_Suffix      = "_ESN";
  StaffMan_XCalc_Suffix = "_StaffMan";

 PRIVATE PROCEDURE SetSaldo();
  VAR
   sldSum,
   rslSum  : L_XObj.tSum;
   sldQnt,
   rslQnt  : L_XObj.tQnt;
   curXD   : DATE;
 BEGIN
  SAVE(XCalc);
  curXD:=XCalc.XDat;
  CHANGESEL(XCalc, XObject, , XCalc.XObject, XCalc.AcCut);
  IF PREV(XCalc) THEN
   L_XObj.OutSaldo(sldSum, sldQnt);
   L_XObj.OutRSaldo(rslSum, rslQnt);
   rslSum:=L_General.Denominate(XCalc.XDat, curXD, rslSum);
  ELSE
   SETZERO(sldSum, rslSum, sldQnt, rslQnt);
  END;
  RESTORE(XCalc);
  XCalc.SldSum:=sldSum;
  XCalc.SldQnt:=sldQnt;
  XCalc.RSlSum:=rslSum;
  XCalc.RSlQnt:=rslQnt;
  REPLACE(XCalc);
 END {SetSaldo};
 
 PRIVATE PROCEDURE BalXCalc1();
  VAR
   P: DATE;
 BEGIN
  CONFORM(XCalc, XObject);
  SetSaldo();
  P:=XCalc.XDat;
  SAVE(XCalc);
  CHANGESEL(XCalc, XObject, , XCalc.XObject, XCalc.AcCut);
  L_XObj.BalXCalc();
  CONFORM(XCalc, XObject);
  L_XObj.ResetXObjectDone(P, L_XObj.SectionOfXObjectAcCut(XCalc.AcCut), 1);
  RESTORE(XCalc);
 END {BalXCalc1};

 PRIVATE PROCEDURE CheckClcPer();
 BEGIN
  Memo.gl_SetCurDate(XCalc.XDat);
  CONFORM(XCalc, XObject);
  L_XObj.CheckClcPer(L_XObj.SectionOfXObjectAcCut(XCalc.AcCut));
 END {CheckClcPer};

 PRIVATE PROCEDURE XCalc_OnBeforeEdit();
 BEGIN
  L_General.AdminOnly();
  CheckClcPer();
 END {XCalc_OnBeforeEdit};

 PRIVATE PROCEDURE XCalc_OnAfterEdit();
 BEGIN
  L_General.Assert(GE_PVALUE(XCalc.AcCut) = XCalc.AcCut,
                   " ࠧ१   ");
  CheckClcPer();
  BalXCalc1();
 END {XCalc_OnAfterEdit};

 PRIVATE PROCEDURE XCalc_OnBeforeInsert();
 BEGIN
  L_General.AdminOnly();
 END {XCalc_OnBeforeInsert};

 PRIVATE PROCEDURE XCalc_OnAfterInsert();
 BEGIN
  CheckClcPer();
  BalXCalc1();
 END {XCalc_OnAfterInsert};

 PRIVATE PROCEDURE XCalc_OnBeforeDelete();
 BEGIN
  L_General.AdminOnly();
  CheckClcPer();
  CONFORM(XCalc, XApport);
  L_General.Assert(~OCCURE(XApport),
                   "饭 㤠  稨 ⮢");
 END {XCalc_OnBeforeDelete};

 PRIVATE PROCEDURE SetPermanentFilterAndTitle(VAR trgPermanentFilter, trgTitle: STRING[]);
  VAR
   erkn    : STRING[];
   trgAcCut: STRING[];
 BEGIN
  erkn:=L_WDO.GetEnvVarValue("trg_Notion");

  IF ~!erkn THEN
   L_kn.AccessERKN("AcCut", erkn);
   trgTitle:=ERKN.Name;

   trgAcCut:=L_AcCut.erkn_GetSoft(SYSDATE(), erkn);
   IF !trgAcCut THEN
    L_StdFrm.BlueStop("㭪樮쭮  ⠭");
   END;
   trgPermanentFilter:="XCalc.AcCut="+trgAcCut;
  END;
 END {GetPermanentFilterAndTitle};

 PRIVATE PROCEDURE XCalc_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "XCalcE");
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).Narrowing:="XODone.XObject=XObject.XObject";

  SetPermanentFilterAndTitle(L_WDO.iZone(1).PermanentFilter, L_WDO.iWindow().Title);
 END {XCalc_OnInitializeWindow};

 PRIVATE PROCEDURE XOManS_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="XCalc";
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iZone        (1).ParentZone:=L_WDO.iZone(0);
  L_WDO.iProgs       (1, "XCalc");
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).Narrowing:="XCalc.XObject=mfMan.XObject";
  L_WDO.iSubwindow   (2, "XCalcE");
  L_WDO.iZone        (3).ViewOnly:=1;
  L_WDO.iZone        (3).Narrowing:="XODone.XObject=mfMan.XObject";

  SetPermanentFilterAndTitle(L_WDO.iZone(2).PermanentFilter, L_WDO.iWindow().Title);
 END {XOManS_OnInitializeWindow};

 PRIVATE PROCEDURE XCalc_OnConformToWindow();
  VAR
   mstTableName,
   intmDoneFormat: STRING[];
 BEGIN
  mstTableName:=RTI.Get().CurZone.MasterTable.Name;
  ACCESS((mstTableName));
  IF mstTableName # "XObject" THEN
   IF Str.Match(RTI.Get().TrgWindow.AssignedName, "XCalc"+ESN_XCalc_Suffix+"*") THEN
    L_General.CallUs(mstTableName = "Staff");
    IF SEARCH(mfMan, Man, Staff.Man, Staff.MyFirm) & ~!mfMan.XO_ESN THEN
     SEARCH(XObject, XObject, , mfMan.XO_ESN);
    ELSE
     L_StdFrm.BlueStop(" ᫥  ");
    END;
   ELSIF Str.Match(RTI.Get().TrgWindow.AssignedName, "XCalc"+StaffMan_XCalc_Suffix+"*") THEN
    L_General.CallUs(mstTableName = "Staff");
    IF SEARCH(mfMan, Man, Staff.Man, Staff.MyFirm) THEN
     SEARCH(XObject, XObject, , mfMan.XObject);
    ELSE
     L_StdFrm.BlueStop(" ᫥  ࠡ⭨");
    END;
   ELSE
    CONFORM((mstTableName), XObject);
   END;
  END;
  IF OCCURE(XObject) THEN
   IF (XObject.Origin = L_XObj.o_Staff) |  (XObject.Origin = L_XObj.o_Man) | (XObject.Origin = L_XObj.o_ESN) THEN
    L_XObj.PassManXCalcViewAcsPnt();
   END;
   SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, XObject);
   RTI.Get().TrgWindow.Zones(0).Fields("v_XObjectOriginName").Value:=L_XObj.GetXObjectOriginName();
   IF XObject.Origin=L_XObj.o_Contract THEN
    intmDoneFormat:="-|";
   ELSE
    intmDoneFormat:=" | ";
   END;
   RTI.Get().TrgWindow.Zones(2).Fields("XODone.intmDone[0]").Format:=intmDoneFormat;
  ELSE
   HALT(1);
  END;
 END {XCalc_OnConformToWindow};

 PRIVATE PROCEDURE XCalcE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iUnmodifiable(0, ["v_XObjectOriginName", "XCalc.SldSum", "XCalc.DbtSum", "XCalc.RSlSum", "XCalc.CrdSum"]);
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeEdit]);
  L_WDO.iField       (1, "XApport.WFDate").Last:=1;
  L_WDO.iUnmodifiable(1, ["XApport.Source"]);
  L_WDO.iField       (1, "Apport.CirType").Format:="|";
  L_WDO.iField       (1, "XApport.Source").Format:=L_XObj.src_Pool;
 END {XCalcE_OnInitializeWindow};

 PRIVATE PROCEDURE xovME_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iUnmodifiable(0, ["v_XObjectOriginName", "XCalc.SldQnt", "XCalc.SldSum", "XCalc.CrdQnt", "XCalc.CrdSum",
                          "XCalc.DbtSum", "XCalc.DbtQnt", "XCalc.RSlSum", "XCalc.RSlQnt"]);
  L_WDO.iEvents      (1, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeEdit]);
  L_WDO.iField       (1, "XApport.WFDate").Last:=1;
  L_WDO.iUnmodifiable(1, ["XApport.Source"]);
  L_WDO.iField       (1, "Apport.CirType").Format:="|";
  L_WDO.iField       (1, "XApport.Source").Format:=L_XObj.src_Pool;
 END {xovME_OnInitializeWindow};

 PRIVATE PROCEDURE XCalcE_0_OnReposition();
 BEGIN
  ACCESS(XCalc);
  CONFORM(XCalc, XObject);
  RTI.Get().CurZone.Fields("v_XObjectOriginName").Value:=L_XObj.GetXObjectOriginName();
 END {XCalcE_0_OnReposition};

 PRIVATE PROCEDURE xovME_0_OnReposition();
 BEGIN
  ACCESS(XCalc);
  CONFORM(XCalc, XObject);
  RTI.Get().CurZone.Fields("v_XObjectOriginName").Value:=L_XObj.GetXObjectOriginName();
 END {xovME_0_OnReposition};

 PRIVATE PROCEDURE intViewXCalcByERKN(Suffix: STRING[]; trgNotion: L_kn.tNotion);
  VAR
   Window2Load: FORM_WINDOW;
   trgEnv     : ENV;
 BEGIN
  trgEnv:=ENV.Create();
  IF ~!trgNotion THEN
   trgEnv.Add("trg_Notion", trgNotion);
  END;
  Window2Load:=APP.Get().Forms.Load("XCalc",
                                    "XCalc"+Suffix+L_Str.IntStr(trgNotion)+"<xyz" + RTI.Get().CurWindow.AssignedName + ">",
                                    RTI.Get().CurZone,
                                    trgEnv);
  LIKEMENU(View, Window2Load.Name + " 1 " + RTI.Get().CurWindow.Name + " " + L_Str.IntStr(RTI.Get().CurZone.Number));
 END {intViewXCalcByERKN};

 PRIVATE PROCEDURE intViewXCalc(Suffix: STRING[]);
 BEGIN
  intViewXCalcByERKN(Suffix, EMPTYOF(L_kn.tNotion));
 END {intViewXCalc};

 PUBLIC PROCEDURE ViewXCalc();
 BEGIN
  intViewXCalc("");
 END {ViewXCalc};

 PUBLIC PROCEDURE ViewESNXCalc();
 BEGIN
  intViewXCalc(ESN_XCalc_Suffix);
 END {ViewESNXCalc};

 PUBLIC PROCEDURE ViewStaffManXCalc();
 BEGIN
  intViewXCalc(StaffMan_XCalc_Suffix);
 END {ViewStaffManXCalc};

 PUBLIC PROCEDURE ViewStaffManXCalcByERKN(trgNotion: L_kn.tNotion);
 BEGIN
  intViewXCalcByERKN(StaffMan_XCalc_Suffix, trgNotion);
 END {ViewStaffManXCalcByERKN};

 PUBLIC PROCEDURE ViewXOManSByERKN(trgNotion: L_kn.tNotion);
  VAR
   Window2Load: FORM_WINDOW;
   trgEnv     : ENV;
 BEGIN
  L_XObj.PassManXCalcViewAcsPnt();
  trgEnv:=ENV.Create();
  IF ~!trgNotion THEN
   trgEnv.Add("trg_Notion", trgNotion);
  END;
  Window2Load:=APP.Get().Forms.Load("XOManS", "XOManS"+L_Str.IntStr(trgNotion), , trgEnv);
  LIKEMENU(View, Window2Load.Name + " 1");
 END {ViewXOManSByERKN};

 PUBLIC PROCEDURE ViewXOManS();
 BEGIN
  ViewXOManSByERKN(EMPTYOF(L_kn.tNotion));
 END {ViewXOManS};

BEGIN
 L_Events.ExecuteHandler();
END.
