(*
%Copyright   (c) Polak IT
%Author      16.04.2008 10:36:13 POLAK\Bor
%Purpose     㬥,  ஢ ᫥  
%Type        report
%Specific    SYS
%Modified    22.09.2014 18:55:33 POLAK\San
%Environment
*)

 MODULE XDAntEdt [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_DatTim, L_OwnData, L_XDoc, L_Str, L_StdFrm, L_APtm, L_AFM, L_JDoc, L_XObj, L_MathR,
        L_PCS, L_DBD, Str;

 PRIVATE VAR
  BegDate,
  EndDate,
  LimDate: DATE;
  LimTime: TIME;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
?, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|㬥                                         |      |६   |짮⥫     |            |
|-------------------------------------------------|----------|--------|-----------------|--------------------|
}
*)

(*
$P{ Line:
?, L, ""
_XDAD.XDJDate, L, "D.N.y"
_XDAD.XDJTime, L, "H:M"
_XDAD.XDJSec, R, "L00"
_XDAD.Login, L, ""
L_Str.PoolItem(L_XDoc.action_Pool, _XDAD.Action), L, ""
@
|#################################################|##########|#####:##|#################|####################|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE GetLastClosedMonth(_System: L_APtm.tSystems): DATE;
 BEGIN
  L_APtm.MonthAccess(Memo.ud_mb());
  CHANGESEL(Month, Period);
  WHILE OCCURE(Month) DO
   IF Month.NoTouch[_System] THEN
    RETURN Month.Period;
   END;
   PREV(Month);
  END; (* WHILE OCCURE(Month) ... *)
  L_General.Error("    ");
 END {GetLastClosedMonth};

 PRIVATE PROCEDURE GetLimDatTimByClosedMonth(_System: L_APtm.tSystems; P: DATE);
 BEGIN
  Memo.gl_SetCurDate(P);
  L_APtm.MonthAccess(P);
  L_General.Assert(Month.NoTouch[_System], " "+L_DatTim.PeriodStr(P)+"  ");
  LimDate:=Month.NoTouchD[_System];
  LimTime:=Month.NoTouchT[_System];
 END {GetLimDatTimByClosedMonth};

 PRIVATE PROCEDURE GetLimDatTimByMemo(Head: STRING[]);
 BEGIN
  BegDate:=Memo.ud_fr();
  EndDate:=Memo.ud_ut();
  LimDate:=Memo.ud_cd();
  LimTime:=STRTOFLD("00:00", TIME);
  LOOP
   STDFORM(L_StdFrm.sf_Choice("|"+Str.Slice(Head, 0, 46)+
                              "|"                                              +
                              "|  ਮ     㬥 "+
                              "|"                                              +
                              "|         %##########%  %##########%        "+
                              "|"                                              +
                              "| 묨 ࠡ⠫  %##########% %#####%|",
                              "%L<D.N.y>I %L<D.N.y>I" +
                              "%L<D.N.y>I %L<H:M>I"),
           " ࠡ  㬥⠬",
           ,
           ,
           BegDate, EndDate, LimDate, LimTime);
   IF BegDate > EndDate THEN
    L_StdFrm.RedInform(" 砫  砭");
   ELSE
    EXIT;
   END;
  END; (* LOOP *)
 END {GetLimDatTimByMemo};

 PRIVATE PROCEDURE LimStrByMemo(): STRING[];
 BEGIN
  RETURN " ਮ  "+L_DatTim.DateStr(BegDate) + "  " + L_DatTim.DateStr(EndDate)+
         "  묨 ࠡ⠫  "+L_DatTim.DateStr(LimDate)+" "+L_DatTim.TimeStr(LimTime);
 END {LimStrByMemo};

 PRIVATE PROCEDURE CondAction(_Action: LIKE(XDocJrn.Action)): SCAL[2];
 BEGIN
  RETURN (_Action # L_XDoc.action_Reprint);
 END {CondAction};

 PRIVATE PROCEDURE MakeOneDoc(_XDocId  : L_XDoc.tXDocId);
  VAR
   _XDocType: L_XDoc.tXDocType;
   _XDocKind: L_XDoc.tXDocKind;
   _XDoc    : L_XDoc.tXDoc;
   FileName,
   FieldName: STRING[];
 BEGIN
  PROMPT(": " + L_XDoc.XDocStr(_XDocId));
  IF ~SEARCH(_XDAD, XDocId, _XDocId) THEN
   L_XDoc.DecodeXDocId(_XDocId, _XDocType, _XDocKind, _XDoc);
   SETSEL(XDocJrn, XDocJrn, _XDocType, _XDocKind, _XDoc);
   SRCINSEL(XDocJrn, GE, , LimDate);
   WHILE OCCURE(XDocJrn) DO
    IF (XDocJrn.Date > LimDate) |
       ((XDocJrn.EndTime > LimTime) &
        (XDocJrn.Date+(XDocJrn.BegTime>XDocJrn.EndTime) = LimDate)) THEN
     IF CondAction(XDocJrn.Action) THEN
      FileName:=L_XDoc.Ref_FileName(_XDocType);
      FieldName:=L_DBD.GetFieldName(FileName, L_XDoc.DateFieldName(FileName));
      DEFAULT(_XDAD);
      _XDAD.Date   :=^FieldName;
      _XDAD.XDocId :=_XDocId;
      _XDAD.XDJDate:=XDocJrn.Date+(XDocJrn.BegTime>XDocJrn.EndTime);
      _XDAD.XDJTime:=XDocJrn.EndTime;
      _XDAD.XDJSec :=XDocJrn.EndSec;
      CONFORM(XDocJrn, AcsObj);
      _XDAD.Login  :=AcsObj.Name;
      _XDAD.Action :=XDocJrn.Action;
      INSERT(_XDAD);
      RETURN;
     END;
    END;
    NEXT(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)
  END;
 END {MakeOneDoc};

 PRIVATE PROCEDURE MakeOneContract();
  VAR
   jdlPassCnt: NUMERIC[0];
 BEGIN
  SETSEL(PDocMDoc, Contract, Contract.Contract);
  SRCINSEL(PDocMDoc, GE, , BegDate);
  WHILE OCCURE(PDocMDoc) & (PDocMDoc.PDocDate <= EndDate) DO
   CONFORM(PDocMDoc, PDoc);
   MakeOneDoc(L_XDoc.curXDocId(L_XDoc.xdt_PDoc));
   NEXT(PDocMDoc);
  END; (* WHILE OCCURE(PDocMDoc) ... *)

  SELECT(MDoc, Contract, , Contract.Contract);
  WHILE OCCURE(MDoc) DO
   NARROWSEL(MDoc, MDocKind);
   SRCINSEL(MDoc, GE, , BegDate);
   WHILE OCCURE(MDoc) & (MDoc.Date <= EndDate) DO
    MakeOneDoc(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
    NEXT(MDoc);
   END; (* WHILE OCCURE(MDoc) ... *)
   NEXTINEXTENDEDSEL(MDoc, MDocKind);
  END; (* WHILE OCCURE(MDoc) ... *)

  L_XObj.AccessXObjectByOrigin(L_XObj.o_Contract);
  jdlPassCnt:=0;
  REPEAT
   IF jdlPassCnt = 0 THEN
    SETSEL(JDocList, XObject,  XObject.XObject);
   ELSE
    SETSEL(JDocList, XObject2, XObject.XObject);
   END;
   SRCINSEL(JDocList, GE, , BegDate);
   WHILE OCCURE(JDocList) & (JDocList.Date <= EndDate) DO
    CONFORM(JDocList, JDoc);
    MakeOneDoc(JDoc.XDocId);
    NEXT(JDocList);
   END; (* WHILE OCCURE(JDocList) ... *)
   INC(jdlPassCnt);
  UNTIL jdlPassCnt = 2;
 END {MakeOneContract};

 PRIVATE PROCEDURE MakeOneMath();
 BEGIN
  SETSEL(MDocList, Math, Math.Math);
  SRCINSEL(MDocList, GE, , BegDate);
  WHILE OCCURE(MDocList) & (MDocList.Date <= EndDate) DO
   CONFORM(MDocList, MDoc);
   MakeOneDoc(L_XDoc.curXDocId(L_XDoc.xdt_MDoc));
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
 END {MakeOneMath};

 PRIVATE PROCEDURE PrintRep();
  VAR
   _XDocStr: STRING[];
 BEGIN
  SELECT(_XDAD, Date);
  WHILE OCCURE(_XDAD) DO
   _XDocStr:=L_XDoc.extXDocStr(_XDAD.XDocId, L_XDoc.xdast_wDate);
   PROMPT(_XDocStr);
   MAKEPART(R, Line, _XDocStr);
   L_XDoc.sl_AddItem(_XDAD.XDocId, _XDocStr);
   NEXT(_XDAD);
  END; (* WHILE OCCURE(_XDAD) ... *)
  MAKEPART(R, Bot);
  CLOSEREP(R);
 
  L_AFM.AF_PurgeTemp("_XDAD");
 
  L_XDoc.sl_Done();
 END {PrintRep};

 PRIVATE PROCEDURE InitRep(RepName, Head1, Head2: STRING[]);
 BEGIN
  L_XDoc.sl_Init("㬥");
 
  L_AFM.MakeMultipleIndex("_XDAD", "Date   : DATE;" +
                                   "XDocId : "+TYPENAMEOF(L_XDoc.tXDocId)+";" +
                                   "XDJDate: DATE;" +
                                   "XDJTime: LIKE(XDocJrn.EndTime);" +
                                   "XDJSec : LIKE(XDocJrn.EndSec);" +
                                   "Login  : LIKE(AcsObj.Name);" +
                                   "Action : LIKE(XDocJrn.Action)",
                             "XDocId: XDocId;"+
                             "Date  : Date, XDocId");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, Head1, Head2);
 END {InitRep};

 PRIVATE PROCEDURE MakeAllDoc(XDocType: L_XDoc.tXDocType);
  VAR
   Msg          : STRING[];
   RefXDocT,
   DateIndex,
   FileName,
   DateFieldName,
   IndexName    : STRING[];
   DateFlag     : SCAL[2];
 BEGIN
  FileName     :=L_XDoc.Ref_FileName(XDocType);
  DateFieldName:=L_XDoc.DateFieldName(FileName);
  IF ~!DateFieldName THEN
   DateFieldName:=TABLE.Get(FileName).Fields(DateFieldName).ObtainName();
  END;
  DateIndex:=L_PCS.DateIndexName(FileName);
  IF ~!DateIndex THEN
   IndexName:=DateIndex;
   SETSEL(^FileName, ^IndexName);
   SRCINSEL(^FileName, GE, , BegDate);
  ELSE
   IndexName:=L_DBD.GetPrimaryIndex(FileName);
   SELECT(^FileName, ^IndexName);
  END;
  LOOP
   IF    ~OCCURE(^FileName) THEN
    EXIT;
   ELSIF (IndexName = DateIndex) &
         (^DateFieldName > EndDate) (*易⥫쭮 ⤥쭮 ப - ^*) THEN
    EXIT;
   ELSE
    PROMPT(": " + L_XDoc.XDocStr(L_XDoc.curXDocId(XDocType)));
    IF (IndexName = DateIndex) | !DateFieldName |
       L_DatTim.IsActive_Inc(^DateFieldName, BegDate, EndDate) THEN
     MakeOneDoc(L_XDoc.curXDocId(XDocType));
    END;
    NEXT(^FileName);
   END;
  END; (* LOOP *)
 END {MakeAllDoc};

 PRIVATE PROCEDURE GetXDocTypePool(VAR NamePool, TypePool: STRING[]);
  VAR
   XDocType: L_XDoc.tXDocType;
 BEGIN
  XDocType:=0;
  SETEMPTY(NamePool, TypePool);
  WHILE ~!L_XDoc.Ref_FileName(XDocType) DO
   IF ~!DATABASE.Get().Tables(L_XDoc.Ref_FileName(XDocType)) &
      L_XDoc.XDocTypeHasXDocJrn(XDocType) THEN
    NamePool:=NamePool + L_XDoc.Ref_FullName(XDocType) + "|";
    TypePool:=TypePool + L_Str.IntStr(XDocType)        + "|";
   END;
   INC(XDocType);
  END;
 END {GetXDocTypePool};

 PRIVATE PROCEDURE GetUserChoice(VAR XDocType: L_XDoc.tXDocType);
  VAR
   VarStr,
   NamePool,
   TypePool,
   Blank,
   PoolIns : STRING[];
   RefXDocT: L_XDoc.tXDocType;
 BEGIN
  IF !XDocType THEN
   GetXDocTypePool(NamePool, TypePool);
   Blank   :="%############%                                                        " +
            "|%####################################################################%" + "||";
   PoolIns :="%< 㬥⮢>M" + "%L<" + NamePool + ">I";
   VarStr  :="RefXDocT, ";
   RefXDocT:=0;
  ELSE
   SETEMPTY(Blank, PoolIns, VarStr, RefXDocT);
  END;
  INC(Blank, "%##########################################% %#######################%" +
            "|%%%########% %%%########%                    %########% %###%         ");
  INC(PoolIns, "%<ਮ,     㬥>M" + "%< 묨 ࠡ⠫ >M" +
               "%<>M" + "%L<D.N.y>I" + "%<>M" + "%L<D.N.y>I" + "%L<D.N.y>I" + "%L<H:M>I");
  INC(VarStr, "BegDate, EndDate, LimDate, LimTime");

  BegDate:=Memo.ud_fr();
  EndDate:=Memo.ud_ut();
  LimDate:=Memo.ud_cd();
  LimTime:=STRTOFLD("00:00", TIME);
  LOOP
   STDFORM(L_StdFrm.sf_Choice(Blank, PoolIns),
           " ࠡ  㬥⠬",
           ,
           ,
           ^VarStr);
   IF BegDate <= EndDate THEN
    EXIT;
   ELSE
    L_StdFrm.RedInform(" 砫  砭");
   END;
  END; (* LOOP *)
  IF !XDocType THEN
   XDocType:=L_Str.PoolItem(TypePool, RefXDocT);
  END;
 END {GetUserChoice};

 PRIVATE PROCEDURE MakeRep(XDocType: L_XDoc.tXDocType);
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  GetUserChoice(XDocType);
  InitRep("EditD",
          "㬥  "+L_XDoc.Ref_FullName(XDocType),
          LimStrByMemo());
  MakeAllDoc(XDocType);
  PrintRep();
 END {MakeRep};

 PUBLIC PROCEDURE Rep_ByChoiceDocType();
 BEGIN
  MakeRep(EMPTYOF(L_XDoc.tXDocType));
 END {Rep_ByChoiceDocType};

 PUBLIC PROCEDURE Rep_ByCurDocType();
  VAR
   XDocType: L_XDoc.tXDocType;
 BEGIN
  XDocType:=L_XDoc.DefineCurrentXDocType();
  L_General.Assert(L_XDoc.XDocTypeHasXDocJrn(XDocType), " ꥪ '" + L_XDoc.Ref_FullName(XDocType) + "' ୠ 権  ");
  MakeRep(XDocType);
 END {Rep_ByCurDocType};

 PUBLIC PROCEDURE MakeOneContractRep();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(Contract);
  GetLimDatTimByMemo("㬥   "+Contract.Contract+" "+Contract.Name);
  InitRep("CnAnD",
          "㬥   "+Contract.Contract+" "+Contract.Name,
          LimStrByMemo());
  MakeOneContract();
  PrintRep();
 END {MakeOneContractRep};

 PUBLIC PROCEDURE MakeOneContractRepClosedMonth();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  GetLimDatTimByClosedMonth(L_APtm.system_Math, Memo.ud_mb());
  BegDate:=L_DatTim.MINDATE();
  EndDate:=Memo.gl_me();
  ACCESS(Contract);
  InitRep("CnAnD",
          "㬥   "+Contract.Contract+" "+Contract.Name,
          " ஢ ᫥  "+L_DatTim.PeriodStr(Memo.gl_mb())+" ("+
          FLDTOSTR(LimDate, "D.N")+" "+FLDTOSTR(LimTime, "H:M")+")");
  MakeOneContract();
  PrintRep();
 END {MakeOneContractRepClosedMonth};

 PUBLIC PROCEDURE MakeOneMathRep();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  ACCESS(Math);
  GetLimDatTimByMemo("㬥  "+L_Str.PoolItem("|", Math.MathKind)+" "+Math.Math+" "+Math.Name);
  InitRep("MtAnD",
          "㬥  "+L_Str.PoolItem("|", Math.MathKind)+" "+Math.Math+" "+Math.Name,
          LimStrByMemo());
  MakeOneMath();
  PrintRep();
 END {MakeOneMathRep};

 PUBLIC PROCEDURE MakeOneMathRepClosedMonth();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Math), " । ꥪ");
  IF    Math.MathKind = L_MathR.mathk_Math THEN
   GetLimDatTimByClosedMonth(L_APtm.system_Math, Memo.ud_mb());
  ELSIF Math.MathKind = L_MathR.mathk_KeyAs THEN
   GetLimDatTimByClosedMonth(L_APtm.system_KeyAss, Memo.ud_mb());
  ELSE
   L_General.ConsultToUs(0, "XDantEdt.MathKind: Error "+Math.MathKind);
  END;
  BegDate:=Memo.gl_mb();
  EndDate:=Memo.gl_me();

  InitRep("MtAnD",
          "㬥  "+L_Str.PoolItem("|", Math.MathKind)+" "+Math.Math+" "+Math.Name,
          " "+L_DatTim.PeriodStr(Memo.ud_mb())+",  ஢ ᫥   ("+
          FLDTOSTR(LimDate, "D.N")+" "+FLDTOSTR(LimTime, "H:M")+")");
  MakeOneMath();
  PrintRep();
 END {MakeOneMathRepClosedMonth};

END.
