(*
%Copyright   (c) Polak IT
%Author      03.10.2012 16:58:17 POLAK\San
%Purpose     㦨 XDFCase
%Type        control
%Specific    SYS
%Modified    06.09.2013 18:48:45 POLAK\Bor
%Environment
*)

 MODULE XDFCase [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_WDO, L_XDF, L_XDoc, L_Str, L_StdFrm;

 PRIVATE PERMANENT VAR
  curOwner : LIKE(XDFCase.Owner);
  curClosed: LIKE(XDFCase.Closed);
  smrTimer : TIMESTAMP;

 PRIVATE PROCEDURE IsMyself(): SCAL[2];
 BEGIN
  RETURN curOwner = L_General.curUSER;
 END {IsMyself};

 PRIVATE PROCEDURE GetNarrowing(): STRING[];
 BEGIN
  RETURN "(XDFCase.Closed=XDFCase.curClosed) & (XDFCase.Owner=XDFCase.curOwner)";
 END {GetNarrowing};

 PRIVATE PROCEDURE ResetSummaryTimer();
 BEGIN
  smrTimer:=SYSTIMESTAMP()-999;
 END {ResetSummaryTimer};

 PRIVATE PROCEDURE MyXDFC_OnSetupWindow();
  VAR
   trgTitle: STRING[];
 BEGIN
  IF curClosed = 1 THEN
   trgTitle:="娢: ";
  ELSE
   trgTitle:="";
  END;
  IF IsMyself() THEN
   INC(trgTitle, ' 筠   㬥⠬');
  ELSE
   SEARCH(AcsObj, AcsObj, , curOwner);
   INC(trgTitle, '  㬥⠬ 㯯 "' + AcsObj.FullName + '"');
  END;
  L_WDO.iWindow().Title:=trgTitle;
  ResetSummaryTimer();
  MyXDFC_1_OnReposition();
 END {MyXDFC_OnSetupWindow};

 PRIVATE PROCEDURE MyXDFC_OnInitializeWindow();
 BEGIN
  IF ~VAR_IMPL.Get(curOwner).Initialized THEN
   curOwner :=L_General.curUSER;
   curClosed:=0;
  END;
  L_WDO.iWindow().MNUFileName:="XDFCase";
  L_WDO.iZone        (0).ViewOnly:=1;
  L_WDO.iField       (0, "XDoc_Description").LineBreakEnable:=1;
  L_WDO.iEvents      (1, [L_WDO.e_OnReposition]);
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iZone        (1).Narrowing:=GetNarrowing();
  L_WDO.iField       (1, "XDFCase.ToDo" ).Format:=L_XDF.ctd_Pool;
  MyXDFC_OnSetupWindow();
 END {MyXDFC_OnInitializeWindow};

 PRIVATE PROCEDURE GetSummary(): STRING[];
  CONST
   maxD = 20;
  VAR
   gCnt,
   dCnt   : NUMERIC[0];
   Result : STRING[];
 BEGIN
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   SETZERO(gCnt, dCnt);
   IF IsMyself() THEN
    SELECT(AOMem, AcsObj2, , L_General.curUSER);
    WHILE OCCURE(AOMem) DO
     IF SELECT(XDFCase, Owner, AOMem.AcsObj) THEN
      INC(gCnt);
      IF SRCINSEL(XDFCase, LT, 1) THEN
       WHILE OCCURE(XDFCase) & (dCnt < maxD) DO
        INC(dCnt);
        PREV(XDFCase);
       END;
      END;
     END;
     NEXT(AOMem);
    END; (* WHILE OCCURE(AOMem) *)
    IF gCnt > 0 THEN
     Result:="㯯 : " + L_Str.IntStr(gCnt) + "; ";
    ELSE
     Result:="㯯  ";
    END;
   ELSE
    gCnt:=1;
    IF SELECT(XDFCase, Owner, L_General.curUSER, 0) THEN
     WHILE OCCURE(XDFCase) & (dCnt < maxD) DO
      INC(dCnt);
      NEXT(XDFCase);
     END;
    END;
    Result:=" 筮  ";
   END; (* IF IsMyself() *)
   IF    dCnt = maxD THEN
    INC(Result, "㬥⮢  ࠡ   祬 " + L_Str.IntStr(maxD));
   ELSIF dCnt > 0 THEN
    INC(Result, "㬥⮢  ࠡ: " + L_Str.IntStr(dCnt));
   ELSIF gCnt > 0 THEN
    INC(Result, "㬥⮢  ࠡ ");
   END;
   INC(Result, ".");
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END;
  RETURN Result;
 END {GetSummary};

 PRIVATE PROCEDURE MyXDFC_1_OnReposition();
  VAR
   ZF0: FORM_FIELDS;
 BEGIN
  ZF0:=RTI.Get().CurWindow.Zones(0).Fields;
  IF ACCESS(XDFCase) THEN
   ZF0("XDoc_Description").Value:=L_XDF.XDocFullDescription(XDFCase.XDocId);
  ELSE
   ZF0("XDoc_Description").Value:="";
  END;
  IF (SYSTIMESTAMP() - smrTimer) > 1/24/60 THEN
   ZF0("Summary").Value:=GetSummary();
   smrTimer:=SYSTIMESTAMP();
  END;
 END {MyXDFC_1_OnReposition};

 PUBLIC PROCEDURE GoToXDoc();
 BEGIN
  ACCESS(XDFCase);
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, XDFCase.XDocId, "");
 END {GoToXDoc};

 PUBLIC PROCEDURE ChangeView();
  VAR
   i   : NUMERIC[0];
   List: STRING[];
   oa  : LIKE(AcsObj.AcsObj)[64];
 BEGIN
  i:=0;
  List:="";
  IF ~IsMyself() THEN
   oa[i]:=L_General.curUSER;
   INC(i);
   INC(List, " 筠 " + "|");
  END;
  TRY
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   SELECT(AOMem, AcsObj2, , L_General.curUSER);
   WHILE OCCURE(AOMem) DO
    IF (AOMem.AcsObj # curOwner) & SELECT(XDFCase, Owner, AOMem.AcsObj) THEN
     oa[i]:=AOMem.AcsObj;
     INC(i);
     SEARCH(AcsObj, AcsObj, , AOMem.AcsObj);
     INC(List, AcsObj.FullName + "|");
    END;
    NEXT(AOMem);
   END; (* WHILE OCCURE(AOMem) *)
  EXCEPT
  END;
  IF i > 0 THEN
   IF i = 1  THEN
    i:=0;
   ELSE
    i:=L_StdFrm.ShowListAsMenu(List, "롮 ");
   END;
   curOwner:=oa[i];
   MyXDFC_OnSetupWindow();
  ELSE
   L_StdFrm.BlueStop(" 㯯 ");
  END;
 END {ChangeView};

 PUBLIC PROCEDURE Put2Closed();
 BEGIN
  ACCESS(XDFCase);
  L_StdFrm.TimedINFORM("  㬥 㤥 " +
                       L_Str.PoolItem("६饭  娢|祭  娢", XDFCase.Closed), 5);
  IF ~XDFCase.Closed & (XDFCase.ToDo # L_XDF.ctd_Done) THEN
   L_General.Error(" 娢  ६   㬥 ⮫쪮  ﭨ ' 娢'");
  END;
  XDFCase.Closed:=~XDFCase.Closed;
  REPLACE(XDFCase);
  MyXDFC_OnSetupWindow();
 END {Put2Closed};

 PUBLIC PROCEDURE ShowArchive();
 BEGIN
  curClosed:=~curClosed;
  MyXDFC_OnSetupWindow();
 END {ShowArchive};

 PUBLIC PROCEDURE SetupVarsForRequiredPosition();
 BEGIN
  curOwner :=XDFCase.Owner;
  curClosed:=XDFCase.Closed;
  ResetSummaryTimer();
 END {SetupVarsForRequiredPosition};

BEGIN
 L_Events.ExecuteHandler();
END.