(*
%Copyright   (c) Polak
%Author      23.04.2002 18:14:34 MOG
%Purpose
%Type        operation
%Specific    SYS
%Modified    22.07.2014 11:35:06 POLAK\San
%Environment
*)

 MODULE XDoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_XDoc,
        L_General, L_Events, Math, Str, L_Str, L_StdFrm, L_Pmnt, Shell, FIO, L_DatTim, L_WDO,
        L_MDoc, L_ODoc, L_PDoc, L_FIO, L_AFM, L_PCS, L_DBD, L_SysLog, L_bp, L_OwnData;

 PRIVATE TYPE
  tActionType           = SCAL[16];
  tRefDocClassification = SCAL[4];
  tBPSelector           = SCAL[16];
  tReactionType         = SCAL[2];

 PRIVATE PERMANENT VAR
  CurrentXDocId: L_XDoc.tXDocId;

 PRIVATE CONST
  bp_MakeDone        = 0;
  bp_BuildAddDocs    = 1;
  bp_Print           = 2;
  bp_PrintCopy       = 3;
  bp_Send            = 4;
  bp_CheckStatus     = 5;
  bp_CheckPrinted    = 6;
  bp_CheckVerifiedCC = 7;

  bp_ActionPool = "ࠡ⪠ 㬥|"+
                  "ନ஢ ⥫ 㬥⮢|"+
                  " ਣ 㬥|"+
                  "  㬥|"+
                  "ࠢ 㬥|"+
                  "஢ઠ  㬥|"+
                  "஢ઠ, ⯥⠭  㬥|"+
                  "஢ઠ, ⢥ত  ";

  rdc_Itself  = 0;
  rdc_AllRefs = 1;
  rdc_ISFOnly = 2;
  rdc_Parent  = 3;

  bps_ITN_CopmpleteShipment  = 0;
  bps_ITN_Shipment_woVATDocs = 1;
  bps_ITN_CheckSpending      = 2;
  bps_ITN_TitlesPool = "㧪|㧪  ନ஢ ⮢-䠪|஫ 室";

  bps_Nrd_Reservation = 0;
  bps_Nrd_BuildMSP    = 1;
  bps_Nrd_TitlesPool = "ࢨ஢|ନ஢ ";

  rt_Choice = 0;
  rt_Stop   = 1;

 PRIVATE PROCEDURE XDocTypeMustBeVerified(curXDocType: L_XDoc.tXDocType): SCAL[2];
 BEGIN
  RETURN (curXDocType = L_XDoc.xdt_RWayS) | (curXDocType = L_XDoc.xdt_MDoc ) |
         (curXDocType = L_XDoc.xdt_PDoc ) | (curXDocType = L_XDoc.xdt_ODoc ) ;
 END {XDocTypeMustBeVerified};

 PRIVATE PROCEDURE VerifyCC(_XDocId     : L_XDoc.tXDocId;
                            _CopyCnt    : L_XDoc.tCopyCnt;
                            VAR _Message: STRING[]);
  VAR
   _DocType : L_XDoc.tXDocType;
   _DocKind : L_XDoc.tXDocKind;
   _Doc     : L_XDoc.tXDoc;
 BEGIN
  L_XDoc.DecodeXDocId(_XDocId, _DocType, _DocKind, _Doc);
  L_General.Assert(XDocTypeMustBeVerified(_DocType),
                   "㬥  '" + _DocType + " " + L_XDoc.Ref_FullName(_DocType) + "'    ஢");
  L_XDoc.PositionOnXDoc(_XDocId);
  L_General.Assert(~L_XDoc.XDocIsVerifiedCC(_DocType, _DocKind, _Doc),
                   "⢥ত 㦥 믮");
  L_General.Assert(L_XDoc.XDocIsPrinted(_DocType, _DocKind, _Doc),
                   "⢥ত 믮  ⯥⠭ 㬥⮢");
  L_General.Assert(^(L_XDoc.Ref_FileName(_DocType)).CopyCnt = _CopyCnt,
                   "     ᮮ⢥  㬠 ⥫");
  L_XDoc.XDocJrn_Mark(_DocType, _DocKind, _Doc, L_XDoc.action_VerifyCC);
  _Message:="⢥ত: "+L_XDoc.extXDocStr(_XDocId, L_XDoc.xdast_wDate);
 END {VerifyCC};

 PUBLIC PROCEDURE VerifyCopyCnt();
 BEGIN
  L_XDoc.DoByBarCode("⢥ত ", PROCREF(VerifyCC), 1);
 END {VerifyCopyCnt};

 PRIVATE PROCEDURE InitiateByBarCode(    trgXDocId : L_XDoc.tXDocId;
                                         trgCopyCnt: L_XDoc.tCopyCnt;
                                     VAR trgMessage: STRING[]);
 BEGIN
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, trgXDocId, "");
 END {InitiateByBarCode};

 PRIVATE PROCEDURE InitiateByPDocMDoc(FromPDocToMDoc: SCAL[2]);
  VAR
   _XDocId: STRING[];
 BEGIN
  IF ACCESS(PDocMDoc) THEN
   IF FromPDocToMDoc THEN
    _XDocId:=L_XDoc.XDocId(L_XDoc.xdt_MDoc, PDocMDoc.MDocKind, PDocMDoc.MDoc);
   ELSE
    _XDocId:=L_XDoc.XDocId(L_XDoc.xdt_PDoc, PDocMDoc.PDocKind, PDocMDoc.PDoc);
   END;
   L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, _XDocId, "");
  END;
 END {InitiateByPDocMDoc};

 PUBLIC PROCEDURE StandOnMDocByPDoc();
 BEGIN
  InitiateByPDocMDoc(1);
 END {StandOnMDocByPDoc};

 PUBLIC PROCEDURE StandOnPDocByMDoc();
 BEGIN
  InitiateByPDocMDoc(0);
 END {StandOnPDocByMDoc};

 PUBLIC PROCEDURE InitiateByShowList();
 BEGIN
  L_XDoc.sl_Show();
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.pvs_XDocId, "");
 END {InitiateByShowList};

 PRIVATE PROCEDURE MaySetReference(cXDocId, rXDocId: L_XDoc.tXDocId);
  VAR
   cContract,
   rContract: LIKE(Contract.Contract);
 BEGIN
  IF (L_XDoc.ExtractXDocType(cXDocId) = L_XDoc.xdt_MDoc) &
     (L_XDoc.ExtractXDocType(rXDocId) = L_XDoc.xdt_MDoc) THEN
   SAVE(MDoc);
   SAVE(MDocKind);
   L_XDoc.PositionOnXDoc(cXDocId); cContract:=MDoc.Contract;
   CONFORM(MDoc, MDocKind);
   L_XDoc.PositionOnXDoc(rXDocId); rContract:=MDoc.Contract;
   RESTORE(MDocKind);
   RESTORE(MDoc);
   L_General.Assert(cContract = rContract,
                    "⨬ ⠭   㬥⠬  ࠧ ࠬ");
  END;
 END {MaySetReference};

 PRIVATE PROCEDURE ConfirmChangeReference(cXDocId,
                                          rXDocId: L_XDoc.tXDocId;
                                          DoSet  : SCAL[2]);
 BEGIN
  L_StdFrm.Choice(Str.Align("騩 㬥 ", 20, LEFT) +
                  Str.Align(L_XDoc.extXDocStr(cXDocId, L_XDoc.xdast_wDate), 32, LEFT) +
                  "|" +
                  Str.Align(L_Str.PoolItem("ࢠ|⠭", DoSet) + "   ", 20, LEFT) +
                  Str.Align(L_XDoc.extXDocStr(rXDocId, L_XDoc.xdast_wDate), 32, LEFT));
 END {ConfirmChangeReference};

 PRIVATE PROCEDURE ManualRefType(curXDocId: L_XDoc.tXDocId; refXDocKindId: L_XDoc.tXDocKindId): LIKE(XDocRef.RefType);
  VAR
   curXDocType,
   refXDocType: L_XDoc.tXDocType;
   curXDocKind,
   refXDocKind: L_XDoc.tXDocKind;
   curXDoc    : L_XDoc.tXDoc;
   Result     : LIKE(XDocRef.RefType);
 BEGIN
  SETEMPTY(Result);
  L_XDoc.DecodeXDocId(curXDocId, curXDocType, curXDocKind, curXDoc);
  L_XDoc.DecodeXDocKindId(refXDocKindId, refXDocType, refXDocKind);
  IF    curXDocType = L_XDoc.xdt_MDoc THEN
   IF    (refXDocType = L_XDoc.xdt_MDoc) & L_Pmnt.extIsAcceptableAddMDocKind(refXDocKind, curXDocKind) THEN
    Result:=L_XDoc.rft_BaseOn;
   ELSIF (curXDocKind = L_MDoc.md_TOV) |
         (curXDocKind = L_MDoc.md_ViP) THEN
    IF refXDocKindId = L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, L_MDoc.md_ZNr) THEN
     Result:=L_XDoc.rft_RefTo;
    END;
   ELSIF L_Pmnt.IsAcptMDocKind(curXDocKind) THEN
    SAVE(MDoc);
    SAVE(MDocKind);
    L_XDoc.PositionOnXDoc(curXDocId);
    IF L_Pmnt.E_IsSellMDoc() THEN
     IF refXDocKindId = L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, L_MDoc.md_PPr) THEN
      Result:=L_XDoc.rft_BaseOn;
     END;
    ELSE
     IF refXDocKindId = L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, L_MDoc.md_PPk) THEN
      Result:=L_XDoc.rft_BaseOn;
     END;
    END; (* IF L_Pmnt.E_IsSellMDoc() ... *)
    RESTORE(MDocKind);
    RESTORE(MDoc);
   ELSIF L_Pmnt.IsVATMDocKind(curXDocKind) & ~L_XDoc.XDocWasAutoBuild(curXDocType, curXDocKind, curXDoc) THEN
    IF    refXDocType = L_XDoc.xdt_MDoc THEN
     IF L_Pmnt.IsAcptMDocKind(refXDocKind) | L_Pmnt.IsVATMDocKind(refXDocKind) THEN
      Result:=L_XDoc.rft_BaseOn;
     END;
    ELSIF refXDocType = L_XDoc.xdt_PDoc THEN
     IF (refXDocKind # L_PDoc.pd_OVN) & (refXDocKind # L_PDoc.pd_CND) & (refXDocKind # L_PDoc.pd_AVO) THEN
      Result:=L_XDoc.rft_BaseOn;
     END;
    END;
   END;
  ELSIF curXDocType = L_XDoc.xdt_PDoc THEN
   IF (refXDocType = L_XDoc.xdt_PDoc) & L_Pmnt.extIsAcceptableAddPDocKind(refXDocKind, EMPTYOF(PDoc.Dest), EMPTYOF(DATE), curXDocKind) THEN
    Result:=L_XDoc.rft_BaseOn;
   END;
  ELSIF curXDocType = L_XDoc.xdt_Dfrls THEN
   IF (refXDocType = L_XDoc.xdt_MDoc) & ((refXDocKind = L_MDoc.md_VhA) | (refXDocKind = L_MDoc.md_PPk) | (refXDocKind = L_MDoc.md_PPK)) THEN
    Result:=L_XDoc.rft_BaseOn;
   END;
  END;
  RETURN Result;
 END {ManualRefType};

 PRIVATE PROCEDURE SetRefXDocKind(curXDocId: L_XDoc.tXDocId): L_XDoc.tXDocKindId;
  CONST
   xdknLength = 32;
  VAR
   xdt        : L_XDoc.tXDocType;
   xdkId      : L_XDoc.tXDocKindId;
   Ids        : L_XDoc.tXDocKindId[128];
   i          : NUMERIC[0];
   List       : STRING[];
 BEGIN
  List:="";
  i:=0;
  FOR_EACH xdt DO
   IF    xdt = L_XDoc.xdt_MDoc THEN
    SELECT(MDocKind, MDocKind);
    WHILE OCCURE(MDocKind) DO
     xdkId:=L_XDoc.XDocKindId(L_XDoc.xdt_MDoc, MDocKind.MDocKind);
     IF ~!ManualRefType(curXDocId, xdkId) THEN
      Ids[i]:=xdkId;
      List:=List + L_XDoc.Ref_FullName(xdt) + ": "
                 + MDocKind.MDocKind + " "
                 + Str.Align(MDocKind.SName, xdknLength, LEFT) + " "
                 + MDocKind.Sign + "|";
      INC(i);
     END;
     NEXT(MDocKind);
    END; (* WHILE OCCURE(MDocKind) ... *)
   ELSIF xdt = L_XDoc.xdt_PDoc THEN
    SELECT(PDocKind, PDocKind);
    WHILE OCCURE(PDocKind) DO
     xdkId:=L_XDoc.XDocKindId(L_XDoc.xdt_PDoc, PDocKind.PDocKind);
     IF ~!ManualRefType(curXDocId, xdkId) THEN
      Ids[i]:=xdkId;
      List:=List + L_XDoc.Ref_FullName(xdt) + ":"
                 + PDocKind.PDocKind + " "
                 + Str.Align(PDocKind.SName, xdknLength, LEFT) + " ("
                 + PDocKind.Sign + ")" + "|";
      INC(i);
     END;
     NEXT(PDocKind);
    END; (* WHILE OCCURE(PDocKind) ... *)
   ELSE
    xdkId:=L_XDoc.XDocKindId(xdt, L_XDoc.EmptyXDocKind);
    IF ~!ManualRefType(curXDocId, xdkId) THEN
     Ids[i]:=xdkId;
     List:=List + L_XDoc.Ref_FullName(xdt) + "|";
     INC(i);
    END;
   END; (* IF xdt = ... *)
  END; (* FOR_EACH xdt ... *)
  L_General.Assert(i > 0, " ।ᬮ७ 稥 易 㬥");
  i:=L_StdFrm.ShowListAsMenu(List, "⠭   㬥⮬");
  RETURN Ids[i];
 END {SetRefXDocKind};

 PUBLIC PROCEDURE SetReference();
  VAR
   xdc: L_XDoc.tXDocCollection;
 BEGIN
  CurrentXDocId:=L_XDoc.GetCurrentXDocId();
  xdc          :=L_XDoc.GetAllRefToXDC(CurrentXDocId);
  IF L_XDoc.xdc_Count(xdc) > 0 THEN
   L_General.Error("騩 㬥 㦥 易  㣨: " + L_XDoc.XDocStr(L_XDoc.xdc_Item(xdc, 0)));
  END;
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_WaitUserChoice, SetRefXDocKind(CurrentXDocId), "XDoc.SetReference_Phase2()");
 END {SetReference};

 PUBLIC PROCEDURE SetReference_Phase2();
  VAR
   curXDocType: L_XDoc.tXDocType;
   defRefType : LIKE(XDocRef.RefType);
 BEGIN
  curXDocType:=L_XDoc.ExtractXDocType(CurrentXDocId);
  (* ६ CallUs -  ।  XDocRef *)
  IF    curXDocType = L_XDoc.xdt_MDoc THEN
   L_General.CallUs(ACCESS(MDoc));
  ELSIF curXDocType = L_XDoc.xdt_PDoc THEN
   L_General.CallUs(ACCESS(PDoc));
  ELSIF curXDocType = L_XDoc.xdt_Dfrls THEN
   L_General.CallUs(ACCESS(Dfrls));
  ELSE
   L_General.CallUs(0);
  END;
  L_General.Assert(CurrentXDocId = L_XDoc.curXDocId(curXDocType),
                   "⠭ 裡 , .. ᡨ   室 㬥 ("+L_XDoc.XDocStr(CurrentXDocId)+")"+
                   L_StdFrm.HR()+"஡    ࠧ");
  defRefType:=ManualRefType(CurrentXDocId, L_XDoc.ExtractXDocKindId(L_XDoc.ref_XDocId));
  L_General.CallUs(~!defRefType);
  L_XDoc.rf_Insert(L_XDoc.ExtractXDocType(CurrentXDocId), L_XDoc.ref_XDocId, defRefType);
  ConfirmChangeReference(CurrentXDocId, L_XDoc.ref_XDocId, 1);
  MaySetReference(CurrentXDocId, L_XDoc.ref_XDocId);
 END {SetReference_Phase2};

 PUBLIC PROCEDURE BreakReference();
  VAR
   xdc       : L_XDoc.tXDocCollection;
   curXDocId,
   refXDocId : L_XDoc.tXDocId;
   defRefType: LIKE(XDocRef.RefType);
 BEGIN
  curXDocId:=L_XDoc.GetCurrentXDocId();
  xdc      :=L_XDoc.GetAllRefToXDC(curXDocId);
  refXDocId:=L_XDoc.xdc_Item(xdc, 0);
  L_General.Assert(~!refXDocId, "騩 㬥   痢  㣨 㬥⠬");
  defRefType:=ManualRefType(curXDocId, L_XDoc.ExtractXDocKindId(refXDocId));
  L_General.Assert(~!defRefType, "⨬ ࠧ 裡, ᪮  ⠭ 㣨 ᯮᮡ");
  ConfirmChangeReference(curXDocId, refXDocId, 0);
  SEARCH(XDocRef, bXDocId, , curXDocId, refXDocId);
  L_General.CallUs((XDocRef.RefType = defRefType) |
                   (XDocRef.RefType = L_XDoc.rft_RefTo (* ६   ⨯ 裡 0090866 28.03.2012 20:47:02 POLAK\Bor*)));
  L_XDoc.rf_Remove(L_XDoc.ExtractXDocType(curXDocId), refXDocId, XDocRef.RefType);
 END {BreakReference};

 PRIVATE CONST
  dbp_DEBUG = 0;
  dbp_ProtocolWidth = 80;

 PRIVATE VAR
  dbp_Protocol: STRING[];

 PRIVATE PROCEDURE dbp_Protocol_Show(Title: STRING[]);
  VAR
   Dummy: NUMERIC[0];
 BEGIN
  IF ~!dbp_Protocol THEN
   Dummy:=0;
   Dummy:=STDFORM("%" + L_Str.IntStr(dbp_ProtocolWidth) + ",16<" + dbp_Protocol + ">I",
                  " 믮 楤: " + Str.Small(Title, 0, 1) + " ",
                  INFORM, , Dummy);
  END;
  IF dbp_DEBUG THEN
   L_General.Error("  㫨஢");
  END;
 END {dbp_Protocol_Show};

 PRIVATE PROCEDURE dbp_AddToProtocol(Action : tActionType;
                                     _XDocId: L_XDoc.tXDocId;
                                     ErrMsg : STRING[];
                                     RT     : tReactionType);
  VAR
   XDoc_asStr,
   Action_asStr: STRING[];
 BEGIN
  XDoc_asStr:=Str.Align(L_XDoc.extXDocStr(_XDocId, L_XDoc.xdast_wDate), dbp_ProtocolWidth/2, LEFT);
  Action_asStr:=Str.Align(L_Str.PoolItem(bp_ActionPool, Action),
                          dbp_ProtocolWidth-2-Str.Length(XDoc_asStr)-1, LEFT) + " " + XDoc_asStr;
  INC(dbp_Protocol, "|" + L_Str.PoolItem("-|", !ErrMsg) + " " + Action_asStr);
  IF ~!ErrMsg THEN
   IF RT = rt_Choice THEN
    L_StdFrm.Choice(Action_asStr + "| |" + ErrMsg);
   ELSE
    L_General.Error(Action_asStr + "| |" + ErrMsg);
   END;
  END;
 END {dbp_AddToProtocol};

 PRIVATE PROCEDURE dbp_Call(Prc: STRING[]): STRING[];
 BEGIN
  TRY
   CALL(^Prc);
   RETURN "";
  EXCEPT
  ON Exc:Exc_Root DO
   RETURN Exc.MsgOriginalText;
  END;
 END {dbp_Call};

 PRIVATE PROCEDURE dbp_Process(Prc: STRING[]): STRING[];
 BEGIN
  TRY [TRANSACTION(TRANSACTION_SLAVE)]
   CALL(^Prc);
   RETURN "";
  EXCEPT
  ON Exc:Exc_Root DO
   RETURN Exc.MsgOriginalText;
  END;
 END {dbp_Process};

 PRIVATE PROCEDURE IsAcceptableRefDoc(rXDocId: L_XDoc.tXDocId;
                                      wRefDoc: tRefDocClassification): SCAL[2];
  VAR
   refXDocType: L_XDoc.tXDocType;
   refXDocKind: L_XDoc.tXDocKind;
   refXDoc    : L_XDoc.tXDoc;
 BEGIN
  L_XDoc.DecodeXDocId(rXDocId, refXDocType, refXDocKind, refXDoc);
  IF    wRefDoc = rdc_AllRefs THEN
   RETURN 1;
  ELSIF wRefDoc = rdc_ISFOnly THEN
   RETURN (refXDocType = L_XDoc.xdt_MDoc) & (refXDocKind = L_MDoc.md_ISF);
  ELSE
   L_General.Error("IsAcceptableRefDoc.Error -   rdc_");
  END;
 END {IsAcceptableRefDoc};

 PRIVATE PROCEDURE GetParentDocId(curXDocId: L_XDoc.tXDocId): L_XDoc.tXDocId;
  VAR
   curXDocType : L_XDoc.tXDocType;
   curXDocKind : L_XDoc.tXDocKind;
   curXDoc     : L_XDoc.tXDoc;
 BEGIN
  LOOP
   curXDocId:=L_XDoc.GetBaseOnXDocId(curXDocId);
   IF ~!curXDocId THEN
    L_XDoc.DecodeXDocId(curXDocId, curXDocType, curXDocKind, curXDoc);
    IF (curXDocType # L_XDoc.xdt_MDoc) |
       ~L_Pmnt.IsTransitiveMDoc(curXDocKind) THEN
     RETURN curXDocId;
    END;
   ELSE
    RETURN curXDocId;
   END;
  END;
 END {GetParentDocId};

 PRIVATE PROCEDURE dbp_Do(curXDocId: L_XDoc.tXDocId;
                          Action   : tActionType;
                          wRefDoc  : tRefDocClassification);
  CONST
   rs_EmptyOption = ",  㦤  ॣ樨 26.12.2002 19:33:11 POLAK\SAN";

  VAR
   curXDocType   : L_XDoc.tXDocType;
   curXDocKind   : L_XDoc.tXDocKind;
   curXDoc       : L_XDoc.tXDoc;
   parentXDocId  : L_XDoc.tXDocId;
   DependentXDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
   Result        : STRING[];
   RT            : tReactionType;
 BEGIN
  L_XDoc.DecodeXDocId(curXDocId, curXDocType, curXDocKind, curXDoc);
  SAVE(^(L_XDoc.Ref_FileName(curXDocType)));
  L_XDoc.PositionOnXDoc(curXDocId);
  RT:=rt_Choice;
  IF curXDocType = L_XDoc.xdt_MDoc THEN
   IF wRefDoc # rdc_Itself THEN
    IF wRefDoc = rdc_Parent THEN
     parentXDocId:=GetParentDocId(curXDocId);
     IF ~!parentXDocId THEN
      dbp_Do(parentXDocId, Action, rdc_Itself);
     END;
    ELSE
     DependentXDocs:=L_XDoc.GetAllDependentXDC(curXDocId);
     i:=0;
     WHILE i < L_XDoc.xdc_Count(DependentXDocs) DO
      IF IsAcceptableRefDoc(L_XDoc.xdc_Item(DependentXDocs, i), wRefDoc) THEN
       dbp_Do(L_XDoc.xdc_Item(DependentXDocs, i), Action, rdc_Itself);
      END;
      INC(i);
     END;
    END;
    Result:=rs_EmptyOption;
   ELSE
    IF    Action = bp_MakeDone THEN
     RT:=rt_Stop;
     IF ~MDoc.Done THEN
      Result:=dbp_Process("MDoc.SingleMakeDone()");
     ELSE
      Result:=rs_EmptyOption;
     END;
    ELSIF Action = bp_BuildAddDocs THEN
     RT:=rt_Stop;
     Result:=dbp_Process("MDoc.BuildAddDocSilent()");
    ELSIF Action = bp_Print THEN
     IF ~L_XDoc.XDocIsPrinted(curXDocType, curXDocKind, curXDoc) THEN
      IF ~dbp_DEBUG THEN
       Result:=dbp_Process("MDoc.StreamRePrint()");
       IF !Result THEN
        Result:=dbp_Call("MDoc.StreamPrint()");
       END;
      ELSE
       L_XDoc.XDocJrn_Mark(curXDocType, curXDocKind, curXDoc, L_XDoc.action_Reprint);
       Result:="";
      END;
     ELSE
      Result:=rs_EmptyOption;
     END;
    ELSIF Action = bp_PrintCopy THEN
     IF ~dbp_DEBUG THEN
      Result:=dbp_Call("MDoc.SinglePrintCopy()");
     ELSE
      L_XDoc.XDocJrn_Mark(curXDocType, curXDocKind, curXDoc, L_XDoc.action_PrintCopy);
      Result:="";
     END;
    ELSIF Action = bp_Send THEN
     IF ~dbp_DEBUG THEN
      Result:=dbp_Call("MDoc.SingleSending()");
     ELSE
      L_XDoc.XDocJrn_Mark(curXDocType, curXDocKind, curXDoc, L_XDoc.action_Sent);
      Result:="";
     END;
    ELSIF Action = bp_CheckStatus THEN
     RT:=rt_Stop;
     IF MDoc.Status # L_MDoc.st_Passed THEN
      Result:="㬥  ஢";
     ELSE
      Result:="";
     END;
    ELSIF Action = bp_CheckPrinted THEN
     RT:=rt_Stop;
     IF ~L_XDoc.XDocIsPrinted(curXDocType, curXDocKind, curXDoc) THEN
      Result:="㬥  ⯥⠭";
     ELSE
      Result:="";
     END;
    ELSIF Action = bp_CheckVerifiedCC THEN
     RT:=rt_Stop;
     IF ~L_XDoc.XDocIsVerifiedCC(curXDocType, curXDocKind, curXDoc) THEN
      Result:=" ⢥ত  㬥";
     ELSE
      Result:="";
     END;
    END; (* IF Action ... *)
   END; (* IF wRefDoc ... *)
  ELSIF curXDocType = L_XDoc.xdt_PDoc THEN
   IF Action = bp_Send THEN
    IF ~dbp_DEBUG THEN
     Result:=dbp_Call("PDoc.SingleSending()");
    ELSE
     L_XDoc.XDocJrn_Mark(curXDocType, curXDocKind, curXDoc, L_XDoc.action_Sent);
     Result:="";
    END;
   ELSE
    Result:=": " + "???";
   END;
  ELSIF curXDocType = L_XDoc.xdt_ODoc THEN
   IF Action = bp_Send THEN
    IF ~dbp_DEBUG THEN
     Result:=dbp_Call("ODocP.Send(0)");
    ELSE
     L_XDoc.XDocJrn_Mark(curXDocType, curXDocKind, curXDoc, L_XDoc.action_Sent);
     Result:="";
    END;
   ELSE
    Result:=": " + "???";
   END;
  ELSIF curXDocType = L_XDoc.xdt_Contract THEN
   IF Action = bp_Send THEN
    IF ~dbp_DEBUG THEN
     Result:=dbp_Call("O_Cntr.Send()");
    ELSE
(*      ୠ
     L_XDoc.XDocJrn_Mark(curXDocType, curXDocKind, curXDoc, L_XDoc.action_Sent);
*)
     Result:="";
    END;
   ELSE
    Result:=": " + "???";
   END;
  ELSE
   Result:=" 㬥  㦨";
  END; (* IF curXDocType ... *)
  IF !Result THEN
   dbp_AddToProtocol(Action, curXDocId,     "", RT);
  ELSIF Result # rs_EmptyOption THEN
   dbp_AddToProtocol(Action, curXDocId, Result, RT);
  END; (* IF !Result ... *)
  RESTORE(^(L_XDoc.Ref_FileName(curXDocType)));
 END {dbp_Do};

 PRIVATE PROCEDURE 㧪(curXDocId : L_XDoc.tXDocId;
                              bpSelector: tBPSelector);
  VAR
   parentXDocId: L_XDoc.tXDocId;
   sendParent  : SCAL[2];
 BEGIN
  dbp_Do(curXDocId, bp_CheckStatus,     rdc_Itself);
  dbp_Do(curXDocId, bp_MakeDone,        rdc_Itself);
  dbp_Do(curXDocId, bp_CheckVerifiedCC, rdc_Itself);
  IF bpSelector = bps_ITN_CopmpleteShipment THEN
   dbp_Do(curXDocId, bp_BuildAddDocs, rdc_Itself);
  ELSE
   L_General.Assert(bpSelector = bps_ITN_Shipment_woVATDocs,
                    "㧪: ⨬ ᥫ 楤");
  END;
  dbp_Do(curXDocId, bp_CheckStatus,  rdc_AllRefs);
  dbp_Do(curXDocId, bp_MakeDone,     rdc_AllRefs);
  parentXDocId:=GetParentDocId(curXDocId);
  sendParent:=0;
  IF ~!parentXDocId THEN
   IF    ~L_XDoc.DoJrnProcByXDocId(parentXDocId, PROCREF(L_XDoc.XDocIsPrinted)) THEN
    dbp_Do(curXDocId, bp_Print, rdc_Parent);
    VerifyCopyCnt();
   END;
   IF ~L_XDoc.DoJrnProcByXDocId(parentXDocId, PROCREF(L_XDoc.XDocIsSent)) THEN
    dbp_Do(curXDocId, bp_CheckVerifiedCC, rdc_Parent);
    sendParent:=1;
   END;
  END;
  dbp_Do(curXDocId, bp_Print,        rdc_ISFOnly);
  VerifyCopyCnt();
  dbp_Do(curXDocId, bp_CheckVerifiedCC, rdc_ISFOnly);
  IF sendParent THEN
   dbp_Do(curXDocId, bp_Send,            rdc_Parent);
  END;
  dbp_Do(curXDocId, bp_Send,         rdc_Itself);
  dbp_Do(curXDocId, bp_Send,         rdc_ISFOnly);
  dbp_Do(curXDocId, bp_PrintCopy,    rdc_Itself);
(*
  04.01.2005 16:06:16 POLAK\San - 0040516
  dbp_Do(curXDocId, bp_PrintCopy,    rdc_Itself);
*)
 END {㧪};

 PRIVATE PROCEDURE ࢨ஢();
 BEGIN
  CALL(_Math.RsmMD());
 END {ࢨ஢};

 PRIVATE PROCEDURE ନ஢();
 BEGIN
  CALL(_Math.BuildMSPByNrd());
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_GoToEdit, L_XDoc.curXDocId(L_XDoc.xdt_MDoc), "")
 END {ନ஢};

 PRIVATE PROCEDURE ஫쐠室쥄室室();
 BEGIN
  CALL(_Math.ChSCI());
 END {஫쐠室쥄室室};

 PRIVATE PROCEDURE dbp_SelectBP(bpList: STRING[]): tBPSelector;
  VAR
   Result: tBPSelector;
 BEGIN
  Result:=0;
  STDFORM(L_StdFrm.sf_Choice("|楤 : %###########################################%",
                             "%L<"+bpList+">I|"),
          "롮 ⠭⭮ 楤",
          ,
          ,
          Result);
  RETURN Result;
 END {dbp_SelectBP};

 PRIVATE PROCEDURE DoBusinessProcedure(curXDocType: L_XDoc.tXDocType);
  VAR
   dbp_Title : STRING[];
   bpSelector: tBPSelector;
 BEGIN
  dbp_Title:="";
  dbp_Protocol:="";
  IF curXDocType = L_XDoc.xdt_MDoc THEN
   L_MDoc.AccessMDoc();
   IF    (MDoc.MDocKind = L_MDoc.md_ITN) |
         (MDoc.MDocKind = L_MDoc.md_IAS) |
         (MDoc.MDocKind = L_MDoc.md_IAP) THEN
    bpSelector:=dbp_SelectBP(bps_ITN_TitlesPool);
    dbp_Title :=L_Str.PoolItem(bps_ITN_TitlesPool, bpSelector);
    IF bpSelector = bps_ITN_CheckSpending THEN
     ஫쐠室쥄室室();
    ELSE
     㧪(L_XDoc.curXDocId(L_XDoc.xdt_MDoc), bpSelector);
    END;
   ELSIF MDoc.MDocKind = L_MDoc.md_Nrd THEN
    bpSelector:=dbp_SelectBP(bps_Nrd_TitlesPool);
    dbp_Title :=L_Str.PoolItem(bps_Nrd_TitlesPool, bpSelector);
    IF    bpSelector = bps_Nrd_Reservation THEN
     ࢨ஢();
    ELSIF bpSelector = bps_Nrd_BuildMSP THEN
     ନ஢();
    END;
   ELSIF MDoc.MDocKind = L_MDoc.md_VhS THEN
    LIKEMENU(Edit, "P_6009 0");
   END;
  END;
  L_General.Assert(~!dbp_Title,
                   " ⥪饣 㬥 ⠭⭠ 楤  ।ᬮ७");
  dbp_Protocol_Show(dbp_Title);
 END {DoBusinessProcedure};

 PUBLIC PROCEDURE DoMDocBusinessProcedure();
 BEGIN
  DoBusinessProcedure(L_XDoc.xdt_MDoc);
 END {DoMDocBusinessProcedure};

 PUBLIC PROCEDURE ProcessAfterAsk();
 BEGIN
  L_General.CallUs(~!L_XDoc.pvs_ActionAfter);
  L_XDoc.ref_XDocId:=L_XDoc.GetCurrentXDocId();
  IF L_Str.IsStrInStr(L_XDoc.pvs_ActionAfter, "()") THEN
   LIKEMENU(CALL, L_XDoc.pvs_ActionAfter);
  ELSE
   LIKEMENU(RunProg, L_XDoc.pvs_ActionAfter);
  END;
 END {ProcessAfterAsk};

 PUBLIC PROCEDURE SetReportWNavigationSurveyWindowTitle();
  VAR
   SurveyWindow: WINDOW;
 BEGIN
  SurveyWindow:=APPLICATION.Get().TopWindow;
  L_General.CallUs(SurveyWindow.Type = WINDOW.Type_Survey);
  SurveyWindow.Title:=SurveyWindow.Title + "[F3]";
 END {SetReportWNavigationSurveyWindowTitle};

 PUBLIC PROCEDURE LinkedXDocsList();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.LinkedXDocsMenu(L_XDoc.GetCurrentXDocId()), "");
 END {LinkedXDocsList};

 PUBLIC PROCEDURE LinkedXDocsList_woDirectLinks();
 BEGIN
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.LinkedXDocsMenu_woDirectLinks(L_XDoc.GetCurrentXDocId()), "");
 END {LinkedXDocsList_woDirectLinks};

 PRIVATE PROCEDURE AccessByPrimaryKeyValue(trgTable: TABLE; Value: STRING[]): SCAL[2];
  VAR
   f          : FIELD;
   i          : NUMERIC[0];
   pkValue,
   PrimaryKey,
   SingleValue: STRING[];
 BEGIN
  PrimaryKey:=L_DBD.GetPrimaryIndex(trgTable.Name);
  pkValue   :="";
  i         :=0;
  FOR_EACH f IN trgTable.Indexes(PrimaryKey).Fields DO
   IF i > 0 THEN
    INC(pkValue, ", ");
   END;
   IF f.Type.Id = TYPESPEC.Id_String THEN
    INC(pkValue, "'" + L_Str.AnyItem(Value, "|", i) + "'");
   ELSE
    SingleValue:=L_Str.AnyItem(Value, "|", i);
    IF !SingleValue THEN
     SingleValue:="EMPTYOF(" + f.Table.Name + "." + f.Name + ")";
    END;
    INC(pkValue,       SingleValue);
   END;
   INC(i);
  END;
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   IF trgTable.Indexes(PrimaryKey).Unique THEN RETURN SEARCH(^(trgTable.Name), ^(PrimaryKey), ^(pkValue));
   ELSE                                        RETURN SELECT(^(trgTable.Name), ^(PrimaryKey), ^(pkValue));
   END;
  EXCEPT
  ON Exc: Exc_Root DO
   RETURN 0;
  END;
 END {AccessByPrimaryKeyValue};

 PRIVATE PROCEDURE srh_AccessRecordBySYSLOG_(): SCAL[2];
  VAR
   trgTable: TABLE;
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF SELECT(SYSLOGD, SYSLOG_, SYSLOG_.SYSLOG_) & LAST(SYSLOGD) THEN
   trgTable:=DATABASE.Get().TableById(SYSLOG_.fiOwn);
   IF ~!SYSLOG_.riOwn THEN
    Result:=SEARCH(^(trgTable.Name), RECORDID, SYSLOG_.riOwn);
   ELSE
    Result:=AccessByPrimaryKeyValue(trgTable, L_SysLog.GetFieldValue_BeforeModification(SYSLOGD.SYSLOG_, SYSLOGD.SYSLOGD));
   END;
  END;
  RETURN Result;
 END {srh_AccessRecordBySYSLOG_};

 PRIVATE PROCEDURE GatherRecordsHistory(VAR List     : STRING[];
                                        VAR asHistory: STRING[];
                                            byAcsObj : SCAL[2]);
  VAR
   i,
   Cnt        : NUMERIC[0];
   curItem    : STRING[];
   curTable   : TABLE;
   curXDocType: L_XDoc.tXDocType;
 BEGIN
  APP.Get().NewPrompt("⮢ ਨ 䨪樨 ᥩ (     Esc!)");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  Cnt      :=0;
  List     :="";
  asHistory:="";
  LAST(SYSLOG_);
  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   WHILE OCCURE(SYSLOG_) & (Cnt < 500) DO
    PROMPT(L_Str.IntStr(Cnt));
    IF srh_AccessRecordBySYSLOG_() THEN
     curTable:=DATABASE.Get().TableById(SYSLOG_.fiOwn);
     TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)]
      curItem:=FLDTOSTR(SYSLOG_.BegDTS, "D.N.y H:M", 0) + " ";
      IF byAcsObj THEN
       INC(curItem, Str.Align(L_Str.CutLongStr(curTable.Description, 48), 48, LEFT) + " ");
      ELSE
       CONFORM(SYSLOG_, AcsObj);
       INC(curItem, Str.Align(Str.Align(AcsObj.FullName, 32, LEFT) + " " + AcsObj.AcsObj + " " + AcsObj.Name, 48, LEFT) + " ");
      END;
      curXDocType:=L_XDoc.GetFileXDT(curTable.Name);
      IF ~!curXDocType THEN
       INC(curItem, L_XDoc.extXDocStr(L_XDoc.curXDocId(curXDocType), L_XDoc.xdast_wDate));
      ELSE
       INC(curItem, Str.Flatten(L_DBD.GetPrimaryIndexValue(curTable.Name)));
      END;
      INC(List, curItem + "|");
      INC(asHistory, SYSLOG_.SYSLOG_ + "|");
     EXCEPT
     END;
     SLEEP(0.01);
     INC(Cnt);
    END;
    PREV(SYSLOG_);
   END; (* WHILE OCCURE(SYSLOG_) ... *)
  EXCEPT
  ON Exc: Exc_TermByUser DO
  END;
 END {GatherRecordsHistory};

 PRIVATE PROCEDURE intShowRecordsHistory(byAcsObj: SCAL[2]);
  VAR
   i        : NUMERIC[0];
   List     : STRING[];
   asHistory: STRING[];
 BEGIN
  GatherRecordsHistory(List, asHistory, byAcsObj);
  i:=L_StdFrm.ShowListAsMenu(List, "  䨪樨 ᥩ ");
  SEARCH(SYSLOG_, SYSLOG_, , L_Str.PoolItem(asHistory, i));
  IF srh_AccessRecordBySYSLOG_() THEN
   L_DBD.extPosToCurRecordOfTable(DATABASE.Get().TableById(SYSLOG_.fiOwn));
  END;
 END {intShowRecordsHistory};

 PUBLIC PROCEDURE ShowRecordsHistory();
 BEGIN
  SETSEL(SYSLOG_, AcsObj, L_General.curUSER);
  intShowRecordsHistory(1);
 END {ShowRecordsHistory};

 PUBLIC PROCEDURE ShowAcsObjRecordsHistory();
 BEGIN
  L_General.SilentAdminOnly();
  ACCESS(AcsObj);
  SETSEL(SYSLOG_, AcsObj, AcsObj.AcsObj);
  intShowRecordsHistory(1);
 END {ShowAcsObjRecordsHistory};

 PUBLIC PROCEDURE ShowFileRecordsHistory();
  VAR
   curTable: TABLE;
 BEGIN
  curTable:=TABLE.Get(L_General.GetCurWinMasterTable());
  SETSEL(SYSLOG_, SYSLOG_1, curTable.Name);
  intShowRecordsHistory(0);
 END {ShowFileRecordsHistory};

 PUBLIC PROCEDURE StandOnCurXDoc();
 BEGIN
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, L_XDoc.GetCurrentXDocId(), "");
 END {StandOnCurXDoc};

 PUBLIC PROCEDURE StandOnXDocByBarCode();
 BEGIN
  L_XDoc.DoByBarCodeWithHint(" 㬥/ꥪ", " ,  ,  ", PROCREF(InitiateByBarCode), 1);
 END {StandOnXDocByBarCode};

 PRIVATE TYPE
  XDSeq_tStatus = SCAL[3];

 PRIVATE CONST
  XDSeq_Amount = 30;

  XDSeq_s_DoIt    = 0;
  XDSeq_s_Already = 1;
  XDSeq_s_NoNeed  = 2;
  XDSeq_s_Pool = "+||x";

 PRIVATE VAR
  XDSeq_XDocId: L_XDoc.tXDocId[XDSeq_Amount+1];
  XDSeq_2Send,
  XDSeq_2MkCp : SCAL[3][XDSeq_Amount+1];

(*
$P{ XDSeq_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ XDSeq_Line:
?, L, ""
@
|############################################################################################################|
}
*)

(*
$P{ XDSeq_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE XDSeq_SignificantAction(trgXDocType: LIKE(XDocJrn.XDocType);
                                           trgXDocKind: LIKE(XDocJrn.XDocKind);
                                           trgAction: LIKE(XDocJrn.Action)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  IF L_General.IsPolakSpecific() THEN
   Result:=0;
   IF    trgXDocType = L_XDoc.xdt_PDoc THEN
    IF trgAction = L_XDoc.action_Sent THEN
     IF    trgXDocKind = L_PDoc.pd_IPP THEN Result:=0;
     ELSIF trgXDocKind = L_PDoc.pd_VPP THEN Result:=1;
     ELSIF trgXDocKind = L_PDoc.pd_IMO THEN Result:=0;
     ELSIF trgXDocKind = L_PDoc.pd_VMO THEN Result:=1;
     ELSIF trgXDocKind = L_PDoc.pd_ITP THEN Result:=1;
     ELSIF trgXDocKind = L_PDoc.pd_VPK THEN Result:=1;
     ELSIF trgXDocKind = L_PDoc.pd_IPK THEN Result:=0;
     END;
    END;
   ELSIF trgXDocType = L_XDoc.xdt_MDoc THEN
    IF    trgAction = L_XDoc.action_Sent THEN
     IF    trgXDocKind = L_MDoc.md_IsS THEN Result:=1;
     ELSIF trgXDocKind = L_MDoc.md_ITN THEN Result:=1;
     ELSIF trgXDocKind = L_MDoc.md_ISF THEN Result:=1;
     ELSIF trgXDocKind = L_MDoc.md_IAU THEN Result:=1;
     ELSIF trgXDocKind = L_MDoc.md_IAS THEN Result:=1;
     ELSIF trgXDocKind = L_MDoc.md_Dvr THEN Result:=0;
     ELSIF trgXDocKind = L_MDoc.md_ISA THEN Result:=1;
     ELSIF trgXDocKind = L_MDoc.md_IAP THEN Result:=1;
     ELSIF trgXDocKind = L_MDoc.md_VAU THEN Result:=1;
     ELSIF trgXDocKind = L_MDoc.md_PIO THEN Result:=1;
     END;
    ELSIF trgAction = L_XDoc.action_PrintCopy THEN
     IF    trgXDocKind = L_MDoc.md_IsS THEN Result:=0;
     ELSIF trgXDocKind = L_MDoc.md_ITN THEN Result:=1;
     ELSIF trgXDocKind = L_MDoc.md_ISF THEN Result:=0;
     ELSIF trgXDocKind = L_MDoc.md_IAS THEN Result:=1;
     ELSIF trgXDocKind = L_MDoc.md_IAU THEN Result:=1;
     ELSIF trgXDocKind = L_MDoc.md_Dvr THEN Result:=0;
     ELSIF trgXDocKind = L_MDoc.md_ISA THEN Result:=0;
     ELSIF trgXDocKind = L_MDoc.md_IAP THEN Result:=1;
     ELSIF trgXDocKind = L_MDoc.md_VAU THEN Result:=1;
     ELSIF trgXDocKind = L_MDoc.md_PIO THEN Result:=1;
     END;
    END;
   ELSIF trgXDocType = L_XDoc.xdt_ODoc THEN
    IF    trgAction = L_XDoc.action_Sent THEN
     IF    trgXDocKind = 81 THEN Result:=1;
     ELSIF trgXDocKind = 82 THEN Result:=1;
     ELSIF trgXDocKind = 83 THEN Result:=1;
     ELSIF trgXDocKind = 26 THEN Result:=1;
     END;
    END;
   ELSIF trgXDocType = L_XDoc.xdt_Contract THEN
    Result:=trgAction = L_XDoc.action_Sent;
   END;
  ELSE
   IF    trgXDocType = L_XDoc.xdt_PDoc THEN
    Result:=trgAction # L_XDoc.action_PrintCopy;
   ELSIF trgXDocType = L_XDoc.xdt_MDoc THEN
    IF trgAction = L_XDoc.action_PrintCopy THEN
     Result:=(trgXDocKind # L_MDoc.md_IsS) & (trgXDocKind # L_MDoc.md_ISF);
    ELSE
     Result:=1;
    END;
   ELSIF trgXDocType = L_XDoc.xdt_ODoc THEN
    Result:=trgAction # L_XDoc.action_PrintCopy;
   ELSIF trgXDocType = L_XDoc.xdt_Contract THEN
    Result:=trgAction # L_XDoc.action_PrintCopy;
   ELSE
    Result:=0;
   END;
  END;
  RETURN Result;
 END {XDSeq_SignificantAction};

 PRIVATE PROCEDURE XDSeq_GetSingle(trgXDocType: L_XDoc.tXDocType;
                                   trgXDocKind: L_XDoc.tXDocKind;
                                   trgXDoc    : L_XDoc.tXDoc;
                                   trgAction  : L_XDoc.tAction): XDSeq_tStatus;
  VAR
   Result: XDSeq_tStatus;
 BEGIN
  IF XDSeq_SignificantAction(trgXDocType, trgXDocKind, trgAction) THEN
   IF trgXDocType = L_XDoc.xdt_Contract THEN
    Result:=XDSeq_s_DoIt;
   ELSE
    IF L_XDoc.JrnHasValidAction(trgXDocType, trgXDocKind, trgXDoc, trgAction) THEN
     Result:=XDSeq_s_Already;
    ELSE
     Result:=XDSeq_s_DoIt;
    END;
   END;
  ELSE
   Result:=XDSeq_s_NoNeed;
  END;
  RETURN Result;
 END {XDSeq_GetSingle};

 PRIVATE PROCEDURE XDSeq_PrepareMsg(upperI: NUMERIC[0]): STRING[];
  CONST
   LineLength = 64;
  VAR
   i     : NUMERIC[0];
   Result: STRING[];
 BEGIN
  Result:=Str.Align("ࠢ   㬥", LineLength, LEFT) + "|" + L_Str.Repeat("-", LineLength) + "|";
  i:=0;
  WHILE ~!XDSeq_XDocId[i] & (i <= upperI) DO
   INC(Result, Str.Align(Str.Align(L_Str.PoolItem(XDSeq_s_Pool, XDSeq_2Send[i]), Str.Length("ࠢ"), CENTRE) + " " +
                         Str.Align(L_Str.PoolItem(XDSeq_s_Pool, XDSeq_2MkCp[i]), Str.Length(" "), CENTRE) + " " +
                         L_XDoc.extXDocStr(XDSeq_XDocId[i], L_XDoc.xdast_wDate),
                         LineLength, LEFT) + "|");
   INC(i);
  END; (* WHILE ~!XDSeq_XDocId[i] *)
  RETURN Result;
 END {XDSeq_PrepareMsg};

 PRIVATE PROCEDURE XDSeq_Put(curXDocId     : L_XDoc.tXDocId;
                             curCopyCnt    : L_XDoc.tCopyCnt;
                             VAR
                              curHint,
                              curMsg : STRING[]);
  VAR
   curXDocType : L_XDoc.tXDocType;
   curXDocKind : L_XDoc.tXDocKind;
   curXDoc     : L_XDoc.tXDoc;
   i           : NUMERIC[0];
 BEGIN
  SETEMPTY(curMsg);
  L_XDoc.DecodeXDocId(curXDocId, curXDocType, curXDocKind, curXDoc);
  L_XDoc.PositionOnXDoc(curXDocId);
  IF XDocTypeMustBeVerified(curXDocType) THEN
   IF ~L_XDoc.XDocIsVerifiedCC(curXDocType, curXDocKind, curXDoc) THEN
    TRY [TRANSACTION(TRANSACTION_SLAVE)]
     VerifyCC(curXDocId, curCopyCnt, curMsg);
    EXCEPT
    END; (* TRY *)
   END;
  END;
  i:=0;
  WHILE ~!XDSeq_XDocId[i] DO
   IF XDSeq_XDocId[i] = curXDocId THEN
    L_General.Error("㬥 㦥  㯯 (" + L_XDoc.extXDocStr(curXDocId, L_XDoc.xdast_wDate) + ")");
   END;
   INC(i);
   IF i = XDSeq_Amount THEN
    L_General.Error("⨣ । ࠧ ("+L_Str.IntStr(XDSeq_Amount)+") 㯯 㬥⮢");
   END;
  END;
  TRY
   XDSeq_XDocId[i]:=curXDocId;
   XDSeq_2Send [i]:=XDSeq_GetSingle(curXDocType, curXDocKind, curXDoc, L_XDoc.action_Sent);
   XDSeq_2MkCp [i]:=XDSeq_GetSingle(curXDocType, curXDocKind, curXDoc, L_XDoc.action_PrintCopy);
   IF (XDSeq_2Send[i] = XDSeq_s_NoNeed) & (XDSeq_2MkCp[i] = XDSeq_s_NoNeed) THEN
    L_General.Error(L_XDoc.extXDocStr(XDSeq_XDocId[i], L_XDoc.xdast_wDate) + ": " + " 㬥⮬   ⨯ 樨");
   END;
  EXCEPT
  ON Exc:Exc_Root DO
   SETEMPTY(XDSeq_XDocId[i]);
   RAISE();
  END;
  curHint:=XDSeq_PrepareMsg(i);
 END {XDSeq_Put};

 PRIVATE PROCEDURE XDSeq_ShowTooltip();
 BEGIN
  TOOLTIP(XDSeq_PrepareMsg(MAXOF(NUMERIC[0])), 0, 0);
 END {XDSeq_ShowTooltip};

 PRIVATE PROCEDURE XDSeq_Do(i: NUMERIC[0]; Action: tActionType; VAR What: XDSeq_tStatus[]);
 BEGIN
  IF What[i] = XDSeq_s_DoIt THEN
   TRY [TRANSACTION(TRANSACTION_SLAVE)]
    dbp_Do(XDSeq_XDocId[i], Action, rdc_Itself);
    What[i]:=XDSeq_s_Already;
    XDSeq_ShowTooltip();
   EXCEPT
   ON Exc:Exc_Root DO
    (* nothing *)
   END; (* TRY *)
  END;
 END {XDSeq_Do};

 PUBLIC PROCEDURE XDSeq();
  CONST
   bpId   = "XDSeq";
   bpName = "믮 ᫥⥫쭮 ⨯ 権  㯯 㬥⮢";
  VAR
   Msg   : STRING[];
   i     : NUMERIC[0];
   curStr: STRING[];
 BEGIN
  SETEMPTY(XDSeq_XDocId);
  L_XDoc.DoByBarCode(bpName, PROCREF(XDSeq_Put), 1);
  Msg:=XDSeq_PrepareMsg(MAXOF(i));

  IF ~!XDSeq_XDocId[0] THEN
   LOOP
    TRY
     L_StdFrm.Question(bpName + L_StdFrm.THR("⠢ 㯯 㬥⮢") + Msg);
     EXIT;
    EXCEPT
    ON Exc: Exc_Root DO
     IF L_StdFrm.RedAlternative("⢨⥫쭮 ⬥ 믮?") THEN
      HALT();
     END;
    END; (* TRY *)
   END; (* LOOP *)
   XDSeq_ShowTooltip();
   dbp_Protocol:="";
   i:=0;
   WHILE ~!XDSeq_XDocId[i] DO
    XDSeq_Do(i, bp_Send,      XDSeq_2Send);
    XDSeq_Do(i, bp_PrintCopy, XDSeq_2MkCp);
    INC(i);
   END; (* WHILE ~!XDSeq_XDocId[i] *)
   OPENREP(R, L_General.rfn_byConnection(bpId), Create);
   MAKEPART(R, XDSeq_Top, bpId, bpName);
   i:=0;
   LOOP
    curStr:=L_Str.PoolItem(dbp_Protocol, i);
    IF ~!curStr THEN
     MAKEPART(R, XDSeq_Line, curStr);
    ELSE
     EXIT;
    END;
    INC(i);
   END; (* LOOP  *)
   MAKEPART(R, XDSeq_Bot);
   CLOSEREP(R);
   L_General.SurveyLastReport();
  END; (* IF ~!Msg *)
 END {XDSeq};

BEGIN
 L_Events.ExecuteHandler();
END.
