(*
%Copyright   (c) Polak
%Author      17.05.2010 14:05:23 POLAK\MLB
%Purpose
%Type        operation
%Specific    SYS
%Modified    24.09.2014 16:12:07 LDA
%Environment
*)

 MODULE XDocFile [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_Events, L_General, L_StdFrm, L_WDO, L_XDoc, Shell, Str, L_Str, L_DBD,
        FIO, L_FIO, L_SES, L_ODoc, L_ACL, L_kn, L_OwnData;

 PRIVATE CONST
  sesvi_DefXDFSaveDir = "DefaultXDFSaveDir";

 PRIVATE PROCEDURE CheckOwnerXDocFile(Message: STRING[]);
  VAR
   ThisIsOwnerXDocFile: SCAL[2];
   _XDocType          : LIKE(XDocJrn.XDocType);
   _XDocKind          : LIKE(XDocJrn.XDocKind);
   _XDoc              : LIKE(XDocJrn.XDoc);
 BEGIN
  ThisIsOwnerXDocFile:=1;
  L_XDoc.DecodeXDocId(L_XDoc.curXDocId(L_XDoc.xdt_XDocFile), _XDocType, _XDocKind, _XDoc);
  SELECT(XDocJrn, XDocJrn, , _XDocType, _XDocKind, _XDoc);
  WHILE OCCURE(XDocJrn) & ThisIsOwnerXDocFile DO
   IF XDocJrn.AcsObj # L_General.curUSER THEN
    ThisIsOwnerXDocFile:=0;
   END;
   NEXT(XDocJrn);
  END; (* WHILE OCCURE(XDocJrn) ... *)
  IF ThisIsOwnerXDocFile THEN
   L_StdFrm.Choice(Message + L_StdFrm.HR() + "  믮 , ⮬   宧鶴 !");
  ELSE
   L_General.Assert_wReferToAdmin(0, Message);
  END;
 END {CheckOwnerXDocFile};

 PRIVATE PROCEDURE GetParentXDocType(): L_XDoc.tXDocType;
  VAR
   ParentMaster: STRING[];
 BEGIN
  ParentMaster:=GE_WZD_MASTER(RTI.Get().CurWindow.ParentZone.Window.OriginalName,
                              RTI.Get().CurWindow.ParentZone.Number);
  TABLE.Get(ParentMaster).AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(^ParentMaster), " ⠭ ꥪ");
  RETURN L_XDoc.GetFileXDT(ParentMaster);
 END {GetParentXDocType};

 PRIVATE PROCEDURE Add_xdfk_2List(    trgTable : TABLE;
                                  VAR List2Show,
                                      List     : STRING[]);
 BEGIN
  IF    trgTable.Name = "ODoc" THEN
   CONFORM(ODoc, ODocKind);
   IF L_kn.Is(ODoc.Date, L_ODoc.erkn_RAccid) THEN
    SEARCH(XDFKind, XDFKind, , L_XDoc.xdfk_SchemaRA);
    List2Show:=List2Show + XDFKind.XDFKind + " " + XDFKind.Name + "|";
    List     :=List      + XDFKind.XDFKind + "|";
   END;
  END;
 END {Add_xdfk_2List};

 PUBLIC PROCEDURE AttachFile();
  VAR
   cur_iri     : L_General.tInternalRecordId;
   curTable    : TABLE;
   D           : DROPTARGETDIALOG;
   DroppedFile : DROPPEDFILE;
   StoreFolder,
   defaultPath,
   srcFileName : STRING[];
   li,
   i           : NUMERIC[0];
   xdfk        : L_XDoc.tXDFKind;
   xdfkList,
   List        : STRING[];
   cfd         : CHOOSEFILEDIALOG;
 BEGIN
  SETEMPTY(List, xdfkList);
  cur_iri:=L_XDoc.GetCurrent_iri();
  curTable:=DATABASE.Get().TableById(L_General.iri_fi(cur_iri));

  Add_xdfk_2List(curTable, List, xdfkList);
  SELECT(XDFKind, XDFKind);
  SRCINSEL(XDFKind, GE, , L_XDoc.xdfk_UserDefined);
  WHILE OCCURE(XDFKind) DO
   List    :=List     + XDFKind.XDFKind + " " + XDFKind.Name + "|";
   xdfkList:=xdfkList + XDFKind.XDFKind + "|";
   NEXT(XDFKind);
  END; (* WHILE OCCURE(XDFKind) ... *)
  li:=L_StdFrm.ShowListAsMenu(List, "롮  ਪ९ 䠩");

  xdfk:=L_Str.PoolItem(xdfkList, li);
  L_General.CallUs(SEARCH(XDFKind, XDFKind, xdfk));

  SEARCH((curTable.Name), RECORDID, , L_General.iri_ri(cur_iri));
  IF L_XDoc.xdf_TypeMustBeUnique(xdfk) & L_XDoc.xdf_StandOnActualBy_iri(cur_iri, xdfk) THEN
   CONFORM(XDocFile, XDFKind);
   L_General.Error("㬥 ⨯ '" + XDFKind.Name + "'   㭨.|⠢ 饭.");
  END;
  IF XDFKind.SrcType = L_XDoc.xdft_Copy THEN
   D              :=DROPTARGETDIALOG.Create();
   D.MayMoveOnDrop:=1;
   D.MayLinkOnDrop:=1;
   D.Title        :="ਪ९ 䠩 (" + XDFKind.XDFKind + " " + XDFKind.Name + ")";
   IF D.Deal() THEN
    StoreFolder:=L_XDoc.GetXDocCopiesStoreFolder();
    L_FIO.MakeSubDirs(StoreFolder);
    i:=0;
    IF L_XDoc.xdf_TypeMustBeUnique(xdfk) & (D.DroppedFiles.Count > 1) THEN
     CONFORM(XDocFile, XDFKind);
     L_General.Error("  '" + XDFKind.Name + "'   㭨." +
                     "|饭 ਪ९ ᪮쪮 䠩.");
    END;
    WHILE i < D.DroppedFiles.Count DO
     DroppedFile:=D.DroppedFiles(i);
     (* ஢ઠ (६,  ।  UTF)  饭 ᨬ   䠩 . 0086328 *)
     TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
      srcFileName:=DroppedFile.Path;
     EXCEPT
     ON Exc: Exc_Root DO
      L_General.Error(Exc.MsgOriginalText);
     END;
     L_XDoc.AttachFile2iri(cur_iri, xdfk, srcFileName, "", DroppedFile.DropEffect, L_XDoc.xdfSt_Passed, "");
     INC(i);
    END;
    SE_WZD_POSITION(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number, XDocFile);
   END; (* IF D.Deal()...*)
  ELSE
   SETEMPTY(defaultPath);
   IF curTable.Name = "ODoc" THEN
    CONFORM(ODoc, ODocKind);
    defaultPath:=ODocKind.DefPath;
   END;
   IF !defaultPath & ~!XDFKind.DefPath THEN
    defaultPath:=XDFKind.DefPath;
   END;
   cfd:=CHOOSEFILEDIALOG.Create(FIO.BuildPath("*.*", , defaultPath));
   cfd.Title:="ਪ९ 䠩 (" + XDFKind.XDFKind + " " + XDFKind.Name + ")";
   srcFileName:=cfd.Deal();
   IF ~!srcFileName THEN
    IF    XDFKind.SrcType = L_XDoc.xdft_Source THEN
     L_XDoc.AttachFile2iri(cur_iri, xdfk, srcFileName, "", L_XDoc.FO_Move, L_XDoc.xdfSt_Prepared, "");
    ELSIF XDFKind.SrcType = L_XDoc.xdft_SourceLink THEN
     L_XDoc.AttachFile2iri(cur_iri, xdfk, srcFileName, "", L_XDoc.FO_Copy, L_XDoc.xdfSt_Prepared, "");
    ELSE
     L_General.CallUs(0);
    END;
    SE_WZD_POSITION(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number, XDocFile);
    LIKEMENU(Edit, "@");
   END;
  END;
 END {AttachFile};

 PRIVATE PROCEDURE CopyCurXDocFileTo(dstFullFN: STRING[]);
  VAR
   srcFullFN: STRING[];
 BEGIN
  srcFullFN:=L_XDoc.xdf_GetSourceFileFullName();
  L_General.Assert(FIO.Exists(srcFullFN), "  䠩|" +  srcFullFN + "|᫨   㤠﫨 ,   ࠧࠡ稪.");

  IF FIO.Exists(dstFullFN) THEN
   FIO.SetAttr(dstFullFN, , 0); (* ReadOnly = 0 *)
   FIO.Erase(dstFullFN);
  END;

  L_FIO.ExactFileCopy(srcFullFN, dstFullFN);
 END {CopyCurXDocFileTo};

 PRIVATE PROCEDURE ReplaceIllegalCharacter(FileName: STRING[]): STRING[];
  CONST
   IllegalChars = '\/:*?"<>|';
  VAR
   i     : NUMERIC[0];
   Char,
   Result: STRING[];
 BEGIN
  Result:=FileName;
  i:=0;
  LOOP
   Char:=L_Str.Char(IllegalChars, i);
   IF !Char THEN
    EXIT;
   END;
   Result:=Str.Replace(Result, Char, "_");
   INC(i);
  END; (* LOOP *)
  RETURN Result;
 END {ReplaceIllegalCharacter};

 PRIVATE PROCEDURE GetTmpXDocFileName(): STRING[];
  VAR
   dstExt,
   Result: STRING[];
 BEGIN
(*0091611*)
  dstExt:=L_FIO.effp_FileExt(XDocFile.Name);
  IF L_Str.IsEqStrI(dstExt, "WEBSITE") THEN
   dstExt:="URL";
  END;
  RETURN FIO.BuildPath(XDocFile.XDocFile + "_" + ReplaceIllegalCharacter(L_FIO.effp_FileName_woExt(XDocFile.Name)), dstExt);
 END {GetTmpXDocFileName};

 PRIVATE PROCEDURE CopyCurXDocFileToTempDir(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=L_FIO.tf_GetFullPath(GetTmpXDocFileName(), "");
  CopyCurXDocFileTo(Result);
  RETURN Result;
 END {CopyCurXDocFileToTempDir};

 PUBLIC PROCEDURE ViewFile();
  VAR
   FullFNInTempDir: STRING[];
 BEGIN
  ACCESS(XDocFile);
  IF XDocFile.Status = L_XDoc.xdfSt_Canceled THEN
   CheckOwnerXDocFile("ᬮ 㫨஢ 䠩.");
  END;

  FullFNInTempDir:=CopyCurXDocFileToTempDir();
  FIO.SetAttr(FullFNInTempDir, , 1); (* Read only  = 1 *)
  Shell.Execute("open", FullFNInTempDir);
 END {ViewFile};

 PUBLIC PROCEDURE SaveFileAs();
  VAR
   ChooseFD   : CHOOSEFILEDIALOG;
   DefaultDir,
   ChoosenDir,
   dstFileName: STRING[];
 BEGIN
  ACCESS(XDocFile);
  IF XDocFile.Status = L_XDoc.xdfSt_Canceled THEN
   CheckOwnerXDocFile("㧪 㫨஢ 䠩.");
  END;
  IF ~L_SES.GetValue(L_SES.sit_WindowsProfile, sesvi_DefXDFSaveDir, DefaultDir) |
     ~FIO.DirExists(DefaultDir) THEN
   SETEMPTY(DefaultDir);
  END;
  ChooseFD                     :=CHOOSEFILEDIALOG.Create(FIO.MakePath("*.*", , DefaultDir));
  ChooseFD.FilesAreAcceptable  :=0;
  ChooseFD.FoldersAreAcceptable:=1;
  ChoosenDir:=ChooseFD.Deal();
  IF ~!ChoosenDir THEN
   dstFileName:=GetTmpXDocFileName();
   CopyCurXDocFileTo(FIO.BuildPath(dstFileName, , ChoosenDir));
   L_SES.PutValueAtSlaveTrn(L_SES.sit_WindowsProfile, sesvi_DefXDFSaveDir, ChoosenDir);
   L_StdFrm.Inform(" ࠭  ⠫ |'" + ChoosenDir + "'|" + "  '" + dstFileName + "'");
  END;
 END {SaveFileAs};

 PUBLIC PROCEDURE EditFile();
  CONST
   Maximized = 3;
  VAR
   FullFNInTempDir,
   IntermediateFN : STRING[];
   OldStamp,
   NewStamp       : TIMESTAMP;
   sysTimeBefore  : TIMESTAMP;
 BEGIN
  ACCESS(XDocFile);
  L_General.Assert(XDocFile.Status # L_XDoc.xdfSt_Canceled, " 㯭  㫨஢ ᥩ");

  CONFORM(XDocFile, XDFKind);

  IF XDFKind.SrcType = L_XDoc.xdft_Copy THEN
   L_General.Assert_wReferToAdmin(0,"஢ ਪ९  㬥 䠩.");
   FullFNInTempDir:=CopyCurXDocFileToTempDir();
 
   OldStamp:=L_FIO.GetUTCFileLastModifiedDTS(FullFNInTempDir);
 
   FIO.SetAttr(FullFNInTempDir, , 0); (* Read only  = 0 *)
   sysTimeBefore:=SYSTIMESTAMP();
   Shell.Execute("open", FullFNInTempDir, , , Maximized, 1);
   IntermediateFN:=L_FIO.tf_GetFullPath(CreateUUID(0), "");

   TRY [TERM_BY_USER(TERM_BY_USER_IGNORE)]
    LOOP
     IF (SYSTIMESTAMP() - sysTimeBefore) < 7/24/60/60 THEN
      PROMPT("  祭 ᪮쪨 ᥪ㭤 ...");
      SLEEP(0.5);
     ELSE
      TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
       FIO.RenMov(FullFNInTempDir, , IntermediateFN , );
       FIO.RenMov(IntermediateFN , , FullFNInTempDir, );
       EXIT;
      EXCEPT
      ON Exc: Exc_RunTime DO
       PROMPT("㬥 㯥  ६饭. ,    襭");
       SLEEP(0.5);
      END;
     END;
    END; (* LOOP *)
   EXCEPT
   END; (* TRY *)

   NewStamp:=L_FIO.GetUTCFileLastModifiedDTS(FullFNInTempDir);
 
   IF OldStamp # NewStamp THEN
    L_XDoc.xdf_Cancel();
    L_XDoc.AttachFile2iri(L_General.iri_Pack(XDocFile.fiOwn, XDocFile.riOwn), XDocFile.XDFKind,
                          FullFNInTempDir, XDocFile.Name, L_XDoc.FO_Move, L_XDoc.xdfSt_Passed, "");
   ELSE
    TOOLTIP("  䠩  㦥");
   END;
  ELSE
   IF XDocFile.Status = L_XDoc.xdfSt_Prepared THEN
    TRY [ABORT_AFTER(AA_ON)]
     REPLACE(XDocFile); (* ஢ઠ 稩*)
    EXCEPT
    END;
    Shell.Execute("open", L_XDoc.xdf_GetFullFileName(), , , Maximized, 1);
   ELSE
    L_General.Error(" ਪ९ 䠩  室   ﭨ '஢'.  䠩 饭");
   END;
  END;
 END {EditFile};

 PUBLIC PROCEDURE OpenFile();
 BEGIN
  ACCESS(XDocFile);
  CONFORM(XDocFile, XDFKind);
  IF ((XDFKind.SrcType = L_XDoc.xdft_Source) | (XDFKind.SrcType = L_XDoc.xdft_SourceLink)) & (XDocFile.Status = L_XDoc.xdfSt_Prepared) THEN
   TOOLTIP("⨥ 䠩  ");
   EditFile();
  ELSE
   ViewFile();
  END;
 END {OpenFile};

 PUBLIC PROCEDURE ShowInfo();
  CONST
   URLMarker = "URL=";
  VAR
   sffn,
   Msg,
   S    : STRING[];
 BEGIN
  ACCESS(XDocFile);
  sffn:=L_XDoc.xdf_GetSourceFileFullName();
  Msg:=L_StdFrm.THR("饭 䠩") + L_Str.CRLF + sffn + L_Str.CRLF;
  IF Str.Cap(L_FIO.effp_FileExt(sffn)) = "URL" THEN
   FIO.Open(grff, sffn, "", Input);
   FIO.SetCP(grff, FIO.CP_WindowsRussian);
   LOOP
    IF ~FIO.RdStr(grff, S) THEN
     EXIT;
    ELSIF Str.Pos(S, URLMarker) = 0 THEN
     INC(Msg, L_Str.CRLF + L_StdFrm.THR("ন 뫪") +
              L_Str.CRLF + Str.Slice(S, Str.Length(URLMarker), 99999) + L_Str.CRLF);
     EXIT;
    END;
   END; (* LOOP *)
   FIO.Close(grff);
  END;
  L_StdFrm.Inform(Msg);
 END {ShowInfo};

 PRIVATE PROCEDURE XDocFile_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "XDocFE");
  L_WDO.iField       (1, "XDocFile.Status").Format:=L_XDoc.xdfSt_ShortPool;
 END {XDocFile_OnInitializeWindow};

 PRIVATE PROCEDURE XDocFE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterEdit, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["XDocFile.Name", "XDocFile.Status", "XDocFile.XDFKind"]);
  L_WDO.iUnmodifiable(0, ["XDocFile.FileSize", "v_OwnName", "XDocFile.XDocFile"]);
  L_WDO.iMayBeEmpty  (0, ["XDocFile.Note"]);
  L_WDO.iField       (0, "XDocFile.Status").Format:=L_XDoc.xdfSt_Pool;
 END {XDocFE_OnInitializeWindow};

 PRIVATE PROCEDURE XDocFE_0_OnReposition();
  VAR
   Fields: FORMFIELDS;
 BEGIN
  Fields:=RTI.Get().CurWindow.Zones(0).Fields;
  Fields("XDocFile.XDFKind").Modifiable:=~L_XDoc.IsSystemXDFKind(XDocFile.XDFKind);
  Fields("v_OwnName").Value:=L_XDoc.Get_iri_Description(XDocFile.fiOwn, XDocFile.riOwn);
  CONFORM(XDocFile, XDFKind);
  IF XDFKind.SrcType = L_XDoc.xdft_Copy THEN
   Fields("XDocFile.Name").First:=1;
  ELSE
   Fields("XDocFile.Status").First:=1;
  END;
 END {XDocFE_0_OnReposition};

 PRIVATE PROCEDURE XDocFile_Status_OnSuccessfulChange();
  VAR
   curXDocType : LIKE(XDocJrn.XDocType);
   curXDocKind : LIKE(XDocJrn.XDocKind);
   curXDoc     : LIKE(XDocJrn.XDoc);
   srcFileName : STRING[];
   srcEntry    : FOLDERENTRY;
 BEGIN
  IF (GE_PVALUE() = L_XDoc.xdfSt_Canceled) | (XDocFile.Status = L_XDoc.xdfSt_Canceled) THEN
   L_XDoc.DecodeXDocId(L_XDoc.curXDocId(L_XDoc.xdt_XDocFile), curXDocType, curXDocKind, curXDoc);
   IF (GE_PVALUE() = L_XDoc.xdfSt_Canceled) &
      L_XDoc.XDocSomeTimeWas(curXDocType, curXDocKind, curXDoc, L_XDoc.action_AutoEdit) THEN
    L_General.Error("⬥ 㫨஢ 饭.     䠩");
   END;
   IF    GE_PVALUE() = L_XDoc.xdfSt_Canceled THEN
    CheckOwnerXDocFile("  ⬥ 㫨஢ 㬥?");
   ELSIF XDocFile.Status = L_XDoc.xdfSt_Canceled THEN
    CheckOwnerXDocFile("  㫨஢ 㬥?");
   END;
  END;
  IF XDocFile.Status = L_XDoc.xdfSt_Passed THEN
   srcFileName:=L_XDoc.xdf_GetSourceFileFullName();
   TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
    srcEntry:=FOLDERENTRY.Create(srcFileName);
   EXCEPT
   ON Exc:Exc_Root DO
    L_General.Error("  䠩 " + srcFileName +
                    L_StdFrm.HR() +
                    "᫨   㤠﫨 ,   ࠧࠡ稪.");
   END; (* TRY *)
   XDocFile.FileDTS :=srcEntry.UTCLastModified;
   XDocFile.FileSize:=srcEntry.Size;
   REPLACE(XDocFile);
  END;
 END {XDocFile_Status_OnSuccessfulChange};

 PRIVATE PROCEDURE XDocFile_Name_OnSuccessfulChange();
  VAR
   prvName, prvExt,
   newName, newExt,
   newPath          : STRING[];
 BEGIN
  FIO.SplitPath(GE_PVALUE(),   prvName, prvExt);
  FIO.SplitPath(XDocFile.Name, newName, newExt, newPath);
  L_General.Assert(!newPath, " ᫥ 㪠뢠   䠩. 쪮 ");
  L_General.Assert(newExt = prvExt, " ᫥  ७ 䠩");
  CheckOwnerXDocFile("  䠩");
 END {XDocFile_Name_OnSuccessfulChange};

 PRIVATE PROCEDURE XDocFile_XDFKind_OnSuccessfulChange();
  VAR
   newSrcType: LIKE(XDFKind.SrcType);
 BEGIN
  IF ~!GE_PVALUE() THEN
   SEARCH(XDFKind, XDFKind, , XDocFile.XDFKind);
   newSrcType:=XDFKind.SrcType;
   SEARCH(XDFKind, XDFKind, , GE_PVALUE());
   IF newSrcType # XDFKind.SrcType THEN
    L_General.Error("   㣮 ⨯ 䠩");
   END;
  END;
 END {XDocFile_XDFKind_OnSuccessfulChange};

 PRIVATE PROCEDURE XDocFile_OnConformToWindow();
  VAR
   iri: L_General.tInternalRecordId;
 BEGIN
  iri:=L_XDoc.GetCurrent_iri();
  SELECT(XDocFile, iriName, , L_General.iri_fi(iri), L_General.iri_ri(iri));
  SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, XDocFile);
  RTI.Get().TrgWindow.Zones(0).Fields("v_OwnName").Value:=L_XDoc.Get_iri_Description(L_General.iri_fi(iri), L_General.iri_ri(iri));
 END {XDocFile_OnConformToWindow};

 PRIVATE PROCEDURE XDocFile_OnBeforeEdit();
 BEGIN
  L_XDoc.Jrn_Start(L_XDoc.curXDocId(L_XDoc.xdt_XDocFile), L_XDoc.action_Edit);
 END {XDocFile_OnBeforeEdit};

 PRIVATE PROCEDURE XDocFile_OnAfterEdit();
 BEGIN
  L_XDoc.Jrn_Stop(L_XDoc.curXDocId(L_XDoc.xdt_XDocFile));
 END {XDocFile_OnAfterEdit};

 PUBLIC PROCEDURE ViewXDocFiles();
 BEGIN
  L_XDoc.LaunchViewingServiceFile("XDocFile");
 END {ViewXDocFiles};

 PRIVATE PROCEDURE XDFKind_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnAfterInsert, L_WDO.e_OnBeforeDelete, L_WDO.e_OnOpenZone]);
  L_WDO.iField       (1, "XDFKind.SrcType").Format:=L_XDoc.xdft_Pool;
  L_WDO.iProgs       (1, "XDocFile");
  L_WDO.iScsChange   (1, ["XDFKind.DefPath"]);
  RTI.Get().CurWindow.Zones(1).FLevProg:="XDocFile";
 END {XDFKind_OnInitializeWindow};

(*
$P{ DPC_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, ""
?, L, ""
XDFKind.XDFKind, L, ""
XDFKind.Name, L, ""
@
########################################################################################### ########## #####
=#####======================================================================================================
|                        ⮪ 訡  ⪥  '  㬮砭'                        |
| : ######################################################################################################|
|: ######################################################################################################|
|  ਪ९ 䠩 ### ################################                                        |
|----------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ DPC_Line:
?, L, ""
@
|##########################################################################################################|
}
*)

(*
$P{ DPC_Bot:
@
=(c) Polak==================================================================================================
}
*)

 PRIVATE PROCEDURE XDFKind_DefPath_OnSuccessfulChange();
  CONST
   RepName = "DPCEr";
  VAR
   urlFullFN,
   dstFullFN,
   srcFullFN,
   srcFN,
   dstFolder,
   srcFolder: STRING[];
   HasError : SCAL[2];
 BEGIN
  IF XDFKind.SrcType = L_XDoc.xdft_SourceLink THEN
   IF SELECT(XDocFile, XDFKind, XDFKind.XDFKind) THEN
    L_General.AdminOnly();
    HasError:=0;
    dstFolder:=XDFKind.DefPath;
    L_StdFrm.Question("室 䠩  ६饭  '" + dstFolder + "'");
    IF ~FIO.DirExists(dstFolder) THEN
     L_StdFrm.Question("⠫ " + dstFolder + "  .|| ⠫?");
     L_FIO.MakeSubDirs(dstFolder);
    END;
    WHILE OCCURE(XDocFile) DO
     PROMPT(XDocFile.Name);
     urlFullFN:=L_XDoc.xdf_GetFullFileName();
     srcFullFN:=L_XDoc.xdf_GetSourceFileFullName();
     FIO.SplitPath(srcFullFN, srcFN, , srcFolder);
     dstFullFN:=FIO.BuildPath(srcFN, , dstFolder);
     IF FIO.Exists(dstFullFN) THEN
      dstFullFN:=L_XDoc.xdf_CreateSourceFile(dstFullFN, urlFullFN);
      L_General.CallUs(L_XDoc.xdf_GetSourceFileFullName() = dstFullFN);
     ELSE
      IF ~FIO.Exists(srcFullFN) THEN
       IF ~HasError THEN
        OPENREP(R, L_General.NameConnection(RepName), Create);
        MAKEPART(R, DPC_Top, RepName, srcFolder, dstFolder);
       END;
       HasError:=1;
       MAKEPART(R, DPC_Line, "室 䠩 '" + srcFullFN + "'  ");
      ELSE
       TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF), MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
        FIO.RenMov(srcFullFN, , dstFullFN, );
       EXCEPT
       ON Exc: Exc_Root DO
        L_General.Error(Exc.Description);
       END;
       dstFullFN:=L_XDoc.xdf_CreateSourceFile(dstFullFN, urlFullFN);
       L_General.CallUs(L_XDoc.xdf_GetSourceFileFullName() = dstFullFN);
      END;
     END;
     NEXT(XDocFile);
    END; (* WHILE OCCURE(XDocFile) ... *)
    IF HasError THEN
     MAKEPART(R, DPC_Bot);
     L_General.Error("  ६饭 室 䠩 ந諨 訡" + "|" +
                     "  訡: '" + L_General.NameConnection(RepName) + "'");
    END;
   END; (* IF SELECT(XDocFile, XDFKind, XDFKind.XDFKind) ... *)
  END; (* IF XDFKind.SrcType = ... *)
 END {XDFKind_DefPath_OnSuccessfulChange};

 PRIVATE PROCEDURE XDFKind_1_OnZoneOpen();
 BEGIN
  IF ~!RTI.Get().CurWindow.AskSourceField THEN
   RTI.Get().CurZone.PermanentFilter:="XDFKind.XDFKind >= " + L_Str.IntStr(L_XDoc.xdfk_UserDefined);
  END;
 END {XDFKind_1_OnZoneOpen};

 PRIVATE PROCEDURE XDFKind_CheckRightsModif();
 BEGIN
  L_General.Assert(~L_XDoc.IsSystemXDFKind(XDFKind.XDFKind),
                   " " + XDFKind.XDFKind + " १ࢨ஢ ⮏");
 END {XDFKind_CheckRightsModif};

 PRIVATE PROCEDURE XDFKind_OnBeforeEdit();
 BEGIN
  XDFKind_CheckRightsModif();
 END {XDFKind_OnBeforeEdit};

 PRIVATE PROCEDURE XDFKind_OnBeforeDelete();
 BEGIN
  XDFKind_CheckRightsModif();
 END {XDFKind_OnBeforeDelete};

 PRIVATE PROCEDURE XDFKind_OnAfterInsert();
 BEGIN
  XDFKind_CheckRightsModif();
 END {XDFKind_OnAfterInsert};

BEGIN
 L_Events.ExecuteHandler();
END.
