(*
%Copyright   (c) Polak Computer System
%Author      25.10.2001 18:29:18 SAN
%Purpose     ஫ XDocJrn
%Type        operation
%Specific    SYS
%Modified    05.10.2012 14:57:29 POLAK\San
%Environment
*)

 MODULE XDocJrn [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_XDoc, L_WDO, DBD, L_Str, L_StdFrm, Str, Memo, L_Basis, FIO, L_AFM,
        L_DatTim, Math, L_bp;

 PRIVATE PROCEDURE XDocJrn_OnInitializeWindow();
 BEGIN
  L_WDO.iZone        (1).ViewOnly:=1;
  L_WDO.iField       (1, "XDocJrn.Action").Format:=L_XDoc.action_Pool;
 END {XDocJrn_OnInitializeWindow};

 PUBLIC PROCEDURE ViewJrn();
 BEGIN
  L_XDoc.LaunchViewingServiceFile("XDocJrn");
 END {ViewJrn};

 PRIVATE PROCEDURE XDocJrn_OnConformToWindow();
  VAR
   curXDocId  : L_XDoc.tXDocId;
   curXDocType: L_XDoc.tXDocType;
   curXDocKind: L_XDoc.tXDocKind;
   curXDoc    : L_XDoc.tXDoc;
   curXDocName: STRING[];
   kN         : STRING[];
 BEGIN
  ACCESS((RTI.Get().CurZone.MasterTable.Name));
  curXDocId:=L_XDoc.GetCurrentXDocId();
  L_XDoc.DecodeXDocId(curXDocId, curXDocType, curXDocKind, curXDoc);
  L_General.Assert(L_XDoc.XDocTypeHasXDocJrn(curXDocType),
                   "'ୠ 権  裡  㬥⮬'   ꥪ  ");
  IF SELECT(XDocJrn, XDocJrn, curXDocType, curXDocKind, curXDoc) THEN
   LAST(XDocJrn);
  END;
  SE_WWD_CURSOR(RTI.Get().TrgWindow.Name, XDocJrn);

  curXDocName:=L_XDoc.Ref_FullName(curXDocType);
  IF L_XDoc.XDocTypeHasXDocKind(curXDocType) THEN
   kN:=(L_XDoc.Ref_KindName(curXDocType));
   IF DBD.FileExist(^kN) THEN
    CONFORM((L_XDoc.Ref_FileName(curXDocType)), (kN));
    INC(curXDocName, " " + ^kN.Sign);
   END;
  END;
  INC(curXDocName, " " + curXDoc);
  RTI.Get().TrgWindow.Zones(0).Fields("v_XDocName").Value:=curXDocName;
 END {XDocJrn_OnConformToWindow};

 PRIVATE PROCEDURE MakeExcelTop();
 BEGIN
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", " 㬥");
  L_Basis.wb_WrStr("F", " 㬥");
  L_Basis.wb_WrStr("F", "ࢠ");
  L_Basis.wb_WrStr("F", "");
  L_Basis.wb_WrStr("F", "⢮");
  L_Basis.wb_WrStr("F", "६");
  L_Basis.wb_TermLine("F");
 END {MakeExcelTop};

 PRIVATE PROCEDURE GetXDocKindAsStr(_XDocType: L_XDoc.tXDocType;
                            _XDocKind: L_XDoc.tXDocKind): STRING[];
  VAR
   File: STRING[];
 BEGIN
  IF L_XDoc.XDocTypeHasXDocKind(_XDocType) THEN
   File:=L_XDoc.Ref_KindName(_XDocType);
   SELECT(^File, ^File, , _XDocKind);
   IF    _XDocType = L_XDoc.xdt_PDoc THEN
    RETURN PDocKind.SName;
   ELSIF _XDocType = L_XDoc.xdt_MDoc THEN
    RETURN MDocKind.ExtSName;
   ELSIF _XDocType = L_XDoc.xdt_ODoc THEN
    RETURN ODocKind.SName;
   ELSIF _XDocType = L_XDoc.xdt_JDoc THEN
    RETURN JDocKind.Name;
   END;
  END;
  RETURN "---";
 END {GetXDocKindAsStr};

 PRIVATE PROCEDURE MakeExcelLine(_AcsObj,
                         AcsObjName    : STRING[];
                         _XDocType     : L_XDoc.tXDocType;
                         _XDocKind     : L_XDoc.tXDocKind;
                         TimIntvl      : TIME;
                         ActionAsStr   : STRING[];
                         ActionCount   : NUMERIC[0];
                         ActionDuration: NUMERIC[2]);
 BEGIN
  L_Basis.wb_WrStr("F", _AcsObj);
  L_Basis.wb_WrStr("F", AcsObjName);
  L_Basis.wb_WrStr("F", L_XDoc.Ref_FullName(_XDocType));
  L_Basis.wb_WrStr("F", GetXDocKindAsStr(_XDocType, _XDocKind));
  IF ~!TimIntvl THEN
   L_Basis.wb_WrTim("F", TimIntvl);
  ELSE
   L_Basis.wb_WrStr("F", "---");
  END;
  L_Basis.wb_WrStr("F", ActionAsStr);
  L_Basis.wb_WrNum("F", ActionCount, 0);
  L_Basis.wb_WrNum("F", ActionDuration, 2);
  L_Basis.wb_TermLine("F");
 END {MakeExcelLine};

 PRIVATE PROCEDURE ConvTimeToNum(Time: TIME): NUMERIC[0];
 BEGIN
  RETURN Math.Trunc(Time - 00:00);
 END {ConvTimeToNum};

 PRIVATE PROCEDURE ConvNumToTime(Num: NUMERIC[0]): TIME;
 BEGIN
  RETURN 00:00 + Num;
 END {ConvNumToTime};

 PRIVATE PROCEDURE GetTimeInterval(): TIME;
 BEGIN
  RETURN ConvNumToTime(ConvTimeToNum(XDocJrn.BegTime));
 END {GetTimeInterval};

 PRIVATE PROCEDURE MakeExcelReport();
  VAR
   curXDocType   : L_XDoc.tXDocType;
   curXDocKind   : L_XDoc.tXDocKind;
   TotalCount    : NUMERIC[0];
   TotalDurat,
   ActionDuration: NUMERIC[2];
 BEGIN
  L_AFM.MakeMultipleIndex("_XDJ",  "AcsObj  : LIKE(AcsObj.AcsObj);" +
                                   "XDocType: LIKE(XDocJrn.XDocType);" +
                                   "XDocKind: LIKE(XDocJrn.XDocKind);" +
                                   "TimIntvl: TIME;" +
                                   "Action  : LIKE(XDocJrn.Action);" +
                                   "Count   : NUMERIC[0];" +
                                   "Durat   : NUMERIC[2]",
                          "_XDJ:AcsObj,XDocType,XDocKind,Action,TimIntvl");

  L_AFM.MakeMultipleIndex("AOTot", "AcsObj  : LIKE(AcsObj.AcsObj);" +
                                   "XDocType: LIKE(XDocJrn.XDocType);" +
                                   "XDocKind: LIKE(XDocJrn.XDocKind);" +
                                   "XDoc    : LIKE(XDocJrn.XDoc);" +
                                   "Durat   : NUMERIC[2]",
                          "AcsObj:AcsObj,XDocType,XDocKind,XDoc;XDocType:XDocType,XDocKind,XDoc,AcsObj");

  SELECT(XDocJrn, AcsObj);
  WHILE OCCURE(XDocJrn) DO
   NARROWSEL(XDocJrn, AcsObj);
   CONFORM(XDocJrn, AcsObj);
   SRCINSEL(XDocJrn, GE, , Memo.ud_fr());
   WHILE OCCURE(XDocJrn) & (XDocJrn.Date <= Memo.ud_ut()) DO
    PROMPT(" " + AcsObj.FullName + " " + L_DatTim.DateStr(XDocJrn.Date));
    IF ~!XDocJrn.EndTime THEN
     ActionDuration:=(XDocJrn.EndTime - XDocJrn.BegTime) * 60 + (XDocJrn.EndSec - XDocJrn.BegSec) / 60;
    ELSE
     ActionDuration:=0;
    END;

    ADD(AOTot, AcsObj, , XDocJrn.AcsObj, XDocJrn.XDocType, XDocJrn.XDocKind, XDocJrn.XDoc,
        AOTot.Durat, ActionDuration);

    IF (ActionDuration > 0) | (XDocJrn.Action = L_XDoc.action_AutoBuild) | (XDocJrn.Action = L_XDoc.action_Reprint) THEN
     ADD(_XDJ, _XDJ, , XDocJrn.AcsObj, XDocJrn.XDocType, XDocJrn.XDocKind, XDocJrn.Action, GetTimeInterval(),
         _XDJ.Count, 1,
         _XDJ.Durat, ActionDuration);
    END;
    NEXT(XDocJrn);
   END; (* WHILE OCCURE(XDocJrn) ... *)
   NEXTINEXTENDEDSEL(XDocJrn, AcsObj);
  END; (* WHILE OCCURE(XDocJrn) ... *)

  MakeExcelTop();

  SELECT(_XDJ, _XDJ);
  WHILE OCCURE(_XDJ) DO
   NARROWSEL(_XDJ, AcsObj);
   SEARCH(AcsObj, AcsObj, , _XDJ.AcsObj);
   WHILE OCCURE(_XDJ) DO
    PROMPT(" " + _XDJ.AcsObj + " " + _XDJ.XDocType + _XDJ.XDocKind);
    MakeExcelLine(_XDJ.AcsObj,
                  AcsObj.Name + " " + AcsObj.FullName,
                  _XDJ.XDocType,
                  _XDJ.XDocKind,
                  _XDJ.TimIntvl,
                  L_Str.PoolItem(L_XDoc.action_Pool, _XDJ.Action),
                  _XDJ.Count,
                  _XDJ.Durat);
    NEXT(_XDJ);
   END; (* WHILE OCCURE(_XDJ) ... *)
   NEXTINEXTENDEDSEL(_XDJ, AcsObj);
  END; (* WHILE OCCURE(_XDJ) ... *)

  SELECT(AOTot, AcsObj);
  WHILE OCCURE(AOTot) DO
   NARROWSEL(AOTot, AcsObj);
   SEARCH(AcsObj, AcsObj, , AOTot.AcsObj);
   WHILE OCCURE(AOTot) DO
    NARROWSEL(AOTot, XDocType, XDocKind);
    curXDocType:=AOTot.XDocType;
    curXDocKind:=AOTot.XDocKind;
    SETZERO(TotalCount, TotalDurat);
    WHILE OCCURE(AOTot) DO
     PROMPT(" ⮣  楫   " + AOTot.AcsObj);
     INC(TotalCount);
     INC(TotalDurat, AOTot.Durat);
     NEXT(AOTot);
    END; (* WHILE OCCURE(AOTot) ... *)
    MakeExcelLine(AcsObj.AcsObj,
                  AcsObj.Name + " " + AcsObj.FullName,
                  curXDocType,
                  curXDocKind,
                  L_General.EMPTY_TIME(),
                  " 楫  ",
                  TotalCount,
                  TotalDurat);
    NEXTINEXTENDEDSEL(AOTot, XDocType, XDocKind);
   END; (* WHILE OCCURE(AOTot) ... *)
   NEXTINEXTENDEDSEL(AOTot, AcsObj);
  END; (* WHILE OCCURE(AOTot) ... *)

  SELECT(AOTot, XDocType);
  WHILE OCCURE(AOTot) DO
   NARROWSEL(AOTot, XDocType, XDocKind);
   curXDocType:=AOTot.XDocType;
   curXDocKind:=AOTot.XDocKind;
   SETZERO(TotalDurat, TotalCount);
   WHILE OCCURE(AOTot) DO
    PROMPT(" ⮣  ਮ " + AOTot.AcsObj);
    INC(TotalCount);
    INC(TotalDurat, AOTot.Durat);
    NEXT(AOTot);
   END; (* WHILE OCCURE(AOTot) ... *)
   MakeExcelLine("---",
                 " 楫  ਮ",
                 curXDocType,
                 curXDocKind,
                 L_General.EMPTY_TIME(),
                 "---",
                 TotalCount,
                 TotalDurat);
   NEXTINEXTENDEDSEL(AOTot, XDocType, XDocKind);
  END; (* WHILE OCCURE(AOTot) ... *)
 END {MakeExcelReport};

 PUBLIC PROCEDURE XDJrn();
  CONST
   bpId = "XDJrn";
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  L_bp.Begin(bpId, " । ६ ⮢ 㬥⮢", L_bp.t_RTBasis, L_General.tc_inIntvl);
  FIO.Open(F, L_General.NameConnection(bpId), "REP", Create);
  MakeExcelReport();
  FIO.Close(F);
  L_bp.End();
 END {XDJrn};

BEGIN
 L_Events.ExecuteHandler();
END.
