(*
%Copyright   (c) Polak Computer System
%Author      18.07.2001 12:49:38 RSN
%Purpose      壠᪨ ஢  ꥪ⠬ 
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:31:45 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, D_XObj, L_DatTim, L_XObj, L_General, L_Acnt, P_Firm;

 CONST
  RMNum = 10;

  mByAcCtAllGlobObj  = 111;
  mByObjAllGlobObj   = 112;
  mByAcntAllGlobObj  = 113;
  mByAcntAllCntrObj  = 114;
  mByAcCtCurCntr     = 115;
  mByAcCtCurFirm     = 116;
  mByAcCtCurCostItem = 117;

 VAR
  SubTitle   : STRING[];
  _XST_Object: D_XObj.XCSortType;
  _CirType   : NUMERIC[0];

(*
$P{ Top:
?, L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName(), L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
SubTitle, C, ""
@
############################################################################# ########## #####
-#####----------------------------------------------------------------------------------------
|               壠᪨ ஢  ਮ  ##########  ##########              |
|############################################################################################|
}
*)

(*
$P{ CutHead:
?, L, ""
?, L, ""
@
|--------------------------------------------------------------------------------------------|
|१ ### #################################################################################|
}
*)

(*
$P{ ObjHead:
?, L, ""
?, L, ""
@
|============================================================================================|
|ꥪ ######### ###########################################################################|
}
*)

(*
$P{ SaldoTop:
?, L, "D.N.y"
?, L, ""
?, R, ",2-"
@
|                                                                                            |
|줮  ########## #################                                  ####################|
}
*)

(*
$P{ SaldoBot:
?, L, ""
?, R, ",2-"
@
|                     #################                                  ####################|
}
*)

(*
$P{ Cir:
?, L, ""
?, R, ",2-"
@
|                                                                                            |
|  #######                                                      ####################|
}
*)

(*
$P{ Line:
?, L, ""
?, L, ""
?, R, ",2-"
@
|  ######### ########################################### ####################                |
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================
}
*)

 PRIVATE PROCEDURE NeedDtlSaldo(): SCAL[2];
 BEGIN
  RETURN (MODE = mByAcntAllCntrObj) | (MODE = mByAcCtCurFirm);
 END {NeedDtlSaldo};

 PRIVATE PROCEDURE RepName(): STRING[];
 BEGIN
  IF    MODE = mByAcCtAllGlobObj  THEN RETURN "XO001";
  ELSIF MODE = mByObjAllGlobObj   THEN RETURN "XO002";
  ELSIF MODE = mByAcntAllGlobObj  THEN RETURN "XO003";
  ELSIF MODE = mByAcntAllCntrObj  THEN RETURN "XO004";
  ELSIF MODE = mByAcCtCurCntr     THEN RETURN "XM005";
  ELSIF MODE = mByAcCtCurFirm     THEN RETURN "XM006";
  ELSIF MODE = mByAcCtCurCostItem THEN RETURN "XM007";
  ELSE
   L_General.ConsultToUs(0, "RepName.Error 1");
  END;
 END {RepName};

 PRIVATE PROCEDURE DiskRepName(): STRING[];
 BEGIN
  IF (MODE = mByAcCtCurCntr) | (MODE = mByAcCtCurFirm) | (MODE = mByAcCtCurCostItem) THEN
   RETURN L_General.NameConnection(RepName());
  ELSE
   RETURN L_General.NameAnyMonth(RepName(), L_DatTim.Per(Memo.ud_ut()));
  END;
 END {DiskRepName};

 PRIVATE PROCEDURE _BuildBasis(_Title   : STRING[];
                       _XCC     : D_XObj.XCContentType;
                       _Section : L_XObj.tSection;
                       _Origin  : L_XObj.tOrigin;
                       _Object  : D_XObj.XCSortType;
                       _Cut1,
                       _Cut2    : D_XObj.XCSortType);
  VAR
   trgOM: L_XObj.tOriginsMap;
 BEGIN
  _XST_Object:=_Object;
  SubTitle   :=_Title;
  SETZERO(trgOM);
  trgOM[_Origin]:=1;
  D_XObj.PointwiseBuildXC001(_XCC, _Section, L_Acnt.ak_Acn, trgOM, L_General.EMPTY_NUMBER(), _Object, _Cut1, _Cut2);
 END {_BuildBasis};

 PRIVATE PROCEDURE BuildBasis(_Mode: SCAL[255]);
 BEGIN
  IF    _Mode = mByAcCtAllGlobObj THEN
   _BuildBasis(", ",
               D_XObj.XCC_FullWealth, L_XObj.s_Payments, L_XObj.o_Global,
               D_XObj.XST_TheSingle, D_XObj.XST_ByAcCut, D_XObj.XST_ByApport);
  ELSIF _Mode = mByObjAllGlobObj THEN
   _BuildBasis(",  - ꥪ⭮",
               D_XObj.XCC_FullWealth, L_XObj.s_Payments, L_XObj.o_Global,
               D_XObj.XST_ByXObj, D_XObj.XST_ByAcCut, D_XObj.XST_ByApport);
  ELSIF _Mode = mByAcntAllGlobObj THEN
   _BuildBasis(",  -  ⠬",
               D_XObj.XCC_FullWealth, L_XObj.s_Payments, L_XObj.o_Global,
               D_XObj.XST_TheSingle, D_XObj.XST_ByAcCut, D_XObj.XST_ByAcnt);
  ELSIF _Mode = mByAcntAllCntrObj THEN
   _BuildBasis(" - ",
               D_XObj.XCC_FullWealth, L_XObj.s_Payments, L_XObj.o_Contract,
               D_XObj.XST_TheSingle, D_XObj.XST_ByAcCut, D_XObj.XST_ByAcnt);
  ELSIF _Mode = mByAcCtCurCntr THEN
   L_General.Assert(ACCESS(Contract), " ⠭ ⥪騩 ");
   CONFORM(Contract, XObject);
   _BuildBasis(" -  " + Contract.Contract + " " + Contract.Name,
               D_XObj.XCC_SingleXObject, L_XObj.s_Payments, L_XObj.o_Contract,
               D_XObj.XST_TheSingle, D_XObj.XST_ByAcCut, D_XObj.XST_ByAcCut);
  ELSIF _Mode = mByAcCtCurFirm THEN
   L_General.Assert(ACCESS(Firm), " ⠭ ࠣ");
   _BuildBasis(" - ࠣ " + Firm.Firm + " " + Firm.Name,
               D_XObj.XCC_SingleFirm, L_XObj.s_Payments, L_XObj.o_Contract,
               D_XObj.XST_TheSingle, D_XObj.XST_ByAcCut, D_XObj.XST_ByAcCut);
  ELSIF _Mode = mByAcCtCurCostItem THEN
   L_General.Assert(ACCESS(CostItem), " ⠭ ⥪  室  室");
   CONFORM(CostItem, XObject);
   _BuildBasis(" -  " + CostItem.CostItem + " " + CostItem.Name,
               D_XObj.XCC_SingleXObject, L_XObj.s_Payments, L_XObj.o_CostItem,
               D_XObj.XST_TheSingle, D_XObj.XST_ByAcCut, D_XObj.XST_ByAcCut);
  ELSE
   L_General.BadMode(MODE);
  END;
 END {BuildBasis};

 VAR
  curSum: L_XObj.tSum;

BEGIN
 OPENREP(R, DiskRepName(), Create);

 BuildBasis(MODE);

 SELECT(XC001, mfObject);
 WHILE OCCURE(XC001) DO
  CHANGESEL(XC001, mfObject, , XC001.MyFirm);
  MAKEPART(R, Top, P_Firm.MyFirmName(XC001.MyFirm, SYSDATE()));
  WHILE OCCURE(XC001) DO
   PROMPT(XC001.Cut1);
   IF _XST_Object # D_XObj.XST_TheSingle THEN
    MAKEPART(R, ObjHead, XC001.Object, D_XObj.GetCutName(XC001.Object, D_XObj.XCL_Object));
   END;
   MAKEPART(R, CutHead, XC001.Cut1, D_XObj.GetCutName(XC001.Cut1, D_XObj.XCL_Cut1));
   IF NeedDtlSaldo() THEN
    MAKEPART(R, SaldoTop, L_DatTim.Per(Memo.ud_fr()), "",  XC001.uav_aSum[L_Acnt.uavp_ISlDbt]);
    MAKEPART(R, SaldoBot,                             "।", XC001.uav_aSum[L_Acnt.uavp_ISlCrd]);
   ELSE
    MAKEPART(R, SaldoTop, L_DatTim.Per(Memo.ud_fr()), "", XC001.uav_aSum[L_Acnt.uavp_ISlDbt]-XC001.uav_aSum[L_Acnt.uavp_ISlCrd]);
   END;
   _CirType:=1;
   WHILE _CirType >= 0 DO
    IF _CirType=L_Acnt.ct_Credit THEN
     MAKEPART(R, Cir, "।", XC001.uav_aSum[L_Acnt.uavp_CirCrd]);
    ELSE
     MAKEPART(R, Cir, "",  XC001.uav_aSum[L_Acnt.uavp_CirDbt]);
    END; (* IF _CirType *)
    SELECT(XA001, mfObject, , XC001.MyFirm, XC001.Object, XC001.Cut1, _CirType);
    WHILE OCCURE(XA001) DO
     curSum:=0;
     CHANGESEL(XA001, mfObject, , XA001.MyFirm, XA001.Object, XA001.Cut1, XA001.CirType, XA001.Cut2);
     WHILE OCCURE(XA001) DO
      INC(curSum, XA001.Sum);
      NEXT(XA001);
     END; (* WHILE OCCURE(XA001) ... *)
     LAST(XA001);
     MAKEPART(R, Line, XA001.Cut2, D_XObj.GetCutName(XA001.Cut2, D_XObj.XCL_Cut2), curSum);
     CHANGESEL(XA001, mfObject, , XA001.MyFirm, XA001.Object, XA001.Cut1, XA001.CirType);
     NEXT(XA001);
    END; (* WHILE OCCURE(XA001)...*)
    DEC(_CirType);
   END; (* WHILE _CirType ... *)
   IF NeedDtlSaldo() THEN
    MAKEPART(R, SaldoTop, L_DatTim.MonthEnd(Memo.ud_ut())+1, "",  XC001.uav_aSum[L_Acnt.uavp_OSlDbt]);
    MAKEPART(R, SaldoBot,                                    "।", XC001.uav_aSum[L_Acnt.uavp_OSlCrd]);
   ELSE
    MAKEPART(R, SaldoTop, L_DatTim.MonthEnd(Memo.ud_ut())+1, "", XC001.uav_aSum[L_Acnt.uavp_OSlDbt]-XC001.uav_aSum[L_Acnt.uavp_OSlCrd]);
   END;
   NEXT(XC001);
  END; (* WHILE OCCURE(XC001) ... *)
  MAKEPART(R, Bot);
  LAST(XC001);
  FORMFEED(R);
  CHANGESEL(XC001, mfObject,);
  NEXT(XC001);
 END; (* WHILE OCCURE(XC001) ... *)
 CLOSEREP(R);
 D_XObj.PurgeXC001();
END.
