(*
%Copyright   (c) Polak IT
%Author      23.12.2009 10:02:11 POLAK\LDA
%Purpose       
%Type        report
%Specific    AP
%Modified    18.03.2014 19:07:15 POLAK\LDA
%Environment
*)

 MODULE XOMN10 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Packet, L_DatTim, L_Str, L_StdFrm, P_MyFirm, L_ATER, Math;

 PRIVATE PROCEDURE PutInPacket(BPer, EPer: DATE);
  CONST
   trgTable2 = 00000;
   trgRow2   = 00000;
 BEGIN
  CONFORM(Packet, ATER);
  L_Packet.psf_Str("", L_Packet.GetIdFile("NO_USN"), trgTable2, trgRow2);
  L_Packet.FinishATER(L_Packet.st_InProcess);
 END {PutInPacket};

 PRIVATE PROCEDURE Make(BPer, EPer: DATE);
 BEGIN
  PutInPacket(BPer, EPer);
 END {Make};

 PRIVATE PROCEDURE CheckTaxationMode();
  VAR
   Msg         : STRING[];
   TaxationMode: P_MyFirm.tTaxationMode;
 BEGIN
  CONFORM(Packet, ATER);
  TaxationMode:=P_MyFirm.GetTaxationMode(Packet.MyFirm, Packet.PerB);
  Msg         :="ଠ  ⭮ " + ATER.ATER + "|" +
                " ਬ  ⠭ ० |" +
                "'" + L_Str.PoolItem(P_MyFirm.tm_Pool, TaxationMode) + "'|" +
                " " + Packet.MyFirm;

  IF    (ATER.ATER = 5000) | (ATER.ATER = 5002) | (ATER.ATER = 5004) THEN
   L_General.Assert(TaxationMode = P_MyFirm.tm_USNO_Income, Msg);
  ELSIF (ATER.ATER = 5001) | (ATER.ATER = 5003) | (ATER.ATER = 5005) THEN
   L_General.Assert(TaxationMode = P_MyFirm.tm_USNO_IncomeWOCharge, Msg);
  ELSE
   L_General.CallUs(0);
  END;
 END {CheckTaxationMode};

 PUBLIC PROCEDURE XOMN10();
  VAR
   Msg           : STRING[];
   StandartPeriod: SCAL[2];
   BPer, EPer    : DATE;
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭    ⭮");
  CheckTaxationMode();
  L_Packet.ClearATER(0);
  BPer:=Packet.PerB;
  EPer:=L_DatTim.MonthEnd(Packet.PerE);
  CONFORM(Packet, ATER);
  L_Packet.CheckActualPacketInPer();
  StandartPeriod:=1;
  IF (L_DatTim.MONTH(BPer) = 0) & (L_DatTim.MONTH(EPer) = 11) THEN
   Msg     :=" " +
             L_Str.IntStr(L_DatTim.YEAR(EPer)) + " ";
   L_General.Assert(ATER.Kind = L_Packet.knd_USNO_Decl, "   㦭 ନ஢ ⭮  |'"+L_Str.PoolItem(L_Packet.knd_Pool, L_Packet.knd_USNO_Decl)+"'");
  ELSE
   IF L_DatTim.IsLastMonthOfQuartal(EPer) & (BPer = L_DatTim.YearBeg(EPer)) THEN
    Msg    :=" " +
             L_Str.PoolItem("I ⠫ |㣮 |9 楢 ", L_DatTim.QUARTAL(EPer)) +
             L_Str.IntStr(L_DatTim.YEAR(EPer)) + " ";
   ELSE
    StandartPeriod:=0;
    Msg    :=" ਮ c " +
             Str.Cap(L_DatTim.FullDateStr(BPer)) +
             "  " + Str.Cap(L_DatTim.FullDateStr(EPer));
   END;
  END;
  L_StdFrm.Question("⮢ ⭮  ଥ|" + L_Str.PoolItem(L_Packet.knd_Pool, ATER.Kind) + "|" +  Msg);
  IF ~StandartPeriod THEN
   L_StdFrm.Choice(" ਮ|" + "c " + Str.Cap(L_DatTim.FullDateStr(BPer)) +
                   "  " + Str.Cap(L_DatTim.FullDateStr(EPer)) + "|  ⠭! த?");
  END;

  Make(BPer, EPer);
 END {XOMN10};

END.
