(*
%Copyright   (c) Polak IT
%Author      07.04.2010 11:34:50 POLAK\San
%Purpose     -1
%Type        report
%Specific    AP
%Modified    08.08.2014 17:09:45 POLAK\LDA
%Environment
*)

 MODULE XOMN11 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Packet, L_DatTim, L_Str, L_StdFrm, P_MyFirm, Str, L_AFM, L_SFee, L_STx, L_Man,
        L_APtm, L_Cntr, L_XObj, L_Acnt, L_AcCut, L_ATER, E_Utils, L_EC, Math, L_OwnData;

 PRIVATE TYPE
  tValueType = SCAL[7];
  tMonthType = SCAL[4];

 PRIVATE CONST
  vt_Sld = 0;
  vt_Obj = 1;
  vt_Ex1 = 2;
  vt_Ex2 = 3;
  vt_Ovr = 4;
  vt_Bas = 5;
  vt_Tax = 6;
  vt_Pool = "Sld|Obj|Ex1|Ex2|Ovr|Bas|Tax";

  mt_1 = 0;
  mt_2 = 1;
  mt_3 = 2;
  mt_P = 3;
  mt_Pool = "1|2|3|P";

  p_Pool   = "PFIn|PFAc|XXXX|MSFF|TSFF";

  mag_Pool = "Old|Ave";

  vp_MonthType   = 1;
  vp_Part        = vp_MonthType   * (MAXOF(tMonthType)+1);
  vp_ManAgeGroup = vp_Part        * (MAXOF(L_SFee.tPart)+1);
  vp_ValueType   = vp_ManAgeGroup * (MAXOF(L_SFee.tManAgeGroup)+1);

  LastPFRContractDate = 01\12\2009;

 PRIVATE TYPE
  tValArr    = NUMERIC[2][vp_ValueType   * (MAXOF(tValueType)+1)];

 PRIVATE VAR
  BPer, EPer          : DATE;
  curMyFirm           : LIKE(MyFirm.MyFirm);
  _Table2             : LIKE(ATERAttr.Table);
  _Row2               : LIKE(ATERAttr.Row);
  prvYearRSVPacket,
  prvRSVPacket        : LIKE(Packet.Packet);
  ShowReportRequered,
  IsFirstQuartalPacket: SCAL[2];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Packet.Packet, L, ""
Packet.PerB, L, "N.y"
Packet.PerE, L, "N.y"
@
############################################################################################# ########## #####
=##########===================================================================================================
|                  ⮪ ନ஢   客 ᠬ     (-1)                   |
|                                  #######  ਮ  #######  #######                                |
|------------------------------------------------------------------------------------------------------------|
|ਡ                                                                  | . 㬬|㬬  |c宦.|
|-------------------------------------------------------------------------|------------|------------|--------|
}
*)

(*
$P{ Line:
?, L, ""
?, R, "0"
?, R, "0"
?, R, "0"
@
|#########################################################################|############|############|########|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE pv_GN(v: tValueType;
                         p: L_SFee.tPart;
                         a: L_SFee.tManAgeGroup;
                         m: tMonthType): STRING[];
 BEGIN
  RETURN       L_Str.PoolItem( vt_Pool, v) +
         "_" + L_Str.PoolItem(  p_Pool, p) +
         "_" + L_Str.PoolItem(mag_Pool, a) +
         "_" + L_Str.PoolItem( mt_Pool, m) ;
 END {pv_GN};

 PRIVATE PROCEDURE pv_GI(v: tValueType;
                         p: L_SFee.tPart;
                         a: L_SFee.tManAgeGroup;
                         m: tMonthType): NUMERIC[0];
 BEGIN
  RETURN v*vp_ValueType + p*vp_Part + a*vp_ManAgeGroup + m*vp_MonthType;
 END {pv_GI};

 PRIVATE PROCEDURE pv_Period2MT(Period: DATE): tMonthType;
  VAR
   ma: NUMERIC[0];
 BEGIN
  ma:=L_DatTim.MONTH(L_DatTim.GetLastDateOfQuartal(EPer)) - L_DatTim.MONTH(Period);
  IF    ma = 0 THEN RETURN mt_3;
  ELSIF ma = 1 THEN RETURN mt_2;
  ELSIF ma = 2 THEN RETURN mt_1;
  ELSIF (ma >= 3) & (ma <= 11) THEN
   RETURN mt_P;
  ELSE
   L_General.CallUs(0);
  END;
 END {pv_Period2MT};

 PRIVATE PROCEDURE 㧨(Name: STRING[]; Value: NUMERIC[2]);
 BEGIN
  IF ~!Value THEN
   L_Packet.psf_Num    (Name, Value, _Table2, _Row2);
  ELSE
   L_Packet.ext_psf_Num(Name, Value, _Table2, _Row2, L_Packet.src_Operator);
  END;
 END {㧨};

 PRIVATE PROCEDURE GetValueByPrvValue(prvValue: NUMERIC[0];
                                      curValue: NUMERIC[0]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=prvValue;
  IF !Result THEN
   Result:=curValue;
  END;
  RETURN Result;
 END {GetValueByPrvValue};

 PRIVATE PROCEDURE int㧨ਡ_।(curName : STRING[];
                                                    prvValue: NUMERIC[0];
                                                    curValue: NUMERIC[0]);
 BEGIN
  㧨(curName, GetValueByPrvValue(prvValue, curValue));
 END {int㧨ਡ_।};

 PRIVATE PROCEDURE GetValueFromPrvPacket(prvPacket: LIKE(Packet.Packet);
                                         prvName  : STRING[]): NUMERIC[0];
  VAR
   prvValue: NUMERIC[2];
 BEGIN
  SETEMPTY(prvValue);
  IF    IsFirstQuartalPacket THEN
   prvValue:=0;
  ELSIF ~!prvPacket THEN
   prvValue:=L_ATER.extGetNumericValueFromPacket(prvPacket, prvName, L_ATER.ZeroTable, 1);
  END;
  RETURN prvValue;
 END {GetValueFromPrvPacket};

 PRIVATE PROCEDURE 㧨ਡ_।(curName  : STRING[];
                                                 prvPacket: LIKE(Packet.Packet);
                                                 prvName  : STRING[];
                                                 curValue : NUMERIC[0]);
 BEGIN
  int㧨ਡ_।(curName,
                                   GetValueFromPrvPacket(prvPacket, prvName),
                                   curValue);
 END {㧨ਡ_।};

 PRIVATE PROCEDURE 㧨_(Name: STRING[]; Value: STRING[]);
 BEGIN
  L_Packet.psf_Str(Name, Value, _Table2, _Row2);
 END {㧨_};

 PRIVATE PROCEDURE 㧨ப_㫥(Line: STRING[]; begColumn, endColumn: NUMERIC[0]);
 BEGIN
  WHILE begColumn <= endColumn DO
   㧨(Line + "_" + L_Str.IntStr(begColumn), 0);
   INC(begColumn);
  END;
 END {㧨ப_㫥};

 PRIVATE PROCEDURE 㧨ਡ_ॡ筮(Name: STRING[]; Value: NUMERIC[2]);
 BEGIN
  L_Packet.ext_psf_Num(Name, Value, _Table2, _Row2, L_Packet.src_Operator);
 END {㧨ਡ_ॡ筮};

 PRIVATE PROCEDURE 㧨ப_ॡ筮(Name: STRING[]; begColumn, endColumn: NUMERIC[0]; Value: NUMERIC[2]);
 BEGIN
  WHILE begColumn <= endColumn DO
   㧨ਡ_ॡ筮(Name + "_" + L_Str.IntStr(begColumn), Value);
   INC(begColumn);
  END;
 END {㧨ப_ॡ筮};

 PRIVATE PROCEDURE GetInvalidPaymentsFromPrvPacket(prvPacket  : LIKE(Packet.Packet);
                                                   trgRECORDID: LIKE(Man.RECORDID)): NUMERIC[0];
  VAR
   Result, tmpValue: NUMERIC[0];
 BEGIN
  L_General.CallUs(L_Packet.AccessATERAttrByPublicName("_"));
  IF IsFirstQuartalPacket THEN
   Result:=0;
  ELSE
   SETEMPTY(Result);
   SAVE(PckATER);
   SELECT(PckATER, PckATER, , prvPacket, ATERAttr.Table, 00000, ATERAttr.ATERAttr);
   WHILE OCCURE(PckATER) DO
    IF STRTOFLD(PckATER.Value, SCAL) = trgRECORDID THEN
     tmpValue:=L_ATER.extGetNumericValueFromPacket(prvPacket, "_㬬", PckATER.Table2, 1);
     IF ~!tmpValue THEN
      IF !Result THEN
       SETZERO(Result);
      END;
      INC(Result, tmpValue);
     END;
    END;
    NEXT(PckATER);
   END; (* WHILE OCCURE(PckATER) ... *)
   RESTORE(PckATER);
  END;
  RETURN Result;
 END {GetInvalidPaymentsFromPrvPacket};

 PRIVATE PROCEDURE GetUploadValue(va        : tValArr;
                                  v         : tValueType;
                                  p         : L_SFee.tPart;
                                  a         : L_SFee.tManAgeGroup;
                                  m         : tMonthType;
                                  forceEmpty: SCAL[2]): NUMERIC[2];
  VAR
   idx     : NUMERIC[0];
   Value   : NUMERIC[2];
   b_p, e_p: L_SFee.tPart;
   b_a, e_a: L_SFee.tManAgeGroup;
   b_m, e_m: tMonthType;
 BEGIN
  Value:=0;
  IF !p THEN b_p:=MINOF(p); e_p:=MAXOF(p);
  ELSE       b_p:=p;        e_p:=p;
  END;
  IF !a THEN b_a:=MINOF(a); e_a:=MAXOF(a);
  ELSE       b_a:=a;        e_a:=a;
  END;
  IF !m THEN b_m:=MINOF(m); e_m:=MAXOF(m);
  ELSE       b_m:=m;        e_m:=m;
  END;
  p:=b_p;
  LOOP
   a:=b_a;
   LOOP
    m:=b_m;
    LOOP
     idx:=pv_GI(v, p, a, m);
     IF forceEmpty & !va[idx] THEN
      RETURN EMPTYOF(Value);
     END;
     INC(Value, va[idx]);
     IF m = e_m THEN
      EXIT;
     END;
     INC(m);
    END; (* LOOP *)
    IF a = e_a THEN
     EXIT;
    END;
    INC(a);
   END; (* LOOP *)
   IF p = e_p THEN
    EXIT;
   END;
   INC(p);
  END; (* LOOP *)
  RETURN Value;
 END {GetUploadValue};

 PRIVATE PROCEDURE pd_FillFee(VAR va: tValArr; ag: L_SFee.tManAgeGroup);
  VAR
   mt: tMonthType;
   p : NUMERIC[0];
 BEGIN
  mt:=pv_Period2MT(ManSFee.Period);
  p :=0;
  WHILE p < L_SFee.p_Amount DO
   IF L_SFee.IsAcceptablePart(EPer, p) THEN
    INC(va[pv_GI(vt_Obj, p, ag, mt)], ManSFee.Object);
    INC(va[pv_GI(vt_Ex1, p, ag, mt)], ManSFee.ExcCmn);
    INC(va[pv_GI(vt_Bas, p, ag, mt)], L_SFee.GetCurrentSinglePartBase(p));
    INC(va[pv_GI(vt_Ovr, p, ag, mt)], ManSFee.OvrPrt[L_SFee.p2b(p)]);
    INC(va[pv_GI(vt_Tax, p, ag, mt)], ManSFee.Fee[p]);
   END;
   INC(p);
  END;
 END {pd_FillFee};

 PRIVATE PROCEDURE SpecificUploadInvalidRow_SingleColumn(    Name1,
                                                             Name2   : STRING[];
                                                             Column  : SCAL[9];
                                                             Total   : NUMERIC[0];
                                                         VAR TotalOld: NUMERIC[0];
                                                         VAR TotalAve: NUMERIC[0]);
 BEGIN
  IF TotalOld < TotalAve THEN
   TotalAve:=Total - TotalOld;
  ELSE
   TotalOld:=Total - TotalAve;
  END;
  㧨(Name1 + "_" + Column, TotalOld);
  㧨(Name2 + "_" + Column, TotalAve);
 END {SpecificUploadInvalidRow_SingleColumn};

 PRIVATE PROCEDURE SpecificUploadInvalidRow(VAR va: tValArr);
  VAR
   m        : tMonthType;
   Total,
   TotalOld,
   TotalAve,
   pTotal,
   pTotalOld,
   pTotalAve,
   qTotalOld,
   qTotalAve: NUMERIC[0];
   mTotal,
   mTotalOld,
   mTotalAve: NUMERIC[0][3];
 BEGIN
  Total:=L_ATER.extGetNumericValueFromPacket(Packet.Packet, "_ᥣ", 00000, 1);
  IF ~!Total THEN
   TotalOld:=GetUploadValue(va, vt_Obj, MINOF(L_SFee.tPart), L_SFee.mag_Old, EMPTYOF(mt_P), 0);
   TotalAve:=GetUploadValue(va, vt_Obj, MINOF(L_SFee.tPart), L_SFee.mag_Ave, EMPTYOF(mt_P), 0);
   IF TotalOld < TotalAve THEN
    TotalAve:=Total - TotalOld;
   ELSE
    TotalOld:=Total - TotalAve;
   END;

   m:=mt_1;
   WHILE m <= mt_3 DO
    mTotal[m]   :=L_ATER.extGetNumericValueFromPacket(Packet.Packet, "_ᥣ_" + L_Str.IntStr(m + 1), 00000, 1);
    mTotalOld[m]:=GetUploadValue(va, vt_Obj, MINOF(L_SFee.tPart), L_SFee.mag_Old, m, 0);
    mTotalAve[m]:=GetUploadValue(va, vt_Obj, MINOF(L_SFee.tPart), L_SFee.mag_Ave, m, 0);
    INC(m);
   END;
  ELSE
   SETZERO(Total, TotalOld, TotalAve, mTotal, mTotalOld, mTotalAve);
  END;

  SETZERO(qTotalOld, qTotalAve);
  m:=mt_1;
  WHILE m <= mt_3 DO
   SpecificUploadInvalidRow_SingleColumn("301", "302", m+4, mTotal[m], mTotalOld[m], mTotalAve[m]);
   INC(qTotalOld, mTotalOld[m]);
   INC(qTotalAve, mTotalAve[m]);
   INC(m);
  END; (* WHILE i <= m...*)

  IF IsFirstQuartalPacket THEN
   pTotal   :=0;
   pTotalOld:=0;
   pTotalAve:=0;
  ELSE
   pTotal   :=Total-(qTotalOld+qTotalAve);
   pTotalOld:=TotalOld-qTotalOld;
   pTotalAve:=TotalAve-qTotalAve;
  END;
  SpecificUploadInvalidRow_SingleColumn("p301", "p302", 3, pTotal, pTotalOld, pTotalAve);
 END {SpecificUploadInvalidRow};

 PRIVATE PROCEDURE E_ExecuteArchaicCodeDateXOMN11_woCtzn(): DATE;
 BEGIN
  RETURN L_EC.ExecE_Func_Date(BPer, PROCREF(E_Utils.ExecuteArchaicCodeDateXOMN11_woCtzn), 01\01\2012);
 END {E_ExecuteArchaicCodeDateXOMN11_woCtzn};

 PRIVATE PROCEDURE intUploadSingleTableRow(va         : tValArr;
                                           v          : tValueType;
                                           p          : L_SFee.tPart;
                                           a          : L_SFee.tManAgeGroup;
                                           Name       : STRING[];
                                           prvValue   : NUMERIC[0];
                                           curNamePool,
                                           Comment    : STRING[]);
  VAR
   m,
   Delta,
   totValue,
   curValueC,
   curValueP,
   mValue     : NUMERIC[0];
   mValuesC   : NUMERIC[2][3];
   mValuesP   : NUMERIC[0][3];
   tmpValue   :NUMERIC[2];
 BEGIN
  SETZERO(Delta);
  SETEMPTY(mValuesP);
  totValue :=GetUploadValue(va, v, p, a, EMPTYOF(mt_P), 1);
  tmpValue :=GetUploadValue(va, v, p, a, mt_P, 1);
  IF IsFirstQuartalPacket & !tmpValue THEN
   tmpValue:=0;
  END;
  prvValue :=GetValueByPrvValue(prvValue, tmpValue);
  curValueP:=prvValue;
  m        :=mt_1;
  WHILE m <= mt_3 DO
   mValuesC[m]:=GetUploadValue(va, v, p, a, m, 1);
   IF ~!mValuesC[m] THEN
    mValue     :=Math.Round(mValuesC[m]);
    INC(tmpValue, mValuesC[m]);
    curValueC  :=tmpValue;
    INC(Delta, curValueC - curValueP);
 
    IF mValuesC[m] # 0 THEN
     mValuesP[m]:=Delta;
     SETZERO(Delta);
     INC(curValueP, mValuesP[m]);
 
     IF Math.Abs(mValue - mValuesP[m]) > 1 THEN
      ShowReportRequered:=1;
      L_Packet.StandOnATERAttrByPublicName(L_Str.PoolItem(curNamePool, m));
      MAKEPART(R, Line, Comment + ATERAttr.Name,
                        mValue,
                        mValuesP[m],
                        mValue - mValuesP[m]);
  
     END;
    ELSE
     mValuesP[m]:=mValuesC[m];
    END;
   END;
   INC(m);
  END; (* WHILE i <= m...*)

  IF ~!totValue & ~!curValueP &
     ((totValue - curValueP) # 0) THEN
   ShowReportRequered:=1;
   L_Packet.StandOnATERAttrByPublicName(Name);
   MAKEPART(R, Line, Comment + ATERAttr.Name,
                     totValue,
                     curValueP,
                     totValue-curValueP);
  END;

  㧨("p"+Name, prvValue);
  m:=mt_1;
  WHILE m <= mt_3 DO
   㧨(L_Str.PoolItem(curNamePool, m), mValuesP[m]);
   INC(m);
  END; (* WHILE i <= m...*)
 END {intUploadSingleTableRow};

 PRIVATE PROCEDURE extUploadSingleTableRow(Name: STRING[];
                                           va  : tValArr;
                                           v   : tValueType;
                                           p   : L_SFee.tPart;
                                           a   : L_SFee.tManAgeGroup);
  VAR
   prvValue: NUMERIC[0];
 BEGIN
  prvValue:=GetValueFromPrvPacket(prvRSVPacket, Name+"_3");
  intUploadSingleTableRow(va, v, p, a, Name+"_3", prvValue, Name+"_4|"+Name+"_5|"+Name+"_6", "");
 END {extUploadSingleTableRow};

 PRIVATE PROCEDURE UploadSingleTableRow(Name: STRING[];
                                        va  : tValArr;
                                        v   : tValueType;
                                        a   : L_SFee.tManAgeGroup);
 BEGIN
  extUploadSingleTableRow(Name, va, v, MINOF(L_SFee.tPart), a);
 END {UploadSingleTableRow};

 PRIVATE PROCEDURE UploadSingleTableRow_wCorrectError(VAR va   : tValArr;
                                                          v    : tValueType;
                                                          Name1,
                                                          Name2: STRING[]);
  VAR
   a       : L_SFee.tManAgeGroup;
   Value   : NUMERIC[0][2];
   Delta,
   totValue: NUMERIC[0];
 BEGIN
  totValue             :=GetUploadValue(va, v, MINOF(L_SFee.tPart), "",             EMPTYOF(mt_P), 1);
  SETZERO(Value);
  Value[L_SFee.mag_Old]:=GetUploadValue(va, v, MINOF(L_SFee.tPart), L_SFee.mag_Old, EMPTYOF(mt_P), 1);
  Value[L_SFee.mag_Ave]:=GetUploadValue(va, v, MINOF(L_SFee.tPart), L_SFee.mag_Ave, EMPTYOF(mt_P), 1);
  Delta                :=totValue - (Value[L_SFee.mag_Old] + Value[L_SFee.mag_Ave]);
  IF Delta # 0 THEN
   L_General.CallUs((Value[L_SFee.mag_Old] + Value[L_SFee.mag_Ave]) # 0);
   IF Value[L_SFee.mag_Old] < Value[L_SFee.mag_Ave] THEN
    a:=L_SFee.mag_Ave;
   ELSE
    a:=L_SFee.mag_Old;
   END;
   INC(va[pv_GI(v, MINOF(L_SFee.tPart), a, mt_P)], Delta);
  END;

  UploadSingleTableRow(Name1, va, v, L_SFee.mag_Old);
  UploadSingleTableRow(Name2, va, v, L_SFee.mag_Ave);
 END {UploadSingleTableRow_wCorrectError};

 PRIVATE PROCEDURE PrepareData(ManualMake: SCAL[2]);
  VAR
   TariffCode    : SCAL[99];
   va,
   va_SingleInval: tValArr;
   ag            : L_SFee.tManAgeGroup;
   ManCnt        : NUMERIC[0];
   _DocGiveD     : LIKE(ManPro.DocGiveD);
   _DocExpD      : LIKE(ManPro.DocExpD);
   TaxationMode  : P_MyFirm.tTaxationMode;
   Surname,
   FirstName,
   Patronymic    : STRING[];
   TotalAmount,
   AverageAmount : NUMERIC[0];
 BEGIN
  IF ManualMake THEN
   AverageAmount:=L_ATER.GetAverageCount(BPer, EPer, curMyFirm);
   TotalAmount  :=CALL(ManIns.CalcNumOfInsMen(curMyFirm, BPer, EPer));
  ELSE
   SETZERO(AverageAmount, TotalAmount);
  END;

  㧨("।ᯨ筠᫥", AverageAmount);
  㧨("⢮", TotalAmount);
  㧨ਡ_ॡ筮("⢮⮢ਫ", 0);
  IF L_General.IsPolakSpecific() THEN
   㧨ਡ_ॡ筮("⢮࠭", 1);
  END;

  L_AFM.MakeMultipleIndex("byMan", "Man   : LIKE(Man.Man);"+
                                   "Type  : LIKE(ManSFee.Type);"+
                                   "Period: DATE;"+
                                   "AgeGrp: " + TYPENAMEOF(L_SFee.tManAgeGroup) + ";"+
                                   "Values: " + TYPENAMEOF(tValArr) + ";",
                            "byMan: Man, Type, Period, AgeGrp;Type: Type, Man, Period, AgeGrp");
  SETZERO(va);
  SELECT(ManSFee, Actual, , 1, curMyFirm);
  WHILE OCCURE(ManSFee) DO
   PROMPT("⮢: " + ManSFee.Man);
   NARROWSEL(ManSFee, Man);
   IF SRCINSEL(ManSFee, GE, BPer) THEN
    CONFORM(ManSFee, Man);
    ag:=L_SFee.ManAgeGroup(EPer);
    WHILE OCCURE(ManSFee) & (ManSFee.Period <= EPer) DO
     IF ~L_General.NeedExecuteArchaicCode(BPer, E_ExecuteArchaicCodeDateXOMN11_woCtzn())
        | (ManSFee.Type # L_SFee.t_woCtzn) THEN
      ADD(byMan, byMan, ,
          Man.Man, ManSFee.Type, ManSFee.Period, ag);
      IF ManSFee.Type # L_SFee.t_Invalid THEN
       pd_FillFee(va, ag);
      END;
     END;
     NEXT(ManSFee);
    END; (* WHILE OCCURE(File) *)
   END; (* IF SRCINSEL(ManSFee ... *)
   NEXTINEXTENDEDSEL(ManSFee, Man);
  END; (* WHILE OCCURE(ManSFee) ... *)

  TaxationMode:=P_MyFirm.GetTaxationMode(curMyFirm, BPer);
  IF    TaxationMode = P_MyFirm.tm_Common THEN
   TariffCode:=01;
  ELSIF P_MyFirm.IsUSNO(TaxationMode) | (TaxationMode = P_MyFirm.tm_ENVD) THEN
   IF L_DatTim.YEAR(BPer) <= 2010 THEN
    TariffCode:=05;
   ELSE
    IF L_SFee.IsUSNOLowSFee(curMyFirm, EPer) THEN
     TariffCode:=07;
    ELSE
     TariffCode:=51;
    END
   END;
  ELSE
   L_General.CallUs(0);
  END;

  㧨_("", TariffCode);
  UploadSingleTableRow_wCorrectError(va, vt_Obj, "201", "202");
  UploadSingleTableRow_wCorrectError(va, vt_Ex1, "211", "212");
  UploadSingleTableRow_wCorrectError(va, vt_Ex2, "214", "215");
  UploadSingleTableRow_wCorrectError(va, vt_Ovr, "217", "218");

  extUploadSingleTableRow("241", va, vt_Tax, L_SFee.p_PFIn, "");
  extUploadSingleTableRow("242", va, vt_Tax, L_SFee.p_PFAc, "");
  extUploadSingleTableRow("243", va, vt_Tax, L_SFee.p_MSFF, "");
  extUploadSingleTableRow("244", va, vt_Tax, L_SFee.p_MSTF, "");

  SETZERO(va, ManCnt);
  IF SELECT(byMan, Type, L_SFee.t_Invalid) THEN
   WHILE OCCURE(byMan) DO
    NARROWSEL(byMan, Man);
    SEARCH(Man, Man, , byMan.Man);
    PROMPT("㧪: " + L_Man.Man_ManAsStr());
    SETZERO(va_SingleInval);
    SETEMPTY(_DocGiveD, _DocExpD);
    WHILE OCCURE(byMan) DO
     SELECT(ManSFee, MyFirm, , curMyFirm, byMan.Man, 1, byMan.Period);
     WHILE OCCURE(ManSFee) DO
      IF ManSFee.Type = byMan.Type THEN
       pd_FillFee(va,             byMan.AgeGrp);
       pd_FillFee(va_SingleInval, byMan.AgeGrp);
      END;
      NEXT(ManSFee);
     END; (* WHILE OCCURE(ManSFee) ... *)
 
     L_General.Assert(L_STx.STx_Man_IsInvalid(byMan.Period, Man.Man),
                      " " + L_Man.Man_ManAsStr() + ": 믫  |" +
                      "   ᠭ   " + L_DatTim.DateStr(byMan.Period));
     L_General.Assert(~!ManPro.DocGiveD, " " + L_Man.Man_ManAsStr() + ":|   뤠 ࠢ  ");
     _DocGiveD:=ManPro.DocGiveD;
     _DocExpD :=ManPro.DocExpD;
     NEXT(byMan);
    END; (* WHILE OCCURE(byMan) ... *)
 
    L_Man.curMan_SplitName(Surname, FirstName, Patronymic);
    㧨_("_",               Man.RECORDID);
    㧨_("_",           Str.Cap(Surname));
    㧨_("_",               Str.Cap(FirstName));
    㧨_("_⢮",          Str.Cap(Patronymic));
    㧨_("_⠂뤠稑ࠢ", L_DatTim.DateStr(ManPro.DocGiveD));
    IF ~!ManPro.DocExpD THEN
     㧨_("_⠎砭⢨", L_DatTim.DateStr(ManPro.DocExpD));
    ELSE
     㧨_("_⠎砭⢨", L_DatTim.DateStr(L_DatTim.YearEnd(BPer)));
    END;

    intUploadSingleTableRow(va_SingleInval, vt_Obj, MINOF(L_SFee.tPart), "",
                            "_㬬", GetInvalidPaymentsFromPrvPacket(prvRSVPacket, Man.RECORDID),
                            "_㬬_1|_㬬_2|_㬬_3",
                            FLDTOSTR(Man.Man, "", 5) + " " + L_Str.ShortName(Man.Name) + " ");
    INC(_Table2);
    INC(ManCnt);
    NEXTINEXTENDEDSEL(byMan, Man);
   END; (* WHILE OCCURE(byMan) ... *)
   _Table2:=00000;

   㧨("⢮⭨", ManCnt);
  END;

  SpecificUploadInvalidRow(va);

  UploadSingleTableRow("311", va, vt_Ex1, L_SFee.mag_Old);
  UploadSingleTableRow("312", va, vt_Ex1, L_SFee.mag_Ave);
  UploadSingleTableRow("314", va, vt_Ex2, L_SFee.mag_Old);
  UploadSingleTableRow("315", va, vt_Ex2, L_SFee.mag_Ave);
  UploadSingleTableRow("317", va, vt_Ovr, L_SFee.mag_Old);
  UploadSingleTableRow("318", va, vt_Ovr, L_SFee.mag_Ave);

  extUploadSingleTableRow("341", va, vt_Tax, L_SFee.p_PFIn, "");
  extUploadSingleTableRow("342", va, vt_Tax, L_SFee.p_PFAc, "");
  extUploadSingleTableRow("343", va, vt_Tax, L_SFee.p_MSFF, "");
  extUploadSingleTableRow("344", va, vt_Tax, L_SFee.p_MSTF, "");

  IF    L_DatTim.YEAR(BPer) <= 2010 THEN
   (*  *)
   㧨ப_㫥("351", 3, 6);
   㧨ப_㫥("352", 3, 6);
   㧨ப_㫥("361", 3, 6);
   㧨ப_㫥("362", 3, 6);
   㧨ப_㫥("364", 3, 6);
   㧨ப_㫥("365", 3, 6);
   㧨ப_㫥("391", 3, 6);
   㧨ப_㫥("392", 3, 6);
   㧨ப_㫥("393", 3, 6);
   㧨ப_㫥("394", 3, 6);
  ELSIF L_SFee.IsUSNOLowSFee(curMyFirm, EPer) THEN
   㧨ਡ_ॡ筮("435_3", 0);
   㧨ਡ_ॡ筮("436_3", 0);
(*
  ELSE
   㧨("435_3", 0);
   㧨("436_3", 0);
*)
  END;
 END {PrepareData};

 PRIVATE PROCEDURE SetupXObjectByErknedContract(P           : DATE;
                                                _Notion     : L_APtm.tNotion;
                                                VAR _XObject: LIKE(XObject.XObject);
                                                VAR _AcCut  : LIKE(AcCut.AcCut)): SCAL[2];
  VAR
   _Contract: LIKE(Contract.Contract);
 BEGIN
  _Contract:=L_Cntr.erkn_GetSoft(P, _Notion, curMyFirm);
  IF ~!_Contract THEN
   SEARCH(Contract, Contract, , _Contract);
   _XObject:=Contract.XObject;
   _AcCut  :=L_Acnt.GetSpecificAcCutForContract(Contract.Contract, L_Acnt.acp_Contract_Netto);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {SetupXObjectByErknedContract};

 PRIVATE PROCEDURE GetVPSPmntValue(p             : L_SFee.tPart;
                                   AcntVectorPart: L_Acnt.tAcntVectorPart;
                                   ContractDate,
                                   PerB, PerE    : DATE): NUMERIC[2];
  VAR
   Total     : L_Acnt.tAcntVector;
   dummyAcCut: LIKE(AcCut.AcCut);
   trgXObject: LIKE(XObject.XObject);
 BEGIN
  IF SetupXObjectByErknedContract(ContractDate, L_SFee.sfp2Notion(p), trgXObject, dummyAcCut) THEN
   Total:=L_XObj.GetAcntVector(trgXObject,
                               L_AcCut.erkn_Get(ContractDate, L_AcCut.erkn_OnlineBalance),
                               EMPTYOF(AcCut.AcCut),
                               PerB, PerE);
   RETURN Total[AcntVectorPart];
  ELSE
   RETURN EMPTYOF(Total[0]);
  END;
 END {GetVPSPmntValue};

 PRIVATE PROCEDURE GetVPSInSaldo(p: L_SFee.tPart; ContractDate: DATE): NUMERIC[2];
  VAR
   VPSInSaldo: NUMERIC[0];
 BEGIN
  VPSInSaldo:=GetVPSPmntValue(p, L_Acnt.avp_InSaldo, ContractDate, BPer, EPer);
  IF ~!VPSInSaldo THEN
   VPSInSaldo:=(-1) * VPSInSaldo;
  END;
  RETURN VPSInSaldo;
 END {GetVPSInSaldo};

 PRIVATE PROCEDURE GetVPSDebit(p: L_SFee.tPart; ContractDate: DATE): NUMERIC[2];
 BEGIN
  RETURN GetVPSPmntValue(p, L_Acnt.avp_Debit, ContractDate, BPer, L_DatTim.MonthEnd(EPer));
 END {GetVPSDebit};

 PRIVATE PROCEDURE UploadTable1_SingleCol(Col: STRING[];
                                          va  : tValArr;
                                          p   : L_SFee.tPart);
 BEGIN
  intUploadSingleTableRow(va, vt_Tax, p, MINOF(L_SFee.tManAgeGroup),
                          "140_"+Col,
                          GetValueFromPrvPacket(prvRSVPacket, "140_"+Col),
                          "141_"+Col+"|142_"+Col+"|143_"+Col,
                          "");
 END {UploadTable1_SingleCol};

 PRIVATE PROCEDURE GetPFRPmntValues(begPer, endPer: DATE; VAR va: tValArr);
  VAR
   p         : L_SFee.tPart;
   mt        : tMonthType;
   idx       : NUMERIC[0];
   Per       : DATE;
   Total     : L_Acnt.tAcntVector;
   trgAcCut  : LIKE(AcCut.AcCut);
   trgXObject: LIKE(XObject.XObject);
   m_Empty   : SCAL[2][MAXOF(tMonthType)+1];
 BEGIN
  FOR_EACH p DO
   IF L_SFee.IsPartwNotion(endPer, p) THEN
    SETZERO(m_Empty);
    Per:=begPer;
    WHILE Per <= endPer DO
     mt :=pv_Period2MT(Per);
     idx:=pv_GI(vt_Tax, p, MINOF(L_SFee.tManAgeGroup), mt);
     IF    SetupXObjectByErknedContract(Per, L_SFee.sfp2Notion(p), trgXObject, trgAcCut) THEN
      Total:=L_XObj.GetAcntVector(trgXObject,
                                  trgAcCut,
                                  EMPTYOF(AcCut.AcCut),
                                  Per, L_DatTim.MonthEnd(Per));
      IF m_Empty[mt] = 0 THEN
       IF !va[idx] THEN
        SETZERO(va[idx]);
       END;
       INC(va[idx], Total[L_Acnt.avp_Debit]);
      END;
     ELSIF P_MyFirm.IsUSNO(P_MyFirm.GetTaxationMode(curMyFirm, Per)) THEN
      SETZERO(va[idx]);
     ELSE
      m_Empty[mt]:=1;
      SETEMPTY(va[idx]);
     END;
     Per:=L_DatTim.IncMonth(Per, +1);
    END;
   END;
  END; (* FOR_EACH p... *)
 END {GetPFRPmntValues};

 PRIVATE PROCEDURE GetVPSValue(p: L_SFee.tPart; InSaldo: NUMERIC[0]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=GetVPSDebit(p, LastPFRContractDate);
  IF !Result & (InSaldo = 0) THEN
   Result:=0;
  END;
  RETURN Result;
 END {GetVPSValue};

 PRIVATE PROCEDURE PutPmntValues();
  VAR
   va    : tValArr;
   v510_3,
   v510_4,
   v520_3,
   v520_4: NUMERIC[0];
 BEGIN
  IF L_DatTim.YEAR(BPer) = 2010 THEN
   㧨ப_㫥("100", 3, 6);
  ELSE
   㧨ਡ_।("100_3", prvYearRSVPacket, "150_3", GetVPSInSaldo(L_SFee.p_PFIn, BPer));
   㧨ਡ_।("100_4", prvYearRSVPacket, "150_4", GetVPSInSaldo(L_SFee.p_PFAc, BPer));
   㧨ਡ_।("100_5", prvYearRSVPacket, "150_5", GetVPSInSaldo(L_SFee.p_MSFF, BPer));
   㧨ਡ_।("100_6", prvYearRSVPacket, "150_6", GetVPSInSaldo(L_SFee.p_MSTF, BPer));
  END;

  SETEMPTY(va);
  GetPFRPmntValues(Packet.PerB, Packet.PerE, va);

  IF L_General.IsPolakSpecific() THEN
   㧨ப_ॡ筮("120", 3, 6, 0);
  END;
  UploadTable1_SingleCol("3", va, L_SFee.p_PFIn);
  UploadTable1_SingleCol("4", va, L_SFee.p_PFAc);
  UploadTable1_SingleCol("5", va, L_SFee.p_MSFF);
  UploadTable1_SingleCol("6", va, L_SFee.p_MSTF);

  v510_3:=GetValueByPrvValue(GetValueFromPrvPacket(prvYearRSVPacket, "530_3"), GetVPSInSaldo(L_SFee.p_PFIn, LastPFRContractDate));
  v510_4:=GetValueByPrvValue(GetValueFromPrvPacket(prvYearRSVPacket, "530_4"), GetVPSInSaldo(L_SFee.p_PFAc, LastPFRContractDate));
  v520_3:=GetVPSValue(L_SFee.p_PFIn, v510_3);
  v520_4:=GetVPSValue(L_SFee.p_PFAc, v510_4);
  㧨("510_3", v510_3);
  㧨("510_4", v510_4);
  㧨("520_3", v520_3);
  㧨("520_4", v520_4);
 END {PutPmntValues};

 PRIVATE PROCEDURE Make(ManualMake: SCAL[2]);
  VAR
   RepName: STRING[];
 BEGIN
  ShowReportRequered:=0;
  RepName           :="X11_" + Packet.Packet;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  L_Packet.DefinePckMyFirm(L_Packet.bm_byPacket);
  CONFORM(Packet, ATER);
  _Table2:=00000;
  _Row2  :=00000;

  L_Packet.psf_Str("", L_Packet.trnFileName(), _Table2, _Row2);
  IF L_General.GetAPSiteNumber() = 96 THEN
   L_Packet.ext_psf_Str("।ਮ", prvRSVPacket, _Table2, _Row2);
  ELSE
   L_Packet.psf_Str("।ਮ", prvRSVPacket, _Table2, _Row2);
  END;

  PutPmntValues();

  PrepareData(ManualMake);

  L_Packet.PutManualInputATERAttr();

  L_Packet.SetDTStamp();
  Packet.PrpDate :=SYSDATE();
  Packet.DTStamp :=L_Packet.DTStamp;
  Packet.DataType:=L_Packet.dt_None;
  Packet.CorrType:=L_Packet.ct_None;
  REPLACE(Packet);
  MAKEPART(R, Bot);
  IF ManualMake & ShowReportRequered THEN
   LIKEMENU(Survey, ""),
  END;
 END {Make};

 PUBLIC PROCEDURE intXOMN11(ManualMake: SCAL[2]);
  VAR
   Msg           : STRING[];
   StandartPeriod: SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭ ");
  L_General.Assert(Packet.DataType = L_Packet.dt_None, "ନ஢    ");
  L_Packet.ClearATER(0);
  CONFORM(Packet, ATER);
  L_Packet.CheckActualPacketInPer();
  BPer          :=Packet.PerB;
  EPer          :=L_DatTim.MonthEnd(Packet.PerE);

  IF L_APtm.MonthIsClosed(EPer, L_APtm.system_Salary) THEN
   SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  END;

  curMyFirm     :=Packet.MyFirm;
  L_General.Assert(L_DatTim.MONTH(BPer) = 0, "⭮ ନ ⮫쪮  砫 ");
  IsFirstQuartalPacket:=(L_DatTim.QUARTAL(Packet.PerB) = 0) & (L_DatTim.QUARTAL(Packet.PerE) = 0);
  IF ManualMake THEN
   StandartPeriod:=L_DatTim.IsLastMonthOfQuartal(EPer) & (BPer = L_DatTim.YearBeg(EPer));
   IF StandartPeriod THEN
    Msg:=" " +
         L_Str.PoolItem("I ⠫ " + L_Str.IntStr(L_DatTim.YEAR(EPer)) + " |" +
                        "㣮 " + L_Str.IntStr(L_DatTim.YEAR(EPer)) + " |" +
                        "9 楢 " + L_Str.IntStr(L_DatTim.YEAR(EPer)) + " |" +
                        L_Str.IntStr(L_DatTim.YEAR(EPer)) + " ", L_DatTim.QUARTAL(EPer));
   ELSE
    Msg:=" ਮ c " +
         Str.Cap(L_DatTim.FullDateStr(BPer)) + "  " + Str.Cap(L_DatTim.FullDateStr(EPer));
   END;
   L_StdFrm.Question("⮢ ⭮  ଥ|" + L_Str.PoolItem(L_Packet.knd_Pool, ATER.Kind) + "|" +  Msg);
   IF ~StandartPeriod THEN
    L_StdFrm.Choice(" ਮ|" + "c " + Str.Cap(L_DatTim.FullDateStr(BPer)) +
                    "  " + Str.Cap(L_DatTim.FullDateStr(EPer)) + "|  ⠭! த?");
   END;
  END;
  L_General.Assert_wReferToAdmin(L_SFee.SFeeIsCalculatedInProperConsecution(L_DatTim.Per(EPer)),
                                 "ॡ  客 ᮢ  " + L_DatTim.PeriodStr(EPer) + " ᫥  |" +
                                 "    ⥫");

  IF L_DatTim.YEAR(BPer) = 2010 THEN
   SETEMPTY(prvYearRSVPacket);
  ELSE
   prvYearRSVPacket:=L_ATER.GetPrvYearPacket(Packet.Packet);
  END;

  prvRSVPacket:=L_ATER.GetPrvQuartalPacket(Packet.Packet, L_ATER.GetPckATERValue_Str(Packet.Packet, "।ਮ", 00000));
  Make(ManualMake);
 END {intXOMN11};

 PUBLIC PROCEDURE XOMN11();
 BEGIN
  intXOMN11(1);
 END {XOMN11};

END.
