(*
%Copyright   (c) Polak IT
%Author      18.01.2011 11:38:03 LDA
%Purpose
%Type        control,report,temporary,convertor,operation,library,to paste
%Specific    AP,AP_PC,AP_PT,SYS,TOOL,LOC
%Modified    10.04.2012 12:31:50 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_Packet, L_DatTim, Str, L_Str, P_MyFirm, P_Firm, L_General, L_StdFrm, L_ATER;

 PRIVATE VAR
  BPer, EPer: DATE;

 PRIVATE PROCEDURE Make();
  VAR
   GUID     : STRING[];
   trgRow2  : LIKE(ATERAttr.Row);
   trgTable2: LIKE(ATERAttr.Table);
 BEGIN
  L_Packet.DefinePckMyFirm(L_Packet.bm_byPacket);
  CONFORM(Packet, ATER);
  trgTable2:=00000;
  trgRow2  :=00000;

  GUID:=Str.Cap(CreateUUID());
  L_Packet.psf_Str("",          GUID, trgTable2, trgRow2);
  L_Packet.psf_Str("",         L_Packet.GetIdFile("NO_SRCHIS"), trgTable2, trgRow2);
  L_Packet.psf_Dat("⠑।", EPer+1, trgTable2, trgRow2);
  L_Packet.psf_Num("",         L_ATER.GetAverageCount(BPer, EPer, L_Packet.PckMyFirm), trgTable2, trgRow2);

  L_Packet.PutManualInputATERAttr();

  L_Packet.SetDTStamp();
  Packet.PrpDate :=SYSDATE();
  Packet.DTStamp :=L_Packet.DTStamp;
  Packet.DataType:=L_Packet.dt_None;
  Packet.CorrType:=L_Packet.ct_None;
  REPLACE(Packet);
 END {Make};

 PRIVATE PROCEDURE XOMN12();
  VAR
   Msg           : STRING[];
   StandartPeriod: SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭ ");
  L_Packet.ClearATER(0);
  CONFORM(Packet, ATER);
  L_Packet.CheckActualPacketInPer();
  BPer          :=Packet.PerB;
  EPer          :=L_DatTim.MonthEnd(Packet.PerE);

  StandartPeriod:=(L_DatTim.YearBeg(BPer) = L_DatTim.YearBeg(EPer)) &
                  (L_DatTim.MONTH(BPer) = 00) & (L_DatTim.MONTH(EPer) = 11);
  IF StandartPeriod THEN
   Msg    :=" " + L_Str.IntStr(L_DatTim.YEAR(EPer)) + " ";
  ELSE
   Msg    :=" ਮ c " +
            Str.Cap(L_DatTim.FullDateStr(BPer)) +
            "  " + Str.Cap(L_DatTim.FullDateStr(EPer));
  END;
  L_StdFrm.JustQuestion("⮢   ଥ|" + L_Str.PoolItem(L_Packet.knd_Pool, ATER.Kind) + "|" +  Msg);
  IF ~StandartPeriod THEN
   L_StdFrm.OrdinaryCHOICE(" ਮ|" + "c " + Str.Cap(L_DatTim.FullDateStr(BPer)) +
                           "  " + Str.Cap(L_DatTim.FullDateStr(EPer)) + "|  ⠭! த?");
  END;
  Make();
 END {XOMN12};

END.
