(*
%Copyright   (c) Polak IT
%Author      07.04.2010 11:34:50 POLAK\San
%Purpose     -1  01.2012
%Type        report
%Specific    AP
%Modified    08.08.2014 17:31:03 POLAK\LDA
%Environment
*)

 MODULE XOMN15 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Packet, L_DatTim, L_Str, L_StdFrm, P_MyFirm, Str, L_AFM, L_SFee, L_Man, L_PRoll,
        L_APtm, L_Cntr, L_XObj, L_Acnt, L_AcCut, L_ATER, Math, P_Firm, L_Env, L_ExtAb, L_PDoc;

 PRIVATE TYPE
  tValueType      = SCAL[9];
  tMonthType      = SCAL[4];
  tManGroup       = SCAL[3];
  tFeePresenceArr = SCAL[2][4];

 PRIVATE CONST
  vt_Sld    = 0;
  vt_Obj    = 1;
  vt_Ex1    = 2;
  vt_Ovr    = 3;
  vt_Bas    = 4;
  vt_Tax    = 5;
  vt_TaxOvr = 6;

  mt_1 = 0;
  mt_2 = 1;
  mt_3 = 2;
  mt_P = 3;
  mt_T = 3; (* ᫥ - ᥣ  ਮ  mt_P*)

  mg_Old = 0;
  mg_Ave = 1;
  mg_Frg = 2;

  vp_MonthType = 1;
  vp_Part      = vp_MonthType * (MAXOF(tMonthType)+1);
  vp_ManGroup  = vp_Part      * (MAXOF(L_SFee.tPart)+1);
  vp_ValueType = vp_ManGroup  * (MAXOF(tManGroup)+1);

  fp_Fee  = 0;
  fp_Ovr  = 1;
  fp_PFA1 = 2;
  fp_PFA2 = 3;

 PRIVATE TYPE
  tValArr          = NUMERIC[2][vp_ValueType   * (MAXOF(tValueType)+1)];
  tManAmountArr    = NUMERIC[0][MAXOF(tMonthType)+1];
  tContractListArr = LIKE(Contract.Contract)[5];

 PRIVATE VAR
  BPer, EPer          : DATE;
  curMyFirm           : LIKE(MyFirm.MyFirm);
  prvYearRSVPacket,
  prvRSVPacket        : LIKE(Packet.Packet);
  ShowReportRequired,
  IsFirstQuartalPacket: SCAL[2];

(*
$P{ Top:
P_Firm.FP_ContractorBriefName(P_Firm.fomf(curMyFirm), Packet.PerE), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Packet.Packet, L, ""
Packet.PerB, L, "N.y"
Packet.PerE, L, "N.y"
@
############################################################################################# ########## #####
=##########===================================================================================================
|                  ⮪ ନ஢   客 ᠬ     (-1)                   |
|                                  #######  ਮ  #######  #######                                |
|------------------------------------------------------------------------------------------------------------|
|ਡ                                                        |  ⠭|   ᫥|   c宦|
|                                                               |        |  ()|              |
|---------------------------------------------------------------|--------------|--------------|--------------|
}
*)

(*
$P{ Line:
?, L, ""
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|###############################################################|##############|##############|##############|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE IsPolakSpecific(): SCAL[2];
 BEGIN
  RETURN L_General.IsPolakSpecific() & ((curMyFirm = L_Env.mf_KPR) | (curMyFirm = L_Env.mf_LSF));
 END {IsPolakSpecific};

 PRIVATE PROCEDURE pv_GI(v: tValueType;
                         p: L_SFee.tPart;
                         g: tManGroup;
                         m: tMonthType): NUMERIC[0];
 BEGIN
  RETURN v*vp_ValueType + p*vp_Part + g*vp_ManGroup + m*vp_MonthType;
 END {pv_GI};

 PRIVATE PROCEDURE pv_Period2MT(Period: DATE): tMonthType;
  VAR
   ma: NUMERIC[0];
 BEGIN
  ma:=L_DatTim.MONTH(L_DatTim.GetLastDateOfQuartal(EPer)) - L_DatTim.MONTH(Period);
  IF    ma = 0 THEN RETURN mt_3;
  ELSIF ma = 1 THEN RETURN mt_2;
  ELSIF ma = 2 THEN RETURN mt_1;
  ELSIF (ma >= 3) & (ma <= 11) THEN
   RETURN mt_P;
  ELSE
   L_General.CallUs(0);
  END;
 END {pv_Period2MT};

 PRIVATE PROCEDURE ext㧨(trgTable2: LIKE(PckATER.Table2); Name: STRING[]; Value: NUMERIC[2]);
 BEGIN
  IF ~!Value THEN
   L_Packet.psf_Num    (Name, Value, trgTable2, L_ATER.ZeroRow2);
  ELSE
   L_Packet.ext_psf_Num(Name, Value, trgTable2, L_ATER.ZeroRow2, L_Packet.src_Operator);
  END;
 END {ext㧨};

 PRIVATE PROCEDURE 㧨(Name: STRING[]; Value: NUMERIC[2]);
 BEGIN
  ext㧨(L_ATER.ZeroTable, Name, Value);
 END {㧨};

 PRIVATE PROCEDURE ext㧨_(trgTable2: LIKE(PckATER.Table2); Name: STRING[]; Value: STRING[]);
 BEGIN
  L_Packet.psf_Str(Name, Value, trgTable2, L_ATER.ZeroRow2);
 END {ext㧨_};

 PRIVATE PROCEDURE 㧨_(Name: STRING[]; Value: STRING[]);
 BEGIN
  ext㧨_(L_ATER.ZeroTable, Name, Value);
 END {㧨_};

 PRIVATE PROCEDURE GetValueByPrvValue(prvValue: NUMERIC[2];
                                      curValue: NUMERIC[2]): NUMERIC[2];
  VAR
   Result: NUMERIC[2];
 BEGIN
  Result:=prvValue;
  IF !Result THEN
   Result:=curValue;
  END;
  RETURN Result;
 END {GetValueByPrvValue};

 PRIVATE PROCEDURE int㧨ਡ_।(curName : STRING[];
                                                    prvValue: NUMERIC[2];
                                                    curValue: NUMERIC[2]);
 BEGIN
  㧨(curName, GetValueByPrvValue(prvValue, curValue));
 END {int㧨ਡ_।};

 PRIVATE PROCEDURE GetValueFromPrvPacket(prvPacket: LIKE(Packet.Packet);
                                         prvName  : STRING[]): NUMERIC[2];
  VAR
   prvValue: NUMERIC[2];
 BEGIN
  SETEMPTY(prvValue);
  IF    IsFirstQuartalPacket THEN
   prvValue:=0;
  ELSIF ~!prvPacket THEN
   prvValue:=L_ATER.extGetNumericValueFromPacket(prvPacket, prvName, L_ATER.ZeroTable, 1);
  END;
  RETURN prvValue;
 END {GetValueFromPrvPacket};

 PRIVATE PROCEDURE 㧨ਡ_।(curName  : STRING[];
                                                 prvPacket: LIKE(Packet.Packet);
                                                 prvName  : STRING[];
                                                 curValue : NUMERIC[2]);
 BEGIN
  int㧨ਡ_।(curName,
                                   GetValueFromPrvPacket(prvPacket, prvName),
                                   curValue);
 END {㧨ਡ_।};

 PRIVATE PROCEDURE 㧨ਡ_ॡ筮(Name: STRING[]; Value: NUMERIC[2]);
 BEGIN
  L_Packet.ext_psf_Num(Name, Value, L_ATER.ZeroTable, L_ATER.ZeroRow2, L_Packet.src_Operator);
 END {㧨ਡ_ॡ筮};

 PRIVATE PROCEDURE GetInvalidPaymentsFromPrvPacket(prvPacket  : LIKE(Packet.Packet);
                                                   trgRECORDID: LIKE(Man.RECORDID)): NUMERIC[2];
  VAR
   Result, tmpValue: NUMERIC[2];
 BEGIN
  L_General.CallUs(L_Packet.AccessATERAttrByPublicName("_"));
  IF IsFirstQuartalPacket THEN
   Result:=0;
  ELSE
   SETEMPTY(Result);
   SAVE(PckATER);
   SELECT(PckATER, PckATER, , prvPacket, ATERAttr.Table, L_ATER.ZeroTable, ATERAttr.ATERAttr);
   WHILE OCCURE(PckATER) DO
    IF STRTOFLD(PckATER.Value, SCAL) = trgRECORDID THEN
     tmpValue:=L_ATER.extGetNumericValueFromPacket(prvPacket, "_㬬", PckATER.Table2, 1);
     IF ~!tmpValue THEN
      IF !Result THEN
       SETZERO(Result);
      END;
      INC(Result, tmpValue);
     END;
    END;
    NEXT(PckATER);
   END; (* WHILE OCCURE(PckATER) ... *)
   RESTORE(PckATER);
  END;
  RETURN Result;
 END {GetInvalidPaymentsFromPrvPacket};

 PRIVATE PROCEDURE GetUploadValue(va        : tValArr;
                                  v         : tValueType;
                                  p         : L_SFee.tPart;
                                  g         : tManGroup;
                                  m         : tMonthType;
                                  forceEmpty: SCAL[2]): NUMERIC[2];
  VAR
   idx     : NUMERIC[0];
   Value   : NUMERIC[2];
   b_p, e_p: L_SFee.tPart;
   b_g, e_g: tManGroup;
   b_m, e_m: tMonthType;
 BEGIN
  Value:=0;
  IF !p THEN b_p:=MINOF(p); e_p:=MAXOF(p);
  ELSE       b_p:=p;        e_p:=p;
  END;
  IF !g THEN b_g:=MINOF(g); e_g:=MAXOF(g);
  ELSE       b_g:=g;        e_g:=g;
  END;
  IF !m THEN b_m:=MINOF(m); e_m:=MAXOF(m);
  ELSE       b_m:=m;        e_m:=m;
  END;
  p:=b_p;
  LOOP
   g:=b_g;
   LOOP
    m:=b_m;
    LOOP
     idx:=pv_GI(v, p, g, m);
     IF forceEmpty & !va[idx] THEN
      RETURN EMPTYOF(Value);
     END;
     INC(Value, va[idx]);
     IF m = e_m THEN
      EXIT;
     END;
     INC(m);
    END; (* LOOP *)
    IF g = e_g THEN
     EXIT;
    END;
    INC(g);
   END; (* LOOP *)
   IF p = e_p THEN
    EXIT;
   END;
   INC(p);
  END; (* LOOP *)
  RETURN Value;
 END {GetUploadValue};

 PRIVATE PROCEDURE CalcManAmount(    FeePresence: tFeePresenceArr;
                                     mt         : tMonthType;
                                 VAR maa        : tManAmountArr;
                                 VAR maaOvr     : tManAmountArr;
                                 VAR maaPFA1    : tManAmountArr;
                                 VAR maaPFA2    : tManAmountArr);

 BEGIN
  IF FeePresence[fp_Fee] THEN
   INC(maa[mt]);
  END;
  IF FeePresence[fp_Ovr] THEN
   INC(maaOvr[mt]);
  END;
  IF FeePresence[fp_PFA1] THEN
   INC(maaPFA1[mt]);
  END;
  IF FeePresence[fp_PFA2] THEN
   INC(maaPFA2[mt]);
  END;
 END {CalcManAmount};

 PRIVATE PROCEDURE pd_FillFee(VAR va         : tValArr;
                              VAR maa        : tManAmountArr;
                              VAR maaOvr     : tManAmountArr;
                              VAR maaPFA1    : tManAmountArr;
                              VAR maaPFA2    : tManAmountArr;
                              VAR FeePresence: tFeePresenceArr;
                                  g          : tManGroup);
  VAR
   mt                     : tMonthType;
   i, p                   : NUMERIC[0];
   Obj, Ex1, Bas, Fee, Ovr: NUMERIC[2];
   SingleMonthFeePresence : tFeePresenceArr;
 BEGIN
  SETZERO(SingleMonthFeePresence);
  mt:=pv_Period2MT(ManSFee.Period);
  p :=0;
  WHILE p < L_SFee.p_Amount DO
   IF L_SFee.IsAcceptablePart(EPer, p) THEN
    Obj:=ManSFee.Object;
    Ex1:=ManSFee.ExcCmn + ManSFee.ExcPrt[L_SFee.p2b(p)];
    Bas:=L_SFee.GetCurrentSinglePartBase(p);
    Fee:=ManSFee.Fee[p];
    Ovr:=ManSFee.OvrPrt[L_SFee.p2b(p)];
 
    IF ((p = L_SFee.p_PFA1) | (p = L_SFee.p_PFA2)) & (Bas = 0) & (Fee = 0) THEN
     SETZERO(Obj, Ex1, Bas, Fee, Ovr);
    END;
 
    INC(va[pv_GI(vt_Bas, p, g, mt)], Bas);
    INC(va[pv_GI(vt_Obj, p, g, mt)], Obj);
    INC(va[pv_GI(vt_Ex1, p, g, mt)], Ex1);
    INC(va[pv_GI(vt_Tax, p, g, mt)], Fee);
    INC(va[pv_GI(vt_Ovr, p, g, mt)], Ovr);
 
    IF    ((p = L_SFee.p_PFIn) | (p = L_SFee.p_PFAc) | (p = L_SFee.p_MSFF)) & (ManSFee.Fee[p] # 0) THEN
     SingleMonthFeePresence[fp_Fee]:=1;
    ELSIF (p = L_SFee.p_PFA1) & (ManSFee.Fee[p] # 0) THEN
     SingleMonthFeePresence[fp_PFA1]:=1;
    ELSIF (p = L_SFee.p_PFA2) & (ManSFee.Fee[p] # 0) THEN
     SingleMonthFeePresence[fp_PFA2]:=1;
    END;
 
    IF Ovr # 0 THEN
     SingleMonthFeePresence[fp_Ovr]:=1;
    END;
   END;
   INC(p);
  END;
  IF mt # mt_P THEN
   CalcManAmount(SingleMonthFeePresence, mt, maa, maaOvr, maaPFA1, maaPFA2);
  END;
  i:=0;
  WHILE i <= HIGH(FeePresence) DO
   FeePresence[i]:=FeePresence[i] | SingleMonthFeePresence[i];
   INC(i);
  END; (* WHILE i <= HIGH(FeePresence)...*)
 END {pd_FillFee};

 PRIVATE PROCEDURE intUploadSingleTableRow_Int(trgTable2  : LIKE(PckATER.Table2);
                                               TotalValue : NUMERIC[2];
                                               ValuesByPer: NUMERIC[2][MAXOF(tMonthType)+1];
                                               Name,
                                               curNamePool: STRING[];
                                               prvValue   : NUMERIC[2];
                                               prvName,
                                               Comment,
                                               TariffNbr  : STRING[]);
  VAR
   m        : tMonthType;
   Delta,
   mValue,
   curValueC,
   curValueP: NUMERIC[2];
   mValuesP : NUMERIC[2][3];
 BEGIN
  SETZERO(Delta);
  SETEMPTY(mValuesP);
  prvValue :=GetValueByPrvValue(prvValue, ValuesByPer[mt_P]);
  curValueP:=prvValue;
  m        :=mt_1;
  WHILE m <= mt_3 DO
   IF ~!ValuesByPer[m] THEN
    mValue   :=ValuesByPer[m];
    INC(ValuesByPer[mt_P], ValuesByPer[m]);
    curValueC:=ValuesByPer[mt_P];
    INC(Delta, curValueC - curValueP);
 
    IF ValuesByPer[m] # 0 THEN
     mValuesP[m]:=Delta;
     SETZERO(Delta);
     INC(curValueP, mValuesP[m]);
 
     IF Math.Abs(mValue - mValuesP[m]) # 0 THEN
      ShowReportRequired:=1;
      L_Packet.StandOnATERAttrByPublicName(L_Str.PoolItem(curNamePool, m)+TariffNbr);
      MAKEPART(R, Line, Comment + ATERAttr.Name,
                        mValue,
                        mValuesP[m],
                        mValue - mValuesP[m]);
  
     END;
    ELSE
     mValuesP[m]:=ValuesByPer[m];
    END;
   END;
   INC(m);
  END; (* WHILE i <= m...*)

  IF ~!TotalValue & ~!curValueP &
     ((TotalValue - curValueP) # 0) THEN
   ShowReportRequired:=1;
   L_Packet.StandOnATERAttrByPublicName(Name+TariffNbr);
   MAKEPART(R, Line, Comment + ATERAttr.Name,
                     TotalValue,
                     curValueP,
                     TotalValue-curValueP);
  END;

  IF ~!prvName THEN
   ext㧨(trgTable2, prvName+TariffNbr, prvValue);
  END;
  m:=mt_1;
  WHILE m <= mt_3 DO
   ext㧨(trgTable2, L_Str.PoolItem(curNamePool, m)+TariffNbr, mValuesP[m]);
   INC(m);
  END; (* WHILE i <= m...*)
 END {intUploadSingleTableRow_Int};

 PRIVATE PROCEDURE UploadSingleAmountRow(Name     : STRING[];
                                         AmountArr: tManAmountArr;
                                         TariffNbr: STRING[]);
  VAR
   m: tMonthType;
 BEGIN
  m:=mt_1;
  FOR_EACH m DO
   㧨(L_Str.PoolItem(Name+"_4|"+Name+"_5|"+Name+"_6|"+Name+"_3", m)+TariffNbr, AmountArr[m]);
  END; (* FOR_EACH *)
 END {UploadSingleAmountRow};

 PRIVATE PROCEDURE UploadSingleTableRow_Ext(Name       : STRING[];
                                            ValuesByPer: NUMERIC[2][MAXOF(tMonthType)+1];
                                            prvValue   : NUMERIC[2];
                                            TariffNbr  : STRING[]);
 BEGIN
  intUploadSingleTableRow_Int(L_ATER.ZeroTable,
                              GetArrSum(ValuesByPer),
                              ValuesByPer,
                              Name+"_3",
                              Name+"_4|"+Name+"_5|"+Name+"_6",
                              prvValue,
                              "p"+Name,
                              "",
                              TariffNbr);
 END {UploadSingleTableRow_Ext};

 PRIVATE PROCEDURE intUploadSingleTableRow(trgTable2  : LIKE(PckATER.Table2);
                                           va         : tValArr;
                                           v          : tValueType;
                                           p          : L_SFee.tPart;
                                           g          : tManGroup;
                                           Name,
                                           curNamePool: STRING[];
                                           prvValue   : NUMERIC[2];
                                           prvName    : STRING[];
                                           Comment,
                                           TariffNbr  : STRING[]);
  VAR
   m          : tMonthType;
   TotalValue : NUMERIC[3];
   ValuesByPer: NUMERIC[2][MAXOF(tMonthType)+1];
 BEGIN
  SETEMPTY(ValuesByPer);
  TotalValue       :=GetUploadValue(va, v, p, g, EMPTYOF(mt_P), 1);
  ValuesByPer[mt_P]:=GetUploadValue(va, v, p, g, mt_P, 1);
  IF IsFirstQuartalPacket & !ValuesByPer[mt_P] THEN
   ValuesByPer[mt_P]:=0;
  END;
  m:=mt_1;
  WHILE m <= mt_3 DO
   ValuesByPer[m]:=GetUploadValue(va, v, p, g, m, 1);
   INC(m);
  END; (* WHILE i <= m...*)
  intUploadSingleTableRow_Int(trgTable2, TotalValue, ValuesByPer, Name, curNamePool, prvValue, prvName, Comment, TariffNbr);
 END {intUploadSingleTableRow};

 PRIVATE PROCEDURE extUploadSingleTableRow(Name     : STRING[];
                                           va       : tValArr;
                                           v        : tValueType;
                                           p        : L_SFee.tPart;
                                           g        : tManGroup;
                                           TariffNbr: STRING[]);
  VAR
   prvValue: NUMERIC[2];
 BEGIN
  prvValue:=GetValueFromPrvPacket(prvRSVPacket, Name+"_3"+TariffNbr);
  intUploadSingleTableRow(L_ATER.ZeroTable, va, v, p, g, Name+"_3", Name+"_4|"+Name+"_5|"+Name+"_6", prvValue, "p"+Name, "", TariffNbr);
 END {extUploadSingleTableRow};

 PRIVATE PROCEDURE GetArrSum(VAR Arr: NUMERIC[2][]): NUMERIC[2];
  VAR
   i     : NUMERIC[0];
   Result: NUMERIC[2];
 BEGIN
  SETZERO(i, Result);
  WHILE i <= HIGH(Arr) DO
   INC(Result, Arr[i]);
   INC(i);
  END; (* WHILE i <= HIGH(Arr)...*)
  RETURN Result;
 END {GetArrSum};

 PRIVATE PROCEDURE UploadPart2_SingleTableRow_wErrorCorrection(VAR va       : tValArr;
                                                                   v        : tValueType;
                                                                   Names    : STRING[];
                                                                   TariffNbr: STRING[]);
  VAR
   g       : tManGroup;
   Value   : NUMERIC[2][3];
   Delta,
   totValue: NUMERIC[2];
 BEGIN
  SETZERO(Value);
  totValue     :=GetUploadValue(va, v, MINOF(L_SFee.tPart),  "",     EMPTYOF(mt_P), 1);
  Value[mg_Old]:=GetUploadValue(va, v, MINOF(L_SFee.tPart),  mg_Old, EMPTYOF(mt_P), 1);
  Value[mg_Ave]:=GetUploadValue(va, v, MINOF(L_SFee.tPart),  mg_Ave, EMPTYOF(mt_P), 1);
  Value[mg_Frg]:=GetUploadValue(va, v, MINOF(L_SFee.tPart),  mg_Frg, EMPTYOF(mt_P), 1);

  Delta        :=totValue - (GetArrSum(Value));
  IF Delta # 0 THEN
   L_General.CallUs(GetArrSum(Value) # 0);

   IF Value[mg_Old] < Value[mg_Ave] THEN
    g:=mg_Ave;
   ELSE
    g:=mg_Old;
   END;
   IF Value[g] < Value[mg_Frg] THEN
    g:=mg_Frg;
   END;

   INC(va[pv_GI(v, MINOF(L_SFee.tPart), g, mt_P)], Delta);
  END;

  FOR_EACH g DO
   extUploadSingleTableRow(L_Str.PoolItem(Names, g), va, v, MINOF(L_SFee.tPart), g, TariffNbr);
  END; (* FOR_EACH *)
 END {UploadPart2_SingleTableRow_wErrorCorrection};

 PRIVATE PROCEDURE RecalculateAndUploadPFRTax(VAR va       : tValArr;
                                                  trgType  : LIKE(ManSFee.Type);
                                                  TariffNbr: STRING[]);
  VAR
   m             : tMonthType;
   PFOv_Tax_ByPer,
   PFIn_Tax_ByPer,
   PFAc_Tax_ByPer: NUMERIC[2][MAXOF(tMonthType)+1];
 BEGIN
  SETZERO(PFOv_Tax_ByPer, PFIn_Tax_ByPer, PFAc_Tax_ByPer);
  FOR_EACH m DO
   PFIn_Tax_ByPer[m]:=GetUploadValue(va, vt_Tax, L_SFee.p_PFIn,       "", m, 1);
   PFAc_Tax_ByPer[m]:=GetUploadValue(va, vt_Tax, L_SFee.p_PFAc,       "", m, 1);
   PFOv_Tax_ByPer[m]:=GetUploadValue(va, vt_Tax, L_SFee.p_PFOv,       "", m, 1);
  END; (* FOR_EACH *)

  UploadSingleTableRow_Ext("250",
                           PFIn_Tax_ByPer,
                           GetValueFromPrvPacket(prvRSVPacket, "250_3"+TariffNbr),
                           TariffNbr);

  UploadSingleTableRow_Ext("251",
                           PFAc_Tax_ByPer,
                           GetValueFromPrvPacket(prvRSVPacket, "251_3"+TariffNbr),
                           TariffNbr);

  UploadSingleTableRow_Ext("252",
                           PFOv_Tax_ByPer,
                           GetValueFromPrvPacket(prvRSVPacket, "252_3"+TariffNbr),
                           TariffNbr);
 END {RecalculateAndUploadPFRTax};

 PRIVATE PROCEDURE UploadPart2_Common(TariffNbr : STRING[];
                                      TariffCode: SCAL[99];
                                      trgType   : LIKE(ManSFee.Type);
                                      va        : tValArr;
                                      maa,
                                      maaOvr,
                                      maaPFA1,
                                      maaPFA2   : tManAmountArr);
 BEGIN
  㧨_(""+TariffNbr, TariffCode);
  UploadPart2_SingleTableRow_wErrorCorrection(va, vt_Obj, "201|202|203", TariffNbr);
  UploadPart2_SingleTableRow_wErrorCorrection(va, vt_Ex1, "211|212|213", TariffNbr);
  UploadPart2_SingleTableRow_wErrorCorrection(va, vt_Ovr, "231|232|233", TariffNbr);

  RecalculateAndUploadPFRTax(va, trgType, TariffNbr);

  UploadSingleAmountRow(  "260", maa,    TariffNbr);
  UploadSingleAmountRow(  "261", maaOvr, TariffNbr);
  extUploadSingleTableRow("271", va, vt_Obj, L_SFee.p_MSFF, "", TariffNbr);
  extUploadSingleTableRow("272", va, vt_Ex1, L_SFee.p_MSFF, "", TariffNbr);
  extUploadSingleTableRow("274", va, vt_Ovr, L_SFee.p_MSFF, "", TariffNbr);
  extUploadSingleTableRow("276", va, vt_Tax, L_SFee.p_MSFF, "", TariffNbr);
 END {UploadPart2_Common};

 PRIVATE PROCEDURE IncArr(VAR TotArr, Arr           : NUMERIC[2][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE i <= HIGH(TotArr) DO
   INC(TotArr[i], Arr[i]);
   INC(i);
  END;
 END {IncArr};

 PRIVATE PROCEDURE MakePart2_Common(VAR Tot_va     : tValArr;
                                    VAR Tot_maaPFA1: tManAmountArr;
                                    VAR Tot_maaPFA2: tManAmountArr);

  VAR
   TariffNbr   : STRING[];
   trgType     : LIKE(ManSFee.Type);
   TariffCode  : SCAL[99];
   a           : L_SFee.tManAgeGroup;
   g           : tManGroup;
   maa, maaOvr : tManAmountArr;
   FeePresence : tFeePresenceArr;
   TaxationMode: P_MyFirm.tTaxationMode;
   va          : tValArr;
   maaPFA1,
   maaPFA2     : tManAmountArr;
 BEGIN
  L_AFM.MakeMultipleIndex("Invalid", "Man   : LIKE(Man.Man);"+
                                     "Period: DATE;"+
                                     "AgeGrp: " + TYPENAMEOF(L_SFee.tManAgeGroup),
                          "Man: Man, Period, AgeGrp");

  TariffNbr   :="_1";
  TaxationMode:=P_MyFirm.GetTaxationMode(curMyFirm, BPer);
  IF    TaxationMode = P_MyFirm.tm_Common THEN
   TariffCode:=01;
   trgType   :=L_SFee.t_Normal;
  ELSIF P_MyFirm.IsUSNO(TaxationMode) | (TaxationMode = P_MyFirm.tm_ENVD) THEN
   IF L_SFee.IsUSNOLowSFee(curMyFirm, EPer) THEN
    TariffCode:=07;
   ELSE
    TariffCode:=52;
   END;
   trgType   :=L_SFee.t_USNO;
  ELSE
   L_General.CallUs(0);
  END;

  SETZERO(va, maa, maaOvr, maaPFA1, maaPFA2);
  SELECT(ManSFee, Actual, , 1, curMyFirm);
  WHILE OCCURE(ManSFee) DO
   PROMPT("⮢: " + ManSFee.Man);
   NARROWSEL(ManSFee, Man);
   SETZERO(FeePresence);
   IF SRCINSEL(ManSFee, GE, BPer) THEN
    CONFORM(ManSFee, Man);
    a:=L_SFee.ManAgeGroup(EPer);
    WHILE OCCURE(ManSFee) & (ManSFee.Period <= EPer) DO
     IF ManSFee.Type # L_SFee.t_Invalid THEN
      IF (ManSFee.Type = L_SFee.t_woCtzn)            |
         (ManSFee.Type = L_SFee.t_woCtzn_Commorancy) |
         (ManSFee.Type = L_SFee.t_woCtzn_TmpResidence) THEN
       g:=mg_Frg;
      ELSE
       g:=a;
      END;
      pd_FillFee(va, maa, maaOvr, maaPFA1, maaPFA2, FeePresence, g);
     ELSE
      ADD(Invalid, Man, , Man.Man, ManSFee.Period, a);
     END;
     NEXT(ManSFee);
    END; (* WHILE OCCURE(File) *)
   END; (* IF SRCINSEL(ManSFee ... *)
   CalcManAmount(FeePresence, mt_T, maa, maaOvr, maaPFA1, maaPFA2);
   NEXTINEXTENDEDSEL(ManSFee, Man);
  END; (* WHILE OCCURE(ManSFee) ... *)

  UploadPart2_Common(TariffNbr, TariffCode, trgType, va, maa, maaOvr, maaPFA1, maaPFA2);

  IF TariffCode = 07 THEN
   㧨ਡ_ॡ筮("361_3", 0);
   㧨ਡ_ॡ筮("362_3", 0);
  END;

  IncArr(Tot_va,      va);
  IncArr(Tot_maaPFA1, maaPFA1);
  IncArr(Tot_maaPFA2, maaPFA2);
 END {MakePart2_Common};

 PRIVATE PROCEDURE MakePart2_Invalid(VAR Tot_va     : tValArr;
                                     VAR Tot_maaPFA1: tManAmountArr;
                                     VAR Tot_maaPFA2: tManAmountArr);
  VAR
   trgTable2       : LIKE(PckATER.Table2);
   TariffNbr       : STRING[];
   a               : L_SFee.tManAgeGroup;
   g               : tManGroup;
   maa,
   maaOvr,
   maa_Dummy       : tManAmountArr;
   ManCnt          : NUMERIC[0];
   trgType         : LIKE(ManSFee.Type);
   TariffCode      : SCAL[99];
   va_SingleInval  : tValArr;
   FeePresence,
   dummyFeePresence: tFeePresenceArr;
   va              : tValArr;
   maaPFA1,
   maaPFA2         : tManAmountArr;
   Surname,
   FirstName,
   Patronymic      : STRING[];
 BEGIN
  SETZERO(va, maa, maaOvr, maaPFA1, maaPFA2, maa_Dummy, ManCnt);
  IF SELECT(Invalid, Man) THEN
   trgTable2 :=L_ATER.ZeroTable;
   TariffNbr :="_2";
   TariffCode:=03;
   trgType   :=L_SFee.t_Invalid;

   WHILE OCCURE(Invalid) DO
    NARROWSEL(Invalid, Man);
    SEARCH(Man, Man, , Invalid.Man);
    PROMPT("㧪: " + L_Man.Man_ManAsStr());
    SETZERO(va_SingleInval, FeePresence, dummyFeePresence);
    WHILE OCCURE(Invalid) DO
     SELECT(ManSFee, MyFirm, , curMyFirm, Invalid.Man, 1, Invalid.Period);
     WHILE OCCURE(ManSFee) DO
      IF ManSFee.Type = L_SFee.t_Invalid THEN
       pd_FillFee(va,             maa,       maaOvr,    maaPFA1,   maaPFA2,   FeePresence,      Invalid.AgeGrp);
       pd_FillFee(va_SingleInval, maa_Dummy, maa_Dummy, maa_Dummy, maa_Dummy, dummyFeePresence, Invalid.AgeGrp);
      END;
      NEXT(ManSFee);
     END; (* WHILE OCCURE(ManSFee) ... *)
     L_General.Assert(L_SFee.ManIsInvalid(Man.Man, Invalid.Period),
                      " " + L_Man.Man_ManAsStr() + ": 믫  |" +
                      "   ᠭ   " + L_DatTim.DateStr(Invalid.Period));
     L_General.Assert(~!ManPro.DocGiveD, " " + L_Man.Man_ManAsStr() + ":|   뤠 ࠢ  ");
     NEXT(Invalid);
    END; (* WHILE OCCURE(Invalid) ... *)
    L_Man.curMan_SplitName(Surname, FirstName, Patronymic);
    ext㧨(    trgTable2, "_",           trgTable2+1);
    ext㧨_(trgTable2, "_",               Man.RECORDID);
    ext㧨_(trgTable2, "_",           Str.Cap(Surname));
    ext㧨_(trgTable2, "_",               Str.Cap(FirstName));
    ext㧨_(trgTable2, "_⢮",          Str.Cap(Patronymic));
    ext㧨_(trgTable2, "_⠂뤠稑ࠢ", L_DatTim.DateStr(ManPro.DocGiveD));
    IF ~!ManPro.DocExpD THEN
     ext㧨_(trgTable2, "_⠎砭⢨", L_DatTim.DateStr(ManPro.DocExpD));
    ELSE
     ext㧨_(trgTable2, "_⠎砭⢨", L_DatTim.DateStr(L_DatTim.YearEnd(BPer)));
    END;
    intUploadSingleTableRow(trgTable2,
                            va_SingleInval, vt_Obj, MINOF(L_SFee.tPart), "",
                            "_㬬",
                            "_㬬_1|_㬬_2|_㬬_3",
                            GetInvalidPaymentsFromPrvPacket(prvRSVPacket, Man.RECORDID),
                            "p_㬬",
                            FLDTOSTR(Man.Man, "", 5) + " " + L_Str.ShortName(Man.Name) + " ",
                            "");
    INC(trgTable2);
    CalcManAmount(FeePresence, mt_T, maa, maaOvr, maaPFA1, maaPFA2);
    INC(ManCnt);
    NEXTINEXTENDEDSEL(Invalid, Man);
   END; (* WHILE OCCURE(Invalid) ... *)

   㧨("⢮⭨", ManCnt);
   UploadPart2_Common(TariffNbr, TariffCode, trgType, va, maa, maaOvr, maaPFA1, maaPFA2);
  END;

  IncArr(Tot_va,      va);
  IncArr(Tot_maaPFA1, maaPFA1);
  IncArr(Tot_maaPFA2, maaPFA2);
 END {MakePart2_Invalid};

 PRIVATE PROCEDURE MakePart2_2(Tot_va     : tValArr;
                               Tot_maaPFA1: tManAmountArr;
                               Tot_maaPFA2: tManAmountArr);
 BEGIN
  extUploadSingleTableRow("280", Tot_va, vt_Obj, L_SFee.p_PFA1, "", "");
  extUploadSingleTableRow("281", Tot_va, vt_Ex1, L_SFee.p_PFA1, "", "");
  extUploadSingleTableRow("284", Tot_va, vt_Tax, L_SFee.p_PFA1, "", "");
  UploadSingleAmountRow(  "285", Tot_maaPFA1, "");

  extUploadSingleTableRow("290", Tot_va, vt_Obj, L_SFee.p_PFA2, "", "");
  extUploadSingleTableRow("291", Tot_va, vt_Ex1, L_SFee.p_PFA2, "", "");
  extUploadSingleTableRow("294", Tot_va, vt_Tax, L_SFee.p_PFA2, "", "");
  UploadSingleAmountRow(  "295", Tot_maaPFA2, "");
 END {MakePart2_2};

 PRIVATE PROCEDURE MakePart4(ZeroManAmount: SCAL[2]);
  VAR
   p                     : L_SFee.tPart;
   est                   : L_PRoll.tExtensionSubType;
   Msg                   : STRING[];
   Period                : DATE;
   dummyDTS              : TIMESTAMP;
   TotalFee              : LIKE(ManSFee.Fee);
   trgTable2             : LIKE(PckATER.Table2);
 BEGIN
  IF ~ZeroManAmount | ~IsPolakSpecific() THEN
   L_SFee.PrepareChanges(curMyFirm, BPer, EMPTYOF(DATE), L_DatTim.GetLastDateOfQuartal(EPer));
 
   trgTable2:=L_ATER.ZeroTable;
   SELECT(MSFCh, Period, , curMyFirm);
   WHILE OCCURE(MSFCh) DO
    NARROWSEL(MSFCh, Period);
    Period:=MSFCh.Period;
    est   :=MSFCh.est;
    SETZERO(TotalFee);
    WHILE OCCURE(MSFCh) DO
     FOR_EACH p DO
      INC(TotalFee[p], MSFCh.Fee[p]);
     END; (* FOR_EACH p... *)
     NEXT(MSFCh);
    END; (* WHILE OCCURE(MSFCh) ... *)
 
    IF (TotalFee[L_SFee.p_PFOv] # 0) |
       (TotalFee[L_SFee.p_PFIn] # 0) | (TotalFee[L_SFee.p_PFAc] # 0) |
       (TotalFee[L_SFee.p_PFA1] # 0) | (TotalFee[L_SFee.p_PFA2] # 0) |
       ((TotalFee[L_SFee.p_MSFF]+TotalFee[L_SFee.p_MSTF]) # 0) THEN
     ext㧨(trgTable2, "᫥_",                trgTable2+1);
     IF    est = L_PRoll.est_byMyself THEN
      ext㧨(trgTable2, "᫥_᭮",              2);
     ELSIF est = L_PRoll.est_byAudit THEN
      ext㧨(trgTable2, "᫥_᭮",              1);
     END;
  
     ext㧨(trgTable2, "᫥_",                    L_DatTim.YEAR(Period));
     ext㧨(trgTable2, "᫥_",                  L_DatTim.MONTH(Period)+1);
     ext㧨(trgTable2, "᫥__襏।", TotalFee[L_SFee.p_PFOv]);
     ext㧨(trgTable2, "᫥_",                  TotalFee[L_SFee.p_PFIn]);
     ext㧨(trgTable2, "᫥_",                  TotalFee[L_SFee.p_PFAc]);
     ext㧨(trgTable2, "᫥__1",        TotalFee[L_SFee.p_PFA1]);
     ext㧨(trgTable2, "᫥__2",        TotalFee[L_SFee.p_PFA2]);
     ext㧨(trgTable2, "᫥_",                    TotalFee[L_SFee.p_MSFF]+TotalFee[L_SFee.p_MSTF]);
     INC(trgTable2);
    END;
    NEXTINEXTENDEDSEL(MSFCh, Period);
   END; (* WHILE OCCURE(MSFCh) ... *)
  END;
 END {MakePart4};

 PRIVATE PROCEDURE PrepareData(ManualMake: SCAL[2]; TotalAmount: NUMERIC[0]);
  VAR
   Tot_va       : tValArr;
   Tot_maaPFA1  : tManAmountArr;
   Tot_maaPFA2  : tManAmountArr;
   AverageAmount: NUMERIC[0];
 BEGIN
  IF ManualMake THEN
   AverageAmount:=L_ATER.GetAverageCount(BPer, EPer, curMyFirm);
  ELSE
   SETZERO(AverageAmount);
  END;

  㧨("।ᯨ筠᫥", AverageAmount);
  㧨("⢮", TotalAmount);
  㧨ਡ_ॡ筮("⢮⮢ਫ", 0);
  㧨ਡ_ॡ筮("⢮࠭", 1);

  SETZERO(Tot_va, Tot_maaPFA1, Tot_maaPFA2);
  MakePart2_Common(Tot_va, Tot_maaPFA1, Tot_maaPFA2);
  MakePart2_Invalid(Tot_va, Tot_maaPFA1, Tot_maaPFA2);
  MakePart2_2(Tot_va, Tot_maaPFA1, Tot_maaPFA2);
  IF ManualMake THEN
   MakePart4((TotalAmount = 0) & (AverageAmount = 0));
  END;
 END {PrepareData};

 PRIVATE PROCEDURE AddContractToList(    trgContract : LIKE(Contract.Contract);
                                     VAR ContractList: LIKE(Contract.Contract)[]);
  VAR
   i             : NUMERIC[0];
   ItsNewContract: SCAL[2];
 BEGIN
  i             :=0;
  ItsNewContract:=1;
  WHILE (i <= HIGH(ContractList)) & ~!ContractList[i] & ItsNewContract DO
   IF ContractList[i] = trgContract THEN
    ItsNewContract:=0;
   END;
   INC(i);
  END; (* WHILE (i <= HIGH(ContractList)) &... *)
  L_General.CallUs(i <= HIGH(ContractList));
  IF ItsNewContract THEN
   ContractList[i]:=trgContract;
  END;
 END {AddContractToList};

 PRIVATE PROCEDURE GetErknedContractList(    P           : DATE;
                                             _Notion     : L_APtm.tNotion;
                                         VAR ContractList: LIKE(Contract.Contract)[]): SCAL[2];
  VAR
   EndMonth   : DATE;
   Result     : SCAL[2];
   EndPrvYear : DATE;
   trgContract: LIKE(Contact.Contact);
 BEGIN
  SETZERO(Result);
  EndPrvYear:=L_DatTim.YearBeg(P) - 1;
  SETEMPTY(ContractList);
  LOOP
   EndMonth:=L_DatTim.MonthEnd(P);
   IF EndMonth < EndPrvYear THEN
    EXIT;
   END;
   trgContract:=L_Cntr.erkn_GetSoft(EndMonth, _Notion, curMyFirm);
   IF ~!trgContract THEN
    Result:=1;
    AddContractToList(trgContract, ContractList);
   END;
   P:=L_DatTim.IncMonth(P, -1);
  END; (* LOOP *)
  RETURN Result;
 END {GetErknedContractList};

 PRIVATE PROCEDURE SetupXObjectByErknedContract(    trgContract: LIKE(Contract.Contract);
                                                VAR trgXObject : LIKE(XObject.XObject);
                                                VAR trgAcCut   : LIKE(AcCut.AcCut));
 BEGIN
  SEARCH(Contract, Contract, , trgContract);
  trgXObject:=Contract.XObject;
  trgAcCut  :=L_Acnt.GetSpecificAcCutForContract(Contract.Contract, L_Acnt.acp_Contract_Netto);
 END {SetupXObjectByErknedContract};

 PRIVATE PROCEDURE sf_GetPmntValue(p             : L_SFee.tPart;
                                   AcntVectorPart: L_Acnt.tAcntVectorPart;
                                   ContractDate,
                                   PerB, PerE    : DATE): NUMERIC[2];
  VAR
   i           : NUMERIC[0];
   Total       : L_Acnt.tAcntVector;
   Result      : NUMERIC[2];
   dummyAcCut  : LIKE(AcCut.AcCut);
   trgXObject  : LIKE(XObject.XObject);
   ContractList: tContractListArr;
 BEGIN
  IF GetErknedContractList(L_DatTim.Per(PerE), L_SFee.sfp2Notion(p), ContractList) THEN
   SETZERO(i, Result);
   WHILE (i <= HIGH(ContractList)) & ~!ContractList[i] DO
    SetupXObjectByErknedContract(ContractList[i], trgXObject, dummyAcCut);
    Total:=L_XObj.GetAcntVector(trgXObject,
                                L_AcCut.erkn_Get(ContractDate, L_AcCut.erkn_OnlineBalance),
                                EMPTYOF(AcCut.AcCut),
                                PerB, PerE);
    INC(Result, Total[AcntVectorPart]);
    INC(i);
   END; (* WHILE (i <= HIGH(ContractList)) &... *)
   RETURN Result;
  ELSE
   RETURN EMPTYOF(Result);
  END;
 END {sf_GetPmntValue};

 PRIVATE PROCEDURE sf_GetInSaldo(p: L_SFee.tPart; ContractDate: DATE): NUMERIC[2];
  VAR
   InSaldo,
   MSTFInSaldo: NUMERIC[2];
 BEGIN
  InSaldo:=sf_GetPmntValue(p, L_Acnt.avp_InSaldo, ContractDate, BPer, EPer);
  IF ~!InSaldo THEN
   InSaldo:=(-1) * InSaldo;
  END;

  IF p = L_SFee.p_MSFF THEN
   MSTFInSaldo:=sf_GetInSaldo(L_SFee.p_MSTF, ContractDate);
   IF ~!InSaldo & ~!MSTFInSaldo THEN
    INC(InSaldo, MSTFInSaldo);
   END;
  END;
  RETURN InSaldo;
 END {sf_GetInSaldo};

 PRIVATE PROCEDURE Part1_UploadRow140SingleCol(Col: STRING[];
                                               va : tValArr;
                                               p  : L_SFee.tPart);
 BEGIN
  intUploadSingleTableRow(L_ATER.ZeroTable,
                          va, vt_Tax, p, MINOF(tManGroup),
                          "140_"+Col,
                          "141_"+Col+"|142_"+Col+"|143_"+Col,
                          GetValueFromPrvPacket(prvRSVPacket, "140_"+Col),
                          "p140_"+Col,
                          "",
                          "");
 END {Part1_UploadRow140SingleCol};

 PRIVATE PROCEDURE sf_GetPmntValues(begPer, endPer: DATE; VAR va: tValArr);
  VAR
   p           : L_SFee.tPart;
   mt          : tMonthType;
   i, idx      : NUMERIC[0];
   Per         : DATE;
   Total       : L_Acnt.tAcntVector;
   trgAcCut    : LIKE(AcCut.AcCut);
   trgXObject  : LIKE(XObject.XObject);
   m_Empty     : SCAL[2][MAXOF(tMonthType)+1];
   TotalDebit  : NUMERIC[2];
   ContractList: tContractListArr;
 BEGIN
  FOR_EACH p DO
   IF L_SFee.IsPartwNotion(endPer, p) THEN
    SETZERO(m_Empty);
    Per:=begPer;
    WHILE Per <= endPer DO
     mt :=pv_Period2MT(Per);
     idx:=pv_GI(vt_Tax, p, MINOF(tManGroup), mt);
     IF    GetErknedContractList(Per, L_SFee.sfp2Notion(p), ContractList) THEN
      SETZERO(i, TotalDebit);
      WHILE (i <= HIGH(ContractList)) & ~!ContractList[i] DO
       SetupXObjectByErknedContract(ContractList[i], trgXObject, trgAcCut);
       Total:=L_XObj.GetAcntVector(trgXObject,
                                   trgAcCut,
                                   EMPTYOF(AcCut.AcCut),
                                   Per, L_DatTim.MonthEnd(Per));
       INC(TotalDebit, Total[L_Acnt.avp_Debit]);
       INC(i);
      END; (* WHILE (i <= HIGH(ContractList)) &... *)
      IF m_Empty[mt] = 0 THEN
       IF !va[idx] THEN
        SETZERO(va[idx]);
       END;
       INC(va[idx], TotalDebit);
      END;
     ELSIF P_MyFirm.IsUSNO(P_MyFirm.GetTaxationMode(curMyFirm, Per)) THEN
      SETZERO(va[idx]);
     ELSE
      m_Empty[mt]:=1;
      SETEMPTY(va[idx]);
     END;
     Per:=L_DatTim.IncMonth(Per, +1);
    END;
   END;
  END; (* FOR_EACH p... *)
 END {sf_GetPmntValues};

 PRIVATE PROCEDURE AddMSFFAndMSTFValues(VAR va: tValArr);
  VAR
   mt      : tMonthType;
   idx_MSFF,
   idx_MSTF: NUMERIC[0];
 BEGIN
  FOR_EACH mt DO
   idx_MSFF:=pv_GI(vt_Tax, L_SFee.p_MSFF, MINOF(tManGroup), mt);
   idx_MSTF:=pv_GI(vt_Tax, L_SFee.p_MSTF, MINOF(tManGroup), mt);
   IF ~!va[idx_MSFF] & ~!va[idx_MSTF] THEN
    INC(va[idx_MSFF], va[idx_MSTF]);
   END;
  END; (* FOR_EACH*)
 END {AddMSFFAndMSTFValues};

 PRIVATE PROCEDURE PutPmntValues();
  VAR
   va          : tValArr;
   prvOMSValue,
   curOMSValue,
   prvMSFFValue,
   prvMSTFValue: NUMERIC[2];
 BEGIN
  㧨ਡ_।("100_3", prvYearRSVPacket, "150_3", sf_GetInSaldo(L_SFee.p_PFIn, BPer));
  㧨ਡ_।("100_4", prvYearRSVPacket, "150_4", sf_GetInSaldo(L_SFee.p_PFAc, BPer));

  IF L_DatTim.YEAR(Packet.PerB) = 2013 THEN
   㧨ਡ_।("100_5", EMPTYOF(Packet.Packet), "", sf_GetInSaldo(L_SFee.p_PFA1, BPer));
   㧨ਡ_।("100_6", EMPTYOF(Packet.Packet), "", sf_GetInSaldo(L_SFee.p_PFA2, BPer));

   prvOMSValue:=GetValueFromPrvPacket(prvYearRSVPacket, "150_5");
  ELSE
   㧨ਡ_।("100_5", prvYearRSVPacket, "150_5", sf_GetInSaldo(L_SFee.p_PFA1, BPer));
   㧨ਡ_।("100_6", prvYearRSVPacket, "150_6", sf_GetInSaldo(L_SFee.p_PFA2, BPer));

   prvOMSValue:=GetValueFromPrvPacket(prvYearRSVPacket, "150_7");
  END;
  curOMSValue:=sf_GetInSaldo(L_SFee.p_MSFF, BPer);
  int㧨ਡ_।("100_7", prvOMSValue, curOMSValue);

  SETEMPTY(va);
  sf_GetPmntValues(Packet.PerB, Packet.PerE, va);
  AddMSFFAndMSTFValues(va);

  Part1_UploadRow140SingleCol("3", va, L_SFee.p_PFIn);
  Part1_UploadRow140SingleCol("4", va, L_SFee.p_PFAc);
  Part1_UploadRow140SingleCol("5", va, L_SFee.p_PFA1);
  Part1_UploadRow140SingleCol("6", va, L_SFee.p_PFA2);
  Part1_UploadRow140SingleCol("7", va, L_SFee.p_MSFF);
 END {PutPmntValues};

 PRIVATE PROCEDURE Make(ManualMake: SCAL[2]; TotalAmount: NUMERIC[0]);
  VAR
   RepName: STRING[];
 BEGIN
  RepName           :="X15_" + Packet.Packet;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  L_Packet.DefinePckMyFirm(L_Packet.bm_byPacket);
  CONFORM(Packet, ATER);

  㧨_("", L_Packet.trnFileName());
  IF L_General.GetAPSiteNumber() = 96 THEN
   L_Packet.ext_psf_Str("।ਮ", prvRSVPacket, L_ATER.ZeroTable, L_ATER.ZeroRow2);
  ELSE
   㧨_("।ਮ", prvRSVPacket);
  END;

  PutPmntValues();

  PrepareData(ManualMake, TotalAmount);

  L_Packet.PutManualInputATERAttr();

  L_Packet.SetDTStamp();
  Packet.PrpDate :=SYSDATE();
  Packet.DTStamp :=L_Packet.DTStamp;
  Packet.DataType:=L_Packet.dt_None;
  Packet.CorrType:=L_Packet.ct_None;
  REPLACE(Packet);
  MAKEPART(R, Bot);
 END {Make};

 PUBLIC PROCEDURE intXOMN15(ManualMake: SCAL[2]);
  VAR
   TotalAmount: NUMERIC[0];
 BEGIN
  curMyFirm:=Packet.MyFirm;
  L_Packet.CheckQuartalATER(ManualMake, IsFirstQuartalPacket, BPer, EPer);

  IF L_APtm.MonthIsClosed(EPer, L_APtm.system_Salary) THEN
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  END;
  L_General.Assert_wReferToAdmin(L_SFee.SFeeIsCalculatedInProperConsecution(L_DatTim.Per(EPer)),
                                 "ॡ  客 ᮢ  " + L_DatTim.PeriodStr(EPer) + " ᫥  |" +
                                 "    ⥫");
  L_Packet.ClearATER(0);

  IF ManualMake THEN
   TotalAmount:=CALL(ManIns.CalcNumOfInsMen(curMyFirm, BPer, EPer));
   IF !TotalAmount & IsPolakSpecific() THEN
    SETZERO(TotalAmount);
   END;
  ELSE
   SETZERO(TotalAmount);
  END;
  IF L_DatTim.IsLastMonthOfQuartal(EPer) & (BPer = L_DatTim.YearBeg(EPer)) THEN
   IF ~APP.Get().ProductiveCopy THEN
    STDFORM(L_StdFrm.sf_Choice("|⮢ -1  ⢨ ନ஢" +
                               "|ᢥ ᮭ஢   ୮ " +
                               "||⢮ 客  %####%",
                               "%RI"),
            "",
            INFORM,
            ,
            TotalAmount);

   ELSE
    L_General.Assert(~!TotalAmount, " ନ஢ -1 ॡ 稥 ନ஢|" +
                                    "ᢥ ᮭ஢   ਮ  " + L_DatTim.PeriodStr(BPer) + "  " + L_DatTim.PeriodStr(EPer));
   END;
  END;

  prvYearRSVPacket:=L_ATER.GetPrvYearPacket(Packet.Packet);
  prvRSVPacket    :=L_ATER.GetPrvQuartalPacket(Packet.Packet, L_ATER.GetPckATERValue_Str(Packet.Packet, "।ਮ", L_ATER.ZeroTable));

  ShowReportRequired:=0;
  Make(ManualMake, TotalAmount);
  IF ManualMake & ShowReportRequired THEN
   L_General.SurveyLastReport();
  END;
 END {intXOMN15};

 PUBLIC PROCEDURE XOMN15();
 BEGIN
  intXOMN15(1);
 END {XOMN15};

END.
