(*
%Copyright   (c) Polak IT
%Author      07.04.2010 11:34:50 POLAK\San
%Purpose     -1  01.2014
%Type        report
%Specific    AP
%Modified    11.08.2014 09:22:42 POLAK\LDA
%Environment
*)

 MODULE XOMN16 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Packet, L_DatTim, L_Str, L_StdFrm, P_MyFirm, Str, L_AFM, L_SFee, L_Man, L_PRoll,
        L_APtm, L_Cntr, L_XObj, L_Acnt, L_AcCut, L_ATER, Math, P_Firm, L_Env, L_ExtAb, L_PDoc, P_Officer;

 PRIVATE TYPE
  tValueType      = SCAL[7];
  tMonthType      = SCAL[4];
  tFeePresenceArr = SCAL[2][L_SFee.p_Amount];
  tTariffCode     = SCAL[99];

 PRIVATE CONST
  tc_Invalid     = 03;
  tc_USNOLowSFee = 07;

  vt_Bas    = 0;
  vt_Obj    = 1;
  vt_Exc    = 2;
  vt_Tax    = 3;
  vt_Ovr    = 4;
  vt_Pay    = 5;
  vt_PayOld = 6;

  mt_1 = 0;
  mt_2 = 1;
  mt_3 = 2;
  mt_P = 3;
  mt_T = 3; (* ᫥ - ᥣ  ਮ  mt_P*)

 PRIVATE TYPE
  tContractListArr = LIKE(Contract.Contract)[5];

 PRIVATE VAR
  DEBUG               : SCAL[2];
  BPer, EPer          : DATE;
  curMyFirm           : LIKE(MyFirm.MyFirm);
  prvYearRSVPacket,
  prvRSVPacket        : LIKE(Packet.Packet);
  ShowProtocolRequired,
  IsFirstQuartalPacket: SCAL[2];

(*
$P{ Top:
P_Firm.FP_ContractorBriefName(P_Firm.fomf(curMyFirm), Packet.PerE), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Packet.Packet, L, ""
Packet.PerB, L, "N.y"
Packet.PerE, L, "N.y"
@
############################################################################################# ########## #####
=##########===================================================================================================
|                  ⮪ ନ஢   客 ᠬ     (-1)                   |
|                                  #######  ਮ  #######  #######                                |
|------------------------------------------------------------------------------------------------------------|
|ਡ                                                        |  ⠭|   ᫥|   c宦|
|                                                               |        |  ()|              |
|---------------------------------------------------------------|--------------|--------------|--------------|
}
*)

(*
$P{ Line:
?, L, ""
?, R, "2-"
?, R, "2-"
?, R, "2-"
@
|###############################################################|##############|##############|##############|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE IsPolakSpecific(): SCAL[2];
 BEGIN
  RETURN L_General.IsPolakSpecific() & ((curMyFirm = L_Env.mf_KPR) |
                                        (curMyFirm = L_Env.mf_LSF) |
                                        (curMyFirm = L_Env.mf_PIT) & (L_DatTim.YEAR(Packet.PerB) >= 2014));
 END {IsPolakSpecific};

 PRIVATE PROCEDURE pv_Period2MT(Period: DATE): tMonthType;
  VAR
   ma: NUMERIC[0];
 BEGIN
  ma:=L_DatTim.MONTH(L_DatTim.GetLastDateOfQuartal(EPer)) - L_DatTim.MONTH(Period);
  IF    ma = 0                 THEN RETURN mt_3;
  ELSIF ma = 1                 THEN RETURN mt_2;
  ELSIF ma = 2                 THEN RETURN mt_1;
  ELSIF (ma >= 3) & (ma <= 11) THEN RETURN mt_P;
  ELSE                              L_General.CallUs(0);
  END;
 END {pv_Period2MT};

 PRIVATE PROCEDURE ext㧨_(trgTable2: LIKE(PckATER.Table2); Name: STRING[]; Value: NUMERIC[2]);
 BEGIN
  IF ~!Value THEN
   L_Packet.psf_Num    (Name, Value, trgTable2, L_ATER.ZeroRow2);
  ELSE
   L_Packet.ext_psf_Num(Name, Value, trgTable2, L_ATER.ZeroRow2, L_Packet.src_Operator);
  END;
 END {ext㧨_};

 PRIVATE PROCEDURE 㧨(Name: STRING[]; Value: NUMERIC[2]);
 BEGIN
  ext㧨_(L_ATER.ZeroTable, Name, Value);
 END {㧨};

 PRIVATE PROCEDURE ext㧨_(trgTable2: LIKE(PckATER.Table2); Name: STRING[]; Value: STRING[]);
 BEGIN
  L_Packet.psf_Str(Name, Value, trgTable2, L_ATER.ZeroRow2);
 END {ext㧨_};

 PRIVATE PROCEDURE 㧨_(Name: STRING[]; Value: STRING[]);
 BEGIN
  ext㧨_(L_ATER.ZeroTable, Name, Value);
 END {㧨_};

 PRIVATE PROCEDURE GetValueByPrvValue(prvValue: NUMERIC[2];
                                      curValue: NUMERIC[2]): NUMERIC[2];
  VAR
   Result: NUMERIC[2];
 BEGIN
  Result:=prvValue;
  IF !Result THEN
   Result:=curValue;
  END;
  RETURN Result;
 END {GetValueByPrvValue};

 PRIVATE PROCEDURE int㧨ਡ_।(curName : STRING[];
                                                    prvValue: NUMERIC[2];
                                                    curValue: NUMERIC[2]);
 BEGIN
  㧨(curName, GetValueByPrvValue(prvValue, curValue));
 END {int㧨ਡ_।};

 PRIVATE PROCEDURE GetValueFromPrvPacket(prvPacket: LIKE(Packet.Packet);
                                         prvName  : STRING[]): NUMERIC[2];
  VAR
   prvValue: NUMERIC[2];
 BEGIN
  SETEMPTY(prvValue);
  IF    IsFirstQuartalPacket THEN
   prvValue:=0;
  ELSIF ~!prvPacket THEN
   prvValue:=L_ATER.extGetNumericValueFromPacket(prvPacket, prvName, L_ATER.ZeroTable, 1);
  END;
  RETURN prvValue;
 END {GetValueFromPrvPacket};

 PRIVATE PROCEDURE 㧨ਡ_।(curName  : STRING[];
                                                 prvPacket: LIKE(Packet.Packet);
                                                 prvName  : STRING[];
                                                 curValue : NUMERIC[2]);
 BEGIN
  int㧨ਡ_।(curName,
                                   GetValueFromPrvPacket(prvPacket, prvName),
                                   curValue);
 END {㧨ਡ_।};

 PRIVATE PROCEDURE 㧨ਡ_ॡ筮(Name: STRING[]; Value: NUMERIC[2]);
 BEGIN
  L_Packet.ext_psf_Num(Name, Value, L_ATER.ZeroTable, L_ATER.ZeroRow2, L_Packet.src_Operator);
 END {㧨ਡ_ॡ筮};

 PRIVATE PROCEDURE GetValue(v         : tValueType;
                            p         : L_SFee.tPart;
                            mt        : tMonthType;
                            TariffCode: tTariffCode;
                            ReasonCode: L_SFee.tPFAReasonCode): NUMERIC[2];
  VAR
   Result  : NUMERIC[2];
   b_p, e_p: L_SFee.tPart;
 BEGIN
  SETEMPTY(Result);
  IF SELECT(_Values, _Values, v) THEN
   Result:=0;
   IF !p THEN b_p:=MINOF(p); e_p:=MAXOF(p);
   ELSE       b_p:=p;        e_p:=p;
   END;
   WHILE OCCURE(_Values) DO
    IF !mt | (_Values.MonthT = mt) THEN
     IF !TariffCode | (_Values.TariffC = TariffCode) THEN
      IF !ReasonCode | (_Values.ReasonC = ReasonCode) THEN
       p:=b_p;
       LOOP
        INC(Result, _Values.Value[p]);
        IF p = e_p THEN
         EXIT;
        END;
        INC(p);
       END; (* LOOP *)
      END;
     END;
    END;
    NEXT(_Values);
   END; (* WHILE OCCURE(_Values) ... *)
  END;
  IF !Result THEN
   IF (v # vt_Pay) & (v # vt_PayOld) THEN
    Result:=0;
   END;
  END;
  RETURN Result;
 END {GetValue};

 PRIVATE PROCEDURE UploadSingleTableRow(Name       : STRING[];
                                        TotalValue : NUMERIC[2];
                                        ValuesByPer: NUMERIC[2][MAXOF(tMonthType)+1];
                                        NamesByPer : STRING[];
                                        prvName    : STRING[];
                                        Suffix     : STRING[]);
  VAR
   mt       : tMonthType;
   Delta,
   mValue,
   prvValue,
   curValueC,
   curValueP: NUMERIC[2];
   mValuesP : NUMERIC[2][3];
 BEGIN
  prvValue:=GetValueFromPrvPacket(prvRSVPacket, Name+Suffix);

  IF IsFirstQuartalPacket & !ValuesByPer[mt_P] THEN
   ValuesByPer[mt_P]:=0;
  END;

  SETZERO(Delta);
  SETEMPTY(mValuesP);
  prvValue :=GetValueByPrvValue(prvValue, ValuesByPer[mt_P]);
  curValueP:=prvValue;
  mt       :=mt_1;
  WHILE mt <= mt_3 DO
   IF ~!ValuesByPer[mt] THEN
    mValue   :=ValuesByPer[mt];
    INC(ValuesByPer[mt_P], ValuesByPer[mt]);
    curValueC:=ValuesByPer[mt_P];
    INC(Delta, curValueC - curValueP);
 
    IF ValuesByPer[mt] # 0 THEN
     mValuesP[mt]:=Delta;
     SETZERO(Delta);
     INC(curValueP, mValuesP[mt]);
 
     IF Math.Abs(mValue - mValuesP[mt]) # 0 THEN
      ShowProtocolRequired:=1;
      L_Packet.StandOnATERAttrByPublicName(L_Str.PoolItem(NamesByPer, mt)+Suffix);
      MAKEPART(R, Line, ATERAttr.Name,
                        mValue,
                        mValuesP[mt],
                        mValue - mValuesP[mt]);
  
     END;
    ELSE
     mValuesP[mt]:=ValuesByPer[mt];
    END;
   END;
   INC(mt);
  END; (* WHILE i <= mt...*)

  IF ~!TotalValue & ~!curValueP &
     ((TotalValue - curValueP) # 0) THEN
   ShowProtocolRequired:=1;
   L_Packet.StandOnATERAttrByPublicName(Name+Suffix);
   MAKEPART(R, Line, ATERAttr.Name,
                     TotalValue,
                     curValueP,
                     TotalValue-curValueP);
  END;

  IF ~!prvName THEN
   ext㧨_(L_ATER.ZeroTable, prvName+Suffix, prvValue);
  END;
  mt:=mt_1;
  WHILE mt <= mt_3 DO
   ext㧨_(L_ATER.ZeroTable, L_Str.PoolItem(NamesByPer, mt)+Suffix, mValuesP[mt]);
   INC(mt);
  END; (* WHILE i <= mt...*)
 END {UploadSingleTableRow};

 PRIVATE PROCEDURE GetManAmount(p         : L_SFee.tPart;
                                mt        : tMonthType;
                                TariffCode: tTariffCode;
                                ReasonCode: L_SFee.tPFAReasonCode): NUMERIC[0];

  VAR
   Result: NUMERIC[0];
 BEGIN
  IF ~!TariffCode & ~!ReasonCode THEN
   L_General.CallUs(0);
  END;

  SETZERO(Result);
  SELECT(MAmnt, MAmnt, , mt, p, TariffCode, ReasonCode);
  WHILE OCCURE(MAmnt) DO
   INC(Result, MAmnt.ManAmnt);
   NEXT(MAmnt);
  END; (* WHILE OCCURE(MAmnt) ... *)

  RETURN Result;
 END {GetManAmount};

 PRIVATE PROCEDURE UploadSingleRow_Amount(Name      : STRING[];
                                          p         : L_SFee.tPart;
                                          TariffCode: tTariffCode;
                                          ReasonCode: L_SFee.tPFAReasonCode;
                                          Suffix    : STRING[]);
  VAR
   mt: tMonthType;
 BEGIN
  mt:=mt_1;
  FOR_EACH mt DO
   㧨(L_Str.PoolItem(Name+"_4|"+Name+"_5|"+Name+"_6|"+Name+"_3", mt)+Suffix, GetManAmount(p, mt, TariffCode, ReasonCode));
  END; (* FOR_EACH *)
 END {UploadSingleRow_Amount};

 PRIVATE PROCEDURE intUploadSingleRow_Money(Name      : STRING[];
                                            v         : tValueType;
                                            p         : L_SFee.tPart;
                                            TariffCode: tTariffCode;
                                            ReasonCode: L_SFee.tPFAReasonCode;
                                            NamesByPer: STRING[];
                                            prvName   : STRING[];
                                            Suffix    : STRING[]);
  VAR
   mt         : tMonthType;
   prvValue   : NUMERIC[2];
   TotalValue : NUMERIC[3];
   ValuesByPer: NUMERIC[2][MAXOF(tMonthType)+1];
 BEGIN
  SETEMPTY(ValuesByPer);
  TotalValue       :=GetValue(v, p, EMPTYOF(mt_P), TariffCode, ReasonCode);
  ValuesByPer[mt_P]:=GetValue(v, p, mt_P,          TariffCode, ReasonCode);

  mt:=mt_1;
  WHILE mt <= mt_3 DO
   ValuesByPer[mt]:=GetValue(v, p, mt, TariffCode, ReasonCode);
   INC(mt);
  END; (* WHILE i <= mt...*)

  UploadSingleTableRow(Name, TotalValue, ValuesByPer, NamesByPer, prvName, Suffix);
 END {intUploadSingleRow_Money};

 PRIVATE PROCEDURE UploadSingleRow_Money(Name      : STRING[];
                                         v         : tValueType;
                                         p         : L_SFee.tPart;
                                         TariffCode: tTariffCode;
                                         ReasonCode: L_SFee.tPFAReasonCode;
                                         Suffix    : STRING[]);
 BEGIN
  intUploadSingleRow_Money(Name+"_3", v, p, TariffCode, ReasonCode, Name+"_4|"+Name+"_5|"+Name+"_6", "p"+Name, Suffix);
 END {UploadSingleRow_Money};

 PRIVATE PROCEDURE IsZeroArr(VAR Arr: NUMERIC[2][]): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  SETZERO(i);
  WHILE i <= HIGH(Arr) DO
   IF Arr[i] # 0 THEN
    RETURN 0;
   END;
   INC(i);
  END;
  RETURN 1;
 END {IsZeroArr};

 PRIVATE PROCEDURE GetMainTariffCode(): tTariffCode;
  VAR
   Result      : tTariffCode;
   TaxationMode: P_MyFirm.tTaxationMode;
 BEGIN
  TaxationMode:=P_MyFirm.GetTaxationMode(curMyFirm, BPer);
  IF    TaxationMode = P_MyFirm.tm_Common THEN
   Result:=01;
  ELSIF P_MyFirm.IsUSNO(TaxationMode) | (TaxationMode = P_MyFirm.tm_ENVD) THEN
   IF L_SFee.IsUSNOLowSFee(curMyFirm, EPer) THEN
    Result:=tc_USNOLowSFee;
   ELSE
    Result:=52;
   END;
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {GetMainTariffCode};

 PRIVATE PROCEDURE intInsMAmnt(trgMan    : LIKE(Man.Man);
                               mt        : tMonthType;
                               p         : L_SFee.tPart;
                               TariffCode: tTariffCode;
                               ReasonCode: L_SFee.tPFAReasonCode);
 BEGIN
  IF ~SEARCH(MAmnt, MAmnt, mt, p, TariffCode, ReasonCode, trgMan) THEN
   ADD(MAmnt, MAmnt, , mt, p, TariffCode, ReasonCode, trgMan,
       MAmnt.ManAmnt, 1);
  END;
 END {intInsMAmnt};

 PRIVATE PROCEDURE InsMAmnt(trgMan    : LIKE(Man.Man);
                            mt        : tMonthType;
                            p         : L_SFee.tPart;
                            TariffCode: tTariffCode;
                            ReasonCode: L_SFee.tPFAReasonCode);
 BEGIN
  intInsMAmnt(trgMan, mt, p, TariffCode,           EMPTYOF(L_SFee.tPFAReasonCode));
  intInsMAmnt(trgMan, mt, p, EMPTYOF(tTariffCode), ReasonCode);
 END {InsMAmnt};

 PRIVATE PROCEDURE CalcManAmount(trgMan     : LIKE(Man.Man);
                                 mt         : tMonthType;
                                 TariffCode : tTariffCode;
                                 ReasonCode : L_SFee.tPFAReasonCode;
                                 FeePresence: tFeePresenceArr);
  VAR
   p: L_SFee.tPart;
 BEGIN
  FOR_EACH p DO
   IF FeePresence[p] # 0 THEN
    InsMAmnt(trgMan, mt, p, TariffCode, ReasonCode);
    IF mt # mt_T THEN
     InsMAmnt(trgMan, mt_T, p, TariffCode, ReasonCode);
    END;
   END;
  END; (* FOR_EACH *)
 END {CalcManAmount};

 PRIVATE PROCEDURE IsNewPFAddPart(p: L_SFee.tPart): SCAL[2];
 BEGIN
  RETURN (p = L_SFee.p_PFA3_1) |
         (p = L_SFee.p_PFA3_2) |
         (p = L_SFee.p_PFA3_3) |
         (p = L_SFee.p_PFA3_4) |
         (p = L_SFee.p_PFA4_0);
 END {IsNewPFAddPart};

 PRIVATE PROCEDURE IsPFAddPart(p: L_SFee.tPart): SCAL[2];
 BEGIN
  RETURN (p = L_SFee.p_PFA1) |
         (p = L_SFee.p_PFA2) |
         IsNewPFAddPart(p);
 END {IsPFAddPart};

 PRIVATE PROCEDURE IsRequiredCalcManAmount(p: L_SFee.tPart): SCAL[2];
 BEGIN
  RETURN (p = L_SFee.p_PFIn)   |
         (p = L_SFee.p_PFOv)   |
         IsPFAddPart(p);
 END {IsRequiredCalcManAmount};

 PRIVATE PROCEDURE CalcValues(v         : tValueType;
                              p         : L_SFee.tPart;
                              mt        : tMonthType;
                              TariffCode: tTariffCode;
                              ReasonCode: L_SFee.tPFAReasonCode;
                              trgValue  : NUMERIC[2]);
 BEGIN
  IF ~SEARCH(_Values, _Values, v, mt, TariffCode, ReasonCode) THEN
   _Values.ValueType:=v;
   _Values.MonthT   :=mt;
   _Values.TariffC  :=TariffCode;
   _Values.ReasonC  :=ReasonCode;
   SETZERO(_Values.Value);
   INSERT(_Values);
  END;

  INC(_Values.Value[p], trgValue);
  REPLACE(_Values);
 END {CalcValues};

 PRIVATE PROCEDURE pd_FillFee();
  VAR
   p                      : L_SFee.tPart;
   Obj, Exc, Bas, Tax, Ovr: NUMERIC[2];
   SingleMonthFeePresence : tFeePresenceArr;
 BEGIN
  SELECT(_MSFee, _MSFee);
  WHILE OCCURE(_MSFee) DO
   NARROWSEL(_MSFee, Man);
   PROMPT("⮢:  " + _MSFee.Man);
   WHILE OCCURE(_MSFee) DO
    SETZERO(SingleMonthFeePresence);
    FOR_EACH p DO
     Obj:=_MSFee.Object;
     Exc:=_MSFee.ExcCmn + _MSFee.ExcPrt[L_SFee.p2b(p)];
     Bas:=_MSFee.Object-_MSFee.ExcCmn-_MSFee.ExcPrt[L_SFee.p2b(p)]-_MSFee.OvrPrt[L_SFee.p2b(p)];
     Tax:=_MSFee.Fee[p];
     Ovr:=_MSFee.OvrPrt[L_SFee.p2b(p)];
  
     IF ((p = L_SFee.p_MSFF) & _MSFee.Frgnr) | ((Tax = 0) & IsPFAddPart(p)) THEN
  (*
  1   ꥪ    ࠭楢
  2   ꥪ    㫥 
  *)
      SETZERO(Obj, Exc, Bas, Ovr);
     END;
  
     CalcValues(vt_Bas, p, _MSFee.MonthT, _MSFee.TariffC, _MSFee.ReasonC, Bas);
     CalcValues(vt_Obj, p, _MSFee.MonthT, _MSFee.TariffC, _MSFee.ReasonC, Obj);
     CalcValues(vt_Exc, p, _MSFee.MonthT, _MSFee.TariffC, _MSFee.ReasonC, Exc);
     CalcValues(vt_Tax, p, _MSFee.MonthT, _MSFee.TariffC, _MSFee.ReasonC, Tax);
     CalcValues(vt_Ovr, p, _MSFee.MonthT, _MSFee.TariffC, _MSFee.ReasonC, Ovr);
  
     IF IsRequiredCalcManAmount(p) & (_MSFee.Fee[p] # 0) THEN
      SingleMonthFeePresence[p]:=1;
     END;
    END; (* FOR_EACH *)
  
    IF ~IsZeroArr(SingleMonthFeePresence) THEN
     IF SingleMonthFeePresence[L_SFee.p_PFIn] = 0 THEN
      SingleMonthFeePresence[L_SFee.p_PFIn]:=1;
     END;
     CalcManAmount(_MSFee.Man, _MSFee.MonthT, _MSFee.TariffC, _MSFee.ReasonC, SingleMonthFeePresence);
    END;

    NEXT(_MSFee);
   END; (* WHILE OCCURE(_MSFee) ... *)
   NEXTINEXTENDEDSEL(_MSFee, Man);
  END; (* WHILE OCCURE(_MSFee) ... *)
 END {pd_FillFee};

(*
$P{ Top_Debug:
@
MonthT;Part;TariffC;ReasonC;ManAmnt;Man
}
*)

(*
$P{ Line_Debug:
MAmnt.MonthT, L, "0"
MAmnt.Part, L, "0"
MAmnt.TariffC, L, "0"
MAmnt.ReasonC, L, "0"
MAmnt.ManAmnt, L, "0"
MAmnt.Man, L, ""
@
##;##;##;##;#####;#####
}
*)

 PRIVATE PROCEDURE IsAcceptableManSFee(mt: tMonthType; prvRSVPacketDTS: TIMESTAMP): SCAL[2];
 BEGIN
  IF ~!prvRSVPacketDTS & (mt = mt_P) THEN
   SEARCH(iga, RECORDID, , ManSFee.ri_iga);
   RETURN iga.DTS <= prvRSVPacketDTS;
  ELSE
   RETURN ManSFee.Actual;
  END;
 END {IsAcceptableManSFee};

 PRIVATE PROCEDURE Gather(MainTariffCode: tTariffCode);
  VAR
   mt             : tMonthType;
   ReasonCode     : L_SFee.tPFAReasonCode;
   TariffCode     : tTariffCode;
   IsForeigner    : SCAL[2];
   prvRSVPacketDTS: TIMESTAMP;
 BEGIN
  L_AFM.MakeMultipleIndex("_Values", "MonthT   : NUMERIC[0];"+
                                     "TariffC  : SCAL[99];"+
                                     "ReasonC  : NUMERIC[0];"+
                                     "ValueType: SCAL[7];"+
                                     "Value    : NUMERIC[2]["+L_Str.IntStr(L_SFee.p_Amount)+"]",
                          "_Values:ValueType,MonthT,TariffC,ReasonC;"+
                          "ValueType:ValueType,MonthT;"+
                          "TariffC:TariffC,ReasonC,MonthT");

  L_AFM.MakeMultipleIndex("MAmnt", "MonthT : NUMERIC[0];"+
                                   "Part   : L_SFee.tPart;"+
                                   "TariffC: SCAL[99];"+
                                   "ReasonC: NUMERIC[0];"+
                                   "ManAmnt: NUMERIC[0];"+
                                   "Man    : LIKE(Man.Man)",
                          "MAmnt:MonthT,Part,TariffC,ReasonC,Man;"+
                          "MTariff:MonthT,Part,TariffC,Man;"+
                          "MReason:MonthT,Part,ReasonC,Man");

  L_AFM.MakeMultipleIndex("_MSFee", "Man    : LIKE(Man.Man);"+
                                    "Period : DATE;" +
                                    "MonthT : NUMERIC[0];"+
                                    "TariffC: SCAL[99];"+
                                    "ReasonC: NUMERIC[0];"+
                                    "Frgnr  : SCAL[2];"+
                                    "Object : LIKE(ManSFee.Object);"+
                                    "ExcCmn : LIKE(ManSFee.ExcCmn);"+
                                    "ExcPrt : LIKE(ManSFee.ExcPrt);"+
                                    "OvrPrt : LIKE(ManSFee.OvrPrt);"+
                                    "Fee    : LIKE(ManSFee.Fee)",
                          "_MSFee:Man,Period,MonthT,TariffC,ReasonC,Frgnr");

  IF ~!prvRSVPacket THEN
   SAVE(Packet);
   SEARCH(Packet, Packet, , prvRSVPacket);
   prvRSVPacketDTS:=L_Packet.GetDTStampTIMESTAMP(Packet.DTStamp);
   RESTORE(Packet);
  ELSE
   SETEMPTY(prvRSVPacketDTS);
  END;

  SELECT(ManSFee, Man);
  WHILE OCCURE(ManSFee) DO
   NARROWSEL(ManSFee, Man);
   PROMPT(":  " + ManSFee.Man);
   SAVE(ManSFee);
   IF SELECT(ManSFee, Man, ManSFee.Man, curMyFirm) & SRCINSEL(ManSFee, GE, BPer) THEN
    WHILE OCCURE(ManSFee) & (ManSFee.Period <= EPer) DO
     IF ManSFee.Type # L_SFee.t_woCtzn THEN
      ReasonCode:=L_SFee.GetPFA_ReasonCode();
      IF ManSFee.Type = L_SFee.t_Invalid THEN
       TariffCode:=tc_Invalid;
      ELSE
       TariffCode:=MainTariffCode;
      END;
      mt         :=pv_Period2MT(ManSFee.Period);
      IsForeigner:=(ManSFee.Type = L_SFee.t_woCtzn) | (ManSFee.Type = L_SFee.t_woCtzn_Commorancy);
      IF IsAcceptableManSFee(mt, prvRSVPacketDTS) THEN
       IF ~SEARCH(_MSFee, _MSFee, ManSFee.Man, ManSFee.Period, mt, TariffCode, ReasonCode, IsForeigner) THEN
        _MSFee.Man    :=ManSFee.Man;
        _MSFee.Period :=ManSFee.Period;
        _MSFee.MonthT :=mt;
        _MSFee.TariffC:=TariffCode;
        _MSFee.ReasonC:=ReasonCode;
        _MSFee.Frgnr  :=IsForeigner;
        SETEMPTY(_MSFee.Object, _MSFee.ExcCmn, _MSFee.ExcPrt, _MSFee.OvrPrt, _MSFee.Fee);
        INSERT(_MSFee);
       END;
       _MSFee.Object :=ManSFee.Object;
       _MSFee.ExcCmn :=ManSFee.ExcCmn;
       _MSFee.ExcPrt :=ManSFee.ExcPrt;
       _MSFee.OvrPrt :=ManSFee.OvrPrt;
       _MSFee.Fee    :=ManSFee.Fee;
       REPLACE(_MSFee);
      END;
     END;
     NEXT(ManSFee);
    END; (* WHILE OCCURE(File) *)
   END; (* IF SRCINSEL(ManSFee ... *)
   RESTORE(ManSFee);
   NEXTINEXTENDEDSEL(ManSFee, Man);
  END; (* WHILE OCCURE(ManSFee) ... *)

  pd_FillFee();

  IF DEBUG THEN
   OPENREP(Z, L_General.NameConnection("Debug_" + Packet.Packet), Create);
   MAKEPART(Z, Top_Debug);
   SELECT(MAmnt, MAmnt);
   WHILE OCCURE(MAmnt) DO
    MAKEPART(Z, Line_Debug);
    NEXT(MAmnt);
   END; (* WHILE OCCURE(MAmnt) ... *)
   CLOSEREP(Z);
  END;
 END {Gather};

 PRIVATE PROCEDURE Part2_1_X(TariffCode: tTariffCode; Suffix: STRING[]);
 BEGIN
  IF (TariffCode # tc_Invalid) | SELECT(_Values, TariffC, TariffCode) THEN
   㧨_(""+Suffix, TariffCode);
 
   UploadSingleRow_Money("200", vt_Obj, MINOF(L_SFee.tPart), TariffCode, EMPTYOF(L_SFee.tPFAReasonCode), Suffix);
   UploadSingleRow_Money("201", vt_Exc, MINOF(L_SFee.tPart), TariffCode, EMPTYOF(L_SFee.tPFAReasonCode), Suffix);
 
   UploadSingleRow_Money("203", vt_Ovr, MINOF(L_SFee.tPart), TariffCode, EMPTYOF(L_SFee.tPFAReasonCode), Suffix);
 
   UploadSingleRow_Money("205", vt_Tax, L_SFee.p_PFIn,       TariffCode, EMPTYOF(L_SFee.tPFAReasonCode), Suffix);
   UploadSingleRow_Money("206", vt_Tax, L_SFee.p_PFOv,       TariffCode, EMPTYOF(L_SFee.tPFAReasonCode), Suffix);
 
   UploadSingleRow_Amount("207",        L_SFee.p_PFIn,       TariffCode, EMPTYOF(L_SFee.tPFAReasonCode), Suffix);
   UploadSingleRow_Amount("208",        L_SFee.p_PFOv,       TariffCode, EMPTYOF(L_SFee.tPFAReasonCode), Suffix);
 
   UploadSingleRow_Money("210", vt_Obj, L_SFee.p_MSFF,       TariffCode, EMPTYOF(L_SFee.tPFAReasonCode), Suffix);
   UploadSingleRow_Money("211", vt_Exc, L_SFee.p_MSFF,       TariffCode, EMPTYOF(L_SFee.tPFAReasonCode), Suffix);
   UploadSingleRow_Money("213", vt_Ovr, L_SFee.p_MSFF,       TariffCode, EMPTYOF(L_SFee.tPFAReasonCode), Suffix);
   UploadSingleRow_Money("215", vt_Tax, L_SFee.p_MSFF,       TariffCode, EMPTYOF(L_SFee.tPFAReasonCode), Suffix);
  END;
 END {Part2_1_X};

 PRIVATE PROCEDURE Part2_1(MainTariffCode: tTariffCode);
 BEGIN
  Part2_1_X(MainTariffCode, "_1");
  Part2_1_X(tc_Invalid,     "_2");
 END {Part2_1};

 PRIVATE PROCEDURE Part2_2();
 BEGIN
  UploadSingleRow_Money( "220", vt_Obj, L_SFee.p_PFA1, EMPTYOF(tTariffCode), L_SFee.pfarc_1, "");
  UploadSingleRow_Money( "221", vt_Exc, L_SFee.p_PFA1, EMPTYOF(tTariffCode), L_SFee.pfarc_1, "");
  UploadSingleRow_Money( "224", vt_Tax, L_SFee.p_PFA1, EMPTYOF(tTariffCode), L_SFee.pfarc_1, "");
  UploadSingleRow_Amount("225",         L_SFee.p_PFA1, EMPTYOF(tTariffCode), L_SFee.pfarc_1, "");
 END {Part2_2};

 PRIVATE PROCEDURE Part2_3();
 BEGIN
  UploadSingleRow_Money( "230", vt_Obj, L_SFee.p_PFA2, EMPTYOF(tTariffCode), L_SFee.pfarc_2, "");
  UploadSingleRow_Money( "231", vt_Exc, L_SFee.p_PFA2, EMPTYOF(tTariffCode), L_SFee.pfarc_2, "");
  UploadSingleRow_Money( "234", vt_Tax, L_SFee.p_PFA2, EMPTYOF(tTariffCode), L_SFee.pfarc_2, "");
  UploadSingleRow_Amount("235",         L_SFee.p_PFA2, EMPTYOF(tTariffCode), L_SFee.pfarc_2, "");
 END {Part2_3};

 PRIVATE PROCEDURE Part2_4_BySingleMansFeePart(RowNbr    : NUMERIC[0];
                                               p         : L_SFee.tPart;
                                               ReasonCode: L_SFee.tPFAReasonCode;
                                               Suffix    : STRING[]);
 BEGIN
  UploadSingleRow_Money( L_Str.IntStr(RowNbr),   vt_Obj, p, EMPTYOF(tTariffCode), ReasonCode, Suffix);
  UploadSingleRow_Money( L_Str.IntStr(RowNbr+1), vt_Exc, p, EMPTYOF(tTariffCode), ReasonCode, Suffix);
  UploadSingleRow_Money( L_Str.IntStr(RowNbr+4), vt_Tax, p, EMPTYOF(tTariffCode), ReasonCode, Suffix);
  UploadSingleRow_Amount(L_Str.IntStr(RowNbr+5),         p, EMPTYOF(tTariffCode), ReasonCode, Suffix);
 END {Part2_4_BySingleMansFeePart};

 PRIVATE PROCEDURE IsUploadPart2_4_Required(ReasonCode: L_SFee.tPFAReasonCode): SCAL[2];
  VAR
   p                      : L_SFee.tPart;
   TotalManAmountByPart2_4: NUMERIC[0];
 BEGIN
  SETZERO(TotalManAmountByPart2_4);
  FOR_EACH p DO
   IF IsNewPFAddPart(p) THEN
    INC(TotalManAmountByPart2_4, GetManAmount(p, mt_T, EMPTYOF(tTariffCode), ReasonCode));
   END;
  END; (* FOR_EACH *)
  RETURN TotalManAmountByPart2_4 # 0;
 END {IsUploadPart2_4_Required};

 PRIVATE PROCEDURE Part2_4_X(ReasonCode: L_SFee.tPFAReasonCode; ReasonForPart2_4: SCAL[2][2]; Suffix: STRING[]);
  CONST
   rfp2_4_Spec = 0;
   rfp2_4_Att  = 1;
   rfp2_4_Mix  = 2;

   ReasonForPart2_4_Pool = " |   |      ";
  VAR
   trgReasonForPart2_4: SCAL[3];
 BEGIN
  IF IsUploadPart2_4_Required(ReasonCode) THEN
   IF    ~!ReasonForPart2_4[0] & ~!ReasonForPart2_4[1] THEN
    trgReasonForPart2_4:=rfp2_4_Mix;
   ELSIF ~!ReasonForPart2_4[0] THEN
    trgReasonForPart2_4:=rfp2_4_Att;
   ELSIF ~!ReasonForPart2_4[1] THEN
    trgReasonForPart2_4:=rfp2_4_Spec;
   ELSE
    L_General.CallUs(0);
   END;

   㧨("᭮⠏"+Suffix, ReasonCode);
   㧨_("᭮2_4"+Suffix, L_Str.PoolItem(ReasonForPart2_4_Pool, trgReasonForPart2_4));
   Part2_4_BySingleMansFeePart(240, L_SFee.p_PFA4_0, ReasonCode, Suffix);
   Part2_4_BySingleMansFeePart(246, L_SFee.p_PFA3_4, ReasonCode, Suffix);
   Part2_4_BySingleMansFeePart(252, L_SFee.p_PFA3_3, ReasonCode, Suffix);
   Part2_4_BySingleMansFeePart(258, L_SFee.p_PFA3_2, ReasonCode, Suffix);
   Part2_4_BySingleMansFeePart(264, L_SFee.p_PFA3_1, ReasonCode, Suffix);
  END;
 END {Part2_4_X};

 PUBLIC PROCEDURE GetPFAReasonCodeByPnsAttr(trgPnsAttr: LIKE(PnsAttr.PnsAttr)): L_SFee.tPFAReasonCode;
  VAR
   Result: L_SFee.tPFAReasonCode;
 BEGIN
  IF trgPnsAttr # L_Packet.OrdinaryPnsAttr THEN
   SAVE(PnsAttr);
   SEARCH(PnsAttr, PnsAttr, , trgPnsAttr);
   IF L_Str.AnyItem(PnsAttr.Str2002, ";", 0) = "27-1" THEN
    Result:=L_SFee.pfarc_1;
   ELSE
    Result:=L_SFee.pfarc_2;
   END;
   RESTORE(PnsAttr);
  ELSE
   Result:=L_SFee.pfarc_None;
  END;
  RETURN Result;
 END {GetPFAReasonCodeByPnsAttr};

 PRIVATE PROCEDURE Part2_4();
  VAR
   ReasonCode          : L_SFee.tPFAReasonCode;
   ReasonForPart2_4_1,
   ReasonForPart2_4_2  : SCAL[2][2];
   dumDirtyTyp         : LIKE(DirtyTyp.DirtyTyp);
   trgSpecialEvaluation: P_Officer.tSpecialEvaluation;
 BEGIN
  SETEMPTY(ReasonForPart2_4_1, ReasonForPart2_4_2);
  SELECT(OfcPro, Property, , P_Officer.P_LabourConditions);
  WHILE OCCURE(OfcPro) DO
   PROMPT("  " + OfcPro.Sort + " " + OfcPro.Officer);
   IF L_DatTim.IsActiveInIntvl_Inc(BPer, EPer, OfcPro.Date, OfcPro.EndDate) THEN
    CONFORM(OfcPro, Officer);
    IF L_DatTim.IsActiveInIntvl_Inc(BPer, EPer, Officer.Begin, Officer.Till) THEN
     SAVE(OfcPro);
     P_Officer.GetP_LabourConditions(OfcPro.Sort, OfcPro.Officer, OfcPro.Date, dumDirtyTyp, trgSpecialEvaluation);
     ReasonCode:=GetPFAReasonCodeByPnsAttr(Officer.PnsAttr);
     IF    ReasonCode = L_SFee.pfarc_1 THEN
      ReasonForPart2_4_1[trgSpecialEvaluation]:=1;
     ELSIF ReasonCode = L_SFee.pfarc_2 THEN
      ReasonForPart2_4_2[trgSpecialEvaluation]:=1;
     END;
     RESTORE(OfcPro);
    END;
   END;
   NEXT(OfcPro);
  END; (* WHILE OCCURE(OfcPro) ... *)

  Part2_4_X(L_SFee.pfarc_1, ReasonForPart2_4_1, "_1");
  Part2_4_X(L_SFee.pfarc_2, ReasonForPart2_4_2, "_2");
 END {Part2_4};

 PRIVATE PROCEDURE Part3_6(MainTariffCode: tTariffCode);
 BEGIN
  IF MainTariffCode = tc_USNOLowSFee THEN
   㧨ਡ_ॡ筮("361_3", 0);
   㧨ਡ_ॡ筮("362_3", 0);
  END;
 END {Part3_6};

 PRIVATE PROCEDURE GetBPerForPrepareChanges(): DATE;
  VAR
   Result: DATE;
 BEGIN
  IF (L_General.GetAPSiteNumber() = 28) & (L_DatTim.YEAR(BPer) = 2014) THEN
   Result:=L_DatTim.IncYear(BPer, -1);
  ELSE
   IF !prvRSVPacket THEN
    Result:=BPer;
   ELSE
    Result:=L_DatTim.GetFirstDateOfQuartal(EPer);
   END;
  END;
  RETURN Result;
 END {GetBPerForPrepareChanges};

 PRIVATE PROCEDURE Part4(    ZeroManAmount    : SCAL[2];
                         VAR ᫥_: NUMERIC[2]);
  VAR
   p         : L_SFee.tPart;
   est       : L_PRoll.tExtensionSubType;
   Period    : DATE;
   TotalFee  : LIKE(ManSFee.Fee);
   trgTable2 : LIKE(PckATER.Table2);
   ReasonCode: L_SFee.tPFAReasonCode;
   Total_PFAdd,
   _1_᫥_ᥣ_120_6,
   _2_᫥_ᥣ_120_7: NUMERIC[2];
   섮᫥,
   섮᫥_襏।: SCAL[2];
 BEGIN
  SETZERO(᫥_, 섮᫥, 섮᫥_襏।);
  IF ~ZeroManAmount | ~IsPolakSpecific() THEN
   L_SFee.PrepareChanges(curMyFirm, GetBPerForPrepareChanges(), EMPTYOF(DATE), L_DatTim.GetLastDateOfQuartal(EPer));

   IF SELECT(MSFCh, Period, curMyFirm) THEN
    SETZERO(_1_᫥_ᥣ_120_6, _2_᫥_ᥣ_120_7);
    trgTable2:=L_ATER.ZeroTable;
    WHILE OCCURE(MSFCh) DO
     NARROWSEL(MSFCh, Period, est, ReasonC);
     Period    :=MSFCh.Period;
     est       :=MSFCh.est;
     ReasonCode:=MSFCh.ReasonC;
     SETZERO(TotalFee);
     WHILE OCCURE(MSFCh) DO
      FOR_EACH p DO
       INC(TotalFee[p], MSFCh.Fee[p]);
      END; (* FOR_EACH p... *)
      NEXT(MSFCh);
     END; (* WHILE OCCURE(MSFCh) ... *)
  
     IF ~IsZeroArr(TotalFee) THEN
      섮᫥:=1;
      IF TotalFee[L_SFee.p_PFOv] THEN
       섮᫥_襏।:=1;
      END;

      ext㧨_(trgTable2, "_᫥",                trgTable2+1);
      IF    est = L_PRoll.est_byMyself THEN
       ext㧨_(trgTable2, "᭮_᫥",              3);
      ELSIF est = L_PRoll.est_byAudit THEN
       ext㧨_(trgTable2, "᭮_᫥",              1);
      END;
   
      ext㧨_(trgTable2, "_᫥",                      L_DatTim.YEAR(Period));
      ext㧨_(trgTable2, "_᫥",                    L_DatTim.MONTH(Period)+1);
      IF L_DatTim.YEAR(Period) < 2014 THEN
       ext㧨_(trgTable2, "_᫥",                    TotalFee[L_SFee.p_PFIn]);
       ext㧨_(trgTable2, "_襏।_᫥",   TotalFee[L_SFee.p_PFOv]);
       ext㧨_(trgTable2, "_᫥",                      0);
       ext㧨_(trgTable2, "_襏।_᫥",     0);
      ELSE
       ext㧨_(trgTable2, "_᫥",                      TotalFee[L_SFee.p_PFIn]);
       ext㧨_(trgTable2, "_襏।_᫥",     TotalFee[L_SFee.p_PFOv]);
       ext㧨_(trgTable2, "_᫥",                    0);
       ext㧨_(trgTable2, "_襏।_᫥",   0);
      END;
 
      ext㧨_(trgTable2, "_᫥",                    TotalFee[L_SFee.p_PFAc]);
 
      ext㧨_(trgTable2, "_1_᫥",          TotalFee[L_SFee.p_PFA1]);
      ext㧨_(trgTable2, "_2_᫥",          TotalFee[L_SFee.p_PFA2]);

      Total_PFAdd:=TotalFee[L_SFee.p_PFA3_1]+TotalFee[L_SFee.p_PFA3_2]+TotalFee[L_SFee.p_PFA3_3]+TotalFee[L_SFee.p_PFA3_4]+TotalFee[L_SFee.p_PFA4_0];
      IF Total_PFAdd # 0 THEN
       ext㧨_(trgTable2, "_2_1_᫥",        Total_PFAdd);
       IF ReasonCode # L_SFee.pfarc_None THEN
        ext㧨_(trgTable2, "᭮_᫥", ReasonCode);
       END;
(*
      ELSE
       ext㧨_(trgTable2, "᭮_᫥", EMPTYOF(NUMERIC[0]));
*)
      END;
      ext㧨_(trgTable2, "_᫥",                      TotalFee[L_SFee.p_MSFF]+TotalFee[L_SFee.p_MSTF]);
 
      INC(᫥_, TotalFee[L_SFee.p_PFIn]);

      IF ReasonCode = L_SFee.pfarc_1 THEN
       INC(_1_᫥_ᥣ_120_6, TotalFee[L_SFee.p_PFA1] + Total_PFAdd);
      ELSE
       INC(_2_᫥_ᥣ_120_7, TotalFee[L_SFee.p_PFA2] + Total_PFAdd);
      END;
      INC(trgTable2);
     END;
     NEXTINEXTENDEDSEL(MSFCh, Period, est, ReasonC);
    END; (* WHILE OCCURE(MSFCh) ... *)

    IF 섮᫥ THEN
     㧨("_1_᫥_ᥣ_120_6", _1_᫥_ᥣ_120_6);
     㧨("_2_᫥_ᥣ_120_7", _2_᫥_ᥣ_120_7);
 
     㧨("섮᫥",                  섮᫥);
     㧨("섮᫥_襏।", 섮᫥_襏।);
    END;
   END;
  END;
 END {Part4};

 PRIVATE PROCEDURE AddContractToList(    trgContract : LIKE(Contract.Contract);
                                     VAR ContractList: LIKE(Contract.Contract)[]);
  VAR
   i             : NUMERIC[0];
   ItsNewContract: SCAL[2];
 BEGIN
  i             :=0;
  ItsNewContract:=1;
  WHILE (i <= HIGH(ContractList)) & ~!ContractList[i] & ItsNewContract DO
   IF ContractList[i] = trgContract THEN
    ItsNewContract:=0;
   END;
   INC(i);
  END; (* WHILE (i <= HIGH(ContractList)) &... *)
  L_General.CallUs(i <= HIGH(ContractList));
  IF ItsNewContract THEN
   ContractList[i]:=trgContract;
  END;
 END {AddContractToList};

 PRIVATE PROCEDURE GetErknedContractList(    P           : DATE;
                                             _Notion     : L_APtm.tNotion;
                                         VAR ContractList: LIKE(Contract.Contract)[]): SCAL[2];
  VAR
   EndMonth   : DATE;
   Result     : SCAL[2];
   EndPrvYear : DATE;
   trgContract: LIKE(Contact.Contact);
 BEGIN
  SETZERO(Result);
  EndPrvYear:=L_DatTim.YearBeg(P) - 1;
  SETEMPTY(ContractList);
  LOOP
   EndMonth:=L_DatTim.MonthEnd(P);
   IF EndMonth < EndPrvYear THEN
    EXIT;
   END;
   trgContract:=L_Cntr.erkn_GetSoft(EndMonth, _Notion, curMyFirm);
   IF ~!trgContract THEN
    Result:=1;
    AddContractToList(trgContract, ContractList);
   END;
   P:=L_DatTim.IncMonth(P, -1);
  END; (* LOOP *)
  RETURN Result;
 END {GetErknedContractList};

 PRIVATE PROCEDURE SetupXObjectByErknedContract(    trgContract: LIKE(Contract.Contract);
                                                VAR trgXObject : LIKE(XObject.XObject);
                                                VAR trgAcCut   : LIKE(AcCut.AcCut));
 BEGIN
  SEARCH(Contract, Contract, , trgContract);
  trgXObject:=Contract.XObject;
  trgAcCut  :=L_Acnt.GetSpecificAcCutForContract(Contract.Contract, L_Acnt.acp_Contract_Netto);
 END {SetupXObjectByErknedContract};

 PRIVATE PROCEDURE sf_GetPmntValue(p             : L_SFee.tPart;
                                   AcntVectorPart: L_Acnt.tAcntVectorPart;
                                   ContractDate,
                                   PerB, PerE    : DATE): NUMERIC[2];
  VAR
   i           : NUMERIC[0];
   Total       : L_Acnt.tAcntVector;
   Result      : NUMERIC[2];
   dummyAcCut  : LIKE(AcCut.AcCut);
   trgXObject  : LIKE(XObject.XObject);
   ContractList: tContractListArr;
 BEGIN
  IF GetErknedContractList(L_DatTim.Per(PerE), L_SFee.sfp2Notion(p), ContractList) THEN
   SETZERO(i, Result);
   WHILE (i <= HIGH(ContractList)) & ~!ContractList[i] DO
    SetupXObjectByErknedContract(ContractList[i], trgXObject, dummyAcCut);
    Total:=L_XObj.GetAcntVector(trgXObject,
                                L_AcCut.erkn_Get(ContractDate, L_AcCut.erkn_OnlineBalance),
                                EMPTYOF(AcCut.AcCut),
                                PerB, PerE);
    INC(Result, Total[AcntVectorPart]);
    INC(i);
   END; (* WHILE (i <= HIGH(ContractList)) &... *)
   RETURN Result;
  ELSE
   RETURN EMPTYOF(Result);
  END;
 END {sf_GetPmntValue};

 PRIVATE PROCEDURE sf_GetInSaldo(p: L_SFee.tPart; ContractDate: DATE): NUMERIC[2];
  VAR
   InSaldo,
   MSTFInSaldo: NUMERIC[2];
 BEGIN
  InSaldo:=sf_GetPmntValue(p, L_Acnt.avp_InSaldo, ContractDate, BPer, EPer);
  IF ~!InSaldo THEN
   InSaldo:=(-1) * InSaldo;
  END;

  IF p = L_SFee.p_MSFF THEN
   MSTFInSaldo:=sf_GetInSaldo(L_SFee.p_MSTF, ContractDate);
   IF ~!InSaldo & ~!MSTFInSaldo THEN
    INC(InSaldo, MSTFInSaldo);
   END;
  END;
  RETURN InSaldo;
 END {sf_GetInSaldo};

 PRIVATE PROCEDURE GetValueFromCurPacket(Name: STRING[]): NUMERIC[2];
  VAR
   Result: NUMERIC[2];
 BEGIN
  SETEMPTY(Result);
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=L_ATER.extGetNumericValueFromPacket(Packet.Packet, Name, L_ATER.ZeroTable, 1);
  EXCEPT
  ON Exc: Exc_Root DO
  END; (* TRY *)
  RETURN Result;
 END {GetValueFromCurPacket};

 PRIVATE PROCEDURE Part1(VAR ⮪_: NUMERIC[2]);
  VAR
   trgSource             : LIKE(PckATER.Source);
   ⮪_,
   GetInSaldoPFIn,
   curPFInValueFromPacket,
   prvPFInValueFromPacket: NUMERIC[2];
 BEGIN
  IF L_DatTim.YEAR(Packet.PerB) = 2014 THEN
   prvPFInValueFromPacket:=GetValueFromPrvPacket(prvYearRSVPacket, "150_3");
   curPFInValueFromPacket:=GetValueFromCurPacket("100_3");
   IF !curPFInValueFromPacket THEN
    curPFInValueFromPacket:=GetValueFromCurPacket("100_4");
   END;

   GetInSaldoPFIn        :=sf_GetInSaldo(L_SFee.p_PFIn, BPer);
   trgSource             :=L_Packet.src_System;
   IF    !prvPFInValueFromPacket & ~!GetInSaldoPFIn THEN
    prvPFInValueFromPacket:=GetInSaldoPFIn;
   ELSIF !prvPFInValueFromPacket & !GetInSaldoPFIn THEN
    trgSource:=L_Packet.src_Operator;
    IF !curPFInValueFromPacket THEN
     STDFORM(L_StdFrm.sf_Choice("⮪   客   ਮ 2010 - 2013 .,|" +
                                " 㯫  "+L_DatTim.DateStr(BPer)+
                                "|(+) , (-) ९"+
                                "||%############% .."+
                                "|",
                                "%RI"),
             "",
             LIKE_WDO,
             ,
             prvPFInValueFromPacket);
    ELSE
     prvPFInValueFromPacket:=curPFInValueFromPacket;
    END;
   END;
   SETZERO(⮪_, ⮪_);
   IF    (prvPFInValueFromPacket >= 0) & (!GetInSaldoPFIn | (GetInSaldoPFIn >= 0)) THEN
    ⮪_:=GetValueByPrvValue(prvPFInValueFromPacket, GetInSaldoPFIn);
    㧨("100_3", ⮪_);
    L_Packet.ext_psf_Num("100_4", ⮪_, L_ATER.ZeroTable, L_ATER.ZeroRow2, trgSource);
   ELSIF (prvPFInValueFromPacket < 0) & (!GetInSaldoPFIn | (GetInSaldoPFIn < 0)) THEN
    ⮪_  :=GetValueByPrvValue(prvPFInValueFromPacket, GetInSaldoPFIn);
    L_Packet.ext_psf_Num("100_3", ⮪_, L_ATER.ZeroTable, L_ATER.ZeroRow2, trgSource);
    㧨("100_4", ⮪_);
   ELSE
    L_General.CallUs(0);
   END;

   㧨ਡ_।("100_5", prvYearRSVPacket, "150_4", sf_GetInSaldo(L_SFee.p_PFAc, BPer));
   㧨ਡ_।("100_6", prvYearRSVPacket, "150_5", sf_GetInSaldo(L_SFee.p_PFA1, BPer));
   㧨ਡ_।("100_7", prvYearRSVPacket, "150_6", sf_GetInSaldo(L_SFee.p_PFA2, BPer));
   㧨ਡ_।("100_8", prvYearRSVPacket, "150_7", sf_GetInSaldo(L_SFee.p_MSFF, BPer));
  ELSE
   L_General.CallUs(0);
  END;
 END {Part1};

 PRIVATE PROCEDURE Part1_UploadRow140SingleCol(v     : tValueType;
                                               p     : L_SFee.tPart;
                                               Column: STRING[]);
 BEGIN
  intUploadSingleRow_Money("140_"+Column,
                           v,
                           p,
                           EMPTYOF(tTariffCode),
                           EMPTYOF(L_SFee.tPFAReasonCode),
                           "141_"+Column+"|142_"+Column+"|143_"+Column,
                           "p140_"+Column,
                           "");
 END {Part1_UploadRow140SingleCol};

 PRIVATE PROCEDURE ProceedSingleMonthTPay(    mt              : tMonthType;
                                          VAR ForPay_PFIn_2013: NUMERIC[2]);
  VAR
   PayOld: NUMERIC[2];
 BEGIN
  IF SELECT(_Values, ValueType, vt_Pay, mt) THEN
   IF ForPay_PFIn_2013 # 0 THEN
    PayOld:=Math.Min(ForPay_PFIn_2013, _Values.Value[L_SFee.p_PFIn]);

    _Values.Value[L_SFee.p_PFIn]:=_Values.Value[L_SFee.p_PFIn] - PayOld;
    REPLACE(_Values);

    DEC(ForPay_PFIn_2013, PayOld);

    CalcValues(vt_PayOld, L_SFee.p_PFIn, mt, EMPTYOF(tTariffCode), EMPTYOF(L_SFee.tPFAReasonCode), PayOld);
   ELSE
    CalcValues(vt_PayOld, L_SFee.p_PFIn, mt, EMPTYOF(tTariffCode), EMPTYOF(L_SFee.tPFAReasonCode), 0);
   END;
  END;
 END {ProceedSingleMonthTPay};

 PRIVATE PROCEDURE Part1_UploadRow140(TariffCode: tTariffCode; ForPay_PFIn_2013: NUMERIC[2]);
  VAR
   p              : L_SFee.tPart;
   i              : NUMERIC[0];
   mt             : tMonthType;
   Per            : DATE;
   Total          : L_Acnt.tAcntVector;
   trgAcCut       : LIKE(AcCut.AcCut);
   trgXObject     : LIKE(XObject.XObject);
   TotalDebit     : NUMERIC[2];
   ContractList   : tContractListArr;
   EmptyTariffCode: tTariffCode;
   EmptyReasonCode: L_SFee.tPFAReasonCode;
 BEGIN
  SETEMPTY(EmptyTariffCode, EmptyReasonCode);

  FOR_EACH p DO
   IF p < L_SFee.p_PFA3_1 THEN
    Per:=Packet.PerB;
    WHILE Per <= Packet.PerE DO
     mt:=pv_Period2MT(Per);
     IF    GetErknedContractList(Per, L_SFee.sfp2Notion(p), ContractList) THEN
      SETZERO(i, TotalDebit);
      WHILE (i <= HIGH(ContractList)) & ~!ContractList[i] DO
       SetupXObjectByErknedContract(ContractList[i], trgXObject, trgAcCut);
       Total:=L_XObj.GetAcntVector(trgXObject,
                                   trgAcCut,
                                   EMPTYOF(AcCut.AcCut),
                                   Per, L_DatTim.MonthEnd(Per));
       INC(TotalDebit, Total[L_Acnt.avp_Debit]);
       INC(i);
      END; (* WHILE (i <= HIGH(ContractList)) &... *)
      CalcValues(vt_Pay, p, mt, EmptyTariffCode, EmptyReasonCode, TotalDebit);
     ELSIF P_MyFirm.IsUSNO(P_MyFirm.GetTaxationMode(curMyFirm, Per)) THEN
      CalcValues(vt_Pay, p, mt, EmptyTariffCode, EmptyReasonCode, 0);
     END;
     Per:=L_DatTim.IncMonth(Per, +1);
    END;
   END;
  END; (* FOR_EACH p... *)


  IF SELECT(_Values, ValueType, vt_Pay) THEN
   IF IsFirstQuartalPacket & ~SELECT(_Values, ValueType, vt_Pay, mt_P) THEN
    CalcValues(vt_Pay, p, mt_P, EmptyTariffCode, EmptyReasonCode, 0);
   END;

   SELECT(_Values, ValueType, , vt_Pay);
   WHILE OCCURE(_Values) DO
    IF ~!_Values.Value[L_SFee.p_MSFF] & ~!_Values.Value[L_SFee.p_MSTF] THEN
     INC(_Values.Value[L_SFee.p_MSFF], _Values.Value[L_SFee.p_MSTF]);
     REPLACE(_Values);
    END;
    NEXT(_Values);
   END; (* WHILE OCCURE(_Values) ... *)
  END;

  ProceedSingleMonthTPay(mt_P, ForPay_PFIn_2013);
  mt:=mt_1;
  WHILE mt <= mt_3 DO
   ProceedSingleMonthTPay(mt, ForPay_PFIn_2013);
   INC(mt);
  END; (* WHILE i <= mt...*)

  Part1_UploadRow140SingleCol(vt_Pay,    L_SFee.p_PFIn, "3");
  Part1_UploadRow140SingleCol(vt_PayOld, L_SFee.p_PFIn, "4");
  Part1_UploadRow140SingleCol(vt_Pay,    L_SFee.p_PFAc, "5");
  Part1_UploadRow140SingleCol(vt_Pay,    L_SFee.p_PFA1, "6");
  Part1_UploadRow140SingleCol(vt_Pay,    L_SFee.p_PFA2, "7");
  Part1_UploadRow140SingleCol(vt_Pay,    L_SFee.p_MSFF, "8");
 END {Part1_UploadRow140};

 PRIVATE PROCEDURE Part2_5_1();
  VAR
   trgTable2   : LIKE(PckATER.Table2);
   PacketAmount: NUMERIC[0];
 BEGIN
  IF SELECT(_PInf, _PInf, 0) THEN
   trgTable2:=L_ATER.ZeroTable;
   SETZERO(PacketAmount);
   WHILE OCCURE(_PInf) DO
    ext㧨_(trgTable2, "_",                                                  trgTable2+1);
    ext㧨_(trgTable2, "᫥客傧ᮢॢ।_", _PInf.Base);
    ext㧨_(trgTable2, "客傧ᮢ_",                                      _PInf.Fee_PF);
    ext㧨_(trgTable2, "⢮窥_",                                       _PInf.ManAmnt);
    ext㧨_(trgTable2, "_",                                                 _PInf.TrnFName);
    INC(PacketAmount);
    INC(trgTable2);
    NEXT(_PInf);
   END; (* WHILE OCCURE(_PInf) ... *)

   㧨("⢮祪_",                                                             PacketAmount);
  END;
 END {Part2_5_1};

 PRIVATE PROCEDURE Part2_5_2();
  VAR
   trgTable2   : LIKE(PckATER.Table2);
   PacketAmount: NUMERIC[0];
 BEGIN
  IF SELECT(_PInf, _PInf, 1) THEN
   trgTable2:=L_ATER.ZeroTable;
   SETZERO(PacketAmount);
   WHILE OCCURE(_PInf) DO
    ext㧨_(trgTable2, "_",                         trgTable2+1);
    ext㧨_(trgTable2, "⠫_",                         _PInf.PerCode);
    ext㧨_(trgTable2, "_",                             _PInf.Year);
    ext㧨_(trgTable2, "᫥客傧ᮢ_",  _PInf.Fee_PF);
    ext㧨_(trgTable2, "᫥客_",     _PInf.Fee_PFIn);
    ext㧨_(trgTable2, "᫥⥫_", _PInf.Fee_PFAc);
    ext㧨_(trgTable2, "⢮窥_",              _PInf.ManAmnt);
    ext㧨_(trgTable2, "_",                        _PInf.TrnFName);

    INC(PacketAmount);
    INC(trgTable2);
    NEXT(_PInf);
   END; (* WHILE OCCURE(_PInf) ... *)

   㧨("⢮祪_",                                     PacketAmount);
  END;
 END {Part2_5_2};

 PRIVATE PROCEDURE IsBasicRSV(): SCAL[2];
 BEGIN
  RETURN STRTOFLD(Packet.ExtNbr, NUMERIC) = 1;
 END {IsBasicRSV};

 PRIVATE PROCEDURE GetPFRPacketsDTSStamp(): LIKE(Packet.DTStamp);
  VAR
   Result: LIKE(Packet.DTStamp);
 BEGIN
  SETEMPTY(Result);
  SAVE(Packet);
  SELECT(_PInf, _PInf);
  WHILE OCCURE(_PInf) DO
   SEARCH(Packet, Packet, , _PInf.Packet);
   IF !Result THEN
    Result:=Packet.DTStamp;
   ELSE
    L_General.CallUs(Result = Packet.DTStamp);
   END;
   NEXT(_PInf);
  END; (* WHILE OCCURE(_PInf) ... *)
  RESTORE(Packet);
  RETURN Result;
 END {GetPFRPacketsDTSStamp};

 PRIVATE PROCEDURE GatherPFRPakets();
 BEGIN
  L_AFM.MakeMultipleIndex("_PInf", "Type    : SCAL[2];" +
                                   "Year    : NUMERIC[0];" +
                                   "PerCode : NUMERIC[0];" +
                                   "TrnFName: STRING[100];"+
                                   "Packet  : LIKE(Packet.Packet);"+
                                   "Base    : NUMERIC[2];"+
                                   "Fee_PF  : NUMERIC[2];"+
                                   "Fee_PFIn: NUMERIC[2];"+
                                   "Fee_PFAc: NUMERIC[2];"+
                                   "ManAmnt : NUMERIC[0]",
                          "_PInf:Type,Year,PerCode,TrnFName,Packet");

  CALL(ManIns14.GetPersPacketsInfo(curMyFirm, BPer, EPer));
 END {GatherPFRPakets};

 PRIVATE PROCEDURE CheckIsAcceptablePFRPacket(PFRPacketsDTSStamp: LIKE(Packet.DTStamp));
  VAR
   curPerB,
   curPerE  : DATE;
   curPacket: LIKE(Packet.Packet);
 BEGIN
  IF ~IsBasicRSV() THEN
   curPacket:=Packet.Packet;
   curPerB  :=Packet.PerB;
   curPerE  :=Packet.PerE;
   SAVE(Packet);
   IF SELECT(Packet, PacketKn, L_Packet.rcv_e_TaxDep, L_Packet.knd_RSV_1, curPerB, curPerE) THEN
    LAST(Packet);
    WHILE OCCURE(Packet) & ((Packet.Status = L_Packet.st_Canceled) | (Packet.Packet = curPacket)) DO
     PREV(Packet);
    END; (* WHILE OCCURE(Packet) ... *)
    IF OCCURE(Packet) THEN
     IF PFRPacketsDTSStamp < Packet.DTStamp THEN
      L_StdFrm.WrongDB(" ନ஢ ४饩    ନ஢|" +
                       "室 ᢥ ᮭ஢ |" +
                       " ४㥬 ਮ  " + L_DatTim.PeriodStr(BPer) + "  " + L_DatTim.PeriodStr(EPer) + ".||" +
                       " ନ஢ 室 ᢥ ᮭ஢ |" +
                       "  ਮ   ﭨ '⢥࣭'");
     END;
    END;
   END;
   RESTORE(Packet);
  END;
 END {CheckIsAcceptablePFRPacket};

 PRIVATE PROCEDURE PrepareData(ManualMake: SCAL[2]; TotalAmount: NUMERIC[0]);
  CONST
   RSVCorrectType_Pool = "1  ⥫,  㯫    ( .  . 䠬)|"+
                         "2  㬬 ᫥    ( ⮬ ᫥  . 䠬)|"+
                         "3      㣨 ⥫,  ࠣ ᢥ .";
  VAR
   RSVCorrectType,
   AverageAmount     : NUMERIC[0];
   ⮪_,
   ᫥_ : NUMERIC[2];
   MainTariffCode    : tTariffCode;
   PFRPacketsDTSStamp: LIKE(Packet.DTStamp);
 BEGIN
  GatherPFRPakets();
  IF ManualMake THEN
   TRY
    IF ~DEBUG THEN
     AverageAmount:=L_ATER.GetAverageCount(BPer, EPer, curMyFirm);
    ELSE
     AverageAmount:=1;
    END;
   EXCEPT
   ON Exc:Exc_Raise DO
    IF ~APP.Get().ProductiveCopy THEN
     L_StdFrm.Choice("ந諠 訡   ।ᯨ筮 ᫥:||" +
                     Exc.MsgOriginalText + "||" +
                     "⮢   ୮ : ᫥ 㤥 ⠭  0");
     D_Slr.CalcAverageCount_PurgeFiles();
     SETZERO(AverageAmount);
    ELSE
     RAISE();
    END;
   END; (* TRY *)
   PFRPacketsDTSStamp:=GetPFRPacketsDTSStamp();
   CheckIsAcceptablePFRPacket(PFRPacketsDTSStamp);
   L_Packet.psf_Num("⠬⠏", PFRPacketsDTSStamp, L_ATER.ZeroTable, L_ATER.ZeroRow2);
  ELSE
   SETZERO(AverageAmount);
  END;

  IF ~IsBasicRSV() THEN
(*
   SETEMPTY(RSVCorrectType);
   STDFORM(L_StdFrm.sf_Choice("| ४஢" +
                              "%##################################################################################%"+
                              "|",
                              "%<"+RSVCorrectType_Pool+">I"),
           "",
           LIKE_WDO,
           ,
           RSVCorrectType);
*)
   RSVCorrectType:=2;
   㧨("४஢", RSVCorrectType);
  END;
  㧨("।ᯨ筠᫥", AverageAmount);
  㧨("⢮", TotalAmount);
  㧨ਡ_ॡ筮("⢮⮢ਫ", 0);
  㧨ਡ_ॡ筮("⢮࠭", 1);

  Part1(⮪_);

  MainTariffCode:=GetMainTariffCode();
  Gather(MainTariffCode);

  Part2_1(MainTariffCode);

  Part2_2();
  Part2_3();
  Part2_4();

  IF ManualMake THEN
   Part2_5_1();
   Part2_5_2();
   Part3_6(MainTariffCode);

   Part4((TotalAmount = 0) & (AverageAmount = 0), ᫥_);

   Part1_UploadRow140(MainTariffCode, ⮪_+᫥_);
  END;
 END {PrepareData};

 PRIVATE PROCEDURE Make(ManualMake: SCAL[2]; TotalAmount: NUMERIC[0]);
  VAR
   RepName: STRING[];
 BEGIN
  RepName:="X16_" + Packet.Packet;
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
  L_Packet.DefinePckMyFirm(L_Packet.bm_byPacket);
  CONFORM(Packet, ATER);

  㧨_("", L_Packet.trnFileName());
  IF L_General.GetAPSiteNumber() = 96 THEN
   L_Packet.ext_psf_Str("।ਮ", prvRSVPacket, L_ATER.ZeroTable, L_ATER.ZeroRow2);
  ELSE
   㧨_("।ਮ", prvRSVPacket);
  END;

  PrepareData(ManualMake, TotalAmount);

  L_Packet.PutManualInputATERAttr();

  L_Packet.SetDTStamp();
  Packet.PrpDate :=SYSDATE();
  Packet.DTStamp :=L_Packet.DTStamp;
  Packet.DataType:=L_Packet.dt_None;
  Packet.CorrType:=L_Packet.ct_None;
  REPLACE(Packet);
  MAKEPART(R, Bot);
 END {Make};

 PRIVATE PROCEDURE CalcNumOfInsMen(ManualMake: SCAL[2]): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  IF ManualMake THEN
   Result:=CALL(ManIns14.CalcNumOfInsMen(curMyFirm, BPer, EPer));
   IF !Result THEN
    IF IsPolakSpecific() THEN
     SETZERO(Result);
    ELSE
     IF L_DatTim.IsLastMonthOfQuartal(EPer) & (BPer = L_DatTim.YearBeg(EPer)) THEN
      IF ~APP.Get().ProductiveCopy THEN
       STDFORM(L_StdFrm.sf_Choice("|⮢ -1  ⢨ ନ஢" +
                                  "|ᢥ ᮭ஢   ୮ " +
                                  "||⢮ 客  %####%"+
                                  "|",
                                  "%RI"),
               "",
               LIKE_WDO,
               ,
               Result);
   
      ELSE
       L_General.Error(" ନ஢ -1 ॡ 稥 ନ஢|" +
                       "ᢥ ᮭ஢   ਮ  " + L_DatTim.PeriodStr(BPer) + "  " + L_DatTim.PeriodStr(EPer));
      END;
     END;
    END;
   END;
  ELSE
   SETZERO(Result);
  END;
  RETURN Result;
 END {CalcNumOfInsMen};

 PUBLIC PROCEDURE intXOMN16(ManualMake: SCAL[2]);
  VAR
   TotalAmount: NUMERIC[0];
 BEGIN
  DEBUG:=0;
  L_Packet.ClearATER(0);

  L_Packet.CheckQuartalATER(ManualMake, IsFirstQuartalPacket, BPer, EPer);

  IF L_APtm.MonthIsClosed(EPer, L_APtm.system_Salary) THEN
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  END;
  L_General.Assert_wReferToAdmin(L_SFee.SFeeIsCalculatedInProperConsecution(L_DatTim.Per(EPer)),
                                 "ॡ  客 ᮢ  " + L_DatTim.PeriodStr(EPer) + " ᫥  |" +
                                 "    ⥫");
  L_Packet.ClearATER(0);

  curMyFirm           :=Packet.MyFirm;
  prvYearRSVPacket    :=L_ATER.GetPrvYearPacket(Packet.Packet);
  prvRSVPacket        :=L_ATER.GetPrvQuartalPacket(Packet.Packet, L_ATER.GetPckATERValue_Str(Packet.Packet, "।ਮ", L_ATER.ZeroTable));
  TotalAmount         :=CalcNumOfInsMen(ManualMake);
  ShowProtocolRequired:=0;

  Make(ManualMake, TotalAmount);
  IF ManualMake & ShowProtocolRequired THEN
   L_General.SurveyLastReport();
  END;
 END {intXOMN16};

 PUBLIC PROCEDURE XOMN16();
 BEGIN
  intXOMN16(1);
 END {XOMN16};

END.
