(*
%Copyright   (c) Polak IT
%Author      17.07.2006 20:17:31 POLAK\Gina
%Purpose     ⭠  
%Type        report
%Specific    SYS
%Modified    24.09.2014 16:15:13 LDA
%Environment
*)

 MODULE XOMN8 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Packet, L_DatTim, Str, L_StdFrm, L_Str, L_AFM, L_AvePay,
        L_Staff, L_Man, L_STx, L_Acnt, P_Firm, L_XObj, D_Slr, L_PRoll, Math,
        L_Tax, E_Utils, P_Man, L_OTx, L_Pmnt, L_AcCut, L_APtm,
        L_SFee, L_PDoc, L_ATER, L_Cntr, L_FSS, P_MCList, L_XDoc, P_MyFirm;

 PRIVATE TYPE
  tPer      = SCAL[9];

 PRIVATE CONST
  AveLineNbr = 5;

  per_Total       = 0;
  per_FirstMonth  = 1;
  per_SecondMonth = 2;
  per_ThirdMonth  = 3;
  per_PrevPeriod  = 4;
  per_Pool        = "ᥣ|1|2|3|।ਮ";

 RuleForChildCare1 = "室_15_।1";
 RuleForChildCare2 = "室_15_।2";

 VAR
  BPer,
  EPer: DATE;
  AveAmount      : NUMERIC[0][AveLineNbr];
  ChildCareAmount: NUMERIC[0][AveLineNbr];
  curMyFirm      : LIKE(MyFirm.MyFirm);
  _Table2        : LIKE(ATERAttr.Table);
  ObjectSpecialTaxation: NUMERIC[2];

  prevPeriodPacket: LIKE(Packet.Packet);

 PRIVATE PROCEDURE CheckYEARPer();
 BEGIN
  L_General.Assert(L_DatTim.YEAR(BPer) = L_DatTim.YEAR(EPer), "ਮ    ।  ");
 END {CheckYEARPer};

 PRIVATE PROCEDURE Since2012(): SCAL[2];
 BEGIN
  CheckYEARPer();
  RETURN L_DatTim.Per(EPer) >= 01\01\2012;
 END {Since2012};

 PRIVATE PROCEDURE Since2011(): SCAL[2];
 BEGIN
  CheckYEARPer();
  RETURN L_DatTim.Per(EPer) >= 01\01\2011;
 END {Since2011};

 PRIVATE PROCEDURE IsSince2010(): SCAL[2];
 BEGIN
  CheckYEARPer();
  RETURN L_DatTim.Per(EPer) >= L_STx.STx2001_LastPeriod;
 END {IsSince2010};

 PRIVATE PROCEDURE _SetEmpty(_Value: FLOAT): FLOAT;
 BEGIN
  IF _Value = 0 THEN
   RETURN EMPTYOF(FLOAT);
  ELSE
   RETURN _Value;
  END;
 END {_SetEmpty};

 PRIVATE PROCEDURE pip_SingleValue_Str(_Value, _PublicName: STRING[]);
 BEGIN
  L_Packet.psf_Str(_PublicName, _Value, _Table2, 00000);
 END {pip_SingleValue_Str};

 PRIVATE PROCEDURE pip_SingleValue(_Value: FLOAT; _PublicName: STRING[]);
 BEGIN
  L_Packet.psf_Num(_PublicName, _SetEmpty(_Value), _Table2, 00000);
 END {pip_SingleValue};

 PRIVATE PROCEDURE pip_SingleValue_Date(_Value: DATE; _PublicName: STRING[]);
 BEGIN
  pip_SingleValue_Str(FLDTOSTR(_Value, "y-N-D", 10), _PublicName);
 END {pip_SingleValue_Date};

 PRIVATE PROCEDURE pip_SingleValueSoft(_Value: FLOAT; _PublicName: STRING[]);
 BEGIN
  IF L_Packet.AccessATERAttrByPublicName(_PublicName) THEN
   pip_SingleValue(_Value, _PublicName);
  END;
 END {pip_SingleValueSoft};

 PRIVATE PROCEDURE GetPacket(_Kind: LIKE(Packet.Kind); PerB, PerE: DATE): LIKE(Packet.Packet);
 BEGIN
  RETURN L_ATER.GetPacket(Packet.Packet, Packet.MyFirm, _Kind, PerB, PerE);
 END {GetPacket};

 PRIVATE PROCEDURE GetPckATERValue(): FLOAT;
 BEGIN
  RETURN STRTOFLD(Str.Condense(L_ATER.GetSingleAttr(0000, 0000)), NUMERIC);
 END {GetPckATERValue};

 PRIVATE PROCEDURE GetFromPacket(_Packet: LIKE(Packet.Packet);
                                 _pn    : LIKE(ATERAttr.PublicNm)): FLOAT;
  VAR
   _Value: FLOAT;
 BEGIN
  IF ~!_Packet THEN
   SAVE(ATERAttr);
   SAVE(Packet);
   L_General.CallUs(SEARCH(Packet, Packet, _Packet));
   L_General.CallUs(L_Packet.AccessATERAttrByPublicName(_pn));
   _Value:=GetPckATERValue();
   RESTORE(ATERAttr);
   RESTORE(Packet);
  ELSE
   SETEMPTY(_Value);
  END;
  RETURN _Value;
 END {GetFromPacket};

 PRIVATE PROCEDURE GetFromPacketByAA(_Packet: LIKE(Packet.Packet);
                                     _AA:     LIKE(ATERAttr.ATERAttr)): FLOAT;
  VAR
   _Value: FLOAT;
 BEGIN
  IF ~!_Packet THEN
   SAVE(ATERAttr);
   SAVE(Packet);
   L_General.CallUs(SEARCH(Packet, Packet, _Packet));
   L_General.CallUs(AccessATERAttrByATERAttr(_AA));
   _Value:=GetPckATERValue();
   RESTORE(ATERAttr);
   RESTORE(Packet);
  ELSE
   SETEMPTY(_Value);
  END;
  RETURN _Value;
 END {GetFromPacketByAA};

 PRIVATE PROCEDURE GetFromPacketByAANotEmpty(trgPacket: LIKE(Packet.Packet);
                                             trgAA:     LIKE(ATERAttr.ATERAttr)): FLOAT;
  VAR
   Result: FLOAT;
 BEGIN
  Result:=GetFromPacketByAA(trgPacket, trgAA);
  IF !Result THEN
   Result:=0;
  END;
  RETURN Result;
 END {GetFromPacketByAANotEmpty};

 PRIVATE PROCEDURE SetFromPacket(_Packet: LIKE(Packet.Packet);
                                 _pn    : LIKE(ATERAttr.PublicNm));
 BEGIN
  pip_SingleValue(GetFromPacket(_Packet, _pn), _pn);
 END {SetFromPacket};

 PRIVATE PROCEDURE SetFromPacketByATERAttr(_Packet: LIKE(Packet.Packet);
                                           _pn    : LIKE(ATERAttr.PublicNm);
                                           _ATERAttr: LIKE(ATERAttr.ATERAttr));
  VAR
   _Value: FLOAT;
 BEGIN
  IF ~!_Packet THEN
   SAVE(ATERAttr);
   SAVE(Packet);
   L_General.CallUs(SEARCH(Packet, Packet, _Packet));
   L_General.CallUs(AccessATERAttrByATERAttr(_ATERAttr));
   _Value:=GetPckATERValue();
   RESTORE(ATERAttr);
   RESTORE(Packet);
  ELSE
   SETEMPTY(_Value);
  END;
  pip_SingleValue(_Value, _pn);
 END {SetFromPacketByATERAttr};

 PRIVATE PROCEDURE pip_SingleAvgCountType(_Type: SCAL[9]; ac_pn_Total, ac_pn_Female: STRING[]);
  VAR
   AvgCountSpc,
   AvgCount: NUMERIC[3][2];
 BEGIN
  SETZERO(AvgCount, AvgCountSpc);
  IF SEARCH(AvgCnt, AvgCnt, _Type) THEN
   AvgCount:=AvgCnt.Count;
  END;
  IF Since2011() & (_Type = D_Slr.act_Total) THEN
   IF SEARCH(AvgCnt, AvgCnt, D_Slr.act_SpecTax) THEN
    AvgCountSpc:=AvgCnt.Count;
    INC(AvgCount[L_Man.sex_Female], AvgCnt.Count[L_Man.sex_Female]);
    INC(AvgCount[L_Man.sex_Male],   AvgCnt.Count[L_Man.sex_Male])
   END;
  END;

  pip_SingleValue(AvgCount[L_Man.sex_Female]+AvgCount[L_Man.sex_Male], ac_pn_Total);
  IF ~!ac_pn_Female THEN
   pip_SingleValue(AvgCount[L_Man.sex_Female], ac_pn_Female);
  END;
 END {pip_SingleAvgCountType};

 PRIVATE PROCEDURE AverageCount(ManualMake: SCAL[2]);
 BEGIN
  IF ManualMake THEN
   D_Slr.CalcAverageCount(BPer, EPer, curMyFirm);
   IF Since2011() THEN
    pip_SingleAvgCountType(D_Slr.act_Total,   "᫥।",         "᫥।ᆥ騭");
    pip_SingleAvgCountType(D_Slr.act_Invalid, "᫥।ር", "");
    pip_SingleAvgCountType(D_Slr.act_Harm,    "᫥।।",  "");
   ELSE
    pip_SingleAvgCountType(D_Slr.act_Total,   "᫥।",         "᫥।ᆥ騭");
    pip_SingleAvgCountType(D_Slr.act_SpecTax, "᫥।ᑯ捎",   "᫥।ᆥ騭捎");
    pip_SingleAvgCountType(D_Slr.act_Invalid, "᫥।ር", "");
    pip_SingleAvgCountType(D_Slr.act_Harm,    "᫥।।",  "");
   END;
  ELSE
   IF Since2011() THEN
    pip_SingleValue(0, "᫥।");
    pip_SingleValue(0, "᫥।ᆥ騭");
    pip_SingleValue(0, "᫥।ር");
    pip_SingleValue(0, "᫥।।");
   ELSE
    L_General.SetupRequired();
   END;
  END;
 END {AverageCount};

 PRIVATE PROCEDURE GetPeriod_AsStr(PerId: tPer): STRING[];
 BEGIN
  IF ~!PerId THEN
   RETURN "_" + L_Str.PoolItem(per_Pool, PerId);
  ELSE
   RETURN "";
  END;
 END {GetPeriod_AsStr};

 PRIVATE PROCEDURE GetPublicName(Name : STRING[];
                                 PerId: tPer): STRING[];
 BEGIN
  RETURN Name + GetPeriod_AsStr(PerId);
 END {GetPublicName};

 PRIVATE PROCEDURE GetTaxation(): L_STx.tSpecificSTx;
 BEGIN
  IF P_Firm.FirmHasSimplifiedTaxation(L_Packet.GetPacketOwnFirm(), Packet.PerB) THEN
   RETURN L_STx.SpcSTx_USNO;
  ELSIF SEARCH(AcCut, AcCut, L_STx.Spc_BasAcCut) & SELECT(XCalc, AcCut, L_STx.Spc_BasAcCut) &
        L_DatTim.IsActive(Packet.PerB, AcCut.Begin, AcCut.Till) THEN
   RETURN L_STx.SpcSTx_ENVD;
  ELSE
   RETURN L_STx.SpcSTx_None;
  END;
 END {GetTaxation};

 PRIVATE PROCEDURE GetPrevPeriod(VAR BDate, EDate: DATE);
 BEGIN
  BDate:=L_DatTim.YearBeg(Packet.PerE);
  EDate:=L_DatTim.MonthBeg(L_DatTim.GetLastDateOfQuartal(L_DatTim.IncMonth(Packet.PerE, -3)));
 END {GetPrevPeriod};

 PRIVATE PROCEDURE IsAcceptablePrevPeriodPacket(): SCAL[2];
 BEGIN
  RETURN ~!prevPeriodPacket;
 END {IsAcceptablePrevPeriodPacket};

 PRIVATE PROCEDURE IntFirstTable(PerId: tPer);
  VAR
   Object,
   ExcPrt,
   CntBase,
   Base,
   InvBase,
   OverObject,
   Fee      : NUMERIC[2];
   BDate,
   EDate    : DATE;
   curInvldBase: NUMERIC[2][10];
 BEGIN
  IF    PerId = per_Total THEN
   BDate:=L_DatTim.YearBeg(Packet.PerE);
   EDate:=Packet.PerE;
  ELSIF (PerId = per_FirstMonth) | (PerId = per_SecondMonth) | (PerId = per_ThirdMonth) THEN
   BDate:=L_DatTim.IncMonth(L_DatTim.Per(L_DatTim.GetLastDateOfQuartal(Packet.PerE)), (PerId-3));
   EDate:=BDate;
   IF (BDate < Packet.PerB) | (EDate > Packet.PerE) THEN
    RETURN;
   END;
  ELSIF PerId = per_PrevPeriod THEN
   IF IsAcceptablePrevPeriodPacket() THEN
    SetFromPacketByATERAttr(prevPeriodPacket, "ꥪ⎡_।ਮ",         "S1");
    SetFromPacketByATERAttr(prevPeriodPacket, "9_।ਮ",           "S2");
    SetFromPacketByATERAttr(prevPeriodPacket, "_।ਮ",         "S3");
    SetFromPacketByATERAttr(prevPeriodPacket, "襏।_।ਮ", "S4");
    RETURN;
   END;
   GetPrevPeriod(BDate, EDate);
  END;

  SETZERO(ObjectSpecialTaxation, Object, ExcPrt, Base, InvBase, OverObject, Fee);
  SELECT(ManSFee, Actual, , 1, curMyFirm);
  WHILE OCCURE(ManSFee) DO
   NARROWSEL(ManSFee, Man);
   SRCINSEL(ManSFee, GE, , BDate);
   WHILE OCCURE(ManSFee) & (ManSFee.Period<=EDate) DO
    PROMPT("ઠ  "+ManSFee.Man+" "+L_DatTim.PeriodStr(ManSFee.Period));
    IF ~Since2011() & ((ManSFee.Type = L_SFee.t_ENVD) | (ManSFee.Type = L_SFee.t_USNO)) THEN
     INC(ObjectSpecialTaxation, ManSFee.Object);
    ELSE
     INC(Object, ManSFee.Object);
     INC(ExcPrt, ManSFee.ExcCmn+ManSFee.ExcPrt[L_SFee.b_FSS]);
     INC(OverObject, ManSFee.OvrPrt[L_SFee.b_FSS]);
     IF ManSFee.Type = L_SFee.t_Invalid THEN
      INC(InvBase, L_SFee.GetCurrentSinglePartBase(L_SFee.p_xFSS));
      CONFORM(ManSFee, Man);
      L_General.Assert(L_SFee.ManIsInvalid(Man.Man, ManSFee.Period),
                      " " + L_Man.Man_ManAsStr() + ": 믫  |" +
                      "   ᠭ   " + L_DatTim.DateStr(ManSFee.Period));
      L_General.Assert(~!ManPro.DocGiveD, " " + L_Man.Man_ManAsStr() + ":|   뤠 ࠢ  ");
      SETZERO(curInvldBase);
      curInvldBase[PerId]:=L_SFee.GetCurrentSinglePartBase(L_SFee.p_xFSS);
      ADD(Invld, Invld, , ManSFee.Man,
                          Invld.InvBase[per_Total],       curInvldBase[per_Total],
                          Invld.InvBase[per_FirstMonth],  curInvldBase[per_FirstMonth],
                          Invld.InvBase[per_SecondMonth], curInvldBase[per_SecondMonth],
                          Invld.InvBase[per_ThirdMonth],  curInvldBase[per_ThirdMonth]);
      Invld._DocGiveD:=ManPro.DocGiveD;
      Invld._DocExpD :=ManPro.DocExpD;
      REPLACE(Invld);
     END;
     INC(Fee, ManSFee.Fee[L_SFee.p_xFSS]);
    END;
    INC(Base, L_SFee.GetCurrentSinglePartBase(L_SFee.p_xFSS));
    NEXT(ManSFee);
   END; (* WHILE OCCURE(ManSFee) *)
   NEXTINEXTENDEDSEL(ManSFee, Man);
  END; (* WHILE OCCURE(ManSFee) *)

  IF Since2011() & (L_DatTim.Per(EPer) < 01\01\2012) THEN
   CntBase:=Math.Round(Object)-Math.Round(ExcPrt)-Math.Round(OverObject);
   IF Math.Round(CntBase) # Math.Round(Base) THEN
    L_General.Assert(Math.Abs(Math.Round(CntBase)-Math.Round(Base))<=1,
                     "砥   "+
                     "| :    "+FLDTOSTR(CntBase, "2.", 0)+
                     "| ⭮: "+FLDTOSTR(Base, "2.", 0));
    Object:=Math.Round(Base)+Math.Round(ExcPrt)+Math.Round(OverObject);
   END;
  END;
  pip_SingleValue(Object,     GetPublicName("ꥪ⎡", PerId)); (*ꥪ *)
  pip_SingleValue(ExcPrt,     GetPublicName("9",   PerId));
  pip_SingleValue(InvBase,    GetPublicName("", PerId));
  pip_SingleValue(OverObject, GetPublicName("襏।", PerId));
  IF PerId # per_PrevPeriod THEN
   pip_SingleValue(Fee,       GetPublicName("᫥", PerId)+"_");
  END;
 END {IntFirstTable};

 PRIVATE PROCEDURE SetupXObjectByErknedContract(P           : DATE;
                                                _Notion     : L_APtm.tNotion;
                                                VAR _XObject: LIKE(XObject.XObject);
                                                VAR _AcCut  : LIKE(AcCut.AcCut)): SCAL[2];
  VAR
   _Contract: LIKE(Contract.Contract);
 BEGIN
  _Contract:=L_Cntr.erkn_GetSoft(P, _Notion, curMyFirm);
  IF ~!_Contract THEN
   SEARCH(Contract, Contract, , _Contract);
   _XObject:=Contract.XObject;
   _AcCut  :=L_Acnt.GetSpecificAcCutForContract(Contract.Contract, L_Acnt.acp_Contract_Netto);
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {SetupXObjectByErknedContract};

PRIVATE PROCEDURE AccessATERAttrByATERAttr(aa: STRING[]): SCAL[2];
BEGIN
 RETURN SELECT(ATERAttr, ATERAttr, Packet.ATER, aa);
END {AccessATERAttrByATERAttr};

PRIVATE PROCEDURE ReplaceSingleField(aa, Value: STRING[]);
BEGIN
 IF AccessATERAttrByATERAttr(aa) & SEARCH(PckATER, Table, Packet.Packet, ATERAttr.Table, 00000, 00000, ATERAttr.Row, aa) THEN
  L_General.CallUs(PckATER.Source = L_Packet.src_Operator);
  PckATER.Value:=Value;
  REPLACE(PckATER);
 ELSE
  L_General.CallUs(0);
 END;
END {ReplaceSingleField};

PRIVATE PROCEDURE rsf_Numeric(aa: STRING[]; Value: NUMERIC[2]);
BEGIN
 ReplaceSingleField(aa, FLDTOSTR(_SetEmpty(Value), "2."));
END {rsf_Numeric};

 PRIVATE PROCEDURE ReplaceSingleFieldPmntValuesTable(trgTable, trgTable2: LIKE(PckATER.Table2); aa, Value: STRING[]);
 BEGIN
  L_General.CallUs(SEARCH(ATERAttr, Table, Packet.ATER, trgTable, aa));
  IF    SEARCH(PckATER, Table, Packet.Packet, ATERAttr.Table, trgTable2, 00000, ATERAttr.Row, aa) THEN
   PckATER.Value:=Value;
   REPLACE(PckATER);
  ELSIF trgTable2 > 0 THEN
   L_Packet.PutSingleValueInPacket(trgTable2, 00000, Value, L_Packet.src_System);
  ELSE
   L_General.CallUs(0);
  END;
 END {ReplaceSingleFieldPmntValuesTable};

 PRIVATE PROCEDURE GetAcCut_69(): LIKE(AcCut.AcCut);
 BEGIN
  IF L_General.IsPolakSpecific() THEN
   RETURN 680;
  ELSE
   RETURN L_AcCut.erkn_Get(SYSDATE(), L_AcCut.erkn_SocialInsurance);
  END;
 END {GetAcCut_69};

 PRIVATE PROCEDURE PutPDoc(_Contract: LIKE(Contract.Contract);
                           _XObject : LIKE(XObject.XObject);
                           aaOnPer  : STRING[];
                           trgTable : LIKE(ATERAttr.Table));
  VAR
   Per      : DATE;
   Total    : L_Acnt.tAcntVector;
   PDAmount,
   i        : NUMERIC[0];
 BEGIN
  L_AFM.MakeIndex("xomn8_PDoc", "ri: LIKE(PDoc.RECORDID)");
  i:=3;
  WHILE i > 0 DO
   DEC(i);
   Per  :=L_DatTim.IncMonth(Packet.PerE, -i);
   Total:=L_XObj.GetAcntVector(_XObject,
                               GetAcCut_69(),
                               L_kn.Get(Per, L_AcCut.erkn_SettlementAccounts),
                               Per, Per);
   IF Total[L_Acnt.avp_Debit]#0 THEN
    rsf_Numeric(L_Str.PoolItem(aaOnPer, i), Total[L_Acnt.avp_Debit]);
   END;
   SETSEL(PDocMDoc, Contract, _Contract);
   SRCINSEL(PDocMDoc, GE, , Per);
   WHILE OCCURE(PDocMDoc) & (PDocMDoc.PDocDate <= L_DatTim.MonthEnd(Per)) DO
    IF PDocMDoc.PDocKind = L_PDoc.pd_IPP THEN
     CONFORM(PDocMDoc, PDoc);
     IF (PDoc.Status # L_PDoc.st_Canceled) & ~SEARCH(xomn8_PDoc, xomn8_PDoc, PDoc.RECORDID) THEN
      xomn8_PDoc.ri:=PDoc.RECORDID;
      INSERT(xomn8_PDoc);
     END;
    ELSIF PDocMDoc.PDocKind = L_PDoc.pd_VPP THEN
(*祭  *)
    END;
    NEXT(PDocMDoc);
   END; (* WHILE OCCURE(PDocMDoc) ... *)
  END;

  PDAmount:=0;
  IF SELECT(xomn8_PDoc, xomn8_PDoc) THEN
   WHILE OCCURE(xomn8_PDoc) DO
    SEARCH(PDoc, RECORDID, , xomn8_PDoc.ri);
    ReplaceSingleFieldPmntValuesTable(trgTable, PDAmount, "DT",  L_DatTim.DateStr(PDoc.Date));
    ReplaceSingleFieldPmntValuesTable(trgTable, PDAmount, "NUM", PDoc.SrcNbr);
    ReplaceSingleFieldPmntValuesTable(trgTable, PDAmount, "SUM", FLDTOSTR(PDoc.Total, "2."));
    INC(PDAmount);
    NEXT(xomn8_PDoc);
   END; (* WHILE OCCURE(xomn8_PDoc) ... *)
  END;
  L_AFM.AF_PurgeTemp("xomn8_PDoc");
 END {PutPDoc};

 PRIVATE PROCEDURE GetSFeePmntValues();
  VAR
   _AcCut  : LIKE(AcCut.AcCut);
   _XObject: LIKE(XObject.XObject);
 BEGIN
  IF SetupXObjectByErknedContract(EPer, L_SFee.sfp2Notion(L_SFee.p_xFSS), _XObject, _AcCut) THEN
   PutPDoc(Contract.Contract, Contract.XObject, "S2R26|S2R30|S2R29", 00004);
  END;
  IF IsAcceptablePrevPeriodPacket() THEN
   rsf_Numeric("S2R27", GetFromPacketByAANotEmpty(prevPeriodPacket, "S2R27") (* 砫 ਮ*) +
                        GetFromPacketByAANotEmpty(prevPeriodPacket, "S2R29") (*1 *) +
                        GetFromPacketByAANotEmpty(prevPeriodPacket, "S2R30") (*2 *) +
                        GetFromPacketByAANotEmpty(prevPeriodPacket, "S2R26") (*3 *)
              );
  END;
 END {GetSFeePmntValues};

 PRIVATE PROCEDURE int㧨ਡ_।(curPublicName       : STRING[];
                                                    prvValue            : FLOAT;
                                                    curValue            : FLOAT);
  VAR
   trgValue: FLOAT;
 BEGIN
  trgValue:=prvValue;
  IF !trgValue THEN
   trgValue:=curValue;
  END;
  pip_SingleValue(trgValue, curPublicName);
 END {int㧨ਡ_।};

 PRIVATE PROCEDURE 㧨믫눭_।(trgRECORDID: LIKE(Man.RECORDID);
                                                          curValue   : NUMERIC[2]);
  VAR
   prvValue, tmpValue: FLOAT;
 BEGIN
  L_General.CallUs(L_Packet.AccessATERAttrByPublicName("_"));
  IF IsAcceptablePrevPeriodPacket() THEN
   SETZERO(prvValue);
   SAVE(PckATER);
   SELECT(PckATER, PckATER, , prevPeriodPacket, ATERAttr.Table, 00000, ATERAttr.ATERAttr);
   WHILE OCCURE(PckATER) DO
    IF STRTOFLD(PckATER.Value, SCAL) = trgRECORDID THEN
     tmpValue:=L_ATER.extGetNumericValueFromPacket(prevPeriodPacket, "_㬬", PckATER.Table2, 1);
     IF ~!tmpValue THEN
      INC(prvValue, tmpValue);
     END;
    END;
    NEXT(PckATER);
   END; (* WHILE OCCURE(PckATER) ... *)
   RESTORE(PckATER);
  ELSE
   SETEMPTY(prvValue);
  END;
  int㧨ਡ_।("p_㬬", prvValue, curValue);
 END {㧨믫눭_।};

 PRIVATE PROCEDURE 㧨_।(curValue   : NUMERIC[2];
                                          curPublicNm,
                                          prvPublicNm: LIKE(ATERAttr.PublicNm));
  VAR
   prvValue: FLOAT;
 BEGIN
  IF IsAcceptablePrevPeriodPacket() THEN
   L_General.CallUs(L_Packet.AccessATERAttrByPublicName(prvPublicNm));
   SAVE(PckATER);
   prvValue:=L_ATER.extGetNumericValueFromPacket(prevPeriodPacket, prvPublicNm, PckATER.Table2, 1);
   RESTORE(PckATER);
  ELSE
   SETEMPTY(prvValue);
  END;
  int㧨ਡ_।(curPublicNm, prvValue, curValue);
 END {㧨_।};

 PRIVATE PROCEDURE FirstTable();
  VAR
   PrevYearPacket: LIKE(Packet.Packet);
   IIInsDebt,
   IIFSSDebt,
   InsDebt,
   FSSDebt,
   FSSDebtExpences,
   FSSDebtOver,
   FSSDebtSpc    : FLOAT;
   Taxation      : L_STx.tSpecificSTx;
   Surname,
   FirstName,
   Patronymic    : STRING[];
 BEGIN
  SETEMPTY(InsDebt, FSSDebt, FSSDebtExpences, FSSDebtOver, FSSDebtSpc, IIInsDebt, IIFSSDebt);
  IF (L_DatTim.YEAR(BPer) = 2010) | (BPer # L_DatTim.YearBeg(BPer)) THEN
(* 2010   ,  諨    *)
  ELSE
   PrevYearPacket:=L_ATER.GetPrvYearPacket(Packet.Packet);
   IF ~!PrevYearPacket THEN
    SAVE(Packet);
    L_General.Assert(SEARCH(Packet, Packet, PrevYearPacket), "  ।騩  "+PrevYearPacket);
    L_General.CallUs((Packet.ATER=0031) | (Packet.ATER=0035) | (Packet.ATER=0039) | (Packet.ATER=0042) | (Packet.ATER=0046)); (* 㣨 ATER   *)
    RESTORE(Packet);
    InsDebt        :=GetFromPacketByAA(PrevYearPacket, "InsDebt");        (*  客⥫   ⭮ ਮ*)
    FSSDebt        :=GetFromPacketByAA(PrevYearPacket, "FssDebt");        (*     ⭮*)
    FSSDebtExpences:=GetFromPacketByAA(PrevYearPacket, "000020001003");  (*     ⭮  ⮬ ᫥   ॢ襭 室*)
    FSSDebtOver    :=GetFromPacketByAA(PrevYearPacket, "S2R18");          (*     ⭮  ⮬ ᫥   ९*)
    IF ~Since2011() THEN
     FSSDebtSpc    :=GetFromPacketByAA(PrevYearPacket, "T2R18C1");        (*     ⭮  捎*)
    END;
    IIInsDebt      :=GetFromPacketByAA(PrevYearPacket, "T7R34C1");        (*ࠢ⨧.   客⥫   ⭮ ਮ*)
    IIFSSDebt      :=GetFromPacketByAA(PrevYearPacket, "T7R18C1");        (*ࠢ⨧.      ⭮ ਮ*)
   END;
  END;
  rsf_Numeric("S2R1",          InsDebt);         (*  客⥫  砫 ⭮ ਮ*)
  rsf_Numeric("S2R19",         FSSDebt);         (*    砫 ⭮ ਮ*)
  rsf_Numeric("000020001303", FSSDebtExpences); (*    ⮬ ᫥   ॢ襭 室*)
  rsf_Numeric("S2R20",         FSSDebtOver);     (*    ⮬ ᫥   ९*)
  IF ~Since2011() THEN
   rsf_Numeric("T2R19C1",      FSSDebtSpc);      (*    砫 ⭮ ਮ  捎*)
  END;
  rsf_Numeric("T7R1C1",         IIInsDebt);      (*ࠢ⨧.   客⥫  砫 ⭮ ਮ*)
  rsf_Numeric("T7R19C1",        IIFSSDebt);      (*ࠢ⨧.     砫 ⭮ ਮ*)

  L_AFM.MakeMultipleIndex("Invld", "_Man     : LIKE(ManPro.Man);"+
                                   "_DocGiveD: LIKE(ManPro.DocGiveD);"+
                                   "_DocExpD : LIKE(ManPro.DocExpD);"+
                                   "InvBase  : NUMERIC[2][10]",
                          "Invld: _Man");
  IF Since2011() THEN
   prevPeriodPacket:=L_ATER.GetPrvQuartalPacket(Packet.Packet, "");
   IntFirstTable(per_Total);
   IntFirstTable(per_PrevPeriod);
   IntFirstTable(per_FirstMonth);
   IntFirstTable(per_SecondMonth);
   IntFirstTable(per_ThirdMonth);
  ELSE
   SETEMPTY(prevPeriodPacket);
   IntFirstTable(per_Total);
   IntFirstTable(per_FirstMonth);
   IntFirstTable(per_SecondMonth);
   IntFirstTable(per_ThirdMonth);
  END;
  Taxation:=GetTaxation();
  GetSFeePmntValues();

  IF Since2011() THEN
   IF (L_DatTim.Per(EPer) >= 01\01\2012) & L_SFee.IsUSNOLowSFee(Packet.MyFirm, L_DatTim.Per(EPer)) THEN
    pip_SingleValue_Str("121", "4");
   ELSE
    pip_SingleValue_Str("071", "4");
   END;
   L_General.CallUs(Taxation<=2);
   pip_SingleValue_Str(L_Str.PoolItem("00|02|01", Taxation), "TaxType2"); (*00|02|01 - ||*)
   pip_SingleValue_Str("00",                                 "TaxType3");
   ReplaceSingleField("⢮⮢ਫ", "0");
  ELSE
   IF (ObjectSpecialTaxation # 0) | (Taxation = L_STx.SpcSTx_USNO) THEN
    pip_SingleValue(ObjectSpecialTaxation, "믫둯捎");
    pip_SingleValue_Str(L_Str.AnyItem("|021|011|032", "|", Taxation), "捎");
   END;
   IF Taxation # L_STx.SpcSTx_USNO THEN
    pip_SingleValue_Str("071", "4");
   END;
  END;

  IF Since2011() THEN
   SELECT(Invld, Invld);
   WHILE OCCURE(Invld) DO
    L_General.Assert(SEARCH(Man, Man, Invld._Man), "  "+Invld._Man);
    L_Man.curMan_SplitName(Surname, FirstName, Patronymic);
    pip_SingleValue_Str(Man.RECORDID,        "_");
    pip_SingleValue_Str(Str.Cap(Surname),    "_");
    pip_SingleValue_Str(Str.Cap(FirstName),  "_");
    pip_SingleValue_Str(Str.Cap(Patronymic), "_⢮");
    pip_SingleValue_Date(Invld._DocGiveD,    "_⠂뤠稑ࠢ");
    IF ~!Invld._DocExpD THEN
     pip_SingleValue_Date(Invld._DocExpD,    "_⠎砭⢨");
    END;
    㧨믫눭_।(Man.RECORDID,
                                           Invld.InvBase[per_Total]-Invld.InvBase[per_FirstMonth]-Invld.InvBase[per_SecondMonth]-Invld.InvBase[per_ThirdMonth]);
    pip_SingleValue(Invld.InvBase[per_FirstMonth],  "_㬬_1");
    pip_SingleValue(Invld.InvBase[per_SecondMonth], "_㬬_2");
    pip_SingleValue(Invld.InvBase[per_ThirdMonth],  "_㬬_3");
    NEXT(Invld);
    INC(_Table2);
   END; (* WHILE OCCURE(Invld) ... *)
   _Table2:=00000;
  END;
  L_AFM.AF_PurgeTemp("Invld");
 END {FirstTable};

 PRIVATE PROCEDURE Account();
  VAR
   Packet_ESN: LIKE(Packet.Packet);
   Total     : L_Acnt.tAcntVector;
   Taxation  : L_STx.tSpecificSTx;
 BEGIN
  IF IsSince2010() THEN
   FirstTable();
  ELSE
   Taxation:=GetTaxation();
   IF (L_DatTim.MONTH(BPer) = 0) & (L_DatTim.MONTH(EPer) = 11) THEN
    Packet_ESN:=GetPacket(L_Packet.knd_ESN_Decl,   Packet.PerB, Packet.PerE);
   ELSE
    Packet_ESN:=GetPacket(L_Packet.knd_ESN_AdvRep, Packet.PerB, Packet.PerE);
   END;
   IF ~!Packet_ESN THEN
    L_General.CallUs((ATER.ATER = 0010(*ᮢ  *)) | (ATER.ATER = 0012(*  *)) |
                     (ATER.ATER = 0020(*ᮢ  *)) | (ATER.ATER = 0018(*  *)) |
                                                              (ATER.ATER = 0027(*  *))); (*,   "000020060004"  祭    *)
   ELSIF Taxation # L_STx.SpcSTx_USNO THEN
    L_StdFrm.Choice("  ⭮| ᮮ⢥騩 ਮ  ⥫  | ।⥫쭮 ନ஢");
   END;

   SetFromPacket(Packet_ESN, "_ᥣ_");
   SetFromPacket(Packet_ESN, "죮_ᥣ_");
 
   SetFromPacketByATERAttr(Packet_ESN, "᫥_ᥣ_",  "000020060004");
   SetFromPacketByATERAttr(Packet_ESN, "᫥_1_", "000020062004");
   SetFromPacketByATERAttr(Packet_ESN, "᫥_2_", "000020063004");
   SetFromPacketByATERAttr(Packet_ESN, "᫥_3_", "000020064004");
 
   SetFromPacket(Packet_ESN, "室덠_ᥣ_");
   SetFromPacket(Packet_ESN, "室덠_1_");
   SetFromPacket(Packet_ESN, "室덠_2_");
   SetFromPacket(Packet_ESN, "室덠_3_");
 
   IF EPer >= 01\04\2009 THEN
    SetFromPacketByATERAttr(Packet_ESN, "饭_ᥣ_",  "000020080003");
    SetFromPacketByATERAttr(Packet_ESN, "饭_1_", "000020082003");
    SetFromPacketByATERAttr(Packet_ESN, "饭_2_", "000020083003");
    SetFromPacketByATERAttr(Packet_ESN, "饭_3_", "000020084003");
   END;
   SETEMPTY(Total);
   IF Taxation > L_STx.SpcSTx_None THEN
    Total:=L_XObj.GetAcntVector_Total(curMyFirm, L_STx.Spc_BasAcCut, "", BPer, EPer);
   END;
   pip_SingleValue(Total[L_Acnt.avp_Credit], "믫둯捎");
   pip_SingleValue_Str(L_Str.AnyItem("|011|021|032", "|", Taxation), "捎");
  END; (*IF IsSince2010...*)
 END {Account};

 CONST
  MonthAmount = 12;

 PRIVATE PROCEDURE GetMonthIdx(Per: DATE): SCAL[MonthAmount];
 BEGIN
  RETURN L_DatTim.MONTH(Per);
 END {GetMonthIdx};

 PRIVATE PROCEDURE CheckMCodeList(_MCodeList: STRING[]; Per: DATE);
  VAR
   i     : NUMERIC[0];
   _MCode: LIKE(MCList.MCode);
 BEGIN
  i:=0;
  _MCode:=L_Str.PoolItem(_MCodeList, i);
  WHILE ~!_MCode DO
   L_General.Assert(SEARCH(MCList, MCode, _MCode), "   ᫥ "+_MCode);
   IF L_DatTim.IsExpired_Inc(Per, MCList.Till) THEN
    L_StdFrm.Choice("  " + _MCode + "    "+L_DatTim.PeriodStr(Per)+"|, ᫥ ᮮ ࠧࠡ稪   ");
   END;
   INC(i);
   _MCode:=L_Str.PoolItem(_MCodeList, i);
  END;
 END {CheckMCodeList};

 PRIVATE PROCEDURE IsInvalid(P: DATE): SCAL[2];
 BEGIN
  IF IsSince2010() THEN
   RETURN L_SFee.ManIsInvalid(Man.Man, P);
  ELSE
   RETURN P_Man.HasActualManPro(Man.Man, L_DatTim.MonthEnd(P), P_Man.P_Invalid);
  END;
 END {IsInvalid};

 PRIVATE PROCEDURE TravmOblig_MCList_Attitude_IsObject(D: DATE): SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(MCList), " ⠭ ");
  RETURN P_MCList.a2ii_Attitude(MCList.MCode, D) # P_MCList.a2ii_NotObject;
 END {TravmOblig_MCList_Attitude_IsObject};

 PRIVATE PROCEDURE ProceedSingleMoney(MonthIdx: SCAL[MonthAmount];
                                      VAR IIBaseInvalid, IIBaseNormal, IIBaseNotTaxed: NUMERIC[2];
                                      VAR IIBaseInvQuartal, IIBaseNormalQuartal, IIBaseNotTaxedQuartal: NUMERIC[2][MonthAmount]);
  VAR
   trgPeriod: DATE;
   trgSum   : NUMERIC[2];
 BEGIN
  IF Since2012() THEN
   trgPeriod:=L_SFee_M.Period;
   trgSum   :=L_SFee_M.Sum;
  ELSE
   trgPeriod:=Money.Closed;
   trgSum   :=Money.Sum;
  END;
  IF TravmOblig_MCList_Attitude_IsObject(trgPeriod) THEN
   IF L_OTx.TravmOblig_MCList_Attitude(trgPeriod) THEN
    IF IsInvalid(trgPeriod) THEN
     INC(IIBaseInvalid,                 trgSum);
     INC(IIBaseInvQuartal[MonthIdx],    trgSum);
    ELSE
     INC(IIBaseNormal,                  trgSum);
     INC(IIBaseNormalQuartal[MonthIdx], trgSum);
    END;
   ELSE
    INC(IIBaseNotTaxed,                  trgSum);
    INC(IIBaseNotTaxedQuartal[MonthIdx], trgSum);
   END;
  END;
 END {ProceedSingleMoney};

 PRIVATE PROCEDURE GetAvePay(): LIKE(AvePay.AvePay);
  VAR
   _XDocType : L_XDoc.tXDocType;
   _XDocKind : L_XDoc.tXDocKind;
   _XDoc     : L_XDoc.tXDoc;
 BEGIN
  IF !MoneyDst.XDocId THEN
   RETURN EMPTYOF(AvePay.AvePay);
  ELSE
   L_XDoc.DecodeXDocId(MoneyDst.XDocId, _XDocType, _XDocKind, _XDoc);
   IF _XDocType = L_XDoc.xdt_AvePay THEN
    RETURN _XDoc;
   ELSE
    RETURN EMPTYOF(AvePay.AvePay);
   END;
  END;
 END {GetAvePay};

 PRIVATE PROCEDURE Prepare_Tmp01();
  TYPE
   tIITax = NUMERIC[7];
  VAR
   IITaxCur,
   IITax           : tIITax;
   Crd69,
   IIBaseNormal,
   IIBaseInvalid,
   IIBase,
   IIBaseInv,
   IIBaseNotTaxed  : NUMERIC[2];

   IIBaseNotTaxedQuartal,
   Crd69Quartal,
   IIBaseNormalQuartal,
   IIBaseInvQuartal: NUMERIC[2][MonthAmount];
   IITaxQuartal    : tIITax[MonthAmount];
   MonthIdx        : SCAL[MonthAmount];

   TravmObligTariff: P_MyFirm.tTravmObligTariff[MonthAmount];
   Month1,
   Month2,
   Month3          : SCAL[MonthAmount];
   _MCodeList      : STRING[][MonthAmount];
   sie             : L_FSS.tsie;
   CurClosed       : LIKE(Money.Closed);
   hasExtension    : SCAL[2];
   Per             : DATE;
   curAvePay       : LIKE(AvePay.AvePay);
 BEGIN
  SETEMPTY(_MCodeList);
  Per:=BPer;
  WHILE Per <= EPer DO
   MonthIdx:=GetMonthIdx(Per);
   TravmObligTariff[MonthIdx]:=L_OTx.TravmObligTariff(curMyFirm, Per);
   sie:=L_FSS.sie_SickOrdinary;
   WHILE sie <= L_FSS.sie_IndustrialInj DO
    _MCodeList[MonthIdx]:=L_Str.AddStrDlm(_MCodeList[MonthIdx], "|")+E_Utils.XOMN8_Get_MCode(Per, sie, L_FSS.TaxGroupOrdinary, 0);
    _MCodeList[MonthIdx]:=L_Str.AddStrDlm(_MCodeList[MonthIdx], "|")+E_Utils.XOMN8_Get_MCode(Per, sie, L_FSS.TaxGroupSpec, 0);
    _MCodeList[MonthIdx]:=L_Str.AddStrDlm(_MCodeList[MonthIdx], "|")+E_Utils.XOMN8_Get_MCode(Per, sie, L_FSS.TaxGroupOrdinary, 1);
    _MCodeList[MonthIdx]:=L_Str.AddStrDlm(_MCodeList[MonthIdx], "|")+E_Utils.XOMN8_Get_MCode(Per, sie, L_FSS.TaxGroupSpec, 1);
    INC(sie);
   END;
   CheckMCodeList(_MCodeList[MonthIdx], Per);
   Per:=L_DatTim.IncMonth(Per, +1);
  END;

  SETZERO(IIBase, IIBaseInv, IIBaseNotTaxed, IIBaseNotTaxedQuartal, IIBaseInvQuartal, IIBaseNormalQuartal,
          IITax, IITaxQuartal,
          Crd69, Crd69Quartal);

  IF Since2012() THEN
   L_SFee.extPrepareForDistribution(BPer, L_DatTim.MonthBeg(EPer), 0, curMyFirm);
  END;

  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   SELECT(Staff, MyFirm, , curMyFirm, Man.Man);
   WHILE OCCURE(Staff) DO
    hasExtension:=SELECT(eMoney, TSN, Staff.TSN, L_PRoll.et_ManSFee);
    SETSEL(Money, TSN, Staff.TSN);
    SRCINSEL(Money, GE, , BPer);
    WHILE OCCURE(Money) & (Money.Closed <= EPer) DO
     PROMPT("ઠ  :  " + Man.Man+" "+L_DatTim.PeriodStr(Money.Closed));
     SETZERO(IIBaseNormal, IIBaseInvalid);
     NARROWSEL(Money, Closed);
     MonthIdx:=GetMonthIdx(Money.Closed);
     CurClosed:=Money.Closed;
     WHILE OCCURE(Money) DO
      IF ~!L_Str.PositionInPool(_MCodeList[MonthIdx], Money.MCode) THEN
       ADD(Tmp01, Tmp01, , L_STx.IsSpecSTxOfficer(Money.Closed), Money.MCode, Money.Closed, Money.TSN, Money.Period, Staff.Contract,
                           Tmp01._Sum, Money.Sum);
       ADD(Tmp01, Tmp01, , L_FSS.TaxGroupAll,                    Money.MCode, Money.Closed, Money.TSN, Money.Period, Staff.Contract,
                           Tmp01._Sum, Money.Sum);
       IF SELECT(MoneyDst, MoneyDst, Money.RECORDID) THEN
        WHILE OCCURE(MoneyDst) DO
         IF MoneyDst.Sum # 0 THEN
          curAvePay:=GetAvePay();
          IF ~!curAvePay THEN
           ADD(APLst, APLst, ,
               L_FSS.TaxGroupAll, Money.MCode, Money.TSN, Money.Closed, Money.Period, Staff.Contract, curAvePay);
          END;
         END;
         NEXT(MoneyDst);
        END; (* WHILE OCCURE(MoneyDst) ... *)
       END; (* IF SELECT(MoneyDst... *)
      END;
      IF L_PRoll.MoneyIsForSocialInsuranceFond() THEN
       INC(Crd69,                  Money.Sum);
       INC(Crd69Quartal[MonthIdx], Money.Sum);
      END;
      CONFORM(Money, MCList);
      IF MCList.MCTyp = L_PRoll.mct_Credit THEN
       IF ~Since2012() THEN
        IF ~hasExtension | ~SEARCH(eMoney, ori, Money.RECORDID, L_PRoll.et_ManSFee) | (eMoney.ClcPer = CurClosed) THEN
         ProceedSingleMoney(MonthIdx,
                            IIBaseInvalid, IIBaseNormal, IIBaseNotTaxed,
                            IIBaseInvQuartal, IIBaseNormalQuartal, IIBaseNotTaxedQuartal);
        END;
       END;
      END;
      NEXT(Money);
     END; (* WHILE OCCURE(Money) ... *)
     IF ~Since2012() THEN
      IF hasExtension & SELECT(eMoney, TSN, Staff.TSN, L_PRoll.et_ManSFee, CurClosed) THEN
       WHILE OCCURE(eMoney) DO
        SAVE(Money);
        SAVE(MCList);
        L_General.CallUs(SEARCH(Money, RECORDID, eMoney.ori));
        CONFORM(Money, MCList);
        ProceedSingleMoney(MonthIdx,
                           IIBaseInvalid, IIBaseNormal, IIBaseNotTaxed,
                           IIBaseInvQuartal, IIBaseNormalQuartal, IIBaseNotTaxedQuartal);
        RESTORE(Money);
        RESTORE(MCList);
        NEXT(eMoney);
       END; (* WHILE OCCURE(eMoney) ... *)
      END;

      IITaxCur:=(IIBaseInvalid * TravmObligTariff[MonthIdx] / 100 * L_OTx.TravmOblig_InvalidCoef) +
                (IIBaseNormal * TravmObligTariff[MonthIdx] / 100);
      INC(IIBase, IIBaseInvalid + IIBaseNormal);
      INC(IIBaseInv, IIBaseInvalid);
      IF ~IsSince2010() THEN
       IITaxCur:=Math.Round(IITaxCur*100, 0.01*100)/100;
      END;
      INC(IITaxQuartal[MonthIdx], IITaxCur);
     END; (* IF ~Since2012()... *)
     NEXTINEXTENDEDSEL(Money, Closed);
    END; (* WHILE OCCURE(Money) ... *)
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)

   IF Since2012() THEN
    SELECT(L_SFee_M, MyFirm, , curMyFirm, Man.Man);
    WHILE OCCURE(L_SFee_M) DO
     MonthIdx:=GetMonthIdx(L_SFee_M.Period);
     NARROWSEL(L_SFee_M, Period);
     SETZERO(IIBaseNormal, IIBaseInvalid);
     WHILE OCCURE(L_SFee_M) DO
      SEARCH(MCList, MCode, , L_SFee_M.MCode);
      ProceedSingleMoney(MonthIdx,
                         IIBaseInvalid, IIBaseNormal, IIBaseNotTaxed,
                         IIBaseInvQuartal, IIBaseNormalQuartal, IIBaseNotTaxedQuartal);
      NEXT(L_SFee_M);
     END; (* WHILE OCCURE(L_SFee_M) ... *)

     IITaxCur:=(IIBaseInvalid * TravmObligTariff[MonthIdx] / 100 * L_OTx.TravmOblig_InvalidCoef) +
               (IIBaseNormal * TravmObligTariff[MonthIdx] / 100);
     INC(IIBase, IIBaseInvalid + IIBaseNormal);
     INC(IIBaseInv, IIBaseInvalid);
     INC(IITaxQuartal[MonthIdx], IITaxCur);
     NEXTINEXTENDEDSEL(L_SFee_M, Period);
    END; (* WHILE OCCURE(L_SFee_M) ... *)
   END;

   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)

  Month1:=GetMonthIdx(L_DatTim.IncMonth(L_DatTim.Per(L_DatTim.GetLastDateOfQuartal(Packet.PerE)), -2));
  Month2:=GetMonthIdx(L_DatTim.IncMonth(L_DatTim.Per(L_DatTim.GetLastDateOfQuartal(Packet.PerE)), -1));
  Month3:=GetMonthIdx(L_DatTim.IncMonth(L_DatTim.Per(L_DatTim.GetLastDateOfQuartal(Packet.PerE)), -0));

  IF Since2011() | (GetTaxation() # L_STx.SpcSTx_USNO) THEN
   pip_SingleValue(Crd69,                "室덠_ᥣ_");
   pip_SingleValue(Crd69Quartal[Month1], "室덠_1_");
   pip_SingleValue(Crd69Quartal[Month2], "室덠_2_");
   pip_SingleValue(Crd69Quartal[Month3], "室덠_3_");
  END;

  IF Since2011() THEN
   㧨_।(IIBase-(IIBaseInvQuartal[Month1]+IIBaseNormalQuartal[Month1]+IIBaseInvQuartal[Month2]+IIBaseNormalQuartal[Month2]+IIBaseInvQuartal[Month3]+IIBaseNormalQuartal[Month3]),
                          "p_ᥣ_ࠢ⨧", "_ᥣ_ࠢ⨧");
  ELSE
   pip_SingleValue(IIBase,                                              "_ᥣ_ࠢ⨧");
  END;
  pip_SingleValue(IIBaseInvQuartal[Month1]+IIBaseNormalQuartal[Month1], "_1_ࠢ⨧");
  pip_SingleValue(IIBaseInvQuartal[Month2]+IIBaseNormalQuartal[Month2], "_2_ࠢ⨧");
  pip_SingleValue(IIBaseInvQuartal[Month3]+IIBaseNormalQuartal[Month3], "_3_ࠢ⨧");

  IF Since2011() THEN
   㧨_।(IIBaseInv-(IIBaseInvQuartal[Month1]+IIBaseInvQuartal[Month2]+IIBaseInvQuartal[Month3]),
                          "p_ᥣ_ࠢ⨧", "_ᥣ_ࠢ⨧");
  ELSE
   pip_SingleValue(IIBaseInv,                "_ᥣ_ࠢ⨧");
  END;
  pip_SingleValue(IIBaseInvQuartal[Month1], "_1_ࠢ⨧");
  pip_SingleValue(IIBaseInvQuartal[Month2], "_2_ࠢ⨧");
  pip_SingleValue(IIBaseInvQuartal[Month3], "_3_ࠢ⨧");

  IF Since2011() THEN
   㧨_।(IIBaseNotTaxed-(IIBaseNotTaxedQuartal[Month1]+IIBaseNotTaxedQuartal[Month2]+IIBaseNotTaxedQuartal[Month3]),
                          "p_ᥣ_ࠢ⨧_", "_ᥣ_ࠢ⨧_");
   pip_SingleValue(IIBaseNotTaxedQuartal[Month1], "_1_ࠢ⨧_");
   pip_SingleValue(IIBaseNotTaxedQuartal[Month2], "_2_ࠢ⨧_");
   pip_SingleValue(IIBaseNotTaxedQuartal[Month3], "_3_ࠢ⨧_");
  ELSE
   pip_SingleValue(IIBaseNotTaxed,               "_ᥣ_ࠢ⨧_");
  END;

  FOR_EACH MonthIdx DO
   INC(IITax, Math.Round(IITaxQuartal[MonthIdx], 0.01));
  END;

  pip_SingleValue(IITax,                    "_ᥣ_ࠢ⨧");
  pip_SingleValue(IITaxQuartal[Month1],     "_1_ࠢ⨧");
  pip_SingleValue(IITaxQuartal[Month2],     "_2_ࠢ⨧");
  pip_SingleValue(IITaxQuartal[Month3],     "_3_ࠢ⨧");
 END {Prepare_Tmp01};

 PRIVATE PROCEDURE GetAddKind(    trgMCode        : LIKE(MCList.MCode);
                              VAR AddKindChildCare: LIKE(Adding.AddKind)[];
                              VAR RuleChildCare   : LIKE(MoneyRul.Rule)[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  SETEMPTY(AddKindChildCare);
  i:=0;
  SELECT(MoneyRul, MCode, , trgMCode);
  WHILE OCCURE(MoneyRul) DO
   CONFORM(MoneyRul, MMthLog);
   CONFORM(MMthLog, MoneyMth);
   IF (MMthLog.Date <= EPer) & L_DatTim.IsActive(BPer, MoneyMth.Begin, MoneyMth.Till) &
      SELECT(AddKind, MoneyMth, MMthLog.Method) THEN
    L_General.Assert((MoneyRul.Rule = RuleForChildCare1) | (MoneyRul.Rule = RuleForChildCare2),
                     "⭮ ࠢ "+MoneyRul.Rule+"|⮤ ᫥ "+MoneyMth.Method+" "+MoneyMth.Name);
    AddKindChildCare[i]:=AddKind.AddKind;
    RuleChildCare[i]   :=MoneyRul.Rule;
    INC(i);
   END;
   NEXT(MoneyRul);
  END; (* WHILE OCCURE(MoneyRul) ... *)
 END {GetAddKind};

 PRIVATE PROCEDURE DistrAverageSalary(_MCode: LIKE(MCList.MCode));
  CONST
   AddKNbr=3;
  VAR
   FromSum,
   ToSum           : NUMERIC[2][AveLineNbr];
   AddKindChildCare: LIKE(Adding.AddKind)[AddKNbr];
   RuleChildCare   : LIKE(MoneyRul.Rule) [AddKNbr];
   AverageSalary   : NUMERIC[2];
   i,
   AKNbr  : NUMERIC[0];
   Found  : SCAL[2];
 BEGIN
  FromSum[00]:=     0; ToSum[00]:=  3750;
  FromSum[01]:=  3750; ToSum[01]:=  7500;
  FromSum[02]:=  7500; ToSum[02]:= 11250;
  IF EPer >= 01\04\2009 THEN
   FromSum[03]:= 11250; ToSum[03]:= 18000;
   FromSum[04]:= 18000; ToSum[04]:=    -1;
  ELSE
   FromSum[03]:= 11250; ToSum[03]:= 15000;
   FromSum[04]:= 15000; ToSum[04]:=    -1;
  END;

  GetAddKind(_MCode, AddKindChildCare, RuleChildCare);

  IF ~!AddKindChildCare[0] THEN
   SELECT(Tmp03, Tmp03);
   WHILE OCCURE(Tmp03) DO
    Found:=0;
    AKNbr:=0;
    WHILE ~Found & (AKNbr <= HIGH(AddKindChildCare)) DO
     SETSEL(Adding, TSN, Tmp03._TSN, AddKindChildCare[AKNbr]);
     IF SRCINSEL(Adding, LE, EPer) THEN (*뢠  । *)
      AverageSalary:=Adding.Value*L_DatTim.MonthLen(EPer);

      IF    RuleChildCare[AKNbr] = RuleForChildCare1 THEN
       INC(ChildCareAmount[0]);
      ELSIF RuleChildCare[AKNbr] = RuleForChildCare2 THEN
       INC(ChildCareAmount[1]);
      ELSE
       L_General.Error("⭮ ࠢ "+RuleChildCare[AKNbr]);
      END;
  
      i:=0;
      WHILE (i < AveLineNbr) & ~Found DO
       IF ((FromSum[i] <= AverageSalary) | (AverageSalary<0)) & ((AverageSalary < ToSum[i]) | (ToSum[i]<0)) THEN
        Found:=1;
        INC(AveAmount[i]);
       END;
       INC(i);
      END;
      L_General.Assert(Found, "  ࢠ  㬬 "+FLDTOSTR(AverageSalary, "2.", 0));
     END; (* IF SELECT(Adding... *)
     INC(AKNbr);
    END; (* WHILE ~Found... *)
    NEXT(Tmp03);
   END; (* WHILE OCCURE(Tmp03) ... *)
  END;
 END {DistrAverageSalary};

 PRIVATE PROCEDURE MoneyIsNotSequel(): SCAL[2];
 BEGIN
  RETURN ~ADD(Tmp04, Tmp04, Tmp01._MCode, Tmp01._TSN, Tmp01._Period);
 END {MoneyIsNotSequel};

 VAR
  _Sum_ExternalCombineOverNorms,
  _SumOverNorms,
  _Sum_ExternalCombine,
  _Sum                      : NUMERIC[2];
  DaysAmount_ExternalCombine,
  DaysAmount,
  DocAmount_ExternalCombine,
  DocAmount                 : NUMERIC[0];
  SumQuartal                : NUMERIC[2][MonthAmount];

 PRIVATE PROCEDURE OneAvePay();
 BEGIN
  ADD(Tmp02, Tmp02, , AvePay.AvePay);
  IF ~L_AvePay.SickAvePayIsSequel() THEN
   INC(DocAmount);
   IF Tmp01._Contract = L_Staff.cnt_ExternalCombine THEN
    INC(DocAmount_ExternalCombine);
   END;
  END;
  INC(DaysAmount, AvePay.Amount);
  IF Tmp01._Contract = L_Staff.cnt_ExternalCombine THEN
   INC(DaysAmount_ExternalCombine, AvePay.Amount);
  END;
 END {OneAvePay};

 PRIVATE PROCEDURE OneMCList(_TaxGroup: L_FSS.tTaxGroup;
                             sie      : L_FSS.tsie;
                             _MCode   : LIKE(MCList.MCode);
                             Per      : DATE);
  VAR
   _AveTypeList: STRING[];
   MonthIdx    : SCAL[MonthAmount];
 BEGIN
  IF SELECT(Tmp01, Tmp01, _TaxGroup, _MCode, Per) THEN
   MonthIdx:=GetMonthIdx(Per);
   WHILE OCCURE(Tmp01) DO
    PROMPT("ઠ 室: " + Tmp01._TSN);
    NARROWSEL(Tmp01, _TSN);
    WHILE OCCURE(Tmp01) DO
     IF ~SEARCH(Tmp03, Tmp03, Tmp01._TSN) THEN
      ADD(Tmp03, Tmp03, , Tmp01._TSN);
     END;
     INC(_Sum, Tmp01._Sum);
     INC(SumQuartal[MonthIdx], Tmp01._Sum);
     IF Tmp01._Contract = L_Staff.cnt_ExternalCombine THEN
      INC(_Sum_ExternalCombine, Tmp01._Sum);
     END;
     IF Tmp01._Sum > 0 THEN
      _AveTypeList:=L_FSS.GetAveTypeList(Tmp01._Period, _MCode);
      IF !_AveTypeList THEN
       INC(DocAmount, MoneyIsNotSequel());
       IF Tmp01._Contract = L_Staff.cnt_ExternalCombine THEN
        INC(DocAmount_ExternalCombine);
       END;
      ELSE
       IF SELECT(APLst, APLst, Tmp01._TaxGroup, Tmp01._MCode, Tmp01._TSN, Tmp01._Closed, Tmp01._Period, Tmp01._Contract) THEN
        WHILE OCCURE(APLst) DO
         L_General.CallUs(SEARCH(AvePay, AvePay, APLst._AvePay));
         IF ~SEARCH(Tmp02, Tmp02, AvePay.AvePay) THEN
          OneAvePay();
         END;
         NEXT(APLst);
        END; (* WHILE OCCURE(APLst) ... *)
       END; (* IF SELECT(APLst... *)
       SETSEL(AvePay, EBDTSN, Tmp01._TSN);
       SRCINSEL(AvePay, GE, , Tmp01._Period);
       WHILE OCCURE(AvePay) DO
        IF (AvePay.Status = L_AvePay.st_Estimated) &
           ~!L_Str.PositionInPool(_AveTypeList, AvePay.AveType) &
           L_FSS.IsInPer() & ~SEARCH(Tmp02, Tmp02, AvePay.AvePay) THEN
         OneAvePay();
        END;
        NEXT(AvePay);
       END; (* WHILE OCCURE(AvePay) ... *)
      END; (* IF !_AveTypeList... *)
     END; (* IF Tmp01._Sum... *)
     NEXT(Tmp01);
    END; (* WHILE OCCURE(Tmp01) ... *)
    NEXTINEXTENDEDSEL(Tmp01, _TSN);
   END;
  END;

  IF SELECT(Tmp01, Tmp01, _TaxGroup, E_Utils.XOMN8_Get_MCode(Per, sie, _TaxGroup, 1), Per) THEN
   WHILE OCCURE(Tmp01) DO
    NARROWSEL(Tmp01, _TSN);
    WHILE OCCURE(Tmp01) DO
     INC(_SumOverNorms, Tmp01._Sum);
     IF Tmp01._Contract = L_Staff.cnt_ExternalCombine THEN
      INC(_Sum_ExternalCombineOverNorms, Tmp01._Sum);
     END;
     NEXT(Tmp01);
    END; (* WHILE OCCURE(Tmp01) ... *)
    NEXTINEXTENDEDSEL(Tmp01, _TSN);
   END;
  END;
 END {OneMCList};

 PRIVATE PROCEDURE IsActive_sie(curSIE: L_FSS.tsie; curPer: DATE): SCAL[2];
 BEGIN
  IF (curPer >= 01\04\2009) & (curSIE = L_FSS.sie_Adoption) THEN
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {IsActive_sie};

 PRIVATE PROCEDURE OneTaxation(TaxGroup: L_FSS.tTaxGroup;
                               sie_fr,
                               sie_ut  : L_FSS.tsie);
  VAR
   i         : NUMERIC[0];
   sie       : L_FSS.tsie;
   PN_Prefix,
   PN_Suffix,
   _MCodeList: STRING[];
   Per       : DATE;
 BEGIN
  SETZERO(AveAmount, ChildCareAmount);
  PN_Suffix:=L_Str.AnyItem("|捎", "|", TaxGroup);

  sie:=sie_fr;
  WHILE sie <= sie_ut DO
   IF IsActive_sie(sie, EPer) THEN
    SETZERO(DocAmount, DocAmount_ExternalCombine, DaysAmount, DaysAmount_ExternalCombine,
            _Sum, _Sum_ExternalCombine, _SumOverNorms, _Sum_ExternalCombineOverNorms, SumQuartal);
    Per:=BPer;
    WHILE Per <= EPer DO
     _MCodeList:=E_Utils.XOMN8_Get_MCode(Per, sie, TaxGroup, 0);
     IF ~!_MCodeList THEN
      i:=0;
      REPEAT
       OneMCList(TaxGroup, sie, L_Str.PoolItem(_MCodeList, i), Per);
       INC(i);
      UNTIL !L_Str.PoolItem(_MCodeList, i);
     END; (* IF ~!_MCodeList... *)
     Per:=L_DatTim.IncMonth(Per, +1);
    END; (* WHILE Per... *)

    IF (sie=L_FSS.sie_BabyMinding1) | (sie=L_FSS.sie_BabyMinding2) THEN
     DistrAverageSalary(E_Utils.XOMN8_Get_MCode(EPer, sie, TaxGroup, 0));
    END;

    PN_Prefix:=L_Str.PoolItem(L_FSS.sie_Pool, sie);
    pip_SingleValue(_Sum+_SumOverNorms, PN_Prefix+"㬬"+PN_Suffix);
    IF Since2011() & (sie = L_FSS.sie_HldBabyInvld) THEN
     L_General.CallUs(_SumOverNorms = 0);
     _SumOverNorms:=_Sum;
    END;
    pip_SingleValueSoft(_SumOverNorms, PN_Prefix+"㬬卮"+PN_Suffix);
    pip_SingleValueSoft(_Sum_ExternalCombine+_Sum_ExternalCombineOverNorms,
                                       PN_Prefix+"㬬"+PN_Suffix);          (* ᭮  ࠡ*)
    pip_SingleValueSoft(_Sum_ExternalCombineOverNorms,
                                       PN_Prefix+"㬬卮"+PN_Suffix); (* ᭮  ࠡ*)
    pip_SingleValueSoft(DaysAmount,    PN_Prefix+""+PN_Suffix);
    pip_SingleValueSoft(DaysAmount_ExternalCombine,
                                       PN_Prefix+""+PN_Suffix);            (* ᭮  ࠡ*)
    pip_SingleValueSoft(DocAmount,     PN_Prefix+"ᮡ"+PN_Suffix);
    pip_SingleValueSoft(DocAmount,     PN_Prefix+"砥"+PN_Suffix);
    pip_SingleValueSoft(DocAmount_ExternalCombine,
                                       PN_Prefix+"砥"+PN_Suffix);        (* ᭮  ࠡ*)
  
    IF sie=L_FSS.sie_IndustrialInj THEN
(*室 ࠢ⨧  ᫥   ⭮ ਮ*)
     rsf_Numeric("T7R23C1", SumQuartal[GetMonthIdx(L_DatTim.IncMonth(L_DatTim.Per(L_DatTim.GetLastDateOfQuartal(Packet.PerE)), -2))]); (*1*)
     rsf_Numeric("T7R24C1", SumQuartal[GetMonthIdx(L_DatTim.IncMonth(L_DatTim.Per(L_DatTim.GetLastDateOfQuartal(Packet.PerE)), -1))]); (*2*)
     rsf_Numeric("T7R25C1", SumQuartal[GetMonthIdx(L_DatTim.IncMonth(L_DatTim.Per(L_DatTim.GetLastDateOfQuartal(Packet.PerE)), -0))]); (*3*)
    END;

    SELECT(Tmp02, Tmp02);
    REMSEL(Tmp02);
  
    SELECT(Tmp03, Tmp03);
    REMSEL(Tmp03);
 
    SELECT(Tmp04, Tmp04);
    REMSEL(Tmp04);
   END;
   INC(sie);
  END;

  IF sie_fr # L_FSS.sie_IndustrialInj THEN
   pip_SingleValue(ChildCareAmount[0], "室1_5珮⥫"        +PN_Suffix);
   pip_SingleValue(ChildCareAmount[1], "室1_5멊珮⥫"+PN_Suffix);
   IF ~IsSince2010() THEN
    i:=0;
    WHILE i < AveLineNbr DO
     pip_SingleValue(AveAmount[i], "珮⥫।௫"+L_Str.IntStr(i+1)+PN_Suffix);
     INC(i);
    END;
   END;
  END;
 END {OneTaxation};

 PRIVATE PROCEDURE SocialInsuranceExpences();
 BEGIN
  L_AFM.MakeMultipleIndex("Tmp01", "_TaxGroup: SCAL[3];"+
                                   "_MCode   : LIKE(Money.MCode);"+
                                   "_TSN     : LIKE(Money.TSN);"+
                                   "_Closed  : LIKE(Money.Closed);"+
                                   "_Period  : LIKE(Money.Period);"+
                                   "_Contract: LIKE(Staff.Contract);"+
                                   "_Sum     : NUMERIC[2]",
                          "Tmp01: _TaxGroup, _MCode, _Closed, _TSN, _Period, _Contract");

  L_AFM.MakeIndex("APLst", "_TaxGroup: SCAL[3];"+              (*, 易  ᫥ﬨ १ MoneyDst*)
                           "_MCode : LIKE(Money.MCode);"+
                           "_TSN   : LIKE(Money.TSN);"+
                           "_Closed: LIKE(Money.Closed);"+
                           "_Period: LIKE(Money.Period);"+
                           "_Contract: LIKE(Staff.Contract);"+
                           "_AvePay: LIKE(AvePay.AvePay)");

  L_AFM.MakeIndex("Tmp02", "_AvePay: LIKE(AvePay.AvePay)");
  L_AFM.MakeIndex("Tmp03", "_TSN   : LIKE(Money.TSN)");
  L_AFM.MakeIndex("Tmp04", "_MCode : LIKE(Money.MCode);"+
                           "_TSN   : LIKE(Money.TSN);"+
                           "_Period: LIKE(Money.Period)");

  Prepare_Tmp01();

  IF  Since2011() THEN
   OneTaxation(L_FSS.TaxGroupAll, L_FSS.sie_SickOrdinary, L_FSS.sie_BabyMinding2);
  ELSE
   OneTaxation(L_FSS.TaxGroupOrdinary, L_FSS.sie_SickOrdinary, L_FSS.sie_BabyMinding2);
   OneTaxation(L_FSS.TaxGroupSpec,     L_FSS.sie_SickOrdinary, L_FSS.sie_BabyMinding2);
  END;
 END {SocialInsuranceExpences};

 PRIVATE PROCEDURE IndustrialInjuries();
  VAR
   curTravmObligTariffInc: P_MyFirm.tTravmObligTariffInc;
 BEGIN
  IF L_DatTim.Per(EPer) >= 01\01\2013 THEN
   pip_SingleValue(P_MyFirm.TravmObligTariff(curMyFirm, Packet.PerE), "ࠢ䏮㐨᪠");
   pip_SingleValue(L_OTx.TravmObligTariff(curMyFirm, Packet.PerE), "ࠢ");
   curTravmObligTariffInc:=P_MyFirm.TravmObligTariffInc(curMyFirm, Packet.PerE);
   IF ~!curTravmObligTariffInc THEN
    IF    curTravmObligTariffInc > 0 THEN
     pip_SingleValue(curTravmObligTariffInc, "ࠢ䍠");
     pip_SingleValue_Date(MFPro.Date, "ࠢ䍠⠓");
    ELSIF curTravmObligTariffInc < 0 THEN
     pip_SingleValue(-curTravmObligTariffInc, "ࠢ䑪");
    END;
   END;
  ELSE
   pip_SingleValue(L_OTx.TravmObligTariff(curMyFirm, Packet.PerB), "ࠢ業");
  END;

  OneTaxation(L_FSS.TaxGroupAll, L_FSS.sie_IndustrialInj, L_FSS.sie_IndustrialInj);
 END {IndustrialInjuries};

 PRIVATE PROCEDURE ClosePacket();
 BEGIN
  L_Packet.SetDTStamp();
  Packet.PrpDate :=SYSDATE();
  Packet.DTStamp :=L_Packet.DTStamp;
  Packet.DataType:=L_Packet.dt_None;
  Packet.CorrType:=L_Packet.ct_None;
  REPLACE(Packet);
  L_AFM.AF_PurgeTemp("Tmp01");
  L_AFM.AF_PurgeTemp("Tmp02");
  L_AFM.AF_PurgeTemp("Tmp03");
  L_AFM.AF_PurgeTemp("Tmp04");
 END {ClosePacket};

 PRIVATE PROCEDURE PutPmntValues(ManualMake: SCAL[2]);
  VAR
   _XObject : LIKE(XObject.XObject);
   _Contract: LIKE(Contract.Contract);
   obnAcCut : LIKE(AcCut.AcCut);
   PerB     : DATE;
   Total    : L_Acnt.tAcntVector;
   S        : STRING[];
   PDAmount,
   i        : NUMERIC[0];
   IITax    : NUMERIC[2];
 BEGIN
  IF L_Pmnt.StandOnKnownContract(curMyFirm, Packet.PerE, L_Pmnt.cf_TrvmObl) THEN
   _Contract:=Contract.Contract;
   _XObject :=Contract.XObject;
   obnAcCut :=L_AcCut.erkn_Get(SYSDATE(), L_AcCut.erkn_OnlineBalance);
   Total:=L_XObj.GetTaxVector(_XObject,
                              obnAcCut,
                              EMPTYOF(AcCut.AcCut),
                              Packet.PerB, Packet.PerE);
   IF IsSince2010() THEN
    IITax:=GetFromPacket(Packet.Packet, "_ᥣ_ࠢ⨧");
    IF !IITax THEN
     IITax:=0;
    END;
    IF ManualMake & (Total[L_Acnt.avp_Credit] # IITax) THEN
     L_StdFrm.Inform("  ᠬ  ࠢ⨧:"+
                     "|  "+_Contract+",  ।: "+FLDTOSTR(Total[L_Acnt.avp_Credit], "2.", 0)+
                     "| ⭮ ᫥:         "+FLDTOSTR(IITax, "2.", 0)+
                     "|,    ..,  ᫥  (筮 )");
    END;
    IF    Total[L_Acnt.avp_InSaldo] > 0 THEN
     rsf_Numeric("T7R19C1",  Total[L_Acnt.avp_InSaldo]);
    ELSIF Total[L_Acnt.avp_InSaldo] < 0 THEN
     rsf_Numeric("T7R1C1",  -Total[L_Acnt.avp_InSaldo]);
    END;
   ELSE
    IF Total[L_Acnt.avp_InSaldo] > 0 THEN
     rsf_Numeric("000100000103", 0.00);
     rsf_Numeric("000100000903", Total[L_Acnt.avp_InSaldo]);
    ELSE
     rsf_Numeric("000100000103", -Total[L_Acnt.avp_InSaldo]);
     rsf_Numeric("000100000903", 0.00);
    END;
    IF    Total[L_Acnt.avp_OutSaldo] > 0 THEN
     rsf_Numeric("000100000803",  Total[L_Acnt.avp_OutSaldo]);
    ELSIF Total[L_Acnt.avp_OutSaldo] < 0 THEN
     rsf_Numeric("000100001403", -Total[L_Acnt.avp_OutSaldo]);
    END;
   END; (* IF IsSince2010... *)

   IF IsSince2010() THEN
    PutPDoc(_Contract, _XObject, "T7R31C1|T7R30C1|T7R29C1", 00007);
   ELSE
    i:=0;
    WHILE i < 3 DO
     PerB:=L_DatTim.IncMonth(Packet.PerE, -i);
     Total:=L_XObj.GetAcntVector(_XObject,
                                 obnAcCut,
                                 EMPTYOF(AcCut.AcCut),
                                 PerB, PerB);
     SETEMPTY(S);
     SETSEL(PDocMDoc, Contract, _Contract);
     SRCINSEL(PDocMDoc, GE, , PerB);
     WHILE OCCURE(PDocMDoc) & (PDocMDoc.PDocDate <= L_DatTim.MonthEnd(PerB)) DO
      CONFORM(PDocMDoc, PDoc);
      IF PDocMDoc.PDocKind = L_PDoc.pd_IPP THEN
       S:=L_Str.AddStrDlm(S, ",")   + L_DatTim.DateStr(PDoc.Date) + " " + PDoc.SrcNbr;
      ELSIF PDocMDoc.PDocKind = L_PDoc.pd_VPP THEN
 (*祭  *)
      END;
      NEXT(PDocMDoc);
     END; (* WHILE OCCURE(PDocMDoc) ... *)
     rsf_Numeric("0001000011"+L_Str.IntStr(14-i), Total[L_Acnt.avp_Debit]);
     ReplaceSingleField("0001000011" + L_Str.IntStr(24-i), S);
     INC(i);
    END;
   END;

   PerB:=L_DatTim.IncMonth(Packet.PerE, -3);
   Total:=L_XObj.GetTaxVector(_XObject,
                              obnAcCut,
                              EMPTYOF(AcCut.AcCut),
                              Packet.PerB, PerB);
   IF ~Since2011() THEN
    IF IsSince2010() THEN
     IF Total[L_Acnt.avp_Debit] # 0 THEN
      rsf_Numeric("T7R27C1", Total[L_Acnt.avp_Debit]);
     END;
    ELSE
     rsf_Numeric("000100001110", Total[L_Acnt.avp_Debit]);
    END;
   END;
  END; (* IF L_Pmnt.StandOnKnownContract... *)
  IF Since2011() THEN
   IF IsAcceptablePrevPeriodPacket() THEN
    rsf_Numeric("T7R27C1", GetFromPacketByAANotEmpty(prevPeriodPacket, "T7R27C1") (* 砫 ਮ*) +
                           GetFromPacketByAANotEmpty(prevPeriodPacket, "T7R29C1") (*1 *) +
                           GetFromPacketByAANotEmpty(prevPeriodPacket, "T7R30C1") (*2 *) +
                           GetFromPacketByAANotEmpty(prevPeriodPacket, "T7R31C1") (*3 *));
   END;
  END;
 END {PutPmntValues};

 PRIVATE PROCEDURE CheckATERPeriod();
  VAR
   Msg: STRING[];
 BEGIN
  IF (L_DatTim.MONTH(BPer) = 0) & (L_DatTim.MONTH(EPer) = 11) THEN
   Msg:=" " + FLDTOSTR(EPer, "y ", 0);
  ELSE
   IF L_DatTim.IsLastMonthOfQuartal(EPer) & (L_DatTim.YearBeg(BPer) = BPer) THEN
    Msg:=" " + L_Str.PoolItem("I ⠫ |㣮 |9 楢 ", L_DatTim.QUARTAL(Packet.PerE)) +
         FLDTOSTR(Packet.PerE, "y ", 0);
   ELSE
    Msg:="ਮ c " +  L_DatTim.FullDateStr(BPer) + "  " + L_DatTim.FullDateStr(EPer);
    L_StdFrm.Choice(Msg+"|  ⠭! த?");
   END;
  END;
  L_StdFrm.Question("⮢    ।⢠  |" +  Msg);
 END {CheckATERPeriod};

 PUBLIC PROCEDURE intMakeFSSSheet(ManualMake: SCAL[2]);
 BEGIN
  IF !PROCREF(E_Utils.XOMN8_Get_MCode) THEN
   L_General.InformUs(" ᫥, 頥  । ");
  END;

  L_General.Assert(ACCESS(Packet), " ࠭ ");
  L_General.Assert(Packet.DataType = L_Packet.dt_None, "ନ஢    ");

  BPer:=Packet.PerB;
  EPer:=L_DatTim.MonthEnd(Packet.PerE);
  curMyFirm:=L_Packet.GetPacketMyFirm();
  L_General.Assert(L_DatTim.MONTH(BPer) = 0, "⭮ ନ ⮫쪮  砫 ");
  L_Packet.CheckActualPacketInPer();
  L_Packet.ClearATER(0);
  IF ManualMake THEN
   CheckATERPeriod();
  END;
  IF IsSince2010() THEN
   L_General.Assert_wReferToAdmin(L_SFee.SFeeIsCalculatedInProperConsecution(L_DatTim.Per(EPer)),
                                  "ॡ  客 ᮢ  " + L_DatTim.PeriodStr(EPer) + " ᫥  |" +
                                  "    ⥫");
  END;
  IF L_APtm.MonthIsClosed(EPer, L_APtm.system_Salary) THEN
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  END;
  _Table2:=00000;
  L_Packet.PutManualInputATERAttr();
  Account();
  AverageCount(ManualMake);
  SocialInsuranceExpences();
  IndustrialInjuries();
  PutPmntValues(ManualMake);
  ClosePacket();
 END {intMakeFSSSheet};

 PUBLIC PROCEDURE MakeFSSSheet();
 BEGIN
  intMakeFSSSheet(1);
 END {MakeFSSSheet};

END.
