(*
%Copyright   (c) Polak IT
%Author      28.04.2008 12:45:56 POLAK\Bor
%Purpose       ⢮
%Type        report
%Specific    SYS,
%Modified    04.02.2014 18:35:40 POLAK\LDA
%Environment
*)

 MODULE XOMN9 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Packet, L_Str, L_XObj, L_StdFrm, L_MathR, L_AFM, P_Math, P_MyFirm, Str, L_ATER;

 PRIVATE TYPE
  tScope      = SCAL[2];
  tPropKind   = SCAL[4];
  tTaxConcess = SCAL[1e7];
  tTaxRate    = NUMERIC[2];
  tCost       = NUMERIC[2][15];

 PRIVATE CONST
  s_RemCost = 0;
  s_AdvSum  = 1;

  idx_EndPer     = 13;
  idx_RealEstate = 14;

 PRIVATE VAR
  trgTable2 : LIKE(ATERAttr.Table);
  trgRow2   : LIKE(ATERAttr.Row);
  prvPackets: LIKE(Packet.Packet)[3];

 PRIVATE PROCEDURE MathIsImmovables(trgMath: LIKE(Math.Math); D: DATE): SCAL[2];
 BEGIN
  L_MathR.PosToKAG(trgMath, D);
  RETURN (KAGLog.DeprecT = 01) | (KAGLog.DeprecT = 02) | (KAGLog.DeprecT = 03) |
         (~!KAGLog.OKOF & (KAGLog.OKOF < 140000000));
 END {MathIsImmovables};

 PRIVATE PROCEDURE Create_Mth1();
 BEGIN
  CreateFILE(_Mth1, "", "", "");

  CreateFIELD(_Mth1, Scope,         tScope,         "", "",  "", " 祭", "0-筠 ⮨ 筮;1-ᮢ ⥦");
  CreateFIELD(_Mth1, PropKind,      tPropKind,      "", "",  "", " ⢠", "");
  CreateFIELD(_Mth1, TaxRate,       tTaxRate,       "", "",  "", " ⠢", "");
  CreateFIELD(_Mth1, TaxConcess,    tTaxConcess,    "", "",  "", "  죮", "");
  CreateFIELD(_Mth1, TaxDecConcess, tTaxConcess,    "", "",  "", "  죮     ⠢", "");
  CreateFIELD(_Mth1, Cost,          tCost,          "", "0", "", "筠 ⮨ 筮", "");
  CreateFIELD(_Mth1, ContCost,      tCost,          "", "0", "", "筠 ⮨ 죮㥬 ⢠ 筮", "");

  CreateINDEX(_Mth1, _Mth1, UNIQUE, "", "", Scope, PropKind, TaxRate, TaxConcess, TaxDecConcess);
  SetVersionOfFILE(_Mth1, 0);
 END {Create_Mth1};

 PRIVATE PROCEDURE psf_Str(Value, pn: STRING[]);
 BEGIN
  L_Packet.psf_Str(pn, Value, trgTable2, trgRow2);
 END {psf_Str};

 PRIVATE PROCEDURE psf_Num(Value: FLOAT; pn: STRING[]);
 BEGIN
  L_Packet.psf_Num(pn, Value, trgTable2, trgRow2);
 END {psf_Num};

 PRIVATE PROCEDURE GetPropKind(): tPropKind; (*  ⢠*)
 BEGIN
  RETURN 3; (*㣮 ⢮*)
 END {GetPropKind};

 PRIVATE PROCEDURE PosToMth1(_Scope        : tScope;
                             _PropKind     : tPropKind;
                             _TaxRate      : tTaxRate;
                             _TaxConcess,
                             _TaxDecConcess: tTaxConcess): SCAL[2];
  VAR
   Has: SCAL[2];
 BEGIN
  Has:=SELECT(_Mth1, _Mth1, _Scope, _PropKind, _TaxRate, _TaxConcess, _TaxDecConcess);
  IF ~Has THEN
   Has:=!_TaxDecConcess & ~!_TaxConcess &
        SELECT(_Mth1, _Mth1, _Scope, _PropKind, _TaxRate, "", "");
  END;
  RETURN Has;
 END {PosToMth1};

 PRIVATE PROCEDURE GetAdvSum();
  VAR
   i        : NUMERIC[0];
   Sum      : NUMERIC[2];
 BEGIN
  i      :=0;
  LOOP
   IF i = 3 THEN
    EXIT;
   END;
   IF ~!prvPackets[i] THEN
    SAVE(PckATER);
    SELECT(PckATER, Packet, , prvPackets[i], "㬀");
    WHILE OCCURE(PckATER) DO
     IF ~!PckATER.Value THEN
      Sum:=STRTOFLD(PckATER.Value, NUMERIC);
      ADD(_Mth1, _Mth1, , s_AdvSum, L_ATER.extGetNumericValueFromPacket(prvPackets[i], "",   PckATER.Table2, 1),
                                    L_ATER.extGetNumericValueFromPacket(prvPackets[i], "⠢",   PckATER.Table2, 1),
                                    L_ATER.extGetNumericValueFromPacket(prvPackets[i], "", PckATER.Table2, 1),
                                    L_ATER.extGetNumericValueFromPacket(prvPackets[i], "",  PckATER.Table2, 1),
          _Mth1.Cost[0], Sum);
     END;
     NEXT(PckATER);
    END; (* WHILE OCCURE(PckATER) ... *)
    INC(Sum);
    RESTORE(PckATER);
   END; (* IF ~!prvPackets[i]...*)
   INC(i);
  END; (* LOOP *)
 END {GetAdvSum};

 PRIVATE PROCEDURE IsMathIsRealEstate(P: DATE): SCAL[2];
  VAR
   Grp: SCAL[99];
 BEGIN
  L_MathR.PosToKAG(Math.Math, P);
  L_General.Assert(~!KAGLog.OKOF, " " + Math.Math + ":  㪠   㯯 த  " + KAGLog.KAGroup);
  Grp:=Str.Slice(KAGLog.OKOF, 0, 2);
  RETURN (Grp = 11) | (Grp = 12) | (Grp = 13);
 END {IsMathIsRealEstate};

 PRIVATE PROCEDURE IsCPDDeclAfter2010(BPer: DATE): SCAL[2];
 BEGIN
  RETURN (ATER.Kind = L_Packet.knd_CPT_Decl) & (L_DatTim.YEAR(BPer) >= 2011);
 END {IsCPDDeclAfter2010};

 PRIVATE PROCEDURE IsCPDAdvRepAfter2013(BPer: DATE): SCAL[2];
 BEGIN
  RETURN (ATER.Kind = L_Packet.knd_CPT_AdvRep) & (L_DatTim.YEAR(BPer) >= 2014);
 END {IsCPDAdvRepAfter2013};

 PRIVATE PROCEDURE MakeIndex(BPer, EPer: DATE);
  VAR
   P            : DATE;
   i            : SCAL[100];
   Cost,
   ContCost     : L_XObj.tSum;
   TaxConcess,
   TaxDecConcess,
   _PropTaxCode : P_MyFirm.tPropTaxCode;
   _PropTaxRate,
   TTaxRate     : P_MyFirm.tPropTaxRate;
   TCost,
   TContCost    : tCost;
   IsRealEstate : SCAL[2];
 BEGIN
  Create_Mth1();
  L_AFM.CreateTemp("_Mth1");
  SELECT(Math, LeafMK, , 1, L_MathR.mathk_KeyAs);
  WHILE OCCURE(Math) DO
   PROMPT(": "+Math.Math);
   IF (Math.MyFirm = Packet.MyFirm) &
      (~L_Packet.Kind_wMyPlace(EPer, Packet.Kind) | (Packet.MyPlace = P_Math.GetMyPlace(Math.Math, EPer))) THEN
    L_MathR.CountUpMath(Math.Math, EPer);
    P:=BPer;
    i:=1;
    WHILE P <= (EPer+1) DO
     Cost:=L_MathR.GetKeyAssBalCostR(P, L_MathR.KA_All) - L_MathR.GetKeyAssWearR(P, L_MathR.KA_All);
     IF Cost # 0 THEN
      IF P >= 01\01\2013 THEN
       IF ~MathIsImmovables(Math.Math, L_DatTim.MonthEnd(P)) & (L_MathR.GetKeyAssAPrDate(Math.Math) >= 01\01\2013) THEN
        Cost:=0;
       END;
      END;
     END; (* IF Cost # 0 *)
     IF Cost # 0 THEN
      P_Math.PropertyTax(Math.Math, EPer, _PropTaxCode, _PropTaxRate);
      IF !_PropTaxRate THEN
       P_MyFirm.PropertyTax(Packet.MyFirm, EPer, _PropTaxCode, _PropTaxRate);
      END;
      IF _PropTaxRate=0 THEN
       TaxConcess   :=_PropTaxCode;
       TaxDecConcess:="";
       ContCost     :=Cost;
      ELSE
       TaxConcess   :="";
       TaxDecConcess:=_PropTaxCode;
       ContCost     :=0;
      END;

      IF (P <= EPer) & IsCPDDeclAfter2010(BPer) THEN
       IsRealEstate:=IsMathIsRealEstate(P);
      ELSE
       IsRealEstate:=0;
      END;
 
      ADD(_Mth1, _Mth1, , s_RemCost, GetPropKind(), _PropTaxRate, TaxConcess, TaxDecConcess,
          _Mth1.Cost[i],                  Cost,
          _Mth1.ContCost[i],              ContCost,
          _Mth1.Cost[idx_RealEstate],     Cost * IsRealEstate,
          _Mth1.ContCost[idx_RealEstate], ContCost * IsRealEstate);
     END; (* IF Cost # 0 *)
     P:=L_DatTim.IncMonth(P, +1);
     INC(i);
    END; (* WHILE P <= ... *)
   END; (* IF (Math.MyFirm ... *)
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)

  (*᪫뢠 ⢮  죮   ⮡ 뢥   ⠡*)
  SELECT(_Mth1, _Mth1, , s_RemCost);
  WHILE OCCURE(_Mth1) DO
   NARROWSEL(_Mth1, PropKind);
   IF _Mth1.TaxRate = 0 THEN
    L_General.Assert(~!_Mth1.TaxConcess, "⠢  0%   죮");
    LAST(_Mth1); (*ᠬ  ⠢*)
    IF !_Mth1.TaxConcess & !_Mth1.TaxDecConcess THEN
     TCost    :=_Mth1.Cost;
     TContCost:=_Mth1.ContCost;
     TTaxRate :=_Mth1.TaxRate;

     REMOVE(_Mth1);
     FIRST(_Mth1);
     i:=0;
     WHILE i <= HIGH(TCost) DO
      INC(_Mth1.Cost[i],     TCost[i]);
      INC(_Mth1.ContCost[i], TContCost[i]);
      INC(i);
     END;
     _Mth1.TaxRate:=TTaxRate;
     REPLACE(_Mth1);
    END;
   END;
   NEXTINEXTENDEDSEL(_Mth1, PropKind);
  END; (* WHILE OCCURE(_Mth1) ... *)
 END {MakeIndex};

 PRIVATE PROCEDURE FillPrvPackets(BPer: DATE);
  VAR
   i      : NUMERIC[0];
   tmpPerB,
   tmpPerE: DATE;
 BEGIN
  SETEMPTY(prvPackets);
  tmpPerB:=BPer;
  tmpPerE:=BPer;
  i      :=0;
  LOOP
   IF i = 3 THEN
    EXIT;
   END;
   tmpPerE      :=L_DatTim.IncMonth(tmpPerE, 2+1*(i#0));
   prvPackets[i]:=L_ATER.GetPacket(Packet.Packet, Packet.MyFirm, L_Packet.knd_CPT_AdvRep, tmpPerB, tmpPerE);
   INC(i);
  END; (* LOOP *)
 END {FillPrvPackets};

 PRIVATE PROCEDURE Make(BPer, EPer: DATE);
  VAR
   i    : SCAL[100];
   Base,
   Base0: NUMERIC[2];
   Tax  : NUMERIC[0];
   ds   : STRING[4];
 BEGIN
  trgTable2:=00000;
  trgRow2  :=00000;

  IF    (ATER.Kind = L_Packet.knd_CPT_AdvRep) THEN
   psf_Str(L_Packet.GetIdFile("NO_IMUR"), "");
  ELSIF (ATER.Kind = L_Packet.knd_CPT_Decl) THEN
   psf_Str(L_Packet.GetIdFile("NO_IMUD"), "");
  END;

  MakeIndex(BPer, EPer);
  IF ATER.Kind = L_Packet.knd_CPT_Decl THEN
   GetAdvSum();
  END;

  SELECT(_Mth1, _Mth1, , s_RemCost);
  LAST(_Mth1);
  WHILE OCCURE(_Mth1) DO
   psf_Str(_Mth1.PropKind,   "");
   IF ~!_Mth1.TaxConcess THEN
    psf_Str(_Mth1.TaxConcess, "");
   END;
   IF ~!_Mth1.TaxDecConcess THEN
    psf_Str(_Mth1.TaxDecConcess, "");
   END;
   psf_Num(_Mth1.TaxRate,    "⠢");

   SETZERO(Base, Base0);
   i:=1;
   WHILE i<=(L_DatTim.MONTH(EPer)+2(*!    ਮ ⮦*)) DO
    IF i < idx_EndPer THEN
     ds:="01"+i;
    ELSE
     ds:="3112";
    END;
    psf_Num(_Mth1.Cost[i], ""+ds);
    INC(Base, _Mth1.Cost[i]);
    IF _Mth1.Cost[i] # 0 THEN
     psf_Num(_Mth1.ContCost[i], "죈"+ds);
     INC(Base0, _Mth1.ContCost[i]);
    END;
    INC(i);
   END;

   IF IsCPDAdvRepAfter2013(BPer) THEN
    psf_Num(_Mth1.Cost[i-1], "");
   END;

   IF IsCPDDeclAfter2010(BPer) THEN
    psf_Num(_Mth1.Cost[idx_RealEstate] / 13, "⍥");
    psf_Num(_Mth1.ContCost[idx_RealEstate],  "죈鍥");
   END;

   Base :=Base / (i-1);
   Base0:=Base0 / (i-1);

   WHILE i<=10 DO (*  砥 ᮢ *)
    psf_Num(EMPTYOF(NUMERIC[2]), "01"+i);
    INC(i);
   END;

   psf_Num(Base, "∬");
   IF Base0 # 0 THEN
    psf_Num(Base0, "∬鍥");
   END;

   IF ATER.Kind = L_Packet.knd_CPT_AdvRep THEN
    Tax:=(Base-Base0)*_Mth1.TaxRate/4/100;
    psf_Num(Tax, "㬀");
   ELSE
    Tax:=(Base-Base0)*_Mth1.TaxRate/100;
    psf_Num(Base-Base0, "");

    psf_Num(Tax, "㬍");

    SAVE(_Mth1);
    IF PosToMth1(s_AdvSum, _Mth1.PropKind, _Mth1.TaxRate, _Mth1.TaxConcess, _Mth1.TaxDecConcess) THEN
     psf_Num(_Mth1.Cost[0], "㬀");
     REMOVE(_Mth1); (*⮡   *)
    ELSE
     psf_Num(0,             "㬀");
    END;
    RESTORE(_Mth1);
   END;

   INC(trgTable2);
   PREV(_Mth1);
  END; (* WHILE OCCURE(_Mth1) ... *)

  SELECT(_Mth1, _Mth1, , s_AdvSum);
  WHILE OCCURE(_Mth1) DO
   L_StdFrm.Choice(" ᮢ     㬬 ⥦"+
                   "|᫥  ⠢ , 騬  樨:"+
                   "|  ⢠: "+_Mth1.PropKind+
                   "|  죮: "+FLDTOSTR(_Mth1.TaxConcess, "")+
                   "|  죮     ⠢: "+FLDTOSTR(_Mth1.TaxDecConcess, "")+
                   "| ⠢ (%): "+FLDTOSTR(_Mth1.TaxRate, "2.")+
                   "||㬬   㯫   । ४");
   NEXT(_Mth1);
  END; (* WHILE OCCURE(_Mth1) ... *)
  L_Packet.FinishATER(L_Packet.st_InProcess);
  L_AFM.AF_PurgeTemp("_Mth1");
 END {Make};

 PUBLIC PROCEDURE XOMN9();
  VAR
   Msg                 : STRING[];
   BPer, EPer          : DATE;
   IsFirstQuartalPacket: SCAL[2];
 BEGIN
  L_General.Assert(ACCESS(Packet), " ࠭ ");
  L_Packet.CheckQuartalATER(1, IsFirstQuartalPacket, BPer, EPer);

  L_Packet.ClearATER(0);
  IF ATER.Kind = L_Packet.knd_CPT_Decl THEN
   FillPrvPackets(BPer);
  END;
  Make(BPer, EPer);
 END {XOMN9};

END.
