(*
%Copyright   (c) Polak Computer System
%Author      15.03.2004 17:17:39 POLAK\GAV
%Purpose     Excel (ole) প ⮢  設.
%Type        control
%Specific    SYS
%Modified    18.02.2013 17:53:10 ROBOT by POLAK\MLB
%Environment
*)

 TYPE
  tCondition = SCAL[100];

 CONST
  MaxKey = 128;

  prm_BoxNbr = "";
  prm_Value  = "";

 IMPORT L_General, Str, L_OLE, L_AFM, L_Env, L_Car;

 VAR
  IntvlB,
  IntvlE   : DATE;
  v_BoxNbr,
  v_Value  : STRING[];

 PRIVATE PROCEDURE FillParams(Heap: STRING[]);
  VAR
   Params: STRING[][32];
 BEGIN
  L_OLE.SliceBySingle(Heap, Params);
  L_OLE.SetByKeyWord(Params, prm_BoxNbr, v_BoxNbr);
  L_OLE.SetByKeyWord(Params, prm_Value,  v_Value);
 END {FillParams};

 PRIVATE PROCEDURE Condition(): SCAL[2];
 BEGIN
  RETURN L_Env.RealBoxNbr(Car.BoxNbr) &
         L_Car.CarIsInOperation(Car.BoxNbr, IntvlE);
 END {Condition};

 PRIVATE PROCEDURE Create_x_car();
 BEGIN
  TRY
   CreateFILE(x_car, "", "᮪ ", "");
   CreateFIELD(x_car, BoxNbr, LIKE(Car.BoxNbr), "", "", "", "ࠦ", "");
   CreateINDEXandLINK(x_car, BoxNbr, UNIQUE, Car, BoxNbr, USER, "", "", BoxNbr);
   SetVersionOfFILE(x_car, 0);
  EXCEPT
   ON Exc: Exc_RunTime DO
    IF Exc.ErrorCode # 95 THEN
     RAISE()
    END;
  END;
 END {Create_x_car};

 PRIVATE PROCEDURE Prepare_x_car(ForceRebuild: SCAL[2]);
 BEGIN
  Create_x_car();
  L_AFM.NewReusableFile("x_car", "x_car", L_General.timeCond_OnDate, IntvlB, IntvlE);
  IF ForceRebuild | ~L_AFM.CanReuseFile("x_car", 1) THEN
   L_AFM.CreateReusableFile("x_car");
   SELECT(Car, BoxNbr);
   WHILE OCCURE(Car) DO
    PROMPT(Car.BoxNbr);
    IF Condition() THEN
     x_car.BoxNbr:=Car.BoxNbr;
     INSERT(x_car);
    END;
    NEXT(Car);
   END; (* WHILE OCCURE(Car) ... *)
   L_AFM.ReAttachReusableFile("x_car");
  END; (* IF ~CanReuseFile ... *)
 END {Prepare_x_car};

 PRIVATE PROCEDURE Init(_IntvlB, _IntvlE: DATE; Rebuild: SCAL[2]);
 BEGIN
  IntvlB:=_IntvlB;
  IntvlE:=_IntvlE;
  L_OLE.SetUsedBasisList("x_car|");
  Prepare_x_car(Rebuild);
 END {oleInit};

 PRIVATE PROCEDURE oleInit(_IntvlB, _IntvlE: DATE);
 BEGIN
  Init(_IntvlB, _IntvlE, 0);
 END {oleInit};

 PRIVATE PROCEDURE oleInit_wRebuild(_IntvlB, _IntvlE: DATE);
 BEGIN
  Init(_IntvlB, _IntvlE, 1);
 END {oleInit};

 PRIVATE PROCEDURE oleDeInit();
 BEGIN
  L_OLE.DeInit();
 END {oleDeInit};

 PRIVATE PROCEDURE GetFirstCar(): STRING[];
 BEGIN
  IF SELECT(x_car, BoxNbr) THEN
   RETURN x_car.BoxNbr;
  ELSE
   RETURN "";
  END;
 END {GetFirstCar};

 PRIVATE PROCEDURE GetNext(Heap: STRING[]): STRING[];
 BEGIN
  FillParams(Heap);
  IF    ~!v_BoxNbr THEN
   L_General.Assert(SEARCH(x_car, BoxNbr, v_BoxNbr),
                    " ࠦ: " + v_BoxNbr);
   CHANGESEL(x_car, BoxNbr);
   IF NEXT(x_car) THEN
    RETURN x_car.BoxNbr;
   END;
  END;
  RETURN "";
 END {GetNext};

 PRIVATE PROCEDURE GetValue(Heap: STRING[]): STRING[];
 BEGIN
  FillParams(Heap);
  RETURN L_OLE.GetValue(v_Value, v_BoxNbr, IntvlE);
 END {GetValue};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
END.
