(*
%Copyright   (c) Polak Computer System
%Author      09.03.2007 18:43:05 POLAK\San
%Purpose     ole প ⠪⮢
%Type        control
%Specific    SYS
%Modified    19.12.2013 15:14:54 POLAK\LDA
%Environment
*)

 MODULE x_ctc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_ctc, L_DatTim, Str, L_Str;

 PRIVATE VAR
  List,
  Names,
  Phones: STRING[];

  LastName   : LIKE(FirmCtc.Name);
  LastECKName: LIKE(FirmCtc.ECKName);

 PRIVATE PROCEDURE gfcl_BuildListItem(S: STRING[][]; L: NUMERIC[0][]): STRING[];
  VAR
   i     : NUMERIC[0];
   Result: STRING[];
 BEGIN
  Result:="";
  i:=0;
  WHILE (i <= HIGH(L)) & ~!L[i] DO
   IF ~!Result THEN
    Result:=Result + " ";
   END;
   Result:=Result + Str.Align(S[i], L[i], LEFT);
   INC(i);
  END;
  RETURN Result;
 END {gfcl_BuildListItem};

 PRIVATE PROCEDURE cl_PutItemToList();
  CONST
   liiAmount = 5;
  VAR
   liiStr    : STRING[][liiAmount];
   liiLen    : NUMERIC[0][liiAmount];
   trgName   : LIKE(FirmCtc.Name);
   trgECKName: LIKE(FirmCtc.ECKName);
   IsOwnCtc  : SCAL[2];
 BEGIN
  liiLen[0]:=35; liiLen[1]:=25; liiLen[2]:=01; liiLen[3]:=01; liiLen[4]:=35;
  trgName   :=FirmCtc.Name;
  trgECKName:=FirmCtc.ECKName;
  IsOwnCtc  :=FirmCtc.Contact = Contact.Contact;
  IF (LastName#trgName) | !LastName THEN
   liiStr[0]  :=L_Str.Repeat(" ", (L_ctc.cl_CntParents()+1)*2) + trgName;
   liiStr[1]  :=trgECKName;
  ELSE
   liiStr[0]  :=L_Str.Repeat(" ", (L_ctc.cl_CntParents()+1)*2);
   IF (LastECKName#trgECKName) | !LastECKName THEN
    liiStr[1] :=trgECKName;
   ELSE
    liiStr[1] :="";
   END;
  END;
  LastName   :=trgName;
  LastECKName:=trgECKName;

  liiStr[2]  :=" ";
  IF ~!FCtcLst.Adr THEN
   IF FCtcLst.Coverage = L_ctc.cvc_Work THEN
    liiStr[3]  :=" ";
   ELSE
    liiStr[3]  :=L_Str.PoolItem(L_ctc.cvc_PoolShort, FCtcLst.Coverage);
   END;
   IF FCtcLst.Type = L_ctc.cvt_PhonePST THEN
    liiStr[4]:="   ";
   ELSE
    liiStr[4]:=L_Str.PoolItem(L_ctc.cvt_PoolShort, FCtcLst.Type);
   END;
   IF ~IsOwnCtc THEN
    liiStr[4]:=liiStr[4] + "    ";
   END;
   liiStr[4]:=liiStr[4] + " " + FCtcLst.Value;
   Phones:=Phones + FCtcLst.Adr + "|";
  ELSE
   liiStr[3]:="";
   liiStr[4]:="";
   Phones   :=Phones + "|";
  END;
  Names:=Names + trgName + "|";
  List:=List + gfcl_BuildListItem(liiStr, liiLen) + "|";
 END {cl_PutItemToList};

 PRIVATE PROCEDURE IsAcceptableFirmCtcId(trgFirmCtcId: LIKE(FirmCtc.Id)): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   Result:=0;
   IF trgFirmCtcId = 0000 THEN
    Result:=1;
   ELSE
    LOOP
     IF    FirmCtc.Id = trgFirmCtcId THEN
      Result:=1;
      EXIT;
     ELSIF !FirmCtc.Parent THEN
      EXIT;
     END;
     SEARCH(FirmCtc, Id, , FirmCtc.Firm, FirmCtc.Parent);
    END; (* LOOP *)
   END;
  EXCEPT
  ON Exc:Exc_Root DO
   RAISE();
  END; (* TRY *)
  RETURN Result;
 END {IsAcceptableFirmCtcId};

 PUBLIC PROCEDURE GetFirmCtcList(trgFirm: LIKE(Firm.Firm); trgFirmCtcId: LIKE(FirmCtc.Id)): STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt(" ⠪⮢ ࠣ");
  SETEMPTY(List, Phones, Names, LastName, LastECKName);
  TRY
   L_General.Assert(SEARCH(Firm, Firm, trgFirm), "  ࠣ   " + trgFirm);
   L_ctc.MakeFCtcLst(L_ctc.ls_FirmForJournal, SYSDATE());
   SELECT(FCtcLst, Source, , L_ctc.cls_CtcVal);
   WHILE OCCURE(FCtcLst) DO
    PROMPT(L_Str.IntStr(FCtcLst.Num));
    IF ~FCtcLst.Leaf | ~!FCtcLst.Value THEN
     IF !FCtcLst.Adr | (FCtcLst.MthConnect = 0) | (FCtcLst.MthConnect = 1) THEN
      L_General.CallUs(SEARCH(FirmCtc, Id, trgFirm, FCtcLst.FCtcId));
      IF ~!FCtcLst.Adr THEN
       L_General.CallUs(SEARCH(Contact, Contact, FCtcLst.Contact));
      END;
      IF IsAcceptableFirmCtcId(trgFirmCtcId) THEN
       cl_PutItemToList();
      END;
     END;
    END;
    NEXT(FCtcLst);
   END; (* WHILE OCCURE(FCtcLst) ... *)
   L_General.RaiseLockReleaseException();
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.CheckIsLockReleaseException(Exc);
  END; (* TRY *)
  RETURN List;
 END {GetFirmCtcList};

 PUBLIC PROCEDURE Call(Idx: NUMERIC[0]);
  VAR
   Phone: STRING[];
 BEGIN
  Phone:=L_Str.AnyItem(Phones, "|", Idx);
  L_General.Assert(~!Phone & (Phone # " "), "  ⥫䮭");
  L_ctc.Call(Phone, Str.Item(Names, "|", Idx, 0, 1));
 END {Call};

END.
