(*
%Copyright   (c) Polak Computer System
%Author      15.03.2002 17:43:01 SAN
%Purpose     Excel (ole) প ⮢  ࠡ⭨.
%Type        control
%Specific    SYS
%Modified    10.04.2012 12:32:15 ROBOT by POLAK\LDA
%Environment
*)

 TYPE
  tCondition = SCAL[100];

 CONST
  MaxKey = 128;

  prm_TSN    = "";
  prm_Value  = "";
  prm_EDORow = "ப";

 IMPORT L_Env, L_General, Str, L_Str, L_OLE, L_DatTim, L_AFM, L_EDO,
(****** 㦭  㯠  L_OLE ***************************************)
        L_Man, L_Staff, P_Man, P_Staff, P_Car, P_Mark, P_Route, P_EDOKnd,
        P_Math, P_Firm, P_Union, P_Sort, P_Cntr, P_Post, P_Officer;
(*************************************************************************)
 VAR
  IntvlB,
  IntvlE   : DATE;
  v_TSN,
  v_EDORow,
  v_Value  : STRING[];

 PRIVATE PROCEDURE FillParams(Heap: STRING[]);
  VAR
   Params: STRING[][32];
 BEGIN
  L_OLE.SliceBySingle(Heap, Params);
  L_OLE.SetByKeyWord (Params, prm_TSN,    v_TSN);
  L_OLE.SetByKeyWord (Params, prm_EDORow, v_EDORow);
  L_OLE.SetByKeyWord (Params, prm_Value,  v_Value);
 END {FillParams};

 PRIVATE PROCEDURE Condition(): SCAL[2];
 BEGIN
  RETURN EDOrderL.Status = L_EDO.st_Passed;
 END {Condition};

 PRIVATE PROCEDURE Create_EDOL1();
 BEGIN
  TRY
   CreateFILE(EDOL1, "", "᮪ ப ਪ", "");

   CreateFIELD(EDOL1, EDOrder, LIKE(EDOrderL.EDOrder), "", "", "", "", "");
   CreateFIELD(EDOL1, Row,     LIKE(EDOrderL.Row),     "", "", "", "", "");

   CreateINDEXandLINK(EDOL1, EDOrder, UNIQUE, EDOrder, EDOrder, USER, "", "", EDOrder, Row);
  EXCEPT
   ON Exc: Exc_RunTime DO
    IF Exc.ErrorCode # 95 THEN
     RAISE()
    END;
  END;
  SetVersionOfFILE(EDOL1, 0);
 END {Create_EDOL1};

 PRIVATE PROCEDURE Prepare_EDOL1(ForceRebuild: SCAL[2]);
 BEGIN
  Create_EDOL1();
  L_AFM.NewReusableFile("EDOL1", "EDOL1", L_General.timeCond_InIntvl, IntvlB, IntvlE);
  IF ForceRebuild | ~L_AFM.CanReuseFile("EDOL1", 1) THEN
   L_AFM.CreateReusableFile("EDOL1");
   SELECT(EDOrder, EDODate);
   SRCINSEL(EDOrder, GE, , IntvlB);
   WHILE OCCURE(EDOrder) & (EDOrder.Date <= IntvlE) DO
    PROMPT(L_DatTim.DateStr(EDOrder.Date) + " " + EDOrder.EDOrder);
    SELECT(EDOrderL, EDOrder, , EDOrder.EDOrder);
    WHILE OCCURE(EDOrderL) DO
     IF Condition() THEN
      EDOL1.EDOrder:=EDOrderL.EDOrder;
      EDOL1.Row    :=EDOrderL.Row;
      INSERT(EDOL1);
     END;
     NEXT(EDOrderL);
    END; (* WHILE OCCURE(EDOrderL) ... *)
    NEXT(EDOrder);
   END; (* WHILE OCCURE(EDOrder) ... *)
   L_AFM.ReAttachReusableFile("EDOL1");
  END; (* IF ~CanReuseFile ... *)
 END {Prepare_EDOL1};

 PRIVATE PROCEDURE Init(_IntvlB, _IntvlE: DATE; Rebuild: SCAL[2]);
 BEGIN
  IntvlB:=_IntvlB;
  IntvlE:=_IntvlE;
  L_OLE.SetUsedBasisList("EDOL1|");
  Prepare_EDOL1(Rebuild);
 END {oleInit};

 PRIVATE PROCEDURE oleInit(_IntvlB, _IntvlE: DATE);
 BEGIN
  Init(_IntvlB, _IntvlE, 0);
 END {oleInit};

 PRIVATE PROCEDURE oleInit_wRebuild(_IntvlB, _IntvlE: DATE);
 BEGIN
  Init(_IntvlB, _IntvlE, 1);
 END {oleInit};

 PRIVATE PROCEDURE oleDeInit();
 BEGIN
  L_OLE.DeInit();
 END {oleDeInit};

 PRIVATE PROCEDURE EDOL1_Id(): STRING[];
 BEGIN
  RETURN EDOL1.EDOrder + "|" + EDOL1.Row;
 END {EDOL1_Id};

 PRIVATE PROCEDURE AccessEDOL1(Id: STRING[]);
 BEGIN
   L_General.Assert(SEARCH(EDOL1, EDOrder, L_Str.PoolItem(Id, 0),
                                           L_Str.PoolItem(Id, 1)),
                    "ୠ ப ਪ: "+v_EDORow);
 END {AccessEDOL1};

 PRIVATE PROCEDURE AccessEDOrderL(Id: STRING[]);
 BEGIN
  L_General.Assert(SEARCH(EDOrderL, EDOrder, L_Str.PoolItem(Id, 0),
                                             L_Str.PoolItem(Id, 1)),
                   "ୠ ப ਪ: "+v_EDORow);
 END {AccessEDOL1};

 PRIVATE PROCEDURE GetFirst(): STRING[];
 BEGIN
  IF SELECT(EDOL1, EDOrder) THEN
   RETURN EDOL1_Id();
  END;
  RETURN "";
 END {GetFirst};

 PRIVATE PROCEDURE GetNext(Heap: STRING[]): STRING[];
 BEGIN
  FillParams(Heap);
  IF    ~!v_EDORow THEN
   AccessEDOL1(v_EDORow);
   CHANGESEL(EDOL1, EDOrder);
   IF NEXT(EDOL1) THEN
    RETURN EDOL1_Id();
   END;
  END;
  RETURN "";
 END {GetNext};

 PRIVATE PROCEDURE _GetToStr(s: STRING[]): PROC;
 BEGIN
  RETURN PROCREF(^s);
 END {_GetToStr};

 PRIVATE PROCEDURE GetValue(Heap: STRING[]): STRING[];
  VAR
   FirstFile: STRING[];
 BEGIN
  FillParams(Heap);
  IF    !v_Value THEN
   RETURN "";
  END;
  FirstFile:=Str.Item(v_Value, ".", 0);

  IF FirstFile = "EDOrderL" THEN
   IF !v_EDORow THEN
    RETURN "";
   END;
   AccessEDOrderL(v_EDORow);
  ELSE
   L_General.Error(" 䨪: " + FirstFile);
  END;
  RETURN L_OLE.GetValue(v_Value, IntvlE, PROCREF(_GetToStr));
 END {GetValue};

BEGIN
END.