(*
%Copyright   (c) Polak Computer System
%Author      28.05.2002 15:47:15 GAV
%Purpose     Excel (ole) প  ⮢  ௫
%Type        control
%Specific    SYS
%Modified    10.04.2012 12:32:20 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, L_DatTim, L_OLE, L_AFM, L_MathR, L_MDoc, L_Acnt, L_XObj;

 CONST
  prm_Cir     = "";
  prm_Math    = "";
  prm_AcCut   = "१";
  prm_Storage = "";
  MaxKey = 128;

 VAR
  IntvlB,
  IntvlE   : DATE;
  v_AcCut,
  v_Cir,
  v_Math,
  v_Storage: L_OLE.tKeyValue[MaxKey];

 PRIVATE PROCEDURE Create_MD002();
 BEGIN
  TRY
   CreateFILE(MD002, "", " 業⥩  ਮ", "");
   CreateFIELD(MD002, Math,    LIKE(Math.Math),       "", "",  "", " ", "");
   CreateFIELD(MD002, Storage, LIKE(Storage.Storage), "", "",  "", " ࠭", "");
   CreateFIELD(MD002, Rest,    L_XObj.tQnt,           "", "0", "", "⮪", "");
   CreateFIELD(MD002, Dbt,     L_XObj.tQnt,           "", "0", "", "室", "");
   CreateFIELD(MD002, Crd,     L_XObj.tQnt,           "", "0", "", "室", "");
   CreateINDEXandLINK(MD002, Math, UNIQUE, Math, Math, USER, "", "", Math, Storage);
   SetVersionOfFILE(MD002, 8);
  EXCEPT
   ON Exc: Exc_RunTime DO
    IF Exc.ErrorCode # 95 THEN
     RAISE()
    END;
  END;
 END {Create_MD002};

 PRIVATE PROCEDURE AddMath();
 BEGIN
  SELECT(mItem, Math, , Math.Math);
  WHILE OCCURE(mItem) DO
   SELECT(XCalc, XObject, , mItem.XObject);
   WHILE OCCURE(XCalc) DO
    CHANGESEL(XCalc, XObject, , mItem.XObject, XCalc.AcCut);
    IF L_MathR.AcCutOfRealStock(XCalc.AcCut) & SRCINSEL(XCalc, LT, IntvlB) THEN
     ADD(MD002, Math, , Math.Math, mItem.Storage,
         MD002.Rest, XCalc.SldQnt+XCalc.DbtQnt-XCalc.CrdQnt);
    END;
    LAST(XCalc);
    CHANGESEL(XCalc, XObject, , mItem.XObject);
    NEXT(XCalc);
   END; (* WHILE OCCURE(XCalc) ... *)
   NEXT(mItem);
  END; (* WHILE OCCURE(mItem) ... *)
 END {AddMath};

 PRIVATE PROCEDURE AddCir();
  VAR
   Dir: L_MDoc.tMathFlowType;
 BEGIN
  Dir:=L_MDoc.getMDocListStorageRelatedMathFlowType();
  IF ~!MDoc.Storage THEN
   IF    Dir = L_MDoc.mft_Debit THEN
    ADD(MD002, Math, , MDocList.Math, MDoc.Storage,
        MD002.Dbt, MDocList.Qnt);
   ELSIF Dir = L_MDoc.mft_Credit THEN
    ADD(MD002, Math, , MDocList.Math, MDoc.Storage,
        MD002.Crd, MDocList.Qnt);
   END;
  END;
  IF ~!MDoc.Storage2 THEN
   IF    Dir = L_MDoc.mft_Debit THEN
    ADD(MD002, Math, , MDocList.Math, MDoc.Storage2,
        MD002.Crd, MDocList.Qnt);
   ELSIF Dir = L_MDoc.mft_Credit THEN
    ADD(MD002, Math, , MDocList.Math, MDoc.Storage2,
        MD002.Dbt, MDocList.Qnt);
   END;
  END;
 END {AddCir};

 PRIVATE PROCEDURE Prepare_MD002(ForceRebuild: SCAL[2]);
 BEGIN
  L_DatTim.CheckWMIntvl(IntvlB, IntvlE);

  Create_MD002();
 
  L_AFM.NewReusableFile("MD002", "MD002", L_General.timeCond_InIntvl, IntvlB, IntvlE);
  IF ForceRebuild | ~L_AFM.CanReuseFile("MD002", 1) THEN
   L_AFM.CreateReusableFile("MD002");

   SELECT(Math, LeafMK, , 1, L_MathR.mathk_Math);
   WHILE OCCURE(Math) DO
    PROMPT(Math.Math);
    AddMath();
    NEXT(Math);
   END; (* WHILE OCCURE(Math) ... *)

   SELECT(MDoc, Date);
   SRCINSEL(MDoc, GE, , IntvlB);
   WHILE OCCURE(MDoc) & (MDoc.Date <= IntvlE) DO
    IF (MDoc.Status = L_MDoc.st_Passed) & ~L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) THEN
     CONFORM(MDoc, Dest);
     CONFORM(MDoc, MDocKind);
     IF MDocKind.Activity THEN
      SELECT(MDocList, MDLMath, , MDoc.MDocKind, MDoc.MDoc);
      PROMPT(FLDTOSTR(MDoc.Date) + " " + MDocKind.Sign + " " + MDoc.MDoc);
      WHILE OCCURE(MDocList) DO
       IF ~!MDocList.Math THEN
        CONFORM(MDocList, Math);
        IF Math.MathKind = L_MathR.mathk_Math THEN
         AddCir();
        END;
       END;
       NEXT(MDocList);
      END; (* WHILE OCCURE(MDocList) ... *)
     END;
    END;
    NEXT(MDoc);
   END; (* WHILE OCCURE(MDoc) ... *)

   L_AFM.ReAttachReusableFile("MD002");
  END; (* IF ~CanReuseFile ... *)
 END {Prepare_MD002};

 PRIVATE PROCEDURE GSM_GetCir(Heap: STRING[]): L_XObj.tSum;
  VAR
   Params: STRING[][32];
   Sum   : L_XObj.tSum;
   i     :   NUMERIC[0];
   Fld   : STRING[];
 BEGIN
  L_OLE.SliceBySingle(Heap, Params);
  L_OLE.FillByKeyWord(Params, prm_Cir,     v_Cir);
  L_OLE.FillByKeyWord(Params, prm_Math,    v_Math);
  L_OLE.FillByKeyWord(Params, prm_Storage, v_Storage);
  Sum:=0;
  IF L_OLE.HasCondition(v_Cir) THEN
   i:=0;
   WHILE ~!v_Math[i] DO
    SELECT(MD002, Math, , v_Math[i]);
    WHILE OCCURE(MD002) DO
     IF L_OLE.Check(MD002.Storage, v_Storage) THEN
      IF    (v_Cir[0] = 0) THEN INC(Sum, MD002.Rest);
      ELSIF (v_Cir[0] = 1) THEN INC(Sum, MD002.Dbt);
      ELSIF (v_Cir[0] = 2) THEN INC(Sum, MD002.Crd);
      END;
     END;
     NEXT(MD002);
    END;
    INC(i);
   END;
  END;
  RETURN Sum;
 END {GSM_GetCir};

 PRIVATE PROCEDURE GSM_GetMathName(_Math: STRING[]): STRING[];
 BEGIN
  IF SEARCH(Math, Math, _Math) THEN
   RETURN Math.Name;
  ELSE
   RETURN "";
  END;
 END {GSM_GetMathName};

 PRIVATE PROCEDURE Init(_IntvlB, _IntvlE: DATE; Rebuild: SCAL[2]);
 BEGIN
  IntvlB:=_IntvlB;
  IntvlE:=_IntvlE;
  L_OLE.SetUsedBasisList("MD002|");
  Prepare_MD002(Rebuild);
 END {Init};

 PRIVATE PROCEDURE oleInit(_IntvlB, _IntvlE: DATE);
 BEGIN
  Init(_IntvlB, _IntvlE, 0);
 END {oleInit};

 PRIVATE PROCEDURE oleInit_wRebuild(_IntvlB, _IntvlE: DATE);
 BEGIN
  Init(_IntvlB, _IntvlE, 1);
 END {oleInit};

 PRIVATE PROCEDURE oleDeInit();
 BEGIN
  L_OLE.DeInit();
 END {oleDeInit};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
END.
