(*
%Copyright   (c) Polak Computer System
%Author      15.03.2002 17:43:01 SAN
%Purpose     Excel (ole) প  ⮢  ௫
%Type        control
%Specific    SYS
%Modified    26.08.2014 17:25:39 POLAK\Gina
%Environment
*)

 IMPORT L_AFM, L_Staff, L_General, L_APtm, Str, DBD, D_Slr,
        Math, L_OLE, L_DatTim;

 CONST
  prm_MCode    = "";
  prm_Union    = "⥣";
  prm_Post     = "";
  prm_Sort     = "";
  prm_Contract = "";
  prm_FOT      = "";
  prm_Officer  = "";
  prm_ContDTyp = "";
  MaxKey = 256;

 VAR
  IntvlB,
  IntvlE : DATE;

  v_ContDTyp,
  v_FOT,
  v_MCode,
  v_Union,
  v_Post,
  v_Sort,
  v_Officer,
  v_Contract : L_OLE.tKeyValue[MaxKey];

 PRIVATE PROCEDURE FillParams(Heap: STRING[]);
  VAR
   Params     : STRING[][32];
 BEGIN
  L_OLE.SliceBySingle(Heap, Params);
  L_OLE.FillByKeyWord(Params, prm_FOT,      v_FOT);
  L_OLE.FillByKeyWord(Params, prm_MCode,    v_MCode);
  L_OLE.FillByKeyWord(Params, prm_Union,    v_Union);
  L_OLE.FillByKeyWord(Params, prm_Post,     v_Post);
  L_OLE.FillByKeyWord(Params, prm_Sort,     v_Sort);
  L_OLE.FillByKeyWord(Params, prm_Contract, v_Contract);
  L_OLE.FillByKeyWord(Params, prm_Officer,  v_Officer);
  L_OLE.FillByKeyWord(Params, prm_ContDTyp, v_ContDTyp);
 END {FillParams};

(* ======================== 㬬   ᫥/㤥ঠ*)

 PRIVATE PROCEDURE CollectSum(VAR _Sum: NUMERIC[2]);
 BEGIN
  FOR_EACH Mn001 DO
   IF L_OLE.Check(Mn001.Sort,     v_Sort) &
      L_OLE.Check(Mn001.Contract, v_Contract) &
      L_OLE.Check(Mn001.ContDTyp, v_ContDTyp) &
      L_OLE.Check(Mn001.Officer,  v_Officer) &
      L_OLE.Check(Mn001.Post,     v_Post) THEN
    INC(_Sum, Mn001.Sum);
   END;
  END; (* FOR_EACH Mn001 *)
 END {CollectSum};

 PRIVATE PROCEDURE T0003_GetSum(Heap: STRING[]): NUMERIC[2];
  VAR
   _Sum: NUMERIC[2];
   curv_Union,
   curv_MCode: L_OLE.tKeyValue;
 BEGIN
  FillParams(Heap);
  _Sum:=0;
  IF L_OLE.HasCondition(v_Union) THEN
   FOR_EACH curv_MCode IN v_MCode DO
    FOR_EACH curv_Union IN v_Union DO
     SETSEL(Mn001, MCode, curv_MCode, curv_Union);
     CollectSum(_Sum);
    END; (* FOR_EACH curv_Union *)
   END; (* FOR_EACH curv_MCode *)
  ELSE
   FOR_EACH curv_MCode IN v_MCode DO
    SETSEL(Mn001, MCode, curv_MCode);
    CollectSum(_Sum);
   END; (* FOR_EACH curv_MCode *)
  END;
  RETURN _Sum;
 END {T0003_GetSum};

(* ======================== 㬬  宦  *)

 PRIVATE PROCEDURE CollectFOTSum(VAR _Sum: NUMERIC[2]; Key: L_OLE.tKeyValue[]; Index: STRING[]): SCAL[2];
  VAR
   curKey: L_OLE.tKeyValue;
 BEGIN
  IF L_OLE.HasCondition(Key) THEN
   FOR_EACH curKey IN Key DO
    SETSEL(Mn001, ^Index, curKey);
    FOR_EACH Mn001 DO
     IF L_OLE.Check(Mn001.Sort,     v_Sort) &
        L_OLE.Check(Mn001.Contract, v_Contract) &
        L_OLE.Check(Mn001.ContDTyp, v_ContDTyp) &
        L_OLE.Check(Mn001.Post,     v_Post) &
        L_OLE.Check(Mn001.FOT,      v_FOT) &
        L_OLE.Check(Mn001.Officer,  v_Officer) &
        L_OLE.Check(Mn001.Union,    v_Union) THEN
      INC(_Sum, Mn001.Sum);
     END;
    END; (* FOR_EACH Mn001 *)
   END; (* FOR_EACH curKey *)
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {CollectFOTSum};

 PRIVATE PROCEDURE T0003_GetFOTSum(Heap: STRING[]): NUMERIC[2];
  VAR
   _Sum  : NUMERIC[2];
 BEGIN
  FillParams(Heap);
  _Sum:=0;
  IF L_OLE.HasCondition(v_FOT) THEN
   IF ~CollectFOTSum(_Sum, v_Post,  "Post") &
      ~CollectFOTSum(_Sum, v_Sort,  "Officer") &
      ~CollectFOTSum(_Sum, v_Union, "Union") THEN
    SETSEL(Mn001, MCode);
    FOR_EACH Mn001 DO
     IF L_OLE.Check(Mn001.FOT, v_FOT) THEN
      IF L_OLE.Check(Mn001.Contract, v_Contract) &
         L_OLE.Check(Mn001.ContDTyp, v_ContDTyp) &
         L_OLE.Check(Mn001.Officer,  v_Officer) THEN
       INC(_Sum, Mn001.Sum);
      END;
     ELSE
      CHANGESEL(Mn001, MCode, , Mn001.MCode);
      LAST(Mn001);
      CHANGESEL(Mn001, MCode);
     END;
    END; (* FOR_EACH Mn001 *)
   END;
  END;
  RETURN _Sum;
 END {T0003_GetFOTSum};

(* ======================== ᫥   *)

 PRIVATE PROCEDURE CollectCount(VAR _Sum: NUMERIC[2]; Key: L_OLE.tKeyValue[]; Index: STRING[]): SCAL[2];
  VAR
   curKey: L_OLE.tKeyValue;
 BEGIN
  IF L_OLE.HasCondition(Key) THEN
   FOR_EACH curKey IN Key DO
    SELECT(SL001, ^Index, , curKey);
    WHILE OCCURE(SL001) DO
     IF L_OLE.Check(SL001.Post,    v_Post) &
        L_OLE.Check(SL001.Union,   v_Union) &
        L_OLE.Check(SL001.Sort,    v_Sort) &
        L_OLE.Check(SL001.Officer, v_Officer) THEN
      CHANGESEL(SL001, Officer, , SL001.Sort, SL001.Officer);
      WHILE OCCURE(SL001) DO
       CONFORM(SL001, Staff);
       HISTCONF(SL001.ODate, Staff, StaffLog);
       IF L_OLE.Check(Staff.Contract,    v_Contract) &
          L_OLE.Check(StaffLog.ContDTyp, v_ContDTyp) THEN
        INC(_Sum, SL001._InState);
       END;
       NEXT(SL001);
      END; (* WHILE OCCURE(SL001) ... *)
      LAST(SL001);
     END;
     CHANGESEL(SL001, ^Index, , curKey);
     NEXT(SL001);
    END; (* WHILE OCCURE(SL001) ... *)
   END; (* FOR_EACH curKey *)
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {CollectCount};

 PRIVATE PROCEDURE T0003_GetCount(Heap: STRING[]): NUMERIC[0];
  VAR
   _Sum: NUMERIC[2];
 BEGIN
  FillParams(Heap);
  _Sum:=0;
  IF ~CollectCount(_Sum, v_Post,  "Post") &
     ~CollectCount(_Sum, v_Sort,  "Officer") &
     ~CollectCount(_Sum, v_Union, "Union") THEN
   SETSEL(SL001, TSN);
   FOR_EACH SL001 DO
    PROMPT(SL001.TSN);
    CONFORM(SL001, Staff);
    HISTCONF(SL001.ODate, Staff, StaffLog);
    IF L_OLE.Check(Staff.Contract,    v_Contract) &
       L_OLE.Check(StaffLog.ContDTyp, v_ContDTyp) &
       L_OLE.Check(SL001.Officer,     v_Officer) THEN
     INC(_Sum, SL001._InState);
    END;
   END; (* FOR_EACH SL001 *)
  END;
  RETURN _Sum;
 END {T0003_GetCount};

(* ======================== ।ᯨ筠 ᫥*)

 PRIVATE PROCEDURE CollectDays(): D_Slr.tAvgCount;
  VAR
   curDaysNotFullDuty,
   curDaysInFirm: D_Slr.tAvgCount;
 BEGIN
  D_Slr.GetFromSh001(curDaysInFirm, curDaysNotFullDuty, EMPTYOF(PROC));
  RETURN curDaysInFirm-curDaysNotFullDuty;
 END {CollectDays};

 PRIVATE PROCEDURE CollectAvgCount(VAR _Sum: NUMERIC[3]; Key: L_OLE.tKeyValue[]; Index: STRING[]): SCAL[2];
  VAR
   curKey: L_OLE.tKeyValue;
 BEGIN
  IF L_OLE.HasCondition(Key) THEN
   FOR_EACH curKey IN Key DO
    SELECT(SL001, ^Index, , curKey);
    WHILE OCCURE(SL001) DO
     IF L_OLE.Check(SL001.Post,     v_Post) &
        L_OLE.Check(SL001.Union,    v_Union) &
        L_OLE.Check(SL001.Sort,     v_Sort) &
        L_OLE.Check(SL001.Officer,  v_Officer) THEN
      CHANGESEL(SL001, Officer, , SL001.Sort, SL001.Officer);
      WHILE OCCURE(SL001) DO
       CONFORM(SL001, Staff);
       HISTCONF(SL001.ODate, Staff, StaffLog);
       IF L_OLE.Check(Staff.Contract,    v_Contract) &
          L_OLE.Check(StaffLog.ContDTyp, v_ContDTyp) THEN
        INC(_Sum, CollectDays());
       END;
       NEXT(SL001);
      END; (* WHILE OCCURE(SL001) ... *)
      LAST(SL001);
     END;
     CHANGESEL(SL001, ^Index, , curKey);
     NEXT(SL001);
    END; (* WHILE OCCURE(SL001) ... *)
   END; (* FOR_EACH curKey *)
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {CollectAvgCount};

 PRIVATE PROCEDURE T0003_GetAvgCount(Heap: STRING[]): NUMERIC[3];
  VAR
   _Sum: NUMERIC[3];
 BEGIN
  FillParams(Heap);
  _Sum:=0;
  IF ~CollectAvgCount(_Sum, v_Post,  "Post") &
     ~CollectAvgCount(_Sum, v_Sort,  "Officer") &
     ~CollectAvgCount(_Sum, v_Union, "Union") THEN
   SETSEL(SL001, TSN);
   FOR_EACH SL001 DO
    PROMPT(SL001.TSN);
    CONFORM(SL001, Staff);
    HISTCONF(SL001.ODate, Staff, StaffLog);
    IF L_OLE.Check(Staff.Contract,    v_Contract) &
       L_OLE.Check(StaffLog.ContDTyp, v_ContDTyp) &
       L_OLE.Check(SL001.Officer,     v_Officer) THEN
     INC(_Sum, CollectDays());
    END;
   END; (* FOR_EACH SL001 *)
  END;
  RETURN _Sum/(IntvlE-IntvlB+1);
 END {T0003_GetAvgCount};

 PRIVATE PROCEDURE CollectTime(VAR _Tim  : NUMERIC[3];
                                   Key   : L_OLE.tKeyValue[];
                                   Field,
                                   Index : STRING[]): SCAL[2];
  VAR
   curKey: L_OLE.tKeyValue;
 BEGIN
  IF L_OLE.HasCondition(Key) THEN
   FOR_EACH curKey IN Key DO
    SETSEL(SL001, ^Index, curKey);
    FOR_EACH SL001 DO
     CONFORM(SL001, Staff);
     HISTCONF(SL001.ODate, Staff, StaffLog);
     IF L_OLE.Check(Staff.Contract,    v_Contract) &
        L_OLE.Check(StaffLog.ContDTyp, v_ContDTyp) &
        L_OLE.Check(SL001.Post,        v_Post) &
        L_OLE.Check(SL001.Union,       v_Union) &
        L_OLE.Check(SL001.Sort,        v_Sort) &
        L_OLE.Check(SL001.Officer,     v_Officer) THEN
      INC(_Tim, ^("SL001."+Field));
     END;
    END; (* FOR_EACH SL001 *)
   END; (* FOR_EACH curKey *)
   RETURN 1;
  ELSE
   RETURN 0;
  END;
 END {CollectTime};

 PRIVATE PROCEDURE T0003_GetTimDone(Heap: STRING[]): NUMERIC[3];
  VAR
   _Tim: NUMERIC[3];
 BEGIN
  FillParams(Heap);
  _Tim:=0;
  IF ~CollectTime(_Tim, v_Post,  "TimDone", "Post") &
     ~CollectTime(_Tim, v_Sort,  "TimDone", "Officer") &
     ~CollectTime(_Tim, v_Union, "TimDone", "Union") THEN
   SETSEL(SL001, TSN);
   FOR_EACH SL001 DO
    PROMPT(SL001.TSN);
    CONFORM(SL001, Staff);
    HISTCONF(SL001.ODate, Staff, StaffLog);
    IF L_OLE.Check(Staff.Contract,    v_Contract) &
       L_OLE.Check(StaffLog.ContDTyp, v_ContDTyp) &
       L_OLE.Check(SL001.Officer,     v_Officer) THEN
     INC(_Tim, SL001.TimDone);
    END;
   END; (* FOR_EACH SL001 *)
  END;
  RETURN _Tim;
 END {T0003_GetTimDone};

 PRIVATE PROCEDURE Init(_IntvlB, _IntvlE: DATE; Rebuild: SCAL[2]);
 BEGIN
  IntvlB:=_IntvlB;
  IntvlE:=_IntvlE;
  L_OLE.SetUsedBasisList("Mn001|SL001|Sh001|");
  IF _IntvlB >= 01\07\2012 THEN
   D_Slr.extPrepare_Mn001(IntvlB, IntvlE, 0, Rebuild, 1, 0);
  ELSE
   D_Slr.extPrepare_Mn001(IntvlB, IntvlE, 0, Rebuild, 1, 1);
  END;
  D_Slr._Prepare_SL001(IntvlB, IntvlE,    Rebuild, 1);
 END {Init};

 PRIVATE PROCEDURE oleInit(_IntvlB, _IntvlE: DATE);
 BEGIN
  Init(_IntvlB, _IntvlE, 0);
 END {oleInit};

 PRIVATE PROCEDURE oleInit_wRebuild(_IntvlB, _IntvlE: DATE);
 BEGIN
  Init(_IntvlB, _IntvlE, 1);
 END {oleInit};

 PRIVATE PROCEDURE oleDeInit();
 BEGIN
  L_OLE.DeInit();
 END {oleDeInit};

BEGIN
 RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
END.
