(*
%Copyright   (c) Polak Computer System
%Author      08.05.1997 08:38:36 POLAK
%Purpose     ஫ 䨪樨 Math
%Type        control
%Specific    SYS
%Modified    22.09.2014 18:54:43 POLAK\San
%Environment
*)

 IMPORT L_General, L_DatTim, L_Events, L_Prop, L_BarCode, L_SysLog, L_MathR,
        L_AFM, L_Car, L_StdFrm, L_XDoc, L_MDoc, L_Pmnt, L_Way, L_XObj, L_Str, L_CI,
        L_OwnData, L_APtm, L_DBD, L_WDO, Memo, P_Firm, P_Mark, P_Math, Shell,
        Math, Str, E_Stock, L_Env, L_Basis, FIO, L_Acnt, L_Stock, P_Man,
        L_AR, L_CUC, L_AcsPnt, L_r2r;

 PRIVATE CONST
  acspnt_ChangeCarUnit = 0000062;

 PRIVATE PROCEDURE CheckMDocDone();
  VAR
   minPer,
   MDocP: DATE;
 BEGIN
  SETEMPTY(minPer);
  SELECT(MDocList, Math, , Math.Math);
  WHILE OCCURE(MDocList) & !minPer DO
   PROMPT("஢ઠ 㬥⮢ "+L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc));
   CONFORM(MDocList, MDoc);
   IF MDoc.Done & (MDoc.Status = L_MDoc.st_Passed) THEN
    TRY
     Memo.gl_SetCurDate(MDoc.Date);
     L_MathR.CheckMDocProceedAllowed(Math.MathKind);
     minPer:=L_DatTim.Per(MDoc.Date);
    EXCEPT
    ON Exc: Exc_Raise DO
     IF Exc.ErrorCode # -1 THEN
      RAISE();
     END;
    END;
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  L_General.Assert(!minPer, "室 ।⥫쭮 ⪠ 㬥  ⮬ ꥪ|"+
                            "稭  "+L_DatTim.PeriodStr(minPer));
  PROMPT("஢ઠ 楢 ");
  L_MathR.CheckMathDone(SYSDATE());
 END {CheckMDocDone};

 CONST
  lengthMath = Str.Length(FLDTOSTR(MAXOF(Math.Math), "L", 0, "L"));
 VAR
  FreeMathList: STRING[];
  minMathKeyAs,
  maxMathKeyAs: NUMERIC[0];

 PRIVATE PROCEDURE PutItemToFreeMathList(begMath, endMath: NUMERIC[0]; mk: LIKE(Math.MathKind));
  VAR
   Item    : STRING[];
   Continue: SCAL[2];
 BEGIN
  IF endMath >= begMath THEN
   IF mk = L_MathR.mathk_Math  THEN
    Continue:= !minMathKeyAs | (begMath >= maxMathKeyAs) | (endMath <= minMathKeyAs);
    IF ~Continue THEN
     IF (begMath < minMathKeyAs) & (endMath < maxMathKeyAs) THEN
      endMath:=minMathKeyAs - 1;
      Continue:=endMath >= begMath;
     END;
     IF (begMath <= maxMathKeyAs) & (endMath > maxMathKeyAs) THEN
      begMath:=maxMathKeyAs + 1;
      Continue:=endMath >= begMath;
     END;
     IF (begMath < minMathKeyAs) & (endMath > maxMathKeyAs) THEN
      PutItemToFreeMathList(begMath, minMathKeyAs - 1);
      PutItemToFreeMathList(maxMathKeyAs + 1, endMath);
      Continue:=0;
     END;
    END;
    IF Continue THEN
     IF (endMath - begMath) = 0 THEN
      Item:=FLDTOSTR(begMath, "L", lengthMath) + "  " + FLDTOSTR(begMath, "L", lengthMath) + "  " + L_Str.Repeat(" ", lengthMath)      + "  ";
     ELSIF (endMath - begMath) = 1 THEN
      Item:=FLDTOSTR(begMath, "L", lengthMath) + "  " + FLDTOSTR(begMath, "L", lengthMath) + ", " + FLDTOSTR(endMath, "L", lengthMath) + "  ";
     ELSE
      Item:=FLDTOSTR(begMath, "L", lengthMath) + "  " + FLDTOSTR(begMath, "L", lengthMath) + ".." + FLDTOSTR(endMath, "L", lengthMath) + "  " + FLDTOSTR(endMath - begMath + 1, "", lengthMath);
     END;
     FreeMathList:=FreeMathList + "|" + Item;
    END;
   END;
  END; (* IF endMath >= begMath ... *)
 END {PutItemToFreeMathList};

 PRIVATE PROCEDURE Math_Math_OnBeforeAsk();
  VAR
   firstMath,
   prevMath,
   Idx       : NUMERIC[0];
   mk        : LIKE(Math.MathKind);
   curMaxMath: NUMERIC[0];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  mk:=Math.MathKind;
  minMathKeyAs:=50000;
  maxMathKeyAs:=MAXOF(Math.Math);
  IF L_General.IsPolakSpecific() THEN
   minMathKeyAs:=MAXOF(Math.Math);
  END;
  firstMath:=1;
  SETEMPTY(FreeMathList);
  SAVE(Math);
  IF SELECT(Math, Math) & ~!Math.Math THEN
   PutItemToFreeMathList(firstMath, Math.Math-1, mk);
   LOOP
    PROMPT(Math.Math);
    prevMath:=Math.Math;
    IF Math.Math >= minMathKeyAs THEN
     EXIT;
    ELSIF NEXT(Math) & ~!Math.Math THEN
     PutItemToFreeMathList(prevMath+1, Math.Math-1, mk);
    ELSE
     EXIT;
    END;
   END; (* LOOP *)
   PutItemToFreeMathList(prevMath+1, minMathKeyAs, mk);
  ELSE
   PutItemToFreeMathList(firstMath,  minMathKeyAs, mk);
  END;
  RESTORE(Math);
  Idx:=L_StdFrm.ShowListAsMenu_wCaption(FreeMathList, " ", L_Str.Repeat(" ", lengthMath) + "  " + Str.Align("", lengthMath*2 + 2, LEFT) + "  " +  Str.Align("", lengthMath, RIGHT) +
                                                                           "|" +
                                                                          L_Str.Repeat("", lengthMath) + "" + L_Str.Repeat("", lengthMath*2 + 2)           + "" +  L_Str.Repeat("", lengthMath));
  L_General.Assert(ACCESS(Math), " " + L_Str.PoolItem("। ⥪騩 |। ⥪饥 ", Math.MathKind));
  SE_INTEGRITY(1);
  Math.Math:=Str.Slice(L_Str.PoolItem(FreeMathList, Idx), 0, lengthMath);
  REPLACE(Math);
 END {Math_Math_OnBeforeAsk};

 PRIVATE PROCEDURE Math_MathType_intSingleOnSuccessfulChange(prvValue: LIKE(Math.MathType));
 BEGIN
  IF ~!Math.Math THEN
   L_Stock.mItem_CheckAllIsZero(Math.Math, EMPTYOF(Storage.Storage), 0);
   CheckMDocDone();
  END;
 END {Math_MathType_intSingleOnSuccessfulChange};

 PRIVATE PROCEDURE Math_Replicate2Children(newMathType: LIKE(Math.MathType); oldCarUnit, newCarUnit: LIKE(Math.CarUnit));
  VAR
   prvMathType: LIKE(Math.MathType);
   prvCarUnit : LIKE(Math.CarUnit);
 BEGIN
  IF ~!Math.Math & (~!newMathType | ~!newCarUnit) THEN
   SAVE(Math);
   SELECT(Math, Parent, , Math.Math);
   WHILE OCCURE(Math) DO
    PROMPT(": " + Math.Math);
    IF ~!newMathType & (Math.MathType # newMathType) THEN
     prvMathType:=Math.MathType;
     Math.MathType:=newMathType;
     REPLACE(Math);
     Math_MathType_intSingleOnSuccessfulChange(prvMathType);
     SAVE(Math);
     Math_Replicate2Children(newMathType, oldCarUnit, newCarUnit);
     RESTORE(Math);
    END;
    IF ~!newCarUnit & (Math.CarUnit # newCarUnit) & (Math.CarUnit = oldCarUnit) THEN
     prvCarUnit:=Math.CarUnit;
     Math.CarUnit:=newCarUnit;
     REPLACE(Math);
     Math_CarUnit_intSingleOnSuccessfulChange(prvCarUnit);
     SAVE(Math);
     Math_Replicate2Children(newMathType, oldCarUnit, newCarUnit);
     RESTORE(Math);
    END;
    NEXT(Math);
   END; (* WHILE OCCURE(Math) ... *)
   RESTORE(Math);
  END;
 END {Math_Replicate2Children};

 PRIVATE PROCEDURE Math_MathType_intOnSuccessfulChange(prvValue: LIKE(Math.MathType));
 BEGIN
  Math_MathType_intSingleOnSuccessfulChange(prvValue);
  Math_Replicate2Children(Math.MathType, EMPTYOF(Math.CarUnit), EMPTYOF(Math.CarUnit));
 END {Math_MathType_intOnSuccessfulChange};

 PRIVATE PROCEDURE Math_MathType_OnSuccessfulChange();
 BEGIN
  Math_MathType_intOnSuccessfulChange(GE_PVALUE());
 END {Math_MathType_OnSuccessfulChange};

 PRIVATE PROCEDURE Math_CarUnit_intSingleOnSuccessfulChange(prvValue: LIKE(Math.CarUnit));
 BEGIN
  (* nothing *)
 END {Math_CarUnit_intSingleOnSuccessfulChange};

 PRIVATE PROCEDURE Math_CarUnit_intOnSuccessfulChange(prvValue: LIKE(Math.CarUnit));
 BEGIN
  Math_CarUnit_intSingleOnSuccessfulChange(prvValue);
  Math_Replicate2Children(EMPTYOF(Math.MathType), prvValue, Math.CarUnit);
 END {Math_CarUnit_intOnSuccessfulChange};

 PRIVATE PROCEDURE Math_CarUnit_OnSuccessfulChange();
  VAR
   prnCarUnit: LIKE(Math.CarUnit);
 BEGIN
  SAVE(Math);
  IF SEARCH(Math, Math, Math.Parent) THEN
   prnCarUnit:=Math.CarUnit;
  ELSE
   SETEMPTY(prnCarUnit);
  END;
  RESTORE(Math);
  IF ~!prnCarUnit & (GE_PVALUE() = prnCarUnit) THEN
   L_AcsPnt.PassAccessPoint(acspnt_ChangeCarUnit);
  END;
  Math_CarUnit_intOnSuccessfulChange(GE_PVALUE());
 END {Math_CarUnit_OnSuccessfulChange};

 PRIVATE PROCEDURE Math_Name_OnSuccessfulChange();
  VAR
   curMath: LIKE(Math.Math);
 BEGIN
  IF Math.Leaf THEN
   curMath:=Math.Math;
   SAVE(Math);
   CHANGESEL(Math, MKindNam, , Math.MathKind, Math.Name);
   FIRST(Math);
   LOOP
    IF ~OCCURE(Math) THEN
     EXIT;
    ELSIF (Math.Leaf) & (Math.Math # curMath) THEN
     L_StdFrm.ConditionalCHOICE("  ꥪ  ⠪ ", Math.MathKind = L_MathR.mathk_KeyAs);
     EXIT;
    END;
    NEXT(Math);
   END; (* LOOP *)
   RESTORE(Math);
  END;
 END {Math_Name_OnSuccessfulChange};

 PRIVATE PROCEDURE Math_UnitedC_OnSuccessfulChange();
 BEGIN
  (*KeyAss*)
  SAVE(Math);
  L_General.Assert(SELECT(Math, MKindUnC, Math.MathKind, Math.UnitedC) & ~NEXT(Math),
                   "  ꥪ  ⠪ 祭");
  RESTORE(Math);
 END {Math_UnitedC_OnSuccessfulChange};

 PRIVATE PROCEDURE Math_Begin_OnSuccessfulChange();
  VAR
   srcMath : LIKE(Math.Math);
   srcRI   : LIKE(Math.RECORDID);
   srcMathB: DATE;
 BEGIN
  srcMath:=L_WDO.GetInsertionSource();
  IF    ~!srcMath THEN
   IF ~!GE_PVALUE() THEN
    L_StdFrm.Choice(" ᢮⢠  宦  㯯 த " +
                    "| 㤠  ⠢ , 㠫  " + L_DatTim.DateStr(Math.Begin));
    SELECT(MathKAGL, Math, , Math.Math);
    REMSEL(MathKAGL);
    SELECT(MathPro, Math, , Math.Math);
    WHILE OCCURE(MathPro) DO
     L_Prop.RemoveCurrentPro("MathPro");
    END; (* WHILE OCCURE(MathPro) ... *)
   END;
   SAVE(Math);
   SEARCH(Math, Math, , srcMath);
   srcRI   :=Math.RECORDID;
   srcMathB:=Math.Begin;
   RESTORE(Math);
   L_Prop.CopyProRecords("Math", srcRI, Math.RECORDID);
   SELECT(MathKAGL, Math, , srcMath);
   IF ~SRCINSEL(MathKAGL, LE, Math.Begin) THEN
    FIRST(MathKAGL);
   END;
   WHILE OCCURE(MathKAGL) DO
    TRY [RESTORE_CURSORS(RC_ON)]
     IF MathKAGL.DateE >= Math.Begin THEN
      MathKAGL.Math:=Math.Math;
      IF (MathKAGL.Date < Math.Begin) | (MathKAGL.Date = srcMathB) THEN
       MathKAGL.Date:=Math.Begin;
      END;
      INSERT(MathKAGL);
     END;
    EXCEPT
    END; (* TRY *)
    NEXT(MathKAGL);
   END; (* WHILE OCCURE(MathKAGL) .. *)
  ELSIF ~!GE_PVALUE() THEN
   L_Prop.AnyProBeginChange("Math", GE_PVALUE());
  END;
 END {Math_Begin_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckMUnitUse(trgMath: LIKE(Math.Math); trgNumber: LIKE(MathUnit.Number); prvMUnit: LIKE(MUnit.MUnit));
  VAR
   Checked     : SCAL[2];
   prvMUnitSign: STRING[];
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Edit THEN
   prvMUnitSign:="'"+L_MathR.MUnitSign(prvMUnit)+"'";
   APP.Get().NewPrompt("஢ઠ ᯮ짮  "+prvMUnitSign);
   Checked:=0;
   SELECT(MDocList, Math, , trgMath);
   WHILE OCCURE(MDocList) & ~Checked DO
    PROMPT(L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc));
    IF (MDocList.MUNbr = trgNumber) THEN
     CONFORM(MDocList, MDoc);
     L_General.Assert_wReferToAdmin(~MDoc.Done | (MDoc.Status # L_MDoc.st_Passed),
                                    "  ࠡ⠭ ஢ |"+
                                    "  "+trgMath+"  楩 ७ "+prvMUnit+" "+prvMUnitSign);
     Checked:=1;
    END;
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
  END;
 END {CheckMUnitUse};

 PRIVATE PROCEDURE Math_MUnit_OnSuccessfulChange();
 BEGIN
  CheckMUnitUse(Math.Math, 000, GE_PVALUE(Math.MUnit));
 END {Math_MUnit_OnSuccessfulChange};

 PRIVATE PROCEDURE MathE_SetupFormFields();
  VAR
   prnMathType : LIKE(Math.MathType);
   curZone     : FORM_ZONE;
 BEGIN
  IF Math.MathKind # L_MathR.mathk_KeyAs THEN
   IF !Math.Parent THEN
    SETEMPTY(prnMathType);
   ELSE
    SAVE(Math);
    SEARCH(Math, Math, , Math.Parent);
    prnMathType:=Math.MathType;
    RESTORE(Math);
   END;
   curZone:=RTI.Get().CurZone;
   curZone.Fields("Math.MathType").Modifiable   :=!prnMathType;
   curZone.Fields("Math.CarUnit").Modifiable    :=1;
   curZone.Fields("Math.CarUnit").MustBeNonempty:=Math.Leaf;
   curZone.Fields("v_ParentName").Value         :=L_DBD.BuildHierarchyString("Math", 106, 3);
  END;
 END {MathE_SetupFormFields};

 PRIVATE PROCEDURE Math_Parent_OnSuccessfulChange();
  VAR
   prvMathType,
   prnMathType : LIKE(Math.MathType);
   prvCarUnit,
   prnCarUnit  : LIKE(Math.CarUnit);
 BEGIN
  IF !Math.Parent THEN
   SETEMPTY(prnMathType, prnCarUnit);
  ELSE
   SAVE(Math);
   SEARCH(Math, Math, , Math.Parent);
   prnMathType:=Math.MathType;
   prnCarUnit :=Math.CarUnit;
   RESTORE(Math);
   IF ~!prnMathType & (Math.MathType # prnMathType) THEN
    prvMathType:=Math.MathType;
    Math.MathType:=prnMathType;
    REPLACE(Math);
    Math_MathType_intOnSuccessfulChange(prvMathType);
   END;
   IF ~!prnCarUnit & (Math.CarUnit # prnCarUnit) THEN
    prvCarUnit:=Math.CarUnit;
    IF ~!prvCarUnit THEN
     IF L_AcsPnt.MayPassAccessPoint(acspnt_ChangeCarUnit) THEN
      IF ~L_StdFrm.Alternative("   祭  'ॣ'  ᫥⢨  㯯஢筮 ?") THEN
       L_AcsPnt.PassAccessPoint(acspnt_ChangeCarUnit);
       prvCarUnit:=prnCarUnit;
      END;
     ELSE
      L_StdFrm.Question("᫥⢨  㯯஢筮   祭  'ॣ'");
     END;
    END;
    IF prvCarUnit # prnCarUnit THEN
     Math.CarUnit:=prnCarUnit;
     REPLACE(Math);
     Math_CarUnit_intOnSuccessfulChange(prvCarUnit);
    END;
   END;
  END;
  MathE_SetupFormFields();
 END {Math_Parent_OnSuccessfulChange};

 PRIVATE PROCEDURE ReplicateToMathUnit();
 BEGIN
  IF ~!Math.MUnit THEN
   IF ~SEARCH(MathUnit, Math, Math.Math, 0) THEN
    DEFAULT(MathUnit);
    MathUnit.Math  :=Math.Math;
    MathUnit.Number:=0;
    MathUnit.Ratio :=1;
    INSERT(MathUnit);
   END;
 
   CONFORM(Math, MUnit);
   MathUnit.MUnit:=MUnit.MUnit;
   MathUnit.Name :=MUnit.Name;
   MathUnit.Sign :=MUnit.Sign;
   REPLACE(MathUnit);
  END;
 END {ReplicateToMathUnit};

 PRIVATE PROCEDURE MathUnit_1_OnZoneOpen();
 BEGIN
  IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Ask THEN
   RTI.Get().CurZone.PermanentFilter:="";
  ELSE
   RTI.Get().CurZone.PermanentFilter:="MathUnit.Number#000";
  END;
 END {MathUnit_1_OnZoneOpen};

 PRIVATE PROCEDURE MathUnit_OnBeforeDelete();
 BEGIN
  SELECT(MDocList, Math, , MathUnit.Math);
  WHILE OCCURE(MDocList) DO
   PROMPT("஢ઠ ⮢ 㬥⮢ " + L_MDoc.MDocStr(MDocList.MDocKind, MDocList.MDoc));
   L_General.Assert(MDocList.MUNbr # MathUnit.Number,
                    " ७ ᯮ  ⮢ 㬥." +
                    "|| 饭.");
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
 END {MathUnit_OnBeforeDelete};

 PRIVATE PROCEDURE MathUnit_MUnit_OnSuccessfulChange();
 BEGIN
  IF ~!MathUnit.MUnit THEN
   IF ~!GE_PVALUE(MathUnit.MUnit) THEN
    CheckMUnitUse(MathUnit.Math, MathUnit.Number, GE_PVALUE(MathUnit.MUnit));
    IF SEARCH(MUnit, MUnit, GE_PVALUE(MathUnit.MUnit)) &
       (MathUnit.Name = MUnit.Name) &
       (MathUnit.Sign = MUnit.Sign) THEN
      SETEMPTY(MathUnit.Name, MathUnit.Sign);
    END;
   END;
   IF SEARCH(MUnit, MUnit, MathUnit.MUnit) &
      !MathUnit.Name &
      !MathUnit.Sign THEN
    MathUnit.Name:=MUnit.Name;
    MathUnit.Sign:=MUnit.Sign;
   ELSE
    L_StdFrm.Inform("  祭 ⠢  ");
   END;
   REPLACE(MathUnit);
  END;
 END {MathUnit_MUnit_OnSuccessfulChange};

 PRIVATE PROCEDURE MathUnit_OnAfterEdit();
 BEGIN
  (* 맮 L_PCS.SysLogHandler  L_Events*)
 END {MathUnit_OnAfterEdit};

 PRIVATE PROCEDURE MathUnit_OnAfterInsert();
 BEGIN
  (* 맮 L_PCS.SysLogHandler  L_Events*)
 END {MathUnit_OnAfterInsert};

 PRIVATE PROCEDURE SupportBegEndDate();
  VAR
   curDateE: LIKE(MathKAGL.DateE);
 BEGIN
  SAVE(MathKAGL);
  ACCESS(Math);
  curDateE:=L_DatTim.till2ED(Math.Till);
  SETSEL(MathKAGL, Math, Math.Math);
  IF LAST(MathKAGL) THEN
   REPEAT
    MathKAGL.DateE:=curDateE;
    REPLACE(MathKAGL);
    curDateE:=MathKAGL.Date-1;
   UNTIL ~PREV(MathKAGL);
  END;
  RESTORE(MathKAGL);
 END {SupportBegEndDate};

 PRIVATE PROCEDURE CheckMathKAGL();
  VAR
   APrDate: DATE;
 BEGIN
  APrDate:=L_MathR.GetKeyAssAPrDate(Math.Math);
  IF ~!APrDate THEN
   L_MathR.PosToKAG(Math.Math, APrDate);
  END;
 END {CheckMathKAGL};

 PRIVATE PROCEDURE Math_OnBeforeAnyModification();
 BEGIN
  IF ~Math.Leaf THEN
   L_AcsPnt.PassAccessPoint(0000046);
  END;
  L_AR.GrantRightsForInteractiveModification();
 END {Math_OnBeforeAnyModification};

 PRIVATE PROCEDURE Math_Math_SetOnBeforeAsk(OnBeforeAsk: SCAL[2]);
 BEGIN
  RTI.Get().CurWindow.Zones(0).Fields("Math.Math").AskMode:=WFD_ASK_SYSTEM;
  RTI.Get().CurWindow.Zones(0).Fields("Math.Math").OnBeforeAsk:=OnBeforeAsk;
 END {Math_Math_SetOnBeforeAsk};

 PRIVATE PROCEDURE Math_OnBeforeEdit();
 BEGIN
  Math_OnBeforeAnyModification();
  Math_Math_SetOnBeforeAsk(0);
 END {Math_OnBeforeEdit};

 PRIVATE PROCEDURE Math_OnBeforeInsertDelete();
 BEGIN
  IF RTI.Get().CurWindow.ParentZone.MasterCursor.TABLE.Name # "Math" THEN
   L_General.Error(" ⮬ ० ᬮ ᯨ᪠  ⠢  㤠 饭");
  END;
 END {Math_OnBeforeInsertDelete};

 PRIVATE PROCEDURE Math_OnBeforeInsert();
  VAR
   srcMath,
   trgMath  : LIKE(Math.Math);
   trgParent: LIKE(Math.Parent);
 BEGIN
  Math_Math_SetOnBeforeAsk(RTI.Get().CurWindow.OriginalName # "Math01E");
  Math.Leaf:=~L_WDO.InHierarchyInsMode();
  REPLACE(Math);
  Math_OnBeforeAnyModification();
  Math_OnBeforeInsertDelete();
  IF RTI.Get().CurWindow.OriginalName = "Math01E" THEN
   SETEMPTY(trgMath);
   SAVE(Math);
   SETSEL(Math, MathKind, L_MathR.mathk_KeyAs);
   IF SRCINSEL(Math, LE, MAXOF(Math.Math)) (*  SRCINSEL.  ० ⠢ # LAST *) THEN
    trgMath:=Math.Math + 1;
   ELSE
    SETSEL(Math, Math);
    IF SRCINSEL(Math, LE, MAXOF(Math.Math)) & (Math.Math<90000) THEN
     trgMath:=(Math.Math DIV 10000 +1)*10000;
    ELSE
     trgMath:=50001;
    END;
   END;
   WHILE SEARCH(Math, Math, trgMath) DO
    INC(trgMath);
   END;
   IF SELECT(Math, MKPL, L_MathR.mathk_KeyAs, 0) THEN
    trgParent:=Math.Math;
    L_General.CallUs(~NEXT(Math));
   ELSE
    SETEMPTY(trgParent);
   END;
   RESTORE(Math);

   srcMath:=L_WDO.GetInsertionSource();
   IF ~!srcMath THEN
    Math.Math    :=trgMath;
    REPLACE(Math);
    intMakeCopy(srcMath);
   ELSE
    Math.Math    :=trgMath;
    Math.MathKind:=L_MathR.mathk_KeyAs;
    L_General.Assert(SEARCH(MathType, MathType, L_MathR.mtyp_KeyAssets), "  "+L_Str.IntStr(L_MathR.mtyp_KeyAssets)+" (᭮ ।⢠)   ");
    Math.MathType:=L_MathR.mtyp_KeyAssets;
    Math.MyFirm  :=P_Firm.DefineMyFirm();
    L_General.Assert(SEARCH(Product, Product, 000), "  000  䨪 ");
    Math.Product :=000;
    L_General.Assert(SEARCH(MUnit, MUnit, 01), "  01   ७");
    Math.MUnit   :=01;
    L_General.Assert(SEARCH(CarUnit, CarUnit, 0000), "  0000  ॣ, ");
    Math.CarUnit :=0000;
    Math.UnitedC :=".";
    Math.Parent  :=trgParent;
    Math.Leaf    :=1;
    REPLACE(Math);
   END;
  ELSE
   IF ~Math.Leaf THEN
    SAVE(Math);
    IF SELECT(Math, Leaf, 0) & ~!Math.Math THEN
     trgMath:=Math.Math-1;
     IF PREV(Math) & (Math.Math = trgMath) THEN
      NEXT(Math);
      trgMath:=Math.Math+1;
      IF NEXT(Math) &  (Math.Math = trgMath) THEN
       SETEMPTY(trgMath);
      END;
     END;
    ELSE
     trgMath:=MAXOF(Math.Math);
    END;
    RESTORE(Math);
    Math.Math:=trgMath;
    REPLACE(Math);
   END; (* IF ~Math.Leaf *)
  END;
  IF ~!Math.Parent THEN
   Math_Parent_OnSuccessfulChange();
  END;
 END {Math_OnBeforeInsert};

 PRIVATE PROCEDURE SrcKeyAssCUCopy();
  VAR
   _CUCopy: SCAL[2];
 BEGIN
  SETEMPTY(_CUCopy);
  SELECT(CUCopy, Math, , Math.Math);
  WHILE OCCURE(CUCopy) DO
   IF CUCopy.Origin = L_CUC.o_KeyAss THEN
    L_General.CallUs(!_CUCopy);
    _CUCopy:=CUCopy.CUCopy;
   END;
   NEXT(CUCopy);
  END; (* WHILE OCCURE(CUCopy) ... *)
  L_General.CallUs(~!_CUCopy);
  SEARCH(CUCopy, CUCopy, , _CUCopy);
 END {SrcKeyAssCUCopy};

 PRIVATE PROCEDURE SetKeyAssCUCopy();
 BEGIN
  CUCopy.Math   :=Math.Math;
  CUCopy.MnfDate:=Math.Born;
  SETEMPTY(CUCopy.Serial,
           CUCopy.InitRun,
           CUCopy.Till,
           CUCopy.Storage);
  CUCopy.Origin :=L_CUC.o_KeyAss;
  CUCopy.Begin  :=Math.Begin;
  CUCopy.Comment:=Math.Name;
 END {SetKeyAssCUCopy};

 PRIVATE PROCEDURE SimpleReplicate(Src, Dst, ownFields: STRING[]);
  VAR
   tSrc,
   tDst : TABLE;
   fSrc : FIELD;
 BEGIN
  tSrc:=TABLE.Get(Src);
  tDst:=TABLE.Get(Dst);
  FOR_EACH fSrc IN tSrc.Fields DO
   IF (fSrc.Name # "RECORDID") & ~!tDst.Fields(fSrc.Name) & !L_Str.PositionInPool(ownFields, fSrc.Name) THEN
    ^(L_DBD.GetFieldName(tDst.Name, fSrc.Name)):=^(L_DBD.GetFieldName(tSrc.Name, fSrc.Name));
   END;
  END; (* FOR_EACH *)
  REPLACE(^Dst);
 END {SimpleReplicate};

 PRIVATE PROCEDURE sr_Math2MathMrkG();
 BEGIN
  SimpleReplicate("Math", "MathMrkG", "Math|MarkG");
 END {sr_Math2MathMrkG};

 PRIVATE PROCEDURE MathMarkG_RemoveParent();
  VAR
   curMarkG : LIKE(MathMrkG.MarkG);
   prvParent: LIKE(MathMrkG.Parent);
 BEGIN
  IF ~!MathMrkG.Parent THEN
   curMarkG :=MathMrkG.MarkG;
   prvParent:=MathMrkG.Parent;
   TRY
    SETEMPTY(MathMrkG.Parent);
    REPLACE(MathMrkG);
    SAVE(MathMrkG);
    IF ~SELECT(MathMrkG, Parent, curMarkG, prvParent) THEN
     L_General.CallUs(SEARCH(MathMrkG, MarkG, curMarkG, prvParent));
     MathMarkG_RemoveParent();
     REMOVE(MathMrkG);
    ELSE
     RESTORE(MathMrkG);
     L_General.RaiseLockReleaseException();
    END;
    RESTORE(MathMrkG);
   EXCEPT
   ON Exc: Exc_Root DO
    L_General.CheckIsLockReleaseException(Exc);
   END;
  END;
 END {MathMarkG_RemoveParent};

 PRIVATE PROCEDURE MathMarkG_ControlParent();
  VAR
   curMarkG : LIKE(MathMrkG.MarkG);
   curParent: LIKE(MathMrkG.Parent);
 BEGIN
  IF ~!MathMrkG.Parent THEN
   SAVE(MathMrkG);
   curMarkG :=MathMrkG.MarkG;
   curParent:=MathMrkG.Parent;
   IF ~SEARCH(MathMrkG, MarkG, curMarkG, curParent) THEN
    DEFAULT(MathMrkG);
    MathMrkG.MarkG:=curMarkG;
    MathMrkG.Math :=curParent;
    INSERT(MathMrkG);
    SAVE(Math);
    L_General.CallUs(SEARCH(Math, Math, curParent));
    sr_Math2MathMrkG();
    RESTORE(Math);
    MathMarkG_ControlParent();
   END;
   RESTORE(MathMrkG);
  END;
 END {MathMarkG_ControlParent};

 PRIVATE PROCEDURE ReplicateMath2SinleMathMrkG();
 BEGIN
  IF Math.Parent # MathMrkG.Parent THEN
   MathMarkG_RemoveParent();
  END;
  sr_Math2MathMrkG();
  MathMarkG_ControlParent();
 END {ReplicateMath2SinleMathMrkG};

 PRIVATE PROCEDURE Math_OnAfterEdIns();
  VAR
   _Math: LIKE(Math.Math);
 BEGIN
  L_General.Assert((Math.MathKind=L_MathR.mathk_KeyAs) = (Math.MathType=L_MathR.mtyp_KeyAssets),
                   "   ᫥ ଫ  ࠧ ࠢ筨");

  IF L_General.GetAPSiteID() = "SP" THEN
   Math.Name:=Str.Cap(Math.Name, 0, 1);
   REPLACE(Math);
  END;
  IF L_General.IsPolakSpecific() THEN
   IF Math.Leaf THEN
    SAVE(Math);
    _Math:=Math.Math;
    SELECT(Math, Vendor, , Math.Vendor, Math.UnitedC);
    WHILE OCCURE(Math) DO
     IF Math.Leaf THEN
      L_General.Assert(Math.Math = _Math,
                       "   " + Math.Math + " c   ⠫ '" + Math.UnitedC + "'");
     END;
     NEXT(Math);
    END; (* WHILE OCCURE(Math) ... *)
    RESTORE(Math);
   END; (* IF Math.Leaf *)
  END;

  SETSEL(MathKAGL, Math, Math.Math);
  IF LAST(MathKAGL) THEN
   MathKAGL.DateE:=L_DatTim.till2ED(Math.Till);
   REPLACE(MathKAGL);
  END; (* IF LAST(MathKAGL ... *)

  SELECT(MathMrkG, Math, , Math.Math);
  WHILE OCCURE(MathMrkG) DO
   ReplicateMath2SinleMathMrkG();
   NEXT(MathMrkG);
  END; (* WHILE OCCURE(MathMrkG) ... *)
  L_DBD.CheckValidity("Math");
 END {Math_OnAfterEdIns};

 PRIVATE PROCEDURE Math_OnAfterInsert();
 BEGIN
  IF Math.MathKind = L_MathR.mathk_KeyAs THEN
   CheckMathKAGL();
   DEFAULT(MathUnit);
   MathUnit.Math  :=Math.Math;
   MathUnit.Number:=000;
   MathUnit.MUnit :=01;
   MathUnit.Ratio :=1;
   INSERT(MathUnit);
IF 0 THEN (*0066571*)
   L_General.CLEAR("CUCopy");
   SETEMPTY(CUCopy.CUCopy);
   SetKeyAssCUCopy();
   INSERT(CUCopy);
END;
  ELSE
   ReplicateToMathUnit();
  END;
  Math_OnAfterEdIns();
 END {Math_OnAfterInsert};

 PRIVATE PROCEDURE ReplicateToCUCopy();
 BEGIN
  IF Math.Name # GE_PVALUE(Math.Name) THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    L_AR.GrantRightsUnconditionally();
    IF SELECT(CUCopy, Math, Math.Math) & (CUCopy.Origin = L_CUC.o_Math) THEN
     CUCopy.Serial:=Math.Name;
     REPLACE(CUCopy);
    END;
   EXCEPT
   END; (* TRY *)
  END;
 END {ReplicateToCUCopy};

 PRIVATE PROCEDURE Math_OnAfterEdit();
 BEGIN
  IF Math.MathKind = L_MathR.mathk_KeyAs THEN
   CheckMathKAGL();
IF 0 THEN (*0066571*)
   SrcKeyAssCUCopy();
   SetKeyAssCUCopy();
   REPLACE(CUCopy);
END;
  ELSE
   ReplicateToMathUnit();
   ReplicateToCUCopy();
  END;
  Math_OnAfterEdIns();
 END {Math_OnAfterEdit};

 PRIVATE PROCEDURE Math_OnBeforeDelete();
 BEGIN
  Math_OnBeforeAnyModification();
  Math_OnBeforeInsertDelete();
  L_Stock.mItem_CheckAllIsZero(Math.Math, EMPTYOF(Storage.Storage), 1);
  L_DBD.CheckUsers(GE_CURFILE());
  L_r2r.Owner_OnBeforeDelete("Math");
 END {Math_OnBeforeDelete};

 PRIVATE PROCEDURE MakeKAUnDone(D: DATE);
 BEGIN
  D:=Math.Max(D, L_Env.aptm_Start);
  L_StdFrm.Choice("㤥 믮  楢  ꥪ| "+ L_DatTim.PeriodStr(D));
  L_MathR.ResetMathDone_AP(Math.Math, L_DatTim.NextPer(D));
  L_MathR.ResetMathDone_AP(Math.Math, L_DatTim.Per(D));
 END {MakeKAUnDone};

 PRIVATE PROCEDURE SetCorrTypePool();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF ACCESS(MathKAGL) & SEARCH(KAGroup, KAGroup, MathKAGL.KAGroup) THEN
   Fields("MathKAGL.CorAcnTp").Format:=L_MathR.GetCorrTypePool(KAGroup.AcnDprM);
   Fields("MathKAGL.CorTaxTp").Format:=L_MathR.GetCorrTypePool(KAGroup.TaxDprM);
  ELSE
   Fields("MathKAGL.CorAcnTp").Format:=L_MathR.GetCorrTypePool("");
   Fields("MathKAGL.CorTaxTp").Format:=L_MathR.GetCorrTypePool("");
  END;
 END {SetCorrTypePool};

 PRIVATE PROCEDURE MathKAGL_KAGroup_OnSuccessfulChange();
 BEGIN
  SetCorrTypePool();
 END {MathKAGL_KAGroup_OnSuccessfulChange};

 PRIVATE PROCEDURE xovM1_SetFilterOnMyFirm();
  VAR
   filterValue: STRING[];
 BEGIN
  filterValue:="";
  IF ACCESS(Math) THEN
   SELECT(MyFirm, MyFirm);
   WHILE OCCURE(MyFirm) DO
    IF SELECT(mItem, Math, Math.Math, MyFirm.Storage) THEN
     IF ~!filterValue THEN
      filterValue:=filterValue + "|";
     END;
     filterValue:=filterValue + "(MyFirm.MyFirm=" + MyFirm.MyFirm + ")";
    END;
    NEXT(MyFirm);
   END; (* WHILE OCCURE(MyFirm) ... *)
  END;
  IF !filterValue THEN
   filterValue:="MyFirm.MyFirm=9999";
  END;
  RTI.Get().CurWindow.Zones(1).PermanentFilter:=filterValue;
 END {xovM1_SetFilterOnMyFirm};

 PRIVATE PROCEDURE MathE_0_OnReposition();
 BEGIN
  MathE_SetupFormFields();
 END {MathE_0_OnReposition};

 PRIVATE PROCEDURE MathGE_0_OnReposition();
 BEGIN
  MathE_SetupFormFields();
 END {MathGE_0_OnReposition};

 PRIVATE PROCEDURE Math00_1_OnReposition();
 BEGIN
  IF ACCESS(Math) THEN
   IF Math.Leaf THEN
    RTI.Get().CurProcess.ReplaceContexts("View_Math00_RCD_Math");
   ELSE
    RTI.Get().CurProcess.ReplaceContexts("View_Math00_RCD_Group");
   END;
  ELSE
   RTI.Get().CurProcess.ReplaceContexts("View_Math00_RCD_Group");
  END;
 END {Math00_1_OnReposition};

 PRIVATE PROCEDURE Math_1_OnReposition();
 BEGIN
  RTI.Get().CurProcess.ReplaceContexts("View_Math00_RCD_Group");
 END {Math_1_OnReposition};

 PRIVATE PROCEDURE Fill_ccKAXDoc();
  VAR
   leftSide: SCAL[2];
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
   SETSEL(ccKAXDoc, ccKAXDoc, L_WDO.v_dbConnection, Math.Math);
   REMSEL(ccKAXDoc);
 
   SETSEL(MDocList, Math, Math.Math);
   FOR_EACH MDocList DO
    CONFORM(MDocList, MDoc);
    IF ~ADD(ccKAXDoc, ccKAXDoc, L_WDO.v_dbConnection, Math.Math, MDoc.Date, L_DatTim.FL2TS(MDoc.DoneDTS), MDoc.XDocId,
                                ccKAXDoc.Sum, MDocList.Sum,
                                ccKAXDoc.VAT, MDocList.VAT) THEN
     ccKAXDoc.XDocStr:=L_XDoc.XDocStr(MDoc.XDocId);
     IF L_MDoc.KeyAssetsMDoc(MDoc.MDocKind) THEN
      IF L_MDoc.IsKeyAssChangeResponsibleMDocKind(MDoc.MDocKind) THEN
       CONFORM(MDoc, Staff);
       CONFORM(Staff, Man);
       ccKAXDoc.Brief:=MDoc.TSN+" "+Man.Name;
      ELSIF MDoc.MDocKind = L_MDoc.md_APc THEN
       ccKAXDoc.IsSumsMD:=1;
      END;
     ELSE
      ccKAXDoc.IsSumsMD:=1;
     END;
     ccKAXDoc.Status :=MDoc.Status;
     ccKAXDoc.Done   :=MDoc.Done;
     REPLACE(ccKAXDoc);
    END;
   END; (* FOR_EACH MDocList *)

   SETSEL(ccKAXDoc, IsSumsMD, L_WDO.v_dbConnection, Math.Math, 1);
   FOR_EACH ccKAXDoc DO
(*
    ccKAXDoc.Brief:=Str.Align(L_Money.MoneyToStr(ccKAXDoc.Date, ",", ccKAXDoc.Sum)+" ("+L_Money.MoneyToStr(ccKAXDoc.Date, ",", ccKAXDoc.VAT)+")",
                              36, RIGHT);
*)
    ccKAXDoc.Brief:=L_Money.MoneyToStr(ccKAXDoc.Date, ",", ccKAXDoc.Sum)+" ("+L_Money.MoneyToStr(ccKAXDoc.Date, ",", ccKAXDoc.VAT)+")";
    REPLACE(ccKAXDoc);
   END; (* FOR_EACH ccKAXDoc *)

   IF L_MathR.SoftAccessKeyAssXObject() THEN
    FOR_EACH leftSide DO
     IF leftSide THEN
      SETSEL(JDocList, XObject,   XObject.XObject);
     ELSE
      SETSEL(JDocList, XObject2, XObject.XObject);
     END;
     FOR_EACH JDocList DO
      CONFORM(JDocList, JDoc);
      IF ~ADD(ccKAXDoc, ccKAXDoc, L_WDO.v_dbConnection, Math.Math, JDoc.Date, L_DatTim.FL2TS(JDoc.DoneDTS), JDoc.XDocId) THEN
       ccKAXDoc.XDocStr:=L_XDoc.XDocStr(JDoc.XDocId);
       ccKAXDoc.Brief  :=L_lsStore.Get(JDoc.Comment);
       ccKAXDoc.Status :=JDoc.Status;
       ccKAXDoc.Done   :=JDoc.Done;
       REPLACE(ccKAXDoc);
      END;
     END; (* FOR_EACH JDocList *)
    END; (* FOR_EACH leftSide *)
   END;
  EXCEPT
  END; (* TRY *)
 END {Fill_ccKAXDoc};

 PUBLIC PROCEDURE PositionToXDocBy_ccKAXDoc();
 BEGIN
  L_General.Assert(ACCESS(ccKAXDoc), " ࠭ 㬥");
  L_XDoc.PositionInVideoSystem(L_XDoc.pm_StandOnly, ccKAXDoc.XDocId, "");
 END {PositionToXDocBy_ccKAXDoc};

 PRIVATE PROCEDURE Math01E_0_OnReposition();
 BEGIN
  L_MathR.RecalculateKeyAssPermanent(RTI.Get().CurWindow);
  Fill_ccKAXDoc();
 END {Math01E_0_OnReposition};

 PRIVATE PROCEDURE Math_OnReposition();
  VAR
   curWindow: FORM_WINDOW;
 BEGIN
  curWindow:=RTI.Get().CurWindow;
  IF    curWindow.OriginalName = "xovM1" THEN
   xovM1_SetFilterOnMyFirm();
  ELSE
   L_General.CallUs(0);
  END; (* curWindow.OriginalName *)
 END {Math_OnReposition};

 PRIVATE PROCEDURE MathMrkG_OnReposition();
 BEGIN
  Math_OnReposition();
 END {MathMrkG_OnReposition};

 PRIVATE PROCEDURE MathKAGL_OnReposition();
 BEGIN
  SetCorrTypePool();
  SetCorULModifiable(MathKAGL.CorAcnTp, MathKAGL.CorAcnUL, "MathKAGL.CorAcnUL", 0);
  SetCorULModifiable(MathKAGL.CorTaxTp, MathKAGL.CorTaxUL, "MathKAGL.CorTaxUL", 0);
 END {MathKAGL_OnReposition};

 PRIVATE PROCEDURE Math00A_OnInitializeWindow();
  VAR
   fuckingNarrow: STRING[];
 BEGIN
  fuckingNarrow:=L_WDO.iZone(1).Narrowing;
  L_WDO.iZone        (0).ViewOnly:=1;
  L_WDO.iZone        (1).ViewOnly:=1;
  IF L_WDO.iZone(1).MasterTable.Name = "Math" THEN
   L_WDO.iZone        (1).Narrowing:="(Math.MathKind=0) & (Math.Leaf = 0)";
   L_WDO.iZone        (1).HierarchicLink:=LINK.Get("Math", "Parent");
  ELSE
   L_WDO.iZone(1).Narrowing:=fuckingNarrow;
  END;
  L_WDO.iField       (1, "Name").Hierarchic:=1;
 END {Math00A_OnInitializeWindow};

 PRIVATE PROCEDURE Math00_OnInitializeWindow();
  VAR
   fuckingNarrow: STRING[];
 BEGIN
  fuckingNarrow:=L_WDO.iZone(1).Narrowing;
  L_WDO.iZone  (0).ViewOnly:=1;
  L_WDO.iEvents(1, [L_WDO.e_OnReposition, L_WDO.e_OnSetSubwindow]);
  IF L_WDO.iZone(1).MasterTable.Name = "Math" THEN
   L_WDO.iZone  (1).Narrowing:="Math.MathKind=0";
   L_WDO.iZone  (1).HierarchicLink:=LINK.Get("Math", "Parent");
  ELSE
   L_WDO.iZone(1).Narrowing:=fuckingNarrow;
  END;
  L_WDO.iField (1, "Name").Hierarchic:=1;
  L_WDO.iProgs (1, "_Math");
 END {Math00_OnInitializeWindow};

 PRIVATE PROCEDURE Math_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Math00";
  L_WDO.iZone  (0).ViewOnly:=1;
  L_WDO.iEvents(1, [L_WDO.e_OnReposition, L_WDO.e_OnSetSubwindow]);
  IF L_WDO.iZone(1).MasterTable.Name = "Math" THEN
   L_WDO.iZone(1).HierarchicLink:=LINK.Get("Math", "Parent");
  END;
  L_WDO.iField (1, "Name").Hierarchic:=1;
  L_WDO.iProgs (1, "_Math");
 END {Math_OnInitializeWindow};

 PRIVATE PROCEDURE MathE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iField       (0, "Math.Parent").OwnerWindowOriginalName:="Math00A";
  L_WDO.iField       (0, "Math.Parent").OwnerZoneNumber:=1;
  L_WDO.iScsChange   (0, ["Math.MathType", "Math.MUnit", "Math.Name", "Math.Parent", "Math.Begin", "Math.CarUnit"]);
  L_WDO.iUnmodifiable(0, ["v_ParentName"]);
  L_WDO.iMayBeEmpty  (0, ["Math.Comment", "Math.NoBuy", "Math.Till", "Math.GWeight",
                          "Math.OverDim[0]", "Math.OverDim[1]", "Math.OverDim[2]", "Math.Parent"]);
  L_WDO.iProgs       (0, "_Math");
 END {MathE_OnInitializeWindow};

 PRIVATE PROCEDURE Math01_OnInitializeWindow();
 BEGIN
  L_WDO.iZone        (1).Narrowing:="(Math.MathKind=1)";
  L_WDO.iSubwindow   (1, "Math01E");
  L_WDO.iProgs       (1, "_Math");
  L_WDO.iZone        (1).PermanentFilter:="Math.Leaf = 1";
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).Narrowing:="CarLog.Math=Math.Math";
  L_WDO.iZone        (2).PermanentFilter:="(CarLog.DateE>=Memo.CurDate)&(CarLog.Date<=Memo.CurDate)";
 END {Math01_OnInitializeWindow};

 PRIVATE PROCEDURE Math01E_OnInitializeWindow();
 BEGIN
  L_WDO.iWindow().MNUFileName:="Math01";
  L_WDO.iEvents      (0, [L_WDO.e_OnAnyModification, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["Math.UnitedC", "Math.Name", "Math.Begin"]);
  L_WDO.iUnmodifiable(0, ["v_KeyAss_asAPr_AcnDprMUnit", "v_KeyAss_asAPr_TaxDprMUnit", "v_KeyAss_asASp_Date", "v_KeyAss_asAPr_Date", "v_KeyAss_TSN"]);
  L_WDO.iMayBeEmpty  (0, ["Math.Till", "Math.Comment", "Math.Born"]);
  L_WDO.iProgs       (0, "_Math");
  L_WDO.iSubwindow   (1, "Math01EE");
  L_WDO.iZone        (2).ViewOnly:=1;
  L_WDO.iZone        (2).Narrowing:="(ccKAXDoc.cc="+L_WDO.v_dbConnection+") & "+
                                    "(ccKAXDoc.Math=Math.Math)";
(*
  L_WDO.iField       (2, "ccKAXDoc.DoneDTS").ReverseSorting:=1;
*)
 END {Math01E_OnInitializeWindow};

 PRIVATE PROCEDURE Math01EE_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents      (0, [L_WDO.e_OnAfterMdf, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterDelete, L_WDO.e_OnReposition]);
  L_WDO.iScsChange   (0, ["MathKAGL.CorAcnTp", "MathKAGL.CorTaxTp", "MathKAGL.KAGroup"]);
  L_WDO.iMayBeEmpty  (0, ["MathKAGL.CostItem"]);
  L_WDO.iField       (0, "KAGroup.AcnDprM").Format:=L_MathR.dprm_Pool;
  L_WDO.iField       (0, "KAGroup.TaxDprM").Format:=L_MathR.dprm_Pool;
  L_WDO.iField       (0, "MathKAGL.AcnStat").Format:=L_MathR.matst_Pool;
  L_WDO.iField       (0, "MathKAGL.TaxStat").Format:=L_MathR.matst_Pool;
  L_WDO.iProgs       (0, "_Math");
 END {Math01EE_OnInitializeWindow};

 PRIVATE PROCEDURE MathType_1_OnZoneOpen();
 BEGIN
  RTI.Get().CurZone.Fields("MathType.Category").Format:=L_Acnt.mtc_Pool;
 END {MathType_1_OnZoneOpen};

 PRIVATE PROCEDURE MathType_CheckRightsModif();
 BEGIN
  IF (MathType.MathType = L_MathR.mtyp_CWOrdIncome)         |
     (MathType.MathType = L_MathR.mtyp_AdvertisingServices) |
     (MathType.MathType = 99)                               |
     ((MathType.MathType >= L_MathR.mtyp_Materials) & (MathType.MathType <= L_MathR.mtyp_KeyAssets)) THEN
   L_General.PrgsOnly_wMes("   " +
                           L_Str.FixedIntStr(L_MathR.mtyp_Materials, 2) + ".." + L_Str.FixedIntStr(L_MathR.mtyp_KeyAssets, 2) + ", " +
                           L_Str.FixedIntStr(L_MathR.mtyp_CWOrdIncome, 2)         + ", " +
                           L_Str.FixedIntStr(L_MathR.mtyp_AdvertisingServices, 2) + ", " +
                           "99 "                                   +
                           "१ࢨ஢ ⮏");
  END;
 END {MathType_CheckRightsModif};

 PRIVATE PROCEDURE MathType_OnBeforeEdit();
 BEGIN
  MathType_CheckRightsModif();
 END {MathType_OnBeforeEdit};

 PRIVATE PROCEDURE MathType_OnBeforeDelete();
 BEGIN
  MathType_CheckRightsModif();
 END {MathType_OnBeforeDelete};

 PRIVATE PROCEDURE MathType_OnAfterInsert();
 BEGIN
  MathType_CheckRightsModif();
 END {MathType_OnAfterInsert};

 PRIVATE PROCEDURE MathType_MathType_OnSuccessfulChange();
 BEGIN
  L_General.Assert_wReferToAdmin(RTI.Get().CurProcess.Kind # FORM_PROCESS.Kind_Edit, "饭    ");
 END {MathType_MathType_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckHeritage(DprK: L_MathR.DprKindType);
  VAR
   curCorType,
   prvCorType: LIKE(MathKAGL.CorAcnTp);
   curDprM   : LIKE(KAGroup.AcnDprM);
   curStatus,
   prvStatus : LIKE(MathKAGL.AcnStat);
   DprName   : STRING[];
 BEGIN
  CONFORM(MathKAGL, KAGroup);
  IF DprK = L_MathR.DprK_Acn THEN
   curCorType:=MathKAGL.CorAcnTp;
   curDprM   :=KAGroup.AcnDprM;
   curStatus :=MathKAGL.AcnStat;
   DprName :=".";
  ELSE
   curCorType:=MathKAGL.CorTaxTp;
   curDprM   :=KAGroup.TaxDprM;
   curStatus :=MathKAGL.TaxStat;
   DprName :=".";
  END;
  IF curCorType = L_MathR.cortp_None THEN
   SAVE(MathKAGL);
   CHANGESEL(MathKAGL, Math, , MathKAGL.Math);
   IF PREV(MathKAGL) THEN
    IF DprK = L_MathR.DprK_Acn THEN
     prvCorType:=MathKAGL.CorAcnTp;
     prvStatus :=MathKAGL.AcnStat;
    ELSE
     prvCorType:=MathKAGL.CorTaxTp;
     prvStatus :=MathKAGL.TaxStat;
    END;
    IF (curDprM = L_MathR.DprM_Line) &
       (curStatus # L_MathR.matst_Conservation) &
       (prvStatus = L_MathR.matst_Conservation) THEN
     L_StdFrm.Choice("뫠 ࢠ  "+DprName+"| 㢥७    㪠 ⠢訩 ?");
    ELSIF prvCorType # L_MathR.cortp_None THEN
     L_StdFrm.Choice(" 뫠 ४஢  "+DprName+"| 㢥७    㪠 ४஢  ?");
    END;
   END;
   RESTORE(MathKAGL);
  END;
 END {CheckHeritage};

 PRIVATE PROCEDURE MathKAGL_OnBeforeInsert();
 BEGIN
  MathKAGL.AcnBreak:=L_MathR.E_DefMathKAGLBreak(L_MathR.DprK_Acn);
  MathKAGL.TaxBreak:=L_MathR.E_DefMathKAGLBreak(L_MathR.DprK_Tax);
  REPLACE(MathKAGL);
 END {MathKAGL_OnBeforeInsert};

 PRIVATE PROCEDURE CheckMathKAGLCostItem();
  VAR
   CurType,
   NeedType: LIKE(CIKind.Type);
 BEGIN
  IF ~!MathKAGL.CostItem THEN
   CONFORM(MathKAGL, CostItem);
   L_General.Assert(CostItem.MyFirm = Math.MyFirm, " ᮢ   "+CostItem.CostItem+"   "+Math.Math);
   IF ~!CostItem.CIKind THEN
    CONFORM(CostItem, CIKind);
    CurType:=CIKind.Type;
   ELSE
    SETEMPTY(CurType);
   END;
   CONFORM(MathKAGL, KAGroup);
   L_General.Assert(KAGroup.Begin <= MathKAGL.Date, "ਮ ਬ 㯯 த  "+KAGroup.KAGroup+"   㯨  "+L_DatTim.DateStr(MathKAGL.Date));
   HISTCONF(MathKAGL.Date, KAGroup, KAGLog);
   IF KAGLog.IsCar THEN
    NeedType:=L_CI.cikt_Car;
   ELSE
    NeedType:=L_CI.cikt_KeyAss;
   END;
   L_General.Assert(CurType = NeedType, " , "+L_Str.PoolItem("|", KAGLog.IsCar)+"饣 ,   㪠   ⨯ '"+L_Str.PoolItem(L_CI.cikt_Pool, NeedType)+"'");
  END;
 END {CheckMathKAGLCostItem};

 PRIVATE PROCEDURE MathKAGL_OnAfterEditInsert(D: DATE);
  CONST
   Msg = '᫥ 㪠뢠  ॣ| ४஢ ஡ ()';
 BEGIN
  SupportBegEndDate();
  CONFORM(MathKAGL, KAGroup);
  IF (KAGroup.AcnDprM = L_MathR.DprM_Runs) &
     (MathKAGL.CorAcnTp = L_MathR.cortp_None) THEN
   IF    (MathKAGL.AcnBreak = L_MathR.brk_Allways) THEN
    L_General.Error(Msg);
   ELSIF (MathKAGL.AcnBreak = L_MathR.brk_Usually) THEN
    SAVE(MathKAGL);
    CHANGESEL(MathKAGL, Math, , MathKAGL.Math);
    IF PREV(MathKAGL) THEN
     CONFORM(MathKAGL, KAGroup);
     IF (KAGroup.AcnDprM # L_MathR.DprM_Runs) THEN
      L_General.Error(Msg);
     END;
    END;
    RESTORE(MathKAGL);
   END;
  END;

  CheckMathKAGLCostItem();

  CheckHeritage(L_MathR.DprK_Acn);
  CheckHeritage(L_MathR.DprK_Tax);

  IF ((MathKAGL.CorAcnTp = L_MathR.cortp_Rest) & (MathKAGL.AcnBreak # L_MathR.brk_Allways)) |
     ((MathKAGL.CorTaxTp = L_MathR.cortp_Rest) & (MathKAGL.TaxBreak # L_MathR.brk_Allways)) THEN
   L_General.Error(' 㪠 ⠢襣 ப 㦭  " ॣ"');
  END;
  IF ((Math.PrvAcnUL#0) & (MathKAGL.CorAcnTp=L_MathR.cortp_None)) |
     ((Math.PrvTaxUL#0) & (MathKAGL.CorTaxTp=L_MathR.cortp_None)) THEN
   L_StdFrm.Choice(" ப '⨧樨 ।騬 楬'.| 㢥७,    ᤥ ४஢ ?");
  END;
  MakeKAUnDone(D);

  L_MathR.RecalculateKeyAssPermanent(RTI.Get().CurWindow.ParentZone.Window);
 END {MathKAGL_OnAfterEditInsert};

 PRIVATE PROCEDURE MathKAGL_OnAfterInsert();
 BEGIN
  MathKAGL_OnAfterEditInsert(MathKAGL.Date);
 END {MathKAGL_OnAfterInsert};

 PRIVATE PROCEDURE MathKAGL_OnBeforeDelete();
 BEGIN
  MakeKAUnDone(MathKAGL.Date);
 END {MathKAGL_OnBeforeDelete};

 PRIVATE PROCEDURE MathKAGL_OnAfterDelete();
 BEGIN
  SupportBegEndDate();
 END {MathKAGL_OnAfterDelete};

 PRIVATE PROCEDURE MathKAGL_OnAfterEdit();
 BEGIN
  MathKAGL_OnAfterEditInsert(L_DatTim.MinDATE(MathKAGL.Date, GE_PVALUE(MathKAGL.Date)));
 END {MathKAGL_OnAfterEdit};

 PRIVATE PROCEDURE SetCorULModifiable(VAR trgCorTp: LIKE(MathKAGL.CorAcnTp);
                                      VAR trgCorUL: LIKE(MathKAGL.CorAcnUL);
                                      ULFieldName: STRING[];
                                      OnSuccessfulChange: SCAL[2]);
  VAR
   Modifiable: SCAL[2];
 BEGIN
  Modifiable:=(trgCorTp # L_MathR.cortp_None);
  IF OnSuccessfulChange & ~Modifiable THEN
   SETEMPTY(trgCorUL);
   REPLACE(MathKAGL);
  END;
  RTI.Get().CurZone.Fields(ULFieldName).Modifiable:=Modifiable;
 END {SetCorULModifiable};

 PRIVATE PROCEDURE MathKAGL_CorAcnTp_OnSuccessfulChange();
 BEGIN
  SetCorULModifiable(MathKAGL.CorAcnTp, MathKAGL.CorAcnUL, "MathKAGL.CorAcnUL", 1)
 END {MathKAGL_CorAcnTp_OnSuccessfulChange};

 PRIVATE PROCEDURE MathKAGL_CorTaxTp_OnSuccessfulChange();
 BEGIN
  SetCorULModifiable(MathKAGL.CorTaxTp, MathKAGL.CorTaxUL, "MathKAGL.CorTaxUL", 1);
 END {MathKAGL_CorTaxTp_OnSuccessfulChange};

 PRIVATE PROCEDURE CheckBCSymbology(s: STRING[]);
  VAR
   i   : NUMERIC[0];
   Char: STRING[];
 BEGIN
  i:=0;
  LOOP
   Char:=L_Str.Char(s, i);
   IF !Char THEN
    EXIT;
   END;
   IF (ORD(Char) < 32) | (ORD(Char) > 126) THEN
    L_General.Error(" ४ , ᮤঠ騩 ⨬ ᨬ '" + Char + "'");
   END;
   INC(i);
  END; (* LOOP *)
 END {CheckBCSymbology};

 PRIVATE PROCEDURE MathEAN_OnBeforeDelete();
 BEGIN
  (* 맮 L_PCS.SysLogHandler  L_Events*)
 END {MathEAN_OnBeforeDelete};

 PRIVATE PROCEDURE MathEAN_OnAfterEdIns();
  VAR
   _EAN: STRING[];
 BEGIN
  CheckBCSymbology(MathEAN.EAN);
  _EAN:=MathEAN.EAN;
  SAVE(MathEAN);
  CHANGESEL(MathEAN, EAN);
  PREV(MathEAN);
  IF OCCURE(MathEAN) & MathEAN.IsMask THEN
   L_General.Assert(~Str.Match(_EAN, MathEAN.EAN+"*"), " ᪠  - ᥪ  ᪮ ꥪ "+MathEAN.Math);
  END;
  RESTORE(MathEAN);
  IF MathEAN.IsMask THEN
   SAVE(MathEAN);
   CHANGESEL(MathEAN, EAN);
   NEXT(MathEAN);
   IF OCCURE(MathEAN) THEN
    L_General.Assert(~Str.Match(MathEAN.EAN, _EAN+"*"), " ᪠ ᥪ  ᪮  - ꥪ "+MathEAN.Math);
   END;
   RESTORE(MathEAN);
  ELSIF ~L_BarCode.IsEAN(MathEAN.EAN) THEN
   L_StdFrm.Choice(" -?");
  END;
 END {MathEAN_OnAfterEdIns};

 PRIVATE PROCEDURE MathEAN_OnAfterInsert();
 BEGIN
  MathEAN_OnAfterEdIns();
 END {MathEAN_OnAfterInsert};

 PRIVATE PROCEDURE MathEAN_OnAfterEdit();
 BEGIN
  MathEAN_OnAfterEdIns();
 END {MathEAN_OnAfterEdit};

 PRIVATE PROCEDURE P_7051_SetMathUnitedC();
 BEGIN
  P_Math.SetMathUnitedCInPurchasesInf();
 END {P_7051_SetMathUnitedC};

 PUBLIC PROCEDURE ShowBySpcRefs();
  VAR
   i      : NUMERIC[0];
   List,
   Dummy  : STRING[];
   Values : STRING[][16];
 BEGIN
  L_General.Assert(ACCESS(Math), " ⠭ ⥪騩 ");
  List:=""; i:=0;
  WHILE i < 2 DO
   Dummy:=P_Math.GetSpcRef(Math.Math, SYSDATE(), i);
   Values[i]:=Dummy;
   IF !Dummy THEN
    Dummy:=" 뫪";
   END;
   List:=List + Str.Slice(Dummy, 0, 64) + "|";
   INC(i);
  END;
  i:=L_StdFrm.ShowListAsMenu(List, "뫪  ᯥ䨪樨");
  IF ~!Values[i] THEN
   Shell.Execute("open", Values[i], , P_Math.GetSpcFolder(i));
  END;
 END {ShowBySpcRefs};

 PRIVATE TYPE
  tRsvStatus   = SCAL[11];
  tRsvKind     = SCAL[5];
  tRsvShowKind = SCAL[3];
  tRsvShowCond = SCAL[2];

 PRIVATE CONST
  rsvs_Nothing        = 0;
  rsvs_AtStock        = 1;
  rsvs_AtXStock       = 2;
  rsvs_PrepareToBook  = 3;
  rsvs_Booked         = 4;
  rsvs_WaitToArrive   = 5;
  rsvs_ProceedByStock = 6;
  rsvs_PrepareToSell  = 7;
  rsvs_InSell         = 8;
  rsvs_MinRmdr        = 9;
  rsvs_InOffers       = 10;

  rsvs_Pool = "|"+
              " ᪫  |"+
              " ᪫' |"+
              "    |"+
              "   |"+
              "      |"+
              "室|"+
              "ॡ  |"+
              "㦠|"+
              ".  |"+
              "   ";

  rsvk_CurrentMath = 0;
  rsvk_CurrentMDoc = 1;
  rsvk_ByNrds      = 2;
  rsvk_CurrentFirm = 3;
  rsvk_All         = 4;

  rsvsk_wDeficit = 0;
  rsvsk_Unsafe   = 1;
  rsvsk_All      = 2;

  rsvsc_Standart = 0;
  rsvsc_wOffers  = 1;

 PRIVATE VAR
  rsvShowKind: tRsvShowKind;
  rsvShowCond: tRsvShowCond;
  rsvKind    : tRsvKind;
  rsvFirm    : LIKE(Firm.Firm);
  rsvMath    : LIKE(Math.Math);

 PRIVATE CONST
  rsvsk_Pool = " |ॡ ஫|뢠 ";
  rsvsc_Pool = "⠭| ⠬";

(*
$P{ Rsv_Top:
P_Firm.FP_FirmName(P_Firm.OWN_FIRM, SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
'"'+L_Str.PoolItem(rsvsk_Pool, rsvShowKind)+'"', L, ""
?, C, ""
@
#############################################################################                 ########## #####
=#####========================================================================================================
|                ⮪ "१ࢨ஢" . : ##############################                        |
|############################################################################################################|
}
*)

(*
$P{ Rsv_Math:
?, L, "!|"
Math.Math, L, ""
Math.Name, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|# ##### ####################################################################################################|
|------------------------------------------------------------------------------------------------------------|
|     | -|ਨ                                                                    |  줮|
|-----------|-------|-------------------------------------------------------------------------------|--------|
}
*)

(*
$P{ Rsv_Dummy:
Math.Math, L, ""
Math.Name, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|* ##### ####################################################################################################|
}
*)

 PRIVATE PROCEDURE FormatCir(_Value: NUMERIC[2]): STRING[];
 BEGIN
  IF    Math.Round(_Value, 1.0) = _Value THEN
   RETURN FLDTOSTR(_Value, "0");
  ELSE
   RETURN FLDTOSTR(_Value, "2.");
  END;
 END {FormatCir};

(*
$P{ Rsv_Line:
L_Str.PoolItem(rsvs_Pool, RsvMt.Status), L, ""
FormatCir(RsvMt.Value), R, "0"
RsvMt.Comment, L, ""
FormatCir(RsvMt.Saldo), R, "0"
@
|###########|#######|###############################################################################|########|
}
*)

(*
$P{ Rsv_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE rsv_Put(D         : DATE;
                           trgMath   : LIKE(Math.Math);
                           trgStatus : tRsvStatus;
                           trgValue  : NUMERIC[2];
                           trgStorage: LIKE(Storage.Storage);
                           trgComment: STRING[]);

  VAR
   Idx      : NUMERIC[0];
   arrMath  : LIKE(Math.Math)           [P_Math.cs_Amount];
   arrAmount: NUMERIC[0]                [P_Math.cs_Amount];
   arrType  : P_Math.tCompositionSetType[P_Math.cs_Amount];
 BEGIN
  RsvMt.Math   :=trgMath;
  RsvMt.Status :=trgStatus;
  RsvMt.Value  :=trgValue;
  RsvMt.Comment:=trgComment;
  SETZERO(RsvMt.Saldo, RsvMt.TotSaldo);
  INSERT(RsvMt);
  IF P_Math.IsCompositeMath(trgMath, D) THEN
   IF (trgStatus = rsvs_AtStock) THEN
    trgComment:=" ᪫ " + trgStorage + "  ⠢  ( " + trgMath + ")";
   ELSE
    trgComment:="<= " + trgMath + " " + trgComment;
   END;
   P_Math.Decode_CompositionSet(P_Math.GetMathProSoft(trgMath, D, P_Math.P_CompositionSet), arrMath, arrAmount, arrType);
   Idx:=0;
   WHILE (Idx < P_Math.cs_Amount) & ~!arrMath[Idx] DO
    rsv_Put(D, arrMath[Idx], trgStatus, trgValue*arrAmount[Idx], trgStorage, trgComment);
    INC(Idx);
   END;
  END;
 END {rsv_Put};

 PRIVATE PROCEDURE rsv_ProceedAtStock(_Math : LIKE(Math.Math);
                                      OnDate: DATE);
  CONST
   EmptyMDoc = 0;
  VAR
   macc    : L_MathR.tMathAcCutCollection;
   i       : NUMERIC[0];
   _Qnt    : L_XObj.tQnt;
   _Comment: STRING[];
 BEGIN
  IF ~SELECT(MDDon, MDoc, _Math, L_XDoc.EmptyXDocKind, EmptyMDoc) THEN
   SELECT(mItem, Math, , _Math);
   WHILE OCCURE(mItem) DO
    CONFORM(mItem, XObject);
    macc:=L_MathR.GetXObjectAcCutCollection(mItem.XObject);
    i:=0;
    WHILE ~!macc[i] DO
     IF L_MathR.AcCutOfRealStock(macc[i]) THEN
      _Qnt:=L_XObj.qo_GetInSaldo(macc[i], L_DatTim.NextPer(OnDate));
      IF _Qnt # 0 THEN
       SEARCH(AcCut, AcCut, , macc[i]);
       SEARCH(Storage, Storage, , mItem.Storage);
       _Comment:=Str.Align(L_Str.PoolItem(L_Stock.st_Pool_SH, Storage.Type) + " " +
                           Storage.Storage + " " + Storage.Name, 54, LEFT) +
                 L_Str.CutLongStr(" (" + AcCut.AcCut + " " + AcCut.Name, 24) + ")";
       IF (AcCut.AcCut = 003) | (AcCut.AcCut = 008) | (AcCut.AcCut = 414) |
          (AcCut.AcCut = 415) | (AcCut.AcCut = 413) THEN
        rsv_Put(OnDate, _Math, rsvs_AtXStock, _Qnt, Storage.Storage, _Comment);
       ELSE
        rsv_Put(OnDate, _Math, rsvs_AtStock,  _Qnt, Storage.Storage, _Comment);
       END;
      END;
     END; (* IF L_MathR.AcCutOfRealStock ... *)
     INC(i);
    END; (* WHILE ~!AcCuts[i] ... *)

    NEXT(mItem);
   END; (* WHILE OCCURE(mItem) ... *)
   MDDon.Math:=_Math;
   MDDon.MDocKind:=L_XDoc.EmptyXDocKind;
   MDDon.MDoc:=EmptyMDoc;
   INSERT(MDDon);
  END;
 END {rsv_ProceedAtStock};

 PRIVATE PROCEDURE rsv_GetStatusByOfferMDoc(): tRsvStatus;
 BEGIN
  IF    MDoc.MDocKind = L_MDoc.md_VhS THEN
   IF MDoc.Status = L_MDoc.st_Prepared THEN
    RETURN rsvs_PrepareToBook;
   ELSE
    RETURN rsvs_Booked;
   END;
  ELSIF MDoc.MDocKind = L_MDoc.md_Dvr THEN
   RETURN rsvs_WaitToArrive;
  ELSIF (MDoc.MDocKind = L_MDoc.md_VTN) | (MDoc.MDocKind = L_MDoc.md_VAP) THEN
   IF MDoc.Status = L_MDoc.st_Prepared THEN
    RETURN rsvs_ProceedByStock;
   ELSE
    RETURN rsvs_Nothing;
   END;
  ELSIF MDoc.MDocKind = L_MDoc.md_IsS THEN
   IF (rsvShowCond = rsvsc_wOffers) &
      (MDoc.Status = L_MDoc.st_Passed) &
      (MDoc.Date >= 21\04\2003) THEN
    RETURN rsvs_InOffers;
   ELSE
    RETURN rsvs_Nothing;
   END;
  ELSIF MDoc.MDocKind = L_MDoc.md_Nrd THEN
   RETURN rsvs_PrepareToSell;
  ELSIF (MDoc.MDocKind = L_MDoc.md_ITN) | (MDoc.MDocKind = L_MDoc.md_IAP) THEN
   IF MDoc.Status = L_MDoc.st_Prepared THEN
    RETURN rsvs_InSell;
   ELSE
    RETURN rsvs_Nothing;
   END;
  ELSE
   L_General.CallUs(0);
  END;
 END {rsv_GetStatusByOfferMDoc};

 PRIVATE PROCEDURE IsShipmentToOfferMDocKind(_MDocKind, offerMDocKind: LIKE(MDoc.MDocKind)): SCAL[2];
 BEGIN
  IF    offerMDocKind = L_MDoc.md_Nrd THEN
   RETURN (_MDocKind = L_MDoc.md_ITN) |
          (_MDocKind = L_MDoc.md_IAS) |
          (_MDocKind = L_MDoc.md_IAP) ;
  ELSIF (offerMDocKind = L_MDoc.md_VhS) THEN
   RETURN (_MDocKind = L_MDoc.md_VTN) |
          (_MDocKind = L_MDoc.md_VhA) |
          (_MDocKind = L_MDoc.md_VAP) |
          (_MDocKind = L_MDoc.md_Dvr) ;
  ELSIF (offerMDocKind = L_MDoc.md_Dvr) THEN
   RETURN (_MDocKind = L_MDoc.md_VTN) |
          (_MDocKind = L_MDoc.md_VhA) |
          (_MDocKind = L_MDoc.md_VAP) ;
  ELSIF (offerMDocKind = L_MDoc.md_IsS) THEN
   RETURN (_MDocKind = L_MDoc.md_Nrd);
  ELSIF (offerMDocKind = L_MDoc.md_VTN) |
        (offerMDocKind = L_MDoc.md_VAP) |
        (offerMDocKind = L_MDoc.md_ITN) |
        (offerMDocKind = L_MDoc.md_IAP) THEN
   RETURN 0;
  ELSE
   L_General.CallUs(0);
  END;
 END {IsShipmentToOfferMDocKind};

 PRIVATE PROCEDURE rsv_MDocListIsWorkedOff(): NUMERIC[2];
  VAR
   Result        : NUMERIC[2];
   _Math         : LIKE(Math.Math);
   offerMDocKind : LIKE(MDoc.MDocKind);
   DependentMDocs: L_XDoc.tXDocCollection;
   i             : NUMERIC[0];
 BEGIN
  _Math        :=MDocList.Math;
  offerMDocKind:=MDocList.MDocKind;
  SAVE(MDocList);
  CHANGESEL(MDocList, MDLMath, , MDocList.MDocKind, MDocList.MDoc, MDocList.Math);
  Result:=0;
  FIRST(MDocList);
  WHILE OCCURE(MDocList) DO
   INC(Result, L_MDoc.GetMDocListCir2());
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
  RESTORE(MDocList);
  IF Result # 0 THEN
   SAVE(MDoc);
   SAVE(MDocList);
   i:=0;
   DependentMDocs:=L_MDoc.GetDependentMDocXDC();
   WHILE L_XDoc.xdc_PositionOn(DependentMDocs, i) DO
    IF (MDoc.Status # L_MDoc.st_Canceled) &
        IsShipmentToOfferMDocKind(MDoc.MDocKind, offerMDocKind) THEN
     SELECT(MDocList, MDLMath, , MDoc.MDocKind, MDoc.MDoc, _Math);
     WHILE OCCURE(MDocList) DO
      DEC(Result, L_MDoc.GetMDocListCir2());
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList) ... *)
    END;
    INC(i);
   END; (* WHILE i < ... *)
   RESTORE(MDocList);
   RESTORE(MDoc);
  END; (* IF Result ... *)
  RETURN Result;
 END {rsv_MDocListIsWorkedOff};

 PRIVATE PROCEDURE rsv_ProceedSingleMDocList(offerStatus : tRsvStatus): SCAL[2];
  VAR
   _Value: NUMERIC[2];
   Result: SCAL[2];
 BEGIN
  Result:=0;
  IF ~SELECT(MDDon, MDoc, MDocList.Math, MDocList.MDocKind, MDocList.MDoc) THEN
   MDDon.Math    :=MDocList.Math;
   MDDon.MDocKind:=MDocList.MDocKind;
   MDDon.MDoc    :=MDocList.MDoc;
   INSERT(MDDon);
   IF (MDoc.Status # L_MDoc.st_Canceled) & (MDoc.Closed > (SYSDATE()-15)) THEN
    _Value:=rsv_MDocListIsWorkedOff();
    IF _Value > 0 THEN
     Result:=1;
     CONFORM(MDoc, Contract);
     rsv_Put(SYSDATE(), MDocList.Math, offerStatus, _Value, EMPTYOF(Storage.Storage),
             L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + "  " + L_DatTim.DateStr(MDoc.Date) + " " + Contract.Name);
    END; (* IF offerStatus *)
   END; (* IF MDoc.Status ... *)
  END;
  RETURN Result;
 END {rsv_ProceedSingleMDocList};

 PRIVATE PROCEDURE E_IsReservableMath(): SCAL[2];
 BEGIN
  RETURN (Math.MathType # 02(*      *)) &
         (Math.MathType # 97(*⥬ ⮏*)) &
         (Math.MathType # 98(*㣨  த *)) ;
 END {E_IsReservableMath};

 PRIVATE PROCEDURE E_IsShowableMath(): SCAL[2];
 BEGIN
  RETURN (Math.MathType # 96(*ࠡ  த*));
 END {E_IsShowableMath};

 PRIVATE PROCEDURE rsv_IsAcceptableStatus(_ShowCond: tRsvShowCond;
                                          _Status  : tRsvStatus): SCAL[2];
 BEGIN
  RETURN (_ShowCond = rsvsc_wOffers) | (_Status # rsvs_InOffers);
 END {rsv_IsAcceptableStatus};

 PRIVATE PROCEDURE rsv_GetSingleMathShowKind(sc: tRsvShowCond): tRsvShowKind;
  VAR
   _Saldo,
   usValue: NUMERIC[2];
   Result : tRsvShowKind;
 BEGIN
  SAVE(RsvMt);
  L_General.CallUs(SELECT(RsvMt, Math, Math.Math));
  SETZERO(_Saldo, usValue);
  WHILE OCCURE(RsvMt) DO
   IF rsv_IsAcceptableStatus(sc, RsvMt.Status) THEN
    IF (RsvMt.Status = rsvs_AtStock       ) |
       (RsvMt.Status = rsvs_PrepareToBook ) |
       (RsvMt.Status = rsvs_Booked        ) |
       (RsvMt.Status = rsvs_WaitToArrive  ) |
       (RsvMt.Status = rsvs_ProceedByStock) THEN
     INC(_Saldo, RsvMt.Value);
    ELSIF (RsvMt.Status # rsvs_AtXStock) THEN
     DEC(_Saldo, RsvMt.Value);
    END;
    IF (RsvMt.Status = rsvs_PrepareToBook) |
       (RsvMt.Status = rsvs_Booked)        THEN
     INC(usValue, RsvMt.Value);
    END;
   END; (* IF rsv_IsAcceptableStatus *)
   RsvMt.Saldo:=_Saldo;
   REPLACE(RsvMt);
   NEXT(RsvMt);
  END;
  FIRST(RsvMt);
  WHILE OCCURE(RsvMt) DO
   RsvMt.TotSaldo:=_Saldo;
   REPLACE(RsvMt);
   NEXT(RsvMt);
  END;
  LAST(RsvMt);
  IF    RsvMt.Saldo < 0 THEN
   Result:=rsvsk_wDeficit;
  ELSIF RsvMt.Saldo < usValue THEN
   Result:=rsvsk_Unsafe;
  ELSE
   Result:=rsvsk_All;
  END;
  RESTORE(RsvMt);
  RETURN Result;
 END {rsv_GetSingleMathShowKind};

 PRIVATE PROCEDURE rsv_IsMathToPrint(): SCAL[2];
 BEGIN
  RETURN E_IsReservableMath() & E_IsShowableMath() & SELECT(nMath, Math, Math.Math);
 END {rsv_IsMathToPrint};

 PRIVATE PROCEDURE rsv_PrintSingleMath();
 BEGIN
  IF rsv_IsMathToPrint() THEN
   IF rsvShowKind >= rsv_GetSingleMathShowKind(rsvsc_wOffers) THEN
    SETSEL(RsvMt, Math, Math.Math);
    LAST(RsvMt);
    MAKEPART(R, Rsv_Math, RsvMt.Saldo >= 0);
    FIRST(RsvMt);
    WHILE OCCURE(RsvMt) DO
     MAKEPART(R, Rsv_Line);
     NEXT(RsvMt);
    END;
   END;
  END;
 END {rsv_PrintSingleMath};

 PRIVATE PROCEDURE rsv_Excel_MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "  ⠫");
  L_Basis.wb_WrStr(F, "⠢騪");
  L_Basis.wb_WrStr(F, "⠢騪");
  L_Basis.wb_WrStr(F, "᫮");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "");
  L_Basis.wb_WrStr(F, "⢮");
  L_Basis.wb_WrStr(F, "줮");
  L_Basis.wb_WrStr(F, "⥫쭮 ᠫ줮");
  L_Basis.wb_WrStr(F, "ਨ");
  L_Basis.wb_TermLine(F);
 END {rsv_Excel_MakeHeader};

 PRIVATE PROCEDURE rsv_Excel_MakeLine(F     : STRING[];
                                      sk    : tRsvShowKind;
                                      sc    : tRsvShowCond;
                                      _Firm : LIKE(Firm.Firm);
                                      _Price: FLOAT);
 BEGIN
  L_Basis.wb_WrScl(F, Math.Math);
  L_Basis.wb_WrStr(F, Math.Name);
  L_Basis.wb_WrScl(F, Vendor.Vendor);
  L_Basis.wb_WrStr(F, Vendor.Name);
  L_Basis.wb_WrStr(F, Math.UnitedC);
  IF ~!_Firm THEN
   L_Basis.wb_WrScl(F, Firm.Firm);
   L_Basis.wb_WrStr(F, Firm.Name);
  ELSE
   L_Basis.wb_WrScl(F, "----");
   L_Basis.wb_WrStr(F, "----");
  END;
  L_Basis.wb_WrStr(F, L_Str.PoolItem(rsvsc_Pool, sc));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(rsvsk_Pool, sk));
  L_Basis.wb_WrStr(F, L_Str.PoolItem(rsvs_Pool, RsvMt.Status));
  L_Basis.wb_WrNum(F, _Price, 5);
  L_Basis.wb_WrNum(F, RsvMt.Value, 2);
  L_Basis.wb_WrNum(F, RsvMt.Saldo, 2);
  L_Basis.wb_WrNum(F, RsvMt.TotSaldo, 2);
  L_Basis.wb_WrStr(F, RsvMt.Comment);
  L_Basis.wb_TermLine(F);
 END {rsv_Excel_MakeLine};

 PRIVATE PROCEDURE rsv_Excel_MakeSingleMathOfProvider(F     : STRING[];
                                                      sk    : tRsvShowKind;
                                                      sc    : tRsvShowCond;
                                                      _Firm : LIKE(Firm.Firm);
                                                      _Price: FLOAT);
 BEGIN
  IF ~!_Firm THEN
   SEARCH(Firm, Firm, , _Firm);
  END;
  SELECT(RsvMt, Math, , Math.Math);
  WHILE OCCURE(RsvMt) DO
   IF rsv_IsAcceptableStatus(sc, RsvMt.Status) THEN
    rsv_Excel_MakeLine(F, sk, sc, _Firm, _Price);
   END;
   NEXT(RsvMt);
  END; (* WHILE OCCURE(RsvMt) ... *)
 END {rsv_Excel_MakeSingleMathOfProvider};

 PRIVATE PROCEDURE rsv_Excel_MakeSingleMath(F: STRING[]; _Math: LIKE(Math.Math));
  VAR
   sk           : tRsvShowKind;
   sc           : tRsvShowCond;
   pProvider    : L_Prop.tArrayElement;
   pPrice       : P_Math.tPI_Price;
   pPMath       : P_Math.tPI_ProvidersMath;
   pMainProvider: P_Math.tPI_MainProvider;
   i            : NUMERIC[0];
 BEGIN
  APP.Get().NewPrompt("⮢ ");
  SEARCH(Math, Math, , _Math);
  CONFORM(Math, Vendor);
  PROMPT(" " + Math.Math);
  IF rsv_IsMathToPrint() THEN
   P_Math.GetP_PurchaseInf(_Math, SYSDATE(), pProvider, pPrice, pPMath, pMainProvider);
   sc:=MINOF(tRsvShowCond);
   WHILE sc <= MAXOF(tRsvShowCond) DO
    sk:=rsv_GetSingleMathShowKind(sc);
    rsv_Excel_MakeSingleMathOfProvider(F, sk, sc, EMPTYOF(Firm.Firm), EMPTYOF(FLOAT));
    i:=0;
    WHILE ~!pProvider[i] & (i <= HIGH(pProvider)) DO
     rsv_Excel_MakeSingleMathOfProvider(F, sk, sc, pProvider[i], pPrice[i]);
     INC(i);
    END; (* WHILE i ...*)
    INC(sc);
   END; (* WHILE sc <= ... *)
  END;
 END {rsv_Excel_MakeSingleMath};

 PRIVATE PROCEDURE rsv_ToExcel(RepName: STRING[]);
 BEGIN
  FIO.Open(R, L_General.NameConnection(RepName), "REP", Create);
  rsv_Excel_MakeHeader("R");
  SELECT(RsvMt, Math);
  WHILE OCCURE(RsvMt) DO
   NARROWSEL(RsvMt, Math);
   SAVE(RsvMt);
   rsv_Excel_MakeSingleMath("R", RsvMt.Math);
   RESTORE(RsvMt);
   NEXTINEXTENDEDSEL(RsvMt, Math);
  END; (* WHILE OCCURE(RsvMt) ... *)
  FIO.Close(R);
  L_Basis.ExtPlayMakedRunTimeRep(RepName,
                                 FLDTOSTR(SYSDATE(), "yND") + "_" +
                                 FLDTOSTR(SYSTIME(), "HM"),
                                 L_General.timeCond_Entire,
                                 "ࢨ஢  ﭨ  " +
                                 L_DatTim.DateTimeStr(SYSDATE(), SYSTIME()),
                                 0);

 END {rsv_ToExcel};

 PRIVATE PROCEDURE IsMathSupplier(D    : DATE;
                                  _Firm: LIKE(Firm.Firm);
                                  _Math: LIKE(Math.Math)): SCAL[2];
  VAR
   _Provider    : L_Prop.tArrayElement;
   _Price       : P_Math.tPI_Price;
   _PMath       : P_Math.tPI_ProvidersMath;
   _MainProvider: P_Math.tPI_MainProvider;
   i            : NUMERIC[0];
 BEGIN
  P_Math.GetP_PurchaseInf(_Math, D, _Provider, _Price, _PMath, _MainProvider);
  i:=0;
  WHILE i <= HIGH(_Provider) DO
   IF STRTOFLD(_Provider[i], SCAL) = _Firm THEN
    RETURN 1;
   END;
   INC(i);
  END; (* WHILE i <= HIGH(_Provider)...*)
  RETURN 0;
 END {IsMathSupplier};

 PRIVATE PROCEDURE rsv_PrintAll();
 BEGIN
  APP.Get().NewPrompt("⮢ ");
  SELECT(RsvMt, Math);
  WHILE OCCURE(RsvMt) DO
   NARROWSEL(RsvMt, Math);
   SEARCH(Math, Math, , RsvMt.Math);
   PROMPT(" " + Math.Math);
   IF ((rsvKind # rsvk_CurrentFirm) |
       IsMathSupplier(SYSDATE(), rsvFirm, Math.Math)) &
      ((rsvKind # rsvk_CurrentMath) |
       (Math.Math = rsvMath)) THEN
    SAVE(RsvMt);
    rsv_PrintSingleMath();
    RESTORE(RsvMt);
   END;
   NEXTINEXTENDEDSEL(RsvMt, Math);
  END; (* WHILE OCCURE(RsvMt) ... *)
 END {rsv_PrintAll};

 PRIVATE PROCEDURE rsv_SetShowAll(_rsvShowKind: tRsvShowKind;
                                  _rsvShowCond: tRsvShowCond;
                                  Title       : STRING[];
                                  RepName     : STRING[]);
 BEGIN
  rsvShowKind:=_rsvShowKind;
  rsvShowCond:=_rsvShowCond;
  STDFORM(L_StdFrm.sf_Choice("|" + Str.Slice(Title, 0, 48) +
                             "|" +
                             "|ନ஢   ० %###################%"+
                             "|" +
                             "| ⮬              %###################%",
                             "%<"+rsvsk_Pool+ ">I"+
                             "%<"+"|"+ ">I"),
          " 'ࢨ஢' ",
          INFORM,
          ,
          rsvShowKind, rsvShowCond);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Rsv_Top, RepName, Title);
 END {rsv_SetShowAll};

 PRIVATE PROCEDURE rsv_nMath_Put(_Math: LIKE(Math.Math));
 BEGIN
  IF ~SELECT(nMath, Math, _Math) THEN
   nMath.Math:=_Math;
   INSERT(nMath);
  END;
 END {rsv_nMath_Put};

 PRIVATE PROCEDURE rsv_nMath_PutSingle(trgMath: LIKE(Math.Math); D: DATE);
  VAR
   Idx      : NUMERIC[0];
   arrMath  : LIKE(Math.Math)           [P_Math.cs_Amount];
   arrAmount: NUMERIC[0]                [P_Math.cs_Amount];
   arrType  : P_Math.tCompositionSetType[P_Math.cs_Amount];
 BEGIN
  rsv_nMath_Put(trgMath);
  IF P_Math.IsCompositeMath(trgMath, D) THEN
   P_Math.Decode_CompositionSet(P_Math.GetMathProSoft(trgMath, D, P_Math.P_CompositionSet), arrMath, arrAmount, arrType);
   Idx:=0;
   WHILE (Idx < P_Math.cs_Amount) & ~!arrMath[Idx] DO
    rsv_nMath_Put(arrMath[Idx]);
    INC(Idx);
   END;
  END;
 END {rsv_nMath_PutSingle};

 PRIVATE PROCEDURE rsv_Build_MDToD(_MDocKind: LIKE(MDocKind.MDocKind));
 BEGIN
  APP.Get().NewPrompt("⮢ ");
  SETSEL(MDoc, MDocKind, _MDocKind);
  SRCINSEL(MDoc, GT, , SYSDATE());
  WHILE OCCURE(MDoc) DO
   PROMPT(L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   MDToD.MDocKind:=MDoc.MDocKind;
   MDToD.MDoc    :=MDoc.MDoc    ;
   INSERT(MDToD);
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
 END {rsv_Build_MDToD};

 PRIVATE PROCEDURE rsv_nMath_BySingleMDoc();
 BEGIN
  PROMPT("⮢ ᯨ᪠ : " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
  IF (MDoc.Status # L_MDoc.st_Canceled) THEN
   SELECT(MDocList, MDoc, , MDoc.MDocKind, MDoc.MDoc);
   WHILE OCCURE(MDocList) DO
    rsv_nMath_PutSingle(MDocList.Math, SYSDATE()(*!MDoc.Date*));
    NEXT(MDocList);
   END; (* WHILE OCCURE(MDocList) ... *)
  END;
 END {rsv_nMath_BySingleMDoc};

 PRIVATE PROCEDURE rsv_nMath_BySingleMDocKind(_MDocKind: LIKE(MDocKind.MDocKind));
 BEGIN
  SELECT(MDToD, MDoc, , _MDocKind);
  WHILE OCCURE(MDToD) DO
   SEARCH(MDoc, MDoc, , MDToD.MDocKind, MDToD.MDoc);
   rsv_nMath_BySingleMDoc();
   NEXT(MDToD);
  END; (* WHILE OCCURE(MDToD) ... *)
 END {rsv_nMath_BySingleMDocKind};

 PRIVATE PROCEDURE rsv_nMath_ByAll();
  VAR
   _MinRemainder: NUMERIC[2];
   offerStatus  : tRsvStatus;
   CloseIt      : SCAL[2];
   Idx          : NUMERIC[0];
   arrMath      : LIKE(Math.Math)           [P_Math.cs_Amount];
   arrAmount    : NUMERIC[0]                [P_Math.cs_Amount];
   arrType      : P_Math.tCompositionSetType[P_Math.cs_Amount];
 BEGIN
  IF rsvShowCond = rsvsc_wOffers THEN
   rsv_Build_MDToD(L_MDoc.md_IsS);
  END;
  rsv_Build_MDToD(L_MDoc.md_Nrd);
  rsv_Build_MDToD(L_MDoc.md_ITN);
  rsv_Build_MDToD(L_MDoc.md_IAP);
  rsv_Build_MDToD(L_MDoc.md_VhS);
  rsv_Build_MDToD(L_MDoc.md_Dvr);
  rsv_Build_MDToD(L_MDoc.md_VTN);
  rsv_Build_MDToD(L_MDoc.md_VAP);
  IF (rsvKind # rsvk_CurrentMDoc) THEN
   rsv_nMath_BySingleMDocKind(L_MDoc.md_Nrd);
   IF rsvShowCond = rsvsc_wOffers THEN
    rsv_nMath_BySingleMDocKind(L_MDoc.md_IsS);
   END;
   SELECT(Math, LeafMK, , 1, L_MathR.mathk_Math);
   WHILE OCCURE(Math) DO
    PROMPT("⮢ ᯨ᪠  ( ⮪): " + Math.Math);
    _MinRemainder:=P_Math.GetMinRemainder(Math.Math, SYSDATE());
    IF (_MinRemainder # 0) & ~SELECT(nMath, Math, Math.Math) THEN
     rsv_nMath_PutSingle(Math.Math, SYSDATE());
    END;
    NEXT(Math);
   END; (* WHILE OCCURE(Math) ... *)
  END; (* IF (rsvKind # rsvk_CurrentMDoc) ... *)
  SELECT(Math, Leaf, , 1);
  WHILE OCCURE(Math) DO
   PROMPT("宦  ⠢ : " + Math.Math);
   IF P_Math.IsCompositeMath(Math.Math, SYSDATE()) THEN
    P_Math.Decode_CompositionSet(P_Math.GetMathProSoft(Math.Math, SYSDATE(), P_Math.P_CompositionSet), arrMath, arrAmount, arrType);
    Idx:=0;
    WHILE (Idx < P_Math.cs_Amount) & ~!arrMath[Idx] DO
     IF SELECT(nMath, Math, arrMath[Idx]) THEN
      rsv_nMath_Put(Math.Math);
     END;
     INC(Idx);
    END;
   END;
   NEXT(Math);
  END; (* WHILE OCCURE(Math) ... *)
  SELECT(MDToD, MDoc);
  WHILE OCCURE(MDToD) DO
   SEARCH(MDoc, MDoc, , MDToD.MDocKind, MDToD.MDoc);
   PROMPT("ࠡ⪠ : " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc));
   CloseIt:=1;
   IF MDoc.Status # L_MDoc.st_Canceled THEN
    IF L_Pmnt.E_IsMayBePaidMDoc() |
       (MDoc.Status = L_MDoc.st_Prepared) |
       (rsvKind = rsvk_CurrentMDoc) THEN
     CloseIt:=0;
    END;
    offerStatus:=rsv_GetStatusByOfferMDoc();
    IF offerStatus # rsvs_Nothing THEN
     CONFORM(MDoc, MDocList);
     WHILE OCCURE(MDocList) DO
      IF rsv_ProceedSingleMDocList(offerStatus) THEN
       CloseIt:=0;
      END;
      NEXT(MDocList);
     END; (* WHILE OCCURE(MDocList) ... *)
    END;
   END;
   IF CloseIt THEN
    MDoc.Closed:=SYSDATE();
    TRY [MSGSUPPRESSIONMODE(MSGSUPPRESS_ALL)];
     REPLACE(MDoc);
    EXCEPT
    ON Exc: Exc_AccessDeny DO
    END;
   END;
   NEXT(MDToD);
  END; (* WHILE OCCURE(MDToD) ... *)

  SELECT(nMath, Math);
  WHILE OCCURE(nMath) DO
   PROMPT("ࠡ⪠ ᪫᪨ ⪮ : " + nMath.Math);
   SEARCH(Math, Math, , nMath.Math);
   IF E_IsReservableMath() THEN
    rsv_ProceedAtStock(Math.Math, SYSDATE());
    _MinRemainder:=P_Math.GetMinRemainder(Math.Math, SYSDATE());
    IF _MinRemainder # 0 THEN
     rsv_Put(SYSDATE(), Math.Math, rsvs_MinRmdr, _MinRemainder, EMPTYOF(Storage.Storage), "᭨ ⮪");
    END;
   END;
   NEXT(nMath);
  END; (* WHILE OCCURE(nMath) ... *)
 END {rsv_nMath_ByAll};

 PRIVATE PROCEDURE Reserve(RepName: STRING[]; trg_rsvKind: tRsvKind);
 BEGIN
  APP.Get().NewPrompt(RepName);
  L_AFM.MakeMultipleIndex("MDToD", "MDocKind : LIKE(MDoc.MDocKind);"+
                                      "MDoc     : LIKE(MDoc.MDoc)",
                              "MDoc: MDocKind, MDoc");
  L_AFM.MakeMultipleIndex("MDDon", "Math     : LIKE(Math.Math);"+
                                      "MDocKind : LIKE(MDoc.MDocKind);"+
                                      "MDoc     : LIKE(MDoc.MDoc)",
                              "MDoc: Math, MDocKind, MDoc");
  L_AFM.MakeMultipleIndex("nMath", "Math     : LIKE(Math.Math)",
                              "Math: Math");
  L_AFM.MakeMultipleIndex("RsvMt", "Math    : LIKE(Math.Math);"+
                                      "Status  : SCAL[1E2];"+
                                      "Value   : NUMERIC[2];"+
                                      "Saldo   : NUMERIC[2];"+
                                      "TotSaldo: NUMERIC[2];"+
                                      "Comment : STRING[79]",
                              "Math: Math, Status, Comment");
  rsvKind:=trg_rsvKind;
  IF rsvKind # rsvk_CurrentMDoc THEN
   RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  END;
  IF    rsvKind = rsvk_All THEN
   rsvShowKind:=rsvsk_All;
   rsvShowCond:=rsvsc_wOffers;
  ELSIF rsvKind = rsvk_CurrentMath THEN
   L_General.Assert(ACCESS(Math), " ⠭ ⥪騩 ");
   rsvMath:=Math.Math;
   rsv_SetShowAll(rsvsk_All, 1,
                  ": " + Math.Math + " " + Math.Name,
                  RepName);
  ELSIF rsvKind = rsvk_CurrentMDoc THEN
   L_MDoc.AccessMDoc();
   rsv_SetShowAll(rsvsk_wDeficit, 0,
                  ": " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc),
                  RepName);
   rsv_nMath_BySingleMDoc();
  ELSIF rsvKind = rsvk_ByNrds THEN
   rsv_SetShowAll(rsvsk_wDeficit, 0,
                  " ",
                  RepName);
  ELSIF rsvKind = rsvk_CurrentFirm THEN
   L_General.Assert(ACCESS(Firm), " ⠭ ࠣ");
   rsvFirm:=Firm.Firm;
   rsv_SetShowAll(rsvsk_wDeficit, 1,
                  "   ⠢騪 " + Firm.Firm + " " + Firm.Name,
                  RepName);
  ELSE
   L_General.CallUs(0);
  END;
  rsv_nMath_ByAll();
  IF rsvKind = rsvk_All THEN
   rsv_ToExcel(RepName);
  ELSE
   rsv_PrintAll();
   MAKEPART(R, Rsv_Bot);
   CLOSEREP(R);
   L_General.SurveyLastReport();
  END;
 END {Reserve};

 PUBLIC PROCEDURE Rsrvr();
 BEGIN
  Reserve("Rsrvr", rsvk_All);
 END {Rsrvr};

 PUBLIC PROCEDURE RsmMt();
 BEGIN
  Reserve("RsmMt", rsvk_CurrentMath);
 END {RsmMt};

 PUBLIC PROCEDURE RsmMD();
 BEGIN
  Reserve("RsmMD", rsvk_CurrentMDoc);
 END {RsmMD};

 PUBLIC PROCEDURE RsmAF();
 BEGIN
  Reserve("RsmAF", rsvk_CurrentFirm);
 END {RsmAF};

 PUBLIC PROCEDURE RsmAl();
 BEGIN
  Reserve("RsmAl", rsvk_ByNrds);
 END {RsmAl};

 PRIVATE PROCEDURE MathMrkG_MarkG_OnBeforeAsk();
 BEGIN
  L_Way.v_MarkGT:=L_Way.mgt_MathCompatibility;
 END {MathMrkG_MarkG_OnBeforeAsk};

 PRIVATE PROCEDURE MathMrkG_MarkG_OnSuccessfulChange();
  VAR
   Dummy: STRING[];
 BEGIN
  IF ~!MathMrkG.MarkG THEN
   Dummy:=P_Mark.GetMarkGName(L_Way.mgt_MathCompatibility, MathMrkG.MarkG);
  END;
 END {MathMrkG_MarkG_OnSuccessfulChange};

(*
$P{ Mth_PP_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Math.Math, L, ""
Memo.ud_cd(), L, "D.N.y"
?, L, ""
?, L, ""
@
############################################################################################ ########## #####
=#####=======================================================================================================
|                               ⮨  #####  ##########                                  |
|###########################################################################################################|
|###########################################################################################################|
|-----------------------------------------------------------------------------------------------------------|
|  |                                                    |- ||      |          㬬|
|-----|----------------------------------------------------------------|-------|-|----------|---------------|
}
*)

(*
$P{ Mth_PP_Line:
?, L, ""
?, L, ""
?, R, "3."
?, L, " |!"
?, R, "5."
?, R, "5."
@
|#####|################################################################|#######|#|##########|###############|
}
*)

(*
$P{ Mth_PP_SubLine:
?, L, ""
@
|     |################################################################|       | |          |               |
}
*)


(*
$P{ Mth_PP_Bot:
?, R, "5."
@
|-------------------------------------------------------------------------------------------|---------------|
|⮣                                                                                      |###############|
=(c) Polak===================================================================================================
}
*)

 PRIVATE PROCEDURE MthPP_SingleMath(VAR Total : NUMERIC[5]);
  CONST
   ExpPeriod = 10;
  VAR
   _Price        : NUMERIC[5];
   _Sum          : NUMERIC[5];
   Idx           : NUMERIC[0];
   arrMath       : LIKE(Math.Math)           [P_Math.cs_Amount];
   arrAmount     : NUMERIC[0]                [P_Math.cs_Amount];
   arrType       : P_Math.tCompositionSetType[P_Math.cs_Amount];
   i, j          : NUMERIC[0];
   MathName      : STRING[66][10];
   ErrMsg,
   SingleErrMsg  : STRING[];
 BEGIN
  SETEMPTY(ErrMsg);
  IF P_Math.IsCompositeMath(Math.Math, Memo.ud_cd()) THEN
   SAVE(Math);
   P_Math.Decode_CompositionSet(P_Math.GetMathProSoft(Math.Math, Memo.ud_cd(), P_Math.P_CompositionSet), arrMath, arrAmount, arrType);
   Idx:=0;
   LOOP
    IF !arrMath[Idx] THEN
     EXIT;
    END;
    SEARCH(Math, Math, , arrMath[Idx]);
    IF P_Math.IsCompositeMath(Math.Math, Memo.ud_cd()) THEN
     MthPP_SingleMath(Total);
    ELSE
     SETEMPTY(SingleErrMsg);
     _Price:=P_Math.GetPPrice(Math.Math, Memo.ud_cd(), ExpPeriod, 1, SingleErrMsg);
     ErrMsg:=L_Str.AddStrDlm(ErrMsg, "|") + SingleErrMsg;
     IF ~!_Price THEN
      _Sum:=_Price*arrAmount[Idx];
     ELSE
      _Sum:=0;
     END;
     Str.Format(MathName, Math.Name, 64, LEFT);
     MAKEPART(R, Mth_PP_Line, Math.Math, MathName[0], arrAmount[Idx], ~!SingleErrMsg, _Price, _Sum);
     j:=1;
     WHILE ~!MathName[j] DO
      MAKEPART(R, Mth_PP_SubLine, MathName[j]);
      INC(j);
     END; (* WHILE *)
     INC(Total, _Sum);
    END;
    INC(Idx);
   END; (* LOOP *)
   RESTORE(Math);
  ELSE
   SETEMPTY(SingleErrMsg);
   _Price:=P_Math.GetPPrice(Math.Math, Memo.ud_cd(), ExpPeriod, 1, SingleErrMsg);
   ErrMsg:=L_Str.AddStrDlm(ErrMsg, "|") + SingleErrMsg;
   MAKEPART(R, Mth_PP_Line, ,
                            ,
                            ,
                            ~!SingleErrMsg,
                            ,
                            _Price);
   IF ~!_Price THEN
    INC(Total, _Price);
   END;
  END;
  IF ~!ErrMsg THEN
   L_StdFrm.BlueStop("   ५  祬  " + L_Str.IntStr(ExpPeriod) + " " + L_StdFrm.HR() + ErrMsg);
  END;
 END {MthPP_SingleMath};

 PRIVATE PROCEDURE MthPP();
  CONST
   RepName = "MthPP";
  VAR
   Total   : NUMERIC[5];
   MathName: STRING[104][2];
 BEGIN
  APP.Get().NewPrompt(RepName);
  L_General.Assert(ACCESS(Math), " ⠭ ⥪騩 ");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  Str.Format(MathName, Math.Name, 107, LEFT);
  MAKEPART(R, Mth_PP_Top, RepName, MathName[0], MathName[1]);
  Total:=0;
  MthPP_SingleMath(Total);
  MAKEPART(R, Mth_PP_Bot, Total);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MthPP};

 PRIVATE PROCEDURE Math_GetSubWindowName(trgLeaf: LIKE(Math.Leaf)): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF    trgLeaf = 1 THEN Result:="MathE";
  ELSE                   Result:="MathGE";
  END;
  RETURN Result;
 END {Math_GetSubWindowName};

 PRIVATE PROCEDURE Math_OnSetSubwindow(trgMathKind: LIKE(Math.MathKind));
  VAR
   trgLeaf         : LIKE(Math.Leaf);
   trgSubWindowName: STRING[];
 BEGIN
  IF RTI.Get().CurProcess.Kind # FORM_PROCESS.Kind_Insert THEN
   L_General.Assert(ACCESS(Math), " । ꥪ");
  END;
  IF !trgMathKind THEN
   IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert THEN
    IF L_Env.KeyAssAcntLev(SYSDATE()) = L_MathR.kaal_NoKeyAssets THEN
     trgMathKind:=L_MathR.mathk_Math;
    ELSE
     trgMathKind:=L_StdFrm.ShowListAsMenu("|ꥪ ", "⠢");
    END;
   ELSE
    trgMathKind:=Math.MathKind;
   END;
  END;
  IF    trgMathKind = L_MathR.mathk_Math THEN
   IF RTI.Get().CurProcess.Kind = FORM_PROCESS.Kind_Insert THEN
    IF L_WDO.InHierarchyInsMode() THEN trgLeaf:=0;
    ELSE                               trgLeaf:=1;
    END;
   ELSE
    trgLeaf:=Math.Leaf;
   END;
   trgSubWindowName:=Math_GetSubWindowName(trgLeaf);
   RTI.Get().CurZone.HasVariousSubwindows:=1;
  ELSIF trgMathKind = L_MathR.mathk_KeyAs THEN
   trgSubWindowName:="Math01E";
  ELSE
   L_General.CallUs(0);
  END;
  RTI.Get().CurZone.SubwindowOriginalName:=trgSubWindowName;
 END {Math_OnSetSubwindow};

 PRIVATE PROCEDURE Math00_1_OnSetSubwindow();
 BEGIN
  Math_OnSetSubwindow(L_MathR.mathk_Math);
 END {Math00_1_OnSetSubwindow};

 PUBLIC PROCEDURE Math_1_OnSetSubwindow();
 BEGIN
  Math_OnSetSubwindow(EMPTYOF(Math.MathKind));
 END {Math_1_OnSetSubwindow};

(*
$P{ Math_CSE_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Math.Math + " " + Math.Name, C, ""
?, L, "D.N.y"
@
############################################################# ########## #####
=#####========================================================================
|                     宦   ⠢ ⮢                      |
|############################################################################|
|                                 ##########                               |
|----------------------------------------------------------------------------|
| ()                                        |C         |        |
|----------------------------------------------------- |----------|----------|
}
*)

(*
$P{ Math_CSE_Line:
Math.Math, L, ""
Math.Name, L, ""
MathPro.Date, L, "D.N.y"
MathPro.EndDate, L, "D.N.y"
@
|##### ################################################|##########|##########|
}
*)

(*
$P{ Math_CSE_Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE ActualMathPro(_Date: DATE): SCAL[2];
 BEGIN
  RETURN L_DatTim.IsActive(_Date, MathPro.Date, MathPro.EndDate);
 END {ActualMathPro};

 PRIVATE PROCEDURE IsInCompositionSet(trgMath: LIKE(Math.Math);
                                      D      : DATE): SCAL[2];
  VAR
   Idx      : NUMERIC[0];
   arrMath  : LIKE(Math.Math)           [P_Math.cs_Amount];
   arrAmount: NUMERIC[0]                [P_Math.cs_Amount];
   arrType  : P_Math.tCompositionSetType[P_Math.cs_Amount];
   Result   : SCAL[2];
 BEGIN
  P_Math.Decode_CompositionSet(P_Math.GetMathProSoft(MathPro.Math, D, P_Math.P_CompositionSet), arrMath, arrAmount, arrType);
  SETZERO(Idx, Result);
  WHILE ~Result & (Idx < P_Math.cs_Amount) & ~!arrMath[Idx] DO
   Result:=(trgMath = arrMath[Idx]);
   INC(Idx);
  END; (* WHILE (Idx < P_Math.cs_Amount) & ~!arrMath[Idx] ...*)
  RETURN Result;
 END {IsInCompositionSet};

 PUBLIC PROCEDURE MthCE();
  CONST
   RepName = "MthCE";
  VAR
   curMath: LIKE(Math.Math);
 BEGIN
  APP.Get().NewPrompt(RepName);
  L_General.Assert(ACCESS(Math), " ⠭ ⥪騩 ");
  curMath:=Math.Math;
  L_XDoc.sl_Init("宦  " + curMath + "  ⠢ ⮢");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Math_CSE_Top, RepName, Memo.ud_cd());
  SELECT(MathPro, Property, , P_Math.P_CompositionSet);
  WHILE OCCURE(MathPro) DO
   SAVE(MathPro);
   PROMPT(MathPro.Math);
   IF ActualMathPro(Memo.ud_cd()) THEN
    IF IsInCompositionSet(curMath, Memo.ud_cd()) THEN
     CONFORM(MathPro, Math);
     L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_Math, L_XDoc.EmptyXDocKind, Math.Math),
                       Str.Slice(Math.Math + " " + Math.Name, 0, 64));
     MAKEPART(R, Math_CSE_Line);
    END;
   END;
   RESTORE(MathPro);
   NEXT(MathPro);
  END; (* WHILE OCCURE(MathPro) ... *)
  MAKEPART(R, Math_CSE_Bot);
  CLOSEREP(R);
  L_XDoc.sl_Done();
 END {MthCE};

 CONST
  maxFormat = 2;

 TYPE
  tbmspQnt = NUMERIC[maxFormat+1];

(*
$P{ bmsp_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
MDoc.MDoc, L, ""
Storage.Storage, L, ""
Storage.Name, L, ""
@
############################################################################################# ########## #####
=#####========================================================================================================
|⮪ ନ஢    ####### ( ⮬  冷   ####### ########################)|
|------------------------------------------------------------------------------------------------------------|
|                                                                     |    拉|        |    |
|------------------------------------------------------------------------|-----------|-----------|-----------|
}
*)

(*
$P{ bmsp_Line:
Math.Math, L, ""
Math.Name, L, ""
BlMSP.qNrd, R, "3."
BlMSP.qStr, R, "3."
BlMSP.qTot, R, "3."
@
|##### ##################################################################|###########|###########|###########|
}
*)

(*
$P{ bmsp_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE bmsp_IsAcceptableMath(_Math: LIKE(Math.Math)): SCAL[2];
 BEGIN
  SEARCH(Math, Math, , _Math);
  RETURN E_IsReservableMath() & E_IsShowableMath();
 END {bmsp_IsAcceptableMath};

 PRIVATE PROCEDURE bmsp_Put(_Math : LIKE(Math.Math);
                            Qnt   : tbmspQnt;
                            byNrd : SCAL[2];
                            VAR
                             MDLNbr: LIKE(MDocList.MDLNbr));
  VAR
   qNrd, qStr: tbmspQnt;
 BEGIN
  IF bmsp_IsAcceptableMath(_Math) THEN
   IF byNrd THEN
    qNrd:=Qnt;
    qStr:=0;
   ELSE
    qNrd:=0;
    qStr:=Qnt;
   END;
   IF ~ADD(BlMSP, Math, _Math,
           BlMSP.qNrd, qNrd,
           BlMSP.qStr, qStr,
           BlMSP.qTot, qNrd-qStr) THEN
    BlMSP.MDLNbr:=MDLNbr;
    REPLACE(BlMSP);
    INC(MDLNbr);
   END;
  END;
 END {bmsp_Put};

 PRIVATE PROCEDURE bmsp_PutSingleNrd(VAR MDLNbr: NUMERIC[0]);
  VAR
   Qnt      : L_XObj.tQnt;
   Idx      : NUMERIC[0];
   arrMath  : LIKE(Math.Math)           [P_Math.cs_Amount];
   arrAmount: NUMERIC[0]                [P_Math.cs_Amount];
   arrType  : P_Math.tCompositionSetType[P_Math.cs_Amount];
 BEGIN
  SELECT(MDocList, MDLMath, , MDoc.MDocKind, MDoc.MDoc);
  WHILE OCCURE(MDocList) DO
   Qnt:=rsv_MDocListIsWorkedOff();
   IF Qnt > 0 THEN
    IF P_Math.IsCompositeMath(MDocList.Math, MDoc.Date) THEN
     P_Math.Decode_CompositionSet(P_Math.GetMathProSoft(MDocList.Math, MDoc.Date, P_Math.P_CompositionSet), arrMath, arrAmount, arrType);
     Idx:=0;
     WHILE (Idx < P_Math.cs_Amount) & ~!arrMats[Idx] DO
      bmsp_Put(arrMath[Idx], Qnt*arrAmount[Idx], 1, MDLNbr);
      INC(Idx);
     END;
    ELSE
     bmsp_Put(MDocList.Math, Qnt, 1, MDLNbr);
    END;
   END;
   NARROWSEL(MDocList, Math);
   NEXTINEXTENDEDSEL(MDocList, Math);
  END; (* WHILE OCCURE(MDocList) ... *)
 END {bmsp_PutSingleNrd};

 PUBLIC PROCEDURE BuildMSPByNrd();
  CONST
   RepName = "BlMSP";
  VAR
   macc     : L_MathR.tMathAcCutCollection;
   i        : NUMERIC[0];
   MDLNbr   : NUMERIC[0];
   Qnt      : tbmspQnt;
   _Storage2: LIKE(MDoc.Storage2);
 BEGIN
  L_General.Assert(ACCESS(MDoc),
                   " ⠭ ⥪騩 ");
  L_General.Assert(MDoc.MDocKind = L_MDoc.md_Nrd,
                   "ନ஢  믮 ⮫쪮  ");
  L_General.Assert(!MDoc.Closed,
                   "騩   ࠡ⠭");
  L_AFM.MakeMultipleIndex("BlMSP", "Math : LIKE(Math.Math);" +
                                      "qTot : NUMERIC[3](*tbmspQnt*);"+
                                      "qNrd : NUMERIC[3](*tbmspQnt*);"+
                                      "qStr : NUMERIC[3](*tbmspQnt*);"+
                                      "MDLNbr: LIKE(MDocList.MDLNbr)",
                             "Math: Math; MDLNbr: MDLNbr");
  MDLNbr:=0;
  IF ~!MDoc.Storage THEN
   SAVE(MDoc);
   _Storage2:=MDoc.Storage;
   SELECT(MDoc, MDKStrg, , L_MDoc.md_Nrd, _Storage2);
   WHILE OCCURE(MDoc) DO
    IF !MDoc.Closed THEN
     bmsp_PutSingleNrd(MDLNbr);
    END;
    NEXT(MDoc);
   END; (* WHILE OCCURE(MDoc) ... *)
   RESTORE(MDoc);
   SELECT(mItem, Storage, , MDoc.Storage);
   WHILE OCCURE(mItem) DO
    CONFORM(mItem, XObject);
    macc:=L_MathR.GetXObjectAcCutCollection(mItem.XObject);
    i:=0;
    WHILE ~!macc[i] DO
     IF L_MathR.AcCutOfRealStock(macc[i]) THEN
      Qnt:=L_XObj.qo_GetInSaldo(macc[i], L_DatTim.NextPer(SYSDATE()));
      IF Qnt # 0 THEN
       bmsp_Put(mItem.Math, Qnt, 0, MDLNbr);
      END;
     END;
     INC(i);
    END;
    NEXT(mItem);
   END; (* WHILE OCCURE(mItem) ... *)
  ELSE
   bmsp_PutSingleNrd(MDLNbr);
   SETEMPTY(_Storage2);
  END;
  IF ~!_Storage2 THEN
   CONFORM(MDoc, Storage);
   OPENREP(R, L_General.NameConnection(RepName), Create);
   MAKEPART(R, bmsp_Top, RepName);
  END;
  i:=0;
  SELECT(BlMSP, MDLNbr);
  WHILE OCCURE(BlMSP) DO
   IF ~!_Storage2 THEN
    SEARCH(Math, Math, , BlMSP.Math);
    MAKEPART(R, bmsp_Line);
   END;
   IF BlMSP.qTot > 0 THEN
    IF i = 0 THEN
     DEFAULT(MDoc);
     MDoc.MDocKind:=L_MDoc.md_MSP;
     MDoc.Date    :=SYSDATE();
     MDoc.Storage2:=_Storage2;
     MDoc.TSN     :=L_MDoc.curUSER2MDocTSN(0);
     MDoc.Status  :=L_MDoc.st_Prepared;
     L_MDoc.Insert_MDoc();
    END;
    L_MathR.SearchMUnit(L_MathR.DefaultMUnit(BlMSP.Math));
    L_MDoc.InsMDocList(BlMSP.Math, L_MathR.mm_New,
                       L_MDoc.E_DefaultVATMode(MDoc.Date, BlMSP.Math),
                       Math.Trunc(BlMSP.qTot + 1/Math.Pow(10, MUnit.Format)-1/Math.Pow(10, maxFormat+1), 1/Math.Pow(10, MUnit.Format)), 0, 0);
    INC(i);
   END;
   NEXT(BlMSP);
  END; (* WHILE OCCURE(BlMSP) ... *)
  L_AFM.AF_PurgeTemp("BlMSP");
  IF ~!_Storage2 THEN
   MAKEPART(R, bmsp_Bot);
   CLOSEREP(R);
  END;
  IF i = 0 THEN
   L_StdFrm.BlueHalt("  室 ନ஢ ");
  ELSE
   TRY
    L_StdFrm.Question("㤥 ନ஢  (" + L_Str.IntStr(i) + " 権)");
   EXCEPT
   ELSE
    HALT();
   END;
  END;
 END {BuildMSPByNrd};

(*
$P{ cs_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
CostItem.CostItem, L, ""
CostItem.Name, L, ""
@
######################################################################################################################### ########## #####
=#####====================================================================================================================================
| 室, 祭  業.  室  室 ####### ################################################################|
|----------------------------------------------------------------------------------------------------------------------------------------|
|                                                                                                 |       |       |    |
|----------------------------------------------------------------------------------------------------|-----------|-----------|-----------|
}
*)

 PRIVATE PROCEDURE cs_Delta(): tbmspQnt;
 BEGIN
  IF ChSCI.Plan # ChSCI.Fact THEN
   RETURN ChSCI.Plan - ChSCI.Fact;
  ELSE
   RETURN EMPTYOF(tbmspQnt);
  END;
 END {cs_Delta};

(*
$P{ cs_Line:
Math.Math, L, ""
Math.Name, L, ""
ChSCI.Plan, R, "3."
ChSCI.Fact, R, "3."
cs_Delta(), R, "3."
@
|##### ##############################################################################################|###########|###########|###########|
}
*)

(*
$P{ cs_Bot:
@
=(c) Polak================================================================================================================================
}
*)

 PRIVATE PROCEDURE cs_Put(_Math: LIKE(Math.Math); Qnt: L_XObj.tQnt; IsFact: SCAL[2]);
 BEGIN
  ADD(ChSCI, Math, , _Math,
      ChSCI.Plan, Qnt*~IsFact,
      ChSCI.Fact, Qnt* IsFact);
 END {cs_Put};

 PRIVATE PROCEDURE cs_PutSingleMDoc(Dir: NUMERIC[0]; IsFact: SCAL[2]; InCompositeMathOnly: SCAL[2]);
  VAR
   Qnt      : L_XObj.tQnt;
   Idx      : NUMERIC[0];
   arrMath  : LIKE(Math.Math)           [P_Math.cs_Amount];
   arrAmount: NUMERIC[0]                [P_Math.cs_Amount];
   arrType  : P_Math.tCompositionSetType[P_Math.cs_Amount];
 BEGIN
  CONFORM(MDoc, MDocList);
  WHILE OCCURE(MDocList) DO
   Qnt:=L_MDoc.GetMDocListCir2();
   IF P_Math.IsCompositeMath(MDocList.Math, MDoc.Date) THEN
    P_Math.Decode_CompositionSet(P_Math.GetMathProSoft(MDocList.Math, MDoc.Date, P_Math.P_CompositionSet), arrMath, arrAmount, arrType);
    Idx:=0;
    WHILE (Idx < P_Math.cs_Amount) & ~!arrMath[Idx] DO
     cs_Put(arrMath[Idx], Dir*Qnt*arrAmount[Idx], IsFact);
     INC(Idx);
    END;
   ELSIF ~InCompositeMathOnly THEN
    cs_Put(MDocList.Math, Dir*Qnt, IsFact);
   END;
   NEXT(MDocList);
  END; (* WHILE OCCURE(MDocList) ... *)
 END {cs_PutSingleMDoc};

 PUBLIC PROCEDURE ChSCI();
  CONST
   RepName = "ChSCI";
 BEGIN
  APP.Get().NewPrompt(RepName);
  L_General.Assert(ACCESS(MDoc), " ⠭ ⥪騩 ");
  L_General.Assert(~!MDoc.CostItem, " 㪠  室  室");
  L_AFM.MakeMultipleIndex("ChSCI", "Math : LIKE(Math.Math);" +
                                      "Plan : NUMERIC[3](*tbmspQnt*);"+
                                      "Fact : NUMERIC[3](*tbmspQnt*)",
                             "Math: Math");
  CONFORM(MDoc, CostItem);
  SELECT(MDoc, CostItem, , CostItem.CostItem);
  WHILE OCCURE(MDoc) DO
   PROMPT(L_MDoc.GetMDocStrNbr());
   IF    MDoc.MDocKind = L_MDoc.md_TOV THEN
    cs_PutSingleMDoc(+1, 1, 0);
   ELSIF MDoc.MDocKind = L_MDoc.md_ViP THEN
    cs_PutSingleMDoc(-1, 1, 0);
   ELSIF MDoc.MDocKind = L_MDoc.md_IAS THEN
    cs_PutSingleMDoc(+1, 0, 1);
   ELSE
    L_General.Error(" " + L_MDoc.MDocStr(MDoc.MDocKind, MDoc.MDoc) + ": 㪠  室  室");
   END;
   NEXT(MDoc);
  END; (* WHILE OCCURE(MDoc) ... *)
  IF SELECT(ChSCI, Math) THEN
   OPENREP(R, L_General.NameConnection(RepName), Create);
   MAKEPART(R, cs_Top, RepName);
   WHILE OCCURE(ChSCI) DO
    SEARCH(Math, Math, , ChSCI.Math);
    MAKEPART(R, cs_Line);
    NEXT(ChSCI);
   END; (* WHILE OCCURE(ChSCI) *)
   MAKEPART(R, cs_Bot);
   CLOSEREP(R);
   L_General.SurveyLastReport();
  ELSE
   L_StdFrm.BlueHalt("  ଠ樨  '室'");
  END;
 END {ChSCI};

 PRIVATE PROCEDURE MathMrkG_OnInitializeWindow();
 BEGIN
  L_WDO.iZone        (0).ViewOnly:=1;
  L_WDO.iField       (0, "Math.Name").LineBreakEnable:=1;
  L_WDO.iEvents      (1, [L_WDO.e_OnBeforeEdit, L_WDO.e_OnBeforeInsert, L_WDO.e_OnAfterEdit, L_WDO.e_OnAfterInsert, L_WDO.e_OnBeforeDelete]);
  L_WDO.iZone        (1).Narrowing:="MathMrkG.Math=Math.Math";
  L_WDO.iField       (1, "MathMrkG.MarkG").OnBeforeAsk:=1;
  L_WDO.iScsChange   (1, ["MathMrkG.MarkG"]);
  L_WDO.iProgs       (1, "_Math");
 END {MathMrkG_OnInitializeWindow};

 PRIVATE PROCEDURE MathMrkG_OnBeforeModification();
 BEGIN
  CONFORM(MathMrkG, Math);
  L_General.Assert(Math.Leaf = 1, " 㯯஢ ᥩ  䨪|" +
                                  "ᮢ⨬   㯯 ப  饭");
 END {MathMrkG_OnBeforeModification};

 PRIVATE PROCEDURE MathMrkG_OnBeforeEdit();
 BEGIN
  MathMrkG_OnBeforeModification();
 END {MathMrkG_OnBeforeEdit};

 PRIVATE PROCEDURE MathMrkG_OnBeforeInsert();
 BEGIN
  MathMrkG_OnBeforeModification();
 END {MathMrkG_OnBeforeInsert};

 PRIVATE PROCEDURE MathMrkG_OnAfterEdIns();
 BEGIN
  CONFORM(MathMrkG, Math);
  ReplicateMath2SinleMathMrkG();
 END {MathMrkG_OnAfterEdIns};

 PRIVATE PROCEDURE MathMrkG_OnAfterEdit();
 BEGIN
  MathMrkG_OnAfterEdIns();
 END {MathMrkG_OnAfterEdit};

 PRIVATE PROCEDURE MathMrkG_OnAfterInsert();
 BEGIN
  MathMrkG_OnAfterEdIns();
 END {MathMrkG_OnAfterInsert};

 PRIVATE PROCEDURE MathMrkG_OnBeforeDelete();
 BEGIN
  MathMrkG_OnBeforeModification();
  MathMarkG_RemoveParent();
 END {MathMrkG_OnBeforeDelete};

 PRIVATE PROCEDURE Math00_cv_ChooseGroup(): LIKE(MarkG.MarkG);
  VAR
   List  : STRING[];
   Groups: LIKE(MarkG.MarkG)[128];
   i     : NUMERIC[0];
 BEGIN
  SETEMPTY(Groups[0]);
  IF SELECT(MathMrkG, MarkG) THEN
   List:=L_Str.Repeat(" ", Str.Length(MathMrkG.MarkG) + 1) + "  ";
   i:=1;
   SELECT(MathMrkG, MarkG);
   WHILE OCCURE(MathMrkG) DO
    NARROWSEL(MathMrkG, MarkG);
    CONFORM(MathMrkG, MarkG);
    IF L_DatTim.IsActive(Memo.ud_cd(), MarkG.Begin, MarkG.Till) THEN
     INC(List, "|" + MarkG.MarkG + " " + MarkG.Name);
     Groups[i]:=MarkG.MarkG;
     INC(i);
    END;
    NEXTINEXTENDEDSEL(MathMrkG, MarkG);
   END; (* WHILE OCCURE(MathMrkG) *)
   RETURN Groups[L_StdFrm.ShowListAsMenu(List, " 롮 㯯 ப  ᮢ⨬  ")];
  ELSE
   L_StdFrm.Inform("     ᮢ⨬ ");
   RETURN Groups[0];
  END;
 END {Math00_cv_ChooseGroup};

 PRIVATE PROCEDURE Math00_cv_SingleZone(Z: FORM_ZONE; curMaster, newMaster: TABLE);
  VAR
   ff: FORM_FIELD;
   fl: FORM_FILTER;
 BEGIN
  Z.SetMaster(newMaster);
  FOR_EACH ff IN Z.Fields DO
   IF Str.Pos(ff.Expression, curMaster.Name+".") = 0 THEN
    ff.Expression:=Str.Replace(ff.Expression, curMaster.Name+".", newMaster.Name + ".");
   END;
  END;
  IF ~Z.Plane THEN
   FOR_EACH fl IN Z.Filters DO
    fl.Value:=Str.Replace(fl.Value, curMaster.Name+".", newMaster.Name + ".");
   END;
  END;
 END {Math00_cv_SingleZone};

 PUBLIC PROCEDURE Math00_ChangeView();
  VAR
   curWindow,
   newWindow : FORMWINDOW;
   curMaster,
   newMaster : TABLE;
   newMarkG  : LIKE(MarkG.MarkG);
   curMath   : LIKE(Math.Math);
   curAFName : STRING[];
 BEGIN
  newMarkG :=Math00_cv_ChooseGroup();
  curWindow:=APPLICATION.Get().TopWindow;
  curMaster:=curWindow.Zones(1).MasterCursor.TABLE;
  curAFName:=curWindow.Zones(1).ActiveField.Name;
  IF ~!newMarkG THEN
   newMaster:=TABLE.Get("MathMrkG");
   SEARCH(MarkG, MarkG, , newMarkG);
   curWindow.Title:=", ᮢ⨬  㯯 ப " + newMarkG + " " + MarkG.Name;
  ELSE
   newMaster:=TABLE.Get("Math");
   curWindow.Title:="ꥪ ਠ쭮 ";
  END;
  IF (curMaster # newMaster) | ~!newMarkG THEN
   GE_WZD_CURSOR(curWindow.Name, 1, ^(curMaster.Name));
   IF OCCURE(^(curMaster.Name)) THEN
    curMath:=^(L_DBD.GetFieldName(curMaster.Name, "Math"));
   ELSE
    SETEMPTY(curMath);
   END;
   curWindow.Hide();
   Math00_cv_SingleZone(curWindow.Zones(0), curMaster, newMaster);
   Math00_cv_SingleZone(curWindow.Zones(1), curMaster, newMaster);
   curWindow.SetMaster(newMaster);
   curWindow.Zones(1).HierarchicLink:=LINK.Get(newMaster.Name, "Parent");
   IF curWindow.OriginalName = "Math00" THEN
    curWindow.Zones(1).Narrowing:="(" + L_DBD.GetFieldName(newMaster.Name, "MathKind") +
                                  " = " + L_Str.IntStr(L_MathR.mathk_Math) + ")";
    IF ~!newMarkG THEN
     INC(curWindow.Zones(1).Narrowing, "&(MathMrkG.MarkG = " + newMarkG + ")");
    END;
   ELSE
    curWindow.Zones(1).Narrowing:="";
    IF ~!newMarkG THEN
     INC(curWindow.Zones(1).Narrowing, "(MathMrkG.MarkG = " + newMarkG + ")");
    END;
   END;
   SETEMPTY(curWindow.Zones(1).PermanentFilter);
   newWindow:=APPLICATION.Get().Forms.Load(curWindow.OriginalName, curWindow.AssignedName);
   IF newMaster.Name = "Math" THEN
    IF ~SEARCH(Math, Math, curMath) THEN
     IF newWindow.OriginalName = "Math" THEN
      SELECT(Math, Math);
     ELSE
      SELECT(Math, MathKind, , 0(*0095977*));
     END;
     newWindow.Zones(1).CloseAllParentsInHierarchicView();
    END;
    IF 0&L_General.IsAcceptableProcessorVersion(14152010) THEN
     curWindow.Zones(1).SortingField:=curWindow.Zones(1).Fields(curAFName);
    ELSE
     IF curAFName = "Name" THEN
      IF newWindow.OriginalName = "Math" THEN
       CHANGESEL(Math, Parent);
      ELSE
       CHANGESEL(Math, MKP, , Math.MathKind);
      END;
     ELSE
      IF newWindow.OriginalName = "Math" THEN
       CHANGESEL(Math, Math);
      ELSE
       CHANGESEL(Math, MathKind, , Math.MathKind);
      END;
     END;
    END;
   ELSE
    IF ~SEARCH(MathMrkG, MarkG, newMarkG, curMath) THEN
     SELECT(MathMrkG, Parent, , newMarkG, EMPTYOF(MathMrkG.Parent), 0);
     newWindow.Zones(1).CloseAllParentsInHierarchicView();
    END;
    IF OCCURE(MathMrkG) THEN
     IF curAFName = "Name" THEN
      IF newWindow.OriginalName = "Math" THEN
       CHANGESEL(MathMrkG, Parent, , MathMrkG.MarkG);
      ELSE
       CHANGESEL(MathMrkG, MKP, , MathMrkG.MathKind, MathMrkG.MarkG);
      END;
     ELSE
      IF newWindow.OriginalName = "Math" THEN
       CHANGESEL(MathMrkG, MarkG, , MathMrkG.MarkG);
      ELSE
       CHANGESEL(MathMrkG, MathKind, , MathMrkG.MathKind, MathMrkG.MarkG);
      END;
     END;
    END;
   END;
   TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF), MSGSUPPRESSIONMODE(MSGSUPPRESS_ALL)]
    SE_WWD_CURSOR(newWindow.Name, ^(newMaster.Name));
    SE_WZD_CURSOR(newWindow.Name, 1, ^(newMaster.Name));
   EXCEPT
   ELSE
   END;
   IF newWindow.OriginalName = "Math00" THEN
    LIKEMENU(View, newWindow.Name + " 1");
   ELSE
    LIKEMENU(Ask, "");
   END;
  END;
 END {Math00_ChangeView};

 PRIVATE PROCEDURE MathE_OnConformToWindow();
 BEGIN
  IF RTI.Get().CurZone.MasterCursor.TABLE.Name = "MathMrkG" THEN
   L_General.CallUs(ACCESS(MathMrkG));
   CONFORM(MathMrkG, Math);
   CHANGESEL(Math, MathKind, , Math.MathKind);
   SE_WWD_CURSOR(RTI.Get().ConformTargetWindow.Name, Math);
   SE_WZD_CURSOR(RTI.Get().ConformTargetWindow.Name, 0, Math);
  END;
 END {MathE_OnConformToWindow};

 PRIVATE PROCEDURE MathGE_OnConformToWindow();
 BEGIN
  MathE_OnConformToWindow();
 END {MathGE_OnConformToWindow};

 PRIVATE PROCEDURE intMakeCopy(srcMath: LIKE(Math.Math));
 BEGIN
  L_DBD.CopyFromSrcRecord("Math", srcMath);
  REPLACE(Math);
 END {intMakeCopy};

 PUBLIC PROCEDURE MakeCopy();
 BEGIN
  ACCESS(Math);
  L_WDO.LaunchInsertBySource(Math.Math, "");
 END {MakeCopy};

BEGIN
 L_Events.ExecuteHandler();
END.
