(*
%Copyright   (c) Polak Computer System
%Author      19.11.2002 20:41:29 POLAK\BOR
%Purpose     ⭮ ⠢
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:12:25 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT Memo, L_General, L_DatTim, L_OwnData, L_Man, L_Staff, L_AFM, L_APtm;

 VAR
  _00_18,
  _18_40,
  _40_50,
  _50_60,
  _60_XX,
  _00_XX: NUMERIC[0][2];
  Male_18_40,
  Female_18_40: NUMERIC[0][200];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L ,""
Memo.ud_cd(), L, "D.N.y"
_00_18[L_Man.sex_Male], R, ""
_00_18[L_Man.sex_Female], R, ""
_00_18[L_Man.sex_Female]+_00_18[L_Man.sex_Male], R, ""
_18_40[L_Man.sex_Male], R, ""
_18_40[L_Man.sex_Female], R, ""
_18_40[L_Man.sex_Female]+_18_40[L_Man.sex_Male], R, ""
@
##################################################### ########## #####
-#####----------------------------------------------------------------
|       ⭮ ⠢ ࠡ⭨ ।  ##########       |
|====================================================================|
|                                     | 稭| 騭|  ⮣|
|--------------------------------------------|-------|-------|-------|
|  18                                   | ##### | ##### | ##### |
|--------------------------------------------|-------|-------|-------|
|  18  40                             | ##### | ##### | ##### |
|                                            |       |       |       |
|     ⮬ ᫥:                            |       |       |       |
|                                            |       |       |       |
}
*)

(*
$P{ Line:
?, R, ""
?, R, ""
?, R, ""
?, R, ""
?, R, ""
@
|     ##  ##                             | ##### | ##### | ##### |
}
*)

(*
$P{ Bot:
_40_50[L_Man.sex_Male], R, ""
_40_50[L_Man.sex_Female], R, ""
_40_50[L_Man.sex_Female]+_40_50[L_Man.sex_Male], R, ""
_50_60[L_Man.sex_Male], R, ""
_50_60[L_Man.sex_Female], R, ""
_50_60[L_Man.sex_Female]+_50_60[L_Man.sex_Male], R, ""
_60_XX[L_Man.sex_Male], R, ""
_60_XX[L_Man.sex_Female], R, ""
_60_XX[L_Man.sex_Female]+_60_XX[L_Man.sex_Male], R, ""
_00_XX[L_Man.sex_Male], R, ""
_00_XX[L_Man.sex_Female], R, ""
_00_XX[L_Man.sex_Female]+_00_XX[L_Man.sex_Male], R, ""
@
|--------------------------------------------|-------|-------|-------|
|  40  50                             | ##### | ##### | ##### |
|--------------------------------------------|-------|-------|-------|
|  50  60                             | ##### | ##### | ##### |
|--------------------------------------------|-------|-------|-------|
|  60                                | ##### | ##### | ##### |
|--------------------------------------------|-------|-------|-------|
| ⮣                                      | ##### | ##### | ##### |
=(c) Polak============================================================
}
*)

 PRIVATE PROCEDURE Age(_Birth: LIKE(Man.Birth)): NUMERIC[0];
 BEGIN
  RETURN L_DatTim.CompleteYearsInIntvl(_Birth, Memo.ud_cd()-1);
 END {Age};

 PRIVATE PROCEDURE Count_Age(_Age, Min, Max: NUMERIC[0]; VAR Count: NUMERIC[0][2]);
 BEGIN
  INC(Count[Man.Sex], (Min <= _Age) & (_Age < Max));
 END {Count_Age};

 PUBLIC PROCEDURE Ages();
  CONST
   RepName="AgeSt";
  VAR
   i,
   curAge: NUMERIC[0];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  SETZERO(_00_18, _18_40, _40_50, _50_60, _60_XX, _00_XX,
          Male_18_40, Female_18_40);
  OPENREP(R, L_General.NameConnection(RepName), Create);
 
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   PROMPT(Man.Man);
   SELECT(Staff, Man, , Man.Man);
   WHILE OCCURE(Staff) & ~L_Staff.rInState(Memo.ud_cd()) DO
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   IF OCCURE(Staff) THEN
    curAge:=Age(Man.Birth);
    L_General.Assert(curAge>=14, "  14 !  "+Man.Man);
    Count_Age(curAge, 00,  18, _00_18);
    Count_Age(curAge, 40,  50, _40_50);
    Count_Age(curAge, 50,  60, _50_60);
    Count_Age(curAge, 60, 200, _60_XX);
    Count_Age(curAge, 00, 200, _00_XX);
    Count_Age(curAge, 18,  40, _18_40);
    IF Man.Sex = L_Man.sex_Male THEN
     INC(  Male_18_40[curAge]);
    ELSE
     INC(Female_18_40[curAge]);
    END;
   END;
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
 
  i:=18;
  MAKEPART(R, Top, RepName);
  WHILE i<40 DO
   IF (Male_18_40[i]>0) | (Female_18_40[i]>0) THEN
    MAKEPART(R, Line, i, i+1, Male_18_40[i], Female_18_40[i], Male_18_40[i]+Female_18_40[i]);
   END;
   INC(i);
  END;
  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {Ages};

(*
$P{ TopUnAge:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, "D.N.y"
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|              ᫥ ࠡ⭨    ##########              |
|############################################################################|
|----------------------------------------------------------------------------|
|⥣                         |00..30|30..40|40..50|50..60|60....| ᥣ|
|----------------------------------|------|------|------|------|------|------|
}
*)

(*
$P{ DlmUnAge:
@
|----------------------------------|------|------|------|------|------|------|
}
*)

(*
$P{ LineUnAge:
?, L, ""
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
?, R, "0"
@
|##################################|######|######|######|######|######|######|
}
*)

(*
$P{ BotUnAge:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "६ 䠩", "");

  CreateFIELD(Tmp, Union, LIKE(Union.Union), "", "",  "", "⥣",   "");
  CreateFIELD(Tmp, Age,   NUMERIC[0][5],     "", "0", "", " ", "");

  CreateINDEXandLINK(Tmp, Union, UNIQUE, Union, Union, USER, "", "", Union);

  SetVersionOfFILE(Tmp, 0);

  L_AFM.CreateTemp("Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE RepTitle(): STRING[];
 BEGIN
  IF L_APtm.IsMGT() THEN
   RETURN "(᪢; ᭮ ࠡ)";
  ELSE
   RETURN "(᭮ ࠡ)";
  END;
 END {RepTitle};

 PRIVATE PROCEDURE Condition(): SCAL[2];
 BEGIN
  IF L_APtm.IsMGT() THEN
   RETURN L_Man.Man_Citizen(Man.Man, Memo.ud_cd()) = L_Man.ct_Moscow;
  ELSE
   RETURN 1;
  END;
 END {Condition};

 PRIVATE PROCEDURE AgeGroup(Age: NUMERIC[0]): NUMERIC[0];
 BEGIN
  IF    Age < 30 THEN RETURN 0;
  ELSIF Age < 40 THEN RETURN 1;
  ELSIF Age < 50 THEN RETURN 2;
  ELSIF Age < 60 THEN RETURN 3;
  ELSE                RETURN 4;
  END;
 END {AgeGroup};

 PRIVATE PROCEDURE Do();
 BEGIN
  SELECT(Staff, TSN);
  WHILE OCCURE(Staff) DO
   PROMPT(Staff.TSN);
   IF (Staff.Contract = L_Staff.cnt_Basic) & L_Staff.rInState(Memo.ud_cd()) THEN
    CONFORM(Staff, Man);
    IF Condition() THEN
     CONFORM(StaffLog, Officer);
     ADD(Tmp, Union, , Officer.Union,
         Tmp.Age[AgeGroup(Age(Man.Birth))], 1);
    END;
   END;
   NEXT(Staff);
  END; (* WHILE OCCURE(Staff) ... *)
 END {Do};

 PRIVATE PROCEDURE PrintRep();
  CONST
   RepName = "UnAge";
  VAR
   SumAge: NUMERIC[0][5];
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, TopUnAge, RepName, Memo.ud_cd(), RepTitle());
  SETZERO(SumAge);
  SELECT(Tmp, Union);
  WHILE OCCURE(Tmp) DO
   L_General.CallUs(SEARCH(Union, Union, Tmp.Union));
   INC(SumAge[0], Tmp.Age[0]);
   INC(SumAge[1], Tmp.Age[1]);
   INC(SumAge[2], Tmp.Age[2]);
   INC(SumAge[3], Tmp.Age[3]);
   INC(SumAge[4], Tmp.Age[4]);
   MAKEPART(R, LineUnAge, Union.Union+" "+Union.Name,
            Tmp.Age[0], Tmp.Age[1], Tmp.Age[2], Tmp.Age[3], Tmp.Age[4],
            Tmp.Age[0]+Tmp.Age[1]+Tmp.Age[2]+Tmp.Age[3]+Tmp.Age[4]);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, DlmUnAge);
  MAKEPART(R, LineUnAge, "⮣",
           SumAge[0], SumAge[1], SumAge[2], SumAge[3], SumAge[4],
           SumAge[0]+SumAge[1]+SumAge[2]+SumAge[3]+SumAge[4]);
  MAKEPART(R, BotUnAge);
 END {PrintRep};

 PUBLIC PROCEDURE Un_Age();
 BEGIN
  Create_Tmp();
  Do();
  PrintRep();
  L_AFM.AF_PurgeTemp("Tmp");
 END {Un_Age};

END.
