(*
%Copyright   (c) Polak Computer System
%Author      25.10.2002 19:39:32 POLAK\LDA
%Purpose      ᯮ짮   ਮ
%Type        report
%Specific    SYS
%Modified    28.05.2013 15:14:40 POLAK\MLB
%Environment
*)

 IMPORT L_General, L_Basis, L_DatTim, L_Staff, L_OwnData, L_AFM, L_Str, Memo, FIO, Math;

 PRIVATE PROCEDURE MakeHeader(F: STRING[]);
 BEGIN
  L_Basis.wb_WrInQM(F, "⠊");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, " 砫 믫");
  L_Basis.wb_WrInQM(F, " ४饭 ");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⥣");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "⤥");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "");
  L_Basis.wb_WrInQM(F, "  ");
  L_Basis.wb_WrInQM(F, "祭");
  L_Basis.wb_WrInQM(F, "  ਪ");
  L_Basis.wb_WrInQM(F, " ਪ");
  L_Basis.wb_WrInQM(F, " ਪ");
  L_Basis.wb_WrInQM(F, " ॢ");
  L_Basis.wb_TermLine(F);
 END {MakeHeader};

 PRIVATE PROCEDURE MakePart(F: STRING[];
                    EDOrderSrcNum: LIKE(EDOrder.SrcNum);
                    EDOrderDate: LIKE(EDOrder.Date);
                    HasTransfer: SCAL[2]);
 BEGIN
  L_Basis.wb_WrScl(F, Adding.AddKind);
  L_Basis.wb_WrStr(F, AddKind.Name);
  L_Basis.wb_WrDat(F, Adding.From);
  L_Basis.wb_WrDat(F, Adding.UpTo);
  L_Basis.wb_WrScl(F, Union.Union);
  L_Basis.wb_WrStr(F, Union.Name);
  L_Basis.wb_WrScl(F, L_Staff.getDepart());
  L_Basis.wb_WrStr(F, L_Staff.getDepartName());
  L_Basis.wb_WrScl(F, Sort.Sort);
  L_Basis.wb_WrStr(F, Sort.Name);
  L_Basis.wb_WrScl(F, Staff.TSN);
  L_Basis.wb_WrStr(F, Man.Name);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("㡫|業", AddKind.ValType));
  L_Basis.wb_WrNum(F, Adding.Value, 2);
  L_Basis.wb_WrScl(F, Adding._EDOrder);
  L_Basis.wb_WrStr(F, EDOrderSrcNum);
  L_Basis.wb_WrDat(F, EDOrderDate);
  L_Basis.wb_WrStr(F, L_Str.PoolItem("-|+", HasTransfer));
  L_Basis.wb_TermLine(F);
 END {MakePart};

 PRIVATE PROCEDURE _InOrder(B, E: DATE): SCAL[2];
 BEGIN
  IF Staff.BegDate > E THEN
   RETURN 0;
  END;
  L_Staff.PosToStaffLog(Staff.TSN, E, 1);
  RETURN L_Staff.OrderInIntvl(B, E);
 END {_InOrder};

 PRIVATE PROCEDURE MakeRep(BPer, EPer: DATE);
  VAR
   HasTransfer: SCAL[2];
 BEGIN
  FIO.Open(R, L_General.NameConnection("CAdd1"), "REP", Create);
  MakeHeader("R");
  SELECT(Adding, TSN);
  WHILE OCCURE(Adding) DO
   CHANGESEL(Adding, TSN, , Adding.TSN);
   PROMPT(Adding.TSN);
   WHILE OCCURE(Adding) DO
    CHANGESEL(Adding, TSN, , Adding.TSN, Adding.AddKind);
    WHILE OCCURE(Adding) DO
     IF L_DatTim.IsActiveInIntvl_Inc(BPer, EPer, Adding.From, Adding.UpTo) THEN
      CONFORM(Adding, Staff);
      IF _InOrder(BPer, Math.Min(EPer, Adding.UpTo)) THEN
       CONFORM(Adding, AddKind);
       CONFORM(StaffLog, Officer);
       CONFORM(Officer, Sort);
       CONFORM(Officer, Union);
       CONFORM(Staff, Man);
       HasTransfer:=(StaffLog.Date > Adding.From) & (StaffLog.Date >= BPer);
       IF ~!Adding._EDOrder &
          SEARCH(EDOrderL, EDOrder, Adding._EDOrder, Adding._Row) THEN
        CONFORM(EDOrderL, EDOrder);
        MakePart("R", EDOrder.SrcNum, EDOrder.Date, HasTransfer);
       ELSE
        MakePart("R", "", EMPTYOF(DATE), HasTransfer);
       END;
      END; (* IF *)
     END; (* IF *)
     NEXT(Adding);
    END; (* WHILE OCCURE(Adding) ... *)
    LAST(Adding);
    CHANGESEL(Adding, TSN, , Adding.TSN);
    NEXT(Adding);
   END; (* WHILE OCCURE(Adding) ... *)
   LAST(Adding);
   CHANGESEL(Adding, TSN);
   NEXT(Adding);
  END; (* WHILE OCCURE(Adding) ... *)
  FIO.Close(R);
 END {MakeRep};

(***************************)

(*
$P{ AddNTop:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
"᮪ ࠡ⭨,   " + AddKind.AddKind + " " + AddKind.Name, C , ""
?, C , ""
@
######################################################################### ########## #####
=#####====================================================================================
|########################################################################################|
|     ############################################################################       |
}

$P{ AddNSubTop:
Union.Union, L, ""
Union.Name, L, ""
AddKind.ValType, R, "㬬|%"
@
|----------------------------------------------------------------------------------------|
|⥣ ## ############################################################               |
|----------------------------------------------------------------------------------------|
|.                      |       |         |        |###########|ਪ |
|-----------------------------|----------------|----------|----------|-----------|-------|
}

$P{ AddNLine:
?, L, ""
?, L, ""
Post.Name, L, ""
ANtmp.From, L, "D.N.y"
ANtmp.UpTo, L, "D.N.y"
ANtmp.Value, R, "3."
ANtmp.EDOrder, L, ""
@
|##### #######################|################|##########|##########|###########|#######|
}

$P{ AddNBot:
@
=(c) Polak================================================================================
}
*)

 PRIVATE PROCEDURE PrepareANtmp(Cond: PROC);
 BEGIN
  L_AFM.MakeIndex("ANtmp", "Union  : LIKE(Union.Union);" +
                           "TSN    : LIKE(Staff.TSN);" +
                           "From   : LIKE(Adding.From);" +
                           "UpTo   : LIKE(Adding.UpTo);" +
                           "Value  : LIKE(Adding.Value);" +
                           "Post   : LIKE(Post.Post);" +
                           "EDOrder: LIKE(Adding._EDOrder)");
  SELECT(Adding, AddKind, , AddKind.AddKind);
  WHILE OCCURE(Adding) DO
   PROMPT(Adding.TSN);
   IF Cond() THEN
    CONFORM(StaffLog, Officer);
    ADD(ANtmp, ANtmp, , Officer.Union, Staff.TSN, Adding.From, Adding.UpTo,
                        Adding.Value, Officer.Post, Adding._EDOrder);
   END;
   NEXT(Adding);
  END; (* WHILE OCCURE(Adding) ... *)
 END {PrepareANtmp};

 PRIVATE PROCEDURE MakeAddN(RepName, RepSubtitle: STRING[]; Cond: PROC);
  VAR
   _TSN: LIKE(Staff.TSN);
 BEGIN
  SETEMPTY(_TSN);
  L_General.Assert(ACCESS(AddKind), " ⠭  ");
  PrepareANtmp(Cond);
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, AddNTop, RepName, RepSubtitle);
  SELECT(ANtmp, ANtmp);
  WHILE OCCURE(ANtmp) DO
   PROMPT(ANtmp.Union);
   CHANGESEL(ANtmp, ANtmp, , ANtmp.Union);
   SEARCH(Union, Union, , ANtmp.Union);
   MAKEPART(R, AddNSubTop);
   WHILE OCCURE(ANtmp) DO
    SEARCH(Post, Post, , ANtmp.Post);
    IF ANtmp.TSN = _TSN THEN
     MAKEPART(R, AddNLine);
    ELSE
     _TSN:=ANtmp.TSN;
     SEARCH(Staff, TSN, , _TSN);
     CONFORM(Staff, Man);
     MAKEPART(R, AddNLine, _TSN, Man.Name);
    END;
    NEXT(ANtmp);
   END; (* WHILE OCCURE(ANtmp) ... *)
   LAST(ANtmp);
   CHANGESEL(ANtmp, ANtmp);
   NEXT(ANtmp);
  END; (* WHILE OCCURE(ANtmp) ... *)
  MAKEPART(R, AddNBot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("ANtmp");
 END {MakeAddN};

 PRIVATE PROCEDURE Stand(D: DATE): SCAL[2];
 BEGIN
  CONFORM(Adding, Staff);
  IF Staff.BegDate > D THEN
   RETURN 0;
  END;
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  RETURN 1;
 END {Stand};

 PRIVATE PROCEDURE PeriodCond(): SCAL[2];
 BEGIN
  RETURN Stand(Memo.ud_ut()) &
         L_Staff.OrderInIntvl(Memo.ud_fr(), Memo.ud_ut()) &
         L_DatTim.IsActiveInIntvl_Inc(Adding.From, Adding.UpTo,
                                      Memo.ud_fr(), Memo.ud_ut());
 END {PeriodCond};

 PRIVATE PROCEDURE CurDateCond(): SCAL[2];
 BEGIN
  RETURN Stand(Memo.ud_cd()) &
         L_Staff.InOrder(Memo.ud_cd()) &
         L_DatTim.IsActive_Inc(Memo.ud_cd(), Adding.From, Adding.UpTo);
 END {CurDateCond};

BEGIN
 IF    MODE = 100 THEN
  MakeRep(Memo.ud_fr(), Memo.ud_ut());
 ELSIF MODE = 101 THEN
  MakeAddN("Addn0", " ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) +
                    "  " + L_DatTim.DateStr(Memo.ud_ut()),
           PROCREF(PeriodCond));
 ELSIF MODE = 102 THEN
  MakeAddN("Addn1", " " + L_DatTim.DateStr(Memo.ud_cd()),
           PROCREF(CurDateCond));
 ELSE
  L_General.BadMode(MODE);
 END;
END.
