(*
%Copyright   (c) Polak Computer System
%Author      16.04.2003 11:13:31 POLAK\RSN
%Purpose     ⭨,   稢 ப ⢨ 㤮⮢७
%Type        report
%Specific    SYS
%Modified    22.06.2012 14:43:29 POLAK\LDA
%Environment
*)

 MODULE DrvSert [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_OwnData, L_General, L_DatTim, L_AFM, P_Man, L_Env, L_Staff, E_Prop,
        Math, L_Str, Str, Memo, L_Man;

 PRIVATE CONST
  ObjectAbsent = " 㤮⮢७| ";

  obj_DrvSert      = 0;
  obj_DrvCLIPolicy = 1;
  obj_ForeignerLAL = 2;

  rt_Absentee = 0;
  rt_Elapsing = 1;
  rt_Present  = 2;

 PRIVATE VAR
  Object,
  RepType : SCAL[3];
  ByPeriod: SCAL[2];
  BDate,
  EDate   : DATE;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
#########################################################################           ########## #####
=#####==============================================================================================
|##################################################################################################|
}
*)

(*
$P{ LineSort:
Sort.Sort, L, ""
Sort.Name, L, ""
@
|--------------------------------------------------------------------------------------------------|
|  ### ##################################################                                    |
|--------------------------------------------------------------------------------------------------|
|. |                                             |      |      |ਬ砭           |
|     |                                                |뤠    |砭 |                     |
|-----|------------------------------------------------|----------|----------|---------------------|
}
*)

(*
$P{ Line:
Tmp.TSN, L, ""
Tmp.Name, L, ""
Tmp.DocGiveD, L, "D.N.y"
Tmp.DocExpD, L, "D.N.y"
Tmp.Value, L, ""
@
|#####|################################################|##########|##########|#####################|
}
*)

(*
$P{ TotalSort:
?, L, ""
@
|--------------------------------------------------------------------------------------------------|
|⮣  ᥪ ####                                                                             |
}
*)

(*
$P{ Bot:
@
=(c) Polak==========================================================================================
}
*)

 PRIVATE PROCEDURE Create_Tmp();
 BEGIN
  CreateFILE(Tmp, "", "", "");

  CreateFIELD(Tmp, TSN, LIKE(Staff.TSN), "", "", "", ".  ࠡ⭨", "");
  CreateFIELD(Tmp, Name, LIKE(Man.Name), "", "", "", " ", "");
  CreateFIELD(Tmp, DocGiveD, DATE, "", "", "", " 뤠 㤮⮢७", "");
  CreateFIELD(Tmp, DocExpD, DATE, "", "", "", " 砭 ⢨ ", "");
  CreateFIELD(Tmp, Value, LIKE(ManPro.Value), "", "", "", "㤮⮢७", "");
  CreateFIELD(Tmp, Sort, LIKE(Sort.Sort), "", "", "", "ᥪ", "");

  CreateINDEXandLINK(Tmp, Sort, PLURAL, Sort, Sort, USER, "", "", Sort, TSN);

  SetVersionOfFILE(Tmp, 0);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
 END {Create_Tmp};

 PRIVATE PROCEDURE PropCond(_Property: LIKE(Property.Property)): SCAL[2];
 BEGIN
  IF    RepType = rt_Present THEN
   RETURN P_Man.HasActualManPro(Man.Man,  EDate, _Property);
  ELSIF RepType = rt_Absentee THEN
   RETURN ~P_Man.HasActualManPro(Man.Man, EDate, _Property);
  ELSIF RepType = rt_Elapsing THEN
   RETURN P_Man.HasManPro(Man.Man, EDate, _Property) &
          L_DatTim.IsActive_Inc(ManPro.DocExpD, BDate, EDate);
  ELSE
   L_General.CallUs(0);
  END;
 END {PropCond};

 PRIVATE PROCEDURE StaffCond(): SCAL[2];
 BEGIN
  IF    Object = obj_ForeignerLAL THEN
   RETURN L_Man.LaborActivityLicenseRequired(Staff.Man, EDate);
  ELSE
   RETURN L_Env.IsDriver();
  END;
 END {StaffCond};

 PRIVATE PROCEDURE Do();
  VAR
   _Property: LIKE(Property.Property);
 BEGIN
  IF    Object = obj_DrvSert THEN
   _Property:=P_Man.P_DriveSertification;
  ELSIF Object = obj_DrvCLIPolicy THEN
   _Property:=E_Prop.P_CivilLiabilityInsurance;
  ELSIF Object = obj_ForeignerLAL THEN
   _Property:=P_Man.P_LaborActivityLicense;
  END;
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   PROMPT(Man.Man);
   SELECT(Staff, Man, , Man.Man);
   WHILE OCCURE(Staff) DO
    IF L_Staff.rInState(BDate) THEN
     L_Staff.PosToStaffLog(Staff.TSN, EDate, 1);
     CONFORM(StaffLog, Officer);
     IF StaffCond() & PropCond(_Property) THEN
      DEFAULT(Tmp);
      Tmp.TSN  :=StaffLog.TSN;
      Tmp.Name :=Man.Name;
      Tmp.Sort :=StaffLog.Sort;
      IF P_Man.HasManPro(Man.Man, EDate, _Property) THEN
       Tmp.DocGiveD:=ManPro.DocGiveD;
       Tmp.DocExpD :=ManPro.DocExpD;
       IF    Object = obj_DrvSert THEN
        Tmp.Value  :=FLDTOSTR(ManPro.Value, "", 5);
       END;
       Tmp.Value   :=Str.Condense(Tmp.Value + " " + ManPro.DocNum);
      ELSE
       Tmp.Value   :=L_Str.PoolItem(ObjectAbsent, Object);
      END;
      INSERT(Tmp);
     END;
    END;
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
 END {Do};

 PRIVATE PROCEDURE PrintRep();
  VAR
   Amount: NUMERIC[0];
 BEGIN
  SELECT(Tmp, Sort);
  WHILE OCCURE(Tmp) DO
   CHANGESEL(Tmp, Sort, , Tmp.Sort);
   CONFORM(Tmp, Sort);
   MAKEPART(R, LineSort);
   Amount:=0;
   WHILE OCCURE(Tmp) DO
    PROMPT(" " + Tmp.TSN);
    IF ~ByPeriod |
       ((Tmp.Value = L_Str.PoolItem(ObjectAbsent, Object)) |
        (L_DatTim.IsActive_Inc(Tmp.DocExpD, BDate, EDate))) THEN
     MAKEPART(R, Line);
     INC(Amount);
    END;
    NEXT(Tmp);
   END; (* WHILE OCCURE(Tmp) ... *)
   MAKEPART(R, TotalSort, Amount);
   LAST(Tmp);
   CHANGESEL(Tmp, Sort);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)
  MAKEPART(R, Bot);
 END {PrintRep};

 PRIVATE PROCEDURE MakeRep();
  VAR
   RepName,
   RepTitle: STRING[];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);
  IF    RepType = rt_Absentee THEN
   RepName :=L_Str.PoolItem("DrvSr|DrNCP|FLALN", Object);
   RepTitle:=L_Str.PoolItem("⥫,    㤮⮢७|" +
                            "⥫,    客 |" +
                            "࠭,    ࠢ  㤮 ⥫쭮", Object) +
             "  稢  ப  " + L_DatTim.DateStr(Memo.ud_cd());
   ByPeriod:=0;
   BDate   :=Memo.ud_cd();
   EDate   :=Memo.ud_cd();
  ELSIF RepType = rt_Elapsing THEN
   RepName :=L_Str.PoolItem("DrvSP|DrCPP|FLALP", Object);
   RepTitle:=L_Str.PoolItem("⥫,   稢 ப ⢨ 㤮⮢७|" +
                            "⥫,   稢 ப ⢨ 客 |" +
                            "࠭,   稢 ப ⢨ ࠢ  㤮 ⥫쭮", Object) +
             "  ਮ  " + L_DatTim.DateStr(Memo.ud_fr()) + "  " + L_DatTim.DateStr(Memo.ud_ut());
   ByPeriod:=1;
   BDate   :=Memo.ud_fr();
   EDate   :=Memo.ud_ut();
  ELSIF RepType = rt_Present THEN
   RepName :=L_Str.PoolItem("DrSrt|DrCLI|FLALL", Object);
   RepTitle:=L_Str.PoolItem("⥫ c 㤮⮢७ﬨ|" +
                            "⥫  客묨 ᠬ|" +
                            "࠭ c ࠢ  㤮 ⥫쭮", Object) +
             "  " + L_DatTim.DateStr(Memo.ud_cd());
   ByPeriod:=0;
   BDate   :=Memo.ud_cd();
   EDate   :=Memo.ud_cd();
  ELSE
   L_General.CallUs(0);
  END;

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName, RepTitle);
  Create_Tmp();
  Do();
  PrintRep();
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MakeRep};

 PUBLIC PROCEDURE DrvSr();
 BEGIN
  Object :=obj_DrvSert;
  RepType:=rt_Absentee;
  MakeRep();
 END {DrvSr};

 PUBLIC PROCEDURE DrvSP();
 BEGIN
  Object :=obj_DrvSert;
  RepType:=rt_Elapsing;
  MakeRep();
 END {DrvSP};

 PUBLIC PROCEDURE DrSrt();
 BEGIN
  Object :=obj_DrvSert;
  RepType:=rt_Present;
  MakeRep();
 END {DrSrt};

 PUBLIC PROCEDURE DrNCP();
 BEGIN
  Object :=obj_DrvCLIPolicy;
  RepType:=rt_Absentee;
  MakeRep();
 END {DrNCP};

 PUBLIC PROCEDURE DrCPP();
 BEGIN
  Object :=obj_DrvCLIPolicy;
  RepType:=rt_Elapsing;
  MakeRep();
 END {DrCPP};

 PUBLIC PROCEDURE DrCLI();
 BEGIN
  Object :=obj_DrvCLIPolicy;
  RepType:=rt_Present;
  MakeRep();
 END {DrCLI};

 PUBLIC PROCEDURE FLALN();
 BEGIN
  Object :=obj_ForeignerLAL;
  RepType:=rt_Absentee;
  MakeRep();
 END {FLALN};

 PUBLIC PROCEDURE FLALP();
 BEGIN
  Object :=obj_ForeignerLAL;
  RepType:=rt_Elapsing;
  MakeRep();
 END {FLALP};

 PUBLIC PROCEDURE FLALL();
 BEGIN
  Object :=obj_ForeignerLAL;
  RepType:=rt_Present;
  MakeRep();
 END {FLALL};

END.
