(*
%Copyright   (c) Polak Computer System
%Author      17.05.1995 12:51:21 SAN
%Purpose       ⮤  ⥪饣 
%Type        control
%Specific    SYS
%Modified    18.09.2013 10:51:28 POLAK\Gina
%Environment
*)

 MODULE MoneyMth [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_DatTim, L_General, L_Events, L_OwnData, Str, L_Str, L_Way, L_StdFrm, L_DBD, L_Adding, L_WDO;

 PRIVATE PROCEDURE SupportBeginTill();
  VAR
   curTill: DATE;
 BEGIN
  L_General.Assert(SELECT(MMthLog, MoneyMth, MoneyMth.Method),
                   "⮤      䨪");
  MoneyMth.Begin:=MMthLog.Date;
  REPLACE(MoneyMth);
  LAST(MMthLog);
  L_General.Assert(MMthLog.Date < MoneyMth.Till,
                   "|ਮ ⢨ ⮤  稢" +
                   "|  ᫥ 䨪樨");
  curTill:=MoneyMth.Till;
  WHILE OCCURE(MMthLog) DO
   MMthLog.Till:=curTill;
   REPLACE(MMthLog);
   curTill:=MMthLog.Date;
   PREV(MMthLog);
  END; (* WHILE OCCURE(MMthLog) ... *)
 END {SupportBeginTill};

 PUBLIC PROCEDURE NextLog();
  VAR
   curDate: LIKE(MMthLog.Date);
 BEGIN
  curDate:=Memo.ud_mb();
  L_StdFrm.Question(" 䨪  " + L_DatTim.PeriodStr(curDate));
  L_General.Assert(ACCESS(MMthLog), " ⠭ ⥪ 䨪");

  SAVE(MMthLog);
  CHANGESEL(MMthLog, MoneyMth, , MMthLog.Method);
  IF NEXT(MMthLog) THEN
   L_StdFrm.Choice("    ᫥ 䨪樨");
  ELSE
   L_General.Assert(curDate < MoneyMth.Till,
                    "⮤    " + L_DatTim.PeriodStr(curDate));
  END;
  L_General.Assert(~SRCINSEL(MMthLog, EQ, curDate),
                   "  䨪  " + L_DatTim.PeriodStr(curDate));
  RESTORE(MMthLog);

  CONFORM(MMthLog, MoneyRul);
  WHILE OCCURE(MoneyRul) DO
   SAVE(MoneyRul);
   MoneyRul.Date:=curDate;
   INSERT(MoneyRul);
   RESTORE(MoneyRul);
   NEXT(MoneyRul);
  END; (* WHILE OCCURE(MoneyRul) ... *)

  MMthLog.Method:=MoneyMth.Method;
  MMthLog.Date  :=curDate;
  INSERT(MMthLog);
  SE_WZD_POSITION(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number, MMthLog);
 END {NextLog};

 PUBLIC PROCEDURE NewVersion();
  CONST
   _Method = "XXXX";
 BEGIN
  L_StdFrm.Question(" ⮤");
  L_General.Assert(ACCESS(MoneyMth), " ⠭ ⥪騩 ⮤");
  SAVE(MoneyMth);
  L_General.Assert(~SEARCH(MoneyMth, MoneyMth, _Method),
                   "  ⮤   " + _Method);
  RESTORE(MoneyMth);
  SELECT(MMthLog, MoneyMth, , MoneyMth.Method);
  WHILE OCCURE(MMthLog) DO
   SAVE(MMthLog);
   CONFORM(MMthLog, MoneyRul);
   WHILE OCCURE(MoneyRul) DO
    SAVE(MoneyRul);
    MoneyRul.Method:=_Method;
    INSERT(MoneyRul);
    RESTORE(MoneyRul);
    NEXT(MoneyRul);
   END; (* WHILE OCCURE(MoneyRul ... *)
   MMthLog.Method:=_Method;
   INSERT(MMthLog);
   RESTORE(MMthLog);
   NEXT(MMthLog);
  END; (* WHILE OCCURE(MMthLog)... *)
  MoneyMth.Method:=_Method;
  MoneyMth.Name  :=_Method;
  INSERT(MoneyMth);
  SE_WZD_POSITION(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number, MoneyMth);
 END {NewVersion};

 PRIVATE PROCEDURE MoneyMth_OnAfterEditInsert();
 BEGIN
  SupportBeginTill();
  L_DBD.CheckOwnersValidity("MoneyMth");
 END {MoneyMth_OnAfterEditInsert};

 PRIVATE PROCEDURE MoneyMth_OnAfterEdit();
 BEGIN
  MoneyMth_OnAfterEditInsert();
 END {MoneyMth_OnAfterEdit};

 PRIVATE PROCEDURE MoneyMth_OnAfterInsert();
 BEGIN
  MoneyMth_OnAfterEditInsert();
 END {MoneyMth_OnAfterInsert};

 PRIVATE PROCEDURE CustomizeEdit();
 BEGIN
  L_General.Assert(ACCESS(MoneyMth), " ⠭ ⥪騩 ⮤");
  SETSEL(MMthLog, MoneyMth, MoneyMth.Method);
  IF LAST(MMthLog) THEN
   SE_WZD_POSITION(RTI.Get().CurWindow.Name, RTI.Get().CurZone.Number, MMthLog);
  END;
 END {CustomizeEdit};

 PRIVATE PROCEDURE MoneyMth_OnInitializeWindow();
 BEGIN
  L_WDO.iSubwindow   (1, "MMthE");
  IF L_WDO.IsLoadableAskClone() & (L_WDO.iWindow().AskSourceField.Name = "AddKind.Method") THEN
   L_WDO.iZone(1).Narrowing:="MoneyMth.MthType=89";
  END;
 END {MoneyMth_OnInitializeWindow};

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
@
############################################################################# ########## #####
=#####========================================================================================
|############################################################################################|
}
*)

(*
$P{ MthTypeTop:
@
|--------------------------------------------------------------------------------------------|
|                                     ௫                                  |
}
*)

(*
$P{ MthTypeLine:
MthType.MthType, L, ""
MthType.Name, L, ""
@
|--------------------------------------------------------------------------------------------|
|ਬ  㬮砭   ## ########################################################|
}
*)

(*
$P{ PayKindTop:
@
|--------------------------------------------------------------------------------------------|
|  ௫                                                        |      |     |
|----------------------------------------------------------------------------|-------|-------|
}
*)

(*
$P{ PayKindLine:
PayKind.PayKind, L, ""
PayKind.Name, L, ""
PayKind.Begin, L, "N.y"
PayKind.Till, L, "N.y"
@
|## #########################################################################|#######|#######|
}
*)

(*
$P{ AddKindTop:
@
|--------------------------------------------------------------------------------------------|
|                                                                                |
|--------------------------------------------------------------------------------------------|
|                                                         |     |      |     |
|-------------------------------------------------------------------|--------|-------|-------|
}
*)

(*
$P{ AddKindLine:
AddKind.AddKind, L, ""
AddKind.Name, L, ""
AddKind.ValType, L, L_Adding.vt_Pool
AddKind.Begin, L, "N.y"
AddKind.Till, L, "N.y"
@
|## ################################################################|########|#######|#######|
}
*)

(*
$P{ WJMethodTop:
@
|--------------------------------------------------------------------------------------------|
|                                 ࠡ  ⥢                               |
|--------------------------------------------------------------------------------------------|
| ࠡ                         || ࠡ              |⢮|      |     |
|-----------------------------------|----|--------------------------|--------|-------|-------|
}
*)

(*
$P{ WJMethodLine:
WJMethod.WJCode, L, ""
WJMode.Name, L, ""
L_Str.PoolItem(L_Way.rwswho_Pool_Short, WJMethod.Who), L, ""
WJMethod.JRegime, L, ""
JRegime.Name, L, ""
WJMethod.Quality, R, ""
WJMethod.Begin, L, "N.y"
WJMethod.Till, L, "N.y"
@
|## ################################|####|## #######################|########|#######|#######|
}
*)

(*
$P{ EDOKindTop:
@
|--------------------------------------------------------------------------------------------|
|                                 ਪ  ᮭ                                |
|--------------------------------------------------------------------------------------------|
|㯯  ਪ  | ਪ                                        |      |     |
|-----------------------|----------------------------------------------------|-------|-------|
}
*)

(*
$P{ EDOKindLine:
EDOKind.EDOGrp, L, ""
EDOGrp.Name, L, ""
EDOKind.EDOKind, L, ""
EDOKind.Name, L, ""
EDOKind.Begin, L, "N.y"
EDOKind.Till, L, "N.y"
@
|## ####################|### ################################################|#######|#######|
}
*)

(*
$P{ Bot:
@
=(c) Polak====================================================================================
}
*)

 PUBLIC PROCEDURE C_Mth();
  CONST
   RepName = "C_Mth";
  VAR
   MthTypeTopMaked,
   Total          : SCAL[2];
   OnDate         : DATE;
   MethodAsStr    : STRING[];
 BEGIN
  SE_ACCESSDATAMODE(AccessDataMode_SOFT);

  L_General.Assert(ACCESS(MoneyMth), " ⠭ ⮤");

  MethodAsStr:=MoneyMth.Method + " " + MoneyMth.Name;
  OnDate:=Memo.ud_mb();
  Total :=L_StdFrm.ShowListAsMenu("  (" + L_DatTim.DateStr(OnDate) + ")| ",
                                  " ᯮ짮 ⮤ ");
  OPENREP(R, L_General.NameConnection(RepName), Create);
  IF Total THEN
   MAKEPART(R, Top, RepName, "ᯮ짮 ⮤ '" + MethodAsStr + "' ( )" );
  ELSE
   MAKEPART(R, Top, RepName, "ᯮ짮 ⮤ '" + MethodAsStr + "'  " + L_DatTim.DateStr(OnDate));
  END;

  MthTypeTopMaked:=0;
  IF (Str.Slice(MoneyMth.Method, 2, 2) = "00") &
     (Str.Slice(MoneyMth.Method, 0, 2) = FLDTOSTR(MoneyMth.MthType)) &
     (Total | L_DatTim.IsActive(OnDate, MoneyMth.Begin, MoneyMth.Till)) THEN
   CONFORM(MoneyMth, MthType);
   MAKEPART(R, MthTypeTop);
   MAKEPART(R, MthTypeLine);
   MthTypeTopMaked:=1;
  END;

  IF SELECT(Methods, MoneyMth, MoneyMth.Method) THEN
   IF ~MthTypeTopMaked THEN
    MAKEPART(R, MthTypeTop);
   END;
   MAKEPART(R, PayKindTop);
   WHILE OCCURE(Methods) DO
    CONFORM(Methods, PayKind);
    IF Total | L_DatTim.IsActive(OnDate, PayKind.Begin, PayKind.Till) THEN
     MAKEPART(R, PayKindLine);
    END;
    NEXT(Methods);
   END; (* WHILE OCCURE(Methods) ... *)
  END;

  IF SELECT(AddKind, MoneyMth, MoneyMth.Method) THEN
   MAKEPART(R, AddKindTop);
   WHILE OCCURE(AddKind) DO
    MAKEPART(R, AddKindLine);
    NEXT(AddKind);
   END; (* WHILE OCCURE(AddKind) ... *)
  END;

  IF SELECT(WJMethod, MoneyMth, MoneyMth.Method) THEN
   MAKEPART(R, WJMethodTop);
   WHILE OCCURE(WJMethod) DO
    IF Total | L_DatTim.IsActive(OnDate, WJMethod.Begin, WJMethod.Till) THEN
     CONFORM(WJMethod, WJMode);
     CONFORM(WJMethod, JRegime);
     MAKEPART(R, WJMethodLine);
    END;
    NEXT(WJMethod);
   END; (* WHILE OCCURE(WJMethod) ... *)
  END;

  IF SELECT(EDOKind, MoneyMth, MoneyMth.Method) THEN
   MAKEPART(R, EDOKindTop);
   WHILE OCCURE(EDOKind) DO
    IF Total | L_DatTim.IsActive(OnDate, EDOKind.Begin, EDOKind.Till) THEN
     CONFORM(EDOKind, EDOGrp);
     MAKEPART(R, EDOKindLine);
    END;
    NEXT(EDOKind);
   END; (* WHILE OCCURE(EDOKind) ... *)
  END;

  MAKEPART(R, Bot);
  CLOSEREP(R);
 END {C_Mth};

BEGIN
 L_Events.ExecuteHandler();
END.
