(*
%Copyright   (c) Polak IT
%Author      20.05.2003 13:04:52 POLAK\LDA
%Purpose
%Type        control
%Specific    SYS
%Modified    11.04.2014 16:46:44 POLAK\Gina
%Environment
*)

 MODULE PDocExAb [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_Events, L_Str, L_ExtAb, L_WDO, Str, L_StdFrm;

 PRIVATE PROCEDURE ExtForPayP(): SCAL[2];
 BEGIN
  RETURN RTI.Get().CurWindow.OriginalName = "PayPLSE";
 END {ExtForPayP};

 PRIVATE PROCEDURE SetFieldStatus();
  VAR
   Field           : FORM_FIELD;
   Fields          : FORM_FIELDS;
   trgModifiable   : SCAL[2];
   DocDateFieldName: STRING[];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;

  trgModifiable:=!L_WDO.GetEnvVarValue("ViewOnly");
  IF trgModifiable THEN
   IF ~ExtForPayP() THEN
    DocDateFieldName:="DocDate";
    Fields("Code").Modifiable:=PDoc.Date>=31\03\2014;
   ELSE
    DocDateFieldName:="DocDateAsStr";
   END;
 
   Fields("Former").Modifiable        :=1;
   Fields("Period_Type").Modifiable   :=0;
   Fields("Period").Modifiable        :=1;
   Fields("DocNbr").Modifiable        :=0;
   Fields(DocDateFieldName).Modifiable:=0;
 
   IF ~!Fields("Reason").Value THEN
    IF    Fields("Reason").Value = 0 THEN
     Fields("Period_Type").Modifiable   :=1;
     Fields("DocNbr").Modifiable        :=1;
     Fields(DocDateFieldName).Modifiable:=1;
    ELSIF Fields("Reason").Value = 1 THEN
     Fields("Period_Type").Modifiable   :=1;
     Fields(DocDateFieldName).Modifiable:=1;
    ELSIF Fields("Reason").Value = 2 THEN
     Fields("Period_Type").Modifiable   :=1;
     Fields(DocDateFieldName).Modifiable:=0;
    ELSIF (Fields("Reason").Value = 9) | (Fields("Reason").Value = 10) THEN
     Fields(DocDateFieldName).Modifiable:=1;
     Fields("DocNbr").Modifiable        :=1;
    ELSE
     Fields("Period").Modifiable        :=1;
     Fields(DocDateFieldName).Modifiable:=1;
     Fields("DocNbr" ).Modifiable       :=1;
    END;
   ELSE
    Fields("Period").Modifiable:=0;
   END;
   IF (Fields("Period_Type").Value = 0) | !Fields("Period_Type").Value THEN
    Fields("Period").Modifiable:=0;
   END;
  ELSE
   FOR_EACH Field IN RTI.Get().CurWindow.Zones(0).Fields DO
    Field.Modifiable:=trgModifiable;
   END;
  END;

  IF ~!Fields("Period_Type").Value THEN
   Fields("Period_Prefix").Value:=L_Str.AnyItem(L_ExtAb.Period_Type_Pool_Short, "|", Fields("Period_Type").Value);
   IF Fields("Period_Prefix").Value # " " THEN
    Fields("Period_Prefix").Value:=Fields("Period_Prefix").Value+".";
   END;
  ELSE
   Fields("Period_Prefix").Value:=" ";
  END;

  IF ~ExtForPayP() & ~!Fields("Period_Type").Value THEN
   Fields("Period").Format:=L_Str.PoolItem(L_ExtAb.PeriodFormat_Pool, Fields("Period_Type").Value);
  ELSE
   Fields("Period").Format:="";
  END;
 END {SetFieldStatus};

 PRIVATE PROCEDURE SetExtAbFormats(FormerPoolAdd: STRING[]);
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Former").Template        :=L_ExtAb.Former_Pool + FormerPoolAdd;
  Fields("Former").TemplateIsStrict:=1;
  Fields("Reason").Format          :=L_ExtAb.Reason_Pool;
  Fields("Period_Type").Format     :=L_ExtAb.Period_Type_Pool;
  Fields("PaymentType").Format     :=L_ExtAb.PaymentType_Pool;
  SetFieldStatus();
 END {SetExtAbFormats};

 PRIVATE PROCEDURE AnyReason_OnSuccessfulChange();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  SETEMPTY(Fields("Period_Type").Value, Fields("Period").Value, Fields("DocNbr").Value);
  IF ~ExtForPayP() THEN
   SETEMPTY(Fields("DocDate").Value);
  ELSE
   SETEMPTY(Fields("DocDateAsStr").Value);
  END;

  IF    Fields("Reason").Value = 0 THEN
   Fields("Period_Type").Value:=0;
  ELSIF (Fields("Reason").Value = 1) | (Fields("Reason").Value = 2) THEN
   Fields("DocNbr").Value:="0";
  ELSIF (Fields("Reason").Value = 9) | (Fields("Reason").Value = 10) THEN
   SETEMPTY(Fields("Period_Type").Value, Fields("DocNbr").Value);
   Fields("Period_Type").Value:=0;
   Fields("Period").Value     :="0";
  ELSE
   Fields("Period_Type").Value:=1;
   SETEMPTY(Fields("DocNbr").Value);
  END;
  SetFieldStatus();
 END {AnyReason_OnSuccessfulChange};

 PRIVATE PROCEDURE PDoc_Reason_OnSuccessfulChange();
 BEGIN
  AnyReason_OnSuccessfulChange();
 END {PDoc_Reason_OnSuccessfulChange};

 PRIVATE PROCEDURE PayP_Reason_OnSuccessfulChange();
 BEGIN
  AnyReason_OnSuccessfulChange();
 END {PayP_Reason_OnSuccessfulChange};

 PRIVATE PROCEDURE AnyPeriod_Type_OnSuccessfulChange();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  SETEMPTY(Fields("Period").Value);
  IF ~!Fields("Period_Type").Value & (Fields("Period_Type").Value = 0) THEN
   Fields("Period").Value:="0";
  END;
  SetFieldStatus();
 END {AnyPeriod_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE PDoc_Period_Type_OnSuccessfulChange();
 BEGIN
  AnyPeriod_Type_OnSuccessfulChange();
 END {PDoc_Period_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE PayP_Period_Type_OnSuccessfulChange();
 BEGIN
  AnyPeriod_Type_OnSuccessfulChange();
 END {PayP_Period_Type_OnSuccessfulChange};

 PRIVATE PROCEDURE GetExtAbout(): STRING[];
  VAR
   Idx     : NUMERIC[0];
   Fields  : FORM_FIELDS;
   curPaymentType,
   curCode,
   _DocNbr,
   _Period,
   _DocDate: STRING[];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  IF !Fields("DocNbr").Value THEN
   _DocNbr:="0";
  ELSE
   _DocNbr:=Fields("DocNbr").Value;
  END;
  IF ~ExtForPayP() THEN
   IF !Fields("DocDate").Value THEN
    _DocDate:="0";
   ELSE
    _DocDate:=FLDTOSTR(Fields("DocDate").Value, "D.N.y");
   END;
  ELSE
   IF !Fields("DocDateAsStr").Value THEN
    _DocDate:="0";
   ELSE
    _DocDate:=Fields("DocDateAsStr").Value;
   END;
  END;

  IF ~ExtForPayP() THEN
   IF    Fields("Period_Type").Value = 0 THEN
    _Period:="0";
   ELSIF Fields("Period_Type").Value = 1 THEN
    _Period:=FLDTOSTR(Fields("Period").Value, L_Str.PoolItem(L_ExtAb.PeriodFormat_Pool, Fields("Period_Type").Value));
   ELSE
    _Period:=L_Str.AnyItem(L_ExtAb.Period_Type_Pool_Short, "|", Fields("Period_Type").Value) +
                           "."+
                           FLDTOSTR(Fields("Period").Value, L_Str.PoolItem(L_ExtAb.PeriodFormat_Pool, Fields("Period_Type").Value));
   END;
   L_ExtAb.CheckSpecialDateValue(Fields("Period_Type").Value, _Period);
   curCode:=Fields("Code").Value;
   IF (PDoc.Date>=31\03\2014) & !curCode THEN
    L_StdFrm.WrongDB("    .  ⢨ , 室 㪠 祭 '0'");
   END;
   IF Str.Length(curCode) > 20 THEN
    L_StdFrm.WrongDB("      20 ᨬ,       "+L_Str.IntStr(Str.Length(curCode)));
   END;
  ELSE
   IF    Fields("Period_Type").Value = 0 THEN
    _Period:="0";
   ELSIF Fields("Period_Type").Value = 1 THEN
    _Period:=Fields("Period").Value;
   ELSE
    _Period:=L_Str.AnyItem(L_ExtAb.Period_Type_Pool_Short, "|", Fields("Period_Type").Value) +
                           "."+Fields("Period").Value;
   END;
   curCode:="";
  END;
  Idx:=L_Str.PositionInPool(L_ExtAb.Former_Pool + "|" + L_ExtAb.Former_PayPTemplate, Fields("Former").Value);

  curPaymentType:=L_Str.PoolItem(L_ExtAb.PaymentType_Pool_Short, Fields("PaymentType").Value);
  IF (curPaymentType # "0") & (curPaymentType # "") & (curPaymentType # "") THEN
   L_StdFrm.WrongDB(" 02.2014   '110  ⥦' ᪠ ⮫쪮 祭 '0', ''  ''");
  END;

  RETURN L_Str.PoolItem(L_ExtAb.Former_Pool_Short + "|" + L_ExtAb.Former_PayPTemplate, Idx) + ";" +
         Fields("KBK").Value    + ";" +
         Fields("OKATO").Value  + ";" +
         L_Str.PoolItem(L_ExtAb.Reason_Pool_Short, Fields("Reason").Value) + ";" +
         _Period  + ";" +
         _DocNbr  + ";" +
         _DocDate + ";" +
         curPaymentType + ";" +
         curCode;
 END {GetExtAbout};

 PRIVATE PROCEDURE PDocExAb_0_OnReposition();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_ExtAb.DecodePDocExtAbout(PDoc.ExtAbout,
                             Fields("Former").Value, Fields("KBK").Value, Fields("OKATO").Value,
                             Fields("Reason").Value, Fields("Period_Type").Value, Fields("Period").Value,
                             Fields("DocNbr").Value, Fields("DocDate").Value, Fields("PaymentType").Value,
                             Fields("Code").Value);
  SetExtAbFormats("");
 END {PDocExAb_0_OnReposition};

 PRIVATE PROCEDURE PDoc_OnBeforeEdit();
 BEGIN
  L_General.Assert(!L_WDO.GetEnvVarValue("ViewOnly"), "  㯭 ");
 END {PDoc_OnBeforeEdit};

 PRIVATE PROCEDURE PDoc_OnAfterEdit();
 BEGIN
  PDoc.ExtAbout:=GetExtAbout();
  REPLACE(PDoc);
 END {PDoc_OnAfterEdit};

 PRIVATE PROCEDURE PayPLSE_0_OnReposition();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_ExtAb.DecodePayPLSExt(PayP.PayLSExt,
                          Fields("Former").Value, Fields("KBK").Value, Fields("OKATO").Value,
                          Fields("Reason").Value, Fields("Period_Type").Value, Fields("Period").Value,
                          Fields("DocNbr").Value, Fields("DocDateAsStr").Value, Fields("PaymentType").Value);

  Fields("KBK").Template   :="\MDoc.Contract.7322.KBK|";
  Fields("OKATO").Template :="\MDoc.Contract.7322.OKATO|";
  Fields("Period").Template:="\MDoc.Date^mm|"+
                             "\MDoc.Date^mm.yyyy|"+
                             "\MDoc.Date^qq.yyyy|"+
                             "\MDoc.Date^yyyy||";
  SetExtAbFormats("|" + L_ExtAb.Former_PayPTemplate);
 END {PayPLSE_0_OnReposition};

 PRIVATE PROCEDURE PayP_OnBeforeEdit();
 BEGIN
  L_General.Assert(!L_WDO.GetEnvVarValue("ViewOnly"), "  㯭 ");
 END {PayP_OnBeforeEdit};

 PRIVATE PROCEDURE PayP_OnAfterEdit();
 BEGIN
  PayP.PayLSExt:=GetExtAbout();
  REPLACE(PayP);
 END {PayP_OnAfterEdit};

BEGIN
 L_Events.ExecuteHandler();
END.
