(*
%Copyright   (c) Polak IT
%Author      15.12.2002 11:31:24 POLAK\GAV
%Purpose     ⥦ 㬥  ⠡쭮.
%Type        report
%Specific    SYS
%Modified    10.04.2012 12:25:15 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_OwnData, L_General, L_PDoc, L_DatTim, L_AFM, Memo, L_XDoc, Str;

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
Staff.TSN, L, ""
Man.Name, L, ""
@
################################################################## ########## #####
=#####=============================================================================
|#################################################################################|
|---------------------------------------------------------------------------------|
| ##### ####################################################                      |
}

$P{ DestTop:
Dest.Dest, L, ""
Dest.Name, L, ""
@
|---------------------------------------------------------------------------------|
| 樨 ### ################################################                |
|---------------------------------------------------------------------------------|
|      |㬥   |祭                         ||||       㬬|
|----------|-----------|-----------------------------------|---|---|-|------------|
}

$P{ Line:
PDoc.Date, L, "D.N.y"
L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc), L, ""
L_PDoc.PDocAbout(PDoc.PDocKind, PDoc.PDoc), L, ""
PDoc.Type, L, "||"
Tmp.State, C, "|-|"
PDoc.Done, L, " |"
Tmp.Sum, R, ",2-"
@
|##########|###########|###################################|###|###|#|############|
}

$P{ DestBot:
?, R, ",2-"
@
|--------------------------------------------------------------------|------------|
| ⮣   樨                                             |############|
}

$P{ Bot:
@
=(c) Polak=========================================================================
}
*)

 PRIVATE PROCEDURE CreateTmp();
 BEGIN
  CreateFILE(Tmp, "", "⥦ 㬥", "");

  CreateFIELD(Tmp, Date,     DATE,                 "", "", "", "", "");
  CreateFIELD(Tmp, PDoc,     LIKE(PDoc.PDoc),      "", "", "", "", "");
  CreateFIELD(Tmp, PDocKind, LIKE(PDoc.PDocKind),  "", "", "", "", "");
  CreateFIELD(Tmp, State,    LIKE(PDocList.State), "", "", "", "", "");
  CreateFIELD(Tmp, Dest,     LIKE(PDoc.Dest),      "", "", "", "", "");
  CreateFIELD(Tmp, Sum,      NUMERIC[2],           "", "", "", "", "");

  CreateINDEX(Tmp, Tmp, UNIQUE, "", "", Dest, Date, PDocKind, PDoc, State);

  SetVersionOfFILE(Tmp, 0);
  L_AFM.AF_CreateTemp("Tmp", "Tmp");
 END {CreateTmp};

 PRIVATE PROCEDURE MakeRep(RepName: STRING[]; Salary, OnMonth: SCAL[2]);
  VAR
   Title: STRING[];
   _Sum : NUMERIC[2];
 BEGIN
  L_General.Assert(ACCESS(Staff), " ⠭ ࠡ⭨");
  CONFORM(Staff, Man);
  CreateTmp();

  SELECT(PDocList, TSN, , Staff.TSN);
  IF OnMonth THEN
   SRCINSEL(PDocList, GE, , Memo.ud_mb());
  END;
  WHILE OCCURE(PDocList) & (~OnMonth | (PDocList.PDocDate <= Memo.ud_me())) DO
   PROMPT(L_DatTim.DateStr(PDocList.PDocDate) + " " + PDocList.PDocKind);
   CONFORM(PDocList, PDoc);
   IF ~!PDoc.Dest (* Dest    PDoc*) &
      (PDoc.Status # L_PDoc.st_Canceled) &
      (L_PDoc.IsSalaryDest(PDoc.Dest) = Salary) THEN
    ADD(Tmp, Tmp, , PDoc.Dest, PDoc.Date, PDoc.PDocKind, PDoc.PDoc, PDocList.State,
                    Tmp.Sum, PDocList.Sum);
   END;
   NEXT(PDocList);
  END; (* WHILE OCCURE(PDocList) ... *)

  OPENREP(R, L_General.NameConnection(RepName), Create);
  Title:="⥦ 㬥";
  IF Salary THEN
   Title:=Title + "  ௫";
  ELSE
   Title:=Title + "   ௫";
  END;
  IF OnMonth THEN
   Title:=Title + "  " + L_DatTim.PeriodStr(Memo.ud_mb());
  END;
  L_XDoc.sl_Init(Title);
  MAKEPART(R, Top, RepName, Title);
  SELECT(Tmp, Tmp);
  WHILE OCCURE(Tmp) DO
   PROMPT(Tmp.Dest);
   SEARCH(Dest, Dest, , Tmp.Dest);
   MAKEPART(R, DestTop);
   _Sum:=0;
   CHANGESEL(Tmp, Tmp, , Tmp.Dest);
   WHILE OCCURE(Tmp) DO
    SEARCH(PDoc, PDoc, , Tmp.PDocKind, Tmp.PDoc);
    IF Tmp.State = L_PDoc.pdl_st_Paid THEN
     INC(_Sum, Tmp.Sum);
    END;
    L_XDoc.sl_AddItem(L_XDoc.XDocId(L_XDoc.xdt_PDoc, PDoc.PDocKind, PDoc.PDoc),
                      L_PDoc.PDocStr(PDoc.PDocKind, PDoc.PDoc) +
                      " " + L_DatTim.DateStr(PDoc.Date) +
                      " " + Str.Align(L_PDoc.PDocAbout(PDoc.PDocKind, PDoc.PDoc), 30, LEFT) +
                      " " + FLDTOSTR(Tmp.Sum, "2-", 12));
    MAKEPART(R, Line);
    NEXT(Tmp);
   END; (* WHILE OCCURE(Tmp) ... *)
   MAKEPART(R, DestBot, _Sum);
   LAST(Tmp);
   CHANGESEL(Tmp, Tmp);
   NEXT(Tmp);
  END; (* WHILE OCCURE(Tmp) ... *)

  MAKEPART(R, Bot);
  L_AFM.AF_PurgeTemp("Tmp");
  CLOSEREP(R);
  L_XDoc.sl_Done();
 END {MakeRep};

BEGIN
 IF    MODE = 100 THEN
  MakeRep("PSTSN", 1, 0);
 ELSIF MODE = 101 THEN
  MakeRep("PSTSM", 1, 1);
 ELSIF MODE = 102 THEN
  MakeRep("PATSN", 0, 0);
 ELSIF MODE = 103 THEN
  MakeRep("PATSM", 0, 1);
 ELSE
  L_General.BadMode(MODE);
 END;
END.