(*
%Copyright   (c) Polak IT
%Author      22.04.2003 13:41:41 POLAK\GINA
%Purpose     ⮪ 㤥ঠ
%Type        report
%Specific    SYS
%Modified    23.07.2014 17:57:27 POLAK\Bor
%Environment
*)

 MODULE PrcDed [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Sheet, L_OwnData, L_Str, Math, L_PRoll, L_AFM, Memo;

 PRIVATE VAR
  _Money : NUMERIC[2][2];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_fr(), L, "N.y"
Memo.ud_ut(), L, "N.y"
Staff.TSN, L, ""
Man.Name, L, ""
Deduct.DedNbr, L, ""
DedType.DedType, L, ""
DedType.Name, L, ""
Deduct.BegDate, L, "D.N.y"
Deduct.EndDate, L, "D.N.y"
DedType.BaseNo, R, "㬬|業|業|業|業|業|業|業|業|業"
@
################################################################ ########## #####
=#####===========================================================================
|           ⮪  㤥ঠ  ਮ  #######  #######           |
|-------------------------------------------------------------------------------|
|⭨ ##### ################################################################|
|ঠ  ##  ## #########################################################|
|            ##########  ##########                                 |
|-------------------------------------------------------------------------------|
|  |ࠡ| ᫥|  ঠ|   |##########|     㬬|  ⮢|
|       | |          |          | 㤥ঠ|          | 㤥ঠ|      ᡮ|
|-------|-----|----------|----------|----------|----------|----------|----------|
}
*)

(*
$P{ Line:
DedAcnt.Period, L, "N.y"
GetWorkDays(DedAcnt.Period), R, ""
_Money[0], R, "2-"
_Money[1], R, "2-"
_Money[0]-_Money[1], R, "2-"
DedAcnt.ToPay, R, "2."
DedAcnt.NetDebt, R, "2-"
DedAcnt.TotDebt-DedAcnt.NetDebt, R, "2-"
@
|#######|#####|##########|##########|##########|##########|##########|##########|
}
*)

(*
$P{ Bot:
@
=(c) Polak=======================================================================
}
*)

(*
$P{ TopAll:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
Memo.ud_mb(), L, "N.y"
L_DatTim.MonthLen(Memo.ud_mb()), L, "0"
DedType.DedType, L, ""
?, L, ""
@
###########################################################################                                                                                                            ########## #####
=#####=================================================================================================================================================================================================
| ᫥  ####### (## .)  ⨯ 㤥ঠ ## ##############################################################                                                                                  |
}
*)

(*
$P{ TopAllFirm:
Firm.Firm, L, ""
Firm.Name, L, ""
@
|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|ࠣ #### - ##########################################                                                                                                                                         |
|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|. |                 | ᫥|  ঠ|      |    %||ࠡ|.|ࠡ|४|    㬬|               |                |                                      |
|-----|--------------------|----------|----------|----------|-----|--|-------|-------|-------|---------|---------|-------------------|--------------------|-------------------------------------------|
}
*)

(*
$P{ LineAll:
Deduct.TSN, L, ""
L_Str.ShortName(Man.Name), L, ""
_Money[0], R, "2-"
_Money[1], R, "2-"
_Money[0]-_Money[1], R, "2-"
GetPrc(), R, "2."
L_DatTim.DATEINT(Deduct.BegDate, Deduct.EndDate, Memo.ud_mb(), Memo.ud_me()), R, "0"
PCalc.TimDone, R, "3."
PCalc.CorBal, R, "3."
Math.Max(PCalc.CorBal - PCalc.TimDone, 0), R, "3."
DedAcnt.Corr, R, "2-"
DedAcnt.NetDebt, R, "2-"
L_Str.ShortName(Deduct.Person), L, ""
Deduct.PCode, L, ""
Deduct.PAddr[0], L, ""
@
|#####|####################|##########|##########|##########|#####|##|#######|#######|#######|#########|#########|###################|####################|###########################################|
}
*)

(*
$P{ BotAll:
@
=(c) Polak=============================================================================================================================================================================================
}
*)

 PRIVATE PROCEDURE GetPrc(): LIKE(DedAcnt.ToPay);
 BEGIN
  IF DedType.BaseNo>L_PRoll.dtbn_Sum THEN
   RETURN DedAcnt.ToPay;
  ELSE
   RETURN EMPTYOF(DedAcnt.ToPay);
  END;
 END {GetPrc};

 PRIVATE PROCEDURE GetMoney(P: DATE);
 BEGIN
  SETZERO(_Money);
  IF (DedType.BaseNo # L_PRoll.dtbn_OnRest) & (DedType.BaseNo # L_PRoll.dtbn_OnDept) THEN
   SELECT(Money, TSN, , Deduct.TSN, P);
   WHILE OCCURE(Money) DO
    CONFORM(Money, MCList);
    IF MCList.ForDed[DedType.BaseNo] | (DedType.BaseNo=L_PRoll.dtbn_Sum) THEN
     INC(_Money[MCList.MCTyp], Money.Sum);
    END;
    NEXT(Money);
   END; (* WHILE OCCURE(Money) ... *)
  END;
 END {GetMoney};

 PRIVATE PROCEDURE GetWorkDays(P: DATE): NUMERIC[0];
  VAR
   _Day: NUMERIC[0];
 BEGIN
  _Day:=0;
  SETSEL(Sheet, TSN, Deduct.TSN, P);
  FOR_EACH Sheet DO
   CONFORM(Sheet, JMode);
   IF JMode.Type=L_Sheet.jmType_TimDone THEN
    INC(_Day);
   END;
  END; (* FOR_EACH Sheet *)
  RETURN _Day;
 END {GetWorkDays};

 PUBLIC PROCEDURE PrcSg();
  CONST
   RepName = "PrcSg";
 BEGIN
  APP.Get().NewPrompt("("+RepName+")");
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Deduct), " ⠭ 㤥ঠ");
  L_DatTim.CheckWMIntvl(Memo.ud_fr(), Memo.ud_ut());
 
  CONFORM(Deduct, DedType);
  CONFORM(Deduct, Staff);
  CONFORM(Staff, Man);

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top, RepName);
 
  SETSEL(DedAcnt, TSN, Deduct.TSN, Deduct.DedNbr);
  SRCINSEL(DedAcnt, GE, , L_DatTim.MonthBeg(Memo.ud_fr()));
  WHILE OCCURE(DedAcnt) & (DedAcnt.Period<= L_DatTim.MonthEnd(Memo.ud_ut())) DO
   PROMPT(L_DatTim.PeriodStr(DedAcnt.Period));
   GetMoney(DedAcnt.Period);
   MAKEPART(R, Line);
   NEXT(DedAcnt);
  END; (* WHILE OCCURE(DedAcnt) ... *)
 
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {PrcSg};

 PRIVATE PROCEDURE MakeRep(RepName: STRING[]; w_Arr: SCAL[2]);
  VAR
   First  : SCAL[2];
   Title  : STRING[];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  APP.Get().NewPrompt("("+RepName+")");

  L_General.Assert(ACCESS(DedType), " ⠭ ⨯ 㤥ঠ");
  Title:=DedType.Name;
  IF w_Arr THEN
   Title:=Title + " ( ᮭ  ࠡ⪮)"
  END;

  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, TopAll, RepName, Title);

  L_AFM.MakeIndex("Tmp01", "Firm  : LIKE(Deduct.Firm);"+
                           "TSN   : LIKE(Deduct.TSN);"+
                           "DedNbr: LIKE(Deduct.DedNbr)");
  SELECT(Deduct, DedType, , DedType.DedType);
  WHILE OCCURE(Deduct) DO
   PROMPT(" "+Deduct.TSN);
   IF SEARCH(DedAcnt, TSN, Deduct.TSN, Deduct.DedNbr, Memo.ud_mb()) &
      (DedAcnt.NetDebt > 0) THEN
    CONFORM(Deduct, Staff);
    L_PRoll.CheckSalDone(Memo.ud_mb());
    Tmp01.Firm  :=Deduct.Firm;
    Tmp01.TSN   :=Deduct.TSN;
    Tmp01.DedNbr:=Deduct.DedNbr;
    INSERT(Tmp01);
   END;
   NEXT(Deduct);
  END; (* WHILE OCCURE(Deduct) ... *)

  SELECT(Tmp01, Tmp01);
  WHILE OCCURE(Tmp01) DO
   First:=1;
   NARROWSEL(Tmp01, Firm);
   SEARCH(Firm, Firm, , Tmp01.Firm);
   WHILE OCCURE(Tmp01) DO
    PROMPT(" "+Tmp01.TSN);
    SEARCH(Staff, TSN, , Tmp01.TSN);
    L_General.Assert(L_PRoll.SrcPCalc(Memo.ud_mb()),
                     "  ப 楢   " +
                     L_DatTim.PeriodStr(Memo.ud_mb()));
    IF ~w_Arr | (PCalc.TimDone < PCalc.CorBal) THEN
     IF First THEN
      MAKEPART(R, TopAllFirm);
      First:=0;
     END;
     SEARCH(Deduct, TSN, , Tmp01.TSN, Tmp01.DedNbr);
     SEARCH(DedAcnt, TSN, , Tmp01.TSN, Tmp01.DedNbr, Memo.ud_mb());
     CONFORM(Staff, Man);
     GetMoney(Memo.ud_mb());
     MAKEPART(R, LineAll);
    END;
    NEXT(Tmp01);
   END; (* WHILE OCCURE(Tmp01) ... *)
   NEXTINEXTENDEDSEL(Tmp01, Firm);
  END; (* WHILE OCCURE(Tmp01) ... *)

  MAKEPART(R, BotAll);
  CLOSEREP(R);
  L_General.SurveyLastReport();
 END {MakeRep};

 PUBLIC PROCEDURE PrcDD();
 BEGIN
  MakeRep("PrcDD", 0);
 END {PrcDD};

 PUBLIC PROCEDURE PrcDL();
 BEGIN
  MakeRep("PrcDL", 1);
 END {PrcDL};

END.
