(*
%Copyright   (c) Polak IT
%Author      03.12.2002 10:50:34 POLAK\GAV
%Purpose       xls  BASIS
%Type        operation
%Specific    SYS
%Modified    10.04.2012 12:28:05 ROBOT by POLAK\LDA
%Environment
*)

 IMPORT L_General, Str, L_Str, FIO, DBD, L_Basis, L_DatTim, L_Prop;

 VAR
  fso        : OBJECT;
  SrcFolders : ENUMERATOR;
  CleanedSize: NUMERIC[0];

 PRIVATE PROCEDURE CleanFilesInFolder(SrcFold: OBJECT; Cond: PROC);
  VAR
   CurFile : OBJECT;
   SrcFiles: ENUMERATOR;
   Size    : NUMERIC[0];
 BEGIN
  SrcFiles:=CreateENUMERATOR(SrcFold.Files);
  WHILE ~SrcFiles.AtEnd() DO
   CurFile :=SrcFiles.Item();
   PROMPT(CurFile.Path);
   IF Cond(CurFile) THEN
    Size:=CurFile.Size;
    TRY [EXCEPTIONHANDLING(EXCEPTIONHANDLING_OFF)]
     CurFile.Delete();
     INC(CleanedSize, Size);
    EXCEPT
     ON Exc: Exc_Object DO
      (*,  ᬮ, ⠪  ᬮ...*)
    END;
   END;
   SrcFiles.MoveNext();
  END;
 END {CleanFilesInFolder};

 PRIVATE PROCEDURE CondForXLS(CurFile: OBJECT): SCAL[2];
  VAR
   ext,
   BasisName: STRING[];
   TimeCond : L_General.tTimeCond;
   _CurDate,
   _From,
   _UpTo    : DATE;
 BEGIN
  IF (CurFile.DateLastModified < (SYSDATE() - 90)) &
     (CurFile.DateCreated < (SYSDATE() - 90)) THEN
   FIO.SplitPath(CurFile.Name, BasisName, ext);
   ext:=Str.Cap(ext);
   IF ext = "XLS" THEN
    RETURN 1;
   ELSIF (ext = "CSV") | (ext = "TXT") | (ext = "DID") | (ext = "KEY") THEN
    IF L_Basis.IsRTBasis(BasisName) THEN
     RETURN 1;
    ELSE
     IF (ext = "DID") | (ext = "KEY") THEN
      IF (CurFile.DateLastModified < (SYSDATE() - 365)) &
         (CurFile.DateCreated < (SYSDATE() - 365)) THEN
       RETURN 1;
      END;
     END;
     BasisName:=Str.Slice(BasisName, 6, Str.Length(CurFile.Name));
     IF L_Basis.SplitBasisName(BasisName, TimeCond, _CurDate, _From, _UpTo) THEN
      IF    TimeCond = L_General.timeCond_OnDate THEN
       RETURN L_DatTim.DAY(_CurDate) # 1;
      ELSIF TimeCond = L_General.timeCond_InIntvl THEN
       RETURN (_From # L_DatTim.MonthBeg(_From)) | (_UpTo # L_DatTim.MonthEnd(_UpTo));
      END;
     END;
    END;
   END;
  END;
  RETURN 0;
 END {CondForXLS};

 PRIVATE PROCEDURE CleanFolder(SrcFold: OBJECT);
  VAR
   SrcFolders: ENUMERATOR;
 BEGIN
  CleanFilesInFolder(SrcFold, PROCREF(CondForXLS));
  SrcFolders:=CreateENUMERATOR(SrcFold.SubFolders);
  WHILE ~SrcFolders.AtEnd() DO
   CleanFolder(SrcFolders.Item());
   SrcFolders.MoveNext();
  END;
 END {CleanFolder};

 PRIVATE PROCEDURE CondForErh(CurFile: OBJECT): SCAL[2];
 BEGIN
  RETURN (Str.Cap(Str.Item(CurFile.Name, ".", 1)) # "ZIP");
 END {CondForErh};

 PRIVATE PROCEDURE CleanErhArchive();
  VAR
   Dummy,
   DirName   : STRING[];
   SrcFolders: ENUMERATOR;
   CurFolder : OBJECT;
   ArcDate   : DATE;
 BEGIN
  FIO.SplitPath(FIO.FirstPath(DBD.BaseName(), "ecn"), Dummy, , DirName);
  SrcFolders:=CreateENUMERATOR(fso.GetFolder(DirName).SubFolders);
  WHILE ~SrcFolders.AtEnd() DO
   CurFolder:=SrcFolders.Item();
   ArcDate:=L_Prop.GetDateValueFromStr(CurFolder.Name, "yN01", 0);
   IF ArcDate < (SYSDATE() - 90) THEN
    CleanFilesInFolder(CurFolder, PROCREF(CondForErh));
   END;
   SrcFolders.MoveNext();
  END;
 END {CleanErhArchive};

 PRIVATE PROCEDURE CleanedInform();
 BEGIN
  STDMSG("᢮ " + FLDTOSTR(CleanedSize / 1024 / 1024, " 2.") + " Mb", INFORM);
 END {CleanedInform};

 PRIVATE PROCEDURE Choice(Msg: STRING[]): SCAL[2];
 BEGIN
  RETURN STDFORM("| 㤠 ॢ訥 䠩 " + Msg +
                 "||%<  믮 >X  %< 믮 >B", , STOP);
 END {Choice};

BEGIN
 IF MODE = 100 THEN
  L_General.SilentAdminOnly();
  fso:=CreateOBJECT("Scripting.FileSystemObject");
  IF Choice("        |⮢ ⮢  ଠ Excel| ࠭ 䠩  (DID  KEY)  ") THEN
   CleanedSize:=0;
   CleanFolder(fso.GetFolder(L_Basis.GetBasisPath(L_Basis.CurrentBranch(), SYSDATE())));
   CleanedInform();
  END;
  IF Choice(" 娢 ୠ 訡 (஬ ZIP)") THEN
   CleanedSize:=0;
   CleanErhArchive();
   CleanedInform();
  END;
 ELSE
  L_General.BadMode(MODE);
 END;
END.