(*
%Copyright   (c) Polak IT
%Author      14.04.2003 12:33:46 POLAK\RSN
%Purpose     ।ᯨ筠 ᫥  
%Type        report
%Specific    SYS
%Modified    26.08.2014 17:28:07 POLAK\Gina
%Environment
*)

 IMPORT Memo, L_General, L_DatTim, Math, L_Staff, L_OwnData, L_AFM;

 TYPE
  tMakeMode = SCAL[2];

 CONST
  mm_cntAll   = 0; (*tMakeMode*)
  mm_cntBasic = 1;

 VAR
  RepName,
  Title  : STRING[];

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_mb(), L, "N.y"
Title, C, ""
@
############################################################# ########## #####
=#####========================================================================
|                ।ᯨ筠 ᫥    #######                |
|############################################################################|
|----------------------------------------------------------------------------|
|| |                       |/ᯨ筠|                 |
|----|----|--------------------------------|------------|--------------------|
}
*)

(*
$P{ Line:
Stl01.Sort, L, ""
Stl01.Officer, L, ""
Post.Name, L, ""
Stl01.Amnt, R, "2."
Stl01.Fot, R, ",2-"
@
|####|####|################################|############|####################|
}
*)

(*
$P{ Bot:
?, R, "2."
?, R, ",2-"
@
|------------------------------------------|------------|--------------------|
|⮣                                     |############|####################|
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE Create_Stl01();
 BEGIN

  CreateFILE(Stl01, "", "", "");

  CreateFIELD(Stl01, Sort,     LIKE(Officer.Sort),    "", "", "", "ࠧ", "");
  CreateFIELD(Stl01, Officer,  LIKE(Officer.Officer), "", "", "", " ࠡ祣   । ᥪ", "");
  CreateFIELD(Stl01, Post,     LIKE(Officer.Post),    "", "", "", " ", "");
  CreateFIELD(Stl01, Amnt,     NUMERIC[8, 3],         "", "", "", "᫥", "");
  CreateFIELD(Stl01, Fot,      NUMERIC[12, 2],        "", "", "", "", "");

  CreateINDEXandLINK(Stl01, Sort, UNIQUE, Sort, Sort, USER, "", "", Sort, Officer, Post);
  CreateINDEXandLINK(Stl01, Post, PLURAL, Post, Post, USER, "", "", Post);

  SetVersionOfFILE(Stl01, 1);

 END {Create_Stl01};

 PRIVATE PROCEDURE ModeCond(Mode: tMakeMode): SCAL[2];
 BEGIN
  IF Mode = mm_cntBasic THEN
   RETURN (Staff.Contract=L_Staff.cnt_Basic) & (StaffLog.DutyDgr > 0);
  ELSE
   RETURN 1;
  END;
 END {ModeCond};

 PRIVATE PROCEDURE Prepare_Stl01(Mode: tMakeMode);
  VAR
   MonB,
   MonE           : DATE;
   DaysInM,
   curDaysInFirm,
   curDaysFullDuty: NUMERIC[0];
   curFOT         : NUMERIC[2];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(ACCESS(Union), " । ⥣");
  Create_Stl01();
  L_AFM.AF_CreateTemp("Stl01", "Stl01");

  MonB:=Memo.ud_mb();
  MonE:=Memo.ud_me();
  DaysInM:=MonE - MonB + 1;
  D_Slr.Prepare_SL001(MonB, MonE);

  SETSEL(Officer, Union, Union.Union);
  FOR_EACH Officer DO
   PROMPT(" " + Officer.Sort + " / " + Officer.Officer);
   IF L_DatTim.IsActiveInIntvl_Inc(MonB, MonE, Officer.Begin, Officer.Till) THEN
    SETSEL(StaffLog, Officer, Officer.Sort, Officer.Officer);
    FOR_EACH StaffLog DO
     IF ~L_Staff.IsDischargeStaffLog() THEN
      PROMPT(" " + Officer.Sort + " / " + Officer.Officer + " ⠡. " + StaffLog.TSN);
      CONFORM(StaffLog, Staff);
      IF ModeCond(Mode) THEN
       SETZERO(curDaysInFirm, curDaysFullDuty, curFOT);
       SETSEL(SL001, TSN, StaffLog.TSN, StaffLog.Date);
       FOR_EACH SL001 DO
        D_Slr.GetFromSh001(curDaysInFirm, curDaysFullDuty, EMPTYOF(PROC));
       END; (* FOR_EACH SL001 *)
       SETSEL(Money, TSN, StaffLog.TSN, MonB);
       FOR_EACH Money DO
        IF Money.ODate = StaffLog.Date THEN
         CONFORM(Money, MCList, MCGroup);
         IF MCGroup.FOT > 0 THEN
          INC(curFOT, Money.Sum);
         END;
        END;
       END; (* FOR_EACH Money *)

       IF ((curDaysInFirm-curDaysFullDuty) # 0) | (curFOT # 0) THEN
        ADD(Stl01, Sort, , Officer.Sort, Officer.Officer, Officer.Post,
                           Stl01.Amnt, (curDaysInFirm-curDaysFullDuty)/DaysInM,
                           Stl01.Fot,  curFOT);
       END;
      END;
     END; (* IF ~L_Staff.IsDischargeStaffLog()... *)
    END; (* FOR_EACH StaffLog *)
   END;
  END; (* FOR_EACH Officer *)
 END {Prepare_Stl01};

 PRIVATE PROCEDURE Print_Stl01(Mode: tMakeMode);
  VAR
   TotAmnt,
   TotFot : NUMERIC[2];
 BEGIN
  OPENREP(R, L_General.NameConnection(RepName), Create);
  Title:="⥣ " + Union.Union + " " + Union.Name;
  IF Mode = mm_cntBasic THEN
   Title:=Title + " (᭮ ࠡ)";
  END;
  MAKEPART(R, Top);
  SETZERO(TotAmnt, TotFot);
  SETSEL(Stl01, Sort);
  FOR_EACH Stl01 DO
   CONFORM(Stl01, Post);
   MAKEPART(R, Line);
   INC(TotAmnt, Stl01.Amnt);
   INC(TotFot,  Stl01.Fot);
  END; (* FOR_EACH Stl01 *)
  MAKEPART(R, Bot, TotAmnt, TotFot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("Stl01");
 END {Print_Stl01};

 PUBLIC PROCEDURE SASFO();
 BEGIN
  RepName:="UniFt";
  Prepare_Stl01(mm_cntAll);
  Print_Stl01(mm_cntAll);
  L_General.SurveyLastReport();
 END {SASFO};

 PUBLIC PROCEDURE SASFOBasic();
 BEGIN
  RepName:="UniFb";
  Prepare_Stl01(mm_cntBasic);
  Print_Stl01(mm_cntBasic);
  L_General.SurveyLastReport();
 END {SASFOBasic};

END.