(*
%Copyright   (c) Polak Computer System
%Author      07.04.1998 15:58:11 GINA
%Specific    SYS
%Modified    03.07.2012 20:09:28 POLAK\Gina
%Environment
*)

 MODULE Staff100 [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_OwnData, L_DatTim, L_Staff, L_AFM, L_Env, Math;

 CONST
  RepName="St100";

(*
$P{ Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
RepName, L, ""
Memo.ud_fr(), L, "D.N.y"
Memo.ud_ut(), L, "D.N.y"
@
######################################################################################### ########## #####
=#####====================================================================================================
|                  ⭨, 騥  ஦  ਮ  ##########  ##########                  |
|--------------------------------------------------------------------------------------------------------|
|. |, , ⢮                  |                    |   ||           |
}
*)

(*
$P{ Del:
@
|-----|----------------------------------------|-----------------------------|----------|----|-----------|
}
*)

(*
$P{ Line:
?, L, ""
Man.Name, L, ""
Post.Name, L, ""
Man.Birth, L, "D.N.y"
L_DatTim.CompleteYearsInIntvl(Man.Birth, Memo.ud_ut()-1), R, ""
@
|#####|########################################|#############################|##########|####|           |
}
*)

(*
$P{ Bot:
@
=(c) Polak================================================================================================
}
*)

 PRIVATE PROCEDURE Create_NBorn();
 BEGIN
  CreateFILE(NBorn, "", "", "");

  CreateFIELD(NBorn, DAY,   NUMERIC[0],         "", "", "", " ஦", "");
  CreateFIELD(NBorn, MONTH, L_DatTim.tMonth,    "", "", "", " ஦", "");
  CreateFIELD(NBorn, TSN,   LIKE(Staff.TSN),    "", "", "", "", "");
  CreateFIELD(NBorn, Man,   LIKE(Staff.Man),    "", "", "", "", "");
  CreateFIELD(NBorn, Post,  LIKE(Officer.Post), "", "", "", "", "");

  CreateINDEX(NBorn, BirthDay, PLURAL, "", "", MONTH, DAY, TSN);
  CreateINDEXandLINK(NBorn, TSN,  PLURAL, Staff, TSN,  USER, "", "", TSN);
  CreateINDEXandLINK(NBorn, Man,  PLURAL, Man,   Man,  USER, "", "", Man);
  CreateINDEXandLINK(NBorn, Post, PLURAL, Post,  Post, USER, "", "", Post);
  SetVersionOfFILE(NBorn, 000);
  L_AFM.AF_CreateTemp("NBorn", "NBorn");
 END {Create_NBorn};

 PUBLIC PROCEDURE Staff100();
  VAR
   _DAY   : NUMERIC[0];
   _MONTH : L_DatTim.tMonth;
   Birth  : DATE;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_General.Assert(L_DatTim.YearsInIntvl(Memo.ud_fr(), Memo.ud_ut())<=1, "ਮ    ");
 
  Create_NBorn();
 
  OPENREP(R, L_General.NameConnection(RepName), Create);
  MAKEPART(R, Top);
 
  SELECT(Man, Man);
  WHILE OCCURE(Man) DO
   PROMPT(Man.Man);
   IF ~!Man.Birth THEN
    Birth:=L_DatTim.IncYear(L_DatTim.MonthBeg(Man.Birth), L_DatTim.CompleteYearsInIntvl(Man.Birth, Memo.ud_ut()));
    Birth:=Birth+Math.Min(L_DatTim.MonthLen(Birth), L_DatTim.DAY(Man.Birth))-1;
    IF L_DatTim.IsActive_Inc(Birth, Memo.ud_fr(), Memo.ud_ut()) THEN
     IF L_Staff.IsStandOnAnyMainContract(Man.Man, Birth) & L_Staff.rInState(Birth) THEN
      HISTCONF(Birth, Staff, StaffLog);
      CONFORM(StaffLog, Officer);
      NBorn.DAY  :=L_DatTim.DAY(Man.Birth);
      NBorn.MONTH:=L_DatTim.MONTH(Man.Birth);
      NBorn.TSN  :=Staff.TSN;
      NBorn.Man  :=Staff.Man;
      NBorn.Post :=Officer.Post;
      INSERT(NBorn);
     END;
    END;
   END;
   NEXT(Man);
  END; (* WHILE OCCURE(Man) ... *)
 
  SETEMPTY(_DAY, _MONTH);
  SELECT(NBorn, BirthDay);
  WHILE OCCURE(NBorn) DO
   PROMPT(NBorn.TSN);
   IF (_MONTH # NBorn.MONTH) | (_DAY # NBorn.DAY) THEN
    MAKEPART(R, Del);
    _DAY  :=NBorn.DAY;
    _MONTH:=NBorn.MONTH;
   END;
   CONFORM(NBorn, Man);
   CONFORM(NBorn, Post);
   MAKEPART(R, Line, NBorn.TSN);
   NEXT(NBorn);
  END; (* WHILE OCCURE(NBorn) ... *)
 
  MAKEPART(R, Bot);
  CLOSEREP(R);
  L_AFM.AF_PurgeTemp("NBorn");
 END {Staff100};

END.