(*
%Copyright   (c) Polak IT
%Author      27.01.2003 13:05:27 POLAK\GINA
%Purpose     ⥬ 樨
%Type        operation
%Specific    SYS
%Modified    18.09.2014 14:08:56 POLAK\LDA
%Environment
*)

 MODULE Sys_Util [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DBD, L_StdFrm, L_Str, DBD, Str, FIO, L_AFM, L_DatTim, L_PCS, Math,
        L_WDO, L_FIO, L_Timer, L_Excel, L_Math, SysLog, L_Events, Shell, L_Prop, L_SES,
        Memo, L_AR, L_Msg, L_lsStore, L_PDBS, L_OwnData, L_MSO, L_SysLog;

 PRIVATE CONST
  chat_NoRCUser = "  室  ࠢ";

  sl_AllTemplate     = 0;
  sl_BY_USERTemplate = 1;
  sl_SystemTemplate  = 2;

 PRIVATE PROCEDURE V32ClPh_OnInitializeWindow();
 BEGIN
  L_WDO.iEvents   (0, [L_WDO.e_OnOpenZone, L_WDO.e_OnAfterEdit]);
  L_WDO.iScsChange(0, ["V32DevPath", "V32PrsPath"]);
  L_WDO.iProgs (0, "Sys_Util");
  L_WDO.iField (0, "V32DevPath").OnBeforeAsk:=1;
  L_WDO.iField (0, "V32PrsPath").OnBeforeAsk:=1;
 END {V32ClPh_OnInitializeWindow};

 PRIVATE PROCEDURE V32ClPh_AnyPath_OnBeforeAsk();
  VAR
   Path     : STRING[];
   ChooseDir: CHOOSEFILEDIALOG;
   Zone     : FORM_ZONE;
 BEGIN
  Zone:=RTI.Get().CurZone;
  Path:=Zone.ActiveField.Value;
  IF !Path | ~FIO.DirExists(Path) THEN
   Path:=CHOOSEFILEDIALOG.NameMask_Drives;
  ELSE
   Path:=FIO.BuildPath("*.*", , Path);
  END;
  ChooseDir                     :=CHOOSEFILEDIALOG.Create(Path);
  ChooseDir.FilesAreAcceptable  :=0;
  ChooseDir.FoldersAreAcceptable:=1;
  Path:=ChooseDir.Deal();
  IF ~!Path THEN
   Zone.ActiveField.Value:=Path;
  ELSE
   HALT();
  END;
 END {V32ClPh_AnyPath_OnBeforeAsk};

 PRIVATE PROCEDURE V32ClPh_V32DevPath_OnBeforeAsk();
 BEGIN
  V32ClPh_AnyPath_OnBeforeAsk();
 END {V32ClPh_V32DevPath_OnBeforeAsk};

 PRIVATE PROCEDURE V32ClPh_V32PrsPath_OnBeforeAsk();
 BEGIN
  V32ClPh_AnyPath_OnBeforeAsk();
 END {V32ClPh_V32PrsPath_OnBeforeAsk};

 PRIVATE PROCEDURE V32ClPh_AnyPath_OnSuccessfulChange();
  VAR
   Path: STRING[];
 BEGIN
  Path:=RTI.Get().CurZone.ActiveField.Value;
  L_General.Assert(FIO.DirExists(Path), "   '" + Path + "'");
 END {V32ClPh_AnyPath_OnSuccessfulChange};

 PRIVATE PROCEDURE V32ClPh_V32DevPath_OnSuccessfulChange();
 BEGIN
  V32ClPh_AnyPath_OnSuccessfulChange();
 END {V32ClPh_V32DevPath_OnSuccessfulChange};

 PRIVATE PROCEDURE V32ClPh_V32PrsPath_OnSuccessfulChange();
 BEGIN
  V32ClPh_AnyPath_OnSuccessfulChange();
 END {V32ClPh_V32PrsPath_OnSuccessfulChange};

 PRIVATE PROCEDURE V32ClPh_0_OnZoneOpen();
  VAR
   Fields: FORM_FIELDS;
   dummy : SCAL[2];
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  dummy:=L_SES.GetValue(L_SES.sit_Global, "APP.V32DevPath", Fields("V32DevPath").Value);
  dummy:=L_SES.GetValue(L_SES.sit_Global, "APP.V32PrsPath", Fields("V32PrsPath").Value);
 END {V32ClPh_0_OnZoneOpen};

 PRIVATE PROCEDURE V32ClPh_OnAfterEdit();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  L_SES.PutValueAtCurTrn(L_SES.sit_Global, "APP.V32DevPath", Fields("V32DevPath").Value);
  L_SES.PutValueAtCurTrn(L_SES.sit_Global, "APP.V32PrsPath", Fields("V32PrsPath").Value);
 END {V32ClPh_OnAfterEdit};

 PRIVATE PROCEDURE AccessCurFile();
 BEGIN
  L_General.Assert(~!GE_CURFILE(),          " ⠭ ⥪騩 䠩");
 END {AccessCurFile};

 PRIVATE PROCEDURE AccessCurRecord();
 BEGIN
  AccessCurFile();
  L_General.Assert(ACCESS(^(GE_CURFILE())), " ⠭ ⥪ ");
 END {AccessCurRecord};

 PUBLIC PROCEDURE Remove();
 BEGIN
  L_General.PermitIllegalDataModifying();
  L_StdFrm.Warning(" ");
  AccessCurRecord();
  L_DBD.CheckUsers(GE_CURFILE());
  INTEGRITY(NoAsk);
  REMOVE(^(GE_CURFILE()));
  INTEGRITY(Off);
 END {Remove};

 PUBLIC PROCEDURE RemSel();
  VAR
   Cnt: NUMERIC[0];
   File: STRING[8];
 BEGIN
  L_General.PermitIllegalDataModifying();
  L_StdFrm.Warning("   SELECT, 稭  ⥪饩");
  AccessCurRecord();
  INTEGRITY(NoAsk);
  File:=GE_CURFILE();
  Cnt:=0;
  ACCESS(^File);
  WHILE OCCURE(^File) DO INC(Cnt);
   PROMPT(FLDTOSTR(Cnt, "0"));
   REMOVE(^File);
  END;
 END {RemSel};

 PUBLIC PROCEDURE Defrost();
  CONST
   Message = "뢮   娢 |७   娢 ";
  VAR
   Freeze,
   OneRec : SCAL[2];
 BEGIN
  L_General.SilentAdminOnly();
  AccessCurRecord();
  Freeze:=0;
  OneRec:=1;
  STDFORM(L_StdFrm.sf_Choice("|⢨ : %####################################%" +
                             "|" +
                             "|  : %##############%                      |",
                             "%L<" + Message + ">I %L<騩 ᥫ| >I"),
          "  娢 ",
          ,
          ,
          Freeze, OneRec);
  L_StdFrm.Warning("믮 "+ L_Str.PoolItem("뢮  娢 |७  娢 ", Freeze) + "|" +
                   L_Str.PoolItem("⥪饣 ᥫ|⥪饩 ", OneRec) + "?");
  PROMPT(L_Str.PoolItem(Message, Freeze) + "...");
  INTEGRITY(NoAsk);
  IF OneRec THEN
   IF Freeze THEN
    L_General.Assert(~FREEZED(^(GE_CURFILE())), " 㦥 室  娢 ");
    FREEZE(^(GE_CURFILE()));
   ELSE
    L_General.Assert(FREEZED(^(GE_CURFILE())), "  室  娢 ");
    DEFROST(^(GE_CURFILE()));
   END;
  ELSE
   IF Freeze THEN
    FREEZESEL(^(GE_CURFILE()));
   ELSE
    DEFROSTSEL(^(GE_CURFILE()));
   END;
  END;
  INTEGRITY(Off);
 END {Defrost};

 PRIVATE PROCEDURE su_AppendUsers(File: STRING[]; VAR tUsers: STRING[][]);
  VAR
   cUsers: STRING[][64];
   i, j  : NUMERIC[0];
 BEGIN
  L_DBD.GetActiveUsers(File, cUsers);
  i:=0;
  WHILE ~!tUsers[i] DO
   INC(i);
  END;
  j:=0;
  WHILE ~!cUsers[j] DO
   tUsers[i]:=cUsers[j];
   INC(i);
   INC(j);
  END;
 END {su_AppendUsers};

 PRIVATE PROCEDURE su_Append_r2rUsers(File: STRING[]; VAR tUsers: STRING[][]);
  VAR
   i: NUMERIC[0];
 BEGIN
  i:=0;
  WHILE ~!tUsers[i] DO
   INC(i);
  END;
  IF ~!TABLE.Get(File).Fields("RECORDID") THEN
   SELECT(r2r, byOwn, , TABLE.Get(File).Id, ^(TABLE.Get(File).Fields("RECORDID").ObtainName()));
   WHILE OCCURE(r2r) DO
    NARROWSEL(r2r, fiUsr);
    tUsers[i]:=DATABASE.Get().TableById(r2r.fiUsr).Name;
    INC(i);
    NEXTINEXTENDEDSEL(r2r, fiUsr);
   END; (* WHILE OCCURE(r2r) ... *)
  END;
 END {su_Append_r2rUsers};

 PRIVATE PROCEDURE BrowseAllow(): SCAL[2];
 BEGIN
  RETURN L_General.IsAdmin() | L_General.IsProgrammer();
 END {BrowseAllow};

(*
$P{ Users_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, C, ""
?, C, ""
?, C, ""
@
############################################################# ########## #####
=#####========================================================================
|############################################################################|
|############################################################################|
|############################################################################|
|----------------------------------------------------------------------------|
}
*)

(*
$P{ Users_SubTop:
?, L, ""
@
|############################################################################|
|----------------------------------------------------------------------------|
}
*)

(*
$P{ Users_Line:
?, L, ""
@
|############################################################################|
}
*)

(*
$P{ Users_Bot:
@
=(c) Polak====================================================================
}
*)

 PRIVATE PROCEDURE su_GetRecordCodeAndName(File: STRING[]): STRING[];
  VAR
   Result,
   trgName: STRING[];
 BEGIN
  Result:=L_DBD.GetPrimaryIndexValue(File);
  IF DBD.FieldExist(^(File), "Name") THEN
   trgName:=^(L_DBD.GetFieldName(File, "Name"));
   Result:=Result + " " + trgName;
  END;
  RETURN Result;
 END {su_GetRecordCodeAndName};

 PRIVATE PROCEDURE su_AddLinePart(UserFileName: STRING[]);
  VAR
   RecName: STRING[];
 BEGIN
  RecName:=su_GetRecordCodeAndName(UserFileName);
  PROMPT(RecName);
  MAKEPART(R, Users_Line, RecName);
 END {su_AddLinePart};

 PRIVATE PROCEDURE su_PrintFile(File, cooFile: STRING[]);
  VAR
   j, n: NUMERIC[0];
   Link: STRING[];
 BEGIN
  IF ~!TABLE.Get(File).Fields("RECORDID") THEN
   SELECT(r2r, byOwn, , TABLE.Get(File).Id, ^(TABLE.Get(File).Fields("RECORDID").ObtainName()), TABLE.Get(cooFile).Id);
   WHILE OCCURE(r2r) DO
    L_General.CallUs(SEARCH(^(DATABASE.Get().TableById(r2r.fiUsr).Name), RECORDID, r2r.riUsr));
    su_AddLinePart(cooFile);
    NEXT(r2r);
   END; (* WHILE OCCURE(r2r) ... *)
  END;
  j:=0;
  n:=DBD.LinkAmount(^File);
  WHILE j<n DO
   Link:=DBD.LinkName(^File, j);
   IF DBD.LinkKind(^File, ^Link) = L_General.lk_OWNER THEN
    IF DBD.LinkCooFileName(^File, ^Link) = cooFile THEN
     SAVE((cooFile));
     L_DBD.SelectUsers(File, Link);
     WHILE OCCURE((cooFile)) DO
      su_AddLinePart(cooFile);
      NEXT((cooFile));
     END;
     RESTORE((cooFile));
    END;
   END;
   INC(j);
  END;
 END {su_PrintFile};

 PUBLIC PROCEDURE ShowUsers();
  TYPE
   tMode = SCAL[3];
  CONST
   m_Exit   = 0;
   m_GoTo   = 1;
   m_Report = 2;
   RepName  = "Users";
  VAR
   File,
   PrimIndex,
   Title,
   Mirror: STRING[];
   tUsers: STRING[][64];
   List  : STRING[];
   Mode  : tMode;
   i,
   j     : NUMERIC[0];
 BEGIN
  AccessCurRecord();
  TRY
   GRANT_ALL_RIGHTS();
   SETEMPTY(tUsers);
   File:=GE_CURFILE();
   su_AppendUsers(File, tUsers);
   IF ~!PROCREF(L_PCS.GetMirrorEntity) THEN
    Mirror:=L_PCS.GetMirrorEntity(File);
    IF ~!Mirror THEN
     L_PCS.StandOnMirrorRecord(File);
     su_AppendUsers(Mirror, tUsers);
    END;
   END;
   su_Append_r2rUsers(File, tUsers);
  EXCEPT
  END; (* TRY *)
  List:="";
  i:=0;
  WHILE ~!tUsers[i] DO
   List:=List + Str.Align(L_Str.CutLongStr(DBD.FileDescription(^(tUsers[i])), 57), 57, LEFT) + "|";
   INC(i);
  END;
  IF ~!List THEN
   i:=0;
   Mode:=STDFORM("|" +
                 "|%L,10AI||||||||||" +
                 "|%< ⬥{} >X         %< {}३ >" + L_Str.PoolItem("NB|B", BrowseAllow()) + "         %<  {}  >DB",
                 " 뫪  ⥪  ",
                 INFORM,
                 -1,
                 List, i);
   IF    Mode = m_GoTo   THEN
    LIKEMENU(View, "@" + tUsers[i] + " 1");
   ELSIF Mode = m_Report THEN
    OPENREP(R, L_General.NameConnection(RepName), Create);
    PrimIndex:=L_DBD.GetPrimaryIndex(tUsers[i]);
    j:=0;
    SETEMPTY(Title);
    WHILE j < DBD.IndexFieldAmount(^(tUsers[i]), ^(PrimIndex)) DO
     IF !Title THEN
      Title:=DBD.FieldDescription(^(tUsers[i]), ^(DBD.IndexFieldName(^(tUsers[i]), ^(PrimIndex), j)));
     ELSE
      Title:=Title + ", " + DBD.FieldDescription(^(tUsers[i]), ^(DBD.IndexFieldName(^(tUsers[i]), ^(PrimIndex), j)));
     END;
     INC(j);
    END;
    MAKEPART(R, Users_Top, RepName,
             "祭 뫮  䠩 '" + DBD.FileDescription(^(tUsers[i])) + "'",
             "  "                + su_GetRecordCodeAndName(File),
             "䠩 '"                   + DBD.FileDescription(^File) + "'");
    MAKEPART(R, Users_SubTop, Title);
    su_PrintFile(File, tUsers[i]);
    IF ~!Mirror THEN
     L_PCS.StandOnMirrorRecord(File);
     su_PrintFile(Mirror, tUsers[i]);
    END;
    MAKEPART(R, Users_Bot);
    CLOSEREP(R);
    LIKEMENU(Survey, "");
   END;
  ELSE
   L_StdFrm.Inform(" 뫮  ");
  END;
 END {ShowUsers};

 PRIVATE PROCEDURE BrowseFile(ShowAll: SCAL[2]);
 BEGIN
  L_General.Assert(BrowseAllow(), "   稩  믮 ⮩ 樨");
  LIKEMENU(View, "@" + L_DBD.ChooseFileName("ᬮ 䠩  ᯥ樠쭮 ଠ", ShowAll) + " 1");
 END {BrowseFile};

 PUBLIC PROCEDURE BrowseCurFile();
 BEGIN
  BrowseFile(0);
 END {BrowseCurFile};

 PUBLIC PROCEDURE BrowseAnyFile();
 BEGIN
  BrowseFile(1);
 END {BrowseAnyFile};

 PRIVATE PROCEDURE cac_TextVersion();
  CONST
   MaxWidth       = 240;
   MaxHeight      = 120;

   MinWidth       = 80;
   MinHeight      = 25;

   btnOk          = 2;
   btnApply       = 3;
   btn112X50      = 1;
  VAR
   val,
   Variables                 : STRING[];
   React,
   Width,
   Height,
   curWidth,
   curHeight                 : NUMERIC[0];
   HasError,
   Mousable,
   ExitFromLOOP,
   MenuArrangeStyle,
   MenuRespondToMouseMovement: SCAL[2];
 BEGIN
  Mousable                  :=APP.Get().Mousable;
  MenuRespondToMouseMovement:=APP.Get().MenuRespondToMouseMovement;
  MenuArrangeStyle          :=APP.Get().MenuArrangeStyle;
  GE_APPWIN_SIZE(curWidth, curHeight);
  Width    :=curWidth;
  Height   :=curHeight;
  Variables:="Width, Height, Mousable, MenuRespondToMouseMovement, MenuArrangeStyle";
  LOOP
   ExitFromLOOP:=0;
   HasError    :=0;
   React:=STDFORM(L_StdFrm.PartForm("%LI" +
                                    "%LI" +
                                    "%< 112  50 >B" +
                                    "%L<ࠢ   >E" +
                                    "%L< ॠ  ६饭 >E" +
                                    "%L<᪠ ࠧ饭 >E" +
                                    "%<  >DB" +
                                    "%< ਬ >B" +
                                    "%< ⮯! >X" +
                                     "@" +
                                    "|ਭ: %####% : %####% %##########%" +
                                    "|%########################################%" +
                                    "|%########################################%" +
                                    "|%########################################%" +
                                    "|" +
                                    "|%####%  %###########%  %#######%"),
                                    " ன ࠬ஢ ᮫ ",
                                    INFORM_NEUTRAL,
                                    1,
                                    ^Variables);
   IF React = btn112X50 THEN
    HasError    :=0;
    ExitFromLOOP:=0;
    Width       :=L_General.MainWindowStandartWidth();
    Height      :=L_General.MainWindowStandartHeight();
   ELSE
    IF (Width < MinWidth) | (Height < MinHeight) |
       (Width > MaxWidth) | (Height > MaxHeight) THEN
     L_StdFrm.RedInform(" ࠧ ᮫  室  | " +
                        L_Str.IntStr(MinWidth) + "*" + L_Str.IntStr(MinHeight)+ "  " +
                        L_Str.IntStr(MaxWidth) + "*" + L_Str.IntStr(MaxHeight) + " ᨬ");
     HasError:=1;
    ELSE
     L_SES.PutValueAtCurTrn(L_SES.sit_User, "APP.Mousable",                   Mousable);
     L_SES.PutValueAtCurTrn(L_SES.sit_User, "APP.MenuRespondToMouseMovement", MenuRespondToMouseMovement);
     L_SES.PutValueAtCurTrn(L_SES.sit_User, "APP.MenuArrangeStyle",           MenuArrangeStyle);
     Memo.DefineApplicationProperties();
     curWidth :=Width;
     curHeight:=Height;
    END;
    IF React = btnApply THEN
     ExitFromLOOP:=0;
    ELSE
     ExitFromLOOP:=~HasError;
    END;
   END;
   IF ~HasError THEN
    SE_APPWIN_SIZE(Width, Height);
   END;
   IF ExitFromLOOP THEN
    EXIT;
   END;
  END; (* LOOP *)
 END {cac_TextVersion};

 PRIVATE PROCEDURE cac_GetCanvasParam(VAR cwp, chp, bfs: NUMERIC[0]);
  VAR
   ch, cw: NUMERIC[2];
 BEGIN
  bfs:=APP.Get().BasicFontSize;
  GE_APPWIN_SIZE(cw, ch);
  cwp:=100 * cw / L_General.MainWindowStandartWidth();
  chp:=100 * ch / L_General.MainWindowStandartHeight();
 END {cac_GetCanvasParam};

 PRIVATE PROCEDURE cac_ChngsMsg(t1, n1, t2, n2: STRING[]): STRING[];
 BEGIN
  RETURN Str.Align(t1 + " " + n1, 30, LEFT) +
         Str.Align(t2 + " " + n2, 16, LEFT);
 END {cac_ChngsMsg};

 PRIVATE PROCEDURE GetAcceptableFontFaces(): STRING[];
  CONST
   FontFaces = "Arial|Calibri|Georgia|Roboto|Segoe UI|Tahoma|Times New Roman|Verdana";
  VAR
   i                      : NUMERIC[0];
   Result,
   SingleFontFace,
   curProportionalFontFace: STRING[];
 BEGIN
  curProportionalFontFace:=APP.Get().ProportionalFontFace;
  SETEMPTY(Result);
  i:=0;
  LOOP
   SingleFontFace:=L_Str.PoolItem(FontFaces, i);
   IF !SingleFontFace THEN
    EXIT;
   END;
   IF L_General.SetProportionalFontFace(SingleFontFace) THEN
    Result:=L_Str.AddStrDlm(Result, "|") + SingleFontFace;
   END;
   INC(i);
  END; (* LOOP *)

  APP.Get().ProportionalFontFace:=curProportionalFontFace;

  IF !L_Str.PositionInPool(Result, curProportionalFontFace) THEN
   Result:=L_Str.AddStrDlm(Result, "|") + curProportionalFontFace;
  END;
  RETURN Result;
 END {GetAcceptableFontFaces};

 PRIVATE PROCEDURE cac_GUIVersion();
  VAR
   curPFF,
   curPFF1             : NUMERIC[0];
   chp,
   cwp,
   chp1,
   cwp1,
   bfs,
   bfs1,
   React               : NUMERIC[0];
   Save2SESProc        : PROC;
   trgForceClearType,
   trgForceClearType1,
   trgLargeUISchema,
   trgLargeUISchema1,
   trgUseAltForMainMenuAccess,
   trgUseAltForMainMenuAccess1,
   trgMenuArrangeStyle,
   trgMenuArrangeStyle1: SCAL[2];
   Msg, Msg2,
   AcceptableFontFaces : STRING[];
 BEGIN
  L_General.Assert(DBD.ProcessorVersion() >= 014210151,
                   "    ᪠." +
                   "|| ࠬ஢ ᮫ " +
                   "|᫥⢨ ⢨ ᮫.");

  cac_GetCanvasParam(cwp1, chp1, bfs1);
  AcceptableFontFaces:=GetAcceptableFontFaces();
  LOOP
   trgMenuArrangeStyle1:=APP.Get().MenuArrangeStyle;
   curPFF1             :=L_Str.PositionInPool(AcceptableFontFaces, APP.Get().ProportionalFontFace);
   trgMenuArrangeStyle :=trgMenuArrangeStyle1;
   curPFF              :=curPFF1;
   bfs:=bfs1;
   cwp:=cwp1;
   chp:=chp1;
   trgUseAltForMainMenuAccess1:=APP.Get().UseAltForMainMenuAccess;
   trgUseAltForMainMenuAccess :=trgUseAltForMainMenuAccess1;
   IF L_General.IsAcceptableProcessorVersion(014237010) THEN
    trgForceClearType1:=APP.Get().ForceClearType;
    trgForceClearType :=trgForceClearType1;
    trgLargeUISchema1 :=APP.Get().LargeUISchema;
    trgLargeUISchema  :=trgLargeUISchema1;
    React:=STDFORM(L_StdFrm.PartForm("%L< ⭠, $>M" + "%R< ࠧ >M" +
                                     "%RI" + "%RI" + "%RI" +
                                     "%L<᪠ ࠧ饭 >E" +
                                     "%L<筮 ᯮ짮 Alt -  F10>E" +
                                     "%L<㯭  ⠬,    >E" +
                                     "%L< ᣫ ⥪ (ClearType)>E" +
                                     "%L< >M" +
                                     "%L<" + AcceptableFontFaces + ">I" +
                                     "%<⠭ ࠧ ⭠>B" + "%<>DB" + "%<ਬ>B" + "%<⮯!>X" +
                                     "@" +
                                      " %###############%Ŀ%###################% " +
                                     "|  ਭ %####%  %####%                 %###% " +
                                     "|  " +
                                     "| Ŀ " +
                                     "| %#################################################%  " +
                                     "| %################################################%   " +
                                     "| %#################################################%  " +
                                     "| %#################################################%  " +
                                     "|  " +
                                     "| %##########%Ŀ " +
                                     "|  %################################################%  " +
                                     "|  " +
                                     "|%############################% %####% %###########% %#######%"),
                   " ன ࠬ஢   ", LIKE_WDO, 1,
                   cwp, chp, bfs, trgMenuArrangeStyle, trgUseAltForMainMenuAccess, trgLargeUISchema,
                   trgForceClearType, curPFF);
   ELSE
    trgForceClearType1:=0;
    trgForceClearType :=trgForceClearType1;
    trgLargeUISchema1 :=0;
    trgLargeUISchema  :=trgLargeUISchema1;
    React:=STDFORM(L_StdFrm.PartForm("%L< ⭠, $>M" + "%R< >M" +
                                     "%RI" + "%RI" + "%RI" +
                                     "%L<᪠ ࠧ饭 >E" +
                                     "%L<筮 ᯮ짮 Alt -  F10>E" +
                                     "%L< >M" +
                                     "%L<" + AcceptableFontFaces + ">I" +
                                     "%<⠭ ࠧ ⭠>B" + "%<>DB" + "%<ਬ>B" + "%<⮯!>X" +
                                     "@" +
                                      " %###############%Ŀ %###########% " +
                                     "| ਭ %####%   %####%         %###% " +
                                     "|   " +
                                     "| Ŀ " +
                                     "| %########################################%   " +
                                     "| %#########################################%  " +
                                     "|  " +
                                     "| %##########%Ŀ " +
                                     "|  %########################################%  " +
                                     "|  " +
                                     "|%############################% %####% %###########% %#######%"),
                   " ன ࠬ஢   ", LIKE_WDO, 1,
                   cwp, chp, bfs, trgMenuArrangeStyle, trgUseAltForMainMenuAccess, curPFF);
   END;
   IF (React = 3) & (bfs = bfs1) &
                    (cwp = cwp1) &
                    (chp = chp1) &
                    (curPFF = curPFF1) &
                    (trgMenuArrangeStyle = trgMenuArrangeStyle1) &
                    (trgLargeUISchema = trgLargeUISchema1) &
                    (trgForceClearType = trgForceClearType1) &
                    (trgUseAltForMainMenuAccess = trgUseAltForMainMenuAccess1) THEN
     L_StdFrm.Inform(" , ॡ ਬ");
   ELSE
    IF React = 1 THEN
     cwp:=100;
     chp:=100;
    END;
    IF bfs < bfs1 THEN
     APP.Get().BasicFontSize:=bfs;
    END;
    IF (cwp # cwp1) | (chp # chp1) THEN
     TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
      SE_APPWIN_SIZE(cwp * L_General.MainWindowStandartWidth() / 100, chp * L_General.MainWindowStandartHeight() / 100);
     EXCEPT
     ON Exc: Exc_RunTime DO
      IF Exc.ErrorCode = L_General.ec_rt_TooBigCanvasSize THEN
       L_StdFrm.RedInform(" ⨬ ࠧ ⭠");
      ELSE
       RAISE();
      END;
     END;
    END;
    IF bfs > bfs1 THEN
     APP.Get().BasicFontSize:=bfs;
    END;
    IF (React = 1) | (React = 3) THEN
     Save2SESProc:=PROCREF(L_SES.PutValueAtSlaveTrn);
    ELSE
     Save2SESProc:=PROCREF(L_SES.PutValueAtCurTrn);
    END;
    Save2SESProc(L_SES.sit_User, "APP.MenuArrangeStyle",        trgMenuArrangeStyle);
    Save2SESProc(L_SES.sit_User, "APP.ProportionalFontFace",    L_Str.PoolItem(AcceptableFontFaces, curPFF));
    Save2SESProc(L_SES.sit_User, "APP.UseAltForMainMenuAccess", trgUseAltForMainMenuAccess);
    IF L_General.IsAcceptableProcessorVersion(014237010) THEN
     Save2SESProc(L_SES.sit_User, "APP.LargeUISchema",          trgLargeUISchema);
     Save2SESProc(L_SES.sit_User, "APP.ForceClearType",         trgForceClearType);
    END;
    Memo.DefineApplicationProperties();

    IF (trgForceClearType # trgForceClearType1) THEN
     L_StdFrm.RedInform(" ० ᣫ  㯨  ᨫ ᫥ १᪠ ਫ");
    END;
 
    cac_GetCanvasParam(cwp1, chp1, bfs1);
    Msg:="";
    IF bfs1 # bfs THEN
     Msg:=L_Str.AddStrDlm(Msg, "|") + cac_ChngsMsg(" ࠧ ", L_Str.IntStr(bfs),
                                                   "⠭",          L_Str.IntStr(bfs1));
    END;
    IF cwp1 # cwp THEN
     Msg:=L_Str.AddStrDlm(Msg, "|") + cac_ChngsMsg(" ਭ ⭠", L_Str.IntStr(cwp) + "%",
                                                   "⠭", L_Str.IntStr(cwp1) + "%");
    END;
    IF chp1 # chp THEN
     Msg:=L_Str.AddStrDlm(Msg, "|") + cac_ChngsMsg("  ⭠", L_Str.IntStr(chp) + "%",
                                                   "⠭", L_Str.IntStr(chp1) + "%");
    END;
 
    IF ~!Msg THEN
     Msg2:="";
     IF    bfs1 < bfs THEN
      Msg2:=L_Str.AddStrDlm(Msg2, ".|") + "  㬥襭, ⮡  ⨫  ࠭";
     ELSIF bfs1 > bfs THEN
      Msg2:=L_Str.AddStrDlm(Msg2, ".|") + "  㢥祭, ⮡   뫮 ᫨誮 쪨";
     END;
     IF (cwp1 < cwp) | (chp1 < chp) THEN
      Msg2:=L_Str.AddStrDlm(Msg2, ".|") + " ⭠ 㬥襭, ⮡  ⨫  ࠭";
     END;
     IF (cwp1 > cwp) | (chp1 > chp) THEN
      Msg2:=L_Str.AddStrDlm(Msg2, ".|") + " ⭠ 㢥祭, ⠪   ᨬ஢";
     END;
     L_StdFrm.RedInform(Msg + L_StdFrm.HR() + Msg2);
    ELSIF React = 2 THEN
     EXIT;
    END;
   END; (* IF (React=3) & (bfs=bfs1) ... *)
  END; (* LOOP *)
 END {cac_GUIVersion};

 PUBLIC PROCEDURE ChangeApplicationConsole();
 BEGIN
  IF L_StdFrm.wGUI() THEN
   cac_GUIVersion();
  ELSE
   cac_TextVersion();
  END;
 END {ChangeApplicationConsole};

 PRIVATE TYPE
  tAdditionalBackupType = SCAL[2];

 PRIVATE CONST
  bckpf_ActualRoot = "Backup\Actual";

  abckpt_Full = 0;
  abckpt_Main = 1;

 PRIVATE PROCEDURE bckp_GetActualFullPath(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  Result:=FIO.BuildPath(bckpf_ActualRoot, , FIO.AsbSpecialFolders("ServerProjectRoot"));
  L_General.Assert(FIO.DirExists(Result) # 0,
                   "⠫ '" + Result + "'|" + " ,   ࠢ (NTFS) ⥭");
  RETURN Result;
 END {bckp_GetActualFullPath};

 PRIVATE PROCEDURE bckp_GetAdditionalRootPath(): STRING[];
  VAR
   Local: PROC;
 BEGIN
  Local:=PROCREF(L_PCS.GetBackupAdditionalRootPath);
  L_General.Assert(~!Local,
                   " ஥   ᮧ ⥫쭮 १ࢭ ");
  RETURN Local();
 END {bckp_GetAdditionalRootPath};

 PRIVATE PROCEDURE bckp_IsFileOfFullPart(Name: STRING[]): SCAL[2];
 BEGIN
  RETURN Str.Cap(L_FIO.effp_FileExt(Name)) = "DAP";
 END {bckp_IsFileOfFullPart};

 PRIVATE PROCEDURE bckp_CheckForderAvailability(Path: STRING[]): SCAL[2];
  CONST
   TestFolderName = "QWERTYUIOPASDFGHJKLZXCVBNM123456789";
  VAR
   FullTestFolderName: STRING[];
 BEGIN
  FullTestFolderName:=FIO.BuildPath(TestFolderName, , Path);
  TRY [MSG_SUPPRESSION(MSG_SUPPRESSION_ALL)]
   IF FIO.DirExists(FullTestFolderName) THEN
    FIO.RmDir(FullTestFolderName);
   END;
   FIO.MkDir(FullTestFolderName);
   FIO.RmDir(FullTestFolderName);
  EXCEPT
  ON Exc: Exc_Root DO
   FIO.RmDir(FullTestFolderName);
   RETURN 0;
  END; (* TRY *)
  RETURN 1;
 END {bckp_CheckForderAvailability};

 PRIVATE PROCEDURE TimedCHOICE(Title, Body: STRING[]);
  VAR
   T, React: NUMERIC[0];
 BEGIN
  T    :=60;
  React:=STDFORM(Body + "|| %<    {}⬥    >X     %<   {} %T >DB",
                 " " + Title + " ",
                 STOP,
                 1,
                 T);
 END {TimedCHOICE};

 PRIVATE PROCEDURE ConvertExcDescription(Exc: OBJECT): STRING[];
  VAR
   Msg: STRING[];
 BEGIN
  IF Exc.Class = "Exc_Object" THEN
   Msg:=" 訡 0x" + L_Math.DecToHex(Exc.ErrorCode) + ", " + Exc.MsgOriginalText;
  ELSE
   Msg:=" 訡 " + L_Str.IntStr(Exc.ErrorCode) + ", " + Exc.MsgOriginalText;
  END;
  RETURN Msg;
 END {ConvertExcDescription};

 PRIVATE PROCEDURE bckp_ShowErrorDialog(FullFileName, p_Dst, ExcDescription, prvErrorsDscrp: STRING[]);
  CONST
   MaxErrorDialogWidth = 76;
  VAR
   p_Src,
   FileName: STRING[];
 BEGIN
  IF ~L_General.BatchExecution_IsRunning() THEN
   p_Src   :=L_FIO.effp_Folder(FullFileName);
   FileName:=L_FIO.effp_FileName(FullFileName);
   TimedCHOICE(" ⥫쭮 १ࢭ ",
               "|ந諠 訡 ஢ 䠩 " + FileName + "." +
               "|⭥ ᥣ, 訡 맢 ᮪ 㧪 ." +
               "|஡   ஢" +
               "| 믮 楤 १ࢭ ஢ " +
               "|( ਮ  㧪 ࢥ)" +
               "||஢, 筮  ᢮   楫 ᪥." +
               "||᫨   ⠫ (室  楫) 㯭," +
               "|஡   ⠫  ஢  ⮣ ." +
               "||᫨ 訡 㤥 ,   ࠡ稪." +
               "|" + Str.Align("室 ⠫: " + p_Src, MaxErrorDialogWidth, LEFT) + L_Str.PoolItem("-|", bckp_CheckForderAvailability(p_Src)) +
               "|" + Str.Align(" ⠫ : " + p_Dst, MaxErrorDialogWidth, LEFT) + L_Str.PoolItem("-|", bckp_CheckForderAvailability(p_Dst)) +
               "||" + Str.Align("ᠭ 訡:", MaxErrorDialogWidth, LEFT) +
               "|" + ExcDescription +
               prvErrorsDscrp);
  END;
 END {bckp_ShowErrorDialog};

 PRIVATE PROCEDURE StrToDTS(DTSStr: STRING[]; FullFormat: SCAL[2]): TIMESTAMP;
  CONST
   Format_Pool = "yNDHM|yNDHMS";
  VAR
   Result: TIMESTAMP;
 BEGIN
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Result:=STRTOFLD(DTSStr, TIMESTAMP, L_Str.PoolItem(Format_Pool, FullFormat));
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = L_General.ec_rt_FailedSTRTOFLD THEN
    IF FullFormat THEN
     Result:=StrToDTS(DTSStr, 0);
    ELSE
     RAISE();
    END;
   END;
  END;
  RETURN Result;
 END {StrToDTS};

 PRIVATE PROCEDURE GetArchiveParams(    FullFileName          : STRING[];
                                    VAR IsFullAdditionalBackup: SCAL[2];
                                    VAR LastModifiedDTS       : TIMESTAMP);
  VAR
   FileName_woExt: STRING[];
 BEGIN
  FileName_woExt        :=L_FIO.effp_FileName_woExt(FullFileName);
  LastModifiedDTS       :=StrToDTS(Str.Item(FileName_woExt, "_", 0), 1);
  IsFullAdditionalBackup:=Str.Cap( Str.Item(FileName_woExt, "_", 1)) = "FULL";
 END {GetArchiveParams};

 PRIVATE PROCEDURE IsAdditionalBackupArchive_Int(FullFileName: STRING[]; FullFormat: SCAL[2]): SCAL[2];
  VAR
   DTS           : TIMESTAMP;
   Result        : SCAL[2];
   Mask,
   FileName_woExt: STRING[];
 BEGIN
  Result:=0;
  IF L_Str.IsEqStrI(L_FIO.effp_FileExt(FullFileName), "ZIP") THEN
   IF FullFormat THEN
    Mask:="??????????????";
   ELSE
    Mask:="????????????";
   END;
   FileName_woExt:=Str.Cap(L_FIO.effp_FileName_woExt(FullFileName));
   IF Str.Match(FileName_woExt, Mask+"_FULL") | Str.Match(FileName_woExt, Mask+"_MAIN") THEN
    TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     DTS   :=StrToDTS(Str.Item(FileName_woExt, "_", 0), FullFormat);
     Result:=1;
    EXCEPT
    ON Exc:Exc_Root DO
    END; (* TRY *)
   END;
  END;
  RETURN Result;
 END {IsAdditionalBackupArchive_Int};

 PRIVATE PROCEDURE IsAdditionalBackupArchive(FullFileName: STRING[]): SCAL[2];
 BEGIN
  RETURN IsAdditionalBackupArchive_Int(FullFileName, 1) | IsAdditionalBackupArchive_Int(FullFileName, 0);
 END {IsAdditionalBackupArchive};

 PRIVATE PROCEDURE GatherArchivesList(bckpf_Additional: STRING[]);
  VAR
   D                     : DATE;
   File                  : FOLDER_ENTRY;
   FolderContent         : ENUMERATOR;
   LastModifiedDTS       : TIMESTAMP;
   IsFullAdditionalBackup: SCAL[2];
 BEGIN
  APP.Get().NewPrompt("");
  FolderContent:=CreateENUMERATOR(FOLDER_ENTRY.Create(bckpf_Additional).FolderContent);
  WHILE ~FolderContent.AtEnd() DO
   File:=FolderContent.Item();
   PROMPT("⮢ ᯨ᪠ 䠩  㤠: "+File.Path);
   IF ~File.Attributes.Directory & IsAdditionalBackupArchive(File.Path) THEN
    GetArchiveParams(File.Path, IsFullAdditionalBackup, LastModifiedDTS);
    D:=L_DatTim.GetDateOfTIMESTAMP(LastModifiedDTS);
    ArchL.Path:=File.Path;
    ArchL.Full:=IsFullAdditionalBackup;
    ArchL.DTS :=LastModifiedDTS;
    ArchL.D   :=D;
    ArchL.y   :=L_DatTim.YEAR(D);
    ArchL.N   :=L_DatTim.MONTH(D);
    INSERT(ArchL);
   END;
   FolderContent.MoveNext();
  END; (* WHILE ~FolderContent.AtEnd() ... *)
 END {GatherArchivesList};

 PRIVATE PROCEDURE GetAvailableVolumeSpace(bckpf_Additional: STRING[]): NUMERIC[0];
  VAR
   bckp_fso: OBJECT;
 BEGIN
  bckp_fso:=CreateOBJECT("Scripting.FileSystemObject");
  RETURN bckp_fso.GetFolder(bckpf_Additional).Drive.AvailableSpace;
 END {GetAvailableVolumeSpace};

 PRIVATE PROCEDURE IsLastArhiveInSpecificPeriod(): SCAL[2];
  VAR
   Result: SCAL[2];
 BEGIN
  SAVE(ArchL);
  Result:=~NEXT(ArchL);
  RESTORE(ArchL);

  RETURN Result;
 END {IsLastArhiveInSpecificPeriod};

 PRIVATE PROCEDURE EraseAdditionalBackupArchive();
 BEGIN
  L_SysLog.ELN_Put("Remove.Old.BackUp", ArchL.Path);
  FIO.Erase(ArchL.Path);
 END {EraseAdditionalBackupArchive};

 PRIVATE PROCEDURE TryToFreeVolumeSpace(bckpf_Additional: STRING[]; RequiredVolumeSpace: NUMERIC[0]);
  CONST
   MinFullAdditionalBackupAmount = 3;
  VAR
   File                      : FOLDER_ENTRY;
   FolderContent             : ENUMERATOR;
   LastModifiedDTS           : TIMESTAMP;
   IsFullAdditionalBackup    : SCAL[2];
   ArchiveLastModifiedDTS,
   MinArchiveLastModifiedDTS : TIMESTAMP;
   FullAdditionalBackupAmount: NUMERIC[0];
 BEGIN
  IF GetAvailableVolumeSpace(bckpf_Additional) < RequiredVolumeSpace THEN
   PROMPT("⪠   ᪥");
   IF ~L_General.BatchExecution_IsRunning() THEN
    L_StdFrm.Confirm(" ᪥ 筮   ᮧ १ࢭ .|" +
                     "㤥 믮 ⮬᪮ 㤠  १ࢭ ");
   END;
   L_AFM.MakeMultipleIndex("ArchL", "Full : SCAL[2];"     +
                                    "Path : STRING[255];" +
                                    "DTS  : TIMESTAMP;"   +
                                    "D    : DATE;"        +
                                    "y    : NUMERIC[0];"  +
                                    "N    : NUMERIC[0]",
                           "Full: Full, y, N, DTS");

   GatherArchivesList(bckpf_Additional);

   SETZERO(FullAdditionalBackupAmount);
   SELECT(ArchL, Full, , 1);
   WHILE OCCURE(ArchL) DO
    INC(FullAdditionalBackupAmount);
    NEXT(ArchL);
   END; (* WHILE OCCURE(ArchL) ... *)

   IF FullAdditionalBackupAmount > MinFullAdditionalBackupAmount THEN
    SELECT(ArchL, Full, , 1);
    WHILE OCCURE(ArchL) DO
     NARROWSEL(ArchL, y);
     WHILE OCCURE(ArchL) & (FullAdditionalBackupAmount > MinFullAdditionalBackupAmount) DO
      PROMPT(" " + ArchL.Path);
      IF ~IsLastArhiveInSpecificPeriod() & (L_DatTim.IncYear(ArchL.D, 1) < SYSDATE()) THEN
       EraseAdditionalBackupArchive();
       DEC(FullAdditionalBackupAmount);
      END;
      NEXT(ArchL);
     END; (* WHILE OCCURE(ArchL) ... *)
     NEXTINEXTENDEDSEL(ArchL, y);
    END; (* WHILE OCCURE(ArchL) ... *)
   END;

   SETEMPTY(MinArchiveLastModifiedDTS);
   FolderContent:=CreateENUMERATOR(FOLDER_ENTRY.Create(bckpf_Additional).FolderContent);
   WHILE ~FolderContent.AtEnd() DO
    File:=FolderContent.Item();
    PROMPT(" ⥫   " + File.Path);
    IF ~File.Attributes.Directory & IsAdditionalBackupArchive(File.Path) THEN
     GetArchiveParams(File.Path, IsFullAdditionalBackup, ArchiveLastModifiedDTS);
     IF IsFullAdditionalBackup THEN
      IF !MinArchiveLastModifiedDTS THEN
       MinArchiveLastModifiedDTS:=ArchiveLastModifiedDTS;
      ELSE
       MinArchiveLastModifiedDTS:=Math.Min(MinArchiveLastModifiedDTS, ArchiveLastModifiedDTS);
      END;
     END;
    END;
    FolderContent.MoveNext();
   END; (* WHILE ~FolderContent.AtEnd() ... *)

   SELECT(ArchL, Full, , 0);
   WHILE OCCURE(ArchL) DO
    NARROWSEL(ArchL, y, N);
    WHILE OCCURE(ArchL) DO
     PROMPT(" " + ArchL.Path);
     IF (~!MinArchiveLastModifiedDTS & (ArchL.DTS < MinArchiveLastModifiedDTS)) |
        ~IsLastArhiveInSpecificPeriod() & ((ArchL.D + 7) < SYSDATE()) THEN
      EraseAdditionalBackupArchive();
     END;
     NEXT(ArchL);
    END; (* WHILE OCCURE(ArchL) ... *)
    NEXTINEXTENDEDSEL(ArchL, y, N);
   END; (* WHILE OCCURE(ArchL) ... *)
 
   IF GetAvailableVolumeSpace(bckpf_Additional) < RequiredVolumeSpace THEN
    L_General.Error(" 㤠 ᢮ 筮   ᮧ १ࢭ .|" +
                    "஡ 믮  , ⥬  ᮧ १ࢭ ");
   ELSE
    IF L_General.BatchExecution_IsRunning() THEN
     L_StdFrm.Warning("뫮 믮 㤠  १ࢭ |" +
                      " ᢮   ᪥");
    END;
   END;
  END;
 END {TryToFreeVolumeSpace};

 PRIVATE PROCEDURE GetLastSubFolder(FullFolderPath: STRING[]): STRING[];
  VAR
   Folders      : STRING[][10];
   FoldersAmount: NUMERIC[0];
 BEGIN
  L_FIO.SplitFolders(FullFolderPath, Folders, FoldersAmount);
  L_General.CallUs(~!Folders[FoldersAmount]);
  RETURN Folders[FoldersAmount];
 END {GetLastSubFolder};

 PRIVATE PROCEDURE bckp_CreateFolder(path: STRING[]);
  CONST
   fso_ecAccesDenied = -2146828218;
   fso_ecBadFileName = -2146828212;
  VAR
   parentPath: STRING[];
 BEGIN
  IF ~FIO.DirExists(path) THEN
   parentPath:=Str.Slice(path, 0, Str.Pos(path, "\", , BACKWARD));
   L_General.Assert(~!Str.Item(parentPath, "\", 1),
                    " " + Str.Item(parentPath, "\", 0) +
                    " 㯥,|    । ⥢  " +
                    GetLastSubFolder(path));
   L_General.Assert(parentPath # path, " ᮧ ⠫: " + path);
   TRY
    L_FIO.MakeSubDirs(path);
   EXCEPT
    ON Exc: Exc_Object DO
     IF    Exc.ErrorCode = fso_ecAccesDenied THEN
      L_General.Error(" ࠢ    ⠫ " + parentPath);
     ELSIF Exc.ErrorCode = fso_ecBadFileName THEN
      L_General.Error("⨬  ⠫: " + GetLastSubFolder(path));
     END;
     RAISE();
   END; (* TRY *)
  END;
 END {bckp_CreateFolder};

 PRIVATE PROCEDURE GetRGSLastModifiedDTS(bckpf_Actual: STRING[]): TIMESTAMP;
  VAR
   RGSFileName: STRING[];
 BEGIN
  RGSFileName:=FIO.BuildPath(DBD.BaseName(), "rgs", bckpf_Actual);
  L_General.CallUs(FIO.Exists(RGSFileName));
  RETURN L_FIO.GetFileLastModifiedDTS(RGSFileName);
 END {GetRGSLastModifiedDTS};

 PRIVATE PROCEDURE abckp_Make(abckp_Type      : tAdditionalBackupType;
                              bckpf_Actual    : STRING[];
                              bckpf_Additional: STRING[];
                              TimeOut         : NUMERIC[0]);
  CONST
   MaxCopyTryAmnt = 10;
  VAR
   abckp_MarkMsg   : STRING[];
   CopyTryAmnt     : NUMERIC[0];
   ErrorsDscrp,
   Suffix,
   ZipFileName,
   prvErrorsDscrp,
   IncludeFilesMask: STRING[];
 BEGIN
  IncludeFilesMask:='-include="' + FIO.BuildPath("*.rgs", , bckpf_Actual) + '" ' +
                    '-include="' + FIO.BuildPath("*.dbd", , bckpf_Actual) + '"';
  IF abckp_Type = abckpt_Full THEN
   Suffix          :="Full";
   abckp_MarkMsg   :=" १ࢭ ";
   IncludeFilesMask:=IncludeFilesMask + ' ' +
                     '-include="' + FIO.BuildPath("*.dap", , bckpf_Actual) + '"';
  ELSE
   Suffix          :="Main";
   abckp_MarkMsg   :=" १ࢭ ";
  END;
  L_StdFrm.TimedINFORM("㤥 ᮧ  " + abckp_MarkMsg, TimeOut);

  PROMPT("娢 १ࢭ ...");

  ZipFileName:=L_FIO.tf_GetFullPath(FLDTOSTR(GetRGSLastModifiedDTS(bckpf_Actual), "yNDHMS")+"_"+Suffix, "zip");

  IF FIO.Exists(ZipFileName) THEN
   FIO.Erase(ZipFileName);
  END;

  L_General.Assert(L_General.Launch_PKZIP("-add -dir=relative " + IncludeFilesMask,
                                          FIO.BuildPath("*.asb", , bckpf_Actual),
                                          ZipFileName) = L_General.eprc_Normal,
                   "訡  娢樨");

  L_FIO.SetFileLastModifiedDTS(ZipFileName, GetRGSLastModifiedDTS(bckpf_Actual));
  TryToFreeVolumeSpace(bckpf_Additional, L_FIO.GetFileSize(ZipFileName));

  CopyTryAmnt:=0;
  SETEMPTY(ErrorsDscrp, prvErrorsDscrp);
  LOOP
   TRY
    PROMPT("६饭 ⥫쭮 १ࢭ ...");
    FIO.RenMov(ZipFileName, , FIO.BuildPath(L_FIO.effp_FileName(ZipFileName), , bckpf_Additional));
   EXCEPT
   ON Exc: Exc_Root DO
    IF ~!ErrorsDscrp THEN
     prvErrorsDscrp:="||।騥 訡:|" + ErrorsDscrp;
    END;
    IF L_Math.DecToHex(Exc.ErrorCode) = "80070070" (*   ᪥*) THEN
     L_General.Error("ந諠 訡 ஢ 䠩|" + ZipFileName + "|" +
                     ConvertExcDescription(Exc) +
                     prvErrorsDscrp);
    ELSE
     INC(CopyTryAmnt);
     L_General.Assert(CopyTryAmnt < MaxCopyTryAmnt,
                      "஢ 䠩|" + ZipFileName + " :||" +
                      ConvertExcDescription(Exc) + "||" +
                      "஡  १ࢭ ஢ ." +
                      "||᫨ 訡 㤥 ,   ࠡ稪." +
                      prvErrorsDscrp);
     bckp_ShowErrorDialog(ZipFileName, bckpf_Additional, ConvertExcDescription(Exc), prvErrorsDscrp);
     ErrorsDscrp:=L_Str.AddStrDlm(ErrorsDscrp, "|") + ConvertExcDescription(Exc);
    END; (* IF L_Math.DecToHex(...*)
   END; (* TRY *)
   EXIT;
  END; (* LOOP *)
  PROMPT("");

  TRY [TRANSACTION(TRANSACTION_SLAVE)]
   SysLog.Mark("BACKUP", abckp_MarkMsg);
  EXCEPT
  ON Exc: Exc_Root DO
  END; (* TRY *)
  L_StdFrm.TimedINFORM("襭 ᮧ  १ࢭ :|(" + bckpf_Additional + ")", TimeOut);
 END {abckp_Make};

 PRIVATE PROCEDURE abckp_GetType(bckpf_Actual, bckpf_Additional: STRING[]): tAdditionalBackupType;
  VAR
   File                     : FOLDER_ENTRY;
   Result                   : tAdditionalBackupType;
   FolderContent            : ENUMERATOR;
   IsFullAdditionalBackup   : SCAL[2];
   ArchiveLastModifiedDTS,
   MaxArchiveLastModifiedDTS: TIMESTAMP;
 BEGIN
  APP.Get().NewPrompt("");
  SETEMPTY(Result, MaxArchiveLastModifiedDTS);

  FolderContent:=CreateENUMERATOR(FOLDER_ENTRY.Create(bckpf_Additional).FolderContent);
  WHILE ~FolderContent.AtEnd() DO
   File:=FolderContent.Item();
   PROMPT(" ⥫   " + File.Path);
   IF ~File.Attributes.Directory & IsAdditionalBackupArchive(File.Path) THEN
    GetArchiveParams(File.Path, IsFullAdditionalBackup, ArchiveLastModifiedDTS);
    IF IsFullAdditionalBackup THEN
     IF !MaxArchiveLastModifiedDTS THEN
      MaxArchiveLastModifiedDTS:=ArchiveLastModifiedDTS;
     ELSE
      MaxArchiveLastModifiedDTS:=Math.Max(MaxArchiveLastModifiedDTS, ArchiveLastModifiedDTS);
     END;
    END;
   END;
   FolderContent.MoveNext();
  END; (* WHILE ~FolderContent.AtEnd() ... *)

  IF ~!MaxArchiveLastModifiedDTS THEN
   FolderContent:=CreateENUMERATOR(FOLDER_ENTRY.Create(bckpf_Actual).FolderContent);
   WHILE ~FolderContent.AtEnd() & !Result DO
    File:=FolderContent.Item();
    PROMPT("  १ࢭ  " + File.Path);
    IF ~File.Attributes.Directory       &
       bckp_IsFileOfFullPart(File.Path) &
       (File.TimeLastModified > MaxArchiveLastModifiedDTS) THEN
     Result:=abckpt_Full;
    END;
    FolderContent.MoveNext();
   END; (* WHILE ~FolderContent.AtEnd() ... *)
  ELSE
   Result:=abckpt_Full;
  END;

  IF !Result THEN
   Result:=abckpt_Main;
  END;
  RETURN Result;
 END {abckp_GetType};

 PRIVATE PROCEDURE bckp_PrepareAdditionalFolder(bckpf_Additional: STRING[]);
 BEGIN
  L_General.Assert(L_FIO.IsFullUNCPath(bckpf_Additional),
                   "୮ ଫ ⥪ ன 9007.||"+
                   '"'+bckpf_Additional+'"||   ⥬  ଠ UNC.');
  IF ~FIO.DirExists(bckpf_Additional) THEN
   L_StdFrm.Warning("   ⮢ १ࢭ   :" +
                    "|" + "(" + bckpf_Additional + ")" +
                    "||" + " ?");
   bckp_CreateFolder(bckpf_Additional);
  END;
 END {bckp_PrepareAdditionalFolder};

 PRIVATE PROCEDURE intBackup(TimeOut: NUMERIC[0]);
  CONST
   MaxTryAmnt = 10;
  VAR
   TryAmnt         : NUMERIC[0];
   abckp_Type      : tAdditionalBackupType;
   ErrorsDscrp,
   bckpf_Actual,
   bckpf_Additional: STRING[];
 BEGIN
  APP.Get().NewPrompt("ࢭ ஢");
  bckpf_Actual    :=bckp_GetActualFullPath();
  bckpf_Additional:=bckp_GetAdditionalRootPath();

  BACKUP(BACKUPSRC_FULLDATAONLY, bckpf_ActualRoot, BACKUPMTH_UPDATE);

  L_StdFrm.TimedINFORM("  १ࢭ  襭." +
                       "||짮⥫ ⥬ 㦥 ࠡ", TimeOut);

  TRY
   bckp_PrepareAdditionalFolder(bckpf_Additional);
  EXCEPT
  ELSE
   IF ~APP.Get().ProductiveCopy THEN
    IF TimeOut > 0 THEN
    L_StdFrm.Warning(" ࠡ⠥  ୮  ஥." +
                     "||ࢭ ஢ 㤥 믮" +
                     "| ᮧ ⥫쭮 ");
    END;
    SETEMPTY(bckpf_Additional);
   ELSE
    RAISE();
   END;
  END; (* TRY *)

  IF ~!bckpf_Additional THEN
   SETZERO(TryAmnt);
   SETEMPTY(ErrorsDscrp);
   LOOP
    TRY
     abckp_Type:=abckp_GetType(bckpf_Actual, bckpf_Additional);
     EXIT;
    EXCEPT
    ON Exc: Exc_Root DO
     INC(TryAmnt);
     ErrorsDscrp:=L_Str.AddStrDlm(ErrorsDscrp, "|") + ConvertExcDescription(Exc);
     L_General.Assert(TryAmnt < MaxTryAmnt,
                      " 㤠 믮 ࠢ १ࢭ ." +
                      "|஡  १ࢭ ஢ ." +
                      "||᫨ 訡 㤥 ,   ࠡ稪." +
                      "|।騥 訡:" +
                      "|" + ErrorsDscrp);
     TimedCHOICE("ࠢ ",
                 "ந諠 訡  ६ ࠢ .|" +
                 "||᫨ 訡 㤥 ,   ࠡ稪." +
                 "|ᠭ 訡:" +
                 "|" + ConvertExcDescription(Exc));
    END; (* TRY *)
   END; (* LOOP *)
   abckp_Make(abckp_Type, bckpf_Actual, bckpf_Additional, TimeOut);
  END;
 END {intBackup};

 PUBLIC PROCEDURE Backup();
  VAR
   StopT,
   TimeOut: NUMERIC[0];
 BEGIN
  TimeOut:=0;
  StopT  :=20;
  STDFORM("|  १ࢭ ." +
          "||ଠ樮 ᮮ饭 뢠%4Iᥪ㭤." +
          "||%< ⮯! %T >X    %< {}믮 >DB",
          "",
          INFORM, -1,
          TimeOut, StopT);
  intBackup(TimeOut);
 END {Backup};

 PUBLIC PROCEDURE BackupByGuard();
 BEGIN
  intBackup(0);
 END {BackupByGuard};

 PRIVATE CONST
  wdFalse = 0;

  SearchModePool     = " 砫  ६|    ६";

  dp_Document = 0;
  dp_Header   = 1;
  dp_Footer   = 2;
  dp_Pool = "㬥|孨 | ";

(*
$P{ SrcRs_Top:
L_OwnData.ODFirmName(SYSDATE()), L, ""
SYSDATE(), L, "D.N.y"
SYSTIME(), L, "H:M"
?, L, ""
?, L, ""
?, L, ""
?, L, SearchModePool
@
############################################################################################# ########## #####
=#####========================================================================================================
|                             ᪠ DocVariable  蠡 MS Word                                |
| ᪠: ############################################################################################|
| ᪠  : ############################################################################################|
| ᪠  : ############################################################################################|
}
*)

(*
$P{ SrcRs_TemplateName:
?, L, ""
@
==============================================================================================================
|############################################################################################################|
}
*)

(*
$P{ SrcRs_DocumentPart:
?, L, ""
@
|------------------------------------------------------------------------------------------------------------|
|############################################################################################################|
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ SrcRs_DocVariable:
?, L, ""
@
|  ##########################################################################################################|
}
*)

(*
$P{ SrcRs_Dlm:
@
|------------------------------------------------------------------------------------------------------------|
}
*)

(*
$P{ SrcRs_SubBot:
?, L, ""
?, R, "0"
@
|############################# ####                                                                          |
}
*)

(*
$P{ SrcRs_Bot:
@
=(c) Polak====================================================================================================
}
*)

 PRIVATE PROCEDURE GetDocVariableName(Code: STRING[]): STRING[];
  VAR
   i     : NUMERIC[0];
   Found : SCAL[2];
   Result: STRING[];
 BEGIN
  SETZERO(i, Found);
  LOOP
   Result:=Str.Item(Code, " ", i);
   IF !Result THEN
    EXIT;
   END;
   IF Str.Pos(Result, ".") # Str.Length(Result) THEN
    Found:=1;
    EXIT;
   END;
   INC(i);
  END; (* LOOP *)
  IF ~Found THEN
   Result:=Code;
  END;
  RETURN Str.Condense(Result);
 END {GetDocVariableName};

 PRIVATE PROCEDURE CheckFieldCollection(    DotName_wDTS,
                                            DocVariables          : STRING[];
                                            InWholeDocvariableName: SCAL[2];
                                            FieldCollection       : OBJECT;
                                            DocumentPart          : SCAL[3];
                                        VAR fp_Template           : SCAL[2];
                                        VAR Found                 : SCAL[2]);
  CONST
   wdFieldDocVariable = 64;
  VAR
   i, j             : NUMERIC[0];
   _Code,
   SingleDocVariable: STRING[];
   Field            : OBJECT;
   fp_DocumentPart  : SCAL[2];
 BEGIN
  APP.Get().NewPrompt(" ");
  fp_DocumentPart:=1;
  j              :=FieldCollection.Count;
  WHILE j > 0 DO
   PROMPT(L_Str.IntStr(j));
   Field:=FieldCollection(j);
   IF Field.Type = wdFieldDocVariable THEN
    _Code:=GetDocVariableName(Field.Code.Text);
    i:=0;
    LOOP
     SingleDocVariable:=L_Str.AnyItem(DocVariables, ";", i);
     IF !SingleDocVariable THEN
      EXIT;
     END;
     IF (InWholeDocvariableName  & Str.Match(_Code, "*" + SingleDocVariable + "*")) |
        (~InWholeDocvariableName & Str.Match(_Code, SingleDocVariable + "*")) THEN
      IF fp_Template THEN
       MAKEPART(R, SrcRs_TemplateName, DotName_wDTS);
       fp_Template:=0;
      END;

      IF fp_DocumentPart THEN
       MAKEPART(R, SrcRs_DocumentPart, L_Str.PoolItem(dp_Pool, DocumentPart));
       fp_DocumentPart:=0;
      END;

      MAKEPART(R, SrcRs_DocVariable, _Code);
      Found:=1;
     END;
     INC(i);
    END; (* LOOP *)
   END;
   DEC(j);
  END;
 END {CheckFieldCollection};

 PRIVATE PROCEDURE CheckDocVariableExists(DotFullName           : STRING[];
                                          DTS                   : TIMESTAMP;
                                          DocVariables          : STRING[];
                                          InWholeDocvariableName: SCAL[2];
                                          word                  : OBJECT): SCAL[2];
  VAR
   i, j, Pos   : NUMERIC[0];
   Document    : OBJECT;
   Found,
   fp_Template : SCAL[2];
   DotName_wDTS: STRING[];
 BEGIN
  APP.Get().NewPrompt("");
  PROMPT("ࠡ⪠ 㬥");
  Found      :=0;
  fp_Template:=1;
  Pos        :=Str.Pos(Str.Cap(DotFullName), "AUTOPARK.LIB");
  IF Pos = Str.Length(DotFullName) THEN
   Pos:=Str.Length(FIO.AsbSpecialFolders("ClientProjectRoot"))+1;
  END;
  DotName_wDTS:=Str.Align(Str.Delete(DotFullName, 0, Pos), 108 - 16, LEFT) + L_DatTim.TimestampStr(DTS);
  Document    :=word.Documents.Open(DotFullName, wdFalse);
  CheckFieldCollection(DotName_wDTS, DocVariables, InWholeDocvariableName, Document.Fields, dp_Document, fp_Template, Found);
  i:=1;
  WHILE i <= Document.Sections.Count DO
   j:=1;
   WHILE j <= Document.Sections(i).Headers.Count DO
    PROMPT("ࠡ⪠ Headers " + L_Str.IntStr(j));
    IF Document.Sections(i).Headers(j).LinkToPrevious = wdFalse THEN
     CheckFieldCollection(DotName_wDTS, DocVariables, InWholeDocvariableName, Document.Sections(i).Headers(j).Range.Fields, dp_Header, fp_Template, Found);
    END;
    INC(j);
   END;
   j:=1;
   WHILE j <= Document.Sections(i).Footers.Count DO
    PROMPT("ࠡ⪠ Footers " + L_Str.IntStr(j));
    IF Document.Sections(i).Footers(j).LinkToPrevious = wdFalse THEN
     CheckFieldCollection(DotName_wDTS, DocVariables, InWholeDocvariableName, Document.Sections(i).Footers(j).Range.Fields, dp_Footer, fp_Template, Found);
    END;
    INC(j);
   END;
   INC(i);
  END;
  Document.Close(wdFalse);
  RETURN Found;
 END {CheckDocVariableExists};

 PRIVATE PROCEDURE IsAcceptableTemplate(SearchLocation: SCAL[3]; IsBY_USERTemplate: SCAL[2]): SCAL[2];
 BEGIN
  RETURN (SearchLocation  = sl_AllTemplate)                           |
         ((SearchLocation = sl_BY_USERTemplate) &  IsBY_USERTemplate) |
         ((SearchLocation = sl_SystemTemplate)  & ~IsBY_USERTemplate);
 END {IsAcceptableTemplate};

 PUBLIC PROCEDURE extSearchDocVariablesInMSWordTemplates(    RepFullName           : STRING[];
                                                             SearchLocationPool    : STRING[];
                                                             SearchLocation        : SCAL[3];
                                                             DocVariableNames      : STRING[];
                                                             InWholeDocvariableName: SCAL[2];
                                                         VAR TotalAmount           : NUMERIC[0]);
  VAR
   word,
   File             : OBJECT;
   Amount           : NUMERIC[0][2];
   SrcFolder        : FOLDER_ENTRY;
   DotFullName      : STRING[];
   FilesCollection  : ENUMERATOR;
   IsBY_USERTemplate: SCAL[2];
 BEGIN
  TRY [TERM_BY_USER(TERM_BY_USER_THROW)]
   SETZERO(Amount);
   L_General.Assert(~!SearchLocation, " ࠭  ᪠");
   L_General.Assert(~!DocVariableNames, " 㪠 ப ᪠");
   word        :=CreateOBJECT("Word.Application");
   word.Visible:=wdFalse;
   OPENREP(R, RepFullName, Create);

   MAKEPART(R, SrcRs_Top, Str.Slice(L_FIO.effp_FileName_woExt(RepFullName), 0, 5),
                          L_Str.PoolItem(SearchLocationPool, SearchLocation),
                          DocVariableNames,
                          InWholeDocvariableName);
   SrcFolder      :=FOLDER_ENTRY.CreateRedirector("*.DOT");
   FilesCollection:=CreateENUMERATOR(SrcFolder.FolderContent);
   WHILE ~FilesCollection.AtEnd() DO
    File             :=FilesCollection.Item();
    DotFullName      :=Str.Cap(FilesCollection.Item().Path);
    IsBY_USERTemplate:=L_MSO.IsBY_USERTemplate(DotFullName);
    PROMPT(" " + DotFullName);
    IF (Str.Cap(L_FIO.effp_FileExt(DotFullName)) = "DOT") &
       (Str.Slice(L_FIO.effp_FileName(DotFullName), 0, 2) # "~$") &
       IsAcceptableTemplate(SearchLocation, IsBY_USERTemplate) THEN
     IF CheckDocVariableExists(DotFullName, File.DateLastModified, DocVariableNames, InWholeDocvariableName, word) THEN
      INC(Amount[IsBY_USERTemplate]);
     END;
    END;
    FilesCollection.MoveNext();
   END; (*WHILE*)
   word.Quit();
   SETEMPTY(word);
   TotalAmount:=Amount[0] + Amount[1];
   MAKEPART(R, SrcRs_Dlm);
   MAKEPART(R, SrcRs_SubBot, "ᥣ 蠡", TotalAmount);
   IF SearchLocation = sl_AllTemplate THEN
    MAKEPART(R, SrcRs_SubBot, "  ⮬ ᫥ 짮⥫᪨", Amount[1]);
   END;
   MAKEPART(R, SrcRs_Bot);
   CLOSEREP(R);
  EXCEPT
  ON Exc: Exc_Root DO
   RAISE();
  FINALLY
   IF VAR_IMPL.Get(word).Initialized & ~!word THEN
    word.Quit();
   END;
  END; (* TRY *)
 END {extSearchDocVariablesInMSWordTemplates};

 PUBLIC PROCEDURE SearchDocVariablesInMSWordTemplates();
  CONST
   RepName = "SrcRs";
  VAR
   Dummy                 : NUMERIC[2];
   SearchLocation        : SCAL[3];
   DocVariableNames,
   SearchLocationPool    : STRING[];
   InWholeDocvariableName: SCAL[2];
 BEGIN
  SETEMPTY(DocVariableNames);
  IF L_General.IsOurEngineeringCopy() THEN
   SearchLocation:=sl_AllTemplate;
  ELSE
   SearchLocation:=sl_BY_USERTemplate;
  END;

  SearchLocationPool:="  蠡| 짮⥫᪨ 蠡";
  IF L_General.IsOurSite() THEN
   SearchLocationPool:=SearchLocationPool + "| ⥬ 蠡";
  END;
  InWholeDocvariableName:=1;
  STDFORM(L_StdFrm.sf_Choice("| ᪠ %###########################%      " +
                             "|" +
                             "|᪠         %#################################%" +
                             "|" +
                             "| ᪠   %#################################%" +
                             L_StdFrm.HR() +
                             " ᪠ ᪮쪨 DocVariable"+
                             "| ६  १ ;",
                             "%L<" + SearchLocationPool + ">I"+
                             "%L<>I"+
                             "%L<" + SearchModePool + ">I"),
                             " DocVariable  蠡 Word",
                             INFORM_NEUTRAL,
                             ,
                             SearchLocation, DocVariableNames, InWholeDocvariableName);
  extSearchDocVariablesInMSWordTemplates(L_General.NameConnection(RepName), SearchLocationPool, SearchLocation, DocVariableNames, InWholeDocvariableName, Dummy);
  L_General.SurveyLastReport();
 END {SearchDocVariablesInMSWordTemplates};

 PUBLIC PROCEDURE LaunchFAR();
  VAR
   Dummy: NUMERIC[0];
 BEGIN
  L_General.Assert(~UNDERREMOTECONTROL(), " 室  ࠢ");
  Dummy:=L_General.ExecEP(L_General.ept_Special, "FAR.EXE", "", "", L_General.ws_Normal, 0, L_General.eprc_Normal);
 END {LaunchFAR};

 PRIVATE PROCEDURE ChatWRC_GetRCName(): STRING[];
  VAR
   Name: STRING[];
 BEGIN
  IF UNDERREMOTECONTROL(Name) THEN
   RETURN Name;
  ELSE
   RETURN chat_NoRCUser;
  END;
 END {ChatWRC_GetRCName};

 PRIVATE PROCEDURE ChatWRC_GetFullName(Login: STRING[]): STRING[];
 BEGIN
  IF Login # chat_NoRCUser THEN
   L_General.CallUs(L_AR.StandOnUser(Login));
   RETURN AcsObj.FullName + " (" + Login + ")";
  ELSE
   RETURN Login;
  END;
 END {ChatWRC_GetFullName};

 PRIVATE PROCEDURE ChatWRC_SetWhoIsWho();
  VAR
   Fields: FORM_FIELDS;
 BEGIN
  Fields:=RTI.Get().CurZone.Fields;
  Fields("Chat_RCName").Value      :=ChatWRC_GetFullName(ChatWRC_GetRCName());
  Fields("Chat_UserName").Value    :=ChatWRC_GetFullName(LOGINNAME());
  Fields("Chat_RCInput").Modifiable:=UNDERREMOTECONTROL();
 END {ChatWRC_SetWhoIsWho};

 PRIVATE PROCEDURE ChatWRC_OnBeforeEdit();
 BEGIN
  ChatWRC_SetWhoIsWho();
  IF ~UNDERREMOTECONTROL() THEN
   L_StdFrm.RedInform("  室  ࠢ.||" + " ⮫쪮 ᬮ ");
  END;
 END {ChatWRC_OnBeforeEdit};

 PUBLIC PROCEDURE OpenChat();
 BEGIN
  LIKEMENU(Edit, "ChatWRC 0");
 END {OpenChat};

 PRIVATE PROCEDURE Chat_History_Cut(Chat_History: FORM_FIELD);
  CONST
   HistoryWidth  = 76;
   HistoryHeight = 16;
  VAR
   HistoryArr: STRING[][40];
   Height, i : NUMERIC[0];
 BEGIN
  Str.Format(HistoryArr, Chat_History.Value, HistoryWidth, LEFT);
  Height:=0;
  WHILE ~!HistoryArr[Height] DO
   INC(Height);
  END;
  i:=Math.Max(0, Height - HistoryHeight);
  SETEMPTY(Chat_History.Value);
  WHILE i < Height DO
   Chat_History.Value:=Chat_History.Value + HistoryArr[i] + L_Str.CRLF;
   INC(i);
  END;
 END {Chat_History_Cut};

 PRIVATE PROCEDURE PutMessage(RCName, Msg: STRING[]);
 BEGIN
  L_General.CallUs(L_AR.StandOnUser(RCName));
  IF AcsObj.AcsObj # L_General.curUSER THEN
   L_Msg.MakeAnyRecordMsg(L_Msg.mt_Org, AcsObj.AcsObj, L_General.curUSER, L_Msg.mi_Normal,
                          Msg, SYSTIMESTAMP(), "", "");
   SELECT(Message, Org, , Message.Message);
   L_Msg.ToggleMessageStatus();
  ELSE
   L_Msg.MakeCurRecordNote("", Msg);
  END;
 END {PutMessage};

 PRIVATE PROCEDURE SaveChatMessage(RCName: STRING[]);
  VAR
   Field: FORM_FIELD;
 BEGIN
  IF RTI.Get().CurWindow.OriginalName = "ChatWRC" THEN
   Field:=RTI.Get().CurZone.ActiveField;
   IF (Field.Name = "Chat_RCInput") | (Field.Name = "Chat_UserInput") THEN
    PutMessage(RCName, Field.Value);
   END;
  END;
 END {SaveChatMessage};

 PRIVATE PROCEDURE ChatWRC_Chat_AnyInput_OnSuccessfulChange(Remote: SCAL[2]);
  CONST
   MessageNotSend = "[ ࠢ]";
  VAR
   RCName,
   AuthorName : STRING[];
   HistField,
   ActiveField: FORM_FIELD;
   Pos        : NUMERIC[0];
 BEGIN
  ActiveField:=RTI.Get().CurZone.ActiveField;
  ChatWRC_SetWhoIsWho();
  IF UNDERREMOTECONTROL(RCName) THEN
   IF ~!ActiveField.Value THEN
    TRY [TRANSACTION(TRANSACTION_SLAVE)]
     SaveChatMessage(RCName);
    EXCEPT
    ON Exc: Exc_Raise DO
     RAISE();
    END; (* TRY *)

    SETEMPTY(AuthorName);
    IF    Remote THEN
     AuthorName:=RCName;
    ELSE
     AuthorName:=LOGINNAME();
     IF Str.Pos(ActiveField.Value, MessageNotSend) = 0 THEN
      ActiveField.Value:=Str.Delete(ActiveField.Value, 0, Str.Length(MessageNotSend));
     END;
    END;
    IF ~!AuthorName THEN
     HistField:=RTI.Get().CurZone.Fields("Chat_History");
     HistField.Value:=HistField.Value + AuthorName +
                      " (" + FLDTOSTR(L_DatTim.GetSysTIMESTAMP(), "H:M:S D.N.y") + "): " +
                      ActiveField.Value + L_Str.CRLF;
     Chat_History_Cut(HistField);
     SETEMPTY(ActiveField.Value);
    END;
   END;
  ELSE
   IF ~Remote & ~!ActiveField.Value THEN
    IF Str.Pos(ActiveField.Value, MessageNotSend) # 0 THEN
     ActiveField.Value:=MessageNotSend + ActiveField.Value;
    END;
   END;
   L_StdFrm.RedInform("  室  ࠢ.|| ⮫쪮 ᬮ ");
  END;
 END {ChatWRC_Chat_AnyInput_OnSuccessfulChange};

 PRIVATE PROCEDURE ChatWRC_Chat_RCInput_OnSuccessfulChange();
 BEGIN
  ChatWRC_Chat_AnyInput_OnSuccessfulChange(1);
 END {ChatWRC_Chat_RCInput_OnSuccessfulChange};

 PRIVATE PROCEDURE ChatWRC_Chat_UserInput_OnSuccessfulChange();
 BEGIN
  ChatWRC_Chat_AnyInput_OnSuccessfulChange(0);
 END {ChatWRC_Chat_UserInput_OnSuccessfulChange};

 PUBLIC PROCEDURE UploadDBStructureToExcel();
  VAR
   objXL,
   objWB,
   objWS_files,
   objWS_fields, 
   objWS_Indexes,
   objWS_links: OBJECT;
   fileIdx,
   fieldIdx,
   indexIdx,
   indexfieldIdx,
   linkIdx    : NUMERIC[0];
   fileName,
   fieldName,
   indexName,
   linkName  : STRING[];
 BEGIN
  SETEMPTY(objXL, objWB);
  TRY
   PROMPT("⮢...");
   L_General.Assert(L_Excel.ExcelInstalled(), "Excel  ⠭");
   objXL:=CreateOBJECT("Excel.Application");
   objXL.Visible       :=L_Excel.xlFalse;
   objXL.EnableEvents  :=L_Excel.xlFalse;
   objXL.ScreenUpdating:=L_Excel.xlFalse;
   
   objWB:=L_Excel.NewWorkbook(objXL, 4);

   objWS_files :=objWB.WorkSheets(1);
   objWS_files.Name:="";

   objWS_fields:=objWB.WorkSheets(2);
   objWS_fields.Name:="ਡ";

   objWS_Indexes:=objWB.WorkSheets(3);
   objWS_Indexes.Name:="";

   objWS_links:=objWB.WorkSheets(4);
   objWS_links.Name:="뫪";

   L_Excel.ws_Init(objWS_files);
   L_Excel.ws_AddColumn(objWS_files, L_General.ft_STRING,  0, "", "");
   L_Excel.ws_AddColumn(objWS_files, L_General.ft_STRING,  0, "ᠭ", "");
   L_Excel.ws_AddColumn(objWS_files, L_General.ft_STRING,  0, "", "");
   L_Excel.ws_TermLine(objWS_files);

   L_Excel.ws_Init(objWS_fields);
   L_Excel.ws_AddColumn(objWS_fields, L_General.ft_STRING,  0, "", "");
   L_Excel.ws_AddColumn(objWS_fields, L_General.ft_STRING,  0, "ਡ", "");
   L_Excel.ws_AddColumn(objWS_fields, L_General.ft_STRING,  0, " ", "");
   L_Excel.ws_AddColumn(objWS_fields, L_General.ft_STRING,  0, "ᠭ", "");
   L_Excel.ws_TermLine(objWS_fields);

   L_Excel.ws_Init(objWS_Indexes);
   L_Excel.ws_AddColumn(objWS_Indexes, L_General.ft_STRING,  0, "", "");
   L_Excel.ws_AddColumn(objWS_Indexes, L_General.ft_STRING,  0, " ", "");
   L_Excel.ws_AddColumn(objWS_Indexes, L_General.ft_STRING,  0, "ᠭ", "");
   L_Excel.ws_AddColumn(objWS_Indexes, L_General.ft_STRING,  0, "쭮", "");
   L_Excel.ws_AddColumn(objWS_Indexes, L_General.ft_STRING,  0, "᫮   ", "");
   L_Excel.ws_AddColumn(objWS_Indexes, L_General.ft_STRING,  0, " 1", "");
   L_Excel.ws_AddColumn(objWS_Indexes, L_General.ft_STRING,  0, " 2", "");
   L_Excel.ws_AddColumn(objWS_Indexes, L_General.ft_STRING,  0, " 3", "");
   L_Excel.ws_AddColumn(objWS_Indexes, L_General.ft_STRING,  0, " 4", "");
   L_Excel.ws_AddColumn(objWS_Indexes, L_General.ft_STRING,  0, " 5", "");
   L_Excel.ws_AddColumn(objWS_Indexes, L_General.ft_STRING,  0, " 6", "");
   L_Excel.ws_AddColumn(objWS_Indexes, L_General.ft_STRING,  0, " 7", "");
   L_Excel.ws_AddColumn(objWS_Indexes, L_General.ft_STRING,  0, " 8", "");
   L_Excel.ws_TermLine(objWS_Indexes);

   L_Excel.ws_Init(objWS_links);
   L_Excel.ws_AddColumn(objWS_links, L_General.ft_STRING,  0, "", "");
   L_Excel.ws_AddColumn(objWS_links, L_General.ft_STRING,  0, " 뫪", "");
   L_Excel.ws_AddColumn(objWS_links, L_General.ft_STRING,  0, " ", "");
   L_Excel.ws_AddColumn(objWS_links, L_General.ft_STRING,  0, "㦠 ⠡", "");
   L_Excel.ws_AddColumn(objWS_links, L_General.ft_STRING,  0, "㦮 ", "");
   L_Excel.ws_AddColumn(objWS_links, L_General.ft_STRING,  0, "ᠭ", "");
   L_Excel.ws_TermLine(objWS_links);

   fileIdx:=0;
   WHILE fileIdx < DBD.FileAmount() DO
    fileName:=DBD.FileName(fileIdx);
    L_Excel.ws_WrStr(objWS_files, fileName);
    L_Excel.ws_WrStr(objWS_files, DBD.FileDescription(^fileName));
    L_Excel.ws_TermLine(objWS_files);

    fieldIdx:=0;
    WHILE fieldIdx < DBD.FieldAmount(^fileName) DO
     fieldName:=DBD.FieldName(^fileName, fieldIdx);
     PROMPT(fileName + "." + fieldName);
     L_Excel.ws_WrStr(objWS_fields, fileName);
     L_Excel.ws_WrStr(objWS_fields, fieldName);
     L_Excel.ws_WrStr(objWS_fields, TYPENAMEOF(^(DBD.FieldFullName(^fileName, fieldIdx))));
     L_Excel.ws_WrStr(objWS_fields, DBD.FieldDescription(^fileName, ^fieldName));
     L_Excel.ws_TermLine(objWS_fields);
     INC(fieldIdx);
    END;

    indexIdx:=0;
    WHILE indexIdx < DBD.IndexAmount(^fileName) DO
     indexName:=DBD.IndexName(^fileName, indexIdx);
     PROMPT(fileName + "." + indexName);
     L_Excel.ws_WrStr(objWS_Indexes, fileName);
     L_Excel.ws_WrStr(objWS_Indexes, indexName);
     L_Excel.ws_WrStr(objWS_Indexes, DBD.IndexDescription(^fileName, ^indexName));
     L_Excel.ws_WrStr(objWS_Indexes, L_Str.PoolItem('PLURAL|UNIQUE|AUTOINCR', DBD.IndexUnique(^fileName, ^indexName)));
     L_Excel.ws_WrStr(objWS_Indexes, FLDTOSTR(DBD.IndexFieldAmount(^fileName, ^indexName)));
     indexfieldIdx:=0;
     WHILE indexfieldIdx < DBD.IndexFieldAmount(^fileName, ^indexName) DO
      L_Excel.ws_WrStr(objWS_Indexes, DBD.IndexFieldName(^fileName, ^indexName, indexfieldIdx));
      INC(indexfieldIdx);
     END;
     L_Excel.ws_TermLine(objWS_Indexes);
     INC(indexIdx);
    END;

    linkIdx:=0;
    WHILE linkIdx < DBD.LinkAmount(^fileName) DO
     linkName:=DBD.LinkName(^fileName, linkIdx);
     PROMPT(fileName + "." + linkName);
     L_Excel.ws_WrStr(objWS_links, fileName);
     L_Excel.ws_WrStr(objWS_links, linkName);
     L_Excel.ws_WrStr(objWS_links, DBD.LinkIndexName(^fileName, ^linkName));
     L_Excel.ws_WrStr(objWS_links,DBD.LinkCooFileName(^fileName, ^linkName));
     L_Excel.ws_WrStr(objWS_links, DBD.LinkCooIndexName(^fileName, ^linkName));
     L_Excel.ws_WrStr(objWS_links, DBD.LinkDescription(^fileName, ^linkName));
     L_Excel.ws_TermLine(objWS_links);
     INC(linkIdx);
    END;

    INC(fileIdx);
   END;

   objWS_files.UsedRange.EntireColumn.AutoFit();
   objWS_fields.UsedRange.EntireColumn.AutoFit();
   objWS_Indexes.UsedRange.EntireColumn.AutoFit();
   objWS_links.UsedRange.EntireColumn.AutoFit();

   objWS_fields.UsedRange.AutoFilter();
   objWS_Indexes.UsedRange.AutoFilter();
   objWS_links.UsedRange.AutoFilter();

   objWS_files.Visible :=L_Excel.xlTrue;
   objWS_fields.Visible:=L_Excel.xlTrue;
   objWS_Indexes.Visible:=L_Excel.xlTrue;
   objWS_links.Visible:=L_Excel.xlTrue;

   objWB.SaveAs("DBStructure_" + DBD.BaseName());
   objXL.ScreenUpdating:=L_Excel.xlTrue;
   objXL.EnableEvents  :=L_Excel.xlTrue;
   objXL.Visible       :=L_Excel.xlTrue;
  EXCEPT
  ON Exc: Exc_Root DO
   L_Excel.CloseExcelAfterCrash(objXL, objWB);
   RAISE();
  END; (* TRY *)
 END {UploadDBStructureToExcel};

 PUBLIC PROCEDURE SetCustomSelect();
 BEGIN
  L_WDO.SetCustomSelectForm();
 END {SetCustomSelect};

 PRIVATE PROCEDURE GetTopWindowMaster(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  SETEMPTY(Result);
  IF ~!APP.Get().TopWindow &
     (APP.Get().TopWindow.Type # WINDOW.Type_Survey) &
     ~!APP.Get().TopWindow.ActiveZone &
     ~!APP.Get().TopWindow.ActiveZone.MasterTable THEN
   Result:=APP.Get().TopWindow.ActiveZone.MasterTable.Name;
  END;
  RETURN Result;
 END {GetTopWindowMaster};

 PUBLIC PROCEDURE LaunchF1();
  CONST
   ⢠_Unicode  = ".D0.A1.D0.B2.D0.BE.D0.B9.D1.81.D1.82.D0.B2.D0.B0";
  VAR
   Host,
   Page,
   humPagePat,
   humPage,
   CurFile,
   S           : STRING[];
   po          : L_Prop.tProObject;
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_HOTTEST;
  Host:="http://www.autopark.ru/wiki/";
  CurFile:=GetTopWindowMaster();
  IF ~!CurFile THEN
   S:=Str.BracketedItem(DBD.FileComment(^CurFile), 0);
   IF ~!S THEN
    CurFile:=S;
   END;
  END;
  L_PDBS.GetF1SpecialPage(CurFile, Page, humPagePat);
  IF !Page THEN
   IF ~!CurFile THEN
    Page:=DBD.FileDescription(^CurFile);
    humPagePat:=Page;
    IF ~!L_DBD.Get2FilesLinkName(CurFile, "Property") THEN
     FOR_EACH po DO
      IF L_Prop.ObjectFileProName(po) = CurFile THEN
       Page:=DBD.FileDescription(^(L_Prop.ObjectFileName(po)));
       IF ACCESS(^CurFile) THEN
        humPagePat:=Page + " (co " + ^CurFile.Property + ")";
        Page:=Page + "#" + ^CurFile.Property;
       ELSE
        SELECT(Property, PropObj, , po);
        humPagePat:=Page + " (c⢠)";
        Page:=Page + "#" + Property.Property;
       END;
       EXIT;
      END;
     END; (* FOR_EACH *)
    END;
   ELSE
    Page:="⥣:㪠";
    humPagePat:="㪠";
   END;
  END;
  humPage:=humPagePat;
  STDFORM(L_StdFrm.sf_Choice("| 㤥 믮 室  ࠭ 㬥樨 ⮏."+
                             "|( ୥   www.autopark.ru)"+
                             "|"+
                             "|%##########################################################################%" +
                             L_StdFrm.HR() +
                             "   । ࠭  ᫮ - 㤥 믮 .|"+
                             "( ᯮ짮 ᨬ '*'   ᫮  ᪠  ᫮)",
                             "%L<>I"),
          "室  㬥樨 ⮏",
          INFORM,
          ,
          humPage);
  IF humPage # humPagePat THEN
   Host:=Host + "/㦥:Search?search=" + humPage + "&fulltext=";
  ELSE
   Host:=Host + Page;
  END;
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   Shell.Execute("open", Host);
  EXCEPT
  ON Exc: Exc_Root DO
   L_General.Assert_wReferToAdmin(0, " 㤠 ३  ࠭ 㬥樨.||" + Exc.Description);
  END; (* TRY *)
 END {LaunchF1};

 PUBLIC PROCEDURE SaveFileInCurrentSurvey();
  VAR
   oAppl          : APPLICATION;
   oSurveyWin     : SURVEYWINDOW;
   RepFileName,
   RepFileName_Short,
   RepFileExt,
   RepFileSuff,
   Path2TempRep,
   Dummy,
   DstFullFileName,
   cpr_Path       : STRING[];
 BEGIN
  oAppl     :=APPLICATION.Get();
  oSurveyWin:=oAppl.TopWindow;
  FIO.SplitPath(oSurveyWin.RepFilePath, RepFileName, RepFileExt, Dummy);
  IF Str.Cap(RepFileExt) = "REP" THEN
   RepFileSuff      :=L_DatTim.SysDateTimeStamp();
   RepFileName_Short:=L_Str.CutLongStr(RepFileName + "_", L_General.MainWindowStandartWidth()-37);
   STDFORM(L_StdFrm.sf_Choice("| : %" + L_Str.Repeat("#", Str.Length(RepFileName_Short)) + "%%##############%.rep|",
                              "%RNI%LI"),
           "ࠬ ࠭  (䠩)",
           ,
           ,
           RepFileName_Short, RepFileSuff);
   RepFileName:=RepFileName + "_" + RepFileSuff;
   FIO.SplitPath(FIO.FirstPath("Probe2TempRep_99", "REP"), Dummy, Dummy, Path2TempRep);
   DstFullFileName:=FIO.MakePath(RepFileName, RepFileExt, FIO.UNCPath(Path2TempRep));
   L_FIO.ExactFileCopy(oSurveyWin.RepFilePath, DstFullFileName);
   cpr_Path:=FIO.UNCPath(FIO.AsbSpecialFolders("ClientProjectRoot"));
   IF Str.Pos(DstFullFileName, cpr_Path) = 0 THEN
    DstFullFileName:=Str.Delete(DstFullFileName, 0, Str.Length(cpr_Path)+1);
   END;
   L_StdFrm.Inform(" (䠩) ᪮஢ |" + L_Str.CutLongStr(DstFullFileName, L_General.MainWindowStandartWidth()-2-2*2));
  ELSE
   L_General.Error("  㬥 ࠭  REP 䠩");
  END;
 END {SaveFileInCurrentSurvey};

 PUBLIC PROCEDURE IsolateWindow();
  VAR
   StandartIsolateRequired: SCAL[2];
 BEGIN
  StandartIsolateRequired:=1;
  TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
   IF ~!APP.Get().TopWindow.WLevProg THEN
    TRY [EXCEPTION_HANDLING(EXCEPTION_HANDLING_OFF)]
     CALL(^(APP.Get().TopWindow.WLevProg + ".IsolateWindow()"));
     StandartIsolateRequired:=0;
    EXCEPT
    ON Exc: Exc_Root DO
     L_WDO.CheckIsNonExistentProcException(Exc);
    END; (* TRY *)
   END;
   IF StandartIsolateRequired THEN
    APP.Get().TopWindow.Clone   :=1;
    APP.Get().TopWindow.Isolated:=1;
   END;
  EXCEPT
  ON Exc: Exc_RunTime DO
   IF Exc.ErrorCode = 944 THEN
    L_General.Error('믮   ஢ |' +
                    '"' + L_WDO.getActiveForm().Title + '"|' +
                    ' ( 訡 4)||' +
                    ',  砩   ,  뢠|'+
                    '믮   ஢ .  ᫨  ⢨⥫쭮 |' +
                    '室, , ,   ࠡ稪');
   ELSE
    RAISE();
   END;
  END; (* TRY *)
 END {IsolateWindow};

 PUBLIC PROCEDURE ShowTableInIsolatedWindow();
 BEGIN
  LIKEMENU(View, ">" + L_WDO.getActiveForm().Name + " " + L_Str.IntStr(L_WDO.getActiveZone().Number));
 END {ShowTableInIsolatedWindow};

 PRIVATE PROCEDURE GetFilePrimaryKeyValue(File, _Window: STRING[]; _Zone: NUMERIC[0]): STRING[];
  VAR
   Result,
   PrKeyN: STRING[];
   i     : NUMERIC[0];
 BEGIN
  SETEMPTY(Result, PrKeyN);
  IF ~!File & DBD.FileExist(^File) THEN
   SETZERO(i);
   WHILE (i < DBD.IndexAmount(^File)) & !PrKeyN DO
    IF DBD.IndexUnique(^File, ^(DBD.IndexName(^File, i))) # 0 THEN
     PrKeyN:=DBD.IndexName(^File, i);
    END;
    INC(i);
   END;
   IF ~!PrKeyN THEN
    GE_WZD_CURSOR(_Window, _Zone, ^File);
    IF OCCURE(^File) THEN
     SETZERO(i);
     WHILE i < DBD.IndexFieldAmount(^File, ^PrKeyN) DO
      IF ~!Result THEN
       Result:=Result + ", ";
      END;
      IF INSTANCEOF(^File.^(DBD.IndexFieldName(^File, ^PrKeyN, i))) = 3 THEN
       Result:=Result + ^File.^(DBD.IndexFieldName(^File, ^PrKeyN, i));
      ELSE
       Result:=Result + FLDTOSTR(^File.^(DBD.IndexFieldName(^File, ^PrKeyN, i)));
      END;
      INC(i);
     END;
     SETZERO(i);
     WHILE i < DBD.FieldAmount(^File) DO
      IF Str.Match(Str.Cap(DBD.FieldName(^File, i)), "*NAME*") &
         (INSTANCEOF(^File.^(DBD.FieldName(^File, i))) = 3) THEN
       Result:=Result + ", " + ^File.^(DBD.FieldName(^File, i));
       i:=DBD.FieldAmount(^File);
      END;
      INC(i);
     END;
    END;
   END;
  END;
  RETURN Result;
 END {GetFilePrimaryKeyValue};

 PRIVATE PROCEDURE GetWinTitle(Win: WINDOW): STRING[];
 BEGIN
  IF Win.Type = WINDOW.Type_Survey THEN
   RETURN "ᬮ ";
  ELSE
   RETURN Str.Condense(Str.Replace(Win.Title, CHR(255), " "));
  END;
 END {GetWinTitle};

 PUBLIC PROCEDURE GoToOpenWindow();
  VAR
   LItem,
   List : STRING[];
   Appl : APPLICATION;
   VWin : VISIBLEWINDOWS;
   Form : WINDOW;
   i    : NUMERIC[0];
   Title: STRING[];
   TtlSz,
   WinSz: NUMERIC[0];
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  SETEMPTY(List);
  GE_APPWIN_SIZE(WinSz);
  Appl:=APPLICATION.Get();
  VWin:=Appl.VisibleWindows;
  SETZERO(i, TtlSz);
  WHILE i < VWin.Count DO
   IF Str.Length(GetWinTitle(VWin.Item(i))) > TtlSz THEN
    TtlSz:=Str.Length(GetWinTitle(VWin.Item(i)));
   END;
   INC(i);
  END;
  SETZERO(i);
  WHILE i < VWin.Count DO
   SETEMPTY(LItem);
   Form :=VWin.Item(i);
   LItem:=Str.Align(GetWinTitle(Form), TtlSz, LEFT);
   IF Form.Type # WINDOW.Type_Survey THEN
    LItem:=LItem + " " + L_Str.PoolItem(" |", Form.Isolated) +
                         L_Str.PoolItem(" !||| ?||C||VOID???", Form.ActiveZone.Processes(0).Kind) + " " +
                         L_Str.IntStr(Form.ActiveZone.Number) + " " +
                         GetFilePrimaryKeyValue(GE_WZD_MASTER(Form.Name, Form.ActiveZone.Number),
                                                Form.Name, Form.ActiveZone.Number);
   ELSE
    LItem:=LItem + "  " + Str.Condense(Form.Title);
   END;
   List:=List + Str.Slice(LItem, 0, WinSz - 6) + "|";
   INC(i);
  END;
  i:=L_StdFrm.ShowListAsMenu(List, " ");
  LIKEMENU(GoToWin, VWin.Item(i).Id);
 END {GoToOpenWindow};

 PUBLIC PROCEDURE ChangeHierarchicView();
 BEGIN
  RTI.Get().CurZone.BanHierarchicView:=~RTI.Get().CurZone.BanHierarchicView;
  IF ~!RTI.Get().CurZone.ZLevProg THEN
   L_WDO.CallProc_woParam(RTI.Get().CurZone.ZLevProg + "." + RTI.Get().CurWindow.OriginalName +
                          "_" + L_Str.IntStr(RTI.Get().CurZone.Number) + "_OnChangeHierarchicView");
  END;
 END {ChangeHierarchicView};

 PUBLIC PROCEDURE OpenAllParentsInHierarchicView();
 BEGIN
  L_WDO.getActiveZone().OpenAllParentsInHierarchicView();
 END {OpenAllParentsInHierarchicView};

 PUBLIC PROCEDURE CloseAllParentsInHierarchicView();
 BEGIN
  L_WDO.getActiveZone().CloseAllParentsInHierarchicView();
 END {CloseAllParentsInHierarchicView};

 PUBLIC PROCEDURE InsertParent();
  VAR
   CurFile: STRING[];
 BEGIN
  CurFile:=GetTopWindowMaster();
  IF ~!CurFile THEN
   IF ~!TABLE.Get(CurFile).Fields("Leaf") THEN
    LIKEMENU(Ins, "@ HierarchyInsMode=Group");
   ELSE
    L_General.Error("⠢ 㯯஢筮   ᪨ ࠢ筨 ");
   END;
  END;
 END {InsertParent};

 PUBLIC PROCEDURE MarkCurRecord();
  VAR
   fName: STRING[];
 BEGIN
  fName:=RTI.Get().CurZone.MasterTable.Name;
  L_General.Assert(ACCESS(^fName), " ⠭ ⥪ ");
  TRY
   L_AR.GrantRightsUnconditionally();
   IF WITHLAB(^fName, 0) THEN
    RESETLAB(^fName, 0);
   ELSE
    SETLAB(^fName, 0);
   END;
   REPLACE(^fName);
  EXCEPT
  END; (* TRY *)
 END {MarkCurRecord};

 PUBLIC PROCEDURE UpdateTimers();
 BEGIN
  L_Timer.UpdateTimers();
 END {UpdateTimers};

 PUBLIC PROCEDURE UploadAnyFileToExcel();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Excel.UploadFileToExcel(0, 0, "");
 END {UploadAnyFileToExcel};

 PUBLIC PROCEDURE UploadCurFileToExcel();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Excel.UploadFileToExcel(1, 0, "");
 END {UploadCurFileToExcel};

 PUBLIC PROCEDURE UploadCurRecordToExcel();
 BEGIN
  RTI.Get().TryBlock.AccessDataMode:=adm_SOFT;
  L_Excel.UploadFileToExcel(1, 1, "");
 END {UploadCurRecordToExcel};

 PUBLIC PROCEDURE ToggleFilter();
 BEGIN
  L_WDO.ToggleFilter();
 END {ToggleFilter};

BEGIN
 L_Events.ExecuteHandler();
END.
