(*
%Copyright   (c) Polak Computer System
%Author      15.03.2002 17:43:01 SAN
%Purpose     Excel (ole) প ⮢  ࠡ⭨.
%Type        control
%Specific    SYS
%Modified    10.04.2012 12:32:25 ROBOT by POLAK\LDA
%Environment
*)

 CONST
  MaxKey = 128;

  prm_TSN         = "";
  prm_Man         = "";
  prm_Value       = "";
  prm_InStateOnly = "";

 IMPORT L_Env, L_General, Str, L_Str, L_OLE, L_DatTim, L_AFM, L_Staff;

 VAR
  IntvlB,
  IntvlE       : DATE;
  v_TSN,
  v_Man,
  v_Value,
  v_InStateOnly: STRING[];

 PRIVATE PROCEDURE FillParams(Heap: STRING[]);
  VAR
   Params: STRING[][32];
 BEGIN
  L_OLE.SliceBySingle(Heap, Params);
  L_OLE.SetByKeyWord (Params, prm_TSN,         v_TSN);
  L_OLE.SetByKeyWord (Params, prm_Man,         v_Man);
  L_OLE.SetByKeyWord (Params, prm_Value,       v_Value);
  L_OLE.SetByKeyWord (Params, prm_InStateOnly, v_InStateOnly);
 END {FillParams};

 PRIVATE PROCEDURE Condition(): SCAL[2];
 BEGIN
  RETURN L_Staff.rInState(IntvlE);
 END {Condition};

 PRIVATE PROCEDURE Create_StMan();
 BEGIN
  TRY
   CreateFILE(StMan, "", "᮪ ࠡ⭨", "");
   CreateFIELD(StMan, TSN,     LIKE(Staff.TSN), "", "", "", "", "");
   CreateFIELD(StMan, Man,     LIKE(Staff.Man), "", "", "", "", "");
   CreateFIELD(StMan, InState, SCAL[2],         "", "", "", " ", "");
   CreateINDEXandLINK(StMan, TSN,   UNIQUE, Staff, TSN, USER, "", "", TSN);
   CreateINDEXandLINK(StMan, Man,   PLURAL, Man,   Man, USER, "", "", Man);
   CreateINDEX       (StMan, isTSN, UNIQUE,                   "", "", InState, TSN);
   CreateINDEX       (StMan, isMan, PLURAL,                   "", "", InState, Man);
   SetVersionOfFILE(StMan, 00001);
  EXCEPT
   ON Exc: Exc_RunTime DO
    IF Exc.ErrorCode # 95 THEN
     RAISE()
    END;
  END;
 END {Create_StMan};

 PRIVATE PROCEDURE Prepare_StMan(ForceRebuild: SCAL[2]);
 BEGIN
  Create_StMan();
  L_AFM.NewReusableFile("StMan", "StMan", L_General.timeCond_OnDate, IntvlB, IntvlE);
  IF ForceRebuild | ~L_AFM.CanReuseFile("StMan", 1) THEN
   L_AFM.CreateReusableFile("StMan");
   SELECT(Staff, TSN);
   WHILE OCCURE(Staff) DO
    PROMPT(Staff.TSN);
    StMan.TSN:=Staff.TSN;
    StMan.Man:=Staff.Man;
    StMan.InState:=Condition();
    INSERT(StMan);
    NEXT(Staff);
   END; (* WHILE OCCURE(Staff) ... *)
   L_AFM.ReAttachReusableFile("StMan");
  END; (* IF ~CanReuseFile ... *)
 END {Prepare_StMan};

 PRIVATE PROCEDURE Init(_IntvlB, _IntvlE: DATE; Rebuild: SCAL[2]);
 BEGIN
  IntvlB:=_IntvlB;
  IntvlE:=_IntvlE;
  L_OLE.SetUsedBasisList("StMan|");
  Prepare_StMan(Rebuild);
 END {oleInit};

 PRIVATE PROCEDURE oleInit(_IntvlB, _IntvlE: DATE);
 BEGIN
  Init(_IntvlB, _IntvlE, 0);
 END {oleInit};

 PRIVATE PROCEDURE oleInit_wRebuild(_IntvlB, _IntvlE: DATE);
 BEGIN
  Init(_IntvlB, _IntvlE, 1);
 END {oleInit};

 PRIVATE PROCEDURE oleDeInit();
 BEGIN
  L_OLE.DeInit();
 END {oleDeInit};

 PRIVATE PROCEDURE GetFirstStaff(Heap: STRING[]): STRING[];
 BEGIN
  FillParams(Heap);
  IF v_InStateOnly = "1" THEN
   SELECT(StMan, isTSN, , 1);
  ELSE
   SELECT(StMan, TSN);
  END;
  IF OCCURE(StMan) THEN
   RETURN StMan.TSN;
  ELSE
   RETURN "";
  END;
 END {GetFirstStaff};

 PRIVATE PROCEDURE GetFirstMan(Heap: STRING[]): STRING[];
 BEGIN
  FillParams(Heap);
  IF v_InStateOnly = "1" THEN
   SELECT(StMan, isMan, , 1);
  ELSE
   SELECT(StMan, Man);
  END;
  IF OCCURE(StMan) THEN
   RETURN StMan.Man;
  ELSE
   RETURN "";
  END;
 END {GetFirstMan};

 PRIVATE PROCEDURE GetNext(Heap: STRING[]): STRING[];
 BEGIN
  FillParams(Heap);
  IF    ~!v_TSN THEN
   L_General.Assert(SEARCH(StMan, TSN, v_TSN), " ⠡: "+v_TSN);
   IF v_InStateOnly = "1" THEN
    L_General.Assert(StMan.InState, v_TSN + "   ");
    CHANGESEL(StMan, isTSN, , StMan.InState);
   ELSE
    CHANGESEL(StMan, TSN);
   END;
   IF NEXT(StMan) THEN
    RETURN StMan.TSN;
   END;
  ELSIF ~!v_Man THEN
   IF v_InStateOnly = "1" THEN
    L_General.Assert(SELECT(StMan, isMan, 1, v_Man), " " + v_Man + "   ");
    LAST(StMan);
    CHANGESEL(StMan, isMan, , StMan.InState);
   ELSE
    L_General.Assert(SELECT(StMan, Man, v_Man), "  : "+v_Man);
    LAST(StMan);
    CHANGESEL(StMan, Man);
   END;
   IF NEXT(StMan) THEN
    RETURN StMan.Man;
   END;
  END;
  RETURN "";
 END {GetNext};

 PRIVATE PROCEDURE GetStaffValue(Heap: STRING[]): STRING[];
 BEGIN
  FillParams(Heap);
  IF ~!v_Value THEN
   L_General.Assert(Str.Item(v_Value, ".", 0) = "Staff",
                    "ᠭ   稭  ࠡ⭨ (Staff):|" + v_Value);
   RETURN L_OLE.GetValue(v_Value, v_TSN, IntvlE);
  ELSE
   RETURN "";
  END;
 END {GetStaffValue};

 PRIVATE PROCEDURE GetManValue(Heap: STRING[]): STRING[];
 BEGIN
  FillParams(Heap);
  IF ~!v_Value THEN
   L_General.Assert(Str.Item(v_Value, ".", 0) = "Man", "ᠭ   稭   (Man):|" + v_Value);
   RETURN L_OLE.GetValue(v_Value, v_Man, IntvlE);
  ELSE
   RETURN "";
  END;
 END {GetManValue};

 PRIVATE PROCEDURE StMan_InStateAmount(): NUMERIC[0];
  VAR
   Count: NUMERIC[0];
 BEGIN
  Count:=0;
  SELECT(StMan, isTSN, , 1);
  WHILE OCCURE(StMan) DO
   INC(Count);
   NEXT(StMan);
  END; (* WHILE OCCURE(StMan) ... *)
  RETURN Count;
 END {StMan_InStateAmount};

BEGIN
 SE_ACCESSDATAMODE(AccessDataMode_SOFT);
END.