(*
%Copyright   (c) Polak Computer System
%Author
%Purpose          ⠡
%Type        library,to paste
%Specific    SP
%Modified    10.04.2014 11:03:49 POLAK\San
%Environment
*)

 IMPORT Math, L_OwnData, L_General, P_Staff, L_AP, E_Prop, L_Str, L_PRoll,
        L_Staff, L_Env, Memo, L_Sheet, L_Hld, P_OwnData, L_Way, L_StdFrm;

 CONST
  jm_Work       = 00(*ࠡ*);
  jm_Line       = 02(**);
  jm_Pupil      = 16(*祭*);
  jm_HolidWork  = 24(*ࠡ  室*);
  KTUMtyIdx = 90;

  src_rws  = 0;
  src_All  = 1;

  mtid_EconFuel  = 00;
  mtid_BadTrips  = 02;
  mtid_TimeAveTS = 03;
  mtid_SlrAveTS  = 04;
  mtid_PlanTrips = 05;
  mtid_GoodTrips = 06;
  mtid_PlIncTown = 07;
  mtid_FcIncTown = 08;
  mtid_TimeTown  = 09;
  mtid_SlrTown   = 10;
  mtid_PlInc388  = 11;
  mtid_FcInc388  = 12;
  mtid_Time388   = 13;
  mtid_Slr388    = 14;
  mtid_PlIncComm = 15;
  mtid_FcIncComm = 16;
  mtid_TimeComm  = 17;
  mtid_SlrComm   = 18;
  mtid_TimeAmbul = 19;
  mtid_SlrAmbul  = 20;
  mtid_PlInc388Dr= 21;
  mtid_FcInc388Dr= 22;
  mtid_TimeSchool= 23;
  mtid_TimeOrder = 24;
  mtid_SlrOrder  = 25;
  mtid_TimeDuty  = 26;
  mtid_SlrDuty   = 27;
  mtid_SlrSchool = 28;

 VAR
  NeedPay: SCAL[2];
  OverPrc,
  PZVSum : NUMERIC[2];
  PZVTim : NUMERIC[3];
  HPayAvrgBal : tHMPay;

 (*-----ᥬ-------------------------------------------------*)

 PRIVATE PROCEDURE GetPayMarkG(_Who    : LIKE(MPG_WP.Who);
                               _JRgPayT: LIKE(MPG_WP.JRgPayT);
                               _MarkG  : LIKE(MPG_WP.MarkG)): LIKE(WagePayL.Pay[0]);
  VAR
   _Pay: LIKE(WagePayL.Pay[0]);
 BEGIN
  SAVE(WagePayL);
  _Pay:=L_AP.GetPayByMPG_WP(_MarkG, _Who, _JRgPayT, L_Way.rwpay_Basic, Memo.gl_mb(), 1);
  RESTORE(WagePayL);
  RETURN _Pay;
 END {GetPayMarkG};

 PRIVATE PROCEDURE GetDefltPay(_Who: LIKE(MPG_WP.Who);
                               _JRgPayT: LIKE(MPG_WP.JRgPayT)): LIKE(WagePayL.Pay[0]);
 BEGIN
  RETURN GetPayMarkG(_Who, _JRgPayT, 0030(*।.*));
 END {GetDefltPay};

 PRIVATE PROCEDURE GetDriverGuardPay(_Who: LIKE(Monthly.Who)): NUMERIC[3];
  VAR
   _Tim,
   _Sum    : LIKE(Monthly.Proof);
   AveTS   : LIKE(WagePayL.Pay[0]);
   _JRgPayT: LIKE(JRgPayT.JRgPayT);
 BEGIN
  _Tim:=L_AP.AcsMonthly(_Who, 1, mtid_TimeAveTS);
  _Sum:=L_AP.AcsMonthly(_Who, 1, mtid_SlrAveTS);
  IF _Tim = 0 THEN
   L_General.Assert(_Sum = 0, "㫥 ६,   㫥 ࠡ⮪    ");
   AveTS:=0;
  ELSE
   AveTS:=_Sum / _Tim;
  END;
  IF Memo.gl_mb() >= 01\04\2010 THEN
   IF (AveTS = 0) & (_TimDone # 0) THEN
    L_StdFrm.Question("⭨ "+Staff.TSN+"  㫥 । , ..| ⥫   ࠢ  ⥫  । :"+"|ਪ  / "+L_DatTim.DateStr(StaffLog.Date));
   END;
  ELSE
   IF AveTS = 0 THEN
    IF (Memo.gl_mb() >= 01\12\2004) | (_Who = 0) THEN
     _JRgPayT:=01(**);
    ELSE
     _JRgPayT:=02(**);
    END;
    IF Memo.gl_mb() >= 01\12\2004 THEN (*10.12.2004 12:59:25 POLAK\Gina: ࠢ ।,   *)
     AveTS:=GetDefltPay(_Who, _JRgPayT);
    ELSE
     AveTS:=GetDefltPay(0,    _JRgPayT);
    END;
   END;
  END;
  RETURN AveTS;
 END {GetDriverGuardPay};

 PRIVATE PROCEDURE _GetAddValue(Code: LIKE(AddKind.AddKind)): LIKE(Adding.Value);
  VAR
   BegDate,
   EndDate : DATE;
 BEGIN
  SELECT(Adding, TSN, , Staff.TSN, Code);
  GetGate(BegDate, EndDate);
  SRCINSEL(Adding, LE, , EndDate);
  IF OCCURE(Adding) & (!Adding.UpTo | (BegDate <= Adding.UpTo)) THEN
   RETURN Adding.Value;
  ELSE
   RETURN 0;
  END;
 END {_GetAddValue};

 PRIVATE PROCEDURE Add_HPay(s: NUMERIC[0]);
  VAR
   _HPayAvrgBal,
   _HPay,
   _MPay: tHMPay;
 BEGIN
  IF Memo.gl_mb() >= 01\08\2004 THEN
   _MPay:=_GetAddValue(17(*ᮢ饭   筮 *));
   IF _MPay > 0 THEN
    _HPay:=_MPay/RegHead.FullBal;
    IF Memo.gl_mb() >= 01\04\2010 THEN
     _HPayAvrgBal:=_MPay/L_PRoll.AverageMonthHBal(Memo.gl_mb());
    ELSE
     _HPayAvrgBal:=_HPay;
    END;
    INC(HPay, s*_HPay);
    INC(MPay, s*_MPay);
    INC(HPayAvrgBal, s*_HPayAvrgBal);
   END;
  END;
 END {Add_HPay};

 PUBLIC PROCEDURE Sht_GetPay();
 BEGIN
  IF    (Officer.PayKind = 01(* *)) | ((Memo.gl_mb() >= 01\04\2010) & (Officer.PayKind = 14(*⥫ *))) THEN
   HPay:=GetDriverGuardPay(L_AP.mthlWho_Driver);
   MPay:=HPay*RegHead.FullBal;
   HPayAvrgBal:=HPay;
  ELSIF Officer.PayKind = 02(**) THEN
   HPay:=GetDriverGuardPay(L_AP.mthlWho_Guard);
   MPay:=HPay*RegHead.FullBal;
   HPayAvrgBal:=HPay;
  ELSE
   L_PRoll.GetManyHMPay(Memo.gl_mb(), RegHead.FullBal, HPay, HPayAvrgBal, MPay);
   IF Memo.gl_mb() < 01\04\2010 THEN
    HPayAvrgBal:=HPay;
   END;
   IF (HPay = 0) & (Officer.WagePay # 0000) THEN
    L_StdFrm.Question(" ࠡ⭨ 㪠 㫥 䭠 ⠢");
   END;
   Add_HPay(+1);
  END;
 END {Sht_GetPay};

 PUBLIC PROCEDURE ();      (*  ᮢ   ࠡ    *)
 BEGIN
  Add_HPay(-1); (*   *)
  HourPay(Tims[jm_Work]+Tims[jm_HolidWork]);
  Add_HPay(+1);
 END {};

 PUBLIC PROCEDURE ();      (*  誠  ᮢ   ࠡ (祭) *)
  VAR Beg: DATE;
 BEGIN
  Beg:=L_DatTim.Per(Staff.BegDate);
  IF L_DatTim.DAY(Staff.BegDate) > 15 THEN
   Beg:=L_DatTim.IncMonth(Beg, +1);
  END;
  IF    L_DatTim.IncMonth(Beg, +2) > Memo.gl_mb() THEN
   Bonus(75, Tims[jm_Work]);
  ELSIF L_DatTim.IncMonth(Beg, +4) > Memo.gl_mb() THEN
   Bonus(80, Tims[jm_Work]);
  ELSE
   Bonus(90, Tims[jm_Work]);
  END;
 END {};

 PUBLIC PROCEDURE ();        (*   ᮢ        *)
 BEGIN
  HourPayBySpecHPay(SpT[L_Sheet.spk_Night], 40/100, HPayAvrgBal);
 END {};

 PRIVATE PROCEDURE GetTimsDone(VAR T: NUMERIC[3]; WholeMonth: SCAL[2]);
 BEGIN
  IF WholeMonth THEN
   T:=_TimDone;
  ELSE
   CONFORM(Sheet, JMode);
   IF JMode.Type = 2(*ந*) THEN
    INC(T, Sheet.Tim);
   END;
  END;
 END {GetTimsDone};

 PRIVATE PROCEDURE GetTims00(VAR T: NUMERIC[3]; WholeMonth: SCAL[2]);
 BEGIN
  IF WholeMonth THEN
   T:=Tims[jm_Work];
  ELSE
   IF Sheet.JMode=jm_Work THEN
    INC(T, Sheet.Tim);
   END;
  END;
 END {GetTims00};

 PRIVATE PROCEDURE GetTimeByAdding(GetTime: STRING[]): NUMERIC[3];
  VAR
   T       : NUMERIC[3];
   B,
   E       : DATE;
   NeedCalc: SCAL[2];
 BEGIN
  IF ~OCCURE(Adding) THEN RETURN 0; END;
  NeedCalc:=0;
  GetGate(B, E);
  IF Adding.From > B THEN
   B:=Adding.From;
   NeedCalc:=1;
  END;
  IF ~!Adding.UpTo & (Adding.UpTo < E) THEN
   E:=Adding.UpTo;
   NeedCalc:=1;
  END;
  IF NeedCalc THEN
   SELECT(Sheet, TSN, , Staff.TSN, Memo.gl_mb());
   SRCINSEL(Sheet, EQ, , L_DatTim.DAY(B));
   T:=0;
   WHILE OCCURE(Sheet) & (Sheet.Day <= L_DatTim.DAY(E)) DO
    ^GetTime(T, 0);
    NEXT(Sheet);
   END; (* WHILE OCCURE(Sheet) ... *)
  ELSE
   ^GetTime(T, 1);
  END; (* IF NeedCalc ... *)
  RETURN T;
 END {GetTimeByAdding};

 PUBLIC PROCEDURE 01();   (* -  -  "ࠡ" *)
 BEGIN
  Bonus(Adding.Value, GetTimeByAdding("GetTims00"));
 END {01};

 PUBLIC PROCEDURE 12();   (*  . ࠡ *)
 BEGIN
  Bonus(Adding.Value, GetTimeByAdding("GetTimsDone"));
 END {12};

 PUBLIC PROCEDURE 08();   (*  . ࠡ  "" *)
 BEGIN
  Bonus(Adding.Value, Tims[jm_Line]);
 END {08};

 PUBLIC PROCEDURE 03();   (* ᮭ쭠     *)
 BEGIN
  IF Memo.gl_mb() >= 01\05\2004 THEN
   PropPay(Adding.Value, GetTimeByAdding("GetTimsDone"));
  ELSE
   PropPay(Adding.Value, Math.Min(_HBal, GetTimeByAdding("GetTimsDone")));
  END;
 END {03};

 PUBLIC PROCEDURE 04();   (*  ਣ⢮         *)
 BEGIN
  PropPay(Adding.Value, Math.Min(_HBal, GetTimeByAdding("GetTimsDone")));
 END {04};

 TYPE
  tOver = NUMERIC[2];

 PRIVATE PROCEDURE Over(f, p: LIKE(Monthly.Proof)): tOver;
 BEGIN
  IF p > 0 THEN
   RETURN f / p * 100;
  ELSE
   RETURN 0;
  END;
 END {Over};

 PRIVATE PROCEDURE ForceOverIf9502(f, p: LIKE(Monthly.Proof)): tOver;
  VAR
   Result: tOver;
 BEGIN
  Result:=Over(f, p);
  IF (Result < OverPrc) & NeedPay THEN
   Result:=OverPrc;
  END;
  RETURN Result;
 END {ForceOverIf9502};

 PUBLIC PROCEDURE 06();   (*  ⠦ 20  *)
  VAR
   S   : NUMERIC[2];
   over: NUMERIC[2];
 BEGIN
  S:=Adding.Value/100*L_OwnData.ODMROT(Memo.gl_mb());
  IF S # 0 THEN
   IF L_Env.IsGuard() THEN
    over:=ForceOverIf9502(AcsGuMonthly(mtid_FcIncTown, src_All) +
                          AcsGuMonthly(mtid_FcInc388, src_All),
                          Math.Div(AcsGuMonthly(mtid_PlIncTown, src_All))+
                          Math.Div(AcsGuMonthly(mtid_PlInc388, src_All)));
   ELSIF L_Env.IsRouteDriver() THEN
    over:=ForceOverIf9502(AcsDrMonthly(mtid_FcIncTown, src_All) +
                          AcsDrMonthly(mtid_FcInc388, src_All) +
                          AcsDrMonthly(mtid_FcIncComm, src_All),
                          Math.Div(AcsDrMonthly(mtid_PlIncTown, src_All)) +
                          Math.Div(AcsDrMonthly(mtid_PlInc388, src_All)) +
                          Math.Div(AcsDrMonthly(mtid_PlIncComm, src_All)));
    IF Memo.gl_mb()>=01\06\2010 THEN
     IF (over = 0) &
        (AcsDrMonthly(mtid_PlIncTown, src_All)  = 0) &
        (AcsDrMonthly(mtid_PlInc388, src_All)   = 0) &
        (AcsDrMonthly(mtid_PlIncComm, src_All)  = 0) THEN
      over:=OverPrc;
     END;
    END;
   ELSE
    over:=OverPrc;
   END;
   IF over >= OverPrc THEN
    PropPay(S, Math.Min(GetTimeByAdding("GetTimsDone"), _HBal));
   END;
  END;
 END {06};

 PUBLIC PROCEDURE ⨯();
  VAR
   B, E : DATE;
   DILen: NUMERIC[0];
 BEGIN
  L_General.Assert(Memo.gl_mb() < 01\12\2010, "ࠢ '⨯'   12.2010");
  GetGate(B, E);
  DILen:=L_DatTim.DATEINT(B, E, Memo.gl_mb(), Memo.gl_me());
  MoneyMan(L_OwnData.ODMROT(Memo.gl_mb()) * DILen/L_DatTim.MonthLen(Memo.gl_mb()), 0);
 END {⨯};

 PUBLIC PROCEDURE ६1();
 BEGIN
  MoneyMan(BonSum[0] * L_Staff.GetOfficerBonus(Memo.gl_mb()) / 100, BonTim[0]);
 END {६1};

 PRIVATE PROCEDURE GetKTU(): LIKE(Monthly.Proof);
 BEGIN
  IF SEARCH(Monthly, TSN, StaffLog.TSN, Memo.gl_mb(), StaffLog.Date, L_AP.mthlWho_Staff, L_AP.mthlSrc_Operator, KTUMtyIdx) THEN
   RETURN Monthly.Proof;
  ELSE
   RETURN 1.000;
  END;
 END {GetKTU};

 PUBLIC PROCEDURE ६1();
  VAR
   BaseBonus: NUMERIC[2];
 BEGIN
  L_General.Assert(Memo.gl_mb()>=01\10\2009, "ࠢ '६1'    10.2009");
  IF Officer.Sort=052(*  *) THEN
   BaseBonus:=BonSum[0] * L_Staff.GetOfficerBonus(Memo.gl_mb()) / 100;
   MoneyMan((BaseBonus * GetKTU()) - BaseBonus, BonTim[0]);
  END;
 END {६1};

 PUBLIC PROCEDURE ।();      (*  ।  "ࠡ"        *)
 BEGIN
  Bonus(L_Staff.GetOfficerHarm(Memo.gl_mb(), 0), Tims[jm_Work]);
 END {।};

 PUBLIC PROCEDURE ࠧ();      (* ࠧ  ᮢ   *)
 BEGIN
  HourPayBySpecHPay(HolTime, 1, HPayAvrgBal);
 END {ࠧ};

 PUBLIC PROCEDURE 室();
 BEGIN
  SAVE(JMode);
  L_General.Assert(SEARCH(JMode, JMode, jm_HolidWork) & ~JMode.PayHldy, " ࠡ  ⠡ "+FLDTOSTR(jm_HolidWork, "0")+"     ࠧ");
  RESTORE(JMode);
  HourPayBySpecHPay(Tims[jm_HolidWork], 1, HPayAvrgBal);
 END {室};

 (*-----⥫---------------------------------------------*)

 PUBLIC PROCEDURE 祭();     (*    "祭"            *)
 BEGIN
  MoneyMan(GetDefltPay(L_AP.mthlWho_Driver, 01) * Tims[jm_Pupil] * MoneyRul.Number, Tims[jm_Pupil]);
 END {祭};

 PUBLIC PROCEDURE 祭();     (*    "祭" *)
 BEGIN
  IF Memo.gl_mb() >= 01\04\2010 THEN
   HourPayBySpecHPay(Tims[jm_Pupil], 1, GetPayMarkG(L_AP.mthlWho_Driver, 01, 0029(**)));
  ELSE
   MoneyMan(HPay * Tims[jm_Pupil], Tims[jm_Pupil]);
  END;
 END {祭};

 PUBLIC PROCEDURE 勐();   (*   "", "६", "祭" *)
  CONST
   Hol_MCode = 009; (*ࠧ*)
 BEGIN
  IF    Memo.gl_mb() >= 01\04\2007 THEN
   PayOverBySpecHPay(Tims[jm_Line] + Tims[12] + Tims[jm_Pupil] + ⠂६() - GetMoneyTimSrc(Hol_MCode, ""), 0, HPayAvrgBal);
  ELSIF Memo.gl_mb() >= 01\04\2005 THEN
   PayOver(Tims[jm_Line] + Tims[12] + Tims[jm_Pupil] + ⠂६() - GetMoneyTimSrc(Hol_MCode, ""), RegHead.RDay);
  ELSE
   PayOver(Tims[jm_Line] + Tims[12] + Tims[jm_Pupil] - HolTime,   RegHead.RDay);
  END;
 END {勐};

 PUBLIC PROCEDURE ();     (*   "ࠡ" *)
  VAR
   superover,
   DaysWithOver,
   TimsWithOver: NUMERIC[3];
   B,
   E           : DATE;
 BEGIN
  IF    MonthB >= 01\01\2014 THEN
   PayOverBySpecHPay(_TimDone-Tims[jm_HolidWork]-HolTime, 0, HPayAvrgBal);
  ELSIF MonthB >= 01\08\2004 THEN
   GetGate(B, E);
   SETZERO(DaysWithOver, TimsWithOver);
   SELECT(Sheet, TSN, , Staff.TSN, Memo.gl_mb());
   SRCINSEL(Sheet, EQ, , L_DatTim.DAY(B));
   WHILE OCCURE(Sheet) & (Sheet.Day <= L_DatTim.DAY(E)) DO
    IF (Sheet.JMode = jm_Work) & ~L_Hld.DayIsHoliday(Sheet.Period+Sheet.Day-1) THEN
(* 02.09.2004 10:22:08 POLAK\Gina
 ࠧ   RegList.DayTime,
᫨  ᬥ - ⭮,    뫠 ࠡ⪠
*)
     L_General.Assert(SEARCH(RegList, HumReg, StaffLog.Regime, Sheet.Period, Sheet.Day), "  ० ࠡ  "+L_DatTim.DateStr(Sheet.Period+Sheet.Day-1));
     IF Sheet.Tim > RegList.Durat THEN
      INC(DaysWithOver);
      INC(TimsWithOver, (Sheet.Tim - RegList.Durat));
     END;
    END;
    NEXT(Sheet);
   END; (* WHILE OCCURE(Sheet) ... *)
   IF TimsWithOver > 0 THEN
    IF Memo.gl_mb() >= 01\04\2007 THEN
     superover:=TimsWithOver;
    ELSE
     superover:=TimsWithOver - DaysWithOver * 2.0;
    END;
    IF superover > 0 THEN
     MoneyMan(HPayAvrgBal * (TimsWithOver+superover) * MoneyRul.Number, TimsWithOver);
    ELSE
     MoneyMan(HPayAvrgBal *  TimsWithOver            * MoneyRul.Number, TimsWithOver);
    END;
   END;
  ELSE
   PayOver(Tims[jm_Work] - HolTime, RegHead.RDay);
  END;
 END {};

 PUBLIC PROCEDURE ();
 BEGIN
  IF (L_Env.IsDriver() |
      ((Officer.Sort=054) & (Officer.Officer=0003)) |
      ((Officer.Sort=023) & (Officer.Officer=0001))) &
     (WagePayL.Type=L_PRoll.wplType_Tariff) THEN
   IF    StaffLog.Class = 1 THEN
    MoneyMan(HPay * Tims[jm_Work] * 0.25, Tims[jm_Work]);
   ELSIF StaffLog.Class = 2 THEN
    MoneyMan(HPay * Tims[jm_Work] * 0.10, Tims[jm_Work]);
   END;
  END;
 END {};

(*-------------------------------------------------*)

 PUBLIC PROCEDURE ⠂६(): L_PRoll.tTime;
 BEGIN
  IF Memo.gl_mb()>=01\07\2006 THEN
   RETURN Tims[jm_Work];
  ELSE
   RETURN 0;
  END;
 END {⠂६};

 PUBLIC PROCEDURE ⠇ࠡ⮪(): L_PRoll.tSum;
 BEGIN
  IF Memo.gl_mb()>=01\07\2006 THEN
   RETURN HPay * ⠂६();
  ELSE
   RETURN 0;
  END;
 END {⠇ࠡ⮪};

 PUBLIC PROCEDURE ();  (*६  ࠡ  ⠡ - ᫥ /⮪ ⬥  ⠡ ࠡ⮩*)
 BEGIN
  L_General.Assert(Memo.gl_mb()>=01\07\2006, "ࠢ ''   07.2006");
  MoneyMan(⠇ࠡ⮪(), ⠂६());
 END {};

(*---------⥫----------------------------------------------*)

 PRIVATE PROCEDURE AcsGuMonthly(_MtyIdx: LIKE(Monthly.MtyIdx); _All: SCAL[2]): LIKE(Monthly.Proof);
 BEGIN
  IF _All THEN
   RETURN L_AP.AcsMonthlyFull(L_AP.mthlWho_Guard, _MtyIdx);
  ELSE
   RETURN L_AP.AcsMonthly(L_AP.mthlWho_Guard,  L_AP.mthlSrc_RWayS, _MtyIdx);
  END;
 END {AcsGuMonthly};

 PRIVATE PROCEDURE AcsDrMonthly(_MtyIdx: LIKE(Monthly.MtyIdx); _All: SCAL[2]): LIKE(Monthly.Proof);
 BEGIN
  IF _All THEN
   RETURN L_AP.AcsMonthlyFull(L_AP.mthlWho_Driver, _MtyIdx);
  ELSE
   RETURN L_AP.AcsMonthly(L_AP.mthlWho_Driver, L_AP.mthlSrc_RWayS, _MtyIdx);
  END;
 END {AcsDrMonthly};

 PRIVATE PROCEDURE TotalDrMonthly(_MtyIdx: LIKE(Monthly.MtyIdx)): LIKE(Monthly.Proof);
 BEGIN
  RETURN L_AP.AcsMonthlyFullMonth(L_AP.mthlWho_Driver, L_AP.mthlSrc_RWayS, _MtyIdx, Memo.gl_mb());
 END {TotalDrMonthly};

 PRIVATE PROCEDURE Check(_MtyIdx: LIKE(Monthly.MtyIdx)): SCAL[2];
 BEGIN
  RETURN (_MtyIdx = mtid_TimeTown)   |
         (_MtyIdx = mtid_Time388)    |
         (_MtyIdx = mtid_TimeComm)   |
         (_MtyIdx = mtid_TimeAmbul)  |
         (_MtyIdx = mtid_TimeSchool) |
         (_MtyIdx = mtid_TimeOrder)  |
         (_MtyIdx = mtid_TimeDuty);
 END {Check};

 PRIVATE PROCEDURE GetPartPZV(    _Who   : LIKE(Monthly.Who);
                                  _MtyIdx: LIKE(Monthly.MtyIdx);
                              VAR _Tim   : NUMERIC[3];
                              VAR _Sum   : NUMERIC[2]);
  VAR
   AllTime,
   SrcTime : NUMERIC[3];
   Proc    : PROC;
   Prc     : NUMERIC[6];
 BEGIN
  SETZERO(_Tim, _Sum);
  IF (Memo.gl_mb() < 01\03\2004) & (Memo.gl_mb() >= 01\04\2003) THEN
   IF _Who = L_AP.mthlWho_Driver THEN
    Proc:=PROCREF(AcsDrMonthly);
   ELSE
    Proc:=PROCREF(AcsGuMonthly);
   END;
   SrcTime:=Proc(_MtyIdx, src_rws);
   L_General.Assert(Check(_MtyIdx),
                    " ଠ樨  ⥫ 筮 ⥫ " +
                    _MtyIdx);
   IF SrcTime > 0 THEN
    AllTime:=Proc(mtid_TimeTown,   src_rws) +
             Proc(mtid_Time388,    src_rws) +
             Proc(mtid_TimeComm,   src_rws) +
             Proc(mtid_TimeAmbul,  src_rws) +
             Proc(mtid_TimeSchool, src_rws) +
             Proc(mtid_TimeOrder,  src_rws) +
             Proc(mtid_TimeDuty,   src_rws);
    Prc:=SrcTime / AllTime;
    IF SEARCH(Money, TSN, Staff.TSN, Memo.gl_mb(), Memo.gl_mb(),
                          StaffLog.Date, Memo.gl_mb(),
                          001 (**), L_PRoll.src_RWayS) THEN
     _Tim:=Money.Tim * Prc;
     _Sum:=Money.Sum * Prc;
    END;
   END;
  END;
 END {GetPartPZV};

 PRIVATE PROCEDURE GetOwnDValue(_Property: LIKE(Property.Property); Item: NUMERIC[0]): NUMERIC[5];
 BEGIN
  RETURN STRTOFLD(L_Str.AnyItem(P_OwnData.GetOwnDProStrong(Memo.gl_mb(), _Property), ";", Item), NUMERIC);
 END {GetOwnDValue};

(*--  ⥫------------------------------------------------*)

 PUBLIC PROCEDURE 祭();     (*    "祭"            *)
 BEGIN
  MoneyMan(GetDefltPay(L_AP.mthlWho_Guard, 01) * Tims[jm_Pupil] * MoneyRul.Number, Tims[jm_Pupil]);
 END {祭};

 PUBLIC PROCEDURE 388();
 BEGIN
  MoneyMan(AcsGuMonthly(mtid_FcInc388, src_All) * 0.01, 0);
 END {388};

 PRIVATE PROCEDURE AddingSalary(LocaLSal, TotalSal: L_PRoll.tSum): L_PRoll.tSum;
  CONST
   HonouredWorker_MCode = 227; (*㦥 ࠡ⭨*)
 BEGIN
  IF Memo.gl_mb() >= 01\04\2009 THEN
   IF TotalSal > 0 THEN
    RETURN GetMoneySum(HonouredWorker_MCode) * LocaLSal / TotalSal;
   ELSE
    RETURN 0;
   END;
  ELSE
   RETURN 0;
  END;
 END {AddingSalary};

 PUBLIC PROCEDURE 믏();
  VAR
   over    : FLOAT;
   Prc,
   PrcTown,
   Prc388,
   _pzvtim,
   _pzvsum : NUMERIC[3];
   SalrTotal,
   SalrTown,
   Salr388: LIKE(Monthly.Proof);
 BEGIN
  SETZERO(_pzvtim, _pzvsum);
  GetPartPZV(L_AP.mthlWho_Guard, mtid_TimeTown, _pzvtim, _pzvsum);
  GetPartPZV(L_AP.mthlWho_Guard, mtid_Time388, PZVTim, PZVSum);
  INC(_pzvtim, PZVTim); INC(_pzvsum, PZVSum);
  IF Memo.gl_mb() >= 01\08\2008 THEN
   over:=ForceOverIf9502(AcsGuMonthly(mtid_FcIncTown, src_All), Math.Div(AcsGuMonthly(mtid_PlIncTown, src_All)));
   SalrTown:=AcsGuMonthly(mtid_SlrTown,  src_rws) + _pzvsum + ⠇ࠡ⮪();
   Salr388 :=AcsGuMonthly(mtid_Slr388,   src_rws);
   SalrTotal:=SalrTown+Salr388;
   IF over >= OverPrc THEN
    PrcTown:=GetOwnDValue(E_Prop.P_MakePlan_Guard, 0) / 100;
    SalrTown:=SalrTown+AddingSalary(SalrTown, SalrTotal);
    MoneyMan(SalrTown * PrcTown,
             AcsGuMonthly(mtid_TimeTown, src_rws) + _pzvtim + ⠂६());
   END;
   over:=ForceOverIf9502(AcsGuMonthly(mtid_FcInc388, src_All), Math.Div(AcsGuMonthly(mtid_PlInc388, src_All)));
   IF over >= OverPrc THEN
    Prc388:= GetOwnDValue(E_Prop.P_MakePlan_Guard, 1) / 100;
    Salr388:=Salr388+AddingSalary(Salr388, SalrTotal);
    MoneyMan(Salr388 * Prc388, AcsGuMonthly(mtid_Time388,  src_rws));
   END;
  ELSE
   over:=ForceOverIf9502(AcsGuMonthly(mtid_FcIncTown, src_All) +
                         AcsGuMonthly(mtid_FcInc388, src_All),
                         Math.Div(AcsGuMonthly(mtid_PlIncTown, src_All))+
                         Math.Div(AcsGuMonthly(mtid_PlInc388, src_All)));
   IF over >= OverPrc THEN
    IF    Memo.gl_mb() >= 01\03\2005 THEN
     PrcTown:=GetOwnDValue(E_Prop.P_MakePlan_Guard, 0) / 100;
     Prc388:= GetOwnDValue(E_Prop.P_MakePlan_Guard, 1) / 100;
     MoneyMan((AcsGuMonthly(mtid_SlrTown,  src_rws) + _pzvsum + ⠇ࠡ⮪()) * PrcTown,
              AcsGuMonthly(mtid_TimeTown, src_rws) + _pzvtim + ⠂६());
     MoneyMan(AcsGuMonthly(mtid_Slr388,   src_rws) * Prc388,
              AcsGuMonthly(mtid_Time388,  src_rws));
    ELSIF Memo.gl_mb() >= 01\04\2003 THEN
     Prc:=STRTOFLD(P_OwnData.GetOwnDProStrong(Memo.gl_mb(),
                                              E_Prop.P_MakePlan_Guard),
                   NUMERIC) / 100;
     MoneyMan((AcsGuMonthly(mtid_SlrTown,  src_rws) + _pzvsum +
               AcsGuMonthly(mtid_Slr388,   src_rws)) * Prc,
               AcsGuMonthly(mtid_TimeTown, src_rws) + _pzvtim +
               AcsGuMonthly(mtid_Time388,  src_rws));
    ELSE
     MoneyMan(BonSum[2] * 0.80, BonTim[2]);
    END;
   END;
  END;
 END {믏};

 PUBLIC PROCEDURE ();
  VAR
   Prc,
   _Sum,
   plan,
   planM,
   fact,
   factM   : NUMERIC[2];
   over    : FLOAT;
   time    : NUMERIC[3];
   _NeedPay: SCAL[2];
 BEGIN
  IF Memo.gl_mb() >= 01\03\2005 THEN
   time :=AcsGuMonthly(mtid_TimeTown, src_rws);
   plan :=Math.Div(AcsGuMonthly(mtid_PlIncTown, src_All)); (*த, ਣத*)
   fact :=AcsGuMonthly(mtid_FcIncTown, src_All);
   over:=Over(fact, plan);
   IF    over >= 120 THEN
    Prc:=0.50;
   ELSIF over >= 110 THEN
    Prc:=0.25;
   ELSIF over >= 100 THEN
    Prc:=0.10;
   ELSE
    Prc:=0;
   END;
   MoneyMan((fact - plan) * Prc, time);
  ELSE
   (*c 03.2005  ॢ믮  388  *)
   time :=AcsGuMonthly(mtid_TimeTown, src_rws) +
          AcsGuMonthly(mtid_Time388, src_rws);
   plan :=Math.Div(AcsGuMonthly(mtid_PlIncTown, src_All)); (*த, ਣத*)
   planM:=Math.Div(AcsGuMonthly(mtid_PlInc388, src_All)); (*த*)
   fact :=AcsGuMonthly(mtid_FcIncTown, src_All);
   factM:=AcsGuMonthly(mtid_FcInc388, src_All);
 
   over:=Over(fact + factM, plan + planM);
   SETZERO(_Sum, Prc);
   _NeedPay:=NeedPay & (Memo.gl_mb() >= 01\05\2004);
   IF (over > 100) | _NeedPay THEN
    IF (Over(factM, planM) > 100) | _NeedPay THEN
     IF Memo.gl_mb() >= 01\01\2004 THEN
      _Sum:=factM * 0.01;
     ELSE
      _Sum:=(factM - planM) * 0.10;
     END;
    END;
   END;
   IF over > 100 THEN
    over:=Over(fact, plan);
    IF    over >= 120 THEN
     Prc:=0.50;
    ELSIF over >= 110 THEN
     Prc:=0.25;
    ELSIF over >= 100 THEN
     Prc:=0.10;
    END;
    _Sum:=_Sum + (fact - plan) * Prc;
   END;
   MoneyMan(_Sum, time);
  END;
 END {};

 PRIVATE PROCEDURE OverPrcForVldPsgBonus(): NUMERIC[5];
 BEGIN
  IF Memo.gl_mb() >= 01\04\2010 THEN
   RETURN OverPrc / 100;
  ELSE
   RETURN 1;
  END;
 END {OverPrcForVldPsgBonus};

 PUBLIC PROCEDURE 믏ଏ();
  VAR
   plan,
   fact: LIKE(Monthly.Proof);
 BEGIN
  L_General.Assert(Memo.gl_mb() >= 01\04\2008, "ࠢ '믏ଏ'    04.2008");
  plan:=Math.Trunc(AcsGuMonthly(30, src_All)); (* 죮⭨*)
  fact:=AcsGuMonthly(31, src_All);             (*䠪 죮⭨*)
  IF (plan>0) & (fact >= plan*OverPrcForVldPsgBonus()) THEN
   MoneyMan(AcsGuMonthly(mtid_SlrTown,  src_rws) * 0.30,
            AcsGuMonthly(mtid_TimeTown, src_rws));
  END;
 END {믏ଏ};

 PUBLIC PROCEDURE ଏ();
  VAR
   plan,
   fact: LIKE(Monthly.Proof);
 BEGIN
  L_General.Assert(Memo.gl_mb() >= 01\03\2008, "ࠢ 'ଏ'    03.2008");
  plan:=Math.Trunc(AcsGuMonthly(30, src_All)); (* 죮⭨*)
  fact:=AcsGuMonthly(31, src_All);             (*䠪 죮⭨*)
  IF (plan>0) & (fact > plan) THEN
   IF Memo.gl_mb() >= 01\08\2011 THEN
    MoneyMan((fact - plan) * 1.50, 0);
   ELSE
    MoneyMan((fact - plan) * 0.50, 0);
   END;
  END;
 END {ଏ};

(*--⥫  ⥫--------------------------------------------------*)

 PUBLIC PROCEDURE ⠦();
  VAR
   Prc: NUMERIC[2];
 BEGIN
  IF AcsDrMonthly(mtid_TimeAmbul, src_rws) > 0 THEN
   IF P_Staff.HasActualStaffPro(Staff.TSN, Memo.gl_me(), E_Prop.P_BonusForStage) &
      (StaffPro.Value # "0") THEN
    Prc:=STRTOFLD(StaffPro.Value, NUMERIC)/100;
    MoneyMan(AcsDrMonthly(mtid_SlrAmbul, src_rws) * Prc,
             AcsDrMonthly(mtid_TimeAmbul, src_rws));
   END;
  END;
 END {⠦};

 PRIVATE PROCEDURE GetPrcForClass(): NUMERIC[2];
 BEGIN
  IF Memo.gl_mb() >= 01\03\2004 THEN
   RETURN 1.00;
  ELSE
   IF    StaffLog.Class = 1 THEN
    RETURN 1.25;
   ELSIF StaffLog.Class = 2 THEN
    RETURN 1.10;
   ELSE
    RETURN 1.00;
   END;
  END;
 END {GetPrcForClass};

 PRIVATE PROCEDURE TotalDrSalary(): L_PRoll.tSum;
 BEGIN
  RETURN AcsDrMonthly(mtid_SlrTown, src_rws) + AcsDrMonthly(mtid_Slr388, src_rws) +
         AcsDrMonthly(mtid_SlrComm, src_rws);
 END {TotalDrSalary};

 PUBLIC PROCEDURE 믏();
  VAR
   over,
   ६த: NUMERIC[2];
   Salr: LIKE(Monthly.Proof);
 BEGIN
  GetPartPZV(L_AP.mthlWho_Driver, mtid_TimeTown, PZVTim, PZVSum);
  over:=ForceOverIf9502(AcsDrMonthly(mtid_FcIncTown, src_All),
                        Math.Div(AcsDrMonthly(mtid_PlIncTown, src_All)));
  IF over >= OverPrc THEN
   Salr:=AcsDrMonthly(mtid_SlrTown, src_rws) + PZVSum;
   Salr:=Salr + AddingSalary(Salr, TotalDrSalary());
   ६த:=GetOwnDValue(E_Prop.P_MakePlanBonus, 0) / 100;
   MoneyMan(Salr * ६த * GetPrcForClass(),
            AcsDrMonthly(mtid_TimeTown, src_rws) + PZVTim);
  END;
 END {믏};

 PUBLIC PROCEDURE 믏();
  VAR
   t_plan,
   i_plan,
   t_fact,
   i_fact,
   ६,
   ६,
   i_over,
   t_over  : NUMERIC[2];
   Salr: LIKE(Monthly.Proof);
 BEGIN
  GetPartPZV(L_AP.mthlWho_Driver, mtid_Time388, PZVTim, PZVSum);
  ६:=GetOwnDValue(E_Prop.P_MakePlanBonus, 1) / 100;
  ६:=GetOwnDValue(E_Prop.P_MakePlanBonus, 2) / 100;

  i_fact:=AcsDrMonthly(mtid_FcInc388Dr, src_All);
  i_plan:=Math.Div(AcsDrMonthly(mtid_PlInc388Dr, src_All));
  i_over:=ForceOverIf9502(i_fact, i_plan);
  IF Memo.gl_mb() >= 01\05\2005 THEN
   t_over:=ForceOverIf9502(AcsDrMonthly(mtid_FcInc388, src_All),
                           Math.Div(AcsDrMonthly(mtid_PlInc388, src_All)));
  ELSE
   t_over:=ForceOverIf9502(AcsDrMonthly(mtid_FcInc388, src_All) - i_fact,
                           Math.Div(AcsDrMonthly(mtid_PlInc388, src_All)) - i_plan);
  END;
  IF Memo.gl_mb() >= 01\03\2003 THEN
   IF i_over >= OverPrc THEN
    Salr:=AcsDrMonthly(mtid_Slr388, src_rws)+PZVSum;
    Salr:=Salr + AddingSalary(Salr, TotalDrSalary());
    MoneyMan(Salr * ६ * GetPrcForClass(),
             0);
   END;
   IF t_over >= OverPrc THEN
    MoneyMan((AcsDrMonthly(mtid_Slr388, src_rws)+PZVSum) * ६ * GetPrcForClass(),
             AcsDrMonthly(mtid_Time388, src_rws)+PZVTim);
   END;
  ELSE
   IF (i_over >= OverPrc) & (t_over >= OverPrc) THEN
    MoneyMan((AcsDrMonthly(mtid_Slr388, src_rws)+PZVSum) * ६ * GetPrcForClass(),
             AcsDrMonthly(mtid_Time388, src_rws)+PZVTim);
   END;
  END;
 END {믏};

 PUBLIC PROCEDURE 믏();
  VAR
   over : tOver;
   Prc  : NUMERIC[3];
   Plan,
   Fact,
   Time : LIKE(Monthly.Proof);
   FactMsc,
   PlanMsc,
   SalaryMsc,
   TimeMsc: NUMERIC[3];
   Salr: LIKE(Monthly.Proof);
 BEGIN
  IF    MonthB >= 01\03\2014  THEN
   GetPartPZV(L_AP.mthlWho_Driver, mtid_TimeComm, PZVTim, PZVSum);
   SETZERO(FactMsc, PlanMsc, SalaryMsc, TimeMsc);
   IF L_Env.IsMTDriver() THEN
    FactMsc  :=AcsDrMonthly(mtid_FcInc388, src_All);
    PlanMsc  :=AcsDrMonthly(mtid_PlInc388, src_All);
    SalaryMsc:=AcsDrMonthly(mtid_Slr388, src_rws);
    TimeMsc  :=AcsDrMonthly(mtid_Time388, src_rws);
   END;
   over:=ForceOverIf9502(AcsDrMonthly(mtid_FcIncComm, src_All) + FactMsc,
                         Math.Trunc(AcsDrMonthly(mtid_PlIncComm, src_All) + PlanMsc));
   IF over >= OverPrc THEN
    Prc:=GetOwnDValue(E_Prop.P_MakePlanBonus, 3) / 100;
    Salr:=AcsDrMonthly(mtid_SlrComm, src_rws) + SalaryMsc;
    Salr:=Salr + AddingSalary(Salr, TotalDrSalary());
    MoneyMan(Salr *
             GetPrcForClass() * Prc,
             AcsDrMonthly(mtid_TimeComm, src_rws) + TimeMsc);
   END;
  ELSIF MonthB >= 01\11\2013  THEN
   Plan:=AcsDrMonthly(mtid_PlIncComm, src_All);
   Fact:=AcsDrMonthly(mtid_FcIncComm, src_All);
   IF L_Env.IsMTDriver() THEN
    INC(Plan, AcsDrMonthly(mtid_PlInc388, src_All));
    INC(Fact, AcsDrMonthly(mtid_FcInc388, src_All));
   END;
   over:=ForceOverIf9502(Fact, Math.Trunc(Plan));
   Prc:=GetOwnDValue(E_Prop.P_MakePlanBonus, 3);
   IF    over >= OverPrc THEN Prc:=Prc;
   ELSIF over >= 98      THEN Prc:=Prc * 80/100;
   ELSIF over >= 96      THEN Prc:=Prc * 60/100;
   ELSIF over >= 90      THEN Prc:=Prc * 40/100;
   ELSE                       Prc:=0;
   END;
   IF Prc > 0 THEN
    Salr:=AcsDrMonthly(mtid_SlrComm, src_rws);
    Time:=AcsDrMonthly(mtid_TimeComm, src_rws);
    IF L_Env.IsMTDriver() THEN
     INC(Salr, AcsDrMonthly(mtid_Slr388, src_rws));
     INC(Time, AcsDrMonthly(mtid_Time388, src_rws));
    END;
    Salr:=Salr + AddingSalary(Salr, TotalDrSalary());
    MoneyMan(Salr * Prc / 100, Time);
   END;
  ELSIF MonthB >= 01\06\2013 THEN
   Plan:=AcsDrMonthly(mtid_PlIncComm, src_All);
   Fact:=AcsDrMonthly(mtid_FcIncComm, src_All);
   IF L_Env.IsMTDriver() THEN
    INC(Plan, AcsDrMonthly(mtid_PlInc388, src_All));
    INC(Fact, AcsDrMonthly(mtid_FcInc388, src_All));
   END;
   over:=ForceOverIf9502(Fact, Math.Trunc(Plan));
   Prc:=GetOwnDValue(E_Prop.P_MakePlanBonus, 3);
   IF    over >= OverPrc THEN Prc:=Prc;
   ELSIF over >= 98      THEN Prc:=Prc * 95/100;
   ELSIF over >= 96      THEN Prc:=Prc * 85/100;
   ELSIF over >= 90      THEN Prc:=Prc * 75/100;
   ELSE                       Prc:=0;
   END;
   IF Prc > 0 THEN
    Salr:=AcsDrMonthly(mtid_SlrComm, src_rws);
    Time:=AcsDrMonthly(mtid_TimeComm, src_rws);
    IF L_Env.IsMTDriver() THEN
     INC(Salr, AcsDrMonthly(mtid_Slr388, src_rws));
     INC(Time, AcsDrMonthly(mtid_Time388, src_rws));
    END;
    Salr:=Salr + AddingSalary(Salr, TotalDrSalary());
    MoneyMan(Salr * Prc / 100, Time);
   END;
  ELSE
   GetPartPZV(L_AP.mthlWho_Driver, mtid_TimeComm, PZVTim, PZVSum);
   SETZERO(FactMsc, PlanMsc, SalaryMsc, TimeMsc);
   IF (Memo.gl_mb() >= 01\06\2006) & L_Env.IsMTDriver() THEN
    FactMsc  :=AcsDrMonthly(mtid_FcInc388, src_All);
    PlanMsc  :=AcsDrMonthly(mtid_PlInc388, src_All);
    SalaryMsc:=AcsDrMonthly(mtid_Slr388, src_rws);
    TimeMsc  :=AcsDrMonthly(mtid_Time388, src_rws);
   END;
   over:=ForceOverIf9502(AcsDrMonthly(mtid_FcIncComm, src_All) + FactMsc,
                         Math.Trunc(AcsDrMonthly(mtid_PlIncComm, src_All) + PlanMsc));
   IF over >= OverPrc THEN
    IF    Memo.gl_mb() >= 01\06\2006 THEN
     Prc:=GetOwnDValue(E_Prop.P_MakePlanBonus, 3) / 100;
     Salr:=AcsDrMonthly(mtid_SlrComm, src_rws) + SalaryMsc;
     Salr:=Salr + AddingSalary(Salr, TotalDrSalary());
     MoneyMan(Salr *
              GetPrcForClass() * Prc,
              AcsDrMonthly(mtid_TimeComm, src_rws) + TimeMsc);
    ELSIF Memo.gl_mb() >= 01\04\2004 THEN
     Prc:=GetOwnDValue(E_Prop.P_MakePlanBonus, 3) / 100;
     MoneyMan((AcsDrMonthly(mtid_SlrComm, src_rws) + PZVSum) *
              GetPrcForClass() * Prc,
              AcsDrMonthly(mtid_TimeComm, src_rws) + PZVTim);
    ELSIF Memo.gl_mb() >= 01\03\2004 THEN
     (*%% ᪨   RWS_  mtid_SlrComm*)
     MoneyMan((AcsDrMonthly(mtid_SlrComm, src_rws) + PZVSum) *
              GetPrcForClass(),
              AcsDrMonthly(mtid_TimeComm, src_rws) + PZVTim);
    ELSIF Memo.gl_mb() >= 01\04\2003 THEN
     Prc:=STRTOFLD(P_OwnData.GetOwnDProStrong(Memo.gl_mb(),
                                              E_Prop.P_woGuardBonus), NUMERIC) / 100;
     MoneyMan((AcsDrMonthly(mtid_SlrComm, src_rws) + PZVSum) *
              GetPrcForClass() +
              AcsDrMonthly(mtid_SlrComm, src_rws) * Prc,
              AcsDrMonthly(mtid_TimeComm, src_rws)+PZVTim);
    ELSE
     MoneyMan(BonSum[1], BonTim[1]);
    END;
   END;
  END;
 END {믏};

 PUBLIC PROCEDURE ();
  VAR
   i_plan,
   i_fact,
   plan,
   fact : LIKE(Monthly.Proof);
   NeedPayBonus: SCAL[2];
 BEGIN
  plan:=Math.Div(AcsDrMonthly(mtid_PlIncTown, src_All));
  fact:=AcsDrMonthly(mtid_FcIncTown, src_All);
  IF (plan > 0) & (fact > plan) THEN
   MoneyMan((fact-plan)*0.10, AcsDrMonthly(mtid_TimeTown, src_rws));
  END;

  IF MonthB >= 01\02\2004 THEN
   i_fact      :=AcsDrMonthly(mtid_FcInc388Dr, src_All);
   i_plan      :=Math.Div(AcsDrMonthly(mtid_PlInc388Dr, src_All));
   NeedPayBonus:=0;
   IF    MonthB >= 01\09\2013 THEN
    NeedPayBonus:=(i_fact > i_plan) &
                  (AcsDrMonthly(mtid_FcInc388, src_All) >= Math.Div(AcsDrMonthly(mtid_PlInc388, src_All)));
   ELSIF MonthB >= 01\03\2004 THEN
    NeedPayBonus:=(i_fact > i_plan) &
                  (AcsDrMonthly(mtid_FcInc388, src_All) > Math.Div(AcsDrMonthly(mtid_PlInc388, src_All)));
   ELSE
    NeedPayBonus:=i_fact > i_plan;
   END;
   IF NeedPayBonus THEN
    MoneyMan((i_fact-i_plan) * 0.50, 0);
   END;
  END;
 END {};

 PUBLIC PROCEDURE ();
  VAR
   plan,
   fact : LIKE(Monthly.Proof);
 BEGIN
  plan:=Math.Div(AcsDrMonthly(mtid_PlIncComm, src_All));
  fact:=AcsDrMonthly(mtid_FcIncComm, src_All);
  IF (plan > 0) & (fact > plan) THEN
   MoneyMan((fact-plan)*0.50, AcsDrMonthly(mtid_TimeComm, src_All));
  END;
 END {};

 PUBLIC PROCEDURE 믏();
  VAR
   plan,
   fact: LIKE(Monthly.Proof);
 BEGIN
  CheckBegin(01\06\2013);
  IF MonthB < 01\03\2014 THEN
   plan:=Math.Trunc(AcsDrMonthly(mtid_PlIncComm, src_All)) * 101.99/100;
   fact:=AcsDrMonthly(mtid_FcIncComm, src_All);
   IF fact > plan THEN
    MoneyMan((fact-plan)*20/100, 0);
   END;
  END;
 END {믏};

 PRIVATE PROCEDURE _Regularity(BonusIdx: NUMERIC[0]; _Time: NUMERIC[3]);
  VAR
   _Bonus: NUMERIC[2];
   _Reg  : FLOAT;
 BEGIN
  _Bonus:=GetOwnDValue(E_Prop.P_RegularityBonus, BonusIdx);
  L_General.Assert(~!_Bonus,
                   "୮ ଫ ன " +
                   L_Str.IntStr(E_Prop.P_RegularityBonus));
  IF Memo.gl_mb() >= 01\03\2003 THEN
   _Reg:=Over(AcsDrMonthly(mtid_GoodTrips, src_rws),
              AcsDrMonthly(mtid_GoodTrips, src_rws) +
              AcsDrMonthly(mtid_BadTrips, src_rws));
  ELSE
   _Reg:=Over(AcsDrMonthly(mtid_GoodTrips, src_rws),
              AcsDrMonthly(mtid_PlanTrips, src_rws));
  END;
  IF _Reg >= 95 THEN
   MoneyMan(_Time * _Bonus, _Time);
  END;
 END {_Regularity};

 PUBLIC PROCEDURE ();
  VAR
   _Time : NUMERIC[3];
 BEGIN
  IF Memo.gl_mb() >= 01\02\2005 THEN
   _Time:=AcsDrMonthly(mtid_TimeTown, src_rws);
  ELSE
   _Time:=AcsDrMonthly(mtid_TimeTown, src_rws) +
          AcsDrMonthly(mtid_Time388, src_rws);
  END;
  _Regularity(0, _Time);
 END {};

 PUBLIC PROCEDURE 댒();
 BEGIN
  _Regularity(1, AcsDrMonthly(mtid_TimeComm, src_rws));
 END {댒};

 PUBLIC PROCEDURE 388();
 BEGIN
  L_General.Assert(Memo.gl_mb() < 01\04\2005,
                   "ࠢ 388  ਬ  04.2005");
  L_General.Assert(Memo.gl_mb() >= 01\02\2005,
                   "ࠢ 388  ਬ  02.2005");
  _Regularity(2, AcsDrMonthly(mtid_Time388, src_rws));
 END {388};

 PUBLIC PROCEDURE ६();
  VAR
   Prc   : NUMERIC[2];
 BEGIN
  L_General.Assert(Memo.gl_mb() < 01\03\2011, "ࠢ ६  ਬ  03.2011");
  GetPartPZV(L_AP.mthlWho_Driver, mtid_TimeOrder, PZVTim, PZVSum);
  Prc:=STRTOFLD(P_OwnData.GetOwnDProStrong(Memo.gl_mb(), E_Prop.P_OrderBonus), NUMERIC)/100;
  IF AcsDrMonthly(mtid_TimeOrder, src_rws) > 0 THEN
   MoneyMan((AcsDrMonthly(mtid_SlrOrder,  src_rws) + PZVSum) * Prc * GetPrcForClass(),
             AcsDrMonthly(mtid_TimeOrder, src_rws) + PZVTim);
  END;
 END {६};

 PUBLIC PROCEDURE ६();
  VAR
   Prc: NUMERIC[2];
 BEGIN
  GetPartPZV(L_AP.mthlWho_Driver, mtid_TimeDuty, PZVTim, PZVSum);
  Prc:=STRTOFLD(P_OwnData.GetOwnDProStrong(Memo.gl_mb(), E_Prop.P_OnDutyBonus),
                NUMERIC) / 100;
  IF AcsDrMonthly(mtid_TimeDuty, src_rws) > 0 THEN
   MoneyMan((AcsDrMonthly(mtid_SlrDuty, src_rws) + PZVSum) * Prc * GetPrcForClass(),
            AcsDrMonthly(mtid_TimeDuty, src_rws) + PZVTim);
  END;
 END {६};

 PUBLIC PROCEDURE ६();
  VAR
   Prc: NUMERIC[2];
 BEGIN
  GetPartPZV(L_AP.mthlWho_Driver, mtid_TimeSchool, PZVTim, PZVSum);
  Prc:=STRTOFLD(P_OwnData.GetOwnDProStrong(Memo.gl_mb(),
                                           E_Prop.P_SchoolDriverBonus),
                NUMERIC)/100;
  IF AcsDrMonthly(mtid_TimeSchool, src_rws) > 0 THEN
   MoneyMan((AcsDrMonthly(mtid_SlrSchool, src_rws) + PZVSum) * Prc * GetPrcForClass(),
            AcsDrMonthly(mtid_TimeSchool, src_rws) + PZVTim);
  END;
 END {६};

 PUBLIC PROCEDURE ();
  VAR
   prc,
   value : NUMERIC[3];
   maxval: NUMERIC[2];
 BEGIN
  IF Memo.gl_mb() >= 01\11\2004 THEN
   IF L_Staff.LastLogInMonth() THEN
    value:=TotalDrMonthly(mtid_EconFuel);
   ELSE
    value:=0;
   END;
  ELSE
   value:=AcsDrMonthly(mtid_EconFuel, src_rws);
  END;
  IF value > 0 THEN
   IF Memo.gl_mb() >= 01\09\2004 THEN
    prc:=GetOwnDValue(E_Prop.P_FuelEconBonus, 0);
    MoneyMan(value * prc / 100, 0);
   ELSE
    maxval:=STRTOFLD(P_OwnData.GetOwnDProStrong(Memo.gl_mb(),
                                                E_Prop.P_MaxEconomy), NUMERIC);
    MoneyMan(Math.Min(value, maxval), 0);
   END;
  END;
 END; {}

 PUBLIC PROCEDURE ();
  VAR
   prc,
   value: FLOAT;
 BEGIN
  IF Memo.gl_mb() >= 01\11\2004 THEN
   IF L_Staff.LastLogInMonth() THEN
    value:=TotalDrMonthly(mtid_EconFuel);
   ELSE
    value:=0;
   END;
  ELSE
   value:=AcsDrMonthly(mtid_EconFuel, src_rws);
  END;
  IF value < 0 THEN
   IF Memo.gl_mb() >= 01\09\2004 THEN
    prc:=GetOwnDValue(E_Prop.P_FuelEconBonus, 1);
    L_General.Assert(~!prc, " ன " + L_Str.IntStr(E_Prop.P_FuelEconBonus) +
                            "  㪠 業 㤥ঠ  ०");
    MoneyMan(-value * prc / 100, 0);
   ELSE
    MoneyMan(value * MoneyRul.Number, 0);
   END;
  END;
 END {};

 PUBLIC PROCEDURE 믏ଏ();
  VAR
   plan,
   fact: LIKE(Monthly.Proof);
 BEGIN
  L_General.Assert(Memo.gl_mb() >= 01\04\2008, "ࠢ '믏ଏ'    04.2008");
  plan:=Math.Trunc(AcsDrMonthly(30, src_All)); (* 죮⭨*)
  fact:=AcsDrMonthly(31, src_All);             (*䠪 죮⭨*)
  IF (plan>0) & (fact >= plan*OverPrcForVldPsgBonus()) THEN
   IF Memo.gl_mb() >= 01\05\2008 THEN
    MoneyMan(AcsDrMonthly(32, src_rws) * 0.20, AcsDrMonthly(33, src_rws));
   ELSE
    MoneyMan(AcsDrMonthly(mtid_SlrTown, src_rws) * 0.20, AcsDrMonthly(mtid_TimeTown, src_rws));
   END;
  END;
 END {믏ଏ};

 PUBLIC PROCEDURE ଏ();
  VAR
   plan,
   fact: LIKE(Monthly.Proof);
 BEGIN
  L_General.Assert(Memo.gl_mb() >= 01\03\2008, "ࠢ 'ଏ'    03.2008");
  plan:=Math.Trunc(AcsDrMonthly(30, src_All)); (* 죮⭨*)
  fact:=AcsDrMonthly(31, src_All);             (*䠪 죮⭨*)
  IF (plan>0) & (fact > plan) THEN
   IF Memo.gl_mb() >= 01\08\2011 THEN
    MoneyMan((fact - plan) * 1.40, 0);
   ELSE
    MoneyMan((fact - plan) * 0.40, 0);
   END;
  END;
 END {ଏ};

 PUBLIC PROCEDURE ⠭();
  VAR
   _GDay: NUMERIC[0];
   B,
   E    : DATE;
   FullNightTime: NUMERIC[0];
 BEGIN
  IF (Officer.PayKind # 13(*. ᪮ன*)) & (Officer.PayKind # 14(*.*)) &
     (SpT[L_Sheet.spk_Night] > 0) THEN
   IF    Memo.gl_mb() >= 01\04\2007 THEN
    FullNightTime:=4;
   ELSIF Memo.gl_mb() >= 01\05\2004 THEN
    FullNightTime:=6;
   ELSE
    FullNightTime:=7;
   END;
   SETZERO(_GDay);
   GetGate(B, E);
   SELECT(Sheet, TSN, , Staff.TSN, Memo.gl_mb());
   SRCINSEL(Sheet, EQ, , L_DatTim.DAY(B));
   WHILE OCCURE(Sheet) & (Sheet.Day <= L_DatTim.DAY(E)) DO
    CONFORM(Sheet, JMode);
    IF (JMode.Type = L_Sheet.jmType_TimDone) &
       (Sheet.SpKind = L_Sheet.spk_Night) &
       (Sheet.SpTime >= FullNightTime) THEN
     INC(_GDay);
    END;
    NEXT(Sheet);
   END; (* WHILE OCCURE(Sheet) ... *)
   IF _GDay>0 THEN
    MoneyMan(MoneyRul.Number * _GDay, 0);
   END;
  END;
 END {⠭};

 PRIVATE PROCEDURE _GetOfficerBonus(P: DATE): NUMERIC[3];
  VAR _Bonus: NUMERIC[3];
 BEGIN
  _Bonus:=L_Staff.GetOfficerBonus(P);
  RETURN _Bonus;
 END {_GetOfficerBonus};

 PRIVATE PROCEDURE _(_Bonus: SCAL[2]);
  VAR
   _Tim,
   _TD       : NUMERIC[3];
   _Pay      : LIKE(WagePayL.Pay[0]);
 BEGIN
  L_General.Assert(~!Adding._EDOrder, "  ᮢ饭   ଫ  ਪ");
  L_General.Assert(SEARCH(EDOrderL, EDOrder, Adding._EDOrder, Adding._Row), ".Error 2445");
  _Tim:=GetTimeByAdding("GetTimsDone");
  SEARCH(Officer, Officer, , EDOrderL.Sort, EDOrderL.Officer);
  CONFORM(Officer, WagePay);
  HISTCONF(Memo.gl_mb(), WagePay, WagePayL);
  _Pay:=WagePayL.Pay[EDOrderL.Class];
  IF WagePayL.Type = L_PRoll.wplType_MonthlyWage THEN
   _Pay:=_Pay / RegHead.FullBal * _Tim;
  ELSE
   _Pay:=_Pay * _Tim;
  END;
  IF ~_Bonus THEN
   MoneyMan(_Pay * (Adding.Value / 100), _Tim);
  ELSE
   MoneyMan(_Pay * (Adding.Value / 100) * _GetOfficerBonus(Memo.gl_mb()) / 100, _Tim);
  END;
(*---- restore correct values ------------*)
  CONFORM(StaffLog, Officer, WagePay);
  HISTCONF(Memo.gl_mb(), WagePay, WagePayL);
 END {_};

 PUBLIC PROCEDURE ();
 BEGIN
  _(0);
 END {};

 PUBLIC PROCEDURE ();
 BEGIN
  _(1);
 END {};

 PRIVATE PROCEDURE BadDays(): NUMERIC[0];
 BEGIN
  RETURN Days[03](*쭨*)+Days[05](*ࠢ*)+Days[13](*⮩*)+Days[15](*ண*)+
         Days[19](* ᢮ *)+Days[22](*   *)+Days[23](* ࠧ*);
 END {BadDays};

 PRIVATE PROCEDURE OverPrcForWorkHoursBonus(): NUMERIC[5];
 BEGIN
  IF Memo.gl_mb() >= 01\04\2010 THEN
   RETURN OverPrc / 100;
  ELSE
   RETURN 1;
  END;
 END {OverPrcForWorkHoursBonus};

 PUBLIC PROCEDURE ();
  CONST
   RegularMC = 015(*६ ॣ୮*);
   PlanMC    = 059(*६  *);
   OrderMC   = 045(*६ *);
   SchoolMC  = 088(*६ 誮*);
   VldPlanMC = 222(*६  믮   죮⭨*);
  VAR
   BaseSum: NUMERIC[2];
 BEGIN
  L_General.Assert(Memo.gl_mb() >= 01\11\2007, "ࠢ ''    11.2007");
  IF CanPayByMCode(MoneyRul.MCode, Memo.gl_mb()) & (_TimDone >= _CorBal*OverPrcForWorkHoursBonus()) & (BadDays() = 0) THEN
   IF Memo.gl_mb() >= 01\05\2008 THEN
    BaseSum:=GetMoneySum(RegularMC) +
             GetMoneySum(PlanMC) +
             GetMoneySum(OrderMC) +
             GetMoneySum(SchoolMC) +
             GetMoneySum(VldPlanMC);
   ELSE
    BaseSum:=GetMoneySum(RegularMC) +
             GetMoneySum(PlanMC) +
             GetMoneySum(OrderMC) +
             GetMoneySum(SchoolMC);
   END;
   MoneyMan(BaseSum * 0.15, 0);
  END;
 END {};

 PUBLIC PROCEDURE ExecClientPart();
  CONST
   KTUBonusMC     = 012(*६. .᫮ ६஢*);
   KTUBonusMC1    = 034(* /ਣ*);
   KTUBonusMC2    = 053(*६   㦠*);
   KTUBonusCorrMC = 230(*४.६.  *);
  VAR
   BaseSum: L_PRoll.tSum;
 BEGIN
  IF Memo.gl_mb() >= 01\03\2010 THEN
   BaseSum:=GetMoneySum(KTUBonusMC)+GetMoneySum(KTUBonusMC1)+GetMoneySum(KTUBonusMC2)+GetMoneySum(KTUBonusCorrMC);
   IF BaseSum < 0 THEN
    L_StdFrm.Choice("⥫쭠 㬬 ६,|  譨 㤥ঠ  ਪ");
   END;
  END;
 END {ExecClientPart};

(*--   ⥩ -------------------------------------------------*)

 PRIVATE PROCEDURE GetAddValueLen(): NUMERIC[6];
  VAR
   UpTo : DATE;
   DILen: NUMERIC[0];
 BEGIN
  IF !Adding.UpTo THEN
   UpTo:=Memo.gl_me();
  ELSE
   UpTo:=Adding.UpTo;
  END;
  DILen:=L_DatTim.DATEINT(Memo.gl_mb(), Memo.gl_me(), Adding.From, UpTo);
  IF DILen > 0 THEN
   L_General.Assert(Tims[06](*  室  ॡ*) > 0,
                    "稥   室  ॡ|" +
                    " ᮮ⢥ ⬥⮪  ⠡");
  END;
  RETURN DILen/L_DatTim.MonthLen(Memo.gl_mb());
 END {GetAddValueLen};

 PUBLIC PROCEDURE 室_15(); (* ( 14) *)
 BEGIN
  IF Adding.Value # 0 THEN
   L_General.Assert(Memo.gl_mb() < 01\01\2007, "ࠢ '室_15' ५  01.2007");
   MoneyMan(GetAddValueLen() * L_OwnData.ODPayBabyMind15(Memo.gl_mb()), 0);
  END;
 END {室_15};

BEGIN
 OverPrc:=STRTOFLD(P_OwnData.GetOwnDProStrong(Memo.gl_mb(), E_Prop.P_MakePlanPrc), NUMERIC);
 NeedPay:=SEARCH(StaffPro, TSN, Staff.TSN, E_Prop.P_IncPlan100, Memo.gl_mb()) & (StaffPro.Value="");
 SETZERO(PZVTim, PZVSum);
END.
