(*
%Copyright   (c) Polak Computer System
%Author
%Purpose     ⥪ 楤  RWayS.asl
%Type        library, to paste
%Specific    LOC
%Modified    20.01.2014 12:01:32 POLAK\Gina
%Environment
*)

 IMPORT L_General, L_Way, L_Hld, L_APtm, L_APWI,
        P_Car, P_Mark, P_OwnData, Str, E_Stock, E_Way, E_Prop, L_Env, L_RWayS;

 VAR
  ChopperTSN: LIKE(RWayS.TSN)[TripAmount];

(*--⥫----------------------------------------------------------------*)

 PRIVATE PROCEDURE IsSchoolTKind(trgTKind: LIKE(TKind.TKind)): SCAL[2];
 BEGIN
  RETURN trgTKind = 19;
 END {IsSchoolTKind};

 PUBLIC PROCEDURE ६();
  VAR
   Prc: NUMERIC[3];
 BEGIN
  L_General.Assert(RWayS.Date >= 01\03\2011, "ࠢ ६   03.2011");
  IF IsSchoolTKind(L_Way.GetRouteTKind(RWayS.Date, 1)) THEN
   Prc:=95;
  ELSE
   IF RWayS.Date >= 01\04\2012 THEN
    Prc:=95;
   ELSE
    Prc:=100;
   END;
  END;
  MoneyMan(Get___() *  Prc/100, CurTime);
 END {६};

 PUBLIC PROCEDURE _CompletePay(initialPay: tPay;
                               _Who      : SCAL[4];
                               _RWPay    : LIKE(RWPay.RWPay)): tPay;
 BEGIN
  RETURN initialPay;
 END {_CompletePay};

 PUBLIC PROCEDURE ();
 BEGIN
  IF RWayS.Date >= 01\03\2004 THEN
   AddPZVSum();
  END;
  MoneyMan(Add___(CurTime * TS * _n), CurTime);
 END {};

 PRIVATE PROCEDURE GetClass(): NUMERIC[3];
 BEGIN
  IF    StaffLog.Class = 1 THEN
   RETURN 0.25;
  ELSIF StaffLog.Class = 2 THEN
   RETURN 0.10;
  ELSE
   RETURN 0.00;
  END;
 END {GetClass};

 PUBLIC PROCEDURE ();
 BEGIN
  IF RWayS.Date >= 01\03\2004 THEN
   MoneyMan(Add___(CurTime * TS * GetClass()), CurTime);
  ELSE
   MoneyMan(CurTime * TS * GetClass(), CurTime);
  END;
 END {};

 PRIVATE PROCEDURE GetSDrvAmnt(): NUMERIC[0];
  VAR
   Result: NUMERIC[0];
 BEGIN
  Result:=0;
  IF ~L_RWayS.E_GetTimesFromWayLMen() THEN
   SAVE(WayLMen);
   IF SELECT(WayLMen, RWayS, RWayS.RWayS, L_Way.wlmwho_SDriver) THEN
    INC(Result, L_RWayS.IsRWayJForCurWayLMen());
   END;
   RESTORE(WayLMen);
  END;
  RETURN Result;
 END {GetSDrvAmnt};

 PUBLIC PROCEDURE ᇠ();
  VAR
   DrvAmnt: NUMERIC[0];
 BEGIN
  DrvAmnt:=GetSDrvAmnt()+L_Env.RealTSN(RWayS.TSN);
  IF RWayS.Date >= 01\03\2004 THEN
   MoneyMan(Add___(CurTime * TS * GetClass() / DrvAmnt), CurTime / DrvAmnt);
  ELSE
   MoneyMan(CurTime * TS * GetClass() / DrvAmnt, CurTime / DrvAmnt);
  END;
 END {ᇠ};

 PUBLIC PROCEDURE (); (*६  ࠡ  *)
 BEGIN
  IF ~INBITSET(TripArr[TripNbr], Gu) THEN
   IF WJMethod.Method ="22" THEN  (*஠⮡*)
    IF RWayS.Date >= 01\03\2004 THEN
     MoneyMan(Add___(CurTime * TS * _६(E_Prop.P_woGuardBonus, 0)), CurTime);
    ELSE
     MoneyMan(CurTime * TS * _६(E_Prop.P_woGuardBonus, 0), CurTime);
    END;
   ELSE
    MoneyMan(GetRWJP(E_Way.rwjp_DriverFctInc) * _n, CurTime);
   END;
  END;
 END {};

 PUBLIC PROCEDURE ६();
  VAR
   _Pay: NUMERIC[3];
 BEGIN
  IF P_Mark.HasActualMarkPro(Mark.Mark, RWayS.Date, P_Mark.P_OrderBonus) THEN
   _n:=STRTOFLD(MarkPro.Value, NUMERIC, "2.")/100;
  END;
  IF    StaffLog.Class = 1 THEN
   _Pay:= TS * 1.25;
  ELSIF StaffLog.Class = 2 THEN
   _Pay:= TS * 1.10;
  ELSE
   _Pay:= TS;
  END;
  MoneyMan(CurTime * _Pay * _n, CurTime);
 END {६};

 PUBLIC PROCEDURE ();
 BEGIN
  MoneyMan(Add___(CurNight * TS * 0.4), CurNight);
 END {};

 PUBLIC PROCEDURE ⠦();
 BEGIN
  L_General.Assert(RWayS.Date < 01\08\2012, 'ࠢ "⠦"  ਬ  08.2012');
  IF (CurWho = Dr) & INBITSET(TripArr[TripNbr], Dp) |
     (CurWho = Gu) & INBITSET(TripArr[TripNbr], Gp) THEN
   MoneyMan(CurTime * TS * _n, CurTime);
  END;
 END {⠦};

 PUBLIC PROCEDURE ();
 BEGIN
  IF L_Way.GetGapSign(CurWho) THEN
   IF RWayS.Date >= 01\04\2003 THEN
    MoneyMan(Add___(CurTime * TS * 0.40), CurTime);
   ELSE
    MoneyMan(CurTime * TS * 0.30, CurTime);
   END;
  END;
 END {};

 PUBLIC PROCEDURE ⥭();
  VAR
   _Pay    : NUMERIC[2];
   _TKind  : LIKE(TKind.TKind);
   _JRegime: LIKE(JRegime.JRegime);
 BEGIN
  SETZERO(_Pay);
  _TKind  :=L_Way.GetRouteTKind(RWayS.Date, 1);
  _JRegime:=L_Way.GetRouteJRegime(RWayS.Date, 1);
  IF    RWayS.Date >= 01\04\2012 THEN
   IF    _TKind = 01 (*த*) THEN
    _Pay:=5.00;
   ELSIF (_TKind = 11 (* *)) | (_TKind = 07 (* *)) THEN
    _Pay:=11.00;
   ELSIF (_TKind = 09) & (_JRegime = 03) (*"388 -"*) THEN
    _Pay:=0.00;
   ELSIF P_Mark.GetP_PVLim(Mark.Mark, RWayS.Date) > 110 THEN
    _Pay:=0.00;
   ELSIF Route.Route = "0704" THEN (*誮*)
    _Pay:=35.00;
   END;
  ELSIF RWayS.Date >= 01\03\2011 THEN
   IF    _TKind = 01 (*த*) THEN
    _Pay:=7.00;
   ELSIF (_TKind = 11 (* *)) | (_TKind = 07 (* *)) THEN
    _Pay:=20.00;
   ELSIF (_TKind = 09) & (_JRegime = 03) (*"388 -"*) THEN
    _Pay:=5.00;
   ELSIF P_Mark.GetP_PVLim(Mark.Mark, RWayS.Date) > 110 THEN
    _Pay:=5.00;
   ELSIF Route.Route = "0704" THEN (*誮*)
    IF RWayS.Date >= 01\03\2011 THEN
     _Pay:=40.00;
    ELSE
     _Pay:=50.00;
    END;
   END;
  ELSIF RWayS.Date >= 01\11\2007 THEN
   IF    _TKind = 01 (*த*) THEN
    _Pay:=10.00;
   ELSIF (_TKind = 11 (* *)) | (_TKind = 07 (* *)) THEN
    _Pay:=20.00;
   ELSIF (_TKind = 09) & (_JRegime = 03) (*"388 -"*) THEN
    _Pay:=5.00;
   ELSIF P_Mark.GetP_PVLim(Mark.Mark, RWayS.Date) > 110 THEN
    _Pay:=10.00;
   ELSIF Route.Route = "0704" THEN (*誮*)
    _Pay:=45.00;
   END;
  ELSIF RWayS.Date >= 01\01\2007 THEN
   IF    _TKind = 01 (*த*) THEN
    _Pay:=8.00;
   ELSIF _TKind = 11 (* *) THEN
    _Pay:=16.00;
   END;
   IF P_Mark.GetP_PVLim(Mark.Mark, RWayS.Date) > 110 THEN
    INC(_Pay, 8.00);
   END;
   IF    (RWayS.Date>=01\03\2007) & (Route.Route = "0788") (*த  ஠⮡*) THEN
    _Pay:=10.00;
   ELSIF Route.Route = "0388" (*த*) THEN
    _Pay:=10.00;
   ELSIF Route.Route = "0704" THEN (*誮*)
    _Pay:=25.00;
   END;
  ELSIF RWayS.Date >= 01\10\2006 THEN
   IF    _TKind = 01 (*த*) THEN
    _Pay:=8.00;
   ELSIF _TKind = 11 (* *) THEN
    _Pay:=16.00;
   ELSIF _JRegime = 03 (*த*) THEN
    _Pay:=13.00;
   END;
   IF P_Mark.GetP_PVLim(Mark.Mark, RWayS.Date) > 110 THEN
    INC(_Pay, 8.00);
   END;
   IF Route.Route = "0704" THEN (*誮*)
    _Pay:=25.00;
   END;
  ELSIF RWayS.Date >= 01\03\2006 THEN
   IF    _TKind = 01 (*த*) THEN
    _Pay:=4.00;
   ELSIF _TKind = 11 (* *) THEN
    _Pay:=16.00;
   ELSIF _JRegime = 03 (*த*) THEN
    _Pay:=10.00;
   END;
   IF P_Mark.GetP_PVLim(Mark.Mark, RWayS.Date) > 110 THEN
    INC(_Pay, 6.00);
   END;
  ELSIF RWayS.Date >= 01\01\2006 THEN
   IF _JRegime # 03 (*த*) THEN
    IF    _TKind = 01 (*த*) THEN
     _Pay:=4.00;
    ELSIF _TKind = 11 (* *) THEN
     _Pay:=16.00;
    END;
    IF P_Mark.GetP_PVLim(Mark.Mark, RWayS.Date) > 110 THEN
     INC(_Pay, 6.00);
    END;
   END;
  ELSIF RWayS.Date >= 01\02\2005 THEN
   IF    _TKind = 01 (*த*) THEN
    _Pay:=4.00;
   ELSIF _TKind = 11 (* *) THEN
    _Pay:=16.00;
   ELSIF _JRegime = 03 (*த*) THEN
    IF RWayS.Date >= 01\04\2005 THEN
     _Pay:=20.00;
    ELSE
     _Pay:=17.00;
    END;
   END;
   IF P_Mark.GetP_PVLim(Mark.Mark, RWayS.Date) > 110 THEN
    INC(_Pay, 6.00);
   END;
  ELSIF RWayS.Date >= 01\11\2003 THEN
   IF    _TKind = 01 (*த*) THEN
    _Pay:=2.00;
   ELSIF _TKind = 11 (* *) THEN
    _Pay:=10.00;
   ELSIF _JRegime = 03 (*த*) THEN
    _Pay:=6.00;
   END;
   IF P_Mark.GetP_PVLim(Mark.Mark, RWayS.Date) > 110 THEN
    INC(_Pay, 5.00);
   END;
  ELSE
   IF L_Env.IsMTDriver()         &
      (RWayS.Date >= 01\08\2003) &
      Str.Match(Route.Route, "06*") THEN
    INC(_Pay, 6.00);
   END;
   IF _TKind = 01 (*த*) THEN
    INC(_Pay, 2.00);
   END;
   IF (_TKind = 11) (* *) THEN
    IF RWayS.Date >= 01\05\2003 THEN
     INC(_Pay, 6.00);
    END;
   END;
   IF _JRegime = 03 (*த*) THEN
    IF RWayS.Date >= 01\03\2003 THEN
     INC(_Pay, 6.00);
    ELSE
     INC(_Pay, 3.00);
    END;
   END;
   IF P_Mark.GetP_PVLim(Mark.Mark, RWayS.Date) > 110 THEN
    INC(_Pay, 5.00);
   END;
  END;
  IF _Pay > 0 THEN
   MoneyMan(CurTime * _Pay, CurTime);
  END;
 END {⥭};

 PUBLIC PROCEDURE ⥭();
  VAR
   _Pay: NUMERIC[2];
 BEGIN
  L_General.Assert(RWayS.Date < 01\11\2007, 'ࠢ ⥭  ਬ  11.2007');
  SETZERO(_Pay);
  IF L_Way.GetRouteJRegime(RWayS.Date, 1) = 03 (*த*) THEN
   IF    RWayS.Date >= 01\02\2005 THEN
    _Pay:=10.00;
   ELSIF RWayS.Date >= 01\11\2003 THEN
    _Pay:=9.00;
   ELSIF RWayS.Date >= 01\03\2003 THEN
    _Pay:=11.00;
   ELSE
    _Pay:=12.00;
   END;
  ELSE
   IF    RWayS.Date >= 01\02\2005 THEN
    _Pay:=5.00;
   ELSIF RWayS.Date >= 01\11\2003 THEN
    _Pay:=3.00;
   ELSIF RWayS.Date >= 01\03\2003 THEN
    _Pay:=6.00;
   ELSE
    _Pay:=7.00;
   END;
  END;
  IF _Pay > 0 THEN
   MoneyMan(CurTime * _Pay, CurTime);
  END;
 END {⥭};

 PUBLIC PROCEDURE ⥭();
  VAR
   _Pay: NUMERIC[2];
 BEGIN
  L_General.Assert(RWayS.Date >= 01\04\2010, 'ࠢ ⥭ ਬ  04.2010');
  L_General.Assert(L_Way.GetRouteJRegime(RWayS.Date, 1) = 03(*த*), "⥭:  ० ࠡ");
  _Pay:=4.00;
  MoneyMan(CurTime * _Pay, CurTime);
 END {⥭};

 PUBLIC PROCEDURE ᪢();
  VAR t: FLOAT;
 BEGIN
  t:=GetRWJP(E_Way.rwjp_MoscowTime);
  IF t = 0 THEN
   t:=(CurTime / ((SEJobs.StopT-SEJobs.StartT) * RWayJ.Fact) * RoutMod.TimSign[2] / 60)* RWayJ.Fact;
  END;
  MoneyMan(t * TS * _n, t);
 END {᪢};

 PUBLIC PROCEDURE ();
  VAR
   Cnt : NUMERIC[0];
   _Pay: NUMERIC[2];
 BEGIN
  L_General.Assert(RWayS.Date < 01\06\2012, "ࠢ ''    06.2012");
  Cnt:=GetRWJP(E_Way.rwjp_DriverAddTrip);
  SETZERO(_Pay);
  IF Cnt > 0 THEN
   IF L_Way.GetRouteJRegime(RWayS.Date, 1) = 01 (*த*) THEN
    _Pay:= 50;
   ELSIF L_Way.GetRouteJRegime(RWayS.Date, 1) = 02 (*ਣத*) THEN
    _Pay:= 100;
   ELSIF L_Way.GetRouteJRegime(RWayS.Date, 1) = 03 (*த*) THEN
    _Pay:= 200;
   END;
   IF _Pay > 0 THEN
    MoneyMan(Cnt * _Pay, Cnt);
   END;
  END;
 END {};

 PUBLIC PROCEDURE ();
  VAR
   Cnt : NUMERIC[0];
   _Pay: NUMERIC[2];
 BEGIN
  L_General.Assert(RWayS.Date < 01\06\2012, "ࠢ ''    06.2012");
  Cnt:=GetRWJP(E_Way.rwjp_GuardAddTrip);
  SETZERO(_Pay);
  IF Cnt > 0 THEN
   IF L_Way.GetRouteJRegime(RWayS.Date, 1) = 01 (*த*) THEN
    _Pay:= 25;
   ELSIF L_Way.GetRouteJRegime(RWayS.Date, 1) = 02 (*ਣத*) THEN
    _Pay:= 50;
   END;
   IF _Pay > 0 THEN
    MoneyMan(Cnt * _Pay, Cnt);
   END;
  END;
 END {};

 PUBLIC PROCEDURE ६();
 BEGIN
  MoneyMan(CurTime * TS * _n, CurTime);
 END {६};

 PUBLIC PROCEDURE ();
  VAR
   _K     : NUMERIC[3];
   _TKind : LIKE(TKind.TKind);
   DrvAmnt: NUMERIC[0];
 BEGIN
  IF L_Env.IsRouteDriver() THEN
   IF RWayS.Date >= 01\07\2003 THEN
    _TKind:=L_Way.GetRouteTKind(RWayS.Date, 1);
    IF    RWayS.Date >= 01\04\2012 THEN
     IF    IsSchoolTKind(_TKind) THEN _K:=30;
     ELSIF Route.Route = "3013"  THEN _K:=25; (*- ⮑*)
     ELSE                             _K:=65;
     END;
    ELSIF RWayS.Date >= 01\03\2011 THEN
     IF    IsSchoolTKind(_TKind) THEN
      _K:=50;
     ELSIF Route.Route = "3013" THEN _K:=25; (*- ⮑*)
     ELSE                            _K:=65;
     END;
    ELSIF RWayS.Date >= 01\11\2007 THEN
     IF Route.Route = "3013" THEN _K:=25; (*- ⮑*)
     ELSE                         _K:=70;
     END;
    ELSIF RWayS.Date >= 01\10\2006 THEN
     IF Route.Route = "3013" THEN _K:=25; (*- ⮑*)
     ELSE                         _K:=60;
     END;
    ELSIF RWayS.Date >= 01\01\2004 THEN
     IF Route.Route = "3013" THEN _K:=25; (*- ⮑*)
     ELSE                         _K:=50;
     END;
    ELSIF RWayS.Date >= 01\11\2003 THEN _K:=25;
    ELSE                                _K:=15;              (*15 .  *)
    END;
    DrvAmnt:=GetSDrvAmnt()+L_Env.RealTSN(RWayS.TSN);
    MoneyMan(CurTime * _K / DrvAmnt, CurTime / DrvAmnt);
   ELSE
    MoneyMan(CurTime * 15, CurTime);                         (*15 .  *)
   END;
  END;
 END {};

 PUBLIC PROCEDURE ();
 BEGIN
  IF    RWayS.Date >= 01\11\2007 THEN
   MoneyMan(0.05 * Get___(), CurTime);
  ELSIF RWayS.Date >= 01\03\2007 THEN
   MoneyMan(0.45 * Get___(), CurTime);
  ELSIF RWayS.Date >= 01\09\2005 THEN
   MoneyMan(CurTime * 5, CurTime);
  ELSIF RWayS.Date >= 01\11\2003 THEN
   MoneyMan(CurTime * 2, CurTime);
  ELSIF RWayS.Date >= 01\10\2002 THEN
   MoneyMan(CurTime * 4, CurTime);
  ELSE
   L_General.Error('ࠢ   ਬ  10.2002');
  END;
 END {};

 PUBLIC PROCEDURE ।();
  VAR
   Prc : NUMERIC[3];
 BEGIN
  IF P_Car.HasActualCarPro(RWayS.BoxNbr, RWayS.Date, E_Prop.P_CarHarm) THEN
   Prc:=STRTOFLD(CarPro.Value, NUMERIC, "2.")/100;
   MoneyMan(CurTime * TS * Prc, CurTime);
  END;
 END {।};

 PUBLIC PROCEDURE ஡();
 BEGIN
(*
  IF    GlobalRun >  500000 THEN
   MoneyMan(TS * 20 / 100, CurTime);
  END;
*)
 END {஡};

 PUBLIC PROCEDURE 室();
 BEGIN
  IF (ToSheet = 2) & ~L_Hld.DayIsHoliday(Calendar.Date) THEN
   MoneyMan(CurTime * TS * _n, CurTime);
  END;
 END {室};

 PUBLIC PROCEDURE 室();
 BEGIN
  IF (L_Way.GetWLMToSheetSign(WayLMen.Who) = 2) &
     ~L_Hld.DayIsHoliday(Calendar.Date) THEN
   MoneyMan(CurTime * TS * _n, CurTime);
  END;
 END {室};

 PUBLIC PROCEDURE ();
 BEGIN
  MoneyMan(CurTime * TS, CurTime);
 END {};

 PUBLIC PROCEDURE ();
 BEGIN
  MoneyMan(CurTime * TS, CurTime);
 END {};

 PUBLIC PROCEDURE ();
 BEGIN
  MoneyMan(CurTime * TS * GetClass(), CurTime);
 END {};

 PUBLIC PROCEDURE ࠧ();
 BEGIN
  IF TotalHolid > 0 THEN
   MoneyMan(TotalHolid * TS, TotalHolid);
  END;
 END {ࠧ};

 PUBLIC PROCEDURE ࠧ();
 BEGIN
  IF TotalHolid > 0 THEN
   MoneyMan(TotalHolid * TS, TotalHolid);
  END;
 END {ࠧ};

 PRIVATE PROCEDURE _६(ODPro: LIKE(Property.Property); _Item: SCAL[10]): NUMERIC[3];
  VAR
   _Value: STRING[];
 BEGIN
  _Value:=Str.Item(P_OwnData.GetOwnDProStrong(RWayS.Date, ODPro), ";", _Item);
  RETURN STRTOFLD(_Value, NUMERIC, "3.")/100;
 END {_६};

 PUBLIC PROCEDURE 멃䨪();
  VAR
   Need: SCAL[2];
 BEGIN
  L_General.Assert(RWayS.Date>=01\08\2006, "ࠢ '멃䨪'    08.2006");
  IF L_Way.GetWho(CurWho) = L_Way.rwswho_Driver THEN
   IF RWayS.Date >= 01\10\2006 THEN
    Need:=L_Env.IsMTDriver();
   ELSE
    Need:=(StaffLog.Regime="0170") | (StaffLog.Regime="0171");
   END;
   IF Need THEN
    IF RWayS.Date>=01\01\2007 THEN
     MoneyMan(Add___(CurTime * TS * 0.12), CurTime);
    ELSE
     MoneyMan(Add___(CurTime * TS * 0.16), CurTime);
    END;
   END;
  END;
 END {멃䨪};

 PUBLIC PROCEDURE 6();
 BEGIN
  IF Str.Match(Route.Route, "06*") & (L_Way.GetMarkG(Mark.Mark, L_Way.mgt_REPlan) # 0122) THEN
   MoneyMan(CurTime * 15, CurTime);
  END;
 END {6};

 PRIVATE PROCEDURE PsgPrice(): NUMERIC[2];
 BEGIN
  IF RWayS.Date >= 01\03\2008 THEN
   IF    L_Way.GetWho(CurWho) = Dr THEN
    RETURN 0.60;
   ELSE
    RETURN 0.50;
   END;
  ELSE
   RETURN 0.50;
  END;
 END {PsgPrice};

 PRIVATE PROCEDURE TestChopperAmount();
 BEGIN
  (* ࠧ  . ᠦ஢  ࠧ 稪*)
  IF ~!ChopperTSN[TripNbr] THEN
   L_General.Error(" " + RWayJPoint() + "   " +
                   "|᪮쪨  稪 (ନ騪):" +
                   "|| ⠡. " + ChopperTSN[TripNbr] + "  " + Staff.TSN + "." +
                   "||᪠    稪  ३");
  END;
 END {TestChopperAmount};

 PUBLIC PROCEDURE 죏();
  VAR
   Amount: NUMERIC[0];
 BEGIN
  IF WithASCP THEN
   RETURN;
  END;
  IF    (RWayS.Date >= 01\05\2007) THEN
   Amount:=0;
   IF    L_Way.GetWho(CurWho) = Dr THEN
    Amount:=GetRWJP(73) + GetRWJP(74) + GetRWJP(69);
   ELSIF L_Way.GetWho(CurWho) = Gu THEN
    IF    WayLMen.Number = 1 THEN
     Amount:=GetRWJP(79) + GetRWJP(80) + GetRWJP(72);
    ELSIF WayLMen.Number = 2 THEN
     Amount:=GetRWJP(77) + GetRWJP(78) + GetRWJP(71);
    ELSE
     L_General.Error("  2- ஢");
    END;
   ELSIF  (L_Way.GetWho(CurWho) = L_Way.rwswho_Chopper) & (RWayS.Date>=11\10\2005) THEN
    TestChopperAmount();
    Amount:=GetRWJP(75) + GetRWJP(76) + GetRWJP(70);
   END;
   MoneyMan(Amount * PsgPrice(), 0);
  ELSE
   IF (L_Way.GetWho(CurWho) = Dr) & ~INBITSET(TripArr[TripNbr], Gu) THEN
    MoneyMan((GetRWJP(79)+GetRWJP(80)) * 0.50, 0);
   ELSIF L_Way.GetWho(CurWho) = Gu THEN
    IF    WayLMen.Number = 1 THEN
     MoneyMan((GetRWJP(79)+GetRWJP(80)) * 0.50, 0);
    ELSIF WayLMen.Number = 2 THEN
     MoneyMan((GetRWJP(77)+GetRWJP(78)) * 0.50, 0);
    ELSE
     L_General.Error("  2- ஢");
    END;
   END;
  END;
 END {죏};

 PUBLIC PROCEDURE ⏠();
  VAR
   Amount: NUMERIC[0];
 BEGIN
  IF WithASCP THEN
   RETURN;
  END;
  Amount:=0;
  IF    L_Way.GetWho(CurWho) = Dr THEN   Amount:=GetRWJP(82);
  ELSIF L_Way.GetWho(CurWho) = Gu THEN
   IF    WayLMen.Number = 1 THEN         Amount:=GetRWJP(85);
   ELSIF WayLMen.Number = 2 THEN         Amount:=GetRWJP(84);
   ELSE
    L_General.Error("  2- ஢");
   END;
  ELSIF  (L_Way.GetWho(CurWho) = L_Way.rwswho_Chopper) & (RWayS.Date>=11\10\2005) THEN
   TestChopperAmount();
   ChopperTSN[TripNbr]:=Staff.TSN;
   Amount:=GetRWJP(83);
  END;
  MoneyMan(Amount * PsgPrice(), 0);
 END {⏠};

 PUBLIC PROCEDURE ६();
 BEGIN
  L_General.Assert(RWayS.Date>=01\11\2009, "ࠢ '६'    11.2009");
  IF WithASCP THEN
   MoneyMan(Get___() * 30 / 100, CurTime);
  END;
 END {६};

 PUBLIC PROCEDURE ();
 BEGIN
  L_General.Assert(RWayS.Date>=01\05\2011, "ࠢ ''    05.2011");
  MoneyMan(GetRWJP(E_Way.rwjp_TKPrepayment) * 5 / 100, 0);
 END {};

 PUBLIC PROCEDURE GetCSignature(): STRING[100];
 BEGIN
  RETURN SEJobs.Exit;
 END {GetCSignature};

 PUBLIC PROCEDURE DecCSignature(S: STRING[100]): STRING[100];
 BEGIN
  RETURN "室 "+S;
 END {DecCSignature};

 PUBLIC PROCEDURE SetCBox(Idx: NUMERIC[0]);
 BEGIN
  INC(CBoxByCash[Idx], GetRWJP(E_Way.rwjp_CasFctInc));
  INC(CBoxIncome[Idx], CurIncome);
 END {SetCBox};

 PRIVATE PROCEDURE FullIncome(): NUMERIC[2];
 BEGIN
  RETURN GetRWJP(E_Way.rwjp_DriverFctInc)+
         GetRWJP(E_Way.rwjp_GuardFctInc)+GetRWJP(E_Way.rwjp_SGuardFctInc)+
         GetRWJP(E_Way.rwjp_CasFctInc)+
         GetRWJP(E_Way.rwjp_Chopper_Msk)+GetRWJP(E_Way.rwjp_Chopper_Htk);
 END {FullIncome};

 PUBLIC PROCEDURE SetCurIncome();
 BEGIN
  IF !CurWho THEN     (*AllIncome  FirstPass()*)
   IF (MODE = 001) | (MODE = 003) THEN
    IF WithGu = 0 THEN
     L_General.Assert((GetRWJP(E_Way.rwjp_GuardFctInc)+GetRWJP(E_Way.rwjp_SGuardFctInc)) = 0, "㤠 ᪠ 窠?");
    ELSE
     L_General.Assert((GetRWJP(E_Way.rwjp_DriverFctInc) = 0) |
                      ((GetRWJP(E_Way.rwjp_GuardFctInc)+GetRWJP(E_Way.rwjp_SGuardFctInc)) = 0),
                      "⥫  ஬ ᤠ ?");
     IF WithGu = 1 THEN
      L_General.Assert(GetRWJP(E_Way.rwjp_SGuardFctInc) = 0, "㤠 窠 ண ");
     END;
    END;
   END;
   CurIncome:=FullIncome();
  ELSE
   IF CurWho = L_Way.rwswho_Guard THEN
    IF    WayLMen.Number = 1 THEN
     CurIncome:=GetRWJP(E_Way.rwjp_GuardFctInc)+GetRWJP(E_Way.rwjp_CasFctInc);
    ELSIF WayLMen.Number = 2 THEN
     CurIncome:=GetRWJP(E_Way.rwjp_SGuardFctInc)+GetRWJP(E_Way.rwjp_CasFctInc);
    ELSE
     L_General.Error("  2- ஢");
    END;
   ELSIF CurWho = L_Way.rwswho_Chopper THEN
    IF L_Way.AccessTckRcS_byRWayJ(Staff.TSN, L_Way.trs_Chopper) THEN
     IF    TckRcS.AsWhoCnd = E_Way.trawc_Msk THEN
      CurIncome:=GetRWJP(E_Way.rwjp_Chopper_Msk);
     ELSIF TckRcS.AsWhoCnd = E_Way.trawc_Htk THEN
      CurIncome:=GetRWJP(E_Way.rwjp_Chopper_Htk);
     ELSIF TckRcS.AsWhoCnd = E_Way.trawc_Ctl THEN
      CurIncome:=0;
     ELSE
      L_General.CallUs(0);
     END;
    ELSE
     CurIncome:=0;
    END;
   ELSE
    CurIncome:=FullIncome();
   END;
  END; (* IF AllIncome... *)
 END {SetCurIncome};

 PRIVATE PROCEDURE GetIncPlanCorr(): NUMERIC[3];
  VAR
   Coef,
   Delta: NUMERIC[3];
 BEGIN
  Delta:=STRTOFLD(P_Car.GetCarProSoft(RWayS.BoxNbr, RWayS.Date, E_Prop.P_CarIncPlnCorr), NUMERIC);
  IF ~!Delta THEN
   Coef:=1 + Delta / 100;
  ELSE
   Coef:=1;
  END;
  IF ((01\09\2004 <= RWayS.Date) & (RWayS.Date <= 30\09\2004)) &
     (Route.Route = "0388") THEN
   Coef:=0.9*Coef;
  END;
  IF ((RWayS.Date = 01\05\2003) |
      (RWayS.Date = 09\05\2003) |
      (RWayS.Date = 15\06\2003)) & Str.Match(SEJobs.Exit, "6*") THEN
   RETURN 0.7; (* ࠢ쭮 0.7*Coef,   㦥 ࠢ *)
  ELSE
   RETURN Coef;
  END;
 END {GetIncPlanCorr};

 PUBLIC PROCEDURE GetPl(): NUMERIC[4];
  VAR
   Result: NUMERIC[4];
 BEGIN
  L_General.Assert(GetRWJP(L_Way.rwjp_PlanIsEqualFact) <= E_Way.PlEqFc_All,
                   "祭 ⥫  " + L_Str.IntStr(L_Way.rwjp_PlanIsEqualFact)+"     3");
  IF (WJMode.IncSel * Route.IncSel > 0) THEN
   IF    L_Way.E_RWayJPlanIsEqualFact() THEN
    Result:=CurIncome;
   ELSE
    Result:=GetIncPlanCorr() * L_APWI.GetPlanIncomeForRWayJ(WithGu);
   END;
  ELSE
   Result:=0;
  END;
  RETURN Result;
 END {GetPl};

 PRIVATE PROCEDURE IsPeugeot(): SCAL[2];
 BEGIN
  RETURN (Mark.Mark = 0114);
 END {IsPeugeot};

 PUBLIC PROCEDURE (): NUMERIC[6];                           
 BEGIN
  IF    CurWho = L_Way.rwswho_Driver THEN
   IF (ForFuel > 0) & IsPeugeot() THEN
    RETURN 0;
   ELSE
    RETURN ForFuel;
   END;
  ELSE
   RETURN 0;                                                              
  END;
 END {};           
 
 PUBLIC PROCEDURE 唠(): NUMERIC[6];                           
 BEGIN
  IF ~L_Way.rwswhoWithSale(L_Way.GetWho(CurWho)) THEN
   RETURN 0;
  END;
  RETURN CurIncome;
 END {唠};

 PUBLIC PROCEDURE 叫(): NUMERIC[6];
  VAR
   _CurIncome: NUMERIC[2];
 BEGIN
  IF ~L_Way.rwswhoWithSale(L_Way.GetWho(CurWho)) THEN
   RETURN 0;
  END;
  IF    CurWho = L_Way.rwswho_Guard THEN
   IF (RWayS.Date >= 01\11\2009) & WithASCP THEN
    IF    WayLMen.Number = 1 THEN  (*"" 䠪 㠫, ⮡  뫮,  த   *)
     _CurIncome:=GetRWJP(E_Way.rwjp_GuardFctInc);
    ELSIF WayLMen.Number = 2 THEN
     _CurIncome:=GetRWJP(E_Way.rwjp_SGuardFctInc);
    END;
    L_General.Assert(_CurIncome=0, "  : 㤠 䠪᪠ 窠");
    RETURN 0;
   ELSE
    RETURN TripIPl[TripNbr]/IPlDvdr[TripNbr];
   END;
  ELSIF CurWho = L_Way.rwswho_Chopper THEN
   RETURN E_Way.int_GetChopperPlanIncome(Staff.TSN);
  ELSE
   RETURN TripIPl[TripNbr];
  END;
 END {叫};

 PRIVATE PROCEDURE NeedIndividualIncome(): SCAL[2];
 BEGIN
  RETURN (SEJobs.Route = "0388") & (L_Way.GetWho(CurWho) = Dr);
 END {NeedIndividualIncome};
 
 PUBLIC PROCEDURE 唠∭(): NUMERIC[6];
 BEGIN
  IF NeedIndividualIncome() THEN
   RETURN GetRWJP(E_Way.rwjp_DriverFctInc);
  ELSE
   RETURN 0;
  END;
 END {唠∭};
 
 PUBLIC PROCEDURE 叫(): NUMERIC[6];
 BEGIN
  IF NeedIndividualIncome() THEN
   IF (GetRWJP(L_Way.rwjp_PlanIsEqualFact) = E_Way.PlEqFc_DriverOnly) |
      (GetRWJP(L_Way.rwjp_PlanIsEqualFact) = E_Way.PlEqFc_All) THEN
    RETURN GetRWJP(E_Way.rwjp_DriverFctInc);
   ELSE
    RETURN L_APWI.E_GetPlanIncomeScope(L_APWI.piScope_RWTaxed, RWayS.Date, L_Way.ipc_Driver);
   END;
  ELSE
   RETURN 0;
  END;
 END {叫};

 PUBLIC PROCEDURE ६(): NUMERIC[6];
 BEGIN
  RETURN CurTime;
 END {६};

 PUBLIC PROCEDURE ࠡ(): NUMERIC[6];
 BEGIN
  RETURN TSsum;
 END {ࠡ};
 
 PUBLIC PROCEDURE ࠡ६(): NUMERIC[6];
 BEGIN
  IF RWayS.Date >= 01\02\2004 THEN
   RETURN Get___();
  ELSE
   RETURN TSsum;
  END;
 END {ࠡ६};
 
 PUBLIC PROCEDURE (): NUMERIC[6];
 BEGIN
  RETURN RWayJ.Fact;
 END {};

 PUBLIC PROCEDURE ६388();
  VAR
   Cnt: NUMERIC[1];
 BEGIN
  L_General.Assert(RWayS.Date<01\02\2005, "ࠢ '६388'    02\2005");
  SETZERO(Cnt);
  CONFORM(RWayS, RWayJ);
  WHILE OCCURE(RWayJ) DO
   CONFORM(RWayJ, Quality);
   IF Quality.Type > 0 THEN
    CONFORM(RWayJ, SEJobs);
    IF (SEJobs.WJCode = "10") & (SEJobs.Route = "0388") THEN
     INC(Cnt);
    END;
   END;
   NEXT(RWayJ);
  END;
  IF (RWayS.Date >= 01\05\2004) & (Cnt/2 >= 1) THEN
   MoneyMan(_n, 0);
  ELSIF Cnt/2 >= 3 THEN
   MoneyMan(_n, 0);
  END;
 END {६388};

 PUBLIC PROCEDURE ࠡ६(): NUMERIC[6];
 BEGIN
  L_General.Assert(RWayS.Date >= 01\04\2008, "ࠢ 'ࠡ६'    04.2008");
  IF ~WithASCP & (ଏᏫ() > 0) THEN
   RETURN Get___();
  ELSE
   RETURN 0;
  END;
 END {ࠡ६};

 PUBLIC PROCEDURE ६(): NUMERIC[6];
 BEGIN
  L_General.Assert(RWayS.Date >= 01\04\2008, "ࠢ '६'    04.2008");
  IF ~WithASCP & (ଏᏫ() > 0) THEN
   RETURN CurTime;
  ELSE
   RETURN 0;
  END;
 END {६};
 
 PUBLIC PROCEDURE FuelAcntInit(VAR TK_AcCuts: LIKE(AcCut.AcCut)[]);
  VAR
   _MtyIdx: LIKE(MtyIdx.MtyIdx);
 BEGIN
  SAVE(TKind);
  SELECT(TKind, TKind);
  WHILE OCCURE(TKind) DO
   IF (TKind.TKind # 06) & (TKind.TKind # 17) THEN (*直   ࠢ筨*)
    _MtyIdx:=E_Stock.TKind2MtyIdx(RWayS.Date, TKind.TKind);
    IF ~!_MtyIdx THEN
     TK_AcCut[TKind.TKind]:=E_Stock.MtyIdxAcCut(L_MathR.DprK_Acn, _MtyIdx);
    END;
   END;
   NEXT(TKind);
  END; (* WHILE OCCURE(TKind) ... *)
  RESTORE(TKind);
 END {FuelAcntInit};

BEGIN
 SETEMPTY(ChopperTSN);
END.