(*
%Copyright   (c) Polak Computer System
%Author      25.03.2002 17:59:08 GINA
%Purpose     ᮡ 뤠 
%Type        library
%Specific    LOC
%Modified    22.03.2013 16:02:45 POLAK\Gina
%Environment
*)

 IMPORT L_DatTim, L_Staff, L_General, L_PRoll, P_Staff, L_Sheet, L_Str;

 PUBLIC PROCEDURE GetMinSum(D: DATE): LIKE(Money.Sum);
 BEGIN
  RETURN 300;
 END {GetMinSum};

 PRIVATE PROCEDURE NoAvn_Sheet();
 BEGIN
  L_General.Assert(SEARCH(Sheet, TSN, Staff.TSN, L_DatTim.Per(Today), L_DatTim.DAY(Today)), "  ⠡  "+L_DatTim.DateStr(Today));
  NoAvn_Assert((Sheet.JMode#L_Sheet.jm_ParentalLeave) & (Sheet.JMode#L_Sheet.jm_ParentalLeaveUntil3Y),
               "室  ॡ");
 END {NoAvn_Sheet};

 PUBLIC PROCEDURE GetAvnValue(): NUMERIC[2];
  VAR
   AvansbySum: SCAL[2];
   Avans     : NUMERIC[2];
 BEGIN
  NoAvn_Assert(Staff.Contract=L_Staff.cnt_Basic, " .ࠡ: "+L_Str.PoolItem(L_Staff.cnt_Pool, Staff.Contract));
  HISTCONF(PeriodE, Staff, StaffLog);
  NoAvn_Sheet();
  L_Staff.GetAvans(Staff.TSN, _Period, AvansbySum, Avans);
  NoAvn_Assert(Avans > 0, "⠭  0");
  CONFORM(StaffLog, Officer, WagePay);
  HISTCONF(_Period, WagePay, WagePayL);
  IF ~AvansbySum THEN
   NoAvn_Assert(WagePay.WagePay#0000, "䭠 ⠢ 0");
   IF WagePayL.Type = L_PRoll.wplType_Tariff THEN
    NoAvn_Assert(0, "  %  ");
   END;
   Avans:=WagePayL.Pay[StaffLog.Class]*Avans/100;
  ELSE
   IF (WagePayL.Type = L_PRoll.wplType_MonthlyWage) &
      (~P_Staff.HasActualStaffPro(Staff.TSN, _Period, P_Staff.P_Advance)) THEN
    Avans:=WagePayL.Pay[StaffLog.Class] / 2;
   END;
  END;
  RETURN Avans;
 END {GetAvnValue};

 PUBLIC PROCEDURE SetCorrVal();
  VAR
   _OutSaldo: NUMERIC[2];
   Dummy    : FLOAT;
 BEGIN
  L_General.Assert(L_PRoll.IsDedD_OnDate(Today), " 믮  ௫  "+Staff.TSN+"   "+L_DatTim.DateStr(Today));
  CorrVal:=InitVal;
  Dummy:=CorrectionByTime(); (*  TimDone  *)
  NoAvn_Assert(_TimDone >= 0.60 * _FullBal, "ࠡ⪠ < 60 %");
  _OutSaldo:=L_PRoll.OutSaldo(L_DatTim.Per(SYSDATE()));
  IF _OutSaldo < 0 THEN
   Corr:=CorrVal;
  ELSIF CorrVal > _OutSaldo THEN
   Corr:=CorrVal-_OutSaldo;
  ELSE
   Corr:=0;
  END;
  DEC(CorrVal, Corr);
 END {SetCorrVal};

END.
