(*
%Copyright   (c) Polak Computer System
%Author      26.01.2000 15:08:52 RSN
%Purpose     ᮡ   ⥦ 㬥⠬
%Type        library
%Specific    LOC
%Modified    29.05.2013 17:08:18 POLAK\GAV
%Environment
*)

 MODULE E_PDoc [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_DatTim, L_PDoc, CB_BVz2, FIO;

 PRIVATE CONST
  cb_BVzr = 2;

 PUBLIC PROCEDURE ClientBankOperation(_CB: NUMERIC[0]; Operation: STRING[]): STRING[];
  VAR
   p: PROC;
 BEGIN
  p:=STRTOFLD(ClientBankNick(_CB) + "." + Operation, PROC);
  RETURN p(_CB);
 END {ClientBankOperation};

 PUBLIC PROCEDURE ClientBank(D: DATE): NUMERIC[0];
 BEGIN
  IF    (FirmAcnt.FirmAcnt = 62) | (FirmAcnt.FirmAcnt = 63) THEN
   RETURN cb_BVzr;
  ELSIF (FirmAcnt.FirmAcnt = 01) | (FirmAcnt.FirmAcnt = 03) THEN
   IF D >= 03\09\2003 THEN
    RETURN cb_BVzr;
   ELSE
    RETURN 0;
   END;
  ELSE
   RETURN 0;
  END;
 END {ClientBank};

 PUBLIC PROCEDURE ClientBankNick(_CB: NUMERIC[0]): STRING[];
 BEGIN
  IF    _CB = cb_BVzr THEN
   RETURN CB_BVz2.Nick;
  ELSE
   RETURN L_PDoc.cb_NoCB_Nick;
  END;
 END {ClientBankNick};

 PRIVATE CONST
  _PathForCB      = "REP\CB_BVZR";
  _UploadFolder   = "SEND";
  _DownloadFolder = "RECEIVE";

 PUBLIC PROCEDURE ClientBankUploadPath(_CB: NUMERIC[0]): STRING[];
 BEGIN
  IF (_CB = cb_BVzr) THEN
(*
   ᥢ   ਬ
   RETURN "C:\$CLIENT\$ASTRA\mailbox\API\R";
   RETURN "C:\CLIENT44\$API\R";
   RETURN "C:\V_CLIENT\$ASTRA\mailbox\0030\R";
*)
   RETURN FIO.MakePath(_UploadFolder, , _PathForCB);
  ELSE
   RETURN "";
  END;
 END {ClientBankUploadPath};

 PUBLIC PROCEDURE FileNameForAdd_Doc(D: DATE; curCB: NUMERIC[0]; DefaultName: STRING[]): STRING[];
 BEGIN
  IF curCB = cb_BVzr THEN
   RETURN FIO.MakePath("Sks1791", "dbf", _PathForCB);
  ELSE
   RETURN "";
  END;
 END {FileNameForAdd_Doc};

 PUBLIC PROCEDURE CBPrintUploaded(D: DATE): SCAL[2];
 BEGIN
  RETURN 0;
 END {CBPrintUploaded};

 PUBLIC PROCEDURE ADP_BVZR_NeedAdd_Doc(D: DATE): SCAL[2];
 BEGIN
  RETURN 0;
 END {ADP_BVZR_NeedAdd_Doc};

 PUBLIC PROCEDURE VTYPEFieldForAdd_Doc(D: DATE): STRING[];
 BEGIN
  RETURN "043";
 END {VTYPEFieldForAdd_Doc};

 PUBLIC PROCEDURE ClientBankDownloadPath(_CB: NUMERIC[0]): STRING[];
 BEGIN
  IF _CB = cb_BVzr THEN
   RETURN FIO.MakePath(_DownloadFolder, , _PathForCB);
  ELSE
   RETURN "";
  END;
 END {ClientBankDownloadPath};

 PUBLIC PROCEDURE NeedCorrectPCalc(D: DATE): SCAL[2];
 BEGIN
  IF    L_DatTim.Per(D) =  01\02\2009 THEN (* 0069501 *)
   RETURN 0;
  ELSIF L_DatTim.Per(D) =  01\01\2009 THEN (* 0069203 *)
   RETURN 0;
  ELSIF L_DatTim.Per(D) =  01\05\2005 THEN (* 0043808 *)
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {NeedCorrectPCalc};

 PUBLIC PROCEDURE TurnForPDoc(_D: DATE; _Turn: L_PDoc.tTurn; _PDocKind: LIKE(PDoc.PDocKind)): L_PDoc.tTurn;
 BEGIN
  IF (_D >= 30\10\2007) & (_PDocKind = L_PDoc.pd_IPP) THEN
   RETURN 1*MAXOF(Staff.TSN);
  END;
  RETURN _Turn;
 END {TurnForPDoc};

 PUBLIC PROCEDURE CashBookPagesShift(CurDate: DATE; VAR StartP: DATE; VAR PagesShift: NUMERIC[0]);
 BEGIN
  StartP:=01\11\2002;
  PagesShift:=0;
 END {CashBookPagesShift};

 PUBLIC PROCEDURE UploadSinglePDocInSingleFile(_CB: NUMERIC[0]): SCAL[2];
 BEGIN
  IF (_CB = cb_BVzr) THEN
   RETURN 0;
  ELSE
   L_General.CallUs(0);
   RETURN 1;
  END;
 END {UploadSinglePDocInSingleFile};

END.
