(*
%Copyright   (c) Polak Computer System
%Author      22.09.1997 16:57:18 GINA
%Purpose     ᮡ   ௫
%Type        library,to paste
%Specific    SP
%Modified    17.04.2014 11:58:05 POLAK\Gina
%Environment
*)

 MODULE E_PRoll [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_DatTim, L_Staff, L_Man, P_Firm, P_Man, L_Tax, L_Packet, L_PRoll, P_MCList, L_Env;

 PUBLIC CONST
  mclBon_PayByHour  = 0;
  mclBon_MTDriver   = 1;
  mclBon_Guard      = 2;
  mclBon_Progressiv = 3;
  mclBon_BrigadeJob = 4;

 PUBLIC PROCEDURE ResidentApproachLevel(P: DATE; Default: NUMERIC[0]): NUMERIC[0];
 BEGIN
  IF P >= 01\01\2010 THEN
   RETURN Default;
  ELSE
   RETURN L_Tax.rap_None;
  END;
 END {ResidentApproachLevel};

 PUBLIC PROCEDURE DeadMonthForPaySheet(D: DATE): NUMERIC[0];
 BEGIN
  IF D >= 01\02\2004 THEN
   RETURN -3;
  ELSE
   RETURN -1;
  END;
 END {DeadMonthForPaySheet};

 PUBLIC PROCEDURE IsLeaveInPaySheet(D: DATE): SCAL[2];
 BEGIN
  IF D >= 01\02\2004 THEN
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {IsLeaveInPaySheet};

 PUBLIC PROCEDURE UsePersMPay(D: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {UsePersMPay};

 PUBLIC PROCEDURE HasTimeMismatch(D         : DATE;
                                  _PCalcTim,
                                  _MonTim   : NUMERIC[3];
                                  Default   : SCAL[2]): SCAL[2];
 BEGIN
  RETURN Default & ~((_MonTim = 0) & (_PCalcTim > 0));
 END {HasTimeMismatch};

 PUBLIC PROCEDURE Blank_wInformativeSheet(P: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {Blank_wInformativeSheet};

 PUBLIC PROCEDURE MCListBonusName(i: SCAL[20]): STRING[];
 BEGIN
  IF    i = mclBon_PayByHour  THEN RETURN "६騪";
  ELSIF i = mclBon_MTDriver   THEN RETURN ".஠.";
  ELSIF i = mclBon_Guard      THEN RETURN "ࠬ";
  ELSIF i = mclBon_Progressiv THEN RETURN "ணᨢ";
  ELSIF i = mclBon_BrigadeJob THEN RETURN "ਣ.";
  ELSE
   RETURN "";
  END;
 END {MCListBonusName};

 PUBLIC PROCEDURE A_CalcDedCond_01(): SCAL[2];
 BEGIN
  HISTCONF(Memo.gl_me(), Staff, StaffLog);
  WHILE OCCURE(StaffLog) DO
   IF SEARCH(SrMnthly, Sort, StaffLog.Sort, Memo.gl_mb()) & L_Staff.OrderInMonth(Memo.gl_mb()) THEN
    RETURN 1;
   END;
   PREV(StaffLog);
  END;
  RETURN 0;
 END {A_CalcDedCond_01};

 PUBLIC PROCEDURE GetTradeUnionMCode(D: DATE): NUMERIC[0];
 BEGIN
  RETURN 145;
 END {GetTradeUnionMCode};

 PUBLIC PROCEDURE SMAmountOnA4(P: DATE): NUMERIC[0];
 BEGIN
  RETURN 99;
 END {SMAmountOnA4};

 PUBLIC PROCEDURE ReflectEDOrder(D: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {ReflectEDOrder};

 PUBLIC PROCEDURE ManIns_ActingLeadName(D: DATE): STRING[];
 BEGIN
  RETURN P_Firm.FP_AcntName(P_Firm.OWN_FIRM, D);
 END {ManIns_ActingLeadName};

 PUBLIC PROCEDURE ManIns_ActingLeadPostName(D: DATE): STRING[];
 BEGIN
  RETURN P_Firm.FP_AcntPostName(P_Firm.OWN_FIRM, D);
 END {ManIns_ActingLeadPostName};

(* ⬮஦ ன,  16.06.2003 (0028924),  15.02.2011 (0083799); 15.02.2011 10:59:21 POLAK\Bor
 PUBLIC PROCEDURE ManIns_ExtNbrForADV(D: DATE): LIKE(Packet.ExtNbr);
 BEGIN
  RETURN FLDTOSTR(L_DatTim.YEAR(D) - 1979, "0")+"001";
 END {ManIns_ExtNbrForADV};
*)

 PUBLIC PROCEDURE ManIns_NeedDwMA(D: DATE): SCAL[3];
 BEGIN
  RETURN L_Packet.adr_OnlyReg;
(*
  RETURN L_Packet.adr_None;
  RETURN L_Packet.adr_UseDwell;
*)
 END {ManIns_NeedDwMA};

 PUBLIC PROCEDURE Ank_ActingLeadName(D: DATE): STRING[];
 BEGIN
  RETURN P_Firm.FP_StaffDepChiefName(P_Firm.OWN_FIRM, D);
 END {Ank_ActingLeadName};

 PUBLIC PROCEDURE Ank_ActingLeadPostName(D: DATE): STRING[];
 BEGIN
  RETURN P_Firm.FP_StaffDepChiefPostName(P_Firm.OWN_FIRM, D);
 END {Ank_ActingLeadPostName};

 PUBLIC PROCEDURE MCodeToKeepInXCalc(P: DATE): SCAL[2];
 BEGIN
  IF    MCList.MCode = 154 THEN RETURN P >= 01\05\2005;  (**)
  ELSIF MCList.MCode = 152 THEN RETURN P >= 01\05\2006;  (**)
  ELSIF MCList.AcCut = 354 THEN RETURN P >= 01\01\2011;  (* 䮭*)
  ELSIF MCList.AcCut = 410 THEN RETURN P >= 01\01\2012;  (**)
  ELSIF MCList.AcCut = 422 THEN RETURN P >= 01\09\2012;  (*客 ⥫*)
  ELSE                          RETURN 0;
  END;
 END {MCodeToKeepInXCalc};

 PUBLIC PROCEDURE MethodOfPDocToMoney(D: DATE): SCAL[16];
 BEGIN
  IF    D >= 01\01\2012 THEN
   RETURN L_PRoll.pdtom_PaidAndDeposited;
  ELSE
   RETURN L_PRoll.pdtom_PaidOnly;
  END;
 END {MethodOfPDocToMoney};

 PUBLIC PROCEDURE MC_ToDeponent(): LIKE(Money.MCode);
 BEGIN
  RETURN 248;
 END {MC_ToDeponent};

 PUBLIC PROCEDURE MCH_NeedLog(D: DATE): SCAL[2];
 BEGIN
  RETURN (Officer.Union = 01) | (Officer.Union = 02) | (Officer.Union = 03) |  (**)
         (Officer.Post=115(*.*)) | (Officer.Post=106(*ᯮ*)) | (Officer.Post=107(**)) |
         (Officer.Post=187(**)) | (Officer.Post=159(*.*)) |
         (Officer.Post=275(*  *));
 END {MCH_NeedLog};

 PUBLIC PROCEDURE MCH_MoneyCond(P: DATE): SCAL[2];
 BEGIN
  RETURN P_MCList.inBonus(MCList.MCode, P, mclBon_Progressiv);
 END {MCH_MoneyCond};

 PUBLIC PROCEDURE IsSummationSheet(D: DATE): SCAL[2];
  VAR
   Resalt: SCAL[2];
 BEGIN
  IF    D >= 01\04\2014 THEN
   Resalt:=StaffLog.Regime = "0001";
   IF ~Resalt THEN
    SAVE(RegMain);
    CONFORM(StaffLog, RegMain);
    Resalt:=RegMain.SlipGr = L_PRoll.rgt_SlipGr;
    RESTORE(RegMain);
   END;
   RETURN Resalt;
  ELSIF D >= 01\09\2006 THEN
   RETURN L_Env.IsRouteDriver() | L_Env.IsGuard() | (Officer.Union = 06(*.ன*));
  ELSE
   RETURN 0;
  END;
 END {IsSummationSheet};

END.
