(*
%Copyright   (c) Polak Computer System
%Author      09.09.2002 10:34:40 LDA
%Purpose     ஫ ࠡ  묨 ᢮⢠
%Type        control
%Specific    LOC
%Modified    23.07.2014 11:58:52 POLAK\LDA
%Environment
*)

 MODULE E_Prop [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  P_SelfControl             = 9501;
  P_IncPlan100              = 9502;
  P_NormHourPrice           = 9503;
  P_CarHarm                 = 9510;
  P_BonusForStage           = 9511;
  P_DrBrigadeBonus          = 9512;
  P_ChargesCoef             = 9513;
  P_CivilLiabilityInsurance = 9514;
  P_CarIncPlnCorr           = 9515;
  P_FuelEconBonus           = 9516;
  P_MaxEconomy              = 9517; (* . ६   ⮯ *)
  P_RegularityBonus         = 9518; (* ६  ॣ୮ (/) *)
  P_MakePlanBonus           = 9519; (* % ६  믮  *)
  P_MakePlanPrc             = 9520; (* % 믮   室 *)
  P_OrderBonus              = 9521; (* % ६   *)
  P_OnDutyBonus             = 9522; (* % ६  ୮ ⮡ *)
  P_woGuardBonus            = 9523; (* ६  ࠡ   *)
  P_MakePlan_Guard          = 9524; (*  믮   *)
  P_SchoolDriverBonus       = 9525; (* ६ ⥫ 誮 *)
  P_RouteforTck10           = 9526; (* 㯯  Tck10 *)

  P_Charges_1 = 9601; (* 9601 01.10.2004 室 - 388  (;६)*)
  P_Charges_2 = 9602; (* 9602 01.10.2004 室 ਣத *)
  P_Charges_3 = 9603; (* 9603 01.02.2004 室 -  ⠪ (;६)*)
  P_Charges_4 = 9604; (* 9604 01.10.2004 室 - த 樠*)
  P_Charges_5 = 9605; (* 9605 01.10.2004 室- த 樠*)
  P_Charges_6 = 9606; (* 9606 01.10.2004 室 த *)

 PRIVATE CONST
  pool_RouteforTck10 = 0000960;

 IMPORT L_Prop, L_General, L_DatTim, L_PRoll, L_Pool, L_Rpr, L_PDoc, L_CUC, E_Rpr;

 PUBLIC PROCEDURE PropertyModificationAllowed(_Property: LIKE(Property.Property)): L_Prop.tModifAllowedCondition;
 BEGIN
  IF (_Property = P_OrderBonus) THEN
   RETURN L_Prop.mac_Old;
  ELSE
   RETURN L_Prop.mac_Full;
  END;
 END {PropertyModificationAllowed};

 PRIVATE PROCEDURE CheckAnyNumericValue(_Date: DATE; _Value: STRING[]);
 BEGIN
  L_Prop.CheckNumericValue(_Value, "");
 END {CheckAnyNumericValue};

 PUBLIC PROCEDURE Check(_Property: LIKE(Property.Property));
 BEGIN
  IF    _Property = P_NormHourPrice THEN
   L_Prop.CheckNumericValue(RprPro.Value, "");
  ELSIF _Property = P_CarHarm THEN
   L_Prop.CheckNumericValue(CarPro.Value, "");
  ELSIF _Property = P_BonusForStage THEN
   L_Prop.CheckNumericValue(StaffPro.Value, "");
  ELSIF _Property = P_DrBrigadeBonus THEN
   L_Prop.CheckNumericValue(SortPro.Value, "");
  ELSIF _Property = P_ChargesCoef THEN
   L_Prop.CheckRow(MarkPro.Date, MarkPro.Value, PROCREF(CheckAnyNumericValue));
  ELSIF _Property = P_IncPlan100 THEN
   L_General.Assert(StaffPro.Date=L_DatTim.Per(StaffPro.Date), "⢮  ⢮  ࢮ ᫠ ");
   CONFORM(StaffPro, Staff);
   L_PRoll.ShtDone_AP(L_DatTim.Per(StaffPro.Date), 0);
  ELSIF _Property = P_CarIncPlnCorr THEN
   L_Prop.CheckNumericValue(CarPro.Value, "");
  ELSIF _Property = P_FuelEconBonus THEN
   L_Prop.CheckRow(OwnDPro.Date, OwnDPro.Value, PROCREF(CheckAnyNumericValue));
  ELSIF _Property = P_MaxEconomy         THEN
   L_Prop.CheckNumericValue(OwnDPro.Value, "");
  ELSIF _Property = P_RegularityBonus    THEN
   L_Prop.CheckRow(OwnDPro.Date, OwnDPro.Value, PROCREF(CheckAnyNumericValue));
  ELSIF _Property = P_MakePlanBonus      THEN
   L_Prop.CheckRow(OwnDPro.Date, OwnDPro.Value, PROCREF(CheckAnyNumericValue));
  ELSIF _Property = P_MakePlanPrc        THEN
   L_Prop.CheckNumericValue(OwnDPro.Value, "");
  ELSIF _Property = P_OrderBonus         THEN
   L_Prop.CheckNumericValue(OwnDPro.Value, "");
  ELSIF _Property = P_OnDutyBonus        THEN
   L_Prop.CheckNumericValue(OwnDPro.Value, "");
  ELSIF _Property = P_woGuardBonus       THEN
   L_Prop.CheckNumericValue(OwnDPro.Value, "");
  ELSIF _Property = P_MakePlan_Guard     THEN
   L_Prop.CheckRow(OwnDPro.Date, OwnDPro.Value, PROCREF(CheckAnyNumericValue));
  ELSIF _Property = P_SchoolDriverBonus  THEN
   L_Prop.CheckNumericValue(OwnDPro.Value, "");
  ELSIF (_Property = P_Charges_1) |
        (_Property = P_Charges_2) |
        (_Property = P_Charges_3) |
        (_Property = P_Charges_4) |
        (_Property = P_Charges_5) |
        (_Property = P_Charges_6) THEN
   L_Prop.CheckRow(OwnDPro.Date, OwnDPro.Value, PROCREF(CheckAnyNumericValue));
  END;
 END {Check};

 PRIVATE PROCEDURE GetNormHourPricePool(): STRING[];
  VAR
   Result: STRING[];
 BEGIN
  IF OCCURE(RprPro) & ~OCCURE(RprS) THEN
   CONFORM(RprPro, RprS);
  END;
  IF    RprS.OrdDate >= 01\01\2014 THEN
   SETEMPTY(Result);
   IF    RprS.OrdDate >= 01\03\2014 THEN
    IF    L_Rpr.IsRprS_w_OutCar() | (RprS.Location = L_Rpr.rprl_MaintenanceZone) THEN
     Result:="700";
    ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
     Result:="750";
    END;
   ELSIF RprS.OrdDate >= 01\01\2014 THEN
    IF    L_Rpr.IsRprS_w_OutCar() | (RprS.Location = L_Rpr.rprl_MaintenanceZone) THEN
     Result:="630";
    ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
     Result:="525";
    END;
   END;
   L_General.CallUs(~!Result);
   RETURN Result;
  ELSE
   IF    RprS.Location = L_Rpr.rprl_MaintenanceZone THEN
    IF    RprS.OrdDate >= 01\01\2014 THEN
     RETURN "630";
    ELSIF RprS.OrdDate >= 30\08\2011 THEN
     RETURN "900";
    ELSIF RprS.OrdDate >= 01\08\2010 THEN
     RETURN "700|900";
    ELSIF RprS.OrdDate >= 01\03\2010 THEN
     RETURN "900";
    ELSE
     RETURN "980";
    END;
   ELSIF RprS.Location = L_Rpr.rprl_ServiceCenter THEN
    IF    RprS.OrdDate >= 25\11\2011 THEN
     RETURN "760|900|1100";
    ELSIF RprS.OrdDate >= 30\08\2011 THEN
     RETURN "760|1100";
    ELSE
     RETURN "700|1050";
    END;
   ELSIF E_Rpr.IsOutCarInRepairZone(RprS.Location) THEN
    IF RprS.OrdDate >= 01\01\2014 THEN
     RETURN "630";
    ELSE
     RETURN "900";
    END;
   ELSIF L_Rpr.IsWorkshopLocation(RprS.Location) & L_Rpr.IsRprS_w_OutCBlc() THEN
    IF RprS.OrdDate >= 01\01\2014 THEN
     RETURN "525";
    ELSE
     RETURN "750|927|1100";
    END;
   ELSE
    L_General.Error("  "+RprS.RprS+"  㤠 । ⮨ ମ.||" +
                    "᫨  㢥७  ࠢ쭮 ᢮ ⢨,   ");
   END;
  END;
 END {GetNormHourPricePool};

 PUBLIC PROCEDURE GetPool(_Property: LIKE(Property.Property)): STRING[];
 BEGIN
  IF    _Property = P_SelfControl THEN
   RETURN "|";
  ELSIF _Property = P_IncPlan100 THEN
   RETURN "|";
  ELSIF _Property = P_NormHourPrice THEN
   RETURN GetNormHourPricePool();
  ELSIF _Property = P_CivilLiabilityInsurance THEN
   RETURN "|";
  ELSIF _Property = P_RouteforTck10 THEN
   RETURN L_Pool.Get(pool_RouteforTck10);
  ELSE
   RETURN "";
  END;
 END {GetPool};

 PUBLIC PROCEDURE SetProperty();
 BEGIN
  L_Prop.extSetProp(P_SelfControl,             "஫",                     L_Prop.StaffProObj, L_Prop.pf_Special, [L_Prop.tag_DescriptionObj]);
  L_Prop.extSetProp(P_IncPlan100,              "믮   100%",         L_Prop.StaffProObj, L_Prop.pf_Special, [L_Prop.tag_Finance]);
  L_Prop.extSetProp(P_NormHourPrice,           "⮨ ମ-",             L_Prop.RprProObj,   L_Prop.pf_StrongPool, [L_Prop.tag_Finance]);
  L_Prop.extSetProp(P_CarHarm,                 "  ।",             L_Prop.CarProObj,   L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_BonusForStage,           "६  ⠦  ᪮ன ",  L_Prop.StaffProObj, L_Prop.pf_Special, [L_Prop.tag_Finance]);
  L_Prop.extSetProp(P_DrBrigadeBonus,          "  䮭 ਣ ()",  L_Prop.SortProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance]);
  L_Prop.extSetProp(P_ChargesCoef,             "樥 室(;६)", L_Prop.MarkProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance]);
  L_Prop.extSetProp(P_CivilLiabilityInsurance, " 客  ⥫",    L_Prop.ManProObj,   L_Prop.pf_Special, [L_Prop.tag_Documents, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_CarIncPlnCorr,           "४   窥",       L_Prop.CarProObj,   L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_FuelEconBonus,           "業  ;०",      L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_MaxEconomy,              ". ६   ⮯", L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_RegularityBonus,         "६  ॣ୮ (/)", L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_MakePlanBonus,           "% ६  믮 ",     L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_MakePlanPrc,             "% 믮   室",    L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_OrderBonus,              "% ६  ",               L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_OnDutyBonus,             "% ६  ୮ ⮡",    L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_woGuardBonus,            "६  ࠡ  ",  L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_MakePlan_Guard,          " 믮  ",   L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_SchoolDriverBonus,       "६ ⥫ 誮",       L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_RouteforTck10,           "㯯 ⮢  Tck10",       L_Prop.RouteProObj, L_Prop.pf_StrongPool, [L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_Charges_1,               "室 - 388 ",            L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_Charges_2,               "室 - ਣத ",    L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_Charges_3,               "室 -  ⠪",       L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_Charges_4,               "室 - த 樠",       L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_Charges_5,               "室 - த 樠",    L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
  L_Prop.extSetProp(P_Charges_6,               "室 - த ",       L_Prop.OwnDProObj,  L_Prop.pf_Special, [L_Prop.tag_Finance, L_Prop.tag_Traffic]);
 END {SetProperty};

 PUBLIC PROCEDURE StaffPro_OnBeforeDelete();
 BEGIN
  IF    (StaffPro.Property = P_IncPlan100) THEN
   CONFORM(StaffPro, Staff);
   L_PRoll.ShtDone_AP(L_DatTim.Per(StaffPro.Date), 0);
  END;
 END {StaffPro_OnBeforeDelete};

 PUBLIC PROCEDURE Date_OnSuccessfulChange(_Property: LIKE(Property.Property));
 BEGIN
  IF _Property = P_IncPlan100 THEN
   RTI.Get().CurZone.Fields("DocExpD").Value:=L_DatTim.IncMonth(StaffPro.Date, 1);
  END;
 END {Date_OnSuccessfulChange};

 PUBLIC PROCEDURE Value_OnSuccessfulChange(_Property: LIKE(Property.Property));
 BEGIN
  IF _Property = P_RouteforTck10 THEN
   L_Pool.Put(pool_RouteforTck10, RoutePro.Value);
  END;
 END {Value_OnSuccessfulChange};

 PUBLIC PROCEDURE OnBeforeInsert();
  VAR
   IsUnique: SCAL[2];
 BEGIN
  IF ^(GE_CURFILE()).Property = P_NormHourPrice THEN
   L_General.Assert(L_Rpr.AcceptableCalcRprJSum(), "    ⮨ ६⭮ ࠡ  ঠ.|" +
                                                   "ᯮ짮 ᢮⢠ " + RprPro.Property + " 饭.");
   SAVE(RprPro);
   SELECT(RprPro, RprS, , RprPro.RprS, RprPro.RprT, RprPro.RprJ, RprPro.Property);
   IsUnique:=~NEXT(RprPro);
   RESTORE(RprPro);
   L_General.Assert(IsUnique, "  ᢮⢮ " + RprPro.Property);
   L_General.Assert(!RprPro.RprT, "C⢮ " + RprPro.Property + "  ⢮ ⮫쪮  ");
  END;
 END {OnBeforeInsert};

END.
