(*
%Copyright   (c) Polak IT
%Author      28.08.2002 16:24:51 SAN
%Purpose     ᮡ ६
%Type        operation
%Specific    LOC
%Modified    27.05.2014 09:21:54 POLAK\LDA
%Environment
*)

 MODULE E_Rpr [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 PUBLIC CONST
  cb_BackAxle    = 01;
  cb_Engine      = 02;
  cb_Transm      = 03;
  cb_Accumulator = 04;
  cb_Tyre        = 16;
  cb_FrontAxle   = 20;

  grp_Bus   = 0;
  grp_GAZel = 1;
  grp_Other = 2;

 IMPORT L_General, L_Rpr, L_XDoc, L_Car, E_Way, L_Way, L_DatTim, L_Str, P_Rpr, E_Prop, P_Firm, L_ctc,
        E_Stock, L_PDoc, L_MDoc, P_Rpr, L_MSO, L_Env, L_StdFrm;

 PUBLIC PROCEDURE GetOpenRprSGroup(): LIKE(RprSMirr.Group);
  VAR
   _MarkG: LIKE(MarkG.MarkG);
 BEGIN
  _MarkG:=L_Way.GetMarkG(CarLog.Mark, E_Way.mgt_BusOrGAZel);
  IF    _MarkG = E_Way.markg_Bus THEN
   RETURN grp_Bus;
  ELSIF _MarkG = E_Way.markg_GAZel THEN
   RETURN grp_GAZel;
  ELSE
   RETURN grp_Other;
  END;
 END {GetOpenRprSGroup};

 PUBLIC PROCEDURE GetDefaultTechAidSort(_Kind: LIKE(RprPlace.Kind)): LIKE(Sort.Sort);
 BEGIN
  IF (_Kind = L_Rpr.rpk_Retriever) |
     (_Kind = L_Rpr.rpk_TechAid) THEN
   RETURN 015;
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {GetDefaultTechAidSort};

 PUBLIC PROCEDURE GetRprSLocation_Pool(Short: SCAL[2]): STRING[];
 BEGIN
  IF Short THEN
   RETURN " ||||||";
  ELSE
   RETURN " |堭-|  |审㦨|ࢨ| |୮-ॣ ";
  END;
 END {GetRprSLocation_Pool};

 PUBLIC PROCEDURE AllowedRprSLocation(rl: L_Rpr.tRprSLocation): SCAL[2];
 BEGIN
  IF SYSDATE() >= 19\12\2013 THEN
   RETURN (rl = L_Rpr.rprl_Gate)            |
          (rl = L_Rpr.rprl_RepairZone)      |
          (rl = L_Rpr.rprl_MaintenanceZone) |
          (rl = L_Rpr.rprl_Workshop);
  ELSE
   RETURN (rl = L_Rpr.rprl_Gate)            |
          (rl = L_Rpr.rprl_RepairZone)      |
          (rl = L_Rpr.rprl_MaintenanceZone) |
          (rl = L_Rpr.rprl_ServiceCenter)   |
          (rl = L_Rpr.rprl_RZ_Part1)        |
          (rl = L_Rpr.rprl_Workshop);
  END;
 END {AllowedRprSLocation};

 PUBLIC PROCEDURE TransferCondition(    dstLocation: LIKE(RprS.Location);
                                    VAR Result     : SCAL[2];
                                    VAR Text       : STRING[]);
 BEGIN
  IF dstLocation = L_Rpr.rprl_Gate THEN
   CONFORM(RprS, RprDA);
   WHILE OCCURE(RprDA) & (RprDA.Fixed # L_Rpr.daf_ThereIs) DO
    NEXT(RprDA);
   END; (* WHILE OCCURE(RprDA)... *)
   IF OCCURE(RprDA) THEN
    L_StdFrm.CrucialChoice("।   ஢ '"+L_Rpr.GetRprSLocation_AsStr(dstLocation)+"'|" +
                           " ࠭묨 ࠢﬨ",
                           L_Rpr.GetRprSGroupName(dstLocation));
   END;
  END;
 END {TransferCondition};

 PUBLIC PROCEDURE IsOutCarInRepairZone(trgLocation: LIKE(RprS.Location)): SCAL[2];
 BEGIN
  RETURN L_Rpr.IsRprS_w_OutCar() & L_Rpr.IsRepairZoneLocation(trgLocation);
 END {IsOutCarInRepairZone};

 PUBLIC PROCEDURE ConditionalClose();
 BEGIN
  IF L_Rpr.IsServiceCenterLocation(RprS.Location) & L_Rpr.IsRprS_w_OutCar() |
     IsOutCarInRepairZone(RprS.Location) THEN
   L_General.Assert(~!RprS.SMBef, "室   ᯨ  砫 ६");
   L_General.Assert(RprS.SMBef # 0, "४⭮ 祭  ᯨ 0");
  END;
 END {ConditionalClose};

 PUBLIC PROCEDURE MaySetMirrorStatus(ms     : L_Rpr.tMirrorStatus;
                                     default: SCAL[2]): SCAL[2];
 BEGIN
  IF    L_Rpr.IsMainRpr() | L_General.IsMemberOf('RPRS_INEXPL') THEN
   RETURN default;
  ELSIF L_Rpr.CanModify(L_Rpr.rprl_Gate) | L_Rpr.CanModify(L_Rpr.rprl_RepairZone) THEN
   IF    RprS.Status = L_Rpr.ms_NeedRate THEN
    RETURN ms = L_Rpr.ms_Done;
   ELSIF RprS.Status # L_Rpr.ms_Ready THEN
    RETURN ms = L_Rpr.ms_Ready;
   ELSE
    RETURN 0;
   END;
  ELSIF L_Rpr.CanModify(L_Rpr.rprl_MaintenanceZone) | L_Rpr.CanModify(L_Rpr.rprl_ServiceCenter) THEN
   RETURN default;
  END;
  RETURN 0;
 END {MaySetMirrorStatus};

 PUBLIC PROCEDURE RprSAcceptableAction(trgAction  : LIKE(XDocJrn.Action);
                                       dstLocation: L_Rpr.tRprSLocation;
                                       default    : SCAL[2]): SCAL[2];
 BEGIN
  IF    trgAction = L_XDoc.action_Insert THEN
   IF L_Rpr.CanModify(dstLocation) THEN
    RETURN 1;
   END;
  ELSIF trgAction = L_XDoc.action_rprTransfer THEN
   IF    L_Rpr.IsRprS_w_Car() | L_Rpr.IsRprS_w_OutCar() THEN
    RETURN (RprS.Location # dstLocation)            &
           L_Rpr.E_AllowedRprSLocation(dstLocation) &
           (L_Rpr.IsRepairZoneLocation(dstLocation) | L_Rpr.IsServiceCenterLocation(dstLocation));
   ELSE
    RETURN 0;
   END;
  END;
  RETURN default;
 END {RprSAcceptableAction};

 PUBLIC PROCEDURE LocationForRegistrationFromLine(): L_Rpr.tRprSLocation;
 BEGIN
  RETURN L_Rpr.rprl_Gate;
 END {LocationForRegistrationFromLine};

 PUBLIC PROCEDURE AcceptableLocation_ForReturnRprS(D: DATE): SCAL[2];
 BEGIN
(*  *)
  RETURN 1;
 END {AcceptableLocation_ForReturnRprS};

 PUBLIC PROCEDURE AcceptableLocation_ForDoneRprS(D: DATE): SCAL[2];
 BEGIN
(*  *)
  RETURN 1;
 END {AcceptableLocation_ForDoneRprS};

(* ⠢ ६ ய⨩  ࠡ⪥  *)

 PRIVATE PROCEDURE HasSpecificRprJob(_RprJob: LIKE(RprJ.RprJob)): SCAL[2];
 BEGIN
  SELECT(RprJ, RprS, , RprS.RprS);
  WHILE OCCURE(RprJ) DO
   IF RprJ.RprJob = _RprJob THEN
    RETURN 1;
   END;
   NEXT(RprJ);
  END; (* WHILE OCCURE(RprJ) ... *)
  RETURN 0;
 END {HasSpecificRprJob};

 PRIVATE PROCEDURE HasSpecificRprTTackKind(_TaskKind: LIKE(RprT.TaskKind)): SCAL[2];
 BEGIN
  SELECT(RprT, RprS, , RprS.RprS);
  WHILE OCCURE(RprT) DO
   IF RprT.TaskKind = _TaskKind THEN
    RETURN 1;
   END;
   NEXT(RprT);
  END; (* WHILE OCCURE(RprT) ... *)
  RETURN 0;
 END {HasSpecificRprTTackKind};

 PUBLIC PROCEDURE GatherRequiredRepEvent(ByProceedRprS: SCAL[2]);
  VAR
   CanHasMinorRepairs: SCAL[2];
 BEGIN
  IF ~ByProceedRprS | (RprS.OrdDate >= 21\09\2009) THEN
   CanHasMinorRepairs:=0;
  ELSE
   CanHasMinorRepairs:=1;
  END;

  IF    RprS.OrdDate >= 01\01\2010 THEN
   SELECT(RprJ, RprS, , RprS.RprS);
   WHILE OCCURE(RprJ) DO
    IF    RprJ.RprJob = 00447 THEN
     L_Rpr.Add_RepEv(E_Way.re_TO1,             L_Rpr.are_lev_RprJ);
    ELSIF (RprJ.RprJob = 00042) | (RprJ.RprJob = 01148) |
          (RprJ.RprJob = 01149) | (RprJ.RprJob = 01150) |
          (RprJ.RprJob = 01989) | (RprJ.RprJob = 01990) |
          (RprJ.RprJob = 02022) | (RprJ.RprJob = 02023) THEN
     L_Rpr.Add_RepEv(E_Way.re_TO2,             L_Rpr.are_lev_RprJ);
     IF    RprJ.RprJob = 01148 THEN
      (*RepEv.RepEvDtl:= -c *)
     ELSIF RprJ.RprJob = 01149 THEN
      (*RepEv.RepEvDtl:= -A *)
     ELSIF RprJ.RprJob = 01150 THEN
      (*RepEv.RepEvDtl:= -B *)
     ELSIF RprJ.RprJob = 01989 THEN
      (*RepEv.RepEvDtl:= -Bx *)
     ELSIF RprJ.RprJob = 01990 THEN
      (*RepEv.RepEvDtl:= -Cx *)
     END;
    ELSIF RprJ.RprJob = 00249 THEN
     L_Rpr.Add_RepEv(E_Way.re_OilReplace,      L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 00438 THEN
     L_Rpr.Add_RepEv(E_Way.re_HMT_OilReplace,  L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 00553 THEN
     L_Rpr.Add_RepEv(E_Way.re_Sinchronisation, L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 00554 THEN
     L_Rpr.Add_RepEv(E_Way.re_VTMStrapReplace, L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 00951 THEN
     L_Rpr.Add_RepEv(E_Way.re_SeasonService,   L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 01168 THEN
     L_Rpr.Add_RepEv(E_Way.re_Capsulation,     L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 01172 THEN
     L_Rpr.Add_RepEv(E_Way.re_Diagnostic1,     L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 02000 THEN
     L_Rpr.Add_RepEv(E_Way.re_Diagnostic3,     L_Rpr.are_lev_RprJ);
    ELSIF (RprJ.RprJob = 01227) | (RprJ.RprJob = 00247) THEN
     L_Rpr.Add_RepEv(E_Way.re_Body,            L_Rpr.are_lev_RprJ);
    ELSIF (RprJ.RprJob = 01287) | (RprJ.RprJob = 01288) | (RprJ.RprJob = 00598) | (RprJ.RprJob = 00785) |
          (RprJ.RprJob = 01324) | (RprJ.RprJob = 00783) THEN
     L_Rpr.Add_RepEv(E_Way.re_rprEngine,       L_Rpr.are_lev_RprJ);
    ELSIF (RprJ.RprJob = 01290) | (RprJ.RprJob = 01203) | (RprJ.RprJob = 01299) | (RprJ.RprJob = 00005) THEN
     L_Rpr.Add_RepEv(E_Way.re_rprTransm,       L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 00106 THEN
     L_Rpr.Add_RepEv(E_Way.re_rprBackAxle,     L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 00108 THEN
     L_Rpr.Add_RepEv(E_Way.re_rprFrontAxle,    L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 01311 THEN
     L_Rpr.Add_RepEv(E_Way.re_rprAccumulator,  L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 02032 THEN
     L_Rpr.Add_RepEv(E_Way.re_Diagnostic4,     L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 02053 THEN
     L_Rpr.Add_RepEv(E_Way.re_TO_R_X,          L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 01278 THEN
     L_Rpr.Add_RepEv(E_Way.re_TO_S,            L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 02077 THEN
     L_Rpr.Add_RepEv(E_Way.re_TO_X,            L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 02079 THEN
     L_Rpr.Add_RepEv(E_Way.re_TO_M,            L_Rpr.are_lev_RprJ);
    END;
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
  ELSIF RprS.OrdDate >= 01\12\2004 THEN
   SELECT(RprJ, RprS, , RprS.RprS);
   WHILE OCCURE(RprJ) DO
    IF    (RprJ.RprJob = 00447) | (RprJ.RprJob = 01149) THEN
     L_Rpr.Add_RepEv(E_Way.re_TO1,             L_Rpr.are_lev_RprJ);
    ELSIF (RprJ.RprJob = 00042) | (RprJ.RprJob = 01148) | (RprJ.RprJob = 01150) THEN
     L_Rpr.Add_RepEv(E_Way.re_TO2,             L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 00249 THEN
     L_Rpr.Add_RepEv(E_Way.re_OilReplace,      L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 00438 THEN
     L_Rpr.Add_RepEv(E_Way.re_HMT_OilReplace,  L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 00553 THEN
     L_Rpr.Add_RepEv(E_Way.re_Sinchronisation, L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 00554 THEN
     L_Rpr.Add_RepEv(E_Way.re_VTMStrapReplace, L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 00951 THEN
     L_Rpr.Add_RepEv(E_Way.re_SeasonService,   L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 01168 THEN
     L_Rpr.Add_RepEv(E_Way.re_Capsulation,     L_Rpr.are_lev_RprJ);
    ELSIF RprJ.RprJob = 01172 THEN
     L_Rpr.Add_RepEv(E_Way.re_Diagnostic1,     L_Rpr.are_lev_RprJ);
    END;
    NEXT(RprJ);
   END; (* WHILE OCCURE(RprJ) ... *)
  ELSE
   IF    HasSpecificRprJob(00249) THEN
    L_Rpr.Add_RepEv(E_Way.re_OilReplace,       L_Rpr.are_lev_RprJ);
   ELSIF HasSpecificRprJob(00438) THEN
    L_Rpr.Add_RepEv(E_Way.re_HMT_OilReplace,   L_Rpr.are_lev_RprJ);
   END;
   IF    HasSpecificRprTTackKind(L_Rpr.tk_Servicing1) THEN
    L_Rpr.Add_RepEv(E_Way.re_TO1,              L_Rpr.are_lev_RprT);
    CanHasMinorRepairs:=0;
   ELSIF HasSpecificRprTTackKind(L_Rpr.tk_Overhaul) THEN
    L_Rpr.Add_RepEv(E_Way.re_Overhaul,         L_Rpr.are_lev_RprT);
    CanHasMinorRepairs:=0;
   ELSIF HasSpecificRprTTackKind(L_Rpr.tk_Servicing2) THEN
    L_Rpr.Add_RepEv(E_Way.re_TO2,              L_Rpr.are_lev_RprT);
   END;
  END; (* IF RprS.OrdDate >= ...*)

  IF CanHasMinorRepairs THEN
   SELECT(RprDA, RprS, , RprS.RprS);
   WHILE OCCURE(RprDA) DO
    IF    RprDA.CarBlock = cb_Engine THEN
     L_Rpr.Add_RepEv(E_Way.re_rprEngine,      L_Rpr.are_lev_RprDA);
    ELSIF RprDA.CarBlock = cb_Transm THEN
     L_Rpr.Add_RepEv(E_Way.re_rprTransm,      L_Rpr.are_lev_RprDA);
    ELSIF RprDA.CarBlock = cb_FrontAxle THEN
     L_Rpr.Add_RepEv(E_Way.re_rprFrontAxle,   L_Rpr.are_lev_RprDA);
    ELSIF RprDA.CarBlock = cb_BackAxle THEN
     L_Rpr.Add_RepEv(E_Way.re_rprBackAxle,    L_Rpr.are_lev_RprDA);
    ELSIF (RprDA.CarBlock = cb_Accumulator) & (RprDA.RprDfApr = 0032) THEN
     L_Rpr.Add_RepEv(E_Way.re_rprAccumulator, L_Rpr.are_lev_RprDA);
    ELSIF (RprDA.CarBlock = cb_Tyre) & (RprDA.RprDfApr = 0083) THEN
     L_Rpr.Add_RepEv(E_Way.re_rprTyre,        L_Rpr.are_lev_RprDA);
    END;
    NEXT(RprDA);
   END; (* WHILE OCCURE(RprDA) ... *)
  END; (* IF CanHasMinorRepairs...*)

  IF ~ByProceedRprS THEN
   L_Rpr.Add_RepEv(E_Way.re_Repair,           L_Rpr.are_lev_RprDA);
  END;
 END {GatherRequiredRepEvent};

 PUBLIC PROCEDURE RprSShiftParams(VAR BegTime: TIME;
                                  VAR Length : NUMERIC[3]);
 BEGIN
  BegTime:=08:00;
  Length :=12;
 END {RprSShiftParams};

 PUBLIC PROCEDURE NeedInformAboutRepetition(_Location: L_Rpr.tRprSLocation): SCAL[2];
 BEGIN
  RETURN (_Location = L_Rpr.rprl_RepairZone) | (_Location = L_Rpr.rprl_RZ_Part1);
 END {NeedInformAboutRepetition};

 PUBLIC PROCEDURE MayInsertPutOffDfApr(Action: SCAL[100]): SCAL[2];
 BEGIN
  RETURN RprS.Location = L_Rpr.rprl_Gate;
 END {MayInsertPutOffDfApr};

 PRIVATE PROCEDURE HasSpecialRprDfApr(): SCAL[2];
 BEGIN
  IF RprS.OrdDate >= 17\03\2005 THEN
   SELECT(RprDA, RprS, , RprS.RprS);
   WHILE OCCURE(RprDA) DO
    IF (RprDA.CarBlock = 02) |    (*⥫*)
       (RprDA.CarBlock = 04) |    (* ம㤮 *)
       (RprDA.CarBlock = 05) |    (* ମ *)
       (RprDA.CarBlock = 08) |    (**)
       (RprDA.CarBlock = 11) |    (*㧮*)
       (RprDA.CarBlock = 12) |    (*࠭ᬨ*)
       (RprDA.CarBlock = 14) |    (*㫥*)
       (RprDA.CarBlock = 16) |    (* 室 *)
       (RprDA.CarBlock = 17) |    (*᪠*)
       (RprDA.CarBlock = 23) THEN (*⮬設*)
     RETURN 1;
    END;
    NEXT(RprDA);
   END; (* WHILE OCCURE(RprDA) ... *)
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {HasSpecialRprDfApr};

 PUBLIC PROCEDURE GetRepeatedRprSDescr(D: DATE): STRING[];
  VAR
   Description: STRING[];
   curRprS    : LIKE(RprS.RprS);
   curOrdDate : DATE;
   curCUCopy  : LIKE(CUCopy.CUCopy);
 BEGIN
  SETEMPTY(Description);
  curRprS   :=RprS.RprS;
  curOrdDate:=RprS.OrdDate;
  curCUCopy :=RprS.CUCopy;
  SAVE(RprS);
  SELECT(RprS, CUCopy, , curCUCopy);
  SRCINSEL(RprS, GE, , curOrdDate);
  WHILE OCCURE(RprS) & (RprS.OrdDate >= (curOrdDate - 5)) DO
   PROMPT(" " + RprS.RprS);
   IF (RprS.Status # L_Rpr.ms_Cancel) & (RprS.RprS # curRprS) THEN
    SELECT(RprT, RprS, , RprS.RprS);
    WHILE OCCURE(RprT) DO
     IF (RprT.TaskKind = L_Rpr.tk_Servicing2) |
        ((RprT.TaskKind = L_Rpr.tk_Servicing1) & HasSpecialRprDfApr()) THEN
      Description:=Description +
                   "᫥ " + L_Str.PoolItem(L_Rpr.rpr_TaskKind_Pool, RprT.TaskKind) +
                   " ( " + RprS.RprS + "  " + L_DatTim.DateStr(RprS.OrdDate) + "); ";
     END;
     NEXT(RprT);
    END; (* WHILE OCCURE(RprT) ... *)
   END;
   PREV(RprS);
  END; (* WHILE OCCURE(RprS) ... *)
  RESTORE(RprS);
  RETURN Description;
 END {GetRepeatedRprSDescr};

 PUBLIC PROCEDURE RprT_CheckFilling();
 BEGIN
  IF L_Rpr.IsRprS_w_Car() THEN
   IF RprT.TaskKind = L_Rpr.tk_Servicing1 THEN
    L_Rpr.AccessOrigin();
    L_General.Assert_wReferToAdmin(L_Rpr.FoundReFrCast(Car.BoxNbr, E_Way.re_TO1, RprS.OrdDate) |
                                   L_Rpr.IsMainRpr(),
                                   "⨬ ଫ -1 - ய⨥  ஢.");
   END;
  END;
 END {RprT_CheckFilling};

 PUBLIC PROCEDURE RemainsIndication_Required(D: DATE): SCAL[2];
 BEGIN
  RETURN 0;
 END {RemainsIndication_Required};

 PUBLIC PROCEDURE SpeedometerIndication_Required(D: DATE): SCAL[2];
 BEGIN
  RETURN D >= 02\04\2012;
 END {SpeedometerIndication_Required};

 PUBLIC PROCEDURE RprJPeriodEqualRprTJobPeriod(D: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {RprJPeriodEqualRprTJobPeriod};

 PUBLIC PROCEDURE NeedCheckCarLocation(_Date: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {NeedCheckCarLocation};

 PUBLIC PROCEDURE rfl_StrongCheckFillField(D: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {rfl_StrongCheckFillField};

 PUBLIC PROCEDURE rfl_PrintRprSImmediately(D: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {rfl_PrintRprSImmediately};

 PUBLIC PROCEDURE UseRprTJobBegDateTime(D: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {UseRprTJobBegDateTime};

 PUBLIC PROCEDURE GetRepairContractTemplate(D          : DATE;
                                            trgFirm    : LIKE(Firm.Firm);
                                            trgLocation: L_Rpr.tRprSLocation): LIKE(Contract.Contract);
 BEGIN
  IF    trgLocation = L_Rpr.rprl_MaintenanceZone THEN
   RETURN 000011;
  ELSIF IsOutCarInRepairZone(trgLocation) THEN
   RETURN 000011;
  ELSE
   L_General.Error(" ஥ 楤 ᪠ 蠡 ஢  ६  ஢ " + trgLocation);
  END;
 END {GetRepairContractTemplate};

 PUBLIC PROCEDURE GetNormHourPricePool(): STRING[];
 BEGIN
  RETURN E_Prop.GetPool(E_Prop.P_NormHourPrice);
 END {GetNormHourPricePool};

 PUBLIC PROCEDURE GetNormHourPrice(): NUMERIC[2];
 BEGIN
  IF L_Rpr.AcceptableCalcRprJSum() THEN
   RETURN STRTOFLD(P_Rpr.GetProStrong(RprS.RprS, L_Rpr.v_EmptyIndexValue, L_Rpr.v_EmptyIndexValue, E_Prop.P_NormHourPrice), NUMERIC);
  ELSE
   RETURN L_General.EMPTY_NUMBER();
  END;
 END {GetNormHourPrice};

 PUBLIC PROCEDURE GetRealPayer(D: DATE; defFirm: LIKE(Firm.Firm)): LIKE(Firm.Firm);
  VAR
   Result : LIKE(Firm.Firm);
 BEGIN
  Result:=defFirm;
  IF L_Rpr.IsWarrantyRepair() THEN
   TRY [RESTORE_CURSORS(RC_ON)]
    L_Rpr.AccessOrigin();
    IF    L_Rpr.IsRprS_w_Car() | L_Rpr.IsRprS_w_OutCar() THEN
     L_Rpr.AccessMark(D);
     IF ~!Mark.Mark THEN
      IF    Mark.Mark = 0104 THEN
       Result:=3648;
      ELSIF Mark.Mark = 0127 THEN
       Result:=8128;
      ELSIF (Mark.Mark = 0130) | (Mark.Mark = 0131) | (Mark.Mark = 0132) | (Mark.Mark = 0133) THEN
       Result:=4522;
      END;
     END;
    ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
     IF OutCBlc.Math = 08344 THEN
      Result:=8128;
     END;
    END;
   EXCEPT
   ON Exc:Exc_Root DO
    RAISE();
   END; (* TRY *)
  END;
  RETURN Result;
 END {GetRealPayer};

 PRIVATE PROCEDURE GetAnyCarFirm(D: DATE): LIKE(Firm.Firm);
  VAR
   Result: LIKE(Firm.Firm);
 BEGIN
  IF    L_Rpr.IsRprS_w_OutCar() THEN
   Result:=OutCar.Firm;
  ELSIF L_Rpr.IsRprS_w_Car() THEN
   Result:=L_Car.GetFirmOfCar(D);
  ELSE
   L_General.CallUs(0);
  END;
  RETURN Result;
 END {GetAnyCarFirm};

 PUBLIC PROCEDURE GetRprJobMath(D: DATE): LIKE(Math.Math);
  VAR
   rpFirm,
   trgFirm: LIKE(Firm.Firm);
 BEGIN
  L_Rpr.AccessOrigin();
  IF    L_Rpr.IsServiceCenterLocation(RprS.Location) THEN
   trgFirm:=GetAnyCarFirm(D);
   IF    L_Rpr.IsWarrantyRepair() THEN
    rpFirm:=GetRealPayer(D, trgFirm);
    IF    rpFirm = 3648 THEN
     RETURN 20311;
    ELSIF rpFirm = 8128 THEN
     RETURN 20215;
    ELSIF rpFirm = 4522 THEN
     RETURN 20316;
    ELSE
     L_General.Error(" ࠣ " + rpFirm + "  ।   |" +
                     "ଫ 㣨 '࠭⨩ ६'.||" +
                     "᫨  㢥७  ࠢ쭮 ᢮ ⢨,|" +
                     "  ");
    END;
   ELSIF L_Rpr.IsRprS_w_OutCar() & L_PDoc.IsOneHeadFirmBranch(P_Firm.mf_Own, trgFirm, D) THEN
    RETURN 20211;
   END;
   IF    RprS.Location = L_Rpr.rprl_MaintenanceZone THEN
    RETURN 20088;
   ELSIF RprS.Location = L_Rpr.rprl_ServiceCenter THEN
    RETURN 20455;
   END;
  ELSIF IsOutCarInRepairZone(RprS.Location) THEN
   RETURN 20303;
  ELSIF L_Rpr.IsWorkshopLocation(RprS.Location) THEN
   IF L_Rpr.IsRprS_w_OutCBlc() THEN
    IF    L_Rpr.IsWarrantyRepair() THEN
     rpFirm:=GetRealPayer(D, OutCBlc.Firm);
     IF rpFirm = 8128 THEN
      RETURN 20216;
     ELSE
      L_General.CallUs(0);
     END;
    ELSE
     IF L_PDoc.IsOneHeadFirmBranch(P_Firm.mf_Own, OutCBlc.Firm, D) THEN
      RETURN 08094;
     ELSE
      RETURN 08095;
     END;
    END;
   END;
  END;
  RETURN L_General.EMPTY_NUMBER();
 END {GetRprJobMath};

 PUBLIC PROCEDURE PackDocs_OutCBlcPrepare(D: DATE; Root: STRING[]);
  VAR
   Idx        : SCAL[P_Rpr.CntCylinder];
   curValue   : STRING[];
   Pressure   : NUMERIC[1];
   Temperature: NUMERIC[0];
   Compression: NUMERIC[0][P_Rpr.CntCylinder];
 BEGIN
  SETEMPTY(curValue);
  SELECT(RprPro, RprS, , RprS.RprS);
  WHILE OCCURE(RprPro) DO
   IF RprPro.Property = P_Rpr.P_EngineParams THEN
    CONFORM(RprPro, Property);
    L_General.Assert(!curValue, "    ᢮⢠ " + RprPro.Property + " '" + Property.Name + "'");
    curValue:=RprPro.Value;
   END;
   NEXT(RprPro);
  END; (* WHILE OCCURE(RprPro) ... *)

  Root:=Root + "RprS.RprObj.Engine.EngineParams.";
  P_Rpr.Decode_EngineParams(curValue, Pressure, Temperature, Compression);
  L_MSO.wordSetVar(Root + "Pressure",    L_Str.NumericStr(Pressure, 1));
  L_MSO.wordSetVar(Root + "Temperature", L_Str.IntStr(Temperature));
  FOR_EACH Idx DO
   L_MSO.wordSetVar_wIndex(Root + "Compression", L_Str.IntStr(Compression[Idx]), Idx);
  END;
 END {PackDocs_OutCBlcPrepare};

 PUBLIC PROCEDURE DefineAdditionalDocList();
 BEGIN
  L_Rpr.AccessOrigin();
  IF    L_Rpr.IsServiceCenterLocation(RprS.Location) | IsOutCarInRepairZone(RprS.Location) THEN
   L_MSO.dl_AddLocDoc(" ਥ-। ࢨ", "AcptRep_02", "OutCarAcceptReportPrepare", "RprS.OrdDate");
   L_MSO.dl_AddLocDoc(" ਥ  ᯮ⥫", "AcptRep_03", "OutCarAcceptReportPrepare", "RprS.OrdDate");
   L_MSO.dl_AddLocDoc(" ਥ  稪", "ConvDeed_01", "E_Rpr.ConveyanceDeed", "RprS.OrdDate");
   IF (RprS.Location = L_Rpr.rprl_MaintenanceZone) & L_Rpr.IsRprS_w_OutCar() THEN
    L_MSO.dl_AddLocDoc("- (ଠ )", "Narjad_02", "", "RprS.OrdDate");
   END;
  ELSIF L_Rpr.IsWorkshopLocation(RprS.Location) &
        L_Rpr.IsRprS_w_OutCBlc()                &
        L_Rpr.IsSpecificRprSContractConditions(OutCBlc.Firm, RprS.OrdDate) THEN
   L_MSO.dl_AddLocDoc(" 㬥⮢  । ⥫ 䨫", "PackDocs_01", "E_Rpr.PackDocs_OutCBlcPrepare", "Memo.ud_cd()");
  END;
  L_MSO.dl_AddLocDoc("ਫ  ", "RprSAdd_01", "", "RprS.OrdDate");
 END {DefineAdditionalDocList};

 PUBLIC PROCEDURE ConveyanceDeed(D: DATE; Root: STRING[]);
 BEGIN
  L_MSO.wordSetVar(Root + "ConvDeed.BarCode",  L_XDoc.BarCode(L_XDoc.bck_IdIn17, L_XDoc.xdt_RprS, L_XDoc.EmptyXDocKind, RprS.RprS, 99));
  L_Rpr.UploadRprJ(D, Root);
 END {ConveyanceDeed};

 PUBLIC PROCEDURE GetBusPictureName(D: DATE; default: STRING[]): STRING[];
 BEGIN
  L_Rpr.AccessMark(SYSDATE());
  IF L_Way.GetMarkG_Soft(Mark.Mark, E_Way.mgt_BusOrGAZel) = 0127 THEN
   RETURN "sc_SmallBus.jpg";
  END;
  RETURN default;
 END {GetBusPictureName};

 PRIVATE CONST
  rk_CommonAll          = 0;
  rk_PrivateCar         = 1;
  rk_CommonAll_MiltiRep = 2;
  rk_CommonBus          = 3;
  rk_CommonSmallBus     = 4;
  rk_DepartAll          = 5;
  rk_All                = 6;

 PUBLIC PROCEDURE Rpr17_GetAdditionalReportSettings(VAR E_ReportKindPool       : STRING[];
                                                    VAR E_ReportKind           : NUMERIC[0];
                                                    VAR ChangeDefReportKindPool: SCAL[2]);
 BEGIN
  E_ReportKindPool         :="饣 짮| |饣 짮 - ࠧ쭮|饣 짮 - ⮡|饣 짮 - ஀⮡|⢥ 짮|";
  E_ReportKind             :=rk_CommonAll;
  ChangeDefReportKindPool:=1;
 END {Rpr17_GetAdditionalReportSettings};

 PUBLIC PROCEDURE Rpr17_GetRealReportKinds(    ReportKind     : NUMERIC[0];
                                           VAR RealReportKinds: NUMERIC[0][]);
 BEGIN
  IF ReportKind = rk_CommonAll_MiltiRep THEN
   RealReportKinds[0]:=rk_CommonBus;
   RealReportKinds[1]:=rk_CommonSmallBus;
  ELSE
   RealReportKinds[0]:=ReportKind;
  END;
 END {Rpr17_GetRealReportKinds};

 PRIVATE PROCEDURE Rpr17_IsPrivateCar(): SCAL[2];
 BEGIN
  RETURN (Car.BoxNbr >= 6300) & (Car.BoxNbr <= 6399);
 END {Rpr17_IsPrivateCar};

 PUBLIC PROCEDURE Rpr17_IsAcceptableCar(ReportKind: NUMERIC[0]): SCAL[2];
  VAR
   _MarkG: LIKE(MarkG.MarkG);
 BEGIN
   _MarkG:=L_Way.GetMarkG_Soft(CarLog.Mark, L_Way.mgt_KIPandKTG);
  IF    ReportKind = rk_CommonAll THEN
   RETURN (CarLog.Purpose = L_Car.purp_Common) & ~Rpr17_IsPrivateCar();
  ELSIF ReportKind = rk_PrivateCar THEN
   RETURN Rpr17_IsPrivateCar();
  ELSIF ReportKind = rk_CommonBus THEN
   RETURN (CarLog.Purpose = L_Car.purp_Common) & (_MarkG # 0150) & (_MarkG # 0151) & ~Rpr17_IsPrivateCar();
  ELSIF ReportKind = rk_CommonSmallBus THEN
   RETURN (CarLog.Purpose = L_Car.purp_Common) & ((_MarkG = 0150) | (_MarkG = 0151)) & ~Rpr17_IsPrivateCar();
  ELSIF ReportKind = rk_DepartAll THEN
   RETURN CarLog.Purpose = L_Car.purp_Depart;
  ELSIF ReportKind = rk_All THEN
   RETURN 1;
  ELSE
   L_General.CallUs(0);
  END;
 END {Rpr17_IsAcceptableCar};

 PUBLIC PROCEDURE Rpr17_GetReportDivisionMarkG(): LIKE(MarkG.MarkG);
 BEGIN
  RETURN L_Way.GetMarkG(CarLog.Mark, E_Way.mgt_BusOrGAZel);
 END {Rpr17_GetReportDivisionMarkG};

 PUBLIC PROCEDURE Rpr17_GetSummaryColumnTitles(VAR SummaryColumnTitles: STRING[][]);
 BEGIN
  SummaryColumnTitles[L_Way.tkfnm_Subsidy] :="樠";
  SummaryColumnTitles[L_Way.tkfnm_Commerce]:=" + ";
  SummaryColumnTitles[L_Way.tkfnm_Other]   :="稥";
 END {Rpr17_GetSummaryColumnTitles};

 PUBLIC PROCEDURE sc_GetContacts(    D       : DATE;
                                 VAR sc_Phone: STRING[];
                                 VAR sc_Site : STRING[]);
 BEGIN
  IF RprS.Location = L_Rpr.rprl_ServiceCenter THEN
   SETEMPTY(sc_Phone, sc_Site);
   SELECT(FirmCtc, fCtcKind, , P_Firm.OWN_FIRM, 09);
   WHILE OCCURE(FirmCtc) DO
    IF L_DatTim.IsActive_Inc(D, FirmCtc.Begin, FirmCtc.Till) THEN
     CONFORM(FirmCtc, Contact);
     CONFORM(Contact, CtcVal);
     WHILE OCCURE(CtcVal) DO
      IF L_DatTim.IsActive_Inc(D, CtcVal.Begin, CtcVal.Till) THEN
       IF    CtcVal.Type = L_ctc.cvt_PhonePST THEN
        sc_Phone:=CtcVal.Value
       ELSIF CtcVal.Type = L_ctc.cvt_WWW THEN
        sc_Site:=CtcVal.Value
       END;
      END;
      NEXT(CtcVal);
     END; (* WHILE OCCURE(CtcVal) ... *)
    END;
    NEXT(FirmCtc);
   END; (* WHILE OCCURE(FirmCtc) ... *)
  ELSE
   SETEMPTY(sc_Site);
  END;
 END {sc_GetContacts};

 PUBLIC PROCEDURE FillDefMDocAttrByRprS();
  VAR
   trgDest    : LIKE(Dest.Dest);
   trgFirm    : LIKE(Firm.Firm);
   trgCostItem: LIKE(CostItem.CostItem);
 BEGIN
  TRY [RESTORE_CURSORS(RC_ON)]
   L_Rpr.AccessOrigin();
   IF MDoc.MDocKind = L_MDoc.md_NOV THEN
    SETEMPTY(trgDest);
    IF L_Env.RealBoxNbr(Car.BoxNbr) THEN
     L_Car.StandOnCarLog(Car.BoxNbr, RprS.OrdDate);
     L_General.Assert(~!CarLog.TKind, "ࠦ  " + Car.BoxNbr + "  ९   ॢ  " + L_DatTim.DateStr(RprS.OrdDate));
     IF    (CarLog.TKind = 01) | (CarLog.TKind = 02) | (CarLog.TKind = 11) THEN
      trgDest:=190;
     ELSIF (CarLog.TKind = 04) | (CarLog.TKind = 16) | (CarLog.TKind = 17) THEN
      trgDest:=191;
     ELSIF CarLog.TKind = 09 THEN
      trgDest:=192;
     ELSIF CarLog.TKind = 18 THEN
      trgDest:=194;
     ELSIF CarLog.TKind = 19 THEN
      trgDest:=196;
     ELSIF CarLog.TKind = 15 THEN
      trgDest:=198;
     ELSIF (CarLog.TKind = 07) | (CarLog.TKind = 10) THEN
      trgDest:=199;
     ELSIF (CarLog.TKind = 05) | (CarLog.TKind = 14) THEN
      trgDest:=453;
     END;
    END;
    MDoc.Dest  :=trgDest;
    MDoc.Alower:=14; (* 株 .. *)
   ELSE
    SETEMPTY(trgDest, trgCostItem);
    IF    L_Rpr.IsRprS_w_CarBlock() THEN
     trgDest    :=274;
     trgCostItem:=0000103;
    ELSIF L_Rpr.IsRprS_w_OutCar() | L_Rpr.IsRprS_w_OutCBlc() THEN
     IF (MDoc.MDocKind = L_MDoc.md_IsS) | (MDoc.MDocKind = L_MDoc.md_IAS) | (MDoc.MDocKind = L_MDoc.md_RPr) THEN
      IF L_Rpr.IsWarrantyRepair() THEN
       trgDest:=215;
      ELSE
       trgDest:=221;
      END;
     ELSE
      trgDest:=274;
     END;

     IF ~L_Rpr.IsWarrantyRepair() THEN
      IF    L_Rpr.IsRprS_w_OutCar() THEN
       IF L_PDoc.IsOneHeadFirmBranch(P_Firm.mf_Own, OutCar.Firm, RprS.OrdDate) THEN
        trgCostItem:=0000108;
       END;
      ELSIF L_Rpr.IsRprS_w_OutCBlc() THEN
       IF L_PDoc.IsOneHeadFirmBranch(P_Firm.mf_Own, OutCBlc.Firm, RprS.OrdDate) THEN
        trgCostItem:=0000107;
       END;
      ELSE
       L_General.CallUs(0);
      END;
     END;
    END;
    MDoc.Dest    :=trgDest;
    MDoc.CostItem:=trgCostItem;

    IF (MDoc.MDocKind # L_MDoc.md_MSP) & SEARCH(Alower, Alower, L_MDoc.NoAlower) THEN
     MDoc.Alower:=Alower.Alower;
    ELSE
     SETEMPTY(MDoc.Alower);
    END;
   END; (* IF MDoc.MDocKind = md_NOV...*)
  EXCEPT
  END; (* TRY *)
 END {FillDefMDocAttrByRprS};

 PUBLIC PROCEDURE PutTaskStandartJobsList(D: DATE): SCAL[2];
 BEGIN
  RETURN 0;
 END {PutTaskStandartJobsList};

 PUBLIC PROCEDURE OutRprObjAllowed(): SCAL[2];
 BEGIN
  RETURN 1;
 END {OutRprObjAllowed};

 PUBLIC PROCEDURE RprJBaseTimeRequired(D: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {RprJBaseTimeRequired};

 PUBLIC PROCEDURE GetAcceptableRprObjT(VAR default: LIKE(RprS.RprObjT)[]);
  VAR
   i: NUMERIC[0];
 BEGIN
  IF RprS.Location = L_Rpr.rprl_Gate THEN
   i:=0;
   WHILE (i <= HIGH(default)) & ~!default[i] DO
    INC(i);
   END;
   L_General.CallUs(i <= HIGH(default));
   default[i]:=L_Rpr.rot_OutCar;
  END;
 END {GetAcceptableRprObjT};

END.
