(*
%Copyright   (c) Polak Computer System
%Author      04.03.1998 17:38:33 GINA
%Purpose     ᮡ   ஢ 
%Type        library
%Specific    LOC
%Modified    29.10.2013 16:01:50 POLAK\LDA
%Environment
*)

 MODULE E_Staff [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_Staff, L_MSO, L_Env, L_Str, P_Man, FIO, L_Packet,
        L_Man, L_Print, L_StdFrm;

 PUBLIC PROCEDURE SpecStage2ForPens(D: DATE; trgJMode: LIKE(Sheet.JMode)): L_Packet.tMInsAddType;
 BEGIN
  IF    trgJMode = 03 THEN RETURN L_Packet.miat_Disability;
  ELSIF trgJMode = 19 THEN RETURN L_Packet.miat_UnpaidLeave;
  ELSE                     RETURN EMPTYOF(L_Packet.tMInsAddType);
  END;
 END {SpecStage2ForPens};

 PRIVATE PROCEDURE GetActualAdding(_TSN    : LIKE(Staff.TSN);
                                   _AddKind: LIKE(AddKind.AddKind)): LIKE(Adding.Value);
 BEGIN
  SETSEL(Adding, TSN, _TSN, _AddKind);
  IF SRCINSEL(Adding, LE, Memo.ud_me()) & (!Adding.UpTo | (Memo.ud_mb() <= Adding.UpTo)) THEN
   RETURN Adding.Value;
  ELSE
   RETURN 0;
  END;
 END {GetActualAdding};

 PUBLIC PROCEDURE GetOtherInformationAboutStaff(VAR Inf: STRING[][]);
  VAR
   _Value: LIKE(Adding.Value);
 BEGIN
  _Value:=GetActualAdding(Staff.TSN, 03);
  IF OCCURE(Adding) THEN
   CONFORM(Adding, AddKind);
   Inf[0]:=Adding.AddKind+" "+AddKind.Name+" : "+FLDTOSTR(_Value, "3.");
  ELSE
   Inf[0]:="";
  END; (* IF *)
  Inf[1]:="";
 END {GetOtherInformationAboutStaff};

 PUBLIC PROCEDURE IsOutsider(D: DATE): SCAL[2];
 BEGIN
  IF L_Man.intInteractiveAccessStaffByMan(0, 1) THEN
   L_Staff.StandOnMainContractByStaff(D);
   L_Staff.PosToStaffLog(Staff.TSN, D, 1);
   RETURN (StaffLog.Sort = 120) | (StaffLog.Sort = 122);
  ELSE
   RETURN 1;
  END;
 END {IsOutsider};

 PUBLIC PROCEDURE PassIntPrepare(D: DATE; Root: STRING[]);
 BEGIN
  L_Staff.StandOnMainContractByStaff(D);
  L_Staff.PosToStaffLog(Staff.TSN, D, 1);
  CONFORM(StaffLog, Officer);
  CONFORM(Officer, Post);
  L_MSO.wordSetVarsByFile_wPrefix("Post" ,"Staff.StaffLog.Officer.");
  L_Staff.WordSetManName("");
  L_Staff.PassIntPrepare(D, 35);
 END {PassIntPrepare};

 PUBLIC PROCEDURE ClnExCpnPrepare(D: DATE; Root: STRING[]);
 BEGIN
  IF ~!Root THEN
   L_MSO.wordSetVarsByFile_wAliasE("ManPro",  "Staff.Man.MemberOMI",
                                   ~P_Man.HasActualManPro(Man.Man, D, P_Man.P_MemberOMI));
  END;
 END {ClnExCpnPrepare};

 PUBLIC PROCEDURE DefineAdditionalDocList();
 BEGIN
  L_MSO.dl_AddLocDoc("⭠ 窠 童 ", "TradUn01", "E_Staff.TradUnPrepare", "Memo.ud_cd()");
  L_MSO.dl_AddLocDoc(" ᯠਧ樨", "ClnExCpn", "E_Staff.ClnExCpnPrepare", "Memo.ud_cd()");
 END {DefineAdditionalDocumentList};

 PUBLIC PROCEDURE LbC01Prepare(D: DATE; Root: STRING[]);
  VAR
   Extra : STRING[];
 BEGIN
  IF ~!Root THEN
   SETEMPTY(Extra);
   L_Staff.PosToStaffLog(Staff.TSN, D, 1);
   CONFORM(StaffLog, Officer);
   IF L_Env.IsDriver() THEN
    Extra:="஬ ⮣, ࠡ⭨ 易 ᮡ ࠢ ७ "+
           "㤮 ᯮ浪, ᮤঠ ९ ⮬  "+
           "孨᪨ ࠢ ﭨ, 믮 ࠢ  ࠭ "+
           "㤠  孨 ᭮, ண ᮡ ࠢ "+
           "஦ .";
   END;
   L_MSO.wordSetVar("Staff.ExtraObligations", Extra);
   L_MSO.wordSetDateVar("TheDoc.Date", D);
  END;
 END {LbC01Prepare};

 PUBLIC PROCEDURE TradUnPrepare(D: DATE; Root: STRING[]);
  VAR
   _filename: STRING[];
   _DateS   : DATE;
 BEGIN
  IF ~!Root THEN
   L_General.Assert(P_Man.HasActualManPro(Staff.Man, D, P_Man.P_TradeUnionMember),
                    "⭨   童 ");
   L_MSO.wordSetVarsByFile_wAlias("ManPro", Root+"Man.TradeUnionMembership");
   CHANGESEL(ManPro, Man, , ManPro.Man, ManPro.Property);
   _DateS:=ManPro.Date;
   WHILE PREV(ManPro) & (ManPro.DocExpD = _DateS) DO
    _DateS:=ManPro.Date;
   END; (* WHILE OCCURE(ManPro) ... *)
   L_MSO.wordSetDateVar(Root+"Man.TradeUnionMembership.RealBegDate", _DateS);
   _filename:=P_Man.GetManProSoft(Man.Man, D, P_Man.P_ManPhoto);
   IF FIO.Exists(_filename, "") THEN
    L_MSO.wordSetBkm("Face", "");
    L_MSO.wordSetPic("Face",  _filename,  30, -1);
   END;
   L_MSO.wordSetVar(Root+"Man.EducationLevel", L_Man.GetManEducationLevelAsStr());
  END;
 END {TradUnPrepare};

 PUBLIC PROCEDURE EDO_Level(D: DATE): SCAL[5];
 BEGIN
  RETURN 1;
 END {EDO_Level};

 PUBLIC PROCEDURE Loan_Creditor(D: DATE): STRING[];
 BEGIN
  RETURN " ࣨ-ᠤ᪮ ⤥ 2578 ࡠ ᨨ";
 END {Loan_Creditor};

 PUBLIC PROCEDURE Staff013_NeedStaff(D: DATE): SCAL[2];
 BEGIN
  CONFORM(StaffLog, Officer);
  IF (Officer.Union = 021) | (*ᮢ⥫*)
     (Officer.Union = 022) | (*ᯨ ⠢*)
     (Officer.Union = 027) | (* *)
     (Officer.Union = 028) | (*訥 ࠡ⭨*)
     (Officer.Union = 029) | (*ᮢ⥫ ७ (᫥)*)
     (Officer.Union = 030) | (*祭*)
     (Officer.Union = 022) | (*ᮢ⥫ ७ (⥫)*)
     (Officer.Post = 001)  | (*४*)
     (Officer.Post = 187)    (* 䨧࠯ (ᮢ.)*) THEN
   RETURN 0;
  ELSE
   RETURN 1;
  END;
 END {Staff013_NeedStaff};

END.
