(*
%Copyright   (c) Polak IT
%Author      19.09.2005 12:22:31 Gina
%Purpose     ᮡ   
%Type        library
%Specific    LOC
%Modified    07.06.2013 18:42:59 POLAK\Bor
%Environment
*)

 MODULE E_TRS [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT L_General, L_DatTim, L_Way, L_Staff, L_TRS, L_XDoc, L_Car, L_XObj, P_Firm, Str, E_Way, L_Env;

 PUBLIC PROCEDURE JointResponsibility(D: DATE): SCAL[2];
 BEGIN
  RETURN "";
 END {JointResponsibility};

 PUBLIC PROCEDURE AbnormalCashAcceptMode(D: DATE): SCAL[2];
 BEGIN
  RETURN 1;
 END {AbnormalCashAcceptMode};

 PRIVATE PROCEDURE PutSingleTckKindByTckRcJ(trgMath  : LIKE(Math.Math);
                                            trgSum   : L_TRS.tOBK02Sum;
                                            dOrigin: L_XObj.tOrigin;
                                            dObject: L_XDoc.tXDoc;
                                            cOrigin: L_XObj.tOrigin;
                                            cObject: L_XDoc.tXDoc;
                                            toMDL  : SCAL[2]);
 BEGIN
  IF (dOrigin = L_XObj.o_Contract) & !dObject THEN
   dObject:=MDoc.Contract;
  END;
  IF (cOrigin = L_XObj.o_Contract) & !cObject THEN
   cObject:=MDoc.Contract;
  END;
  ADD(OBK02, OBK02, , MyFirm.MyFirm, trgMath, dOrigin, dObject, cOrigin, cObject, toMDL,
      OBK02.Sum, trgSum);
 END {PutSingleTckKindByTckRcJ};

 PRIVATE CONST
  ci_Surplus = 0000088;
  cn_IF_TOP  = 0011328;
  cn_IF_MG   = 0011329;

 PRIVATE PROCEDURE Tck30_ApplyInsuranceFee(    D       : DATE;
                                               trgTKind: LIKE(TKind.TKind);
                                               trgSum  : L_TRS.tOBK02Sum;
                                               trgPsg  : NUMERIC[0];
                                           VAR bsSum,
                                               ifSum   : L_TRS.tOBK02Sum);
  TYPE
   tInsuranceFeeMethod = SCAL[4];
  CONST
   ifm_None   = 0;
   ifm_OnePrc = 1;
   ifm_FixSum = 2;
   ifm_1Of101 = 3;
  VAR
   ifMethod: tInsuranceFeeMethod;
 BEGIN
  IF    L_Way.E_IsImaginaryRoute(D, TckRcJ.Route) THEN
   ifMethod:=ifm_None;
  ELSIF TckKind.InSale = L_TRS.tks_Prepayment THEN
   ifMethod:=ifm_None;
  ELSE
   IF D >= 01\04\2013 THEN
    ifMethod:=ifm_None;
   ELSE
    IF (TckRcJ.Route = "0388") (*᪢*) THEN
     ifMethod:=ifm_FixSum;
    ELSIF trgTKind = 01(*த 樠*) THEN
     ifMethod:=ifm_OnePrc;
    ELSIF trgTKind = 02(*ਣத 樠*) THEN
     ifMethod:=ifm_OnePrc;
    ELSIF (trgTKind = 14(*த *)) | (trgTKind = 05(*ਣத *)) THEN
     ifMethod:=ifm_None;
    ELSIF (trgTKind = 09(*த*)) | (trgTKind = 18(**)) THEN
     ifMethod:=ifm_None;
    ELSE
     L_General.CallUs(0);
    END;
   END;
  END;

  IF    ifMethod = ifm_OnePrc THEN
   ifSum:=trgSum*(1/100);
  ELSIF ifMethod = ifm_1Of101 THEN
   ifSum:=trgSum*(1/101);
  ELSIF ifMethod = ifm_FixSum THEN
   IF    D >= 01\03\2011 THEN
    (*砫  ᠦ஢  ᫥*)
   ELSIF D >= 01\01\2011 THEN
    trgPsg:=trgSum/110; (* ⢮ ᠦ஢    ⬥. 110 - । ⮨  (0084332) *)
   ELSE
    trgPsg:=trgSum/90;  (* ⢮ ᠦ஢    ⬥. 90 - । ⮨  *)
   END;
   ifSum:=trgPsg*1.5;
  ELSIF ifMethod = ifm_None THEN
   ifSum:=0;
  ELSE
   L_General.CallUs(0);
  END;

  bsSum:=trgSum - ifSum;
  L_General.Assert(bsSum >= 0, " "+TckRcJ.TckRcS+" ३ "+L_DatTim.TimeStr(TckRcJ.StartT)+":|窠 "+FLDTOSTR(trgSum, "2-")+"  㬬 客 ᡮ "+FLDTOSTR(ifSum, "2-"));
 END {Tck30_ApplyInsuranceFee};

 PUBLIC PROCEDURE Tck30_PutSingleTckKindByTckRcJ(D  : DATE;
                                                 Sum: L_TRS.tOBK02Sum;
                                                 Psg: LIKE(TckRcJ.Psg));
  CONST
   ci_Prepay = 0000065;
  VAR
   curTKind      : LIKE(TKind.TKind);
   curMath       : LIKE(Math.Math);
   rCostItem     : LIKE(CostItem.CostItem);
   fiContract    : LIKE(Contract.Contract);
   bsSum,
   ifSum         : L_TRS.tOBK02Sum;
   ifOrigin      : L_XObj.tOrigin;
   ifObject      : L_XDoc.tXDoc;
 BEGIN
  IF Sum # 0 THEN
   curTKind:=L_Way.GetRouteTKind(D, 1);
   rCostItem:=L_TRS.GetIncomesCosItemForTckRcJ();
   SETEMPTY(fiContract, ifOrigin);
   Tck30_ApplyInsuranceFee(D, curTKind, Sum, Psg, bsSum, ifSum);
   IF TckKind.InSale = L_TRS.tks_Prepayment THEN
    PutSingleTckKindByTckRcJ(L_General.EMPTY_NUMBER(), bsSum, L_XObj.o_Contract, L_General.EMPTY_NUMBER(), L_XObj.o_CostItem, ci_Prepay, 0);
   ELSE
    IF    L_Way.E_IsImaginaryRoute(D, TckRcJ.Route) THEN
     curMath:=14711(*窠 *);
    ELSIF (TckRcJ.Route = "0388") (*᪢*) THEN
     curMath:=51466(*த ୮*);
     fiContract:=cn_IF_MG;
    ELSIF (curTKind = 09(*த*)) | (curTKind = 18(**)) THEN
     curMath:=51467(**);
    ELSIF curTKind = 01(*த 樠*) THEN
     curMath:=51469(*த 樠*);
     fiContract:=cn_IF_TOP;
    ELSIF (curTKind = 14(*த *)) | (curTKind = 05(*ਣத *)) THEN
     curMath:=51471(* ॢ*);
    ELSIF curTKind = 02(*ਣத 樠*) THEN
     curMath:=51470(*ਣத 樠*);
     fiContract:=cn_IF_TOP;
    ELSE
     L_General.CallUs(0);
    END;

    IF TckKind.InSale = L_TRS.tks_Sales THEN
     PutSingleTckKindByTckRcJ(curMath, bsSum, L_XObj.o_Contract, L_General.EMPTY_NUMBER(), L_XObj.o_CostItem, rCostItem, 1);
     ifOrigin:=L_XObj.o_Contract;
     ifObject:=L_General.EMPTY_NUMBER();
    ELSIF TckKind.InSale = L_TRS.tks_CashlessSales THEN
     PutSingleTckKindByTckRcJ(curMath, bsSum, L_XObj.o_CostItem, ci_Prepay, L_XObj.o_CostItem, rCostItem, 1);
     ifOrigin:=L_XObj.o_CostItem;
     ifObject:=ci_Prepay;
    ELSE
     L_General.CallUs(0);
    END;
   END;
   IF ifSum # 0 THEN
    L_General.CallUs(~!fiContract);
    L_General.CallUs(~!ifOrigin);
    PutSingleTckKindByTckRcJ(curMath, ifSum, ifOrigin, ifObject, L_XObj.o_Contract, fiContract, 0);
   END;
  END; (* IF Sum  *)
 END {Tck30_PutSingleTckKindByTckRcJ};

 PUBLIC PROCEDURE Tck30_PutSurplus(D: DATE; Sum: L_TRS.tOBK02Sum);
 BEGIN
  PutSingleTckKindByTckRcJ(L_General.EMPTY_NUMBER(), Sum, L_XObj.o_Contract, L_General.EMPTY_NUMBER(), L_XObj.o_CostItem, ci_Surplus, 0);
 END {Tck30_PutSurplus};

 PUBLIC PROCEDURE GetRouteForChopper(D: DATE): LIKE(Route.Route);
 BEGIN
  RETURN "0388";
 END {GetRouteForChopper};

 PUBLIC PROCEDURE GetDefaultAsWho(_TSN: LIKE(Staff.TSN); D: DATE; Default: LIKE(TckRcS.AsWho)): LIKE(TckRcS.AsWho);
 BEGIN
  IF (StaffLog.Sort = 093) | (StaffLog.Sort = 031(*⮢*)) THEN
   RETURN L_Way.trs_Chopper;
  ELSE
   RETURN Default;
  END;
 END {GetDefaultAsWho};

 PUBLIC PROCEDURE GetDefaultAsWhoCnd(_TSN: LIKE(Staff.TSN); D: DATE; Default: LIKE(TckRcS.AsWhoCnd)): LIKE(TckRcS.AsWhoCnd);
 BEGIN
  L_General.ConsultToUs(SEARCH(Staff, TSN, _TSN), "GetDefaultAsWhoCnd.Error 1");
  L_Staff.PosToStaffLog(_TSN, D, 1);
  IF StaffLog.Sort = 093 THEN
   RETURN E_Way.trawc_Msk;
  ELSIF (StaffLog.Sort = 031(*⮢*)) THEN
   RETURN E_Way.trawc_Ctl;
  ELSE
   RETURN Default;
  END;
 END {GetDefaultAsWhoCnd};

 PUBLIC PROCEDURE RequiredKKM(default : SCAL[2];
                              _TSN    : LIKE(TckRcS.TSN);
                              _AsWho  : LIKE(TckRcS.AsWho);
                              _AsRWayS: LIKE(TckRcS.asRWayS)): SCAL[2];
  VAR
   i: NUMERIC[0];
 BEGIN
  SAVE(RWayS);
  i:=0;
  WHILE ~default & (i <= HIGH(_AsRWayS)) & ~!_AsRWayS[i] DO
   IF SEARCH(RWayS, RWayS, _AsRWayS[i]) THEN
    IF    Str.Match(RWayS.Exit, "6*") | Str.Match(RWayS.Exit, "7*") THEN
     default:=1;
    ELSE
     L_Car.AccessMark(RWayS.BoxNbr, RWayS.Date);
     IF (Mark.Mark = 0102) | (Mark.Mark = 0112) THEN
      default:=1;
     END;
    END;
   END;
   INC(i);
  END;
  RESTORE(RWayS);
  RETURN default;
 END {RequiredKKM};

 PUBLIC PROCEDURE RequiredVLD(default : SCAL[2];
                              _TSN    : LIKE(TckRcS.TSN);
                              _AsWho  : LIKE(TckRcS.AsWho);
                              _AsRWayS: LIKE(TckRcS.asRWayS)): SCAL[2];
  VAR
   _TKind: LIKE(TKind.TKind);
   i     : NUMERIC[0];
 BEGIN
  IF    _AsWho = L_Way.trs_Guard THEN
   SAVE(RWayS);
   i:=0;
   WHILE ~default & (i <= HIGH(_AsRWayS)) & ~!_AsRWayS[i] DO
    IF SEARCH(RWayS, RWayS, _AsRWayS[i]) THEN
     CONFORM(RWayS, StExit);
     CONFORM(StExit, SEJobs);
     CONFORM(SEJobs, Route);
     _TKind:=L_Way.GetRouteTKind(RWayS.Date, 1);
     default:=(_TKind = 01) | (_TKind = 02);
    END;
    INC(i);
   END;
   RESTORE(RWayS);
  ELSIF _AsWho = L_Way.trs_Chopper THEN
   L_General.ConsultToUs(SEARCH(Staff, TSN, _TSN), "RequiredVLD.Error 1");
   L_Staff.PosToStaffLog(_TSN, SYSDATE(), 1);
   IF (StaffLog.Sort = 031(*⮢*)) THEN
    default:=1;
   END;
  ELSIF _AsWho = L_Way.trs_Driver THEN
   SAVE(RWayS);
   i:=0;
   WHILE ~default & (i <= HIGH(_AsRWayS)) & ~!_AsRWayS[i] DO
    IF SEARCH(RWayS, RWayS, _AsRWayS[i]) THEN
     default:=Str.Match(RWayS.Exit, "720*");
    END;
    INC(i);
   END;
   RESTORE(RWayS);
  END;
  RETURN default;
 END {RequiredVLD};

 PUBLIC PROCEDURE NeedAutoTaxTckRcJR(D: DATE): SCAL[2];
  VAR
   Rezult: SCAL[2];
 BEGIN
  IF    D >= 01\05\2011 THEN
   RETURN (TckKind.TckKind = 0803) | (TckKind.TckKind = 0814); (*  த    *)
  ELSIF D >= 01\07\2010 THEN
   IF    TckKind.TckKind = 0803(*  த  *) THEN
    RETURN 1;
   ELSIF TckKind.TckKind = 0814(**) THEN
    SAVE(Staff);
    SAVE(StaffLog);
    SAVE(Officer);
    CONFORM(TckRcS, Staff);
    L_Staff.PosToStaffLog(TckRcS.TSN, TckRcS.Date, 1);
    CONFORM(StaffLog, Officer);
    Rezult:=L_Env.IsMTDriver();
    RESTORE(Staff);
    RESTORE(StaffLog);
    RESTORE(Officer);
    RETURN Rezult;
   ELSE
    RETURN 0;
   END;
  ELSIF D >= 13\08\2009 THEN
   RETURN (TckKind.TckKind = 0803);
  ELSE
   RETURN 0;
  END;
 END {NeedAutoTaxTckRcJR};

 PUBLIC PROCEDURE MakeVldPsgRWJP(D: DATE; _TckKind: LIKE(TckKind.TckKind)): SCAL[2];
 BEGIN
  IF    D >= 01\05\2012 THEN
   RETURN (_TckKind # 0804(*  த  ᠫ*));
  ELSIF D >= 01\08\2009 THEN
   RETURN (_TckKind # 0803(*  த  *)) &
          (_TckKind # 0804(*  த  ᠫ*));
  ELSE
   RETURN 1;
  END;
 END {MakeVldPsgRWJP};

 PUBLIC PROCEDURE IsGoodRouteForElTck(D: DATE): SCAL[2];
 BEGIN
  RETURN (TckRcJ.Route = ElTck.Route) |
         (TckRcJ.Route = "0031") & (ElTck.Route = "0044") |
         (TckRcJ.Route = "0055") & (ElTck.Route = "0044");
 END {IsGoodRouteForElTck};

 PUBLIC PROCEDURE IsMainTckKind(default: SCAL[2]; trgTckKind: LIKE(TckKind.TckKind); D: DATE; trgRoute: LIKE(Route.Route)): SCAL[2];
 BEGIN
  IF D >= 01\03\2011 THEN
   IF trgTckKind = 0047 (* 20 *) THEN
    default:=(trgRoute = "0388");
   END;
  END;
  RETURN default;
 END {IsMainTckKind};

END.