(*
%Copyright   (c) Polak Computer System
%Author      27.03.2000 18:15:20 SAN
%Purpose     ᮡ : ࠧ ணࠬ
%Type        library
%Specific    LOC
%Modified    09.09.2014 15:45:28 ?
%Environment
*)

 MODULE E_Utils [DEFAULTACCESSLEVELFORPROCEDURE(PRIVATE)];

 IMPORT Memo, L_General, L_Staff, L_Way, L_AP, P_Sort, E_Prop, L_Env,
        P_Firm, L_Str, Str, L_DatTim, P_MyFirm, L_EMail, L_FSS, P_Man;

 PRIVATE CONST
  Alg_Left   = 0;
  Alg_Centre = 1;
  Alg_Right  = 2;
  Alg_Format = 3;

 PUBLIC CONST
  BabyMindingRegime = "0099";

 PUBLIC PROCEDURE TypeKTU_NeedOfficer(D: DATE): SCAL[2];
 BEGIN
  RETURN (Officer.PayKind = 08(**))|(Officer.PayKind = 01(*⥫*));
 END {TypeKTU_NeedOfficer};

 PUBLIC PROCEDURE TypeKTU_NeedKTU(_Sort: LIKE(Sort.Sort)): SCAL[2];
 BEGIN
  RETURN P_Sort.HasActualPro(_Sort, Memo.ud_mb(), E_Prop.P_DrBrigadeBonus)|
         SEARCH(SrMnthly, Sort, _Sort, Memo.ud_mb());
 END {TypeKTU_NeedKTU};

 PUBLIC PROCEDURE FlRec_MakeFlRec_wRWayS(D: DATE): SCAL[2];
 BEGIN
  RETURN 0;
 END {FlRec_MakeFlRec_wRWayS};

(*
$P{ TSN_Inc_Bot:
?, L, "N.y"
@
|-------------------------------------------------------------------------------------------------------------------------------------|
| 楫  #######                            |        |        |     %|          +/-|                                       |
|----------------------------------------------|------------|------------|------|-------------|---------------------------------------|
}
*)

(*
$P{ TSN_Inc_BotLine:
?, L, ""
?, R, "2-"
?, R, "2-"
?, R, "2."
?, R, "0"
@
|##############################################|############|############|######|#############|                                       |
}
*)

 PRIVATE PROCEDURE TSN_Inc_msb_Line(S: STRING[]; Pl, Fc: NUMERIC[2]);
  VAR
   Prc: NUMERIC[4];
 BEGIN
  IF (Pl > 0) | (Fc > 0) THEN
   IF Pl # 0 THEN
    Prc:=Fc/Pl*100;
   ELSE
    Prc:=100;
   END;
   MAKEPART(R, TSN_Inc_BotLine, S, Pl, Fc, Prc, Fc-Pl);
  END;
 END {TSN_Inc_msb_Line};

 PUBLIC PROCEDURE TSN_Inc_MakeSpecialBot(_Who: L_Way.tRWSWho;
                                         tTm : NUMERIC[3][];
                                         tPl,
                                         tFc : NUMERIC[2][]);
  VAR
   PlVldPsg,
   FcVldPsg,
   PlCom,
   FcCom,
   PlInc,
   FcInc,
   indPl,
   indFc,
   Pl388,
   Fc388    : NUMERIC[2];
 BEGIN
  SETZERO(indPl, indFc, Pl388, Fc388, PlInc, FcInc, PlCom, FcCom, PlVldPsg, FcVldPsg);
  SETSEL(StaffLog, TSN, Staff.TSN);
  SRCINSEL(StaffLog, LE, , Memo.ud_ut());
  WHILE OCCURE(StaffLog) DO
   IF L_Staff.OrderInIntvl(Memo.ud_fr(), Memo.ud_ut()) THEN
    INC(Pl388,    L_AP.AcsMonthlyFullOnPer(_Who, 11, Memo.ud_fr()));
    INC(Fc388,    L_AP.AcsMonthlyFullOnPer(_Who, 12, Memo.ud_fr()));
    INC(indPl,    L_AP.AcsMonthlyFullOnPer(_Who, 21, Memo.ud_fr()));
    INC(indFc,    L_AP.AcsMonthlyFullOnPer(_Who, 22, Memo.ud_fr()));
    INC(PlInc,    L_AP.AcsMonthlyFullOnPer(_Who, 07, Memo.ud_fr()));
    INC(FcInc,    L_AP.AcsMonthlyFullOnPer(_Who, 08, Memo.ud_fr()));
    INC(PlCom,    L_AP.AcsMonthlyFullOnPer(_Who, 15, Memo.ud_fr()));
    INC(FcCom,    L_AP.AcsMonthlyFullOnPer(_Who, 16, Memo.ud_fr()));
    INC(PlVldPsg, L_AP.AcsMonthlyFullOnPer(_Who, 30, Memo.ud_fr()));
    INC(FcVldPsg, L_AP.AcsMonthlyFullOnPer(_Who, 31, Memo.ud_fr()));
   END;
   PREV(StaffLog);
  END; (* WHILE OCCURE(StaffLog) ... *)
  IF (PlInc > 0) | (FcInc > 0) | (PlCom > 0) | (FcCom > 0) | (indPl > 0) | (indFc > 0) | (Pl388 > 0) | (Fc388 > 0) | (PlVldPsg > 0) | (FcVldPsg > 0) THEN
   MAKEPART(R, TSN_Inc_Bot, Memo.ud_fr());
   TSN_Inc_msb_Line("樠",                     PlInc,       FcInc);
   TSN_Inc_msb_Line("",                     PlCom,       FcCom);
   TSN_Inc_msb_Line("騥 ⥫, ᪢",       Pl388,       Fc388);
   TSN_Inc_msb_Line(". ⥫, ᪢",    indPl,       indFc);
   TSN_Inc_msb_Line(" . ⥫, ᪢", Pl388-indPl, Fc388-indFc);
   TSN_Inc_msb_Line(". ᠦ",                PlVldPsg,    FcVldPsg);
  END;
 END {TSN_Inc_MakeSpecialBot};

 PUBLIC PROCEDURE RWDst_RouteInGroup(D: DATE; _Route: LIKE(Route.Route); _Group: SCAL[16]): SCAL[2];
  VAR
   IsIn   : SCAL[2];
   IsOrder: SCAL[2];
   _TKind : LIKE(TKind.TKind);
 BEGIN
  SAVE(Route);
  SEARCH(Route, Route, , _Route);
  _TKind:=L_Way.GetRouteTKind(D, 1);
  IF D>=01\03\2009 THEN
   IsOrder:=(_TKind = 04) | (_TKind = 16) | (_TKind = 17);
  ELSE
   IsOrder:=(_TKind = 04);
  END;
  IF    _Group = 1 THEN (*  *)
   IsIn:=IsOrder;
  ELSIF _Group = 2 THEN (* ஬  *)
   IsIn:=~IsOrder;
  ELSIF _Group = 3 THEN (* த ., ਣத .*)
   IsIn:=(_TKind = 01) | (_TKind = 02);
  ELSE
   IsIn:=0;
  END;
  RESTORE(Route);
  RETURN IsIn;
 END {RWDst_RouteInGroup};

 PUBLIC PROCEDURE RWDst_GroupForMCode(D      : DATE;
                                      _Who   : L_Way.tRWSWho;
                                      _MCode : LIKE(MCList.MCode)): SCAL[16];
 BEGIN
  IF    (D>=01\01\2008) & (_MCode = 015(*६. ॣ୮*)) THEN
   RETURN 3;
  ELSIF (_MCode = 046) |
        (_MCode = 044) |
        (_MCode = 045) THEN
   RETURN 1;
  ELSIF (_MCode = 015) |(_MCode = 019) |
        (_MCode = 034) |(_MCode = 058) |
        (_MCode = 059) |(_MCode = 060) |
        (_MCode = 070) THEN
   RETURN 2;
  END;
  RETURN 0;
 END {RWDst_GroupForMCode};

 PRIVATE PROCEDURE RealRegime(_Regime: LIKE(RegMain.Regime)): SCAL[2];
 BEGIN
  RETURN _Regime # BabyMindingRegime;
 END {RealRegime};

 PRIVATE PROCEDURE _Alg(_S: STRING[]; _Len : NUMERIC[0]; _Alg_V: SCAL[5]): STRING[];
 BEGIN
  IF    _Alg_V = Alg_Left THEN
   RETURN Str.Align(_S, _Len, LEFT);
  ELSIF _Alg_V = Alg_Centre THEN
   RETURN Str.Align(_S, _Len, CENTRE);
  ELSIF _Alg_V = Alg_Right THEN
   RETURN Str.Align(_S, _Len, RIGHT);
  ELSIF _Alg_V = Alg_Format THEN
   RETURN Str.Align(_S, _Len, FORMAT);
  ELSE
   L_General.CallUs(0);
  END;
 END {_Alg};

 PRIVATE CONST
  EmptySign = "____________________ /                             /";

 PRIVATE PROCEDURE GetResponsibleNameByPost(trgSort: LIKE(Officer.Sort);
                                            trgPost: LIKE(Officer.Post);
                                            trgDate: DATE): STRING[];
  VAR
   Found: SCAL[2];
   curName: LIKE(Man.Name);
 BEGIN
  APP.Get().NewPrompt("   " + trgPost);
  TRY [RESTORE_CURSORS(RC_ON)]
   IF ~SEARCH(Post, Post, trgPost) THEN
    L_General.InformUs("E_UTILS.ASL:   "+trgPost);
   END;
   IF ~SEARCH(Sort, Sort, trgSort) THEN
    L_General.InformUs("E_UTILS.ASL:  ᥪ "+trgSort);
   END;
   Found:=0;
   SELECT(Officer, Post, , trgPost);
   WHILE OCCURE(Officer) & ~Found DO
    IF (Officer.Sort=trgSort) & L_DatTim.IsActive_Inc(trgDate, Officer.Begin, Officer.Till) THEN
     SELECT(StaffLog, Officer, , Officer.Sort, Officer.Officer);
     WHILE OCCURE(StaffLog) & ~Found DO
      PROMPT(". "+StaffLog.TSN);
      IF L_Staff.InOrder(trgDate) & ~L_Staff.IsDischargeStaffLog() & RealRegime(StaffLog.Regime) THEN
       Found:=1;
       CONFORM(StaffLog, Staff);
       CONFORM(Staff, Man);
       curName:=Man.Name;
      END;
      NEXT(StaffLog);
     END; (* WHILE OCCURE(StaffLog) ... *)
    END;
    NEXT(Officer);
   END; (* WHILE OCCURE(Officer) ... *)
  EXCEPT
  END; (* TRY *)

  IF Found THEN
   RETURN "____________________ /"+L_Str.ShortName(curName)+"/";
  ELSE
   RETURN EmptySign;
  END;
 END {GetResponsibleNameByPost};

 PUBLIC PROCEDURE Beg002_RepTop(D: DATE; VAR RepTopLine: STRING[][]);
  CONST
   Len = 101;
 BEGIN
  RepTopLine[0]:=_Alg('""', Len, Alg_Left) + '""';
  RepTopLine[1]:=_Alg("⥫ ४  ॢ "+GetResponsibleNameByPost(001, 003, D), Len, Alg_Left) + "।ᥤ⥫ 䪮 "+GetResponsibleNameByPost(078, 161, D);
 END {Beg002_RepTop};

 PUBLIC PROCEDURE Beg002_BotSign(D: DATE; VAR BotSignLine: STRING[][]);
  CONST
   Len = 160;
 BEGIN
  BotSignLine[0]:="";
  BotSignLine[1]:=_Alg("         砫쭨 鸞        " + EmptySign, Len, Alg_Left);
  BotSignLine[2]:="";
  BotSignLine[3]:=_Alg("          ⤥  " + EmptySign, Len, Alg_Left);
  BotSignLine[4]:="";
  BotSignLine[5]:="";
  BotSignLine[6]:="";
  BotSignLine[7]:="";
 END {Beg002_BotSign};

 PRIVATE PROCEDURE fc_SpecialBotTechnic(): STRING[];
 BEGIN
  RETURN GetResponsibleNameByPost(016, 032, SYSDATE());
 END {fc_SpecialBotTechnic};

(*
$P{ fc_SpecialBot:
L_Str.ShortName(P_MyFirm.MainEngineerName(P_Firm.mf_Own, SYSDATE()))+"/", L, ""
fc_SpecialBotTechnic(), L, ""
GetResponsibleNameByPost(015, 029, SYSDATE()), L, ""
EmptySign, L, ""
EmptySign, L, ""
@
|----------------------------------------------------------------------------|
|ᮡ ⬥⪨                                                              |
|                                                                            |
|                                                                            |
|                                                                            |
|                                                                            |
|----------------------------------------------------------------------------|
|                                                                            |
|          ____________________ /##############################|
|                                                                            |
|孨                  ####################################################|
|                                                                            |
|砫쭨            ####################################################|
|                                                                            |
|砫쭨 鸞        ####################################################|
|                                                                            |
|⥫                ####################################################|
=(c) Polak====================================================================
}
*)

 PUBLIC PROCEDURE cucfc_SpecialBot();
 BEGIN
  MAKEPART(R, fc_SpecialBot);
 END {cucfc_SpecialBot};

 PUBLIC PROCEDURE AutoExec_LaunchAtLast(default: STRING[]): STRING[];
 BEGIN
  IF L_Str.IsEqStrI(LOGINNAME(), "") THEN
   default:='CALL, "StatusMap.StatusMapByExit()"';
  END;
  RETURN default;
 END {AutoExec_LaunchAtLast};

 PUBLIC PROCEDURE GetPhotoArchiveFolder(): STRING[];
 BEGIN
  RETURN "IMG";
 END {GetPhotoArchiveFolder};

 PUBLIC PROCEDURE CN002_KOD_PRED(): STRING[];
 BEGIN
  RETURN "132";
 END {CN002_KOD_PRED};

 PUBLIC PROCEDURE XOMN8_Get_MCode(D: DATE;
                                  sie      : L_FSS.tsie;
                                  TaxGroup : L_FSS.tTaxGroup;
                                  OverNorms: SCAL[2]): STRING[];
 BEGIN
  IF OverNorms THEN                           RETURN "";
  ELSIF sie = L_FSS.sie_SickOrdinary   THEN   RETURN "007";
  ELSIF sie = L_FSS.sie_SickPregnancy  THEN   RETURN "082";
  ELSIF sie = L_FSS.sie_BabyMinding1   THEN   RETURN "068";
  ELSIF sie = L_FSS.sie_BabyBirth      THEN   RETURN "226";
  ELSIF sie = L_FSS.sie_HldBabyInvld   THEN   RETURN "247";
  ELSIF sie = L_FSS.sie_EarlyPregnancy THEN   RETURN "083";
  ELSIF sie = L_FSS.sie_BabyMinding2   THEN   RETURN "212";
  ELSIF sie = L_FSS.sie_IndustrialInj  THEN   RETURN "018";
  ELSE                                        RETURN "";
  END;
 END {XOMN8_Get_MCode};

 PUBLIC PROCEDURE convACSOutpost(_Outpost: NUMERIC[0]): LIKE(ACSEvent.Outpost);
 BEGIN
  IF    _Outpost = 1 THEN
   RETURN 1;
  ELSIF _Outpost = 2 THEN
   RETURN 1;
  END;
  L_General.CallUs(0);
 END {convACSOutpost};

 PUBLIC PROCEDURE ACS_ReportContactTo(): L_EMail.tContact;
 BEGIN
  RETURN L_EMail.AssembleContact("室 ", "sam@ak1791.autopark.ru");
 END {ACS_ReportContactTo};

 PUBLIC PROCEDURE ACS_ReportContactFrom(): L_EMail.tContact;
 BEGIN
  RETURN L_EMail.AssembleContact("室 ", "null@polak.ru");
 END {ACS_ReportContactFrom};


 PUBLIC PROCEDURE StaffSMS_GetSendParams(VAR SMTPServer : STRING[];
                                         VAR EMailDomain: STRING[];
                                         VAR FrContact  : L_EMail.tContact;
                                         VAR Login      : STRING[];
                                         VAR Password   : STRING[]);
 BEGIN
  SMTPServer :="beeline.amega-inform.ru:256";
  EMailDomain:="sms.beeline.amega-inform.ru";
  Login      :="2682";
  FrContact  :=L_EMail.AssembleContact("From", "AK1791@anydomain.ru");
  Password   :=ENCRYPTSTR("Qwerty123", CSECR_PKCU, CALG_3DES, 0, CALG_MD5, CSP_NAME_MS_STRONG, CSP_TYPE_RSA_FULL);
 END {StaffSMS_GetSendParams};

 PRIVATE PROCEDURE WorkingInDate(trgDate: DATE): SCAL[2];
 BEGIN
  RETURN SELECT(RWayS, sTSN, L_Way.rwsStat_Ordered, Staff.TSN, trgDate) |
         SELECT(RWayS, sTSN, L_Way.rwsStat_Given, Staff.TSN, trgDate);
 END {WorkingInDate};

 PUBLIC PROCEDURE StaffSMS_ms_IsAcceptableStaff(ms_Kind: P_Man.tMassSendKind; trgDate: DATE; default: SCAL[2]): SCAL[2];
  VAR
   Pool  : STRING[];
   Result: SCAL[2];
 BEGIN
  Pool:=P_Man.E_msk_GetPool();
  IF    L_Str.PoolItem(Pool, ms_Kind) = "ᥬ ࠡ騬 ᥣ ⥫  㪮⥫" THEN
   Result:=0;
   IF P_Man.IsSMSMassSendReceiver(Man.Man, trgDate, ms_Kind, 0) THEN
    IF L_Staff.IsStandOnAnyMainContract(Man.Man, trgDate) & L_Staff.rInState(trgDate) THEN
     L_Staff.PosToStaffLog(Staff.TSN, trgDate, 0);
     CONFORM(StaffLog, Officer);
     IF (L_Env.IsDriver() & WorkingInDate(trgDate)) |
        (~L_Env.IsDriver() & P_Man.IsSMSMassSendReceiver(Man.Man, trgDate, ms_Kind, 1)) THEN
      Result:=1;
     END;
    ELSE
     Result:=(Man.Man = 05122) | (Man.Man = 02982) | (Man.Man = 07173);
    END;
   END;
  ELSIF L_Str.PoolItem(Pool, ms_Kind) = "ᥬ ⥫" THEN
   Result:=0;
   IF L_Staff.IsStandOnAnyMainContract(Man.Man, trgDate) &
      L_Staff.rInState(trgDate) &
      P_Man.IsSMSMassSendReceiver(Man.Man, trgDate, ms_Kind, 0) THEN
    L_Staff.PosToStaffLog(Staff.TSN, trgDate, 0);
    CONFORM(StaffLog, Officer);
    Result:=L_Env.IsDriver() | P_Man.IsSMSMassSendReceiver(Man.Man, trgDate, ms_Kind, 1);
   END;
  ELSIF L_Str.PoolItem(Pool, ms_Kind) = "⥫ ஠⮡ᮢ" THEN
   Result:=0;
   IF L_Staff.IsStandOnAnyMainContract(Man.Man, trgDate) &
      L_Staff.rInState(trgDate) &
      P_Man.IsSMSMassSendReceiver(Man.Man, trgDate, ms_Kind, 0) THEN
    L_Staff.PosToStaffLog(Staff.TSN, trgDate, 0);
    CONFORM(StaffLog, Officer);
    Result:=((Officer.Post = 091) & (L_Staff.getDepart() = 144)) |
            P_Man.IsSMSMassSendReceiver(Man.Man, trgDate, ms_Kind, 1);
   END;
  ELSE
   Result:=default;
  END;
  RETURN Result;
 END {StaffSMS_ms_IsAcceptableStaff};

 PUBLIC PROCEDURE RWPrt_RWAmntOnPage(D: DATE): NUMERIC[0];
 BEGIN
  RETURN 3;
 END {RWPrt_RWAmntOnPage};

 PUBLIC PROCEDURE BegRWP_RepTop(D: DATE; VAR RepTopLine: STRING[][]);
  CONST
   Len = 120;
 BEGIN
  SETEMPTY(RepTopLine);
  RepTopLine[0]:=_Alg('""', Len, Alg_Centre);
  RepTopLine[1]:=_Alg(".४  ॢ "+GetResponsibleNameByPost(001, 003, D), Len, Alg_Right);
  RepTopLine[2]:=_Alg('""',  Len, Alg_Centre);
  RepTopLine[3]:=_Alg("  "+GetResponsibleNameByPost(001, 002, D), Len, Alg_Right);
  RepTopLine[4]:="";
  RepTopLine[5]:=_Alg("砫쭨  "+GetResponsibleNameByPost(014, 026, D), Len, Alg_Right);
 END {BegRWP_RepTop};

 PUBLIC PROCEDURE XDF_AuthenticationKind(): L_XDF.tAuthenticationKind;
 BEGIN
  RETURN L_XDF.ak_BarCode;
 END {XDF_AuthenticationKind};

END.
